import numpy as np


#1st order terms
class RR2:
    def l0(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        fd,Dd,gd2,bd2,bd1,fdd,Ddd,gdd2,bdd2,bdd1 = cosmo_functions.get_derivs(zz)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = -8*C*D1**3*Pk1*Pk2*k1**2*k2**2*(3*D1*bd1*f**2*(r + s - 1)**2 + 5*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + b1*f*(10*D1*bd1*(r + s - 1)**2 + (3*D1*fd + 6*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(15*d**2*k3**6) - 8*C*D1**3*Pk1*Pk2*k2**4*st**2*(D1*bd1*f**2*(r + s - 1)**2 + 5*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + b1*f*(10*D1*bd1*(r + s - 1)**2 + (D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(15*d**2*k3**6) + 4*C*D1**3*Pk1*Pkd2*k1**2*k2*(3*D1*bd1*f**2*(s - 1)*(r + s - 1) + 5*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(5*D1*bd1*(2*s - 1)*(r + s - 1) + 3*D1*fd*s*(2*r + 2*s - 1) + 3*Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))/(15*d**2*k3**4) + 4*C*D1**3*Pk1*Pkd2*k2**3*st**2*(D1*bd1*f**2*(s - 1)*(r + s - 1) + 5*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(5*D1*bd1*(2*s - 1)*(r + s - 1) + D1*fd*s*(2*r + 2*s - 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1)))/(15*d**2*k3**4) - 8*C*D1**2*Pk1*Pk2*k1**4*st**2*(6*D1**2*b1*f*fd*r**2 + 12*D1**2*b1*f*fd*r*s - 6*D1**2*b1*f*fd*r + 6*D1**2*b1*f*fd*s**2 - 6*D1**2*b1*f*fd*s + 3*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(r + s - 1)**2 - 3*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s**2 + 4*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 + 12*D1*Dd*b1*f**2*r**2 + 24*D1*Dd*b1*f**2*r*s - 12*D1*Dd*b1*f**2*r + 12*D1*Dd*b1*f**2*s**2 - 12*D1*Dd*b1*f**2*s + 6*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 144*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 144*D1*Dd*b1*f*fd*s + 36*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 4*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 140*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 140*D1*Dd*f**2*fd*s + 40*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 36*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 20*D1*Ddd*f**3*s + 10*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + 6*D1*fd*(2*r + 2*s - 1) + 12*Dd*f*(2*r + 2*s - 1)) + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 108*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 60*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 60*Dd**2*f**3*s + 10*Dd**2*f**3)/(315*d**2*k3**6) + 8*C*D1**2*Pk1*Pk2*k1**4*(-3*D1*f*(r + s - 1)*(14*D1*bd1**2*(r + s - 1) + 5*D1*bdd1*f*(r + s - 1) + bd1*(-3*D1*f*(r + s - 1) + 10*D1*fd*(2*r + 2*s - 1) + 20*Dd*f*(2*r + 2*s - 1))) + 7*b1**2*(D1**2*(fd - 3*fdd)*(r + s)**2 + 2*D1*(Dd*(f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 3*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 6*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-42*D1**2*bdd1*f*(r + s - 1)**2 - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 12*Dd*f*(2*r + 2*s - 1)) + 6*D1*f*(Dd*(3*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 10*fd*(2*r + 2*s - 1)**2) - 5*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 30*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(105*d**2*k3**6) + 8*C*D1**2*Pk1*Pk2*k1**2*k2**2*st**4*(10*D1**2*b1*f*fd*r**2 + 20*D1**2*b1*f*fd*r*s - 10*D1**2*b1*f*fd*r + 10*D1**2*b1*f*fd*s**2 - 10*D1**2*b1*f*fd*s + 5*D1**2*b1*f*fd - 12*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 12*D1**2*b1*f*fdd*r - 12*D1**2*b1*f*fdd*s**2 + 12*D1**2*b1*f*fdd*s - 6*D1**2*b1*f*fdd - 12*D1**2*b1*fd**2*r**2 - 24*D1**2*b1*fd**2*r*s + 12*D1**2*b1*fd**2*r - 12*D1**2*b1*fd**2*s**2 + 12*D1**2*b1*fd**2*s - 6*D1**2*bdd1*f**2*(r + s - 1)**2 + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 6*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 8*D1**2*f**2*fdd*r - 6*D1**2*f**2*fdd*s**2 + 8*D1**2*f**2*fdd*s - 4*D1**2*f**2*fdd - 12*D1**2*f*fd**2*r**2 - 24*D1**2*f*fd**2*r*s + 16*D1**2*f*fd**2*r - 12*D1**2*f*fd**2*s**2 + 16*D1**2*f*fd**2*s - 4*D1**2*f*fd**2 + 20*D1*Dd*b1*f**2*r**2 + 40*D1*Dd*b1*f**2*r*s - 20*D1*Dd*b1*f**2*r + 20*D1*Dd*b1*f**2*s**2 - 20*D1*Dd*b1*f**2*s + 10*D1*Dd*b1*f**2 - 96*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 96*D1*Dd*b1*f*fd*r - 96*D1*Dd*b1*f*fd*s**2 + 96*D1*Dd*b1*f*fd*s - 24*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 48*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 56*D1*Dd*f**2*fd*r - 48*D1*Dd*f**2*fd*s**2 + 56*D1*Dd*f**2*fd*s - 16*D1*Dd*f**2*fd - 24*D1*Ddd*b1*f**2*r**2 - 48*D1*Ddd*b1*f**2*r*s + 24*D1*Ddd*b1*f**2*r - 24*D1*Ddd*b1*f**2*s**2 + 24*D1*Ddd*b1*f**2*s - 12*D1*Ddd*b1*f**2 - 8*D1*Ddd*f**3*r**2 - 16*D1*Ddd*f**3*r*s + 8*D1*Ddd*f**3*r - 8*D1*Ddd*f**3*s**2 + 8*D1*Ddd*f**3*s - 4*D1*Ddd*f**3 + D1*bd1*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 24*Dd*f*(2*r + 2*s - 1)) - 72*Dd**2*b1*f**2*r**2 - 144*Dd**2*b1*f**2*r*s + 72*Dd**2*b1*f**2*r - 72*Dd**2*b1*f**2*s**2 + 72*Dd**2*b1*f**2*s - 12*Dd**2*b1*f**2 - 24*Dd**2*f**3*r**2 - 48*Dd**2*f**3*r*s + 24*Dd**2*f**3*r - 24*Dd**2*f**3*s**2 + 24*Dd**2*f**3*s - 4*Dd**2*f**3)/(35*d**2*k3**6) + 8*C*D1**2*Pk1*Pk2*k1**2*k2**2*st**2*(D1*f*(-84*D1*bd1**2*(r + s - 1)**2 + 2*bd1*(r + s - 1)*(11*D1*f*(r + s - 1) - 18*D1*fd*(2*r + 2*s - 1) - 36*Dd*f*(2*r + 2*s - 1)) - 3*f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1))) + 7*b1**2*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + 2*D1*(Dd*(7*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 12*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 2*b1*(-42*D1**2*bdd1*f*(r + s - 1)**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 44*D1*Dd*f**2*s + 22*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 144*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 + 7*D1*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2))/(105*d**2*k3**6) + 8*C*D1**2*Pk1*Pk2*k2**4*st**6*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 72*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 72*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 144*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 144*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 28*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s - 8*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 12*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s - 2*Dd**2*f**3)/(63*d**2*k3**6) + 8*C*D1**2*Pk1*Pk2*k2**4*st**4*(-D1*f*(14*D1*bd1**2*(r + s - 1)**2 + bd1*(r + s - 1)*(5*D1*f*(r + s - 1) + 2*D1*fd*(2*r + 2*s - 1) + 4*Dd*f*(2*r + 2*s - 1)) + f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1))) + 7*b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-14*D1**2*bdd1*f*(r + s - 1)**2 - 10*D1**2*f*fd*r**2 - 20*D1**2*f*fd*r*s + 10*D1**2*f*fd*r - 10*D1**2*f*fd*s**2 + 10*D1**2*f*fd*s - 5*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s - 20*D1*Dd*f**2*r**2 - 40*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r - 20*D1*Dd*f**2*s**2 + 20*D1*Dd*f**2*s - 10*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 16*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 16*D1*Dd*f*fd*s - 4*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 4*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + 28*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 12*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 12*Dd**2*f**2*s - 2*Dd**2*f**2))/(35*d**2*k3**6) - 4*C*D1**2*Pk1*Pkd2*k1**2*k2*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(35*d**2*k3**4) - 4*C*D1**2*Pk1*Pkd2*k1**2*k2*st**2*(D1*f*(-21*D1*bd1**2*(2*s - 1)*(r + s - 1) + bd1*(D1*(f*(11*s - 18)*(r + s - 1) - 9*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1))) + 21*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(-21*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + 22*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s - 7*D1**2*f*fd - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 44*D1*Dd*f**2*r*s - 11*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 33*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 90*D1*Dd*f*fd*s - 9*D1*Dd*f*fd - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 27*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 21*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 81*Dd**2*f**2*s - 9*Dd**2*f**2))/(105*d**2*k3**4) - 4*C*D1**2*Pk1*Pkd2*k2**3*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(63*d**2*k3**4) - 4*C*D1**2*Pk1*Pkd2*k2**3*st**4*(-D1*f*(7*D1*bd1**2*(2*s - 1)*(r + s - 1) + bd1*(D1*(f*(5*s + 2)*(r + s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) + f*(D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1))) + 7*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(-7*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 10*D1**2*f*fd*r*s + 7*D1**2*f*fd*r - 10*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 7*D1**2*f*fd - 2*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*s**2 + D1**2*f*fdd*s - 2*D1**2*fd**2*r*s - 2*D1**2*fd**2*s**2 + D1**2*fd**2*s - 20*D1*Dd*f**2*r*s + 5*D1*Dd*f**2*r - 20*D1*Dd*f**2*s**2 + 15*D1*Dd*f**2*s - 5*D1*Dd*f**2 - 16*D1*Dd*f*fd*r*s + 2*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 10*D1*Dd*f*fd*s - D1*Dd*f*fd - 4*D1*Ddd*f**2*r*s + D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 3*D1*Ddd*f**2*s - D1*Ddd*f**2 + 7*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 12*Dd**2*f**2*r*s + 3*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 9*Dd**2*f**2*s - Dd**2*f**2))/(35*d**2*k3**4) + 4*C*D1**2*Pk2*Pkd1*k1**3*st**2*(6*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fd*r*s - 3*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 18*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 3*D1**2*f**2*fd*r**2 - 3*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r + D1**2*f**2*fd*s - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r - 10*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 + 12*D1*Dd*b1*f**2*r**2 + 12*D1*Dd*b1*f**2*r*s - 9*D1*Dd*b1*f**2*r - 3*D1*Dd*b1*f**2*s + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 90*D1*Dd*b1*f*fd*r - 18*D1*Dd*b1*f*fd*s + 9*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 4*D1*Dd*f**3*r*s + 3*D1*Dd*f**3*r + D1*Dd*f**3*s - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 105*D1*Dd*f**2*fd*r - 35*D1*Dd*f**2*fd*s + 20*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 27*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 15*D1*Ddd*f**3*r - 5*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 3*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 108*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 81*Dd**2*b1*f**2*r - 27*Dd**2*b1*f**2*s + 9*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 45*Dd**2*f**3*r - 15*Dd**2*f**3*s + 5*Dd**2*f**3)/(315*d**2*k3**4) - 4*C*D1**2*Pk2*Pkd1*k1**3*(-3*D1*f*(7*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-3*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 5*fd*(8*r - 3)*(2*r + 2*s - 1)) + 5*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)))/(105*d**2*k3**4) + 4*C*D1**2*Pk2*Pkd1*k1*k2**2*st**4*(2*D1**2*b1*f*fd*r**2 + 2*D1**2*b1*f*fd*r*s - D1**2*b1*f*fd*r + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*f*fdd*r*s - 3*D1**2*b1*f*fdd*r + 6*D1**2*b1*fd**2*r**2 + 6*D1**2*b1*fd**2*r*s - 3*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 3*D1**2*f**2*fd*r**2 - 3*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r + D1**2*f**2*fd*s - D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 + 4*D1*Dd*b1*f**2*r**2 + 4*D1*Dd*b1*f**2*r*s - 3*D1*Dd*b1*f**2*r - D1*Dd*b1*f**2*s + D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 48*D1*Dd*b1*f*fd*r*s - 30*D1*Dd*b1*f*fd*r - 6*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 4*D1*Dd*f**3*r*s + 3*D1*Dd*f**3*r + D1*Dd*f**3*s - D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 21*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 4*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 + 12*D1*Ddd*b1*f**2*r*s - 9*D1*Ddd*b1*f**2*r - 3*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r - D1*Ddd*f**3*s + D1*Ddd*f**3 + D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 3*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 36*Dd**2*b1*f**2*r**2 + 36*Dd**2*b1*f**2*r*s - 27*Dd**2*b1*f**2*r - 9*Dd**2*b1*f**2*s + 3*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 9*Dd**2*f**3*r - 3*Dd**2*f**3*s + Dd**2*f**3)/(35*d**2*k3**4) + 4*C*D1**2*Pk2*Pkd1*k1*k2**2*st**2*(D1*f*(21*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-11*f*r*(r + s - 1) + 9*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 9*D1*bdd1*f*r*(r + s - 1) + 9*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) - 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r*s + 22*D1**2*f*fd*r + 11*D1**2*f*fd*s - 11*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*r - 9*D1**2*fd**2*s - 44*D1*Dd*f**2*r**2 - 44*D1*Dd*f**2*r*s + 33*D1*Dd*f**2*r + 11*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 144*D1*Dd*f*fd*r*s - 126*D1*Dd*f*fd*r - 54*D1*Dd*f*fd*s + 27*D1*Dd*f*fd + 36*D1*Ddd*f**2*r**2 + 36*D1*Ddd*f**2*r*s - 27*D1*Ddd*f**2*r - 9*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 - 7*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 108*Dd**2*f**2*r**2 + 108*Dd**2*f**2*r*s - 81*Dd**2*f**2*r - 27*Dd**2*f**2*s + 9*Dd**2*f**2))/(105*d**2*k3**4) - C*D1**2*Pk2*Pkdd1*k1**2*st**2*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(315*d**2*k3**2) + C*D1**2*Pk2*Pkdd1*k1**2*(3*D1*f*r*(-14*D1*bd1**2*(r - 1) + D1*bd1*(3*f*r + fd*(10 - 20*r)) - 5*D1*bdd1*f*r + 10*Dd*bd1*f*(1 - 4*r)) + 7*b1**2*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + b1*(-21*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) + 10*fd**2*r*(r - 1)) + 7*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) - 3*D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(8*r**2 - 6*r + 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) - 90*Dd**2*f**2*r*(2*r - 1)))/(105*d**2*k3**2) - C*D1**2*Pk2*Pkdd1*k2**2*st**4*(30*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*fd**2*r**2 + 3*D1**2*bdd1*f**2*(r - 1)**2 + 3*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 60*D1*Dd*b1*f**2*r**2 - 30*D1*Dd*b1*f**2*r + 15*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 - 12*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 - 6*D1*Ddd*b1*f**2*r + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) + 4*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*b1*f**2*r**2 - 18*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(105*d**2*k3**2) - C*D1**2*Pk2*Pkdd1*k2**2*st**2*(D1*f*r*(14*D1*bd1**2*(r - 1) + D1*bd1*(f*r + 6*fd*(2*r - 1)) + 3*D1*bdd1*f*r + 6*Dd*bd1*f*(4*r - 1)) + 7*b1**2*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + b1*(7*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 7*D1*bd1*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r))/(105*d**2*k3**2) - 2*C*D1**2*Pkd1*Pkd2*ct*k1**2*(21*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 15*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(7*b1*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(-3*f*r*(s - 1) + 5*fd*(4*r*s - 2*r - s + 1)) + 5*Dd*f*(r*(8*s - 5) - s + 1))) + 7*b1**2*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(7*D1*bdd1*f*(r*(2*s - 1) - s) - D1*s*(2*r - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) + 4*C*D1**2*Pkd1*Pkd2*k1*k2*st**4*(3*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-4*r*s + r + 2*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 3*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 7*r + 7*s - 2)) + D1*(D1*(2*f*fd*(r*(3*s - 1) - s) + f*(-3*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) + fd**2*(r*(2 - 6*s) + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) + 4*C*D1**2*Pkd1*Pkd2*k1*k2*st**2*(-7*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) - 3*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(7*b1*(D1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) - 2*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(2*f*r*(s - 1) + fd*(-4*r*s + 2*r + s - 1)) + Dd*f*(r*(5 - 8*s) + s - 1))) - 7*b1**2*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(3*D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-16*r*s + 2*r + 6*s - 1)) + D1*(7*D1*bdd1*f*(-2*r*s + r + s) + 3*D1*s*(2*r - 1)*(2*f*fd - f*fdd - fd**2) + 3*Ddd*f**2*(-4*r*s + r + s)) - 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) - 4*D1**3*Pk1*Pk2*ct**3*k2**5*(3*D1*bd1*f**2*(r + s - 1)**2 + 5*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + b1*f*(10*D1*bd1*(r + s - 1)**2 + (3*D1*fd + 6*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(15*d**2*k1*k3**6) - D1**3*Pk1*Pk2*ct**2*k2**4*(8*C + 8)*(3*D1*bd1*f**2*(r + s - 1)**2 + 5*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + b1*f*(10*D1*bd1*(r + s - 1)**2 + (3*D1*fd + 6*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(15*d**2*k3**6) + 2*D1**3*Pk1*Pk2*ct**2*k2**4*(3*D1*bd1*f**2*r*(r + s - 1) + 5*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s - 3*r - s + 1)) + b1*f*(5*D1*bd1*(2*r - 1)*(r + s - 1) + 3*D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)))/(15*d**2*k1**2*k3**4) - D1**3*Pk1*Pk2*ct*k1*k2**3*(16*C + 4)*(3*D1*bd1*f**2*(r + s - 1)**2 + 5*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + b1*f*(10*D1*bd1*(r + s - 1)**2 + (3*D1*fd + 6*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(15*d**2*k3**6) - 4*D1**3*Pk1*Pk2*ct*k2**5*st**2*(D1*bd1*f**2*(r + s - 1)**2 + 5*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + b1*f*(10*D1*bd1*(r + s - 1)**2 + (D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(15*d**2*k1*k3**6) + 4*D1**3*Pk1*Pk2*ct*k2**3*(3*D1*bd1*f**2*r*(r + s - 1) + 5*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s - 3*r - s + 1)) + b1*f*(5*D1*bd1*(2*r - 1)*(r + s - 1) + 3*D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)))/(15*d**2*k1*k3**4) + 2*D1**3*Pk1*Pk2*k2**2*(3*D1*bd1*f**2*r*(r + s - 1) + 5*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s - 3*r - s + 1)) + b1*f*(5*D1*bd1*(2*r - 1)*(r + s - 1) + 3*D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)))/(15*d**2*k3**4) + 2*D1**3*Pk1*Pk2*k2**4*st**2*(D1*bd1*f**2*r*(r + s - 1) + 5*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + b1*f*(5*D1*bd1*(2*r - 1)*(r + s - 1) + D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)))/(15*d**2*k1**2*k3**4) + D1**3*Pk1*Pkd2*b1*k2*(D1*bd1*f*r*(1 - 2*s) + 3*Dd*b1**2*(-4*r*s + r + s) + b1*(3*D1*bd1*(-3*r*s + r + s) - D1*fd*s*(r - 1) + Dd*f*(-4*r*s + r + s)))/(3*d**2*k1**2) + 2*D1**3*Pk1*Pkd2*ct**3*k2**4*(3*D1*bd1*f**2*(s - 1)*(r + s - 1) + 5*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(5*D1*bd1*(2*s - 1)*(r + s - 1) + 3*D1*fd*s*(2*r + 2*s - 1) + 3*Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))/(15*d**2*k1*k3**4) + D1**3*Pk1*Pkd2*ct**2*k2**3*(4*C + 4)*(3*D1*bd1*f**2*(s - 1)*(r + s - 1) + 5*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(5*D1*bd1*(2*s - 1)*(r + s - 1) + 3*D1*fd*s*(2*r + 2*s - 1) + 3*Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))/(15*d**2*k3**4) + D1**3*Pk1*Pkd2*ct**2*k2**3*(-3*D1*bd1*f**2*r*(s - 1) - 5*b1**2*(D1*fd*r*s + Dd*f*(4*r*s - r - s)) + b1*f*(5*D1*bd1*(-2*r*s + r + s) + 3*D1*fd*s*(1 - 2*r) + 3*Dd*f*(-4*r*s + r + s)))/(15*d**2*k1**2*k3**2) + D1**3*Pk1*Pkd2*ct*k1*k2**2*(8*C + 2)*(3*D1*bd1*f**2*(s - 1)*(r + s - 1) + 5*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(5*D1*bd1*(2*s - 1)*(r + s - 1) + 3*D1*fd*s*(2*r + 2*s - 1) + 3*Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))/(15*d**2*k3**4) + 2*D1**3*Pk1*Pkd2*ct*k2**4*st**2*(D1*bd1*f**2*(s - 1)*(r + s - 1) + 5*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(5*D1*bd1*(2*s - 1)*(r + s - 1) + D1*fd*s*(2*r + 2*s - 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1)))/(15*d**2*k1*k3**4) - 2*D1**3*Pk1*Pkd2*ct*k2**2*(3*D1*bd1*f**2*r*(s - 1) + 5*b1**2*(D1*fd*r*s + Dd*f*(r*(4*s - 1) - s)) + b1*f*(5*D1*bd1*(r*(2*s - 1) - s) + 3*D1*fd*s*(2*r - 1) + 3*Dd*f*(4*r*s - r - s)))/(15*d**2*k1*k3**2) + D1**3*Pk1*Pkd2*k2*(-3*D1*bd1*f**2*r*(s - 1) - 5*b1**2*(D1*fd*r*s + Dd*f*(4*r*s - r - s)) + b1*f*(5*D1*bd1*(-2*r*s + r + s) + 3*D1*fd*s*(1 - 2*r) + 3*Dd*f*(-4*r*s + r + s)))/(15*d**2*k3**2) + D1**3*Pk1*Pkd2*k2**3*st**2*(-D1*bd1*f**2*r*(s - 1) - 5*b1**2*(D1*fd*r*s + Dd*f*(r*(4*s - 1) - s)) + b1*f*(5*D1*bd1*(-2*r*s + r + s) + D1*fd*s*(1 - 2*r) + Dd*f*(-4*r*s + r + s)))/(15*d**2*k1**2*k3**2) - D1**2*Pk1*Pk2*ct**8*k2**4*(8*C - 8)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 42*D1**2*f**2*fd*r**2 + 84*D1**2*f**2*fd*r*s - 56*D1**2*f**2*fd*r + 42*D1**2*f**2*fd*s**2 - 56*D1**2*f**2*fd*s + 28*D1**2*f**2*fd - 21*D1**2*f**2*fdd*r**2 - 42*D1**2*f**2*fdd*r*s + 28*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd*s**2 + 28*D1**2*f**2*fdd*s - 14*D1**2*f**2*fdd - 42*D1**2*f*fd**2*r**2 - 84*D1**2*f*fd**2*r*s + 56*D1**2*f*fd**2*r - 42*D1**2*f*fd**2*s**2 + 56*D1**2*f*fd**2*s - 14*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 72*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 72*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 144*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 144*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 56*D1*Dd*f**3*r**2 + 112*D1*Dd*f**3*r*s - 56*D1*Dd*f**3*r + 56*D1*Dd*f**3*s**2 - 56*D1*Dd*f**3*s + 28*D1*Dd*f**3 - 168*D1*Dd*f**2*fd*r**2 - 336*D1*Dd*f**2*fd*r*s + 196*D1*Dd*f**2*fd*r - 168*D1*Dd*f**2*fd*s**2 + 196*D1*Dd*f**2*fd*s - 56*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 - 56*D1*Ddd*f**3*r*s + 28*D1*Ddd*f**3*r - 28*D1*Ddd*f**3*s**2 + 28*D1*Ddd*f**3*s - 14*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 84*Dd**2*f**3*r**2 - 168*Dd**2*f**3*r*s + 84*Dd**2*f**3*r - 84*Dd**2*f**3*s**2 + 84*Dd**2*f**3*s - 14*Dd**2*f**3)/(63*d**2*k3**6) - D1**2*Pk1*Pk2*ct**8*k2**2*(16*C - 16)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 14*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 7*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 7*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(63*d**2*k3**4) - D1**2*Pk1*Pk2*ct**8*(8*C - 8)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k3**2) + 4*D1**2*Pk1*Pk2*ct**7*f*(11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(18*fd*(4*s**2 - 2*s + 1) - 9*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + 2*fd*s*(bd1*(11 - 33*s) + 27*fd*(1 - 2*s))) + D1*f*(18*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(11*bd1*s + 9*fd*(4*s - 1)) - 9*Ddd*f*(4*s**2 - 2*s + 1)) + 54*Dd**2*f**2*s*(1 - 2*s)))/(33*d**2*k1*k2) - 4*D1**2*Pk1*Pk2*ct**7*k1*k2**3*(936*C*D1**2*b1*f*fd*r**2 + 1872*C*D1**2*b1*f*fd*r*s - 936*C*D1**2*b1*f*fd*r + 936*C*D1**2*b1*f*fd*s**2 - 936*C*D1**2*b1*f*fd*s + 468*C*D1**2*b1*f*fd - 720*C*D1**2*b1*f*fdd*r**2 - 1440*C*D1**2*b1*f*fdd*r*s + 720*C*D1**2*b1*f*fdd*r - 720*C*D1**2*b1*f*fdd*s**2 + 720*C*D1**2*b1*f*fdd*s - 360*C*D1**2*b1*f*fdd - 720*C*D1**2*b1*fd**2*r**2 - 1440*C*D1**2*b1*fd**2*r*s + 720*C*D1**2*b1*fd**2*r - 720*C*D1**2*b1*fd**2*s**2 + 720*C*D1**2*b1*fd**2*s + 1140*C*D1**2*f**2*fd*r**2 + 2280*C*D1**2*f**2*fd*r*s - 1520*C*D1**2*f**2*fd*r + 1140*C*D1**2*f**2*fd*s**2 - 1520*C*D1**2*f**2*fd*s + 760*C*D1**2*f**2*fd - 840*C*D1**2*f**2*fdd*r**2 - 1680*C*D1**2*f**2*fdd*r*s + 1120*C*D1**2*f**2*fdd*r - 840*C*D1**2*f**2*fdd*s**2 + 1120*C*D1**2*f**2*fdd*s - 560*C*D1**2*f**2*fdd - 1680*C*D1**2*f*fd**2*r**2 - 3360*C*D1**2*f*fd**2*r*s + 2240*C*D1**2*f*fd**2*r - 1680*C*D1**2*f*fd**2*s**2 + 2240*C*D1**2*f*fd**2*s - 560*C*D1**2*f*fd**2 + 1872*C*D1*Dd*b1*f**2*r**2 + 3744*C*D1*Dd*b1*f**2*r*s - 1872*C*D1*Dd*b1*f**2*r + 1872*C*D1*Dd*b1*f**2*s**2 - 1872*C*D1*Dd*b1*f**2*s + 936*C*D1*Dd*b1*f**2 - 5760*C*D1*Dd*b1*f*fd*r**2 - 11520*C*D1*Dd*b1*f*fd*r*s + 5760*C*D1*Dd*b1*f*fd*r - 5760*C*D1*Dd*b1*f*fd*s**2 + 5760*C*D1*Dd*b1*f*fd*s - 1440*C*D1*Dd*b1*f*fd + 1520*C*D1*Dd*f**3*r**2 + 3040*C*D1*Dd*f**3*r*s - 1520*C*D1*Dd*f**3*r + 1520*C*D1*Dd*f**3*s**2 - 1520*C*D1*Dd*f**3*s + 760*C*D1*Dd*f**3 - 6720*C*D1*Dd*f**2*fd*r**2 - 13440*C*D1*Dd*f**2*fd*r*s + 7840*C*D1*Dd*f**2*fd*r - 6720*C*D1*Dd*f**2*fd*s**2 + 7840*C*D1*Dd*f**2*fd*s - 2240*C*D1*Dd*f**2*fd - 1440*C*D1*Ddd*b1*f**2*r**2 - 2880*C*D1*Ddd*b1*f**2*r*s + 1440*C*D1*Ddd*b1*f**2*r - 1440*C*D1*Ddd*b1*f**2*s**2 + 1440*C*D1*Ddd*b1*f**2*s - 720*C*D1*Ddd*b1*f**2 - 1120*C*D1*Ddd*f**3*r**2 - 2240*C*D1*Ddd*f**3*r*s + 1120*C*D1*Ddd*f**3*r - 1120*C*D1*Ddd*f**3*s**2 + 1120*C*D1*Ddd*f**3*s - 560*C*D1*Ddd*f**3 - 4320*C*Dd**2*b1*f**2*r**2 - 8640*C*Dd**2*b1*f**2*r*s + 4320*C*Dd**2*b1*f**2*r - 4320*C*Dd**2*b1*f**2*s**2 + 4320*C*Dd**2*b1*f**2*s - 720*C*Dd**2*b1*f**2 - 3360*C*Dd**2*f**3*r**2 - 6720*C*Dd**2*f**3*r*s + 3360*C*Dd**2*f**3*r - 3360*C*Dd**2*f**3*s**2 + 3360*C*Dd**2*f**3*s - 560*C*Dd**2*f**3 - 1116*D1**2*b1*f*fd*r**2 - 2232*D1**2*b1*f*fd*r*s + 1116*D1**2*b1*f*fd*r - 1116*D1**2*b1*f*fd*s**2 + 1116*D1**2*b1*f*fd*s - 558*D1**2*b1*f*fd + 810*D1**2*b1*f*fdd*r**2 + 1620*D1**2*b1*f*fdd*r*s - 810*D1**2*b1*f*fdd*r + 810*D1**2*b1*f*fdd*s**2 - 810*D1**2*b1*f*fdd*s + 405*D1**2*b1*f*fdd + 810*D1**2*b1*fd**2*r**2 + 1620*D1**2*b1*fd**2*r*s - 810*D1**2*b1*fd**2*r + 810*D1**2*b1*fd**2*s**2 - 810*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(8*C - 9)*(r + s - 1)**2 - 1350*D1**2*f**2*fd*r**2 - 2700*D1**2*f**2*fd*r*s + 1800*D1**2*f**2*fd*r - 1350*D1**2*f**2*fd*s**2 + 1800*D1**2*f**2*fd*s - 900*D1**2*f**2*fd + 945*D1**2*f**2*fdd*r**2 + 1890*D1**2*f**2*fdd*r*s - 1260*D1**2*f**2*fdd*r + 945*D1**2*f**2*fdd*s**2 - 1260*D1**2*f**2*fdd*s + 630*D1**2*f**2*fdd + 1890*D1**2*f*fd**2*r**2 + 3780*D1**2*f*fd**2*r*s - 2520*D1**2*f*fd**2*r + 1890*D1**2*f*fd**2*s**2 - 2520*D1**2*f*fd**2*s + 630*D1**2*f*fd**2 - 2232*D1*Dd*b1*f**2*r**2 - 4464*D1*Dd*b1*f**2*r*s + 2232*D1*Dd*b1*f**2*r - 2232*D1*Dd*b1*f**2*s**2 + 2232*D1*Dd*b1*f**2*s - 1116*D1*Dd*b1*f**2 + 6480*D1*Dd*b1*f*fd*r**2 + 12960*D1*Dd*b1*f*fd*r*s - 6480*D1*Dd*b1*f*fd*r + 6480*D1*Dd*b1*f*fd*s**2 - 6480*D1*Dd*b1*f*fd*s + 1620*D1*Dd*b1*f*fd - 1800*D1*Dd*f**3*r**2 - 3600*D1*Dd*f**3*r*s + 1800*D1*Dd*f**3*r - 1800*D1*Dd*f**3*s**2 + 1800*D1*Dd*f**3*s - 900*D1*Dd*f**3 + 7560*D1*Dd*f**2*fd*r**2 + 15120*D1*Dd*f**2*fd*r*s - 8820*D1*Dd*f**2*fd*r + 7560*D1*Dd*f**2*fd*s**2 - 8820*D1*Dd*f**2*fd*s + 2520*D1*Dd*f**2*fd + 1620*D1*Ddd*b1*f**2*r**2 + 3240*D1*Ddd*b1*f**2*r*s - 1620*D1*Ddd*b1*f**2*r + 1620*D1*Ddd*b1*f**2*s**2 - 1620*D1*Ddd*b1*f**2*s + 810*D1*Ddd*b1*f**2 + 1260*D1*Ddd*f**3*r**2 + 2520*D1*Ddd*f**3*r*s - 1260*D1*Ddd*f**3*r + 1260*D1*Ddd*f**3*s**2 - 1260*D1*Ddd*f**3*s + 630*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(26*C - 31)*(r + s - 1) - D1*fd*(40*C - 45)*(2*r + 2*s - 1) - Dd*f*(80*C - 90)*(2*r + 2*s - 1)) + 4860*Dd**2*b1*f**2*r**2 + 9720*Dd**2*b1*f**2*r*s - 4860*Dd**2*b1*f**2*r + 4860*Dd**2*b1*f**2*s**2 - 4860*Dd**2*b1*f**2*s + 810*Dd**2*b1*f**2 + 3780*Dd**2*f**3*r**2 + 7560*Dd**2*f**3*r*s - 3780*Dd**2*f**3*r + 3780*Dd**2*f**3*s**2 - 3780*Dd**2*f**3*s + 630*Dd**2*f**3)/(315*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**7*k1*k2*(9*b1*(D1**2*(f*(fd*(46*C - 56) + fdd*(35 - 30*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(35 - 30*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(46*C - 56)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(35 - 30*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(35 - 30*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(35 - 30*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(66*C - 80)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (6*C - 7)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(49 - 42*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(46*C - 56)*(r + s - 1) - fd*(30*C - 35)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(35 - 30*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*(f*(66*C - 80)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(42*C - 49)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(49 - 42*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(49 - 42*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(315*d**2*k3**4) - D1**2*Pk1*Pk2*ct**7*k1*(16*C - 20)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2*k3**2) + 4*D1**2*Pk1*Pk2*ct**7*k2**5*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 42*D1**2*f**2*fd*r**2 + 84*D1**2*f**2*fd*r*s - 56*D1**2*f**2*fd*r + 42*D1**2*f**2*fd*s**2 - 56*D1**2*f**2*fd*s + 28*D1**2*f**2*fd - 21*D1**2*f**2*fdd*r**2 - 42*D1**2*f**2*fdd*r*s + 28*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd*s**2 + 28*D1**2*f**2*fdd*s - 14*D1**2*f**2*fdd - 42*D1**2*f*fd**2*r**2 - 84*D1**2*f*fd**2*r*s + 56*D1**2*f*fd**2*r - 42*D1**2*f*fd**2*s**2 + 56*D1**2*f*fd**2*s - 14*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 72*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 72*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 144*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 144*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 56*D1*Dd*f**3*r**2 + 112*D1*Dd*f**3*r*s - 56*D1*Dd*f**3*r + 56*D1*Dd*f**3*s**2 - 56*D1*Dd*f**3*s + 28*D1*Dd*f**3 - 168*D1*Dd*f**2*fd*r**2 - 336*D1*Dd*f**2*fd*r*s + 196*D1*Dd*f**2*fd*r - 168*D1*Dd*f**2*fd*s**2 + 196*D1*Dd*f**2*fd*s - 56*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 - 56*D1*Ddd*f**3*r*s + 28*D1*Ddd*f**3*r - 28*D1*Ddd*f**3*s**2 + 28*D1*Ddd*f**3*s - 14*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 84*Dd**2*f**3*r**2 - 168*Dd**2*f**3*r*s + 84*Dd**2*f**3*r - 84*Dd**2*f**3*s**2 + 84*Dd**2*f**3*s - 14*Dd**2*f**3)/(63*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk2*ct**7*k2**3*(9*D1*bd1*f*(D1*(2*f*(r + s - 1)*(7*C*(r - 1) - 7*r + 5*s + 7) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 9*b1*(D1**2*(f*(2*fd*(r**2*(14*C - 14) + r*(7*C - 2)*(2*s - 1) + 10*s**2 - 10*s + 5) - 5*fdd*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(14*C*f*(4*r**2 + r*(4*s - 3) - s + 1) - 4*f*(14*r**2 + 4*r*(s - 2) - 10*s**2 + 4*s + 1) - 5*fd*(8*s - 3)*(2*r + 2*s - 1)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) - 5*f*(D1**2*(f*(9*bdd1*s*(r + s - 1) + 2*fd*(-13*C*(3*r**2 + 3*r*(s - 1) - s + 1) + 39*r**2 + 18*r*s - 32*r - 21*s**2 + 8*s + 6) + fdd*(4*C*(3*r**2 + 3*r*(s - 1) - s + 1) - 12*r**2 + 9*r*s + 5*r + 21*s**2 - 17*s + 3)) + fd**2*(4*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 24*r**2 + 2*r*(9*s + 5) + 42*s**2 - 34*s + 3)) + D1*f*(Dd*(-2*f*(13*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 52*r**2 - 24*r*s + 32*r + 28*s**2 - 8*s - 6) + fd*(4*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) - 96*r**2 + 72*r*s + 35*r + 168*s**2 - 119*s + 12)) + Ddd*f*(4*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 16*r**2 + 12*r*s + 5*r + 28*s**2 - 17*s + 3)) + Dd**2*f**2*(4*C*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1) - 48*r**2 + 3*r*(12*s + 5) + 84*s**2 - 51*s + 3)))/(315*d**2*k1*k3**4) - 8*D1**2*Pk1*Pk2*ct**6*k1**2*k2**2*(450*C*D1**2*b1*f*fd*r**2 + 900*C*D1**2*b1*f*fd*r*s - 450*C*D1**2*b1*f*fd*r + 450*C*D1**2*b1*f*fd*s**2 - 450*C*D1**2*b1*f*fd*s + 225*C*D1**2*b1*f*fd - 540*C*D1**2*b1*f*fdd*r**2 - 1080*C*D1**2*b1*f*fdd*r*s + 540*C*D1**2*b1*f*fdd*r - 540*C*D1**2*b1*f*fdd*s**2 + 540*C*D1**2*b1*f*fdd*s - 270*C*D1**2*b1*f*fdd - 540*C*D1**2*b1*fd**2*r**2 - 1080*C*D1**2*b1*fd**2*r*s + 540*C*D1**2*b1*fd**2*r - 540*C*D1**2*b1*fd**2*s**2 + 540*C*D1**2*b1*fd**2*s + 585*C*D1**2*f**2*fd*r**2 + 1170*C*D1**2*f**2*fd*r*s - 780*C*D1**2*f**2*fd*r + 585*C*D1**2*f**2*fd*s**2 - 780*C*D1**2*f**2*fd*s + 390*C*D1**2*f**2*fd - 630*C*D1**2*f**2*fdd*r**2 - 1260*C*D1**2*f**2*fdd*r*s + 840*C*D1**2*f**2*fdd*r - 630*C*D1**2*f**2*fdd*s**2 + 840*C*D1**2*f**2*fdd*s - 420*C*D1**2*f**2*fdd - 1260*C*D1**2*f*fd**2*r**2 - 2520*C*D1**2*f*fd**2*r*s + 1680*C*D1**2*f*fd**2*r - 1260*C*D1**2*f*fd**2*s**2 + 1680*C*D1**2*f*fd**2*s - 420*C*D1**2*f*fd**2 + 900*C*D1*Dd*b1*f**2*r**2 + 1800*C*D1*Dd*b1*f**2*r*s - 900*C*D1*Dd*b1*f**2*r + 900*C*D1*Dd*b1*f**2*s**2 - 900*C*D1*Dd*b1*f**2*s + 450*C*D1*Dd*b1*f**2 - 4320*C*D1*Dd*b1*f*fd*r**2 - 8640*C*D1*Dd*b1*f*fd*r*s + 4320*C*D1*Dd*b1*f*fd*r - 4320*C*D1*Dd*b1*f*fd*s**2 + 4320*C*D1*Dd*b1*f*fd*s - 1080*C*D1*Dd*b1*f*fd + 780*C*D1*Dd*f**3*r**2 + 1560*C*D1*Dd*f**3*r*s - 780*C*D1*Dd*f**3*r + 780*C*D1*Dd*f**3*s**2 - 780*C*D1*Dd*f**3*s + 390*C*D1*Dd*f**3 - 5040*C*D1*Dd*f**2*fd*r**2 - 10080*C*D1*Dd*f**2*fd*r*s + 5880*C*D1*Dd*f**2*fd*r - 5040*C*D1*Dd*f**2*fd*s**2 + 5880*C*D1*Dd*f**2*fd*s - 1680*C*D1*Dd*f**2*fd - 1080*C*D1*Ddd*b1*f**2*r**2 - 2160*C*D1*Ddd*b1*f**2*r*s + 1080*C*D1*Ddd*b1*f**2*r - 1080*C*D1*Ddd*b1*f**2*s**2 + 1080*C*D1*Ddd*b1*f**2*s - 540*C*D1*Ddd*b1*f**2 - 840*C*D1*Ddd*f**3*r**2 - 1680*C*D1*Ddd*f**3*r*s + 840*C*D1*Ddd*f**3*r - 840*C*D1*Ddd*f**3*s**2 + 840*C*D1*Ddd*f**3*s - 420*C*D1*Ddd*f**3 - 3240*C*Dd**2*b1*f**2*r**2 - 6480*C*Dd**2*b1*f**2*r*s + 3240*C*Dd**2*b1*f**2*r - 3240*C*Dd**2*b1*f**2*s**2 + 3240*C*Dd**2*b1*f**2*s - 540*C*Dd**2*b1*f**2 - 2520*C*Dd**2*f**3*r**2 - 5040*C*Dd**2*f**3*r*s + 2520*C*Dd**2*f**3*r - 2520*C*Dd**2*f**3*s**2 + 2520*C*Dd**2*f**3*s - 420*C*Dd**2*f**3 - 684*D1**2*b1*f*fd*r**2 - 1368*D1**2*b1*f*fd*r*s + 684*D1**2*b1*f*fd*r - 684*D1**2*b1*f*fd*s**2 + 684*D1**2*b1*f*fd*s - 342*D1**2*b1*f*fd + 720*D1**2*b1*f*fdd*r**2 + 1440*D1**2*b1*f*fdd*r*s - 720*D1**2*b1*f*fdd*r + 720*D1**2*b1*f*fdd*s**2 - 720*D1**2*b1*f*fdd*s + 360*D1**2*b1*f*fdd + 720*D1**2*b1*fd**2*r**2 + 1440*D1**2*b1*fd**2*r*s - 720*D1**2*b1*fd**2*r + 720*D1**2*b1*fd**2*s**2 - 720*D1**2*b1*fd**2*s - 90*D1**2*bdd1*f**2*(3*C - 4)*(r + s - 1)**2 - 870*D1**2*f**2*fd*r**2 - 1740*D1**2*f**2*fd*r*s + 1160*D1**2*f**2*fd*r - 870*D1**2*f**2*fd*s**2 + 1160*D1**2*f**2*fd*s - 580*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 + 1680*D1**2*f**2*fdd*r*s - 1120*D1**2*f**2*fdd*r + 840*D1**2*f**2*fdd*s**2 - 1120*D1**2*f**2*fdd*s + 560*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r**2 + 3360*D1**2*f*fd**2*r*s - 2240*D1**2*f*fd**2*r + 1680*D1**2*f*fd**2*s**2 - 2240*D1**2*f*fd**2*s + 560*D1**2*f*fd**2 - 1368*D1*Dd*b1*f**2*r**2 - 2736*D1*Dd*b1*f**2*r*s + 1368*D1*Dd*b1*f**2*r - 1368*D1*Dd*b1*f**2*s**2 + 1368*D1*Dd*b1*f**2*s - 684*D1*Dd*b1*f**2 + 5760*D1*Dd*b1*f*fd*r**2 + 11520*D1*Dd*b1*f*fd*r*s - 5760*D1*Dd*b1*f*fd*r + 5760*D1*Dd*b1*f*fd*s**2 - 5760*D1*Dd*b1*f*fd*s + 1440*D1*Dd*b1*f*fd - 1160*D1*Dd*f**3*r**2 - 2320*D1*Dd*f**3*r*s + 1160*D1*Dd*f**3*r - 1160*D1*Dd*f**3*s**2 + 1160*D1*Dd*f**3*s - 580*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 + 13440*D1*Dd*f**2*fd*r*s - 7840*D1*Dd*f**2*fd*r + 6720*D1*Dd*f**2*fd*s**2 - 7840*D1*Dd*f**2*fd*s + 2240*D1*Dd*f**2*fd + 1440*D1*Ddd*b1*f**2*r**2 + 2880*D1*Ddd*b1*f**2*r*s - 1440*D1*Ddd*b1*f**2*r + 1440*D1*Ddd*b1*f**2*s**2 - 1440*D1*Ddd*b1*f**2*s + 720*D1*Ddd*b1*f**2 + 1120*D1*Ddd*f**3*r**2 + 2240*D1*Ddd*f**3*r*s - 1120*D1*Ddd*f**3*r + 1120*D1*Ddd*f**3*s**2 - 1120*D1*Ddd*f**3*s + 560*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(D1*f*(25*C - 38)*(r + s - 1) - D1*fd*(60*C - 80)*(2*r + 2*s - 1) - Dd*f*(120*C - 160)*(2*r + 2*s - 1)) + 4320*Dd**2*b1*f**2*r**2 + 8640*Dd**2*b1*f**2*r*s - 4320*Dd**2*b1*f**2*r + 4320*Dd**2*b1*f**2*s**2 - 4320*Dd**2*b1*f**2*s + 720*Dd**2*b1*f**2 + 3360*Dd**2*f**3*r**2 + 6720*Dd**2*f**3*r*s - 3360*Dd**2*f**3*r + 3360*Dd**2*f**3*s**2 - 3360*Dd**2*f**3*s + 560*Dd**2*f**3)/(315*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**6*k1**2*(3*b1*(D1**2*(f*(fd*(32*C - 55) + fdd*(45 - 30*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(45 - 30*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(32*C - 55)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(45 - 30*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(45 - 30*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(45 - 30*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(16*C - 27)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (2*C - 3)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(21 - 14*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(32*C - 55)*(r + s - 1) - fd*(30*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(45 - 30*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*(f*(16*C - 27)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(14*C - 21)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(21 - 14*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(21 - 14*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) - D1**2*Pk1*Pk2*ct**6*k1**2*(8*C - 16)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2**2*k3**2) - D1**2*Pk1*Pk2*ct**6*k2**4*st**2*(8*C - 8)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 20*D1**2*f**2*fdd*s - 10*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 40*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 72*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 72*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 144*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 144*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 40*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 40*D1*Dd*f**3*s + 20*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 140*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 140*D1*Dd*f**2*fd*s - 40*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 20*D1*Ddd*f**3*s - 10*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 60*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 60*Dd**2*f**3*s - 10*Dd**2*f**3)/(21*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**6*k2**4*(63*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 9*b1*(-14*C*D1**2*f*fd*r**2 - 28*C*D1**2*f*fd*r*s + 14*C*D1**2*f*fd*r - 14*C*D1**2*f*fd*s**2 + 14*C*D1**2*f*fd*s - 7*C*D1**2*f*fd - 28*C*D1*Dd*f**2*r**2 - 56*C*D1*Dd*f**2*r*s + 28*C*D1*Dd*f**2*r - 28*C*D1*Dd*f**2*s**2 + 28*C*D1*Dd*f**2*s - 14*C*D1*Dd*f**2 - 14*D1**2*bdd1*f*(C - 1)*(r + s - 1)**2 - 32*D1**2*f*fd*r**2 - 64*D1**2*f*fd*r*s + 32*D1**2*f*fd*r - 32*D1**2*f*fd*s**2 + 32*D1**2*f*fd*s - 16*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s + 15*D1**2*f*fdd + 30*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 30*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s - 64*D1*Dd*f**2*r**2 - 128*D1*Dd*f**2*r*s + 64*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 + 64*D1*Dd*f**2*s - 32*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 240*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 240*D1*Dd*f*fd*s + 60*D1*Dd*f*fd + 60*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 60*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) + 180*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 180*Dd**2*f**2*s + 30*Dd**2*f**2) + f*(-126*D1**2*bd1**2*(C - 1)*(r + s - 1)**2 + 135*D1**2*bdd1*f*(r + s - 1)**2 + 5*D1**2*(-f*(fd*(23*C + 10) - fdd*(7*C + 14))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(14*C + 28)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 9*D1*bd1*(r + s - 1)*(D1*f*(7*C + 16)*(r + s - 1) - 30*D1*fd*(2*r + 2*s - 1) - 60*Dd*f*(2*r + 2*s - 1)) - 10*D1*f*(Dd*(f*(23*C + 10)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(14*C + 28)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Ddd*f*(-7*C - 14)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 5*Dd**2*f**2*(14*C + 28)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(315*d**2*k3**6) - D1**2*Pk1*Pk2*ct**6*k2**2*st**2*(16*C - 16)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 10*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(21*d**2*k3**4) - 2*D1**2*Pk1*Pk2*ct**6*k2**2*(252*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 9*b1*(-154*C*D1**2*f*fd*r**2 - 388*C*D1**2*f*fd*r*s + 234*C*D1**2*f*fd*r - 234*C*D1**2*f*fd*s**2 + 274*C*D1**2*f*fd*s - 157*C*D1**2*f*fd + 70*C*D1**2*f*fdd*r**2 + 236*C*D1**2*f*fdd*r*s - 138*C*D1**2*f*fdd*r + 166*C*D1**2*f*fdd*s**2 - 186*C*D1**2*f*fdd*s + 103*C*D1**2*f*fdd + 70*C*D1**2*fd**2*r**2 + 236*C*D1**2*fd**2*r*s - 138*C*D1**2*fd**2*r + 166*C*D1**2*fd**2*s**2 - 186*C*D1**2*fd**2*s - 308*C*D1*Dd*f**2*r**2 - 776*C*D1*Dd*f**2*r*s + 348*C*D1*Dd*f**2*r - 468*C*D1*Dd*f**2*s**2 + 428*C*D1*Dd*f**2*s - 194*C*D1*Dd*f**2 + 560*C*D1*Dd*f*fd*r**2 + 1888*C*D1*Dd*f*fd*r*s - 928*C*D1*Dd*f*fd*r + 1328*C*D1*Dd*f*fd*s**2 - 1312*C*D1*Dd*f*fd*s + 324*C*D1*Dd*f*fd + 140*C*D1*Ddd*f**2*r**2 + 472*C*D1*Ddd*f**2*r*s - 188*C*D1*Ddd*f**2*r + 332*C*D1*Ddd*f**2*s**2 - 284*C*D1*Ddd*f**2*s + 118*C*D1*Ddd*f**2 + 420*C*Dd**2*f**2*r**2 + 1416*C*Dd**2*f**2*r*s - 564*C*Dd**2*f**2*r + 996*C*Dd**2*f**2*s**2 - 852*C*Dd**2*f**2*s + 118*C*Dd**2*f**2 - 28*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) + 174*D1**2*f*fd*r**2 + 236*D1**2*f*fd*r*s - 158*D1**2*f*fd*r + 62*D1**2*f*fd*s**2 - 102*D1**2*f*fd*s + 71*D1**2*f*fd - 80*D1**2*f*fdd*r**2 - 146*D1**2*f*fdd*r*s + 93*D1**2*f*fdd*r - 66*D1**2*f*fdd*s**2 + 86*D1**2*f*fdd*s - 53*D1**2*f*fdd - 80*D1**2*fd**2*r**2 - 146*D1**2*fd**2*r*s + 93*D1**2*fd**2*r - 66*D1**2*fd**2*s**2 + 86*D1**2*fd**2*s + 348*D1*Dd*f**2*r**2 + 472*D1*Dd*f**2*r*s - 292*D1*Dd*f**2*r + 124*D1*Dd*f**2*s**2 - 180*D1*Dd*f**2*s + 118*D1*Dd*f**2 - 640*D1*Dd*f*fd*r**2 - 1168*D1*Dd*f*fd*r*s + 678*D1*Dd*f*fd*r - 528*D1*Dd*f*fd*s**2 + 622*D1*Dd*f*fd*s - 179*D1*Dd*f*fd - 160*D1*Ddd*f**2*r**2 - 292*D1*Ddd*f**2*r*s + 153*D1*Ddd*f**2*r - 132*D1*Ddd*f**2*s**2 + 139*D1*Ddd*f**2*s - 73*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 480*Dd**2*f**2*r**2 - 876*Dd**2*f**2*r*s + 459*Dd**2*f**2*r - 396*Dd**2*f**2*s**2 + 417*Dd**2*f**2*s - 73*Dd**2*f**2) + f*(-252*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) + 9*D1**2*bdd1*f*(r + s - 1)*(C*(35*r + 83*s - 15) - 40*r - 33*s + 20) - 5*D1**2*(f*(fd*(C*(441*r**2 + 1074*r*s - 652*r + 633*s**2 - 780*s + 358) - 507*r**2 - 774*r*s + 596*r - 267*s**2 + 436*s - 258) + fdd*(-C*(207*r**2 + 618*r*s - 344*r + 411*s**2 - 480*s + 206) + 240*r**2 + 441*r*s - 307*r + 201*s**2 - 281*s + 147)) + fd**2*(-2*C*(207*r**2 + 618*r*s - 344*r + 411*s**2 - 480*s + 103) + 480*r**2 + 882*r*s - 614*r + 402*s**2 - 562*s + 147)) - 9*D1*bd1*(D1*(f*(r + s - 1)*(C*(77*r + 117*s - 37) - 87*r - 31*s + 47) + fd*(-2*C*(70*r**2 + 236*r*s - 119*r + 166*s**2 - 191*s + 59) + 160*r**2 + 292*r*s - 213*r + 132*s**2 - 192*s + 73)) + Dd*f*(-4*C*(70*r**2 + 236*r*s - 97*r + 166*s**2 - 169*s + 37) + 320*r**2 + 584*r*s - 393*r + 264*s**2 - 351*s + 113)) - 5*D1*f*(Dd*(2*f*(C*(294*r**2 + r*(716*s - 326) + 422*s**2 - 390*s + 179) - 338*r**2 + r*(298 - 516*s) - 178*s**2 + 218*s - 129) + fd*(-8*C*(207*r**2 + r*(618*s - 301) + 411*s**2 - 420*s + 103) + 1920*r**2 + 7*r*(504*s - 307) + 1608*s**2 - 1967*s + 588)) + Ddd*f*(-2*C*(138*r**2 + 4*r*(103*s - 43) + 274*s**2 - 240*s + 103) + 320*r**2 + r*(588*s - 307) + 268*s**2 - 281*s + 147)) - 5*Dd**2*f**2*(-2*C*(414*r**2 + 12*r*(103*s - 43) + 822*s**2 - 720*s + 103) + 960*r**2 + 3*r*(588*s - 307) + 804*s**2 - 843*s + 147)))/(315*d**2*k3**4) - D1**2*Pk1*Pk2*ct**6*st**2*(8*C - 8)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k3**2) + 4*D1**2*Pk1*Pk2*ct**6*(D1**2*(35*f**3*(12*fd*(4*s**2 - 2*s + 1) - 6*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) - 5*f**2*s*(66*bd1**2*s + 22*bd1*(7*fd*(3*s - 1) + s*(3*K - 3)) + 252*fd**2*(2*s - 1) - s*(33*bdd1*(K - 1) + 132*gd2 - 66*gdd2)) + 66*f*(5*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 5*fdd*g2*(2*s**2 - 2*s + 1) + s**2*(7*bd1**2*(K - 1) + 14*bd1*(g2 - gd2) - 7*bdd1*g2)) - 132*fd*g2*s*(7*bd1 + 5*fd)*(s - 1)) + 2*D1*f*(Dd*(210*f**3*(4*s**2 - 2*s + 1) - 35*f**2*(4*s - 1)*(11*bd1*s + 6*fd*(4*s - 1)) + 165*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 66*g2*(4*s - 1)*(7*bd1*s + 5*fd*(2*s - 1))) - 15*Ddd*f*(7*f**2 + 11*g2)*(4*s**2 - 2*s + 1)) - 180*Dd**2*f**2*s*(7*f**2 + 11*g2)*(2*s - 1) + 33*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) - 14*fd*(K - 1)*(s - 1)**2 + 7*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) - 7*f*(K - 1)*(4*s**2 - 2*s + 1) + 7*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-7*K + 5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-7*K + 5*f + 7)) + 11*b1*(D1**2*(5*f**2*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(12*bd1 - 6*bdd1)) + f*(-70*fd**2*s*(3*s - 2) - 30*fd*(K*(2*s**2 - 2*s + 1) + s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) + 15*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(42*K*bdd1 - 84*bd1*(K - 1) - 42*bdd1 + 84*gd2 - 42*gdd2)) + (6*s - 6)*(5*fd**2*s*(K - 1) + 14*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(35*f**3*(4*s**2 - 2*s + 1) - 5*f**2*(3*K*(4*s**2 - 2*s + 1) + 7*fd*(12*s**2 - 7*s + 1) + s**2*(24*bd1 - 12) - s*(6*bd1 - 6) - 3) + 3*f*(5*fd*(K - 1)*(8*s**2 - 6*s + 1) + 14*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(14*K*bd1 - 14*bd1 - 14*gd2)) - 42*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(35*f**2 - 15*f*(K - 1) + 42*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(35*f**2 - 15*f*(K - 1) + 42*g2)))/(385*d**2*k2**2) - 2*D1**2*Pk1*Pk2*ct**6*k2**4*(24*D1**2*b1*f*fd*r**2 + 24*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*r + 30*D1**2*b1*f*fdd*r**2 + 30*D1**2*b1*f*fdd*r*s - 15*D1**2*b1*f*fdd*r + 30*D1**2*b1*fd**2*r**2 + 30*D1**2*b1*fd**2*r*s - 15*D1**2*b1*fd**2*r + 15*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 60*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r - 20*D1**2*f**2*fd*s + 20*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r - 10*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 + 48*D1*Dd*b1*f**2*r**2 + 48*D1*Dd*b1*f**2*r*s - 36*D1*Dd*b1*f**2*r - 12*D1*Dd*b1*f**2*s + 12*D1*Dd*b1*f**2 + 240*D1*Dd*b1*f*fd*r**2 + 240*D1*Dd*b1*f*fd*r*s - 150*D1*Dd*b1*f*fd*r - 30*D1*Dd*b1*f*fd*s + 15*D1*Dd*b1*f*fd + 80*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r - 20*D1*Dd*f**3*s + 20*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 105*D1*Dd*f**2*fd*r - 35*D1*Dd*f**2*fd*s + 20*D1*Dd*f**2*fd + 60*D1*Ddd*b1*f**2*r**2 + 60*D1*Ddd*b1*f**2*r*s - 45*D1*Ddd*b1*f**2*r - 15*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 15*D1*Ddd*f**3*r - 5*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) + 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 180*Dd**2*b1*f**2*r**2 + 180*Dd**2*b1*f**2*r*s - 135*Dd**2*b1*f**2*r - 45*Dd**2*b1*f**2*s + 15*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 45*Dd**2*f**3*r - 15*Dd**2*f**3*s + 5*Dd**2*f**3)/(105*d**2*k1**2*k3**4) + 4*D1**2*Pk1*Pk2*ct**5*f*st**2*(11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(4*s**2 - 2*s + 1) - 7*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + 2*fd*s*(bd1*(11 - 33*s) + 21*fd*(1 - 2*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(11*bd1*s + 7*fd*(4*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(11*d**2*k1*k2) - 4*D1**2*Pk1*Pk2*ct**5*k1**3*k2*(432*C*D1**2*b1*f*fd*r**2 + 864*C*D1**2*b1*f*fd*r*s - 432*C*D1**2*b1*f*fd*r + 432*C*D1**2*b1*f*fd*s**2 - 432*C*D1**2*b1*f*fd*s + 216*C*D1**2*b1*f*fd - 720*C*D1**2*b1*f*fdd*r**2 - 1440*C*D1**2*b1*f*fdd*r*s + 720*C*D1**2*b1*f*fdd*r - 720*C*D1**2*b1*f*fdd*s**2 + 720*C*D1**2*b1*f*fdd*s - 360*C*D1**2*b1*f*fdd - 720*C*D1**2*b1*fd**2*r**2 - 1440*C*D1**2*b1*fd**2*r*s + 720*C*D1**2*b1*fd**2*r - 720*C*D1**2*b1*fd**2*s**2 + 720*C*D1**2*b1*fd**2*s + 600*C*D1**2*f**2*fd*r**2 + 1200*C*D1**2*f**2*fd*r*s - 800*C*D1**2*f**2*fd*r + 600*C*D1**2*f**2*fd*s**2 - 800*C*D1**2*f**2*fd*s + 400*C*D1**2*f**2*fd - 840*C*D1**2*f**2*fdd*r**2 - 1680*C*D1**2*f**2*fdd*r*s + 1120*C*D1**2*f**2*fdd*r - 840*C*D1**2*f**2*fdd*s**2 + 1120*C*D1**2*f**2*fdd*s - 560*C*D1**2*f**2*fdd - 1680*C*D1**2*f*fd**2*r**2 - 3360*C*D1**2*f*fd**2*r*s + 2240*C*D1**2*f*fd**2*r - 1680*C*D1**2*f*fd**2*s**2 + 2240*C*D1**2*f*fd**2*s - 560*C*D1**2*f*fd**2 + 864*C*D1*Dd*b1*f**2*r**2 + 1728*C*D1*Dd*b1*f**2*r*s - 864*C*D1*Dd*b1*f**2*r + 864*C*D1*Dd*b1*f**2*s**2 - 864*C*D1*Dd*b1*f**2*s + 432*C*D1*Dd*b1*f**2 - 5760*C*D1*Dd*b1*f*fd*r**2 - 11520*C*D1*Dd*b1*f*fd*r*s + 5760*C*D1*Dd*b1*f*fd*r - 5760*C*D1*Dd*b1*f*fd*s**2 + 5760*C*D1*Dd*b1*f*fd*s - 1440*C*D1*Dd*b1*f*fd + 800*C*D1*Dd*f**3*r**2 + 1600*C*D1*Dd*f**3*r*s - 800*C*D1*Dd*f**3*r + 800*C*D1*Dd*f**3*s**2 - 800*C*D1*Dd*f**3*s + 400*C*D1*Dd*f**3 - 6720*C*D1*Dd*f**2*fd*r**2 - 13440*C*D1*Dd*f**2*fd*r*s + 7840*C*D1*Dd*f**2*fd*r - 6720*C*D1*Dd*f**2*fd*s**2 + 7840*C*D1*Dd*f**2*fd*s - 2240*C*D1*Dd*f**2*fd - 1440*C*D1*Ddd*b1*f**2*r**2 - 2880*C*D1*Ddd*b1*f**2*r*s + 1440*C*D1*Ddd*b1*f**2*r - 1440*C*D1*Ddd*b1*f**2*s**2 + 1440*C*D1*Ddd*b1*f**2*s - 720*C*D1*Ddd*b1*f**2 - 1120*C*D1*Ddd*f**3*r**2 - 2240*C*D1*Ddd*f**3*r*s + 1120*C*D1*Ddd*f**3*r - 1120*C*D1*Ddd*f**3*s**2 + 1120*C*D1*Ddd*f**3*s - 560*C*D1*Ddd*f**3 - 4320*C*Dd**2*b1*f**2*r**2 - 8640*C*Dd**2*b1*f**2*r*s + 4320*C*Dd**2*b1*f**2*r - 4320*C*Dd**2*b1*f**2*s**2 + 4320*C*Dd**2*b1*f**2*s - 720*C*Dd**2*b1*f**2 - 3360*C*Dd**2*f**3*r**2 - 6720*C*Dd**2*f**3*r*s + 3360*C*Dd**2*f**3*r - 3360*C*Dd**2*f**3*s**2 + 3360*C*Dd**2*f**3*s - 560*C*Dd**2*f**3 - 882*D1**2*b1*f*fd*r**2 - 1764*D1**2*b1*f*fd*r*s + 882*D1**2*b1*f*fd*r - 882*D1**2*b1*f*fd*s**2 + 882*D1**2*b1*f*fd*s - 441*D1**2*b1*f*fd + 1260*D1**2*b1*f*fdd*r**2 + 2520*D1**2*b1*f*fdd*r*s - 1260*D1**2*b1*f*fdd*r + 1260*D1**2*b1*f*fdd*s**2 - 1260*D1**2*b1*f*fdd*s + 630*D1**2*b1*f*fdd + 1260*D1**2*b1*fd**2*r**2 + 2520*D1**2*b1*fd**2*r*s - 1260*D1**2*b1*fd**2*r + 1260*D1**2*b1*fd**2*s**2 - 1260*D1**2*b1*fd**2*s - 90*D1**2*bdd1*f**2*(4*C - 7)*(r + s - 1)**2 - 1185*D1**2*f**2*fd*r**2 - 2370*D1**2*f**2*fd*r*s + 1580*D1**2*f**2*fd*r - 1185*D1**2*f**2*fd*s**2 + 1580*D1**2*f**2*fd*s - 790*D1**2*f**2*fd + 1470*D1**2*f**2*fdd*r**2 + 2940*D1**2*f**2*fdd*r*s - 1960*D1**2*f**2*fdd*r + 1470*D1**2*f**2*fdd*s**2 - 1960*D1**2*f**2*fdd*s + 980*D1**2*f**2*fdd + 2940*D1**2*f*fd**2*r**2 + 5880*D1**2*f*fd**2*r*s - 3920*D1**2*f*fd**2*r + 2940*D1**2*f*fd**2*s**2 - 3920*D1**2*f*fd**2*s + 980*D1**2*f*fd**2 - 1764*D1*Dd*b1*f**2*r**2 - 3528*D1*Dd*b1*f**2*r*s + 1764*D1*Dd*b1*f**2*r - 1764*D1*Dd*b1*f**2*s**2 + 1764*D1*Dd*b1*f**2*s - 882*D1*Dd*b1*f**2 + 10080*D1*Dd*b1*f*fd*r**2 + 20160*D1*Dd*b1*f*fd*r*s - 10080*D1*Dd*b1*f*fd*r + 10080*D1*Dd*b1*f*fd*s**2 - 10080*D1*Dd*b1*f*fd*s + 2520*D1*Dd*b1*f*fd - 1580*D1*Dd*f**3*r**2 - 3160*D1*Dd*f**3*r*s + 1580*D1*Dd*f**3*r - 1580*D1*Dd*f**3*s**2 + 1580*D1*Dd*f**3*s - 790*D1*Dd*f**3 + 11760*D1*Dd*f**2*fd*r**2 + 23520*D1*Dd*f**2*fd*r*s - 13720*D1*Dd*f**2*fd*r + 11760*D1*Dd*f**2*fd*s**2 - 13720*D1*Dd*f**2*fd*s + 3920*D1*Dd*f**2*fd + 2520*D1*Ddd*b1*f**2*r**2 + 5040*D1*Ddd*b1*f**2*r*s - 2520*D1*Ddd*b1*f**2*r + 2520*D1*Ddd*b1*f**2*s**2 - 2520*D1*Ddd*b1*f**2*s + 1260*D1*Ddd*b1*f**2 + 1960*D1*Ddd*f**3*r**2 + 3920*D1*Ddd*f**3*r*s - 1960*D1*Ddd*f**3*r + 1960*D1*Ddd*f**3*s**2 - 1960*D1*Ddd*f**3*s + 980*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(D1*f*(24*C - 49)*(r + s - 1) - D1*fd*(80*C - 140)*(2*r + 2*s - 1) - Dd*f*(160*C - 280)*(2*r + 2*s - 1)) + 7560*Dd**2*b1*f**2*r**2 + 15120*Dd**2*b1*f**2*r*s - 7560*Dd**2*b1*f**2*r + 7560*Dd**2*b1*f**2*s**2 - 7560*Dd**2*b1*f**2*s + 1260*Dd**2*b1*f**2 + 5880*Dd**2*f**3*r**2 + 11760*Dd**2*f**3*r*s - 5880*Dd**2*f**3*r + 5880*Dd**2*f**3*s**2 - 5880*Dd**2*f**3*s + 980*Dd**2*f**3)/(315*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**5*k1**3*(9*b1*(D1**2*(f*(fd*(6*C - 22) + fdd*(25 - 10*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(25 - 10*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(6*C - 22)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(25 - 10*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(25 - 10*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(25 - 10*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(10*C - 34)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (2*C - 5)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(35 - 14*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(6*C - 22)*(r + s - 1) - fd*(10*C - 25)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(25 - 10*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*(f*(10*C - 34)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(14*C - 35)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(35 - 14*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(35 - 14*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(315*d**2*k2*k3**4) + 4*D1**2*Pk1*Pk2*ct**5*k1**3*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2**3*k3**2) - 4*D1**2*Pk1*Pk2*ct**5*k1*k2**3*st**2*(1872*C*D1**2*b1*f*fd*r**2 + 3744*C*D1**2*b1*f*fd*r*s - 1872*C*D1**2*b1*f*fd*r + 1872*C*D1**2*b1*f*fd*s**2 - 1872*C*D1**2*b1*f*fd*s + 936*C*D1**2*b1*f*fd - 1440*C*D1**2*b1*f*fdd*r**2 - 2880*C*D1**2*b1*f*fdd*r*s + 1440*C*D1**2*b1*f*fdd*r - 1440*C*D1**2*b1*f*fdd*s**2 + 1440*C*D1**2*b1*f*fdd*s - 720*C*D1**2*b1*f*fdd - 1440*C*D1**2*b1*fd**2*r**2 - 2880*C*D1**2*b1*fd**2*r*s + 1440*C*D1**2*b1*fd**2*r - 1440*C*D1**2*b1*fd**2*s**2 + 1440*C*D1**2*b1*fd**2*s + 1752*C*D1**2*f**2*fd*r**2 + 3504*C*D1**2*f**2*fd*r*s - 2336*C*D1**2*f**2*fd*r + 1752*C*D1**2*f**2*fd*s**2 - 2336*C*D1**2*f**2*fd*s + 1168*C*D1**2*f**2*fd - 1200*C*D1**2*f**2*fdd*r**2 - 2400*C*D1**2*f**2*fdd*r*s + 1600*C*D1**2*f**2*fdd*r - 1200*C*D1**2*f**2*fdd*s**2 + 1600*C*D1**2*f**2*fdd*s - 800*C*D1**2*f**2*fdd - 2400*C*D1**2*f*fd**2*r**2 - 4800*C*D1**2*f*fd**2*r*s + 3200*C*D1**2*f*fd**2*r - 2400*C*D1**2*f*fd**2*s**2 + 3200*C*D1**2*f*fd**2*s - 800*C*D1**2*f*fd**2 + 3744*C*D1*Dd*b1*f**2*r**2 + 7488*C*D1*Dd*b1*f**2*r*s - 3744*C*D1*Dd*b1*f**2*r + 3744*C*D1*Dd*b1*f**2*s**2 - 3744*C*D1*Dd*b1*f**2*s + 1872*C*D1*Dd*b1*f**2 - 11520*C*D1*Dd*b1*f*fd*r**2 - 23040*C*D1*Dd*b1*f*fd*r*s + 11520*C*D1*Dd*b1*f*fd*r - 11520*C*D1*Dd*b1*f*fd*s**2 + 11520*C*D1*Dd*b1*f*fd*s - 2880*C*D1*Dd*b1*f*fd + 2336*C*D1*Dd*f**3*r**2 + 4672*C*D1*Dd*f**3*r*s - 2336*C*D1*Dd*f**3*r + 2336*C*D1*Dd*f**3*s**2 - 2336*C*D1*Dd*f**3*s + 1168*C*D1*Dd*f**3 - 9600*C*D1*Dd*f**2*fd*r**2 - 19200*C*D1*Dd*f**2*fd*r*s + 11200*C*D1*Dd*f**2*fd*r - 9600*C*D1*Dd*f**2*fd*s**2 + 11200*C*D1*Dd*f**2*fd*s - 3200*C*D1*Dd*f**2*fd - 2880*C*D1*Ddd*b1*f**2*r**2 - 5760*C*D1*Ddd*b1*f**2*r*s + 2880*C*D1*Ddd*b1*f**2*r - 2880*C*D1*Ddd*b1*f**2*s**2 + 2880*C*D1*Ddd*b1*f**2*s - 1440*C*D1*Ddd*b1*f**2 - 1600*C*D1*Ddd*f**3*r**2 - 3200*C*D1*Ddd*f**3*r*s + 1600*C*D1*Ddd*f**3*r - 1600*C*D1*Ddd*f**3*s**2 + 1600*C*D1*Ddd*f**3*s - 800*C*D1*Ddd*f**3 - 8640*C*Dd**2*b1*f**2*r**2 - 17280*C*Dd**2*b1*f**2*r*s + 8640*C*Dd**2*b1*f**2*r - 8640*C*Dd**2*b1*f**2*s**2 + 8640*C*Dd**2*b1*f**2*s - 1440*C*Dd**2*b1*f**2 - 4800*C*Dd**2*f**3*r**2 - 9600*C*Dd**2*f**3*r*s + 4800*C*Dd**2*f**3*r - 4800*C*Dd**2*f**3*s**2 + 4800*C*Dd**2*f**3*s - 800*C*Dd**2*f**3 - 2412*D1**2*b1*f*fd*r**2 - 4824*D1**2*b1*f*fd*r*s + 2412*D1**2*b1*f*fd*r - 2412*D1**2*b1*f*fd*s**2 + 2412*D1**2*b1*f*fd*s - 1206*D1**2*b1*f*fd + 1710*D1**2*b1*f*fdd*r**2 + 3420*D1**2*b1*f*fdd*r*s - 1710*D1**2*b1*f*fdd*r + 1710*D1**2*b1*f*fdd*s**2 - 1710*D1**2*b1*f*fdd*s + 855*D1**2*b1*f*fdd + 1710*D1**2*b1*fd**2*r**2 + 3420*D1**2*b1*fd**2*r*s - 1710*D1**2*b1*fd**2*r + 1710*D1**2*b1*fd**2*s**2 - 1710*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(16*C - 19)*(r + s - 1)**2 - 2202*D1**2*f**2*fd*r**2 - 4404*D1**2*f**2*fd*r*s + 2936*D1**2*f**2*fd*r - 2202*D1**2*f**2*fd*s**2 + 2936*D1**2*f**2*fd*s - 1468*D1**2*f**2*fd + 1425*D1**2*f**2*fdd*r**2 + 2850*D1**2*f**2*fdd*r*s - 1900*D1**2*f**2*fdd*r + 1425*D1**2*f**2*fdd*s**2 - 1900*D1**2*f**2*fdd*s + 950*D1**2*f**2*fdd + 2850*D1**2*f*fd**2*r**2 + 5700*D1**2*f*fd**2*r*s - 3800*D1**2*f*fd**2*r + 2850*D1**2*f*fd**2*s**2 - 3800*D1**2*f*fd**2*s + 950*D1**2*f*fd**2 - 4824*D1*Dd*b1*f**2*r**2 - 9648*D1*Dd*b1*f**2*r*s + 4824*D1*Dd*b1*f**2*r - 4824*D1*Dd*b1*f**2*s**2 + 4824*D1*Dd*b1*f**2*s - 2412*D1*Dd*b1*f**2 + 13680*D1*Dd*b1*f*fd*r**2 + 27360*D1*Dd*b1*f*fd*r*s - 13680*D1*Dd*b1*f*fd*r + 13680*D1*Dd*b1*f*fd*s**2 - 13680*D1*Dd*b1*f*fd*s + 3420*D1*Dd*b1*f*fd - 2936*D1*Dd*f**3*r**2 - 5872*D1*Dd*f**3*r*s + 2936*D1*Dd*f**3*r - 2936*D1*Dd*f**3*s**2 + 2936*D1*Dd*f**3*s - 1468*D1*Dd*f**3 + 11400*D1*Dd*f**2*fd*r**2 + 22800*D1*Dd*f**2*fd*r*s - 13300*D1*Dd*f**2*fd*r + 11400*D1*Dd*f**2*fd*s**2 - 13300*D1*Dd*f**2*fd*s + 3800*D1*Dd*f**2*fd + 3420*D1*Ddd*b1*f**2*r**2 + 6840*D1*Ddd*b1*f**2*r*s - 3420*D1*Ddd*b1*f**2*r + 3420*D1*Ddd*b1*f**2*s**2 - 3420*D1*Ddd*b1*f**2*s + 1710*D1*Ddd*b1*f**2 + 1900*D1*Ddd*f**3*r**2 + 3800*D1*Ddd*f**3*r*s - 1900*D1*Ddd*f**3*r + 1900*D1*Ddd*f**3*s**2 - 1900*D1*Ddd*f**3*s + 950*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(52*C - 67)*(r + s - 1) - D1*fd*(80*C - 95)*(2*r + 2*s - 1) - Dd*f*(160*C - 190)*(2*r + 2*s - 1)) + 10260*Dd**2*b1*f**2*r**2 + 20520*Dd**2*b1*f**2*r*s - 10260*Dd**2*b1*f**2*r + 10260*Dd**2*b1*f**2*s**2 - 10260*Dd**2*b1*f**2*s + 1710*Dd**2*b1*f**2 + 5700*Dd**2*f**3*r**2 + 11400*Dd**2*f**3*r*s - 5700*Dd**2*f**3*r + 5700*Dd**2*f**3*s**2 - 5700*Dd**2*f**3*s + 950*Dd**2*f**3)/(315*d**2*k3**6) - 4*D1**2*Pk1*Pk2*ct**5*k1*k2**3*(84*D1*b1*bd1*(r + s - 1)*(D1*f*(14*C - 17)*(r + s - 1) - D1*fd*(24*C - 27)*(r + s) - Dd*f*(48*C - 54)*(2*r + 2*s - 1)) + 21*b1**2*(D1**2*(r + s)**2*(fd*(28*C - 34) + fdd*(27 - 24*C)) + 4*D1*Dd*(f*(14*C - 17)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(24*C - 27)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - D1*Ddd*f*(48*C - 54)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd**2*f*(48*C - 54)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) - 9*b1*(14*D1**2*bdd1*f*(8*C - 9)*(r + s - 1)**2 + D1**2*(f*(fd*(28*C + 52) - 75*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 150*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*f*(2*Dd*(f*(14*C + 26)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 75*fd*(2*r + 2*s - 1)**2) - 75*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 150*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + f*(-126*D1**2*bd1**2*(8*C - 9)*(r + s - 1)**2 + 675*D1**2*bdd1*f*(r + s - 1)**2 - 10*D1**2*(f*(fd*(56*C - 3) - fdd*(28*C + 21))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(-56*C - 42)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 18*D1*bd1*(r + s - 1)*(D1*f*(14*C + 26)*(r + s - 1) - 75*D1*fd*(2*r + 2*s - 1) - 150*Dd*f*(2*r + 2*s - 1)) - 20*D1*f*(Dd*(f*(56*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(56*C + 42)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Ddd*f*(-28*C - 21)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 5*Dd**2*f**2*(112*C + 84)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(315*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**5*k1*k2*st**2*(3*b1*(D1**2*(f*(fd*(92*C - 122) + fdd*(75 - 60*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(75 - 60*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(92*C - 122)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(75 - 60*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(75 - 60*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(75 - 60*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(164*C - 214)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 25)*(9*bdd1*s*(r + s - 1) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(125 - 100*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(92*C - 122)*(r + s - 1) - fd*(60*C - 75)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(75 - 60*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(164*C - 214)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(100*C - 125)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(125 - 100*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(125 - 100*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) + D1**2*Pk1*Pk2*ct**5*k1*k2*(-84*D1*b1*bd1*(D1*(f*(26*C - 32)*(2*s - 1)*(r + s - 1) - fd*(18*C - 21)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(42 - 36*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 84*b1**2*(D1**2*s*(r + s)*(fd*(26*C - 32) + fdd*(21 - 18*C)) + D1*(Dd*(f*(26*C - 32)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(18*C - 21)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(21 - 18*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(18*C - 21)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 9*b1*(28*D1**2*bdd1*f*(6*C - 7)*(2*s - 1)*(r + s - 1) + D1**2*(f*(fd*(4*C*(70*r**2 + 344*r*s - 218*r + 274*s**2 - 320*s + 183) - 414*r**2 - 1156*r*s + 802*r - 742*s**2 + 966*s - 595) + fdd*(-4*C*(70*r**2 + 4*r*(71*s - 43) + 214*s**2 - 244*s + 137) + 410*r**2 + 1012*r*s - 646*r + 602*s**2 - 742*s + 441)) + 2*fd**2*(r**2*(205 - 140*C) + r*(-568*C*s + 344*C + 506*s - 323) + s*(-428*C*s + 488*C + 301*s - 371))) + 2*D1*f*(Dd*(f*(4*C*(70*r**2 + 344*r*s - 121*r + 274*s**2 - 223*s + 86) - 414*r**2 - 1156*r*s + 496*r - 742*s**2 + 660*s - 289) - 2*fd*(2*r + 2*s - 1)*(8*C*(35*r + 107*s - 52) - 410*r - 602*s + 347)) + Ddd*f*(-4*C*(70*r**2 + 284*r*s - 106*r + 214*s**2 - 178*s + 71) + 410*r**2 + 1012*r*s - 458*r + 602*s**2 - 554*s + 253)) + 2*Dd**2*f**2*(-4*C*(210*r**2 + 6*r*(142*s - 53) + 642*s**2 - 534*s + 71) + 1230*r**2 + 6*r*(506*s - 229) + 1806*s**2 - 1662*s + 253)) + f*(252*D1**2*bd1**2*(6*C - 7)*(2*s - 1)*(r + s - 1) - 9*D1**2*bdd1*f*(r + s - 1)*(4*C*(35*r + 107*s - 5) - 205*r - 301*s + 65) + 5*D1**2*(f*(fd*(12*C*(69*r**2 + 318*r*s - 152*r + 249*s**2 - 272*s + 106) - 1251*r**2 - 3594*r*s + 2032*r - 2343*s**2 + 2760*s - 1198) + fdd*(-12*C*(57*r**2 + 240*r*s - 118*r + 183*s**2 - 202*s + 80) + 1017*r**2 + 2742*r*s - 1592*r + 1725*s**2 - 2064*s + 914)) + 2*fd**2*(-12*C*(57*r**2 + 240*r*s - 118*r + 183*s**2 - 202*s + 40) + 1017*r**2 + 2742*r*s - 1592*r + 1725*s**2 - 2064*s + 457)) + 9*D1*bd1*(D1*(f*(r + s - 1)*(4*C*(35*r + 137*s + 11) - 207*r - 371*s - 17) - 2*fd*(4*C*(70*r**2 + 284*r*s - 126*r + 214*s**2 - 234*s + 71) - 410*r**2 - 1012*r*s + 593*r - 602*s**2 + 737*s - 253)) - 4*Dd*f*(4*C*(70*r**2 + 284*r*s - 93*r + 214*s**2 - 201*s + 38) - 410*r**2 - 1012*r*s + 499*r - 602*s**2 + 643*s - 159)) + 10*D1*f*(Dd*(f*(12*C*(46*r**2 + 212*r*s - 76*r + 166*s**2 - 136*s + 53) - 834*r**2 - 2396*r*s + 1016*r - 1562*s**2 + 1380*s - 599) - 4*fd*(3*C*(228*r**2 + 960*r*s - 413*r + 732*s**2 - 707*s + 160) - 1017*r**2 - 2742*r*s + 1393*r - 1725*s**2 + 1806*s - 457)) + Ddd*f*(-12*C*(38*r**2 + 160*r*s - 59*r + 122*s**2 - 101*s + 40) + 678*r**2 + 1828*r*s - 796*r + 1150*s**2 - 1032*s + 457)) + 10*Dd**2*f**2*(-12*C*(114*r**2 + 480*r*s - 177*r + 366*s**2 - 303*s + 40) + 2034*r**2 + 5484*r*s - 2388*r + 3450*s**2 - 3096*s + 457)))/(315*d**2*k3**4) - D1**2*Pk1*Pk2*ct**5*k1*st**2*(32*C - 44)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2*k3**2) + 4*D1**2*Pk1*Pk2*ct**5*k1*(99*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + 11*b1*(D1**2*(10*f**2*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + f*(-140*fd**2*s*(3*s - 2) - 90*fd*(s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) - 45*fdd*(2*s**2 - 2*s + 1) + 9*s**2*(28*bd1 - 14*bdd1)) - 18*fd*s*(14*bd1 + 5*fd)*(s - 1)) + D1*f*(2*Dd*(70*f**2*(4*s**2 - 2*s + 1) - 5*f*(14*fd*(12*s**2 - 7*s + 1) + s**2*(72*bd1 - 36) - s*(18*bd1 - 18) - 9) - (36*s - 9)*(14*bd1*s + 5*fd*(2*s - 1))) - 5*Ddd*f*(14*f + 9)*(4*s**2 - 2*s + 1)) - 30*Dd**2*f**2*s*(14*f + 9)*(2*s - 1)) + f*(D1**2*(-198*bd1*s*(7*bd1*s + 5*fd*(2*s - 1)) + 35*f**2*(18*fd*(4*s**2 - 2*s + 1) - 9*fdd*(4*s**2 - 2*s + 1) + s**2*(44*bd1 - 22*bdd1)) - 5*f*s*(198*bd1**2*s + 22*bd1*(14*fd*(3*s - 1) - 9*s) + 99*bdd1*s + 378*fd**2*(2*s - 1))) + 5*D1*f*(2*Dd*(99*bd1*s*(1 - 4*s) + 63*f**2*(4*s**2 - 2*s + 1) - 7*f*(4*s - 1)*(22*bd1*s + 36*fd*s - 9*fd)) - 63*Ddd*f**2*(4*s**2 - 2*s + 1)) + 1890*Dd**2*f**3*s*(1 - 2*s)))/(1155*d**2*k2**3) + 4*D1**2*Pk1*Pk2*ct**5*k2**5*st**2*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 20*D1**2*f**2*fdd*s - 10*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 40*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 72*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 72*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 144*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 144*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 40*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 40*D1*Dd*f**3*s + 20*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 140*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 140*D1*Dd*f**2*fd*s - 40*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 20*D1*Ddd*f**3*s - 10*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 60*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 60*Dd**2*f**3*s - 10*Dd**2*f**3)/(21*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk2*ct**5*k2**5*(D1*f*(-14*D1*bd1**2*(r + s - 1)**2 + bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(2*r + 2*s - 1)) - 5*f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1))) + 7*b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-14*D1**2*bdd1*f*(r + s - 1)**2 + 6*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s - 6*D1**2*f*fd*r + 6*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s + 3*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 12*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 12*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 80*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 20*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 + 28*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 60*Dd**2*f**2*s - 10*Dd**2*f**2))/(35*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk2*ct**5*k2**3*st**2*(864*C*D1**2*b1*f*fd*r**2 + 864*C*D1**2*b1*f*fd*r*s - 432*C*D1**2*b1*f*fd*r - 180*C*D1**2*b1*f*fdd*r**2 - 180*C*D1**2*b1*f*fdd*r*s + 90*C*D1**2*b1*f*fdd*r - 180*C*D1**2*b1*fd**2*r**2 - 180*C*D1**2*b1*fd**2*r*s + 90*C*D1**2*b1*fd**2*r + 888*C*D1**2*f**2*fd*r**2 + 888*C*D1**2*f**2*fd*r*s - 888*C*D1**2*f**2*fd*r - 296*C*D1**2*f**2*fd*s + 296*C*D1**2*f**2*fd - 390*C*D1**2*f**2*fdd*r**2 - 390*C*D1**2*f**2*fdd*r*s + 390*C*D1**2*f**2*fdd*r + 130*C*D1**2*f**2*fdd*s - 130*C*D1**2*f**2*fdd - 780*C*D1**2*f*fd**2*r**2 - 780*C*D1**2*f*fd**2*r*s + 780*C*D1**2*f*fd**2*r + 260*C*D1**2*f*fd**2*s - 130*C*D1**2*f*fd**2 + 1728*C*D1*Dd*b1*f**2*r**2 + 1728*C*D1*Dd*b1*f**2*r*s - 1296*C*D1*Dd*b1*f**2*r - 432*C*D1*Dd*b1*f**2*s + 432*C*D1*Dd*b1*f**2 - 1440*C*D1*Dd*b1*f*fd*r**2 - 1440*C*D1*Dd*b1*f*fd*r*s + 900*C*D1*Dd*b1*f*fd*r + 180*C*D1*Dd*b1*f*fd*s - 90*C*D1*Dd*b1*f*fd + 1184*C*D1*Dd*f**3*r**2 + 1184*C*D1*Dd*f**3*r*s - 888*C*D1*Dd*f**3*r - 296*C*D1*Dd*f**3*s + 296*C*D1*Dd*f**3 - 3120*C*D1*Dd*f**2*fd*r**2 - 3120*C*D1*Dd*f**2*fd*r*s + 2730*C*D1*Dd*f**2*fd*r + 910*C*D1*Dd*f**2*fd*s - 520*C*D1*Dd*f**2*fd - 360*C*D1*Ddd*b1*f**2*r**2 - 360*C*D1*Ddd*b1*f**2*r*s + 270*C*D1*Ddd*b1*f**2*r + 90*C*D1*Ddd*b1*f**2*s - 90*C*D1*Ddd*b1*f**2 - 520*C*D1*Ddd*f**3*r**2 - 520*C*D1*Ddd*f**3*r*s + 390*C*D1*Ddd*f**3*r + 130*C*D1*Ddd*f**3*s - 130*C*D1*Ddd*f**3 - 1080*C*Dd**2*b1*f**2*r**2 - 1080*C*Dd**2*b1*f**2*r*s + 810*C*Dd**2*b1*f**2*r + 270*C*Dd**2*b1*f**2*s - 90*C*Dd**2*b1*f**2 - 1560*C*Dd**2*f**3*r**2 - 1560*C*Dd**2*f**3*r*s + 1170*C*Dd**2*f**3*r + 390*C*Dd**2*f**3*s - 130*C*Dd**2*f**3 - 864*D1**2*b1*f*fd*r**2 - 324*D1**2*b1*f*fd*r*s + 162*D1**2*b1*f*fd*r + 540*D1**2*b1*f*fd*s**2 - 540*D1**2*b1*f*fd*s + 270*D1**2*b1*f*fd + 180*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 270*D1**2*b1*f*fdd*s**2 + 270*D1**2*b1*f*fdd*s - 135*D1**2*b1*f*fdd + 180*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 270*D1**2*b1*fd**2*s**2 + 270*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)*(2*C*(r - 1) - 2*r + 3*s + 2) - 888*D1**2*f**2*fd*r**2 - 438*D1**2*f**2*fd*r*s + 738*D1**2*f**2*fd*r + 450*D1**2*f**2*fd*s**2 - 154*D1**2*f**2*fd*s - 146*D1**2*f**2*fd + 390*D1**2*f**2*fdd*r**2 + 165*D1**2*f**2*fdd*r*s - 315*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 95*D1**2*f**2*fdd*s + 55*D1**2*f**2*fdd + 780*D1**2*f*fd**2*r**2 + 330*D1**2*f*fd**2*r*s - 630*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 190*D1**2*f*fd**2*s + 55*D1**2*f*fd**2 - 1728*D1*Dd*b1*f**2*r**2 - 648*D1*Dd*b1*f**2*r*s + 1026*D1*Dd*b1*f**2*r + 1080*D1*Dd*b1*f**2*s**2 - 378*D1*Dd*b1*f**2*s - 162*D1*Dd*b1*f**2 + 1440*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s - 90*D1*Dd*b1*f*fd*r - 2160*D1*Dd*b1*f*fd*s**2 + 1710*D1*Dd*b1*f*fd*s - 315*D1*Dd*b1*f*fd - 1184*D1*Dd*f**3*r**2 - 584*D1*Dd*f**3*r*s + 738*D1*Dd*f**3*r + 600*D1*Dd*f**3*s**2 - 154*D1*Dd*f**3*s - 146*D1*Dd*f**3 + 3120*D1*Dd*f**2*fd*r**2 + 1320*D1*Dd*f**2*fd*r*s - 2205*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 665*D1*Dd*f**2*fd*s + 220*D1*Dd*f**2*fd + 360*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s - 135*D1*Ddd*b1*f**2*r - 540*D1*Ddd*b1*f**2*s**2 + 315*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 + 520*D1*Ddd*f**3*r**2 + 220*D1*Ddd*f**3*r*s - 315*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 95*D1*Ddd*f**3*s + 55*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(6*f*(r + s - 1)*(8*C*(r - 1) - 8*r + 5*s + 8) - 5*fd*(2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 8*r**2 + 4*r*s + 7*r + 12*s**2 - 8*s + 1)) - 5*Dd*f*(2*C*(8*r**2 + 8*r*s - 11*r - 5*s + 3) - 16*r**2 + 8*r*s + 19*r + 24*s**2 - 11*s - 3)) + 1080*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s - 405*Dd**2*b1*f**2*r - 1620*Dd**2*b1*f**2*s**2 + 945*Dd**2*b1*f**2*s - 45*Dd**2*b1*f**2 + 1560*Dd**2*f**3*r**2 + 660*Dd**2*f**3*r*s - 945*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 285*Dd**2*f**3*s + 55*Dd**2*f**3)/(315*d**2*k1*k3**4) + D1**2*Pk1*Pk2*ct**5*k2**3*(840*D1*b1**2*(C - 1)*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 3*b1*(280*D1**2*bd1*f*(C - 1)*(2*r - 1)*(r + s - 1) + 3*D1**2*(f*(fd*(8*C*(8*r**2 + 8*r*s - 15*r - 11*s + 11) - 126*r**2 + r*(234 - 292*s) - 166*s**2 + 254*s - 171) + fdd*(-16*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 42*r**2 + 2*r*(94*s - 55) + 146*s**2 - 162*s + 89)) - 2*fd**2*(r**2*(16*C - 21) + r*(16*C*(s - 1) - 94*s + 55) + s*(-8*C - 73*s + 81))) + 6*D1*f*(Dd*(f*(16*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 126*r**2 - 292*r*s + 136*r - 166*s**2 + 156*s - 73) - 4*fd*(2*r + 2*s - 1)*(2*C*(8*r - 3) - 21*r - 73*s + 34)) + Ddd*f*(-8*C*(4*r**2 + 4*r*s - 3*r - s + 1) + 42*r**2 + 188*r*s - 68*r + 146*s**2 - 120*s + 47)) - 6*Dd**2*f**2*(8*C*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1) - 126*r**2 + r*(204 - 564*s) - 438*s**2 + 360*s - 47)) + f*(-9*D1**2*bdd1*f*(r + s - 1)*(r*(16*C - 21) - 73*s + 5) - 5*D1**2*(f*(fd*(104*C*(3*r**2 + 3*r*(s - 1) - s + 1) + 27*r**2 + 354*r*s - 136*r + 327*s**2 - 336*s + 118) - fdd*(16*C*(3*r**2 + 3*r*(s - 1) - s + 1) + 81*r**2 + 366*r*s - 176*r + 285*s**2 - 312*s + 122)) - 2*fd**2*(8*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 81*r**2 + 366*r*s - 176*r + 285*s**2 - 312*s + 61)) + 9*D1*bd1*(D1*(f*(r + s - 1)*(8*C*(4*r + 7) - 63*r - 83*s - 25) + 2*fd*(-8*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 42*r**2 + 188*r*s - 81*r + 146*s**2 - 159*s + 47)) - 8*Dd*f*(2*C*(8*r**2 + 8*r*s - 7*r - s + 1) - 21*r**2 - 94*r*s + 30*r - 73*s**2 + 69*s - 13)) - 10*D1*f*(Dd*(f*(52*C*(4*r**2 + 4*r*s - 3*r - s + 1) + 18*r**2 + 236*r*s - 68*r + 218*s**2 - 168*s + 59) - 4*fd*(2*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + 81*r**2 + 366*r*s - 154*r + 285*s**2 - 273*s + 61)) - Ddd*f*(8*C*(4*r**2 + 4*r*s - 3*r - s + 1) + 54*r**2 + 244*r*s - 88*r + 190*s**2 - 156*s + 61)) + 10*Dd**2*f**2*(8*C*(12*r**2 + 12*r*s - 9*r - 3*s + 1) + 162*r**2 + 732*r*s - 264*r + 570*s**2 - 468*s + 61)))/(315*d**2*k1*k3**4) - D1**2*Pk1*Pk2*ct**4*k1**4*(8*C - 24)*(54*D1**2*b1*f*fd*r**2 + 108*D1**2*b1*f*fd*r*s - 54*D1**2*b1*f*fd*r + 54*D1**2*b1*f*fd*s**2 - 54*D1**2*b1*f*fd*s + 27*D1**2*b1*f*fd - 90*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd - 90*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)**2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 216*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 108*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 720*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 720*D1*Dd*b1*f*fd*s - 180*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 100*D1*Dd*f**3*s + 50*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 980*D1*Dd*f**2*fd*s - 280*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 180*D1*Ddd*b1*f**2*s - 90*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 140*D1*Ddd*f**3*s - 70*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(2*r + 2*s - 1)) - 540*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 540*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 420*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct**4*k1**4*(9*b1*(D1**2*(f*(3*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(3*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 5*fd*(8*s - 3)*(2*r + 2*s - 1)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(-5*D1**2*(f*(9*bdd1*s*(r + s - 1) - 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(3*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) - 5*D1*f*(Dd*(-5*f*(4*r*s - r + 4*s**2 - 3*s + 1) + 7*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) + 7*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 35*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(315*d**2*k2**2*k3**4) - 16*D1**2*Pk1*Pk2*ct**4*k1**2*k2**2*st**2*(270*C*D1**2*b1*f*fd*r**2 + 540*C*D1**2*b1*f*fd*r*s - 270*C*D1**2*b1*f*fd*r + 270*C*D1**2*b1*f*fd*s**2 - 270*C*D1**2*b1*f*fd*s + 135*C*D1**2*b1*f*fd - 324*C*D1**2*b1*f*fdd*r**2 - 648*C*D1**2*b1*f*fdd*r*s + 324*C*D1**2*b1*f*fdd*r - 324*C*D1**2*b1*f*fdd*s**2 + 324*C*D1**2*b1*f*fdd*s - 162*C*D1**2*b1*f*fdd - 324*C*D1**2*b1*fd**2*r**2 - 648*C*D1**2*b1*fd**2*r*s + 324*C*D1**2*b1*fd**2*r - 324*C*D1**2*b1*fd**2*s**2 + 324*C*D1**2*b1*fd**2*s + 297*C*D1**2*f**2*fd*r**2 + 594*C*D1**2*f**2*fd*r*s - 396*C*D1**2*f**2*fd*r + 297*C*D1**2*f**2*fd*s**2 - 396*C*D1**2*f**2*fd*s + 198*C*D1**2*f**2*fd - 270*C*D1**2*f**2*fdd*r**2 - 540*C*D1**2*f**2*fdd*r*s + 360*C*D1**2*f**2*fdd*r - 270*C*D1**2*f**2*fdd*s**2 + 360*C*D1**2*f**2*fdd*s - 180*C*D1**2*f**2*fdd - 540*C*D1**2*f*fd**2*r**2 - 1080*C*D1**2*f*fd**2*r*s + 720*C*D1**2*f*fd**2*r - 540*C*D1**2*f*fd**2*s**2 + 720*C*D1**2*f*fd**2*s - 180*C*D1**2*f*fd**2 + 540*C*D1*Dd*b1*f**2*r**2 + 1080*C*D1*Dd*b1*f**2*r*s - 540*C*D1*Dd*b1*f**2*r + 540*C*D1*Dd*b1*f**2*s**2 - 540*C*D1*Dd*b1*f**2*s + 270*C*D1*Dd*b1*f**2 - 2592*C*D1*Dd*b1*f*fd*r**2 - 5184*C*D1*Dd*b1*f*fd*r*s + 2592*C*D1*Dd*b1*f*fd*r - 2592*C*D1*Dd*b1*f*fd*s**2 + 2592*C*D1*Dd*b1*f*fd*s - 648*C*D1*Dd*b1*f*fd + 396*C*D1*Dd*f**3*r**2 + 792*C*D1*Dd*f**3*r*s - 396*C*D1*Dd*f**3*r + 396*C*D1*Dd*f**3*s**2 - 396*C*D1*Dd*f**3*s + 198*C*D1*Dd*f**3 - 2160*C*D1*Dd*f**2*fd*r**2 - 4320*C*D1*Dd*f**2*fd*r*s + 2520*C*D1*Dd*f**2*fd*r - 2160*C*D1*Dd*f**2*fd*s**2 + 2520*C*D1*Dd*f**2*fd*s - 720*C*D1*Dd*f**2*fd - 648*C*D1*Ddd*b1*f**2*r**2 - 1296*C*D1*Ddd*b1*f**2*r*s + 648*C*D1*Ddd*b1*f**2*r - 648*C*D1*Ddd*b1*f**2*s**2 + 648*C*D1*Ddd*b1*f**2*s - 324*C*D1*Ddd*b1*f**2 - 360*C*D1*Ddd*f**3*r**2 - 720*C*D1*Ddd*f**3*r*s + 360*C*D1*Ddd*f**3*r - 360*C*D1*Ddd*f**3*s**2 + 360*C*D1*Ddd*f**3*s - 180*C*D1*Ddd*f**3 - 1944*C*Dd**2*b1*f**2*r**2 - 3888*C*Dd**2*b1*f**2*r*s + 1944*C*Dd**2*b1*f**2*r - 1944*C*Dd**2*b1*f**2*s**2 + 1944*C*Dd**2*b1*f**2*s - 324*C*Dd**2*b1*f**2 - 1080*C*Dd**2*f**3*r**2 - 2160*C*Dd**2*f**3*r*s + 1080*C*Dd**2*f**3*r - 1080*C*Dd**2*f**3*s**2 + 1080*C*Dd**2*f**3*s - 180*C*Dd**2*f**3 - 504*D1**2*b1*f*fd*r**2 - 1008*D1**2*b1*f*fd*r*s + 504*D1**2*b1*f*fd*r - 504*D1**2*b1*f*fd*s**2 + 504*D1**2*b1*f*fd*s - 252*D1**2*b1*f*fd + 504*D1**2*b1*f*fdd*r**2 + 1008*D1**2*b1*f*fdd*r*s - 504*D1**2*b1*f*fdd*r + 504*D1**2*b1*f*fdd*s**2 - 504*D1**2*b1*f*fdd*s + 252*D1**2*b1*f*fdd + 504*D1**2*b1*fd**2*r**2 + 1008*D1**2*b1*fd**2*r*s - 504*D1**2*b1*fd**2*r + 504*D1**2*b1*fd**2*s**2 - 504*D1**2*b1*fd**2*s - 18*D1**2*bdd1*f**2*(9*C - 14)*(r + s - 1)**2 - 516*D1**2*f**2*fd*r**2 - 1032*D1**2*f**2*fd*r*s + 688*D1**2*f**2*fd*r - 516*D1**2*f**2*fd*s**2 + 688*D1**2*f**2*fd*s - 344*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 1008*D1*Dd*b1*f**2*r**2 - 2016*D1*Dd*b1*f**2*r*s + 1008*D1*Dd*b1*f**2*r - 1008*D1*Dd*b1*f**2*s**2 + 1008*D1*Dd*b1*f**2*s - 504*D1*Dd*b1*f**2 + 4032*D1*Dd*b1*f*fd*r**2 + 8064*D1*Dd*b1*f*fd*r*s - 4032*D1*Dd*b1*f*fd*r + 4032*D1*Dd*b1*f*fd*s**2 - 4032*D1*Dd*b1*f*fd*s + 1008*D1*Dd*b1*f*fd - 688*D1*Dd*f**3*r**2 - 1376*D1*Dd*f**3*r*s + 688*D1*Dd*f**3*r - 688*D1*Dd*f**3*s**2 + 688*D1*Dd*f**3*s - 344*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 3920*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 3920*D1*Dd*f**2*fd*s + 1120*D1*Dd*f**2*fd + 1008*D1*Ddd*b1*f**2*r**2 + 2016*D1*Ddd*b1*f**2*r*s - 1008*D1*Ddd*b1*f**2*r + 1008*D1*Ddd*b1*f**2*s**2 - 1008*D1*Ddd*b1*f**2*s + 504*D1*Ddd*b1*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 560*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 560*D1*Ddd*f**3*s + 280*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(D1*f*(15*C - 28)*(r + s - 1) - D1*fd*(36*C - 56)*(2*r + 2*s - 1) - Dd*f*(72*C - 112)*(2*r + 2*s - 1)) + 3024*Dd**2*b1*f**2*r**2 + 6048*Dd**2*b1*f**2*r*s - 3024*Dd**2*b1*f**2*r + 3024*Dd**2*b1*f**2*s**2 - 3024*Dd**2*b1*f**2*s + 504*Dd**2*b1*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 1680*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 1680*Dd**2*f**3*s + 280*Dd**2*f**3)/(315*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**4*k1**2*k2**2*(42*D1*b1*bd1*(r + s - 1)*(D1*f*(11*C - 18)*(r + s - 1) - D1*fd*(36*C - 48)*(r + s) - Dd*f*(72*C - 96)*(2*r + 2*s - 1)) + 21*b1**2*(D1**2*(r + s)**2*(fd*(11*C - 18) + fdd*(24 - 18*C)) + 2*D1*(Dd*(f*(11*C - 18)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(36*C - 48)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(24 - 18*C)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(36*C - 48)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) - 9*b1*(28*D1**2*bdd1*f*(3*C - 4)*(r + s - 1)**2 + D1**2*(f*(fd*(7*C + 30) - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 100*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*f*(Dd*(f*(7*C + 30)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 100*fd*(2*r + 2*s - 1)**2) - 50*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 100*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + f*(-252*D1**2*bd1**2*(3*C - 4)*(r + s - 1)**2 + 450*D1**2*bdd1*f*(r + s - 1)**2 + 10*D1**2*(-f*(-21*C*fdd + fd*(24*C - 4) - 7*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(42*C + 14)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 9*D1*bd1*(r + s - 1)*(D1*f*(7*C + 30)*(r + s - 1) - 100*D1*fd*(2*r + 2*s - 1) - 200*Dd*f*(2*r + 2*s - 1)) - 20*D1*f*(2*Dd*(f*(12*C - 2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(21*C + 7)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Ddd*f*(-21*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 10*Dd**2*f**2*(42*C + 14)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(315*d**2*k3**6) - 16*D1**2*Pk1*Pk2*ct**4*k1**2*st**2*(3*b1*(D1**2*(f*(fd*(22*C - 45) + fdd*(33 - 18*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(33 - 18*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(22*C - 45)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(33 - 18*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(33 - 18*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(33 - 18*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(42*C - 83)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (6*C - 11)*(9*bdd1*s*(r + s - 1) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(55 - 30*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(22*C - 45)*(r + s - 1) - fd*(18*C - 33)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(33 - 18*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(42*C - 83)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(30*C - 55)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(55 - 30*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(55 - 30*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) - 2*D1**2*Pk1*Pk2*ct**4*k1**2*(42*D1*b1*bd1*(D1*(f*(16*C - 29)*(2*s - 1)*(r + s - 1) - fd*(18*C - 27)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(54 - 36*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 42*b1**2*(D1**2*s*(r + s)*(fd*(16*C - 29) + fdd*(27 - 18*C)) + D1*(Dd*(f*(16*C - 29)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(18*C - 27)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(27 - 18*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(18*C - 27)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) - 9*b1*(42*D1**2*bdd1*f*(2*C - 3)*(2*s - 1)*(r + s - 1) + D1**2*(f*(fd*(C*(42*r**2 + 436*r*s - 282*r + 394*s**2 - 458*s + 261) - 116*r**2 - 534*r*s + 377*r - 418*s**2 + 528*s - 319) + fdd*(-C*(70*r**2 + 428*r*s - 274*r + 358*s**2 - 418*s + 239) + 170*r**2 + 512*r*s - 346*r + 342*s**2 - 432*s + 261)) + 2*fd**2*(r**2*(85 - 35*C) + r*(-214*C*s + 137*C + 256*s - 173) + s*(-179*C*s + 209*C + 171*s - 216))) + D1*f*(Dd*(f*(C*(84*r**2 + 872*r*s - 260*r + 788*s**2 - 612*s + 218) - 232*r**2 - 1068*r*s + 383*r - 836*s**2 + 685*s - 267) - 2*fd*(2*r + 2*s - 1)*(2*C*(70*r + 358*s - 173) - 340*r - 684*s + 389)) + 2*Ddd*f*(-C*(70*r**2 + 428*r*s - 142*r + 358*s**2 - 286*s + 107) + 170*r**2 + 512*r*s - 213*r + 342*s**2 - 299*s + 128)) - 2*Dd**2*f**2*(C*(210*r**2 + 6*r*(214*s - 71) + 1074*s**2 - 858*s + 107) - 510*r**2 - 1536*r*s + 639*r - 1026*s**2 + 897*s - 128)) - f*(378*D1**2*bd1**2*(2*C - 3)*(2*s - 1)*(r + s - 1) - 9*D1**2*bdd1*f*(r + s - 1)*(C*(35*r + 179*s + 25) - 85*r - 171*s - 5) + 5*D1**2*(f*(fd*(C*(129*r**2 + 6*r*(203*s - 82) + 1089*s**2 - 1132*s + 406) - 354*r**2 - 1629*r*s + 779*r - 1275*s**2 + 1393*s - 543) + fdd*(-C*(159*r**2 + 6*r*(187*s - 80) + 963*s**2 - 1016*s + 374) + 393*r**2 + 1422*r*s - 736*r + 1029*s**2 - 1160*s + 474)) + 2*fd**2*(-C*(159*r**2 + 6*r*(187*s - 80) + 963*s**2 - 1016*s + 187) + 393*r**2 + 1422*r*s - 736*r + 1029*s**2 - 1160*s + 237)) + 9*D1*bd1*(D1*(f*(r + s - 1)*(C*(21*r + 197*s + 43) - 58*r - 209*s - 52) + 2*fd*(-C*(70*r**2 + 428*r*s - 147*r + 358*s**2 - 363*s + 107) + 170*r**2 + 512*r*s - 253*r + 342*s**2 - 382*s + 128)) - 2*Dd*f*(2*C*(70*r**2 + 428*r*s - 81*r + 358*s**2 - 297*s + 41) - 340*r**2 - 1024*r*s + 373*r - 684*s**2 + 631*s - 123)) + 5*D1*f*(Dd*(f*(2*C*(86*r**2 + 812*r*s - 246*r + 726*s**2 - 566*s + 203) - 472*r**2 - 2172*r*s + 779*r - 1700*s**2 + 1393*s - 543) - 8*fd*(C*(159*r**2 + 6*r*(187*s - 70) + 963*s**2 - 889*s + 187) - 393*r**2 - 1422*r*s + 644*r - 1029*s**2 + 1015*s - 237)) - 2*Ddd*f*(C*(106*r**2 + 748*r*s - 240*r + 642*s**2 - 508*s + 187) - 262*r**2 - 948*r*s + 368*r - 686*s**2 + 580*s - 237)) + 10*Dd**2*f**2*(-C*(318*r**2 + 2244*r*s - 720*r + 1926*s**2 - 1524*s + 187) + 786*r**2 + 2844*r*s - 1104*r + 2058*s**2 - 1740*s + 237)))/(315*d**2*k3**4) - D1**2*Pk1*Pk2*ct**4*k1**2*st**2*(48*C - 128)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(105*d**2*k2**2*k3**2) - 4*D1**2*Pk1*Pk2*ct**4*k1**2*(126*b1**2*(C - 2)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 9*b1*(-150*C*D1**2*f*fd*s**2 + 190*C*D1**2*f*fd*s - 95*C*D1**2*f*fd + 110*C*D1**2*f*fdd*s**2 - 130*C*D1**2*f*fdd*s + 65*C*D1**2*f*fdd + 110*C*D1**2*fd**2*s**2 - 130*C*D1**2*fd**2*s - 300*C*D1*Dd*f**2*s**2 + 150*C*D1*Dd*f**2*s - 75*C*D1*Dd*f**2 + 880*C*D1*Dd*f*fd*s**2 - 740*C*D1*Dd*f*fd*s + 130*C*D1*Dd*f*fd + 220*C*D1*Ddd*f**2*s**2 - 110*C*D1*Ddd*f**2*s + 55*C*D1*Ddd*f**2 + 660*C*Dd**2*f**2*s**2 - 330*C*Dd**2*f**2*s - 14*D1**2*bdd1*f*(C - 2)*(2*s**2 - 2*s + 1) + 48*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 236*D1**2*f*fd*s**2 - 316*D1**2*f*fd*s + 158*D1**2*f*fd - 38*D1**2*f*fdd*r*s + 19*D1**2*f*fdd*r - 188*D1**2*f*fdd*s**2 + 228*D1**2*f*fdd*s - 114*D1**2*f*fdd - 38*D1**2*fd**2*r*s + 19*D1**2*fd**2*r - 188*D1**2*fd**2*s**2 + 228*D1**2*fd**2*s + 96*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 472*D1*Dd*f**2*s**2 - 260*D1*Dd*f**2*s + 118*D1*Dd*f**2 - 304*D1*Dd*f*fd*r*s + 114*D1*Dd*f*fd*r - 1504*D1*Dd*f*fd*s**2 + 1326*D1*Dd*f*fd*s - 247*D1*Dd*f*fd - 76*D1*Ddd*f**2*r*s + 19*D1*Ddd*f**2*r - 376*D1*Ddd*f**2*s**2 + 207*D1*Ddd*f**2*s - 94*D1*Ddd*f**2 + 28*D1*bd1*(C - 2)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 228*Dd**2*f**2*r*s + 57*Dd**2*f**2*r - 1128*Dd**2*f**2*s**2 + 621*Dd**2*f**2*s - 19*Dd**2*f**2) - f*(252*D1**2*bd1**2*s*(C - 2)*(s - 1) + 9*D1**2*bdd1*f*(-5*C*(11*s**2 + 4*s - 2) + 94*s**2 + s*(19*r + 21) - 20) + 5*D1**2*(f*(fd*(129*C*(3*s**2 - 2*s + 1) - 120*r*s + 40*r - 630*s**2 + 460*s - 210) + fdd*(-87*C*(3*s**2 - 2*s + 1) + 87*r*s - 29*r + 450*s**2 - 329*s + 150)) + fd**2*(58*r*(3*s - 1) + s**2*(900 - 522*C) + s*(348*C - 658) + 29)) + 9*D1*bd1*(D1*(f*(5*C*(15*s**2 + 8*s - 4) - 118*s**2 - s*(24*r + 56) + 40) + fd*(19*r*(4*s - 1) - s**2*(220*C - 376) + s*(90*C - 186) + 19)) + Dd*f*(C*(-440*s**2 + 30*s + 20) + 19*r*(8*s - 1) + 752*s**2 - 123*s - 21)) + 5*D1*f*(Dd*(f*(129*C*(4*s**2 - 2*s + 1) - 40*r*(4*s - 1) - 840*s**2 + 460*s - 210) + fd*(-174*C*(12*s**2 - 7*s + 1) + 29*r*(24*s - 7) + 3600*s**2 - 2303*s + 358)) + Ddd*f*(-87*C*(4*s**2 - 2*s + 1) + 29*r*(4*s - 1) + 600*s**2 - 329*s + 150)) + 5*Dd**2*f**2*(87*r*(4*s - 1) - s**2*(1044*C - 1800) + s*(522*C - 987) + 29)))/(315*d**2*k2**2*k3**2) - D1**2*Pk1*Pk2*ct**4*k2**4*st**4*(8*C - 8)*(12*D1**2*b1*f*fd*r**2 + 24*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*r + 12*D1**2*b1*f*fd*s**2 - 12*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fd - 6*D1**2*b1*f*fdd*r**2 - 12*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*r - 6*D1**2*b1*f*fdd*s**2 + 6*D1**2*b1*f*fdd*s - 3*D1**2*b1*f*fdd - 6*D1**2*b1*fd**2*r**2 - 12*D1**2*b1*fd**2*r*s + 6*D1**2*b1*fd**2*r - 6*D1**2*b1*fd**2*s**2 + 6*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 24*D1*Dd*b1*f**2*r**2 + 48*D1*Dd*b1*f**2*r*s - 24*D1*Dd*b1*f**2*r + 24*D1*Dd*b1*f**2*s**2 - 24*D1*Dd*b1*f**2*s + 12*D1*Dd*b1*f**2 - 48*D1*Dd*b1*f*fd*r**2 - 96*D1*Dd*b1*f*fd*r*s + 48*D1*Dd*b1*f*fd*r - 48*D1*Dd*b1*f*fd*s**2 + 48*D1*Dd*b1*f*fd*s - 12*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 28*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s - 8*D1*Dd*f**2*fd - 12*D1*Ddd*b1*f**2*r**2 - 24*D1*Ddd*b1*f**2*r*s + 12*D1*Ddd*b1*f**2*r - 12*D1*Ddd*b1*f**2*s**2 + 12*D1*Ddd*b1*f**2*s - 6*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 6*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 36*Dd**2*b1*f**2*r**2 - 72*Dd**2*b1*f**2*r*s + 36*Dd**2*b1*f**2*r - 36*Dd**2*b1*f**2*s**2 + 36*Dd**2*b1*f**2*s - 6*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 12*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s - 2*Dd**2*f**3)/(7*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**4*k2**4*st**2*(126*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 9*b1*(-64*C*D1**2*f*fd*r**2 - 128*C*D1**2*f*fd*r*s + 64*C*D1**2*f*fd*r - 64*C*D1**2*f*fd*s**2 + 64*C*D1**2*f*fd*s - 32*C*D1**2*f*fd + 18*C*D1**2*f*fdd*r**2 + 36*C*D1**2*f*fdd*r*s - 18*C*D1**2*f*fdd*r + 18*C*D1**2*f*fdd*s**2 - 18*C*D1**2*f*fdd*s + 9*C*D1**2*f*fdd + 18*C*D1**2*fd**2*r**2 + 36*C*D1**2*fd**2*r*s - 18*C*D1**2*fd**2*r + 18*C*D1**2*fd**2*s**2 - 18*C*D1**2*fd**2*s - 128*C*D1*Dd*f**2*r**2 - 256*C*D1*Dd*f**2*r*s + 128*C*D1*Dd*f**2*r - 128*C*D1*Dd*f**2*s**2 + 128*C*D1*Dd*f**2*s - 64*C*D1*Dd*f**2 + 144*C*D1*Dd*f*fd*r**2 + 288*C*D1*Dd*f*fd*r*s - 144*C*D1*Dd*f*fd*r + 144*C*D1*Dd*f*fd*s**2 - 144*C*D1*Dd*f*fd*s + 36*C*D1*Dd*f*fd + 36*C*D1*Ddd*f**2*r**2 + 72*C*D1*Ddd*f**2*r*s - 36*C*D1*Ddd*f**2*r + 36*C*D1*Ddd*f**2*s**2 - 36*C*D1*Ddd*f**2*s + 18*C*D1*Ddd*f**2 + 108*C*Dd**2*f**2*r**2 + 216*C*Dd**2*f**2*r*s - 108*C*Dd**2*f**2*r + 108*C*Dd**2*f**2*s**2 - 108*C*Dd**2*f**2*s + 18*C*Dd**2*f**2 - 28*D1**2*bdd1*f*(C - 1)*(r + s - 1)**2 - 48*D1**2*f*fd*r**2 - 96*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 48*D1**2*f*fd*s - 24*D1**2*f*fd + 52*D1**2*f*fdd*r**2 + 104*D1**2*f*fdd*r*s - 52*D1**2*f*fdd*r + 52*D1**2*f*fdd*s**2 - 52*D1**2*f*fdd*s + 26*D1**2*f*fdd + 52*D1**2*fd**2*r**2 + 104*D1**2*fd**2*r*s - 52*D1**2*fd**2*r + 52*D1**2*fd**2*s**2 - 52*D1**2*fd**2*s - 96*D1*Dd*f**2*r**2 - 192*D1*Dd*f**2*r*s + 96*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 96*D1*Dd*f**2*s - 48*D1*Dd*f**2 + 416*D1*Dd*f*fd*r**2 + 832*D1*Dd*f*fd*r*s - 416*D1*Dd*f*fd*r + 416*D1*Dd*f*fd*s**2 - 416*D1*Dd*f*fd*s + 104*D1*Dd*f*fd + 104*D1*Ddd*f**2*r**2 + 208*D1*Ddd*f**2*r*s - 104*D1*Ddd*f**2*r + 104*D1*Ddd*f**2*s**2 - 104*D1*Ddd*f**2*s + 52*D1*Ddd*f**2 + 56*D1*bd1*(C - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) + 312*Dd**2*f**2*r**2 + 624*Dd**2*f**2*r*s - 312*Dd**2*f**2*r + 312*Dd**2*f**2*s**2 - 312*Dd**2*f**2*s + 52*Dd**2*f**2) + f*(-612*C*D1**2*f*fd*r**2 - 1224*C*D1**2*f*fd*r*s + 816*C*D1**2*f*fd*r - 612*C*D1**2*f*fd*s**2 + 816*C*D1**2*f*fd*s - 408*C*D1**2*f*fd + 225*C*D1**2*f*fdd*r**2 + 450*C*D1**2*f*fdd*r*s - 300*C*D1**2*f*fdd*r + 225*C*D1**2*f*fdd*s**2 - 300*C*D1**2*f*fdd*s + 150*C*D1**2*f*fdd + 450*C*D1**2*fd**2*r**2 + 900*C*D1**2*fd**2*r*s - 600*C*D1**2*fd**2*r + 450*C*D1**2*fd**2*s**2 - 600*C*D1**2*fd**2*s + 150*C*D1**2*fd**2 - 816*C*D1*Dd*f**2*r**2 - 1632*C*D1*Dd*f**2*r*s + 816*C*D1*Dd*f**2*r - 816*C*D1*Dd*f**2*s**2 + 816*C*D1*Dd*f**2*s - 408*C*D1*Dd*f**2 + 1800*C*D1*Dd*f*fd*r**2 + 3600*C*D1*Dd*f*fd*r*s - 2100*C*D1*Dd*f*fd*r + 1800*C*D1*Dd*f*fd*s**2 - 2100*C*D1*Dd*f*fd*s + 600*C*D1*Dd*f*fd + 300*C*D1*Ddd*f**2*r**2 + 600*C*D1*Ddd*f**2*r*s - 300*C*D1*Ddd*f**2*r + 300*C*D1*Ddd*f**2*s**2 - 300*C*D1*Ddd*f**2*s + 150*C*D1*Ddd*f**2 + 900*C*Dd**2*f**2*r**2 + 1800*C*Dd**2*f**2*r*s - 900*C*Dd**2*f**2*r + 900*C*Dd**2*f**2*s**2 - 900*C*Dd**2*f**2*s + 150*C*Dd**2*f**2 - 252*D1**2*bd1**2*(C - 1)*(r + s - 1)**2 + 9*D1**2*bdd1*f*(9*C + 26)*(r + s - 1)**2 - 276*D1**2*f*fd*r**2 - 552*D1**2*f*fd*r*s + 368*D1**2*f*fd*r - 276*D1**2*f*fd*s**2 + 368*D1**2*f*fd*s - 184*D1**2*f*fd + 300*D1**2*f*fdd*r**2 + 600*D1**2*f*fdd*r*s - 400*D1**2*f*fdd*r + 300*D1**2*f*fdd*s**2 - 400*D1**2*f*fdd*s + 200*D1**2*f*fdd + 600*D1**2*fd**2*r**2 + 1200*D1**2*fd**2*r*s - 800*D1**2*fd**2*r + 600*D1**2*fd**2*s**2 - 800*D1**2*fd**2*s + 200*D1**2*fd**2 - 368*D1*Dd*f**2*r**2 - 736*D1*Dd*f**2*r*s + 368*D1*Dd*f**2*r - 368*D1*Dd*f**2*s**2 + 368*D1*Dd*f**2*s - 184*D1*Dd*f**2 + 2400*D1*Dd*f*fd*r**2 + 4800*D1*Dd*f*fd*r*s - 2800*D1*Dd*f*fd*r + 2400*D1*Dd*f*fd*s**2 - 2800*D1*Dd*f*fd*s + 800*D1*Dd*f*fd + 400*D1*Ddd*f**2*r**2 + 800*D1*Ddd*f**2*r*s - 400*D1*Ddd*f**2*r + 400*D1*Ddd*f**2*s**2 - 400*D1*Ddd*f**2*s + 200*D1*Ddd*f**2 - 18*D1*bd1*(r + s - 1)*(D1*f*(16*C + 12)*(r + s - 1) - D1*fd*(9*C + 26)*(2*r + 2*s - 1) - Dd*f*(18*C + 52)*(2*r + 2*s - 1)) + 1200*Dd**2*f**2*r**2 + 2400*Dd**2*f**2*r*s - 1200*Dd**2*f**2*r + 1200*Dd**2*f**2*s**2 - 1200*Dd**2*f**2*s + 200*Dd**2*f**2))/(315*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct**4*k2**4*(-3*D1*f*(14*D1*bd1**2*(C + 2)*(r + s - 1)**2 - bd1*(r + s - 1)*(D1*f*(10*C - 1)*(r + s - 1) - D1*fd*(10*C + 20)*(2*r + 2*s - 1) - Dd*f*(20*C + 40)*(2*r + 2*s - 1)) + 5*f*(D1*bdd1*(C + 2)*(r + s - 1)**2 + (C + 1)*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))) + 7*b1**2*(D1**2*(r + s)**2*(fd*(11*C + 2) - fdd*(3*C + 6)) + 2*D1*(Dd*(f*(11*C + 2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(6*C + 12)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(-3*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(6*C + 12)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-42*D1**2*bdd1*f*(C + 2)*(r + s - 1)**2 - 3*D1**2*(-f*(fd*(10*C - 1) - fdd*(5*C + 10))*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd**2*(10*C + 20)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*D1*bd1*(r + s - 1)*(D1*f*(11*C + 2)*(r + s - 1) - D1*fd*(6*C + 12)*(r + s) - Dd*f*(12*C + 24)*(2*r + 2*s - 1)) - 6*D1*f*(Dd*(-f*(10*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(10*C + 20)*(2*r + 2*s - 1)**2) + Ddd*f*(5*C + 10)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 3*Dd**2*f**2*(10*C + 20)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(105*d**2*k3**6) - D1**2*Pk1*Pk2*ct**4*k2**2*st**4*(16*C - 16)*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(7*d**2*k3**4) - 2*D1**2*Pk1*Pk2*ct**4*k2**2*st**2*(504*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 9*b1*(-388*C*D1**2*f*fd*r**2 - 1000*C*D1**2*f*fd*r*s + 548*C*D1**2*f*fd*r - 612*C*D1**2*f*fd*s**2 + 660*C*D1**2*f*fd*s - 354*C*D1**2*f*fd + 236*C*D1**2*f*fdd*r**2 + 640*C*D1**2*f*fdd*r*s - 344*C*D1**2*f*fdd*r + 404*C*D1**2*f*fdd*s**2 - 428*C*D1**2*f*fdd*s + 226*C*D1**2*f*fdd + 236*C*D1**2*fd**2*r**2 + 640*C*D1**2*fd**2*r*s - 344*C*D1**2*fd**2*r + 404*C*D1**2*fd**2*s**2 - 428*C*D1**2*fd**2*s - 776*C*D1*Dd*f**2*r**2 - 2000*C*D1*Dd*f**2*r*s + 888*C*D1*Dd*f**2*r - 1224*C*D1*Dd*f**2*s**2 + 1112*C*D1*Dd*f**2*s - 500*C*D1*Dd*f**2 + 1888*C*D1*Dd*f*fd*r**2 + 5120*C*D1*Dd*f*fd*r*s - 2488*C*D1*Dd*f*fd*r + 3232*C*D1*Dd*f*fd*s**2 - 3160*C*D1*Dd*f*fd*s + 772*C*D1*Dd*f*fd + 472*C*D1*Ddd*f**2*r**2 + 1280*C*D1*Ddd*f**2*r*s - 556*C*D1*Ddd*f**2*r + 808*C*D1*Ddd*f**2*s**2 - 724*C*D1*Ddd*f**2*s + 320*C*D1*Ddd*f**2 + 1416*C*Dd**2*f**2*r**2 + 3840*C*Dd**2*f**2*r*s - 1668*C*Dd**2*f**2*r + 2424*C*Dd**2*f**2*s**2 - 2172*C*Dd**2*f**2*s + 320*C*Dd**2*f**2 - 56*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) + 448*D1**2*f*fd*r**2 + 636*D1**2*f*fd*r*s - 366*D1**2*f*fd*r + 188*D1**2*f*fd*s**2 - 236*D1**2*f*fd*s + 142*D1**2*f*fd - 266*D1**2*f*fdd*r**2 - 430*D1**2*f*fdd*r*s + 239*D1**2*f*fdd*r - 164*D1**2*f*fdd*s**2 + 188*D1**2*f*fdd*s - 106*D1**2*f*fdd - 266*D1**2*fd**2*r**2 - 430*D1**2*fd**2*r*s + 239*D1**2*fd**2*r - 164*D1**2*fd**2*s**2 + 188*D1**2*fd**2*s + 896*D1*Dd*f**2*r**2 + 1272*D1*Dd*f**2*r*s - 766*D1*Dd*f**2*r + 376*D1*Dd*f**2*s**2 - 506*D1*Dd*f**2*s + 318*D1*Dd*f**2 - 2128*D1*Dd*f*fd*r**2 - 3440*D1*Dd*f*fd*r*s + 1918*D1*Dd*f*fd*r - 1312*D1*Dd*f*fd*s**2 + 1510*D1*Dd*f*fd*s - 427*D1*Dd*f*fd - 532*D1*Ddd*f**2*r**2 - 860*D1*Ddd*f**2*r*s + 481*D1*Ddd*f**2*r - 328*D1*Ddd*f**2*s**2 + 379*D1*Ddd*f**2*s - 215*D1*Ddd*f**2 + 56*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 1596*Dd**2*f**2*r**2 - 2580*Dd**2*f**2*r*s + 1443*Dd**2*f**2*r - 984*Dd**2*f**2*s**2 + 1137*Dd**2*f**2*s - 215*Dd**2*f**2) + f*(-3654*C*D1**2*f*fd*r**2 - 8436*C*D1**2*f*fd*r*s + 5248*C*D1**2*f*fd*r - 4782*C*D1**2*f*fd*s**2 + 6000*C*D1**2*f*fd*s - 2812*C*D1**2*f*fd + 2394*C*D1**2*f*fdd*r**2 + 5352*C*D1**2*f*fdd*r*s - 3380*C*D1**2*f*fdd*r + 2958*C*D1**2*f*fdd*s**2 - 3756*C*D1**2*f*fdd*s + 1784*C*D1**2*f*fdd + 4788*C*D1**2*fd**2*r**2 + 10704*C*D1**2*fd**2*r*s - 6760*C*D1**2*fd**2*r + 5916*C*D1**2*fd**2*s**2 - 7512*C*D1**2*fd**2*s + 1784*C*D1**2*fd**2 - 4872*C*D1*Dd*f**2*r**2 - 11248*C*D1*Dd*f**2*r*s + 5248*C*D1*Dd*f**2*r - 6376*C*D1*Dd*f**2*s**2 + 6000*C*D1*Dd*f**2*s - 2812*C*D1*Dd*f**2 + 19152*C*D1*Dd*f*fd*r**2 + 42816*C*D1*Dd*f*fd*r*s - 23660*C*D1*Dd*f*fd*r + 23664*C*D1*Dd*f*fd*s**2 - 26292*C*D1*Dd*f*fd*s + 7136*C*D1*Dd*f*fd + 3192*C*D1*Ddd*f**2*r**2 + 7136*C*D1*Ddd*f**2*r*s - 3380*C*D1*Ddd*f**2*r + 3944*C*D1*Ddd*f**2*s**2 - 3756*C*D1*Ddd*f**2*s + 1784*C*D1*Ddd*f**2 + 9576*C*Dd**2*f**2*r**2 + 21408*C*Dd**2*f**2*r*s - 10140*C*Dd**2*f**2*r + 11832*C*Dd**2*f**2*s**2 - 11268*C*Dd**2*f**2*s + 1784*C*Dd**2*f**2 - 504*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) + 9*D1**2*bdd1*f*(r + s - 1)*(2*C*(59*r + 101*s - 47) - 133*r - 82*s + 109) + 4368*D1**2*f*fd*r**2 + 5874*D1**2*f*fd*r*s - 4870*D1**2*f*fd*r + 1506*D1**2*f*fd*s**2 - 2962*D1**2*f*fd*s + 1958*D1**2*f*fd - 2859*D1**2*f*fdd*r**2 - 4017*D1**2*f*fdd*r*s + 3245*D1**2*f*fdd*r - 1158*D1**2*f*fdd*s**2 + 2111*D1**2*f*fdd*s - 1339*D1**2*f*fdd - 5718*D1**2*fd**2*r**2 - 8034*D1**2*fd**2*r*s + 6490*D1**2*fd**2*r - 2316*D1**2*fd**2*s**2 + 4222*D1**2*fd**2*s - 1339*D1**2*fd**2 + 5824*D1*Dd*f**2*r**2 + 7832*D1*Dd*f**2*r*s - 4870*D1*Dd*f**2*r + 2008*D1*Dd*f**2*s**2 - 2962*D1*Dd*f**2*s + 1958*D1*Dd*f**2 - 22872*D1*Dd*f*fd*r**2 - 32136*D1*Dd*f*fd*r*s + 22715*D1*Dd*f*fd*r - 9264*D1*Dd*f*fd*s**2 + 14777*D1*Dd*f*fd*s - 5356*D1*Dd*f*fd - 3812*D1*Ddd*f**2*r**2 - 5356*D1*Ddd*f**2*r*s + 3245*D1*Ddd*f**2*r - 1544*D1*Ddd*f**2*s**2 + 2111*D1*Ddd*f**2*s - 1339*D1*Ddd*f**2 - 9*D1*bd1*(D1*(2*f*(r + s - 1)*(C*(97*r + 153*s - 73) - 112*r - 47*s + 88) + fd*(-4*C*(118*r**2 + 64*r*(5*s - 3) + 202*s**2 - 255*s + 80) + 532*r**2 + 860*r*s - 723*r + 328*s**2 - 570*s + 215)) + Dd*f*(-4*C*(236*r**2 + 640*r*s - 351*r + 404*s**2 - 477*s + 127) + 1064*r**2 + 1720*r*s - 1449*r + 656*s**2 - 1143*s + 433)) - 11436*Dd**2*f**2*r**2 - 16068*Dd**2*f**2*r*s + 9735*Dd**2*f**2*r - 4632*Dd**2*f**2*s**2 + 6333*Dd**2*f**2*s - 1339*Dd**2*f**2))/(315*d**2*k3**4) + 2*D1**2*Pk1*Pk2*ct**4*k2**2*(7*b1**2*(D1**2*(r + s)*(fd*r*(55*C - 61) + fd*s*(39*C - 39) + fdd*r*(28 - 25*C) - fdd*s*(37*C - 37)) + D1*(Dd*(2*f*(C*(110*r**2 + 2*r*(94*s - 51) + 78*s**2 - 86*s + 47) - 122*r**2 - 200*r*s + 111*r - 78*s**2 + 89*s - 50) + fd*(r**2*(224 - 200*C) + r*(-496*C*s + 112*C + 520*s - 121) + s*(-296*C*s + 136*C + 296*s - 139))) + Ddd*f*(-2*C*(50*r**2 + 124*r*s - 56*r + 74*s**2 - 68*s + 31) + 112*r**2 + 260*r*s - 121*r + 148*s**2 - 139*s + 65)) + Dd**2*f*(-2*C*(150*r**2 + 372*r*s - 168*r + 222*s**2 - 204*s + 31) + 336*r**2 + 780*r*s - 363*r + 444*s**2 - 417*s + 65)) + b1*(-7*D1**2*bdd1*f*(r + s - 1)*(C*(50*r + 74*s - 62) - 56*r - 74*s + 65) + 3*D1**2*(f*(fd*(16*C*(6*r**2 + 4*r*s - 6*r - 2*s**2 - 2*s + 3) - 198*r**2 - 520*r*s + 342*r - 322*s**2 + 404*s - 243) + fdd*(-4*C*(12*r**2 + 8*r*s - 5*r - 4*s**2 + 3*s - 1) + 176*r**2 + 470*r*s - 248*r + 294*s**2 - 307*s + 160)) + fd**2*(r**2*(176 - 48*C) + r*(-4*C*(8*s - 5) + 470*s - 248) + s*(4*C*(4*s - 3) + 294*s - 307))) + 7*D1*bd1*(D1*(2*f*(r + s - 1)*(C*(55*r + 39*s - 47) - 61*r - 39*s + 50) + fd*(r**2*(112 - 100*C) + r*(-248*C*s + 112*C + 260*s - 121) + s*(-148*C*s + 136*C + 148*s - 139))) + 2*Dd*f*(-4*C*(50*r**2 + 124*r*s - 84*r + 74*s**2 - 102*s + 31) + 224*r**2 + 520*r*s - 363*r + 296*s**2 - 417*s + 130)) + 3*D1*f*(Dd*(2*f*(16*C*(6*r**2 + 4*r*(s - 1) - 2*s**2 + 1) - 198*r**2 - 520*r*s + 229*r - 322*s**2 + 291*s - 130) - fd*(2*r + 2*s - 1)*(8*C*(24*r - 8*s - 1) - 704*r - 1176*s + 555)) + Ddd*f*(-16*C*(6*r**2 + 4*r*(s - 1) - 2*s**2 + 1) + 352*r**2 + 940*r*s - 411*r + 588*s**2 - 529*s + 235)) + 3*Dd**2*f**2*(-16*C*(18*r**2 + 12*r*(s - 1) - 6*s**2 + 1) + 1056*r**2 + 3*r*(940*s - 411) + 1764*s**2 - 1587*s + 235)) + f*(-7*D1**2*bd1**2*(r + s - 1)*(C*(50*r + 74*s - 62) - 56*r - 74*s + 65) - 3*D1**2*bdd1*f*(r + s - 1)*(4*C*(6*r - 2*s - 5) - 88*r - 147*s + 75) - 5*D1**2*(f*(C*fd*(147*r**2 + 6*r*(41*s - 30) + 99*s**2 - 148*s + 82) - C*fdd*(69*r**2 + 6*r*(25*s - 16) + 81*s**2 - 104*s + 50) - 4*fd*(9*r**2 + r*(2 - 24*s) - 33*s**2 + 30*s - 8) - 4*fdd*(9*r**2 + r*(39*s - 19) + 30*s**2 - 33*s + 13)) - 2*fd**2*(C*(69*r**2 + 150*r*s - 96*r + 81*s**2 - 104*s + 25) + 36*r**2 + 156*r*s - 76*r + 120*s**2 - 132*s + 26)) + 3*D1*bd1*(D1*(f*(r + s - 1)*(16*C*(3*r - s + 1) - 99*r - 161*s + 17) + fd*(-4*C*(24*r**2 + 16*r*s - 27*r - 8*s**2 - 3*s + 4) + 352*r**2 + 940*r*s - 574*r + 588*s**2 - 751*s + 235)) + Dd*f*(-8*C*(24*r**2 + 16*r*s - 30*r - 8*s**2 - 6*s + 7) + 704*r**2 + 1880*r*s - 1063*r + 1176*s**2 - 1417*s + 385)) - 10*D1*f*(Dd*(f*(C*(98*r**2 + 164*r*s - 90*r + 66*s**2 - 74*s + 41) - 24*r**2 + 64*r*s - 4*r + 88*s**2 - 60*s + 16) - 2*fd*(2*C*(69*r**2 + 150*r*s - 84*r + 81*s**2 - 91*s + 25) + 72*r**2 + 312*r*s - 133*r + 240*s**2 - 231*s + 52)) - Ddd*f*(C*(46*r**2 + 100*r*s - 48*r + 54*s**2 - 52*s + 25) + 24*r**2 + 104*r*s - 38*r + 80*s**2 - 66*s + 26)) + 10*Dd**2*f**2*(C*(138*r**2 + 12*r*(25*s - 12) + 162*s**2 - 156*s + 25) + 72*r**2 + 6*r*(52*s - 19) + 240*s**2 - 198*s + 26)))/(105*d**2*k3**4) - D1**2*Pk1*Pk2*ct**4*st**4*(24*C - 24)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k3**2) + 4*D1**2*Pk1*Pk2*ct**4*st**2*(D1**2*(25*f**3*(28*fd*(4*s**2 - 2*s + 1) - 14*fdd*(4*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) - 6*f**2*s*(165*bd1**2*s + 11*bd1*(25*fd*(3*s - 1) + s*(6*K - 6)) + 350*fd**2*(2*s - 1) - s*(33*bdd1*(K - 1) + 132*gd2 - 66*gdd2)) + 132*f*(3*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 3*fdd*g2*(2*s**2 - 2*s + 1) + s**2*(7*bd1**2*(K - 1) + 14*bd1*(g2 - gd2) - 7*bdd1*g2)) - 264*fd*g2*s*(7*bd1 + 3*fd)*(s - 1)) + 2*D1*f*(Dd*(350*f**3*(4*s**2 - 2*s + 1) - 25*f**2*(4*s - 1)*(33*bd1*s + 14*fd*(4*s - 1)) + 198*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 132*g2*(4*s - 1)*(7*bd1*s + fd*(6*s - 3))) - Ddd*f*(175*f**2 + 198*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(175*f**2 + 198*g2)*(2*s - 1) + 33*b1**2*(D1**2*(30*f*fd*(2*s**2 - 2*s + 1) - 15*f*fdd*(2*s**2 - 2*s + 1) - 30*fd**2*s*(s - 1) - 28*fd*(K - 1)*(s - 1)**2 + 14*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(15*f**2*(4*s**2 - 2*s + 1) - 15*f*fd*(8*s**2 - 6*s + 1) - 14*f*(K - 1)*(4*s**2 - 2*s + 1) + 14*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-14*K + 15*f + 14)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-14*K + 15*f + 14)) + 33*b1*(D1**2*(5*f**2*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(12*bd1 - 6*bdd1)) - 2*f*(25*fd**2*s*(3*s - 2) + 6*fd*(K*(2*s**2 - 2*s + 1) + s**2*(10*bd1 - 2) + s*(2 - 5*bd1) - 1) - 3*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(-14*K*bdd1 + 28*bd1*(K - 1) + 14*bdd1 - 28*gd2 + 14*gdd2)) + (4*s - 4)*(3*fd**2*s*(K - 1) + 14*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(25*f**3*(4*s**2 - 2*s + 1) + f**2*(-6*K*(4*s**2 - 2*s + 1) - 25*fd*(12*s**2 - 7*s + 1) - 6*s**2*(20*bd1 - 4) - 6*s*(2 - 5*bd1) + 6) + 2*f*(3*fd*(K - 1)*(8*s**2 - 6*s + 1) + 14*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(14*K*bd1 - 14*bd1 - 14*gd2)) - 28*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(25*f**2 - 6*f*(K - 1) + 28*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(25*f**2 - 6*f*(K - 1) + 28*g2)))/(385*d**2*k2**2) + 2*D1**2*Pk1*Pk2*ct**4*(-17094*D1**2*K*bd1**2*f*s**2 - 2772*D1**2*K*bd1**2*f*s + 9405*D1**2*K*bd1*f**2*s**2 - 25740*D1**2*K*bd1*f*fd*s**2 + 12870*D1**2*K*bd1*f*fd*s - 6435*D1**2*K*bdd1*f**2*s**2 + 2772*D1**2*bd1**2*f**2*r*s + 4554*D1**2*bd1**2*f**2*s**2 + 4554*D1**2*bd1**2*f**2*s + 2772*D1**2*bd1**2*f*r*s + 11550*D1**2*bd1**2*f*s**2 + 1386*D1**2*bd1**2*f*s - 9240*D1**2*bd1**2*g2*s**2 + 9240*D1**2*bd1**2*g2*s - 2772*D1**2*bd1*bd2*f*s**2 - 3740*D1**2*bd1*f**3*r*s - 14685*D1**2*bd1*f**3*s**2 - 4290*D1**2*bd1*f**3*s + 3080*D1**2*bd1*f**3 + 17160*D1**2*bd1*f**2*fd*r*s - 2860*D1**2*bd1*f**2*fd*r + 66330*D1**2*bd1*f**2*fd*s**2 - 21670*D1**2*bd1*f**2*fd*s + 1430*D1**2*bd1*f**2*fd - 3564*D1**2*bd1*f**2*r*s - 5445*D1**2*bd1*f**2*s**2 + 7128*D1**2*bd1*f*fd*r*s - 1782*D1**2*bd1*f*fd*r + 17820*D1**2*bd1*f*fd*s**2 - 10692*D1**2*bd1*f*fd*s - 22638*D1**2*bd1*f*g2*s**2 - 11088*D1**2*bd1*f*g2*s + 5544*D1**2*bd1*f*g2 + 34188*D1**2*bd1*f*gd2*s**2 + 5544*D1**2*bd1*f*gd2*s + 34188*D1**2*bd1*fd*g2*s**2 - 34188*D1**2*bd1*fd*g2*s + 1980*D1**2*bd2*f**2*s**2 - 3960*D1**2*bd2*f*fd*s**2 + 1980*D1**2*bd2*f*fd*s + 2860*D1**2*bdd1*f**3*r*s + 11055*D1**2*bdd1*f**3*s**2 + 1650*D1**2*bdd1*f**3*s - 1540*D1**2*bdd1*f**3 + 1782*D1**2*bdd1*f**2*r*s + 4455*D1**2*bdd1*f**2*s**2 + 17094*D1**2*bdd1*f*g2*s**2 + 5544*D1**2*bdd1*f*g2*s - 2772*D1**2*bdd1*f*g2 - 990*D1**2*bdd2*f**2*s**2 - 7560*D1**2*f**3*fd*r*s + 1890*D1**2*f**3*fd*r - 40040*D1**2*f**3*fd*s**2 + 21910*D1**2*f**3*fd*s - 10010*D1**2*f**3*fd + 5320*D1**2*f**3*fdd*r*s - 1330*D1**2*f**3*fdd*r + 27720*D1**2*f**3*fdd*s**2 - 15190*D1**2*f**3*fdd*s + 6930*D1**2*f**3*fdd + 15960*D1**2*f**2*fd**2*r*s - 3990*D1**2*f**2*fd**2*r + 83160*D1**2*f**2*fd**2*s**2 - 45570*D1**2*f**2*fd**2*s + 1330*D1**2*f**2*fd**2 - 18810*D1**2*f**2*gd2*s**2 + 12870*D1**2*f**2*gdd2*s**2 - 37620*D1**2*f*fd*g2*s**2 + 37620*D1**2*f*fd*g2*s - 18810*D1**2*f*fd*g2 + 51480*D1**2*f*fd*gd2*s**2 - 25740*D1**2*f*fd*gd2*s + 25740*D1**2*f*fdd*g2*s**2 - 25740*D1**2*f*fdd*g2*s + 12870*D1**2*f*fdd*g2 + 25740*D1**2*fd**2*g2*s**2 - 25740*D1**2*fd**2*g2*s - 51480*D1*Dd*K*bd1*f**2*s**2 + 12870*D1*Dd*K*bd1*f**2*s + 22880*D1*Dd*bd1*f**3*r*s - 2860*D1*Dd*bd1*f**3*r + 88440*D1*Dd*bd1*f**3*s**2 - 18370*D1*Dd*bd1*f**3*s - 1650*D1*Dd*bd1*f**3 + 14256*D1*Dd*bd1*f**2*r*s - 1782*D1*Dd*bd1*f**2*r + 35640*D1*Dd*bd1*f**2*s**2 - 10692*D1*Dd*bd1*f**2*s + 136752*D1*Dd*bd1*f*g2*s**2 - 12012*D1*Dd*bd1*f*g2*s - 5544*D1*Dd*bd1*f*g2 - 7920*D1*Dd*bd2*f**2*s**2 + 1980*D1*Dd*bd2*f**2*s - 7560*D1*Dd*f**4*r*s + 1890*D1*Dd*f**4*r - 40040*D1*Dd*f**4*s**2 + 21910*D1*Dd*f**4*s - 10010*D1*Dd*f**4 + 42560*D1*Dd*f**3*fd*r*s - 10640*D1*Dd*f**3*fd*r + 221760*D1*Dd*f**3*fd*s**2 - 121520*D1*Dd*f**3*fd*s + 16520*D1*Dd*f**3*fd - 75240*D1*Dd*f**2*g2*s**2 + 37620*D1*Dd*f**2*g2*s - 18810*D1*Dd*f**2*g2 + 102960*D1*Dd*f**2*gd2*s**2 - 25740*D1*Dd*f**2*gd2*s + 205920*D1*Dd*f*fd*g2*s**2 - 154440*D1*Dd*f*fd*g2*s + 25740*D1*Dd*f*fd*g2 + 5320*D1*Ddd*f**4*r*s - 1330*D1*Ddd*f**4*r + 27720*D1*Ddd*f**4*s**2 - 15190*D1*Ddd*f**4*s + 6930*D1*Ddd*f**4 + 51480*D1*Ddd*f**2*g2*s**2 - 25740*D1*Ddd*f**2*g2*s + 12870*D1*Ddd*f**2*g2 + 15960*Dd**2*f**4*r*s - 3990*Dd**2*f**4*r + 83160*Dd**2*f**4*s**2 - 45570*Dd**2*f**4*s + 1330*Dd**2*f**4 + 154440*Dd**2*f**2*g2*s**2 - 77220*Dd**2*f**2*g2*s + 462*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-5*K*(4*s**2 - 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s + 20*s**2 - 10*s + 5) - D1*Ddd*(-5*K + 3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-5*K + 3*f + 5)) + 33*b1**2*(343*D1**2*K*fd*s**2 - 854*D1**2*K*fd*s + 427*D1**2*K*fd - 259*D1**2*K*fdd*s**2 + 602*D1**2*K*fdd*s - 301*D1**2*K*fdd - 14*D1**2*bdd1*(-5*K + 3*f + 5)*(3*s**2 - 2*s + 1) - 84*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 66*D1**2*f*fd*s**2 + 426*D1**2*f*fd*s - 213*D1**2*f*fd + 84*D1**2*f*fdd*r*s - 42*D1**2*f*fdd*r + 138*D1**2*f*fdd*s**2 - 318*D1**2*f*fdd*s + 159*D1**2*f*fdd + 84*D1**2*fd**2*r*s - 42*D1**2*fd**2*r + 138*D1**2*fd**2*s**2 - 318*D1**2*fd**2*s - 84*D1**2*fd*r*s + 84*D1**2*fd*r - 175*D1**2*fd*s**2 + 518*D1**2*fd*s - 259*D1**2*fd + 42*D1**2*fdd*r*s - 42*D1**2*fdd*r + 175*D1**2*fdd*s**2 - 434*D1**2*fdd*s + 217*D1**2*fdd + 280*D1**2*gd2*s**2 - 140*D1**2*gdd2*s**2 + 1372*D1*Dd*K*f*s**2 - 686*D1*Dd*K*f*s + 343*D1*Dd*K*f - 2072*D1*Dd*K*fd*s**2 + 2926*D1*Dd*K*fd*s - 602*D1*Dd*K*fd - 168*D1*Dd*f**2*r*s + 42*D1*Dd*f**2*r - 132*D1*Dd*f**2*s**2 + 108*D1*Dd*f**2*s - 33*D1*Dd*f**2 + 672*D1*Dd*f*fd*r*s - 252*D1*Dd*f*fd*r + 1104*D1*Dd*f*fd*s**2 - 1632*D1*Dd*f*fd*s + 360*D1*Dd*f*fd - 336*D1*Dd*f*r*s + 84*D1*Dd*f*r - 700*D1*Dd*f*s**2 + 434*D1*Dd*f*s - 175*D1*Dd*f + 336*D1*Dd*fd*r*s - 210*D1*Dd*fd*r + 1400*D1*Dd*fd*s**2 - 2128*D1*Dd*fd*s + 476*D1*Dd*fd + 1120*D1*Dd*g2*s**2 - 560*D1*Dd*g2*s + 280*D1*Dd*g2 - 1120*D1*Dd*gd2*s**2 + 280*D1*Dd*gd2*s - 1036*D1*Ddd*K*f*s**2 + 518*D1*Ddd*K*f*s - 259*D1*Ddd*K*f + 168*D1*Ddd*f**2*r*s - 42*D1*Ddd*f**2*r + 276*D1*Ddd*f**2*s**2 - 180*D1*Ddd*f**2*s + 69*D1*Ddd*f**2 + 168*D1*Ddd*f*r*s - 42*D1*Ddd*f*r + 700*D1*Ddd*f*s**2 - 392*D1*Ddd*f*s + 175*D1*Ddd*f - 560*D1*Ddd*g2*s**2 + 280*D1*Ddd*g2*s - 140*D1*Ddd*g2 + 28*D1*bd1*(D1*(-5*K*(3*s**2 - 2*s + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s + 15*s**2 - 10*s + 5) - Dd*(-5*K + 3*f + 5)*(12*s**2 - 7*s + 1)) - 3108*Dd**2*K*f*s**2 + 1554*Dd**2*K*f*s + 504*Dd**2*f**2*r*s - 126*Dd**2*f**2*r + 828*Dd**2*f**2*s**2 - 540*Dd**2*f**2*s + 42*Dd**2*f**2 + 504*Dd**2*f*r*s - 126*Dd**2*f*r + 2100*Dd**2*f*s**2 - 1176*Dd**2*f*s + 42*Dd**2*f - 1680*Dd**2*g2*s**2 + 840*Dd**2*g2*s) - 11*b1*(-1710*D1**2*K*f*fd*s**2 + 1710*D1**2*K*f*fd*s - 855*D1**2*K*f*fd + 1170*D1**2*K*f*fdd*s**2 - 1170*D1**2*K*f*fdd*s + 585*D1**2*K*f*fdd + 1170*D1**2*K*fd**2*s**2 - 1170*D1**2*K*fd**2*s - 252*D1**2*b2*fd*s**2 + 504*D1**2*b2*fd*s - 252*D1**2*b2*fd + 126*D1**2*b2*fdd*s**2 - 252*D1**2*b2*fdd*s + 126*D1**2*b2*fdd + 84*D1**2*bd1**2*s*(3*s - 2)*(-5*K + 3*f + 5) - 252*D1**2*bd2*f*s**2 + 252*D1**2*bd2*fd*s**2 - 252*D1**2*bd2*fd*s - 6*D1**2*bdd1*(f**2*(69*s**2 + s*(42*r + 69) - 45) + 7*f*(K*(-37*s**2 - 6*s + 3) + 25*s**2 + s*(6*r + 3) - 3) - 70*g2*(2*s**2 - 2*s + 1)) + 126*D1**2*bdd2*f*s**2 + 1020*D1**2*f**2*fd*r*s - 340*D1**2*f**2*fd*r + 4005*D1**2*f**2*fd*s**2 - 3400*D1**2*f**2*fd*s + 1615*D1**2*f**2*fd - 780*D1**2*f**2*fdd*r*s + 260*D1**2*f**2*fdd*r - 3015*D1**2*f**2*fdd*s**2 + 2420*D1**2*f**2*fdd*s - 1145*D1**2*f**2*fdd - 1560*D1**2*f*fd**2*r*s + 520*D1**2*f*fd**2*r - 6030*D1**2*f*fd**2*s**2 + 4840*D1**2*f*fd**2*s - 130*D1**2*f*fd**2 + 648*D1**2*f*fd*r*s - 324*D1**2*f*fd*r + 990*D1**2*f*fd*s**2 - 1314*D1**2*f*fd*s + 495*D1**2*f*fd - 324*D1**2*f*fdd*r*s + 162*D1**2*f*fdd*r - 810*D1**2*f*fdd*s**2 + 972*D1**2*f*fdd*s - 405*D1**2*f*fdd + 2058*D1**2*f*gd2*s**2 - 1554*D1**2*f*gdd2*s**2 - 324*D1**2*fd**2*r*s + 162*D1**2*fd**2*r - 810*D1**2*fd**2*s**2 + 972*D1**2*fd**2*s - 162*D1**2*fd**2 + 2058*D1**2*fd*g2*s**2 - 5124*D1**2*fd*g2*s + 2562*D1**2*fd*g2 - 3108*D1**2*fd*gd2*s**2 + 3612*D1**2*fd*gd2*s - 1554*D1**2*fdd*g2*s**2 + 3612*D1**2*fdd*g2*s - 1806*D1**2*fdd*g2 - 3420*D1*Dd*K*f**2*s**2 + 1710*D1*Dd*K*f**2*s - 855*D1*Dd*K*f**2 + 9360*D1*Dd*K*f*fd*s**2 - 7020*D1*Dd*K*f*fd*s + 1170*D1*Dd*K*f*fd - 1008*D1*Dd*b2*f*s**2 + 504*D1*Dd*b2*f*s - 252*D1*Dd*b2*f + 1008*D1*Dd*b2*fd*s**2 - 1260*D1*Dd*b2*fd*s + 252*D1*Dd*b2*fd + 1008*D1*Dd*bd2*f*s**2 - 252*D1*Dd*bd2*f*s + 1360*D1*Dd*f**3*r*s - 340*D1*Dd*f**3*r + 5340*D1*Dd*f**3*s**2 - 3010*D1*Dd*f**3*s + 1335*D1*Dd*f**3 - 6240*D1*Dd*f**2*fd*r*s + 1820*D1*Dd*f**2*fd*r - 24120*D1*Dd*f**2*fd*s**2 + 16490*D1*Dd*f**2*fd*s - 2680*D1*Dd*f**2*fd + 1296*D1*Dd*f**2*r*s - 324*D1*Dd*f**2*r + 1980*D1*Dd*f**2*s**2 - 1314*D1*Dd*f**2*s + 495*D1*Dd*f**2 - 2592*D1*Dd*f*fd*r*s + 972*D1*Dd*f*fd*r - 6480*D1*Dd*f*fd*s**2 + 5832*D1*Dd*f*fd*s - 1134*D1*Dd*f*fd + 8232*D1*Dd*f*g2*s**2 - 4116*D1*Dd*f*g2*s + 2058*D1*Dd*f*g2 - 12432*D1*Dd*f*gd2*s**2 + 3108*D1*Dd*f*gd2*s - 12432*D1*Dd*fd*g2*s**2 + 17556*D1*Dd*fd*g2*s - 3612*D1*Dd*fd*g2 + 2340*D1*Ddd*K*f**2*s**2 - 1170*D1*Ddd*K*f**2*s + 585*D1*Ddd*K*f**2 + 504*D1*Ddd*b2*f*s**2 - 252*D1*Ddd*b2*f*s + 126*D1*Ddd*b2*f - 1040*D1*Ddd*f**3*r*s + 260*D1*Ddd*f**3*r - 4020*D1*Ddd*f**3*s**2 + 2270*D1*Ddd*f**3*s - 1005*D1*Ddd*f**3 - 648*D1*Ddd*f**2*r*s + 162*D1*Ddd*f**2*r - 1620*D1*Ddd*f**2*s**2 + 972*D1*Ddd*f**2*s - 405*D1*Ddd*f**2 - 6216*D1*Ddd*f*g2*s**2 + 3108*D1*Ddd*f*g2*s - 1554*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(3*f**2*(11*s**2 + s*(14*r + 53) - 30) + f*(7*K*(-49*s**2 - 12*s + 6) - 3*fd*(14*r*(4*s - 1) + 92*s**2 - 60*s + 7) + 175*s**2 + 7*s*(12*r + 6) - 42) - 7*fd*(6*r*(2*s - 1) + s**2*(50 - 74*K) + s*(80*K - 59) + 3) - 140*g2*(2*s**2 - 2*s + 1) - 140*gd2*s*(1 - 2*s)) + Dd*(f**2*(-42*r*(8*s - 1) - 552*s**2 - 96*s + 69) + 7*f*(K*(296*s**2 - 50*s - 6) - 48*r*s + 6*r - 200*s**2 + 44*s + 3) + 140*g2*(8*s**2 - 6*s + 1))) + 7020*Dd**2*K*f**2*s**2 - 3510*Dd**2*K*f**2*s + 1512*Dd**2*b2*f*s**2 - 756*Dd**2*b2*f*s - 3120*Dd**2*f**3*r*s + 780*Dd**2*f**3*r - 12060*Dd**2*f**3*s**2 + 6810*Dd**2*f**3*s - 260*Dd**2*f**3 - 1944*Dd**2*f**2*r*s + 486*Dd**2*f**2*r - 4860*Dd**2*f**2*s**2 + 2916*Dd**2*f**2*s - 162*Dd**2*f**2 - 18648*Dd**2*f*g2*s**2 + 9324*Dd**2*f*g2*s) + 198*b2*(D1**2*(f*(10*fd*(2*s**2 - 2*s + 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(14*bd1 - 7*bdd1)) - 2*fd*s*(7*bd1 + 5*fd)*(s - 1)) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(7*bd1*s + 5*fd*(2*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(3465*d**2*k2**2) - 2*D1**2*Pk1*Pk2*ct**4*k2**4*st**2*(324*D1**2*b1*f*fd*r**2 + 324*D1**2*b1*f*fd*r*s - 162*D1**2*b1*f*fd*r + 90*D1**2*b1*f*fdd*r**2 + 90*D1**2*b1*f*fdd*r*s - 45*D1**2*b1*f*fdd*r + 90*D1**2*b1*fd**2*r**2 + 90*D1**2*b1*fd**2*r*s - 45*D1**2*b1*fd**2*r + 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 438*D1**2*f**2*fd*r**2 + 438*D1**2*f**2*fd*r*s - 438*D1**2*f**2*fd*r - 146*D1**2*f**2*fd*s + 146*D1**2*f**2*fd - 165*D1**2*f**2*fdd*r**2 - 165*D1**2*f**2*fdd*r*s + 165*D1**2*f**2*fdd*r + 55*D1**2*f**2*fdd*s - 55*D1**2*f**2*fdd - 330*D1**2*f*fd**2*r**2 - 330*D1**2*f*fd**2*r*s + 330*D1**2*f*fd**2*r + 110*D1**2*f*fd**2*s - 55*D1**2*f*fd**2 + 648*D1*Dd*b1*f**2*r**2 + 648*D1*Dd*b1*f**2*r*s - 486*D1*Dd*b1*f**2*r - 162*D1*Dd*b1*f**2*s + 162*D1*Dd*b1*f**2 + 720*D1*Dd*b1*f*fd*r**2 + 720*D1*Dd*b1*f*fd*r*s - 450*D1*Dd*b1*f*fd*r - 90*D1*Dd*b1*f*fd*s + 45*D1*Dd*b1*f*fd + 584*D1*Dd*f**3*r**2 + 584*D1*Dd*f**3*r*s - 438*D1*Dd*f**3*r - 146*D1*Dd*f**3*s + 146*D1*Dd*f**3 - 1320*D1*Dd*f**2*fd*r**2 - 1320*D1*Dd*f**2*fd*r*s + 1155*D1*Dd*f**2*fd*r + 385*D1*Dd*f**2*fd*s - 220*D1*Dd*f**2*fd + 180*D1*Ddd*b1*f**2*r**2 + 180*D1*Ddd*b1*f**2*r*s - 135*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2*s + 45*D1*Ddd*b1*f**2 - 220*D1*Ddd*f**3*r**2 - 220*D1*Ddd*f**3*r*s + 165*D1*Ddd*f**3*r + 55*D1*Ddd*f**3*s - 55*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(18*f*(r - 1)*(r + s - 1) + 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 540*Dd**2*b1*f**2*r**2 + 540*Dd**2*b1*f**2*r*s - 405*Dd**2*b1*f**2*r - 135*Dd**2*b1*f**2*s + 45*Dd**2*b1*f**2 - 660*Dd**2*f**3*r**2 - 660*Dd**2*f**3*r*s + 495*Dd**2*f**3*r + 165*Dd**2*f**3*s - 55*Dd**2*f**3)/(315*d**2*k1**2*k3**4) - 2*D1**2*Pk1*Pk2*ct**4*k2**4*(3*D1*f*(7*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(f*(5*r + 7)*(r + s - 1) + fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + D1*f*(bdd1*r*(r + s - 1) - 5*fd*(3*r**2 + 3*r*(s - 1) - s + 1)) + Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1) - 5*Dd*f**2*(4*r**2 + r*(4*s - 3) - s + 1)) + 7*b1**2*(D1**2*r*(4*fd + 3*fdd)*(r + s) + D1*(Dd*(4*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(8*r**2 + 8*r*s - 3*r - s)) + 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) + 3*D1**2*(f*(fd*(10*r**2 + 10*r*s - 17*r - 12*s + 12) + fdd*(2*r**2 + 2*r*(s - 1) - s + 1)) + fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(4*f*(2*r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 3*r - s)) + 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 3*D1*f*(Dd*(5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + fd*(8*r - 3)*(2*r + 2*s - 1)) + Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 3*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)))/(105*d**2*k1**2*k3**4) + 4*D1**2*Pk1*Pk2*ct**3*f*st**4*(11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(4*s**2 - 2*s + 1) - 5*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + 2*fd*s*(bd1*(11 - 33*s) + 15*fd*(1 - 2*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(11*bd1*s + 5*fd*(4*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(11*d**2*k1*k2) + 4*D1**2*Pk1*Pk2*ct**3*k1**5*(54*D1**2*b1*f*fd*r**2 + 108*D1**2*b1*f*fd*r*s - 54*D1**2*b1*f*fd*r + 54*D1**2*b1*f*fd*s**2 - 54*D1**2*b1*f*fd*s + 27*D1**2*b1*f*fd - 90*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd - 90*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)**2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 216*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 108*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 720*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 720*D1*Dd*b1*f*fd*s - 180*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 100*D1*Dd*f**3*s + 50*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 980*D1*Dd*f**2*fd*s - 280*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 180*D1*Ddd*b1*f**2*s - 90*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 140*D1*Ddd*f**3*s - 70*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(2*r + 2*s - 1)) - 540*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 540*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 420*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k2*k3**6) - 8*D1**2*Pk1*Pk2*ct**3*k1**3*k2*st**2*(32*C*D1**2*b1*f*fd*r**2 + 64*C*D1**2*b1*f*fd*r*s - 32*C*D1**2*b1*f*fd*r + 32*C*D1**2*b1*f*fd*s**2 - 32*C*D1**2*b1*f*fd*s + 16*C*D1**2*b1*f*fd - 72*C*D1**2*b1*f*fdd*r**2 - 144*C*D1**2*b1*f*fdd*r*s + 72*C*D1**2*b1*f*fdd*r - 72*C*D1**2*b1*f*fdd*s**2 + 72*C*D1**2*b1*f*fdd*s - 36*C*D1**2*b1*f*fdd - 72*C*D1**2*b1*fd**2*r**2 - 144*C*D1**2*b1*fd**2*r*s + 72*C*D1**2*b1*fd**2*r - 72*C*D1**2*b1*fd**2*s**2 + 72*C*D1**2*b1*fd**2*s + 48*C*D1**2*f**2*fd*r**2 + 96*C*D1**2*f**2*fd*r*s - 64*C*D1**2*f**2*fd*r + 48*C*D1**2*f**2*fd*s**2 - 64*C*D1**2*f**2*fd*s + 32*C*D1**2*f**2*fd - 60*C*D1**2*f**2*fdd*r**2 - 120*C*D1**2*f**2*fdd*r*s + 80*C*D1**2*f**2*fdd*r - 60*C*D1**2*f**2*fdd*s**2 + 80*C*D1**2*f**2*fdd*s - 40*C*D1**2*f**2*fdd - 120*C*D1**2*f*fd**2*r**2 - 240*C*D1**2*f*fd**2*r*s + 160*C*D1**2*f*fd**2*r - 120*C*D1**2*f*fd**2*s**2 + 160*C*D1**2*f*fd**2*s - 40*C*D1**2*f*fd**2 + 64*C*D1*Dd*b1*f**2*r**2 + 128*C*D1*Dd*b1*f**2*r*s - 64*C*D1*Dd*b1*f**2*r + 64*C*D1*Dd*b1*f**2*s**2 - 64*C*D1*Dd*b1*f**2*s + 32*C*D1*Dd*b1*f**2 - 576*C*D1*Dd*b1*f*fd*r**2 - 1152*C*D1*Dd*b1*f*fd*r*s + 576*C*D1*Dd*b1*f*fd*r - 576*C*D1*Dd*b1*f*fd*s**2 + 576*C*D1*Dd*b1*f*fd*s - 144*C*D1*Dd*b1*f*fd + 64*C*D1*Dd*f**3*r**2 + 128*C*D1*Dd*f**3*r*s - 64*C*D1*Dd*f**3*r + 64*C*D1*Dd*f**3*s**2 - 64*C*D1*Dd*f**3*s + 32*C*D1*Dd*f**3 - 480*C*D1*Dd*f**2*fd*r**2 - 960*C*D1*Dd*f**2*fd*r*s + 560*C*D1*Dd*f**2*fd*r - 480*C*D1*Dd*f**2*fd*s**2 + 560*C*D1*Dd*f**2*fd*s - 160*C*D1*Dd*f**2*fd - 144*C*D1*Ddd*b1*f**2*r**2 - 288*C*D1*Ddd*b1*f**2*r*s + 144*C*D1*Ddd*b1*f**2*r - 144*C*D1*Ddd*b1*f**2*s**2 + 144*C*D1*Ddd*b1*f**2*s - 72*C*D1*Ddd*b1*f**2 - 80*C*D1*Ddd*f**3*r**2 - 160*C*D1*Ddd*f**3*r*s + 80*C*D1*Ddd*f**3*r - 80*C*D1*Ddd*f**3*s**2 + 80*C*D1*Ddd*f**3*s - 40*C*D1*Ddd*f**3 - 432*C*Dd**2*b1*f**2*r**2 - 864*C*Dd**2*b1*f**2*r*s + 432*C*Dd**2*b1*f**2*r - 432*C*Dd**2*b1*f**2*s**2 + 432*C*Dd**2*b1*f**2*s - 72*C*Dd**2*b1*f**2 - 240*C*Dd**2*f**3*r**2 - 480*C*Dd**2*f**3*r*s + 240*C*Dd**2*f**3*r - 240*C*Dd**2*f**3*s**2 + 240*C*Dd**2*f**3*s - 40*C*Dd**2*f**3 - 122*D1**2*b1*f*fd*r**2 - 244*D1**2*b1*f*fd*r*s + 122*D1**2*b1*f*fd*r - 122*D1**2*b1*f*fd*s**2 + 122*D1**2*b1*f*fd*s - 61*D1**2*b1*f*fd + 180*D1**2*b1*f*fdd*r**2 + 360*D1**2*b1*f*fdd*r*s - 180*D1**2*b1*f*fdd*r + 180*D1**2*b1*f*fdd*s**2 - 180*D1**2*b1*f*fdd*s + 90*D1**2*b1*f*fdd + 180*D1**2*b1*fd**2*r**2 + 360*D1**2*b1*fd**2*r*s - 180*D1**2*b1*fd**2*r + 180*D1**2*b1*fd**2*s**2 - 180*D1**2*b1*fd**2*s - 18*D1**2*bdd1*f**2*(2*C - 5)*(r + s - 1)**2 - 147*D1**2*f**2*fd*r**2 - 294*D1**2*f**2*fd*r*s + 196*D1**2*f**2*fd*r - 147*D1**2*f**2*fd*s**2 + 196*D1**2*f**2*fd*s - 98*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 244*D1*Dd*b1*f**2*r**2 - 488*D1*Dd*b1*f**2*r*s + 244*D1*Dd*b1*f**2*r - 244*D1*Dd*b1*f**2*s**2 + 244*D1*Dd*b1*f**2*s - 122*D1*Dd*b1*f**2 + 1440*D1*Dd*b1*f*fd*r**2 + 2880*D1*Dd*b1*f*fd*r*s - 1440*D1*Dd*b1*f*fd*r + 1440*D1*Dd*b1*f*fd*s**2 - 1440*D1*Dd*b1*f*fd*s + 360*D1*Dd*b1*f*fd - 196*D1*Dd*f**3*r**2 - 392*D1*Dd*f**3*r*s + 196*D1*Dd*f**3*r - 196*D1*Dd*f**3*s**2 + 196*D1*Dd*f**3*s - 98*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 1400*D1*Dd*f**2*fd*r + 1200*D1*Dd*f**2*fd*s**2 - 1400*D1*Dd*f**2*fd*s + 400*D1*Dd*f**2*fd + 360*D1*Ddd*b1*f**2*r**2 + 720*D1*Ddd*b1*f**2*r*s - 360*D1*Ddd*b1*f**2*r + 360*D1*Ddd*b1*f**2*s**2 - 360*D1*Ddd*b1*f**2*s + 180*D1*Ddd*b1*f**2 + 200*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 200*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s**2 - 200*D1*Ddd*f**3*s + 100*D1*Ddd*f**3 + D1*bd1*f*(r + s - 1)*(D1*f*(16*C - 61)*(r + s - 1) - D1*fd*(72*C - 180)*(2*r + 2*s - 1) - Dd*f*(144*C - 360)*(2*r + 2*s - 1)) + 1080*Dd**2*b1*f**2*r**2 + 2160*Dd**2*b1*f**2*r*s - 1080*Dd**2*b1*f**2*r + 1080*Dd**2*b1*f**2*s**2 - 1080*Dd**2*b1*f**2*s + 180*Dd**2*b1*f**2 + 600*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 600*Dd**2*f**3*r + 600*Dd**2*f**3*s**2 - 600*Dd**2*f**3*s + 100*Dd**2*f**3)/(105*d**2*k3**6) - 4*D1**2*Pk1*Pk2*ct**3*k1**3*k2*(21*b1**2*(D1**2*(r + s)**2*(fd*(8*C - 19) + fdd*(42 - 24*C)) + 2*D1*(Dd*(f*(8*C - 19)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(48*C - 84)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(42 - 24*C)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(48*C - 84)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 3*b1*(-84*D1**2*bdd1*f*(4*C - 7)*(r + s - 1)**2 - 45*D1**2*(f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*D1*bd1*(r + s - 1)*(D1*f*(8*C - 19)*(r + s - 1) - D1*fd*(48*C - 84)*(r + s) - Dd*f*(96*C - 168)*(2*r + 2*s - 1)) - 90*D1*f*(Dd*(3*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 10*fd*(2*r + 2*s - 1)**2) - 5*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 450*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + f*(-252*D1**2*bd1**2*(4*C - 7)*(r + s - 1)**2 + 675*D1**2*bdd1*f*(r + s - 1)**2 + 5*D1**2*(-f*(-56*C*fdd + fd*(40*C - 4) - 7*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(112*C + 14)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 135*D1*bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(2*r + 2*s - 1)) - 10*D1*f*(2*Dd*(f*(20*C - 2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(56*C + 7)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Ddd*f*(-56*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 5*Dd**2*f**2*(112*C + 14)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(315*d**2*k3**6) - D1**2*Pk1*Pk2*ct**3*k1**3*st**2*(16*C - 64)*(b1*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 9*fd*(8*s - 3)*(2*r + 2*s - 1)) - 9*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 9*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(7*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 5*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k2*k3**4) + D1**2*Pk1*Pk2*ct**3*k1**3*(-84*D1*b1*bd1*(D1*(f*(2*C - 10)*(2*s - 1)*(r + s - 1) - fd*(6*C - 15)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(30 - 12*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 84*b1**2*(D1**2*s*(r + s)*(fd*(2*C - 10) + fdd*(15 - 6*C)) + D1*(Dd*(f*(2*C - 10)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C - 15)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(15 - 6*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(6*C - 15)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 9*b1*(28*D1**2*bdd1*f*(2*C - 5)*(2*s - 1)*(r + s - 1) + D1**2*(f*(fd*(8*C*(20*r*s - 13*r + 20*s**2 - 23*s + 13) - 54*r**2 - 396*r*s + 286*r - 342*s**2 + 430*s - 259) + fdd*(-8*C*(24*r*s - 17*r + 24*s**2 - 29*s + 17) + 90*r**2 + 380*r*s - 290*r + 290*s**2 - 390*s + 245)) + 2*fd**2*(45*r**2 + r*(-96*C*s + 68*C + 190*s - 145) + s*(-96*C*s + 116*C + 145*s - 195))) + 2*D1*f*(Dd*(40*C*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - 9*f*(6*r**2 + 2*r*(22*s - 7) + 38*s**2 - 30*s + 11) + 4*fd*(2*r + 2*s - 1)*(-96*C*s + 46*C + 45*r + 145*s - 85)) + Ddd*f*(-48*C*(4*r*s - r + 4*s**2 - 3*s + 1) + 90*r**2 + 380*r*s - 140*r + 290*s**2 - 240*s + 95)) - 2*Dd**2*f**2*(48*C*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) - 270*r**2 - 60*r*(19*s - 7) - 870*s**2 + 720*s - 95)) + f*(252*D1**2*bd1**2*(2*C - 5)*(2*s - 1)*(r + s - 1) + 9*D1**2*bdd1*f*(r + s - 1)*(-8*C*(12*s + 5) + 45*r + 145*s + 55) + 5*D1**2*(f*(fd*(152*C*(3*r*s - r + 3*s**2 - 3*s + 1) - 159*r**2 - 1206*r*s + 508*r - 1047*s**2 + 1100*s - 402) + fdd*(-184*C*(3*r*s - r + 3*s**2 - 3*s + 1) + 201*r**2 + 1170*r*s - 524*r + 969*s**2 - 1036*s + 390)) - 2*fd**2*(92*C*(6*r*s - 2*r + 6*s**2 - 6*s + 1) - 201*r**2 - 1170*r*s + 524*r - 969*s**2 + 1036*s - 195)) + 9*D1*bd1*(-8*C*Dd*f*(r*(96*s + 8) + 96*s**2 - 64*s + 2) + D1*f*(r + s - 1)*(8*C*(10*s + 3) - 27*r - 171*s - 61) + 2*D1*fd*(-4*C*(r*(48*s - 7) + 48*s**2 - 43*s + 12) + 90*r**2 + 5*r*(76*s - 27) + 290*s**2 - 285*s + 95) + 40*Dd*f*(9*r**2 + r*(38*s - 6) + 29*s**2 - 21*s + 2)) + 10*D1*f*(Dd*(f*(76*C*(4*r*s - r + 4*s**2 - 3*s + 1) - 106*r**2 - 804*r*s + 254*r - 698*s**2 + 550*s - 201) + 2*fd*(-46*C*(24*r*s - 7*r + 24*s**2 - 21*s + 4) + 402*r**2 + 2340*r*s - 917*r + 1938*s**2 - 1813*s + 390)) + Ddd*f*(-92*C*(4*r*s - r + 4*s**2 - 3*s + 1) + 134*r**2 + 780*r*s - 262*r + 646*s**2 - 518*s + 195)) + 10*Dd**2*f**2*(-92*C*(12*r*s - 3*r + 12*s**2 - 9*s + 1) + 402*r**2 + 2340*r*s - 786*r + 1938*s**2 - 1554*s + 195)))/(315*d**2*k2*k3**4) + 8*D1**2*Pk1*Pk2*ct**3*k1**3*st**2*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2**3*k3**2) + 2*D1**2*Pk1*Pk2*ct**3*k1**3*(126*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 9*b1*(-14*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 98*D1**2*f*fd*s**2 + 138*D1**2*f*fd*s - 69*D1**2*f*fd + 70*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 45*D1**2*f*fdd + 70*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 196*D1*Dd*f**2*s**2 + 98*D1*Dd*f**2*s - 49*D1*Dd*f**2 + 560*D1*Dd*f*fd*s**2 - 500*D1*Dd*f*fd*s + 90*D1*Dd*f*fd + 140*D1*Ddd*f**2*s**2 - 70*D1*Ddd*f**2*s + 35*D1*Ddd*f**2 + 28*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 420*Dd**2*f**2*s**2 - 210*Dd**2*f**2*s) + f*(-252*D1**2*bd1**2*s*(s - 1) + 45*D1**2*bdd1*f*(7*s**2 + 4*s - 2) + 5*D1**2*(-f*(91*fd - 59*fdd)*(3*s**2 - 2*s + 1) + 118*fd**2*s*(3*s - 2)) - 9*D1*bd1*(D1*f*(49*s**2 + 40*s - 20) + 10*D1*fd*s*(5 - 14*s) - 10*Dd*f*(28*s**2 + s - 2)) + 5*D1*f*(-91*Dd*f*(4*s**2 - 2*s + 1) + 118*Dd*fd*(12*s**2 - 7*s + 1) + 59*Ddd*f*(4*s**2 - 2*s + 1)) + 1770*Dd**2*f**2*s*(2*s - 1)))/(315*d**2*k2**3*k3**2) - 4*D1**2*Pk1*Pk2*ct**3*k1*k2**3*st**4*(312*C*D1**2*b1*f*fd*r**2 + 624*C*D1**2*b1*f*fd*r*s - 312*C*D1**2*b1*f*fd*r + 312*C*D1**2*b1*f*fd*s**2 - 312*C*D1**2*b1*f*fd*s + 156*C*D1**2*b1*f*fd - 240*C*D1**2*b1*f*fdd*r**2 - 480*C*D1**2*b1*f*fdd*r*s + 240*C*D1**2*b1*f*fdd*r - 240*C*D1**2*b1*f*fdd*s**2 + 240*C*D1**2*b1*f*fdd*s - 120*C*D1**2*b1*f*fdd - 240*C*D1**2*b1*fd**2*r**2 - 480*C*D1**2*b1*fd**2*r*s + 240*C*D1**2*b1*fd**2*r - 240*C*D1**2*b1*fd**2*s**2 + 240*C*D1**2*b1*fd**2*s + 204*C*D1**2*f**2*fd*r**2 + 408*C*D1**2*f**2*fd*r*s - 272*C*D1**2*f**2*fd*r + 204*C*D1**2*f**2*fd*s**2 - 272*C*D1**2*f**2*fd*s + 136*C*D1**2*f**2*fd - 120*C*D1**2*f**2*fdd*r**2 - 240*C*D1**2*f**2*fdd*r*s + 160*C*D1**2*f**2*fdd*r - 120*C*D1**2*f**2*fdd*s**2 + 160*C*D1**2*f**2*fdd*s - 80*C*D1**2*f**2*fdd - 240*C*D1**2*f*fd**2*r**2 - 480*C*D1**2*f*fd**2*r*s + 320*C*D1**2*f*fd**2*r - 240*C*D1**2*f*fd**2*s**2 + 320*C*D1**2*f*fd**2*s - 80*C*D1**2*f*fd**2 + 624*C*D1*Dd*b1*f**2*r**2 + 1248*C*D1*Dd*b1*f**2*r*s - 624*C*D1*Dd*b1*f**2*r + 624*C*D1*Dd*b1*f**2*s**2 - 624*C*D1*Dd*b1*f**2*s + 312*C*D1*Dd*b1*f**2 - 1920*C*D1*Dd*b1*f*fd*r**2 - 3840*C*D1*Dd*b1*f*fd*r*s + 1920*C*D1*Dd*b1*f*fd*r - 1920*C*D1*Dd*b1*f*fd*s**2 + 1920*C*D1*Dd*b1*f*fd*s - 480*C*D1*Dd*b1*f*fd + 272*C*D1*Dd*f**3*r**2 + 544*C*D1*Dd*f**3*r*s - 272*C*D1*Dd*f**3*r + 272*C*D1*Dd*f**3*s**2 - 272*C*D1*Dd*f**3*s + 136*C*D1*Dd*f**3 - 960*C*D1*Dd*f**2*fd*r**2 - 1920*C*D1*Dd*f**2*fd*r*s + 1120*C*D1*Dd*f**2*fd*r - 960*C*D1*Dd*f**2*fd*s**2 + 1120*C*D1*Dd*f**2*fd*s - 320*C*D1*Dd*f**2*fd - 480*C*D1*Ddd*b1*f**2*r**2 - 960*C*D1*Ddd*b1*f**2*r*s + 480*C*D1*Ddd*b1*f**2*r - 480*C*D1*Ddd*b1*f**2*s**2 + 480*C*D1*Ddd*b1*f**2*s - 240*C*D1*Ddd*b1*f**2 - 160*C*D1*Ddd*f**3*r**2 - 320*C*D1*Ddd*f**3*r*s + 160*C*D1*Ddd*f**3*r - 160*C*D1*Ddd*f**3*s**2 + 160*C*D1*Ddd*f**3*s - 80*C*D1*Ddd*f**3 - 1440*C*Dd**2*b1*f**2*r**2 - 2880*C*Dd**2*b1*f**2*r*s + 1440*C*Dd**2*b1*f**2*r - 1440*C*Dd**2*b1*f**2*s**2 + 1440*C*Dd**2*b1*f**2*s - 240*C*Dd**2*b1*f**2 - 480*C*Dd**2*f**3*r**2 - 960*C*Dd**2*f**3*r*s + 480*C*Dd**2*f**3*r - 480*C*Dd**2*f**3*s**2 + 480*C*Dd**2*f**3*s - 80*C*Dd**2*f**3 - 492*D1**2*b1*f*fd*r**2 - 984*D1**2*b1*f*fd*r*s + 492*D1**2*b1*f*fd*r - 492*D1**2*b1*f*fd*s**2 + 492*D1**2*b1*f*fd*s - 246*D1**2*b1*f*fd + 330*D1**2*b1*f*fdd*r**2 + 660*D1**2*b1*f*fdd*r*s - 330*D1**2*b1*f*fdd*r + 330*D1**2*b1*f*fdd*s**2 - 330*D1**2*b1*f*fdd*s + 165*D1**2*b1*f*fdd + 330*D1**2*b1*fd**2*r**2 + 660*D1**2*b1*fd**2*r*s - 330*D1**2*b1*fd**2*r + 330*D1**2*b1*fd**2*s**2 - 330*D1**2*b1*fd**2*s - 15*D1**2*bdd1*f**2*(8*C - 11)*(r + s - 1)**2 - 294*D1**2*f**2*fd*r**2 - 588*D1**2*f**2*fd*r*s + 392*D1**2*f**2*fd*r - 294*D1**2*f**2*fd*s**2 + 392*D1**2*f**2*fd*s - 196*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 220*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 220*D1**2*f**2*fdd*s + 110*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 440*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 440*D1**2*f*fd**2*s + 110*D1**2*f*fd**2 - 984*D1*Dd*b1*f**2*r**2 - 1968*D1*Dd*b1*f**2*r*s + 984*D1*Dd*b1*f**2*r - 984*D1*Dd*b1*f**2*s**2 + 984*D1*Dd*b1*f**2*s - 492*D1*Dd*b1*f**2 + 2640*D1*Dd*b1*f*fd*r**2 + 5280*D1*Dd*b1*f*fd*r*s - 2640*D1*Dd*b1*f*fd*r + 2640*D1*Dd*b1*f*fd*s**2 - 2640*D1*Dd*b1*f*fd*s + 660*D1*Dd*b1*f*fd - 392*D1*Dd*f**3*r**2 - 784*D1*Dd*f**3*r*s + 392*D1*Dd*f**3*r - 392*D1*Dd*f**3*s**2 + 392*D1*Dd*f**3*s - 196*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1540*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1540*D1*Dd*f**2*fd*s + 440*D1*Dd*f**2*fd + 660*D1*Ddd*b1*f**2*r**2 + 1320*D1*Ddd*b1*f**2*r*s - 660*D1*Ddd*b1*f**2*r + 660*D1*Ddd*b1*f**2*s**2 - 660*D1*Ddd*b1*f**2*s + 330*D1*Ddd*b1*f**2 + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 220*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 220*D1*Ddd*f**3*s + 110*D1*Ddd*f**3 + 6*D1*bd1*f*(r + s - 1)*(D1*f*(26*C - 41)*(r + s - 1) - D1*fd*(40*C - 55)*(2*r + 2*s - 1) - Dd*f*(80*C - 110)*(2*r + 2*s - 1)) + 1980*Dd**2*b1*f**2*r**2 + 3960*Dd**2*b1*f**2*r*s - 1980*Dd**2*b1*f**2*r + 1980*Dd**2*b1*f**2*s**2 - 1980*Dd**2*b1*f**2*s + 330*Dd**2*b1*f**2 + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 660*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 660*Dd**2*f**3*s + 110*Dd**2*f**3)/(105*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**3*k1*k2**3*st**2*(21*b1**2*(D1**2*(r + s)**2*(fd*(14*C - 20) + fdd*(15 - 12*C)) + 4*D1*Dd*(f*(7*C - 10)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(12*C - 15)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - D1*Ddd*f*(24*C - 30)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd**2*f*(24*C - 30)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 3*b1*(-280*C*D1**2*f*fd*r**2 - 560*C*D1**2*f*fd*r*s + 280*C*D1**2*f*fd*r - 280*C*D1**2*f*fd*s**2 + 280*C*D1**2*f*fd*s - 140*C*D1**2*f*fd + 168*C*D1**2*f*fdd*r**2 + 336*C*D1**2*f*fdd*r*s - 168*C*D1**2*f*fdd*r + 168*C*D1**2*f*fdd*s**2 - 168*C*D1**2*f*fdd*s + 84*C*D1**2*f*fdd + 168*C*D1**2*fd**2*r**2 + 336*C*D1**2*fd**2*r*s - 168*C*D1**2*fd**2*r + 168*C*D1**2*fd**2*s**2 - 168*C*D1**2*fd**2*s - 560*C*D1*Dd*f**2*r**2 - 1120*C*D1*Dd*f**2*r*s + 560*C*D1*Dd*f**2*r - 560*C*D1*Dd*f**2*s**2 + 560*C*D1*Dd*f**2*s - 280*C*D1*Dd*f**2 + 1344*C*D1*Dd*f*fd*r**2 + 2688*C*D1*Dd*f*fd*r*s - 1344*C*D1*Dd*f*fd*r + 1344*C*D1*Dd*f*fd*s**2 - 1344*C*D1*Dd*f*fd*s + 336*C*D1*Dd*f*fd + 336*C*D1*Ddd*f**2*r**2 + 672*C*D1*Ddd*f**2*r*s - 336*C*D1*Ddd*f**2*r + 336*C*D1*Ddd*f**2*s**2 - 336*C*D1*Ddd*f**2*s + 168*C*D1*Ddd*f**2 + 1008*C*Dd**2*f**2*r**2 + 2016*C*Dd**2*f**2*r*s - 1008*C*Dd**2*f**2*r + 1008*C*Dd**2*f**2*s**2 - 1008*C*Dd**2*f**2*s + 168*C*Dd**2*f**2 - 42*D1**2*bdd1*f*(4*C - 5)*(r + s - 1)**2 - 116*D1**2*f*fd*r**2 - 232*D1**2*f*fd*r*s + 116*D1**2*f*fd*r - 116*D1**2*f*fd*s**2 + 116*D1**2*f*fd*s - 58*D1**2*f*fd + 198*D1**2*f*fdd*r**2 + 396*D1**2*f*fdd*r*s - 198*D1**2*f*fdd*r + 198*D1**2*f*fdd*s**2 - 198*D1**2*f*fdd*s + 99*D1**2*f*fdd + 198*D1**2*fd**2*r**2 + 396*D1**2*fd**2*r*s - 198*D1**2*fd**2*r + 198*D1**2*fd**2*s**2 - 198*D1**2*fd**2*s - 232*D1*Dd*f**2*r**2 - 464*D1*Dd*f**2*r*s + 232*D1*Dd*f**2*r - 232*D1*Dd*f**2*s**2 + 232*D1*Dd*f**2*s - 116*D1*Dd*f**2 + 1584*D1*Dd*f*fd*r**2 + 3168*D1*Dd*f*fd*r*s - 1584*D1*Dd*f*fd*r + 1584*D1*Dd*f*fd*s**2 - 1584*D1*Dd*f*fd*s + 396*D1*Dd*f*fd + 396*D1*Ddd*f**2*r**2 + 792*D1*Ddd*f**2*r*s - 396*D1*Ddd*f**2*r + 396*D1*Ddd*f**2*s**2 - 396*D1*Ddd*f**2*s + 198*D1*Ddd*f**2 + 28*D1*bd1*(r + s - 1)*(D1*f*(7*C - 10)*(r + s - 1) - D1*fd*(12*C - 15)*(r + s) - Dd*f*(24*C - 30)*(2*r + 2*s - 1)) + 1188*Dd**2*f**2*r**2 + 2376*Dd**2*f**2*r*s - 1188*Dd**2*f**2*r + 1188*Dd**2*f**2*s**2 - 1188*Dd**2*f**2*s + 198*Dd**2*f**2) + f*(-126*D1**2*bd1**2*(4*C - 5)*(r + s - 1)**2 + 9*D1**2*bdd1*f*(28*C + 33)*(r + s - 1)**2 - 2*D1**2*(f*(fd*(173*C + 9) - fdd*(100*C + 45))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(-200*C - 90)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 6*D1*bd1*(r + s - 1)*(D1*f*(70*C + 29)*(r + s - 1) - D1*fd*(84*C + 99)*(2*r + 2*s - 1) - Dd*f*(168*C + 198)*(2*r + 2*s - 1)) - 4*D1*f*(Dd*(f*(173*C + 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(200*C + 90)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Ddd*f*(-100*C - 45)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd**2*f**2*(400*C + 180)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(315*d**2*k3**6) + 4*D1**2*Pk1*Pk2*ct**3*k1*k2**3*(-3*D1*f*(28*D1*bd1**2*(4*C + 3)*(r + s - 1)**2 - bd1*(r + s - 1)*(D1*f*(52*C - 17)*(r + s - 1) - D1*fd*(80*C + 60)*(2*r + 2*s - 1) - Dd*f*(160*C + 120)*(2*r + 2*s - 1)) + 5*f*(2*D1*bdd1*(4*C + 3)*(r + s - 1)**2 + (4*C + 1)*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))) + 14*b1**2*(D1**2*(r + s)**2*(fd*(24*C - 7) - fdd*(12*C + 9)) + 2*D1*(Dd*(f*(24*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(24*C + 18)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(-12*C - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(24*C + 18)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-84*D1**2*bdd1*f*(4*C + 3)*(r + s - 1)**2 - 3*D1**2*(-f*(fd*(52*C - 17) - fdd*(40*C + 30))*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd**2*(80*C + 60)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 28*D1*bd1*(r + s - 1)*(D1*f*(24*C - 7)*(r + s - 1) - D1*fd*(24*C + 18)*(r + s) - Dd*f*(48*C + 36)*(2*r + 2*s - 1)) + 6*D1*f*(Dd*(f*(52*C - 17)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(-80*C - 60)*(2*r + 2*s - 1)**2) + Ddd*f*(-40*C - 30)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 3*Dd**2*f**2*(80*C + 60)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(105*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**3*k1*k2*st**4*(b1*(D1**2*(f*(fd*(46*C - 76) + fdd*(45 - 30*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(45 - 30*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(46*C - 76)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(45 - 30*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(45 - 30*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(45 - 30*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(18*C - 28)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (10*C - 15)*(3*bdd1*s*(r + s - 1) + fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(15 - 10*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(46*C - 76)*(r + s - 1) - fd*(30*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(45 - 30*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(18*C - 28)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(10*C - 15)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(15 - 10*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(15 - 10*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(35*d**2*k3**4) - 2*D1**2*Pk1*Pk2*ct**3*k1*k2*st**2*(84*b1**2*(D1**2*s*(r + s)*(fd*(13*C - 19) + fdd*(12 - 9*C)) + D1*(Dd*(f*(13*C - 19)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(9*C - 12)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(12 - 9*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(9*C - 12)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 3*b1*(-740*C*D1**2*f*fd*r**2 - 3088*C*D1**2*f*fd*r*s + 1732*C*D1**2*f*fd*r - 2348*C*D1**2*f*fd*s**2 + 2536*C*D1**2*f*fd*s - 1362*C*D1**2*f*fd + 636*C*D1**2*f*fdd*r**2 + 2496*C*D1**2*f*fdd*r*s - 1356*C*D1**2*f*fdd*r + 1860*C*D1**2*f*fdd*s**2 - 1968*C*D1**2*f*fdd*s + 1038*C*D1**2*f*fdd + 636*C*D1**2*fd**2*r**2 + 2496*C*D1**2*fd**2*r*s - 1356*C*D1**2*fd**2*r + 1860*C*D1**2*fd**2*s**2 - 1968*C*D1**2*fd**2*s - 1480*C*D1*Dd*f**2*r**2 - 6176*C*D1*Dd*f**2*r*s + 2284*C*D1*Dd*f**2*r - 4696*C*D1*Dd*f**2*s**2 + 3892*C*D1*Dd*f**2*s - 1544*C*D1*Dd*f**2 + 5088*C*D1*Dd*f*fd*r**2 + 19968*C*D1*Dd*f*fd*r*s - 9192*C*D1*Dd*f*fd*r + 14880*C*D1*Dd*f*fd*s**2 - 14088*C*D1*Dd*f*fd*s + 3324*C*D1*Dd*f*fd + 1272*C*D1*Ddd*f**2*r**2 + 4992*C*D1*Ddd*f**2*r*s - 1884*C*D1*Ddd*f**2*r + 3720*C*D1*Ddd*f**2*s**2 - 3108*C*D1*Ddd*f**2*s + 1248*C*D1*Ddd*f**2 + 3816*C*Dd**2*f**2*r**2 + 14976*C*Dd**2*f**2*r*s - 5652*C*Dd**2*f**2*r + 11160*C*Dd**2*f**2*s**2 - 9324*C*Dd**2*f**2*s + 1248*C*Dd**2*f**2 - 84*D1**2*bdd1*f*(3*C - 4)*(2*s - 1)*(r + s - 1) + 1142*D1**2*f*fd*r**2 + 2644*D1**2*f*fd*r*s - 1582*D1**2*f*fd*r + 1502*D1**2*f*fd*s**2 - 1762*D1**2*f*fd*s + 1011*D1**2*f*fd - 1026*D1**2*f*fdd*r**2 - 2316*D1**2*f*fdd*r*s + 1302*D1**2*f*fdd*r - 1290*D1**2*f*fdd*s**2 + 1434*D1**2*f*fdd*s - 789*D1**2*f*fdd - 1026*D1**2*fd**2*r**2 - 2316*D1**2*fd**2*r*s + 1302*D1**2*fd**2*r - 1290*D1**2*fd**2*s**2 + 1434*D1**2*fd**2*s + 2284*D1*Dd*f**2*r**2 + 5288*D1*Dd*f**2*r*s - 2464*D1*Dd*f**2*r + 3004*D1*Dd*f**2*s**2 - 2824*D1*Dd*f**2*s + 1322*D1*Dd*f**2 - 8208*D1*Dd*f*fd*r**2 - 18528*D1*Dd*f*fd*r*s + 9576*D1*Dd*f*fd*r - 10320*D1*Dd*f*fd*s**2 + 10632*D1*Dd*f*fd*s - 2736*D1*Dd*f*fd - 2052*D1*Ddd*f**2*r**2 - 4632*D1*Ddd*f**2*r*s + 2184*D1*Ddd*f**2*r - 2580*D1*Ddd*f**2*s**2 + 2448*D1*Ddd*f**2*s - 1158*D1*Ddd*f**2 + 28*D1*bd1*(D1*(f*(13*C - 19)*(2*s - 1)*(r + s - 1) - fd*(9*C - 12)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(24 - 18*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 6156*Dd**2*f**2*r**2 - 13896*Dd**2*f**2*r*s + 6552*Dd**2*f**2*r - 7740*Dd**2*f**2*s**2 + 7344*Dd**2*f**2*s - 1158*Dd**2*f**2) + f*(-2322*C*D1**2*f*fd*r**2 - 8892*C*D1**2*f*fd*r*s + 4512*C*D1**2*f*fd*r - 6570*C*D1**2*f*fd*s**2 + 7344*C*D1**2*f*fd*s - 2964*C*D1**2*f*fd + 1782*C*D1**2*f*fdd*r**2 + 6444*C*D1**2*f*fdd*r*s - 3336*C*D1**2*f*fdd*r + 4662*C*D1**2*f*fdd*s**2 - 5256*C*D1**2*f*fdd*s + 2148*C*D1**2*f*fdd + 3564*C*D1**2*fd**2*r**2 + 12888*C*D1**2*fd**2*r*s - 6672*C*D1**2*fd**2*r + 9324*C*D1**2*fd**2*s**2 - 10512*C*D1**2*fd**2*s + 2148*C*D1**2*fd**2 - 3096*C*D1*Dd*f**2*r**2 - 11856*C*D1*Dd*f**2*r*s + 4512*C*D1*Dd*f**2*r - 8760*C*D1*Dd*f**2*s**2 + 7344*C*D1*Dd*f**2*s - 2964*C*D1*Dd*f**2 + 14256*C*D1*Dd*f*fd*r**2 + 51552*C*D1*Dd*f*fd*r*s - 23352*C*D1*Dd*f*fd*r + 37296*C*D1*Dd*f*fd*s**2 - 36792*C*D1*Dd*f*fd*s + 8592*C*D1*Dd*f*fd + 2376*C*D1*Ddd*f**2*r**2 + 8592*C*D1*Ddd*f**2*r*s - 3336*C*D1*Ddd*f**2*r + 6216*C*D1*Ddd*f**2*s**2 - 5256*C*D1*Ddd*f**2*s + 2148*C*D1*Ddd*f**2 + 7128*C*Dd**2*f**2*r**2 + 25776*C*Dd**2*f**2*r*s - 10008*C*Dd**2*f**2*r + 18648*C*Dd**2*f**2*s**2 - 15768*C*Dd**2*f**2*s + 2148*C*Dd**2*f**2 - 252*D1**2*bd1**2*(3*C - 4)*(2*s - 1)*(r + s - 1) + 9*D1**2*bdd1*f*(r + s - 1)*(2*C*(53*r + 155*s - 35) - 171*r - 215*s + 123) + 3843*D1**2*f*fd*r**2 + 8058*D1**2*f*fd*r*s - 5248*D1**2*f*fd*r + 4215*D1**2*f*fd*s**2 - 5496*D1**2*f*fd*s + 2686*D1**2*f*fd - 3069*D1**2*f*fdd*r**2 - 6270*D1**2*f*fdd*r*s + 4136*D1**2*f*fdd*r - 3201*D1**2*f*fdd*s**2 + 4224*D1**2*f*fdd*s - 2090*D1**2*f*fdd - 6138*D1**2*fd**2*r**2 - 12540*D1**2*fd**2*r*s + 8272*D1**2*fd**2*r - 6402*D1**2*fd**2*s**2 + 8448*D1**2*fd**2*s - 2090*D1**2*fd**2 + 5124*D1*Dd*f**2*r**2 + 10744*D1*Dd*f**2*r*s - 5248*D1*Dd*f**2*r + 5620*D1*Dd*f**2*s**2 - 5496*D1*Dd*f**2*s + 2686*D1*Dd*f**2 - 24552*D1*Dd*f*fd*r**2 - 50160*D1*Dd*f*fd*r*s + 28952*D1*Dd*f*fd*r - 25608*D1*Dd*f*fd*s**2 + 29568*D1*Dd*f*fd*s - 8360*D1*Dd*f*fd - 4092*D1*Ddd*f**2*r**2 - 8360*D1*Ddd*f**2*r*s + 4136*D1*Ddd*f**2*r - 4268*D1*Ddd*f**2*s**2 + 4224*D1*Ddd*f**2*s - 2090*D1*Ddd*f**2 - 3*D1*bd1*(-12*C*Dd*f*(212*r**2 + r*(832*s - 333) + 620*s**2 - 639*s + 139) + D1*f*(r + s - 1)*(2*C*(185*r + 587*s - 91) - 571*r - 751*s + 311) - 6*D1*fd*(C*(212*r**2 + 832*r*s - 402*r + 620*s**2 - 708*s + 208) - 342*r**2 - 772*r*s + 511*r - 430*s**2 + 577*s - 193) + 24*Dd*f*(171*r**2 + r*(386*s - 238) + 215*s**2 - 271*s + 79)) - 12276*Dd**2*f**2*r**2 - 25080*Dd**2*f**2*r*s + 12408*Dd**2*f**2*r - 12804*Dd**2*f**2*s**2 + 12672*Dd**2*f**2*s - 2090*Dd**2*f**2))/(315*d**2*k3**4) + D1**2*Pk1*Pk2*ct**3*k1*k2*(7*b1**2*(D1**2*(r + s)*(fd*r*(100*C - 141) + fd*s*(164*C - 201) + fdd*r*(143 - 100*C) + fdd*s*(203 - 172*C)) + 2*D1*(Dd*(f*(4*C*(50*r**2 + 2*r*(66*s - 29) + 82*s**2 - 74*s + 33) - 282*r**2 - 12*r*(57*s - 26) - 402*s**2 + 372*s - 171) - 4*fd*(r**2*(100*C - 143) + r*(272*C*s - 59*C - 346*s + 79) + s*(172*C*s - 77*C - 203*s + 94))) + Ddd*f*(-4*C*(50*r**2 + 136*r*s - 59*r + 86*s**2 - 77*s + 34) + 286*r**2 + 692*r*s - 316*r + 406*s**2 - 376*s + 173)) - 2*Dd**2*f*(4*C*(150*r**2 + 3*r*(136*s - 59) + 258*s**2 - 231*s + 34) - 858*r**2 + r*(948 - 2076*s) - 1218*s**2 + 1128*s - 173)) + 2*b1*(-7*D1**2*bdd1*f*(r + s - 1)*(4*C*(25*r + 43*s - 34) - 143*r - 203*s + 173) + 3*D1**2*(f*(fd*(16*C*(6*r**2 + r - 6*s**2 + 7*s - 4) - 282*r**2 - 756*r*s + 392*r - 474*s**2 + 488*s - 251) + fdd*(-12*C*(4*r**2 + 3*r - 4*s**2 + 7*s - 5) + 302*r**2 + 756*r*s - 364*r + 454*s**2 - 440*s + 213)) - 2*fd**2*(r**2*(24*C - 151) + 2*r*(9*C - 189*s + 91) + s*(-24*C*s + 42*C - 227*s + 220))) + 7*D1*bd1*(D1*(f*(r + s - 1)*(4*C*(25*r + 41*s - 33) - 141*r - 201*s + 171) + 2*fd*(r**2*(143 - 100*C) - 2*r*(136*C*s - 59*C - 173*s + 79) + s*(-172*C*s + 154*C + 203*s - 188))) - 4*Dd*f*(2*C*(100*r**2 + 272*r*s - 177*r + 172*s**2 - 231*s + 68) - 286*r**2 - 692*r*s + 474*r - 406*s**2 + 564*s - 173)) + 6*D1*f*(Dd*(3*f*(r**2*(32*C - 94) - 2*r*(8*C + 126*s - 55) - s**2*(32*C + 158) + s*(16*C + 142) - 63) - 2*fd*(2*r + 2*s - 1)*(6*C*(8*r - 8*s + 5) - 302*r - 454*s + 201)) + Ddd*f*(r**2*(302 - 48*C) + 4*r*(6*C + 189*s - 85) + s**2*(48*C + 454) - s*(24*C + 416) + 189)) - 18*Dd**2*f**2*(r**2*(48*C - 302) - 4*r*(6*C + 189*s - 85) - s**2*(48*C + 454) + s*(24*C + 416) - 63)) + f*(-14*D1**2*bd1**2*(r + s - 1)*(4*C*(25*r + 43*s - 34) - 143*r - 203*s + 173) - 6*D1**2*bdd1*f*(r + s - 1)*(12*C*(2*r - 2*s - 5) - 151*r - 227*s + 165) - 5*D1**2*(f*(fd*(4*C*(69*r**2 + 6*r*(31*s - 18) + 117*s**2 - 140*s + 62) - 75*r**2 + 126*r*s + 8*r + 201*s**2 - 176*s + 42) - fdd*(4*C*(57*r**2 + 156*r*s - 90*r + 99*s**2 - 118*s + 52) + 39*r**2 + 234*r*s - 104*r + 195*s**2 - 208*s + 78)) - 2*fd**2*(4*C*(57*r**2 + 156*r*s - 90*r + 99*s**2 - 118*s + 26) + 39*r**2 + 234*r*s - 104*r + 195*s**2 - 208*s + 39)) + 6*D1*bd1*(D1*(f*(r + s - 1)*(16*C*(3*r - 3*s - 4) - 141*r - 237*s + 127) + 2*fd*(r**2*(302 - 48*C) + 6*r*(11*C + 126*s - 83) + s**2*(48*C + 454) - s*(6*C + 612) + 189)) - 4*Dd*f*(6*C*(8*r**2 - 16*r - 8*s**2 - 4*s + 5) - 302*r**2 - 54*r*(14*s - 9) - 454*s**2 + 600*s - 177)) - 10*D1*f*(-4*C*Ddd*f*(38*r**2 + r*(104*s - 45) + 66*s**2 - 59*s + 26) + Dd*f*(4*C*(46*r**2 + 124*r*s - 54*r + 78*s**2 - 70*s + 31) - 50*r**2 + 84*r*s + 4*r + 134*s**2 - 88*s + 21) - 4*Dd*fd*(C*(228*r**2 + 624*r*s - 315*r + 396*s**2 - 413*s + 104) + 39*r**2 + 234*r*s - 91*r + 195*s**2 - 182*s + 39) - 13*Ddd*f*(2*r**2 + 4*r*(3*s - 1) + 10*s**2 - 8*s + 3)) + 10*Dd**2*f**2*(4*C*(114*r**2 + 312*r*s - 135*r + 198*s**2 - 177*s + 26) + 78*r**2 + 468*r*s - 156*r + 390*s**2 - 312*s + 39)))/(105*d**2*k3**4) - D1**2*Pk1*Pk2*ct**3*k1*st**4*(16*C - 28)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k2*k3**2) + 8*D1**2*Pk1*Pk2*ct**3*k1*st**2*(99*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + 11*b1*(D1**2*(10*f**2*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + f*(-100*fd**2*s*(3*s - 2) - 18*fd*(s**2*(20*bd1 - 6) + s*(6 - 10*bd1) - 3) + 9*fdd*(-6*s**2 + 6*s - 3) + 9*s**2*(28*bd1 - 14*bdd1)) - 18*fd*s*(14*bd1 + 3*fd)*(s - 1)) + D1*f*(2*Dd*(50*f**2*(4*s**2 - 2*s + 1) + f*(-50*fd*(12*s**2 - 7*s + 1) + 9*s**2*(12 - 40*bd1) + 9*s*(10*bd1 - 6) + 27) - (36*s - 9)*(14*bd1*s + fd*(6*s - 3))) - Ddd*f*(50*f + 27)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(50*f + 27)*(2*s - 1)) + f*(D1**2*(-198*bd1*s*(7*bd1*s + fd*(6*s - 3)) + 25*f**2*(14*fd*(4*s**2 - 2*s + 1) - 7*fdd*(4*s**2 - 2*s + 1) + s**2*(44*bd1 - 22*bdd1)) + f*s*(-990*bd1**2*s - 1100*bd1*fd*(3*s - 1) + 594*bd1*s - 297*bdd1*s - 1050*fd**2*(2*s - 1))) + D1*f*(594*Dd*bd1*s*(1 - 4*s) + 350*Dd*f**2*(4*s**2 - 2*s + 1) - 50*Dd*f*(4*s - 1)*(22*bd1*s + 7*fd*(4*s - 1)) - 175*Ddd*f**2*(4*s**2 - 2*s + 1)) + 1050*Dd**2*f**3*s*(1 - 2*s)))/(1155*d**2*k2**3) + 2*D1**2*Pk1*Pk2*ct**3*k1*(42*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + 3*b1**2*(-14*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 222*D1**2*f*fd*s**2 + 462*D1**2*f*fd*s - 231*D1**2*f*fd + 174*D1**2*f*fdd*s**2 - 294*D1**2*f*fdd*s + 147*D1**2*f*fdd + 174*D1**2*fd**2*s**2 - 294*D1**2*fd**2*s - 245*D1**2*fd*s**2 + 658*D1**2*fd*s - 329*D1**2*fd + 175*D1**2*fdd*s**2 - 434*D1**2*fdd*s + 217*D1**2*fdd - 444*D1*Dd*f**2*s**2 + 222*D1*Dd*f**2*s - 111*D1*Dd*f**2 + 1392*D1*Dd*f*fd*s**2 - 1524*D1*Dd*f*fd*s + 294*D1*Dd*f*fd - 980*D1*Dd*f*s**2 + 490*D1*Dd*f*s - 245*D1*Dd*f + 1400*D1*Dd*fd*s**2 - 2086*D1*Dd*fd*s + 434*D1*Dd*fd + 348*D1*Ddd*f**2*s**2 - 174*D1*Ddd*f**2*s + 87*D1*Ddd*f**2 + 700*D1*Ddd*f*s**2 - 350*D1*Ddd*f*s + 175*D1*Ddd*f + 28*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) + 1044*Dd**2*f**2*s**2 - 522*Dd**2*f**2*s + 2100*Dd**2*f*s**2 - 1050*Dd**2*f*s) + b1*(-84*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) + 6*D1**2*bdd1*f*(f*(87*s**2 + 60*s - 30) + 175*s**2 + 42*s - 21) - 2550*D1**2*f**2*fd*s**2 + 1980*D1**2*f**2*fd*s - 990*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*s**2 - 1260*D1**2*f**2*fdd*s + 630*D1**2*f**2*fdd + 3360*D1**2*f*fd**2*s**2 - 2520*D1**2*f*fd**2*s - 1242*D1**2*f*fd*s**2 + 1242*D1**2*f*fd*s - 621*D1**2*f*fd + 810*D1**2*f*fdd*s**2 - 810*D1**2*f*fdd*s + 405*D1**2*f*fdd + 810*D1**2*fd**2*s**2 - 810*D1**2*fd**2*s - 3400*D1*Dd*f**3*s**2 + 1700*D1*Dd*f**3*s - 850*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*s**2 - 8400*D1*Dd*f**2*fd*s + 1260*D1*Dd*f**2*fd - 2484*D1*Dd*f**2*s**2 + 1242*D1*Dd*f**2*s - 621*D1*Dd*f**2 + 6480*D1*Dd*f*fd*s**2 - 4860*D1*Dd*f*fd*s + 810*D1*Dd*f*fd + 2240*D1*Ddd*f**3*s**2 - 1120*D1*Ddd*f**3*s + 560*D1*Ddd*f**3 + 1620*D1*Ddd*f**2*s**2 - 810*D1*Ddd*f**2*s + 405*D1*Ddd*f**2 - 6*D1*bd1*(D1*(3*f**2*(37*s**2 + 40*s - 20) + f*(s**2*(245 - 348*fd) + s*(174*fd + 84) - 42) + 14*fd*s*(28 - 25*s)) - 2*Dd*f*(4*s - 1)*(87*f*s + 30*f + 175*s + 21)) + 6720*Dd**2*f**3*s**2 - 3360*Dd**2*f**3*s + 4860*Dd**2*f**2*s**2 - 2430*Dd**2*f**2*s) + f*(6*D1**2*bd1**2*s*(87*f*s + 60*f + 175*s + 42) - D1*bd1*(D1*(10*f**2*(85*s**2 + 28*s - 14) + 3*f*s*(-280*fd*(4*s - 1) + 207*s) + 810*fd*s*(1 - 2*s)) - 10*Dd*f*(4*s - 1)*(14*f*(8*s + 1) + 81*s)) + 5*f*(D1**2*bdd1*(14*f*(8*s**2 + 2*s - 1) + 81*s**2) - 7*D1**2*(f*(11*fd - 7*fdd)*(4*s**2 - 2*s + 1) + 42*fd**2*s*(1 - 2*s)) - 7*D1*f*(11*Dd*f*(4*s**2 - 2*s + 1) - 14*Dd*fd*(1 - 4*s)**2 - 7*Ddd*f*(4*s**2 - 2*s + 1)) - 294*Dd**2*f**2*s*(1 - 2*s))))/(315*d**2*k2**3) + 4*D1**2*Pk1*Pk2*ct**3*k2**5*st**4*(12*D1**2*b1*f*fd*r**2 + 24*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*r + 12*D1**2*b1*f*fd*s**2 - 12*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fd - 6*D1**2*b1*f*fdd*r**2 - 12*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*r - 6*D1**2*b1*f*fdd*s**2 + 6*D1**2*b1*f*fdd*s - 3*D1**2*b1*f*fdd - 6*D1**2*b1*fd**2*r**2 - 12*D1**2*b1*fd**2*r*s + 6*D1**2*b1*fd**2*r - 6*D1**2*b1*fd**2*s**2 + 6*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 24*D1*Dd*b1*f**2*r**2 + 48*D1*Dd*b1*f**2*r*s - 24*D1*Dd*b1*f**2*r + 24*D1*Dd*b1*f**2*s**2 - 24*D1*Dd*b1*f**2*s + 12*D1*Dd*b1*f**2 - 48*D1*Dd*b1*f*fd*r**2 - 96*D1*Dd*b1*f*fd*r*s + 48*D1*Dd*b1*f*fd*r - 48*D1*Dd*b1*f*fd*s**2 + 48*D1*Dd*b1*f*fd*s - 12*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 28*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s - 8*D1*Dd*f**2*fd - 12*D1*Ddd*b1*f**2*r**2 - 24*D1*Ddd*b1*f**2*r*s + 12*D1*Ddd*b1*f**2*r - 12*D1*Ddd*b1*f**2*s**2 + 12*D1*Ddd*b1*f**2*s - 6*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 6*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 36*Dd**2*b1*f**2*r**2 - 72*Dd**2*b1*f**2*r*s + 36*Dd**2*b1*f**2*r - 36*Dd**2*b1*f**2*s**2 + 36*Dd**2*b1*f**2*s - 6*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 12*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s - 2*Dd**2*f**3)/(7*d**2*k1*k3**6) + 8*D1**2*Pk1*Pk2*ct**3*k2**5*st**2*(-D1*f*(14*D1*bd1**2*(r + s - 1)**2 + bd1*(r + s - 1)*(D1*f*(r + s - 1) + 6*D1*fd*(2*r + 2*s - 1) + 12*Dd*f*(2*r + 2*s - 1)) + 3*f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1))) + 7*b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-14*D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 3*D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - 2*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 48*D1*Dd*f*fd*s - 12*D1*Dd*f*fd - 12*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 + 28*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) - 36*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 36*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s - 6*Dd**2*f**2))/(35*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk2*ct**3*k2**3*st**4*(324*C*D1**2*b1*f*fd*r**2 + 324*C*D1**2*b1*f*fd*r*s - 162*C*D1**2*b1*f*fd*r - 120*C*D1**2*b1*f*fdd*r**2 - 120*C*D1**2*b1*f*fdd*r*s + 60*C*D1**2*b1*f*fdd*r - 120*C*D1**2*b1*fd**2*r**2 - 120*C*D1**2*b1*fd**2*r*s + 60*C*D1**2*b1*fd**2*r + 186*C*D1**2*f**2*fd*r**2 + 186*C*D1**2*f**2*fd*r*s - 186*C*D1**2*f**2*fd*r - 62*C*D1**2*f**2*fd*s + 62*C*D1**2*f**2*fd - 120*C*D1**2*f**2*fdd*r**2 - 120*C*D1**2*f**2*fdd*r*s + 120*C*D1**2*f**2*fdd*r + 40*C*D1**2*f**2*fdd*s - 40*C*D1**2*f**2*fdd - 240*C*D1**2*f*fd**2*r**2 - 240*C*D1**2*f*fd**2*r*s + 240*C*D1**2*f*fd**2*r + 80*C*D1**2*f*fd**2*s - 40*C*D1**2*f*fd**2 + 648*C*D1*Dd*b1*f**2*r**2 + 648*C*D1*Dd*b1*f**2*r*s - 486*C*D1*Dd*b1*f**2*r - 162*C*D1*Dd*b1*f**2*s + 162*C*D1*Dd*b1*f**2 - 960*C*D1*Dd*b1*f*fd*r**2 - 960*C*D1*Dd*b1*f*fd*r*s + 600*C*D1*Dd*b1*f*fd*r + 120*C*D1*Dd*b1*f*fd*s - 60*C*D1*Dd*b1*f*fd + 248*C*D1*Dd*f**3*r**2 + 248*C*D1*Dd*f**3*r*s - 186*C*D1*Dd*f**3*r - 62*C*D1*Dd*f**3*s + 62*C*D1*Dd*f**3 - 960*C*D1*Dd*f**2*fd*r**2 - 960*C*D1*Dd*f**2*fd*r*s + 840*C*D1*Dd*f**2*fd*r + 280*C*D1*Dd*f**2*fd*s - 160*C*D1*Dd*f**2*fd - 240*C*D1*Ddd*b1*f**2*r**2 - 240*C*D1*Ddd*b1*f**2*r*s + 180*C*D1*Ddd*b1*f**2*r + 60*C*D1*Ddd*b1*f**2*s - 60*C*D1*Ddd*b1*f**2 - 160*C*D1*Ddd*f**3*r**2 - 160*C*D1*Ddd*f**3*r*s + 120*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s - 40*C*D1*Ddd*f**3 - 720*C*Dd**2*b1*f**2*r**2 - 720*C*Dd**2*b1*f**2*r*s + 540*C*Dd**2*b1*f**2*r + 180*C*Dd**2*b1*f**2*s - 60*C*Dd**2*b1*f**2 - 480*C*Dd**2*f**3*r**2 - 480*C*Dd**2*f**3*r*s + 360*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s - 40*C*Dd**2*f**3 - 324*D1**2*b1*f*fd*r**2 - 144*D1**2*b1*f*fd*r*s + 72*D1**2*b1*f*fd*r + 180*D1**2*b1*f*fd*s**2 - 180*D1**2*b1*f*fd*s + 90*D1**2*b1*f*fd + 120*D1**2*b1*f*fdd*r**2 + 30*D1**2*b1*f*fdd*r*s - 15*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd + 120*D1**2*b1*fd**2*r**2 + 30*D1**2*b1*fd**2*r*s - 15*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s - 15*D1**2*bdd1*f**2*(r + s - 1)*(4*C*(r - 1) - 4*r + 3*s + 4) - 186*D1**2*f**2*fd*r**2 - 96*D1**2*f**2*fd*r*s + 156*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s**2 - 28*D1**2*f**2*fd*s - 32*D1**2*f**2*fd + 120*D1**2*f**2*fdd*r**2 + 75*D1**2*f**2*fdd*r*s - 105*D1**2*f**2*fdd*r - 45*D1**2*f**2*fdd*s**2 + 5*D1**2*f**2*fdd*s + 25*D1**2*f**2*fdd + 240*D1**2*f*fd**2*r**2 + 150*D1**2*f*fd**2*r*s - 210*D1**2*f*fd**2*r - 90*D1**2*f*fd**2*s**2 + 10*D1**2*f*fd**2*s + 25*D1**2*f*fd**2 - 648*D1*Dd*b1*f**2*r**2 - 288*D1*Dd*b1*f**2*r*s + 396*D1*Dd*b1*f**2*r + 360*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s - 72*D1*Dd*b1*f**2 + 960*D1*Dd*b1*f*fd*r**2 + 240*D1*Dd*b1*f*fd*r*s - 330*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 510*D1*Dd*b1*f*fd*s - 75*D1*Dd*b1*f*fd - 248*D1*Dd*f**3*r**2 - 128*D1*Dd*f**3*r*s + 156*D1*Dd*f**3*r + 120*D1*Dd*f**3*s**2 - 28*D1*Dd*f**3*s - 32*D1*Dd*f**3 + 960*D1*Dd*f**2*fd*r**2 + 600*D1*Dd*f**2*fd*r*s - 735*D1*Dd*f**2*fd*r - 360*D1*Dd*f**2*fd*s**2 + 35*D1*Dd*f**2*fd*s + 100*D1*Dd*f**2*fd + 240*D1*Ddd*b1*f**2*r**2 + 60*D1*Ddd*b1*f**2*r*s - 135*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 75*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 160*D1*Ddd*f**3*r**2 + 100*D1*Ddd*f**3*r*s - 105*D1*Ddd*f**3*r - 60*D1*Ddd*f**3*s**2 + 5*D1*Ddd*f**3*s + 25*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(6*f*(r + s - 1)*(9*C*(r - 1) - 9*r + 5*s + 9) - 5*fd*(4*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 16*r**2 - 4*r*s + 17*r + 12*s**2 - 4*s - 1)) - 5*Dd*f*(4*C*(8*r**2 + 8*r*s - 11*r - 5*s + 3) - 32*r**2 - 8*r*s + 41*r + 24*s**2 - s - 9)) + 720*Dd**2*b1*f**2*r**2 + 180*Dd**2*b1*f**2*r*s - 405*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 225*Dd**2*b1*f**2*s + 15*Dd**2*b1*f**2 + 480*Dd**2*f**3*r**2 + 300*Dd**2*f**3*r*s - 315*Dd**2*f**3*r - 180*Dd**2*f**3*s**2 + 15*Dd**2*f**3*s + 25*Dd**2*f**3)/(105*d**2*k1*k3**4) + 2*D1**2*Pk1*Pk2*ct**3*k2**3*st**2*(84*b1**2*(C - 1)*(D1**2*r*(11*fd - 3*fdd)*(r + s) + D1*(Dd*(11*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 3*b1*(-56*C*D1**2*f*fd*r**2 - 56*C*D1**2*f*fd*r*s - 112*C*D1**2*f*fd*r - 140*C*D1**2*f*fd*s + 140*C*D1**2*f*fd - 168*C*D1**2*f*fdd*r**2 - 168*C*D1**2*f*fdd*r*s + 168*C*D1**2*f*fdd*r + 84*C*D1**2*f*fdd*s - 84*C*D1**2*f*fdd - 168*C*D1**2*fd**2*r**2 - 168*C*D1**2*fd**2*r*s + 168*C*D1**2*fd**2*r + 84*C*D1**2*fd**2*s - 112*C*D1*Dd*f**2*r**2 - 112*C*D1*Dd*f**2*r*s + 84*C*D1*Dd*f**2*r + 28*C*D1*Dd*f**2*s - 28*C*D1*Dd*f**2 - 1344*C*D1*Dd*f*fd*r**2 - 1344*C*D1*Dd*f*fd*r*s + 1176*C*D1*Dd*f*fd*r + 504*C*D1*Dd*f*fd*s - 252*C*D1*Dd*f*fd - 336*C*D1*Ddd*f**2*r**2 - 336*C*D1*Ddd*f**2*r*s + 252*C*D1*Ddd*f**2*r + 84*C*D1*Ddd*f**2*s - 84*C*D1*Ddd*f**2 - 1008*C*Dd**2*f**2*r**2 - 1008*C*Dd**2*f**2*r*s + 756*C*Dd**2*f**2*r + 252*C*Dd**2*f**2*s - 84*C*Dd**2*f**2 - 84*D1**2*bdd1*f*(C - 1)*(2*r - 1)*(r + s - 1) - 250*D1**2*f*fd*r**2 - 748*D1**2*f*fd*r*s + 514*D1**2*f*fd*r - 498*D1**2*f*fd*s**2 + 638*D1**2*f*fd*s - 389*D1**2*f*fd + 342*D1**2*f*fdd*r**2 + 780*D1**2*f*fdd*r*s - 474*D1**2*f*fdd*r + 438*D1**2*f*fdd*s**2 - 522*D1**2*f*fdd*s + 303*D1**2*f*fdd + 342*D1**2*fd**2*r**2 + 780*D1**2*fd**2*r*s - 474*D1**2*fd**2*r + 438*D1**2*fd**2*s**2 - 522*D1**2*fd**2*s - 500*D1*Dd*f**2*r**2 - 1496*D1*Dd*f**2*r*s + 624*D1*Dd*f**2*r - 996*D1*Dd*f**2*s**2 + 872*D1*Dd*f**2*s - 374*D1*Dd*f**2 + 2736*D1*Dd*f*fd*r**2 + 6240*D1*Dd*f*fd*r*s - 3360*D1*Dd*f*fd*r + 3504*D1*Dd*f*fd*s**2 - 3744*D1*Dd*f*fd*s + 996*D1*Dd*f*fd + 684*D1*Ddd*f**2*r**2 + 1560*D1*Ddd*f**2*r*s - 732*D1*Ddd*f**2*r + 876*D1*Ddd*f**2*s**2 - 828*D1*Ddd*f**2*s + 390*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(D1*(11*f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 2052*Dd**2*f**2*r**2 + 4680*Dd**2*f**2*r*s - 2196*Dd**2*f**2*r + 2628*Dd**2*f**2*s**2 - 2484*Dd**2*f**2*s + 390*Dd**2*f**2) + f*(-1176*C*D1**2*f*fd*r**2 - 1176*C*D1**2*f*fd*r*s + 1176*C*D1**2*f*fd*r + 392*C*D1**2*f*fd*s - 392*C*D1**2*f*fd + 480*C*D1**2*f*fdd*r**2 + 480*C*D1**2*f*fdd*r*s - 480*C*D1**2*f*fdd*r - 160*C*D1**2*f*fdd*s + 160*C*D1**2*f*fdd + 960*C*D1**2*fd**2*r**2 + 960*C*D1**2*fd**2*r*s - 960*C*D1**2*fd**2*r - 320*C*D1**2*fd**2*s + 160*C*D1**2*fd**2 - 1568*C*D1*Dd*f**2*r**2 - 1568*C*D1*Dd*f**2*r*s + 1176*C*D1*Dd*f**2*r + 392*C*D1*Dd*f**2*s - 392*C*D1*Dd*f**2 + 3840*C*D1*Dd*f*fd*r**2 + 3840*C*D1*Dd*f*fd*r*s - 3360*C*D1*Dd*f*fd*r - 1120*C*D1*Dd*f*fd*s + 640*C*D1*Dd*f*fd + 640*C*D1*Ddd*f**2*r**2 + 640*C*D1*Ddd*f**2*r*s - 480*C*D1*Ddd*f**2*r - 160*C*D1*Ddd*f**2*s + 160*C*D1*Ddd*f**2 + 1920*C*Dd**2*f**2*r**2 + 1920*C*Dd**2*f**2*r*s - 1440*C*Dd**2*f**2*r - 480*C*Dd**2*f**2*s + 160*C*Dd**2*f**2 - 252*D1**2*bd1**2*(C - 1)*(2*r - 1)*(r + s - 1) - 9*D1**2*bdd1*f*(r + s - 1)*(28*C*r - 57*r - 73*s + 29) - 441*D1**2*f*fd*r**2 - 1470*D1**2*f*fd*r*s + 784*D1**2*f*fd*r - 1029*D1**2*f*fd*s**2 + 1176*D1**2*f*fd*s - 490*D1**2*f*fd + 747*D1**2*f*fdd*r**2 + 1626*D1**2*f*fdd*r*s - 1040*D1**2*f*fdd*r + 879*D1**2*f*fdd*s**2 - 1128*D1**2*f*fdd*s + 542*D1**2*f*fdd + 1494*D1**2*fd**2*r**2 + 3252*D1**2*fd**2*r*s - 2080*D1**2*fd**2*r + 1758*D1**2*fd**2*s**2 - 2256*D1**2*fd**2*s + 542*D1**2*fd**2 - 588*D1*Dd*f**2*r**2 - 1960*D1*Dd*f**2*r*s + 784*D1*Dd*f**2*r - 1372*D1*Dd*f**2*s**2 + 1176*D1*Dd*f**2*s - 490*D1*Dd*f**2 + 5976*D1*Dd*f*fd*r**2 + 13008*D1*Dd*f*fd*r*s - 7280*D1*Dd*f*fd*r + 7032*D1*Dd*f*fd*s**2 - 7896*D1*Dd*f*fd*s + 2168*D1*Dd*f*fd + 996*D1*Ddd*f**2*r**2 + 2168*D1*Ddd*f**2*r*s - 1040*D1*Ddd*f**2*r + 1172*D1*Ddd*f**2*s**2 - 1128*D1*Ddd*f**2*s + 542*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r + s - 1)*(28*C*(r - 6) + 125*r + 249*s + 15) + 6*fd*(14*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 114*r**2 - 260*r*s + 165*r - 146*s**2 + 189*s - 65)) + 12*Dd*f*(7*C*(8*r**2 + 8*r*s - 7*r - s + 1) - 114*r**2 - 260*r*s + 147*r - 146*s**2 + 171*s - 47)) + 2988*Dd**2*f**2*r**2 + 6504*Dd**2*f**2*r*s - 3120*Dd**2*f**2*r + 3516*Dd**2*f**2*s**2 - 3384*Dd**2*f**2*s + 542*Dd**2*f**2))/(315*d**2*k1*k3**4) + D1**2*Pk1*Pk2*ct**3*k2**3*(D1*f*(14*D1*bd1**2*(7*r**2 + r*(38*s - 26) + 31*s**2 - 50*s + 19) - 3*bd1*(D1*(f*(r + s - 1)*(r*(88*C - 5) + 27*s + 1) - 2*fd*(8*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 58*r**2 + 148*r*s - 103*r + 90*s**2 - 127*s + 37)) - 4*Dd*f*(4*C*(8*r**2 + 8*r*s - 7*r - s + 1) + 58*r**2 + 148*r*s - 107*r + 90*s**2 - 131*s + 41)) + 3*f*(D1*bdd1*(r + s - 1)*(r*(16*C + 29) + 45*s - 45) + 20*D1*fd*(3*r**2 + 3*r*(s - 1) - s + 1) + 20*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1))) - 7*b1**2*(D1**2*(r + s)*(40*C*fd*r - 11*fd*r + 17*fd*s - 7*fdd*r - 31*fdd*s) + 2*D1*(Dd*(f*(20*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 22*r**2 + 12*r*s + 8*r + 34*s**2 - 20*s + 3) - 2*fd*(14*r**2 + r*(76*s - 13) + s*(62*s - 25))) - Ddd*f*(14*r**2 + r*(76*s - 26) + 62*s**2 - 50*s + 19)) - 2*Dd**2*f*(42*r**2 + 6*r*(38*s - 13) + 186*s**2 - 150*s + 19)) + b1*(14*D1**2*bdd1*f*(7*r**2 + r*(38*s - 26) + 31*s**2 - 50*s + 19) - 3*D1**2*(f*(fd*(88*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 10*r**2 + 44*r*s - 18*r + 54*s**2 - 50*s + 23) - fdd*(16*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 58*r**2 + 148*r*s - 58*r + 90*s**2 - 74*s + 29)) - 2*fd**2*(r**2*(16*C + 29) + r*(16*C*(s - 1) + 74*s - 29) + s*(-8*C + 45*s - 37))) - 14*D1*bd1*(D1*(f*(r + s - 1)*(20*C*(2*r - 1) - 11*r + 17*s - 3) - 2*fd*(7*r**2 + r*(38*s - 13) + s*(31*s - 25))) - 4*Dd*f*(14*r**2 + r*(76*s - 39) + 62*s**2 - 75*s + 19)) - 6*D1*f*(Dd*(f*(44*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 10*r**2 + 44*r*s - 6*r + 54*s**2 - 38*s + 11) - 2*fd*(2*r + 2*s - 1)*(4*C*(8*r - 3) + 58*r + 90*s - 33)) - Ddd*f*(8*C*(4*r**2 + 4*r*s - 3*r - s + 1) + 58*r**2 + 148*r*s - 66*r + 90*s**2 - 82*s + 37)) + 6*Dd**2*f**2*(8*C*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1) + 174*r**2 + 6*r*(74*s - 33) + 270*s**2 - 246*s + 37)))/(105*d**2*k1*k3**4) + 8*D1**2*Pk1*Pk2*ct**2*k1**4*st**2*(6*C*D1**2*b1*f*fd*r**2 + 12*C*D1**2*b1*f*fd*r*s - 6*C*D1**2*b1*f*fd*r + 6*C*D1**2*b1*f*fd*s**2 - 6*C*D1**2*b1*f*fd*s + 3*C*D1**2*b1*f*fd + 18*C*D1**2*b1*f*fdd*r**2 + 36*C*D1**2*b1*f*fdd*r*s - 18*C*D1**2*b1*f*fdd*r + 18*C*D1**2*b1*f*fdd*s**2 - 18*C*D1**2*b1*f*fdd*s + 9*C*D1**2*b1*f*fdd + 18*C*D1**2*b1*fd**2*r**2 + 36*C*D1**2*b1*fd**2*r*s - 18*C*D1**2*b1*fd**2*r + 18*C*D1**2*b1*fd**2*s**2 - 18*C*D1**2*b1*fd**2*s - 3*C*D1**2*f**2*fd*r**2 - 6*C*D1**2*f**2*fd*r*s + 4*C*D1**2*f**2*fd*r - 3*C*D1**2*f**2*fd*s**2 + 4*C*D1**2*f**2*fd*s - 2*C*D1**2*f**2*fd + 15*C*D1**2*f**2*fdd*r**2 + 30*C*D1**2*f**2*fdd*r*s - 20*C*D1**2*f**2*fdd*r + 15*C*D1**2*f**2*fdd*s**2 - 20*C*D1**2*f**2*fdd*s + 10*C*D1**2*f**2*fdd + 30*C*D1**2*f*fd**2*r**2 + 60*C*D1**2*f*fd**2*r*s - 40*C*D1**2*f*fd**2*r + 30*C*D1**2*f*fd**2*s**2 - 40*C*D1**2*f*fd**2*s + 10*C*D1**2*f*fd**2 + 12*C*D1*Dd*b1*f**2*r**2 + 24*C*D1*Dd*b1*f**2*r*s - 12*C*D1*Dd*b1*f**2*r + 12*C*D1*Dd*b1*f**2*s**2 - 12*C*D1*Dd*b1*f**2*s + 6*C*D1*Dd*b1*f**2 + 144*C*D1*Dd*b1*f*fd*r**2 + 288*C*D1*Dd*b1*f*fd*r*s - 144*C*D1*Dd*b1*f*fd*r + 144*C*D1*Dd*b1*f*fd*s**2 - 144*C*D1*Dd*b1*f*fd*s + 36*C*D1*Dd*b1*f*fd - 4*C*D1*Dd*f**3*r**2 - 8*C*D1*Dd*f**3*r*s + 4*C*D1*Dd*f**3*r - 4*C*D1*Dd*f**3*s**2 + 4*C*D1*Dd*f**3*s - 2*C*D1*Dd*f**3 + 120*C*D1*Dd*f**2*fd*r**2 + 240*C*D1*Dd*f**2*fd*r*s - 140*C*D1*Dd*f**2*fd*r + 120*C*D1*Dd*f**2*fd*s**2 - 140*C*D1*Dd*f**2*fd*s + 40*C*D1*Dd*f**2*fd + 36*C*D1*Ddd*b1*f**2*r**2 + 72*C*D1*Ddd*b1*f**2*r*s - 36*C*D1*Ddd*b1*f**2*r + 36*C*D1*Ddd*b1*f**2*s**2 - 36*C*D1*Ddd*b1*f**2*s + 18*C*D1*Ddd*b1*f**2 + 20*C*D1*Ddd*f**3*r**2 + 40*C*D1*Ddd*f**3*r*s - 20*C*D1*Ddd*f**3*r + 20*C*D1*Ddd*f**3*s**2 - 20*C*D1*Ddd*f**3*s + 10*C*D1*Ddd*f**3 + 108*C*Dd**2*b1*f**2*r**2 + 216*C*Dd**2*b1*f**2*r*s - 108*C*Dd**2*b1*f**2*r + 108*C*Dd**2*b1*f**2*s**2 - 108*C*Dd**2*b1*f**2*s + 18*C*Dd**2*b1*f**2 + 60*C*Dd**2*f**3*r**2 + 120*C*Dd**2*f**3*r*s - 60*C*Dd**2*f**3*r + 60*C*Dd**2*f**3*s**2 - 60*C*Dd**2*f**3*s + 10*C*Dd**2*f**3 + 42*D1**2*b1*f*fd*r**2 + 84*D1**2*b1*f*fd*r*s - 42*D1**2*b1*f*fd*r + 42*D1**2*b1*f*fd*s**2 - 42*D1**2*b1*f*fd*s + 21*D1**2*b1*f*fd - 126*D1**2*b1*f*fdd*r**2 - 252*D1**2*b1*f*fdd*r*s + 126*D1**2*b1*f*fdd*r - 126*D1**2*b1*f*fdd*s**2 + 126*D1**2*b1*f*fdd*s - 63*D1**2*b1*f*fdd - 126*D1**2*b1*fd**2*r**2 - 252*D1**2*b1*fd**2*r*s + 126*D1**2*b1*fd**2*r - 126*D1**2*b1*fd**2*s**2 + 126*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(C - 7)*(r + s - 1)**2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 84*D1*Dd*b1*f**2*r**2 + 168*D1*Dd*b1*f**2*r*s - 84*D1*Dd*b1*f**2*r + 84*D1*Dd*b1*f**2*s**2 - 84*D1*Dd*b1*f**2*s + 42*D1*Dd*b1*f**2 - 1008*D1*Dd*b1*f*fd*r**2 - 2016*D1*Dd*b1*f*fd*r*s + 1008*D1*Dd*b1*f*fd*r - 1008*D1*Dd*b1*f*fd*s**2 + 1008*D1*Dd*b1*f*fd*s - 252*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 100*D1*Dd*f**3*s + 50*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 980*D1*Dd*f**2*fd*s - 280*D1*Dd*f**2*fd - 252*D1*Ddd*b1*f**2*r**2 - 504*D1*Ddd*b1*f**2*r*s + 252*D1*Ddd*b1*f**2*r - 252*D1*Ddd*b1*f**2*s**2 + 252*D1*Ddd*b1*f**2*s - 126*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 140*D1*Ddd*f**3*s - 70*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(C + 7)*(r + s - 1) + D1*fd*(6*C - 42)*(2*r + 2*s - 1) + Dd*f*(12*C - 84)*(2*r + 2*s - 1)) - 756*Dd**2*b1*f**2*r**2 - 1512*Dd**2*b1*f**2*r*s + 756*Dd**2*b1*f**2*r - 756*Dd**2*b1*f**2*s**2 + 756*Dd**2*b1*f**2*s - 126*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 420*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**2*k1**4*(42*D1*b1*bd1*(C - 3)*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 12*Dd*f*(2*r + 2*s - 1)) + 21*b1**2*(C - 3)*(D1**2*(fd - 3*fdd)*(r + s)**2 + 2*D1*(Dd*(f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 3*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 6*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) - 9*b1*(14*D1**2*bdd1*f*(C - 3)*(r + s - 1)**2 + 3*D1**2*(f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 6*D1*f*(Dd*(3*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 10*fd*(2*r + 2*s - 1)**2) - 5*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 30*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + f*(5*C*(D1**2*(-f*(5*fd - 7*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 14*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 2*D1*f*(Dd*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 14*fd*(6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) - 7*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 14*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) - 126*D1**2*bd1**2*(C - 3)*(r + s - 1)**2 + 135*D1**2*bdd1*f*(r + s - 1)**2 - 27*D1*bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(2*r + 2*s - 1))))/(315*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct**2*k1**4*st**2*(b1*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 9*fd*(8*s - 3)*(2*r + 2*s - 1)) - 9*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 9*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(7*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 5*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k2**2*k3**4) + 2*D1**2*Pk1*Pk2*ct**2*k1**4*(42*D1*b1*bd1*(D1*(f*(2*s - 1)*(r + s - 1) + 3*fd*(-4*r*s + r + s*(3 - 4*s))) - 6*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 42*b1**2*(D1**2*s*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + 3*fd*(-8*r*s + r + s*(3 - 8*s))) - 3*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) - 9*b1*(14*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + D1**2*(f*(fd*(22*r*s - 17*r + 22*s**2 - 28*s + 17) + fdd*(-18*r*s + 19*r - 18*s**2 + 28*s - 19)) + fd**2*(r*(19 - 18*s) + s*(28 - 18*s))) + D1*f*(Dd*(11*f*(4*r*s - r + 4*s**2 - 3*s + 1) - fd*(72*s - 47)*(2*r + 2*s - 1)) - 9*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 9*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(-126*D1**2*bd1**2*(2*s - 1)*(r + s - 1) + 9*D1**2*bdd1*f*(9*s + 10)*(r + s - 1) - 5*D1**2*(f*(23*fd - 25*fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 9*D1*bd1*(D1*(f*(11*s + 6)*(r + s - 1) - fd*(36*r*s + r + 36*s**2 - 26*s + 9)) + Dd*f*(-r*(72*s + 31) - 72*s**2 + 23*s + 11)) - 5*D1*f*(Dd*(23*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 25*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 25*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 125*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(315*d**2*k2**2*k3**4) - 8*D1**2*Pk1*Pk2*ct**2*k1**2*k2**2*st**4*(30*C*D1**2*b1*f*fd*r**2 + 60*C*D1**2*b1*f*fd*r*s - 30*C*D1**2*b1*f*fd*r + 30*C*D1**2*b1*f*fd*s**2 - 30*C*D1**2*b1*f*fd*s + 15*C*D1**2*b1*f*fd - 36*C*D1**2*b1*f*fdd*r**2 - 72*C*D1**2*b1*f*fdd*r*s + 36*C*D1**2*b1*f*fdd*r - 36*C*D1**2*b1*f*fdd*s**2 + 36*C*D1**2*b1*f*fdd*s - 18*C*D1**2*b1*f*fdd - 36*C*D1**2*b1*fd**2*r**2 - 72*C*D1**2*b1*fd**2*r*s + 36*C*D1**2*b1*fd**2*r - 36*C*D1**2*b1*fd**2*s**2 + 36*C*D1**2*b1*fd**2*s + 27*C*D1**2*f**2*fd*r**2 + 54*C*D1**2*f**2*fd*r*s - 36*C*D1**2*f**2*fd*r + 27*C*D1**2*f**2*fd*s**2 - 36*C*D1**2*f**2*fd*s + 18*C*D1**2*f**2*fd - 18*C*D1**2*f**2*fdd*r**2 - 36*C*D1**2*f**2*fdd*r*s + 24*C*D1**2*f**2*fdd*r - 18*C*D1**2*f**2*fdd*s**2 + 24*C*D1**2*f**2*fdd*s - 12*C*D1**2*f**2*fdd - 36*C*D1**2*f*fd**2*r**2 - 72*C*D1**2*f*fd**2*r*s + 48*C*D1**2*f*fd**2*r - 36*C*D1**2*f*fd**2*s**2 + 48*C*D1**2*f*fd**2*s - 12*C*D1**2*f*fd**2 + 60*C*D1*Dd*b1*f**2*r**2 + 120*C*D1*Dd*b1*f**2*r*s - 60*C*D1*Dd*b1*f**2*r + 60*C*D1*Dd*b1*f**2*s**2 - 60*C*D1*Dd*b1*f**2*s + 30*C*D1*Dd*b1*f**2 - 288*C*D1*Dd*b1*f*fd*r**2 - 576*C*D1*Dd*b1*f*fd*r*s + 288*C*D1*Dd*b1*f*fd*r - 288*C*D1*Dd*b1*f*fd*s**2 + 288*C*D1*Dd*b1*f*fd*s - 72*C*D1*Dd*b1*f*fd + 36*C*D1*Dd*f**3*r**2 + 72*C*D1*Dd*f**3*r*s - 36*C*D1*Dd*f**3*r + 36*C*D1*Dd*f**3*s**2 - 36*C*D1*Dd*f**3*s + 18*C*D1*Dd*f**3 - 144*C*D1*Dd*f**2*fd*r**2 - 288*C*D1*Dd*f**2*fd*r*s + 168*C*D1*Dd*f**2*fd*r - 144*C*D1*Dd*f**2*fd*s**2 + 168*C*D1*Dd*f**2*fd*s - 48*C*D1*Dd*f**2*fd - 72*C*D1*Ddd*b1*f**2*r**2 - 144*C*D1*Ddd*b1*f**2*r*s + 72*C*D1*Ddd*b1*f**2*r - 72*C*D1*Ddd*b1*f**2*s**2 + 72*C*D1*Ddd*b1*f**2*s - 36*C*D1*Ddd*b1*f**2 - 24*C*D1*Ddd*f**3*r**2 - 48*C*D1*Ddd*f**3*r*s + 24*C*D1*Ddd*f**3*r - 24*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 216*C*Dd**2*b1*f**2*r**2 - 432*C*Dd**2*b1*f**2*r*s + 216*C*Dd**2*b1*f**2*r - 216*C*Dd**2*b1*f**2*s**2 + 216*C*Dd**2*b1*f**2*s - 36*C*Dd**2*b1*f**2 - 72*C*Dd**2*f**3*r**2 - 144*C*Dd**2*f**3*r*s + 72*C*Dd**2*f**3*r - 72*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s - 12*C*Dd**2*f**3 - 108*D1**2*b1*f*fd*r**2 - 216*D1**2*b1*f*fd*r*s + 108*D1**2*b1*f*fd*r - 108*D1**2*b1*f*fd*s**2 + 108*D1**2*b1*f*fd*s - 54*D1**2*b1*f*fd + 96*D1**2*b1*f*fdd*r**2 + 192*D1**2*b1*f*fdd*r*s - 96*D1**2*b1*f*fdd*r + 96*D1**2*b1*f*fdd*s**2 - 96*D1**2*b1*f*fdd*s + 48*D1**2*b1*f*fdd + 96*D1**2*b1*fd**2*r**2 + 192*D1**2*b1*fd**2*r*s - 96*D1**2*b1*fd**2*r + 96*D1**2*b1*fd**2*s**2 - 96*D1**2*b1*fd**2*s - 6*D1**2*bdd1*f**2*(3*C - 8)*(r + s - 1)**2 - 78*D1**2*f**2*fd*r**2 - 156*D1**2*f**2*fd*r*s + 104*D1**2*f**2*fd*r - 78*D1**2*f**2*fd*s**2 + 104*D1**2*f**2*fd*s - 52*D1**2*f**2*fd + 48*D1**2*f**2*fdd*r**2 + 96*D1**2*f**2*fdd*r*s - 64*D1**2*f**2*fdd*r + 48*D1**2*f**2*fdd*s**2 - 64*D1**2*f**2*fdd*s + 32*D1**2*f**2*fdd + 96*D1**2*f*fd**2*r**2 + 192*D1**2*f*fd**2*r*s - 128*D1**2*f*fd**2*r + 96*D1**2*f*fd**2*s**2 - 128*D1**2*f*fd**2*s + 32*D1**2*f*fd**2 - 216*D1*Dd*b1*f**2*r**2 - 432*D1*Dd*b1*f**2*r*s + 216*D1*Dd*b1*f**2*r - 216*D1*Dd*b1*f**2*s**2 + 216*D1*Dd*b1*f**2*s - 108*D1*Dd*b1*f**2 + 768*D1*Dd*b1*f*fd*r**2 + 1536*D1*Dd*b1*f*fd*r*s - 768*D1*Dd*b1*f*fd*r + 768*D1*Dd*b1*f*fd*s**2 - 768*D1*Dd*b1*f*fd*s + 192*D1*Dd*b1*f*fd - 104*D1*Dd*f**3*r**2 - 208*D1*Dd*f**3*r*s + 104*D1*Dd*f**3*r - 104*D1*Dd*f**3*s**2 + 104*D1*Dd*f**3*s - 52*D1*Dd*f**3 + 384*D1*Dd*f**2*fd*r**2 + 768*D1*Dd*f**2*fd*r*s - 448*D1*Dd*f**2*fd*r + 384*D1*Dd*f**2*fd*s**2 - 448*D1*Dd*f**2*fd*s + 128*D1*Dd*f**2*fd + 192*D1*Ddd*b1*f**2*r**2 + 384*D1*Ddd*b1*f**2*r*s - 192*D1*Ddd*b1*f**2*r + 192*D1*Ddd*b1*f**2*s**2 - 192*D1*Ddd*b1*f**2*s + 96*D1*Ddd*b1*f**2 + 64*D1*Ddd*f**3*r**2 + 128*D1*Ddd*f**3*r*s - 64*D1*Ddd*f**3*r + 64*D1*Ddd*f**3*s**2 - 64*D1*Ddd*f**3*s + 32*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(5*C - 18)*(r + s - 1) - D1*fd*(12*C - 32)*(2*r + 2*s - 1) - Dd*f*(24*C - 64)*(2*r + 2*s - 1)) + 576*Dd**2*b1*f**2*r**2 + 1152*Dd**2*b1*f**2*r*s - 576*Dd**2*b1*f**2*r + 576*Dd**2*b1*f**2*s**2 - 576*Dd**2*b1*f**2*s + 96*Dd**2*b1*f**2 + 192*Dd**2*f**3*r**2 + 384*Dd**2*f**3*r*s - 192*Dd**2*f**3*r + 192*Dd**2*f**3*s**2 - 192*Dd**2*f**3*s + 32*Dd**2*f**3)/(105*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**2*k1**2*k2**2*st**2*(7*b1**2*(C - 2)*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + 2*D1*(Dd*(7*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 12*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 2*b1*(-68*C*D1**2*f*fd*r**2 - 136*C*D1**2*f*fd*r*s + 68*C*D1**2*f*fd*r - 68*C*D1**2*f*fd*s**2 + 68*C*D1**2*f*fd*s - 34*C*D1**2*f*fd + 90*C*D1**2*f*fdd*r**2 + 180*C*D1**2*f*fdd*r*s - 90*C*D1**2*f*fdd*r + 90*C*D1**2*f*fdd*s**2 - 90*C*D1**2*f*fdd*s + 45*C*D1**2*f*fdd + 90*C*D1**2*fd**2*r**2 + 180*C*D1**2*fd**2*r*s - 90*C*D1**2*fd**2*r + 90*C*D1**2*fd**2*s**2 - 90*C*D1**2*fd**2*s - 136*C*D1*Dd*f**2*r**2 - 272*C*D1*Dd*f**2*r*s + 136*C*D1*Dd*f**2*r - 136*C*D1*Dd*f**2*s**2 + 136*C*D1*Dd*f**2*s - 68*C*D1*Dd*f**2 + 720*C*D1*Dd*f*fd*r**2 + 1440*C*D1*Dd*f*fd*r*s - 720*C*D1*Dd*f*fd*r + 720*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 180*C*D1*Dd*f*fd + 180*C*D1*Ddd*f**2*r**2 + 360*C*D1*Ddd*f**2*r*s - 180*C*D1*Ddd*f**2*r + 180*C*D1*Ddd*f**2*s**2 - 180*C*D1*Ddd*f**2*s + 90*C*D1*Ddd*f**2 + 540*C*Dd**2*f**2*r**2 + 1080*C*Dd**2*f**2*r*s - 540*C*Dd**2*f**2*r + 540*C*Dd**2*f**2*s**2 - 540*C*Dd**2*f**2*s + 90*C*Dd**2*f**2 - 42*D1**2*bdd1*f*(C - 2)*(r + s - 1)**2 - 38*D1**2*f*fd*r**2 - 76*D1**2*f*fd*r*s + 38*D1**2*f*fd*r - 38*D1**2*f*fd*s**2 + 38*D1**2*f*fd*s - 19*D1**2*f*fd + 54*D1**2*f*fdd*r**2 + 108*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r + 54*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 27*D1**2*f*fdd + 54*D1**2*fd**2*r**2 + 108*D1**2*fd**2*r*s - 54*D1**2*fd**2*r + 54*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s - 76*D1*Dd*f**2*r**2 - 152*D1*Dd*f**2*r*s + 76*D1*Dd*f**2*r - 76*D1*Dd*f**2*s**2 + 76*D1*Dd*f**2*s - 38*D1*Dd*f**2 + 432*D1*Dd*f*fd*r**2 + 864*D1*Dd*f*fd*r*s - 432*D1*Dd*f*fd*r + 432*D1*Dd*f*fd*s**2 - 432*D1*Dd*f*fd*s + 108*D1*Dd*f*fd + 108*D1*Ddd*f**2*r**2 + 216*D1*Ddd*f**2*r*s - 108*D1*Ddd*f**2*r + 108*D1*Ddd*f**2*s**2 - 108*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 7*D1*bd1*(C - 2)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) + 324*Dd**2*f**2*r**2 + 648*Dd**2*f**2*r*s - 324*Dd**2*f**2*r + 324*Dd**2*f**2*s**2 - 324*Dd**2*f**2*s + 54*Dd**2*f**2) + f*(-207*C*D1**2*f*fd*r**2 - 414*C*D1**2*f*fd*r*s + 276*C*D1**2*f*fd*r - 207*C*D1**2*f*fd*s**2 + 276*C*D1**2*f*fd*s - 138*C*D1**2*f*fd + 180*C*D1**2*f*fdd*r**2 + 360*C*D1**2*f*fdd*r*s - 240*C*D1**2*f*fdd*r + 180*C*D1**2*f*fdd*s**2 - 240*C*D1**2*f*fdd*s + 120*C*D1**2*f*fdd + 360*C*D1**2*fd**2*r**2 + 720*C*D1**2*fd**2*r*s - 480*C*D1**2*fd**2*r + 360*C*D1**2*fd**2*s**2 - 480*C*D1**2*fd**2*s + 120*C*D1**2*fd**2 - 276*C*D1*Dd*f**2*r**2 - 552*C*D1*Dd*f**2*r*s + 276*C*D1*Dd*f**2*r - 276*C*D1*Dd*f**2*s**2 + 276*C*D1*Dd*f**2*s - 138*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r**2 + 2880*C*D1*Dd*f*fd*r*s - 1680*C*D1*Dd*f*fd*r + 1440*C*D1*Dd*f*fd*s**2 - 1680*C*D1*Dd*f*fd*s + 480*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 240*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 240*C*D1*Ddd*f**2*s + 120*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 720*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 720*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 84*D1**2*bd1**2*(C - 2)*(r + s - 1)**2 + 18*D1**2*bdd1*f*(5*C + 3)*(r + s - 1)**2 + 12*D1**2*f*fd*r**2 + 24*D1**2*f*fd*r*s - 16*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 8*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 40*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 40*D1**2*f*fdd*s + 20*D1**2*f*fdd + 60*D1**2*fd**2*r**2 + 120*D1**2*fd**2*r*s - 80*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 80*D1**2*fd**2*s + 20*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 8*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 280*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 280*D1*Dd*f*fd*s + 80*D1*Dd*f*fd + 40*D1*Ddd*f**2*r**2 + 80*D1*Ddd*f**2*r*s - 40*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 40*D1*Ddd*f**2*s + 20*D1*Ddd*f**2 - 2*D1*bd1*(r + s - 1)*(D1*f*(34*C + 19)*(r + s - 1) - D1*fd*(90*C + 54)*(2*r + 2*s - 1) - Dd*f*(180*C + 108)*(2*r + 2*s - 1)) + 120*Dd**2*f**2*r**2 + 240*Dd**2*f**2*r*s - 120*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 120*Dd**2*f**2*s + 20*Dd**2*f**2))/(105*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct**2*k1**2*k2**2*(-3*D1*f*(28*D1*bd1**2*(3*C + 1)*(r + s - 1)**2 - bd1*(r + s - 1)*(D1*f*(25*C - 8)*(r + s - 1) - D1*fd*(60*C + 20)*(2*r + 2*s - 1) - Dd*f*(120*C + 40)*(2*r + 2*s - 1)) + 5*f*(C*D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*C*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*D1*bdd1*(3*C + 1)*(r + s - 1)**2)) + 14*b1**2*(D1**2*(r + s)**2*(-9*C*fdd + fd*(8*C - 4) - 3*fdd) + 2*D1*(Dd*f*(8*C - 4)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*fd*(18*C + 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)) - Ddd*f*(9*C + 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(18*C + 6)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-84*D1**2*bdd1*f*(3*C + 1)*(r + s - 1)**2 - 3*D1**2*(-f*(-30*C*fdd + fd*(25*C - 8) - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd**2*(60*C + 20)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 56*D1*bd1*(r + s - 1)*(D1*f*(4*C - 2)*(r + s - 1) - D1*fd*(9*C + 3)*(r + s) - Dd*f*(18*C + 6)*(2*r + 2*s - 1)) + 6*D1*f*(Dd*(f*(25*C - 8)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(-60*C - 20)*(2*r + 2*s - 1)**2) + Ddd*f*(-30*C - 10)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 3*Dd**2*f**2*(60*C + 20)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(105*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**2*k1**2*st**4*(b1*(D1**2*(f*(fd*(12*C - 35) + fdd*(21 - 6*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(21 - 6*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(12*C - 35)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(21 - 6*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(21 - 6*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(21 - 6*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(4*C - 13)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (2*C - 7)*(3*bdd1*s*(r + s - 1) + fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) - fd**2*(2*C - 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(12*C - 35)*(r + s - 1) - fd*(6*C - 21)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(21 - 6*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(4*C - 13)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(2*C - 7)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) - Ddd*f*(2*C - 7)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f**2*(2*C - 7)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(35*d**2*k3**4) - 2*D1**2*Pk1*Pk2*ct**2*k1**2*st**2*(42*b1**2*(D1**2*s*(r + s)*(fd*(12*C - 25) + fdd*(15 - 6*C)) + D1*(Dd*(f*(12*C - 25)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C - 15)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(15 - 6*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(6*C - 15)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 3*b1*(-138*C*D1**2*f*fd*r**2 - 884*C*D1**2*f*fd*r*s + 514*C*D1**2*f*fd*r - 746*C*D1**2*f*fd*s**2 + 818*C*D1**2*f*fd*s - 445*C*D1**2*f*fd + 118*C*D1**2*f*fdd*r**2 + 932*C*D1**2*f*fdd*r*s - 502*C*D1**2*f*fdd*r + 814*C*D1**2*f*fdd*s**2 - 850*C*D1**2*f*fdd*s + 443*C*D1**2*f*fdd + 118*C*D1**2*fd**2*r**2 + 932*C*D1**2*fd**2*r*s - 502*C*D1**2*fd**2*r + 814*C*D1**2*fd**2*s**2 - 850*C*D1**2*fd**2*s - 276*C*D1*Dd*f**2*r**2 - 1768*C*D1*Dd*f**2*r*s + 580*C*D1*Dd*f**2*r - 1492*C*D1*Dd*f**2*s**2 + 1188*C*D1*Dd*f**2*s - 442*C*D1*Dd*f**2 + 944*C*D1*Dd*f*fd*r**2 + 7456*C*D1*Dd*f*fd*r*s - 3176*C*D1*Dd*f*fd*r + 6512*C*D1*Dd*f*fd*s**2 - 5960*C*D1*Dd*f*fd*s + 1352*C*D1*Dd*f*fd + 236*C*D1*Ddd*f**2*r**2 + 1864*C*D1*Ddd*f**2*r*s - 584*C*D1*Ddd*f**2*r + 1628*C*D1*Ddd*f**2*s**2 - 1280*C*D1*Ddd*f**2*s + 466*C*D1*Ddd*f**2 + 708*C*Dd**2*f**2*r**2 + 5592*C*Dd**2*f**2*r*s - 1752*C*Dd**2*f**2*r + 4884*C*Dd**2*f**2*s**2 - 3840*C*Dd**2*f**2*s + 466*C*Dd**2*f**2 - 42*D1**2*bdd1*f*(2*C - 5)*(2*s - 1)*(r + s - 1) + 396*D1**2*f*fd*r**2 + 1144*D1**2*f*fd*r*s - 738*D1**2*f*fd*r + 748*D1**2*f*fd*s**2 - 914*D1**2*f*fd*s + 540*D1**2*f*fd - 436*D1**2*f*fdd*r**2 - 1244*D1**2*f*fdd*r*s + 712*D1**2*f*fdd*r - 808*D1**2*f*fdd*s**2 + 898*D1**2*f*fdd*s - 494*D1**2*f*fdd - 436*D1**2*fd**2*r**2 - 1244*D1**2*fd**2*r*s + 712*D1**2*fd**2*r - 808*D1**2*fd**2*s**2 + 898*D1**2*fd**2*s + 792*D1*Dd*f**2*r**2 + 2288*D1*Dd*f**2*r*s - 968*D1*Dd*f**2*r + 1496*D1*Dd*f**2*s**2 - 1320*D1*Dd*f**2*s + 572*D1*Dd*f**2 - 3488*D1*Dd*f*fd*r**2 - 9952*D1*Dd*f*fd*r*s + 4964*D1*Dd*f*fd*r - 6464*D1*Dd*f*fd*s**2 + 6452*D1*Dd*f*fd*s - 1610*D1*Dd*f*fd - 872*D1*Ddd*f**2*r**2 - 2488*D1*Ddd*f**2*r*s + 1058*D1*Ddd*f**2*r - 1616*D1*Ddd*f**2*s**2 + 1430*D1*Ddd*f**2*s - 622*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(12*C - 25)*(2*s - 1)*(r + s - 1) - fd*(6*C - 15)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(30 - 12*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 2616*Dd**2*f**2*r**2 - 7464*Dd**2*f**2*r*s + 3174*Dd**2*f**2*r - 4848*Dd**2*f**2*s**2 + 4290*Dd**2*f**2*s - 622*Dd**2*f**2) + f*(-417*C*D1**2*f*fd*r**2 - 2874*C*D1**2*f*fd*r*s + 1236*C*D1**2*f*fd*r - 2457*C*D1**2*f*fd*s**2 + 2596*C*D1**2*f*fd*s - 958*C*D1**2*f*fd + 303*C*D1**2*f*fdd*r**2 + 2382*C*D1**2*f*fdd*r*s - 996*C*D1**2*f*fdd*r + 2079*C*D1**2*f*fdd*s**2 - 2180*C*D1**2*f*fdd*s + 794*C*D1**2*f*fdd + 606*C*D1**2*fd**2*r**2 + 4764*C*D1**2*fd**2*r*s - 1992*C*D1**2*fd**2*r + 4158*C*D1**2*fd**2*s**2 - 4360*C*D1**2*fd**2*s + 794*C*D1**2*fd**2 - 556*C*D1*Dd*f**2*r**2 - 3832*C*D1*Dd*f**2*r*s + 1236*C*D1*Dd*f**2*r - 3276*C*D1*Dd*f**2*s**2 + 2596*C*D1*Dd*f**2*s - 958*C*D1*Dd*f**2 + 2424*C*D1*Dd*f*fd*r**2 + 19056*C*D1*Dd*f*fd*r*s - 6972*C*D1*Dd*f*fd*r + 16632*C*D1*Dd*f*fd*s**2 - 15260*C*D1*Dd*f*fd*s + 3176*C*D1*Dd*f*fd + 404*C*D1*Ddd*f**2*r**2 + 3176*C*D1*Ddd*f**2*r*s - 996*C*D1*Ddd*f**2*r + 2772*C*D1*Ddd*f**2*s**2 - 2180*C*D1*Ddd*f**2*s + 794*C*D1*Ddd*f**2 + 1212*C*Dd**2*f**2*r**2 + 9528*C*Dd**2*f**2*r*s - 2988*C*Dd**2*f**2*r + 8316*C*Dd**2*f**2*s**2 - 6540*C*Dd**2*f**2*s + 794*C*Dd**2*f**2 - 126*D1**2*bd1**2*(2*C - 5)*(2*s - 1)*(r + s - 1) + 3*D1**2*bdd1*f*(r + s - 1)*(C*(59*r + 407*s - 23) - 218*r - 404*s + 128) + 1362*D1**2*f*fd*r**2 + 3774*D1**2*f*fd*r*s - 2166*D1**2*f*fd*r + 2412*D1**2*f*fd*s**2 - 2866*D1**2*f*fd*s + 1258*D1**2*f*fd - 1194*D1**2*f*fdd*r**2 - 3264*D1**2*f*fdd*r*s + 1884*D1**2*f*fdd*r - 2070*D1**2*f*fdd*s**2 + 2468*D1**2*f*fdd*s - 1088*D1**2*f*fdd - 2388*D1**2*fd**2*r**2 - 6528*D1**2*fd**2*r*s + 3768*D1**2*fd**2*r - 4140*D1**2*fd**2*s**2 + 4936*D1**2*fd**2*s - 1088*D1**2*fd**2 + 1816*D1*Dd*f**2*r**2 + 5032*D1*Dd*f**2*r*s - 2166*D1*Dd*f**2*r + 3216*D1*Dd*f**2*s**2 - 2866*D1*Dd*f**2*s + 1258*D1*Dd*f**2 - 9552*D1*Dd*f*fd*r**2 - 26112*D1*Dd*f*fd*r*s + 13188*D1*Dd*f*fd*r - 16560*D1*Dd*f*fd*s**2 + 17276*D1*Dd*f*fd*s - 4352*D1*Dd*f*fd - 1592*D1*Ddd*f**2*r**2 - 4352*D1*Ddd*f**2*r*s + 1884*D1*Ddd*f**2*r - 2760*D1*Ddd*f**2*s**2 + 2468*D1*Ddd*f**2*s - 1088*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r + s - 1)*(C*(69*r + 373*s + 3) - 198*r - 374*s + 32) - 2*fd*(C*(118*r**2 + 932*r*s - 333*r + 814*s**2 - 855*s + 233) - 436*r**2 - 1244*r*s + 702*r - 808*s**2 + 981*s - 311)) + 2*Dd*f*(-4*C*(59*r**2 + 466*r*s - 114*r + 407*s**2 - 375*s + 64) + 872*r**2 + 2488*r*s - 1221*r + 1616*s**2 - 1779*s + 439)) - 4776*Dd**2*f**2*r**2 - 13056*Dd**2*f**2*r*s + 5652*Dd**2*f**2*r - 8280*Dd**2*f**2*s**2 + 7404*Dd**2*f**2*s - 1088*Dd**2*f**2))/(315*d**2*k3**4) + 2*D1**2*Pk1*Pk2*ct**2*k1**2*(21*b1**2*(D1**2*(r + s)*(fd*r*(15*C - 38) + fd*s*(47*C - 85) + fdd*r*(59 - 25*C) + fdd*s*(95 - 61*C)) + D1*(Dd*(f*(2*C*(30*r**2 + 124*r*s - 46*r + 94*s**2 - 78*s + 31) - 152*r**2 - 492*r*s + 199*r - 340*s**2 + 293*s - 123) - 8*fd*(r**2*(25*C - 59) + r*(86*C*s - 17*C - 154*s + 34) + s*(61*C*s - 26*C - 95*s + 43))) + 2*Ddd*f*(-C*(50*r**2 + 4*r*(43*s - 17) + 122*s**2 - 104*s + 43) + 118*r**2 + 4*r*(77*s - 34) + 190*s**2 - 172*s + 77)) - 2*Dd**2*f*(C*(150*r**2 + 12*r*(43*s - 17) + 366*s**2 - 312*s + 43) - 354*r**2 + r*(408 - 924*s) - 570*s**2 + 516*s - 77)) + 3*b1*(-14*D1**2*bdd1*f*(r + s - 1)*(C*(25*r + 61*s - 43) - 59*r - 95*s + 77) + 3*D1**2*(f*(fd*(16*C*(2*r**2 - 4*r*s + 5*r - 6*s**2 + 9*s - 6) - 182*r**2 - 502*r*s + 206*r - 320*s**2 + 275*s - 115) + fdd*(-4*C*(4*r**2 - 8*r*s + 17*r - 12*s**2 + 25*s - 19) + 210*r**2 + 538*r*s - 229*r + 328*s**2 - 288*s + 124)) + fd**2*(r**2*(210 - 16*C) + r*(32*C*s - 68*C + 538*s - 229) + 4*s*(12*C*s - 25*C + 82*s - 72))) + 7*D1*bd1*(D1*(f*(r + s - 1)*(C*(30*r + 94*s - 62) - 76*r - 170*s + 123) - 4*fd*(r**2*(25*C - 59) + 2*r*(43*C*s - 17*C - 77*s + 34) + s*(61*C*s - 52*C - 95*s + 86))) - 8*Dd*f*(C*(50*r**2 + 2*r*(86*s - 51) + 122*s**2 - 156*s + 43) - 118*r**2 - 308*r*s + 204*r - 190*s**2 + 258*s - 77)) + 3*D1*f*(Dd*(f*(32*C*(2*r**2 - 4*r*s - 6*s**2 + 4*s - 1) - 364*r**2 - 1004*r*s + 433*r - 640*s**2 + 571*s - 251) - fd*(2*r + 2*s - 1)*(8*C*(8*r - 24*s + 21) - 840*r - 1312*s + 517)) + Ddd*f*(-16*C*(2*r**2 - 4*r*s - 6*s**2 + 4*s - 1) + 420*r**2 + 1076*r*s - 479*r + 656*s**2 - 597*s + 269)) + 3*Dd**2*f**2*(-16*C*(6*r**2 - 12*r*s - 18*s**2 + 12*s - 1) + 1260*r**2 + 3228*r*s - 1437*r + 1968*s**2 - 1791*s + 269)) + f*(-42*D1**2*bd1**2*(r + s - 1)*(C*(25*r + 61*s - 43) - 59*r - 95*s + 77) - 9*D1**2*bdd1*f*(r + s - 1)*(4*C*(2*r - 6*s - 15) - 105*r - 164*s + 145) - 5*D1**2*(f*(fd*(C*(129*r**2 + 642*r*s - 300*r + 513*s**2 - 556*s + 214) - 27*r**2 + 42*r*s + 4*r + 69*s**2 - 60*s + 14) - fdd*(C*(159*r**2 + 618*r*s - 312*r + 459*s**2 - 512*s + 206) + 75*r*s - 25*r + 75*s**2 - 75*s + 25)) - fd**2*(2*C*(159*r**2 + 618*r*s - 312*r + 459*s**2 - 512*s + 103) + 150*r*s - 50*r + 150*s**2 - 150*s + 25)) + 9*D1*bd1*(D1*(f*(r + s - 1)*(16*C*(r - 3*s - 4) - 91*r - 160*s + 136) + fd*(4*C*(-8*r**2 + 16*r*s + 17*r + 24*s**2 - 7*s + 4) + 420*r**2 + 1076*r*s - 729*r + 656*s**2 - 906*s + 269)) + Dd*f*(-8*C*(8*r**2 - 2*r*(8*s + 17) - 24*s**2 - 10*s + 13) + 840*r**2 + 2152*r*s - 1479*r + 1312*s**2 - 1833*s + 559)) - 5*D1*f*(Dd*(2*f*(C*(86*r**2 + 428*r*s - 150*r + 342*s**2 - 278*s + 107) - 18*r**2 + 28*r*s + 2*r + 46*s**2 - 30*s + 7) - fd*(8*C*(159*r**2 + 618*r*s - 273*r + 459*s**2 - 448*s + 103) + 600*r*s - 175*r + 600*s**2 - 525*s + 100)) - Ddd*f*(C*(212*r**2 + 824*r*s - 312*r + 612*s**2 - 512*s + 206) + 100*r*s - 25*r + 100*s**2 - 75*s + 25)) + 5*Dd**2*f**2*(2*C*(318*r**2 + 1236*r*s - 468*r + 918*s**2 - 768*s + 103) + 300*r*s - 75*r + 300*s**2 - 225*s + 25)))/(315*d**2*k3**4) - D1**2*Pk1*Pk2*ct**2*k1**2*st**4*(8*C - 48)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2**2*k3**2) - 4*D1**2*Pk1*Pk2*ct**2*k1**2*st**2*(14*b1**2*(C - 4)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-334*C*D1**2*f*fd*s**2 + 358*C*D1**2*f*fd*s - 179*C*D1**2*f*fd + 202*C*D1**2*f*fdd*s**2 - 214*C*D1**2*f*fdd*s + 107*C*D1**2*f*fdd + 202*C*D1**2*fd**2*s**2 - 214*C*D1**2*fd**2*s - 668*C*D1*Dd*f**2*s**2 + 334*C*D1*Dd*f**2*s - 167*C*D1*Dd*f**2 + 1616*C*D1*Dd*f*fd*s**2 - 1260*C*D1*Dd*f*fd*s + 214*C*D1*Dd*f*fd + 404*C*D1*Ddd*f**2*s**2 - 202*C*D1*Ddd*f**2*s + 101*C*D1*Ddd*f**2 + 1212*C*Dd**2*f**2*s**2 - 606*C*Dd**2*f**2*s - 14*D1**2*bdd1*f*(C - 4)*(2*s**2 - 2*s + 1) + 156*D1**2*f*fd*r*s - 78*D1**2*f*fd*r + 640*D1**2*f*fd*s**2 - 736*D1**2*f*fd*s + 368*D1**2*f*fd - 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 460*D1**2*f*fdd*s**2 + 508*D1**2*f*fdd*s - 254*D1**2*f*fdd - 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 460*D1**2*fd**2*s**2 + 508*D1**2*fd**2*s + 312*D1*Dd*f**2*r*s - 78*D1*Dd*f**2*r + 1280*D1*Dd*f**2*s**2 - 718*D1*Dd*f**2*s + 320*D1*Dd*f**2 - 960*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 3680*D1*Dd*f*fd*s**2 + 3072*D1*Dd*f*fd*s - 568*D1*Dd*f*fd - 240*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 920*D1*Ddd*f**2*s**2 + 520*D1*Ddd*f**2*s - 230*D1*Ddd*f**2 + 28*D1*bd1*(C - 4)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 720*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 2760*Dd**2*f**2*s**2 + 1560*Dd**2*f**2*s - 60*Dd**2*f**2) - f*(285*C*D1**2*f*fd*s**2 - 190*C*D1**2*f*fd*s + 95*C*D1**2*f*fd - 165*C*D1**2*f*fdd*s**2 + 110*C*D1**2*f*fdd*s - 55*C*D1**2*f*fdd - 330*C*D1**2*fd**2*s**2 + 220*C*D1**2*fd**2*s + 380*C*D1*Dd*f**2*s**2 - 190*C*D1*Dd*f**2*s + 95*C*D1*Dd*f**2 - 1320*C*D1*Dd*f*fd*s**2 + 770*C*D1*Dd*f*fd*s - 110*C*D1*Dd*f*fd - 220*C*D1*Ddd*f**2*s**2 + 110*C*D1*Ddd*f**2*s - 55*C*D1*Ddd*f**2 - 660*C*Dd**2*f**2*s**2 + 330*C*Dd**2*f**2*s + 28*D1**2*bd1**2*s*(C - 4)*(s - 1) + D1**2*bdd1*f*(C*(-101*s**2 - 12*s + 6) + 230*s**2 + s*(60*r - 12) - 24) - 126*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 528*D1**2*f*fd*s**2 + 394*D1**2*f*fd*s - 176*D1**2*f*fd + 108*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 354*D1**2*f*fdd*s**2 - 272*D1**2*f*fdd*s + 118*D1**2*f*fdd + 216*D1**2*fd**2*r*s - 72*D1**2*fd**2*r + 708*D1**2*fd**2*s**2 - 544*D1**2*fd**2*s + 36*D1**2*fd**2 - 168*D1*Dd*f**2*r*s + 42*D1*Dd*f**2*r - 704*D1*Dd*f**2*s**2 + 394*D1*Dd*f**2*s - 176*D1*Dd*f**2 + 864*D1*Dd*f*fd*r*s - 252*D1*Dd*f*fd*r + 2832*D1*Dd*f*fd*s**2 - 1904*D1*Dd*f*fd*s + 308*D1*Dd*f*fd + 144*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 472*D1*Ddd*f**2*s**2 - 272*D1*Ddd*f**2*s + 118*D1*Ddd*f**2 + D1*bd1*(D1*(f*(C*(167*s**2 + 24*s - 12) - 320*s**2 - s*(78*r + 18) + 48) + 2*fd*(30*r*(4*s - 1) + s**2*(460 - 202*C) + s*(95*C - 266) + 30)) + 2*Dd*f*(C*(-404*s**2 + 77*s + 6) + 30*r*(8*s - 1) + 920*s**2 - 284*s + 6)) + 432*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 1416*Dd**2*f**2*s**2 - 816*Dd**2*f**2*s + 36*Dd**2*f**2))/(105*d**2*k2**2*k3**2) + D1**2*Pk1*Pk2*ct**2*k1**2*(42*b1**2*(D1**2*s*(-16*fd*r + fd*s*(19*C - 46) + 13*fdd*r + fdd*s*(38 - 17*C)) + D1*(Dd*(19*C*f*(4*s**2 - 2*s + 1) - 2*f*(8*r*(4*s - 1) + 92*s**2 - 54*s + 23) + 13*fd*r*(8*s - 1) + fd*s*(-34*C*(4*s - 1) + 304*s - 89)) + Ddd*f*(-17*C*(4*s**2 - 2*s + 1) + 52*r*s - 13*r + 152*s**2 - 89*s + 38)) + Dd**2*f*(39*r*(4*s - 1) + s**2*(456 - 204*C) + s*(102*C - 267) + 13)) + 3*b1*(-704*C*D1**2*f*fd*s**2 + 1100*C*D1**2*f*fd*s - 550*C*D1**2*f*fd + 632*C*D1**2*f*fdd*s**2 - 956*C*D1**2*f*fdd*s + 478*C*D1**2*f*fdd + 632*C*D1**2*fd**2*s**2 - 956*C*D1**2*fd**2*s - 1408*C*D1*Dd*f**2*s**2 + 704*C*D1*Dd*f**2*s - 352*C*D1*Dd*f**2 + 5056*C*D1*Dd*f*fd*s**2 - 5088*C*D1*Dd*f*fd*s + 956*C*D1*Dd*f*fd + 1264*C*D1*Ddd*f**2*s**2 - 632*C*D1*Ddd*f**2*s + 316*C*D1*Ddd*f**2 + 3792*C*Dd**2*f**2*s**2 - 1896*C*Dd**2*f**2*s - 14*D1**2*bdd1*f*(17*C*(2*s**2 - 2*s + 1) + r*(13 - 26*s) - 76*s**2 + 89*s - 38) + 190*D1**2*f*fd*r*s - 287*D1**2*f*fd*r + 296*D1**2*f*fd*s**2 - 992*D1**2*f*fd*s + 592*D1**2*f*fd - 214*D1**2*f*fdd*r*s + 245*D1**2*f*fdd*r - 512*D1**2*f*fdd*s**2 + 1070*D1**2*f*fdd*s - 604*D1**2*f*fdd - 214*D1**2*fd**2*r*s + 245*D1**2*fd**2*r - 512*D1**2*fd**2*s**2 + 1070*D1**2*fd**2*s + 380*D1*Dd*f**2*r*s - 95*D1*Dd*f**2*r + 592*D1*Dd*f**2*s**2 - 391*D1*Dd*f**2*s + 148*D1*Dd*f**2 - 1712*D1*Dd*f*fd*r*s + 1194*D1*Dd*f*fd*r - 4096*D1*Dd*f*fd*s**2 + 5518*D1*Dd*f*fd*s - 1315*D1*Dd*f*fd - 428*D1*Ddd*f**2*r*s + 107*D1*Ddd*f**2*r - 1024*D1*Ddd*f**2*s**2 + 619*D1*Ddd*f**2*s - 256*D1*Ddd*f**2 + 14*D1*bd1*(D1*(19*C*f*(2*s**2 - 2*s + 1) - 2*f*(8*r*(2*s - 1) + 46*s**2 - 54*s + 23) + 13*fd*r*(4*s - 1) + fd*s*(C*(34 - 68*s) + 152*s - 89)) + 2*Dd*f*(-17*C*(8*s**2 - 6*s + 1) + 13*r*(8*s - 3) + 304*s**2 - 267*s + 51)) - 1284*Dd**2*f**2*r*s + 321*Dd**2*f**2*r - 3072*Dd**2*f**2*s**2 + 1857*Dd**2*f**2*s - 107*Dd**2*f**2) - f*(3498*C*D1**2*f*fd*s**2 - 2332*C*D1**2*f*fd*s + 1166*C*D1**2*f*fd - 3018*C*D1**2*f*fdd*s**2 + 2012*C*D1**2*f*fdd*s - 1006*C*D1**2*f*fdd - 6036*C*D1**2*fd**2*s**2 + 4024*C*D1**2*fd**2*s + 4664*C*D1*Dd*f**2*s**2 - 2332*C*D1*Dd*f**2*s + 1166*C*D1*Dd*f**2 - 24144*C*D1*Dd*f*fd*s**2 + 14084*C*D1*Dd*f*fd*s - 2012*C*D1*Dd*f*fd - 4024*C*D1*Ddd*f**2*s**2 + 2012*C*D1*Ddd*f**2*s - 1006*C*D1*Ddd*f**2 - 12072*C*Dd**2*f**2*s**2 + 6036*C*Dd**2*f**2*s - 42*D1**2*bd1**2*(13*r*(2*s - 1) - (s - 1)*(s*(34*C - 76) + 13)) + 3*D1**2*bdd1*f*(-2*C*(158*s**2 + 162*s - 81) + r*(107*s + 138) + 256*s**2 + 451*s - 348) - 2037*D1**2*f*fd*r*s + 679*D1**2*f*fd*r - 3552*D1**2*f*fd*s**2 + 3047*D1**2*f*fd*s - 1184*D1**2*f*fd + 1707*D1**2*f*fdd*r*s - 569*D1**2*f*fdd*r + 3612*D1**2*f*fdd*s**2 - 2977*D1**2*f*fdd*s + 1204*D1**2*f*fdd + 3414*D1**2*fd**2*r*s - 1138*D1**2*fd**2*r + 7224*D1**2*fd**2*s**2 - 5954*D1**2*fd**2*s + 569*D1**2*fd**2 - 2716*D1*Dd*f**2*r*s + 679*D1*Dd*f**2*r - 4736*D1*Dd*f**2*s**2 + 3047*D1*Dd*f**2*s - 1184*D1*Dd*f**2 + 13656*D1*Dd*f*fd*r*s - 3983*D1*Dd*f*fd*r + 28896*D1*Dd*f*fd*s**2 - 20839*D1*Dd*f*fd*s + 3546*D1*Dd*f*fd + 2276*D1*Ddd*f**2*r*s - 569*D1*Ddd*f**2*r + 4816*D1*Ddd*f**2*s**2 - 2977*D1*Ddd*f**2*s + 1204*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(22*C*(16*s**2 + 18*s - 9) - r*(95*s + 192) - 148*s**2 - 601*s + 444) + fd*(r*(428*s + 31) - s**2*(1264*C - 1024) + s*(308*C - 168) + 107)) + Dd*f*(-4*C*(632*s**2 + 166*s - 81) + r*(856*s + 445) + 2048*s**2 + 1185*s - 589)) + 6828*Dd**2*f**2*r*s - 1707*Dd**2*f**2*r + 14448*Dd**2*f**2*s**2 - 8931*Dd**2*f**2*s + 569*Dd**2*f**2))/(315*d**2*k2**2*k3**2) - D1**2*Pk1*Pk2*ct**2*k2**4*st**6*(8*C - 8)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 72*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 72*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 144*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 144*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 28*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s - 8*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 12*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s - 2*Dd**2*f**3)/(63*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**2*k2**4*st**4*(21*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 3*b1*(-70*C*D1**2*f*fd*r**2 - 140*C*D1**2*f*fd*r*s + 70*C*D1**2*f*fd*r - 70*C*D1**2*f*fd*s**2 + 70*C*D1**2*f*fd*s - 35*C*D1**2*f*fd + 28*C*D1**2*f*fdd*r**2 + 56*C*D1**2*f*fdd*r*s - 28*C*D1**2*f*fdd*r + 28*C*D1**2*f*fdd*s**2 - 28*C*D1**2*f*fdd*s + 14*C*D1**2*f*fdd + 28*C*D1**2*fd**2*r**2 + 56*C*D1**2*fd**2*r*s - 28*C*D1**2*fd**2*r + 28*C*D1**2*fd**2*s**2 - 28*C*D1**2*fd**2*s - 140*C*D1*Dd*f**2*r**2 - 280*C*D1*Dd*f**2*r*s + 140*C*D1*Dd*f**2*r - 140*C*D1*Dd*f**2*s**2 + 140*C*D1*Dd*f**2*s - 70*C*D1*Dd*f**2 + 224*C*D1*Dd*f*fd*r**2 + 448*C*D1*Dd*f*fd*r*s - 224*C*D1*Dd*f*fd*r + 224*C*D1*Dd*f*fd*s**2 - 224*C*D1*Dd*f*fd*s + 56*C*D1*Dd*f*fd + 56*C*D1*Ddd*f**2*r**2 + 112*C*D1*Ddd*f**2*r*s - 56*C*D1*Ddd*f**2*r + 56*C*D1*Ddd*f**2*s**2 - 56*C*D1*Ddd*f**2*s + 28*C*D1*Ddd*f**2 + 168*C*Dd**2*f**2*r**2 + 336*C*Dd**2*f**2*r*s - 168*C*Dd**2*f**2*r + 168*C*Dd**2*f**2*s**2 - 168*C*Dd**2*f**2*s + 28*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(C - 1)*(r + s - 1)**2 - 16*D1**2*f*fd*r**2 - 32*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 16*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 22*D1**2*f*fdd*r**2 + 44*D1**2*f*fdd*r*s - 22*D1**2*f*fdd*r + 22*D1**2*f*fdd*s**2 - 22*D1**2*f*fdd*s + 11*D1**2*f*fdd + 22*D1**2*fd**2*r**2 + 44*D1**2*fd**2*r*s - 22*D1**2*fd**2*r + 22*D1**2*fd**2*s**2 - 22*D1**2*fd**2*s - 32*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 32*D1*Dd*f**2*r - 32*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 176*D1*Dd*f*fd*r**2 + 352*D1*Dd*f*fd*r*s - 176*D1*Dd*f*fd*r + 176*D1*Dd*f*fd*s**2 - 176*D1*Dd*f*fd*s + 44*D1*Dd*f*fd + 44*D1*Ddd*f**2*r**2 + 88*D1*Ddd*f**2*r*s - 44*D1*Ddd*f**2*r + 44*D1*Ddd*f**2*s**2 - 44*D1*Ddd*f**2*s + 22*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) + 132*Dd**2*f**2*r**2 + 264*Dd**2*f**2*r*s - 132*Dd**2*f**2*r + 132*Dd**2*f**2*s**2 - 132*Dd**2*f**2*s + 22*Dd**2*f**2) + f*(-99*C*D1**2*f*fd*r**2 - 198*C*D1**2*f*fd*r*s + 132*C*D1**2*f*fd*r - 99*C*D1**2*f*fd*s**2 + 132*C*D1**2*f*fd*s - 66*C*D1**2*f*fd + 45*C*D1**2*f*fdd*r**2 + 90*C*D1**2*f*fdd*r*s - 60*C*D1**2*f*fdd*r + 45*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 30*C*D1**2*f*fdd + 90*C*D1**2*fd**2*r**2 + 180*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 90*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s + 30*C*D1**2*fd**2 - 132*C*D1*Dd*f**2*r**2 - 264*C*D1*Dd*f**2*r*s + 132*C*D1*Dd*f**2*r - 132*C*D1*Dd*f**2*s**2 + 132*C*D1*Dd*f**2*s - 66*C*D1*Dd*f**2 + 360*C*D1*Dd*f*fd*r**2 + 720*C*D1*Dd*f*fd*r*s - 420*C*D1*Dd*f*fd*r + 360*C*D1*Dd*f*fd*s**2 - 420*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 60*C*D1*Ddd*f**2*r**2 + 120*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 60*C*D1*Ddd*f**2*s**2 - 60*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 180*C*Dd**2*f**2*r**2 + 360*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 180*C*Dd**2*f**2*s**2 - 180*C*Dd**2*f**2*s + 30*C*Dd**2*f**2 - 42*D1**2*bd1**2*(C - 1)*(r + s - 1)**2 + 3*D1**2*bdd1*f*(14*C + 11)*(r + s - 1)**2 - 42*D1**2*f*fd*r**2 - 84*D1**2*f*fd*r*s + 56*D1**2*f*fd*r - 42*D1**2*f*fd*s**2 + 56*D1**2*f*fd*s - 28*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 40*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 40*D1**2*f*fdd*s + 20*D1**2*f*fdd + 60*D1**2*fd**2*r**2 + 120*D1**2*fd**2*r*s - 80*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 80*D1**2*fd**2*s + 20*D1**2*fd**2 - 56*D1*Dd*f**2*r**2 - 112*D1*Dd*f**2*r*s + 56*D1*Dd*f**2*r - 56*D1*Dd*f**2*s**2 + 56*D1*Dd*f**2*s - 28*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 280*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 280*D1*Dd*f*fd*s + 80*D1*Dd*f*fd + 40*D1*Ddd*f**2*r**2 + 80*D1*Ddd*f**2*r*s - 40*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 40*D1*Ddd*f**2*s + 20*D1*Ddd*f**2 - 3*D1*bd1*(r + s - 1)*(D1*f*(35*C + 8)*(r + s - 1) - D1*fd*(28*C + 22)*(2*r + 2*s - 1) - Dd*f*(56*C + 44)*(2*r + 2*s - 1)) + 120*Dd**2*f**2*r**2 + 240*Dd**2*f**2*r*s - 120*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 120*Dd**2*f**2*s + 20*Dd**2*f**2))/(105*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct**2*k2**4*st**2*(D1*f*(-84*D1*bd1**2*(C + 1)*(r + s - 1)**2 + bd1*(C + 1)*(r + s - 1)*(D1*f*(r + s - 1) - 36*D1*fd*(2*r + 2*s - 1) - 72*Dd*f*(2*r + 2*s - 1)) - 9*f*(2*D1*bdd1*(C + 1)*(r + s - 1)**2 + (2*C + 1)*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))) + 7*b1**2*(D1**2*(r + s)**2*(fd*(17*C + 2) - fdd*(6*C + 6)) + 2*D1*(Dd*(f*(17*C + 2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(12*C + 12)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(-6*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(12*C + 12)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(14*D1*bd1*(r + s - 1)*(D1*f*(17*C + 2)*(r + s - 1) - D1*fd*(12*C + 12)*(r + s) - Dd*f*(24*C + 24)*(2*r + 2*s - 1)) - (C + 1)*(84*D1**2*bdd1*f*(r + s - 1)**2 + D1**2*(-f*(fd - 18*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 36*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*f*(-Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 36*Dd*fd*(2*r + 2*s - 1)**2 + 18*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 36*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1))))/(105*d**2*k3**6) - D1**2*Pk1*Pk2*ct**2*k2**2*st**6*(16*C - 16)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(63*d**2*k3**4) - 2*D1**2*Pk1*Pk2*ct**2*k2**2*st**4*(84*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 3*b1*(-234*C*D1**2*f*fd*r**2 - 692*C*D1**2*f*fd*r*s + 354*C*D1**2*f*fd*r - 458*C*D1**2*f*fd*s**2 + 466*C*D1**2*f*fd*s - 237*C*D1**2*f*fd + 166*C*D1**2*f*fdd*r**2 + 444*C*D1**2*f*fdd*r*s - 226*C*D1**2*f*fdd*r + 278*C*D1**2*f*fdd*s**2 - 282*C*D1**2*f*fdd*s + 143*C*D1**2*f*fdd + 166*C*D1**2*fd**2*r**2 + 444*C*D1**2*fd**2*r*s - 226*C*D1**2*fd**2*r + 278*C*D1**2*fd**2*s**2 - 282*C*D1**2*fd**2*s - 468*C*D1*Dd*f**2*r**2 - 1384*C*D1*Dd*f**2*r*s + 580*C*D1*Dd*f**2*r - 916*C*D1*Dd*f**2*s**2 + 804*C*D1*Dd*f**2*s - 346*C*D1*Dd*f**2 + 1328*C*D1*Dd*f*fd*r**2 + 3552*C*D1*Dd*f*fd*r*s - 1680*C*D1*Dd*f*fd*r + 2224*C*D1*Dd*f*fd*s**2 - 2128*C*D1*Dd*f*fd*s + 508*C*D1*Dd*f*fd + 332*C*D1*Ddd*f**2*r**2 + 888*C*D1*Ddd*f**2*r*s - 388*C*D1*Ddd*f**2*r + 556*C*D1*Ddd*f**2*s**2 - 500*C*D1*Ddd*f**2*s + 222*C*D1*Ddd*f**2 + 996*C*Dd**2*f**2*r**2 + 2664*C*Dd**2*f**2*r*s - 1164*C*Dd**2*f**2*r + 1668*C*Dd**2*f**2*s**2 - 1500*C*Dd**2*f**2*s + 222*C*Dd**2*f**2 - 28*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) + 294*D1**2*f*fd*r**2 + 420*D1**2*f*fd*r*s - 218*D1**2*f*fd*r + 126*D1**2*f*fd*s**2 - 134*D1**2*f*fd*s + 71*D1**2*f*fd - 196*D1**2*f*fdd*r**2 - 294*D1**2*f*fdd*r*s + 151*D1**2*f*fdd*r - 98*D1**2*f*fdd*s**2 + 102*D1**2*f*fdd*s - 53*D1**2*f*fdd - 196*D1**2*fd**2*r**2 - 294*D1**2*fd**2*r*s + 151*D1**2*fd**2*r - 98*D1**2*fd**2*s**2 + 102*D1**2*fd**2*s + 588*D1*Dd*f**2*r**2 + 840*D1*Dd*f**2*r*s - 504*D1*Dd*f**2*r + 252*D1*Dd*f**2*s**2 - 336*D1*Dd*f**2*s + 210*D1*Dd*f**2 - 1568*D1*Dd*f*fd*r**2 - 2352*D1*Dd*f*fd*r*s + 1290*D1*Dd*f*fd*r - 784*D1*Dd*f*fd*s**2 + 898*D1*Dd*f*fd*s - 253*D1*Dd*f*fd - 392*D1*Ddd*f**2*r**2 - 588*D1*Ddd*f**2*r*s + 343*D1*Ddd*f**2*r - 196*D1*Ddd*f**2*s**2 + 245*D1*Ddd*f**2*s - 147*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 1176*Dd**2*f**2*r**2 - 1764*Dd**2*f**2*r*s + 1029*Dd**2*f**2*r - 588*Dd**2*f**2*s**2 + 735*Dd**2*f**2*s - 147*Dd**2*f**2) + f*(-387*C*D1**2*f*fd*r**2 - 966*C*D1**2*f*fd*r*s + 580*C*D1**2*f*fd*r - 579*C*D1**2*f*fd*s**2 + 708*C*D1**2*f*fd*s - 322*C*D1**2*f*fd + 261*C*D1**2*f*fdd*r**2 + 582*C*D1**2*f*fdd*r*s - 368*C*D1**2*f*fdd*r + 321*C*D1**2*f*fdd*s**2 - 408*C*D1**2*f*fdd*s + 194*C*D1**2*f*fdd + 522*C*D1**2*fd**2*r**2 + 1164*C*D1**2*fd**2*r*s - 736*C*D1**2*fd**2*r + 642*C*D1**2*fd**2*s**2 - 816*C*D1**2*fd**2*s + 194*C*D1**2*fd**2 - 516*C*D1*Dd*f**2*r**2 - 1288*C*D1*Dd*f**2*r*s + 580*C*D1*Dd*f**2*r - 772*C*D1*Dd*f**2*s**2 + 708*C*D1*Dd*f**2*s - 322*C*D1*Dd*f**2 + 2088*C*D1*Dd*f*fd*r**2 + 4656*C*D1*Dd*f*fd*r*s - 2576*C*D1*Dd*f*fd*r + 2568*C*D1*Dd*f*fd*s**2 - 2856*C*D1*Dd*f*fd*s + 776*C*D1*Dd*f*fd + 348*C*D1*Ddd*f**2*r**2 + 776*C*D1*Ddd*f**2*r*s - 368*C*D1*Ddd*f**2*r + 428*C*D1*Ddd*f**2*s**2 - 408*C*D1*Ddd*f**2*s + 194*C*D1*Ddd*f**2 + 1044*C*Dd**2*f**2*r**2 + 2328*C*Dd**2*f**2*r*s - 1104*C*Dd**2*f**2*r + 1284*C*Dd**2*f**2*s**2 - 1224*C*Dd**2*f**2*s + 194*C*Dd**2*f**2 - 84*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) + 3*D1**2*bdd1*f*(r + s - 1)*(C*(83*r + 139*s - 79) - 98*r - 49*s + 94) + 525*D1**2*f*fd*r**2 + 582*D1**2*f*fd*r*s - 544*D1**2*f*fd*r + 57*D1**2*f*fd*s**2 - 232*D1**2*f*fd*s + 194*D1**2*f*fd - 366*D1**2*f*fdd*r**2 - 417*D1**2*f*fdd*r*s + 383*D1**2*f*fdd*r - 51*D1**2*f*fdd*s**2 + 173*D1**2*f*fdd*s - 139*D1**2*f*fdd - 732*D1**2*fd**2*r**2 - 834*D1**2*fd**2*r*s + 766*D1**2*fd**2*r - 102*D1**2*fd**2*s**2 + 346*D1**2*fd**2*s - 139*D1**2*fd**2 + 700*D1*Dd*f**2*r**2 + 776*D1*Dd*f**2*r*s - 544*D1*Dd*f**2*r + 76*D1*Dd*f**2*s**2 - 232*D1*Dd*f**2*s + 194*D1*Dd*f**2 - 2928*D1*Dd*f*fd*r**2 - 3336*D1*Dd*f*fd*r*s + 2681*D1*Dd*f*fd*r - 408*D1*Dd*f*fd*s**2 + 1211*D1*Dd*f*fd*s - 556*D1*Dd*f*fd - 488*D1*Ddd*f**2*r**2 - 556*D1*Ddd*f**2*r*s + 383*D1*Ddd*f**2*r - 68*D1*Ddd*f**2*s**2 + 173*D1*Ddd*f**2*s - 139*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r + s - 1)*(C*(117*r + 229*s - 109) - 147*r - 63*s + 139) + fd*(-2*C*(166*r**2 + 444*r*s - 275*r + 278*s**2 - 359*s + 111) + 392*r**2 + 588*r*s - 535*r + 196*s**2 - 388*s + 147)) + Dd*f*(-4*C*(166*r**2 + 37*r*(12*s - 7) + 278*s**2 - 343*s + 95) + 784*r**2 + 1176*r*s - 1111*r + 392*s**2 - 817*s + 335)) - 1464*Dd**2*f**2*r**2 - 1668*Dd**2*f**2*r*s + 1149*Dd**2*f**2*r - 204*Dd**2*f**2*s**2 + 519*Dd**2*f**2*s - 139*Dd**2*f**2))/(105*d**2*k3**4) + 2*D1**2*Pk1*Pk2*ct**2*k2**2*st**2*(7*b1**2*(D1**2*(r + s)*(fd*r*(63*C - 75) + fd*s*(39*C - 39) + fdd*r*(55 - 49*C) - fdd*s*(37*C - 37)) + 2*D1*(Dd*(3*f*(C*(42*r**2 + 68*r*s - 38*r + 26*s**2 - 30*s + 17) - 50*r**2 - 76*r*s + 44*r - 26*s**2 + 32*s - 19) + fd*(r**2*(220 - 196*C) + r*(-344*C*s + 92*C + 368*s - 101) + s*(-148*C*s + 80*C + 148*s - 83))) + Ddd*f*(-C*(98*r**2 + 172*r*s - 92*r + 74*s**2 - 80*s + 43) + 110*r**2 + 184*r*s - 101*r + 74*s**2 - 83*s + 46)) + 2*Dd**2*f*(-C*(294*r**2 + 516*r*s - 276*r + 222*s**2 - 240*s + 43) + 330*r**2 + 552*r*s - 303*r + 222*s**2 - 249*s + 46)) + b1*(-178*C*D1**2*f*fd*r**2 - 916*C*D1**2*f*fd*r*s + 346*C*D1**2*f*fd*r - 738*C*D1**2*f*fd*s**2 + 626*C*D1**2*f*fd*s - 257*C*D1**2*f*fd + 110*C*D1**2*f*fdd*r**2 + 724*C*D1**2*f*fdd*r*s - 278*C*D1**2*f*fdd*r + 614*C*D1**2*f*fdd*s**2 - 530*C*D1**2*f*fdd*s + 223*C*D1**2*f*fdd + 110*C*D1**2*fd**2*r**2 + 724*C*D1**2*fd**2*r*s - 278*C*D1**2*fd**2*r + 614*C*D1**2*fd**2*s**2 - 530*C*D1**2*fd**2*s - 356*C*D1*Dd*f**2*r**2 - 1832*C*D1*Dd*f**2*r*s + 636*C*D1*Dd*f**2*r - 1476*C*D1*Dd*f**2*s**2 + 1196*C*D1*Dd*f**2*s - 458*C*D1*Dd*f**2 + 880*C*D1*Dd*f*fd*r**2 + 5792*C*D1*Dd*f*fd*r*s - 2056*C*D1*Dd*f*fd*r + 4912*C*D1*Dd*f*fd*s**2 - 4072*C*D1*Dd*f*fd*s + 808*C*D1*Dd*f*fd + 220*C*D1*Ddd*f**2*r**2 + 1448*C*D1*Ddd*f**2*r*s - 472*C*D1*Ddd*f**2*r + 1228*C*D1*Ddd*f**2*s**2 - 976*C*D1*Ddd*f**2*s + 362*C*D1*Ddd*f**2 + 660*C*Dd**2*f**2*r**2 + 4344*C*Dd**2*f**2*r*s - 1416*C*Dd**2*f**2*r + 3684*C*Dd**2*f**2*s**2 - 2928*C*Dd**2*f**2*s + 362*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(r + s - 1)*(C*(49*r + 37*s - 43) - 55*r - 37*s + 46) - 340*D1**2*f*fd*r**2 - 1120*D1**2*f*fd*r*s + 728*D1**2*f*fd*r - 780*D1**2*f*fd*s**2 + 948*D1**2*f*fd*s - 558*D1**2*f*fd + 604*D1**2*f*fdd*r**2 + 1316*D1**2*f*fdd*r*s - 784*D1**2*f*fdd*r + 712*D1**2*f*fdd*s**2 - 838*D1**2*f*fdd*s + 482*D1**2*f*fdd + 604*D1**2*fd**2*r**2 + 1316*D1**2*fd**2*r*s - 784*D1**2*fd**2*r + 712*D1**2*fd**2*s**2 - 838*D1**2*fd**2*s - 680*D1*Dd*f**2*r**2 - 2240*D1*Dd*f**2*r*s + 900*D1*Dd*f**2*r - 1560*D1*Dd*f**2*s**2 + 1340*D1*Dd*f**2*s - 560*D1*Dd*f**2 + 4832*D1*Dd*f*fd*r**2 + 10528*D1*Dd*f*fd*r*s - 5660*D1*Dd*f*fd*r + 5696*D1*Dd*f*fd*s**2 - 6092*D1*Dd*f*fd*s + 1622*D1*Dd*f*fd + 1208*D1*Ddd*f**2*r**2 + 2632*D1*Ddd*f**2*r*s - 1262*D1*Ddd*f**2*r + 1424*D1*Ddd*f**2*s**2 - 1370*D1*Ddd*f**2*s + 658*D1*Ddd*f**2 + 14*D1*bd1*(D1*(3*f*(r + s - 1)*(C*(21*r + 13*s - 17) - 25*r - 13*s + 19) + fd*(r**2*(110 - 98*C) + r*(-172*C*s + 92*C + 184*s - 101) + s*(-74*C*s + 80*C + 74*s - 83))) + 2*Dd*f*(-2*C*(98*r**2 + 2*r*(86*s - 69) + 74*s**2 - 120*s + 43) + 220*r**2 + 368*r*s - 303*r + 148*s**2 - 249*s + 92)) + 3624*Dd**2*f**2*r**2 + 7896*Dd**2*f**2*r*s - 3786*Dd**2*f**2*r + 4272*Dd**2*f**2*s**2 - 4110*Dd**2*f**2*s + 658*Dd**2*f**2) + f*(-14*D1**2*bd1**2*(r + s - 1)*(C*(49*r + 37*s - 43) - 55*r - 37*s + 46) + D1**2*bdd1*f*(r + s - 1)*(C*(55*r + 307*s - 139) + 302*r + 356*s - 176) - 3*D1**2*(f*(fd*(2*C*(123*r**2 + 6*r*(37*s - 26) + 99*s**2 - 140*s + 74) - 3*r**2 + 2*r*(69*s - 22) + 141*s**2 - 140*s + 46) - fdd*(2*C*(93*r**2 + 6*r*(29*s - 20) + 81*s**2 - 112*s + 58) + 69*r**2 + 2*r*(99*s - 56) + 129*s**2 - 152*s + 66)) - 2*fd**2*(2*C*(93*r**2 + 6*r*(29*s - 20) + 81*s**2 - 112*s + 29) + 69*r**2 + 2*r*(99*s - 56) + 129*s**2 - 152*s + 33)) + D1*bd1*(D1*(-f*(r + s - 1)*(C*(89*r + 369*s - 201) + 170*r + 390*s - 2) + 2*fd*(C*(110*r**2 + 724*r*s - 333*r + 614*s**2 - 711*s + 181) + 604*r**2 + 1316*r*s - 870*r + 712*s**2 - 951*s + 329)) + 2*Dd*f*(4*C*(55*r**2 + 362*r*s - 156*r + 307*s**2 - 345*s + 80) + 1208*r**2 + 2632*r*s - 1587*r + 1424*s**2 - 1749*s + 505)) - 6*D1*f*(Dd*(f*(2*C*(82*r**2 + 148*r*s - 78*r + 66*s**2 - 70*s + 37) - 2*r**2 + 92*r*s - 22*r + 94*s**2 - 70*s + 23) - 4*fd*(2*C*(93*r**2 + 3*r*(58*s - 35) + 81*s**2 - 98*s + 29) + 69*r**2 + 198*r*s - 98*r + 129*s**2 - 133*s + 33)) - Ddd*f*(2*C*(62*r**2 + 116*r*s - 60*r + 54*s**2 - 56*s + 29) + 46*r**2 + 132*r*s - 56*r + 86*s**2 - 76*s + 33)) + 6*Dd**2*f**2*(C*(372*r**2 + 24*r*(29*s - 15) + 324*s**2 - 336*s + 58) + 138*r**2 + 12*r*(33*s - 14) + 258*s**2 - 228*s + 33)))/(105*d**2*k3**4) - 2*D1**2*Pk1*Pk2*ct**2*k2**2*(D1*f*(-14*D1*bd1**2*(r + s - 1)*(25*C*(r + s - 1) + 16*r + 34*s - 25) + 3*bd1*(D1*(f*(r + s - 1)*(125*C*r + 21*C*(s - 1) - 27*r + 30*s - 23) - 2*fd*(C*(118*r**2 + r*(188*s - 153) + 70*s**2 - 117*s + 47) + 64*r**2 + 2*r*(82*s - 57) + 100*s**2 - 141*s + 41)) - 2*Dd*f*(2*C*(118*r**2 + r*(188*s - 147) + 70*s**2 - 111*s + 41) + 128*r**2 + r*(328*s - 237) + 200*s**2 - 291*s + 91)) - 3*f*(D1*bdd1*(r + s - 1)*(59*C*r + 35*C*(s - 1) + 32*r + 50*s - 50) + 5*D1*fd*(3*r**2 + 3*r*(s - 1) - s + 1) + 5*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1))) + 7*b1**2*(D1**2*(r + s)*(fd*(r*(55*C - 28) + s*(15*C + 18)) - fdd*(r*(25*C + 16) + s*(25*C + 34))) + 2*D1*(Dd*(f*(5*C*(22*r**2 + 28*r*s - 18*r + 6*s**2 - 10*s + 7) - 56*r**2 - 20*r*s + 33*r + 36*s**2 - 13*s - 5) - fd*(r**2*(100*C + 64) + r*(50*C*(4*s - 1) + 200*s - 41) + s*(50*C*(2*s - 1) + 136*s - 59))) - Ddd*f*(25*C*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 32*r**2 + 100*r*s - 41*r + 68*s**2 - 59*s + 25)) - 2*Dd**2*f*(25*C*(6*r**2 + 12*r*s - 6*r + 6*s**2 - 6*s + 1) + 96*r**2 + 300*r*s - 123*r + 204*s**2 - 177*s + 25)) + b1*(-14*D1**2*bdd1*f*(r + s - 1)*(25*C*(r + s - 1) + 16*r + 34*s - 25) + 3*D1**2*(f*(fd*(C*(250*r**2 + 292*r*s - 250*r + 42*s**2 - 146*s + 125) - 54*r**2 + 6*r*s + 47*r + 60*s**2 - 10*s - 20) - fdd*(C*(118*r**2 + 2*r*(94*s - 59) + 70*s**2 - 94*s + 59) + 64*r**2 + 2*r*(82*s - 32) + 100*s**2 - 82*s + 32)) - 2*fd**2*(r**2*(59*C + 32) + r*(94*C*s - 59*C + 82*s - 32) + s*(35*C*s - 47*C + 50*s - 41))) + 14*D1*bd1*(D1*(f*(r + s - 1)*(5*C*(11*r + 3*s - 7) - 28*r + 18*s + 5) - fd*(r**2*(50*C + 32) + r*(50*C*(2*s - 1) + 100*s - 41) + s*(50*C*(s - 1) + 68*s - 59))) - 2*Dd*f*(50*C*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 64*r**2 + 200*r*s - 123*r + 136*s**2 - 177*s + 50)) + 3*D1*f*(Dd*(f*(2*C*(250*r**2 + 292*r*s - 198*r + 42*s**2 - 94*s + 73) - 108*r**2 + 12*r*s + 51*r + 120*s**2 - 63*s + 3) - 2*fd*(2*r + 2*s - 1)*(2*C*(118*r + 70*s - 53) + 128*r + 200*s - 73)) - 2*Ddd*f*(C*(118*r**2 + 2*r*(94*s - 53) + 70*s**2 - 82*s + 47) + 64*r**2 + 164*r*s - 73*r + 100*s**2 - 91*s + 41)) - 6*Dd**2*f**2*(C*(354*r**2 + 6*r*(94*s - 53) + 210*s**2 - 246*s + 47) + 192*r**2 + 492*r*s - 219*r + 300*s**2 - 273*s + 41)))/(105*d**2*k3**4) - D1**2*Pk1*Pk2*ct**2*st**6*(8*C - 8)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k3**2) + 12*D1**2*Pk1*Pk2*ct**2*st**4*(D1**2*(5*f**3*(20*fd*(4*s**2 - 2*s + 1) - 10*fdd*(4*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + f**2*s*(-330*bd1**2*s - 22*bd1*(15*fd*(3*s - 1) + s*(K - 1)) - 300*fd**2*(2*s - 1) + s*(11*bdd1*(K - 1) + 44*gd2 - 22*gdd2)) + 22*f*(fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - fdd*g2*(2*s**2 - 2*s + 1) + s**2*(7*bd1**2*(K - 1) + 14*bd1*(g2 - gd2) - 7*bdd1*g2)) - 44*fd*g2*s*(7*bd1 + fd)*(s - 1)) + 2*D1*f*(Dd*(50*f**3*(4*s**2 - 2*s + 1) - 5*f**2*(4*s - 1)*(33*bd1*s + 10*fd*(4*s - 1)) + 11*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 22*g2*(4*s - 1)*(7*bd1*s + fd*(2*s - 1))) - Ddd*f*(25*f**2 + 11*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(25*f**2 + 11*g2)*(2*s - 1) + 11*b1**2*(D1**2*(30*f*fd*(2*s**2 - 2*s + 1) - 15*f*fdd*(2*s**2 - 2*s + 1) - 30*fd**2*s*(s - 1) - 14*fd*(K - 1)*(s - 1)**2 + 7*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(15*f**2*(4*s**2 - 2*s + 1) - 15*f*fd*(8*s**2 - 6*s + 1) - 7*f*(K - 1)*(4*s**2 - 2*s + 1) + 7*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-7*K + 15*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-7*K + 15*f + 7)) + 11*b1*(D1**2*(-15*f**2*(fd*(-6*s**2 + 4*s - 2) + fdd*(3*s**2 - 2*s + 1) + s**2*(-4*bd1 + 2*bdd1)) + f*(30*fd**2*s*(2 - 3*s) - 2*fd*(K*(2*s**2 - 2*s + 1) + s**2*(60*bd1 - 2) + s*(2 - 30*bd1) - 1) + fdd*(K - 1)*(2*s**2 - 2*s + 1) - s**2*(-14*K*bdd1 + 28*bd1*(K - 1) + 14*bdd1 - 28*gd2 + 14*gdd2)) + (2*s - 2)*(fd**2*s*(K - 1) + 14*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(15*f**3*(4*s**2 - 2*s + 1) - f**2*(4*K*s**2 - 2*K*s + K + 120*bd1*s**2 - 30*bd1*s + 15*fd*(12*s**2 - 7*s + 1) - 4*s**2 + 2*s - 1) + f*(fd*(K - 1)*(8*s**2 - 6*s + 1) + 14*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(14*K*bd1 - 14*bd1 - 14*gd2)) - 14*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(-K*f + 15*f**2 + f + 14*g2)) - 6*Dd**2*f*s*(2*s - 1)*(-K*f + 15*f**2 + f + 14*g2)))/(385*d**2*k2**2) + 2*D1**2*Pk1*Pk2*ct**2*st**2*(-7238*D1**2*K*bd1**2*f*s**2 - 308*D1**2*K*bd1**2*f*s + 1969*D1**2*K*bd1*f**2*s**2 - 4708*D1**2*K*bd1*f*fd*s**2 + 2354*D1**2*K*bd1*f*fd*s - 1177*D1**2*K*bdd1*f**2*s**2 + 1848*D1**2*bd1**2*f**2*r*s + 5148*D1**2*bd1**2*f**2*s**2 + 1452*D1**2*bd1**2*f**2*s + 1848*D1**2*bd1**2*f*r*s + 3542*D1**2*bd1**2*f*s**2 - 616*D1**2*bd1**2*f*s - 3080*D1**2*bd1**2*g2*s**2 + 3080*D1**2*bd1**2*g2*s - 1848*D1**2*bd1*bd2*f*s**2 - 1408*D1**2*bd1*f**3*r*s - 6402*D1**2*bd1*f**3*s**2 - 1056*D1**2*bd1*f**3*s + 880*D1**2*bd1*f**3 + 8976*D1**2*bd1*f**2*fd*r*s - 1496*D1**2*bd1*f**2*fd*r + 28116*D1**2*bd1*f**2*fd*s**2 - 10604*D1**2*bd1*f**2*fd*s + 748*D1**2*bd1*f**2*fd - 1232*D1**2*bd1*f**2*r*s - 385*D1**2*bd1*f**2*s**2 + 3696*D1**2*bd1*f*fd*r*s - 924*D1**2*bd1*f*fd*r + 1540*D1**2*bd1*f*fd*s**2 - 1694*D1**2*bd1*f*fd*s - 10626*D1**2*bd1*f*g2*s**2 - 1232*D1**2*bd1*f*g2*s + 616*D1**2*bd1*f*g2 + 14476*D1**2*bd1*f*gd2*s**2 + 616*D1**2*bd1*f*gd2*s + 14476*D1**2*bd1*fd*g2*s**2 - 14476*D1**2*bd1*fd*g2*s + 792*D1**2*bd2*f**2*s**2 - 1584*D1**2*bd2*f*fd*s**2 + 792*D1**2*bd2*f*fd*s + 1496*D1**2*bdd1*f**3*r*s + 4686*D1**2*bdd1*f**3*s**2 + 132*D1**2*bdd1*f**3*s - 440*D1**2*bdd1*f**3 + 924*D1**2*bdd1*f**2*r*s + 385*D1**2*bdd1*f**2*s**2 + 7238*D1**2*bdd1*f*g2*s**2 + 616*D1**2*bdd1*f*g2*s - 308*D1**2*bdd1*f*g2 - 396*D1**2*bdd2*f**2*s**2 - 1680*D1**2*f**3*fd*r*s + 420*D1**2*f**3*fd*r - 11440*D1**2*f**3*fd*s**2 + 6140*D1**2*f**3*fd*s - 2860*D1**2*f**3*fd + 2160*D1**2*f**3*fdd*r*s - 540*D1**2*f**3*fdd*r + 7920*D1**2*f**3*fdd*s**2 - 4500*D1**2*f**3*fdd*s + 1980*D1**2*f**3*fdd + 6480*D1**2*f**2*fd**2*r*s - 1620*D1**2*f**2*fd**2*r + 23760*D1**2*f**2*fd**2*s**2 - 13500*D1**2*f**2*fd**2*s + 540*D1**2*f**2*fd**2 - 3938*D1**2*f**2*gd2*s**2 + 2354*D1**2*f**2*gdd2*s**2 - 7876*D1**2*f*fd*g2*s**2 + 7876*D1**2*f*fd*g2*s - 3938*D1**2*f*fd*g2 + 9416*D1**2*f*fd*gd2*s**2 - 4708*D1**2*f*fd*gd2*s + 4708*D1**2*f*fdd*g2*s**2 - 4708*D1**2*f*fdd*g2*s + 2354*D1**2*f*fdd*g2 + 4708*D1**2*fd**2*g2*s**2 - 4708*D1**2*fd**2*g2*s - 9416*D1*Dd*K*bd1*f**2*s**2 + 2354*D1*Dd*K*bd1*f**2*s + 11968*D1*Dd*bd1*f**3*r*s - 1496*D1*Dd*bd1*f**3*r + 37488*D1*Dd*bd1*f**3*s**2 - 10340*D1*Dd*bd1*f**3*s - 132*D1*Dd*bd1*f**3 + 7392*D1*Dd*bd1*f**2*r*s - 924*D1*Dd*bd1*f**2*r + 3080*D1*Dd*bd1*f**2*s**2 - 1694*D1*Dd*bd1*f**2*s + 57904*D1*Dd*bd1*f*g2*s**2 - 12012*D1*Dd*bd1*f*g2*s - 616*D1*Dd*bd1*f*g2 - 3168*D1*Dd*bd2*f**2*s**2 + 792*D1*Dd*bd2*f**2*s - 1680*D1*Dd*f**4*r*s + 420*D1*Dd*f**4*r - 11440*D1*Dd*f**4*s**2 + 6140*D1*Dd*f**4*s - 2860*D1*Dd*f**4 + 17280*D1*Dd*f**3*fd*r*s - 4320*D1*Dd*f**3*fd*r + 63360*D1*Dd*f**3*fd*s**2 - 36000*D1*Dd*f**3*fd*s + 5040*D1*Dd*f**3*fd - 15752*D1*Dd*f**2*g2*s**2 + 7876*D1*Dd*f**2*g2*s - 3938*D1*Dd*f**2*g2 + 18832*D1*Dd*f**2*gd2*s**2 - 4708*D1*Dd*f**2*gd2*s + 37664*D1*Dd*f*fd*g2*s**2 - 28248*D1*Dd*f*fd*g2*s + 4708*D1*Dd*f*fd*g2 + 2160*D1*Ddd*f**4*r*s - 540*D1*Ddd*f**4*r + 7920*D1*Ddd*f**4*s**2 - 4500*D1*Ddd*f**4*s + 1980*D1*Ddd*f**4 + 9416*D1*Ddd*f**2*g2*s**2 - 4708*D1*Ddd*f**2*g2*s + 2354*D1*Ddd*f**2*g2 + 6480*Dd**2*f**4*r*s - 1620*Dd**2*f**4*r + 23760*Dd**2*f**4*s**2 - 13500*Dd**2*f**4*s + 540*Dd**2*f**4 + 28248*Dd**2*f**2*g2*s**2 - 14124*Dd**2*f**2*g2*s + 154*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-5*K*(4*s**2 - 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s + 20*s**2 - 10*s + 5) - D1*Ddd*(-5*K + 6*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-5*K + 6*f + 5)) + 11*b1**2*(483*D1**2*K*fd*s**2 - 1022*D1**2*K*fd*s + 511*D1**2*K*fd - 329*D1**2*K*fdd*s**2 + 686*D1**2*K*fdd*s - 343*D1**2*K*fdd - 14*D1**2*bdd1*(-5*K + 6*f + 5)*(3*s**2 - 2*s + 1) - 168*D1**2*f*fd*r*s + 84*D1**2*f*fd*r - 516*D1**2*f*fd*s**2 + 948*D1**2*f*fd*s - 474*D1**2*f*fd + 168*D1**2*f*fdd*r*s - 84*D1**2*f*fdd*r + 468*D1**2*f*fdd*s**2 - 684*D1**2*f*fdd*s + 342*D1**2*f*fdd + 168*D1**2*fd**2*r*s - 84*D1**2*fd**2*r + 468*D1**2*fd**2*s**2 - 684*D1**2*fd**2*s - 168*D1**2*fd*r*s + 168*D1**2*fd*r - 147*D1**2*fd*s**2 + 350*D1**2*fd*s - 175*D1**2*fd + 84*D1**2*fdd*r*s - 84*D1**2*fdd*r + 161*D1**2*fdd*s**2 - 350*D1**2*fdd*s + 175*D1**2*fdd + 280*D1**2*gd2*s**2 - 140*D1**2*gdd2*s**2 + 1932*D1*Dd*K*f*s**2 - 966*D1*Dd*K*f*s + 483*D1*Dd*K*f - 2632*D1*Dd*K*fd*s**2 + 3402*D1*Dd*K*fd*s - 686*D1*Dd*K*fd - 336*D1*Dd*f**2*r*s + 84*D1*Dd*f**2*r - 1032*D1*Dd*f**2*s**2 + 600*D1*Dd*f**2*s - 258*D1*Dd*f**2 + 1344*D1*Dd*f*fd*r*s - 504*D1*Dd*f*fd*r + 3744*D1*Dd*f*fd*s**2 - 3840*D1*Dd*f*fd*s + 768*D1*Dd*f*fd - 672*D1*Dd*f*r*s + 168*D1*Dd*f*r - 588*D1*Dd*f*s**2 + 462*D1*Dd*f*s - 147*D1*Dd*f + 672*D1*Dd*fd*r*s - 420*D1*Dd*fd*r + 1288*D1*Dd*fd*s**2 - 1806*D1*Dd*fd*s + 434*D1*Dd*fd + 1120*D1*Dd*g2*s**2 - 560*D1*Dd*g2*s + 280*D1*Dd*g2 - 1120*D1*Dd*gd2*s**2 + 280*D1*Dd*gd2*s - 1316*D1*Ddd*K*f*s**2 + 658*D1*Ddd*K*f*s - 329*D1*Ddd*K*f + 336*D1*Ddd*f**2*r*s - 84*D1*Ddd*f**2*r + 936*D1*Ddd*f**2*s**2 - 552*D1*Ddd*f**2*s + 234*D1*Ddd*f**2 + 336*D1*Ddd*f*r*s - 84*D1*Ddd*f*r + 644*D1*Ddd*f*s**2 - 406*D1*Ddd*f*s + 161*D1*Ddd*f - 560*D1*Ddd*g2*s**2 + 280*D1*Ddd*g2*s - 140*D1*Ddd*g2 + 28*D1*bd1*(D1*(-5*K*(3*s**2 - 2*s + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s + 15*s**2 - 10*s + 5) - Dd*(-5*K + 6*f + 5)*(12*s**2 - 7*s + 1)) - 3948*Dd**2*K*f*s**2 + 1974*Dd**2*K*f*s + 1008*Dd**2*f**2*r*s - 252*Dd**2*f**2*r + 2808*Dd**2*f**2*s**2 - 1656*Dd**2*f**2*s + 84*Dd**2*f**2 + 1008*Dd**2*f*r*s - 252*Dd**2*f*r + 1932*Dd**2*f*s**2 - 1218*Dd**2*f*s + 84*Dd**2*f - 1680*Dd**2*g2*s**2 + 840*Dd**2*g2*s) - 11*b1*(-358*D1**2*K*f*fd*s**2 + 358*D1**2*K*f*fd*s - 179*D1**2*K*f*fd + 214*D1**2*K*f*fdd*s**2 - 214*D1**2*K*f*fdd*s + 107*D1**2*K*f*fdd + 214*D1**2*K*fd**2*s**2 - 214*D1**2*K*fd**2*s - 168*D1**2*b2*fd*s**2 + 336*D1**2*b2*fd*s - 168*D1**2*b2*fd + 84*D1**2*b2*fdd*s**2 - 168*D1**2*b2*fdd*s + 84*D1**2*b2*fdd + 28*D1**2*bd1**2*s*(3*s - 2)*(-5*K + 6*f + 5) - 168*D1**2*bd2*f*s**2 + 168*D1**2*bd2*fd*s**2 - 168*D1**2*bd2*fd*s - 2*D1**2*bdd1*(6*f**2*(39*s**2 + s*(14*r + 11) - 9) + 7*f*(-47*K*s**2 - 2*K*s + K + 12*r*s + 23*s**2 - 4*s - 1) - 70*g2*(2*s**2 - 2*s + 1)) + 84*D1**2*bdd2*f*s**2 + 384*D1**2*f**2*fd*r*s - 128*D1**2*f**2*fd*r + 1746*D1**2*f**2*fd*s**2 - 1388*D1**2*f**2*fd*s + 662*D1**2*f**2*fd - 408*D1**2*f**2*fdd*r*s + 136*D1**2*f**2*fdd*r - 1278*D1**2*f**2*fdd*s**2 + 1000*D1**2*f**2*fdd*s - 466*D1**2*f**2*fdd - 816*D1**2*f*fd**2*r*s + 272*D1**2*f*fd**2*r - 2556*D1**2*f*fd**2*s**2 + 2000*D1**2*f*fd**2*s - 68*D1**2*f*fd**2 + 224*D1**2*f*fd*r*s - 112*D1**2*f*fd*r + 70*D1**2*f*fd*s**2 - 182*D1**2*f*fd*s + 35*D1**2*f*fd - 168*D1**2*f*fdd*r*s + 84*D1**2*f*fdd*r - 70*D1**2*f*fdd*s**2 + 154*D1**2*f*fdd*s - 35*D1**2*f*fdd + 966*D1**2*f*gd2*s**2 - 658*D1**2*f*gdd2*s**2 - 168*D1**2*fd**2*r*s + 84*D1**2*fd**2*r - 70*D1**2*fd**2*s**2 + 154*D1**2*fd**2*s - 84*D1**2*fd**2 + 966*D1**2*fd*g2*s**2 - 2044*D1**2*fd*g2*s + 1022*D1**2*fd*g2 - 1316*D1**2*fd*gd2*s**2 + 1372*D1**2*fd*gd2*s - 658*D1**2*fdd*g2*s**2 + 1372*D1**2*fdd*g2*s - 686*D1**2*fdd*g2 - 716*D1*Dd*K*f**2*s**2 + 358*D1*Dd*K*f**2*s - 179*D1*Dd*K*f**2 + 1712*D1*Dd*K*f*fd*s**2 - 1284*D1*Dd*K*f*fd*s + 214*D1*Dd*K*f*fd - 672*D1*Dd*b2*f*s**2 + 336*D1*Dd*b2*f*s - 168*D1*Dd*b2*f + 672*D1*Dd*b2*fd*s**2 - 840*D1*Dd*b2*fd*s + 168*D1*Dd*b2*fd + 672*D1*Dd*bd2*f*s**2 - 168*D1*Dd*bd2*f*s + 512*D1*Dd*f**3*r*s - 128*D1*Dd*f**3*r + 2328*D1*Dd*f**3*s**2 - 1292*D1*Dd*f**3*s + 582*D1*Dd*f**3 - 3264*D1*Dd*f**2*fd*r*s + 952*D1*Dd*f**2*fd*r - 10224*D1*Dd*f**2*fd*s**2 + 6964*D1*Dd*f**2*fd*s - 1136*D1*Dd*f**2*fd + 448*D1*Dd*f**2*r*s - 112*D1*Dd*f**2*r + 140*D1*Dd*f**2*s**2 - 182*D1*Dd*f**2*s + 35*D1*Dd*f**2 - 1344*D1*Dd*f*fd*r*s + 504*D1*Dd*f*fd*r - 560*D1*Dd*f*fd*s**2 + 924*D1*Dd*f*fd*s - 238*D1*Dd*f*fd + 3864*D1*Dd*f*g2*s**2 - 1932*D1*Dd*f*g2*s + 966*D1*Dd*f*g2 - 5264*D1*Dd*f*gd2*s**2 + 1316*D1*Dd*f*gd2*s - 5264*D1*Dd*fd*g2*s**2 + 6804*D1*Dd*fd*g2*s - 1372*D1*Dd*fd*g2 + 428*D1*Ddd*K*f**2*s**2 - 214*D1*Ddd*K*f**2*s + 107*D1*Ddd*K*f**2 + 336*D1*Ddd*b2*f*s**2 - 168*D1*Ddd*b2*f*s + 84*D1*Ddd*b2*f - 544*D1*Ddd*f**3*r*s + 136*D1*Ddd*f**3*r - 1704*D1*Ddd*f**3*s**2 + 988*D1*Ddd*f**3*s - 426*D1*Ddd*f**3 - 336*D1*Ddd*f**2*r*s + 84*D1*Ddd*f**2*r - 140*D1*Ddd*f**2*s**2 + 154*D1*Ddd*f**2*s - 35*D1*Ddd*f**2 - 2632*D1*Ddd*f*g2*s**2 + 1316*D1*Ddd*f*g2*s - 658*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(6*f**2*(43*s**2 + s*(14*r + 29) - 18) - f*(7*K*(69*s**2 + 4*s - 2) + 6*fd*(14*r*(4*s - 1) + 156*s**2 - 92*s + 7) - 168*r*s - 147*s**2 + 56*s + 14) - 14*fd*(6*r*(2*s - 1) + s**2*(23 - 47*K) + s*(48*K - 27) + 3) - 140*g2*(2*s**2 - 2*s + 1) - 140*gd2*s*(1 - 2*s)) - 2*Dd*(3*f**2*(14*r*(8*s - 1) + 312*s**2 - 48*s - 11) + 7*f*(-188*K*s**2 + 43*K*s + K + 48*r*s - 6*r + 92*s**2 - 37*s + 2) - 70*g2*(8*s**2 - 6*s + 1))) + 1284*Dd**2*K*f**2*s**2 - 642*Dd**2*K*f**2*s + 1008*Dd**2*b2*f*s**2 - 504*Dd**2*b2*f*s - 1632*Dd**2*f**3*r*s + 408*Dd**2*f**3*r - 5112*Dd**2*f**3*s**2 + 2964*Dd**2*f**3*s - 136*Dd**2*f**3 - 1008*Dd**2*f**2*r*s + 252*Dd**2*f**2*r - 420*Dd**2*f**2*s**2 + 462*Dd**2*f**2*s - 84*Dd**2*f**2 - 7896*Dd**2*f*g2*s**2 + 3948*Dd**2*f*g2*s) + 132*b2*(D1**2*(f*(6*fd*(2*s**2 - 2*s + 1) + fdd*(-6*s**2 + 6*s - 3) + s**2*(14*bd1 - 7*bdd1)) - 2*fd*s*(7*bd1 + 3*fd)*(s - 1)) + D1*f*(6*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(7*bd1*s + fd*(6*s - 3)) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(1155*d**2*k2**2) - D1**2*Pk1*Pk2*ct**2*(-717*D1**2*K*bdd1*f**2*s**2 - 525*D1**2*b2*bdd1*f*s**2 + 882*D1**2*b2*f*fd*s**2 - 882*D1**2*b2*f*fd*s + 441*D1**2*b2*f*fd - 630*D1**2*b2*f*fdd*s**2 + 630*D1**2*b2*f*fdd*s - 315*D1**2*b2*f*fdd - 630*D1**2*b2*fd**2*s**2 + 630*D1**2*b2*fd**2*s - 3*D1**2*bd1**2*(3*f**2*(2*r*(9*s - 22) + 140*s**2 - 197*s + 22) + 7*f*(-2*r*(s + 7) + s*(92*K*s + 34*K + 8*s - 19)) + 980*g2*s*(s - 1)) + 441*D1**2*bd2*f**2*s**2 - 1260*D1**2*bd2*f*fd*s**2 + 630*D1**2*bd2*f*fd*s + 424*D1**2*bdd1*f**3*r*s + 170*D1**2*bdd1*f**3*r + 459*D1**2*bdd1*f**3*s**2 + 603*D1**2*bdd1*f**3*s - 450*D1**2*bdd1*f**3 + 393*D1**2*bdd1*f**2*r*s + 87*D1**2*bdd1*f**2*s**2 + 1932*D1**2*bdd1*f*g2*s**2 + 1428*D1**2*bdd1*f*g2*s - 714*D1**2*bdd1*f*g2 - 315*D1**2*bdd2*f**2*s**2 - 1020*D1**2*f**3*fd*r*s + 255*D1**2*f**3*fd*r - 2160*D1**2*f**3*fd*s**2 + 1335*D1**2*f**3*fd*s - 540*D1**2*f**3*fd + 1020*D1**2*f**3*fdd*r*s - 255*D1**2*f**3*fdd*r + 2160*D1**2*f**3*fdd*s**2 - 1335*D1**2*f**3*fdd*s + 540*D1**2*f**3*fdd + 3060*D1**2*f**2*fd**2*r*s - 765*D1**2*f**2*fd**2*r + 6480*D1**2*f**2*fd**2*s**2 - 4005*D1**2*f**2*fd**2*s + 255*D1**2*f**2*fd**2 - 1650*D1**2*f**2*gd2*s**2 + 1434*D1**2*f**2*gdd2*s**2 - 3300*D1**2*f*fd*g2*s**2 + 3300*D1**2*f*fd*g2*s - 1650*D1**2*f*fd*g2 + 5736*D1**2*f*fd*gd2*s**2 - 2868*D1**2*f*fd*gd2*s + 2868*D1**2*f*fdd*g2*s**2 - 2868*D1**2*f*fdd*g2*s + 1434*D1**2*f*fdd*g2 + 2868*D1**2*fd**2*g2*s**2 - 2868*D1**2*fd**2*g2*s + 1764*D1*Dd*b2*f**2*s**2 - 882*D1*Dd*b2*f**2*s + 441*D1*Dd*b2*f**2 - 5040*D1*Dd*b2*f*fd*s**2 + 3780*D1*Dd*b2*f*fd*s - 630*D1*Dd*b2*f*fd - 2520*D1*Dd*bd2*f**2*s**2 + 630*D1*Dd*bd2*f**2*s - 1020*D1*Dd*f**4*r*s + 255*D1*Dd*f**4*r - 2160*D1*Dd*f**4*s**2 + 1335*D1*Dd*f**4*s - 540*D1*Dd*f**4 + 8160*D1*Dd*f**3*fd*r*s - 2040*D1*Dd*f**3*fd*r + 17280*D1*Dd*f**3*fd*s**2 - 10680*D1*Dd*f**3*fd*s + 1590*D1*Dd*f**3*fd - 6600*D1*Dd*f**2*g2*s**2 + 3300*D1*Dd*f**2*g2*s - 1650*D1*Dd*f**2*g2 + 11472*D1*Dd*f**2*gd2*s**2 - 2868*D1*Dd*f**2*gd2*s + 22944*D1*Dd*f*fd*g2*s**2 - 17208*D1*Dd*f*fd*g2*s + 2868*D1*Dd*f*fd*g2 - 1260*D1*Ddd*b2*f**2*s**2 + 630*D1*Ddd*b2*f**2*s - 315*D1*Ddd*b2*f**2 + 1020*D1*Ddd*f**4*r*s - 255*D1*Ddd*f**4*r + 2160*D1*Ddd*f**4*s**2 - 1335*D1*Ddd*f**4*s + 540*D1*Ddd*f**4 + 5736*D1*Ddd*f**2*g2*s**2 - 2868*D1*Ddd*f**2*g2*s + 1434*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-f**3*(344*r*s + 250*r + 189*s**2 + 963*s - 630) + f**2*(fd*(12*r*(212*s - 7) + 2754*s**2 - 136*s + 127) + 3*s*(-185*r + s*(275*K + 19))) + 3*f*(131*fd*r*(4*s - 1) + fd*s*(-478*K*(2*s - 1) + 116*s - 189) - 14*g2*(52*s**2 + 38*s - 19) + 7*s*(35*b2*s - 50*bd2*s + 184*gd2*s + 68*gd2)) - 42*fd*s*(25*b2 - 92*g2)*(s - 1)) + Dd*f*(f**2*(64*r*(53*s + 4) + 3672*s**2 + 1070*s - 773) + 3*f*(131*r*(8*s - 1) + s*(-478*K*(4*s - 1) + 232*s - 189)) + (168*s - 42)*(-25*b2*s + g2*(92*s + 34)))) - 3780*Dd**2*b2*f**2*s**2 + 1890*Dd**2*b2*f**2*s + 3060*Dd**2*f**4*r*s - 765*Dd**2*f**4*r + 6480*Dd**2*f**4*s**2 - 4005*Dd**2*f**4*s + 255*Dd**2*f**4 + 17208*Dd**2*f**2*g2*s**2 - 8604*Dd**2*f**2*g2*s + 105*b1**3*(D1**2*s*(2*fd*r + 7*fd*s - 2*fdd*r - 5*fdd*s) + D1*(Dd*(-5*K*(4*s**2 - 2*s + 1) + f*(r*(8*s - 2) + 28*s**2 - 16*s + 7) - 16*fd*r*s + 2*fd*r - 40*fd*s**2 + 12*fd*s + 16*r*s - 4*r + 20*s**2 - 14*s + 5) + Ddd*(7*K*(4*s**2 - 2*s + 1) + f*(r*(2 - 8*s) - 20*s**2 + 12*s - 5) - 8*r*s + 2*r - 28*s**2 + 16*s - 7)) - 2*Dd**2*(-42*K*s**2 + 21*K*s + f*(3*r*(4*s - 1) + 30*s**2 - 18*s + 1) + 3*r*(4*s - 1) + 42*s**2 - 24*s + 1)) + 3*b1**2*(364*D1**2*K*fd*s**2 - 994*D1**2*K*fd*s + 497*D1**2*K*fd - 322*D1**2*K*fdd*s**2 + 882*D1**2*K*fdd*s - 441*D1**2*K*fdd - 35*D1**2*bdd1*(-7*K*(3*s**2 - 2*s + 1) + f*(r*(6*s - 2) + 15*s**2 - 12*s + 5) + 6*r*s - 2*r + 21*s**2 - 16*s + 7) + 150*D1**2*f*fd*r*s + 105*D1**2*f*fd*r + 756*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 63*D1**2*f*fd - 54*D1**2*f*fdd*r*s - 105*D1**2*f*fdd*r - 420*D1**2*f*fdd*s**2 - 144*D1**2*f*fdd*s + 105*D1**2*f*fdd - 54*D1**2*fd**2*r*s - 105*D1**2*fd**2*r - 420*D1**2*fd**2*s**2 - 144*D1**2*fd**2*s + 21*D1**2*fd*r*s + 175*D1**2*fd*r + 126*D1**2*fd*s**2 - 182*D1**2*fd*s - 7*D1**2*fd + 7*D1**2*fdd*r*s - 105*D1**2*fdd*r - 28*D1**2*fdd*s**2 - 84*D1**2*fdd*s + 91*D1**2*fdd + 350*D1**2*gd2*s**2 - 490*D1**2*gdd2*s**2 + 1456*D1*Dd*K*f*s**2 - 728*D1*Dd*K*f*s + 364*D1*Dd*K*f - 2576*D1*Dd*K*fd*s**2 + 4172*D1*Dd*K*fd*s - 882*D1*Dd*K*fd + 300*D1*Dd*f**2*r*s - 75*D1*Dd*f**2*r + 1512*D1*Dd*f**2*s**2 - 831*D1*Dd*f**2*s + 378*D1*Dd*f**2 - 432*D1*Dd*f*fd*r*s - 366*D1*Dd*f*fd*r - 3360*D1*Dd*f*fd*s**2 + 318*D1*Dd*f*fd*s + 249*D1*Dd*f*fd + 84*D1*Dd*f*r*s - 21*D1*Dd*f*r + 504*D1*Dd*f*s**2 - 273*D1*Dd*f*s + 126*D1*Dd*f + 56*D1*Dd*fd*r*s - 427*D1*Dd*fd*r - 224*D1*Dd*fd*s**2 - 287*D1*Dd*fd*s + 189*D1*Dd*fd + 1400*D1*Dd*g2*s**2 - 700*D1*Dd*g2*s + 350*D1*Dd*g2 - 3920*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 1288*D1*Ddd*K*f*s**2 + 644*D1*Ddd*K*f*s - 322*D1*Ddd*K*f - 108*D1*Ddd*f**2*r*s + 27*D1*Ddd*f**2*r - 840*D1*Ddd*f**2*s**2 + 447*D1*Ddd*f**2*s - 210*D1*Ddd*f**2 + 28*D1*Ddd*f*r*s - 7*D1*Ddd*f*r - 112*D1*Ddd*f*s**2 + 49*D1*Ddd*f*s - 28*D1*Ddd*f - 1960*D1*Ddd*g2*s**2 + 980*D1*Ddd*g2*s - 490*D1*Ddd*g2 + 35*D1*bd1*(D1*(-5*K*(3*s**2 - 2*s + 1) + f*(r*(6*s - 2) + 21*s**2 - 16*s + 7) - 12*fd*r*s + 2*fd*r - 30*fd*s**2 + 12*fd*s + 12*r*s - 4*r + 15*s**2 - 14*s + 5) - 2*Dd*(-7*K*(12*s**2 - 7*s + 1) + f*(r*(24*s - 7) + 60*s**2 - 42*s + 7) + 24*r*s - 7*r + 84*s**2 - 56*s + 9)) - 3864*Dd**2*K*f*s**2 + 1932*Dd**2*K*f*s - 324*Dd**2*f**2*r*s + 81*Dd**2*f**2*r - 2520*Dd**2*f**2*s**2 + 1341*Dd**2*f**2*s - 27*Dd**2*f**2 + 84*Dd**2*f*r*s - 21*Dd**2*f*r - 336*Dd**2*f*s**2 + 147*Dd**2*f*s + 7*Dd**2*f - 5880*Dd**2*g2*s**2 + 2940*Dd**2*g2*s) + b1*(1650*D1**2*K*f*fd*s**2 - 1650*D1**2*K*f*fd*s + 825*D1**2*K*f*fd - 1434*D1**2*K*f*fdd*s**2 + 1434*D1**2*K*f*fdd*s - 717*D1**2*K*f*fdd - 1434*D1**2*K*fd**2*s**2 + 1434*D1**2*K*fd**2*s + 735*D1**2*b2*fd*s**2 - 1470*D1**2*b2*fd*s + 735*D1**2*b2*fd - 525*D1**2*b2*fdd*s**2 + 1050*D1**2*b2*fdd*s - 525*D1**2*b2*fdd - 210*D1**2*bd1**2*(-21*K*s**2 + 14*K*s + f*(r*(6*s - 2) + 15*s**2 - 12*s + 1) + r*(6*s - 2) + 21*s**2 - 16*s + 1) + 735*D1**2*bd2*f*s**2 - 1050*D1**2*bd2*fd*s**2 + 1050*D1**2*bd2*fd*s - 3*D1**2*bdd1*(3*f**2*(2*r*(9*s - 22) + 140*s**2 - 197*s + 105) + 7*f*(K*(92*s**2 + 34*s - 17) - 2*r*(s + 7) + 8*s**2 - 19*s + 17) + 490*g2*(2*s**2 - 2*s + 1)) - 525*D1**2*bdd2*f*s**2 - 1032*D1**2*f**2*fd*r*s + 594*D1**2*f**2*fd*r - 567*D1**2*f**2*fd*s**2 + 1685*D1**2*f**2*fd*s - 819*D1**2*f**2*fd + 1272*D1**2*f**2*fdd*r*s - 594*D1**2*f**2*fdd*r + 1377*D1**2*f**2*fdd*s**2 - 1945*D1**2*f**2*fdd*s + 909*D1**2*f**2*fdd + 2544*D1**2*f*fd**2*r*s - 1188*D1**2*f*fd**2*r + 2754*D1**2*f*fd**2*s**2 - 3890*D1**2*f*fd**2*s + 297*D1**2*f*fd**2 - 1110*D1**2*f*fd*r*s + 555*D1**2*f*fd*r + 114*D1**2*f*fd*s**2 + 441*D1**2*f*fd*s + 57*D1**2*f*fd + 786*D1**2*f*fdd*r*s - 393*D1**2*f*fdd*r + 174*D1**2*f*fdd*s**2 - 567*D1**2*f*fdd*s + 87*D1**2*f*fdd - 2184*D1**2*f*gd2*s**2 + 1932*D1**2*f*gdd2*s**2 + 786*D1**2*fd**2*r*s - 393*D1**2*fd**2*r + 174*D1**2*fd**2*s**2 - 567*D1**2*fd**2*s + 393*D1**2*fd**2 - 2184*D1**2*fd*g2*s**2 + 5964*D1**2*fd*g2*s - 2982*D1**2*fd*g2 + 3864*D1**2*fd*gd2*s**2 - 5292*D1**2*fd*gd2*s + 1932*D1**2*fdd*g2*s**2 - 5292*D1**2*fdd*g2*s + 2646*D1**2*fdd*g2 + 3300*D1*Dd*K*f**2*s**2 - 1650*D1*Dd*K*f**2*s + 825*D1*Dd*K*f**2 - 11472*D1*Dd*K*f*fd*s**2 + 8604*D1*Dd*K*f*fd*s - 1434*D1*Dd*K*f*fd + 2940*D1*Dd*b2*f*s**2 - 1470*D1*Dd*b2*f*s + 735*D1*Dd*b2*f - 4200*D1*Dd*b2*fd*s**2 + 5250*D1*Dd*b2*fd*s - 1050*D1*Dd*b2*fd - 4200*D1*Dd*bd2*f*s**2 + 1050*D1*Dd*bd2*f*s - 1376*D1*Dd*f**3*r*s + 344*D1*Dd*f**3*r - 756*D1*Dd*f**3*s**2 + 722*D1*Dd*f**3*s - 189*D1*Dd*f**3 + 10176*D1*Dd*f**2*fd*r*s - 3648*D1*Dd*f**2*fd*r + 11016*D1*Dd*f**2*fd*s**2 - 11806*D1*Dd*f**2*fd*s + 2539*D1*Dd*f**2*fd - 2220*D1*Dd*f**2*r*s + 555*D1*Dd*f**2*r + 228*D1*Dd*f**2*s**2 + 441*D1*Dd*f**2*s + 57*D1*Dd*f**2 + 6288*D1*Dd*f*fd*r*s - 2358*D1*Dd*f*fd*r + 1392*D1*Dd*f*fd*s**2 - 3402*D1*Dd*f*fd*s + 960*D1*Dd*f*fd - 8736*D1*Dd*f*g2*s**2 + 4368*D1*Dd*f*g2*s - 2184*D1*Dd*f*g2 + 15456*D1*Dd*f*gd2*s**2 - 3864*D1*Dd*f*gd2*s + 15456*D1*Dd*fd*g2*s**2 - 25032*D1*Dd*fd*g2*s + 5292*D1*Dd*fd*g2 - 2868*D1*Ddd*K*f**2*s**2 + 1434*D1*Ddd*K*f**2*s - 717*D1*Ddd*K*f**2 - 2100*D1*Ddd*b2*f*s**2 + 1050*D1*Ddd*b2*f*s - 525*D1*Ddd*b2*f + 1696*D1*Ddd*f**3*r*s - 424*D1*Ddd*f**3*r + 1836*D1*Ddd*f**3*s**2 - 1342*D1*Ddd*f**3*s + 459*D1*Ddd*f**3 + 1572*D1*Ddd*f**2*r*s - 393*D1*Ddd*f**2*r + 348*D1*Ddd*f**2*s**2 - 567*D1*Ddd*f**2*s + 87*D1*Ddd*f**2 + 7728*D1*Ddd*f*g2*s**2 - 3864*D1*Ddd*f*g2*s + 1932*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(3*f**2*(10*r*(5*s - 6) + 252*s**2 - 289*s + 147) + f*(7*K*(104*s**2 + 38*s - 19) + fd*(-54*r*(4*s - 1) - 1680*s**2 + 894*s + 39) + 42*r*s - 196*r + 252*s**2 - 91*s + 133) + 7*fd*(4*r*(s - 4) - s**2*(184*K + 16) + s*(218*K - 5) + 1) + 350*g2*(2*s**2 - 2*s + 1) + 980*gd2*s*(1 - 2*s)) + Dd*(f**2*(-6*r*(72*s - 97) - 3360*s**2 + 3258*s - 723) + 7*f*(K*(-736*s**2 + 48*s + 34) + 16*r*s + 54*r - 64*s**2 + 90*s - 33) - 980*g2*(8*s**2 - 6*s + 1))) - 8604*Dd**2*K*f**2*s**2 + 4302*Dd**2*K*f**2*s - 6300*Dd**2*b2*f*s**2 + 3150*Dd**2*b2*f*s + 5088*Dd**2*f**3*r*s - 1272*Dd**2*f**3*r + 5508*Dd**2*f**3*s**2 - 4026*Dd**2*f**3*s + 424*Dd**2*f**3 + 4716*Dd**2*f**2*r*s - 1179*Dd**2*f**2*r + 1044*Dd**2*f**2*s**2 - 1701*Dd**2*f**2*s + 393*Dd**2*f**2 + 23184*Dd**2*f*g2*s**2 - 11592*Dd**2*f*g2*s))/(315*d**2*k2**2) - 2*D1**2*Pk1*Pk2*ct**2*k2**4*st**4*(144*D1**2*b1*f*fd*r**2 + 144*D1**2*b1*f*fd*r*s - 72*D1**2*b1*f*fd*r - 30*D1**2*b1*f*fdd*r**2 - 30*D1**2*b1*f*fdd*r*s + 15*D1**2*b1*f*fdd*r - 30*D1**2*b1*fd**2*r**2 - 30*D1**2*b1*fd**2*r*s + 15*D1**2*b1*fd**2*r - 15*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 96*D1**2*f**2*fd*r**2 + 96*D1**2*f**2*fd*r*s - 96*D1**2*f**2*fd*r - 32*D1**2*f**2*fd*s + 32*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 288*D1*Dd*b1*f**2*r**2 + 288*D1*Dd*b1*f**2*r*s - 216*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s + 72*D1*Dd*b1*f**2 - 240*D1*Dd*b1*f*fd*r**2 - 240*D1*Dd*b1*f*fd*r*s + 150*D1*Dd*b1*f*fd*r + 30*D1*Dd*b1*f*fd*s - 15*D1*Dd*b1*f*fd + 128*D1*Dd*f**3*r**2 + 128*D1*Dd*f**3*r*s - 96*D1*Dd*f**3*r - 32*D1*Dd*f**3*s + 32*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 525*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s - 100*D1*Dd*f**2*fd - 60*D1*Ddd*b1*f**2*r**2 - 60*D1*Ddd*b1*f**2*r*s + 45*D1*Ddd*b1*f**2*r + 15*D1*Ddd*b1*f**2*s - 15*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 75*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(24*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 180*Dd**2*b1*f**2*r**2 - 180*Dd**2*b1*f**2*r*s + 135*Dd**2*b1*f**2*r + 45*Dd**2*b1*f**2*s - 15*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 225*Dd**2*f**3*r + 75*Dd**2*f**3*s - 25*Dd**2*f**3)/(105*d**2*k1**2*k3**4) - 4*D1**2*Pk1*Pk2*ct**2*k2**4*st**2*(35*D1*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - D1*f*(D1*bd1*(f*(4*r - 21)*(r + s - 1) + 12*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*D1*f*(4*bdd1*r*(r + s - 1) + fd*(9*r**2 + 9*r*(s - 1) - 3*s + 3)) + 12*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1) + 9*Dd*f**2*(4*r**2 + r*(4*s - 3) - s + 1)) + b1*(35*D1**2*bd1*f*(2*r - 1)*(r + s - 1) - D1**2*(f*(fd*(8*r**2 + r*(8*s + 13) + 17*s - 17) + 12*fdd*(2*r**2 + 2*r*(s - 1) - s + 1)) + 12*fd**2*(2*r**2 + 2*r*(s - 1) - s)) - 4*D1*f*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(8*r - 3)*(2*r + 2*s - 1)) + 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 12*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)))/(105*d**2*k1**2*k3**4) + 4*D1**2*Pk1*Pk2*ct*f*st**6*(11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(6*fd*(4*s**2 - 2*s + 1) - 3*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + 2*fd*s*(bd1*(11 - 33*s) + 9*fd*(1 - 2*s))) + D1*f*(6*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(11*bd1*s + 3*fd*(4*s - 1)) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(33*d**2*k1*k2) - 4*D1**2*Pk1*Pk2*ct*k1**5*st**2*(6*D1**2*b1*f*fd*r**2 + 12*D1**2*b1*f*fd*r*s - 6*D1**2*b1*f*fd*r + 6*D1**2*b1*f*fd*s**2 - 6*D1**2*b1*f*fd*s + 3*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(r + s - 1)**2 - 3*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s**2 + 4*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 + 12*D1*Dd*b1*f**2*r**2 + 24*D1*Dd*b1*f**2*r*s - 12*D1*Dd*b1*f**2*r + 12*D1*Dd*b1*f**2*s**2 - 12*D1*Dd*b1*f**2*s + 6*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 144*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 144*D1*Dd*b1*f*fd*s + 36*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 4*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 140*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 140*D1*Dd*f**2*fd*s + 40*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 36*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 20*D1*Ddd*f**3*s + 10*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + 6*D1*fd*(2*r + 2*s - 1) + 12*Dd*f*(2*r + 2*s - 1)) + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 108*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 60*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 60*Dd**2*f**3*s + 10*Dd**2*f**3)/(315*d**2*k2*k3**6) + 4*D1**2*Pk1*Pk2*ct*k1**5*(-3*D1*f*(r + s - 1)*(14*D1*bd1**2*(r + s - 1) + 5*D1*bdd1*f*(r + s - 1) + bd1*(-3*D1*f*(r + s - 1) + 10*D1*fd*(2*r + 2*s - 1) + 20*Dd*f*(2*r + 2*s - 1))) + 7*b1**2*(D1**2*(fd - 3*fdd)*(r + s)**2 + 2*D1*(Dd*(f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 3*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 6*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-42*D1**2*bdd1*f*(r + s - 1)**2 - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 12*Dd*f*(2*r + 2*s - 1)) + 6*D1*f*(Dd*(3*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 10*fd*(2*r + 2*s - 1)**2) - 5*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 30*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(105*d**2*k2*k3**6) + 4*D1**2*Pk1*Pk2*ct*k1**3*k2*st**4*(10*D1**2*b1*f*fd*r**2 + 20*D1**2*b1*f*fd*r*s - 10*D1**2*b1*f*fd*r + 10*D1**2*b1*f*fd*s**2 - 10*D1**2*b1*f*fd*s + 5*D1**2*b1*f*fd - 12*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 12*D1**2*b1*f*fdd*r - 12*D1**2*b1*f*fdd*s**2 + 12*D1**2*b1*f*fdd*s - 6*D1**2*b1*f*fdd - 12*D1**2*b1*fd**2*r**2 - 24*D1**2*b1*fd**2*r*s + 12*D1**2*b1*fd**2*r - 12*D1**2*b1*fd**2*s**2 + 12*D1**2*b1*fd**2*s - 6*D1**2*bdd1*f**2*(r + s - 1)**2 + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 6*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 8*D1**2*f**2*fdd*r - 6*D1**2*f**2*fdd*s**2 + 8*D1**2*f**2*fdd*s - 4*D1**2*f**2*fdd - 12*D1**2*f*fd**2*r**2 - 24*D1**2*f*fd**2*r*s + 16*D1**2*f*fd**2*r - 12*D1**2*f*fd**2*s**2 + 16*D1**2*f*fd**2*s - 4*D1**2*f*fd**2 + 20*D1*Dd*b1*f**2*r**2 + 40*D1*Dd*b1*f**2*r*s - 20*D1*Dd*b1*f**2*r + 20*D1*Dd*b1*f**2*s**2 - 20*D1*Dd*b1*f**2*s + 10*D1*Dd*b1*f**2 - 96*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 96*D1*Dd*b1*f*fd*r - 96*D1*Dd*b1*f*fd*s**2 + 96*D1*Dd*b1*f*fd*s - 24*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 48*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 56*D1*Dd*f**2*fd*r - 48*D1*Dd*f**2*fd*s**2 + 56*D1*Dd*f**2*fd*s - 16*D1*Dd*f**2*fd - 24*D1*Ddd*b1*f**2*r**2 - 48*D1*Ddd*b1*f**2*r*s + 24*D1*Ddd*b1*f**2*r - 24*D1*Ddd*b1*f**2*s**2 + 24*D1*Ddd*b1*f**2*s - 12*D1*Ddd*b1*f**2 - 8*D1*Ddd*f**3*r**2 - 16*D1*Ddd*f**3*r*s + 8*D1*Ddd*f**3*r - 8*D1*Ddd*f**3*s**2 + 8*D1*Ddd*f**3*s - 4*D1*Ddd*f**3 + D1*bd1*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 24*Dd*f*(2*r + 2*s - 1)) - 72*Dd**2*b1*f**2*r**2 - 144*Dd**2*b1*f**2*r*s + 72*Dd**2*b1*f**2*r - 72*Dd**2*b1*f**2*s**2 + 72*Dd**2*b1*f**2*s - 12*Dd**2*b1*f**2 - 24*Dd**2*f**3*r**2 - 48*Dd**2*f**3*r*s + 24*Dd**2*f**3*r - 24*Dd**2*f**3*s**2 + 24*Dd**2*f**3*s - 4*Dd**2*f**3)/(35*d**2*k3**6) + 4*D1**2*Pk1*Pk2*ct*k1**3*k2*st**2*(21*b1**2*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + 2*D1*(Dd*(7*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 12*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 3*b1*(64*C*D1**2*f*fd*r**2 + 128*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*r + 64*C*D1**2*f*fd*s**2 - 64*C*D1**2*f*fd*s + 32*C*D1**2*f*fd - 144*C*D1**2*f*fdd*r**2 - 288*C*D1**2*f*fdd*r*s + 144*C*D1**2*f*fdd*r - 144*C*D1**2*f*fdd*s**2 + 144*C*D1**2*f*fdd*s - 72*C*D1**2*f*fdd - 144*C*D1**2*fd**2*r**2 - 288*C*D1**2*fd**2*r*s + 144*C*D1**2*fd**2*r - 144*C*D1**2*fd**2*s**2 + 144*C*D1**2*fd**2*s + 128*C*D1*Dd*f**2*r**2 + 256*C*D1*Dd*f**2*r*s - 128*C*D1*Dd*f**2*r + 128*C*D1*Dd*f**2*s**2 - 128*C*D1*Dd*f**2*s + 64*C*D1*Dd*f**2 - 1152*C*D1*Dd*f*fd*r**2 - 2304*C*D1*Dd*f*fd*r*s + 1152*C*D1*Dd*f*fd*r - 1152*C*D1*Dd*f*fd*s**2 + 1152*C*D1*Dd*f*fd*s - 288*C*D1*Dd*f*fd - 288*C*D1*Ddd*f**2*r**2 - 576*C*D1*Ddd*f**2*r*s + 288*C*D1*Ddd*f**2*r - 288*C*D1*Ddd*f**2*s**2 + 288*C*D1*Ddd*f**2*s - 144*C*D1*Ddd*f**2 - 864*C*Dd**2*f**2*r**2 - 1728*C*Dd**2*f**2*r*s + 864*C*Dd**2*f**2*r - 864*C*Dd**2*f**2*s**2 + 864*C*Dd**2*f**2*s - 144*C*Dd**2*f**2 - 84*D1**2*bdd1*f*(r + s - 1)**2 + 42*D1**2*f*fd*r**2 + 84*D1**2*f*fd*r*s - 42*D1**2*f*fd*r + 42*D1**2*f*fd*s**2 - 42*D1**2*f*fd*s + 21*D1**2*f*fd - 42*D1**2*f*fdd*r**2 - 84*D1**2*f*fdd*r*s + 42*D1**2*f*fdd*r - 42*D1**2*f*fdd*s**2 + 42*D1**2*f*fdd*s - 21*D1**2*f*fdd - 42*D1**2*fd**2*r**2 - 84*D1**2*fd**2*r*s + 42*D1**2*fd**2*r - 42*D1**2*fd**2*s**2 + 42*D1**2*fd**2*s + 84*D1*Dd*f**2*r**2 + 168*D1*Dd*f**2*r*s - 84*D1*Dd*f**2*r + 84*D1*Dd*f**2*s**2 - 84*D1*Dd*f**2*s + 42*D1*Dd*f**2 - 336*D1*Dd*f*fd*r**2 - 672*D1*Dd*f*fd*r*s + 336*D1*Dd*f*fd*r - 336*D1*Dd*f*fd*s**2 + 336*D1*Dd*f*fd*s - 84*D1*Dd*f*fd - 84*D1*Ddd*f**2*r**2 - 168*D1*Ddd*f**2*r*s + 84*D1*Ddd*f**2*r - 84*D1*Ddd*f**2*s**2 + 84*D1*Ddd*f**2*s - 42*D1*Ddd*f**2 + 14*D1*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) - 252*Dd**2*f**2*r**2 - 504*Dd**2*f**2*r*s + 252*Dd**2*f**2*r - 252*Dd**2*f**2*s**2 + 252*Dd**2*f**2*s - 42*Dd**2*f**2) + f*(288*C*D1**2*f*fd*r**2 + 576*C*D1**2*f*fd*r*s - 384*C*D1**2*f*fd*r + 288*C*D1**2*f*fd*s**2 - 384*C*D1**2*f*fd*s + 192*C*D1**2*f*fd - 360*C*D1**2*f*fdd*r**2 - 720*C*D1**2*f*fdd*r*s + 480*C*D1**2*f*fdd*r - 360*C*D1**2*f*fdd*s**2 + 480*C*D1**2*f*fdd*s - 240*C*D1**2*f*fdd - 720*C*D1**2*fd**2*r**2 - 1440*C*D1**2*fd**2*r*s + 960*C*D1**2*fd**2*r - 720*C*D1**2*fd**2*s**2 + 960*C*D1**2*fd**2*s - 240*C*D1**2*fd**2 + 384*C*D1*Dd*f**2*r**2 + 768*C*D1*Dd*f**2*r*s - 384*C*D1*Dd*f**2*r + 384*C*D1*Dd*f**2*s**2 - 384*C*D1*Dd*f**2*s + 192*C*D1*Dd*f**2 - 2880*C*D1*Dd*f*fd*r**2 - 5760*C*D1*Dd*f*fd*r*s + 3360*C*D1*Dd*f*fd*r - 2880*C*D1*Dd*f*fd*s**2 + 3360*C*D1*Dd*f*fd*s - 960*C*D1*Dd*f*fd - 480*C*D1*Ddd*f**2*r**2 - 960*C*D1*Ddd*f**2*r*s + 480*C*D1*Ddd*f**2*r - 480*C*D1*Ddd*f**2*s**2 + 480*C*D1*Ddd*f**2*s - 240*C*D1*Ddd*f**2 - 1440*C*Dd**2*f**2*r**2 - 2880*C*Dd**2*f**2*r*s + 1440*C*Dd**2*f**2*r - 1440*C*Dd**2*f**2*s**2 + 1440*C*Dd**2*f**2*s - 240*C*Dd**2*f**2 - 252*D1**2*bd1**2*(r + s - 1)**2 - 9*D1**2*bdd1*f*(24*C + 7)*(r + s - 1)**2 - 24*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 32*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 32*D1**2*f*fd*s - 16*D1**2*f*fd - 15*D1**2*f*fdd*r**2 - 30*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*r - 15*D1**2*f*fdd*s**2 + 20*D1**2*f*fdd*s - 10*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 40*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 40*D1**2*fd**2*s - 10*D1**2*fd**2 - 32*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 32*D1*Dd*f**2*r - 32*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 16*D1*Dd*f**2 - 120*D1*Dd*f*fd*r**2 - 240*D1*Dd*f*fd*r*s + 140*D1*Dd*f*fd*r - 120*D1*Dd*f*fd*s**2 + 140*D1*Dd*f*fd*s - 40*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 20*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 + 3*D1*bd1*(r + s - 1)*(D1*f*(32*C + 21)*(r + s - 1) - D1*fd*(144*C + 42)*(2*r + 2*s - 1) - Dd*f*(288*C + 84)*(2*r + 2*s - 1)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 60*Dd**2*f**2*s - 10*Dd**2*f**2))/(315*d**2*k3**6) + 4*D1**2*Pk1*Pk2*ct*k1**3*k2*(-3*D1*f*(r + s - 1)*(14*D1*bd1**2*(8*C + 1)*(r + s - 1) + 5*D1*bdd1*f*(8*C + 1)*(r + s - 1) + 2*bd1*(D1*f*(2 - 12*C)*(r + s - 1) + D1*fd*(40*C + 5)*(2*r + 2*s - 1) + Dd*f*(80*C + 10)*(2*r + 2*s - 1))) + 7*b1**2*(D1**2*(r + s)**2*(-24*C*fdd + fd*(8*C - 4) - 3*fdd) + 2*D1*(Dd*f*(8*C - 4)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*fd*(48*C + 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)) - Ddd*f*(24*C + 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(48*C + 6)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-42*D1**2*bdd1*f*(8*C + 1)*(r + s - 1)**2 - 3*D1**2*(-f*(-40*C*fdd + fd*(24*C - 4) - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd**2*(80*C + 10)*(r**2 + r*(2*s - 1) + s*(s - 1))) + 28*D1*bd1*(r + s - 1)*(D1*f*(4*C - 2)*(r + s - 1) - D1*fd*(24*C + 3)*(r + s) - Dd*f*(48*C + 6)*(2*r + 2*s - 1)) + 6*D1*f*(2*Dd*(f*(12*C - 2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(-40*C - 5)*(2*r + 2*s - 1)**2) + Ddd*f*(-40*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 3*Dd**2*f**2*(80*C + 10)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(105*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct*k1**3*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(35*d**2*k2*k3**4) + D1**2*Pk1*Pk2*ct*k1**3*st**2*(252*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 3*b1*(160*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*r + 160*C*D1**2*f*fd*s**2 - 160*C*D1**2*f*fd*s + 80*C*D1**2*f*fd - 192*C*D1**2*f*fdd*r*s + 96*C*D1**2*f*fdd*r - 192*C*D1**2*f*fdd*s**2 + 192*C*D1**2*f*fdd*s - 96*C*D1**2*f*fdd - 192*C*D1**2*fd**2*r*s + 96*C*D1**2*fd**2*r - 192*C*D1**2*fd**2*s**2 + 192*C*D1**2*fd**2*s + 320*C*D1*Dd*f**2*r*s - 80*C*D1*Dd*f**2*r + 320*C*D1*Dd*f**2*s**2 - 240*C*D1*Dd*f**2*s + 80*C*D1*Dd*f**2 - 1536*C*D1*Dd*f*fd*r*s + 576*C*D1*Dd*f*fd*r - 1536*C*D1*Dd*f*fd*s**2 + 1344*C*D1*Dd*f*fd*s - 288*C*D1*Dd*f*fd - 384*C*D1*Ddd*f**2*r*s + 96*C*D1*Ddd*f**2*r - 384*C*D1*Ddd*f**2*s**2 + 288*C*D1*Ddd*f**2*s - 96*C*D1*Ddd*f**2 - 1152*C*Dd**2*f**2*r*s + 288*C*Dd**2*f**2*r - 1152*C*Dd**2*f**2*s**2 + 864*C*Dd**2*f**2*s - 96*C*Dd**2*f**2 - 84*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 86*D1**2*f*fd*r**2 - 268*D1**2*f*fd*r*s + 206*D1**2*f*fd*r - 182*D1**2*f*fd*s**2 + 254*D1**2*f*fd*s - 163*D1**2*f*fd + 106*D1**2*f*fdd*r**2 + 428*D1**2*f*fdd*r*s - 250*D1**2*f*fdd*r + 322*D1**2*f*fdd*s**2 - 358*D1**2*f*fdd*s + 197*D1**2*f*fdd + 106*D1**2*fd**2*r**2 + 428*D1**2*fd**2*r*s - 250*D1**2*fd**2*r + 322*D1**2*fd**2*s**2 - 358*D1**2*fd**2*s - 172*D1*Dd*f**2*r**2 - 536*D1*Dd*f**2*r*s + 220*D1*Dd*f**2*r - 364*D1*Dd*f**2*s**2 + 316*D1*Dd*f**2*s - 134*D1*Dd*f**2 + 848*D1*Dd*f*fd*r**2 + 3424*D1*Dd*f*fd*r*s - 1640*D1*Dd*f*fd*r + 2576*D1*Dd*f*fd*s**2 - 2504*D1*Dd*f*fd*s + 608*D1*Dd*f*fd + 212*D1*Ddd*f**2*r**2 + 856*D1*Ddd*f**2*r*s - 320*D1*Ddd*f**2*r + 644*D1*Ddd*f**2*s**2 - 536*D1*Ddd*f**2*s + 214*D1*Ddd*f**2 + 84*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 636*Dd**2*f**2*r**2 + 2568*Dd**2*f**2*r*s - 960*Dd**2*f**2*r + 1932*Dd**2*f**2*s**2 - 1608*Dd**2*f**2*s + 214*Dd**2*f**2) + f*(528*C*D1**2*f*fd*r*s - 176*C*D1**2*f*fd*r + 528*C*D1**2*f*fd*s**2 - 528*C*D1**2*f*fd*s + 176*C*D1**2*f*fd - 480*C*D1**2*f*fdd*r*s + 160*C*D1**2*f*fdd*r - 480*C*D1**2*f*fdd*s**2 + 480*C*D1**2*f*fdd*s - 160*C*D1**2*f*fdd - 960*C*D1**2*fd**2*r*s + 320*C*D1**2*fd**2*r - 960*C*D1**2*fd**2*s**2 + 960*C*D1**2*fd**2*s - 160*C*D1**2*fd**2 + 704*C*D1*Dd*f**2*r*s - 176*C*D1*Dd*f**2*r + 704*C*D1*Dd*f**2*s**2 - 528*C*D1*Dd*f**2*s + 176*C*D1*Dd*f**2 - 3840*C*D1*Dd*f*fd*r*s + 1120*C*D1*Dd*f*fd*r - 3840*C*D1*Dd*f*fd*s**2 + 3360*C*D1*Dd*f*fd*s - 640*C*D1*Dd*f*fd - 640*C*D1*Ddd*f**2*r*s + 160*C*D1*Ddd*f**2*r - 640*C*D1*Ddd*f**2*s**2 + 480*C*D1*Ddd*f**2*s - 160*C*D1*Ddd*f**2 - 1920*C*Dd**2*f**2*r*s + 480*C*Dd**2*f**2*r - 1920*C*Dd**2*f**2*s**2 + 1440*C*Dd**2*f**2*s - 160*C*Dd**2*f**2 - 252*D1**2*bd1**2*(2*s - 1)*(r + s - 1) + 3*D1**2*bdd1*f*(r + s - 1)*(-96*C*s + 53*r + 161*s - 17) - 303*D1**2*f*fd*r**2 - 1110*D1**2*f*fd*r*s + 572*D1**2*f*fd*r - 807*D1**2*f*fd*s**2 + 908*D1**2*f*fd*s - 370*D1**2*f*fd + 273*D1**2*f*fdd*r**2 + 1122*D1**2*f*fdd*r*s - 556*D1**2*f*fdd*r + 849*D1**2*f*fdd*s**2 - 940*D1**2*f*fdd*s + 374*D1**2*f*fdd + 546*D1**2*fd**2*r**2 + 2244*D1**2*fd**2*r*s - 1112*D1**2*fd**2*r + 1698*D1**2*fd**2*s**2 - 1880*D1**2*fd**2*s + 374*D1**2*fd**2 - 404*D1*Dd*f**2*r**2 - 1480*D1*Dd*f**2*r*s + 572*D1*Dd*f**2*r - 1076*D1*Dd*f**2*s**2 + 908*D1*Dd*f**2*s - 370*D1*Dd*f**2 + 2184*D1*Dd*f*fd*r**2 + 8976*D1*Dd*f*fd*r*s - 3892*D1*Dd*f*fd*r + 6792*D1*Dd*f*fd*s**2 - 6580*D1*Dd*f*fd*s + 1496*D1*Dd*f*fd + 364*D1*Ddd*f**2*r**2 + 1496*D1*Ddd*f**2*r*s - 556*D1*Ddd*f**2*r + 1132*D1*Ddd*f**2*s**2 - 940*D1*Ddd*f**2*s + 374*D1*Ddd*f**2 + 3*D1*bd1*(D1*(-f*(r + s - 1)*(-80*C*s + 43*r + 91*s + 29) + 2*fd*(-48*C*(r*(4*s - 1) + (1 - 2*s)**2) + 106*r**2 + 428*r*s - 195*r + 322*s**2 - 357*s + 107)) - 8*Dd*f*(12*C*(8*r*s - r + 8*s**2 - 7*s + 1) - 53*r**2 - 214*r*s + 75*r - 161*s**2 + 156*s - 31)) + 1092*Dd**2*f**2*r**2 + 4488*Dd**2*f**2*r*s - 1668*Dd**2*f**2*r + 3396*Dd**2*f**2*s**2 - 2820*Dd**2*f**2*s + 374*Dd**2*f**2))/(315*d**2*k2*k3**4) + D1**2*Pk1*Pk2*ct*k1**3*(7*b1**2*(-D1**2*(r + s)*(17*fd*r + fd*s*(49 - 8*C) - 31*fdd*r + fdd*s*(24*C - 67)) + 2*D1*(Dd*(f*(4*C*(4*r*s - r + 4*s**2 - 3*s + 1) - 34*r**2 - 132*r*s + 50*r - 98*s**2 + 82*s - 33) + 4*fd*(31*r**2 + r*(-24*C*s + 3*C + 98*s - 20) + s*(-24*C*s + 9*C + 67*s - 29))) + Ddd*f*(-12*C*(4*r*s - r + 4*s**2 - 3*s + 1) + 62*r**2 + 196*r*s - 80*r + 134*s**2 - 116*s + 49)) + 2*Dd**2*f*(-12*C*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) + 186*r**2 + 12*r*(49*s - 20) + 402*s**2 - 348*s + 49)) + b1*(14*D1**2*bdd1*f*(r + s - 1)*(C*(12 - 24*s) + 31*r + 67*s - 49) - 3*D1**2*(f*(fd*(8*C*(8*r*s - 7*r + 8*s**2 - 11*s + 7) + 86*r**2 + 268*r*s - 86*r + 182*s**2 - 134*s + 43) - fdd*(8*C*(4*r*s - 7*r + 4*s**2 - 9*s + 7) + 106*r**2 + 316*r*s - 106*r + 210*s**2 - 158*s + 53)) - 2*fd**2*(53*r**2 + r*(4*C*(4*s - 7) + 158*s - 53) + s*(4*C*(4*s - 9) + 105*s - 79))) + 14*D1*bd1*(D1*(f*(r + s - 1)*(C*(8*s - 4) - 17*r - 49*s + 33) + 2*fd*(31*r**2 + r*(-24*C*s + 6*C + 98*s - 40) + s*(-24*C*s + 18*C + 67*s - 58))) - 4*Dd*f*(6*C*(8*r*s - 3*r + 8*s**2 - 9*s + 2) - 62*r**2 - 196*r*s + 120*r - 134*s**2 + 174*s - 49)) - 6*D1*f*(Dd*(f*(16*C*(4*r*s - r + 4*s**2 - 3*s + 1) + 86*r**2 + 268*r*s - 110*r + 182*s**2 - 158*s + 67) - 4*fd*(2*r + 2*s - 1)*(16*C*(s - 1) + 53*r + 105*s - 33)) - Ddd*f*(8*C*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + 106*r**2 + 4*r*(79*s - 33) + 210*s**2 - 184*s + 79)) + 6*Dd**2*f**2*(8*C*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) + 318*r**2 + 12*r*(79*s - 33) + 630*s**2 - 552*s + 79)) + f*(-120*C*(D1**2*(f*(fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 14*D1**2*bd1**2*(r + s - 1)*(C*(12 - 24*s) + 31*r + 67*s - 49) + 3*D1**2*bdd1*f*(r + s - 1)*(8*C*(2*s + 5) + 53*r + 105*s - 105) - 3*D1*bd1*(D1*(f*(r + s - 1)*(8*C*(4*s + 3) + 43*r + 91*s - 91) - 2*fd*(4*C*(8*r*s + 3*r + 8*s**2 - 3*s + 2) + 106*r**2 + 316*r*s - 211*r + 210*s**2 - 289*s + 79)) - 8*Dd*f*(2*C*(r*(8*s + 9) + 8*s**2 + 3*s - 4) + 53*r**2 + 2*r*(79*s - 56) + 105*s**2 - 151*s + 46))))/(105*d**2*k2*k3**4) + 4*D1**2*Pk1*Pk2*ct*k1**3*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2**3*k3**2) + 2*D1**2*Pk1*Pk2*ct*k1**3*st**2*(14*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-14*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 146*D1**2*f*fd*s**2 + 170*D1**2*f*fd*s - 85*D1**2*f*fd + 94*D1**2*f*fdd*s**2 - 106*D1**2*f*fdd*s + 53*D1**2*f*fdd + 94*D1**2*fd**2*s**2 - 106*D1**2*fd**2*s - 292*D1*Dd*f**2*s**2 + 146*D1*Dd*f**2*s - 73*D1*Dd*f**2 + 752*D1*Dd*f*fd*s**2 - 612*D1*Dd*f*fd*s + 106*D1*Dd*f*fd + 188*D1*Ddd*f**2*s**2 - 94*D1*Ddd*f**2*s + 47*D1*Ddd*f**2 + 28*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 564*Dd**2*f**2*s**2 - 282*Dd**2*f**2*s) + f*(-28*D1**2*bd1**2*s*(s - 1) + D1**2*bdd1*f*(47*s**2 + 12*s - 6) - 123*D1**2*f*fd*s**2 + 82*D1**2*f*fd*s - 41*D1**2*f*fd + 75*D1**2*f*fdd*s**2 - 50*D1**2*f*fdd*s + 25*D1**2*f*fdd + 150*D1**2*fd**2*s**2 - 100*D1**2*fd**2*s - 164*D1*Dd*f**2*s**2 + 82*D1*Dd*f**2*s - 41*D1*Dd*f**2 + 600*D1*Dd*f*fd*s**2 - 350*D1*Dd*f*fd*s + 50*D1*Dd*f*fd + 100*D1*Ddd*f**2*s**2 - 50*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 - D1*bd1*(D1*f*(73*s**2 + 24*s - 12) + 2*D1*fd*s*(41 - 94*s) + 2*Dd*f*(-188*s**2 + 23*s + 6)) + 300*Dd**2*f**2*s**2 - 150*Dd**2*f**2*s))/(105*d**2*k2**3*k3**2) - D1**2*Pk1*Pk2*ct*k1**3*(7*b1**2*(D1**2*s**2*(17*fd - 11*fdd) + D1*(17*Dd*f*(4*s**2 - 2*s + 1) + 22*Dd*fd*s*(1 - 4*s) - 11*Ddd*f*(4*s**2 - 2*s + 1)) + 66*Dd**2*f*s*(1 - 2*s)) + b1*(-77*D1**2*bdd1*f*(2*s**2 - 2*s + 1) + 8*D1**2*f*fd*s**2 + 154*D1**2*f*fd*s - 77*D1**2*f*fd + 52*D1**2*f*fdd*s**2 - 154*D1**2*f*fdd*s + 77*D1**2*f*fdd + 52*D1**2*fd**2*s**2 - 154*D1**2*fd**2*s + 16*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 4*D1*Dd*f**2 + 416*D1*Dd*f*fd*s**2 - 720*D1*Dd*f*fd*s + 154*D1*Dd*f*fd + 104*D1*Ddd*f**2*s**2 - 52*D1*Ddd*f**2*s + 26*D1*Ddd*f**2 + 7*D1*bd1*(17*D1*f*(2*s**2 - 2*s + 1) + 22*D1*fd*s*(1 - 2*s) - 22*Dd*f*(8*s**2 - 6*s + 1)) + 312*Dd**2*f**2*s**2 - 156*Dd**2*f**2*s) + f*(-154*D1**2*bd1**2*s*(s - 1) + D1**2*bdd1*f*(26*s**2 + 102*s - 51) - 51*D1**2*(f*(fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*bd1*(D1*f*(4*s**2 - 162*s + 81) + 2*D1*fd*s*(52*s + 25) + 2*Dd*f*(104*s**2 + 178*s - 51)) - 51*D1*f*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(12*s**2 - 7*s + 1) + Ddd*f*(-4*s**2 + 2*s - 1)) - 306*Dd**2*f**2*s*(1 - 2*s)))/(105*d**2*k2**3*k3**2) + 4*D1**2*Pk1*Pk2*ct*k1*k2**3*st**6*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 72*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 72*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 144*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 144*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 28*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s - 8*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 12*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s - 2*Dd**2*f**3)/(63*d**2*k3**6) + 4*D1**2*Pk1*Pk2*ct*k1*k2**3*st**4*(21*b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 3*b1*(104*C*D1**2*f*fd*r**2 + 208*C*D1**2*f*fd*r*s - 104*C*D1**2*f*fd*r + 104*C*D1**2*f*fd*s**2 - 104*C*D1**2*f*fd*s + 52*C*D1**2*f*fd - 80*C*D1**2*f*fdd*r**2 - 160*C*D1**2*f*fdd*r*s + 80*C*D1**2*f*fdd*r - 80*C*D1**2*f*fdd*s**2 + 80*C*D1**2*f*fdd*s - 40*C*D1**2*f*fdd - 80*C*D1**2*fd**2*r**2 - 160*C*D1**2*fd**2*r*s + 80*C*D1**2*fd**2*r - 80*C*D1**2*fd**2*s**2 + 80*C*D1**2*fd**2*s + 208*C*D1*Dd*f**2*r**2 + 416*C*D1*Dd*f**2*r*s - 208*C*D1*Dd*f**2*r + 208*C*D1*Dd*f**2*s**2 - 208*C*D1*Dd*f**2*s + 104*C*D1*Dd*f**2 - 640*C*D1*Dd*f*fd*r**2 - 1280*C*D1*Dd*f*fd*r*s + 640*C*D1*Dd*f*fd*r - 640*C*D1*Dd*f*fd*s**2 + 640*C*D1*Dd*f*fd*s - 160*C*D1*Dd*f*fd - 160*C*D1*Ddd*f**2*r**2 - 320*C*D1*Ddd*f**2*r*s + 160*C*D1*Ddd*f**2*r - 160*C*D1*Ddd*f**2*s**2 + 160*C*D1*Ddd*f**2*s - 80*C*D1*Ddd*f**2 - 480*C*Dd**2*f**2*r**2 - 960*C*Dd**2*f**2*r*s + 480*C*Dd**2*f**2*r - 480*C*Dd**2*f**2*s**2 + 480*C*Dd**2*f**2*s - 80*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(r + s - 1)**2 - 14*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 14*D1**2*f*fdd*s**2 + 14*D1**2*f*fdd*s - 7*D1**2*f*fdd - 14*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 14*D1**2*fd**2*s**2 + 14*D1**2*fd**2*s - 112*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 112*D1*Dd*f*fd*r - 112*D1*Dd*f*fd*s**2 + 112*D1*Dd*f*fd*s - 28*D1*Dd*f*fd - 28*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 28*D1*Ddd*f**2*r - 28*D1*Ddd*f**2*s**2 + 28*D1*Ddd*f**2*s - 14*D1*Ddd*f**2 + 28*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) - 84*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 84*Dd**2*f**2*r - 84*Dd**2*f**2*s**2 + 84*Dd**2*f**2*s - 14*Dd**2*f**2) + f*(-42*D1**2*bd1**2*(r + s - 1)**2 - 3*D1**2*bdd1*f*(40*C + 7)*(r + s - 1)**2 + 2*D1**2*(f*(fd*(34*C + 3) - fdd*(20*C + 3))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(-40*C - 6)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 6*D1*bd1*(r + s - 1)*(26*C*D1*f*(r + s - 1) - 40*C*D1*fd*(2*r + 2*s - 1) - 80*C*Dd*f*(2*r + 2*s - 1) - (7*D1*fd + 14*Dd*f)*(2*r + 2*s - 1)) + 4*D1*f*(Dd*(f*(34*C + 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(40*C + 6)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) - Ddd*f*(20*C + 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f**2*(80*C + 12)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(105*d**2*k3**6) + 4*D1**2*Pk1*Pk2*ct*k1*k2**3*st**2*(D1*f*(-84*D1*bd1**2*(4*C + 1)*(r + s - 1)**2 + bd1*(r + s - 1)*(D1*f*(32*C + 15)*(r + s - 1) - D1*fd*(144*C + 36)*(2*r + 2*s - 1) - Dd*f*(288*C + 72)*(2*r + 2*s - 1)) - 3*f*(6*D1*bdd1*(4*C + 1)*(r + s - 1)**2 + (12*C + 1)*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))) + 14*b1**2*(D1**2*(r + s)**2*(14*C*fd - 12*C*fdd + fd - 3*fdd) + 2*D1*(Dd*(f*(14*C + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(24*C + 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(-12*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(24*C + 6)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(64*C*D1**2*f*fd*r**2 + 128*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*r + 64*C*D1**2*f*fd*s**2 - 64*C*D1**2*f*fd*s + 32*C*D1**2*f*fd - 144*C*D1**2*f*fdd*r**2 - 288*C*D1**2*f*fdd*r*s + 144*C*D1**2*f*fdd*r - 144*C*D1**2*f*fdd*s**2 + 144*C*D1**2*f*fdd*s - 72*C*D1**2*f*fdd - 144*C*D1**2*fd**2*r**2 - 288*C*D1**2*fd**2*r*s + 144*C*D1**2*fd**2*r - 144*C*D1**2*fd**2*s**2 + 144*C*D1**2*fd**2*s + 128*C*D1*Dd*f**2*r**2 + 256*C*D1*Dd*f**2*r*s - 128*C*D1*Dd*f**2*r + 128*C*D1*Dd*f**2*s**2 - 128*C*D1*Dd*f**2*s + 64*C*D1*Dd*f**2 - 1152*C*D1*Dd*f*fd*r**2 - 2304*C*D1*Dd*f*fd*r*s + 1152*C*D1*Dd*f*fd*r - 1152*C*D1*Dd*f*fd*s**2 + 1152*C*D1*Dd*f*fd*s - 288*C*D1*Dd*f*fd - 288*C*D1*Ddd*f**2*r**2 - 576*C*D1*Ddd*f**2*r*s + 288*C*D1*Ddd*f**2*r - 288*C*D1*Ddd*f**2*s**2 + 288*C*D1*Ddd*f**2*s - 144*C*D1*Ddd*f**2 - 864*C*Dd**2*f**2*r**2 - 1728*C*Dd**2*f**2*r*s + 864*C*Dd**2*f**2*r - 864*C*Dd**2*f**2*s**2 + 864*C*Dd**2*f**2*s - 144*C*Dd**2*f**2 - 84*D1**2*bdd1*f*(4*C + 1)*(r + s - 1)**2 + 30*D1**2*f*fd*r**2 + 60*D1**2*f*fd*r*s - 30*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 30*D1**2*f*fd*s + 15*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 60*D1*Dd*f**2*r**2 + 120*D1*Dd*f**2*r*s - 60*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 60*D1*Dd*f**2*s + 30*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 288*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 288*D1*Dd*f*fd*s - 72*D1*Dd*f*fd - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 72*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 72*D1*Ddd*f**2*s - 36*D1*Ddd*f**2 + 28*D1*bd1*(r + s - 1)*(D1*f*(14*C + 1)*(r + s - 1) - D1*fd*(24*C + 6)*(r + s) - Dd*f*(48*C + 12)*(2*r + 2*s - 1)) - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 216*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 216*Dd**2*f**2*s - 36*Dd**2*f**2))/(105*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct*k1*k2*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(63*d**2*k3**4) + D1**2*Pk1*Pk2*ct*k1*k2*st**4*(84*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 3*b1*(96*C*D1**2*f*fd*r**2 + 448*C*D1**2*f*fd*r*s - 224*C*D1**2*f*fd*r + 352*C*D1**2*f*fd*s**2 - 352*C*D1**2*f*fd*s + 176*C*D1**2*f*fd - 48*C*D1**2*f*fdd*r**2 - 336*C*D1**2*f*fdd*r*s + 168*C*D1**2*f*fdd*r - 288*C*D1**2*f*fdd*s**2 + 288*C*D1**2*f*fdd*s - 144*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r**2 - 336*C*D1**2*fd**2*r*s + 168*C*D1**2*fd**2*r - 288*C*D1**2*fd**2*s**2 + 288*C*D1**2*fd**2*s + 192*C*D1*Dd*f**2*r**2 + 896*C*D1*Dd*f**2*r*s - 320*C*D1*Dd*f**2*r + 704*C*D1*Dd*f**2*s**2 - 576*C*D1*Dd*f**2*s + 224*C*D1*Dd*f**2 - 384*C*D1*Dd*f*fd*r**2 - 2688*C*D1*Dd*f*fd*r*s + 1104*C*D1*Dd*f*fd*r - 2304*C*D1*Dd*f*fd*s**2 + 2064*C*D1*Dd*f*fd*s - 456*C*D1*Dd*f*fd - 96*C*D1*Ddd*f**2*r**2 - 672*C*D1*Ddd*f**2*r*s + 216*C*D1*Ddd*f**2*r - 576*C*D1*Ddd*f**2*s**2 + 456*C*D1*Ddd*f**2*s - 168*C*D1*Ddd*f**2 - 288*C*Dd**2*f**2*r**2 - 2016*C*Dd**2*f**2*r*s + 648*C*Dd**2*f**2*r - 1728*C*Dd**2*f**2*s**2 + 1368*C*Dd**2*f**2*s - 168*C*Dd**2*f**2 - 28*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 230*D1**2*f*fd*r**2 - 372*D1**2*f*fd*r*s + 194*D1**2*f*fd*r - 142*D1**2*f*fd*s**2 + 150*D1**2*f*fd*s - 79*D1**2*f*fd + 178*D1**2*f*fdd*r**2 + 340*D1**2*f*fdd*r*s - 174*D1**2*f*fdd*r + 162*D1**2*f*fdd*s**2 - 166*D1**2*f*fdd*s + 85*D1**2*f*fdd + 178*D1**2*fd**2*r**2 + 340*D1**2*fd**2*r*s - 174*D1**2*fd**2*r + 162*D1**2*fd**2*s**2 - 166*D1**2*fd**2*s - 460*D1*Dd*f**2*r**2 - 744*D1*Dd*f**2*r*s + 416*D1*Dd*f**2*r - 284*D1*Dd*f**2*s**2 + 328*D1*Dd*f**2*s - 186*D1*Dd*f**2 + 1424*D1*Dd*f*fd*r**2 + 2720*D1*Dd*f*fd*r*s - 1392*D1*Dd*f*fd*r + 1296*D1*Dd*f*fd*s**2 - 1328*D1*Dd*f*fd*s + 340*D1*Dd*f*fd + 356*D1*Ddd*f**2*r**2 + 680*D1*Ddd*f**2*r*s - 348*D1*Ddd*f**2*r + 324*D1*Ddd*f**2*s**2 - 332*D1*Ddd*f**2*s + 170*D1*Ddd*f**2 + 28*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 1068*Dd**2*f**2*r**2 + 2040*Dd**2*f**2*r*s - 1044*Dd**2*f**2*r + 972*Dd**2*f**2*s**2 - 996*Dd**2*f**2*s + 170*Dd**2*f**2) + f*(144*C*D1**2*f*fd*r**2 + 864*C*D1**2*f*fd*r*s - 384*C*D1**2*f*fd*r + 720*C*D1**2*f*fd*s**2 - 768*C*D1**2*f*fd*s + 288*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r**2 - 504*C*D1**2*f*fdd*r*s + 216*C*D1**2*f*fdd*r - 432*C*D1**2*f*fdd*s**2 + 456*C*D1**2*f*fdd*s - 168*C*D1**2*f*fdd - 144*C*D1**2*fd**2*r**2 - 1008*C*D1**2*fd**2*r*s + 432*C*D1**2*fd**2*r - 864*C*D1**2*fd**2*s**2 + 912*C*D1**2*fd**2*s - 168*C*D1**2*fd**2 + 192*C*D1*Dd*f**2*r**2 + 1152*C*D1*Dd*f**2*r*s - 384*C*D1*Dd*f**2*r + 960*C*D1*Dd*f**2*s**2 - 768*C*D1*Dd*f**2*s + 288*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r**2 - 4032*C*D1*Dd*f*fd*r*s + 1512*C*D1*Dd*f*fd*r - 3456*C*D1*Dd*f*fd*s**2 + 3192*C*D1*Dd*f*fd*s - 672*C*D1*Dd*f*fd - 96*C*D1*Ddd*f**2*r**2 - 672*C*D1*Ddd*f**2*r*s + 216*C*D1*Ddd*f**2*r - 576*C*D1*Ddd*f**2*s**2 + 456*C*D1*Ddd*f**2*s - 168*C*D1*Ddd*f**2 - 288*C*Dd**2*f**2*r**2 - 2016*C*Dd**2*f**2*r*s + 648*C*Dd**2*f**2*r - 1728*C*Dd**2*f**2*s**2 + 1368*C*Dd**2*f**2*s - 168*C*Dd**2*f**2 - 84*D1**2*bd1**2*(2*s - 1)*(r + s - 1) - 3*D1**2*bdd1*f*(r + s - 1)*(24*C*(r + 6*s - 1) - 89*r - 81*s + 85) - 405*D1**2*f*fd*r**2 - 582*D1**2*f*fd*r*s + 464*D1**2*f*fd*r - 177*D1**2*f*fd*s**2 + 312*D1**2*f*fd*s - 194*D1**2*f*fd + 279*D1**2*f*fdd*r**2 + 426*D1**2*f*fdd*r*s - 328*D1**2*f*fdd*r + 147*D1**2*f*fdd*s**2 - 240*D1**2*f*fdd*s + 142*D1**2*f*fdd + 558*D1**2*fd**2*r**2 + 852*D1**2*fd**2*r*s - 656*D1**2*fd**2*r + 294*D1**2*fd**2*s**2 - 480*D1**2*fd**2*s + 142*D1**2*fd**2 - 540*D1*Dd*f**2*r**2 - 776*D1*Dd*f**2*r*s + 464*D1*Dd*f**2*r - 236*D1*Dd*f**2*s**2 + 312*D1*Dd*f**2*s - 194*D1*Dd*f**2 + 2232*D1*Dd*f*fd*r**2 + 3408*D1*Dd*f*fd*r*s - 2296*D1*Dd*f*fd*r + 1176*D1*Dd*f*fd*s**2 - 1680*D1*Dd*f*fd*s + 568*D1*Dd*f*fd + 372*D1*Ddd*f**2*r**2 + 568*D1*Ddd*f**2*r*s - 328*D1*Ddd*f**2*r + 196*D1*Ddd*f**2*s**2 - 240*D1*Ddd*f**2*s + 142*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(r + s - 1)*(16*C*(3*r + 11*s - 3) - 115*r - 71*s + 107) + 2*fd*(-12*C*(4*r**2 + 28*r*s - 11*r + 24*s**2 - 26*s + 7) + 178*r**2 + 340*r*s - 261*r + 162*s**2 - 249*s + 85)) - 4*Dd*f*(6*C*(8*r**2 + 56*r*s - 17*r + 48*s**2 - 47*s + 9) - 178*r**2 - 340*r*s + 261*r - 162*s**2 + 249*s - 85)) + 1116*Dd**2*f**2*r**2 + 1704*Dd**2*f**2*r*s - 984*Dd**2*f**2*r + 588*Dd**2*f**2*s**2 - 720*Dd**2*f**2*s + 142*Dd**2*f**2))/(105*d**2*k3**4) + D1**2*Pk1*Pk2*ct*k1*k2*st**2*(21*b1**2*(D1**2*(r + s)*(fd*r*(48*C - 89) + fd*s*(8*C - 45) + fdd*r*(67 - 24*C) + fdd*s*(55 - 24*C)) + 2*D1*(Dd*(f*(4*C*(24*r**2 + 28*r*s - 19*r + 4*s**2 - 9*s + 7) - 178*r**2 - 268*r*s + 156*r - 90*s**2 + 112*s - 67) - 4*fd*(r**2*(24*C - 67) + 2*r*(24*C*s - 6*C - 61*s + 16) + s*(24*C*s - 12*C - 55*s + 29))) + Ddd*f*(-24*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 134*r**2 + 4*r*(61*s - 32) + 110*s**2 - 116*s + 61)) + 2*Dd**2*f*(-24*C*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) + 402*r**2 + 12*r*(61*s - 32) + 330*s**2 - 348*s + 61)) + 6*b1*(-164*C*D1**2*f*fd*r**2 - 1168*C*D1**2*f*fd*r*s + 556*C*D1**2*f*fd*r - 1004*C*D1**2*f*fd*s**2 + 976*C*D1**2*f*fd*s - 474*C*D1**2*f*fd + 348*C*D1**2*f*fdd*r**2 + 1200*C*D1**2*f*fdd*r*s - 600*C*D1**2*f*fdd*r + 852*C*D1**2*f*fdd*s**2 - 852*C*D1**2*f*fdd*s + 426*C*D1**2*f*fdd + 348*C*D1**2*fd**2*r**2 + 1200*C*D1**2*fd**2*r*s - 600*C*D1**2*fd**2*r + 852*C*D1**2*fd**2*s**2 - 852*C*D1**2*fd**2*s - 328*C*D1*Dd*f**2*r**2 - 2336*C*D1*Dd*f**2*r*s + 748*C*D1*Dd*f**2*r - 2008*C*D1*Dd*f**2*s**2 + 1588*C*D1*Dd*f**2*s - 584*C*D1*Dd*f**2 + 2784*C*D1*Dd*f*fd*r**2 + 9600*C*D1*Dd*f*fd*r*s - 4296*C*D1*Dd*f*fd*r + 6816*C*D1*Dd*f*fd*s**2 - 6312*C*D1*Dd*f*fd*s + 1452*C*D1*Dd*f*fd + 696*C*D1*Ddd*f**2*r**2 + 2400*C*D1*Ddd*f**2*r*s - 948*C*D1*Ddd*f**2*r + 1704*C*D1*Ddd*f**2*s**2 - 1452*C*D1*Ddd*f**2*s + 600*C*D1*Ddd*f**2 + 2088*C*Dd**2*f**2*r**2 + 7200*C*Dd**2*f**2*r*s - 2844*C*Dd**2*f**2*r + 5112*C*Dd**2*f**2*s**2 - 4356*C*Dd**2*f**2*s + 600*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(r + s - 1)*(24*C*(r + s - 1) - 67*r - 55*s + 61) - 206*D1**2*f*fd*r**2 - 508*D1**2*f*fd*r*s + 324*D1**2*f*fd*r - 302*D1**2*f*fd*s**2 + 372*D1**2*f*fd*s - 221*D1**2*f*fd + 250*D1**2*f*fdd*r**2 + 548*D1**2*f*fdd*r*s - 316*D1**2*f*fdd*r + 298*D1**2*f*fdd*s**2 - 340*D1**2*f*fdd*s + 191*D1**2*f*fdd + 250*D1**2*fd**2*r**2 + 548*D1**2*fd**2*r*s - 316*D1**2*fd**2*r + 298*D1**2*fd**2*s**2 - 340*D1**2*fd**2*s - 412*D1*Dd*f**2*r**2 - 1016*D1*Dd*f**2*r*s + 460*D1*Dd*f**2*r - 604*D1*Dd*f**2*s**2 + 556*D1*Dd*f**2*s - 254*D1*Dd*f**2 + 2000*D1*Dd*f*fd*r**2 + 4384*D1*Dd*f*fd*r*s - 2312*D1*Dd*f*fd*r + 2384*D1*Dd*f*fd*s**2 - 2504*D1*Dd*f*fd*s + 656*D1*Dd*f*fd + 500*D1*Ddd*f**2*r**2 + 1096*D1*Ddd*f**2*r*s - 524*D1*Ddd*f**2*r + 596*D1*Ddd*f**2*s**2 - 572*D1*Ddd*f**2*s + 274*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(r + s - 1)*(4*C*(12*r + 2*s - 7) - 89*r - 45*s + 67) - 2*fd*(r**2*(24*C - 67) + 2*r*(12*C*(2*s - 1) - 61*s + 32) + s*(24*C*(s - 1) - 55*s + 58))) - 4*Dd*f*(24*C*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 134*r**2 - 244*r*s + 192*r - 110*s**2 + 174*s - 61)) + 1500*Dd**2*f**2*r**2 + 3288*Dd**2*f**2*r*s - 1572*Dd**2*f**2*r + 1788*Dd**2*f**2*s**2 - 1716*Dd**2*f**2*s + 274*Dd**2*f**2) + f*(-2484*C*D1**2*f*fd*r**2 - 6696*C*D1**2*f*fd*r*s + 3888*C*D1**2*f*fd*r - 4212*C*D1**2*f*fd*s**2 + 5040*C*D1**2*f*fd*s - 2232*C*D1**2*f*fd + 2484*C*D1**2*f*fdd*r**2 + 6048*C*D1**2*f*fdd*r*s - 3672*C*D1**2*f*fdd*r + 3564*C*D1**2*f*fdd*s**2 - 4392*C*D1**2*f*fdd*s + 2016*C*D1**2*f*fdd + 4968*C*D1**2*fd**2*r**2 + 12096*C*D1**2*fd**2*r*s - 7344*C*D1**2*fd**2*r + 7128*C*D1**2*fd**2*s**2 - 8784*C*D1**2*fd**2*s + 2016*C*D1**2*fd**2 - 3312*C*D1*Dd*f**2*r**2 - 8928*C*D1*Dd*f**2*r*s + 3888*C*D1*Dd*f**2*r - 5616*C*D1*Dd*f**2*s**2 + 5040*C*D1*Dd*f**2*s - 2232*C*D1*Dd*f**2 + 19872*C*D1*Dd*f*fd*r**2 + 48384*C*D1*Dd*f*fd*r*s - 25704*C*D1*Dd*f*fd*r + 28512*C*D1*Dd*f*fd*s**2 - 30744*C*D1*Dd*f*fd*s + 8064*C*D1*Dd*f*fd + 3312*C*D1*Ddd*f**2*r**2 + 8064*C*D1*Ddd*f**2*r*s - 3672*C*D1*Ddd*f**2*r + 4752*C*D1*Ddd*f**2*s**2 - 4392*C*D1*Ddd*f**2*s + 2016*C*D1*Ddd*f**2 + 9936*C*Dd**2*f**2*r**2 + 24192*C*Dd**2*f**2*r*s - 11016*C*Dd**2*f**2*r + 14256*C*Dd**2*f**2*s**2 - 13176*C*Dd**2*f**2*s + 2016*C*Dd**2*f**2 - 42*D1**2*bd1**2*(r + s - 1)*(24*C*(r + s - 1) - 67*r - 55*s + 61) + 6*D1**2*bdd1*f*(r + s - 1)*(6*C*(29*r + 71*s - 29) + 125*r + 149*s - 83) + 249*D1**2*f*fd*r**2 - 426*D1**2*f*fd*r*s - 24*D1**2*f*fd*r - 675*D1**2*f*fd*s**2 + 592*D1**2*f*fd*s - 142*D1**2*f*fd + 213*D1**2*f*fdd*r**2 + 942*D1**2*f*fdd*r*s - 456*D1**2*f*fdd*r + 729*D1**2*f*fdd*s**2 - 800*D1**2*f*fdd*s + 314*D1**2*f*fdd + 426*D1**2*fd**2*r**2 + 1884*D1**2*fd**2*r*s - 912*D1**2*fd**2*r + 1458*D1**2*fd**2*s**2 - 1600*D1**2*fd**2*s + 314*D1**2*fd**2 + 332*D1*Dd*f**2*r**2 - 568*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r - 900*D1*Dd*f**2*s**2 + 592*D1*Dd*f**2*s - 142*D1*Dd*f**2 + 1704*D1*Dd*f*fd*r**2 + 7536*D1*Dd*f*fd*r*s - 3192*D1*Dd*f*fd*r + 5832*D1*Dd*f*fd*s**2 - 5600*D1*Dd*f*fd*s + 1256*D1*Dd*f*fd + 284*D1*Ddd*f**2*r**2 + 1256*D1*Ddd*f**2*r*s - 456*D1*Ddd*f**2*r + 972*D1*Ddd*f**2*s**2 - 800*D1*Ddd*f**2*s + 314*D1*Ddd*f**2 - 6*D1*bd1*(D1*(f*(r + s - 1)*(2*C*(41*r + 251*s - 55) + 103*r + 151*s - 33) - 2*fd*(6*C*(58*r**2 + 4*r*(50*s - 27) + 142*s**2 - 171*s + 50) + 250*r**2 + 548*r*s - 366*r + 298*s**2 - 402*s + 137)) - 4*Dd*f*(3*C*(116*r**2 + 5*r*(80*s - 39) + 284*s**2 - 321*s + 79) + 250*r**2 + 548*r*s - 339*r + 298*s**2 - 375*s + 110)) + 852*Dd**2*f**2*r**2 + 3768*Dd**2*f**2*r*s - 1368*Dd**2*f**2*r + 2916*Dd**2*f**2*s**2 - 2400*Dd**2*f**2*s + 314*Dd**2*f**2))/(315*d**2*k3**4) + D1**2*Pk1*Pk2*ct*k1*k2*(D1*f*(14*D1*bd1**2*(r + s - 1)*(100*C*(r + s - 1) + 19*r + 43*s - 31) + 3*D1*bdd1*f*(r + s - 1)*(4*C*(47*r + 35*s - 35) + 33*r + 65*s - 65) - 3*bd1*(D1*(f*(r + s - 1)*(236*C*r + 84*C*(s - 1) - 53*r + 39*s - 39) - 2*fd*(4*C*(94*r**2 + r*(164*s - 129) + 70*s**2 - 111*s + 41) + 66*r**2 + r*(196*s - 131) + 130*s**2 - 179*s + 49)) - 4*Dd*f*(8*C*(47*r**2 + r*(82*s - 63) + 35*s**2 - 54*s + 19) + 66*r**2 + r*(196*s - 139) + 130*s**2 - 187*s + 57))) - 7*b1**2*(D1**2*(r + s)*(fd*(r*(100*C - 47) + s*(60*C + 21)) - fdd*(r*(100*C + 19) + s*(100*C + 43))) + 2*D1*(Dd*(f*(20*C*(10*r**2 + 16*r*s - 9*r + 6*s**2 - 7*s + 4) - 94*r**2 - 52*r*s + 60*r + 42*s**2 - 8*s - 13) - 2*fd*(r**2*(200*C + 38) + r*(100*C*(4*s - 1) + 124*s - 25) + s*(100*C*(2*s - 1) + 86*s - 37))) - Ddd*f*(100*C*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 38*r**2 + 124*r*s - 50*r + 86*s**2 - 74*s + 31)) - 2*Dd**2*f*(100*C*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) + 114*r**2 + 6*r*(62*s - 25) + 258*s**2 - 222*s + 31)) + b1*(14*D1**2*bdd1*f*(r + s - 1)*(100*C*(r + s - 1) + 19*r + 43*s - 31) - 3*D1**2*(f*(fd*(4*C*(118*r**2 + 2*r*(80*s - 59) + 42*s**2 - 80*s + 59) - 106*r**2 - 28*r*s + 106*r + 78*s**2 + 14*s - 53) - fdd*(4*C*(94*r**2 + 164*r*s - 94*r + 70*s**2 - 82*s + 47) + 66*r**2 + 196*r*s - 66*r + 130*s**2 - 98*s + 33)) - 2*fd**2*(r**2*(188*C + 33) + r*(4*C*(82*s - 47) + 98*s - 33) + s*(4*C*(35*s - 41) + 65*s - 49))) - 14*D1*bd1*(D1*(f*(r + s - 1)*(20*C*(5*r + 3*s - 4) - 47*r + 21*s + 13) - 2*fd*(r**2*(100*C + 19) + r*(100*C*(2*s - 1) + 62*s - 25) + s*(100*C*(s - 1) + 43*s - 37))) - 4*Dd*f*(100*C*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 38*r**2 + 124*r*s - 75*r + 86*s**2 - 111*s + 31)) - 6*D1*f*(Dd*(f*(4*C*(118*r**2 + 160*r*s - 99*r + 42*s**2 - 61*s + 40) - 106*r**2 - 28*r*s + 60*r + 78*s**2 - 32*s - 7) - 2*fd*(2*r + 2*s - 1)*(8*C*(47*r + 35*s - 22) + 66*r + 130*s - 41)) - Ddd*f*(4*C*(94*r**2 + 164*r*s - 88*r + 70*s**2 - 76*s + 41) + 66*r**2 + 196*r*s - 82*r + 130*s**2 - 114*s + 49)) + 6*Dd**2*f**2*(4*C*(282*r**2 + 12*r*(41*s - 22) + 210*s**2 - 228*s + 41) + 198*r**2 + 6*r*(98*s - 41) + 390*s**2 - 342*s + 49)))/(105*d**2*k3**4) + 4*D1**2*Pk1*Pk2*ct*k1*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2*k3**2) + 4*D1**2*Pk1*Pk2*ct*k1*st**4*(33*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + 11*b1*(D1**2*(-10*f**2*(fd*(-6*s**2 + 4*s - 2) + fdd*(3*s**2 - 2*s + 1) + s**2*(-6*bd1 + 3*bdd1)) + f*(20*fd**2*s*(2 - 3*s) - 6*fd*(s**2*(20*bd1 - 2) + s*(2 - 10*bd1) - 1) - 3*fdd*(2*s**2 - 2*s + 1) - 3*s**2*(-28*bd1 + 14*bdd1)) - 6*fd*s*(14*bd1 + fd)*(s - 1)) + D1*f*(2*Dd*(10*f**2*(4*s**2 - 2*s + 1) + f*(-10*fd*(12*s**2 - 7*s + 1) + s**2*(12 - 120*bd1) + s*(30*bd1 - 6) + 3) - (12*s - 3)*(14*bd1*s + fd*(2*s - 1))) - Ddd*f*(10*f + 3)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(10*f + 3)*(2*s - 1)) + f*(D1**2*(-66*bd1*s*(7*bd1*s + fd*(2*s - 1)) + 5*f**2*(10*fd*(4*s**2 - 2*s + 1) - 5*fdd*(4*s**2 - 2*s + 1) + s**2*(44*bd1 - 22*bdd1)) + f*s*(-330*bd1**2*s - 220*bd1*fd*(3*s - 1) + 66*bd1*s - 33*bdd1*s - 150*fd**2*(2*s - 1))) + D1*f*(2*Dd*(33*bd1*s*(1 - 4*s) + 25*f**2*(4*s**2 - 2*s + 1) - 5*f*(4*s - 1)*(22*bd1*s + 20*fd*s - 5*fd)) - 25*Ddd*f**2*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**3*s*(1 - 2*s)))/(385*d**2*k2**3) + 2*D1**2*Pk1*Pk2*ct*k1*st**2*(14*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + b1**2*(-14*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 318*D1**2*f*fd*s**2 + 462*D1**2*f*fd*s - 231*D1**2*f*fd + 222*D1**2*f*fdd*s**2 - 294*D1**2*f*fdd*s + 147*D1**2*f*fdd + 222*D1**2*fd**2*s**2 - 294*D1**2*fd**2*s - 301*D1**2*fd*s**2 + 658*D1**2*fd*s - 329*D1**2*fd + 203*D1**2*fdd*s**2 - 434*D1**2*fdd*s + 217*D1**2*fdd - 636*D1*Dd*f**2*s**2 + 318*D1*Dd*f**2*s - 159*D1*Dd*f**2 + 1776*D1*Dd*f*fd*s**2 - 1620*D1*Dd*f*fd*s + 294*D1*Dd*f*fd - 1204*D1*Dd*f*s**2 + 602*D1*Dd*f*s - 301*D1*Dd*f + 1624*D1*Dd*fd*s**2 - 2142*D1*Dd*fd*s + 434*D1*Dd*fd + 444*D1*Ddd*f**2*s**2 - 222*D1*Ddd*f**2*s + 111*D1*Ddd*f**2 + 812*D1*Ddd*f*s**2 - 406*D1*Ddd*f*s + 203*D1*Ddd*f + 28*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) + 1332*Dd**2*f**2*s**2 - 666*Dd**2*f**2*s + 2436*Dd**2*f*s**2 - 1218*Dd**2*f*s) + b1*(-28*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) + 2*D1**2*bdd1*f*(3*f*(37*s**2 + 12*s - 6) + 203*s**2 + 14*s - 7) - 534*D1**2*f**2*fd*s**2 + 396*D1**2*f**2*fd*s - 198*D1**2*f**2*fd + 348*D1**2*f**2*fdd*s**2 - 252*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd + 696*D1**2*f*fd**2*s**2 - 504*D1**2*f*fd**2*s - 170*D1**2*f*fd*s**2 + 170*D1**2*f*fd*s - 85*D1**2*f*fd + 106*D1**2*f*fdd*s**2 - 106*D1**2*f*fdd*s + 53*D1**2*f*fdd + 106*D1**2*fd**2*s**2 - 106*D1**2*fd**2*s - 712*D1*Dd*f**3*s**2 + 356*D1*Dd*f**3*s - 178*D1*Dd*f**3 + 2784*D1*Dd*f**2*fd*s**2 - 1704*D1*Dd*f**2*fd*s + 252*D1*Dd*f**2*fd - 340*D1*Dd*f**2*s**2 + 170*D1*Dd*f**2*s - 85*D1*Dd*f**2 + 848*D1*Dd*f*fd*s**2 - 636*D1*Dd*f*fd*s + 106*D1*Dd*f*fd + 464*D1*Ddd*f**3*s**2 - 232*D1*Ddd*f**3*s + 116*D1*Ddd*f**3 + 212*D1*Ddd*f**2*s**2 - 106*D1*Ddd*f**2*s + 53*D1*Ddd*f**2 - 2*D1*bd1*(D1*(3*f**2*(53*s**2 + 24*s - 12) + f*(s**2*(301 - 444*fd) + s*(222*fd + 28) - 14) + 14*fd*s*(30 - 29*s)) - 2*Dd*f*(4*s - 1)*(3*f*(37*s + 6) + 203*s + 7)) + 1392*Dd**2*f**3*s**2 - 696*Dd**2*f**3*s + 636*Dd**2*f**2*s**2 - 318*Dd**2*f**2*s) + f*(2*D1**2*bd1**2*s*(111*f*s + 36*f + 203*s + 14) - D1**2*bd1*(2*f**2*(89*s**2 + 20*s - 10) + f*s*(-24*fd*(29*s - 8) + 85*s) + 106*fd*s*(1 - 2*s)) + D1**2*bdd1*f*(2*f*(58*s**2 + 10*s - 5) + 53*s**2) + 2*D1*Dd*bd1*f*(4*s - 1)*(2*f*(58*s + 5) + 53*s) - 5*f*(D1**2*(f*(11*fd - 7*fdd)*(4*s**2 - 2*s + 1) + 42*fd**2*s*(1 - 2*s)) + D1*f*(11*Dd*f*(4*s**2 - 2*s + 1) - 14*Dd*fd*(1 - 4*s)**2 - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s))))/(105*d**2*k2**3) - D1**2*Pk1*Pk2*ct*k1*(35*b1**3*(D1**2*s**2*(5*fd - 3*fdd) + D1*Dd*(5*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 28) + s*(6*fd - 14) + 7) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + 7*b1**2*(-5*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) + 30*D1**2*f*fd*s**2 + 30*D1**2*f*fd*s - 15*D1**2*f*fd - 6*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s + 15*D1**2*f*fdd - 6*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s - 8*D1**2*fd*s**2 + 50*D1**2*fd*s - 25*D1**2*fd + 14*D1**2*fdd*s**2 - 50*D1**2*fdd*s + 25*D1**2*fdd + 60*D1*Dd*f**2*s**2 - 30*D1*Dd*f**2*s + 15*D1*Dd*f**2 - 48*D1*Dd*f*fd*s**2 - 108*D1*Dd*f*fd*s + 30*D1*Dd*f*fd - 32*D1*Dd*f*s**2 + 16*D1*Dd*f*s - 8*D1*Dd*f + 112*D1*Dd*fd*s**2 - 228*D1*Dd*fd*s + 50*D1*Dd*fd - 12*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 56*D1*Ddd*f*s**2 - 28*D1*Ddd*f*s + 14*D1*Ddd*f + 5*D1*bd1*(D1*(5*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 21) + s*(6*fd - 14) + 7) - 2*Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) - 36*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s + 168*Dd**2*f*s**2 - 84*Dd**2*f*s) + b1*(-70*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) - 7*D1**2*bdd1*f*(6*f*(s**2 - 6*s + 3) - 28*s**2 - 22*s + 11) - 153*D1**2*f**2*fd*s**2 + 252*D1**2*f**2*fd*s - 126*D1**2*f**2*fd + 243*D1**2*f**2*fdd*s**2 - 252*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd + 486*D1**2*f*fd**2*s**2 - 504*D1**2*f*fd**2*s - 154*D1**2*f*fd*s**2 + 154*D1**2*f*fd*s - 77*D1**2*f*fd + 154*D1**2*f*fdd*s**2 - 154*D1**2*f*fdd*s + 77*D1**2*f*fdd + 154*D1**2*fd**2*s**2 - 154*D1**2*fd**2*s - 204*D1*Dd*f**3*s**2 + 102*D1*Dd*f**3*s - 51*D1*Dd*f**3 + 1944*D1*Dd*f**2*fd*s**2 - 1494*D1*Dd*f**2*fd*s + 252*D1*Dd*f**2*fd - 308*D1*Dd*f**2*s**2 + 154*D1*Dd*f**2*s - 77*D1*Dd*f**2 + 1232*D1*Dd*f*fd*s**2 - 924*D1*Dd*f*fd*s + 154*D1*Dd*f*fd + 324*D1*Ddd*f**3*s**2 - 162*D1*Ddd*f**3*s + 81*D1*Ddd*f**3 + 308*D1*Ddd*f**2*s**2 - 154*D1*Ddd*f**2*s + 77*D1*Ddd*f**2 + 7*D1*bd1*(D1*(30*f**2*(s - 1)**2 + f*(-s**2*(24*fd + 16) + s*(12*fd - 34) + 17) + 2*fd*s*(28*s - 39)) - 2*Dd*f*(4*s - 1)*(6*f*(s - 3) - 28*s - 11)) + 972*Dd**2*f**3*s**2 - 486*Dd**2*f**3*s + 924*Dd**2*f**2*s**2 - 462*Dd**2*f**2*s) + f*(14*D1**2*bd1**2*s*(-3*f*(s - 6) + 14*s + 11) + D1*bd1*(D1*(-3*f**2*(17*s**2 + 50*s - 25) + f*s*(486*fd*s + 18*fd - 77*s) + 154*fd*s*(2*s - 1)) + 2*Dd*f*(4*s - 1)*(9*f*(9*s + 5) + 77*s)) + f*(D1**2*bdd1*(9*f*(9*s**2 + 10*s - 5) + 77*s**2) - 45*D1**2*(f*(fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) - 45*D1*f*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) - 270*Dd**2*f**2*s*(1 - 2*s))))/(105*d**2*k2**3) + 4*D1**2*Pk1*Pk2*ct*k2**5*st**6*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 72*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 72*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 144*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 144*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 28*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s - 8*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 12*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s - 2*Dd**2*f**3)/(63*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk2*ct*k2**5*st**4*(-D1*f*(14*D1*bd1**2*(r + s - 1)**2 + bd1*(r + s - 1)*(5*D1*f*(r + s - 1) + 2*D1*fd*(2*r + 2*s - 1) + 4*Dd*f*(2*r + 2*s - 1)) + f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1))) + 7*b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-14*D1**2*bdd1*f*(r + s - 1)**2 - 10*D1**2*f*fd*r**2 - 20*D1**2*f*fd*r*s + 10*D1**2*f*fd*r - 10*D1**2*f*fd*s**2 + 10*D1**2*f*fd*s - 5*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s - 20*D1*Dd*f**2*r**2 - 40*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r - 20*D1*Dd*f**2*s**2 + 20*D1*Dd*f**2*s - 10*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 16*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 16*D1*Dd*f*fd*s - 4*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 4*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + 28*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 12*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 12*Dd**2*f**2*s - 2*Dd**2*f**2))/(35*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk2*ct*k2**3*st**6*(72*C*D1**2*b1*f*fd*r**2 + 72*C*D1**2*b1*f*fd*r*s - 36*C*D1**2*b1*f*fd*r - 36*C*D1**2*b1*f*fdd*r**2 - 36*C*D1**2*b1*f*fdd*r*s + 18*C*D1**2*b1*f*fdd*r - 36*C*D1**2*b1*fd**2*r**2 - 36*C*D1**2*b1*fd**2*r*s + 18*C*D1**2*b1*fd**2*r + 12*C*D1**2*f**2*fd*r**2 + 12*C*D1**2*f**2*fd*r*s - 12*C*D1**2*f**2*fd*r - 4*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r**2 - 6*C*D1**2*f**2*fdd*r*s + 6*C*D1**2*f**2*fdd*r + 2*C*D1**2*f**2*fdd*s - 2*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r**2 - 12*C*D1**2*f*fd**2*r*s + 12*C*D1**2*f*fd**2*r + 4*C*D1**2*f*fd**2*s - 2*C*D1**2*f*fd**2 + 144*C*D1*Dd*b1*f**2*r**2 + 144*C*D1*Dd*b1*f**2*r*s - 108*C*D1*Dd*b1*f**2*r - 36*C*D1*Dd*b1*f**2*s + 36*C*D1*Dd*b1*f**2 - 288*C*D1*Dd*b1*f*fd*r**2 - 288*C*D1*Dd*b1*f*fd*r*s + 180*C*D1*Dd*b1*f*fd*r + 36*C*D1*Dd*b1*f*fd*s - 18*C*D1*Dd*b1*f*fd + 16*C*D1*Dd*f**3*r**2 + 16*C*D1*Dd*f**3*r*s - 12*C*D1*Dd*f**3*r - 4*C*D1*Dd*f**3*s + 4*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r**2 - 48*C*D1*Dd*f**2*fd*r*s + 42*C*D1*Dd*f**2*fd*r + 14*C*D1*Dd*f**2*fd*s - 8*C*D1*Dd*f**2*fd - 72*C*D1*Ddd*b1*f**2*r**2 - 72*C*D1*Ddd*b1*f**2*r*s + 54*C*D1*Ddd*b1*f**2*r + 18*C*D1*Ddd*b1*f**2*s - 18*C*D1*Ddd*b1*f**2 - 8*C*D1*Ddd*f**3*r**2 - 8*C*D1*Ddd*f**3*r*s + 6*C*D1*Ddd*f**3*r + 2*C*D1*Ddd*f**3*s - 2*C*D1*Ddd*f**3 - 216*C*Dd**2*b1*f**2*r**2 - 216*C*Dd**2*b1*f**2*r*s + 162*C*Dd**2*b1*f**2*r + 54*C*Dd**2*b1*f**2*s - 18*C*Dd**2*b1*f**2 - 24*C*Dd**2*f**3*r**2 - 24*C*Dd**2*f**3*r*s + 18*C*Dd**2*f**3*r + 6*C*Dd**2*f**3*s - 2*C*Dd**2*f**3 - 72*D1**2*b1*f*fd*r**2 - 36*D1**2*b1*f*fd*r*s + 18*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd + 36*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd + 36*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)*(2*C*(r - 1) - 2*r + s + 2) - 12*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 10*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 2*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 5*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + D1**2*f**2*fdd*s + D1**2*f**2*fdd + 12*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 10*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 2*D1**2*f*fd**2*s + D1**2*f*fd**2 - 144*D1*Dd*b1*f**2*r**2 - 72*D1*Dd*b1*f**2*r*s + 90*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 18*D1*Dd*b1*f**2*s - 18*D1*Dd*b1*f**2 + 288*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 126*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 90*D1*Dd*b1*f*fd*s - 9*D1*Dd*b1*f*fd - 16*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 2*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 35*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 7*D1*Dd*f**2*fd*s + 4*D1*Dd*f**2*fd + 72*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 45*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 9*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 8*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 5*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + D1*Ddd*f**3*s + D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(2*f*(r + s - 1)*(2*C*(r - 1) - 2*r + s + 2) + fd*(-2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 8*r**2 + 4*r*s - 9*r - 4*s**2 + 1)) + Dd*f*(-2*C*(8*r**2 + 8*r*s - 11*r - 5*s + 3) + 16*r**2 + 8*r*s - 21*r - 8*s**2 - 3*s + 5)) + 216*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 135*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 27*Dd**2*b1*f**2*s + 9*Dd**2*b1*f**2 + 24*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 15*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 3*Dd**2*f**3*s + Dd**2*f**3)/(63*d**2*k1*k3**4) + D1**2*Pk1*Pk2*ct*k2**3*st**4*(168*b1**2*(C - 1)*(D1**2*r*(2*fd - fdd)*(r + s) + D1*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 3*r + s)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + Dd**2*f*(-12*r**2 + r*(9 - 12*s) + 3*s - 1)) + 3*b1*(-80*C*D1**2*f*fd*r**2 - 80*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s + 16*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r**2 - 16*C*D1**2*f*fdd*r*s + 16*C*D1**2*f*fdd*r + 8*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r**2 - 16*C*D1**2*fd**2*r*s + 16*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r**2 - 160*C*D1*Dd*f**2*r*s + 120*C*D1*Dd*f**2*r + 40*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 - 128*C*D1*Dd*f*fd*r**2 - 128*C*D1*Dd*f*fd*r*s + 112*C*D1*Dd*f*fd*r + 48*C*D1*Dd*f*fd*s - 24*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r**2 - 32*C*D1*Ddd*f**2*r*s + 24*C*D1*Ddd*f**2*r + 8*C*D1*Ddd*f**2*s - 8*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r**2 - 96*C*Dd**2*f**2*r*s + 72*C*Dd**2*f**2*r + 24*C*Dd**2*f**2*s - 8*C*Dd**2*f**2 - 56*D1**2*bdd1*f*(C - 1)*(2*r - 1)*(r + s - 1) - 62*D1**2*f*fd*r**2 - 228*D1**2*f*fd*r*s + 130*D1**2*f*fd*r - 166*D1**2*f*fd*s**2 + 182*D1**2*f*fd*s - 99*D1**2*f*fd + 122*D1**2*f*fdd*r**2 + 268*D1**2*f*fdd*r*s - 142*D1**2*f*fdd*r + 146*D1**2*f*fdd*s**2 - 154*D1**2*f*fdd*s + 81*D1**2*f*fdd + 122*D1**2*fd**2*r**2 + 268*D1**2*fd**2*r*s - 142*D1**2*fd**2*r + 146*D1**2*fd**2*s**2 - 154*D1**2*fd**2*s - 124*D1*Dd*f**2*r**2 - 456*D1*Dd*f**2*r*s + 176*D1*Dd*f**2*r - 332*D1*Dd*f**2*s**2 + 280*D1*Dd*f**2*s - 114*D1*Dd*f**2 + 976*D1*Dd*f*fd*r**2 + 2144*D1*Dd*f*fd*r*s - 1080*D1*Dd*f*fd*r + 1168*D1*Dd*f*fd*s**2 - 1176*D1*Dd*f*fd*s + 296*D1*Dd*f*fd + 244*D1*Ddd*f**2*r**2 + 536*D1*Ddd*f**2*r*s - 256*D1*Ddd*f**2*r + 292*D1*Ddd*f**2*s**2 - 280*D1*Ddd*f**2*s + 134*D1*Ddd*f**2 + 56*D1*bd1*(C - 1)*(D1*(2*f*(2*r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 3*r + s)) - 2*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 732*Dd**2*f**2*r**2 + 1608*Dd**2*f**2*r*s - 768*Dd**2*f**2*r + 876*Dd**2*f**2*s**2 - 840*Dd**2*f**2*s + 134*Dd**2*f**2) + f*(-264*C*D1**2*f*fd*r**2 - 264*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*r + 88*C*D1**2*f*fd*s - 88*C*D1**2*f*fd + 240*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 240*C*D1**2*f*fdd*r - 80*C*D1**2*f*fdd*s + 80*C*D1**2*f*fdd + 480*C*D1**2*fd**2*r**2 + 480*C*D1**2*fd**2*r*s - 480*C*D1**2*fd**2*r - 160*C*D1**2*fd**2*s + 80*C*D1**2*fd**2 - 352*C*D1*Dd*f**2*r**2 - 352*C*D1*Dd*f**2*r*s + 264*C*D1*Dd*f**2*r + 88*C*D1*Dd*f**2*s - 88*C*D1*Dd*f**2 + 1920*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 1680*C*D1*Dd*f*fd*r - 560*C*D1*Dd*f*fd*s + 320*C*D1*Dd*f*fd + 320*C*D1*Ddd*f**2*r**2 + 320*C*D1*Ddd*f**2*r*s - 240*C*D1*Ddd*f**2*r - 80*C*D1*Ddd*f**2*s + 80*C*D1*Ddd*f**2 + 960*C*Dd**2*f**2*r**2 + 960*C*Dd**2*f**2*r*s - 720*C*Dd**2*f**2*r - 240*C*Dd**2*f**2*s + 80*C*Dd**2*f**2 - 168*D1**2*bd1**2*(C - 1)*(2*r - 1)*(r + s - 1) - 3*D1**2*bdd1*f*(r + s - 1)*(8*C*r - 61*r - 73*s + 53) - 153*D1**2*f*fd*r**2 - 294*D1**2*f*fd*r*s + 200*D1**2*f*fd*r - 141*D1**2*f*fd*s**2 + 192*D1**2*f*fd*s - 98*D1**2*f*fd + 171*D1**2*f*fdd*r**2 + 282*D1**2*f*fdd*r*s - 208*D1**2*f*fdd*r + 111*D1**2*f*fdd*s**2 - 168*D1**2*f*fdd*s + 94*D1**2*f*fdd + 342*D1**2*fd**2*r**2 + 564*D1**2*fd**2*r*s - 416*D1**2*fd**2*r + 222*D1**2*fd**2*s**2 - 336*D1**2*fd**2*s + 94*D1**2*fd**2 - 204*D1*Dd*f**2*r**2 - 392*D1*Dd*f**2*r*s + 200*D1*Dd*f**2*r - 188*D1*Dd*f**2*s**2 + 192*D1*Dd*f**2*s - 98*D1*Dd*f**2 + 1368*D1*Dd*f*fd*r**2 + 2256*D1*Dd*f*fd*r*s - 1456*D1*Dd*f*fd*r + 888*D1*Dd*f*fd*s**2 - 1176*D1*Dd*f*fd*s + 376*D1*Dd*f*fd + 228*D1*Ddd*f**2*r**2 + 376*D1*Ddd*f**2*r*s - 208*D1*Ddd*f**2*r + 148*D1*Ddd*f**2*s**2 - 168*D1*Ddd*f**2*s + 94*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r + s - 1)*(8*C*(5*r - 7) + 31*r + 83*s - 15) + 2*fd*(4*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 122*r**2 - 268*r*s + 185*r - 146*s**2 + 203*s - 67)) + 8*Dd*f*(C*(8*r**2 + 8*r*s - 7*r - s + 1) - 61*r**2 - 134*r*s + 89*r - 73*s**2 + 98*s - 30)) + 684*Dd**2*f**2*r**2 + 1128*Dd**2*f**2*r*s - 624*Dd**2*f**2*r + 444*Dd**2*f**2*s**2 - 504*Dd**2*f**2*s + 94*Dd**2*f**2))/(105*d**2*k1*k3**4) + D1**2*Pk1*Pk2*ct*k2**3*st**2*(D1*f*(434*D1*bd1**2*(r + s - 1)**2 + D1*bd1*(-f*(r + s - 1)*(r*(136*C - 29) + 43*s + 41) + 2*fd*(48*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 202*r**2 + 308*r*s - 255*r + 106*s**2 - 183*s + 77)) + D1*bdd1*f*(r + s - 1)*(r*(96*C + 101) + 53*s - 53) + 4*Dd*bd1*f*(24*C*(8*r**2 + r*(8*s - 7) - s + 1) + 202*r**2 + r*(308*s - 243) + 106*s**2 - 171*s + 65) + 36*f*(D1*fd*(3*r**2 + 3*r*(s - 1) - s + 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1))) - 7*b1**2*(D1**2*(r + s)*(fd*r*(40*C - 3) + 17*fd*s - 31*fdd*(r + s)) + 2*D1*(Dd*(f*(20*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 6*r**2 + 28*r*s - 4*r + 34*s**2 - 24*s + 7) - 62*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 31*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 62*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-272*C*D1**2*f*fd*r**2 - 272*C*D1**2*f*fd*r*s + 272*C*D1**2*f*fd*r + 136*C*D1**2*f*fd*s - 136*C*D1**2*f*fd + 192*C*D1**2*f*fdd*r**2 + 192*C*D1**2*f*fdd*r*s - 192*C*D1**2*f*fdd*r - 96*C*D1**2*f*fdd*s + 96*C*D1**2*f*fdd + 192*C*D1**2*fd**2*r**2 + 192*C*D1**2*fd**2*r*s - 192*C*D1**2*fd**2*r - 96*C*D1**2*fd**2*s - 544*C*D1*Dd*f**2*r**2 - 544*C*D1*Dd*f**2*r*s + 408*C*D1*Dd*f**2*r + 136*C*D1*Dd*f**2*s - 136*C*D1*Dd*f**2 + 1536*C*D1*Dd*f*fd*r**2 + 1536*C*D1*Dd*f*fd*r*s - 1344*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s + 288*C*D1*Dd*f*fd + 384*C*D1*Ddd*f**2*r**2 + 384*C*D1*Ddd*f**2*r*s - 288*C*D1*Ddd*f**2*r - 96*C*D1*Ddd*f**2*s + 96*C*D1*Ddd*f**2 + 1152*C*Dd**2*f**2*r**2 + 1152*C*Dd**2*f**2*r*s - 864*C*Dd**2*f**2*r - 288*C*Dd**2*f**2*s + 96*C*Dd**2*f**2 + 434*D1**2*bdd1*f*(r + s - 1)**2 + 58*D1**2*f*fd*r**2 - 28*D1**2*f*fd*r*s + 26*D1**2*f*fd*r - 86*D1**2*f*fd*s**2 + 98*D1**2*f*fd*s - 55*D1**2*f*fd + 202*D1**2*f*fdd*r**2 + 308*D1**2*f*fdd*r*s - 202*D1**2*f*fdd*r + 106*D1**2*f*fdd*s**2 - 154*D1**2*f*fdd*s + 101*D1**2*f*fdd + 202*D1**2*fd**2*r**2 + 308*D1**2*fd**2*r*s - 202*D1**2*fd**2*r + 106*D1**2*fd**2*s**2 - 154*D1**2*fd**2*s + 116*D1*Dd*f**2*r**2 - 56*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r - 172*D1*Dd*f**2*s**2 + 100*D1*Dd*f**2*s - 14*D1*Dd*f**2 + 1616*D1*Dd*f*fd*r**2 + 2464*D1*Dd*f*fd*r*s - 1520*D1*Dd*f*fd*r + 848*D1*Dd*f*fd*s**2 - 1136*D1*Dd*f*fd*s + 356*D1*Dd*f*fd + 404*D1*Ddd*f**2*r**2 + 616*D1*Ddd*f**2*r*s - 356*D1*Ddd*f**2*r + 212*D1*Ddd*f**2*s**2 - 260*D1*Ddd*f**2*s + 154*D1*Ddd*f**2 - 14*D1*bd1*(r + s - 1)*(D1*f*(20*C*(2*r - 1) - 3*r + 17*s - 7) - 62*D1*fd*(r + s) - 124*Dd*f*(2*r + 2*s - 1)) + 1212*Dd**2*f**2*r**2 + 1848*Dd**2*f**2*r*s - 1068*Dd**2*f**2*r + 636*Dd**2*f**2*s**2 - 780*Dd**2*f**2*s + 154*Dd**2*f**2))/(105*d**2*k1*k3**4) + 2*D1**2*Pk1*Pk2*k1**4*st**2*(3*b1*(D1**2*(f*(fd + 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(4*r*s - r + 4*s**2 - 3*s + 1) + 3*fd*(8*s - 3)*(2*r + 2*s - 1)) + 3*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 3*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(9*bdd1*s*(r + s - 1) + fd*(-3*r*s + r - 3*s**2 + 3*s - 1) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(r + s - 1) + 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(-4*r*s + r - 4*s**2 + 3*s - 1) + 5*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) + 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(315*d**2*k2**2*k3**4) - 2*D1**2*Pk1*Pk2*k1**4*(-3*D1*f*(7*D1*bd1**2*(2*s - 1)*(r + s - 1) + D1*bd1*(-3*f*(s - 1)*(r + s - 1) + 5*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + 5*D1*bdd1*f*(s - 1)*(r + s - 1) + 5*Dd*bd1*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) + 7*b1**2*(D1**2*s*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + 3*fd*(-8*r*s + r + s*(3 - 8*s))) - 3*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + 3*D1**2*s*(2*r + 2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 7*D1*bd1*(D1*(f*(2*s - 1)*(r + s - 1) + 3*fd*(-4*r*s + r + s*(3 - 4*s))) - 6*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r*s - r + 4*s**2 - 3*s + 1) + 5*fd*(8*s - 1)*(2*r + 2*s - 1)) + 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 15*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k2**2*k3**4) + 2*D1**2*Pk1*Pk2*k1**2*st**4*(48*C*D1**2*b1*f*fd*r*s - 24*C*D1**2*b1*f*fd*r + 48*C*D1**2*b1*f*fd*s**2 - 48*C*D1**2*b1*f*fd*s + 24*C*D1**2*b1*f*fd - 24*C*D1**2*b1*f*fdd*r*s + 12*C*D1**2*b1*f*fdd*r - 24*C*D1**2*b1*f*fdd*s**2 + 24*C*D1**2*b1*f*fdd*s - 12*C*D1**2*b1*f*fdd - 24*C*D1**2*b1*fd**2*r*s + 12*C*D1**2*b1*fd**2*r - 24*C*D1**2*b1*fd**2*s**2 + 24*C*D1**2*b1*fd**2*s + 24*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r + 24*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r*s + 4*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r*s + 8*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 96*C*D1*Dd*b1*f**2*r*s - 24*C*D1*Dd*b1*f**2*r + 96*C*D1*Dd*b1*f**2*s**2 - 72*C*D1*Dd*b1*f**2*s + 24*C*D1*Dd*b1*f**2 - 192*C*D1*Dd*b1*f*fd*r*s + 72*C*D1*Dd*b1*f*fd*r - 192*C*D1*Dd*b1*f*fd*s**2 + 168*C*D1*Dd*b1*f*fd*s - 36*C*D1*Dd*b1*f*fd + 32*C*D1*Dd*f**3*r*s - 8*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r*s + 28*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 84*C*D1*Dd*f**2*fd*s - 16*C*D1*Dd*f**2*fd - 48*C*D1*Ddd*b1*f**2*r*s + 12*C*D1*Ddd*b1*f**2*r - 48*C*D1*Ddd*b1*f**2*s**2 + 36*C*D1*Ddd*b1*f**2*s - 12*C*D1*Ddd*b1*f**2 - 16*C*D1*Ddd*f**3*r*s + 4*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 12*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 144*C*Dd**2*b1*f**2*r*s + 36*C*Dd**2*b1*f**2*r - 144*C*Dd**2*b1*f**2*s**2 + 108*C*Dd**2*b1*f**2*s - 12*C*Dd**2*b1*f**2 - 48*C*Dd**2*f**3*r*s + 12*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 36*C*Dd**2*f**3*s - 4*C*Dd**2*f**3 - 12*D1**2*b1*f*fd*r**2 - 10*D1**2*b1*f*fd*r*s + 5*D1**2*b1*f*fd*r + 2*D1**2*b1*f*fd*s**2 - 2*D1**2*b1*f*fd*s + D1**2*b1*f*fd + 6*D1**2*b1*f*fdd*r**2 + 12*D1**2*b1*f*fdd*r*s - 6*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 - 6*D1**2*b1*f*fdd*s + 3*D1**2*b1*f*fdd + 6*D1**2*b1*fd**2*r**2 + 12*D1**2*b1*fd**2*r*s - 6*D1**2*b1*fd**2*r + 6*D1**2*b1*fd**2*s**2 - 6*D1**2*b1*fd**2*s + 3*D1**2*bdd1*f**2*(r + s - 1)*(-4*C*s + r + s - 1) - 6*D1**2*f**2*fd*r**2 - 9*D1**2*f**2*fd*r*s + 7*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s**2 + 5*D1**2*f**2*fd*s - 3*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 6*D1**2*f**2*fdd*r*s - 4*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 4*D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 12*D1**2*f*fd**2*r*s - 8*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 8*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 - 24*D1*Dd*b1*f**2*r**2 - 20*D1*Dd*b1*f**2*r*s + 17*D1*Dd*b1*f**2*r + 4*D1*Dd*b1*f**2*s**2 + 3*D1*Dd*b1*f**2*s - 5*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 96*D1*Dd*b1*f*fd*r*s - 48*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 48*D1*Dd*b1*f*fd*s + 12*D1*Dd*b1*f*fd - 8*D1*Dd*f**3*r**2 - 12*D1*Dd*f**3*r*s + 7*D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 5*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 48*D1*Dd*f**2*fd*r*s - 28*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 28*D1*Dd*f**2*fd*s + 8*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 + 24*D1*Ddd*b1*f**2*r*s - 12*D1*Ddd*b1*f**2*r + 12*D1*Ddd*b1*f**2*s**2 - 12*D1*Ddd*b1*f**2*s + 6*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 8*D1*Ddd*f**3*r*s - 4*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 4*D1*Ddd*f**3*s + 2*D1*Ddd*f**3 + D1*bd1*f*(D1*(-f*(r + s - 1)*(6*r - s*(24*C + 1) - 6) - 6*fd*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 - 2*r**2 + r*(3 - 4*s) - 2*s**2 + 3*s - 1)) + 12*Dd*f*(C*(-8*r*s + r - 8*s**2 + 7*s - 1) + 2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 36*Dd**2*b1*f**2*r**2 + 72*Dd**2*b1*f**2*r*s - 36*Dd**2*b1*f**2*r + 36*Dd**2*b1*f**2*s**2 - 36*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 24*Dd**2*f**3*r*s - 12*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 12*Dd**2*f**3*s + 2*Dd**2*f**3)/(35*d**2*k3**4) - 2*D1**2*Pk1*Pk2*k1**2*st**2*(21*b1**2*(D1**2*(r + s)*(fd*(6*r + s) - 3*fdd*(r + s)) + D1*(Dd*(f*(24*r**2 + r*(28*s - 19) + 4*s**2 - 9*s + 7) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 6*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 3*b1*(42*C*D1**2*f*fd*r**2 + 308*C*D1**2*f*fd*r*s - 154*C*D1**2*f*fd*r + 266*C*D1**2*f*fd*s**2 - 266*C*D1**2*f*fd*s + 133*C*D1**2*f*fd - 70*C*D1**2*f*fdd*r**2 - 308*C*D1**2*f*fdd*r*s + 154*C*D1**2*f*fdd*r - 238*C*D1**2*f*fdd*s**2 + 238*C*D1**2*f*fdd*s - 119*C*D1**2*f*fdd - 70*C*D1**2*fd**2*r**2 - 308*C*D1**2*fd**2*r*s + 154*C*D1**2*fd**2*r - 238*C*D1**2*fd**2*s**2 + 238*C*D1**2*fd**2*s + 84*C*D1*Dd*f**2*r**2 + 616*C*D1*Dd*f**2*r*s - 196*C*D1*Dd*f**2*r + 532*C*D1*Dd*f**2*s**2 - 420*C*D1*Dd*f**2*s + 154*C*D1*Dd*f**2 - 560*C*D1*Dd*f*fd*r**2 - 2464*C*D1*Dd*f*fd*r*s + 1064*C*D1*Dd*f*fd*r - 1904*C*D1*Dd*f*fd*s**2 + 1736*C*D1*Dd*f*fd*s - 392*C*D1*Dd*f*fd - 140*C*D1*Ddd*f**2*r**2 - 616*C*D1*Ddd*f**2*r*s + 224*C*D1*Ddd*f**2*r - 476*C*D1*Ddd*f**2*s**2 + 392*C*D1*Ddd*f**2*s - 154*C*D1*Ddd*f**2 - 420*C*Dd**2*f**2*r**2 - 1848*C*Dd**2*f**2*r*s + 672*C*Dd**2*f**2*r - 1428*C*Dd**2*f**2*s**2 + 1176*C*Dd**2*f**2*s - 154*C*Dd**2*f**2 - 42*D1**2*bdd1*f*(r + s - 1)**2 + 22*D1**2*f*fd*r**2 + 42*D1**2*f*fd*r*s - 28*D1**2*f*fd*r + 20*D1**2*f*fd*s**2 - 27*D1**2*f*fd*s + 17*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 42*D1**2*f*fdd*r*s + 21*D1**2*f*fdd*r - 24*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s - 12*D1**2*f*fdd - 18*D1**2*fd**2*r**2 - 42*D1**2*fd**2*r*s + 21*D1**2*fd**2*r - 24*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 84*D1*Dd*f**2*r*s - 43*D1*Dd*f**2*r + 40*D1*Dd*f**2*s**2 - 41*D1*Dd*f**2*s + 21*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 336*D1*Dd*f*fd*r*s + 162*D1*Dd*f*fd*r - 192*D1*Dd*f*fd*s**2 + 186*D1*Dd*f*fd*s - 45*D1*Dd*f*fd - 36*D1*Ddd*f**2*r**2 - 84*D1*Ddd*f**2*r*s + 39*D1*Ddd*f**2*r - 48*D1*Ddd*f**2*s**2 + 45*D1*Ddd*f**2*s - 21*D1*Ddd*f**2 + 7*D1*bd1*(r + s - 1)*(D1*f*(12*r + 2*s - 7) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) - 108*Dd**2*f**2*r**2 - 252*Dd**2*f**2*r*s + 117*Dd**2*f**2*r - 144*Dd**2*f**2*s**2 + 135*Dd**2*f**2*s - 21*Dd**2*f**2) + f*(177*C*D1**2*f*fd*r**2 + 690*C*D1**2*f*fd*r*s - 348*C*D1**2*f*fd*r + 513*C*D1**2*f*fd*s**2 - 572*C*D1**2*f*fd*s + 230*C*D1**2*f*fd - 183*C*D1**2*f*fdd*r**2 - 642*C*D1**2*f*fdd*r*s + 336*C*D1**2*f*fdd*r - 459*C*D1**2*f*fdd*s**2 + 520*C*D1**2*f*fdd*s - 214*C*D1**2*f*fdd - 366*C*D1**2*fd**2*r**2 - 1284*C*D1**2*fd**2*r*s + 672*C*D1**2*fd**2*r - 918*C*D1**2*fd**2*s**2 + 1040*C*D1**2*fd**2*s - 214*C*D1**2*fd**2 + 236*C*D1*Dd*f**2*r**2 + 920*C*D1*Dd*f**2*r*s - 348*C*D1*Dd*f**2*r + 684*C*D1*Dd*f**2*s**2 - 572*C*D1*Dd*f**2*s + 230*C*D1*Dd*f**2 - 1464*C*D1*Dd*f*fd*r**2 - 5136*C*D1*Dd*f*fd*r*s + 2352*C*D1*Dd*f*fd*r - 3672*C*D1*Dd*f*fd*s**2 + 3640*C*D1*Dd*f*fd*s - 856*C*D1*Dd*f*fd - 244*C*D1*Ddd*f**2*r**2 - 856*C*D1*Ddd*f**2*r*s + 336*C*D1*Ddd*f**2*r - 612*C*D1*Ddd*f**2*s**2 + 520*C*D1*Ddd*f**2*s - 214*C*D1*Ddd*f**2 - 732*C*Dd**2*f**2*r**2 - 2568*C*Dd**2*f**2*r*s + 1008*C*Dd**2*f**2*r - 1836*C*Dd**2*f**2*s**2 + 1560*C*Dd**2*f**2*s - 214*C*Dd**2*f**2 - 126*D1**2*bd1**2*(r + s - 1)**2 - 3*D1**2*bdd1*f*(r + s - 1)*(7*C*(5*r + 17*s - 5) + 9*r + 12*s - 9) - 27*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 26*D1**2*f*fd*r + 3*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s - 8*D1**2*f*fd - 15*D1**2*f*fdd*r*s + 5*D1**2*f*fdd*r - 15*D1**2*f*fdd*s**2 + 15*D1**2*f*fdd*s - 5*D1**2*f*fdd - 30*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s - 5*D1**2*fd**2 - 36*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 26*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 8*D1*Dd*f**2 - 120*D1*Dd*f*fd*r*s + 35*D1*Dd*f*fd*r - 120*D1*Dd*f*fd*s**2 + 105*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r*s + 5*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 15*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + 3*D1*bd1*(-56*C*Dd*f*(5*r**2 + r*(22*s - 9) + 17*s**2 - 18*s + 4) + D1*f*(r + s - 1)*(7*C*(3*r + 19*s - 3) + 11*r + 10*s - 4) - D1*fd*(14*C*(10*r**2 + 44*r*s - 21*r + 34*s**2 - 39*s + 11) + 36*r**2 + 84*r*s - 57*r + 48*s**2 - 66*s + 21) - 3*Dd*f*(24*r**2 + r*(56*s - 37) + 32*s**2 - 43*s + 13)) - 60*Dd**2*f**2*r*s + 15*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 45*Dd**2*f**2*s - 5*Dd**2*f**2))/(315*d**2*k3**4) - 2*D1**2*Pk1*Pk2*k1**2*(D1*f*(-7*D1*bd1**2*(r + s - 1)*(50*C*(r + s - 1) + 6*s - 3) - 3*D1*bdd1*f*(r + s - 1)*(43*C*r + 35*C*(s - 1) + 5*s - 5) + 3*bd1*(-4*C*Dd*f*(86*r**2 + r*(156*s - 119) + 70*s**2 - 107*s + 37) + D1*f*(r + s - 1)*(37*C*r + 21*C*(s - 1) - 7*r + 3*s - 3) - D1*fd*(2*C*(86*r**2 + r*(156*s - 121) + 70*s**2 - 109*s + 39) + 5*r*(4*s - 2) + 20*s**2 - 25*s + 5) - 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3))) + 7*b1**2*(D1**2*(r + s)*(fd*(15*C*s + r*(15*C - 5) + s) - fdd*(25*C*(r + s) + 3*s)) + D1*(-50*C*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*f*(15*C*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 10*r**2 - 8*r*s + 7*r + 2*s**2 + s - 2) + Dd*fd*(-200*C*r**2 + r*(-400*C*s + 100*C - 24*s + 3) + s*(-200*C*s + 100*C - 24*s + 9)) - 3*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(50*C*(6*r**2 + 12*r*s - 6*r + 6*s**2 - 6*s + 1) + 36*r*s - 9*r + 36*s**2 - 27*s + 3)) + b1*(-7*D1**2*bdd1*f*(r + s - 1)*(50*C*(r + s - 1) + 6*s - 3) + 3*D1**2*(f*(fd*(C*(74*r**2 + 116*r*s - 74*r + 42*s**2 - 58*s + 37) - 14*r**2 - 8*r*s + 14*r + 6*s**2 + 4*s - 7) - fdd*(C*(86*r**2 + 156*r*s - 86*r + 70*s**2 - 78*s + 43) + 5*s*(2*r + 2*s - 1))) - fd**2*(2*C*(43*r**2 + r*(78*s - 43) + s*(35*s - 39)) + 5*s*(2*r + 2*s - 1))) + 7*D1*bd1*(-200*C*Dd*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*D1*f*(r + s - 1)*(15*C*(r + s - 1) - 5*r + s + 2) + D1*fd*(-100*C*r**2 + r*(-100*C*(2*s - 1) - 12*s + 3) + s*(-100*C*(s - 1) - 12*s + 9)) - 6*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 3*D1*f*(-2*C*Ddd*f*(86*r**2 + 2*r*(78*s - 41) + 70*s**2 - 74*s + 39) + 2*Dd*f*(C*(74*r**2 + 2*r*(58*s - 33) + 42*s**2 - 50*s + 29) - 14*r**2 + r*(9 - 8*s) + 6*s**2 - s - 2) - Dd*fd*(2*r + 2*s - 1)*(4*C*(86*r + 70*s - 41) + 40*s - 5) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f**2*(6*C*(86*r**2 + 2*r*(78*s - 41) + 70*s**2 - 74*s + 13) + 15*r*(4*s - 1) + 60*s**2 - 45*s + 5)))/(105*d**2*k3**4) + 4*D1**2*Pk1*Pk2*k1**2*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(C*(4*s**2 - 4*s + 2) - 2*r*s + r - 4*s**2 + 4*s - 2) + fd**2*(r*(2*s - 1) + 4*s*(-C*s + C + s - 1))) + D1*f*(Dd*(2*f*(C*(8*s**2 - 4*s + 2) - 4*r*s + r - 8*s**2 + 5*s - 2) + fd*(-4*C*(8*s**2 - 6*s + 1) + 16*r*s - 6*r + 32*s**2 - 26*s + 5)) - Ddd*f*(C*(8*s**2 - 4*s + 2) - 4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f**2*(3*r*(4*s - 1) - s**2*(24*C - 24) + s*(12*C - 15) + 1)) + f*(D1**2*(f*(3*bdd1*s*(-2*C*s + r + 2*s - 1) + 2*fd*(C*(6*s**2 - 4*s + 2) - 3*r*s + r - 6*s**2 + 5*s - 2) - fdd*(C*(6*s**2 - 4*s + 2) - 3*r*s + r - 6*s**2 + 5*s - 2)) + fd**2*(r*(6*s - 2) - s**2*(12*C - 12) + s*(8*C - 10) + 1)) - 3*D1*bd1*(-2*D1*f*s*(-r + s*(2*C - 2) + 1) - D1*fd*r*(4*s - 1) + D1*fd*(2*s - 1)*(s*(4*C - 4) + 1) + Dd*f*(-8*r*s + r + s**2*(16*C - 16) + s*(9 - 4*C) - 1)) + D1*f*(Dd*(2*f*(C*(8*s**2 - 4*s + 2) - 4*r*s + r - 8*s**2 + 5*s - 2) + fd*(-4*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r + 48*s**2 - 35*s + 6)) - Ddd*f*(C*(8*s**2 - 4*s + 2) - 4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f**2*(3*r*(4*s - 1) - s**2*(24*C - 24) + s*(12*C - 15) + 1)))/(105*d**2*k2**2*k3**2) - D1**2*Pk1*Pk2*k1**2*st**2*(42*b1**2*(D1**2*s*(2*fd - fdd)*(r + 2*s) + D1*(2*Dd*f*(r*(4*s - 1) + 8*s**2 - 5*s + 2) + Dd*fd*(-8*r*s + r + s*(5 - 16*s)) + Ddd*f*(-4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f*(r*(3 - 12*s) - 24*s**2 + 15*s - 1)) + 3*b1*(192*C*D1**2*f*fd*s**2 - 192*C*D1**2*f*fd*s + 96*C*D1**2*f*fd - 152*C*D1**2*f*fdd*s**2 + 152*C*D1**2*f*fdd*s - 76*C*D1**2*f*fdd - 152*C*D1**2*fd**2*s**2 + 152*C*D1**2*fd**2*s + 384*C*D1*Dd*f**2*s**2 - 192*C*D1*Dd*f**2*s + 96*C*D1*Dd*f**2 - 1216*C*D1*Dd*f*fd*s**2 + 912*C*D1*Dd*f*fd*s - 152*C*D1*Dd*f*fd - 304*C*D1*Ddd*f**2*s**2 + 152*C*D1*Ddd*f**2*s - 76*C*D1*Ddd*f**2 - 912*C*Dd**2*f**2*s**2 + 456*C*Dd**2*f**2*s - 14*D1**2*bdd1*f*(2*r*s - r + 4*s**2 - 5*s + 2) - 74*D1**2*f*fd*r*s + 49*D1**2*f*fd*r - 32*D1**2*f*fd*s**2 + 68*D1**2*f*fd*s - 40*D1**2*f*fd + 58*D1**2*f*fdd*r*s - 35*D1**2*f*fdd*r + 72*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 48*D1**2*f*fdd + 58*D1**2*fd**2*r*s - 35*D1**2*fd**2*r + 72*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 148*D1*Dd*f**2*r*s + 37*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 + 69*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 464*D1*Dd*f*fd*r*s - 198*D1*Dd*f*fd*r + 576*D1*Dd*f*fd*s**2 - 562*D1*Dd*f*fd*s + 125*D1*Dd*f*fd + 116*D1*Ddd*f**2*r*s - 29*D1*Ddd*f**2*r + 144*D1*Ddd*f**2*s**2 - 101*D1*Ddd*f**2*s + 36*D1*Ddd*f**2 + 14*D1*bd1*(D1*(2*f*(r*(2*s - 1) + 4*s**2 - 5*s + 2) + fd*(-4*r*s + r + s*(5 - 8*s))) - 2*Dd*f*(r*(8*s - 3) + 16*s**2 - 15*s + 3)) + 348*Dd**2*f**2*r*s - 87*Dd**2*f**2*r + 432*Dd**2*f**2*s**2 - 303*Dd**2*f**2*s + 29*Dd**2*f**2) + f*(384*C*D1**2*f*fd*s**2 - 256*C*D1**2*f*fd*s + 128*C*D1**2*f*fd - 300*C*D1**2*f*fdd*s**2 + 200*C*D1**2*f*fdd*s - 100*C*D1**2*f*fdd - 600*C*D1**2*fd**2*s**2 + 400*C*D1**2*fd**2*s + 512*C*D1*Dd*f**2*s**2 - 256*C*D1*Dd*f**2*s + 128*C*D1*Dd*f**2 - 2400*C*D1*Dd*f*fd*s**2 + 1400*C*D1*Dd*f*fd*s - 200*C*D1*Dd*f*fd - 400*C*D1*Ddd*f**2*s**2 + 200*C*D1*Ddd*f**2*s - 100*C*D1*Ddd*f**2 - 1200*C*Dd**2*f**2*s**2 + 600*C*Dd**2*f**2*s - 42*D1**2*bd1**2*(r*(2*s - 1) + 4*s**2 - 5*s + 1) + 3*D1**2*bdd1*f*(r*(29*s + 6) + s**2*(36 - 76*C) - 11*s - 12) - 237*D1**2*f*fd*r*s + 79*D1**2*f*fd*r - 168*D1**2*f*fd*s**2 + 191*D1**2*f*fd*s - 56*D1**2*f*fd + 159*D1**2*f*fdd*r*s - 53*D1**2*f*fdd*r + 192*D1**2*f*fdd*s**2 - 181*D1**2*f*fdd*s + 64*D1**2*f*fdd + 318*D1**2*fd**2*r*s - 106*D1**2*fd**2*r + 384*D1**2*fd**2*s**2 - 362*D1**2*fd**2*s + 53*D1**2*fd**2 - 316*D1*Dd*f**2*r*s + 79*D1*Dd*f**2*r - 224*D1*Dd*f**2*s**2 + 191*D1*Dd*f**2*s - 56*D1*Dd*f**2 + 1272*D1*Dd*f*fd*r*s - 371*D1*Dd*f*fd*r + 1536*D1*Dd*f*fd*s**2 - 1267*D1*Dd*f*fd*s + 234*D1*Dd*f*fd + 212*D1*Ddd*f**2*r*s - 53*D1*Ddd*f**2*r + 256*D1*Ddd*f**2*s**2 - 181*D1*Ddd*f**2*s + 64*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r*(37*s + 12) + s**2*(16 - 96*C) - s - 24) + fd*(r*(23 - 116*s) + s**2*(304*C - 144) - s*(152*C - 112) - 29)) + Dd*f*(r*(5 - 232*s) + s**2*(608*C - 288) + s*(145 - 152*C) - 5)) + 636*Dd**2*f**2*r*s - 159*Dd**2*f**2*r + 768*Dd**2*f**2*s**2 - 543*Dd**2*f**2*s + 53*Dd**2*f**2))/(315*d**2*k2**2*k3**2) - D1**2*Pk1*Pk2*k1**2*(7*b1**2*(D1**2*s*(-15*fd*r + fd*s*(2*C - 12) + 15*fdd*r + fdd*s*(16 - 6*C)) + D1*(Dd*(C*f*(8*s**2 - 4*s + 2) - 3*f*(5*r*(4*s - 1) + 16*s**2 - 13*s + 4) + 15*fd*r*(8*s - 1) + fd*s*(C*(12 - 48*s) + 128*s - 47)) + Ddd*f*(-6*C*(4*s**2 - 2*s + 1) + 60*r*s - 15*r + 64*s**2 - 47*s + 16)) + 3*Dd**2*f*(15*r*(4*s - 1) - s**2*(24*C - 64) + s*(12*C - 47) + 5)) + b1*(-104*C*D1**2*f*fd*s**2 + 140*C*D1**2*f*fd*s - 70*C*D1**2*f*fd + 80*C*D1**2*f*fdd*s**2 - 140*C*D1**2*f*fdd*s + 70*C*D1**2*f*fdd + 80*C*D1**2*fd**2*s**2 - 140*C*D1**2*fd**2*s - 208*C*D1*Dd*f**2*s**2 + 104*C*D1*Dd*f**2*s - 52*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 140*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 40*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s - 7*D1**2*bdd1*f*(6*C*(2*s**2 - 2*s + 1) + r*(15 - 30*s) - 32*s**2 + 47*s - 16) - 174*D1**2*f*fd*r*s - 120*D1**2*f*fd*s**2 + 87*D1**2*f*fd*s + 150*D1**2*f*fdd*r*s + 144*D1**2*f*fdd*s**2 - 75*D1**2*f*fdd*s + 150*D1**2*fd**2*r*s + 144*D1**2*fd**2*s**2 - 75*D1**2*fd**2*s - 348*D1*Dd*f**2*r*s + 87*D1*Dd*f**2*r - 240*D1*Dd*f**2*s**2 + 207*D1*Dd*f**2*s - 60*D1*Dd*f**2 + 1200*D1*Dd*f*fd*r*s - 150*D1*Dd*f*fd*r + 1152*D1*Dd*f*fd*s**2 - 738*D1*Dd*f*fd*s + 75*D1*Dd*f*fd + 300*D1*Ddd*f**2*r*s - 75*D1*Ddd*f**2*r + 288*D1*Ddd*f**2*s**2 - 219*D1*Ddd*f**2*s + 72*D1*Ddd*f**2 + 7*D1*bd1*(D1*(C*f*(4*s**2 - 4*s + 2) - 3*f*(5*r*(2*s - 1) + 8*s**2 - 13*s + 4) + 15*fd*r*(4*s - 1) + fd*s*(C*(12 - 24*s) + 64*s - 47)) + 2*Dd*f*(-6*C*(8*s**2 - 6*s + 1) + 15*r*(8*s - 3) + 128*s**2 - 141*s + 31)) + 900*Dd**2*f**2*r*s - 225*Dd**2*f**2*r + 864*Dd**2*f**2*s**2 - 657*Dd**2*f**2*s + 75*Dd**2*f**2) + f*(-42*C*(D1**2*(f*(fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(12*s**2 - 7*s + 1) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + 7*D1**2*bd1**2*(15*r*(2*s - 1) - (s - 1)*(s*(12*C - 32) + 15)) + D1**2*bdd1*f*(10*C*(4*s**2 + 6*s - 3) + (s - 1)*(75*r + 72*s - 72)) + D1*bd1*(D1*(-f*(2*C*(26*s**2 + 18*s - 9) + (s - 1)*(87*r + 60*s - 60)) + fd*(150*r*(2*s - 1) + s**2*(160*C + 288) - s*(20*C + 363) + 75)) + Dd*f*(20*C*(16*s**2 + 8*s - 3) + 75*r*(8*s - 5) + 576*s**2 - 795*s + 219))))/(105*d**2*k2**2*k3**2) + 2*D1**2*Pk1*Pk2*k2**2*st**6*(144*C*D1**2*b1*f*fd*r*s - 72*C*D1**2*b1*f*fd*r + 144*C*D1**2*b1*f*fd*s**2 - 144*C*D1**2*b1*f*fd*s + 72*C*D1**2*b1*f*fd - 72*C*D1**2*b1*f*fdd*r*s + 36*C*D1**2*b1*f*fdd*r - 72*C*D1**2*b1*f*fdd*s**2 + 72*C*D1**2*b1*f*fdd*s - 36*C*D1**2*b1*f*fdd - 72*C*D1**2*b1*fd**2*r*s + 36*C*D1**2*b1*fd**2*r - 72*C*D1**2*b1*fd**2*s**2 + 72*C*D1**2*b1*fd**2*s + 24*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r + 24*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r*s + 4*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r*s + 8*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 288*C*D1*Dd*b1*f**2*r*s - 72*C*D1*Dd*b1*f**2*r + 288*C*D1*Dd*b1*f**2*s**2 - 216*C*D1*Dd*b1*f**2*s + 72*C*D1*Dd*b1*f**2 - 576*C*D1*Dd*b1*f*fd*r*s + 216*C*D1*Dd*b1*f*fd*r - 576*C*D1*Dd*b1*f*fd*s**2 + 504*C*D1*Dd*b1*f*fd*s - 108*C*D1*Dd*b1*f*fd + 32*C*D1*Dd*f**3*r*s - 8*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r*s + 28*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 84*C*D1*Dd*f**2*fd*s - 16*C*D1*Dd*f**2*fd - 144*C*D1*Ddd*b1*f**2*r*s + 36*C*D1*Ddd*b1*f**2*r - 144*C*D1*Ddd*b1*f**2*s**2 + 108*C*D1*Ddd*b1*f**2*s - 36*C*D1*Ddd*b1*f**2 - 16*C*D1*Ddd*f**3*r*s + 4*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 12*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 432*C*Dd**2*b1*f**2*r*s + 108*C*Dd**2*b1*f**2*r - 432*C*Dd**2*b1*f**2*s**2 + 324*C*Dd**2*b1*f**2*s - 36*C*Dd**2*b1*f**2 - 48*C*Dd**2*f**3*r*s + 12*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 36*C*Dd**2*f**3*s - 4*C*Dd**2*f**3 - 36*D1**2*b1*f*fd*r**2 - 36*D1**2*b1*f*fd*r*s + 18*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 18*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(r + s - 1)*(-4*C*s + r - 1) - 6*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r + 2*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 - 72*D1*Dd*b1*f**2*r**2 - 72*D1*Dd*b1*f**2*r*s + 54*D1*Dd*b1*f**2*r + 18*D1*Dd*b1*f**2*s - 18*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 90*D1*Dd*b1*f*fd*r - 18*D1*Dd*b1*f*fd*s + 9*D1*Dd*b1*f*fd - 8*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r + 2*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 21*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 4*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 27*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r - D1*Ddd*f**3*s + D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(-2*f*(r + s - 1)*(-4*C*s + r - 1) + fd*(-4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 + 4*r*s - 5*r - 2*s + 1)) + Dd*f*(-4*C*(8*r*s - r + 8*s**2 - 7*s + 1) + 8*r**2 + 8*r*s - 11*r - 5*s + 3)) + 108*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 81*Dd**2*b1*f**2*r - 27*Dd**2*b1*f**2*s + 9*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 9*Dd**2*f**3*r - 3*Dd**2*f**3*s + Dd**2*f**3)/(63*d**2*k3**4) - 2*D1**2*Pk1*Pk2*k2**2*st**4*(7*b1**2*(D1**2*r*(2*fd - fdd)*(r + s) + D1*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 3*r + s)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + Dd**2*f*(-12*r**2 + r*(9 - 12*s) + 3*s - 1)) + b1*(42*C*D1**2*f*fd*r**2 + 196*C*D1**2*f*fd*r*s - 98*C*D1**2*f*fd*r + 154*C*D1**2*f*fd*s**2 - 154*C*D1**2*f*fd*s + 77*C*D1**2*f*fd - 70*C*D1**2*f*fdd*r**2 - 196*C*D1**2*f*fdd*r*s + 98*C*D1**2*f*fdd*r - 126*C*D1**2*f*fdd*s**2 + 126*C*D1**2*f*fdd*s - 63*C*D1**2*f*fdd - 70*C*D1**2*fd**2*r**2 - 196*C*D1**2*fd**2*r*s + 98*C*D1**2*fd**2*r - 126*C*D1**2*fd**2*s**2 + 126*C*D1**2*fd**2*s + 84*C*D1*Dd*f**2*r**2 + 392*C*D1*Dd*f**2*r*s - 140*C*D1*Dd*f**2*r + 308*C*D1*Dd*f**2*s**2 - 252*C*D1*Dd*f**2*s + 98*C*D1*Dd*f**2 - 560*C*D1*Dd*f*fd*r**2 - 1568*C*D1*Dd*f*fd*r*s + 728*C*D1*Dd*f*fd*r - 1008*C*D1*Dd*f*fd*s**2 + 952*C*D1*Dd*f*fd*s - 224*C*D1*Dd*f*fd - 140*C*D1*Ddd*f**2*r**2 - 392*C*D1*Ddd*f**2*r*s + 168*C*D1*Ddd*f**2*r - 252*C*D1*Ddd*f**2*s**2 + 224*C*D1*Ddd*f**2*s - 98*C*D1*Ddd*f**2 - 420*C*Dd**2*f**2*r**2 - 1176*C*Dd**2*f**2*r*s + 504*C*Dd**2*f**2*r - 756*C*Dd**2*f**2*s**2 + 672*C*Dd**2*f**2*s - 98*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + D1**2*f*fd - 8*D1**2*f*fdd*r**2 - 14*D1**2*f*fdd*r*s + 8*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 7*D1**2*f*fdd*s - 4*D1**2*f*fdd - 8*D1**2*fd**2*r**2 - 14*D1**2*fd**2*r*s + 8*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 7*D1**2*fd**2*s + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 2*D1*Dd*f**2*s - 64*D1*Dd*f*fd*r**2 - 112*D1*Dd*f*fd*r*s + 62*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 54*D1*Dd*f*fd*s - 15*D1*Dd*f*fd - 16*D1*Ddd*f**2*r**2 - 28*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 13*D1*Ddd*f**2*s - 7*D1*Ddd*f**2 + 7*D1*bd1*(D1*(2*f*(2*r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 3*r + s)) - 2*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 48*Dd**2*f**2*r**2 - 84*Dd**2*f**2*r*s + 45*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 39*Dd**2*f**2*s - 7*Dd**2*f**2) + f*(33*C*D1**2*f*fd*r**2 + 66*C*D1**2*f*fd*r*s - 44*C*D1**2*f*fd*r + 33*C*D1**2*f*fd*s**2 - 44*C*D1**2*f*fd*s + 22*C*D1**2*f*fd - 39*C*D1**2*f*fdd*r**2 - 66*C*D1**2*f*fdd*r*s + 48*C*D1**2*f*fdd*r - 27*C*D1**2*f*fdd*s**2 + 40*C*D1**2*f*fdd*s - 22*C*D1**2*f*fdd - 78*C*D1**2*fd**2*r**2 - 132*C*D1**2*fd**2*r*s + 96*C*D1**2*fd**2*r - 54*C*D1**2*fd**2*s**2 + 80*C*D1**2*fd**2*s - 22*C*D1**2*fd**2 + 44*C*D1*Dd*f**2*r**2 + 88*C*D1*Dd*f**2*r*s - 44*C*D1*Dd*f**2*r + 44*C*D1*Dd*f**2*s**2 - 44*C*D1*Dd*f**2*s + 22*C*D1*Dd*f**2 - 312*C*D1*Dd*f*fd*r**2 - 528*C*D1*Dd*f*fd*r*s + 336*C*D1*Dd*f*fd*r - 216*C*D1*Dd*f*fd*s**2 + 280*C*D1*Dd*f*fd*s - 88*C*D1*Dd*f*fd - 52*C*D1*Ddd*f**2*r**2 - 88*C*D1*Ddd*f**2*r*s + 48*C*D1*Ddd*f**2*r - 36*C*D1*Ddd*f**2*s**2 + 40*C*D1*Ddd*f**2*s - 22*C*D1*Ddd*f**2 - 156*C*Dd**2*f**2*r**2 - 264*C*Dd**2*f**2*r*s + 144*C*Dd**2*f**2*r - 108*C*Dd**2*f**2*s**2 + 120*C*Dd**2*f**2*s - 22*C*Dd**2*f**2 - 7*D1**2*bd1**2*(2*r - 1)*(r + s - 1) - D1**2*bdd1*f*(r + s - 1)*(7*C*(5*r + 9*s - 5) + 4*r + 3*s - 3) + 3*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 3*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*r - 3*D1**2*f*fdd*s**2 + 4*D1**2*f*fdd*s - 2*D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 8*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 8*D1**2*fd**2*s - 2*D1**2*fd**2 + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 4*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s + 28*D1*Dd*f*fd*r - 24*D1*Dd*f*fd*s**2 + 28*D1*Dd*f*fd*s - 8*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 4*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + D1*bd1*(D1*(f*(r + s - 1)*(7*C*(3*r + 11*s - 3) + r - s + 1) - fd*(14*C*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 23*s + 7) + 16*r**2 + 28*r*s - 22*r + 12*s**2 - 19*s + 7)) - Dd*f*(56*C*(5*r**2 + 14*r*s - 8*r + 9*s**2 - 11*s + 3) + 32*r**2 + 56*r*s - 43*r + 24*s**2 - 37*s + 13)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 12*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 12*Dd**2*f**2*s - 2*Dd**2*f**2))/(35*d**2*k3**4) - 2*D1**2*Pk1*Pk2*k2**2*st**2*(D1*f*(-14*D1*bd1**2*(25*C + 3)*(r + s - 1)**2 + D1*bd1*(f*(r + s - 1)*(61*C*r + 21*C*(s - 1) + 4*r + 11*s - 4) - 2*fd*(C*(166*r**2 + r*(236*s - 201) + 70*s**2 - 129*s + 59) + 18*r**2 + 9*r*(4*s - 3) + 18*s**2 - 27*s + 9)) - D1*bdd1*f*(r + s - 1)*(83*C*r + 35*C*(s - 1) + 9*r + 9*s - 9) - 4*Dd*bd1*f*(C*(166*r**2 + r*(236*s - 189) + 70*s**2 - 117*s + 47) + 18*r**2 + 9*r*(4*s - 3) + 18*s**2 - 27*s + 9) - 3*f*(D1*fd*(3*r**2 + 3*r*(s - 1) - s + 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1))) + 7*b1**2*(D1**2*(r + s)**2*(15*C*fd + fd - fdd*(25*C + 3)) + 2*D1*(Dd*(f*(15*C + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(50*C + 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - Ddd*f*(25*C + 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(50*C + 6)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(122*C*D1**2*f*fd*r**2 + 164*C*D1**2*f*fd*r*s - 122*C*D1**2*f*fd*r + 42*C*D1**2*f*fd*s**2 - 82*C*D1**2*f*fd*s + 61*C*D1**2*f*fd - 166*C*D1**2*f*fdd*r**2 - 236*C*D1**2*f*fdd*r*s + 166*C*D1**2*f*fdd*r - 70*C*D1**2*f*fdd*s**2 + 118*C*D1**2*f*fdd*s - 83*C*D1**2*f*fdd - 166*C*D1**2*fd**2*r**2 - 236*C*D1**2*fd**2*r*s + 166*C*D1**2*fd**2*r - 70*C*D1**2*fd**2*s**2 + 118*C*D1**2*fd**2*s + 244*C*D1*Dd*f**2*r**2 + 328*C*D1*Dd*f**2*r*s - 204*C*D1*Dd*f**2*r + 84*C*D1*Dd*f**2*s**2 - 124*C*D1*Dd*f**2*s + 82*C*D1*Dd*f**2 - 1328*C*D1*Dd*f*fd*r**2 - 1888*C*D1*Dd*f*fd*r*s + 1232*C*D1*Dd*f*fd*r - 560*C*D1*Dd*f*fd*s**2 + 848*C*D1*Dd*f*fd*s - 284*C*D1*Dd*f*fd - 332*C*D1*Ddd*f**2*r**2 - 472*C*D1*Ddd*f**2*r*s + 284*C*D1*Ddd*f**2*r - 140*C*D1*Ddd*f**2*s**2 + 188*C*D1*Ddd*f**2*s - 118*C*D1*Ddd*f**2 - 996*C*Dd**2*f**2*r**2 - 1416*C*Dd**2*f**2*r*s + 852*C*Dd**2*f**2*r - 420*C*Dd**2*f**2*s**2 + 564*C*Dd**2*f**2*s - 118*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(25*C + 3)*(r + s - 1)**2 + 8*D1**2*f*fd*r**2 + 30*D1**2*f*fd*r*s - 15*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 60*D1*Dd*f**2*r*s - 23*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 37*D1*Dd*f**2*s + 15*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 144*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 + 14*D1*bd1*(r + s - 1)*(D1*f*(15*C + 1)*(r + s - 1) - D1*fd*(50*C + 6)*(r + s) - Dd*f*(100*C + 12)*(2*r + 2*s - 1)) - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2))/(105*d**2*k3**4) + 4*D1**2*Pk1*Pk2*st**6*(-9*D1*bd1*f*(-2*D1*f*s*(2*C*s - r + 1) - D1*fd*r*(4*s - 1) + D1*fd*(2*s - 1)*(4*C*s + 1) + Dd*f*(16*C*s**2 - 8*r*s + r + s*(5 - 4*C) - 1)) + 9*b1*(2*C*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(2*C*(D1**2*(-f*(9*bdd1*s**2 + fd*(-6*s**2 + 4*s - 2) + 3*fdd*s**2 - 2*fdd*s + fdd) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + D1*Dd*f*(2*f*(-4*r*s + r + s) + fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(2*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) + fd**2*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(63*d**2*k3**2) + 4*D1**2*Pk1*Pk2*st**6*(33*b1**2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + 11*b1*f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(12*bd1 - 6*bdd1)) + 2*fd*s*(bd1*(6 - 12*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(6*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f**2*(D1**2*(f*(4*fd*(4*s**2 - 2*s + 1) + fdd*(-8*s**2 + 4*s - 2) + s**2*(22*bd1 - 11*bdd1)) - 2*s*(33*bd1**2*s + 11*bd1*fd*(3*s - 1) + 6*fd**2*(2*s - 1))) + 2*D1*f*(Dd*f*(8*s**2 - 4*s + 2) - Dd*(4*s - 1)*(11*bd1*s + fd*(8*s - 2)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 12*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2**2) + 2*D1**2*Pk1*Pk2*st**4*(-924*D1**2*K*bd1**2*f*s**2 + 132*D1**2*K*bd1*f**2*s**2 - 264*D1**2*K*bd1*f*fd*s**2 + 132*D1**2*K*bd1*f*fd*s - 66*D1**2*K*bdd1*f**2*s**2 + 924*D1**2*bd1**2*f**2*r*s + 3630*D1**2*bd1**2*f**2*s**2 - 66*D1**2*bd1**2*f**2*s + 924*D1**2*bd1**2*f*r*s - 924*D1**2*bd1**2*f*s**2 - 462*D1**2*bd1**2*f*s - 924*D1**2*bd1*bd2*f*s**2 - 220*D1**2*bd1*f**3*r*s - 1155*D1**2*bd1*f**3*s**2 - 66*D1**2*bd1*f**3*s + 88*D1**2*bd1*f**3 + 1848*D1**2*bd1*f**2*fd*r*s - 308*D1**2*bd1*f**2*fd*r + 4950*D1**2*bd1*f**2*fd*s**2 - 2090*D1**2*bd1*f**2*fd*s + 154*D1**2*bd1*f**2*fd - 132*D1**2*bd1*f**2*r*s + 132*D1**2*bd1*f**2*s**2 + 264*D1**2*bd1*f*fd*r*s - 66*D1**2*bd1*f*fd*r - 264*D1**2*bd1*f*fd*s**2 + 66*D1**2*bd1*f*fd*s - 1848*D1**2*bd1*f*g2*s**2 + 1848*D1**2*bd1*f*gd2*s**2 + 1848*D1**2*bd1*fd*g2*s**2 - 1848*D1**2*bd1*fd*g2*s + 132*D1**2*bd2*f**2*s**2 - 264*D1**2*bd2*f*fd*s**2 + 132*D1**2*bd2*f*fd*s + 308*D1**2*bdd1*f**3*r*s + 825*D1**2*bdd1*f**3*s**2 - 66*D1**2*bdd1*f**3*s - 44*D1**2*bdd1*f**3 + 66*D1**2*bdd1*f**2*r*s - 66*D1**2*bdd1*f**2*s**2 + 924*D1**2*bdd1*f*g2*s**2 - 66*D1**2*bdd2*f**2*s**2 - 120*D1**2*f**3*fd*r*s + 30*D1**2*f**3*fd*r - 1144*D1**2*f**3*fd*s**2 + 602*D1**2*f**3*fd*s - 286*D1**2*f**3*fd + 280*D1**2*f**3*fdd*r*s - 70*D1**2*f**3*fdd*r + 792*D1**2*f**3*fdd*s**2 - 466*D1**2*f**3*fdd*s + 198*D1**2*f**3*fdd + 840*D1**2*f**2*fd**2*r*s - 210*D1**2*f**2*fd**2*r + 2376*D1**2*f**2*fd**2*s**2 - 1398*D1**2*f**2*fd**2*s + 70*D1**2*f**2*fd**2 - 264*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gdd2*s**2 - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*s**2 - 264*D1**2*f*fd*gd2*s + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s - 528*D1*Dd*K*bd1*f**2*s**2 + 132*D1*Dd*K*bd1*f**2*s + 2464*D1*Dd*bd1*f**3*r*s - 308*D1*Dd*bd1*f**3*r + 6600*D1*Dd*bd1*f**3*s**2 - 2222*D1*Dd*bd1*f**3*s + 66*D1*Dd*bd1*f**3 + 528*D1*Dd*bd1*f**2*r*s - 66*D1*Dd*bd1*f**2*r - 528*D1*Dd*bd1*f**2*s**2 + 66*D1*Dd*bd1*f**2*s + 7392*D1*Dd*bd1*f*g2*s**2 - 1848*D1*Dd*bd1*f*g2*s - 528*D1*Dd*bd2*f**2*s**2 + 132*D1*Dd*bd2*f**2*s - 120*D1*Dd*f**4*r*s + 30*D1*Dd*f**4*r - 1144*D1*Dd*f**4*s**2 + 602*D1*Dd*f**4*s - 286*D1*Dd*f**4 + 2240*D1*Dd*f**3*fd*r*s - 560*D1*Dd*f**3*fd*r + 6336*D1*Dd*f**3*fd*s**2 - 3728*D1*Dd*f**3*fd*s + 536*D1*Dd*f**3*fd - 1056*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*s**2 - 264*D1*Dd*f**2*gd2*s + 2112*D1*Dd*f*fd*g2*s**2 - 1584*D1*Dd*f*fd*g2*s + 264*D1*Dd*f*fd*g2 + 280*D1*Ddd*f**4*r*s - 70*D1*Ddd*f**4*r + 792*D1*Ddd*f**4*s**2 - 466*D1*Ddd*f**4*s + 198*D1*Ddd*f**4 + 528*D1*Ddd*f**2*g2*s**2 - 264*D1*Ddd*f**2*g2*s + 132*D1*Ddd*f**2*g2 + 840*Dd**2*f**4*r*s - 210*Dd**2*f**4*r + 2376*Dd**2*f**4*s**2 - 1398*Dd**2*f**4*s + 70*Dd**2*f**4 + 1584*Dd**2*f**2*g2*s**2 - 792*Dd**2*f**2*g2*s + 462*b1**3*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1**2*(28*D1**2*K*fd*s**2 - 56*D1**2*K*fd*s + 28*D1**2*K*fd - 14*D1**2*K*fdd*s**2 + 28*D1**2*K*fdd*s - 14*D1**2*K*fdd - 14*D1**2*bdd1*f*(3*s**2 - 2*s + 1) - 28*D1**2*f*fd*r*s + 14*D1**2*f*fd*r - 150*D1**2*f*fd*s**2 + 174*D1**2*f*fd*s - 87*D1**2*f*fd + 28*D1**2*f*fdd*r*s - 14*D1**2*f*fdd*r + 110*D1**2*f*fdd*s**2 - 122*D1**2*f*fdd*s + 61*D1**2*f*fdd + 28*D1**2*fd**2*r*s - 14*D1**2*fd**2*r + 110*D1**2*fd**2*s**2 - 122*D1**2*fd**2*s - 28*D1**2*fd*r*s + 28*D1**2*fd*r + 28*D1**2*fd*s**2 - 56*D1**2*fd*s + 28*D1**2*fd + 14*D1**2*fdd*r*s - 14*D1**2*fdd*r - 14*D1**2*fdd*s**2 + 28*D1**2*fdd*s - 14*D1**2*fdd + 112*D1*Dd*K*f*s**2 - 56*D1*Dd*K*f*s + 28*D1*Dd*K*f - 112*D1*Dd*K*fd*s**2 + 140*D1*Dd*K*fd*s - 28*D1*Dd*K*fd - 56*D1*Dd*f**2*r*s + 14*D1*Dd*f**2*r - 300*D1*Dd*f**2*s**2 + 164*D1*Dd*f**2*s - 75*D1*Dd*f**2 + 224*D1*Dd*f*fd*r*s - 84*D1*Dd*f*fd*r + 880*D1*Dd*f*fd*s**2 - 736*D1*Dd*f*fd*s + 136*D1*Dd*f*fd - 112*D1*Dd*f*r*s + 28*D1*Dd*f*r + 112*D1*Dd*f*s**2 - 28*D1*Dd*f*s + 28*D1*Dd*f + 112*D1*Dd*fd*r*s - 70*D1*Dd*fd*r - 112*D1*Dd*fd*s**2 + 126*D1*Dd*fd*s - 14*D1*Dd*fd - 56*D1*Ddd*K*f*s**2 + 28*D1*Ddd*K*f*s - 14*D1*Ddd*K*f + 56*D1*Ddd*f**2*r*s - 14*D1*Ddd*f**2*r + 220*D1*Ddd*f**2*s**2 - 124*D1*Ddd*f**2*s + 55*D1*Ddd*f**2 + 56*D1*Ddd*f*r*s - 14*D1*Ddd*f*r - 56*D1*Ddd*f*s**2 + 14*D1*Ddd*f*s - 14*D1*Ddd*f + 28*D1*bd1*(D1*f*(3*s**2 - 2*s + 1) + D1*fd*s*(1 - 3*s) + Dd*f*(-12*s**2 + 7*s - 1)) - 168*Dd**2*K*f*s**2 + 84*Dd**2*K*f*s + 168*Dd**2*f**2*r*s - 42*Dd**2*f**2*r + 660*Dd**2*f**2*s**2 - 372*Dd**2*f**2*s + 14*Dd**2*f**2 + 168*Dd**2*f*r*s - 42*Dd**2*f*r - 168*Dd**2*f*s**2 + 42*Dd**2*f*s + 14*Dd**2*f) + 11*b1*(-84*D1**2*K*bdd1*f*s**2 + 24*D1**2*K*f*fd*s**2 - 24*D1**2*K*f*fd*s + 12*D1**2*K*f*fd - 12*D1**2*K*f*fdd*s**2 + 12*D1**2*K*f*fdd*s - 6*D1**2*K*f*fdd - 12*D1**2*K*fd**2*s**2 + 12*D1**2*K*fd**2*s - 84*D1**2*bd1**2*f*s*(3*s - 2) + 84*D1**2*bd2*f*s**2 - 84*D1**2*bd2*fd*s**2 + 84*D1**2*bd2*fd*s + 84*D1**2*bdd1*f**2*r*s + 330*D1**2*bdd1*f**2*s**2 - 6*D1**2*bdd1*f**2*s - 18*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*r*s - 84*D1**2*bdd1*f*s**2 - 42*D1**2*bdd1*f*s - 42*D1**2*bdd2*f*s**2 - 60*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 315*D1**2*f**2*fd*s**2 + 236*D1**2*f**2*fd*s - 113*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r*s - 28*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 172*D1**2*f**2*fdd*s + 79*D1**2*f**2*fdd + 168*D1**2*f*fd**2*r*s - 56*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 344*D1**2*f*fd**2*s + 14*D1**2*f*fd**2 - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s + 12*D1**2*f*fd + 12*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 6*D1**2*f*fdd - 168*D1**2*f*gd2*s**2 + 84*D1**2*f*gdd2*s**2 + 12*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s + 6*D1**2*fd**2 - 168*D1**2*fd*g2*s**2 + 336*D1**2*fd*g2*s - 168*D1**2*fd*g2 + 168*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 84*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 + 48*D1*Dd*K*f**2*s**2 - 24*D1*Dd*K*f**2*s + 12*D1*Dd*K*f**2 - 96*D1*Dd*K*f*fd*s**2 + 72*D1*Dd*K*f*fd*s - 12*D1*Dd*K*f*fd - 336*D1*Dd*bd2*f*s**2 + 84*D1*Dd*bd2*f*s - 80*D1*Dd*f**3*r*s + 20*D1*Dd*f**3*r - 420*D1*Dd*f**3*s**2 + 230*D1*Dd*f**3*s - 105*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r*s - 196*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 1222*D1*Dd*f**2*fd*s + 200*D1*Dd*f**2*fd - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 12*D1*Dd*f**2 + 96*D1*Dd*f*fd*r*s - 36*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 36*D1*Dd*f*fd*s - 672*D1*Dd*f*g2*s**2 + 336*D1*Dd*f*g2*s - 168*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*s**2 - 168*D1*Dd*f*gd2*s + 672*D1*Dd*fd*g2*s**2 - 840*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 - 24*D1*Ddd*K*f**2*s**2 + 12*D1*Ddd*K*f**2*s - 6*D1*Ddd*K*f**2 + 112*D1*Ddd*f**3*r*s - 28*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 178*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 24*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*s**2 - 168*D1*Ddd*f*g2*s + 84*D1*Ddd*f*g2 - 6*D1*bd1*(D1*(f**2*(75*s**2 + s*(14*r + 5) - 6) - f*(fd*(14*r*(4*s - 1) + 220*s**2 - 124*s + 7) + 14*s*(-2*r + s*(2*K + 2) + 1)) + 7*fd*(r*(2 - 4*s) + (s - 1)*(s*(4*K + 4) + 1))) - Dd*f*(f*(14*r*(8*s - 1) + 440*s**2 - 128*s + 1) + 14*r*(8*s - 1) - 7*s**2*(16*K + 16) + 7*s*(4*K - 2) + 7)) - 72*Dd**2*K*f**2*s**2 + 36*Dd**2*K*f**2*s + 336*Dd**2*f**3*r*s - 84*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 534*Dd**2*f**3*s + 28*Dd**2*f**3 + 72*Dd**2*f**2*r*s - 18*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s + 6*Dd**2*f**2 + 1008*Dd**2*f*g2*s**2 - 504*Dd**2*f*g2*s + 42*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))) + 66*b2*(D1**2*(f*(fd*(4*s**2 - 4*s + 2) + fdd*(-2*s**2 + 2*s - 1) + s**2*(14*bd1 - 7*bdd1)) - 2*fd*s*(7*bd1 + fd)*(s - 1)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(7*bd1*s + fd*(2*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1155*d**2*k2**2) - D1**2*Pk1*Pk2*st**2*(-114*D1**2*K*bdd1*f**2*s**2 - 525*D1**2*b2*bdd1*f*s**2 + 294*D1**2*b2*f*fd*s**2 - 294*D1**2*b2*f*fd*s + 147*D1**2*b2*f*fd - 210*D1**2*b2*f*fdd*s**2 + 210*D1**2*b2*f*fdd*s - 105*D1**2*b2*f*fdd - 210*D1**2*b2*fd**2*s**2 + 210*D1**2*b2*fd**2*s + 3*D1**2*bd1**2*f*(5*f*(6*r*(3*s + 2) + 28*s**2 + 27*s - 6) + 14*r*(13*s + 1) - 7*s*(52*K*s + 48*s + 15)) + 147*D1**2*bd2*f**2*s**2 - 420*D1**2*bd2*f*fd*s**2 + 210*D1**2*bd2*f*fd*s + 220*D1**2*bdd1*f**3*r*s + 50*D1**2*bdd1*f**3*r + 243*D1**2*bdd1*f**3*s**2 + 45*D1**2*bdd1*f**3*s - 90*D1**2*bdd1*f**3 + 87*D1**2*bdd1*f**2*r*s - 96*D1**2*bdd1*f**2*s**2 + 1092*D1**2*bdd1*f*g2*s**2 - 105*D1**2*bdd2*f**2*s**2 - 300*D1**2*f**3*fd*r*s + 75*D1**2*f**3*fd*r - 432*D1**2*f**3*fd*s**2 + 291*D1**2*f**3*fd*s - 108*D1**2*f**3*fd + 300*D1**2*f**3*fdd*r*s - 75*D1**2*f**3*fdd*r + 432*D1**2*f**3*fdd*s**2 - 291*D1**2*f**3*fdd*s + 108*D1**2*f**3*fdd + 900*D1**2*f**2*fd**2*r*s - 225*D1**2*f**2*fd**2*r + 1296*D1**2*f**2*fd**2*s**2 - 873*D1**2*f**2*fd**2*s + 75*D1**2*f**2*fd**2 - 288*D1**2*f**2*gd2*s**2 + 228*D1**2*f**2*gdd2*s**2 - 576*D1**2*f*fd*g2*s**2 + 576*D1**2*f*fd*g2*s - 288*D1**2*f*fd*g2 + 912*D1**2*f*fd*gd2*s**2 - 456*D1**2*f*fd*gd2*s + 456*D1**2*f*fdd*g2*s**2 - 456*D1**2*f*fdd*g2*s + 228*D1**2*f*fdd*g2 + 456*D1**2*fd**2*g2*s**2 - 456*D1**2*fd**2*g2*s + 588*D1*Dd*b2*f**2*s**2 - 294*D1*Dd*b2*f**2*s + 147*D1*Dd*b2*f**2 - 1680*D1*Dd*b2*f*fd*s**2 + 1260*D1*Dd*b2*f*fd*s - 210*D1*Dd*b2*f*fd - 840*D1*Dd*bd2*f**2*s**2 + 210*D1*Dd*bd2*f**2*s - 300*D1*Dd*f**4*r*s + 75*D1*Dd*f**4*r - 432*D1*Dd*f**4*s**2 + 291*D1*Dd*f**4*s - 108*D1*Dd*f**4 + 2400*D1*Dd*f**3*fd*r*s - 600*D1*Dd*f**3*fd*r + 3456*D1*Dd*f**3*fd*s**2 - 2328*D1*Dd*f**3*fd*s + 366*D1*Dd*f**3*fd - 1152*D1*Dd*f**2*g2*s**2 + 576*D1*Dd*f**2*g2*s - 288*D1*Dd*f**2*g2 + 1824*D1*Dd*f**2*gd2*s**2 - 456*D1*Dd*f**2*gd2*s + 3648*D1*Dd*f*fd*g2*s**2 - 2736*D1*Dd*f*fd*g2*s + 456*D1*Dd*f*fd*g2 - 420*D1*Ddd*b2*f**2*s**2 + 210*D1*Ddd*b2*f**2*s - 105*D1*Ddd*b2*f**2 + 300*D1*Ddd*f**4*r*s - 75*D1*Ddd*f**4*r + 432*D1*Ddd*f**4*s**2 - 291*D1*Ddd*f**4*s + 108*D1*Ddd*f**4 + 912*D1*Ddd*f**2*g2*s**2 - 456*D1*Ddd*f**2*g2*s + 228*D1*Ddd*f**2*g2 - D1*bd1*(D1*(f**3*(10*r*(26*s + 1) + 189*s**2 + 117*s - 126) - f**2*(fd*(120*r*(11*s - 1) + 1458*s**2 - 616*s + 85) + 3*s*(48*K*s - 51*r + 50*s)) - 3*f*(29*fd*r*(4*s - 1) + fd*s*(-76*K*(2*s - 1) - 128*s + 35) + s**2*(245*b2 - 350*bd2 - 448*g2 + 728*gd2)) + 42*fd*s*(25*b2 - 52*g2)*(s - 1)) + Dd*f*(f**2*(-20*r*(88*s - 1) - 1944*s**2 + 526*s + 95) - 3*f*(29*r*(8*s - 1) + s*(-304*K*s + 76*K - 256*s + 35)) + s*(1050*b2 - 2184*g2)*(4*s - 1))) - 1260*Dd**2*b2*f**2*s**2 + 630*Dd**2*b2*f**2*s + 900*Dd**2*f**4*r*s - 225*Dd**2*f**4*r + 1296*Dd**2*f**4*s**2 - 873*Dd**2*f**4*s + 75*Dd**2*f**4 + 2736*Dd**2*f**2*g2*s**2 - 1368*Dd**2*f**2*g2*s - 105*b1**3*(D1*Dd*(f*(r*(2 - 8*s) - 28*s**2 + 16*s - 7) + 2*r*(fd*(8*s - 1) - 8*s + 2) + 4*s*(fd*(10*s - 3) + 1)) + D1*(D1*s*(-2*fd*r - 7*fd*s + 2*fdd*r + 5*fdd*s) + Ddd*(f*(8*r*s - 2*r + 20*s**2 - 12*s + 5) + 8*r*s - 2*r - 2*s)) + 2*Dd**2*(f*(12*r*s - 3*r + 30*s**2 - 18*s + 1) + 12*r*s - 3*r - 3*s + 1)) + 3*b1**2*(224*D1**2*K*fd*s**2 - 448*D1**2*K*fd*s + 224*D1**2*K*fd - 182*D1**2*K*fdd*s**2 + 364*D1**2*K*fdd*s - 182*D1**2*K*fdd - 35*D1**2*bdd1*(f*(6*r*s - 2*r + 15*s**2 - 12*s + 5) + 6*r*s - 2*r - 2*s) - 138*D1**2*f*fd*r*s + 105*D1**2*f*fd*r - 28*D1**2*f*fd*s**2 + 304*D1**2*f*fd*s - 161*D1**2*f*fd + 90*D1**2*f*fdd*r*s - 105*D1**2*f*fdd*r + 140*D1**2*f*fdd*s**2 - 320*D1**2*f*fdd*s + 175*D1**2*f*fdd + 90*D1**2*fd**2*r*s - 105*D1**2*fd**2*r + 140*D1**2*fd**2*s**2 - 320*D1**2*fd**2*s - 147*D1**2*fd*r*s + 175*D1**2*fd*r + 266*D1**2*fd*s**2 - 560*D1**2*fd*s + 266*D1**2*fd + 91*D1**2*fdd*r*s - 105*D1**2*fdd*r - 168*D1**2*fdd*s**2 + 350*D1**2*fdd*s - 168*D1**2*fdd + 896*D1*Dd*K*f*s**2 - 448*D1*Dd*K*f*s + 224*D1*Dd*K*f - 1456*D1*Dd*K*fd*s**2 + 1820*D1*Dd*K*fd*s - 364*D1*Dd*K*fd - 276*D1*Dd*f**2*r*s + 69*D1*Dd*f**2*r - 56*D1*Dd*f**2*s**2 + 97*D1*Dd*f**2*s - 14*D1*Dd*f**2 + 720*D1*Dd*f*fd*r*s - 510*D1*Dd*f*fd*r + 1120*D1*Dd*f*fd*s**2 - 1650*D1*Dd*f*fd*s + 425*D1*Dd*f*fd - 588*D1*Dd*f*r*s + 147*D1*Dd*f*r + 1064*D1*Dd*f*s**2 - 385*D1*Dd*f*s + 266*D1*Dd*f + 728*D1*Dd*fd*r*s - 511*D1*Dd*fd*r - 1344*D1*Dd*fd*s**2 + 1645*D1*Dd*fd*s - 245*D1*Dd*fd - 728*D1*Ddd*K*f*s**2 + 364*D1*Ddd*K*f*s - 182*D1*Ddd*K*f + 180*D1*Ddd*f**2*r*s - 45*D1*Ddd*f**2*r + 280*D1*Ddd*f**2*s**2 - 185*D1*Ddd*f**2*s + 70*D1*Ddd*f**2 + 364*D1*Ddd*f*r*s - 91*D1*Ddd*f*r - 672*D1*Ddd*f*s**2 + 245*D1*Ddd*f*s - 168*D1*Ddd*f + 35*D1*bd1*(D1*(f*(r*(6*s - 2) + 21*s**2 - 16*s + 7) - 2*r*(6*fd*s - fd - 6*s + 2) - 2*s*(15*fd*s - 6*fd + 2)) - 2*Dd*(f*(24*r*s - 7*r + 60*s**2 - 42*s + 7) + 24*r*s - 7*r - 7*s + 2)) - 2184*Dd**2*K*f*s**2 + 1092*Dd**2*K*f*s + 540*Dd**2*f**2*r*s - 135*Dd**2*f**2*r + 840*Dd**2*f**2*s**2 - 555*Dd**2*f**2*s + 45*Dd**2*f**2 + 1092*Dd**2*f*r*s - 273*Dd**2*f*r - 2016*Dd**2*f*s**2 + 735*Dd**2*f*s + 91*Dd**2*f) + b1*(-1092*D1**2*K*bdd1*f*s**2 + 288*D1**2*K*f*fd*s**2 - 288*D1**2*K*f*fd*s + 144*D1**2*K*f*fd - 228*D1**2*K*f*fdd*s**2 + 228*D1**2*K*f*fdd*s - 114*D1**2*K*f*fdd - 228*D1**2*K*fd**2*s**2 + 228*D1**2*K*fd**2*s - 210*D1**2*bd1**2*(f*(r*(6*s - 2) + 15*s**2 - 12*s + 1) + r*(6*s - 2) - 2*s + 1) + 735*D1**2*bd2*f*s**2 - 1050*D1**2*bd2*fd*s**2 + 1050*D1**2*bd2*fd*s + 270*D1**2*bdd1*f**2*r*s + 180*D1**2*bdd1*f**2*r + 420*D1**2*bdd1*f**2*s**2 + 405*D1**2*bdd1*f**2*s - 315*D1**2*bdd1*f**2 + 546*D1**2*bdd1*f*r*s + 42*D1**2*bdd1*f*r - 1008*D1**2*bdd1*f*s**2 - 315*D1**2*bdd1*f*s - 525*D1**2*bdd2*f*s**2 - 780*D1**2*f**2*fd*r*s + 270*D1**2*f**2*fd*r - 567*D1**2*f**2*fd*s**2 + 755*D1**2*f**2*fd*s - 315*D1**2*f**2*fd + 660*D1**2*f**2*fdd*r*s - 270*D1**2*f**2*fdd*r + 729*D1**2*f**2*fdd*s**2 - 751*D1**2*f**2*fdd*s + 333*D1**2*f**2*fdd + 1320*D1**2*f*fd**2*r*s - 540*D1**2*f*fd**2*r + 1458*D1**2*f*fd**2*s**2 - 1502*D1**2*f*fd**2*s + 135*D1**2*f*fd**2 - 306*D1**2*f*fd*r*s + 153*D1**2*f*fd*r + 300*D1**2*f*fd*s**2 - 147*D1**2*f*fd*s + 150*D1**2*f*fd + 174*D1**2*f*fdd*r*s - 87*D1**2*f*fdd*r - 192*D1**2*f*fdd*s**2 + 105*D1**2*f*fdd*s - 96*D1**2*f*fdd - 1344*D1**2*f*gd2*s**2 + 1092*D1**2*f*gdd2*s**2 + 174*D1**2*fd**2*r*s - 87*D1**2*fd**2*r - 192*D1**2*fd**2*s**2 + 105*D1**2*fd**2*s + 87*D1**2*fd**2 - 1344*D1**2*fd*g2*s**2 + 2688*D1**2*fd*g2*s - 1344*D1**2*fd*g2 + 2184*D1**2*fd*gd2*s**2 - 2184*D1**2*fd*gd2*s + 1092*D1**2*fdd*g2*s**2 - 2184*D1**2*fdd*g2*s + 1092*D1**2*fdd*g2 + 576*D1*Dd*K*f**2*s**2 - 288*D1*Dd*K*f**2*s + 144*D1*Dd*K*f**2 - 1824*D1*Dd*K*f*fd*s**2 + 1368*D1*Dd*K*f*fd*s - 228*D1*Dd*K*f*fd - 4200*D1*Dd*bd2*f*s**2 + 1050*D1*Dd*bd2*f*s - 1040*D1*Dd*f**3*r*s + 260*D1*Dd*f**3*r - 756*D1*Dd*f**3*s**2 + 638*D1*Dd*f**3*s - 189*D1*Dd*f**3 + 5280*D1*Dd*f**2*fd*r*s - 1740*D1*Dd*f**2*fd*r + 5832*D1*Dd*f**2*fd*s**2 - 5122*D1*Dd*f**2*fd*s + 1021*D1*Dd*f**2*fd - 612*D1*Dd*f**2*r*s + 153*D1*Dd*f**2*r + 600*D1*Dd*f**2*s**2 - 147*D1*Dd*f**2*s + 150*D1*Dd*f**2 + 1392*D1*Dd*f*fd*r*s - 522*D1*Dd*f*fd*r - 1536*D1*Dd*f*fd*s**2 + 630*D1*Dd*f*fd*s - 18*D1*Dd*f*fd - 5376*D1*Dd*f*g2*s**2 + 2688*D1*Dd*f*g2*s - 1344*D1*Dd*f*g2 + 8736*D1*Dd*f*gd2*s**2 - 2184*D1*Dd*f*gd2*s + 8736*D1*Dd*fd*g2*s**2 - 10920*D1*Dd*fd*g2*s + 2184*D1*Dd*fd*g2 - 456*D1*Ddd*K*f**2*s**2 + 228*D1*Ddd*K*f**2*s - 114*D1*Ddd*K*f**2 + 880*D1*Ddd*f**3*r*s - 220*D1*Ddd*f**3*r + 972*D1*Ddd*f**3*s**2 - 706*D1*Ddd*f**3*s + 243*D1*Ddd*f**3 + 348*D1*Ddd*f**2*r*s - 87*D1*Ddd*f**2*r - 384*D1*Ddd*f**2*s**2 + 105*D1*Ddd*f**2*s - 96*D1*Ddd*f**2 + 4368*D1*Ddd*f*g2*s**2 - 2184*D1*Ddd*f*g2*s + 1092*D1*Ddd*f*g2 - 3*D1*bd1*(D1*(f**2*(6*r*(23*s + 6) + 28*s**2 + 207*s - 147) - f*(5*fd*(18*r*(4*s - 1) + 112*s**2 - 74*s + 15) - 14*r*(21*s + 2) + 7*s*(64*K*s + 76*s + 25)) + 7*fd*(r*(28 - 52*s) + s**2*(104*K + 96) - s*(104*K + 85) - 13)) - Dd*f*(5*f*(6*r*(24*s + 5) + 224*s**2 + 34*s - 39) + 14*r*(104*s - 9) - 7*s**2*(416*K + 384) + 7*s*(104*K + 10) + 91)) - 1368*Dd**2*K*f**2*s**2 + 684*Dd**2*K*f**2*s + 2640*Dd**2*f**3*r*s - 660*Dd**2*f**3*r + 2916*Dd**2*f**3*s**2 - 2118*Dd**2*f**3*s + 220*Dd**2*f**3 + 1044*Dd**2*f**2*r*s - 261*Dd**2*f**2*r - 1152*Dd**2*f**2*s**2 + 315*Dd**2*f**2*s + 87*Dd**2*f**2 + 13104*Dd**2*f*g2*s**2 - 6552*Dd**2*f*g2*s + 105*b2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + D1*(7*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(4*s**2 - 5*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f*s*(1 - 2*s))))/(315*d**2*k2**2) - D1**2*Pk1*Pk2*(35*D1**2*K*bdd1*f**2*s**2 + 105*D1**2*b2*bdd1*f*s**2 - 70*D1**2*b2*f*fd*s**2 + 70*D1**2*b2*f*fd*s - 35*D1**2*b2*f*fd + 70*D1**2*b2*f*fdd*s**2 - 70*D1**2*b2*f*fdd*s + 35*D1**2*b2*f*fdd + 70*D1**2*b2*fd**2*s**2 - 70*D1**2*b2*fd**2*s + 7*D1**2*bd1**2*(f**2*(18*r*(2*s - 1) + 40*s**2 - 39*s + 9) + 3*f*(r*(6*s - 3) + 2*s*(4*K*s + K + 6*s - 1)) + 20*g2*s*(s - 1)) - 35*D1**2*bd2*f**2*s**2 + 140*D1**2*bd2*f*fd*s**2 - 70*D1**2*bd2*f*fd*s + 45*D1**2*bdd1*f**3*r*s - 45*D1**2*bdd1*f**3*r + 63*D1**2*bdd1*f**3*s**2 - 84*D1**2*bdd1*f**3*s + 42*D1**2*bdd1*f**3 + 35*D1**2*bdd1*f**2*s**2 - 168*D1**2*bdd1*f*g2*s**2 - 84*D1**2*bdd1*f*g2*s + 42*D1**2*bdd1*f*g2 + 35*D1**2*bdd2*f**2*s**2 + 70*D1**2*f**2*gd2*s**2 - 70*D1**2*f**2*gdd2*s**2 + 140*D1**2*f*fd*g2*s**2 - 140*D1**2*f*fd*g2*s + 70*D1**2*f*fd*g2 - 280*D1**2*f*fd*gd2*s**2 + 140*D1**2*f*fd*gd2*s - 140*D1**2*f*fdd*g2*s**2 + 140*D1**2*f*fdd*g2*s - 70*D1**2*f*fdd*g2 - 140*D1**2*fd**2*g2*s**2 + 140*D1**2*fd**2*g2*s - 140*D1*Dd*b2*f**2*s**2 + 70*D1*Dd*b2*f**2*s - 35*D1*Dd*b2*f**2 + 560*D1*Dd*b2*f*fd*s**2 - 420*D1*Dd*b2*f*fd*s + 70*D1*Dd*b2*f*fd + 280*D1*Dd*bd2*f**2*s**2 - 70*D1*Dd*bd2*f**2*s + 280*D1*Dd*f**2*g2*s**2 - 140*D1*Dd*f**2*g2*s + 70*D1*Dd*f**2*g2 - 560*D1*Dd*f**2*gd2*s**2 + 140*D1*Dd*f**2*gd2*s - 1120*D1*Dd*f*fd*g2*s**2 + 840*D1*Dd*f*fd*g2*s - 140*D1*Dd*f*fd*g2 + 140*D1*Ddd*b2*f**2*s**2 - 70*D1*Ddd*b2*f**2*s + 35*D1*Ddd*b2*f**2 - 280*D1*Ddd*f**2*g2*s**2 + 140*D1*Ddd*f**2*g2*s - 70*D1*Ddd*f**2*g2 - D1*bd1*(D1*(f**3*(45*r*(s - 1) + 63*s**2 - 84*s + 42) + f**2*(-3*fd*(90*r*s - 45*r + 126*s**2 - 113*s + 15) + s**2*(35*K + 35)) - 7*f*(10*fd*s*(K + 1)*(2*s - 1) + g2*(28*s**2 + 4*s - 2) - 3*s*(4*gd2*(4*s + 1) + s*(5*b2 - 10*bd2))) - 42*fd*s*(5*b2 - 8*g2)*(s - 1)) + Dd*f*(-3*f**2*(15*r*(8*s - 5) + 168*s**2 - 169*s + 43) - 70*f*s*(K + 1)*(4*s - 1) + (168*s - 42)*(-5*b2*s + g2*(8*s + 2)))) + 420*Dd**2*b2*f**2*s**2 - 210*Dd**2*b2*f**2*s - 840*Dd**2*f**2*g2*s**2 + 420*Dd**2*f**2*g2*s - 35*b1**3*(3*D1**2*s*(fd - fdd)*(r + s) + D1*(Dd*(4*K*s**2 - 2*K*s + K + 3*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - 24*fd*r*s + 3*fd*r - 24*fd*s**2 + 9*fd*s + 12*r*s - 3*r - 4*s**2 - s - 1) + Ddd*(K*(4*s**2 - 2*s + 1) - 3*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - (4*s - 1)*(3*r + s - 1))) - 3*Dd**2*(-4*K*s**2 + 2*K*s + f*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) + 3*r*(4*s - 1) + 4*s**2 - 5*s + 1)) - 7*b1**2*(14*D1**2*K*fd*s**2 - 30*D1**2*K*fd*s + 15*D1**2*K*fd - 12*D1**2*K*fdd*s**2 + 30*D1**2*K*fdd*s - 15*D1**2*K*fdd - 5*D1**2*bdd1*(K*(-3*s**2 + 2*s - 1) + f*(r*(9*s - 3) + 9*s**2 - 9*s + 3) + 9*r*s - 3*r + 3*s**2 - 5*s + 1) + 36*D1**2*f*fd*r*s + 40*D1**2*f*fd*s**2 - 19*D1**2*f*fd*s + 5*D1**2*f*fd - 36*D1**2*f*fdd*r*s - 40*D1**2*f*fdd*s**2 + 19*D1**2*f*fdd*s - 5*D1**2*f*fdd - 36*D1**2*fd**2*r*s - 40*D1**2*fd**2*s**2 + 19*D1**2*fd**2*s + 13*D1**2*fd*r*s + 16*D1**2*fd*s**2 - 43*D1**2*fd*s + 15*D1**2*fd - 9*D1**2*fdd*r*s - 18*D1**2*fdd*s**2 + 39*D1**2*fdd*s - 15*D1**2*fdd - 10*D1**2*gd2*s**2 - 10*D1**2*gdd2*s**2 + 56*D1*Dd*K*f*s**2 - 28*D1*Dd*K*f*s + 14*D1*Dd*K*f - 96*D1*Dd*K*fd*s**2 + 144*D1*Dd*K*fd*s - 30*D1*Dd*K*fd + 72*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 80*D1*Dd*f**2*s**2 - 58*D1*Dd*f**2*s + 20*D1*Dd*f**2 - 288*D1*Dd*f*fd*r*s + 36*D1*Dd*f*fd*r - 320*D1*Dd*f*fd*s**2 + 192*D1*Dd*f*fd*s - 19*D1*Dd*f*fd + 52*D1*Dd*f*r*s - 13*D1*Dd*f*r + 64*D1*Dd*f*s**2 - 45*D1*Dd*f*s + 16*D1*Dd*f - 72*D1*Dd*fd*r*s + 9*D1*Dd*fd*r - 144*D1*Dd*fd*s**2 + 201*D1*Dd*fd*s - 39*D1*Dd*fd - 40*D1*Dd*g2*s**2 + 20*D1*Dd*g2*s - 10*D1*Dd*g2 - 80*D1*Dd*gd2*s**2 + 20*D1*Dd*gd2*s - 48*D1*Ddd*K*f*s**2 + 24*D1*Ddd*K*f*s - 12*D1*Ddd*K*f - 72*D1*Ddd*f**2*r*s + 18*D1*Ddd*f**2*r - 80*D1*Ddd*f**2*s**2 + 58*D1*Ddd*f**2*s - 20*D1*Ddd*f**2 - 36*D1*Ddd*f*r*s + 9*D1*Ddd*f*r - 72*D1*Ddd*f*s**2 + 45*D1*Ddd*f*s - 18*D1*Ddd*f - 40*D1*Ddd*g2*s**2 + 20*D1*Ddd*g2*s - 10*D1*Ddd*g2 + 5*D1*bd1*(D1*(3*K*s**2 - 2*K*s + K + f*(r*(9*s - 3) + 9*s**2 - 9*s + 3) - 18*fd*r*s + 3*fd*r - 18*fd*s**2 + 9*fd*s + 9*r*s - 3*r - 3*s**2 - s - 1) + Dd*(2*K*(12*s**2 - 7*s + 1) - 3*f*(r*(24*s - 7) + 24*s**2 - 21*s + 4) - 72*r*s + 21*r - 24*s**2 + 35*s - 8)) - 144*Dd**2*K*f*s**2 + 72*Dd**2*K*f*s - 216*Dd**2*f**2*r*s + 54*Dd**2*f**2*r - 240*Dd**2*f**2*s**2 + 174*Dd**2*f**2*s - 18*Dd**2*f**2 - 108*Dd**2*f*r*s + 27*Dd**2*f*r - 216*Dd**2*f*s**2 + 135*Dd**2*f*s - 9*Dd**2*f - 120*Dd**2*g2*s**2 + 60*Dd**2*g2*s) + b1*(-70*D1**2*K*f*fd*s**2 + 70*D1**2*K*f*fd*s - 35*D1**2*K*f*fd + 70*D1**2*K*f*fdd*s**2 - 70*D1**2*K*f*fdd*s + 35*D1**2*K*f*fdd + 70*D1**2*K*fd**2*s**2 - 70*D1**2*K*fd**2*s - 105*D1**2*b2*fd*s**2 + 210*D1**2*b2*fd*s - 105*D1**2*b2*fd + 105*D1**2*b2*fdd*s**2 - 210*D1**2*b2*fdd*s + 105*D1**2*b2*fdd + 35*D1**2*bd1**2*(-6*K*s**2 + 4*K*s + 3*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*r*(3*s - 1) + 6*s**2 - 10*s + 3) - 105*D1**2*bd2*f*s**2 + 210*D1**2*bd2*fd*s**2 - 210*D1**2*bd2*fd*s + 7*D1**2*bdd1*(f**2*(18*r*(2*s - 1) + 40*s**2 - 39*s + 15) + 3*f*(K*(8*s**2 + 2*s - 1) + 6*r*s - 3*r + 12*s**2 - 2*s + 1) + 10*g2*(2*s**2 - 2*s + 1)) + 105*D1**2*bdd2*f*s**2 - 135*D1**2*f**2*fd*r*s - 189*D1**2*f**2*fd*s**2 + 87*D1**2*f**2*fd*s - 21*D1**2*f**2*fd + 135*D1**2*f**2*fdd*r*s + 189*D1**2*f**2*fdd*s**2 - 87*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd + 270*D1**2*f*fd**2*r*s + 378*D1**2*f*fd**2*s**2 - 174*D1**2*f*fd**2*s - 70*D1**2*f*fd*s**2 + 70*D1**2*f*fd*s - 35*D1**2*f*fd + 70*D1**2*f*fdd*s**2 - 70*D1**2*f*fdd*s + 35*D1**2*f*fdd + 196*D1**2*f*gd2*s**2 - 168*D1**2*f*gdd2*s**2 + 70*D1**2*fd**2*s**2 - 70*D1**2*fd**2*s + 196*D1**2*fd*g2*s**2 - 420*D1**2*fd*g2*s + 210*D1**2*fd*g2 - 336*D1**2*fd*gd2*s**2 + 420*D1**2*fd*gd2*s - 168*D1**2*fdd*g2*s**2 + 420*D1**2*fdd*g2*s - 210*D1**2*fdd*g2 - 140*D1*Dd*K*f**2*s**2 + 70*D1*Dd*K*f**2*s - 35*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*s**2 - 420*D1*Dd*K*f*fd*s + 70*D1*Dd*K*f*fd - 420*D1*Dd*b2*f*s**2 + 210*D1*Dd*b2*f*s - 105*D1*Dd*b2*f + 840*D1*Dd*b2*fd*s**2 - 1050*D1*Dd*b2*fd*s + 210*D1*Dd*b2*fd + 840*D1*Dd*bd2*f*s**2 - 210*D1*Dd*bd2*f*s - 180*D1*Dd*f**3*r*s + 45*D1*Dd*f**3*r - 252*D1*Dd*f**3*s**2 + 171*D1*Dd*f**3*s - 63*D1*Dd*f**3 + 1080*D1*Dd*f**2*fd*r*s - 135*D1*Dd*f**2*fd*r + 1512*D1*Dd*f**2*fd*s**2 - 861*D1*Dd*f**2*fd*s + 87*D1*Dd*f**2*fd - 140*D1*Dd*f**2*s**2 + 70*D1*Dd*f**2*s - 35*D1*Dd*f**2 + 560*D1*Dd*f*fd*s**2 - 420*D1*Dd*f*fd*s + 70*D1*Dd*f*fd + 784*D1*Dd*f*g2*s**2 - 392*D1*Dd*f*g2*s + 196*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 1344*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s - 420*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*s**2 - 70*D1*Ddd*K*f**2*s + 35*D1*Ddd*K*f**2 + 420*D1*Ddd*b2*f*s**2 - 210*D1*Ddd*b2*f*s + 105*D1*Ddd*b2*f + 180*D1*Ddd*f**3*r*s - 45*D1*Ddd*f**3*r + 252*D1*Ddd*f**3*s**2 - 171*D1*Ddd*f**3*s + 63*D1*Ddd*f**3 + 140*D1*Ddd*f**2*s**2 - 70*D1*Ddd*f**2*s + 35*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*s**2 + 336*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(f**2*(18*r*(2*s - 1) + 40*s**2 - 39*s + 15) + f*(K*(28*s**2 + 2*s - 1) + fd*(-36*r*(4*s - 1) - 160*s**2 + 116*s - 9) + 26*r*s - 13*r + 32*s**2 - 2*s + 1) + fd*(r*(9 - 36*s) - s**2*(48*K + 72) + s*(54*K + 84) - 9) - 10*g2*(2*s**2 - 2*s + 1) - 20*gd2*s*(2*s - 1)) - Dd*(f**2*(8*s - 3)*(36*r + 40*s - 19) + 3*f*(K*(64*s**2 - 8*s - 2) + 6*r*(8*s - 3) + 96*s**2 - 38*s + 5) + 20*g2*(8*s**2 - 6*s + 1))) + 420*Dd**2*K*f**2*s**2 - 210*Dd**2*K*f**2*s + 1260*Dd**2*b2*f*s**2 - 630*Dd**2*b2*f*s + 540*Dd**2*f**3*r*s - 135*Dd**2*f**3*r + 756*Dd**2*f**3*s**2 - 513*Dd**2*f**3*s + 45*Dd**2*f**3 + 420*Dd**2*f**2*s**2 - 210*Dd**2*f**2*s - 2016*Dd**2*f*g2*s**2 + 1008*Dd**2*f*g2*s))/(105*d**2*k2**2) - 2*D1**2*Pk1*Pk2*k2**4*st**6*(36*D1**2*b1*f*fd*r**2 + 36*D1**2*b1*f*fd*r*s - 18*D1**2*b1*f*fd*r - 18*D1**2*b1*f*fdd*r**2 - 18*D1**2*b1*f*fdd*r*s + 9*D1**2*b1*f*fdd*r - 18*D1**2*b1*fd**2*r**2 - 18*D1**2*b1*fd**2*r*s + 9*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 6*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r - 2*D1**2*f**2*fd*s + 2*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 3*D1**2*f**2*fdd*r*s + 3*D1**2*f**2*fdd*r + D1**2*f**2*fdd*s - D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 6*D1**2*f*fd**2*r*s + 6*D1**2*f*fd**2*r + 2*D1**2*f*fd**2*s - D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 72*D1*Dd*b1*f**2*r*s - 54*D1*Dd*b1*f**2*r - 18*D1*Dd*b1*f**2*s + 18*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 144*D1*Dd*b1*f*fd*r*s + 90*D1*Dd*b1*f*fd*r + 18*D1*Dd*b1*f*fd*s - 9*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r - 2*D1*Dd*f**3*s + 2*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 24*D1*Dd*f**2*fd*r*s + 21*D1*Dd*f**2*fd*r + 7*D1*Dd*f**2*fd*s - 4*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 36*D1*Ddd*b1*f**2*r*s + 27*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2*s - 9*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 4*D1*Ddd*f**3*r*s + 3*D1*Ddd*f**3*r + D1*Ddd*f**3*s - D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(-8*r**2 + r*(11 - 8*s) + 5*s - 3)) - 108*Dd**2*b1*f**2*r**2 - 108*Dd**2*b1*f**2*r*s + 81*Dd**2*b1*f**2*r + 27*Dd**2*b1*f**2*s - 9*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 12*Dd**2*f**3*r*s + 9*Dd**2*f**3*r + 3*Dd**2*f**3*s - Dd**2*f**3)/(63*d**2*k1**2*k3**4) + 2*D1**2*Pk1*Pk2*k2**4*st**4*(D1*f*(7*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(f*(5*r - 7)*(r + s - 1) + fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + D1*f*(bdd1*r*(r + s - 1) + fd*(3*r**2 + 3*r*(s - 1) - s + 1)) + Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1) + Dd*f**2*(4*r**2 + r*(4*s - 3) - s + 1)) - 7*b1**2*(D1**2*r*(2*fd - fdd)*(r + s) + D1*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 3*r + s)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + Dd**2*f*(-12*r**2 + r*(9 - 12*s) + 3*s - 1)) + b1*(7*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) + 10*D1**2*f*fd*r**2 + 10*D1**2*f*fd*r*s - 3*D1**2*f*fd*r + 2*D1**2*f*fd*s - 2*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r - D1**2*f*fdd*s + D1**2*f*fdd + 2*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r*s - 2*D1**2*fd**2*r - D1**2*fd**2*s + 20*D1*Dd*f**2*r**2 + 20*D1*Dd*f**2*r*s - 15*D1*Dd*f**2*r - 5*D1*Dd*f**2*s + 5*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 16*D1*Dd*f*fd*r*s - 14*D1*Dd*f*fd*r - 6*D1*Dd*f*fd*s + 3*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 + 4*D1*Ddd*f**2*r*s - 3*D1*Ddd*f**2*r - D1*Ddd*f**2*s + D1*Ddd*f**2 - 7*D1*bd1*(D1*(2*f*(2*r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 3*r + s)) - 2*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 12*Dd**2*f**2*r**2 + 12*Dd**2*f**2*r*s - 9*Dd**2*f**2*r - 3*Dd**2*f**2*s + Dd**2*f**2))/(35*d**2*k1**2*k3**4) + D1**2*Pk1*Pkd2*ct**8*k2**3*(4*C - 4)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 14*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 7*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 7*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(63*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**8*k2*(C - 1)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**7*f*(-11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(-18*fd*(4*s**2 - 2*s + 1) + 9*fdd*(4*s**2 - 2*s + 1) + s**2*(-22*bd1 + 11*bdd1)) + 2*fd*s*(11*bd1*(3*s - 1) + 27*fd*(2*s - 1))) + D1*f*(2*Dd*(-9*f*(4*s**2 - 2*s + 1) + (4*s - 1)*(11*bd1*s + 36*fd*s - 9*fd)) + 9*Ddd*f*(4*s**2 - 2*s + 1)) + 54*Dd**2*f**2*s*(2*s - 1)))/(22*d**2*k1) + 2*D1**2*Pk1*Pkd2*ct**7*k1*k2**2*(9*b1*(D1**2*(f*(fd*(46*C - 56) + fdd*(35 - 30*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(35 - 30*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(46*C - 56)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(35 - 30*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(35 - 30*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(35 - 30*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(66*C - 80)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (6*C - 7)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(49 - 42*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(46*C - 56)*(r + s - 1) - fd*(30*C - 35)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(35 - 30*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*(f*(66*C - 80)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(42*C - 49)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(49 - 42*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(49 - 42*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(315*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**7*k1*(4*C - 5)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k3**2) - 2*D1**2*Pk1*Pkd2*ct**7*k2**4*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 14*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 7*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 7*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(63*d**2*k1*k3**4) + D1**2*Pk1*Pkd2*ct**7*k2**2*(-9*b1*(D1**2*(f*(fd*r*(56*C - 56)*(2*s - 1) + 50*fd*(2*s**2 - 2*s + 1) - 25*fdd*(2*s**2 - 2*s + 1)) - 50*fd**2*s*(s - 1)) + D1*f*(Dd*f*(-56*C*s + r*(56*C - 56)*(4*s - 1) + 200*s**2 - 44*s + 50) - 50*Dd*fd*(8*s**2 - 6*s + 1) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(-10*fd*(r*(52*C - 52)*(3*s - 1) + 105*s**2 - s*(52*C + 18) + 35) + 5*fdd*(r*(16*C - 16)*(3*s - 1) + 105*s**2 - s*(16*C + 54) + 35) - 9*s*(bd1*(56*C*(r - 1) - 56*r + 50*s + 56) - 25*bdd1*s)) + 10*fd*(45*bd1*s*(2*s - 1) + fd*(8*C*(6*r*s - 2*r - 2*s + 1) - 48*r*s + 16*r + 105*s**2 - 54*s - 8))) - 5*D1*f*(2*Dd*(45*bd1*s*(1 - 4*s) + f*(r*(52*C - 52)*(4*s - 1) + 140*s**2 - s*(52*C + 18) + 35) + fd*(-8*C*(r*(24*s - 7) - 7*s + 2) + 8*r*(24*s - 7) - 420*s**2 + 189*s - 19)) + Ddd*f*(-r*(16*C - 16)*(4*s - 1) - 140*s**2 + s*(16*C + 54) - 35)) + 10*Dd**2*f**2*(8*C*(3*r*(4*s - 1) - 3*s + 1) + r*(24 - 96*s) + 210*s**2 - 81*s - 8)))/(630*d**2*k1*k3**2) - D1**2*Pk1*Pkd2*ct**6*f*k2*(11*D1*bd1*f*(D1*(f*s*(r - 1) - 5*fd*(6*r*s - r - 3*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 11*b1*(D1*Dd*f*(f*(-4*r*s + r + s) + 5*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(D1*r*(3*s - 1)*(-f*fd + 5*f*fdd + 10*fd**2) + 5*Ddd*f**2*(r*(4*s - 1) - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(-7*D1*Dd*f*(5*f*r*(4*s - 1) - 5*f*s + 6*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-35*f*fd*(r*(4*s - 1) - s) + f*(-55*bdd1*s*(r - 1) + 21*fdd*(-4*r*s + r + s)) - 21*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 21*Ddd*f**2*(-4*r*s + r + s)) - 21*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1**2) + 2*D1**2*Pk1*Pkd2*ct**6*k1**2*k2*(3*b1*(D1**2*(f*(fd*(32*C - 55) + fdd*(45 - 30*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(45 - 30*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(32*C - 55)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(45 - 30*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(45 - 30*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(45 - 30*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(16*C - 27)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (2*C - 3)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(21 - 14*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(32*C - 55)*(r + s - 1) - fd*(30*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(45 - 30*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*(f*(16*C - 27)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(14*C - 21)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(21 - 14*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(21 - 14*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**6*k1**2*(C - 2)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k2*k3**2) + D1**2*Pk1*Pkd2*ct**6*k2**3*st**2*(4*C - 4)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 10*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(21*d**2*k3**4) + 2*D1**2*Pk1*Pkd2*ct**6*k2**3*(126*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 9*b1*(-28*C*D1**2*f*fd*r*s + 34*C*D1**2*f*fd*r - 28*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 34*C*D1**2*f*fd - 10*C*D1**2*f*fdd*r - 10*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd - 10*C*D1**2*fd**2*r - 10*C*D1**2*fd**2*s - 56*C*D1*Dd*f**2*r*s + 14*C*D1*Dd*f**2*r - 56*C*D1*Dd*f**2*s**2 + 42*C*D1*Dd*f**2*s - 14*C*D1*Dd*f**2 - 40*C*D1*Dd*f*fd*r - 40*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd - 14*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) - 58*D1**2*f*fd*r*s + 9*D1**2*f*fd*r - 58*D1**2*f*fd*s**2 + 38*D1**2*f*fd*s - 9*D1**2*f*fd + 50*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r + 50*D1**2*f*fdd*s**2 - 40*D1**2*f*fdd*s + 15*D1**2*f*fdd + 50*D1**2*fd**2*r*s - 15*D1**2*fd**2*r + 50*D1**2*fd**2*s**2 - 40*D1**2*fd**2*s - 116*D1*Dd*f**2*r*s + 29*D1*Dd*f**2*r - 116*D1*Dd*f**2*s**2 + 87*D1*Dd*f**2*s - 29*D1*Dd*f**2 + 400*D1*Dd*f*fd*r*s - 110*D1*Dd*f*fd*r + 400*D1*Dd*f*fd*s**2 - 310*D1*Dd*f*fd*s + 55*D1*Dd*f*fd + 100*D1*Ddd*f**2*r*s - 25*D1*Ddd*f**2*r + 100*D1*Ddd*f**2*s**2 - 75*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 + 14*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 300*Dd**2*f**2*r*s - 75*Dd**2*f**2*r + 300*Dd**2*f**2*s**2 - 225*Dd**2*f**2*s + 25*Dd**2*f**2) + f*(-126*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) + 45*D1**2*bdd1*f*(2*C + 5*s - 2)*(r + s - 1) + 5*D1**2*(-f*(fd*(46*C + 15) - fdd*(14*C + 21))*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(14*C + 21)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 9*D1*bd1*(D1*(f*(r + s - 1)*(2*C*(7*s + 10) + 29*s - 20) - 5*fd*(r*(2*C + 20*s - 7) + 20*s**2 + s*(2*C - 22) + 5)) - 5*Dd*f*(C*(8*r + 8*s - 4) + r*(40*s - 13) + 40*s**2 - 43*s + 9)) + 5*D1*f*(Dd*(-f*(46*C + 15)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(14*C + 21)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(14*C + 21)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(14*C + 21)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(315*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**6*k2*st**2*(3*C - 3)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**6*k2*(315*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 9*b1*(-168*C*D1**2*f*fd*r*s + 84*C*D1**2*f*fd*r - 248*C*D1**2*f*fd*s**2 + 348*C*D1**2*f*fd*s - 174*C*D1**2*f*fd + 56*C*D1**2*f*fdd*r*s - 28*C*D1**2*f*fdd*r + 166*C*D1**2*f*fdd*s**2 - 216*C*D1**2*f*fdd*s + 108*C*D1**2*f*fdd + 56*C*D1**2*fd**2*r*s - 28*C*D1**2*fd**2*r + 166*C*D1**2*fd**2*s**2 - 216*C*D1**2*fd**2*s - 336*C*D1*Dd*f**2*r*s + 84*C*D1*Dd*f**2*r - 496*C*D1*Dd*f**2*s**2 + 332*C*D1*Dd*f**2*s - 124*C*D1*Dd*f**2 + 448*C*D1*Dd*f*fd*r*s - 168*C*D1*Dd*f*fd*r + 1328*C*D1*Dd*f*fd*s**2 - 1252*C*D1*Dd*f*fd*s + 244*C*D1*Dd*f*fd + 112*C*D1*Ddd*f**2*r*s - 28*C*D1*Ddd*f**2*r + 332*C*D1*Ddd*f**2*s**2 - 194*C*D1*Ddd*f**2*s + 83*C*D1*Ddd*f**2 + 336*C*Dd**2*f**2*r*s - 84*C*Dd**2*f**2*r + 996*C*Dd**2*f**2*s**2 - 582*C*Dd**2*f**2*s + 28*C*Dd**2*f**2 - 35*D1**2*bdd1*f*(C - 1)*(2*s**2 - 2*s + 1) + 188*D1**2*f*fd*r*s - 94*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 148*D1**2*f*fd*s + 74*D1**2*f*fd - 66*D1**2*f*fdd*r*s + 33*D1**2*f*fdd*r - 66*D1**2*f*fdd*s**2 + 116*D1**2*f*fdd*s - 58*D1**2*f*fdd - 66*D1**2*fd**2*r*s + 33*D1**2*fd**2*r - 66*D1**2*fd**2*s**2 + 116*D1**2*fd**2*s + 376*D1*Dd*f**2*r*s - 94*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 142*D1*Dd*f**2*s + 24*D1*Dd*f**2 - 528*D1*Dd*f*fd*r*s + 198*D1*Dd*f*fd*r - 528*D1*Dd*f*fd*s**2 + 662*D1*Dd*f*fd*s - 149*D1*Dd*f*fd - 132*D1*Ddd*f**2*r*s + 33*D1*Ddd*f**2*r - 132*D1*Ddd*f**2*s**2 + 99*D1*Ddd*f**2*s - 33*D1*Ddd*f**2 + 70*D1*bd1*(C - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 396*Dd**2*f**2*r*s + 99*Dd**2*f**2*r - 396*Dd**2*f**2*s**2 + 297*Dd**2*f**2*s - 33*Dd**2*f**2) + f*(-630*D1**2*bd1**2*s*(C - 1)*(s - 1) + 9*D1**2*bdd1*f*(C*(83*s**2 + s*(28*r + 22) - 25) - 33*s**2 - s*(33*r + 17) + 25) - 5*D1**2*(f*(2*fd*(C*(70*r*(3*s - 1) + 351*s**2 - 304*s + 117) - 81*r*(3*s - 1) - 141*s**2 + 175*s - 47) + fdd*(-4*C*(13*r*(3*s - 1) + 108*s**2 - 85*s + 36) + 63*r*(3*s - 1) + 222*s**2 - 211*s + 74)) + fd**2*(-4*C*(26*r*(3*s - 1) + 216*s**2 - 170*s + 13) + 126*r*(3*s - 1) + 444*s**2 - 422*s + 63)) - 9*D1*bd1*(D1*(2*f*(C*(62*s**2 + s*(42*r + 8) - 25) - 12*s**2 - s*(47*r + 3) + 25) + fd*(-4*C*(7*r*(4*s - 1) + 83*s**2 - 43*s + 7) + 33*r*(4*s - 1) + 132*s**2 - 82*s + 33)) + Dd*f*(C*(-28*r*(8*s - 1) - 664*s**2 + 106*s + 22) + 33*r*(8*s - 1) + 264*s**2 - 31*s - 17)) - 5*D1*f*(Dd*(2*f*(C*(70*r*(4*s - 1) + 468*s**2 - 304*s + 117) - 81*r*(4*s - 1) - 188*s**2 + 175*s - 47) + fd*(-4*C*(13*r*(24*s - 7) + 864*s**2 - 595*s + 98) + 63*r*(24*s - 7) + 1776*s**2 - 1477*s + 274)) + Ddd*f*(-4*C*(13*r*(4*s - 1) + 144*s**2 - 85*s + 36) + 63*r*(4*s - 1) + 296*s**2 - 211*s + 74)) - 5*Dd**2*f**2*(-4*C*(39*r*(4*s - 1) + 432*s**2 - 255*s + 13) + 189*r*(4*s - 1) + 888*s**2 - 633*s + 63)))/(315*d**2*k3**2) - 3*D1**2*Pk1*Pkd2*ct**6*(D1**2*(35*f**3*(12*fd*(4*s**2 - 2*s + 1) - 6*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) - 5*f**2*s*(66*bd1**2*s + 22*bd1*(7*fd*(3*s - 1) + s*(3*K - 3)) + 252*fd**2*(2*s - 1) - s*(33*bdd1*(K - 1) + 132*gd2 - 66*gdd2)) + 66*f*(5*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 5*fdd*g2*(2*s**2 - 2*s + 1) + s**2*(7*bd1**2*(K - 1) + 14*bd1*(g2 - gd2) - 7*bdd1*g2)) - 132*fd*g2*s*(7*bd1 + 5*fd)*(s - 1)) + 2*D1*f*(Dd*(210*f**3*(4*s**2 - 2*s + 1) - 35*f**2*(4*s - 1)*(11*bd1*s + 6*fd*(4*s - 1)) + 165*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 66*g2*(4*s - 1)*(7*bd1*s + 5*fd*(2*s - 1))) - 15*Ddd*f*(7*f**2 + 11*g2)*(4*s**2 - 2*s + 1)) - 180*Dd**2*f**2*s*(7*f**2 + 11*g2)*(2*s - 1) + 33*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) - 14*fd*(K - 1)*(s - 1)**2 + 7*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) - 7*f*(K - 1)*(4*s**2 - 2*s + 1) + 7*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-7*K + 5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-7*K + 5*f + 7)) + 11*b1*(D1**2*(5*f**2*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(12*bd1 - 6*bdd1)) + f*(-70*fd**2*s*(3*s - 2) - 30*fd*(K*(2*s**2 - 2*s + 1) + s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) + 15*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(42*K*bdd1 - 84*bd1*(K - 1) - 42*bdd1 + 84*gd2 - 42*gdd2)) + (6*s - 6)*(5*fd**2*s*(K - 1) + 14*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(35*f**3*(4*s**2 - 2*s + 1) - 5*f**2*(3*K*(4*s**2 - 2*s + 1) + 7*fd*(12*s**2 - 7*s + 1) + s**2*(24*bd1 - 12) - s*(6*bd1 - 6) - 3) + 3*f*(5*fd*(K - 1)*(8*s**2 - 6*s + 1) + 14*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(14*K*bd1 - 14*bd1 - 14*gd2)) - 42*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(35*f**2 - 15*f*(K - 1) + 42*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(35*f**2 - 15*f*(K - 1) + 42*g2)))/(770*d**2*k2) + D1**2*Pk1*Pkd2*ct**6*k2**3*(3*D1*bd1*f*(D1*(4*f*s*(r - 1) + 5*fd*(4*r*s - r - 2*s + 1)) + 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) + 3*b1*(D1*Dd*f*(4*f*(4*r*s - r - s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(D1*r*(2*s - 1)*(4*f*fd + 5*f*fdd + 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 5*f*(D1*Dd*f*(4*f*(r*(4*s - 1) - s) + fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(4*f*fd*(r*(3*s - 1) - s) + f*(3*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) + fd**2*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1**2*k3**2) - 3*D1**2*Pk1*Pkd2*ct**5*f*st**2*(11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(4*s**2 - 2*s + 1) - 7*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + 2*fd*s*(bd1*(11 - 33*s) + 21*fd*(1 - 2*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(11*bd1*s + 7*fd*(4*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(22*d**2*k1) + 2*D1**2*Pk1*Pkd2*ct**5*k1**3*(9*b1*(D1**2*(f*(fd*(6*C - 22) + fdd*(25 - 10*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(25 - 10*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(6*C - 22)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(25 - 10*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(25 - 10*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(25 - 10*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(10*C - 34)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (2*C - 5)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(35 - 14*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(6*C - 22)*(r + s - 1) - fd*(10*C - 25)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(25 - 10*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*(f*(10*C - 34)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(14*C - 35)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(35 - 14*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(35 - 14*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(315*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**5*k1**3*(-9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(-14*fd*(3*s**2 - 2*s + 1) + 7*fdd*(3*s**2 - 2*s + 1) + s**2*(-18*bd1 + 9*bdd1)) + 2*fd*s*(9*bd1*(2*s - 1) + 7*fd*(3*s - 2))) + D1*f*(2*Dd*(-7*f*(4*s**2 - 2*s + 1) + (4*s - 1)*(9*bd1*s + 21*fd*s - 7*fd)) + 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(2*s - 1)))/(14*d**2*k2**2*k3**2) + 2*D1**2*Pk1*Pkd2*ct**5*k1*k2**2*st**2*(3*b1*(D1**2*(f*(fd*(92*C - 122) + fdd*(75 - 60*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(75 - 60*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(92*C - 122)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(75 - 60*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(75 - 60*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(75 - 60*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(164*C - 214)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 25)*(9*bdd1*s*(r + s - 1) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(125 - 100*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(92*C - 122)*(r + s - 1) - fd*(60*C - 75)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(75 - 60*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(164*C - 214)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(100*C - 125)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(125 - 100*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(125 - 100*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) + 2*D1**2*Pk1*Pkd2*ct**5*k1*k2**2*(7*b1**2*(D1**2*s*(r + s)*(fd*(26*C - 32) + fdd*(21 - 18*C)) + D1*(Dd*(f*(26*C - 32)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(18*C - 21)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(21 - 18*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(18*C - 21)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(-21*D1**2*bdd1*f*(6*C - 7)*(2*s - 1)*(r + s - 1) - 3*D1**2*(f*(fd*(2*C*(28*r*s - 37*r + 28*s**2 - 51*s + 37) + 74*r*s + 19*r + 74*s**2 - 18*s - 19) + 5*fdd*(6*C*(r + s - 1) - 20*r*s + 3*r - 20*s**2 + 13*s - 3)) + 5*fd**2*(r*(6*C - 20*s + 3) + s*(6*C - 20*s + 13))) + 7*D1*bd1*(D1*(f*(26*C - 32)*(2*s - 1)*(r + s - 1) - fd*(18*C - 21)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(42 - 36*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 3*D1*f*(Dd*(f*(28*C + 37)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + 20*fd*(3*C - 20*s + 4)*(2*r + 2*s - 1)) - 50*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 150*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(-21*D1**2*bd1**2*(6*C - 7)*(2*s - 1)*(r + s - 1) + 15*D1**2*bdd1*f*(6*C + 10*s - 7)*(r + s - 1) + 5*D1**2*(-f*(-14*C*fdd + fd*(34*C - 7) - 7*fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(14*C + 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 3*D1*bd1*(D1*(f*(r + s - 1)*(C*(28*s + 46) + 37*s - 56) - 5*fd*(6*C*s + r*(6*C + 40*s - 17) + 40*s**2 - 47*s + 10)) - 10*Dd*f*(6*C*(2*r + 2*s - 1) + 40*r*s - 19*r + 40*s**2 - 49*s + 12)) + 5*D1*f*(Dd*(-f*(34*C - 7)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(14*C + 7)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(14*C + 7)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(14*C + 7)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**5*k1*st**2*(8*C - 11)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**5*k1*(315*b1**2*(4*C - 5)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 9*b1*(-224*C*D1**2*f*fd*r*s + 112*C*D1**2*f*fd*r - 880*C*D1**2*f*fd*s**2 + 1280*C*D1**2*f*fd*s - 640*C*D1**2*f*fd + 112*C*D1**2*f*fdd*r*s - 56*C*D1**2*f*fdd*r + 552*C*D1**2*f*fdd*s**2 - 752*C*D1**2*f*fdd*s + 376*C*D1**2*f*fdd + 112*C*D1**2*fd**2*r*s - 56*C*D1**2*fd**2*r + 552*C*D1**2*fd**2*s**2 - 752*C*D1**2*fd**2*s - 448*C*D1*Dd*f**2*r*s + 112*C*D1*Dd*f**2*r - 1760*C*D1*Dd*f**2*s**2 + 992*C*D1*Dd*f**2*s - 440*C*D1*Dd*f**2 + 896*C*D1*Dd*f*fd*r*s - 336*C*D1*Dd*f*fd*r + 4416*C*D1*Dd*f*fd*s**2 - 4224*C*D1*Dd*f*fd*s + 808*C*D1*Dd*f*fd + 224*C*D1*Ddd*f**2*r*s - 56*C*D1*Ddd*f**2*r + 1104*C*D1*Ddd*f**2*s**2 - 608*C*D1*Ddd*f**2*s + 276*C*D1*Ddd*f**2 + 672*C*Dd**2*f**2*r*s - 168*C*Dd**2*f**2*r + 3312*C*Dd**2*f**2*s**2 - 1824*C*Dd**2*f**2*s + 56*C*Dd**2*f**2 - 35*D1**2*bdd1*f*(4*C - 5)*(2*s**2 - 2*s + 1) + 360*D1**2*f*fd*r*s - 180*D1**2*f*fd*r + 516*D1**2*f*fd*s**2 - 1016*D1**2*f*fd*s + 508*D1**2*f*fd - 208*D1**2*f*fdd*r*s + 104*D1**2*f*fdd*r - 398*D1**2*f*fdd*s**2 + 648*D1**2*f*fdd*s - 324*D1**2*f*fdd - 208*D1**2*fd**2*r*s + 104*D1**2*fd**2*r - 398*D1**2*fd**2*s**2 + 648*D1**2*fd**2*s + 720*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r + 1032*D1*Dd*f**2*s**2 - 696*D1*Dd*f**2*s + 258*D1*Dd*f**2 - 1664*D1*Dd*f*fd*r*s + 624*D1*Dd*f*fd*r - 3184*D1*Dd*f*fd*s**2 + 3596*D1*Dd*f*fd*s - 752*D1*Dd*f*fd - 416*D1*Ddd*f**2*r*s + 104*D1*Ddd*f**2*r - 796*D1*Ddd*f**2*s**2 + 502*D1*Ddd*f**2*s - 199*D1*Ddd*f**2 + 70*D1*bd1*(4*C - 5)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 1248*Dd**2*f**2*r*s + 312*Dd**2*f**2*r - 2388*Dd**2*f**2*s**2 + 1506*Dd**2*f**2*s - 104*Dd**2*f**2) - f*(630*D1**2*bd1**2*s*(4*C - 5)*(s - 1) - 9*D1**2*bdd1*f*(4*C*(69*s**2 + s*(14*r + 36) - 25) - 199*s**2 - s*(104*r + 146) + 125) + 20*D1**2*(f*(fd*(4*C*(33*r*s - 11*r + 162*s**2 - 119*s + 54) - 225*r*s + 75*r - 501*s**2 + 409*s - 167) + 2*fdd*(C*(-33*r*s + 11*r - 189*s**2 + 137*s - 63) + 63*r*s - 21*r + 159*s**2 - 127*s + 53)) + 2*fd**2*(C*(r*(22 - 66*s) - 378*s**2 + 274*s - 11) + 42*r*(3*s - 1) + 318*s**2 - 254*s + 21)) + 18*D1*bd1*(D1*(f*(4*C*(55*s**2 + s*(14*r + 36) - 25) - 129*s**2 - s*(90*r + 160) + 125) + 2*fd*(-2*C*(7*r*(4*s - 1) + 138*s**2 - 58*s + 7) + 26*r*(4*s - 1) + 199*s**2 - 89*s + 26)) + Dd*f*(-4*C*(7*r*(8*s - 1) + 276*s**2 - 4*s - 18) + 52*r*(8*s - 1) + 796*s**2 + 41*s - 73)) + 20*D1*f*(Dd*(f*(4*C*(44*r*s - 11*r + 216*s**2 - 119*s + 54) - 300*r*s + 75*r - 668*s**2 + 409*s - 167) - 2*fd*(C*(264*r*s - 77*r + 1512*s**2 - 959*s + 148) - 504*r*s + 147*r - 1272*s**2 + 889*s - 148)) + 2*Ddd*f*(C*(-44*r*s + 11*r - 252*s**2 + 137*s - 63) + 84*r*s - 21*r + 212*s**2 - 127*s + 53)) + 40*Dd**2*f**2*(C*(-33*r*(4*s - 1) - 756*s**2 + 411*s - 11) + 63*r*(4*s - 1) + 636*s**2 - 381*s + 21)))/(630*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**5*k1*(-99*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) - 11*b1*(D1**2*(10*f**2*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + f*(-140*fd**2*s*(3*s - 2) - 90*fd*(s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) - 45*fdd*(2*s**2 - 2*s + 1) + 9*s**2*(28*bd1 - 14*bdd1)) - 18*fd*s*(14*bd1 + 5*fd)*(s - 1)) + D1*f*(2*Dd*(70*f**2*(4*s**2 - 2*s + 1) - 5*f*(14*fd*(12*s**2 - 7*s + 1) + s**2*(72*bd1 - 36) - s*(18*bd1 - 18) - 9) - (36*s - 9)*(14*bd1*s + 5*fd*(2*s - 1))) - 5*Ddd*f*(14*f + 9)*(4*s**2 - 2*s + 1)) - 30*Dd**2*f**2*s*(14*f + 9)*(2*s - 1)) + f*(D1**2*(198*bd1*s*(7*bd1*s + 5*fd*(2*s - 1)) - 35*f**2*(18*fd*(4*s**2 - 2*s + 1) - 9*fdd*(4*s**2 - 2*s + 1) + s**2*(44*bd1 - 22*bdd1)) + 5*f*s*(198*bd1**2*s + 22*bd1*(14*fd*(3*s - 1) - 9*s) + 99*bdd1*s + 378*fd**2*(2*s - 1))) - 5*D1*f*(2*Dd*(99*bd1*s*(1 - 4*s) + 63*f**2*(4*s**2 - 2*s + 1) - 7*f*(4*s - 1)*(22*bd1*s + 36*fd*s - 9*fd)) - 63*Ddd*f**2*(4*s**2 - 2*s + 1)) + 1890*Dd**2*f**3*s*(2*s - 1)))/(770*d**2*k2**2) - 2*D1**2*Pk1*Pkd2*ct**5*k2**4*st**2*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 10*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(21*d**2*k1*k3**4) - 2*D1**2*Pk1*Pkd2*ct**5*k2**4*(D1*f*(-7*D1*bd1**2*(2*s - 1)*(r + s - 1) + bd1*(D1*(f*(3*s - 10)*(r + s - 1) - 5*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) - 5*f*(D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1))) + 7*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(-7*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + 6*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 6*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 7*D1**2*f*fd - 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*s**2 + 5*D1**2*f*fdd*s - 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*s**2 + 5*D1**2*fd**2*s + 12*D1*Dd*f**2*r*s - 3*D1*Dd*f**2*r + 12*D1*Dd*f**2*s**2 - 9*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 80*D1*Dd*f*fd*r*s + 10*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 50*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 20*D1*Ddd*f**2*r*s + 5*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 15*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + 7*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 60*Dd**2*f**2*r*s + 15*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 45*Dd**2*f**2*s - 5*Dd**2*f**2))/(35*d**2*k1*k3**4) - D1**2*Pk1*Pkd2*ct**5*k2**2*st**2*(9*b1*(D1**2*(f*(6*fd*(r*(32*C - 32)*(2*s - 1) + 50*s**2 - 50*s + 25) - 5*fdd*(r*(8*C - 8)*(2*s - 1) + 30*s**2 - 30*s + 15)) - 10*fd**2*(r*(4*C - 4)*(2*s - 1) + s*(15*s - 15))) + D1*f*(2*Dd*(f*(r*(96*C - 96)*(4*s - 1) + 300*s**2 - s*(96*C + 54) + 75) - 5*fd*(4*C*(2*r*(8*s - 3) - 2*s + 1) - 8*r*(8*s - 3) + 120*s**2 - 82*s + 11)) - 5*Ddd*f*(r*(8*C - 8)*(4*s - 1) + 60*s**2 - s*(8*C + 22) + 15)) - 10*Dd**2*f**2*(4*C*(3*r*(4*s - 1) - 3*s + 1) + r*(12 - 48*s) + 90*s**2 - 33*s - 4)) + f*(D1**2*(f*(-45*bdd1*s*(8*C*(r - 1) - 8*r + 15*s + 8) + 2*fd*(r*(592*C - 592)*(3*s - 1) + 1125*s**2 - s*(592*C + 158) + 375) - 5*fdd*(r*(104*C - 104)*(3*s - 1) + 225*s**2 - s*(104*C + 46) + 75)) - 10*fd**2*(52*C*(r*(6*s - 2) - 2*s + 1) - 104*r*(3*s - 1) + 225*s**2 - 46*s - 52)) + 18*D1*bd1*(D1*(3*f*s*(32*C*(r - 1) - 32*r + 25*s + 32) - 5*fd*(4*C*(4*r*s - r - 2*s + 1) - 16*r*s + 4*r + 30*s**2 - 7*s - 4)) - 5*Dd*f*(4*C*(8*r*s - r - 5*s + 1) - 32*r*s + 4*r + 60*s**2 + 5*s - 4)) + D1*f*(2*Dd*(f*(r*(592*C - 592)*(4*s - 1) + 1500*s**2 - s*(592*C + 158) + 375) - 5*fd*(52*C*(r*(24*s - 7) - 7*s + 2) - 52*r*(24*s - 7) + 900*s**2 - 161*s - 29)) - 5*Ddd*f*(r*(104*C - 104)*(4*s - 1) + 300*s**2 - s*(104*C + 46) + 75)) - 10*Dd**2*f**2*(52*C*(3*r*(4*s - 1) - 3*s + 1) - 156*r*(4*s - 1) + 450*s**2 - 69*s - 52)))/(630*d**2*k1*k3**2) - D1**2*Pk1*Pkd2*ct**5*k2**2*(42*D1*b1*bd1*(D1*f*(r*(20*C - 20)*(2*s - 1) + 6*s**2 + s*(14 - 20*C) + 3) + 3*D1*fd*s*(1 - 2*s) - 3*Dd*f*(8*s**2 - 6*s + 1)) + 21*b1**2*(D1**2*s*(fd*r*(40*C - 40) + 6*fd*s - 3*fdd*s) + D1*(2*Dd*f*(r*(20*C - 20)*(4*s - 1) + 12*s**2 + s*(14 - 20*C) + 3) + 6*Dd*fd*s*(1 - 4*s) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f*s*(1 - 2*s)) - 9*b1*(7*D1**2*bdd1*f*(2*s**2 - 2*s + 1) + D1**2*(f*(2*fd*(44*C*s + r*(-4*C*(8*s + 7) + 76*s + 6) + 80*s**2 - 134*s + 45) + fdd*(-16*C*s + 8*r*(4*C*s - 6*s + 1) - 136*s**2 + 162*s - 73)) + 2*fd**2*(4*r*(4*C*s - 6*s + 1) + s*(-8*C - 68*s + 81))) - 2*D1*f*(Dd*(2*f*(r*(8*C - 19)*(4*s - 1) - 80*s**2 + s*(59 - 8*C) - 20) + fd*(-8*C*(2*r*(8*s - 1) - 6*s + 1) + 8*r*(24*s - 5) + 544*s**2 - 484*s + 85)) + 2*Ddd*f*(-r*(4*C - 6)*(4*s - 1) + 68*s**2 + s*(4*C - 40) + 17)) + 8*Dd**2*f**2*(C*(6*r*(4*s - 1) - 6*s + 2) + r*(9 - 36*s) - 102*s**2 + 60*s - 3)) + f*(-126*D1**2*bd1**2*s*(s - 1) - 9*D1**2*bdd1*f*(8*r*(2*C*(s - 1) - 3*s + 2) - 68*s**2 - 2*s + 5) - 5*D1**2*(f*(2*fd*(r*(52*C + 6)*(3*s - 1) + 177*s**2 - s*(52*C + 124) + 59) + fdd*(-r*(16*C + 24)*(3*s - 1) - 285*s**2 + s*(16*C + 214) - 95)) - 2*fd**2*(8*C*(r*(6*s - 2) - 2*s + 1) + 24*r*(3*s - 1) + 285*s**2 - 214*s + 12)) + 18*D1*bd1*(D1*(f*(2*r*(C*(8*s - 22) - 19*s + 22) - 40*s**2 + s*(28*C - 16) + 5) + fd*(-8*C*(r*(4*s - 2) - s + 1) + 4*r*(12*s - 5) + 136*s**2 - 79*s + 12)) + Dd*f*(-8*C*(r*(8*s - 5) - s + 1) + r*(96*s - 44) + 272*s**2 - 76*s + 7)) - 5*D1*f*(2*Dd*(f*(r*(52*C + 6)*(4*s - 1) + 236*s**2 - s*(52*C + 124) + 59) + fd*(-8*C*(r*(24*s - 7) - 7*s + 2) + r*(84 - 288*s) - 1140*s**2 + 749*s - 119)) + Ddd*f*(-r*(16*C + 24)*(4*s - 1) - 380*s**2 + s*(16*C + 214) - 95)) + 10*Dd**2*f**2*(8*C*(3*r*(4*s - 1) - 3*s + 1) + 36*r*(4*s - 1) + 570*s**2 - 321*s + 12)))/(630*d**2*k1*k3**2) - D1**2*Pk1*Pkd2*ct**5*(-792*D1**2*K*bdd1*f**2*r*s - 990*D1**2*bd1**2*f*s*(5*f*(2*s - 1) + 7*s) + 1320*D1**2*bdd1*f**3*r*s + 1595*D1**2*bdd1*f**3*s**2 + 2970*D1**2*bdd1*f**3*s - 1925*D1**2*bdd1*f**3 + 792*D1**2*bdd1*f**2*r*s - 2475*D1**2*bdd1*f**2*s**2 - 8960*D1**2*f**3*fd*r*s + 2240*D1**2*f**3*fd*r - 27720*D1**2*f**3*fd*s**2 + 16100*D1**2*f**3*fd*s - 6930*D1**2*f**3*fd + 4480*D1**2*f**3*fdd*r*s - 1120*D1**2*f**3*fdd*r + 16940*D1**2*f**3*fdd*s**2 - 9590*D1**2*f**3*fdd*s + 4235*D1**2*f**3*fdd + 13440*D1**2*f**2*fd**2*r*s - 3360*D1**2*f**2*fd**2*r + 50820*D1**2*f**2*fd**2*s**2 - 28770*D1**2*f**2*fd**2*s + 1120*D1**2*f**2*fd**2 - 8712*D1**2*f**2*gd2*r*s + 1584*D1**2*f**2*gdd2*r*s - 17424*D1**2*f*fd*g2*r*s + 8712*D1**2*f*fd*g2*r + 8712*D1**2*f*fd*g2*s + 6336*D1**2*f*fd*gd2*r*s - 1584*D1**2*f*fd*gd2*r - 1584*D1**2*f*fd*gd2*s + 3168*D1**2*f*fdd*g2*r*s - 1584*D1**2*f*fdd*g2*r - 1584*D1**2*f*fdd*g2*s + 3168*D1**2*fd**2*g2*r*s - 1584*D1**2*fd**2*g2*r - 1584*D1**2*fd**2*g2*s + 1584*D1**2*fd**2*g2 - 8960*D1*Dd*f**4*r*s + 2240*D1*Dd*f**4*r - 27720*D1*Dd*f**4*s**2 + 16100*D1*Dd*f**4*s - 6930*D1*Dd*f**4 + 35840*D1*Dd*f**3*fd*r*s - 8960*D1*Dd*f**3*fd*r + 135520*D1*Dd*f**3*fd*s**2 - 76720*D1*Dd*f**3*fd*s + 10710*D1*Dd*f**3*fd - 34848*D1*Dd*f**2*g2*r*s + 8712*D1*Dd*f**2*g2*r + 8712*D1*Dd*f**2*g2*s + 12672*D1*Dd*f**2*gd2*r*s - 1584*D1*Dd*f**2*gd2*r - 1584*D1*Dd*f**2*gd2*s + 25344*D1*Dd*f*fd*g2*r*s - 9504*D1*Dd*f*fd*g2*r - 9504*D1*Dd*f*fd*g2*s + 3168*D1*Dd*f*fd*g2 + 4480*D1*Ddd*f**4*r*s - 1120*D1*Ddd*f**4*r + 16940*D1*Ddd*f**4*s**2 - 9590*D1*Ddd*f**4*s + 4235*D1*Ddd*f**4 + 6336*D1*Ddd*f**2*g2*r*s - 1584*D1*Ddd*f**2*g2*r - 1584*D1*Ddd*f**2*g2*s - 22*D1*bd1*f*(D1*(5*f**2*(11*s**2 + s*(24*r + 54) - 35) - f*(5*fd*(12*r*(6*s - 1) + 87*s**2 + 13*s + 8) + 9*s*(r*(22*K - 22) + 25*s)) + 9*fd*(r*(4*K - 4)*(4*s - 1) + s*(-4*K + 50*s - 21)) + 420*g2*s*(r - 1)) - Dd*f*(5*f*(12*r*(8*s - 1) + 116*s**2 + 67*s - 27) - 9*r*(4*K - 4)*(8*s - 1) - 9*s*(-4*K + 100*s - 21))) + 13440*Dd**2*f**4*r*s - 3360*Dd**2*f**4*r + 50820*Dd**2*f**4*s**2 - 28770*Dd**2*f**4*s + 1120*Dd**2*f**4 + 19008*Dd**2*f**2*g2*r*s - 4752*Dd**2*f**2*g2*r - 4752*Dd**2*f**2*g2*s + 1584*Dd**2*f**2*g2 + 165*b1**2*(D1**2*(30*fd**2*s*(1 - 2*s) + 2*fd*(15*f*(4*s**2 - 2*s + 1) + (7*s - 7)*(2*K*r - 2*r + 3*s - 3)) - 3*fdd*(5*f*(4*s**2 - 2*s + 1) + 7*(s - 1)**2)) + D1*(2*Dd*(30*f**2*(4*s**2 - 2*s + 1) - 15*f*fd*(1 - 4*s)**2 + 7*f*(r*(2*K - 2)*(4*s - 1) + 12*s**2 - s*(2*K + 4) + 3) - 21*fd*(4*s**2 - 5*s + 1)) - 3*Ddd*f*(10*f + 7)*(4*s**2 - 2*s + 1)) - 18*Dd**2*f*s*(10*f + 7)*(2*s - 1)) + 11*b1*(792*D1**2*K*f*fd*r*s - 396*D1**2*K*f*fd*r - 396*D1**2*K*f*fd*s - 144*D1**2*K*f*fdd*r*s + 72*D1**2*K*f*fdd*r + 72*D1**2*K*f*fdd*s - 144*D1**2*K*fd**2*r*s + 72*D1**2*K*fd**2*r + 72*D1**2*K*fd**2*s - 72*D1**2*K*fd**2 - 45*D1**2*bdd1*f*(5*f*(4*s**2 - 2*s + 1) + 14*s**2) - 720*D1**2*f**2*fd*r*s + 240*D1**2*f**2*fd*r - 330*D1**2*f**2*fd*s**2 + 1000*D1**2*f**2*fd*s - 460*D1**2*f**2*fd + 360*D1**2*f**2*fdd*r*s - 120*D1**2*f**2*fdd*r + 435*D1**2*f**2*fdd*s**2 - 680*D1**2*f**2*fdd*s + 320*D1**2*f**2*fdd + 720*D1**2*f*fd**2*r*s - 240*D1**2*f*fd**2*r + 870*D1**2*f*fd**2*s**2 - 1360*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 792*D1**2*f*fd*r*s + 396*D1**2*f*fd*r + 900*D1**2*f*fd*s**2 - 504*D1**2*f*fd*s + 450*D1**2*f*fd + 144*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*r - 450*D1**2*f*fdd*s**2 + 378*D1**2*f*fdd*s - 225*D1**2*f*fdd - 840*D1**2*f*gd2*r*s + 144*D1**2*fd**2*r*s - 72*D1**2*fd**2*r - 450*D1**2*fd**2*s**2 + 378*D1**2*fd**2*s + 72*D1**2*fd**2 - 840*D1**2*fd*g2*r*s + 840*D1**2*fd*g2*r + 1584*D1*Dd*K*f**2*r*s - 396*D1*Dd*K*f**2*r - 396*D1*Dd*K*f**2*s - 1152*D1*Dd*K*f*fd*r*s + 432*D1*Dd*K*f*fd*r + 432*D1*Dd*K*f*fd*s - 144*D1*Dd*K*f*fd - 960*D1*Dd*f**3*r*s + 240*D1*Dd*f**3*r - 440*D1*Dd*f**3*s**2 + 460*D1*Dd*f**3*s - 110*D1*Dd*f**3 + 2880*D1*Dd*f**2*fd*r*s - 840*D1*Dd*f**2*fd*r + 3480*D1*Dd*f**2*fd*s**2 - 3950*D1*Dd*f**2*fd*s + 800*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*r*s + 396*D1*Dd*f**2*r + 1800*D1*Dd*f**2*s**2 - 504*D1*Dd*f**2*s + 450*D1*Dd*f**2 + 1152*D1*Dd*f*fd*r*s - 432*D1*Dd*f*fd*r - 3600*D1*Dd*f*fd*s**2 + 2268*D1*Dd*f*fd*s - 306*D1*Dd*f*fd - 3360*D1*Dd*f*g2*r*s + 840*D1*Dd*f*g2*r + 840*D1*Dd*f*g2*s - 288*D1*Ddd*K*f**2*r*s + 72*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s + 480*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r + 580*D1*Ddd*f**3*s**2 - 410*D1*Ddd*f**3*s + 145*D1*Ddd*f**3 + 288*D1*Ddd*f**2*r*s - 72*D1*Ddd*f**2*r - 900*D1*Ddd*f**2*s**2 + 378*D1*Ddd*f**2*s - 225*D1*Ddd*f**2 + 30*D1*bd1*(D1*(15*f**2*(4*s**2 - 2*s + 1) - 60*f*fd*s*(2*s - 1) + 14*f*s*(K*(2*r - 1) - 2*r + 3*s + 1) - 42*fd*s*(s - 1)) - 3*Dd*f*(4*s - 1)*(5*f*(4*s - 1) + 14*s)) - 864*Dd**2*K*f**2*r*s + 216*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s - 72*Dd**2*K*f**2 + 1440*Dd**2*f**3*r*s - 360*Dd**2*f**3*r + 1740*Dd**2*f**3*s**2 - 1230*Dd**2*f**3*s + 120*Dd**2*f**3 + 864*Dd**2*f**2*r*s - 216*Dd**2*f**2*r - 2700*Dd**2*f**2*s**2 + 1134*Dd**2*f**2*s + 72*Dd**2*f**2))/(6930*d**2*k1) + D1**2*Pk1*Pkd2*ct**4*f*k2*st**2*(33*D1*bd1*f*(D1*(f*s*(r - 1) + fd*r*(6*s - 1) - 3*fd*s + fd) + Dd*f*(r*(8*s - 1) - 5*s + 1)) + 33*b1*(D1*Dd*f*(f*r*(4*s - 1) - f*s + fd*r*(24*s - 7) - 3*fd*s + fd) + D1*(D1*r*(3*s - 1)*(f*(fd + fdd) + 2*fd**2) + Ddd*f**2*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(5*D1*Dd*f*(19*f*(4*r*s - r - s) - 30*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(33*bdd1*f*s*(r - 1) + 95*f*fd*(r*(4*s - 1) - s) - 75*f*fdd*(r*(4*s - 1) - s) - 75*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 75*Ddd*f**2*(-4*r*s + r + s)) - 75*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1**2) - 2*D1**2*Pk1*Pkd2*ct**4*k1**4*(9*b1*(D1**2*(f*(3*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(3*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 5*fd*(8*s - 3)*(2*r + 2*s - 1)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(-5*D1**2*(f*(9*bdd1*s*(r + s - 1) - 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(3*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) - 5*D1*f*(Dd*(-5*f*(4*r*s - r + 4*s**2 - 3*s + 1) + 7*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) + 7*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 35*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(315*d**2*k2*k3**4) + 4*D1**2*Pk1*Pkd2*ct**4*k1**2*k2*st**2*(3*b1*(D1**2*(f*(fd*(22*C - 45) + fdd*(33 - 18*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(33 - 18*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(22*C - 45)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(33 - 18*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(33 - 18*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(33 - 18*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(42*C - 83)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (6*C - 11)*(9*bdd1*s*(r + s - 1) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(55 - 30*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(22*C - 45)*(r + s - 1) - fd*(18*C - 33)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(33 - 18*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(42*C - 83)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(30*C - 55)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(55 - 30*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(55 - 30*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) + 2*D1**2*Pk1*Pkd2*ct**4*k1**2*k2*(21*b1**2*(D1**2*s*(r + s)*(fd*(16*C - 29) + fdd*(27 - 18*C)) + D1*(Dd*(f*(16*C - 29)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(18*C - 27)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(27 - 18*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(18*C - 27)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 3*b1*(-63*D1**2*bdd1*f*(2*C - 3)*(2*s - 1)*(r + s - 1) - 3*D1**2*(f*(fd*(C*(28*r*s - 46*r + 28*s**2 - 60*s + 46) + 60*r*s + 25*r + 60*s**2 - 5*s - 25) + 5*fdd*(6*C*(r + s - 1) - 20*r*s + r - 20*s**2 + 11*s - 1)) + 5*fd**2*(r*(6*C - 20*s + 1) + s*(6*C - 20*s + 11))) + 7*D1*bd1*(D1*(f*(16*C - 29)*(2*s - 1)*(r + s - 1) - fd*(18*C - 27)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(54 - 36*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 6*D1*f*(Dd*(f*(7*C + 15)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + 10*fd*(3*C - 20*s + 3)*(2*r + 2*s - 1)) - 25*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 150*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(-189*D1**2*bd1**2*(2*C - 3)*(2*s - 1)*(r + s - 1) + 45*D1**2*bdd1*f*(6*C + 10*s - 9)*(r + s - 1) + 5*D1**2*(-f*(-42*C*fdd + fd*(66*C - 31) - 7*fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(42*C + 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 9*D1*bd1*(D1*(f*(r + s - 1)*(2*C*(7*s + 16) + 30*s - 55) - 5*fd*(6*C*s + r*(6*C + 40*s - 19) + 40*s**2 - 49*s + 10)) - 10*Dd*f*(6*C*(2*r + 2*s - 1) + 40*r*s - 23*r + 40*s**2 - 53*s + 14)) + 5*D1*f*(Dd*(-f*(66*C - 31)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(42*C + 7)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(42*C + 7)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(42*C + 7)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(315*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**4*k1**2*st**2*(6*C - 16)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2*k3**2) + D1**2*Pk1*Pkd2*ct**4*k1**2*(315*b1**2*(C - 2)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 9*b1*(-192*C*D1**2*f*fd*s**2 + 292*C*D1**2*f*fd*s - 146*C*D1**2*f*fd + 110*C*D1**2*f*fdd*s**2 - 160*C*D1**2*f*fdd*s + 80*C*D1**2*f*fdd + 110*C*D1**2*fd**2*s**2 - 160*C*D1**2*fd**2*s - 384*C*D1*Dd*f**2*s**2 + 192*C*D1*Dd*f**2*s - 96*C*D1*Dd*f**2 + 880*C*D1*Dd*f*fd*s**2 - 860*C*D1*Dd*f*fd*s + 160*C*D1*Dd*f*fd + 220*C*D1*Ddd*f**2*s**2 - 110*C*D1*Ddd*f**2*s + 55*C*D1*Ddd*f**2 + 660*C*Dd**2*f**2*s**2 - 330*C*Dd**2*f**2*s - 35*D1**2*bdd1*f*(C - 2)*(2*s**2 - 2*s + 1) + 48*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 200*D1**2*f*fd*s**2 - 400*D1**2*f*fd*s + 200*D1**2*f*fd - 38*D1**2*f*fdd*r*s + 19*D1**2*f*fdd*r - 128*D1**2*f*fdd*s**2 + 228*D1**2*f*fdd*s - 114*D1**2*f*fdd - 38*D1**2*fd**2*r*s + 19*D1**2*fd**2*r - 128*D1**2*fd**2*s**2 + 228*D1**2*fd**2*s + 96*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 400*D1*Dd*f**2*s**2 - 224*D1*Dd*f**2*s + 100*D1*Dd*f**2 - 304*D1*Dd*f*fd*r*s + 114*D1*Dd*f*fd*r - 1024*D1*Dd*f*fd*s**2 + 1206*D1*Dd*f*fd*s - 247*D1*Dd*f*fd - 76*D1*Ddd*f**2*r*s + 19*D1*Ddd*f**2*r - 256*D1*Ddd*f**2*s**2 + 147*D1*Ddd*f**2*s - 64*D1*Ddd*f**2 + 70*D1*bd1*(C - 2)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 228*Dd**2*f**2*r*s + 57*Dd**2*f**2*r - 768*Dd**2*f**2*s**2 + 441*Dd**2*f**2*s - 19*Dd**2*f**2) - f*(630*D1**2*bd1**2*s*(C - 2)*(s - 1) + 9*D1**2*bdd1*f*(-5*C*(11*s**2 + 10*s - 5) + 64*s**2 + s*(19*r + 81) - 50) + 5*D1**2*(f*(2*fd*(99*C*(3*s**2 - 2*s + 1) - 60*r*s + 20*r - 396*s**2 + 284*s - 132) + fdd*(-108*C*(3*s**2 - 2*s + 1) + 87*r*s - 29*r + 450*s**2 - 329*s + 150)) + fd**2*(58*r*(3*s - 1) + s**2*(900 - 648*C) + s*(432*C - 658) + 29)) + 9*D1*bd1*(D1*(2*f*(C*(48*s**2 + 50*s - 25) - 50*s**2 - s*(12*r + 88) + 50) + fd*(19*r*(4*s - 1) - s**2*(220*C - 256) + s*(60*C - 66) + 19)) + Dd*f*(-10*C*(44*s**2 + 9*s - 5) + 19*r*(8*s - 1) + 512*s**2 + 177*s - 81)) + 5*D1*f*(Dd*(2*f*(99*C*(4*s**2 - 2*s + 1) - 20*r*(4*s - 1) - 528*s**2 + 284*s - 132) + fd*(-216*C*(12*s**2 - 7*s + 1) + 29*r*(24*s - 7) + 3600*s**2 - 2303*s + 358)) + Ddd*f*(-108*C*(4*s**2 - 2*s + 1) + 29*r*(4*s - 1) + 600*s**2 - 329*s + 150)) + 5*Dd**2*f**2*(87*r*(4*s - 1) - s**2*(1296*C - 1800) + s*(648*C - 987) + 29)))/(315*d**2*k2*k3**2) + D1**2*Pk1*Pkd2*ct**4*k2**3*st**4*(4*C - 4)*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(7*d**2*k3**4) + 4*D1**2*Pk1*Pkd2*ct**4*k2**3*st**2*(42*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 3*b1*(-64*C*D1**2*f*fd*r*s + 44*C*D1**2*f*fd*r - 64*C*D1**2*f*fd*s**2 + 76*C*D1**2*f*fd*s - 44*C*D1**2*f*fd + 18*C*D1**2*f*fdd*r*s - 15*C*D1**2*f*fdd*r + 18*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 15*C*D1**2*f*fdd + 18*C*D1**2*fd**2*r*s - 15*C*D1**2*fd**2*r + 18*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 128*C*D1*Dd*f**2*r*s + 32*C*D1*Dd*f**2*r - 128*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 32*C*D1*Dd*f**2 + 144*C*D1*Dd*f*fd*r*s - 78*C*D1*Dd*f*fd*r + 144*C*D1*Dd*f*fd*s**2 - 150*C*D1*Dd*f*fd*s + 39*C*D1*Dd*f*fd + 36*C*D1*Ddd*f**2*r*s - 9*C*D1*Ddd*f**2*r + 36*C*D1*Ddd*f**2*s**2 - 27*C*D1*Ddd*f**2*s + 9*C*D1*Ddd*f**2 + 108*C*Dd**2*f**2*r*s - 27*C*Dd**2*f**2*r + 108*C*Dd**2*f**2*s**2 - 81*C*Dd**2*f**2*s + 9*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) - 42*D1**2*f*fd*r*s + 9*D1**2*f*fd*r - 42*D1**2*f*fd*s**2 + 30*D1**2*f*fd*s - 9*D1**2*f*fd + 42*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 15*D1**2*f*fdd + 42*D1**2*fd**2*r*s - 15*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s - 84*D1*Dd*f**2*r*s + 21*D1*Dd*f**2*r - 84*D1*Dd*f**2*s**2 + 63*D1*Dd*f**2*s - 21*D1*Dd*f**2 + 336*D1*Dd*f*fd*r*s - 102*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 270*D1*Dd*f*fd*s + 51*D1*Dd*f*fd + 84*D1*Ddd*f**2*r*s - 21*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 63*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 + 14*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 252*Dd**2*f**2*r*s - 63*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 189*Dd**2*f**2*s + 21*Dd**2*f**2) + f*(-204*C*D1**2*f*fd*r*s + 68*C*D1**2*f*fd*r - 204*C*D1**2*f*fd*s**2 + 204*C*D1**2*f*fd*s - 68*C*D1**2*f*fd + 75*C*D1**2*f*fdd*r*s - 25*C*D1**2*f*fdd*r + 75*C*D1**2*f*fdd*s**2 - 75*C*D1**2*f*fdd*s + 25*C*D1**2*f*fdd + 150*C*D1**2*fd**2*r*s - 50*C*D1**2*fd**2*r + 150*C*D1**2*fd**2*s**2 - 150*C*D1**2*fd**2*s + 25*C*D1**2*fd**2 - 272*C*D1*Dd*f**2*r*s + 68*C*D1*Dd*f**2*r - 272*C*D1*Dd*f**2*s**2 + 204*C*D1*Dd*f**2*s - 68*C*D1*Dd*f**2 + 600*C*D1*Dd*f*fd*r*s - 175*C*D1*Dd*f*fd*r + 600*C*D1*Dd*f*fd*s**2 - 525*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 100*C*D1*Ddd*f**2*r*s - 25*C*D1*Ddd*f**2*r + 100*C*D1*Ddd*f**2*s**2 - 75*C*D1*Ddd*f**2*s + 25*C*D1*Ddd*f**2 + 300*C*Dd**2*f**2*r*s - 75*C*Dd**2*f**2*r + 300*C*Dd**2*f**2*s**2 - 225*C*Dd**2*f**2*s + 25*C*Dd**2*f**2 - 42*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) + 9*D1**2*bdd1*f*(r + s - 1)*(3*C*s + 2*C + 7*s - 2) - 69*D1**2*f*fd*r*s + 23*D1**2*f*fd*r - 69*D1**2*f*fd*s**2 + 69*D1**2*f*fd*s - 23*D1**2*f*fd + 75*D1**2*f*fdd*r*s - 25*D1**2*f*fdd*r + 75*D1**2*f*fdd*s**2 - 75*D1**2*f*fdd*s + 25*D1**2*f*fdd + 150*D1**2*fd**2*r*s - 50*D1**2*fd**2*r + 150*D1**2*fd**2*s**2 - 150*D1**2*fd**2*s + 25*D1**2*fd**2 - 92*D1*Dd*f**2*r*s + 23*D1*Dd*f**2*r - 92*D1*Dd*f**2*s**2 + 69*D1*Dd*f**2*s - 23*D1*Dd*f**2 + 600*D1*Dd*f*fd*r*s - 175*D1*Dd*f*fd*r + 600*D1*Dd*f*fd*s**2 - 525*D1*Dd*f*fd*s + 100*D1*Dd*f*fd + 100*D1*Ddd*f**2*r*s - 25*D1*Ddd*f**2*r + 100*D1*Ddd*f**2*s**2 - 75*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r + s - 1)*(4*C*(8*s + 3) + 21*s - 12) - 3*fd*(C*(12*r*s - r + 12*s**2 - 10*s + 3) + 28*r*s - 9*r + 28*s**2 - 30*s + 7)) - 3*Dd*f*(C*(24*r*s + 5*r + 24*s**2 - 13*s - 1) + 56*r*s - 15*r + 56*s**2 - 57*s + 11)) + 300*Dd**2*f**2*r*s - 75*Dd**2*f**2*r + 300*Dd**2*f**2*s**2 - 225*Dd**2*f**2*s + 25*Dd**2*f**2))/(105*d**2*k3**4) - 2*D1**2*Pk1*Pkd2*ct**4*k2**3*(-3*D1*f*(7*D1*bd1**2*(2*C + 3)*(2*s - 1)*(r + s - 1) + D1*bd1*(-f*(r + s - 1)*(C*(20*s - 34) - 5*s - 9) + fd*(10*C + 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + 5*D1*bdd1*f*(2*C + 3)*(s - 1)*(r + s - 1) + 5*Dd*bd1*f*(2*C + 3)*(r*(8*s - 5) + 8*s**2 - 11*s + 3) + f*(10*C + 10)*(D1*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1))) + 7*b1**2*(D1**2*s*(r + s)*(fd*(22*C + 3) - fdd*(6*C + 9)) + D1*(Dd*(f*(22*C + 3)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C + 9)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(-6*C - 9)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(6*C + 9)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*C + 3)*(2*s - 1)*(r + s - 1) - 3*D1**2*(f*fd*(-2*C*(r*(20*s + 7) + 20*s**2 - 3*s - 7) + 2*r*(5*s - 7) + 10*s**2 - 19*s + 14) + f*fdd*s*(10*C + 15)*(2*r + 2*s - 1) + fd**2*s*(10*C + 15)*(2*r + 2*s - 1)) + 7*D1*bd1*(D1*(f*(22*C + 3)*(2*s - 1)*(r + s - 1) - fd*(6*C + 9)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(-12*C - 18)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 15*D1*f*(Dd*(f*(4*C - 1)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(2*C + 3)*(8*s - 1)*(2*r + 2*s - 1)) - Ddd*f*(2*C + 3)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f**2*(10*C + 15)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**4*k2*st**4*(9*C - 9)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**4*k2*st**2*(630*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 9*b1*(-352*C*D1**2*f*fd*r*s + 176*C*D1**2*f*fd*r - 676*C*D1**2*f*fd*s**2 + 796*C*D1**2*f*fd*s - 398*C*D1**2*f*fd + 176*C*D1**2*f*fdd*r*s - 88*C*D1**2*f*fdd*r + 422*C*D1**2*f*fdd*s**2 - 482*C*D1**2*f*fdd*s + 241*C*D1**2*f*fdd + 176*C*D1**2*fd**2*r*s - 88*C*D1**2*fd**2*r + 422*C*D1**2*fd**2*s**2 - 482*C*D1**2*fd**2*s - 704*C*D1*Dd*f**2*r*s + 176*C*D1*Dd*f**2*r - 1352*C*D1*Dd*f**2*s**2 + 852*C*D1*Dd*f**2*s - 338*C*D1*Dd*f**2 + 1408*C*D1*Dd*f*fd*r*s - 528*C*D1*Dd*f*fd*r + 3376*C*D1*Dd*f*fd*s**2 - 2948*C*D1*Dd*f*fd*s + 570*C*D1*Dd*f*fd + 352*C*D1*Ddd*f**2*r*s - 88*C*D1*Ddd*f**2*r + 844*C*D1*Ddd*f**2*s**2 - 510*C*D1*Ddd*f**2*s + 211*C*D1*Ddd*f**2 + 1056*C*Dd**2*f**2*r*s - 264*C*Dd**2*f**2*r + 2532*C*Dd**2*f**2*s**2 - 1530*C*Dd**2*f**2*s + 88*C*Dd**2*f**2 - 70*D1**2*bdd1*f*(C - 1)*(2*s**2 - 2*s + 1) + 412*D1**2*f*fd*r*s - 206*D1**2*f*fd*r + 176*D1**2*f*fd*s**2 - 296*D1**2*f*fd*s + 148*D1**2*f*fd - 206*D1**2*f*fdd*r*s + 103*D1**2*f*fdd*r - 172*D1**2*f*fdd*s**2 + 232*D1**2*f*fdd*s - 116*D1**2*f*fdd - 206*D1**2*fd**2*r*s + 103*D1**2*fd**2*r - 172*D1**2*fd**2*s**2 + 232*D1**2*fd**2*s + 824*D1*Dd*f**2*r*s - 206*D1*Dd*f**2*r + 352*D1*Dd*f**2*s**2 - 382*D1*Dd*f**2*s + 88*D1*Dd*f**2 - 1648*D1*Dd*f*fd*r*s + 618*D1*Dd*f*fd*r - 1376*D1*Dd*f*fd*s**2 + 1478*D1*Dd*f*fd*s - 335*D1*Dd*f*fd - 412*D1*Ddd*f**2*r*s + 103*D1*Ddd*f**2*r - 344*D1*Ddd*f**2*s**2 + 275*D1*Ddd*f**2*s - 86*D1*Ddd*f**2 + 140*D1*bd1*(C - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 1236*Dd**2*f**2*r*s + 309*Dd**2*f**2*r - 1032*Dd**2*f**2*s**2 + 825*Dd**2*f**2*s - 103*Dd**2*f**2) + f*(-2760*C*D1**2*f*fd*r*s + 920*C*D1**2*f*fd*r - 5394*C*D1**2*f*fd*s**2 + 4516*C*D1**2*f*fd*s - 1798*C*D1**2*f*fd + 1704*C*D1**2*f*fdd*r*s - 568*C*D1**2*f*fdd*r + 3183*C*D1**2*f*fdd*s**2 - 2690*C*D1**2*f*fdd*s + 1061*C*D1**2*f*fdd + 3408*C*D1**2*fd**2*r*s - 1136*C*D1**2*fd**2*r + 6366*C*D1**2*fd**2*s**2 - 5380*C*D1**2*fd**2*s + 568*C*D1**2*fd**2 - 3680*C*D1*Dd*f**2*r*s + 920*C*D1*Dd*f**2*r - 7192*C*D1*Dd*f**2*s**2 + 4516*C*D1*Dd*f**2*s - 1798*C*D1*Dd*f**2 + 13632*C*D1*Dd*f*fd*r*s - 3976*C*D1*Dd*f*fd*r + 25464*C*D1*Dd*f*fd*s**2 - 18830*C*D1*Dd*f*fd*s + 3258*C*D1*Dd*f*fd + 2272*C*D1*Ddd*f**2*r*s - 568*C*D1*Ddd*f**2*r + 4244*C*D1*Ddd*f**2*s**2 - 2690*C*D1*Ddd*f**2*s + 1061*C*D1*Ddd*f**2 + 6816*C*Dd**2*f**2*r*s - 1704*C*Dd**2*f**2*r + 12732*C*Dd**2*f**2*s**2 - 8070*C*Dd**2*f**2*s + 568*C*Dd**2*f**2 - 1260*D1**2*bd1**2*s*(C - 1)*(s - 1) + 9*D1**2*bdd1*f*(C*(211*s**2 + s*(88*r - 28) - 30) - 86*s**2 + s*(43 - 103*r) + 30) + 3474*D1**2*f*fd*r*s - 1158*D1**2*f*fd*r + 1644*D1**2*f*fd*s**2 - 2254*D1**2*f*fd*s + 548*D1**2*f*fd - 2169*D1**2*f*fdd*r*s + 723*D1**2*f*fdd*r - 1308*D1**2*f*fdd*s**2 + 1595*D1**2*f*fdd*s - 436*D1**2*f*fdd - 4338*D1**2*fd**2*r*s + 1446*D1**2*fd**2*r - 2616*D1**2*fd**2*s**2 + 3190*D1**2*fd**2*s - 723*D1**2*fd**2 + 4632*D1*Dd*f**2*r*s - 1158*D1*Dd*f**2*r + 2192*D1*Dd*f**2*s**2 - 2254*D1*Dd*f**2*s + 548*D1*Dd*f**2 - 17352*D1*Dd*f*fd*r*s + 5061*D1*Dd*f*fd*r - 10464*D1*Dd*f*fd*s**2 + 11165*D1*Dd*f*fd*s - 2318*D1*Dd*f*fd - 2892*D1*Ddd*f**2*r*s + 723*D1*Ddd*f**2*r - 1744*D1*Ddd*f**2*s**2 + 1595*D1*Ddd*f**2*s - 436*D1*Ddd*f**2 - 9*D1*bd1*(D1*(2*f*(C*(169*s**2 + s*(88*r - 28) - 30) - 44*s**2 + s*(43 - 103*r) + 30) + fd*(C*(-88*r*(4*s - 1) - 844*s**2 + 538*s - 88) + 103*r*(4*s - 1) + 344*s**2 - 318*s + 103)) + Dd*f*(-2*C*(44*r*(8*s - 1) + 844*s**2 - 311*s + 14) + 103*r*(8*s - 1) + 688*s**2 - 447*s + 43)) - 8676*Dd**2*f**2*r*s + 2169*Dd**2*f**2*r - 5232*Dd**2*f**2*s**2 + 4785*Dd**2*f**2*s - 723*Dd**2*f**2))/(315*d**2*k3**2) - D1**2*Pk1*Pkd2*ct**4*k2*(21*b1**2*(D1**2*s*(fd*(60*C*r + 50*C*s - 66*r - 38*s) + fdd*(-40*C*s + r*(23 - 20*C) + 34*s)) + D1*(Dd*(2*f*(5*C*(24*r*s - 6*r + 20*s**2 - 16*s + 5) - 132*r*s + 33*r - 76*s**2 + 71*s - 19) + fd*(-r*(20*C - 23)*(8*s - 1) + s*(-320*C*s + 100*C + 272*s - 91))) + Ddd*f*(-20*C*(4*r*s - r + 8*s**2 - 5*s + 2) + 92*r*s - 23*r + 136*s**2 - 91*s + 34)) + Dd**2*f*(-20*C*(3*r*(4*s - 1) + 24*s**2 - 15*s + 1) + 69*r*(4*s - 1) + 408*s**2 - 273*s + 23)) + 3*b1*(-7*D1**2*bdd1*f*(20*C*(r*(2*s - 1) + 4*s**2 - 5*s + 2) + r*(23 - 46*s) - 68*s**2 + 91*s - 34) + 3*D1**2*(f*(fd*(4*C*(16*r*s + 21*r - 3*s**2 + 13*s - 21) - 178*r*s - 45*r - 268*s**2 + 286*s - 76) + fdd*(C*(-4*r*(8*s + 7) + 6*s**2 - 82*s + 63) + 124*r*s - 9*r + 218*s**2 - 171*s + 59)) - fd**2*(r*(4*C*(8*s + 7) - 124*s + 9) + s*(C*(82 - 6*s) - 218*s + 171))) + 7*D1*bd1*(D1*(2*f*(5*C*(12*r*s - 6*r + 10*s**2 - 16*s + 5) - 66*r*s + 33*r - 38*s**2 + 71*s - 19) + fd*(-r*(20*C - 23)*(4*s - 1) + s*(-20*C*(8*s - 5) + 136*s - 91))) - 2*Dd*f*(20*C*(8*r*s - 3*r + 16*s**2 - 15*s + 3) - 184*r*s + 69*r - 272*s**2 + 273*s - 57)) + 3*D1*f*(Dd*(f*(-2*C*(r*(16 - 64*s) + 12*s**2 + 10*s + 3) - 356*r*s + 89*r - 536*s**2 + 357*s - 134) - 2*fd*(C*(8*r*(16*s + 5) - 24*s**2 + 154*s - 55) - 496*r*s + 80*r - 872*s**2 + 622*s - 90)) + Ddd*f*(C*(r*(16 - 64*s) + 12*s**2 + 10*s + 3) + 62*r*(4*s - 1) + 436*s**2 - 280*s + 109)) + 6*Dd**2*f**2*(C*(r*(24 - 96*s) + 18*s**2 + 15*s - 8) + 93*r*(4*s - 1) + 654*s**2 - 420*s + 31)) + f*(-21*D1**2*bd1**2*(20*C*(r*(2*s - 1) + 4*s**2 - 5*s + 1) + r*(23 - 46*s) - 68*s**2 + 91*s - 23) - 9*D1**2*bdd1*f*(C*(4*r*(4*s - 11) - 3*s**2 - 92*s + 60) + r*(53 - 62*s) - 109*s**2 + 109*s - 50) - 5*D1**2*(f*(fd*(4*C*(35*r*(3*s - 1) + 81*s**2 - 89*s + 27) - 153*r*s + 51*r + 300*s**2 - 149*s + 100) - fdd*(C*(52*r*(3*s - 1) + 243*s**2 - 214*s + 81) + 45*r*s - 15*r + 231*s**2 - 169*s + 77)) - fd**2*(2*C*(52*r*(3*s - 1) + 243*s**2 - 214*s + 26) + 90*r*s - 30*r + 462*s**2 - 338*s + 15)) + 9*D1*bd1*(D1*(f*(2*C*(16*r*s - 58*r - 3*s**2 - 36*s + 39) - 89*r*s + 134*r - 134*s**2 + 71*s - 58) + fd*(2*C*(r*(30 - 32*s) + 6*s**2 + 51*s - 8) + 248*r*s - 115*r + 436*s**2 - 389*s + 62)) + 2*Dd*f*(C*(-64*r*s + 96*r + 12*s**2 + 189*s - 68) + 248*r*s - 137*r + 436*s**2 - 358*s + 81)) - 5*D1*f*(Dd*(f*(4*C*(35*r*(4*s - 1) + 108*s**2 - 89*s + 27) - 51*r*(4*s - 1) + 400*s**2 - 149*s + 100) - fd*(2*C*(26*r*(24*s - 7) + 972*s**2 - 749*s + 133) + 15*r*(24*s - 7) + 1848*s**2 - 1183*s + 184)) - Ddd*f*(C*(52*r*(4*s - 1) + 324*s**2 - 214*s + 81) + 15*r*(4*s - 1) + 308*s**2 - 169*s + 77)) + 5*Dd**2*f**2*(2*C*(78*r*(4*s - 1) + 486*s**2 - 321*s + 26) + 45*r*(4*s - 1) + 924*s**2 - 507*s + 15)))/(315*d**2*k3**2) - 3*D1**2*Pk1*Pkd2*ct**4*st**2*(D1**2*(25*f**3*(28*fd*(4*s**2 - 2*s + 1) - 14*fdd*(4*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) - 6*f**2*s*(165*bd1**2*s + 11*bd1*(25*fd*(3*s - 1) + s*(6*K - 6)) + 350*fd**2*(2*s - 1) - s*(33*bdd1*(K - 1) + 132*gd2 - 66*gdd2)) + 132*f*(3*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 3*fdd*g2*(2*s**2 - 2*s + 1) + s**2*(7*bd1**2*(K - 1) + 14*bd1*(g2 - gd2) - 7*bdd1*g2)) - 264*fd*g2*s*(7*bd1 + 3*fd)*(s - 1)) + 2*D1*f*(Dd*(350*f**3*(4*s**2 - 2*s + 1) - 25*f**2*(4*s - 1)*(33*bd1*s + 14*fd*(4*s - 1)) + 198*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 132*g2*(4*s - 1)*(7*bd1*s + fd*(6*s - 3))) - Ddd*f*(175*f**2 + 198*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(175*f**2 + 198*g2)*(2*s - 1) + 33*b1**2*(D1**2*(30*f*fd*(2*s**2 - 2*s + 1) - 15*f*fdd*(2*s**2 - 2*s + 1) - 30*fd**2*s*(s - 1) - 28*fd*(K - 1)*(s - 1)**2 + 14*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(15*f**2*(4*s**2 - 2*s + 1) - 15*f*fd*(8*s**2 - 6*s + 1) - 14*f*(K - 1)*(4*s**2 - 2*s + 1) + 14*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-14*K + 15*f + 14)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-14*K + 15*f + 14)) + 33*b1*(D1**2*(5*f**2*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(12*bd1 - 6*bdd1)) - 2*f*(25*fd**2*s*(3*s - 2) + 6*fd*(K*(2*s**2 - 2*s + 1) + s**2*(10*bd1 - 2) + s*(2 - 5*bd1) - 1) - 3*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(-14*K*bdd1 + 28*bd1*(K - 1) + 14*bdd1 - 28*gd2 + 14*gdd2)) + (4*s - 4)*(3*fd**2*s*(K - 1) + 14*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(25*f**3*(4*s**2 - 2*s + 1) + f**2*(-6*K*(4*s**2 - 2*s + 1) - 25*fd*(12*s**2 - 7*s + 1) - 6*s**2*(20*bd1 - 4) - 6*s*(2 - 5*bd1) + 6) + 2*f*(3*fd*(K - 1)*(8*s**2 - 6*s + 1) + 14*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(14*K*bd1 - 14*bd1 - 14*gd2)) - 28*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(25*f**2 - 6*f*(K - 1) + 28*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(25*f**2 - 6*f*(K - 1) + 28*g2)))/(770*d**2*k2) - D1**2*Pk1*Pkd2*ct**4*(-17094*D1**2*K*bd1**2*f*s**2 - 6930*D1**2*K*bd1**2*f*s + 14454*D1**2*K*bd1*f**2*s**2 - 31680*D1**2*K*bd1*f*fd*s**2 + 15840*D1**2*K*bd1*f*fd*s - 7920*D1**2*K*bdd1*f**2*s**2 + 2772*D1**2*bd1**2*f**2*r*s - 7326*D1**2*bd1**2*f**2*s**2 + 13464*D1**2*bd1**2*f**2*s + 2772*D1**2*bd1**2*f*r*s + 3234*D1**2*bd1**2*f*s**2 + 5544*D1**2*bd1**2*f*s - 23100*D1**2*bd1**2*g2*s**2 + 23100*D1**2*bd1**2*g2*s - 6930*D1**2*bd1*bd2*f*s**2 - 3740*D1**2*bd1*f**3*r*s - 12210*D1**2*bd1*f**3*s**2 - 13530*D1**2*bd1*f**3*s + 7700*D1**2*bd1*f**3 + 17160*D1**2*bd1*f**2*fd*r*s - 2860*D1**2*bd1*f**2*fd*r + 45540*D1**2*bd1*f**2*fd*s**2 - 5500*D1**2*bd1*f**2*fd*s + 1430*D1**2*bd1*f**2*fd - 3564*D1**2*bd1*f**2*r*s - 4554*D1**2*bd1*f**2*s**2 + 7128*D1**2*bd1*f*fd*r*s - 1782*D1**2*bd1*f*fd*r + 11880*D1**2*bd1*f*fd*s**2 - 7722*D1**2*bd1*f*fd*s - 29568*D1**2*bd1*f*g2*s**2 - 27720*D1**2*bd1*f*g2*s + 13860*D1**2*bd1*f*g2 + 34188*D1**2*bd1*f*gd2*s**2 + 13860*D1**2*bd1*f*gd2*s + 34188*D1**2*bd1*fd*g2*s**2 - 34188*D1**2*bd1*fd*g2*s + 4950*D1**2*bd2*f**2*s**2 - 9900*D1**2*bd2*f*fd*s**2 + 4950*D1**2*bd2*f*fd*s + 2860*D1**2*bdd1*f**3*r*s + 7590*D1**2*bdd1*f**3*s**2 + 6270*D1**2*bdd1*f**3*s - 3850*D1**2*bdd1*f**3 + 1782*D1**2*bdd1*f**2*r*s + 2970*D1**2*bdd1*f**2*s**2 + 17094*D1**2*bdd1*f*g2*s**2 + 13860*D1**2*bdd1*f*g2*s - 6930*D1**2*bdd1*f*g2 - 2475*D1**2*bdd2*f**2*s**2 - 7560*D1**2*f**3*fd*r*s + 1890*D1**2*f**3*fd*r - 49280*D1**2*f**3*fd*s**2 + 26530*D1**2*f**3*fd*s - 12320*D1**2*f**3*fd + 5320*D1**2*f**3*fdd*r*s - 1330*D1**2*f**3*fdd*r + 27720*D1**2*f**3*fdd*s**2 - 15190*D1**2*f**3*fdd*s + 6930*D1**2*f**3*fdd + 15960*D1**2*f**2*fd**2*r*s - 3990*D1**2*f**2*fd**2*r + 83160*D1**2*f**2*fd**2*s**2 - 45570*D1**2*f**2*fd**2*s + 1330*D1**2*f**2*fd**2 - 28908*D1**2*f**2*gd2*s**2 + 15840*D1**2*f**2*gdd2*s**2 - 57816*D1**2*f*fd*g2*s**2 + 57816*D1**2*f*fd*g2*s - 28908*D1**2*f*fd*g2 + 63360*D1**2*f*fd*gd2*s**2 - 31680*D1**2*f*fd*gd2*s + 31680*D1**2*f*fdd*g2*s**2 - 31680*D1**2*f*fdd*g2*s + 15840*D1**2*f*fdd*g2 + 31680*D1**2*fd**2*g2*s**2 - 31680*D1**2*fd**2*g2*s - 63360*D1*Dd*K*bd1*f**2*s**2 + 15840*D1*Dd*K*bd1*f**2*s + 22880*D1*Dd*bd1*f**3*r*s - 2860*D1*Dd*bd1*f**3*r + 60720*D1*Dd*bd1*f**3*s**2 + 7040*D1*Dd*bd1*f**3*s - 6270*D1*Dd*bd1*f**3 + 14256*D1*Dd*bd1*f**2*r*s - 1782*D1*Dd*bd1*f**2*r + 23760*D1*Dd*bd1*f**2*s**2 - 7722*D1*Dd*bd1*f**2*s + 136752*D1*Dd*bd1*f*g2*s**2 + 21252*D1*Dd*bd1*f*g2*s - 13860*D1*Dd*bd1*f*g2 - 19800*D1*Dd*bd2*f**2*s**2 + 4950*D1*Dd*bd2*f**2*s - 7560*D1*Dd*f**4*r*s + 1890*D1*Dd*f**4*r - 49280*D1*Dd*f**4*s**2 + 26530*D1*Dd*f**4*s - 12320*D1*Dd*f**4 + 42560*D1*Dd*f**3*fd*r*s - 10640*D1*Dd*f**3*fd*r + 221760*D1*Dd*f**3*fd*s**2 - 121520*D1*Dd*f**3*fd*s + 16520*D1*Dd*f**3*fd - 115632*D1*Dd*f**2*g2*s**2 + 57816*D1*Dd*f**2*g2*s - 28908*D1*Dd*f**2*g2 + 126720*D1*Dd*f**2*gd2*s**2 - 31680*D1*Dd*f**2*gd2*s + 253440*D1*Dd*f*fd*g2*s**2 - 190080*D1*Dd*f*fd*g2*s + 31680*D1*Dd*f*fd*g2 + 5320*D1*Ddd*f**4*r*s - 1330*D1*Ddd*f**4*r + 27720*D1*Ddd*f**4*s**2 - 15190*D1*Ddd*f**4*s + 6930*D1*Ddd*f**4 + 63360*D1*Ddd*f**2*g2*s**2 - 31680*D1*Ddd*f**2*g2*s + 15840*D1*Ddd*f**2*g2 + 15960*Dd**2*f**4*r*s - 3990*Dd**2*f**4*r + 83160*Dd**2*f**4*s**2 - 45570*Dd**2*f**4*s + 1330*Dd**2*f**4 + 190080*Dd**2*f**2*g2*s**2 - 95040*Dd**2*f**2*g2*s + 1155*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-5*K*(4*s**2 - 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s + 20*s**2 - 10*s + 5) - D1*Ddd*(-5*K + 3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-5*K + 3*f + 5)) + 33*b1**2*(448*D1**2*K*fd*s**2 - 1316*D1**2*K*fd*s + 658*D1**2*K*fd - 259*D1**2*K*fdd*s**2 + 728*D1**2*K*fdd*s - 364*D1**2*K*fdd - 35*D1**2*bdd1*(-5*K + 3*f + 5)*(3*s**2 - 2*s + 1) - 84*D1**2*f*fd*r*s + 42*D1**2*f*fd*r + 528*D1**2*f*fd*s**2 + 372*D1**2*f*fd*s - 186*D1**2*f*fd + 84*D1**2*f*fdd*r*s - 42*D1**2*f*fdd*r - 222*D1**2*f*fdd*s**2 - 228*D1**2*f*fdd*s + 114*D1**2*f*fdd + 84*D1**2*fd**2*r*s - 42*D1**2*fd**2*r - 222*D1**2*fd**2*s**2 - 228*D1**2*fd**2*s - 84*D1**2*fd*r*s + 84*D1**2*fd*r - 28*D1**2*fd*s**2 + 476*D1**2*fd*s - 238*D1**2*fd + 42*D1**2*fdd*r*s - 42*D1**2*fdd*r + 49*D1**2*fdd*s**2 - 308*D1**2*fdd*s + 154*D1**2*fdd + 700*D1**2*gd2*s**2 - 350*D1**2*gdd2*s**2 + 1792*D1*Dd*K*f*s**2 - 896*D1*Dd*K*f*s + 448*D1*Dd*K*f - 2072*D1*Dd*K*fd*s**2 + 3430*D1*Dd*K*fd*s - 728*D1*Dd*K*fd - 168*D1*Dd*f**2*r*s + 42*D1*Dd*f**2*r + 1056*D1*Dd*f**2*s**2 - 486*D1*Dd*f**2*s + 264*D1*Dd*f**2 + 672*D1*Dd*f*fd*r*s - 252*D1*Dd*f*fd*r - 1776*D1*Dd*f*fd*s**2 - 552*D1*Dd*f*fd*s + 270*D1*Dd*f*fd - 336*D1*Dd*f*r*s + 84*D1*Dd*f*r - 112*D1*Dd*f*s**2 + 140*D1*Dd*f*s - 28*D1*Dd*f + 336*D1*Dd*fd*r*s - 210*D1*Dd*fd*r + 392*D1*Dd*fd*s**2 - 1372*D1*Dd*fd*s + 350*D1*Dd*fd + 2800*D1*Dd*g2*s**2 - 1400*D1*Dd*g2*s + 700*D1*Dd*g2 - 2800*D1*Dd*gd2*s**2 + 700*D1*Dd*gd2*s - 1036*D1*Ddd*K*f*s**2 + 518*D1*Ddd*K*f*s - 259*D1*Ddd*K*f + 168*D1*Ddd*f**2*r*s - 42*D1*Ddd*f**2*r - 444*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 111*D1*Ddd*f**2 + 168*D1*Ddd*f*r*s - 42*D1*Ddd*f*r + 196*D1*Ddd*f*s**2 - 140*D1*Ddd*f*s + 49*D1*Ddd*f - 1400*D1*Ddd*g2*s**2 + 700*D1*Ddd*g2*s - 350*D1*Ddd*g2 + 70*D1*bd1*(D1*(-5*K*(3*s**2 - 2*s + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s + 15*s**2 - 10*s + 5) - Dd*(-5*K + 3*f + 5)*(12*s**2 - 7*s + 1)) - 3108*Dd**2*K*f*s**2 + 1554*Dd**2*K*f*s + 504*Dd**2*f**2*r*s - 126*Dd**2*f**2*r - 1332*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s + 42*Dd**2*f**2 + 504*Dd**2*f*r*s - 126*Dd**2*f*r + 588*Dd**2*f*s**2 - 420*Dd**2*f*s + 42*Dd**2*f - 4200*Dd**2*g2*s**2 + 2100*Dd**2*g2*s) - 11*b1*(-2628*D1**2*K*f*fd*s**2 + 2628*D1**2*K*f*fd*s - 1314*D1**2*K*f*fd + 1440*D1**2*K*f*fdd*s**2 - 1440*D1**2*K*f*fdd*s + 720*D1**2*K*f*fdd + 1440*D1**2*K*fd**2*s**2 - 1440*D1**2*K*fd**2*s - 630*D1**2*b2*fd*s**2 + 1260*D1**2*b2*fd*s - 630*D1**2*b2*fd + 315*D1**2*b2*fdd*s**2 - 630*D1**2*b2*fdd*s + 315*D1**2*b2*fdd + 210*D1**2*bd1**2*s*(3*s - 2)*(-5*K + 3*f + 5) - 630*D1**2*bd2*f*s**2 + 630*D1**2*bd2*fd*s**2 - 630*D1**2*bd2*fd*s + 3*D1**2*bdd1*(3*f**2*(74*s**2 - s*(28*r + 136) + 75) + 7*f*(K*(74*s**2 + 30*s - 15) - 14*s**2 - s*(12*r + 24) + 15) + 350*g2*(2*s**2 - 2*s + 1)) + 315*D1**2*bdd2*f*s**2 + 1020*D1**2*f**2*fd*r*s - 340*D1**2*f**2*fd*r + 3330*D1**2*f**2*fd*s**2 - 3790*D1**2*f**2*fd*s + 1810*D1**2*f**2*fd - 780*D1**2*f**2*fdd*r*s + 260*D1**2*f**2*fdd*r - 2070*D1**2*f**2*fdd*s**2 + 2210*D1**2*f**2*fdd*s - 1040*D1**2*f**2*fdd - 1560*D1**2*f*fd**2*r*s + 520*D1**2*f*fd**2*r - 4140*D1**2*f*fd**2*s**2 + 4420*D1**2*f*fd**2*s - 130*D1**2*f*fd**2 + 648*D1**2*f*fd*r*s - 324*D1**2*f*fd*r + 828*D1**2*f*fd*s**2 - 1152*D1**2*f*fd*s + 414*D1**2*f*fd - 324*D1**2*f*fdd*r*s + 162*D1**2*f*fdd*r - 540*D1**2*f*fdd*s**2 + 702*D1**2*f*fdd*s - 270*D1**2*f*fdd + 2688*D1**2*f*gd2*s**2 - 1554*D1**2*f*gdd2*s**2 - 324*D1**2*fd**2*r*s + 162*D1**2*fd**2*r - 540*D1**2*fd**2*s**2 + 702*D1**2*fd**2*s - 162*D1**2*fd**2 + 2688*D1**2*fd*g2*s**2 - 7896*D1**2*fd*g2*s + 3948*D1**2*fd*g2 - 3108*D1**2*fd*gd2*s**2 + 4368*D1**2*fd*gd2*s - 1554*D1**2*fdd*g2*s**2 + 4368*D1**2*fdd*g2*s - 2184*D1**2*fdd*g2 - 5256*D1*Dd*K*f**2*s**2 + 2628*D1*Dd*K*f**2*s - 1314*D1*Dd*K*f**2 + 11520*D1*Dd*K*f*fd*s**2 - 8640*D1*Dd*K*f*fd*s + 1440*D1*Dd*K*f*fd - 2520*D1*Dd*b2*f*s**2 + 1260*D1*Dd*b2*f*s - 630*D1*Dd*b2*f + 2520*D1*Dd*b2*fd*s**2 - 3150*D1*Dd*b2*fd*s + 630*D1*Dd*b2*fd + 2520*D1*Dd*bd2*f*s**2 - 630*D1*Dd*bd2*f*s + 1360*D1*Dd*f**3*r*s - 340*D1*Dd*f**3*r + 4440*D1*Dd*f**3*s**2 - 2560*D1*Dd*f**3*s + 1110*D1*Dd*f**3 - 6240*D1*Dd*f**2*fd*r*s + 1820*D1*Dd*f**2*fd*r - 16560*D1*Dd*f**2*fd*s**2 + 13760*D1*Dd*f**2*fd*s - 2470*D1*Dd*f**2*fd + 1296*D1*Dd*f**2*r*s - 324*D1*Dd*f**2*r + 1656*D1*Dd*f**2*s**2 - 1152*D1*Dd*f**2*s + 414*D1*Dd*f**2 - 2592*D1*Dd*f*fd*r*s + 972*D1*Dd*f*fd*r - 4320*D1*Dd*f*fd*s**2 + 4212*D1*Dd*f*fd*s - 864*D1*Dd*f*fd + 10752*D1*Dd*f*g2*s**2 - 5376*D1*Dd*f*g2*s + 2688*D1*Dd*f*g2 - 12432*D1*Dd*f*gd2*s**2 + 3108*D1*Dd*f*gd2*s - 12432*D1*Dd*fd*g2*s**2 + 20580*D1*Dd*fd*g2*s - 4368*D1*Dd*fd*g2 + 2880*D1*Ddd*K*f**2*s**2 - 1440*D1*Ddd*K*f**2*s + 720*D1*Ddd*K*f**2 + 1260*D1*Ddd*b2*f*s**2 - 630*D1*Ddd*b2*f*s + 315*D1*Ddd*b2*f - 1040*D1*Ddd*f**3*r*s + 260*D1*Ddd*f**3*r - 2760*D1*Ddd*f**3*s**2 + 1640*D1*Ddd*f**3*s - 690*D1*Ddd*f**3 - 648*D1*Ddd*f**2*r*s + 162*D1*Ddd*f**2*r - 1080*D1*Ddd*f**2*s**2 + 702*D1*Ddd*f**2*s - 270*D1*Ddd*f**2 - 6216*D1*Ddd*f*g2*s**2 + 3108*D1*Ddd*f*g2*s - 1554*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(3*f**2*(-88*s**2 + s*(14*r + 143) - 75) + f*(-7*K*(64*s**2 + 30*s - 15) - 3*fd*(14*r*(4*s - 1) - 148*s**2 + 60*s + 7) + 28*s**2 + 7*s*(12*r + 24) - 105) - 7*fd*(6*r*(2*s - 1) + s**2*(14 - 74*K) + s*(89*K - 32) + 3) - 350*g2*(2*s**2 - 2*s + 1) - 350*gd2*s*(1 - 2*s)) + Dd*(-6*f**2*(56*r*s - 7*r - 148*s**2 + 166*s - 34) - 7*f*(K*(-296*s**2 + 14*s + 15) + 48*r*s - 6*r + 56*s**2 + 28*s - 12) + 350*g2*(8*s**2 - 6*s + 1))) + 8640*Dd**2*K*f**2*s**2 - 4320*Dd**2*K*f**2*s + 3780*Dd**2*b2*f*s**2 - 1890*Dd**2*b2*f*s - 3120*Dd**2*f**3*r*s + 780*Dd**2*f**3*r - 8280*Dd**2*f**3*s**2 + 4920*Dd**2*f**3*s - 260*Dd**2*f**3 - 1944*Dd**2*f**2*r*s + 486*Dd**2*f**2*r - 3240*Dd**2*f**2*s**2 + 2106*Dd**2*f**2*s - 162*Dd**2*f**2 - 18648*Dd**2*f*g2*s**2 + 9324*Dd**2*f*g2*s) + 495*b2*(D1**2*(f*(10*fd*(2*s**2 - 2*s + 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(14*bd1 - 7*bdd1)) - 2*fd*s*(7*bd1 + 5*fd)*(s - 1)) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(7*bd1*s + 5*fd*(2*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(6930*d**2*k2) + D1**2*Pk1*Pkd2*ct**4*k2**3*st**2*(9*D1*bd1*f*(D1*(18*f*s*(r - 1) + 5*fd*(4*r*s - r - 2*s + 1)) + 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) + 9*b1*(D1*Dd*f*(18*f*(4*r*s - r - s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(D1*r*(2*s - 1)*(18*f*fd + 5*f*fdd + 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(146*f*(4*r*s - r - s) - 55*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(146*f*fd*(r*(3*s - 1) - s) + 5*f*(9*bdd1*s*(r - 1) + 11*fdd*(-3*r*s + r + s)) - 55*fd**2*(r*(6*s - 2) - 2*s + 1)) + 55*Ddd*f**2*(-4*r*s + r + s)) - 55*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k1**2*k3**2) + D1**2*Pk1*Pkd2*ct**4*k2**3*(21*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + D1*bd1*(7*b1*(D1*(f*r*(8*s - 4) - 4*f*s + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(f*r*(5*s - 12) + 7*f*s + fd*r*(4*s - 2) - fd*s + fd) + Dd*f*(r*(8*s - 5) - s + 1))) + 3*D1*f**2*(D1*bdd1*r*(s - 1) + 5*D1*fd*(-3*r*s + r + s) + 5*Dd*f*(-4*r*s + r + s)) + 7*b1**2*(D1*Dd*(4*f*r*(4*s - 1) - 4*f*s + 3*fd*r*(8*s - 1) - 3*fd*s) + D1*(D1*r*s*(4*fd + 3*fdd) + 3*Ddd*f*(r*(4*s - 1) - s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1*(D1*Dd*f*(5*f*r*(4*s - 1) - 5*f*s + 2*fd*r*(8*s - 1) - 6*fd*s + fd) + D1*(7*D1*bdd1*f*(r*(2*s - 1) - s) + D1*(f*fd*(r*(10*s + 7) - 12*s) + f*fdd*s*(2*r - 1) + fd**2*s*(2*r - 1)) + Ddd*f**2*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1**2*k3**2) + D1**2*Pk1*Pkd2*ct**4*k2*(D1*f*(9*D1*bd1**2*(3*f*(4*r*s - r - 2*s + 1) + s*(14*r - 7)) + D1*bdd1*f*r*(5*f*(2*s - 1) + 9*s) + bd1*(D1*(35*f**2*r*(2*s - 1) + 5*f*fd*(4*r*(3*s - 1) - 2*s + 1) + 108*f*r*s + 9*fd*r*(4*s - 1) - 9*fd*s) + Dd*f*(5*f*(16*r*s - 6*r - 2*s + 1) + 72*r*s - 9*r - 9*s))) + 3*b1**2*(D1*Dd*(2*f*(3*f + 14)*(r*(4*s - 1) - s) + 3*fd*(3*f*(8*r - 1)*(4*s - 1) + 7*r*(8*s - 5) - 7*s + 7)) + D1*(D1*r*(3*f*fd*(4*s - 1) + 9*fd**2*(4*s - 1) + 28*fd*(s - 1) + 3*fdd*(12*f*s - 3*f + 7*s - 7)) + 3*Ddd*f*(6*f + 7)*(r*(4*s - 1) - s)) + 3*Dd**2*f*(6*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(2*f*(35*f + 54)*(r*(4*s - 1) - s) + fd*(5*f*(48*r*s - 10*r - 14*s + 3) + 144*r*s - 54*r - 54*s + 18)) + 3*D1*bd1*(D1*(f*(3*f*r*(4*s - 1) - 6*f*s + s*(56*r - 28)) + 3*fd*(3*f*(4*r - 1)*(4*s - 1) + 7*r*(4*s - 2) - 7*s + 7)) + 3*Dd*f*(3*f*(8*r - 3)*(4*s - 1) + 14*r*(8*s - 1) - 42*s + 7)) + D1*(D1*(f*fd*(35*f*r*(6*s - 1) + 108*r*(2*s - 1) + s*(-70*f - 108)) + f*(27*bdd1*f*(r*(4*s - 1) - 2*s) + 63*bdd1*s*(2*r - 1) + fdd*r*(5*f*(6*s - 1) + 18*s - 9) - fdd*s*(10*f + 9)) + fd**2*(5*f*(2*r*(6*s - 1) - 4*s + 1) + 9*r*(2*s - 1) - 9*s + 9)) + Ddd*f**2*(10*f + 9)*(r*(4*s - 1) - s)) + Dd**2*f**2*(10*f + 9)*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k1**2) - 3*D1**2*Pk1*Pkd2*ct**3*f*st**4*(11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(4*s**2 - 2*s + 1) - 5*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + 2*fd*s*(bd1*(11 - 33*s) + 15*fd*(1 - 2*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(11*bd1*s + 5*fd*(4*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(22*d**2*k1) + D1**2*Pk1*Pkd2*ct**3*k1**3*st**2*(4*C - 16)*(b1*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 9*fd*(8*s - 3)*(2*r + 2*s - 1)) - 9*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 9*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(7*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 5*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) + 2*D1**2*Pk1*Pkd2*ct**3*k1**3*(21*b1**2*(D1**2*s*(r + s)*(fd*(2*C - 10) + fdd*(15 - 6*C)) + D1*(Dd*(f*(2*C - 10)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C - 15)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(15 - 6*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(6*C - 15)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 3*b1*(-21*D1**2*bdd1*f*(2*C - 5)*(2*s - 1)*(r + s - 1) - 3*D1**2*(f*(fd*(-6*C*(r + s - 1) + 30*r*s + 7*r + 30*s**2 - 8*s - 7) + 5*fdd*(2*C*(r + s - 1) - 5*s*(2*r + 2*s - 1))) + 5*fd**2*(2*C*(r + s) - 5*s*(2*r + 2*s - 1))) + 7*D1*bd1*(D1*(f*(2*C - 10)*(2*s - 1)*(r + s - 1) - fd*(6*C - 15)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(30 - 12*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 15*D1*f*(Dd*(3*f*(4*r*s - r + 4*s**2 - 3*s + 1) + fd*(4*C - 40*s + 5)*(2*r + 2*s - 1)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 75*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(70*C*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) - 63*D1**2*bd1**2*(2*C - 5)*(2*s - 1)*(r + s - 1) + 45*D1**2*bdd1*f*(2*C + 5*s - 5)*(r + s - 1) + 5*D1**2*(14*C*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - f*(-14*C*fdd + fd*(10*C - 9))*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - 9*D1*bd1*(D1*(f*(6*C + 15*s - 22)*(r + s - 1) - 5*fd*(2*C*s + 2*r*(C + 10*s - 5) + 20*s**2 - 25*s + 5)) - 5*Dd*f*(C*(8*r + 8*s - 4) + 40*r*s - 25*r + 40*s**2 - 55*s + 15)) + 5*D1*f*(14*C*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + Dd*(14*C*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4) - f*(10*C - 9)*(4*r*s - r + 4*s**2 - 3*s + 1)))))/(315*d**2*k3**4) - 3*D1**2*Pk1*Pkd2*ct**3*k1**3*st**2*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2**2*k3**2) - D1**2*Pk1*Pkd2*ct**3*k1**3*(63*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 9*b1*(-7*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 16*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 18*D1**2*f*fd + 8*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 32*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 64*D1*Dd*f*fd*s**2 - 88*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 16*D1*Ddd*f**2*s**2 - 8*D1*Ddd*f**2*s + 4*D1*Ddd*f**2 + 14*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 48*Dd**2*f**2*s**2 - 24*Dd**2*f**2*s) + f*(-126*D1**2*bd1**2*s*(s - 1) + 9*D1**2*bdd1*f*(4*s**2 + 10*s - 5) - 59*D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) - 18*D1*bd1*(D1*f*(4*s**2 + 10*s - 5) - D1*fd*s*(8*s + 1) + Dd*f*(-16*s**2 - 16*s + 5)) - 59*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 354*Dd**2*f**2*s*(1 - 2*s)))/(126*d**2*k2**2*k3**2) + 2*D1**2*Pk1*Pkd2*ct**3*k1*k2**2*st**4*(b1*(D1**2*(f*(fd*(46*C - 76) + fdd*(45 - 30*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(45 - 30*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(46*C - 76)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(45 - 30*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(45 - 30*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(45 - 30*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(18*C - 28)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (10*C - 15)*(3*bdd1*s*(r + s - 1) + fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(15 - 10*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(46*C - 76)*(r + s - 1) - fd*(30*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(45 - 30*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(18*C - 28)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(10*C - 15)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(15 - 10*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(15 - 10*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(35*d**2*k3**4) + 4*D1**2*Pk1*Pkd2*ct**3*k1*k2**2*st**2*(7*b1**2*(D1**2*s*(r + s)*(fd*(13*C - 19) + fdd*(12 - 9*C)) + D1*(Dd*(f*(13*C - 19)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(9*C - 12)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(12 - 9*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(9*C - 12)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(-266*C*D1**2*f*fd*r*s + 180*C*D1**2*f*fd*r - 266*C*D1**2*f*fd*s**2 + 313*C*D1**2*f*fd*s - 180*C*D1**2*f*fd + 126*C*D1**2*f*fdd*r*s - 90*C*D1**2*f*fdd*r + 126*C*D1**2*f*fdd*s**2 - 153*C*D1**2*f*fdd*s + 90*C*D1**2*f*fdd + 126*C*D1**2*fd**2*r*s - 90*C*D1**2*fd**2*r + 126*C*D1**2*fd**2*s**2 - 153*C*D1**2*fd**2*s - 532*C*D1*Dd*f**2*r*s + 133*C*D1*Dd*f**2*r - 532*C*D1*Dd*f**2*s**2 + 399*C*D1*Dd*f**2*s - 133*C*D1*Dd*f**2 + 1008*C*D1*Dd*f*fd*r*s - 486*C*D1*Dd*f*fd*r + 1008*C*D1*Dd*f*fd*s**2 - 990*C*D1*Dd*f*fd*s + 243*C*D1*Dd*f*fd + 252*C*D1*Ddd*f**2*r*s - 63*C*D1*Ddd*f**2*r + 252*C*D1*Ddd*f**2*s**2 - 189*C*D1*Ddd*f**2*s + 63*C*D1*Ddd*f**2 + 756*C*Dd**2*f**2*r*s - 189*C*Dd**2*f**2*r + 756*C*Dd**2*f**2*s**2 - 567*C*Dd**2*f**2*s + 63*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(3*C - 4)*(2*s - 1)*(r + s - 1) - 70*D1**2*f*fd*r*s - 30*D1**2*f*fd*r - 70*D1**2*f*fd*s**2 + 5*D1**2*f*fd*s + 30*D1**2*f*fd + 126*D1**2*f*fdd*r*s - 27*D1**2*f*fdd*r + 126*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 27*D1**2*f*fdd + 126*D1**2*fd**2*r*s - 27*D1**2*fd**2*r + 126*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 140*D1*Dd*f**2*r*s + 35*D1*Dd*f**2*r - 140*D1*Dd*f**2*s**2 + 105*D1*Dd*f**2*s - 35*D1*Dd*f**2 + 1008*D1*Dd*f*fd*r*s - 234*D1*Dd*f*fd*r + 1008*D1*Dd*f*fd*s**2 - 738*D1*Dd*f*fd*s + 117*D1*Dd*f*fd + 252*D1*Ddd*f**2*r*s - 63*D1*Ddd*f**2*r + 252*D1*Ddd*f**2*s**2 - 189*D1*Ddd*f**2*s + 63*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(13*C - 19)*(2*s - 1)*(r + s - 1) - fd*(9*C - 12)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(24 - 18*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 756*Dd**2*f**2*r*s - 189*Dd**2*f**2*r + 756*Dd**2*f**2*s**2 - 567*Dd**2*f**2*s + 63*Dd**2*f**2) + f*(-300*C*D1**2*f*fd*r*s + 100*C*D1**2*f*fd*r - 300*C*D1**2*f*fd*s**2 + 300*C*D1**2*f*fd*s - 100*C*D1**2*f*fd + 150*C*D1**2*f*fdd*r*s - 50*C*D1**2*f*fdd*r + 150*C*D1**2*f*fdd*s**2 - 150*C*D1**2*f*fdd*s + 50*C*D1**2*f*fdd + 300*C*D1**2*fd**2*r*s - 100*C*D1**2*fd**2*r + 300*C*D1**2*fd**2*s**2 - 300*C*D1**2*fd**2*s + 50*C*D1**2*fd**2 - 400*C*D1*Dd*f**2*r*s + 100*C*D1*Dd*f**2*r - 400*C*D1*Dd*f**2*s**2 + 300*C*D1*Dd*f**2*s - 100*C*D1*Dd*f**2 + 1200*C*D1*Dd*f*fd*r*s - 350*C*D1*Dd*f*fd*r + 1200*C*D1*Dd*f*fd*s**2 - 1050*C*D1*Dd*f*fd*s + 200*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*r*s - 50*C*D1*Ddd*f**2*r + 200*C*D1*Ddd*f**2*s**2 - 150*C*D1*Ddd*f**2*s + 50*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*r*s - 150*C*Dd**2*f**2*r + 600*C*Dd**2*f**2*s**2 - 450*C*Dd**2*f**2*s + 50*C*Dd**2*f**2 - 21*D1**2*bd1**2*(3*C - 4)*(2*s - 1)*(r + s - 1) + 9*D1**2*bdd1*f*(r + s - 1)*(7*C*s + 3*C + 7*s - 4) + 18*D1**2*f*fd*r*s - 6*D1**2*f*fd*r + 18*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 6*D1**2*f*fd + 45*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r + 45*D1**2*f*fdd*s**2 - 45*D1**2*f*fdd*s + 15*D1**2*f*fdd + 90*D1**2*fd**2*r*s - 30*D1**2*fd**2*r + 90*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s + 15*D1**2*fd**2 + 24*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 18*D1*Dd*f**2*s + 6*D1*Dd*f**2 + 360*D1*Dd*f*fd*r*s - 105*D1*Dd*f*fd*r + 360*D1*Dd*f*fd*s**2 - 315*D1*Dd*f*fd*s + 60*D1*Dd*f*fd + 60*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 45*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + D1*bd1*(D1*(-f*(r + s - 1)*(C*(133*s + 47) + 35*s - 65) + 9*fd*(C*(28*r*s - 4*r + 28*s**2 - 25*s + 7) + 28*r*s - 11*r + 28*s**2 - 32*s + 7)) + 9*Dd*f*(C*(56*r*s + 5*r + 56*s**2 - 37*s + 1) + 56*r*s - 23*r + 56*s**2 - 65*s + 15)) + 180*Dd**2*f**2*r*s - 45*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 135*Dd**2*f**2*s + 15*Dd**2*f**2))/(105*d**2*k3**4) - 2*D1**2*Pk1*Pkd2*ct**3*k1*k2**2*(-3*D1*f*(21*D1*bd1**2*(2*C + 1)*(2*s - 1)*(r + s - 1) + D1*bd1*(-f*(r + s - 1)*(C*(46*s - 74) - 26*s + 19) + fd*(30*C + 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + 15*D1*bdd1*f*(2*C + 1)*(s - 1)*(r + s - 1) + 15*Dd*bd1*f*(2*C + 1)*(r*(8*s - 5) + 8*s**2 - 11*s + 3) + f*(20*C + 5)*(D1*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1))) + 7*b1**2*(D1**2*s*(r + s)*(-18*C*fdd + fd*(46*C - 17) - 9*fdd) + D1*(Dd*(f*(46*C - 17)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(18*C + 9)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(-18*C - 9)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(18*C + 9)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(-63*D1**2*bdd1*f*(2*C + 1)*(2*s - 1)*(r + s - 1) - 3*D1**2*(f*fd*(-2*C*(2*r*(23*s + 7) + 46*s**2 - 9*s - 14) + r*(52*s - 7) + 52*s**2 - 33*s + 7) + f*fdd*s*(30*C + 15)*(2*r + 2*s - 1) + fd**2*s*(30*C + 15)*(2*r + 2*s - 1)) + 7*D1*bd1*(D1*(f*(46*C - 17)*(2*s - 1)*(r + s - 1) - fd*(18*C + 9)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(-36*C - 18)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 3*D1*f*(Dd*(-f*(46*C - 26)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(30*C + 15)*(8*s - 1)*(2*r + 2*s - 1)) + Ddd*f*(30*C + 15)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f**2*(30*C + 15)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**3*k1*st**4*(12*C - 21)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**3*k1*st**2*(315*b1**2*(2*C - 3)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(-368*C*D1**2*f*fd*r*s + 184*C*D1**2*f*fd*r - 2256*C*D1**2*f*fd*s**2 + 2616*C*D1**2*f*fd*s - 1308*C*D1**2*f*fd + 240*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 1296*C*D1**2*f*fdd*s**2 - 1476*C*D1**2*f*fdd*s + 738*C*D1**2*f*fdd + 240*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 1296*C*D1**2*fd**2*s**2 - 1476*C*D1**2*fd**2*s - 736*C*D1*Dd*f**2*r*s + 184*C*D1*Dd*f**2*r - 4512*C*D1*Dd*f**2*s**2 + 2440*C*D1*Dd*f**2*s - 1128*C*D1*Dd*f**2 + 1920*C*D1*Dd*f*fd*r*s - 720*C*D1*Dd*f*fd*r + 10368*C*D1*Dd*f*fd*s**2 - 8736*C*D1*Dd*f*fd*s + 1596*C*D1*Dd*f*fd + 480*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 2592*C*D1*Ddd*f**2*s**2 - 1416*C*D1*Ddd*f**2*s + 648*C*D1*Ddd*f**2 + 1440*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 7776*C*Dd**2*f**2*s**2 - 4248*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 105*D1**2*bdd1*f*(2*C - 3)*(2*s**2 - 2*s + 1) + 776*D1**2*f*fd*r*s - 388*D1**2*f*fd*r + 1404*D1**2*f*fd*s**2 - 1944*D1**2*f*fd*s + 972*D1**2*f*fd - 528*D1**2*f*fdd*r*s + 264*D1**2*f*fdd*r - 954*D1**2*f*fdd*s**2 + 1224*D1**2*f*fdd*s - 612*D1**2*f*fdd - 528*D1**2*fd**2*r*s + 264*D1**2*fd**2*r - 954*D1**2*fd**2*s**2 + 1224*D1**2*fd**2*s + 1552*D1*Dd*f**2*r*s - 388*D1*Dd*f**2*r + 2808*D1*Dd*f**2*s**2 - 1792*D1*Dd*f**2*s + 702*D1*Dd*f**2 - 4224*D1*Dd*f*fd*r*s + 1584*D1*Dd*f*fd*r - 7632*D1*Dd*f*fd*s**2 + 7332*D1*Dd*f*fd*s - 1488*D1*Dd*f*fd - 1056*D1*Ddd*f**2*r*s + 264*D1*Ddd*f**2*r - 1908*D1*Ddd*f**2*s**2 + 1218*D1*Ddd*f**2*s - 477*D1*Ddd*f**2 + 210*D1*bd1*(2*C - 3)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 3168*Dd**2*f**2*r*s + 792*Dd**2*f**2*r - 5724*Dd**2*f**2*s**2 + 3654*Dd**2*f**2*s - 264*Dd**2*f**2) + f*(-630*D1**2*bd1**2*s*(2*C - 3)*(s - 1) + 9*D1**2*bdd1*f*(C*(216*s**2 + s*(40*r + 20) - 30) - 159*s**2 - s*(88*r + 2) + 45) - 2*D1**2*(f*(2*fd*(C*(72*r*(3*s - 1) + 1515*s**2 - 1082*s + 505) - 510*r*s + 170*r - 1011*s**2 + 844*s - 337) + fdd*(C*(-108*r*(3*s - 1) - 1677*s**2 + 1226*s - 559) + 260*r*(3*s - 1) + 1254*s**2 - 1096*s + 418)) + 2*fd**2*(C*(-108*r*(3*s - 1) - 1677*s**2 + 1226*s - 54) + 260*r*(3*s - 1) + 1254*s**2 - 1096*s + 130)) - 6*D1*bd1*(D1*(f*(C*(564*s**2 + s*(92*r + 88) - 90) - 351*s**2 - s*(194*r + 76) + 135) - 6*fd*(C*(10*r*(4*s - 1) + 216*s**2 - 113*s + 10) + r*(22 - 88*s) - 159*s**2 + 101*s - 22)) - 3*Dd*f*(2*C*(10*r*(8*s - 1) + 432*s**2 - 98*s - 5) - 44*r*(8*s - 1) - 636*s**2 + 199*s + 1)) - 2*D1*f*(2*Dd*(f*(C*(72*r*(4*s - 1) + 2020*s**2 - 1082*s + 505) - 170*r*(4*s - 1) - 1348*s**2 + 844*s - 337) + fd*(C*(-54*r*(24*s - 7) - 6708*s**2 + 4291*s - 667) + 130*r*(24*s - 7) + 5016*s**2 - 3836*s + 678)) + Ddd*f*(C*(-108*r*(4*s - 1) - 2236*s**2 + 1226*s - 559) + 260*r*(4*s - 1) + 1672*s**2 - 1096*s + 418)) - 4*Dd**2*f**2*(-3*C*(54*r*(4*s - 1) + 1118*s**2 - 613*s + 18) + 390*r*(4*s - 1) + 2508*s**2 - 1644*s + 130)))/(315*d**2*k3**2) - D1**2*Pk1*Pkd2*ct**3*k1*(84*b1**2*(D1**2*s*(fd*r*(20*C - 31) + fd*s*(40*C - 43) + fdd*r*(18 - 10*C) + fdd*s*(34 - 30*C)) + D1*(Dd*(f*(20*C*(4*r*s - r + 8*s**2 - 5*s + 2) - 124*r*s + 31*r - 172*s**2 + 117*s - 43) + 2*fd*(-r*(5*C - 9)*(8*s - 1) + s*(-120*C*s + 35*C + 136*s - 43))) - 2*Ddd*f*(5*C*(4*r*s - r + 12*s**2 - 7*s + 3) - 36*r*s + 9*r - 68*s**2 + 43*s - 17)) + 2*Dd**2*f*(-5*C*(3*r*(4*s - 1) + 36*s**2 - 21*s + 1) + 27*r*(4*s - 1) + 204*s**2 - 129*s + 9)) + 3*b1*(-56*D1**2*bdd1*f*(5*C*(r*(2*s - 1) + 6*s**2 - 7*s + 3) + r*(9 - 18*s) - 34*s**2 + 43*s - 17) + 3*D1**2*(f*(2*fd*(4*C*(2*r*(4*s + 7) - 6*s**2 + 52*s - 35) - 2*r*(80*s + 21) - 330*s**2 + 184*s - 31) + fdd*(4*C*(-2*r*(4*s + 7) + 6*s**2 - 80*s + 49) + 498*s**2 + s*(272*r - 226) + 45)) - 2*fd**2*(4*C*(r*(4*s + 7) + s*(40 - 3*s)) + s*(-136*r - 249*s + 113))) + 28*D1*bd1*(D1*(f*(20*C*(2*r*s - r + 4*s**2 - 5*s + 2) - 62*r*s + 31*r - 86*s**2 + 117*s - 43) - 2*fd*(r*(5*C - 9)*(4*s - 1) + s*(60*C*s - 35*C - 68*s + 43))) - 4*Dd*f*(5*C*(8*r*s - 3*r + 24*s**2 - 21*s + 4) - 72*r*s + 27*r - 136*s**2 + 129*s - 26)) + 3*D1*f*(2*Dd*(f*(4*C*(4*r*(4*s - 1) - 12*s**2 + 2*s - 3) - 80*r*(4*s - 1) - 660*s**2 + 410*s - 165) + fd*(-4*C*(8*r*(4*s + 3) - 24*s**2 + 162*s - 47) + 136*r*(8*s - 1) + 1992*s**2 - 1086*s + 113)) + Ddd*f*(C*(r*(16 - 64*s) + 48*s**2 - 8*s + 12) + 136*r*(4*s - 1) + 996*s**2 - 634*s + 249)) - 6*Dd**2*f**2*(4*C*(6*r*(4*s - 1) - 18*s**2 + 3*s + 2) - 204*r*(4*s - 1) - 1494*s**2 + 951*s - 68)) + f*(-168*D1**2*bd1**2*(5*C*(r*(2*s - 1) + 6*s**2 - 7*s + 1) + r*(9 - 18*s) - 34*s**2 + 43*s - 9) - 9*D1**2*bdd1*f*(4*C*(2*r*(2*s - 9) - 3*s**2 - 78*s + 46) - 136*r*(s - 1) - 249*s**2 + 408*s - 204) - 5*D1**2*(f*(2*fd*(4*C*(66*r*s - 22*r + 135*s**2 - 112*s + 45) - 162*r*s + 54*r + 123*s**2 - 28*s + 41) - fdd*(4*C*(66*r*s - 22*r + 189*s**2 - 148*s + 63) + 177*s**2 - 118*s + 59)) - 2*fd**2*(4*C*(66*r*s - 22*r + 189*s**2 - 148*s + 11) + 59*s*(3*s - 2))) + 18*D1*bd1*(D1*(f*(4*C*(2*r*(2*s - 9) - 3*s**2 - 50*s + 32) + r*(122 - 80*s) - 165*s**2 + 226*s - 134) + fd*(4*C*(r*(11 - 8*s) + 6*s**2 + 38*s - 2) + 136*r*(2*s - 1) + 498*s**2 - 521*s + 68)) + Dd*f*(4*C*(r*(38 - 16*s) + 12*s**2 + 155*s - 48) + 68*r*(8*s - 5) + 996*s**2 - 1133*s + 272)) - 5*D1*f*(-4*C*Ddd*f*(22*r*(4*s - 1) + 252*s**2 - 148*s + 63) + 2*Dd*f*(4*C*(88*r*s - 22*r + 180*s**2 - 112*s + 45) - 216*r*s + 54*r + 164*s**2 - 28*s + 41) - 2*Dd*fd*(4*C*(264*r*s - 77*r + 756*s**2 - 518*s + 85) + 708*s**2 - 413*s + 59) - 59*Ddd*f*(4*s**2 - 2*s + 1)) + 10*Dd**2*f**2*(4*C*(33*r*(4*s - 1) + 378*s**2 - 222*s + 11) + 177*s*(2*s - 1))))/(630*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**3*k1*st**2*(-99*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) - 11*b1*(D1**2*(10*f**2*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + f*(-100*fd**2*s*(3*s - 2) - 18*fd*(s**2*(20*bd1 - 6) + s*(6 - 10*bd1) - 3) + 9*fdd*(-6*s**2 + 6*s - 3) + 9*s**2*(28*bd1 - 14*bdd1)) - 18*fd*s*(14*bd1 + 3*fd)*(s - 1)) + D1*f*(2*Dd*(50*f**2*(4*s**2 - 2*s + 1) + f*(-50*fd*(12*s**2 - 7*s + 1) + 9*s**2*(12 - 40*bd1) + 9*s*(10*bd1 - 6) + 27) - (36*s - 9)*(14*bd1*s + fd*(6*s - 3))) - Ddd*f*(50*f + 27)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(50*f + 27)*(2*s - 1)) + f*(D1**2*(198*bd1*s*(7*bd1*s + fd*(6*s - 3)) - 25*f**2*(14*fd*(4*s**2 - 2*s + 1) - 7*fdd*(4*s**2 - 2*s + 1) + s**2*(44*bd1 - 22*bdd1)) + f*s*(990*bd1**2*s + 1100*bd1*fd*(3*s - 1) - 594*bd1*s + 297*bdd1*s + 1050*fd**2*(2*s - 1))) + D1*f*(594*Dd*bd1*s*(4*s - 1) - 350*Dd*f**2*(4*s**2 - 2*s + 1) + 50*Dd*f*(4*s - 1)*(22*bd1*s + 7*fd*(4*s - 1)) + 175*Ddd*f**2*(4*s**2 - 2*s + 1)) + 1050*Dd**2*f**3*s*(2*s - 1)))/(385*d**2*k2**2) - D1**2*Pk1*Pkd2*ct**3*k1*(105*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + 3*b1**2*(-35*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) + 12*D1**2*f*fd*s**2 + 588*D1**2*f*fd*s - 294*D1**2*f*fd - 6*D1**2*f*fdd*s**2 - 294*D1**2*f*fdd*s + 147*D1**2*f*fdd - 6*D1**2*fd**2*s**2 - 294*D1**2*fd**2*s - 224*D1**2*fd*s**2 + 868*D1**2*fd*s - 434*D1**2*fd + 112*D1**2*fdd*s**2 - 434*D1**2*fdd*s + 217*D1**2*fdd + 24*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 48*D1*Dd*f*fd*s**2 - 1164*D1*Dd*f*fd*s + 294*D1*Dd*f*fd - 896*D1*Dd*f*s**2 + 448*D1*Dd*f*s - 224*D1*Dd*f + 896*D1*Dd*fd*s**2 - 1960*D1*Dd*fd*s + 434*D1*Dd*fd - 12*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 448*D1*Ddd*f*s**2 - 224*D1*Ddd*f*s + 112*D1*Ddd*f + 70*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) - 36*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s + 1344*Dd**2*f*s**2 - 672*Dd**2*f*s) + b1*(-210*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) + 3*D1**2*bdd1*f*(-6*f*(s**2 - 50*s + 25) + 224*s**2 + 210*s - 105) - 15*D1**2*(7*f**2*(2*fd - fdd)*(13*s**2 - 12*s + 6) + f*(14*fd**2*s*(12 - 13*s) + 54*fd*(2*s**2 - 2*s + 1) - 27*fdd*(2*s**2 - 2*s + 1)) - 54*fd**2*s*(s - 1)) + 6*D1*bd1*(D1*(6*f**2*(s**2 - 50*s + 25) + f*(-s**2*(12*fd + 224) + s*(6*fd - 210) + 105) + 7*fd*s*(32*s - 47)) - Dd*f*(4*s - 1)*(6*f*(s - 25) - 224*s - 105)) - 5*D1*f*(2*Dd*(91*f**2*(4*s**2 - 2*s + 1) - 21*f*fd*(52*s**2 - 37*s + 6) + 81*f*(4*s**2 - 2*s + 1) - 81*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(91*f + 81)*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(91*f + 81)*(2*s - 1)) + f*(6*D1**2*bd1**2*s*(-3*f*(s - 50) + 112*s + 105) - 10*D1*bd1*(D1*(7*f**2*(13*s**2 + 10*s - 5) + 3*f*s*(-91*fd*s + 7*fd + 27*s) + 81*fd*s*(1 - 2*s)) - Dd*f*(4*s - 1)*(7*f*(13*s + 5) + 81*s)) + 5*f*(D1**2*bdd1*(7*f*(13*s**2 + 10*s - 5) + 81*s**2) - 49*D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) - 49*D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) - 294*Dd**2*f**2*s*(1 - 2*s))))/(630*d**2*k2**2) - 2*D1**2*Pk1*Pkd2*ct**3*k2**4*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(7*d**2*k1*k3**4) - 4*D1**2*Pk1*Pkd2*ct**3*k2**4*st**2*(-D1*f*(7*D1*bd1**2*(2*s - 1)*(r + s - 1) + bd1*(D1*(f*(s + 6)*(r + s - 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 3*Dd*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) + 3*f*(D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1))) + 7*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(-7*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + 7*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 7*D1**2*f*fd - 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s - 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 3*D1*Dd*f**2*s - D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 30*D1*Dd*f*fd*s - 3*D1*Dd*f*fd - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 9*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 7*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 27*Dd**2*f**2*s - 3*Dd**2*f**2))/(35*d**2*k1*k3**4) + D1**2*Pk1*Pkd2*ct**3*k2**2*st**4*(-3*b1*(D1**2*(f*(fd*r*(216*C - 216)*(2*s - 1) + 150*fd*(2*s**2 - 2*s + 1) - fdd*r*(80*C - 80)*(2*s - 1) - 75*fdd*(2*s**2 - 2*s + 1)) - 10*fd**2*(r*(8*C - 8)*(2*s - 1) + s*(15*s - 15))) + D1*f*(2*Dd*(3*f*(r*(36*C - 36)*(4*s - 1) + 100*s**2 - s*(36*C + 14) + 25) - 5*fd*(8*C*(2*r*(8*s - 3) - 2*s + 1) - 16*r*(8*s - 3) + 120*s**2 - 74*s + 7)) + 5*Ddd*f*(-r*(16*C - 16)*(4*s - 1) - 60*s**2 + s*(16*C + 14) - 15)) - 10*Dd**2*f**2*(8*C*(3*r*(4*s - 1) - 3*s + 1) + r*(24 - 96*s) + 90*s**2 - 21*s - 8)) + f*(D1**2*(f*(15*bdd1*s*(16*C*(r - 1) - 16*r + 15*s + 16) + fd*(248*C*s - r*(248*C - 248)*(3*s - 1) - 450*s**2 + 52*s - 150) + 5*fdd*(-32*C*s + r*(32*C - 32)*(3*s - 1) + 45*s**2 + 2*s + 15)) + 10*fd**2*(16*C*(6*r*s - 2*r - 2*s + 1) - 96*r*s + 32*r + 45*s**2 + 2*s - 16)) - 6*D1*bd1*(D1*(3*f*s*(36*C*(r - 1) - 36*r + 25*s + 36) - 5*fd*(8*C*(4*r*s - r - 2*s + 1) - 32*r*s + 8*r + 30*s**2 + s - 8)) - 5*Dd*f*(8*C*(8*r*s - r - 5*s + 1) - 64*r*s + 8*r + 60*s**2 + 25*s - 8)) + D1*f*(-2*Dd*(f*(r*(124*C - 124)*(4*s - 1) + 300*s**2 - s*(124*C + 26) + 75) - 5*fd*(16*C*(r*(24*s - 7) - 7*s + 2) - 16*r*(24*s - 7) + 180*s**2 + 7*s - 17)) + 5*Ddd*f*(r*(32*C - 32)*(4*s - 1) + 60*s**2 + s*(2 - 32*C) + 15)) + 10*Dd**2*f**2*(16*C*(3*r*(4*s - 1) - 3*s + 1) - 48*r*(4*s - 1) + 90*s**2 + 3*s - 16)))/(210*d**2*k1*k3**2) - D1**2*Pk1*Pkd2*ct**3*k2**2*st**2*(21*b1**2*(D1**2*s*(fd*(r*(44*C - 44) + 6*s) - 3*fdd*(r*(4*C - 4) + s)) + D1*(2*Dd*(f*(-22*C*s + r*(22*C - 22)*(4*s - 1) + 12*s**2 + 16*s + 3) - 3*fd*(r*(2*C - 2)*(8*s - 1) + s*(-2*C + 4*s + 1))) - 3*Ddd*f*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 4*s**2 + 2*s + 1)) - 6*Dd**2*f*(C*(24*r*s - 6*r - 6*s + 2) - 24*r*s + 6*r + 6*s**2 + 3*s - 2)) + 3*b1*(-56*C*D1**2*f*fd*r*s + 168*C*D1**2*f*fd*r - 140*C*D1**2*f*fd*s - 168*C*D1**2*f*fdd*r*s + 84*C*D1**2*f*fdd*s - 168*C*D1**2*fd**2*r*s + 84*C*D1**2*fd**2*s - 112*C*D1*Dd*f**2*r*s + 28*C*D1*Dd*f**2*r + 28*C*D1*Dd*f**2*s - 1344*C*D1*Dd*f*fd*r*s + 168*C*D1*Dd*f*fd*r + 504*C*D1*Dd*f*fd*s - 84*C*D1*Dd*f*fd - 336*C*D1*Ddd*f**2*r*s + 84*C*D1*Ddd*f**2*r + 84*C*D1*Ddd*f**2*s - 1008*C*Dd**2*f**2*r*s + 252*C*Dd**2*f**2*r + 252*C*Dd**2*f**2*s - 84*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(-4*C*s + r*(4*C - 4)*(2*s - 1) + 2*s**2 + 2*s + 1) - 232*D1**2*f*fd*r*s - 24*D1**2*f*fd*r - 504*D1**2*f*fd*s**2 + 680*D1**2*f*fd*s - 270*D1**2*f*fd + 312*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*r + 420*D1**2*f*fdd*s**2 - 522*D1**2*f*fdd*s + 219*D1**2*f*fdd + 312*D1**2*fd**2*r*s - 72*D1**2*fd**2*r + 420*D1**2*fd**2*s**2 - 522*D1**2*fd**2*s - 464*D1*Dd*f**2*r*s + 116*D1*Dd*f**2*r - 1008*D1*Dd*f**2*s**2 + 620*D1*Dd*f**2*s - 252*D1*Dd*f**2 + 2496*D1*Dd*f*fd*r*s - 600*D1*Dd*f*fd*r + 3360*D1*Dd*f*fd*s**2 - 3240*D1*Dd*f*fd*s + 594*D1*Dd*f*fd + 624*D1*Ddd*f**2*r*s - 156*D1*Ddd*f**2*r + 840*D1*Ddd*f**2*s**2 - 576*D1*Ddd*f**2*s + 210*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(-22*C*s + r*(22*C - 22)*(2*s - 1) + 6*s**2 + 16*s + 3) - 3*fd*(r*(2*C - 2)*(4*s - 1) + s*(-2*C + 2*s + 1))) - 3*Dd*f*(4*C*(8*r*s - 3*r - 3*s + 1) - 32*r*s + 12*r + 8*s**2 + 6*s - 3)) + 1872*Dd**2*f**2*r*s - 468*Dd**2*f**2*r + 2520*Dd**2*f**2*s**2 - 1728*Dd**2*f**2*s + 156*Dd**2*f**2) + f*(-1176*C*D1**2*f*fd*r*s + 392*C*D1**2*f*fd*r + 392*C*D1**2*f*fd*s + 480*C*D1**2*f*fdd*r*s - 160*C*D1**2*f*fdd*r - 160*C*D1**2*f*fdd*s + 960*C*D1**2*fd**2*r*s - 320*C*D1**2*fd**2*r - 320*C*D1**2*fd**2*s + 160*C*D1**2*fd**2 - 1568*C*D1*Dd*f**2*r*s + 392*C*D1*Dd*f**2*r + 392*C*D1*Dd*f**2*s + 3840*C*D1*Dd*f*fd*r*s - 1120*C*D1*Dd*f*fd*r - 1120*C*D1*Dd*f*fd*s + 320*C*D1*Dd*f*fd + 640*C*D1*Ddd*f**2*r*s - 160*C*D1*Ddd*f**2*r - 160*C*D1*Ddd*f**2*s + 1920*C*Dd**2*f**2*r*s - 480*C*Dd**2*f**2*r - 480*C*Dd**2*f**2*s + 160*C*Dd**2*f**2 - 126*D1**2*bd1**2*(C*(4*r*s - 2*r - 2*s + 2) - 4*r*s + 2*r + s**2 + s - 2) - 9*D1**2*bdd1*f*(4*r*(7*C*(s - 1) - 13*s + 7) - 70*s**2 + 18*s + 3) - 132*D1**2*f*fd*r*s + 44*D1**2*f*fd*r - 1110*D1**2*f*fd*s**2 + 784*D1**2*f*fd*s - 370*D1**2*f*fd + 552*D1**2*f*fdd*r*s - 184*D1**2*f*fdd*r + 879*D1**2*f*fdd*s**2 - 770*D1**2*f*fdd*s + 293*D1**2*f*fdd + 1104*D1**2*fd**2*r*s - 368*D1**2*fd**2*r + 1758*D1**2*fd**2*s**2 - 1540*D1**2*fd**2*s + 184*D1**2*fd**2 - 176*D1*Dd*f**2*r*s + 44*D1*Dd*f**2*r - 1480*D1*Dd*f**2*s**2 + 784*D1*Dd*f**2*s - 370*D1*Dd*f**2 + 4416*D1*Dd*f*fd*r*s - 1288*D1*Dd*f*fd*r + 7032*D1*Dd*f*fd*s**2 - 5390*D1*Dd*f*fd*s + 954*D1*Dd*f*fd + 736*D1*Ddd*f**2*r*s - 184*D1*Ddd*f**2*r + 1172*D1*Ddd*f**2*s**2 - 770*D1*Ddd*f**2*s + 293*D1*Ddd*f**2 - 6*D1*bd1*(D1*(f*(-84*C*s + 2*r*(7*C*(s + 5) + 29*s - 35) + 126*s**2 + 30*s - 9) + 3*fd*(14*C*(4*r*s - 2*r - s + 1) - 104*r*s + 40*r - 140*s**2 + 105*s - 26)) + 3*Dd*f*(14*C*(8*r*s - 5*r - s + 1) - 208*r*s + 82*r - 280*s**2 + 132*s - 23)) + 2208*Dd**2*f**2*r*s - 552*Dd**2*f**2*r + 3516*Dd**2*f**2*s**2 - 2310*Dd**2*f**2*s + 184*Dd**2*f**2))/(315*d**2*k1*k3**2) + D1**2*Pk1*Pkd2*ct**3*k2**2*(D1*f*(-14*D1*bd1**2*(r*(8*s - 4) + 31*s**2 - 35*s + 4) + 6*bd1*(-8*C*Dd*f*(r*(8*s - 5) - s + 1) + D1*f*(2*r*(22*C*(s - 1) - 2*s - 5) + 17*s**2 - 20*s + 17) - 2*D1*fd*(4*C*(r*(4*s - 2) - s + 1) + 3*r*(8*s - 4) + 45*s**2 - 51*s + 6) - 3*Dd*f*(4*r*(8*s - 5) + 60*s**2 - 79*s + 19)) - 3*f*(D1*bdd1*(s - 1)*(r*(16*C + 24) + 45*s - 45) + 20*D1*fd*(3*r*s - r - s) + 20*Dd*f*(4*r*s - r - s))) + 7*b1**2*(D1**2*s*(40*C*fd*r - 4*fd*r + 22*fd*s - 8*fdd*r - 31*fdd*s) + D1*(2*Dd*(f*(r*(20*C - 2)*(4*s - 1) + 44*s**2 - s*(20*C + 20) + 11) + fd*(r*(4 - 32*s) + s*(35 - 124*s))) + Ddd*f*(r*(8 - 32*s) - 124*s**2 + 70*s - 31)) - 2*Dd**2*f*(12*r*(4*s - 1) + 186*s**2 - 105*s + 4)) + b1*(-7*D1**2*bdd1*f*(8*r*(2*s - 1) + 62*s**2 - 70*s + 31) + 6*D1**2*(2*f*fd*(r*(s*(44*C - 4) + 7) + s*(-22*C + 17*s - 5)) + f*fdd*s*(-16*C*r + 8*C - 24*r - 45*s + 12) + fd**2*s*(-16*C*r + 8*C - 24*r - 45*s + 12)) + 14*D1*bd1*(D1*(f*(r*(20*C - 2)*(2*s - 1) + 22*s**2 - s*(20*C + 20) + 11) + fd*(r*(4 - 16*s) + s*(35 - 62*s))) + Dd*f*(-8*r*(8*s - 3) - 248*s**2 + 210*s - 39)) + 3*D1*f*(2*Dd*(f*(-44*C*s + r*(44*C - 4)*(4*s - 1) + 68*s**2 - 30*s + 17) - 2*fd*(4*C*(16*r*s - 2*r - 6*s + 1) + 96*r*s - 12*r + 180*s**2 - 81*s + 6)) + Ddd*f*(-r*(16*C + 24)*(4*s - 1) - 180*s**2 + s*(16*C + 114) - 45)) - 6*Dd**2*f**2*(8*C*(3*r*(4*s - 1) - 3*s + 1) + 36*r*(4*s - 1) + 270*s**2 - 171*s + 12)))/(210*d**2*k1*k3**2) - D1**2*Pk1*Pkd2*ct**3*st**2*(-1386*D1**2*K*bdd1*f**2*r*s - 198*D1**2*bd1**2*f*s*(7*K*(2*r - 1) + 25*f*(2*s - 1) - 14*r + 35*s + 7) + 2640*D1**2*bdd1*f**3*r*s + 2695*D1**2*bdd1*f**3*s**2 + 990*D1**2*bdd1*f**3*s - 1375*D1**2*bdd1*f**3 + 1386*D1**2*bdd1*f**2*r*s - 1485*D1**2*bdd1*f**2*s**2 + 2772*D1**2*bdd1*f*g2*r*s - 2772*D1**2*bdd1*f*g2*s - 5760*D1**2*f**3*fd*r*s + 1440*D1**2*f**3*fd*r - 19800*D1**2*f**3*fd*s**2 + 11340*D1**2*f**3*fd*s - 4950*D1**2*f**3*fd + 6400*D1**2*f**3*fdd*r*s - 1600*D1**2*f**3*fdd*r + 12100*D1**2*f**3*fdd*s**2 - 7650*D1**2*f**3*fdd*s + 3025*D1**2*f**3*fdd + 19200*D1**2*f**2*fd**2*r*s - 4800*D1**2*f**2*fd**2*r + 36300*D1**2*f**2*fd**2*s**2 - 22950*D1**2*f**2*fd**2*s + 1600*D1**2*f**2*fd**2 - 4620*D1**2*f**2*gd2*r*s + 2772*D1**2*f**2*gdd2*r*s - 9240*D1**2*f*fd*g2*r*s + 4620*D1**2*f*fd*g2*r + 4620*D1**2*f*fd*g2*s + 11088*D1**2*f*fd*gd2*r*s - 2772*D1**2*f*fd*gd2*r - 2772*D1**2*f*fd*gd2*s + 5544*D1**2*f*fdd*g2*r*s - 2772*D1**2*f*fdd*g2*r - 2772*D1**2*f*fdd*g2*s + 5544*D1**2*fd**2*g2*r*s - 2772*D1**2*fd**2*g2*r - 2772*D1**2*fd**2*g2*s + 2772*D1**2*fd**2*g2 - 5760*D1*Dd*f**4*r*s + 1440*D1*Dd*f**4*r - 19800*D1*Dd*f**4*s**2 + 11340*D1*Dd*f**4*s - 4950*D1*Dd*f**4 + 51200*D1*Dd*f**3*fd*r*s - 12800*D1*Dd*f**3*fd*r + 96800*D1*Dd*f**3*fd*s**2 - 61200*D1*Dd*f**3*fd*s + 9250*D1*Dd*f**3*fd - 18480*D1*Dd*f**2*g2*r*s + 4620*D1*Dd*f**2*g2*r + 4620*D1*Dd*f**2*g2*s + 22176*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r - 2772*D1*Dd*f**2*gd2*s + 44352*D1*Dd*f*fd*g2*r*s - 16632*D1*Dd*f*fd*g2*r - 16632*D1*Dd*f*fd*g2*s + 5544*D1*Dd*f*fd*g2 + 6400*D1*Ddd*f**4*r*s - 1600*D1*Ddd*f**4*r + 12100*D1*Ddd*f**4*s**2 - 7650*D1*Ddd*f**4*s + 3025*D1*Ddd*f**4 + 11088*D1*Ddd*f**2*g2*r*s - 2772*D1*Ddd*f**2*g2*r - 2772*D1*Ddd*f**2*g2*s - 22*D1*bd1*(D1*(f**3*(155*s**2 + s*(132*r + 162) - 125) - 5*f**2*(fd*(24*r*(6*s - 1) + 147*s**2 - 55*s + 16) + 3*s*(r*(7*K - 7) + 9*s)) + 9*f*fd*(r*(7*K - 7)*(4*s - 1) + s*(-7*K + 30*s - 8)) + 42*f*s*(11*g2*(r - 1) - 6*gd2*r + 3*gd2) - 126*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-5*f**2*(24*r*(8*s - 1) + 196*s**2 - 37*s - 9) + 9*f*(r*(7*K - 7)*(8*s - 1) + s*(-7*K + 60*s - 8)) - 126*g2*(r*(8*s - 1) - 5*s + 1))) + 19200*Dd**2*f**4*r*s - 4800*Dd**2*f**4*r + 36300*Dd**2*f**4*s**2 - 22950*Dd**2*f**4*s + 1600*Dd**2*f**4 + 33264*Dd**2*f**2*g2*r*s - 8316*Dd**2*f**2*g2*r - 8316*Dd**2*f**2*g2*s + 2772*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(-150*fd**2*s*(2*s - 1) + 2*fd*(75*f*(4*s**2 - 2*s + 1) + (s - 1)*(7*r*(11*K - 11) + 105*s - 105)) - 3*fdd*(25*f*(4*s**2 - 2*s + 1) + (7*s - 7)*(2*K*r - 2*r + 5*s - 5))) + D1*(2*Dd*(150*f**2*(4*s**2 - 2*s + 1) + f*(-77*K*s - 75*fd*(1 - 4*s)**2 + 7*r*(11*K - 11)*(4*s - 1) + 420*s**2 - 133*s + 105) - 21*fd*(K*r*(8*s - 5) - K*s + K - 8*r*s + 5*r + 20*s**2 - 24*s + 4)) - 3*Ddd*f*(50*f*(4*s**2 - 2*s + 1) + 7*r*(2*K - 2)*(4*s - 1) + 140*s**2 - 7*s*(2*K + 8) + 35)) - 6*Dd**2*f*(7*K*(3*r*(4*s - 1) - 3*s + 1) + 300*f*s**2 - 150*f*s + r*(21 - 84*s) + 210*s**2 - 84*s - 7)) + 11*b1*(420*D1**2*K*f*fd*r*s - 210*D1**2*K*f*fd*r - 210*D1**2*K*f*fd*s - 252*D1**2*K*f*fdd*r*s + 126*D1**2*K*f*fdd*r + 126*D1**2*K*f*fdd*s - 252*D1**2*K*fd**2*r*s + 126*D1**2*K*fd**2*r + 126*D1**2*K*fd**2*s - 126*D1**2*K*fd**2 - 9*D1**2*bdd1*f*(25*f*(4*s**2 - 2*s + 1) + 14*s*(K*(2*r - 1) - 2*r + 5*s + 1)) - 792*D1**2*f**2*fd*r*s + 264*D1**2*f**2*fd*r - 930*D1**2*f**2*fd*s**2 + 1208*D1**2*f**2*fd*s - 560*D1**2*f**2*fd + 720*D1**2*f**2*fdd*r*s - 240*D1**2*f**2*fdd*r + 735*D1**2*f**2*fdd*s**2 - 820*D1**2*f**2*fdd*s + 370*D1**2*f**2*fdd + 1440*D1**2*f*fd**2*r*s - 480*D1**2*f*fd**2*r + 1470*D1**2*f*fd**2*s**2 - 1640*D1**2*f*fd**2*s + 80*D1**2*f*fd**2 - 420*D1**2*f*fd*r*s + 210*D1**2*f*fd*r + 540*D1**2*f*fd*s**2 - 330*D1**2*f*fd*s + 270*D1**2*f*fd + 252*D1**2*f*fdd*r*s - 126*D1**2*f*fdd*r - 270*D1**2*f*fdd*s**2 + 144*D1**2*f*fdd*s - 135*D1**2*f*fdd - 924*D1**2*f*gd2*r*s + 252*D1**2*f*gdd2*r*s + 252*D1**2*fd**2*r*s - 126*D1**2*fd**2*r - 270*D1**2*fd**2*s**2 + 144*D1**2*fd**2*s + 126*D1**2*fd**2 - 924*D1**2*fd*g2*r*s + 924*D1**2*fd*g2*r + 504*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*r + 252*D1**2*fdd*g2*r*s - 252*D1**2*fdd*g2*r + 840*D1*Dd*K*f**2*r*s - 210*D1*Dd*K*f**2*r - 210*D1*Dd*K*f**2*s - 2016*D1*Dd*K*f*fd*r*s + 756*D1*Dd*K*f*fd*r + 756*D1*Dd*K*f*fd*s - 252*D1*Dd*K*f*fd - 1056*D1*Dd*f**3*r*s + 264*D1*Dd*f**3*r - 1240*D1*Dd*f**3*s**2 + 884*D1*Dd*f**3*s - 310*D1*Dd*f**3 + 5760*D1*Dd*f**2*fd*r*s - 1680*D1*Dd*f**2*fd*r + 5880*D1*Dd*f**2*fd*s**2 - 5470*D1*Dd*f**2*fd*s + 1060*D1*Dd*f**2*fd - 840*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r + 1080*D1*Dd*f**2*s**2 - 330*D1*Dd*f**2*s + 270*D1*Dd*f**2 + 2016*D1*Dd*f*fd*r*s - 756*D1*Dd*f*fd*r - 2160*D1*Dd*f*fd*s**2 + 864*D1*Dd*f*fd*s - 18*D1*Dd*f*fd - 3696*D1*Dd*f*g2*r*s + 924*D1*Dd*f*g2*r + 924*D1*Dd*f*g2*s + 2016*D1*Dd*f*gd2*r*s - 252*D1*Dd*f*gd2*r - 252*D1*Dd*f*gd2*s + 2016*D1*Dd*fd*g2*r*s - 1260*D1*Dd*fd*g2*r - 252*D1*Dd*fd*g2*s + 252*D1*Dd*fd*g2 - 504*D1*Ddd*K*f**2*r*s + 126*D1*Ddd*K*f**2*r + 126*D1*Ddd*K*f**2*s + 960*D1*Ddd*f**3*r*s - 240*D1*Ddd*f**3*r + 980*D1*Ddd*f**3*s**2 - 730*D1*Ddd*f**3*s + 245*D1*Ddd*f**3 + 504*D1*Ddd*f**2*r*s - 126*D1*Ddd*f**2*r - 540*D1*Ddd*f**2*s**2 + 144*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r*s - 252*D1*Ddd*f*g2*r - 252*D1*Ddd*f*g2*s + 6*D1*bd1*(D1*(75*f**2*(4*s**2 - 2*s + 1) + f*s*(77*K*(2*r - 1) - 300*fd*(2*s - 1) - 154*r + 210*s + 77) - 21*fd*(K*r*(4*s - 2) - K*s + K + r*(2 - 4*s) + 10*s**2 - 9*s - 1)) - 3*Dd*f*(14*K*r*(8*s - 1) - 42*K*s + 7*K + 25*f*(1 - 4*s)**2 + 7*r*(2 - 16*s) + 280*s**2 - 28*s - 7)) - 1512*Dd**2*K*f**2*r*s + 378*Dd**2*K*f**2*r + 378*Dd**2*K*f**2*s - 126*Dd**2*K*f**2 + 2880*Dd**2*f**3*r*s - 720*Dd**2*f**3*r + 2940*Dd**2*f**3*s**2 - 2190*Dd**2*f**3*s + 240*Dd**2*f**3 + 1512*Dd**2*f**2*r*s - 378*Dd**2*f**2*r - 1620*Dd**2*f**2*s**2 + 432*Dd**2*f**2*s + 126*Dd**2*f**2 + 3024*Dd**2*f*g2*r*s - 756*Dd**2*f*g2*r - 756*Dd**2*f*g2*s + 252*Dd**2*f*g2))/(3465*d**2*k1) - D1**2*Pk1*Pkd2*ct**3*(72*D1**2*K*bdd1*f**2*r*s - 288*D1**2*b2*f*fd*r*s + 144*D1**2*b2*f*fd*r + 144*D1**2*b2*f*fd*s + 144*D1**2*b2*f*fdd*r*s - 72*D1**2*b2*f*fdd*r - 72*D1**2*b2*f*fdd*s + 144*D1**2*b2*fd**2*r*s - 72*D1**2*b2*fd**2*r - 72*D1**2*b2*fd**2*s + 72*D1**2*b2*fd**2 + 6*D1**2*bd1**2*f*(3*f*(4*r*(8*s - 3) + 93*s**2 - 56*s + 8) + r*(28 - 28*K)*(2*s - 1) + 7*s*(28*s + 3)) - 144*D1**2*bd2*f**2*r*s + 288*D1**2*bd2*f*fd*r*s - 72*D1**2*bd2*f*fd*r - 72*D1**2*bd2*f*fd*s + 240*D1**2*bdd1*f**3*r*s - 160*D1**2*bdd1*f**3*r + 630*D1**2*bdd1*f**3*s**2 - 630*D1**2*bdd1*f**3*s + 315*D1**2*bdd1*f**3 + 72*D1**2*bdd1*f**2*r*s + 405*D1**2*bdd1*f**2*s**2 + 336*D1**2*bdd1*f*g2*r*s - 336*D1**2*bdd1*f*g2*r + 72*D1**2*bdd2*f**2*r*s + 792*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gdd2*r*s + 1584*D1**2*f*fd*g2*r*s - 792*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s - 576*D1**2*f*fd*gd2*r*s + 144*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s - 288*D1**2*f*fdd*g2*r*s + 144*D1**2*f*fdd*g2*r + 144*D1**2*f*fdd*g2*s - 288*D1**2*fd**2*g2*r*s + 144*D1**2*fd**2*g2*r + 144*D1**2*fd**2*g2*s - 144*D1**2*fd**2*g2 - 576*D1*Dd*b2*f**2*r*s + 144*D1*Dd*b2*f**2*r + 144*D1*Dd*b2*f**2*s + 1152*D1*Dd*b2*f*fd*r*s - 432*D1*Dd*b2*f*fd*r - 432*D1*Dd*b2*f*fd*s + 144*D1*Dd*b2*f*fd + 576*D1*Dd*bd2*f**2*r*s - 72*D1*Dd*bd2*f**2*r - 72*D1*Dd*bd2*f**2*s + 3168*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r - 792*D1*Dd*f**2*g2*s - 1152*D1*Dd*f**2*gd2*r*s + 144*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s - 2304*D1*Dd*f*fd*g2*r*s + 864*D1*Dd*f*fd*g2*r + 864*D1*Dd*f*fd*g2*s - 288*D1*Dd*f*fd*g2 + 288*D1*Ddd*b2*f**2*r*s - 72*D1*Ddd*b2*f**2*r - 72*D1*Ddd*b2*f**2*s - 576*D1*Ddd*f**2*g2*r*s + 144*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s - 2*D1*bd1*(D1*(5*f**3*(48*r*s - 32*r + 90*s**2 - 90*s + 45) + f**2*(-10*fd*(4*r*(18*s - 7) + 189*s**2 - 138*s + 8) + 9*s*(r*(22*K - 6) + 31*s)) - 9*f*fd*(r*(4*K + 4)*(4*s - 1) + s*(-4*K + 90*s - 49)) + 84*f*(g2*r*(4*s - 9) + 5*g2*s + 2*gd2*r*(1 - 2*s)) - 168*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-5*f**2*(8*r*(24*s - 11) + 504*s**2 - 402*s + 79) - 9*f*(r*(4*K + 4)*(8*s - 1) + s*(-4*K + 180*s - 49)) - 168*g2*(r*(8*s - 5) - s + 1))) + 864*Dd**2*b2*f**2*r*s - 216*Dd**2*b2*f**2*r - 216*Dd**2*b2*f**2*s + 72*Dd**2*b2*f**2 - 1728*Dd**2*f**2*g2*r*s + 432*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s - 144*Dd**2*f**2*g2 + 21*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-30*K*s + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s + r*(30*K - 30)*(4*s - 1) + 20*s**2 + 20*s + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + 3*b1**2*(112*D1**2*K*fd*r*s + 140*D1**2*K*fd*r - 252*D1**2*K*fd*s - 56*D1**2*K*fdd*r*s + 56*D1**2*K*fdd*s - 7*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 384*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 780*D1**2*f*fd*s**2 + 468*D1**2*f*fd*s - 210*D1**2*f*fd + 192*D1**2*f*fdd*r*s - 24*D1**2*f*fdd*r + 558*D1**2*f*fdd*s**2 - 318*D1**2*f*fdd*s + 147*D1**2*f*fdd + 192*D1**2*fd**2*r*s - 24*D1**2*fd**2*r + 558*D1**2*fd**2*s**2 - 318*D1**2*fd**2*s - 112*D1**2*fd*r*s - 140*D1**2*fd*r - 252*D1**2*fd*s**2 + 840*D1**2*fd*s - 294*D1**2*fd + 56*D1**2*fdd*r*s + 196*D1**2*fdd*s**2 - 490*D1**2*fdd*s + 217*D1**2*fdd - 840*D1**2*gd2*r*s + 448*D1*Dd*K*f*r*s - 112*D1*Dd*K*f*r - 112*D1*Dd*K*f*s - 448*D1*Dd*K*fd*r*s + 56*D1*Dd*K*fd*r + 280*D1*Dd*K*fd*s - 56*D1*Dd*K*fd - 768*D1*Dd*f**2*r*s + 192*D1*Dd*f**2*r - 1560*D1*Dd*f**2*s**2 + 972*D1*Dd*f**2*s - 390*D1*Dd*f**2 + 1536*D1*Dd*f*fd*r*s - 288*D1*Dd*f*fd*r + 4464*D1*Dd*f*fd*s**2 - 2580*D1*Dd*f*fd*s + 342*D1*Dd*f*fd - 448*D1*Dd*f*r*s + 112*D1*Dd*f*r - 1008*D1*Dd*f*s**2 + 616*D1*Dd*f*s - 252*D1*Dd*f + 448*D1*Dd*fd*r*s - 56*D1*Dd*fd*r + 1568*D1*Dd*fd*s**2 - 2408*D1*Dd*fd*s + 490*D1*Dd*fd - 3360*D1*Dd*g2*r*s + 840*D1*Dd*g2*r + 840*D1*Dd*g2*s - 224*D1*Ddd*K*f*r*s + 56*D1*Ddd*K*f*r + 56*D1*Ddd*K*f*s + 384*D1*Ddd*f**2*r*s - 96*D1*Ddd*f**2*r + 1116*D1*Ddd*f**2*s**2 - 654*D1*Ddd*f**2*s + 279*D1*Ddd*f**2 + 224*D1*Ddd*f*r*s - 56*D1*Ddd*f*r + 784*D1*Ddd*f*s**2 - 448*D1*Ddd*f*s + 196*D1*Ddd*f + 14*D1*bd1*(D1*(-30*K*s + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s + r*(30*K - 30)*(3*s - 1) + 15*s**2 + 20*s + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) - 672*Dd**2*K*f*r*s + 168*Dd**2*K*f*r + 168*Dd**2*K*f*s - 56*Dd**2*K*f + 1152*Dd**2*f**2*r*s - 288*Dd**2*f**2*r + 3348*Dd**2*f**2*s**2 - 1962*Dd**2*f**2*s + 96*Dd**2*f**2 + 672*Dd**2*f*r*s - 168*Dd**2*f*r + 2352*Dd**2*f*s**2 - 1344*Dd**2*f*s + 56*Dd**2*f) + b1*(-792*D1**2*K*f*fd*r*s + 396*D1**2*K*f*fd*r + 396*D1**2*K*f*fd*s + 144*D1**2*K*f*fdd*r*s - 72*D1**2*K*f*fdd*r - 72*D1**2*K*f*fdd*s + 144*D1**2*K*fd**2*r*s - 72*D1**2*K*fd**2*r - 72*D1**2*K*fd**2*s + 72*D1**2*K*fd**2 - 42*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) + 3*D1**2*bdd1*f*(6*f*(4*r*(8*s - 3) + 93*s**2 - 56*s + 22) - 7*r*(8*K - 8)*(2*s - 1) + 392*s**2 + 42*s - 21) - 1440*D1**2*f**2*fd*r*s + 160*D1**2*f**2*fd*r - 2700*D1**2*f**2*fd*s**2 + 1380*D1**2*f**2*fd*s - 450*D1**2*f**2*fd + 720*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 1890*D1**2*f**2*fdd*s**2 - 870*D1**2*f**2*fdd*s + 315*D1**2*f**2*fdd + 1440*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 3780*D1**2*f*fd**2*s**2 - 1740*D1**2*f*fd**2*s + 80*D1**2*f*fd**2 + 216*D1**2*f*fd*r*s - 108*D1**2*f*fd*r - 1116*D1**2*f*fd*s**2 + 1008*D1**2*f*fd*s - 558*D1**2*f*fd + 144*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*r + 810*D1**2*f*fdd*s**2 - 882*D1**2*f*fdd*s + 405*D1**2*f*fdd - 672*D1**2*f*gd2*r*s + 336*D1**2*f*gdd2*r*s + 144*D1**2*fd**2*r*s - 72*D1**2*fd**2*r + 810*D1**2*fd**2*s**2 - 882*D1**2*fd**2*s + 72*D1**2*fd**2 - 672*D1**2*fd*g2*r*s - 840*D1**2*fd*g2*r + 1512*D1**2*fd*g2*s + 672*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*s + 336*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*s - 1584*D1*Dd*K*f**2*r*s + 396*D1*Dd*K*f**2*r + 396*D1*Dd*K*f**2*s + 1152*D1*Dd*K*f*fd*r*s - 432*D1*Dd*K*f*fd*r - 432*D1*Dd*K*f*fd*s + 144*D1*Dd*K*f*fd - 1920*D1*Dd*f**3*r*s + 480*D1*Dd*f**3*r - 3600*D1*Dd*f**3*s**2 + 2280*D1*Dd*f**3*s - 900*D1*Dd*f**3 + 5760*D1*Dd*f**2*fd*r*s - 1040*D1*Dd*f**2*fd*r + 15120*D1*Dd*f**2*fd*s**2 - 7980*D1*Dd*f**2*fd*s + 950*D1*Dd*f**2*fd + 432*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r - 2232*D1*Dd*f**2*s**2 + 1008*D1*Dd*f**2*s - 558*D1*Dd*f**2 + 1152*D1*Dd*f*fd*r*s - 432*D1*Dd*f*fd*r + 6480*D1*Dd*f*fd*s**2 - 5292*D1*Dd*f*fd*s + 954*D1*Dd*f*fd - 2688*D1*Dd*f*g2*r*s + 672*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s + 2688*D1*Dd*f*gd2*r*s - 336*D1*Dd*f*gd2*r - 336*D1*Dd*f*gd2*s + 2688*D1*Dd*fd*g2*r*s - 336*D1*Dd*fd*g2*r - 1680*D1*Dd*fd*g2*s + 336*D1*Dd*fd*g2 + 288*D1*Ddd*K*f**2*r*s - 72*D1*Ddd*K*f**2*r - 72*D1*Ddd*K*f**2*s + 960*D1*Ddd*f**3*r*s - 240*D1*Ddd*f**3*r + 2520*D1*Ddd*f**3*s**2 - 1500*D1*Ddd*f**3*s + 630*D1*Ddd*f**3 + 288*D1*Ddd*f**2*r*s - 72*D1*Ddd*f**2*r + 1620*D1*Ddd*f**2*s**2 - 882*D1*Ddd*f**2*s + 405*D1*Ddd*f**2 + 1344*D1*Ddd*f*g2*r*s - 336*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s - 6*D1*bd1*(6*D1*f**2*(4*r*(8*s - 3) + 65*s**2 - 42*s + 15) + D1*f*(-6*fd*(16*r*(4*s - 1) + 186*s**2 - 109*s + 4) - 7*r*(2*K - 2)*(8*s - 9) + 252*s**2 - 7*s*(10*K - 16) - 21) + 7*D1*(fd*(4*K*(4*r*s - r - 2*s + 1) - 16*r*s + 4*r - 56*s**2 + 67*s - 4) + 60*g2*(r*(2*s - 1) - s)) - 6*Dd*f**2*(8*r*(16*s - 5) + 372*s**2 - 221*s + 34) + 7*Dd*f*(4*K*(2*r*(8*s - 3) - 2*s + 1) - 8*r*(8*s - 3) - 224*s**2 + 52*s - 1)) + 864*Dd**2*K*f**2*r*s - 216*Dd**2*K*f**2*r - 216*Dd**2*K*f**2*s + 72*Dd**2*K*f**2 + 2880*Dd**2*f**3*r*s - 720*Dd**2*f**3*r + 7560*Dd**2*f**3*s**2 - 4500*Dd**2*f**3*s + 240*Dd**2*f**3 + 864*Dd**2*f**2*r*s - 216*Dd**2*f**2*r + 4860*Dd**2*f**2*s**2 - 2646*Dd**2*f**2*s + 72*Dd**2*f**2 + 4032*Dd**2*f*g2*r*s - 1008*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s + 336*Dd**2*f*g2))/(630*d**2*k1) + D1**2*Pk1*Pkd2*ct**2*f*k2*st**4*(33*D1*bd1*f*(D1*f*s*(r - 1) + D1*fd*(-6*r*s + r + 3*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 33*b1*(D1*Dd*f*(f*(-4*r*s + r + s) + fd*r*(24*s - 7) - 3*fd*s + fd) - D1*(D1*r*(3*s - 1)*(f*(fd - fdd) - 2*fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(23*f*(4*r*s - r - s) - 78*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-33*bdd1*f*s*(r - 1) + 23*f*fd*(r*(4*s - 1) - s) + 39*f*fdd*(-4*r*s + r + s) - 39*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 39*Ddd*f**2*(-4*r*s + r + s)) - 39*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k1**2) - 2*D1**2*Pk1*Pkd2*ct**2*k1**4*st**2*(b1*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 9*fd*(8*s - 3)*(2*r + 2*s - 1)) - 9*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 9*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(7*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 5*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k2*k3**4) - 2*D1**2*Pk1*Pkd2*ct**2*k1**4*(-3*D1*f*(7*D1*bd1**2*(2*s - 1)*(r + s - 1) + D1*bd1*(-3*f*(s - 1)*(r + s - 1) + 5*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + 5*D1*bdd1*f*(s - 1)*(r + s - 1) + 5*Dd*bd1*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) + 7*b1**2*(D1**2*s*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + 3*fd*(-8*r*s + r + s*(3 - 8*s))) - 3*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + 3*D1**2*s*(2*r + 2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 7*D1*bd1*(D1*(f*(2*s - 1)*(r + s - 1) + 3*fd*(-4*r*s + r + s*(3 - 4*s))) - 6*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r*s - r + 4*s**2 - 3*s + 1) + 5*fd*(8*s - 1)*(2*r + 2*s - 1)) + 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 15*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k2*k3**4) + 2*D1**2*Pk1*Pkd2*ct**2*k1**2*k2*st**4*(b1*(D1**2*(f*(fd*(12*C - 35) + fdd*(21 - 6*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(21 - 6*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(12*C - 35)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(21 - 6*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(21 - 6*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(21 - 6*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(4*C - 13)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (2*C - 7)*(3*bdd1*s*(r + s - 1) + fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) - fd**2*(2*C - 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(12*C - 35)*(r + s - 1) - fd*(6*C - 21)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(21 - 6*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(4*C - 13)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(2*C - 7)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) - Ddd*f*(2*C - 7)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f**2*(2*C - 7)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(35*d**2*k3**4) + 2*D1**2*Pk1*Pkd2*ct**2*k1**2*k2*st**2*(7*b1**2*(D1**2*s*(r + s)*(fd*(12*C - 25) + fdd*(15 - 6*C)) + D1*(Dd*(f*(12*C - 25)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C - 15)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(15 - 6*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(6*C - 15)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(-220*C*D1**2*f*fd*r*s + 146*C*D1**2*f*fd*r - 220*C*D1**2*f*fd*s**2 + 256*C*D1**2*f*fd*s - 146*C*D1**2*f*fd + 180*C*D1**2*f*fdd*r*s - 108*C*D1**2*f*fdd*r + 180*C*D1**2*f*fdd*s**2 - 198*C*D1**2*f*fdd*s + 108*C*D1**2*f*fdd + 180*C*D1**2*fd**2*r*s - 108*C*D1**2*fd**2*r + 180*C*D1**2*fd**2*s**2 - 198*C*D1**2*fd**2*s - 440*C*D1*Dd*f**2*r*s + 110*C*D1*Dd*f**2*r - 440*C*D1*Dd*f**2*s**2 + 330*C*D1*Dd*f**2*s - 110*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r*s - 612*C*D1*Dd*f*fd*r + 1440*C*D1*Dd*f*fd*s**2 - 1332*C*D1*Dd*f*fd*s + 306*C*D1*Dd*f*fd + 360*C*D1*Ddd*f**2*r*s - 90*C*D1*Ddd*f**2*r + 360*C*D1*Ddd*f**2*s**2 - 270*C*D1*Ddd*f**2*s + 90*C*D1*Ddd*f**2 + 1080*C*Dd**2*f**2*r*s - 270*C*Dd**2*f**2*r + 1080*C*Dd**2*f**2*s**2 - 810*C*Dd**2*f**2*s + 90*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(2*C - 5)*(2*s - 1)*(r + s - 1) - 76*D1**2*f*fd*r*s - 45*D1**2*f*fd*r - 76*D1**2*f*fd*s**2 - 7*D1**2*f*fd*s + 45*D1**2*f*fd + 108*D1**2*f*fdd*r*s - 9*D1**2*f*fdd*r + 108*D1**2*f*fdd*s**2 - 63*D1**2*f*fdd*s + 9*D1**2*f*fdd + 108*D1**2*fd**2*r*s - 9*D1**2*fd**2*r + 108*D1**2*fd**2*s**2 - 63*D1**2*fd**2*s - 152*D1*Dd*f**2*r*s + 38*D1*Dd*f**2*r - 152*D1*Dd*f**2*s**2 + 114*D1*Dd*f**2*s - 38*D1*Dd*f**2 + 864*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r + 864*D1*Dd*f*fd*s**2 - 576*D1*Dd*f*fd*s + 72*D1*Dd*f*fd + 216*D1*Ddd*f**2*r*s - 54*D1*Ddd*f**2*r + 216*D1*Ddd*f**2*s**2 - 162*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(12*C - 25)*(2*s - 1)*(r + s - 1) - fd*(6*C - 15)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(30 - 12*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 648*Dd**2*f**2*r*s - 162*Dd**2*f**2*r + 648*Dd**2*f**2*s**2 - 486*Dd**2*f**2*s + 54*Dd**2*f**2) + f*(-270*C*D1**2*f*fd*r*s + 90*C*D1**2*f*fd*r - 270*C*D1**2*f*fd*s**2 + 270*C*D1**2*f*fd*s - 90*C*D1**2*f*fd + 180*C*D1**2*f*fdd*r*s - 60*C*D1**2*f*fdd*r + 180*C*D1**2*f*fdd*s**2 - 180*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 360*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 360*C*D1**2*fd**2*s**2 - 360*C*D1**2*fd**2*s + 60*C*D1**2*fd**2 - 360*C*D1*Dd*f**2*r*s + 90*C*D1*Dd*f**2*r - 360*C*D1*Dd*f**2*s**2 + 270*C*D1*Dd*f**2*s - 90*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r*s - 420*C*D1*Dd*f*fd*r + 1440*C*D1*Dd*f*fd*s**2 - 1260*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 180*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 540*C*Dd**2*f**2*s + 60*C*Dd**2*f**2 - 21*D1**2*bd1**2*(2*C - 5)*(2*s - 1)*(r + s - 1) + 9*D1**2*bdd1*f*(r + s - 1)*(10*C*s + 2*C + 6*s - 5) + 51*D1**2*f*fd*r*s - 17*D1**2*f*fd*r + 51*D1**2*f*fd*s**2 - 51*D1**2*f*fd*s + 17*D1**2*f*fd + 15*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r + 15*D1**2*f*fdd*s**2 - 15*D1**2*f*fdd*s + 5*D1**2*f*fdd + 30*D1**2*fd**2*r*s - 10*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s + 5*D1**2*fd**2 + 68*D1*Dd*f**2*r*s - 17*D1*Dd*f**2*r + 68*D1*Dd*f**2*s**2 - 51*D1*Dd*f**2*s + 17*D1*Dd*f**2 + 120*D1*Dd*f*fd*r*s - 35*D1*Dd*f*fd*r + 120*D1*Dd*f*fd*s**2 - 105*D1*Dd*f*fd*s + 20*D1*Dd*f*fd + 20*D1*Ddd*f**2*r*s - 5*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 15*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-f*(r + s - 1)*(2*C*(55*s + 18) + 38*s - 83) + 9*fd*(2*C*(20*r*s - 4*r + 20*s**2 - 19*s + 5) + 24*r*s - 11*r + 24*s**2 - 29*s + 6)) + 18*Dd*f*(C*(40*r*s - r + 40*s**2 - 31*s + 3) + 24*r*s - 13*r + 24*s**2 - 31*s + 8)) + 60*Dd**2*f**2*r*s - 15*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 45*Dd**2*f**2*s + 5*Dd**2*f**2))/(105*d**2*k3**4) - 2*D1**2*Pk1*Pkd2*ct**2*k1**2*k2*(-3*D1*f*(10*C*f*(D1*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 7*D1*bd1**2*(6*C + 1)*(2*s - 1)*(r + s - 1) + D1*bd1*(-f*(r + s - 1)*(32*C*s - 46*C - 25*s + 25) + fd*(30*C + 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + 5*D1*bdd1*f*(6*C + 1)*(s - 1)*(r + s - 1) + 5*Dd*bd1*f*(6*C + 1)*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) + 7*b1**2*(D1**2*s*(r + s)*(-18*C*fdd + fd*(26*C - 19) - 3*fdd) + D1*(Dd*(f*(26*C - 19)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(18*C + 3)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(-18*C - 3)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(18*C + 3)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(-21*D1**2*bdd1*f*(6*C + 1)*(2*s - 1)*(r + s - 1) - 3*D1**2*(-2*C*f*fd*(r*(32*s + 7) + 32*s**2 - 9*s - 7) + 30*C*f*fdd*s*(2*r + 2*s - 1) + 30*C*fd**2*s*(2*r + 2*s - 1) + s*(5*f*(5*fd + fdd) + 5*fd**2)*(2*r + 2*s - 1)) + 7*D1*bd1*(D1*(f*(26*C - 19)*(2*s - 1)*(r + s - 1) - fd*(18*C + 3)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(-36*C - 6)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 3*D1*f*(Dd*(-f*(32*C - 25)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(30*C + 5)*(8*s - 1)*(2*r + 2*s - 1)) + Ddd*f*(30*C + 5)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f**2*(30*C + 5)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(105*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**2*k1**2*st**4*(3*C - 18)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2*k3**2) + D1**2*Pk1*Pkd2*ct**2*k1**2*st**2*(35*b1**2*(C - 4)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-556*C*D1**2*f*fd*s**2 + 616*C*D1**2*f*fd*s - 308*C*D1**2*f*fd + 292*C*D1**2*f*fdd*s**2 - 322*C*D1**2*f*fdd*s + 161*C*D1**2*f*fdd + 292*C*D1**2*fd**2*s**2 - 322*C*D1**2*fd**2*s - 1112*C*D1*Dd*f**2*s**2 + 556*C*D1*Dd*f**2*s - 278*C*D1*Dd*f**2 + 2336*C*D1*Dd*f*fd*s**2 - 1872*C*D1*Dd*f*fd*s + 322*C*D1*Dd*f*fd + 584*C*D1*Ddd*f**2*s**2 - 292*C*D1*Ddd*f**2*s + 146*C*D1*Ddd*f**2 + 1752*C*Dd**2*f**2*s**2 - 876*C*Dd**2*f**2*s - 35*D1**2*bdd1*f*(C - 4)*(2*s**2 - 2*s + 1) + 156*D1**2*f*fd*r*s - 78*D1**2*f*fd*r + 664*D1**2*f*fd*s**2 - 904*D1**2*f*fd*s + 452*D1**2*f*fd - 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 388*D1**2*f*fdd*s**2 + 508*D1**2*f*fdd*s - 254*D1**2*f*fdd - 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 388*D1**2*fd**2*s**2 + 508*D1**2*fd**2*s + 312*D1*Dd*f**2*r*s - 78*D1*Dd*f**2*r + 1328*D1*Dd*f**2*s**2 - 742*D1*Dd*f**2*s + 332*D1*Dd*f**2 - 960*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 3104*D1*Dd*f*fd*s**2 + 2928*D1*Dd*f*fd*s - 568*D1*Dd*f*fd - 240*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 776*D1*Ddd*f**2*s**2 + 448*D1*Ddd*f**2*s - 194*D1*Ddd*f**2 + 70*D1*bd1*(C - 4)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 720*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 2328*Dd**2*f**2*s**2 + 1344*Dd**2*f**2*s - 60*Dd**2*f**2) - f*(492*C*D1**2*f*fd*s**2 - 328*C*D1**2*f*fd*s + 164*C*D1**2*f*fd - 255*C*D1**2*f*fdd*s**2 + 170*C*D1**2*f*fdd*s - 85*C*D1**2*f*fdd - 510*C*D1**2*fd**2*s**2 + 340*C*D1**2*fd**2*s + 656*C*D1*Dd*f**2*s**2 - 328*C*D1*Dd*f**2*s + 164*C*D1*Dd*f**2 - 2040*C*D1*Dd*f*fd*s**2 + 1190*C*D1*Dd*f*fd*s - 170*C*D1*Dd*f*fd - 340*C*D1*Ddd*f**2*s**2 + 170*C*D1*Ddd*f**2*s - 85*C*D1*Ddd*f**2 - 1020*C*Dd**2*f**2*s**2 + 510*C*Dd**2*f**2*s + 70*D1**2*bd1**2*s*(C - 4)*(s - 1) + D1**2*bdd1*f*(C*(-146*s**2 - 30*s + 15) + 194*s**2 + s*(60*r + 60) - 60) - 126*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 636*D1**2*f*fd*s**2 + 466*D1**2*f*fd*s - 212*D1**2*f*fd + 108*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 354*D1**2*f*fdd*s**2 - 272*D1**2*f*fdd*s + 118*D1**2*f*fdd + 216*D1**2*fd**2*r*s - 72*D1**2*fd**2*r + 708*D1**2*fd**2*s**2 - 544*D1**2*fd**2*s + 36*D1**2*fd**2 - 168*D1*Dd*f**2*r*s + 42*D1*Dd*f**2*r - 848*D1*Dd*f**2*s**2 + 466*D1*Dd*f**2*s - 212*D1*Dd*f**2 + 864*D1*Dd*f*fd*r*s - 252*D1*Dd*f*fd*r + 2832*D1*Dd*f*fd*s**2 - 1904*D1*Dd*f*fd*s + 308*D1*Dd*f*fd + 144*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 472*D1*Ddd*f**2*s**2 - 272*D1*Ddd*f**2*s + 118*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(C*(139*s**2 + 30*s - 15) - 166*s**2 - s*(39*r + 81) + 60) + fd*(30*r*(4*s - 1) - s**2*(292*C - 388) + s*(131*C - 194) + 30)) + Dd*f*(C*(-584*s**2 + 86*s + 15) + 30*r*(8*s - 1) + 776*s**2 - 104*s - 30)) + 432*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 1416*Dd**2*f**2*s**2 - 816*Dd**2*f**2*s + 36*Dd**2*f**2))/(105*d**2*k2*k3**2) - D1**2*Pk1*Pkd2*ct**2*k1**2*(7*b1**2*(D1**2*s*(-2*fd*(8*r + s*(28 - 15*C)) + fdd*(-20*C*s + 13*r + 38*s)) + D1*(Dd*(30*C*f*(4*s**2 - 2*s + 1) - 8*f*(r*(8*s - 2) + 28*s**2 - 16*s + 7) + fd*(13*r*(8*s - 1) + s*(-160*C*s + 40*C + 304*s - 89))) + Ddd*f*(-20*C*(4*s**2 - 2*s + 1) + 52*r*s - 13*r + 152*s**2 - 89*s + 38)) + Dd**2*f*(39*r*(4*s - 1) + s**2*(456 - 240*C) + s*(120*C - 267) + 13)) + b1*(-7*D1**2*bdd1*f*(20*C*(2*s**2 - 2*s + 1) + r*(13 - 26*s) - 76*s**2 + 89*s - 38) - 3*D1**2*(C*(4*f*fd*(3*s**2 - 28*s + 14) + f*fdd*(-6*s**2 + 70*s - 35) + 2*fd**2*s*(35 - 3*s)) + f*(fd*r*(50*s + 7) + 16*fd*s*(11*s - 2) + fdd*s*(-46*r - 116*s + 23)) + fd**2*s*(-46*r - 116*s + 23)) + 7*D1*bd1*(D1*(30*C*f*(2*s**2 - 2*s + 1) - 8*f*(r*(4*s - 2) + 14*s**2 - 16*s + 7) + fd*(13*r*(4*s - 1) + s*(-80*C*s + 40*C + 152*s - 89))) + 2*Dd*f*(-20*C*(8*s**2 - 6*s + 1) + 13*r*(8*s - 3) + 304*s**2 - 267*s + 51)) - 3*D1*f*(Dd*(f*(6*C*(4*s**2 - 2*s + 1) + 25*r*(4*s - 1) + 352*s**2 - 201*s + 88) - fd*(C*(48*s**2 - 292*s + 70) + 46*r*(8*s - 1) + 928*s**2 - 370*s + 23)) - Ddd*f*(3*C*(4*s**2 - 2*s + 1) + 23*r*(4*s - 1) + 232*s**2 - 139*s + 58)) - 3*Dd**2*f**2*(-69*r*(4*s - 1) - s**2*(36*C + 696) + s*(18*C + 417) - 23)) + f*(-15*C*(D1**2*(f*(8*fd - 5*fdd)*(3*s**2 - 2*s + 1) + 10*fd**2*s*(2 - 3*s)) + D1*f*(8*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(12*s**2 - 7*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)) + 7*D1**2*bd1**2*(13*r*(2*s - 1) - (s - 1)*(s*(40*C - 76) + 13)) + 3*D1**2*bdd1*f*(C*(3*s**2 + 64*s - 32) + (s - 1)*(23*r + 58*s - 58)) - 3*D1*bd1*(D1*(f*(2*C*(3*s**2 + 50*s - 25) + r*(25*s - 32) + 88*s**2 - 169*s + 88) - fd*(46*r*(2*s - 1) + s**2*(12*C + 232) + s*(58*C - 255) + 23)) - Dd*f*(C*(24*s**2 + 250*s - 64) + 23*r*(8*s - 5) + 464*s**2 - 603*s + 139)) - 15*D1*f*(D1*fd*(-3*r*s + r + s) + Dd*f*(-4*r*s + r + s))))/(105*d**2*k2*k3**2) + D1**2*Pk1*Pkd2*ct**2*k2**3*st**6*(4*C - 4)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(63*d**2*k3**4) + 2*D1**2*Pk1*Pkd2*ct**2*k2**3*st**4*(14*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(-140*C*D1**2*f*fd*r*s + 74*C*D1**2*f*fd*r - 140*C*D1**2*f*fd*s**2 + 144*C*D1**2*f*fd*s - 74*C*D1**2*f*fd + 56*C*D1**2*f*fdd*r*s - 30*C*D1**2*f*fdd*r + 56*C*D1**2*f*fdd*s**2 - 58*C*D1**2*f*fdd*s + 30*C*D1**2*f*fdd + 56*C*D1**2*fd**2*r*s - 30*C*D1**2*fd**2*r + 56*C*D1**2*fd**2*s**2 - 58*C*D1**2*fd**2*s - 280*C*D1*Dd*f**2*r*s + 70*C*D1*Dd*f**2*r - 280*C*D1*Dd*f**2*s**2 + 210*C*D1*Dd*f**2*s - 70*C*D1*Dd*f**2 + 448*C*D1*Dd*f*fd*r*s - 176*C*D1*Dd*f*fd*r + 448*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 88*C*D1*Dd*f*fd + 112*C*D1*Ddd*f**2*r*s - 28*C*D1*Ddd*f**2*r + 112*C*D1*Ddd*f**2*s**2 - 84*C*D1*Ddd*f**2*s + 28*C*D1*Ddd*f**2 + 336*C*Dd**2*f**2*r*s - 84*C*Dd**2*f**2*r + 336*C*Dd**2*f**2*s**2 - 252*C*Dd**2*f**2*s + 28*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) - 26*D1**2*f*fd*r*s + 9*D1**2*f*fd*r - 26*D1**2*f*fd*s**2 + 22*D1**2*f*fd*s - 9*D1**2*f*fd + 34*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r + 34*D1**2*f*fdd*s**2 - 32*D1**2*f*fdd*s + 15*D1**2*f*fdd + 34*D1**2*fd**2*r*s - 15*D1**2*fd**2*r + 34*D1**2*fd**2*s**2 - 32*D1**2*fd**2*s - 52*D1*Dd*f**2*r*s + 13*D1*Dd*f**2*r - 52*D1*Dd*f**2*s**2 + 39*D1*Dd*f**2*s - 13*D1*Dd*f**2 + 272*D1*Dd*f*fd*r*s - 94*D1*Dd*f*fd*r + 272*D1*Dd*f*fd*s**2 - 230*D1*Dd*f*fd*s + 47*D1*Dd*f*fd + 68*D1*Ddd*f**2*r*s - 17*D1*Ddd*f**2*r + 68*D1*Ddd*f**2*s**2 - 51*D1*Ddd*f**2*s + 17*D1*Ddd*f**2 + 14*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 204*Dd**2*f**2*r*s - 51*Dd**2*f**2*r + 204*Dd**2*f**2*s**2 - 153*Dd**2*f**2*s + 17*Dd**2*f**2) + f*(-66*C*D1**2*f*fd*r*s + 22*C*D1**2*f*fd*r - 66*C*D1**2*f*fd*s**2 + 66*C*D1**2*f*fd*s - 22*C*D1**2*f*fd + 30*C*D1**2*f*fdd*r*s - 10*C*D1**2*f*fdd*r + 30*C*D1**2*f*fdd*s**2 - 30*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd + 60*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*r + 60*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s + 10*C*D1**2*fd**2 - 88*C*D1*Dd*f**2*r*s + 22*C*D1*Dd*f**2*r - 88*C*D1*Dd*f**2*s**2 + 66*C*D1*Dd*f**2*s - 22*C*D1*Dd*f**2 + 240*C*D1*Dd*f*fd*r*s - 70*C*D1*Dd*f*fd*r + 240*C*D1*Dd*f*fd*s**2 - 210*C*D1*Dd*f*fd*s + 40*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*r*s - 10*C*D1*Ddd*f**2*r + 40*C*D1*Ddd*f**2*s**2 - 30*C*D1*Ddd*f**2*s + 10*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*r*s - 30*C*Dd**2*f**2*r + 120*C*Dd**2*f**2*s**2 - 90*C*Dd**2*f**2*s + 10*C*Dd**2*f**2 - 14*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) + D1**2*bdd1*f*(r + s - 1)*(28*C*s + 2*C + 17*s - 2) - 21*D1**2*f*fd*r*s + 7*D1**2*f*fd*r - 21*D1**2*f*fd*s**2 + 21*D1**2*f*fd*s - 7*D1**2*f*fd + 15*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r + 15*D1**2*f*fdd*s**2 - 15*D1**2*f*fdd*s + 5*D1**2*f*fdd + 30*D1**2*fd**2*r*s - 10*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s + 5*D1**2*fd**2 - 28*D1*Dd*f**2*r*s + 7*D1*Dd*f**2*r - 28*D1*Dd*f**2*s**2 + 21*D1*Dd*f**2*s - 7*D1*Dd*f**2 + 120*D1*Dd*f*fd*r*s - 35*D1*Dd*f*fd*r + 120*D1*Dd*f*fd*s**2 - 105*D1*Dd*f*fd*s + 20*D1*Dd*f*fd + 20*D1*Ddd*f**2*r*s - 5*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 15*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-f*(r + s - 1)*(C*(70*s + 4) + 13*s - 4) + fd*(2*C*(56*r*s - 13*r + 56*s**2 - 55*s + 14) + 68*r*s - 19*r + 68*s**2 - 70*s + 17)) + Dd*f*(4*C*(56*r*s - 5*r + 56*s**2 - 47*s + 6) + 136*r*s - 25*r + 136*s**2 - 127*s + 21)) + 60*Dd**2*f**2*r*s - 15*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 45*Dd**2*f**2*s + 5*Dd**2*f**2))/(35*d**2*k3**4) - 2*D1**2*Pk1*Pkd2*ct**2*k2**3*st**2*(D1*f*(-21*D1*bd1**2*(4*C + 3)*(2*s - 1)*(r + s - 1) + bd1*(D1*(f*(r + s - 1)*(2*C*(s - 43) - 9*s - 33) - fd*(36*C + 27)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(-36*C - 27)*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) - 9*f*(D1*bdd1*(4*C + 3)*(s - 1)*(r + s - 1) + (4*C + 2)*(D1*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))) + 7*b1**2*(D1**2*s*(r + s)*(fd*(34*C + 3) - fdd*(12*C + 9)) + D1*(Dd*(f*(34*C + 3)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(12*C + 9)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(-12*C - 9)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(12*C + 9)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(4*C*D1**2*f*fd*r*s + 84*C*D1**2*f*fd*r + 4*C*D1**2*f*fd*s**2 + 82*C*D1**2*f*fd*s - 84*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*s**2 + 36*C*D1**2*f*fdd*s - 72*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*s**2 + 36*C*D1**2*fd**2*s + 8*C*D1*Dd*f**2*r*s - 2*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s**2 - 6*C*D1*Dd*f**2*s + 2*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r*s + 72*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 360*C*D1*Dd*f*fd*s - 36*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r*s + 36*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 108*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r*s + 108*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 324*C*Dd**2*f**2*s - 36*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(4*C + 3)*(2*s - 1)*(r + s - 1) - 18*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 18*D1**2*f*fd*s**2 + 51*D1**2*f*fd*s - 42*D1**2*f*fd - 54*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*s**2 + 27*D1**2*f*fdd*s - 54*D1**2*fd**2*r*s - 54*D1**2*fd**2*s**2 + 27*D1**2*fd**2*s - 36*D1*Dd*f**2*r*s + 9*D1*Dd*f**2*r - 36*D1*Dd*f**2*s**2 + 27*D1*Dd*f**2*s - 9*D1*Dd*f**2 - 432*D1*Dd*f*fd*r*s + 54*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 270*D1*Dd*f*fd*s - 27*D1*Dd*f*fd - 108*D1*Ddd*f**2*r*s + 27*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 81*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(34*C + 3)*(2*s - 1)*(r + s - 1) - fd*(12*C + 9)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(-24*C - 18)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 324*Dd**2*f**2*r*s + 81*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 243*Dd**2*f**2*s - 27*Dd**2*f**2))/(105*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**2*k2*st**6*(C - 1)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**2*k2*st**4*(105*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(-184*C*D1**2*f*fd*r*s + 92*C*D1**2*f*fd*r - 528*C*D1**2*f*fd*s**2 + 548*C*D1**2*f*fd*s - 274*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r*s - 60*C*D1**2*f*fdd*r + 306*C*D1**2*f*fdd*s**2 - 316*C*D1**2*f*fdd*s + 158*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r*s - 60*C*D1**2*fd**2*r + 306*C*D1**2*fd**2*s**2 - 316*C*D1**2*fd**2*s - 368*C*D1*Dd*f**2*r*s + 92*C*D1*Dd*f**2*r - 1056*C*D1*Dd*f**2*s**2 + 620*C*D1*Dd*f**2*s - 264*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r*s - 360*C*D1*Dd*f*fd*r + 2448*C*D1*Dd*f*fd*s**2 - 1996*C*D1*Dd*f*fd*s + 376*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 612*C*D1*Ddd*f**2*s**2 - 366*C*D1*Ddd*f**2*s + 153*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 1836*C*Dd**2*f**2*s**2 - 1098*C*Dd**2*f**2*s + 60*C*Dd**2*f**2 - 35*D1**2*bdd1*f*(C - 1)*(2*s**2 - 2*s + 1) + 244*D1**2*f*fd*r*s - 122*D1**2*f*fd*r + 128*D1**2*f*fd*s**2 - 148*D1**2*f*fd*s + 74*D1**2*f*fd - 150*D1**2*f*fdd*r*s + 75*D1**2*f*fdd*r - 106*D1**2*f*fdd*s**2 + 116*D1**2*f*fdd*s - 58*D1**2*f*fdd - 150*D1**2*fd**2*r*s + 75*D1**2*fd**2*r - 106*D1**2*fd**2*s**2 + 116*D1**2*fd**2*s + 488*D1*Dd*f**2*r*s - 122*D1*Dd*f**2*r + 256*D1*Dd*f**2*s**2 - 250*D1*Dd*f**2*s + 64*D1*Dd*f**2 - 1200*D1*Dd*f*fd*r*s + 450*D1*Dd*f*fd*r - 848*D1*Dd*f*fd*s**2 + 826*D1*Dd*f*fd*s - 191*D1*Dd*f*fd - 300*D1*Ddd*f**2*r*s + 75*D1*Ddd*f**2*r - 212*D1*Ddd*f**2*s**2 + 181*D1*Ddd*f**2*s - 53*D1*Ddd*f**2 + 70*D1*bd1*(C - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 900*Dd**2*f**2*r*s + 225*Dd**2*f**2*r - 636*Dd**2*f**2*s**2 + 543*Dd**2*f**2*s - 75*Dd**2*f**2) + f*(-252*C*D1**2*f*fd*r*s + 84*C*D1**2*f*fd*r - 678*C*D1**2*f*fd*s**2 + 536*C*D1**2*f*fd*s - 226*C*D1**2*f*fd + 180*C*D1**2*f*fdd*r*s - 60*C*D1**2*f*fdd*r + 366*C*D1**2*f*fdd*s**2 - 304*C*D1**2*f*fdd*s + 122*C*D1**2*f*fdd + 360*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 732*C*D1**2*fd**2*s**2 - 608*C*D1**2*fd**2*s + 60*C*D1**2*fd**2 - 336*C*D1*Dd*f**2*r*s + 84*C*D1*Dd*f**2*r - 904*C*D1*Dd*f**2*s**2 + 536*C*D1*Dd*f**2*s - 226*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r*s - 420*C*D1*Dd*f*fd*r + 2928*C*D1*Dd*f*fd*s**2 - 2128*C*D1*Dd*f*fd*s + 364*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 488*C*D1*Ddd*f**2*s**2 - 304*C*D1*Ddd*f**2*s + 122*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 1464*C*Dd**2*f**2*s**2 - 912*C*Dd**2*f**2*s + 60*C*Dd**2*f**2 - 210*D1**2*bd1**2*s*(C - 1)*(s - 1) + 3*D1**2*bdd1*f*(C*(153*s**2 + s*(60*r - 50) - 5) - 53*s**2 + s*(65 - 75*r) + 5) + 390*D1**2*f*fd*r*s - 130*D1**2*f*fd*r + 78*D1**2*f*fd*s**2 - 182*D1**2*f*fd*s + 26*D1**2*f*fd - 285*D1**2*f*fdd*r*s + 95*D1**2*f*fdd*r - 66*D1**2*f*fdd*s**2 + 139*D1**2*f*fdd*s - 22*D1**2*f*fdd - 570*D1**2*fd**2*r*s + 190*D1**2*fd**2*r - 132*D1**2*fd**2*s**2 + 278*D1**2*fd**2*s - 95*D1**2*fd**2 + 520*D1*Dd*f**2*r*s - 130*D1*Dd*f**2*r + 104*D1*Dd*f**2*s**2 - 182*D1*Dd*f**2*s + 26*D1*Dd*f**2 - 2280*D1*Dd*f*fd*r*s + 665*D1*Dd*f*fd*r - 528*D1*Dd*f*fd*s**2 + 973*D1*Dd*f*fd*s - 234*D1*Dd*f*fd - 380*D1*Ddd*f**2*r*s + 95*D1*Ddd*f**2*r - 88*D1*Ddd*f**2*s**2 + 139*D1*Ddd*f**2*s - 22*D1*Ddd*f**2 - 3*D1*bd1*(D1*(2*f*(C*(132*s**2 + s*(46*r - 36) - 5) - 32*s**2 + s*(51 - 61*r) + 5) + fd*(-4*C*(15*r*(4*s - 1) + 153*s**2 - 104*s + 15) + 75*r*(4*s - 1) + 212*s**2 - 246*s + 75)) + Dd*f*(-2*C*(30*r*(8*s - 1) + 612*s**2 - 283*s + 25) + 75*r*(8*s - 1) + 424*s**2 - 441*s + 65)) - 1140*Dd**2*f**2*r*s + 285*Dd**2*f**2*r - 264*Dd**2*f**2*s**2 + 417*Dd**2*f**2*s - 95*Dd**2*f**2))/(105*d**2*k3**2) - D1**2*Pk1*Pkd2*ct**2*k2*st**2*(7*b1**2*(D1**2*s*(fd*(52*C*r + 56*C*s - 64*r - 38*s) + fdd*r*(42 - 36*C) + fdd*s*(34 - 43*C)) + D1*(2*Dd*(f*(2*C*(52*r*s - 13*r + 56*s**2 - 41*s + 14) - 128*r*s + 32*r - 76*s**2 + 70*s - 19) + fd*(r*(21 - 18*C)*(8*s - 1) + s*(-172*C*s + 61*C + 136*s - 55))) + Ddd*f*(C*(-144*r*s + 36*r - 172*s**2 + 122*s - 43) + 168*r*s - 42*r + 136*s**2 - 110*s + 34)) - 6*Dd**2*f*(C*(18*r*(4*s - 1) + 86*s**2 - 61*s + 6) + r*(21 - 84*s) - 68*s**2 + 55*s - 7)) + b1*(-408*C*D1**2*f*fd*r*s + 336*C*D1**2*f*fd*r - 736*C*D1**2*f*fd*s**2 + 876*C*D1**2*f*fd*s - 504*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r*s - 168*C*D1**2*f*fdd*r + 578*C*D1**2*f*fdd*s**2 - 648*C*D1**2*f*fdd*s + 378*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r*s - 168*C*D1**2*fd**2*r + 578*C*D1**2*fd**2*s**2 - 648*C*D1**2*fd**2*s - 816*C*D1*Dd*f**2*r*s + 204*C*D1*Dd*f**2*r - 1472*C*D1*Dd*f**2*s**2 + 940*C*D1*Dd*f**2*s - 368*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r*s - 792*C*D1*Dd*f*fd*r + 4624*C*D1*Dd*f*fd*s**2 - 3868*C*D1*Dd*f*fd*s + 816*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 1156*C*D1*Ddd*f**2*s**2 - 638*C*D1*Ddd*f**2*s + 289*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 3468*C*Dd**2*f**2*s**2 - 1914*C*Dd**2*f**2*s + 60*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(C*(36*r*(2*s - 1) + 86*s**2 - 122*s + 43) + r*(42 - 84*s) - 68*s**2 + 110*s - 34) - 68*D1**2*f*fd*r*s - 154*D1**2*f*fd*r - 644*D1**2*f*fd*s**2 + 668*D1**2*f*fd*s - 240*D1**2*f*fd + 384*D1**2*f*fdd*r*s - 42*D1**2*f*fdd*r + 490*D1**2*f*fdd*s**2 - 516*D1**2*f*fdd*s + 183*D1**2*f*fdd + 384*D1**2*fd**2*r*s - 42*D1**2*fd**2*r + 490*D1**2*fd**2*s**2 - 516*D1**2*fd**2*s - 136*D1*Dd*f**2*r*s + 34*D1*Dd*f**2*r - 1288*D1*Dd*f**2*s**2 + 678*D1*Dd*f**2*s - 322*D1*Dd*f**2 + 3072*D1*Dd*f*fd*r*s - 552*D1*Dd*f*fd*r + 3920*D1*Dd*f*fd*s**2 - 3428*D1*Dd*f*fd*s + 558*D1*Dd*f*fd + 768*D1*Ddd*f**2*r*s - 192*D1*Ddd*f**2*r + 980*D1*Ddd*f**2*s**2 - 682*D1*Ddd*f**2*s + 245*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(C*(52*r*s - 26*r + 56*s**2 - 82*s + 28) - 64*r*s + 32*r - 38*s**2 + 70*s - 19) + fd*(r*(21 - 18*C)*(4*s - 1) + s*(-86*C*s + 61*C + 68*s - 55))) + Dd*f*(C*(-36*r*(8*s - 3) - 344*s**2 + 366*s - 79) + 42*r*(8*s - 3) + 272*s**2 - 330*s + 76)) + 2304*Dd**2*f**2*r*s - 576*Dd**2*f**2*r + 2940*Dd**2*f**2*s**2 - 2046*Dd**2*f**2*s + 192*Dd**2*f**2) + f*(-600*C*D1**2*f*fd*r*s + 200*C*D1**2*f*fd*r - 648*C*D1**2*f*fd*s**2 + 632*C*D1**2*f*fd*s - 216*C*D1**2*f*fd + 408*C*D1**2*f*fdd*r*s - 136*C*D1**2*f*fdd*r + 486*C*D1**2*f*fdd*s**2 - 460*C*D1**2*f*fdd*s + 162*C*D1**2*f*fdd + 816*C*D1**2*fd**2*r*s - 272*C*D1**2*fd**2*r + 972*C*D1**2*fd**2*s**2 - 920*C*D1**2*fd**2*s + 136*C*D1**2*fd**2 - 800*C*D1*Dd*f**2*r*s + 200*C*D1*Dd*f**2*r - 864*C*D1*Dd*f**2*s**2 + 632*C*D1*Dd*f**2*s - 216*C*D1*Dd*f**2 + 3264*C*D1*Dd*f*fd*r*s - 952*C*D1*Dd*f*fd*r + 3888*C*D1*Dd*f*fd*s**2 - 3220*C*D1*Dd*f*fd*s + 596*C*D1*Dd*f*fd + 544*C*D1*Ddd*f**2*r*s - 136*C*D1*Ddd*f**2*r + 648*C*D1*Ddd*f**2*s**2 - 460*C*D1*Ddd*f**2*s + 162*C*D1*Ddd*f**2 + 1632*C*Dd**2*f**2*r*s - 408*C*Dd**2*f**2*r + 1944*C*Dd**2*f**2*s**2 - 1380*C*Dd**2*f**2*s + 136*C*Dd**2*f**2 - 14*D1**2*bd1**2*(C*(18*r*(2*s - 1) + 43*s**2 - 61*s + 18) + r*(21 - 42*s) - 34*s**2 + 55*s - 21) + D1**2*bdd1*f*(C*(12*r*(5*s + 9) + 289*s**2 + 10*s - 89) + 6*r*(32*s - 25) + 245*s**2 - 166*s + 62) + 186*D1**2*f*fd*r*s - 62*D1**2*f*fd*r - 336*D1**2*f*fd*s**2 + 162*D1**2*f*fd*s - 112*D1**2*f*fd + 78*D1**2*f*fdd*r*s - 26*D1**2*f*fdd*r + 249*D1**2*f*fdd*s**2 - 192*D1**2*f*fdd*s + 83*D1**2*f*fdd + 156*D1**2*fd**2*r*s - 52*D1**2*fd**2*r + 498*D1**2*fd**2*s**2 - 384*D1**2*fd**2*s + 26*D1**2*fd**2 + 248*D1*Dd*f**2*r*s - 62*D1*Dd*f**2*r - 448*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 112*D1*Dd*f**2 + 624*D1*Dd*f*fd*r*s - 182*D1*Dd*f*fd*r + 1992*D1*Dd*f*fd*s**2 - 1344*D1*Dd*f*fd*s + 218*D1*Dd*f*fd + 104*D1*Ddd*f**2*r*s - 26*D1*Ddd*f**2*r + 332*D1*Ddd*f**2*s**2 - 192*D1*Ddd*f**2*s + 83*D1*Ddd*f**2 - 2*D1*bd1*(D1*(f*(2*C*(51*r*s + 33*r + 92*s**2 - 16*s - 34) + 17*r*s - 94*r + 161*s**2 - 5*s + 41) - fd*(2*C*(60*r*s + 12*r + 289*s**2 - 157*s + 15) + 384*r*s - 171*r + 490*s**2 - 424*s + 96)) - Dd*f*(C*(6*r*(40*s + 31) + 1156*s**2 - 299*s - 59) + 768*r*s - 396*r + 980*s**2 - 673*s + 158)) + 312*Dd**2*f**2*r*s - 78*Dd**2*f**2*r + 996*Dd**2*f**2*s**2 - 576*Dd**2*f**2*s + 26*Dd**2*f**2))/(105*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**2*k2*(D1*f*(-7*D1*bd1**2*(10*C*(r*(4*s - 2) + 5*s**2 - 7*s + 2) + 7*r*(2*s - 1) + 42*s**2 - 49*s + 7) + 3*bd1*(D1*(f*(4*C*(s - 1)*(29*r + 7*s - 7) - 44*r*s + 37*r + 20*s**2 - 33*s + 20) - fd*(4*C*(44*r*s - 22*r + 35*s**2 - 46*s + 11) + 52*r*s - 26*r + 124*s**2 - 137*s + 13)) - Dd*f*(2*C*(22*r*(8*s - 5) + 140*s**2 - 197*s + 57) + 13*r*(8*s - 5) + 248*s**2 - 323*s + 75)) - 3*f*(D1*bdd1*(s - 1)*(44*C*r + 35*C*(s - 1) + 13*r + 31*s - 31) + 5*D1*fd*(r*(3*s - 1) - s) + 5*Dd*f*(r*(4*s - 1) - s))) + 7*b1**2*(D1**2*s*(fd*(r*(60*C - 31) + s*(20*C + 12)) - fdd*(r*(20*C + 7) + s*(25*C + 21))) + D1*(-5*C*Ddd*f*(4*r*(4*s - 1) + 20*s**2 - 14*s + 5) + Dd*f*(20*C*(4*s - 1)*(3*r + s - 1) - 124*r*s + 31*r + 48*s**2 + 7*s + 12) + Dd*fd*(-r*(20*C + 7)*(8*s - 1) + s*(-200*C*s + 70*C - 168*s + 49)) - 7*Ddd*f*(r*(4*s - 1) + 12*s**2 - 7*s + 3)) - Dd**2*f*(10*C*(24*r*s - 6*r + 30*s**2 - 21*s + 2) + 84*r*s - 21*r + 252*s**2 - 147*s + 7)) + b1*(-7*D1**2*bdd1*f*(5*C*(r*(8*s - 4) + 10*s**2 - 14*s + 5) + 7*r*(2*s - 1) + 42*s**2 - 49*s + 21) + 3*D1**2*(f*(fd*(r*(232*C*s - 88*s + 7) + s*(56*C*s - 116*C + 40*s + 37)) - fdd*s*(C*(88*r + 70*s - 44) + 26*r + 62*s - 13)) - fd**2*s*(C*(88*r + 70*s - 44) + 26*r + 62*s - 13)) + 7*D1*bd1*(D1*(f*(20*C*(6*r*s - 3*r + 2*s**2 - 5*s + 1) - 62*r*s + 31*r + 24*s**2 + 7*s + 12) + fd*(-r*(20*C + 7)*(4*s - 1) + s*(-100*C*s + 70*C - 84*s + 49))) - 2*Dd*f*(5*C*(4*r*(8*s - 3) + 40*s**2 - 42*s + 9) + 7*r*(8*s - 3) + 168*s**2 - 147*s + 28)) + 3*D1*f*(Dd*(4*f*(C*(29*r*(4*s - 1) + 28*s**2 - 43*s + 7) + r*(11 - 44*s) + 20*s**2 + s + 5) - fd*(C*(88*r*(8*s - 1) + 560*s**2 - 404*s + 44) + 26*r*(8*s - 1) + 496*s**2 - 202*s + 13)) - Ddd*f*(C*(44*r*(4*s - 1) + 140*s**2 - 114*s + 35) + 13*r*(4*s - 1) + 124*s**2 - 75*s + 31)) - 3*Dd**2*f**2*(2*C*(66*r*(4*s - 1) + 210*s**2 - 171*s + 22) + 39*r*(4*s - 1) + 372*s**2 - 225*s + 13)))/(105*d**2*k3**2) - 9*D1**2*Pk1*Pkd2*ct**2*st**4*(D1**2*(5*f**3*(20*fd*(4*s**2 - 2*s + 1) - 10*fdd*(4*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + f**2*s*(-330*bd1**2*s - 22*bd1*(15*fd*(3*s - 1) + s*(K - 1)) - 300*fd**2*(2*s - 1) + s*(11*bdd1*(K - 1) + 44*gd2 - 22*gdd2)) + 22*f*(fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - fdd*g2*(2*s**2 - 2*s + 1) + s**2*(7*bd1**2*(K - 1) + 14*bd1*(g2 - gd2) - 7*bdd1*g2)) - 44*fd*g2*s*(7*bd1 + fd)*(s - 1)) + 2*D1*f*(Dd*(50*f**3*(4*s**2 - 2*s + 1) - 5*f**2*(4*s - 1)*(33*bd1*s + 10*fd*(4*s - 1)) + 11*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 22*g2*(4*s - 1)*(7*bd1*s + fd*(2*s - 1))) - Ddd*f*(25*f**2 + 11*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(25*f**2 + 11*g2)*(2*s - 1) + 11*b1**2*(D1**2*(30*f*fd*(2*s**2 - 2*s + 1) - 15*f*fdd*(2*s**2 - 2*s + 1) - 30*fd**2*s*(s - 1) - 14*fd*(K - 1)*(s - 1)**2 + 7*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(15*f**2*(4*s**2 - 2*s + 1) - 15*f*fd*(8*s**2 - 6*s + 1) - 7*f*(K - 1)*(4*s**2 - 2*s + 1) + 7*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-7*K + 15*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-7*K + 15*f + 7)) + 11*b1*(D1**2*(-15*f**2*(fd*(-6*s**2 + 4*s - 2) + fdd*(3*s**2 - 2*s + 1) + s**2*(-4*bd1 + 2*bdd1)) + f*(30*fd**2*s*(2 - 3*s) - 2*fd*(K*(2*s**2 - 2*s + 1) + s**2*(60*bd1 - 2) + s*(2 - 30*bd1) - 1) + fdd*(K - 1)*(2*s**2 - 2*s + 1) - s**2*(-14*K*bdd1 + 28*bd1*(K - 1) + 14*bdd1 - 28*gd2 + 14*gdd2)) + (2*s - 2)*(fd**2*s*(K - 1) + 14*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(15*f**3*(4*s**2 - 2*s + 1) - f**2*(4*K*s**2 - 2*K*s + K + 120*bd1*s**2 - 30*bd1*s + 15*fd*(12*s**2 - 7*s + 1) - 4*s**2 + 2*s - 1) + f*(fd*(K - 1)*(8*s**2 - 6*s + 1) + 14*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(14*K*bd1 - 14*bd1 - 14*gd2)) - 14*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(-K*f + 15*f**2 + f + 14*g2)) - 6*Dd**2*f*s*(2*s - 1)*(-K*f + 15*f**2 + f + 14*g2)))/(770*d**2*k2) - D1**2*Pk1*Pkd2*ct**2*st**2*(-9548*D1**2*K*bd1**2*f*s**2 - 770*D1**2*K*bd1**2*f*s + 3388*D1**2*K*bd1*f**2*s**2 - 7084*D1**2*K*bd1*f*fd*s**2 + 3542*D1**2*K*bd1*f*fd*s - 1771*D1**2*K*bdd1*f**2*s**2 + 1848*D1**2*bd1**2*f**2*r*s + 396*D1**2*bd1**2*f**2*s**2 + 5016*D1**2*bd1**2*f**2*s + 1848*D1**2*bd1**2*f*r*s + 308*D1**2*bd1**2*f*s**2 - 154*D1**2*bd1**2*f*s - 7700*D1**2*bd1**2*g2*s**2 + 7700*D1**2*bd1**2*g2*s - 4620*D1**2*bd1*bd2*f*s**2 - 1408*D1**2*bd1*f**3*r*s - 6204*D1**2*bd1*f**3*s**2 - 3696*D1**2*bd1*f**3*s + 2200*D1**2*bd1*f**3 + 8976*D1**2*bd1*f**2*fd*r*s - 1496*D1**2*bd1*f**2*fd*r + 22176*D1**2*bd1*f**2*fd*s**2 - 5984*D1**2*bd1*f**2*fd*s + 748*D1**2*bd1*f**2*fd - 1232*D1**2*bd1*f**2*r*s + 572*D1**2*bd1*f**2*s**2 + 3696*D1**2*bd1*f*fd*r*s - 924*D1**2*bd1*f*fd*r - 836*D1**2*bd1*f*fd*s**2 - 506*D1**2*bd1*f*fd*s - 17556*D1**2*bd1*f*g2*s**2 - 3080*D1**2*bd1*f*g2*s + 1540*D1**2*bd1*f*g2 + 19096*D1**2*bd1*f*gd2*s**2 + 1540*D1**2*bd1*f*gd2*s + 19096*D1**2*bd1*fd*g2*s**2 - 19096*D1**2*bd1*fd*g2*s + 1980*D1**2*bd2*f**2*s**2 - 3960*D1**2*bd2*f*fd*s**2 + 1980*D1**2*bd2*f*fd*s + 1496*D1**2*bdd1*f**3*r*s + 3696*D1**2*bdd1*f**3*s**2 + 1452*D1**2*bdd1*f**3*s - 1100*D1**2*bdd1*f**3 + 924*D1**2*bdd1*f**2*r*s - 209*D1**2*bdd1*f**2*s**2 + 9548*D1**2*bdd1*f*g2*s**2 + 1540*D1**2*bdd1*f*g2*s - 770*D1**2*bdd1*f*g2 - 990*D1**2*bdd2*f**2*s**2 - 1680*D1**2*f**3*fd*r*s + 420*D1**2*f**3*fd*r - 14080*D1**2*f**3*fd*s**2 + 7460*D1**2*f**3*fd*s - 3520*D1**2*f**3*fd + 2160*D1**2*f**3*fdd*r*s - 540*D1**2*f**3*fdd*r + 7920*D1**2*f**3*fdd*s**2 - 4500*D1**2*f**3*fdd*s + 1980*D1**2*f**3*fdd + 6480*D1**2*f**2*fd**2*r*s - 1620*D1**2*f**2*fd**2*r + 23760*D1**2*f**2*fd**2*s**2 - 13500*D1**2*f**2*fd**2*s + 540*D1**2*f**2*fd**2 - 6776*D1**2*f**2*gd2*s**2 + 3542*D1**2*f**2*gdd2*s**2 - 13552*D1**2*f*fd*g2*s**2 + 13552*D1**2*f*fd*g2*s - 6776*D1**2*f*fd*g2 + 14168*D1**2*f*fd*gd2*s**2 - 7084*D1**2*f*fd*gd2*s + 7084*D1**2*f*fdd*g2*s**2 - 7084*D1**2*f*fdd*g2*s + 3542*D1**2*f*fdd*g2 + 7084*D1**2*fd**2*g2*s**2 - 7084*D1**2*fd**2*g2*s - 14168*D1*Dd*K*bd1*f**2*s**2 + 3542*D1*Dd*K*bd1*f**2*s + 11968*D1*Dd*bd1*f**3*r*s - 1496*D1*Dd*bd1*f**3*r + 29568*D1*Dd*bd1*f**3*s**2 - 3080*D1*Dd*bd1*f**3*s - 1452*D1*Dd*bd1*f**3 + 7392*D1*Dd*bd1*f**2*r*s - 924*D1*Dd*bd1*f**2*r - 1672*D1*Dd*bd1*f**2*s**2 - 506*D1*Dd*bd1*f**2*s + 76384*D1*Dd*bd1*f*g2*s**2 - 12936*D1*Dd*bd1*f*g2*s - 1540*D1*Dd*bd1*f*g2 - 7920*D1*Dd*bd2*f**2*s**2 + 1980*D1*Dd*bd2*f**2*s - 1680*D1*Dd*f**4*r*s + 420*D1*Dd*f**4*r - 14080*D1*Dd*f**4*s**2 + 7460*D1*Dd*f**4*s - 3520*D1*Dd*f**4 + 17280*D1*Dd*f**3*fd*r*s - 4320*D1*Dd*f**3*fd*r + 63360*D1*Dd*f**3*fd*s**2 - 36000*D1*Dd*f**3*fd*s + 5040*D1*Dd*f**3*fd - 27104*D1*Dd*f**2*g2*s**2 + 13552*D1*Dd*f**2*g2*s - 6776*D1*Dd*f**2*g2 + 28336*D1*Dd*f**2*gd2*s**2 - 7084*D1*Dd*f**2*gd2*s + 56672*D1*Dd*f*fd*g2*s**2 - 42504*D1*Dd*f*fd*g2*s + 7084*D1*Dd*f*fd*g2 + 2160*D1*Ddd*f**4*r*s - 540*D1*Ddd*f**4*r + 7920*D1*Ddd*f**4*s**2 - 4500*D1*Ddd*f**4*s + 1980*D1*Ddd*f**4 + 14168*D1*Ddd*f**2*g2*s**2 - 7084*D1*Ddd*f**2*g2*s + 3542*D1*Ddd*f**2*g2 + 6480*Dd**2*f**4*r*s - 1620*Dd**2*f**4*r + 23760*Dd**2*f**4*s**2 - 13500*Dd**2*f**4*s + 540*Dd**2*f**4 + 42504*Dd**2*f**2*g2*s**2 - 21252*Dd**2*f**2*g2*s + 385*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-5*K*(4*s**2 - 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s + 20*s**2 - 10*s + 5) - D1*Ddd*(-5*K + 6*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-5*K + 6*f + 5)) + 11*b1**2*(798*D1**2*K*fd*s**2 - 1736*D1**2*K*fd*s + 868*D1**2*K*fd - 434*D1**2*K*fdd*s**2 + 938*D1**2*K*fdd*s - 469*D1**2*K*fdd - 35*D1**2*bdd1*(-5*K + 6*f + 5)*(3*s**2 - 2*s + 1) - 168*D1**2*f*fd*r*s + 84*D1**2*f*fd*r + 96*D1**2*f*fd*s**2 + 984*D1**2*f*fd*s - 492*D1**2*f*fd + 168*D1**2*f*fdd*r*s - 84*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 576*D1**2*f*fdd*s + 288*D1**2*f*fdd + 168*D1**2*fd**2*r*s - 84*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 576*D1**2*fd**2*s - 168*D1**2*fd*r*s + 168*D1**2*fd*r + 42*D1**2*fd*s**2 + 56*D1**2*fd*s - 28*D1**2*fd + 84*D1**2*fdd*r*s - 84*D1**2*fdd*r + 14*D1**2*fdd*s**2 - 98*D1**2*fdd*s + 49*D1**2*fdd + 700*D1**2*gd2*s**2 - 350*D1**2*gdd2*s**2 + 3192*D1*Dd*K*f*s**2 - 1596*D1*Dd*K*f*s + 798*D1*Dd*K*f - 3472*D1*Dd*K*fd*s**2 + 4620*D1*Dd*K*fd*s - 938*D1*Dd*K*fd - 336*D1*Dd*f**2*r*s + 84*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 48*D1*Dd*f**2 + 1344*D1*Dd*f*fd*r*s - 504*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s**2 - 2544*D1*Dd*f*fd*s + 660*D1*Dd*f*fd - 672*D1*Dd*f*r*s + 168*D1*Dd*f*r + 168*D1*Dd*f*s**2 + 84*D1*Dd*f*s + 42*D1*Dd*f + 672*D1*Dd*fd*r*s - 420*D1*Dd*fd*r + 112*D1*Dd*fd*s**2 - 504*D1*Dd*fd*s + 182*D1*Dd*fd + 2800*D1*Dd*g2*s**2 - 1400*D1*Dd*g2*s + 700*D1*Dd*g2 - 2800*D1*Dd*gd2*s**2 + 700*D1*Dd*gd2*s - 1736*D1*Ddd*K*f*s**2 + 868*D1*Ddd*K*f*s - 434*D1*Ddd*K*f + 336*D1*Ddd*f**2*r*s - 84*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 120*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + 336*D1*Ddd*f*r*s - 84*D1*Ddd*f*r + 56*D1*Ddd*f*s**2 - 112*D1*Ddd*f*s + 14*D1*Ddd*f - 1400*D1*Ddd*g2*s**2 + 700*D1*Ddd*g2*s - 350*D1*Ddd*g2 + 70*D1*bd1*(D1*(-5*K*(3*s**2 - 2*s + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s + 15*s**2 - 10*s + 5) - Dd*(-5*K + 6*f + 5)*(12*s**2 - 7*s + 1)) - 5208*Dd**2*K*f*s**2 + 2604*Dd**2*K*f*s + 1008*Dd**2*f**2*r*s - 252*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 360*Dd**2*f**2*s + 84*Dd**2*f**2 + 1008*Dd**2*f*r*s - 252*Dd**2*f*r + 168*Dd**2*f*s**2 - 336*Dd**2*f*s + 84*Dd**2*f - 4200*Dd**2*g2*s**2 + 2100*Dd**2*g2*s) - 11*b1*(-616*D1**2*K*f*fd*s**2 + 616*D1**2*K*f*fd*s - 308*D1**2*K*f*fd + 322*D1**2*K*f*fdd*s**2 - 322*D1**2*K*f*fdd*s + 161*D1**2*K*f*fdd + 322*D1**2*K*fd**2*s**2 - 322*D1**2*K*fd**2*s - 420*D1**2*b2*fd*s**2 + 840*D1**2*b2*fd*s - 420*D1**2*b2*fd + 210*D1**2*b2*fdd*s**2 - 420*D1**2*b2*fdd*s + 210*D1**2*b2*fdd + 70*D1**2*bd1**2*s*(3*s - 2)*(-5*K + 6*f + 5) - 420*D1**2*bd2*f*s**2 + 420*D1**2*bd2*fd*s**2 - 420*D1**2*bd2*fd*s + D1**2*bdd1*(-6*f**2*(6*s**2 + s*(28*r + 76) - 45) + 7*f*(K*(124*s**2 + 10*s - 5) - 24*r*s - 4*s**2 + 2*s + 5) + 350*g2*(2*s**2 - 2*s + 1)) + 210*D1**2*bdd2*f*s**2 + 384*D1**2*f**2*fd*r*s - 128*D1**2*f**2*fd*r + 1692*D1**2*f**2*fd*s**2 - 1592*D1**2*f**2*fd*s + 764*D1**2*f**2*fd - 408*D1**2*f**2*fdd*r*s + 136*D1**2*f**2*fdd*r - 1008*D1**2*f**2*fdd*s**2 + 940*D1**2*f**2*fdd*s - 436*D1**2*f**2*fdd - 816*D1**2*f*fd**2*r*s + 272*D1**2*f*fd**2*r - 2016*D1**2*f*fd**2*s**2 + 1880*D1**2*f*fd**2*s - 68*D1**2*f*fd**2 + 224*D1**2*f*fd*r*s - 112*D1**2*f*fd*r - 104*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s - 52*D1**2*f*fd - 168*D1**2*f*fdd*r*s + 84*D1**2*f*fdd*r + 38*D1**2*f*fdd*s**2 + 46*D1**2*f*fdd*s + 19*D1**2*f*fdd + 1596*D1**2*f*gd2*s**2 - 868*D1**2*f*gdd2*s**2 - 168*D1**2*fd**2*r*s + 84*D1**2*fd**2*r + 38*D1**2*fd**2*s**2 + 46*D1**2*fd**2*s - 84*D1**2*fd**2 + 1596*D1**2*fd*g2*s**2 - 3472*D1**2*fd*g2*s + 1736*D1**2*fd*g2 - 1736*D1**2*fd*gd2*s**2 + 1876*D1**2*fd*gd2*s - 868*D1**2*fdd*g2*s**2 + 1876*D1**2*fdd*g2*s - 938*D1**2*fdd*g2 - 1232*D1*Dd*K*f**2*s**2 + 616*D1*Dd*K*f**2*s - 308*D1*Dd*K*f**2 + 2576*D1*Dd*K*f*fd*s**2 - 1932*D1*Dd*K*f*fd*s + 322*D1*Dd*K*f*fd - 1680*D1*Dd*b2*f*s**2 + 840*D1*Dd*b2*f*s - 420*D1*Dd*b2*f + 1680*D1*Dd*b2*fd*s**2 - 2100*D1*Dd*b2*fd*s + 420*D1*Dd*b2*fd + 1680*D1*Dd*bd2*f*s**2 - 420*D1*Dd*bd2*f*s + 512*D1*Dd*f**3*r*s - 128*D1*Dd*f**3*r + 2256*D1*Dd*f**3*s**2 - 1256*D1*Dd*f**3*s + 564*D1*Dd*f**3 - 3264*D1*Dd*f**2*fd*r*s + 952*D1*Dd*f**2*fd*r - 8064*D1*Dd*f**2*fd*s**2 + 6184*D1*Dd*f**2*fd*s - 1076*D1*Dd*f**2*fd + 448*D1*Dd*f**2*r*s - 112*D1*Dd*f**2*r - 208*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s - 52*D1*Dd*f**2 - 1344*D1*Dd*f*fd*r*s + 504*D1*Dd*f*fd*r + 304*D1*Dd*f*fd*s**2 + 276*D1*Dd*f*fd*s - 130*D1*Dd*f*fd + 6384*D1*Dd*f*g2*s**2 - 3192*D1*Dd*f*g2*s + 1596*D1*Dd*f*g2 - 6944*D1*Dd*f*gd2*s**2 + 1736*D1*Dd*f*gd2*s - 6944*D1*Dd*fd*g2*s**2 + 9240*D1*Dd*fd*g2*s - 1876*D1*Dd*fd*g2 + 644*D1*Ddd*K*f**2*s**2 - 322*D1*Ddd*K*f**2*s + 161*D1*Ddd*K*f**2 + 840*D1*Ddd*b2*f*s**2 - 420*D1*Ddd*b2*f*s + 210*D1*Ddd*b2*f - 544*D1*Ddd*f**3*r*s + 136*D1*Ddd*f**3*r - 1344*D1*Ddd*f**3*s**2 + 808*D1*Ddd*f**3*s - 336*D1*Ddd*f**3 - 336*D1*Ddd*f**2*r*s + 84*D1*Ddd*f**2*r + 76*D1*Ddd*f**2*s**2 + 46*D1*Ddd*f**2*s + 19*D1*Ddd*f**2 - 3472*D1*Ddd*f*g2*s**2 + 1736*D1*Ddd*f*g2*s - 868*D1*Ddd*f*g2 + 2*D1*bd1*(6*D1*f**2*(-8*s**2 + s*(14*r + 83) - 45) - D1*f*(7*K*(114*s**2 + 10*s - 5) + 6*fd*(14*r*(4*s - 1) + 12*s**2 - 20*s + 7) - 168*r*s + 42*s**2 + 14*s + 35) - 7*D1*(fd*(12*r*(2*s - 1) + s**2*(4 - 124*K) + s*(129*K - 15) + 6) + 50*g2*(2*s**2 - 2*s + 1) + 50*gd2*s*(1 - 2*s)) - 12*Dd*f**2*(7*r*(8*s - 1) + 12*s**2 + 66*s - 19) - 7*Dd*f*(K*(-496*s**2 + 104*s + 5) + 12*r*(8*s - 1) + 16*s**2 - 20*s + 1) + 350*Dd*g2*(8*s**2 - 6*s + 1)) + 1932*Dd**2*K*f**2*s**2 - 966*Dd**2*K*f**2*s + 2520*Dd**2*b2*f*s**2 - 1260*Dd**2*b2*f*s - 1632*Dd**2*f**3*r*s + 408*Dd**2*f**3*r - 4032*Dd**2*f**3*s**2 + 2424*Dd**2*f**3*s - 136*Dd**2*f**3 - 1008*Dd**2*f**2*r*s + 252*Dd**2*f**2*r + 228*Dd**2*f**2*s**2 + 138*Dd**2*f**2*s - 84*Dd**2*f**2 - 10416*Dd**2*f*g2*s**2 + 5208*Dd**2*f*g2*s) + 330*b2*(D1**2*(f*(6*fd*(2*s**2 - 2*s + 1) + fdd*(-6*s**2 + 6*s - 3) + s**2*(14*bd1 - 7*bdd1)) - 2*fd*s*(7*bd1 + 3*fd)*(s - 1)) + D1*f*(6*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(7*bd1*s + fd*(6*s - 3)) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(2310*d**2*k2) - D1**2*Pk1*Pkd2*ct**2*(210*D1**2*K*bd1**2*f*s**2 + 840*D1**2*K*bd1**2*f*s - 504*D1**2*K*bd1*f**2*s**2 + 1260*D1**2*K*bd1*f*fd*s**2 - 630*D1**2*K*bd1*f*fd*s + 315*D1**2*K*bdd1*f**2*s**2 + 792*D1**2*bd1**2*f**2*r*s - 396*D1**2*bd1**2*f**2*r + 2430*D1**2*bd1**2*f**2*s**2 - 1998*D1**2*bd1**2*f**2*s + 198*D1**2*bd1**2*f**2 + 588*D1**2*bd1**2*f*r*s - 294*D1**2*bd1**2*f*r + 1638*D1**2*bd1**2*f*s**2 - 588*D1**2*bd1**2*f*s + 3360*D1**2*bd1**2*g2*s**2 - 3360*D1**2*bd1**2*g2*s + 924*D1**2*bd1*bd2*f*s**2 + 126*D1**2*bd1*bd2*f*s - 250*D1**2*bd1*f**3*r*s + 250*D1**2*bd1*f**3*r - 1080*D1**2*bd1*f**3*s**2 + 1440*D1**2*bd1*f**3*s - 720*D1**2*bd1*f**3 + 1020*D1**2*bd1*f**2*fd*r*s - 510*D1**2*bd1*f**2*fd*r + 4050*D1**2*bd1*f**2*fd*s**2 - 3320*D1**2*bd1*f**2*fd*s + 170*D1**2*bd1*f**2*fd + 126*D1**2*bd1*f**2*r*s - 504*D1**2*bd1*f**2*s**2 + 1260*D1**2*bd1*f*fd*s**2 - 630*D1**2*bd1*f*fd*s + 420*D1**2*bd1*f*g2*s**2 + 2520*D1**2*bd1*f*g2*s - 1260*D1**2*bd1*f*g2 - 420*D1**2*bd1*f*gd2*s**2 - 1680*D1**2*bd1*f*gd2*s - 420*D1**2*bd1*fd*g2*s**2 + 420*D1**2*bd1*fd*g2*s - 504*D1**2*bd2*f**2*s**2 + 1260*D1**2*bd2*f*fd*s**2 - 630*D1**2*bd2*f*fd*s + 170*D1**2*bdd1*f**3*r*s - 170*D1**2*bdd1*f**3*r + 675*D1**2*bdd1*f**3*s**2 - 900*D1**2*bdd1*f**3*s + 450*D1**2*bdd1*f**3 + 315*D1**2*bdd1*f**2*s**2 - 210*D1**2*bdd1*f*g2*s**2 - 1680*D1**2*bdd1*f*g2*s + 840*D1**2*bdd1*f*g2 + 315*D1**2*bdd2*f**2*s**2 + 1008*D1**2*f**2*gd2*s**2 - 630*D1**2*f**2*gdd2*s**2 + 2016*D1**2*f*fd*g2*s**2 - 2016*D1**2*f*fd*g2*s + 1008*D1**2*f*fd*g2 - 2520*D1**2*f*fd*gd2*s**2 + 1260*D1**2*f*fd*gd2*s - 1260*D1**2*f*fdd*g2*s**2 + 1260*D1**2*f*fdd*g2*s - 630*D1**2*f*fdd*g2 - 1260*D1**2*fd**2*g2*s**2 + 1260*D1**2*fd**2*g2*s + 2520*D1*Dd*K*bd1*f**2*s**2 - 630*D1*Dd*K*bd1*f**2*s + 1360*D1*Dd*bd1*f**3*r*s - 850*D1*Dd*bd1*f**3*r + 5400*D1*Dd*bd1*f**3*s**2 - 5120*D1*Dd*bd1*f**3*s + 1070*D1*Dd*bd1*f**3 + 2520*D1*Dd*bd1*f**2*s**2 - 630*D1*Dd*bd1*f**2*s - 1680*D1*Dd*bd1*f*g2*s**2 - 6300*D1*Dd*bd1*f*g2*s + 1680*D1*Dd*bd1*f*g2 + 2520*D1*Dd*bd2*f**2*s**2 - 630*D1*Dd*bd2*f**2*s + 4032*D1*Dd*f**2*g2*s**2 - 2016*D1*Dd*f**2*g2*s + 1008*D1*Dd*f**2*g2 - 5040*D1*Dd*f**2*gd2*s**2 + 1260*D1*Dd*f**2*gd2*s - 10080*D1*Dd*f*fd*g2*s**2 + 7560*D1*Dd*f*fd*g2*s - 1260*D1*Dd*f*fd*g2 - 2520*D1*Ddd*f**2*g2*s**2 + 1260*D1*Ddd*f**2*g2*s - 630*D1*Ddd*f**2*g2 - 7560*Dd**2*f**2*g2*s**2 + 3780*Dd**2*f**2*g2*s - 42*b1**3*(D1**2*s*(5*fd*r + 17*fd*s - 5*fdd*r - 11*fdd*s) + D1*(Dd*(-25*K*(4*s**2 - 2*s + 1) + f*(5*r*(4*s - 1) + 68*s**2 - 39*s + 17) - 40*fd*r*s + 5*fd*r - 88*fd*s**2 + 27*fd*s + 40*r*s - 10*r + 60*s**2 - 40*s + 15) + Ddd*(20*K*(4*s**2 - 2*s + 1) + f*(r*(5 - 20*s) - 44*s**2 + 27*s - 11) - 20*r*s + 5*r - 60*s**2 + 35*s - 15)) - Dd**2*(f*(15*r*(4*s - 1) + 132*s**2 - 81*s + 5) + 15*r*(4*s - 1) + 5*s**2*(36 - 48*K) + 5*s*(24*K - 21) + 5)) - 3*b1**2*(70*D1**2*K*fd*s**2 - 560*D1**2*K*fd*s + 280*D1**2*K*fd - 35*D1**2*K*fdd*s**2 + 350*D1**2*K*fdd*s - 175*D1**2*K*fdd - 70*D1**2*bd2*s**2 - 14*D1**2*bdd1*(-20*K*(3*s**2 - 2*s + 1) + f*(5*r*(3*s - 1) + 33*s**2 - 27*s + 11) + 15*r*s - 5*r + 45*s**2 - 35*s + 15) + 35*D1**2*bdd2*s**2 + 360*D1**2*f*fd*r*s + 1284*D1**2*f*fd*s**2 - 426*D1**2*f*fd*s + 168*D1**2*f*fd - 264*D1**2*f*fdd*r*s - 810*D1**2*f*fdd*s**2 + 276*D1**2*f*fdd*s - 105*D1**2*f*fdd - 264*D1**2*fd**2*r*s - 810*D1**2*fd**2*s**2 + 276*D1**2*fd**2*s + 126*D1**2*fd*r*s + 70*D1**2*fd*r + 406*D1**2*fd*s**2 - 756*D1**2*fd*s + 280*D1**2*fd - 98*D1**2*fdd*r*s - 273*D1**2*fdd*s**2 + 448*D1**2*fdd*s - 175*D1**2*fdd + 700*D1**2*gd2*s**2 - 560*D1**2*gdd2*s**2 + 280*D1*Dd*K*f*s**2 - 140*D1*Dd*K*f*s + 70*D1*Dd*K*f - 280*D1*Dd*K*fd*s**2 + 1470*D1*Dd*K*fd*s - 350*D1*Dd*K*fd - 280*D1*Dd*b2*s**2 + 140*D1*Dd*b2*s - 70*D1*Dd*b2 + 280*D1*Dd*bd2*s**2 - 70*D1*Dd*bd2*s + 720*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r + 2568*D1*Dd*f**2*s**2 - 1464*D1*Dd*f**2*s + 642*D1*Dd*f**2 - 2112*D1*Dd*f*fd*r*s + 264*D1*Dd*f*fd*r - 6480*D1*Dd*f*fd*s**2 + 2988*D1*Dd*f*fd*s - 276*D1*Dd*f*fd + 504*D1*Dd*f*r*s - 126*D1*Dd*f*r + 1624*D1*Dd*f*s**2 - 938*D1*Dd*f*s + 406*D1*Dd*f - 784*D1*Dd*fd*r*s + 98*D1*Dd*fd*r - 2184*D1*Dd*fd*s**2 + 2436*D1*Dd*fd*s - 448*D1*Dd*fd + 2800*D1*Dd*g2*s**2 - 1400*D1*Dd*g2*s + 700*D1*Dd*g2 - 4480*D1*Dd*gd2*s**2 + 1120*D1*Dd*gd2*s - 140*D1*Ddd*K*f*s**2 + 70*D1*Ddd*K*f*s - 35*D1*Ddd*K*f + 140*D1*Ddd*b2*s**2 - 70*D1*Ddd*b2*s + 35*D1*Ddd*b2 - 528*D1*Ddd*f**2*r*s + 132*D1*Ddd*f**2*r - 1620*D1*Ddd*f**2*s**2 + 942*D1*Ddd*f**2*s - 405*D1*Ddd*f**2 - 392*D1*Ddd*f*r*s + 98*D1*Ddd*f*r - 1092*D1*Ddd*f*s**2 + 644*D1*Ddd*f*s - 273*D1*Ddd*f - 2240*D1*Ddd*g2*s**2 + 1120*D1*Ddd*g2*s - 560*D1*Ddd*g2 + 14*D1*bd1*(D1*(-25*K*(3*s**2 - 2*s + 1) + f*(5*r*(3*s - 1) + 51*s**2 - 39*s + 17) - 30*fd*r*s + 5*fd*r - 66*fd*s**2 + 27*fd*s + 30*r*s - 10*r + 45*s**2 - 40*s + 15) + Dd*(40*K*(12*s**2 - 7*s + 1) + f*(-5*r*(24*s - 7) - 264*s**2 + 189*s - 32) - 120*r*s + 35*r - 360*s**2 + 245*s - 40)) - 420*Dd**2*K*f*s**2 + 210*Dd**2*K*f*s + 420*Dd**2*b2*s**2 - 210*Dd**2*b2*s - 1584*Dd**2*f**2*r*s + 396*Dd**2*f**2*r - 4860*Dd**2*f**2*s**2 + 2826*Dd**2*f**2*s - 132*Dd**2*f**2 - 1176*Dd**2*f*r*s + 294*Dd**2*f*r - 3276*Dd**2*f*s**2 + 1932*Dd**2*f*s - 98*Dd**2*f - 6720*Dd**2*g2*s**2 + 3360*Dd**2*g2*s) + b1*(210*D1**2*K*bdd1*f*s**2 + 840*D1**2*K*bdd1*f*s - 420*D1**2*K*bdd1*f - 1008*D1**2*K*f*fd*s**2 + 1008*D1**2*K*f*fd*s - 504*D1**2*K*f*fd + 630*D1**2*K*f*fdd*s**2 - 630*D1**2*K*f*fdd*s + 315*D1**2*K*f*fdd + 630*D1**2*K*fd**2*s**2 - 630*D1**2*K*fd**2*s + 42*D1**2*bd1**2*(f*(10*r*(3*s - 1) + 66*s**2 - 54*s + 5) + 5*r*(6*s - 2) - 5*s**2*(24*K - 18) + 5*s*(16*K - 14) + 5) - 714*D1**2*bd2*f*s**2 + 924*D1**2*bd2*fd*s**2 - 1050*D1**2*bd2*fd*s + 792*D1**2*bdd1*f**2*r*s - 396*D1**2*bdd1*f**2*r + 2430*D1**2*bdd1*f**2*s**2 - 1998*D1**2*bdd1*f**2*s + 900*D1**2*bdd1*f**2 + 588*D1**2*bdd1*f*r*s - 294*D1**2*bdd1*f*r + 1638*D1**2*bdd1*f*s**2 - 588*D1**2*bdd1*f*s + 294*D1**2*bdd1*f + 3360*D1**2*bdd1*g2*s**2 - 3360*D1**2*bdd1*g2*s + 1680*D1**2*bdd1*g2 + 462*D1**2*bdd2*f*s**2 - 750*D1**2*f**2*fd*r*s - 3240*D1**2*f**2*fd*s**2 + 970*D1**2*f**2*fd*s - 360*D1**2*f**2*fd + 510*D1**2*f**2*fdd*r*s + 2025*D1**2*f**2*fdd*s**2 - 620*D1**2*f**2*fdd*s + 225*D1**2*f**2*fdd + 1020*D1**2*f*fd**2*r*s + 4050*D1**2*f*fd**2*s**2 - 1240*D1**2*f*fd**2*s + 252*D1**2*f*fd*r*s - 126*D1**2*f*fd*r - 1008*D1**2*f*fd*s**2 + 882*D1**2*f*fd*s - 504*D1**2*f*fd + 630*D1**2*f*fdd*s**2 - 630*D1**2*f*fdd*s + 315*D1**2*f*fdd + 420*D1**2*f*gd2*s**2 - 210*D1**2*f*gdd2*s**2 + 630*D1**2*fd**2*s**2 - 630*D1**2*fd**2*s + 420*D1**2*fd*g2*s**2 - 3360*D1**2*fd*g2*s + 1680*D1**2*fd*g2 - 420*D1**2*fd*gd2*s**2 + 2100*D1**2*fd*gd2*s - 210*D1**2*fdd*g2*s**2 + 2100*D1**2*fdd*g2*s - 1050*D1**2*fdd*g2 - 2016*D1*Dd*K*f**2*s**2 + 1008*D1*Dd*K*f**2*s - 504*D1*Dd*K*f**2 + 5040*D1*Dd*K*f*fd*s**2 - 3780*D1*Dd*K*f*fd*s + 630*D1*Dd*K*f*fd + 3696*D1*Dd*bd2*f*s**2 - 924*D1*Dd*bd2*f*s - 1000*D1*Dd*f**3*r*s + 250*D1*Dd*f**3*r - 4320*D1*Dd*f**3*s**2 + 2410*D1*Dd*f**3*s - 1080*D1*Dd*f**3 + 4080*D1*Dd*f**2*fd*r*s - 510*D1*Dd*f**2*fd*r + 16200*D1*Dd*f**2*fd*s**2 - 7040*D1*Dd*f**2*fd*s + 620*D1*Dd*f**2*fd + 504*D1*Dd*f**2*r*s - 126*D1*Dd*f**2*r - 2016*D1*Dd*f**2*s**2 + 882*D1*Dd*f**2*s - 504*D1*Dd*f**2 + 5040*D1*Dd*f*fd*s**2 - 3780*D1*Dd*f*fd*s + 630*D1*Dd*f*fd + 1680*D1*Dd*f*g2*s**2 - 840*D1*Dd*f*g2*s + 420*D1*Dd*f*g2 - 1680*D1*Dd*f*gd2*s**2 + 420*D1*Dd*f*gd2*s - 1680*D1*Dd*fd*g2*s**2 + 8820*D1*Dd*fd*g2*s - 2100*D1*Dd*fd*g2 + 1260*D1*Ddd*K*f**2*s**2 - 630*D1*Ddd*K*f**2*s + 315*D1*Ddd*K*f**2 + 680*D1*Ddd*f**3*r*s - 170*D1*Ddd*f**3*r + 2700*D1*Ddd*f**3*s**2 - 1520*D1*Ddd*f**3*s + 675*D1*Ddd*f**3 + 1260*D1*Ddd*f**2*s**2 - 630*D1*Ddd*f**2*s + 315*D1*Ddd*f**2 - 840*D1*Ddd*f*g2*s**2 + 420*D1*Ddd*f*g2*s - 210*D1*Ddd*f*g2 - 6*D1*bd1*(D1*(3*f**2*(30*r*(2*s - 1) + 214*s**2 - 173*s + 79) + f*(35*K*(2*s**2 + 6*s - 3) - 3*fd*(44*r*(4*s - 1) + 540*s**2 - 314*s + 11) + 14*r*(9*s - 7) + 406*s**2 - 91*s + 63) + 7*fd*(r*(7 - 28*s) - s**2*(10*K + 78) + s*(30*K + 78) - 7) + 350*g2*(2*s**2 - 2*s + 1) + 7*s*(5*bd2 - 80*gd2)*(2*s - 1)) - Dd*(3*f**2*(44*r*(8*s - 3) + 1080*s**2 - 758*s + 133) + 7*f*(10*K*(4*s**2 + 7*s - 2) + 14*r*(8*s - 3) + 312*s**2 - 148*s + 21) + 560*g2*(8*s**2 - 6*s + 1))) + 3780*Dd**2*K*f**2*s**2 - 1890*Dd**2*K*f**2*s + 2040*Dd**2*f**3*r*s - 510*Dd**2*f**3*r + 8100*Dd**2*f**3*s**2 - 4560*Dd**2*f**3*s + 170*Dd**2*f**3 + 3780*Dd**2*f**2*s**2 - 1890*Dd**2*f**2*s - 2520*Dd**2*f*g2*s**2 + 1260*Dd**2*f*g2*s + 21*b2*(-5*D1**2*bdd1*(2*s**2 - 2*s + 1) - 34*D1**2*fd*s**2 + 80*D1**2*fd*s - 40*D1**2*fd + 22*D1**2*fdd*s**2 - 50*D1**2*fdd*s + 25*D1**2*fdd - 136*D1*Dd*f*s**2 + 68*D1*Dd*f*s - 34*D1*Dd*f + 176*D1*Dd*fd*s**2 - 244*D1*Dd*fd*s + 50*D1*Dd*fd + 88*D1*Ddd*f*s**2 - 44*D1*Ddd*f*s + 22*D1*Ddd*f + 10*D1*bd1*(D1*(2*s**2 - 2*s + 1) + Dd*(-8*s**2 + 6*s - 1)) + 264*Dd**2*f*s**2 - 132*Dd**2*f*s)) - 21*b2*(10*D1**2*bd1**2*s*(s - 1) + D1**2*bdd1*f*(-22*s**2 - 6*s + 3) + 3*D1**2*(f*(8*fd - 5*fdd)*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1)) + 2*D1*bd1*(D1*f*(17*s**2 + 6*s - 3) - 22*D1*fd*s*(s - 1) + Dd*f*(-88*s**2 + 10*s + 3)) + 3*D1*f*(8*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(8*s**2 - 6*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 90*Dd**2*f**2*s*(1 - 2*s)))/(630*d**2*k2) + D1**2*Pk1*Pkd2*ct**2*k2**3*st**4*(3*D1*bd1*f*(D1*(24*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 3*b1*(D1*Dd*f*(24*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(24*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(32*f*(4*r*s - r - s) - 25*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(32*f*fd*(r*(3*s - 1) - s) + 5*f*(-3*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(-4*r*s + r + s)) - 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1**2*k3**2) + 2*D1**2*Pk1*Pkd2*ct**2*k2**3*st**2*(35*D1*b1**2*(D1*fd*r*s + Dd*f*(r*(4*s - 1) - s)) - D1*bd1*f*(D1*(35*b1*(-2*r*s + r + s) + f*(4*r*s + 17*r - 21*s) + 12*fd*(r*(4*s - 2) - s + 1)) + 12*Dd*f*(r*(8*s - 5) - s + 1)) + 3*D1*f**2*(-4*D1*bdd1*r*(s - 1) + 3*D1*fd*(-3*r*s + r + s) + 3*Dd*f*(-4*r*s + r + s)) + b1*(-4*D1*Dd*f*(f*(4*r*s - r - s) + 3*fd*(16*r*s - 2*r - 6*s + 1)) + D1*(D1*(f*fd*(r*(21 - 8*s) - 17*s) + 12*f*fdd*s*(1 - 2*r) + 12*fd**2*s*(1 - 2*r)) + 12*Ddd*f**2*(-4*r*s + r + s)) - 12*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1**2*k3**2) + 2*D1**2*Pk1*Pkd2*ct**2*k2*st**2*(-3*D1**2*bd1**2*f**2*(r*(4*s - 1) - 2*s + 1) + D1**2*bdd1*f**2*r*(f*(7 - 14*s) - 12*s) + D1*bd1*f*(D1*(5*f**2*r*(2*s - 1) - 7*f*fd*(4*r*(3*s - 1) - 2*s + 1) + 17*f*r*s + 12*fd*(-4*r*s + r + s)) + Dd*f*(-7*f*(2*r*(8*s - 3) - 2*s + 1) - 96*r*s + 12*r + 12*s) + b1*(D1*(6*f*(4*r*s - r - 2*s) - 3*fd*(4*r - 1)*(4*s - 1) + s*(70*r - 35)) - 3*Dd*f*(8*r - 3)*(4*s - 1))) + b1**2*(D1*Dd*f*(-3*fd*(8*r - 1)*(4*s - 1) + (12*f + 35)*(r*(4*s - 1) - s)) + D1*(D1*r*(6*f*fd*(4*s - 1) + 3*f*fdd*(1 - 4*s) + fd**2*(3 - 12*s) + 35*fd*(s - 1)) + 6*Ddd*f**2*(-4*r*s + r + s)) - 6*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(f*(10*f + 17)*(r*(4*s - 1) - s) + fd*(-7*f*(48*r*s - 10*r - 14*s + 3) - 192*r*s + 72*r + 72*s - 24)) + D1*(D1*(f*fd*(r*(30*f*s - 5*f + 34*s - 17) - s*(10*f + 17)) + f*(3*bdd1*f*(-4*r*s + r + 2*s) + fdd*r*(f*(7 - 42*s) - 24*s + 12) + fdd*s*(14*f + 12)) + fd**2*(-7*f*(12*r*s - 2*r - 4*s + 1) - 24*r*s + 12*r + 12*s - 12)) - 2*Ddd*f**2*(7*f + 6)*(r*(4*s - 1) - s)) - 2*Dd**2*f**2*(7*f + 6)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1**2) + D1**2*Pk1*Pkd2*ct**2*k2*(D1**2*bd1*f*r*(-bd1*(3*f + 7)*(2*s - 1) - 21*f*s) + D1*b1*(7*D1*bd1**2*(f + 5)*(r*(6*s - 2) - 2*s + 1) + bd1*(D1*(f*fd*(r*(6 - 24*s) + 6*s - 3) + f*r*(27*f*(2*s - 1) + 98*s - 84) + 35*f*s + 7*fd*(-4*r*s + r + 2*s - 1)) - Dd*f*(3*f + 7)*(2*r*(8*s - 3) - 2*s + 1)) + f*(-D1*bdd1*r*(3*f + 7)*(2*s - 1) + 21*D1*fd*(-2*r*s + r + s) + 21*Dd*f*(-4*r*s + r + s))) + 7*b1**3*(D1*Dd*(r*(12*f*s - 3*f + 8*fd*s - fd + 80*s - 20) - s*(3*f + fd + 20)) + D1*(D1*r*s*(3*fd + fdd) + Ddd*(f + 5)*(4*r*s - r - s)) + Dd**2*(f + 5)*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(D1*Dd*(f*(27*f + 49)*(r*(4*s - 1) - s) + fd*(f*(-48*r*s + 6*r + 18*s - 3) - 56*r*s + 7*r + 35*s - 7)) + 7*D1*bd1*(D1*(r*(9*f*s - 3*f + 6*fd*s - fd + 60*s - 20) - s*(3*f + fd + 20)) + Dd*(f + 5)*(r*(24*s - 7) - 7*s + 2)) + D1*(7*D1*bdd1*(f + 5)*(r*(3*s - 1) - s) + D1*(fd**2*s*(3 - 6*r) + fd*(r*(54*f*s + 49*s + 35) + s*(-27*f - 84)) + fdd*s*(f*(3 - 6*r) - 7*r + 7)) - Ddd*f*(3*f + 7)*(r*(4*s - 1) - s)) - Dd**2*f*(3*f + 7)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1**2) + D1**2*Pk1*Pkd2*ct*f*st**6*(-11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(-6*fd*(4*s**2 - 2*s + 1) + 3*fdd*(4*s**2 - 2*s + 1) + s**2*(-22*bd1 + 11*bdd1)) + 2*fd*s*(11*bd1*(3*s - 1) + 9*fd*(2*s - 1))) + D1*f*(-6*Dd*f*(4*s**2 - 2*s + 1) + 2*Dd*(4*s - 1)*(11*bd1*s + 3*fd*(4*s - 1)) + 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(2*s - 1)))/(22*d**2*k1) - 2*D1**2*Pk1*Pkd2*ct*k1**3*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(35*d**2*k3**4) - 2*D1**2*Pk1*Pkd2*ct*k1**3*st**2*(21*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(44*C*D1**2*f*fd*r*s - 22*C*D1**2*f*fd*r + 44*C*D1**2*f*fd*s**2 - 44*C*D1**2*f*fd*s + 22*C*D1**2*f*fd - 36*C*D1**2*f*fdd*r*s + 18*C*D1**2*f*fdd*r - 36*C*D1**2*f*fdd*s**2 + 36*C*D1**2*f*fdd*s - 18*C*D1**2*f*fdd - 36*C*D1**2*fd**2*r*s + 18*C*D1**2*fd**2*r - 36*C*D1**2*fd**2*s**2 + 36*C*D1**2*fd**2*s + 88*C*D1*Dd*f**2*r*s - 22*C*D1*Dd*f**2*r + 88*C*D1*Dd*f**2*s**2 - 66*C*D1*Dd*f**2*s + 22*C*D1*Dd*f**2 - 288*C*D1*Dd*f*fd*r*s + 108*C*D1*Dd*f*fd*r - 288*C*D1*Dd*f*fd*s**2 + 252*C*D1*Dd*f*fd*s - 54*C*D1*Dd*f*fd - 72*C*D1*Ddd*f**2*r*s + 18*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 54*C*D1*Ddd*f**2*s - 18*C*D1*Ddd*f**2 - 216*C*Dd**2*f**2*r*s + 54*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 162*C*Dd**2*f**2*s - 18*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + 22*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s - 7*D1**2*f*fd - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 44*D1*Dd*f**2*r*s - 11*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 33*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 90*D1*Dd*f*fd*s - 9*D1*Dd*f*fd - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 27*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 21*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 81*Dd**2*f**2*s - 9*Dd**2*f**2) + f*(42*C*D1**2*f*fd*r*s - 14*C*D1**2*f*fd*r + 42*C*D1**2*f*fd*s**2 - 42*C*D1**2*f*fd*s + 14*C*D1**2*f*fd - 30*C*D1**2*f*fdd*r*s + 10*C*D1**2*f*fdd*r - 30*C*D1**2*f*fdd*s**2 + 30*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd - 60*C*D1**2*fd**2*r*s + 20*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 60*C*D1**2*fd**2*s - 10*C*D1**2*fd**2 + 56*C*D1*Dd*f**2*r*s - 14*C*D1*Dd*f**2*r + 56*C*D1*Dd*f**2*s**2 - 42*C*D1*Dd*f**2*s + 14*C*D1*Dd*f**2 - 240*C*D1*Dd*f*fd*r*s + 70*C*D1*Dd*f*fd*r - 240*C*D1*Dd*f*fd*s**2 + 210*C*D1*Dd*f*fd*s - 40*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r*s + 10*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 30*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r*s + 30*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 90*C*Dd**2*f**2*s - 10*C*Dd**2*f**2 - 21*D1**2*bd1**2*(2*s - 1)*(r + s - 1) - 9*D1**2*bdd1*f*(r + s - 1)*(2*C*s + s - 1) - 9*D1**2*f*fd*r*s + 3*D1**2*f*fd*r - 9*D1**2*f*fd*s**2 + 9*D1**2*f*fd*s - 3*D1**2*f*fd - 12*D1*Dd*f**2*r*s + 3*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 9*D1*Dd*f**2*s - 3*D1*Dd*f**2 + D1*bd1*(D1*(f*(s*(22*C + 11) - 18)*(r + s - 1) - 9*fd*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + r*(4*s - 2) + 4*s**2 - 5*s + 1)) - 9*Dd*f*(2*C*(r*(8*s - 1) + 8*s**2 - 7*s + 1) + r*(8*s - 5) + 8*s**2 - 11*s + 3))))/(105*d**2*k3**4) - 2*D1**2*Pk1*Pkd2*ct*k1**3*(-3*D1*f*(14*C*D1*bd1**2*(2*s - 1)*(r + s - 1) + 10*C*D1*bdd1*f*(s - 1)*(r + s - 1) + 10*C*Dd*bd1*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3) + D1*bd1*(10*C*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - f*(6*C - 7)*(s - 1)*(r + s - 1))) + 7*b1**2*(-6*C*Dd**2*f*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) + D1**2*s*(r + s)*(-6*C*fdd + fd*(2*C - 5)) + D1*(-6*C*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + Dd*(6*C*fd*(-8*r*s + r + s*(3 - 8*s)) + f*(2*C - 5)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))) + b1*(-42*C*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 30*C*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) - 3*D1**2*s*(2*r + 2*s - 1)*(10*C*f*fdd + 10*C*fd**2 + f*fd*(7 - 6*C)) + 7*D1*bd1*(-12*C*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2) + D1*(6*C*fd*(-4*r*s + r + s*(3 - 4*s)) + f*(2*C - 5)*(2*s - 1)*(r + s - 1))) - 3*D1*f*(10*C*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + Dd*(10*C*fd*(8*s - 1)*(2*r + 2*s - 1) - f*(6*C - 7)*(4*r*s - r + 4*s**2 - 3*s + 1)))))/(105*d**2*k3**4) - 3*D1**2*Pk1*Pkd2*ct*k1**3*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(70*d**2*k2**2*k3**2) - D1**2*Pk1*Pkd2*ct*k1**3*st**2*(35*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-35*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 152*D1**2*f*fd*s**2 + 212*D1**2*f*fd*s - 106*D1**2*f*fd + 76*D1**2*f*fdd*s**2 - 106*D1**2*f*fdd*s + 53*D1**2*f*fdd + 76*D1**2*fd**2*s**2 - 106*D1**2*fd**2*s - 304*D1*Dd*f**2*s**2 + 152*D1*Dd*f**2*s - 76*D1*Dd*f**2 + 608*D1*Dd*f*fd*s**2 - 576*D1*Dd*f*fd*s + 106*D1*Dd*f*fd + 152*D1*Ddd*f**2*s**2 - 76*D1*Ddd*f**2*s + 38*D1*Ddd*f**2 + 70*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 456*Dd**2*f**2*s**2 - 228*Dd**2*f**2*s) + f*(-70*D1**2*bd1**2*s*(s - 1) + D1**2*bdd1*f*(38*s**2 + 30*s - 15) - 25*D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + 2*D1*bd1*(D1*f*(-38*s**2 - 30*s + 15) + D1*fd*s*(76*s - 23) + Dd*f*(152*s**2 + 22*s - 15)) - 25*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 150*Dd**2*f**2*s*(1 - 2*s)))/(210*d**2*k2**2*k3**2) + D1**2*Pk1*Pkd2*ct*k1**3*(-D1*f*(s - 1)*(154*D1*bd1**2*s + 51*D1*bdd1*f*(s - 1) + 102*bd1*(D1*(-f*s + f + 2*fd*s) + Dd*f*(4*s - 1))) + 77*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-77*D1**2*bdd1*f*(2*s**2 - 2*s + 1) + 102*D1**2*s**2*(2*f*fd - f*fdd - fd**2) + 154*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 51*D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) + 4*Dd*fd*s*(1 - 4*s) + Ddd*f*(-4*s**2 + 2*s - 1)) + 306*Dd**2*f**2*s*(1 - 2*s)))/(210*d**2*k2**2*k3**2) - 2*D1**2*Pk1*Pkd2*ct*k1*k2**2*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(63*d**2*k3**4) - 2*D1**2*Pk1*Pkd2*ct*k1*k2**2*st**4*(7*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(92*C*D1**2*f*fd*r*s - 46*C*D1**2*f*fd*r + 92*C*D1**2*f*fd*s**2 - 92*C*D1**2*f*fd*s + 46*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r*s + 30*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 60*C*D1**2*f*fdd*s - 30*C*D1**2*f*fdd - 60*C*D1**2*fd**2*r*s + 30*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 60*C*D1**2*fd**2*s + 184*C*D1*Dd*f**2*r*s - 46*C*D1*Dd*f**2*r + 184*C*D1*Dd*f**2*s**2 - 138*C*D1*Dd*f**2*s + 46*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r*s + 180*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 420*C*D1*Dd*f*fd*s - 90*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r*s + 30*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 90*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r*s + 90*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 270*C*Dd**2*f**2*s - 30*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + 2*D1**2*f*fd*r*s + D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - D1**2*f*fd - 8*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r - 8*D1**2*f*fdd*s**2 + 7*D1**2*f*fdd*s - 3*D1**2*f*fdd - 8*D1**2*fd**2*r*s + 3*D1**2*fd**2*r - 8*D1**2*fd**2*s**2 + 7*D1**2*fd**2*s + 4*D1*Dd*f**2*r*s - D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 3*D1*Dd*f**2*s + D1*Dd*f**2 - 64*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 64*D1*Dd*f*fd*s**2 + 52*D1*Dd*f*fd*s - 10*D1*Dd*f*fd - 16*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r - 16*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 4*D1*Ddd*f**2 + 7*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 48*Dd**2*f**2*r*s + 12*Dd**2*f**2*r - 48*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s - 4*Dd**2*f**2) + f*(54*C*D1**2*f*fd*r*s - 18*C*D1**2*f*fd*r + 54*C*D1**2*f*fd*s**2 - 54*C*D1**2*f*fd*s + 18*C*D1**2*f*fd - 30*C*D1**2*f*fdd*r*s + 10*C*D1**2*f*fdd*r - 30*C*D1**2*f*fdd*s**2 + 30*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd - 60*C*D1**2*fd**2*r*s + 20*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 60*C*D1**2*fd**2*s - 10*C*D1**2*fd**2 + 72*C*D1*Dd*f**2*r*s - 18*C*D1*Dd*f**2*r + 72*C*D1*Dd*f**2*s**2 - 54*C*D1*Dd*f**2*s + 18*C*D1*Dd*f**2 - 240*C*D1*Dd*f*fd*r*s + 70*C*D1*Dd*f*fd*r - 240*C*D1*Dd*f*fd*s**2 + 210*C*D1*Dd*f*fd*s - 40*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r*s + 10*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 30*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r*s + 30*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 90*C*Dd**2*f**2*s - 10*C*Dd**2*f**2 - 7*D1**2*bd1**2*(2*s - 1)*(r + s - 1) - D1**2*bdd1*f*(r + s - 1)*(30*C*s + 4*s - 1) + 3*D1**2*f*fd*r*s - D1**2*f*fd*r + 3*D1**2*f*fd*s**2 - 3*D1**2*f*fd*s + D1**2*f*fd - 3*D1**2*f*fdd*r*s + D1**2*f*fdd*r - 3*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s - D1**2*f*fdd - 6*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s - D1**2*fd**2 + 4*D1*Dd*f**2*r*s - D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 3*D1*Dd*f**2*s + D1*Dd*f**2 - 24*D1*Dd*f*fd*r*s + 7*D1*Dd*f*fd*r - 24*D1*Dd*f*fd*s**2 + 21*D1*Dd*f*fd*s - 4*D1*Dd*f*fd - 4*D1*Ddd*f**2*r*s + D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 3*D1*Ddd*f**2*s - D1*Ddd*f**2 + D1*bd1*(D1*(f*(r + s - 1)*(46*C*s + s - 2) - fd*(30*C*(r*(4*s - 1) + (1 - 2*s)**2) + 16*r*s - 5*r + 16*s**2 - 17*s + 4)) - 2*Dd*f*(15*C*(8*r*s - r + 8*s**2 - 7*s + 1) + (4*s - 1)*(4*r + 4*s - 3))) - 12*Dd**2*f**2*r*s + 3*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 9*Dd**2*f**2*s - Dd**2*f**2))/(35*d**2*k3**4) - 2*D1**2*Pk1*Pkd2*ct*k1*k2**2*st**2*(D1*f*(-21*D1*bd1**2*(6*C + 1)*(2*s - 1)*(r + s - 1) + D1*bd1*(f*(r + s - 1)*(2*C*(5*s - 47) + 4*s - 11) + fd*(-54*C - 9)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - 9*D1*bdd1*f*(6*C + 1)*(s - 1)*(r + s - 1) - 9*Dd*bd1*f*(6*C + 1)*(r*(8*s - 5) + 8*s**2 - 11*s + 3) - f*(36*C + 3)*(D1*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1))) + 7*b1**2*(D1**2*s*(r + s)*(26*C*fd - 18*C*fdd + fd - 3*fdd) + D1*(Dd*(f*(26*C + 1)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(18*C + 3)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(-18*C - 3)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(18*C + 3)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(20*C*D1**2*f*fd*r*s + 84*C*D1**2*f*fd*r + 20*C*D1**2*f*fd*s**2 + 74*C*D1**2*f*fd*s - 84*C*D1**2*f*fd - 108*C*D1**2*f*fdd*r*s - 108*C*D1**2*f*fdd*s**2 + 54*C*D1**2*f*fdd*s - 108*C*D1**2*fd**2*r*s - 108*C*D1**2*fd**2*s**2 + 54*C*D1**2*fd**2*s + 40*C*D1*Dd*f**2*r*s - 10*C*D1*Dd*f**2*r + 40*C*D1*Dd*f**2*s**2 - 30*C*D1*Dd*f**2*s + 10*C*D1*Dd*f**2 - 864*C*D1*Dd*f*fd*r*s + 108*C*D1*Dd*f*fd*r - 864*C*D1*Dd*f*fd*s**2 + 540*C*D1*Dd*f*fd*s - 54*C*D1*Dd*f*fd - 216*C*D1*Ddd*f**2*r*s + 54*C*D1*Ddd*f**2*r - 216*C*D1*Ddd*f**2*s**2 + 162*C*D1*Ddd*f**2*s - 54*C*D1*Ddd*f**2 - 648*C*Dd**2*f**2*r*s + 162*C*Dd**2*f**2*r - 648*C*Dd**2*f**2*s**2 + 486*C*Dd**2*f**2*s - 54*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(6*C + 1)*(2*s - 1)*(r + s - 1) + 8*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 + 3*D1**2*f*fd*s - 7*D1**2*f*fd - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 90*D1*Dd*f*fd*s - 9*D1*Dd*f*fd - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 27*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(26*C + 1)*(2*s - 1)*(r + s - 1) - fd*(18*C + 3)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(-36*C - 6)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 81*Dd**2*f**2*s - 9*Dd**2*f**2))/(105*d**2*k3**4) + D1**2*Pk1*Pkd2*ct*k1*st**6*(-9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(-6*s**2 + 4*s - 2) + fdd*(3*s**2 - 2*s + 1) + s**2*(-18*bd1 + 9*bdd1)) + 2*fd*s*(9*bd1*(2*s - 1) + fd*(3*s - 2))) + D1*f*(-2*Dd*f*(4*s**2 - 2*s + 1) + 2*Dd*(4*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)))/(14*d**2*k3**2) - D1**2*Pk1*Pkd2*ct*k1*st**4*(105*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(32*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 464*C*D1**2*f*fd*s**2 - 464*C*D1**2*f*fd*s + 232*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*r - 232*C*D1**2*f*fdd*s**2 + 232*C*D1**2*f*fdd*s - 116*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*r - 232*C*D1**2*fd**2*s**2 + 232*C*D1**2*fd**2*s + 64*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*r + 928*C*D1*Dd*f**2*s**2 - 480*C*D1*Dd*f**2*s + 232*C*D1*Dd*f**2 - 128*C*D1*Dd*f*fd*r*s + 48*C*D1*Dd*f*fd*r - 1856*C*D1*Dd*f*fd*s**2 + 1408*C*D1*Dd*f*fd*s - 240*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r*s + 8*C*D1*Ddd*f**2*r - 464*C*D1*Ddd*f**2*s**2 + 240*C*D1*Ddd*f**2*s - 116*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r*s + 24*C*Dd**2*f**2*r - 1392*C*Dd**2*f**2*s**2 + 720*C*Dd**2*f**2*s - 8*C*Dd**2*f**2 - 35*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 168*D1**2*f*fd*r*s + 84*D1**2*f*fd*r - 260*D1**2*f*fd*s**2 + 280*D1**2*f*fd*s - 140*D1**2*f*fd + 112*D1**2*f*fdd*r*s - 56*D1**2*f*fdd*r + 158*D1**2*f*fdd*s**2 - 168*D1**2*f*fdd*s + 84*D1**2*f*fdd + 112*D1**2*fd**2*r*s - 56*D1**2*fd**2*r + 158*D1**2*fd**2*s**2 - 168*D1**2*fd**2*s - 336*D1*Dd*f**2*r*s + 84*D1*Dd*f**2*r - 520*D1*Dd*f**2*s**2 + 344*D1*Dd*f**2*s - 130*D1*Dd*f**2 + 896*D1*Dd*f*fd*r*s - 336*D1*Dd*f*fd*r + 1264*D1*Dd*f*fd*s**2 - 1100*D1*Dd*f*fd*s + 224*D1*Dd*f*fd + 224*D1*Ddd*f**2*r*s - 56*D1*Ddd*f**2*r + 316*D1*Ddd*f**2*s**2 - 214*D1*Ddd*f**2*s + 79*D1*Ddd*f**2 + 70*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 672*Dd**2*f**2*r*s - 168*Dd**2*f**2*r + 948*Dd**2*f**2*s**2 - 642*Dd**2*f**2*s + 56*Dd**2*f**2) + f*(-210*D1**2*bd1**2*s*(s - 1) - 3*D1**2*bdd1*f*(s**2*(116*C - 79) + s*(8*C*(r - 1) - 56*r + 46) + 5) + 4*D1**2*(f*(fd*(2*C*(6*r*s - 2*r + 87*s**2 - 60*s + 29) - 57*r*s + 19*r - 63*s**2 + 61*s - 21) + fdd*(C*(-6*r*s + 2*r - 87*s**2 + 60*s - 29) + 42*r*s - 14*r + 36*s**2 - 38*s + 12)) - 2*fd**2*(C*(6*r*s - 2*r + 87*s**2 - 60*s + 1) - 42*r*s + 14*r - 36*s**2 + 38*s - 7)) + 6*D1*bd1*(D1*(f*(s**2*(116*C - 65) + s*(8*C*(r - 1) - 42*r + 32) + 5) - 2*fd*(2*C*(4*r*s - r + 58*s**2 - 31*s + 1) - 56*r*s + 14*r - 79*s**2 + 65*s - 14)) + Dd*f*(-4*C*(r*(8*s - 1) + 116*s**2 - 34*s + 1) + 28*r*(8*s - 1) + 316*s**2 - 199*s + 23)) + 4*D1*f*(C*Ddd*f*(r*(2 - 8*s) - 116*s**2 + 60*s - 29) + Dd*f*(2*C*(r*(8*s - 2) + 116*s**2 - 60*s + 29) + r*(19 - 76*s) - 84*s**2 + 61*s - 21) + 2*Dd*fd*(C*(r*(7 - 24*s) - 348*s**2 + 210*s - 31) + 7*r*(24*s - 7) + 144*s**2 - 133*s + 26) + 2*Ddd*f*(7*r*(4*s - 1) + 24*s**2 - 19*s + 6)) - 8*Dd**2*f**2*(C*(3*r*(4*s - 1) + 174*s**2 - 90*s + 1) + r*(21 - 84*s) - 72*s**2 + 57*s - 7)))/(210*d**2*k3**2) - D1**2*Pk1*Pkd2*ct*k1*st**2*(14*b1**2*(D1**2*s*(fd*r*(8*C - 30) + fd*s*(28*C - 36) - fdd*r*(4*C - 20) + fdd*s*(23 - 14*C)) + D1*(2*Dd*(2*C*f*(r*(8*s - 2) + 28*s**2 - 16*s + 7) - 3*f*(5*r*(4*s - 1) + 24*s**2 - 17*s + 6) + fd*r*(10 - 2*C)*(8*s - 1) + fd*s*(-8*C*(7*s - 2) + 92*s - 33)) + Ddd*f*(-2*C*(8*r*s - 2*r + 28*s**2 - 16*s + 7) + 80*r*s - 20*r + 92*s**2 - 66*s + 23)) + 2*Dd**2*f*(C*(r*(6 - 24*s) - 84*s**2 + 48*s - 2) + 30*r*(4*s - 1) + 138*s**2 - 99*s + 10)) + b1*(-352*C*D1**2*f*fd*r*s + 224*C*D1**2*f*fd*r - 1344*C*D1**2*f*fd*s**2 + 1632*C*D1**2*f*fd*s - 840*C*D1**2*f*fd + 288*C*D1**2*f*fdd*r*s - 168*C*D1**2*f*fdd*r + 1008*C*D1**2*f*fdd*s**2 - 1152*C*D1**2*f*fdd*s + 588*C*D1**2*f*fdd + 288*C*D1**2*fd**2*r*s - 168*C*D1**2*fd**2*r + 1008*C*D1**2*fd**2*s**2 - 1152*C*D1**2*fd**2*s - 704*C*D1*Dd*f**2*r*s + 176*C*D1*Dd*f**2*r - 2688*C*D1*Dd*f**2*s**2 + 1520*C*D1*Dd*f**2*s - 672*C*D1*Dd*f**2 + 2304*C*D1*Dd*f*fd*r*s - 960*C*D1*Dd*f*fd*r + 8064*C*D1*Dd*f*fd*s**2 - 6912*C*D1*Dd*f*fd*s + 1320*C*D1*Dd*f*fd + 576*C*D1*Ddd*f**2*r*s - 144*C*D1*Ddd*f**2*r + 2016*C*D1*Ddd*f**2*s**2 - 1152*C*D1*Ddd*f**2*s + 504*C*D1*Ddd*f**2 + 1728*C*Dd**2*f**2*r*s - 432*C*Dd**2*f**2*r + 6048*C*Dd**2*f**2*s**2 - 3456*C*Dd**2*f**2*s + 144*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(2*C*(r*(4*s - 2) + 14*s**2 - 16*s + 7) + r*(20 - 40*s) - 46*s**2 + 66*s - 23) - 32*D1**2*f*fd*r*s - 140*D1**2*f*fd*r - 492*D1**2*f*fd*s**2 + 312*D1**2*f*fd*s - 78*D1**2*f*fd + 240*D1**2*f*fdd*r*s + 302*D1**2*f*fdd*s**2 - 226*D1**2*f*fdd*s + 53*D1**2*f*fdd + 240*D1**2*fd**2*r*s + 302*D1**2*fd**2*s**2 - 226*D1**2*fd**2*s - 64*D1*Dd*f**2*r*s + 16*D1*Dd*f**2*r - 984*D1*Dd*f**2*s**2 + 508*D1*Dd*f**2*s - 246*D1*Dd*f**2 + 1920*D1*Dd*f*fd*r*s - 240*D1*Dd*f*fd*r + 2416*D1*Dd*f*fd*s**2 - 1748*D1*Dd*f*fd*s + 226*D1*Dd*f*fd + 480*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r + 604*D1*Ddd*f**2*s**2 - 422*D1*Ddd*f**2*s + 151*D1*Ddd*f**2 + 28*D1*bd1*(D1*(2*C*f*(r*(4*s - 2) + 14*s**2 - 16*s + 7) - 3*f*(5*r*(2*s - 1) + 12*s**2 - 17*s + 6) + fd*r*(10 - 2*C)*(4*s - 1) + fd*s*(-4*C*(7*s - 4) + 46*s - 33)) + Dd*f*(-2*C*(2*r*(8*s - 3) + 56*s**2 - 48*s + 9) + 20*r*(8*s - 3) + 184*s**2 - 198*s + 43)) + 1440*Dd**2*f**2*r*s - 360*Dd**2*f**2*r + 1812*Dd**2*f**2*s**2 - 1266*Dd**2*f**2*s + 120*Dd**2*f**2) + f*(-336*C*D1**2*f*fd*r*s + 112*C*D1**2*f*fd*r - 1080*C*D1**2*f*fd*s**2 + 832*C*D1**2*f*fd*s - 360*C*D1**2*f*fd + 312*C*D1**2*f*fdd*r*s - 104*C*D1**2*f*fdd*r + 756*C*D1**2*f*fdd*s**2 - 608*C*D1**2*f*fdd*s + 252*C*D1**2*f*fdd + 624*C*D1**2*fd**2*r*s - 208*C*D1**2*fd**2*r + 1512*C*D1**2*fd**2*s**2 - 1216*C*D1**2*fd**2*s + 104*C*D1**2*fd**2 - 448*C*D1*Dd*f**2*r*s + 112*C*D1*Dd*f**2*r - 1440*C*D1*Dd*f**2*s**2 + 832*C*D1*Dd*f**2*s - 360*C*D1*Dd*f**2 + 2496*C*D1*Dd*f*fd*r*s - 728*C*D1*Dd*f*fd*r + 6048*C*D1*Dd*f*fd*s**2 - 4256*C*D1*Dd*f*fd*s + 712*C*D1*Dd*f*fd + 416*C*D1*Ddd*f**2*r*s - 104*C*D1*Ddd*f**2*r + 1008*C*D1*Ddd*f**2*s**2 - 608*C*D1*Ddd*f**2*s + 252*C*D1*Ddd*f**2 + 1248*C*Dd**2*f**2*r*s - 312*C*Dd**2*f**2*r + 3024*C*Dd**2*f**2*s**2 - 1824*C*Dd**2*f**2*s + 104*C*Dd**2*f**2 - 28*D1**2*bd1**2*(2*C*(r*(2*s - 1) + 7*s**2 - 8*s + 1) + r*(10 - 20*s) - 23*s**2 + 33*s - 10) + D1**2*bdd1*f*(12*C*(2*r*(6*s + 1) + 42*s**2 - 7) + 120*r*(s - 1) + 151*s**2 - 196*s + 98) + 180*D1**2*f*fd*r*s - 60*D1**2*f*fd*r - 114*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 38*D1**2*f*fd + 75*D1**2*f*fdd*s**2 - 50*D1**2*f*fdd*s + 25*D1**2*f*fdd + 150*D1**2*fd**2*s**2 - 100*D1**2*fd**2*s + 240*D1*Dd*f**2*r*s - 60*D1*Dd*f**2*r - 152*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 38*D1*Dd*f**2 + 600*D1*Dd*f*fd*s**2 - 350*D1*Dd*f*fd*s + 50*D1*Dd*f*fd + 100*D1*Ddd*f**2*s**2 - 50*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 - 2*D1*bd1*(D1*(f*(4*C*(22*r*s + 6*r + 84*s**2 + 14*s - 21) + r*(8*s - 78) + 123*s**2 - 98*s + 84) - fd*(12*C*(r*(24*s - 5) + 84*s**2 - 48*s + 6) + 120*r*(2*s - 1) + 302*s**2 - 309*s + 60)) + Dd*f*(-12*C*(r*(48*s - 2) + 168*s**2 - 48*s - 1) - 60*r*(8*s - 5) - 604*s**2 + 603*s - 158)) + 300*Dd**2*f**2*s**2 - 150*Dd**2*f**2*s))/(210*d**2*k3**2) + D1**2*Pk1*Pkd2*ct*k1*(D1*f*(-14*D1*bd1**2*(20*C*(r*(2*s - 1) + 3*s**2 - 4*s + 1) + s*(11*s - 11)) - 3*D1*bdd1*f*(s - 1)*(12*C*(6*r + 7*s - 7) + 17*s - 17) + 6*bd1*(-12*C*Dd*f*(3*r*(8*s - 5) + 28*s**2 - 38*s + 10) + D1*f*(s - 1)*(4*C*(18*r + 7*s - 7) - 42*r + 3*s - 3) - 2*D1*fd*(6*C*(6*r*(2*s - 1) + 14*s**2 - 17*s + 3) + s*(17*s - 17)) - 17*Dd*f*(4*s**2 - 5*s + 1))) + 7*b1**2*(D1**2*s*(2*fd*(40*C*r + 20*C*s - 30*r + s) - fdd*(40*C*r + 60*C*s + 11*s)) + D1*(2*Dd*(f*(20*C*(r*(8*s - 2) + (1 - 2*s)**2) - 120*r*s + 30*r + 4*s**2 + 28*s + 1) + fd*(-20*C*(r*(8*s - 1) + 4*s*(3*s - 1)) + s*(11 - 44*s))) - Ddd*f*(20*C*(8*r*s - 2*r + 12*s**2 - 8*s + 3) + 44*s**2 - 22*s + 11)) - 2*Dd**2*f*(20*C*(12*r*s - 3*r + 18*s**2 - 12*s + 1) + 33*s*(2*s - 1))) + b1*(-7*D1**2*bdd1*f*(20*C*(r*(4*s - 2) + 6*s**2 - 8*s + 3) + 22*s**2 - 22*s + 11) + 6*D1**2*s*(f*(8*C*fd*(18*r + 7*s - 9) - 12*C*fdd*(6*r + 7*s - 3) + 6*fd*(-14*r + s + 7) - 17*fdd*s) - fd**2*(12*C*(6*r + 7*s - 3) + 17*s)) + 14*D1*bd1*(-20*C*Dd*f*(2*r*(8*s - 3) + 24*s**2 - 24*s + 5) + D1*f*(20*C*(r*(4*s - 2) + 2*s**2 - 4*s + 1) + r*(30 - 60*s) + 2*s**2 + 28*s + 1) + D1*fd*(-20*C*(r*(4*s - 1) + 2*s*(3*s - 2)) + s*(11 - 22*s)) - 11*Dd*f*(8*s**2 - 6*s + 1)) + 3*D1*f*(-12*C*Ddd*f*(6*r*(4*s - 1) + 28*s**2 - 20*s + 7) + 2*Dd*f*(4*C*(72*r*s - 18*r + 28*s**2 - 32*s + 7) - 168*r*s + 42*r + 12*s**2 + 36*s + 3) - 4*Dd*fd*(6*C*(48*r*s - 6*r + 56*s**2 - 32*s + 3) + 17*s*(4*s - 1)) - 17*Ddd*f*(4*s**2 - 2*s + 1)) - 18*Dd**2*f**2*(12*C*(12*r*s - 3*r + 14*s**2 - 10*s + 1) + 17*s*(2*s - 1))))/(210*d**2*k3**2) - 3*D1**2*Pk1*Pkd2*ct*k1*st**4*(33*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + 11*b1*(D1**2*(-10*f**2*(fd*(-6*s**2 + 4*s - 2) + fdd*(3*s**2 - 2*s + 1) + s**2*(-6*bd1 + 3*bdd1)) + f*(20*fd**2*s*(2 - 3*s) - 6*fd*(s**2*(20*bd1 - 2) + s*(2 - 10*bd1) - 1) - 3*fdd*(2*s**2 - 2*s + 1) - 3*s**2*(-28*bd1 + 14*bdd1)) - 6*fd*s*(14*bd1 + fd)*(s - 1)) + D1*f*(2*Dd*(10*f**2*(4*s**2 - 2*s + 1) + f*(-10*fd*(12*s**2 - 7*s + 1) + s**2*(12 - 120*bd1) + s*(30*bd1 - 6) + 3) - (12*s - 3)*(14*bd1*s + fd*(2*s - 1))) - Ddd*f*(10*f + 3)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(10*f + 3)*(2*s - 1)) + f*(D1**2*(-66*bd1*s*(7*bd1*s + fd*(2*s - 1)) + 5*f**2*(10*fd*(4*s**2 - 2*s + 1) - 5*fdd*(4*s**2 - 2*s + 1) + s**2*(44*bd1 - 22*bdd1)) + f*s*(-330*bd1**2*s - 220*bd1*fd*(3*s - 1) + 66*bd1*s - 33*bdd1*s - 150*fd**2*(2*s - 1))) + D1*f*(2*Dd*(33*bd1*s*(1 - 4*s) + 25*f**2*(4*s**2 - 2*s + 1) - 5*f*(4*s - 1)*(22*bd1*s + 20*fd*s - 5*fd)) - 25*Ddd*f**2*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**3*s*(1 - 2*s)))/(770*d**2*k2**2) - D1**2*Pk1*Pkd2*ct*k1*st**2*(35*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + b1**2*(-35*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 228*D1**2*f*fd*s**2 + 588*D1**2*f*fd*s - 294*D1**2*f*fd + 114*D1**2*f*fdd*s**2 - 294*D1**2*f*fdd*s + 147*D1**2*f*fdd + 114*D1**2*fd**2*s**2 - 294*D1**2*fd**2*s - 364*D1**2*fd*s**2 + 868*D1**2*fd*s - 434*D1**2*fd + 182*D1**2*fdd*s**2 - 434*D1**2*fdd*s + 217*D1**2*fdd - 456*D1*Dd*f**2*s**2 + 228*D1*Dd*f**2*s - 114*D1*Dd*f**2 + 912*D1*Dd*f*fd*s**2 - 1404*D1*Dd*f*fd*s + 294*D1*Dd*f*fd - 1456*D1*Dd*f*s**2 + 728*D1*Dd*f*s - 364*D1*Dd*f + 1456*D1*Dd*fd*s**2 - 2100*D1*Dd*fd*s + 434*D1*Dd*fd + 228*D1*Ddd*f**2*s**2 - 114*D1*Ddd*f**2*s + 57*D1*Ddd*f**2 + 728*D1*Ddd*f*s**2 - 364*D1*Ddd*f*s + 182*D1*Ddd*f + 70*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) + 684*Dd**2*f**2*s**2 - 342*Dd**2*f**2*s + 2184*Dd**2*f*s**2 - 1092*Dd**2*f*s) + b1*(-70*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) + D1**2*bdd1*f*(6*f*(19*s**2 + 30*s - 15) + 364*s**2 + 70*s - 35) - 606*D1**2*f**2*fd*s**2 + 504*D1**2*f**2*fd*s - 252*D1**2*f**2*fd + 303*D1**2*f**2*fdd*s**2 - 252*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd + 606*D1**2*f*fd**2*s**2 - 504*D1**2*f*fd**2*s - 212*D1**2*f*fd*s**2 + 212*D1**2*f*fd*s - 106*D1**2*f*fd + 106*D1**2*f*fdd*s**2 - 106*D1**2*f*fdd*s + 53*D1**2*f*fdd + 106*D1**2*fd**2*s**2 - 106*D1**2*fd**2*s - 808*D1*Dd*f**3*s**2 + 404*D1*Dd*f**3*s - 202*D1*Dd*f**3 + 2424*D1*Dd*f**2*fd*s**2 - 1614*D1*Dd*f**2*fd*s + 252*D1*Dd*f**2*fd - 424*D1*Dd*f**2*s**2 + 212*D1*Dd*f**2*s - 106*D1*Dd*f**2 + 848*D1*Dd*f*fd*s**2 - 636*D1*Dd*f*fd*s + 106*D1*Dd*f*fd + 404*D1*Ddd*f**3*s**2 - 202*D1*Ddd*f**3*s + 101*D1*Ddd*f**3 + 212*D1*Ddd*f**2*s**2 - 106*D1*Ddd*f**2*s + 53*D1*Ddd*f**2 - 2*D1*bd1*(D1*(6*f**2*(19*s**2 + 30*s - 15) + f*(-s**2*(228*fd - 364) + s*(114*fd + 70) - 35) + 7*fd*s*(57 - 52*s)) - Dd*f*(4*s - 1)*(114*f*s + 90*f + 364*s + 35)) + 1212*Dd**2*f**3*s**2 - 606*Dd**2*f**3*s + 636*Dd**2*f**2*s**2 - 318*Dd**2*f**2*s) + f*(2*D1**2*bd1**2*s*(57*f*s + 90*f + 182*s + 35) - 2*D1**2*bd1*(f**2*(101*s**2 + 50*s - 25) + f*s*(fd*(51 - 303*s) + 53*s) + 53*fd*s*(1 - 2*s)) + D1**2*bdd1*f*(f*(101*s**2 + 50*s - 25) + 53*s**2) + 2*D1*Dd*bd1*f*(4*s - 1)*(f*(101*s + 25) + 53*s) - 35*f*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))))/(210*d**2*k2**2) + D1**2*Pk1*Pkd2*ct*k1*(-D1*f*(s - 1)*(14*D1*bd1**2*s*(18*f + 11) + 45*D1*bdd1*f**2*(s - 1) + 90*bd1*f*(D1*(-f*s + f + 3*fd*s) + Dd*f*(4*s - 1))) + 35*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + 7*b1**2*(-5*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) + 72*D1**2*f*fd*s**2 - 36*D1**2*f*fdd*s**2 - 36*D1**2*fd**2*s**2 + 22*D1**2*fd*s**2 - 11*D1**2*fdd*s**2 + 144*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 36*D1*Dd*f**2 - 288*D1*Dd*f*fd*s**2 + 72*D1*Dd*f*fd*s + 88*D1*Dd*f*s**2 - 44*D1*Dd*f*s + 22*D1*Dd*f - 88*D1*Dd*fd*s**2 + 22*D1*Dd*fd*s - 72*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 - 44*D1*Ddd*f*s**2 + 22*D1*Ddd*f*s - 11*D1*Ddd*f + 10*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) - 216*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 132*Dd**2*f*s**2 + 66*Dd**2*f*s) - b1*(70*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) - 14*D1*bd1*(D1*(18*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(22 - 72*fd) + s*(36*fd - 22) + 11) + 11*fd*s*(1 - 2*s)) - Dd*f*(18*f + 11)*(8*s**2 - 6*s + 1)) + f*(7*D1**2*bdd1*(18*f + 11)*(2*s**2 - 2*s + 1) - 135*D1**2*s**2*(2*f*fd - f*fdd - 2*fd**2) - 45*D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) + 6*Dd*fd*s*(1 - 4*s) + Ddd*f*(-4*s**2 + 2*s - 1)) - 270*Dd**2*f**2*s*(1 - 2*s))))/(210*d**2*k2**2) - 2*D1**2*Pk1*Pkd2*ct*k2**4*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(63*d**2*k1*k3**4) - 2*D1**2*Pk1*Pkd2*ct*k2**4*st**4*(-D1*f*(7*D1*bd1**2*(2*s - 1)*(r + s - 1) + bd1*(D1*(f*(5*s + 2)*(r + s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) + f*(D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1))) + 7*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(-7*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 10*D1**2*f*fd*r*s + 7*D1**2*f*fd*r - 10*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 7*D1**2*f*fd - 2*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*s**2 + D1**2*f*fdd*s - 2*D1**2*fd**2*r*s - 2*D1**2*fd**2*s**2 + D1**2*fd**2*s - 20*D1*Dd*f**2*r*s + 5*D1*Dd*f**2*r - 20*D1*Dd*f**2*s**2 + 15*D1*Dd*f**2*s - 5*D1*Dd*f**2 - 16*D1*Dd*f*fd*r*s + 2*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 10*D1*Dd*f*fd*s - D1*Dd*f*fd - 4*D1*Ddd*f**2*r*s + D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 3*D1*Ddd*f**2*s - D1*Ddd*f**2 + 7*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 12*Dd**2*f**2*r*s + 3*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 9*Dd**2*f**2*s - Dd**2*f**2))/(35*d**2*k1*k3**4) + D1**2*Pk1*Pkd2*ct*k2**2*st**6*(-9*b1*(D1**2*(f*(2*fd - fdd)*(r*(8*C - 8)*(2*s - 1) + 10*s**2 - 10*s + 5) - 2*fd**2*(r*(4*C - 4)*(2*s - 1) + s*(5*s - 5))) + D1*f*(2*Dd*(f*(r*(8*C - 8)*(4*s - 1) + 20*s**2 - s*(8*C + 2) + 5) + fd*(C*(-8*r*(8*s - 3) + 8*s - 4) + 8*r*(8*s - 3) - 40*s**2 + 22*s - 1)) + Ddd*f*(-r*(8*C - 8)*(4*s - 1) - 20*s**2 + s*(8*C + 2) - 5)) + 2*Dd**2*f**2*(-4*C*(3*r*(4*s - 1) - 3*s + 1) + 12*r*(4*s - 1) - 30*s**2 + 3*s + 4)) + f*(D1**2*(f*(9*bdd1*s*(8*C*(r - 1) - 8*r + 5*s + 8) - 2*fd*(-8*C*s + r*(8*C - 8)*(3*s - 1) + 15*s**2 - 2*s + 5) + fdd*(-8*C*s + r*(8*C - 8)*(3*s - 1) + 15*s**2 - 2*s + 5)) + 2*fd**2*(4*C*(r*(6*s - 2) - 2*s + 1) + r*(8 - 24*s) + 15*s**2 - 2*s - 4)) - 18*D1*bd1*(D1*(f*s*(8*C*(r - 1) - 8*r + 5*s + 8) + fd*(4*C*(-4*r*s + r + 2*s - 1) + 16*r*s - 4*r - 10*s**2 - 3*s + 4)) + Dd*f*(-4*C*(8*r*s - r - 5*s + 1) + 32*r*s - 4*r - 20*s**2 - 15*s + 4)) + D1*f*(-2*Dd*(f*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 20*s**2 - 2*s + 5) + fd*(-4*C*(24*r*s - 7*r - 7*s + 2) + 96*r*s - 28*r - 60*s**2 + 7*s + 3)) + Ddd*f*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 20*s**2 - 2*s + 5)) + 2*Dd**2*f**2*(4*C*(3*r*(4*s - 1) - 3*s + 1) + r*(12 - 48*s) + 30*s**2 - 3*s - 4)))/(126*d**2*k1*k3**2) - D1**2*Pk1*Pkd2*ct*k2**2*st**4*(21*b1**2*(D1**2*s*(2*fd - fdd)*(r*(8*C - 8) + s) + D1*(2*Dd*(f*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 4*s**2 + 6*s + 1) + fd*(-r*(4*C - 4)*(8*s - 1) + s*(4*C - 4*s - 3))) - Ddd*f*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 4*s**2 + 6*s + 1)) - 2*Dd**2*f*(4*C*(12*r*s - 3*r - 3*s + 1) - 48*r*s + 12*r + 6*s**2 + 9*s - 4)) + 3*b1*(-80*C*D1**2*f*fd*r*s + 56*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s - 16*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*s - 16*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r + 40*C*D1*Dd*f**2*s - 128*C*D1*Dd*f*fd*r*s + 16*C*D1*Dd*f*fd*r + 48*C*D1*Dd*f*fd*s - 8*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r*s + 8*C*D1*Ddd*f**2*r + 8*C*D1*Ddd*f**2*s - 96*C*Dd**2*f**2*r*s + 24*C*Dd**2*f**2*r + 24*C*Dd**2*f**2*s - 8*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(r*(8*C - 8)*(2*s - 1) + 2*s**2 + s*(6 - 8*C) + 1) - 24*D1**2*f*fd*r*s - 4*D1**2*f*fd*r - 176*D1**2*f*fd*s**2 + 196*D1**2*f*fd*s - 90*D1**2*f*fd + 96*D1**2*f*fdd*r*s - 40*D1**2*f*fdd*r + 144*D1**2*f*fdd*s**2 - 154*D1**2*f*fdd*s + 73*D1**2*f*fdd + 96*D1**2*fd**2*r*s - 40*D1**2*fd**2*r + 144*D1**2*fd**2*s**2 - 154*D1**2*fd**2*s - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 352*D1*Dd*f**2*s**2 + 188*D1*Dd*f**2*s - 88*D1*Dd*f**2 + 768*D1*Dd*f*fd*r*s - 256*D1*Dd*f*fd*r + 1152*D1*Dd*f*fd*s**2 - 1000*D1*Dd*f*fd*s + 194*D1*Dd*f*fd + 192*D1*Ddd*f**2*r*s - 48*D1*Ddd*f**2*r + 288*D1*Ddd*f**2*s**2 - 192*D1*Ddd*f**2*s + 72*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(-8*C*s + r*(8*C - 8)*(2*s - 1) + 2*s**2 + 6*s + 1) + fd*(-r*(4*C - 4)*(4*s - 1) + s*(4*C - 2*s - 3))) + Dd*f*(-8*C*(r*(8*s - 3) - 3*s + 1) + 8*r*(8*s - 3) - 8*s**2 - 18*s + 7)) + 576*Dd**2*f**2*r*s - 144*Dd**2*f**2*r + 864*Dd**2*f**2*s**2 - 576*Dd**2*f**2*s + 48*Dd**2*f**2) + f*(-264*C*D1**2*f*fd*r*s + 88*C*D1**2*f*fd*r + 88*C*D1**2*f*fd*s + 240*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r - 80*C*D1**2*f*fdd*s + 480*C*D1**2*fd**2*r*s - 160*C*D1**2*fd**2*r - 160*C*D1**2*fd**2*s + 80*C*D1**2*fd**2 - 352*C*D1*Dd*f**2*r*s + 88*C*D1*Dd*f**2*r + 88*C*D1*Dd*f**2*s + 1920*C*D1*Dd*f*fd*r*s - 560*C*D1*Dd*f*fd*r - 560*C*D1*Dd*f*fd*s + 160*C*D1*Dd*f*fd + 320*C*D1*Ddd*f**2*r*s - 80*C*D1*Ddd*f**2*r - 80*C*D1*Ddd*f**2*s + 960*C*Dd**2*f**2*r*s - 240*C*Dd**2*f**2*r - 240*C*Dd**2*f**2*s + 80*C*Dd**2*f**2 - 42*D1**2*bd1**2*(C*(8*r*s - 4*r - 4*s + 4) - 8*r*s + 4*r + s**2 + 3*s - 4) - 3*D1**2*bdd1*f*(8*r*(C*(s - 1) - 6*s + 1) - 72*s**2 + 38*s + 1) - 60*D1**2*f*fd*r*s + 20*D1**2*f*fd*r - 150*D1**2*f*fd*s**2 + 120*D1**2*f*fd*s - 50*D1**2*f*fd + 120*D1**2*f*fdd*r*s - 40*D1**2*f*fdd*r + 111*D1**2*f*fdd*s**2 - 114*D1**2*f*fdd*s + 37*D1**2*f*fdd + 240*D1**2*fd**2*r*s - 80*D1**2*fd**2*r + 222*D1**2*fd**2*s**2 - 228*D1**2*fd**2*s + 40*D1**2*fd**2 - 80*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r - 200*D1*Dd*f**2*s**2 + 120*D1*Dd*f**2*s - 50*D1*Dd*f**2 + 960*D1*Dd*f*fd*r*s - 280*D1*Dd*f*fd*r + 888*D1*Dd*f*fd*s**2 - 798*D1*Dd*f*fd*s + 154*D1*Dd*f*fd + 160*D1*Ddd*f**2*r*s - 40*D1*Ddd*f**2*r + 148*D1*Ddd*f**2*s**2 - 114*D1*Ddd*f**2*s + 37*D1*Ddd*f**2 - 6*D1*bd1*(D1*(f*(-28*C*s + r*(20*C*s + 8*C + 6*s - 8) + 44*s**2 + 4*s - 1) + fd*(4*C*(4*r*s - 2*r - s + 1) - 96*r*s + 28*r - 144*s**2 + 115*s - 24)) + Dd*f*(4*C*(8*r*s - 5*r - s + 1) - 192*r*s + 40*r - 288*s**2 + 172*s - 23)) + 480*Dd**2*f**2*r*s - 120*Dd**2*f**2*r + 444*Dd**2*f**2*s**2 - 342*Dd**2*f**2*s + 40*Dd**2*f**2))/(210*d**2*k1*k3**2) + D1**2*Pk1*Pkd2*ct*k2**2*st**2*(D1*f*(-14*D1*bd1**2*(12*r*(2*s - 1) + 31*s**2 - 43*s + 12) + 2*bd1*(D1*(f*(r*(68*C*(s - 1) - 40*s - 2) + 25*s**2 - 8*s + 25) - 2*fd*(24*C*(4*r*s - 2*r - s + 1) + 72*r*s - 36*r + 53*s**2 - 71*s + 18)) + Dd*f*(-48*C*(r*(8*s - 5) - s + 1) - 36*r*(8*s - 5) - 212*s**2 + 301*s - 89)) + f*(-D1*bdd1*(s - 1)*(r*(96*C + 72) + 53*s - 53) - 36*D1*fd*(3*r*s - r - s) - 36*Dd*f*(4*r*s - r - s))) + 7*b1**2*(D1**2*s*(40*C*fd*r - 12*fd*r + 22*fd*s - 24*fdd*r - 31*fdd*s) + D1*(2*Dd*(f*(r*(20*C - 6)*(4*s - 1) + 44*s**2 - s*(20*C + 16) + 11) + fd*(r*(12 - 96*s) + s*(43 - 124*s))) + Ddd*f*(r*(24 - 96*s) - 124*s**2 + 86*s - 31)) - 6*Dd**2*f*(12*r*(4*s - 1) + 62*s**2 - 43*s + 4)) + b1*(272*C*D1**2*f*fd*r*s - 136*C*D1**2*f*fd*s - 192*C*D1**2*f*fdd*r*s + 96*C*D1**2*f*fdd*s - 192*C*D1**2*fd**2*r*s + 96*C*D1**2*fd**2*s + 544*C*D1*Dd*f**2*r*s - 136*C*D1*Dd*f**2*r - 136*C*D1*Dd*f**2*s - 1536*C*D1*Dd*f*fd*r*s + 192*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s - 96*C*D1*Dd*f*fd - 384*C*D1*Ddd*f**2*r*s + 96*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s - 1152*C*Dd**2*f**2*r*s + 288*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s - 96*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(24*r*(2*s - 1) + 62*s**2 - 86*s + 31) - 160*D1**2*f*fd*r*s + 84*D1**2*f*fd*r + 100*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s - 144*D1**2*f*fdd*r*s - 106*D1**2*f*fdd*s**2 + 72*D1**2*f*fdd*s - 144*D1**2*fd**2*r*s - 106*D1**2*fd**2*s**2 + 72*D1**2*fd**2*s - 320*D1*Dd*f**2*r*s + 80*D1*Dd*f**2*r + 200*D1*Dd*f**2*s**2 - 20*D1*Dd*f**2*s + 50*D1*Dd*f**2 - 1152*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r - 848*D1*Dd*f*fd*s**2 + 644*D1*Dd*f*fd*s - 72*D1*Dd*f*fd - 288*D1*Ddd*f**2*r*s + 72*D1*Ddd*f**2*r - 212*D1*Ddd*f**2*s**2 + 178*D1*Ddd*f**2*s - 53*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(r*(20*C - 6)*(2*s - 1) + 22*s**2 - s*(20*C + 16) + 11) + fd*(r*(12 - 48*s) + s*(43 - 62*s))) + Dd*f*(-24*r*(8*s - 3) - 248*s**2 + 258*s - 55)) - 864*Dd**2*f**2*r*s + 216*Dd**2*f**2*r - 636*Dd**2*f**2*s**2 + 534*Dd**2*f**2*s - 72*Dd**2*f**2))/(210*d**2*k1*k3**2) - D1**2*Pk1*Pkd2*ct*st**4*(-132*D1**2*K*bdd1*f**2*r*s - 66*D1**2*bd1**2*f*s*(7*K*(4*r - 2) + 25*f*(2*s - 1) - 28*r + 35*s + 14) + 1320*D1**2*bdd1*f**3*r*s + 1265*D1**2*bdd1*f**3*s**2 - 330*D1**2*bdd1*f**3*s - 275*D1**2*bdd1*f**3 + 132*D1**2*bdd1*f**2*r*s - 165*D1**2*bdd1*f**2*s**2 + 1848*D1**2*bdd1*f*g2*r*s - 1848*D1**2*bdd1*f*g2*s - 1024*D1**2*f**3*fd*r*s + 256*D1**2*f**3*fd*r - 3960*D1**2*f**3*fd*s**2 + 2236*D1**2*f**3*fd*s - 990*D1**2*f**3*fd + 1920*D1**2*f**3*fdd*r*s - 480*D1**2*f**3*fdd*r + 2420*D1**2*f**3*fdd*s**2 - 1690*D1**2*f**3*fdd*s + 605*D1**2*f**3*fdd + 5760*D1**2*f**2*fd**2*r*s - 1440*D1**2*f**2*fd**2*r + 7260*D1**2*f**2*fd**2*s**2 - 5070*D1**2*f**2*fd**2*s + 480*D1**2*f**2*fd**2 - 528*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gdd2*r*s - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s + 1056*D1**2*f*fd*gd2*r*s - 264*D1**2*f*fd*gd2*r - 264*D1**2*f*fd*gd2*s + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s + 264*D1**2*fd**2*g2 - 1024*D1*Dd*f**4*r*s + 256*D1*Dd*f**4*r - 3960*D1*Dd*f**4*s**2 + 2236*D1*Dd*f**4*s - 990*D1*Dd*f**4 + 15360*D1*Dd*f**3*fd*r*s - 3840*D1*Dd*f**3*fd*r + 19360*D1*Dd*f**3*fd*s**2 - 13520*D1*Dd*f**3*fd*s + 2170*D1*Dd*f**3*fd - 2112*D1*Dd*f**2*g2*r*s + 528*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s + 2112*D1*Dd*f**2*gd2*r*s - 264*D1*Dd*f**2*gd2*r - 264*D1*Dd*f**2*gd2*s + 4224*D1*Dd*f*fd*g2*r*s - 1584*D1*Dd*f*fd*g2*r - 1584*D1*Dd*f*fd*g2*s + 528*D1*Dd*f*fd*g2 + 1920*D1*Ddd*f**4*r*s - 480*D1*Ddd*f**4*r + 2420*D1*Ddd*f**4*s**2 - 1690*D1*Ddd*f**4*s + 605*D1*Ddd*f**4 + 1056*D1*Ddd*f**2*g2*r*s - 264*D1*Ddd*f**2*g2*r - 264*D1*Ddd*f**2*g2*s - 22*D1*bd1*(D1*(f**3*(85*s**2 + s*(48*r + 18) - 25) - f**2*(5*fd*(12*r*(6*s - 1) + 69*s**2 - 41*s + 8) + 3*s*(r*(4*K - 4) + 5*s)) + 3*f*(fd*(r*(2*K - 2)*(4*s - 1) + s*(-2*K + 10*s - 3)) + s*(56*g2*(r - 1) - 56*gd2*r + 28*gd2)) - 84*fd*g2*(r*(2*s - 1) - s + 1)) - Dd*f*(5*f**2*(12*r*(8*s - 1) + 92*s**2 - 47*s + 3) + f*(-r*(6*K - 6)*(8*s - 1) + s*(6*K - 60*s + 9)) + 84*g2*(r*(8*s - 1) - 5*s + 1))) + 5760*Dd**2*f**4*r*s - 1440*Dd**2*f**4*r + 7260*Dd**2*f**4*s**2 - 5070*Dd**2*f**4*s + 480*Dd**2*f**4 + 3168*Dd**2*f**2*g2*r*s - 792*Dd**2*f**2*g2*r - 792*Dd**2*f**2*g2*s + 264*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(50*f*fd*(4*s**2 - 2*s + 1) - 25*f*fdd*(4*s**2 - 2*s + 1) - 50*fd**2*s*(2*s - 1) + 14*fd*(s - 1)*(r*(4*K - 4) + 5*s - 5) - 7*fdd*(s - 1)*(r*(4*K - 4) + 5*s - 5)) + D1*(2*Dd*(50*f**2*(4*s**2 - 2*s + 1) + f*(-28*K*s - 25*fd*(1 - 4*s)**2 + 7*r*(4*K - 4)*(4*s - 1) + 140*s**2 - 42*s + 35) - 7*fd*(2*K*(8*r*s - 5*r - s + 1) - 16*r*s + 10*r + 20*s**2 - 23*s + 3)) + Ddd*f*(28*K*s - 50*f*(4*s**2 - 2*s + 1) - 7*r*(4*K - 4)*(4*s - 1) - 140*s**2 + 42*s - 35)) + 2*Dd**2*f*(-14*K*(3*r*(4*s - 1) - 3*s + 1) - 300*f*s**2 + 150*f*s + 42*r*(4*s - 1) - 210*s**2 + 63*s + 14)) + 11*b1*(48*D1**2*K*f*fd*r*s - 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s - 24*D1**2*K*f*fdd*r*s + 12*D1**2*K*f*fdd*r + 12*D1**2*K*f*fdd*s - 24*D1**2*K*fd**2*r*s + 12*D1**2*K*fd**2*r + 12*D1**2*K*fd**2*s - 12*D1**2*K*fd**2 - 3*D1**2*bdd1*f*(25*f*(4*s**2 - 2*s + 1) + 14*s*(K*(4*r - 2) - 4*r + 5*s + 2)) - 288*D1**2*f**2*fd*r*s + 96*D1**2*f**2*fd*r - 510*D1**2*f**2*fd*s**2 + 472*D1**2*f**2*fd*s - 220*D1**2*f**2*fd + 360*D1**2*f**2*fdd*r*s - 120*D1**2*f**2*fdd*r + 345*D1**2*f**2*fdd*s**2 - 320*D1**2*f**2*fdd*s + 140*D1**2*f**2*fdd + 720*D1**2*f*fd**2*r*s - 240*D1**2*f*fd**2*r + 690*D1**2*f*fd**2*s**2 - 640*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 48*D1**2*f*fd*r*s + 24*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s + 30*D1**2*f*fd + 24*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 15*D1**2*f*fdd - 336*D1**2*f*gd2*r*s + 168*D1**2*f*gdd2*r*s + 24*D1**2*fd**2*r*s - 12*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 12*D1**2*fd**2 - 336*D1**2*fd*g2*r*s + 336*D1**2*fd*g2*r + 336*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*r + 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r + 96*D1*Dd*K*f**2*r*s - 24*D1*Dd*K*f**2*r - 24*D1*Dd*K*f**2*s - 192*D1*Dd*K*f*fd*r*s + 72*D1*Dd*K*f*fd*r + 72*D1*Dd*K*f*fd*s - 24*D1*Dd*K*f*fd - 384*D1*Dd*f**3*r*s + 96*D1*Dd*f**3*r - 680*D1*Dd*f**3*s**2 + 436*D1*Dd*f**3*s - 170*D1*Dd*f**3 + 2880*D1*Dd*f**2*fd*r*s - 840*D1*Dd*f**2*fd*r + 2760*D1*Dd*f**2*fd*s**2 - 2330*D1*Dd*f**2*fd*s + 440*D1*Dd*f**2*fd - 96*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 36*D1*Dd*f**2*s + 30*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 108*D1*Dd*f*fd*s - 6*D1*Dd*f*fd - 1344*D1*Dd*f*g2*r*s + 336*D1*Dd*f*g2*r + 336*D1*Dd*f*g2*s + 1344*D1*Dd*f*gd2*r*s - 168*D1*Dd*f*gd2*r - 168*D1*Dd*f*gd2*s + 1344*D1*Dd*fd*g2*r*s - 840*D1*Dd*fd*g2*r - 168*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 - 48*D1*Ddd*K*f**2*r*s + 12*D1*Ddd*K*f**2*r + 12*D1*Ddd*K*f**2*s + 480*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r + 460*D1*Ddd*f**3*s**2 - 350*D1*Ddd*f**3*s + 115*D1*Ddd*f**3 + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + 672*D1*Ddd*f*g2*r*s - 168*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s + 6*D1*bd1*(D1*(25*f**2*(4*s**2 - 2*s + 1) + 2*f*s*(7*K*(4*r - 2) - 50*fd*(2*s - 1) - 28*r + 35*s + 14) - 14*fd*(K*r*(4*s - 2) - K*s + K + r*(2 - 4*s) + 5*s**2 - 4*s - 1)) - Dd*f*(28*K*r*(8*s - 1) - 84*K*s + 14*K + 25*f*(1 - 4*s)**2 + 14*r*(2 - 16*s) + 280*s**2 + 14*s - 14)) - 144*Dd**2*K*f**2*r*s + 36*Dd**2*K*f**2*r + 36*Dd**2*K*f**2*s - 12*Dd**2*K*f**2 + 1440*Dd**2*f**3*r*s - 360*Dd**2*f**3*r + 1380*Dd**2*f**3*s**2 - 1050*Dd**2*f**3*s + 120*Dd**2*f**3 + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s + 12*Dd**2*f**2 + 2016*Dd**2*f*g2*r*s - 504*Dd**2*f*g2*r - 504*Dd**2*f*g2*s + 168*Dd**2*f*g2))/(2310*d**2*k1) - D1**2*Pk1*Pkd2*ct*st**2*(48*D1**2*K*bdd1*f**2*r*s - 80*D1**2*b2*f*fd*r*s + 40*D1**2*b2*f*fd*r + 40*D1**2*b2*f*fd*s + 96*D1**2*b2*f*fdd*r*s - 48*D1**2*b2*f*fdd*r - 48*D1**2*b2*f*fdd*s + 96*D1**2*b2*fd**2*r*s - 48*D1**2*b2*fd**2*r - 48*D1**2*b2*fd**2*s + 48*D1**2*b2*fd**2 + 2*D1**2*bd1**2*(3*f**2*(8*r*(8*s - 3) + 95*s**2 - 70*s + 16) + 7*f*(r*(2 - 2*K)*(2*s - 1) + s*(30*s + 1)) + 140*g2*(r*(2*s - 1) - s + 1)) - 40*D1**2*bd2*f**2*r*s + 192*D1**2*bd2*f*fd*r*s - 48*D1**2*bd2*f*fd*r - 48*D1**2*bd2*f*fd*s + 96*D1**2*bdd1*f**3*r*s - 64*D1**2*bdd1*f**3*r + 126*D1**2*bdd1*f**3*s**2 - 126*D1**2*bdd1*f**3*s + 63*D1**2*bdd1*f**3 + 48*D1**2*bdd1*f**2*r*s + 53*D1**2*bdd1*f**2*s**2 + 56*D1**2*bdd1*f*g2*r*s - 56*D1**2*bdd1*f*g2*r + 48*D1**2*bdd2*f**2*r*s + 136*D1**2*f**2*gd2*r*s - 96*D1**2*f**2*gdd2*r*s + 272*D1**2*f*fd*g2*r*s - 136*D1**2*f*fd*g2*r - 136*D1**2*f*fd*g2*s - 384*D1**2*f*fd*gd2*r*s + 96*D1**2*f*fd*gd2*r + 96*D1**2*f*fd*gd2*s - 192*D1**2*f*fdd*g2*r*s + 96*D1**2*f*fdd*g2*r + 96*D1**2*f*fdd*g2*s - 192*D1**2*fd**2*g2*r*s + 96*D1**2*fd**2*g2*r + 96*D1**2*fd**2*g2*s - 96*D1**2*fd**2*g2 - 160*D1*Dd*b2*f**2*r*s + 40*D1*Dd*b2*f**2*r + 40*D1*Dd*b2*f**2*s + 768*D1*Dd*b2*f*fd*r*s - 288*D1*Dd*b2*f*fd*r - 288*D1*Dd*b2*f*fd*s + 96*D1*Dd*b2*f*fd + 384*D1*Dd*bd2*f**2*r*s - 48*D1*Dd*bd2*f**2*r - 48*D1*Dd*bd2*f**2*s + 544*D1*Dd*f**2*g2*r*s - 136*D1*Dd*f**2*g2*r - 136*D1*Dd*f**2*g2*s - 768*D1*Dd*f**2*gd2*r*s + 96*D1*Dd*f**2*gd2*r + 96*D1*Dd*f**2*gd2*s - 1536*D1*Dd*f*fd*g2*r*s + 576*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s - 192*D1*Dd*f*fd*g2 + 192*D1*Ddd*b2*f**2*r*s - 48*D1*Ddd*b2*f**2*r - 48*D1*Ddd*b2*f**2*s - 384*D1*Ddd*f**2*g2*r*s + 96*D1*Ddd*f**2*g2*r + 96*D1*Ddd*f**2*g2*s - 2*D1*bd1*(D1*(f**3*(8*r*(3*s - 2) + 90*s**2 - 90*s + 45) + f**2*(-2*fd*(8*r*(18*s - 7) + 189*s**2 - 150*s + 16) + s*(r*(34*K + 6) + 39*s)) + f*(fd*(-r*(24*K + 24)*(4*s - 1) + s*(24*K - 106*s + 77)) - 28*g2*r*(3*s + 2) + 140*g2*s - 28*gd2*r*(2*s - 1)) - 28*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(f**2*(r*(176 - 384*s) - 504*s**2 + 426*s - 95) + f*(-r*(24*K + 24)*(8*s - 1) + s*(24*K - 212*s + 77)) - 28*g2*(r*(8*s - 5) - s + 1))) + 576*Dd**2*b2*f**2*r*s - 144*Dd**2*b2*f**2*r - 144*Dd**2*b2*f**2*s + 48*Dd**2*b2*f**2 - 1152*Dd**2*f**2*g2*r*s + 288*Dd**2*f**2*g2*r + 288*Dd**2*f**2*g2*s - 96*Dd**2*f**2*g2 + 7*b1**3*(3*D1**2*s**2*(2*fd - fdd) + D1*(2*Dd*(-20*K*s + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s + r*(20*K - 20)*(4*s - 1) + 20*s**2 + 10*s + 5) - Ddd*(-20*K*s + 3*f*(4*s**2 - 2*s + 1) + 5*r*(4*K - 4)*(4*s - 1) + 20*s**2 + 10*s + 5)) - 2*Dd**2*(10*K*(3*r*(4*s - 1) - 3*s + 1) + 18*f*s**2 - 9*f*s - 30*r*(4*s - 1) + 30*s**2 + 15*s - 10)) + b1**2*(-84*D1**2*K*fd*r*s + 140*D1**2*K*fd*r - 56*D1**2*K*fd*s - 28*D1**2*K*fdd*r*s + 28*D1**2*K*fdd*s - 7*D1**2*bdd1*(-20*K*s + f*(9*s**2 - 6*s + 3) + 5*r*(4*K - 4)*(3*s - 1) + 15*s**2 + 10*s + 5) - 320*D1**2*f*fd*r*s + 40*D1**2*f*fd*r - 804*D1**2*f*fd*s**2 + 460*D1**2*f*fd*s - 210*D1**2*f*fd + 384*D1**2*f*fdd*r*s - 48*D1**2*f*fdd*r + 570*D1**2*f*fdd*s**2 - 342*D1**2*f*fdd*s + 147*D1**2*f*fdd + 384*D1**2*fd**2*r*s - 48*D1**2*fd**2*r + 570*D1**2*fd**2*s**2 - 342*D1**2*fd**2*s + 84*D1**2*fd*r*s - 140*D1**2*fd*r - 280*D1**2*fd*s**2 + 644*D1**2*fd*s - 294*D1**2*fd + 28*D1**2*fdd*r*s + 210*D1**2*fdd*s**2 - 462*D1**2*fdd*s + 217*D1**2*fdd - 560*D1**2*gd2*r*s + 280*D1**2*gdd2*r*s - 336*D1*Dd*K*f*r*s + 84*D1*Dd*K*f*r + 84*D1*Dd*K*f*s - 224*D1*Dd*K*fd*r*s + 28*D1*Dd*K*fd*r + 140*D1*Dd*K*fd*s - 28*D1*Dd*K*fd - 640*D1*Dd*f**2*r*s + 160*D1*Dd*f**2*r - 1608*D1*Dd*f**2*s**2 + 964*D1*Dd*f**2*s - 402*D1*Dd*f**2 + 3072*D1*Dd*f*fd*r*s - 576*D1*Dd*f*fd*r + 4560*D1*Dd*f*fd*s**2 - 2892*D1*Dd*f*fd*s + 390*D1*Dd*f*fd + 336*D1*Dd*f*r*s - 84*D1*Dd*f*r - 1120*D1*Dd*f*s**2 + 476*D1*Dd*f*s - 280*D1*Dd*f + 224*D1*Dd*fd*r*s - 28*D1*Dd*fd*r + 1680*D1*Dd*fd*s**2 - 2296*D1*Dd*fd*s + 462*D1*Dd*fd - 2240*D1*Dd*g2*r*s + 560*D1*Dd*g2*r + 560*D1*Dd*g2*s + 2240*D1*Dd*gd2*r*s - 280*D1*Dd*gd2*r - 280*D1*Dd*gd2*s - 112*D1*Ddd*K*f*r*s + 28*D1*Ddd*K*f*r + 28*D1*Ddd*K*f*s + 768*D1*Ddd*f**2*r*s - 192*D1*Ddd*f**2*r + 1140*D1*Ddd*f**2*s**2 - 762*D1*Ddd*f**2*s + 285*D1*Ddd*f**2 + 112*D1*Ddd*f*r*s - 28*D1*Ddd*f*r + 840*D1*Ddd*f*s**2 - 448*D1*Ddd*f*s + 210*D1*Ddd*f + 1120*D1*Ddd*g2*r*s - 280*D1*Ddd*g2*r - 280*D1*Ddd*g2*s + 14*D1*bd1*(D1*(-20*K*s + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s + r*(20*K - 20)*(3*s - 1) + 15*s**2 + 10*s + 5) - Dd*(10*K*(24*r*s - 7*r - 7*s + 2) + 3*f*(12*s**2 - 7*s + 1) - 240*r*s + 70*r + 60*s**2 + 35*s - 15)) - 336*Dd**2*K*f*r*s + 84*Dd**2*K*f*r + 84*Dd**2*K*f*s - 28*Dd**2*K*f + 2304*Dd**2*f**2*r*s - 576*Dd**2*f**2*r + 3420*Dd**2*f**2*s**2 - 2286*Dd**2*f**2*s + 192*Dd**2*f**2 + 336*Dd**2*f*r*s - 84*Dd**2*f*r + 2520*Dd**2*f*s**2 - 1344*Dd**2*f*s + 28*Dd**2*f + 3360*Dd**2*g2*r*s - 840*Dd**2*g2*r - 840*Dd**2*g2*s + 280*Dd**2*g2) + b1*(-136*D1**2*K*f*fd*r*s + 68*D1**2*K*f*fd*r + 68*D1**2*K*f*fd*s + 96*D1**2*K*f*fdd*r*s - 48*D1**2*K*f*fdd*r - 48*D1**2*K*f*fdd*s + 96*D1**2*K*fd**2*r*s - 48*D1**2*K*fd**2*r - 48*D1**2*K*fd**2*s + 48*D1**2*K*fd**2 - 14*D1**2*bd1**2*(10*K*(r*(6*s - 2) - 2*s + 1) + 9*f*s**2 - 6*f*s + r*(20 - 60*s) + 15*s**2 + 10*s - 10) + D1**2*bdd1*(6*f**2*(8*r*(8*s - 3) + 95*s**2 - 70*s + 23) - 7*f*(r*(4*K - 4)*(2*s - 1) - 60*s**2 - 2*s + 1) + 280*g2*(r*(2*s - 1) - s)) - 144*D1**2*f**2*fd*r*s + 16*D1**2*f**2*fd*r - 540*D1**2*f**2*fd*s**2 + 228*D1**2*f**2*fd*s - 90*D1**2*f**2*fd + 288*D1**2*f**2*fdd*r*s - 32*D1**2*f**2*fdd*r + 378*D1**2*f**2*fdd*s**2 - 222*D1**2*f**2*fdd*s + 63*D1**2*f**2*fdd + 576*D1**2*f*fd**2*r*s - 64*D1**2*f*fd**2*r + 756*D1**2*f*fd**2*s**2 - 444*D1**2*f*fd**2*s + 32*D1**2*f*fd**2 - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 156*D1**2*f*fd*s**2 + 168*D1**2*f*fd*s - 78*D1**2*f*fd + 96*D1**2*f*fdd*r*s - 48*D1**2*f*fdd*r + 106*D1**2*f*fdd*s**2 - 154*D1**2*f*fdd*s + 53*D1**2*f*fdd + 168*D1**2*f*gd2*r*s + 56*D1**2*f*gdd2*r*s + 96*D1**2*fd**2*r*s - 48*D1**2*fd**2*r + 106*D1**2*fd**2*s**2 - 154*D1**2*fd**2*s + 48*D1**2*fd**2 + 168*D1**2*fd*g2*r*s - 280*D1**2*fd*g2*r + 112*D1**2*fd*g2*s + 112*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*s + 56*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*s - 272*D1*Dd*K*f**2*r*s + 68*D1*Dd*K*f**2*r + 68*D1*Dd*K*f**2*s + 768*D1*Dd*K*f*fd*r*s - 288*D1*Dd*K*f*fd*r - 288*D1*Dd*K*f*fd*s + 96*D1*Dd*K*f*fd - 192*D1*Dd*f**3*r*s + 48*D1*Dd*f**3*r - 720*D1*Dd*f**3*s**2 + 408*D1*Dd*f**3*s - 180*D1*Dd*f**3 + 2304*D1*Dd*f**2*fd*r*s - 416*D1*Dd*f**2*fd*r + 3024*D1*Dd*f**2*fd*s**2 - 1932*D1*Dd*f**2*fd*s + 254*D1*Dd*f**2*fd - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 312*D1*Dd*f**2*s**2 + 168*D1*Dd*f**2*s - 78*D1*Dd*f**2 + 768*D1*Dd*f*fd*r*s - 288*D1*Dd*f*fd*r + 848*D1*Dd*f*fd*s**2 - 924*D1*Dd*f*fd*s + 202*D1*Dd*f*fd + 672*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 168*D1*Dd*f*g2*s + 448*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r - 56*D1*Dd*f*gd2*s + 448*D1*Dd*fd*g2*r*s - 56*D1*Dd*fd*g2*r - 280*D1*Dd*fd*g2*s + 56*D1*Dd*fd*g2 + 192*D1*Ddd*K*f**2*r*s - 48*D1*Ddd*K*f**2*r - 48*D1*Ddd*K*f**2*s + 384*D1*Ddd*f**3*r*s - 96*D1*Ddd*f**3*r + 504*D1*Ddd*f**3*s**2 - 348*D1*Ddd*f**3*s + 126*D1*Ddd*f**3 + 192*D1*Ddd*f**2*r*s - 48*D1*Ddd*f**2*r + 212*D1*Ddd*f**2*s**2 - 154*D1*Ddd*f**2*s + 53*D1*Ddd*f**2 + 224*D1*Ddd*f*g2*r*s - 56*D1*Ddd*f*g2*r - 56*D1*Ddd*f*g2*s - 2*D1*bd1*(D1*(2*f**2*(80*r*s - 30*r + 201*s**2 - 126*s + 48) - 6*f*fd*(32*r*(4*s - 1) + 190*s**2 - 127*s + 8) + 7*f*(r*(4*K - 4)*(3*s + 1) + 40*s**2 - s*(10*K - 12) - 1) + 7*fd*(K*(r*(8*s - 2) - 4*s + 2) + r*(2 - 8*s) - 60*s**2 + 65*s - 2) + 140*g2*r*(4*s - 2) - 280*g2*s + 140*gd2*(-4*r*s + r + s)) - Dd*(6*f**2*(16*r*(16*s - 5) + 380*s**2 - 267*s + 47) + 7*f*(K*(-4*r*(8*s - 3) + 4*s - 2) + 4*r*(8*s - 3) + 240*s**2 - 60*s + 1) + 280*g2*(r*(8*s - 3) - 3*s + 1))) + 576*Dd**2*K*f**2*r*s - 144*Dd**2*K*f**2*r - 144*Dd**2*K*f**2*s + 48*Dd**2*K*f**2 + 1152*Dd**2*f**3*r*s - 288*Dd**2*f**3*r + 1512*Dd**2*f**3*s**2 - 1044*Dd**2*f**3*s + 96*Dd**2*f**3 + 576*Dd**2*f**2*r*s - 144*Dd**2*f**2*r + 636*Dd**2*f**2*s**2 - 462*Dd**2*f**2*s + 48*Dd**2*f**2 + 672*Dd**2*f*g2*r*s - 168*Dd**2*f*g2*r - 168*Dd**2*f*g2*s + 56*Dd**2*f*g2))/(210*d**2*k1) - D1**2*Pk1*Pkd2*ct*(-2*D1*(D1*bd1**2*f*(-r*(2*s - 1)*(28*K + 24*f + 28) + s*(-63*f - 77)*(s - 1)) + 56*D1*bdd1*f*g2*r*(s - 1) - 28*b2*(D1*bd1*(-2*f*r*(s - 1) + fd*r*(2*s - 1) - fd*s + fd) + D1*bdd1*f*r*(s - 1) + Dd*bd1*f*(r*(8*s - 5) - s + 1)) + 28*bd1*(D1*(f*r*(-2*bd2*s + bd2 - 9*g2*s + 9*g2 + 4*gd2*s - 2*gd2) + 2*fd*g2*(2*r*s - r - s + 1)) + 2*Dd*f*g2*(r*(8*s - 5) - s + 1))) - 7*b1**3*(D1**2*s*(16*fd*r + 10*fd*s - 8*fdd*r - 15*fdd*s) + D1*(2*Dd*(-30*K*s + f*(8*r*(4*s - 1) + 20*s**2 - 18*s + 5) - 4*fd*r*(8*s - 1) - 60*fd*s**2 + 19*fd*s - 30*r*(-4*K*s + K + 4*s - 1) - 20*s**2 + 40*s - 5) - Ddd*(f*(8*r*(4*s - 1) + 60*s**2 - 38*s + 15) + 100*s**2 - 50*s + 25)) - 2*Dd**2*(f*(12*r*(4*s - 1) + 90*s**2 - 57*s + 4) + 75*s*(2*s - 1))) + b1**2*(-252*D1**2*K*fd*r*s + 252*D1**2*K*fd*s + 56*D1**2*K*fdd*r*s - 56*D1**2*K*fdd*s + 7*D1**2*bdd1*(f*(8*r*(3*s - 1) + 45*s**2 - 38*s + 15) + 75*s**2 - 50*s + 25) - 192*D1**2*f*fd*r*s - 84*D1**2*f*fd*s**2 + 96*D1**2*f*fd*s + 96*D1**2*f*fdd*r*s + 126*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 96*D1**2*fd**2*r*s + 126*D1**2*fd**2*s**2 - 48*D1**2*fd**2*s + 28*D1**2*fd*r*s - 14*D1**2*fd*s**2 - 28*D1**2*fd*s + 56*D1**2*fdd*r*s + 77*D1**2*fdd*s**2 - 56*D1**2*fdd*s + 840*D1**2*gd2*r*s - 1008*D1*Dd*K*f*r*s + 252*D1*Dd*K*f*r + 252*D1*Dd*K*f*s + 448*D1*Dd*K*fd*r*s - 56*D1*Dd*K*fd*r - 280*D1*Dd*K*fd*s + 56*D1*Dd*K*fd - 384*D1*Dd*f**2*r*s + 96*D1*Dd*f**2*r - 168*D1*Dd*f**2*s**2 + 180*D1*Dd*f**2*s - 42*D1*Dd*f**2 + 768*D1*Dd*f*fd*r*s - 96*D1*Dd*f*fd*r + 1008*D1*Dd*f*fd*s**2 - 540*D1*Dd*f*fd*s + 48*D1*Dd*f*fd + 112*D1*Dd*f*r*s - 28*D1*Dd*f*r - 56*D1*Dd*f*s**2 - 14*D1*Dd*f + 448*D1*Dd*fd*r*s - 56*D1*Dd*fd*r + 616*D1*Dd*fd*s**2 - 434*D1*Dd*fd*s + 56*D1*Dd*fd + 3360*D1*Dd*g2*r*s - 840*D1*Dd*g2*r - 840*D1*Dd*g2*s + 224*D1*Ddd*K*f*r*s - 56*D1*Ddd*K*f*r - 56*D1*Ddd*K*f*s + 192*D1*Ddd*f**2*r*s - 48*D1*Ddd*f**2*r + 252*D1*Ddd*f**2*s**2 - 174*D1*Ddd*f**2*s + 63*D1*Ddd*f**2 + 224*D1*Ddd*f*r*s - 56*D1*Ddd*f*r + 308*D1*Ddd*f*s**2 - 210*D1*Ddd*f*s + 77*D1*Ddd*f - 14*D1*bd1*(D1*(-30*K*s + f*(8*r*(3*s - 1) + 15*s**2 - 18*s + 5) + fd*r*(4 - 24*s) - 45*fd*s**2 + 19*fd*s + r*(30*K - 30)*(3*s - 1) - 15*s**2 + 40*s - 5) - Dd*(f*(4*r*(24*s - 7) + 180*s**2 - 133*s + 23) + 300*s**2 - 175*s + 25)) + 672*Dd**2*K*f*r*s - 168*Dd**2*K*f*r - 168*Dd**2*K*f*s + 56*Dd**2*K*f + 576*Dd**2*f**2*r*s - 144*Dd**2*f**2*r + 756*Dd**2*f**2*s**2 - 522*Dd**2*f**2*s + 48*Dd**2*f**2 + 672*Dd**2*f*r*s - 168*Dd**2*f*r + 924*Dd**2*f*s**2 - 630*Dd**2*f*s + 56*Dd**2*f) + b1*(14*D1**2*bd1**2*(f*(8*r*(3*s - 1) + 45*s**2 - 38*s + 4) + 25*s*(3*s - 2)) + D1**2*bdd1*f*(3*f*(32*r*s - 16*r + 42*s**2 - 42*s + 21) + r*(56*K + 56)*(2*s - 1) + 154*s**2 - 154*s + 77) - 56*D1*Dd*(f*(bd2*(-8*r*s + r + s) + 9*g2*(-4*r*s + r + s) + 2*gd2*(8*r*s - r - s)) + 2*fd*g2*(r*(8*s - 1) - 5*s + 1)) - 2*D1*bd1*(D1*(3*f**2*(32*r*s - 16*r + 14*s**2 - 14*s + 7) - 6*f*fd*(8*r*(4*s - 1) + 42*s**2 - 29*s + 4) + 7*f*(r*(18*K - 2)*(2*s - 1) + 2*s**2 - 2*s + 1) - 7*fd*(4*K*(r*(4*s - 1) - 2*s + 1) + 4*r*(4*s - 1) + 22*s**2 - 19*s + 4) - 420*g2*(r*(2*s - 1) - s)) - Dd*f*(28*K*(2*r*(8*s - 3) - 2*s + 1) + 3*f*(16*r*(8*s - 3) + 168*s**2 - 142*s + 29) + 56*r*(8*s - 3) + 616*s**2 - 518*s + 105)) - 56*D1*(D1*s*(bd2*(2*f*r - 2*fd*r + fd) - bdd2*f*r - 9*f*gd2*r + 2*f*gdd2*r + fd*(-9*g2*r + 9*g2 + 4*gd2*r - 2*gd2) + 2*fdd*g2*r - 2*fdd*g2) + 2*Ddd*f*g2*(r*(4*s - 1) - s)) - 112*Dd**2*f*g2*(3*r*(4*s - 1) - 3*s + 1) - 56*b2*(-D1*Dd*(2*f*(-4*r*s + r + s) + fd*r*(8*s - 1) - 5*fd*s + fd) + D1*(D1*s*(2*fd - fdd)*(r - 1) + Ddd*f*(-4*r*s + r + s)) - Dd**2*f*(3*r*(4*s - 1) - 3*s + 1))))/(210*d**2*k1) + D1**2*Pk1*Pkd2*f*k2*st**6*(11*D1*bd1*f*(D1*(5*f*s*(r - 1) - 7*fd*(6*r*s - r - 3*s + 1)) - 7*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 11*b1*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(5*f*fd - 7*f*fdd - 14*fd**2) + 7*Ddd*f**2*(4*r*s - r - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(3*D1*Dd*f*(3*f*r*(4*s - 1) - 3*f*s - 14*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(9*f*fd*(r*(4*s - 1) - s) + 7*f*(-11*bdd1*s*(r - 1) + 3*fdd*(-4*r*s + r + s)) - 21*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 21*Ddd*f**2*(-4*r*s + r + s)) - 21*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1**2) - D1**2*Pk1*Pkd2*k1**2*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(5*C*(2*s**2 - 2*s + 1) - 2*r*s + r - 4*s**2 + 4*s - 2) + fd**2*(r*(2*s - 1) + s*(4 - 10*C)*(s - 1))) + D1*f*(Dd*(2*f*(5*C*(4*s**2 - 2*s + 1) - 4*r*s + r - 8*s**2 + 5*s - 2) + fd*(-10*C*(8*s**2 - 6*s + 1) + 16*r*s - 6*r + 32*s**2 - 26*s + 5)) - Ddd*f*(5*C*(4*s**2 - 2*s + 1) - 4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f**2*(3*r*(4*s - 1) + s**2*(24 - 60*C) + s*(30*C - 15) + 1)) + f*(D1**2*(f*(3*bdd1*s*(-5*C*s + r + 2*s - 1) + 2*fd*(5*C*(3*s**2 - 2*s + 1) - 3*r*s + r - 6*s**2 + 5*s - 2) - fdd*(5*C*(3*s**2 - 2*s + 1) - 3*r*s + r - 6*s**2 + 5*s - 2)) + fd**2*(r*(6*s - 2) - s**2*(30*C - 12) + s*(20*C - 10) + 1)) - 3*D1*bd1*(-2*D1*f*s*(-r + s*(5*C - 2) + 1) - D1*fd*r*(4*s - 1) + D1*fd*(2*s - 1)*(s*(10*C - 4) + 1) + Dd*f*(-8*r*s + r + s**2*(40*C - 16) + s*(9 - 10*C) - 1)) + D1*f*(Dd*(2*f*(5*C*(4*s**2 - 2*s + 1) - 4*r*s + r - 8*s**2 + 5*s - 2) + fd*(-10*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r + 48*s**2 - 35*s + 6)) - Ddd*f*(5*C*(4*s**2 - 2*s + 1) - 4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f**2*(3*r*(4*s - 1) + s**2*(24 - 60*C) + s*(30*C - 15) + 1)))/(105*d**2*k2*k3**2) - D1**2*Pk1*Pkd2*k1**2*st**2*(7*b1**2*(D1**2*s*(2*fd - fdd)*(-r + s*(C - 2)) + D1*(Dd*(2*f*(4*C*s**2 - 2*C*s + C - 4*r*s + r - 8*s**2 + 5*s - 2) + fd*r*(8*s - 1) + fd*s*(C*(2 - 8*s) + 16*s - 5)) - Ddd*f*(4*C*s**2 - 2*C*s + C - 4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f*(3*r*(4*s - 1) - s**2*(12*C - 24) + s*(6*C - 15) + 1)) + b1*(-100*C*D1**2*f*fd*s**2 + 112*C*D1**2*f*fd*s - 56*C*D1**2*f*fd + 64*C*D1**2*f*fdd*s**2 - 70*C*D1**2*f*fdd*s + 35*C*D1**2*f*fdd + 64*C*D1**2*fd**2*s**2 - 70*C*D1**2*fd**2*s - 200*C*D1*Dd*f**2*s**2 + 100*C*D1*Dd*f**2*s - 50*C*D1*Dd*f**2 + 512*C*D1*Dd*f*fd*s**2 - 408*C*D1*Dd*f*fd*s + 70*C*D1*Dd*f*fd + 128*C*D1*Ddd*f**2*s**2 - 64*C*D1*Ddd*f**2*s + 32*C*D1*Ddd*f**2 + 384*C*Dd**2*f**2*s**2 - 192*C*Dd**2*f**2*s - 7*D1**2*bdd1*f*(2*C*s**2 - 2*C*s + C - 2*r*s + r - 4*s**2 + 5*s - 2) + 2*D1**2*f*fd*r*s - 7*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s + 6*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*s**2 - 3*D1**2*f*fdd*s + 6*D1**2*fd**2*r*s + 12*D1**2*fd**2*s**2 - 3*D1**2*fd**2*s + 4*D1*Dd*f**2*r*s - D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 23*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 48*D1*Dd*f*fd*r*s - 6*D1*Dd*f*fd*r + 96*D1*Dd*f*fd*s**2 - 42*D1*Dd*f*fd*s + 3*D1*Dd*f*fd + 12*D1*Ddd*f**2*r*s - 3*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s**2 - 15*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 7*D1*bd1*(D1*(2*f*(2*C*s**2 - 2*C*s + C - 2*r*s + r - 4*s**2 + 5*s - 2) + fd*r*(4*s - 1) + fd*s*(C*(2 - 4*s) + 8*s - 5)) - 2*Dd*f*(8*C*s**2 - 6*C*s + C - 8*r*s + 3*r - 16*s**2 + 15*s - 3)) + 36*Dd**2*f**2*r*s - 9*Dd**2*f**2*r + 72*Dd**2*f**2*s**2 - 45*Dd**2*f**2*s + 3*Dd**2*f**2) + f*(-3*C*(D1**2*(f*(8*fd - 5*fdd)*(3*s**2 - 2*s + 1) + 10*fd**2*s*(2 - 3*s)) + D1*f*(8*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(12*s**2 - 7*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)) + 7*D1**2*bd1**2*(r*(2*s - 1) - (s - 1)*(s*(2*C - 4) + 1)) + D1**2*bdd1*f*(C*(32*s**2 + 6*s - 3) + (3*s - 3)*(r + 2*s - 2)) + D1*bd1*(C*Dd*f*(256*s**2 - 40*s - 6) + D1*f*(-2*C*(25*s**2 + 6*s - 3) + r*(s + 6) - 12*s**2 + 17*s - 12) + D1*fd*(6*r*(2*s - 1) + s**2*(128*C + 24) - s*(58*C + 27) + 3) + 3*Dd*f*(r*(8*s - 5) + 16*s**2 - 21*s + 5)) - 3*D1*f*(D1*fd*(-3*r*s + r + s) + Dd*f*(-4*r*s + r + s))))/(105*d**2*k2*k3**2) - D1**2*Pk1*Pkd2*k1**2*(D1*f*(s - 1)*(3*C*D1*bdd1*f*(s - 1) + bd1*(2*C*D1*s*(5*bd1 + 6*fd) + 6*C*Dd*f*(4*s - 1) + 3*D1*f*r)) + 5*b1**2*(C*(D1**2*fdd*s**2 + 2*D1*Dd*fd*s*(4*s - 1) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1)) + D1*(D1*fd*r*s + Dd*f*(4*r*s - r - s))) + b1*(5*C*D1**2*bdd1*f*(2*s**2 - 2*s + 1) + 3*C*(2*D1**2*s**2*(f*fdd + fd**2) + D1*f*(4*Dd*fd*s*(4*s - 1) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)) + 5*D1*bd1*(2*C*(2*s - 1)*(D1*fd*s + Dd*f*(4*s - 1)) + D1*f*(r*(2*s - 1) - s)) + 3*D1*f*(D1*fd*s*(2*r - 1) + Dd*f*(4*r*s - r - s))))/(15*d**2*k2*k3**2) + D1**2*Pk1*Pkd2*k2*st**6*(9*D1*bd1*f*(-2*D1*f*s*(5*C*s - r + 1) - D1*fd*r*(4*s - 1) + D1*fd*(2*s - 1)*(10*C*s + 1) + Dd*f*(40*C*s**2 - 8*r*s + r + s*(5 - 10*C) - 1)) - 9*b1*(5*C*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(-5*C*(D1**2*(-f*(9*bdd1*s**2 + fd*(-6*s**2 + 4*s - 2) + 3*fdd*s**2 - 2*fdd*s + fdd) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 7*r + 7*s - 2)) + D1*(D1*(2*f*fd*(r*(3*s - 1) - s) + f*(-9*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) + fd**2*(r*(2 - 6*s) + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(63*d**2*k3**2) + D1**2*Pk1*Pkd2*k2*st**4*(-21*D1**2*bd1**2*f*(r*(2*s - 1) - (s - 1)*(2*C*s + 1)) - 3*D1*bd1*(7*b1*(2*C*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - D1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) + 2*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(2*C*(D1*(f*(-14*r*s - 41*s**2 + 12*s + 1) + fd*(56*r*s - 14*r + 124*s**2 - 89*s + 14)) + Dd*f*(14*r*(8*s - 1) + 248*s**2 - 128*s + 13)) + D1*(f*(r*(3*s + 2) - s*(4*s + 5)) + fd*(r*(8*s - 3) + 8*s**2 - 7*s + 2)) + 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 5*s + 1))) - 21*b1**2*(C*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1*(7*D1**2*bdd1*f*(2*C*s**2 - 2*C*s + C - 2*r*s + r + s) + D1**2*(f*(fd*(4*C*(14*r*s - 7*r + 41*s**2 - 42*s + 21) - 6*r*s + 5*r + 8*s**2 - 10*s + 4) + fdd*(C*(-56*r*s + 28*r - 124*s**2 + 126*s - 63) - 4*r*s + r - 4*s**2 + 5*s - 2)) + fd**2*(r*(-56*C*s + 28*C - 4*s + 1) + s*(-124*C*s + 126*C - 4*s + 5))) + D1*f*(Dd*(f*(2*C*(56*r*s - 14*r + 164*s**2 - 96*s + 41) - 12*r*s + 3*r + 16*s**2 - 5*s + 4) - 2*fd*(C*(28*r*(8*s - 3) + 496*s**2 - 404*s + 77) + (4*s - 1)*(4*r + 4*s - 3))) - 2*Ddd*f*(C*(56*r*s - 14*r + 124*s**2 - 76*s + 31) + 4*r*s - r + 4*s**2 - 3*s + 1)) - 2*Dd**2*f**2*(2*C*(84*r*s - 21*r + 186*s**2 - 114*s + 7) + 12*r*s - 3*r + 12*s**2 - 9*s + 1)) + f*(3*D1**2*bdd1*f*(-62*C*s**2 + C*s*(26 - 28*r) + C - (r + s)*(2*s - 1)) + D1**2*(f*(fd*(4*C*(15*r*s - 5*r + 27*s**2 - 23*s + 9) - 3*r*s + r + 12*s**2 - 7*s + 4) + fdd*(C*(-84*r*s + 28*r - 81*s**2 + 82*s - 27) - 3*r*s + r - 6*s**2 + 5*s - 2)) - fd**2*(2*C*(84*r*s - 28*r + 81*s**2 - 82*s + 14) + 6*r*s - 2*r + 12*s**2 - 10*s + 1)) + D1*f*(Dd*(f*(4*C*(20*r*s - 5*r + 36*s**2 - 23*s + 9) - 4*r*s + r + 16*s**2 - 7*s + 4) - fd*(2*C*(336*r*s - 98*r + 324*s**2 - 287*s + 55) + 24*r*s - 7*r + 48*s**2 - 35*s + 6)) + Ddd*f*(C*(-112*r*s + 28*r - 108*s**2 + 82*s - 27) - 4*r*s + r - 8*s**2 + 5*s - 2)) - Dd**2*f**2*(C*(84*r*(4*s - 1) + 324*s**2 - 246*s + 28) + 3*r*(4*s - 1) + 24*s**2 - 15*s + 1)))/(105*d**2*k3**2) + D1**2*Pk1*Pkd2*k2*st**2*(D1*f*(-7*D1*bd1**2*(10*C*(4*r*s - 2*r + 5*s**2 - 7*s + 2) + 2*r*s - r + 4*s**2 - 5*s + 1) + bd1*(-10*C*Dd*f*(6*r*(8*s - 5) + 28*s**2 - 41*s + 13) + D1*f*(4*C*(s - 1)*(9*r + 7*s - 7) - 8*r*s + r + 12*s**2 - 17*s + 12) - D1*fd*(20*C*(12*r*s - 6*r + 7*s**2 - 10*s + 3) + 12*r*s - 6*r + 24*s**2 - 27*s + 3) - 3*Dd*f*(r*(8*s - 5) + 16*s**2 - 21*s + 5)) + f*(-D1*bdd1*(s - 1)*(5*C*(12*r + 7*s - 7) + 3*r + 6*s - 6) + 3*D1*fd*(-3*r*s + r + s) + 3*Dd*f*(-4*r*s + r + s))) + 7*b1**2*(D1**2*s*(fd*(20*C*r + 20*C*s - 3*r + 4*s) - fdd*(20*C*r + 25*C*s + r + 2*s)) + D1*(Dd*(f*(20*C*(4*r*s - r + 4*s**2 - 3*s + 1) - 12*r*s + 3*r + 16*s**2 - 5*s + 4) + fd*(-r*(20*C + 1)*(8*s - 1) + s*(-200*C*s + 70*C - 16*s + 5))) + Ddd*f*(-5*C*(16*r*s - 4*r + 20*s**2 - 14*s + 5) - 4*r*s + r - 8*s**2 + 5*s - 2)) - Dd**2*f*(10*C*(24*r*s - 6*r + 30*s**2 - 21*s + 2) + 12*r*s - 3*r + 24*s**2 - 15*s + 1)) + b1*(72*C*D1**2*f*fd*r*s + 56*C*D1**2*f*fd*s**2 - 36*C*D1**2*f*fd*s - 120*C*D1**2*f*fdd*r*s - 70*C*D1**2*f*fdd*s**2 + 60*C*D1**2*f*fdd*s - 120*C*D1**2*fd**2*r*s - 70*C*D1**2*fd**2*s**2 + 60*C*D1**2*fd**2*s + 144*C*D1*Dd*f**2*r*s - 36*C*D1*Dd*f**2*r + 112*C*D1*Dd*f**2*s**2 - 92*C*D1*Dd*f**2*s + 28*C*D1*Dd*f**2 - 960*C*D1*Dd*f*fd*r*s + 120*C*D1*Dd*f*fd*r - 560*C*D1*Dd*f*fd*s**2 + 500*C*D1*Dd*f*fd*s - 60*C*D1*Dd*f*fd - 240*C*D1*Ddd*f**2*r*s + 60*C*D1*Ddd*f**2*r - 140*C*D1*Ddd*f**2*s**2 + 130*C*D1*Ddd*f**2*s - 35*C*D1*Ddd*f**2 - 720*C*Dd**2*f**2*r*s + 180*C*Dd**2*f**2*r - 420*C*Dd**2*f**2*s**2 + 390*C*Dd**2*f**2*s - 60*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(5*C*(8*r*s - 4*r + 10*s**2 - 14*s + 5) + 2*r*s - r + 4*s**2 - 5*s + 2) - 16*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 + D1**2*f*fd*s - 6*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s - 6*D1**2*fd**2*r*s - 12*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s - 32*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 42*D1*Dd*f*fd*s - 3*D1*Dd*f*fd - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 15*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(20*C*(2*s - 1)*(r + s - 1) - 6*r*s + 3*r + 8*s**2 - 5*s + 4) + fd*(-r*(20*C + 1)*(4*s - 1) + s*(-100*C*s + 70*C - 8*s + 5))) - 2*Dd*f*(5*C*(4*r*(8*s - 3) + 40*s**2 - 42*s + 9) + 8*r*s - 3*r + 16*s**2 - 15*s + 3)) - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 45*Dd**2*f**2*s - 3*Dd**2*f**2))/(105*d**2*k3**2) - 3*D1**2*Pk1*Pkd2*st**6*(33*b1**2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + 11*b1*f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(12*bd1 - 6*bdd1)) + 2*fd*s*(bd1*(6 - 12*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(6*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f**2*(D1**2*(f*(4*fd*(4*s**2 - 2*s + 1) + fdd*(-8*s**2 + 4*s - 2) + s**2*(22*bd1 - 11*bdd1)) - 2*s*(33*bd1**2*s + 11*bd1*fd*(3*s - 1) + 6*fd**2*(2*s - 1))) + 2*D1*f*(Dd*f*(8*s**2 - 4*s + 2) - Dd*(4*s - 1)*(11*bd1*s + fd*(8*s - 2)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 12*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k2) - D1**2*Pk1*Pkd2*st**4*(-2310*D1**2*K*bd1**2*f*s**2 + 330*D1**2*K*bd1*f**2*s**2 - 660*D1**2*K*bd1*f*fd*s**2 + 330*D1**2*K*bd1*f*fd*s - 165*D1**2*K*bdd1*f**2*s**2 + 924*D1**2*bd1**2*f**2*r*s + 2838*D1**2*bd1**2*f**2*s**2 + 528*D1**2*bd1**2*f**2*s + 924*D1**2*bd1**2*f*r*s - 2310*D1**2*bd1**2*f*s**2 - 462*D1**2*bd1**2*f*s - 2310*D1**2*bd1*bd2*f*s**2 - 220*D1**2*bd1*f**3*r*s - 1254*D1**2*bd1*f**3*s**2 - 330*D1**2*bd1*f**3*s + 220*D1**2*bd1*f**3 + 1848*D1**2*bd1*f**2*fd*r*s - 308*D1**2*bd1*f**2*fd*r + 4356*D1**2*bd1*f**2*fd*s**2 - 1628*D1**2*bd1*f**2*fd*s + 154*D1**2*bd1*f**2*fd - 132*D1**2*bd1*f**2*r*s + 330*D1**2*bd1*f**2*s**2 + 264*D1**2*bd1*f*fd*r*s - 66*D1**2*bd1*f*fd*r - 660*D1**2*bd1*f*fd*s**2 + 264*D1**2*bd1*f*fd*s - 4620*D1**2*bd1*f*g2*s**2 + 4620*D1**2*bd1*f*gd2*s**2 + 4620*D1**2*bd1*fd*g2*s**2 - 4620*D1**2*bd1*fd*g2*s + 330*D1**2*bd2*f**2*s**2 - 660*D1**2*bd2*f*fd*s**2 + 330*D1**2*bd2*f*fd*s + 308*D1**2*bdd1*f**3*r*s + 726*D1**2*bdd1*f**3*s**2 + 66*D1**2*bdd1*f**3*s - 110*D1**2*bdd1*f**3 + 66*D1**2*bdd1*f**2*r*s - 165*D1**2*bdd1*f**2*s**2 + 2310*D1**2*bdd1*f*g2*s**2 - 165*D1**2*bdd2*f**2*s**2 - 120*D1**2*f**3*fd*r*s + 30*D1**2*f**3*fd*r - 1408*D1**2*f**3*fd*s**2 + 734*D1**2*f**3*fd*s - 352*D1**2*f**3*fd + 280*D1**2*f**3*fdd*r*s - 70*D1**2*f**3*fdd*r + 792*D1**2*f**3*fdd*s**2 - 466*D1**2*f**3*fdd*s + 198*D1**2*f**3*fdd + 840*D1**2*f**2*fd**2*r*s - 210*D1**2*f**2*fd**2*r + 2376*D1**2*f**2*fd**2*s**2 - 1398*D1**2*f**2*fd**2*s + 70*D1**2*f**2*fd**2 - 660*D1**2*f**2*gd2*s**2 + 330*D1**2*f**2*gdd2*s**2 - 1320*D1**2*f*fd*g2*s**2 + 1320*D1**2*f*fd*g2*s - 660*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*s**2 - 660*D1**2*f*fd*gd2*s + 660*D1**2*f*fdd*g2*s**2 - 660*D1**2*f*fdd*g2*s + 330*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*s**2 - 660*D1**2*fd**2*g2*s - 1320*D1*Dd*K*bd1*f**2*s**2 + 330*D1*Dd*K*bd1*f**2*s + 2464*D1*Dd*bd1*f**3*r*s - 308*D1*Dd*bd1*f**3*r + 5808*D1*Dd*bd1*f**3*s**2 - 1496*D1*Dd*bd1*f**3*s - 66*D1*Dd*bd1*f**3 + 528*D1*Dd*bd1*f**2*r*s - 66*D1*Dd*bd1*f**2*r - 1320*D1*Dd*bd1*f**2*s**2 + 264*D1*Dd*bd1*f**2*s + 18480*D1*Dd*bd1*f*g2*s**2 - 4620*D1*Dd*bd1*f*g2*s - 1320*D1*Dd*bd2*f**2*s**2 + 330*D1*Dd*bd2*f**2*s - 120*D1*Dd*f**4*r*s + 30*D1*Dd*f**4*r - 1408*D1*Dd*f**4*s**2 + 734*D1*Dd*f**4*s - 352*D1*Dd*f**4 + 2240*D1*Dd*f**3*fd*r*s - 560*D1*Dd*f**3*fd*r + 6336*D1*Dd*f**3*fd*s**2 - 3728*D1*Dd*f**3*fd*s + 536*D1*Dd*f**3*fd - 2640*D1*Dd*f**2*g2*s**2 + 1320*D1*Dd*f**2*g2*s - 660*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*s**2 - 660*D1*Dd*f**2*gd2*s + 5280*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 660*D1*Dd*f*fd*g2 + 280*D1*Ddd*f**4*r*s - 70*D1*Ddd*f**4*r + 792*D1*Ddd*f**4*s**2 - 466*D1*Ddd*f**4*s + 198*D1*Ddd*f**4 + 1320*D1*Ddd*f**2*g2*s**2 - 660*D1*Ddd*f**2*g2*s + 330*D1*Ddd*f**2*g2 + 840*Dd**2*f**4*r*s - 210*Dd**2*f**4*r + 2376*Dd**2*f**4*s**2 - 1398*Dd**2*f**4*s + 70*Dd**2*f**4 + 3960*Dd**2*f**2*g2*s**2 - 1980*Dd**2*f**2*g2*s + 1155*b1**3*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1**2*(70*D1**2*K*fd*s**2 - 140*D1**2*K*fd*s + 70*D1**2*K*fd - 35*D1**2*K*fdd*s**2 + 70*D1**2*K*fdd*s - 35*D1**2*K*fdd - 35*D1**2*bdd1*f*(3*s**2 - 2*s + 1) - 28*D1**2*f*fd*r*s + 14*D1**2*f*fd*r - 144*D1**2*f*fd*s**2 + 204*D1**2*f*fd*s - 102*D1**2*f*fd + 28*D1**2*f*fdd*r*s - 14*D1**2*f*fdd*r + 86*D1**2*f*fdd*s**2 - 116*D1**2*f*fdd*s + 58*D1**2*f*fdd + 28*D1**2*fd**2*r*s - 14*D1**2*fd**2*r + 86*D1**2*fd**2*s**2 - 116*D1**2*fd**2*s - 28*D1**2*fd*r*s + 28*D1**2*fd*r + 70*D1**2*fd*s**2 - 140*D1**2*fd*s + 70*D1**2*fd + 14*D1**2*fdd*r*s - 14*D1**2*fdd*r - 35*D1**2*fdd*s**2 + 70*D1**2*fdd*s - 35*D1**2*fdd + 280*D1*Dd*K*f*s**2 - 140*D1*Dd*K*f*s + 70*D1*Dd*K*f - 280*D1*Dd*K*fd*s**2 + 350*D1*Dd*K*fd*s - 70*D1*Dd*K*fd - 56*D1*Dd*f**2*r*s + 14*D1*Dd*f**2*r - 288*D1*Dd*f**2*s**2 + 158*D1*Dd*f**2*s - 72*D1*Dd*f**2 + 224*D1*Dd*f*fd*r*s - 84*D1*Dd*f*fd*r + 688*D1*Dd*f*fd*s**2 - 664*D1*Dd*f*fd*s + 130*D1*Dd*f*fd - 112*D1*Dd*f*r*s + 28*D1*Dd*f*r + 280*D1*Dd*f*s**2 - 112*D1*Dd*f*s + 70*D1*Dd*f + 112*D1*Dd*fd*r*s - 70*D1*Dd*fd*r - 280*D1*Dd*fd*s**2 + 336*D1*Dd*fd*s - 56*D1*Dd*fd - 140*D1*Ddd*K*f*s**2 + 70*D1*Ddd*K*f*s - 35*D1*Ddd*K*f + 56*D1*Ddd*f**2*r*s - 14*D1*Ddd*f**2*r + 172*D1*Ddd*f**2*s**2 - 100*D1*Ddd*f**2*s + 43*D1*Ddd*f**2 + 56*D1*Ddd*f*r*s - 14*D1*Ddd*f*r - 140*D1*Ddd*f*s**2 + 56*D1*Ddd*f*s - 35*D1*Ddd*f + 70*D1*bd1*(D1*f*(3*s**2 - 2*s + 1) + D1*fd*s*(1 - 3*s) + Dd*f*(-12*s**2 + 7*s - 1)) - 420*Dd**2*K*f*s**2 + 210*Dd**2*K*f*s + 168*Dd**2*f**2*r*s - 42*Dd**2*f**2*r + 516*Dd**2*f**2*s**2 - 300*Dd**2*f**2*s + 14*Dd**2*f**2 + 168*Dd**2*f*r*s - 42*Dd**2*f*r - 420*Dd**2*f*s**2 + 168*Dd**2*f*s + 14*Dd**2*f) + 11*b1*(-210*D1**2*K*bdd1*f*s**2 + 60*D1**2*K*f*fd*s**2 - 60*D1**2*K*f*fd*s + 30*D1**2*K*f*fd - 30*D1**2*K*f*fdd*s**2 + 30*D1**2*K*f*fdd*s - 15*D1**2*K*f*fdd - 30*D1**2*K*fd**2*s**2 + 30*D1**2*K*fd**2*s - 210*D1**2*bd1**2*f*s*(3*s - 2) + 210*D1**2*bd2*f*s**2 - 210*D1**2*bd2*fd*s**2 + 210*D1**2*bd2*fd*s + 84*D1**2*bdd1*f**2*r*s + 258*D1**2*bdd1*f**2*s**2 + 48*D1**2*bdd1*f**2*s - 45*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*r*s - 210*D1**2*bdd1*f*s**2 - 42*D1**2*bdd1*f*s - 105*D1**2*bdd2*f*s**2 - 60*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 342*D1**2*f**2*fd*s**2 + 278*D1**2*f**2*fd*s - 134*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r*s - 28*D1**2*f**2*fdd*r + 198*D1**2*f**2*fdd*s**2 - 166*D1**2*f**2*fdd*s + 76*D1**2*f**2*fdd + 168*D1**2*f*fd**2*r*s - 56*D1**2*f*fd**2*r + 396*D1**2*f*fd**2*s**2 - 332*D1**2*f*fd**2*s + 14*D1**2*f*fd**2 - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s + 30*D1**2*f*fd + 12*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s - 15*D1**2*f*fdd - 420*D1**2*f*gd2*s**2 + 210*D1**2*f*gdd2*s**2 + 12*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s + 6*D1**2*fd**2 - 420*D1**2*fd*g2*s**2 + 840*D1**2*fd*g2*s - 420*D1**2*fd*g2 + 420*D1**2*fd*gd2*s**2 - 420*D1**2*fd*gd2*s + 210*D1**2*fdd*g2*s**2 - 420*D1**2*fdd*g2*s + 210*D1**2*fdd*g2 + 120*D1*Dd*K*f**2*s**2 - 60*D1*Dd*K*f**2*s + 30*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*s**2 + 180*D1*Dd*K*f*fd*s - 30*D1*Dd*K*f*fd - 840*D1*Dd*bd2*f*s**2 + 210*D1*Dd*bd2*f*s - 80*D1*Dd*f**3*r*s + 20*D1*Dd*f**3*r - 456*D1*Dd*f**3*s**2 + 248*D1*Dd*f**3*s - 114*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r*s - 196*D1*Dd*f**2*fd*r + 1584*D1*Dd*f**2*fd*s**2 - 1144*D1*Dd*f**2*fd*s + 194*D1*Dd*f**2*fd - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 48*D1*Dd*f**2*s + 30*D1*Dd*f**2 + 96*D1*Dd*f*fd*r*s - 36*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 144*D1*Dd*f*fd*s - 18*D1*Dd*f*fd - 1680*D1*Dd*f*g2*s**2 + 840*D1*Dd*f*g2*s - 420*D1*Dd*f*g2 + 1680*D1*Dd*f*gd2*s**2 - 420*D1*Dd*f*gd2*s + 1680*D1*Dd*fd*g2*s**2 - 2100*D1*Dd*fd*g2*s + 420*D1*Dd*fd*g2 - 60*D1*Ddd*K*f**2*s**2 + 30*D1*Ddd*K*f**2*s - 15*D1*Ddd*K*f**2 + 112*D1*Ddd*f**3*r*s - 28*D1*Ddd*f**3*r + 264*D1*Ddd*f**3*s**2 - 160*D1*Ddd*f**3*s + 66*D1*Ddd*f**3 + 24*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 24*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + 840*D1*Ddd*f*g2*s**2 - 420*D1*Ddd*f*g2*s + 210*D1*Ddd*f*g2 - 6*D1*bd1*(D1*(f**2*(72*s**2 + s*(14*r + 23) - 15) - f*(fd*(14*r*(4*s - 1) + 172*s**2 - 100*s + 7) + 14*s*(-2*r + s*(5*K + 5) + 1)) + 7*fd*(r*(2 - 4*s) + (s - 1)*(s*(10*K + 10) + 1))) + Dd*f*(f*(-14*r*(8*s - 1) - 344*s**2 + 68*s + 8) + 7*r*(2 - 16*s) + 7*s**2*(40*K + 40) - 7*s*(10*K + 4) - 7)) - 180*Dd**2*K*f**2*s**2 + 90*Dd**2*K*f**2*s + 336*Dd**2*f**3*r*s - 84*Dd**2*f**3*r + 792*Dd**2*f**3*s**2 - 480*Dd**2*f**3*s + 28*Dd**2*f**3 + 72*Dd**2*f**2*r*s - 18*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 72*Dd**2*f**2*s + 6*Dd**2*f**2 + 2520*Dd**2*f*g2*s**2 - 1260*Dd**2*f*g2*s + 105*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))) + 165*b2*(D1**2*(f*(fd*(4*s**2 - 4*s + 2) + fdd*(-2*s**2 + 2*s - 1) + s**2*(14*bd1 - 7*bdd1)) - 2*fd*s*(7*bd1 + fd)*(s - 1)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(7*bd1*s + fd*(2*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(2310*d**2*k2) - D1**2*Pk1*Pkd2*st**2*(1008*D1**2*K*bd1**2*f*s**2 + 42*D1**2*K*bd1**2*f*s - 168*D1**2*K*bd1*f**2*s**2 + 420*D1**2*K*bd1*f*fd*s**2 - 210*D1**2*K*bd1*f*fd*s + 105*D1**2*K*bdd1*f**2*s**2 + 360*D1**2*bd1**2*f**2*r*s - 180*D1**2*bd1**2*f**2*r + 822*D1**2*bd1**2*f**2*s**2 - 702*D1**2*bd1**2*f**2*s + 90*D1**2*bd1**2*f**2 + 84*D1**2*bd1**2*f*r*s - 42*D1**2*bd1**2*f*r + 1008*D1**2*bd1**2*f*s**2 + 42*D1**2*bd1**2*f*s + 420*D1**2*bd1**2*g2*s**2 - 420*D1**2*bd1**2*g2*s + 1008*D1**2*bd1*bd2*f*s**2 + 42*D1**2*bd1*bd2*f*s - 10*D1**2*bd1*f**3*r*s + 10*D1**2*bd1*f**3*r - 216*D1**2*bd1*f**3*s**2 + 288*D1**2*bd1*f**3*s - 144*D1**2*bd1*f**3 + 300*D1**2*bd1*f**2*fd*r*s - 150*D1**2*bd1*f**2*fd*r + 810*D1**2*bd1*f**2*fd*s**2 - 680*D1**2*bd1*f**2*fd*s + 50*D1**2*bd1*f**2*fd + 42*D1**2*bd1*f**2*r*s - 168*D1**2*bd1*f**2*s**2 + 420*D1**2*bd1*f*fd*s**2 - 210*D1**2*bd1*f*fd*s + 1596*D1**2*bd1*f*g2*s**2 + 168*D1**2*bd1*f*g2*s - 84*D1**2*bd1*f*g2 - 2016*D1**2*bd1*f*gd2*s**2 - 84*D1**2*bd1*f*gd2*s - 2016*D1**2*bd1*fd*g2*s**2 + 2016*D1**2*bd1*fd*g2*s - 168*D1**2*bd2*f**2*s**2 + 420*D1**2*bd2*f*fd*s**2 - 210*D1**2*bd2*f*fd*s + 50*D1**2*bdd1*f**3*r*s - 50*D1**2*bdd1*f**3*r + 135*D1**2*bdd1*f**3*s**2 - 180*D1**2*bdd1*f**3*s + 90*D1**2*bdd1*f**3 + 105*D1**2*bdd1*f**2*s**2 - 1008*D1**2*bdd1*f*g2*s**2 - 84*D1**2*bdd1*f*g2*s + 42*D1**2*bdd1*f*g2 + 105*D1**2*bdd2*f**2*s**2 + 336*D1**2*f**2*gd2*s**2 - 210*D1**2*f**2*gdd2*s**2 + 672*D1**2*f*fd*g2*s**2 - 672*D1**2*f*fd*g2*s + 336*D1**2*f*fd*g2 - 840*D1**2*f*fd*gd2*s**2 + 420*D1**2*f*fd*gd2*s - 420*D1**2*f*fdd*g2*s**2 + 420*D1**2*f*fdd*g2*s - 210*D1**2*f*fdd*g2 - 420*D1**2*fd**2*g2*s**2 + 420*D1**2*fd**2*g2*s + 840*D1*Dd*K*bd1*f**2*s**2 - 210*D1*Dd*K*bd1*f**2*s + 400*D1*Dd*bd1*f**3*r*s - 250*D1*Dd*bd1*f**3*r + 1080*D1*Dd*bd1*f**3*s**2 - 1040*D1*Dd*bd1*f**3*s + 230*D1*Dd*bd1*f**3 + 840*D1*Dd*bd1*f**2*s**2 - 210*D1*Dd*bd1*f**2*s - 8064*D1*Dd*bd1*f*g2*s**2 + 1680*D1*Dd*bd1*f*g2*s + 84*D1*Dd*bd1*f*g2 + 840*D1*Dd*bd2*f**2*s**2 - 210*D1*Dd*bd2*f**2*s + 1344*D1*Dd*f**2*g2*s**2 - 672*D1*Dd*f**2*g2*s + 336*D1*Dd*f**2*g2 - 1680*D1*Dd*f**2*gd2*s**2 + 420*D1*Dd*f**2*gd2*s - 3360*D1*Dd*f*fd*g2*s**2 + 2520*D1*Dd*f*fd*g2*s - 420*D1*Dd*f*fd*g2 - 840*D1*Ddd*f**2*g2*s**2 + 420*D1*Ddd*f**2*g2*s - 210*D1*Ddd*f**2*g2 - 2520*Dd**2*f**2*g2*s**2 + 1260*Dd**2*f**2*g2*s - 21*b1**3*(2*D1**2*s*(5*fd*r + 19*fd*s - 5*fdd*r - 12*fdd*s) + D1*(2*Dd*(-5*K*(4*s**2 - 2*s + 1) + f*(5*r*(4*s - 1) + 76*s**2 - 43*s + 19) - 40*fd*r*s + 5*fd*r - 96*fd*s**2 + 29*fd*s + 40*r*s - 10*r - 20*s**2 - 5) + Ddd*(20*K*s**2 - 10*K*s + 5*K - 2*f*(5*r*(4*s - 1) + 48*s**2 - 29*s + 12) - 40*r*s + 10*r + 20*s**2 + 5)) - 2*Dd**2*(15*K*s*(1 - 2*s) + f*(15*r*(4*s - 1) + 144*s**2 - 87*s + 5) + 15*r*(4*s - 1) - 30*s**2 + 5)) - 3*b1**2*(266*D1**2*K*fd*s**2 - 560*D1**2*K*fd*s + 280*D1**2*K*fd - 168*D1**2*K*fdd*s**2 + 350*D1**2*K*fdd*s - 175*D1**2*K*fdd - 70*D1**2*bd2*s**2 - 7*D1**2*bdd1*(-15*K*s**2 + 10*K*s - 5*K + 2*f*(5*r*(3*s - 1) + 36*s**2 - 29*s + 12) + 30*r*s - 10*r - 15*s**2 - 5) + 35*D1**2*bdd2*s**2 + 72*D1**2*f*fd*r*s + 436*D1**2*f*fd*s**2 - 130*D1**2*f*fd*s + 56*D1**2*f*fd - 120*D1**2*f*fdd*r*s - 274*D1**2*f*fdd*s**2 + 100*D1**2*f*fdd*s - 35*D1**2*f*fdd - 120*D1**2*fd**2*r*s - 274*D1**2*fd**2*s**2 + 100*D1**2*fd**2*s - 42*D1**2*fd*r*s + 70*D1**2*fd*r + 266*D1**2*fd*s**2 - 588*D1**2*fd*s + 280*D1**2*fd - 14*D1**2*fdd*r*s - 168*D1**2*fdd*s**2 + 364*D1**2*fdd*s - 175*D1**2*fdd + 140*D1**2*gd2*s**2 - 70*D1**2*gdd2*s**2 + 1064*D1*Dd*K*f*s**2 - 532*D1*Dd*K*f*s + 266*D1*Dd*K*f - 1344*D1*Dd*K*fd*s**2 + 1736*D1*Dd*K*fd*s - 350*D1*Dd*K*fd - 280*D1*Dd*b2*s**2 + 140*D1*Dd*b2*s - 70*D1*Dd*b2 + 280*D1*Dd*bd2*s**2 - 70*D1*Dd*bd2*s + 144*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r + 872*D1*Dd*f**2*s**2 - 472*D1*Dd*f**2*s + 218*D1*Dd*f**2 - 960*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 2192*D1*Dd*f*fd*s**2 + 1068*D1*Dd*f*fd*s - 100*D1*Dd*f*fd - 168*D1*Dd*f*r*s + 42*D1*Dd*f*r + 1064*D1*Dd*f*s**2 - 490*D1*Dd*f*s + 266*D1*Dd*f - 112*D1*Dd*fd*r*s + 14*D1*Dd*fd*r - 1344*D1*Dd*fd*s**2 + 1806*D1*Dd*fd*s - 364*D1*Dd*fd + 560*D1*Dd*g2*s**2 - 280*D1*Dd*g2*s + 140*D1*Dd*g2 - 560*D1*Dd*gd2*s**2 + 140*D1*Dd*gd2*s - 672*D1*Ddd*K*f*s**2 + 336*D1*Ddd*K*f*s - 168*D1*Ddd*K*f + 140*D1*Ddd*b2*s**2 - 70*D1*Ddd*b2*s + 35*D1*Ddd*b2 - 240*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 548*D1*Ddd*f**2*s**2 + 334*D1*Ddd*f**2*s - 137*D1*Ddd*f**2 - 56*D1*Ddd*f*r*s + 14*D1*Ddd*f*r - 672*D1*Ddd*f*s**2 + 350*D1*Ddd*f*s - 168*D1*Ddd*f - 280*D1*Ddd*g2*s**2 + 140*D1*Ddd*g2*s - 70*D1*Ddd*g2 + 14*D1*bd1*(D1*(-5*K*(3*s**2 - 2*s + 1) + f*(5*r*(3*s - 1) + 57*s**2 - 43*s + 19) - 30*fd*r*s + 5*fd*r - 72*fd*s**2 + 29*fd*s + 30*r*s - 10*r - 15*s**2 - 5) + Dd*(60*K*s**2 - 35*K*s + 5*K + f*(-5*r*(24*s - 7) - 288*s**2 + 203*s - 34) - 120*r*s + 35*r + 60*s**2 - 5)) - 2016*Dd**2*K*f*s**2 + 1008*Dd**2*K*f*s + 420*Dd**2*b2*s**2 - 210*Dd**2*b2*s - 720*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 1644*Dd**2*f**2*s**2 + 1002*Dd**2*f**2*s - 60*Dd**2*f**2 - 168*Dd**2*f*r*s + 42*Dd**2*f*r - 2016*Dd**2*f*s**2 + 1050*Dd**2*f*s - 14*Dd**2*f - 840*Dd**2*g2*s**2 + 420*Dd**2*g2*s) + b1*(1008*D1**2*K*bdd1*f*s**2 + 42*D1**2*K*bdd1*f*s - 21*D1**2*K*bdd1*f - 336*D1**2*K*f*fd*s**2 + 336*D1**2*K*f*fd*s - 168*D1**2*K*f*fd + 210*D1**2*K*f*fdd*s**2 - 210*D1**2*K*f*fdd*s + 105*D1**2*K*f*fdd + 210*D1**2*K*fd**2*s**2 - 210*D1**2*K*fd**2*s + 42*D1**2*bd1**2*(5*K*s*(2 - 3*s) + f*(10*r*(3*s - 1) + 72*s**2 - 58*s + 5) + 5*r*(6*s - 2) - 15*s**2 + 5) - 798*D1**2*bd2*f*s**2 + 1008*D1**2*bd2*fd*s**2 - 1050*D1**2*bd2*fd*s + 360*D1**2*bdd1*f**2*r*s - 180*D1**2*bdd1*f**2*r + 822*D1**2*bdd1*f**2*s**2 - 702*D1**2*bdd1*f**2*s + 306*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*r*s - 42*D1**2*bdd1*f*r + 1008*D1**2*bdd1*f*s**2 + 42*D1**2*bdd1*f*s - 21*D1**2*bdd1*f + 420*D1**2*bdd1*g2*s**2 - 420*D1**2*bdd1*g2*s + 210*D1**2*bdd1*g2 + 504*D1**2*bdd2*f*s**2 - 30*D1**2*f**2*fd*r*s - 648*D1**2*f**2*fd*s**2 + 154*D1**2*f**2*fd*s - 72*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r*s + 405*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 45*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r*s + 810*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s + 84*D1**2*f*fd*r*s - 42*D1**2*f*fd*r - 336*D1**2*f*fd*s**2 + 294*D1**2*f*fd*s - 168*D1**2*f*fd + 210*D1**2*f*fdd*s**2 - 210*D1**2*f*fdd*s + 105*D1**2*f*fdd + 1596*D1**2*f*gd2*s**2 - 1008*D1**2*f*gdd2*s**2 + 210*D1**2*fd**2*s**2 - 210*D1**2*fd**2*s + 1596*D1**2*fd*g2*s**2 - 3360*D1**2*fd*g2*s + 1680*D1**2*fd*g2 - 2016*D1**2*fd*gd2*s**2 + 2100*D1**2*fd*gd2*s - 1008*D1**2*fdd*g2*s**2 + 2100*D1**2*fdd*g2*s - 1050*D1**2*fdd*g2 - 672*D1*Dd*K*f**2*s**2 + 336*D1*Dd*K*f**2*s - 168*D1*Dd*K*f**2 + 1680*D1*Dd*K*f*fd*s**2 - 1260*D1*Dd*K*f*fd*s + 210*D1*Dd*K*f*fd + 4032*D1*Dd*bd2*f*s**2 - 1008*D1*Dd*bd2*f*s - 40*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r - 864*D1*Dd*f**3*s**2 + 442*D1*Dd*f**3*s - 216*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r*s - 150*D1*Dd*f**2*fd*r + 3240*D1*Dd*f**2*fd*s**2 - 1520*D1*Dd*f**2*fd*s + 140*D1*Dd*f**2*fd + 168*D1*Dd*f**2*r*s - 42*D1*Dd*f**2*r - 672*D1*Dd*f**2*s**2 + 294*D1*Dd*f**2*s - 168*D1*Dd*f**2 + 1680*D1*Dd*f*fd*s**2 - 1260*D1*Dd*f*fd*s + 210*D1*Dd*f*fd + 6384*D1*Dd*f*g2*s**2 - 3192*D1*Dd*f*g2*s + 1596*D1*Dd*f*g2 - 8064*D1*Dd*f*gd2*s**2 + 2016*D1*Dd*f*gd2*s - 8064*D1*Dd*fd*g2*s**2 + 10416*D1*Dd*fd*g2*s - 2100*D1*Dd*fd*g2 + 420*D1*Ddd*K*f**2*s**2 - 210*D1*Ddd*K*f**2*s + 105*D1*Ddd*K*f**2 + 200*D1*Ddd*f**3*r*s - 50*D1*Ddd*f**3*r + 540*D1*Ddd*f**3*s**2 - 320*D1*Ddd*f**3*s + 135*D1*Ddd*f**3 + 420*D1*Ddd*f**2*s**2 - 210*D1*Ddd*f**2*s + 105*D1*Ddd*f**2 - 4032*D1*Ddd*f*g2*s**2 + 2016*D1*Ddd*f*g2*s - 1008*D1*Ddd*f*g2 - 6*D1*bd1*(D1*(f**2*(18*r*(2*s - 1) + 218*s**2 - 171*s + 81) + f*(266*K*s**2 + 14*K*s - 7*K + fd*(-60*r*(4*s - 1) - 548*s**2 + 334*s - 15) - 42*r*s - 14*r + 266*s**2 + 49*s - 7) + 7*fd*(-4*r*s + r - s**2*(48*K + 48) + s*(49*K + 51) - 1) + 35*g2*(4*s**2 - 4*s + 2) + 7*s*(5*bd2 - 10*gd2)*(2*s - 1)) + Dd*(f**2*(-60*r*(8*s - 3) - 1096*s**2 + 802*s - 147) - 7*f*(K*(192*s**2 - 44*s - 1) + 2*r*(8*s - 3) + 2*s*(96*s - 23)) - 70*g2*(8*s**2 - 6*s + 1))) + 1260*Dd**2*K*f**2*s**2 - 630*Dd**2*K*f**2*s + 600*Dd**2*f**3*r*s - 150*Dd**2*f**3*r + 1620*Dd**2*f**3*s**2 - 960*Dd**2*f**3*s + 50*Dd**2*f**3 + 1260*Dd**2*f**2*s**2 - 630*Dd**2*f**2*s - 12096*Dd**2*f*g2*s**2 + 6048*Dd**2*f*g2*s + 21*b2*(-5*D1**2*bdd1*(2*s**2 - 2*s + 1) - 38*D1**2*fd*s**2 + 80*D1**2*fd*s - 40*D1**2*fd + 24*D1**2*fdd*s**2 - 50*D1**2*fdd*s + 25*D1**2*fdd - 152*D1*Dd*f*s**2 + 76*D1*Dd*f*s - 38*D1*Dd*f + 192*D1*Dd*fd*s**2 - 248*D1*Dd*fd*s + 50*D1*Dd*fd + 96*D1*Ddd*f*s**2 - 48*D1*Ddd*f*s + 24*D1*Ddd*f + 10*D1*bd1*(D1*(2*s**2 - 2*s + 1) + Dd*(-8*s**2 + 6*s - 1)) + 288*Dd**2*f*s**2 - 144*Dd**2*f*s)) - 21*b2*(10*D1**2*bd1**2*s*(s - 1) + D1**2*bdd1*f*(-24*s**2 - 2*s + 1) + 16*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 8*D1**2*f*fd - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 32*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 8*D1*Dd*f**2 - 80*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*s**2 + 10*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + 2*D1*bd1*(D1*f*(19*s**2 + 2*s - 1) - 24*D1*fd*s*(s - 1) + Dd*f*(-96*s**2 + 20*s + 1)) - 60*Dd**2*f**2*s**2 + 30*Dd**2*f**2*s))/(630*d**2*k2) - D1**2*Pk1*Pkd2*(D1*(s - 1)*(5*D1*b2*bdd1*f*(s - 1) + 2*D1*bd1*s*(3*bd1*f**2 + 5*bd1*f*(K + 1) - 30*bd1*g2 + 5*bd2*f - 10*f*gd2 - 10*fd*g2) - 10*D1*bdd1*f*g2*(s - 1) + 20*Dd*bd1*f*g2*(1 - 4*s) + 10*b2*bd1*(D1*s*(3*bd1 + fd) + Dd*f*(4*s - 1))) + 5*b1**3*(D1**2*fdd*s**2 + D1*(6*Dd*r*(4*s - 1) + 2*Dd*s*(fd*(4*s - 1) - 3) + Ddd*(3*K + f + 3)*(4*s**2 - 2*s + 1)) + 6*Dd**2*s*(2*s - 1)*(3*K + f + 3)) + b1**2*(5*D1**2*K*fdd*s**2 + 5*D1**2*bdd1*(3*K + f + 3)*(3*s**2 - 2*s + 1) + 15*D1**2*bdd2*s**2 + 6*D1**2*f*fdd*s**2 + 6*D1**2*fd**2*s**2 + 10*D1**2*fd*r*s - 10*D1**2*fd*s + 5*D1**2*fdd*s**2 - 30*D1**2*gdd2*s**2 + 40*D1*Dd*K*fd*s**2 - 10*D1*Dd*K*fd*s + 120*D1*Dd*bd2*s**2 - 30*D1*Dd*bd2*s + 48*D1*Dd*f*fd*s**2 - 12*D1*Dd*f*fd*s + 40*D1*Dd*f*r*s - 10*D1*Dd*f*r - 10*D1*Dd*f*s + 40*D1*Dd*fd*s**2 - 10*D1*Dd*fd*s - 240*D1*Dd*gd2*s**2 + 60*D1*Dd*gd2*s + 20*D1*Ddd*K*f*s**2 - 10*D1*Ddd*K*f*s + 5*D1*Ddd*K*f + 60*D1*Ddd*b2*s**2 - 30*D1*Ddd*b2*s + 15*D1*Ddd*b2 + 12*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 20*D1*Ddd*f*s**2 - 10*D1*Ddd*f*s + 5*D1*Ddd*f - 120*D1*Ddd*g2*s**2 + 60*D1*Ddd*g2*s - 30*D1*Ddd*g2 + 10*D1*bd1*(D1*r*(9*s - 3) + D1*s*(fd*(3*s - 1) - 3) + Dd*(3*K + f + 3)*(12*s**2 - 7*s + 1)) + 60*Dd**2*K*f*s**2 - 30*Dd**2*K*f*s + 180*Dd**2*b2*s**2 - 90*Dd**2*b2*s + 36*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s + 60*Dd**2*f*s**2 - 30*Dd**2*f*s - 360*Dd**2*g2*s**2 + 180*Dd**2*g2*s) + b1*(90*D1**2*K*bd1**2*s**2 - 60*D1**2*K*bd1**2*s + 20*D1**2*K*bd1*fd*s**2 - 10*D1**2*K*bd1*fd*s + 30*D1**2*bd1**2*f*s**2 - 20*D1**2*bd1**2*f*s + 90*D1**2*bd1**2*s**2 - 60*D1**2*bd1**2*s + 60*D1**2*bd1*bd2*s**2 - 30*D1**2*bd1*bd2*s + 24*D1**2*bd1*f*fd*s**2 - 12*D1**2*bd1*f*fd*s + 20*D1**2*bd1*f*r*s - 10*D1**2*bd1*f*r + 20*D1**2*bd1*fd*s**2 - 10*D1**2*bd1*fd*s - 120*D1**2*bd1*gd2*s**2 + 60*D1**2*bd1*gd2*s + 10*D1**2*bd2*fd*s**2 + D1**2*bdd1*(3*f**2 + 5*f*(K + 1) - 30*g2)*(2*s**2 - 2*s + 1) + 5*D1**2*bdd2*f*s**2 - 10*D1**2*f*gdd2*s**2 - 20*D1**2*fd*gd2*s**2 - 10*D1**2*fdd*g2*s**2 + 80*D1*Dd*K*bd1*f*s**2 - 60*D1*Dd*K*bd1*f*s + 10*D1*Dd*K*bd1*f + 48*D1*Dd*bd1*f**2*s**2 - 36*D1*Dd*bd1*f**2*s + 6*D1*Dd*bd1*f**2 + 80*D1*Dd*bd1*f*s**2 - 60*D1*Dd*bd1*f*s + 10*D1*Dd*bd1*f - 480*D1*Dd*bd1*g2*s**2 + 360*D1*Dd*bd1*g2*s - 60*D1*Dd*bd1*g2 + 40*D1*Dd*bd2*f*s**2 - 10*D1*Dd*bd2*f*s - 80*D1*Dd*f*gd2*s**2 + 20*D1*Dd*f*gd2*s - 80*D1*Dd*fd*g2*s**2 + 20*D1*Dd*fd*g2*s - 40*D1*Ddd*f*g2*s**2 + 20*D1*Ddd*f*g2*s - 10*D1*Ddd*f*g2 - 120*Dd**2*f*g2*s**2 + 60*Dd**2*f*g2*s + 5*b2*(3*D1**2*bdd1*(2*s**2 - 2*s + 1) + D1**2*fdd*s**2 + 6*D1*Dd*bd1*(8*s**2 - 6*s + 1) + 8*D1*Dd*fd*s**2 - 2*D1*Dd*fd*s + 4*D1*Ddd*f*s**2 - 2*D1*Ddd*f*s + D1*Ddd*f + 12*Dd**2*f*s**2 - 6*Dd**2*f*s)))/(30*d**2*k2) + D1**2*Pk1*Pkd2*k2**3*st**6*(9*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-4*r*s + r + 2*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 9*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 7*r + 7*s - 2)) + D1*(D1*(2*f*fd*(r*(3*s - 1) - s) + f*(-9*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) + fd**2*(r*(2 - 6*s) + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(63*d**2*k1**2*k3**2) + D1**2*Pk1*Pkd2*k2**3*st**4*(-7*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + D1*bd1*(7*b1*(D1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) - 2*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(-D1*(f*r*(5*s + 2) - 7*f*s + fd*r*(4*s - 2) - fd*s + fd) + Dd*f*(r*(5 - 8*s) + s - 1))) + D1*f**2*(-D1*bdd1*r*(s - 1) + D1*fd*(-3*r*s + r + s) + Dd*f*(-4*r*s + r + s)) - 7*b1**2*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(5*f*(-4*r*s + r + s) + fd*(r*(2 - 16*s) + 6*s - 1)) + D1*(7*D1*bdd1*f*(-2*r*s + r + s) + D1*f*(fd*r*(7 - 10*s) - 2*fd*s + fdd*s*(1 - 2*r)) + D1*fd**2*s*(1 - 2*r) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(35*d**2*k1**2*k3**2) + D1**2*Pk1*Pkd2*k2*st**4*(D1*f*(-3*D1*bd1**2*(5*f*(4*r*s - r - 2*s + 1) + s*(14*r - 7)) + D1*bdd1*f*r*(f*(5 - 10*s) - 3*s) + bd1*(D1*(f**2*r*(2*s - 1) - 5*f*fd*(4*r*(3*s - 1) - 2*s + 1) + 6*f*r*s + 3*fd*(-4*r*s + r + s)) + Dd*f*(-5*f*(16*r*s - 6*r - 2*s + 1) - 24*r*s + 3*r + 3*s))) - 3*b1**2*(D1*Dd*(-2*f*(3*f + 7)*(r*(4*s - 1) - s) + fd*(5*f*(8*r - 1)*(4*s - 1) + 7*r*(8*s - 5) - 7*s + 7)) + D1*(D1*r*(5*fd**2*(4*s - 1) + fd*(-12*f*s + 3*f - 14*s + 14) + fdd*(20*f*s - 5*f + 7*s - 7)) + Ddd*f*(10*f + 7)*(r*(4*s - 1) - s)) + Dd**2*f*(10*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(2*f*(f + 3)*(r*(4*s - 1) - s) + fd*(-5*f*(48*r*s - 10*r - 14*s + 3) - 48*r*s + 18*r + 18*s - 6)) + 3*D1*bd1*(D1*(3*f**2*(r*(4*s - 1) - 2*s) - 5*f*fd*(4*r - 1)*(4*s - 1) + 14*f*s*(2*r - 1) + 7*fd*(r*(2 - 4*s) + s - 1)) + Dd*f*(-5*f*(8*r - 3)*(4*s - 1) + 7*r*(2 - 16*s) + 42*s - 7)) + D1*(D1*(f*fd*(r*(6*f*s - f + 12*s - 6) + s*(-2*f - 6)) + f*(15*bdd1*f*(-4*r*s + r + 2*s) + 21*bdd1*s*(1 - 2*r) + fdd*r*(f*(5 - 30*s) - 6*s + 3) + fdd*s*(10*f + 3)) + fd**2*(-5*f*(12*r*s - 2*r - 4*s + 1) - 6*r*s + 3*r + 3*s - 3)) - Ddd*f**2*(10*f + 3)*(r*(4*s - 1) - s)) - Dd**2*f**2*(10*f + 3)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1**2) + D1**2*Pk1*Pkd2*k2*st**2*(D1**2*bd1*f*r*(-bd1*(9*f + 7)*(2*s - 1) - 7*f*s) + D1*b1*(-7*D1*bd1**2*(3*f + 5)*(r*(6*s - 2) - 2*s + 1) + bd1*(D1*(-9*f*fd*(r*(8*s - 2) - 2*s + 1) - f*r*(f*(6*s - 3) + 42*s + 14) + 35*f*s + 7*fd*(-4*r*s + r + 2*s - 1)) - Dd*f*(9*f + 7)*(2*r*(8*s - 3) - 2*s + 1)) + f*(-D1*bdd1*r*(9*f + 7)*(2*s - 1) + 7*D1*fd*(-2*r*s + r + s) + 7*Dd*f*(-4*r*s + r + s))) - 7*b1**3*(D1*Dd*(r*(-4*f*s + f + 24*fd*s - 3*fd - 40*s + 10) + s*(f - 3*fd + 10)) + D1*(-D1*r*s*(fd - 3*fdd) + Ddd*(3*f + 5)*(4*r*s - r - s)) + Dd**2*(3*f + 5)*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(D1*Dd*(-3*f*(f + 7)*(r*(4*s - 1) - s) + fd*(-9*f*(16*r*s - 2*r - 6*s + 1) - 56*r*s + 7*r + 35*s - 7)) + 7*D1*bd1*(D1*(r*(3*f*s - f - 18*fd*s + 3*fd + 30*s - 10) - s*(f - 3*fd + 10)) - Dd*(3*f + 5)*(r*(24*s - 7) - 7*s + 2)) + D1*(-7*D1*bdd1*(3*f + 5)*(r*(3*s - 1) - s) + D1*(9*fd**2*s*(1 - 2*r) + fd*(r*(-s*(6*f + 21) + 35) + s*(3*f - 14)) + fdd*s*(f*(9 - 18*r) - 7*r + 7)) - Ddd*f*(9*f + 7)*(r*(4*s - 1) - s)) - Dd**2*f*(9*f + 7)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1**2) - D1**2*Pk1*Pkdd2*ct**8*k2**2*(C - 1)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(63*d**2*k3**2) + D1**2*Pk1*Pkdd2*ct**7*f*k2*(11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(18*fd*(4*s**2 - 2*s + 1) - 9*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + 2*fd*s*(bd1*(11 - 33*s) + 27*fd*(1 - 2*s))) + D1*f*(18*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(11*bd1*s + 9*fd*(4*s - 1)) - 9*Ddd*f*(4*s**2 - 2*s + 1)) + 54*Dd**2*f**2*s*(1 - 2*s)))/(198*d**2*k1) + D1**2*Pk1*Pkdd2*ct**7*k2**3*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(126*d**2*k1*k3**2) - D1**2*Pk1*Pkdd2*ct**6*k2**2*st**2*(C - 1)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k3**2) + D1**2*Pk1*Pkdd2*ct**5*f*k2*st**2*(11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(14*fd*(4*s**2 - 2*s + 1) - 7*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + 2*fd*s*(bd1*(11 - 33*s) + 21*fd*(1 - 2*s))) + D1*f*(14*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(11*bd1*s + 7*fd*(4*s - 1)) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(66*d**2*k1) + D1**2*Pk1*Pkdd2*ct**5*k2**3*st**2*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(42*d**2*k1*k3**2) - D1**2*Pk1*Pkdd2*ct**4*k2**2*st**4*(C - 1)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k3**2) + D1**2*Pk1*Pkdd2*ct**3*f*k2*st**4*(11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(10*fd*(4*s**2 - 2*s + 1) - 5*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + 2*fd*s*(bd1*(11 - 33*s) + 15*fd*(1 - 2*s))) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(11*bd1*s + 5*fd*(4*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(66*d**2*k1) + D1**2*Pk1*Pkdd2*ct**3*k2**3*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k1*k3**2) - D1**2*Pk1*Pkdd2*ct**2*k2**2*st**6*(C - 1)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(63*d**2*k3**2) + D1**2*Pk1*Pkdd2*ct*f*k2*st**6*(11*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(6*fd*(4*s**2 - 2*s + 1) - 3*fdd*(4*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + 2*fd*s*(bd1*(11 - 33*s) + 9*fd*(1 - 2*s))) + D1*f*(6*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(11*bd1*s + 3*fd*(4*s - 1)) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(198*d**2*k1) + D1**2*Pk1*Pkdd2*ct*k2**3*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(126*d**2*k1*k3**2) + D1**2*Pk1*ct**7*k2*(9*b1*(D1**2*(f*(2*fd*(8*Pk2*(r*(14*C - 14)*(2*s - 1) + 10*s**2 - 10*s + 5) + Pkdd2*k1**2*(25 - 20*C)*(2*s**2 - 2*s + 1)) - 5*fdd*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(2*s**2 - 2*s + 1)) - 10*fd**2*s*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(s - 1)) + D1*f*(2*Dd*(f*(8*Pk2*(-14*C*s + r*(14*C - 14)*(4*s - 1) + 20*s**2 + 4*s + 5) + Pkdd2*k1**2*(25 - 20*C)*(4*s**2 - 2*s + 1)) - 5*fd*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(8*s**2 - 6*s + 1)) - 5*Ddd*f*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(4*s**2 - 2*s + 1)) - 30*Dd**2*f**2*s*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(2*s - 1)) + f*(D1**2*(f*(80*Pk2*fd*(r*(26*C - 26)*(3*s - 1) + 21*s**2 + s*(12 - 26*C) + 7) - 40*Pk2*fdd*(r*(8*C - 8)*(3*s - 1) + 21*s**2 - s*(8*C + 6) + 7) - Pkdd2*fd*k1**2*(280*C - 350)*(3*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(140*C - 175)*(3*s**2 - 2*s + 1) + 9*bd1*s*(16*Pk2*(14*C*(r - 1) - 14*r + 5*s + 14) + Pkdd2*k1**2*s*(50 - 40*C)) - 45*bdd1*s**2*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))) + 10*fd*(-9*bd1*s*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(2*s - 1) + fd*(-8*Pk2*(4*C*(6*r*s - 2*r - 2*s + 1) - 24*r*s + 8*r + 21*s**2 - 6*s - 4) + Pkdd2*k1**2*s*(28*C - 35)*(3*s - 2)))) + 5*D1*f*(2*Dd*(-9*bd1*s*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(4*s - 1) + f*(8*Pk2*(-26*C*s + r*(26*C - 26)*(4*s - 1) + 28*s**2 + 12*s + 7) + Pkdd2*k1**2*(35 - 28*C)*(4*s**2 - 2*s + 1)) + fd*(-8*Pk2*(4*C*(24*r*s - 7*r - 7*s + 2) - 96*r*s + 28*r + 84*s**2 - 21*s - 1) + Pkdd2*k1**2*(28*C - 35)*(12*s**2 - 7*s + 1))) + Ddd*f*(-8*Pk2*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 28*s**2 - 6*s + 7) + Pkdd2*k1**2*(28*C - 35)*(4*s**2 - 2*s + 1))) + 10*Dd**2*f**2*(-8*Pk2*(4*C*(12*r*s - 3*r - 3*s + 1) - 48*r*s + 12*r + 42*s**2 - 9*s - 4) + Pkdd2*k1**2*s*(84*C - 105)*(2*s - 1))))/(630*d**2*k1*k3**2) + D1**2*Pk1*ct**6*(-504*Pk2*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 9*b1*(-672*C*D1**2*Pk2*f*fd*r*s + 336*C*D1**2*Pk2*f*fd*r - 824*C*D1**2*Pk2*f*fd*s**2 + 984*C*D1**2*Pk2*f*fd*s - 492*C*D1**2*Pk2*f*fd + 224*C*D1**2*Pk2*f*fdd*r*s - 112*C*D1**2*Pk2*f*fdd*r + 664*C*D1**2*Pk2*f*fdd*s**2 - 744*C*D1**2*Pk2*f*fdd*s + 372*C*D1**2*Pk2*f*fdd + 224*C*D1**2*Pk2*fd**2*r*s - 112*C*D1**2*Pk2*fd**2*r + 664*C*D1**2*Pk2*fd**2*s**2 - 744*C*D1**2*Pk2*fd**2*s + 20*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 20*C*D1**2*Pkdd2*f*fd*k1**2*s + 10*C*D1**2*Pkdd2*f*fd*k1**2 - 10*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 10*C*D1**2*Pkdd2*f*fdd*k1**2*s - 5*C*D1**2*Pkdd2*f*fdd*k1**2 - 10*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 10*C*D1**2*Pkdd2*fd**2*k1**2*s - 1344*C*D1*Dd*Pk2*f**2*r*s + 336*C*D1*Dd*Pk2*f**2*r - 1648*C*D1*Dd*Pk2*f**2*s**2 + 1160*C*D1*Dd*Pk2*f**2*s - 412*C*D1*Dd*Pk2*f**2 + 1792*C*D1*Dd*Pk2*f*fd*r*s - 672*C*D1*Dd*Pk2*f*fd*r + 5312*C*D1*Dd*Pk2*f*fd*s**2 - 4528*C*D1*Dd*Pk2*f*fd*s + 856*C*D1*Dd*Pk2*f*fd + 40*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 20*C*D1*Dd*Pkdd2*f**2*k1**2*s + 10*C*D1*Dd*Pkdd2*f**2*k1**2 - 80*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 60*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 10*C*D1*Dd*Pkdd2*f*fd*k1**2 + 448*C*D1*Ddd*Pk2*f**2*r*s - 112*C*D1*Ddd*Pk2*f**2*r + 1328*C*D1*Ddd*Pk2*f**2*s**2 - 776*C*D1*Ddd*Pk2*f**2*s + 332*C*D1*Ddd*Pk2*f**2 - 20*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 10*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 5*C*D1*Ddd*Pkdd2*f**2*k1**2 + 1344*C*Dd**2*Pk2*f**2*r*s - 336*C*Dd**2*Pk2*f**2*r + 3984*C*Dd**2*Pk2*f**2*s**2 - 2328*C*Dd**2*Pk2*f**2*s + 112*C*Dd**2*Pk2*f**2 - 60*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 30*C*Dd**2*Pkdd2*f**2*k1**2*s - 56*D1**2*Pk2*bdd1*f*(C - 1)*(2*s**2 - 2*s + 1) + 752*D1**2*Pk2*f*fd*r*s - 376*D1**2*Pk2*f*fd*r + 504*D1**2*Pk2*f*fd*s**2 - 664*D1**2*Pk2*f*fd*s + 332*D1**2*Pk2*f*fd - 264*D1**2*Pk2*f*fdd*r*s + 132*D1**2*Pk2*f*fdd*r - 504*D1**2*Pk2*f*fdd*s**2 + 584*D1**2*Pk2*f*fdd*s - 292*D1**2*Pk2*f*fdd - 264*D1**2*Pk2*fd**2*r*s + 132*D1**2*Pk2*fd**2*r - 504*D1**2*Pk2*fd**2*s**2 + 584*D1**2*Pk2*fd**2*s - 40*D1**2*Pkdd2*f*fd*k1**2*s**2 + 40*D1**2*Pkdd2*f*fd*k1**2*s - 20*D1**2*Pkdd2*f*fd*k1**2 + 20*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 20*D1**2*Pkdd2*f*fdd*k1**2*s + 10*D1**2*Pkdd2*f*fdd*k1**2 + 20*D1**2*Pkdd2*fd**2*k1**2*s**2 - 20*D1**2*Pkdd2*fd**2*k1**2*s + 1504*D1*Dd*Pk2*f**2*r*s - 376*D1*Dd*Pk2*f**2*r + 1008*D1*Dd*Pk2*f**2*s**2 - 880*D1*Dd*Pk2*f**2*s + 252*D1*Dd*Pk2*f**2 - 2112*D1*Dd*Pk2*f*fd*r*s + 792*D1*Dd*Pk2*f*fd*r - 4032*D1*Dd*Pk2*f*fd*s**2 + 3608*D1*Dd*Pk2*f*fd*s - 716*D1*Dd*Pk2*f*fd - 80*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 40*D1*Dd*Pkdd2*f**2*k1**2*s - 20*D1*Dd*Pkdd2*f**2*k1**2 + 160*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 120*D1*Dd*Pkdd2*f*fd*k1**2*s + 20*D1*Dd*Pkdd2*f*fd*k1**2 - 528*D1*Ddd*Pk2*f**2*r*s + 132*D1*Ddd*Pk2*f**2*r - 1008*D1*Ddd*Pk2*f**2*s**2 + 636*D1*Ddd*Pk2*f**2*s - 252*D1*Ddd*Pk2*f**2 + 40*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 20*D1*Ddd*Pkdd2*f**2*k1**2*s + 10*D1*Ddd*Pkdd2*f**2*k1**2 + 112*D1*Pk2*bd1*(C - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 1584*Dd**2*Pk2*f**2*r*s + 396*Dd**2*Pk2*f**2*r - 3024*Dd**2*Pk2*f**2*s**2 + 1908*Dd**2*Pk2*f**2*s - 132*Dd**2*Pk2*f**2 + 120*Dd**2*Pkdd2*f**2*k1**2*s**2 - 60*Dd**2*Pkdd2*f**2*k1**2*s) + f*(1008*D1**2*Pk2*bd1**2*s*(C - 1)*(s - 1) - 9*D1**2*bdd1*f*(4*Pk2*(C*(28*r*s + 83*s**2 - 8*s - 10) - 33*r*s - 63*s**2 + 13*s + 10) + Pkdd2*k1**2*s**2*(10 - 5*C)) + 5*D1**2*(f*(2*Pk2*fd*(10*C*(84*r*s - 28*r + 99*s**2 - 94*s + 33) - 972*r*s + 324*r - 654*s**2 + 760*s - 218) - 4*Pk2*fdd*(C*(52*r*(3*s - 1) + 369*s**2 - 298*s + 123) - 189*r*s + 63*r - 285*s**2 + 253*s - 95) + Pkdd2*fd*k1**2*(28 - 14*C)*(3*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(7*C - 14)*(3*s**2 - 2*s + 1)) + 2*fd**2*(-2*Pk2*(2*C*(52*r*(3*s - 1) + 369*s**2 - 298*s + 26) - 378*r*s + 126*r - 570*s**2 + 506*s - 63) + Pkdd2*k1**2*s*(7*C - 14)*(3*s - 2))) + 18*D1*bd1*(D1*(2*Pk2*f*(C*(103*s**2 + s*(84*r - 44) - 20) - 63*s**2 + s*(54 - 94*r) + 20) + Pk2*fd*(-4*C*(14*r*(4*s - 1) + 166*s**2 - 101*s + 14) + 66*r*(4*s - 1) + 504*s**2 - 344*s + 66) + Pkdd2*f*k1**2*s**2*(10 - 5*C) + Pkdd2*fd*k1**2*s*(5*C - 10)*(2*s - 1)) + Dd*f*(-2*Pk2*(C*(28*r*(8*s - 1) + 664*s**2 - 226*s + 8) - 264*r*s + 33*r - 504*s**2 + 211*s - 13) + Pkdd2*k1**2*s*(5*C - 10)*(4*s - 1))) + 5*D1*f*(2*Dd*(2*Pk2*f*(5*C*(28*r*(4*s - 1) + 132*s**2 - 94*s + 33) - 162*r*(4*s - 1) - 436*s**2 + 380*s - 109) + Pk2*fd*(-4*C*(26*r*(24*s - 7) + 1476*s**2 - 1043*s + 175) + 126*r*(24*s - 7) + 4560*s**2 - 3542*s + 632) + Pkdd2*f*k1**2*(14 - 7*C)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(7*C - 14)*(12*s**2 - 7*s + 1)) + Ddd*f*(-4*Pk2*(C*(52*r*(4*s - 1) + 492*s**2 - 298*s + 123) - 252*r*s + 63*r - 380*s**2 + 253*s - 95) + Pkdd2*k1**2*(7*C - 14)*(4*s**2 - 2*s + 1))) + 10*Dd**2*f**2*(-4*C*Pk2*(78*r*(4*s - 1) + 738*s**2 - 447*s + 26) + 6*Pk2*(63*r*(4*s - 1) + 380*s**2 - 253*s + 21) + Pkdd2*k1**2*s*(21*C - 42)*(2*s - 1))))/(315*d**2*k3**2) + D1**2*Pk1*ct**6*k2**2*(-612*C*D1**2*Pk2*b1*f*fd*r**2 - 72*C*D1**2*Pk2*b1*f*fdd*r**2 - 72*C*D1**2*Pk2*b1*fd**2*r**2 - 858*C*D1**2*Pk2*f**2*fd*r**2 + 572*C*D1**2*Pk2*f**2*fd*r - 286*C*D1**2*Pk2*f**2*fd - 192*C*D1**2*Pk2*f**2*fdd*r**2 + 128*C*D1**2*Pk2*f**2*fdd*r - 64*C*D1**2*Pk2*f**2*fdd - 384*C*D1**2*Pk2*f*fd**2*r**2 + 256*C*D1**2*Pk2*f*fd**2*r - 126*C*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 63*C*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 126*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 306*C*D1**2*Pkdd2*b1*f*fd*k1**2*s + 153*C*D1**2*Pkdd2*b1*f*fd*k1**2 + 90*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 45*C*D1**2*Pkdd2*b1*f*fdd*k1**2 + 90*C*D1**2*Pkdd2*b1*fd**2*k1**2*s + 345*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 230*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 115*C*D1**2*Pkdd2*f**2*fd*k1**2 - 105*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 70*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 35*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 210*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 140*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 1224*C*D1*Dd*Pk2*b1*f**2*r**2 + 612*C*D1*Dd*Pk2*b1*f**2*r - 306*C*D1*Dd*Pk2*b1*f**2 - 576*C*D1*Dd*Pk2*b1*f*fd*r**2 + 144*C*D1*Dd*Pk2*b1*f*fd*r - 1144*C*D1*Dd*Pk2*f**3*r**2 + 572*C*D1*Dd*Pk2*f**3*r - 286*C*D1*Dd*Pk2*f**3 - 1536*C*D1*Dd*Pk2*f**2*fd*r**2 + 896*C*D1*Dd*Pk2*f**2*fd*r - 128*C*D1*Dd*Pk2*f**2*fd - 504*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 252*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 126*C*D1*Dd*Pkdd2*b1**2*f*k1**2 + 504*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 126*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 252*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 126*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 63*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 360*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 90*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 460*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 230*C*D1*Dd*Pkdd2*f**3*k1**2*s + 115*C*D1*Dd*Pkdd2*f**3*k1**2 - 840*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 490*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 70*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 144*C*D1*Ddd*Pk2*b1*f**2*r**2 + 72*C*D1*Ddd*Pk2*b1*f**2*r - 36*C*D1*Ddd*Pk2*b1*f**2 - 256*C*D1*Ddd*Pk2*f**3*r**2 + 128*C*D1*Ddd*Pk2*f**3*r - 64*C*D1*Ddd*Pk2*f**3 + 252*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 126*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 63*C*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 140*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 70*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 35*C*D1*Ddd*Pkdd2*f**3*k1**2 - 432*C*Dd**2*Pk2*b1*f**2*r**2 + 216*C*Dd**2*Pk2*b1*f**2*r - 768*C*Dd**2*Pk2*f**3*r**2 + 384*C*Dd**2*Pk2*f**3*r + 756*C*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 378*C*Dd**2*Pkdd2*b1**2*f*k1**2*s - 420*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 210*C*Dd**2*Pkdd2*f**3*k1**2*s + 612*D1**2*Pk2*b1*f*fd*r**2 - 144*D1**2*Pk2*b1*f*fd*r*s + 72*D1**2*Pk2*b1*f*fd*r + 72*D1**2*Pk2*b1*f*fdd*r**2 - 180*D1**2*Pk2*b1*f*fdd*r*s + 90*D1**2*Pk2*b1*f*fdd*r + 72*D1**2*Pk2*b1*fd**2*r**2 - 180*D1**2*Pk2*b1*fd**2*r*s + 90*D1**2*Pk2*b1*fd**2*r + 858*D1**2*Pk2*f**2*fd*r**2 - 360*D1**2*Pk2*f**2*fd*r*s - 452*D1**2*Pk2*f**2*fd*r + 120*D1**2*Pk2*f**2*fd*s + 286*D1**2*Pk2*f**2*fd + 192*D1**2*Pk2*f**2*fdd*r**2 - 90*D1**2*Pk2*f**2*fdd*r*s - 98*D1**2*Pk2*f**2*fdd*r + 30*D1**2*Pk2*f**2*fdd*s + 64*D1**2*Pk2*f**2*fdd + 384*D1**2*Pk2*f*fd**2*r**2 - 180*D1**2*Pk2*f*fd**2*r*s - 196*D1**2*Pk2*f*fd**2*r + 60*D1**2*Pk2*f*fd**2*s - 30*D1**2*Pk2*f*fd**2 + 126*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 63*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 234*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 54*D1**2*Pkdd2*b1*f*fd*k1**2*s + 27*D1**2*Pkdd2*b1*f*fd*k1**2 - 180*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 90*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 45*D1**2*Pkdd2*b1*f*fdd*k1**2 - 180*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 90*D1**2*Pkdd2*b1*fd**2*k1**2*s + 126*D1**2*Pkdd2*bd1**2*f*k1**2*s*(C - 1)*(s - 1) + 75*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 50*D1**2*Pkdd2*f**2*fd*k1**2*s + 25*D1**2*Pkdd2*f**2*fd*k1**2 - 105*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 70*D1**2*Pkdd2*f**2*fdd*k1**2*s - 35*D1**2*Pkdd2*f**2*fdd*k1**2 - 210*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 140*D1**2*Pkdd2*f*fd**2*k1**2*s - 9*D1**2*bdd1*f*(2*Pk2*f*(r - 1)*(2*C*(r - 1) - 2*r + 5*s + 2) - 7*Pkdd2*b1*k1**2*(C - 1)*(2*s**2 - 2*s + 1) + 5*Pkdd2*f*k1**2*(C*(2*s - 1) + 2*s**2 - 2*s + 1)) + 1224*D1*Dd*Pk2*b1*f**2*r**2 - 288*D1*Dd*Pk2*b1*f**2*r*s - 540*D1*Dd*Pk2*b1*f**2*r + 72*D1*Dd*Pk2*b1*f**2*s + 306*D1*Dd*Pk2*b1*f**2 + 576*D1*Dd*Pk2*b1*f*fd*r**2 - 1440*D1*Dd*Pk2*b1*f*fd*r*s + 396*D1*Dd*Pk2*b1*f*fd*r + 180*D1*Dd*Pk2*b1*f*fd*s - 90*D1*Dd*Pk2*b1*f*fd + 1144*D1*Dd*Pk2*f**3*r**2 - 480*D1*Dd*Pk2*f**3*r*s - 452*D1*Dd*Pk2*f**3*r + 120*D1*Dd*Pk2*f**3*s + 286*D1*Dd*Pk2*f**3 + 1536*D1*Dd*Pk2*f**2*fd*r**2 - 720*D1*Dd*Pk2*f**2*fd*r*s - 686*D1*Dd*Pk2*f**2*fd*r + 210*D1*Dd*Pk2*f**2*fd*s + 68*D1*Dd*Pk2*f**2*fd + 504*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 252*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 126*D1*Dd*Pkdd2*b1**2*f*k1**2 - 504*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 126*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 468*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 234*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 117*D1*Dd*Pkdd2*b1*f**2*k1**2 - 1440*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 720*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 90*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 100*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 50*D1*Dd*Pkdd2*f**3*k1**2*s + 25*D1*Dd*Pkdd2*f**3*k1**2 - 840*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 490*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 70*D1*Dd*Pkdd2*f**2*fd*k1**2 + 144*D1*Ddd*Pk2*b1*f**2*r**2 - 360*D1*Ddd*Pk2*b1*f**2*r*s + 18*D1*Ddd*Pk2*b1*f**2*r + 90*D1*Ddd*Pk2*b1*f**2*s + 36*D1*Ddd*Pk2*b1*f**2 + 256*D1*Ddd*Pk2*f**3*r**2 - 120*D1*Ddd*Pk2*f**3*r*s - 98*D1*Ddd*Pk2*f**3*r + 30*D1*Ddd*Pk2*f**3*s + 64*D1*Ddd*Pk2*f**3 - 252*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 126*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 63*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 360*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 180*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 90*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 140*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 70*D1*Ddd*Pkdd2*f**3*k1**2*s - 35*D1*Ddd*Pkdd2*f**3*k1**2 - 9*D1*bd1*(D1*(-14*Pkdd2*b1*fd*k1**2*s*(C - 1)*(2*s - 1) + f**2*(2*Pk2*(r - 1)*(17*C*(r - 1) - 17*r + 4*s + 17) - Pkdd2*k1**2*(C*(7*s**2 + 20*s - 10) + 13*s**2 - 20*s + 10)) + 2*f*(Pk2*fd*(r**2*(8*C - 8) + r*(-8*C + 20*s + 3) - 10*s + 5) + 7*Pkdd2*b1*k1**2*(C - 1)*(2*s**2 - 2*s + 1) + 5*Pkdd2*fd*k1**2*s*(C + 4*s - 3))) + 2*Dd*f*(Pk2*f*(4*C*(4*r**2 - 5*r + 1) - 16*r**2 + 5*r*(8*s + 3) - 25*s + 1) - 7*Pkdd2*b1*k1**2*(C - 1)*(8*s**2 - 6*s + 1) + 5*Pkdd2*f*k1**2*(4*s - 1)*(C + 2*s - 1))) + 432*Dd**2*Pk2*b1*f**2*r**2 - 1080*Dd**2*Pk2*b1*f**2*r*s + 54*Dd**2*Pk2*b1*f**2*r + 270*Dd**2*Pk2*b1*f**2*s - 90*Dd**2*Pk2*b1*f**2 + 768*Dd**2*Pk2*f**3*r**2 - 360*Dd**2*Pk2*f**3*r*s - 294*Dd**2*Pk2*f**3*r + 90*Dd**2*Pk2*f**3*s - 30*Dd**2*Pk2*f**3 - 756*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 378*Dd**2*Pkdd2*b1**2*f*k1**2*s - 1080*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 540*Dd**2*Pkdd2*b1*f**2*k1**2*s - 420*Dd**2*Pkdd2*f**3*k1**2*s**2 + 210*Dd**2*Pkdd2*f**3*k1**2*s)/(315*d**2*k1**2*k3**2) - D1**2*Pk1*ct**6*(-495*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 2200*D1**2*Pk2*bdd1*f**3*r*s - 2200*D1**2*Pk2*bdd1*f**3*s + 5600*D1**2*Pk2*f**3*fd*r*s - 1400*D1**2*Pk2*f**3*fd*r - 1400*D1**2*Pk2*f**3*fd*s + 3360*D1**2*Pk2*f**3*fdd*r*s - 840*D1**2*Pk2*f**3*fdd*r - 840*D1**2*Pk2*f**3*fdd*s + 10080*D1**2*Pk2*f**2*fd**2*r*s - 2520*D1**2*Pk2*f**2*fd**2*r - 2520*D1**2*Pk2*f**2*fd**2*s + 840*D1**2*Pk2*f**2*fd**2 + 198*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(-7*K + 5*f + 7) + 1155*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 495*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 1386*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 5040*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 2520*D1**2*Pkdd2*f**3*fd*k1**2*s - 1260*D1**2*Pkdd2*f**3*fd*k1**2 + 2520*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 1260*D1**2*Pkdd2*f**3*fdd*k1**2*s + 630*D1**2*Pkdd2*f**3*fdd*k1**2 + 7560*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 3780*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 1980*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 990*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 3960*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 3960*D1**2*Pkdd2*f*fd*g2*k1**2*s - 1980*D1**2*Pkdd2*f*fd*g2*k1**2 + 3960*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 1980*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 1980*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 1980*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 990*D1**2*Pkdd2*f*fdd*g2*k1**2 + 1980*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 1980*D1**2*Pkdd2*fd**2*g2*k1**2*s + 5600*D1*Dd*Pk2*f**4*r*s - 1400*D1*Dd*Pk2*f**4*r - 1400*D1*Dd*Pk2*f**4*s + 26880*D1*Dd*Pk2*f**3*fd*r*s - 6720*D1*Dd*Pk2*f**3*fd*r - 6720*D1*Dd*Pk2*f**3*fd*s + 1680*D1*Dd*Pk2*f**3*fd - 5040*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 2520*D1*Dd*Pkdd2*f**4*k1**2*s - 1260*D1*Dd*Pkdd2*f**4*k1**2 + 20160*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 10080*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 1260*D1*Dd*Pkdd2*f**3*fd*k1**2 - 7920*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 3960*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 1980*D1*Dd*Pkdd2*f**2*g2*k1**2 + 7920*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 1980*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 15840*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 11880*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 1980*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 3360*D1*Ddd*Pk2*f**4*r*s - 840*D1*Ddd*Pk2*f**4*r - 840*D1*Ddd*Pk2*f**4*s + 2520*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 1260*D1*Ddd*Pkdd2*f**4*k1**2*s + 630*D1*Ddd*Pkdd2*f**4*k1**2 + 3960*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 1980*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 990*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 22*D1*bd1*(D1*(-9*Pkdd2*f*k1**2*s*(5*fd*(2*s - 1)*(-K + 2*b1 + 1) + s*(14*b1*(K - 1) - 14*g2 + 14*gd2)) - 126*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) + 5*f**3*s*(4*Pk2*(r - 1) + 21*Pkdd2*k1**2*s) - 5*f**2*(20*Pk2*fd*(r*(6*s - 1) - 3*s + 1) + 21*Pkdd2*fd*k1**2*s*(3*s - 1) + Pkdd2*k1**2*s**2*(9*K - 18*b1 - 9))) + Dd*f*(-45*Pkdd2*f*k1**2*s*(4*s - 1)*(-K + 2*b1 + 1) - Pkdd2*k1**2*s*(4*s - 1)*(-126*K*b1 + 126*b1 + 126*g2) - 5*f**2*(20*Pk2*(r*(8*s - 1) - 5*s + 1) + 21*Pkdd2*k1**2*s*(4*s - 1)))) + 10080*Dd**2*Pk2*f**4*r*s - 2520*Dd**2*Pk2*f**4*r - 2520*Dd**2*Pk2*f**4*s + 840*Dd**2*Pk2*f**4 + 7560*Dd**2*Pkdd2*f**4*k1**2*s**2 - 3780*Dd**2*Pkdd2*f**4*k1**2*s + 11880*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 5940*Dd**2*Pkdd2*f**2*g2*k1**2*s - 99*Pkdd2*b1**2*k1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) - 14*fd*(K - 1)*(s - 1)**2 + 7*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) - 7*f*(K - 1)*(4*s**2 - 2*s + 1) + 7*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-7*K + 5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-7*K + 5*f + 7)) + 11*b1*(-2*D1*Dd*(9*Pkdd2*f*k1**2*(5*fd*(K - 1)*(8*s**2 - 6*s + 1) + 14*g2*(4*s**2 - 2*s + 1) + 14*gd2*s*(1 - 4*s)) - 126*Pkdd2*fd*g2*k1**2*(4*s**2 - 5*s + 1) + 5*f**3*(4*Pk2*r*(4*s - 1) - 4*Pk2*s + 21*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 5*f**2*(20*Pk2*fd*(r*(24*s - 7) - 3*s + 1) + 21*Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1) + Pkdd2*k1**2*(9*K - 9)*(4*s**2 - 2*s + 1))) + D1*(D1*(-18*Pkdd2*k1**2*(s - 1)*(5*fd**2*s*(K - 1) + 14*fd*(g2*(s - 1) - gd2*s) - 7*fdd*g2*(s - 1)) - 5*f**2*(8*Pk2*fd*r*(3*s - 1) + 40*Pk2*fdd*r*(1 - 3*s) - 18*Pkdd2*bdd1*k1**2*s**2 + 42*Pkdd2*fd*k1**2*(3*s**2 - 2*s + 1) - 21*Pkdd2*fdd*k1**2*(3*s**2 - 2*s + 1)) + f*(90*Pkdd2*fd*k1**2*(K - 1)*(2*s**2 - 2*s + 1) - 9*Pkdd2*k1**2*(5*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(14*bdd1*(K - 1) + 28*gd2 - 14*gdd2)) + 10*fd**2*(40*Pk2*r*(3*s - 1) + 21*Pkdd2*k1**2*s*(3*s - 2)))) + Ddd*f*(-45*Pkdd2*f*k1**2*(K - 1)*(4*s**2 - 2*s + 1) + 126*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 5*f**2*(40*Pk2*(4*r*s - r - s) + 21*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 2*Dd**2*f*(-135*Pkdd2*f*k1**2*s*(K - 1)*(2*s - 1) + 378*Pkdd2*g2*k1**2*s*(2*s - 1) + 5*f**2*(20*Pk2*(12*r*s - 3*r - 3*s + 1) + 63*Pkdd2*k1**2*s*(2*s - 1)))))/(6930*d**2*k1**2) + D1**2*Pk1*ct**5*k1*(-504*Pk2*b1**2*(4*C - 5)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 9*b1*(-896*C*D1**2*Pk2*f*fd*r*s + 448*C*D1**2*Pk2*f*fd*r - 2848*C*D1**2*Pk2*f*fd*s**2 + 3488*C*D1**2*Pk2*f*fd*s - 1744*C*D1**2*Pk2*f*fd + 448*C*D1**2*Pk2*f*fdd*r*s - 224*C*D1**2*Pk2*f*fdd*r + 2208*C*D1**2*Pk2*f*fdd*s**2 - 2528*C*D1**2*Pk2*f*fdd*s + 1264*C*D1**2*Pk2*f*fdd + 448*C*D1**2*Pk2*fd**2*r*s - 224*C*D1**2*Pk2*fd**2*r + 2208*C*D1**2*Pk2*fd**2*s**2 - 2528*C*D1**2*Pk2*fd**2*s - 1792*C*D1*Dd*Pk2*f**2*r*s + 448*C*D1*Dd*Pk2*f**2*r - 5696*C*D1*Dd*Pk2*f**2*s**2 + 3296*C*D1*Dd*Pk2*f**2*s - 1424*C*D1*Dd*Pk2*f**2 + 3584*C*D1*Dd*Pk2*f*fd*r*s - 1344*C*D1*Dd*Pk2*f*fd*r + 17664*C*D1*Dd*Pk2*f*fd*s**2 - 14976*C*D1*Dd*Pk2*f*fd*s + 2752*C*D1*Dd*Pk2*f*fd + 896*C*D1*Ddd*Pk2*f**2*r*s - 224*C*D1*Ddd*Pk2*f**2*r + 4416*C*D1*Ddd*Pk2*f**2*s**2 - 2432*C*D1*Ddd*Pk2*f**2*s + 1104*C*D1*Ddd*Pk2*f**2 + 2688*C*Dd**2*Pk2*f**2*r*s - 672*C*Dd**2*Pk2*f**2*r + 13248*C*Dd**2*Pk2*f**2*s**2 - 7296*C*Dd**2*Pk2*f**2*s + 224*C*Dd**2*Pk2*f**2 - 56*D1**2*Pk2*bdd1*f*(4*C - 5)*(2*s**2 - 2*s + 1) + 1440*D1**2*Pk2*f*fd*r*s - 720*D1**2*Pk2*f*fd*r + 2664*D1**2*Pk2*f*fd*s**2 - 3464*D1**2*Pk2*f*fd*s + 1732*D1**2*Pk2*f*fd - 832*D1**2*Pk2*f*fdd*r*s + 416*D1**2*Pk2*f*fdd*r - 2312*D1**2*Pk2*f*fdd*s**2 + 2712*D1**2*Pk2*f*fdd*s - 1356*D1**2*Pk2*f*fdd - 832*D1**2*Pk2*fd**2*r*s + 416*D1**2*Pk2*fd**2*r - 2312*D1**2*Pk2*fd**2*s**2 + 2712*D1**2*Pk2*fd**2*s - 20*D1**2*Pkdd2*f*fd*k1**2*s**2 + 20*D1**2*Pkdd2*f*fd*k1**2*s - 10*D1**2*Pkdd2*f*fd*k1**2 + 10*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 10*D1**2*Pkdd2*f*fdd*k1**2*s + 5*D1**2*Pkdd2*f*fdd*k1**2 + 10*D1**2*Pkdd2*fd**2*k1**2*s**2 - 10*D1**2*Pkdd2*fd**2*k1**2*s + 2880*D1*Dd*Pk2*f**2*r*s - 720*D1*Dd*Pk2*f**2*r + 5328*D1*Dd*Pk2*f**2*s**2 - 3384*D1*Dd*Pk2*f**2*s + 1332*D1*Dd*Pk2*f**2 - 6656*D1*Dd*Pk2*f*fd*r*s + 2496*D1*Dd*Pk2*f*fd*r - 18496*D1*Dd*Pk2*f*fd*s**2 + 16304*D1*Dd*Pk2*f*fd*s - 3128*D1*Dd*Pk2*f*fd - 40*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 20*D1*Dd*Pkdd2*f**2*k1**2*s - 10*D1*Dd*Pkdd2*f**2*k1**2 + 80*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 60*D1*Dd*Pkdd2*f*fd*k1**2*s + 10*D1*Dd*Pkdd2*f*fd*k1**2 - 1664*D1*Ddd*Pk2*f**2*r*s + 416*D1*Ddd*Pk2*f**2*r - 4624*D1*Ddd*Pk2*f**2*s**2 + 2728*D1*Ddd*Pk2*f**2*s - 1156*D1*Ddd*Pk2*f**2 + 20*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 10*D1*Ddd*Pkdd2*f**2*k1**2*s + 5*D1*Ddd*Pkdd2*f**2*k1**2 + 112*D1*Pk2*bd1*(4*C - 5)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 4992*Dd**2*Pk2*f**2*r*s + 1248*Dd**2*Pk2*f**2*r - 13872*Dd**2*Pk2*f**2*s**2 + 8184*Dd**2*Pk2*f**2*s - 416*Dd**2*Pk2*f**2 + 60*Dd**2*Pkdd2*f**2*k1**2*s**2 - 30*Dd**2*Pkdd2*f**2*k1**2*s) + f*(1008*D1**2*Pk2*bd1**2*s*(4*C - 5)*(s - 1) - 9*D1**2*bdd1*f*(4*Pk2*(4*C*(14*r*s + 69*s**2 + 6*s - 10) - 104*r*s - 289*s**2 + 4*s + 50) + 5*Pkdd2*k1**2*s**2) + 5*D1**2*(f*(2*fd*(8*C*Pk2*(44*r*(3*s - 1) + 441*s**2 - 338*s + 147) - 50*Pk2*(12*r*(3*s - 1) + 69*s**2 - 58*s + 23) + 7*Pkdd2*k1**2*(3*s**2 - 2*s + 1)) + fdd*(-4*Pk2*(4*C*(66*r*s - 22*r + 315*s**2 - 232*s + 105) - 504*r*s + 168*r - 1335*s**2 + 1058*s - 445) - 7*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + 2*fd**2*(-4*Pk2*(4*C*(66*r*s - 22*r + 315*s**2 - 232*s + 11) - 504*r*s + 168*r - 1335*s**2 + 1058*s - 84) + 7*Pkdd2*k1**2*s*(2 - 3*s))) + 18*D1*bd1*(D1*(2*Pk2*f*(4*C*(89*s**2 + s*(28*r + 12) - 20) - 333*s**2 - s*(180*r + 20) + 100) - 4*Pk2*fd*(4*C*(7*r*(4*s - 1) + 138*s**2 - 73*s + 7) - 52*r*(4*s - 1) - 578*s**2 + 343*s - 52) + 5*Pkdd2*f*k1**2*s**2 + 5*Pkdd2*fd*k1**2*s*(1 - 2*s)) + Dd*f*(-4*Pk2*(4*C*(56*r*s - 7*r + 276*s**2 - 64*s - 3) - 416*r*s + 52*r - 1156*s**2 + 349*s - 2) + 5*Pkdd2*k1**2*s*(1 - 4*s))) + 5*D1*f*(2*Dd*(8*C*Pk2*f*(44*r*(4*s - 1) + 588*s**2 - 338*s + 147) - 50*Pk2*f*(12*r*(4*s - 1) + 92*s**2 - 58*s + 23) - 4*Pk2*fd*(4*C*(11*r*(24*s - 7) + 1260*s**2 - 812*s + 127) - 84*r*(24*s - 7) - 5340*s**2 + 3703*s - 613) + 7*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) - 7*Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1)) + Ddd*f*(-4*Pk2*(4*C*(88*r*s - 22*r + 420*s**2 - 232*s + 105) - 672*r*s + 168*r - 1780*s**2 + 1058*s - 445) - 7*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 10*Dd**2*f**2*(-16*C*Pk2*(33*r*(4*s - 1) + 630*s**2 - 348*s + 11) + 12*Pk2*(84*r*(4*s - 1) + 890*s**2 - 529*s + 28) + 21*Pkdd2*k1**2*s*(1 - 2*s))))/(630*d**2*k2*k3**2) + D1**2*Pk1*ct**5*k2*st**2*(9*b1*(D1**2*(f*(48*Pk2*fd*(r*(16*C - 16)*(2*s - 1) + 10*s**2 - 10*s + 5) - 40*Pk2*fdd*(r*(4*C - 4)*(2*s - 1) + 6*s**2 - 6*s + 3) + Pkdd2*fd*k1**2*(110 - 80*C)*(2*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(40*C - 55)*(2*s**2 - 2*s + 1)) + 10*fd**2*(-8*Pk2*(r*(2*C - 2)*(2*s - 1) + s*(3*s - 3)) + Pkdd2*k1**2*s*(8*C - 11)*(s - 1))) + D1*f*(2*Dd*(24*Pk2*f*(r*(16*C - 16)*(4*s - 1) + 20*s**2 + s*(6 - 16*C) + 5) - 40*Pk2*fd*(2*C*(2*r*(8*s - 3) - 2*s + 1) - 4*r*(8*s - 3) + 24*s**2 - 14*s + 1) + Pkdd2*f*k1**2*(55 - 40*C)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(40*C - 55)*(8*s**2 - 6*s + 1)) + 5*Ddd*f*(-8*Pk2*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 12*s**2 - 2*s + 3) + Pkdd2*k1**2*(8*C - 11)*(4*s**2 - 2*s + 1))) + 10*Dd**2*f**2*(-8*Pk2*(C*(24*r*s - 6*r - 6*s + 2) - 24*r*s + 6*r + 18*s**2 - 3*s - 2) + Pkdd2*k1**2*s*(24*C - 33)*(2*s - 1))) + f*(D1**2*(f*(16*Pk2*fd*(r*(296*C - 296)*(3*s - 1) + 225*s**2 + s*(146 - 296*C) + 75) + Pkdd2*fd*k1**2*(550 - 400*C)*(3*s**2 - 2*s + 1) - 45*bdd1*s*(8*Pk2*(4*C*(r - 1) - 4*r + 3*s + 4) + Pkdd2*k1**2*s*(11 - 8*C)) - 5*fdd*(8*Pk2*(-52*C*s + r*(52*C - 52)*(3*s - 1) + 45*s**2 + 22*s + 15) + Pkdd2*k1**2*(55 - 40*C)*(3*s**2 - 2*s + 1))) - 10*fd**2*(8*Pk2*(26*C*(6*r*s - 2*r - 2*s + 1) - 156*r*s + 52*r + 45*s**2 + 22*s - 26) + Pkdd2*k1**2*s*(55 - 40*C)*(3*s - 2))) + 18*D1*bd1*(D1*f*s*(24*Pk2*(16*C*(r - 1) - 16*r + 5*s + 16) + Pkdd2*k1**2*s*(55 - 40*C)) + 5*D1*fd*(-8*Pk2*(C*(8*r*s - 2*r - 4*s + 2) - 8*r*s + 2*r + 6*s**2 + s - 2) + Pkdd2*k1**2*s*(8*C - 11)*(2*s - 1)) - 40*Dd*Pk2*f*(2*C*(r*(8*s - 1) - 5*s + 1) + r*(2 - 16*s) + 12*s**2 + 7*s - 2) + Dd*Pkdd2*f*k1**2*s*(40*C - 55)*(4*s - 1)) + D1*f*(2*Dd*(8*Pk2*f*(r*(296*C - 296)*(4*s - 1) + 300*s**2 + s*(146 - 296*C) + 75) - 40*Pk2*fd*(26*C*(r*(24*s - 7) - 7*s + 2) - 26*r*(24*s - 7) + 180*s**2 + 77*s - 37) + Pkdd2*f*k1**2*(275 - 200*C)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(200*C - 275)*(12*s**2 - 7*s + 1)) - 5*Ddd*f*(8*Pk2*(-52*C*s + r*(52*C - 52)*(4*s - 1) + 60*s**2 + 22*s + 15) + Pkdd2*k1**2*(55 - 40*C)*(4*s**2 - 2*s + 1))) - 10*Dd**2*f**2*(8*Pk2*(26*C*(12*r*s - 3*r - 3*s + 1) - 312*r*s + 78*r + 90*s**2 + 33*s - 26) + Pkdd2*k1**2*s*(165 - 120*C)*(2*s - 1))))/(630*d**2*k1*k3**2) - D1**2*Pk1*ct**5*k2*(-1680*C*D1**2*Pk2*b1**2*fd*r*s + 2448*C*D1**2*Pk2*b1*f*fd*r**2 - 576*C*D1**2*Pk2*b1*f*fd*r*s - 1296*C*D1**2*Pk2*b1*f*fd*r + 1584*C*D1**2*Pk2*b1*f*fd*s + 288*C*D1**2*Pk2*b1*f*fdd*r**2 + 288*C*D1**2*Pk2*b1*f*fdd*r*s + 144*C*D1**2*Pk2*b1*f*fdd*r - 288*C*D1**2*Pk2*b1*f*fdd*s + 288*C*D1**2*Pk2*b1*fd**2*r**2 + 288*C*D1**2*Pk2*b1*fd**2*r*s + 144*C*D1**2*Pk2*b1*fd**2*r - 288*C*D1**2*Pk2*b1*fd**2*s + 4296*C*D1**2*Pk2*f**2*fd*r**2 + 6288*C*D1**2*Pk2*f**2*fd*r*s - 4960*C*D1**2*Pk2*f**2*fd*r - 2096*C*D1**2*Pk2*f**2*fd*s + 1432*C*D1**2*Pk2*f**2*fd - 96*C*D1**2*Pk2*f**2*fdd*r**2 - 2928*C*D1**2*Pk2*f**2*fdd*r*s + 1040*C*D1**2*Pk2*f**2*fdd*r + 976*C*D1**2*Pk2*f**2*fdd*s - 32*C*D1**2*Pk2*f**2*fdd - 192*C*D1**2*Pk2*f*fd**2*r**2 - 5856*C*D1**2*Pk2*f*fd**2*r*s + 2080*C*D1**2*Pk2*f*fd**2*r + 1952*C*D1**2*Pk2*f*fd**2*s - 976*C*D1**2*Pk2*f*fd**2 + 504*C*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 252*C*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 504*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 1224*C*D1**2*Pkdd2*b1*f*fd*k1**2*s - 612*C*D1**2*Pkdd2*b1*f*fd*k1**2 - 360*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 180*C*D1**2*Pkdd2*b1*f*fdd*k1**2 - 360*C*D1**2*Pkdd2*b1*fd**2*k1**2*s - 1380*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 920*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 460*C*D1**2*Pkdd2*f**2*fd*k1**2 + 420*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 280*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 140*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 840*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 560*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 6720*C*D1*Dd*Pk2*b1**2*f*r*s + 1680*C*D1*Dd*Pk2*b1**2*f*r + 1680*C*D1*Dd*Pk2*b1**2*f*s + 4896*C*D1*Dd*Pk2*b1*f**2*r**2 - 1152*C*D1*Dd*Pk2*b1*f**2*r*s - 2160*C*D1*Dd*Pk2*b1*f**2*r + 288*C*D1*Dd*Pk2*b1*f**2*s + 1224*C*D1*Dd*Pk2*b1*f**2 + 2304*C*D1*Dd*Pk2*b1*f*fd*r**2 + 2304*C*D1*Dd*Pk2*b1*f*fd*r*s - 288*C*D1*Dd*Pk2*b1*f*fd*r - 1440*C*D1*Dd*Pk2*b1*f*fd*s + 144*C*D1*Dd*Pk2*b1*f*fd + 5728*C*D1*Dd*Pk2*f**3*r**2 + 8384*C*D1*Dd*Pk2*f**3*r*s - 4960*C*D1*Dd*Pk2*f**3*r - 2096*C*D1*Dd*Pk2*f**3*s + 1432*C*D1*Dd*Pk2*f**3 - 768*C*D1*Dd*Pk2*f**2*fd*r**2 - 23424*C*D1*Dd*Pk2*f**2*fd*r*s + 7280*C*D1*Dd*Pk2*f**2*fd*r + 6832*C*D1*Dd*Pk2*f**2*fd*s - 2016*C*D1*Dd*Pk2*f**2*fd + 2016*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 1008*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 504*C*D1*Dd*Pkdd2*b1**2*f*k1**2 - 2016*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 504*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 1008*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 504*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 252*C*D1*Dd*Pkdd2*b1*f**2*k1**2 - 1440*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 360*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 - 1840*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 920*C*D1*Dd*Pkdd2*f**3*k1**2*s - 460*C*D1*Dd*Pkdd2*f**3*k1**2 + 3360*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 1960*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 280*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 576*C*D1*Ddd*Pk2*b1*f**2*r**2 + 576*C*D1*Ddd*Pk2*b1*f**2*r*s - 432*C*D1*Ddd*Pk2*b1*f**2*r - 144*C*D1*Ddd*Pk2*b1*f**2*s + 144*C*D1*Ddd*Pk2*b1*f**2 - 128*C*D1*Ddd*Pk2*f**3*r**2 - 3904*C*D1*Ddd*Pk2*f**3*r*s + 1040*C*D1*Ddd*Pk2*f**3*r + 976*C*D1*Ddd*Pk2*f**3*s - 32*C*D1*Ddd*Pk2*f**3 - 1008*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 504*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 252*C*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 560*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 280*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 140*C*D1*Ddd*Pkdd2*f**3*k1**2 + 1728*C*Dd**2*Pk2*b1*f**2*r**2 + 1728*C*Dd**2*Pk2*b1*f**2*r*s - 1296*C*Dd**2*Pk2*b1*f**2*r - 432*C*Dd**2*Pk2*b1*f**2*s + 144*C*Dd**2*Pk2*b1*f**2 - 384*C*Dd**2*Pk2*f**3*r**2 - 11712*C*Dd**2*Pk2*f**3*r*s + 3120*C*Dd**2*Pk2*f**3*r + 2928*C*Dd**2*Pk2*f**3*s - 976*C*Dd**2*Pk2*f**3 - 3024*C*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 1512*C*Dd**2*Pkdd2*b1**2*f*k1**2*s + 1680*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 840*C*Dd**2*Pkdd2*f**3*k1**2*s + 1680*D1**2*Pk2*b1**2*fd*r*s - 2448*D1**2*Pk2*b1*f*fd*r**2 + 2160*D1**2*Pk2*b1*f*fd*r*s + 504*D1**2*Pk2*b1*f*fd*r + 2988*D1**2*Pk2*b1*f*fd*s**2 - 4572*D1**2*Pk2*b1*f*fd*s + 1494*D1**2*Pk2*b1*f*fd - 288*D1**2*Pk2*b1*f*fdd*r**2 - 576*D1**2*Pk2*b1*f*fdd*r*s - 2628*D1**2*Pk2*b1*f*fdd*s**2 + 2916*D1**2*Pk2*b1*f*fdd*s - 1314*D1**2*Pk2*b1*f*fdd - 288*D1**2*Pk2*b1*fd**2*r**2 - 576*D1**2*Pk2*b1*fd**2*r*s - 2628*D1**2*Pk2*b1*fd**2*s**2 + 2916*D1**2*Pk2*b1*fd**2*s - 4704*D1**2*Pk2*f**2*fd*r**2 - 2808*D1**2*Pk2*f**2*fd*r*s + 4072*D1**2*Pk2*f**2*fd*r + 3270*D1**2*Pk2*f**2*fd*s**2 - 1244*D1**2*Pk2*f**2*fd*s - 478*D1**2*Pk2*f**2*fd + 84*D1**2*Pk2*f**2*fdd*r**2 + 1728*D1**2*Pk2*f**2*fdd*r*s - 632*D1**2*Pk2*f**2*fdd*r - 2850*D1**2*Pk2*f**2*fdd*s**2 + 1324*D1**2*Pk2*f**2*fdd*s - 922*D1**2*Pk2*f**2*fdd + 168*D1**2*Pk2*f*fd**2*r**2 + 3456*D1**2*Pk2*f*fd**2*r*s - 1264*D1**2*Pk2*f*fd**2*r - 5700*D1**2*Pk2*f*fd**2*s**2 + 2648*D1**2*Pk2*f*fd**2*s + 576*D1**2*Pk2*f*fd**2 - 630*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 315*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 450*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 450*D1**2*Pkdd2*b1*f*fd*k1**2*s + 225*D1**2*Pkdd2*b1*f*fd*k1**2 + 540*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 90*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 45*D1**2*Pkdd2*b1*f*fdd*k1**2 + 540*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 90*D1**2*Pkdd2*b1*fd**2*k1**2*s - 126*D1**2*Pkdd2*bd1**2*f*k1**2*s*(4*C - 5)*(s - 1) + 465*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 310*D1**2*Pkdd2*f**2*fd*k1**2*s + 155*D1**2*Pkdd2*f**2*fd*k1**2 + 105*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 70*D1**2*Pkdd2*f**2*fdd*k1**2*s + 35*D1**2*Pkdd2*f**2*fdd*k1**2 + 210*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 140*D1**2*Pkdd2*f*fd**2*k1**2*s + 9*D1**2*bdd1*f*(2*Pk2*f*(8*C*(r**2 + r*(s - 4) + s + 1) - 8*r**2 - 16*r*(s - 2) - 73*s**2 - 8) - 7*Pkdd2*b1*k1**2*(4*C - 5)*(2*s**2 - 2*s + 1) + 5*Pkdd2*f*k1**2*(C*(8*s - 4) + 6*s**2 - 10*s + 5)) + 6720*D1*Dd*Pk2*b1**2*f*r*s - 1680*D1*Dd*Pk2*b1**2*f*r - 1680*D1*Dd*Pk2*b1**2*f*s - 4896*D1*Dd*Pk2*b1*f**2*r**2 + 4320*D1*Dd*Pk2*b1*f**2*r*s + 1368*D1*Dd*Pk2*b1*f**2*r + 5976*D1*Dd*Pk2*b1*f**2*s**2 - 4068*D1*Dd*Pk2*b1*f**2*s + 270*D1*Dd*Pk2*b1*f**2 - 2304*D1*Dd*Pk2*b1*f*fd*r**2 - 4608*D1*Dd*Pk2*b1*f*fd*r*s + 1152*D1*Dd*Pk2*b1*f*fd*r - 21024*D1*Dd*Pk2*b1*f*fd*s**2 + 17496*D1*Dd*Pk2*b1*f*fd*s - 2916*D1*Dd*Pk2*b1*f*fd - 6272*D1*Dd*Pk2*f**3*r**2 - 3744*D1*Dd*Pk2*f**3*r*s + 4072*D1*Dd*Pk2*f**3*r + 4360*D1*Dd*Pk2*f**3*s**2 - 1244*D1*Dd*Pk2*f**3*s - 478*D1*Dd*Pk2*f**3 + 672*D1*Dd*Pk2*f**2*fd*r**2 + 13824*D1*Dd*Pk2*f**2*fd*r*s - 4424*D1*Dd*Pk2*f**2*fd*r - 22800*D1*Dd*Pk2*f**2*fd*s**2 + 9268*D1*Dd*Pk2*f**2*fd*s - 692*D1*Dd*Pk2*f**2*fd - 2520*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 1260*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 630*D1*Dd*Pkdd2*b1**2*f*k1**2 + 2520*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 630*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 900*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 450*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 225*D1*Dd*Pkdd2*b1*f**2*k1**2 + 4320*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 1440*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 90*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 620*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 310*D1*Dd*Pkdd2*f**3*k1**2*s + 155*D1*Dd*Pkdd2*f**3*k1**2 + 840*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 490*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 70*D1*Dd*Pkdd2*f**2*fd*k1**2 - 576*D1*Ddd*Pk2*b1*f**2*r**2 - 1152*D1*Ddd*Pk2*b1*f**2*r*s + 576*D1*Ddd*Pk2*b1*f**2*r - 5256*D1*Ddd*Pk2*b1*f**2*s**2 + 2916*D1*Ddd*Pk2*b1*f**2*s - 1458*D1*Ddd*Pk2*b1*f**2 + 112*D1*Ddd*Pk2*f**3*r**2 + 2304*D1*Ddd*Pk2*f**3*r*s - 632*D1*Ddd*Pk2*f**3*r - 3800*D1*Ddd*Pk2*f**3*s**2 + 1324*D1*Ddd*Pk2*f**3*s - 922*D1*Ddd*Pk2*f**3 + 1260*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 630*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 315*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 1080*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 540*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 270*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 140*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 70*D1*Ddd*Pkdd2*f**3*k1**2*s + 35*D1*Ddd*Pkdd2*f**3*k1**2 + 3*D1*bd1*(D1*(-42*Pkdd2*b1*fd*k1**2*s*(4*C - 5)*(2*s - 1) + 3*f**2*(2*Pk2*(4*C*(17*r**2 - 4*r*(s + 3) - 18*s + 17) - 68*r**2 + 60*r*s + 48*r + 83*s**2 + 28*s - 68) - Pkdd2*k1**2*(4*C*(7*s**2 + 20*s - 10) + 25*s**2 - 100*s + 50)) + 2*f*(-280*Pk2*b1*(C - 1)*(r*(2*s - 1) - s) + 6*Pk2*fd*(4*C*(4*r**2 + r*(4*s - 7) + 1) - 16*r**2 - 32*r*(s - 1) - 146*s**2 + 81*s - 8) + 21*Pkdd2*b1*k1**2*(4*C - 5)*(2*s**2 - 2*s + 1) + 15*Pkdd2*fd*k1**2*s*(4*C + 12*s - 11))) + 6*Dd*f*(2*Pk2*f*(4*C*(8*r**2 + 8*r*s - 19*r + 3*s + 3) - 32*r**2 + r*(80 - 64*s) - 292*s**2 + 81*s - 16) - 7*Pkdd2*b1*k1**2*(4*C - 5)*(8*s**2 - 6*s + 1) + 5*Pkdd2*f*k1**2*(4*s - 1)*(4*C + 6*s - 5))) - 1728*Dd**2*Pk2*b1*f**2*r**2 - 3456*Dd**2*Pk2*b1*f**2*r*s + 1728*Dd**2*Pk2*b1*f**2*r - 15768*Dd**2*Pk2*b1*f**2*s**2 + 8748*Dd**2*Pk2*b1*f**2*s - 288*Dd**2*Pk2*b1*f**2 + 336*Dd**2*Pk2*f**3*r**2 + 6912*Dd**2*Pk2*f**3*r*s - 1896*Dd**2*Pk2*f**3*r - 11400*Dd**2*Pk2*f**3*s**2 + 3972*Dd**2*Pk2*f**3*s + 576*Dd**2*Pk2*f**3 + 3780*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 1890*Dd**2*Pkdd2*b1**2*f*k1**2*s + 3240*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 1620*Dd**2*Pkdd2*b1*f**2*k1**2*s + 420*Dd**2*Pkdd2*f**3*k1**2*s**2 - 210*Dd**2*Pkdd2*f**3*k1**2*s)/(630*d**2*k1*k3**2) + D1**2*Pk1*ct**5*(-3168*D1**2*K*Pk2*bdd1*f**2*r*s + 5280*D1**2*Pk2*bdd1*f**3*r*s + 15620*D1**2*Pk2*bdd1*f**3*s**2 + 2640*D1**2*Pk2*bdd1*f**3*s - 3080*D1**2*Pk2*bdd1*f**3 + 3168*D1**2*Pk2*bdd1*f**2*r*s - 3960*D1**2*Pk2*bdd1*f**2*s**2 - 35840*D1**2*Pk2*f**3*fd*r*s + 8960*D1**2*Pk2*f**3*fd*r - 92400*D1**2*Pk2*f**3*fd*s**2 + 55160*D1**2*Pk2*f**3*fd*s - 23100*D1**2*Pk2*f**3*fd + 17920*D1**2*Pk2*f**3*fdd*r*s - 4480*D1**2*Pk2*f**3*fdd*r + 67760*D1**2*Pk2*f**3*fdd*s**2 - 38360*D1**2*Pk2*f**3*fdd*s + 16940*D1**2*Pk2*f**3*fdd + 53760*D1**2*Pk2*f**2*fd**2*r*s - 13440*D1**2*Pk2*f**2*fd**2*r + 203280*D1**2*Pk2*f**2*fd**2*s**2 - 115080*D1**2*Pk2*f**2*fd**2*s + 4480*D1**2*Pk2*f**2*fd**2 - 34848*D1**2*Pk2*f**2*gd2*r*s + 6336*D1**2*Pk2*f**2*gdd2*r*s - 69696*D1**2*Pk2*f*fd*g2*r*s + 34848*D1**2*Pk2*f*fd*g2*r + 34848*D1**2*Pk2*f*fd*g2*s + 25344*D1**2*Pk2*f*fd*gd2*r*s - 6336*D1**2*Pk2*f*fd*gd2*r - 6336*D1**2*Pk2*f*fd*gd2*s + 12672*D1**2*Pk2*f*fdd*g2*r*s - 6336*D1**2*Pk2*f*fdd*g2*r - 6336*D1**2*Pk2*f*fdd*g2*s + 12672*D1**2*Pk2*fd**2*g2*r*s - 6336*D1**2*Pk2*fd**2*g2*r - 6336*D1**2*Pk2*fd**2*g2*s + 6336*D1**2*Pk2*fd**2*g2 - 770*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 495*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 2520*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 1260*D1**2*Pkdd2*f**3*fd*k1**2*s + 630*D1**2*Pkdd2*f**3*fd*k1**2 - 1260*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 630*D1**2*Pkdd2*f**3*fdd*k1**2*s - 315*D1**2*Pkdd2*f**3*fdd*k1**2 - 3780*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 1890*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 198*D1**2*bd1**2*f*s*(5*f*(8*Pk2*(2*s - 1) + Pkdd2*k1**2*s) + s*(56*Pk2 + 7*Pkdd2*k1**2)) - 35840*D1*Dd*Pk2*f**4*r*s + 8960*D1*Dd*Pk2*f**4*r - 92400*D1*Dd*Pk2*f**4*s**2 + 55160*D1*Dd*Pk2*f**4*s - 23100*D1*Dd*Pk2*f**4 + 143360*D1*Dd*Pk2*f**3*fd*r*s - 35840*D1*Dd*Pk2*f**3*fd*r + 542080*D1*Dd*Pk2*f**3*fd*s**2 - 306880*D1*Dd*Pk2*f**3*fd*s + 42840*D1*Dd*Pk2*f**3*fd - 139392*D1*Dd*Pk2*f**2*g2*r*s + 34848*D1*Dd*Pk2*f**2*g2*r + 34848*D1*Dd*Pk2*f**2*g2*s + 50688*D1*Dd*Pk2*f**2*gd2*r*s - 6336*D1*Dd*Pk2*f**2*gd2*r - 6336*D1*Dd*Pk2*f**2*gd2*s + 101376*D1*Dd*Pk2*f*fd*g2*r*s - 38016*D1*Dd*Pk2*f*fd*g2*r - 38016*D1*Dd*Pk2*f*fd*g2*s + 12672*D1*Dd*Pk2*f*fd*g2 + 2520*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 1260*D1*Dd*Pkdd2*f**4*k1**2*s + 630*D1*Dd*Pkdd2*f**4*k1**2 - 10080*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 5040*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 630*D1*Dd*Pkdd2*f**3*fd*k1**2 + 17920*D1*Ddd*Pk2*f**4*r*s - 4480*D1*Ddd*Pk2*f**4*r + 67760*D1*Ddd*Pk2*f**4*s**2 - 38360*D1*Ddd*Pk2*f**4*s + 16940*D1*Ddd*Pk2*f**4 + 25344*D1*Ddd*Pk2*f**2*g2*r*s - 6336*D1*Ddd*Pk2*f**2*g2*r - 6336*D1*Ddd*Pk2*f**2*g2*s - 1260*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 630*D1*Ddd*Pkdd2*f**4*k1**2*s - 315*D1*Ddd*Pkdd2*f**4*k1**2 - 22*D1*bd1*f*(D1*(1680*Pk2*g2*s*(r - 1) + 10*f**2*(Pk2*(79*s**2 + s*(48*r + 24) - 28) - 7*Pkdd2*k1**2*s**2) - f*(10*fd*(2*Pk2*(12*r*(6*s - 1) + 213*s**2 - 71*s + 8) + 7*Pkdd2*k1**2*s*(1 - 3*s)) + 9*s*(Pk2*r*(88*K - 88) + 40*Pk2*s + 5*Pkdd2*k1**2*s)) + 9*fd*(8*Pk2*(r*(2*K - 2)*(4*s - 1) + s*(-2*K + 10*s - 3)) + 5*Pkdd2*k1**2*s*(2*s - 1))) + Dd*f*(-20*Pk2*f*(12*r*(8*s - 1) + 284*s**2 - 59*s - 6) + 72*Pk2*(r*(2*K - 2)*(8*s - 1) + s*(-2*K + 20*s - 3)) + 70*Pkdd2*f*k1**2*s*(4*s - 1) + 45*Pkdd2*k1**2*s*(4*s - 1))) + 53760*Dd**2*Pk2*f**4*r*s - 13440*Dd**2*Pk2*f**4*r + 203280*Dd**2*Pk2*f**4*s**2 - 115080*Dd**2*Pk2*f**4*s + 4480*Dd**2*Pk2*f**4 + 76032*Dd**2*Pk2*f**2*g2*r*s - 19008*Dd**2*Pk2*f**2*g2*r - 19008*Dd**2*Pk2*f**2*g2*s + 6336*Dd**2*Pk2*f**2*g2 - 3780*Dd**2*Pkdd2*f**4*k1**2*s**2 + 1890*Dd**2*Pkdd2*f**4*k1**2*s + 33*b1**2*(D1**2*(-30*fd**2*s*(8*Pk2*(2*s - 1) + Pkdd2*k1**2*(s - 1)) + fd*(16*Pk2*(15*f*(4*s**2 - 2*s + 1) + (7*s - 7)*(5*K*r - 5*r + 3*s - 3)) + 6*Pkdd2*k1**2*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2)) - 3*fdd*(8*Pk2*(5*f*(4*s**2 - 2*s + 1) + 7*(s - 1)**2) + Pkdd2*k1**2*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2))) + D1*(2*Dd*(-8*Pk2*f*(35*K*s + 15*fd*(1 - 4*s)**2 - 7*r*(5*K - 5)*(4*s - 1) - 84*s**2 + 7*s - 21) + 3*Pkdd2*f*k1**2*(-5*fd*(8*s**2 - 6*s + 1) + 28*s**2 - 14*s + 7) + 15*f**2*(16*Pk2 + Pkdd2*k1**2)*(4*s**2 - 2*s + 1) - 21*fd*(8*Pk2 + Pkdd2*k1**2)*(4*s**2 - 5*s + 1)) - 3*Ddd*f*(Pk2*(80*f + 56) + Pkdd2*k1**2*(5*f + 7))*(4*s**2 - 2*s + 1)) - 18*Dd**2*f*s*(2*s - 1)*(Pk2*(80*f + 56) + Pkdd2*k1**2*(5*f + 7))) + 11*b1*(3168*D1**2*K*Pk2*f*fd*r*s - 1584*D1**2*K*Pk2*f*fd*r - 1584*D1**2*K*Pk2*f*fd*s - 576*D1**2*K*Pk2*f*fdd*r*s + 288*D1**2*K*Pk2*f*fdd*r + 288*D1**2*K*Pk2*f*fdd*s - 576*D1**2*K*Pk2*fd**2*r*s + 288*D1**2*K*Pk2*fd**2*r + 288*D1**2*K*Pk2*fd**2*s - 288*D1**2*K*Pk2*fd**2 - 2880*D1**2*Pk2*f**2*fd*r*s + 960*D1**2*Pk2*f**2*fd*r - 4740*D1**2*Pk2*f**2*fd*s**2 + 4600*D1**2*Pk2*f**2*fd*s - 2140*D1**2*Pk2*f**2*fd + 1440*D1**2*Pk2*f**2*fdd*r*s - 480*D1**2*Pk2*f**2*fdd*r + 4260*D1**2*Pk2*f**2*fdd*s**2 - 3560*D1**2*Pk2*f**2*fdd*s + 1700*D1**2*Pk2*f**2*fdd + 2880*D1**2*Pk2*f*fd**2*r*s - 960*D1**2*Pk2*f*fd**2*r + 8520*D1**2*Pk2*f*fd**2*s**2 - 7120*D1**2*Pk2*f*fd**2*s + 160*D1**2*Pk2*f*fd**2 - 3168*D1**2*Pk2*f*fd*r*s + 1584*D1**2*Pk2*f*fd*r + 1440*D1**2*Pk2*f*fd*s**2 + 144*D1**2*Pk2*f*fd*s + 720*D1**2*Pk2*f*fd + 576*D1**2*Pk2*f*fdd*r*s - 288*D1**2*Pk2*f*fdd*r - 720*D1**2*Pk2*f*fdd*s**2 + 432*D1**2*Pk2*f*fdd*s - 360*D1**2*Pk2*f*fdd - 3360*D1**2*Pk2*f*gd2*r*s + 576*D1**2*Pk2*fd**2*r*s - 288*D1**2*Pk2*fd**2*r - 720*D1**2*Pk2*fd**2*s**2 + 432*D1**2*Pk2*fd**2*s + 288*D1**2*Pk2*fd**2 - 3360*D1**2*Pk2*fd*g2*r*s + 3360*D1**2*Pk2*fd*g2*r + 420*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 280*D1**2*Pkdd2*f**2*fd*k1**2*s + 140*D1**2*Pkdd2*f**2*fd*k1**2 - 210*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 140*D1**2*Pkdd2*f**2*fdd*k1**2*s - 70*D1**2*Pkdd2*f**2*fdd*k1**2 - 420*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 280*D1**2*Pkdd2*f*fd**2*k1**2*s + 180*D1**2*Pkdd2*f*fd*k1**2*s**2 - 180*D1**2*Pkdd2*f*fd*k1**2*s + 90*D1**2*Pkdd2*f*fd*k1**2 - 90*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 90*D1**2*Pkdd2*f*fdd*k1**2*s - 45*D1**2*Pkdd2*f*fdd*k1**2 - 90*D1**2*Pkdd2*fd**2*k1**2*s**2 + 90*D1**2*Pkdd2*fd**2*k1**2*s - 18*D1**2*bdd1*f*(5*f*(4*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2) + s**2*(56*Pk2 + 7*Pkdd2*k1**2)) + 6336*D1*Dd*K*Pk2*f**2*r*s - 1584*D1*Dd*K*Pk2*f**2*r - 1584*D1*Dd*K*Pk2*f**2*s - 4608*D1*Dd*K*Pk2*f*fd*r*s + 1728*D1*Dd*K*Pk2*f*fd*r + 1728*D1*Dd*K*Pk2*f*fd*s - 576*D1*Dd*K*Pk2*f*fd - 3840*D1*Dd*Pk2*f**3*r*s + 960*D1*Dd*Pk2*f**3*r - 6320*D1*Dd*Pk2*f**3*s**2 + 4120*D1*Dd*Pk2*f**3*s - 1580*D1*Dd*Pk2*f**3 + 11520*D1*Dd*Pk2*f**2*fd*r*s - 3360*D1*Dd*Pk2*f**2*fd*r + 34080*D1*Dd*Pk2*f**2*fd*s**2 - 24200*D1*Dd*Pk2*f**2*fd*s + 4040*D1*Dd*Pk2*f**2*fd - 6336*D1*Dd*Pk2*f**2*r*s + 1584*D1*Dd*Pk2*f**2*r + 2880*D1*Dd*Pk2*f**2*s**2 + 144*D1*Dd*Pk2*f**2*s + 720*D1*Dd*Pk2*f**2 + 4608*D1*Dd*Pk2*f*fd*r*s - 1728*D1*Dd*Pk2*f*fd*r - 5760*D1*Dd*Pk2*f*fd*s**2 + 2592*D1*Dd*Pk2*f*fd*s - 144*D1*Dd*Pk2*f*fd - 13440*D1*Dd*Pk2*f*g2*r*s + 3360*D1*Dd*Pk2*f*g2*r + 3360*D1*Dd*Pk2*f*g2*s + 560*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 280*D1*Dd*Pkdd2*f**3*k1**2*s + 140*D1*Dd*Pkdd2*f**3*k1**2 - 1680*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 980*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 140*D1*Dd*Pkdd2*f**2*fd*k1**2 + 360*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 180*D1*Dd*Pkdd2*f**2*k1**2*s + 90*D1*Dd*Pkdd2*f**2*k1**2 - 720*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 540*D1*Dd*Pkdd2*f*fd*k1**2*s - 90*D1*Dd*Pkdd2*f*fd*k1**2 - 1152*D1*Ddd*K*Pk2*f**2*r*s + 288*D1*Ddd*K*Pk2*f**2*r + 288*D1*Ddd*K*Pk2*f**2*s + 1920*D1*Ddd*Pk2*f**3*r*s - 480*D1*Ddd*Pk2*f**3*r + 5680*D1*Ddd*Pk2*f**3*s**2 - 3320*D1*Ddd*Pk2*f**3*s + 1420*D1*Ddd*Pk2*f**3 + 1152*D1*Ddd*Pk2*f**2*r*s - 288*D1*Ddd*Pk2*f**2*r - 1440*D1*Ddd*Pk2*f**2*s**2 + 432*D1*Ddd*Pk2*f**2*s - 360*D1*Ddd*Pk2*f**2 - 280*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 140*D1*Ddd*Pkdd2*f**3*k1**2*s - 70*D1*Ddd*Pkdd2*f**3*k1**2 - 180*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 90*D1*Ddd*Pkdd2*f**2*k1**2*s - 45*D1*Ddd*Pkdd2*f**2*k1**2 + 12*D1*bd1*(D1*(15*f**2*(4*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2) + f*s*(-4*Pk2*(-70*K*r + 35*K + 60*fd*(2*s - 1) + 70*r - 42*s - 35) + 3*Pkdd2*k1**2*(fd*(5 - 10*s) + 7*s)) - 21*fd*s*(8*Pk2 + Pkdd2*k1**2)*(s - 1)) - 3*Dd*f*(4*s - 1)*(5*f*(16*Pk2*s - 4*Pk2 + Pkdd2*k1**2*s) + s*(56*Pk2 + 7*Pkdd2*k1**2))) - 3456*Dd**2*K*Pk2*f**2*r*s + 864*Dd**2*K*Pk2*f**2*r + 864*Dd**2*K*Pk2*f**2*s - 288*Dd**2*K*Pk2*f**2 + 5760*Dd**2*Pk2*f**3*r*s - 1440*Dd**2*Pk2*f**3*r + 17040*Dd**2*Pk2*f**3*s**2 - 9960*Dd**2*Pk2*f**3*s + 480*Dd**2*Pk2*f**3 + 3456*Dd**2*Pk2*f**2*r*s - 864*Dd**2*Pk2*f**2*r - 4320*Dd**2*Pk2*f**2*s**2 + 1296*Dd**2*Pk2*f**2*s + 288*Dd**2*Pk2*f**2 - 840*Dd**2*Pkdd2*f**3*k1**2*s**2 + 420*Dd**2*Pkdd2*f**3*k1**2*s - 540*Dd**2*Pkdd2*f**2*k1**2*s**2 + 270*Dd**2*Pkdd2*f**2*k1**2*s))/(6930*d**2*k1*k2) - D1**2*Pk1*ct**5*k2**3*(-468*D1**2*Pk2*b1*f*fd*r**2 + 108*D1**2*Pk2*b1*f*fdd*r**2 + 108*D1**2*Pk2*b1*fd**2*r**2 - 498*D1**2*Pk2*f**2*fd*r**2 + 332*D1**2*Pk2*f**2*fd*r - 166*D1**2*Pk2*f**2*fd - 102*D1**2*Pk2*f**2*fdd*r**2 + 68*D1**2*Pk2*f**2*fdd*r - 34*D1**2*Pk2*f**2*fdd - 204*D1**2*Pk2*f*fd**2*r**2 + 136*D1**2*Pk2*f*fd**2*r - 126*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 63*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 54*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 126*D1**2*Pkdd2*b1*f*fd*k1**2*s + 63*D1**2*Pkdd2*b1*f*fd*k1**2 + 90*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 90*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 126*D1**2*Pkdd2*bd1**2*f*k1**2*s*(s - 1) + 135*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 90*D1**2*Pkdd2*f**2*fd*k1**2*s + 45*D1**2*Pkdd2*f**2*fd*k1**2 + 9*D1**2*bdd1*f*(7*Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1) + f*(6*Pk2*(r - 1)**2 + 5*Pkdd2*k1**2*(s - 1)**2)) - 936*D1*Dd*Pk2*b1*f**2*r**2 + 468*D1*Dd*Pk2*b1*f**2*r - 234*D1*Dd*Pk2*b1*f**2 + 864*D1*Dd*Pk2*b1*f*fd*r**2 - 216*D1*Dd*Pk2*b1*f*fd*r - 664*D1*Dd*Pk2*f**3*r**2 + 332*D1*Dd*Pk2*f**3*r - 166*D1*Dd*Pk2*f**3 - 816*D1*Dd*Pk2*f**2*fd*r**2 + 476*D1*Dd*Pk2*f**2*fd*r - 68*D1*Dd*Pk2*f**2*fd - 504*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 252*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 126*D1*Dd*Pkdd2*b1**2*f*k1**2 + 504*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 126*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 108*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 54*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 27*D1*Dd*Pkdd2*b1*f**2*k1**2 + 720*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 180*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 180*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 90*D1*Dd*Pkdd2*f**3*k1**2*s + 45*D1*Dd*Pkdd2*f**3*k1**2 + 216*D1*Ddd*Pk2*b1*f**2*r**2 - 108*D1*Ddd*Pk2*b1*f**2*r + 54*D1*Ddd*Pk2*b1*f**2 - 136*D1*Ddd*Pk2*f**3*r**2 + 68*D1*Ddd*Pk2*f**3*r - 34*D1*Ddd*Pk2*f**3 + 252*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 126*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 63*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 180*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 90*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 45*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 9*D1*bd1*(D1*(14*Pkdd2*b1*fd*k1**2*s*(1 - 2*s) + f**2*(26*Pk2*(r - 1)**2 + Pkdd2*k1**2*(3*s**2 - 20*s + 10)) + 2*f*(7*Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1) - 2*fd*(6*Pk2*r*(r - 1) + 5*Pkdd2*k1**2*s*(s - 1)))) - 2*Dd*f*(6*Pk2*f*(4*r**2 - 5*r + 1) + 7*Pkdd2*b1*k1**2*(8*s**2 - 6*s + 1) + 5*Pkdd2*f*k1**2*(4*s**2 - 5*s + 1))) + 648*Dd**2*Pk2*b1*f**2*r**2 - 324*Dd**2*Pk2*b1*f**2*r - 408*Dd**2*Pk2*f**3*r**2 + 204*Dd**2*Pk2*f**3*r + 756*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 378*Dd**2*Pkdd2*b1**2*f*k1**2*s + 540*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 270*Dd**2*Pkdd2*b1*f**2*k1**2*s)/(630*d**2*k1**3*k3**2) - D1**2*Pk1*ct**5*k2*(-3630*D1**2*Pk2*b1*f**2*fd*r**2 + 330*D1**2*Pk2*b1*f**2*fdd*r**2 + 660*D1**2*Pk2*b1*f*fd**2*r**2 - 4600*D1**2*Pk2*f**3*fd*r**2 + 2300*D1**2*Pk2*f**3*fd*r - 1150*D1**2*Pk2*f**3*fd - 1000*D1**2*Pk2*f**3*fdd*r**2 + 500*D1**2*Pk2*f**3*fdd*r - 250*D1**2*Pk2*f**3*fdd - 3000*D1**2*Pk2*f**2*fd**2*r**2 + 1500*D1**2*Pk2*f**2*fd**2*r - 3960*D1**2*Pkdd2*b1**2*f*fd*k1**2*s**2 + 1980*D1**2*Pkdd2*b1**2*f*fd*k1**2*s - 990*D1**2*Pkdd2*b1**2*f*fd*k1**2 + 1980*D1**2*Pkdd2*b1**2*f*fdd*k1**2*s**2 - 990*D1**2*Pkdd2*b1**2*f*fdd*k1**2*s + 495*D1**2*Pkdd2*b1**2*f*fdd*k1**2 + 1980*D1**2*Pkdd2*b1**2*fd**2*k1**2*s**2 - 990*D1**2*Pkdd2*b1**2*fd**2*k1**2*s - 1386*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 2772*D1**2*Pkdd2*b1**2*fd*k1**2*s - 1386*D1**2*Pkdd2*b1**2*fd*k1**2 + 693*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 1386*D1**2*Pkdd2*b1**2*fdd*k1**2*s + 693*D1**2*Pkdd2*b1**2*fdd*k1**2 - 3135*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 550*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 275*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 2310*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 770*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 385*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 4620*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 1540*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 1980*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 1980*D1**2*Pkdd2*b1*f*fd*k1**2*s - 990*D1**2*Pkdd2*b1*f*fd*k1**2 + 990*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 990*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 495*D1**2*Pkdd2*b1*f*fdd*k1**2 + 990*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 990*D1**2*Pkdd2*b1*fd**2*k1**2*s + 198*D1**2*Pkdd2*bd1**2*f*k1**2*s*(5*f*(2*s - 1) + 7*s) + 1540*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 770*D1**2*Pkdd2*f**3*fd*k1**2*s + 385*D1**2*Pkdd2*f**3*fd*k1**2 + 11*D1**2*bdd1*f*(126*Pkdd2*b1*k1**2*s**2 + 45*Pkdd2*f*k1**2*(4*b1*s**2 - 2*b1*s + b1 + s**2) + 5*f**2*(2*Pk2*(r - 1)**2 + 7*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 4840*D1*Dd*Pk2*b1*f**3*r**2 + 2420*D1*Dd*Pk2*b1*f**3*r - 1210*D1*Dd*Pk2*b1*f**3 + 2640*D1*Dd*Pk2*b1*f**2*fd*r**2 - 660*D1*Dd*Pk2*b1*f**2*fd*r - 4600*D1*Dd*Pk2*f**4*r**2 + 2300*D1*Dd*Pk2*f**4*r - 1150*D1*Dd*Pk2*f**4 - 8000*D1*Dd*Pk2*f**3*fd*r**2 + 4000*D1*Dd*Pk2*f**3*fd*r - 500*D1*Dd*Pk2*f**3*fd - 7920*D1*Dd*Pkdd2*b1**2*f**2*k1**2*s**2 + 3960*D1*Dd*Pkdd2*b1**2*f**2*k1**2*s - 1980*D1*Dd*Pkdd2*b1**2*f**2*k1**2 + 15840*D1*Dd*Pkdd2*b1**2*f*fd*k1**2*s**2 - 7920*D1*Dd*Pkdd2*b1**2*f*fd*k1**2*s + 990*D1*Dd*Pkdd2*b1**2*f*fd*k1**2 - 5544*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 2772*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 1386*D1*Dd*Pkdd2*b1**2*f*k1**2 + 5544*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 6930*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 1386*D1*Dd*Pkdd2*b1**2*fd*k1**2 - 4180*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 2090*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 1045*D1*Dd*Pkdd2*b1*f**3*k1**2 + 18480*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 7700*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 770*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 3960*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 1980*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 990*D1*Dd*Pkdd2*b1*f**2*k1**2 + 7920*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 5940*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 990*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 1540*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 770*D1*Dd*Pkdd2*f**4*k1**2*s + 385*D1*Dd*Pkdd2*f**4*k1**2 + 440*D1*Ddd*Pk2*b1*f**3*r**2 - 220*D1*Ddd*Pk2*b1*f**3*r + 110*D1*Ddd*Pk2*b1*f**3 - 1000*D1*Ddd*Pk2*f**4*r**2 + 500*D1*Ddd*Pk2*f**4*r - 250*D1*Ddd*Pk2*f**4 + 3960*D1*Ddd*Pkdd2*b1**2*f**2*k1**2*s**2 - 1980*D1*Ddd*Pkdd2*b1**2*f**2*k1**2*s + 990*D1*Ddd*Pkdd2*b1**2*f**2*k1**2 + 2772*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 1386*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 693*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 3080*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 1540*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 770*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 1980*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 990*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 495*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 11*D1*bd1*(D1*(-252*Pkdd2*b1*fd*k1**2*s*(s - 1) - 18*Pkdd2*f*k1**2*s*(-14*b1*s + fd*(20*b1 + 5)*(2*s - 1)) + 5*f**3*(22*Pk2*(r - 1)**2 + Pkdd2*k1**2*(19*s**2 - 28*s + 14)) + 10*f**2*(-6*Pk2*fd*r*(r - 1) + 9*Pkdd2*b1*k1**2*(4*s**2 - 2*s + 1) + 14*Pkdd2*fd*k1**2*s*(2 - 3*s) + 9*Pkdd2*k1**2*s**2)) - 2*Dd*f*(126*Pkdd2*b1*k1**2*s*(4*s - 1) + 45*Pkdd2*f*k1**2*(4*s - 1)*(b1*(4*s - 1) + s) + 5*f**2*(2*Pk2*(4*r**2 - 5*r + 1) + 7*Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) + 1320*Dd**2*Pk2*b1*f**3*r**2 - 660*Dd**2*Pk2*b1*f**3*r - 3000*Dd**2*Pk2*f**4*r**2 + 1500*Dd**2*Pk2*f**4*r + 11880*Dd**2*Pkdd2*b1**2*f**2*k1**2*s**2 - 5940*Dd**2*Pkdd2*b1**2*f**2*k1**2*s + 8316*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 4158*Dd**2*Pkdd2*b1**2*f*k1**2*s + 9240*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 4620*Dd**2*Pkdd2*b1*f**3*k1**2*s + 5940*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 2970*Dd**2*Pkdd2*b1*f**2*k1**2*s)/(6930*d**2*k1**3) - 2*D1**2*Pk1*ct**4*st**2*(504*Pk2*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 9*b1*(-704*C*D1**2*Pk2*f*fd*r*s + 352*C*D1**2*Pk2*f*fd*r - 968*C*D1**2*Pk2*f*fd*s**2 + 1064*C*D1**2*Pk2*f*fd*s - 532*C*D1**2*Pk2*f*fd + 352*C*D1**2*Pk2*f*fdd*r*s - 176*C*D1**2*Pk2*f*fdd*r + 736*C*D1**2*Pk2*f*fdd*s**2 - 784*C*D1**2*Pk2*f*fdd*s + 392*C*D1**2*Pk2*f*fdd + 352*C*D1**2*Pk2*fd**2*r*s - 176*C*D1**2*Pk2*fd**2*r + 736*C*D1**2*Pk2*fd**2*s**2 - 784*C*D1**2*Pk2*fd**2*s + 12*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 12*C*D1**2*Pkdd2*f*fd*k1**2*s + 6*C*D1**2*Pkdd2*f*fd*k1**2 - 6*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 6*C*D1**2*Pkdd2*f*fdd*k1**2*s - 3*C*D1**2*Pkdd2*f*fdd*k1**2 - 6*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 6*C*D1**2*Pkdd2*fd**2*k1**2*s - 1408*C*D1*Dd*Pk2*f**2*r*s + 352*C*D1*Dd*Pk2*f**2*r - 1936*C*D1*Dd*Pk2*f**2*s**2 + 1320*C*D1*Dd*Pk2*f**2*s - 484*C*D1*Dd*Pk2*f**2 + 2816*C*D1*Dd*Pk2*f*fd*r*s - 1056*C*D1*Dd*Pk2*f*fd*r + 5888*C*D1*Dd*Pk2*f*fd*s**2 - 4960*C*D1*Dd*Pk2*f*fd*s + 960*C*D1*Dd*Pk2*f*fd + 24*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 12*C*D1*Dd*Pkdd2*f**2*k1**2*s + 6*C*D1*Dd*Pkdd2*f**2*k1**2 - 48*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 36*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 6*C*D1*Dd*Pkdd2*f*fd*k1**2 + 704*C*D1*Ddd*Pk2*f**2*r*s - 176*C*D1*Ddd*Pk2*f**2*r + 1472*C*D1*Ddd*Pk2*f**2*s**2 - 912*C*D1*Ddd*Pk2*f**2*s + 368*C*D1*Ddd*Pk2*f**2 - 12*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*C*D1*Ddd*Pkdd2*f**2*k1**2 + 2112*C*Dd**2*Pk2*f**2*r*s - 528*C*Dd**2*Pk2*f**2*r + 4416*C*Dd**2*Pk2*f**2*s**2 - 2736*C*Dd**2*Pk2*f**2*s + 176*C*Dd**2*Pk2*f**2 - 36*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*C*Dd**2*Pkdd2*f**2*k1**2*s - 56*D1**2*Pk2*bdd1*f*(C - 1)*(2*s**2 - 2*s + 1) + 824*D1**2*Pk2*f*fd*r*s - 412*D1**2*Pk2*f*fd*r + 568*D1**2*Pk2*f*fd*s**2 - 664*D1**2*Pk2*f*fd*s + 332*D1**2*Pk2*f*fd - 412*D1**2*Pk2*f*fdd*r*s + 206*D1**2*Pk2*f*fdd*r - 536*D1**2*Pk2*f*fdd*s**2 + 584*D1**2*Pk2*f*fdd*s - 292*D1**2*Pk2*f*fdd - 412*D1**2*Pk2*fd**2*r*s + 206*D1**2*Pk2*fd**2*r - 536*D1**2*Pk2*fd**2*s**2 + 584*D1**2*Pk2*fd**2*s - 32*D1**2*Pkdd2*f*fd*k1**2*s**2 + 32*D1**2*Pkdd2*f*fd*k1**2*s - 16*D1**2*Pkdd2*f*fd*k1**2 + 16*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 16*D1**2*Pkdd2*f*fdd*k1**2*s + 8*D1**2*Pkdd2*f*fdd*k1**2 + 16*D1**2*Pkdd2*fd**2*k1**2*s**2 - 16*D1**2*Pkdd2*fd**2*k1**2*s + 1648*D1*Dd*Pk2*f**2*r*s - 412*D1*Dd*Pk2*f**2*r + 1136*D1*Dd*Pk2*f**2*s**2 - 980*D1*Dd*Pk2*f**2*s + 284*D1*Dd*Pk2*f**2 - 3296*D1*Dd*Pk2*f*fd*r*s + 1236*D1*Dd*Pk2*f*fd*r - 4288*D1*Dd*Pk2*f*fd*s**2 + 3820*D1*Dd*Pk2*f*fd*s - 790*D1*Dd*Pk2*f*fd - 64*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 32*D1*Dd*Pkdd2*f**2*k1**2*s - 16*D1*Dd*Pkdd2*f**2*k1**2 + 128*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 96*D1*Dd*Pkdd2*f*fd*k1**2*s + 16*D1*Dd*Pkdd2*f*fd*k1**2 - 824*D1*Ddd*Pk2*f**2*r*s + 206*D1*Ddd*Pk2*f**2*r - 1072*D1*Ddd*Pk2*f**2*s**2 + 742*D1*Ddd*Pk2*f**2*s - 268*D1*Ddd*Pk2*f**2 + 32*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 16*D1*Ddd*Pkdd2*f**2*k1**2*s + 8*D1*Ddd*Pkdd2*f**2*k1**2 + 112*D1*Pk2*bd1*(C - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 2472*Dd**2*Pk2*f**2*r*s + 618*Dd**2*Pk2*f**2*r - 3216*Dd**2*Pk2*f**2*s**2 + 2226*Dd**2*Pk2*f**2*s - 206*Dd**2*Pk2*f**2 + 96*Dd**2*Pkdd2*f**2*k1**2*s**2 - 48*Dd**2*Pkdd2*f**2*k1**2*s) + f*(-5520*C*D1**2*Pk2*f*fd*r*s + 1840*C*D1**2*Pk2*f*fd*r - 7116*C*D1**2*Pk2*f*fd*s**2 + 6584*C*D1**2*Pk2*f*fd*s - 2372*C*D1**2*Pk2*f*fd + 3408*C*D1**2*Pk2*f*fdd*r*s - 1136*C*D1**2*Pk2*f*fdd*r + 5016*C*D1**2*Pk2*f*fdd*s**2 - 4480*C*D1**2*Pk2*f*fdd*s + 1672*C*D1**2*Pk2*f*fdd + 6816*C*D1**2*Pk2*fd**2*r*s - 2272*C*D1**2*Pk2*fd**2*r + 10032*C*D1**2*Pk2*fd**2*s**2 - 8960*C*D1**2*Pk2*fd**2*s + 1136*C*D1**2*Pk2*fd**2 + 90*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 60*C*D1**2*Pkdd2*f*fd*k1**2*s + 30*C*D1**2*Pkdd2*f*fd*k1**2 - 45*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 30*C*D1**2*Pkdd2*f*fdd*k1**2*s - 15*C*D1**2*Pkdd2*f*fdd*k1**2 - 90*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 60*C*D1**2*Pkdd2*fd**2*k1**2*s - 7360*C*D1*Dd*Pk2*f**2*r*s + 1840*C*D1*Dd*Pk2*f**2*r - 9488*C*D1*Dd*Pk2*f**2*s**2 + 6584*C*D1*Dd*Pk2*f**2*s - 2372*C*D1*Dd*Pk2*f**2 + 27264*C*D1*Dd*Pk2*f*fd*r*s - 7952*C*D1*Dd*Pk2*f*fd*r + 40128*C*D1*Dd*Pk2*f*fd*s**2 - 31360*C*D1*Dd*Pk2*f*fd*s + 5616*C*D1*Dd*Pk2*f*fd + 120*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 60*C*D1*Dd*Pkdd2*f**2*k1**2*s + 30*C*D1*Dd*Pkdd2*f**2*k1**2 - 360*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 210*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 30*C*D1*Dd*Pkdd2*f*fd*k1**2 + 4544*C*D1*Ddd*Pk2*f**2*r*s - 1136*C*D1*Ddd*Pk2*f**2*r + 6688*C*D1*Ddd*Pk2*f**2*s**2 - 4480*C*D1*Ddd*Pk2*f**2*s + 1672*C*D1*Ddd*Pk2*f**2 - 60*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 30*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 15*C*D1*Ddd*Pkdd2*f**2*k1**2 + 13632*C*Dd**2*Pk2*f**2*r*s - 3408*C*Dd**2*Pk2*f**2*r + 20064*C*Dd**2*Pk2*f**2*s**2 - 13440*C*Dd**2*Pk2*f**2*s + 1136*C*Dd**2*Pk2*f**2 - 180*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 90*C*Dd**2*Pkdd2*f**2*k1**2*s - 1008*D1**2*Pk2*bd1**2*s*(C - 1)*(s - 1) + 6948*D1**2*Pk2*f*fd*r*s - 2316*D1**2*Pk2*f*fd*r + 4116*D1**2*Pk2*f*fd*s**2 - 5060*D1**2*Pk2*f*fd*s + 1372*D1**2*Pk2*f*fd - 4338*D1**2*Pk2*f*fdd*r*s + 1446*D1**2*Pk2*f*fdd*r - 3516*D1**2*Pk2*f*fdd*s**2 + 3790*D1**2*Pk2*f*fdd*s - 1172*D1**2*Pk2*f*fdd - 8676*D1**2*Pk2*fd**2*r*s + 2892*D1**2*Pk2*fd**2*r - 7032*D1**2*Pk2*fd**2*s**2 + 7580*D1**2*Pk2*fd**2*s - 1446*D1**2*Pk2*fd**2 - 240*D1**2*Pkdd2*f*fd*k1**2*s**2 + 160*D1**2*Pkdd2*f*fd*k1**2*s - 80*D1**2*Pkdd2*f*fd*k1**2 + 120*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 80*D1**2*Pkdd2*f*fdd*k1**2*s + 40*D1**2*Pkdd2*f*fdd*k1**2 + 240*D1**2*Pkdd2*fd**2*k1**2*s**2 - 160*D1**2*Pkdd2*fd**2*k1**2*s + 9*D1**2*bdd1*f*(2*Pk2*(4*C*(22*r*s + 46*s**2 - 16*s - 3) - 103*r*s - 134*s**2 + 79*s + 12) + Pkdd2*k1**2*s**2*(8 - 3*C)) + 9264*D1*Dd*Pk2*f**2*r*s - 2316*D1*Dd*Pk2*f**2*r + 5488*D1*Dd*Pk2*f**2*s**2 - 5060*D1*Dd*Pk2*f**2*s + 1372*D1*Dd*Pk2*f**2 - 34704*D1*Dd*Pk2*f*fd*r*s + 10122*D1*Dd*Pk2*f*fd*r - 28128*D1*Dd*Pk2*f*fd*s**2 + 26530*D1*Dd*Pk2*f*fd*s - 5236*D1*Dd*Pk2*f*fd - 320*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 160*D1*Dd*Pkdd2*f**2*k1**2*s - 80*D1*Dd*Pkdd2*f**2*k1**2 + 960*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 560*D1*Dd*Pkdd2*f*fd*k1**2*s + 80*D1*Dd*Pkdd2*f*fd*k1**2 - 5784*D1*Ddd*Pk2*f**2*r*s + 1446*D1*Ddd*Pk2*f**2*r - 4688*D1*Ddd*Pk2*f**2*s**2 + 3790*D1*Ddd*Pk2*f**2*s - 1172*D1*Ddd*Pk2*f**2 + 160*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 80*D1*Ddd*Pkdd2*f**2*k1**2*s + 40*D1*Ddd*Pkdd2*f**2*k1**2 - 18*D1*bd1*(D1*(2*Pk2*f*(C*(121*s**2 + s*(88*r - 64) - 12) - 71*s**2 + s*(79 - 103*r) + 12) + Pk2*fd*(-8*C*(11*r*(4*s - 1) + 92*s**2 - 65*s + 11) + 103*r*(4*s - 1) + 536*s**2 - 450*s + 103) + Pkdd2*f*k1**2*s**2*(8 - 3*C) + Pkdd2*fd*k1**2*s*(3*C - 8)*(2*s - 1)) + Dd*f*(Pk2*(-8*C*(11*r*(8*s - 1) + 184*s**2 - 89*s + 8) + 103*r*(8*s - 1) + 1072*s**2 - 687*s + 79) + Pkdd2*k1**2*s*(3*C - 8)*(4*s - 1))) - 17352*Dd**2*Pk2*f**2*r*s + 4338*Dd**2*Pk2*f**2*r - 14064*Dd**2*Pk2*f**2*s**2 + 11370*Dd**2*Pk2*f**2*s - 1446*Dd**2*Pk2*f**2 + 480*Dd**2*Pkdd2*f**2*k1**2*s**2 - 240*Dd**2*Pkdd2*f**2*k1**2*s))/(315*d**2*k3**2) + D1**2*Pk1*ct**4*(21*b1**2*(D1**2*s*(6*fd*(Pk2*r*(20*C - 22) + Pk2*s*(13*C - 13) - Pkdd2*k1**2*s*(C - 2)) + fdd*(Pk2*r*(46 - 40*C) - Pk2*s*(74*C - 74) + Pkdd2*k1**2*s*(3*C - 6))) + D1*(2*Dd*(3*Pk2*f*(C*(80*r*s - 20*r + 52*s**2 - 46*s + 13) - 88*r*s + 22*r - 52*s**2 + 48*s - 13) - Pk2*fd*r*(20*C - 23)*(8*s - 1) + Pk2*fd*s*(C*(94 - 296*s) + 296*s - 97) - Pkdd2*f*k1**2*(3*C - 6)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(3*C - 6)*(4*s - 1)) + Ddd*f*(-2*Pk2*(C*(80*r*s - 20*r + 148*s**2 - 94*s + 37) - 92*r*s + 23*r - 148*s**2 + 97*s - 37) + Pkdd2*k1**2*(3*C - 6)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*(C*(-60*r*(4*s - 1) - 444*s**2 + 282*s - 20) + 69*r*(4*s - 1) + 444*s**2 - 291*s + 23) + Pkdd2*k1**2*s*(9*C - 18)*(2*s - 1))) + 3*b1*(-344*C*D1**2*Pk2*f*fd*r**2 - 984*C*D1**2*Pk2*f*fd*r*s + 1188*C*D1**2*Pk2*f*fd*r - 1740*C*D1**2*Pk2*f*fd*s**2 + 1776*C*D1**2*Pk2*f*fd*s - 1236*C*D1**2*Pk2*f*fd + 116*C*D1**2*Pk2*f*fdd*r**2 + 1080*C*D1**2*Pk2*f*fdd*r*s - 804*C*D1**2*Pk2*f*fdd*r + 1668*C*D1**2*Pk2*f*fdd*s**2 - 2064*C*D1**2*Pk2*f*fdd*s + 1164*C*D1**2*Pk2*f*fdd + 116*C*D1**2*Pk2*fd**2*r**2 + 1080*C*D1**2*Pk2*fd**2*r*s - 804*C*D1**2*Pk2*fd**2*r + 1668*C*D1**2*Pk2*fd**2*s**2 - 2064*C*D1**2*Pk2*fd**2*s + 42*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 102*C*D1**2*Pkdd2*f*fd*k1**2*s + 51*C*D1**2*Pkdd2*f*fd*k1**2 + 30*C*D1**2*Pkdd2*f*fdd*k1**2*s - 15*C*D1**2*Pkdd2*f*fdd*k1**2 + 30*C*D1**2*Pkdd2*fd**2*k1**2*s - 688*C*D1*Dd*Pk2*f**2*r**2 - 1968*C*D1*Dd*Pk2*f**2*r*s + 836*C*D1*Dd*Pk2*f**2*r - 3480*C*D1*Dd*Pk2*f**2*s**2 + 2232*C*D1*Dd*Pk2*f**2*s - 1042*C*D1*Dd*Pk2*f**2 + 928*C*D1*Dd*Pk2*f*fd*r**2 + 8640*C*D1*Dd*Pk2*f*fd*r*s - 4528*C*D1*Dd*Pk2*f*fd*r + 13344*C*D1*Dd*Pk2*f*fd*s**2 - 12672*C*D1*Dd*Pk2*f*fd*s + 2868*C*D1*Dd*Pk2*f*fd + 84*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 42*C*D1*Dd*Pkdd2*f**2*k1**2*s + 21*C*D1*Dd*Pkdd2*f**2*k1**2 + 120*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 30*C*D1*Dd*Pkdd2*f*fd*k1**2 + 232*C*D1*Ddd*Pk2*f**2*r**2 + 2160*C*D1*Ddd*Pk2*f**2*r*s - 656*C*D1*Ddd*Pk2*f**2*r + 3336*C*D1*Ddd*Pk2*f**2*s**2 - 2208*C*D1*Ddd*Pk2*f**2*s + 892*C*D1*Ddd*Pk2*f**2 + 696*C*Dd**2*Pk2*f**2*r**2 + 6480*C*Dd**2*Pk2*f**2*r*s - 1968*C*Dd**2*Pk2*f**2*r + 10008*C*Dd**2*Pk2*f**2*s**2 - 6624*C*Dd**2*Pk2*f**2*s + 540*C*Dd**2*Pk2*f**2 + 428*D1**2*Pk2*f*fd*r**2 + 510*D1**2*Pk2*f*fd*r*s - 1059*D1**2*Pk2*f*fd*r - 12*D1**2*Pk2*f*fd*s**2 + 84*D1**2*Pk2*f*fd*s + 360*D1**2*Pk2*f*fd - 200*D1**2*Pk2*f*fdd*r**2 - 738*D1**2*Pk2*f*fdd*r*s + 687*D1**2*Pk2*f*fdd*r - 204*D1**2*Pk2*f*fdd*s**2 + 546*D1**2*Pk2*f*fdd*s - 432*D1**2*Pk2*f*fdd - 200*D1**2*Pk2*fd**2*r**2 - 738*D1**2*Pk2*fd**2*r*s + 687*D1**2*Pk2*fd**2*r - 204*D1**2*Pk2*fd**2*s**2 + 546*D1**2*Pk2*fd**2*s + 36*D1**2*Pkdd2*f*fd*k1**2*s**2 + 84*D1**2*Pkdd2*f*fd*k1**2*s - 42*D1**2*Pkdd2*f*fd*k1**2 - 60*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 60*D1**2*Pkdd2*fd**2*k1**2*s**2 - 7*D1**2*bdd1*f*(2*Pk2*(C*(40*r*s - 20*r + 74*s**2 - 94*s + 37) - 46*r*s + 23*r - 74*s**2 + 97*s - 37) + Pkdd2*k1**2*(6 - 3*C)*(2*s**2 - 2*s + 1)) + 856*D1*Dd*Pk2*f**2*r**2 + 1020*D1*Dd*Pk2*f**2*r*s - 683*D1*Dd*Pk2*f**2*r - 24*D1*Dd*Pk2*f**2*s**2 - 243*D1*Dd*Pk2*f**2*s + 208*D1*Dd*Pk2*f**2 - 1600*D1*Dd*Pk2*f*fd*r**2 - 5904*D1*Dd*Pk2*f*fd*r*s + 3886*D1*Dd*Pk2*f*fd*r - 1632*D1*Dd*Pk2*f*fd*s**2 + 3330*D1*Dd*Pk2*f*fd*s - 1233*D1*Dd*Pk2*f*fd + 72*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 36*D1*Dd*Pkdd2*f**2*k1**2*s + 18*D1*Dd*Pkdd2*f**2*k1**2 - 480*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 120*D1*Dd*Pkdd2*f*fd*k1**2*s - 400*D1*Ddd*Pk2*f**2*r**2 - 1476*D1*Ddd*Pk2*f**2*r*s + 569*D1*Ddd*Pk2*f**2*r - 408*D1*Ddd*Pk2*f**2*s**2 + 573*D1*Ddd*Pk2*f**2*s - 202*D1*Ddd*Pk2*f**2 - 120*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 60*D1*Ddd*Pkdd2*f**2*k1**2*s - 30*D1*Ddd*Pkdd2*f**2*k1**2 + 14*D1*bd1*(D1*(3*Pk2*f*(C*(40*r*s - 20*r + 26*s**2 - 46*s + 13) - 44*r*s + 22*r - 26*s**2 + 48*s - 13) - Pk2*fd*r*(20*C - 23)*(4*s - 1) + Pk2*fd*s*(C*(94 - 148*s) + 148*s - 97) - Pkdd2*f*k1**2*(3*C - 6)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(3*C - 6)*(2*s - 1)) + Dd*f*(-2*Pk2*(C*(20*r*(8*s - 3) + 296*s**2 - 282*s + 57) - 184*r*s + 69*r - 296*s**2 + 291*s - 60) + Pkdd2*k1**2*(3*C - 6)*(8*s**2 - 6*s + 1))) - 1200*Dd**2*Pk2*f**2*r**2 - 4428*Dd**2*Pk2*f**2*r*s + 1707*Dd**2*Pk2*f**2*r - 1224*Dd**2*Pk2*f**2*s**2 + 1719*Dd**2*Pk2*f**2*s - 369*Dd**2*Pk2*f**2 - 360*Dd**2*Pkdd2*f**2*k1**2*s**2 + 180*Dd**2*Pkdd2*f**2*k1**2*s) - f*(1668*C*D1**2*Pk2*f*fd*r**2 + 10284*C*D1**2*Pk2*f*fd*r*s - 4540*C*D1**2*Pk2*f*fd*r + 7548*C*D1**2*Pk2*f*fd*s**2 - 8460*C*D1**2*Pk2*f*fd*s + 3072*C*D1**2*Pk2*f*fd - 618*C*D1**2*Pk2*f*fdd*r**2 - 6924*C*D1**2*Pk2*f*fdd*r*s + 2720*C*D1**2*Pk2*f*fdd*r - 7068*C*D1**2*Pk2*f*fdd*s**2 + 7020*C*D1**2*Pk2*f*fdd*s - 2562*C*D1**2*Pk2*f*fdd - 1236*C*D1**2*Pk2*fd**2*r**2 - 13848*C*D1**2*Pk2*fd**2*r*s + 5440*C*D1**2*Pk2*fd**2*r - 14136*C*D1**2*Pk2*fd**2*s**2 + 14040*C*D1**2*Pk2*fd**2*s - 2308*C*D1**2*Pk2*fd**2 - 345*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 230*C*D1**2*Pkdd2*f*fd*k1**2*s - 115*C*D1**2*Pkdd2*f*fd*k1**2 + 105*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 70*C*D1**2*Pkdd2*f*fdd*k1**2*s + 35*C*D1**2*Pkdd2*f*fdd*k1**2 + 210*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 140*C*D1**2*Pkdd2*fd**2*k1**2*s + 2224*C*D1*Dd*Pk2*f**2*r**2 + 13712*C*D1*Dd*Pk2*f**2*r*s - 4540*C*D1*Dd*Pk2*f**2*r + 10064*C*D1*Dd*Pk2*f**2*s**2 - 8460*C*D1*Dd*Pk2*f**2*s + 3072*C*D1*Dd*Pk2*f**2 - 4944*C*D1*Dd*Pk2*f*fd*r**2 - 55392*C*D1*Dd*Pk2*f*fd*r*s + 19040*C*D1*Dd*Pk2*f*fd*r - 56544*C*D1*Dd*Pk2*f*fd*s**2 + 49140*C*D1*Dd*Pk2*f*fd*s - 9740*C*D1*Dd*Pk2*f*fd - 460*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 230*C*D1*Dd*Pkdd2*f**2*k1**2*s - 115*C*D1*Dd*Pkdd2*f**2*k1**2 + 840*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 490*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 70*C*D1*Dd*Pkdd2*f*fd*k1**2 - 824*C*D1*Ddd*Pk2*f**2*r**2 - 9232*C*D1*Ddd*Pk2*f**2*r*s + 2720*C*D1*Ddd*Pk2*f**2*r - 9424*C*D1*Ddd*Pk2*f**2*s**2 + 7020*C*D1*Ddd*Pk2*f**2*s - 2562*C*D1*Ddd*Pk2*f**2 + 140*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 70*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 35*C*D1*Ddd*Pkdd2*f**2*k1**2 - 2472*C*Dd**2*Pk2*f**2*r**2 - 27696*C*Dd**2*Pk2*f**2*r*s + 8160*C*Dd**2*Pk2*f**2*r - 28272*C*Dd**2*Pk2*f**2*s**2 + 21060*C*Dd**2*Pk2*f**2*s - 2308*C*Dd**2*Pk2*f**2 + 420*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 210*C*Dd**2*Pkdd2*f**2*k1**2*s - 2562*D1**2*Pk2*f*fd*r**2 - 8841*D1**2*Pk2*f*fd*r*s + 4655*D1**2*Pk2*f*fd*r - 1848*D1**2*Pk2*f*fd*s**2 + 4179*D1**2*Pk2*f*fd*s - 1470*D1**2*Pk2*f*fd + 1092*D1**2*Pk2*f*fdd*r**2 + 6081*D1**2*Pk2*f*fdd*r*s - 2755*D1**2*Pk2*f*fdd*r + 2328*D1**2*Pk2*f*fdd*s**2 - 3579*D1**2*Pk2*f*fdd*s + 1140*D1**2*Pk2*f*fdd + 2184*D1**2*Pk2*fd**2*r**2 + 12162*D1**2*Pk2*fd**2*r*s - 5510*D1**2*Pk2*fd**2*r + 4656*D1**2*Pk2*fd**2*s**2 - 7158*D1**2*Pk2*fd**2*s + 2027*D1**2*Pk2*fd**2 + 270*D1**2*Pkdd2*f*fd*k1**2*s**2 - 180*D1**2*Pkdd2*f*fd*k1**2*s + 90*D1**2*Pkdd2*f*fd*k1**2 + 42*D1**2*bd1**2*(Pk2*(C*(40*r*s - 20*r + 74*s**2 - 94*s + 20) - 46*r*s + 23*r - 74*s**2 + 97*s - 23) + Pkdd2*k1**2*s*(6 - 3*C)*(s - 1)) - 3*D1**2*bdd1*f*(Pk2*(2*C*(29*r**2 + 270*r*s + 74*r + 417*s**2 - 72*s - 136) - 100*r**2 - 369*r*s - 118*r - 102*s**2 + 27*s + 230) - 15*Pkdd2*k1**2*(C*(2*s - 1) + 2*(s - 1)**2)) - 3416*D1*Dd*Pk2*f**2*r**2 - 11788*D1*Dd*Pk2*f**2*r*s + 4655*D1*Dd*Pk2*f**2*r - 2464*D1*Dd*Pk2*f**2*s**2 + 4179*D1*Dd*Pk2*f**2*s - 1470*D1*Dd*Pk2*f**2 + 8736*D1*Dd*Pk2*f*fd*r**2 + 48648*D1*Dd*Pk2*f*fd*r*s - 19285*D1*Dd*Pk2*f*fd*r + 18624*D1*Dd*Pk2*f*fd*s**2 - 25053*D1*Dd*Pk2*f*fd*s + 6334*D1*Dd*Pk2*f*fd + 360*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 180*D1*Dd*Pkdd2*f**2*k1**2*s + 90*D1*Dd*Pkdd2*f**2*k1**2 + 1456*D1*Ddd*Pk2*f**2*r**2 + 8108*D1*Ddd*Pk2*f**2*r*s - 2755*D1*Ddd*Pk2*f**2*r + 3104*D1*Ddd*Pk2*f**2*s**2 - 3579*D1*Ddd*Pk2*f**2*s + 1140*D1*Ddd*Pk2*f**2 + 3*D1*bd1*(D1*(Pk2*f*(2*C*(86*r**2 + 2*r*(123*s + 88) + 435*s**2 - 228*s - 97) - 214*r**2 - r*(255*s + 376) + 6*s**2 + 327*s + 152) + Pk2*fd*(-4*C*(58*r**2 + r*(540*s - 127) + 834*s**2 - 588*s + 135) + 400*r**2 + 41*r*(36*s - 11) + 408*s**2 - 600*s + 369) - 3*Pkdd2*f*k1**2*(C*(7*s**2 + 20*s - 10) + 6*s**2 - 40*s + 20) + 30*Pkdd2*fd*k1**2*s*(C + 4*s - 4)) + Dd*f*(Pk2*(C*(-464*r**2 - 4320*r*s + 64*r - 6672*s**2 + 2784*s + 4) + 800*r**2 + 2952*r*s - 97*r + 816*s**2 - 681*s - 91) + 30*Pkdd2*k1**2*(4*s - 1)*(C + 2*s - 2))) + 4368*Dd**2*Pk2*f**2*r**2 + 24324*Dd**2*Pk2*f**2*r*s - 8265*Dd**2*Pk2*f**2*r + 9312*Dd**2*Pk2*f**2*s**2 - 10737*Dd**2*Pk2*f**2*s + 2027*Dd**2*Pk2*f**2))/(315*d**2*k3**2) + D1**2*Pk1*ct**4*k2**2*st**2*(-432*C*D1**2*Pk2*b1*f*fd*r**2 - 540*C*D1**2*Pk2*b1*f*fdd*r**2 - 540*C*D1**2*Pk2*b1*fd**2*r**2 - 96*C*D1**2*Pk2*f**2*fd*r**2 + 64*C*D1**2*Pk2*f**2*fd*r - 32*C*D1**2*Pk2*f**2*fd - 114*C*D1**2*Pk2*f**2*fdd*r**2 + 76*C*D1**2*Pk2*f**2*fdd*r - 38*C*D1**2*Pk2*f**2*fdd - 228*C*D1**2*Pk2*f*fd**2*r**2 + 152*C*D1**2*Pk2*f*fd**2*r - 252*C*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 126*C*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 576*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 792*C*D1**2*Pkdd2*b1*f*fd*k1**2*s + 396*C*D1**2*Pkdd2*b1*f*fd*k1**2 - 162*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 270*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 135*C*D1**2*Pkdd2*b1*f*fdd*k1**2 - 162*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 270*C*D1**2*Pkdd2*b1*fd**2*k1**2*s + 612*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 408*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 204*C*D1**2*Pkdd2*f**2*fd*k1**2 - 225*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 150*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 75*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 450*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 300*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 864*C*D1*Dd*Pk2*b1*f**2*r**2 + 432*C*D1*Dd*Pk2*b1*f**2*r - 216*C*D1*Dd*Pk2*b1*f**2 - 4320*C*D1*Dd*Pk2*b1*f*fd*r**2 + 1080*C*D1*Dd*Pk2*b1*f*fd*r - 128*C*D1*Dd*Pk2*f**3*r**2 + 64*C*D1*Dd*Pk2*f**3*r - 32*C*D1*Dd*Pk2*f**3 - 912*C*D1*Dd*Pk2*f**2*fd*r**2 + 532*C*D1*Dd*Pk2*f**2*fd*r - 76*C*D1*Dd*Pk2*f**2*fd - 1008*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 504*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 252*C*D1*Dd*Pkdd2*b1**2*f*k1**2 + 1008*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 252*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 1152*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 576*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 288*C*D1*Dd*Pkdd2*b1*f**2*k1**2 - 1296*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 1404*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 270*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 816*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 408*C*D1*Dd*Pkdd2*f**3*k1**2*s + 204*C*D1*Dd*Pkdd2*f**3*k1**2 - 1800*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 1050*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 150*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1080*C*D1*Ddd*Pk2*b1*f**2*r**2 + 540*C*D1*Ddd*Pk2*b1*f**2*r - 270*C*D1*Ddd*Pk2*b1*f**2 - 152*C*D1*Ddd*Pk2*f**3*r**2 + 76*C*D1*Ddd*Pk2*f**3*r - 38*C*D1*Ddd*Pk2*f**3 + 504*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 252*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 126*C*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 324*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 162*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 81*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 300*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 150*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 75*C*D1*Ddd*Pkdd2*f**3*k1**2 - 3240*C*Dd**2*Pk2*b1*f**2*r**2 + 1620*C*Dd**2*Pk2*b1*f**2*r - 456*C*Dd**2*Pk2*f**3*r**2 + 228*C*Dd**2*Pk2*f**3*r + 1512*C*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 756*C*Dd**2*Pkdd2*b1**2*f*k1**2*s - 972*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 486*C*Dd**2*Pkdd2*b1*f**2*k1**2*s - 900*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 450*C*Dd**2*Pkdd2*f**3*k1**2*s + 432*D1**2*Pk2*b1*f*fd*r**2 - 648*D1**2*Pk2*b1*f*fd*r*s + 324*D1**2*Pk2*b1*f*fd*r + 540*D1**2*Pk2*b1*f*fdd*r**2 - 180*D1**2*Pk2*b1*f*fdd*r*s + 90*D1**2*Pk2*b1*f*fdd*r + 540*D1**2*Pk2*b1*fd**2*r**2 - 180*D1**2*Pk2*b1*fd**2*r*s + 90*D1**2*Pk2*b1*fd**2*r + 96*D1**2*Pk2*f**2*fd*r**2 - 876*D1**2*Pk2*f**2*fd*r*s + 228*D1**2*Pk2*f**2*fd*r + 292*D1**2*Pk2*f**2*fd*s + 32*D1**2*Pk2*f**2*fd + 114*D1**2*Pk2*f**2*fdd*r**2 + 330*D1**2*Pk2*f**2*fdd*r*s - 186*D1**2*Pk2*f**2*fdd*r - 110*D1**2*Pk2*f**2*fdd*s + 38*D1**2*Pk2*f**2*fdd + 228*D1**2*Pk2*f*fd**2*r**2 + 660*D1**2*Pk2*f*fd**2*r*s - 372*D1**2*Pk2*f*fd**2*r - 220*D1**2*Pk2*f*fd**2*s + 110*D1**2*Pk2*f*fd**2 + 252*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 126*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 324*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 108*D1**2*Pkdd2*b1*f*fd*k1**2*s + 54*D1**2*Pkdd2*b1*f*fd*k1**2 - 288*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 180*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 90*D1**2*Pkdd2*b1*f*fdd*k1**2 - 288*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 180*D1**2*Pkdd2*b1*fd**2*k1**2*s + 252*D1**2*Pkdd2*bd1**2*f*k1**2*s*(C - 1)*(s - 1) + 138*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 92*D1**2*Pkdd2*f**2*fd*k1**2*s + 46*D1**2*Pkdd2*f**2*fd*k1**2 - 150*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 100*D1**2*Pkdd2*f**2*fdd*k1**2*s - 50*D1**2*Pkdd2*f**2*fdd*k1**2 - 300*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 200*D1**2*Pkdd2*f*fd**2*k1**2*s - 9*D1**2*bdd1*f*(10*Pk2*f*(r - 1)*(3*C*(r - 1) - 3*r + s + 3) - 14*Pkdd2*b1*k1**2*(C - 1)*(2*s**2 - 2*s + 1) + Pkdd2*f*k1**2*(3*C*(3*s**2 + 4*s - 2) + 16*s**2 - 12*s + 6)) + 864*D1*Dd*Pk2*b1*f**2*r**2 - 1296*D1*Dd*Pk2*b1*f**2*r*s - 108*D1*Dd*Pk2*b1*f**2*r + 324*D1*Dd*Pk2*b1*f**2*s + 216*D1*Dd*Pk2*b1*f**2 + 4320*D1*Dd*Pk2*b1*f*fd*r**2 - 1440*D1*Dd*Pk2*b1*f*fd*r*s - 540*D1*Dd*Pk2*b1*f*fd*r + 180*D1*Dd*Pk2*b1*f*fd*s - 90*D1*Dd*Pk2*b1*f*fd + 128*D1*Dd*Pk2*f**3*r**2 - 1168*D1*Dd*Pk2*f**3*r*s + 228*D1*Dd*Pk2*f**3*r + 292*D1*Dd*Pk2*f**3*s + 32*D1*Dd*Pk2*f**3 + 912*D1*Dd*Pk2*f**2*fd*r**2 + 2640*D1*Dd*Pk2*f**2*fd*r*s - 1302*D1*Dd*Pk2*f**2*fd*r - 770*D1*Dd*Pk2*f**2*fd*s + 296*D1*Dd*Pk2*f**2*fd + 1008*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 504*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 252*D1*Dd*Pkdd2*b1**2*f*k1**2 - 1008*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 252*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 648*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 324*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 162*D1*Dd*Pkdd2*b1*f**2*k1**2 - 2304*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 1296*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 180*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 184*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 92*D1*Dd*Pkdd2*f**3*k1**2*s + 46*D1*Dd*Pkdd2*f**3*k1**2 - 1200*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 700*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 100*D1*Dd*Pkdd2*f**2*fd*k1**2 + 1080*D1*Ddd*Pk2*b1*f**2*r**2 - 360*D1*Ddd*Pk2*b1*f**2*r*s - 450*D1*Ddd*Pk2*b1*f**2*r + 90*D1*Ddd*Pk2*b1*f**2*s + 270*D1*Ddd*Pk2*b1*f**2 + 152*D1*Ddd*Pk2*f**3*r**2 + 440*D1*Ddd*Pk2*f**3*r*s - 186*D1*Ddd*Pk2*f**3*r - 110*D1*Ddd*Pk2*f**3*s + 38*D1*Ddd*Pk2*f**3 - 504*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 252*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 126*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 576*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 288*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 144*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 200*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 100*D1*Ddd*Pkdd2*f**3*k1**2*s - 50*D1*Ddd*Pkdd2*f**3*k1**2 - 18*D1*bd1*(D1*(-14*Pkdd2*b1*fd*k1**2*s*(C - 1)*(2*s - 1) + f**2*(6*Pk2*(r - 1)*(2*C*(r - 1) - 2*r + 3*s + 2) - Pkdd2*k1**2*(2*C*(8*s**2 + 6*s - 3) + 9*s**2 - 12*s + 6)) + f*(5*Pk2*fd*(r**2*(12*C - 12) + r*(-12*C + 4*s + 11) - 2*s + 1) + 14*Pkdd2*b1*k1**2*(C - 1)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(3*C*(6*s - 1) + 32*s - 22))) + Dd*f*(5*Pk2*f*(6*C*(4*r**2 - 5*r + 1) - 24*r**2 + 8*r*s + 29*r - 5*s - 5) - 14*Pkdd2*b1*k1**2*(C - 1)*(8*s**2 - 6*s + 1) + Pkdd2*f*k1**2*(4*s - 1)*(C*(9*s + 6) + 16*s - 6))) + 3240*Dd**2*Pk2*b1*f**2*r**2 - 1080*Dd**2*Pk2*b1*f**2*r*s - 1350*Dd**2*Pk2*b1*f**2*r + 270*Dd**2*Pk2*b1*f**2*s - 90*Dd**2*Pk2*b1*f**2 + 456*Dd**2*Pk2*f**3*r**2 + 1320*Dd**2*Pk2*f**3*r*s - 558*Dd**2*Pk2*f**3*r - 330*Dd**2*Pk2*f**3*s + 110*Dd**2*Pk2*f**3 - 1512*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 756*Dd**2*Pkdd2*b1**2*f*k1**2*s - 1728*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 864*Dd**2*Pkdd2*b1*f**2*k1**2*s - 600*Dd**2*Pkdd2*f**3*k1**2*s**2 + 300*Dd**2*Pkdd2*f**3*k1**2*s)/(315*d**2*k1**2*k3**2) + D1**2*Pk1*ct**4*k2**2*(-21*b1**2*(D1**2*(Pk2*fd*r**2*(22*C - 22) + Pk2*fdd*r**2*(4*C - 4) - Pkdd2*fd*k1**2*s**2*(11*C + 1) + Pkdd2*fdd*k1**2*s**2*(3*C + 3)) + D1*(Dd*(Pk2*f*(22*C - 22)*(4*r**2 - 2*r + 1) + Pk2*fd*r*(8*C - 8)*(4*r - 1) - Pkdd2*f*k1**2*(11*C + 1)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(6*C + 6)*(4*s - 1)) + Ddd*f*(Pk2*(4*C - 4)*(4*r**2 - 2*r + 1) + Pkdd2*k1**2*(3*C + 3)*(4*s**2 - 2*s + 1))) + 6*Dd**2*f*(Pk2*r*(4*C - 4)*(2*r - 1) + Pkdd2*k1**2*s*(3*C + 3)*(2*s - 1))) - 3*b1*(152*C*D1**2*Pk2*f*fd*r**2 - 236*C*D1**2*Pk2*f*fd*r + 118*C*D1**2*Pk2*f*fd + 64*C*D1**2*Pk2*f*fdd*r**2 - 64*C*D1**2*Pk2*f*fdd*r + 32*C*D1**2*Pk2*f*fdd + 64*C*D1**2*Pk2*fd**2*r**2 - 64*C*D1**2*Pk2*fd**2*r - 60*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 42*C*D1**2*Pkdd2*f*fd*k1**2*s + 21*C*D1**2*Pkdd2*f*fd*k1**2 + 30*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 30*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 304*C*D1*Dd*Pk2*f**2*r**2 - 152*C*D1*Dd*Pk2*f**2*r + 76*C*D1*Dd*Pk2*f**2 + 512*C*D1*Dd*Pk2*f*fd*r**2 - 384*C*D1*Dd*Pk2*f*fd*r + 64*C*D1*Dd*Pk2*f*fd - 120*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 60*C*D1*Dd*Pkdd2*f**2*k1**2*s - 30*C*D1*Dd*Pkdd2*f**2*k1**2 + 240*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 60*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 128*C*D1*Ddd*Pk2*f**2*r**2 - 64*C*D1*Ddd*Pk2*f**2*r + 32*C*D1*Ddd*Pk2*f**2 + 60*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 30*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 15*C*D1*Ddd*Pkdd2*f**2*k1**2 + 384*C*Dd**2*Pk2*f**2*r**2 - 192*C*Dd**2*Pk2*f**2*r + 180*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 90*C*Dd**2*Pkdd2*f**2*k1**2*s - 224*D1**2*Pk2*f*fd*r**2 + 162*D1**2*Pk2*f*fd*r*s + 155*D1**2*Pk2*f*fd*r - 118*D1**2*Pk2*f*fd - 112*D1**2*Pk2*f*fdd*r**2 - 186*D1**2*Pk2*f*fdd*r*s + 157*D1**2*Pk2*f*fdd*r - 32*D1**2*Pk2*f*fdd - 112*D1**2*Pk2*fd**2*r**2 - 186*D1**2*Pk2*fd**2*r*s + 157*D1**2*Pk2*fd**2*r + 24*D1**2*Pkdd2*f*fd*k1**2*s**2 - 42*D1**2*Pkdd2*f*fd*k1**2*s + 21*D1**2*Pkdd2*f*fd*k1**2 + 30*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*fd**2*k1**2*s**2 + 7*D1**2*bdd1*f*(Pk2*(4*C - 4)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(3*C + 3)*(2*s**2 - 2*s + 1)) - 448*D1*Dd*Pk2*f**2*r**2 + 324*D1*Dd*Pk2*f**2*r*s + 143*D1*Dd*Pk2*f**2*r - 81*D1*Dd*Pk2*f**2*s - 112*D1*Dd*Pk2*f**2 - 896*D1*Dd*Pk2*f*fd*r**2 - 1488*D1*Dd*Pk2*f*fd*r*s + 1038*D1*Dd*Pk2*f*fd*r + 186*D1*Dd*Pk2*f*fd*s - 157*D1*Dd*Pk2*f*fd + 48*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 24*D1*Dd*Pkdd2*f**2*k1**2*s + 12*D1*Dd*Pkdd2*f**2*k1**2 + 240*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 60*D1*Dd*Pkdd2*f*fd*k1**2*s - 224*D1*Ddd*Pk2*f**2*r**2 - 372*D1*Ddd*Pk2*f**2*r*s + 205*D1*Ddd*Pk2*f**2*r + 93*D1*Ddd*Pk2*f**2*s - 56*D1*Ddd*Pk2*f**2 + 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 30*D1*Ddd*Pkdd2*f**2*k1**2*s + 15*D1*Ddd*Pkdd2*f**2*k1**2 + 7*D1*bd1*(D1*(Pk2*f*(22*C - 22)*(2*r**2 - 2*r + 1) + Pk2*fd*r*(8*C - 8)*(2*r - 1) - Pkdd2*f*k1**2*(11*C + 1)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(6*C + 6)*(2*s - 1)) + 2*Dd*f*(Pk2*(4*C - 4)*(8*r**2 - 6*r + 1) + Pkdd2*k1**2*(3*C + 3)*(8*s**2 - 6*s + 1))) - 672*Dd**2*Pk2*f**2*r**2 - 1116*Dd**2*Pk2*f**2*r*s + 615*Dd**2*Pk2*f**2*r + 279*Dd**2*Pk2*f**2*s - 93*Dd**2*Pk2*f**2 + 180*Dd**2*Pkdd2*f**2*k1**2*s**2 - 90*Dd**2*Pkdd2*f**2*k1**2*s) + f*(438*C*D1**2*Pk2*f*fd*r**2 - 292*C*D1**2*Pk2*f*fd*r + 146*C*D1**2*Pk2*f*fd + 132*C*D1**2*Pk2*f*fdd*r**2 - 88*C*D1**2*Pk2*f*fdd*r + 44*C*D1**2*Pk2*f*fdd + 264*C*D1**2*Pk2*fd**2*r**2 - 176*C*D1**2*Pk2*fd**2*r - 135*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 90*C*D1**2*Pkdd2*f*fd*k1**2*s - 45*C*D1**2*Pkdd2*f*fd*k1**2 + 584*C*D1*Dd*Pk2*f**2*r**2 - 292*C*D1*Dd*Pk2*f**2*r + 146*C*D1*Dd*Pk2*f**2 + 1056*C*D1*Dd*Pk2*f*fd*r**2 - 616*C*D1*Dd*Pk2*f*fd*r + 88*C*D1*Dd*Pk2*f*fd - 180*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 90*C*D1*Dd*Pkdd2*f**2*k1**2*s - 45*C*D1*Dd*Pkdd2*f**2*k1**2 + 176*C*D1*Ddd*Pk2*f**2*r**2 - 88*C*D1*Ddd*Pk2*f**2*r + 44*C*D1*Ddd*Pk2*f**2 + 528*C*Dd**2*Pk2*f**2*r**2 - 264*C*Dd**2*Pk2*f**2*r + 174*D1**2*Pk2*f*fd*r**2 - 3*D1**2*Pk2*f*fd*r*s - 115*D1**2*Pk2*f*fd*r + D1**2*Pk2*f*fd*s + 58*D1**2*Pk2*f*fd + 156*D1**2*Pk2*f*fdd*r**2 + 123*D1**2*Pk2*f*fdd*r*s - 145*D1**2*Pk2*f*fdd*r - 41*D1**2*Pk2*f*fdd*s + 52*D1**2*Pk2*f*fdd + 312*D1**2*Pk2*fd**2*r**2 + 246*D1**2*Pk2*fd**2*r*s - 290*D1**2*Pk2*fd**2*r - 82*D1**2*Pk2*fd**2*s + 41*D1**2*Pk2*fd**2 - 135*D1**2*Pkdd2*f*fd*k1**2*s**2 + 90*D1**2*Pkdd2*f*fd*k1**2*s - 45*D1**2*Pkdd2*f*fd*k1**2 - 42*D1**2*bd1**2*(Pk2*r*(4*C - 4)*(r - 1) + Pkdd2*k1**2*s*(3*C + 3)*(s - 1)) - 3*D1**2*bdd1*f*(Pk2*(r**2*(32*C - 56) + r*(48 - 93*s) + 93*s - 24) + Pkdd2*k1**2*(15*C + 15)*(s - 1)**2) + 232*D1*Dd*Pk2*f**2*r**2 - 4*D1*Dd*Pk2*f**2*r*s - 115*D1*Dd*Pk2*f**2*r + D1*Dd*Pk2*f**2*s + 58*D1*Dd*Pk2*f**2 + 1248*D1*Dd*Pk2*f*fd*r**2 + 984*D1*Dd*Pk2*f*fd*r*s - 1015*D1*Dd*Pk2*f*fd*r - 287*D1*Dd*Pk2*f*fd*s + 186*D1*Dd*Pk2*f*fd - 180*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 90*D1*Dd*Pkdd2*f**2*k1**2*s - 45*D1*Dd*Pkdd2*f**2*k1**2 + 208*D1*Ddd*Pk2*f**2*r**2 + 164*D1*Ddd*Pk2*f**2*r*s - 145*D1*Ddd*Pk2*f**2*r - 41*D1*Ddd*Pk2*f**2*s + 52*D1*Ddd*Pk2*f**2 - 3*D1*bd1*(D1*(Pk2*f*(C*(76*r**2 + 84*r - 42) - 112*r**2 + 81*r*s - 12*r - 81*s + 6) + Pk2*fd*(r**2*(128*C - 224) + r*(-64*C - 372*s + 253) + 186*s - 93) + 3*Pkdd2*f*k1**2*(C*(-10*s**2 + 34*s - 17) + 4*s**2 + 6*s - 3) + Pkdd2*fd*k1**2*s*(60*C + 60)*(s - 1)) + Dd*f*(Pk2*(r**2*(256*C - 448) + r*(-64*C - 744*s + 397) + 465*s - 141) + Pkdd2*k1**2*(30*C + 30)*(4*s**2 - 5*s + 1))) + 624*Dd**2*Pk2*f**2*r**2 + 492*Dd**2*Pk2*f**2*r*s - 435*Dd**2*Pk2*f**2*r - 123*Dd**2*Pk2*f**2*s + 41*Dd**2*Pk2*f**2))/(315*d**2*k1**2*k3**2) - D1**2*Pk1*ct**4*st**2*(-594*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 1320*D1**2*Pk2*bdd1*f**3*r*s - 1320*D1**2*Pk2*bdd1*f**3*s + 15200*D1**2*Pk2*f**3*fd*r*s - 3800*D1**2*Pk2*f**3*fd*r - 3800*D1**2*Pk2*f**3*fd*s - 12000*D1**2*Pk2*f**3*fdd*r*s + 3000*D1**2*Pk2*f**3*fdd*r + 3000*D1**2*Pk2*f**3*fdd*s - 36000*D1**2*Pk2*f**2*fd**2*r*s + 9000*D1**2*Pk2*f**2*fd**2*r + 9000*D1**2*Pk2*f**2*fd**2*s - 3000*D1**2*Pk2*f**2*fd**2 + 198*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(-14*K + 15*f + 14) + 2475*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 594*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 2772*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 8400*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 4200*D1**2*Pkdd2*f**3*fd*k1**2*s - 2100*D1**2*Pkdd2*f**3*fd*k1**2 + 4200*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 2100*D1**2*Pkdd2*f**3*fdd*k1**2*s + 1050*D1**2*Pkdd2*f**3*fdd*k1**2 + 12600*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 6300*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 2376*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 1188*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 4752*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 4752*D1**2*Pkdd2*f*fd*g2*k1**2*s - 2376*D1**2*Pkdd2*f*fd*g2*k1**2 + 4752*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 2376*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 2376*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 2376*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 1188*D1**2*Pkdd2*f*fdd*g2*k1**2 + 2376*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 2376*D1**2*Pkdd2*fd**2*g2*k1**2*s + 15200*D1*Dd*Pk2*f**4*r*s - 3800*D1*Dd*Pk2*f**4*r - 3800*D1*Dd*Pk2*f**4*s - 96000*D1*Dd*Pk2*f**3*fd*r*s + 24000*D1*Dd*Pk2*f**3*fd*r + 24000*D1*Dd*Pk2*f**3*fd*s - 6000*D1*Dd*Pk2*f**3*fd - 8400*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 4200*D1*Dd*Pkdd2*f**4*k1**2*s - 2100*D1*Dd*Pkdd2*f**4*k1**2 + 33600*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 16800*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 2100*D1*Dd*Pkdd2*f**3*fd*k1**2 - 9504*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 4752*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 2376*D1*Dd*Pkdd2*f**2*g2*k1**2 + 9504*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 2376*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 19008*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 14256*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 2376*D1*Dd*Pkdd2*f*fd*g2*k1**2 - 12000*D1*Ddd*Pk2*f**4*r*s + 3000*D1*Ddd*Pk2*f**4*r + 3000*D1*Ddd*Pk2*f**4*s + 4200*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 2100*D1*Ddd*Pkdd2*f**4*k1**2*s + 1050*D1*Ddd*Pkdd2*f**4*k1**2 + 4752*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 2376*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 1188*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 66*D1*bd1*(D1*(6*Pkdd2*f*k1**2*s*(3*fd*(2*s - 1)*(-K + 5*b1 + 1) + s*(14*b1*(K - 1) - 14*g2 + 14*gd2)) + 84*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) - 5*f**3*s*(-4*Pk2*(r - 1) + 15*Pkdd2*k1**2*s) + f**2*(20*Pk2*fd*(r*(6*s - 1) - 3*s + 1) + 75*Pkdd2*fd*k1**2*s*(3*s - 1) + Pkdd2*k1**2*s**2*(18*K - 90*b1 - 18))) + Dd*f*(18*Pkdd2*f*k1**2*s*(4*s - 1)*(-K + 5*b1 + 1) + Pkdd2*k1**2*s*(4*s - 1)*(-84*K*b1 + 84*b1 + 84*g2) + 5*f**2*(4*Pk2*(r*(8*s - 1) - 5*s + 1) + 15*Pkdd2*k1**2*s*(4*s - 1)))) - 36000*Dd**2*Pk2*f**4*r*s + 9000*Dd**2*Pk2*f**4*r + 9000*Dd**2*Pk2*f**4*s - 3000*Dd**2*Pk2*f**4 + 12600*Dd**2*Pkdd2*f**4*k1**2*s**2 - 6300*Dd**2*Pkdd2*f**4*k1**2*s + 14256*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 7128*Dd**2*Pkdd2*f**2*g2*k1**2*s - 99*Pkdd2*b1**2*k1**2*(D1**2*(30*f*fd*(2*s**2 - 2*s + 1) - 15*f*fdd*(2*s**2 - 2*s + 1) - 30*fd**2*s*(s - 1) - 28*fd*(K - 1)*(s - 1)**2 + 14*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(15*f**2*(4*s**2 - 2*s + 1) - 15*f*fd*(8*s**2 - 6*s + 1) - 14*f*(K - 1)*(4*s**2 - 2*s + 1) + 14*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-14*K + 15*f + 14)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-14*K + 15*f + 14)) + 33*b1*(2*D1*Dd*(-6*Pkdd2*f*k1**2*(3*fd*(K - 1)*(8*s**2 - 6*s + 1) + 14*g2*(4*s**2 - 2*s + 1) + 14*gd2*s*(1 - 4*s)) + 84*Pkdd2*fd*g2*k1**2*(4*s**2 - 5*s + 1) - 5*f**3*(4*Pk2*(-4*r*s + r + s) + 15*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(20*Pk2*fd*(r*(24*s - 7) - 3*s + 1) + 75*Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1) + Pkdd2*k1**2*(18*K - 18)*(4*s**2 - 2*s + 1))) + D1*(D1*(-12*Pkdd2*k1**2*(s - 1)*(3*fd**2*s*(K - 1) + 14*fd*(g2*(s - 1) - gd2*s) - 7*fdd*g2*(s - 1)) - 5*f**2*(8*Pk2*fd*r*(1 - 3*s) + 8*Pk2*fdd*r*(1 - 3*s) - 18*Pkdd2*bdd1*k1**2*s**2 + 30*Pkdd2*fd*k1**2*(3*s**2 - 2*s + 1) - 15*Pkdd2*fdd*k1**2*(3*s**2 - 2*s + 1)) + 2*f*(18*Pkdd2*fd*k1**2*(K - 1)*(2*s**2 - 2*s + 1) - 3*Pkdd2*k1**2*(3*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(14*bdd1*(K - 1) + 28*gd2 - 14*gdd2)) + 5*fd**2*(8*Pk2*r*(3*s - 1) + 15*Pkdd2*k1**2*s*(3*s - 2)))) + Ddd*f*(-18*Pkdd2*f*k1**2*(K - 1)*(4*s**2 - 2*s + 1) + 84*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 5*f**2*(8*Pk2*r*(4*s - 1) - 8*Pk2*s + 15*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 2*Dd**2*f*(-54*Pkdd2*f*k1**2*s*(K - 1)*(2*s - 1) + 252*Pkdd2*g2*k1**2*s*(2*s - 1) + 5*f**2*(4*Pk2*(12*r*s - 3*r - 3*s + 1) + 45*Pkdd2*k1**2*s*(2*s - 1)))))/(6930*d**2*k1**2) + D1**2*Pk1*ct**4*(-1056*D1**2*K*Pk2*bdd1*f**2*r**2 - 495*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 1452*D1**2*Pk2*bdd1*f**3*r**2 + 2530*D1**2*Pk2*bdd1*f**3*r*s - 1716*D1**2*Pk2*bdd1*f**3*r - 2970*D1**2*Pk2*bdd1*f**3*s + 968*D1**2*Pk2*bdd1*f**3 + 1056*D1**2*Pk2*bdd1*f**2*r**2 - 396*D1**2*Pk2*bdd1*f**2*r*s + 1848*D1**2*Pk2*bdd1*f*g2*r**2 - 3696*D1**2*Pk2*bdd1*f*g2*r + 1848*D1**2*Pk2*bdd1*f*g2 + 8320*D1**2*Pk2*f**3*fd*r**2 - 2200*D1**2*Pk2*f**3*fd*r*s - 3610*D1**2*Pk2*f**3*fd*r + 550*D1**2*Pk2*f**3*fd*s + 2080*D1**2*Pk2*f**3*fd + 2880*D1**2*Pk2*f**3*fdd*r**2 + 2200*D1**2*Pk2*f**3*fdd*r*s - 1990*D1**2*Pk2*f**3*fdd*r - 550*D1**2*Pk2*f**3*fdd*s + 720*D1**2*Pk2*f**3*fdd + 8640*D1**2*Pk2*f**2*fd**2*r**2 + 6600*D1**2*Pk2*f**2*fd**2*r*s - 5970*D1**2*Pk2*f**2*fd**2*r - 1650*D1**2*Pk2*f**2*fd**2*s + 550*D1**2*Pk2*f**2*fd**2 + 7788*D1**2*Pk2*f**2*gd2*r**2 + 2112*D1**2*Pk2*f**2*gdd2*r**2 + 15576*D1**2*Pk2*f*fd*g2*r**2 - 15576*D1**2*Pk2*f*fd*g2*r + 7788*D1**2*Pk2*f*fd*g2 + 8448*D1**2*Pk2*f*fd*gd2*r**2 - 4224*D1**2*Pk2*f*fd*gd2*r + 4224*D1**2*Pk2*f*fdd*g2*r**2 - 4224*D1**2*Pk2*f*fdd*g2*r + 2112*D1**2*Pk2*f*fdd*g2 + 4224*D1**2*Pk2*fd**2*g2*r**2 - 4224*D1**2*Pk2*fd**2*g2*r - 693*D1**2*Pkdd2*b2*bdd1*f*k1**2*s**2 + 1980*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 - 1980*D1**2*Pkdd2*b2*f*fd*k1**2*s + 990*D1**2*Pkdd2*b2*f*fd*k1**2 - 990*D1**2*Pkdd2*b2*f*fdd*k1**2*s**2 + 990*D1**2*Pkdd2*b2*f*fdd*k1**2*s - 495*D1**2*Pkdd2*b2*f*fdd*k1**2 - 990*D1**2*Pkdd2*b2*fd**2*k1**2*s**2 + 990*D1**2*Pkdd2*b2*fd**2*k1**2*s + 990*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 - 1980*D1**2*Pkdd2*bd2*f*fd*k1**2*s**2 + 990*D1**2*Pkdd2*bd2*f*fd*k1**2*s - 1155*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 1540*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 770*D1**2*Pkdd2*bdd1*f**3*k1**2 - 495*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 2772*D1**2*Pkdd2*bdd1*f*g2*k1**2*s - 1386*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 495*D1**2*Pkdd2*bdd2*f**2*k1**2*s**2 - 3080*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 1540*D1**2*Pkdd2*f**3*fd*k1**2*s - 770*D1**2*Pkdd2*f**3*fd*k1**2 - 3366*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 990*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 6732*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 6732*D1**2*Pkdd2*f*fd*g2*k1**2*s - 3366*D1**2*Pkdd2*f*fd*g2*k1**2 + 3960*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 1980*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 1980*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 1980*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 990*D1**2*Pkdd2*f*fdd*g2*k1**2 + 1980*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 1980*D1**2*Pkdd2*fd**2*g2*k1**2*s - 66*D1**2*bd1**2*(70*Pkdd2*g2*k1**2*s*(s - 1) + 3*f**2*(6*Pk2*(4*r*s - r - 2*s + 1) + 5*Pkdd2*k1**2*s*(4*s - 3)) + 7*f*(2*Pk2*(r**2*(2*K - 2) + r*(-2*K + 6*s + 2) - 3*s) + 3*Pkdd2*k1**2*s*(K + 2*s - 1))) + 8320*D1*Dd*Pk2*f**4*r**2 - 2200*D1*Dd*Pk2*f**4*r*s - 3610*D1*Dd*Pk2*f**4*r + 550*D1*Dd*Pk2*f**4*s + 2080*D1*Dd*Pk2*f**4 + 23040*D1*Dd*Pk2*f**3*fd*r**2 + 17600*D1*Dd*Pk2*f**3*fd*r*s - 15920*D1*Dd*Pk2*f**3*fd*r - 4400*D1*Dd*Pk2*f**3*fd*s + 2540*D1*Dd*Pk2*f**3*fd + 31152*D1*Dd*Pk2*f**2*g2*r**2 - 15576*D1*Dd*Pk2*f**2*g2*r + 7788*D1*Dd*Pk2*f**2*g2 + 16896*D1*Dd*Pk2*f**2*gd2*r**2 - 4224*D1*Dd*Pk2*f**2*gd2*r + 33792*D1*Dd*Pk2*f*fd*g2*r**2 - 25344*D1*Dd*Pk2*f*fd*g2*r + 4224*D1*Dd*Pk2*f*fd*g2 + 3960*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 - 1980*D1*Dd*Pkdd2*b2*f**2*k1**2*s + 990*D1*Dd*Pkdd2*b2*f**2*k1**2 - 7920*D1*Dd*Pkdd2*b2*f*fd*k1**2*s**2 + 5940*D1*Dd*Pkdd2*b2*f*fd*k1**2*s - 990*D1*Dd*Pkdd2*b2*f*fd*k1**2 - 3960*D1*Dd*Pkdd2*bd2*f**2*k1**2*s**2 + 990*D1*Dd*Pkdd2*bd2*f**2*k1**2*s - 3080*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 1540*D1*Dd*Pkdd2*f**4*k1**2*s - 770*D1*Dd*Pkdd2*f**4*k1**2 - 13464*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 6732*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 3366*D1*Dd*Pkdd2*f**2*g2*k1**2 + 7920*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 1980*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 15840*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 11880*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 1980*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 2880*D1*Ddd*Pk2*f**4*r**2 + 2200*D1*Ddd*Pk2*f**4*r*s - 1990*D1*Ddd*Pk2*f**4*r - 550*D1*Ddd*Pk2*f**4*s + 720*D1*Ddd*Pk2*f**4 + 8448*D1*Ddd*Pk2*f**2*g2*r**2 - 4224*D1*Ddd*Pk2*f**2*g2*r + 2112*D1*Ddd*Pk2*f**2*g2 - 1980*D1*Ddd*Pkdd2*b2*f**2*k1**2*s**2 + 990*D1*Ddd*Pkdd2*b2*f**2*k1**2*s - 495*D1*Ddd*Pkdd2*b2*f**2*k1**2 + 3960*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 1980*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 990*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 11*D1*bd1*(D1*(f**3*(2*Pk2*(84*r**2 - r*(275*s + 42) + 135*s + 56) + 5*Pkdd2*k1**2*(15*s**2 - 56*s + 28)) + f**2*(-6*Pk2*r*(r*(59*K - 59) + 72*s) + Pkdd2*k1**2*s**2*(153*K + 27) + 2*fd*(Pk2*(396*r**2 + 690*r*s - 403*r - 385*s + 125) + 35*Pkdd2*k1**2*s*(7 - 9*s))) + 6*f*(Pk2*fd*(r**2*(64 - 64*K) + r*(32*K - 24*s - 26) + 6*s) + 56*Pk2*gd2*r*(r - 1) - 15*Pkdd2*fd*k1**2*s*(K + 1)*(2*s - 1) + 42*Pkdd2*gd2*k1**2*s + Pkdd2*k1**2*s**2*(21*b2 - 21*bd2) + 7*g2*(22*Pk2*(r - 1)**2 + Pkdd2*k1**2*(-5*s**2 - 12*s + 6))) + 42*fd*(8*Pk2*g2*r*(r - 1) - 3*Pkdd2*b2*k1**2*s*(s - 1))) + 2*Dd*f*(168*Pk2*g2*(4*r**2 - 5*r + 1) + 63*Pkdd2*b2*k1**2*s*(1 - 4*s) + 126*Pkdd2*g2*k1**2*(4*s - 1) + f**2*(Pk2*(528*r**2 + r*(920*s - 559) - 655*s + 213) - 35*Pkdd2*k1**2*(12*s**2 - 11*s + 2)) - 3*f*(2*Pk2*(r**2*(64*K - 64) + r*(-16*K + 24*s + 13) - 3*s) + Pkdd2*k1**2*s*(15*K + 15)*(4*s - 1)))) + 8640*Dd**2*Pk2*f**4*r**2 + 6600*Dd**2*Pk2*f**4*r*s - 5970*Dd**2*Pk2*f**4*r - 1650*Dd**2*Pk2*f**4*s + 550*Dd**2*Pk2*f**4 + 25344*Dd**2*Pk2*f**2*g2*r**2 - 12672*Dd**2*Pk2*f**2*g2*r - 5940*Dd**2*Pkdd2*b2*f**2*k1**2*s**2 + 2970*Dd**2*Pkdd2*b2*f**2*k1**2*s + 11880*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 5940*Dd**2*Pkdd2*f**2*g2*k1**2*s + 231*Pkdd2*b1**3*k1**2*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-5*K*(4*s**2 - 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s + 20*s**2 - 10*s + 5) - D1*Ddd*(-5*K + 3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-5*K + 3*f + 5)) - 33*b1**2*(D1**2*(154*K*Pk2*fd*r**2 + 28*K*Pk2*fdd*r**2 - 35*K*Pkdd2*fd*k1**2*s**2 + 154*K*Pkdd2*fd*k1**2*s - 77*K*Pkdd2*fd*k1**2 - 42*K*Pkdd2*fdd*k1**2*s + 21*K*Pkdd2*fdd*k1**2 + 48*Pk2*f*fd*r*s - 12*Pk2*f*fd*r + 144*Pk2*f*fdd*r*s - 36*Pk2*f*fdd*r + 144*Pk2*fd**2*r*s - 36*Pk2*fd**2*r - 154*Pk2*fd*r**2 + 112*Pk2*fd*r*s - 112*Pk2*fd*r - 28*Pk2*fdd*r**2 + 84*Pk2*fdd*r*s - 84*Pk2*fdd*r - 14*Pkdd2*bd1*k1**2*(-5*K*(3*s**2 - 2*s + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s + 15*s**2 - 10*s + 5) + 7*Pkdd2*bdd1*k1**2*(-5*K + 3*f + 5)*(3*s**2 - 2*s + 1) - 198*Pkdd2*f*fd*k1**2*s**2 + 18*Pkdd2*f*fd*k1**2*s - 9*Pkdd2*f*fd*k1**2 + 120*Pkdd2*f*fdd*k1**2*s**2 - 30*Pkdd2*f*fdd*k1**2*s + 15*Pkdd2*f*fdd*k1**2 + 120*Pkdd2*fd**2*k1**2*s**2 - 30*Pkdd2*fd**2*k1**2*s - 49*Pkdd2*fd*k1**2*s**2 + 14*Pkdd2*fd*k1**2*s - 7*Pkdd2*fd*k1**2 + 42*Pkdd2*fdd*k1**2*s**2 - 42*Pkdd2*fdd*k1**2*s + 21*Pkdd2*fdd*k1**2 - 140*Pkdd2*gd2*k1**2*s**2 + 70*Pkdd2*gdd2*k1**2*s**2) + D1*(Dd*(-70*Pkdd2*k1**2*(bd1*(K - 1)*(12*s**2 - 7*s + 1) + 2*g2*(4*s**2 - 2*s + 1) + 2*gd2*s*(1 - 4*s)) - 3*f**2*(8*Pk2*(-4*r*s + r + s) + 33*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(2*Pk2*(77*K*(4*r**2 - 2*r + 1) + 18*fd*(8*r - 1)*(4*s - 1) - 308*r**2 + 224*r*s + 98*r - 56*s - 77) + Pkdd2*k1**2*(42*bd1*(12*s**2 - 7*s + 1) + 30*fd*(32*s**2 - 12*s + 1) + (-35*K - 49)*(4*s**2 - 2*s + 1))) - 14*fd*(Pk2*(r**2*(16 - 16*K) + r*(4*K - 48*s + 26) + 6*s - 6) + 3*Pkdd2*k1**2*(4*s - 1)*(K - 2*s + 1))) + 2*Ddd*(35*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 6*f**2*(6*Pk2*r*(4*s - 1) - 6*Pk2*s + 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 7*f*(2*Pk2*(4*K*r**2 - 2*K*r + K - 4*r**2 + 12*r*s - r - 3*s - 1) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 12*Dd**2*(35*Pkdd2*g2*k1**2*s*(2*s - 1) + 6*f**2*(3*Pk2*r*(4*s - 1) - 3*Pk2*s + Pk2 + 5*Pkdd2*k1**2*s*(2*s - 1)) + 7*f*(Pk2*(r**2*(4*K - 4) + r*(-2*K + 12*s - 1) - 3*s + 1) + 3*Pkdd2*k1**2*s*(2*s - 1)))) - 11*b1*(708*D1**2*K*Pk2*f*fd*r**2 - 708*D1**2*K*Pk2*f*fd*r + 354*D1**2*K*Pk2*f*fd + 192*D1**2*K*Pk2*f*fdd*r**2 - 192*D1**2*K*Pk2*f*fdd*r + 96*D1**2*K*Pk2*f*fdd + 192*D1**2*K*Pk2*fd**2*r**2 - 192*D1**2*K*Pk2*fd**2*r - 306*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 306*D1**2*K*Pkdd2*f*fd*k1**2*s - 153*D1**2*K*Pkdd2*f*fd*k1**2 + 90*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 90*D1**2*K*Pkdd2*f*fdd*k1**2*s + 45*D1**2*K*Pkdd2*f*fdd*k1**2 + 90*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 90*D1**2*K*Pkdd2*fd**2*k1**2*s - 504*D1**2*Pk2*f**2*fd*r**2 + 1650*D1**2*Pk2*f**2*fd*r*s - 298*D1**2*Pk2*f**2*fd*r - 280*D1**2*Pk2*f**2*fd*s - 56*D1**2*Pk2*f**2*fd - 396*D1**2*Pk2*f**2*fdd*r**2 - 690*D1**2*Pk2*f**2*fdd*r*s + 338*D1**2*Pk2*f**2*fdd*r - 40*D1**2*Pk2*f**2*fdd*s - 44*D1**2*Pk2*f**2*fdd - 792*D1**2*Pk2*f*fd**2*r**2 - 1380*D1**2*Pk2*f*fd**2*r*s + 676*D1**2*Pk2*f*fd**2*r - 80*D1**2*Pk2*f*fd**2*s + 20*D1**2*Pk2*f*fd**2 - 708*D1**2*Pk2*f*fd*r**2 + 864*D1**2*Pk2*f*fd*r*s + 276*D1**2*Pk2*f*fd*r - 432*D1**2*Pk2*f*fd*s - 354*D1**2*Pk2*f*fd - 192*D1**2*Pk2*f*fdd*r**2 + 72*D1**2*Pk2*f*fdd*r*s + 156*D1**2*Pk2*f*fdd*r - 36*D1**2*Pk2*f*fdd*s - 96*D1**2*Pk2*f*fdd - 924*D1**2*Pk2*f*gd2*r**2 - 168*D1**2*Pk2*f*gdd2*r**2 - 192*D1**2*Pk2*fd**2*r**2 + 72*D1**2*Pk2*fd**2*r*s + 156*D1**2*Pk2*fd**2*r - 36*D1**2*Pk2*fd**2*s + 36*D1**2*Pk2*fd**2 - 924*D1**2*Pk2*fd*g2*r**2 - 336*D1**2*Pk2*fd*gd2*r**2 - 168*D1**2*Pk2*fdd*g2*r**2 - 126*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 252*D1**2*Pkdd2*b2*fd*k1**2*s - 126*D1**2*Pkdd2*b2*fd*k1**2 + 63*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 126*D1**2*Pkdd2*b2*fdd*k1**2*s + 63*D1**2*Pkdd2*b2*fdd*k1**2 + 42*D1**2*Pkdd2*bd1**2*k1**2*s*(3*s - 2)*(-5*K + 3*f + 5) - 126*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 126*D1**2*Pkdd2*bd2*fd*k1**2*s**2 - 126*D1**2*Pkdd2*bd2*fd*k1**2*s + 63*D1**2*Pkdd2*bdd2*f*k1**2*s**2 - 225*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 130*D1**2*Pkdd2*f**2*fd*k1**2*s + 65*D1**2*Pkdd2*f**2*fd*k1**2 + 315*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 70*D1**2*Pkdd2*f**2*fdd*k1**2*s + 35*D1**2*Pkdd2*f**2*fdd*k1**2 + 630*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 140*D1**2*Pkdd2*f*fd**2*k1**2*s - 54*D1**2*Pkdd2*f*fd*k1**2*s**2 + 54*D1**2*Pkdd2*f*fd*k1**2*s - 27*D1**2*Pkdd2*f*fd*k1**2 + 90*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 90*D1**2*Pkdd2*f*fdd*k1**2*s + 45*D1**2*Pkdd2*f*fdd*k1**2 + 210*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 90*D1**2*Pkdd2*fd**2*k1**2*s**2 - 90*D1**2*Pkdd2*fd**2*k1**2*s + 210*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 924*D1**2*Pkdd2*fd*g2*k1**2*s + 462*D1**2*Pkdd2*fd*g2*k1**2 + 252*D1**2*Pkdd2*fd*gd2*k1**2*s + 252*D1**2*Pkdd2*fdd*g2*k1**2*s - 126*D1**2*Pkdd2*fdd*g2*k1**2 + 3*D1**2*bdd1*(70*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 3*f**2*(12*Pk2*(4*r*s - r - 2*s) + 5*Pkdd2*k1**2*(8*s**2 - 6*s + 3)) + 7*f*(4*Pk2*(2*K*r**2 - 2*K*r + K - 2*r**2 + 6*r*s + 2*r - 3*s - 1) + 3*Pkdd2*k1**2*(2*K*s - K + 4*s**2 - 2*s + 1))) + 1416*D1*Dd*K*Pk2*f**2*r**2 - 708*D1*Dd*K*Pk2*f**2*r + 354*D1*Dd*K*Pk2*f**2 + 1536*D1*Dd*K*Pk2*f*fd*r**2 - 1152*D1*Dd*K*Pk2*f*fd*r + 192*D1*Dd*K*Pk2*f*fd - 612*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 306*D1*Dd*K*Pkdd2*f**2*k1**2*s - 153*D1*Dd*K*Pkdd2*f**2*k1**2 + 720*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 540*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 90*D1*Dd*K*Pkdd2*f*fd*k1**2 - 672*D1*Dd*Pk2*f**3*r**2 + 2200*D1*Dd*Pk2*f**3*r*s - 214*D1*Dd*Pk2*f**3*r - 550*D1*Dd*Pk2*f**3*s - 168*D1*Dd*Pk2*f**3 - 3168*D1*Dd*Pk2*f**2*fd*r**2 - 5520*D1*Dd*Pk2*f**2*fd*r*s + 2834*D1*Dd*Pk2*f**2*fd*r + 530*D1*Dd*Pk2*f**2*fd*s - 298*D1*Dd*Pk2*f**2*fd - 1416*D1*Dd*Pk2*f**2*r**2 + 1728*D1*Dd*Pk2*f**2*r*s + 276*D1*Dd*Pk2*f**2*r - 432*D1*Dd*Pk2*f**2*s - 354*D1*Dd*Pk2*f**2 - 1536*D1*Dd*Pk2*f*fd*r**2 + 576*D1*Dd*Pk2*f*fd*r*s + 936*D1*Dd*Pk2*f*fd*r - 216*D1*Dd*Pk2*f*fd*s - 120*D1*Dd*Pk2*f*fd - 3696*D1*Dd*Pk2*f*g2*r**2 + 1848*D1*Dd*Pk2*f*g2*r - 924*D1*Dd*Pk2*f*g2 - 1344*D1*Dd*Pk2*f*gd2*r**2 + 336*D1*Dd*Pk2*f*gd2*r - 1344*D1*Dd*Pk2*fd*g2*r**2 + 336*D1*Dd*Pk2*fd*g2*r - 504*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 252*D1*Dd*Pkdd2*b2*f*k1**2*s - 126*D1*Dd*Pkdd2*b2*f*k1**2 + 504*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 630*D1*Dd*Pkdd2*b2*fd*k1**2*s + 126*D1*Dd*Pkdd2*b2*fd*k1**2 + 504*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 126*D1*Dd*Pkdd2*bd2*f*k1**2*s - 300*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 150*D1*Dd*Pkdd2*f**3*k1**2*s - 75*D1*Dd*Pkdd2*f**3*k1**2 + 2520*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 910*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 70*D1*Dd*Pkdd2*f**2*fd*k1**2 - 108*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 54*D1*Dd*Pkdd2*f**2*k1**2*s - 27*D1*Dd*Pkdd2*f**2*k1**2 + 720*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 540*D1*Dd*Pkdd2*f*fd*k1**2*s + 90*D1*Dd*Pkdd2*f*fd*k1**2 + 840*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 420*D1*Dd*Pkdd2*f*g2*k1**2*s + 210*D1*Dd*Pkdd2*f*g2*k1**2 + 1008*D1*Dd*Pkdd2*fd*g2*k1**2*s - 252*D1*Dd*Pkdd2*fd*g2*k1**2 + 384*D1*Ddd*K*Pk2*f**2*r**2 - 192*D1*Ddd*K*Pk2*f**2*r + 96*D1*Ddd*K*Pk2*f**2 + 180*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 90*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 45*D1*Ddd*K*Pkdd2*f**2*k1**2 - 528*D1*Ddd*Pk2*f**3*r**2 - 920*D1*Ddd*Pk2*f**3*r*s + 494*D1*Ddd*Pk2*f**3*r + 230*D1*Ddd*Pk2*f**3*s - 132*D1*Ddd*Pk2*f**3 - 384*D1*Ddd*Pk2*f**2*r**2 + 144*D1*Ddd*Pk2*f**2*r*s + 156*D1*Ddd*Pk2*f**2*r - 36*D1*Ddd*Pk2*f**2*s - 96*D1*Ddd*Pk2*f**2 - 672*D1*Ddd*Pk2*f*g2*r**2 + 336*D1*Ddd*Pk2*f*g2*r - 168*D1*Ddd*Pk2*f*g2 + 252*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 126*D1*Ddd*Pkdd2*b2*f*k1**2*s + 63*D1*Ddd*Pkdd2*b2*f*k1**2 + 420*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 210*D1*Ddd*Pkdd2*f**3*k1**2*s + 105*D1*Ddd*Pkdd2*f**3*k1**2 + 180*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 90*D1*Ddd*Pkdd2*f**2*k1**2*s + 45*D1*Ddd*Pkdd2*f**2*k1**2 + 6*D1*bd1*(D1*(-6*Pk2*f**2*(-4*r*s + r + 2*s) + Pk2*f*(77*K*(2*r**2 - 2*r + 1) + 18*fd*(4*r - 1)*(4*s - 1) - 154*r**2 + 112*r*s + 154*r - 56*s - 77) - 9*Pkdd2*f**2*k1**2*(11*s**2 - 10*s + 5) - Pkdd2*f*k1**2*(7*K*(5*s**2 + 6*s - 3) + s**2*(49 - 240*fd) + s*(120*fd - 42) + 21) - 70*Pkdd2*k1**2*(g2*(2*s**2 - 2*s + 1) + gd2*s*(1 - 2*s)) - 7*fd*(Pk2*(r**2*(8 - 8*K) + 4*r*(K - 6*s + 2) + 6*s - 6) + 3*Pkdd2*k1**2*s*(K - 4*s + 3))) + Dd*(70*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) + 3*f**2*(4*s - 1)*(6*Pk2*(8*r - 3) + 5*Pkdd2*k1**2*(8*s - 3)) + 7*f*(2*Pk2*(2*K*(8*r**2 - 6*r + 1) - 16*r**2 + 48*r*s + 6*r - 18*s + 1) + 3*Pkdd2*k1**2*(4*s - 1)*(K + 4*s - 1)))) + 1152*Dd**2*K*Pk2*f**2*r**2 - 576*Dd**2*K*Pk2*f**2*r + 540*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 270*Dd**2*K*Pkdd2*f**2*k1**2*s - 1584*Dd**2*Pk2*f**3*r**2 - 2760*Dd**2*Pk2*f**3*r*s + 1482*Dd**2*Pk2*f**3*r + 690*Dd**2*Pk2*f**3*s - 230*Dd**2*Pk2*f**3 - 1152*Dd**2*Pk2*f**2*r**2 + 432*Dd**2*Pk2*f**2*r*s + 468*Dd**2*Pk2*f**2*r - 108*Dd**2*Pk2*f**2*s + 36*Dd**2*Pk2*f**2 - 2016*Dd**2*Pk2*f*g2*r**2 + 1008*Dd**2*Pk2*f*g2*r + 756*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 378*Dd**2*Pkdd2*b2*f*k1**2*s + 1260*Dd**2*Pkdd2*f**3*k1**2*s**2 - 630*Dd**2*Pkdd2*f**3*k1**2*s + 540*Dd**2*Pkdd2*f**2*k1**2*s**2 - 270*Dd**2*Pkdd2*f**2*k1**2*s))/(6930*d**2*k1**2) + D1**2*Pk1*ct**3*k1*st**2*(-504*Pk2*b1**2*(2*C - 3)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 3*b1*(-1472*C*D1**2*Pk2*f*fd*r*s + 736*C*D1**2*Pk2*f*fd*r - 6000*C*D1**2*Pk2*f*fd*s**2 + 6576*C*D1**2*Pk2*f*fd*s - 3288*C*D1**2*Pk2*f*fd + 960*C*D1**2*Pk2*f*fdd*r*s - 480*C*D1**2*Pk2*f*fdd*r + 4176*C*D1**2*Pk2*f*fdd*s**2 - 4464*C*D1**2*Pk2*f*fdd*s + 2232*C*D1**2*Pk2*f*fdd + 960*C*D1**2*Pk2*fd**2*r*s - 480*C*D1**2*Pk2*fd**2*r + 4176*C*D1**2*Pk2*fd**2*s**2 - 4464*C*D1**2*Pk2*fd**2*s - 2944*C*D1*Dd*Pk2*f**2*r*s + 736*C*D1*Dd*Pk2*f**2*r - 12000*C*D1*Dd*Pk2*f**2*s**2 + 6736*C*D1*Dd*Pk2*f**2*s - 3000*C*D1*Dd*Pk2*f**2 + 7680*C*D1*Dd*Pk2*f*fd*r*s - 2880*C*D1*Dd*Pk2*f*fd*r + 33408*C*D1*Dd*Pk2*f*fd*s**2 - 27168*C*D1*Dd*Pk2*f*fd*s + 4944*C*D1*Dd*Pk2*f*fd + 1920*C*D1*Ddd*Pk2*f**2*r*s - 480*C*D1*Ddd*Pk2*f**2*r + 8352*C*D1*Ddd*Pk2*f**2*s**2 - 4656*C*D1*Ddd*Pk2*f**2*s + 2088*C*D1*Ddd*Pk2*f**2 + 5760*C*Dd**2*Pk2*f**2*r*s - 1440*C*Dd**2*Pk2*f**2*r + 25056*C*Dd**2*Pk2*f**2*s**2 - 13968*C*Dd**2*Pk2*f**2*s + 480*C*Dd**2*Pk2*f**2 - 168*D1**2*Pk2*bdd1*f*(2*C - 3)*(2*s**2 - 2*s + 1) + 3104*D1**2*Pk2*f*fd*r*s - 1552*D1**2*Pk2*f*fd*r + 5832*D1**2*Pk2*f*fd*s**2 - 6696*D1**2*Pk2*f*fd*s + 3348*D1**2*Pk2*f*fd - 2112*D1**2*Pk2*f*fdd*r*s + 1056*D1**2*Pk2*f*fdd*r - 4680*D1**2*Pk2*f*fdd*s**2 + 5112*D1**2*Pk2*f*fdd*s - 2556*D1**2*Pk2*f*fdd - 2112*D1**2*Pk2*fd**2*r*s + 1056*D1**2*Pk2*fd**2*r - 4680*D1**2*Pk2*fd**2*s**2 + 5112*D1**2*Pk2*fd**2*s - 36*D1**2*Pkdd2*f*fd*k1**2*s**2 + 36*D1**2*Pkdd2*f*fd*k1**2*s - 18*D1**2*Pkdd2*f*fd*k1**2 + 18*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 18*D1**2*Pkdd2*f*fdd*k1**2*s + 9*D1**2*Pkdd2*f*fdd*k1**2 + 18*D1**2*Pkdd2*fd**2*k1**2*s**2 - 18*D1**2*Pkdd2*fd**2*k1**2*s + 6208*D1*Dd*Pk2*f**2*r*s - 1552*D1*Dd*Pk2*f**2*r + 11664*D1*Dd*Pk2*f**2*s**2 - 7384*D1*Dd*Pk2*f**2*s + 2916*D1*Dd*Pk2*f**2 - 16896*D1*Dd*Pk2*f*fd*r*s + 6336*D1*Dd*Pk2*f*fd*r - 37440*D1*Dd*Pk2*f*fd*s**2 + 31920*D1*Dd*Pk2*f*fd*s - 6168*D1*Dd*Pk2*f*fd - 72*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 36*D1*Dd*Pkdd2*f**2*k1**2*s - 18*D1*Dd*Pkdd2*f**2*k1**2 + 144*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 108*D1*Dd*Pkdd2*f*fd*k1**2*s + 18*D1*Dd*Pkdd2*f*fd*k1**2 - 4224*D1*Ddd*Pk2*f**2*r*s + 1056*D1*Ddd*Pk2*f**2*r - 9360*D1*Ddd*Pk2*f**2*s**2 + 5736*D1*Ddd*Pk2*f**2*s - 2340*D1*Ddd*Pk2*f**2 + 36*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Ddd*Pkdd2*f**2*k1**2*s + 9*D1*Ddd*Pkdd2*f**2*k1**2 + 336*D1*Pk2*bd1*(2*C - 3)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 12672*Dd**2*Pk2*f**2*r*s + 3168*Dd**2*Pk2*f**2*r - 28080*Dd**2*Pk2*f**2*s**2 + 17208*Dd**2*Pk2*f**2*s - 1056*Dd**2*Pk2*f**2 + 108*Dd**2*Pkdd2*f**2*k1**2*s**2 - 54*Dd**2*Pkdd2*f**2*k1**2*s) + f*(3456*C*D1**2*Pk2*f*fd*r*s - 1152*C*D1**2*Pk2*f*fd*r + 15096*C*D1**2*Pk2*f*fd*s**2 - 11216*C*D1**2*Pk2*f*fd*s + 5032*C*D1**2*Pk2*f*fd - 2592*C*D1**2*Pk2*f*fdd*r*s + 864*C*D1**2*Pk2*f*fdd*r - 9816*C*D1**2*Pk2*f*fdd*s**2 + 7408*C*D1**2*Pk2*f*fdd*s - 3272*C*D1**2*Pk2*f*fdd - 5184*C*D1**2*Pk2*fd**2*r*s + 1728*C*D1**2*Pk2*fd**2*r - 19632*C*D1**2*Pk2*fd**2*s**2 + 14816*C*D1**2*Pk2*fd**2*s - 864*C*D1**2*Pk2*fd**2 + 4608*C*D1*Dd*Pk2*f**2*r*s - 1152*C*D1*Dd*Pk2*f**2*r + 20128*C*D1*Dd*Pk2*f**2*s**2 - 11216*C*D1*Dd*Pk2*f**2*s + 5032*C*D1*Dd*Pk2*f**2 - 20736*C*D1*Dd*Pk2*f*fd*r*s + 6048*C*D1*Dd*Pk2*f*fd*r - 78528*C*D1*Dd*Pk2*f*fd*s**2 + 51856*C*D1*Dd*Pk2*f*fd*s - 8272*C*D1*Dd*Pk2*f*fd - 3456*C*D1*Ddd*Pk2*f**2*r*s + 864*C*D1*Ddd*Pk2*f**2*r - 13088*C*D1*Ddd*Pk2*f**2*s**2 + 7408*C*D1*Ddd*Pk2*f**2*s - 3272*C*D1*Ddd*Pk2*f**2 - 10368*C*Dd**2*Pk2*f**2*r*s + 2592*C*Dd**2*Pk2*f**2*r - 39264*C*Dd**2*Pk2*f**2*s**2 + 22224*C*Dd**2*Pk2*f**2*s - 864*C*Dd**2*Pk2*f**2 + 1008*D1**2*Pk2*bd1**2*s*(2*C - 3)*(s - 1) - 8160*D1**2*Pk2*f*fd*r*s + 2720*D1**2*Pk2*f*fd*r - 14340*D1**2*Pk2*f*fd*s**2 + 12280*D1**2*Pk2*f*fd*s - 4780*D1**2*Pk2*f*fd + 6240*D1**2*Pk2*f*fdd*r*s - 2080*D1**2*Pk2*f*fdd*r + 10572*D1**2*Pk2*f*fdd*s**2 - 9128*D1**2*Pk2*f*fdd*s + 3524*D1**2*Pk2*f*fdd + 12480*D1**2*Pk2*fd**2*r*s - 4160*D1**2*Pk2*fd**2*r + 21144*D1**2*Pk2*fd**2*s**2 - 18256*D1**2*Pk2*fd**2*s + 2080*D1**2*Pk2*fd**2 + 90*D1**2*Pkdd2*f*fd*k1**2*s**2 - 60*D1**2*Pkdd2*f*fd*k1**2*s + 30*D1**2*Pkdd2*f*fd*k1**2 - 45*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*f*fdd*k1**2*s - 15*D1**2*Pkdd2*f*fdd*k1**2 - 90*D1**2*Pkdd2*fd**2*k1**2*s**2 + 60*D1**2*Pkdd2*fd**2*k1**2*s - 9*D1**2*bdd1*f*(4*Pk2*(2*C*(20*r*s + 87*s**2 - 8*s - 6) - 88*r*s - 195*s**2 + 52*s + 18) + 3*Pkdd2*k1**2*s**2) - 10880*D1*Dd*Pk2*f**2*r*s + 2720*D1*Dd*Pk2*f**2*r - 19120*D1*Dd*Pk2*f**2*s**2 + 12280*D1*Dd*Pk2*f**2*s - 4780*D1*Dd*Pk2*f**2 + 49920*D1*Dd*Pk2*f*fd*r*s - 14560*D1*Dd*Pk2*f*fd*r + 84576*D1*Dd*Pk2*f*fd*s**2 - 63896*D1*Dd*Pk2*f*fd*s + 11208*D1*Dd*Pk2*f*fd + 120*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 60*D1*Dd*Pkdd2*f**2*k1**2*s + 30*D1*Dd*Pkdd2*f**2*k1**2 - 360*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 210*D1*Dd*Pkdd2*f*fd*k1**2*s - 30*D1*Dd*Pkdd2*f*fd*k1**2 + 8320*D1*Ddd*Pk2*f**2*r*s - 2080*D1*Ddd*Pk2*f**2*r + 14096*D1*Ddd*Pk2*f**2*s**2 - 9128*D1*Ddd*Pk2*f**2*s + 3524*D1*Ddd*Pk2*f**2 - 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 30*D1*Ddd*Pkdd2*f**2*k1**2*s - 15*D1*Ddd*Pkdd2*f**2*k1**2 + 6*D1*bd1*(D1*(2*Pk2*f*(2*C*(92*r*s + 375*s**2 - 20*s - 36) - 388*r*s - 729*s**2 + 172*s + 108) - 12*Pk2*fd*(C*(80*r*s - 20*r + 348*s**2 - 202*s + 20) - 176*r*s + 44*r - 390*s**2 + 265*s - 44) + 9*Pkdd2*f*k1**2*s**2 - 9*Pkdd2*fd*k1**2*s*(2*s - 1)) + 3*Dd*f*(-4*Pk2*(2*C*(80*r*s - 10*r + 348*s**2 - 113*s + 4) - 352*r*s + 44*r - 780*s**2 + 343*s - 26) + 3*Pkdd2*k1**2*s*(1 - 4*s))) + 24960*Dd**2*Pk2*f**2*r*s - 6240*Dd**2*Pk2*f**2*r + 42288*Dd**2*Pk2*f**2*s**2 - 27384*Dd**2*Pk2*f**2*s + 2080*Dd**2*Pk2*f**2 - 180*Dd**2*Pkdd2*f**2*k1**2*s**2 + 90*Dd**2*Pkdd2*f**2*k1**2*s))/(315*d**2*k2*k3**2) + D1**2*Pk1*ct**3*k1*(21*b1**2*(D1**2*s*(2*Pk2*fd*(r*(80*C - 124) + s*(116*C - 153)) + Pk2*fdd*(-216*C*s + r*(144 - 80*C) + 278*s) + 6*Pkdd2*fd*k1**2*s - 3*Pkdd2*fdd*k1**2*s) + D1*(2*Dd*(Pk2*f*(4*C*(80*r*s - 20*r + 116*s**2 - 78*s + 29) - 496*r*s + 124*r - 612*s**2 + 430*s - 153) - Pk2*fd*r*(40*C - 72)*(8*s - 1) + 2*Pk2*fd*s*(-16*C*(27*s - 8) + 556*s - 175) + 3*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + 3*Pkdd2*fd*k1**2*s*(1 - 4*s)) + Ddd*f*(-2*Pk2*(4*C*(40*r*s - 10*r + 108*s**2 - 64*s + 27) - 288*r*s + 72*r - 556*s**2 + 350*s - 139) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(2*Pk2*(4*C*(60*r*s - 15*r + 162*s**2 - 96*s + 5) - 432*r*s + 108*r - 834*s**2 + 525*s - 36) + 9*Pkdd2*k1**2*s*(2*s - 1))) + 3*b1*(-1600*C*D1**2*Pk2*f*fd*r*s + 1664*C*D1**2*Pk2*f*fd*r - 4608*C*D1**2*Pk2*f*fd*s**2 + 6000*C*D1**2*Pk2*f*fd*s - 3432*C*D1**2*Pk2*f*fd + 1696*C*D1**2*Pk2*f*fdd*r*s - 1280*C*D1**2*Pk2*f*fdd*r + 4320*C*D1**2*Pk2*f*fdd*s**2 - 5856*C*D1**2*Pk2*f*fdd*s + 3144*C*D1**2*Pk2*f*fdd + 1696*C*D1**2*Pk2*fd**2*r*s - 1280*C*D1**2*Pk2*fd**2*r + 4320*C*D1**2*Pk2*fd**2*s**2 - 5856*C*D1**2*Pk2*fd**2*s - 3200*C*D1*Dd*Pk2*f**2*r*s + 800*C*D1*Dd*Pk2*f**2*r - 9216*C*D1*Dd*Pk2*f**2*s**2 + 5408*C*D1*Dd*Pk2*f**2*s - 2304*C*D1*Dd*Pk2*f**2 + 13568*C*D1*Dd*Pk2*f*fd*r*s - 6816*C*D1*Dd*Pk2*f*fd*r + 34560*C*D1*Dd*Pk2*f*fd*s**2 - 33760*C*D1*Dd*Pk2*f*fd*s + 7136*C*D1*Dd*Pk2*f*fd + 3392*C*D1*Ddd*Pk2*f**2*r*s - 848*C*D1*Ddd*Pk2*f**2*r + 8640*C*D1*Ddd*Pk2*f**2*s**2 - 5168*C*D1*Ddd*Pk2*f**2*s + 2160*C*D1*Ddd*Pk2*f**2 + 10176*C*Dd**2*Pk2*f**2*r*s - 2544*C*Dd**2*Pk2*f**2*r + 25920*C*Dd**2*Pk2*f**2*s**2 - 15504*C*Dd**2*Pk2*f**2*s + 848*C*Dd**2*Pk2*f**2 + 308*D1**2*Pk2*f*fd*r**2 + 1744*D1**2*Pk2*f*fd*r*s - 2336*D1**2*Pk2*f*fd*r + 1440*D1**2*Pk2*f*fd*s**2 - 2892*D1**2*Pk2*f*fd*s + 2178*D1**2*Pk2*f*fd - 308*D1**2*Pk2*f*fdd*r**2 - 1936*D1**2*Pk2*f*fdd*r*s + 1784*D1**2*Pk2*f*fdd*r - 2064*D1**2*Pk2*f*fdd*s**2 + 3756*D1**2*Pk2*f*fdd*s - 2286*D1**2*Pk2*f*fdd - 308*D1**2*Pk2*fd**2*r**2 - 1936*D1**2*Pk2*fd**2*r*s + 1784*D1**2*Pk2*fd**2*r - 2064*D1**2*Pk2*fd**2*s**2 + 3756*D1**2*Pk2*fd**2*s + 18*D1**2*Pkdd2*f*fd*k1**2*s**2 + 42*D1**2*Pkdd2*f*fd*k1**2*s - 21*D1**2*Pkdd2*f*fd*k1**2 - 30*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 30*D1**2*Pkdd2*fd**2*k1**2*s**2 - 7*D1**2*bdd1*f*(2*Pk2*(4*C*(20*r*s - 10*r + 54*s**2 - 64*s + 27) - 144*r*s + 72*r - 278*s**2 + 350*s - 139) + 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 616*D1*Dd*Pk2*f**2*r**2 + 3488*D1*Dd*Pk2*f**2*r*s - 1180*D1*Dd*Pk2*f**2*r + 2880*D1*Dd*Pk2*f**2*s**2 - 2312*D1*Dd*Pk2*f**2*s + 874*D1*Dd*Pk2*f**2 - 2464*D1*Dd*Pk2*f*fd*r**2 - 15488*D1*Dd*Pk2*f*fd*r*s + 9688*D1*Dd*Pk2*f*fd*r - 16512*D1*Dd*Pk2*f*fd*s**2 + 21088*D1*Dd*Pk2*f*fd*s - 5540*D1*Dd*Pk2*f*fd + 36*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**2*k1**2*s + 9*D1*Dd*Pkdd2*f**2*k1**2 - 240*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 60*D1*Dd*Pkdd2*f*fd*k1**2*s - 616*D1*Ddd*Pk2*f**2*r**2 - 3872*D1*Ddd*Pk2*f**2*r*s + 1276*D1*Ddd*Pk2*f**2*r - 4128*D1*Ddd*Pk2*f**2*s**2 + 3032*D1*Ddd*Pk2*f**2*s - 1186*D1*Ddd*Pk2*f**2 - 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 30*D1*Ddd*Pkdd2*f**2*k1**2*s - 15*D1*Ddd*Pkdd2*f**2*k1**2 + 14*D1*bd1*(D1*(Pk2*f*(4*C*(20*r*(2*s - 1) + 58*s**2 - 78*s + 29) - 124*r*(2*s - 1) - 306*s**2 + 430*s - 153) - Pk2*fd*r*(40*C - 72)*(4*s - 1) + 2*Pk2*fd*s*(-8*C*(27*s - 16) + 278*s - 175) + 3*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + 3*Pkdd2*fd*k1**2*s*(1 - 2*s)) + Dd*f*(-2*Pk2*(4*C*(10*r*(8*s - 3) + 216*s**2 - 192*s + 37) - 72*r*(8*s - 3) - 1112*s**2 + 1050*s - 211) - 3*Pkdd2*k1**2*(8*s**2 - 6*s + 1))) - 1848*Dd**2*Pk2*f**2*r**2 - 11616*Dd**2*Pk2*f**2*r*s + 3828*Dd**2*Pk2*f**2*r - 12384*Dd**2*Pk2*f**2*s**2 + 9096*Dd**2*Pk2*f**2*s - 968*Dd**2*Pk2*f**2 - 180*Dd**2*Pkdd2*f**2*k1**2*s**2 + 90*Dd**2*Pkdd2*f**2*k1**2*s) - f*(12768*C*D1**2*Pk2*f*fd*r*s - 4256*C*D1**2*Pk2*f*fd*r + 21336*C*D1**2*Pk2*f*fd*s**2 - 18480*C*D1**2*Pk2*f*fd*s + 7112*C*D1**2*Pk2*f*fd - 9408*C*D1**2*Pk2*f*fdd*r*s + 3136*C*D1**2*Pk2*f*fdd*r - 19416*C*D1**2*Pk2*f*fdd*s**2 + 16080*C*D1**2*Pk2*f*fdd*s - 6472*C*D1**2*Pk2*f*fdd - 18816*C*D1**2*Pk2*fd**2*r*s + 6272*C*D1**2*Pk2*fd**2*r - 38832*C*D1**2*Pk2*fd**2*s**2 + 32160*C*D1**2*Pk2*fd**2*s - 3136*C*D1**2*Pk2*fd**2 + 17024*C*D1*Dd*Pk2*f**2*r*s - 4256*C*D1*Dd*Pk2*f**2*r + 28448*C*D1*Dd*Pk2*f**2*s**2 - 18480*C*D1*Dd*Pk2*f**2*s + 7112*C*D1*Dd*Pk2*f**2 - 75264*C*D1*Dd*Pk2*f*fd*r*s + 21952*C*D1*Dd*Pk2*f*fd*r - 155328*C*D1*Dd*Pk2*f*fd*s**2 + 112560*C*D1*Dd*Pk2*f*fd*s - 19216*C*D1*Dd*Pk2*f*fd - 12544*C*D1*Ddd*Pk2*f**2*r*s + 3136*C*D1*Ddd*Pk2*f**2*r - 25888*C*D1*Ddd*Pk2*f**2*s**2 + 16080*C*D1*Ddd*Pk2*f**2*s - 6472*C*D1*Ddd*Pk2*f**2 - 37632*C*Dd**2*Pk2*f**2*r*s + 9408*C*Dd**2*Pk2*f**2*r - 77664*C*Dd**2*Pk2*f**2*s**2 + 48240*C*Dd**2*Pk2*f**2*s - 3136*C*Dd**2*Pk2*f**2 - 1758*D1**2*Pk2*f*fd*r**2 - 17472*D1**2*Pk2*f*fd*r*s + 6996*D1**2*Pk2*f*fd*r - 12774*D1**2*Pk2*f*fd*s**2 + 14340*D1**2*Pk2*f*fd*s - 4844*D1**2*Pk2*f*fd + 1338*D1**2*Pk2*f*fdd*r**2 + 13272*D1**2*Pk2*f*fdd*r*s - 5316*D1**2*Pk2*f*fdd*r + 13434*D1**2*Pk2*f*fdd*s**2 - 13380*D1**2*Pk2*f*fdd*s + 4924*D1**2*Pk2*f*fdd + 2676*D1**2*Pk2*fd**2*r**2 + 26544*D1**2*Pk2*fd**2*r*s - 10632*D1**2*Pk2*fd**2*r + 26868*D1**2*Pk2*fd**2*s**2 - 26760*D1**2*Pk2*fd**2*s + 4424*D1**2*Pk2*fd**2 + 135*D1**2*Pkdd2*f*fd*k1**2*s**2 - 90*D1**2*Pkdd2*f*fd*k1**2*s + 45*D1**2*Pkdd2*f*fd*k1**2 + 42*D1**2*bd1**2*(2*Pk2*(4*C*(10*r*s - 5*r + 27*s**2 - 32*s + 5) - 72*r*s + 36*r - 139*s**2 + 175*s - 36) + 3*Pkdd2*k1**2*s*(s - 1)) - 3*D1**2*bdd1*f*(2*Pk2*(4*C*(106*r*s + 54*r + 270*s**2 + 86*s - 123) - 77*r**2 - 484*r*s - 254*r - 516*s**2 - 362*s + 550) - 15*Pkdd2*k1**2*(s - 1)**2) - 2344*D1*Dd*Pk2*f**2*r**2 - 23296*D1*Dd*Pk2*f**2*r*s + 6996*D1*Dd*Pk2*f**2*r - 17032*D1*Dd*Pk2*f**2*s**2 + 14340*D1*Dd*Pk2*f**2*s - 4844*D1*Dd*Pk2*f**2 + 10704*D1*Dd*Pk2*f*fd*r**2 + 106176*D1*Dd*Pk2*f*fd*r*s - 37212*D1*Dd*Pk2*f*fd*r + 107472*D1*Dd*Pk2*f*fd*s**2 - 93660*D1*Dd*Pk2*f*fd*s + 18696*D1*Dd*Pk2*f*fd + 180*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 90*D1*Dd*Pkdd2*f**2*k1**2*s + 45*D1*Dd*Pkdd2*f**2*k1**2 + 1784*D1*Ddd*Pk2*f**2*r**2 + 17696*D1*Ddd*Pk2*f**2*r*s - 5316*D1*Ddd*Pk2*f**2*r + 17912*D1*Ddd*Pk2*f**2*s**2 - 13380*D1*Ddd*Pk2*f**2*s + 4924*D1*Ddd*Pk2*f**2 + 3*D1*bd1*(D1*(2*Pk2*f*(4*C*(4*r*(25*s + 27) + 288*s**2 + 74*s - 141) - 77*r**2 - 436*r*s - 578*r - 360*s**2 - 290*s + 652) + 4*Pk2*fd*(-4*C*(212*r*s - 26*r + 540*s**2 - 280*s + 53) + 154*r**2 + 968*r*s - 192*r + 1032*s**2 - 577*s + 242) - 3*Pkdd2*f*k1**2*(3*s**2 - 20*s + 10) + 60*Pkdd2*fd*k1**2*s*(s - 1)) - 4*Dd*Pk2*f*(4*C*(424*r*s + 55*r + 1080*s**2 - 151*s - 70) - 308*r**2 - 1936*r*s - 189*r - 2064*s**2 + 34*s + 308) + 30*Dd*Pkdd2*f*k1**2*(4*s**2 - 5*s + 1)) + 5352*Dd**2*Pk2*f**2*r**2 + 53088*Dd**2*Pk2*f**2*r*s - 15948*Dd**2*Pk2*f**2*r + 53736*Dd**2*Pk2*f**2*s**2 - 40140*Dd**2*Pk2*f**2*s + 4424*Dd**2*Pk2*f**2))/(630*d**2*k2*k3**2) + D1**2*Pk1*ct**3*k2*st**4*(3*b1*(D1**2*(f*(48*Pk2*fd*(r*(18*C - 18)*(2*s - 1) + 10*s**2 - 10*s + 5) - 40*Pk2*fdd*(r*(8*C - 8)*(2*s - 1) + 6*s**2 - 6*s + 3) + Pkdd2*fd*k1**2*(70 - 40*C)*(2*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(20*C - 35)*(2*s**2 - 2*s + 1)) + 10*fd**2*(-8*Pk2*(r*(4*C - 4)*(2*s - 1) + s*(3*s - 3)) + Pkdd2*k1**2*s*(4*C - 7)*(s - 1))) + D1*f*(2*Dd*(24*Pk2*f*(r*(18*C - 18)*(4*s - 1) + 20*s**2 + s*(8 - 18*C) + 5) - 40*Pk2*fd*(4*C*(2*r*(8*s - 3) - 2*s + 1) - 8*r*(8*s - 3) + 24*s**2 - 10*s - 1) + Pkdd2*f*k1**2*(35 - 20*C)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(20*C - 35)*(8*s**2 - 6*s + 1)) - 5*Ddd*f*(8*Pk2*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 12*s**2 + 2*s + 3) - Pkdd2*k1**2*(4*C - 7)*(4*s**2 - 2*s + 1))) - 10*Dd**2*f**2*(8*Pk2*(4*C*(12*r*s - 3*r - 3*s + 1) - 48*r*s + 12*r + 18*s**2 + 3*s - 4) + Pkdd2*k1**2*s*(21 - 12*C)*(2*s - 1))) + f*(D1**2*(-80*Pk2*fd**2*(8*C*(r*(6*s - 2) - 2*s + 1) + r*(16 - 48*s) + 9*s**2 + 10*s - 8) + Pkdd2*fd**2*k1**2*s*(40*C - 70)*(3*s - 2) + 2*f*fd*(8*Pk2*(-62*C*s + r*(62*C - 62)*(3*s - 1) + 45*s**2 + 32*s + 15) + Pkdd2*k1**2*(35 - 20*C)*(3*s**2 - 2*s + 1)) - 5*f*(3*bdd1*s*(8*Pk2*(8*C*(r - 1) - 8*r + 3*s + 8) + Pkdd2*k1**2*s*(7 - 4*C)) + fdd*(8*Pk2*(-16*C*s + r*(16*C - 16)*(3*s - 1) + 9*s**2 + 10*s + 3) - Pkdd2*k1**2*(4*C - 7)*(3*s**2 - 2*s + 1)))) + 6*D1*bd1*(D1*f*s*(24*Pk2*(18*C*(r - 1) - 18*r + 5*s + 18) + Pkdd2*k1**2*s*(35 - 20*C)) + 5*D1*fd*(-8*Pk2*(4*C*(4*r*s - r - 2*s + 1) - 16*r*s + 4*r + 6*s**2 + 5*s - 4) + Pkdd2*k1**2*s*(4*C - 7)*(2*s - 1)) - 40*Dd*Pk2*f*(4*C*(r*(8*s - 1) - 5*s + 1) + r*(4 - 32*s) + 12*s**2 + 17*s - 4) + Dd*Pkdd2*f*k1**2*s*(20*C - 35)*(4*s - 1)) + D1*f*(2*Dd*(8*Pk2*f*(r*(62*C - 62)*(4*s - 1) + 60*s**2 + s*(32 - 62*C) + 15) - 40*Pk2*fd*(8*C*(r*(24*s - 7) - 7*s + 2) - 8*r*(24*s - 7) + 36*s**2 + 35*s - 13) + Pkdd2*f*k1**2*(35 - 20*C)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(20*C - 35)*(12*s**2 - 7*s + 1)) - 5*Ddd*f*(8*Pk2*(-16*C*s + r*(16*C - 16)*(4*s - 1) + 12*s**2 + 10*s + 3) - Pkdd2*k1**2*(4*C - 7)*(4*s**2 - 2*s + 1))) - 10*Dd**2*f**2*(8*Pk2*(8*C*(12*r*s - 3*r - 3*s + 1) - 96*r*s + 24*r + 18*s**2 + 15*s - 8) + Pkdd2*k1**2*s*(21 - 12*C)*(2*s - 1))))/(210*d**2*k1*k3**2) - D1**2*Pk1*ct**3*k2*st**2*(126*D1**2*bd1**2*f*(Pk2*(4*C - 4)*(r*(2*s - 1) - s + 1) - Pkdd2*k1**2*s*(2*C - 3)*(s - 1)) - 3*D1*bd1*(-14*b1*(D1*(-Pk2*f*(44*C - 44)*(r*(2*s - 1) - s) + Pk2*fd*(12*C - 12)*(r*(4*s - 1) - s) + Pkdd2*f*k1**2*(6*C - 9)*(2*s**2 - 2*s + 1) + 3*Pkdd2*fd*k1**2*s*(C*(2 - 4*s) + 6*s - 3)) + 3*Dd*f*(Pk2*(8*C - 8)*(r*(8*s - 3) - 3*s + 1) - Pkdd2*k1**2*(2*C - 3)*(8*s**2 - 6*s + 1))) + f*(D1*(-2*Pk2*f*(2*C*(51*r**2 + 170*r*s - 32*r - 240*s + 51) - 102*r**2 - 196*r*s + 64*r + 249*s**2 + 336*s - 102) + 12*Pk2*fd*(2*C*(10*r**2 + 52*r*s - 16*r - 33*s + 13) - 20*r**2 - 56*r*s + 20*r + 146*s**2 - 31*s - 14) + 9*Pkdd2*f*k1**2*(2*C*(7*s**2 + 4*s - 2) + s**2 - 12*s + 6) + 6*Pkdd2*fd*k1**2*s*(C*(8 - 28*s) - 24*s + 21)) - 6*Dd*f*(-2*Pk2*(2*C*(20*r**2 + 2*r*(52*s - 5) - 93*s + 18) - 40*r**2 - 112*r*s + 8*r + 292*s**2 + 53*s - 24) + Pkdd2*k1**2*(4*s - 1)*(2*C*(7*s + 3) + 12*s - 9)))) + 21*b1**2*(2*D1*Dd*(-Pk2*f*(44*C - 44)*(r*(4*s - 1) - s) + Pk2*fd*(12*C - 12)*(r*(8*s - 1) - s) + Pkdd2*f*k1**2*(6*C - 9)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(9 - 6*C)*(4*s - 1)) + D1*(D1*s*(Pk2*fd*r*(88 - 88*C) + Pk2*fdd*r*(24*C - 24) + Pkdd2*fd*k1**2*s*(12*C - 18) + Pkdd2*fdd*k1**2*s*(9 - 6*C)) - 3*Ddd*f*(Pk2*(8 - 8*C)*(4*r*s - r - s) + Pkdd2*k1**2*(2*C - 3)*(4*s**2 - 2*s + 1))) + 6*Dd**2*f*(Pk2*(4*C - 4)*(3*r*(4*s - 1) - 3*s + 1) + 3*Pkdd2*k1**2*s*(C*(2 - 4*s) + 6*s - 3))) + 3*b1*(D1**2*(f*(168*Pk2*bdd1*(C - 1)*(r*(2*s - 1) - s) + 2*Pk2*fd*(140*C*s + r**2*(204*C - 204) + 8*r*(85*C*s - 60*C - 49*s + 42) + 498*s**2 - 638*s + 249) - 6*Pk2*fdd*(28*C*s + r**2*(20*C - 20) + 8*r*(13*C*s - 10*C - 7*s + 7) + 146*s**2 - 174*s + 73) - 21*Pkdd2*bdd1*k1**2*(2*C - 3)*(2*s**2 - 2*s + 1) - 9*Pkdd2*fd*k1**2*(2*C*(14*s**2 - 18*s + 9) + 2*s**2 + 10*s - 5) + 3*Pkdd2*fdd*k1**2*(4*C*(7*s**2 - 10*s + 5) + 24*s**2 - 6*s + 3)) + 6*fd**2*(-2*Pk2*(r**2*(10*C - 10) + 4*r*(13*C*s - 10*C - 7*s + 7) + s*(14*C + 73*s - 87)) + Pkdd2*k1**2*s*(2*C*(7*s - 10) + 12*s - 3))) + D1*f*(Dd*(2*Pk2*f*(34*C*(12*r**2 + 8*r*(5*s - 2) - 10*s + 3) - 408*r**2 + r*(400 - 784*s) + 996*s**2 - 302*s + 147) - 12*Pk2*fd*(C*(80*r**2 + 8*r*(52*s - 29) + 4*s + 26) - 80*r**2 - 32*r*(7*s - 5) + 584*s**2 - 466*s + 59) + Pkdd2*f*k1**2*(-126*C - 9)*(4*s**2 - 2*s + 1) + 6*Pkdd2*fd*k1**2*(4*s - 1)*(4*C*(7*s - 5) + 24*s - 3)) + 6*Ddd*f*(Pk2*(-2*C*(20*r**2 + 4*r*(26*s - 9) - 26*s + 5) + 40*r**2 + 16*r*(7*s - 3) - 292*s**2 + 118*s - 63) + Pkdd2*k1**2*(7*C + 6)*(4*s**2 - 2*s + 1))) + 12*Dd**2*f**2*(Pk2*(-2*C*(30*r**2 + 6*r*(26*s - 9) - 39*s + 13) + 60*r**2 + 24*r*(7*s - 3) - 438*s**2 + 177*s + 14) + Pkdd2*k1**2*s*(21*C + 18)*(2*s - 1))) + f*(-9*D1**2*bdd1*f*(2*Pk2*(2*C*(5*r**2 + r*(26*s + 4) - 40*s + 5) - 10*r**2 - 4*r*(7*s + 2) + 73*s**2 + 56*s - 10) - Pkdd2*k1**2*(2*C*(7*s**2 + 6*s - 3) + 12*s**2 - 18*s + 9)) + D1**2*(f*(2*Pk2*fd*(2*C*(345*r**2 + 1896*r*s - 862*r - 632*s + 115) - 804*r**2 - 2484*r*s + 1364*r + 1029*s**2 + 142*s + 75) - 2*Pk2*fdd*(2*C*(375*r**2 + 1272*r*s - 674*r - 424*s + 125) - 834*r**2 - 1512*r*s + 1060*r + 879*s**2 - 82*s + 15) - Pkdd2*fd*k1**2*(254*C - 51)*(3*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(100*C + 15)*(3*s**2 - 2*s + 1)) + 2*fd**2*(-2*Pk2*(2*C*(375*r**2 + 1272*r*s - 674*r - 424*s + 212) - 834*r**2 - 1512*r*s + 1060*r + 879*s**2 - 82*s - 252) + Pkdd2*k1**2*s*(100*C + 15)*(3*s - 2))) + D1*f*(Dd*(2*Pk2*f*(2*C*(460*r**2 + r*(2528*s - 862) - 632*s + 115) - 1072*r**2 - 4*r*(828*s - 341) + 1372*s**2 + 142*s + 75) + 2*Pk2*fd*(-4*C*(1500*r**2 + r*(5088*s - 2359) - 1484*s + 549) + 6672*r**2 + 28*r*(432*s - 265) - 7032*s**2 + 574*s + 978) - Pkdd2*f*k1**2*(254*C - 51)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(200*C + 30)*(12*s**2 - 7*s + 1)) + Ddd*f*(-2*Pk2*(2*C*(500*r**2 + 1696*r*s - 674*r - 424*s + 125) - 1112*r**2 - 2016*r*s + 1060*r + 1172*s**2 - 82*s + 15) + Pkdd2*k1**2*(100*C + 15)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f**2*(-4*C*Pk2*(750*r**2 + 3*r*(848*s - 337) - 636*s + 212) + 6*Pk2*(556*r**2 + 2*r*(504*s - 265) - 586*s**2 + 41*s + 84) + Pkdd2*k1**2*s*(300*C + 45)*(2*s - 1))))/(315*d**2*k1*k3**2) - D1**2*Pk1*ct**3*k2*(21*b1**2*(D1**2*(Pk2*fd*r*(8*C - 8)*(11*r + 4*s) + Pk2*fdd*r*(16*C - 16)*(r - s) + Pkdd2*fd*k1**2*s**2*(19 - 44*C) + Pkdd2*fdd*k1**2*s**2*(12*C + 3)) + D1*(Dd*(Pk2*f*(8*C - 8)*(44*r**2 + 2*r*(8*s - 13) - 4*s + 11) + Pk2*fd*(16*C - 16)*(r - s)*(8*r - 1) - Pkdd2*f*k1**2*(44*C - 19)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(24*C + 6)*(4*s - 1)) + Ddd*f*(Pk2*(16*C - 16)*(4*r**2 - r*(4*s + 1) + s + 1) + Pkdd2*k1**2*(12*C + 3)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*(8*C - 8)*(12*r**2 - 3*r*(4*s + 1) + 3*s - 1) + Pkdd2*k1**2*s*(36*C + 9)*(2*s - 1))) + 3*b1*(1056*C*D1**2*Pk2*f*fd*r**2 + 1024*C*D1**2*Pk2*f*fd*r*s - 1392*C*D1**2*Pk2*f*fd*r - 512*C*D1**2*Pk2*f*fd*s + 696*C*D1**2*Pk2*f*fd - 192*C*D1**2*Pk2*f*fdd*r**2 - 736*C*D1**2*Pk2*f*fdd*r*s + 192*C*D1**2*Pk2*f*fdd*r + 368*C*D1**2*Pk2*f*fdd*s - 96*C*D1**2*Pk2*f*fdd - 192*C*D1**2*Pk2*fd**2*r**2 - 736*C*D1**2*Pk2*fd**2*r*s + 192*C*D1**2*Pk2*fd**2*r + 368*C*D1**2*Pk2*fd**2*s - 240*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 168*C*D1**2*Pkdd2*f*fd*k1**2*s + 84*C*D1**2*Pkdd2*f*fd*k1**2 + 120*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 120*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 2112*C*D1*Dd*Pk2*f**2*r**2 + 2048*C*D1*Dd*Pk2*f**2*r*s - 1568*C*D1*Dd*Pk2*f**2*r - 512*C*D1*Dd*Pk2*f**2*s + 528*C*D1*Dd*Pk2*f**2 - 1536*C*D1*Dd*Pk2*f*fd*r**2 - 5888*C*D1*Dd*Pk2*f*fd*r*s + 1888*C*D1*Dd*Pk2*f*fd*r + 2208*C*D1*Dd*Pk2*f*fd*s - 560*C*D1*Dd*Pk2*f*fd - 480*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 240*C*D1*Dd*Pkdd2*f**2*k1**2*s - 120*C*D1*Dd*Pkdd2*f**2*k1**2 + 960*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 240*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 384*C*D1*Ddd*Pk2*f**2*r**2 - 1472*C*D1*Ddd*Pk2*f**2*r*s + 560*C*D1*Ddd*Pk2*f**2*r + 368*C*D1*Ddd*Pk2*f**2*s - 96*C*D1*Ddd*Pk2*f**2 + 240*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 120*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 60*C*D1*Ddd*Pkdd2*f**2*k1**2 - 1152*C*Dd**2*Pk2*f**2*r**2 - 4416*C*Dd**2*Pk2*f**2*r*s + 1680*C*Dd**2*Pk2*f**2*r + 1104*C*Dd**2*Pk2*f**2*s - 368*C*Dd**2*Pk2*f**2 + 720*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 360*C*Dd**2*Pkdd2*f**2*k1**2*s - 1312*D1**2*Pk2*f*fd*r**2 - 1552*D1**2*Pk2*f*fd*r*s + 1784*D1**2*Pk2*f*fd*r - 1176*D1**2*Pk2*f*fd*s**2 + 1688*D1**2*Pk2*f*fd*s - 1348*D1**2*Pk2*f*fd + 208*D1**2*Pk2*f*fdd*r**2 + 1168*D1**2*Pk2*f*fdd*r*s - 416*D1**2*Pk2*f*fdd*r + 1176*D1**2*Pk2*f*fdd*s**2 - 1544*D1**2*Pk2*f*fdd*s + 688*D1**2*Pk2*f*fdd + 208*D1**2*Pk2*fd**2*r**2 + 1168*D1**2*Pk2*fd**2*r*s - 416*D1**2*Pk2*fd**2*r + 1176*D1**2*Pk2*fd**2*s**2 - 1544*D1**2*Pk2*fd**2*s + 192*D1**2*Pkdd2*f*fd*k1**2*s**2 - 42*D1**2*Pkdd2*f*fd*k1**2*s + 21*D1**2*Pkdd2*f*fd*k1**2 + 30*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*fd**2*k1**2*s**2 + 7*D1**2*bdd1*f*(Pk2*(16*C - 16)*(2*r**2 - r*(2*s + 1) + s + 1) + Pkdd2*k1**2*(12*C + 3)*(2*s**2 - 2*s + 1)) - 2624*D1*Dd*Pk2*f**2*r**2 - 3104*D1*Dd*Pk2*f**2*r*s + 2088*D1*Dd*Pk2*f**2*r - 2352*D1*Dd*Pk2*f**2*s**2 + 1952*D1*Dd*Pk2*f**2*s - 1244*D1*Dd*Pk2*f**2 + 1664*D1*Dd*Pk2*f*fd*r**2 + 9344*D1*Dd*Pk2*f*fd*r*s - 3248*D1*Dd*Pk2*f*fd*r + 9408*D1*Dd*Pk2*f*fd*s**2 - 9696*D1*Dd*Pk2*f*fd*s + 1960*D1*Dd*Pk2*f*fd + 384*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 192*D1*Dd*Pkdd2*f**2*k1**2*s + 96*D1*Dd*Pkdd2*f**2*k1**2 + 240*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 60*D1*Dd*Pkdd2*f*fd*k1**2*s + 416*D1*Ddd*Pk2*f**2*r**2 + 2336*D1*Ddd*Pk2*f**2*r*s - 792*D1*Ddd*Pk2*f**2*r + 2352*D1*Ddd*Pk2*f**2*s**2 - 1760*D1*Ddd*Pk2*f**2*s + 692*D1*Ddd*Pk2*f**2 + 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 30*D1*Ddd*Pkdd2*f**2*k1**2*s + 15*D1*Ddd*Pkdd2*f**2*k1**2 + 7*D1*bd1*(D1*(Pk2*f*(8*C - 8)*(22*r**2 + r*(8*s - 26) - 4*s + 11) + Pk2*fd*(16*C - 16)*(r - s)*(4*r - 1) - Pkdd2*f*k1**2*(44*C - 19)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(24*C + 6)*(2*s - 1)) + 2*Dd*f*(Pk2*(16*C - 16)*(r - s)*(8*r - 3) + Pkdd2*k1**2*(12*C + 3)*(8*s**2 - 6*s + 1))) + 1248*Dd**2*Pk2*f**2*r**2 + 7008*Dd**2*Pk2*f**2*r*s - 2376*Dd**2*Pk2*f**2*r + 7056*Dd**2*Pk2*f**2*s**2 - 5280*Dd**2*Pk2*f**2*s + 584*Dd**2*Pk2*f**2 + 180*Dd**2*Pkdd2*f**2*k1**2*s**2 - 90*Dd**2*Pkdd2*f**2*k1**2*s) + f*(-2616*C*D1**2*Pk2*f*fd*r**2 - 1728*C*D1**2*Pk2*f*fd*r*s + 2320*C*D1**2*Pk2*f*fd*r + 576*C*D1**2*Pk2*f*fd*s - 872*C*D1**2*Pk2*f*fd + 336*C*D1**2*Pk2*f*fdd*r**2 + 1728*C*D1**2*Pk2*f*fdd*r*s - 800*C*D1**2*Pk2*f*fdd*r - 576*C*D1**2*Pk2*f*fdd*s + 112*C*D1**2*Pk2*f*fdd + 672*C*D1**2*Pk2*fd**2*r**2 + 3456*C*D1**2*Pk2*fd**2*r*s - 1600*C*D1**2*Pk2*fd**2*r - 1152*C*D1**2*Pk2*fd**2*s + 576*C*D1**2*Pk2*fd**2 + 540*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 360*C*D1**2*Pkdd2*f*fd*k1**2*s + 180*C*D1**2*Pkdd2*f*fd*k1**2 - 3488*C*D1*Dd*Pk2*f**2*r**2 - 2304*C*D1*Dd*Pk2*f**2*r*s + 2320*C*D1*Dd*Pk2*f**2*r + 576*C*D1*Dd*Pk2*f**2*s - 872*C*D1*Dd*Pk2*f**2 + 2688*C*D1*Dd*Pk2*f*fd*r**2 + 13824*C*D1*Dd*Pk2*f*fd*r*s - 5600*C*D1*Dd*Pk2*f*fd*r - 4032*C*D1*Dd*Pk2*f*fd*s + 1376*C*D1*Dd*Pk2*f*fd + 720*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 360*C*D1*Dd*Pkdd2*f**2*k1**2*s + 180*C*D1*Dd*Pkdd2*f**2*k1**2 + 448*C*D1*Ddd*Pk2*f**2*r**2 + 2304*C*D1*Ddd*Pk2*f**2*r*s - 800*C*D1*Ddd*Pk2*f**2*r - 576*C*D1*Ddd*Pk2*f**2*s + 112*C*D1*Ddd*Pk2*f**2 + 1344*C*Dd**2*Pk2*f**2*r**2 + 6912*C*Dd**2*Pk2*f**2*r*s - 2400*C*Dd**2*Pk2*f**2*r - 1728*C*Dd**2*Pk2*f**2*s + 576*C*Dd**2*Pk2*f**2 + 312*D1**2*Pk2*f*fd*r**2 - 2904*D1**2*Pk2*f*fd*r*s + 760*D1**2*Pk2*f*fd*r - 3348*D1**2*Pk2*f*fd*s**2 + 3200*D1**2*Pk2*f*fd*s - 1012*D1**2*Pk2*f*fd + 168*D1**2*Pk2*f*fdd*r**2 + 2424*D1**2*Pk2*f*fdd*r*s - 920*D1**2*Pk2*f*fdd*r + 3348*D1**2*Pk2*f*fdd*s**2 - 3040*D1**2*Pk2*f*fdd*s + 1172*D1**2*Pk2*f*fdd + 336*D1**2*Pk2*fd**2*r**2 + 4848*D1**2*Pk2*fd**2*r*s - 1840*D1**2*Pk2*fd**2*r + 6696*D1**2*Pk2*fd**2*s**2 - 6080*D1**2*Pk2*fd**2*s + 808*D1**2*Pk2*fd**2 + 135*D1**2*Pkdd2*f*fd*k1**2*s**2 - 90*D1**2*Pkdd2*f*fd*k1**2*s + 45*D1**2*Pkdd2*f*fd*k1**2 + 42*D1**2*bd1**2*(Pk2*(8*C - 8)*(2*r**2 - r*(2*s + 1) + s - 1) + Pkdd2*k1**2*s*(12*C + 3)*(s - 1)) - 3*D1**2*bdd1*f*(4*Pk2*(r**2*(24*C - 26) + 2*r*(46*C*(s - 1) - 73*s + 47) - 147*s**2 + 54*s - 1) + Pkdd2*k1**2*(-60*C - 15)*(s - 1)**2) + 416*D1*Dd*Pk2*f**2*r**2 - 3872*D1*Dd*Pk2*f**2*r*s + 760*D1*Dd*Pk2*f**2*r - 4464*D1*Dd*Pk2*f**2*s**2 + 3200*D1*Dd*Pk2*f**2*s - 1012*D1*Dd*Pk2*f**2 + 1344*D1*Dd*Pk2*f*fd*r**2 + 19392*D1*Dd*Pk2*f*fd*r*s - 6440*D1*Dd*Pk2*f*fd*r + 26784*D1*Dd*Pk2*f*fd*s**2 - 21280*D1*Dd*Pk2*f*fd*s + 3960*D1*Dd*Pk2*f*fd + 180*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 90*D1*Dd*Pkdd2*f**2*k1**2*s + 45*D1*Dd*Pkdd2*f**2*k1**2 + 224*D1*Ddd*Pk2*f**2*r**2 + 3232*D1*Ddd*Pk2*f**2*r*s - 920*D1*Ddd*Pk2*f**2*r + 4464*D1*Ddd*Pk2*f**2*s**2 - 3040*D1*Ddd*Pk2*f**2*s + 1172*D1*Ddd*Pk2*f**2 + 3*D1*bd1*(8*D1*Pk2*fd*(-2*C*(24*r**2 + 92*r*s - 58*r - 23*s + 23) + 52*r**2 + 146*r*(2*s - 1) + 294*s**2 - 247*s + 73) + D1*Pkdd2*fd*k1**2*s*(240*C + 60)*(s - 1) + D1*f*(4*Pk2*(2*C*(66*r**2 + 64*r*s - 22*r - 21) - 164*r**2 - 194*r*s + 76*r - 147*s**2 + 66*s + 26) + 3*Pkdd2*k1**2*(-4*C*(10*s**2 - 34*s + 17) + 32*s**2 - 50*s + 25)) - 8*Dd*Pk2*f*(C*(96*r**2 + 368*r*s - 254*r - 46*s + 46) - 104*r**2 + r*(287 - 584*s) - 588*s**2 + 328*s - 74) + Dd*Pkdd2*f*k1**2*(120*C + 30)*(4*s**2 - 5*s + 1)) + 672*Dd**2*Pk2*f**2*r**2 + 9696*Dd**2*Pk2*f**2*r*s - 2760*Dd**2*Pk2*f**2*r + 13392*Dd**2*Pk2*f**2*s**2 - 9120*Dd**2*Pk2*f**2*s + 808*Dd**2*Pk2*f**2))/(630*d**2*k1*k3**2) - D1**2*Pk1*ct**3*st**2*(5544*D1**2*K*Pk2*bdd1*f**2*r*s - 10560*D1**2*Pk2*bdd1*f**3*r*s - 17380*D1**2*Pk2*bdd1*f**3*s**2 + 2640*D1**2*Pk2*bdd1*f**3*s + 2200*D1**2*Pk2*bdd1*f**3 - 5544*D1**2*Pk2*bdd1*f**2*r*s + 2376*D1**2*Pk2*bdd1*f**2*s**2 - 11088*D1**2*Pk2*bdd1*f*g2*r*s + 11088*D1**2*Pk2*bdd1*f*g2*s + 23040*D1**2*Pk2*f**3*fd*r*s - 5760*D1**2*Pk2*f**3*fd*r + 66000*D1**2*Pk2*f**3*fd*s**2 - 38760*D1**2*Pk2*f**3*fd*s + 16500*D1**2*Pk2*f**3*fd - 25600*D1**2*Pk2*f**3*fdd*r*s + 6400*D1**2*Pk2*f**3*fdd*r - 48400*D1**2*Pk2*f**3*fdd*s**2 + 30600*D1**2*Pk2*f**3*fdd*s - 12100*D1**2*Pk2*f**3*fdd - 76800*D1**2*Pk2*f**2*fd**2*r*s + 19200*D1**2*Pk2*f**2*fd**2*r - 145200*D1**2*Pk2*f**2*fd**2*s**2 + 91800*D1**2*Pk2*f**2*fd**2*s - 6400*D1**2*Pk2*f**2*fd**2 + 18480*D1**2*Pk2*f**2*gd2*r*s - 11088*D1**2*Pk2*f**2*gdd2*r*s + 36960*D1**2*Pk2*f*fd*g2*r*s - 18480*D1**2*Pk2*f*fd*g2*r - 18480*D1**2*Pk2*f*fd*g2*s - 44352*D1**2*Pk2*f*fd*gd2*r*s + 11088*D1**2*Pk2*f*fd*gd2*r + 11088*D1**2*Pk2*f*fd*gd2*s - 22176*D1**2*Pk2*f*fdd*g2*r*s + 11088*D1**2*Pk2*f*fdd*g2*r + 11088*D1**2*Pk2*f*fdd*g2*s - 22176*D1**2*Pk2*fd**2*g2*r*s + 11088*D1**2*Pk2*fd**2*g2*r + 11088*D1**2*Pk2*fd**2*g2*s - 11088*D1**2*Pk2*fd**2*g2 + 550*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 297*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 1400*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 700*D1**2*Pkdd2*f**3*fd*k1**2*s - 350*D1**2*Pkdd2*f**3*fd*k1**2 + 700*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 350*D1**2*Pkdd2*f**3*fdd*k1**2*s + 175*D1**2*Pkdd2*f**3*fdd*k1**2 + 2100*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 1050*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 198*D1**2*bd1**2*f*s*(40*Pk2*f*(2*s - 1) + 28*Pk2*(K*(2*r - 1) - 2*r + 2*s + 1) + Pkdd2*k1**2*s*(5*f + 7)) + 23040*D1*Dd*Pk2*f**4*r*s - 5760*D1*Dd*Pk2*f**4*r + 66000*D1*Dd*Pk2*f**4*s**2 - 38760*D1*Dd*Pk2*f**4*s + 16500*D1*Dd*Pk2*f**4 - 204800*D1*Dd*Pk2*f**3*fd*r*s + 51200*D1*Dd*Pk2*f**3*fd*r - 387200*D1*Dd*Pk2*f**3*fd*s**2 + 244800*D1*Dd*Pk2*f**3*fd*s - 37000*D1*Dd*Pk2*f**3*fd + 73920*D1*Dd*Pk2*f**2*g2*r*s - 18480*D1*Dd*Pk2*f**2*g2*r - 18480*D1*Dd*Pk2*f**2*g2*s - 88704*D1*Dd*Pk2*f**2*gd2*r*s + 11088*D1*Dd*Pk2*f**2*gd2*r + 11088*D1*Dd*Pk2*f**2*gd2*s - 177408*D1*Dd*Pk2*f*fd*g2*r*s + 66528*D1*Dd*Pk2*f*fd*g2*r + 66528*D1*Dd*Pk2*f*fd*g2*s - 22176*D1*Dd*Pk2*f*fd*g2 - 1400*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 700*D1*Dd*Pkdd2*f**4*k1**2*s - 350*D1*Dd*Pkdd2*f**4*k1**2 + 5600*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 2800*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 350*D1*Dd*Pkdd2*f**3*fd*k1**2 - 25600*D1*Ddd*Pk2*f**4*r*s + 6400*D1*Ddd*Pk2*f**4*r - 48400*D1*Ddd*Pk2*f**4*s**2 + 30600*D1*Ddd*Pk2*f**4*s - 12100*D1*Ddd*Pk2*f**4 - 44352*D1*Ddd*Pk2*f**2*g2*r*s + 11088*D1*Ddd*Pk2*f**2*g2*r + 11088*D1*Ddd*Pk2*f**2*g2*s + 700*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 350*D1*Ddd*Pkdd2*f**4*k1**2*s + 175*D1*Ddd*Pkdd2*f**4*k1**2 + 22*D1*bd1*(D1*(-504*Pk2*fd*g2*(r*(2*s - 1) - s + 1) + f**3*(Pk2*(528*r*s + 950*s**2 + 48*s - 200) - 50*Pkdd2*k1**2*s**2) - f**2*(10*fd*(Pk2*(48*r*(6*s - 1) + 474*s**2 - 230*s + 32) + 5*Pkdd2*k1**2*s*(1 - 3*s)) + 3*s*(Pk2*r*(140*K - 140) + 72*Pk2*s + 9*Pkdd2*k1**2*s)) + 3*f*(56*Pk2*s*(11*g2*(r - 1) - 6*gd2*r + 3*gd2) + 3*fd*(4*Pk2*(r*(7*K - 7)*(4*s - 1) + s*(-7*K + 12*s + 1)) + 3*Pkdd2*k1**2*s*(2*s - 1)))) + Dd*f*(-504*Pk2*g2*(r*(8*s - 1) - 5*s + 1) - 10*f**2*(2*Pk2*(24*r*(8*s - 1) + 316*s**2 - 127*s + 6) + 5*Pkdd2*k1**2*s*(1 - 4*s)) + 9*f*(4*Pk2*(r*(7*K - 7)*(8*s - 1) + s*(-7*K + 24*s + 1)) + 3*Pkdd2*k1**2*s*(4*s - 1)))) - 76800*Dd**2*Pk2*f**4*r*s + 19200*Dd**2*Pk2*f**4*r - 145200*Dd**2*Pk2*f**4*s**2 + 91800*Dd**2*Pk2*f**4*s - 6400*Dd**2*Pk2*f**4 - 133056*Dd**2*Pk2*f**2*g2*r*s + 33264*Dd**2*Pk2*f**2*g2*r + 33264*Dd**2*Pk2*f**2*g2*s - 11088*Dd**2*Pk2*f**2*g2 + 2100*Dd**2*Pkdd2*f**4*k1**2*s**2 - 1050*Dd**2*Pkdd2*f**4*k1**2*s - 33*b1**2*(D1**2*(-30*fd**2*s*(8*Pk2*(2*s - 1) + Pkdd2*k1**2*(s - 1)) + fd*(8*Pk2*(30*f*(4*s**2 - 2*s + 1) + (s - 1)*(7*r*(11*K - 11) + 42*s - 42)) + 6*Pkdd2*k1**2*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2)) - 3*fdd*(8*Pk2*(5*f*(4*s**2 - 2*s + 1) + (7*s - 7)*(r*(K - 1) + s - 1)) + Pkdd2*k1**2*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2))) + D1*(2*Dd*(15*f**2*(16*Pk2 + Pkdd2*k1**2)*(4*s**2 - 2*s + 1) + f*(-4*Pk2*(77*K*s + 30*fd*(1 - 4*s)**2 - r*(77*K - 77)*(4*s - 1) - 168*s**2 + 7*s - 42) + 3*Pkdd2*k1**2*(-5*fd*(8*s**2 - 6*s + 1) + 28*s**2 - 14*s + 7)) - 21*fd*(4*Pk2*(K*r*(8*s - 5) - K*s + K + r*(5 - 8*s) + 8*s**2 - 9*s + 1) + Pkdd2*k1**2*(4*s**2 - 5*s + 1))) - 3*Ddd*f*(8*Pk2*(-7*K*s + 10*f*(4*s**2 - 2*s + 1) + r*(7*K - 7)*(4*s - 1) + 28*s**2 - 7*s + 7) + Pkdd2*k1**2*(5*f + 7)*(4*s**2 - 2*s + 1))) - 6*Dd**2*f*(4*Pk2*(7*K*(12*r*s - 3*r - 3*s + 1) + 120*f*s**2 - 60*f*s - 84*r*s + 21*r + 84*s**2 - 21*s - 7) + Pkdd2*k1**2*s*(15*f + 21)*(2*s - 1))) - 11*b1*(1680*D1**2*K*Pk2*f*fd*r*s - 840*D1**2*K*Pk2*f*fd*r - 840*D1**2*K*Pk2*f*fd*s - 1008*D1**2*K*Pk2*f*fdd*r*s + 504*D1**2*K*Pk2*f*fdd*r + 504*D1**2*K*Pk2*f*fdd*s - 1008*D1**2*K*Pk2*fd**2*r*s + 504*D1**2*K*Pk2*fd**2*r + 504*D1**2*K*Pk2*fd**2*s - 504*D1**2*K*Pk2*fd**2 - 3168*D1**2*Pk2*f**2*fd*r*s + 1056*D1**2*Pk2*f**2*fd*r - 5700*D1**2*Pk2*f**2*fd*s**2 + 4952*D1**2*Pk2*f**2*fd*s - 2300*D1**2*Pk2*f**2*fd + 2880*D1**2*Pk2*f**2*fdd*r*s - 960*D1**2*Pk2*f**2*fdd*r + 4740*D1**2*Pk2*f**2*fdd*s**2 - 3880*D1**2*Pk2*f**2*fdd*s + 1780*D1**2*Pk2*f**2*fdd + 5760*D1**2*Pk2*f*fd**2*r*s - 1920*D1**2*Pk2*f*fd**2*r + 9480*D1**2*Pk2*f*fd**2*s**2 - 7760*D1**2*Pk2*f*fd**2*s + 320*D1**2*Pk2*f*fd**2 - 1680*D1**2*Pk2*f*fd*r*s + 840*D1**2*Pk2*f*fd*r + 864*D1**2*Pk2*f*fd*s**2 - 24*D1**2*Pk2*f*fd*s + 432*D1**2*Pk2*f*fd + 1008*D1**2*Pk2*f*fdd*r*s - 504*D1**2*Pk2*f*fdd*r - 432*D1**2*Pk2*f*fdd*s**2 - 72*D1**2*Pk2*f*fdd*s - 216*D1**2*Pk2*f*fdd - 3696*D1**2*Pk2*f*gd2*r*s + 1008*D1**2*Pk2*f*gdd2*r*s + 1008*D1**2*Pk2*fd**2*r*s - 504*D1**2*Pk2*fd**2*r - 432*D1**2*Pk2*fd**2*s**2 - 72*D1**2*Pk2*fd**2*s + 504*D1**2*Pk2*fd**2 - 3696*D1**2*Pk2*fd*g2*r*s + 3696*D1**2*Pk2*fd*g2*r + 2016*D1**2*Pk2*fd*gd2*r*s - 1008*D1**2*Pk2*fd*gd2*r + 1008*D1**2*Pk2*fdd*g2*r*s - 1008*D1**2*Pk2*fdd*g2*r + 300*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 200*D1**2*Pkdd2*f**2*fd*k1**2*s + 100*D1**2*Pkdd2*f**2*fd*k1**2 - 150*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 100*D1**2*Pkdd2*f**2*fdd*k1**2*s - 50*D1**2*Pkdd2*f**2*fdd*k1**2 - 300*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 200*D1**2*Pkdd2*f*fd**2*k1**2*s + 108*D1**2*Pkdd2*f*fd*k1**2*s**2 - 108*D1**2*Pkdd2*f*fd*k1**2*s + 54*D1**2*Pkdd2*f*fd*k1**2 - 54*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 54*D1**2*Pkdd2*f*fdd*k1**2*s - 27*D1**2*Pkdd2*f*fdd*k1**2 - 54*D1**2*Pkdd2*fd**2*k1**2*s**2 + 54*D1**2*Pkdd2*fd**2*k1**2*s - 18*D1**2*bdd1*f*(5*f*(4*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2) + 7*s*(Pk2*(8*K*r - 4*K - 8*r + 8*s + 4) + Pkdd2*k1**2*s)) + 3360*D1*Dd*K*Pk2*f**2*r*s - 840*D1*Dd*K*Pk2*f**2*r - 840*D1*Dd*K*Pk2*f**2*s - 8064*D1*Dd*K*Pk2*f*fd*r*s + 3024*D1*Dd*K*Pk2*f*fd*r + 3024*D1*Dd*K*Pk2*f*fd*s - 1008*D1*Dd*K*Pk2*f*fd - 4224*D1*Dd*Pk2*f**3*r*s + 1056*D1*Dd*Pk2*f**3*r - 7600*D1*Dd*Pk2*f**3*s**2 + 4856*D1*Dd*Pk2*f**3*s - 1900*D1*Dd*Pk2*f**3 + 23040*D1*Dd*Pk2*f**2*fd*r*s - 6720*D1*Dd*Pk2*f**2*fd*r + 37920*D1*Dd*Pk2*f**2*fd*s**2 - 27880*D1*Dd*Pk2*f**2*fd*s + 4840*D1*Dd*Pk2*f**2*fd - 3360*D1*Dd*Pk2*f**2*r*s + 840*D1*Dd*Pk2*f**2*r + 1728*D1*Dd*Pk2*f**2*s**2 - 24*D1*Dd*Pk2*f**2*s + 432*D1*Dd*Pk2*f**2 + 8064*D1*Dd*Pk2*f*fd*r*s - 3024*D1*Dd*Pk2*f*fd*r - 3456*D1*Dd*Pk2*f*fd*s**2 - 432*D1*Dd*Pk2*f*fd*s + 576*D1*Dd*Pk2*f*fd - 14784*D1*Dd*Pk2*f*g2*r*s + 3696*D1*Dd*Pk2*f*g2*r + 3696*D1*Dd*Pk2*f*g2*s + 8064*D1*Dd*Pk2*f*gd2*r*s - 1008*D1*Dd*Pk2*f*gd2*r - 1008*D1*Dd*Pk2*f*gd2*s + 8064*D1*Dd*Pk2*fd*g2*r*s - 5040*D1*Dd*Pk2*fd*g2*r - 1008*D1*Dd*Pk2*fd*g2*s + 1008*D1*Dd*Pk2*fd*g2 + 400*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 200*D1*Dd*Pkdd2*f**3*k1**2*s + 100*D1*Dd*Pkdd2*f**3*k1**2 - 1200*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 700*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 100*D1*Dd*Pkdd2*f**2*fd*k1**2 + 216*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 108*D1*Dd*Pkdd2*f**2*k1**2*s + 54*D1*Dd*Pkdd2*f**2*k1**2 - 432*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 324*D1*Dd*Pkdd2*f*fd*k1**2*s - 54*D1*Dd*Pkdd2*f*fd*k1**2 - 2016*D1*Ddd*K*Pk2*f**2*r*s + 504*D1*Ddd*K*Pk2*f**2*r + 504*D1*Ddd*K*Pk2*f**2*s + 3840*D1*Ddd*Pk2*f**3*r*s - 960*D1*Ddd*Pk2*f**3*r + 6320*D1*Ddd*Pk2*f**3*s**2 - 4120*D1*Ddd*Pk2*f**3*s + 1580*D1*Ddd*Pk2*f**3 + 2016*D1*Ddd*Pk2*f**2*r*s - 504*D1*Ddd*Pk2*f**2*r - 864*D1*Ddd*Pk2*f**2*s**2 - 72*D1*Ddd*Pk2*f**2*s - 216*D1*Ddd*Pk2*f**2 + 4032*D1*Ddd*Pk2*f*g2*r*s - 1008*D1*Ddd*Pk2*f*g2*r - 1008*D1*Ddd*Pk2*f*g2*s - 200*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 100*D1*Ddd*Pkdd2*f**3*k1**2*s - 50*D1*Ddd*Pkdd2*f**3*k1**2 - 108*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 54*D1*Ddd*Pkdd2*f**2*k1**2*s - 27*D1*Ddd*Pkdd2*f**2*k1**2 + 12*D1*bd1*(D1*(15*f**2*(4*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2) + f*s*(-240*Pk2*fd*(2*s - 1) + 14*Pk2*(11*K*(2*r - 1) - 22*r + 12*s + 11) + 3*Pkdd2*k1**2*(fd*(5 - 10*s) + 7*s)) - 21*fd*(2*Pk2*(K*r*(4*s - 2) - K*s + K + r*(2 - 4*s) + 4*s**2 - 3*s - 1) + Pkdd2*k1**2*s*(s - 1))) - 3*Dd*f*(20*Pk2*f*(1 - 4*s)**2 + 14*Pk2*(2*K*r*(8*s - 1) - 6*K*s + K + r*(2 - 16*s) + 16*s**2 + 2*s - 1) + Pkdd2*k1**2*s*(5*f + 7)*(4*s - 1))) - 6048*Dd**2*K*Pk2*f**2*r*s + 1512*Dd**2*K*Pk2*f**2*r + 1512*Dd**2*K*Pk2*f**2*s - 504*Dd**2*K*Pk2*f**2 + 11520*Dd**2*Pk2*f**3*r*s - 2880*Dd**2*Pk2*f**3*r + 18960*Dd**2*Pk2*f**3*s**2 - 12360*Dd**2*Pk2*f**3*s + 960*Dd**2*Pk2*f**3 + 6048*Dd**2*Pk2*f**2*r*s - 1512*Dd**2*Pk2*f**2*r - 2592*Dd**2*Pk2*f**2*s**2 - 216*Dd**2*Pk2*f**2*s + 504*Dd**2*Pk2*f**2 + 12096*Dd**2*Pk2*f*g2*r*s - 3024*Dd**2*Pk2*f*g2*r - 3024*Dd**2*Pk2*f*g2*s + 1008*Dd**2*Pk2*f*g2 - 600*Dd**2*Pkdd2*f**3*k1**2*s**2 + 300*Dd**2*Pkdd2*f**3*k1**2*s - 324*Dd**2*Pkdd2*f**2*k1**2*s**2 + 162*Dd**2*Pkdd2*f**2*k1**2*s))/(3465*d**2*k1*k2) - D1**2*Pk1*ct**3*(-7656*D1**2*K*Pk2*bdd1*f**2*r*s + 6336*D1**2*Pk2*b2*f*fd*r*s - 3168*D1**2*Pk2*b2*f*fd*r - 3168*D1**2*Pk2*b2*f*fd*s - 3168*D1**2*Pk2*b2*f*fdd*r*s + 1584*D1**2*Pk2*b2*f*fdd*r + 1584*D1**2*Pk2*b2*f*fdd*s - 3168*D1**2*Pk2*b2*fd**2*r*s + 1584*D1**2*Pk2*b2*fd**2*r + 1584*D1**2*Pk2*b2*fd**2*s - 1584*D1**2*Pk2*b2*fd**2 + 3168*D1**2*Pk2*bd2*f**2*r*s - 6336*D1**2*Pk2*bd2*f*fd*r*s + 1584*D1**2*Pk2*bd2*f*fd*r + 1584*D1**2*Pk2*bd2*f*fd*s + 616*D1**2*Pk2*bdd1*f**3*r**2 + 4224*D1**2*Pk2*bdd1*f**3*r*s + 2904*D1**2*Pk2*bdd1*f**3*r + 7524*D1**2*Pk2*bdd1*f**3*s - 6622*D1**2*Pk2*bdd1*f**3 + 132*D1**2*Pk2*bdd1*f**2*r**2 + 4488*D1**2*Pk2*bdd1*f**2*r*s - 8910*D1**2*Pk2*bdd1*f**2*s**2 - 3696*D1**2*Pk2*bdd1*f*g2*r*s + 7392*D1**2*Pk2*bdd1*f*g2*r - 3696*D1**2*Pk2*bdd1*f*g2*s - 1584*D1**2*Pk2*bdd2*f**2*r*s - 7680*D1**2*Pk2*f**3*fd*r**2 - 28160*D1**2*Pk2*f**3*fd*r*s + 10880*D1**2*Pk2*f**3*fd*r - 39600*D1**2*Pk2*f**3*fd*s**2 + 26840*D1**2*Pk2*f**3*fd*s - 11820*D1**2*Pk2*f**3*fd + 2080*D1**2*Pk2*f**3*fdd*r**2 + 28160*D1**2*Pk2*f**3*fdd*r*s - 8080*D1**2*Pk2*f**3*fdd*r + 39600*D1**2*Pk2*f**3*fdd*s**2 - 26840*D1**2*Pk2*f**3*fdd*s + 10420*D1**2*Pk2*f**3*fdd + 6240*D1**2*Pk2*f**2*fd**2*r**2 + 84480*D1**2*Pk2*f**2*fd**2*r*s - 24240*D1**2*Pk2*f**2*fd**2*r + 118800*D1**2*Pk2*f**2*fd**2*s**2 - 80520*D1**2*Pk2*f**2*fd**2*s + 7040*D1**2*Pk2*f**2*fd**2 - 34320*D1**2*Pk2*f**2*gd2*r*s + 15312*D1**2*Pk2*f**2*gdd2*r*s - 68640*D1**2*Pk2*f*fd*g2*r*s + 34320*D1**2*Pk2*f*fd*g2*r + 34320*D1**2*Pk2*f*fd*g2*s + 61248*D1**2*Pk2*f*fd*gd2*r*s - 15312*D1**2*Pk2*f*fd*gd2*r - 15312*D1**2*Pk2*f*fd*gd2*s + 30624*D1**2*Pk2*f*fdd*g2*r*s - 15312*D1**2*Pk2*f*fdd*g2*r - 15312*D1**2*Pk2*f*fdd*g2*s + 30624*D1**2*Pk2*fd**2*g2*r*s - 15312*D1**2*Pk2*fd**2*g2*r - 15312*D1**2*Pk2*fd**2*g2*s + 15312*D1**2*Pk2*fd**2*g2 + 385*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 770*D1**2*Pkdd2*bdd1*f**3*k1**2*s + 385*D1**2*Pkdd2*bdd1*f**3*k1**2 + 1540*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 770*D1**2*Pkdd2*f**3*fd*k1**2*s + 385*D1**2*Pkdd2*f**3*fd*k1**2 - 66*D1**2*bd1**2*f*(-7*Pk2*r*(8*K - 8)*(s - 1) - 14*Pk2*s*(2*K - 31*s - 2) - 21*Pkdd2*k1**2*s*(s - 1) + 6*f*(Pk2*(4*r*(8*s - 3) + 98*s**2 - 61*s + 8) - 5*Pkdd2*k1**2*s*(s - 1))) + 12672*D1*Dd*Pk2*b2*f**2*r*s - 3168*D1*Dd*Pk2*b2*f**2*r - 3168*D1*Dd*Pk2*b2*f**2*s - 25344*D1*Dd*Pk2*b2*f*fd*r*s + 9504*D1*Dd*Pk2*b2*f*fd*r + 9504*D1*Dd*Pk2*b2*f*fd*s - 3168*D1*Dd*Pk2*b2*f*fd - 12672*D1*Dd*Pk2*bd2*f**2*r*s + 1584*D1*Dd*Pk2*bd2*f**2*r + 1584*D1*Dd*Pk2*bd2*f**2*s - 7680*D1*Dd*Pk2*f**4*r**2 - 28160*D1*Dd*Pk2*f**4*r*s + 10880*D1*Dd*Pk2*f**4*r - 39600*D1*Dd*Pk2*f**4*s**2 + 26840*D1*Dd*Pk2*f**4*s - 11820*D1*Dd*Pk2*f**4 + 16640*D1*Dd*Pk2*f**3*fd*r**2 + 225280*D1*Dd*Pk2*f**3*fd*r*s - 64640*D1*Dd*Pk2*f**3*fd*r + 316800*D1*Dd*Pk2*f**3*fd*s**2 - 214720*D1*Dd*Pk2*f**3*fd*s + 34920*D1*Dd*Pk2*f**3*fd - 137280*D1*Dd*Pk2*f**2*g2*r*s + 34320*D1*Dd*Pk2*f**2*g2*r + 34320*D1*Dd*Pk2*f**2*g2*s + 122496*D1*Dd*Pk2*f**2*gd2*r*s - 15312*D1*Dd*Pk2*f**2*gd2*r - 15312*D1*Dd*Pk2*f**2*gd2*s + 244992*D1*Dd*Pk2*f*fd*g2*r*s - 91872*D1*Dd*Pk2*f*fd*g2*r - 91872*D1*Dd*Pk2*f*fd*g2*s + 30624*D1*Dd*Pk2*f*fd*g2 + 1540*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 770*D1*Dd*Pkdd2*f**4*k1**2*s + 385*D1*Dd*Pkdd2*f**4*k1**2 - 6336*D1*Ddd*Pk2*b2*f**2*r*s + 1584*D1*Ddd*Pk2*b2*f**2*r + 1584*D1*Ddd*Pk2*b2*f**2*s + 2080*D1*Ddd*Pk2*f**4*r**2 + 28160*D1*Ddd*Pk2*f**4*r*s - 8080*D1*Ddd*Pk2*f**4*r + 39600*D1*Ddd*Pk2*f**4*s**2 - 26840*D1*Ddd*Pk2*f**4*s + 10420*D1*Ddd*Pk2*f**4 + 61248*D1*Ddd*Pk2*f**2*g2*r*s - 15312*D1*Ddd*Pk2*f**2*g2*r - 15312*D1*Ddd*Pk2*f**2*g2*s - 11*D1*bd1*(D1*(-12*Pk2*f*(4*fd*r**2 + fd*r*(-232*K*s + 58*K + 136*s - 36) + fd*s*(58*K - 270*s + 101) + 28*g2*(r*(2*s - 9) + 7*s) - 28*gd2*(2*r*(s - 1) + s)) + 336*Pk2*fd*g2*(r*(2*s - 1) - s + 1) + 2*f**3*(Pk2*(128*r**2 - 48*r*(s - 4) - 180*s**2 + 522*s - 341) - 5*Pkdd2*k1**2*(2*s**2 + 14*s - 7)) - f**2*(3*Pk2*(-64*r**2 + r*s*(520*K - 328) + 330*s**2) + 63*Pkdd2*k1**2*s**2 + fd*(8*Pk2*(42*r**2 + 288*r*s + 4*r + 123*s + 32) + 210*Pkdd2*k1**2*s*(s - 1)))) - 2*Dd*f*(6*Pk2*f*(8*r**2 + r*(-464*K*s + 58*K + 272*s - 36) + s*(58*K - 540*s + 101)) - 168*Pk2*g2*(r*(8*s - 9) + 3*s + 1) + f**2*(2*Pk2*(112*r**2 + 768*r*s + 140*r + 588*s - 237) + 35*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 19008*Dd**2*Pk2*b2*f**2*r*s + 4752*Dd**2*Pk2*b2*f**2*r + 4752*Dd**2*Pk2*b2*f**2*s - 1584*Dd**2*Pk2*b2*f**2 + 6240*Dd**2*Pk2*f**4*r**2 + 84480*Dd**2*Pk2*f**4*r*s - 24240*Dd**2*Pk2*f**4*r + 118800*Dd**2*Pk2*f**4*s**2 - 80520*Dd**2*Pk2*f**4*s + 7040*Dd**2*Pk2*f**4 + 183744*Dd**2*Pk2*f**2*g2*r*s - 45936*Dd**2*Pk2*f**2*g2*r - 45936*Dd**2*Pk2*f**2*g2*s + 15312*Dd**2*Pk2*f**2*g2 - 231*b1**3*(3*D1**2*Pkdd2*k1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(Pk2*(60*K - 60)*(r*(4*s - 1) - s) + Pkdd2*k1**2*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5)) - D1*Ddd*Pkdd2*k1**2*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*Pkdd2*k1**2*s*(3*f + 5)*(2*s - 1)) + 33*b1**2*(D1**2*(1680*Pk2*gd2*r*s + 7*Pkdd2*bdd1*k1**2*(3*f + 5)*(3*s**2 - 2*s + 1) - 14*bd1*(Pk2*(60*K - 60)*(r*(3*s - 1) - s) + Pkdd2*k1**2*(3*f + 5)*(3*s**2 - 2*s + 1)) - 12*fd**2*(4*Pk2*r*(8*s - 1) + Pk2*s*(98*s - 53) - 5*Pkdd2*k1**2*s**2) + fd*(2*Pk2*(252*K*s + 3*f*(16*r*(8*s - 1) + 252*s**2 - 142*s + 63) - 7*r*(4*K - 4)*(2*s + 7) + 259*s**2 - 770*s + 259) - Pkdd2*k1**2*(-126*bd1*s**2 + 42*bd1*s + 3*f*(26*s**2 + 14*s - 7) + 7*s**2 + 70*s - 35)) + fdd*(-6*Pk2*f*(8*r*(8*s - 1) + 196*s**2 - 106*s + 49) + 14*Pk2*(-8*K*s + r*(4*K - 4)*(s + 1) - 31*s**2 + 70*s - 31) + Pkdd2*k1**2*s**2*(60*f + 21))) + D1*(Dd*(28*Pk2*fd*(2*K*(r*(8*s + 3) - 9*s + 1) - 2*r*(8*s + 3) - 124*s**2 + 173*s - 33) + 1680*Pk2*g2*(r*(4*s - 1) - s) + 70*Pkdd2*bd1*k1**2*(12*s**2 - 7*s + 1) + 42*Pkdd2*fd*k1**2*s*(4*s - 1) + 3*f**2*(4*Pk2*(32*r*(4*s - 1) + 252*s**2 - 158*s + 63) - 13*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(-2*Pk2*(-56*K*s + 6*fd*(16*r*(16*s - 3) + 784*s**2 - 440*s + 57) + 7*r*(8*K - 8)*(4*s - 1) - 1036*s**2 + 574*s - 259) + Pkdd2*k1**2*(42*bd1*(12*s**2 - 7*s + 1) + s**2*(480*fd - 28) - s*(120*fd - 14) - 7))) + Ddd*f*(-12*Pk2*f*(16*r*(4*s - 1) + 196*s**2 - 114*s + 49) + 14*Pk2*(r*(4*K - 4)*(4*s - 1) - 124*s**2 + s*(66 - 4*K) - 31) + Pkdd2*k1**2*(30*f + 21)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(2*Pk2*(-7*K*(24*r*s - 6*r - 6*s + 2) + 6*f*(24*r*(4*s - 1) + 294*s**2 - 171*s + 8) + 168*r*s - 42*r + 1302*s**2 - 693*s + 14) + Pkdd2*k1**2*s*(-90*f - 63)*(2*s - 1))) + 11*b1*(3120*D1**2*K*Pk2*f*fd*r*s - 1560*D1**2*K*Pk2*f*fd*r - 1560*D1**2*K*Pk2*f*fd*s - 1392*D1**2*K*Pk2*f*fdd*r*s + 696*D1**2*K*Pk2*f*fdd*r + 696*D1**2*K*Pk2*f*fdd*s - 1392*D1**2*K*Pk2*fd**2*r*s + 696*D1**2*K*Pk2*fd**2*r + 696*D1**2*K*Pk2*fd**2*s - 696*D1**2*K*Pk2*fd**2 - 768*D1**2*Pk2*f**2*fd*r**2 + 288*D1**2*Pk2*f**2*fd*r*s + 800*D1**2*Pk2*f**2*fd*r + 1080*D1**2*Pk2*f**2*fd*s**2 + 228*D1**2*Pk2*f**2*fd*s - 578*D1**2*Pk2*f**2*fd + 168*D1**2*Pk2*f**2*fdd*r**2 + 1152*D1**2*Pk2*f**2*fdd*r*s - 760*D1**2*Pk2*f**2*fdd*r - 1068*D1**2*Pk2*f**2*fdd*s + 658*D1**2*Pk2*f**2*fdd + 336*D1**2*Pk2*f*fd**2*r**2 + 2304*D1**2*Pk2*f*fd**2*r*s - 1520*D1**2*Pk2*f*fd**2*r - 2136*D1**2*Pk2*f*fd**2*s + 128*D1**2*Pk2*f*fd**2 - 384*D1**2*Pk2*f*fd*r**2 - 1968*D1**2*Pk2*f*fd*r*s + 1368*D1**2*Pk2*f*fd*r + 1980*D1**2*Pk2*f*fd*s**2 - 996*D1**2*Pk2*f*fd*s + 798*D1**2*Pk2*f*fd + 24*D1**2*Pk2*f*fdd*r**2 + 816*D1**2*Pk2*f*fdd*r*s - 432*D1**2*Pk2*f*fdd*r - 1620*D1**2*Pk2*f*fdd*s**2 + 1212*D1**2*Pk2*f*fdd*s - 798*D1**2*Pk2*f*fdd + 672*D1**2*Pk2*f*gd2*r*s - 336*D1**2*Pk2*f*gdd2*r*s + 24*D1**2*Pk2*fd**2*r**2 + 816*D1**2*Pk2*fd**2*r*s - 432*D1**2*Pk2*fd**2*r - 1620*D1**2*Pk2*fd**2*s**2 + 1212*D1**2*Pk2*fd**2*s + 408*D1**2*Pk2*fd**2 + 672*D1**2*Pk2*fd*g2*r*s + 2352*D1**2*Pk2*fd*g2*r - 3024*D1**2*Pk2*fd*g2*s - 672*D1**2*Pk2*fd*gd2*r*s - 336*D1**2*Pk2*fd*gd2*r + 672*D1**2*Pk2*fd*gd2*s - 336*D1**2*Pk2*fdd*g2*r*s - 336*D1**2*Pk2*fdd*g2*r + 672*D1**2*Pk2*fdd*g2*s + 42*D1**2*Pkdd2*bd1**2*k1**2*s*(3*f + 5)*(3*s - 2) + 60*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 180*D1**2*Pkdd2*f**2*fd*k1**2*s + 90*D1**2*Pkdd2*f**2*fd*k1**2 + 105*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 210*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 126*D1**2*Pkdd2*f*fd*k1**2*s**2 - 126*D1**2*Pkdd2*f*fd*k1**2*s + 63*D1**2*Pkdd2*f*fd*k1**2 - 3*D1**2*bdd1*f*(-28*Pk2*(r*(4*K - 4)*(s - 1) + s*(2*K - 31*s - 2)) - 21*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + 6*f*(Pk2*(8*r*(8*s - 3) + 196*s**2 - 122*s + 49) - 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 6240*D1*Dd*K*Pk2*f**2*r*s - 1560*D1*Dd*K*Pk2*f**2*r - 1560*D1*Dd*K*Pk2*f**2*s - 11136*D1*Dd*K*Pk2*f*fd*r*s + 4176*D1*Dd*K*Pk2*f*fd*r + 4176*D1*Dd*K*Pk2*f*fd*s - 1392*D1*Dd*K*Pk2*f*fd - 1024*D1*Dd*Pk2*f**3*r**2 + 384*D1*Dd*Pk2*f**3*r*s + 416*D1*Dd*Pk2*f**3*r + 1440*D1*Dd*Pk2*f**3*s**2 - 816*D1*Dd*Pk2*f**3*s + 104*D1*Dd*Pk2*f**3 + 1344*D1*Dd*Pk2*f**2*fd*r**2 + 9216*D1*Dd*Pk2*f**2*fd*r*s - 4528*D1*Dd*Pk2*f**2*fd*r - 5424*D1*Dd*Pk2*f**2*fd*s + 1828*D1*Dd*Pk2*f**2*fd - 768*D1*Dd*Pk2*f**2*r**2 - 3936*D1*Dd*Pk2*f**2*r*s + 1368*D1*Dd*Pk2*f**2*r + 3960*D1*Dd*Pk2*f**2*s**2 - 996*D1*Dd*Pk2*f**2*s + 798*D1*Dd*Pk2*f**2 + 192*D1*Dd*Pk2*f*fd*r**2 + 6528*D1*Dd*Pk2*f*fd*r*s - 2592*D1*Dd*Pk2*f*fd*r - 12960*D1*Dd*Pk2*f*fd*s**2 + 7272*D1*Dd*Pk2*f*fd*s - 780*D1*Dd*Pk2*f*fd + 2688*D1*Dd*Pk2*f*g2*r*s - 672*D1*Dd*Pk2*f*g2*r - 672*D1*Dd*Pk2*f*g2*s - 2688*D1*Dd*Pk2*f*gd2*r*s + 336*D1*Dd*Pk2*f*gd2*r + 336*D1*Dd*Pk2*f*gd2*s - 2688*D1*Dd*Pk2*fd*g2*r*s - 1008*D1*Dd*Pk2*fd*g2*r + 3024*D1*Dd*Pk2*fd*g2*s - 336*D1*Dd*Pk2*fd*g2 + 80*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 40*D1*Dd*Pkdd2*f**3*k1**2*s + 20*D1*Dd*Pkdd2*f**3*k1**2 + 840*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 210*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 252*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 126*D1*Dd*Pkdd2*f**2*k1**2*s + 63*D1*Dd*Pkdd2*f**2*k1**2 - 2784*D1*Ddd*K*Pk2*f**2*r*s + 696*D1*Ddd*K*Pk2*f**2*r + 696*D1*Ddd*K*Pk2*f**2*s + 224*D1*Ddd*Pk2*f**3*r**2 + 1536*D1*Ddd*Pk2*f**3*r*s - 496*D1*Ddd*Pk2*f**3*r - 384*D1*Ddd*Pk2*f**3*s + 56*D1*Ddd*Pk2*f**3 + 48*D1*Ddd*Pk2*f**2*r**2 + 1632*D1*Ddd*Pk2*f**2*r*s - 432*D1*Ddd*Pk2*f**2*r - 3240*D1*Ddd*Pk2*f**2*s**2 + 1212*D1*Ddd*Pk2*f**2*s - 798*D1*Ddd*Pk2*f**2 - 1344*D1*Ddd*Pk2*f*g2*r*s + 336*D1*Ddd*Pk2*f*g2*r + 336*D1*Ddd*Pk2*f*g2*s + 140*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 70*D1*Ddd*Pkdd2*f**3*k1**2*s + 35*D1*Ddd*Pkdd2*f**3*k1**2 + 6*D1*bd1*(D1*(840*Pk2*g2*(r*(2*s - 1) - s) + 3*f**2*(16*Pk2*r*(8*s - 3) + 3*Pk2*(84*s**2 - 58*s + 21) + Pkdd2*k1**2*(-13*s**2 + 20*s - 10)) + f*(-7*Pk2*r*(4*K - 4)*(4*s - 9) - 14*Pk2*s*(14*K - 37*s - 14) - 7*Pkdd2*k1**2*(s**2 - 6*s + 3) - 12*fd*(2*Pk2*(32*r*s - 8*r + 98*s**2 - 57*s + 2) + 5*Pkdd2*k1**2*s*(1 - 2*s))) + 7*fd*(4*Pk2*(K*s*(4*r - 3) + K - 31*s**2 + s*(34 - 4*r) - 1) + 3*Pkdd2*k1**2*s*(2*s - 1))) + Dd*f*(-6*Pk2*f*(16*r*(16*s - 5) + 784*s**2 - 472*s + 73) + 28*Pk2*(2*K*r*(8*s - 5) + 2*K*s + K - 2*r*(8*s - 5) - 124*s**2 + 29*s - 1) + Pkdd2*k1**2*(30*f + 21)*(8*s**2 - 6*s + 1))) - 8352*Dd**2*K*Pk2*f**2*r*s + 2088*Dd**2*K*Pk2*f**2*r + 2088*Dd**2*K*Pk2*f**2*s - 696*Dd**2*K*Pk2*f**2 + 672*Dd**2*Pk2*f**3*r**2 + 4608*Dd**2*Pk2*f**3*r*s - 1488*Dd**2*Pk2*f**3*r - 1152*Dd**2*Pk2*f**3*s + 384*Dd**2*Pk2*f**3 + 144*Dd**2*Pk2*f**2*r**2 + 4896*Dd**2*Pk2*f**2*r*s - 1296*Dd**2*Pk2*f**2*r - 9720*Dd**2*Pk2*f**2*s**2 + 3636*Dd**2*Pk2*f**2*s + 408*Dd**2*Pk2*f**2 - 4032*Dd**2*Pk2*f*g2*r*s + 1008*Dd**2*Pk2*f*g2*r + 1008*Dd**2*Pk2*f*g2*s - 336*Dd**2*Pk2*f*g2 + 420*Dd**2*Pkdd2*f**3*k1**2*s**2 - 210*Dd**2*Pkdd2*f**3*k1**2*s))/(6930*d**2*k1*k2) - D1**2*Pk1*ct**3*k2**3*st**2*(108*D1**2*Pk2*b1*f*fd*r**2 - 180*D1**2*Pk2*b1*f*fdd*r**2 - 180*D1**2*Pk2*b1*fd**2*r**2 + 390*D1**2*Pk2*f**2*fd*r**2 - 260*D1**2*Pk2*f**2*fd*r + 130*D1**2*Pk2*f**2*fd - 222*D1**2*Pk2*f**2*fdd*r**2 + 148*D1**2*Pk2*f**2*fdd*r - 74*D1**2*Pk2*f**2*fdd - 444*D1**2*Pk2*f*fd**2*r**2 + 296*D1**2*Pk2*f*fd**2*r - 126*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 63*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 18*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 126*D1**2*Pkdd2*b1*f*fd*k1**2*s + 63*D1**2*Pkdd2*b1*f*fd*k1**2 + 54*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 54*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 126*D1**2*Pkdd2*bd1**2*f*k1**2*s*(s - 1) + 81*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 54*D1**2*Pkdd2*f**2*fd*k1**2*s + 27*D1**2*Pkdd2*f**2*fd*k1**2 - 9*D1**2*bdd1*f*(-7*Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1) + f*(10*Pk2*(r - 1)**2 - 3*Pkdd2*k1**2*(s - 1)**2)) + 216*D1*Dd*Pk2*b1*f**2*r**2 - 108*D1*Dd*Pk2*b1*f**2*r + 54*D1*Dd*Pk2*b1*f**2 - 1440*D1*Dd*Pk2*b1*f*fd*r**2 + 360*D1*Dd*Pk2*b1*f*fd*r + 520*D1*Dd*Pk2*f**3*r**2 - 260*D1*Dd*Pk2*f**3*r + 130*D1*Dd*Pk2*f**3 - 1776*D1*Dd*Pk2*f**2*fd*r**2 + 1036*D1*Dd*Pk2*f**2*fd*r - 148*D1*Dd*Pk2*f**2*fd - 504*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 252*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 126*D1*Dd*Pkdd2*b1**2*f*k1**2 + 504*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 126*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 36*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 18*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 9*D1*Dd*Pkdd2*b1*f**2*k1**2 + 432*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 108*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 108*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 54*D1*Dd*Pkdd2*f**3*k1**2*s + 27*D1*Dd*Pkdd2*f**3*k1**2 - 360*D1*Ddd*Pk2*b1*f**2*r**2 + 180*D1*Ddd*Pk2*b1*f**2*r - 90*D1*Ddd*Pk2*b1*f**2 - 296*D1*Ddd*Pk2*f**3*r**2 + 148*D1*Ddd*Pk2*f**3*r - 74*D1*Ddd*Pk2*f**3 + 252*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 126*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 63*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 108*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 54*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 27*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 9*D1*bd1*(D1*(14*Pkdd2*b1*fd*k1**2*s*(2*s - 1) + f**2*(6*Pk2*(r - 1)**2 + Pkdd2*k1**2*(s**2 + 12*s - 6)) - 2*f*(20*Pk2*fd*r*(r - 1) + 7*Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1) - 6*Pkdd2*fd*k1**2*s*(s - 1))) + 2*Dd*f*(-10*Pk2*f*(4*r**2 - 5*r + 1) + 7*Pkdd2*b1*k1**2*(8*s**2 - 6*s + 1) + 3*Pkdd2*f*k1**2*(4*s**2 - 5*s + 1))) - 1080*Dd**2*Pk2*b1*f**2*r**2 + 540*Dd**2*Pk2*b1*f**2*r - 888*Dd**2*Pk2*f**3*r**2 + 444*Dd**2*Pk2*f**3*r + 756*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 378*Dd**2*Pkdd2*b1**2*f*k1**2*s + 324*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 162*Dd**2*Pkdd2*b1*f**2*k1**2*s)/(315*d**2*k1**3*k3**2) + D1**2*Pk1*ct**3*k2**3*(D1*f*(-28*D1*Pk2*bd1**2*r*(r - 1) + 26*D1*Pk2*bdd1*f*r**2 + bd1*(52*D1*Pk2*fd*r*(2*r - 1) + D1*f*(46*Pk2*r**2 - 21*Pkdd2*k1**2*(s - 1)**2) + 52*Dd*Pk2*f*r*(4*r - 1))) + 7*b1**2*(D1**2*(14*Pk2*fd*r**2 - 2*Pk2*fdd*r**2 - 5*Pkdd2*fd*k1**2*s**2) + D1*Dd*(14*Pk2*f*(4*r**2 - 2*r + 1) + 4*Pk2*fd*r*(1 - 4*r) - 5*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 2*D1*Ddd*Pk2*f*(4*r**2 - 2*r + 1) + 12*Dd**2*Pk2*f*r*(1 - 2*r)) + b1*(-14*D1**2*Pk2*bdd1*f*(2*r**2 - 2*r + 1) + 92*D1**2*Pk2*f*fd*r**2 - 92*D1**2*Pk2*f*fd*r + 46*D1**2*Pk2*f*fd + 52*D1**2*Pk2*f*fdd*r**2 - 52*D1**2*Pk2*f*fdd*r + 26*D1**2*Pk2*f*fdd + 52*D1**2*Pk2*fd**2*r**2 - 52*D1**2*Pk2*fd**2*r - 42*D1**2*Pkdd2*f*fd*k1**2*s**2 + 184*D1*Dd*Pk2*f**2*r**2 - 92*D1*Dd*Pk2*f**2*r + 46*D1*Dd*Pk2*f**2 + 416*D1*Dd*Pk2*f*fd*r**2 - 312*D1*Dd*Pk2*f*fd*r + 52*D1*Dd*Pk2*f*fd - 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 42*D1*Dd*Pkdd2*f**2*k1**2*s - 21*D1*Dd*Pkdd2*f**2*k1**2 + 104*D1*Ddd*Pk2*f**2*r**2 - 52*D1*Ddd*Pk2*f**2*r + 26*D1*Ddd*Pk2*f**2 + 7*D1*bd1*(D1*(14*Pk2*f*(2*r**2 - 2*r + 1) + 4*Pk2*fd*r*(1 - 2*r) - 5*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) - 4*Dd*Pk2*f*(8*r**2 - 6*r + 1)) + 312*Dd**2*Pk2*f**2*r**2 - 156*Dd**2*Pk2*f**2*r))/(210*d**2*k1**3*k3**2) - D1**2*Pk1*ct**3*k2*st**2*(1650*D1**2*Pk2*b1*f**2*fd*r**2 - 2310*D1**2*Pk2*b1*f**2*fdd*r**2 - 4620*D1**2*Pk2*b1*f*fd**2*r**2 + 2920*D1**2*Pk2*f**3*fd*r**2 - 1460*D1**2*Pk2*f**3*fd*r + 730*D1**2*Pk2*f**3*fd - 2120*D1**2*Pk2*f**3*fdd*r**2 + 1060*D1**2*Pk2*f**3*fdd*r - 530*D1**2*Pk2*f**3*fdd - 6360*D1**2*Pk2*f**2*fd**2*r**2 + 3180*D1**2*Pk2*f**2*fd**2*r - 3960*D1**2*Pkdd2*b1**2*f*fd*k1**2*s**2 + 1980*D1**2*Pkdd2*b1**2*f*fd*k1**2*s - 990*D1**2*Pkdd2*b1**2*f*fd*k1**2 + 1980*D1**2*Pkdd2*b1**2*f*fdd*k1**2*s**2 - 990*D1**2*Pkdd2*b1**2*f*fdd*k1**2*s + 495*D1**2*Pkdd2*b1**2*f*fdd*k1**2 + 1980*D1**2*Pkdd2*b1**2*fd**2*k1**2*s**2 - 990*D1**2*Pkdd2*b1**2*fd**2*k1**2*s - 1386*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 2772*D1**2*Pkdd2*b1**2*fd*k1**2*s - 1386*D1**2*Pkdd2*b1**2*fd*k1**2 + 693*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 1386*D1**2*Pkdd2*b1**2*fdd*k1**2*s + 693*D1**2*Pkdd2*b1**2*fdd*k1**2 - 1815*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 110*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 55*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 1650*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 550*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 275*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 3300*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 1100*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 1188*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 1188*D1**2*Pkdd2*b1*f*fd*k1**2*s - 594*D1**2*Pkdd2*b1*f*fd*k1**2 + 594*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 594*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 297*D1**2*Pkdd2*b1*f*fdd*k1**2 + 594*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 594*D1**2*Pkdd2*b1*fd**2*k1**2*s + 198*D1**2*Pkdd2*bd1**2*f*k1**2*s*(5*f*(2*s - 1) + 7*s) + 1100*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 550*D1**2*Pkdd2*f**3*fd*k1**2*s + 275*D1**2*Pkdd2*f**3*fd*k1**2 - 11*D1**2*bdd1*f*(-126*Pkdd2*b1*k1**2*s**2 - 9*Pkdd2*f*k1**2*(5*b1*(4*s**2 - 2*s + 1) + 3*s**2) + 5*f**2*(14*Pk2*(r - 1)**2 - 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 2200*D1*Dd*Pk2*b1*f**3*r**2 - 1100*D1*Dd*Pk2*b1*f**3*r + 550*D1*Dd*Pk2*b1*f**3 - 18480*D1*Dd*Pk2*b1*f**2*fd*r**2 + 4620*D1*Dd*Pk2*b1*f**2*fd*r + 2920*D1*Dd*Pk2*f**4*r**2 - 1460*D1*Dd*Pk2*f**4*r + 730*D1*Dd*Pk2*f**4 - 16960*D1*Dd*Pk2*f**3*fd*r**2 + 8480*D1*Dd*Pk2*f**3*fd*r - 1060*D1*Dd*Pk2*f**3*fd - 7920*D1*Dd*Pkdd2*b1**2*f**2*k1**2*s**2 + 3960*D1*Dd*Pkdd2*b1**2*f**2*k1**2*s - 1980*D1*Dd*Pkdd2*b1**2*f**2*k1**2 + 15840*D1*Dd*Pkdd2*b1**2*f*fd*k1**2*s**2 - 7920*D1*Dd*Pkdd2*b1**2*f*fd*k1**2*s + 990*D1*Dd*Pkdd2*b1**2*f*fd*k1**2 - 5544*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 2772*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 1386*D1*Dd*Pkdd2*b1**2*f*k1**2 + 5544*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 6930*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 1386*D1*Dd*Pkdd2*b1**2*fd*k1**2 - 2420*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 1210*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 605*D1*Dd*Pkdd2*b1*f**3*k1**2 + 13200*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 5500*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 550*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 2376*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 1188*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 594*D1*Dd*Pkdd2*b1*f**2*k1**2 + 4752*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 3564*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 594*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 1100*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 550*D1*Dd*Pkdd2*f**4*k1**2*s + 275*D1*Dd*Pkdd2*f**4*k1**2 - 3080*D1*Ddd*Pk2*b1*f**3*r**2 + 1540*D1*Ddd*Pk2*b1*f**3*r - 770*D1*Ddd*Pk2*b1*f**3 - 2120*D1*Ddd*Pk2*f**4*r**2 + 1060*D1*Ddd*Pk2*f**4*r - 530*D1*Ddd*Pk2*f**4 + 3960*D1*Ddd*Pkdd2*b1**2*f**2*k1**2*s**2 - 1980*D1*Ddd*Pkdd2*b1**2*f**2*k1**2*s + 990*D1*Ddd*Pkdd2*b1**2*f**2*k1**2 + 2772*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 1386*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 693*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 2200*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 1100*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 550*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 1188*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 594*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 297*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 11*D1*bd1*(D1*(252*Pkdd2*b1*fd*k1**2*s*(s - 1) + 18*Pkdd2*f*k1**2*s*(-14*b1*s + fd*(20*b1 + 3)*(2*s - 1)) + 5*f**3*(10*Pk2*(r - 1)**2 + Pkdd2*k1**2*(-11*s**2 + 20*s - 10)) - 2*f**2*(210*Pk2*fd*r*(r - 1) + 45*Pkdd2*b1*k1**2*(4*s**2 - 2*s + 1) + 50*Pkdd2*fd*k1**2*s*(2 - 3*s) + 27*Pkdd2*k1**2*s**2)) + 2*Dd*f*(126*Pkdd2*b1*k1**2*s*(4*s - 1) + 9*Pkdd2*f*k1**2*(4*s - 1)*(5*b1*(4*s - 1) + 3*s) - 5*f**2*(14*Pk2*(4*r**2 - 5*r + 1) - 5*Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) - 9240*Dd**2*Pk2*b1*f**3*r**2 + 4620*Dd**2*Pk2*b1*f**3*r - 6360*Dd**2*Pk2*f**4*r**2 + 3180*Dd**2*Pk2*f**4*r + 11880*Dd**2*Pkdd2*b1**2*f**2*k1**2*s**2 - 5940*Dd**2*Pkdd2*b1**2*f**2*k1**2*s + 8316*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 4158*Dd**2*Pkdd2*b1**2*f*k1**2*s + 6600*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 3300*Dd**2*Pkdd2*b1*f**3*k1**2*s + 3564*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 1782*Dd**2*Pkdd2*b1*f**2*k1**2*s)/(3465*d**2*k1**3) + D1**2*Pk1*ct**3*k2*(D1*f*(2*D1*Pk2*bdd1*f*r**2*(14*f + 13) + bd1**2*(4*D1*Pk2*r*(6*f - 7)*(r - 1) - 6*D1*Pkdd2*k1**2*s*(5*f + 7)*(s - 1)) + bd1*(D1*(52*Pk2*fd*r*(2*r - 1) + f**2*(52*Pk2*r**2 - 15*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(56*Pk2*fd*r*(3*r - 1) + 46*Pk2*r**2 - 21*Pkdd2*k1**2*s**2)) + 4*Dd*Pk2*f*r*(14*f + 13)*(4*r - 1))) + 7*Pkdd2*b1**3*k1**2*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + b1**2*(D1**2*(120*Pk2*f*fd*r**2 + 24*Pk2*f*fdd*r**2 + 24*Pk2*fd**2*r**2 + 98*Pk2*fd*r**2 - 14*Pk2*fdd*r**2 + 14*Pkdd2*bd1*k1**2*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - 7*Pkdd2*bdd1*k1**2*(3*f + 5)*(3*s**2 - 2*s + 1) - 24*Pkdd2*f*fd*k1**2*s**2 + 42*Pkdd2*f*fd*k1**2*s - 21*Pkdd2*f*fd*k1**2 - 30*Pkdd2*f*fdd*k1**2*s**2 - 30*Pkdd2*fd**2*k1**2*s**2 + 7*Pkdd2*fd*k1**2*s**2 + 70*Pkdd2*fd*k1**2*s - 35*Pkdd2*fd*k1**2 - 21*Pkdd2*fdd*k1**2*s**2) + D1*(Dd*(-28*Pk2*fd*r*(4*r - 1) - 70*Pkdd2*bd1*k1**2*(12*s**2 - 7*s + 1) - 42*Pkdd2*fd*k1**2*s*(4*s - 1) + 12*f**2*(5*Pk2*(4*r**2 - 2*r + 1) + Pkdd2*k1**2*(-4*s**2 + 2*s - 1)) + f*(2*Pk2*(r**2*(96*fd + 196) - r*(24*fd + 98) + 49) + Pkdd2*k1**2*(-42*bd1*(12*s**2 - 7*s + 1) - s**2*(240*fd - 28) + s*(60*fd - 14) + 7))) + Ddd*f*(Pk2*(12*f - 14)*(4*r**2 - 2*r + 1) - Pkdd2*k1**2*(15*f + 21)*(4*s**2 - 2*s + 1))) + 6*Dd**2*f*(Pk2*r*(12*f - 14)*(2*r - 1) - Pkdd2*k1**2*s*(15*f + 21)*(2*s - 1))) + b1*(156*D1**2*Pk2*f**2*fd*r**2 - 104*D1**2*Pk2*f**2*fd*r + 52*D1**2*Pk2*f**2*fd + 84*D1**2*Pk2*f**2*fdd*r**2 - 56*D1**2*Pk2*f**2*fdd*r + 28*D1**2*Pk2*f**2*fdd + 168*D1**2*Pk2*f*fd**2*r**2 - 112*D1**2*Pk2*f*fd**2*r + 92*D1**2*Pk2*f*fd*r**2 - 92*D1**2*Pk2*f*fd*r + 46*D1**2*Pk2*f*fd + 52*D1**2*Pk2*f*fdd*r**2 - 52*D1**2*Pk2*f*fdd*r + 26*D1**2*Pk2*f*fdd + 52*D1**2*Pk2*fd**2*r**2 - 52*D1**2*Pk2*fd**2*r - 14*D1**2*Pkdd2*bd1**2*k1**2*s*(3*f + 5)*(3*s - 2) - 90*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 30*D1**2*Pkdd2*f**2*fd*k1**2*s - 15*D1**2*Pkdd2*f**2*fd*k1**2 - 42*D1**2*Pkdd2*f*fd*k1**2*s**2 + 42*D1**2*Pkdd2*f*fd*k1**2*s - 21*D1**2*Pkdd2*f*fd*k1**2 + D1**2*bdd1*f*(Pk2*(12*f - 14)*(2*r**2 - 2*r + 1) - Pkdd2*k1**2*(15*f + 21)*(2*s**2 - 2*s + 1)) + 208*D1*Dd*Pk2*f**3*r**2 - 104*D1*Dd*Pk2*f**3*r + 52*D1*Dd*Pk2*f**3 + 672*D1*Dd*Pk2*f**2*fd*r**2 - 392*D1*Dd*Pk2*f**2*fd*r + 56*D1*Dd*Pk2*f**2*fd + 184*D1*Dd*Pk2*f**2*r**2 - 92*D1*Dd*Pk2*f**2*r + 46*D1*Dd*Pk2*f**2 + 416*D1*Dd*Pk2*f*fd*r**2 - 312*D1*Dd*Pk2*f*fd*r + 52*D1*Dd*Pk2*f*fd - 120*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 60*D1*Dd*Pkdd2*f**3*k1**2*s - 30*D1*Dd*Pkdd2*f**3*k1**2 - 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 42*D1*Dd*Pkdd2*f**2*k1**2*s - 21*D1*Dd*Pkdd2*f**2*k1**2 + 112*D1*Ddd*Pk2*f**3*r**2 - 56*D1*Ddd*Pk2*f**3*r + 28*D1*Ddd*Pk2*f**3 + 104*D1*Ddd*Pk2*f**2*r**2 - 52*D1*Ddd*Pk2*f**2*r + 26*D1*Ddd*Pk2*f**2 + D1*bd1*(D1*(3*f**2*(20*Pk2*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-8*s**2 - 6*s + 3)) + 2*f*(Pk2*(r**2*(48*fd + 98) - r*(24*fd + 98) + 49) + Pkdd2*k1**2*(s**2*(7 - 60*fd) + s*(30*fd - 42) + 21)) + 14*fd*(2*Pk2*r*(1 - 2*r) + 3*Pkdd2*k1**2*s*(1 - 2*s))) + 4*Dd*Pk2*f*(6*f - 7)*(8*r**2 - 6*r + 1) - 6*Dd*Pkdd2*f*k1**2*(5*f + 7)*(8*s**2 - 6*s + 1)) + 336*Dd**2*Pk2*f**3*r**2 - 168*Dd**2*Pk2*f**3*r + 312*Dd**2*Pk2*f**2*r**2 - 156*Dd**2*Pk2*f**2*r))/(210*d**2*k1**3) + D1**2*Pk1*ct**2*st**4*(-168*Pk2*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 3*b1*(-736*C*D1**2*Pk2*f*fd*r*s + 368*C*D1**2*Pk2*f*fd*r - 1272*C*D1**2*Pk2*f*fd*s**2 + 1304*C*D1**2*Pk2*f*fd*s - 652*C*D1**2*Pk2*f*fd + 480*C*D1**2*Pk2*f*fdd*r*s - 240*C*D1**2*Pk2*f*fdd*r + 888*C*D1**2*Pk2*f*fdd*s**2 - 904*C*D1**2*Pk2*f*fdd*s + 452*C*D1**2*Pk2*f*fdd + 480*C*D1**2*Pk2*fd**2*r*s - 240*C*D1**2*Pk2*fd**2*r + 888*C*D1**2*Pk2*fd**2*s**2 - 904*C*D1**2*Pk2*fd**2*s + 4*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 4*C*D1**2*Pkdd2*f*fd*k1**2*s + 2*C*D1**2*Pkdd2*f*fd*k1**2 - 2*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 2*C*D1**2*Pkdd2*f*fdd*k1**2*s - C*D1**2*Pkdd2*f*fdd*k1**2 - 2*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 2*C*D1**2*Pkdd2*fd**2*k1**2*s - 1472*C*D1*Dd*Pk2*f**2*r*s + 368*C*D1*Dd*Pk2*f**2*r - 2544*C*D1*Dd*Pk2*f**2*s**2 + 1640*C*D1*Dd*Pk2*f**2*s - 636*C*D1*Dd*Pk2*f**2 + 3840*C*D1*Dd*Pk2*f*fd*r*s - 1440*C*D1*Dd*Pk2*f*fd*r + 7104*C*D1*Dd*Pk2*f*fd*s**2 - 5872*C*D1*Dd*Pk2*f*fd*s + 1144*C*D1*Dd*Pk2*f*fd + 8*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 4*C*D1*Dd*Pkdd2*f**2*k1**2*s + 2*C*D1*Dd*Pkdd2*f**2*k1**2 - 16*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 12*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 2*C*D1*Dd*Pkdd2*f*fd*k1**2 + 960*C*D1*Ddd*Pk2*f**2*r*s - 240*C*D1*Ddd*Pk2*f**2*r + 1776*C*D1*Ddd*Pk2*f**2*s**2 - 1128*C*D1*Ddd*Pk2*f**2*s + 444*C*D1*Ddd*Pk2*f**2 - 4*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 2*C*D1*Ddd*Pkdd2*f**2*k1**2*s - C*D1*Ddd*Pkdd2*f**2*k1**2 + 2880*C*Dd**2*Pk2*f**2*r*s - 720*C*Dd**2*Pk2*f**2*r + 5328*C*Dd**2*Pk2*f**2*s**2 - 3384*C*Dd**2*Pk2*f**2*s + 240*C*Dd**2*Pk2*f**2 - 12*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 6*C*Dd**2*Pkdd2*f**2*k1**2*s - 56*D1**2*Pk2*bdd1*f*(C - 1)*(2*s**2 - 2*s + 1) + 976*D1**2*Pk2*f*fd*r*s - 488*D1**2*Pk2*f*fd*r + 632*D1**2*Pk2*f*fd*s**2 - 664*D1**2*Pk2*f*fd*s + 332*D1**2*Pk2*f*fd - 600*D1**2*Pk2*f*fdd*r*s + 300*D1**2*Pk2*f*fdd*r - 568*D1**2*Pk2*f*fdd*s**2 + 584*D1**2*Pk2*f*fdd*s - 292*D1**2*Pk2*f*fdd - 600*D1**2*Pk2*fd**2*r*s + 300*D1**2*Pk2*fd**2*r - 568*D1**2*Pk2*fd**2*s**2 + 584*D1**2*Pk2*fd**2*s - 24*D1**2*Pkdd2*f*fd*k1**2*s**2 + 24*D1**2*Pkdd2*f*fd*k1**2*s - 12*D1**2*Pkdd2*f*fd*k1**2 + 12*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 12*D1**2*Pkdd2*f*fdd*k1**2*s + 6*D1**2*Pkdd2*f*fdd*k1**2 + 12*D1**2*Pkdd2*fd**2*k1**2*s**2 - 12*D1**2*Pkdd2*fd**2*k1**2*s + 1952*D1*Dd*Pk2*f**2*r*s - 488*D1*Dd*Pk2*f**2*r + 1264*D1*Dd*Pk2*f**2*s**2 - 1120*D1*Dd*Pk2*f**2*s + 316*D1*Dd*Pk2*f**2 - 4800*D1*Dd*Pk2*f*fd*r*s + 1800*D1*Dd*Pk2*f*fd*r - 4544*D1*Dd*Pk2*f*fd*s**2 + 4072*D1*Dd*Pk2*f*fd*s - 884*D1*Dd*Pk2*f*fd - 48*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 24*D1*Dd*Pkdd2*f**2*k1**2*s - 12*D1*Dd*Pkdd2*f**2*k1**2 + 96*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 72*D1*Dd*Pkdd2*f*fd*k1**2*s + 12*D1*Dd*Pkdd2*f*fd*k1**2 - 1200*D1*Ddd*Pk2*f**2*r*s + 300*D1*Ddd*Pk2*f**2*r - 1136*D1*Ddd*Pk2*f**2*s**2 + 868*D1*Ddd*Pk2*f**2*s - 284*D1*Ddd*Pk2*f**2 + 24*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 12*D1*Ddd*Pkdd2*f**2*k1**2*s + 6*D1*Ddd*Pkdd2*f**2*k1**2 + 112*D1*Pk2*bd1*(C - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 3600*Dd**2*Pk2*f**2*r*s + 900*Dd**2*Pk2*f**2*r - 3408*Dd**2*Pk2*f**2*s**2 + 2604*Dd**2*Pk2*f**2*s - 300*Dd**2*Pk2*f**2 + 72*Dd**2*Pkdd2*f**2*k1**2*s**2 - 36*Dd**2*Pkdd2*f**2*k1**2*s) + f*(1008*C*D1**2*Pk2*f*fd*r*s - 336*C*D1**2*Pk2*f*fd*r + 1524*C*D1**2*Pk2*f*fd*s**2 - 1352*C*D1**2*Pk2*f*fd*s + 508*C*D1**2*Pk2*f*fd - 720*C*D1**2*Pk2*f*fdd*r*s + 240*C*D1**2*Pk2*f*fdd*r - 924*C*D1**2*Pk2*f*fdd*s**2 + 856*C*D1**2*Pk2*f*fdd*s - 308*C*D1**2*Pk2*f*fdd - 1440*C*D1**2*Pk2*fd**2*r*s + 480*C*D1**2*Pk2*fd**2*r - 1848*C*D1**2*Pk2*fd**2*s**2 + 1712*C*D1**2*Pk2*fd**2*s - 240*C*D1**2*Pk2*fd**2 - 6*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 4*C*D1**2*Pkdd2*f*fd*k1**2*s - 2*C*D1**2*Pkdd2*f*fd*k1**2 + 3*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 2*C*D1**2*Pkdd2*f*fdd*k1**2*s + C*D1**2*Pkdd2*f*fdd*k1**2 + 6*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 4*C*D1**2*Pkdd2*fd**2*k1**2*s + 1344*C*D1*Dd*Pk2*f**2*r*s - 336*C*D1*Dd*Pk2*f**2*r + 2032*C*D1*Dd*Pk2*f**2*s**2 - 1352*C*D1*Dd*Pk2*f**2*s + 508*C*D1*Dd*Pk2*f**2 - 5760*C*D1*Dd*Pk2*f*fd*r*s + 1680*C*D1*Dd*Pk2*f*fd*r - 7392*C*D1*Dd*Pk2*f*fd*s**2 + 5992*C*D1*Dd*Pk2*f*fd*s - 1096*C*D1*Dd*Pk2*f*fd - 8*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 4*C*D1*Dd*Pkdd2*f**2*k1**2*s - 2*C*D1*Dd*Pkdd2*f**2*k1**2 + 24*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 14*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 2*C*D1*Dd*Pkdd2*f*fd*k1**2 - 960*C*D1*Ddd*Pk2*f**2*r*s + 240*C*D1*Ddd*Pk2*f**2*r - 1232*C*D1*Ddd*Pk2*f**2*s**2 + 856*C*D1*Ddd*Pk2*f**2*s - 308*C*D1*Ddd*Pk2*f**2 + 4*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 2*C*D1*Ddd*Pkdd2*f**2*k1**2*s + C*D1*Ddd*Pkdd2*f**2*k1**2 - 2880*C*Dd**2*Pk2*f**2*r*s + 720*C*Dd**2*Pk2*f**2*r - 3696*C*Dd**2*Pk2*f**2*s**2 + 2568*C*Dd**2*Pk2*f**2*s - 240*C*Dd**2*Pk2*f**2 + 12*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 6*C*Dd**2*Pkdd2*f**2*k1**2*s + 336*D1**2*Pk2*bd1**2*s*(C - 1)*(s - 1) - 1560*D1**2*Pk2*f*fd*r*s + 520*D1**2*Pk2*f*fd*r - 564*D1**2*Pk2*f*fd*s**2 + 896*D1**2*Pk2*f*fd*s - 188*D1**2*Pk2*f*fd + 1140*D1**2*Pk2*f*fdd*r*s - 380*D1**2*Pk2*f*fdd*r + 444*D1**2*Pk2*f*fdd*s**2 - 676*D1**2*Pk2*f*fdd*s + 148*D1**2*Pk2*f*fdd + 2280*D1**2*Pk2*fd**2*r*s - 760*D1**2*Pk2*fd**2*r + 888*D1**2*Pk2*fd**2*s**2 - 1352*D1**2*Pk2*fd**2*s + 380*D1**2*Pk2*fd**2 + 36*D1**2*Pkdd2*f*fd*k1**2*s**2 - 24*D1**2*Pkdd2*f*fd*k1**2*s + 12*D1**2*Pkdd2*f*fd*k1**2 - 18*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 12*D1**2*Pkdd2*f*fdd*k1**2*s - 6*D1**2*Pkdd2*f*fdd*k1**2 - 36*D1**2*Pkdd2*fd**2*k1**2*s**2 + 24*D1**2*Pkdd2*fd**2*k1**2*s - 3*D1**2*bdd1*f*(4*Pk2*(C*(60*r*s + 111*s**2 - 56*s - 2) - 75*r*s - 71*s**2 + 71*s + 2) - Pkdd2*k1**2*s**2*(C - 6)) - 2080*D1*Dd*Pk2*f**2*r*s + 520*D1*Dd*Pk2*f**2*r - 752*D1*Dd*Pk2*f**2*s**2 + 896*D1*Dd*Pk2*f**2*s - 188*D1*Dd*Pk2*f**2 + 9120*D1*Dd*Pk2*f*fd*r*s - 2660*D1*Dd*Pk2*f*fd*r + 3552*D1*Dd*Pk2*f*fd*s**2 - 4732*D1*Dd*Pk2*f*fd*s + 1056*D1*Dd*Pk2*f*fd + 48*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 24*D1*Dd*Pkdd2*f**2*k1**2*s + 12*D1*Dd*Pkdd2*f**2*k1**2 - 144*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 84*D1*Dd*Pkdd2*f*fd*k1**2*s - 12*D1*Dd*Pkdd2*f*fd*k1**2 + 1520*D1*Ddd*Pk2*f**2*r*s - 380*D1*Ddd*Pk2*f**2*r + 592*D1*Ddd*Pk2*f**2*s**2 - 676*D1*Ddd*Pk2*f**2*s + 148*D1*Ddd*Pk2*f**2 - 24*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 12*D1*Ddd*Pkdd2*f**2*k1**2*s - 6*D1*Ddd*Pkdd2*f**2*k1**2 + 6*D1*bd1*(D1*(2*Pk2*f*(C*(92*r*s + 159*s**2 - 84*s - 4) - 122*r*s - 79*s**2 + 114*s + 4) - 2*Pk2*fd*(C*(60*r*(4*s - 1) + 444*s**2 - 338*s + 60) - 300*r*s + 75*r - 284*s**2 + 288*s - 75) - Pkdd2*f*k1**2*s**2*(C - 6) + Pkdd2*fd*k1**2*s*(C - 6)*(2*s - 1)) + Dd*f*(-2*Pk2*(C*(60*r*(8*s - 1) + 888*s**2 - 506*s + 56) - 600*r*s + 75*r - 568*s**2 + 501*s - 71) + Pkdd2*k1**2*s*(C - 6)*(4*s - 1))) + 4560*Dd**2*Pk2*f**2*r*s - 1140*Dd**2*Pk2*f**2*r + 1776*Dd**2*Pk2*f**2*s**2 - 2028*Dd**2*Pk2*f**2*s + 380*Dd**2*Pk2*f**2 - 72*Dd**2*Pkdd2*f**2*k1**2*s**2 + 36*Dd**2*Pkdd2*f**2*k1**2*s))/(105*d**2*k3**2) - D1**2*Pk1*ct**2*st**2*(-7*b1**2*(D1**2*s*(2*fd*(Pk2*r*(52*C - 64) + Pk2*s*(39*C - 39) - Pkdd2*k1**2*s*(C - 4)) + fdd*(Pk2*r*(84 - 72*C) - Pk2*s*(74*C - 74) + Pkdd2*k1**2*s*(C - 4))) + D1*(2*Dd*(Pk2*f*(13*C*(4*r*(4*s - 1) + 12*s**2 - 10*s + 3) - 64*r*(4*s - 1) - 156*s**2 + 142*s - 39) - 2*Pk2*fd*(r*(18*C - 21)*(8*s - 1) + s*(C*(148*s - 55) - 148*s + 58)) - Pkdd2*f*k1**2*(C - 4)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(C - 4)*(4*s - 1)) + Ddd*f*(Pk2*(C*(-72*r*(4*s - 1) - 296*s**2 + 220*s - 74) + 84*r*(4*s - 1) + 296*s**2 - 232*s + 74) + Pkdd2*k1**2*(C - 4)*(4*s**2 - 2*s + 1))) - 6*Dd**2*f*(2*Pk2*(C*(72*r*s - 18*r + 74*s**2 - 55*s + 6) - 84*r*s + 21*r - 74*s**2 + 58*s - 7) + Pkdd2*k1**2*s*(-2*C*s + C + 8*s - 4))) + b1*(344*C*D1**2*Pk2*f*fd*r**2 + 3336*C*D1**2*Pk2*f*fd*r*s - 1932*C*D1**2*Pk2*f*fd*r + 2964*C*D1**2*Pk2*f*fd*s**2 - 3072*C*D1**2*Pk2*f*fd*s + 1668*C*D1**2*Pk2*f*fd - 312*C*D1**2*Pk2*f*fdd*r**2 - 2424*C*D1**2*Pk2*f*fdd*r*s + 1428*C*D1**2*Pk2*f*fdd*r - 2812*C*D1**2*Pk2*f*fdd*s**2 + 2880*C*D1**2*Pk2*f*fdd*s - 1548*C*D1**2*Pk2*f*fdd - 312*C*D1**2*Pk2*fd**2*r**2 - 2424*C*D1**2*Pk2*fd**2*r*s + 1428*C*D1**2*Pk2*fd**2*r - 2812*C*D1**2*Pk2*fd**2*s**2 + 2880*C*D1**2*Pk2*fd**2*s - 74*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 86*C*D1**2*Pkdd2*f*fd*k1**2*s - 43*C*D1**2*Pkdd2*f*fd*k1**2 + 30*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 36*C*D1**2*Pkdd2*f*fdd*k1**2*s + 18*C*D1**2*Pkdd2*f*fdd*k1**2 + 30*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 36*C*D1**2*Pkdd2*fd**2*k1**2*s + 688*C*D1*Dd*Pk2*f**2*r**2 + 6672*C*D1*Dd*Pk2*f**2*r*s - 2012*C*D1*Dd*Pk2*f**2*r + 5928*C*D1*Dd*Pk2*f**2*s**2 - 4632*C*D1*Dd*Pk2*f**2*s + 1654*C*D1*Dd*Pk2*f**2 - 2496*C*D1*Dd*Pk2*f*fd*r**2 - 19392*C*D1*Dd*Pk2*f*fd*r*s + 8760*C*D1*Dd*Pk2*f*fd*r - 22496*C*D1*Dd*Pk2*f*fd*s**2 + 19568*C*D1*Dd*Pk2*f*fd*s - 4308*C*D1*Dd*Pk2*f*fd - 148*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 74*C*D1*Dd*Pkdd2*f**2*k1**2*s - 37*C*D1*Dd*Pkdd2*f**2*k1**2 + 240*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 204*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 36*C*D1*Dd*Pkdd2*f*fd*k1**2 - 624*C*D1*Ddd*Pk2*f**2*r**2 - 4848*C*D1*Ddd*Pk2*f**2*r*s + 1524*C*D1*Ddd*Pk2*f**2*r - 5624*C*D1*Ddd*Pk2*f**2*s**2 + 4024*C*D1*Ddd*Pk2*f**2*s - 1562*C*D1*Ddd*Pk2*f**2 + 60*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 30*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 15*C*D1*Ddd*Pkdd2*f**2*k1**2 - 1872*C*Dd**2*Pk2*f**2*r**2 - 14544*C*Dd**2*Pk2*f**2*r*s + 4572*C*Dd**2*Pk2*f**2*r - 16872*C*Dd**2*Pk2*f**2*s**2 + 12072*C*Dd**2*Pk2*f**2*s - 1212*C*Dd**2*Pk2*f**2 + 180*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 90*C*Dd**2*Pkdd2*f**2*k1**2*s - 512*D1**2*Pk2*f*fd*r**2 - 2804*D1**2*Pk2*f*fd*r*s + 1778*D1**2*Pk2*f*fd*r - 240*D1**2*Pk2*f*fd*s**2 + 236*D1**2*Pk2*f*fd*s - 306*D1**2*Pk2*f*fd + 480*D1**2*Pk2*f*fdd*r**2 + 1836*D1**2*Pk2*f*fdd*r*s - 1218*D1**2*Pk2*f*fdd*r + 568*D1**2*Pk2*f*fdd*s**2 - 552*D1**2*Pk2*f*fdd*s + 426*D1**2*Pk2*f*fdd + 480*D1**2*Pk2*fd**2*r**2 + 1836*D1**2*Pk2*fd**2*r*s - 1218*D1**2*Pk2*fd**2*r + 568*D1**2*Pk2*fd**2*s**2 - 552*D1**2*Pk2*fd**2*s + 8*D1**2*Pkdd2*f*fd*k1**2*s**2 - 56*D1**2*Pkdd2*f*fd*k1**2*s + 28*D1**2*Pkdd2*f*fd*k1**2 + 24*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 24*D1**2*Pkdd2*fd**2*k1**2*s**2 + 7*D1**2*bdd1*f*(2*Pk2*(C*(72*r*s - 36*r + 74*s**2 - 110*s + 37) - 84*r*s + 42*r - 74*s**2 + 116*s - 37) - Pkdd2*k1**2*(C - 4)*(2*s**2 - 2*s + 1)) - 1024*D1*Dd*Pk2*f**2*r**2 - 5608*D1*Dd*Pk2*f**2*r*s + 1914*D1*Dd*Pk2*f**2*r - 480*D1*Dd*Pk2*f**2*s**2 + 1642*D1*Dd*Pk2*f**2*s - 376*D1*Dd*Pk2*f**2 + 3840*D1*Dd*Pk2*f*fd*r**2 + 14688*D1*Dd*Pk2*f*fd*r*s - 7668*D1*Dd*Pk2*f*fd*r + 4544*D1*Dd*Pk2*f*fd*s**2 - 5180*D1*Dd*Pk2*f*fd*s + 1770*D1*Dd*Pk2*f*fd + 16*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 8*D1*Dd*Pkdd2*f**2*k1**2*s + 4*D1*Dd*Pkdd2*f**2*k1**2 + 192*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 48*D1*Dd*Pkdd2*f*fd*k1**2*s + 960*D1*Ddd*Pk2*f**2*r**2 + 3672*D1*Ddd*Pk2*f**2*r*s - 1398*D1*Ddd*Pk2*f**2*r + 1136*D1*Ddd*Pk2*f**2*s**2 - 1486*D1*Ddd*Pk2*f**2*s + 524*D1*Ddd*Pk2*f**2 + 48*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 24*D1*Ddd*Pkdd2*f**2*k1**2*s + 12*D1*Ddd*Pkdd2*f**2*k1**2 - 14*D1*bd1*(D1*(Pk2*f*(13*C*(r*(8*s - 4) + 6*s**2 - 10*s + 3) - 64*r*(2*s - 1) - 78*s**2 + 142*s - 39) - 2*Pk2*fd*(r*(18*C - 21)*(4*s - 1) + s*(C*(74*s - 55) - 74*s + 58)) - Pkdd2*f*k1**2*(C - 4)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(C - 4)*(2*s - 1)) + Dd*f*(-2*Pk2*(C*(36*r*(8*s - 3) + 296*s**2 - 330*s + 73) - 42*r*(8*s - 3) - 296*s**2 + 348*s - 79) + Pkdd2*k1**2*(C - 4)*(8*s**2 - 6*s + 1))) + 2880*Dd**2*Pk2*f**2*r**2 + 11016*Dd**2*Pk2*f**2*r*s - 4194*Dd**2*Pk2*f**2*r + 3408*Dd**2*Pk2*f**2*s**2 - 4458*Dd**2*Pk2*f**2*s + 918*Dd**2*Pk2*f**2 + 144*Dd**2*Pkdd2*f**2*k1**2*s**2 - 72*Dd**2*Pkdd2*f**2*k1**2*s) + f*(240*C*D1**2*Pk2*f*fd*r**2 + 3204*C*D1**2*Pk2*f*fd*r*s - 1228*C*D1**2*Pk2*f*fd*r + 1884*C*D1**2*Pk2*f*fd*s**2 - 2324*C*D1**2*Pk2*f*fd*s + 708*C*D1**2*Pk2*f*fd - 300*C*D1**2*Pk2*f*fdd*r**2 - 2412*C*D1**2*Pk2*f*fdd*r*s + 1004*C*D1**2*Pk2*f*fdd*r - 1716*C*D1**2*Pk2*f*fdd*s**2 + 1948*C*D1**2*Pk2*f*fdd*s - 672*C*D1**2*Pk2*f*fdd - 600*C*D1**2*Pk2*fd**2*r**2 - 4824*C*D1**2*Pk2*fd**2*r*s + 2008*C*D1**2*Pk2*fd**2*r - 3432*C*D1**2*Pk2*fd**2*s**2 + 3896*C*D1**2*Pk2*fd**2*s - 804*C*D1**2*Pk2*fd**2 - 69*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 46*C*D1**2*Pkdd2*f*fd*k1**2*s - 23*C*D1**2*Pkdd2*f*fd*k1**2 + 30*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 20*C*D1**2*Pkdd2*f*fdd*k1**2*s + 10*C*D1**2*Pkdd2*f*fdd*k1**2 + 60*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 40*C*D1**2*Pkdd2*fd**2*k1**2*s + 320*C*D1*Dd*Pk2*f**2*r**2 + 4272*C*D1*Dd*Pk2*f**2*r*s - 1228*C*D1*Dd*Pk2*f**2*r + 2512*C*D1*Dd*Pk2*f**2*s**2 - 2324*C*D1*Dd*Pk2*f**2*s + 708*C*D1*Dd*Pk2*f**2 - 2400*C*D1*Dd*Pk2*f*fd*r**2 - 19296*C*D1*Dd*Pk2*f*fd*r*s + 7028*C*D1*Dd*Pk2*f*fd*r - 13728*C*D1*Dd*Pk2*f*fd*s**2 + 13636*C*D1*Dd*Pk2*f*fd*s - 2952*C*D1*Dd*Pk2*f*fd - 92*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 46*C*D1*Dd*Pkdd2*f**2*k1**2*s - 23*C*D1*Dd*Pkdd2*f**2*k1**2 + 240*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 140*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 20*C*D1*Dd*Pkdd2*f*fd*k1**2 - 400*C*D1*Ddd*Pk2*f**2*r**2 - 3216*C*D1*Ddd*Pk2*f**2*r*s + 1004*C*D1*Ddd*Pk2*f**2*r - 2288*C*D1*Ddd*Pk2*f**2*s**2 + 1948*C*D1*Ddd*Pk2*f**2*s - 672*C*D1*Ddd*Pk2*f**2 + 40*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 20*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 10*C*D1*Ddd*Pkdd2*f**2*k1**2 - 1200*C*Dd**2*Pk2*f**2*r**2 - 9648*C*Dd**2*Pk2*f**2*r*s + 3012*C*Dd**2*Pk2*f**2*r - 6864*C*Dd**2*Pk2*f**2*s**2 + 5844*C*Dd**2*Pk2*f**2*s - 804*C*Dd**2*Pk2*f**2 + 120*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 60*C*Dd**2*Pkdd2*f**2*k1**2*s - 564*D1**2*Pk2*f*fd*r**2 - 3030*D1**2*Pk2*f*fd*r*s + 1386*D1**2*Pk2*f*fd*r - 78*D1**2*Pk2*f*fd*s**2 + 1062*D1**2*Pk2*f*fd*s - 214*D1**2*Pk2*f*fd + 624*D1**2*Pk2*f*fdd*r**2 + 2046*D1**2*Pk2*f*fdd*r*s - 1098*D1**2*Pk2*f*fdd*r + 246*D1**2*Pk2*f*fdd*s**2 - 846*D1**2*Pk2*f*fdd*s + 290*D1**2*Pk2*f*fdd + 1248*D1**2*Pk2*fd**2*r**2 + 4092*D1**2*Pk2*fd**2*r*s - 2196*D1**2*Pk2*fd**2*r + 492*D1**2*Pk2*fd**2*s**2 - 1692*D1**2*Pk2*fd**2*s + 682*D1**2*Pk2*fd**2 + 36*D1**2*Pkdd2*f*fd*k1**2*s**2 - 24*D1**2*Pkdd2*f*fd*k1**2*s + 12*D1**2*Pkdd2*f*fd*k1**2 + 14*D1**2*bd1**2*(2*Pk2*(C*(36*r*s - 18*r + 37*s**2 - 55*s + 18) - 42*r*s + 21*r - 37*s**2 + 58*s - 21) - Pkdd2*k1**2*s*(C - 4)*(s - 1)) + D1**2*bdd1*f*(-2*Pk2*(C*(78*r**2 + 606*r*s - 48*r + 703*s**2 - 572*s + 7) - 120*r**2 - 459*r*s + 90*r - 142*s**2 + 467*s - 49) + 3*Pkdd2*k1**2*(C*(5*s**2 + 2*s - 1) + 4*(s - 1)**2)) - 752*D1*Dd*Pk2*f**2*r**2 - 4040*D1*Dd*Pk2*f**2*r*s + 1386*D1*Dd*Pk2*f**2*r - 104*D1*Dd*Pk2*f**2*s**2 + 1062*D1*Dd*Pk2*f**2*s - 214*D1*Dd*Pk2*f**2 + 4992*D1*Dd*Pk2*f*fd*r**2 + 16368*D1*Dd*Pk2*f*fd*r*s - 7686*D1*Dd*Pk2*f*fd*r + 1968*D1*Dd*Pk2*f*fd*s**2 - 5922*D1*Dd*Pk2*f*fd*s + 1944*D1*Dd*Pk2*f*fd + 48*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 24*D1*Dd*Pkdd2*f**2*k1**2*s + 12*D1*Dd*Pkdd2*f**2*k1**2 + 832*D1*Ddd*Pk2*f**2*r**2 + 2728*D1*Ddd*Pk2*f**2*r*s - 1098*D1*Ddd*Pk2*f**2*r + 328*D1*Ddd*Pk2*f**2*s**2 - 846*D1*Ddd*Pk2*f**2*s + 290*D1*Ddd*Pk2*f**2 + D1*bd1*(D1*(2*Pk2*f*(C*(86*r**2 + 834*r*s - 40*r + 741*s**2 - 780*s - 7) - 128*r**2 - 701*r*s + 68*r - 60*s**2 + 703*s - 35) + 2*Pk2*fd*(-2*C*(156*r**2 + 1212*r*s - 405*r + 1406*s**2 - 1292*s + 303) + 480*r**2 + 1836*r*s - 789*r + 568*s**2 - 1210*s + 459) + Pkdd2*f*k1**2*(C*(-37*s**2 - 12*s + 6) + 4*s**2 + 48*s - 24) + 12*Pkdd2*fd*k1**2*s*(5*C*s - 2*C + 4*s - 4)) + 2*Dd*f*(Pk2*(-2*C*(312*r**2 + 2424*r*s - 477*r + 2812*s**2 - 2150*s + 310) + 960*r**2 + 3672*r*s - 1059*r + 1136*s**2 - 2611*s + 557) + 3*Pkdd2*k1**2*(4*s - 1)*(5*C*s + C + 4*s - 4))) + 2496*Dd**2*Pk2*f**2*r**2 + 8184*Dd**2*Pk2*f**2*r*s - 3294*Dd**2*Pk2*f**2*r + 984*Dd**2*Pk2*f**2*s**2 - 2538*Dd**2*Pk2*f**2*s + 682*Dd**2*Pk2*f**2))/(105*d**2*k3**2) - D1**2*Pk1*ct**2*(21*b1**2*(D1**2*(3*C*Pkdd2*fdd*k1**2*s**2 + Pk2*fd*(r**2*(52*C - 62) + r*s*(132*C - 147) + s**2*(72*C - 72)) + Pk2*fdd*(r**2*(36 - 26*C) + r*s*(131 - 116*C) - s**2*(76*C - 76)) + Pkdd2*fd*k1**2*s**2*(10 - 11*C)) + D1*(Dd*(6*C*Pkdd2*fd*k1**2*s*(4*s - 1) + Pk2*f*(4*C*(52*r**2 + 132*r*s - 59*r + 72*s**2 - 69*s + 31) - 248*r**2 - 588*r*s + 271*r - 288*s**2 + 291*s - 134) + Pk2*fd*(r**2*(288 - 208*C) + r*(-928*C*s + 168*C + 1048*s - 203) + s*(-608*C*s + 268*C + 608*s - 283)) - Pkdd2*f*k1**2*(11*C - 10)*(4*s**2 - 2*s + 1)) + Ddd*f*(3*C*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + Pk2*(-2*C*(52*r**2 + 232*r*s - 84*r + 152*s**2 - 134*s + 51) + 144*r**2 + 524*r*s - 203*r + 304*s**2 - 283*s + 112))) + Dd**2*f*(18*C*Pkdd2*k1**2*s*(2*s - 1) + Pk2*(-4*C*(78*r**2 + 6*r*(58*s - 21) + 228*s**2 - 201*s + 29) + 432*r**2 + 1572*r*s - 609*r + 912*s**2 - 849*s + 131))) + 3*b1*(376*C*D1**2*Pk2*f*fd*r**2 + 576*C*D1**2*Pk2*f*fd*r*s - 180*C*D1**2*Pk2*f*fd*r - 328*C*D1**2*Pk2*f*fd*s**2 + 132*C*D1**2*Pk2*f*fd*s - 120*C*D1**2*Pk2*f*fd - 160*C*D1**2*Pk2*f*fdd*r**2 - 288*C*D1**2*Pk2*f*fdd*r*s - 120*C*D1**2*Pk2*f*fdd*r + 304*C*D1**2*Pk2*f*fdd*s**2 - 276*C*D1**2*Pk2*f*fdd*s + 270*C*D1**2*Pk2*f*fdd - 160*C*D1**2*Pk2*fd**2*r**2 - 288*C*D1**2*Pk2*fd**2*r*s - 120*C*D1**2*Pk2*fd**2*r + 304*C*D1**2*Pk2*fd**2*s**2 - 276*C*D1**2*Pk2*fd**2*s - 60*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 42*C*D1**2*Pkdd2*f*fd*k1**2*s + 21*C*D1**2*Pkdd2*f*fd*k1**2 + 30*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 30*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 752*C*D1*Dd*Pk2*f**2*r**2 + 1152*C*D1*Dd*Pk2*f**2*r*s - 664*C*D1*Dd*Pk2*f**2*r - 656*C*D1*Dd*Pk2*f**2*s**2 + 40*C*D1*Dd*Pk2*f**2*s + 24*C*D1*Dd*Pk2*f**2 - 1280*C*D1*Dd*Pk2*f*fd*r**2 - 2304*C*D1*Dd*Pk2*f*fd*r*s + 128*C*D1*Dd*Pk2*f*fd*r + 2432*C*D1*Dd*Pk2*f*fd*s**2 - 1424*C*D1*Dd*Pk2*f*fd*s + 396*C*D1*Dd*Pk2*f*fd - 120*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 60*C*D1*Dd*Pkdd2*f**2*k1**2*s - 30*C*D1*Dd*Pkdd2*f**2*k1**2 + 240*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 60*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 320*C*D1*Ddd*Pk2*f**2*r**2 - 576*C*D1*Ddd*Pk2*f**2*r*s + 304*C*D1*Ddd*Pk2*f**2*r + 608*C*D1*Ddd*Pk2*f**2*s**2 - 160*C*D1*Ddd*Pk2*f**2*s + 72*C*D1*Ddd*Pk2*f**2 + 60*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 30*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 15*C*D1*Ddd*Pkdd2*f**2*k1**2 - 960*C*Dd**2*Pk2*f**2*r**2 - 1728*C*Dd**2*Pk2*f**2*r*s + 912*C*Dd**2*Pk2*f**2*r + 1824*C*Dd**2*Pk2*f**2*s**2 - 480*C*Dd**2*Pk2*f**2*s - 144*C*Dd**2*Pk2*f**2 + 180*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 90*C*Dd**2*Pkdd2*f**2*k1**2*s - 840*D1**2*Pk2*f*fd*r**2 - 1988*D1**2*Pk2*f*fd*r*s + 1067*D1**2*Pk2*f*fd*r - 1184*D1**2*Pk2*f*fd*s**2 + 1523*D1**2*Pk2*f*fd*s - 798*D1**2*Pk2*f*fd + 504*D1**2*Pk2*f*fdd*r**2 + 1652*D1**2*Pk2*f*fdd*r*s - 635*D1**2*Pk2*f*fdd*r + 1208*D1**2*Pk2*f*fdd*s**2 - 1367*D1**2*Pk2*f*fdd*s + 588*D1**2*Pk2*f*fdd + 504*D1**2*Pk2*fd**2*r**2 + 1652*D1**2*Pk2*fd**2*r*s - 635*D1**2*Pk2*fd**2*r + 1208*D1**2*Pk2*fd**2*s**2 - 1367*D1**2*Pk2*fd**2*s + 84*D1**2*Pkdd2*f*fd*k1**2*s**2 - 7*D1**2*bdd1*f*(-3*C*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + Pk2*(2*C*(26*r**2 + 116*r*s - 84*r + 76*s**2 - 134*s + 51) - 72*r**2 - 262*r*s + 203*r - 152*s**2 + 283*s - 112)) - 1680*D1*Dd*Pk2*f**2*r**2 - 3976*D1*Dd*Pk2*f**2*r*s + 1834*D1*Dd*Pk2*f**2*r - 2368*D1*Dd*Pk2*f**2*s**2 + 2178*D1*Dd*Pk2*f**2*s - 1012*D1*Dd*Pk2*f**2 + 4032*D1*Dd*Pk2*f*fd*r**2 + 13216*D1*Dd*Pk2*f*fd*r*s - 5200*D1*Dd*Pk2*f*fd*r + 9664*D1*Dd*Pk2*f*fd*s**2 - 9536*D1*Dd*Pk2*f*fd*s + 2002*D1*Dd*Pk2*f*fd + 168*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 84*D1*Dd*Pkdd2*f**2*k1**2*s + 42*D1*Dd*Pkdd2*f**2*k1**2 + 1008*D1*Ddd*Pk2*f**2*r**2 + 3304*D1*Ddd*Pk2*f**2*r*s - 1330*D1*Ddd*Pk2*f**2*r + 2416*D1*Ddd*Pk2*f**2*s**2 - 2034*D1*Ddd*Pk2*f**2*s + 856*D1*Ddd*Pk2*f**2 + 7*D1*bd1*(D1*(6*C*Pkdd2*fd*k1**2*s*(2*s - 1) + Pk2*f*(4*C*(26*r**2 + 66*r*s - 59*r + 36*s**2 - 69*s + 31) - 124*r**2 - 294*r*s + 271*r - 144*s**2 + 291*s - 134) + Pk2*fd*(r**2*(144 - 104*C) + r*(-464*C*s + 168*C + 524*s - 203) + s*(-304*C*s + 268*C + 304*s - 283)) - Pkdd2*f*k1**2*(11*C - 10)*(2*s**2 - 2*s + 1)) + 2*Dd*f*(3*C*Pkdd2*k1**2*(8*s**2 - 6*s + 1) + Pk2*(-2*C*(104*r**2 + 464*r*s - 252*r + 304*s**2 - 402*s + 109) + 288*r**2 + 1048*r*s - 609*r + 608*s**2 - 849*s + 243))) + 3024*Dd**2*Pk2*f**2*r**2 + 9912*Dd**2*Pk2*f**2*r*s - 3990*Dd**2*Pk2*f**2*r + 7248*Dd**2*Pk2*f**2*s**2 - 6102*Dd**2*Pk2*f**2*s + 826*Dd**2*Pk2*f**2) + f*(-1248*C*D1**2*Pk2*f*fd*r**2 - 3564*C*D1**2*Pk2*f*fd*r*s + 2020*C*D1**2*Pk2*f*fd*r - 2268*C*D1**2*Pk2*f*fd*s**2 + 2700*C*D1**2*Pk2*f*fd*s - 1172*C*D1**2*Pk2*f*fd + 678*C*D1**2*Pk2*f*fdd*r**2 + 3564*C*D1**2*Pk2*f*fdd*r*s - 1640*C*D1**2*Pk2*f*fdd*r + 2268*C*D1**2*Pk2*f*fdd*s**2 - 2700*C*D1**2*Pk2*f*fdd*s + 982*C*D1**2*Pk2*f*fdd + 1356*C*D1**2*Pk2*fd**2*r**2 + 7128*C*D1**2*Pk2*fd**2*r*s - 3280*C*D1**2*Pk2*fd**2*r + 4536*C*D1**2*Pk2*fd**2*s**2 - 5400*C*D1**2*Pk2*fd**2*s + 1188*C*D1**2*Pk2*fd**2 + 135*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 90*C*D1**2*Pkdd2*f*fd*k1**2*s + 45*C*D1**2*Pkdd2*f*fd*k1**2 - 1664*C*D1*Dd*Pk2*f**2*r**2 - 4752*C*D1*Dd*Pk2*f**2*r*s + 2020*C*D1*Dd*Pk2*f**2*r - 3024*C*D1*Dd*Pk2*f**2*s**2 + 2700*C*D1*Dd*Pk2*f**2*s - 1172*C*D1*Dd*Pk2*f**2 + 5424*C*D1*Dd*Pk2*f*fd*r**2 + 28512*C*D1*Dd*Pk2*f*fd*r*s - 11480*C*D1*Dd*Pk2*f*fd*r + 18144*C*D1*Dd*Pk2*f*fd*s**2 - 18900*C*D1*Dd*Pk2*f*fd*s + 4340*C*D1*Dd*Pk2*f*fd + 180*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 90*C*D1*Dd*Pkdd2*f**2*k1**2*s + 45*C*D1*Dd*Pkdd2*f**2*k1**2 + 904*C*D1*Ddd*Pk2*f**2*r**2 + 4752*C*D1*Ddd*Pk2*f**2*r*s - 1640*C*D1*Ddd*Pk2*f**2*r + 3024*C*D1*Ddd*Pk2*f**2*s**2 - 2700*C*D1*Ddd*Pk2*f**2*s + 982*C*D1*Ddd*Pk2*f**2 + 2712*C*Dd**2*Pk2*f**2*r**2 + 14256*C*Dd**2*Pk2*f**2*r*s - 4920*C*Dd**2*Pk2*f**2*r + 9072*C*Dd**2*Pk2*f**2*s**2 - 8100*C*Dd**2*Pk2*f**2*s + 1188*C*Dd**2*Pk2*f**2 + 270*D1**2*Pk2*f*fd*r**2 - 1077*D1**2*Pk2*f*fd*r*s + 179*D1**2*Pk2*f*fd*r - 1944*D1**2*Pk2*f*fd*s**2 + 1655*D1**2*Pk2*f*fd*s - 558*D1**2*Pk2*f*fd + 957*D1**2*Pk2*f*fdd*r*s - 319*D1**2*Pk2*f*fdd*r + 1944*D1**2*Pk2*f*fdd*s**2 - 1615*D1**2*Pk2*f*fdd*s + 648*D1**2*Pk2*f*fdd + 1914*D1**2*Pk2*fd**2*r*s - 638*D1**2*Pk2*fd**2*r + 3888*D1**2*Pk2*fd**2*s**2 - 3230*D1**2*Pk2*fd**2*s + 319*D1**2*Pk2*fd**2 - 21*D1**2*bd1**2*(-6*C*Pkdd2*k1**2*s*(s - 1) + Pk2*(4*C*(13*r**2 + 58*r*s - 42*r + 38*s**2 - 67*s + 29) - 72*r**2 - 262*r*s + 203*r - 152*s**2 + 283*s - 131)) - 3*D1**2*bdd1*f*(-15*C*Pkdd2*k1**2*(s - 1)**2 + Pk2*(2*C*(40*r**2 + 72*r*s - 212*r - 76*s**2 - 58*s + 99) - 252*r**2 - 826*r*s + 695*r - 604*s**2 + 667*s - 268)) + 360*D1*Dd*Pk2*f**2*r**2 - 1436*D1*Dd*Pk2*f**2*r*s + 179*D1*Dd*Pk2*f**2*r - 2592*D1*Dd*Pk2*f**2*s**2 + 1655*D1*Dd*Pk2*f**2*s - 558*D1*Dd*Pk2*f**2 + 7656*D1*Dd*Pk2*f*fd*r*s - 2233*D1*Dd*Pk2*f*fd*r + 15552*D1*Dd*Pk2*f*fd*s**2 - 11305*D1*Dd*Pk2*f*fd*s + 1934*D1*Dd*Pk2*f*fd + 1276*D1*Ddd*Pk2*f**2*r*s - 319*D1*Ddd*Pk2*f**2*r + 2592*D1*Ddd*Pk2*f**2*s**2 - 1615*D1*Ddd*Pk2*f**2*s + 648*D1*Ddd*Pk2*f**2 + 3*D1*bd1*(D1*(60*C*Pkdd2*fd*k1**2*s*(s - 1) + Pk2*f*(4*C*(47*r**2 + 72*r*s - 121*r - 41*s**2 - 23*s + 36) - 420*r**2 - 994*r*s + 767*r - 592*s**2 + 655*s - 214) + Pk2*fd*(-4*C*(80*r**2 + 2*r*(72*s - 91) - 152*s**2 + 11*s + 36) + 1008*r**2 + 3304*r*s - 2025*r + 2416*s**2 - 2701*s + 826) + 3*Pkdd2*f*k1**2*(C*(-10*s**2 + 34*s - 17) + 14*(s - 1)**2)) + 2*Dd*f*(15*C*Pkdd2*k1**2*(4*s**2 - 5*s + 1) + Pk2*(-2*C*(160*r**2 + 288*r*s - 500*r - 304*s**2 - 76*s + 135) + 1008*r**2 + 3304*r*s - 2055*r + 2416*s**2 - 2351*s + 681))) + 3828*Dd**2*Pk2*f**2*r*s - 957*Dd**2*Pk2*f**2*r + 7776*Dd**2*Pk2*f**2*s**2 - 4845*Dd**2*Pk2*f**2*s + 319*Dd**2*Pk2*f**2))/(315*d**2*k3**2) + D1**2*Pk1*ct**2*k2**2*st**4*(-60*C*D1**2*Pk2*b1*f*fd*r**2 - 96*C*D1**2*Pk2*b1*f*fdd*r**2 - 96*C*D1**2*Pk2*b1*fd**2*r**2 - 150*C*D1**2*Pk2*f**2*fd*r**2 + 100*C*D1**2*Pk2*f**2*fd*r - 50*C*D1**2*Pk2*f**2*fd + 228*C*D1**2*Pk2*f**2*fdd*r**2 - 152*C*D1**2*Pk2*f**2*fdd*r + 76*C*D1**2*Pk2*f**2*fdd + 456*C*D1**2*Pk2*f*fd**2*r**2 - 304*C*D1**2*Pk2*f*fd**2*r - 42*C*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 21*C*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 210*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 222*C*D1**2*Pkdd2*b1*f*fd*k1**2*s + 111*C*D1**2*Pkdd2*b1*f*fd*k1**2 - 84*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 90*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 45*C*D1**2*Pkdd2*b1*f*fdd*k1**2 - 84*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 90*C*D1**2*Pkdd2*b1*fd**2*k1**2*s + 99*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 66*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 33*C*D1**2*Pkdd2*f**2*fd*k1**2 - 45*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 30*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 15*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 90*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 60*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 120*C*D1*Dd*Pk2*b1*f**2*r**2 + 60*C*D1*Dd*Pk2*b1*f**2*r - 30*C*D1*Dd*Pk2*b1*f**2 - 768*C*D1*Dd*Pk2*b1*f*fd*r**2 + 192*C*D1*Dd*Pk2*b1*f*fd*r - 200*C*D1*Dd*Pk2*f**3*r**2 + 100*C*D1*Dd*Pk2*f**3*r - 50*C*D1*Dd*Pk2*f**3 + 1824*C*D1*Dd*Pk2*f**2*fd*r**2 - 1064*C*D1*Dd*Pk2*f**2*fd*r + 152*C*D1*Dd*Pk2*f**2*fd - 168*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 84*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 42*C*D1*Dd*Pkdd2*b1**2*f*k1**2 + 168*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 42*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 420*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 210*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 105*C*D1*Dd*Pkdd2*b1*f**2*k1**2 - 672*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 528*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 90*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 132*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 66*C*D1*Dd*Pkdd2*f**3*k1**2*s + 33*C*D1*Dd*Pkdd2*f**3*k1**2 - 360*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 210*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 30*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 192*C*D1*Ddd*Pk2*b1*f**2*r**2 + 96*C*D1*Ddd*Pk2*b1*f**2*r - 48*C*D1*Ddd*Pk2*b1*f**2 + 304*C*D1*Ddd*Pk2*f**3*r**2 - 152*C*D1*Ddd*Pk2*f**3*r + 76*C*D1*Ddd*Pk2*f**3 + 84*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 42*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 21*C*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 168*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 84*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 42*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 60*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 30*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 15*C*D1*Ddd*Pkdd2*f**3*k1**2 - 576*C*Dd**2*Pk2*b1*f**2*r**2 + 288*C*Dd**2*Pk2*b1*f**2*r + 912*C*Dd**2*Pk2*f**3*r**2 - 456*C*Dd**2*Pk2*f**3*r + 252*C*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 126*C*Dd**2*Pkdd2*b1**2*f*k1**2*s - 504*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 252*C*Dd**2*Pkdd2*b1*f**2*k1**2*s - 180*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 90*C*Dd**2*Pkdd2*f**3*k1**2*s + 60*D1**2*Pk2*b1*f*fd*r**2 - 288*D1**2*Pk2*b1*f*fd*r*s + 144*D1**2*Pk2*b1*f*fd*r + 96*D1**2*Pk2*b1*f*fdd*r**2 + 60*D1**2*Pk2*b1*f*fdd*r*s - 30*D1**2*Pk2*b1*f*fdd*r + 96*D1**2*Pk2*b1*fd**2*r**2 + 60*D1**2*Pk2*b1*fd**2*r*s - 30*D1**2*Pk2*b1*fd**2*r + 150*D1**2*Pk2*f**2*fd*r**2 - 192*D1**2*Pk2*f**2*fd*r*s - 36*D1**2*Pk2*f**2*fd*r + 64*D1**2*Pk2*f**2*fd*s + 50*D1**2*Pk2*f**2*fd - 228*D1**2*Pk2*f**2*fdd*r**2 + 150*D1**2*Pk2*f**2*fdd*r*s + 102*D1**2*Pk2*f**2*fdd*r - 50*D1**2*Pk2*f**2*fdd*s - 76*D1**2*Pk2*f**2*fdd - 456*D1**2*Pk2*f*fd**2*r**2 + 300*D1**2*Pk2*f*fd**2*r*s + 204*D1**2*Pk2*f*fd**2*r - 100*D1**2*Pk2*f*fd**2*s + 50*D1**2*Pk2*f*fd**2 + 42*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 21*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 18*D1**2*Pkdd2*b1*f*fd*k1**2*s + 9*D1**2*Pkdd2*b1*f*fd*k1**2 - 36*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 15*D1**2*Pkdd2*b1*f*fdd*k1**2 - 36*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 30*D1**2*Pkdd2*b1*fd**2*k1**2*s + 42*D1**2*Pkdd2*bd1**2*f*k1**2*s*(C - 1)*(s - 1) + 21*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 14*D1**2*Pkdd2*f**2*fd*k1**2*s + 7*D1**2*Pkdd2*f**2*fd*k1**2 - 15*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 10*D1**2*Pkdd2*f**2*fdd*k1**2*s - 5*D1**2*Pkdd2*f**2*fdd*k1**2 - 30*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 20*D1**2*Pkdd2*f*fd**2*k1**2*s - 3*D1**2*bdd1*f*(2*Pk2*f*(r - 1)*(8*C*(r - 1) - 8*r - 5*s + 8) - 7*Pkdd2*b1*k1**2*(C - 1)*(2*s**2 - 2*s + 1) + Pkdd2*f*k1**2*(C*(14*s**2 + 2*s - 1) + 6*s**2 - 2*s + 1)) + 120*D1*Dd*Pk2*b1*f**2*r**2 - 576*D1*Dd*Pk2*b1*f**2*r*s + 84*D1*Dd*Pk2*b1*f**2*r + 144*D1*Dd*Pk2*b1*f**2*s + 30*D1*Dd*Pk2*b1*f**2 + 768*D1*Dd*Pk2*b1*f*fd*r**2 + 480*D1*Dd*Pk2*b1*f*fd*r*s - 372*D1*Dd*Pk2*b1*f*fd*r - 60*D1*Dd*Pk2*b1*f*fd*s + 30*D1*Dd*Pk2*b1*f*fd + 200*D1*Dd*Pk2*f**3*r**2 - 256*D1*Dd*Pk2*f**3*r*s - 36*D1*Dd*Pk2*f**3*r + 64*D1*Dd*Pk2*f**3*s + 50*D1*Dd*Pk2*f**3 - 1824*D1*Dd*Pk2*f**2*fd*r**2 + 1200*D1*Dd*Pk2*f**2*fd*r*s + 714*D1*Dd*Pk2*f**2*fd*r - 350*D1*Dd*Pk2*f**2*fd*s - 52*D1*Dd*Pk2*f**2*fd + 168*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 84*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 42*D1*Dd*Pkdd2*b1**2*f*k1**2 - 168*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 42*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 60*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 30*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 15*D1*Dd*Pkdd2*b1*f**2*k1**2 - 288*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 192*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 30*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 28*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 14*D1*Dd*Pkdd2*f**3*k1**2*s + 7*D1*Dd*Pkdd2*f**3*k1**2 - 120*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 70*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 10*D1*Dd*Pkdd2*f**2*fd*k1**2 + 192*D1*Ddd*Pk2*b1*f**2*r**2 + 120*D1*Ddd*Pk2*b1*f**2*r*s - 126*D1*Ddd*Pk2*b1*f**2*r - 30*D1*Ddd*Pk2*b1*f**2*s + 48*D1*Ddd*Pk2*b1*f**2 - 304*D1*Ddd*Pk2*f**3*r**2 + 200*D1*Ddd*Pk2*f**3*r*s + 102*D1*Ddd*Pk2*f**3*r - 50*D1*Ddd*Pk2*f**3*s - 76*D1*Ddd*Pk2*f**3 - 84*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 42*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 21*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 72*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 36*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 18*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 20*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 10*D1*Ddd*Pkdd2*f**3*k1**2*s - 5*D1*Ddd*Pkdd2*f**3*k1**2 - 3*D1*bd1*(D1*(-14*Pkdd2*b1*fd*k1**2*s*(C - 1)*(2*s - 1) + f**2*(2*Pk2*(r - 1)*(5*C*(r - 1) - 5*r + 24*s + 5) - Pkdd2*k1**2*(C*(35*s**2 + 4*s - 2) + 5*s**2 - 4*s + 2)) + 2*f*(Pk2*fd*(r**2*(32*C - 32) + r*(-32*C - 20*s + 37) + 10*s - 5) + 7*Pkdd2*b1*k1**2*(C - 1)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(C*(28*s - 13) + 12*s - 7))) + 2*Dd*f*(Pk2*f*(16*C*(4*r**2 - 5*r + 1) - 64*r**2 - 40*r*s + 85*r + 25*s - 21) - 7*Pkdd2*b1*k1**2*(C - 1)*(8*s**2 - 6*s + 1) + Pkdd2*f*k1**2*(4*s - 1)*(14*C*s + C + 6*s - 1))) + 576*Dd**2*Pk2*b1*f**2*r**2 + 360*Dd**2*Pk2*b1*f**2*r*s - 378*Dd**2*Pk2*b1*f**2*r - 90*Dd**2*Pk2*b1*f**2*s + 30*Dd**2*Pk2*b1*f**2 - 912*Dd**2*Pk2*f**3*r**2 + 600*Dd**2*Pk2*f**3*r*s + 306*Dd**2*Pk2*f**3*r - 150*Dd**2*Pk2*f**3*s + 50*Dd**2*Pk2*f**3 - 252*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 126*Dd**2*Pkdd2*b1**2*f*k1**2*s - 216*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 108*Dd**2*Pkdd2*b1*f**2*k1**2*s - 60*Dd**2*Pkdd2*f**3*k1**2*s**2 + 30*Dd**2*Pkdd2*f**3*k1**2*s)/(105*d**2*k1**2*k3**2) - D1**2*Pk1*ct**2*k2**2*st**2*(7*b1**2*(D1**2*(Pk2*fd*r**2*(2*C - 2) + Pk2*fdd*r**2*(14*C - 14) - Pkdd2*fd*k1**2*s**2*(17*C + 1) + Pkdd2*fdd*k1**2*s**2*(6*C + 3)) + D1*(Dd*(Pk2*f*(2*C - 2)*(4*r**2 - 2*r + 1) + Pk2*fd*r*(28*C - 28)*(4*r - 1) - Pkdd2*f*k1**2*(17*C + 1)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(12*C + 6)*(4*s - 1)) + Ddd*f*(Pk2*(14*C - 14)*(4*r**2 - 2*r + 1) + Pkdd2*k1**2*(6*C + 3)*(4*s**2 - 2*s + 1))) + 6*Dd**2*f*(Pk2*r*(14*C - 14)*(2*r - 1) + Pkdd2*k1**2*s*(6*C + 3)*(2*s - 1))) + b1*(-116*C*D1**2*Pk2*f*fd*r**2 - 52*C*D1**2*Pk2*f*fd*r + 26*C*D1**2*Pk2*f*fd - 124*C*D1**2*Pk2*f*fdd*r**2 + 124*C*D1**2*Pk2*f*fdd*r - 62*C*D1**2*Pk2*f*fdd - 124*C*D1**2*Pk2*fd**2*r**2 + 124*C*D1**2*Pk2*fd**2*r - 2*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 84*C*D1**2*Pkdd2*f*fd*k1**2*s + 42*C*D1**2*Pkdd2*f*fd*k1**2 + 36*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 36*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 232*C*D1*Dd*Pk2*f**2*r**2 + 116*C*D1*Dd*Pk2*f**2*r - 58*C*D1*Dd*Pk2*f**2 - 992*C*D1*Dd*Pk2*f*fd*r**2 + 744*C*D1*Dd*Pk2*f*fd*r - 124*C*D1*Dd*Pk2*f*fd - 4*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 2*C*D1*Dd*Pkdd2*f**2*k1**2*s - C*D1*Dd*Pkdd2*f**2*k1**2 + 288*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 72*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 248*C*D1*Ddd*Pk2*f**2*r**2 + 124*C*D1*Ddd*Pk2*f**2*r - 62*C*D1*Ddd*Pk2*f**2 + 72*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 36*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 18*C*D1*Ddd*Pkdd2*f**2*k1**2 - 744*C*Dd**2*Pk2*f**2*r**2 + 372*C*Dd**2*Pk2*f**2*r + 216*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 108*C*Dd**2*Pkdd2*f**2*k1**2*s + 200*D1**2*Pk2*f*fd*r**2 - 108*D1**2*Pk2*f*fd*r*s + 106*D1**2*Pk2*f*fd*r - 26*D1**2*Pk2*f*fd + 40*D1**2*Pk2*f*fdd*r**2 + 12*D1**2*Pk2*f*fdd*r*s - 130*D1**2*Pk2*f*fdd*r + 62*D1**2*Pk2*f*fdd + 40*D1**2*Pk2*fd**2*r**2 + 12*D1**2*Pk2*fd**2*r*s - 130*D1**2*Pk2*fd**2*r + 20*D1**2*Pkdd2*f*fd*k1**2*s**2 - 42*D1**2*Pkdd2*f*fd*k1**2*s + 21*D1**2*Pkdd2*f*fd*k1**2 + 18*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 18*D1**2*Pkdd2*fd**2*k1**2*s**2 + 7*D1**2*bdd1*f*(Pk2*(14*C - 14)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(6*C + 3)*(2*s**2 - 2*s + 1)) + 400*D1*Dd*Pk2*f**2*r**2 - 216*D1*Dd*Pk2*f**2*r*s - 146*D1*Dd*Pk2*f**2*r + 54*D1*Dd*Pk2*f**2*s + 100*D1*Dd*Pk2*f**2 + 320*D1*Dd*Pk2*f*fd*r**2 + 96*D1*Dd*Pk2*f*fd*r*s - 612*D1*Dd*Pk2*f*fd*r - 12*D1*Dd*Pk2*f*fd*s + 130*D1*Dd*Pk2*f*fd + 40*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 20*D1*Dd*Pkdd2*f**2*k1**2*s + 10*D1*Dd*Pkdd2*f**2*k1**2 + 144*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 36*D1*Dd*Pkdd2*f*fd*k1**2*s + 80*D1*Ddd*Pk2*f**2*r**2 + 24*D1*Ddd*Pk2*f**2*r*s - 46*D1*Ddd*Pk2*f**2*r - 6*D1*Ddd*Pk2*f**2*s + 20*D1*Ddd*Pk2*f**2 + 36*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Ddd*Pkdd2*f**2*k1**2*s + 9*D1*Ddd*Pkdd2*f**2*k1**2 + 7*D1*bd1*(D1*(Pk2*f*(2*C - 2)*(2*r**2 - 2*r + 1) + Pk2*fd*r*(28*C - 28)*(2*r - 1) - Pkdd2*f*k1**2*(17*C + 1)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(12*C + 6)*(2*s - 1)) + 2*Dd*f*(Pk2*(14*C - 14)*(8*r**2 - 6*r + 1) + Pkdd2*k1**2*(6*C + 3)*(8*s**2 - 6*s + 1))) + 240*Dd**2*Pk2*f**2*r**2 + 72*Dd**2*Pk2*f**2*r*s - 138*Dd**2*Pk2*f**2*r - 18*Dd**2*Pk2*f**2*s + 6*Dd**2*Pk2*f**2 + 108*Dd**2*Pkdd2*f**2*k1**2*s**2 - 54*Dd**2*Pkdd2*f**2*k1**2*s) + f*(-84*C*D1**2*Pk2*f*fd*r**2 + 56*C*D1**2*Pk2*f*fd*r - 28*C*D1**2*Pk2*f*fd - 48*C*D1**2*Pk2*f*fdd*r**2 + 32*C*D1**2*Pk2*f*fdd*r - 16*C*D1**2*Pk2*f*fdd - 96*C*D1**2*Pk2*fd**2*r**2 + 64*C*D1**2*Pk2*fd**2*r + 54*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 36*C*D1**2*Pkdd2*f*fd*k1**2*s + 18*C*D1**2*Pkdd2*f*fd*k1**2 - 112*C*D1*Dd*Pk2*f**2*r**2 + 56*C*D1*Dd*Pk2*f**2*r - 28*C*D1*Dd*Pk2*f**2 - 384*C*D1*Dd*Pk2*f*fd*r**2 + 224*C*D1*Dd*Pk2*f*fd*r - 32*C*D1*Dd*Pk2*f*fd + 72*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 36*C*D1*Dd*Pkdd2*f**2*k1**2*s + 18*C*D1*Dd*Pkdd2*f**2*k1**2 - 64*C*D1*Ddd*Pk2*f**2*r**2 + 32*C*D1*Ddd*Pk2*f**2*r - 16*C*D1*Ddd*Pk2*f**2 - 192*C*Dd**2*Pk2*f**2*r**2 + 96*C*Dd**2*Pk2*f**2*r + 138*D1**2*Pk2*f*fd*r**2 - 426*D1**2*Pk2*f*fd*r*s + 50*D1**2*Pk2*f*fd*r + 142*D1**2*Pk2*f*fd*s + 46*D1**2*Pk2*f*fd + 66*D1**2*Pk2*f*fdd*r**2 + 330*D1**2*Pk2*f*fdd*r*s - 154*D1**2*Pk2*f*fdd*r - 110*D1**2*Pk2*f*fdd*s + 22*D1**2*Pk2*f*fdd + 132*D1**2*Pk2*fd**2*r**2 + 660*D1**2*Pk2*fd**2*r*s - 308*D1**2*Pk2*fd**2*r - 220*D1**2*Pk2*fd**2*s + 110*D1**2*Pk2*fd**2 + 27*D1**2*Pkdd2*f*fd*k1**2*s**2 - 18*D1**2*Pkdd2*f*fd*k1**2*s + 9*D1**2*Pkdd2*f*fd*k1**2 + 14*D1**2*bd1**2*(Pk2*r*(14*C - 14)*(r - 1) + Pkdd2*k1**2*s*(6*C + 3)*(s - 1)) + D1**2*bdd1*f*(Pk2*(r**2*(20 - 62*C) + 6*r*(s + 14) - 6*s - 42) + Pkdd2*k1**2*(18*C + 9)*(s - 1)**2) + 184*D1*Dd*Pk2*f**2*r**2 - 568*D1*Dd*Pk2*f**2*r*s + 50*D1*Dd*Pk2*f**2*r + 142*D1*Dd*Pk2*f**2*s + 46*D1*Dd*Pk2*f**2 + 528*D1*Dd*Pk2*f*fd*r**2 + 2640*D1*Dd*Pk2*f*fd*r*s - 1078*D1*Dd*Pk2*f*fd*r - 770*D1*Dd*Pk2*f*fd*s + 264*D1*Dd*Pk2*f*fd + 36*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**2*k1**2*s + 9*D1*Dd*Pkdd2*f**2*k1**2 + 88*D1*Ddd*Pk2*f**2*r**2 + 440*D1*Ddd*Pk2*f**2*r*s - 154*D1*Ddd*Pk2*f**2*r - 110*D1*Ddd*Pk2*f**2*s + 22*D1*Ddd*Pk2*f**2 + D1*bd1*(D1*(-2*Pk2*f*(C*(29*r**2 - 84*r + 42) - 50*r**2 + 9*r*(3*s + 14) - 27*s - 63) + 2*Pk2*fd*(r**2*(40 - 124*C) + r*(62*C + 12*s + 19) - 6*s + 3) + Pkdd2*f*k1**2*(-C*(s**2 - 86*s + 43) + 10*s**2 + 22*s - 11) + Pkdd2*fd*k1**2*s*(72*C + 36)*(s - 1)) + 2*Dd*f*(Pk2*(r**2*(80 - 248*C) + r*(62*C + 24*s + 145) - 15*s - 39) + Pkdd2*k1**2*(18*C + 9)*(4*s**2 - 5*s + 1))) + 264*Dd**2*Pk2*f**2*r**2 + 1320*Dd**2*Pk2*f**2*r*s - 462*Dd**2*Pk2*f**2*r - 330*Dd**2*Pk2*f**2*s + 110*Dd**2*Pk2*f**2))/(105*d**2*k1**2*k3**2) + D1**2*Pk1*ct**2*k2**2*(D1*f*(7*D1*Pk2*bd1**2*(16*r**2 + 22*r*s - 27*r - 11*s + 11) + D1*Pk2*bdd1*f*r*(r*(20*C + 12) - 17*s + 17) + bd1*(D1*(Pk2*fd*(r**2*(80*C + 48) - 2*r*(20*C + 34*s - 5) + 17*s - 17) + f*(Pk2*r*(r*(58*C + 18) - s + 1) - Pkdd2*k1**2*(21*C + 21)*(s - 1)**2)) + Dd*Pk2*f*(r**2*(160*C + 96) + r*(-40*C - 136*s + 61) + 17*s - 17))) + 7*b1**2*(D1**2*(Pk2*fd*r*(r*(10*C - 6) - 17*s) + Pk2*fdd*r*(8*r + 11*s) - Pkdd2*fd*k1**2*s**2*(5*C + 5)) + D1*(Dd*(Pk2*fd*(64*r**2 + r*(88*s - 27) - 11*s) + f*(Pk2*(10*C*(4*r**2 - 2*r + 1) - 24*r**2 - 68*r*s + 29*r + 17*s - 6) - Pkdd2*k1**2*(5*C + 5)*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(32*r**2 + r*(44*s - 27) - 11*s + 8)) + Dd**2*Pk2*f*(96*r**2 + 3*r*(44*s - 27) - 33*s + 11)) + b1*(116*C*D1**2*Pk2*f*fd*r**2 - 116*C*D1**2*Pk2*f*fd*r + 58*C*D1**2*Pk2*f*fd + 40*C*D1**2*Pk2*f*fdd*r**2 - 40*C*D1**2*Pk2*f*fdd*r + 20*C*D1**2*Pk2*f*fdd + 40*C*D1**2*Pk2*fd**2*r**2 - 40*C*D1**2*Pk2*fd**2*r - 42*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 232*C*D1*Dd*Pk2*f**2*r**2 - 116*C*D1*Dd*Pk2*f**2*r + 58*C*D1*Dd*Pk2*f**2 + 320*C*D1*Dd*Pk2*f*fd*r**2 - 240*C*D1*Dd*Pk2*f*fd*r + 40*C*D1*Dd*Pk2*f*fd - 84*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 42*C*D1*Dd*Pkdd2*f**2*k1**2*s - 21*C*D1*Dd*Pkdd2*f**2*k1**2 + 80*C*D1*Ddd*Pk2*f**2*r**2 - 40*C*D1*Ddd*Pk2*f**2*r + 20*C*D1*Ddd*Pk2*f**2 + 240*C*Dd**2*Pk2*f**2*r**2 - 120*C*Dd**2*Pk2*f**2*r + 7*D1**2*Pk2*bdd1*f*(16*r**2 + 22*r*s - 27*r - 11*s + 8) + 36*D1**2*Pk2*f*fd*r**2 - 2*D1**2*Pk2*f*fd*r*s - 36*D1**2*Pk2*f*fd*r + D1**2*Pk2*f*fd*s + 18*D1**2*Pk2*f*fd + 24*D1**2*Pk2*f*fdd*r**2 - 34*D1**2*Pk2*f*fdd*r*s - 24*D1**2*Pk2*f*fdd*r + 17*D1**2*Pk2*f*fdd*s + 12*D1**2*Pk2*f*fdd + 24*D1**2*Pk2*fd**2*r**2 - 34*D1**2*Pk2*fd**2*r*s - 24*D1**2*Pk2*fd**2*r + 17*D1**2*Pk2*fd**2*s - 42*D1**2*Pkdd2*f*fd*k1**2*s**2 + 72*D1*Dd*Pk2*f**2*r**2 - 4*D1*Dd*Pk2*f**2*r*s - 35*D1*Dd*Pk2*f**2*r + D1*Dd*Pk2*f**2*s + 18*D1*Dd*Pk2*f**2 + 192*D1*Dd*Pk2*f*fd*r**2 - 272*D1*Dd*Pk2*f*fd*r*s - 110*D1*Dd*Pk2*f*fd*r + 102*D1*Dd*Pk2*f*fd*s + 7*D1*Dd*Pk2*f*fd - 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 42*D1*Dd*Pkdd2*f**2*k1**2*s - 21*D1*Dd*Pkdd2*f**2*k1**2 + 48*D1*Ddd*Pk2*f**2*r**2 - 68*D1*Ddd*Pk2*f**2*r*s - 7*D1*Ddd*Pk2*f**2*r + 17*D1*Ddd*Pk2*f**2*s + 12*D1*Ddd*Pk2*f**2 + 7*D1*bd1*(D1*(Pk2*fd*(32*r**2 + r*(44*s - 27) - 11*s) + f*(Pk2*(10*C*(2*r**2 - 2*r + 1) - 12*r**2 - 34*r*s + 29*r + 17*s - 6) - Pkdd2*k1**2*(5*C + 5)*(2*s**2 - 2*s + 1))) + 2*Dd*Pk2*f*(64*r**2 + r*(88*s - 81) - 33*s + 19)) + 144*Dd**2*Pk2*f**2*r**2 - 204*Dd**2*Pk2*f**2*r*s - 21*Dd**2*Pk2*f**2*r + 51*Dd**2*Pk2*f**2*s - 17*Dd**2*Pk2*f**2))/(105*d**2*k1**2*k3**2) - D1**2*Pk1*ct**2*st**4*(-33*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 1320*D1**2*Pk2*bdd1*f**3*r*s + 1320*D1**2*Pk2*bdd1*f**3*s + 3680*D1**2*Pk2*f**3*fd*r*s - 920*D1**2*Pk2*f**3*fd*r - 920*D1**2*Pk2*f**3*fd*s - 6240*D1**2*Pk2*f**3*fdd*r*s + 1560*D1**2*Pk2*f**3*fdd*r + 1560*D1**2*Pk2*f**3*fdd*s - 18720*D1**2*Pk2*f**2*fd**2*r*s + 4680*D1**2*Pk2*f**2*fd**2*r + 4680*D1**2*Pk2*f**2*fd**2*s - 1560*D1**2*Pk2*f**2*fd**2 + 66*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(-7*K + 15*f + 7) + 495*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 33*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 462*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 1200*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 600*D1**2*Pkdd2*f**3*fd*k1**2*s - 300*D1**2*Pkdd2*f**3*fd*k1**2 + 600*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 300*D1**2*Pkdd2*f**3*fdd*k1**2*s + 150*D1**2*Pkdd2*f**3*fdd*k1**2 + 1800*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 900*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 132*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 66*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 264*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 264*D1**2*Pkdd2*f*fd*g2*k1**2*s - 132*D1**2*Pkdd2*f*fd*g2*k1**2 + 264*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 132*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 132*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 132*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 66*D1**2*Pkdd2*f*fdd*g2*k1**2 + 132*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 132*D1**2*Pkdd2*fd**2*g2*k1**2*s + 3680*D1*Dd*Pk2*f**4*r*s - 920*D1*Dd*Pk2*f**4*r - 920*D1*Dd*Pk2*f**4*s - 49920*D1*Dd*Pk2*f**3*fd*r*s + 12480*D1*Dd*Pk2*f**3*fd*r + 12480*D1*Dd*Pk2*f**3*fd*s - 3120*D1*Dd*Pk2*f**3*fd - 1200*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 600*D1*Dd*Pkdd2*f**4*k1**2*s - 300*D1*Dd*Pkdd2*f**4*k1**2 + 4800*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 2400*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 300*D1*Dd*Pkdd2*f**3*fd*k1**2 - 528*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 264*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 132*D1*Dd*Pkdd2*f**2*g2*k1**2 + 528*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 132*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 1056*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 792*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 132*D1*Dd*Pkdd2*f*fd*g2*k1**2 - 6240*D1*Ddd*Pk2*f**4*r*s + 1560*D1*Ddd*Pk2*f**4*r + 1560*D1*Ddd*Pk2*f**4*s + 600*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 300*D1*Ddd*Pkdd2*f**4*k1**2*s + 150*D1*Ddd*Pkdd2*f**4*k1**2 + 264*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 132*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 66*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 66*D1*bd1*(D1*(Pkdd2*f*k1**2*s*(fd*(2*s - 1)*(-K + 30*b1 + 1) + s*(14*b1*(K - 1) - 14*g2 + 14*gd2)) + 14*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) - 5*f**3*s*(-4*Pk2*(r - 1) + 3*Pkdd2*k1**2*s) + f**2*(Pkdd2*k1**2*s**2*(K - 30*b1 - 1) - 5*fd*(4*Pk2*(6*r*s - r - 3*s + 1) + 3*Pkdd2*k1**2*s*(1 - 3*s)))) + Dd*f*(Pkdd2*f*k1**2*s*(4*s - 1)*(-K + 30*b1 + 1) + Pkdd2*k1**2*s*(4*s - 1)*(-14*K*b1 + 14*b1 + 14*g2) - 5*f**2*(4*Pk2*(r*(8*s - 1) - 5*s + 1) + 3*Pkdd2*k1**2*s*(1 - 4*s)))) - 18720*Dd**2*Pk2*f**4*r*s + 4680*Dd**2*Pk2*f**4*r + 4680*Dd**2*Pk2*f**4*s - 1560*Dd**2*Pk2*f**4 + 1800*Dd**2*Pkdd2*f**4*k1**2*s**2 - 900*Dd**2*Pkdd2*f**4*k1**2*s + 792*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 396*Dd**2*Pkdd2*f**2*g2*k1**2*s - 33*Pkdd2*b1**2*k1**2*(D1**2*(30*f*fd*(2*s**2 - 2*s + 1) - 15*f*fdd*(2*s**2 - 2*s + 1) - 30*fd**2*s*(s - 1) - 14*fd*(K - 1)*(s - 1)**2 + 7*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(15*f**2*(4*s**2 - 2*s + 1) - 15*f*fd*(8*s**2 - 6*s + 1) - 7*f*(K - 1)*(4*s**2 - 2*s + 1) + 7*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-7*K + 15*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-7*K + 15*f + 7)) - 33*b1*(-2*D1*Dd*(Pkdd2*f*k1**2*(-fd*(K - 1)*(8*s**2 - 6*s + 1) - 14*g2*(4*s**2 - 2*s + 1) - 14*gd2*s*(1 - 4*s)) + 14*Pkdd2*fd*g2*k1**2*(4*s**2 - 5*s + 1) - 5*f**3*(4*Pk2*(-4*r*s + r + s) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(-20*Pk2*fd*(r*(24*s - 7) - 3*s + 1) + 15*Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1) + Pkdd2*k1**2*(K - 1)*(4*s**2 - 2*s + 1))) + D1*(D1*(2*Pkdd2*k1**2*(s - 1)*(fd**2*s*(K - 1) + 14*fd*(g2*(s - 1) - gd2*s) - 7*fdd*g2*(s - 1)) + 5*f**2*(8*Pk2*fd*r*(1 - 3*s) + 8*Pk2*fdd*r*(3*s - 1) - 6*Pkdd2*bdd1*k1**2*s**2 + 6*Pkdd2*fd*k1**2*(3*s**2 - 2*s + 1) - 3*Pkdd2*fdd*k1**2*(3*s**2 - 2*s + 1)) + f*(-2*Pkdd2*fd*k1**2*(K - 1)*(2*s**2 - 2*s + 1) + Pkdd2*k1**2*(fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(14*bdd1*(K - 1) + 28*gd2 - 14*gdd2)) + 10*fd**2*(8*Pk2*r*(3*s - 1) + 3*Pkdd2*k1**2*s*(2 - 3*s)))) - Ddd*f*(-Pkdd2*f*k1**2*(K - 1)*(4*s**2 - 2*s + 1) + 14*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 5*f**2*(8*Pk2*(-4*r*s + r + s) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 2*Dd**2*f*(3*Pkdd2*f*k1**2*s*(K - 1)*(2*s - 1) + 42*Pkdd2*g2*k1**2*s*(1 - 2*s) + 5*f**2*(4*Pk2*(12*r*s - 3*r - 3*s + 1) + 9*Pkdd2*k1**2*s*(1 - 2*s)))))/(2310*d**2*k1**2) + D1**2*Pk1*ct**2*st**2*(22*D1**2*bd1**2*(-70*Pkdd2*g2*k1**2*s*(s - 1) + 6*f**2*(Pk2*(8*r*s - 2*r - 4*s + 2) + 3*Pkdd2*k1**2*s*(3 - 4*s)) - 7*f*(Pk2*r*(14*K - 14)*(r - 1) + Pkdd2*k1**2*s*(5*K*s + K + 7*s - 1))) + 22*D1**2*bdd1*f*(2*Pk2*f**2*(12*r**2 + r*(13*s - 30) + 15*s + 8) + Pk2*f*r*(r*(31*K - 31) + 48*s) + 98*Pk2*g2*(r - 1)**2 - 21*Pkdd2*b2*k1**2*s**2 - 5*Pkdd2*f**2*k1**2*(3*s**2 - 4*s + 2) - 9*Pkdd2*f*k1**2*s**2*(K + 1) + 7*Pkdd2*g2*k1**2*(5*s**2 + 2*s - 1)) - 2*D1**2*(2*f**3*(Pk2*fdd*(192*r**2 + r*(1540*s - 481) - 385*s + 48) + fd*(Pk2*(-32*r**2 - 1540*r*s + 401*r + 385*s - 8) + 55*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + f**2*(2*Pk2*fd**2*(576*r**2 + 3*r*(1540*s - 481) - 1155*s + 385) - 11*Pkdd2*k1**2*s**2*(18*bd2 - 9*bdd2) - 11*gd2*(26*Pk2*r**2 - 43*Pkdd2*k1**2*s**2) - 11*gdd2*(-62*Pk2*r**2 + 18*Pkdd2*k1**2*s**2)) - 11*f*(fd*(26*Pk2*g2*(2*r**2 - 2*r + 1) - 248*Pk2*gd2*r**2 + 124*Pk2*gd2*r + 18*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) - 36*Pkdd2*bd2*k1**2*s**2 + 18*Pkdd2*bd2*k1**2*s - 43*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 72*Pkdd2*gd2*k1**2*s**2 - 36*Pkdd2*gd2*k1**2*s) + fdd*(-62*Pk2*g2*(2*r**2 - 2*r + 1) - 9*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) + 18*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1))) + 22*fd**2*(62*Pk2*g2*r*(r - 1) + 9*Pkdd2*b2*k1**2*s*(s - 1) - 18*Pkdd2*g2*k1**2*s*(s - 1))) - 11*D1*bd1*(D1*(2*f**3*(2*Pk2*(6*r**2 + r*(5*s - 18) + 15*s + 4) + Pkdd2*k1**2*(-3*s**2 + 40*s - 20)) - f**2*(-2*Pk2*r*(r*(13*K - 13) + 68*s) + Pkdd2*k1**2*s**2*(43*K + 29) + 4*fd*(Pk2*(72*r**2 + 78*r*s - 97*r + 17*s - 1) + 5*Pkdd2*k1**2*s*(7 - 9*s))) - 2*f*(2*Pk2*fd*(r**2*(62*K - 62) + r*(-31*K + 96*s + 7) - 24*s) + 196*Pk2*gd2*r*(r - 1) - 18*Pkdd2*fd*k1**2*s*(K + 1)*(2*s - 1) + 14*Pkdd2*gd2*k1**2*s*(5*s + 1) + 2*Pkdd2*k1**2*s**2*(21*b2 - 21*bd2) + 7*g2*(2*Pk2*(r - 1)**2 + Pkdd2*k1**2*(-15*s**2 - 4*s + 2))) + 28*fd*(-14*Pk2*g2*r*(r - 1) + 3*Pkdd2*b2*k1**2*s*(s - 1) - 5*Pkdd2*g2*k1**2*s*(s - 1))) - 4*Dd*f*(Pk2*f**2*(96*r**2 + r*(104*s - 157) + 47*s + 15) + Pk2*f*(r**2*(124*K - 124) + r*(-31*K + 192*s + 7) - 24*s) + 98*Pk2*g2*(4*r**2 - 5*r + 1) - 21*Pkdd2*b2*k1**2*s*(4*s - 1) - 5*Pkdd2*f**2*k1**2*(12*s**2 - 11*s + 2) - 9*Pkdd2*f*k1**2*s*(K + 1)*(4*s - 1) - 7*Pkdd2*g2*k1**2*(-20*s**2 + s + 1))) - 2*D1*f*(Dd*(4*Pk2*f**2*fd*(4*r - 1)*(192*r + 1540*s - 433) - 2*f**3*(Pk2*(32*r**2 + r*(1540*s - 401) - 385*s + 8) - 55*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 11*f*(26*Pk2*g2*(4*r**2 - 2*r + 1) - 124*Pk2*gd2*r*(4*r - 1) + 18*Pkdd2*b2*k1**2*(4*s**2 - 2*s + 1) + 18*Pkdd2*bd2*k1**2*s*(1 - 4*s) - 43*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 36*Pkdd2*gd2*k1**2*s*(4*s - 1)) + 22*fd*(62*Pk2*g2*(8*r**2 - 6*r + 1) + 9*Pkdd2*b2*k1**2*(8*s**2 - 6*s + 1) - 18*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1))) + Ddd*f*(2*Pk2*f**2*(192*r**2 + r*(1540*s - 481) - 385*s + 48) + 682*Pk2*g2*(4*r**2 - 2*r + 1) + 99*Pkdd2*b2*k1**2*(4*s**2 - 2*s + 1) - 198*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1))) - 4*Dd**2*f**2*(Pk2*f**2*(576*r**2 + 3*r*(1540*s - 481) - 1155*s + 385) + 2046*Pk2*g2*r*(2*r - 1) + 297*Pkdd2*b2*k1**2*s*(2*s - 1) + 594*Pkdd2*g2*k1**2*s*(1 - 2*s)) + 77*Pkdd2*b1**3*k1**2*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-5*K*(4*s**2 - 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s + 20*s**2 - 10*s + 5) - D1*Ddd*(-5*K + 6*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-5*K + 6*f + 5)) - 11*b1**2*(D1**2*(14*K*Pk2*fd*r**2 + 98*K*Pk2*fdd*r**2 - 105*K*Pkdd2*fd*k1**2*s**2 + 238*K*Pkdd2*fd*k1**2*s - 119*K*Pkdd2*fd*k1**2 + 35*K*Pkdd2*fdd*k1**2*s**2 - 84*K*Pkdd2*fdd*k1**2*s + 42*K*Pkdd2*fdd*k1**2 + 192*Pk2*f*fd*r*s - 48*Pk2*f*fd*r - 96*Pk2*f*fdd*r*s + 24*Pk2*f*fdd*r - 96*Pk2*fd**2*r*s + 24*Pk2*fd**2*r - 14*Pk2*fd*r**2 + 280*Pk2*fd*r*s - 280*Pk2*fd*r - 98*Pk2*fdd*r**2 - 14*Pkdd2*bd1*k1**2*(-5*K*(3*s**2 - 2*s + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s + 15*s**2 - 10*s + 5) + 7*Pkdd2*bdd1*k1**2*(-5*K + 6*f + 5)*(3*s**2 - 2*s + 1) - 204*Pkdd2*f*fd*k1**2*s**2 - 12*Pkdd2*f*fd*k1**2*s + 6*Pkdd2*f*fd*k1**2 + 144*Pkdd2*f*fdd*k1**2*s**2 - 36*Pkdd2*f*fdd*k1**2*s + 18*Pkdd2*f*fdd*k1**2 + 144*Pkdd2*fd**2*k1**2*s**2 - 36*Pkdd2*fd**2*k1**2*s - 63*Pkdd2*fd*k1**2*s**2 + 98*Pkdd2*fd*k1**2*s - 49*Pkdd2*fd*k1**2 + 49*Pkdd2*fdd*k1**2*s**2 - 84*Pkdd2*fdd*k1**2*s + 42*Pkdd2*fdd*k1**2 - 140*Pkdd2*gd2*k1**2*s**2 + 70*Pkdd2*gdd2*k1**2*s**2) + D1*(Dd*(-2*Pk2*f*(-28*K*r**2 + 14*K*r - 7*K + 12*fd*(8*r - 1)*(4*s - 1) + 28*r**2 - 560*r*s + 126*r + 140*s + 7) - 70*Pkdd2*bd1*k1**2*(K - 1)*(12*s**2 - 7*s + 1) + 3*Pkdd2*f*k1**2*(28*bd1*(12*s**2 - 7*s + 1) + 12*fd*(32*s**2 - 12*s + 1) + (-35*K - 21)*(4*s**2 - 2*s + 1)) - 140*Pkdd2*k1**2*(g2*(4*s**2 - 2*s + 1) + gd2*s*(1 - 4*s)) - 6*f**2*(16*Pk2*(-4*r*s + r + s) + 17*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 14*fd*(Pk2*r*(14*K - 14)*(4*r - 1) + Pkdd2*k1**2*(4*s - 1)*(K*(5*s - 6) + 7*s - 6))) + Ddd*(70*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 24*f**2*(2*Pk2*(-4*r*s + r + s) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 7*f*(Pk2*(14*K - 14)*(4*r**2 - 2*r + 1) + Pkdd2*k1**2*(5*K + 7)*(4*s**2 - 2*s + 1)))) + 6*Dd**2*(70*Pkdd2*g2*k1**2*s*(2*s - 1) - 8*f**2*(3*Pk2*r*(4*s - 1) - 3*Pk2*s + Pk2 + 9*Pkdd2*k1**2*s*(1 - 2*s)) + 7*f*(Pk2*r*(14*K - 14)*(2*r - 1) + Pkdd2*k1**2*s*(5*K + 7)*(2*s - 1)))) - 11*b1*(52*D1**2*K*Pk2*f*fd*r**2 - 52*D1**2*K*Pk2*f*fd*r + 26*D1**2*K*Pk2*f*fd - 124*D1**2*K*Pk2*f*fdd*r**2 + 124*D1**2*K*Pk2*f*fdd*r - 62*D1**2*K*Pk2*f*fdd - 124*D1**2*K*Pk2*fd**2*r**2 + 124*D1**2*K*Pk2*fd**2*r - 86*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 86*D1**2*K*Pkdd2*f*fd*k1**2*s - 43*D1**2*K*Pkdd2*f*fd*k1**2 + 36*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 36*D1**2*K*Pkdd2*f*fdd*k1**2*s + 18*D1**2*K*Pkdd2*f*fdd*k1**2 + 36*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 36*D1**2*K*Pkdd2*fd**2*k1**2*s + 72*D1**2*Pk2*f**2*fd*r**2 + 60*D1**2*Pk2*f**2*fd*r*s + 4*D1**2*Pk2*f**2*fd*r - 80*D1**2*Pk2*f**2*fd*s + 8*D1**2*Pk2*f**2*fd - 144*D1**2*Pk2*f**2*fdd*r**2 - 156*D1**2*Pk2*f**2*fdd*r*s + 28*D1**2*Pk2*f**2*fdd*r + 112*D1**2*Pk2*f**2*fdd*s - 16*D1**2*Pk2*f**2*fdd - 288*D1**2*Pk2*f*fd**2*r**2 - 312*D1**2*Pk2*f*fd**2*r*s + 56*D1**2*Pk2*f*fd**2*r + 224*D1**2*Pk2*f*fd**2*s - 56*D1**2*Pk2*f*fd**2 - 52*D1**2*Pk2*f*fd*r**2 + 272*D1**2*Pk2*f*fd*r*s - 84*D1**2*Pk2*f*fd*r - 136*D1**2*Pk2*f*fd*s - 26*D1**2*Pk2*f*fd + 124*D1**2*Pk2*f*fdd*r**2 - 192*D1**2*Pk2*f*fdd*r*s - 28*D1**2*Pk2*f*fdd*r + 96*D1**2*Pk2*f*fdd*s + 62*D1**2*Pk2*f*fdd - 28*D1**2*Pk2*f*gd2*r**2 - 196*D1**2*Pk2*f*gdd2*r**2 + 124*D1**2*Pk2*fd**2*r**2 - 192*D1**2*Pk2*fd**2*r*s - 28*D1**2*Pk2*fd**2*r + 96*D1**2*Pk2*fd**2*s - 96*D1**2*Pk2*fd**2 - 28*D1**2*Pk2*fd*g2*r**2 - 392*D1**2*Pk2*fd*gd2*r**2 - 196*D1**2*Pk2*fdd*g2*r**2 - 84*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 168*D1**2*Pkdd2*b2*fd*k1**2*s - 84*D1**2*Pkdd2*b2*fd*k1**2 + 42*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 84*D1**2*Pkdd2*b2*fdd*k1**2*s + 42*D1**2*Pkdd2*b2*fdd*k1**2 + 14*D1**2*Pkdd2*bd1**2*k1**2*s*(3*s - 2)*(-5*K + 6*f + 5) - 84*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 84*D1**2*Pkdd2*bd2*fd*k1**2*s**2 - 84*D1**2*Pkdd2*bd2*fd*k1**2*s + 42*D1**2*Pkdd2*bdd2*f*k1**2*s**2 - 18*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 68*D1**2*Pkdd2*f**2*fd*k1**2*s + 34*D1**2*Pkdd2*f**2*fd*k1**2 + 90*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 20*D1**2*Pkdd2*f**2*fdd*k1**2*s + 10*D1**2*Pkdd2*f**2*fdd*k1**2 + 180*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 40*D1**2*Pkdd2*f*fd**2*k1**2*s - 58*D1**2*Pkdd2*f*fd*k1**2*s**2 + 58*D1**2*Pkdd2*f*fd*k1**2*s - 29*D1**2*Pkdd2*f*fd*k1**2 + 36*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 36*D1**2*Pkdd2*f*fdd*k1**2*s + 18*D1**2*Pkdd2*f*fdd*k1**2 + 210*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 70*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 36*D1**2*Pkdd2*fd**2*k1**2*s**2 - 36*D1**2*Pkdd2*fd**2*k1**2*s + 210*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 476*D1**2*Pkdd2*fd*g2*k1**2*s + 238*D1**2*Pkdd2*fd*g2*k1**2 - 140*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 168*D1**2*Pkdd2*fd*gd2*k1**2*s - 70*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + 168*D1**2*Pkdd2*fdd*g2*k1**2*s - 84*D1**2*Pkdd2*fdd*g2*k1**2 + D1**2*bdd1*(70*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 6*f**2*(4*Pk2*(-4*r*s + r + 2*s) + 3*Pkdd2*k1**2*(8*s**2 - 6*s + 3)) + 7*f*(Pk2*(14*K - 14)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(K*(10*s**2 + 2*s - 1) + 14*s**2 - 2*s + 1))) + 104*D1*Dd*K*Pk2*f**2*r**2 - 52*D1*Dd*K*Pk2*f**2*r + 26*D1*Dd*K*Pk2*f**2 - 992*D1*Dd*K*Pk2*f*fd*r**2 + 744*D1*Dd*K*Pk2*f*fd*r - 124*D1*Dd*K*Pk2*f*fd - 172*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 86*D1*Dd*K*Pkdd2*f**2*k1**2*s - 43*D1*Dd*K*Pkdd2*f**2*k1**2 + 288*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 216*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 36*D1*Dd*K*Pkdd2*f*fd*k1**2 + 96*D1*Dd*Pk2*f**3*r**2 + 80*D1*Dd*Pk2*f**3*r*s - 68*D1*Dd*Pk2*f**3*r - 20*D1*Dd*Pk2*f**3*s + 24*D1*Dd*Pk2*f**3 - 1152*D1*Dd*Pk2*f**2*fd*r**2 - 1248*D1*Dd*Pk2*f**2*fd*r*s + 556*D1*Dd*Pk2*f**2*fd*r + 604*D1*Dd*Pk2*f**2*fd*s - 140*D1*Dd*Pk2*f**2*fd - 104*D1*Dd*Pk2*f**2*r**2 + 544*D1*Dd*Pk2*f**2*r*s - 84*D1*Dd*Pk2*f**2*r - 136*D1*Dd*Pk2*f**2*s - 26*D1*Dd*Pk2*f**2 + 992*D1*Dd*Pk2*f*fd*r**2 - 1536*D1*Dd*Pk2*f*fd*r*s - 168*D1*Dd*Pk2*f*fd*r + 576*D1*Dd*Pk2*f*fd*s - 68*D1*Dd*Pk2*f*fd - 112*D1*Dd*Pk2*f*g2*r**2 + 56*D1*Dd*Pk2*f*g2*r - 28*D1*Dd*Pk2*f*g2 - 1568*D1*Dd*Pk2*f*gd2*r**2 + 392*D1*Dd*Pk2*f*gd2*r - 1568*D1*Dd*Pk2*fd*g2*r**2 + 392*D1*Dd*Pk2*fd*g2*r - 336*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 168*D1*Dd*Pkdd2*b2*f*k1**2*s - 84*D1*Dd*Pkdd2*b2*f*k1**2 + 336*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 420*D1*Dd*Pkdd2*b2*fd*k1**2*s + 84*D1*Dd*Pkdd2*b2*fd*k1**2 + 336*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 84*D1*Dd*Pkdd2*bd2*f*k1**2*s - 24*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 12*D1*Dd*Pkdd2*f**3*k1**2*s - 6*D1*Dd*Pkdd2*f**3*k1**2 + 720*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 260*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 20*D1*Dd*Pkdd2*f**2*fd*k1**2 - 116*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 58*D1*Dd*Pkdd2*f**2*k1**2*s - 29*D1*Dd*Pkdd2*f**2*k1**2 + 288*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 216*D1*Dd*Pkdd2*f*fd*k1**2*s + 36*D1*Dd*Pkdd2*f*fd*k1**2 + 840*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 420*D1*Dd*Pkdd2*f*g2*k1**2*s + 210*D1*Dd*Pkdd2*f*g2*k1**2 - 560*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 140*D1*Dd*Pkdd2*f*gd2*k1**2*s - 560*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 812*D1*Dd*Pkdd2*fd*g2*k1**2*s - 168*D1*Dd*Pkdd2*fd*g2*k1**2 - 248*D1*Ddd*K*Pk2*f**2*r**2 + 124*D1*Ddd*K*Pk2*f**2*r - 62*D1*Ddd*K*Pk2*f**2 + 72*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 36*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 18*D1*Ddd*K*Pkdd2*f**2*k1**2 - 192*D1*Ddd*Pk2*f**3*r**2 - 208*D1*Ddd*Pk2*f**3*r*s + 148*D1*Ddd*Pk2*f**3*r + 52*D1*Ddd*Pk2*f**3*s - 48*D1*Ddd*Pk2*f**3 + 248*D1*Ddd*Pk2*f**2*r**2 - 384*D1*Ddd*Pk2*f**2*r*s - 28*D1*Ddd*Pk2*f**2*r + 96*D1*Ddd*Pk2*f**2*s + 62*D1*Ddd*Pk2*f**2 - 784*D1*Ddd*Pk2*f*g2*r**2 + 392*D1*Ddd*Pk2*f*g2*r - 196*D1*Ddd*Pk2*f*g2 + 168*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 84*D1*Ddd*Pkdd2*b2*f*k1**2*s + 42*D1*Ddd*Pkdd2*b2*f*k1**2 + 120*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 60*D1*Ddd*Pkdd2*f**3*k1**2*s + 30*D1*Ddd*Pkdd2*f**3*k1**2 + 72*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 36*D1*Ddd*Pkdd2*f**2*k1**2*s + 18*D1*Ddd*Pkdd2*f**2*k1**2 - 280*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 140*D1*Ddd*Pkdd2*f*g2*k1**2*s - 70*D1*Ddd*Pkdd2*f*g2*k1**2 + 2*D1*bd1*(D1*(98*Pk2*fd*r*(K - 1)*(2*r - 1) + 7*Pkdd2*fd*k1**2*s*(K*(10*s - 11) + 14*s - 13) - 70*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 70*Pkdd2*gd2*k1**2*s*(2*s - 1) - 6*f**2*(4*Pk2*(-4*r*s + r + 2*s) + Pkdd2*k1**2*(17*s**2 - 18*s + 9)) - f*(Pk2*(-14*K*r**2 + 14*K*r - 7*K + 12*fd*(4*r - 1)*(4*s - 1) + 14*r**2 - 280*r*s - 14*r + 140*s + 7) + Pkdd2*k1**2*(7*K*(15*s**2 + 2*s - 1) - s**2*(288*fd - 63) + s*(144*fd - 14) + 7))) + Dd*(70*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) + 6*f**2*(4*s - 1)*(Pk2*(6 - 16*r) + 3*Pkdd2*k1**2*(8*s - 3)) + 7*f*(Pk2*(14*K - 14)*(8*r**2 - 6*r + 1) + Pkdd2*k1**2*(4*s - 1)*(10*K*s + K + 14*s - 1)))) - 744*Dd**2*K*Pk2*f**2*r**2 + 372*Dd**2*K*Pk2*f**2*r + 216*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 108*Dd**2*K*Pkdd2*f**2*k1**2*s - 576*Dd**2*Pk2*f**3*r**2 - 624*Dd**2*Pk2*f**3*r*s + 444*Dd**2*Pk2*f**3*r + 156*Dd**2*Pk2*f**3*s - 52*Dd**2*Pk2*f**3 + 744*Dd**2*Pk2*f**2*r**2 - 1152*Dd**2*Pk2*f**2*r*s - 84*Dd**2*Pk2*f**2*r + 288*Dd**2*Pk2*f**2*s - 96*Dd**2*Pk2*f**2 - 2352*Dd**2*Pk2*f*g2*r**2 + 1176*Dd**2*Pk2*f*g2*r + 504*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 252*Dd**2*Pkdd2*b2*f*k1**2*s + 360*Dd**2*Pkdd2*f**3*k1**2*s**2 - 180*Dd**2*Pkdd2*f**3*k1**2*s + 216*Dd**2*Pkdd2*f**2*k1**2*s**2 - 108*Dd**2*Pkdd2*f**2*k1**2*s - 840*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 420*Dd**2*Pkdd2*f*g2*k1**2*s))/(2310*d**2*k1**2) + D1**2*Pk1*ct**2*(20*D1**2*K*Pk2*bdd1*f**2*r**2 + 32*D1**2*Pk2*b2*f*fd*r**2 - 32*D1**2*Pk2*b2*f*fd*r + 16*D1**2*Pk2*b2*f*fd + 40*D1**2*Pk2*b2*f*fdd*r**2 - 40*D1**2*Pk2*b2*f*fdd*r + 20*D1**2*Pk2*b2*f*fdd + 40*D1**2*Pk2*b2*fd**2*r**2 - 40*D1**2*Pk2*b2*fd**2*r + 16*D1**2*Pk2*bd2*f**2*r**2 + 80*D1**2*Pk2*bd2*f*fd*r**2 - 40*D1**2*Pk2*bd2*f*fd*r + 24*D1**2*Pk2*bdd1*f**3*r**2 - 36*D1**2*Pk2*bdd1*f**3*r*s + 18*D1**2*Pk2*bdd1*f**3*r + 20*D1**2*Pk2*bdd1*f**2*r**2 - 34*D1**2*Pk2*bdd1*f**2*r*s + 20*D1**2*Pk2*bdd2*f**2*r**2 - 116*D1**2*Pk2*f**2*gd2*r**2 - 40*D1**2*Pk2*f**2*gdd2*r**2 - 232*D1**2*Pk2*f*fd*g2*r**2 + 232*D1**2*Pk2*f*fd*g2*r - 116*D1**2*Pk2*f*fd*g2 - 160*D1**2*Pk2*f*fd*gd2*r**2 + 80*D1**2*Pk2*f*fd*gd2*r - 80*D1**2*Pk2*f*fdd*g2*r**2 + 80*D1**2*Pk2*f*fdd*g2*r - 40*D1**2*Pk2*f*fdd*g2 - 80*D1**2*Pk2*fd**2*g2*r**2 + 80*D1**2*Pk2*fd**2*g2*r - 21*D1**2*Pkdd2*b2*bdd1*f*k1**2*s**2 + 42*D1**2*Pkdd2*b2*bdd1*f*k1**2*s - 21*D1**2*Pkdd2*b2*bdd1*f*k1**2 - 42*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 + 42*D1**2*Pkdd2*b2*f*fd*k1**2*s - 21*D1**2*Pkdd2*b2*f*fd*k1**2 - 21*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 + 42*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 84*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 42*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 42*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 84*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 84*D1**2*Pkdd2*f*fd*g2*k1**2*s + 42*D1**2*Pkdd2*f*fd*g2*k1**2 + 2*D1**2*bd1**2*(280*Pk2*g2*r*(r - 1) - 35*Pkdd2*b2*k1**2*s*(s - 1) + 70*Pkdd2*g2*k1**2*s*(s - 1) + f**2*(Pk2*(80*r**2 + r*(84*s - 81) - 42*s + 21) - 15*Pkdd2*k1**2*s*(s - 1)) + 7*f*s*(11*Pk2*(2*r - 1) - Pkdd2*k1**2*(3*K + 3)*(s - 1))) + 64*D1*Dd*Pk2*b2*f**2*r**2 - 32*D1*Dd*Pk2*b2*f**2*r + 16*D1*Dd*Pk2*b2*f**2 + 320*D1*Dd*Pk2*b2*f*fd*r**2 - 240*D1*Dd*Pk2*b2*f*fd*r + 40*D1*Dd*Pk2*b2*f*fd + 160*D1*Dd*Pk2*bd2*f**2*r**2 - 40*D1*Dd*Pk2*bd2*f**2*r - 464*D1*Dd*Pk2*f**2*g2*r**2 + 232*D1*Dd*Pk2*f**2*g2*r - 116*D1*Dd*Pk2*f**2*g2 - 320*D1*Dd*Pk2*f**2*gd2*r**2 + 80*D1*Dd*Pk2*f**2*gd2*r - 640*D1*Dd*Pk2*f*fd*g2*r**2 + 480*D1*Dd*Pk2*f*fd*g2*r - 80*D1*Dd*Pk2*f*fd*g2 - 84*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 + 42*D1*Dd*Pkdd2*b2*f**2*k1**2*s - 21*D1*Dd*Pkdd2*b2*f**2*k1**2 + 168*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 84*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 42*D1*Dd*Pkdd2*f**2*g2*k1**2 + 80*D1*Ddd*Pk2*b2*f**2*r**2 - 40*D1*Ddd*Pk2*b2*f**2*r + 20*D1*Ddd*Pk2*b2*f**2 - 160*D1*Ddd*Pk2*f**2*g2*r**2 + 80*D1*Ddd*Pk2*f**2*g2*r - 40*D1*Ddd*Pk2*f**2*g2 + D1*bd1*(D1*(-42*Pkdd2*fd*k1**2*s*(b2 - 2*g2)*(s - 1) + f**3*(6*Pk2*r*(16*r + 6*s - 3) - 15*Pkdd2*k1**2*(3*s**2 - 4*s + 2)) + f**2*(6*Pk2*fd*(24*r**2 + r*(4 - 36*s) + 6*s - 3) + 2*Pk2*r*(29*K*r - 13*r + 41*s) + Pkdd2*k1**2*s**2*(-21*K - 21)) + f*(80*K*Pk2*fd*r**2 - 40*K*Pk2*fd*r + 80*Pk2*fd*r**2 - 136*Pk2*fd*r*s - 6*Pk2*fd*r + 34*Pk2*fd*s + 7*Pkdd2*b2*k1**2*(s**2 - 12*s + 6) - 42*Pkdd2*bd2*k1**2*s**2 + 42*Pkdd2*bd2*k1**2*s + 84*Pkdd2*gd2*k1**2*s**2 - 84*Pkdd2*gd2*k1**2*s + 14*g2*(10*Pk2*(2*r**2 + 2*r - 1) + Pkdd2*k1**2*(-6*s**2 + 22*s - 11)))) + 2*Dd*f*(3*Pk2*f**2*(32*r**2 + r*(10 - 48*s) + 6*s - 3) + Pk2*f*(r**2*(80*K + 80) - r*(20*K + 136*s + 3) + 17*s) - Pkdd2*k1**2*(21*b2 - 42*g2)*(4*s**2 - 5*s + 1))) + 240*Dd**2*Pk2*b2*f**2*r**2 - 120*Dd**2*Pk2*b2*f**2*r - 480*Dd**2*Pk2*f**2*g2*r**2 + 240*Dd**2*Pk2*f**2*g2*r + 7*b1**3*(D1**2*Pkdd2*k1**2*s**2*(fd - 3*fdd) + D1*(-50*Dd*Pk2*(K - 1)*(4*r**2 - 2*r + 1) + Dd*Pkdd2*k1**2*(25*K*(4*s**2 - 2*s + 1) + f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s - 20*s**2 + 10*s - 5) - 20*Ddd*Pk2*(K - 1)*(4*r**2 - 2*r + 1) - Ddd*Pkdd2*k1**2*(5*K + 3*f + 5)*(4*s**2 - 2*s + 1)) - 6*Dd**2*(Pk2*r*(20*K - 20)*(2*r - 1) + Pkdd2*k1**2*s*(2*s - 1)*(5*K + 3*f + 5))) - b1**2*(140*D1**2*K*Pk2*fd*r**2 - 420*D1**2*K*Pk2*fd*r + 210*D1**2*K*Pk2*fd - 42*D1**2*K*Pkdd2*fd*k1**2*s**2 - 70*D1**2*K*Pkdd2*fd*k1**2*s + 35*D1**2*K*Pkdd2*fd*k1**2 + 21*D1**2*K*Pkdd2*fdd*k1**2*s**2 - 128*D1**2*Pk2*f*fd*r**2 + 168*D1**2*Pk2*f*fd*r*s - 10*D1**2*Pk2*f*fd*r - 16*D1**2*Pk2*f*fd - 160*D1**2*Pk2*f*fdd*r**2 - 168*D1**2*Pk2*f*fdd*r*s + 82*D1**2*Pk2*f*fdd*r - 20*D1**2*Pk2*f*fdd - 160*D1**2*Pk2*fd**2*r**2 - 168*D1**2*Pk2*fd**2*r*s + 82*D1**2*Pk2*fd**2*r - 140*D1**2*Pk2*fd*r**2 + 98*D1**2*Pk2*fd*r*s + 322*D1**2*Pk2*fd*r - 210*D1**2*Pk2*fd - 154*D1**2*Pk2*fdd*r*s + 154*D1**2*Pk2*fdd*r - 700*D1**2*Pk2*gd2*r**2 - 280*D1**2*Pk2*gdd2*r**2 - 70*D1**2*Pkdd2*bd2*k1**2*s**2 + 35*D1**2*Pkdd2*bdd2*k1**2*s**2 + 108*D1**2*Pkdd2*f*fd*k1**2*s**2 - 42*D1**2*Pkdd2*f*fd*k1**2*s + 21*D1**2*Pkdd2*f*fd*k1**2 + 30*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*fd**2*k1**2*s**2 + 28*D1**2*Pkdd2*fd*k1**2*s**2 - 70*D1**2*Pkdd2*fd*k1**2*s + 35*D1**2*Pkdd2*fd*k1**2 + 21*D1**2*Pkdd2*fdd*k1**2*s**2 + 350*D1**2*Pkdd2*gd2*k1**2*s**2 - 70*D1**2*Pkdd2*gdd2*k1**2*s**2 + 7*D1**2*bdd1*(Pk2*(20*K - 20)*(3*r**2 - 2*r + 1) + Pkdd2*k1**2*(5*K + 3*f + 5)*(3*s**2 - 2*s + 1)) + 560*D1*Dd*K*Pk2*f*r**2 - 280*D1*Dd*K*Pk2*f*r + 140*D1*Dd*K*Pk2*f - 168*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 84*D1*Dd*K*Pkdd2*f*k1**2*s - 42*D1*Dd*K*Pkdd2*f*k1**2 + 168*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 42*D1*Dd*K*Pkdd2*fd*k1**2*s - 256*D1*Dd*Pk2*f**2*r**2 + 336*D1*Dd*Pk2*f**2*r*s + 44*D1*Dd*Pk2*f**2*r - 84*D1*Dd*Pk2*f**2*s - 64*D1*Dd*Pk2*f**2 - 1280*D1*Dd*Pk2*f*fd*r**2 - 1344*D1*Dd*Pk2*f*fd*r*s + 816*D1*Dd*Pk2*f*fd*r + 168*D1*Dd*Pk2*f*fd*s - 82*D1*Dd*Pk2*f*fd - 560*D1*Dd*Pk2*f*r**2 + 392*D1*Dd*Pk2*f*r*s + 182*D1*Dd*Pk2*f*r - 98*D1*Dd*Pk2*f*s - 140*D1*Dd*Pk2*f - 1232*D1*Dd*Pk2*fd*r*s + 770*D1*Dd*Pk2*fd*r + 154*D1*Dd*Pk2*fd*s - 154*D1*Dd*Pk2*fd - 2800*D1*Dd*Pk2*g2*r**2 + 1400*D1*Dd*Pk2*g2*r - 700*D1*Dd*Pk2*g2 - 2240*D1*Dd*Pk2*gd2*r**2 + 560*D1*Dd*Pk2*gd2*r - 280*D1*Dd*Pkdd2*b2*k1**2*s**2 + 140*D1*Dd*Pkdd2*b2*k1**2*s - 70*D1*Dd*Pkdd2*b2*k1**2 + 280*D1*Dd*Pkdd2*bd2*k1**2*s**2 - 70*D1*Dd*Pkdd2*bd2*k1**2*s + 216*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 108*D1*Dd*Pkdd2*f**2*k1**2*s + 54*D1*Dd*Pkdd2*f**2*k1**2 + 240*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 60*D1*Dd*Pkdd2*f*fd*k1**2*s + 112*D1*Dd*Pkdd2*f*k1**2*s**2 - 56*D1*Dd*Pkdd2*f*k1**2*s + 28*D1*Dd*Pkdd2*f*k1**2 + 168*D1*Dd*Pkdd2*fd*k1**2*s**2 - 42*D1*Dd*Pkdd2*fd*k1**2*s + 1400*D1*Dd*Pkdd2*g2*k1**2*s**2 - 700*D1*Dd*Pkdd2*g2*k1**2*s + 350*D1*Dd*Pkdd2*g2*k1**2 - 560*D1*Dd*Pkdd2*gd2*k1**2*s**2 + 140*D1*Dd*Pkdd2*gd2*k1**2*s + 84*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 42*D1*Ddd*K*Pkdd2*f*k1**2*s + 21*D1*Ddd*K*Pkdd2*f*k1**2 - 320*D1*Ddd*Pk2*f**2*r**2 - 336*D1*Ddd*Pk2*f**2*r*s + 244*D1*Ddd*Pk2*f**2*r + 84*D1*Ddd*Pk2*f**2*s - 80*D1*Ddd*Pk2*f**2 - 616*D1*Ddd*Pk2*f*r*s + 154*D1*Ddd*Pk2*f*r + 154*D1*Ddd*Pk2*f*s - 1120*D1*Ddd*Pk2*g2*r**2 + 560*D1*Ddd*Pk2*g2*r - 280*D1*Ddd*Pk2*g2 + 140*D1*Ddd*Pkdd2*b2*k1**2*s**2 - 70*D1*Ddd*Pkdd2*b2*k1**2*s + 35*D1*Ddd*Pkdd2*b2*k1**2 + 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 30*D1*Ddd*Pkdd2*f**2*k1**2*s + 15*D1*Ddd*Pkdd2*f**2*k1**2 + 84*D1*Ddd*Pkdd2*f*k1**2*s**2 - 42*D1*Ddd*Pkdd2*f*k1**2*s + 21*D1*Ddd*Pkdd2*f*k1**2 - 280*D1*Ddd*Pkdd2*g2*k1**2*s**2 + 140*D1*Ddd*Pkdd2*g2*k1**2*s - 70*D1*Ddd*Pkdd2*g2*k1**2 + 7*D1*bd1*(50*D1*Pk2*(K - 1)*(3*r**2 - 2*r + 1) - D1*Pkdd2*k1**2*(25*K*(3*s**2 - 2*s + 1) + f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s - 15*s**2 + 10*s - 5) + 40*Dd*Pk2*(K - 1)*(12*r**2 - 7*r + 1) + 2*Dd*Pkdd2*k1**2*(5*K + 3*f + 5)*(12*s**2 - 7*s + 1)) + 252*Dd**2*K*Pkdd2*f*k1**2*s**2 - 126*Dd**2*K*Pkdd2*f*k1**2*s - 960*Dd**2*Pk2*f**2*r**2 - 1008*Dd**2*Pk2*f**2*r*s + 732*Dd**2*Pk2*f**2*r + 252*Dd**2*Pk2*f**2*s - 84*Dd**2*Pk2*f**2 - 1848*Dd**2*Pk2*f*r*s + 462*Dd**2*Pk2*f*r + 462*Dd**2*Pk2*f*s - 154*Dd**2*Pk2*f - 3360*Dd**2*Pk2*g2*r**2 + 1680*Dd**2*Pk2*g2*r + 420*Dd**2*Pkdd2*b2*k1**2*s**2 - 210*Dd**2*Pkdd2*b2*k1**2*s + 180*Dd**2*Pkdd2*f**2*k1**2*s**2 - 90*Dd**2*Pkdd2*f**2*k1**2*s + 252*Dd**2*Pkdd2*f*k1**2*s**2 - 126*Dd**2*Pkdd2*f*k1**2*s - 840*Dd**2*Pkdd2*g2*k1**2*s**2 + 420*Dd**2*Pkdd2*g2*k1**2*s) - b1*(-116*D1**2*K*Pk2*f*fd*r**2 + 116*D1**2*K*Pk2*f*fd*r - 58*D1**2*K*Pk2*f*fd - 40*D1**2*K*Pk2*f*fdd*r**2 + 40*D1**2*K*Pk2*f*fdd*r - 20*D1**2*K*Pk2*f*fdd - 40*D1**2*K*Pk2*fd**2*r**2 + 40*D1**2*K*Pk2*fd**2*r + 42*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 42*D1**2*K*Pkdd2*f*fd*k1**2*s + 21*D1**2*K*Pkdd2*f*fd*k1**2 - 288*D1**2*Pk2*f**2*fd*r**2 - 108*D1**2*Pk2*f**2*fd*r*s + 210*D1**2*Pk2*f**2*fd*r + 36*D1**2*Pk2*f**2*fd*s - 96*D1**2*Pk2*f**2*fd - 72*D1**2*Pk2*f**2*fdd*r**2 + 108*D1**2*Pk2*f**2*fdd*r*s + 30*D1**2*Pk2*f**2*fdd*r - 36*D1**2*Pk2*f**2*fdd*s - 24*D1**2*Pk2*f**2*fdd - 144*D1**2*Pk2*f*fd**2*r**2 + 216*D1**2*Pk2*f*fd**2*r*s + 60*D1**2*Pk2*f*fd**2*r - 72*D1**2*Pk2*f*fd**2*s + 18*D1**2*Pk2*f*fd**2 + 52*D1**2*Pk2*f*fd*r**2 - 164*D1**2*Pk2*f*fd*r*s + 30*D1**2*Pk2*f*fd*r + 82*D1**2*Pk2*f*fd*s + 26*D1**2*Pk2*f*fd - 40*D1**2*Pk2*f*fdd*r**2 + 68*D1**2*Pk2*f*fdd*r*s + 6*D1**2*Pk2*f*fdd*r - 34*D1**2*Pk2*f*fdd*s - 20*D1**2*Pk2*f*fdd - 280*D1**2*Pk2*f*gd2*r**2 - 40*D1**2*Pk2*fd**2*r**2 + 68*D1**2*Pk2*fd**2*r*s + 6*D1**2*Pk2*fd**2*r - 34*D1**2*Pk2*fd**2*s + 34*D1**2*Pk2*fd**2 - 280*D1**2*Pk2*fd*g2*r**2 + 840*D1**2*Pk2*fd*g2*r - 420*D1**2*Pk2*fd*g2 - 7*D1**2*Pkdd2*b2*fd*k1**2*s**2 - 70*D1**2*Pkdd2*b2*fd*k1**2*s + 35*D1**2*Pkdd2*b2*fd*k1**2 + 21*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 7*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 42*D1**2*Pkdd2*bd2*fd*k1**2*s**2 + 21*D1**2*Pkdd2*bdd2*f*k1**2*s**2 + 135*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 30*D1**2*Pkdd2*f**2*fd*k1**2*s + 15*D1**2*Pkdd2*f**2*fd*k1**2 + 42*D1**2*Pkdd2*f*fd*k1**2*s**2 - 42*D1**2*Pkdd2*f*fd*k1**2*s + 21*D1**2*Pkdd2*f*fd*k1**2 + 84*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 84*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 140*D1**2*Pkdd2*fd*g2*k1**2*s - 70*D1**2*Pkdd2*fd*g2*k1**2 - 84*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + 14*D1**2*bd1**2*(Pk2*r*(20*K - 20)*(3*r - 2) + Pkdd2*k1**2*s*(3*s - 2)*(5*K + 3*f + 5)) + D1**2*bdd1*(35*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) + f**2*(-2*Pk2*(80*r**2 + 84*r*s - 81*r - 42*s + 30) + 15*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 7*f*(22*Pk2*s*(1 - 2*r) + Pkdd2*k1**2*(3*K + 3)*(2*s**2 - 2*s + 1)) - 70*g2*(Pk2*(8*r**2 - 8*r + 4) + Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 232*D1*Dd*K*Pk2*f**2*r**2 + 116*D1*Dd*K*Pk2*f**2*r - 58*D1*Dd*K*Pk2*f**2 - 320*D1*Dd*K*Pk2*f*fd*r**2 + 240*D1*Dd*K*Pk2*f*fd*r - 40*D1*Dd*K*Pk2*f*fd + 84*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 42*D1*Dd*K*Pkdd2*f**2*k1**2*s + 21*D1*Dd*K*Pkdd2*f**2*k1**2 - 384*D1*Dd*Pk2*f**3*r**2 - 144*D1*Dd*Pk2*f**3*r*s + 228*D1*Dd*Pk2*f**3*r + 36*D1*Dd*Pk2*f**3*s - 96*D1*Dd*Pk2*f**3 - 576*D1*Dd*Pk2*f**2*fd*r**2 + 864*D1*Dd*Pk2*f**2*fd*r*s + 156*D1*Dd*Pk2*f**2*fd*r - 252*D1*Dd*Pk2*f**2*fd*s + 6*D1*Dd*Pk2*f**2*fd + 104*D1*Dd*Pk2*f**2*r**2 - 328*D1*Dd*Pk2*f**2*r*s + 30*D1*Dd*Pk2*f**2*r + 82*D1*Dd*Pk2*f**2*s + 26*D1*Dd*Pk2*f**2 - 320*D1*Dd*Pk2*f*fd*r**2 + 544*D1*Dd*Pk2*f*fd*r*s + 36*D1*Dd*Pk2*f*fd*r - 204*D1*Dd*Pk2*f*fd*s + 28*D1*Dd*Pk2*f*fd - 1120*D1*Dd*Pk2*f*g2*r**2 + 560*D1*Dd*Pk2*f*g2*r - 280*D1*Dd*Pk2*f*g2 - 28*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 14*D1*Dd*Pkdd2*b2*f*k1**2*s - 7*D1*Dd*Pkdd2*b2*f*k1**2 + 168*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 42*D1*Dd*Pkdd2*b2*fd*k1**2*s + 168*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 42*D1*Dd*Pkdd2*bd2*f*k1**2*s + 180*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 90*D1*Dd*Pkdd2*f**3*k1**2*s + 45*D1*Dd*Pkdd2*f**3*k1**2 + 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 42*D1*Dd*Pkdd2*f**2*k1**2*s + 21*D1*Dd*Pkdd2*f**2*k1**2 + 336*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 168*D1*Dd*Pkdd2*f*g2*k1**2*s + 84*D1*Dd*Pkdd2*f*g2*k1**2 - 336*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 84*D1*Dd*Pkdd2*f*gd2*k1**2*s - 336*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 84*D1*Dd*Pkdd2*fd*g2*k1**2*s - 80*D1*Ddd*K*Pk2*f**2*r**2 + 40*D1*Ddd*K*Pk2*f**2*r - 20*D1*Ddd*K*Pk2*f**2 - 96*D1*Ddd*Pk2*f**3*r**2 + 144*D1*Ddd*Pk2*f**3*r*s + 12*D1*Ddd*Pk2*f**3*r - 36*D1*Ddd*Pk2*f**3*s - 24*D1*Ddd*Pk2*f**3 - 80*D1*Ddd*Pk2*f**2*r**2 + 136*D1*Ddd*Pk2*f**2*r*s + 6*D1*Ddd*Pk2*f**2*r - 34*D1*Ddd*Pk2*f**2*s - 20*D1*Ddd*Pk2*f**2 + 84*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 42*D1*Ddd*Pkdd2*b2*f*k1**2*s + 21*D1*Ddd*Pkdd2*b2*f*k1**2 - 168*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 84*D1*Ddd*Pkdd2*f*g2*k1**2*s - 42*D1*Ddd*Pkdd2*f*g2*k1**2 + D1*bd1*(-D1*(2*Pk2*f**2*(64*r**2 - 3*r*(28*s + 9) + 42*s + 24) + 2*Pk2*f*(-35*K*(4*r**2 + 2*r - 1) + fd*(320*r**2 + 4*r*(84*s - 61) - 84*s + 21) + 140*r**2 - 14*r*(7*s - 5) + 49*s - 35) + 1120*Pk2*gd2*r**2 - 560*Pk2*gd2*r + 70*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) - 140*Pkdd2*bd2*k1**2*s**2 + 70*Pkdd2*bd2*k1**2*s - 3*Pkdd2*f**2*k1**2*(36*s**2 - 22*s + 11) + Pkdd2*f*k1**2*(7*K*(12*s**2 - 22*s + 11) - s**2*(120*fd + 56) + s*(60*fd - 14) + 7) + 280*Pkdd2*gd2*k1**2*s**2 - 140*Pkdd2*gd2*k1**2*s + 14*fd*(11*Pk2*(r*(4*s - 2) - s + 1) + Pkdd2*k1**2*s*(-3*K - 3)*(2*s - 1)) + 350*g2*(Pk2*(4*r**2 - 4*r + 2) + Pkdd2*k1**2*(-2*s**2 + 2*s - 1))) + 2*Dd*(-77*Pk2*f*(2*r*(8*s - 1) - 6*s + 1) + 35*Pkdd2*b2*k1**2*(8*s**2 - 6*s + 1) + 21*Pkdd2*f*k1**2*(K + 1)*(8*s**2 - 6*s + 1) + f**2*(-Pk2*(8*r - 3)*(80*r + 84*s - 41) + 15*Pkdd2*k1**2*(8*s**2 - 6*s + 1)) - 70*g2*(4*Pk2*(8*r**2 - 6*r + 1) + Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) - 240*Dd**2*K*Pk2*f**2*r**2 + 120*Dd**2*K*Pk2*f**2*r - 288*Dd**2*Pk2*f**3*r**2 + 432*Dd**2*Pk2*f**3*r*s + 36*Dd**2*Pk2*f**3*r - 108*Dd**2*Pk2*f**3*s + 36*Dd**2*Pk2*f**3 - 240*Dd**2*Pk2*f**2*r**2 + 408*Dd**2*Pk2*f**2*r*s + 18*Dd**2*Pk2*f**2*r - 102*Dd**2*Pk2*f**2*s + 34*Dd**2*Pk2*f**2 + 252*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 126*Dd**2*Pkdd2*b2*f*k1**2*s - 504*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 252*Dd**2*Pkdd2*f*g2*k1**2*s))/(210*d**2*k1**2) + D1**2*Pk1*ct*k1*st**4*(168*Pk2*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(128*C*D1**2*Pk2*f*fd*r*s - 64*C*D1**2*Pk2*f*fd*r + 896*C*D1**2*Pk2*f*fd*s**2 - 896*C*D1**2*Pk2*f*fd*s + 448*C*D1**2*Pk2*f*fd - 64*C*D1**2*Pk2*f*fdd*r*s + 32*C*D1**2*Pk2*f*fdd*r - 448*C*D1**2*Pk2*f*fdd*s**2 + 448*C*D1**2*Pk2*f*fdd*s - 224*C*D1**2*Pk2*f*fdd - 64*C*D1**2*Pk2*fd**2*r*s + 32*C*D1**2*Pk2*fd**2*r - 448*C*D1**2*Pk2*fd**2*s**2 + 448*C*D1**2*Pk2*fd**2*s + 256*C*D1*Dd*Pk2*f**2*r*s - 64*C*D1*Dd*Pk2*f**2*r + 1792*C*D1*Dd*Pk2*f**2*s**2 - 960*C*D1*Dd*Pk2*f**2*s + 448*C*D1*Dd*Pk2*f**2 - 512*C*D1*Dd*Pk2*f*fd*r*s + 192*C*D1*Dd*Pk2*f*fd*r - 3584*C*D1*Dd*Pk2*f*fd*s**2 + 2752*C*D1*Dd*Pk2*f*fd*s - 480*C*D1*Dd*Pk2*f*fd - 128*C*D1*Ddd*Pk2*f**2*r*s + 32*C*D1*Ddd*Pk2*f**2*r - 896*C*D1*Ddd*Pk2*f**2*s**2 + 480*C*D1*Ddd*Pk2*f**2*s - 224*C*D1*Ddd*Pk2*f**2 - 384*C*Dd**2*Pk2*f**2*r*s + 96*C*Dd**2*Pk2*f**2*r - 2688*C*Dd**2*Pk2*f**2*s**2 + 1440*C*Dd**2*Pk2*f**2*s - 32*C*Dd**2*Pk2*f**2 - 56*D1**2*Pk2*bdd1*f*(2*s**2 - 2*s + 1) - 672*D1**2*Pk2*f*fd*r*s + 336*D1**2*Pk2*f*fd*r - 968*D1**2*Pk2*f*fd*s**2 + 1000*D1**2*Pk2*f*fd*s - 500*D1**2*Pk2*f*fd + 448*D1**2*Pk2*f*fdd*r*s - 224*D1**2*Pk2*f*fdd*r + 680*D1**2*Pk2*f*fdd*s**2 - 696*D1**2*Pk2*f*fdd*s + 348*D1**2*Pk2*f*fdd + 448*D1**2*Pk2*fd**2*r*s - 224*D1**2*Pk2*fd**2*r + 680*D1**2*Pk2*fd**2*s**2 - 696*D1**2*Pk2*fd**2*s + 4*D1**2*Pkdd2*f*fd*k1**2*s**2 - 4*D1**2*Pkdd2*f*fd*k1**2*s + 2*D1**2*Pkdd2*f*fd*k1**2 - 2*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 2*D1**2*Pkdd2*f*fdd*k1**2*s - D1**2*Pkdd2*f*fdd*k1**2 - 2*D1**2*Pkdd2*fd**2*k1**2*s**2 + 2*D1**2*Pkdd2*fd**2*k1**2*s - 1344*D1*Dd*Pk2*f**2*r*s + 336*D1*Dd*Pk2*f**2*r - 1936*D1*Dd*Pk2*f**2*s**2 + 1304*D1*Dd*Pk2*f**2*s - 484*D1*Dd*Pk2*f**2 + 3584*D1*Dd*Pk2*f*fd*r*s - 1344*D1*Dd*Pk2*f*fd*r + 5440*D1*Dd*Pk2*f*fd*s**2 - 4592*D1*Dd*Pk2*f*fd*s + 920*D1*Dd*Pk2*f*fd + 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**2*k1**2*s + 2*D1*Dd*Pkdd2*f**2*k1**2 - 16*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*Pkdd2*f*fd*k1**2*s - 2*D1*Dd*Pkdd2*f*fd*k1**2 + 896*D1*Ddd*Pk2*f**2*r*s - 224*D1*Ddd*Pk2*f**2*r + 1360*D1*Ddd*Pk2*f**2*s**2 - 904*D1*Ddd*Pk2*f**2*s + 340*D1*Ddd*Pk2*f**2 - 4*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**2*k1**2*s - D1*Ddd*Pkdd2*f**2*k1**2 + 112*D1*Pk2*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 2688*Dd**2*Pk2*f**2*r*s - 672*Dd**2*Pk2*f**2*r + 4080*Dd**2*Pk2*f**2*s**2 - 2712*Dd**2*Pk2*f**2*s + 224*Dd**2*Pk2*f**2 - 12*Dd**2*Pkdd2*f**2*k1**2*s**2 + 6*Dd**2*Pkdd2*f**2*k1**2*s) + f*(192*C*D1**2*Pk2*f*fd*r*s - 64*C*D1**2*Pk2*f*fd*r + 1344*C*D1**2*Pk2*f*fd*s**2 - 960*C*D1**2*Pk2*f*fd*s + 448*C*D1**2*Pk2*f*fd - 96*C*D1**2*Pk2*f*fdd*r*s + 32*C*D1**2*Pk2*f*fdd*r - 672*C*D1**2*Pk2*f*fdd*s**2 + 480*C*D1**2*Pk2*f*fdd*s - 224*C*D1**2*Pk2*f*fdd - 192*C*D1**2*Pk2*fd**2*r*s + 64*C*D1**2*Pk2*fd**2*r - 1344*C*D1**2*Pk2*fd**2*s**2 + 960*C*D1**2*Pk2*fd**2*s - 32*C*D1**2*Pk2*fd**2 + 256*C*D1*Dd*Pk2*f**2*r*s - 64*C*D1*Dd*Pk2*f**2*r + 1792*C*D1*Dd*Pk2*f**2*s**2 - 960*C*D1*Dd*Pk2*f**2*s + 448*C*D1*Dd*Pk2*f**2 - 768*C*D1*Dd*Pk2*f*fd*r*s + 224*C*D1*Dd*Pk2*f*fd*r - 5376*C*D1*Dd*Pk2*f*fd*s**2 + 3360*C*D1*Dd*Pk2*f*fd*s - 512*C*D1*Dd*Pk2*f*fd - 128*C*D1*Ddd*Pk2*f**2*r*s + 32*C*D1*Ddd*Pk2*f**2*r - 896*C*D1*Ddd*Pk2*f**2*s**2 + 480*C*D1*Ddd*Pk2*f**2*s - 224*C*D1*Ddd*Pk2*f**2 - 384*C*Dd**2*Pk2*f**2*r*s + 96*C*Dd**2*Pk2*f**2*r - 2688*C*Dd**2*Pk2*f**2*s**2 + 1440*C*Dd**2*Pk2*f**2*s - 32*C*Dd**2*Pk2*f**2 - 336*D1**2*Pk2*bd1**2*s*(s - 1) - 912*D1**2*Pk2*f*fd*r*s + 304*D1**2*Pk2*f*fd*r - 972*D1**2*Pk2*f*fd*s**2 + 952*D1**2*Pk2*f*fd*s - 324*D1**2*Pk2*f*fd + 672*D1**2*Pk2*f*fdd*r*s - 224*D1**2*Pk2*f*fdd*r + 612*D1**2*Pk2*f*fdd*s**2 - 632*D1**2*Pk2*f*fdd*s + 204*D1**2*Pk2*f*fdd + 1344*D1**2*Pk2*fd**2*r*s - 448*D1**2*Pk2*fd**2*r + 1224*D1**2*Pk2*fd**2*s**2 - 1264*D1**2*Pk2*fd**2*s + 224*D1**2*Pk2*fd**2 + 6*D1**2*Pkdd2*f*fd*k1**2*s**2 - 4*D1**2*Pkdd2*f*fd*k1**2*s + 2*D1**2*Pkdd2*f*fd*k1**2 - 3*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 2*D1**2*Pkdd2*f*fdd*k1**2*s - D1**2*Pkdd2*f*fdd*k1**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s**2 + 4*D1**2*Pkdd2*fd**2*k1**2*s - 3*D1**2*bdd1*f*(4*Pk2*(s**2*(56*C - 85) + s*(8*C*(r - 1) - 56*r + 52) + 2) + Pkdd2*k1**2*s**2) - 1216*D1*Dd*Pk2*f**2*r*s + 304*D1*Dd*Pk2*f**2*r - 1296*D1*Dd*Pk2*f**2*s**2 + 952*D1*Dd*Pk2*f**2*s - 324*D1*Dd*Pk2*f**2 + 5376*D1*Dd*Pk2*f*fd*r*s - 1568*D1*Dd*Pk2*f*fd*r + 4896*D1*Dd*Pk2*f*fd*s**2 - 4424*D1*Dd*Pk2*f*fd*s + 856*D1*Dd*Pk2*f*fd + 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**2*k1**2*s + 2*D1*Dd*Pkdd2*f**2*k1**2 - 24*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 14*D1*Dd*Pkdd2*f*fd*k1**2*s - 2*D1*Dd*Pkdd2*f*fd*k1**2 + 896*D1*Ddd*Pk2*f**2*r*s - 224*D1*Ddd*Pk2*f**2*r + 816*D1*Ddd*Pk2*f**2*s**2 - 632*D1*Ddd*Pk2*f**2*s + 204*D1*Ddd*Pk2*f**2 - 4*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**2*k1**2*s - D1*Ddd*Pkdd2*f**2*k1**2 + 6*D1*bd1*(D1*(2*Pk2*f*(s**2*(112*C - 121) + s*(16*C*(r - 1) - 84*r + 76) + 4) - 4*Pk2*fd*(4*C*(4*r*s - r + 28*s**2 - 16*s + 1) - 112*r*s + 28*r - 170*s**2 + 139*s - 28) + Pkdd2*f*k1**2*s**2 + Pkdd2*fd*k1**2*s*(1 - 2*s)) + Dd*f*(-4*Pk2*(4*C*(8*r*s - r + 56*s**2 - 19*s + 1) - 224*r*s + 28*r - 340*s**2 + 217*s - 26) + Pkdd2*k1**2*s*(1 - 4*s))) + 2688*Dd**2*Pk2*f**2*r*s - 672*Dd**2*Pk2*f**2*r + 2448*Dd**2*Pk2*f**2*s**2 - 1896*Dd**2*Pk2*f**2*s + 224*Dd**2*Pk2*f**2 - 12*Dd**2*Pkdd2*f**2*k1**2*s**2 + 6*Dd**2*Pkdd2*f**2*k1**2*s))/(210*d**2*k2*k3**2) + D1**2*Pk1*ct*k1*st**2*(21*b1**2*(D1**2*s*(2*fd*(Pk2*r*(16*C - 60) + Pk2*s*(32*C - 69) + Pkdd2*k1**2*s) - fdd*(2*Pk2*(r*(8*C - 40) + s*(16*C - 47)) + Pkdd2*k1**2*s)) + D1*(2*Dd*(16*C*Pk2*f*(r*(4*s - 1) + 8*s**2 - 5*s + 2) - 3*Pk2*f*(20*r*(4*s - 1) + 92*s**2 - 66*s + 23) - 2*Pk2*fd*(r*(4*C - 20)*(8*s - 1) + s*(64*C*s - 20*C - 188*s + 67)) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(1 - 4*s)) - Ddd*f*(2*Pk2*(8*C*(4*r*s - r + 8*s**2 - 5*s + 2) - 160*r*s + 40*r - 188*s**2 + 134*s - 47) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(2*Pk2*(4*C*(12*r*s - 3*r + 24*s**2 - 15*s + 1) - 240*r*s + 60*r - 282*s**2 + 201*s - 20) + 3*Pkdd2*k1**2*s*(2*s - 1))) + 3*b1*(-1472*C*D1**2*Pk2*f*fd*r*s + 832*C*D1**2*Pk2*f*fd*r - 3264*C*D1**2*Pk2*f*fd*s**2 + 3552*C*D1**2*Pk2*f*fd*s - 1824*C*D1**2*Pk2*f*fd + 1184*C*D1**2*Pk2*f*fdd*r*s - 640*C*D1**2*Pk2*f*fdd*r + 2976*C*D1**2*Pk2*f*fdd*s**2 - 3120*C*D1**2*Pk2*f*fdd*s + 1584*C*D1**2*Pk2*f*fdd + 1184*C*D1**2*Pk2*fd**2*r*s - 640*C*D1**2*Pk2*fd**2*r + 2976*C*D1**2*Pk2*fd**2*s**2 - 3120*C*D1**2*Pk2*fd**2*s - 2944*C*D1*Dd*Pk2*f**2*r*s + 736*C*D1*Dd*Pk2*f**2*r - 6528*C*D1*Dd*Pk2*f**2*s**2 + 4000*C*D1*Dd*Pk2*f**2*s - 1632*C*D1*Dd*Pk2*f**2 + 9472*C*D1*Dd*Pk2*f*fd*r*s - 3744*C*D1*Dd*Pk2*f*fd*r + 23808*C*D1*Dd*Pk2*f*fd*s**2 - 19616*C*D1*Dd*Pk2*f*fd*s + 3760*C*D1*Dd*Pk2*f*fd + 2368*C*D1*Ddd*Pk2*f**2*r*s - 592*C*D1*Ddd*Pk2*f**2*r + 5952*C*D1*Ddd*Pk2*f**2*s**2 - 3568*C*D1*Ddd*Pk2*f**2*s + 1488*C*D1*Ddd*Pk2*f**2 + 7104*C*Dd**2*Pk2*f**2*r*s - 1776*C*Dd**2*Pk2*f**2*r + 17856*C*Dd**2*Pk2*f**2*s**2 - 10704*C*Dd**2*Pk2*f**2*s + 592*C*Dd**2*Pk2*f**2 + 308*D1**2*Pk2*f*fd*r**2 + 2384*D1**2*Pk2*f*fd*r*s - 1504*D1**2*Pk2*f*fd*r + 848*D1**2*Pk2*f*fd*s**2 - 1204*D1**2*Pk2*f*fd*s + 758*D1**2*Pk2*f*fd - 308*D1**2*Pk2*f*fdd*r**2 - 1808*D1**2*Pk2*f*fdd*r*s + 1144*D1**2*Pk2*f*fdd*r - 1376*D1**2*Pk2*f*fdd*s**2 + 1540*D1**2*Pk2*f*fdd*s - 890*D1**2*Pk2*f*fdd - 308*D1**2*Pk2*fd**2*r**2 - 1808*D1**2*Pk2*fd**2*r*s + 1144*D1**2*Pk2*fd**2*r - 1376*D1**2*Pk2*fd**2*s**2 + 1540*D1**2*Pk2*fd**2*s - 2*D1**2*Pkdd2*f*fd*k1**2*s**2 + 14*D1**2*Pkdd2*f*fd*k1**2*s - 7*D1**2*Pkdd2*f*fd*k1**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s**2 - 7*D1**2*bdd1*f*(2*Pk2*(8*C*(2*r*s - r + 4*s**2 - 5*s + 2) - 80*r*s + 40*r - 94*s**2 + 134*s - 47) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 616*D1*Dd*Pk2*f**2*r**2 + 4768*D1*Dd*Pk2*f**2*r*s - 1500*D1*Dd*Pk2*f**2*r + 1696*D1*Dd*Pk2*f**2*s**2 - 2040*D1*Dd*Pk2*f**2*s + 578*D1*Dd*Pk2*f**2 - 2464*D1*Dd*Pk2*f*fd*r**2 - 14464*D1*Dd*Pk2*f*fd*r*s + 7000*D1*Dd*Pk2*f*fd*r - 11008*D1*Dd*Pk2*f*fd*s**2 + 10720*D1*Dd*Pk2*f*fd*s - 2684*D1*Dd*Pk2*f*fd - 4*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 2*D1*Dd*Pkdd2*f**2*k1**2*s - D1*Dd*Pkdd2*f**2*k1**2 - 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*Pkdd2*f*fd*k1**2*s - 616*D1*Ddd*Pk2*f**2*r**2 - 3616*D1*Ddd*Pk2*f**2*r*s + 1212*D1*Ddd*Pk2*f**2*r - 2752*D1*Ddd*Pk2*f**2*s**2 + 2280*D1*Ddd*Pk2*f**2*s - 842*D1*Ddd*Pk2*f**2 - 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*D1*Ddd*Pkdd2*f**2*k1**2 + 14*D1*bd1*(D1*(16*C*Pk2*f*(r*(2*s - 1) + 4*s**2 - 5*s + 2) - 3*Pk2*f*(20*r*(2*s - 1) + 46*s**2 - 66*s + 23) - 2*Pk2*fd*(r*(4*C - 20)*(4*s - 1) + s*(4*C*(8*s - 5) - 94*s + 67)) + Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(1 - 2*s)) - Dd*f*(2*Pk2*(8*C*(r*(8*s - 3) + 16*s**2 - 15*s + 3) - 40*r*(8*s - 3) - 376*s**2 + 402*s - 87) + Pkdd2*k1**2*(8*s**2 - 6*s + 1))) - 1848*Dd**2*Pk2*f**2*r**2 - 10848*Dd**2*Pk2*f**2*r*s + 3636*Dd**2*Pk2*f**2*r - 8256*Dd**2*Pk2*f**2*s**2 + 6840*Dd**2*Pk2*f**2*s - 904*Dd**2*Pk2*f**2 - 36*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*Dd**2*Pkdd2*f**2*k1**2*s) - f*(3936*C*D1**2*Pk2*f*fd*r*s - 1312*C*D1**2*Pk2*f*fd*r + 7200*C*D1**2*Pk2*f*fd*s**2 - 6112*C*D1**2*Pk2*f*fd*s + 2400*C*D1**2*Pk2*f*fd - 3264*C*D1**2*Pk2*f*fdd*r*s + 1088*C*D1**2*Pk2*f*fdd*r - 6192*C*D1**2*Pk2*f*fdd*s**2 + 5216*C*D1**2*Pk2*f*fdd*s - 2064*C*D1**2*Pk2*f*fdd - 6528*C*D1**2*Pk2*fd**2*r*s + 2176*C*D1**2*Pk2*fd**2*r - 12384*C*D1**2*Pk2*fd**2*s**2 + 10432*C*D1**2*Pk2*fd**2*s - 1088*C*D1**2*Pk2*fd**2 + 5248*C*D1*Dd*Pk2*f**2*r*s - 1312*C*D1*Dd*Pk2*f**2*r + 9600*C*D1*Dd*Pk2*f**2*s**2 - 6112*C*D1*Dd*Pk2*f**2*s + 2400*C*D1*Dd*Pk2*f**2 - 26112*C*D1*Dd*Pk2*f*fd*r*s + 7616*C*D1*Dd*Pk2*f*fd*r - 49536*C*D1*Dd*Pk2*f*fd*s**2 + 36512*C*D1*Dd*Pk2*f*fd*s - 6304*C*D1*Dd*Pk2*f*fd - 4352*C*D1*Ddd*Pk2*f**2*r*s + 1088*C*D1*Ddd*Pk2*f**2*r - 8256*C*D1*Ddd*Pk2*f**2*s**2 + 5216*C*D1*Ddd*Pk2*f**2*s - 2064*C*D1*Ddd*Pk2*f**2 - 13056*C*Dd**2*Pk2*f**2*r*s + 3264*C*Dd**2*Pk2*f**2*r - 24768*C*Dd**2*Pk2*f**2*s**2 + 15648*C*Dd**2*Pk2*f**2*s - 1088*C*Dd**2*Pk2*f**2 - 798*D1**2*Pk2*f*fd*r**2 - 6816*D1**2*Pk2*f*fd*r*s + 2804*D1**2*Pk2*f*fd*r - 2142*D1**2*Pk2*f*fd*s**2 + 3700*D1**2*Pk2*f*fd*s - 980*D1**2*Pk2*f*fd + 858*D1**2*Pk2*f*fdd*r**2 + 4920*D1**2*Pk2*f*fdd*r*s - 2212*D1**2*Pk2*f*fdd*r + 2610*D1**2*Pk2*f*fdd*s**2 - 3380*D1**2*Pk2*f*fdd*s + 1156*D1**2*Pk2*f*fdd + 1716*D1**2*Pk2*fd**2*r**2 + 9840*D1**2*Pk2*fd**2*r*s - 4424*D1**2*Pk2*fd**2*r + 5220*D1**2*Pk2*fd**2*s**2 - 6760*D1**2*Pk2*fd**2*s + 1640*D1**2*Pk2*fd**2 + 27*D1**2*Pkdd2*f*fd*k1**2*s**2 - 18*D1**2*Pkdd2*f*fd*k1**2*s + 9*D1**2*Pkdd2*f*fd*k1**2 + 42*D1**2*bd1**2*(2*Pk2*(4*C*(2*r*s - r + 4*s**2 - 5*s + 1) - 40*r*s + 20*r - 47*s**2 + 67*s - 20) + Pkdd2*k1**2*s*(s - 1)) - 3*D1**2*bdd1*f*(2*Pk2*(8*C*(37*r*s + 3*r + 93*s**2 - 28*s - 6) - 77*r**2 - 452*r*s + 34*r - 344*s**2 + 370*s + 24) - 3*Pkdd2*k1**2*(s - 1)**2) - 1064*D1*Dd*Pk2*f**2*r**2 - 9088*D1*Dd*Pk2*f**2*r*s + 2804*D1*Dd*Pk2*f**2*r - 2856*D1*Dd*Pk2*f**2*s**2 + 3700*D1*Dd*Pk2*f**2*s - 980*D1*Dd*Pk2*f**2 + 6864*D1*Dd*Pk2*f*fd*r**2 + 39360*D1*Dd*Pk2*f*fd*r*s - 15484*D1*Dd*Pk2*f*fd*r + 20880*D1*Dd*Pk2*f*fd*s**2 - 23660*D1*Dd*Pk2*f*fd*s + 5592*D1*Dd*Pk2*f*fd + 36*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**2*k1**2*s + 9*D1*Dd*Pkdd2*f**2*k1**2 + 1144*D1*Ddd*Pk2*f**2*r**2 + 6560*D1*Ddd*Pk2*f**2*r*s - 2212*D1*Ddd*Pk2*f**2*r + 3480*D1*Ddd*Pk2*f**2*s**2 - 3380*D1*Ddd*Pk2*f**2*s + 1156*D1*Ddd*Pk2*f**2 + 3*D1*bd1*(D1*(2*Pk2*f*(16*C*(23*r*s + 3*r + 51*s**2 - 14*s - 6) - 77*r**2 - 596*r*s - 2*r - 212*s**2 + 418*s + 90) - 4*Pk2*fd*(4*C*(148*r*s - 34*r + 372*s**2 - 251*s + 37) - 154*r**2 - 904*r*s + 320*r - 688*s**2 + 755*s - 226) + Pkdd2*f*k1**2*(s**2 + 12*s - 6) + 12*Pkdd2*fd*k1**2*s*(s - 1)) + 2*Dd*f*(Pk2*(-8*C*(296*r*s - 25*r + 744*s**2 - 335*s + 25) + 616*r**2 + 3616*r*s - 742*r + 2752*s**2 - 2620*s + 404) + 3*Pkdd2*k1**2*(4*s**2 - 5*s + 1))) + 3432*Dd**2*Pk2*f**2*r**2 + 19680*Dd**2*Pk2*f**2*r*s - 6636*Dd**2*Pk2*f**2*r + 10440*Dd**2*Pk2*f**2*s**2 - 10140*Dd**2*Pk2*f**2*s + 1640*Dd**2*Pk2*f**2))/(630*d**2*k2*k3**2) - D1**2*Pk1*ct*k1*(7*b1**2*(D1**2*(2*Pk2*fdd*(25*r**2 - r*s*(48*C - 108) + s**2*(77 - 52*C)) + fd*(-2*Pk2*(25*r**2 + r*s*(116 - 56*C) + s**2*(69 - 44*C)) + 5*Pkdd2*k1**2*s**2)) + D1*(Dd*(4*Pk2*fd*(100*r**2 + r*(-192*C*s + 24*C + 432*s - 79) + s*(-208*C*s + 76*C + 308*s - 131)) + f*(4*Pk2*(2*C*(56*r*s - 14*r + 44*s**2 - 36*s + 11) - 50*r**2 - 232*r*s + 83*r - 138*s**2 + 127*s - 47) + 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 4*Ddd*Pk2*f*(2*C*(48*r*s - 12*r + 52*s**2 - 38*s + 13) - 50*r**2 - 216*r*s + 79*r - 154*s**2 + 131*s - 51)) - 12*Dd**2*Pk2*f*(4*C*(24*r*s - 6*r + 26*s**2 - 19*s + 2) - 50*r**2 - 216*r*s + 79*r - 154*s**2 + 131*s - 18)) + b1*(128*C*D1**2*Pk2*f*fd*r*s + 560*C*D1**2*Pk2*f*fd*r - 864*C*D1**2*Pk2*f*fd*s**2 + 1056*C*D1**2*Pk2*f*fd*s - 840*C*D1**2*Pk2*f*fd + 160*C*D1**2*Pk2*f*fdd*r*s - 560*C*D1**2*Pk2*f*fdd*r + 768*C*D1**2*Pk2*f*fdd*s**2 - 1200*C*D1**2*Pk2*f*fdd*s + 840*C*D1**2*Pk2*f*fdd + 160*C*D1**2*Pk2*fd**2*r*s - 560*C*D1**2*Pk2*fd**2*r + 768*C*D1**2*Pk2*fd**2*s**2 - 1200*C*D1**2*Pk2*fd**2*s + 256*C*D1*Dd*Pk2*f**2*r*s - 64*C*D1*Dd*Pk2*f**2*r - 1728*C*D1*Dd*Pk2*f**2*s**2 + 800*C*D1*Dd*Pk2*f**2*s - 432*C*D1*Dd*Pk2*f**2 + 1280*C*D1*Dd*Pk2*f*fd*r*s - 2400*C*D1*Dd*Pk2*f*fd*r + 6144*C*D1*Dd*Pk2*f*fd*s**2 - 6496*C*D1*Dd*Pk2*f*fd*s + 1760*C*D1*Dd*Pk2*f*fd + 320*C*D1*Ddd*Pk2*f**2*r*s - 80*C*D1*Ddd*Pk2*f**2*r + 1536*C*D1*Ddd*Pk2*f**2*s**2 - 848*C*D1*Ddd*Pk2*f**2*s + 384*C*D1*Ddd*Pk2*f**2 + 960*C*Dd**2*Pk2*f**2*r*s - 240*C*Dd**2*Pk2*f**2*r + 4608*C*Dd**2*Pk2*f**2*s**2 - 2544*C*Dd**2*Pk2*f**2*s + 80*C*Dd**2*Pk2*f**2 - 28*D1**2*Pk2*bdd1*f*(C*(48*r*s - 24*r + 52*s**2 - 76*s + 26) - 25*r**2 - 108*r*s + 79*r - 77*s**2 + 131*s - 51) - 660*D1**2*Pk2*f*fd*r**2 - 2448*D1**2*Pk2*f*fd*r*s + 660*D1**2*Pk2*f*fd*r - 1432*D1**2*Pk2*f*fd*s**2 + 1532*D1**2*Pk2*f*fd*s - 484*D1**2*Pk2*f*fd + 540*D1**2*Pk2*f*fdd*r**2 + 2064*D1**2*Pk2*f*fdd*r*s - 540*D1**2*Pk2*f*fdd*r + 1528*D1**2*Pk2*f*fdd*s**2 - 1340*D1**2*Pk2*f*fdd*s + 424*D1**2*Pk2*f*fdd + 540*D1**2*Pk2*fd**2*r**2 + 2064*D1**2*Pk2*fd**2*r*s - 540*D1**2*Pk2*fd**2*r + 1528*D1**2*Pk2*fd**2*s**2 - 1340*D1**2*Pk2*fd**2*s + 42*D1**2*Pkdd2*f*fd*k1**2*s**2 - 1320*D1*Dd*Pk2*f**2*r**2 - 4896*D1*Dd*Pk2*f**2*r*s + 1884*D1*Dd*Pk2*f**2*r - 2864*D1*Dd*Pk2*f**2*s**2 + 2656*D1*Dd*Pk2*f**2*s - 1046*D1*Dd*Pk2*f**2 + 4320*D1*Dd*Pk2*f*fd*r**2 + 16512*D1*Dd*Pk2*f*fd*r*s - 5304*D1*Dd*Pk2*f*fd*r + 12224*D1*Dd*Pk2*f*fd*s**2 - 10480*D1*Dd*Pk2*f*fd*s + 1880*D1*Dd*Pk2*f*fd + 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 42*D1*Dd*Pkdd2*f**2*k1**2*s + 21*D1*Dd*Pkdd2*f**2*k1**2 + 1080*D1*Ddd*Pk2*f**2*r**2 + 4128*D1*Ddd*Pk2*f**2*r*s - 1572*D1*Ddd*Pk2*f**2*r + 3056*D1*Ddd*Pk2*f**2*s**2 - 2560*D1*Ddd*Pk2*f**2*s + 1034*D1*Ddd*Pk2*f**2 + 7*D1*bd1*(D1*(4*Pk2*fd*(50*r**2 + r*(-96*C*s + 24*C + 216*s - 79) + s*(-104*C*s + 76*C + 154*s - 131)) + f*(4*Pk2*(C*(56*r*s - 28*r + 44*s**2 - 72*s + 22) - 25*r**2 - 116*r*s + 83*r - 69*s**2 + 127*s - 47) + 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 8*Dd*Pk2*f*(2*C*(96*r*s - 36*r + 104*s**2 - 114*s + 25) - 100*r**2 - 432*r*s + 237*r - 308*s**2 + 393*s - 105)) + 3240*Dd**2*Pk2*f**2*r**2 + 12384*Dd**2*Pk2*f**2*r*s - 4716*Dd**2*Pk2*f**2*r + 9168*Dd**2*Pk2*f**2*s**2 - 7680*Dd**2*Pk2*f**2*s + 1032*Dd**2*Pk2*f**2) + f*(-28*D1**2*Pk2*bd1**2*(4*C*(6*r*(2*s - 1) + 13*s**2 - 19*s + 6) - 25*r**2 + r*(79 - 108*s) - 77*s**2 + 131*s - 54) + D1*bd1*(D1*(4*Pk2*fd*(4*C*(5*r*(4*s + 5) + 96*s**2 - 31*s + 5) + 270*r**2 + 3*r*(344*s - 217) + 764*s**2 - 945*s + 258) + f*(2*Pk2*(4*C*(r*(8*s - 78) - 54*s**2 - 32*s + 51) - 165*r**2 - 612*r*(s - 1) - 358*s**2 + 562*s - 281) + 21*Pkdd2*k1**2*(s - 1)**2)) + 4*Dd*Pk2*f*(4*C*(5*r*(8*s + 23) + 192*s**2 + 35*s - 52) + 540*r**2 + 3*r*(688*s - 475) + 1528*s**2 - 1860*s + 563)) + 2*Pk2*(D1**2*bdd1*f*(4*C*(10*r*(s + 6) + 48*s**2 + 44*s - 57) + 135*r**2 + 516*r*(s - 1) + 382*s**2 - 610*s + 305) - 3*D1**2*(f*(fd - fdd)*(12*C*(6*r*(3*s - 1) + 21*s**2 - 20*s + 7) + 51*s**2 - 34*s + 17) - 2*fd**2*(12*C*(6*r*(3*s - 1) + 21*s**2 - 20*s + 3) + 17*s*(3*s - 2))) - 3*D1*f*(Dd*(12*C*f*(6*r*(4*s - 1) + 28*s**2 - 20*s + 7) - 24*C*fd*(3*r*(24*s - 7) + 84*s**2 - 70*s + 13) + 17*f*(4*s**2 - 2*s + 1) - 34*fd*(12*s**2 - 7*s + 1)) - Ddd*f*(12*C*(24*r*s - 6*r + 28*s**2 - 20*s + 7) + 68*s**2 - 34*s + 17)) + 18*Dd**2*f**2*(12*C*(3*r*(4*s - 1) + 14*s**2 - 10*s + 1) + 17*s*(2*s - 1)))))/(210*d**2*k2*k3**2) + D1**2*Pk1*ct*k2*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(8*Pk2*(r*(4*C - 4)*(2*s - 1) + 2*s**2 - 2*s + 1) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 2*fd**2*(-8*Pk2*(r*(2*C - 2)*(2*s - 1) + s*(s - 1)) - Pkdd2*k1**2*s*(s - 1))) + D1*f*(2*Dd*(8*Pk2*f*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 4*s**2 + 2*s + 1) - 8*Pk2*fd*(2*C*(16*r*s - 6*r - 2*s + 1) - 32*r*s + 12*r + 8*s**2 - 2*s - 1) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(-8*s**2 + 6*s - 1)) - Ddd*f*(8*Pk2*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 4*s**2 + 2*s + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(8*Pk2*(C*(24*r*s - 6*r - 6*s + 2) - 24*r*s + 6*r + 6*s**2 + 3*s - 2) + 3*Pkdd2*k1**2*s*(2*s - 1))) + f*(D1**2*(f*(-9*bdd1*s*(8*Pk2*(4*C*(r - 1) - 4*r + s + 4) + Pkdd2*k1**2*s) + 2*fd*(8*Pk2*(-4*C*s + r*(4*C - 4)*(3*s - 1) + 3*s**2 + 2*s + 1) + Pkdd2*k1**2*(3*s**2 - 2*s + 1)) - fdd*(8*Pk2*(-4*C*s + r*(4*C - 4)*(3*s - 1) + 3*s**2 + 2*s + 1) + Pkdd2*k1**2*(3*s**2 - 2*s + 1))) - 2*fd**2*(8*Pk2*(2*C*(6*r*s - 2*r - 2*s + 1) - 12*r*s + 4*r + 3*s**2 + 2*s - 2) + Pkdd2*k1**2*s*(3*s - 2))) + 18*D1*bd1*(D1*f*s*(8*Pk2*(4*C*(r - 1) - 4*r + s + 4) + Pkdd2*k1**2*s) + D1*fd*(-8*Pk2*(C*(8*r*s - 2*r - 4*s + 2) - 8*r*s + 2*r + 2*s**2 + 3*s - 2) + Pkdd2*k1**2*s*(1 - 2*s)) - 8*Dd*Pk2*f*(2*C*(r*(8*s - 1) - 5*s + 1) + r*(2 - 16*s) + 4*s**2 + 9*s - 2) + Dd*Pkdd2*f*k1**2*s*(1 - 4*s)) + D1*f*(2*Dd*(8*Pk2*f*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 4*s**2 + 2*s + 1) - 8*Pk2*fd*(2*C*(24*r*s - 7*r - 7*s + 2) - 48*r*s + 14*r + 12*s**2 + 7*s - 3) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) - Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1)) - Ddd*f*(8*Pk2*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 4*s**2 + 2*s + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(8*Pk2*(C*(24*r*s - 6*r - 6*s + 2) - 24*r*s + 6*r + 6*s**2 + 3*s - 2) + 3*Pkdd2*k1**2*s*(2*s - 1))))/(126*d**2*k1*k3**2) - D1**2*Pk1*ct*k2*st**4*(42*D1**2*bd1**2*f*(Pk2*(8*C - 8)*(r*(2*s - 1) - s + 1) + Pkdd2*k1**2*s*(s - 1)) - 3*D1*bd1*(14*D1*b1*(Pk2*f*(16*C - 16)*(r*(2*s - 1) - s) - Pk2*fd*(8*C - 8)*(r*(4*s - 1) - s) + Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(1 - 2*s)) + D1*f*(-2*Pk2*f*(8*C*(8*r**2 + r*(29*s - 14) - 31*s + 8) - 64*r**2 - 4*r*(45*s - 28) + 83*s**2 + 196*s - 64) + 4*Pk2*fd*(4*C*(30*r**2 + r*(72*s - 47) - 37*s + 18) - 120*r**2 - 8*r*(26*s - 21) + 146*s**2 + 35*s - 52) + Pkdd2*f*k1**2*(s**2*(40*C - 3) - 4*s + 2) + 2*Pkdd2*fd*k1**2*s*(C*(20 - 40*s) - 4*s + 3)) - 14*Dd*b1*f*(Pk2*(16*C - 16)*(r*(8*s - 3) - 3*s + 1) + Pkdd2*k1**2*(8*s**2 - 6*s + 1)) + 2*Dd*f**2*(2*Pk2*(4*C*(60*r**2 + 144*r*s - 89*r - 94*s + 33) - 240*r**2 - 416*r*s + 336*r + 292*s**2 + 203*s - 112) - Pkdd2*k1**2*(4*s - 1)*(s*(20*C + 2) - 1))) + 21*b1**2*(-2*D1*Dd*(Pk2*f*(16*C - 16)*(r*(4*s - 1) - s) - Pk2*fd*(8*C - 8)*(r*(8*s - 1) - s) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(1 - 4*s)) + D1*(-D1*s*(2*fd - fdd)*(Pk2*r*(16*C - 16) + Pkdd2*k1**2*s) + Ddd*f*(Pk2*(16*C - 16)*(4*r*s - r - s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*(8*C - 8)*(3*r*(4*s - 1) - 3*s + 1) + 3*Pkdd2*k1**2*s*(2*s - 1))) + 3*b1*(D1**2*(f*(112*Pk2*bdd1*(C - 1)*(r*(2*s - 1) - s) - 2*Pk2*fdd*(r**2*(120*C - 120) + 8*r*(C*(36*s - 19) - 26*s + 14) + 146*s**2 + s*(8*C - 154) + 73) + 7*Pkdd2*bdd1*k1**2*(2*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(20*C*(2*s**2 - 2*s + 1) + 4*s**2 - 2*s + 1) + fd*(2*Pk2*(r**2*(128*C - 128) + 4*r*(2*C*(58*s - 31) - 90*s + 49) + 166*s**2 + s*(16*C - 182) + 83) + Pkdd2*k1**2*(-40*C*(2*s**2 - 2*s + 1) + 6*s**2 - 10*s + 5))) - 2*fd**2*(2*Pk2*(r**2*(60*C - 60) + 4*r*(36*C*s - 19*C - 26*s + 14) + s*(4*C + 73*s - 77)) + Pkdd2*k1**2*s*(-20*C*(s - 1) - 2*s + 1))) + D1*f*(Dd*(2*Pk2*f*(8*C*(32*r**2 + r*(116*s - 45) - 29*s + 8) - 256*r**2 + r*(308 - 720*s) + 332*s**2 + 14*s + 19) - 4*Pk2*fd*(8*C*(60*r**2 + r*(144*s - 71) - 16*s + 9) - 480*r**2 - 64*r*(13*s - 7) + 584*s**2 - 350*s + 21) - Pkdd2*f*k1**2*(40*C - 3)*(4*s**2 - 2*s + 1) + 2*Pkdd2*fd*k1**2*(4*s - 1)*(20*C*(2*s - 1) + 4*s - 1)) + 2*Ddd*f*(Pk2*(-12*C*(20*r**2 + r*(48*s - 22) - 12*s + 5) + 240*r**2 + 32*r*(13*s - 7) - 292*s**2 + 42*s - 13) + Pkdd2*k1**2*(10*C + 1)*(4*s**2 - 2*s + 1))) + 4*Dd**2*f**2*(Pk2*(-36*C*(10*r**2 + r*(24*s - 11) - 6*s + 2) + 360*r**2 + 48*r*(13*s - 7) - 438*s**2 + 63*s + 52) + Pkdd2*k1**2*s*(30*C + 3)*(2*s - 1))) + f*(3*D1**2*bdd1*f*(-2*Pk2*(4*C*(15*r**2 + 4*r*(9*s - 7) - 38*s + 15) - 60*r**2 - 104*r*s + 112*r + 73*s**2 + 112*s - 60) + Pkdd2*k1**2*(s**2*(20*C + 2) - 2*s + 1)) + D1**2*(f*(2*Pk2*fd*(24*C*(6*r**2 + r*(27*s - 13) - 9*s + 2) - 216*r**2 - 36*r*(9*s - 7) + 141*s**2 + 14*s - 25) - 2*Pk2*fdd*(12*C*(15*r**2 + 6*r*(7*s - 4) - 14*s + 5) - 270*r**2 + r*(228 - 144*s) + 111*s**2 - 26*s - 53) - Pkdd2*fd*k1**2*(40*C - 1)*(3*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(20*C + 1)*(3*s**2 - 2*s + 1)) + 2*fd**2*(Pk2*(-24*C*(15*r**2 + 6*r*(7*s - 4) - 14*s + 7) + 540*r**2 + 288*r*s - 456*r - 222*s**2 + 52*s + 48) + Pkdd2*k1**2*s*(20*C + 1)*(3*s - 2))) + D1*f*(Dd*(2*Pk2*f*(24*C*(8*r**2 + 36*r*s - 13*r - 9*s + 2) - 288*r**2 - 432*r*s + 252*r + 188*s**2 + 14*s - 25) - 4*Pk2*fd*(12*C*(60*r**2 + 84*r*(2*s - 1) - 49*s + 19) - 1080*r**2 - 576*r*s + 798*r + 444*s**2 - 91*s - 101) - Pkdd2*f*k1**2*(40*C - 1)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(40*C + 2)*(12*s**2 - 7*s + 1)) + Ddd*f*(-2*Pk2*(12*C*(20*r**2 + 8*r*(7*s - 3) - 14*s + 5) - 360*r**2 - 192*r*s + 228*r + 148*s**2 - 26*s - 53) + Pkdd2*k1**2*(20*C + 1)*(4*s**2 - 2*s + 1))) + 6*Dd**2*f**2*(-2*Pk2*(4*C*(30*r**2 + 84*r*s - 36*r - 21*s + 7) - 180*r**2 - 96*r*s + 114*r + 74*s**2 - 13*s - 8) + Pkdd2*k1**2*s*(20*C + 1)*(2*s - 1))))/(210*d**2*k1*k3**2) - D1**2*Pk1*ct*k2*st**2*(7*b1**2*(D1**2*(Pk2*fd*r*(16*C - 16)*(4*r + 11*s) - Pk2*fdd*r*(8*C - 8)*(9*r + 16*s) + Pkdd2*fd*k1**2*s**2*(3 - 24*C) + Pkdd2*fdd*k1**2*s**2*(12*C + 1)) + D1*(Dd*(Pk2*f*(16*C - 16)*(16*r**2 + r*(44*s - 19) - 11*s + 4) - Pk2*fd*(16*C - 16)*(36*r**2 + r*(64*s - 17) - 8*s) - Pkdd2*f*k1**2*(24*C - 3)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(24*C + 2)*(4*s - 1)) + Ddd*f*(-Pk2*(8*C - 8)*(36*r**2 + r*(64*s - 34) - 16*s + 9) + Pkdd2*k1**2*(12*C + 1)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(-Pk2*(8*C - 8)*(54*r**2 + r*(96*s - 51) - 24*s + 8) + Pkdd2*k1**2*s*(36*C + 3)*(2*s - 1))) + b1*(-144*C*D1**2*Pk2*f*fd*r**2 + 800*C*D1**2*Pk2*f*fd*r*s - 192*C*D1**2*Pk2*f*fd*r - 400*C*D1**2*Pk2*f*fd*s + 96*C*D1**2*Pk2*f*fd - 432*C*D1**2*Pk2*f*fdd*r**2 - 512*C*D1**2*Pk2*f*fdd*r*s + 432*C*D1**2*Pk2*f*fdd*r + 256*C*D1**2*Pk2*f*fdd*s - 216*C*D1**2*Pk2*f*fdd - 432*C*D1**2*Pk2*fd**2*r**2 - 512*C*D1**2*Pk2*fd**2*r*s + 432*C*D1**2*Pk2*fd**2*r + 256*C*D1**2*Pk2*fd**2*s + 24*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 168*C*D1**2*Pkdd2*f*fd*k1**2*s + 84*C*D1**2*Pkdd2*f*fd*k1**2 + 72*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 72*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 288*C*D1*Dd*Pk2*f**2*r**2 + 1600*C*D1*Dd*Pk2*f**2*r*s - 256*C*D1*Dd*Pk2*f**2*r - 400*C*D1*Dd*Pk2*f**2*s - 72*C*D1*Dd*Pk2*f**2 - 3456*C*D1*Dd*Pk2*f*fd*r**2 - 4096*C*D1*Dd*Pk2*f*fd*r*s + 3104*C*D1*Dd*Pk2*f*fd*r + 1536*C*D1*Dd*Pk2*f*fd*s - 688*C*D1*Dd*Pk2*f*fd + 48*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 24*C*D1*Dd*Pkdd2*f**2*k1**2*s + 12*C*D1*Dd*Pkdd2*f**2*k1**2 + 576*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 144*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 864*C*D1*Ddd*Pk2*f**2*r**2 - 1024*C*D1*Ddd*Pk2*f**2*r*s + 688*C*D1*Ddd*Pk2*f**2*r + 256*C*D1*Ddd*Pk2*f**2*s - 216*C*D1*Ddd*Pk2*f**2 + 144*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 72*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 36*C*D1*Ddd*Pkdd2*f**2*k1**2 - 2592*C*Dd**2*Pk2*f**2*r**2 - 3072*C*Dd**2*Pk2*f**2*r*s + 2064*C*Dd**2*Pk2*f**2*r + 768*C*Dd**2*Pk2*f**2*s - 256*C*Dd**2*Pk2*f**2 + 432*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 216*C*Dd**2*Pkdd2*f**2*k1**2*s - 96*D1**2*Pk2*f*fd*r**2 - 2192*D1**2*Pk2*f*fd*r*s + 1008*D1**2*Pk2*f*fd*r - 1176*D1**2*Pk2*f*fd*s**2 + 1576*D1**2*Pk2*f*fd*s - 744*D1**2*Pk2*f*fd + 720*D1**2*Pk2*f*fdd*r**2 + 1712*D1**2*Pk2*f*fdd*r*s - 1176*D1**2*Pk2*f*fdd*r + 1176*D1**2*Pk2*f*fdd*s**2 - 1432*D1**2*Pk2*f*fdd*s + 876*D1**2*Pk2*f*fdd + 720*D1**2*Pk2*fd**2*r**2 + 1712*D1**2*Pk2*fd**2*r*s - 1176*D1**2*Pk2*fd**2*r + 1176*D1**2*Pk2*fd**2*s**2 - 1432*D1**2*Pk2*fd**2*s + 16*D1**2*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*Pkdd2*f*fd*k1**2*s + 7*D1**2*Pkdd2*f*fd*k1**2 + 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 6*D1**2*Pkdd2*fd**2*k1**2*s**2 - 7*D1**2*bdd1*f*(Pk2*(8*C - 8)*(18*r**2 + r*(32*s - 34) - 16*s + 9) - Pkdd2*k1**2*(12*C + 1)*(2*s**2 - 2*s + 1)) - 192*D1*Dd*Pk2*f**2*r**2 - 4384*D1*Dd*Pk2*f**2*r*s + 1192*D1*Dd*Pk2*f**2*r - 2352*D1*Dd*Pk2*f**2*s**2 + 2272*D1*Dd*Pk2*f**2*s - 636*D1*Dd*Pk2*f**2 + 5760*D1*Dd*Pk2*f*fd*r**2 + 13696*D1*Dd*Pk2*f*fd*r*s - 7856*D1*Dd*Pk2*f*fd*r + 9408*D1*Dd*Pk2*f*fd*s**2 - 9792*D1*Dd*Pk2*f*fd*s + 2608*D1*Dd*Pk2*f*fd + 32*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 16*D1*Dd*Pkdd2*f**2*k1**2*s + 8*D1*Dd*Pkdd2*f**2*k1**2 + 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 12*D1*Dd*Pkdd2*f*fd*k1**2*s + 1440*D1*Ddd*Pk2*f**2*r**2 + 3424*D1*Ddd*Pk2*f**2*r*s - 1576*D1*Ddd*Pk2*f**2*r + 2352*D1*Ddd*Pk2*f**2*s**2 - 2032*D1*Ddd*Pk2*f**2*s + 948*D1*Ddd*Pk2*f**2 + 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 6*D1*Ddd*Pkdd2*f**2*k1**2*s + 3*D1*Ddd*Pkdd2*f**2*k1**2 + 7*D1*bd1*(D1*(Pk2*f*(16*C - 16)*(8*r**2 + r*(22*s - 19) - 11*s + 4) - Pk2*fd*(16*C - 16)*(18*r**2 + r*(32*s - 17) - 8*s) - Pkdd2*f*k1**2*(24*C - 3)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(24*C + 2)*(2*s - 1)) + 2*Dd*f*(-Pk2*(8*C - 8)*(72*r**2 + 2*r*(64*s - 51) - 48*s + 25) + Pkdd2*k1**2*(12*C + 1)*(8*s**2 - 6*s + 1))) + 4320*Dd**2*Pk2*f**2*r**2 + 10272*Dd**2*Pk2*f**2*r*s - 4728*Dd**2*Pk2*f**2*r + 7056*Dd**2*Pk2*f**2*s**2 - 6096*Dd**2*Pk2*f**2*s + 856*Dd**2*Pk2*f**2 + 36*Dd**2*Pkdd2*f**2*k1**2*s**2 - 18*Dd**2*Pkdd2*f**2*k1**2*s) + f*(-744*C*D1**2*Pk2*f*fd*r**2 - 1152*C*D1**2*Pk2*f*fd*r*s + 880*C*D1**2*Pk2*f*fd*r + 384*C*D1**2*Pk2*f*fd*s - 248*C*D1**2*Pk2*f*fd + 480*C*D1**2*Pk2*f*fdd*r**2 + 1152*C*D1**2*Pk2*f*fdd*r*s - 704*C*D1**2*Pk2*f*fdd*r - 384*C*D1**2*Pk2*f*fdd*s + 160*C*D1**2*Pk2*f*fdd + 960*C*D1**2*Pk2*fd**2*r**2 + 2304*C*D1**2*Pk2*fd**2*r*s - 1408*C*D1**2*Pk2*fd**2*r - 768*C*D1**2*Pk2*fd**2*s + 384*C*D1**2*Pk2*fd**2 + 108*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 72*C*D1**2*Pkdd2*f*fd*k1**2*s + 36*C*D1**2*Pkdd2*f*fd*k1**2 - 992*C*D1*Dd*Pk2*f**2*r**2 - 1536*C*D1*Dd*Pk2*f**2*r*s + 880*C*D1*Dd*Pk2*f**2*r + 384*C*D1*Dd*Pk2*f**2*s - 248*C*D1*Dd*Pk2*f**2 + 3840*C*D1*Dd*Pk2*f*fd*r**2 + 9216*C*D1*Dd*Pk2*f*fd*r*s - 4928*C*D1*Dd*Pk2*f*fd*r - 2688*C*D1*Dd*Pk2*f*fd*s + 1088*C*D1*Dd*Pk2*f*fd + 144*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 72*C*D1*Dd*Pkdd2*f**2*k1**2*s + 36*C*D1*Dd*Pkdd2*f**2*k1**2 + 640*C*D1*Ddd*Pk2*f**2*r**2 + 1536*C*D1*Ddd*Pk2*f**2*r*s - 704*C*D1*Ddd*Pk2*f**2*r - 384*C*D1*Ddd*Pk2*f**2*s + 160*C*D1*Ddd*Pk2*f**2 + 1920*C*Dd**2*Pk2*f**2*r**2 + 4608*C*Dd**2*Pk2*f**2*r*s - 2112*C*Dd**2*Pk2*f**2*r - 1152*C*Dd**2*Pk2*f**2*s + 384*C*Dd**2*Pk2*f**2 + 144*D1**2*Pk2*f*fd*r**2 - 1032*D1**2*Pk2*f*fd*r*s + 248*D1**2*Pk2*f*fd*r - 468*D1**2*Pk2*f*fd*s**2 + 656*D1**2*Pk2*f*fd*s - 108*D1**2*Pk2*f*fd + 144*D1**2*Pk2*f*fdd*r**2 + 840*D1**2*Pk2*f*fdd*r*s - 376*D1**2*Pk2*f*fdd*r + 468*D1**2*Pk2*f*fdd*s**2 - 592*D1**2*Pk2*f*fdd*s + 204*D1**2*Pk2*f*fdd + 288*D1**2*Pk2*fd**2*r**2 + 1680*D1**2*Pk2*fd**2*r*s - 752*D1**2*Pk2*fd**2*r + 936*D1**2*Pk2*fd**2*s**2 - 1184*D1**2*Pk2*fd**2*s + 280*D1**2*Pk2*fd**2 + 9*D1**2*Pkdd2*f*fd*k1**2*s**2 - 6*D1**2*Pkdd2*f*fd*k1**2*s + 3*D1**2*Pkdd2*f*fd*k1**2 - 14*D1**2*bd1**2*(Pk2*(8*C - 8)*(9*r**2 + r*(16*s - 17) - 8*s + 8) - Pkdd2*k1**2*s*(12*C + 1)*(s - 1)) + D1**2*bdd1*f*(-4*Pk2*(r**2*(54*C - 90) + 2*r*(32*C*(s - 1) - 107*s + 50) - 147*s**2 + 150*s - 18) + Pkdd2*k1**2*(36*C + 3)*(s - 1)**2) + 192*D1*Dd*Pk2*f**2*r**2 - 1376*D1*Dd*Pk2*f**2*r*s + 248*D1*Dd*Pk2*f**2*r - 624*D1*Dd*Pk2*f**2*s**2 + 656*D1*Dd*Pk2*f**2*s - 108*D1*Dd*Pk2*f**2 + 1152*D1*Dd*Pk2*f*fd*r**2 + 6720*D1*Dd*Pk2*f*fd*r*s - 2632*D1*Dd*Pk2*f*fd*r + 3744*D1*Dd*Pk2*f*fd*s**2 - 4144*D1*Dd*Pk2*f*fd*s + 968*D1*Dd*Pk2*f*fd + 12*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 6*D1*Dd*Pkdd2*f**2*k1**2*s + 3*D1*Dd*Pkdd2*f**2*k1**2 + 192*D1*Ddd*Pk2*f**2*r**2 + 1120*D1*Ddd*Pk2*f**2*r*s - 376*D1*Ddd*Pk2*f**2*r + 624*D1*Ddd*Pk2*f**2*s**2 - 592*D1*Ddd*Pk2*f**2*s + 204*D1*Ddd*Pk2*f**2 + D1*bd1*(D1*(-4*Pk2*f*(2*C*(9*r**2 - 50*r*s + 8*r + 21) + 12*r**2 + 274*r*s - 46*r + 147*s**2 - 174*s - 27) + 4*Pk2*fd*(-4*C*(54*r**2 + 64*r*s - 59*r - 16*s + 16) + 360*r**2 + 856*r*s - 494*r + 588*s**2 - 658*s + 214) + Pkdd2*f*k1**2*(12*C*(s**2 + 12*s - 6) + 8*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(144*C + 12)*(s - 1)) + 2*Dd*f*(-4*Pk2*(C*(216*r**2 + 256*r*s - 214*r - 32*s + 32) - 360*r**2 - 856*r*s + 397*r - 588*s**2 + 554*s - 125) + Pkdd2*k1**2*(36*C + 3)*(4*s**2 - 5*s + 1))) + 576*Dd**2*Pk2*f**2*r**2 + 3360*Dd**2*Pk2*f**2*r*s - 1128*Dd**2*Pk2*f**2*r + 1872*Dd**2*Pk2*f**2*s**2 - 1776*Dd**2*Pk2*f**2*s + 280*Dd**2*Pk2*f**2))/(210*d**2*k1*k3**2) - D1**2*Pk1*ct*k2*(D1*f*(28*D1*Pk2*bd1**2*(6*r**2 + 4*r*(7*s - 5) + 25*s**2 - 39*s + 14) + 2*D1*Pk2*bdd1*f*(r**2*(72*C + 36) + r*(112*C + 132)*(s - 1) + 77*(s - 1)**2) + bd1*(D1*(8*Pk2*fd*(4*C*(18*r**2 + 28*r*s - 23*r - 7*s + 7) + 36*r**2 + 132*r*s - 84*r + 77*s**2 - 110*s + 33) + f*(-2*Pk2*(r**2*(228*C - 12) + r*(112*C + 96)*(s - 1) + 77*(s - 1)**2) + Pkdd2*k1**2*(84*C + 21)*(s - 1)**2)) + 4*Dd*Pk2*f*(8*C*(36*r**2 + 56*r*s - 44*r - 7*s + 7) + 144*r**2 + 528*r*s - 366*r + 308*s**2 - 451*s + 143))) - 7*b1**2*(D1**2*(-2*Pk2*fdd*(6*r**2 + 28*r*s + 25*s**2) + fd*(Pk2*r**2*(40*C - 16) + 32*Pk2*r*s + 50*Pk2*s**2 - Pkdd2*k1**2*s**2*(20*C + 5))) + D1*(Dd*(-4*Pk2*fd*(24*r**2 + 4*r*(28*s - 5) + s*(100*s - 39)) + f*(2*Pk2*(20*C*(4*r**2 - 2*r + 1) - 32*r**2 + 64*r*s + 100*s**2 - 66*s + 17) + Pkdd2*k1**2*(-20*C - 5)*(4*s**2 - 2*s + 1))) - 2*Ddd*Pk2*f*(24*r**2 + 8*r*(14*s - 5) + 100*s**2 - 78*s + 31)) - 4*Dd**2*Pk2*f*(36*r**2 + 12*r*(14*s - 5) + 150*s**2 - 117*s + 14)) + b1*(-912*C*D1**2*Pk2*f*fd*r**2 - 448*C*D1**2*Pk2*f*fd*r*s + 912*C*D1**2*Pk2*f*fd*r + 224*C*D1**2*Pk2*f*fd*s - 456*C*D1**2*Pk2*f*fd + 288*C*D1**2*Pk2*f*fdd*r**2 + 448*C*D1**2*Pk2*f*fdd*r*s - 288*C*D1**2*Pk2*f*fdd*r - 224*C*D1**2*Pk2*f*fdd*s + 144*C*D1**2*Pk2*f*fdd + 288*C*D1**2*Pk2*fd**2*r**2 + 448*C*D1**2*Pk2*fd**2*r*s - 288*C*D1**2*Pk2*fd**2*r - 224*C*D1**2*Pk2*fd**2*s + 168*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 1824*C*D1*Dd*Pk2*f**2*r**2 - 896*C*D1*Dd*Pk2*f**2*r*s + 1136*C*D1*Dd*Pk2*f**2*r + 224*C*D1*Dd*Pk2*f**2*s - 456*C*D1*Dd*Pk2*f**2 + 2304*C*D1*Dd*Pk2*f*fd*r**2 + 3584*C*D1*Dd*Pk2*f*fd*r*s - 2176*C*D1*Dd*Pk2*f*fd*r - 1344*C*D1*Dd*Pk2*f*fd*s + 512*C*D1*Dd*Pk2*f*fd + 336*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 168*C*D1*Dd*Pkdd2*f**2*k1**2*s + 84*C*D1*Dd*Pkdd2*f**2*k1**2 + 576*C*D1*Ddd*Pk2*f**2*r**2 + 896*C*D1*Ddd*Pk2*f**2*r*s - 512*C*D1*Ddd*Pk2*f**2*r - 224*C*D1*Ddd*Pk2*f**2*s + 144*C*D1*Ddd*Pk2*f**2 + 1728*C*Dd**2*Pk2*f**2*r**2 + 2688*C*Dd**2*Pk2*f**2*r*s - 1536*C*Dd**2*Pk2*f**2*r - 672*C*Dd**2*Pk2*f**2*s + 224*C*Dd**2*Pk2*f**2 + 14*D1**2*Pk2*bdd1*f*(12*r**2 + 8*r*(7*s - 5) + 50*s**2 - 78*s + 31) + 48*D1**2*Pk2*f*fd*r**2 - 384*D1**2*Pk2*f*fd*r*s - 48*D1**2*Pk2*f*fd*r - 308*D1**2*Pk2*f*fd*s**2 + 192*D1**2*Pk2*f*fd*s + 24*D1**2*Pk2*f*fd + 144*D1**2*Pk2*f*fdd*r**2 + 528*D1**2*Pk2*f*fdd*r*s - 144*D1**2*Pk2*f*fdd*r + 308*D1**2*Pk2*f*fdd*s**2 - 264*D1**2*Pk2*f*fdd*s + 72*D1**2*Pk2*f*fdd + 144*D1**2*Pk2*fd**2*r**2 + 528*D1**2*Pk2*fd**2*r*s - 144*D1**2*Pk2*fd**2*r + 308*D1**2*Pk2*fd**2*s**2 - 264*D1**2*Pk2*fd**2*s + 42*D1**2*Pkdd2*f*fd*k1**2*s**2 + 96*D1*Dd*Pk2*f**2*r**2 - 768*D1*Dd*Pk2*f**2*r*s + 144*D1*Dd*Pk2*f**2*r - 616*D1*Dd*Pk2*f**2*s**2 + 500*D1*Dd*Pk2*f**2*s - 130*D1*Dd*Pk2*f**2 + 1152*D1*Dd*Pk2*f*fd*r**2 + 4224*D1*Dd*Pk2*f*fd*r*s - 1392*D1*Dd*Pk2*f*fd*r + 2464*D1*Dd*Pk2*f*fd*s**2 - 2200*D1*Dd*Pk2*f*fd*s + 408*D1*Dd*Pk2*f*fd + 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 42*D1*Dd*Pkdd2*f**2*k1**2*s + 21*D1*Dd*Pkdd2*f**2*k1**2 + 288*D1*Ddd*Pk2*f**2*r**2 + 1056*D1*Ddd*Pk2*f**2*r*s - 408*D1*Ddd*Pk2*f**2*r + 616*D1*Ddd*Pk2*f**2*s**2 - 572*D1*Ddd*Pk2*f**2*s + 226*D1*Ddd*Pk2*f**2 - 7*D1*bd1*(D1*(-4*Pk2*fd*(12*r**2 + 4*r*(14*s - 5) + s*(50*s - 39)) + f*(2*Pk2*(20*C*(2*r**2 - 2*r + 1) - 16*r**2 + 32*r*s + 50*s**2 - 66*s + 17) + Pkdd2*k1**2*(-20*C - 5)*(2*s**2 - 2*s + 1))) - 4*Dd*Pk2*f*(48*r**2 + 8*r*(28*s - 15) + 200*s**2 - 234*s + 59)) + 864*Dd**2*Pk2*f**2*r**2 + 3168*Dd**2*Pk2*f**2*r*s - 1224*Dd**2*Pk2*f**2*r + 1848*Dd**2*Pk2*f**2*s**2 - 1716*Dd**2*Pk2*f**2*s + 264*Dd**2*Pk2*f**2))/(210*d**2*k1*k3**2) - D1**2*Pk1*ct*st**4*(528*D1**2*K*Pk2*bdd1*f**2*r*s - 5280*D1**2*Pk2*bdd1*f**3*r*s - 6380*D1**2*Pk2*bdd1*f**3*s**2 + 2640*D1**2*Pk2*bdd1*f**3*s + 440*D1**2*Pk2*bdd1*f**3 - 528*D1**2*Pk2*bdd1*f**2*r*s + 264*D1**2*Pk2*bdd1*f**2*s**2 - 7392*D1**2*Pk2*bdd1*f*g2*r*s + 7392*D1**2*Pk2*bdd1*f*g2*s + 4096*D1**2*Pk2*f**3*fd*r*s - 1024*D1**2*Pk2*f**3*fd*r + 13200*D1**2*Pk2*f**3*fd*s**2 - 7624*D1**2*Pk2*f**3*fd*s + 3300*D1**2*Pk2*f**3*fd - 7680*D1**2*Pk2*f**3*fdd*r*s + 1920*D1**2*Pk2*f**3*fdd*r - 9680*D1**2*Pk2*f**3*fdd*s**2 + 6760*D1**2*Pk2*f**3*fdd*s - 2420*D1**2*Pk2*f**3*fdd - 23040*D1**2*Pk2*f**2*fd**2*r*s + 5760*D1**2*Pk2*f**2*fd**2*r - 29040*D1**2*Pk2*f**2*fd**2*s**2 + 20280*D1**2*Pk2*f**2*fd**2*s - 1920*D1**2*Pk2*f**2*fd**2 + 2112*D1**2*Pk2*f**2*gd2*r*s - 1056*D1**2*Pk2*f**2*gdd2*r*s + 4224*D1**2*Pk2*f*fd*g2*r*s - 2112*D1**2*Pk2*f*fd*g2*r - 2112*D1**2*Pk2*f*fd*g2*s - 4224*D1**2*Pk2*f*fd*gd2*r*s + 1056*D1**2*Pk2*f*fd*gd2*r + 1056*D1**2*Pk2*f*fd*gd2*s - 2112*D1**2*Pk2*f*fdd*g2*r*s + 1056*D1**2*Pk2*f*fdd*g2*r + 1056*D1**2*Pk2*f*fdd*g2*s - 2112*D1**2*Pk2*fd**2*g2*r*s + 1056*D1**2*Pk2*fd**2*g2*r + 1056*D1**2*Pk2*fd**2*g2*s - 1056*D1**2*Pk2*fd**2*g2 + 110*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 33*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 200*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 100*D1**2*Pkdd2*f**3*fd*k1**2*s - 50*D1**2*Pkdd2*f**3*fd*k1**2 + 100*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 50*D1**2*Pkdd2*f**3*fdd*k1**2*s + 25*D1**2*Pkdd2*f**3*fdd*k1**2 + 300*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 150*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 66*D1**2*bd1**2*f*s*(8*Pk2*(14*K*r - 7*K + 5*f*(2*s - 1) - 14*r + 7*s + 7) + Pkdd2*k1**2*s*(5*f + 7)) + 4096*D1*Dd*Pk2*f**4*r*s - 1024*D1*Dd*Pk2*f**4*r + 13200*D1*Dd*Pk2*f**4*s**2 - 7624*D1*Dd*Pk2*f**4*s + 3300*D1*Dd*Pk2*f**4 - 61440*D1*Dd*Pk2*f**3*fd*r*s + 15360*D1*Dd*Pk2*f**3*fd*r - 77440*D1*Dd*Pk2*f**3*fd*s**2 + 54080*D1*Dd*Pk2*f**3*fd*s - 8680*D1*Dd*Pk2*f**3*fd + 8448*D1*Dd*Pk2*f**2*g2*r*s - 2112*D1*Dd*Pk2*f**2*g2*r - 2112*D1*Dd*Pk2*f**2*g2*s - 8448*D1*Dd*Pk2*f**2*gd2*r*s + 1056*D1*Dd*Pk2*f**2*gd2*r + 1056*D1*Dd*Pk2*f**2*gd2*s - 16896*D1*Dd*Pk2*f*fd*g2*r*s + 6336*D1*Dd*Pk2*f*fd*g2*r + 6336*D1*Dd*Pk2*f*fd*g2*s - 2112*D1*Dd*Pk2*f*fd*g2 - 200*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 100*D1*Dd*Pkdd2*f**4*k1**2*s - 50*D1*Dd*Pkdd2*f**4*k1**2 + 800*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 400*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 50*D1*Dd*Pkdd2*f**3*fd*k1**2 - 7680*D1*Ddd*Pk2*f**4*r*s + 1920*D1*Ddd*Pk2*f**4*r - 9680*D1*Ddd*Pk2*f**4*s**2 + 6760*D1*Ddd*Pk2*f**4*s - 2420*D1*Ddd*Pk2*f**4 - 4224*D1*Ddd*Pk2*f**2*g2*r*s + 1056*D1*Ddd*Pk2*f**2*g2*r + 1056*D1*Ddd*Pk2*f**2*g2*s + 100*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 50*D1*Ddd*Pkdd2*f**4*k1**2*s + 25*D1*Ddd*Pkdd2*f**4*k1**2 + 22*D1*bd1*(D1*(-336*Pk2*fd*g2*(r*(2*s - 1) - s + 1) + 2*f**3*(Pk2*(96*r*s + 185*s**2 - 24*s - 20) - 5*Pkdd2*k1**2*s**2) - f**2*(10*fd*(2*Pk2*(72*r*s - 12*r + 87*s**2 - 53*s + 8) + Pkdd2*k1**2*s*(1 - 3*s)) + 3*s*(8*Pk2*(r*(2*K - 2) + s) + Pkdd2*k1**2*s)) + 3*f*(112*Pk2*s*(2*g2*(r - 1) - 2*gd2*r + gd2) + fd*(8*Pk2*(r*(K - 1)*(4*s - 1) + s*(-K + 2*s)) + Pkdd2*k1**2*s*(2*s - 1)))) + Dd*f*(-336*Pk2*g2*(r*(8*s - 1) - 5*s + 1) - 10*f**2*(2*Pk2*(96*r*s - 12*r + 116*s**2 - 65*s + 6) + Pkdd2*k1**2*s*(1 - 4*s)) + 3*f*(8*Pk2*(r*(K - 1)*(8*s - 1) + s*(-K + 4*s)) + Pkdd2*k1**2*s*(4*s - 1)))) - 23040*Dd**2*Pk2*f**4*r*s + 5760*Dd**2*Pk2*f**4*r - 29040*Dd**2*Pk2*f**4*s**2 + 20280*Dd**2*Pk2*f**4*s - 1920*Dd**2*Pk2*f**4 - 12672*Dd**2*Pk2*f**2*g2*r*s + 3168*Dd**2*Pk2*f**2*g2*r + 3168*Dd**2*Pk2*f**2*g2*s - 1056*Dd**2*Pk2*f**2*g2 + 300*Dd**2*Pkdd2*f**4*k1**2*s**2 - 150*Dd**2*Pkdd2*f**4*k1**2*s - 33*b1**2*(D1**2*(-10*fd**2*s*(8*Pk2*(2*s - 1) + Pkdd2*k1**2*(s - 1)) + 2*fd*(8*Pk2*(5*f*(4*s**2 - 2*s + 1) + (7*s - 7)*(r*(2*K - 2) + s - 1)) + Pkdd2*k1**2*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2)) - fdd*(8*Pk2*(5*f*(4*s**2 - 2*s + 1) + (7*s - 7)*(r*(2*K - 2) + s - 1)) + Pkdd2*k1**2*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2))) + D1*(2*Dd*(5*f**2*(16*Pk2 + Pkdd2*k1**2)*(4*s**2 - 2*s + 1) + f*(-8*Pk2*(14*K*s + 5*fd*(1 - 4*s)**2 - 7*r*(2*K - 2)*(4*s - 1) - 28*s**2 - 7) + Pkdd2*k1**2*(-5*fd*(8*s**2 - 6*s + 1) + 28*s**2 - 14*s + 7)) - 7*fd*(8*K*Pk2*(r*(8*s - 5) - s + 1) + 8*Pk2*(r*(5 - 8*s) + s*(4*s - 4)) + Pkdd2*k1**2*(4*s**2 - 5*s + 1))) - Ddd*f*(80*Pk2*f*(4*s**2 - 2*s + 1) + 56*Pk2*(-2*K*s + r*(2*K - 2)*(4*s - 1) + 4*s**2 + 1) + Pkdd2*k1**2*(5*f + 7)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(8*Pk2*(7*K*(12*r*s - 3*r - 3*s + 1) + 60*f*s**2 - 30*f*s - 84*r*s + 21*r + 42*s**2 - 7) + Pkdd2*k1**2*s*(15*f + 21)*(2*s - 1))) - 11*b1*(192*D1**2*K*Pk2*f*fd*r*s - 96*D1**2*K*Pk2*f*fd*r - 96*D1**2*K*Pk2*f*fd*s - 96*D1**2*K*Pk2*f*fdd*r*s + 48*D1**2*K*Pk2*f*fdd*r + 48*D1**2*K*Pk2*f*fdd*s - 96*D1**2*K*Pk2*fd**2*r*s + 48*D1**2*K*Pk2*fd**2*r + 48*D1**2*K*Pk2*fd**2*s - 48*D1**2*K*Pk2*fd**2 - 1152*D1**2*Pk2*f**2*fd*r*s + 384*D1**2*Pk2*f**2*fd*r - 2220*D1**2*Pk2*f**2*fd*s**2 + 1768*D1**2*Pk2*f**2*fd*s - 820*D1**2*Pk2*f**2*fd + 1440*D1**2*Pk2*f**2*fdd*r*s - 480*D1**2*Pk2*f**2*fdd*r + 1740*D1**2*Pk2*f**2*fdd*s**2 - 1400*D1**2*Pk2*f**2*fdd*s + 620*D1**2*Pk2*f**2*fdd + 2880*D1**2*Pk2*f*fd**2*r*s - 960*D1**2*Pk2*f*fd**2*r + 3480*D1**2*Pk2*f*fd**2*s**2 - 2800*D1**2*Pk2*f*fd**2*s + 160*D1**2*Pk2*f*fd**2 - 192*D1**2*Pk2*f*fd*r*s + 96*D1**2*Pk2*f*fd*r + 96*D1**2*Pk2*f*fd*s**2 + 48*D1**2*Pk2*f*fd + 96*D1**2*Pk2*f*fdd*r*s - 48*D1**2*Pk2*f*fdd*r - 48*D1**2*Pk2*f*fdd*s**2 - 24*D1**2*Pk2*f*fdd - 1344*D1**2*Pk2*f*gd2*r*s + 672*D1**2*Pk2*f*gdd2*r*s + 96*D1**2*Pk2*fd**2*r*s - 48*D1**2*Pk2*fd**2*r - 48*D1**2*Pk2*fd**2*s**2 + 48*D1**2*Pk2*fd**2 - 1344*D1**2*Pk2*fd*g2*r*s + 1344*D1**2*Pk2*fd*g2*r + 1344*D1**2*Pk2*fd*gd2*r*s - 672*D1**2*Pk2*fd*gd2*r + 672*D1**2*Pk2*fdd*g2*r*s - 672*D1**2*Pk2*fdd*g2*r + 60*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 40*D1**2*Pkdd2*f**2*fd*k1**2*s + 20*D1**2*Pkdd2*f**2*fd*k1**2 - 30*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 20*D1**2*Pkdd2*f**2*fdd*k1**2*s - 10*D1**2*Pkdd2*f**2*fdd*k1**2 - 60*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 40*D1**2*Pkdd2*f*fd**2*k1**2*s + 12*D1**2*Pkdd2*f*fd*k1**2*s**2 - 12*D1**2*Pkdd2*f*fd*k1**2*s + 6*D1**2*Pkdd2*f*fd*k1**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 6*D1**2*Pkdd2*f*fdd*k1**2*s - 3*D1**2*Pkdd2*f*fdd*k1**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s**2 + 6*D1**2*Pkdd2*fd**2*k1**2*s - 6*D1**2*bdd1*f*(5*f*(4*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2) + 7*s*(8*Pk2*(2*K*r - K - 2*r + s + 1) + Pkdd2*k1**2*s)) + 384*D1*Dd*K*Pk2*f**2*r*s - 96*D1*Dd*K*Pk2*f**2*r - 96*D1*Dd*K*Pk2*f**2*s - 768*D1*Dd*K*Pk2*f*fd*r*s + 288*D1*Dd*K*Pk2*f*fd*r + 288*D1*Dd*K*Pk2*f*fd*s - 96*D1*Dd*K*Pk2*f*fd - 1536*D1*Dd*Pk2*f**3*r*s + 384*D1*Dd*Pk2*f**3*r - 2960*D1*Dd*Pk2*f**3*s**2 + 1864*D1*Dd*Pk2*f**3*s - 740*D1*Dd*Pk2*f**3 + 11520*D1*Dd*Pk2*f**2*fd*r*s - 3360*D1*Dd*Pk2*f**2*fd*r + 13920*D1*Dd*Pk2*f**2*fd*s**2 - 10520*D1*Dd*Pk2*f**2*fd*s + 1880*D1*Dd*Pk2*f**2*fd - 384*D1*Dd*Pk2*f**2*r*s + 96*D1*Dd*Pk2*f**2*r + 192*D1*Dd*Pk2*f**2*s**2 + 48*D1*Dd*Pk2*f**2 + 768*D1*Dd*Pk2*f*fd*r*s - 288*D1*Dd*Pk2*f*fd*r - 384*D1*Dd*Pk2*f*fd*s**2 + 48*D1*Dd*Pk2*f*fd - 5376*D1*Dd*Pk2*f*g2*r*s + 1344*D1*Dd*Pk2*f*g2*r + 1344*D1*Dd*Pk2*f*g2*s + 5376*D1*Dd*Pk2*f*gd2*r*s - 672*D1*Dd*Pk2*f*gd2*r - 672*D1*Dd*Pk2*f*gd2*s + 5376*D1*Dd*Pk2*fd*g2*r*s - 3360*D1*Dd*Pk2*fd*g2*r - 672*D1*Dd*Pk2*fd*g2*s + 672*D1*Dd*Pk2*fd*g2 + 80*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 40*D1*Dd*Pkdd2*f**3*k1**2*s + 20*D1*Dd*Pkdd2*f**3*k1**2 - 240*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 140*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 20*D1*Dd*Pkdd2*f**2*fd*k1**2 + 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 12*D1*Dd*Pkdd2*f**2*k1**2*s + 6*D1*Dd*Pkdd2*f**2*k1**2 - 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 36*D1*Dd*Pkdd2*f*fd*k1**2*s - 6*D1*Dd*Pkdd2*f*fd*k1**2 - 192*D1*Ddd*K*Pk2*f**2*r*s + 48*D1*Ddd*K*Pk2*f**2*r + 48*D1*Ddd*K*Pk2*f**2*s + 1920*D1*Ddd*Pk2*f**3*r*s - 480*D1*Ddd*Pk2*f**3*r + 2320*D1*Ddd*Pk2*f**3*s**2 - 1640*D1*Ddd*Pk2*f**3*s + 580*D1*Ddd*Pk2*f**3 + 192*D1*Ddd*Pk2*f**2*r*s - 48*D1*Ddd*Pk2*f**2*r - 96*D1*Ddd*Pk2*f**2*s**2 - 24*D1*Ddd*Pk2*f**2 + 2688*D1*Ddd*Pk2*f*g2*r*s - 672*D1*Ddd*Pk2*f*g2*r - 672*D1*Ddd*Pk2*f*g2*s - 40*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 20*D1*Ddd*Pkdd2*f**3*k1**2*s - 10*D1*Ddd*Pkdd2*f**3*k1**2 - 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*D1*Ddd*Pkdd2*f**2*k1**2 + 12*D1*bd1*(D1*(5*f**2*(4*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2) + f*s*(8*Pk2*(14*K*r - 7*K + fd*(10 - 20*s) - 14*r + 7*s + 7) + Pkdd2*k1**2*(fd*(5 - 10*s) + 7*s)) - 7*fd*(4*Pk2*(K*r*(4*s - 2) - K*s + K + r*(2 - 4*s) + 2*s**2 - s - 1) + Pkdd2*k1**2*s*(s - 1))) - Dd*f*(4*Pk2*(14*K*r*(8*s - 1) - 42*K*s + 7*K + 5*f*(1 - 4*s)**2 + 7*r*(2 - 16*s) + 56*s**2 + 28*s - 7) + Pkdd2*k1**2*s*(5*f + 7)*(4*s - 1))) - 576*Dd**2*K*Pk2*f**2*r*s + 144*Dd**2*K*Pk2*f**2*r + 144*Dd**2*K*Pk2*f**2*s - 48*Dd**2*K*Pk2*f**2 + 5760*Dd**2*Pk2*f**3*r*s - 1440*Dd**2*Pk2*f**3*r + 6960*Dd**2*Pk2*f**3*s**2 - 4920*Dd**2*Pk2*f**3*s + 480*Dd**2*Pk2*f**3 + 576*Dd**2*Pk2*f**2*r*s - 144*Dd**2*Pk2*f**2*r - 288*Dd**2*Pk2*f**2*s**2 + 48*Dd**2*Pk2*f**2 + 8064*Dd**2*Pk2*f*g2*r*s - 2016*Dd**2*Pk2*f*g2*r - 2016*Dd**2*Pk2*f*g2*s + 672*Dd**2*Pk2*f*g2 - 120*Dd**2*Pkdd2*f**3*k1**2*s**2 + 60*Dd**2*Pkdd2*f**3*k1**2*s - 36*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*Dd**2*Pkdd2*f**2*k1**2*s))/(2310*d**2*k1*k2) - D1**2*Pk1*ct*st**2*(-2464*D1**2*K*Pk2*bdd1*f**2*r*s + 1760*D1**2*Pk2*b2*f*fd*r*s - 880*D1**2*Pk2*b2*f*fd*r - 880*D1**2*Pk2*b2*f*fd*s - 2112*D1**2*Pk2*b2*f*fdd*r*s + 1056*D1**2*Pk2*b2*f*fdd*r + 1056*D1**2*Pk2*b2*f*fdd*s - 2112*D1**2*Pk2*b2*fd**2*r*s + 1056*D1**2*Pk2*b2*fd**2*r + 1056*D1**2*Pk2*b2*fd**2*s - 1056*D1**2*Pk2*b2*fd**2 + 880*D1**2*Pk2*bd2*f**2*r*s - 4224*D1**2*Pk2*bd2*f*fd*r*s + 1056*D1**2*Pk2*bd2*f*fd*r + 1056*D1**2*Pk2*bd2*f*fd*s + 880*D1**2*Pk2*bdd1*f**3*r**2 + 4224*D1**2*Pk2*bdd1*f**3*r*s + 528*D1**2*Pk2*bdd1*f**3*r + 1848*D1**2*Pk2*bdd1*f**3*s**2 - 1452*D1**2*Pk2*bdd1*f**3*s - 946*D1**2*Pk2*bdd1*f**3 + 792*D1**2*Pk2*bdd1*f**2*r**2 + 352*D1**2*Pk2*bdd1*f**2*r*s - 1166*D1**2*Pk2*bdd1*f**2*s**2 + 8624*D1**2*Pk2*bdd1*f*g2*r*s + 1232*D1**2*Pk2*bdd1*f*g2*r - 9856*D1**2*Pk2*bdd1*f*g2*s - 1056*D1**2*Pk2*bdd2*f**2*r*s - 1440*D1**2*Pk2*f**3*fd*r**2 - 11264*D1**2*Pk2*f**3*fd*r*s + 3536*D1**2*Pk2*f**3*fd*r - 7920*D1**2*Pk2*f**3*fd*s**2 + 6776*D1**2*Pk2*f**3*fd*s - 2340*D1**2*Pk2*f**3*fd + 1600*D1**2*Pk2*f**3*fdd*r**2 + 11264*D1**2*Pk2*f**3*fdd*r*s - 3616*D1**2*Pk2*f**3*fdd*r + 7920*D1**2*Pk2*f**3*fdd*s**2 - 6776*D1**2*Pk2*f**3*fdd*s + 2380*D1**2*Pk2*f**3*fdd + 4800*D1**2*Pk2*f**2*fd**2*r**2 + 33792*D1**2*Pk2*f**2*fd**2*r*s - 10848*D1**2*Pk2*f**2*fd**2*r + 23760*D1**2*Pk2*f**2*fd**2*s**2 - 20328*D1**2*Pk2*f**2*fd**2*s + 2816*D1**2*Pk2*f**2*fd**2 - 7392*D1**2*Pk2*f**2*gd2*r*s + 4928*D1**2*Pk2*f**2*gdd2*r*s - 14784*D1**2*Pk2*f*fd*g2*r*s + 7392*D1**2*Pk2*f*fd*g2*r + 7392*D1**2*Pk2*f*fd*g2*s + 19712*D1**2*Pk2*f*fd*gd2*r*s - 4928*D1**2*Pk2*f*fd*gd2*r - 4928*D1**2*Pk2*f*fd*gd2*s + 9856*D1**2*Pk2*f*fdd*g2*r*s - 4928*D1**2*Pk2*f*fdd*g2*r - 4928*D1**2*Pk2*f*fdd*g2*s + 9856*D1**2*Pk2*fd**2*g2*r*s - 4928*D1**2*Pk2*fd**2*g2*r - 4928*D1**2*Pk2*fd**2*g2*s + 4928*D1**2*Pk2*fd**2*g2 + 55*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 110*D1**2*Pkdd2*bdd1*f**3*k1**2*s + 55*D1**2*Pkdd2*bdd1*f**3*k1**2 + 220*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 110*D1**2*Pkdd2*f**3*fd*k1**2*s + 55*D1**2*Pkdd2*f**3*fd*k1**2 - 22*D1**2*bd1**2*(280*Pk2*g2*(r*(2*s - 1) - s + 1) + 6*f**2*(Pk2*(8*r*(8*s - 3) + 98*s**2 - 73*s + 16) - 3*Pkdd2*k1**2*s*(s - 1)) + 7*f*(Pk2*r*(4*K - 4)*(14*s + 1) + 2*Pk2*s*(-16*K + 31*s + 16) - Pkdd2*k1**2*s*(s - 1))) + 3520*D1*Dd*Pk2*b2*f**2*r*s - 880*D1*Dd*Pk2*b2*f**2*r - 880*D1*Dd*Pk2*b2*f**2*s - 16896*D1*Dd*Pk2*b2*f*fd*r*s + 6336*D1*Dd*Pk2*b2*f*fd*r + 6336*D1*Dd*Pk2*b2*f*fd*s - 2112*D1*Dd*Pk2*b2*f*fd - 8448*D1*Dd*Pk2*bd2*f**2*r*s + 1056*D1*Dd*Pk2*bd2*f**2*r + 1056*D1*Dd*Pk2*bd2*f**2*s - 1440*D1*Dd*Pk2*f**4*r**2 - 11264*D1*Dd*Pk2*f**4*r*s + 3536*D1*Dd*Pk2*f**4*r - 7920*D1*Dd*Pk2*f**4*s**2 + 6776*D1*Dd*Pk2*f**4*s - 2340*D1*Dd*Pk2*f**4 + 12800*D1*Dd*Pk2*f**3*fd*r**2 + 90112*D1*Dd*Pk2*f**3*fd*r*s - 28928*D1*Dd*Pk2*f**3*fd*r + 63360*D1*Dd*Pk2*f**3*fd*s**2 - 54208*D1*Dd*Pk2*f**3*fd*s + 10392*D1*Dd*Pk2*f**3*fd - 29568*D1*Dd*Pk2*f**2*g2*r*s + 7392*D1*Dd*Pk2*f**2*g2*r + 7392*D1*Dd*Pk2*f**2*g2*s + 39424*D1*Dd*Pk2*f**2*gd2*r*s - 4928*D1*Dd*Pk2*f**2*gd2*r - 4928*D1*Dd*Pk2*f**2*gd2*s + 78848*D1*Dd*Pk2*f*fd*g2*r*s - 29568*D1*Dd*Pk2*f*fd*g2*r - 29568*D1*Dd*Pk2*f*fd*g2*s + 9856*D1*Dd*Pk2*f*fd*g2 + 220*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 110*D1*Dd*Pkdd2*f**4*k1**2*s + 55*D1*Dd*Pkdd2*f**4*k1**2 - 4224*D1*Ddd*Pk2*b2*f**2*r*s + 1056*D1*Ddd*Pk2*b2*f**2*r + 1056*D1*Ddd*Pk2*b2*f**2*s + 1600*D1*Ddd*Pk2*f**4*r**2 + 11264*D1*Ddd*Pk2*f**4*r*s - 3616*D1*Ddd*Pk2*f**4*r + 7920*D1*Ddd*Pk2*f**4*s**2 - 6776*D1*Ddd*Pk2*f**4*s + 2380*D1*Ddd*Pk2*f**4 + 19712*D1*Ddd*Pk2*f**2*g2*r*s - 4928*D1*Ddd*Pk2*f**2*g2*r - 4928*D1*Ddd*Pk2*f**2*g2*s - 11*D1*bd1*(D1*(-4*Pk2*f*(fd*(72*r**2 - 4*r*(56*K*s - 14*K - 8*s + 11) + s*(56*K - 106*s + 45)) - 56*g2*(7*r*s + r - 8*s) + 28*gd2*(14*r*s + r - 8*s)) - 784*Pk2*fd*g2*(r*(2*s - 1) - s + 1) + 2*f**3*(Pk2*(44*r**2 + 12*r*(20*s - 1) + 48*s**2 - 30*s - 59) + Pkdd2*k1**2*(-4*s**2 - 10*s + 5)) - f**2*(8*Pk2*fd*(60*r**2 + 8*r*(36*s - 7) + 126*s**2 - 123*s + 32) - 2*Pk2*(30*r**2 + r*s*(88 - 168*K) - 71*s**2) + 30*Pkdd2*fd*k1**2*s*(s - 1) + 7*Pkdd2*k1**2*s**2)) - 2*Dd*f*(2*Pk2*f*(144*r**2 + r*(-448*K*s + 56*K + 64*s - 44) + s*(56*K - 212*s + 45)) + 56*Pk2*g2*(r*(56*s - 3) - 39*s + 7) + f**2*(2*Pk2*(160*r**2 + 768*r*s - 88*r + 336*s**2 - 312*s + 21) + 5*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 12672*Dd**2*Pk2*b2*f**2*r*s + 3168*Dd**2*Pk2*b2*f**2*r + 3168*Dd**2*Pk2*b2*f**2*s - 1056*Dd**2*Pk2*b2*f**2 + 4800*Dd**2*Pk2*f**4*r**2 + 33792*Dd**2*Pk2*f**4*r*s - 10848*Dd**2*Pk2*f**4*r + 23760*Dd**2*Pk2*f**4*s**2 - 20328*Dd**2*Pk2*f**4*s + 2816*Dd**2*Pk2*f**4 + 59136*Dd**2*Pk2*f**2*g2*r*s - 14784*Dd**2*Pk2*f**2*g2*r - 14784*Dd**2*Pk2*f**2*g2*s + 4928*Dd**2*Pk2*f**2*g2 + 77*b1**3*(-2*D1*Dd*(Pk2*(40*K - 40)*(r*(4*s - 1) - s) + Pkdd2*k1**2*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5)) + D1*(3*D1*Pkdd2*k1**2*s**2*(-2*fd + fdd) + 40*Ddd*Pk2*(K - 1)*(r*(4*s - 1) - s) + Ddd*Pkdd2*k1**2*(3*f + 5)*(4*s**2 - 2*s + 1)) + 2*Dd**2*(Pk2*(20*K - 20)*(3*r*(4*s - 1) - 3*s + 1) + Pkdd2*k1**2*s*(9*f + 15)*(2*s - 1))) - 11*b1**2*(D1**2*(-280*Pk2*bdd1*(K - 1)*(r*(3*s - 1) - s) - 7*Pk2*r*s*(160*gd2 - 80*gdd2) - 7*Pkdd2*bdd1*k1**2*(3*f + 5)*(3*s**2 - 2*s + 1) + 12*fd**2*(8*Pk2*r*(8*s - 1) + Pk2*s*(98*s - 57) - 3*Pkdd2*k1**2*s**2) - fd*(2*Pk2*(56*K*s + f*(40*r*(8*s - 1) + 756*s**2 - 418*s + 189) + 7*r*(8*K - 8)*(7*s - 8) + 259*s**2 - 574*s + 259) + Pkdd2*k1**2*(-3*f*(10*s**2 + 14*s - 7) + 21*s**2 - 70*s + 35)) + fdd*(6*Pk2*f*(16*r*(8*s - 1) + 196*s**2 - 114*s + 49) + 14*Pk2*(4*K*s + r*(4*K - 4)*(7*s - 8) + 31*s**2 - 66*s + 31) - Pkdd2*k1**2*s**2*(36*f + 7))) + 14*D1*bd1*(40*D1*Pk2*(K - 1)*(r*(3*s - 1) - s) + D1*Pkdd2*k1**2*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - 20*Dd*Pk2*(K - 1)*(r*(24*s - 7) - 7*s + 2) - Dd*Pkdd2*k1**2*(3*f + 5)*(12*s**2 - 7*s + 1)) + D1*(Dd*(-4*Pk2*f**2*(80*r*(4*s - 1) + 756*s**2 - 458*s + 189) + 2*Pk2*f*(6*fd*(32*r*(16*s - 3) + 784*s**2 - 488*s + 65) - 7*r*(56*K - 56)*(4*s - 1) - 1036*s**2 + 7*s*(56*K + 18) - 259) - 560*Pk2*(g2*r*(8*s - 2) - 2*g2*s + gd2*(-8*r*s + r + s)) + 15*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) - 3*Pkdd2*f*k1**2*(s**2*(96*fd + 28) - s*(24*fd + 14) + 7) + 14*fd*(2*Pk2*(2*K*(56*r*s - 39*r - 3*s + 7) - 112*r*s + 78*r + 124*s**2 - 149*s + 17) + Pkdd2*k1**2*s*(1 - 4*s))) + Ddd*(560*Pk2*g2*(r*(4*s - 1) - s) + 6*f**2*(Pk2*(64*r*(4*s - 1) + 392*s**2 - 260*s + 98) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 7*f*(Pk2*(-56*K*s + r*(56*K - 56)*(4*s - 1) + 248*s**2 - 68*s + 62) + Pkdd2*k1**2*(-4*s**2 + 2*s - 1)))) + 2*Dd**2*(280*Pk2*g2*(3*r*(4*s - 1) - 3*s + 1) + 6*f**2*(Pk2*(96*r*(4*s - 1) + 588*s**2 - 390*s + 32) + 9*Pkdd2*k1**2*s*(1 - 2*s)) + 7*f*(2*Pk2*(14*K*(12*r*s - 3*r - 3*s + 1) - 168*r*s + 42*r + 186*s**2 - 51*s - 14) + 3*Pkdd2*k1**2*s*(1 - 2*s)))) + 11*b1*(672*D1**2*K*Pk2*f*fd*r*s - 336*D1**2*K*Pk2*f*fd*r - 336*D1**2*K*Pk2*f*fd*s - 448*D1**2*K*Pk2*f*fdd*r*s + 224*D1**2*K*Pk2*f*fdd*r + 224*D1**2*K*Pk2*f*fdd*s - 448*D1**2*K*Pk2*fd**2*r*s + 224*D1**2*K*Pk2*fd**2*r + 224*D1**2*K*Pk2*fd**2*s - 224*D1**2*K*Pk2*fd**2 - 264*D1**2*Pk2*f**2*fd*r**2 - 1440*D1**2*Pk2*f**2*fd*r*s + 632*D1**2*Pk2*f**2*fd*r - 288*D1**2*Pk2*f**2*fd*s**2 + 612*D1**2*Pk2*f**2*fd*s - 302*D1**2*Pk2*f**2*fd + 240*D1**2*Pk2*f**2*fdd*r**2 + 1152*D1**2*Pk2*f**2*fdd*r*s - 592*D1**2*Pk2*f**2*fdd*r + 504*D1**2*Pk2*f**2*fdd*s**2 - 588*D1**2*Pk2*f**2*fdd*s + 334*D1**2*Pk2*f**2*fdd + 480*D1**2*Pk2*f*fd**2*r**2 + 2304*D1**2*Pk2*f*fd**2*r*s - 1184*D1**2*Pk2*f*fd**2*r + 1008*D1**2*Pk2*f*fd**2*s**2 - 1176*D1**2*Pk2*f*fd**2*s + 128*D1**2*Pk2*f*fd**2 - 120*D1**2*Pk2*f*fd*r**2 - 352*D1**2*Pk2*f*fd*r*s + 296*D1**2*Pk2*f*fd*r + 284*D1**2*Pk2*f*fd*s**2 - 108*D1**2*Pk2*f*fd*s + 82*D1**2*Pk2*f*fd + 144*D1**2*Pk2*f*fdd*r**2 + 64*D1**2*Pk2*f*fdd*r*s - 176*D1**2*Pk2*f*fdd*r - 212*D1**2*Pk2*f*fdd*s**2 + 180*D1**2*Pk2*f*fdd*s - 34*D1**2*Pk2*f*fdd - 1568*D1**2*Pk2*f*gd2*r*s + 784*D1**2*Pk2*f*gdd2*r*s + 144*D1**2*Pk2*fd**2*r**2 + 64*D1**2*Pk2*fd**2*r*s - 176*D1**2*Pk2*fd**2*r - 212*D1**2*Pk2*fd**2*s**2 + 180*D1**2*Pk2*fd**2*s + 32*D1**2*Pk2*fd**2 - 1568*D1**2*Pk2*fd*g2*r*s + 1792*D1**2*Pk2*fd*g2*r - 224*D1**2*Pk2*fd*g2*s + 1568*D1**2*Pk2*fd*gd2*r*s - 896*D1**2*Pk2*fd*gd2*r + 112*D1**2*Pk2*fd*gd2*s + 784*D1**2*Pk2*fdd*g2*r*s - 896*D1**2*Pk2*fdd*g2*r + 112*D1**2*Pk2*fdd*g2*s + 24*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 36*D1**2*Pkdd2*f**2*fd*k1**2*s + 18*D1**2*Pkdd2*f**2*fd*k1**2 + 15*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 14*D1**2*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*Pkdd2*f*fd*k1**2*s + 7*D1**2*Pkdd2*f*fd*k1**2 + 14*D1**2*bd1**2*(Pk2*(20*K - 20)*(r*(6*s - 2) - 2*s + 1) + Pkdd2*k1**2*s*(3*f + 5)*(3*s - 2)) + D1**2*bdd1*(-560*Pk2*g2*(r*(2*s - 1) - s) - 6*f**2*(Pk2*(16*r*(8*s - 3) + 196*s**2 - 146*s + 49) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 7*f*(-4*Pk2*(r*(2*K - 2)*(14*s + 1) + s*(-16*K + 31*s + 16)) + Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 1344*D1*Dd*K*Pk2*f**2*r*s - 336*D1*Dd*K*Pk2*f**2*r - 336*D1*Dd*K*Pk2*f**2*s - 3584*D1*Dd*K*Pk2*f*fd*r*s + 1344*D1*Dd*K*Pk2*f*fd*r + 1344*D1*Dd*K*Pk2*f*fd*s - 448*D1*Dd*K*Pk2*f*fd - 352*D1*Dd*Pk2*f**3*r**2 - 1920*D1*Dd*Pk2*f**3*r*s + 656*D1*Dd*Pk2*f**3*r - 384*D1*Dd*Pk2*f**3*s**2 + 672*D1*Dd*Pk2*f**3*s - 184*D1*Dd*Pk2*f**3 + 1920*D1*Dd*Pk2*f**2*fd*r**2 + 9216*D1*Dd*Pk2*f**2*fd*r*s - 4000*D1*Dd*Pk2*f**2*fd*r + 4032*D1*Dd*Pk2*f**2*fd*s**2 - 4512*D1*Dd*Pk2*f**2*fd*s + 1180*D1*Dd*Pk2*f**2*fd - 240*D1*Dd*Pk2*f**2*r**2 - 704*D1*Dd*Pk2*f**2*r*s + 296*D1*Dd*Pk2*f**2*r + 568*D1*Dd*Pk2*f**2*s**2 - 108*D1*Dd*Pk2*f**2*s + 82*D1*Dd*Pk2*f**2 + 1152*D1*Dd*Pk2*f*fd*r**2 + 512*D1*Dd*Pk2*f*fd*r*s - 1056*D1*Dd*Pk2*f*fd*r - 1696*D1*Dd*Pk2*f*fd*s**2 + 1080*D1*Dd*Pk2*f*fd*s - 4*D1*Dd*Pk2*f*fd - 6272*D1*Dd*Pk2*f*g2*r*s + 1568*D1*Dd*Pk2*f*g2*r + 1568*D1*Dd*Pk2*f*g2*s + 6272*D1*Dd*Pk2*f*gd2*r*s - 784*D1*Dd*Pk2*f*gd2*r - 784*D1*Dd*Pk2*f*gd2*s + 6272*D1*Dd*Pk2*fd*g2*r*s - 4368*D1*Dd*Pk2*fd*g2*r - 336*D1*Dd*Pk2*fd*g2*s + 784*D1*Dd*Pk2*fd*g2 + 32*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 16*D1*Dd*Pkdd2*f**3*k1**2*s + 8*D1*Dd*Pkdd2*f**3*k1**2 + 120*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 30*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 28*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 14*D1*Dd*Pkdd2*f**2*k1**2*s + 7*D1*Dd*Pkdd2*f**2*k1**2 - 896*D1*Ddd*K*Pk2*f**2*r*s + 224*D1*Ddd*K*Pk2*f**2*r + 224*D1*Ddd*K*Pk2*f**2*s + 320*D1*Ddd*Pk2*f**3*r**2 + 1536*D1*Ddd*Pk2*f**3*r*s - 544*D1*Ddd*Pk2*f**3*r + 672*D1*Ddd*Pk2*f**3*s**2 - 720*D1*Ddd*Pk2*f**3*s + 248*D1*Ddd*Pk2*f**3 + 288*D1*Ddd*Pk2*f**2*r**2 + 128*D1*Ddd*Pk2*f**2*r*s - 176*D1*Ddd*Pk2*f**2*r - 424*D1*Ddd*Pk2*f**2*s**2 + 180*D1*Ddd*Pk2*f**2*s - 34*D1*Ddd*Pk2*f**2 + 3136*D1*Ddd*Pk2*f*g2*r*s - 784*D1*Ddd*Pk2*f*g2*r - 784*D1*Ddd*Pk2*f*g2*s + 20*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 10*D1*Ddd*Pkdd2*f**3*k1**2*s + 5*D1*Ddd*Pkdd2*f**3*k1**2 + 2*D1*bd1*(D1*(280*Pk2*(g2*r*(4*s - 2) - 2*g2*s + gd2*(-4*r*s + r + s)) + f**2*(Pk2*(40*r*(8*s - 3) + 756*s**2 - 498*s + 189) - 3*Pkdd2*k1**2*(5*s**2 - 12*s + 6)) + f*(7*Pk2*r*(8*K - 8)*(14*s + 1) + 14*Pk2*s*(-32*K + 37*s + 32) + 7*Pkdd2*k1**2*(3*s**2 + 2*s - 1) - 12*fd*(2*Pk2*(64*r*s - 16*r + 98*s**2 - 65*s + 4) + 3*Pkdd2*k1**2*s*(1 - 2*s))) - 7*fd*(4*Pk2*(K*(28*r*s - 15*r - 6*s + 7) - 28*r*s + 15*r + 31*s**2 - 25*s - 7) + Pkdd2*k1**2*s*(1 - 2*s))) + Dd*(-560*Pk2*g2*(r*(8*s - 3) - 3*s + 1) - 6*f**2*(Pk2*(32*r*(16*s - 5) + 784*s**2 - 552*s + 97) - 3*Pkdd2*k1**2*(8*s**2 - 6*s + 1)) - 7*f*(4*Pk2*(K*(2*r*(56*s - 5) - 46*s + 7) - 112*r*s + 10*r + 124*s**2 + 15*s - 7) + Pkdd2*k1**2*(-8*s**2 + 6*s - 1)))) - 2688*Dd**2*K*Pk2*f**2*r*s + 672*Dd**2*K*Pk2*f**2*r + 672*Dd**2*K*Pk2*f**2*s - 224*Dd**2*K*Pk2*f**2 + 960*Dd**2*Pk2*f**3*r**2 + 4608*Dd**2*Pk2*f**3*r*s - 1632*Dd**2*Pk2*f**3*r + 2016*Dd**2*Pk2*f**3*s**2 - 2160*Dd**2*Pk2*f**3*s + 384*Dd**2*Pk2*f**3 + 864*Dd**2*Pk2*f**2*r**2 + 384*Dd**2*Pk2*f**2*r*s - 528*Dd**2*Pk2*f**2*r - 1272*Dd**2*Pk2*f**2*s**2 + 540*Dd**2*Pk2*f**2*s + 32*Dd**2*Pk2*f**2 + 9408*Dd**2*Pk2*f*g2*r*s - 2352*Dd**2*Pk2*f*g2*r - 2352*Dd**2*Pk2*f*g2*s + 784*Dd**2*Pk2*f*g2 + 60*Dd**2*Pkdd2*f**3*k1**2*s**2 - 30*Dd**2*Pkdd2*f**3*k1**2*s))/(2310*d**2*k1*k2) - D1**2*Pk1*ct*(4*D1**2*Pk2*bd1**2*(f**2*(36*r**2 + 2*r*(112*s - 51) + 210*s**2 - 189*s + 56) + 7*f*(6*r**2 - r*(6*K - 6)*(2*s - 1) + 25*s**2) + 140*g2*(r*(2*s - 1) - s + 1)) - D1*bd1*(D1*(-2*Pk2*f**2*(4*fd*(30*r**2 + r*(216*s - 94) + 189*s**2 - 162*s + 24) - 7*s*(r*(8*K + 8) + 11*s)) - 28*Pk2*f*(fd*(r*(4*K + 4)*(4*s - 1) + s*(-4*K + 22*s - 15)) - 12*r*(2*g2*(s - 1) - 2*gd2*s + gd2)) - 336*Pk2*fd*g2*(r*(2*s - 1) - s + 1) + f**3*(2*Pk2*(40*r**2 + 48*r*(3*s - 2) + 126*s**2 - 126*s + 63) - 15*Pkdd2*k1**2*(s - 1)**2)) - 4*Dd*Pk2*f*(f**2*(80*r**2 + 4*r*(144*s - 71) + 504*s**2 - 450*s + 111) + 7*f*(r*(4*K + 4)*(8*s - 1) + s*(-4*K + 44*s - 15)) + 84*g2*(r*(8*s - 5) - s + 1))) + 2*Pk2*(D1**2*bdd1*f*(f**2*(20*r**2 + 48*r*(3*s - 2) + 126*s**2 - 126*s + 63) + 7*f*s*(r*(8*K + 8) + 11*s) + 168*g2*r*(s - 1)) - 56*D1*Dd*f*(f*(bd2*(-8*r*s + r + s) + 2*g2*(-4*r*s + r + s) + 2*gd2*r*(8*s - 1) - 2*gd2*s) + 4*fd*g2*(r*(8*s - 3) - 3*s + 1)) - 56*D1*(D1*(f*fd*(bd2*(-4*r*s + r + s) + 2*g2*(-2*r*s + r + s) + 2*gd2*(4*r*s - r - s)) + f*(f*r*s*(bd2 - bdd2 - 2*gd2 + 2*gdd2) + 2*fdd*g2*(r*(2*s - 1) - s)) + 2*fd**2*g2*(r*(2*s - 1) - s + 1)) + 2*Ddd*f**2*g2*(r*(4*s - 1) - s)) - 112*Dd**2*f**2*g2*(3*r*(4*s - 1) - 3*s + 1) + 56*b2*(D1*Dd*f*(f*(-4*r*s + r + s) + 2*fd*(8*r*s - 3*r - 3*s + 1)) + D1*(D1*(f*fd*(-2*r*s + r + s) + f*fdd*(2*r*s - r - s) + fd**2*(2*r*s - r - s + 1)) + Ddd*f**2*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))) - 35*b1**3*(-D1*Dd*(Pk2*(16*K - 16)*(r*(4*s - 1) - s) + Pkdd2*k1**2*(f + 3)*(4*s**2 - 2*s + 1)) - D1*(D1*Pkdd2*fd*k1**2*s**2 - 8*Ddd*Pk2*(K - 1)*(r*(4*s - 1) - s)) + 8*Dd**2*Pk2*(K - 1)*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(D1**2*(4*Pk2*fd**2*(36*r**2 + r*(224*s - 46) + 7*s*(30*s - 19)) - 2*Pk2*fd*(168*K*s + f*(144*r**2 + 64*r*(7*s - 2) + 420*s**2 - 266*s + 141) + 84*r**2 - 168*r*(s*(K - 1) + 1) + 175*s**2 - 518*s + 259) + 2*Pk2*(-140*bdd1*(K - 1)*(3*r*s - r - s) + fdd*(84*K*s + f*(72*r**2 + r*(448*s - 92) + 420*s**2 - 266*s + 123) + 42*r**2 - 84*r*(s*(K - 1) + 1) + 175*s**2 - 434*s + 217) - 140*r*s*(4*gd2 - 2*gdd2)) + Pkdd2*fd*k1**2*s**2*(84*f + 35)) + 35*D1*bd1*(D1*(Pk2*(16*K - 16)*(r*(3*s - 1) - s) + Pkdd2*k1**2*(f + 3)*(3*s**2 - 2*s + 1)) - 8*Dd*Pk2*(K - 1)*(r*(24*s - 7) - 7*s + 2)) + D1*(Dd*(-28*Pk2*(fd*(6*K*(r*(8*s - 1) - 5*s + 1) - 24*r**2 + r*(36 - 48*s) - 100*s**2 + 155*s - 37) + 20*g2*r*(8*s - 2) - 40*g2*s + 20*gd2*(-8*r*s + r + s)) - 2*f**2*(Pk2*(288*r**2 + 16*r*(56*s - 23) + 840*s**2 - 644*s + 282) - 21*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(2*Pk2*(-168*K*s + fd*(576*r**2 + 64*r*(56*s - 15) + 3360*s**2 - 2352*s + 358) - 336*r**2 + 168*r*(4*K*s - K - 4*s + 2) - 700*s**2 + 518*s - 259) + 35*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 2*Ddd*Pk2*(2*f**2*(72*r**2 + 4*r*(112*s - 37) + 420*s**2 - 322*s + 123) + 7*f*(12*K*s + 24*r**2 - 12*r*(4*K*s - K - 4*s + 2) + 100*s**2 - 62*s + 31) + 280*g2*(r*(4*s - 1) - s))) + 4*Dd**2*Pk2*(2*f**2*(108*r**2 + 6*r*(112*s - 37) + 630*s**2 - 483*s + 56) + 21*f*(K*(-24*r*s + 6*r + 6*s - 2) + 12*r**2 + 24*r*s - 12*r + 50*s**2 - 31*s + 2) + 140*g2*(3*r*(4*s - 1) - 3*s + 1))) + b1*(-224*D1**2*K*Pk2*f*fd*r*s + 112*D1**2*K*Pk2*f*fd*r + 112*D1**2*K*Pk2*f*fd*s + 224*D1**2*K*Pk2*f*fdd*r*s - 112*D1**2*K*Pk2*f*fdd*r - 112*D1**2*K*Pk2*f*fdd*s + 224*D1**2*K*Pk2*fd**2*r*s - 112*D1**2*K*Pk2*fd**2*r - 112*D1**2*K*Pk2*fd**2*s + 112*D1**2*K*Pk2*fd**2 - 280*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) - 2*s + 1) + 2*D1**2*Pk2*bdd1*(f**2*(72*r**2 + 4*r*(112*s - 51) + 420*s**2 - 378*s + 123) + 14*f*(6*r**2 - r*(6*K - 6)*(2*s - 1) + 25*s**2) + 280*g2*(r*(2*s - 1) - s)) - 240*D1**2*Pk2*f**2*fd*r**2 - 864*D1**2*Pk2*f**2*fd*r*s + 256*D1**2*Pk2*f**2*fd*r - 756*D1**2*Pk2*f**2*fd*s**2 + 540*D1**2*Pk2*f**2*fd*s - 206*D1**2*Pk2*f**2*fd + 120*D1**2*Pk2*f**2*fdd*r**2 + 864*D1**2*Pk2*f**2*fdd*r*s - 176*D1**2*Pk2*f**2*fdd*r + 756*D1**2*Pk2*f**2*fdd*s**2 - 540*D1**2*Pk2*f**2*fdd*s + 166*D1**2*Pk2*f**2*fdd + 240*D1**2*Pk2*f*fd**2*r**2 + 1728*D1**2*Pk2*f*fd**2*r*s - 352*D1**2*Pk2*f*fd**2*r + 1512*D1**2*Pk2*f*fd**2*s**2 - 1080*D1**2*Pk2*f*fd**2*s + 96*D1**2*Pk2*f*fd**2 - 224*D1**2*Pk2*f*fd*r*s + 112*D1**2*Pk2*f*fd*r - 308*D1**2*Pk2*f*fd*s**2 + 420*D1**2*Pk2*f*fd*s - 154*D1**2*Pk2*f*fd + 224*D1**2*Pk2*f*fdd*r*s - 112*D1**2*Pk2*f*fdd*r + 308*D1**2*Pk2*f*fdd*s**2 - 420*D1**2*Pk2*f*fdd*s + 154*D1**2*Pk2*f*fdd - 672*D1**2*Pk2*f*gd2*r*s + 336*D1**2*Pk2*f*gdd2*r*s + 224*D1**2*Pk2*fd**2*r*s - 112*D1**2*Pk2*fd**2*r + 308*D1**2*Pk2*fd**2*s**2 - 420*D1**2*Pk2*fd**2*s + 112*D1**2*Pk2*fd**2 - 672*D1**2*Pk2*fd*g2*r*s + 672*D1**2*Pk2*fd*g2*s + 672*D1**2*Pk2*fd*gd2*r*s - 336*D1**2*Pk2*fd*gd2*s + 336*D1**2*Pk2*fdd*g2*r*s - 336*D1**2*Pk2*fdd*g2*s + 45*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 448*D1*Dd*K*Pk2*f**2*r*s + 112*D1*Dd*K*Pk2*f**2*r + 112*D1*Dd*K*Pk2*f**2*s + 1792*D1*Dd*K*Pk2*f*fd*r*s - 672*D1*Dd*K*Pk2*f*fd*r - 672*D1*Dd*K*Pk2*f*fd*s + 224*D1*Dd*K*Pk2*f*fd - 320*D1*Dd*Pk2*f**3*r**2 - 1152*D1*Dd*Pk2*f**3*r*s + 448*D1*Dd*Pk2*f**3*r - 1008*D1*Dd*Pk2*f**3*s**2 + 792*D1*Dd*Pk2*f**3*s - 332*D1*Dd*Pk2*f**3 + 960*D1*Dd*Pk2*f**2*fd*r**2 + 6912*D1*Dd*Pk2*f**2*fd*r*s - 1808*D1*Dd*Pk2*f**2*fd*r + 6048*D1*Dd*Pk2*f**2*fd*s**2 - 4536*D1*Dd*Pk2*f**2*fd*s + 716*D1*Dd*Pk2*f**2*fd - 448*D1*Dd*Pk2*f**2*r*s + 112*D1*Dd*Pk2*f**2*r - 616*D1*Dd*Pk2*f**2*s**2 + 420*D1*Dd*Pk2*f**2*s - 154*D1*Dd*Pk2*f**2 + 1792*D1*Dd*Pk2*f*fd*r*s - 672*D1*Dd*Pk2*f*fd*r + 2464*D1*Dd*Pk2*f*fd*s**2 - 2520*D1*Dd*Pk2*f*fd*s + 532*D1*Dd*Pk2*f*fd - 2688*D1*Dd*Pk2*f*g2*r*s + 672*D1*Dd*Pk2*f*g2*r + 672*D1*Dd*Pk2*f*g2*s + 2688*D1*Dd*Pk2*f*gd2*r*s - 336*D1*Dd*Pk2*f*gd2*r - 336*D1*Dd*Pk2*f*gd2*s + 2688*D1*Dd*Pk2*fd*g2*r*s - 336*D1*Dd*Pk2*fd*g2*r - 1680*D1*Dd*Pk2*fd*g2*s + 336*D1*Dd*Pk2*fd*g2 + 60*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 30*D1*Dd*Pkdd2*f**3*k1**2*s + 15*D1*Dd*Pkdd2*f**3*k1**2 + 448*D1*Ddd*K*Pk2*f**2*r*s - 112*D1*Ddd*K*Pk2*f**2*r - 112*D1*Ddd*K*Pk2*f**2*s + 160*D1*Ddd*Pk2*f**3*r**2 + 1152*D1*Ddd*Pk2*f**3*r*s - 368*D1*Ddd*Pk2*f**3*r + 1008*D1*Ddd*Pk2*f**3*s**2 - 792*D1*Ddd*Pk2*f**3*s + 292*D1*Ddd*Pk2*f**3 + 448*D1*Ddd*Pk2*f**2*r*s - 112*D1*Ddd*Pk2*f**2*r + 616*D1*Ddd*Pk2*f**2*s**2 - 420*D1*Ddd*Pk2*f**2*s + 154*D1*Ddd*Pk2*f**2 + 1344*D1*Ddd*Pk2*f*g2*r*s - 336*D1*Ddd*Pk2*f*g2*r - 336*D1*Ddd*Pk2*f*g2*s + D1*bd1*(D1*(-56*Pk2*(fd*(3*K*(r*(4*s - 1) - 2*s + 1) - 6*r**2 + r*(9 - 12*s) - 25*s**2 + 31*s - 3) + 10*g2*r*(4*s - 2) - 20*g2*s + 10*gd2*(-4*r*s + r + s)) + f**2*(-2*Pk2*(144*r**2 + 16*r*(28*s - 15) + 420*s**2 - 378*s + 141) + 42*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(16*Pk2*fd*(36*r**2 + r*(224*s - 74) + 210*s**2 - 161*s + 14) - 28*Pk2*(12*r**2 - r*(12*K - 12)*(2*s - 1) + 25*s**2) + 35*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 4*Dd*Pk2*(f**2*(288*r**2 + 64*r*(28*s - 11) + 1680*s**2 - 1400*s + 291) + 14*f*(K*(-48*r*s + 18*r + 6*s - 3) + 24*r**2 + 48*r*s - 24*r + 100*s**2 - 31*s + 3) + 280*g2*(r*(8*s - 3) - 3*s + 1))) + 1344*Dd**2*K*Pk2*f**2*r*s - 336*Dd**2*K*Pk2*f**2*r - 336*Dd**2*K*Pk2*f**2*s + 112*Dd**2*K*Pk2*f**2 + 480*Dd**2*Pk2*f**3*r**2 + 3456*Dd**2*Pk2*f**3*r*s - 1104*Dd**2*Pk2*f**3*r + 3024*Dd**2*Pk2*f**3*s**2 - 2376*Dd**2*Pk2*f**3*s + 288*Dd**2*Pk2*f**3 + 1344*Dd**2*Pk2*f**2*r*s - 336*Dd**2*Pk2*f**2*r + 1848*Dd**2*Pk2*f**2*s**2 - 1260*Dd**2*Pk2*f**2*s + 112*Dd**2*Pk2*f**2 + 4032*Dd**2*Pk2*f*g2*r*s - 1008*Dd**2*Pk2*f*g2*r - 1008*Dd**2*Pk2*f*g2*s + 336*Dd**2*Pk2*f*g2))/(210*d**2*k1*k2) - D1**2*Pk1*ct*k2**3*st**4*(228*D1**2*Pk2*b1*f*fd*r**2 - 156*D1**2*Pk2*b1*f*fdd*r**2 - 156*D1**2*Pk2*b1*fd**2*r**2 + 42*D1**2*Pk2*f**2*fd*r**2 - 28*D1**2*Pk2*f**2*fd*r + 14*D1**2*Pk2*f**2*fd + 78*D1**2*Pk2*f**2*fdd*r**2 - 52*D1**2*Pk2*f**2*fdd*r + 26*D1**2*Pk2*f**2*fdd + 156*D1**2*Pk2*f*fd**2*r**2 - 104*D1**2*Pk2*f*fd**2*r - 42*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 21*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 42*D1**2*Pkdd2*b1*f*fd*k1**2*s + 21*D1**2*Pkdd2*b1*f*fd*k1**2 + 6*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 6*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 42*D1**2*Pkdd2*bd1**2*f*k1**2*s*(s - 1) + 9*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 6*D1**2*Pkdd2*f**2*fd*k1**2*s + 3*D1**2*Pkdd2*f**2*fd*k1**2 + 3*D1**2*bdd1*f*(7*Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1) + f*(-26*Pk2*(r - 1)**2 + Pkdd2*k1**2*(s - 1)**2)) + 456*D1*Dd*Pk2*b1*f**2*r**2 - 228*D1*Dd*Pk2*b1*f**2*r + 114*D1*Dd*Pk2*b1*f**2 - 1248*D1*Dd*Pk2*b1*f*fd*r**2 + 312*D1*Dd*Pk2*b1*f*fd*r + 56*D1*Dd*Pk2*f**3*r**2 - 28*D1*Dd*Pk2*f**3*r + 14*D1*Dd*Pk2*f**3 + 624*D1*Dd*Pk2*f**2*fd*r**2 - 364*D1*Dd*Pk2*f**2*fd*r + 52*D1*Dd*Pk2*f**2*fd - 168*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 84*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 42*D1*Dd*Pkdd2*b1**2*f*k1**2 + 168*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 42*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 60*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 30*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 15*D1*Dd*Pkdd2*b1*f**2*k1**2 + 48*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 12*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 12*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 6*D1*Dd*Pkdd2*f**3*k1**2*s + 3*D1*Dd*Pkdd2*f**3*k1**2 - 312*D1*Ddd*Pk2*b1*f**2*r**2 + 156*D1*Ddd*Pk2*b1*f**2*r - 78*D1*Ddd*Pk2*b1*f**2 + 104*D1*Ddd*Pk2*f**3*r**2 - 52*D1*Ddd*Pk2*f**3*r + 26*D1*Ddd*Pk2*f**3 + 84*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 42*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 21*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 12*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 6*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 3*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 3*D1*bd1*(D1*(14*Pkdd2*b1*fd*k1**2*s*(2*s - 1) + f**2*(38*Pk2*(r - 1)**2 + Pkdd2*k1**2*(5*s**2 + 4*s - 2)) - 2*f*(52*Pk2*fd*r*(r - 1) + 7*Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1) - 2*Pkdd2*fd*k1**2*s*(s - 1))) + 2*Dd*f*(-26*Pk2*f*(4*r**2 - 5*r + 1) + 7*Pkdd2*b1*k1**2*(8*s**2 - 6*s + 1) + Pkdd2*f*k1**2*(4*s**2 - 5*s + 1))) - 936*Dd**2*Pk2*b1*f**2*r**2 + 468*Dd**2*Pk2*b1*f**2*r + 312*Dd**2*Pk2*f**3*r**2 - 156*Dd**2*Pk2*f**3*r + 252*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 126*Dd**2*Pkdd2*b1**2*f*k1**2*s + 36*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 18*Dd**2*Pkdd2*b1*f**2*k1**2*s)/(210*d**2*k1**3*k3**2) - D1**2*Pk1*ct*k2**3*st**2*(D1*f*(-28*D1*Pk2*bd1**2*r*(r - 1) + 2*D1*Pk2*bdd1*f*r**2 + bd1*(4*D1*Pk2*fd*r*(2*r - 1) + D1*f*(6*Pk2*r**2 + Pkdd2*k1**2*(s - 1)**2) + 4*Dd*Pk2*f*r*(4*r - 1))) + b1**2*(D1**2*(18*Pk2*fd*r**2 - 14*Pk2*fdd*r**2 + 5*Pkdd2*fd*k1**2*s**2) + D1*Dd*(18*Pk2*f*(4*r**2 - 2*r + 1) + 28*Pk2*fd*r*(1 - 4*r) + 5*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 14*D1*Ddd*Pk2*f*(4*r**2 - 2*r + 1) + 84*Dd**2*Pk2*f*r*(1 - 2*r)) + b1*(-14*D1**2*Pk2*bdd1*f*(2*r**2 - 2*r + 1) + 12*D1**2*Pk2*f*fd*r**2 - 12*D1**2*Pk2*f*fd*r + 6*D1**2*Pk2*f*fd + 4*D1**2*Pk2*f*fdd*r**2 - 4*D1**2*Pk2*f*fdd*r + 2*D1**2*Pk2*f*fdd + 4*D1**2*Pk2*fd**2*r**2 - 4*D1**2*Pk2*fd**2*r + 2*D1**2*Pkdd2*f*fd*k1**2*s**2 + 24*D1*Dd*Pk2*f**2*r**2 - 12*D1*Dd*Pk2*f**2*r + 6*D1*Dd*Pk2*f**2 + 32*D1*Dd*Pk2*f*fd*r**2 - 24*D1*Dd*Pk2*f*fd*r + 4*D1*Dd*Pk2*f*fd + 4*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 2*D1*Dd*Pkdd2*f**2*k1**2*s + D1*Dd*Pkdd2*f**2*k1**2 + 8*D1*Ddd*Pk2*f**2*r**2 - 4*D1*Ddd*Pk2*f**2*r + 2*D1*Ddd*Pk2*f**2 + D1*bd1*(D1*(18*Pk2*f*(2*r**2 - 2*r + 1) + 28*Pk2*fd*r*(1 - 2*r) + 5*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) - 28*Dd*Pk2*f*(8*r**2 - 6*r + 1)) + 24*Dd**2*Pk2*f**2*r**2 - 12*Dd**2*Pk2*f**2*r))/(30*d**2*k1**3*k3**2) - D1**2*Pk1*ct*k2*st**4*(2310*D1**2*Pk2*b1*f**2*fd*r**2 - 1650*D1**2*Pk2*b1*f**2*fdd*r**2 - 3300*D1**2*Pk2*b1*f*fd**2*r**2 + 920*D1**2*Pk2*f**3*fd*r**2 - 460*D1**2*Pk2*f**3*fd*r + 230*D1**2*Pk2*f**3*fd + 200*D1**2*Pk2*f**3*fdd*r**2 - 100*D1**2*Pk2*f**3*fdd*r + 50*D1**2*Pk2*f**3*fdd + 600*D1**2*Pk2*f**2*fd**2*r**2 - 300*D1**2*Pk2*f**2*fd**2*r - 1320*D1**2*Pkdd2*b1**2*f*fd*k1**2*s**2 + 660*D1**2*Pkdd2*b1**2*f*fd*k1**2*s - 330*D1**2*Pkdd2*b1**2*f*fd*k1**2 + 660*D1**2*Pkdd2*b1**2*f*fdd*k1**2*s**2 - 330*D1**2*Pkdd2*b1**2*f*fdd*k1**2*s + 165*D1**2*Pkdd2*b1**2*f*fdd*k1**2 + 660*D1**2*Pkdd2*b1**2*fd**2*k1**2*s**2 - 330*D1**2*Pkdd2*b1**2*fd**2*k1**2*s - 462*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 924*D1**2*Pkdd2*b1**2*fd*k1**2*s - 462*D1**2*Pkdd2*b1**2*fd*k1**2 + 231*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 462*D1**2*Pkdd2*b1**2*fdd*k1**2*s + 231*D1**2*Pkdd2*b1**2*fdd*k1**2 - 165*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 - 110*D1**2*Pkdd2*b1*f**2*fd*k1**2*s + 55*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 330*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 110*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 55*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 660*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 220*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 132*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 132*D1**2*Pkdd2*b1*f*fd*k1**2*s - 66*D1**2*Pkdd2*b1*f*fd*k1**2 + 66*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 66*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 33*D1**2*Pkdd2*b1*f*fdd*k1**2 + 66*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 66*D1**2*Pkdd2*b1*fd**2*k1**2*s + 66*D1**2*Pkdd2*bd1**2*f*k1**2*s*(5*f*(2*s - 1) + 7*s) + 220*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 110*D1**2*Pkdd2*f**3*fd*k1**2*s + 55*D1**2*Pkdd2*f**3*fd*k1**2 - 11*D1**2*bdd1*f*(-42*Pkdd2*b1*k1**2*s**2 - 3*Pkdd2*f*k1**2*(5*b1*(4*s**2 - 2*s + 1) + s**2) + 5*f**2*(10*Pk2*(r - 1)**2 + Pkdd2*k1**2*(-2*s**2 + 2*s - 1))) + 3080*D1*Dd*Pk2*b1*f**3*r**2 - 1540*D1*Dd*Pk2*b1*f**3*r + 770*D1*Dd*Pk2*b1*f**3 - 13200*D1*Dd*Pk2*b1*f**2*fd*r**2 + 3300*D1*Dd*Pk2*b1*f**2*fd*r + 920*D1*Dd*Pk2*f**4*r**2 - 460*D1*Dd*Pk2*f**4*r + 230*D1*Dd*Pk2*f**4 + 1600*D1*Dd*Pk2*f**3*fd*r**2 - 800*D1*Dd*Pk2*f**3*fd*r + 100*D1*Dd*Pk2*f**3*fd - 2640*D1*Dd*Pkdd2*b1**2*f**2*k1**2*s**2 + 1320*D1*Dd*Pkdd2*b1**2*f**2*k1**2*s - 660*D1*Dd*Pkdd2*b1**2*f**2*k1**2 + 5280*D1*Dd*Pkdd2*b1**2*f*fd*k1**2*s**2 - 2640*D1*Dd*Pkdd2*b1**2*f*fd*k1**2*s + 330*D1*Dd*Pkdd2*b1**2*f*fd*k1**2 - 1848*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 924*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 462*D1*Dd*Pkdd2*b1**2*f*k1**2 + 1848*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 2310*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 462*D1*Dd*Pkdd2*b1**2*fd*k1**2 - 220*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 110*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 55*D1*Dd*Pkdd2*b1*f**3*k1**2 + 2640*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 1100*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 110*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 264*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 132*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 66*D1*Dd*Pkdd2*b1*f**2*k1**2 + 528*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 396*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 66*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 220*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 110*D1*Dd*Pkdd2*f**4*k1**2*s + 55*D1*Dd*Pkdd2*f**4*k1**2 - 2200*D1*Ddd*Pk2*b1*f**3*r**2 + 1100*D1*Ddd*Pk2*b1*f**3*r - 550*D1*Ddd*Pk2*b1*f**3 + 200*D1*Ddd*Pk2*f**4*r**2 - 100*D1*Ddd*Pk2*f**4*r + 50*D1*Ddd*Pk2*f**4 + 1320*D1*Ddd*Pkdd2*b1**2*f**2*k1**2*s**2 - 660*D1*Ddd*Pkdd2*b1**2*f**2*k1**2*s + 330*D1*Ddd*Pkdd2*b1**2*f**2*k1**2 + 924*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 462*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 231*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 440*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 220*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 110*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 132*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 66*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 33*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 11*D1*bd1*(D1*(84*Pkdd2*b1*fd*k1**2*s*(s - 1) + 6*Pkdd2*f*k1**2*s*(-14*b1*s + fd*(20*b1 + 1)*(2*s - 1)) + 5*f**3*(14*Pk2*(r - 1)**2 - Pkdd2*k1**2*(s**2 - 4*s + 2)) - 2*f**2*(15*Pkdd2*b1*k1**2*(4*s**2 - 2*s + 1) + 3*Pkdd2*k1**2*s**2 + 10*fd*(15*Pk2*r*(r - 1) + Pkdd2*k1**2*s*(2 - 3*s)))) + 2*Dd*f*(42*Pkdd2*b1*k1**2*s*(4*s - 1) + 3*Pkdd2*f*k1**2*(4*s - 1)*(5*b1*(4*s - 1) + s) - 5*f**2*(10*Pk2*(4*r**2 - 5*r + 1) + Pkdd2*k1**2*(-8*s**2 + 6*s - 1)))) - 6600*Dd**2*Pk2*b1*f**3*r**2 + 3300*Dd**2*Pk2*b1*f**3*r + 600*Dd**2*Pk2*f**4*r**2 - 300*Dd**2*Pk2*f**4*r + 3960*Dd**2*Pkdd2*b1**2*f**2*k1**2*s**2 - 1980*Dd**2*Pkdd2*b1**2*f**2*k1**2*s + 2772*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 1386*Dd**2*Pkdd2*b1**2*f*k1**2*s + 1320*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 660*Dd**2*Pkdd2*b1*f**3*k1**2*s + 396*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 198*Dd**2*Pkdd2*b1*f**2*k1**2*s)/(2310*d**2*k1**3) + D1**2*Pk1*ct*k2*st**2*(-D1*f*(-4*D1*Pk2*bd1**2*r*(54*f + 49)*(r - 1) + 2*D1*Pk2*bdd1*f*r**2*(7 - 6*f) + 2*D1*Pkdd2*bd1**2*k1**2*s*(9*f + 7)*(s - 1) + D1*bd1*(60*Pk2*f**2*r**2 + 24*Pk2*f*fd*r*(1 - 3*r) + 28*Pk2*fd*r*(2*r - 1) + 9*Pkdd2*f**2*k1**2*(2*s**2 - 2*s + 1) + 7*f*(6*Pk2*r**2 + Pkdd2*k1**2*s**2)) - 4*Dd*Pk2*bd1*f*r*(6*f - 7)*(4*r - 1)) + 7*Pkdd2*b1**3*k1**2*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) - b1**2*(D1**2*(264*Pk2*f*fd*r**2 - 216*Pk2*f*fdd*r**2 - 216*Pk2*fd**2*r**2 + 126*Pk2*fd*r**2 - 98*Pk2*fdd*r**2 - 14*Pkdd2*bd1*k1**2*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) + 7*Pkdd2*bdd1*k1**2*(3*f + 5)*(3*s**2 - 2*s + 1) + 48*Pkdd2*f*fd*k1**2*s**2 - 42*Pkdd2*f*fd*k1**2*s + 21*Pkdd2*f*fd*k1**2 + 18*Pkdd2*f*fdd*k1**2*s**2 + 18*Pkdd2*fd**2*k1**2*s**2 + 21*Pkdd2*fd*k1**2*s**2 - 70*Pkdd2*fd*k1**2*s + 35*Pkdd2*fd*k1**2 + 7*Pkdd2*fdd*k1**2*s**2) + D1*(Dd*(196*Pk2*fd*r*(1 - 4*r) + 70*Pkdd2*bd1*k1**2*(12*s**2 - 7*s + 1) + 14*Pkdd2*fd*k1**2*s*(4*s - 1) + 12*f**2*(11*Pk2*(4*r**2 - 2*r + 1) + 2*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 3*f*(-6*Pk2*(r**2*(96*fd - 28) + r*(14 - 24*fd) - 7) + Pkdd2*k1**2*(14*bd1*(12*s**2 - 7*s + 1) + s**2*(48*fd + 28) - s*(12*fd + 14) + 7))) + Ddd*f*(Pk2*(-108*f - 98)*(4*r**2 - 2*r + 1) + Pkdd2*k1**2*(9*f + 7)*(4*s**2 - 2*s + 1))) + 6*Dd**2*f*(Pk2*r*(-108*f - 98)*(2*r - 1) + Pkdd2*k1**2*s*(9*f + 7)*(2*s - 1))) - b1*(180*D1**2*Pk2*f**2*fd*r**2 - 120*D1**2*Pk2*f**2*fd*r + 60*D1**2*Pk2*f**2*fd - 36*D1**2*Pk2*f**2*fdd*r**2 + 24*D1**2*Pk2*f**2*fdd*r - 12*D1**2*Pk2*f**2*fdd - 72*D1**2*Pk2*f*fd**2*r**2 + 48*D1**2*Pk2*f*fd**2*r + 84*D1**2*Pk2*f*fd*r**2 - 84*D1**2*Pk2*f*fd*r + 42*D1**2*Pk2*f*fd + 28*D1**2*Pk2*f*fdd*r**2 - 28*D1**2*Pk2*f*fdd*r + 14*D1**2*Pk2*f*fdd + 28*D1**2*Pk2*fd**2*r**2 - 28*D1**2*Pk2*fd**2*r + 14*D1**2*Pkdd2*bd1**2*k1**2*s*(3*f + 5)*(3*s - 2) + 54*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 18*D1**2*Pkdd2*f**2*fd*k1**2*s + 9*D1**2*Pkdd2*f**2*fd*k1**2 + 14*D1**2*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*Pkdd2*f*fd*k1**2*s + 7*D1**2*Pkdd2*f*fd*k1**2 + D1**2*bdd1*f*(Pk2*(-108*f - 98)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(9*f + 7)*(2*s**2 - 2*s + 1)) + 240*D1*Dd*Pk2*f**3*r**2 - 120*D1*Dd*Pk2*f**3*r + 60*D1*Dd*Pk2*f**3 - 288*D1*Dd*Pk2*f**2*fd*r**2 + 168*D1*Dd*Pk2*f**2*fd*r - 24*D1*Dd*Pk2*f**2*fd + 168*D1*Dd*Pk2*f**2*r**2 - 84*D1*Dd*Pk2*f**2*r + 42*D1*Dd*Pk2*f**2 + 224*D1*Dd*Pk2*f*fd*r**2 - 168*D1*Dd*Pk2*f*fd*r + 28*D1*Dd*Pk2*f*fd + 72*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 36*D1*Dd*Pkdd2*f**3*k1**2*s + 18*D1*Dd*Pkdd2*f**3*k1**2 + 28*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 14*D1*Dd*Pkdd2*f**2*k1**2*s + 7*D1*Dd*Pkdd2*f**2*k1**2 - 48*D1*Ddd*Pk2*f**3*r**2 + 24*D1*Ddd*Pk2*f**3*r - 12*D1*Ddd*Pk2*f**3 + 56*D1*Ddd*Pk2*f**2*r**2 - 28*D1*Ddd*Pk2*f**2*r + 14*D1*Ddd*Pk2*f**2 + D1*bd1*(D1*(3*f**2*(44*Pk2*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(16*s**2 - 2*s + 1)) + 2*f*(-9*Pk2*(r**2*(48*fd - 14) + r*(14 - 24*fd) - 7) + Pkdd2*k1**2*(s**2*(36*fd + 21) - s*(18*fd - 14) - 7)) + 14*fd*(14*Pk2*r*(1 - 2*r) + Pkdd2*k1**2*s*(2*s - 1))) + 2*Dd*f*(Pk2*(-108*f - 98)*(8*r**2 - 6*r + 1) + Pkdd2*k1**2*(9*f + 7)*(8*s**2 - 6*s + 1))) - 144*Dd**2*Pk2*f**3*r**2 + 72*Dd**2*Pk2*f**3*r + 168*Dd**2*Pk2*f**2*r**2 - 84*Dd**2*Pk2*f**2*r))/(210*d**2*k1**3) + D1**2*Pk1*ct*k2*(4*D1**2*Pk2*bd1**2*f*r**2*(9*f + 7) + D1*b1*(28*D1*Pk2*bd1**2*r*(3*f + 5)*(3*r - 2) + 4*D1*Pk2*bdd1*f*r**2*(9*f + 7) + D1*bd1*(56*Pk2*fd*r*(r - 1) - 3*f**2*(-4*Pk2*r**2 + 7*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(12*Pk2*r*(12*fd*r - 6*fd + 7*r) - 35*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 8*Dd*Pk2*bd1*f*r*(9*f + 7)*(4*r - 1)) - 7*b1**3*(D1**2*(2*Pk2*fd*r**2 - 6*Pk2*fdd*r**2 + 5*Pkdd2*fd*k1**2*s**2) + D1*(2*Dd*Pk2*(f*(4*r**2 - 2*r + 1) - r**2*(24*fd + 20) + r*(6*fd + 10) - 5) + 5*Dd*Pkdd2*k1**2*(f + 3)*(4*s**2 - 2*s + 1) - 2*Ddd*Pk2*(3*f + 5)*(4*r**2 - 2*r + 1)) - 12*Dd**2*Pk2*r*(3*f + 5)*(2*r - 1)) + b1**2*(14*D1**2*Pk2*bdd1*(3*f + 5)*(3*r**2 - 2*r + 1) + 12*D1**2*Pk2*f*fd*r**2 - 12*D1**2*Pk2*f*fd*r + 6*D1**2*Pk2*f*fd + 36*D1**2*Pk2*f*fdd*r**2 - 36*D1**2*Pk2*f*fdd*r + 18*D1**2*Pk2*f*fdd + 36*D1**2*Pk2*fd**2*r**2 - 36*D1**2*Pk2*fd**2*r + 42*D1**2*Pk2*fd*r**2 - 84*D1**2*Pk2*fd*r + 42*D1**2*Pk2*fd + 14*D1**2*Pk2*fdd*r**2 - 28*D1**2*Pk2*fdd*r + 14*D1**2*Pk2*fdd - 42*D1**2*Pkdd2*f*fd*k1**2*s**2 - 35*D1**2*Pkdd2*fd*k1**2*s**2 + 24*D1*Dd*Pk2*f**2*r**2 - 12*D1*Dd*Pk2*f**2*r + 6*D1*Dd*Pk2*f**2 + 288*D1*Dd*Pk2*f*fd*r**2 - 216*D1*Dd*Pk2*f*fd*r + 36*D1*Dd*Pk2*f*fd + 168*D1*Dd*Pk2*f*r**2 - 84*D1*Dd*Pk2*f*r + 42*D1*Dd*Pk2*f + 112*D1*Dd*Pk2*fd*r**2 - 140*D1*Dd*Pk2*fd*r + 28*D1*Dd*Pk2*fd - 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 42*D1*Dd*Pkdd2*f**2*k1**2*s - 21*D1*Dd*Pkdd2*f**2*k1**2 - 140*D1*Dd*Pkdd2*f*k1**2*s**2 + 70*D1*Dd*Pkdd2*f*k1**2*s - 35*D1*Dd*Pkdd2*f*k1**2 + 72*D1*Ddd*Pk2*f**2*r**2 - 36*D1*Ddd*Pk2*f**2*r + 18*D1*Ddd*Pk2*f**2 + 56*D1*Ddd*Pk2*f*r**2 - 28*D1*Ddd*Pk2*f*r + 14*D1*Ddd*Pk2*f - 7*D1*bd1*(2*D1*Pk2*(f*(3*r**2 - 2*r + 1) - r**2*(18*fd + 15) + r*(6*fd + 10) - 5) + 5*D1*Pkdd2*k1**2*(f + 3)*(3*s**2 - 2*s + 1) - 4*Dd*Pk2*(3*f + 5)*(12*r**2 - 7*r + 1)) + 216*Dd**2*Pk2*f**2*r**2 - 108*Dd**2*Pk2*f**2*r + 168*Dd**2*Pk2*f*r**2 - 84*Dd**2*Pk2*f*r))/(210*d**2*k1**3) + D1**2*Pk1*st**4*(42*D1**2*Pk2*bd1**2*f*(r*(2*s - 1) - s + 1) - 3*D1*bd1*(14*D1*Pk2*b1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) + D1*f*(-2*C*Pkdd2*f*k1**2*s**2 + 2*C*Pkdd2*fd*k1**2*s*(2*s - 1) + Pk2*f*(4*C*(r**2 + 2*r*(9*s - 1) + 36*s**2 - 18*s + 1) - 18*r**2 + r*(32 - 57*s) + 18*s**2 + 61*s - 18) - Pk2*fd*(8*C*(r**2 + 32*r*s - 9*r + 64*s**2 - 48*s + 8) - 64*r**2 + r*(101 - 156*s) + 8*s**2 + 76*s - 39)) - 28*Dd*Pk2*b1*f*(r*(8*s - 3) - 3*s + 1) - Dd*f**2*(2*C*Pkdd2*k1**2*s*(1 - 4*s) + Pk2*(4*C*(4*r**2 + 128*r*s - 21*r + 256*s**2 - 144*s + 17) - 128*r**2 - 312*r*s + 191*r + 16*s**2 + 199*s - 71))) + 42*Pk2*b1**2*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) - 3*b1*(C*(D1**2*(f*(8*Pk2*fd*(r**2 + 18*r*s - 9*r + 36*s**2 - 36*s + 18) - 4*Pk2*fdd*(r**2 + 32*r*s - 16*r + 64*s**2 - 64*s + 32) - 2*Pkdd2*fd*k1**2*(2*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(2*s**2 - 2*s + 1)) - 2*fd**2*(2*Pk2*(r**2 + 16*r*(2*s - 1) + s*(64*s - 64)) - Pkdd2*k1**2*s*(s - 1))) + D1*f*(2*Dd*(2*Pk2*f*(4*r**2 + 4*r*(18*s - 5) + 144*s**2 - 90*s + 37) - 4*Pk2*fd*(4*r**2 + r*(128*s - 49) + 256*s**2 - 208*s + 40) + Pkdd2*f*k1**2*(-4*s**2 + 2*s - 1) + Pkdd2*fd*k1**2*(8*s**2 - 6*s + 1)) + Ddd*f*(-2*Pk2*(4*r**2 + 128*r*s - 34*r + 256*s**2 - 160*s + 65) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(2*Pk2*(6*r**2 + 192*r*s - 51*r + 384*s**2 - 240*s + 16) + 3*Pkdd2*k1**2*s*(1 - 2*s))) + Pk2*(D1*Dd*f*(3*f*(-24*r**2 + r*(31 - 76*s) + s*(24*s + 7)) + fd*(256*r**2 + 6*r*(104*s - 51) - 32*s**2 - 46*s + 35)) + D1*(D1*(f*(14*bdd1*(-2*r*s + r + s) + fd*(-36*r**2 + r*(61 - 114*s) + 36*s**2 - 40*s + 18) + fdd*(32*r**2 + 78*r*s - 41*r - 4*s**2 + 6*s - 2)) + fd**2*(32*r**2 + r*(78*s - 41) + s*(6 - 4*s))) + Ddd*f**2*(64*r**2 + r*(156*s - 71) - 8*s**2 - 35*s + 14)) + 3*Dd**2*f**2*(64*r**2 + r*(156*s - 71) - 8*s**2 - 35*s + 13))) + f*(3*D1**2*bdd1*f*(-C*Pkdd2*k1**2*s**2 + Pk2*(2*C*(r**2 + 32*r*s - 2*r + 64*s**2 - 32*s + 1) - 16*r**2 - 39*r*s + 30*r + 2*s**2 + 41*s - 16)) + D1**2*(f*(2*C*Pkdd2*fd*k1**2*(3*s**2 - 2*s + 1) + C*Pkdd2*fdd*k1**2*(-3*s**2 + 2*s - 1) - Pk2*fd*(4*C*(3*r**2 + 42*r*s - 16*r + 48*s**2 - 46*s + 17) - 42*r**2 - 123*r*s + 69*r + 30*s**2 + 21*s - 4) + Pk2*fdd*(2*C*(3*r**2 + 96*r*s - 34*r + 84*s**2 - 88*s + 29) - 48*r**2 - 75*r*s + 57*r + 6*s**2 + 21*s - 14)) + fd**2*(2*C*Pkdd2*k1**2*s*(2 - 3*s) + Pk2*(4*C*(3*r**2 + 96*r*s - 34*r + 84*s**2 - 88*s + 16) - 96*r**2 - 150*r*s + 114*r + 12*s**2 + 42*s - 25))) + D1*f*(Dd*(2*C*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) - 2*C*Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1) - Pk2*f*(4*C*(4*r**2 + 8*r*(7*s - 2) + 64*s**2 - 46*s + 17) - 56*r**2 - 164*r*s + 69*r + 40*s**2 + 21*s - 4) + Pk2*fd*(4*C*(12*r**2 + 384*r*s - 119*r + 336*s**2 - 308*s + 61) - 384*r**2 - 600*r*s + 399*r + 48*s**2 + 147*s - 78)) + Ddd*f*(C*Pkdd2*k1**2*(-4*s**2 + 2*s - 1) + Pk2*(2*C*(4*r**2 + 128*r*s - 34*r + 112*s**2 - 88*s + 29) - 64*r**2 - 100*r*s + 57*r + 8*s**2 + 21*s - 14))) + Dd**2*f**2*(6*C*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*(4*C*(6*r**2 + 192*r*s - 51*r + 168*s**2 - 132*s + 16) - 192*r**2 - 300*r*s + 171*r + 24*s**2 + 63*s - 25))))/(105*d**2*k3**2) - D1**2*Pk1*st**2*(21*b1**2*(D1**2*(-2*C*Pkdd2*fd*k1**2*s**2 + C*Pkdd2*fdd*k1**2*s**2 + Pk2*fd*(r**2*(4*C - 14) + r*s*(16*C - 31) - s**2*(6*C - 6)) + Pk2*fdd*(r**2*(12 - 2*C) + r*s*(23 - 8*C) - s**2*(2*C - 2))) + D1*(Dd*(-2*C*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + 2*C*Pkdd2*fd*k1**2*s*(4*s - 1) + Pk2*f*(2*C*(8*r**2 + 4*r*(8*s - 3) - 12*s**2 - 2*s - 1) - 56*r**2 - 124*r*s + 59*r + 24*s**2 + 19*s - 8) + Pk2*fd*(r**2*(96 - 16*C) + r*(-64*C*s + 12*C + 184*s - 47) + s*(-16*C*s + 12*C + 16*s - 27))) + Ddd*f*(C*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + Pk2*(-4*C*(2*r**2 + 8*r*s - 3*r + 2*s**2 - 3*s + 1) + 48*r**2 + 92*r*s - 47*r + 8*s**2 - 27*s + 14))) + Dd**2*f*(6*C*Pkdd2*k1**2*s*(2*s - 1) + Pk2*(-4*C*(6*r**2 + 3*r*(8*s - 3) + 6*s**2 - 9*s + 2) + 144*r**2 + 3*r*(92*s - 47) + 24*s**2 - 81*s + 23))) + 3*b1*(-144*C*D1**2*Pk2*f*fd*r**2 - 744*C*D1**2*Pk2*f*fd*r*s + 396*C*D1**2*Pk2*f*fd*r - 844*C*D1**2*Pk2*f*fd*s**2 + 792*C*D1**2*Pk2*f*fd*s - 408*C*D1**2*Pk2*f*fd + 128*C*D1**2*Pk2*f*fdd*r**2 + 792*C*D1**2*Pk2*f*fdd*r*s - 408*C*D1**2*Pk2*f*fdd*r + 828*C*D1**2*Pk2*f*fdd*s**2 - 816*C*D1**2*Pk2*f*fdd*s + 414*C*D1**2*Pk2*f*fdd + 128*C*D1**2*Pk2*fd**2*r**2 + 792*C*D1**2*Pk2*fd**2*r*s - 408*C*D1**2*Pk2*fd**2*r + 828*C*D1**2*Pk2*fd**2*s**2 - 816*C*D1**2*Pk2*fd**2*s + 2*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 14*C*D1**2*Pkdd2*f*fd*k1**2*s + 7*C*D1**2*Pkdd2*f*fd*k1**2 + 6*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 6*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 288*C*D1*Dd*Pk2*f**2*r**2 - 1488*C*D1*Dd*Pk2*f**2*r*s + 516*C*D1*Dd*Pk2*f**2*r - 1688*C*D1*Dd*Pk2*f**2*s**2 + 1216*C*D1*Dd*Pk2*f**2*s - 494*C*D1*Dd*Pk2*f**2 + 1024*C*D1*Dd*Pk2*f*fd*r**2 + 6336*C*D1*Dd*Pk2*f*fd*r*s - 2680*C*D1*Dd*Pk2*f*fd*r + 6624*C*D1*Dd*Pk2*f*fd*s**2 - 5712*C*D1*Dd*Pk2*f*fd*s + 1224*C*D1*Dd*Pk2*f*fd + 4*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 2*C*D1*Dd*Pkdd2*f**2*k1**2*s + C*D1*Dd*Pkdd2*f**2*k1**2 + 48*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 12*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 256*C*D1*Ddd*Pk2*f**2*r**2 + 1584*C*D1*Ddd*Pk2*f**2*r*s - 524*C*D1*Ddd*Pk2*f**2*r + 1656*C*D1*Ddd*Pk2*f**2*s**2 - 1224*C*D1*Ddd*Pk2*f**2*s + 478*C*D1*Ddd*Pk2*f**2 + 12*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 6*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 3*C*D1*Ddd*Pkdd2*f**2*k1**2 + 768*C*Dd**2*Pk2*f**2*r**2 + 4752*C*Dd**2*Pk2*f**2*r*s - 1572*C*Dd**2*Pk2*f**2*r + 4968*C*Dd**2*Pk2*f**2*s**2 - 3672*C*Dd**2*Pk2*f**2*s + 396*C*Dd**2*Pk2*f**2 + 36*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 18*C*Dd**2*Pkdd2*f**2*k1**2*s - 32*D1**2*Pk2*f*fd*r**2 - 244*D1**2*Pk2*f*fd*r*s + 97*D1**2*Pk2*f*fd*r - 80*D1**2*Pk2*f*fd*s**2 + 169*D1**2*Pk2*f*fd*s - 72*D1**2*Pk2*f*fd + 72*D1**2*Pk2*f*fdd*r**2 + 164*D1**2*Pk2*f*fdd*r*s - 101*D1**2*Pk2*f*fdd*r + 96*D1**2*Pk2*f*fdd*s**2 - 137*D1**2*Pk2*f*fdd*s + 78*D1**2*Pk2*f*fdd + 72*D1**2*Pk2*fd**2*r**2 + 164*D1**2*Pk2*fd**2*r*s - 101*D1**2*Pk2*fd**2*r + 96*D1**2*Pk2*fd**2*s**2 - 137*D1**2*Pk2*fd**2*s - 7*D1**2*bdd1*f*(C*Pkdd2*k1**2*(-2*s**2 + 2*s - 1) + Pk2*(4*C*(r**2 + 4*r*s - 3*r + s**2 - 3*s + 1) - 24*r**2 - 46*r*s + 47*r - 4*s**2 + 27*s - 14)) - 64*D1*Dd*Pk2*f**2*r**2 - 488*D1*Dd*Pk2*f**2*r*s + 154*D1*Dd*Pk2*f**2*r - 160*D1*Dd*Pk2*f**2*s**2 + 202*D1*Dd*Pk2*f**2*s - 56*D1*Dd*Pk2*f**2 + 576*D1*Dd*Pk2*f*fd*r**2 + 1312*D1*Dd*Pk2*f*fd*r*s - 712*D1*Dd*Pk2*f*fd*r + 768*D1*Dd*Pk2*f*fd*s**2 - 904*D1*Dd*Pk2*f*fd*s + 238*D1*Dd*Pk2*f*fd + 144*D1*Ddd*Pk2*f**2*r**2 + 328*D1*Ddd*Pk2*f**2*r*s - 154*D1*Ddd*Pk2*f**2*r + 192*D1*Ddd*Pk2*f**2*s**2 - 178*D1*Ddd*Pk2*f**2*s + 84*D1*Ddd*Pk2*f**2 + 7*D1*bd1*(D1*(-2*C*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + 2*C*Pkdd2*fd*k1**2*s*(2*s - 1) + Pk2*f*(2*C*(4*r**2 + 4*r*(4*s - 3) - 6*s**2 - 2*s - 1) - 28*r**2 - 62*r*s + 59*r + 12*s**2 + 19*s - 8) + Pk2*fd*(r**2*(48 - 8*C) + r*(-32*C*s + 12*C + 92*s - 47) + s*(-8*C*s + 12*C + 8*s - 27))) + 2*Dd*f*(C*Pkdd2*k1**2*(8*s**2 - 6*s + 1) + Pk2*(-4*C*(4*r**2 + 16*r*s - 9*r + 4*s**2 - 9*s + 3) + 96*r**2 + 184*r*s - 141*r + 16*s**2 - 81*s + 37))) + 432*Dd**2*Pk2*f**2*r**2 + 984*Dd**2*Pk2*f**2*r*s - 462*Dd**2*Pk2*f**2*r + 576*Dd**2*Pk2*f**2*s**2 - 534*Dd**2*Pk2*f**2*s + 82*Dd**2*Pk2*f**2) + f*(-456*C*D1**2*Pk2*f*fd*r**2 - 1620*C*D1**2*Pk2*f*fd*r*s + 844*C*D1**2*Pk2*f*fd*r - 756*C*D1**2*Pk2*f*fd*s**2 + 1044*C*D1**2*Pk2*f*fd*s - 404*C*D1**2*Pk2*f*fd + 390*C*D1**2*Pk2*f*fdd*r**2 + 1620*C*D1**2*Pk2*f*fdd*r*s - 800*C*D1**2*Pk2*f*fdd*r + 756*C*D1**2*Pk2*f*fdd*s**2 - 1044*C*D1**2*Pk2*f*fdd*s + 382*C*D1**2*Pk2*f*fdd + 780*C*D1**2*Pk2*fd**2*r**2 + 3240*C*D1**2*Pk2*fd**2*r*s - 1600*C*D1**2*Pk2*fd**2*r + 1512*C*D1**2*Pk2*fd**2*s**2 - 2088*C*D1**2*Pk2*fd**2*s + 540*C*D1**2*Pk2*fd**2 + 27*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 18*C*D1**2*Pkdd2*f*fd*k1**2*s + 9*C*D1**2*Pkdd2*f*fd*k1**2 - 608*C*D1*Dd*Pk2*f**2*r**2 - 2160*C*D1*Dd*Pk2*f**2*r*s + 844*C*D1*Dd*Pk2*f**2*r - 1008*C*D1*Dd*Pk2*f**2*s**2 + 1044*C*D1*Dd*Pk2*f**2*s - 404*C*D1*Dd*Pk2*f**2 + 3120*C*D1*Dd*Pk2*f*fd*r**2 + 12960*C*D1*Dd*Pk2*f*fd*r*s - 5600*C*D1*Dd*Pk2*f*fd*r + 6048*C*D1*Dd*Pk2*f*fd*s**2 - 7308*C*D1*Dd*Pk2*f*fd*s + 1844*C*D1*Dd*Pk2*f*fd + 36*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 18*C*D1*Dd*Pkdd2*f**2*k1**2*s + 9*C*D1*Dd*Pkdd2*f**2*k1**2 + 520*C*D1*Ddd*Pk2*f**2*r**2 + 2160*C*D1*Ddd*Pk2*f**2*r*s - 800*C*D1*Ddd*Pk2*f**2*r + 1008*C*D1*Ddd*Pk2*f**2*s**2 - 1044*C*D1*Ddd*Pk2*f**2*s + 382*C*D1*Ddd*Pk2*f**2 + 1560*C*Dd**2*Pk2*f**2*r**2 + 6480*C*Dd**2*Pk2*f**2*r*s - 2400*C*Dd**2*Pk2*f**2*r + 3024*C*Dd**2*Pk2*f**2*s**2 - 3132*C*Dd**2*Pk2*f**2*s + 540*C*Dd**2*Pk2*f**2 + 54*D1**2*Pk2*f*fd*r**2 - 177*D1**2*Pk2*f*fd*r*s + 23*D1**2*Pk2*f*fd*r - 162*D1**2*Pk2*f*fd*s**2 + 167*D1**2*Pk2*f*fd*s - 36*D1**2*Pk2*f*fd + 129*D1**2*Pk2*f*fdd*r*s - 43*D1**2*Pk2*f*fdd*r + 162*D1**2*Pk2*f*fdd*s**2 - 151*D1**2*Pk2*f*fdd*s + 54*D1**2*Pk2*f*fdd + 258*D1**2*Pk2*fd**2*r*s - 86*D1**2*Pk2*fd**2*r + 324*D1**2*Pk2*fd**2*s**2 - 302*D1**2*Pk2*fd**2*s + 43*D1**2*Pk2*fd**2 - 21*D1**2*bd1**2*(-2*C*Pkdd2*k1**2*s*(s - 1) + Pk2*(4*C*(r**2 + 4*r*s - 3*r + s**2 - 3*s + 2) - 24*r**2 - 46*r*s + 47*r - 4*s**2 + 27*s - 23)) + 3*D1**2*bdd1*f*(3*C*Pkdd2*k1**2*(s - 1)**2 + Pk2*(2*C*(32*r**2 + 198*r*s - 58*r + 207*s**2 - 204*s + 32) + 36*r**2 + 82*r*s - 53*r + 48*s**2 - 41*s + 6)) + 72*D1*Dd*Pk2*f**2*r**2 - 236*D1*Dd*Pk2*f**2*r*s + 23*D1*Dd*Pk2*f**2*r - 216*D1*Dd*Pk2*f**2*s**2 + 167*D1*Dd*Pk2*f**2*s - 36*D1*Dd*Pk2*f**2 + 1032*D1*Dd*Pk2*f*fd*r*s - 301*D1*Dd*Pk2*f*fd*r + 1296*D1*Dd*Pk2*f*fd*s**2 - 1057*D1*Dd*Pk2*f*fd*s + 194*D1*Dd*Pk2*f*fd + 172*D1*Ddd*Pk2*f**2*r*s - 43*D1*Ddd*Pk2*f**2*r + 216*D1*Ddd*Pk2*f**2*s**2 - 151*D1*Ddd*Pk2*f**2*s + 54*D1*Ddd*Pk2*f**2 - 3*D1*bd1*(D1*(-C*Pkdd2*f*k1**2*(s**2 + 12*s - 6) - 12*C*Pkdd2*fd*k1**2*s*(s - 1) + Pk2*f*(2*C*(36*r**2 + 186*r*s - 60*r + 211*s**2 - 212*s + 43) + 16*r**2 + 122*r*s - 57*r + 40*s**2 - 33*s - 16) - Pk2*fd*(4*C*(64*r**2 + 4*r*(99*s - 40) + 414*s**2 - 408*s + 99) + 144*r**2 + 328*r*s - 207*r + 192*s**2 - 219*s + 82)) - 2*Dd*f*(3*C*Pkdd2*k1**2*(4*s**2 - 5*s + 1) + Pk2*(2*C*(128*r**2 + 792*r*s - 247*r + 828*s**2 - 714*s + 131) + 144*r**2 + 328*r*s - 183*r + 192*s**2 - 171*s + 47))) + 516*Dd**2*Pk2*f**2*r*s - 129*Dd**2*Pk2*f**2*r + 648*Dd**2*Pk2*f**2*s**2 - 453*Dd**2*Pk2*f**2*s + 43*Dd**2*Pk2*f**2))/(315*d**2*k3**2) - D1**2*Pk1*(7*D1**2*Pk2*bd1**2*f*(60*C*(r + s - 1)**2 + 9*r*(2*s - 1) + 20*s**2 - 29*s + 9) + D1**2*Pk2*bdd1*f**2*(2*C*(81*r**2 + 126*r*(s - 1) + 35*(s - 1)**2) + (s - 1)*(45*r + 42*s - 42)) + D1*bd1*(-7*b1*(5*C*D1*(-24*Pk2*fd*(r**2 + r*(2*s - 1) + s*(s - 1)) + f*(2*Pk2*(8*r**2 + 2*r*(6*s - 7) + 6*s**2 - 12*s + 7) + Pkdd2*k1**2*(-2*s**2 + 2*s - 1))) - 240*C*Dd*Pk2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*Pk2*(-20*f*r**2 + f*r*(6*s + 17) + f*s*(20*s - 23) + fd*r*(9 - 36*s) + fd*s*(29 - 40*s)) - 2*Dd*Pk2*f*(9*r*(8*s - 3) + 80*s**2 - 87*s + 19)) + f*(D1*(4*C*Pk2*fd*(162*r**2 + 9*r*(28*s - 23) + 70*s**2 - 133*s + 63) + 21*C*Pkdd2*f*k1**2*(s - 1)**2 - Pk2*f*(240*C*r**2 + 252*C*r*(s - 1) + 70*C*(s - 1)**2 - 42*r**2 + 27*r*(s - 1) + 42*(s - 1)**2) + 3*Pk2*fd*(30*r*(2*s - 1) + 56*s**2 - 71*s + 15)) + Dd*Pk2*f*(8*C*(162*r**2 + 252*r*s - 198*r + 70*s**2 - 119*s + 49) + 45*r*(8*s - 5) + 336*s**2 - 465*s + 129))) - 7*b1**2*(5*C*(D1**2*(2*Pk2*fd*(4*r**2 + 6*r*s + 3*s**2) - 6*Pk2*fdd*(r + s)**2 - Pkdd2*fd*k1**2*s**2) + D1*(Dd*(-24*Pk2*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1)) + f*(2*Pk2*(16*r**2 + 24*r*s - 14*r + 12*s**2 - 12*s + 7) + Pkdd2*k1**2*(-4*s**2 + 2*s - 1))) - 12*Ddd*Pk2*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 12*Dd**2*Pk2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) - Pk2*(D1*Dd*(40*f*r**2 - f*r*(12*s + 17) + f*s*(23 - 40*s) + 9*fd*r*(8*s - 1) + fd*s*(80*s - 29)) + D1*(D1*(fd*(10*r**2 - 3*r*s - 10*s**2) + fdd*s*(9*r + 10*s)) + Ddd*f*(9*r*(4*s - 1) + 40*s**2 - 29*s + 10)) + 3*Dd**2*f*(9*r*(4*s - 1) + 40*s**2 - 29*s + 3))) + b1*(C*(-2*D1**2*(-2*Pk2*fd**2*(81*r**2 + 9*r*(14*s - 9) + 7*s*(5*s - 9)) + f*(-Pk2*fdd*(162*r**2 + 18*r*(14*s - 9) + 70*s**2 - 126*s + 81) + fd*(2*Pk2*(120*r**2 + 6*r*(21*s - 20) + 35*s**2 - 63*s + 60) - 21*Pkdd2*k1**2*s**2))) + D1*f*(Dd*(16*Pk2*fd*(162*r**2 + 9*r*(28*s - 17) + 70*s**2 - 112*s + 36) + f*(-2*Pk2*(480*r**2 + 6*r*(84*s - 61) + 140*s**2 - 196*s + 155) + 21*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 8*Ddd*Pk2*f*(81*r**2 + 18*r*(7*s - 4) + 35*s**2 - 49*s + 29)) + 12*Dd**2*Pk2*f**2*(162*r**2 + 36*r*(7*s - 4) + 70*s**2 - 98*s + 21)) + 7*D1**2*Pk2*bdd1*f*(60*C*(r + s - 1)**2 + 9*r*(2*s - 1) + 20*s**2 - 29*s + 10) + 3*Pk2*(D1*Dd*f*(f*(56*r**2 - r*(36*s + 19) + s*(37 - 56*s)) + fd*(30*r*(8*s - 1) + 224*s**2 - 146*s + 15)) + D1*(D1*(f*fd*(28*r**2 - 2*r*(9*s + 14) - 28*s**2 + 9*s + 14) + f*fdd*s*(30*r + 28*s - 15) + fd**2*s*(30*r + 28*s - 15)) + Ddd*f**2*(15*r*(4*s - 1) + 56*s**2 - 43*s + 14)) + 3*Dd**2*f**2*(15*r*(4*s - 1) + 56*s**2 - 43*s + 5))))/(105*d**2*k3**2) + D1**2*Pk1*k2**2*st**6*(-72*C*D1**2*Pk2*b1*f*fd*r**2 + 36*C*D1**2*Pk2*b1*f*fdd*r**2 + 36*C*D1**2*Pk2*b1*fd**2*r**2 - 12*C*D1**2*Pk2*f**2*fd*r**2 + 8*C*D1**2*Pk2*f**2*fd*r - 4*C*D1**2*Pk2*f**2*fd + 6*C*D1**2*Pk2*f**2*fdd*r**2 - 4*C*D1**2*Pk2*f**2*fdd*r + 2*C*D1**2*Pk2*f**2*fdd + 12*C*D1**2*Pk2*f*fd**2*r**2 - 8*C*D1**2*Pk2*f*fd**2*r + 36*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 36*C*D1**2*Pkdd2*b1*f*fd*k1**2*s + 18*C*D1**2*Pkdd2*b1*f*fd*k1**2 - 18*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 18*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 9*C*D1**2*Pkdd2*b1*f*fdd*k1**2 - 18*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 18*C*D1**2*Pkdd2*b1*fd**2*k1**2*s + 6*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 4*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 2*C*D1**2*Pkdd2*f**2*fd*k1**2 - 3*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 2*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - C*D1**2*Pkdd2*f**2*fdd*k1**2 - 6*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 4*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 144*C*D1*Dd*Pk2*b1*f**2*r**2 + 72*C*D1*Dd*Pk2*b1*f**2*r - 36*C*D1*Dd*Pk2*b1*f**2 + 288*C*D1*Dd*Pk2*b1*f*fd*r**2 - 72*C*D1*Dd*Pk2*b1*f*fd*r - 16*C*D1*Dd*Pk2*f**3*r**2 + 8*C*D1*Dd*Pk2*f**3*r - 4*C*D1*Dd*Pk2*f**3 + 48*C*D1*Dd*Pk2*f**2*fd*r**2 - 28*C*D1*Dd*Pk2*f**2*fd*r + 4*C*D1*Dd*Pk2*f**2*fd + 72*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 36*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 18*C*D1*Dd*Pkdd2*b1*f**2*k1**2 - 144*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 108*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 18*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 8*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 4*C*D1*Dd*Pkdd2*f**3*k1**2*s + 2*C*D1*Dd*Pkdd2*f**3*k1**2 - 24*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 14*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 2*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 72*C*D1*Ddd*Pk2*b1*f**2*r**2 - 36*C*D1*Ddd*Pk2*b1*f**2*r + 18*C*D1*Ddd*Pk2*b1*f**2 + 8*C*D1*Ddd*Pk2*f**3*r**2 - 4*C*D1*Ddd*Pk2*f**3*r + 2*C*D1*Ddd*Pk2*f**3 - 36*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 18*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 9*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 4*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 2*C*D1*Ddd*Pkdd2*f**3*k1**2*s - C*D1*Ddd*Pkdd2*f**3*k1**2 + 216*C*Dd**2*Pk2*b1*f**2*r**2 - 108*C*Dd**2*Pk2*b1*f**2*r + 24*C*Dd**2*Pk2*f**3*r**2 - 12*C*Dd**2*Pk2*f**3*r - 108*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 54*C*Dd**2*Pkdd2*b1*f**2*k1**2*s - 12*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 6*C*Dd**2*Pkdd2*f**3*k1**2*s + 72*D1**2*Pk2*b1*f*fd*r**2 - 72*D1**2*Pk2*b1*f*fd*r*s + 36*D1**2*Pk2*b1*f*fd*r - 36*D1**2*Pk2*b1*f*fdd*r**2 + 36*D1**2*Pk2*b1*f*fdd*r*s - 18*D1**2*Pk2*b1*f*fdd*r - 36*D1**2*Pk2*b1*fd**2*r**2 + 36*D1**2*Pk2*b1*fd**2*r*s - 18*D1**2*Pk2*b1*fd**2*r + 12*D1**2*Pk2*f**2*fd*r**2 - 12*D1**2*Pk2*f**2*fd*r*s - 4*D1**2*Pk2*f**2*fd*r + 4*D1**2*Pk2*f**2*fd*s + 4*D1**2*Pk2*f**2*fd - 6*D1**2*Pk2*f**2*fdd*r**2 + 6*D1**2*Pk2*f**2*fdd*r*s + 2*D1**2*Pk2*f**2*fdd*r - 2*D1**2*Pk2*f**2*fdd*s - 2*D1**2*Pk2*f**2*fdd - 12*D1**2*Pk2*f*fd**2*r**2 + 12*D1**2*Pk2*f*fd**2*r*s + 4*D1**2*Pk2*f*fd**2*r - 4*D1**2*Pk2*f*fd**2*s + 2*D1**2*Pk2*f*fd**2 + 9*D1**2*bdd1*f**2*(-C*Pkdd2*k1**2*s**2 + 2*Pk2*(r - 1)*(C*(r - 1) - r + s + 1)) + 144*D1*Dd*Pk2*b1*f**2*r**2 - 144*D1*Dd*Pk2*b1*f**2*r*s - 36*D1*Dd*Pk2*b1*f**2*r + 36*D1*Dd*Pk2*b1*f**2*s + 36*D1*Dd*Pk2*b1*f**2 - 288*D1*Dd*Pk2*b1*f*fd*r**2 + 288*D1*Dd*Pk2*b1*f*fd*r*s - 36*D1*Dd*Pk2*b1*f*fd*r - 36*D1*Dd*Pk2*b1*f*fd*s + 18*D1*Dd*Pk2*b1*f*fd + 16*D1*Dd*Pk2*f**3*r**2 - 16*D1*Dd*Pk2*f**3*r*s - 4*D1*Dd*Pk2*f**3*r + 4*D1*Dd*Pk2*f**3*s + 4*D1*Dd*Pk2*f**3 - 48*D1*Dd*Pk2*f**2*fd*r**2 + 48*D1*Dd*Pk2*f**2*fd*r*s + 14*D1*Dd*Pk2*f**2*fd*r - 14*D1*Dd*Pk2*f**2*fd*s - 72*D1*Ddd*Pk2*b1*f**2*r**2 + 72*D1*Ddd*Pk2*b1*f**2*r*s + 18*D1*Ddd*Pk2*b1*f**2*r - 18*D1*Ddd*Pk2*b1*f**2*s - 18*D1*Ddd*Pk2*b1*f**2 - 8*D1*Ddd*Pk2*f**3*r**2 + 8*D1*Ddd*Pk2*f**3*r*s + 2*D1*Ddd*Pk2*f**3*r - 2*D1*Ddd*Pk2*f**3*s - 2*D1*Ddd*Pk2*f**3 - 18*D1*bd1*f*(C*Dd*Pkdd2*f*k1**2*s*(4*s - 1) + D1*f*(-C*Pkdd2*k1**2*s**2 + 2*Pk2*(r - 1)*(C*(r - 1) - r + s + 1)) - D1*fd*(C*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*(r**2*(4*C - 4) + r*(-4*C + 4*s + 3) - 2*s + 1)) + Dd*Pk2*f*(-2*C*(4*r**2 - 5*r + 1) + 8*r**2 - 8*r*s - 9*r + 5*s + 1)) - 216*Dd**2*Pk2*b1*f**2*r**2 + 216*Dd**2*Pk2*b1*f**2*r*s + 54*Dd**2*Pk2*b1*f**2*r - 54*Dd**2*Pk2*b1*f**2*s + 18*Dd**2*Pk2*b1*f**2 - 24*Dd**2*Pk2*f**3*r**2 + 24*Dd**2*Pk2*f**3*r*s + 6*Dd**2*Pk2*f**3*r - 6*Dd**2*Pk2*f**3*s + 2*Dd**2*Pk2*f**3)/(63*d**2*k1**2*k3**2) - D1**2*Pk1*k2**2*st**4*(21*b1**2*(D1**2*(2*fd - fdd)*(-C*Pkdd2*k1**2*s**2 + Pk2*r**2*(2*C - 2)) + D1*(2*Dd*(C*Pkdd2*f*k1**2*(-4*s**2 + 2*s - 1) + C*Pkdd2*fd*k1**2*s*(4*s - 1) + Pk2*f*(2*C - 2)*(4*r**2 - 2*r + 1) + Pk2*fd*r*(2 - 2*C)*(4*r - 1)) + Ddd*f*(C*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + Pk2*(2 - 2*C)*(4*r**2 - 2*r + 1))) - 6*Dd**2*f*(C*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*r*(2*C - 2)*(2*r - 1))) + 3*b1*(-20*C*D1**2*Pk2*f*fd*r**2 - 8*C*D1**2*Pk2*f*fd*r + 4*C*D1**2*Pk2*f*fd - 4*C*D1**2*Pk2*f*fdd*r**2 + 4*C*D1**2*Pk2*f*fdd*r - 2*C*D1**2*Pk2*f*fdd - 4*C*D1**2*Pk2*fd**2*r**2 + 4*C*D1**2*Pk2*fd**2*r + 10*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 14*C*D1**2*Pkdd2*f*fd*k1**2*s + 7*C*D1**2*Pkdd2*f*fd*k1**2 + 2*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 2*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 40*C*D1*Dd*Pk2*f**2*r**2 + 20*C*D1*Dd*Pk2*f**2*r - 10*C*D1*Dd*Pk2*f**2 - 32*C*D1*Dd*Pk2*f*fd*r**2 + 24*C*D1*Dd*Pk2*f*fd*r - 4*C*D1*Dd*Pk2*f*fd + 20*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 10*C*D1*Dd*Pkdd2*f**2*k1**2*s + 5*C*D1*Dd*Pkdd2*f**2*k1**2 + 16*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 4*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 8*C*D1*Ddd*Pk2*f**2*r**2 + 4*C*D1*Ddd*Pk2*f**2*r - 2*C*D1*Ddd*Pk2*f**2 + 4*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 2*C*D1*Ddd*Pkdd2*f**2*k1**2*s + C*D1*Ddd*Pkdd2*f**2*k1**2 - 24*C*Dd**2*Pk2*f**2*r**2 + 12*C*Dd**2*Pk2*f**2*r + 12*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 6*C*Dd**2*Pkdd2*f**2*k1**2*s + 8*D1**2*Pk2*f*fd*r**2 - 90*D1**2*Pk2*f*fd*r*s + 53*D1**2*Pk2*f*fd*r - 4*D1**2*Pk2*f*fd + 24*D1**2*Pk2*f*fdd*r**2 + 66*D1**2*Pk2*f*fdd*r*s - 37*D1**2*Pk2*f*fdd*r + 2*D1**2*Pk2*f*fdd + 24*D1**2*Pk2*fd**2*r**2 + 66*D1**2*Pk2*fd**2*r*s - 37*D1**2*Pk2*fd**2*r - 7*D1**2*bdd1*f*(C*Pkdd2*k1**2*(-2*s**2 + 2*s - 1) + Pk2*(2*C - 2)*(2*r**2 - 2*r + 1)) + 16*D1*Dd*Pk2*f**2*r**2 - 180*D1*Dd*Pk2*f**2*r*s + 37*D1*Dd*Pk2*f**2*r + 45*D1*Dd*Pk2*f**2*s + 4*D1*Dd*Pk2*f**2 + 192*D1*Dd*Pk2*f*fd*r**2 + 528*D1*Dd*Pk2*f*fd*r*s - 262*D1*Dd*Pk2*f*fd*r - 66*D1*Dd*Pk2*f*fd*s + 37*D1*Dd*Pk2*f*fd + 48*D1*Ddd*Pk2*f**2*r**2 + 132*D1*Ddd*Pk2*f**2*r*s - 57*D1*Ddd*Pk2*f**2*r - 33*D1*Ddd*Pk2*f**2*s + 12*D1*Ddd*Pk2*f**2 + 14*D1*bd1*(D1*(C*Pkdd2*f*k1**2*(-2*s**2 + 2*s - 1) + C*Pkdd2*fd*k1**2*s*(2*s - 1) + Pk2*f*(2*C - 2)*(2*r**2 - 2*r + 1) + Pk2*fd*r*(2 - 2*C)*(2*r - 1)) + Dd*f*(C*Pkdd2*k1**2*(8*s**2 - 6*s + 1) + Pk2*(2 - 2*C)*(8*r**2 - 6*r + 1))) + 144*Dd**2*Pk2*f**2*r**2 + 396*Dd**2*Pk2*f**2*r*s - 171*Dd**2*Pk2*f**2*r - 99*Dd**2*Pk2*f**2*s + 33*Dd**2*Pk2*f**2) + f*(-66*C*D1**2*Pk2*f*fd*r**2 + 44*C*D1**2*Pk2*f*fd*r - 22*C*D1**2*Pk2*f*fd + 60*C*D1**2*Pk2*f*fdd*r**2 - 40*C*D1**2*Pk2*f*fdd*r + 20*C*D1**2*Pk2*f*fdd + 120*C*D1**2*Pk2*fd**2*r**2 - 80*C*D1**2*Pk2*fd**2*r + 9*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 6*C*D1**2*Pkdd2*f*fd*k1**2*s + 3*C*D1**2*Pkdd2*f*fd*k1**2 - 88*C*D1*Dd*Pk2*f**2*r**2 + 44*C*D1*Dd*Pk2*f**2*r - 22*C*D1*Dd*Pk2*f**2 + 480*C*D1*Dd*Pk2*f*fd*r**2 - 280*C*D1*Dd*Pk2*f*fd*r + 40*C*D1*Dd*Pk2*f*fd + 12*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 6*C*D1*Dd*Pkdd2*f**2*k1**2*s + 3*C*D1*Dd*Pkdd2*f**2*k1**2 + 80*C*D1*Ddd*Pk2*f**2*r**2 - 40*C*D1*Ddd*Pk2*f**2*r + 20*C*D1*Ddd*Pk2*f**2 + 240*C*Dd**2*Pk2*f**2*r**2 - 120*C*Dd**2*Pk2*f**2*r + 12*D1**2*Pk2*f*fd*r**2 - 75*D1**2*Pk2*f*fd*r*s + 17*D1**2*Pk2*f*fd*r + 25*D1**2*Pk2*f*fd*s + 4*D1**2*Pk2*f*fd + 30*D1**2*Pk2*f*fdd*r**2 + 51*D1**2*Pk2*f*fdd*r*s - 37*D1**2*Pk2*f*fdd*r - 17*D1**2*Pk2*f*fdd*s + 10*D1**2*Pk2*f*fdd + 60*D1**2*Pk2*fd**2*r**2 + 102*D1**2*Pk2*fd**2*r*s - 74*D1**2*Pk2*fd**2*r - 34*D1**2*Pk2*fd**2*s + 17*D1**2*Pk2*fd**2 - 42*D1**2*bd1**2*(-C*Pkdd2*k1**2*s*(s - 1) + Pk2*r*(2*C - 2)*(r - 1)) + 3*D1**2*bdd1*f*(C*Pkdd2*k1**2*(s - 1)**2 + Pk2*(-r**2*(2*C - 12) + r*(33*s - 20) - 33*s + 10)) + 16*D1*Dd*Pk2*f**2*r**2 - 100*D1*Dd*Pk2*f**2*r*s + 17*D1*Dd*Pk2*f**2*r + 25*D1*Dd*Pk2*f**2*s + 4*D1*Dd*Pk2*f**2 + 240*D1*Dd*Pk2*f*fd*r**2 + 408*D1*Dd*Pk2*f*fd*r*s - 259*D1*Dd*Pk2*f*fd*r - 119*D1*Dd*Pk2*f*fd*s + 54*D1*Dd*Pk2*f*fd + 40*D1*Ddd*Pk2*f**2*r**2 + 68*D1*Ddd*Pk2*f**2*r*s - 37*D1*Ddd*Pk2*f**2*r - 17*D1*Ddd*Pk2*f**2*s + 10*D1*Ddd*Pk2*f**2 - 3*D1*bd1*(D1*(C*Pkdd2*f*k1**2*(-5*s**2 - 4*s + 2) - 4*C*Pkdd2*fd*k1**2*s*(s - 1) + Pk2*f*(2*C*(5*r**2 - 14*r + 7) - 4*r**2 + 45*r*s + 16*r - 45*s - 8) + Pk2*fd*(r**2*(8*C - 48) + r*(-4*C - 132*s + 77) + 66*s - 33)) + Dd*f*(-2*C*Pkdd2*k1**2*(4*s**2 - 5*s + 1) + Pk2*(r**2*(16*C - 96) + r*(-4*C - 264*s + 137) + 165*s - 53))) + 120*Dd**2*Pk2*f**2*r**2 + 204*Dd**2*Pk2*f**2*r*s - 111*Dd**2*Pk2*f**2*r - 51*Dd**2*Pk2*f**2*s + 17*Dd**2*Pk2*f**2))/(105*d**2*k1**2*k3**2) - D1**2*Pk1*k2**2*st**2*(D1*f*(7*D1*Pk2*bd1**2*(12*r**2 + 26*r*s - 25*r - 13*s + 13) + D1*Pk2*bdd1*f*r*(r*(24*C + 18) + 23*s - 23) + bd1*(D1*(Pk2*fd*(r**2*(96*C + 72) + r*(-48*C + 92*s - 82) - 23*s + 23) + f*(C*(-34*Pk2*r**2 + 7*Pkdd2*k1**2*(s - 1)**2) + 5*Pk2*r*(4*r - 5*s + 5))) + Dd*Pk2*f*(r**2*(192*C + 144) + r*(-48*C + 184*s - 151) - 23*s + 23))) - 7*b1**2*(D1**2*(-5*C*Pkdd2*fd*k1**2*s**2 + Pk2*fd*r*(r*(10*C - 8) + 11*s) - Pk2*fdd*r*(6*r + 13*s)) + D1*(Dd*(Pk2*fd*(-48*r**2 + r*(25 - 104*s) + 13*s) + f*(-5*C*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + Pk2*(10*C*(4*r**2 - 2*r + 1) - 32*r**2 + 44*r*s + 5*r - 11*s - 8))) + Ddd*Pk2*f*(-24*r**2 + r*(25 - 52*s) + 13*s - 6)) + Dd**2*Pk2*f*(-72*r**2 + r*(75 - 156*s) + 39*s - 13)) + b1*(-68*C*D1**2*Pk2*f*fd*r**2 + 68*C*D1**2*Pk2*f*fd*r - 34*C*D1**2*Pk2*f*fd + 48*C*D1**2*Pk2*f*fdd*r**2 - 48*C*D1**2*Pk2*f*fdd*r + 24*C*D1**2*Pk2*f*fdd + 48*C*D1**2*Pk2*fd**2*r**2 - 48*C*D1**2*Pk2*fd**2*r + 14*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 136*C*D1*Dd*Pk2*f**2*r**2 + 68*C*D1*Dd*Pk2*f**2*r - 34*C*D1*Dd*Pk2*f**2 + 384*C*D1*Dd*Pk2*f*fd*r**2 - 288*C*D1*Dd*Pk2*f*fd*r + 48*C*D1*Dd*Pk2*f*fd + 28*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 14*C*D1*Dd*Pkdd2*f**2*k1**2*s + 7*C*D1*Dd*Pkdd2*f**2*k1**2 + 96*C*D1*Ddd*Pk2*f**2*r**2 - 48*C*D1*Ddd*Pk2*f**2*r + 24*C*D1*Ddd*Pk2*f**2 + 288*C*Dd**2*Pk2*f**2*r**2 - 144*C*Dd**2*Pk2*f**2*r + 7*D1**2*Pk2*bdd1*f*(12*r**2 + 26*r*s - 25*r - 13*s + 6) + 40*D1**2*Pk2*f*fd*r**2 - 50*D1**2*Pk2*f*fd*r*s - 40*D1**2*Pk2*f*fd*r + 25*D1**2*Pk2*f*fd*s + 20*D1**2*Pk2*f*fd + 36*D1**2*Pk2*f*fdd*r**2 + 46*D1**2*Pk2*f*fdd*r*s - 36*D1**2*Pk2*f*fdd*r - 23*D1**2*Pk2*f*fdd*s + 18*D1**2*Pk2*f*fdd + 36*D1**2*Pk2*fd**2*r**2 + 46*D1**2*Pk2*fd**2*r*s - 36*D1**2*Pk2*fd**2*r - 23*D1**2*Pk2*fd**2*s + 80*D1*Dd*Pk2*f**2*r**2 - 100*D1*Dd*Pk2*f**2*r*s - 15*D1*Dd*Pk2*f**2*r + 25*D1*Dd*Pk2*f**2*s + 20*D1*Dd*Pk2*f**2 + 288*D1*Dd*Pk2*f*fd*r**2 + 368*D1*Dd*Pk2*f*fd*r*s - 262*D1*Dd*Pk2*f*fd*r - 138*D1*Dd*Pk2*f*fd*s + 59*D1*Dd*Pk2*f*fd + 72*D1*Ddd*Pk2*f**2*r**2 + 92*D1*Ddd*Pk2*f**2*r*s - 59*D1*Ddd*Pk2*f**2*r - 23*D1*Ddd*Pk2*f**2*s + 18*D1*Ddd*Pk2*f**2 - 7*D1*bd1*(D1*(Pk2*fd*(-24*r**2 + r*(25 - 52*s) + 13*s) + f*(-5*C*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + Pk2*(10*C*(2*r**2 - 2*r + 1) - 16*r**2 + 22*r*s + 5*r - 11*s - 8))) - 2*Dd*Pk2*f*(48*r**2 + r*(104*s - 75) - 39*s + 19)) + 216*Dd**2*Pk2*f**2*r**2 + 276*Dd**2*Pk2*f**2*r*s - 177*Dd**2*Pk2*f**2*r - 69*Dd**2*Pk2*f**2*s + 23*Dd**2*Pk2*f**2))/(105*d**2*k1**2*k3**2) - D1**2*Pk1*st**6*(198*D1**2*Pkdd2*bd1**2*f**2*k1**2*s**2 + 22*D1*bd1*f*(D1*(18*Pkdd2*b1*fd*k1**2*s*(2*s - 1) + f**2*s*(20*Pk2*(r - 1) - 3*Pkdd2*k1**2*s) + f*(-28*Pk2*fd*(r*(6*s - 1) - 3*s + 1) - 18*Pkdd2*b1*k1**2*s**2 + 3*Pkdd2*fd*k1**2*s*(3*s - 1))) + Dd*f*(-28*Pk2*f*(r*(8*s - 1) - 5*s + 1) + 18*Pkdd2*b1*k1**2*s*(4*s - 1) + 3*Pkdd2*f*k1**2*s*(4*s - 1))) - 99*Pkdd2*b1**2*k1**2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) - 11*b1*f*(-2*D1*Dd*f*(-20*Pk2*f*(-4*r*s + r + s) - 28*Pk2*fd*(r*(24*s - 7) - 3*s + 1) - 3*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + 3*Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1)) + D1*(D1*(f*(40*Pk2*fd*r*(1 - 3*s) + 56*Pk2*fdd*r*(3*s - 1) - 18*Pkdd2*bdd1*k1**2*s**2 + 6*Pkdd2*fd*k1**2*(3*s**2 - 2*s + 1) - 3*Pkdd2*fdd*k1**2*(3*s**2 - 2*s + 1)) + 2*fd**2*(56*Pk2*r*(3*s - 1) + 3*Pkdd2*k1**2*s*(2 - 3*s))) - Ddd*f**2*(56*Pk2*(-4*r*s + r + s) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 2*Dd**2*f**2*(28*Pk2*(3*r*(4*s - 1) - 3*s + 1) + 9*Pkdd2*k1**2*s*(1 - 2*s))) + f**2*(12*D1*Dd*f*(-f*(6*Pk2*(-4*r*s + r + s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + fd*(4*s - 1)*(-28*Pk2*(4*r - 1) + Pkdd2*k1**2*(4*s - 1))) + D1*(D1*(-12*f*fd*(6*Pk2*(-4*r*s + r + s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(11*bdd1*s*(-56*Pk2*(r - 1) + 3*Pkdd2*k1**2*s) + 6*fdd*(28*Pk2*(-4*r*s + r + s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 12*fd**2*(14*Pk2*(12*r*s - 3*r - 3*s + 1) + 3*Pkdd2*k1**2*s*(1 - 2*s))) + 6*Ddd*f**2*(28*Pk2*(-4*r*s + r + s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 12*Dd**2*f**2*(14*Pk2*(3*r*(4*s - 1) - 3*s + 1) + 3*Pkdd2*k1**2*s*(1 - 2*s))))/(1386*d**2*k1**2) - D1**2*Pk1*st**4*(-66*D1**2*K*Pk2*bdd1*f**2*r**2 + 33*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 660*D1**2*Pk2*bdd1*f**3*r**2 + 1210*D1**2*Pk2*bdd1*f**3*r*s - 660*D1**2*Pk2*bdd1*f**3*r - 1650*D1**2*Pk2*bdd1*f**3*s + 440*D1**2*Pk2*bdd1*f**3 + 66*D1**2*Pk2*bdd1*f**2*r**2 - 132*D1**2*Pk2*bdd1*f**2*r*s + 924*D1**2*Pk2*bdd1*f*g2*r**2 - 1848*D1**2*Pk2*bdd1*f*g2*r + 924*D1**2*Pk2*bdd1*f*g2 - 512*D1**2*Pk2*f**3*fd*r**2 - 2200*D1**2*Pk2*f**3*fd*r*s + 806*D1**2*Pk2*f**3*fd*r + 550*D1**2*Pk2*f**3*fd*s - 128*D1**2*Pk2*f**3*fd + 960*D1**2*Pk2*f**3*fdd*r**2 + 2200*D1**2*Pk2*f**3*fdd*r*s - 1030*D1**2*Pk2*f**3*fdd*r - 550*D1**2*Pk2*f**3*fdd*s + 240*D1**2*Pk2*f**3*fdd + 2880*D1**2*Pk2*f**2*fd**2*r**2 + 6600*D1**2*Pk2*f**2*fd**2*r*s - 3090*D1**2*Pk2*f**2*fd**2*r - 1650*D1**2*Pk2*f**2*fd**2*s + 550*D1**2*Pk2*f**2*fd**2 - 264*D1**2*Pk2*f**2*gd2*r**2 + 132*D1**2*Pk2*f**2*gdd2*r**2 - 528*D1**2*Pk2*f*fd*g2*r**2 + 528*D1**2*Pk2*f*fd*g2*r - 264*D1**2*Pk2*f*fd*g2 + 528*D1**2*Pk2*f*fd*gd2*r**2 - 264*D1**2*Pk2*f*fd*gd2*r + 264*D1**2*Pk2*f*fdd*g2*r**2 - 264*D1**2*Pk2*f*fdd*g2*r + 132*D1**2*Pk2*f*fdd*g2 + 264*D1**2*Pk2*fd**2*g2*r**2 - 264*D1**2*Pk2*fd**2*g2*r + 231*D1**2*Pkdd2*b2*bdd1*f*k1**2*s**2 - 132*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 + 132*D1**2*Pkdd2*b2*f*fd*k1**2*s - 66*D1**2*Pkdd2*b2*f*fd*k1**2 + 66*D1**2*Pkdd2*b2*f*fdd*k1**2*s**2 - 66*D1**2*Pkdd2*b2*f*fdd*k1**2*s + 33*D1**2*Pkdd2*b2*f*fdd*k1**2 + 66*D1**2*Pkdd2*b2*fd**2*k1**2*s**2 - 66*D1**2*Pkdd2*b2*fd**2*k1**2*s - 66*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 + 132*D1**2*Pkdd2*bd2*f*fd*k1**2*s**2 - 66*D1**2*Pkdd2*bd2*f*fd*k1**2*s + 33*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 44*D1**2*Pkdd2*bdd1*f**3*k1**2*s + 22*D1**2*Pkdd2*bdd1*f**3*k1**2 + 33*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 462*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 + 33*D1**2*Pkdd2*bdd2*f**2*k1**2*s**2 + 88*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 44*D1**2*Pkdd2*f**3*fd*k1**2*s + 22*D1**2*Pkdd2*f**3*fd*k1**2 + 132*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 66*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 264*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 264*D1**2*Pkdd2*f*fd*g2*k1**2*s + 132*D1**2*Pkdd2*f*fd*g2*k1**2 - 264*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 132*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 132*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 132*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 66*D1**2*Pkdd2*f*fdd*g2*k1**2 - 132*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 132*D1**2*Pkdd2*fd**2*g2*k1**2*s - 66*D1**2*bd1**2*f*(14*Pk2*(r**2*(K - 1) + r*(-K + 2*s + 1) - s) + Pkdd2*k1**2*s**2*(-7*K - 7) + f*(10*Pk2*(4*r*s - r - 2*s + 1) + Pkdd2*k1**2*s*(3 - 4*s))) - 512*D1*Dd*Pk2*f**4*r**2 - 2200*D1*Dd*Pk2*f**4*r*s + 806*D1*Dd*Pk2*f**4*r + 550*D1*Dd*Pk2*f**4*s - 128*D1*Dd*Pk2*f**4 + 7680*D1*Dd*Pk2*f**3*fd*r**2 + 17600*D1*Dd*Pk2*f**3*fd*r*s - 8240*D1*Dd*Pk2*f**3*fd*r - 4400*D1*Dd*Pk2*f**3*fd*s + 1580*D1*Dd*Pk2*f**3*fd - 1056*D1*Dd*Pk2*f**2*g2*r**2 + 528*D1*Dd*Pk2*f**2*g2*r - 264*D1*Dd*Pk2*f**2*g2 + 1056*D1*Dd*Pk2*f**2*gd2*r**2 - 264*D1*Dd*Pk2*f**2*gd2*r + 2112*D1*Dd*Pk2*f*fd*g2*r**2 - 1584*D1*Dd*Pk2*f*fd*g2*r + 264*D1*Dd*Pk2*f*fd*g2 - 264*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 + 132*D1*Dd*Pkdd2*b2*f**2*k1**2*s - 66*D1*Dd*Pkdd2*b2*f**2*k1**2 + 528*D1*Dd*Pkdd2*b2*f*fd*k1**2*s**2 - 396*D1*Dd*Pkdd2*b2*f*fd*k1**2*s + 66*D1*Dd*Pkdd2*b2*f*fd*k1**2 + 264*D1*Dd*Pkdd2*bd2*f**2*k1**2*s**2 - 66*D1*Dd*Pkdd2*bd2*f**2*k1**2*s + 88*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 44*D1*Dd*Pkdd2*f**4*k1**2*s + 22*D1*Dd*Pkdd2*f**4*k1**2 + 528*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 264*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 132*D1*Dd*Pkdd2*f**2*g2*k1**2 - 528*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 132*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 1056*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 792*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 132*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 960*D1*Ddd*Pk2*f**4*r**2 + 2200*D1*Ddd*Pk2*f**4*r*s - 1030*D1*Ddd*Pk2*f**4*r - 550*D1*Ddd*Pk2*f**4*s + 240*D1*Ddd*Pk2*f**4 + 528*D1*Ddd*Pk2*f**2*g2*r**2 - 264*D1*Ddd*Pk2*f**2*g2*r + 132*D1*Ddd*Pk2*f**2*g2 + 132*D1*Ddd*Pkdd2*b2*f**2*k1**2*s**2 - 66*D1*Ddd*Pkdd2*b2*f**2*k1**2*s + 33*D1*Ddd*Pkdd2*b2*f**2*k1**2 - 264*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 132*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 66*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 11*D1*bd1*(D1*(f**3*(2*Pk2*(24*r**2 + r*(71*s - 30) - 75*s + 16) + Pkdd2*k1**2*(-3*s**2 - 8*s + 4)) - 2*f**2*(6*Pk2*r*(r*(K - 1) + 2*s) + Pkdd2*k1**2*s**2*(-3*K - 3) + fd*(5*Pk2*(36*r**2 + 66*r*s - 35*r - 41*s + 13) + Pkdd2*k1**2*s*(9*s - 7))) + 6*f*(4*K*Pk2*fd*r**2 - 2*K*Pk2*fd*r - 2*K*Pkdd2*fd*k1**2*s**2 + K*Pkdd2*fd*k1**2*s - 4*Pk2*fd*r**2 + 8*Pk2*fd*r*s - 2*Pk2*fd*s + 7*Pkdd2*b2*k1**2*s**2 - 7*Pkdd2*bd2*k1**2*s**2 - 2*Pkdd2*fd*k1**2*s**2 + Pkdd2*fd*k1**2*s + 14*g2*(2*Pk2*(r - 1)**2 - Pkdd2*k1**2*s**2) + 14*gd2*(-2*Pk2*r*(r - 1) + Pkdd2*k1**2*s**2)) - 42*fd*(4*Pk2*g2*r*(r - 1) + Pkdd2*b2*k1**2*s*(s - 1) - 2*Pkdd2*g2*k1**2*s*(s - 1))) - 2*Dd*f*(84*Pk2*g2*(4*r**2 - 5*r + 1) + 21*Pkdd2*b2*k1**2*s*(4*s - 1) + 42*Pkdd2*g2*k1**2*s*(1 - 4*s) + f**2*(5*Pk2*(48*r**2 + r*(88*s - 47) - 71*s + 21) + Pkdd2*k1**2*(12*s**2 - 11*s + 2)) - 3*f*(2*K*Pk2*r*(4*r - 1) + K*Pkdd2*k1**2*s*(1 - 4*s) - 2*Pk2*(4*r**2 - 8*r*s + s) + Pkdd2*k1**2*s*(1 - 4*s)))) + 2880*Dd**2*Pk2*f**4*r**2 + 6600*Dd**2*Pk2*f**4*r*s - 3090*Dd**2*Pk2*f**4*r - 1650*Dd**2*Pk2*f**4*s + 550*Dd**2*Pk2*f**4 + 1584*Dd**2*Pk2*f**2*g2*r**2 - 792*Dd**2*Pk2*f**2*g2*r + 396*Dd**2*Pkdd2*b2*f**2*k1**2*s**2 - 198*Dd**2*Pkdd2*b2*f**2*k1**2*s - 792*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 396*Dd**2*Pkdd2*f**2*g2*k1**2*s - 231*Pkdd2*b1**3*k1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1**2*(D1**2*(28*K*Pk2*fd*r**2 - 14*K*Pk2*fdd*r**2 - 14*K*Pkdd2*fd*k1**2*s**2 + 28*K*Pkdd2*fd*k1**2*s - 14*K*Pkdd2*fd*k1**2 + 7*K*Pkdd2*fdd*k1**2*s**2 - 14*K*Pkdd2*fdd*k1**2*s + 7*K*Pkdd2*fdd*k1**2 + 48*Pk2*f*fd*r*s - 12*Pk2*f*fd*r - 80*Pk2*f*fdd*r*s + 20*Pk2*f*fdd*r - 80*Pk2*fd**2*r*s + 20*Pk2*fd**2*r - 28*Pk2*fd*r**2 + 56*Pk2*fd*r*s - 56*Pk2*fd*r + 14*Pk2*fdd*r**2 - 28*Pk2*fdd*r*s + 28*Pk2*fdd*r - 14*Pkdd2*bd1*k1**2*(f*(3*s**2 - 2*s + 1) + fd*s*(1 - 3*s)) + 7*Pkdd2*bdd1*f*k1**2*(3*s**2 - 2*s + 1) - 2*Pkdd2*f*fd*k1**2*s**2 - 10*Pkdd2*f*fd*k1**2*s + 5*Pkdd2*f*fd*k1**2 + 8*Pkdd2*f*fdd*k1**2*s**2 - 2*Pkdd2*f*fdd*k1**2*s + Pkdd2*f*fdd*k1**2 + 8*Pkdd2*fd**2*k1**2*s**2 - 2*Pkdd2*fd**2*k1**2*s - 14*Pkdd2*fd*k1**2*s**2 + 28*Pkdd2*fd*k1**2*s - 14*Pkdd2*fd*k1**2 + 7*Pkdd2*fdd*k1**2*s**2 - 14*Pkdd2*fdd*k1**2*s + 7*Pkdd2*fdd*k1**2) + D1*(Dd*(-4*Pk2*f*(-28*K*r**2 + 14*K*r - 7*K + 5*fd*(8*r - 1)*(4*s - 1) + 28*r**2 - 56*r*s + 14*s + 7) + 2*Pkdd2*f*k1**2*(7*bd1*(12*s**2 - 7*s + 1) + fd*(32*s**2 - 12*s + 1) + (-7*K - 7)*(4*s**2 - 2*s + 1)) - f**2*(24*Pk2*(-4*r*s + r + s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 14*fd*(2*Pk2*(-r**2*(4*K - 4) + r*(K - 8*s + 4) + s - 1) + Pkdd2*k1**2*(K + 1)*(4*s**2 - 5*s + 1))) + Ddd*f*(-2*Pk2*(7*K*(4*r**2 - 2*r + 1) + 20*f*(4*r*s - r - s) - 28*r**2 + 56*r*s - 14*s - 7) + Pkdd2*k1**2*(7*K + 4*f + 7)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(-2*Pk2*(21*K*r*(2*r - 1) + 10*f*(3*r*(4*s - 1) - 3*s + 1) - 42*r**2 + 84*r*s - 21*s + 7) + Pkdd2*k1**2*s*(2*s - 1)*(21*K + 12*f + 21))) + 11*b1*(24*D1**2*K*Pk2*f*fd*r**2 - 24*D1**2*K*Pk2*f*fd*r + 12*D1**2*K*Pk2*f*fd - 12*D1**2*K*Pk2*f*fdd*r**2 + 12*D1**2*K*Pk2*f*fdd*r - 6*D1**2*K*Pk2*f*fdd - 12*D1**2*K*Pk2*fd**2*r**2 + 12*D1**2*K*Pk2*fd**2*r - 12*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 12*D1**2*K*Pkdd2*f*fd*k1**2*s - 6*D1**2*K*Pkdd2*f*fd*k1**2 + 6*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 6*D1**2*K*Pkdd2*f*fdd*k1**2*s + 3*D1**2*K*Pkdd2*f*fdd*k1**2 + 6*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 6*D1**2*K*Pkdd2*fd**2*k1**2*s - 144*D1**2*Pk2*f**2*fd*r**2 - 426*D1**2*Pk2*f**2*fd*r*s + 178*D1**2*Pk2*f**2*fd*r - 8*D1**2*Pk2*f**2*fd*s - 16*D1**2*Pk2*f**2*fd + 180*D1**2*Pk2*f**2*fdd*r**2 + 330*D1**2*Pk2*f**2*fdd*r*s - 170*D1**2*Pk2*f**2*fdd*r + 40*D1**2*Pk2*f**2*fdd*s + 20*D1**2*Pk2*f**2*fdd + 360*D1**2*Pk2*f*fd**2*r**2 + 660*D1**2*Pk2*f*fd**2*r*s - 340*D1**2*Pk2*f*fd**2*r + 80*D1**2*Pk2*f*fd**2*s - 20*D1**2*Pk2*f*fd**2 - 24*D1**2*Pk2*f*fd*r**2 + 48*D1**2*Pk2*f*fd*r*s - 24*D1**2*Pk2*f*fd*s - 12*D1**2*Pk2*f*fd + 12*D1**2*Pk2*f*fdd*r**2 - 24*D1**2*Pk2*f*fdd*r*s + 12*D1**2*Pk2*f*fdd*s + 6*D1**2*Pk2*f*fdd - 168*D1**2*Pk2*f*gd2*r**2 + 84*D1**2*Pk2*f*gdd2*r**2 + 12*D1**2*Pk2*fd**2*r**2 - 24*D1**2*Pk2*fd**2*r*s + 12*D1**2*Pk2*fd**2*s - 12*D1**2*Pk2*fd**2 - 168*D1**2*Pk2*fd*g2*r**2 + 168*D1**2*Pk2*fd*gd2*r**2 + 84*D1**2*Pk2*fdd*g2*r**2 - 42*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 84*D1**2*Pkdd2*b2*fd*k1**2*s - 42*D1**2*Pkdd2*b2*fd*k1**2 + 21*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 42*D1**2*Pkdd2*b2*fdd*k1**2*s + 21*D1**2*Pkdd2*b2*fdd*k1**2 + 42*D1**2*Pkdd2*bd1**2*f*k1**2*s*(3*s - 2) - 42*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 42*D1**2*Pkdd2*bd2*fd*k1**2*s**2 - 42*D1**2*Pkdd2*bd2*fd*k1**2*s + 21*D1**2*Pkdd2*bdd2*f*k1**2*s**2 + 9*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 14*D1**2*Pkdd2*f**2*fd*k1**2*s + 7*D1**2*Pkdd2*f**2*fd*k1**2 + 9*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 2*D1**2*Pkdd2*f**2*fdd*k1**2*s + D1**2*Pkdd2*f**2*fdd*k1**2 + 18*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 4*D1**2*Pkdd2*f*fd**2*k1**2*s - 12*D1**2*Pkdd2*f*fd*k1**2*s**2 + 12*D1**2*Pkdd2*f*fd*k1**2*s - 6*D1**2*Pkdd2*f*fd*k1**2 + 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s + 3*D1**2*Pkdd2*f*fdd*k1**2 + 84*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 6*D1**2*Pkdd2*fd**2*k1**2*s**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s + 84*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 168*D1**2*Pkdd2*fd*g2*k1**2*s + 84*D1**2*Pkdd2*fd*g2*k1**2 - 84*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 84*D1**2*Pkdd2*fd*gd2*k1**2*s - 42*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + 84*D1**2*Pkdd2*fdd*g2*k1**2*s - 42*D1**2*Pkdd2*fdd*g2*k1**2 + 3*D1**2*bdd1*f*(Pk2*(-14*K*(2*r**2 - 2*r + 1) + 40*f*s + 28*r**2 - 4*r*(20*f*s - 5*f + 14*s + 7) + 28*s + 14) + Pkdd2*k1**2*(f*(8*s**2 - 6*s + 3) + s**2*(14*K + 14))) + 48*D1*Dd*K*Pk2*f**2*r**2 - 24*D1*Dd*K*Pk2*f**2*r + 12*D1*Dd*K*Pk2*f**2 - 96*D1*Dd*K*Pk2*f*fd*r**2 + 72*D1*Dd*K*Pk2*f*fd*r - 12*D1*Dd*K*Pk2*f*fd - 24*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 12*D1*Dd*K*Pkdd2*f**2*k1**2*s - 6*D1*Dd*K*Pkdd2*f**2*k1**2 + 48*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 36*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 6*D1*Dd*K*Pkdd2*f*fd*k1**2 - 192*D1*Dd*Pk2*f**3*r**2 - 568*D1*Dd*Pk2*f**3*r*s + 238*D1*Dd*Pk2*f**3*r + 142*D1*Dd*Pk2*f**3*s - 48*D1*Dd*Pk2*f**3 + 1440*D1*Dd*Pk2*f**2*fd*r**2 + 2640*D1*Dd*Pk2*f**2*fd*r*s - 1370*D1*Dd*Pk2*f**2*fd*r - 170*D1*Dd*Pk2*f**2*fd*s + 130*D1*Dd*Pk2*f**2*fd - 48*D1*Dd*Pk2*f**2*r**2 + 96*D1*Dd*Pk2*f**2*r*s - 24*D1*Dd*Pk2*f**2*s - 12*D1*Dd*Pk2*f**2 + 96*D1*Dd*Pk2*f*fd*r**2 - 192*D1*Dd*Pk2*f*fd*r*s + 72*D1*Dd*Pk2*f*fd*s - 12*D1*Dd*Pk2*f*fd - 672*D1*Dd*Pk2*f*g2*r**2 + 336*D1*Dd*Pk2*f*g2*r - 168*D1*Dd*Pk2*f*g2 + 672*D1*Dd*Pk2*f*gd2*r**2 - 168*D1*Dd*Pk2*f*gd2*r + 672*D1*Dd*Pk2*fd*g2*r**2 - 168*D1*Dd*Pk2*fd*g2*r - 168*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 84*D1*Dd*Pkdd2*b2*f*k1**2*s - 42*D1*Dd*Pkdd2*b2*f*k1**2 + 168*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 210*D1*Dd*Pkdd2*b2*fd*k1**2*s + 42*D1*Dd*Pkdd2*b2*fd*k1**2 + 168*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 42*D1*Dd*Pkdd2*bd2*f*k1**2*s + 12*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 6*D1*Dd*Pkdd2*f**3*k1**2*s + 3*D1*Dd*Pkdd2*f**3*k1**2 + 72*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 26*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 2*D1*Dd*Pkdd2*f**2*fd*k1**2 - 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 12*D1*Dd*Pkdd2*f**2*k1**2*s - 6*D1*Dd*Pkdd2*f**2*k1**2 + 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 36*D1*Dd*Pkdd2*f*fd*k1**2*s + 6*D1*Dd*Pkdd2*f*fd*k1**2 + 336*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 168*D1*Dd*Pkdd2*f*g2*k1**2*s + 84*D1*Dd*Pkdd2*f*g2*k1**2 - 336*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 84*D1*Dd*Pkdd2*f*gd2*k1**2*s - 336*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 420*D1*Dd*Pkdd2*fd*g2*k1**2*s - 84*D1*Dd*Pkdd2*fd*g2*k1**2 - 24*D1*Ddd*K*Pk2*f**2*r**2 + 12*D1*Ddd*K*Pk2*f**2*r - 6*D1*Ddd*K*Pk2*f**2 + 12*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 6*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 3*D1*Ddd*K*Pkdd2*f**2*k1**2 + 240*D1*Ddd*Pk2*f**3*r**2 + 440*D1*Ddd*Pk2*f**3*r*s - 230*D1*Ddd*Pk2*f**3*r - 110*D1*Ddd*Pk2*f**3*s + 60*D1*Ddd*Pk2*f**3 + 24*D1*Ddd*Pk2*f**2*r**2 - 48*D1*Ddd*Pk2*f**2*r*s + 12*D1*Ddd*Pk2*f**2*s + 6*D1*Ddd*Pk2*f**2 + 336*D1*Ddd*Pk2*f*g2*r**2 - 168*D1*Ddd*Pk2*f*g2*r + 84*D1*Ddd*Pk2*f*g2 + 84*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 42*D1*Ddd*Pkdd2*b2*f*k1**2*s + 21*D1*Ddd*Pkdd2*b2*f*k1**2 + 12*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 6*D1*Ddd*Pkdd2*f**3*k1**2*s + 3*D1*Ddd*Pkdd2*f**3*k1**2 + 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 6*D1*Ddd*Pkdd2*f**2*k1**2*s + 3*D1*Ddd*Pkdd2*f**2*k1**2 - 168*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 84*D1*Ddd*Pkdd2*f*g2*k1**2*s - 42*D1*Ddd*Pkdd2*f*g2*k1**2 + 6*D1*bd1*(D1*(-f**2*(6*Pk2*(-4*r*s + r + 2*s) + Pkdd2*k1**2*(s**2 - 6*s + 3)) - 2*f*(Pk2*(-14*K*r**2 + 14*K*r - 7*K + 5*fd*(4*r - 1)*(4*s - 1) + 14*r**2 - 28*r*s - 14*r + 14*s + 7) + Pkdd2*k1**2*s*(fd*(4 - 8*s) + s*(7*K + 7))) + 14*fd*(Pk2*(-r**2*(2*K - 2) + r*(K - 4*s + 1) + s - 1) + Pkdd2*k1**2*s*(K + 1)*(s - 1))) + Dd*f*(-14*K*Pk2*(8*r**2 - 6*r + 1) - 14*K*Pkdd2*k1**2*s*(1 - 4*s) - 14*Pk2*(-8*r**2 + 4*r*(4*s + 1) - 6*s) - 14*Pkdd2*k1**2*s*(1 - 4*s) + f*(4*s - 1)*(Pk2*(30 - 80*r) + Pkdd2*k1**2*(8*s - 3)))) - 72*Dd**2*K*Pk2*f**2*r**2 + 36*Dd**2*K*Pk2*f**2*r + 36*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 18*Dd**2*K*Pkdd2*f**2*k1**2*s + 720*Dd**2*Pk2*f**3*r**2 + 1320*Dd**2*Pk2*f**3*r*s - 690*Dd**2*Pk2*f**3*r - 330*Dd**2*Pk2*f**3*s + 110*Dd**2*Pk2*f**3 + 72*Dd**2*Pk2*f**2*r**2 - 144*Dd**2*Pk2*f**2*r*s + 36*Dd**2*Pk2*f**2*s - 12*Dd**2*Pk2*f**2 + 1008*Dd**2*Pk2*f*g2*r**2 - 504*Dd**2*Pk2*f*g2*r + 252*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 126*Dd**2*Pkdd2*b2*f*k1**2*s + 36*Dd**2*Pkdd2*f**3*k1**2*s**2 - 18*Dd**2*Pkdd2*f**3*k1**2*s + 36*Dd**2*Pkdd2*f**2*k1**2*s**2 - 18*Dd**2*Pkdd2*f**2*k1**2*s - 504*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 252*Dd**2*Pkdd2*f*g2*k1**2*s))/(2310*d**2*k1**2) - D1**2*Pk1*st**2*(24*D1**2*K*Pk2*bdd1*f**2*r**2 - 40*D1**2*Pk2*b2*f*fd*r**2 + 40*D1**2*Pk2*b2*f*fd*r - 20*D1**2*Pk2*b2*f*fd + 48*D1**2*Pk2*b2*f*fdd*r**2 - 48*D1**2*Pk2*b2*f*fdd*r + 24*D1**2*Pk2*b2*f*fdd + 48*D1**2*Pk2*b2*fd**2*r**2 - 48*D1**2*Pk2*b2*fd**2*r - 20*D1**2*Pk2*bd2*f**2*r**2 + 96*D1**2*Pk2*bd2*f*fd*r**2 - 48*D1**2*Pk2*bd2*f*fd*r + 48*D1**2*Pk2*bdd1*f**3*r**2 + 108*D1**2*Pk2*bdd1*f**3*r*s - 54*D1**2*Pk2*bdd1*f**3*r + 24*D1**2*Pk2*bdd1*f**2*r**2 + 46*D1**2*Pk2*bdd1*f**2*r*s + 28*D1**2*Pk2*bdd1*f*g2*r**2 + 24*D1**2*Pk2*bdd2*f**2*r**2 + 68*D1**2*Pk2*f**2*gd2*r**2 - 48*D1**2*Pk2*f**2*gdd2*r**2 + 136*D1**2*Pk2*f*fd*g2*r**2 - 136*D1**2*Pk2*f*fd*g2*r + 68*D1**2*Pk2*f*fd*g2 - 192*D1**2*Pk2*f*fd*gd2*r**2 + 96*D1**2*Pk2*f*fd*gd2*r - 96*D1**2*Pk2*f*fdd*g2*r**2 + 96*D1**2*Pk2*f*fdd*g2*r - 48*D1**2*Pk2*f*fdd*g2 - 96*D1**2*Pk2*fd**2*g2*r**2 + 96*D1**2*Pk2*fd**2*g2*r + 7*D1**2*Pkdd2*b2*bdd1*f*k1**2*s**2 - 14*D1**2*Pkdd2*b2*bdd1*f*k1**2*s + 7*D1**2*Pkdd2*b2*bdd1*f*k1**2 + 14*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 - 14*D1**2*Pkdd2*b2*f*fd*k1**2*s + 7*D1**2*Pkdd2*b2*f*fd*k1**2 + 7*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 - 14*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 + 28*D1**2*Pkdd2*bdd1*f*g2*k1**2*s - 14*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 14*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 28*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 28*D1**2*Pkdd2*f*fd*g2*k1**2*s - 14*D1**2*Pkdd2*f*fd*g2*k1**2 + 2*D1**2*bd1**2*(-7*Pk2*f*(r**2*(2*K - 2) - 26*r*s + 13*s) + 140*Pk2*g2*r*(r - 1) + 35*Pkdd2*b2*k1**2*s*(s - 1) + 7*Pkdd2*f*k1**2*s*(K + 1)*(s - 1) - 70*Pkdd2*g2*k1**2*s*(s - 1) + 3*f**2*(Pk2*(32*r**2 + 84*r*s - 45*r - 42*s + 21) + Pkdd2*k1**2*s*(s - 1))) - 80*D1*Dd*Pk2*b2*f**2*r**2 + 40*D1*Dd*Pk2*b2*f**2*r - 20*D1*Dd*Pk2*b2*f**2 + 384*D1*Dd*Pk2*b2*f*fd*r**2 - 288*D1*Dd*Pk2*b2*f*fd*r + 48*D1*Dd*Pk2*b2*f*fd + 192*D1*Dd*Pk2*bd2*f**2*r**2 - 48*D1*Dd*Pk2*bd2*f**2*r + 272*D1*Dd*Pk2*f**2*g2*r**2 - 136*D1*Dd*Pk2*f**2*g2*r + 68*D1*Dd*Pk2*f**2*g2 - 384*D1*Dd*Pk2*f**2*gd2*r**2 + 96*D1*Dd*Pk2*f**2*gd2*r - 768*D1*Dd*Pk2*f*fd*g2*r**2 + 576*D1*Dd*Pk2*f*fd*g2*r - 96*D1*Dd*Pk2*f*fd*g2 + 28*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 - 14*D1*Dd*Pkdd2*b2*f**2*k1**2*s + 7*D1*Dd*Pkdd2*b2*f**2*k1**2 - 56*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 28*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 14*D1*Dd*Pkdd2*f**2*g2*k1**2 + 96*D1*Ddd*Pk2*b2*f**2*r**2 - 48*D1*Ddd*Pk2*b2*f**2*r + 24*D1*Ddd*Pk2*b2*f**2 - 192*D1*Ddd*Pk2*f**2*g2*r**2 + 96*D1*Ddd*Pk2*f**2*g2*r - 48*D1*Ddd*Pk2*f**2*g2 + D1*bd1*(D1*(3*f**3*(-2*Pk2*r*(4*r + 18*s - 9) + Pkdd2*k1**2*(3*s**2 - 4*s + 2)) + f**2*(6*Pk2*fd*(48*r**2 + 4*r*(27*s - 13) - 18*s + 9) - 2*Pk2*r*(17*K*r + 3*r + 39*s) + Pkdd2*k1**2*s**2*(7*K + 7)) + f*(2*Pk2*fd*(r**2*(48*K + 48) + r*(-24*K + 92*s - 47) - 23*s) + 56*Pk2*gd2*r**2 + 7*Pkdd2*b2*k1**2*(3*s**2 + 4*s - 2) + 14*Pkdd2*bd2*k1**2*s*(s - 1) - 28*Pkdd2*gd2*k1**2*s*(s - 1) + 14*g2*(2*Pk2*(3*r**2 - 10*r + 5) + Pkdd2*k1**2*(-3*s**2 - 4*s + 2))) + 14*fd*(4*Pk2*g2*r*(r - 1) + Pkdd2*b2*k1**2*s*(s - 1) - 2*Pkdd2*g2*k1**2*s*(s - 1))) + 2*Dd*f*(3*Pk2*f**2*(64*r**2 + 2*r*(72*s - 35) - 18*s + 9) + Pk2*f*(r**2*(96*K + 96) + r*(-24*K + 184*s - 47) - 23*s) + 7*Pkdd2*b2*k1**2*(4*s**2 - 5*s + 1) - 14*g2*(2*Pk2*r*(1 - 4*r) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 288*Dd**2*Pk2*b2*f**2*r**2 - 144*Dd**2*Pk2*b2*f**2*r - 576*Dd**2*Pk2*f**2*g2*r**2 + 288*Dd**2*Pk2*f**2*g2*r + 7*b1**3*(D1**2*Pkdd2*k1**2*s**2*(3*fd + fdd) + D1*(20*Dd*Pk2*(K - 1)*(4*r**2 - 2*r + 1) + Dd*Pkdd2*k1**2*(-10*K*(4*s**2 - 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) + 2*s**2*(4*fd - 20) - 2*s*(fd - 10) - 10) - 10*Ddd*Pk2*(K - 1)*(4*r**2 - 2*r + 1) + Ddd*Pkdd2*k1**2*(5*K + f + 5)*(4*s**2 - 2*s + 1)) - 6*Dd**2*(Pk2*r*(10*K - 10)*(2*r - 1) - Pkdd2*k1**2*s*(2*s - 1)*(5*K + f + 5))) + b1**2*(-42*D1**2*K*Pk2*fd*r**2 - 56*D1**2*K*Pk2*fd*r + 28*D1**2*K*Pk2*fd - 14*D1**2*K*Pk2*fdd*r**2 + 28*D1**2*K*Pk2*fdd*r - 14*D1**2*K*Pk2*fdd + 21*D1**2*K*Pkdd2*fd*k1**2*s**2 - 70*D1**2*K*Pkdd2*fd*k1**2*s + 35*D1**2*K*Pkdd2*fd*k1**2 + 7*D1**2*K*Pkdd2*fdd*k1**2*s**2 - 160*D1**2*Pk2*f*fd*r**2 - 504*D1**2*Pk2*f*fd*r*s + 166*D1**2*Pk2*f*fd*r - 20*D1**2*Pk2*f*fd + 192*D1**2*Pk2*f*fdd*r**2 + 504*D1**2*Pk2*f*fdd*r*s - 174*D1**2*Pk2*f*fdd*r + 24*D1**2*Pk2*f*fdd + 192*D1**2*Pk2*fd**2*r**2 + 504*D1**2*Pk2*fd**2*r*s - 174*D1**2*Pk2*fd**2*r + 42*D1**2*Pk2*fd*r**2 - 294*D1**2*Pk2*fd*r*s + 350*D1**2*Pk2*fd*r - 28*D1**2*Pk2*fd + 14*D1**2*Pk2*fdd*r**2 + 182*D1**2*Pk2*fdd*r*s - 210*D1**2*Pk2*fdd*r + 14*D1**2*Pk2*fdd - 280*D1**2*Pk2*gd2*r**2 + 140*D1**2*Pk2*gdd2*r**2 - 70*D1**2*Pkdd2*bd2*k1**2*s**2 + 35*D1**2*Pkdd2*bdd2*k1**2*s**2 + 44*D1**2*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*Pkdd2*f*fd*k1**2*s + 7*D1**2*Pkdd2*f*fd*k1**2 + 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 6*D1**2*Pkdd2*fd**2*k1**2*s**2 + 21*D1**2*Pkdd2*fd*k1**2*s**2 - 70*D1**2*Pkdd2*fd*k1**2*s + 35*D1**2*Pkdd2*fd*k1**2 + 7*D1**2*Pkdd2*fdd*k1**2*s**2 + 140*D1**2*Pkdd2*gd2*k1**2*s**2 - 70*D1**2*Pkdd2*gdd2*k1**2*s**2 - 7*D1**2*bdd1*(Pk2*(10*K - 10)*(3*r**2 - 2*r + 1) - Pkdd2*k1**2*(5*K + f + 5)*(3*s**2 - 2*s + 1)) - 168*D1*Dd*K*Pk2*f*r**2 + 84*D1*Dd*K*Pk2*f*r - 42*D1*Dd*K*Pk2*f - 112*D1*Dd*K*Pk2*fd*r**2 + 140*D1*Dd*K*Pk2*fd*r - 28*D1*Dd*K*Pk2*fd + 84*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 42*D1*Dd*K*Pkdd2*f*k1**2*s + 21*D1*Dd*K*Pkdd2*f*k1**2 + 56*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 14*D1*Dd*K*Pkdd2*fd*k1**2*s - 320*D1*Dd*Pk2*f**2*r**2 - 1008*D1*Dd*Pk2*f**2*r*s + 412*D1*Dd*Pk2*f**2*r + 252*D1*Dd*Pk2*f**2*s - 80*D1*Dd*Pk2*f**2 + 1536*D1*Dd*Pk2*f*fd*r**2 + 4032*D1*Dd*Pk2*f*fd*r*s - 1584*D1*Dd*Pk2*f*fd*r - 504*D1*Dd*Pk2*f*fd*s + 174*D1*Dd*Pk2*f*fd + 168*D1*Dd*Pk2*f*r**2 - 1176*D1*Dd*Pk2*f*r*s + 210*D1*Dd*Pk2*f*r + 294*D1*Dd*Pk2*f*s + 42*D1*Dd*Pk2*f + 112*D1*Dd*Pk2*fd*r**2 + 1456*D1*Dd*Pk2*fd*r*s - 1050*D1*Dd*Pk2*fd*r - 182*D1*Dd*Pk2*fd*s + 210*D1*Dd*Pk2*fd - 1120*D1*Dd*Pk2*g2*r**2 + 560*D1*Dd*Pk2*g2*r - 280*D1*Dd*Pk2*g2 + 1120*D1*Dd*Pk2*gd2*r**2 - 280*D1*Dd*Pk2*gd2*r - 280*D1*Dd*Pkdd2*b2*k1**2*s**2 + 140*D1*Dd*Pkdd2*b2*k1**2*s - 70*D1*Dd*Pkdd2*b2*k1**2 + 280*D1*Dd*Pkdd2*bd2*k1**2*s**2 - 70*D1*Dd*Pkdd2*bd2*k1**2*s + 88*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 44*D1*Dd*Pkdd2*f**2*k1**2*s + 22*D1*Dd*Pkdd2*f**2*k1**2 + 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 12*D1*Dd*Pkdd2*f*fd*k1**2*s + 84*D1*Dd*Pkdd2*f*k1**2*s**2 - 42*D1*Dd*Pkdd2*f*k1**2*s + 21*D1*Dd*Pkdd2*f*k1**2 + 56*D1*Dd*Pkdd2*fd*k1**2*s**2 - 14*D1*Dd*Pkdd2*fd*k1**2*s + 560*D1*Dd*Pkdd2*g2*k1**2*s**2 - 280*D1*Dd*Pkdd2*g2*k1**2*s + 140*D1*Dd*Pkdd2*g2*k1**2 - 560*D1*Dd*Pkdd2*gd2*k1**2*s**2 + 140*D1*Dd*Pkdd2*gd2*k1**2*s - 56*D1*Ddd*K*Pk2*f*r**2 + 28*D1*Ddd*K*Pk2*f*r - 14*D1*Ddd*K*Pk2*f + 28*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 14*D1*Ddd*K*Pkdd2*f*k1**2*s + 7*D1*Ddd*K*Pkdd2*f*k1**2 + 384*D1*Ddd*Pk2*f**2*r**2 + 1008*D1*Ddd*Pk2*f**2*r*s - 444*D1*Ddd*Pk2*f**2*r - 252*D1*Ddd*Pk2*f**2*s + 96*D1*Ddd*Pk2*f**2 + 56*D1*Ddd*Pk2*f*r**2 + 728*D1*Ddd*Pk2*f*r*s - 210*D1*Ddd*Pk2*f*r - 182*D1*Ddd*Pk2*f*s + 14*D1*Ddd*Pk2*f + 560*D1*Ddd*Pk2*g2*r**2 - 280*D1*Ddd*Pk2*g2*r + 140*D1*Ddd*Pk2*g2 + 140*D1*Ddd*Pkdd2*b2*k1**2*s**2 - 70*D1*Ddd*Pkdd2*b2*k1**2*s + 35*D1*Ddd*Pkdd2*b2*k1**2 + 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 6*D1*Ddd*Pkdd2*f**2*k1**2*s + 3*D1*Ddd*Pkdd2*f**2*k1**2 + 28*D1*Ddd*Pkdd2*f*k1**2*s**2 - 14*D1*Ddd*Pkdd2*f*k1**2*s + 7*D1*Ddd*Pkdd2*f*k1**2 - 280*D1*Ddd*Pkdd2*g2*k1**2*s**2 + 140*D1*Ddd*Pkdd2*g2*k1**2*s - 70*D1*Ddd*Pkdd2*g2*k1**2 + 7*D1*bd1*(20*D1*Pk2*(K - 1)*(3*r**2 - 2*r + 1) + D1*Pkdd2*k1**2*(-10*K*(3*s**2 - 2*s + 1) + f*(9*s**2 - 6*s + 3) + 2*s**2*(3*fd - 15) - 2*s*(fd - 10) - 10) - 20*Dd*Pk2*(K - 1)*(12*r**2 - 7*r + 1) + 2*Dd*Pkdd2*k1**2*(5*K + f + 5)*(12*s**2 - 7*s + 1)) - 168*Dd**2*K*Pk2*f*r**2 + 84*Dd**2*K*Pk2*f*r + 84*Dd**2*K*Pkdd2*f*k1**2*s**2 - 42*Dd**2*K*Pkdd2*f*k1**2*s + 1152*Dd**2*Pk2*f**2*r**2 + 3024*Dd**2*Pk2*f**2*r*s - 1332*Dd**2*Pk2*f**2*r - 756*Dd**2*Pk2*f**2*s + 252*Dd**2*Pk2*f**2 + 168*Dd**2*Pk2*f*r**2 + 2184*Dd**2*Pk2*f*r*s - 630*Dd**2*Pk2*f*r - 546*Dd**2*Pk2*f*s + 182*Dd**2*Pk2*f + 1680*Dd**2*Pk2*g2*r**2 - 840*Dd**2*Pk2*g2*r + 420*Dd**2*Pkdd2*b2*k1**2*s**2 - 210*Dd**2*Pkdd2*b2*k1**2*s + 36*Dd**2*Pkdd2*f**2*k1**2*s**2 - 18*Dd**2*Pkdd2*f**2*k1**2*s + 84*Dd**2*Pkdd2*f*k1**2*s**2 - 42*Dd**2*Pkdd2*f*k1**2*s - 840*Dd**2*Pkdd2*g2*k1**2*s**2 + 420*Dd**2*Pkdd2*g2*k1**2*s) + b1*(-68*D1**2*K*Pk2*f*fd*r**2 + 68*D1**2*K*Pk2*f*fd*r - 34*D1**2*K*Pk2*f*fd + 48*D1**2*K*Pk2*f*fdd*r**2 - 48*D1**2*K*Pk2*f*fdd*r + 24*D1**2*K*Pk2*f*fdd + 48*D1**2*K*Pk2*fd**2*r**2 - 48*D1**2*K*Pk2*fd**2*r + 14*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*K*Pkdd2*f*fd*k1**2*s + 7*D1**2*K*Pkdd2*f*fd*k1**2 - 72*D1**2*Pk2*f**2*fd*r**2 - 324*D1**2*Pk2*f**2*fd*r*s + 102*D1**2*Pk2*f**2*fd*r + 108*D1**2*Pk2*f**2*fd*s - 24*D1**2*Pk2*f**2*fd + 144*D1**2*Pk2*f**2*fdd*r**2 + 324*D1**2*Pk2*f**2*fdd*r*s - 150*D1**2*Pk2*f**2*fdd*r - 108*D1**2*Pk2*f**2*fdd*s + 48*D1**2*Pk2*f**2*fdd + 288*D1**2*Pk2*f*fd**2*r**2 + 648*D1**2*Pk2*f*fd**2*r*s - 300*D1**2*Pk2*f*fd**2*r - 216*D1**2*Pk2*f*fd**2*s + 54*D1**2*Pk2*f*fd**2 - 12*D1**2*Pk2*f*fd*r**2 - 156*D1**2*Pk2*f*fd*r*s + 90*D1**2*Pk2*f*fd*r + 78*D1**2*Pk2*f*fd*s - 6*D1**2*Pk2*f*fd + 48*D1**2*Pk2*f*fdd*r**2 + 92*D1**2*Pk2*f*fdd*r*s - 94*D1**2*Pk2*f*fdd*r - 46*D1**2*Pk2*f*fdd*s + 24*D1**2*Pk2*f*fdd + 84*D1**2*Pk2*f*gd2*r**2 + 28*D1**2*Pk2*f*gdd2*r**2 + 48*D1**2*Pk2*fd**2*r**2 + 92*D1**2*Pk2*fd**2*r*s - 94*D1**2*Pk2*fd**2*r - 46*D1**2*Pk2*fd**2*s + 46*D1**2*Pk2*fd**2 + 84*D1**2*Pk2*fd*g2*r**2 + 112*D1**2*Pk2*fd*g2*r - 56*D1**2*Pk2*fd*g2 + 56*D1**2*Pk2*fd*gd2*r**2 - 56*D1**2*Pk2*fd*gd2*r + 28*D1**2*Pk2*fdd*g2*r**2 - 56*D1**2*Pk2*fdd*g2*r + 28*D1**2*Pk2*fdd*g2 + 21*D1**2*Pkdd2*b2*fd*k1**2*s**2 - 70*D1**2*Pkdd2*b2*fd*k1**2*s + 35*D1**2*Pkdd2*b2*fd*k1**2 + 7*D1**2*Pkdd2*b2*fdd*k1**2*s**2 + 21*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 14*D1**2*Pkdd2*bd2*fd*k1**2*s**2 + 7*D1**2*Pkdd2*bdd2*f*k1**2*s**2 + 27*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 6*D1**2*Pkdd2*f**2*fd*k1**2*s + 3*D1**2*Pkdd2*f**2*fd*k1**2 + 14*D1**2*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*Pkdd2*f*fd*k1**2*s + 7*D1**2*Pkdd2*f*fd*k1**2 - 42*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 42*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 140*D1**2*Pkdd2*fd*g2*k1**2*s - 70*D1**2*Pkdd2*fd*g2*k1**2 - 28*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 14*D1**2*bd1**2*(Pk2*r*(10*K - 10)*(3*r - 2) - Pkdd2*k1**2*s*(3*s - 2)*(5*K + f + 5)) + D1**2*bdd1*(35*Pk2*g2*(8*r**2 - 8*r + 4) + 35*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) - 70*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 3*f**2*(2*Pk2*(32*r**2 + 84*r*s - 45*r - 42*s + 12) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 7*f*(Pk2*r**2*(4 - 4*K) + 52*Pk2*r*s - 26*Pk2*s + Pkdd2*k1**2*(K + 1)*(2*s**2 - 2*s + 1))) - 136*D1*Dd*K*Pk2*f**2*r**2 + 68*D1*Dd*K*Pk2*f**2*r - 34*D1*Dd*K*Pk2*f**2 + 384*D1*Dd*K*Pk2*f*fd*r**2 - 288*D1*Dd*K*Pk2*f*fd*r + 48*D1*Dd*K*Pk2*f*fd + 28*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 14*D1*Dd*K*Pkdd2*f**2*k1**2*s + 7*D1*Dd*K*Pkdd2*f**2*k1**2 - 96*D1*Dd*Pk2*f**3*r**2 - 432*D1*Dd*Pk2*f**3*r*s + 156*D1*Dd*Pk2*f**3*r + 108*D1*Dd*Pk2*f**3*s - 24*D1*Dd*Pk2*f**3 + 1152*D1*Dd*Pk2*f**2*fd*r**2 + 2592*D1*Dd*Pk2*f**2*fd*r*s - 1212*D1*Dd*Pk2*f**2*fd*r - 756*D1*Dd*Pk2*f**2*fd*s + 258*D1*Dd*Pk2*f**2*fd - 24*D1*Dd*Pk2*f**2*r**2 - 312*D1*Dd*Pk2*f**2*r*s + 90*D1*Dd*Pk2*f**2*r + 78*D1*Dd*Pk2*f**2*s - 6*D1*Dd*Pk2*f**2 + 384*D1*Dd*Pk2*f*fd*r**2 + 736*D1*Dd*Pk2*f*fd*r*s - 564*D1*Dd*Pk2*f*fd*r - 276*D1*Dd*Pk2*f*fd*s + 140*D1*Dd*Pk2*f*fd + 336*D1*Dd*Pk2*f*g2*r**2 - 168*D1*Dd*Pk2*f*g2*r + 84*D1*Dd*Pk2*f*g2 + 224*D1*Dd*Pk2*f*gd2*r**2 - 56*D1*Dd*Pk2*f*gd2*r + 224*D1*Dd*Pk2*fd*g2*r**2 - 280*D1*Dd*Pk2*fd*g2*r + 56*D1*Dd*Pk2*fd*g2 + 84*D1*Dd*Pkdd2*b2*f*k1**2*s**2 - 42*D1*Dd*Pkdd2*b2*f*k1**2*s + 21*D1*Dd*Pkdd2*b2*f*k1**2 + 56*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 14*D1*Dd*Pkdd2*b2*fd*k1**2*s + 56*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 14*D1*Dd*Pkdd2*bd2*f*k1**2*s + 36*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**3*k1**2*s + 9*D1*Dd*Pkdd2*f**3*k1**2 + 28*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 14*D1*Dd*Pkdd2*f**2*k1**2*s + 7*D1*Dd*Pkdd2*f**2*k1**2 - 168*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 84*D1*Dd*Pkdd2*f*g2*k1**2*s - 42*D1*Dd*Pkdd2*f*g2*k1**2 - 112*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 28*D1*Dd*Pkdd2*f*gd2*k1**2*s - 112*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 28*D1*Dd*Pkdd2*fd*g2*k1**2*s + 96*D1*Ddd*K*Pk2*f**2*r**2 - 48*D1*Ddd*K*Pk2*f**2*r + 24*D1*Ddd*K*Pk2*f**2 + 192*D1*Ddd*Pk2*f**3*r**2 + 432*D1*Ddd*Pk2*f**3*r*s - 204*D1*Ddd*Pk2*f**3*r - 108*D1*Ddd*Pk2*f**3*s + 48*D1*Ddd*Pk2*f**3 + 96*D1*Ddd*Pk2*f**2*r**2 + 184*D1*Ddd*Pk2*f**2*r*s - 94*D1*Ddd*Pk2*f**2*r - 46*D1*Ddd*Pk2*f**2*s + 24*D1*Ddd*Pk2*f**2 + 112*D1*Ddd*Pk2*f*g2*r**2 - 56*D1*Ddd*Pk2*f*g2*r + 28*D1*Ddd*Pk2*f*g2 + 28*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 14*D1*Ddd*Pkdd2*b2*f*k1**2*s + 7*D1*Ddd*Pkdd2*b2*f*k1**2 - 56*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 28*D1*Ddd*Pkdd2*f*g2*k1**2*s - 14*D1*Ddd*Pkdd2*f*g2*k1**2 + D1*bd1*(D1*(-70*Pk2*g2*(8*r**2 - 8*r + 4) + 560*Pk2*gd2*r**2 - 280*Pk2*gd2*r - 70*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) + 140*Pkdd2*bd2*k1**2*s**2 - 70*Pkdd2*bd2*k1**2*s + 140*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) - 280*Pkdd2*gd2*k1**2*s**2 + 140*Pkdd2*gd2*k1**2*s + f**2*(-2*Pk2*(80*r**2 + 3*r*(84*s - 41) - 126*s + 30) + Pkdd2*k1**2*(44*s**2 - 30*s + 15)) + 2*f*(Pk2*(-7*K*(6*r**2 - 10*r + 5) + 3*fd*(128*r**2 + 4*r*(84*s - 37) - 84*s + 21) + 42*r**2 - 294*r*s - 70*r + 147*s + 35) + Pkdd2*k1**2*(7*K*(3*s**2 + 2*s - 1) + s**2*(12*fd + 21) + s*(14 - 6*fd) - 7)) - 14*fd*(Pk2*(r**2*(4*K - 4) + r*(-4*K - 52*s + 30) + 13*s - 13) - Pkdd2*k1**2*s*(K + 1)*(2*s - 1))) + 2*Dd*(-7*Pk2*f*(r**2*(16*K - 16) + r*(-4*K - 208*s + 30) + 78*s - 13) + 140*Pk2*g2*(8*r**2 - 6*r + 1) + 35*Pkdd2*b2*k1**2*(8*s**2 - 6*s + 1) + 7*Pkdd2*f*k1**2*(K + 1)*(8*s**2 - 6*s + 1) - 70*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) + 3*f**2*(Pk2*(8*r - 3)*(32*r + 84*s - 29) + Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) + 288*Dd**2*K*Pk2*f**2*r**2 - 144*Dd**2*K*Pk2*f**2*r + 576*Dd**2*Pk2*f**3*r**2 + 1296*Dd**2*Pk2*f**3*r*s - 612*Dd**2*Pk2*f**3*r - 324*Dd**2*Pk2*f**3*s + 108*Dd**2*Pk2*f**3 + 288*Dd**2*Pk2*f**2*r**2 + 552*Dd**2*Pk2*f**2*r*s - 282*Dd**2*Pk2*f**2*r - 138*Dd**2*Pk2*f**2*s + 46*Dd**2*Pk2*f**2 + 336*Dd**2*Pk2*f*g2*r**2 - 168*Dd**2*Pk2*f*g2*r + 84*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 42*Dd**2*Pkdd2*b2*f*k1**2*s - 168*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 84*Dd**2*Pkdd2*f*g2*k1**2*s))/(210*d**2*k1**2) - D1**2*Pk1*(D1*(28*D1*Pk2*b2*bdd1*f*r**2 + 2*D1*Pk2*bd1**2*f*r*(3*f*(8*r + 14*s - 7) + 7*r*(4*K + 4) + 42*s - 21) - 56*D1*Pk2*bdd1*f*g2*r**2 + 7*b2*bd1*(8*D1*Pk2*fd*r*(r - 1) + D1*f*(-8*Pk2*r**2 + 5*Pkdd2*k1**2*(s - 1)**2) + 8*Dd*Pk2*f*r*(4*r - 1)) - 14*bd1*(D1*(-4*Pk2*f*r**2*(bd2 - 2*gd2) + 8*Pk2*fd*g2*r*(r - 1) + f*g2*(-18*Pk2*r**2 + 5*Pkdd2*k1**2*(s - 1)**2)) + 8*Dd*Pk2*f*g2*r*(4*r - 1))) - 7*b1**3*(D1**2*(2*Pk2*fd*r*(4*r + 5*s) - 2*Pk2*fdd*r*(2*r + 5*s) - 5*Pkdd2*fd*k1**2*s**2) + D1*(Dd*(2*Pk2*(15*K*(4*r**2 - 2*r + 1) + f*(16*r**2 + r*(20*s - 13) - 5*s + 4) - 16*fd*r**2 - 40*fd*r*s + 9*fd*r + 5*fd*s - 60*r**2 - 20*r*s + 35*r + 5*s - 15) + Pkdd2*k1**2*(-15*K - 5*f - 15)*(4*s**2 - 2*s + 1)) - 2*Ddd*Pk2*(f*(8*r**2 + r*(20*s - 9) - 5*s + 2) + 5*r*(4*s - 1) - 5*s)) - 2*Dd**2*Pk2*(f*(24*r**2 + 3*r*(20*s - 9) - 15*s + 5) + 15*r*(4*s - 1) - 15*s + 5)) + b1**2*(-126*D1**2*K*Pk2*fd*r**2 + 252*D1**2*K*Pk2*fd*r - 126*D1**2*K*Pk2*fd + 28*D1**2*K*Pk2*fdd*r**2 - 56*D1**2*K*Pk2*fdd*r + 28*D1**2*K*Pk2*fdd + 35*D1**2*K*Pkdd2*fd*k1**2*s**2 + 14*D1**2*Pk2*bdd1*(f*(6*r**2 + 3*r*(5*s - 3) - 5*s + 2) + 5*r*(3*s - 1) - 5*s) - 96*D1**2*Pk2*f*fd*r**2 - 84*D1**2*Pk2*f*fd*r*s + 96*D1**2*Pk2*f*fd*r + 42*D1**2*Pk2*f*fd*s - 48*D1**2*Pk2*f*fd + 48*D1**2*Pk2*f*fdd*r**2 + 84*D1**2*Pk2*f*fdd*r*s - 48*D1**2*Pk2*f*fdd*r - 42*D1**2*Pk2*f*fdd*s + 24*D1**2*Pk2*f*fdd + 48*D1**2*Pk2*fd**2*r**2 + 84*D1**2*Pk2*fd**2*r*s - 48*D1**2*Pk2*fd**2*r - 42*D1**2*Pk2*fd**2*s + 14*D1**2*Pk2*fd*r**2 - 14*D1**2*Pk2*fd*r*s - 28*D1**2*Pk2*fd*r + 14*D1**2*Pk2*fd*s + 14*D1**2*Pk2*fd + 28*D1**2*Pk2*fdd*r**2 + 42*D1**2*Pk2*fdd*r*s - 56*D1**2*Pk2*fdd*r - 42*D1**2*Pk2*fdd*s + 28*D1**2*Pk2*fdd + 420*D1**2*Pk2*gd2*r**2 + 105*D1**2*Pkdd2*bd2*k1**2*s**2 + 42*D1**2*Pkdd2*f*fd*k1**2*s**2 + 35*D1**2*Pkdd2*fd*k1**2*s**2 - 210*D1**2*Pkdd2*gd2*k1**2*s**2 - 504*D1*Dd*K*Pk2*f*r**2 + 252*D1*Dd*K*Pk2*f*r - 126*D1*Dd*K*Pk2*f + 224*D1*Dd*K*Pk2*fd*r**2 - 280*D1*Dd*K*Pk2*fd*r + 56*D1*Dd*K*Pk2*fd + 140*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 70*D1*Dd*K*Pkdd2*f*k1**2*s + 35*D1*Dd*K*Pkdd2*f*k1**2 - 192*D1*Dd*Pk2*f**2*r**2 - 168*D1*Dd*Pk2*f**2*r*s + 138*D1*Dd*Pk2*f**2*r + 42*D1*Dd*Pk2*f**2*s - 48*D1*Dd*Pk2*f**2 + 384*D1*Dd*Pk2*f*fd*r**2 + 672*D1*Dd*Pk2*f*fd*r*s - 372*D1*Dd*Pk2*f*fd*r - 252*D1*Dd*Pk2*f*fd*s + 90*D1*Dd*Pk2*f*fd + 56*D1*Dd*Pk2*f*r**2 - 56*D1*Dd*Pk2*f*r*s - 14*D1*Dd*Pk2*f*r + 14*D1*Dd*Pk2*f*s + 14*D1*Dd*Pk2*f + 224*D1*Dd*Pk2*fd*r**2 + 336*D1*Dd*Pk2*fd*r*s - 322*D1*Dd*Pk2*fd*r - 210*D1*Dd*Pk2*fd*s + 98*D1*Dd*Pk2*fd + 1680*D1*Dd*Pk2*g2*r**2 - 840*D1*Dd*Pk2*g2*r + 420*D1*Dd*Pk2*g2 + 420*D1*Dd*Pkdd2*b2*k1**2*s**2 - 210*D1*Dd*Pkdd2*b2*k1**2*s + 105*D1*Dd*Pkdd2*b2*k1**2 + 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 42*D1*Dd*Pkdd2*f**2*k1**2*s + 21*D1*Dd*Pkdd2*f**2*k1**2 + 140*D1*Dd*Pkdd2*f*k1**2*s**2 - 70*D1*Dd*Pkdd2*f*k1**2*s + 35*D1*Dd*Pkdd2*f*k1**2 - 840*D1*Dd*Pkdd2*g2*k1**2*s**2 + 420*D1*Dd*Pkdd2*g2*k1**2*s - 210*D1*Dd*Pkdd2*g2*k1**2 + 112*D1*Ddd*K*Pk2*f*r**2 - 56*D1*Ddd*K*Pk2*f*r + 28*D1*Ddd*K*Pk2*f + 96*D1*Ddd*Pk2*f**2*r**2 + 168*D1*Ddd*Pk2*f**2*r*s - 90*D1*Ddd*Pk2*f**2*r - 42*D1*Ddd*Pk2*f**2*s + 24*D1*Ddd*Pk2*f**2 + 112*D1*Ddd*Pk2*f*r**2 + 168*D1*Ddd*Pk2*f*r*s - 98*D1*Ddd*Pk2*f*r - 42*D1*Ddd*Pk2*f*s + 28*D1*Ddd*Pk2*f - 7*D1*bd1*(D1*(2*Pk2*(15*K*(3*r**2 - 2*r + 1) + f*(12*r**2 + r*(15*s - 13) - 5*s + 4) - 12*fd*r**2 - 30*fd*r*s + 9*fd*r + 5*fd*s - 45*r**2 - 15*r*s + 35*r + 5*s - 15) + Pkdd2*k1**2*(-15*K - 5*f - 15)*(3*s**2 - 2*s + 1)) - 2*Dd*Pk2*(f*(48*r**2 + 3*r*(40*s - 21) - 35*s + 14) + 5*r*(24*s - 7) - 35*s + 10)) + 336*Dd**2*K*Pk2*f*r**2 - 168*Dd**2*K*Pk2*f*r + 288*Dd**2*Pk2*f**2*r**2 + 504*Dd**2*Pk2*f**2*r*s - 270*Dd**2*Pk2*f**2*r - 126*Dd**2*Pk2*f**2*s + 42*Dd**2*Pk2*f**2 + 336*Dd**2*Pk2*f*r**2 + 504*Dd**2*Pk2*f*r*s - 294*Dd**2*Pk2*f*r - 126*Dd**2*Pk2*f*s + 42*Dd**2*Pk2*f) + b1*(56*D1**2*K*Pk2*bdd1*f*r**2 + 14*D1**2*Pk2*bd1**2*(f*(12*r**2 + 6*r*(5*s - 3) - 10*s + 5) + 5*r*(6*s - 2) - 10*s + 5) - 56*D1**2*Pk2*bd2*f*r**2 + 56*D1**2*Pk2*bd2*fd*r**2 - 56*D1**2*Pk2*bd2*fd*r + 48*D1**2*Pk2*bdd1*f**2*r**2 + 84*D1**2*Pk2*bdd1*f**2*r*s - 42*D1**2*Pk2*bdd1*f**2*r + 56*D1**2*Pk2*bdd1*f*r**2 + 84*D1**2*Pk2*bdd1*f*r*s - 42*D1**2*Pk2*bdd1*f*r + 28*D1**2*Pk2*bdd2*f*r**2 + 252*D1**2*Pk2*f*gd2*r**2 - 56*D1**2*Pk2*f*gdd2*r**2 + 252*D1**2*Pk2*fd*g2*r**2 - 504*D1**2*Pk2*fd*g2*r + 252*D1**2*Pk2*fd*g2 - 112*D1**2*Pk2*fd*gd2*r**2 + 112*D1**2*Pk2*fd*gd2*r - 56*D1**2*Pk2*fdd*g2*r**2 + 112*D1**2*Pk2*fdd*g2*r - 56*D1**2*Pk2*fdd*g2 + 35*D1**2*Pkdd2*bd2*f*k1**2*s**2 - 70*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 70*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 224*D1*Dd*Pk2*bd2*f*r**2 - 56*D1*Dd*Pk2*bd2*f*r + 1008*D1*Dd*Pk2*f*g2*r**2 - 504*D1*Dd*Pk2*f*g2*r + 252*D1*Dd*Pk2*f*g2 - 448*D1*Dd*Pk2*f*gd2*r**2 + 112*D1*Dd*Pk2*f*gd2*r - 448*D1*Dd*Pk2*fd*g2*r**2 + 560*D1*Dd*Pk2*fd*g2*r - 112*D1*Dd*Pk2*fd*g2 - 280*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 140*D1*Dd*Pkdd2*f*g2*k1**2*s - 70*D1*Dd*Pkdd2*f*g2*k1**2 - 224*D1*Ddd*Pk2*f*g2*r**2 + 112*D1*Ddd*Pk2*f*g2*r - 56*D1*Ddd*Pk2*f*g2 + D1*bd1*(D1*(-252*K*Pk2*f*r**2 + 70*K*Pkdd2*f*k1**2*s**2 - 70*K*Pkdd2*f*k1**2*s + 35*K*Pkdd2*f*k1**2 - 96*Pk2*f**2*r**2 - 84*Pk2*f**2*r*s + 42*Pk2*f**2*r + 28*Pk2*f*r**2 - 28*Pk2*f*r*s + 14*Pk2*f*r + 2*Pk2*fd*(3*f*(32*r**2 + r*(56*s - 30) - 14*s + 7) + 7*r**2*(8*K + 8) + 7*r*(-8*K + 12*s - 11) - 42*s + 21) + 210*Pkdd2*b2*k1**2*s**2 - 210*Pkdd2*b2*k1**2*s + 105*Pkdd2*b2*k1**2 + 42*Pkdd2*f**2*k1**2*s**2 - 42*Pkdd2*f**2*k1**2*s + 21*Pkdd2*f**2*k1**2 + 70*Pkdd2*f*k1**2*s**2 - 70*Pkdd2*f*k1**2*s + 35*Pkdd2*f*k1**2 + 210*g2*(Pk2*(4*r**2 - 4*r + 2) + Pkdd2*k1**2*(-2*s**2 + 2*s - 1))) + 2*Dd*Pk2*f*(3*f*(64*r**2 + 2*r*(56*s - 29) - 14*s + 7) + 7*r**2*(32*K + 32) + 7*r*(-8*K + 48*s - 26) - 42*s + 21)) - 672*Dd**2*Pk2*f*g2*r**2 + 336*Dd**2*Pk2*f*g2*r - 7*b2*(D1**2*(-4*Pk2*fdd*(r - 1)**2 + fd*(8*Pk2*(r - 1)**2 - 5*Pkdd2*k1**2*s**2)) + D1*(Dd*(8*Pk2*f*(4*r**2 - 2*r + 1) - 8*Pk2*fd*(4*r**2 - 5*r + 1) - 5*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 4*Ddd*Pk2*f*(4*r**2 - 2*r + 1)) + 24*Dd**2*Pk2*f*r*(1 - 2*r))))/(210*d**2*k1**2) + D1**2*Pk2*Pkd1*ct**7*k2**3*(4*C - 4)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 81*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 450*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 75*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 735*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 140*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 135*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 105*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 405*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 45*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 315*Dd**2*f**3*r + 105*Dd**2*f**3*s - 35*Dd**2*f**3)/(315*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**7*k2*(8*C - 8)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct**6*f*(11*D1*bd1*f*(D1*(5*f*s*(r - 1) - 7*fd*(6*r*s - r - 3*s + 1)) - 7*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 11*b1*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(5*f*fd - 7*f*fdd - 14*fd**2) + 7*Ddd*f**2*(4*r*s - r - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 7*f*(D1*Dd*f*(7*f*(-4*r*s + r + s) + 18*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(7*f*fd*(-4*r*s + r + s) + f*(11*bdd1*s*(r - 1) + 9*fdd*r*(4*s - 1) - 9*fdd*s) + 9*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 9*Ddd*f**2*(r*(4*s - 1) - s)) + 9*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1) + D1**2*Pk2*Pkd1*ct**6*k1*k2**2*(12*C - 14)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 81*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 450*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 75*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 735*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 140*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 135*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 105*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 405*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 45*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 315*Dd**2*f**3*r + 105*Dd**2*f**3*s - 35*Dd**2*f**3)/(315*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**6*k1*(16*C - 20)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) - 2*D1**2*Pk2*Pkd1*ct**6*k2**4*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 81*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 450*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 75*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 735*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 140*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 135*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 105*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 405*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 45*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 315*Dd**2*f**3*r + 105*Dd**2*f**3*s - 35*Dd**2*f**3)/(315*d**2*k1*k3**4) + 2*D1**2*Pk2*Pkd1*ct**6*k2**2*(90*C*D1**2*b1*f*fd*r**2 + 18*C*D1**2*b1*f*fdd*r**2 + 18*C*D1**2*b1*fd**2*r**2 - 15*C*D1**2*f**2*fd*r**2 + 10*C*D1**2*f**2*fd*r - 5*C*D1**2*f**2*fd + 75*C*D1**2*f**2*fdd*r**2 - 50*C*D1**2*f**2*fdd*r + 25*C*D1**2*f**2*fdd + 150*C*D1**2*f*fd**2*r**2 - 100*C*D1**2*f*fd**2*r + 180*C*D1*Dd*b1*f**2*r**2 - 90*C*D1*Dd*b1*f**2*r + 45*C*D1*Dd*b1*f**2 + 144*C*D1*Dd*b1*f*fd*r**2 - 36*C*D1*Dd*b1*f*fd*r - 20*C*D1*Dd*f**3*r**2 + 10*C*D1*Dd*f**3*r - 5*C*D1*Dd*f**3 + 600*C*D1*Dd*f**2*fd*r**2 - 350*C*D1*Dd*f**2*fd*r + 50*C*D1*Dd*f**2*fd + 36*C*D1*Ddd*b1*f**2*r**2 - 18*C*D1*Ddd*b1*f**2*r + 9*C*D1*Ddd*b1*f**2 + 100*C*D1*Ddd*f**3*r**2 - 50*C*D1*Ddd*f**3*r + 25*C*D1*Ddd*f**3 + 108*C*Dd**2*b1*f**2*r**2 - 54*C*Dd**2*b1*f**2*r + 300*C*Dd**2*f**3*r**2 - 150*C*Dd**2*f**3*r - 90*D1**2*b1*f*fd*r**2 - 54*D1**2*b1*f*fd*r*s + 27*D1**2*b1*f*fd*r - 18*D1**2*b1*f*fdd*r**2 + 90*D1**2*b1*f*fdd*r*s - 45*D1**2*b1*f*fdd*r - 18*D1**2*b1*fd**2*r**2 + 90*D1**2*b1*fd**2*r*s - 45*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(r - 1)*(C*(r - 1) - r + 5*s + 1) + 15*D1**2*f**2*fd*r**2 - 75*D1**2*f**2*fd*r*s + 15*D1**2*f**2*fd*r + 25*D1**2*f**2*fd*s + 5*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 105*D1**2*f**2*fdd*r*s + 15*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 210*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r - 70*D1**2*f*fd**2*s + 35*D1**2*f*fd**2 - 180*D1*Dd*b1*f**2*r**2 - 108*D1*Dd*b1*f**2*r*s + 117*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2*s - 45*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 + 720*D1*Dd*b1*f*fd*r*s - 234*D1*Dd*b1*f*fd*r - 90*D1*Dd*b1*f*fd*s + 45*D1*Dd*b1*f*fd + 20*D1*Dd*f**3*r**2 - 100*D1*Dd*f**3*r*s + 15*D1*Dd*f**3*r + 25*D1*Dd*f**3*s + 5*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 840*D1*Dd*f**2*fd*r*s + 105*D1*Dd*f**2*fd*r - 245*D1*Dd*f**2*fd*s + 20*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 + 180*D1*Ddd*b1*f**2*r*s - 27*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2*s - 9*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 140*D1*Ddd*f**3*r*s + 15*D1*Ddd*f**3*r - 35*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(f*(r - 1)*(5*C*(r - 1) - 5*r - 3*s + 5) + fd*(r**2*(4*C - 4) + r*(-4*C + 20*s - 1) - 10*s + 5)) + Dd*f*(2*C*(4*r**2 - 5*r + 1) - 8*r**2 + 40*r*s + 5*r - 25*s + 3)) - 108*Dd**2*b1*f**2*r**2 + 540*Dd**2*b1*f**2*r*s - 81*Dd**2*b1*f**2*r - 135*Dd**2*b1*f**2*s + 45*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 + 420*Dd**2*f**3*r*s + 45*Dd**2*f**3*r - 105*Dd**2*f**3*s + 35*Dd**2*f**3)/(315*d**2*k1*k3**2) - 2*D1**2*Pk2*Pkd1*ct**5*f*k2*(132*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*fd**2*r**2 - 22*D1**2*bdd1*f**2*(r - 1)**2 + 56*D1**2*f**2*fd*r**2 - 28*D1**2*f**2*fd*r + 14*D1**2*f**2*fd - 28*D1**2*f**2*fdd*r**2 + 14*D1**2*f**2*fdd*r - 7*D1**2*f**2*fdd - 84*D1**2*f*fd**2*r**2 + 42*D1**2*f*fd**2*r + 176*D1*Dd*b1*f**2*r**2 - 88*D1*Dd*b1*f**2*r + 44*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 56*D1*Dd*f**3*r**2 - 28*D1*Dd*f**3*r + 14*D1*Dd*f**3 - 224*D1*Dd*f**2*fd*r**2 + 112*D1*Dd*f**2*fd*r - 14*D1*Dd*f**2*fd - 88*D1*Ddd*b1*f**2*r**2 + 44*D1*Ddd*b1*f**2*r - 22*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 + 14*D1*Ddd*f**3*r - 7*D1*Ddd*f**3 + 44*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 264*Dd**2*b1*f**2*r**2 + 132*Dd**2*b1*f**2*r - 84*Dd**2*f**3*r**2 + 42*Dd**2*f**3*r)/(693*d**2*k1**2) + D1**2*Pk2*Pkd1*ct**5*k1**2*k2*(4*C - 6)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 81*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 450*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 75*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 735*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 140*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 135*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 105*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 405*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 45*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 315*Dd**2*f**3*r + 105*Dd**2*f**3*s - 35*Dd**2*f**3)/(105*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**5*k1**2*(8*C - 16)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k2*k3**2) + D1**2*Pk2*Pkd1*ct**5*k2**3*st**2*(8*C - 8)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 69*D1**2*f**2*fd*r**2 + 69*D1**2*f**2*fd*r*s - 69*D1**2*f**2*fd*r - 23*D1**2*f**2*fd*s + 23*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 81*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 450*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 92*D1*Dd*f**3*r**2 + 92*D1*Dd*f**3*r*s - 69*D1*Dd*f**3*r - 23*D1*Dd*f**3*s + 23*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 525*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s - 100*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 135*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 75*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 405*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 45*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 225*Dd**2*f**3*r + 75*Dd**2*f**3*s - 25*Dd**2*f**3)/(315*d**2*k3**4) + 2*D1**2*Pk2*Pkd1*ct**5*k2**3*(42*D1*b1*bd1*(C - 1)*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 42*b1**2*(C - 1)*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) - 9*b1*(14*D1**2*bdd1*f*(C - 1)*(2*r - 1)*(r + s - 1) + D1**2*(f*(3*fd - 5*fdd)*(2*C*(r + s - 1) + 10*r**2 + r*(10*s - 7) - 2*s + 2) - 5*fd**2*(10*r**2 + r*(2*C + 10*s - 7) + s*(2*C - 2))) + 5*D1*f*(Dd*(3*f*(4*r**2 + 4*r*s - 3*r - s + 1) - fd*(4*C + 40*r - 9)*(2*r + 2*s - 1)) - 5*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 25*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + f*(-126*D1**2*bd1**2*(C - 1)*(2*r - 1)*(r + s - 1) - 45*D1**2*bdd1*f*(2*C - 5*r + 3)*(r + s - 1) + 9*D1*bd1*(D1*(3*f*(2*C - 5*r + 3)*(r + s - 1) + 5*fd*(20*r**2 + r*(-2*C + 20*s - 23) - s*(2*C + 8) + 5)) + 5*Dd*f*(C*(-8*r - 8*s + 4) + 40*r**2 + r*(40*s - 47) - 17*s + 11)) - 5*(2*C + 3)*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 7*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + r*(4*s - 3) - s + 1) - 7*fd*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)) - 7*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 7*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1))))/(315*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**5*k2*st**2*(16*C - 16)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(23*f*(4*r*s - r - s) - 25*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(r*(3*s - 1) - s) + 5*f*(-9*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(-4*r*s + r + s)) - 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) + 2*D1**2*Pk2*Pkd1*ct**5*k2*(-126*D1**2*bd1**2*f*(C - 1)*(r*(2*s - 1) - s + 1) + 3*D1*bd1*(-14*b1*(C - 1)*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) - 3*f*(D1*(f*(C*(4*r**2 + r*(34*s - 2) - 40*s + 4) - 3*r**2 - 22*r*s + 28*s - 3) + 2*fd*(C*(-32*r**2 + r*(46 - 76*s) + 43*s - 19) + 38*r**2 + 6*r*(6*s - 7) - 23*s + 9)) - 2*Dd*f*(C*(64*r**2 + r*(152*s - 79) - 115*s + 35) - 76*r**2 + r*(84 - 72*s) + 65*s - 28))) - 42*b1**2*(C - 1)*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) - 9*b1*(2*D1**2*(7*bdd1*f*(C - 1)*(r*(2*s - 1) - s) + f*(fd*(r**2*(4*C - 3) + 2*r*(17*C*s - 10*C - 11*s + 7) + s*(3*C - 3)) + fdd*(r**2*(19 - 16*C) - 2*r*(19*C*s - 12*C - 9*s + 7) - s*(5*C - 5))) + fd**2*(r**2*(19 - 16*C) - 2*r*(19*C*s - 12*C - 9*s + 7) - s*(5*C - 5))) + D1*f*(Dd*(f*(2*C*(8*r**2 + r*(68*s - 21) - 17*s + 2) - 12*r**2 + r*(28 - 88*s) + 22*s - 3) + 2*fd*(C*(-128*r**2 + r*(166 - 304*s) + 18*s - 19) + 152*r**2 + 16*r*(9*s - 7) + 2*s + 9)) + Ddd*f*(-2*C*(32*r**2 + r*(76*s - 35) - 19*s + 8) + 76*r**2 + 8*r*(9*s - 7) - 18*s + 19)) - 2*Dd**2*f**2*(C*(96*r**2 + 3*r*(76*s - 35) - 57*s + 19) - 114*r**2 - 12*r*(9*s - 7) + 27*s - 9)) + f*(9*D1**2*bdd1*f*(2*C*(8*r**2 + r*(19*s - 11) - 24*s + 8) - 19*r**2 + r*(28 - 18*s) + 28*s - 19) - 5*D1**2*(f*(fd*(4*C*(15*r**2 + 6*r*(7*s - 4) - 14*s + 5) - 69*r**2 - 108*r*s + 82*r + 36*s - 23) - 2*fdd*(2*C*(21*r**2 + 6*r*(8*s - 5) - 16*s + 7) - 51*r**2 - 54*r*s + 52*r + 18*s - 17)) - 4*fd**2*(2*C*(21*r**2 + 6*r*(8*s - 5) - 16*s + 8) - 51*r**2 - 54*r*s + 52*r + 18*s - 9)) - 5*D1*f*(Dd*(f*(4*C*(20*r**2 + 8*r*(7*s - 3) - 14*s + 5) - 92*r**2 - 144*r*s + 82*r + 36*s - 23) - 4*fd*(2*C*(84*r**2 + 3*r*(64*s - 35) - 56*s + 23) - 204*r**2 - 216*r*s + 182*r + 63*s - 35)) - 2*Ddd*f*(2*C*(28*r**2 + 64*r*s - 30*r - 16*s + 7) - 68*r**2 - 72*r*s + 52*r + 18*s - 17)) + 20*Dd**2*f**2*(2*C*(42*r**2 + 96*r*s - 45*r - 24*s + 8) - 102*r**2 - 108*r*s + 78*r + 27*s - 9)))/(315*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct**5*(495*D1**2*K*bdd1*f**2*r*s - 99*D1**2*bd1**2*f*s*(2*r - 1)*(-7*K + 5*f + 7) - 1155*D1**2*bdd1*f**3*r*s + 770*D1**2*bdd1*f**3*s - 495*D1**2*bdd1*f**2*r*s - 1386*D1**2*bdd1*f*g2*r*s + 1386*D1**2*bdd1*f*g2*s + 1960*D1**2*f**3*fd*r*s - 490*D1**2*f**3*fd*r - 490*D1**2*f**3*fd*s - 2520*D1**2*f**3*fdd*r*s + 630*D1**2*f**3*fdd*r + 630*D1**2*f**3*fdd*s - 7560*D1**2*f**2*fd**2*r*s + 1890*D1**2*f**2*fd**2*r + 1890*D1**2*f**2*fd**2*s - 630*D1**2*f**2*fd**2 + 594*D1**2*f**2*gd2*r*s - 990*D1**2*f**2*gdd2*r*s + 1188*D1**2*f*fd*g2*r*s - 594*D1**2*f*fd*g2*r - 594*D1**2*f*fd*g2*s - 3960*D1**2*f*fd*gd2*r*s + 990*D1**2*f*fd*gd2*r + 990*D1**2*f*fd*gd2*s - 1980*D1**2*f*fdd*g2*r*s + 990*D1**2*f*fdd*g2*r + 990*D1**2*f*fdd*g2*s - 1980*D1**2*fd**2*g2*r*s + 990*D1**2*fd**2*g2*r + 990*D1**2*fd**2*g2*s - 990*D1**2*fd**2*g2 + 1960*D1*Dd*f**4*r*s - 490*D1*Dd*f**4*r - 490*D1*Dd*f**4*s - 20160*D1*Dd*f**3*fd*r*s + 5040*D1*Dd*f**3*fd*r + 5040*D1*Dd*f**3*fd*s - 1260*D1*Dd*f**3*fd + 2376*D1*Dd*f**2*g2*r*s - 594*D1*Dd*f**2*g2*r - 594*D1*Dd*f**2*g2*s - 7920*D1*Dd*f**2*gd2*r*s + 990*D1*Dd*f**2*gd2*r + 990*D1*Dd*f**2*gd2*s - 15840*D1*Dd*f*fd*g2*r*s + 5940*D1*Dd*f*fd*g2*r + 5940*D1*Dd*f*fd*g2*s - 1980*D1*Dd*f*fd*g2 - 2520*D1*Ddd*f**4*r*s + 630*D1*Ddd*f**4*r + 630*D1*Ddd*f**4*s - 3960*D1*Ddd*f**2*g2*r*s + 990*D1*Ddd*f**2*g2*r + 990*D1*Ddd*f**2*g2*s + 11*D1*bd1*(D1*(25*f**3*s*(3*r - 2) + f**2*(-35*fd*(18*r*s - 3*r - 7*s + 2) + r*s*(27 - 27*K)) + 45*f*fd*(K - 1)*(r*(4*s - 1) - s) + 42*f*s*(g2*(r - 1) - 6*gd2*r + 3*gd2) - 126*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-35*f**2*(24*r*s - 3*r - 11*s + 2) + 45*f*(K - 1)*(8*r*s - r - s) - 126*g2*(8*r*s - r - 5*s + 1))) - 7560*Dd**2*f**4*r*s + 1890*Dd**2*f**4*r + 1890*Dd**2*f**4*s - 630*Dd**2*f**4 - 11880*Dd**2*f**2*g2*r*s + 2970*Dd**2*f**2*g2*r + 2970*Dd**2*f**2*g2*s - 990*Dd**2*f**2*g2 - 33*b1**2*(D1*Dd*(-f*(r*(4*s - 1) - s)*(-7*K + 9*f + 7) + 3*fd*(5*f*(16*r*s - 6*r - 2*s + 1) + (7 - 7*K)*(8*r*s - 5*r - s + 1))) + D1*(D1*r*(f*fd*(9 - 18*s) + 15*f*fdd*(2*s - 1) + 15*fd**2*(2*s - 1) + 7*fd*(K - 1)*(s - 1) + 21*fdd*(-K*s + K + s - 1)) + 3*Ddd*f*(r*(4*s - 1) - s)*(-7*K + 5*f + 7)) + 3*Dd**2*f*(-7*K + 5*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*(D1*Dd*(75*f**3*(r*(4*s - 1) - s) + f**2*(-35*fd*(3*r*(24*s - 7) - 13*s + 4) + (27 - 27*K)*(r*(4*s - 1) - s)) + 6*f*(15*fd*(K - 1)*(r*(8*s - 3) - 3*s + 1) + 7*g2*r*(4*s - 1) - 7*g2*s + 21*gd2*(-8*r*s + r + s)) - 126*fd*g2*(r*(8*s - 5) - s + 1)) + 3*D1*bd1*(D1*(-15*f*fd*(r*(8*s - 2) - 2*s + 1) + f*s*(2*r - 1)*(-7*K + 9*f + 7) + 21*fd*(K - 1)*(r*(4*s - 2) - s + 1)) - 3*Dd*f*(-7*K + 5*f + 7)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(-5*f**2*(9*bdd1*s*(2*r - 1) + 7*fdd*r*(9*s - 3) - 7*fdd*s) + 3*f*(15*fdd*(K - 1)*(r*(2*s - 1) - s) + s*(21*bdd1*(K - 1)*(2*r - 1) + 7*r*(2*gd2 - 6*gdd2))) - 5*fd**2*(7*f*(6*r*(3*s - 1) - 2*s + 1) + (9 - 9*K)*(r*(2*s - 1) - s + 1)) + fd*(25*f**2*(r*(9*s - 3) - s) - 27*f*(K - 1)*(r*(2*s - 1) - s) + 42*r*(g2*(s - 1) - 6*gd2*s + 3*gd2)) - 126*fdd*g2*r*(s - 1)) - 3*Ddd*f*(r*(4*s - 1) - s)*(35*f**2 - 15*f*(K - 1) + 42*g2)) - 3*Dd**2*f*(35*f**2 - 15*f*(K - 1) + 42*g2)*(3*r*(4*s - 1) - 3*s + 1)))/(3465*d**2*k2) - 2*D1**2*Pk2*Pkd1*ct**5*k2**3*(72*D1**2*b1*f*fd*r**2 - 36*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*fd**2*r**2 - 18*D1**2*bdd1*f**2*(r - 1)**2 + 30*D1**2*f**2*fd*r**2 - 20*D1**2*f**2*fd*r + 10*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 + 10*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 + 20*D1**2*f*fd**2*r + 144*D1*Dd*b1*f**2*r**2 - 72*D1*Dd*b1*f**2*r + 36*D1*Dd*b1*f**2 - 288*D1*Dd*b1*f*fd*r**2 + 72*D1*Dd*b1*f*fd*r + 40*D1*Dd*f**3*r**2 - 20*D1*Dd*f**3*r + 10*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 + 70*D1*Dd*f**2*fd*r - 10*D1*Dd*f**2*fd - 72*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r - 18*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 + 10*D1*Ddd*f**3*r - 5*D1*Ddd*f**3 + 36*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 216*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r - 60*Dd**2*f**3*r**2 + 30*Dd**2*f**3*r)/(315*d**2*k1**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct**4*f*st**2*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(6*r*s - r - 3*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(4*f*fd - 5*f*fdd - 10*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(2*D1*Dd*f*(10*f*(-4*r*s + r + s) + 21*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(20*f*fd*(-4*r*s + r + s) + 3*f*(11*bdd1*s*(r - 1) + 7*fdd*r*(4*s - 1) - 7*fdd*s) + 21*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 21*Ddd*f**2*(r*(4*s - 1) - s)) + 21*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1) + D1**2*Pk2*Pkd1*ct**4*k1**3*(4*C - 10)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 81*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 450*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 75*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 735*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 140*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 135*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 105*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 405*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 45*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 315*Dd**2*f**3*r + 105*Dd**2*f**3*s - 35*Dd**2*f**3)/(315*d**2*k3**4) - 4*D1**2*Pk2*Pkd1*ct**4*k1**3*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k2**2*k3**2) + 4*D1**2*Pk2*Pkd1*ct**4*k1*k2**2*st**2*(144*C*D1**2*b1*f*fd*r**2 + 144*C*D1**2*b1*f*fd*r*s - 72*C*D1**2*b1*f*fd*r - 324*C*D1**2*b1*f*fdd*r**2 - 324*C*D1**2*b1*f*fdd*r*s + 162*C*D1**2*b1*f*fdd*r - 324*C*D1**2*b1*fd**2*r**2 - 324*C*D1**2*b1*fd**2*r*s + 162*C*D1**2*b1*fd**2*r + 216*C*D1**2*f**2*fd*r**2 + 216*C*D1**2*f**2*fd*r*s - 216*C*D1**2*f**2*fd*r - 72*C*D1**2*f**2*fd*s + 72*C*D1**2*f**2*fd - 270*C*D1**2*f**2*fdd*r**2 - 270*C*D1**2*f**2*fdd*r*s + 270*C*D1**2*f**2*fdd*r + 90*C*D1**2*f**2*fdd*s - 90*C*D1**2*f**2*fdd - 540*C*D1**2*f*fd**2*r**2 - 540*C*D1**2*f*fd**2*r*s + 540*C*D1**2*f*fd**2*r + 180*C*D1**2*f*fd**2*s - 90*C*D1**2*f*fd**2 + 288*C*D1*Dd*b1*f**2*r**2 + 288*C*D1*Dd*b1*f**2*r*s - 216*C*D1*Dd*b1*f**2*r - 72*C*D1*Dd*b1*f**2*s + 72*C*D1*Dd*b1*f**2 - 2592*C*D1*Dd*b1*f*fd*r**2 - 2592*C*D1*Dd*b1*f*fd*r*s + 1620*C*D1*Dd*b1*f*fd*r + 324*C*D1*Dd*b1*f*fd*s - 162*C*D1*Dd*b1*f*fd + 288*C*D1*Dd*f**3*r**2 + 288*C*D1*Dd*f**3*r*s - 216*C*D1*Dd*f**3*r - 72*C*D1*Dd*f**3*s + 72*C*D1*Dd*f**3 - 2160*C*D1*Dd*f**2*fd*r**2 - 2160*C*D1*Dd*f**2*fd*r*s + 1890*C*D1*Dd*f**2*fd*r + 630*C*D1*Dd*f**2*fd*s - 360*C*D1*Dd*f**2*fd - 648*C*D1*Ddd*b1*f**2*r**2 - 648*C*D1*Ddd*b1*f**2*r*s + 486*C*D1*Ddd*b1*f**2*r + 162*C*D1*Ddd*b1*f**2*s - 162*C*D1*Ddd*b1*f**2 - 360*C*D1*Ddd*f**3*r**2 - 360*C*D1*Ddd*f**3*r*s + 270*C*D1*Ddd*f**3*r + 90*C*D1*Ddd*f**3*s - 90*C*D1*Ddd*f**3 - 1944*C*Dd**2*b1*f**2*r**2 - 1944*C*Dd**2*b1*f**2*r*s + 1458*C*Dd**2*b1*f**2*r + 486*C*Dd**2*b1*f**2*s - 162*C*Dd**2*b1*f**2 - 1080*C*Dd**2*f**3*r**2 - 1080*C*Dd**2*f**3*r*s + 810*C*Dd**2*f**3*r + 270*C*Dd**2*f**3*s - 90*C*Dd**2*f**3 - 198*D1**2*b1*f*fd*r**2 - 198*D1**2*b1*f*fd*r*s + 99*D1**2*b1*f*fd*r + 414*D1**2*b1*f*fdd*r**2 + 414*D1**2*b1*f*fdd*r*s - 207*D1**2*b1*f*fdd*r + 414*D1**2*b1*fd**2*r**2 + 414*D1**2*b1*fd**2*r*s - 207*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(18*C - 23)*(r - 1)*(r + s - 1) - 285*D1**2*f**2*fd*r**2 - 285*D1**2*f**2*fd*r*s + 285*D1**2*f**2*fd*r + 95*D1**2*f**2*fd*s - 95*D1**2*f**2*fd + 345*D1**2*f**2*fdd*r**2 + 345*D1**2*f**2*fdd*r*s - 345*D1**2*f**2*fdd*r - 115*D1**2*f**2*fdd*s + 115*D1**2*f**2*fdd + 690*D1**2*f*fd**2*r**2 + 690*D1**2*f*fd**2*r*s - 690*D1**2*f*fd**2*r - 230*D1**2*f*fd**2*s + 115*D1**2*f*fd**2 - 396*D1*Dd*b1*f**2*r**2 - 396*D1*Dd*b1*f**2*r*s + 297*D1*Dd*b1*f**2*r + 99*D1*Dd*b1*f**2*s - 99*D1*Dd*b1*f**2 + 3312*D1*Dd*b1*f*fd*r**2 + 3312*D1*Dd*b1*f*fd*r*s - 2070*D1*Dd*b1*f*fd*r - 414*D1*Dd*b1*f*fd*s + 207*D1*Dd*b1*f*fd - 380*D1*Dd*f**3*r**2 - 380*D1*Dd*f**3*r*s + 285*D1*Dd*f**3*r + 95*D1*Dd*f**3*s - 95*D1*Dd*f**3 + 2760*D1*Dd*f**2*fd*r**2 + 2760*D1*Dd*f**2*fd*r*s - 2415*D1*Dd*f**2*fd*r - 805*D1*Dd*f**2*fd*s + 460*D1*Dd*f**2*fd + 828*D1*Ddd*b1*f**2*r**2 + 828*D1*Ddd*b1*f**2*r*s - 621*D1*Ddd*b1*f**2*r - 207*D1*Ddd*b1*f**2*s + 207*D1*Ddd*b1*f**2 + 460*D1*Ddd*f**3*r**2 + 460*D1*Ddd*f**3*r*s - 345*D1*Ddd*f**3*r - 115*D1*Ddd*f**3*s + 115*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(f*(8*C - 11)*(r - 1)*(r + s - 1) - fd*(18*C - 23)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(18*C - 23)*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 2484*Dd**2*b1*f**2*r**2 + 2484*Dd**2*b1*f**2*r*s - 1863*Dd**2*b1*f**2*r - 621*Dd**2*b1*f**2*s + 207*Dd**2*b1*f**2 + 1380*Dd**2*f**3*r**2 + 1380*Dd**2*f**3*r*s - 1035*Dd**2*f**3*r - 345*Dd**2*f**3*s + 115*Dd**2*f**3)/(315*d**2*k3**4) + 2*D1**2*Pk2*Pkd1*ct**4*k1*k2**2*(7*b1**2*(6*C - 7)*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(-21*D1**2*bdd1*f*(6*C - 7)*(2*r - 1)*(r + s - 1) - 3*D1**2*(f*(3*fd - 5*fdd)*(6*C*(r + s - 1) + 20*r**2 + r*(20*s - 17) - 7*s + 7) - 5*fd**2*(20*r**2 + r*(6*C + 20*s - 17) + s*(6*C - 7))) + 7*D1*bd1*(6*C - 7)*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 30*D1*f*(Dd*(3*f*(4*r**2 + 4*r*s - 3*r - s + 1) - 2*fd*(3*C + 20*r - 6)*(2*r + 2*s - 1)) - 5*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 150*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + f*(-21*D1**2*bd1**2*(6*C - 7)*(2*r - 1)*(r + s - 1) - 15*D1**2*bdd1*f*(6*C - 10*r + 3)*(r + s - 1) + 3*D1*bd1*(D1*(3*f*(6*C - 10*r + 3)*(r + s - 1) + 5*fd*(-6*C*s + 40*r**2 + r*(-6*C + 40*s - 43) - 13*s + 10)) - 10*Dd*f*(6*C*(2*r + 2*s - 1) - 40*r**2 - 40*r*s + 41*r + 11*s - 8)) - 5*(2*C + 1)*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 7*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + r*(4*s - 3) - s + 1) - 7*fd*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)) - 7*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 7*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1))))/(105*d**2*k3**4) + 8*D1**2*Pk2*Pkd1*ct**4*k1*st**2*(9*D1*bd1*f*(D1*(f*s*(10*C - 13)*(r - 1) - fd*(12*C - 17)*(4*r*s - r - 2*s + 1)) - Dd*f*(12*C - 17)*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(-f*(10*C - 13)*(r*(4*s - 1) - s) + fd*(12*C - 17)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(10*C - 13) + f*fdd*(17 - 12*C) + fd**2*(17 - 12*C)) + Ddd*f**2*(12*C - 17)*(r*(4*s - 1) - s)) + Dd**2*f**2*(12*C - 17)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(66*C - 89)*(r*(4*s - 1) - s) - fd*(60*C - 85)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(66*C - 89)*(r*(3*s - 1) - s) - f*(12*C - 17)*(9*bdd1*s*(r - 1) + 5*fdd*r*(3*s - 1) - 5*fdd*s) - fd**2*(60*C - 85)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(85 - 60*C)*(r*(4*s - 1) - s)) + Dd**2*f**2*(85 - 60*C)*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) - D1**2*Pk2*Pkd1*ct**4*k1*(126*D1**2*bd1**2*f*(4*C - 5)*(r*(2*s - 1) - s + 1) + 42*D1*b1*bd1*(4*C - 5)*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 9*D1*bd1*f*(D1*(f*(6*C*(3*r**2 + 18*r*s - 2*r - 22*s + 3) - 28*r**2 - 103*r*s + 26*r + 133*s - 28) + fd*(-4*C*(30*r**2 + 124*r*s - 51*r - 72*s + 31) + 224*r**2 + 388*r*s - 271*r - 244*s + 97)) + Dd*f*(-4*C*(60*r**2 + 248*r*s - 66*r - 195*s + 46) + 448*r**2 + 776*r*s - 457*r - 685*s + 209)) + 42*b1**2*(4*C - 5)*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 9*b1*(D1**2*(14*bdd1*f*(4*C - 5)*(r*(2*s - 1) - s) + f*(fd*(r**2*(36*C - 56) + r*(216*C*s - 132*C - 206*s + 133) + s*(24*C - 30)) + fdd*(r**2*(112 - 60*C) + r*(-248*C*s + 164*C + 194*s - 147) + s*(50 - 40*C))) + fd**2*(r**2*(112 - 60*C) + r*(-248*C*s + 164*C + 194*s - 147) + s*(50 - 40*C))) + D1*f*(Dd*(f*(18*C*(4*r**2 + 8*r*(3*s - 1) - 6*s + 1) - 112*r**2 + r*(159 - 412*s) + 103*s - 28) + fd*(-4*C*(120*r**2 + 16*r*(31*s - 16) - 22*s + 31) + 896*r**2 + 2*r*(776*s - 503) + 6*s + 97)) + Ddd*f*(-2*C*(60*r**2 + 4*r*(62*s - 23) - 62*s + 15) + 224*r**2 + r*(388*s - 209) - 97*s + 56)) + Dd**2*f**2*(-4*C*(90*r**2 + 6*r*(62*s - 23) - 93*s + 31) + 672*r**2 + 3*r*(388*s - 209) - 291*s + 97)) + f*(-9*D1**2*bdd1*f*(2*C*(15*r**2 + 2*r*(31*s - 5) - 82*s + 15) - 56*r**2 - 97*r*s + 62*r + 147*s - 56) + 5*D1**2*(f*(fd*(2*C*(57*r**2 + 6*r*(47*s - 22) - 94*s + 19) - 204*r**2 - 537*r*s + 315*r + 179*s - 68) + fdd*(-2*C*(69*r**2 + 6*r*(55*s - 26) - 110*s + 23) + 264*r**2 + 579*r*s - 369*r - 193*s + 88)) + fd**2*(-4*C*(69*r**2 + 6*r*(55*s - 26) - 110*s + 55) + 528*r**2 + 1158*r*s - 738*r - 386*s + 193)) + 5*D1*f*(Dd*(f*(2*C*(76*r**2 + 4*r*(94*s - 33) - 94*s + 19) - 272*r**2 - 716*r*s + 315*r + 179*s - 68) + fd*(-4*C*(276*r**2 + 6*r*(220*s - 91) - 385*s + 133) + 2112*r**2 + 4632*r*s - 2583*r - 1351*s + 562)) + Ddd*f*(-2*C*(92*r**2 + 440*r*s - 156*r - 110*s + 23) + 352*r**2 + 772*r*s - 369*r - 193*s + 88)) + 5*Dd**2*f**2*(-4*C*(138*r**2 + 6*r*(110*s - 39) - 165*s + 55) + 1056*r**2 + 3*r*(772*s - 369) - 579*s + 193)))/(315*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct**4*k1*(-33*b1**2*(D1*Dd*(-f*(9*f + 7)*(r*(4*s - 1) - s) + 3*fd*(5*f*(2*r*(8*s - 3) - 2*s + 1) + 7*r*(8*s - 5) - 7*s + 7)) - D1*(D1*r*(fd**2*(15 - 30*s) + fd*(18*f*s - 9*f + 7*s - 7) + 3*fdd*(-10*f*s + 5*f - 7*s + 7)) - 3*Ddd*f*(5*f + 7)*(r*(4*s - 1) - s)) + 3*Dd**2*f*(5*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*(D1*Dd*f*(f*(50*f + 27)*(r*(4*s - 1) - s) - 5*fd*(7*f*(48*r*s - 14*r - 10*s + 3) + 144*r*s - 54*r - 54*s + 18)) + 3*D1*bd1*(D1*(f*s*(9*f + 7)*(2*r - 1) - 3*fd*(5*f*(r*(8*s - 2) - 2*s + 1) + 7*r*(4*s - 2) - 7*s + 7)) - 3*Dd*f*(5*f + 7)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(f*fd*(r*(50*f*(3*s - 1) + 54*s - 27) - s*(25*f + 27)) + f*(-9*bdd1*s*(5*f + 7)*(2*r - 1) - 5*fdd*r*(14*f*(3*s - 1) + 18*s - 9) + fdd*s*(35*f + 45)) - 5*fd**2*(7*f*(12*r*s - 4*r - 2*s + 1) + 18*r*s - 9*r - 9*s + 9)) - 5*Ddd*f**2*(14*f + 9)*(r*(4*s - 1) - s)) - 5*Dd**2*f**2*(14*f + 9)*(3*r*(4*s - 1) - 3*s + 1)) + f*(-99*D1**2*bd1**2*s*(5*f + 7)*(2*r - 1) + 11*D1*bd1*(D1*(25*f**2*s*(2*r - 1) - 35*f*fd*(2*r*(6*s - 1) - 4*s + 1) + 27*f*r*s + 45*fd*(-4*r*s + r + s)) - 5*Dd*f*(7*f*(16*r*s - 2*r - 6*s + 1) + 72*r*s - 9*r - 9*s)) - 5*f*(-7*D1*Dd*f*(7*f*r*(4*s - 1) - 7*f*s - 18*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(77*bdd1*f*s*(2*r - 1) + 99*bdd1*r*s - 49*f*fd*(r*(4*s - 1) - s) + 63*f*fdd*(r*(4*s - 1) - s) + 63*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 63*Ddd*f**2*(r*(4*s - 1) - s)) + 63*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(3465*d**2*k2**2) - 4*D1**2*Pk2*Pkd1*ct**4*k2**4*st**2*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 69*D1**2*f**2*fd*r**2 + 69*D1**2*f**2*fd*r*s - 69*D1**2*f**2*fd*r - 23*D1**2*f**2*fd*s + 23*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 81*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 450*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 92*D1*Dd*f**3*r**2 + 92*D1*Dd*f**3*r*s - 69*D1*Dd*f**3*r - 23*D1*Dd*f**3*s + 23*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 525*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s - 100*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 135*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 75*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 405*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 45*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 225*Dd**2*f**3*r + 75*Dd**2*f**3*s - 25*Dd**2*f**3)/(315*d**2*k1*k3**4) - 2*D1**2*Pk2*Pkd1*ct**4*k2**4*(-3*D1*f*(7*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-3*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 5*fd*(8*r - 3)*(2*r + 2*s - 1)) + 5*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)))/(105*d**2*k1*k3**4) - 4*D1**2*Pk2*Pkd1*ct**4*k2**2*st**2*(90*C*D1**2*b1*f*fd*r**2 - 108*C*D1**2*b1*f*fdd*r**2 - 108*C*D1**2*b1*fd**2*r**2 + 219*C*D1**2*f**2*fd*r**2 - 146*C*D1**2*f**2*fd*r + 73*C*D1**2*f**2*fd - 150*C*D1**2*f**2*fdd*r**2 + 100*C*D1**2*f**2*fdd*r - 50*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*r**2 + 200*C*D1**2*f*fd**2*r + 180*C*D1*Dd*b1*f**2*r**2 - 90*C*D1*Dd*b1*f**2*r + 45*C*D1*Dd*b1*f**2 - 864*C*D1*Dd*b1*f*fd*r**2 + 216*C*D1*Dd*b1*f*fd*r + 292*C*D1*Dd*f**3*r**2 - 146*C*D1*Dd*f**3*r + 73*C*D1*Dd*f**3 - 1200*C*D1*Dd*f**2*fd*r**2 + 700*C*D1*Dd*f**2*fd*r - 100*C*D1*Dd*f**2*fd - 216*C*D1*Ddd*b1*f**2*r**2 + 108*C*D1*Ddd*b1*f**2*r - 54*C*D1*Ddd*b1*f**2 - 200*C*D1*Ddd*f**3*r**2 + 100*C*D1*Ddd*f**3*r - 50*C*D1*Ddd*f**3 - 648*C*Dd**2*b1*f**2*r**2 + 324*C*Dd**2*b1*f**2*r - 600*C*Dd**2*f**3*r**2 + 300*C*Dd**2*f**3*r - 90*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r + 108*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r + 108*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(r - 1)*(6*C*(r - 1) - 6*r + 5*s + 6) - 219*D1**2*f**2*fd*r**2 + 69*D1**2*f**2*fd*r*s + 123*D1**2*f**2*fd*r - 23*D1**2*f**2*fd*s - 73*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s - 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s - 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 - 180*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s + 63*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s - 45*D1*Dd*b1*f**2 + 864*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 54*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd - 292*D1*Dd*f**3*r**2 + 92*D1*Dd*f**3*r*s + 123*D1*Dd*f**3*r - 23*D1*Dd*f**3*s - 73*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s - 525*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s + 50*D1*Dd*f**2*fd + 216*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s - 63*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s + 54*D1*Ddd*b1*f**2 + 200*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s - 75*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s + 50*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(f*(r - 1)*(5*C*(r - 1) - 5*r + 3*s + 5) + fd*(-r**2*(24*C - 24) + r*(24*C - 20*s - 19) + 10*s - 5)) + Dd*f*(-12*C*(4*r**2 - 5*r + 1) + 48*r**2 - 5*r*(8*s + 11) + 25*s + 7)) + 648*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s - 189*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 45*Dd**2*b1*f**2 + 600*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s - 225*Dd**2*f**3*r + 75*Dd**2*f**3*s - 25*Dd**2*f**3)/(315*d**2*k1*k3**2) + D1**2*Pk2*Pkd1*ct**4*k2**2*(42*b1**2*(C - 1)*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + 3*b1*(14*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 3*D1**2*(f*(fd*(2*C*(16*r**2 - 6*r + 3) - 8*r**2 - 62*r*s + 43*r - 6) + fdd*(-2*C*(8*r**2 - 10*r + 5) + 32*r**2 + 66*r*s - 53*r + 10)) + fd**2*r*(-4*C*(4*r - 5) + 32*r + 66*s - 53)) + 14*D1*bd1*(C - 1)*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) - 3*D1*f*(Dd*(f*(16*C*(4*r**2 - 2*r + 1) - 16*r**2 + r*(39 - 124*s) + 31*s - 4) + fd*(-4*C*(32*r**2 - 28*r + 5) + 256*r**2 + 6*r*(88*s - 57) - 66*s + 53)) + Ddd*f*(-8*C*(4*r**2 - 2*r + 1) + 64*r**2 + r*(132*s - 65) - 33*s + 16)) - 9*Dd**2*f**2*(-r**2*(32*C - 64) + r*(16*C + 132*s - 65) - 33*s + 11)) + f*(84*D1**2*bd1**2*r*(C - 1)*(r - 1) + 9*D1**2*bdd1*f*(C*(8*r**2 + 4*r - 2) - 16*r**2 - 33*r*s + 12*r + 33*s - 6) + 5*D1**2*(f*(fd*(C*(6*r**2 - 4*r + 2) + 30*r**2 + 123*r*s - 61*r - 41*s + 10) - fdd*(10*C*(3*r**2 - 2*r + 1) + 42*r**2 + 129*r*s - 71*r - 43*s + 14)) + fd**2*(-r**2*(60*C + 84) + 2*r*(20*C - 129*s + 71) + 86*s - 43)) - 9*D1*bd1*(D1*(f*(2*C*(8*r**2 - 10*r + 5) - 4*r**2 - 31*r*s - 4*r + 31*s + 2) + fd*(-r**2*(32*C - 64) + r*(12*C + 132*s - 77) - 66*s + 33)) + Dd*f*(C*(4 - 64*r**2) + 128*r**2 + 264*r*s - 113*r - 165*s + 45)) + 5*D1*f*(Dd*(f*(C*(8*r**2 - 4*r + 2) + 40*r**2 + 164*r*s - 61*r - 41*s + 10) - fd*(20*C*(12*r**2 - 7*r + 1) + 336*r**2 + 1032*r*s - 497*r - 301*s + 114)) - Ddd*f*(10*C*(4*r**2 - 2*r + 1) + 56*r**2 + 172*r*s - 71*r - 43*s + 14)) + 5*Dd**2*f**2*(r**2*(-120*C - 168) + 3*r*(20*C - 172*s + 71) + 129*s - 43)))/(315*d**2*k1*k3**2) - D1**2*Pk2*Pkd1*ct**4*(-495*D1**2*K*bdd1*f**2*r**2 + 66*D1**2*bd1**2*f*(3*f*(r**2 + r*(4 - 20*s) + 10*s - 5) - 7*r**2*(K - 1) - 7*r*(-K + 6*s + 1) + 21*s) + 825*D1**2*bdd1*f**3*r**2 + 935*D1**2*bdd1*f**3*r*s - 330*D1**2*bdd1*f**3*r - 2475*D1**2*bdd1*f**3*s + 550*D1**2*bdd1*f**3 + 495*D1**2*bdd1*f**2*r**2 - 990*D1**2*bdd1*f**2*r*s + 462*D1**2*bdd1*f*g2*r**2 - 924*D1**2*bdd1*f*g2*r + 462*D1**2*bdd1*f*g2 - 1960*D1**2*f**3*fd*r**2 - 7700*D1**2*f**3*fd*r*s + 2905*D1**2*f**3*fd*r + 1925*D1**2*f**3*fd*s - 490*D1**2*f**3*fd + 2520*D1**2*f**3*fdd*r**2 + 7700*D1**2*f**3*fdd*r*s - 3185*D1**2*f**3*fdd*r - 1925*D1**2*f**3*fdd*s + 630*D1**2*f**3*fdd + 7560*D1**2*f**2*fd**2*r**2 + 23100*D1**2*f**2*fd**2*r*s - 9555*D1**2*f**2*fd**2*r - 5775*D1**2*f**2*fd**2*s + 1925*D1**2*f**2*fd**2 - 594*D1**2*f**2*gd2*r**2 + 990*D1**2*f**2*gdd2*r**2 - 1188*D1**2*f*fd*g2*r**2 + 1188*D1**2*f*fd*g2*r - 594*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r**2 - 1980*D1**2*f*fd*gd2*r + 1980*D1**2*f*fdd*g2*r**2 - 1980*D1**2*f*fdd*g2*r + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r**2 - 1980*D1**2*fd**2*g2*r - 1960*D1*Dd*f**4*r**2 - 7700*D1*Dd*f**4*r*s + 2905*D1*Dd*f**4*r + 1925*D1*Dd*f**4*s - 490*D1*Dd*f**4 + 20160*D1*Dd*f**3*fd*r**2 + 61600*D1*Dd*f**3*fd*r*s - 25480*D1*Dd*f**3*fd*r - 15400*D1*Dd*f**3*fd*s + 5110*D1*Dd*f**3*fd - 2376*D1*Dd*f**2*g2*r**2 + 1188*D1*Dd*f**2*g2*r - 594*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r**2 - 1980*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f*fd*g2*r**2 - 11880*D1*Dd*f*fd*g2*r + 1980*D1*Dd*f*fd*g2 + 2520*D1*Ddd*f**4*r**2 + 7700*D1*Ddd*f**4*r*s - 3185*D1*Ddd*f**4*r - 1925*D1*Ddd*f**4*s + 630*D1*Ddd*f**4 + 3960*D1*Ddd*f**2*g2*r**2 - 1980*D1*Ddd*f**2*g2*r + 990*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*(3*r**2 + r*(25*s + 6) - 45*s + 2) - f**2*(5*fd*(90*r**2 + r*(102*s - 59) - 107*s + 31) + 27*r*(r*(K - 1) + 2*s)) - 6*f*(15*fd*(-2*K*r**2 + K*r + 2*r**2 - 4*r*s + s) + 21*g2*(r - 1)**2 + 14*gd2*r*(r - 1)) - 84*fd*g2*r*(r - 1)) - Dd*f*(5*f**2*(120*r**2 + r*(136*s - 71) - 197*s + 51) - 90*f*(K*r*(4*r - 1) - 4*r**2 + 8*r*s - s) + 84*g2*(4*r**2 - 5*r + 1))) + 7560*Dd**2*f**4*r**2 + 23100*Dd**2*f**4*r*s - 9555*Dd**2*f**4*r - 5775*Dd**2*f**4*s + 1925*Dd**2*f**4 + 11880*Dd**2*f**2*g2*r**2 - 5940*Dd**2*f**2*g2*r + 33*b1**2*(D1**2*r*(6*f*fd*(5*r + 12*s - 3) + 6*f*fdd*(r - 20*s + 5) + 6*fd**2*(r - 20*s + 5) - 7*fd*(r*(3*K - 3) - 2*s + 2) + 7*fdd*(-K*r + r - 6*s + 6)) + D1*(Dd*(3*f**2*(20*r**2 + r*(48*s - 22) - 12*s + 5) + f*(-21*K*(4*r**2 - 2*r + 1) + 6*fd*(8*r**2 + r*(38 - 160*s) + 20*s - 5) + 84*r**2 + 56*r*s - 56*r - 14*s + 21) - 14*fd*(r**2*(4*K - 4) - r*(K - 24*s + 14) - 3*s + 3)) + Ddd*f*(-28*K*r**2 + 14*K*r - 7*K + 3*f*(4*r**2 - 80*r*s + 18*r + 20*s + 1) + 28*r**2 - 168*r*s + 28*r + 42*s + 7)) + 6*Dd**2*f*(f*(6*r**2 - 3*r*(40*s - 9) + 30*s - 10) - 7*r**2*(2*K - 2) + 7*r*(K - 12*s + 2) + 21*s - 7)) + 11*b1*(54*D1**2*K*f*fd*r**2 - 54*D1**2*K*f*fd*r + 27*D1**2*K*f*fd - 90*D1**2*K*f*fdd*r**2 + 90*D1**2*K*f*fdd*r - 45*D1**2*K*f*fdd - 90*D1**2*K*fd**2*r**2 + 90*D1**2*K*fd**2*r + 3*D1**2*bdd1*f*(-14*K*r**2 + 14*K*r - 7*K + 3*f*(2*r**2 - 40*r*s + 8*r + 20*s + 1) + 14*r**2 - 84*r*s - 14*r + 42*s + 7) - 45*D1**2*f**2*fd*r**2 - 375*D1**2*f**2*fd*r*s + 185*D1**2*f**2*fd*r - 100*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 255*D1**2*f**2*fdd*r*s - 205*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s + 25*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 510*D1**2*f*fd**2*r*s - 410*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 - 54*D1**2*f*fd*r**2 + 108*D1**2*f*fd*r*s - 54*D1**2*f*fd*s - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*s + 45*D1**2*f*fdd + 126*D1**2*f*gd2*r**2 + 42*D1**2*f*gdd2*r**2 + 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*s - 90*D1**2*fd**2 + 126*D1**2*fd*g2*r**2 + 84*D1**2*fd*gd2*r**2 + 42*D1**2*fdd*g2*r**2 + 108*D1*Dd*K*f**2*r**2 - 54*D1*Dd*K*f**2*r + 27*D1*Dd*K*f**2 - 720*D1*Dd*K*f*fd*r**2 + 540*D1*Dd*K*f*fd*r - 90*D1*Dd*K*f*fd - 60*D1*Dd*f**3*r**2 - 500*D1*Dd*f**3*r*s + 155*D1*Dd*f**3*r + 125*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 2040*D1*Dd*f**2*fd*r*s - 1525*D1*Dd*f**2*fd*r + 305*D1*Dd*f**2*fd*s + 65*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 + 216*D1*Dd*f**2*r*s - 54*D1*Dd*f**2*s - 27*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 540*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 504*D1*Dd*f*g2*r**2 - 252*D1*Dd*f*g2*r + 126*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 - 84*D1*Dd*f*gd2*r + 336*D1*Dd*fd*g2*r**2 - 84*D1*Dd*fd*g2*r - 180*D1*Ddd*K*f**2*r**2 + 90*D1*Ddd*K*f**2*r - 45*D1*Ddd*K*f**2 + 300*D1*Ddd*f**3*r**2 + 340*D1*Ddd*f**3*r*s - 235*D1*Ddd*f**3*r - 85*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*s + 45*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*r**2 - 84*D1*Ddd*f*g2*r + 42*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(3*f**2*(10*r**2 + 8*r*(3*s - 2) - 12*s + 5) + f*(-7*K*(6*r**2 - 6*r + 3) + 6*fd*(4*r**2 + r*(18 - 80*s) + 20*s - 5) + 42*r**2 + 28*r*s - 42*r - 14*s + 21) - 14*fd*(r**2*(2*K - 2) - r*(K - 12*s + 5) - 3*s + 3)) + 2*Dd*f*(-56*K*r**2 + 42*K*r - 7*K + 6*f*(4*r**2 - 80*r*s + 17*r + 30*s - 7) + 56*r**2 - 336*r*s + 126*s - 14)) - 540*Dd**2*K*f**2*r**2 + 270*Dd**2*K*f**2*r + 900*Dd**2*f**3*r**2 + 1020*Dd**2*f**3*r*s - 705*Dd**2*f**3*r - 255*Dd**2*f**3*s + 85*Dd**2*f**3 + 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 270*Dd**2*f**2*s - 90*Dd**2*f**2 + 504*Dd**2*f*g2*r**2 - 252*Dd**2*f*g2*r))/(3465*d**2*k1) + 2*D1**2*Pk2*Pkd1*ct**3*f*k2*st**2*(66*D1**2*b1*f*fd*r**2 - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 11*D1**2*bdd1*f**2*(r - 1)**2 + 280*D1**2*f**2*fd*r**2 - 140*D1**2*f**2*fd*r + 70*D1**2*f**2*fd - 140*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 + 210*D1**2*f*fd**2*r + 88*D1*Dd*b1*f**2*r**2 - 44*D1*Dd*b1*f**2*r + 22*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 + 66*D1*Dd*b1*f*fd*r + 280*D1*Dd*f**3*r**2 - 140*D1*Dd*f**3*r + 70*D1*Dd*f**3 - 1120*D1*Dd*f**2*fd*r**2 + 560*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 + 22*D1*Ddd*b1*f**2*r - 11*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 22*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 132*Dd**2*b1*f**2*r**2 + 66*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(693*d**2*k1**2) - 2*D1**2*Pk2*Pkd1*ct**3*k1**4*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 81*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 450*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 75*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 735*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 140*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 135*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 105*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 405*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 45*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 315*Dd**2*f**3*r + 105*Dd**2*f**3*s - 35*Dd**2*f**3)/(315*d**2*k2*k3**4) + 4*D1**2*Pk2*Pkd1*ct**3*k1**2*k2*st**2*(10*C*D1**2*b1*f*fd*r**2 + 10*C*D1**2*b1*f*fd*r*s - 5*C*D1**2*b1*f*fd*r - 54*C*D1**2*b1*f*fdd*r**2 - 54*C*D1**2*b1*f*fdd*r*s + 27*C*D1**2*b1*f*fdd*r - 54*C*D1**2*b1*fd**2*r**2 - 54*C*D1**2*b1*fd**2*r*s + 27*C*D1**2*b1*fd**2*r + 27*C*D1**2*f**2*fd*r**2 + 27*C*D1**2*f**2*fd*r*s - 27*C*D1**2*f**2*fd*r - 9*C*D1**2*f**2*fd*s + 9*C*D1**2*f**2*fd - 45*C*D1**2*f**2*fdd*r**2 - 45*C*D1**2*f**2*fdd*r*s + 45*C*D1**2*f**2*fdd*r + 15*C*D1**2*f**2*fdd*s - 15*C*D1**2*f**2*fdd - 90*C*D1**2*f*fd**2*r**2 - 90*C*D1**2*f*fd**2*r*s + 90*C*D1**2*f*fd**2*r + 30*C*D1**2*f*fd**2*s - 15*C*D1**2*f*fd**2 + 20*C*D1*Dd*b1*f**2*r**2 + 20*C*D1*Dd*b1*f**2*r*s - 15*C*D1*Dd*b1*f**2*r - 5*C*D1*Dd*b1*f**2*s + 5*C*D1*Dd*b1*f**2 - 432*C*D1*Dd*b1*f*fd*r**2 - 432*C*D1*Dd*b1*f*fd*r*s + 270*C*D1*Dd*b1*f*fd*r + 54*C*D1*Dd*b1*f*fd*s - 27*C*D1*Dd*b1*f*fd + 36*C*D1*Dd*f**3*r**2 + 36*C*D1*Dd*f**3*r*s - 27*C*D1*Dd*f**3*r - 9*C*D1*Dd*f**3*s + 9*C*D1*Dd*f**3 - 360*C*D1*Dd*f**2*fd*r**2 - 360*C*D1*Dd*f**2*fd*r*s + 315*C*D1*Dd*f**2*fd*r + 105*C*D1*Dd*f**2*fd*s - 60*C*D1*Dd*f**2*fd - 108*C*D1*Ddd*b1*f**2*r**2 - 108*C*D1*Ddd*b1*f**2*r*s + 81*C*D1*Ddd*b1*f**2*r + 27*C*D1*Ddd*b1*f**2*s - 27*C*D1*Ddd*b1*f**2 - 60*C*D1*Ddd*f**3*r**2 - 60*C*D1*Ddd*f**3*r*s + 45*C*D1*Ddd*f**3*r + 15*C*D1*Ddd*f**3*s - 15*C*D1*Ddd*f**3 - 324*C*Dd**2*b1*f**2*r**2 - 324*C*Dd**2*b1*f**2*r*s + 243*C*Dd**2*b1*f**2*r + 81*C*Dd**2*b1*f**2*s - 27*C*Dd**2*b1*f**2 - 180*C*Dd**2*f**3*r**2 - 180*C*Dd**2*f**3*r*s + 135*C*Dd**2*f**3*r + 45*C*Dd**2*f**3*s - 15*C*Dd**2*f**3 - 34*D1**2*b1*f*fd*r**2 - 34*D1**2*b1*f*fd*r*s + 17*D1**2*b1*f*fd*r + 108*D1**2*b1*f*fdd*r**2 + 108*D1**2*b1*f*fdd*r*s - 54*D1**2*b1*f*fdd*r + 108*D1**2*b1*fd**2*r**2 + 108*D1**2*b1*fd**2*r*s - 54*D1**2*b1*fd**2*r - 27*D1**2*bdd1*f**2*(C - 2)*(r - 1)*(r + s - 1) - 63*D1**2*f**2*fd*r**2 - 63*D1**2*f**2*fd*r*s + 63*D1**2*f**2*fd*r + 21*D1**2*f**2*fd*s - 21*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r**2 + 90*D1**2*f**2*fdd*r*s - 90*D1**2*f**2*fdd*r - 30*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r**2 + 180*D1**2*f*fd**2*r*s - 180*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 - 68*D1*Dd*b1*f**2*r**2 - 68*D1*Dd*b1*f**2*r*s + 51*D1*Dd*b1*f**2*r + 17*D1*Dd*b1*f**2*s - 17*D1*Dd*b1*f**2 + 864*D1*Dd*b1*f*fd*r**2 + 864*D1*Dd*b1*f*fd*r*s - 540*D1*Dd*b1*f*fd*r - 108*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 84*D1*Dd*f**3*r**2 - 84*D1*Dd*f**3*r*s + 63*D1*Dd*f**3*r + 21*D1*Dd*f**3*s - 21*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r**2 + 720*D1*Dd*f**2*fd*r*s - 630*D1*Dd*f**2*fd*r - 210*D1*Dd*f**2*fd*s + 120*D1*Dd*f**2*fd + 216*D1*Ddd*b1*f**2*r**2 + 216*D1*Ddd*b1*f**2*r*s - 162*D1*Ddd*b1*f**2*r - 54*D1*Ddd*b1*f**2*s + 54*D1*Ddd*b1*f**2 + 120*D1*Ddd*f**3*r**2 + 120*D1*Ddd*f**3*r*s - 90*D1*Ddd*f**3*r - 30*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + D1*bd1*f*(D1*(f*(5*C - 17)*(r - 1)*(r + s - 1) - fd*(27*C - 54)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(54 - 27*C)*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 648*Dd**2*b1*f**2*r**2 + 648*Dd**2*b1*f**2*r*s - 486*Dd**2*b1*f**2*r - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 360*Dd**2*f**3*r**2 + 360*Dd**2*f**3*r*s - 270*Dd**2*f**3*r - 90*Dd**2*f**3*s + 30*Dd**2*f**3)/(105*d**2*k3**4) + 2*D1**2*Pk2*Pkd1*ct**3*k1**2*k2*(63*b1**2*(2*C - 3)*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 9*b1*(-18*C*D1**2*f*fd*r - 18*C*D1**2*f*fd*s + 18*C*D1**2*f*fd + 30*C*D1**2*f*fdd*r + 30*C*D1**2*f*fdd*s - 30*C*D1**2*f*fdd + 30*C*D1**2*fd**2*r + 30*C*D1**2*fd**2*s + 120*C*D1*Dd*f*fd*r + 120*C*D1*Dd*f*fd*s - 60*C*D1*Dd*f*fd - 21*D1**2*bdd1*f*(2*C - 3)*(2*r - 1)*(r + s - 1) - 60*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s + 57*D1**2*f*fd*r + 27*D1**2*f*fd*s - 27*D1**2*f*fd + 100*D1**2*f*fdd*r**2 + 100*D1**2*f*fdd*r*s - 95*D1**2*f*fdd*r - 45*D1**2*f*fdd*s + 45*D1**2*f*fdd + 100*D1**2*fd**2*r**2 + 100*D1**2*fd**2*r*s - 95*D1**2*fd**2*r - 45*D1**2*fd**2*s - 120*D1*Dd*f**2*r**2 - 120*D1*Dd*f**2*r*s + 90*D1*Dd*f**2*r + 30*D1*Dd*f**2*s - 30*D1*Dd*f**2 + 800*D1*Dd*f*fd*r**2 + 800*D1*Dd*f*fd*r*s - 680*D1*Dd*f*fd*r - 280*D1*Dd*f*fd*s + 140*D1*Dd*f*fd + 200*D1*Ddd*f**2*r**2 + 200*D1*Ddd*f**2*r*s - 150*D1*Ddd*f**2*r - 50*D1*Ddd*f**2*s + 50*D1*Ddd*f**2 + 7*D1*bd1*(2*C - 3)*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 600*Dd**2*f**2*r**2 + 600*Dd**2*f**2*r*s - 450*Dd**2*f**2*r - 150*Dd**2*f**2*s + 50*Dd**2*f**2) + f*(-189*D1**2*bd1**2*(2*C - 3)*(2*r - 1)*(r + s - 1) - 45*D1**2*bdd1*f*(6*C - 10*r + 1)*(r + s - 1) + 9*D1*bd1*(D1*(3*f*(6*C - 10*r + 1)*(r + s - 1) + 5*fd*(-6*C*s + 40*r**2 + r*(-6*C + 40*s - 41) - 11*s + 10)) - 10*Dd*f*(6*C*(2*r + 2*s - 1) - 40*r**2 - 40*r*s + 37*r + 7*s - 6)) - 5*(6*C + 1)*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 7*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + r*(4*s - 3) - s + 1) - 7*fd*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)) - 7*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 7*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1))))/(315*d**2*k3**4) + 8*D1**2*Pk2*Pkd1*ct**3*k1**2*st**2*(D1*bd1*f*(D1*(f*s*(11*C - 26)*(r - 1) - fd*(9*C - 27)*(r*(4*s - 1) - 2*s + 1)) + Dd*f*(27 - 9*C)*(r*(8*s - 1) - 5*s + 1)) + b1*(D1*Dd*f*(f*(11*C - 26)*(r*(4*s - 1) - s) - fd*(9*C - 27)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(D1*r*(2*s - 1)*(f*fd*(11*C - 26) - f*fdd*(9*C - 27) - fd**2*(9*C - 27)) - Ddd*f**2*(9*C - 27)*(r*(4*s - 1) - s)) + Dd**2*f**2*(27 - 9*C)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(7*C - 18)*(r*(4*s - 1) - s) - fd*(5*C - 15)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(7*C - 18)*(r*(3*s - 1) - s) - f*(C - 3)*(9*bdd1*s*(r - 1) + 5*fdd*r*(3*s - 1) - 5*fdd*s) - fd**2*(5*C - 15)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(15 - 5*C)*(r*(4*s - 1) - s)) + Dd**2*f**2*(15 - 5*C)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k2*k3**2) - 2*D1**2*Pk2*Pkd1*ct**3*k1**2*(126*D1**2*bd1**2*f*(C - 2)*(r*(2*s - 1) - s + 1) + 6*D1*bd1*(7*b1*(C - 2)*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(-4*C*Dd*f*(r*(24*s + 2) - 20*s + 3) + D1*f*(C*r*(10*s + 3) - 13*C*s - 3*r**2 - 16*r*s + 22*s - 3) + D1*fd*(C*(r*(7 - 48*s) + 29*s - 12) + 20*r**2 + 5*r*(12*s - 5) - 40*s + 15) + 5*Dd*f*(8*r**2 + r*(24*s - 5) - 23*s + 5))) + 42*b1**2*(C - 2)*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 18*b1*(D1**2*(7*bdd1*f*(C - 2)*(r*(2*s - 1) - s) + f*(fd*(-6*r**2 + r*(20*C*s - 13*C - 32*s + 22) + s*(3*C - 6)) + fdd*(10*r**2 + r*(-24*C*s + 17*C + 30*s - 25) - s*(5*C - 10))) + fd**2*(10*r**2 + r*(-24*C*s + 17*C + 30*s - 25) - s*(5*C - 10))) + D1*f*(Dd*(-f*(12*r**2 + r*(C*(10 - 40*s) + 64*s - 22) + s*(10*C - 16) + 3) + fd*(-4*C*(r*(48*s - 23) - s + 3) + 80*r**2 + 30*r*(8*s - 5) + 10*s + 15)) + Ddd*f*(20*r**2 + r*(C*(12 - 48*s) + 60*s - 25) + s*(12*C - 15) + 5)) + 3*Dd**2*f**2*(-4*C*(3*r*(4*s - 1) - 3*s + 1) + (20*r - 5)*(r + 3*s - 1))) + f*(18*D1**2*bdd1*f*(-C*r*(12*s + 5) + 17*C*s + 5*r**2 + 15*r*s - 25*s + 5) + 5*D1**2*(f*(-2*fd*(19*C*s + 18*r**2 + r*(-57*C*s + 19*C + 90*s - 42) - 30*s + 6) + fdd*(46*C*s + 45*r**2 - 2*r*(69*C*s - 23*C - 99*s + 48) - 66*s + 15)) + 2*fd**2*(-23*C*(6*r*s - 2*r - 2*s + 1) + 45*r**2 + 198*r*s - 96*r - 66*s + 33)) + 5*D1*f*(2*Dd*(-f*(19*C*s + 24*r**2 + r*(-76*C*s + 19*C + 120*s - 42) - 30*s + 6) + fd*(-23*C*(r*(24*s - 7) - 7*s + 2) + 180*r**2 + 24*r*(33*s - 14) - 231*s + 81)) + Ddd*f*(46*C*s + 60*r**2 + r*(-184*C*s + 46*C + 264*s - 96) - 66*s + 15)) + 10*Dd**2*f**2*(-23*C*(3*r*(4*s - 1) - 3*s + 1) + 90*r**2 + 36*r*(11*s - 4) - 99*s + 33)))/(315*d**2*k2*k3**2) + D1**2*Pk2*Pkd1*ct**3*k2**3*st**4*(4*C - 4)*(18*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fd*r*s - 9*D1**2*b1*f*fd*r - 30*D1**2*b1*f*fdd*r**2 - 30*D1**2*b1*f*fdd*r*s + 15*D1**2*b1*f*fdd*r - 30*D1**2*b1*fd**2*r**2 - 30*D1**2*b1*fd**2*r*s + 15*D1**2*b1*fd**2*r - 15*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 21*D1**2*f**2*fd*r**2 + 21*D1**2*f**2*fd*r*s - 21*D1**2*f**2*fd*r - 7*D1**2*f**2*fd*s + 7*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 15*D1**2*f**2*fdd*r*s + 15*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 - 30*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r + 10*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 + 36*D1*Dd*b1*f**2*r**2 + 36*D1*Dd*b1*f**2*r*s - 27*D1*Dd*b1*f**2*r - 9*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 - 240*D1*Dd*b1*f*fd*r**2 - 240*D1*Dd*b1*f*fd*r*s + 150*D1*Dd*b1*f*fd*r + 30*D1*Dd*b1*f*fd*s - 15*D1*Dd*b1*f*fd + 28*D1*Dd*f**3*r**2 + 28*D1*Dd*f**3*r*s - 21*D1*Dd*f**3*r - 7*D1*Dd*f**3*s + 7*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 120*D1*Dd*f**2*fd*r*s + 105*D1*Dd*f**2*fd*r + 35*D1*Dd*f**2*fd*s - 20*D1*Dd*f**2*fd - 60*D1*Ddd*b1*f**2*r**2 - 60*D1*Ddd*b1*f**2*r*s + 45*D1*Ddd*b1*f**2*r + 15*D1*Ddd*b1*f**2*s - 15*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r*s + 15*D1*Ddd*f**3*r + 5*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 180*Dd**2*b1*f**2*r**2 - 180*Dd**2*b1*f**2*r*s + 135*Dd**2*b1*f**2*r + 45*Dd**2*b1*f**2*s - 15*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r*s + 45*Dd**2*f**3*r + 15*Dd**2*f**3*s - 5*Dd**2*f**3)/(105*d**2*k3**4) + 4*D1**2*Pk2*Pkd1*ct**3*k2**3*st**2*(21*b1**2*(C - 1)*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 3*b1*(-14*C*D1**2*f*fd*r**2 - 14*C*D1**2*f*fd*r*s - 4*C*D1**2*f*fd*r - 11*C*D1**2*f*fd*s + 11*C*D1**2*f*fd + 42*C*D1**2*f*fdd*r**2 + 42*C*D1**2*f*fdd*r*s - 12*C*D1**2*f*fdd*r + 9*C*D1**2*f*fdd*s - 9*C*D1**2*f*fdd + 42*C*D1**2*fd**2*r**2 + 42*C*D1**2*fd**2*r*s - 12*C*D1**2*fd**2*r + 9*C*D1**2*fd**2*s - 28*C*D1*Dd*f**2*r**2 - 28*C*D1*Dd*f**2*r*s + 21*C*D1*Dd*f**2*r + 7*C*D1*Dd*f**2*s - 7*C*D1*Dd*f**2 + 336*C*D1*Dd*f*fd*r**2 + 336*C*D1*Dd*f*fd*r*s - 174*C*D1*Dd*f*fd*r - 6*C*D1*Dd*f*fd*s + 3*C*D1*Dd*f*fd + 84*C*D1*Ddd*f**2*r**2 + 84*C*D1*Ddd*f**2*r*s - 63*C*D1*Ddd*f**2*r - 21*C*D1*Ddd*f**2*s + 21*C*D1*Ddd*f**2 + 252*C*Dd**2*f**2*r**2 + 252*C*Dd**2*f**2*r*s - 189*C*Dd**2*f**2*r - 63*C*Dd**2*f**2*s + 21*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(C - 1)*(2*r - 1)*(r + s - 1) - 46*D1**2*f*fd*r**2 - 46*D1**2*f*fd*r*s + 34*D1**2*f*fd*r + 11*D1**2*f*fd*s - 11*D1**2*f*fd + 72*D1**2*f*fdd*r**2 + 72*D1**2*f*fdd*r*s - 45*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd + 72*D1**2*fd**2*r**2 + 72*D1**2*fd**2*r*s - 45*D1**2*fd**2*r - 9*D1**2*fd**2*s - 92*D1*Dd*f**2*r**2 - 92*D1*Dd*f**2*r*s + 69*D1*Dd*f**2*r + 23*D1*Dd*f**2*s - 23*D1*Dd*f**2 + 576*D1*Dd*f*fd*r**2 + 576*D1*Dd*f*fd*r*s - 396*D1*Dd*f*fd*r - 108*D1*Dd*f*fd*s + 54*D1*Dd*f*fd + 144*D1*Ddd*f**2*r**2 + 144*D1*Ddd*f**2*r*s - 108*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s + 36*D1*Ddd*f**2 + 7*D1*bd1*(C - 1)*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 432*Dd**2*f**2*r**2 + 432*Dd**2*f**2*r*s - 324*Dd**2*f**2*r - 108*Dd**2*f**2*s + 36*Dd**2*f**2) + f*(-138*C*D1**2*f*fd*r**2 - 138*C*D1**2*f*fd*r*s + 138*C*D1**2*f*fd*r + 46*C*D1**2*f*fd*s - 46*C*D1**2*f*fd + 150*C*D1**2*f*fdd*r**2 + 150*C*D1**2*f*fdd*r*s - 150*C*D1**2*f*fdd*r - 50*C*D1**2*f*fdd*s + 50*C*D1**2*f*fdd + 300*C*D1**2*fd**2*r**2 + 300*C*D1**2*fd**2*r*s - 300*C*D1**2*fd**2*r - 100*C*D1**2*fd**2*s + 50*C*D1**2*fd**2 - 184*C*D1*Dd*f**2*r**2 - 184*C*D1*Dd*f**2*r*s + 138*C*D1*Dd*f**2*r + 46*C*D1*Dd*f**2*s - 46*C*D1*Dd*f**2 + 1200*C*D1*Dd*f*fd*r**2 + 1200*C*D1*Dd*f*fd*r*s - 1050*C*D1*Dd*f*fd*r - 350*C*D1*Dd*f*fd*s + 200*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*r**2 + 200*C*D1*Ddd*f**2*r*s - 150*C*D1*Ddd*f**2*r - 50*C*D1*Ddd*f**2*s + 50*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*r**2 + 600*C*Dd**2*f**2*r*s - 450*C*Dd**2*f**2*r - 150*C*Dd**2*f**2*s + 50*C*Dd**2*f**2 - 63*D1**2*bd1**2*(C - 1)*(2*r - 1)*(r + s - 1) + 9*D1**2*bdd1*f*(r + s - 1)*(7*C*r - 10*C + 12*r - 9) - 108*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 108*D1**2*f*fd*r + 36*D1**2*f*fd*s - 36*D1**2*f*fd + 135*D1**2*f*fdd*r**2 + 135*D1**2*f*fdd*r*s - 135*D1**2*f*fdd*r - 45*D1**2*f*fdd*s + 45*D1**2*f*fdd + 270*D1**2*fd**2*r**2 + 270*D1**2*fd**2*r*s - 270*D1**2*fd**2*r - 90*D1**2*fd**2*s + 45*D1**2*fd**2 - 144*D1*Dd*f**2*r**2 - 144*D1*Dd*f**2*r*s + 108*D1*Dd*f**2*r + 36*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 1080*D1*Dd*f*fd*r**2 + 1080*D1*Dd*f*fd*r*s - 945*D1*Dd*f*fd*r - 315*D1*Dd*f*fd*s + 180*D1*Dd*f*fd + 180*D1*Ddd*f**2*r**2 + 180*D1*Ddd*f**2*r*s - 135*D1*Ddd*f**2*r - 45*D1*Ddd*f**2*s + 45*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r + s - 1)*(C*(7*r - 18) + 23*r - 12) - 3*fd*(C*(28*r**2 + 28*r*s - 38*r - 17*s + 7) + 48*r**2 + 48*r*s - 57*r - 21*s + 12)) - 3*Dd*f*(C*(56*r**2 + r*(56*s - 89) - 47*s + 27) + 96*r**2 + 24*r*(4*s - 5) - 48*s + 30)) + 540*Dd**2*f**2*r**2 + 540*Dd**2*f**2*r*s - 405*Dd**2*f**2*r - 135*Dd**2*f**2*s + 45*Dd**2*f**2))/(315*d**2*k3**4) - D1**2*Pk2*Pkd1*ct**3*k2**3*(4*C + 6)*(-3*D1*f*(7*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-3*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 5*fd*(8*r - 3)*(2*r + 2*s - 1)) + 5*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)))/(105*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**3*k2*st**4*(8*C - 8)*(3*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 3*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(7*f*(4*r*s - r - s) - 5*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(7*f*fd*(r*(3*s - 1) - s) + 5*f*(-3*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) + 2*D1**2*Pk2*Pkd1*ct**3*k2*st**2*(-126*D1**2*bd1**2*f*(C - 1)*(r*(2*s - 1) - s + 1) + 6*D1*bd1*(-7*b1*(C - 1)*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(f*(C*(-48*r**2 - 43*r*s + 85*r + 54*s - 48) + 48*r**2 + 10*r*s - 85*r - 21*s + 48) + 3*fd*(3*C*(20*r**2 + 4*r*(9*s - 7) - 19*s + 9) - 74*r**2 - 44*r*s + 82*r + 25*s - 11)) + 3*Dd*f*(3*C*(40*r**2 + 72*r*s - 55*r - 49*s + 19) - 148*r**2 - 88*r*s + 184*r + 67*s - 48))) - 42*b1**2*(C - 1)*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) - 3*b1*(2*D1**2*(21*bdd1*f*(C - 1)*(r*(2*s - 1) - s) + f*(fd*(r**2*(96*C - 96) + r*(86*C*s - 54*C - 20*s + 21) + s*(11*C - 11)) + 3*fdd*(r**2*(37 - 30*C) + r*(-54*C*s + 30*C + 22*s - 14) - s*(3*C - 3))) + 3*fd**2*(r**2*(37 - 30*C) + r*(-54*C*s + 30*C + 22*s - 14) - s*(3*C - 3))) + D1*f*(2*Dd*(f*(C*(192*r**2 + r*(172*s - 139) - 43*s + 48) - 192*r**2 - 2*r*(20*s - 53) + 10*s - 48) + 3*fd*(-3*C*(80*r**2 + 6*r*(24*s - 13) - 14*s + 9) + 296*r**2 + 8*r*(22*s - 19) - 10*s + 11)) - 3*Ddd*f*(6*C*(20*r**2 + r*(36*s - 19) - 9*s + 5) - 148*r**2 + r*(96 - 88*s) + 22*s - 37)) - 6*Dd**2*f**2*(9*C*(20*r**2 + r*(36*s - 19) - 9*s + 3) - 222*r**2 + r*(144 - 132*s) + 33*s - 11)) + f*(9*D1**2*bdd1*f*(6*C*(5*r**2 + 9*r*(s - 1) - 10*s + 5) - 37*r**2 - 22*r*s + 68*r + 28*s - 37) + D1**2*(f*(fd*(-4*C*(180*r**2 + 159*r*s - 173*r - 53*s + 60) + 888*r**2 + 162*r*s - 646*r - 54*s + 296) + fdd*(2*C*(261*r**2 + 402*r*s - 308*r - 134*s + 87) - 687*r**2 - 324*r*s + 566*r + 108*s - 229)) + 2*fd**2*(2*C*(261*r**2 + 402*r*s - 308*r - 134*s + 67) - 687*r**2 - 324*r*s + 566*r + 108*s - 54)) + D1*f*(-2*Dd*(f*(2*C*(240*r**2 + 212*r*s - 173*r - 53*s + 60) - 592*r**2 - 108*r*s + 323*r + 27*s - 148) + fd*(C*(-2088*r**2 - 3216*r*s + 2156*r + 938*s - 442) + 2748*r**2 + 1296*r*s - 1981*r - 378*s + 337)) + Ddd*f*(2*C*(348*r**2 + 536*r*s - 308*r - 134*s + 87) - 916*r**2 - 432*r*s + 566*r + 108*s - 229)) + 2*Dd**2*f**2*(2*C*(522*r**2 + 804*r*s - 462*r - 201*s + 67) - 1374*r**2 - 648*r*s + 849*r + 162*s - 54)))/(315*d**2*k3**2) - 2*D1**2*Pk2*Pkd1*ct**3*k2*(21*b1**2*(D1**2*r*(fd*(r*(4*C - 3) + s*(12*C - 12)) - 2*fdd*(r*(6*C - 7) + s*(8*C - 8))) + D1*(Dd*(f*(4*C*(4*r - 1)*(r + 3*s - 1) - 12*r**2 - 48*r*s + 18*r + 12*s - 3) - 4*fd*(r**2*(24*C - 28) + r*(32*C*s - 10*C - 32*s + 11) - s*(4*C - 4))) - 2*Ddd*f*(C*(24*r**2 + 4*r*(8*s - 5) - 8*s + 6) - 28*r**2 - 32*r*s + 22*r + 8*s - 7)) - 4*Dd**2*f*(2*C*(18*r**2 + 3*r*(8*s - 5) - 6*s + 2) - 42*r**2 - 48*r*s + 33*r + 12*s - 4)) + 3*b1*(-14*D1**2*bdd1*f*(2*C*(6*r**2 + 2*r*(4*s - 5) - 4*s + 3) - 14*r**2 + r*(22 - 16*s) + 8*s - 7) + 3*D1**2*(f*(fd*(4*C*(8*r**2 - 4*r*s - 3*r - 5*s + 5) - 52*r**2 - 88*r*s + 70*r + 20*s - 23) + fdd*(-4*C*(4*r**2 - 2*r*s - 5*r - 6*s + 6) + 68*r**2 + 100*r*s - 84*r - 24*s + 29)) + 4*fd**2*(r**2*(17 - 4*C) + r*(2*C*s + 5*C + 25*s - 21) + s*(6*C - 6))) + 7*D1*bd1*(D1*(f*(4*C*(2*r**2 + 6*r*s - 5*r - 3*s + 1) - 6*r**2 - 24*r*s + 18*r + 12*s - 3) + 4*fd*(r**2*(14 - 12*C) + r*(-16*C*s + 10*C + 16*s - 11) + s*(4*C - 4))) - 4*Dd*f*(2*C*(24*r**2 + 32*r*s - 30*r - 12*s + 7) - 56*r**2 - 64*r*s + 66*r + 24*s - 15)) + 6*D1*f*(Dd*(f*(4*C*(8*r**2 - 4*r*s - 3*r + s + 2) - 52*r**2 - 88*r*s + 48*r + 22*s - 13) + 2*fd*(C*(-32*r**2 + 16*r*s + 26*r + 22*s - 11) + 136*r**2 + 200*r*s - 143*r - 49*s + 27)) + Ddd*f*(-2*C*(8*r**2 - 4*r*s - 3*r + s + 2) + 68*r**2 + 100*r*s - 59*r - 25*s + 17)) + 6*Dd**2*f**2*(C*(-48*r**2 + 6*r*(4*s + 3) - 6*s + 2) + 204*r**2 + 3*r*(100*s - 59) - 75*s + 25)) + f*(-84*D1**2*bd1**2*(2*C*(3*r**2 + r*(4*s - 5) - 2*s + 2) - 7*r**2 - 8*r*s + 11*r + 4*s - 4) - 9*D1**2*bdd1*f*(4*C*(2*r**2 - r*(s - 2) + 7*s - 4) - 34*r**2 + r*(34 - 50*s) + 26*s - 5) - 5*D1**2*(f*(fd*(4*C*(15*r**2 + 27*r*s - 19*r - 9*s + 5) + 21*r**2 + 96*r*s - 46*r - 32*s + 7) - 2*fdd*(2*C*(21*r**2 + 27*r*s - 23*r - 9*s + 7) + 12*r**2 + 51*r*s - 25*r - 17*s + 4)) - 2*fd**2*(2*C*(42*r**2 + 54*r*s - 46*r - 18*s + 9) + 24*r**2 + 102*r*s - 50*r - 34*s + 17)) + 9*D1*bd1*(D1*(f*(4*C*(4*r**2 - 2*r*s - 3*r + 7*s - 1) - 26*r**2 - 44*r*s + 26*r + 24*s - 3) + 2*fd*(2*C*(-8*r**2 + 4*r*s + r - 8*s + 1) + 68*r**2 + 100*r*s - 76*r - 38*s + 25)) + 2*Dd*f*(-2*C*(16*r**2 - 8*r*s + 5*r + 29*s - 9) + 136*r**2 + 200*r*s - 127*r - 77*s + 30)) - 5*D1*f*(Dd*(f*(4*C*(20*r**2 + 36*r*s - 19*r - 9*s + 5) + 28*r**2 + 128*r*s - 46*r - 32*s + 7) - 2*fd*(2*C*(168*r**2 + 216*r*s - 161*r - 63*s + 32) + 96*r**2 + 408*r*s - 175*r - 119*s + 42)) - 2*Ddd*f*(2*C*(28*r**2 + 36*r*s - 23*r - 9*s + 7) + 16*r**2 + 68*r*s - 25*r - 17*s + 4)) + 10*Dd**2*f**2*(6*C*(28*r**2 + 36*r*s - 23*r - 9*s + 3) + 48*r**2 + 204*r*s - 75*r - 51*s + 17)))/(315*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct**3*st**2*(297*D1**2*K*bdd1*f**2*r*s - 99*D1**2*bd1**2*f*s*(2*r - 1)*(-7*K + 10*f + 7) - 1650*D1**2*bdd1*f**3*r*s + 1100*D1**2*bdd1*f**3*s - 297*D1**2*bdd1*f**2*r*s - 1386*D1**2*bdd1*f*g2*r*s + 1386*D1**2*bdd1*f*g2*s + 2960*D1**2*f**3*fd*r*s - 740*D1**2*f**3*fd*r - 740*D1**2*f**3*fd*s - 2800*D1**2*f**3*fdd*r*s + 700*D1**2*f**3*fdd*r + 700*D1**2*f**3*fdd*s - 8400*D1**2*f**2*fd**2*r*s + 2100*D1**2*f**2*fd**2*r + 2100*D1**2*f**2*fd**2*s - 700*D1**2*f**2*fd**2 + 726*D1**2*f**2*gd2*r*s - 594*D1**2*f**2*gdd2*r*s + 1452*D1**2*f*fd*g2*r*s - 726*D1**2*f*fd*g2*r - 726*D1**2*f*fd*g2*s - 2376*D1**2*f*fd*gd2*r*s + 594*D1**2*f*fd*gd2*r + 594*D1**2*f*fd*gd2*s - 1188*D1**2*f*fdd*g2*r*s + 594*D1**2*f*fdd*g2*r + 594*D1**2*f*fdd*g2*s - 1188*D1**2*fd**2*g2*r*s + 594*D1**2*fd**2*g2*r + 594*D1**2*fd**2*g2*s - 594*D1**2*fd**2*g2 + 2960*D1*Dd*f**4*r*s - 740*D1*Dd*f**4*r - 740*D1*Dd*f**4*s - 22400*D1*Dd*f**3*fd*r*s + 5600*D1*Dd*f**3*fd*r + 5600*D1*Dd*f**3*fd*s - 1400*D1*Dd*f**3*fd + 2904*D1*Dd*f**2*g2*r*s - 726*D1*Dd*f**2*g2*r - 726*D1*Dd*f**2*g2*s - 4752*D1*Dd*f**2*gd2*r*s + 594*D1*Dd*f**2*gd2*r + 594*D1*Dd*f**2*gd2*s - 9504*D1*Dd*f*fd*g2*r*s + 3564*D1*Dd*f*fd*g2*r + 3564*D1*Dd*f*fd*g2*s - 1188*D1*Dd*f*fd*g2 - 2800*D1*Ddd*f**4*r*s + 700*D1*Ddd*f**4*r + 700*D1*Ddd*f**4*s - 2376*D1*Ddd*f**2*g2*r*s + 594*D1*Ddd*f**2*g2*r + 594*D1*Ddd*f**2*g2*s + 11*D1*bd1*(D1*(46*f**3*s*(3*r - 2) + f**2*(-50*fd*(18*r*s - 3*r - 7*s + 2) + r*s*(33 - 33*K)) + 3*f*(9*fd*(K - 1)*(r*(4*s - 1) - s) + s*(14*g2*(r - 1) - 84*gd2*r + 42*gd2)) - 126*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-50*f**2*(24*r*s - 3*r - 11*s + 2) + 27*f*(K - 1)*(8*r*s - r - s) - 126*g2*(8*r*s - r - 5*s + 1))) - 8400*Dd**2*f**4*r*s + 2100*Dd**2*f**4*r + 2100*Dd**2*f**4*s - 700*Dd**2*f**4 - 7128*Dd**2*f**2*g2*r*s + 1782*Dd**2*f**2*g2*r + 1782*Dd**2*f**2*g2*s - 594*Dd**2*f**2*g2 - 33*b1**2*(D1*Dd*(-f*(r*(4*s - 1) - s)*(-7*K + 18*f + 7) + 3*fd*(10*f*(16*r*s - 6*r - 2*s + 1) + (7 - 7*K)*(8*r*s - 5*r - s + 1))) + D1*(D1*r*(f*fd*(18 - 36*s) + 30*f*fdd*(2*s - 1) + 30*fd**2*(2*s - 1) + 7*fd*(K - 1)*(s - 1) + 21*fdd*(-K*s + K + s - 1)) + 3*Ddd*f*(r*(4*s - 1) - s)*(-7*K + 10*f + 7)) + 3*Dd**2*f*(-7*K + 10*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*(D1*Dd*(138*f**3*(r*(4*s - 1) - s) + f**2*(-50*fd*(3*r*(24*s - 7) - 13*s + 4) + (33 - 33*K)*(r*(4*s - 1) - s)) + 6*f*(9*fd*(K - 1)*(r*(8*s - 3) - 3*s + 1) + 7*g2*r*(4*s - 1) - 7*g2*s + 21*gd2*(-8*r*s + r + s)) - 126*fd*g2*(r*(8*s - 5) - s + 1)) + 3*D1*bd1*(D1*(-30*f*fd*(r*(8*s - 2) - 2*s + 1) + f*s*(2*r - 1)*(-7*K + 18*f + 7) + 21*fd*(K - 1)*(r*(4*s - 2) - s + 1)) - 3*Dd*f*(-7*K + 10*f + 7)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(-10*f**2*(9*bdd1*s*(2*r - 1) + 5*fdd*r*(9*s - 3) - 5*fdd*s) + 3*f*(9*fdd*(K - 1)*(r*(2*s - 1) - s) + s*(21*bdd1*(K - 1)*(2*r - 1) + 7*r*(2*gd2 - 6*gdd2))) + fd**2*(-50*f*(6*r*(3*s - 1) - 2*s + 1) + (27*K - 27)*(r*(2*s - 1) - s + 1)) + fd*(46*f**2*(r*(9*s - 3) - s) - 33*f*(K - 1)*(r*(2*s - 1) - s) + 42*r*(g2*(s - 1) - 6*gd2*s + 3*gd2)) - 126*fdd*g2*r*(s - 1)) - 3*Ddd*f*(r*(4*s - 1) - s)*(50*f**2 - 9*f*(K - 1) + 42*g2)) - 3*Dd**2*f*(50*f**2 - 9*f*(K - 1) + 42*g2)*(3*r*(4*s - 1) - 3*s + 1)))/(3465*d**2*k2) - 2*D1**2*Pk2*Pkd1*ct**3*(-3696*D1**2*K*bd1**2*f*r*s - 693*D1**2*K*bd1**2*f*r + 2541*D1**2*K*bd1**2*f*s + 1287*D1**2*K*bd1*f**2*r*s - 6732*D1**2*K*bd1*f*fd*r*s + 1683*D1**2*K*bd1*f*fd*r + 1683*D1**2*K*bd1*f*fd*s - 1683*D1**2*K*bdd1*f**2*r*s + 792*D1**2*bd1**2*f**2*r**2 - 1188*D1**2*bd1**2*f**2*r*s + 693*D1**2*bd1**2*f**2*r + 99*D1**2*bd1**2*f**2*s - 990*D1**2*bd1**2*f**2 + 924*D1**2*bd1**2*f*r**2 + 924*D1**2*bd1**2*f*r*s - 231*D1**2*bd1**2*f*r - 1155*D1**2*bd1**2*f*s - 4620*D1**2*bd1**2*g2*r*s + 2310*D1**2*bd1**2*g2*r + 2310*D1**2*bd1**2*g2*s - 2310*D1**2*bd1**2*g2 - 1386*D1**2*bd1*bd2*f*r*s + 693*D1**2*bd1*bd2*f*s - 550*D1**2*bd1*f**3*r**2 - 2145*D1**2*bd1*f**3*r*s + 1980*D1**2*bd1*f**3*s - 275*D1**2*bd1*f**3 + 4620*D1**2*bd1*f**2*fd*r**2 + 10890*D1**2*bd1*f**2*fd*r*s - 3355*D1**2*bd1*f**2*fd*r - 5775*D1**2*bd1*f**2*fd*s + 1210*D1**2*bd1*f**2*fd - 297*D1**2*bd1*f**2*r**2 - 693*D1**2*bd1*f**2*r*s + 1980*D1**2*bd1*f*fd*r**2 + 2772*D1**2*bd1*f*fd*r*s - 1683*D1**2*bd1*f*fd*r - 693*D1**2*bd1*f*fd*s - 2772*D1**2*bd1*f*g2*r*s - 462*D1**2*bd1*f*g2*r + 3234*D1**2*bd1*f*g2*s + 7392*D1**2*bd1*f*gd2*r*s + 1386*D1**2*bd1*f*gd2*r - 5082*D1**2*bd1*f*gd2*s + 7392*D1**2*bd1*fd*g2*r*s - 3696*D1**2*bd1*fd*g2*r - 3696*D1**2*bd1*fd*g2*s + 3696*D1**2*bd1*fd*g2 + 297*D1**2*bd2*f**2*r*s - 1980*D1**2*bd2*f*fd*r*s + 495*D1**2*bd2*f*fd*r + 495*D1**2*bd2*f*fd*s + 770*D1**2*bdd1*f**3*r**2 + 1815*D1**2*bdd1*f**3*r*s - 1980*D1**2*bdd1*f**3*s + 385*D1**2*bdd1*f**3 + 495*D1**2*bdd1*f**2*r**2 + 693*D1**2*bdd1*f**2*r*s + 3696*D1**2*bdd1*f*g2*r*s + 1386*D1**2*bdd1*f*g2*r - 5082*D1**2*bdd1*f*g2*s - 495*D1**2*bdd2*f**2*r*s - 1260*D1**2*f**3*fd*r**2 - 6160*D1**2*f**3*fd*r*s + 2170*D1**2*f**3*fd*r + 1540*D1**2*f**3*fd*s - 315*D1**2*f**3*fd + 1400*D1**2*f**3*fdd*r**2 + 6160*D1**2*f**3*fdd*r*s - 2240*D1**2*f**3*fdd*r - 1540*D1**2*f**3*fdd*s + 350*D1**2*f**3*fdd + 4200*D1**2*f**2*fd**2*r**2 + 18480*D1**2*f**2*fd**2*r*s - 6720*D1**2*f**2*fd**2*r - 4620*D1**2*f**2*fd**2*s + 1540*D1**2*f**2*fd**2 - 2574*D1**2*f**2*gd2*r*s + 3366*D1**2*f**2*gdd2*r*s - 5148*D1**2*f*fd*g2*r*s + 2574*D1**2*f*fd*g2*r + 2574*D1**2*f*fd*g2*s + 13464*D1**2*f*fd*gd2*r*s - 3366*D1**2*f*fd*gd2*r - 3366*D1**2*f*fd*gd2*s + 6732*D1**2*f*fdd*g2*r*s - 3366*D1**2*f*fdd*g2*r - 3366*D1**2*f*fdd*g2*s + 6732*D1**2*fd**2*g2*r*s - 3366*D1**2*fd**2*g2*r - 3366*D1**2*fd**2*g2*s + 3366*D1**2*fd**2*g2 - 13464*D1*Dd*K*bd1*f**2*r*s + 1683*D1*Dd*K*bd1*f**2*r + 1683*D1*Dd*K*bd1*f**2*s + 6160*D1*Dd*bd1*f**3*r**2 + 14520*D1*Dd*bd1*f**3*r*s - 3355*D1*Dd*bd1*f**3*r - 9735*D1*Dd*bd1*f**3*s + 1980*D1*Dd*bd1*f**3 + 3960*D1*Dd*bd1*f**2*r**2 + 5544*D1*Dd*bd1*f**2*r*s - 1683*D1*Dd*bd1*f**2*r - 693*D1*Dd*bd1*f**2*s + 29568*D1*Dd*bd1*f*g2*r*s + 1848*D1*Dd*bd1*f*g2*r - 24024*D1*Dd*bd1*f*g2*s + 3696*D1*Dd*bd1*f*g2 - 3960*D1*Dd*bd2*f**2*r*s + 495*D1*Dd*bd2*f**2*r + 495*D1*Dd*bd2*f**2*s - 1260*D1*Dd*f**4*r**2 - 6160*D1*Dd*f**4*r*s + 2170*D1*Dd*f**4*r + 1540*D1*Dd*f**4*s - 315*D1*Dd*f**4 + 11200*D1*Dd*f**3*fd*r**2 + 49280*D1*Dd*f**3*fd*r*s - 17920*D1*Dd*f**3*fd*r - 12320*D1*Dd*f**3*fd*s + 3780*D1*Dd*f**3*fd - 10296*D1*Dd*f**2*g2*r*s + 2574*D1*Dd*f**2*g2*r + 2574*D1*Dd*f**2*g2*s + 26928*D1*Dd*f**2*gd2*r*s - 3366*D1*Dd*f**2*gd2*r - 3366*D1*Dd*f**2*gd2*s + 53856*D1*Dd*f*fd*g2*r*s - 20196*D1*Dd*f*fd*g2*r - 20196*D1*Dd*f*fd*g2*s + 6732*D1*Dd*f*fd*g2 + 1400*D1*Ddd*f**4*r**2 + 6160*D1*Ddd*f**4*r*s - 2240*D1*Ddd*f**4*r - 1540*D1*Ddd*f**4*s + 350*D1*Ddd*f**4 + 13464*D1*Ddd*f**2*g2*r*s - 3366*D1*Ddd*f**2*g2*r - 3366*D1*Ddd*f**2*g2*s + 4200*Dd**2*f**4*r**2 + 18480*Dd**2*f**4*r*s - 6720*Dd**2*f**4*r - 4620*Dd**2*f**4*s + 1540*Dd**2*f**4 + 40392*Dd**2*f**2*g2*r*s - 10098*Dd**2*f**2*g2*r - 10098*Dd**2*f**2*g2*s + 3366*Dd**2*f**2*g2 - 231*b1**3*(D1*Dd*(r*(-20*K*s + 5*K - 4*f*s + f + 3*fd*(8*s - 1) + 20*s - 5) + s*(5*K + f - 3*fd - 5)) + D1*(-D1*r*s*(fd - 3*fdd) + Ddd*(r*(4*s - 1) - s)*(-5*K + 3*f + 5)) + Dd**2*(-5*K + 3*f + 5)*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1**2*(D1**2*(-56*K*fdd*r*s + 77*K*fdd*r - 21*K*fdd*s - 7*bdd1*(r*(3*s - 1) - s)*(-5*K + 3*f + 5) + 24*f*fdd*r**2 - 36*f*fdd*r*s - 27*f*fdd*r + 15*f*fdd*s + 3*fd**2*(8*r**2 - 3*r*(4*s + 3) + 5*s) + fd*(f*r*(33 - 12*s) + r**2*(7 - 6*f) + 7*r*(K*(6*s - 7) - 4*s + 5) + s*(7*K - 9*f - 7)) + 14*fdd*r**2 + 14*fdd*r*s - 35*fdd*r + 21*fdd*s - 70*gd2*r*s - 70*gdd2*r*s) + 7*D1*bd1*(D1*(r*(f*(3*s - 1) + fd*(3 - 18*s) + (5*K - 5)*(3*s - 1)) - s*(5*K + f - 3*fd - 5)) - Dd*(-5*K + 3*f + 5)*(r*(24*s - 7) - 7*s + 2)) + D1*(Dd*(-3*f**2*(4*r**2 + r*(8*s - 4) - 2*s + 1) + f*(-42*K*s + 12*fd*(16*r**2 - 2*r*(12*s + 5) + 8*s + 1) + 28*r**2 + 14*r*(12*K*s - 3*K - 8*s + 1) + 28*s + 7) - 14*fd*(2*K*(r*(16*s - 13) + s + 2) - 8*r**2 + r*(13 - 8*s) - 5*s - 1) - 70*g2*r*(4*s - 1) + 70*g2*s - 70*gd2*r*(8*s - 1) + 70*gd2*s) + 2*Ddd*(3*f**2*(8*r**2 - r*(12*s + 1) + 3*s + 2) + 7*f*(4*K*s + 4*r**2 + r*(-16*K*s + 4*K + 4*s - 3) - s + 1) + 35*g2*(-4*r*s + r + s))) + 2*Dd**2*(9*f**2*(8*r**2 - r*(12*s + 1) + 3*s - 1) - 7*f*(4*K*(12*r*s - 3*r - 3*s + 1) - 12*r**2 - 12*r*s + 9*r + 3*s - 1) - 35*g2*(3*r*(4*s - 1) - 3*s + 1))) - 11*b1*(-234*D1**2*K*f*fd*r*s + 117*D1**2*K*f*fd*r + 117*D1**2*K*f*fd*s + 306*D1**2*K*f*fdd*r*s - 153*D1**2*K*f*fdd*r - 153*D1**2*K*f*fdd*s + 306*D1**2*K*fd**2*r*s - 153*D1**2*K*fd**2*r - 153*D1**2*K*fd**2*s + 153*D1**2*K*fd**2 - 21*D1**2*b2*fd*r*s + 21*D1**2*b2*fd*r + 63*D1**2*b2*fdd*r*s - 63*D1**2*b2*fdd*r + 21*D1**2*bd1**2*(-5*K + 3*f + 5)*(r*(6*s - 2) - 2*s + 1) - 21*D1**2*bd2*f*r*s + 126*D1**2*bd2*fd*r*s - 63*D1**2*bd2*fd*r - 3*D1**2*bdd1*(3*f**2*(8*r**2 + r*(7 - 12*s) + s + 4) + 7*f*(11*K*s + 4*r**2 - r*(16*K*s + 3*K - 4*s + 1) - 5*s + 2) + 70*g2*(-2*r*s + r + s)) + 63*D1**2*bdd2*f*r*s + 150*D1**2*f**2*fd*r**2 + 585*D1**2*f**2*fd*r*s - 295*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 495*D1**2*f**2*fdd*r*s + 305*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 - 990*D1**2*f*fd**2*r*s + 610*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s - 55*D1**2*f*fd**2 + 54*D1**2*f*fd*r**2 + 126*D1**2*f*fd*r*s - 117*D1**2*f*fd*r - 63*D1**2*f*fd*s + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 126*D1**2*f*fdd*r*s + 153*D1**2*f*fdd*r + 63*D1**2*f*fdd*s - 45*D1**2*f*fdd + 252*D1**2*f*gd2*r*s - 336*D1**2*f*gdd2*r*s - 90*D1**2*fd**2*r**2 - 126*D1**2*fd**2*r*s + 153*D1**2*fd**2*r + 63*D1**2*fd**2*s - 63*D1**2*fd**2 + 252*D1**2*fd*g2*r*s - 294*D1**2*fd*g2*r + 42*D1**2*fd*g2*s - 672*D1**2*fd*gd2*r*s + 462*D1**2*fd*gd2*r - 126*D1**2*fd*gd2*s - 336*D1**2*fdd*g2*r*s + 462*D1**2*fdd*g2*r - 126*D1**2*fdd*g2*s - 468*D1*Dd*K*f**2*r*s + 117*D1*Dd*K*f**2*r + 117*D1*Dd*K*f**2*s + 2448*D1*Dd*K*f*fd*r*s - 918*D1*Dd*K*f*fd*r - 918*D1*Dd*K*f*fd*s + 306*D1*Dd*K*f*fd - 84*D1*Dd*b2*f*r*s + 21*D1*Dd*b2*f*r + 21*D1*Dd*b2*f*s + 504*D1*Dd*b2*fd*r*s - 315*D1*Dd*b2*fd*r - 63*D1*Dd*b2*fd*s + 63*D1*Dd*b2*fd + 504*D1*Dd*bd2*f*r*s - 63*D1*Dd*bd2*f*r - 63*D1*Dd*bd2*f*s + 200*D1*Dd*f**3*r**2 + 780*D1*Dd*f**3*r*s - 295*D1*Dd*f**3*r - 195*D1*Dd*f**3*s + 50*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 3960*D1*Dd*f**2*fd*r*s + 2135*D1*Dd*f**2*fd*r + 435*D1*Dd*f**2*fd*s - 290*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 + 252*D1*Dd*f**2*r*s - 117*D1*Dd*f**2*r - 63*D1*Dd*f**2*s + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1008*D1*Dd*f*fd*r*s + 918*D1*Dd*f*fd*r + 378*D1*Dd*f*fd*s - 216*D1*Dd*f*fd + 1008*D1*Dd*f*g2*r*s - 252*D1*Dd*f*g2*r - 252*D1*Dd*f*g2*s - 2688*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s - 2688*D1*Dd*fd*g2*r*s + 2184*D1*Dd*fd*g2*r - 168*D1*Dd*fd*g2*s - 336*D1*Dd*fd*g2 + 612*D1*Ddd*K*f**2*r*s - 153*D1*Ddd*K*f**2*r - 153*D1*Ddd*K*f**2*s + 252*D1*Ddd*b2*f*r*s - 63*D1*Ddd*b2*f*r - 63*D1*Ddd*b2*f*s - 280*D1*Ddd*f**3*r**2 - 660*D1*Ddd*f**3*r*s + 305*D1*Ddd*f**3*r + 165*D1*Ddd*f**3*s - 70*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 252*D1*Ddd*f**2*r*s + 153*D1*Ddd*f**2*r + 63*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 1344*D1*Ddd*f*g2*r*s + 336*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s + 3*D1*bd1*(D1*(3*f**2*(2*r**2 + r*(4*s + 7) - 5*s + 1) - f*(-49*K*s + 12*fd*(8*r**2 - r*(12*s + 1) + 3*s + 1) + 14*r**2 + 7*r*(12*K*s + K - 8*s - 3) + 35*s + 7) - 7*fd*(K*(r*(19 - 32*s) + 5*s - 8) + 8*r**2 + r*(8*s - 11) + s + 2) + 70*g2*r*(2*s - 1) - 70*g2*s + 70*gd2*r*(4*s - 1) - 70*gd2*s) - 2*Dd*(12*f**2*(8*r**2 + r*(3 - 12*s) + 2*s - 1) + 7*f*(K*(-64*r*s + 2*r + 30*s - 4) + 16*r**2 + 16*r*s - 8*r - 12*s + 3) - 70*g2*(r*(8*s - 3) - 3*s + 1))) + 1836*Dd**2*K*f**2*r*s - 459*Dd**2*K*f**2*r - 459*Dd**2*K*f**2*s + 153*Dd**2*K*f**2 + 756*Dd**2*b2*f*r*s - 189*Dd**2*b2*f*r - 189*Dd**2*b2*f*s + 63*Dd**2*b2*f - 840*Dd**2*f**3*r**2 - 1980*Dd**2*f**3*r*s + 915*Dd**2*f**3*r + 495*Dd**2*f**3*s - 165*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 756*Dd**2*f**2*r*s + 459*Dd**2*f**2*r + 189*Dd**2*f**2*s - 63*Dd**2*f**2 - 4032*Dd**2*f*g2*r*s + 1008*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s - 336*Dd**2*f*g2) + 33*b2*(-3*D1*Dd*f*(3*f*(-4*r*s + r + s) + 10*fd*(r*(8*s - 3) - 3*s + 1)) + 7*D1*bd1*(D1*(f*s*(r - 1) + 3*fd*(-2*r*s + r + s - 1)) - 3*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 3*D1*(D1*(3*f*fd*(-2*r*s + r + s) + f*(7*bdd1*s*(r - 1) + 5*fdd*r*(2*s - 1) - 5*fdd*s) + 5*fd**2*(r*(2*s - 1) - s + 1)) + 5*Ddd*f**2*(r*(4*s - 1) - s)) - 15*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(3465*d**2*k2) + 2*D1**2*Pk2*Pkd1*ct**3*k2**3*st**2*(36*D1**2*b1*f*fd*r**2 - 18*D1**2*b1*f*fdd*r**2 - 18*D1**2*b1*fd**2*r**2 - 9*D1**2*bdd1*f**2*(r - 1)**2 + 150*D1**2*f**2*fd*r**2 - 100*D1**2*f**2*fd*r + 50*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 72*D1*Dd*b1*f**2*r**2 - 36*D1*Dd*b1*f**2*r + 18*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 + 36*D1*Dd*b1*f*fd*r + 200*D1*Dd*f**3*r**2 - 100*D1*Dd*f**3*r + 50*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 + 18*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 18*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 108*Dd**2*b1*f**2*r**2 + 54*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(315*d**2*k1**2*k3**2) + 2*D1**2*Pk2*Pkd1*ct**3*k2**3*(2*D1**2*bd1**2*f*r*(r - 1) + D1*b1*(D1*bdd1*f*(2*r**2 - 2*r + 1) - 2*bd1*(D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(1 - 2*r) + Dd*f*(-8*r**2 + 6*r - 1))) + b1**2*(D1**2*r**2*(-2*fd + fdd) - 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*r*(1 - 4*r)) + D1*Ddd*f*(4*r**2 - 2*r + 1) + 6*Dd**2*f*r*(2*r - 1)))/(15*d**2*k1**2*k3**2) - 2*D1**2*Pk2*Pkd1*ct**3*k2*(-2*D1**2*bd1**2*f*r*(6*f + 7)*(r - 1) + D1*b1*(2*D1*bd1*(6*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(14 - 24*fd) + r*(12*fd - 14) + 7) + 7*fd*r*(1 - 2*r)) - D1*bdd1*f*(6*f + 7)*(2*r**2 - 2*r + 1) - 2*Dd*bd1*f*(6*f + 7)*(8*r**2 - 6*r + 1)) + b1**2*(D1**2*r**2*(-12*fd**2 + fd*(24*f + 14) - fdd*(12*f + 7)) + D1*(2*Dd*(6*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(28 - 48*fd) + r*(12*fd - 14) + 7) + 7*fd*r*(1 - 4*r)) - Ddd*f*(6*f + 7)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(6*f + 7)*(2*r - 1)))/(105*d**2*k1**2) - 4*D1**2*Pk2*Pkd1*ct**2*f*st**4*(33*D1*bd1*f*(D1*f*s*(r - 1) + D1*fd*(-6*r*s + r + 3*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 33*b1*(D1*Dd*f*(f*(-4*r*s + r + s) + fd*r*(24*s - 7) - 3*fd*s + fd) - D1*(D1*r*(3*s - 1)*(f*(fd - fdd) - 2*fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(19*f*(4*r*s - r - s) - 30*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(19*f*fd*(r*(4*s - 1) - s) + 3*f*(-11*bdd1*s*(r - 1) + 5*fdd*(-4*r*s + r + s)) - 15*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 15*Ddd*f**2*(-4*r*s + r + s)) - 15*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k1) - 2*D1**2*Pk2*Pkd1*ct**2*k1**3*st**2*(12*C*D1**2*b1*f*fd*r**2 + 12*C*D1**2*b1*f*fd*r*s - 6*C*D1**2*b1*f*fd*r + 36*C*D1**2*b1*f*fdd*r**2 + 36*C*D1**2*b1*f*fdd*r*s - 18*C*D1**2*b1*f*fdd*r + 36*C*D1**2*b1*fd**2*r**2 + 36*C*D1**2*b1*fd**2*r*s - 18*C*D1**2*b1*fd**2*r - 6*C*D1**2*f**2*fd*r**2 - 6*C*D1**2*f**2*fd*r*s + 6*C*D1**2*f**2*fd*r + 2*C*D1**2*f**2*fd*s - 2*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r**2 + 30*C*D1**2*f**2*fdd*r*s - 30*C*D1**2*f**2*fdd*r - 10*C*D1**2*f**2*fdd*s + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r**2 + 60*C*D1**2*f*fd**2*r*s - 60*C*D1**2*f*fd**2*r - 20*C*D1**2*f*fd**2*s + 10*C*D1**2*f*fd**2 + 24*C*D1*Dd*b1*f**2*r**2 + 24*C*D1*Dd*b1*f**2*r*s - 18*C*D1*Dd*b1*f**2*r - 6*C*D1*Dd*b1*f**2*s + 6*C*D1*Dd*b1*f**2 + 288*C*D1*Dd*b1*f*fd*r**2 + 288*C*D1*Dd*b1*f*fd*r*s - 180*C*D1*Dd*b1*f*fd*r - 36*C*D1*Dd*b1*f*fd*s + 18*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r**2 - 8*C*D1*Dd*f**3*r*s + 6*C*D1*Dd*f**3*r + 2*C*D1*Dd*f**3*s - 2*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r**2 + 240*C*D1*Dd*f**2*fd*r*s - 210*C*D1*Dd*f**2*fd*r - 70*C*D1*Dd*f**2*fd*s + 40*C*D1*Dd*f**2*fd + 72*C*D1*Ddd*b1*f**2*r**2 + 72*C*D1*Ddd*b1*f**2*r*s - 54*C*D1*Ddd*b1*f**2*r - 18*C*D1*Ddd*b1*f**2*s + 18*C*D1*Ddd*b1*f**2 + 40*C*D1*Ddd*f**3*r**2 + 40*C*D1*Ddd*f**3*r*s - 30*C*D1*Ddd*f**3*r - 10*C*D1*Ddd*f**3*s + 10*C*D1*Ddd*f**3 + 216*C*Dd**2*b1*f**2*r**2 + 216*C*Dd**2*b1*f**2*r*s - 162*C*Dd**2*b1*f**2*r - 54*C*Dd**2*b1*f**2*s + 18*C*Dd**2*b1*f**2 + 120*C*Dd**2*f**3*r**2 + 120*C*Dd**2*f**3*r*s - 90*C*Dd**2*f**3*r - 30*C*Dd**2*f**3*s + 10*C*Dd**2*f**3 + 18*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fd*r*s - 9*D1**2*b1*f*fd*r - 198*D1**2*b1*f*fdd*r**2 - 198*D1**2*b1*f*fdd*r*s + 99*D1**2*b1*f*fdd*r - 198*D1**2*b1*fd**2*r**2 - 198*D1**2*b1*fd**2*r*s + 99*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(2*C - 11)*(r - 1)*(r + s - 1) + 87*D1**2*f**2*fd*r**2 + 87*D1**2*f**2*fd*r*s - 87*D1**2*f**2*fd*r - 29*D1**2*f**2*fd*s + 29*D1**2*f**2*fd - 165*D1**2*f**2*fdd*r**2 - 165*D1**2*f**2*fdd*r*s + 165*D1**2*f**2*fdd*r + 55*D1**2*f**2*fdd*s - 55*D1**2*f**2*fdd - 330*D1**2*f*fd**2*r**2 - 330*D1**2*f*fd**2*r*s + 330*D1**2*f*fd**2*r + 110*D1**2*f*fd**2*s - 55*D1**2*f*fd**2 + 36*D1*Dd*b1*f**2*r**2 + 36*D1*Dd*b1*f**2*r*s - 27*D1*Dd*b1*f**2*r - 9*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 - 1584*D1*Dd*b1*f*fd*r**2 - 1584*D1*Dd*b1*f*fd*r*s + 990*D1*Dd*b1*f*fd*r + 198*D1*Dd*b1*f*fd*s - 99*D1*Dd*b1*f*fd + 116*D1*Dd*f**3*r**2 + 116*D1*Dd*f**3*r*s - 87*D1*Dd*f**3*r - 29*D1*Dd*f**3*s + 29*D1*Dd*f**3 - 1320*D1*Dd*f**2*fd*r**2 - 1320*D1*Dd*f**2*fd*r*s + 1155*D1*Dd*f**2*fd*r + 385*D1*Dd*f**2*fd*s - 220*D1*Dd*f**2*fd - 396*D1*Ddd*b1*f**2*r**2 - 396*D1*Ddd*b1*f**2*r*s + 297*D1*Ddd*b1*f**2*r + 99*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 220*D1*Ddd*f**3*r**2 - 220*D1*Ddd*f**3*r*s + 165*D1*Ddd*f**3*r + 55*D1*Ddd*f**3*s - 55*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(2*C + 3)*(r - 1)*(r + s - 1) + fd*(6*C - 33)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(6*C - 33)*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 1188*Dd**2*b1*f**2*r**2 - 1188*Dd**2*b1*f**2*r*s + 891*Dd**2*b1*f**2*r + 297*Dd**2*b1*f**2*s - 99*Dd**2*b1*f**2 - 660*Dd**2*f**3*r**2 - 660*Dd**2*f**3*r*s + 495*Dd**2*f**3*r + 165*Dd**2*f**3*s - 55*Dd**2*f**3)/(315*d**2*k3**4) + 2*D1**2*Pk2*Pkd1*ct**2*k1**3*(21*b1**2*(2*C - 5)*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 3*b1*(-21*D1**2*bdd1*f*(2*C - 5)*(2*r - 1)*(r + s - 1) - 3*D1**2*(f*(3*fd - 5*fdd)*(2*C*(r + s - 1) + 10*r**2 + 10*r*(s - 1) - 5*s + 5) - 5*fd**2*(10*r**2 + 2*r*(C + 5*s - 5) + s*(2*C - 5))) + 7*D1*bd1*(2*C - 5)*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 15*D1*f*(Dd*(3*f*(4*r**2 + 4*r*s - 3*r - s + 1) - fd*(4*C + 40*r - 15)*(2*r + 2*s - 1)) - 5*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 75*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + f*(-10*C*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 7*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + r*(4*s - 3) - s + 1) - 7*fd*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)) - 7*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 7*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) - 63*D1**2*bd1**2*(2*C - 5)*(2*r - 1)*(r + s - 1) - 45*D1**2*bdd1*f*(2*C - 5*r)*(r + s - 1) + 9*D1*bd1*(6*C*D1*f*(r + s - 1) - 10*C*D1*fd*(r + s) - 20*C*Dd*f*(2*r + 2*s - 1) + 5*D1*(-3*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 25*Dd*f*(8*r**2 + r*(8*s - 7) - s + 1))))/(315*d**2*k3**4) - 4*D1**2*Pk2*Pkd1*ct**2*k1**3*st**2*(D1*bd1*f*(D1*(11*f*s*(r - 1) - 9*fd*(4*r*s - r - 2*s + 1)) - 9*Dd*f*(r*(8*s - 1) - 5*s + 1)) + b1*(D1*Dd*f*(11*f*(4*r*s - r - s) - 9*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(D1*r*(2*s - 1)*(11*f*fd - 9*f*fdd - 9*fd**2) + 9*Ddd*f**2*(-4*r*s + r + s)) - 9*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(7*f*(4*r*s - r - s) - 5*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(7*f*fd*(r*(3*s - 1) - s) + f*(-9*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k2**2*k3**2) + D1**2*Pk2*Pkd1*ct**2*k1**3*(126*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 42*D1*b1*bd1*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) - 9*D1*bd1*f*(D1*(-f*r*(11*s + 6) + 17*f*s + fd*(36*r*s + r - 28*s + 9)) + Dd*f*(r*(72*s + 31) - 85*s + 9)) + 42*b1**2*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) - 9*b1*(D1*Dd*f*(11*f*(-4*r*s + r + s) + fd*(2*r*(72*s - 47) + 22*s + 9)) + D1*(14*D1*bdd1*f*(-2*r*s + r + s) + D1*(f*(fd*r*(17 - 22*s) - 6*fd*s + fdd*r*(18*s - 19) + 10*fdd*s) + fd**2*(r*(18*s - 19) + 10*s)) + 9*Ddd*f**2*(r*(4*s - 1) - s)) + 9*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(5*D1*Dd*f*(23*f*(r*(4*s - 1) - s) - 25*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(115*f*fd*(r*(3*s - 1) - s) + f*(-9*bdd1*r*(9*s + 10) + 171*bdd1*s + 125*fdd*(-3*r*s + r + s)) - 125*fd**2*(r*(6*s - 2) - 2*s + 1)) + 125*Ddd*f**2*(-4*r*s + r + s)) - 125*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k2**2*k3**2) - 2*D1**2*Pk2*Pkd1*ct**2*k1*k2**2*st**4*(12*C*D1**2*b1*f*fd*r**2 + 12*C*D1**2*b1*f*fd*r*s - 6*C*D1**2*b1*f*fd*r + 36*C*D1**2*b1*f*fdd*r**2 + 36*C*D1**2*b1*f*fdd*r*s - 18*C*D1**2*b1*f*fdd*r + 36*C*D1**2*b1*fd**2*r**2 + 36*C*D1**2*b1*fd**2*r*s - 18*C*D1**2*b1*fd**2*r - 18*C*D1**2*f**2*fd*r**2 - 18*C*D1**2*f**2*fd*r*s + 18*C*D1**2*f**2*fd*r + 6*C*D1**2*f**2*fd*s - 6*C*D1**2*f**2*fd + 18*C*D1**2*f**2*fdd*r**2 + 18*C*D1**2*f**2*fdd*r*s - 18*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s + 6*C*D1**2*f**2*fdd + 36*C*D1**2*f*fd**2*r**2 + 36*C*D1**2*f*fd**2*r*s - 36*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s + 6*C*D1**2*f*fd**2 + 24*C*D1*Dd*b1*f**2*r**2 + 24*C*D1*Dd*b1*f**2*r*s - 18*C*D1*Dd*b1*f**2*r - 6*C*D1*Dd*b1*f**2*s + 6*C*D1*Dd*b1*f**2 + 288*C*D1*Dd*b1*f*fd*r**2 + 288*C*D1*Dd*b1*f*fd*r*s - 180*C*D1*Dd*b1*f*fd*r - 36*C*D1*Dd*b1*f*fd*s + 18*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r**2 - 24*C*D1*Dd*f**3*r*s + 18*C*D1*Dd*f**3*r + 6*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 + 144*C*D1*Dd*f**2*fd*r**2 + 144*C*D1*Dd*f**2*fd*r*s - 126*C*D1*Dd*f**2*fd*r - 42*C*D1*Dd*f**2*fd*s + 24*C*D1*Dd*f**2*fd + 72*C*D1*Ddd*b1*f**2*r**2 + 72*C*D1*Ddd*b1*f**2*r*s - 54*C*D1*Ddd*b1*f**2*r - 18*C*D1*Ddd*b1*f**2*s + 18*C*D1*Ddd*b1*f**2 + 24*C*D1*Ddd*f**3*r**2 + 24*C*D1*Ddd*f**3*r*s - 18*C*D1*Ddd*f**3*r - 6*C*D1*Ddd*f**3*s + 6*C*D1*Ddd*f**3 + 216*C*Dd**2*b1*f**2*r**2 + 216*C*Dd**2*b1*f**2*r*s - 162*C*Dd**2*b1*f**2*r - 54*C*Dd**2*b1*f**2*s + 18*C*Dd**2*b1*f**2 + 72*C*Dd**2*f**3*r**2 + 72*C*Dd**2*f**3*r*s - 54*C*Dd**2*f**3*r - 18*C*Dd**2*f**3*s + 6*C*Dd**2*f**3 + 6*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fd*r*s - 3*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 33*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(6*C - 11)*(r - 1)*(r + s - 1) + 39*D1**2*f**2*fd*r**2 + 39*D1**2*f**2*fd*r*s - 39*D1**2*f**2*fd*r - 13*D1**2*f**2*fd*s + 13*D1**2*f**2*fd - 33*D1**2*f**2*fdd*r**2 - 33*D1**2*f**2*fdd*r*s + 33*D1**2*f**2*fdd*r + 11*D1**2*f**2*fdd*s - 11*D1**2*f**2*fdd - 66*D1**2*f*fd**2*r**2 - 66*D1**2*f*fd**2*r*s + 66*D1**2*f*fd**2*r + 22*D1**2*f*fd**2*s - 11*D1**2*f*fd**2 + 12*D1*Dd*b1*f**2*r**2 + 12*D1*Dd*b1*f**2*r*s - 9*D1*Dd*b1*f**2*r - 3*D1*Dd*b1*f**2*s + 3*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 330*D1*Dd*b1*f*fd*r + 66*D1*Dd*b1*f*fd*s - 33*D1*Dd*b1*f*fd + 52*D1*Dd*f**3*r**2 + 52*D1*Dd*f**3*r*s - 39*D1*Dd*f**3*r - 13*D1*Dd*f**3*s + 13*D1*Dd*f**3 - 264*D1*Dd*f**2*fd*r**2 - 264*D1*Dd*f**2*fd*r*s + 231*D1*Dd*f**2*fd*r + 77*D1*Dd*f**2*fd*s - 44*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 99*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 44*D1*Ddd*f**3*r**2 - 44*D1*Ddd*f**3*r*s + 33*D1*Ddd*f**3*r + 11*D1*Ddd*f**3*s - 11*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(2*C + 1)*(r - 1)*(r + s - 1) + fd*(6*C - 11)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(6*C - 11)*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 297*Dd**2*b1*f**2*r + 99*Dd**2*b1*f**2*s - 33*Dd**2*b1*f**2 - 132*Dd**2*f**3*r**2 - 132*Dd**2*f**3*r*s + 99*Dd**2*f**3*r + 33*Dd**2*f**3*s - 11*Dd**2*f**3)/(105*d**2*k3**4) + 2*D1**2*Pk2*Pkd1*ct**2*k1*k2**2*st**2*(7*b1**2*(2*C - 3)*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(-52*C*D1**2*f*fd*r**2 - 52*C*D1**2*f*fd*r*s + 4*C*D1**2*f*fd*r - 22*C*D1**2*f*fd*s + 22*C*D1**2*f*fd + 180*C*D1**2*f*fdd*r**2 + 180*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*r + 18*C*D1**2*f*fdd*s - 18*C*D1**2*f*fdd + 180*C*D1**2*fd**2*r**2 + 180*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*r + 18*C*D1**2*fd**2*s - 104*C*D1*Dd*f**2*r**2 - 104*C*D1*Dd*f**2*r*s + 78*C*D1*Dd*f**2*r + 26*C*D1*Dd*f**2*s - 26*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r**2 + 1440*C*D1*Dd*f*fd*r*s - 828*C*D1*Dd*f*fd*r - 108*C*D1*Dd*f*fd*s + 54*C*D1*Dd*f*fd + 360*C*D1*Ddd*f**2*r**2 + 360*C*D1*Ddd*f**2*r*s - 270*C*D1*Ddd*f**2*r - 90*C*D1*Ddd*f**2*s + 90*C*D1*Ddd*f**2 + 1080*C*Dd**2*f**2*r**2 + 1080*C*Dd**2*f**2*r*s - 810*C*Dd**2*f**2*r - 270*C*Dd**2*f**2*s + 90*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(2*C - 3)*(2*r - 1)*(r + s - 1) - 76*D1**2*f*fd*r**2 - 76*D1**2*f*fd*r*s + 71*D1**2*f*fd*r + 33*D1**2*f*fd*s - 33*D1**2*f*fd + 108*D1**2*f*fdd*r**2 + 108*D1**2*f*fdd*r*s - 81*D1**2*f*fdd*r - 27*D1**2*f*fdd*s + 27*D1**2*f*fdd + 108*D1**2*fd**2*r**2 + 108*D1**2*fd**2*r*s - 81*D1**2*fd**2*r - 27*D1**2*fd**2*s - 152*D1*Dd*f**2*r**2 - 152*D1*Dd*f**2*r*s + 114*D1*Dd*f**2*r + 38*D1*Dd*f**2*s - 38*D1*Dd*f**2 + 864*D1*Dd*f*fd*r**2 + 864*D1*Dd*f*fd*r*s - 648*D1*Dd*f*fd*r - 216*D1*Dd*f*fd*s + 108*D1*Dd*f*fd + 216*D1*Ddd*f**2*r**2 + 216*D1*Ddd*f**2*r*s - 162*D1*Ddd*f**2*r - 54*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 7*D1*bd1*(2*C - 3)*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 648*Dd**2*f**2*r**2 + 648*Dd**2*f**2*r*s - 486*Dd**2*f**2*r - 162*Dd**2*f**2*s + 54*Dd**2*f**2) + f*(-21*D1**2*bd1**2*(2*C - 3)*(2*r - 1)*(r + s - 1) + 9*D1**2*bdd1*f*(r + s - 1)*(2*C*(5*r - 6) + 6*r - 3) + 3*D1**2*(-f*(-20*C*fdd + fd*(16*C + 3) - 5*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(20*C + 5)*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*bd1*(D1*(-f*(r + s - 1)*(C*(26*r - 48) + 38*r - 5) + 9*fd*(2*C*(20*r**2 + 20*r*s - 26*r - 11*s + 5) + 24*r**2 + 24*r*s - 27*r - 9*s + 6)) + 18*Dd*f*(C*(40*r**2 + 40*r*s - 59*r - 29*s + 17) + 24*r**2 + 24*r*s - 27*r - 9*s + 6)) + 3*D1*f*(Dd*(-f*(16*C + 3)*(4*r**2 + r*(4*s - 3) - s + 1) + fd*(20*C + 5)*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)) + Ddd*f*(20*C + 5)*(4*r**2 + r*(4*s - 3) - s + 1)) + 3*Dd**2*f**2*(20*C + 5)*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)))/(105*d**2*k3**4) - D1**2*Pk2*Pkd1*ct**2*k1*k2**2*(4*C + 2)*(-3*D1*f*(7*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-3*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 5*fd*(8*r - 3)*(2*r + 2*s - 1)) + 5*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)))/(35*d**2*k3**4) + 4*D1**2*Pk2*Pkd1*ct**2*k1*st**4*(3*D1*bd1*f*(D1*(f*s*(8*C - 11)*(r - 1) - fd*(4*C - 9)*(4*r*s - r - 2*s + 1)) - Dd*f*(4*C - 9)*(r*(8*s - 1) - 5*s + 1)) - 3*b1*(D1*Dd*f*(-f*(8*C - 11)*(r*(4*s - 1) - s) + fd*(4*C - 9)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(8*C - 11) + f*fdd*(9 - 4*C) + fd**2*(9 - 4*C)) + Ddd*f**2*(4*C - 9)*(r*(4*s - 1) - s)) + Dd**2*f**2*(4*C - 9)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(8*C - 15)*(r*(4*s - 1) - s) - fd*(4*C - 9)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(8*C - 15)*(r*(3*s - 1) - s) - f*(4*C - 9)*(3*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) - fd**2*(4*C - 9)*(r*(6*s - 2) - 2*s + 1)) - Ddd*f**2*(4*C - 9)*(r*(4*s - 1) - s)) - Dd**2*f**2*(4*C - 9)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) + 2*D1**2*Pk2*Pkd1*ct**2*k1*st**2*(-7*D1**2*bd1**2*f*(4*C - 7)*(r*(2*s - 1) - s + 1) + D1*bd1*(-7*b1*(D1*(-f*(8*C - 9)*(2*r*s - r - s) + fd*(4*C - 7)*(4*r*s - r - s)) + Dd*f*(8*C - 14)*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(f*(C*(-35*r**2 - 66*r*s + 46*r + 90*s - 35) + 62*r**2 + 23*r*s - 89*r - 58*s + 62) + fd*(2*C*(56*r**2 + 276*r*s - 119*r - 144*s + 69) - 292*r**2 - 396*r*s + 370*r + 219*s - 99)) + Dd*f*(2*C*(112*r**2 + 552*r*s - 185*r - 369*s + 97) - 584*r**2 - 792*r*s + 745*r + 579*s - 245))) - 7*b1**2*(D1*Dd*(-f*(8*C - 9)*(r*(4*s - 1) - s) + fd*(4*C - 7)*(r*(8*s - 1) - s)) + D1*(D1*r*s*(fd*(9 - 8*C) + fdd*(4*C - 7)) + Ddd*f*(4*C - 7)*(r*(4*s - 1) - s)) + Dd**2*f*(4*C - 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1**2*(-7*bdd1*f*(4*C - 7)*(r*(2*s - 1) - s) + f*(fd*(r**2*(124 - 70*C) + r*(-132*C*s + 90*C + 46*s - 58) + s*(35 - 24*C)) + fdd*(r**2*(56*C - 146) + 6*r*(46*C*s - 25*C - 33*s + 20) + s*(12*C - 21))) + fd**2*(r**2*(56*C - 146) + 6*r*(46*C*s - 25*C - 33*s + 20) + s*(12*C - 21))) + D1*f*(Dd*(f*(C*(-140*r**2 - 264*r*s + 136*r + 66*s - 35) + 248*r**2 + 92*r*s - 147*r - 23*s + 62) + fd*(2*C*(224*r**2 + 1104*r*s - 494*r - 114*s + 69) - 1168*r**2 - 1584*r*s + 970*r + 114*s - 99)) + Ddd*f*(2*C*(56*r**2 + 276*r*s - 97*r - 69*s + 14) - 292*r**2 - 396*r*s + 245*r + 99*s - 73)) + 3*Dd**2*f**2*(2*C*(56*r**2 + r*(276*s - 97) - 69*s + 23) - 292*r**2 + r*(245 - 396*s) + 99*s - 33)) + f*(D1**2*bdd1*f*(2*C*(14*r**2 + 69*r*s - 22*r - 75*s + 14) - 73*r**2 - 99*r*s + 125*r + 120*s - 73) + D1**2*(f*(fd*(C*(-69*r**2 - 198*r*s + 112*r + 66*s - 23) + 162*r**2 + 102*r*s - 142*r - 34*s + 54) + fdd*(2*C*(24*r**2 + 117*r*s - 55*r - 39*s + 8) - 135*r**2 - 168*r*s + 146*r + 56*s - 45)) + 2*fd**2*(C*(48*r**2 + 234*r*s - 110*r - 78*s + 39) - 135*r**2 - 168*r*s + 146*r + 56*s - 28)) + D1*f*(Dd*(f*(C*(-92*r**2 - 8*r*(33*s - 14) + 66*s - 23) + 216*r**2 + 2*r*(68*s - 71) - 34*s + 54) + 2*fd*(C*(192*r**2 + 936*r*s - 385*r - 273*s + 94) - 540*r**2 - 672*r*s + 511*r + 196*s - 101)) + Ddd*f*(2*C*(32*r**2 + 156*r*s - 55*r - 39*s + 8) - 180*r**2 - 224*r*s + 146*r + 56*s - 45)) + 2*Dd**2*f**2*(3*C*(32*r**2 + 156*r*s - 55*r - 39*s + 13) - 270*r**2 - 336*r*s + 219*r + 84*s - 28)))/(105*d**2*k3**2) - D1**2*Pk2*Pkd1*ct**2*k1*(21*b1**2*(D1**2*r*(fd*r*(14*C - 20) + fd*s*(28*C - 39) + fdd*r*(40 - 22*C) + fdd*s*(57 - 44*C)) + D1*(Dd*(f*(14*C*(4*r**2 + 8*r*s - 4*r - 2*s + 1) - 80*r**2 - 156*r*s + 79*r + 39*s - 20) + fd*(r**2*(320 - 176*C) + r*(-352*C*s + 88*C + 456*s - 137) + s*(44*C - 57))) + Ddd*f*(-22*C*(4*r**2 + 8*r*s - 4*r - 2*s + 1) + 160*r**2 + 228*r*s - 137*r - 57*s + 40)) + Dd**2*f*(-44*C*(6*r**2 + 6*r*(2*s - 1) - 3*s + 1) + 480*r**2 + r*(684*s - 411) - 171*s + 57)) + 3*b1*(-7*D1**2*bdd1*f*(22*C*(2*r**2 + 4*r*(s - 1) - 2*s + 1) - 80*r**2 - 114*r*s + 137*r + 57*s - 40) + 3*D1**2*(f*(fd*(2*C*(16*r**2 - 32*r*s + 8*r - 26*s + 17) - 120*r**2 - 172*r*s + 137*r + 69*s - 60) + fdd*(-2*C*(8*r**2 - 16*r*s + 4*r - 34*s + 19) + 144*r**2 + 212*r*s - 163*r - 87*s + 72)) + fd**2*(r**2*(144 - 16*C) + r*(32*C*s - 8*C + 212*s - 163) + s*(68*C - 87))) + 7*D1*bd1*(D1*(f*(14*C*(2*r**2 + 4*r*(s - 1) - 2*s + 1) - 40*r**2 - 78*r*s + 79*r + 39*s - 20) + fd*(r**2*(160 - 88*C) + r*(-176*C*s + 88*C + 228*s - 137) + s*(44*C - 57))) + 2*Dd*f*(-22*C*(8*r**2 + 4*r*(4*s - 3) - 6*s + 3) + 320*r**2 + 456*r*s - 411*r - 171*s + 97)) + 6*D1*f*(Dd*(f*(8*C*(4*r**2 - 8*r*s + 2*s + 1) - 120*r**2 - 172*r*s + 103*r + 43*s - 30) + fd*(-2*C*(32*r**2 - 64*r*s + 8*r - 60*s + 15) + 576*r**2 + 848*r*s - 576*r - 280*s + 125)) + Ddd*f*(-4*C*(4*r**2 - 8*r*s + 2*s + 1) + 144*r**2 + 212*r*s - 125*r - 53*s + 36)) + 6*Dd**2*f**2*(-8*C*(6*r**2 - 12*r*s + 3*s - 1) + 432*r**2 + 636*r*s - 375*r - 159*s + 53)) + f*(-10*C*(D1**2*(f*(fd*(57*r**2 + 162*r*s - 92*r - 54*s + 19) + fdd*(-69*r**2 - 162*r*s + 100*r + 54*s - 23)) - 2*fd**2*(69*r**2 + 2*r*(81*s - 50) - 54*s + 27)) + D1*f*(Dd*(f*(76*r**2 + 216*r*s - 92*r - 54*s + 19) - 2*fd*(276*r**2 + 648*r*s - 350*r - 189*s + 77)) + Ddd*f*(-92*r**2 - 4*r*(54*s - 25) + 54*s - 23)) - 6*Dd**2*f**2*(46*r**2 + 2*r*(54*s - 25) - 27*s + 9)) - 21*D1**2*bd1**2*(44*C*(r**2 + 2*r*(s - 1) - s + 1) - 80*r**2 + r*(137 - 114*s) + 57*s - 57) - 9*D1**2*bdd1*f*(2*C*(4*r**2 - 4*r*(2*s + 1) + 42*s - 15) - 72*r**2 + r*(87 - 106*s) + 19*s) - 5*D1*Dd*f*(23*f*(4*r*s - r - s) - 25*fd*(24*r*s - 7*r - 7*s + 2)) + 9*D1*bd1*(2*C*(D1*(f*(8*r**2 - 8*r*(2*s + 1) + 42*s - 9) + 2*fd*(-8*r**2 + 2*r*(8*s + 1) - 25*s + 4)) + 2*Dd*f*(-16*r**2 + 8*r*(4*s + 1) - 88*s + 19)) + D1*(f*(-60*r**2 - 86*r*s + 69*r + 17*s) + fd*(288*r**2 + 424*r*s - 337*r - 125*s + 106)) + 2*Dd*f*(288*r**2 + r*(424*s - 299) - 91*s + 53)) - 5*D1*(D1*(23*f*fd*(3*r*s - r - s) + 25*f*fdd*(-3*r*s + r + s) - 25*fd**2*(6*r*s - 2*r - 2*s + 1)) + 25*Ddd*f**2*(-4*r*s + r + s)) + 125*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct**2*k1*st**2*(-11*b1**2*(D1*Dd*(-f*(15*f + 7)*(r*(4*s - 1) - s) + 3*fd*(6*f*(2*r*(8*s - 3) - 2*s + 1) + 7*r*(8*s - 5) - 7*s + 7)) - D1*(D1*r*(fd**2*(18 - 36*s) + fd*(30*f*s - 15*f + 7*s - 7) + 3*fdd*(-12*f*s + 6*f - 7*s + 7)) - 3*Ddd*f*(6*f + 7)*(r*(4*s - 1) - s)) + 3*Dd**2*f*(6*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*(D1*Dd*f*(11*f*(2*f + 1)*(r*(4*s - 1) - s) - 2*fd*(5*f*(48*r*s - 14*r - 10*s + 3) + 72*r*s - 27*r - 27*s + 9)) + D1*bd1*(D1*(f*s*(15*f + 7)*(2*r - 1) - 3*fd*(6*f*(r*(8*s - 2) - 2*s + 1) + 7*r*(4*s - 2) - 7*s + 7)) - 3*Dd*f*(6*f + 7)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(11*f*fd*(r*(6*f*s - 2*f + 2*s - 1) - s*(f + 1)) + f*(-3*bdd1*s*(6*f + 7)*(2*r - 1) + fdd*r*(f*(20 - 60*s) - 18*s + 9) + fdd*s*(10*f + 9)) + fd**2*(-10*f*(12*r*s - 4*r - 2*s + 1) - 18*r*s + 9*r + 9*s - 9)) - Ddd*f**2*(20*f + 9)*(r*(4*s - 1) - s)) - Dd**2*f**2*(20*f + 9)*(3*r*(4*s - 1) - 3*s + 1)) + f*(-33*D1**2*bd1**2*s*(6*f + 7)*(2*r - 1) + 11*D1*bd1*(D1*(11*f**2*s*(2*r - 1) - 10*f*fd*(2*r*(6*s - 1) - 4*s + 1) + 11*f*r*s + 9*fd*(-4*r*s + r + s)) + Dd*f*(-10*f*(16*r*s - 2*r - 6*s + 1) - 72*r*s + 9*r + 9*s)) + f*(5*D1*Dd*f*(17*f*(r*(4*s - 1) - s) - 28*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-99*bdd1*r*s + 85*f*fd*(r*(4*s - 1) - s) - 10*f*(11*bdd1*s*(2*r - 1) + 7*fdd*r*(4*s - 1) - 7*fdd*s) - 70*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 70*Ddd*f**2*(-4*r*s + r + s)) - 70*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(1155*d**2*k2**2) - D1**2*Pk2*Pkd1*ct**2*k1*(-42*b1**3*(D1*Dd*(r*(-4*f*s + f + 24*fd*s - 3*fd + 20*s - 5) + s*(f - 3*fd - 5)) + D1*(-D1*r*s*(fd - 3*fdd) + Ddd*(3*f + 5)*(4*r*s - r - s)) + Dd**2*(3*f + 5)*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1**2*(D1*Dd*(-9*f*(3*f + 7)*(r*(4*s - 1) - s) + fd*(3*f*(16*r*s - 86*r + 38*s + 11) + 392*r*s - 413*r + 119*s + 49)) + 14*D1*bd1*(D1*(r*(3*f*s - f - 18*fd*s + 3*fd - 15*s + 5) + s*(-f + 3*fd + 5)) - Dd*(3*f + 5)*(r*(24*s - 7) - 7*s + 2)) + D1*(-14*D1*bdd1*(3*f + 5)*(r*(3*s - 1) - s) + D1*(fd**2*(r*(6*s - 63) + 30*s) - fd*(r*(9*f*(6*s - 7) + 63*s - 77) + s*(18*f + 14)) + fdd*(r*(6*f*s - 63*f + 49*s - 91) + s*(30*f + 42))) + Ddd*f*(3*f + 49)*(r*(4*s - 1) - s)) + Dd**2*f*(3*f + 49)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-42*D1**2*bd1**2*(3*f + 5)*(r*(6*s - 2) - 2*s + 1) + D1*Dd*f*(-f*(220*f + 153)*(r*(4*s - 1) - s) + fd*(5*f*(48*r*(20*s - 7) - 172*s + 67) + 342*r*(8*s - 3) - 1026*s + 342)) - 3*D1*bd1*(D1*(f*fd*(r*(6 - 24*s) + 6*s - 33) + 2*f*r*(9*f*(3*s + 2) + 63*s + 7) - f*s*(45*f + 77) + 7*fd*(-4*r*(7*s - 5) + s - 7)) - Dd*f*(3*f*(2*r*(8*s + 39) - 46*s - 9) + 14*r*(56*s + 5) - 462*s + 49)) + D1*(D1*(f*fd*(-3*r*(220*f*s - 90*f + 102*s - 51) + s*(85*f + 153)) + f*(3*bdd1*r*(6*f*(s + 10) + 98*s + 42) - 3*bdd1*s*(33*f + 91) + 3*fdd*r*(200*f*s - 90*f + 114*s - 57) - fdd*s*(65*f + 171)) + fd**2*(5*f*(12*r*(20*s - 9) - 26*s + 27) + 171*r*(2*s - 1) - 171*s + 171)) + Ddd*f**2*(200*f + 171)*(r*(4*s - 1) - s)) + Dd**2*f**2*(200*f + 171)*(3*r*(4*s - 1) - 3*s + 1)) + f*(3*D1**2*bd1**2*(f*(6*r*(s + 10) - 33*s - 30) + 14*r*(7*s + 3) - 91*s) - D1*bd1*(D1*(5*f**2*(2*r*(22*s + 5) - 27*s) + f*(-5*fd*(240*r*s - 12*r - 94*s + 13) + 153*r*s) + 171*fd*(-4*r*s + r + s)) + Dd*f*(-80*f*r*(20*s + 1) + 740*f*s - 65*f - 171*r*(8*s - 1) + 171*s)) + f*(-105*D1*Dd*f*(f*r*(4*s - 1) - f*s - 2*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(bdd1*(5*f*(40*r*s + 14*r - 27*s) + 171*r*s) - 105*f*fd*(r*(4*s - 1) - s) + 105*f*fdd*(r*(4*s - 1) - s) + 105*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 105*Ddd*f**2*(r*(4*s - 1) - s)) + 105*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(315*d**2*k2**2) - 2*D1**2*Pk2*Pkd1*ct**2*k2**4*st**4*(18*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fd*r*s - 9*D1**2*b1*f*fd*r - 30*D1**2*b1*f*fdd*r**2 - 30*D1**2*b1*f*fdd*r*s + 15*D1**2*b1*f*fdd*r - 30*D1**2*b1*fd**2*r**2 - 30*D1**2*b1*fd**2*r*s + 15*D1**2*b1*fd**2*r - 15*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 21*D1**2*f**2*fd*r**2 + 21*D1**2*f**2*fd*r*s - 21*D1**2*f**2*fd*r - 7*D1**2*f**2*fd*s + 7*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 15*D1**2*f**2*fdd*r*s + 15*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 - 30*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r + 10*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 + 36*D1*Dd*b1*f**2*r**2 + 36*D1*Dd*b1*f**2*r*s - 27*D1*Dd*b1*f**2*r - 9*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 - 240*D1*Dd*b1*f*fd*r**2 - 240*D1*Dd*b1*f*fd*r*s + 150*D1*Dd*b1*f*fd*r + 30*D1*Dd*b1*f*fd*s - 15*D1*Dd*b1*f*fd + 28*D1*Dd*f**3*r**2 + 28*D1*Dd*f**3*r*s - 21*D1*Dd*f**3*r - 7*D1*Dd*f**3*s + 7*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 120*D1*Dd*f**2*fd*r*s + 105*D1*Dd*f**2*fd*r + 35*D1*Dd*f**2*fd*s - 20*D1*Dd*f**2*fd - 60*D1*Ddd*b1*f**2*r**2 - 60*D1*Ddd*b1*f**2*r*s + 45*D1*Ddd*b1*f**2*r + 15*D1*Ddd*b1*f**2*s - 15*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r*s + 15*D1*Ddd*f**3*r + 5*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 180*Dd**2*b1*f**2*r**2 - 180*Dd**2*b1*f**2*r*s + 135*Dd**2*b1*f**2*r + 45*Dd**2*b1*f**2*s - 15*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r*s + 45*Dd**2*f**3*r + 15*Dd**2*f**3*s - 5*Dd**2*f**3)/(105*d**2*k1*k3**4) + 2*D1**2*Pk2*Pkd1*ct**2*k2**4*st**2*(D1*f*(21*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-11*f*r*(r + s - 1) + 9*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 9*D1*bdd1*f*r*(r + s - 1) + 9*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) - 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r*s + 22*D1**2*f*fd*r + 11*D1**2*f*fd*s - 11*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*r - 9*D1**2*fd**2*s - 44*D1*Dd*f**2*r**2 - 44*D1*Dd*f**2*r*s + 33*D1*Dd*f**2*r + 11*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 144*D1*Dd*f*fd*r*s - 126*D1*Dd*f*fd*r - 54*D1*Dd*f*fd*s + 27*D1*Dd*f*fd + 36*D1*Ddd*f**2*r**2 + 36*D1*Ddd*f**2*r*s - 27*D1*Ddd*f**2*r - 9*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 - 7*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 108*Dd**2*f**2*r**2 + 108*Dd**2*f**2*r*s - 81*Dd**2*f**2*r - 27*Dd**2*f**2*s + 9*Dd**2*f**2))/(105*d**2*k1*k3**4) - 2*D1**2*Pk2*Pkd1*ct**2*k2**2*st**4*(90*C*D1**2*b1*f*fd*r**2 - 66*C*D1**2*b1*f*fdd*r**2 - 66*C*D1**2*b1*fd**2*r**2 + 69*C*D1**2*f**2*fd*r**2 - 46*C*D1**2*f**2*fd*r + 23*C*D1**2*f**2*fd - 39*C*D1**2*f**2*fdd*r**2 + 26*C*D1**2*f**2*fdd*r - 13*C*D1**2*f**2*fdd - 78*C*D1**2*f*fd**2*r**2 + 52*C*D1**2*f*fd**2*r + 180*C*D1*Dd*b1*f**2*r**2 - 90*C*D1*Dd*b1*f**2*r + 45*C*D1*Dd*b1*f**2 - 528*C*D1*Dd*b1*f*fd*r**2 + 132*C*D1*Dd*b1*f*fd*r + 92*C*D1*Dd*f**3*r**2 - 46*C*D1*Dd*f**3*r + 23*C*D1*Dd*f**3 - 312*C*D1*Dd*f**2*fd*r**2 + 182*C*D1*Dd*f**2*fd*r - 26*C*D1*Dd*f**2*fd - 132*C*D1*Ddd*b1*f**2*r**2 + 66*C*D1*Ddd*b1*f**2*r - 33*C*D1*Ddd*b1*f**2 - 52*C*D1*Ddd*f**3*r**2 + 26*C*D1*Ddd*f**3*r - 13*C*D1*Ddd*f**3 - 396*C*Dd**2*b1*f**2*r**2 + 198*C*Dd**2*b1*f**2*r - 156*C*Dd**2*f**3*r**2 + 78*C*Dd**2*f**3*r - 90*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fd*r*s - 9*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fdd*r**2 - 30*D1**2*b1*f*fdd*r*s + 15*D1**2*b1*f*fdd*r + 66*D1**2*b1*fd**2*r**2 - 30*D1**2*b1*fd**2*r*s + 15*D1**2*b1*fd**2*r - 3*D1**2*bdd1*f**2*(r - 1)*(11*C*(r - 1) - 11*r + 5*s + 11) - 69*D1**2*f**2*fd*r**2 + 21*D1**2*f**2*fd*r*s + 39*D1**2*f**2*fd*r - 7*D1**2*f**2*fd*s - 23*D1**2*f**2*fd + 39*D1**2*f**2*fdd*r**2 - 15*D1**2*f**2*fdd*r*s - 21*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd*s + 13*D1**2*f**2*fdd + 78*D1**2*f*fd**2*r**2 - 30*D1**2*f*fd**2*r*s - 42*D1**2*f*fd**2*r + 10*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 - 180*D1*Dd*b1*f**2*r**2 + 36*D1*Dd*b1*f**2*r*s + 81*D1*Dd*b1*f**2*r - 9*D1*Dd*b1*f**2*s - 45*D1*Dd*b1*f**2 + 528*D1*Dd*b1*f*fd*r**2 - 240*D1*Dd*b1*f*fd*r*s - 42*D1*Dd*b1*f*fd*r + 30*D1*Dd*b1*f*fd*s - 15*D1*Dd*b1*f*fd - 92*D1*Dd*f**3*r**2 + 28*D1*Dd*f**3*r*s + 39*D1*Dd*f**3*r - 7*D1*Dd*f**3*s - 23*D1*Dd*f**3 + 312*D1*Dd*f**2*fd*r**2 - 120*D1*Dd*f**2*fd*r*s - 147*D1*Dd*f**2*fd*r + 35*D1*Dd*f**2*fd*s + 16*D1*Dd*f**2*fd + 132*D1*Ddd*b1*f**2*r**2 - 60*D1*Ddd*b1*f**2*r*s - 51*D1*Ddd*b1*f**2*r + 15*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 + 52*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r*s - 21*D1*Ddd*f**3*r + 5*D1*Ddd*f**3*s + 13*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(3*f*(r - 1)*(5*C*(r - 1) - 5*r + s + 5) + fd*(-r**2*(44*C - 44) + r*(44*C - 20*s - 39) + 10*s - 5)) + Dd*f*(-22*C*(4*r**2 - 5*r + 1) + 88*r**2 - 5*r*(8*s + 21) + 25*s + 17)) + 396*Dd**2*b1*f**2*r**2 - 180*Dd**2*b1*f**2*r*s - 153*Dd**2*b1*f**2*r + 45*Dd**2*b1*f**2*s - 15*Dd**2*b1*f**2 + 156*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r*s - 63*Dd**2*f**3*r + 15*Dd**2*f**3*s - 5*Dd**2*f**3)/(105*d**2*k1*k3**2) - 2*D1**2*Pk2*Pkd1*ct**2*k2**2*st**2*(7*b1**2*(C - 1)*(D1**2*r**2*(7*fd - 6*fdd) + D1*(7*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + b1*(110*C*D1**2*f*fd*r**2 - 74*C*D1**2*f*fd*r + 37*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 + 44*C*D1**2*f*fdd*r - 22*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 + 44*C*D1**2*fd**2*r + 220*C*D1*Dd*f**2*r**2 - 110*C*D1*Dd*f**2*r + 55*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 + 216*C*D1*Dd*f*fd*r - 44*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 + 20*C*D1*Ddd*f**2*r - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 + 60*C*Dd**2*f**2*r - 42*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 140*D1**2*f*fd*r**2 - 78*D1**2*f*fd*r*s + 113*D1**2*f*fd*r - 37*D1**2*f*fd + 98*D1**2*f*fdd*r**2 + 102*D1**2*f*fdd*r*s - 95*D1**2*f*fdd*r + 22*D1**2*f*fdd + 98*D1**2*fd**2*r**2 + 102*D1**2*fd**2*r*s - 95*D1**2*fd**2*r - 280*D1*Dd*f**2*r**2 - 156*D1*Dd*f**2*r*s + 179*D1*Dd*f**2*r + 39*D1*Dd*f**2*s - 70*D1*Dd*f**2 + 784*D1*Dd*f*fd*r**2 + 816*D1*Dd*f*fd*r*s - 678*D1*Dd*f*fd*r - 102*D1*Dd*f*fd*s + 95*D1*Dd*f*fd + 196*D1*Ddd*f**2*r**2 + 204*D1*Ddd*f**2*r*s - 149*D1*Ddd*f**2*r - 51*D1*Ddd*f**2*s + 49*D1*Ddd*f**2 + 7*D1*bd1*(C - 1)*(7*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) + 588*Dd**2*f**2*r**2 + 612*Dd**2*f**2*r*s - 447*Dd**2*f**2*r - 153*Dd**2*f**2*s + 51*Dd**2*f**2) + f*(-66*C*D1**2*f*fd*r**2 + 44*C*D1**2*f*fd*r - 22*C*D1**2*f*fd + 60*C*D1**2*f*fdd*r**2 - 40*C*D1**2*f*fdd*r + 20*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 - 80*C*D1**2*fd**2*r - 88*C*D1*Dd*f**2*r**2 + 44*C*D1*Dd*f**2*r - 22*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*r**2 - 280*C*D1*Dd*f*fd*r + 40*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 - 40*C*D1*Ddd*f**2*r + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 - 120*C*Dd**2*f**2*r - 84*D1**2*bd1**2*r*(C - 1)*(r - 1) + D1**2*bdd1*f*(-2*C*(5*r**2 + 12*r - 6) + 49*r**2 + 51*r*s - 54*r - 51*s + 27) - 87*D1**2*f*fd*r**2 - 57*D1**2*f*fd*r*s + 77*D1**2*f*fd*r + 19*D1**2*f*fd*s - 29*D1**2*f*fd + 57*D1**2*f*fdd*r**2 + 69*D1**2*f*fdd*r*s - 61*D1**2*f*fdd*r - 23*D1**2*f*fdd*s + 19*D1**2*f*fdd + 114*D1**2*fd**2*r**2 + 138*D1**2*fd**2*r*s - 122*D1**2*fd**2*r - 46*D1**2*fd**2*s + 23*D1**2*fd**2 - 116*D1*Dd*f**2*r**2 - 76*D1*Dd*f**2*r*s + 77*D1*Dd*f**2*r + 19*D1*Dd*f**2*s - 29*D1*Dd*f**2 + 456*D1*Dd*f*fd*r**2 + 552*D1*Dd*f*fd*r*s - 427*D1*Dd*f*fd*r - 161*D1*Dd*f*fd*s + 84*D1*Dd*f*fd + 76*D1*Ddd*f**2*r**2 + 92*D1*Ddd*f**2*r*s - 61*D1*Ddd*f**2*r - 23*D1*Ddd*f**2*s + 19*D1*Ddd*f**2 + D1*bd1*(D1*(f*(C*(55*r**2 - 36*r + 18) - 70*r**2 - 39*r*s + 66*r + 39*s - 33) + fd*(r**2*(196 - 40*C) + r*(-4*C + 204*s - 203) - 102*s + 51)) + Dd*f*(-4*C*(20*r**2 + 19*r - 6) + 392*r**2 + 408*r*s - 365*r - 255*s + 105)) + 228*Dd**2*f**2*r**2 + 276*Dd**2*f**2*r*s - 183*Dd**2*f**2*r - 69*Dd**2*f**2*s + 23*Dd**2*f**2))/(105*d**2*k1*k3**2) - D1**2*Pk2*Pkd1*ct**2*k2**2*(D1*f*(7*D1*bd1**2*(r**2*(4*C + 12) + r*(-4*C + 26*s - 25) - 13*s + 13) + 3*D1*bdd1*f*r*(r*(10*C + 14) + 19*s - 19) + 3*bd1*(D1*(-f*r*(r*(6*C + 14) + 17*s - 17) + fd*(r**2*(40*C + 56) + r*(-20*C + 76*s - 66) - 19*s + 19)) + Dd*f*(r**2*(80*C + 112) + r*(-20*C + 152*s - 123) - 19*s + 19))) + 7*b1**2*(D1**2*r*(fd*r*(6*C - 2) - 11*fd*s + fdd*r*(2*C + 6) + 13*fdd*s) + D1*(Dd*(f*(6*C*(4*r**2 - 2*r + 1) - 8*r**2 - 44*r*s + 15*r + 11*s - 2) + fd*(r**2*(16*C + 48) + r*(-4*C + 104*s - 25) - 13*s)) + Ddd*f*(C*(8*r**2 - 4*r + 2) + 24*r**2 + 52*r*s - 25*r - 13*s + 6)) + Dd**2*f*(r**2*(24*C + 72) - 3*r*(4*C - 52*s + 25) - 39*s + 13)) + b1*(7*D1**2*bdd1*f*(C*(4*r**2 - 4*r + 2) + 12*r**2 + 26*r*s - 25*r - 13*s + 6) - 3*D1**2*(f*(fd*(6*C*(2*r**2 - 2*r + 1) + 28*r**2 + 34*r*s - 28*r - 17*s + 14) - fdd*(10*C*(2*r**2 - 2*r + 1) + 28*r**2 + 38*r*s - 28*r - 19*s + 14)) + fd**2*(r**2*(-20*C - 28) + r*(20*C - 38*s + 28) + 19*s)) + 7*D1*bd1*(D1*(f*(6*C*(2*r**2 - 2*r + 1) - 4*r**2 - 22*r*s + 15*r + 11*s - 2) + fd*(r**2*(8*C + 24) + r*(-4*C + 52*s - 25) - 13*s)) + 2*Dd*f*(2*C*(8*r**2 - 6*r + 1) + 48*r**2 + 104*r*s - 75*r - 39*s + 19)) - 3*D1*f*(Dd*(f*(6*C*(4*r**2 - 2*r + 1) + 56*r**2 + 68*r*s - 45*r - 17*s + 14) - fd*(20*C*(8*r**2 - 6*r + 1) + 224*r**2 + 304*r*s - 206*r - 114*s + 47)) - Ddd*f*(10*C*(4*r**2 - 2*r + 1) + 56*r**2 + 76*r*s - 47*r - 19*s + 14)) - 3*Dd**2*f**2*(-r**2*(120*C + 168) + 3*r*(20*C - 76*s + 47) + 57*s - 19)))/(105*d**2*k1*k3**2) - D1**2*Pk2*Pkd1*ct**2*st**2*(66*D1**2*bd1**2*f*(2*f*(2*r**2 - 12*r*s + r + 6*s - 3) + r**2*(14 - 14*K) + 14*r*(K - s - 1) + 7*s) + 22*D1**2*bdd1*f*(5*f**2*(6*r**2 + r*(5*s - 6) - 9*s + 4) + f*r*(r*(11 - 11*K) - 9*s) + 42*g2*(r - 1)**2) + 2*D1**2*(-5*f**3*(5*fd*(40*r**2 + 44*r*s - 31*r - 11*s + 10) + fdd*(-144*r**2 - 220*r*s + 127*r + 55*s - 36)) + f**2*(5*fd**2*(432*r**2 + 660*r*s - 381*r - 165*s + 55) + r**2*(-407*gd2 + 242*gdd2)) - 11*f*(37*fd*g2*(2*r**2 - 2*r + 1) + 44*fd*gd2*r*(1 - 2*r) - 22*fdd*g2*(2*r**2 - 2*r + 1)) + 484*fd**2*g2*r*(r - 1)) - 11*D1*bd1*(D1*(f**3*(66*r**2 + r*(46*s - 66) - 90*s + 44) - f**2*(10*fd*(36*r**2 + r*(30*s - 29) - 23*s + 7) + r*(r*(37*K - 37) + 22*s)) + 2*f*(fd*(r**2*(44*K - 44) + r*(-22*K + 36*s + 13) - 9*s) + 49*g2*(r - 1)**2 - 84*gd2*r*(r - 1)) - 168*fd*g2*r*(r - 1)) - 2*Dd*f*(5*f**2*(48*r**2 + r*(40*s - 41) - 41*s + 15) + f*(r**2*(88 - 88*K) + r*(22*K - 72*s - 13) + 9*s) + 84*g2*(4*r**2 - 5*r + 1))) + 2*D1*f*(Dd*(-25*f**3*(40*r**2 + r*(44*s - 31) - 11*s + 10) + 10*f**2*fd*(4*r - 1)*(144*r + 220*s - 91) - 11*f*(37*g2*(4*r**2 - 2*r + 1) + 44*gd2*r*(1 - 4*r)) + 484*fd*g2*(8*r**2 - 6*r + 1)) + Ddd*f*(5*f**2*(144*r**2 + 220*r*s - 127*r - 55*s + 36) + 242*g2*(4*r**2 - 2*r + 1))) + 2*Dd**2*f**2*(5*f**2*(432*r**2 + 660*r*s - 381*r - 165*s + 55) + 1452*g2*r*(2*r - 1)) + 11*b1**2*(D1**2*r*(6*f*fd*(6*r + 20*s - 5) + 6*f*fdd*(4*r - 24*s + 6) + 12*fd**2*(2*r - 12*s + 3) + 7*fd*(r*(7*K - 7) + 2*s - 2) - 42*fdd*(r*(K - 1) + s - 1)) + D1*(Dd*(6*f**2*(12*r**2 + 8*r*(5*s - 2) - 10*s + 3) + f*(49*K*(4*r**2 - 2*r + 1) + 12*fd*(16*r**2 + r*(20 - 96*s) + 12*s - 3) - 196*r**2 + 56*r*s + 84*r - 14*s - 49) - 42*fd*(r**2*(8*K - 8) + r*(-2*K + 8*s - 3) - s + 1)) + 6*Ddd*f*(-28*K*r**2 + 14*K*r - 7*K + 2*f*(4*r**2 - 24*r*s + 4*r + 6*s + 1) + 28*r**2 - 28*r*s - 7*r + 7*s + 7)) + 6*Dd**2*f*(12*f*(2*r**2 + r*(2 - 12*s) + 3*s - 1) - 7*r**2*(12*K - 12) - 7*r*(-6*K + 12*s + 3) + 21*s - 7)) + 11*b1*(74*D1**2*K*f*fd*r**2 - 74*D1**2*K*f*fd*r + 37*D1**2*K*f*fd - 44*D1**2*K*f*fdd*r**2 + 44*D1**2*K*f*fdd*r - 22*D1**2*K*f*fdd - 44*D1**2*K*fd**2*r**2 + 44*D1**2*K*fd**2*r + 6*D1**2*bdd1*f*(7*K*(-2*r**2 + 2*r - 1) + 2*f*(2*r**2 - 12*r*s + r + 6*s + 1) + 14*r**2 - 14*r*(s + 1) + 7*s + 7) - 198*D1**2*f**2*fd*r**2 - 138*D1**2*f**2*fd*r*s + 112*D1**2*f**2*fd*r - 44*D1**2*f**2*fd*s - 22*D1**2*f**2*fd + 180*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 110*D1**2*f**2*fdd*r + 40*D1**2*f**2*fdd*s + 20*D1**2*f**2*fdd + 360*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 220*D1**2*f*fd**2*r + 80*D1**2*f*fd**2*s - 20*D1**2*f*fd**2 - 74*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s + 52*D1**2*f*fd*r - 22*D1**2*f*fd*s - 37*D1**2*f*fd + 44*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s - 26*D1**2*f*fdd*r + 18*D1**2*f*fdd*s + 22*D1**2*f*fdd - 98*D1**2*f*gd2*r**2 + 84*D1**2*f*gdd2*r**2 + 44*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s - 26*D1**2*fd**2*r + 18*D1**2*fd**2*s - 18*D1**2*fd**2 - 98*D1**2*fd*g2*r**2 + 168*D1**2*fd*gd2*r**2 + 84*D1**2*fdd*g2*r**2 + 148*D1*Dd*K*f**2*r**2 - 74*D1*Dd*K*f**2*r + 37*D1*Dd*K*f**2 - 352*D1*Dd*K*f*fd*r**2 + 264*D1*Dd*K*f*fd*r - 44*D1*Dd*K*f*fd - 264*D1*Dd*f**3*r**2 - 184*D1*Dd*f**3*r*s + 178*D1*Dd*f**3*r + 46*D1*Dd*f**3*s - 66*D1*Dd*f**3 + 1440*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 950*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd*s + 70*D1*Dd*f**2*fd - 148*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s + 52*D1*Dd*f**2*r - 22*D1*Dd*f**2*s - 37*D1*Dd*f**2 + 352*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s - 156*D1*Dd*f*fd*r + 108*D1*Dd*f*fd*s + 8*D1*Dd*f*fd - 392*D1*Dd*f*g2*r**2 + 196*D1*Dd*f*g2*r - 98*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r**2 - 168*D1*Dd*f*gd2*r + 672*D1*Dd*fd*g2*r**2 - 168*D1*Dd*fd*g2*r - 88*D1*Ddd*K*f**2*r**2 + 44*D1*Ddd*K*f**2*r - 22*D1*Ddd*K*f**2 + 240*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 170*D1*Ddd*f**3*r - 50*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 88*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s - 26*D1*Ddd*f**2*r + 18*D1*Ddd*f**2*s + 22*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r**2 - 168*D1*Ddd*f*g2*r + 84*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(6*r**2 + r*(20*s - 11) - 10*s + 3) + f*(49*K*(2*r**2 - 2*r + 1) + 12*fd*(8*r**2 + r*(8 - 48*s) + 12*s - 3) - 98*r**2 + 28*r*s + 98*r - 14*s - 49) - 42*fd*(2*K*r*(2*r - 1) - 4*r**2 + 4*r*s - s + 1)) + 6*Dd*f*(-14*K*(8*r**2 - 6*r + 1) + 2*f*(16*r**2 + r*(12 - 96*s) + 36*s - 7) + 112*r**2 - 14*r*(8*s + 5) + 42*s + 7)) - 264*Dd**2*K*f**2*r**2 + 132*Dd**2*K*f**2*r + 720*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 510*Dd**2*f**3*r - 150*Dd**2*f**3*s + 50*Dd**2*f**3 + 264*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s - 78*Dd**2*f**2*r + 54*Dd**2*f**2*s - 18*Dd**2*f**2 + 1008*Dd**2*f*g2*r**2 - 504*Dd**2*f*g2*r))/(1155*d**2*k1) - D1**2*Pk2*Pkd1*ct**2*(-56*D1**2*K*bd1**2*f*r**2 - 14*D1**2*K*bd1**2*f*r - 9*D1**2*K*bd1*f**2*r**2 + 60*D1**2*K*bd1*f*fd*r**2 - 30*D1**2*K*bd1*f*fd*r + 15*D1**2*K*bdd1*f**2*r**2 + 120*D1**2*bd1**2*f**2*r**2 + 252*D1**2*bd1**2*f**2*r*s - 153*D1**2*bd1**2*f**2*r - 126*D1**2*bd1**2*f**2*s + 63*D1**2*bd1**2*f**2 + 84*D1**2*bd1**2*f*r**2 + 182*D1**2*bd1**2*f*r*s - 14*D1**2*bd1**2*f*r - 91*D1**2*bd1**2*f*s + 140*D1**2*bd1**2*g2*r**2 - 140*D1**2*bd1**2*g2*r + 14*D1**2*bd1*bd2*f*r**2 - 14*D1**2*bd1*bd2*f*r - 45*D1**2*bd1*f**3*r**2 - 90*D1**2*bd1*f**3*r*s + 45*D1**2*bd1*f**3*r + 270*D1**2*bd1*f**2*fd*r**2 + 540*D1**2*bd1*f**2*fd*r*s - 270*D1**2*bd1*f**2*fd*r - 90*D1**2*bd1*f**2*fd*s + 45*D1**2*bd1*f**2*fd - 9*D1**2*bd1*f**2*r**2 - 51*D1**2*bd1*f**2*r*s + 60*D1**2*bd1*f*fd*r**2 + 228*D1**2*bd1*f*fd*r*s - 87*D1**2*bd1*f*fd*r - 57*D1**2*bd1*f*fd*s - 112*D1**2*bd1*f*g2*r**2 + 84*D1**2*bd1*f*g2*r - 42*D1**2*bd1*f*g2 + 112*D1**2*bd1*f*gd2*r**2 + 28*D1**2*bd1*f*gd2*r + 112*D1**2*bd1*fd*g2*r**2 - 112*D1**2*bd1*fd*g2*r - 9*D1**2*bd2*f**2*r**2 + 60*D1**2*bd2*f*fd*r**2 - 30*D1**2*bd2*f*fd*r + 45*D1**2*bdd1*f**3*r**2 + 90*D1**2*bdd1*f**3*r*s - 45*D1**2*bdd1*f**3*r + 15*D1**2*bdd1*f**2*r**2 + 57*D1**2*bdd1*f**2*r*s + 56*D1**2*bdd1*f*g2*r**2 + 28*D1**2*bdd1*f*g2*r - 14*D1**2*bdd1*f*g2 + 15*D1**2*bdd2*f**2*r**2 + 18*D1**2*f**2*gd2*r**2 - 30*D1**2*f**2*gdd2*r**2 + 36*D1**2*f*fd*g2*r**2 - 36*D1**2*f*fd*g2*r + 18*D1**2*f*fd*g2 - 120*D1**2*f*fd*gd2*r**2 + 60*D1**2*f*fd*gd2*r - 60*D1**2*f*fdd*g2*r**2 + 60*D1**2*f*fdd*g2*r - 30*D1**2*f*fdd*g2 - 60*D1**2*fd**2*g2*r**2 + 60*D1**2*fd**2*g2*r + 120*D1*Dd*K*bd1*f**2*r**2 - 30*D1*Dd*K*bd1*f**2*r + 360*D1*Dd*bd1*f**3*r**2 + 720*D1*Dd*bd1*f**3*r*s - 360*D1*Dd*bd1*f**3*r - 90*D1*Dd*bd1*f**3*s + 45*D1*Dd*bd1*f**3 + 120*D1*Dd*bd1*f**2*r**2 + 456*D1*Dd*bd1*f**2*r*s - 87*D1*Dd*bd1*f**2*r - 57*D1*Dd*bd1*f**2*s + 448*D1*Dd*bd1*f*g2*r**2 - 28*D1*Dd*bd1*f*g2 + 120*D1*Dd*bd2*f**2*r**2 - 30*D1*Dd*bd2*f**2*r + 72*D1*Dd*f**2*g2*r**2 - 36*D1*Dd*f**2*g2*r + 18*D1*Dd*f**2*g2 - 240*D1*Dd*f**2*gd2*r**2 + 60*D1*Dd*f**2*gd2*r - 480*D1*Dd*f*fd*g2*r**2 + 360*D1*Dd*f*fd*g2*r - 60*D1*Dd*f*fd*g2 - 120*D1*Ddd*f**2*g2*r**2 + 60*D1*Ddd*f**2*g2*r - 30*D1*Ddd*f**2*g2 - 360*Dd**2*f**2*g2*r**2 + 180*Dd**2*f**2*g2*r + 7*b1**3*(D1**2*r**2*(3*fd + fdd) + D1*Dd*(-5*K*(4*r**2 - 2*r + 1) + 3*f*(4*r**2 - 2*r + 1) + 8*fd*r**2 - 2*fd*r + 20*r**2 - 10*r + 5) + D1*Ddd*(-5*K + f + 5)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(2*r - 1)*(-5*K + f + 5)) + b1**2*(56*D1**2*K*fd*r**2 - 70*D1**2*K*fd*r + 35*D1**2*K*fd - 28*D1**2*K*fdd*r**2 + 70*D1**2*K*fdd*r - 35*D1**2*K*fdd + 7*D1**2*bdd1*(-5*K + f + 5)*(3*r**2 - 2*r + 1) - 72*D1**2*f*fd*r**2 - 252*D1**2*f*fd*r*s + 81*D1**2*f*fd*r - 9*D1**2*f*fd + 120*D1**2*f*fdd*r**2 + 252*D1**2*f*fdd*r*s - 93*D1**2*f*fdd*r + 15*D1**2*f*fdd + 120*D1**2*fd**2*r**2 + 252*D1**2*fd**2*r*s - 93*D1**2*fd**2*r - 14*D1**2*fd*r**2 - 77*D1**2*fd*r*s + 147*D1**2*fd*r - 35*D1**2*fd + 42*D1**2*fdd*r**2 + 91*D1**2*fdd*r*s - 161*D1**2*fdd*r + 35*D1**2*fdd + 70*D1**2*gd2*r**2 + 70*D1**2*gdd2*r**2 + 224*D1*Dd*K*f*r**2 - 112*D1*Dd*K*f*r + 56*D1*Dd*K*f - 224*D1*Dd*K*fd*r**2 + 336*D1*Dd*K*fd*r - 70*D1*Dd*K*fd - 144*D1*Dd*f**2*r**2 - 504*D1*Dd*f**2*r*s + 198*D1*Dd*f**2*r + 126*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 960*D1*Dd*f*fd*r**2 + 2016*D1*Dd*f*fd*r*s - 864*D1*Dd*f*fd*r - 252*D1*Dd*f*fd*s + 93*D1*Dd*f*fd - 56*D1*Dd*f*r**2 - 308*D1*Dd*f*r*s + 105*D1*Dd*f*r + 77*D1*Dd*f*s - 14*D1*Dd*f + 336*D1*Dd*fd*r**2 + 728*D1*Dd*fd*r*s - 819*D1*Dd*fd*r - 91*D1*Dd*fd*s + 161*D1*Dd*fd + 280*D1*Dd*g2*r**2 - 140*D1*Dd*g2*r + 70*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 - 140*D1*Dd*gd2*r - 112*D1*Ddd*K*f*r**2 + 56*D1*Ddd*K*f*r - 28*D1*Ddd*K*f + 240*D1*Ddd*f**2*r**2 + 504*D1*Ddd*f**2*r*s - 246*D1*Ddd*f**2*r - 126*D1*Ddd*f**2*s + 60*D1*Ddd*f**2 + 168*D1*Ddd*f*r**2 + 364*D1*Ddd*f*r*s - 175*D1*Ddd*f*r - 91*D1*Ddd*f*s + 42*D1*Ddd*f + 280*D1*Ddd*g2*r**2 - 140*D1*Ddd*g2*r + 70*D1*Ddd*g2 + 7*D1*bd1*(D1*(-5*K*(3*r**2 - 2*r + 1) + f*(9*r**2 - 6*r + 3) + 6*fd*r**2 - 2*fd*r + 15*r**2 - 10*r + 5) + 2*Dd*(-5*K + f + 5)*(12*r**2 - 7*r + 1)) - 336*Dd**2*K*f*r**2 + 168*Dd**2*K*f*r + 720*Dd**2*f**2*r**2 + 1512*Dd**2*f**2*r*s - 738*Dd**2*f**2*r - 378*Dd**2*f**2*s + 126*Dd**2*f**2 + 504*Dd**2*f*r**2 + 1092*Dd**2*f*r*s - 525*Dd**2*f*r - 273*Dd**2*f*s + 91*Dd**2*f + 840*Dd**2*g2*r**2 - 420*Dd**2*g2*r) + b1*(-18*D1**2*K*f*fd*r**2 + 18*D1**2*K*f*fd*r - 9*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 - 30*D1**2*K*f*fdd*r + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 - 30*D1**2*K*fd**2*r + 21*D1**2*b2*fd*r**2 + 7*D1**2*b2*fdd*r**2 + 14*D1**2*bd1**2*r*(3*r - 2)*(-5*K + f + 5) + 21*D1**2*bd2*f*r**2 + 14*D1**2*bd2*fd*r**2 + D1**2*bdd1*(3*f**2*(40*r**2 + r*(84*s - 51) - 42*s + 15) - 7*f*(K*(8*r**2 + 2*r - 1) - 12*r**2 - 26*r*s + 2*r + 13*s - 1) + 70*g2*(2*r**2 - 2*r + 1)) + 7*D1**2*bdd2*f*r**2 - 135*D1**2*f**2*fd*r**2 - 270*D1**2*f**2*fd*r*s + 135*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s - 45*D1**2*f**2*fd + 135*D1**2*f**2*fdd*r**2 + 270*D1**2*f**2*fdd*r*s - 135*D1**2*f**2*fdd*r - 90*D1**2*f**2*fdd*s + 45*D1**2*f**2*fdd + 270*D1**2*f*fd**2*r**2 + 540*D1**2*f*fd**2*r*s - 270*D1**2*f*fd**2*r - 180*D1**2*f*fd**2*s + 45*D1**2*f*fd**2 - 18*D1**2*f*fd*r**2 - 102*D1**2*f*fd*r*s + 69*D1**2*f*fd*r + 51*D1**2*f*fd*s - 9*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 114*D1**2*f*fdd*r*s - 87*D1**2*f*fdd*r - 57*D1**2*f*fdd*s + 15*D1**2*f*fdd - 112*D1**2*f*gd2*r**2 + 56*D1**2*f*gdd2*r**2 + 30*D1**2*fd**2*r**2 + 114*D1**2*fd**2*r*s - 87*D1**2*fd**2*r - 57*D1**2*fd**2*s + 57*D1**2*fd**2 - 112*D1**2*fd*g2*r**2 + 140*D1**2*fd*g2*r - 70*D1**2*fd*g2 + 112*D1**2*fd*gd2*r**2 - 140*D1**2*fd*gd2*r + 56*D1**2*fdd*g2*r**2 - 140*D1**2*fdd*g2*r + 70*D1**2*fdd*g2 - 36*D1*Dd*K*f**2*r**2 + 18*D1*Dd*K*f**2*r - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 - 180*D1*Dd*K*f*fd*r + 30*D1*Dd*K*f*fd + 84*D1*Dd*b2*f*r**2 - 42*D1*Dd*b2*f*r + 21*D1*Dd*b2*f + 56*D1*Dd*b2*fd*r**2 - 14*D1*Dd*b2*fd*r + 56*D1*Dd*bd2*f*r**2 - 14*D1*Dd*bd2*f*r - 180*D1*Dd*f**3*r**2 - 360*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r + 90*D1*Dd*f**3*s - 45*D1*Dd*f**3 + 1080*D1*Dd*f**2*fd*r**2 + 2160*D1*Dd*f**2*fd*r*s - 1080*D1*Dd*f**2*fd*r - 630*D1*Dd*f**2*fd*s + 225*D1*Dd*f**2*fd - 36*D1*Dd*f**2*r**2 - 204*D1*Dd*f**2*r*s + 69*D1*Dd*f**2*r + 51*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 912*D1*Dd*f*fd*r*s - 522*D1*Dd*f*fd*r - 342*D1*Dd*f*fd*s + 144*D1*Dd*f*fd - 448*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r - 112*D1*Dd*f*g2 + 448*D1*Dd*f*gd2*r**2 - 112*D1*Dd*f*gd2*r + 448*D1*Dd*fd*g2*r**2 - 672*D1*Dd*fd*g2*r + 140*D1*Dd*fd*g2 + 60*D1*Ddd*K*f**2*r**2 - 30*D1*Ddd*K*f**2*r + 15*D1*Ddd*K*f**2 + 28*D1*Ddd*b2*f*r**2 - 14*D1*Ddd*b2*f*r + 7*D1*Ddd*b2*f + 180*D1*Ddd*f**3*r**2 + 360*D1*Ddd*f**3*r*s - 180*D1*Ddd*f**3*r - 90*D1*Ddd*f**3*s + 45*D1*Ddd*f**3 + 60*D1*Ddd*f**2*r**2 + 228*D1*Ddd*f**2*r*s - 87*D1*Ddd*f**2*r - 57*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 224*D1*Ddd*f*g2*r**2 - 112*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2 + D1*bd1*(D1*(-9*f**2*(8*r**2 + r*(28*s - 13) - 14*s + 3) + f*(7*K*(16*r**2 - 6*r + 3) + 3*fd*(160*r**2 + 4*r*(84*s - 41) - 84*s + 21) - 28*r**2 - 154*r*s - 42*r + 77*s + 21) - 7*fd*(r**2*(16*K - 24) - 2*r*(9*K + 26*s - 24) + 13*s - 13) + 70*g2*(2*r**2 - 2*r + 1) + 140*gd2*r*(2*r - 1)) + Dd*(3*f**2*(8*r - 3)*(40*r + 84*s - 31) - 7*f*(K*(64*r**2 - 8*r - 2) - 96*r**2 - 208*r*s + 58*r + 78*s - 15) + 140*g2*(8*r**2 - 6*r + 1))) + 180*Dd**2*K*f**2*r**2 - 90*Dd**2*K*f**2*r + 84*Dd**2*b2*f*r**2 - 42*Dd**2*b2*f*r + 540*Dd**2*f**3*r**2 + 1080*Dd**2*f**3*r*s - 540*Dd**2*f**3*r - 270*Dd**2*f**3*s + 90*Dd**2*f**3 + 180*Dd**2*f**2*r**2 + 684*Dd**2*f**2*r*s - 261*Dd**2*f**2*r - 171*Dd**2*f**2*s + 57*Dd**2*f**2 + 672*Dd**2*f*g2*r**2 - 336*Dd**2*f*g2*r) + b2*(7*D1**2*bdd1*f*(r - 1)**2 - 3*D1**2*(f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) - 10*fd**2*r*(r - 1)) + 7*D1*bd1*(r - 1)*(3*D1*f*(r - 1) + 2*D1*fd*r + 2*Dd*f*(4*r - 1)) - 3*D1*f*(3*Dd*f*(4*r**2 - 2*r + 1) - 10*Dd*fd*(8*r**2 - 6*r + 1) - 5*Ddd*f*(4*r**2 - 2*r + 1)) - 90*Dd**2*f**2*r*(1 - 2*r)))/(105*d**2*k1) + 2*D1**2*Pk2*Pkd1*ct*f*k2*st**4*(66*D1**2*b1*f*fd*r**2 - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 11*D1**2*bdd1*f**2*(r - 1)**2 + 64*D1**2*f**2*fd*r**2 - 32*D1**2*f**2*fd*r + 16*D1**2*f**2*fd - 32*D1**2*f**2*fdd*r**2 + 16*D1**2*f**2*fdd*r - 8*D1**2*f**2*fdd - 96*D1**2*f*fd**2*r**2 + 48*D1**2*f*fd**2*r + 88*D1*Dd*b1*f**2*r**2 - 44*D1*Dd*b1*f**2*r + 22*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 + 66*D1*Dd*b1*f*fd*r + 64*D1*Dd*f**3*r**2 - 32*D1*Dd*f**3*r + 16*D1*Dd*f**3 - 256*D1*Dd*f**2*fd*r**2 + 128*D1*Dd*f**2*fd*r - 16*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 + 22*D1*Ddd*b1*f**2*r - 11*D1*Ddd*b1*f**2 - 32*D1*Ddd*f**3*r**2 + 16*D1*Ddd*f**3*r - 8*D1*Ddd*f**3 + 22*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 132*Dd**2*b1*f**2*r**2 + 66*Dd**2*b1*f**2*r - 96*Dd**2*f**3*r**2 + 48*Dd**2*f**3*r)/(231*d**2*k1**2) + 2*D1**2*Pk2*Pkd1*ct*k1**4*st**2*(6*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fd*r*s - 3*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 18*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 3*D1**2*f**2*fd*r**2 - 3*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r + D1**2*f**2*fd*s - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r - 10*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 + 12*D1*Dd*b1*f**2*r**2 + 12*D1*Dd*b1*f**2*r*s - 9*D1*Dd*b1*f**2*r - 3*D1*Dd*b1*f**2*s + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 90*D1*Dd*b1*f*fd*r - 18*D1*Dd*b1*f*fd*s + 9*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 4*D1*Dd*f**3*r*s + 3*D1*Dd*f**3*r + D1*Dd*f**3*s - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 105*D1*Dd*f**2*fd*r - 35*D1*Dd*f**2*fd*s + 20*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 27*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 15*D1*Ddd*f**3*r - 5*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 3*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 108*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 81*Dd**2*b1*f**2*r - 27*Dd**2*b1*f**2*s + 9*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 45*Dd**2*f**3*r - 15*Dd**2*f**3*s + 5*Dd**2*f**3)/(315*d**2*k2*k3**4) - 2*D1**2*Pk2*Pkd1*ct*k1**4*(-3*D1*f*(7*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-3*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 5*fd*(8*r - 3)*(2*r + 2*s - 1)) + 5*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)))/(105*d**2*k2*k3**4) + 2*D1**2*Pk2*Pkd1*ct*k1**2*k2*st**4*(2*D1**2*b1*f*fd*r**2 + 2*D1**2*b1*f*fd*r*s - D1**2*b1*f*fd*r + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*f*fdd*r*s - 3*D1**2*b1*f*fdd*r + 6*D1**2*b1*fd**2*r**2 + 6*D1**2*b1*fd**2*r*s - 3*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 3*D1**2*f**2*fd*r**2 - 3*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r + D1**2*f**2*fd*s - D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 + 4*D1*Dd*b1*f**2*r**2 + 4*D1*Dd*b1*f**2*r*s - 3*D1*Dd*b1*f**2*r - D1*Dd*b1*f**2*s + D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 48*D1*Dd*b1*f*fd*r*s - 30*D1*Dd*b1*f*fd*r - 6*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 4*D1*Dd*f**3*r*s + 3*D1*Dd*f**3*r + D1*Dd*f**3*s - D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 21*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 4*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 + 12*D1*Ddd*b1*f**2*r*s - 9*D1*Ddd*b1*f**2*r - 3*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r - D1*Ddd*f**3*s + D1*Ddd*f**3 + D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 3*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 36*Dd**2*b1*f**2*r**2 + 36*Dd**2*b1*f**2*r*s - 27*Dd**2*b1*f**2*r - 9*Dd**2*b1*f**2*s + 3*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 9*Dd**2*f**3*r - 3*Dd**2*f**3*s + Dd**2*f**3)/(35*d**2*k3**4) - 2*D1**2*Pk2*Pkd1*ct*k1**2*k2*st**2*(21*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 3*b1*(20*C*D1**2*f*fd*r**2 + 20*C*D1**2*f*fd*r*s - 10*C*D1**2*f*fd*r - 108*C*D1**2*f*fdd*r**2 - 108*C*D1**2*f*fdd*r*s + 54*C*D1**2*f*fdd*r - 108*C*D1**2*fd**2*r**2 - 108*C*D1**2*fd**2*r*s + 54*C*D1**2*fd**2*r + 40*C*D1*Dd*f**2*r**2 + 40*C*D1*Dd*f**2*r*s - 30*C*D1*Dd*f**2*r - 10*C*D1*Dd*f**2*s + 10*C*D1*Dd*f**2 - 864*C*D1*Dd*f*fd*r**2 - 864*C*D1*Dd*f*fd*r*s + 540*C*D1*Dd*f*fd*r + 108*C*D1*Dd*f*fd*s - 54*C*D1*Dd*f*fd - 216*C*D1*Ddd*f**2*r**2 - 216*C*D1*Ddd*f**2*r*s + 162*C*D1*Ddd*f**2*r + 54*C*D1*Ddd*f**2*s - 54*C*D1*Ddd*f**2 - 648*C*Dd**2*f**2*r**2 - 648*C*Dd**2*f**2*r*s + 486*C*Dd**2*f**2*r + 162*C*Dd**2*f**2*s - 54*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) + 20*D1**2*f*fd*r**2 + 20*D1**2*f*fd*r*s - 21*D1**2*f*fd*r - 11*D1**2*f*fd*s + 11*D1**2*f*fd - 24*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 21*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 9*D1**2*f*fdd - 24*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 21*D1**2*fd**2*r + 9*D1**2*fd**2*s + 40*D1*Dd*f**2*r**2 + 40*D1*Dd*f**2*r*s - 30*D1*Dd*f**2*r - 10*D1*Dd*f**2*s + 10*D1*Dd*f**2 - 192*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 156*D1*Dd*f*fd*r + 60*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 48*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s - 12*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 144*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 108*Dd**2*f**2*r + 36*Dd**2*f**2*s - 12*Dd**2*f**2) + f*(162*C*D1**2*f*fd*r**2 + 162*C*D1**2*f*fd*r*s - 162*C*D1**2*f*fd*r - 54*C*D1**2*f*fd*s + 54*C*D1**2*f*fd - 270*C*D1**2*f*fdd*r**2 - 270*C*D1**2*f*fdd*r*s + 270*C*D1**2*f*fdd*r + 90*C*D1**2*f*fdd*s - 90*C*D1**2*f*fdd - 540*C*D1**2*fd**2*r**2 - 540*C*D1**2*fd**2*r*s + 540*C*D1**2*fd**2*r + 180*C*D1**2*fd**2*s - 90*C*D1**2*fd**2 + 216*C*D1*Dd*f**2*r**2 + 216*C*D1*Dd*f**2*r*s - 162*C*D1*Dd*f**2*r - 54*C*D1*Dd*f**2*s + 54*C*D1*Dd*f**2 - 2160*C*D1*Dd*f*fd*r**2 - 2160*C*D1*Dd*f*fd*r*s + 1890*C*D1*Dd*f*fd*r + 630*C*D1*Dd*f*fd*s - 360*C*D1*Dd*f*fd - 360*C*D1*Ddd*f**2*r**2 - 360*C*D1*Ddd*f**2*r*s + 270*C*D1*Ddd*f**2*r + 90*C*D1*Ddd*f**2*s - 90*C*D1*Ddd*f**2 - 1080*C*Dd**2*f**2*r**2 - 1080*C*Dd**2*f**2*r*s + 810*C*Dd**2*f**2*r + 270*C*Dd**2*f**2*s - 90*C*Dd**2*f**2 - 63*D1**2*bd1**2*(2*r - 1)*(r + s - 1) - 9*D1**2*bdd1*f*(r + s - 1)*(18*C*(r - 1) + 4*r - 1) + 3*D1**2*f*fd*r**2 + 3*D1**2*f*fd*r*s - 3*D1**2*f*fd*r - D1**2*f*fd*s + D1**2*f*fd - 15*D1**2*f*fdd*r**2 - 15*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 30*D1**2*fd**2*r*s + 30*D1**2*fd**2*r + 10*D1**2*fd**2*s - 5*D1**2*fd**2 + 4*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r*s - 3*D1*Dd*f**2*r - D1*Dd*f**2*s + D1*Dd*f**2 - 120*D1*Dd*f*fd*r**2 - 120*D1*Dd*f*fd*r*s + 105*D1*Dd*f*fd*r + 35*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(r + s - 1)*(10*C*(r - 1) + 10*r + 1) - 3*fd*(18*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 16*r**2 + 16*r*s - 17*r - 5*s + 4)) - 6*Dd*f*(9*C*(8*r**2 + 8*r*s - 11*r - 5*s + 3) + (4*r - 1)*(4*r + 4*s - 3))) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 45*Dd**2*f**2*r + 15*Dd**2*f**2*s - 5*Dd**2*f**2))/(315*d**2*k3**4) - D1**2*Pk2*Pkd1*ct*k1**2*k2*(12*C + 2)*(-3*D1*f*(7*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-3*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 5*fd*(8*r - 3)*(2*r + 2*s - 1)) + 5*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)))/(105*d**2*k3**4) - 8*D1**2*Pk2*Pkd1*ct*k1**2*st**4*(3*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-4*r*s + r + 2*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 3*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 7*r + 7*s - 2)) + D1*(D1*(2*f*fd*(r*(3*s - 1) - s) + f*(-3*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) + fd**2*(r*(2 - 6*s) + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k2*k3**2) + D1**2*Pk2*Pkd1*ct*k1**2*st**2*(84*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) - 6*D1*bd1*(14*b1*(D1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) - 2*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(f*(-20*C*s - 11*r**2 + 2*r*(10*C*s - 2*s + 5) + 16*s - 11) + 2*fd*(-12*C*(4*r*s - r - 2*s + 1) + 25*r**2 + 60*r*s - 37*r - 33*s + 15)) + Dd*f*(-24*C*(8*r*s - r - 5*s + 1) + 100*r**2 + 240*r*s - 131*r - 174*s + 55))) + 84*b1**2*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) - 3*b1*(-2*D1**2*(14*bdd1*f*(r*(2*s - 1) - s) + f*(2*fd*(11*r**2 + r*(-20*C*s + 10*C + 4*s - 8) + 6*s) - fdd*(25*r**2 - 12*r*(4*C*s - 2*C - 5*s + 3) + 6*s)) - fd**2*(25*r**2 - 12*r*(4*C*s - 2*C - 5*s + 3) + 6*s)) + D1*f*(-2*Dd*f*(20*C*s + 44*r**2 + r*(-80*C*s + 20*C + 16*s - 26) - 4*s + 11) + 4*Dd*fd*(-12*C*(16*r*s - 6*r - 2*s + 1) + 100*r**2 + 240*r*s - 127*r - 18*s + 15) + Ddd*f*(48*C*s + 100*r**2 - 2*r*(96*C*s - 24*C - 120*s + 55) - 60*s + 25)) - 6*Dd**2*f**2*(8*C*(3*r*(4*s - 1) - 3*s + 1) - 50*r**2 - 5*r*(24*s - 11) + 30*s - 10)) - f*(3*D1**2*bdd1*f*(48*C*s + 25*r**2 + r*(-48*C*s + 60*s - 38) - 72*s + 25) + D1**2*(f*(-2*fd*(44*C*s + 75*r**2 + r*(-132*C*s + 44*C + 96*s - 82) - 32*s + 25) + fdd*(80*C*s + 129*r**2 + r*(-240*C*s + 80*C + 312*s - 190) - 104*s + 43)) + 2*fd**2*(-40*C*(6*r*s - 2*r - 2*s + 1) + 129*r**2 + 312*r*s - 190*r - 104*s + 52)) + D1*f*(2*Dd*(-f*(44*C*s + 100*r**2 - 2*r*(88*C*s - 22*C - 64*s + 41) - 32*s + 25) + fd*(-40*C*(24*r*s - 7*r - 7*s + 2) + 516*r**2 + 1248*r*s - 665*r - 364*s + 147)) + Ddd*f*(80*C*s + 172*r**2 + r*(-320*C*s + 80*C + 416*s - 190) - 104*s + 43)) + 2*Dd**2*f**2*(-40*C*(12*r*s - 3*r - 3*s + 1) + 258*r**2 + 624*r*s - 285*r - 156*s + 52)))/(315*d**2*k2*k3**2) - 2*D1**2*Pk2*Pkd1*ct*k1**2*(7*b1**2*(D1**2*r*(-4*fd*r + fd*s*(2*C - 8) + 7*fdd*r + fdd*s*(14 - 6*C)) + D1*(-2*Dd*(f*(8*r**2 + r*(-4*C*s + C + 16*s - 8) + s*(C - 4) + 2) + fd*(-28*r**2 + r*(3*C*(8*s - 1) - 56*s + 14) + s*(7 - 3*C))) + Ddd*f*(28*r**2 + r*(C*(6 - 24*s) + 56*s - 28) + s*(6*C - 14) + 7)) + 2*Dd**2*f*(C*(r*(9 - 36*s) + 9*s - 3) + 42*r**2 + 42*r*(2*s - 1) - 21*s + 7)) + b1*(7*D1**2*bdd1*f*(C*r*(6 - 12*s) + 14*r**2 + 28*r*(s - 1) + s*(6*C - 14) + 7) - 6*D1**2*(f*(fd*(3*C*s + 10*r**2 + r*(8*C*s - 7*C + 16*s - 10) - 8*s + 5) - fdd*(5*C*s + 12*r**2 + r*(4*C*s - 7*C + 22*s - 12) - 11*s + 6)) + fd**2*(-12*r**2 + r*(-4*C*s + 7*C - 22*s + 12) + s*(11 - 5*C))) + 14*D1*bd1*(-D1*(f*(4*r**2 + r*(-2*C*s + C + 8*s - 8) + s*(C - 4) + 2) + fd*(-14*r**2 + r*(3*C*(4*s - 1) - 28*s + 14) + s*(7 - 3*C))) + Dd*f*(-6*C*(r*(8*s - 3) - 3*s + 1) + 56*r**2 + 28*r*(4*s - 3) - 42*s + 21)) - 6*D1*f*(Dd*(f*(20*r**2 + 2*r*(C*(8*s - 2) + 16*s - 9) - s*(4*C + 8) + 5) - fd*(2*C*(16*r*(s - 1) + 8*s + 1) + 96*r**2 + 2*r*(88*s - 47) - 66*s + 23)) + Ddd*f*(-24*r**2 + r*(C*(2 - 8*s) - 44*s + 23) + s*(2*C + 11) - 6)) - 6*Dd**2*f**2*(C*(r*(6 - 24*s) + 6*s - 2) - 72*r**2 + r*(69 - 132*s) + 33*s - 11)) - 2*f*(-3*C*(-5*D1*Dd*f*(f*(r*(4*s - 1) - s) + fd*(r*(7 - 24*s) + 7*s - 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(bdd1*r*(2*s + 5) - 7*bdd1*s + 5*fdd*r*(3*s - 1) - 5*fdd*s) + 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(4*s - 1) - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 7*D1**2*bd1**2*(C*(r*(6*s - 3) - 3*s + 3) - 7*r**2 - 14*r*(s - 1) + 7*s - 7) - 3*D1**2*bdd1*f*r*(6*r + 11*s - 11) + 3*D1*bd1*(D1*(f*(-7*C*s + 5*r**2 + r*(4*C*s + 3*C + 8*s - 8)) - fd*(C*(8*r*s + 3*r - 9*s + 2) + 24*r**2 + 44*r*s - 34*r - 11*s + 11)) - Dd*f*(2*C*(8*r*s + 9*r - 15*s + 1) + 48*r**2 + 88*r*s - 67*r - 11*s + 11))))/(105*d**2*k2*k3**2) - 2*D1**2*Pk2*Pkd1*ct*k2**3*st**4*(36*C*D1**2*b1*f*fd*r**2 + 36*C*D1**2*b1*f*fd*r*s - 18*C*D1**2*b1*f*fd*r - 60*C*D1**2*b1*f*fdd*r**2 - 60*C*D1**2*b1*f*fdd*r*s + 30*C*D1**2*b1*f*fdd*r - 60*C*D1**2*b1*fd**2*r**2 - 60*C*D1**2*b1*fd**2*r*s + 30*C*D1**2*b1*fd**2*r + 42*C*D1**2*f**2*fd*r**2 + 42*C*D1**2*f**2*fd*r*s - 42*C*D1**2*f**2*fd*r - 14*C*D1**2*f**2*fd*s + 14*C*D1**2*f**2*fd - 30*C*D1**2*f**2*fdd*r**2 - 30*C*D1**2*f**2*fdd*r*s + 30*C*D1**2*f**2*fdd*r + 10*C*D1**2*f**2*fdd*s - 10*C*D1**2*f**2*fdd - 60*C*D1**2*f*fd**2*r**2 - 60*C*D1**2*f*fd**2*r*s + 60*C*D1**2*f*fd**2*r + 20*C*D1**2*f*fd**2*s - 10*C*D1**2*f*fd**2 + 72*C*D1*Dd*b1*f**2*r**2 + 72*C*D1*Dd*b1*f**2*r*s - 54*C*D1*Dd*b1*f**2*r - 18*C*D1*Dd*b1*f**2*s + 18*C*D1*Dd*b1*f**2 - 480*C*D1*Dd*b1*f*fd*r**2 - 480*C*D1*Dd*b1*f*fd*r*s + 300*C*D1*Dd*b1*f*fd*r + 60*C*D1*Dd*b1*f*fd*s - 30*C*D1*Dd*b1*f*fd + 56*C*D1*Dd*f**3*r**2 + 56*C*D1*Dd*f**3*r*s - 42*C*D1*Dd*f**3*r - 14*C*D1*Dd*f**3*s + 14*C*D1*Dd*f**3 - 240*C*D1*Dd*f**2*fd*r**2 - 240*C*D1*Dd*f**2*fd*r*s + 210*C*D1*Dd*f**2*fd*r + 70*C*D1*Dd*f**2*fd*s - 40*C*D1*Dd*f**2*fd - 120*C*D1*Ddd*b1*f**2*r**2 - 120*C*D1*Ddd*b1*f**2*r*s + 90*C*D1*Ddd*b1*f**2*r + 30*C*D1*Ddd*b1*f**2*s - 30*C*D1*Ddd*b1*f**2 - 40*C*D1*Ddd*f**3*r**2 - 40*C*D1*Ddd*f**3*r*s + 30*C*D1*Ddd*f**3*r + 10*C*D1*Ddd*f**3*s - 10*C*D1*Ddd*f**3 - 360*C*Dd**2*b1*f**2*r**2 - 360*C*Dd**2*b1*f**2*r*s + 270*C*Dd**2*b1*f**2*r + 90*C*Dd**2*b1*f**2*s - 30*C*Dd**2*b1*f**2 - 120*C*Dd**2*f**3*r**2 - 120*C*Dd**2*f**3*r*s + 90*C*Dd**2*f**3*r + 30*C*Dd**2*f**3*s - 10*C*Dd**2*f**3 - 6*D1**2*b1*f*fd*r**2 - 6*D1**2*b1*f*fd*r*s + 3*D1**2*b1*f*fd*r - 18*D1**2*b1*f*fdd*r**2 - 18*D1**2*b1*f*fdd*r*s + 9*D1**2*b1*f*fdd*r - 18*D1**2*b1*fd**2*r**2 - 18*D1**2*b1*fd**2*r*s + 9*D1**2*b1*fd**2*r - 3*D1**2*bdd1*f**2*(10*C + 3)*(r - 1)*(r + s - 1) + 9*D1**2*f**2*fd*r**2 + 9*D1**2*f**2*fd*r*s - 9*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s + 3*D1**2*f**2*fd - 9*D1**2*f**2*fdd*r**2 - 9*D1**2*f**2*fdd*r*s + 9*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s - 3*D1**2*f**2*fdd - 18*D1**2*f*fd**2*r**2 - 18*D1**2*f*fd**2*r*s + 18*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s - 3*D1**2*f*fd**2 - 12*D1*Dd*b1*f**2*r**2 - 12*D1*Dd*b1*f**2*r*s + 9*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2*s - 3*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 144*D1*Dd*b1*f*fd*r*s + 90*D1*Dd*b1*f*fd*r + 18*D1*Dd*b1*f*fd*s - 9*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r**2 + 12*D1*Dd*f**3*r*s - 9*D1*Dd*f**3*r - 3*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 72*D1*Dd*f**2*fd*r**2 - 72*D1*Dd*f**2*fd*r*s + 63*D1*Dd*f**2*fd*r + 21*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 36*D1*Ddd*b1*f**2*r*s + 27*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2*s - 9*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 12*D1*Ddd*f**3*r*s + 9*D1*Ddd*f**3*r + 3*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(6*C - 1)*(r - 1)*(r + s - 1) - fd*(10*C + 3)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(10*C + 3)*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 108*Dd**2*b1*f**2*r**2 - 108*Dd**2*b1*f**2*r*s + 81*Dd**2*b1*f**2*r + 27*Dd**2*b1*f**2*s - 9*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 36*Dd**2*f**3*r*s + 27*Dd**2*f**3*r + 9*Dd**2*f**3*s - 3*Dd**2*f**3)/(105*d**2*k3**4) + D1**2*Pk2*Pkd1*ct*k2**3*st**2*(4*C + 2)*(D1*f*(21*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-11*f*r*(r + s - 1) + 9*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 9*D1*bdd1*f*r*(r + s - 1) + 9*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) - 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(21*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r*s + 22*D1**2*f*fd*r + 11*D1**2*f*fd*s - 11*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*r - 9*D1**2*fd**2*s - 44*D1*Dd*f**2*r**2 - 44*D1*Dd*f**2*r*s + 33*D1*Dd*f**2*r + 11*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 144*D1*Dd*f*fd*r*s - 126*D1*Dd*f*fd*r - 54*D1*Dd*f*fd*s + 27*D1*Dd*f*fd + 36*D1*Ddd*f**2*r**2 + 36*D1*Ddd*f**2*r*s - 27*D1*Ddd*f**2*r - 9*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 - 7*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 108*Dd**2*f**2*r**2 + 108*Dd**2*f**2*r*s - 81*Dd**2*f**2*r - 27*Dd**2*f**2*s + 9*Dd**2*f**2))/(105*d**2*k3**4) - 2*D1**2*Pk2*Pkd1*ct*k2*st**4*(48*C*D1**2*b1*f*fd*r**2 - 24*C*D1**2*b1*f*fd*r*s + 12*C*D1**2*b1*f*fd*r - 24*C*D1**2*b1*f*fdd*r**2 - 72*C*D1**2*b1*f*fdd*r*s + 36*C*D1**2*b1*f*fdd*r - 24*C*D1**2*b1*fd**2*r**2 - 72*C*D1**2*b1*fd**2*r*s + 36*C*D1**2*b1*fd**2*r + 24*C*D1**2*f**2*fd*r**2 + 36*C*D1**2*f**2*fd*r*s - 28*C*D1**2*f**2*fd*r - 12*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r**2 - 36*C*D1**2*f**2*fdd*r*s + 20*C*D1**2*f**2*fdd*r + 12*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r**2 - 72*C*D1**2*f*fd**2*r*s + 40*C*D1**2*f*fd**2*r + 24*C*D1**2*f*fd**2*s - 12*C*D1**2*f*fd**2 + 96*C*D1*Dd*b1*f**2*r**2 - 48*C*D1*Dd*b1*f**2*r*s - 36*C*D1*Dd*b1*f**2*r + 12*C*D1*Dd*b1*f**2*s + 24*C*D1*Dd*b1*f**2 - 192*C*D1*Dd*b1*f*fd*r**2 - 576*C*D1*Dd*b1*f*fd*r*s + 264*C*D1*Dd*b1*f*fd*r + 72*C*D1*Dd*b1*f*fd*s - 36*C*D1*Dd*b1*f*fd + 32*C*D1*Dd*f**3*r**2 + 48*C*D1*Dd*f**3*r*s - 28*C*D1*Dd*f**3*r - 12*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r**2 - 288*C*D1*Dd*f**2*fd*r*s + 140*C*D1*Dd*f**2*fd*r + 84*C*D1*Dd*f**2*fd*s - 32*C*D1*Dd*f**2*fd - 48*C*D1*Ddd*b1*f**2*r**2 - 144*C*D1*Ddd*b1*f**2*r*s + 60*C*D1*Ddd*b1*f**2*r + 36*C*D1*Ddd*b1*f**2*s - 12*C*D1*Ddd*b1*f**2 - 16*C*D1*Ddd*f**3*r**2 - 48*C*D1*Ddd*f**3*r*s + 20*C*D1*Ddd*f**3*r + 12*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 144*C*Dd**2*b1*f**2*r**2 - 432*C*Dd**2*b1*f**2*r*s + 180*C*Dd**2*b1*f**2*r + 108*C*Dd**2*b1*f**2*s - 36*C*Dd**2*b1*f**2 - 48*C*Dd**2*f**3*r**2 - 144*C*Dd**2*f**3*r*s + 60*C*Dd**2*f**3*r + 36*C*Dd**2*f**3*s - 12*C*Dd**2*f**3 - 54*D1**2*b1*f*fd*r**2 + 84*D1**2*b1*f*fd*r*s - 42*D1**2*b1*f*fd*r + 48*D1**2*b1*f*fdd*r**2 + 48*D1**2*b1*fd**2*r**2 - 12*D1**2*bdd1*f**2*(r - 1)*(C*(r + 3*s - 1) - 2*r + 2) - 45*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 27*D1**2*f**2*fdd*r**2 - 18*D1**2*f**2*fdd*r + 9*D1**2*f**2*fdd + 54*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r - 108*D1*Dd*b1*f**2*r**2 + 168*D1*Dd*b1*f**2*r*s + 12*D1*Dd*b1*f**2*r - 42*D1*Dd*b1*f**2*s - 27*D1*Dd*b1*f**2 + 384*D1*Dd*b1*f*fd*r**2 - 96*D1*Dd*b1*f*fd*r - 60*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s + 24*D1*Dd*f**3*r - 6*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 216*D1*Dd*f**2*fd*r**2 - 126*D1*Dd*f**2*fd*r + 18*D1*Dd*f**2*fd + 96*D1*Ddd*b1*f**2*r**2 - 48*D1*Ddd*b1*f**2*r + 24*D1*Ddd*b1*f**2 + 36*D1*Ddd*f**3*r**2 - 18*D1*Ddd*f**3*r + 9*D1*Ddd*f**3 + 3*D1*bd1*f*(-4*C*Dd*f*(8*r - 5)*(r + 3*s - 1) + D1*f*(r - 1)*(8*C*r - 4*C*(s + 2) - 9*r + 14*s + 9) - 4*D1*fd*(C*(4*r**2 + r*(12*s - 7) - 6*s + 3) + r*(8 - 8*r)) + 16*Dd*f*(4*r**2 - 5*r + 1)) + 288*Dd**2*b1*f**2*r**2 - 144*Dd**2*b1*f**2*r + 108*Dd**2*f**3*r**2 - 54*Dd**2*f**3*r)/(105*d**2*k3**2) - D1**2*Pk2*Pkd1*ct*k2*st**2*(7*b1**2*(D1**2*r*(fd*(4*C - 4)*(4*r - 3*s) + fdd*r*(13 - 8*C) - fdd*s*(4*C - 4)) + D1*(2*Dd*(f*(2*C - 2)*(16*r**2 - r*(12*s + 5) + 3*s + 4) + fd*(r**2*(52 - 32*C) + r*(-16*C*s + 10*C + 16*s - 15) + s*(2*C - 2))) + Ddd*f*(-4*C*(8*r**2 + 4*r*s - 5*r - s + 2) + 52*r**2 + 16*r*s - 30*r - 4*s + 13)) + 2*Dd**2*f*(C*(-48*r**2 - 6*r*(4*s - 5) + 6*s - 2) + 78*r**2 + 3*r*(8*s - 15) - 6*s + 2)) + b1*(-344*C*D1**2*f*fd*r*s + 72*C*D1**2*f*fd*r + 4*C*D1**2*f*fd*s + 48*C*D1**2*f*fd + 168*C*D1**2*f*fdd*r**2 + 312*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 12*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd + 168*C*D1**2*fd**2*r**2 + 312*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 12*C*D1**2*fd**2*s - 688*C*D1*Dd*f**2*r*s + 172*C*D1*Dd*f**2*r + 172*C*D1*Dd*f**2*s + 1344*C*D1*Dd*f*fd*r**2 + 2496*C*D1*Dd*f*fd*r*s - 1128*C*D1*Dd*f*fd*r - 264*C*D1*Dd*f*fd*s + 108*C*D1*Dd*f*fd + 336*C*D1*Ddd*f**2*r**2 + 624*C*D1*Ddd*f**2*r*s - 324*C*D1*Ddd*f**2*r - 156*C*D1*Ddd*f**2*s + 84*C*D1*Ddd*f**2 + 1008*C*Dd**2*f**2*r**2 + 1872*C*Dd**2*f**2*r*s - 972*C*Dd**2*f**2*r - 468*C*Dd**2*f**2*s + 156*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(4*C*(4*r**2 + 2*r*s - 5*r - s + 2) - 26*r**2 - 8*r*s + 30*r + 4*s - 13) - 192*D1**2*f*fd*r**2 - 64*D1**2*f*fd*r*s + 180*D1**2*f*fd*r - 4*D1**2*f*fd*s - 72*D1**2*f*fd + 124*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s - 146*D1**2*f*fdd*r - 12*D1**2*f*fdd*s + 43*D1**2*f*fdd + 124*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s - 146*D1**2*fd**2*r - 12*D1**2*fd**2*s - 384*D1*Dd*f**2*r**2 - 128*D1*Dd*f**2*r*s + 224*D1*Dd*f**2*r + 32*D1*Dd*f**2*s - 96*D1*Dd*f**2 + 992*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 976*D1*Dd*f*fd*r - 192*D1*Dd*f*fd*s + 158*D1*Dd*f*fd + 248*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 196*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s + 62*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(2*C - 2)*(8*r**2 - r*(6*s + 5) + 3*s + 4) + fd*(r**2*(26 - 16*C) + r*(-8*C*s + 10*C + 8*s - 15) + s*(2*C - 2))) + Dd*f*(-4*C*(16*r**2 + 8*r*s - 15*r - 3*s + 3) + 104*r**2 + 32*r*s - 90*r - 12*s + 17)) + 744*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 588*Dd**2*f**2*r - 216*Dd**2*f**2*s + 72*Dd**2*f**2) + f*(-240*C*D1**2*f*fd*r**2 - 216*C*D1**2*f*fd*r*s + 232*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s - 80*C*D1**2*f*fd + 228*C*D1**2*f*fdd*r**2 + 216*C*D1**2*f*fdd*r*s - 224*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s + 76*C*D1**2*f*fdd + 456*C*D1**2*fd**2*r**2 + 432*C*D1**2*fd**2*r*s - 448*C*D1**2*fd**2*r - 144*C*D1**2*fd**2*s + 72*C*D1**2*fd**2 - 320*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 232*C*D1*Dd*f**2*r + 72*C*D1*Dd*f**2*s - 80*C*D1*Dd*f**2 + 1824*C*D1*Dd*f*fd*r**2 + 1728*C*D1*Dd*f*fd*r*s - 1568*C*D1*Dd*f*fd*r - 504*C*D1*Dd*f*fd*s + 296*C*D1*Dd*f*fd + 304*C*D1*Ddd*f**2*r**2 + 288*C*D1*Ddd*f**2*r*s - 224*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s + 76*C*D1*Ddd*f**2 + 912*C*Dd**2*f**2*r**2 + 864*C*Dd**2*f**2*r*s - 672*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 14*D1**2*bd1**2*(2*C*(4*r**2 + r*(2*s - 5) - s + 1) - 13*r**2 - 4*r*s + 15*r + 2*s - 2) + D1**2*bdd1*f*(12*C*(7*r**2 + r*(13*s - 17) - 14*s + 9) + 62*r**2 + r*(72*s - 50) - 60*s + 19) - 48*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s + 52*D1**2*f*fd*r + 20*D1**2*f*fd*s - 16*D1**2*f*fd + 33*D1**2*f*fdd*r**2 + 84*D1**2*f*fdd*r*s - 50*D1**2*f*fdd*r - 28*D1**2*f*fdd*s + 11*D1**2*f*fdd + 66*D1**2*fd**2*r**2 + 168*D1**2*fd**2*r*s - 100*D1**2*fd**2*r - 56*D1**2*fd**2*s + 28*D1**2*fd**2 - 64*D1*Dd*f**2*r**2 - 80*D1*Dd*f**2*r*s + 52*D1*Dd*f**2*r + 20*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 264*D1*Dd*f*fd*r**2 + 672*D1*Dd*f*fd*r*s - 350*D1*Dd*f*fd*r - 196*D1*Dd*f*fd*s + 78*D1*Dd*f*fd + 44*D1*Ddd*f**2*r**2 + 112*D1*Ddd*f**2*r*s - 50*D1*Ddd*f**2*r - 28*D1*Ddd*f**2*s + 11*D1*Ddd*f**2 - 2*D1*bd1*(D1*(2*f*(C*(r*(43*s - 25) - 42*s + 12) + 24*r**2 + r*(8*s - 11) - 9*s + 6) - fd*(6*C*(28*r**2 + r*(52*s - 44) - 27*s + 13) + 124*r**2 + 3*r*(48*s - 41) - 66*s + 36)) - Dd*f*(6*C*(56*r**2 + r*(104*s - 95) - 69*s + 31) + 248*r**2 + 18*r*(16*s - 11) - 156*s + 55)) + 132*Dd**2*f**2*r**2 + 336*Dd**2*f**2*r*s - 150*Dd**2*f**2*r - 84*Dd**2*f**2*s + 28*Dd**2*f**2))/(105*d**2*k3**2) + 2*D1**2*Pk2*Pkd1*ct*k2*(D1*f*(-14*D1*bd1**2*(C*(12*r**2 + r*(10*s - 17) - 5*s + 5) + 4*r**2 + 8*r*(s - 1) - 4*s + 4) - 3*D1*bdd1*f*r*(2*C*(12*r + 7*s - 7) + 7*r + 12*s - 12) - 3*bd1*(D1*(-f*r*(2*C*(10*r + 7*s - 7) + 7*r + 10*s - 10) + 2*fd*(C*(48*r**2 + 28*r*s - 38*r - 7*s + 7) + 14*r**2 + 24*r*s - 19*r - 6*s + 6)) + 2*Dd*f*(C*(96*r**2 + 56*r*s - 59*r - 7*s + 7) + 28*r**2 + 48*r*s - 37*r - 6*s + 6))) + 7*b1**2*(D1**2*r*(fd*(4*C*r + 10*C*s + 3*r + 6*s) - 2*fdd*(6*C*r + 5*C*s + 2*r + 4*s)) + D1*(Dd*(f*(2*C*(8*r**2 + 20*r*s - 9*r - 5*s + 2) + 12*r**2 + 24*r*s - 12*r - 6*s + 3) + 2*fd*(r**2*(-48*C - 16) + r*(-40*C*s + 17*C - 32*s + 8) + s*(5*C + 4))) - 2*Ddd*f*(C*(24*r**2 + 20*r*s - 17*r - 5*s + 6) + 8*r**2 + 16*r*s - 8*r - 4*s + 2)) - 2*Dd**2*f*(C*(72*r**2 + 60*r*s - 51*r - 15*s + 5) + 24*r**2 + 48*r*s - 24*r - 12*s + 4)) + b1*(-14*D1**2*bdd1*f*(C*(12*r**2 + r*(10*s - 17) - 5*s + 6) + 4*r**2 + 8*r*(s - 1) - 4*s + 2) + 3*D1**2*(f*(fd*(2*C*(20*r**2 + 14*r*s - 20*r - 7*s + 10) + 14*r**2 + 20*r*s - 14*r - 10*s + 7) - fdd*(2*C*(24*r**2 + 14*r*s - 24*r - 7*s + 12) + 14*r**2 + 24*r*s - 14*r - 12*s + 7)) - 2*fd**2*(r**2*(24*C + 7) + r*(14*C*s - 24*C + 12*s - 7) - s*(7*C + 6))) + 7*D1*bd1*(D1*(f*(2*C*(4*r**2 + r*(10*s - 9) - 5*s + 2) + 6*r**2 + 12*r*(s - 1) - 6*s + 3) + 2*fd*(r**2*(-24*C - 8) + r*(-20*C*s + 17*C - 16*s + 8) + s*(5*C + 4))) - 4*Dd*f*(C*(48*r**2 + r*(40*s - 51) - 15*s + 11) + 16*r**2 + 8*r*(4*s - 3) - 12*s + 6)) + 3*D1*f*(Dd*(f*(2*C*(40*r**2 + r*(28*s - 27) - 7*s + 10) + 28*r**2 + 8*r*(5*s - 3) - 10*s + 7) - 2*fd*(C*(192*r**2 + 2*r*(56*s - 79) - 42*s + 31) + 56*r**2 + 6*r*(16*s - 9) - 36*s + 13)) - Ddd*f*(2*C*(48*r**2 + r*(28*s - 31) - 7*s + 12) + 28*r**2 + r*(48*s - 26) - 12*s + 7)) - 6*Dd**2*f**2*(C*(144*r**2 + r*(84*s - 93) - 21*s + 7) + 42*r**2 + r*(72*s - 39) - 18*s + 6)))/(105*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct*st**4*(-33*b1**2*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*f*(D1*Dd*f*(21*f*(4*r*s - r - s) - 5*fd*(72*r*s - 21*r - 13*s + 4)) + 3*D1*bd1*(D1*(3*f*s*(2*r - 1) - 5*fd*(8*r*s - 2*r - 2*s + 1)) - 5*Dd*f*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(7*f*fd*(r*(9*s - 3) - s) + 5*f*(3*bdd1*s*(1 - 2*r) + fdd*(-9*r*s + 3*r + s)) - 5*fd**2*(6*r*(3*s - 1) - 2*s + 1)) + 15*Ddd*f**2*(-4*r*s + r + s)) - 15*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f**2*(-165*D1**2*bd1**2*s*(2*r - 1) + 2*D1*Dd*f*(39*f*(4*r*s - r - s) - 50*fd*(4*r - 1)*(4*s - 1)) + 11*D1*bd1*(D1*(7*f*s*(3*r - 2) - 5*fd*(18*r*s - 3*r - 7*s + 2)) - 5*Dd*f*(3*r*(8*s - 1) - 11*s + 2)) + D1*(D1*(55*bdd1*f*s*(2 - 3*r) + 78*f*fd*(r*(4*s - 1) - s) + 50*f*fdd*(-4*r*s + r + s) - 50*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 50*Ddd*f**2*(-4*r*s + r + s)) - 50*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(1155*d**2*k2) - D1**2*Pk2*Pkd1*ct*st**2*(-1232*D1**2*K*bd1**2*f*r*s + 616*D1**2*K*bd1**2*f*s + 220*D1**2*K*bd1*f**2*r*s - 1056*D1**2*K*bd1*f*fd*r*s + 264*D1**2*K*bd1*f*fd*r + 264*D1**2*K*bd1*f*fd*s - 264*D1**2*K*bdd1*f**2*r*s + 594*D1**2*bd1**2*f**2*r**2 + 264*D1**2*bd1**2*f**2*r*s - 330*D1**2*bd1**2*f**2*s - 396*D1**2*bd1**2*f**2 + 770*D1**2*bd1**2*f*r**2 - 616*D1**2*bd1**2*f*r*s - 770*D1**2*bd1**2*f*r + 308*D1**2*bd1**2*f*s - 924*D1**2*bd1*bd2*f*r*s + 462*D1**2*bd1*bd2*f*s - 440*D1**2*bd1*f**3*r**2 - 726*D1**2*bd1*f**3*r*s + 132*D1**2*bd1*f**3*r + 792*D1**2*bd1*f**3*s - 220*D1**2*bd1*f**3 + 2508*D1**2*bd1*f**2*fd*r**2 + 5148*D1**2*bd1*f**2*fd*r*s - 2090*D1**2*bd1*f**2*fd*r - 2442*D1**2*bd1*f**2*fd*s + 572*D1**2*bd1*f**2*fd - 264*D1**2*bd1*f**2*r**2 + 264*D1**2*bd1*f**2*r*s + 836*D1**2*bd1*f*fd*r**2 - 528*D1**2*bd1*f*fd*r*s - 286*D1**2*bd1*f*fd*r + 132*D1**2*bd1*f*fd*s + 616*D1**2*bd1*f*g2*r*s - 616*D1**2*bd1*f*g2*s + 2464*D1**2*bd1*f*gd2*r*s - 1232*D1**2*bd1*f*gd2*s + 2464*D1**2*bd1*fd*g2*r*s - 1232*D1**2*bd1*fd*g2*r - 1232*D1**2*bd1*fd*g2*s + 1232*D1**2*bd1*fd*g2 + 242*D1**2*bd2*f**2*r*s - 792*D1**2*bd2*f*fd*r*s + 198*D1**2*bd2*f*fd*r + 198*D1**2*bd2*f*fd*s + 418*D1**2*bdd1*f**3*r**2 + 858*D1**2*bdd1*f**3*r*s - 198*D1**2*bdd1*f**3*r - 792*D1**2*bdd1*f**3*s + 209*D1**2*bdd1*f**3 + 209*D1**2*bdd1*f**2*r**2 - 132*D1**2*bdd1*f**2*r*s + 1232*D1**2*bdd1*f*g2*r*s - 1232*D1**2*bdd1*f*g2*s - 198*D1**2*bdd2*f**2*r*s - 720*D1**2*f**3*fd*r**2 - 1760*D1**2*f**3*fd*r*s + 800*D1**2*f**3*fd*r + 440*D1**2*f**3*fd*s - 180*D1**2*f**3*fd + 580*D1**2*f**3*fdd*r**2 + 1760*D1**2*f**3*fdd*r*s - 730*D1**2*f**3*fdd*r - 440*D1**2*f**3*fdd*s + 145*D1**2*f**3*fdd + 1740*D1**2*f**2*fd**2*r**2 + 5280*D1**2*f**2*fd**2*r*s - 2190*D1**2*f**2*fd**2*r - 1320*D1**2*f**2*fd**2*s + 440*D1**2*f**2*fd**2 - 440*D1**2*f**2*gd2*r*s + 528*D1**2*f**2*gdd2*r*s - 880*D1**2*f*fd*g2*r*s + 440*D1**2*f*fd*g2*r + 440*D1**2*f*fd*g2*s + 2112*D1**2*f*fd*gd2*r*s - 528*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s + 1056*D1**2*f*fdd*g2*r*s - 528*D1**2*f*fdd*g2*r - 528*D1**2*f*fdd*g2*s + 1056*D1**2*fd**2*g2*r*s - 528*D1**2*fd**2*g2*r - 528*D1**2*fd**2*g2*s + 528*D1**2*fd**2*g2 - 2112*D1*Dd*K*bd1*f**2*r*s + 264*D1*Dd*K*bd1*f**2*r + 264*D1*Dd*K*bd1*f**2*s + 3344*D1*Dd*bd1*f**3*r**2 + 6864*D1*Dd*bd1*f**3*r*s - 2486*D1*Dd*bd1*f**3*r - 4026*D1*Dd*bd1*f**3*s + 990*D1*Dd*bd1*f**3 + 1672*D1*Dd*bd1*f**2*r**2 - 1056*D1*Dd*bd1*f**2*r*s - 286*D1*Dd*bd1*f**2*r + 132*D1*Dd*bd1*f**2*s + 9856*D1*Dd*bd1*f*g2*r*s - 1232*D1*Dd*bd1*f*g2*r - 6160*D1*Dd*bd1*f*g2*s + 1232*D1*Dd*bd1*f*g2 - 1584*D1*Dd*bd2*f**2*r*s + 198*D1*Dd*bd2*f**2*r + 198*D1*Dd*bd2*f**2*s - 720*D1*Dd*f**4*r**2 - 1760*D1*Dd*f**4*r*s + 800*D1*Dd*f**4*r + 440*D1*Dd*f**4*s - 180*D1*Dd*f**4 + 4640*D1*Dd*f**3*fd*r**2 + 14080*D1*Dd*f**3*fd*r*s - 5840*D1*Dd*f**3*fd*r - 3520*D1*Dd*f**3*fd*s + 1170*D1*Dd*f**3*fd - 1760*D1*Dd*f**2*g2*r*s + 440*D1*Dd*f**2*g2*r + 440*D1*Dd*f**2*g2*s + 4224*D1*Dd*f**2*gd2*r*s - 528*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s + 8448*D1*Dd*f*fd*g2*r*s - 3168*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s + 1056*D1*Dd*f*fd*g2 + 580*D1*Ddd*f**4*r**2 + 1760*D1*Ddd*f**4*r*s - 730*D1*Ddd*f**4*r - 440*D1*Ddd*f**4*s + 145*D1*Ddd*f**4 + 2112*D1*Ddd*f**2*g2*r*s - 528*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s + 1740*Dd**2*f**4*r**2 + 5280*Dd**2*f**4*r*s - 2190*Dd**2*f**4*r - 1320*Dd**2*f**4*s + 440*Dd**2*f**4 + 6336*Dd**2*f**2*g2*r*s - 1584*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s + 528*Dd**2*f**2*g2 - 154*b1**3*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1**2*(2*D1*Dd*(-2*f**2*(12*r**2 - r*(4*s + 5) + s + 3) + 2*f*(3*fd*(36*r**2 + 16*r*s - 33*r + 4*s + 4) + (14 - 7*K)*(4*r*s - r - s)) - 7*fd*(4*K*(8*r*s - 5*r - s + 1) - 20*r**2 + 16*r*s - 5*r - 2*s + 2)) + 14*D1*bd1*(D1*(f*r*(3*s - 1) - f*s + 3*fd*(-6*r*s + r + s)) - 3*Dd*f*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(-42*bdd1*f*(r*(3*s - 1) - s) + 6*fd**2*(9*r**2 + r*(4*s - 11) + 3*s) + fd*(-24*f*r**2 + f*r*(8*s + 62) - 22*f*s - r*(28*K - 56)*(s - 1)) + fdd*(6*f*r*(4*s - 11) + 18*f*s + r**2*(54*f + 35) - r*(56*K + 28)*(s - 1))) + Ddd*f*(56*K*s + 3*f*(36*r**2 + 2*r*(8*s - 11) - 4*s + 9) + 140*r**2 - 14*r*(16*K*s - 4*K + 8*s + 3) + 28*s + 35)) + 2*Dd**2*f*(-28*K*(12*r*s - 3*r - 3*s + 1) + 3*f*(54*r**2 + 3*r*(8*s - 11) - 6*s + 2) + 210*r**2 - 168*r*s - 63*r + 42*s - 14)) - 11*b1*(-40*D1**2*K*f*fd*r*s + 20*D1**2*K*f*fd*r + 20*D1**2*K*f*fd*s + 48*D1**2*K*f*fdd*r*s - 24*D1**2*K*f*fdd*r - 24*D1**2*K*f*fdd*s + 48*D1**2*K*fd**2*r*s - 24*D1**2*K*fd**2*r - 24*D1**2*K*fd**2*s + 24*D1**2*K*fd**2 - 14*D1**2*b2*fd*r*s + 14*D1**2*b2*fd*r + 42*D1**2*b2*fdd*r*s - 42*D1**2*b2*fdd*r + 42*D1**2*bd1**2*f*(r*(6*s - 2) - 2*s + 1) - 14*D1**2*bd2*f*r*s + 84*D1**2*bd2*fd*r*s - 42*D1**2*bd2*fd*r - D1**2*bdd1*f*(56*K*s + 3*f*(18*r**2 + 8*r*s - 10*s + 9) + 70*r**2 - 14*r*(8*K*s + 4*s + 5) + 28*s + 35) + 42*D1**2*bdd2*f*r*s + 120*D1**2*f**2*fd*r**2 + 198*D1**2*f**2*fd*r*s - 134*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s + 20*D1**2*f**2*fd - 114*D1**2*f**2*fdd*r**2 - 234*D1**2*f**2*fdd*r*s + 136*D1**2*f**2*fdd*r + 6*D1**2*f**2*fdd*s - 19*D1**2*f**2*fdd - 228*D1**2*f*fd**2*r**2 - 468*D1**2*f*fd**2*r*s + 272*D1**2*f*fd**2*r + 12*D1**2*f*fd**2*s - 26*D1**2*f*fd**2 + 48*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 24*D1**2*f*fd*s + 24*D1**2*f*fd - 38*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s + 26*D1**2*f*fdd*r - 12*D1**2*f*fdd*s - 19*D1**2*f*fdd - 56*D1**2*f*gd2*r*s - 112*D1**2*f*gdd2*r*s - 38*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s + 26*D1**2*fd**2*r - 12*D1**2*fd**2*s + 12*D1**2*fd**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 224*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 112*D1**2*fdd*g2*r*s + 112*D1**2*fdd*g2*r - 80*D1*Dd*K*f**2*r*s + 20*D1*Dd*K*f**2*r + 20*D1*Dd*K*f**2*s + 384*D1*Dd*K*f*fd*r*s - 144*D1*Dd*K*f*fd*r - 144*D1*Dd*K*f*fd*s + 48*D1*Dd*K*f*fd - 56*D1*Dd*b2*f*r*s + 14*D1*Dd*b2*f*r + 14*D1*Dd*b2*f*s + 336*D1*Dd*b2*fd*r*s - 210*D1*Dd*b2*fd*r - 42*D1*Dd*b2*fd*s + 42*D1*Dd*b2*fd + 336*D1*Dd*bd2*f*r*s - 42*D1*Dd*bd2*f*r - 42*D1*Dd*bd2*f*s + 160*D1*Dd*f**3*r**2 + 264*D1*Dd*f**3*r*s - 146*D1*Dd*f**3*r - 66*D1*Dd*f**3*s + 40*D1*Dd*f**3 - 912*D1*Dd*f**2*fd*r**2 - 1872*D1*Dd*f**2*fd*r*s + 1006*D1*Dd*f**2*fd*r + 258*D1*Dd*f**2*fd*s - 142*D1*Dd*f**2*fd + 96*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 24*D1*Dd*f**2*s + 24*D1*Dd*f**2 - 304*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s + 156*D1*Dd*f*fd*r - 72*D1*Dd*f*fd*s - 14*D1*Dd*f*fd - 224*D1*Dd*f*g2*r*s + 56*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s - 896*D1*Dd*f*gd2*r*s + 112*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s - 896*D1*Dd*fd*g2*r*s + 560*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s - 112*D1*Dd*fd*g2 + 96*D1*Ddd*K*f**2*r*s - 24*D1*Ddd*K*f**2*r - 24*D1*Ddd*K*f**2*s + 168*D1*Ddd*b2*f*r*s - 42*D1*Ddd*b2*f*r - 42*D1*Ddd*b2*f*s - 152*D1*Ddd*f**3*r**2 - 312*D1*Ddd*f**3*r*s + 154*D1*Ddd*f**3*r + 78*D1*Ddd*f**3*s - 38*D1*Ddd*f**3 - 76*D1*Ddd*f**2*r**2 + 48*D1*Ddd*f**2*r*s + 26*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s - 19*D1*Ddd*f**2 - 448*D1*Ddd*f*g2*r*s + 112*D1*Ddd*f*g2*r + 112*D1*Ddd*f*g2*s + 2*D1*bd1*(D1*(f**2*(12*r**2 + r*(21 - 4*s) - 9*s + 6) - 2*f*(3*fd*(18*r**2 + 8*r*s - 11*r - 2*s + 4) + s*(-14*K*r + 7*K + 28*r - 14)) + 7*fd*(4*K*(4*r*s - 2*r - s + 1) - 10*r**2 + 8*r*s + r - 2*s + 2)) - Dd*f*(7*K*(-64*r*s + 8*r + 24*s - 4) + 3*f*(72*r**2 + r*(32*s - 22) - 24*s + 5) + 280*r**2 - 224*r*s - 182*r + 84*s + 21)) + 288*Dd**2*K*f**2*r*s - 72*Dd**2*K*f**2*r - 72*Dd**2*K*f**2*s + 24*Dd**2*K*f**2 + 504*Dd**2*b2*f*r*s - 126*Dd**2*b2*f*r - 126*Dd**2*b2*f*s + 42*Dd**2*b2*f - 456*Dd**2*f**3*r**2 - 936*Dd**2*f**3*r*s + 462*Dd**2*f**3*r + 234*Dd**2*f**3*s - 78*Dd**2*f**3 - 228*Dd**2*f**2*r**2 + 144*Dd**2*f**2*r*s + 78*Dd**2*f**2*r - 36*Dd**2*f**2*s + 12*Dd**2*f**2 - 1344*Dd**2*f*g2*r*s + 336*Dd**2*f*g2*r + 336*Dd**2*f*g2*s - 112*Dd**2*f*g2) + 22*b2*(D1*Dd*f*(11*f*(4*r*s - r - s) - 18*fd*(8*r*s - 3*r - 3*s + 1)) + 7*D1*bd1*(D1*(f*s*(r - 1) + 3*fd*(-2*r*s + r + s - 1)) - 3*Dd*f*(r*(8*s - 1) - 5*s + 1)) + D1*(D1*(11*f*fd*(r*(2*s - 1) - s) + 3*f*(-7*bdd1*s*(r - 1) + 3*fdd*(-2*r*s + r + s)) + 9*fd**2*(-2*r*s + r + s - 1)) + 9*Ddd*f**2*(-4*r*s + r + s)) - 9*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(1155*d**2*k2) - 2*D1**2*Pk2*Pkd1*ct*(28*D1**2*K*bd1**2*f*r*s + 21*D1**2*K*bd1**2*f*r - 35*D1**2*K*bd1**2*f*s - 21*D1**2*K*bd1*f**2*r*s + 84*D1**2*K*bd1*f*fd*r*s - 21*D1**2*K*bd1*f*fd*r - 21*D1**2*K*bd1*f*fd*s + 21*D1**2*K*bdd1*f**2*r*s + 72*D1**2*bd1**2*f**2*r**2 + 168*D1**2*bd1**2*f**2*r*s - 99*D1**2*bd1**2*f**2*r - 63*D1**2*bd1**2*f**2*s + 42*D1**2*bd1**2*f**2 + 56*D1**2*bd1**2*f*r**2 + 112*D1**2*bd1**2*f*r*s - 21*D1**2*bd1**2*f*r - 35*D1**2*bd1**2*f*s + 140*D1**2*bd1**2*g2*r*s - 70*D1**2*bd1**2*g2*r - 70*D1**2*bd1**2*g2*s + 70*D1**2*bd1**2*g2 + 70*D1**2*bd1*bd2*f*r*s - 35*D1**2*bd1*bd2*f*s - 15*D1**2*bd1*f**3*r**2 - 45*D1**2*bd1*f**3*r*s + 30*D1**2*bd1*f**3*r + 90*D1**2*bd1*f**2*fd*r**2 + 270*D1**2*bd1*f**2*fd*r*s - 135*D1**2*bd1*f**2*fd*r - 45*D1**2*bd1*f**2*fd*s + 30*D1**2*bd1*f**2*fd - 21*D1**2*bd1*f**2*r*s + 84*D1**2*bd1*f*fd*r*s - 21*D1**2*bd1*f*fd*r - 21*D1**2*bd1*f*fd*s + 56*D1**2*bd1*f*g2*r*s + 14*D1**2*bd1*f*g2*r - 70*D1**2*bd1*f*g2*s - 56*D1**2*bd1*f*gd2*r*s - 42*D1**2*bd1*f*gd2*r + 70*D1**2*bd1*f*gd2*s - 56*D1**2*bd1*fd*g2*r*s + 28*D1**2*bd1*fd*g2*r + 28*D1**2*bd1*fd*g2*s - 28*D1**2*bd1*fd*g2 - 21*D1**2*bd2*f**2*r*s + 84*D1**2*bd2*f*fd*r*s - 21*D1**2*bd2*f*fd*r - 21*D1**2*bd2*f*fd*s + 15*D1**2*bdd1*f**3*r**2 + 45*D1**2*bdd1*f**3*r*s - 30*D1**2*bdd1*f**3*r + 21*D1**2*bdd1*f**2*r*s - 28*D1**2*bdd1*f*g2*r*s - 42*D1**2*bdd1*f*g2*r + 70*D1**2*bdd1*f*g2*s + 21*D1**2*bdd2*f**2*r*s + 42*D1**2*f**2*gd2*r*s - 42*D1**2*f**2*gdd2*r*s + 84*D1**2*f*fd*g2*r*s - 42*D1**2*f*fd*g2*r - 42*D1**2*f*fd*g2*s - 168*D1**2*f*fd*gd2*r*s + 42*D1**2*f*fd*gd2*r + 42*D1**2*f*fd*gd2*s - 84*D1**2*f*fdd*g2*r*s + 42*D1**2*f*fdd*g2*r + 42*D1**2*f*fdd*g2*s - 84*D1**2*fd**2*g2*r*s + 42*D1**2*fd**2*g2*r + 42*D1**2*fd**2*g2*s - 42*D1**2*fd**2*g2 + 168*D1*Dd*K*bd1*f**2*r*s - 21*D1*Dd*K*bd1*f**2*r - 21*D1*Dd*K*bd1*f**2*s + 120*D1*Dd*bd1*f**3*r**2 + 360*D1*Dd*bd1*f**3*r*s - 195*D1*Dd*bd1*f**3*r - 45*D1*Dd*bd1*f**3*s + 30*D1*Dd*bd1*f**3 + 168*D1*Dd*bd1*f**2*r*s - 21*D1*Dd*bd1*f**2*r - 21*D1*Dd*bd1*f**2*s - 224*D1*Dd*bd1*f*g2*r*s - 140*D1*Dd*bd1*f*g2*r + 308*D1*Dd*bd1*f*g2*s - 28*D1*Dd*bd1*f*g2 + 168*D1*Dd*bd2*f**2*r*s - 21*D1*Dd*bd2*f**2*r - 21*D1*Dd*bd2*f**2*s + 168*D1*Dd*f**2*g2*r*s - 42*D1*Dd*f**2*g2*r - 42*D1*Dd*f**2*g2*s - 336*D1*Dd*f**2*gd2*r*s + 42*D1*Dd*f**2*gd2*r + 42*D1*Dd*f**2*gd2*s - 672*D1*Dd*f*fd*g2*r*s + 252*D1*Dd*f*fd*g2*r + 252*D1*Dd*f*fd*g2*s - 84*D1*Dd*f*fd*g2 - 168*D1*Ddd*f**2*g2*r*s + 42*D1*Ddd*f**2*g2*r + 42*D1*Ddd*f**2*g2*s - 504*Dd**2*f**2*g2*r*s + 126*Dd**2*f**2*g2*r + 126*Dd**2*f**2*g2*s - 42*Dd**2*f**2*g2 - 7*b1**3*(D1**2*r*(fd*r + 5*fd*s - 3*fdd*r - 5*fdd*s) + D1*(Dd*(f*(4*r**2 + r*(20*s - 7) - 5*s + 1) + fd*r*(11 - 40*s) - r**2*(24*fd + 20) + 5*r*(K*(4*s - 1) - 4*s + 3) + s*(-5*K + 5*fd + 5) - 5) - Ddd*(f*(12*r**2 + r*(20*s - 11) - 5*s + 3) + 20*r**2 + 5*r*(-4*K*s + K + 4*s - 3) + 5*s*(K - 1) + 5)) - Dd**2*(5*K*(-12*r*s + 3*r + 3*s - 1) + f*(36*r**2 + r*(60*s - 33) - 15*s + 5) + 60*r**2 + 60*r*s - 45*r - 15*s + 5)) + b1**2*(-28*D1**2*K*fd*r*s + 35*D1**2*K*fd*r - 7*D1**2*K*fd*s + 14*D1**2*K*fdd*r*s - 35*D1**2*K*fdd*r + 21*D1**2*K*fdd*s + 7*D1**2*bdd1*(f*(9*r**2 + r*(15*s - 11) - 5*s + 3) + 15*r**2 + 5*r*(-3*K*s + K + 3*s - 3) + 5*s*(K - 1) + 5) - 60*D1**2*f*fd*r**2 - 168*D1**2*f*fd*r*s + 51*D1**2*f*fd*r + 21*D1**2*f*fd*s - 15*D1**2*f*fd + 72*D1**2*f*fdd*r**2 + 168*D1**2*f*fdd*r*s - 57*D1**2*f*fdd*r - 21*D1**2*f*fdd*s + 18*D1**2*f*fdd + 72*D1**2*fd**2*r**2 + 168*D1**2*fd**2*r*s - 57*D1**2*fd**2*r - 21*D1**2*fd**2*s - 21*D1**2*fd*r**2 - 42*D1**2*fd*r*s + 77*D1**2*fd*r + 7*D1**2*fd*s - 21*D1**2*fd + 28*D1**2*fdd*r**2 + 56*D1**2*fdd*r*s - 91*D1**2*fdd*r - 21*D1**2*fdd*s + 28*D1**2*fdd + 70*D1**2*gd2*r*s + 70*D1**2*gdd2*r*s - 112*D1*Dd*K*f*r*s + 28*D1*Dd*K*f*r + 28*D1*Dd*K*f*s + 112*D1*Dd*K*fd*r*s - 154*D1*Dd*K*fd*r + 70*D1*Dd*K*fd*s + 14*D1*Dd*K*fd - 120*D1*Dd*f**2*r**2 - 336*D1*Dd*f**2*r*s + 144*D1*Dd*f**2*r + 84*D1*Dd*f**2*s - 30*D1*Dd*f**2 + 576*D1*Dd*f*fd*r**2 + 1344*D1*Dd*f*fd*r*s - 540*D1*Dd*f*fd*r - 252*D1*Dd*f*fd*s + 78*D1*Dd*f*fd - 84*D1*Dd*f*r**2 - 168*D1*Dd*f*r*s + 84*D1*Dd*f*r + 42*D1*Dd*f*s - 21*D1*Dd*f + 224*D1*Dd*fd*r**2 + 448*D1*Dd*fd*r*s - 476*D1*Dd*fd*r - 140*D1*Dd*fd*s + 112*D1*Dd*fd + 280*D1*Dd*g2*r*s - 70*D1*Dd*g2*r - 70*D1*Dd*g2*s + 560*D1*Dd*gd2*r*s - 70*D1*Dd*gd2*r - 70*D1*Dd*gd2*s + 56*D1*Ddd*K*f*r*s - 14*D1*Ddd*K*f*r - 14*D1*Ddd*K*f*s + 144*D1*Ddd*f**2*r**2 + 336*D1*Ddd*f**2*r*s - 156*D1*Ddd*f**2*r - 84*D1*Ddd*f**2*s + 36*D1*Ddd*f**2 + 112*D1*Ddd*f*r**2 + 224*D1*Ddd*f*r*s - 112*D1*Ddd*f*r - 56*D1*Ddd*f*s + 28*D1*Ddd*f + 280*D1*Ddd*g2*r*s - 70*D1*Ddd*g2*r - 70*D1*Ddd*g2*s - 7*D1*bd1*(D1*(f*(3*r**2 + r*(15*s - 7) - 5*s + 1) + fd*r*(11 - 30*s) - r**2*(18*fd + 15) + 5*r*(K*(3*s - 1) - 3*s + 3) + s*(-5*K + 5*fd + 5) - 5) - Dd*(5*K*(r*(7 - 24*s) + 7*s - 2) + f*(72*r**2 + r*(120*s - 77) - 35*s + 16) + 120*r**2 + 15*r*(8*s - 7) - 35*s + 20)) + 168*Dd**2*K*f*r*s - 42*Dd**2*K*f*r - 42*Dd**2*K*f*s + 14*Dd**2*K*f + 432*Dd**2*f**2*r**2 + 1008*Dd**2*f**2*r*s - 468*Dd**2*f**2*r - 252*Dd**2*f**2*s + 84*Dd**2*f**2 + 336*Dd**2*f*r**2 + 672*Dd**2*f*r*s - 336*Dd**2*f*r - 168*Dd**2*f*s + 56*Dd**2*f + 840*Dd**2*g2*r*s - 210*Dd**2*g2*r - 210*Dd**2*g2*s + 70*Dd**2*g2) + b1*(28*D1**2*K*bdd1*f*r*s + 21*D1**2*K*bdd1*f*r - 35*D1**2*K*bdd1*f*s - 42*D1**2*K*f*fd*r*s + 21*D1**2*K*f*fd*r + 21*D1**2*K*f*fd*s + 42*D1**2*K*f*fdd*r*s - 21*D1**2*K*f*fdd*r - 21*D1**2*K*f*fdd*s + 42*D1**2*K*fd**2*r*s - 21*D1**2*K*fd**2*r - 21*D1**2*K*fd**2*s + 21*D1**2*K*fd**2 + 7*D1**2*bd1**2*(5*K*(r*(2 - 6*s) + 2*s - 1) + f*(18*r**2 + r*(30*s - 22) - 10*s + 5) + 30*r**2 + 30*r*(s - 1) - 10*s + 5) - 35*D1**2*bd2*f*r*s + 70*D1**2*bd2*fd*r*s - 35*D1**2*bd2*fd*r + 72*D1**2*bdd1*f**2*r**2 + 168*D1**2*bdd1*f**2*r*s - 99*D1**2*bdd1*f**2*r - 63*D1**2*bdd1*f**2*s + 18*D1**2*bdd1*f**2 + 56*D1**2*bdd1*f*r**2 + 112*D1**2*bdd1*f*r*s - 21*D1**2*bdd1*f*r - 35*D1**2*bdd1*f*s + 140*D1**2*bdd1*g2*r*s - 70*D1**2*bdd1*g2*r - 70*D1**2*bdd1*g2*s + 35*D1**2*bdd2*f*r*s - 45*D1**2*f**2*fd*r**2 - 135*D1**2*f**2*fd*r*s + 45*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 45*D1**2*f**2*fdd*r**2 + 135*D1**2*f**2*fdd*r*s - 45*D1**2*f**2*fdd*r - 45*D1**2*f**2*fdd*s + 15*D1**2*f**2*fdd + 90*D1**2*f*fd**2*r**2 + 270*D1**2*f*fd**2*r*s - 90*D1**2*f*fd**2*r - 90*D1**2*f*fd**2*s + 15*D1**2*f*fd**2 - 42*D1**2*f*fd*r*s + 21*D1**2*f*fd*r + 21*D1**2*f*fd*s + 42*D1**2*f*fdd*r*s - 21*D1**2*f*fdd*r - 21*D1**2*f*fdd*s + 56*D1**2*f*gd2*r*s - 28*D1**2*f*gdd2*r*s + 42*D1**2*fd**2*r*s - 21*D1**2*fd**2*r - 21*D1**2*fd**2*s + 21*D1**2*fd**2 + 56*D1**2*fd*g2*r*s - 70*D1**2*fd*g2*r + 14*D1**2*fd*g2*s - 56*D1**2*fd*gd2*r*s + 70*D1**2*fd*gd2*r - 42*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r*s + 70*D1**2*fdd*g2*r - 42*D1**2*fdd*g2*s - 84*D1*Dd*K*f**2*r*s + 21*D1*Dd*K*f**2*r + 21*D1*Dd*K*f**2*s + 336*D1*Dd*K*f*fd*r*s - 126*D1*Dd*K*f*fd*r - 126*D1*Dd*K*f*fd*s + 42*D1*Dd*K*f*fd + 280*D1*Dd*bd2*f*r*s - 35*D1*Dd*bd2*f*r - 35*D1*Dd*bd2*f*s - 60*D1*Dd*f**3*r**2 - 180*D1*Dd*f**3*r*s + 75*D1*Dd*f**3*r + 45*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*r**2 + 1080*D1*Dd*f**2*fd*r*s - 405*D1*Dd*f**2*fd*r - 315*D1*Dd*f**2*fd*s + 90*D1*Dd*f**2*fd - 84*D1*Dd*f**2*r*s + 21*D1*Dd*f**2*r + 21*D1*Dd*f**2*s + 336*D1*Dd*f*fd*r*s - 126*D1*Dd*f*fd*r - 126*D1*Dd*f*fd*s + 42*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r - 56*D1*Dd*f*g2*s - 224*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r + 28*D1*Dd*f*gd2*s - 224*D1*Dd*fd*g2*r*s + 308*D1*Dd*fd*g2*r - 140*D1*Dd*fd*g2*s - 28*D1*Dd*fd*g2 + 84*D1*Ddd*K*f**2*r*s - 21*D1*Ddd*K*f**2*r - 21*D1*Ddd*K*f**2*s + 60*D1*Ddd*f**3*r**2 + 180*D1*Ddd*f**3*r*s - 75*D1*Ddd*f**3*r - 45*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 84*D1*Ddd*f**2*r*s - 21*D1*Ddd*f**2*r - 21*D1*Ddd*f**2*s - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r + 28*D1*Ddd*f*g2*s + D1*bd1*(D1*(-3*f**2*(20*r**2 + r*(56*s - 31) - 21*s + 5) + f*(6*fd*(48*r**2 + 4*r*(28*s - 13) - 28*s + 7) - 42*r**2 - 7*r*(8*K*s + K + 12*s - 1) + 7*s*(5*K + 5)) + 7*fd*(K*(r*(8*s - 7) + s + 2) + 16*r**2 + r*(32*s - 29) - 11*s + 8) + 70*g2*r*(2*s - 1) - 70*g2*s + 70*gd2*r*(4*s - 1) - 70*gd2*s) + 2*Dd*(3*f**2*(96*r**2 + 2*r*(112*s - 59) - 70*s + 27) + 7*f*(4*K*r*(4*s + 1) - 12*K*s + K + 32*r**2 + r*(64*s - 22) - 18*s + 4) + 70*g2*(r*(8*s - 3) - 3*s + 1))) + 252*Dd**2*K*f**2*r*s - 63*Dd**2*K*f**2*r - 63*Dd**2*K*f**2*s + 21*Dd**2*K*f**2 + 180*Dd**2*f**3*r**2 + 540*Dd**2*f**3*r*s - 225*Dd**2*f**3*r - 135*Dd**2*f**3*s + 45*Dd**2*f**3 + 252*Dd**2*f**2*r*s - 63*Dd**2*f**2*r - 63*Dd**2*f**2*s + 21*Dd**2*f**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r + 84*Dd**2*f*g2*s - 28*Dd**2*f*g2 + 35*b2*(D1*Dd*(f*(-4*r*s + r + s) + fd*r*(8*s - 5) - fd*s + fd) - D1*(D1*r*(fd - fdd)*(s - 1) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1))) - 7*b2*(3*D1*Dd*f*(f*(4*r*s - r - s) + fd*(-16*r*s + 6*r + 6*s - 2)) + 5*D1*bd1*(D1*f*s*(r - 1) + D1*fd*(-2*r*s + r + s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) + D1*(D1*(-5*bdd1*f*s*(r - 1) + 3*f*fd*r*(2*s - 1) - 3*f*fd*s + 3*f*fdd*(-2*r*s + r + s) + 3*fd**2*(-2*r*s + r + s - 1)) + 3*Ddd*f**2*(-4*r*s + r + s)) - 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k2) + 2*D1**2*Pk2*Pkd1*ct*k2**3*st**4*(36*D1**2*b1*f*fd*r**2 - 18*D1**2*b1*f*fdd*r**2 - 18*D1**2*b1*fd**2*r**2 - 9*D1**2*bdd1*f**2*(r - 1)**2 + 24*D1**2*f**2*fd*r**2 - 16*D1**2*f**2*fd*r + 8*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 + 8*D1**2*f**2*fdd*r - 4*D1**2*f**2*fdd - 24*D1**2*f*fd**2*r**2 + 16*D1**2*f*fd**2*r + 72*D1*Dd*b1*f**2*r**2 - 36*D1*Dd*b1*f**2*r + 18*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 + 36*D1*Dd*b1*f*fd*r + 32*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r + 8*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 + 56*D1*Dd*f**2*fd*r - 8*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 + 18*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2 - 16*D1*Ddd*f**3*r**2 + 8*D1*Ddd*f**3*r - 4*D1*Ddd*f**3 + 18*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 108*Dd**2*b1*f**2*r**2 + 54*Dd**2*b1*f**2*r - 48*Dd**2*f**3*r**2 + 24*Dd**2*f**3*r)/(105*d**2*k1**2*k3**2) + D1**2*Pk2*Pkd1*ct*k2**3*st**2*(D1*f*r*(-42*D1*bd1**2*(r - 1) + 26*D1*bd1*(f*r - 2*fd*r + fd) - 13*D1*bdd1*f*r - 26*Dd*bd1*f*(4*r - 1)) + 21*b1**2*(D1**2*r**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*r*(1 - 4*r)) + D1*Ddd*f*(-4*r**2 + 2*r - 1) + 6*Dd**2*f*r*(1 - 2*r)) + b1*(-21*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 13*D1**2*(f*(2*fd - fdd)*(2*r**2 - 2*r + 1) - 2*fd**2*r*(r - 1)) + 42*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(1 - 2*r) + Dd*f*(-8*r**2 + 6*r - 1)) + 13*D1*f*(2*Dd*(4*f*r**2 - 2*f*r + f - 8*fd*r**2 + 6*fd*r - fd) + Ddd*f*(-4*r**2 + 2*r - 1)) + 78*Dd**2*f**2*r*(1 - 2*r)))/(105*d**2*k1**2*k3**2) + D1**2*Pk2*Pkd1*ct*k2*st**2*(D1*f*r*(-6*D1*bd1**2*(6*f + 7)*(r - 1) - D1*bdd1*f*r*(18*f + 13) + 2*bd1*(D1*f*r*(18*f + 13) + D1*fd*(f*(18 - 54*r) - 26*r + 13) - Dd*f*(18*f + 13)*(4*r - 1))) + 3*b1**2*(D1**2*r**2*(-12*fd**2 + fd*(24*f + 14) - fdd*(12*f + 7)) + D1*(2*Dd*(6*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(28 - 48*fd) + r*(12*fd - 14) + 7) + 7*fd*r*(1 - 4*r)) - Ddd*f*(6*f + 7)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(6*f + 7)*(2*r - 1)) + b1*(-3*D1**2*bdd1*f*(6*f + 7)*(2*r**2 - 2*r + 1) + 108*D1**2*f**2*fd*r**2 - 72*D1**2*f**2*fd*r + 36*D1**2*f**2*fd - 54*D1**2*f**2*fdd*r**2 + 36*D1**2*f**2*fdd*r - 18*D1**2*f**2*fdd - 108*D1**2*f*fd**2*r**2 + 72*D1**2*f*fd**2*r + 52*D1**2*f*fd*r**2 - 52*D1**2*f*fd*r + 26*D1**2*f*fd - 26*D1**2*f*fdd*r**2 + 26*D1**2*f*fdd*r - 13*D1**2*f*fdd - 26*D1**2*fd**2*r**2 + 26*D1**2*fd**2*r + 144*D1*Dd*f**3*r**2 - 72*D1*Dd*f**3*r + 36*D1*Dd*f**3 - 432*D1*Dd*f**2*fd*r**2 + 252*D1*Dd*f**2*fd*r - 36*D1*Dd*f**2*fd + 104*D1*Dd*f**2*r**2 - 52*D1*Dd*f**2*r + 26*D1*Dd*f**2 - 208*D1*Dd*f*fd*r**2 + 156*D1*Dd*f*fd*r - 26*D1*Dd*f*fd - 72*D1*Ddd*f**3*r**2 + 36*D1*Ddd*f**3*r - 18*D1*Ddd*f**3 - 52*D1*Ddd*f**2*r**2 + 26*D1*Ddd*f**2*r - 13*D1*Ddd*f**2 + 6*D1*bd1*(D1*(6*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(14 - 24*fd) + r*(12*fd - 14) + 7) + 7*fd*r*(1 - 2*r)) - Dd*f*(6*f + 7)*(8*r**2 - 6*r + 1)) - 216*Dd**2*f**3*r**2 + 108*Dd**2*f**3*r - 156*Dd**2*f**2*r**2 + 78*Dd**2*f**2*r))/(105*d**2*k1**2) + 2*D1**2*Pk2*Pkd1*ct*k2*(-2*D1**2*bd1**2*f*r**2*(3*f + 7) + 2*D1*b1*r*(-D1*bdd1*f*r*(3*f + 7) - 2*bd1*(-D1*f*r*(3*f + 7) + D1*fd*(6*f*r - 3*f + 7*r - 7) + Dd*f*(3*f + 7)*(4*r - 1))) + b1**2*(D1**2*(-6*fd**2*r*(r - 1) + 2*fd*(f*(6*r**2 - 6*r + 3) + 7*(r - 1)**2) - fdd*(f*(6*r**2 - 6*r + 3) + 7*(r - 1)**2)) + D1*(2*Dd*(3*f**2*(4*r**2 - 2*r + 1) - 3*f*fd*(8*r**2 - 6*r + 1) + 7*f*(4*r**2 - 2*r + 1) - 7*fd*(4*r**2 - 5*r + 1)) - Ddd*f*(3*f + 7)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(3*f + 7)*(2*r - 1)))/(105*d**2*k1**2) - 4*D1**2*Pk2*Pkd1*f*st**6*(11*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-6*r*s + r + 3*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 11*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + fd*r*(24*s - 7) - 3*fd*s + fd) - D1*(D1*r*(3*s - 1)*(2*f*fd - f*fdd - 2*fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(6*D1*Dd*f*(f*r*(4*s - 1) - f*s - fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(6*f*fd*(r*(4*s - 1) - s) + f*(-11*bdd1*s*(r - 1) + 3*fdd*(-4*r*s + r + s)) + fd**2*(r*(9 - 36*s) + 9*s - 3)) + 3*Ddd*f**2*(-4*r*s + r + s)) - 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1) - D1**2*Pk2*Pkd1*k1**3*st**2*(3*D1*bd1*f*(D1*(f*s*(r - 1) + 3*fd*(4*r*s - r - 2*s + 1)) + 3*Dd*f*(r*(8*s - 1) - 5*s + 1)) + 3*b1*(D1*Dd*f*(f*r*(4*s - 1) - f*s + 6*fd*r*(8*s - 3) - 6*fd*s + 3*fd) + D1*(D1*r*(2*s - 1)*(f*(fd + 3*fdd) + 3*fd**2) + 3*Ddd*f**2*(r*(4*s - 1) - s)) + 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(-4*r*s + r + s) + 5*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 5*fdd*r*(3*s - 1) - 5*fdd*s) + 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(4*s - 1) - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k2**2*k3**2) - D1**2*Pk2*Pkd1*k1**3*(21*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 15*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(7*b1*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(-3*f*r*(s - 1) + 5*fd*(4*r*s - 2*r - s + 1)) + 5*Dd*f*(r*(8*s - 5) - s + 1))) + 7*b1**2*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(7*D1*bdd1*f*(r*(2*s - 1) - s) - D1*s*(2*r - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k2**2*k3**2) - D1**2*Pk2*Pkd1*k1*st**4*(96*C*D1**2*b1*f*fd*r*s - 48*C*D1**2*b1*f*fd*r - 48*C*D1**2*b1*f*fdd*r*s + 24*C*D1**2*b1*f*fdd*r - 48*C*D1**2*b1*fd**2*r*s + 24*C*D1**2*b1*fd**2*r + 48*C*D1**2*f**2*fd*r*s - 16*C*D1**2*f**2*fd*r - 16*C*D1**2*f**2*fd*s - 24*C*D1**2*f**2*fdd*r*s + 8*C*D1**2*f**2*fdd*r + 8*C*D1**2*f**2*fdd*s - 48*C*D1**2*f*fd**2*r*s + 16*C*D1**2*f*fd**2*r + 16*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 192*C*D1*Dd*b1*f**2*r*s - 48*C*D1*Dd*b1*f**2*r - 48*C*D1*Dd*b1*f**2*s - 384*C*D1*Dd*b1*f*fd*r*s + 144*C*D1*Dd*b1*f*fd*r + 48*C*D1*Dd*b1*f*fd*s - 24*C*D1*Dd*b1*f*fd + 64*C*D1*Dd*f**3*r*s - 16*C*D1*Dd*f**3*r - 16*C*D1*Dd*f**3*s - 192*C*D1*Dd*f**2*fd*r*s + 56*C*D1*Dd*f**2*fd*r + 56*C*D1*Dd*f**2*fd*s - 16*C*D1*Dd*f**2*fd - 96*C*D1*Ddd*b1*f**2*r*s + 24*C*D1*Ddd*b1*f**2*r + 24*C*D1*Ddd*b1*f**2*s - 32*C*D1*Ddd*f**3*r*s + 8*C*D1*Ddd*f**3*r + 8*C*D1*Ddd*f**3*s - 288*C*Dd**2*b1*f**2*r*s + 72*C*Dd**2*b1*f**2*r + 72*C*Dd**2*b1*f**2*s - 24*C*Dd**2*b1*f**2 - 96*C*Dd**2*f**3*r*s + 24*C*Dd**2*f**3*r + 24*C*Dd**2*f**3*s - 8*C*Dd**2*f**3 - 24*D1**2*b1*f*fd*r**2 + 30*D1**2*b1*f*fd*r*s - 15*D1**2*b1*f*fd*r + 12*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*f*fdd*r*s - 3*D1**2*b1*f*fdd*r + 12*D1**2*b1*fd**2*r**2 + 6*D1**2*b1*fd**2*r*s - 3*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(r - 1)*(-8*C*s + 2*r + s - 2) - 12*D1**2*f**2*fd*r**2 + 3*D1**2*f**2*fd*r*s + 7*D1**2*f**2*fd*r - D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 5*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd + 12*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 10*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 - 48*D1*Dd*b1*f**2*r**2 + 60*D1*Dd*b1*f**2*r*s + 9*D1*Dd*b1*f**2*r - 15*D1*Dd*b1*f**2*s - 12*D1*Dd*b1*f**2 + 96*D1*Dd*b1*f*fd*r**2 + 48*D1*Dd*b1*f*fd*r*s - 42*D1*Dd*b1*f*fd*r - 6*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 16*D1*Dd*f**3*r**2 + 4*D1*Dd*f**3*r*s + 7*D1*Dd*f**3*r - D1*Dd*f**3*s - 4*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 35*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 6*D1*Dd*f**2*fd + 24*D1*Ddd*b1*f**2*r**2 + 12*D1*Ddd*b1*f**2*r*s - 15*D1*Ddd*b1*f**2*r - 3*D1*Ddd*b1*f**2*s + 6*D1*Ddd*b1*f**2 + 8*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 5*D1*Ddd*f**3*r - D1*Ddd*f**3*s + 2*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(-f*(r - 1)*(-16*C*s + 4*r - 5*s - 4) + fd*(-8*C*(4*r*s - r - 2*s + 1) + 8*r**2 + 4*r*s - 9*r - 2*s + 1)) + Dd*f*(-8*C*(8*r*s - r - 5*s + 1) + 16*r**2 + 8*r*s - 21*r - 5*s + 5)) + 72*Dd**2*b1*f**2*r**2 + 36*Dd**2*b1*f**2*r*s - 45*Dd**2*b1*f**2*r - 9*Dd**2*b1*f**2*s + 3*Dd**2*b1*f**2 + 24*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 15*Dd**2*f**3*r - 3*Dd**2*f**3*s + Dd**2*f**3)/(105*d**2*k3**2) + D1**2*Pk2*Pkd1*k1*st**2*(21*b1**2*(D1**2*r*(fd*(4*r - 3*s) - fdd*(2*r + s)) + D1*(Dd*(f*(16*r**2 - 12*r*s - 5*r + 3*s + 4) + fd*(-16*r**2 - 8*r*s + 5*r + s)) + Ddd*f*(-8*r**2 + r*(5 - 4*s) + s - 2)) + Dd**2*f*(-24*r**2 - 3*r*(4*s - 5) + 3*s - 1)) + 3*b1*(44*C*D1**2*f*fd*r**2 + 168*C*D1**2*f*fd*r*s - 84*C*D1**2*f*fd*r - 64*C*D1**2*f*fdd*r**2 - 168*C*D1**2*f*fdd*r*s + 84*C*D1**2*f*fdd*r - 64*C*D1**2*fd**2*r**2 - 168*C*D1**2*fd**2*r*s + 84*C*D1**2*fd**2*r + 88*C*D1*Dd*f**2*r**2 + 336*C*D1*Dd*f**2*r*s - 128*C*D1*Dd*f**2*r - 84*C*D1*Dd*f**2*s + 22*C*D1*Dd*f**2 - 512*C*D1*Dd*f*fd*r**2 - 1344*C*D1*Dd*f*fd*r*s + 632*C*D1*Dd*f*fd*r + 168*C*D1*Dd*f*fd*s - 84*C*D1*Dd*f*fd - 128*C*D1*Ddd*f**2*r**2 - 336*C*D1*Ddd*f**2*r*s + 148*C*D1*Ddd*f**2*r + 84*C*D1*Ddd*f**2*s - 32*C*D1*Ddd*f**2 - 384*C*Dd**2*f**2*r**2 - 1008*C*Dd**2*f**2*r*s + 444*C*Dd**2*f**2*r + 252*C*Dd**2*f**2*s - 84*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(4*r**2 + 2*r*s - 5*r - s + 2) + 24*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s - 23*D1**2*f*fd*r + D1**2*f*fd*s + 12*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 3*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 15*D1**2*fd**2*r + 3*D1**2*fd**2*s + 48*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s - 22*D1*Dd*f**2*r + 2*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 96*D1*Dd*f*fd*r + 24*D1*Dd*f*fd*s - 18*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 18*D1*Ddd*f**2*r + 6*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(8*r**2 - 6*r*s - 5*r + 3*s + 4) + fd*(-8*r**2 - 4*r*s + 5*r + s)) - 2*Dd*f*(16*r**2 + r*(8*s - 15) - 3*s + 3)) - 72*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 54*Dd**2*f**2*r + 18*Dd**2*f**2*s - 6*Dd**2*f**2) + f*(174*C*D1**2*f*fd*r**2 + 324*C*D1**2*f*fd*r*s - 224*C*D1**2*f*fd*r - 108*C*D1**2*f*fd*s + 58*C*D1**2*f*fd - 168*C*D1**2*f*fdd*r**2 - 324*C*D1**2*f*fdd*r*s + 220*C*D1**2*f*fdd*r + 108*C*D1**2*f*fdd*s - 56*C*D1**2*f*fdd - 336*C*D1**2*fd**2*r**2 - 648*C*D1**2*fd**2*r*s + 440*C*D1**2*fd**2*r + 216*C*D1**2*fd**2*s - 108*C*D1**2*fd**2 + 232*C*D1*Dd*f**2*r**2 + 432*C*D1*Dd*f**2*r*s - 224*C*D1*Dd*f**2*r - 108*C*D1*Dd*f**2*s + 58*C*D1*Dd*f**2 - 1344*C*D1*Dd*f*fd*r**2 - 2592*C*D1*Dd*f*fd*r*s + 1540*C*D1*Dd*f*fd*r + 756*C*D1*Dd*f*fd*s - 328*C*D1*Dd*f*fd - 224*C*D1*Ddd*f**2*r**2 - 432*C*D1*Ddd*f**2*r*s + 220*C*D1*Ddd*f**2*r + 108*C*D1*Ddd*f**2*s - 56*C*D1*Ddd*f**2 - 672*C*Dd**2*f**2*r**2 - 1296*C*Dd**2*f**2*r*s + 660*C*Dd**2*f**2*r + 324*C*Dd**2*f**2*s - 108*C*Dd**2*f**2 - 21*D1**2*bd1**2*(4*r**2 + r*(2*s - 5) - s + 1) - 3*D1**2*bdd1*f*(4*C*(r - 1)*(8*r + 21*s - 8) + (r + s)*(6*r - 3)) + 3*D1**2*f*fd*r*s - D1**2*f*fd*r - D1**2*f*fd*s - 15*D1**2*f*fdd*r*s + 5*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 30*D1**2*fd**2*r*s + 10*D1**2*fd**2*r + 10*D1**2*fd**2*s - 5*D1**2*fd**2 + 4*D1*Dd*f**2*r*s - D1*Dd*f**2*r - D1*Dd*f**2*s - 120*D1*Dd*f*fd*r*s + 35*D1*Dd*f*fd*r + 35*D1*Dd*f*fd*s - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r*s + 5*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s + 3*D1*bd1*(2*C*(D1*(f*(r - 1)*(11*r + 42*s - 11) - 2*fd*(32*r**2 + 84*r*s - 53*r - 42*s + 21)) - 2*Dd*f*(64*r**2 + r*(168*s - 101) - 105*s + 37)) + D1*(f*(12*r**2 - 2*r*s + r + s) - 3*fd*(8*r**2 + 8*r*s - 7*r - 3*s + 2)) - 6*Dd*f*(8*r**2 + r*(8*s - 5) - 3*s + 1)) - 60*Dd**2*f**2*r*s + 15*Dd**2*f**2*r + 15*Dd**2*f**2*s - 5*Dd**2*f**2))/(315*d**2*k3**2) - D1**2*Pk2*Pkd1*k1*(7*D1**2*bd1**2*f*(4*C*(11*r**2 + 2*r*(5*s - 8) - 5*s + 5) + r*(6*s - 3) - 3*s + 3) + 3*D1**2*bdd1*f**2*r*(38*C*r + 28*C*(s - 1) + 5*s - 5) + D1*bd1*(-7*b1*(2*C*(D1*(f*(14*r**2 + 4*r*(5*s - 6) - 10*s + 7) + 2*fd*(-22*r**2 - 4*r*(5*s - 4) + 5*s)) - 2*Dd*f*(88*r**2 + 16*r*(5*s - 6) - 30*s + 21)) + D1*(f*r*(2*s - 1) - f*s + 3*fd*(-4*r*s + r + s)) - 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(f*r*(C*(-34*r - 28*s + 28) - 3*s + 3) + fd*(4*C*(38*r**2 + r*(28*s - 33) - 7*s + 7) + 5*r*(4*s - 2) - 5*s + 5)) + Dd*f*(4*C*(76*r**2 + r*(56*s - 54) - 7*s + 7) + 5*r*(8*s - 5) - 5*s + 5))) - 7*b1**2*(2*C*(D1**2*r*(7*fd*r + 10*fd*s - 11*fdd*r - 10*fdd*s) + D1*(Dd*(f*(28*r**2 + 8*r*(5*s - 3) - 10*s + 7) + 2*fd*(-44*r**2 - 8*r*(5*s - 2) + 5*s)) + Ddd*f*(-44*r**2 - 8*r*(5*s - 4) + 10*s - 11)) - 2*Dd**2*f*(66*r**2 + 12*r*(5*s - 4) - 15*s + 5)) + D1*Dd*(f*r*(4*s - 1) - f*s + 3*fd*(-8*r*s + r + s)) + D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) - 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-6*C*(D1**2*(f*(fd*(34*r**2 + 28*r*s - 34*r - 14*s + 17) + fdd*(-38*r**2 - 28*r*s + 38*r + 14*s - 19)) + 2*fd**2*(-19*r**2 + r*(19 - 14*s) + 7*s)) + D1*f*(Dd*(f*(68*r**2 + 8*r*(7*s - 6) - 14*s + 17) - 4*fd*(76*r**2 + 8*r*(7*s - 8) - 21*s + 13)) + Ddd*f*(-76*r**2 + r*(52 - 56*s) + 14*s - 19)) - 2*Dd**2*f**2*(114*r**2 + r*(84*s - 78) - 21*s + 7)) + 7*D1**2*bdd1*f*(C*(44*r**2 + 8*r*(5*s - 8) - 20*s + 22) + r*(6*s - 3) - 3*s) - 3*D1*Dd*f*(3*f*(4*r*s - r - s) - 5*fd*(16*r*s - 2*r - 6*s + 1)) - 3*D1*(D1*s*(2*r - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(-4*r*s + r + s)) + 15*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*k1*st**4*(-33*b1**2*(D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*f*(D1*Dd*f*(4*f*(4*r*s - r - s) + fd*(-48*r*s + 14*r + 10*s - 3)) + 3*D1*bd1*(D1*(2*f*s*(2*r - 1) + fd*(-8*r*s + 2*r + 2*s - 1)) - Dd*f*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(2*f*fd*(r*(6*s - 2) - s) + f*(3*bdd1*s*(1 - 2*r) + fdd*(-6*r*s + 2*r + s)) + fd**2*(r*(4 - 12*s) + 2*s - 1)) + 2*Ddd*f**2*(-4*r*s + r + s)) - 2*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f**2*(33*D1**2*bd1**2*s*(1 - 2*r) + 10*D1*Dd*f*(f*r*(4*s - 1) - f*s - fd*(4*r - 1)*(4*s - 1)) + 11*D1*bd1*(D1*(2*f*s*(2*r - 1) + fd*(-12*r*s + 2*r + 4*s - 1)) - Dd*f*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(10*f*fd*(r*(4*s - 1) - s) + f*(11*bdd1*s*(1 - 2*r) + 5*fdd*(-4*r*s + r + s)) - 5*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(1155*d**2*k2**2) - D1**2*Pk2*Pkd1*k1*st**2*(-42*b1**3*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1**2*(D1*Dd*(3*f*(f + 7)*(r*(4*s - 1) - s) + fd*(3*f*(r*(48*s - 34) + 2*s + 5) + 7*r*(8*s - 5) - 7*s + 7)) + 14*D1*bd1*(D1*(f*r*(6*s - 2) - 2*f*s + fd*(-6*r*s + r + s)) + Dd*f*(r*(7 - 24*s) + 7*s - 2)) + D1*(14*D1*bdd1*f*(-3*r*s + r + s) + D1*(3*fd**2*(r*(6*s - 7) + 2*s) + 3*fd*(-4*f*s + r*(2*f*s + 7*f + 7*s - 7)) + fdd*(3*f*r*(6*s - 7) + 6*f*s + 7*r*(s - 1))) + Ddd*f*(9*f + 7)*(r*(4*s - 1) - s)) + Dd**2*f*(9*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-42*D1**2*bd1**2*f*(r*(6*s - 2) - 2*s + 1) + D1*Dd*f*(-f*(34*f - 3)*(r*(4*s - 1) - s) + fd*(f*(12*r*(88*s - 29) - 200*s + 71) + 18*r*(8*s - 3) - 54*s + 18)) + 3*D1*bd1*(D1*(3*f*(2*f*r*(s - 4) + 3*f*s + s*(14*r - 7)) + fd*(3*f*(6*r*(4*s - 1) - 6*s + 5) + 7*r*(4*s - 2) - 7*s + 7)) + Dd*f*(6*f*r*(24*s + 5) - 78*f*s + 3*f + 14*r*(8*s - 1) - 42*s + 7)) + D1*(D1*(f*fd*(r*(-102*f*s + 54*f + 6*s - 3) + s*(7*f - 3)) + f*(9*bdd1*f*(r*(6*s + 4) - 5*s) + 21*bdd1*s*(2*r - 1) + 3*fdd*r*(2*f*(22*s - 9) + 6*s - 3) - fdd*s*(17*f + 9)) + fd**2*(f*(12*r*(22*s - 9) - 34*s + 27) + 18*r*s - 9*r - 9*s + 9)) + Ddd*f**2*(44*f + 9)*(r*(4*s - 1) - s)) + Dd**2*f**2*(44*f + 9)*(3*r*(4*s - 1) - 3*s + 1)) + f*(3*D1**2*bd1**2*(3*f*(r*(6*s + 4) - 5*s - 2) + s*(14*r - 7)) - D1*bd1*(D1*(f**2*(r*(34*s + 20) - 27*s) + f*(fd*(-264*r*s + 24*r + 98*s - 17) - 3*r*s) + 9*fd*(-4*r*s + r + s)) + Dd*f*(f*(-352*r*s + 4*r + 152*s - 17) - 72*r*s + 9*r + 9*s)) + f*(-15*D1*Dd*f*(f*r*(4*s - 1) - f*s - 2*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(bdd1*(2*f*r*(22*s + 5) - 27*f*s + 9*r*s) + 15*f*fd*(-4*r*s + r + s) + 15*f*fdd*(r*(4*s - 1) - s) + 15*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 15*Ddd*f**2*(r*(4*s - 1) - s)) + 15*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(315*d**2*k2**2) + D1**2*Pk2*Pkd1*k1*(-3*D1*f*(7*D1*bd1**2*(f*r*(4*s - 2) - f*s + f + r*(2*s - 1)) + 5*D1*bdd1*f**2*r*(s - 1) + 5*bd1*f*(D1*(-f*r*(s - 1) + fd*r*(6*s - 3) - fd*s + fd) + Dd*f*(r*(8*s - 5) - s + 1))) - 35*b1**3*(-D1*Dd*(r*(4*f*s - f - 8*fd*s + fd - 4*s + 1) + s*(-f + fd + 1)) + D1*(D1*r*s*(-fd + fdd) + Ddd*(f + 1)*(4*r*s - r - s)) + Dd**2*(f + 1)*(3*r*(4*s - 1) - 3*s + 1)) + 7*b1**2*(D1*Dd*(f*(6*f + 1)*(r*(4*s - 1) - s) - 3*fd*(f*(4*r - 1)*(8*s - 1) + 8*r*s - r - 5*s + 1)) + 5*D1*bd1*(D1*(r*(3*f*s - f - 6*fd*s + fd - 3*s + 1) + s*(-f + fd + 1)) - Dd*(f + 1)*(r*(24*s - 7) - 7*s + 2)) + D1*(-5*D1*bdd1*(f + 1)*(r*(3*s - 1) - s) + D1*s*(fd**2*(3 - 12*r) + fd*(12*f*r - 3*f + r - 1) + 3*fdd*(-4*f*r + f - r + 1)) - 3*Ddd*f*(2*f + 1)*(r*(4*s - 1) - s)) - 3*Dd**2*f*(2*f + 1)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-35*D1**2*bd1**2*(f + 1)*(r*(6*s - 2) - 2*s + 1) + 7*D1*bd1*(-D1*(f*(3*f*s - r*(6*f + 1)*(2*s - 1)) + 3*fd*(f*(4*r - 1)*(4*s - 1) + 4*r*s - r - 2*s + 1)) - 3*Dd*f*(f*(4*r - 1)*(8*s - 3) + 16*r*s - 6*r - 2*s + 1)) - 3*f*(-5*D1*Dd*f*(f*(4*r*s - r - s) + fd*(-24*r*s + 3*r + 7*s - 1)) + D1*(7*D1*bdd1*(-f*s + r*(2*f + 1)*(2*s - 1)) - 5*D1*s*(3*r - 1)*(f*fd - f*fdd - 2*fd**2) - 5*Ddd*f**2*(-4*r*s + r + s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(105*d**2*k2**2) - D1**2*Pk2*Pkd1*k2**2*st**4*(12*C*D1**2*b1*f*fd*r**2 + 36*C*D1**2*b1*f*fdd*r**2 + 36*C*D1**2*b1*fd**2*r**2 - 42*C*D1**2*f**2*fd*r**2 + 28*C*D1**2*f**2*fd*r - 14*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r**2 - 20*C*D1**2*f**2*fdd*r + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r**2 - 40*C*D1**2*f*fd**2*r + 24*C*D1*Dd*b1*f**2*r**2 - 12*C*D1*Dd*b1*f**2*r + 6*C*D1*Dd*b1*f**2 + 288*C*D1*Dd*b1*f*fd*r**2 - 72*C*D1*Dd*b1*f*fd*r - 56*C*D1*Dd*f**3*r**2 + 28*C*D1*Dd*f**3*r - 14*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r**2 - 140*C*D1*Dd*f**2*fd*r + 20*C*D1*Dd*f**2*fd + 72*C*D1*Ddd*b1*f**2*r**2 - 36*C*D1*Ddd*b1*f**2*r + 18*C*D1*Ddd*b1*f**2 + 40*C*D1*Ddd*f**3*r**2 - 20*C*D1*Ddd*f**3*r + 10*C*D1*Ddd*f**3 + 216*C*Dd**2*b1*f**2*r**2 - 108*C*Dd**2*b1*f**2*r + 120*C*Dd**2*f**3*r**2 - 60*C*Dd**2*f**3*r - 24*D1**2*b1*f*fd*r**2 + 30*D1**2*b1*f*fd*r*s - 15*D1**2*b1*f*fd*r + 12*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*f*fdd*r*s - 3*D1**2*b1*f*fdd*r + 12*D1**2*b1*fd**2*r**2 + 6*D1**2*b1*fd**2*r*s - 3*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(r - 1)*(6*C*(r - 1) + 2*r + s - 2) - 12*D1**2*f**2*fd*r**2 + 3*D1**2*f**2*fd*r*s + 7*D1**2*f**2*fd*r - D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 5*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd + 12*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 10*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 - 48*D1*Dd*b1*f**2*r**2 + 60*D1*Dd*b1*f**2*r*s + 9*D1*Dd*b1*f**2*r - 15*D1*Dd*b1*f**2*s - 12*D1*Dd*b1*f**2 + 96*D1*Dd*b1*f*fd*r**2 + 48*D1*Dd*b1*f*fd*r*s - 42*D1*Dd*b1*f*fd*r - 6*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 16*D1*Dd*f**3*r**2 + 4*D1*Dd*f**3*r*s + 7*D1*Dd*f**3*r - D1*Dd*f**3*s - 4*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 35*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 6*D1*Dd*f**2*fd + 24*D1*Ddd*b1*f**2*r**2 + 12*D1*Ddd*b1*f**2*r*s - 15*D1*Ddd*b1*f**2*r - 3*D1*Ddd*b1*f**2*s + 6*D1*Ddd*b1*f**2 + 8*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 5*D1*Ddd*f**3*r - D1*Ddd*f**3*s + 2*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(r - 1)*(2*C*(r - 1) - 4*r + 5*s + 4) + fd*(r**2*(24*C + 8) + r*(-24*C + 4*s - 9) - 2*s + 1)) + Dd*f*(12*C*(4*r**2 - 5*r + 1) + 16*r**2 + 8*r*s - 21*r - 5*s + 5)) + 72*Dd**2*b1*f**2*r**2 + 36*Dd**2*b1*f**2*r*s - 45*Dd**2*b1*f**2*r - 9*Dd**2*b1*f**2*s + 3*Dd**2*b1*f**2 + 24*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 15*Dd**2*f**3*r - 3*Dd**2*f**3*s + Dd**2*f**3)/(105*d**2*k1*k3**2) - D1**2*Pk2*Pkd1*k2**2*st**2*(D1*f*(7*D1*bd1**2*(r**2*(8*C + 4) + r*(-8*C + 2*s - 5) - s + 1) + D1*bdd1*f*r*(20*C*r + 6*r + 3*s - 3) + bd1*(D1*(f*r*(-r*(26*C + 12) + s - 1) + fd*(r**2*(80*C + 24) - 2*r*(20*C - 6*s + 9) - 3*s + 3)) + Dd*f*(r**2*(160*C + 48) + r*(-40*C + 24*s - 27) - 3*s + 3))) + 7*b1**2*(D1**2*r*(fd*r*(2*C - 4) + 3*fd*s + fdd*r*(4*C + 2) + fdd*s) + D1*(Dd*(f*(C*(8*r**2 - 4*r + 2) - 16*r**2 + 12*r*s + 5*r - 3*s - 4) + fd*(r**2*(32*C + 16) + r*(-8*C + 8*s - 5) - s)) + Ddd*f*(4*C*(4*r**2 - 2*r + 1) + 8*r**2 + 4*r*s - 5*r - s + 2)) + Dd**2*f*(r**2*(48*C + 24) - 3*r*(8*C - 4*s + 5) - 3*s + 1)) + b1*(-52*C*D1**2*f*fd*r**2 + 52*C*D1**2*f*fd*r - 26*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 - 40*C*D1**2*f*fdd*r + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 - 40*C*D1**2*fd**2*r - 104*C*D1*Dd*f**2*r**2 + 52*C*D1*Dd*f**2*r - 26*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 - 240*C*D1*Dd*f*fd*r + 40*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 - 40*C*D1*Ddd*f**2*r + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 - 120*C*Dd**2*f**2*r + 7*D1**2*bdd1*f*(C*(8*r**2 - 8*r + 4) + 4*r**2 + 2*r*s - 5*r - s + 2) - 24*D1**2*f*fd*r**2 + 2*D1**2*f*fd*r*s + 24*D1**2*f*fd*r - D1**2*f*fd*s - 12*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 6*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s - 12*D1**2*fd**2*r - 3*D1**2*fd**2*s - 48*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r*s + 23*D1*Dd*f**2*r - D1*Dd*f**2*s - 12*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 78*D1*Dd*f*fd*r - 18*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 24*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r - 3*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(C*(4*r**2 - 4*r + 2) - 8*r**2 + 6*r*s + 5*r - 3*s - 4) + fd*(r**2*(16*C + 8) + r*(-8*C + 4*s - 5) - s)) + 2*Dd*f*(4*C*(8*r**2 - 6*r + 1) + 16*r**2 + 8*r*s - 15*r - 3*s + 3)) + 72*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s - 45*Dd**2*f**2*r - 9*Dd**2*f**2*s + 3*Dd**2*f**2))/(105*d**2*k1*k3**2) - D1**2*Pk2*Pkd1*st**4*(33*b1**2*(2*D1**2*r*(f*fd*(r + 8*s - 2) + f*fdd*(3*r - 4*s + 1) + fd**2*(3*r - 4*s + 1)) + D1*f*(Dd*(f*(4*r**2 + 32*r*s - 10*r - 8*s + 1) + 2*fd*(24*r**2 - 32*r*s + 2*r + 4*s - 1)) + Ddd*f*(12*r**2 - 2*r*(8*s + 1) + 4*s + 3)) + 2*Dd**2*f**2*(18*r**2 - 3*r*(8*s + 1) + 6*s - 2)) + 11*b1*f*(3*D1**2*bdd1*f*(6*r**2 - 8*r*s - 4*r + 4*s + 3) - 63*D1**2*f*fd*r**2 - 21*D1**2*f*fd*r*s + 25*D1**2*f*fd*r - 8*D1**2*f*fd*s - 7*D1**2*f*fd + 45*D1**2*f*fdd*r**2 + 33*D1**2*f*fdd*r*s - 23*D1**2*f*fdd*r + 4*D1**2*f*fdd*s + 5*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 66*D1**2*fd**2*r*s - 46*D1**2*fd**2*r + 8*D1**2*fd**2*s - 2*D1**2*fd**2 - 84*D1*Dd*f**2*r**2 - 28*D1*Dd*f**2*r*s + 49*D1*Dd*f**2*r + 7*D1*Dd*f**2*s - 21*D1*Dd*f**2 + 360*D1*Dd*f*fd*r**2 + 264*D1*Dd*f*fd*r*s - 215*D1*Dd*f*fd*r - 17*D1*Dd*f*fd*s + 19*D1*Dd*f*fd + 60*D1*Ddd*f**2*r**2 + 44*D1*Ddd*f**2*r*s - 41*D1*Ddd*f**2*r - 11*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(2*r**2 + 2*r*(8*s - 3) - 8*s + 1) + 2*fd*(12*r**2 - 2*r*(8*s + 1) + 4*s - 1)) + 4*Dd*f*(12*r**2 - r*(16*s + 5) + 6*s)) + 180*Dd**2*f**2*r**2 + 132*Dd**2*f**2*r*s - 123*Dd**2*f**2*r - 33*Dd**2*f**2*s + 11*Dd**2*f**2) + f**2*(66*D1**2*bd1**2*(3*r**2 - 2*r*(2*s + 1) + 2*s - 1) + 11*D1**2*bdd1*f*(15*r**2 + 11*r*s - 18*r - 15*s + 10) - 344*D1**2*f*fd*r**2 - 220*D1**2*f*fd*r*s + 227*D1**2*f*fd*r + 55*D1**2*f*fd*s - 86*D1**2*f*fd + 216*D1**2*f*fdd*r**2 + 220*D1**2*f*fdd*r*s - 163*D1**2*f*fdd*r - 55*D1**2*f*fdd*s + 54*D1**2*f*fdd + 648*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s - 489*D1**2*fd**2*r - 165*D1**2*fd**2*s + 55*D1**2*fd**2 - 344*D1*Dd*f**2*r**2 - 220*D1*Dd*f**2*r*s + 227*D1*Dd*f**2*r + 55*D1*Dd*f**2*s - 86*D1*Dd*f**2 + 1728*D1*Dd*f*fd*r**2 + 1760*D1*Dd*f*fd*r*s - 1304*D1*Dd*f*fd*r - 440*D1*Dd*f*fd*s + 218*D1*Dd*f*fd + 216*D1*Ddd*f**2*r**2 + 220*D1*Ddd*f**2*r*s - 163*D1*Ddd*f**2*r - 55*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 - 11*D1*bd1*(D1*(f*(21*r**2 + 7*r*s - 24*r - 15*s + 14) + fd*(-90*r**2 - 66*r*s + 77*r + 41*s - 13)) + Dd*f*(-120*r**2 + r*(113 - 88*s) + 71*s - 33)) + 648*Dd**2*f**2*r**2 + 660*Dd**2*f**2*r*s - 489*Dd**2*f**2*r - 165*Dd**2*f**2*s + 55*Dd**2*f**2))/(1155*d**2*k1) - D1**2*Pk2*Pkd1*st**2*(28*D1**2*K*bd1**2*f*r**2 - 28*D1**2*K*bd1**2*f*r - 13*D1**2*K*bd1*f**2*r**2 + 40*D1**2*K*bd1*f*fd*r**2 - 20*D1**2*K*bd1*f*fd*r + 10*D1**2*K*bdd1*f**2*r**2 + 80*D1**2*bd1**2*f**2*r**2 + 84*D1**2*bd1**2*f**2*r*s - 81*D1**2*bd1**2*f**2*r - 42*D1**2*bd1**2*f**2*s + 21*D1**2*bd1**2*f**2 + 28*D1**2*bd1**2*f*r**2 + 14*D1**2*bd1**2*f*r*s - 28*D1**2*bd1**2*f*r - 7*D1**2*bd1**2*f*s + 28*D1**2*bd1*bd2*f*r**2 - 28*D1**2*bd1*bd2*f*r - 27*D1**2*bd1*f**3*r**2 - 18*D1**2*bd1*f**3*r*s + 9*D1**2*bd1*f**3*r + 108*D1**2*bd1*f**2*fd*r**2 + 108*D1**2*bd1*f**2*fd*r*s - 72*D1**2*bd1*f**2*fd*r - 18*D1**2*bd1*f**2*fd*s + 9*D1**2*bd1*f**2*fd - 13*D1**2*bd1*f**2*r**2 + D1**2*bd1*f**2*r*s + 40*D1**2*bd1*f*fd*r**2 + 12*D1**2*bd1*f*fd*r*s - 23*D1**2*bd1*f*fd*r - 3*D1**2*bd1*f*fd*s - 14*D1**2*bd1*f*g2*r**2 + 28*D1**2*bd1*f*g2*r - 14*D1**2*bd1*f*g2 - 56*D1**2*bd1*f*gd2*r**2 + 56*D1**2*bd1*f*gd2*r - 56*D1**2*bd1*fd*g2*r**2 + 56*D1**2*bd1*fd*g2*r - 13*D1**2*bd2*f**2*r**2 + 40*D1**2*bd2*f*fd*r**2 - 20*D1**2*bd2*f*fd*r + 18*D1**2*bdd1*f**3*r**2 + 18*D1**2*bdd1*f**3*r*s - 9*D1**2*bdd1*f**3*r + 10*D1**2*bdd1*f**2*r**2 + 3*D1**2*bdd1*f**2*r*s - 28*D1**2*bdd1*f*g2*r**2 + 56*D1**2*bdd1*f*g2*r - 28*D1**2*bdd1*f*g2 + 10*D1**2*bdd2*f**2*r**2 + 26*D1**2*f**2*gd2*r**2 - 20*D1**2*f**2*gdd2*r**2 + 52*D1**2*f*fd*g2*r**2 - 52*D1**2*f*fd*g2*r + 26*D1**2*f*fd*g2 - 80*D1**2*f*fd*gd2*r**2 + 40*D1**2*f*fd*gd2*r - 40*D1**2*f*fdd*g2*r**2 + 40*D1**2*f*fdd*g2*r - 20*D1**2*f*fdd*g2 - 40*D1**2*fd**2*g2*r**2 + 40*D1**2*fd**2*g2*r + 80*D1*Dd*K*bd1*f**2*r**2 - 20*D1*Dd*K*bd1*f**2*r + 144*D1*Dd*bd1*f**3*r**2 + 144*D1*Dd*bd1*f**3*r*s - 90*D1*Dd*bd1*f**3*r - 18*D1*Dd*bd1*f**3*s + 9*D1*Dd*bd1*f**3 + 80*D1*Dd*bd1*f**2*r**2 + 24*D1*Dd*bd1*f**2*r*s - 23*D1*Dd*bd1*f**2*r - 3*D1*Dd*bd1*f**2*s - 224*D1*Dd*bd1*f*g2*r**2 + 280*D1*Dd*bd1*f*g2*r - 56*D1*Dd*bd1*f*g2 + 80*D1*Dd*bd2*f**2*r**2 - 20*D1*Dd*bd2*f**2*r + 104*D1*Dd*f**2*g2*r**2 - 52*D1*Dd*f**2*g2*r + 26*D1*Dd*f**2*g2 - 160*D1*Dd*f**2*gd2*r**2 + 40*D1*Dd*f**2*gd2*r - 320*D1*Dd*f*fd*g2*r**2 + 240*D1*Dd*f*fd*g2*r - 40*D1*Dd*f*fd*g2 - 80*D1*Ddd*f**2*g2*r**2 + 40*D1*Ddd*f**2*g2*r - 20*D1*Ddd*f**2*g2 - 240*Dd**2*f**2*g2*r**2 + 120*Dd**2*f**2*g2*r + 7*b1**3*(D1**2*r**2*(fd + 2*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 4*Dd*fd*r*(4*r - 1) + 2*Ddd*f*(4*r**2 - 2*r + 1)) + 12*Dd**2*f*r*(2*r - 1)) + b1**2*(7*D1**2*K*fd*r**2 + 14*D1**2*K*fdd*r**2 + 14*D1**2*bdd1*f*(3*r**2 - 2*r + 1) - 104*D1**2*f*fd*r**2 - 84*D1**2*f*fd*r*s + 47*D1**2*f*fd*r - 13*D1**2*f*fd + 80*D1**2*f*fdd*r**2 + 84*D1**2*f*fdd*r*s - 41*D1**2*f*fdd*r + 10*D1**2*f*fdd + 80*D1**2*fd**2*r**2 + 84*D1**2*fd**2*r*s - 41*D1**2*fd**2*r + 7*D1**2*fd*r**2 + 21*D1**2*fd*r*s - 21*D1**2*fd*r + 14*D1**2*fdd*r**2 + 7*D1**2*fdd*r*s - 7*D1**2*fdd*r + 28*D1*Dd*K*f*r**2 - 14*D1*Dd*K*f*r + 7*D1*Dd*K*f + 112*D1*Dd*K*fd*r**2 - 28*D1*Dd*K*fd*r - 208*D1*Dd*f**2*r**2 - 168*D1*Dd*f**2*r*s + 146*D1*Dd*f**2*r + 42*D1*Dd*f**2*s - 52*D1*Dd*f**2 + 640*D1*Dd*f*fd*r**2 + 672*D1*Dd*f*fd*r*s - 408*D1*Dd*f*fd*r - 84*D1*Dd*f*fd*s + 41*D1*Dd*f*fd + 28*D1*Dd*f*r**2 + 84*D1*Dd*f*r*s - 35*D1*Dd*f*r - 21*D1*Dd*f*s + 7*D1*Dd*f + 112*D1*Dd*fd*r**2 + 56*D1*Dd*fd*r*s - 63*D1*Dd*fd*r - 7*D1*Dd*fd*s + 7*D1*Dd*fd + 56*D1*Ddd*K*f*r**2 - 28*D1*Ddd*K*f*r + 14*D1*Ddd*K*f + 160*D1*Ddd*f**2*r**2 + 168*D1*Ddd*f**2*r*s - 122*D1*Ddd*f**2*r - 42*D1*Ddd*f**2*s + 40*D1*Ddd*f**2 + 56*D1*Ddd*f*r**2 + 28*D1*Ddd*f*r*s - 35*D1*Ddd*f*r - 7*D1*Ddd*f*s + 14*D1*Ddd*f + 7*D1*bd1*(D1*f*(3*r**2 - 2*r + 1) + 4*D1*fd*r*(3*r - 1) + 4*Dd*f*(12*r**2 - 7*r + 1)) + 168*Dd**2*K*f*r**2 - 84*Dd**2*K*f*r + 480*Dd**2*f**2*r**2 + 504*Dd**2*f**2*r*s - 366*Dd**2*f**2*r - 126*Dd**2*f**2*s + 42*Dd**2*f**2 + 168*Dd**2*f*r**2 + 84*Dd**2*f*r*s - 105*Dd**2*f*r - 21*Dd**2*f*s + 7*Dd**2*f) + b1*(-26*D1**2*K*f*fd*r**2 + 26*D1**2*K*f*fd*r - 13*D1**2*K*f*fd + 20*D1**2*K*f*fdd*r**2 - 20*D1**2*K*f*fdd*r + 10*D1**2*K*f*fdd + 20*D1**2*K*fd**2*r**2 - 20*D1**2*K*fd**2*r + 7*D1**2*b2*fd*r**2 + 14*D1**2*b2*fdd*r**2 + 28*D1**2*bd1**2*f*r*(3*r - 2) + 7*D1**2*bd2*f*r**2 + 28*D1**2*bd2*fd*r**2 + D1**2*bdd1*f*(7*K*(4*r**2 - 4*r + 2) + f*(80*r**2 + r*(84*s - 81) - 42*s + 30) + 28*r**2 + 14*r*(s - 2) - 7*s + 14) + 14*D1**2*bdd2*f*r**2 - 81*D1**2*f**2*fd*r**2 - 54*D1**2*f**2*fd*r*s + 63*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s - 27*D1**2*f**2*fd + 54*D1**2*f**2*fdd*r**2 + 54*D1**2*f**2*fdd*r*s - 45*D1**2*f**2*fdd*r - 18*D1**2*f**2*fdd*s + 18*D1**2*f**2*fdd + 108*D1**2*f*fd**2*r**2 + 108*D1**2*f*fd**2*r*s - 90*D1**2*f*fd**2*r - 36*D1**2*f*fd**2*s + 9*D1**2*f*fd**2 - 26*D1**2*f*fd*r**2 + 2*D1**2*f*fd*r*s + 25*D1**2*f*fd*r - D1**2*f*fd*s - 13*D1**2*f*fd + 20*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 23*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 10*D1**2*f*fdd - 14*D1**2*f*gd2*r**2 - 28*D1**2*f*gdd2*r**2 + 20*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s - 23*D1**2*fd**2*r - 3*D1**2*fd**2*s + 3*D1**2*fd**2 - 14*D1**2*fd*g2*r**2 - 56*D1**2*fd*gd2*r**2 - 28*D1**2*fdd*g2*r**2 - 52*D1*Dd*K*f**2*r**2 + 26*D1*Dd*K*f**2*r - 13*D1*Dd*K*f**2 + 160*D1*Dd*K*f*fd*r**2 - 120*D1*Dd*K*f*fd*r + 20*D1*Dd*K*f*fd + 28*D1*Dd*b2*f*r**2 - 14*D1*Dd*b2*f*r + 7*D1*Dd*b2*f + 112*D1*Dd*b2*fd*r**2 - 28*D1*Dd*b2*fd*r + 112*D1*Dd*bd2*f*r**2 - 28*D1*Dd*bd2*f*r - 108*D1*Dd*f**3*r**2 - 72*D1*Dd*f**3*r*s + 72*D1*Dd*f**3*r + 18*D1*Dd*f**3*s - 27*D1*Dd*f**3 + 432*D1*Dd*f**2*fd*r**2 + 432*D1*Dd*f**2*fd*r*s - 342*D1*Dd*f**2*fd*r - 126*D1*Dd*f**2*fd*s + 63*D1*Dd*f**2*fd - 52*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r*s + 25*D1*Dd*f**2*r - D1*Dd*f**2*s - 13*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 138*D1*Dd*f*fd*r - 18*D1*Dd*f*fd*s + 26*D1*Dd*f*fd - 56*D1*Dd*f*g2*r**2 + 28*D1*Dd*f*g2*r - 14*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 + 56*D1*Dd*f*gd2*r - 224*D1*Dd*fd*g2*r**2 + 56*D1*Dd*fd*g2*r + 40*D1*Ddd*K*f**2*r**2 - 20*D1*Ddd*K*f**2*r + 10*D1*Ddd*K*f**2 + 56*D1*Ddd*b2*f*r**2 - 28*D1*Ddd*b2*f*r + 14*D1*Ddd*b2*f + 72*D1*Ddd*f**3*r**2 + 72*D1*Ddd*f**3*r*s - 54*D1*Ddd*f**3*r - 18*D1*Ddd*f**3*s + 18*D1*Ddd*f**3 + 40*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s - 23*D1*Ddd*f**2*r - 3*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 + 56*D1*Ddd*f*g2*r - 28*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(-104*r**2 + r*(99 - 84*s) + 42*s - 39) + f*(14*K*r**2 - 14*K*r + 7*K + fd*(320*r**2 + 4*r*(84*s - 61) - 84*s + 21) + 14*r**2 + 42*r*s - 14*r - 21*s + 7) + 7*fd*(r**2*(8*K + 8) + r*(-4*K + 4*s - 6) - s + 1)) + Dd*f*(28*K*(8*r**2 - 6*r + 1) + f*(8*r - 3)*(80*r + 84*s - 41) + 224*r**2 + 112*r*s - 182*r - 42*s + 35)) + 120*Dd**2*K*f**2*r**2 - 60*Dd**2*K*f**2*r + 168*Dd**2*b2*f*r**2 - 84*Dd**2*b2*f*r + 216*Dd**2*f**3*r**2 + 216*Dd**2*f**3*r*s - 162*Dd**2*f**3*r - 54*Dd**2*f**3*s + 18*Dd**2*f**3 + 120*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s - 69*Dd**2*f**2*r - 9*Dd**2*f**2*s + 3*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 + 168*Dd**2*f*g2*r) + b2*(14*D1**2*bdd1*f*(r - 1)**2 - 26*D1**2*f*fd*r**2 + 26*D1**2*f*fd*r - 13*D1**2*f*fd + 20*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r + 10*D1**2*f*fdd + 20*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r - 52*D1*Dd*f**2*r**2 + 26*D1*Dd*f**2*r - 13*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 - 120*D1*Dd*f*fd*r + 20*D1*Dd*f*fd + 40*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r + 10*D1*Ddd*f**2 + 7*D1*bd1*(r - 1)*(D1*f*(r - 1) + 4*D1*fd*r + 4*Dd*f*(4*r - 1)) + 120*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r))/(105*d**2*k1) - D1**2*Pk2*Pkd1*(D1*r*(D1*bd1**2*(3*f**2*(18*r + 14*s - 7) + 7*f*(r*(10*K + 10) + 6*s - 3) - 140*g2*(r - 1)) - 70*D1*bdd1*f*g2*r + 35*b2*(2*D1*bd1**2*(r - 1) + D1*bdd1*f*r + bd1*(-D1*f*r + 2*D1*fd*(r - 1) + 2*Dd*f*(4*r - 1))) - 70*bd1*(-D1*f*r*(bd2 + g2 - 2*gd2) + 2*D1*fd*g2*(r - 1) + 2*Dd*f*g2*(4*r - 1))) - 35*b1**3*(D1**2*r*(fd - fdd)*(r + s) + D1*(Dd*(K*(-4*r**2 + 2*r - 1) + f*(4*r**2 + r*(4*s - 3) - s + 1) - 8*fd*r**2 - 8*fd*r*s + 3*fd*r + fd*s - 4*r**2 - 4*r*s + 3*r + s - 1) - Ddd*(4*K*r**2 - 2*K*r + K + f*(4*r**2 + r*(4*s - 3) - s + 1) + 4*r**2 + 4*r*s - 3*r - s + 1)) - Dd**2*(f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1) + r**2*(12*K + 12) - 3*r*(2*K - 4*s + 3) - 3*s + 1)) + b1**2*(-35*D1**2*K*fd*r**2 + 70*D1**2*K*fd*r - 35*D1**2*K*fd + 35*D1**2*K*fdd*r**2 - 70*D1**2*K*fdd*r + 35*D1**2*K*fdd + 35*D1**2*bd2*r**2 + 35*D1**2*bdd1*(3*K*r**2 - 2*K*r + K + f*(3*r**2 + 3*r*(s - 1) - s + 1) + 3*r**2 + 3*r*s - 3*r - s + 1) + 35*D1**2*bdd2*r**2 - 66*D1**2*f*fd*r**2 - 42*D1**2*f*fd*r*s + 66*D1**2*f*fd*r + 21*D1**2*f*fd*s - 33*D1**2*f*fd + 54*D1**2*f*fdd*r**2 + 42*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r - 21*D1**2*f*fdd*s + 27*D1**2*f*fdd + 54*D1**2*fd**2*r**2 + 42*D1**2*fd**2*r*s - 54*D1**2*fd**2*r - 21*D1**2*fd**2*s - 35*D1**2*fd*r**2 - 7*D1**2*fd*r*s + 70*D1**2*fd*r + 7*D1**2*fd*s - 35*D1**2*fd + 35*D1**2*fdd*r**2 + 21*D1**2*fdd*r*s - 70*D1**2*fdd*r - 21*D1**2*fdd*s + 35*D1**2*fdd - 70*D1**2*gd2*r**2 - 70*D1**2*gdd2*r**2 - 140*D1*Dd*K*f*r**2 + 70*D1*Dd*K*f*r - 35*D1*Dd*K*f + 280*D1*Dd*K*fd*r**2 - 350*D1*Dd*K*fd*r + 70*D1*Dd*K*fd + 140*D1*Dd*b2*r**2 - 70*D1*Dd*b2*r + 35*D1*Dd*b2 + 280*D1*Dd*bd2*r**2 - 70*D1*Dd*bd2*r - 132*D1*Dd*f**2*r**2 - 84*D1*Dd*f**2*r*s + 87*D1*Dd*f**2*r + 21*D1*Dd*f**2*s - 33*D1*Dd*f**2 + 432*D1*Dd*f*fd*r**2 + 336*D1*Dd*f*fd*r*s - 366*D1*Dd*f*fd*r - 126*D1*Dd*f*fd*s + 75*D1*Dd*f*fd - 140*D1*Dd*f*r**2 - 28*D1*Dd*f*r*s + 77*D1*Dd*f*r + 7*D1*Dd*f*s - 35*D1*Dd*f + 280*D1*Dd*fd*r**2 + 168*D1*Dd*fd*r*s - 371*D1*Dd*fd*r - 105*D1*Dd*fd*s + 91*D1*Dd*fd - 280*D1*Dd*g2*r**2 + 140*D1*Dd*g2*r - 70*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 + 140*D1*Dd*gd2*r + 140*D1*Ddd*K*f*r**2 - 70*D1*Ddd*K*f*r + 35*D1*Ddd*K*f + 140*D1*Ddd*b2*r**2 - 70*D1*Ddd*b2*r + 35*D1*Ddd*b2 + 108*D1*Ddd*f**2*r**2 + 84*D1*Ddd*f**2*r*s - 75*D1*Ddd*f**2*r - 21*D1*Ddd*f**2*s + 27*D1*Ddd*f**2 + 140*D1*Ddd*f*r**2 + 84*D1*Ddd*f*r*s - 91*D1*Ddd*f*r - 21*D1*Ddd*f*s + 35*D1*Ddd*f - 280*D1*Ddd*g2*r**2 + 140*D1*Ddd*g2*r - 70*D1*Ddd*g2 - 35*D1*bd1*(D1*(K*(-3*r**2 + 2*r - 1) + f*(3*r**2 + 3*r*(s - 1) - s + 1) - 6*fd*r**2 - 6*fd*r*s + 3*fd*r + fd*s - 3*r**2 - 3*r*s + 3*r + s - 1) - Dd*(2*K*(12*r**2 - 7*r + 1) + f*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + 24*r**2 + 24*r*s - 21*r - 7*s + 4)) + 420*Dd**2*K*f*r**2 - 210*Dd**2*K*f*r + 420*Dd**2*b2*r**2 - 210*Dd**2*b2*r + 324*Dd**2*f**2*r**2 + 252*Dd**2*f**2*r*s - 225*Dd**2*f**2*r - 63*Dd**2*f**2*s + 21*Dd**2*f**2 + 420*Dd**2*f*r**2 + 252*Dd**2*f*r*s - 273*Dd**2*f*r - 63*Dd**2*f*s + 21*Dd**2*f - 840*Dd**2*g2*r**2 + 420*Dd**2*g2*r) + b1*(70*D1**2*K*bdd1*f*r**2 + 35*D1**2*bd1**2*(f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + r**2*(6*K + 6) + r*(-4*K + 6*s - 6) - 2*s + 1) - 35*D1**2*bd2*f*r**2 + 70*D1**2*bd2*fd*r**2 - 70*D1**2*bd2*fd*r + 54*D1**2*bdd1*f**2*r**2 + 42*D1**2*bdd1*f**2*r*s - 21*D1**2*bdd1*f**2*r + 70*D1**2*bdd1*f*r**2 + 42*D1**2*bdd1*f*r*s - 21*D1**2*bdd1*f*r - 140*D1**2*bdd1*g2*r**2 + 140*D1**2*bdd1*g2*r - 70*D1**2*bdd1*g2 + 35*D1**2*bdd2*f*r**2 + 70*D1**2*f*gd2*r**2 - 70*D1**2*f*gdd2*r**2 + 70*D1**2*fd*g2*r**2 - 140*D1**2*fd*g2*r + 70*D1**2*fd*g2 - 140*D1**2*fd*gd2*r**2 + 140*D1**2*fd*gd2*r - 70*D1**2*fdd*g2*r**2 + 140*D1**2*fdd*g2*r - 70*D1**2*fdd*g2 + 280*D1*Dd*bd2*f*r**2 - 70*D1*Dd*bd2*f*r + 280*D1*Dd*f*g2*r**2 - 140*D1*Dd*f*g2*r + 70*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*r**2 + 140*D1*Dd*f*gd2*r - 560*D1*Dd*fd*g2*r**2 + 700*D1*Dd*fd*g2*r - 140*D1*Dd*fd*g2 - 280*D1*Ddd*f*g2*r**2 + 140*D1*Ddd*f*g2*r - 70*D1*Ddd*f*g2 + D1*bd1*(D1*(fd*(3*f*(72*r**2 + r*(56*s - 50) - 14*s + 7) + 7*r**2*(20*K + 20) + 7*r*(-20*K + 12*s - 23) - 42*s + 21) - 70*g2*(2*r**2 - 2*r + 1) - r*(-70*bd2*(2*r - 1) + 3*f**2*(22*r + 14*s - 7) + 7*f*(r*(10*K + 10) + 2*s - 1) + 140*gd2*(2*r - 1))) + Dd*(3*f**2*(144*r**2 + 2*r*(56*s - 39) - 14*s + 7) + 7*f*(r**2*(80*K + 80) + r*(-20*K + 48*s - 38) - 6*s + 3) - 140*g2*(8*r**2 - 6*r + 1))) - 840*Dd**2*f*g2*r**2 + 420*Dd**2*f*g2*r + 35*b2*(D1**2*bdd1*(2*r**2 - 2*r + 1) - D1**2*fd*r**2 + 2*D1**2*fd*r - D1**2*fd + D1**2*fdd*r**2 - 2*D1**2*fdd*r + D1**2*fdd - 4*D1*Dd*f*r**2 + 2*D1*Dd*f*r - D1*Dd*f + 8*D1*Dd*fd*r**2 - 10*D1*Dd*fd*r + 2*D1*Dd*fd + 4*D1*Ddd*f*r**2 - 2*D1*Ddd*f*r + D1*Ddd*f + D1*bd1*(D1*(2*r**2 - 2*r + 1) + 2*Dd*(8*r**2 - 6*r + 1)) + 12*Dd**2*f*r**2 - 6*Dd**2*f*r)))/(105*d**2*k1) - D1**2*Pk2*Pkdd1*ct**6*k2**2*(C - 1)*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(315*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct**5*f*k2*(165*D1**2*b1*f*fd*r**2 - 231*D1**2*b1*f*fdd*r**2 - 462*D1**2*b1*fd**2*r**2 - 77*D1**2*bdd1*f**2*(r - 1)**2 + 196*D1**2*f**2*fd*r**2 - 98*D1**2*f**2*fd*r + 49*D1**2*f**2*fd - 252*D1**2*f**2*fdd*r**2 + 126*D1**2*f**2*fdd*r - 63*D1**2*f**2*fdd - 756*D1**2*f*fd**2*r**2 + 378*D1**2*f*fd**2*r + 220*D1*Dd*b1*f**2*r**2 - 110*D1*Dd*b1*f**2*r + 55*D1*Dd*b1*f**2 - 1848*D1*Dd*b1*f*fd*r**2 + 462*D1*Dd*b1*f*fd*r + 196*D1*Dd*f**3*r**2 - 98*D1*Dd*f**3*r + 49*D1*Dd*f**3 - 2016*D1*Dd*f**2*fd*r**2 + 1008*D1*Dd*f**2*fd*r - 126*D1*Dd*f**2*fd - 308*D1*Ddd*b1*f**2*r**2 + 154*D1*Ddd*b1*f**2*r - 77*D1*Ddd*b1*f**2 - 252*D1*Ddd*f**3*r**2 + 126*D1*Ddd*f**3*r - 63*D1*Ddd*f**3 + 11*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) - 42*D1*fd*r + 14*Dd*f*(1 - 4*r)) - 924*Dd**2*b1*f**2*r**2 + 462*Dd**2*b1*f**2*r - 756*Dd**2*f**3*r**2 + 378*Dd**2*f**3*r)/(1386*d**2*k1) - D1**2*Pk2*Pkdd1*ct**5*k1*k2*(4*C - 5)*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(630*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct**5*k2**3*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(630*d**2*k1*k3**2) - D1**2*Pk2*Pkdd1*ct**4*k1**2*(C - 2)*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(315*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct**4*k2**2*st**2*(2*C - 2)*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(105*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**4*k2**2*(21*b1**2*(C - 1)*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + 3*b1*(-21*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 3*D1**2*(f*(3*fd - 5*fdd)*(C*(2*r - 1) + 4*r**2 - 2*r + 1) - 10*fd**2*r*(C + 2*r - 1)) + 7*D1*bd1*(C - 1)*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) - 6*D1*f*(3*Dd*f*(4*r**2 - 2*r + 1) - 5*Dd*fd*(4*r - 1)*(C + 4*r - 1) - 5*Ddd*f*(4*r**2 - 2*r + 1)) - 180*Dd**2*f**2*r*(1 - 2*r)) + f*(-126*D1**2*bd1**2*r*(C - 1)*(r - 1) + 45*D1**2*bdd1*f*(-2*C*r + C + 2*r**2 - 2*r + 1) + 9*D1*bd1*(-3*D1*f*(-2*C*r + C + 2*r**2 - 2*r + 1) - 10*D1*fd*r*(C - 4*r + 3) - 10*Dd*f*(4*r - 1)*(C - 2*r + 1)) - (5*C + 5)*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 - 2*r + 1) + 14*fd**2*r*(2 - 3*r)) + D1*f*(5*Dd*f*(4*r**2 - 2*r + 1) - 14*Dd*fd*(12*r**2 - 7*r + 1) - 7*Ddd*f*(4*r**2 - 2*r + 1)) + 42*Dd**2*f**2*r*(1 - 2*r))))/(315*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**4*(-495*D1**2*K*bdd1*f**2*r**2 + 198*D1**2*bd1**2*f*r*(r - 1)*(-7*K + 5*f + 7) + 1155*D1**2*bdd1*f**3*r**2 - 1540*D1**2*bdd1*f**3*r + 770*D1**2*bdd1*f**3 + 495*D1**2*bdd1*f**2*r**2 + 1386*D1**2*bdd1*f*g2*r**2 - 2772*D1**2*bdd1*f*g2*r + 1386*D1**2*bdd1*f*g2 - 1960*D1**2*f**3*fd*r**2 + 980*D1**2*f**3*fd*r - 490*D1**2*f**3*fd + 2520*D1**2*f**3*fdd*r**2 - 1260*D1**2*f**3*fdd*r + 630*D1**2*f**3*fdd + 7560*D1**2*f**2*fd**2*r**2 - 3780*D1**2*f**2*fd**2*r - 594*D1**2*f**2*gd2*r**2 + 990*D1**2*f**2*gdd2*r**2 - 1188*D1**2*f*fd*g2*r**2 + 1188*D1**2*f*fd*g2*r - 594*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r**2 - 1980*D1**2*f*fd*gd2*r + 1980*D1**2*f*fdd*g2*r**2 - 1980*D1**2*f*fdd*g2*r + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r**2 - 1980*D1**2*fd**2*g2*r - 1960*D1*Dd*f**4*r**2 + 980*D1*Dd*f**4*r - 490*D1*Dd*f**4 + 20160*D1*Dd*f**3*fd*r**2 - 10080*D1*Dd*f**3*fd*r + 1260*D1*Dd*f**3*fd - 2376*D1*Dd*f**2*g2*r**2 + 1188*D1*Dd*f**2*g2*r - 594*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r**2 - 1980*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f*fd*g2*r**2 - 11880*D1*Dd*f*fd*g2*r + 1980*D1*Dd*f*fd*g2 + 2520*D1*Ddd*f**4*r**2 - 1260*D1*Ddd*f**4*r + 630*D1*Ddd*f**4 + 3960*D1*Ddd*f**2*g2*r**2 - 1980*D1*Ddd*f**2*g2*r + 990*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(25*f**3*(3*r**2 - 4*r + 2) + f**2*r*(-70*fd*(9*r - 7) + r*(27 - 27*K)) + 6*f*(15*fd*r*(K - 1)*(2*r - 1) + 7*g2*(r - 1)**2 - 42*gd2*r*(r - 1)) - 252*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(35*f**2*(3*r - 2) - 45*f*r*(K - 1) + 126*g2*(r - 1))) + 7560*Dd**2*f**4*r**2 - 3780*Dd**2*f**4*r + 11880*Dd**2*f**2*g2*r**2 - 5940*Dd**2*f**2*g2*r - 33*b1**2*(D1**2*r**2*(-30*fd**2 + fd*(-7*K + 18*f + 7) - 3*fdd*(-7*K + 10*f + 7)) + D1*(Dd*(9*f**2*(4*r**2 - 2*r + 1) + f*(-7*K*(4*r**2 - 2*r + 1) - r**2*(240*fd - 28) + r*(60*fd - 14) + 7) + 42*fd*r*(K - 1)*(4*r - 1)) - 3*Ddd*f*(-7*K + 5*f + 7)*(4*r**2 - 2*r + 1)) - 18*Dd**2*f*r*(2*r - 1)*(-7*K + 5*f + 7)) - 11*b1*(-54*D1**2*K*f*fd*r**2 + 54*D1**2*K*f*fd*r - 27*D1**2*K*f*fd + 90*D1**2*K*f*fdd*r**2 - 90*D1**2*K*f*fdd*r + 45*D1**2*K*f*fdd + 90*D1**2*K*fd**2*r**2 - 90*D1**2*K*fd**2*r - 9*D1**2*bdd1*f*(-7*K + 5*f + 7)*(2*r**2 - 2*r + 1) + 225*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 315*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 630*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 54*D1**2*f*fd*r**2 - 54*D1**2*f*fd*r + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 + 90*D1**2*f*fdd*r - 45*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 - 126*D1**2*f*gdd2*r**2 - 90*D1**2*fd**2*r**2 + 90*D1**2*fd**2*r + 42*D1**2*fd*g2*r**2 - 252*D1**2*fd*gd2*r**2 - 126*D1**2*fdd*g2*r**2 - 108*D1*Dd*K*f**2*r**2 + 54*D1*Dd*K*f**2*r - 27*D1*Dd*K*f**2 + 720*D1*Dd*K*f*fd*r**2 - 540*D1*Dd*K*f*fd*r + 90*D1*Dd*K*f*fd + 300*D1*Dd*f**3*r**2 - 150*D1*Dd*f**3*r + 75*D1*Dd*f**3 - 2520*D1*Dd*f**2*fd*r**2 + 910*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 - 54*D1*Dd*f**2*r + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 + 540*D1*Dd*f*fd*r - 90*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 - 84*D1*Dd*f*g2*r + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 + 252*D1*Dd*f*gd2*r - 1008*D1*Dd*fd*g2*r**2 + 252*D1*Dd*fd*g2*r + 180*D1*Ddd*K*f**2*r**2 - 90*D1*Ddd*K*f**2*r + 45*D1*Ddd*K*f**2 - 420*D1*Ddd*f**3*r**2 + 210*D1*Ddd*f**3*r - 105*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 + 90*D1*Ddd*f**2*r - 45*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 + 252*D1*Ddd*f*g2*r - 126*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(9*f**2*(2*r**2 - 2*r + 1) + f*(-7*K*(2*r**2 - 2*r + 1) - r**2*(120*fd - 14) + r*(60*fd - 14) + 7) + 42*fd*r*(K - 1)*(2*r - 1)) - 6*Dd*f*(-7*K + 5*f + 7)*(8*r**2 - 6*r + 1)) + 540*Dd**2*K*f**2*r**2 - 270*Dd**2*K*f**2*r - 1260*Dd**2*f**3*r**2 + 630*Dd**2*f**3*r - 540*Dd**2*f**2*r**2 + 270*Dd**2*f**2*r - 1512*Dd**2*f*g2*r**2 + 756*Dd**2*f*g2*r))/(6930*d**2) + D1**2*Pk2*Pkdd1*ct**3*f*k2*st**2*(33*D1**2*b1*f*fd*r**2 - 165*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 55*D1**2*bdd1*f**2*(r - 1)**2 + 60*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r + 15*D1**2*f**2*fd - 140*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 + 210*D1**2*f*fd**2*r + 44*D1*Dd*b1*f**2*r**2 - 22*D1*Dd*b1*f**2*r + 11*D1*Dd*b1*f**2 - 1320*D1*Dd*b1*f*fd*r**2 + 330*D1*Dd*b1*f*fd*r + 60*D1*Dd*f**3*r**2 - 30*D1*Dd*f**3*r + 15*D1*Dd*f**3 - 1120*D1*Dd*f**2*fd*r**2 + 560*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 220*D1*Ddd*b1*f**2*r**2 + 110*D1*Ddd*b1*f**2*r - 55*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 11*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 30*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 660*Dd**2*b1*f**2*r**2 + 330*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(693*d**2*k1) + D1**2*Pk2*Pkdd1*ct**3*k1**3*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(630*d**2*k2*k3**2) + D1**2*Pk2*Pkdd1*ct**3*k1*k2*st**2*(2*C - 3)*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(105*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**3*k1*k2*(21*b1**2*(4*C - 5)*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + 3*b1*(-21*D1**2*bdd1*f*(4*C - 5)*(2*r**2 - 2*r + 1) - 3*D1**2*(f*(3*fd - 5*fdd)*(C*(8*r - 4) + 12*r**2 - 10*r + 5) - 10*fd**2*r*(4*C + 6*r - 5)) + 7*D1*bd1*(4*C - 5)*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) - 6*D1*f*(9*Dd*f*(4*r**2 - 2*r + 1) - 5*Dd*fd*(4*r - 1)*(4*C + 12*r - 5) - 15*Ddd*f*(4*r**2 - 2*r + 1)) - 540*Dd**2*f**2*r*(1 - 2*r)) + f*(-126*D1**2*bd1**2*r*(4*C - 5)*(r - 1) - 45*D1**2*bdd1*f*(C*(8*r - 4) - 6*r**2 + 2*r - 1) + 9*D1*bd1*(3*D1*f*(C*(8*r - 4) - 6*r**2 + 2*r - 1) + 10*D1*fd*r*(-4*C + 12*r - 7) - 10*Dd*f*(4*r - 1)*(4*C - 6*r + 1)) - 5*(4*C + 1)*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 - 2*r + 1) + 14*fd**2*r*(2 - 3*r)) + D1*f*(5*Dd*f*(4*r**2 - 2*r + 1) - 14*Dd*fd*(12*r**2 - 7*r + 1) - 7*Ddd*f*(4*r**2 - 2*r + 1)) + 42*Dd**2*f**2*r*(1 - 2*r))))/(630*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct**3*k1*(33*b1**2*(D1**2*r**2*(-30*fd**2 + fd*(18*f + 7) - fdd*(30*f + 21)) + D1*(Dd*(9*f**2*(4*r**2 - 2*r + 1) + f*(-r**2*(240*fd - 28) + r*(60*fd - 14) + 7) + 42*fd*r*(1 - 4*r)) - 3*Ddd*f*(5*f + 7)*(4*r**2 - 2*r + 1)) - 18*Dd**2*f*r*(5*f + 7)*(2*r - 1)) + 11*b1*(-9*D1**2*bdd1*f*(5*f + 7)*(2*r**2 - 2*r + 1) + 150*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 54*D1**2*f*fd*r**2 - 54*D1**2*f*fd*r + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 + 90*D1**2*f*fdd*r - 45*D1**2*f*fdd - 90*D1**2*fd**2*r**2 + 90*D1**2*fd**2*r + 200*D1*Dd*f**3*r**2 - 100*D1*Dd*f**3*r + 50*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 + 700*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 - 54*D1*Dd*f**2*r + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 + 540*D1*Dd*f*fd*r - 90*D1*Dd*f*fd - 280*D1*Ddd*f**3*r**2 + 140*D1*Ddd*f**3*r - 70*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 + 90*D1*Ddd*f**2*r - 45*D1*Ddd*f**2 + 3*D1*bd1*(D1*(9*f**2*(2*r**2 - 2*r + 1) + f*(-r**2*(120*fd - 14) + r*(60*fd - 14) + 7) + 42*fd*r*(1 - 2*r)) - 6*Dd*f*(5*f + 7)*(8*r**2 - 6*r + 1)) - 840*Dd**2*f**3*r**2 + 420*Dd**2*f**3*r - 540*Dd**2*f**2*r**2 + 270*Dd**2*f**2*r) + f*(-198*D1**2*bd1**2*r*(5*f + 7)*(r - 1) - 55*D1**2*bdd1*f*(7*f*(2*r**2 - 2*r + 1) + 9*r**2) + 11*D1*bd1*(D1*(25*f**2*(2*r**2 - 2*r + 1) + f*r*(-420*fd*r + 280*fd + 27*r) + 90*fd*r*(1 - 2*r)) - 10*Dd*f*(4*r - 1)*(7*f*(2*r - 1) + 9*r)) + 35*f*(D1**2*(f*(7*fd - 9*fdd)*(4*r**2 - 2*r + 1) + 54*fd**2*r*(1 - 2*r)) + D1*f*(7*Dd*f*(4*r**2 - 2*r + 1) - 18*Dd*fd*(1 - 4*r)**2 - 9*Ddd*f*(4*r**2 - 2*r + 1)) + 54*Dd**2*f**2*r*(1 - 2*r))))/(6930*d**2*k2) - D1**2*Pk2*Pkdd1*ct**3*k2**3*st**2*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(105*d**2*k1*k3**2) + D1**2*Pk2*Pkdd1*ct**3*k2**3*(3*D1*f*r*(-14*D1*bd1**2*(r - 1) + D1*bd1*(3*f*r + fd*(10 - 20*r)) - 5*D1*bdd1*f*r + 10*Dd*bd1*f*(1 - 4*r)) + 7*b1**2*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + b1*(-21*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) + 10*fd**2*r*(r - 1)) + 7*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) - 3*D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(8*r**2 - 6*r + 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) - 90*Dd**2*f**2*r*(2*r - 1)))/(210*d**2*k1*k3**2) + D1**2*Pk2*Pkdd1*ct**3*k2*(D1*f*r*(-18*D1*bd1**2*(10*f + 7)*(r - 1) - 5*D1*bdd1*f*r*(14*f + 9) + bd1*(D1*f*r*(50*f + 27) - 10*D1*fd*(14*f*(3*r - 1) + 18*r - 9) - 10*Dd*f*(14*f + 9)*(4*r - 1))) + 3*b1**2*(D1**2*r**2*(-60*fd**2 + fd*(36*f + 7) - fdd*(60*f + 21)) + D1*(Dd*(18*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(28 - 480*fd) + r*(120*fd - 14) + 7) + 42*fd*r*(1 - 4*r)) - 3*Ddd*f*(10*f + 7)*(4*r**2 - 2*r + 1)) - 18*Dd**2*f*r*(10*f + 7)*(2*r - 1)) + b1*(-9*D1**2*bdd1*f*(10*f + 7)*(2*r**2 - 2*r + 1) + 150*D1**2*f**2*fd*r**2 - 100*D1**2*f**2*fd*r + 50*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 + 140*D1**2*f**2*fdd*r - 70*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 + 280*D1**2*f*fd**2*r + 54*D1**2*f*fd*r**2 - 54*D1**2*f*fd*r + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 + 90*D1**2*f*fdd*r - 45*D1**2*f*fdd - 90*D1**2*fd**2*r**2 + 90*D1**2*fd**2*r + 200*D1*Dd*f**3*r**2 - 100*D1*Dd*f**3*r + 50*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 + 980*D1*Dd*f**2*fd*r - 140*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 - 54*D1*Dd*f**2*r + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 + 540*D1*Dd*f*fd*r - 90*D1*Dd*f*fd - 280*D1*Ddd*f**3*r**2 + 140*D1*Ddd*f**3*r - 70*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 + 90*D1*Ddd*f**2*r - 45*D1*Ddd*f**2 + 3*D1*bd1*(D1*(18*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(14 - 240*fd) + r*(120*fd - 14) + 7) + 42*fd*r*(1 - 2*r)) - 6*Dd*f*(10*f + 7)*(8*r**2 - 6*r + 1)) - 840*Dd**2*f**3*r**2 + 420*Dd**2*f**3*r - 540*Dd**2*f**2*r**2 + 270*Dd**2*f**2*r))/(630*d**2*k1) + D1**2*Pk2*Pkdd1*ct**2*k1**2*st**2*(C - 4)*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(315*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**2*k1**2*(21*b1**2*(C - 2)*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + 3*b1*(-21*D1**2*bdd1*f*(C - 2)*(2*r**2 - 2*r + 1) - 3*D1**2*(f*(3*fd - 5*fdd)*(C*(2*r - 1) + 4*r**2 - 4*r + 2) - 10*fd**2*r*(C + 2*r - 2)) + 7*D1*bd1*(C - 2)*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) - 6*D1*f*(3*Dd*f*(4*r**2 - 2*r + 1) - 5*Dd*fd*(4*r - 1)*(C + 4*r - 2) - 5*Ddd*f*(4*r**2 - 2*r + 1)) - 180*Dd**2*f**2*r*(1 - 2*r)) + f*(-5*C*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 - 2*r + 1) + 14*fd**2*r*(2 - 3*r)) + D1*f*(5*Dd*f*(4*r**2 - 2*r + 1) - 14*Dd*fd*(12*r**2 - 7*r + 1) - 7*Ddd*f*(4*r**2 - 2*r + 1)) + 42*Dd**2*f**2*r*(1 - 2*r)) - 126*D1**2*bd1**2*r*(C - 2)*(r - 1) + 45*D1**2*bdd1*f*(-2*C*r + C + 2*r**2) + 9*D1*bd1*(C*D1*(f*(6*r - 3) - 10*fd*r) + 10*C*Dd*f*(1 - 4*r) + 2*D1*r*(-3*f*r + 10*fd*(2*r - 1)) + 20*Dd*f*r*(4*r - 1))))/(315*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct**2*k2**2*st**4*(C - 1)*(30*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*fd**2*r**2 + 3*D1**2*bdd1*f**2*(r - 1)**2 + 3*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 60*D1*Dd*b1*f**2*r**2 - 30*D1*Dd*b1*f**2*r + 15*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 - 12*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 - 6*D1*Ddd*b1*f**2*r + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) + 4*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*b1*f**2*r**2 - 18*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(105*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct**2*k2**2*st**2*(7*b1**2*(C - 1)*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + b1*(-10*C*D1**2*f*fd*r**2 - 2*C*D1**2*f*fd*r + C*D1**2*f*fd - 30*C*D1**2*f*fdd*r**2 - 6*C*D1**2*f*fdd*r + 3*C*D1**2*f*fdd - 30*C*D1**2*fd**2*r**2 - 6*C*D1**2*fd**2*r - 20*C*D1*Dd*f**2*r**2 + 10*C*D1*Dd*f**2*r - 5*C*D1*Dd*f**2 - 240*C*D1*Dd*f*fd*r**2 + 36*C*D1*Dd*f*fd*r + 6*C*D1*Dd*f*fd - 60*C*D1*Ddd*f**2*r**2 + 30*C*D1*Ddd*f**2*r - 15*C*D1*Ddd*f**2 - 180*C*Dd**2*f**2*r**2 + 90*C*Dd**2*f**2*r + 7*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 8*D1**2*f*fd*r**2 + 2*D1**2*f*fd*r - D1**2*f*fd - 24*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r - 3*D1**2*f*fdd - 24*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r - 16*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r - 4*D1*Dd*f**2 - 192*D1*Dd*f*fd*r**2 + 72*D1*Dd*f*fd*r - 6*D1*Dd*f*fd - 48*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r - 12*D1*Ddd*f**2 + 7*D1*bd1*(C - 1)*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) - 144*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r) + f*(14*D1**2*bd1**2*r*(C - 1)*(r - 1) - 3*D1**2*bdd1*f*(C*(5*r**2 - 12*r + 6) + 4*r**2 - 6*r + 3) - D1*bd1*(D1*(f*(C*(5*r**2 - 12*r + 6) + 4*r**2 - 6*r + 3) + 6*fd*r*(C*(10*r - 11) + 8*r - 7)) + 6*Dd*f*(4*r - 1)*(C*(5*r - 6) + 4*r - 3)) + (2*C + 1)*(D1**2*(f*(fd - 5*fdd)*(3*r**2 - 2*r + 1) + 10*fd**2*r*(2 - 3*r)) + D1*f*(Dd*f*(4*r**2 - 2*r + 1) - 10*Dd*fd*(12*r**2 - 7*r + 1) - 5*Ddd*f*(4*r**2 - 2*r + 1)) + 30*Dd**2*f**2*r*(1 - 2*r))))/(105*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct**2*k2**2*(C + 1)*(3*D1*f*r*(-14*D1*bd1**2*(r - 1) + D1*bd1*(3*f*r + fd*(10 - 20*r)) - 5*D1*bdd1*f*r + 10*Dd*bd1*f*(1 - 4*r)) + 7*b1**2*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + b1*(-21*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) + 10*fd**2*r*(r - 1)) + 7*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) - 3*D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(8*r**2 - 6*r + 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) - 90*Dd**2*f**2*r*(2*r - 1)))/(105*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**2*st**2*(-33*D1**2*K*bdd1*f**2*r**2 + 22*D1**2*bd1**2*f*r*(r - 1)*(-7*K + 18*f + 7) + 330*D1**2*bdd1*f**3*r**2 - 440*D1**2*bdd1*f**3*r + 220*D1**2*bdd1*f**3 + 33*D1**2*bdd1*f**2*r**2 + 154*D1**2*bdd1*f*g2*r**2 - 308*D1**2*bdd1*f*g2*r + 154*D1**2*bdd1*f*g2 - 240*D1**2*f**3*fd*r**2 + 120*D1**2*f**3*fd*r - 60*D1**2*f**3*fd + 560*D1**2*f**3*fdd*r**2 - 280*D1**2*f**3*fdd*r + 140*D1**2*f**3*fdd + 1680*D1**2*f**2*fd**2*r**2 - 840*D1**2*f**2*fd**2*r + 22*D1**2*f**2*gd2*r**2 + 66*D1**2*f**2*gdd2*r**2 + 44*D1**2*f*fd*g2*r**2 - 44*D1**2*f*fd*g2*r + 22*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 - 132*D1**2*f*fd*gd2*r + 132*D1**2*f*fdd*g2*r**2 - 132*D1**2*f*fdd*g2*r + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 - 132*D1**2*fd**2*g2*r - 240*D1*Dd*f**4*r**2 + 120*D1*Dd*f**4*r - 60*D1*Dd*f**4 + 4480*D1*Dd*f**3*fd*r**2 - 2240*D1*Dd*f**3*fd*r + 280*D1*Dd*f**3*fd + 88*D1*Dd*f**2*g2*r**2 - 44*D1*Dd*f**2*g2*r + 22*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f*fd*g2*r**2 - 792*D1*Dd*f*fd*g2*r + 132*D1*Dd*f*fd*g2 + 560*D1*Ddd*f**4*r**2 - 280*D1*Ddd*f**4*r + 140*D1*Ddd*f**4 + 264*D1*Ddd*f**2*g2*r**2 - 132*D1*Ddd*f**2*g2*r + 66*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(f**3*(6*r**2 - 8*r + 4) + f**2*r*(-20*fd*(9*r - 7) + r*(K - 1)) - 2*f*(-3*fd*r*(K - 1)*(2*r - 1) + 21*g2*(r - 1)**2 + 14*gd2*r*(r - 1)) - 28*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(10*f**2*(3*r - 2) - 3*f*r*(K - 1) + 14*g2*(r - 1))) + 1680*Dd**2*f**4*r**2 - 840*Dd**2*f**4*r + 792*Dd**2*f**2*g2*r**2 - 396*Dd**2*f**2*g2*r + 11*b1**2*(D1**2*r**2*(36*fd**2 + 3*fd*(-7*K + 4*f + 7) + fdd*(-7*K + 36*f + 7)) + D1*(Dd*(6*f**2*(4*r**2 - 2*r + 1) - 3*f*(7*K*(4*r**2 - 2*r + 1) - r**2*(96*fd + 28) + r*(24*fd + 14) - 7) - 14*fd*r*(K - 1)*(4*r - 1)) + Ddd*f*(-7*K + 18*f + 7)*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)*(-7*K + 18*f + 7)) + 11*b1*(-2*D1**2*K*f*fd*r**2 + 2*D1**2*K*f*fd*r - D1**2*K*f*fd - 6*D1**2*K*f*fdd*r**2 + 6*D1**2*K*f*fdd*r - 3*D1**2*K*f*fdd - 6*D1**2*K*fd**2*r**2 + 6*D1**2*K*fd**2*r + D1**2*bdd1*f*(-7*K + 18*f + 7)*(2*r**2 - 2*r + 1) - 18*D1**2*f**2*fd*r**2 + 4*D1**2*f**2*fd*r - 2*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r**2 - 20*D1**2*f**2*fdd*r + 10*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r**2 - 40*D1**2*f*fd**2*r + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 14*D1**2*f*gdd2*r**2 + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 42*D1**2*fd*g2*r**2 + 28*D1**2*fd*gd2*r**2 + 14*D1**2*fdd*g2*r**2 - 4*D1*Dd*K*f**2*r**2 + 2*D1*Dd*K*f**2*r - D1*Dd*K*f**2 - 48*D1*Dd*K*f*fd*r**2 + 36*D1*Dd*K*f*fd*r - 6*D1*Dd*K*f*fd - 24*D1*Dd*f**3*r**2 + 12*D1*Dd*f**3*r - 6*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r**2 - 260*D1*Dd*f**2*fd*r + 20*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 - 84*D1*Dd*f*g2*r + 42*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 - 28*D1*Dd*f*gd2*r + 112*D1*Dd*fd*g2*r**2 - 28*D1*Dd*fd*g2*r - 12*D1*Ddd*K*f**2*r**2 + 6*D1*Ddd*K*f**2*r - 3*D1*Ddd*K*f**2 + 120*D1*Ddd*f**3*r**2 - 60*D1*Ddd*f**3*r + 30*D1*Ddd*f**3 + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 - 28*D1*Ddd*f*g2*r + 14*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(2*r**2 - 2*r + 1) - 3*f*(7*K*(2*r**2 - 2*r + 1) - r**2*(48*fd + 14) + r*(24*fd + 14) - 7) - 14*fd*r*(K - 1)*(2*r - 1)) + 2*Dd*f*(-7*K + 18*f + 7)*(8*r**2 - 6*r + 1)) - 36*Dd**2*K*f**2*r**2 + 18*Dd**2*K*f**2*r + 360*Dd**2*f**3*r**2 - 180*Dd**2*f**3*r + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r + 168*Dd**2*f*g2*r**2 - 84*Dd**2*f*g2*r))/(2310*d**2) - D1**2*Pk2*Pkdd1*ct**2*(-42*D1**2*K*bd1**2*f*r - 9*D1**2*K*bd1*f**2*r**2 + 60*D1**2*K*bd1*f*fd*r**2 - 30*D1**2*K*bd1*f*fd*r + 15*D1**2*K*bdd1*f**2*r**2 + 120*D1**2*bd1**2*f**2*r**2 - 90*D1**2*bd1**2*f**2*r + 84*D1**2*bd1**2*f*r**2 - 42*D1**2*bd1**2*f*r + 140*D1**2*bd1**2*g2*r**2 - 140*D1**2*bd1**2*g2*r + 42*D1**2*bd1*bd2*f*r**2 - 42*D1**2*bd1*bd2*f*r - 25*D1**2*bd1*f**3*r**2 + 210*D1**2*bd1*f**2*fd*r**2 - 70*D1**2*bd1*f**2*fd*r - 9*D1**2*bd1*f**2*r**2 + 60*D1**2*bd1*f*fd*r**2 - 30*D1**2*bd1*f*fd*r - 28*D1**2*bd1*f*g2*r + 14*D1**2*bd1*f*g2 + 84*D1**2*bd1*f*gd2*r - 9*D1**2*bd2*f**2*r**2 + 60*D1**2*bd2*f*fd*r**2 - 30*D1**2*bd2*f*fd*r + 35*D1**2*bdd1*f**3*r**2 + 15*D1**2*bdd1*f**2*r**2 + 84*D1**2*bdd1*f*g2*r - 42*D1**2*bdd1*f*g2 + 15*D1**2*bdd2*f**2*r**2 + 18*D1**2*f**2*gd2*r**2 - 30*D1**2*f**2*gdd2*r**2 + 36*D1**2*f*fd*g2*r**2 - 36*D1**2*f*fd*g2*r + 18*D1**2*f*fd*g2 - 120*D1**2*f*fd*gd2*r**2 + 60*D1**2*f*fd*gd2*r - 60*D1**2*f*fdd*g2*r**2 + 60*D1**2*f*fdd*g2*r - 30*D1**2*f*fdd*g2 - 60*D1**2*fd**2*g2*r**2 + 60*D1**2*fd**2*g2*r + 120*D1*Dd*K*bd1*f**2*r**2 - 30*D1*Dd*K*bd1*f**2*r + 280*D1*Dd*bd1*f**3*r**2 - 70*D1*Dd*bd1*f**3*r + 120*D1*Dd*bd1*f**2*r**2 - 30*D1*Dd*bd1*f**2*r + 336*D1*Dd*bd1*f*g2*r - 84*D1*Dd*bd1*f*g2 + 120*D1*Dd*bd2*f**2*r**2 - 30*D1*Dd*bd2*f**2*r + 72*D1*Dd*f**2*g2*r**2 - 36*D1*Dd*f**2*g2*r + 18*D1*Dd*f**2*g2 - 240*D1*Dd*f**2*gd2*r**2 + 60*D1*Dd*f**2*gd2*r - 480*D1*Dd*f*fd*g2*r**2 + 360*D1*Dd*f*fd*g2*r - 60*D1*Dd*f*fd*g2 - 120*D1*Ddd*f**2*g2*r**2 + 60*D1*Ddd*f**2*g2*r - 30*D1*Ddd*f**2*g2 - 7*D1*b2*bd1*(r - 1)*(D1*f*(r - 1) - 6*D1*fd*r + 6*Dd*f*(1 - 4*r)) - 360*Dd**2*f**2*g2*r**2 + 180*Dd**2*f**2*g2*r - 7*b1**3*(D1**2*r**2*(fd - 3*fdd) + D1*Dd*(5*K*(4*r**2 - 2*r + 1) + f*(4*r**2 - 2*r + 1) - 24*fd*r**2 + 6*fd*r - 20*r**2 + 10*r - 5) - D1*Ddd*(-5*K + 3*f + 5)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(2*r - 1)*(-5*K + 3*f + 5)) + b1**2*(-14*D1**2*K*fd*r + 7*D1**2*K*fd + 42*D1**2*K*fdd*r - 21*D1**2*K*fdd + 7*D1**2*bdd1*(-5*K + 3*f + 5)*(3*r**2 - 2*r + 1) - 72*D1**2*f*fd*r**2 + 18*D1**2*f*fd*r - 9*D1**2*f*fd + 120*D1**2*f*fdd*r**2 - 30*D1**2*f*fdd*r + 15*D1**2*f*fdd + 120*D1**2*fd**2*r**2 - 30*D1**2*fd**2*r - 14*D1**2*fd*r**2 + 14*D1**2*fd*r - 7*D1**2*fd + 42*D1**2*fdd*r**2 - 42*D1**2*fdd*r + 21*D1**2*fdd + 70*D1**2*gd2*r**2 + 70*D1**2*gdd2*r**2 + 168*D1*Dd*K*fd*r - 42*D1*Dd*K*fd - 144*D1*Dd*f**2*r**2 + 72*D1*Dd*f**2*r - 36*D1*Dd*f**2 + 960*D1*Dd*f*fd*r**2 - 360*D1*Dd*f*fd*r + 30*D1*Dd*f*fd - 56*D1*Dd*f*r**2 + 28*D1*Dd*f*r - 14*D1*Dd*f + 336*D1*Dd*fd*r**2 - 252*D1*Dd*fd*r + 42*D1*Dd*fd + 280*D1*Dd*g2*r**2 - 140*D1*Dd*g2*r + 70*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 - 140*D1*Dd*gd2*r + 240*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r + 60*D1*Ddd*f**2 + 168*D1*Ddd*f*r**2 - 84*D1*Ddd*f*r + 42*D1*Ddd*f + 280*D1*Ddd*g2*r**2 - 140*D1*Ddd*g2*r + 70*D1*Ddd*g2 - 7*D1*bd1*(D1*(5*K*(3*r**2 - 2*r + 1) + f*(3*r**2 - 2*r + 1) - 18*fd*r**2 + 6*fd*r - 15*r**2 + 10*r - 5) - 2*Dd*(-5*K + 3*f + 5)*(12*r**2 - 7*r + 1)) + 720*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r + 504*Dd**2*f*r**2 - 252*Dd**2*f*r + 840*Dd**2*g2*r**2 - 420*Dd**2*g2*r) + b1*(-18*D1**2*K*f*fd*r**2 + 18*D1**2*K*f*fd*r - 9*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 - 30*D1**2*K*f*fdd*r + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 - 30*D1**2*K*fd**2*r - 7*D1**2*b2*fd*r**2 + 21*D1**2*b2*fdd*r**2 + 14*D1**2*bd1**2*r*(3*r - 2)*(-5*K + 3*f + 5) - 7*D1**2*bd2*f*r**2 + 42*D1**2*bd2*fd*r**2 + D1**2*bdd1*(15*f**2*(8*r**2 - 6*r + 3) + 21*f*(-2*K*r + K + 4*r**2 - 2*r + 1) + 70*g2*(2*r**2 - 2*r + 1)) + 21*D1**2*bdd2*f*r**2 - 75*D1**2*f**2*fd*r**2 + 50*D1**2*f**2*fd*r - 25*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 - 70*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 - 140*D1**2*f*fd**2*r - 18*D1**2*f*fd*r**2 + 18*D1**2*f*fd*r - 9*D1**2*f*fd + 30*D1**2*f*fdd*r**2 - 30*D1**2*f*fdd*r + 15*D1**2*f*fdd + 30*D1**2*fd**2*r**2 - 30*D1**2*fd**2*r + 28*D1**2*fd*g2*r - 14*D1**2*fd*g2 - 84*D1**2*fd*gd2*r - 84*D1**2*fdd*g2*r + 42*D1**2*fdd*g2 - 36*D1*Dd*K*f**2*r**2 + 18*D1*Dd*K*f**2*r - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 - 180*D1*Dd*K*f*fd*r + 30*D1*Dd*K*f*fd - 28*D1*Dd*b2*f*r**2 + 14*D1*Dd*b2*f*r - 7*D1*Dd*b2*f + 168*D1*Dd*b2*fd*r**2 - 42*D1*Dd*b2*fd*r + 168*D1*Dd*bd2*f*r**2 - 42*D1*Dd*bd2*f*r - 100*D1*Dd*f**3*r**2 + 50*D1*Dd*f**3*r - 25*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 - 490*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd - 36*D1*Dd*f**2*r**2 + 18*D1*Dd*f**2*r - 9*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 - 180*D1*Dd*f*fd*r + 30*D1*Dd*f*fd - 336*D1*Dd*fd*g2*r + 84*D1*Dd*fd*g2 + 60*D1*Ddd*K*f**2*r**2 - 30*D1*Ddd*K*f**2*r + 15*D1*Ddd*K*f**2 + 84*D1*Ddd*b2*f*r**2 - 42*D1*Ddd*b2*f*r + 21*D1*Ddd*b2*f + 140*D1*Ddd*f**3*r**2 - 70*D1*Ddd*f**3*r + 35*D1*Ddd*f**3 + 60*D1*Ddd*f**2*r**2 - 30*D1*Ddd*f**2*r + 15*D1*Ddd*f**2 + D1*bd1*(D1*(-9*f**2*(8*r**2 - 6*r + 3) + f*(7*K*(2*r - 1) + r**2*(480*fd - 28) + r*(14 - 240*fd) - 7) + 42*fd*r*(K + 4*r - 3) + 70*g2*(2*r**2 - 2*r + 1) + 140*gd2*r*(2*r - 1)) + 2*Dd*(4*r - 1)*(15*f**2*(8*r - 3) - 21*f*(K - 4*r + 1) + 70*g2*(2*r - 1))) + 180*Dd**2*K*f**2*r**2 - 90*Dd**2*K*f**2*r + 252*Dd**2*b2*f*r**2 - 126*Dd**2*b2*f*r + 420*Dd**2*f**3*r**2 - 210*Dd**2*f**3*r + 180*Dd**2*f**2*r**2 - 90*Dd**2*f**2*r) + 3*b2*(7*D1**2*bdd1*f*(r - 1)**2 + D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) + 10*fd**2*r*(r - 1)) + D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(8*r**2 - 6*r + 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) + 30*Dd**2*f**2*r*(2*r - 1)))/(210*d**2) - D1**2*Pk2*Pkdd1*ct*f*k2*st**4*(33*D1**2*b1*f*fd*r**2 + 33*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*fd**2*r**2 + 11*D1**2*bdd1*f**2*(r - 1)**2 + 4*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 20*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 - 30*D1**2*f*fd**2*r + 44*D1*Dd*b1*f**2*r**2 - 22*D1*Dd*b1*f**2*r + 11*D1*Dd*b1*f**2 + 264*D1*Dd*b1*f*fd*r**2 - 66*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 160*D1*Dd*f**2*fd*r**2 - 80*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 44*D1*Ddd*b1*f**2*r**2 - 22*D1*Ddd*b1*f**2*r + 11*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 11*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 6*D1*fd*r + 2*Dd*f*(4*r - 1)) + 132*Dd**2*b1*f**2*r**2 - 66*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(462*d**2*k1) - D1**2*Pk2*Pkdd1*ct*k1**3*st**2*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(630*d**2*k2*k3**2) + D1**2*Pk2*Pkdd1*ct*k1**3*(3*D1*f*r*(-14*D1*bd1**2*(r - 1) + D1*bd1*(3*f*r + fd*(10 - 20*r)) - 5*D1*bdd1*f*r + 10*Dd*bd1*f*(1 - 4*r)) + 7*b1**2*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + b1*(-21*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) + 10*fd**2*r*(r - 1)) + 7*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) - 3*D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(8*r**2 - 6*r + 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) - 90*Dd**2*f**2*r*(2*r - 1)))/(210*d**2*k2*k3**2) - D1**2*Pk2*Pkdd1*ct*k1*k2*st**4*(30*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*fd**2*r**2 + 3*D1**2*bdd1*f**2*(r - 1)**2 + 3*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 60*D1*Dd*b1*f**2*r**2 - 30*D1*Dd*b1*f**2*r + 15*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 - 12*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 - 6*D1*Ddd*b1*f**2*r + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) + 4*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*b1*f**2*r**2 - 18*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(210*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct*k1*k2*st**2*(21*b1**2*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + 3*b1*(24*C*D1**2*f*fd*r**2 + 72*C*D1**2*f*fdd*r**2 + 72*C*D1**2*fd**2*r**2 + 48*C*D1*Dd*f**2*r**2 - 24*C*D1*Dd*f**2*r + 12*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 - 144*C*D1*Dd*f*fd*r + 144*C*D1*Ddd*f**2*r**2 - 72*C*D1*Ddd*f**2*r + 36*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r**2 - 216*C*Dd**2*f**2*r + 7*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 4*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 12*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 12*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 24*D1*Ddd*f**2*r**2 - 12*D1*Ddd*f**2*r + 6*D1*Ddd*f**2 + 7*D1*bd1*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) + 72*Dd**2*f**2*r**2 - 36*Dd**2*f**2*r) + f*(42*D1**2*bd1**2*r*(r - 1) + 9*D1**2*bdd1*f*(12*C*(r - 1)**2 + 2*r**2 - 2*r + 1) + 3*D1*bd1*(D1*(f*(12*C*(r - 1)**2 + 2*r**2 - 2*r + 1) + 6*fd*r*(24*C*(r - 1) + 4*r - 3)) + 6*Dd*f*(4*r - 1)*(12*C*(r - 1) + 2*r - 1)) - (12*C + 1)*(D1**2*(f*(fd - 5*fdd)*(3*r**2 - 2*r + 1) + 10*fd**2*r*(2 - 3*r)) + D1*f*(Dd*f*(4*r**2 - 2*r + 1) - 10*Dd*fd*(12*r**2 - 7*r + 1) - 5*Ddd*f*(4*r**2 - 2*r + 1)) + 30*Dd**2*f**2*r*(1 - 2*r))))/(630*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct*k1*k2*(4*C + 1)*(3*D1*f*r*(-14*D1*bd1**2*(r - 1) + D1*bd1*(3*f*r + fd*(10 - 20*r)) - 5*D1*bdd1*f*r + 10*Dd*bd1*f*(1 - 4*r)) + 7*b1**2*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + b1*(-21*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) + 10*fd**2*r*(r - 1)) + 7*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) - 3*D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(8*r**2 - 6*r + 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) - 90*Dd**2*f**2*r*(2*r - 1)))/(210*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct*k1*st**2*(11*b1**2*(D1**2*r**2*(18*fd**2 + fd*(6*f + 21) + fdd*(18*f + 7)) + D1*(Dd*(3*f**2*(4*r**2 - 2*r + 1) + 3*f*(r**2*(48*fd + 28) - r*(12*fd + 14) + 7) + 14*fd*r*(4*r - 1)) + Ddd*f*(9*f + 7)*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(9*f + 7)*(2*r - 1)) + 11*b1*(D1**2*bdd1*f*(9*f + 7)*(2*r**2 - 2*r + 1) - 6*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 30*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r - 8*D1*Dd*f**3*r**2 + 4*D1*Dd*f**3*r - 2*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r**2 - 100*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 40*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r + 10*D1*Ddd*f**3 + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + D1*bd1*(D1*(f**2*(6*r**2 - 6*r + 3) + 3*f*(r**2*(24*fd + 14) - r*(12*fd + 14) + 7) + 14*fd*r*(2*r - 1)) + 2*Dd*f*(9*f + 7)*(8*r**2 - 6*r + 1)) + 120*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r) + f*(22*D1**2*bd1**2*r*(9*f + 7)*(r - 1) - 11*D1*bd1*(D1*(f**2*(2*r**2 - 2*r + 1) - f*r*(60*fd*r - 40*fd + r) + 6*fd*r*(1 - 2*r)) - 2*Dd*f*(4*r - 1)*(5*f*(2*r - 1) + 3*r)) + f*(11*D1**2*bdd1*(5*f*(2*r**2 - 2*r + 1) + 3*r**2) - 5*D1**2*(f*(3*fd - 7*fdd)*(4*r**2 - 2*r + 1) + 42*fd**2*r*(1 - 2*r)) - 5*D1*f*(3*Dd*f*(4*r**2 - 2*r + 1) - 14*Dd*fd*(1 - 4*r)**2 - 7*Ddd*f*(4*r**2 - 2*r + 1)) - 210*Dd**2*f**2*r*(1 - 2*r))))/(2310*d**2*k2) + D1**2*Pk2*Pkdd1*ct*k1*(D1*f*r*(-18*D1*bd1**2*(5*f*(2*r - 1) + 7*r) - 35*D1*bdd1*f**2*r + 5*bd1*f*(5*D1*f*r + D1*fd*(14 - 42*r) + 14*Dd*f*(1 - 4*r))) + 21*b1**3*(D1**2*r**2*(fd - 3*fdd) + D1*Dd*(f*(4*r**2 - 2*r + 1) - r**2*(24*fd + 20) + r*(6*fd + 10) - 5) - D1*Ddd*(3*f + 5)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(3*f + 5)*(2*r - 1)) + 3*b1**2*(-7*D1**2*bdd1*(3*f + 5)*(3*r**2 - 2*r + 1) + 36*D1**2*f*fd*r**2 - 18*D1**2*f*fd*r + 9*D1**2*f*fd - 60*D1**2*f*fdd*r**2 + 30*D1**2*f*fdd*r - 15*D1**2*f*fdd - 60*D1**2*fd**2*r**2 + 30*D1**2*fd**2*r + 7*D1**2*fd*r**2 - 14*D1**2*fd*r + 7*D1**2*fd - 21*D1**2*fdd*r**2 + 42*D1**2*fdd*r - 21*D1**2*fdd + 72*D1*Dd*f**2*r**2 - 36*D1*Dd*f**2*r + 18*D1*Dd*f**2 - 480*D1*Dd*f*fd*r**2 + 240*D1*Dd*f*fd*r - 30*D1*Dd*f*fd + 28*D1*Dd*f*r**2 - 14*D1*Dd*f*r + 7*D1*Dd*f - 168*D1*Dd*fd*r**2 + 210*D1*Dd*fd*r - 42*D1*Dd*fd - 120*D1*Ddd*f**2*r**2 + 60*D1*Ddd*f**2*r - 30*D1*Ddd*f**2 - 84*D1*Ddd*f*r**2 + 42*D1*Ddd*f*r - 21*D1*Ddd*f + 7*D1*bd1*(D1*(f*(3*r**2 - 2*r + 1) - r**2*(18*fd + 15) + r*(6*fd + 10) - 5) - 2*Dd*(3*f + 5)*(12*r**2 - 7*r + 1)) - 360*Dd**2*f**2*r**2 + 180*Dd**2*f**2*r - 252*Dd**2*f*r**2 + 126*Dd**2*f*r) - b1*(42*D1**2*bd1**2*r*(3*f + 5)*(3*r - 2) - 3*D1*bd1*(D1*(9*f**2*(4*r**2 - 2*r + 1) + 2*f*r*(-120*fd*r + 60*fd + 7*r) - 84*fd*r*(r - 1)) - 6*Dd*f*(4*r - 1)*(5*f*(4*r - 1) + 14*r)) + f*(9*D1**2*bdd1*(5*f*(4*r**2 - 2*r + 1) + 14*r**2) - 5*D1**2*(f*(5*fd - 7*fdd)*(3*r**2 - 2*r + 1) + 14*fd**2*r*(2 - 3*r)) - 5*D1*f*(5*Dd*f*(4*r**2 - 2*r + 1) - 14*Dd*fd*(12*r**2 - 7*r + 1) - 7*Ddd*f*(4*r**2 - 2*r + 1)) - 210*Dd**2*f**2*r*(1 - 2*r))))/(630*d**2*k2) - D1**2*Pk2*Pkdd1*ct*k2**3*st**4*(30*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*fd**2*r**2 + 3*D1**2*bdd1*f**2*(r - 1)**2 + 3*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 60*D1*Dd*b1*f**2*r**2 - 30*D1*Dd*b1*f**2*r + 15*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 - 12*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 - 6*D1*Ddd*b1*f**2*r + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) + 4*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*b1*f**2*r**2 - 18*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(210*d**2*k1*k3**2) - D1**2*Pk2*Pkdd1*ct*k2**3*st**2*(D1*f*r*(14*D1*bd1**2*(r - 1) + D1*bd1*(f*r + 6*fd*(2*r - 1)) + 3*D1*bdd1*f*r + 6*Dd*bd1*f*(4*r - 1)) + 7*b1**2*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + b1*(7*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 7*D1*bd1*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r))/(210*d**2*k1*k3**2) - D1**2*Pk2*Pkdd1*ct*k2*st**2*(D1*f*r*(2*D1*bd1**2*(18*f + 7)*(r - 1) + D1*bdd1*f*r*(10*f + 3) + bd1*(D1*f*r*(1 - 2*f) + 2*D1*fd*(10*f*(3*r - 1) + 6*r - 3) + 2*Dd*f*(10*f + 3)*(4*r - 1))) + b1**2*(D1**2*r**2*(36*fd**2 + fd*(12*f + 21) + fdd*(36*f + 7)) + D1*(Dd*(6*f**2*(4*r**2 - 2*r + 1) + 3*f*(r**2*(96*fd + 28) - r*(24*fd + 14) + 7) + 14*fd*r*(4*r - 1)) + Ddd*f*(18*f + 7)*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(18*f + 7)*(2*r - 1)) + b1*(D1**2*bdd1*f*(18*f + 7)*(2*r**2 - 2*r + 1) - 6*D1**2*f**2*fd*r**2 + 4*D1**2*f**2*fd*r - 2*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r**2 - 20*D1**2*f**2*fdd*r + 10*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 - 40*D1**2*f*fd**2*r + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r - 8*D1*Dd*f**3*r**2 + 4*D1*Dd*f**3*r - 2*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r**2 - 140*D1*Dd*f**2*fd*r + 20*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 40*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r + 10*D1*Ddd*f**3 + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + D1*bd1*(D1*(6*f**2*(2*r**2 - 2*r + 1) + 3*f*(r**2*(48*fd + 14) - r*(24*fd + 14) + 7) + 14*fd*r*(2*r - 1)) + 2*Dd*f*(18*f + 7)*(8*r**2 - 6*r + 1)) + 120*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r))/(210*d**2*k1) - D1**2*Pk2*Pkdd1*ct*k2*(6*D1**2*bd1**2*f*r**2*(5*f + 7) + 2*D1*b1*r*(7*D1*bd1**2*(3*f + 5)*(3*r - 2) + 3*D1*bdd1*f*r*(5*f + 7) + bd1*(-D1*f*r*(9*f + 7) + 6*D1*fd*(10*f*r - 5*f + 7*r - 7) + 6*Dd*f*(5*f + 7)*(4*r - 1))) - 7*b1**3*(D1**2*r**2*(fd - 3*fdd) + D1*Dd*(f*(4*r**2 - 2*r + 1) - r**2*(24*fd + 20) + r*(6*fd + 10) - 5) - D1*Ddd*(3*f + 5)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(3*f + 5)*(2*r - 1)) + b1**2*(7*D1**2*bdd1*(3*f + 5)*(3*r**2 - 2*r + 1) - 18*D1**2*f*fd*r**2 + 18*D1**2*f*fd*r - 9*D1**2*f*fd + 30*D1**2*f*fdd*r**2 - 30*D1**2*f*fdd*r + 15*D1**2*f*fdd + 30*D1**2*fd**2*r**2 - 30*D1**2*fd**2*r - 7*D1**2*fd*r**2 + 14*D1**2*fd*r - 7*D1**2*fd + 21*D1**2*fdd*r**2 - 42*D1**2*fdd*r + 21*D1**2*fdd - 36*D1*Dd*f**2*r**2 + 18*D1*Dd*f**2*r - 9*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 - 180*D1*Dd*f*fd*r + 30*D1*Dd*f*fd - 28*D1*Dd*f*r**2 + 14*D1*Dd*f*r - 7*D1*Dd*f + 168*D1*Dd*fd*r**2 - 210*D1*Dd*fd*r + 42*D1*Dd*fd + 60*D1*Ddd*f**2*r**2 - 30*D1*Ddd*f**2*r + 15*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 - 42*D1*Ddd*f*r + 21*D1*Ddd*f - 7*D1*bd1*(D1*(f*(3*r**2 - 2*r + 1) - r**2*(18*fd + 15) + r*(6*fd + 10) - 5) - 2*Dd*(3*f + 5)*(12*r**2 - 7*r + 1)) + 180*Dd**2*f**2*r**2 - 90*Dd**2*f**2*r + 252*Dd**2*f*r**2 - 126*Dd**2*f*r))/(210*d**2*k1) - D1**2*Pk2*Pkdd1*st**4*(33*b1**2*(2*D1**2*r**2*(f*(5*fd + fdd) + fd**2) + D1*f*(5*Dd*f*(4*r**2 - 2*r + 1) + 4*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f**2*r*(2*r - 1)) + 11*b1*f*(3*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 9*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 9*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r + D1**2*f*fdd + 18*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r + 12*D1*Dd*f**2*r**2 - 6*D1*Dd*f**2*r + 3*D1*Dd*f**2 + 72*D1*Dd*f*fd*r**2 - 26*D1*Dd*f*fd*r + 2*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 3*D1*bd1*(5*D1*f*(2*r**2 - 2*r + 1) + 4*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r) + f**2*(66*D1**2*bd1**2*r*(r - 1) + 11*D1**2*bdd1*f*(3*r**2 - 4*r + 2) + 2*D1**2*(f*(fd + 5*fdd)*(4*r**2 - 2*r + 1) + 30*fd**2*r*(2*r - 1)) + 11*D1*bd1*(D1*f*(3*r**2 - 4*r + 2) + 2*D1*fd*r*(9*r - 7) + 2*Dd*f*(12*r**2 - 11*r + 2)) + 2*D1*f*(Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(1 - 4*r)**2 + 5*Ddd*f*(4*r**2 - 2*r + 1)) + 60*Dd**2*f**2*r*(2*r - 1)))/(2310*d**2) - D1**2*Pk2*Pkdd1*st**2*(14*D1**2*K*bd1**2*f*r**2 - 14*D1**2*K*bd1**2*f*r + D1**2*K*bd1*f**2*r**2 + 12*D1**2*K*bd1*f*fd*r**2 - 6*D1**2*K*bd1*f*fd*r + 3*D1**2*K*bdd1*f**2*r**2 + 24*D1**2*bd1**2*f**2*r**2 - 18*D1**2*bd1**2*f**2*r + 14*D1**2*bd1**2*f*r**2 - 14*D1**2*bd1**2*f*r + 14*D1**2*bd1*bd2*f*r**2 - 14*D1**2*bd1*bd2*f*r - D1**2*bd1*f**3*r**2 + 30*D1**2*bd1*f**2*fd*r**2 - 10*D1**2*bd1*f**2*fd*r + D1**2*bd1*f**2*r**2 + 12*D1**2*bd1*f*fd*r**2 - 6*D1**2*bd1*f*fd*r - 42*D1**2*bd1*f*g2*r**2 + 84*D1**2*bd1*f*g2*r - 42*D1**2*bd1*f*g2 - 28*D1**2*bd1*f*gd2*r**2 + 28*D1**2*bd1*f*gd2*r - 28*D1**2*bd1*fd*g2*r**2 + 28*D1**2*bd1*fd*g2*r + D1**2*bd2*f**2*r**2 + 12*D1**2*bd2*f*fd*r**2 - 6*D1**2*bd2*f*fd*r + 5*D1**2*bdd1*f**3*r**2 + 3*D1**2*bdd1*f**2*r**2 - 14*D1**2*bdd1*f*g2*r**2 + 28*D1**2*bdd1*f*g2*r - 14*D1**2*bdd1*f*g2 + 3*D1**2*bdd2*f**2*r**2 - 2*D1**2*f**2*gd2*r**2 - 6*D1**2*f**2*gdd2*r**2 - 4*D1**2*f*fd*g2*r**2 + 4*D1**2*f*fd*g2*r - 2*D1**2*f*fd*g2 - 24*D1**2*f*fd*gd2*r**2 + 12*D1**2*f*fd*gd2*r - 12*D1**2*f*fdd*g2*r**2 + 12*D1**2*f*fdd*g2*r - 6*D1**2*f*fdd*g2 - 12*D1**2*fd**2*g2*r**2 + 12*D1**2*fd**2*g2*r + 24*D1*Dd*K*bd1*f**2*r**2 - 6*D1*Dd*K*bd1*f**2*r + 40*D1*Dd*bd1*f**3*r**2 - 10*D1*Dd*bd1*f**3*r + 24*D1*Dd*bd1*f**2*r**2 - 6*D1*Dd*bd1*f**2*r - 112*D1*Dd*bd1*f*g2*r**2 + 140*D1*Dd*bd1*f*g2*r - 28*D1*Dd*bd1*f*g2 + 24*D1*Dd*bd2*f**2*r**2 - 6*D1*Dd*bd2*f**2*r - 8*D1*Dd*f**2*g2*r**2 + 4*D1*Dd*f**2*g2*r - 2*D1*Dd*f**2*g2 - 48*D1*Dd*f**2*gd2*r**2 + 12*D1*Dd*f**2*gd2*r - 96*D1*Dd*f*fd*g2*r**2 + 72*D1*Dd*f*fd*g2*r - 12*D1*Dd*f*fd*g2 - 24*D1*Ddd*f**2*g2*r**2 + 12*D1*Ddd*f**2*g2*r - 6*D1*Ddd*f**2*g2 - 72*Dd**2*f**2*g2*r**2 + 36*Dd**2*f**2*g2*r + 7*b1**3*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + b1**2*(21*D1**2*K*fd*r**2 + 7*D1**2*K*fdd*r**2 + 7*D1**2*bdd1*f*(3*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 24*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 24*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 21*D1**2*fd*r**2 + 7*D1**2*fdd*r**2 + 84*D1*Dd*K*f*r**2 - 42*D1*Dd*K*f*r + 21*D1*Dd*K*f + 56*D1*Dd*K*fd*r**2 - 14*D1*Dd*K*fd*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 + 192*D1*Dd*f*fd*r**2 - 72*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 84*D1*Dd*f*r**2 - 42*D1*Dd*f*r + 21*D1*Dd*f + 56*D1*Dd*fd*r**2 - 14*D1*Dd*fd*r + 28*D1*Ddd*K*f*r**2 - 14*D1*Ddd*K*f*r + 7*D1*Ddd*K*f + 48*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r + 12*D1*Ddd*f**2 + 28*D1*Ddd*f*r**2 - 14*D1*Ddd*f*r + 7*D1*Ddd*f + 7*D1*bd1*(D1*f*(9*r**2 - 6*r + 3) + 2*D1*fd*r*(3*r - 1) + 2*Dd*f*(12*r**2 - 7*r + 1)) + 84*Dd**2*K*f*r**2 - 42*Dd**2*K*f*r + 144*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r + 84*Dd**2*f*r**2 - 42*Dd**2*f*r) + b1*(2*D1**2*K*f*fd*r**2 - 2*D1**2*K*f*fd*r + D1**2*K*f*fd + 6*D1**2*K*f*fdd*r**2 - 6*D1**2*K*f*fdd*r + 3*D1**2*K*f*fdd + 6*D1**2*K*fd**2*r**2 - 6*D1**2*K*fd**2*r + 21*D1**2*b2*fd*r**2 + 7*D1**2*b2*fdd*r**2 + 14*D1**2*bd1**2*f*r*(3*r - 2) + 21*D1**2*bd2*f*r**2 + 14*D1**2*bd2*fd*r**2 + D1**2*bdd1*f*(3*f*(8*r**2 - 6*r + 3) + (7*K + 7)*(2*r**2 - 2*r + 1)) + 7*D1**2*bdd2*f*r**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd - 42*D1**2*f*gd2*r**2 - 14*D1**2*f*gdd2*r**2 + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r - 42*D1**2*fd*g2*r**2 - 28*D1**2*fd*gd2*r**2 - 14*D1**2*fdd*g2*r**2 + 4*D1*Dd*K*f**2*r**2 - 2*D1*Dd*K*f**2*r + D1*Dd*K*f**2 + 48*D1*Dd*K*f*fd*r**2 - 36*D1*Dd*K*f*fd*r + 6*D1*Dd*K*f*fd + 84*D1*Dd*b2*f*r**2 - 42*D1*Dd*b2*f*r + 21*D1*Dd*b2*f + 56*D1*Dd*b2*fd*r**2 - 14*D1*Dd*b2*fd*r + 56*D1*Dd*bd2*f*r**2 - 14*D1*Dd*bd2*f*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd - 168*D1*Dd*f*g2*r**2 + 84*D1*Dd*f*g2*r - 42*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*r**2 + 28*D1*Dd*f*gd2*r - 112*D1*Dd*fd*g2*r**2 + 28*D1*Dd*fd*g2*r + 12*D1*Ddd*K*f**2*r**2 - 6*D1*Ddd*K*f**2*r + 3*D1*Ddd*K*f**2 + 28*D1*Ddd*b2*f*r**2 - 14*D1*Ddd*b2*f*r + 7*D1*Ddd*b2*f + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 - 56*D1*Ddd*f*g2*r**2 + 28*D1*Ddd*f*g2*r - 14*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(8*r**2 - 6*r + 3) + 3*f*(7*K*(2*r**2 - 2*r + 1) + r**2*(32*fd + 14) - r*(16*fd + 14) + 7) + 14*fd*r*(K + 1)*(2*r - 1)) + 2*Dd*f*(4*r - 1)*(3*f*(8*r - 3) + (7*K + 7)*(2*r - 1))) + 36*Dd**2*K*f**2*r**2 - 18*Dd**2*K*f**2*r + 84*Dd**2*b2*f*r**2 - 42*Dd**2*b2*f*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r - 168*Dd**2*f*g2*r**2 + 84*Dd**2*f*g2*r) + b2*(7*D1**2*bdd1*f*(r - 1)**2 + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 7*D1*bd1*(r - 1)*(3*D1*f*(r - 1) + 2*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r))/(210*d**2) + D1**2*Pk2*Pkdd1*(-D1*r*(2*D1*bd1**2*(3*f*r*(7*K + 5*f + 7) - 70*g2*(r - 1)) - 42*D1*bdd1*f*g2*r + 7*b2*(10*D1*bd1**2*(r - 1) + 3*D1*bdd1*f*r + bd1*(-D1*f*r + 6*D1*fd*(r - 1) + 6*Dd*f*(4*r - 1))) - 14*bd1*(-D1*f*r*(3*bd2 + g2 - 6*gd2) + 6*D1*fd*g2*(r - 1) + 6*Dd*f*g2*(4*r - 1))) + 7*b1**3*(D1**2*r**2*(fd - 3*fdd) + D1*Dd*(-5*K*(4*r**2 - 2*r + 1) + f*(4*r**2 - 2*r + 1) - 24*fd*r**2 + 6*fd*r - 20*r**2 + 10*r - 5) - D1*Ddd*(5*K + 3*f + 5)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(2*r - 1)*(5*K + 3*f + 5)) + b1**2*(7*D1**2*K*fd*r**2 - 14*D1**2*K*fd*r + 7*D1**2*K*fd - 21*D1**2*K*fdd*r**2 + 42*D1**2*K*fdd*r - 21*D1**2*K*fdd - 35*D1**2*bd2*r**2 - 7*D1**2*bdd1*(5*K + 3*f + 5)*(3*r**2 - 2*r + 1) - 35*D1**2*bdd2*r**2 + 18*D1**2*f*fd*r**2 - 18*D1**2*f*fd*r + 9*D1**2*f*fd - 30*D1**2*f*fdd*r**2 + 30*D1**2*f*fdd*r - 15*D1**2*f*fdd - 30*D1**2*fd**2*r**2 + 30*D1**2*fd**2*r + 7*D1**2*fd*r**2 - 14*D1**2*fd*r + 7*D1**2*fd - 21*D1**2*fdd*r**2 + 42*D1**2*fdd*r - 21*D1**2*fdd + 70*D1**2*gd2*r**2 + 70*D1**2*gdd2*r**2 + 28*D1*Dd*K*f*r**2 - 14*D1*Dd*K*f*r + 7*D1*Dd*K*f - 168*D1*Dd*K*fd*r**2 + 210*D1*Dd*K*fd*r - 42*D1*Dd*K*fd - 140*D1*Dd*b2*r**2 + 70*D1*Dd*b2*r - 35*D1*Dd*b2 - 280*D1*Dd*bd2*r**2 + 70*D1*Dd*bd2*r + 36*D1*Dd*f**2*r**2 - 18*D1*Dd*f**2*r + 9*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 + 180*D1*Dd*f*fd*r - 30*D1*Dd*f*fd + 28*D1*Dd*f*r**2 - 14*D1*Dd*f*r + 7*D1*Dd*f - 168*D1*Dd*fd*r**2 + 210*D1*Dd*fd*r - 42*D1*Dd*fd + 280*D1*Dd*g2*r**2 - 140*D1*Dd*g2*r + 70*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 - 140*D1*Dd*gd2*r - 84*D1*Ddd*K*f*r**2 + 42*D1*Ddd*K*f*r - 21*D1*Ddd*K*f - 140*D1*Ddd*b2*r**2 + 70*D1*Ddd*b2*r - 35*D1*Ddd*b2 - 60*D1*Ddd*f**2*r**2 + 30*D1*Ddd*f**2*r - 15*D1*Ddd*f**2 - 84*D1*Ddd*f*r**2 + 42*D1*Ddd*f*r - 21*D1*Ddd*f + 280*D1*Ddd*g2*r**2 - 140*D1*Ddd*g2*r + 70*D1*Ddd*g2 + 7*D1*bd1*(D1*(-5*K*(3*r**2 - 2*r + 1) + f*(3*r**2 - 2*r + 1) - 18*fd*r**2 + 6*fd*r - 15*r**2 + 10*r - 5) - 2*Dd*(5*K + 3*f + 5)*(12*r**2 - 7*r + 1)) - 252*Dd**2*K*f*r**2 + 126*Dd**2*K*f*r - 420*Dd**2*b2*r**2 + 210*Dd**2*b2*r - 180*Dd**2*f**2*r**2 + 90*Dd**2*f**2*r - 252*Dd**2*f*r**2 + 126*Dd**2*f*r + 840*Dd**2*g2*r**2 - 420*Dd**2*g2*r) + b1*(-42*D1**2*K*bdd1*f*r**2 - 14*D1**2*bd1**2*r*(3*r - 2)*(5*K + 3*f + 5) + 7*D1**2*bd2*f*r**2 - 42*D1**2*bd2*fd*r**2 + 42*D1**2*bd2*fd*r - 30*D1**2*bdd1*f**2*r**2 - 42*D1**2*bdd1*f*r**2 + 140*D1**2*bdd1*g2*r**2 - 140*D1**2*bdd1*g2*r + 70*D1**2*bdd1*g2 - 21*D1**2*bdd2*f*r**2 - 14*D1**2*f*gd2*r**2 + 42*D1**2*f*gdd2*r**2 - 14*D1**2*fd*g2*r**2 + 28*D1**2*fd*g2*r - 14*D1**2*fd*g2 + 84*D1**2*fd*gd2*r**2 - 84*D1**2*fd*gd2*r + 42*D1**2*fdd*g2*r**2 - 84*D1**2*fdd*g2*r + 42*D1**2*fdd*g2 - 168*D1*Dd*bd2*f*r**2 + 42*D1*Dd*bd2*f*r - 56*D1*Dd*f*g2*r**2 + 28*D1*Dd*f*g2*r - 14*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 - 84*D1*Dd*f*gd2*r + 336*D1*Dd*fd*g2*r**2 - 420*D1*Dd*fd*g2*r + 84*D1*Dd*fd*g2 + 168*D1*Ddd*f*g2*r**2 - 84*D1*Ddd*f*g2*r + 42*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(35*g2*(2*r**2 - 2*r + 1) + r*(7*K*f*r + bd2*(35 - 70*r) + 9*f**2*r + 7*f*r - 6*fd*(5*f*(2*r - 1) + (7*K + 7)*(r - 1)) + 140*gd2*r - 70*gd2)) + 2*Dd*(4*r - 1)*(-3*f*r*(7*K + 5*f + 7) + 35*g2*(2*r - 1))) + 504*Dd**2*f*g2*r**2 - 252*Dd**2*f*g2*r - 7*b2*(5*D1**2*bdd1*(2*r**2 - 2*r + 1) - D1**2*fd*r**2 + 2*D1**2*fd*r - D1**2*fd + 3*D1**2*fdd*r**2 - 6*D1**2*fdd*r + 3*D1**2*fdd - 4*D1*Dd*f*r**2 + 2*D1*Dd*f*r - D1*Dd*f + 24*D1*Dd*fd*r**2 - 30*D1*Dd*fd*r + 6*D1*Dd*fd + 12*D1*Ddd*f*r**2 - 6*D1*Ddd*f*r + 3*D1*Ddd*f + 5*D1*bd1*(D1*(2*r**2 - 2*r + 1) + 2*Dd*(8*r**2 - 6*r + 1)) + 36*Dd**2*f*r**2 - 18*Dd**2*f*r)))/(210*d**2) - D1**2*Pkd1*Pkd2*ct**7*k2**2*(2*C - 2)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct**6*f*k2*(11*D1*bd1*f*(D1*(5*f*s*(r - 1) - 7*fd*(6*r*s - r - 3*s + 1)) - 7*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 11*b1*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(5*f*fd - 7*f*fdd - 14*fd**2) + 7*Ddd*f**2*(4*r*s - r - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 7*f*(D1*Dd*f*(7*f*(-4*r*s + r + s) + 18*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(7*f*fd*(-4*r*s + r + s) + f*(11*bdd1*s*(r - 1) + 9*fdd*r*(4*s - 1) - 9*fdd*s) + 9*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 9*Ddd*f**2*(r*(4*s - 1) - s)) + 9*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1) - D1**2*Pkd1*Pkd2*ct**6*k1*k2*(4*C - 5)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct**6*k2**3*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k1*k3**2) - D1**2*Pkd1*Pkd2*ct**5*k1**2*(2*C - 4)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) - D1**2*Pkd1*Pkd2*ct**5*k2**2*st**2*(4*C - 4)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(23*f*(4*r*s - r - s) - 25*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(r*(3*s - 1) - s) + 5*f*(-9*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(-4*r*s + r + s)) - 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) - 2*D1**2*Pkd1*Pkd2*ct**5*k2**2*(-63*D1**2*bd1**2*f*(C - 1)*(r*(2*s - 1) - s + 1) + 3*D1*bd1*(-7*b1*(C - 1)*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(3*f*(-C*r + C*s - 2*r*s + r + s) + 5*fd*(r*(C + 8*s - 3) - s*(C + 3) + 2)) + 10*Dd*f*(r*(2*C + 8*s - 3) - s*(2*C + 3) + 1))) - 21*b1**2*(C - 1)*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 9*b1*(2*D1*Dd*f*(3*f*(-4*r*s + r + s) - 5*fd*(-2*C*s + 2*r*(C - 8*s + 2) + 4*s - 1)) - D1*(7*D1*bdd1*f*(C - 1)*(r*(2*s - 1) - s) - D1*(-C*s + r*(C - 4*s + 1) + s)*(3*f*fd - 5*f*fdd - 5*fd**2) + 10*Ddd*f**2*(-4*r*s + r + s)) + 10*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 5*f*(D1*Dd*f*(C + 1)*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(-5*C - 5)*(r*(3*s - 1) - s) + f*(-9*bdd1*(-C*r + C*s - 2*r*s + r + s) + fdd*(7*C + 7)*(r*(3*s - 1) - s)) + fd**2*(7*C + 7)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(7*C + 7)*(r*(4*s - 1) - s)) + Dd**2*f**2*(7*C + 7)*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct**5*(495*D1**2*K*bdd1*f**2*r*s - 99*D1**2*bd1**2*f*s*(2*r - 1)*(-7*K + 5*f + 7) - 1155*D1**2*bdd1*f**3*r*s + 770*D1**2*bdd1*f**3*s - 495*D1**2*bdd1*f**2*r*s - 1386*D1**2*bdd1*f*g2*r*s + 1386*D1**2*bdd1*f*g2*s + 1960*D1**2*f**3*fd*r*s - 490*D1**2*f**3*fd*r - 490*D1**2*f**3*fd*s - 2520*D1**2*f**3*fdd*r*s + 630*D1**2*f**3*fdd*r + 630*D1**2*f**3*fdd*s - 7560*D1**2*f**2*fd**2*r*s + 1890*D1**2*f**2*fd**2*r + 1890*D1**2*f**2*fd**2*s - 630*D1**2*f**2*fd**2 + 594*D1**2*f**2*gd2*r*s - 990*D1**2*f**2*gdd2*r*s + 1188*D1**2*f*fd*g2*r*s - 594*D1**2*f*fd*g2*r - 594*D1**2*f*fd*g2*s - 3960*D1**2*f*fd*gd2*r*s + 990*D1**2*f*fd*gd2*r + 990*D1**2*f*fd*gd2*s - 1980*D1**2*f*fdd*g2*r*s + 990*D1**2*f*fdd*g2*r + 990*D1**2*f*fdd*g2*s - 1980*D1**2*fd**2*g2*r*s + 990*D1**2*fd**2*g2*r + 990*D1**2*fd**2*g2*s - 990*D1**2*fd**2*g2 + 1960*D1*Dd*f**4*r*s - 490*D1*Dd*f**4*r - 490*D1*Dd*f**4*s - 20160*D1*Dd*f**3*fd*r*s + 5040*D1*Dd*f**3*fd*r + 5040*D1*Dd*f**3*fd*s - 1260*D1*Dd*f**3*fd + 2376*D1*Dd*f**2*g2*r*s - 594*D1*Dd*f**2*g2*r - 594*D1*Dd*f**2*g2*s - 7920*D1*Dd*f**2*gd2*r*s + 990*D1*Dd*f**2*gd2*r + 990*D1*Dd*f**2*gd2*s - 15840*D1*Dd*f*fd*g2*r*s + 5940*D1*Dd*f*fd*g2*r + 5940*D1*Dd*f*fd*g2*s - 1980*D1*Dd*f*fd*g2 - 2520*D1*Ddd*f**4*r*s + 630*D1*Ddd*f**4*r + 630*D1*Ddd*f**4*s - 3960*D1*Ddd*f**2*g2*r*s + 990*D1*Ddd*f**2*g2*r + 990*D1*Ddd*f**2*g2*s + 11*D1*bd1*(D1*(25*f**3*s*(3*r - 2) + f**2*(-35*fd*(18*r*s - 3*r - 7*s + 2) + r*s*(27 - 27*K)) + 45*f*fd*(K - 1)*(r*(4*s - 1) - s) + 42*f*s*(g2*(r - 1) - 6*gd2*r + 3*gd2) - 126*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-35*f**2*(24*r*s - 3*r - 11*s + 2) + 45*f*(K - 1)*(8*r*s - r - s) - 126*g2*(8*r*s - r - 5*s + 1))) - 7560*Dd**2*f**4*r*s + 1890*Dd**2*f**4*r + 1890*Dd**2*f**4*s - 630*Dd**2*f**4 - 11880*Dd**2*f**2*g2*r*s + 2970*Dd**2*f**2*g2*r + 2970*Dd**2*f**2*g2*s - 990*Dd**2*f**2*g2 - 33*b1**2*(D1*Dd*(-f*(r*(4*s - 1) - s)*(-7*K + 9*f + 7) + 3*fd*(5*f*(16*r*s - 6*r - 2*s + 1) + (7 - 7*K)*(8*r*s - 5*r - s + 1))) + D1*(D1*r*(f*fd*(9 - 18*s) + 15*f*fdd*(2*s - 1) + 15*fd**2*(2*s - 1) + 7*fd*(K - 1)*(s - 1) + 21*fdd*(-K*s + K + s - 1)) + 3*Ddd*f*(r*(4*s - 1) - s)*(-7*K + 5*f + 7)) + 3*Dd**2*f*(-7*K + 5*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*(D1*Dd*(75*f**3*(r*(4*s - 1) - s) + f**2*(-35*fd*(3*r*(24*s - 7) - 13*s + 4) + (27 - 27*K)*(r*(4*s - 1) - s)) + 6*f*(15*fd*(K - 1)*(r*(8*s - 3) - 3*s + 1) + 7*g2*r*(4*s - 1) - 7*g2*s + 21*gd2*(-8*r*s + r + s)) - 126*fd*g2*(r*(8*s - 5) - s + 1)) + 3*D1*bd1*(D1*(-15*f*fd*(r*(8*s - 2) - 2*s + 1) + f*s*(2*r - 1)*(-7*K + 9*f + 7) + 21*fd*(K - 1)*(r*(4*s - 2) - s + 1)) - 3*Dd*f*(-7*K + 5*f + 7)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(-5*f**2*(9*bdd1*s*(2*r - 1) + 7*fdd*r*(9*s - 3) - 7*fdd*s) + 3*f*(15*fdd*(K - 1)*(r*(2*s - 1) - s) + s*(21*bdd1*(K - 1)*(2*r - 1) + 7*r*(2*gd2 - 6*gdd2))) - 5*fd**2*(7*f*(6*r*(3*s - 1) - 2*s + 1) + (9 - 9*K)*(r*(2*s - 1) - s + 1)) + fd*(25*f**2*(r*(9*s - 3) - s) - 27*f*(K - 1)*(r*(2*s - 1) - s) + 42*r*(g2*(s - 1) - 6*gd2*s + 3*gd2)) - 126*fdd*g2*r*(s - 1)) - 3*Ddd*f*(r*(4*s - 1) - s)*(35*f**2 - 15*f*(K - 1) + 42*g2)) - 3*Dd**2*f*(35*f**2 - 15*f*(K - 1) + 42*g2)*(3*r*(4*s - 1) - 3*s + 1)))/(3465*d**2) + D1**2*Pkd1*Pkd2*ct**4*f*k2*st**2*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(6*r*s - r - 3*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(4*f*fd - 5*f*fdd - 10*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(2*D1*Dd*f*(10*f*(-4*r*s + r + s) + 21*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(20*f*fd*(-4*r*s + r + s) + 3*f*(11*bdd1*s*(r - 1) + 7*fdd*r*(4*s - 1) - 7*fdd*s) + 21*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 21*Ddd*f**2*(r*(4*s - 1) - s)) + 21*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1) + D1**2*Pkd1*Pkd2*ct**4*k1**3*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k2*k3**2) - 2*D1**2*Pkd1*Pkd2*ct**4*k1*k2*st**2*(9*D1*bd1*f*(D1*(f*s*(10*C - 13)*(r - 1) - fd*(12*C - 17)*(4*r*s - r - 2*s + 1)) - Dd*f*(12*C - 17)*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(-f*(10*C - 13)*(r*(4*s - 1) - s) + fd*(12*C - 17)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(10*C - 13) + f*fdd*(17 - 12*C) + fd**2*(17 - 12*C)) + Ddd*f**2*(12*C - 17)*(r*(4*s - 1) - s)) + Dd**2*f**2*(12*C - 17)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(66*C - 89)*(r*(4*s - 1) - s) - fd*(60*C - 85)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(66*C - 89)*(r*(3*s - 1) - s) - f*(12*C - 17)*(9*bdd1*s*(r - 1) + 5*fdd*r*(3*s - 1) - 5*fdd*s) - fd**2*(60*C - 85)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(85 - 60*C)*(r*(4*s - 1) - s)) + Dd**2*f**2*(85 - 60*C)*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct**4*k1*k2*(63*D1**2*bd1**2*f*(4*C - 5)*(r*(2*s - 1) - s + 1) - 3*D1*bd1*(-7*b1*(4*C - 5)*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(3*f*(4*C*s + r*(-4*C - 6*s + 5) + s) + 5*fd*(-4*C*s + r*(4*C + 24*s - 11) - 7*s + 6)) + 10*Dd*f*(-8*C*s + r*(8*C + 24*s - 13) - 5*s + 3))) + 21*b1**2*(4*C - 5)*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) - 9*b1*(-2*D1*Dd*f*(9*f*(r*(4*s - 1) - s) + 5*fd*(8*r*(C - 6*s + 1) - s*(8*C - 16) - 3)) + D1*(-7*D1*bdd1*f*(4*C - 5)*(r*(2*s - 1) - s) + D1*(3*f*fd - 5*f*fdd - 5*fd**2)*(4*C*r - 4*C*s - 12*r*s + r + 5*s) + 30*Ddd*f**2*(r*(4*s - 1) - s)) + 30*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(4*C + 1)*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(-20*C - 5)*(r*(3*s - 1) - s) + f*(-9*bdd1*(4*C*s + r*(-4*C - 6*s + 5) + s) + fdd*(28*C + 7)*(r*(3*s - 1) - s)) + fd**2*(28*C + 7)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(28*C + 7)*(r*(4*s - 1) - s)) + Dd**2*f**2*(28*C + 7)*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct**4*k1*(-33*b1**2*(D1*Dd*(-f*(9*f + 7)*(r*(4*s - 1) - s) + 3*fd*(5*f*(2*r*(8*s - 3) - 2*s + 1) + 7*r*(8*s - 5) - 7*s + 7)) - D1*(D1*r*(fd**2*(15 - 30*s) + fd*(18*f*s - 9*f + 7*s - 7) + 3*fdd*(-10*f*s + 5*f - 7*s + 7)) - 3*Ddd*f*(5*f + 7)*(r*(4*s - 1) - s)) + 3*Dd**2*f*(5*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*(D1*Dd*f*(f*(50*f + 27)*(r*(4*s - 1) - s) - 5*fd*(7*f*(48*r*s - 14*r - 10*s + 3) + 144*r*s - 54*r - 54*s + 18)) + 3*D1*bd1*(D1*(f*s*(9*f + 7)*(2*r - 1) - 3*fd*(5*f*(r*(8*s - 2) - 2*s + 1) + 7*r*(4*s - 2) - 7*s + 7)) - 3*Dd*f*(5*f + 7)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(f*fd*(r*(50*f*(3*s - 1) + 54*s - 27) - s*(25*f + 27)) + f*(-9*bdd1*s*(5*f + 7)*(2*r - 1) - 5*fdd*r*(14*f*(3*s - 1) + 18*s - 9) + fdd*s*(35*f + 45)) - 5*fd**2*(7*f*(12*r*s - 4*r - 2*s + 1) + 18*r*s - 9*r - 9*s + 9)) - 5*Ddd*f**2*(14*f + 9)*(r*(4*s - 1) - s)) - 5*Dd**2*f**2*(14*f + 9)*(3*r*(4*s - 1) - 3*s + 1)) + f*(-99*D1**2*bd1**2*s*(5*f + 7)*(2*r - 1) + 11*D1*bd1*(D1*(25*f**2*s*(2*r - 1) - 35*f*fd*(2*r*(6*s - 1) - 4*s + 1) + 27*f*r*s + 45*fd*(-4*r*s + r + s)) - 5*Dd*f*(7*f*(16*r*s - 2*r - 6*s + 1) + 72*r*s - 9*r - 9*s)) - 5*f*(-7*D1*Dd*f*(7*f*r*(4*s - 1) - 7*f*s - 18*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(77*bdd1*f*s*(2*r - 1) + 99*bdd1*r*s - 49*f*fd*(r*(4*s - 1) - s) + 63*f*fdd*(r*(4*s - 1) - s) + 63*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 63*Ddd*f**2*(r*(4*s - 1) - s)) + 63*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(3465*d**2*k2) + 2*D1**2*Pkd1*Pkd2*ct**4*k2**3*st**2*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(23*f*(4*r*s - r - s) - 25*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(r*(3*s - 1) - s) + 5*f*(-9*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(-4*r*s + r + s)) - 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k1*k3**2) - D1**2*Pkd1*Pkd2*ct**4*k2**3*(21*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 15*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(7*b1*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(-3*f*r*(s - 1) + 5*fd*(4*r*s - 2*r - s + 1)) + 5*Dd*f*(r*(8*s - 5) - s + 1))) + 7*b1**2*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(7*D1*bdd1*f*(r*(2*s - 1) - s) - D1*s*(2*r - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1*k3**2) + D1**2*Pkd1*Pkd2*ct**4*k2*(D1*f*(-9*D1*bd1**2*(5*f*(4*r*s - r - 2*s + 1) + s*(14*r - 7)) - 5*D1*bdd1*f*r*(7*f*(2*s - 1) + 9*s) + bd1*(D1*(25*f**2*r*(2*s - 1) - 35*f*fd*(4*r*(3*s - 1) - 2*s + 1) + 27*f*r*s + 45*fd*(-4*r*s + r + s)) - 5*Dd*f*(7*f*(16*r*s - 6*r - 2*s + 1) + 72*r*s - 9*r - 9*s))) - 3*b1**2*(D1*Dd*(-f*(18*f + 7)*(r*(4*s - 1) - s) + 3*fd*(5*f*(8*r - 1)*(4*s - 1) + 7*r*(8*s - 5) - 7*s + 7)) - D1*(D1*r*(fd**2*(15 - 60*s) + fd*(36*f*s - 9*f + 7*s - 7) + 3*fdd*(-20*f*s + 5*f - 7*s + 7)) - 3*Ddd*f*(10*f + 7)*(r*(4*s - 1) - s)) + 3*Dd**2*f*(10*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(f*(50*f + 27)*(r*(4*s - 1) - s) - 5*fd*(7*f*(48*r*s - 10*r - 14*s + 3) + 144*r*s - 54*r - 54*s + 18)) + 3*D1*bd1*(D1*(f*(9*f*(4*r*s - r - 2*s) + s*(14*r - 7)) - 3*fd*(5*f*(4*r - 1)*(4*s - 1) + 7*r*(4*s - 2) - 7*s + 7)) - 3*Dd*f*(5*f*(8*r - 3)*(4*s - 1) + 14*r*(8*s - 1) - 42*s + 7)) + D1*(D1*(f*fd*(r*(25*f*(6*s - 1) + 54*s - 27) - s*(50*f + 27)) + f*(-9*bdd1*(5*f*(4*r*s - r - 2*s) + s*(14*r - 7)) + 5*fdd*(r*(-42*f*s + 7*f - 18*s + 9) + s*(14*f + 9))) - 5*fd**2*(7*f*(12*r*s - 2*r - 4*s + 1) + 18*r*s - 9*r - 9*s + 9)) - 5*Ddd*f**2*(14*f + 9)*(r*(4*s - 1) - s)) - 5*Dd**2*f**2*(14*f + 9)*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k1) - 2*D1**2*Pkd1*Pkd2*ct**3*k1**2*st**2*(D1*bd1*f*(D1*(f*s*(11*C - 26)*(r - 1) - fd*(9*C - 27)*(r*(4*s - 1) - 2*s + 1)) + Dd*f*(27 - 9*C)*(r*(8*s - 1) - 5*s + 1)) + b1*(D1*Dd*f*(f*(11*C - 26)*(r*(4*s - 1) - s) - fd*(9*C - 27)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(D1*r*(2*s - 1)*(f*fd*(11*C - 26) - f*fdd*(9*C - 27) - fd**2*(9*C - 27)) - Ddd*f**2*(9*C - 27)*(r*(4*s - 1) - s)) + Dd**2*f**2*(27 - 9*C)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(7*C - 18)*(r*(4*s - 1) - s) - fd*(5*C - 15)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(7*C - 18)*(r*(3*s - 1) - s) - f*(C - 3)*(9*bdd1*s*(r - 1) + 5*fdd*r*(3*s - 1) - 5*fdd*s) - fd**2*(5*C - 15)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(15 - 5*C)*(r*(4*s - 1) - s)) + Dd**2*f**2*(15 - 5*C)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) - 2*D1**2*Pkd1*Pkd2*ct**3*k1**2*(-63*D1**2*bd1**2*f*(C - 2)*(r*(2*s - 1) - s + 1) + 3*D1*bd1*(-7*b1*(C - 2)*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(3*f*(C*s - r*(C + 2*s - 2)) + 5*fd*(r*(C + 8*s - 4) - s*(C + 2) + 2)) - 10*Dd*f*(2*C*s + r*(-2*C - 8*s + 5) + s - 1))) - 21*b1**2*(C - 2)*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 9*b1*(2*D1*Dd*f*(3*f*(-4*r*s + r + s) - 5*fd*(-2*C*s + 2*r*(C - 8*s + 1) + 6*s - 1)) + D1*(-7*D1*bdd1*f*(C - 2)*(r*(2*s - 1) - s) + D1*(C*(r - s) + s*(2 - 4*r))*(3*f*fd - 5*f*fdd - 5*fd**2) + 10*Ddd*f**2*(r*(4*s - 1) - s)) + 10*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 5*f*(C*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 7*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*(r - s) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 18*D1**2*bdd1*f*r*(s - 1)))/(315*d**2*k3**2) - D1**2*Pkd1*Pkd2*ct**3*k2**2*st**4*(2*C - 2)*(3*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 3*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(7*f*(4*r*s - r - s) - 5*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(7*f*fd*(r*(3*s - 1) - s) + 5*f*(-3*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) - 2*D1**2*Pkd1*Pkd2*ct**3*k2**2*st**2*(-63*D1**2*bd1**2*f*(C - 1)*(r*(2*s - 1) - s + 1) + 3*D1*bd1*(-7*b1*(C - 1)*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(3*C*fd*(4*r*(7*s - 1) - 17*s + 7) - f*r*(C*(7*s + 11) + 26*s - 11) + f*s*(18*C + 15) + 9*fd*(4*r*(3*s - 1) - 5*s + 3)) + 3*Dd*f*(C*(56*r*s + 5*r - 47*s + 7) + 72*r*s - 21*r - 33*s + 9))) - 21*b1**2*(C - 1)*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1*(D1*Dd*f*(-f*(7*C + 26)*(r*(4*s - 1) - s) + 3*fd*(C*(2*r*(56*s - 27) - 2*s + 7) + 6*r*(24*s - 7) - 30*s + 9)) - D1*(21*D1*bdd1*f*(C - 1)*(r*(2*s - 1) - s) + D1*(f*(fd*(r*(2*C*(7*s - 9) + 52*s - 15) + s*(11*C - 11)) - 6*fdd*r*(C*(7*s - 5) + 9*s - 3) + fdd*s*(9 - 9*C)) + 3*fd**2*(-2*r*(7*C*s - 5*C + 9*s - 3) + s*(3 - 3*C))) - Ddd*f**2*(21*C + 27)*(r*(4*s - 1) - s)) + Dd**2*f**2*(21*C + 27)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(-f*(46*C + 33)*(r*(4*s - 1) - s) + fd*(50*C + 30)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(-f*fd*(46*C + 33)*(r*(3*s - 1) - s) + f*(9*bdd1*(r*(7*C*s + 3*C + 9*s - 3) + s*(-10*C - 6)) + fdd*(50*C + 30)*(r*(3*s - 1) - s)) + fd**2*(50*C + 30)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(50*C + 30)*(r*(4*s - 1) - s)) + Dd**2*f**2*(50*C + 30)*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k3**2) - D1**2*Pkd1*Pkd2*ct**3*k2**2*(2*C + 2)*(21*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 15*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(7*b1*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(-3*f*r*(s - 1) + 5*fd*(4*r*s - 2*r - s + 1)) + 5*Dd*f*(r*(8*s - 5) - s + 1))) + 7*b1**2*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(7*D1*bdd1*f*(r*(2*s - 1) - s) - D1*s*(2*r - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct**3*st**2*(297*D1**2*K*bdd1*f**2*r*s - 99*D1**2*bd1**2*f*s*(2*r - 1)*(-7*K + 10*f + 7) - 1650*D1**2*bdd1*f**3*r*s + 1100*D1**2*bdd1*f**3*s - 297*D1**2*bdd1*f**2*r*s - 1386*D1**2*bdd1*f*g2*r*s + 1386*D1**2*bdd1*f*g2*s + 2960*D1**2*f**3*fd*r*s - 740*D1**2*f**3*fd*r - 740*D1**2*f**3*fd*s - 2800*D1**2*f**3*fdd*r*s + 700*D1**2*f**3*fdd*r + 700*D1**2*f**3*fdd*s - 8400*D1**2*f**2*fd**2*r*s + 2100*D1**2*f**2*fd**2*r + 2100*D1**2*f**2*fd**2*s - 700*D1**2*f**2*fd**2 + 726*D1**2*f**2*gd2*r*s - 594*D1**2*f**2*gdd2*r*s + 1452*D1**2*f*fd*g2*r*s - 726*D1**2*f*fd*g2*r - 726*D1**2*f*fd*g2*s - 2376*D1**2*f*fd*gd2*r*s + 594*D1**2*f*fd*gd2*r + 594*D1**2*f*fd*gd2*s - 1188*D1**2*f*fdd*g2*r*s + 594*D1**2*f*fdd*g2*r + 594*D1**2*f*fdd*g2*s - 1188*D1**2*fd**2*g2*r*s + 594*D1**2*fd**2*g2*r + 594*D1**2*fd**2*g2*s - 594*D1**2*fd**2*g2 + 2960*D1*Dd*f**4*r*s - 740*D1*Dd*f**4*r - 740*D1*Dd*f**4*s - 22400*D1*Dd*f**3*fd*r*s + 5600*D1*Dd*f**3*fd*r + 5600*D1*Dd*f**3*fd*s - 1400*D1*Dd*f**3*fd + 2904*D1*Dd*f**2*g2*r*s - 726*D1*Dd*f**2*g2*r - 726*D1*Dd*f**2*g2*s - 4752*D1*Dd*f**2*gd2*r*s + 594*D1*Dd*f**2*gd2*r + 594*D1*Dd*f**2*gd2*s - 9504*D1*Dd*f*fd*g2*r*s + 3564*D1*Dd*f*fd*g2*r + 3564*D1*Dd*f*fd*g2*s - 1188*D1*Dd*f*fd*g2 - 2800*D1*Ddd*f**4*r*s + 700*D1*Ddd*f**4*r + 700*D1*Ddd*f**4*s - 2376*D1*Ddd*f**2*g2*r*s + 594*D1*Ddd*f**2*g2*r + 594*D1*Ddd*f**2*g2*s + 11*D1*bd1*(D1*(46*f**3*s*(3*r - 2) + f**2*(-50*fd*(18*r*s - 3*r - 7*s + 2) + r*s*(33 - 33*K)) + 3*f*(9*fd*(K - 1)*(r*(4*s - 1) - s) + s*(14*g2*(r - 1) - 84*gd2*r + 42*gd2)) - 126*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-50*f**2*(24*r*s - 3*r - 11*s + 2) + 27*f*(K - 1)*(8*r*s - r - s) - 126*g2*(8*r*s - r - 5*s + 1))) - 8400*Dd**2*f**4*r*s + 2100*Dd**2*f**4*r + 2100*Dd**2*f**4*s - 700*Dd**2*f**4 - 7128*Dd**2*f**2*g2*r*s + 1782*Dd**2*f**2*g2*r + 1782*Dd**2*f**2*g2*s - 594*Dd**2*f**2*g2 - 33*b1**2*(D1*Dd*(-f*(r*(4*s - 1) - s)*(-7*K + 18*f + 7) + 3*fd*(10*f*(16*r*s - 6*r - 2*s + 1) + (7 - 7*K)*(8*r*s - 5*r - s + 1))) + D1*(D1*r*(f*fd*(18 - 36*s) + 30*f*fdd*(2*s - 1) + 30*fd**2*(2*s - 1) + 7*fd*(K - 1)*(s - 1) + 21*fdd*(-K*s + K + s - 1)) + 3*Ddd*f*(r*(4*s - 1) - s)*(-7*K + 10*f + 7)) + 3*Dd**2*f*(-7*K + 10*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*(D1*Dd*(138*f**3*(r*(4*s - 1) - s) + f**2*(-50*fd*(3*r*(24*s - 7) - 13*s + 4) + (33 - 33*K)*(r*(4*s - 1) - s)) + 6*f*(9*fd*(K - 1)*(r*(8*s - 3) - 3*s + 1) + 7*g2*r*(4*s - 1) - 7*g2*s + 21*gd2*(-8*r*s + r + s)) - 126*fd*g2*(r*(8*s - 5) - s + 1)) + 3*D1*bd1*(D1*(-30*f*fd*(r*(8*s - 2) - 2*s + 1) + f*s*(2*r - 1)*(-7*K + 18*f + 7) + 21*fd*(K - 1)*(r*(4*s - 2) - s + 1)) - 3*Dd*f*(-7*K + 10*f + 7)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(-10*f**2*(9*bdd1*s*(2*r - 1) + 5*fdd*r*(9*s - 3) - 5*fdd*s) + 3*f*(9*fdd*(K - 1)*(r*(2*s - 1) - s) + s*(21*bdd1*(K - 1)*(2*r - 1) + 7*r*(2*gd2 - 6*gdd2))) + fd**2*(-50*f*(6*r*(3*s - 1) - 2*s + 1) + (27*K - 27)*(r*(2*s - 1) - s + 1)) + fd*(46*f**2*(r*(9*s - 3) - s) - 33*f*(K - 1)*(r*(2*s - 1) - s) + 42*r*(g2*(s - 1) - 6*gd2*s + 3*gd2)) - 126*fdd*g2*r*(s - 1)) - 3*Ddd*f*(r*(4*s - 1) - s)*(50*f**2 - 9*f*(K - 1) + 42*g2)) - 3*Dd**2*f*(50*f**2 - 9*f*(K - 1) + 42*g2)*(3*r*(4*s - 1) - 3*s + 1)))/(3465*d**2) + D1**2*Pkd1*Pkd2*ct**3*(-63*D1**2*K*bd1**2*f*r + 63*D1**2*K*bd1**2*f*s + 27*D1**2*K*bd1*f**2*r*s - 180*D1**2*K*bd1*f*fd*r*s + 45*D1**2*K*bd1*f*fd*r + 45*D1**2*K*bd1*f*fd*s - 45*D1**2*K*bdd1*f**2*r*s - 360*D1**2*bd1**2*f**2*r*s + 135*D1**2*bd1**2*f**2*r + 135*D1**2*bd1**2*f**2*s - 90*D1**2*bd1**2*f**2 - 252*D1**2*bd1**2*f*r*s + 63*D1**2*bd1**2*f*r + 63*D1**2*bd1**2*f*s - 420*D1**2*bd1**2*g2*r*s + 210*D1**2*bd1**2*g2*r + 210*D1**2*bd1**2*g2*s - 210*D1**2*bd1**2*g2 - 126*D1**2*bd1*bd2*f*r*s + 63*D1**2*bd1*bd2*f*s + 75*D1**2*bd1*f**3*r*s - 50*D1**2*bd1*f**3*r - 630*D1**2*bd1*f**2*fd*r*s + 245*D1**2*bd1*f**2*fd*r + 105*D1**2*bd1*f**2*fd*s - 70*D1**2*bd1*f**2*fd + 27*D1**2*bd1*f**2*r*s - 180*D1**2*bd1*f*fd*r*s + 45*D1**2*bd1*f*fd*r + 45*D1**2*bd1*f*fd*s - 42*D1**2*bd1*f*g2*r + 42*D1**2*bd1*f*g2*s + 126*D1**2*bd1*f*gd2*r - 126*D1**2*bd1*f*gd2*s + 27*D1**2*bd2*f**2*r*s - 180*D1**2*bd2*f*fd*r*s + 45*D1**2*bd2*f*fd*r + 45*D1**2*bd2*f*fd*s - 105*D1**2*bdd1*f**3*r*s + 70*D1**2*bdd1*f**3*r - 45*D1**2*bdd1*f**2*r*s + 126*D1**2*bdd1*f*g2*r - 126*D1**2*bdd1*f*g2*s - 45*D1**2*bdd2*f**2*r*s - 54*D1**2*f**2*gd2*r*s + 90*D1**2*f**2*gdd2*r*s - 108*D1**2*f*fd*g2*r*s + 54*D1**2*f*fd*g2*r + 54*D1**2*f*fd*g2*s + 360*D1**2*f*fd*gd2*r*s - 90*D1**2*f*fd*gd2*r - 90*D1**2*f*fd*gd2*s + 180*D1**2*f*fdd*g2*r*s - 90*D1**2*f*fdd*g2*r - 90*D1**2*f*fdd*g2*s + 180*D1**2*fd**2*g2*r*s - 90*D1**2*fd**2*g2*r - 90*D1**2*fd**2*g2*s + 90*D1**2*fd**2*g2 - 360*D1*Dd*K*bd1*f**2*r*s + 45*D1*Dd*K*bd1*f**2*r + 45*D1*Dd*K*bd1*f**2*s - 840*D1*Dd*bd1*f**3*r*s + 385*D1*Dd*bd1*f**3*r + 105*D1*Dd*bd1*f**3*s - 70*D1*Dd*bd1*f**3 - 360*D1*Dd*bd1*f**2*r*s + 45*D1*Dd*bd1*f**2*r + 45*D1*Dd*bd1*f**2*s + 504*D1*Dd*bd1*f*g2*r - 504*D1*Dd*bd1*f*g2*s - 360*D1*Dd*bd2*f**2*r*s + 45*D1*Dd*bd2*f**2*r + 45*D1*Dd*bd2*f**2*s - 216*D1*Dd*f**2*g2*r*s + 54*D1*Dd*f**2*g2*r + 54*D1*Dd*f**2*g2*s + 720*D1*Dd*f**2*gd2*r*s - 90*D1*Dd*f**2*gd2*r - 90*D1*Dd*f**2*gd2*s + 1440*D1*Dd*f*fd*g2*r*s - 540*D1*Dd*f*fd*g2*r - 540*D1*Dd*f*fd*g2*s + 180*D1*Dd*f*fd*g2 + 360*D1*Ddd*f**2*g2*r*s - 90*D1*Ddd*f**2*g2*r - 90*D1*Ddd*f**2*g2*s + 21*D1*b2*bd1*(D1*(f*s*(r - 1) + 3*fd*(-2*r*s + r + s - 1)) - 3*Dd*f*(r*(8*s - 1) - 5*s + 1)) + 1080*Dd**2*f**2*g2*r*s - 270*Dd**2*f**2*g2*r - 270*Dd**2*f**2*g2*s + 90*Dd**2*f**2*g2 - 21*b1**3*(D1*Dd*(r*(-20*K*s + 5*K - 4*f*s + f + 3*fd*(8*s - 1) + 20*s - 5) + s*(5*K + f - 3*fd - 5)) + D1*(-D1*r*s*(fd - 3*fdd) + Ddd*(r*(4*s - 1) - s)*(-5*K + 3*f + 5)) + Dd**2*(-5*K + 3*f + 5)*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1**2*(-2*D1*Dd*(18*f**2*(-4*r*s + r + s) + 7*f*(-4*r*s + r + s) + 3*fd*(14*K*s + 5*f*(r*(32*s - 6) - 6*s + 1) - 7*r*(2*K - 8*s + 3) - 21*s + 7) + 35*g2*r*(4*s - 1) - 35*g2*s + 35*gd2*r*(8*s - 1) - 35*gd2*s) + 7*D1*bd1*(D1*(r*(f*(3*s - 1) + fd*(3 - 18*s) + (5*K - 5)*(3*s - 1)) - s*(5*K + f - 3*fd - 5)) - Dd*(-5*K + 3*f + 5)*(r*(24*s - 7) - 7*s + 2)) + D1*(-7*D1*bdd1*(r*(3*s - 1) - s)*(-5*K + 3*f + 5) + D1*(-15*fd**2*(r*(8*s - 1) - s) + fd*(9*f*r*(8*s - 1) - 7*r*(K - 2*s + 1) + s*(7*K - 9*f - 7)) - 3*fdd*(5*f*r*(8*s - 1) - 7*r*(K - 2*s + 1) + s*(7*K - 5*f - 7)) + r*s*(-70*gd2 - 70*gdd2)) - 2*Ddd*(r*(4*s - 1) - s)*(30*f**2 + 21*f + 35*g2)) - 2*Dd**2*(30*f**2 + 21*f + 35*g2)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-63*D1**2*K*bdd1*f*r + 63*D1**2*K*bdd1*f*s + 54*D1**2*K*f*fd*r*s - 27*D1**2*K*f*fd*r - 27*D1**2*K*f*fd*s - 90*D1**2*K*f*fdd*r*s + 45*D1**2*K*f*fdd*r + 45*D1**2*K*f*fdd*s - 90*D1**2*K*fd**2*r*s + 45*D1**2*K*fd**2*r + 45*D1**2*K*fd**2*s - 45*D1**2*K*fd**2 - 21*D1**2*bd1**2*(-5*K + 3*f + 5)*(r*(6*s - 2) - 2*s + 1) + 21*D1**2*bd2*f*r*s - 126*D1**2*bd2*fd*r*s + 63*D1**2*bd2*fd*r - 360*D1**2*bdd1*f**2*r*s + 135*D1**2*bdd1*f**2*r + 135*D1**2*bdd1*f**2*s - 252*D1**2*bdd1*f*r*s + 63*D1**2*bdd1*f*r + 63*D1**2*bdd1*f*s - 420*D1**2*bdd1*g2*r*s + 210*D1**2*bdd1*g2*r + 210*D1**2*bdd1*g2*s - 63*D1**2*bdd2*f*r*s + 225*D1**2*f**2*fd*r*s - 25*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s - 315*D1**2*f**2*fdd*r*s + 35*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s - 630*D1**2*f*fd**2*r*s + 70*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 54*D1**2*f*fd*r*s - 27*D1**2*f*fd*r - 27*D1**2*f*fd*s - 90*D1**2*f*fdd*r*s + 45*D1**2*f*fdd*r + 45*D1**2*f*fdd*s - 90*D1**2*fd**2*r*s + 45*D1**2*fd**2*r + 45*D1**2*fd**2*s - 45*D1**2*fd**2 + 42*D1**2*fd*g2*r - 42*D1**2*fd*g2*s - 126*D1**2*fd*gd2*r + 126*D1**2*fd*gd2*s - 126*D1**2*fdd*g2*r + 126*D1**2*fdd*g2*s + 108*D1*Dd*K*f**2*r*s - 27*D1*Dd*K*f**2*r - 27*D1*Dd*K*f**2*s - 720*D1*Dd*K*f*fd*r*s + 270*D1*Dd*K*f*fd*r + 270*D1*Dd*K*f*fd*s - 90*D1*Dd*K*f*fd - 504*D1*Dd*bd2*f*r*s + 63*D1*Dd*bd2*f*r + 63*D1*Dd*bd2*f*s + 300*D1*Dd*f**3*r*s - 75*D1*Dd*f**3*r - 75*D1*Dd*f**3*s - 2520*D1*Dd*f**2*fd*r*s + 455*D1*Dd*f**2*fd*r + 735*D1*Dd*f**2*fd*s - 140*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r*s - 27*D1*Dd*f**2*r - 27*D1*Dd*f**2*s - 720*D1*Dd*f*fd*r*s + 270*D1*Dd*f*fd*r + 270*D1*Dd*f*fd*s - 90*D1*Dd*f*fd - 504*D1*Dd*fd*g2*r + 504*D1*Dd*fd*g2*s - 180*D1*Ddd*K*f**2*r*s + 45*D1*Ddd*K*f**2*r + 45*D1*Ddd*K*f**2*s - 420*D1*Ddd*f**3*r*s + 105*D1*Ddd*f**3*r + 105*D1*Ddd*f**3*s - 180*D1*Ddd*f**2*r*s + 45*D1*Ddd*f**2*r + 45*D1*Ddd*f**2*s + 3*D1*bd1*(D1*(9*f**2*(r*(8*s - 3) - 3*s) - 7*f*(-K*r + K*s - 4*r*s + r + s) - 3*fd*(7*K*s + 10*f*(4*r - 1)*(4*s - 1) - 7*r*(K - 8*s + 3) - 21*s + 14) - 70*g2*r*(2*s - 1) + 70*g2*s - 70*gd2*r*(4*s - 1) + 70*gd2*s) - 2*Dd*(15*f**2*(2*r*(16*s - 5) - 10*s + 3) + 21*f*(2*r*(K + 8*s - 2) - s*(2*K + 4) + 1) + 70*g2*(r*(8*s - 3) - 3*s + 1))) - 540*Dd**2*K*f**2*r*s + 135*Dd**2*K*f**2*r + 135*Dd**2*K*f**2*s - 45*Dd**2*K*f**2 - 1260*Dd**2*f**3*r*s + 315*Dd**2*f**3*r + 315*Dd**2*f**3*s - 105*Dd**2*f**3 - 540*Dd**2*f**2*r*s + 135*Dd**2*f**2*r + 135*Dd**2*f**2*s - 45*Dd**2*f**2 - 21*b2*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*(8*r*s - 5*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - r - s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1))) - 9*b2*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 10*fd*(r*(8*s - 3) - 3*s + 1)) + D1*(D1*(3*f*fd*(-2*r*s + r + s) + f*(7*bdd1*s*(r - 1) + 5*fdd*r*(2*s - 1) - 5*fdd*s) + 5*fd**2*(r*(2*s - 1) - s + 1)) + 5*Ddd*f**2*(r*(4*s - 1) - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2) + D1**2*Pkd1*Pkd2*ct**2*f*k2*st**4*(33*D1*bd1*f*(D1*f*s*(r - 1) + D1*fd*(-6*r*s + r + 3*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 33*b1*(D1*Dd*f*(f*(-4*r*s + r + s) + fd*r*(24*s - 7) - 3*fd*s + fd) - D1*(D1*r*(3*s - 1)*(f*(fd - fdd) - 2*fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(19*f*(4*r*s - r - s) - 30*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(19*f*fd*(r*(4*s - 1) - s) + 3*f*(-11*bdd1*s*(r - 1) + 5*fdd*(-4*r*s + r + s)) - 15*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 15*Ddd*f**2*(-4*r*s + r + s)) - 15*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k1) + D1**2*Pkd1*Pkd2*ct**2*k1**3*st**2*(D1*bd1*f*(D1*(11*f*s*(r - 1) - 9*fd*(4*r*s - r - 2*s + 1)) - 9*Dd*f*(r*(8*s - 1) - 5*s + 1)) + b1*(D1*Dd*f*(11*f*(4*r*s - r - s) - 9*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(D1*r*(2*s - 1)*(11*f*fd - 9*f*fdd - 9*fd**2) + 9*Ddd*f**2*(-4*r*s + r + s)) - 9*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(7*f*(4*r*s - r - s) - 5*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(7*f*fd*(r*(3*s - 1) - s) + f*(-9*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k2*k3**2) - D1**2*Pkd1*Pkd2*ct**2*k1**3*(21*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 15*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(7*b1*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(-3*f*r*(s - 1) + 5*fd*(4*r*s - 2*r - s + 1)) + 5*Dd*f*(r*(8*s - 5) - s + 1))) + 7*b1**2*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(7*D1*bdd1*f*(r*(2*s - 1) - s) - D1*s*(2*r - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k2*k3**2) + D1**2*Pkd1*Pkd2*ct**2*k1*k2*st**4*(-3*D1*bd1*f*(D1*(f*s*(8*C - 11)*(r - 1) - fd*(4*C - 9)*(4*r*s - r - 2*s + 1)) - Dd*f*(4*C - 9)*(r*(8*s - 1) - 5*s + 1)) + 3*b1*(D1*Dd*f*(-f*(8*C - 11)*(r*(4*s - 1) - s) + fd*(4*C - 9)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(8*C - 11) + f*fdd*(9 - 4*C) + fd**2*(9 - 4*C)) + Ddd*f**2*(4*C - 9)*(r*(4*s - 1) - s)) + Dd**2*f**2*(4*C - 9)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(-f*(8*C - 15)*(r*(4*s - 1) - s) + fd*(4*C - 9)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(-f*fd*(8*C - 15)*(r*(3*s - 1) - s) + f*(4*C - 9)*(3*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) + fd**2*(4*C - 9)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(4*C - 9)*(r*(4*s - 1) - s)) + Dd**2*f**2*(4*C - 9)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct**2*k1*k2*st**2*(7*D1**2*bd1**2*f*(4*C - 7)*(r*(2*s - 1) - s + 1) + D1*bd1*(7*b1*(D1*(-f*(8*C - 9)*(2*r*s - r - s) + fd*(4*C - 7)*(4*r*s - r - s)) + Dd*f*(8*C - 14)*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(f*(r*(36*C*s + 24*C + 46*s - 35) - s*(60*C + 11)) - 3*fd*(4*C*(20*r*s - 4*r - 11*s + 5) + 40*r*s - 17*r - 13*s + 10)) - 6*Dd*f*(2*C*(40*r*s - r - 29*s + 5) + 40*r*s - 19*r - 11*s + 5))) + 7*b1**2*(D1*Dd*(-f*(8*C - 9)*(r*(4*s - 1) - s) + fd*(4*C - 7)*(r*(8*s - 1) - s)) + D1*(D1*r*s*(fd*(9 - 8*C) + fdd*(4*C - 7)) + Ddd*f*(4*C - 7)*(r*(4*s - 1) - s)) + Dd**2*f*(4*C - 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(2*D1*Dd*f*(f*(18*C + 23)*(r*(4*s - 1) - s) - 3*fd*(2*C*(80*r*s - 34*r - 6*s + 5) + 80*r*s - 16*r - 24*s + 5)) + D1*(7*D1*bdd1*f*(4*C - 7)*(r*(2*s - 1) - s) + D1*(f*(fd*r*(12*C*(6*s - 5) + 92*s - 11) + fd*s*(24*C - 35) + 3*fdd*r*(-8*C*(5*s - 3) - 20*s + 3) + fdd*s*(21 - 12*C)) + 3*fd**2*(r*(-40*C*s + 24*C - 20*s + 3) + s*(7 - 4*C))) - Ddd*f**2*(60*C + 30)*(r*(4*s - 1) - s)) + Dd**2*f**2*(-60*C - 30)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(44*C + 7)*(r*(4*s - 1) - s) - fd*(40*C + 5)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(44*C + 7)*(r*(3*s - 1) - s) + f*(-3*bdd1*r*(4*C*(5*s + 1) + 10*s - 7) + 9*bdd1*(8*C*s + s) - fdd*(40*C + 5)*(r*(3*s - 1) - s)) - fd**2*(40*C + 5)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(-40*C - 5)*(r*(4*s - 1) - s)) + Dd**2*f**2*(-40*C - 5)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) - D1**2*Pkd1*Pkd2*ct**2*k1*k2*(4*C + 1)*(21*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 15*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(7*b1*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + 3*f*(D1*(-3*f*r*(s - 1) + 5*fd*(4*r*s - 2*r - s + 1)) + 5*Dd*f*(r*(8*s - 5) - s + 1))) + 7*b1**2*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(7*D1*bdd1*f*(r*(2*s - 1) - s) - D1*s*(2*r - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct**2*k1*st**2*(-11*b1**2*(D1*Dd*(-f*(15*f + 7)*(r*(4*s - 1) - s) + 3*fd*(6*f*(2*r*(8*s - 3) - 2*s + 1) + 7*r*(8*s - 5) - 7*s + 7)) - D1*(D1*r*(fd**2*(18 - 36*s) + fd*(30*f*s - 15*f + 7*s - 7) + 3*fdd*(-12*f*s + 6*f - 7*s + 7)) - 3*Ddd*f*(6*f + 7)*(r*(4*s - 1) - s)) + 3*Dd**2*f*(6*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*(D1*Dd*f*(11*f*(2*f + 1)*(r*(4*s - 1) - s) - 2*fd*(5*f*(48*r*s - 14*r - 10*s + 3) + 72*r*s - 27*r - 27*s + 9)) + D1*bd1*(D1*(f*s*(15*f + 7)*(2*r - 1) - 3*fd*(6*f*(r*(8*s - 2) - 2*s + 1) + 7*r*(4*s - 2) - 7*s + 7)) - 3*Dd*f*(6*f + 7)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(11*f*fd*(r*(6*f*s - 2*f + 2*s - 1) - s*(f + 1)) + f*(-3*bdd1*s*(6*f + 7)*(2*r - 1) + fdd*r*(f*(20 - 60*s) - 18*s + 9) + fdd*s*(10*f + 9)) + fd**2*(-10*f*(12*r*s - 4*r - 2*s + 1) - 18*r*s + 9*r + 9*s - 9)) - Ddd*f**2*(20*f + 9)*(r*(4*s - 1) - s)) - Dd**2*f**2*(20*f + 9)*(3*r*(4*s - 1) - 3*s + 1)) + f*(-33*D1**2*bd1**2*s*(6*f + 7)*(2*r - 1) + 11*D1*bd1*(D1*(11*f**2*s*(2*r - 1) - 10*f*fd*(2*r*(6*s - 1) - 4*s + 1) + 11*f*r*s + 9*fd*(-4*r*s + r + s)) + Dd*f*(-10*f*(16*r*s - 2*r - 6*s + 1) - 72*r*s + 9*r + 9*s)) + f*(5*D1*Dd*f*(17*f*(r*(4*s - 1) - s) - 28*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-99*bdd1*r*s + 85*f*fd*(r*(4*s - 1) - s) - 10*f*(11*bdd1*s*(2*r - 1) + 7*fdd*r*(4*s - 1) - 7*fdd*s) - 70*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 70*Ddd*f**2*(-4*r*s + r + s)) - 70*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(1155*d**2*k2) + D1**2*Pkd1*Pkd2*ct**2*k1*(D1*f*(-9*D1*bd1**2*(5*f*(4*r*s - 2*r - s + 1) + 7*r*(2*s - 1)) - 35*D1*bdd1*f**2*r*(s - 1) - 5*bd1*f*(D1*(-5*f*r*(s - 1) + 7*fd*(6*r*s - 3*r - s + 1)) + 7*Dd*f*(r*(8*s - 5) - s + 1))) - 21*b1**3*(D1*Dd*(r*(-4*f*s + f + 24*fd*s - 3*fd + 20*s - 5) + s*(f - 3*fd - 5)) + D1*(-D1*r*s*(fd - 3*fdd) + Ddd*(3*f + 5)*(4*r*s - r - s)) + Dd**2*(3*f + 5)*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1**2*(D1*Dd*(f*(18*f + 7)*(r*(4*s - 1) - s) - 3*fd*(5*f*(4*r - 1)*(8*s - 1) + 7*r*(8*s - 1) - 35*s + 7)) + 7*D1*bd1*(D1*(r*(3*f*s - f - 18*fd*s + 3*fd - 15*s + 5) + s*(-f + 3*fd + 5)) - Dd*(3*f + 5)*(r*(24*s - 7) - 7*s + 2)) + D1*(-7*D1*bdd1*(3*f + 5)*(r*(3*s - 1) - s) + D1*s*(fd**2*(15 - 60*r) + fd*(36*f*r - 9*f + 7*r - 7) + 3*fdd*(-20*f*r + 5*f - 7*r + 7)) - 3*Ddd*f*(10*f + 7)*(r*(4*s - 1) - s)) - 3*Dd**2*f*(10*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-21*D1**2*bd1**2*(3*f + 5)*(r*(6*s - 2) - 2*s + 1) + 3*D1*bd1*(D1*(f*(-9*f*s + r*(18*f + 7)*(2*s - 1)) - 3*fd*(5*f*(4*r - 1)*(4*s - 1) + 7*r*(4*s - 1) - 14*s + 7)) - 3*Dd*f*(5*f*(4*r - 1)*(8*s - 3) + 14*r*(8*s - 3) - 14*s + 7)) + f*(5*D1*Dd*f*(5*f*(4*r*s - r - s) - 7*fd*(24*r*s - 3*r - 7*s + 1)) + D1*(45*D1*bdd1*f*s - 9*D1*bdd1*r*(10*f + 7)*(2*s - 1) + 5*D1*s*(3*r - 1)*(5*f*fd - 7*f*fdd - 14*fd**2) + 35*Ddd*f**2*(-4*r*s + r + s)) - 35*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(315*d**2*k2) + D1**2*Pkd1*Pkd2*ct**2*k2**3*st**4*(3*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 3*b1*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(7*f*(4*r*s - r - s) - 5*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(7*f*fd*(r*(3*s - 1) - s) + 5*f*(-3*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1*k3**2) + D1**2*Pkd1*Pkd2*ct**2*k2**3*st**2*(-21*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) - 9*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(-7*b1*(D1*(f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(11*f*r*(s - 1) - 9*fd*(4*r*s - 2*r - s + 1)) - 9*Dd*f*(r*(8*s - 5) - s + 1))) - 7*b1**2*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(11*f*(r*(4*s - 1) - s) - 9*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(21*D1*bdd1*f*(-2*r*s + r + s) + D1*s*(2*r - 1)*(11*f*fd - 9*f*fdd - 9*fd**2) + 9*Ddd*f**2*(-4*r*s + r + s)) - 9*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1*k3**2) + D1**2*Pkd1*Pkd2*ct**2*k2*st**2*(D1*f*(-3*D1*bd1**2*(6*f*(4*r*s - r - 2*s + 1) + s*(14*r - 7)) + D1*bdd1*f*r*(f*(10 - 20*s) - 9*s) + bd1*(D1*(11*f**2*r*(2*s - 1) - 10*f*fd*(4*r*(3*s - 1) - 2*s + 1) + 11*f*r*s + 9*fd*(-4*r*s + r + s)) + Dd*f*(-10*f*(16*r*s - 6*r - 2*s + 1) - 72*r*s + 9*r + 9*s))) + b1**2*(D1*Dd*(f*(30*f + 7)*(r*(4*s - 1) - s) - 3*fd*(6*f*(8*r - 1)*(4*s - 1) + 7*r*(8*s - 5) - 7*s + 7)) + D1*(D1*r*(fd**2*(18 - 72*s) + fd*(60*f*s - 15*f + 7*s - 7) + 3*fdd*(-24*f*s + 6*f - 7*s + 7)) - 3*Ddd*f*(12*f + 7)*(r*(4*s - 1) - s)) - 3*Dd**2*f*(12*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(11*f*(2*f + 1)*(r*(4*s - 1) - s) - 2*fd*(5*f*(48*r*s - 10*r - 14*s + 3) + 72*r*s - 27*r - 27*s + 9)) + D1*bd1*(D1*(f*(15*f*(4*r*s - r - 2*s) + s*(14*r - 7)) - 3*fd*(6*f*(4*r - 1)*(4*s - 1) + 7*r*(4*s - 2) - 7*s + 7)) - 3*Dd*f*(6*f*(8*r - 3)*(4*s - 1) + 14*r*(8*s - 1) - 42*s + 7)) + D1*(D1*(11*f*fd*(r*(6*f*s - f + 2*s - 1) - s*(2*f + 1)) + f*(18*bdd1*f*(-4*r*s + r + 2*s) + 21*bdd1*s*(1 - 2*r) + fdd*r*(f*(10 - 60*s) - 18*s + 9) + fdd*s*(20*f + 9)) + fd**2*(-10*f*(12*r*s - 2*r - 4*s + 1) - 18*r*s + 9*r + 9*s - 9)) - Ddd*f**2*(20*f + 9)*(r*(4*s - 1) - s)) - Dd**2*f**2*(20*f + 9)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1) + D1**2*Pkd1*Pkd2*ct**2*k2*(-3*D1**2*bd1**2*f*r*(5*f + 7)*(2*s - 1) + D1*b1*(-7*D1*bd1**2*(3*f + 5)*(r*(6*s - 2) - 2*s + 1) - 3*D1*bdd1*f*r*(5*f + 7)*(2*s - 1) + bd1*(D1*(f*r*(9*f + 7)*(2*s - 1) - 3*fd*(5*f*(8*r*s - 2*r - 2*s + 1) + 28*r*s - 7*r - 14*s + 7)) - 3*Dd*f*(5*f + 7)*(2*r*(8*s - 3) - 2*s + 1))) - 7*b1**3*(D1*Dd*(r*(-4*f*s + f + 24*fd*s - 3*fd + 20*s - 5) + s*(f - 3*fd - 5)) + D1*(-D1*r*s*(fd - 3*fdd) + Ddd*(3*f + 5)*(4*r*s - r - s)) + Dd**2*(3*f + 5)*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(D1*Dd*(f*(9*f + 7)*(r*(4*s - 1) - s) - 3*fd*(5*f*(16*r*s - 2*r - 6*s + 1) + 56*r*s - 7*r - 35*s + 7)) + 7*D1*bd1*(D1*(r*(3*f*s - f - 18*fd*s + 3*fd - 15*s + 5) + s*(-f + 3*fd + 5)) - Dd*(3*f + 5)*(r*(24*s - 7) - 7*s + 2)) + D1*(-7*D1*bdd1*(3*f + 5)*(r*(3*s - 1) - s) + D1*s*(fd**2*(15 - 30*r) + fd*(18*f*r - 9*f + 7*r - 7) + 3*fdd*(-10*f*r + 5*f - 7*r + 7)) - 3*Ddd*f*(5*f + 7)*(r*(4*s - 1) - s)) - 3*Dd**2*f*(5*f + 7)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1) + 2*D1**2*Pkd1*Pkd2*ct*k1**2*st**4*(3*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-4*r*s + r + 2*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 3*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 7*r + 7*s - 2)) + D1*(D1*(2*f*fd*(r*(3*s - 1) - s) + f*(-3*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) + fd**2*(r*(2 - 6*s) + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) + 2*D1**2*Pkd1*Pkd2*ct*k1**2*st**2*(-7*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + D1*bd1*(7*b1*(D1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) - 2*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(f*(-11*C*s + r*(11*C*s + 6*s - 6)) - 3*fd*(3*C*(4*r*s - r - 2*s + 1) + 4*r*s - 2*r - s + 1)) - 3*Dd*f*(3*C*(8*r*s - r - 5*s + 1) + 8*r*s - 5*r - s + 1))) - 7*b1**2*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(f*(11*C + 6)*(r*(4*s - 1) - s) - 3*fd*(3*C*(16*r*s - 6*r - 2*s + 1) + 16*r*s - 2*r - 6*s + 1)) + D1*(7*D1*bdd1*f*(-2*r*s + r + s) + D1*(C*r*(2*s - 1)*(11*f*fd - 9*f*fdd - 9*fd**2) + s*(2*r - 1)*(6*f*fd - 3*f*fdd - 3*fd**2)) - Ddd*f**2*(9*C + 3)*(r*(4*s - 1) - s)) + Dd**2*f**2*(-9*C - 3)*(3*r*(4*s - 1) - 3*s + 1)) + f*(C*(D1*Dd*f*(7*f*(4*r*s - r - s) - 5*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(7*f*fd*(r*(3*s - 1) - s) + f*(-9*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 3*D1**2*bdd1*f*r*(s - 1)))/(105*d**2*k3**2) + 2*D1**2*Pkd1*Pkd2*ct*k2**2*st**4*(3*D1*bd1*f*(D1*(f*s*(3*C + 2)*(r - 1) - fd*(5*C + 1)*(4*r*s - r - 2*s + 1)) - Dd*f*(5*C + 1)*(r*(8*s - 1) - 5*s + 1)) - 3*b1*(D1*Dd*f*(-f*(3*C + 2)*(r*(4*s - 1) - s) + fd*(5*C + 1)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(D1*r*(2*s - 1)*(f*(5*C*fdd - fd*(3*C + 2) + fdd) + fd**2*(5*C + 1)) + Ddd*f**2*(5*C + 1)*(r*(4*s - 1) - s)) + Dd**2*f**2*(5*C + 1)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(7*C + 2)*(r*(4*s - 1) - s) - fd*(5*C + 1)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(7*C + 2)*(r*(3*s - 1) - s) - f*(5*C + 1)*(3*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) - fd**2*(5*C + 1)*(r*(6*s - 2) - 2*s + 1)) - Ddd*f**2*(5*C + 1)*(r*(4*s - 1) - s)) - Dd**2*f**2*(5*C + 1)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) + 2*D1**2*Pkd1*Pkd2*ct*k2**2*st**2*(-7*D1**2*bd1**2*f*(3*C + 1)*(r*(2*s - 1) - s + 1) - 3*D1**2*bdd1*f**2*r*(3*C + 1)*(s - 1) + D1*bd1*(-7*b1*(D1*(-f*(C + 2)*(2*r*s - r - s) + fd*(3*C + 1)*(4*r*s - r - s)) + Dd*f*(6*C + 2)*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(f*r*(11*C + 6)*(s - 1) - fd*(9*C + 3)*(r*(4*s - 2) - s + 1)) + Dd*f*(-9*C - 3)*(r*(8*s - 5) - s + 1))) - 7*b1**2*(D1*Dd*(-f*(C + 2)*(r*(4*s - 1) - s) + fd*(3*C + 1)*(r*(8*s - 1) - s)) + D1*(D1*r*s*(3*C*fdd - fd*(C + 2) + fdd) + Ddd*f*(3*C + 1)*(r*(4*s - 1) - s)) + Dd**2*f*(3*C + 1)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(f*(11*C + 6)*(r*(4*s - 1) - s) - fd*(9*C + 3)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(-7*D1*bdd1*f*(3*C + 1)*(r*(2*s - 1) - s) + D1*s*(2*r - 1)*(f*fd*(11*C + 6) - 3*f*(3*C*fdd + fdd) - fd**2*(9*C + 3)) - Ddd*f**2*(9*C + 3)*(r*(4*s - 1) - s)) + Dd**2*f**2*(-9*C - 3)*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct*st**4*(-33*b1**2*(D1*Dd*f*(3*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*f*(D1*Dd*f*(21*f*(4*r*s - r - s) - 5*fd*(72*r*s - 21*r - 13*s + 4)) + 3*D1*bd1*(D1*(3*f*s*(2*r - 1) - 5*fd*(8*r*s - 2*r - 2*s + 1)) - 5*Dd*f*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(7*f*fd*(r*(9*s - 3) - s) + 5*f*(3*bdd1*s*(1 - 2*r) + fdd*(-9*r*s + 3*r + s)) - 5*fd**2*(6*r*(3*s - 1) - 2*s + 1)) + 15*Ddd*f**2*(-4*r*s + r + s)) - 15*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f**2*(-165*D1**2*bd1**2*s*(2*r - 1) + 2*D1*Dd*f*(39*f*(4*r*s - r - s) - 50*fd*(4*r - 1)*(4*s - 1)) + 11*D1*bd1*(D1*(7*f*s*(3*r - 2) - 5*fd*(18*r*s - 3*r - 7*s + 2)) - 5*Dd*f*(3*r*(8*s - 1) - 11*s + 2)) + D1*(D1*(55*bdd1*f*s*(2 - 3*r) + 78*f*fd*(r*(4*s - 1) - s) + 50*f*fdd*(-4*r*s + r + s) - 50*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 50*Ddd*f**2*(-4*r*s + r + s)) - 50*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(1155*d**2) + D1**2*Pkd1*Pkd2*ct*st**2*(-42*D1**2*K*bd1**2*f*r*s + 21*D1**2*K*bd1**2*f*s + 11*D1**2*K*bd1*f**2*r*s - 36*D1**2*K*bd1*f*fd*r*s + 9*D1**2*K*bd1*f*fd*r + 9*D1**2*K*bd1*f*fd*s - 9*D1**2*K*bdd1*f**2*r*s - 72*D1**2*bd1**2*f**2*r*s + 27*D1**2*bd1**2*f**2*r + 27*D1**2*bd1**2*f**2*s - 18*D1**2*bd1**2*f**2 - 42*D1**2*bd1**2*f*r*s + 21*D1**2*bd1**2*f*s - 42*D1**2*bd1*bd2*f*r*s + 21*D1**2*bd1*bd2*f*s + 21*D1**2*bd1*f**3*r*s - 14*D1**2*bd1*f**3*r - 90*D1**2*bd1*f**2*fd*r*s + 35*D1**2*bd1*f**2*fd*r + 15*D1**2*bd1*f**2*fd*s - 10*D1**2*bd1*f**2*fd + 11*D1**2*bd1*f**2*r*s - 36*D1**2*bd1*f*fd*r*s + 9*D1**2*bd1*f*fd*r + 9*D1**2*bd1*f*fd*s - 14*D1**2*bd1*f*g2*r*s + 14*D1**2*bd1*f*g2*s + 84*D1**2*bd1*f*gd2*r*s - 42*D1**2*bd1*f*gd2*s + 84*D1**2*bd1*fd*g2*r*s - 42*D1**2*bd1*fd*g2*r - 42*D1**2*bd1*fd*g2*s + 42*D1**2*bd1*fd*g2 + 11*D1**2*bd2*f**2*r*s - 36*D1**2*bd2*f*fd*r*s + 9*D1**2*bd2*f*fd*r + 9*D1**2*bd2*f*fd*s - 15*D1**2*bdd1*f**3*r*s + 10*D1**2*bdd1*f**3*r - 9*D1**2*bdd1*f**2*r*s + 42*D1**2*bdd1*f*g2*r*s - 42*D1**2*bdd1*f*g2*s - 9*D1**2*bdd2*f**2*r*s - 22*D1**2*f**2*gd2*r*s + 18*D1**2*f**2*gdd2*r*s - 44*D1**2*f*fd*g2*r*s + 22*D1**2*f*fd*g2*r + 22*D1**2*f*fd*g2*s + 72*D1**2*f*fd*gd2*r*s - 18*D1**2*f*fd*gd2*r - 18*D1**2*f*fd*gd2*s + 36*D1**2*f*fdd*g2*r*s - 18*D1**2*f*fdd*g2*r - 18*D1**2*f*fdd*g2*s + 36*D1**2*fd**2*g2*r*s - 18*D1**2*fd**2*g2*r - 18*D1**2*fd**2*g2*s + 18*D1**2*fd**2*g2 - 72*D1*Dd*K*bd1*f**2*r*s + 9*D1*Dd*K*bd1*f**2*r + 9*D1*Dd*K*bd1*f**2*s - 120*D1*Dd*bd1*f**3*r*s + 55*D1*Dd*bd1*f**3*r + 15*D1*Dd*bd1*f**3*s - 10*D1*Dd*bd1*f**3 - 72*D1*Dd*bd1*f**2*r*s + 9*D1*Dd*bd1*f**2*r + 9*D1*Dd*bd1*f**2*s + 336*D1*Dd*bd1*f*g2*r*s - 42*D1*Dd*bd1*f*g2*r - 210*D1*Dd*bd1*f*g2*s + 42*D1*Dd*bd1*f*g2 - 72*D1*Dd*bd2*f**2*r*s + 9*D1*Dd*bd2*f**2*r + 9*D1*Dd*bd2*f**2*s - 88*D1*Dd*f**2*g2*r*s + 22*D1*Dd*f**2*g2*r + 22*D1*Dd*f**2*g2*s + 144*D1*Dd*f**2*gd2*r*s - 18*D1*Dd*f**2*gd2*r - 18*D1*Dd*f**2*gd2*s + 288*D1*Dd*f*fd*g2*r*s - 108*D1*Dd*f*fd*g2*r - 108*D1*Dd*f*fd*g2*s + 36*D1*Dd*f*fd*g2 + 72*D1*Ddd*f**2*g2*r*s - 18*D1*Ddd*f**2*g2*r - 18*D1*Ddd*f**2*g2*s + 216*Dd**2*f**2*g2*r*s - 54*Dd**2*f**2*g2*r - 54*Dd**2*f**2*g2*s + 18*Dd**2*f**2*g2 - 7*b1**3*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) - D1*(D1*r*s*(fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(D1*Dd*(f*(r*(4*s - 1) - s)*(7*K + 44*f + 7) - 3*fd*(6*f*(r*(32*s - 6) - 6*s + 1) + (7*K + 7)*(r*(8*s - 5) - s + 1))) + 7*D1*bd1*(D1*(f*r*(3*s - 1) - f*s + 3*fd*(-6*r*s + r + s)) - 3*Dd*f*(r*(24*s - 7) - 7*s + 2)) + D1*(21*D1*bdd1*f*(-3*r*s + r + s) + D1*(9*fd**2*(-8*r*s + r + s) + fd*(11*f*r*(8*s - 1) - 11*f*s + r*(7*K + 7)*(s - 1)) + 3*fdd*(f*r*(3 - 24*s) + 3*f*s - r*(7*K + 7)*(s - 1))) - 3*Ddd*f*(r*(4*s - 1) - s)*(7*K + 12*f + 7)) - 3*Dd**2*f*(7*K + 12*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-42*D1**2*K*bdd1*f*r*s + 21*D1**2*K*bdd1*f*s + 22*D1**2*K*f*fd*r*s - 11*D1**2*K*f*fd*r - 11*D1**2*K*f*fd*s - 18*D1**2*K*f*fdd*r*s + 9*D1**2*K*f*fdd*r + 9*D1**2*K*f*fdd*s - 18*D1**2*K*fd**2*r*s + 9*D1**2*K*fd**2*r + 9*D1**2*K*fd**2*s - 9*D1**2*K*fd**2 - 21*D1**2*bd1**2*f*(r*(6*s - 2) - 2*s + 1) + 7*D1**2*bd2*f*r*s - 42*D1**2*bd2*fd*r*s + 21*D1**2*bd2*fd*r - 72*D1**2*bdd1*f**2*r*s + 27*D1**2*bdd1*f**2*r + 27*D1**2*bdd1*f**2*s - 42*D1**2*bdd1*f*r*s + 21*D1**2*bdd1*f*s - 21*D1**2*bdd2*f*r*s + 63*D1**2*f**2*fd*r*s - 7*D1**2*f**2*fd*r - 21*D1**2*f**2*fd*s - 45*D1**2*f**2*fdd*r*s + 5*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s - 90*D1**2*f*fd**2*r*s + 10*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 + 22*D1**2*f*fd*r*s - 11*D1**2*f*fd*r - 11*D1**2*f*fd*s - 18*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 14*D1**2*f*gd2*r*s + 42*D1**2*f*gdd2*r*s - 18*D1**2*fd**2*r*s + 9*D1**2*fd**2*r + 9*D1**2*fd**2*s - 9*D1**2*fd**2 - 14*D1**2*fd*g2*r*s + 14*D1**2*fd*g2*r + 84*D1**2*fd*gd2*r*s - 42*D1**2*fd*gd2*r + 42*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*r + 44*D1*Dd*K*f**2*r*s - 11*D1*Dd*K*f**2*r - 11*D1*Dd*K*f**2*s - 144*D1*Dd*K*f*fd*r*s + 54*D1*Dd*K*f*fd*r + 54*D1*Dd*K*f*fd*s - 18*D1*Dd*K*f*fd - 168*D1*Dd*bd2*f*r*s + 21*D1*Dd*bd2*f*r + 21*D1*Dd*bd2*f*s + 84*D1*Dd*f**3*r*s - 21*D1*Dd*f**3*r - 21*D1*Dd*f**3*s - 360*D1*Dd*f**2*fd*r*s + 65*D1*Dd*f**2*fd*r + 105*D1*Dd*f**2*fd*s - 20*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r*s - 11*D1*Dd*f**2*r - 11*D1*Dd*f**2*s - 144*D1*Dd*f*fd*r*s + 54*D1*Dd*f*fd*r + 54*D1*Dd*f*fd*s - 18*D1*Dd*f*fd - 56*D1*Dd*f*g2*r*s + 14*D1*Dd*f*g2*r + 14*D1*Dd*f*g2*s + 336*D1*Dd*f*gd2*r*s - 42*D1*Dd*f*gd2*r - 42*D1*Dd*f*gd2*s + 336*D1*Dd*fd*g2*r*s - 210*D1*Dd*fd*g2*r - 42*D1*Dd*fd*g2*s + 42*D1*Dd*fd*g2 - 36*D1*Ddd*K*f**2*r*s + 9*D1*Ddd*K*f**2*r + 9*D1*Ddd*K*f**2*s - 60*D1*Ddd*f**3*r*s + 15*D1*Ddd*f**3*r + 15*D1*Ddd*f**3*s - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r + 9*D1*Ddd*f**2*s + 168*D1*Ddd*f*g2*r*s - 42*D1*Ddd*f*g2*r - 42*D1*Ddd*f*g2*s + D1*bd1*(D1*(f*(11*f*(8*r*s - 3*r - 3*s) + s*(7*K + 7)*(2*r - 1)) - 3*fd*(6*f*(4*r - 1)*(4*s - 1) + (7*K + 7)*(4*r*s - 2*r - s + 1))) - 3*Dd*f*(6*f*(32*r*s - 10*r - 10*s + 3) + (7*K + 7)*(16*r*s - 2*r - 6*s + 1))) - 108*Dd**2*K*f**2*r*s + 27*Dd**2*K*f**2*r + 27*Dd**2*K*f**2*s - 9*Dd**2*K*f**2 - 180*Dd**2*f**3*r*s + 45*Dd**2*f**3*r + 45*Dd**2*f**3*s - 15*Dd**2*f**3 - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r + 27*Dd**2*f**2*s - 9*Dd**2*f**2 + 504*Dd**2*f*g2*r*s - 126*Dd**2*f*g2*r - 126*Dd**2*f*g2*s + 42*Dd**2*f*g2 - 7*b2*(D1*Dd*(f*(-4*r*s + r + s) + 3*fd*(8*r*s - 5*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - r - s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1))) + b2*(D1*Dd*f*(11*f*(4*r*s - r - s) - 18*fd*(8*r*s - 3*r - 3*s + 1)) + 7*D1*bd1*(D1*(f*s*(r - 1) + 3*fd*(-2*r*s + r + s - 1)) - 3*Dd*f*(r*(8*s - 1) - 5*s + 1)) + D1*(D1*(11*f*fd*(r*(2*s - 1) - s) + 3*f*(-7*bdd1*s*(r - 1) + 3*fdd*(-2*r*s + r + s)) + 9*fd**2*(-2*r*s + r + s - 1)) + 9*Ddd*f**2*(-4*r*s + r + s)) - 9*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2) + D1**2*Pkd1*Pkd2*ct*(D1*(D1*bd1**2*(-3*f*r*(2*s - 1)*(7*K + 5*f + 7) + 70*g2*(2*r*s - r - s + 1)) + 42*D1*bdd1*f*g2*r*(s - 1) - 7*b2*(5*D1*bd1**2*(r*(2*s - 1) - s + 1) + 3*D1*bdd1*f*r*(s - 1) + bd1*(D1*(-f*r*(s - 1) + fd*(6*r*s - 3*r - 3*s + 3)) + 3*Dd*f*(r*(8*s - 5) - s + 1))) + 7*bd1*(D1*(f*r*(-6*bd2*s + 3*bd2 - 2*g2*s + 2*g2 + 12*gd2*s - 6*gd2) + 6*fd*g2*(2*r*s - r - s + 1)) + 6*Dd*f*g2*(r*(8*s - 5) - s + 1))) - 7*b1**3*(D1*Dd*(r*(-4*f*s + f + 3*fd*(8*s - 1) + (5*K + 5)*(4*s - 1)) + s*(-5*K + f - 3*fd - 5)) + D1*(-D1*r*s*(fd - 3*fdd) + Ddd*(r*(4*s - 1) - s)*(5*K + 3*f + 5)) + Dd**2*(5*K + 3*f + 5)*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(-105*D1**2*K*bdd1*r*s + 35*D1**2*K*bdd1*r + 35*D1**2*K*bdd1*s + 7*D1**2*K*fd*r*s - 7*D1**2*K*fd*s - 21*D1**2*K*fdd*r*s + 21*D1**2*K*fdd*s - 35*D1**2*bd2*r*s - 63*D1**2*bdd1*f*r*s + 21*D1**2*bdd1*f*r + 21*D1**2*bdd1*f*s - 105*D1**2*bdd1*r*s + 35*D1**2*bdd1*r + 35*D1**2*bdd1*s - 35*D1**2*bdd2*r*s + 18*D1**2*f*fd*r*s - 9*D1**2*f*fd*s - 30*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*s - 30*D1**2*fd**2*r*s + 15*D1**2*fd**2*s + 7*D1**2*fd*r*s - 7*D1**2*fd*s - 21*D1**2*fdd*r*s + 21*D1**2*fdd*s + 70*D1**2*gd2*r*s + 70*D1**2*gdd2*r*s + 28*D1*Dd*K*f*r*s - 7*D1*Dd*K*f*r - 7*D1*Dd*K*f*s - 168*D1*Dd*K*fd*r*s + 21*D1*Dd*K*fd*r + 105*D1*Dd*K*fd*s - 21*D1*Dd*K*fd - 280*D1*Dd*bd2*r*s + 35*D1*Dd*bd2*r + 35*D1*Dd*bd2*s + 36*D1*Dd*f**2*r*s - 9*D1*Dd*f**2*r - 9*D1*Dd*f**2*s - 240*D1*Dd*f*fd*r*s + 30*D1*Dd*f*fd*r + 90*D1*Dd*f*fd*s - 15*D1*Dd*f*fd + 28*D1*Dd*f*r*s - 7*D1*Dd*f*r - 7*D1*Dd*f*s - 168*D1*Dd*fd*r*s + 21*D1*Dd*fd*r + 105*D1*Dd*fd*s - 21*D1*Dd*fd + 280*D1*Dd*g2*r*s - 70*D1*Dd*g2*r - 70*D1*Dd*g2*s + 560*D1*Dd*gd2*r*s - 70*D1*Dd*gd2*r - 70*D1*Dd*gd2*s - 84*D1*Ddd*K*f*r*s + 21*D1*Ddd*K*f*r + 21*D1*Ddd*K*f*s - 60*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r + 15*D1*Ddd*f**2*s - 84*D1*Ddd*f*r*s + 21*D1*Ddd*f*r + 21*D1*Ddd*f*s + 280*D1*Ddd*g2*r*s - 70*D1*Ddd*g2*r - 70*D1*Ddd*g2*s + 7*D1*bd1*(D1*(r*(f*(3*s - 1) + fd*(3 - 18*s) - (5*K + 5)*(3*s - 1)) + s*(5*K - f + 3*fd + 5)) - Dd*(5*K + 3*f + 5)*(r*(24*s - 7) - 7*s + 2)) - 252*Dd**2*K*f*r*s + 63*Dd**2*K*f*r + 63*Dd**2*K*f*s - 21*Dd**2*K*f - 180*Dd**2*f**2*r*s + 45*Dd**2*f**2*r + 45*Dd**2*f**2*s - 15*Dd**2*f**2 - 252*Dd**2*f*r*s + 63*Dd**2*f*r + 63*Dd**2*f*s - 21*Dd**2*f + 840*Dd**2*g2*r*s - 210*Dd**2*g2*r - 210*Dd**2*g2*s + 70*Dd**2*g2 - 35*b2*(D1*Dd*(r*(4*s - 1) - s) + D1*Ddd*(r*(4*s - 1) - s) + Dd**2*(3*r*(4*s - 1) - 3*s + 1))) + b1*(-42*D1**2*K*bdd1*f*r*s + 21*D1**2*K*bdd1*f*r - 70*D1**2*b2*bdd1*r*s + 35*D1**2*b2*bdd1*r + 35*D1**2*b2*bdd1*s + 7*D1**2*b2*fd*r*s - 7*D1**2*b2*fd*s - 21*D1**2*b2*fdd*r*s + 21*D1**2*b2*fdd*s - 7*D1**2*bd1**2*(5*K + 3*f + 5)*(r*(6*s - 2) - 2*s + 1) + 7*D1**2*bd2*f*r*s - 42*D1**2*bd2*fd*r*s + 21*D1**2*bd2*fd*s - 30*D1**2*bdd1*f**2*r*s + 15*D1**2*bdd1*f**2*r - 42*D1**2*bdd1*f*r*s + 21*D1**2*bdd1*f*r + 140*D1**2*bdd1*g2*r*s - 70*D1**2*bdd1*g2*r - 70*D1**2*bdd1*g2*s - 21*D1**2*bdd2*f*r*s - 14*D1**2*f*gd2*r*s + 42*D1**2*f*gdd2*r*s - 14*D1**2*fd*g2*r*s + 14*D1**2*fd*g2*s + 84*D1**2*fd*gd2*r*s - 42*D1**2*fd*gd2*s + 42*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*s + 28*D1*Dd*b2*f*r*s - 7*D1*Dd*b2*f*r - 7*D1*Dd*b2*f*s - 168*D1*Dd*b2*fd*r*s + 21*D1*Dd*b2*fd*r + 105*D1*Dd*b2*fd*s - 21*D1*Dd*b2*fd - 168*D1*Dd*bd2*f*r*s + 21*D1*Dd*bd2*f*r + 21*D1*Dd*bd2*f*s - 56*D1*Dd*f*g2*r*s + 14*D1*Dd*f*g2*r + 14*D1*Dd*f*g2*s + 336*D1*Dd*f*gd2*r*s - 42*D1*Dd*f*gd2*r - 42*D1*Dd*f*gd2*s + 336*D1*Dd*fd*g2*r*s - 42*D1*Dd*fd*g2*r - 210*D1*Dd*fd*g2*s + 42*D1*Dd*fd*g2 - 84*D1*Ddd*b2*f*r*s + 21*D1*Ddd*b2*f*r + 21*D1*Ddd*b2*f*s + 168*D1*Ddd*f*g2*r*s - 42*D1*Ddd*f*g2*r - 42*D1*Ddd*f*g2*s + D1*bd1*(D1*(14*K*f*r*s - 7*K*f*r - 140*bd2*r*s + 35*bd2*r + 35*bd2*s + 18*f**2*r*s - 9*f**2*r + 14*f*r*s - 7*f*r - 3*fd*(5*f*(8*r*s - 2*r - 2*s + 1) + (7*K + 7)*(4*r*s - r - 2*s + 1)) + 140*g2*r*s - 70*g2*r - 70*g2*s + 280*gd2*r*s - 70*gd2*r - 70*gd2*s) + Dd*(-15*f**2*(16*r*s - 6*r - 2*s + 1) - 21*f*(K + 1)*(16*r*s - 6*r - 2*s + 1) + 140*g2*(8*r*s - 3*r - 3*s + 1)) - 35*b2*(D1*(2*r*s - r - s) + 2*Dd*(8*r*s - 3*r - 3*s + 1))) - 252*Dd**2*b2*f*r*s + 63*Dd**2*b2*f*r + 63*Dd**2*b2*f*s - 21*Dd**2*b2*f + 504*Dd**2*f*g2*r*s - 126*Dd**2*f*g2*r - 126*Dd**2*f*g2*s + 42*Dd**2*f*g2))/(105*d**2) + D1**2*Pkd1*Pkd2*f*k2*st**6*(11*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-6*r*s + r + 3*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 11*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + fd*r*(24*s - 7) - 3*fd*s + fd) - D1*(D1*r*(3*s - 1)*(2*f*fd - f*fdd - 2*fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(6*D1*Dd*f*(f*r*(4*s - 1) - f*s - fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(6*f*fd*(r*(4*s - 1) - s) + f*(-11*bdd1*s*(r - 1) + 3*fdd*(-4*r*s + r + s)) + fd**2*(r*(9 - 36*s) + 9*s - 3)) + 3*Ddd*f**2*(-4*r*s + r + s)) - 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1) + D1**2*Pkd1*Pkd2*k1*st**4*(-33*b1**2*(D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1*f*(D1*Dd*f*(4*f*(4*r*s - r - s) + fd*(-48*r*s + 14*r + 10*s - 3)) + 3*D1*bd1*(D1*(2*f*s*(2*r - 1) + fd*(-8*r*s + 2*r + 2*s - 1)) - Dd*f*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(2*f*fd*(r*(6*s - 2) - s) + f*(3*bdd1*s*(1 - 2*r) + fdd*(-6*r*s + 2*r + s)) + fd**2*(r*(4 - 12*s) + 2*s - 1)) + 2*Ddd*f**2*(-4*r*s + r + s)) - 2*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f**2*(33*D1**2*bd1**2*s*(1 - 2*r) + 10*D1*Dd*f*(f*r*(4*s - 1) - f*s - fd*(4*r - 1)*(4*s - 1)) + 11*D1*bd1*(D1*(2*f*s*(2*r - 1) + fd*(-12*r*s + 2*r + 4*s - 1)) - Dd*f*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(10*f*fd*(r*(4*s - 1) - s) + f*(11*bdd1*s*(1 - 2*r) + 5*fdd*(-4*r*s + r + s)) - 5*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(1155*d**2*k2) + D1**2*Pkd1*Pkd2*k1*st**2*(D1*f**2*(-9*D1*bd1**2*(r*(4*s - 2) - s + 1) - 5*D1*bdd1*f*r*(s - 1) - 5*bd1*(D1*(-2*f*r*(s - 1) + fd*r*(6*s - 3) - fd*s + fd) + Dd*f*(r*(8*s - 5) - s + 1))) - 21*b1**3*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1**2*(3*D1*Dd*f*(4*f*r*(4*s - 1) - 4*f*s - fd*(4*r - 1)*(8*s - 1)) + 7*D1*bd1*(D1*(f*r*(6*s - 2) - 2*f*s + fd*(-6*r*s + r + s)) + Dd*f*(r*(7 - 24*s) + 7*s - 2)) + D1*(7*D1*bdd1*f*(-3*r*s + r + s) + 3*D1*s*(4*r - 1)*(2*f*fd - f*fdd - fd**2) + 6*Ddd*f**2*(-4*r*s + r + s)) - 6*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + b1*f*(-21*D1**2*bd1**2*(r*(6*s - 2) - 2*s + 1) + 5*D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 3*r + 7*s - 1)) + 9*D1*bd1*(-D1*(2*f*(-4*r*s + 2*r + s) + fd*(4*r - 1)*(4*s - 1)) - Dd*f*(4*r - 1)*(8*s - 3)) + D1*(9*D1*bdd1*f*(r*(2 - 4*s) + s) + 5*D1*s*(3*r - 1)*(2*f*fd - f*fdd - 2*fd**2) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(315*d**2*k2) + D1**2*Pkd1*Pkd2*k2*st**4*(-3*D1**2*bd1**2*f**2*(r*(4*s - 1) - 2*s + 1) + D1**2*bdd1*f**3*r*(1 - 2*s) + D1*bd1*f*(-3*b1*(2*D1*f*(-4*r*s + r + 2*s) + D1*fd*(4*r - 1)*(4*s - 1) + Dd*f*(8*r - 3)*(4*s - 1)) - f*(D1*(2*f*r*(1 - 2*s) + 4*fd*r*(3*s - 1) - 2*fd*s + fd) + Dd*f*(2*r*(8*s - 3) - 2*s + 1))) - 3*b1**2*(D1*Dd*f*(4*f*(-4*r*s + r + s) + fd*(8*r - 1)*(4*s - 1)) - D1*(D1*r*(4*s - 1)*(2*f*fd - f*fdd - fd**2) + 2*Ddd*f**2*(-4*r*s + r + s)) + 2*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + b1*f*(D1*Dd*f*(4*f*(4*r*s - r - s) + fd*(-48*r*s + 10*r + 14*s - 3)) + D1*(D1*(2*f*fd*(r*(6*s - 1) - 2*s) + f*(3*bdd1*(-4*r*s + r + 2*s) + fdd*(-6*r*s + r + 2*s)) + fd**2*(r*(2 - 12*s) + 4*s - 1)) + 2*Ddd*f**2*(-4*r*s + r + s)) - 2*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1) + D1**2*Pkd1*Pkd2*k2*st**2*(3*D1**2*bd1**2*f**2*r*(1 - 2*s) + D1*b1*f*(-7*D1*bd1**2*(r*(6*s - 2) - 2*s + 1) + 3*D1*bdd1*f*r*(1 - 2*s) - 3*bd1*(D1*(2*f*r*(1 - 2*s) + fd*r*(8*s - 2) - 2*fd*s + fd) + Dd*f*(2*r*(8*s - 3) - 2*s + 1))) - 7*b1**3*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(3*D1*Dd*f*(2*f*(r*(4*s - 1) - s) + fd*(r*(2 - 16*s) + 6*s - 1)) + 7*D1*bd1*(D1*(f*r*(6*s - 2) - 2*f*s + fd*(-6*r*s + r + s)) + Dd*f*(r*(7 - 24*s) + 7*s - 2)) + D1*(7*D1*bdd1*f*(-3*r*s + r + s) + 3*D1*s*(2*r - 1)*(2*f*fd - f*fdd - fd**2) + 3*Ddd*f**2*(-4*r*s + r + s)) - 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(105*d**2*k1)
        perm13 = 4*D1**3*Pk1*Pk3*ct**5*f**2*k2**7*(9*D1*bd1*f*(r + s - 1)**2 + 9*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(21*d**2*k1*k3**8) - 4*D1**3*Pk1*Pk3*ct**4*k2**6*(7*b1**2*(D1*fd*(3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 5*K)*(r + s)**2) + Dd*f*(-5*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(14*D1*bd1*f*(-5*K + 3*f + 5)*(r + s - 1)**2 + D1*(-30*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 21*f*fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*f*gd2*(r + s - 1)**2 + 70*fd*g2*(r + s)**2) - Dd*f*(30*f**2 + 21*f*(K - 1) - 70*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(-D1*bd1*(30*f**2 + 21*f*(K - 1) - 70*g2)*(r + s - 1)**2 - 7*D1*(5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*f*gd2*(r + s - 1)**2 - 6*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 7*Dd*f*(5*f**2 - 6*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(35*d**2*k3**8) + 8*D1**3*Pk1*Pk3*ct**3*f**2*k2**7*st**2*(9*D1*bd1*f*(r + s - 1)**2 + 9*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 5*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(21*d**2*k1*k3**8) - 4*D1**3*Pk1*Pk3*ct**3*k1*k2**5*(b1**2*(D1*fd*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (15 - 20*K)*(r + s)**2) + Dd*f*(-20*K + 9*f + 15)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(2*D1*bd1*f*(-20*K + 9*f + 15)*(r + s - 1)**2 + D1*(-3*f*fd*(4*K - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*f*gd2*(r + s - 1)**2 + 40*fd*g2*(r + s)**2) - Dd*f*(3*f*(4*K - 3) - 40*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*bd1*(f*(9 - 12*K) + 40*g2)*(r + s - 1)**2 + D1*(-5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 24*f*gd2*(r + s - 1)**2 + 24*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(5*f**2 - 24*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(5*d**2*k3**8) + 4*D1**3*Pk1*Pk3*ct**3*k2**5*(7*b1**2*(D1*fd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s)*(-10*K*r + 15*r + 5*s)) + Dd*f*(-5*K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 60*r**2 + 80*r*s - 70*r + 20*s**2 - 40*s + 25)) + b1*(7*D1*bd1*f*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (r + s - 1)*(-10*K*(2*r - 1) + 30*r + 10*s - 20)) + D1*(15*f**2*fd*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - 7*f*(3*fd*(K*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 6*r**2 - 8*r*s + 6*r - 2*s**2 + 4*s - 3) - 20*gd2*r*(r + s - 1)) + 140*fd*g2*r*(r + s)) + Dd*f*(30*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 21*f*(K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 12*r**2 - 16*r*s + 14*r - 4*s**2 + 8*s - 5) + 140*g2*(4*r**2 + 4*r*(s - 1) - s + 1))) + f*(D1*bd1*(15*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 21*f*(r + s - 1)*(r*(2*K - 3) - s + 1) + 140*g2*(r - 1)*(r + s - 1)) + 84*D1*(f*gd2*r*(r + s - 1) + fd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 84*Dd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)))/(105*d**2*k1*k3**6) - 4*D1**3*Pk1*Pk3*ct**2*k1**2*k2**4*(63*b1**2*(D1*fd*(3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 10*K)*(r + s)**2) + Dd*f*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 9*b1*(14*D1*bd1*f*(-10*K + 3*f + 5)*(r + s - 1)**2 + D1*(10*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 7*f*(3*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 20*gd2*(r + s - 1)**2) + 140*fd*g2*(r + s)**2) + Dd*f*(10*f**2 + f*(21 - 42*K) + 140*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(9*D1*bd1*(10*f**2 + f*(21 - 42*K) + 140*g2)*(r + s - 1)**2 - 7*D1*(5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 108*f*gd2*(r + s - 1)**2 - 108*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 7*Dd*f*(5*f**2 - 108*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(105*d**2*k3**8) - 4*D1**3*Pk1*Pk3*ct**2*k2**6*st**2*(7*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 5*K)*(r + s)**2) + Dd*f*(-5*K + 6*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(14*D1*bd1*f*(-5*K + 6*f + 5)*(r + s - 1)**2 + D1*(-36*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 7*f*fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*f*gd2*(r + s - 1)**2 + 70*fd*g2*(r + s)**2) - Dd*f*(36*f**2 + 7*f*(K - 1) - 70*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(-D1*bd1*(36*f**2 + 7*f*(K - 1) - 70*g2)*(r + s - 1)**2 - 2*D1*(15*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*f*gd2*(r + s - 1)**2 - 7*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd*f*(15*f**2 - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(35*d**2*k3**8) - 4*D1**3*Pk1*Pk3*ct**2*k2**4*(35*b1**3*(D1*fd*(r + s - 1)**2 + Dd*(-3*K + f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*b1**2*(5*D1*bd1*(-3*K + f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*(-6*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*fd*(-K*(6*r**2 + r*(6*s + 2) + 2*s - 1) + 6*r**2 + r*(7*s + 2) + s**2 + 2*s - 1) + 30*gd2*(r + s - 1)**2) + Dd*(-6*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*f*(6*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 24*r**2 - 28*r*s + 26*r - 4*s**2 + 11*s - 8) + 30*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) - b1*(-294*D1*K*f*fd*r**2 - 336*D1*K*f*fd*r*s + 294*D1*K*f*fd*r - 42*D1*K*f*fd*s**2 + 168*D1*K*f*fd*s - 147*D1*K*f*fd - 35*D1*b2*fd*r**2 - 70*D1*b2*fd*r*s - 35*D1*b2*fd*s**2 + 7*D1*bd1*(12*f**2*(r + s - 1)**2 - 5*f*(K*(12*r**2 + 4*r*(3*s - 5) - 8*s + 7) - 12*r**2 - 14*r*s + 21*r - 2*s**2 + 11*s - 8) - 30*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 35*D1*bd2*f*(r + s - 1)**2 + 135*D1*f**2*fd*r**2 + 270*D1*f**2*fd*r*s - 210*D1*f**2*fd*r + 135*D1*f**2*fd*s**2 - 210*D1*f**2*fd*s + 105*D1*f**2*fd + 294*D1*f*fd*r**2 + 378*D1*f*fd*r*s - 294*D1*f*fd*r + 84*D1*f*fd*s**2 - 189*D1*f*fd*s + 147*D1*f*fd + 420*D1*f*gd2*r**2 + 420*D1*f*gd2*r*s - 420*D1*f*gd2*r + 420*D1*fd*g2*r**2 + 420*D1*fd*g2*r*s + 140*D1*fd*g2*r + 140*D1*fd*g2*s - 70*D1*fd*g2 - 588*Dd*K*f**2*r**2 - 672*Dd*K*f**2*r*s + 630*Dd*K*f**2*r - 84*Dd*K*f**2*s**2 + 252*Dd*K*f**2*s - 189*Dd*K*f**2 - 140*Dd*b2*f*r**2 - 280*Dd*b2*f*r*s + 210*Dd*b2*f*r - 140*Dd*b2*f*s**2 + 210*Dd*b2*f*s - 105*Dd*b2*f + 180*Dd*f**3*r**2 + 360*Dd*f**3*r*s - 270*Dd*f**3*r + 180*Dd*f**3*s**2 - 270*Dd*f**3*s + 135*Dd*f**3 + 588*Dd*f**2*r**2 + 756*Dd*f**2*r*s - 672*Dd*f**2*r + 168*Dd*f**2*s**2 - 357*Dd*f**2*s + 231*Dd*f**2 + 1680*Dd*f*g2*r**2 + 1680*Dd*f*g2*r*s - 1680*Dd*f*g2*r - 420*Dd*f*g2*s + 420*Dd*f*g2) + f*(-D1*bd1*(15*f**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 21*f*(r + s - 1)*(K*(7*r + s - 1) - 7*r - 2*s + 2) + 70*g2*(6*r**2 + 2*r*(3*s - 7) - 8*s + 7)) + 21*D1*bd2*f*(r + s - 1)**2 - 42*D1*(f*gd2*(7*r**2 + 8*r*(s - 1) + (s - 1)**2) + fd*g2*(14*r**2 + 2*r*(8*s - 7) + 2*s**2 - 8*s + 7)) - 42*Dd*f*g2*(28*r**2 + r*(32*s - 30) + (3 - 2*s)**2) + 7*b2*(5*D1*bd1*(r + s - 1)**2 + 3*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(105*d**2*k3**6) + D1**3*Pk1*Pk3*ct**2*k2**4*(5*b1**2*(D1*fd*r*(r*(K - 3) - 2*s) + Dd*f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3)) + b1*(5*D1*bd1*f*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 8*r + 2*s - 3) + D1*(3*f*fd*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 6*r + 2*s - 3) - 10*f*gd2*r**2 - 10*fd*g2*r**2) + Dd*f*(3*f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3) - 10*g2*(4*r**2 - 2*r + 1))) + f*(D1*bd1*(3*f*r*(r*(K - 3) - 2*s + 2) - 10*g2*(r - 1)**2) - 6*D1*f*gd2*r**2 - 6*D1*fd*g2*(2*r**2 - 2*r + 1) - 6*Dd*f*g2*(4*r**2 - 2*r + 1)))/(15*d**2*k1**2*k3**4) + 4*D1**3*Pk1*Pk3*ct*f**2*k2**7*st**4*(3*D1*bd1*f*(r + s - 1)**2 + 3*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(7*d**2*k1*k3**8) - 4*D1**3*Pk1*Pk3*ct*k1**3*k2**3*(7*b1**2*(D1*fd*(3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 20*K)*(r + s)**2) + Dd*f*(-20*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(14*D1*bd1*f*(-20*K + 3*f + 5)*(r + s - 1)**2 + D1*(15*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 7*f*(3*fd*(4*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 40*gd2*(r + s - 1)**2) + 280*fd*g2*(r + s)**2) + Dd*f*(15*f**2 + f*(21 - 84*K) + 280*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*bd1*(15*f**2 + f*(21 - 84*K) + 280*g2)*(r + s - 1)**2 + 168*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 168*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(35*d**2*k3**8) - 4*D1**3*Pk1*Pk3*ct*k1*k2**5*st**2*(7*b1**2*(D1*fd*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 10*K)*(r + s)**2) + Dd*f*(-10*K + 9*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*b1*(2*D1*bd1*f*(-10*K + 9*f + 5)*(r + s - 1)**2 + D1*(-f*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*f*gd2*(r + s - 1)**2 + 20*fd*g2*(r + s)**2) - Dd*f*(f*(2*K - 1) - 20*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(7*D1*bd1*(r + s - 1)**2*(-2*K*f + f + 20*g2) + D1*(-15*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 28*f*gd2*(r + s - 1)**2 + 28*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(15*f**2 - 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(35*d**2*k3**8) - 4*D1**3*Pk1*Pk3*ct*k1*k2**3*(35*b1**3*(D1*fd*(r + s - 1)**2 + Dd*(-6*K + f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*b1**2*(5*D1*bd1*(-6*K + f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*(f*fd*(-6*r - 6*s + 3) + 5*fd*(K*(6*r**2 + r*(6*s + 4) + 4*s - 2) - 4*r**2 - 2*r*(2*s + 1) - 2*s + 1) + 60*gd2*(r + s - 1)**2) + 10*Dd*(f*(3*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1*(336*D1*K*f*fd*r**2 + 420*D1*K*f*fd*r*s - 336*D1*K*f*fd*r + 84*D1*K*f*fd*s**2 - 210*D1*K*f*fd*s + 168*D1*K*f*fd + 70*D1*b2*fd*r**2 + 140*D1*b2*fd*r*s + 70*D1*b2*fd*s**2 + 7*D1*bd1*(f**2*(6*r + 6*s - 3) + 5*f*(2*K*(6*r**2 + 6*r*s - 11*r - 5*s + 4) - 8*r**2 - 8*r*s + 14*r + 6*s - 5) + 60*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 70*D1*bd2*f*(r + s - 1)**2 - 45*D1*f**2*fd*r**2 - 90*D1*f**2*fd*r*s + 60*D1*f**2*fd*r - 45*D1*f**2*fd*s**2 + 60*D1*f**2*fd*s - 30*D1*f**2*fd - 210*D1*f*fd*r**2 - 252*D1*f*fd*r*s + 210*D1*f*fd*r - 42*D1*f*fd*s**2 + 126*D1*f*fd*s - 105*D1*f*fd - 420*D1*f*gd2*r**2 - 420*D1*f*gd2*r*s + 420*D1*f*gd2*r - 420*D1*fd*g2*r**2 - 420*D1*fd*g2*r*s - 280*D1*fd*g2*r - 280*D1*fd*g2*s + 140*D1*fd*g2 + 672*Dd*K*f**2*r**2 + 840*Dd*K*f**2*r*s - 756*Dd*K*f**2*r + 168*Dd*K*f**2*s**2 - 378*Dd*K*f**2*s + 252*Dd*K*f**2 + 280*Dd*b2*f*r**2 + 560*Dd*b2*f*r*s - 420*Dd*b2*f*r + 280*Dd*b2*f*s**2 - 420*Dd*b2*f*s + 210*Dd*b2*f - 60*Dd*f**3*r**2 - 120*Dd*f**3*r*s + 90*Dd*f**3*r - 60*Dd*f**3*s**2 + 90*Dd*f**3*s - 45*Dd*f**3 - 420*Dd*f**2*r**2 - 504*Dd*f**2*r*s + 462*Dd*f**2*r - 84*Dd*f**2*s**2 + 210*Dd*f**2*s - 147*Dd*f**2 - 1680*Dd*f*g2*r**2 - 1680*Dd*f*g2*r*s + 1680*Dd*f*g2*r + 420*Dd*f*g2*s - 420*Dd*f*g2) + f*(-D1*bd1*(15*f**2*(r + s - 1)**2 - 21*f*(r + s - 1)*(2*K*(4*r + s - 1) - 5*r - s + 1) + 140*g2*(3*r**2 + r*(3*s - 8) - 5*s + 4)) + 42*D1*bd2*f*(r + s - 1)**2 - 84*D1*(f*gd2*(4*r**2 + 5*r*(s - 1) + (s - 1)**2) + fd*g2*(8*r**2 + 2*r*(5*s - 4) + 2*s**2 - 5*s + 4)) - 84*Dd*f*g2*(16*r**2 + 2*r*(10*s - 9) + 4*s**2 - 9*s + 6) + 14*b2*(5*D1*bd1*(r + s - 1)**2 + 3*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(105*d**2*k3**6) + 4*D1**3*Pk1*Pk3*ct*k2**5*st**2*(7*b1**2*(D1*fd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s)*(-10*K*r + 15*r + 5*s)) + Dd*f*(-5*K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 60*r**2 + 80*r*s - 70*r + 20*s**2 - 40*s + 25)) + b1*(7*D1*bd1*f*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (r + s - 1)*(-10*K*(2*r - 1) + 30*r + 10*s - 20)) + D1*(9*f**2*fd*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - 7*f*(fd*(K*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 6*r**2 - 8*r*s + 6*r - 2*s**2 + 4*s - 3) - 20*gd2*r*(r + s - 1)) + 140*fd*g2*r*(r + s)) + Dd*f*(18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*f*(K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 12*r**2 - 16*r*s + 14*r - 4*s**2 + 8*s - 5) + 140*g2*(4*r**2 + 4*r*(s - 1) - s + 1))) + f*(D1*bd1*(9*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*f*(r + s - 1)*(r*(2*K - 3) - s + 1) + 140*g2*(r - 1)*(r + s - 1)) + 28*D1*(f*gd2*r*(r + s - 1) + fd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 28*Dd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)))/(105*d**2*k1*k3**6) - 2*D1**3*Pk1*Pk3*ct*k2**3*(30*Dd*b1**3*(K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + 5*b1**2*(6*D1*bd1*(K - 1)*(3*r**2 + 3*r*(s - 1) - s + 1) + D1*fd*(K*(r**2 + 2*r*(s - 2) - 2*s + 2) + r**2 + 4*r + 2*s - 2) - 12*D1*gd2*r*(r + s - 1) + Dd*f*(K*(4*r**2 + 8*r*s - 6*r - 2*s + 1) + 4*r**2 - 2*r + 1) - 12*Dd*g2*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*(5*D1*bd1*(f*(K*(2*r**2 + 4*r*s - 1) + 2*r**2 - 6*r - 2*s + 3) - 12*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - D1*(f*(3*fd*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 6*r + 2*s - 3) + 10*gd2*r*(r + 2*s - 2)) + 10*fd*g2*(r**2 + 2*r*(s - 2) - 2*s + 2)) + Dd*f*(-3*f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3) - 10*g2*(4*r**2 + 8*r*s - 6*r - 2*s + 1))) + f*(-D1*bd1*(3*f*r*(r*(K - 3) - 2*s + 2) + 10*g2*(r**2 + 2*r*(s + 1) - 1)) + 6*D1*f*gd2*r**2 + 6*D1*fd*g2*(2*r**2 - 2*r + 1) + 6*Dd*f*g2*(4*r**2 - 2*r + 1)))/(15*d**2*k1*k3**4) + 12*D1**3*Pk1*Pk3*f*k2**6*st**4*(-7*b1**2*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*b1*f*(-7*D1*bd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + f**2*(2*D1*bd1*(r + s - 1)**2 + (D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(35*d**2*k3**8) + 4*D1**3*Pk1*Pk3*k1**4*k2**2*(D1*bd1*f*(r + s - 1)**2*(10*K*b1 + 3*K*f - 10*g2) + 5*K*b1**2*(D1*fd*(r + s)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(-D1*(-3*K*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*f*gd2*(r + s - 1)**2 + 10*fd*g2*(r + s)**2) + Dd*f*(3*K*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*f*(D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(5*d**2*k3**8) - 4*D1**3*Pk1*Pk3*k1**2*k2**4*st**2*(21*b1**2*(D1*fd*(-5*K*(r + s)**2 + 3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(-5*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 3*b1*(14*D1*bd1*f*(-5*K + 3*f)*(r + s - 1)**2 + D1*(-7*K*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 70*f*gd2*(r + s - 1)**2 + 70*fd*g2*(r + s)**2) + Dd*f*(-7*K*f + 6*f**2 + 70*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(3*D1*bd1*(r + s - 1)**2*(-7*K*f + 6*f**2 + 70*g2) + D1*(-5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 42*f*gd2*(r + s - 1)**2 + 42*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(5*f**2 - 42*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(105*d**2*k3**8) - 4*D1**3*Pk1*Pk3*k1**2*k2**2*(-15*Dd*K*b1**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*b1**2*(D1*(-3*K*bd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(K*(2*r**2 + 2*r*(s + 1) + 2*s - 1) - r*(r + s)) + 6*gd2*(r + s - 1)**2) + Dd*f*(2*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*Dd*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(18*D1*K*f*fd*r**2 + 24*D1*K*f*fd*r*s - 18*D1*K*f*fd*r + 6*D1*K*f*fd*s**2 - 12*D1*K*f*fd*s + 9*D1*K*f*fd + 5*D1*b2*fd*r**2 + 10*D1*b2*fd*r*s + 5*D1*b2*fd*s**2 + 5*D1*bd1*(f*(K*(4*r**2 + 4*r*(s - 2) - 4*s + 3) - (2*r - 1)*(r + s - 1)) + 6*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 5*D1*bd2*f*(r + s - 1)**2 - 6*D1*f*fd*r**2 - 6*D1*f*fd*r*s + 6*D1*f*fd*r + 3*D1*f*fd*s - 3*D1*f*fd - 20*D1*f*gd2*r**2 - 20*D1*f*gd2*r*s + 20*D1*f*gd2*r - 20*D1*fd*g2*r**2 - 20*D1*fd*g2*r*s - 20*D1*fd*g2*r - 20*D1*fd*g2*s + 10*D1*fd*g2 + 36*Dd*K*f**2*r**2 + 48*Dd*K*f**2*r*s - 42*Dd*K*f**2*r + 12*Dd*K*f**2*s**2 - 24*Dd*K*f**2*s + 15*Dd*K*f**2 + 20*Dd*b2*f*r**2 + 40*Dd*b2*f*r*s - 30*Dd*b2*f*r + 20*Dd*b2*f*s**2 - 30*Dd*b2*f*s + 15*Dd*b2*f - 12*Dd*f**2*r**2 - 12*Dd*f**2*r*s + 12*Dd*f**2*r + 3*Dd*f**2*s - 3*Dd*f**2 - 80*Dd*f*g2*r**2 - 80*Dd*f*g2*r*s + 80*Dd*f*g2*r + 20*Dd*f*g2*s - 20*Dd*f*g2) + f*(9*D1*K*bd1*f*r**2 + 12*D1*K*bd1*f*r*s - 12*D1*K*bd1*f*r + 3*D1*K*bd1*f*s**2 - 6*D1*K*bd1*f*s + 3*D1*K*bd1*f - 3*D1*bd1*f*r**2 - 3*D1*bd1*f*r*s + 3*D1*bd1*f*r - 20*D1*bd1*g2*r**2 - 20*D1*bd1*g2*r*s + 60*D1*bd1*g2*r + 40*D1*bd1*g2*s - 30*D1*bd1*g2 + 3*D1*bd2*f*(r + s - 1)**2 - 18*D1*f*gd2*r**2 - 24*D1*f*gd2*r*s + 24*D1*f*gd2*r - 6*D1*f*gd2*s**2 + 12*D1*f*gd2*s - 6*D1*f*gd2 - 36*D1*fd*g2*r**2 - 48*D1*fd*g2*r*s + 36*D1*fd*g2*r - 12*D1*fd*g2*s**2 + 24*D1*fd*g2*s - 18*D1*fd*g2 - 72*Dd*f*g2*r**2 - 96*Dd*f*g2*r*s + 84*Dd*f*g2*r - 24*Dd*f*g2*s**2 + 48*Dd*f*g2*s - 30*Dd*f*g2 + b2*(5*D1*bd1*(r + s - 1)**2 + 3*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(15*d**2*k3**6) - 4*D1**3*Pk1*Pk3*k2**4*st**2*(35*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*b1**2*(5*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(-2*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + (5*r + 5*s)*(3*K*r + K*s - r)) + Dd*f*(5*K*(12*r**2 + 2*r*(8*s - 7) + 4*s**2 - 8*s + 5) - 2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 20*r**2 - 20*r*s + 20*r + 5*s - 5)) - b1*(-42*D1*K*f*fd*r**2 - 56*D1*K*f*fd*r*s + 42*D1*K*f*fd*r - 14*D1*K*f*fd*s**2 + 28*D1*K*f*fd*s - 21*D1*K*f*fd - 35*D1*b2*fd*r**2 - 70*D1*b2*fd*r*s - 35*D1*b2*fd*s**2 + 7*D1*bd1*f*(r + s - 1)*(-10*K*(3*r + s - 2) + 4*f*(r + s - 1) + 10*r - 5) - 35*D1*bd2*f*(r + s - 1)**2 + 27*D1*f**2*fd*r**2 + 54*D1*f**2*fd*r*s - 42*D1*f**2*fd*r + 27*D1*f**2*fd*s**2 - 42*D1*f**2*fd*s + 21*D1*f**2*fd + 14*D1*f*fd*r**2 + 14*D1*f*fd*r*s - 14*D1*f*fd*r - 7*D1*f*fd*s + 7*D1*f*fd + 210*D1*f*gd2*r**2 + 280*D1*f*gd2*r*s - 280*D1*f*gd2*r + 70*D1*f*gd2*s**2 - 140*D1*f*gd2*s + 70*D1*f*gd2 + 210*D1*fd*g2*r**2 + 280*D1*fd*g2*r*s + 70*D1*fd*g2*s**2 - 84*Dd*K*f**2*r**2 - 112*Dd*K*f**2*r*s + 98*Dd*K*f**2*r - 28*Dd*K*f**2*s**2 + 56*Dd*K*f**2*s - 35*Dd*K*f**2 - 140*Dd*b2*f*r**2 - 280*Dd*b2*f*r*s + 210*Dd*b2*f*r - 140*Dd*b2*f*s**2 + 210*Dd*b2*f*s - 105*Dd*b2*f + 36*Dd*f**3*r**2 + 72*Dd*f**3*r*s - 54*Dd*f**3*r + 36*Dd*f**3*s**2 - 54*Dd*f**3*s + 27*Dd*f**3 + 28*Dd*f**2*r**2 + 28*Dd*f**2*r*s - 28*Dd*f**2*r - 7*Dd*f**2*s + 7*Dd*f**2 + 840*Dd*f*g2*r**2 + 1120*Dd*f*g2*r*s - 980*Dd*f*g2*r + 280*Dd*f*g2*s**2 - 560*Dd*f*g2*s + 350*Dd*f*g2) + f*(21*D1*K*bd1*f*r**2 + 28*D1*K*bd1*f*r*s - 28*D1*K*bd1*f*r + 7*D1*K*bd1*f*s**2 - 14*D1*K*bd1*f*s + 7*D1*K*bd1*f - 9*D1*bd1*f**2*r**2 - 18*D1*bd1*f**2*r*s + 12*D1*bd1*f**2*r - 9*D1*bd1*f**2*s**2 + 12*D1*bd1*f**2*s - 6*D1*bd1*f**2 - 7*D1*bd1*f*r**2 - 7*D1*bd1*f*r*s + 7*D1*bd1*f*r - 210*D1*bd1*g2*r**2 - 280*D1*bd1*g2*r*s + 420*D1*bd1*g2*r - 70*D1*bd1*g2*s**2 + 280*D1*bd1*g2*s - 210*D1*bd1*g2 + 7*D1*bd2*f*(r + s - 1)**2 - 42*D1*f*gd2*r**2 - 56*D1*f*gd2*r*s + 56*D1*f*gd2*r - 14*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 14*D1*f*gd2 - 84*D1*fd*g2*r**2 - 112*D1*fd*g2*r*s + 84*D1*fd*g2*r - 28*D1*fd*g2*s**2 + 56*D1*fd*g2*s - 42*D1*fd*g2 - 168*Dd*f*g2*r**2 - 224*Dd*f*g2*r*s + 196*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 112*Dd*f*g2*s - 70*Dd*f*g2 + 7*b2*(5*D1*bd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))))/(105*d**2*k3**6) + D1**3*Pk1*Pk3*k2**2*(-30*Dd*b1**3*(2*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*b1**2*(6*D1*bd1*(2*K - 1)*(3*r**2 + 3*r*(s - 1) - s + 1) + D1*fd*(K*(3*r**2 + 4*r*(s - 2) - 4*s + 4) + r**2 + 4*r + 2*s - 2) - 24*D1*gd2*r*(r + s - 1) + Dd*f*(K*(12*r**2 + 2*r*(8*s - 7) - 4*s + 3) + 4*r**2 - 2*r + 1) - 24*Dd*g2*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*(-5*D1*bd1*(f*(K*(6*r**2 + 8*r*s - 2*r - 1) + 2*r**2 - 6*r - 2*s + 3) - 24*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + D1*(f*(3*fd*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 6*r + 2*s - 3) + 10*gd2*r*(3*r + 4*s - 4)) + 10*fd*g2*(3*r**2 + 4*r*(s - 2) - 4*s + 4)) + Dd*f*(3*f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3) + 10*g2*(12*r**2 + 2*r*(8*s - 7) - 4*s + 3))) + f*(D1*bd1*(3*f*r*(r*(K - 3) - 2*s + 2) + 10*g2*(3*r**2 + r*(4*s + 2) - 1)) - 6*D1*f*gd2*r**2 - 6*D1*fd*g2*(2*r**2 - 2*r + 1) - 6*Dd*f*g2*(4*r**2 - 2*r + 1)))/(15*d**2*k3**4) + D1**3*Pk1*Pk3*k2**4*st**2*(5*b1**2*(D1*fd*r*(r*(K - 3) - 2*s) + Dd*f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3)) + b1*(5*D1*bd1*f*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 8*r + 2*s - 3) + D1*(f*fd*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 6*r + 2*s - 3) - 10*f*gd2*r**2 - 10*fd*g2*r**2) + Dd*f*(f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3) - 10*g2*(4*r**2 - 2*r + 1))) + f*(D1*bd1*(f*r*(r*(K - 3) - 2*s + 2) - 10*g2*(r - 1)**2) - 2*D1*f*gd2*r**2 - 2*D1*fd*g2*(2*r**2 - 2*r + 1) - 2*Dd*f*g2*(4*r**2 - 2*r + 1)))/(15*d**2*k1**2*k3**4) + D1**3*Pk1*Pk3*k2**2*(-2*D1*bd1*f*g2*r**2 + 3*Dd*b1**3*(K - 1)*(4*r**2 - 2*r + 1) + b1**2*(3*D1*bd1*(K - 1)*(3*r**2 - 2*r + 1) + D1*(fd*(K - 1)*(r - 1)**2 - 6*gd2*r**2) + Dd*(f*(K - 1) - 6*g2)*(4*r**2 - 2*r + 1)) - 2*b1*(D1*bd1*(-f*r**2*(K - 1) + g2*(6*r**2 - 6*r + 3)) + D1*(f*gd2*r**2 + fd*g2*(r - 1)**2) + Dd*f*g2*(4*r**2 - 2*r + 1)))/(3*d**2*k1**2*k3**2) + D1**3*Pk1*Pkd3*b1*k2**2*(D1*bd1*f*r*(2*r + 2*s - 1) + 3*Dd*b1**2*(4*r**2 + 4*r*(s - 1) - s + 1) + b1*(3*D1*bd1*(3*r**2 + 3*r*(s - 1) - s + 1) + D1*fd*(r - 1)*(r + s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)))/(3*d**2*k1**2*k3) - D1**3*Pk1*Pkd3*ct**5*f**2*k2**7*(9*D1*bd1*f*(r + s - 1)**2 + 9*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(14*d**2*k1*k3**7) + 3*D1**3*Pk1*Pkd3*ct**4*k2**6*(7*b1**2*(D1*fd*(3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 5*K)*(r + s)**2) + Dd*f*(-5*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(14*D1*bd1*f*(-5*K + 3*f + 5)*(r + s - 1)**2 + D1*(-30*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 21*f*fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*f*gd2*(r + s - 1)**2 + 70*fd*g2*(r + s)**2) - Dd*f*(30*f**2 + 21*f*(K - 1) - 70*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(-D1*bd1*(30*f**2 + 21*f*(K - 1) - 70*g2)*(r + s - 1)**2 - 7*D1*(5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*f*gd2*(r + s - 1)**2 - 6*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 7*Dd*f*(5*f**2 - 6*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(70*d**2*k3**7) - D1**3*Pk1*Pkd3*ct**3*f**2*k2**7*st**2*(9*D1*bd1*f*(r + s - 1)**2 + 9*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 5*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(7*d**2*k1*k3**7) + 3*D1**3*Pk1*Pkd3*ct**3*k1*k2**5*(b1**2*(D1*fd*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (15 - 20*K)*(r + s)**2) + Dd*f*(-20*K + 9*f + 15)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(2*D1*bd1*f*(-20*K + 9*f + 15)*(r + s - 1)**2 + D1*(-3*f*fd*(4*K - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*f*gd2*(r + s - 1)**2 + 40*fd*g2*(r + s)**2) - Dd*f*(3*f*(4*K - 3) - 40*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*bd1*(f*(9 - 12*K) + 40*g2)*(r + s - 1)**2 + D1*(-5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 24*f*gd2*(r + s - 1)**2 + 24*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(5*f**2 - 24*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(10*d**2*k3**7) - D1**3*Pk1*Pkd3*ct**3*k2**5*(35*b1**2*(D1*fd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - (r + s)*(r*(4*K - 9) - 5*s)) + Dd*f*(-4*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 36*r**2 + 56*r*s - 46*r + 20*s**2 - 34*s + 19)) + b1*(35*D1*bd1*f*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (r + s - 1)*(-2*K*(4*r - 2) + 18*r + 10*s - 14)) + D1*(75*f**2*fd*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - 7*f*(3*fd*(K*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 18*r**2 - 28*r*s + 18*r - 10*s**2 + 14*s - 9) - 40*gd2*r*(r + s - 1)) + 280*fd*g2*r*(r + s)) + Dd*f*(150*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 21*f*(4*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 36*r**2 - 56*r*s + 46*r - 20*s**2 + 34*s - 19) + 280*g2*(4*r**2 + 4*r*(s - 1) - s + 1))) + f*(D1*bd1*(75*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 21*f*(r + s - 1)*(r*(4*K - 9) - 5*s + 5) + 280*g2*(r - 1)*(r + s - 1)) + 168*D1*(f*gd2*r*(r + s - 1) + fd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 168*Dd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)))/(210*d**2*k1*k3**5) + D1**3*Pk1*Pkd3*ct**2*k1**2*k2**4*(63*b1**2*(D1*fd*(3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 10*K)*(r + s)**2) + Dd*f*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 9*b1*(14*D1*bd1*f*(-10*K + 3*f + 5)*(r + s - 1)**2 + D1*(10*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 7*f*(3*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 20*gd2*(r + s - 1)**2) + 140*fd*g2*(r + s)**2) + Dd*f*(10*f**2 + f*(21 - 42*K) + 140*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(9*D1*bd1*(10*f**2 + f*(21 - 42*K) + 140*g2)*(r + s - 1)**2 - 7*D1*(5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 108*f*gd2*(r + s - 1)**2 - 108*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 7*Dd*f*(5*f**2 - 108*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(70*d**2*k3**7) + 3*D1**3*Pk1*Pkd3*ct**2*k2**6*st**2*(7*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 5*K)*(r + s)**2) + Dd*f*(-5*K + 6*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(14*D1*bd1*f*(-5*K + 6*f + 5)*(r + s - 1)**2 + D1*(-36*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 7*f*fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*f*gd2*(r + s - 1)**2 + 70*fd*g2*(r + s)**2) - Dd*f*(36*f**2 + 7*f*(K - 1) - 70*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(-D1*bd1*(36*f**2 + 7*f*(K - 1) - 70*g2)*(r + s - 1)**2 - 2*D1*(15*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*f*gd2*(r + s - 1)**2 - 7*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd*f*(15*f**2 - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(70*d**2*k3**7) + D1**3*Pk1*Pkd3*ct**2*k2**4*(175*b1**3*(D1*fd*(r + s - 1)**2 + Dd*(-3*K + f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 35*b1**2*(5*D1*bd1*(-3*K + f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - D1*fd*(-K*(12*r**2 + 2*r*(6*s + 5) + 10*s - 5) + 6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 15*r**2 + 5*r*(4*s + 2) + 5*s**2 + 10*s - 5) + 30*D1*gd2*(r + s - 1)**2 - 6*Dd*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + Dd*f*(12*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 60*r**2 - 10*r*(8*s - 7) - 20*s**2 + 40*s - 25) + 30*Dd*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - b1*(-714*D1*K*f*fd*r**2 - 924*D1*K*f*fd*r*s + 714*D1*K*f*fd*r - 210*D1*K*f*fd*s**2 + 462*D1*K*f*fd*s - 357*D1*K*f*fd - 175*D1*b2*fd*r**2 - 350*D1*b2*fd*r*s - 175*D1*b2*fd*s**2 + 35*D1*bd1*(12*f**2*(r + s - 1)**2 + f*(K*(-24*r**2 - 24*r*s + 46*r + 22*s - 17) + 30*r**2 + 40*r*s - 60*r + 10*s**2 - 40*s + 25) - 30*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 175*D1*bd2*f*(r + s - 1)**2 + 675*D1*f**2*fd*r**2 + 1350*D1*f**2*fd*r*s - 1050*D1*f**2*fd*r + 675*D1*f**2*fd*s**2 - 1050*D1*f**2*fd*s + 525*D1*f**2*fd + 840*D1*f*fd*r**2 + 1260*D1*f*fd*r*s - 840*D1*f*fd*r + 420*D1*f*fd*s**2 - 630*D1*f*fd*s + 420*D1*f*fd + 840*D1*f*gd2*r**2 + 840*D1*f*gd2*r*s - 840*D1*f*gd2*r + 840*D1*fd*g2*r**2 + 840*D1*fd*g2*r*s + 700*D1*fd*g2*r + 700*D1*fd*g2*s - 350*D1*fd*g2 - 1428*Dd*K*f**2*r**2 - 1848*Dd*K*f**2*r*s + 1638*Dd*K*f**2*r - 420*Dd*K*f**2*s**2 + 882*Dd*K*f**2*s - 567*Dd*K*f**2 - 700*Dd*b2*f*r**2 - 1400*Dd*b2*f*r*s + 1050*Dd*b2*f*r - 700*Dd*b2*f*s**2 + 1050*Dd*b2*f*s - 525*Dd*b2*f + 900*Dd*f**3*r**2 + 1800*Dd*f**3*r*s - 1350*Dd*f**3*r + 900*Dd*f**3*s**2 - 1350*Dd*f**3*s + 675*Dd*f**3 + 1680*Dd*f**2*r**2 + 2520*Dd*f**2*r*s - 2100*Dd*f**2*r + 840*Dd*f**2*s**2 - 1470*Dd*f**2*s + 840*Dd*f**2 + 3360*Dd*f*g2*r**2 + 3360*Dd*f*g2*r*s - 3360*Dd*f*g2*r - 840*Dd*f*g2*s + 840*Dd*f*g2) + f*(-D1*bd1*(75*f**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 21*f*(r + s - 1)*(K*(17*r + 5*s - 5) - 20*r - 10*s + 10) + 70*g2*(12*r**2 + 2*r*(6*s - 17) - 22*s + 17)) + 105*D1*bd2*f*(r + s - 1)**2 - 42*D1*(f*gd2*(17*r**2 + 22*r*(s - 1) + 5*(s - 1)**2) + fd*g2*(34*r**2 + r*(44*s - 34) + 10*s**2 - 22*s + 17)) - 42*Dd*f*g2*(68*r**2 + r*(88*s - 78) + 20*s**2 - 42*s + 27) + 35*b2*(5*D1*bd1*(r + s - 1)**2 + 3*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(210*d**2*k3**5) + D1**3*Pk1*Pkd3*ct**2*k2**4*(3*D1*bd1*f**2*r*(r + s - 1) + 5*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*f*(5*D1*bd1*(2*r - 1)*(r + s - 1) + 3*D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)))/(15*d**2*k1**2*k3**3) - 3*D1**3*Pk1*Pkd3*ct*f**2*k2**7*st**4*(3*D1*bd1*f*(r + s - 1)**2 + 3*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(14*d**2*k1*k3**7) + 3*D1**3*Pk1*Pkd3*ct*k1**3*k2**3*(7*b1**2*(D1*fd*(3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 20*K)*(r + s)**2) + Dd*f*(-20*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(14*D1*bd1*f*(-20*K + 3*f + 5)*(r + s - 1)**2 + D1*(15*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 7*f*(3*fd*(4*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 40*gd2*(r + s - 1)**2) + 280*fd*g2*(r + s)**2) + Dd*f*(15*f**2 + f*(21 - 84*K) + 280*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*bd1*(15*f**2 + f*(21 - 84*K) + 280*g2)*(r + s - 1)**2 + 168*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 168*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(70*d**2*k3**7) + 3*D1**3*Pk1*Pkd3*ct*k1*k2**5*st**2*(7*b1**2*(D1*fd*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 10*K)*(r + s)**2) + Dd*f*(-10*K + 9*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*b1*(2*D1*bd1*f*(-10*K + 9*f + 5)*(r + s - 1)**2 + D1*(-f*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*f*gd2*(r + s - 1)**2 + 20*fd*g2*(r + s)**2) - Dd*f*(f*(2*K - 1) - 20*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(7*D1*bd1*(r + s - 1)**2*(-2*K*f + f + 20*g2) + D1*(-15*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 28*f*gd2*(r + s - 1)**2 + 28*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(15*f**2 - 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(70*d**2*k3**7) + D1**3*Pk1*Pkd3*ct*k1*k2**3*(175*b1**3*(D1*fd*(r + s - 1)**2 + Dd*(-6*K + f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 35*b1**2*(5*D1*bd1*(-6*K + f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(2*K*(6*r**2 + 6*r*s + 10*r + 10*s - 5) + f*(-6*r - 6*s + 3) - 8*r**2 - 8*r*s - 10*r - 10*s + 5) + 60*D1*gd2*(r + s - 1)**2 + 4*Dd*f*(3*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + 60*Dd*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(924*D1*K*f*fd*r**2 + 1344*D1*K*f*fd*r*s - 924*D1*K*f*fd*r + 420*D1*K*f*fd*s**2 - 672*D1*K*f*fd*s + 462*D1*K*f*fd + 350*D1*b2*fd*r**2 + 700*D1*b2*fd*r*s + 350*D1*b2*fd*s**2 + 35*D1*bd1*(f**2*(6*r + 6*s - 3) + f*(K*(24*r**2 + 8*r*(3*s - 7) - 32*s + 22) - 16*r**2 - 16*r*s + 34*r + 18*s - 13) + 60*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 350*D1*bd2*f*(r + s - 1)**2 - 225*D1*f**2*fd*r**2 - 450*D1*f**2*fd*r*s + 300*D1*f**2*fd*r - 225*D1*f**2*fd*s**2 + 300*D1*f**2*fd*s - 150*D1*f**2*fd - 546*D1*f*fd*r**2 - 756*D1*f*fd*r*s + 546*D1*f*fd*r - 210*D1*f*fd*s**2 + 378*D1*f*fd*s - 273*D1*f*fd - 840*D1*f*gd2*r**2 - 840*D1*f*gd2*r*s + 840*D1*f*gd2*r - 840*D1*fd*g2*r**2 - 840*D1*fd*g2*r*s - 1400*D1*fd*g2*r - 1400*D1*fd*g2*s + 700*D1*fd*g2 + 1848*Dd*K*f**2*r**2 + 2688*Dd*K*f**2*r*s - 2268*Dd*K*f**2*r + 840*Dd*K*f**2*s**2 - 1512*Dd*K*f**2*s + 882*Dd*K*f**2 + 1400*Dd*b2*f*r**2 + 2800*Dd*b2*f*r*s - 2100*Dd*b2*f*r + 1400*Dd*b2*f*s**2 - 2100*Dd*b2*f*s + 1050*Dd*b2*f - 300*Dd*f**3*r**2 - 600*Dd*f**3*r*s + 450*Dd*f**3*r - 300*Dd*f**3*s**2 + 450*Dd*f**3*s - 225*Dd*f**3 - 1092*Dd*f**2*r**2 - 1512*Dd*f**2*r*s + 1302*Dd*f**2*r - 420*Dd*f**2*s**2 + 798*Dd*f**2*s - 483*Dd*f**2 - 3360*Dd*f*g2*r**2 - 3360*Dd*f*g2*r*s + 3360*Dd*f*g2*r + 840*Dd*f*g2*s - 840*Dd*f*g2) + f*(-D1*bd1*(75*f**2*(r + s - 1)**2 - 21*f*(r + s - 1)*(2*K*(11*r + 5*s - 5) - 13*r - 5*s + 5) + 140*g2*(6*r**2 + r*(6*s - 22) - 16*s + 11)) + 210*D1*bd2*f*(r + s - 1)**2 - 84*D1*(f*gd2*(11*r**2 + 16*r*(s - 1) + 5*(s - 1)**2) + fd*g2*(22*r**2 + r*(32*s - 22) + 10*s**2 - 16*s + 11)) - 84*Dd*f*g2*(44*r**2 + r*(64*s - 54) + 20*s**2 - 36*s + 21) + 70*b2*(5*D1*bd1*(r + s - 1)**2 + 3*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(210*d**2*k3**5) - D1**3*Pk1*Pkd3*ct*k2**5*st**2*(35*b1**2*(D1*fd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - (r + s)*(r*(4*K - 9) - 5*s)) + Dd*f*(-4*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 36*r**2 + 56*r*s - 46*r + 20*s**2 - 34*s + 19)) + b1*(35*D1*bd1*f*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (r + s - 1)*(-2*K*(4*r - 2) + 18*r + 10*s - 14)) + D1*(45*f**2*fd*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - 7*f*(fd*(K*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 18*r**2 - 28*r*s + 18*r - 10*s**2 + 14*s - 9) - 40*gd2*r*(r + s - 1)) + 280*fd*g2*r*(r + s)) + Dd*f*(90*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*f*(4*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 36*r**2 - 56*r*s + 46*r - 20*s**2 + 34*s - 19) + 280*g2*(4*r**2 + 4*r*(s - 1) - s + 1))) + f*(D1*bd1*(45*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*f*(r + s - 1)*(r*(4*K - 9) - 5*s + 5) + 280*g2*(r - 1)*(r + s - 1)) + 56*D1*(f*gd2*r*(r + s - 1) + fd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 56*Dd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)))/(210*d**2*k1*k3**5) - D1**3*Pk1*Pkd3*ct*k2**3*(4*D1*bd1*f*r*(-3*f*(r + s - 1) + 10*g2*(r + s)) + 5*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 3*Dd*(-4*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 20*r**2 + r*(24*s - 22) + 4*s**2 - 10*s + 7)) + b1**2*(5*D1*bd1*(-12*K*(3*r**2 + 3*r*(s - 1) - s + 1) + f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 45*r**2 + 6*r*(9*s - 8) + 9*s**2 - 24*s + 18) + D1*fd*(-20*K*(r - 1)*(r + s - 1) + 6*f*(r + s - 1)**2 + 5*r**2 + 10*r*s - 50*r + 5*s**2 - 30*s + 25) + 120*D1*gd2*r*(r + s - 1) + 3*Dd*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*Dd*f*(4*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 4*r**2 + r*(6 - 8*s) - 4*s**2 + 6*s - 3) + 120*Dd*g2*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*(D1*bd1*(3*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*f*(r**2*(8*K - 2) + r*(8*K*s - 4*K - 4*s - 6) - 2*s**2 - 2*s + 3) + 120*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 4*D1*(f*fd*(6*r**2 + 6*r*(s - 1) - 3*s + 3) - 10*f*gd2*r*(r + s - 1) - 10*fd*g2*(r - 1)*(r + s - 1)) - 4*Dd*f*(3*f - 10*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)))/(30*d**2*k1*k3**3) - 9*D1**3*Pk1*Pkd3*f*k2**6*st**4*(-7*b1**2*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*b1*f*(-7*D1*bd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + f**2*(2*D1*bd1*(r + s - 1)**2 + (D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(70*d**2*k3**7) - 3*D1**3*Pk1*Pkd3*k1**4*k2**2*(D1*bd1*f*(r + s - 1)**2*(10*K*b1 + 3*K*f - 10*g2) + 5*K*b1**2*(D1*fd*(r + s)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(-D1*(-3*K*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*f*gd2*(r + s - 1)**2 + 10*fd*g2*(r + s)**2) + Dd*f*(3*K*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*f*(D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(10*d**2*k3**7) + D1**3*Pk1*Pkd3*k1**2*k2**4*st**2*(21*b1**2*(D1*fd*(-5*K*(r + s)**2 + 3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(-5*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 3*b1*(14*D1*bd1*f*(-5*K + 3*f)*(r + s - 1)**2 + D1*(-7*K*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 70*f*gd2*(r + s - 1)**2 + 70*fd*g2*(r + s)**2) + Dd*f*(-7*K*f + 6*f**2 + 70*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(3*D1*bd1*(r + s - 1)**2*(-7*K*f + 6*f**2 + 70*g2) + D1*(-5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 42*f*gd2*(r + s - 1)**2 + 42*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(5*f**2 - 42*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(70*d**2*k3**7) + D1**3*Pk1*Pkd3*k1**2*k2**2*(-75*Dd*K*b1**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*b1**2*(D1*(-15*K*bd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(K*(4*r**2 + 4*r*s + 10*r + 10*s - 5) - 2*r*(r + s)) + 30*gd2*(r + s - 1)**2) + 2*Dd*f*(2*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + 30*Dd*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(54*D1*K*f*fd*r**2 + 84*D1*K*f*fd*r*s - 54*D1*K*f*fd*r + 30*D1*K*f*fd*s**2 - 42*D1*K*f*fd*s + 27*D1*K*f*fd + 25*D1*b2*fd*r**2 + 50*D1*b2*fd*r*s + 25*D1*b2*fd*s**2 + 5*D1*bd1*(f*(K*(8*r**2 + 8*r*s - 22*r - 14*s + 9) + (2 - 4*r)*(r + s - 1)) + 30*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 25*D1*bd2*f*(r + s - 1)**2 - 12*D1*f*fd*r**2 - 12*D1*f*fd*r*s + 12*D1*f*fd*r + 6*D1*f*fd*s - 6*D1*f*fd - 40*D1*f*gd2*r**2 - 40*D1*f*gd2*r*s + 40*D1*f*gd2*r - 40*D1*fd*g2*r**2 - 40*D1*fd*g2*r*s - 100*D1*fd*g2*r - 100*D1*fd*g2*s + 50*D1*fd*g2 + 108*Dd*K*f**2*r**2 + 168*Dd*K*f**2*r*s - 138*Dd*K*f**2*r + 60*Dd*K*f**2*s**2 - 102*Dd*K*f**2*s + 57*Dd*K*f**2 + 100*Dd*b2*f*r**2 + 200*Dd*b2*f*r*s - 150*Dd*b2*f*r + 100*Dd*b2*f*s**2 - 150*Dd*b2*f*s + 75*Dd*b2*f - 24*Dd*f**2*r**2 - 24*Dd*f**2*r*s + 24*Dd*f**2*r + 6*Dd*f**2*s - 6*Dd*f**2 - 160*Dd*f*g2*r**2 - 160*Dd*f*g2*r*s + 160*Dd*f*g2*r + 40*Dd*f*g2*s - 40*Dd*f*g2) + f*(27*D1*K*bd1*f*r**2 + 42*D1*K*bd1*f*r*s - 42*D1*K*bd1*f*r + 15*D1*K*bd1*f*s**2 - 30*D1*K*bd1*f*s + 15*D1*K*bd1*f - 6*D1*bd1*f*r**2 - 6*D1*bd1*f*r*s + 6*D1*bd1*f*r - 40*D1*bd1*g2*r**2 - 40*D1*bd1*g2*r*s + 180*D1*bd1*g2*r + 140*D1*bd1*g2*s - 90*D1*bd1*g2 + 15*D1*bd2*f*(r + s - 1)**2 - 54*D1*f*gd2*r**2 - 84*D1*f*gd2*r*s + 84*D1*f*gd2*r - 30*D1*f*gd2*s**2 + 60*D1*f*gd2*s - 30*D1*f*gd2 - 108*D1*fd*g2*r**2 - 168*D1*fd*g2*r*s + 108*D1*fd*g2*r - 60*D1*fd*g2*s**2 + 84*D1*fd*g2*s - 54*D1*fd*g2 - 216*Dd*f*g2*r**2 - 336*Dd*f*g2*r*s + 276*Dd*f*g2*r - 120*Dd*f*g2*s**2 + 204*Dd*f*g2*s - 114*Dd*f*g2 + 5*b2*(5*D1*bd1*(r + s - 1)**2 + 3*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(30*d**2*k3**5) + D1**3*Pk1*Pkd3*k2**4*st**2*(175*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 35*b1**2*(5*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(-2*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)*(5*K*s + r*(9*K - 2))) + Dd*f*(K*(36*r**2 + 56*r*s - 46*r + 20*s**2 - 34*s + 19) - 2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*r**2 - 8*r*s + 8*r + 2*s - 2)) - b1*(-126*D1*K*f*fd*r**2 - 196*D1*K*f*fd*r*s + 126*D1*K*f*fd*r - 70*D1*K*f*fd*s**2 + 98*D1*K*f*fd*s - 63*D1*K*f*fd - 175*D1*b2*fd*r**2 - 350*D1*b2*fd*r*s - 175*D1*b2*fd*s**2 + 70*D1*bd1*f*(r + s - 1)*(K*(-9*r - 5*s + 7) + 2*f*(r + s - 1) + 2*r - 1) - 175*D1*bd2*f*(r + s - 1)**2 + 135*D1*f**2*fd*r**2 + 270*D1*f**2*fd*r*s - 210*D1*f**2*fd*r + 135*D1*f**2*fd*s**2 - 210*D1*f**2*fd*s + 105*D1*f**2*fd + 28*D1*f*fd*r**2 + 28*D1*f*fd*r*s - 28*D1*f*fd*r - 14*D1*f*fd*s + 14*D1*f*fd + 630*D1*f*gd2*r**2 + 980*D1*f*gd2*r*s - 980*D1*f*gd2*r + 350*D1*f*gd2*s**2 - 700*D1*f*gd2*s + 350*D1*f*gd2 + 630*D1*fd*g2*r**2 + 980*D1*fd*g2*r*s + 350*D1*fd*g2*s**2 - 252*Dd*K*f**2*r**2 - 392*Dd*K*f**2*r*s + 322*Dd*K*f**2*r - 140*Dd*K*f**2*s**2 + 238*Dd*K*f**2*s - 133*Dd*K*f**2 - 700*Dd*b2*f*r**2 - 1400*Dd*b2*f*r*s + 1050*Dd*b2*f*r - 700*Dd*b2*f*s**2 + 1050*Dd*b2*f*s - 525*Dd*b2*f + 180*Dd*f**3*r**2 + 360*Dd*f**3*r*s - 270*Dd*f**3*r + 180*Dd*f**3*s**2 - 270*Dd*f**3*s + 135*Dd*f**3 + 56*Dd*f**2*r**2 + 56*Dd*f**2*r*s - 56*Dd*f**2*r - 14*Dd*f**2*s + 14*Dd*f**2 + 2520*Dd*f*g2*r**2 + 3920*Dd*f*g2*r*s - 3220*Dd*f*g2*r + 1400*Dd*f*g2*s**2 - 2380*Dd*f*g2*s + 1330*Dd*f*g2) + f*(63*D1*K*bd1*f*r**2 + 98*D1*K*bd1*f*r*s - 98*D1*K*bd1*f*r + 35*D1*K*bd1*f*s**2 - 70*D1*K*bd1*f*s + 35*D1*K*bd1*f - 45*D1*bd1*f**2*r**2 - 90*D1*bd1*f**2*r*s + 60*D1*bd1*f**2*r - 45*D1*bd1*f**2*s**2 + 60*D1*bd1*f**2*s - 30*D1*bd1*f**2 - 14*D1*bd1*f*r**2 - 14*D1*bd1*f*r*s + 14*D1*bd1*f*r - 630*D1*bd1*g2*r**2 - 980*D1*bd1*g2*r*s + 1260*D1*bd1*g2*r - 350*D1*bd1*g2*s**2 + 980*D1*bd1*g2*s - 630*D1*bd1*g2 + 35*D1*bd2*f*(r + s - 1)**2 - 126*D1*f*gd2*r**2 - 196*D1*f*gd2*r*s + 196*D1*f*gd2*r - 70*D1*f*gd2*s**2 + 140*D1*f*gd2*s - 70*D1*f*gd2 - 252*D1*fd*g2*r**2 - 392*D1*fd*g2*r*s + 252*D1*fd*g2*r - 140*D1*fd*g2*s**2 + 196*D1*fd*g2*s - 126*D1*fd*g2 - 504*Dd*f*g2*r**2 - 784*Dd*f*g2*r*s + 644*Dd*f*g2*r - 280*Dd*f*g2*s**2 + 476*Dd*f*g2*s - 266*Dd*f*g2 + 35*b2*(5*D1*bd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))))/(210*d**2*k3**5) + D1**3*Pk1*Pkd3*k2**2*(D1*bd1*f*(6*f*r*(r + s - 1) + (5*r + 5*s)*(b2*(r + s) - 2*g2*(5*r + s))) + 15*Dd*b1**3*(K*(20*r**2 + r*(24*s - 22) + 4*s**2 - 10*s + 7) - 8*r**2 - 8*r*s + 8*r + 2*s - 2) + 5*b1**2*(5*D1*K*fd*r**2 + 6*D1*K*fd*r*s - 10*D1*K*fd*r + D1*K*fd*s**2 - 6*D1*K*fd*s + 5*D1*K*fd + 3*D1*bd1*(K*(15*r**2 + 2*r*(9*s - 8) + 3*s**2 - 8*s + 6) - 6*r**2 - 6*r*s + 6*r + 2*s - 2) + 3*D1*bd2*(r + s - 1)**2 + 4*D1*fd*r + 2*D1*fd*s - 2*D1*fd - 30*D1*gd2*r**2 - 36*D1*gd2*r*s + 36*D1*gd2*r - 6*D1*gd2*s**2 + 12*D1*gd2*s - 6*D1*gd2 + 20*Dd*K*f*r**2 + 24*Dd*K*f*r*s - 22*Dd*K*f*r + 4*Dd*K*f*s**2 - 10*Dd*K*f*s + 7*Dd*K*f + 12*Dd*b2*r**2 + 24*Dd*b2*r*s - 18*Dd*b2*r + 12*Dd*b2*s**2 - 18*Dd*b2*s + 9*Dd*b2 - 120*Dd*g2*r**2 - 144*Dd*g2*r*s + 132*Dd*g2*r - 24*Dd*g2*s**2 + 60*Dd*g2*s - 42*Dd*g2) + b1*(5*D1*bd1*(f*(K*(10*r**2 + 12*r*s - 6*r + 2*s**2 - 2*s + 1) - 4*r - 2*s + 2) - 6*g2*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5)) + 5*D1*bd2*f*r**2 + 10*D1*bd2*f*r*s - 10*D1*bd2*f*r + 5*D1*bd2*f*s**2 - 10*D1*bd2*f*s + 5*D1*bd2*f + 12*D1*f*fd*r**2 + 12*D1*f*fd*r*s - 12*D1*f*fd*r - 6*D1*f*fd*s + 6*D1*f*fd - 50*D1*f*gd2*r**2 - 60*D1*f*gd2*r*s + 60*D1*f*gd2*r - 10*D1*f*gd2*s**2 + 20*D1*f*gd2*s - 10*D1*f*gd2 - 50*D1*fd*g2*r**2 - 60*D1*fd*g2*r*s + 100*D1*fd*g2*r - 10*D1*fd*g2*s**2 + 60*D1*fd*g2*s - 50*D1*fd*g2 + 24*Dd*f**2*r**2 + 24*Dd*f**2*r*s - 24*Dd*f**2*r - 6*Dd*f**2*s + 6*Dd*f**2 - 200*Dd*f*g2*r**2 - 240*Dd*f*g2*r*s + 220*Dd*f*g2*r - 40*Dd*f*g2*s**2 + 100*Dd*f*g2*s - 70*Dd*f*g2 + 5*b2*(3*D1*bd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))))/(30*d**2*k3**3) + D1**3*Pk1*Pkd3*k2**4*st**2*(D1*bd1*f**2*r*(r + s - 1) + 5*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*f*(5*D1*bd1*(2*r - 1)*(r + s - 1) + D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)))/(15*d**2*k1**2*k3**3) + D1**3*Pk1*Pkdd3*b1*ct*k2**3*(D1*bd1*f*(3*f + 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*b1**2*(D1*fd*(r + s - 1)**2 + Dd*(f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(5*D1*bd1*(f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(6*f + 5)*(r + s - 1)**2 + Dd*f*(3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(30*d**2*k1*k3**2) + D1**3*Pk1*Pkdd3*ct**5*f**2*k2**7*(9*D1*bd1*f*(r + s - 1)**2 + 9*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(126*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct**4*k2**6*(7*b1**2*(D1*fd*(3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 5*K)*(r + s)**2) + Dd*f*(-5*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(14*D1*bd1*f*(-5*K + 3*f + 5)*(r + s - 1)**2 + D1*(-30*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 21*f*fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*f*gd2*(r + s - 1)**2 + 70*fd*g2*(r + s)**2) - Dd*f*(30*f**2 + 21*f*(K - 1) - 70*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(-D1*bd1*(30*f**2 + 21*f*(K - 1) - 70*g2)*(r + s - 1)**2 - 7*D1*(5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*f*gd2*(r + s - 1)**2 - 6*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 7*Dd*f*(5*f**2 - 6*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(210*d**2*k3**6) + D1**3*Pk1*Pkdd3*ct**3*f**2*k2**7*st**2*(9*D1*bd1*f*(r + s - 1)**2 + 9*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 5*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(63*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct**3*k1*k2**5*(b1**2*(D1*fd*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (15 - 20*K)*(r + s)**2) + Dd*f*(-20*K + 9*f + 15)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(2*D1*bd1*f*(-20*K + 9*f + 15)*(r + s - 1)**2 + D1*(-3*f*fd*(4*K - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*f*gd2*(r + s - 1)**2 + 40*fd*g2*(r + s)**2) - Dd*f*(3*f*(4*K - 3) - 40*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*bd1*(f*(9 - 12*K) + 40*g2)*(r + s - 1)**2 + D1*(-5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 24*f*gd2*(r + s - 1)**2 + 24*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(5*f**2 - 24*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(30*d**2*k3**6) + D1**3*Pk1*Pkdd3*ct**3*k2**5*(3*D1*bd1*f**2*(5*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*(r + s - 1)**2) + 7*b1**2*(D1*fd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*(r + s)**2) + Dd*f*(6*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*f*(21*D1*bd1*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 70*D1*bd1*(r + s - 1)**2 + 3*D1*fd*(5*f*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 14*r**2 + 7*r*(4*s - 2) + 14*s**2 - 14*s + 7) + 3*Dd*f*(10*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(210*d**2*k1*k3**4) - D1**3*Pk1*Pkdd3*ct**2*k1**2*k2**4*(63*b1**2*(D1*fd*(3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 10*K)*(r + s)**2) + Dd*f*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 9*b1*(14*D1*bd1*f*(-10*K + 3*f + 5)*(r + s - 1)**2 + D1*(10*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 7*f*(3*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 20*gd2*(r + s - 1)**2) + 140*fd*g2*(r + s)**2) + Dd*f*(10*f**2 + f*(21 - 42*K) + 140*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(9*D1*bd1*(10*f**2 + f*(21 - 42*K) + 140*g2)*(r + s - 1)**2 - 7*D1*(5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 108*f*gd2*(r + s - 1)**2 - 108*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 7*Dd*f*(5*f**2 - 108*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(630*d**2*k3**6) - D1**3*Pk1*Pkdd3*ct**2*k2**6*st**2*(7*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 5*K)*(r + s)**2) + Dd*f*(-5*K + 6*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(14*D1*bd1*f*(-5*K + 6*f + 5)*(r + s - 1)**2 + D1*(-36*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 7*f*fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*f*gd2*(r + s - 1)**2 + 70*fd*g2*(r + s)**2) - Dd*f*(36*f**2 + 7*f*(K - 1) - 70*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(-D1*bd1*(36*f**2 + 7*f*(K - 1) - 70*g2)*(r + s - 1)**2 - 2*D1*(15*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*f*gd2*(r + s - 1)**2 - 7*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd*f*(15*f**2 - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(210*d**2*k3**6) + D1**3*Pk1*Pkdd3*ct**2*k2**4*(-35*b1**3*(D1*fd*(r + s - 1)**2 + Dd*(-3*K + f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 7*b1**2*(5*D1*bd1*(-3*K + f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - D1*(6*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*fd*(K*(-2*r - 2*s + 1) + r**2 + 2*r*(s + 1) + s**2 + 2*s - 1) - 30*gd2*(r + s - 1)**2) - Dd*(6*f**2 + 5*f - 30*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(-42*D1*K*f*fd*r**2 - 84*D1*K*f*fd*r*s + 42*D1*K*f*fd*r - 42*D1*K*f*fd*s**2 + 42*D1*K*f*fd*s - 21*D1*K*f*fd - 35*D1*b2*fd*r**2 - 70*D1*b2*fd*r*s - 35*D1*b2*fd*s**2 + 7*D1*bd1*(12*f**2*(r + s - 1)**2 + 5*f*(K*(2*r + 2*s - 1) + 2*r**2 + 4*r*s - 6*r + 2*s**2 - 6*s + 3) - 30*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 35*D1*bd2*f*(r + s - 1)**2 + 135*D1*f**2*fd*r**2 + 270*D1*f**2*fd*r*s - 210*D1*f**2*fd*r + 135*D1*f**2*fd*s**2 - 210*D1*f**2*fd*s + 105*D1*f**2*fd + 84*D1*f*fd*r**2 + 168*D1*f*fd*r*s - 84*D1*f*fd*r + 84*D1*f*fd*s**2 - 84*D1*f*fd*s + 42*D1*f*fd + 140*D1*fd*g2*r + 140*D1*fd*g2*s - 70*D1*fd*g2 - 84*Dd*K*f**2*r**2 - 168*Dd*K*f**2*r*s + 126*Dd*K*f**2*r - 84*Dd*K*f**2*s**2 + 126*Dd*K*f**2*s - 63*Dd*K*f**2 - 140*Dd*b2*f*r**2 - 280*Dd*b2*f*r*s + 210*Dd*b2*f*r - 140*Dd*b2*f*s**2 + 210*Dd*b2*f*s - 105*Dd*b2*f + 180*Dd*f**3*r**2 + 360*Dd*f**3*r*s - 270*Dd*f**3*r + 180*Dd*f**3*s**2 - 270*Dd*f**3*s + 135*Dd*f**3 + 168*Dd*f**2*r**2 + 336*Dd*f**2*r*s - 252*Dd*f**2*r + 168*Dd*f**2*s**2 - 252*Dd*f**2*s + 126*Dd*f**2) + f*(D1*bd1*(15*f**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 21*f*(K - 2)*(r + s - 1)**2 - 70*g2*(2*r + 2*s - 1)) - 21*D1*bd2*f*(r + s - 1)**2 + 42*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 42*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*b2*(5*D1*bd1*(r + s - 1)**2 + 3*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(210*d**2*k3**4) + D1**3*Pk1*Pkdd3*ct*f**2*k2**7*st**4*(3*D1*bd1*f*(r + s - 1)**2 + 3*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(42*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct*k1**3*k2**3*(7*b1**2*(D1*fd*(3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 20*K)*(r + s)**2) + Dd*f*(-20*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(14*D1*bd1*f*(-20*K + 3*f + 5)*(r + s - 1)**2 + D1*(15*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 7*f*(3*fd*(4*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 40*gd2*(r + s - 1)**2) + 280*fd*g2*(r + s)**2) + Dd*f*(15*f**2 + f*(21 - 84*K) + 280*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*bd1*(15*f**2 + f*(21 - 84*K) + 280*g2)*(r + s - 1)**2 + 168*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 168*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(210*d**2*k3**6) - D1**3*Pk1*Pkdd3*ct*k1*k2**5*st**2*(7*b1**2*(D1*fd*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (5 - 10*K)*(r + s)**2) + Dd*f*(-10*K + 9*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*b1*(2*D1*bd1*f*(-10*K + 9*f + 5)*(r + s - 1)**2 + D1*(-f*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*f*gd2*(r + s - 1)**2 + 20*fd*g2*(r + s)**2) - Dd*f*(f*(2*K - 1) - 20*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(7*D1*bd1*(r + s - 1)**2*(-2*K*f + f + 20*g2) + D1*(-15*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 28*f*gd2*(r + s - 1)**2 + 28*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(15*f**2 - 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(210*d**2*k3**6) - D1**3*Pk1*Pkdd3*ct*k1*k2**3*(35*b1**3*(D1*fd*(r + s - 1)**2 + Dd*(-6*K + f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*b1**2*(5*D1*bd1*(-6*K + f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*(-fd*(-10*K + 3*f + 5)*(2*r + 2*s - 1) + 60*gd2*(r + s - 1)**2) + 60*Dd*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(84*D1*K*f*fd*r**2 + 168*D1*K*f*fd*r*s - 84*D1*K*f*fd*r + 84*D1*K*f*fd*s**2 - 84*D1*K*f*fd*s + 42*D1*K*f*fd + 70*D1*b2*fd*r**2 + 140*D1*b2*fd*r*s + 70*D1*b2*fd*s**2 + 7*D1*bd1*(f**2*(6*r + 6*s - 3) - 5*f*(2*K - 1)*(2*r + 2*s - 1) + 60*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 70*D1*bd2*f*(r + s - 1)**2 - 45*D1*f**2*fd*r**2 - 90*D1*f**2*fd*r*s + 60*D1*f**2*fd*r - 45*D1*f**2*fd*s**2 + 60*D1*f**2*fd*s - 30*D1*f**2*fd - 42*D1*f*fd*r**2 - 84*D1*f*fd*r*s + 42*D1*f*fd*r - 42*D1*f*fd*s**2 + 42*D1*f*fd*s - 21*D1*f*fd - 280*D1*fd*g2*r - 280*D1*fd*g2*s + 140*D1*fd*g2 + 168*Dd*K*f**2*r**2 + 336*Dd*K*f**2*r*s - 252*Dd*K*f**2*r + 168*Dd*K*f**2*s**2 - 252*Dd*K*f**2*s + 126*Dd*K*f**2 + 280*Dd*b2*f*r**2 + 560*Dd*b2*f*r*s - 420*Dd*b2*f*r + 280*Dd*b2*f*s**2 - 420*Dd*b2*f*s + 210*Dd*b2*f - 60*Dd*f**3*r**2 - 120*Dd*f**3*r*s + 90*Dd*f**3*r - 60*Dd*f**3*s**2 + 90*Dd*f**3*s - 45*Dd*f**3 - 84*Dd*f**2*r**2 - 168*Dd*f**2*r*s + 126*Dd*f**2*r - 84*Dd*f**2*s**2 + 126*Dd*f**2*s - 63*Dd*f**2) + f*(D1*bd1*(-15*f**2*(r + s - 1)**2 + 21*f*(2*K - 1)*(r + s - 1)**2 + 140*g2*(2*r + 2*s - 1)) + 42*D1*bd2*f*(r + s - 1)**2 - 84*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) - 84*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 14*b2*(5*D1*bd1*(r + s - 1)**2 + 3*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(210*d**2*k3**4) + D1**3*Pk1*Pkdd3*ct*k2**5*st**2*(D1*bd1*f**2*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*(r + s - 1)**2) + 7*b1**2*(D1*fd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*(r + s)**2) + Dd*f*(6*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*f*(7*D1*bd1*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*(r + s - 1)**2) + D1*fd*(9*f*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 14*r**2 + 7*r*(4*s - 2) + 14*s**2 - 14*s + 7) + Dd*f*(18*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(210*d**2*k1*k3**4) + D1**3*Pk1*Pkdd3*f*k2**6*st**4*(-7*b1**2*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*b1*f*(-7*D1*bd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + f**2*(2*D1*bd1*(r + s - 1)**2 + (D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(70*d**2*k3**6) + D1**3*Pk1*Pkdd3*k1**4*k2**2*(D1*bd1*f*(r + s - 1)**2*(10*K*b1 + 3*K*f - 10*g2) + 5*K*b1**2*(D1*fd*(r + s)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(-D1*(-3*K*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*f*gd2*(r + s - 1)**2 + 10*fd*g2*(r + s)**2) + Dd*f*(3*K*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*f*(D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(30*d**2*k3**6) - D1**3*Pk1*Pkdd3*k1**2*k2**4*st**2*(21*b1**2*(D1*fd*(-5*K*(r + s)**2 + 3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(-5*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 3*b1*(14*D1*bd1*f*(-5*K + 3*f)*(r + s - 1)**2 + D1*(-7*K*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 70*f*gd2*(r + s - 1)**2 + 70*fd*g2*(r + s)**2) + Dd*f*(-7*K*f + 6*f**2 + 70*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(3*D1*bd1*(r + s - 1)**2*(-7*K*f + 6*f**2 + 70*g2) + D1*(-5*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 42*f*gd2*(r + s - 1)**2 + 42*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(5*f**2 - 42*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(630*d**2*k3**6) - D1**3*Pk1*Pkdd3*k1**2*k2**2*(-15*Dd*K*b1**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*b1**2*(D1*(-K*(3*bd1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 2*fd*r - 2*fd*s + fd) + 6*gd2*(r + s - 1)**2) + 6*Dd*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(6*D1*K*f*fd*r**2 + 12*D1*K*f*fd*r*s - 6*D1*K*f*fd*r + 6*D1*K*f*fd*s**2 - 6*D1*K*f*fd*s + 3*D1*K*f*fd + 5*D1*bd1*(K*f*(-2*r - 2*s + 1) + 6*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 5*D1*bd2*f*(r + s - 1)**2 - 20*D1*fd*g2*r - 20*D1*fd*g2*s + 10*D1*fd*g2 + 12*Dd*K*f**2*r**2 + 24*Dd*K*f**2*r*s - 18*Dd*K*f**2*r + 12*Dd*K*f**2*s**2 - 18*Dd*K*f**2*s + 9*Dd*K*f**2) + b2*(5*D1*bd1*f*(r + s - 1)**2 + 5*b1*(D1*fd*(r + s)**2 + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + 3*f*(D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + f*(D1*bd1*(3*K*f*(r + s - 1)**2 + 10*g2*(2*r + 2*s - 1)) + 3*D1*bd2*f*(r + s - 1)**2 - 6*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) - 6*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(30*d**2*k3**4) - D1**3*Pk1*Pkdd3*k2**4*st**2*(35*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*b1**2*(5*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(5*K*(r + s)**2 - 2*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(-5*K + 2*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(70*D1*K*bd1*f*r**2 + 140*D1*K*bd1*f*r*s - 140*D1*K*bd1*f*r + 70*D1*K*bd1*f*s**2 - 140*D1*K*bd1*f*s + 70*D1*K*bd1*f + 14*D1*K*f*fd*r**2 + 28*D1*K*f*fd*r*s - 14*D1*K*f*fd*r + 14*D1*K*f*fd*s**2 - 14*D1*K*f*fd*s + 7*D1*K*f*fd - 28*D1*bd1*f**2*r**2 - 56*D1*bd1*f**2*r*s + 56*D1*bd1*f**2*r - 28*D1*bd1*f**2*s**2 + 56*D1*bd1*f**2*s - 28*D1*bd1*f**2 + 35*D1*bd2*f*(r + s - 1)**2 - 27*D1*f**2*fd*r**2 - 54*D1*f**2*fd*r*s + 42*D1*f**2*fd*r - 27*D1*f**2*fd*s**2 + 42*D1*f**2*fd*s - 21*D1*f**2*fd - 70*D1*f*gd2*r**2 - 140*D1*f*gd2*r*s + 140*D1*f*gd2*r - 70*D1*f*gd2*s**2 + 140*D1*f*gd2*s - 70*D1*f*gd2 - 70*D1*fd*g2*r**2 - 140*D1*fd*g2*r*s - 70*D1*fd*g2*s**2 + 28*Dd*K*f**2*r**2 + 56*Dd*K*f**2*r*s - 42*Dd*K*f**2*r + 28*Dd*K*f**2*s**2 - 42*Dd*K*f**2*s + 21*Dd*K*f**2 - 36*Dd*f**3*r**2 - 72*Dd*f**3*r*s + 54*Dd*f**3*r - 36*Dd*f**3*s**2 + 54*Dd*f**3*s - 27*Dd*f**3 - 280*Dd*f*g2*r**2 - 560*Dd*f*g2*r*s + 420*Dd*f*g2*r - 280*Dd*f*g2*s**2 + 420*Dd*f*g2*s - 210*Dd*f*g2 + 35*b2*(D1*fd*(r + s)**2 + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + f*(7*D1*K*bd1*f*r**2 + 14*D1*K*bd1*f*r*s - 14*D1*K*bd1*f*r + 7*D1*K*bd1*f*s**2 - 14*D1*K*bd1*f*s + 7*D1*K*bd1*f - 9*D1*bd1*f**2*r**2 - 18*D1*bd1*f**2*r*s + 12*D1*bd1*f**2*r - 9*D1*bd1*f**2*s**2 + 12*D1*bd1*f**2*s - 6*D1*bd1*f**2 - 70*D1*bd1*g2*r**2 - 140*D1*bd1*g2*r*s + 140*D1*bd1*g2*r - 70*D1*bd1*g2*s**2 + 140*D1*bd1*g2*s - 70*D1*bd1*g2 + 7*D1*bd2*f*(r + s - 1)**2 - 14*D1*f*gd2*r**2 - 28*D1*f*gd2*r*s + 28*D1*f*gd2*r - 14*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 14*D1*f*gd2 - 28*D1*fd*g2*r**2 - 56*D1*fd*g2*r*s + 28*D1*fd*g2*r - 28*D1*fd*g2*s**2 + 28*D1*fd*g2*s - 14*D1*fd*g2 - 56*Dd*f*g2*r**2 - 112*Dd*f*g2*r*s + 84*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 84*Dd*f*g2*s - 42*Dd*f*g2 + 7*b2*(5*D1*bd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))))/(210*d**2*k3**4) - D1**3*Pk1*Pkdd3*k2**2*(D1*bd1*f*(b2 - 2*g2)*(r + s)**2 + 3*Dd*K*b1**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + b1**2*(9*D1*K*bd1*r**2 + 18*D1*K*bd1*r*s - 12*D1*K*bd1*r + 9*D1*K*bd1*s**2 - 12*D1*K*bd1*s + 6*D1*K*bd1 + D1*K*fd*r**2 + 2*D1*K*fd*r*s - 2*D1*K*fd*r + D1*K*fd*s**2 - 2*D1*K*fd*s + D1*K*fd + 3*D1*bd2*(r + s - 1)**2 - 6*D1*gd2*r**2 - 12*D1*gd2*r*s + 12*D1*gd2*r - 6*D1*gd2*s**2 + 12*D1*gd2*s - 6*D1*gd2 + 4*Dd*K*f*r**2 + 8*Dd*K*f*r*s - 6*Dd*K*f*r + 4*Dd*K*f*s**2 - 6*Dd*K*f*s + 3*Dd*K*f + 3*Dd*b2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 24*Dd*g2*r**2 - 48*Dd*g2*r*s + 36*Dd*g2*r - 24*Dd*g2*s**2 + 36*Dd*g2*s - 18*Dd*g2) + b1*(2*D1*K*bd1*f*r**2 + 4*D1*K*bd1*f*r*s - 2*D1*K*bd1*f*r + 2*D1*K*bd1*f*s**2 - 2*D1*K*bd1*f*s + D1*K*bd1*f - 12*D1*bd1*g2*r**2 - 24*D1*bd1*g2*r*s + 12*D1*bd1*g2*r - 12*D1*bd1*g2*s**2 + 12*D1*bd1*g2*s - 6*D1*bd1*g2 + D1*bd2*f*r**2 + 2*D1*bd2*f*r*s - 2*D1*bd2*f*r + D1*bd2*f*s**2 - 2*D1*bd2*f*s + D1*bd2*f - 2*D1*f*gd2*r**2 - 4*D1*f*gd2*r*s + 4*D1*f*gd2*r - 2*D1*f*gd2*s**2 + 4*D1*f*gd2*s - 2*D1*f*gd2 - 2*D1*fd*g2*r**2 - 4*D1*fd*g2*r*s + 4*D1*fd*g2*r - 2*D1*fd*g2*s**2 + 4*D1*fd*g2*s - 2*D1*fd*g2 - 8*Dd*f*g2*r**2 - 16*Dd*f*g2*r*s + 12*Dd*f*g2*r - 8*Dd*f*g2*s**2 + 12*Dd*f*g2*s - 6*Dd*f*g2 + b2*(3*D1*bd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))))/(6*d**2*k3**2) - D1**2*Pk1*Pk3*ct**8*k2**6*(8*C - 8)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 42*D1**2*f**2*fd*r**2 + 84*D1**2*f**2*fd*r*s - 56*D1**2*f**2*fd*r + 42*D1**2*f**2*fd*s**2 - 56*D1**2*f**2*fd*s + 28*D1**2*f**2*fd - 21*D1**2*f**2*fdd*r**2 - 42*D1**2*f**2*fdd*r*s + 28*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd*s**2 + 28*D1**2*f**2*fdd*s - 14*D1**2*f**2*fdd - 42*D1**2*f*fd**2*r**2 - 84*D1**2*f*fd**2*r*s + 56*D1**2*f*fd**2*r - 42*D1**2*f*fd**2*s**2 + 56*D1**2*f*fd**2*s - 14*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 56*D1*Dd*f**3*r**2 + 112*D1*Dd*f**3*r*s - 84*D1*Dd*f**3*r + 56*D1*Dd*f**3*s**2 - 84*D1*Dd*f**3*s + 42*D1*Dd*f**3 - 168*D1*Dd*f**2*fd*r**2 - 336*D1*Dd*f**2*fd*r*s + 238*D1*Dd*f**2*fd*r - 168*D1*Dd*f**2*fd*s**2 + 238*D1*Dd*f**2*fd*s - 84*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 - 56*D1*Ddd*f**3*r*s + 42*D1*Ddd*f**3*r - 28*D1*Ddd*f**3*s**2 + 42*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 84*Dd**2*f**3*r**2 - 168*Dd**2*f**3*r*s + 126*Dd**2*f**3*r - 84*Dd**2*f**3*s**2 + 126*Dd**2*f**3*s - 42*Dd**2*f**3)/(21*d**2*k3**8) - D1**2*Pk1*Pk3*ct**8*k2**4*(16*C - 16)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 14*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 7*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 7*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(63*d**2*k3**6) - D1**2*Pk1*Pk3*ct**8*k2**2*(8*C - 8)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + 2*D1*f*(14*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(2*s**2 - 2*s + 1)) - 14*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k3**4) - 4*D1**2*Pk1*Pk3*ct**7*f*k2**7*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 88*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 88*D1**2*b1*f*fd*s + 44*D1**2*b1*f*fd - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 44*D1**2*b1*f*fdd*r - 33*D1**2*b1*f*fdd*s**2 + 44*D1**2*b1*f*fdd*s - 22*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 88*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 88*D1**2*b1*fd**2*s - 22*D1**2*b1*fd**2 - 11*D1**2*bdd1*f**2*(r + s - 1)**2 + 72*D1**2*f**2*fd*r**2 + 144*D1**2*f**2*fd*r*s - 108*D1**2*f**2*fd*r + 72*D1**2*f**2*fd*s**2 - 108*D1**2*f**2*fd*s + 54*D1**2*f**2*fd - 36*D1**2*f**2*fdd*r**2 - 72*D1**2*f**2*fdd*r*s + 54*D1**2*f**2*fdd*r - 36*D1**2*f**2*fdd*s**2 + 54*D1**2*f**2*fdd*s - 27*D1**2*f**2*fdd - 108*D1**2*f*fd**2*r**2 - 216*D1**2*f*fd**2*r*s + 162*D1**2*f*fd**2*r - 108*D1**2*f*fd**2*s**2 + 162*D1**2*f*fd**2*s - 54*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 176*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r + 88*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 374*D1*Dd*b1*f*fd*r - 264*D1*Dd*b1*f*fd*s**2 + 374*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 72*D1*Dd*f**3*r**2 + 144*D1*Dd*f**3*r*s - 108*D1*Dd*f**3*r + 72*D1*Dd*f**3*s**2 - 108*D1*Dd*f**3*s + 54*D1*Dd*f**3 - 288*D1*Dd*f**2*fd*r**2 - 576*D1*Dd*f**2*fd*r*s + 432*D1*Dd*f**2*fd*r - 288*D1*Dd*f**2*fd*s**2 + 432*D1*Dd*f**2*fd*s - 162*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 - 88*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r - 44*D1*Ddd*b1*f**2*s**2 + 66*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 36*D1*Ddd*f**3*r**2 - 72*D1*Ddd*f**3*r*s + 54*D1*Ddd*f**3*r - 36*D1*Ddd*f**3*s**2 + 54*D1*Ddd*f**3*s - 27*D1*Ddd*f**3 + 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 132*Dd**2*b1*f**2*r**2 - 264*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r - 132*Dd**2*b1*f**2*s**2 + 198*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 108*Dd**2*f**3*r**2 - 216*Dd**2*f**3*r*s + 162*Dd**2*f**3*r - 108*Dd**2*f**3*s**2 + 162*Dd**2*f**3*s - 54*Dd**2*f**3)/(33*d**2*k1*k3**8) - 4*D1**2*Pk1*Pk3*ct**7*k1*k2**5*(1656*C*D1**2*b1*f*fd*r**2 + 3312*C*D1**2*b1*f*fd*r*s - 1656*C*D1**2*b1*f*fd*r + 1656*C*D1**2*b1*f*fd*s**2 - 1656*C*D1**2*b1*f*fd*s + 828*C*D1**2*b1*f*fd - 1080*C*D1**2*b1*f*fdd*r**2 - 2160*C*D1**2*b1*f*fdd*r*s + 1080*C*D1**2*b1*f*fdd*r - 1080*C*D1**2*b1*f*fdd*s**2 + 1080*C*D1**2*b1*f*fdd*s - 540*C*D1**2*b1*f*fdd - 1080*C*D1**2*b1*fd**2*r**2 - 2160*C*D1**2*b1*fd**2*r*s + 1080*C*D1**2*b1*fd**2*r - 1080*C*D1**2*b1*fd**2*s**2 + 1080*C*D1**2*b1*fd**2*s + 1980*C*D1**2*f**2*fd*r**2 + 3960*C*D1**2*f**2*fd*r*s - 2640*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd*s**2 - 2640*C*D1**2*f**2*fd*s + 1320*C*D1**2*f**2*fd - 1260*C*D1**2*f**2*fdd*r**2 - 2520*C*D1**2*f**2*fdd*r*s + 1680*C*D1**2*f**2*fdd*r - 1260*C*D1**2*f**2*fdd*s**2 + 1680*C*D1**2*f**2*fdd*s - 840*C*D1**2*f**2*fdd - 2520*C*D1**2*f*fd**2*r**2 - 5040*C*D1**2*f*fd**2*r*s + 3360*C*D1**2*f*fd**2*r - 2520*C*D1**2*f*fd**2*s**2 + 3360*C*D1**2*f*fd**2*s - 840*C*D1**2*f*fd**2 + 3312*C*D1*Dd*b1*f**2*r**2 + 6624*C*D1*Dd*b1*f**2*r*s - 4968*C*D1*Dd*b1*f**2*r + 3312*C*D1*Dd*b1*f**2*s**2 - 4968*C*D1*Dd*b1*f**2*s + 2484*C*D1*Dd*b1*f**2 - 8640*C*D1*Dd*b1*f*fd*r**2 - 17280*C*D1*Dd*b1*f*fd*r*s + 10800*C*D1*Dd*b1*f*fd*r - 8640*C*D1*Dd*b1*f*fd*s**2 + 10800*C*D1*Dd*b1*f*fd*s - 3240*C*D1*Dd*b1*f*fd + 2640*C*D1*Dd*f**3*r**2 + 5280*C*D1*Dd*f**3*r*s - 3960*C*D1*Dd*f**3*r + 2640*C*D1*Dd*f**3*s**2 - 3960*C*D1*Dd*f**3*s + 1980*C*D1*Dd*f**3 - 10080*C*D1*Dd*f**2*fd*r**2 - 20160*C*D1*Dd*f**2*fd*r*s + 14280*C*D1*Dd*f**2*fd*r - 10080*C*D1*Dd*f**2*fd*s**2 + 14280*C*D1*Dd*f**2*fd*s - 5040*C*D1*Dd*f**2*fd - 2160*C*D1*Ddd*b1*f**2*r**2 - 4320*C*D1*Ddd*b1*f**2*r*s + 3240*C*D1*Ddd*b1*f**2*r - 2160*C*D1*Ddd*b1*f**2*s**2 + 3240*C*D1*Ddd*b1*f**2*s - 1620*C*D1*Ddd*b1*f**2 - 1680*C*D1*Ddd*f**3*r**2 - 3360*C*D1*Ddd*f**3*r*s + 2520*C*D1*Ddd*f**3*r - 1680*C*D1*Ddd*f**3*s**2 + 2520*C*D1*Ddd*f**3*s - 1260*C*D1*Ddd*f**3 - 6480*C*Dd**2*b1*f**2*r**2 - 12960*C*Dd**2*b1*f**2*r*s + 9720*C*Dd**2*b1*f**2*r - 6480*C*Dd**2*b1*f**2*s**2 + 9720*C*Dd**2*b1*f**2*s - 3240*C*Dd**2*b1*f**2 - 5040*C*Dd**2*f**3*r**2 - 10080*C*Dd**2*f**3*r*s + 7560*C*Dd**2*f**3*r - 5040*C*Dd**2*f**3*s**2 + 7560*C*Dd**2*f**3*s - 2520*C*Dd**2*f**3 - 1476*D1**2*b1*f*fd*r**2 - 2952*D1**2*b1*f*fd*r*s + 1476*D1**2*b1*f*fd*r - 1476*D1**2*b1*f*fd*s**2 + 1476*D1**2*b1*f*fd*s - 738*D1**2*b1*f*fd + 990*D1**2*b1*f*fdd*r**2 + 1980*D1**2*b1*f*fdd*r*s - 990*D1**2*b1*f*fdd*r + 990*D1**2*b1*f*fdd*s**2 - 990*D1**2*b1*f*fdd*s + 495*D1**2*b1*f*fdd + 990*D1**2*b1*fd**2*r**2 + 1980*D1**2*b1*fd**2*r*s - 990*D1**2*b1*fd**2*r + 990*D1**2*b1*fd**2*s**2 - 990*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(12*C - 11)*(r + s - 1)**2 - 1770*D1**2*f**2*fd*r**2 - 3540*D1**2*f**2*fd*r*s + 2360*D1**2*f**2*fd*r - 1770*D1**2*f**2*fd*s**2 + 2360*D1**2*f**2*fd*s - 1180*D1**2*f**2*fd + 1155*D1**2*f**2*fdd*r**2 + 2310*D1**2*f**2*fdd*r*s - 1540*D1**2*f**2*fdd*r + 1155*D1**2*f**2*fdd*s**2 - 1540*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd + 2310*D1**2*f*fd**2*r**2 + 4620*D1**2*f*fd**2*r*s - 3080*D1**2*f*fd**2*r + 2310*D1**2*f*fd**2*s**2 - 3080*D1**2*f*fd**2*s + 770*D1**2*f*fd**2 - 2952*D1*Dd*b1*f**2*r**2 - 5904*D1*Dd*b1*f**2*r*s + 4428*D1*Dd*b1*f**2*r - 2952*D1*Dd*b1*f**2*s**2 + 4428*D1*Dd*b1*f**2*s - 2214*D1*Dd*b1*f**2 + 7920*D1*Dd*b1*f*fd*r**2 + 15840*D1*Dd*b1*f*fd*r*s - 9900*D1*Dd*b1*f*fd*r + 7920*D1*Dd*b1*f*fd*s**2 - 9900*D1*Dd*b1*f*fd*s + 2970*D1*Dd*b1*f*fd - 2360*D1*Dd*f**3*r**2 - 4720*D1*Dd*f**3*r*s + 3540*D1*Dd*f**3*r - 2360*D1*Dd*f**3*s**2 + 3540*D1*Dd*f**3*s - 1770*D1*Dd*f**3 + 9240*D1*Dd*f**2*fd*r**2 + 18480*D1*Dd*f**2*fd*r*s - 13090*D1*Dd*f**2*fd*r + 9240*D1*Dd*f**2*fd*s**2 - 13090*D1*Dd*f**2*fd*s + 4620*D1*Dd*f**2*fd + 1980*D1*Ddd*b1*f**2*r**2 + 3960*D1*Ddd*b1*f**2*r*s - 2970*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s**2 - 2970*D1*Ddd*b1*f**2*s + 1485*D1*Ddd*b1*f**2 + 1540*D1*Ddd*f**3*r**2 + 3080*D1*Ddd*f**3*r*s - 2310*D1*Ddd*f**3*r + 1540*D1*Ddd*f**3*s**2 - 2310*D1*Ddd*f**3*s + 1155*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(46*C - 41)*(r + s - 1) - D1*fd*(60*C - 55)*(2*r + 2*s - 1) - Dd*f*(60*C - 55)*(4*r + 4*s - 3)) + 5940*Dd**2*b1*f**2*r**2 + 11880*Dd**2*b1*f**2*r*s - 8910*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s**2 - 8910*Dd**2*b1*f**2*s + 2970*Dd**2*b1*f**2 + 4620*Dd**2*f**3*r**2 + 9240*Dd**2*f**3*r*s - 6930*Dd**2*f**3*r + 4620*Dd**2*f**3*s**2 - 6930*Dd**2*f**3*s + 2310*Dd**2*f**3)/(105*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**7*k1*k2**3*(9*b1*(D1**2*(f*(fd*(86*C - 76) + fdd*(45 - 50*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(45 - 50*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(86*C - 76)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(45 - 50*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(45 - 50*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(45 - 50*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(122*C - 108)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (10*C - 9)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(63 - 70*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(86*C - 76)*(r + s - 1) - fd*(50*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(45 - 50*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(122*C - 108)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(70*C - 63)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(63 - 70*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(63 - 70*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k3**6) - D1**2*Pk1*Pk3*ct**7*k1*k2*(32*C - 28)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + 2*D1*f*(14*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(2*s**2 - 2*s + 1)) - 14*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k3**4) + 4*D1**2*Pk1*Pk3*ct**7*k2**5*(504*C*D1**2*b1*f*fd*r**2 + 504*C*D1**2*b1*f*fd*r*s - 252*C*D1**2*b1*f*fd*r + 780*C*D1**2*f**2*fd*r**2 + 780*C*D1**2*f**2*fd*r*s - 780*C*D1**2*f**2*fd*r - 260*C*D1**2*f**2*fd*s + 260*C*D1**2*f**2*fd - 120*C*D1**2*f**2*fdd*r**2 - 120*C*D1**2*f**2*fdd*r*s + 120*C*D1**2*f**2*fdd*r + 40*C*D1**2*f**2*fdd*s - 40*C*D1**2*f**2*fdd - 240*C*D1**2*f*fd**2*r**2 - 240*C*D1**2*f*fd**2*r*s + 240*C*D1**2*f*fd**2*r + 80*C*D1**2*f*fd**2*s - 40*C*D1**2*f*fd**2 + 1008*C*D1*Dd*b1*f**2*r**2 + 1008*C*D1*Dd*b1*f**2*r*s - 1008*C*D1*Dd*b1*f**2*r - 252*C*D1*Dd*b1*f**2*s + 252*C*D1*Dd*b1*f**2 + 1040*C*D1*Dd*f**3*r**2 + 1040*C*D1*Dd*f**3*r*s - 1040*C*D1*Dd*f**3*r - 260*C*D1*Dd*f**3*s + 260*C*D1*Dd*f**3 - 960*C*D1*Dd*f**2*fd*r**2 - 960*C*D1*Dd*f**2*fd*r*s + 960*C*D1*Dd*f**2*fd*r + 280*C*D1*Dd*f**2*fd*s - 200*C*D1*Dd*f**2*fd - 160*C*D1*Ddd*f**3*r**2 - 160*C*D1*Ddd*f**3*r*s + 160*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s - 40*C*D1*Ddd*f**3 - 480*C*Dd**2*f**3*r**2 - 480*C*Dd**2*f**3*r*s + 480*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s - 80*C*Dd**2*f**3 - 684*D1**2*b1*f*fd*r**2 - 864*D1**2*b1*f*fd*r*s + 432*D1**2*b1*f*fd*r - 180*D1**2*b1*f*fd*s**2 + 180*D1**2*b1*f*fd*s - 90*D1**2*b1*f*fd + 90*D1**2*b1*f*fdd*r**2 + 180*D1**2*b1*f*fdd*r*s - 90*D1**2*b1*f*fdd*r + 90*D1**2*b1*f*fdd*s**2 - 90*D1**2*b1*f*fdd*s + 45*D1**2*b1*f*fdd + 90*D1**2*b1*fd**2*r**2 + 180*D1**2*b1*fd**2*r*s - 90*D1**2*b1*fd**2*r + 90*D1**2*b1*fd**2*s**2 - 90*D1**2*b1*fd**2*s + 45*D1**2*bdd1*f**2*(r + s - 1)**2 - 990*D1**2*f**2*fd*r**2 - 1200*D1**2*f**2*fd*r*s + 1060*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 540*D1**2*f**2*fd*s - 400*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 260*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 180*D1**2*f**2*fdd*s + 110*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 520*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 360*D1**2*f*fd**2*s + 110*D1**2*f*fd**2 - 1368*D1*Dd*b1*f**2*r**2 - 1728*D1*Dd*b1*f**2*r*s + 1548*D1*Dd*b1*f**2*r - 360*D1*Dd*b1*f**2*s**2 + 792*D1*Dd*b1*f**2*s - 522*D1*Dd*b1*f**2 + 720*D1*Dd*b1*f*fd*r**2 + 1440*D1*Dd*b1*f*fd*r*s - 900*D1*Dd*b1*f*fd*r + 720*D1*Dd*b1*f*fd*s**2 - 900*D1*Dd*b1*f*fd*s + 270*D1*Dd*b1*f*fd - 1320*D1*Dd*f**3*r**2 - 1600*D1*Dd*f**3*r*s + 1460*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 680*D1*Dd*f**3*s - 470*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 2150*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 1470*D1*Dd*f**2*fd*s + 620*D1*Dd*f**2*fd + 180*D1*Ddd*b1*f**2*r**2 + 360*D1*Ddd*b1*f**2*r*s - 270*D1*Ddd*b1*f**2*r + 180*D1*Ddd*b1*f**2*s**2 - 270*D1*Ddd*b1*f**2*s + 135*D1*Ddd*b1*f**2 + 300*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 370*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 250*D1*Ddd*f**3*s + 145*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(14*C*(r - 1) - 19*r - 5*s + 19) + 5*D1*fd*(2*r + 2*s - 1) + 5*Dd*f*(4*r + 4*s - 3)) + 540*Dd**2*b1*f**2*r**2 + 1080*Dd**2*b1*f**2*r*s - 810*Dd**2*b1*f**2*r + 540*Dd**2*b1*f**2*s**2 - 810*Dd**2*b1*f**2*s + 270*Dd**2*b1*f**2 + 900*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 1110*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 750*Dd**2*f**3*s + 290*Dd**2*f**3)/(315*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk3*ct**7*k2**3*(9*b1*(D1**2*(f*(2*fd*(r*(7*C - 12)*(2*s - 1) - 10*s**2 + 10*s - 5) + 5*fdd*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 5*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(2*f*(-7*C*s + r*(14*C - 24)*(2*s - 1) - 20*s**2 + 32*s - 10) + 5*fd*(2*s - 1)*(8*r + 8*s - 5)) + 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(9*bdd1*s*(r + s - 1) + 2*fd*(-13*C*s + r*(13*C - 20)*(3*s - 1) - 21*s**2 + 34*s - 7) + fdd*(4*C*s - r*(4*C - 11)*(3*s - 1) + 21*s**2 - 25*s + 7)) + fd**2*(C*(r*(8 - 24*s) + 8*s - 4) + 22*r*(3*s - 1) + 42*s**2 - 50*s + 11)) + 9*D1*bd1*(D1*(2*f*s*(7*C*(r - 1) - 12*r - 5*s + 12) + 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + 5*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(2*f*(r*(26*C - 40)*(2*s - 1) - 28*s**2 + s*(48 - 13*C) - 14) + fd*(-4*C*(2*r*(12*s - 5) - 7*s + 3) + 22*r*(12*s - 5) + 168*s**2 - 217*s + 61)) + Ddd*f*(-r*(8*C - 22)*(2*s - 1) + 28*s**2 + s*(4*C - 39) + 14)) + 5*Dd**2*f**2*(-4*C*(6*r*(2*s - 1) - 3*s + 2) + 66*r*(2*s - 1) + 84*s**2 - 117*s + 36)))/(315*d**2*k1*k3**4) - 4*D1**2*Pk1*Pk3*ct**7*k2*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + 2*D1*f*(14*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(2*s**2 - 2*s + 1)) - 14*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k1*k3**2) + 4*D1**2*Pk1*Pk3*ct**6*f*k2**6*(-33*D1**2*b1*f*fd*r**2 - 33*D1**2*b1*f*fd*r*s + 22*D1**2*b1*f*fd*r + 165*D1**2*b1*f*fdd*r**2 + 165*D1**2*b1*f*fdd*r*s - 110*D1**2*b1*f*fdd*r + 330*D1**2*b1*fd**2*r**2 + 330*D1**2*b1*fd**2*r*s - 220*D1**2*b1*fd**2*r + 55*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 140*D1**2*f**2*fd*r**2 + 140*D1**2*f**2*fd*r*s - 140*D1**2*f**2*fd*r - 35*D1**2*f**2*fd*s + 35*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r**2 + 84*D1**2*f**2*fdd*r*s - 84*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd + 252*D1**2*f*fd**2*r**2 + 252*D1**2*f*fd**2*r*s - 252*D1**2*f*fd**2*r - 63*D1**2*f*fd**2*s + 42*D1**2*f*fd**2 - 44*D1*Dd*b1*f**2*r**2 - 44*D1*Dd*b1*f**2*r*s + 44*D1*Dd*b1*f**2*r + 11*D1*Dd*b1*f**2*s - 11*D1*Dd*b1*f**2 + 1320*D1*Dd*b1*f*fd*r**2 + 1320*D1*Dd*b1*f*fd*r*s - 1100*D1*Dd*b1*f*fd*r - 165*D1*Dd*b1*f*fd*s + 110*D1*Dd*b1*f*fd + 140*D1*Dd*f**3*r**2 + 140*D1*Dd*f**3*r*s - 140*D1*Dd*f**3*r - 35*D1*Dd*f**3*s + 35*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r**2 + 672*D1*Dd*f**2*fd*r*s - 672*D1*Dd*f**2*fd*r - 168*D1*Dd*f**2*fd*s + 126*D1*Dd*f**2*fd + 220*D1*Ddd*b1*f**2*r**2 + 220*D1*Ddd*b1*f**2*r*s - 220*D1*Ddd*b1*f**2*r - 55*D1*Ddd*b1*f**2*s + 55*D1*Ddd*b1*f**2 + 84*D1*Ddd*f**3*r**2 + 84*D1*Ddd*f**3*r*s - 84*D1*Ddd*f**3*r - 21*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 - 11*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) - 5*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 660*Dd**2*b1*f**2*r**2 + 660*Dd**2*b1*f**2*r*s - 660*Dd**2*b1*f**2*r - 165*Dd**2*b1*f**2*s + 110*Dd**2*b1*f**2 + 252*Dd**2*f**3*r**2 + 252*Dd**2*f**3*r*s - 252*Dd**2*f**3*r - 63*Dd**2*f**3*s + 42*Dd**2*f**3)/(693*d**2*k1**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**6*k1**2*k2**4*(3132*C*D1**2*b1*f*fd*r**2 + 6264*C*D1**2*b1*f*fd*r*s - 3132*C*D1**2*b1*f*fd*r + 3132*C*D1**2*b1*f*fd*s**2 - 3132*C*D1**2*b1*f*fd*s + 1566*C*D1**2*b1*f*fd - 2700*C*D1**2*b1*f*fdd*r**2 - 5400*C*D1**2*b1*f*fdd*r*s + 2700*C*D1**2*b1*f*fdd*r - 2700*C*D1**2*b1*f*fdd*s**2 + 2700*C*D1**2*b1*f*fdd*s - 1350*C*D1**2*b1*f*fdd - 2700*C*D1**2*b1*fd**2*r**2 - 5400*C*D1**2*b1*fd**2*r*s + 2700*C*D1**2*b1*fd**2*r - 2700*C*D1**2*b1*fd**2*s**2 + 2700*C*D1**2*b1*fd**2*s + 3870*C*D1**2*f**2*fd*r**2 + 7740*C*D1**2*f**2*fd*r*s - 5160*C*D1**2*f**2*fd*r + 3870*C*D1**2*f**2*fd*s**2 - 5160*C*D1**2*f**2*fd*s + 2580*C*D1**2*f**2*fd - 3150*C*D1**2*f**2*fdd*r**2 - 6300*C*D1**2*f**2*fdd*r*s + 4200*C*D1**2*f**2*fdd*r - 3150*C*D1**2*f**2*fdd*s**2 + 4200*C*D1**2*f**2*fdd*s - 2100*C*D1**2*f**2*fdd - 6300*C*D1**2*f*fd**2*r**2 - 12600*C*D1**2*f*fd**2*r*s + 8400*C*D1**2*f*fd**2*r - 6300*C*D1**2*f*fd**2*s**2 + 8400*C*D1**2*f*fd**2*s - 2100*C*D1**2*f*fd**2 + 6264*C*D1*Dd*b1*f**2*r**2 + 12528*C*D1*Dd*b1*f**2*r*s - 9396*C*D1*Dd*b1*f**2*r + 6264*C*D1*Dd*b1*f**2*s**2 - 9396*C*D1*Dd*b1*f**2*s + 4698*C*D1*Dd*b1*f**2 - 21600*C*D1*Dd*b1*f*fd*r**2 - 43200*C*D1*Dd*b1*f*fd*r*s + 27000*C*D1*Dd*b1*f*fd*r - 21600*C*D1*Dd*b1*f*fd*s**2 + 27000*C*D1*Dd*b1*f*fd*s - 8100*C*D1*Dd*b1*f*fd + 5160*C*D1*Dd*f**3*r**2 + 10320*C*D1*Dd*f**3*r*s - 7740*C*D1*Dd*f**3*r + 5160*C*D1*Dd*f**3*s**2 - 7740*C*D1*Dd*f**3*s + 3870*C*D1*Dd*f**3 - 25200*C*D1*Dd*f**2*fd*r**2 - 50400*C*D1*Dd*f**2*fd*r*s + 35700*C*D1*Dd*f**2*fd*r - 25200*C*D1*Dd*f**2*fd*s**2 + 35700*C*D1*Dd*f**2*fd*s - 12600*C*D1*Dd*f**2*fd - 5400*C*D1*Ddd*b1*f**2*r**2 - 10800*C*D1*Ddd*b1*f**2*r*s + 8100*C*D1*Ddd*b1*f**2*r - 5400*C*D1*Ddd*b1*f**2*s**2 + 8100*C*D1*Ddd*b1*f**2*s - 4050*C*D1*Ddd*b1*f**2 - 4200*C*D1*Ddd*f**3*r**2 - 8400*C*D1*Ddd*f**3*r*s + 6300*C*D1*Ddd*f**3*r - 4200*C*D1*Ddd*f**3*s**2 + 6300*C*D1*Ddd*f**3*s - 3150*C*D1*Ddd*f**3 - 16200*C*Dd**2*b1*f**2*r**2 - 32400*C*Dd**2*b1*f**2*r*s + 24300*C*Dd**2*b1*f**2*r - 16200*C*Dd**2*b1*f**2*s**2 + 24300*C*Dd**2*b1*f**2*s - 8100*C*Dd**2*b1*f**2 - 12600*C*Dd**2*f**3*r**2 - 25200*C*Dd**2*f**3*r*s + 18900*C*Dd**2*f**3*r - 12600*C*Dd**2*f**3*s**2 + 18900*C*Dd**2*f**3*s - 6300*C*Dd**2*f**3 - 2484*D1**2*b1*f*fd*r**2 - 4968*D1**2*b1*f*fd*r*s + 2484*D1**2*b1*f*fd*r - 2484*D1**2*b1*f*fd*s**2 + 2484*D1**2*b1*f*fd*s - 1242*D1**2*b1*f*fd + 2250*D1**2*b1*f*fdd*r**2 + 4500*D1**2*b1*f*fdd*r*s - 2250*D1**2*b1*f*fdd*r + 2250*D1**2*b1*f*fdd*s**2 - 2250*D1**2*b1*f*fdd*s + 1125*D1**2*b1*f*fdd + 2250*D1**2*b1*fd**2*r**2 + 4500*D1**2*b1*fd**2*r*s - 2250*D1**2*b1*fd**2*r + 2250*D1**2*b1*fd**2*s**2 - 2250*D1**2*b1*fd**2*s - 225*D1**2*bdd1*f**2*(6*C - 5)*(r + s - 1)**2 - 3090*D1**2*f**2*fd*r**2 - 6180*D1**2*f**2*fd*r*s + 4120*D1**2*f**2*fd*r - 3090*D1**2*f**2*fd*s**2 + 4120*D1**2*f**2*fd*s - 2060*D1**2*f**2*fd + 2625*D1**2*f**2*fdd*r**2 + 5250*D1**2*f**2*fdd*r*s - 3500*D1**2*f**2*fdd*r + 2625*D1**2*f**2*fdd*s**2 - 3500*D1**2*f**2*fdd*s + 1750*D1**2*f**2*fdd + 5250*D1**2*f*fd**2*r**2 + 10500*D1**2*f*fd**2*r*s - 7000*D1**2*f*fd**2*r + 5250*D1**2*f*fd**2*s**2 - 7000*D1**2*f*fd**2*s + 1750*D1**2*f*fd**2 - 4968*D1*Dd*b1*f**2*r**2 - 9936*D1*Dd*b1*f**2*r*s + 7452*D1*Dd*b1*f**2*r - 4968*D1*Dd*b1*f**2*s**2 + 7452*D1*Dd*b1*f**2*s - 3726*D1*Dd*b1*f**2 + 18000*D1*Dd*b1*f*fd*r**2 + 36000*D1*Dd*b1*f*fd*r*s - 22500*D1*Dd*b1*f*fd*r + 18000*D1*Dd*b1*f*fd*s**2 - 22500*D1*Dd*b1*f*fd*s + 6750*D1*Dd*b1*f*fd - 4120*D1*Dd*f**3*r**2 - 8240*D1*Dd*f**3*r*s + 6180*D1*Dd*f**3*r - 4120*D1*Dd*f**3*s**2 + 6180*D1*Dd*f**3*s - 3090*D1*Dd*f**3 + 21000*D1*Dd*f**2*fd*r**2 + 42000*D1*Dd*f**2*fd*r*s - 29750*D1*Dd*f**2*fd*r + 21000*D1*Dd*f**2*fd*s**2 - 29750*D1*Dd*f**2*fd*s + 10500*D1*Dd*f**2*fd + 4500*D1*Ddd*b1*f**2*r**2 + 9000*D1*Ddd*b1*f**2*r*s - 6750*D1*Ddd*b1*f**2*r + 4500*D1*Ddd*b1*f**2*s**2 - 6750*D1*Ddd*b1*f**2*s + 3375*D1*Ddd*b1*f**2 + 3500*D1*Ddd*f**3*r**2 + 7000*D1*Ddd*f**3*r*s - 5250*D1*Ddd*f**3*r + 3500*D1*Ddd*f**3*s**2 - 5250*D1*Ddd*f**3*s + 2625*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(87*C - 69)*(r + s - 1) - D1*fd*(150*C - 125)*(2*r + 2*s - 1) - Dd*f*(150*C - 125)*(4*r + 4*s - 3)) + 13500*Dd**2*b1*f**2*r**2 + 27000*Dd**2*b1*f**2*r*s - 20250*Dd**2*b1*f**2*r + 13500*Dd**2*b1*f**2*s**2 - 20250*Dd**2*b1*f**2*s + 6750*Dd**2*b1*f**2 + 10500*Dd**2*f**3*r**2 + 21000*Dd**2*f**3*r*s - 15750*Dd**2*f**3*r + 10500*Dd**2*f**3*s**2 - 15750*Dd**2*f**3*s + 5250*Dd**2*f**3)/(105*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**6*k1**2*k2**2*(9*b1*(D1**2*(f*(fd*(144*C - 111) + fdd*(80 - 100*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(80 - 100*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(144*C - 111)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(80 - 100*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(80 - 100*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(80 - 100*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(208*C - 161)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 16)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(112 - 140*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(144*C - 111)*(r + s - 1) - fd*(100*C - 80)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(80 - 100*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(208*C - 161)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(140*C - 112)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(112 - 140*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(112 - 140*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k3**6) - D1**2*Pk1*Pk3*ct**6*k1**2*(16*C - 12)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + 2*D1*f*(14*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(2*s**2 - 2*s + 1)) - 14*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k3**4) - D1**2*Pk1*Pk3*ct**6*k2**6*st**2*(8*C - 8)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 20*D1**2*f**2*fdd*s - 10*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 40*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 170*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 170*D1*Dd*f**2*fd*s - 60*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 30*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 30*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 90*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 90*Dd**2*f**3*s - 30*Dd**2*f**3)/(7*d**2*k3**8) + 4*D1**2*Pk1*Pk3*ct**6*k2**6*(2970*C*D1**2*f**2*fd*r**2 + 5940*C*D1**2*f**2*fd*r*s - 3960*C*D1**2*f**2*fd*r + 2970*C*D1**2*f**2*fd*s**2 - 3960*C*D1**2*f**2*fd*s + 1980*C*D1**2*f**2*fd + 3960*C*D1*Dd*f**3*r**2 + 7920*C*D1*Dd*f**3*r*s - 5940*C*D1*Dd*f**3*r + 3960*C*D1*Dd*f**3*s**2 - 5940*C*D1*Dd*f**3*s + 2970*C*D1*Dd*f**3 + 495*D1**2*K*bdd1*f**2*r**2 + 990*D1**2*K*bdd1*f**2*r*s - 990*D1**2*K*bdd1*f**2*r + 495*D1**2*K*bdd1*f**2*s**2 - 990*D1**2*K*bdd1*f**2*s + 495*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(-7*K + 5*f + 7)*(r + s - 1)**2 + 1540*D1**2*bdd1*f**3*r**2 + 3080*D1**2*bdd1*f**3*r*s - 3080*D1**2*bdd1*f**3*r + 1540*D1**2*bdd1*f**3*s**2 - 3080*D1**2*bdd1*f**3*s + 1540*D1**2*bdd1*f**3 - 495*D1**2*bdd1*f**2*r**2 - 990*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*r - 495*D1**2*bdd1*f**2*s**2 + 990*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 1386*D1**2*bdd1*f*g2*r**2 - 2772*D1**2*bdd1*f*g2*r*s + 2772*D1**2*bdd1*f*g2*r - 1386*D1**2*bdd1*f*g2*s**2 + 2772*D1**2*bdd1*f*g2*s - 1386*D1**2*bdd1*f*g2 - 9520*D1**2*f**3*fd*r**2 - 19040*D1**2*f**3*fd*r*s + 14280*D1**2*f**3*fd*r - 9520*D1**2*f**3*fd*s**2 + 14280*D1**2*f**3*fd*s - 7140*D1**2*f**3*fd + 6300*D1**2*f**3*fdd*r**2 + 12600*D1**2*f**3*fdd*r*s - 9450*D1**2*f**3*fdd*r + 6300*D1**2*f**3*fdd*s**2 - 9450*D1**2*f**3*fdd*s + 4725*D1**2*f**3*fdd + 18900*D1**2*f**2*fd**2*r**2 + 37800*D1**2*f**2*fd**2*r*s - 28350*D1**2*f**2*fd**2*r + 18900*D1**2*f**2*fd**2*s**2 - 28350*D1**2*f**2*fd**2*s + 9450*D1**2*f**2*fd**2 - 2970*D1**2*f**2*fd*r**2 - 5940*D1**2*f**2*fd*r*s + 3960*D1**2*f**2*fd*r - 2970*D1**2*f**2*fd*s**2 + 3960*D1**2*f**2*fd*s - 1980*D1**2*f**2*fd + 1980*D1**2*f**2*gd2*r**2 + 3960*D1**2*f**2*gd2*r*s - 3960*D1**2*f**2*gd2*r + 1980*D1**2*f**2*gd2*s**2 - 3960*D1**2*f**2*gd2*s + 1980*D1**2*f**2*gd2 - 990*D1**2*f**2*gdd2*r**2 - 1980*D1**2*f**2*gdd2*r*s + 1980*D1**2*f**2*gdd2*r - 990*D1**2*f**2*gdd2*s**2 + 1980*D1**2*f**2*gdd2*s - 990*D1**2*f**2*gdd2 + 3960*D1**2*f*fd*g2*r**2 + 7920*D1**2*f*fd*g2*r*s - 3960*D1**2*f*fd*g2*r + 3960*D1**2*f*fd*g2*s**2 - 3960*D1**2*f*fd*g2*s + 1980*D1**2*f*fd*g2 - 3960*D1**2*f*fd*gd2*r**2 - 7920*D1**2*f*fd*gd2*r*s + 5940*D1**2*f*fd*gd2*r - 3960*D1**2*f*fd*gd2*s**2 + 5940*D1**2*f*fd*gd2*s - 1980*D1**2*f*fd*gd2 - 1980*D1**2*f*fdd*g2*r**2 - 3960*D1**2*f*fdd*g2*r*s + 1980*D1**2*f*fdd*g2*r - 1980*D1**2*f*fdd*g2*s**2 + 1980*D1**2*f*fdd*g2*s - 990*D1**2*f*fdd*g2 - 1980*D1**2*fd**2*g2*r**2 - 3960*D1**2*fd**2*g2*r*s + 1980*D1**2*fd**2*g2*r - 1980*D1**2*fd**2*g2*s**2 + 1980*D1**2*fd**2*g2*s - 9520*D1*Dd*f**4*r**2 - 19040*D1*Dd*f**4*r*s + 14280*D1*Dd*f**4*r - 9520*D1*Dd*f**4*s**2 + 14280*D1*Dd*f**4*s - 7140*D1*Dd*f**4 + 50400*D1*Dd*f**3*fd*r**2 + 100800*D1*Dd*f**3*fd*r*s - 75600*D1*Dd*f**3*fd*r + 50400*D1*Dd*f**3*fd*s**2 - 75600*D1*Dd*f**3*fd*s + 28350*D1*Dd*f**3*fd - 3960*D1*Dd*f**3*r**2 - 7920*D1*Dd*f**3*r*s + 5940*D1*Dd*f**3*r - 3960*D1*Dd*f**3*s**2 + 5940*D1*Dd*f**3*s - 2970*D1*Dd*f**3 + 7920*D1*Dd*f**2*g2*r**2 + 15840*D1*Dd*f**2*g2*r*s - 11880*D1*Dd*f**2*g2*r + 7920*D1*Dd*f**2*g2*s**2 - 11880*D1*Dd*f**2*g2*s + 5940*D1*Dd*f**2*g2 - 7920*D1*Dd*f**2*gd2*r**2 - 15840*D1*Dd*f**2*gd2*r*s + 13860*D1*Dd*f**2*gd2*r - 7920*D1*Dd*f**2*gd2*s**2 + 13860*D1*Dd*f**2*gd2*s - 5940*D1*Dd*f**2*gd2 - 15840*D1*Dd*f*fd*g2*r**2 - 31680*D1*Dd*f*fd*g2*r*s + 19800*D1*Dd*f*fd*g2*r - 15840*D1*Dd*f*fd*g2*s**2 + 19800*D1*Dd*f*fd*g2*s - 5940*D1*Dd*f*fd*g2 + 6300*D1*Ddd*f**4*r**2 + 12600*D1*Ddd*f**4*r*s - 9450*D1*Ddd*f**4*r + 6300*D1*Ddd*f**4*s**2 - 9450*D1*Ddd*f**4*s + 4725*D1*Ddd*f**4 - 3960*D1*Ddd*f**2*g2*r**2 - 7920*D1*Ddd*f**2*g2*r*s + 5940*D1*Ddd*f**2*g2*r - 3960*D1*Ddd*f**2*g2*s**2 + 5940*D1*Ddd*f**2*g2*s - 2970*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(95*f**3*(r + s - 1) + f**2*(-63*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) + (45*K + 18)*(r + s - 1)) - 9*f*(5*fd*(K - 1)*(2*r + 2*s - 1) + (14*g2 - 14*gd2)*(r + s - 1)) + 126*fd*g2*(r + s)) - Dd*f*(140*f**2 + 45*f*(K - 1) - 126*g2)*(4*r + 4*s - 3))*(r + s - 1) + 18900*Dd**2*f**4*r**2 + 37800*Dd**2*f**4*r*s - 28350*Dd**2*f**4*r + 18900*Dd**2*f**4*s**2 - 28350*Dd**2*f**4*s + 9450*Dd**2*f**4 - 11880*Dd**2*f**2*g2*r**2 - 23760*Dd**2*f**2*g2*r*s + 17820*Dd**2*f**2*g2*r - 11880*Dd**2*f**2*g2*s**2 + 17820*Dd**2*f**2*g2*s - 5940*Dd**2*f**2*g2 + 99*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(K - 1)*(r + s) - 7*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (7*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-7*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-7*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(252*C*D1**2*f*fd*r**2 + 504*C*D1**2*f*fd*r*s - 252*C*D1**2*f*fd*r + 252*C*D1**2*f*fd*s**2 - 252*C*D1**2*f*fd*s + 126*C*D1**2*f*fd + 504*C*D1*Dd*f**2*r**2 + 1008*C*D1*Dd*f**2*r*s - 756*C*D1*Dd*f**2*r + 504*C*D1*Dd*f**2*s**2 - 756*C*D1*Dd*f**2*s + 378*C*D1*Dd*f**2 - 180*D1**2*K*f*fd*r**2 - 360*D1**2*K*f*fd*r*s + 180*D1**2*K*f*fd*r - 180*D1**2*K*f*fd*s**2 + 180*D1**2*K*f*fd*s - 90*D1**2*K*f*fd + 90*D1**2*K*f*fdd*r**2 + 180*D1**2*K*f*fdd*r*s - 90*D1**2*K*f*fdd*r + 90*D1**2*K*f*fdd*s**2 - 90*D1**2*K*f*fdd*s + 45*D1**2*K*f*fdd + 90*D1**2*K*fd**2*r**2 + 180*D1**2*K*fd**2*r*s - 90*D1**2*K*fd**2*r + 90*D1**2*K*fd**2*s**2 - 90*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(-7*K + 5*f + 7)*(r + s - 1)**2 - 570*D1**2*f**2*fd*r**2 - 1140*D1**2*f**2*fd*r*s + 760*D1**2*f**2*fd*r - 570*D1**2*f**2*fd*s**2 + 760*D1**2*f**2*fd*s - 380*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 72*D1**2*f*fd*r**2 - 144*D1**2*f*fd*r*s + 72*D1**2*f*fd*r - 72*D1**2*f*fd*s**2 + 72*D1**2*f*fd*s - 36*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 45*D1**2*f*fdd + 252*D1**2*f*gd2*r**2 + 504*D1**2*f*gd2*r*s - 504*D1**2*f*gd2*r + 252*D1**2*f*gd2*s**2 - 504*D1**2*f*gd2*s + 252*D1**2*f*gd2 - 126*D1**2*f*gdd2*r**2 - 252*D1**2*f*gdd2*r*s + 252*D1**2*f*gdd2*r - 126*D1**2*f*gdd2*s**2 + 252*D1**2*f*gdd2*s - 126*D1**2*f*gdd2 - 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 252*D1**2*fd*g2*r**2 + 504*D1**2*fd*g2*r*s + 252*D1**2*fd*g2*s**2 - 252*D1**2*fd*gd2*r**2 - 504*D1**2*fd*gd2*r*s + 252*D1**2*fd*gd2*r - 252*D1**2*fd*gd2*s**2 + 252*D1**2*fd*gd2*s - 126*D1**2*fdd*g2*r**2 - 252*D1**2*fdd*g2*r*s - 126*D1**2*fdd*g2*s**2 - 360*D1*Dd*K*f**2*r**2 - 720*D1*Dd*K*f**2*r*s + 540*D1*Dd*K*f**2*r - 360*D1*Dd*K*f**2*s**2 + 540*D1*Dd*K*f**2*s - 270*D1*Dd*K*f**2 + 720*D1*Dd*K*f*fd*r**2 + 1440*D1*Dd*K*f*fd*r*s - 900*D1*Dd*K*f*fd*r + 720*D1*Dd*K*f*fd*s**2 - 900*D1*Dd*K*f*fd*s + 270*D1*Dd*K*f*fd - 760*D1*Dd*f**3*r**2 - 1520*D1*Dd*f**3*r*s + 1140*D1*Dd*f**3*r - 760*D1*Dd*f**3*s**2 + 1140*D1*Dd*f**3*s - 570*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 144*D1*Dd*f**2*r**2 - 288*D1*Dd*f**2*r*s + 216*D1*Dd*f**2*r - 144*D1*Dd*f**2*s**2 + 216*D1*Dd*f**2*s - 108*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 900*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 270*D1*Dd*f*fd + 1008*D1*Dd*f*g2*r**2 + 2016*D1*Dd*f*g2*r*s - 1512*D1*Dd*f*g2*r + 1008*D1*Dd*f*g2*s**2 - 1512*D1*Dd*f*g2*s + 756*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 2016*D1*Dd*f*gd2*r*s + 1764*D1*Dd*f*gd2*r - 1008*D1*Dd*f*gd2*s**2 + 1764*D1*Dd*f*gd2*s - 756*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 2016*D1*Dd*fd*g2*r*s + 756*D1*Dd*fd*g2*r - 1008*D1*Dd*fd*g2*s**2 + 756*D1*Dd*fd*g2*s + 180*D1*Ddd*K*f**2*r**2 + 360*D1*Ddd*K*f**2*r*s - 270*D1*Ddd*K*f**2*r + 180*D1*Ddd*K*f**2*s**2 - 270*D1*Ddd*K*f**2*s + 135*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 1008*D1*Ddd*f*g2*r*s + 756*D1*Ddd*f*g2*r - 504*D1*Ddd*f*g2*s**2 + 756*D1*Ddd*f*g2*s - 378*D1*Ddd*f*g2 + 36*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(K - 1)*(r + s - 1) + 7*fd*(K - 1)*(r + s)) - Dd*f*(-7*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 540*Dd**2*K*f**2*r**2 + 1080*Dd**2*K*f**2*r*s - 810*Dd**2*K*f**2*r + 540*Dd**2*K*f**2*s**2 - 810*Dd**2*K*f**2*s + 270*Dd**2*K*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 270*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 3024*Dd**2*f*g2*r*s + 2268*Dd**2*f*g2*r - 1512*Dd**2*f*g2*s**2 + 2268*Dd**2*f*g2*s - 756*Dd**2*f*g2))/(1155*d**2*k3**8) - D1**2*Pk1*Pk3*ct**6*k2**4*st**2*(16*C - 16)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 10*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 5*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**6*k2**4*(126*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(-234*C*D1**2*f*fd*r**2 - 412*C*D1**2*f*fd*r*s + 166*C*D1**2*f*fd*r - 178*C*D1**2*f*fd*s**2 + 138*C*D1**2*f*fd*s - 69*C*D1**2*f*fd + 110*C*D1**2*f*fdd*r**2 + 276*C*D1**2*f*fdd*r*s - 118*C*D1**2*f*fdd*r + 166*C*D1**2*f*fdd*s**2 - 146*C*D1**2*f*fdd*s + 73*C*D1**2*f*fdd + 110*C*D1**2*fd**2*r**2 + 276*C*D1**2*fd**2*r*s - 118*C*D1**2*fd**2*r + 166*C*D1**2*fd**2*s**2 - 146*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 468*C*D1*Dd*f**2*r**2 - 824*C*D1*Dd*f**2*r*s + 646*C*D1*Dd*f**2*r - 356*C*D1*Dd*f**2*s**2 + 562*C*D1*Dd*f**2*s - 295*C*D1*Dd*f**2 + 880*C*D1*Dd*f*fd*r**2 + 2208*C*D1*Dd*f*fd*r*s - 1244*C*D1*Dd*f*fd*r + 1328*C*D1*Dd*f*fd*s**2 - 1524*C*D1*Dd*f*fd*s + 410*C*D1*Dd*f*fd + 220*C*D1*Ddd*f**2*r**2 + 552*C*D1*Ddd*f**2*r*s - 386*C*D1*Ddd*f**2*r + 332*C*D1*Ddd*f**2*s**2 - 470*C*D1*Ddd*f**2*s + 221*C*D1*Ddd*f**2 + 660*C*Dd**2*f**2*r**2 + 1656*C*Dd**2*f**2*r*s - 1158*C*Dd**2*f**2*r + 996*C*Dd**2*f**2*s**2 - 1410*C*Dd**2*f**2*s + 442*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 246*D1**2*f*fd*r**2 + 456*D1**2*f*fd*r*s - 188*D1**2*f*fd*r + 210*D1**2*f*fd*s**2 - 170*D1**2*f*fd*s + 85*D1**2*f*fd - 130*D1**2*f*fdd*r**2 - 326*D1**2*f*fdd*r*s + 143*D1**2*f*fdd*r - 196*D1**2*f*fdd*s**2 + 176*D1**2*f*fdd*s - 88*D1**2*f*fdd - 130*D1**2*fd**2*r**2 - 326*D1**2*fd**2*r*s + 143*D1**2*fd**2*r - 196*D1**2*fd**2*s**2 + 176*D1**2*fd**2*s + 20*D1**2*fd**2 + 492*D1*Dd*f**2*r**2 + 912*D1*Dd*f**2*r*s - 702*D1*Dd*f**2*r + 420*D1*Dd*f**2*s**2 - 648*D1*Dd*f**2*s + 333*D1*Dd*f**2 - 1040*D1*Dd*f*fd*r**2 - 2608*D1*Dd*f*fd*r*s + 1484*D1*Dd*f*fd*r - 1568*D1*Dd*f*fd*s**2 + 1814*D1*Dd*f*fd*s - 495*D1*Dd*f*fd - 260*D1*Ddd*f**2*r**2 - 652*D1*Ddd*f**2*r*s + 456*D1*Ddd*f**2*r - 392*D1*Ddd*f**2*s**2 + 555*D1*Ddd*f**2*s - 261*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 780*Dd**2*f**2*r**2 - 1956*Dd**2*f**2*r*s + 1368*Dd**2*f**2*r - 1176*Dd**2*f**2*s**2 + 1665*Dd**2*f**2*s - 522*Dd**2*f**2) + f*(-252*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(C*(55*r**2 + 2*r*(69*s - 65) + 83*s**2 - 158*s + 65) - 65*r**2 + r*(150 - 163*s) - 98*s**2 + 183*s - 75) - 5*D1**2*(f*(fd*(C*(789*r**2 + 1230*r*s - 936*r + 441*s**2 - 704*s + 410) - 795*r**2 - 1308*r*s + 966*r - 513*s**2 + 778*s - 436) + fdd*(-C*(381*r**2 + 750*r*s - 504*r + 369*s**2 - 496*s + 250) + 411*r**2 + 843*r*s - 555*r + 432*s**2 - 569*s + 281)) + fd**2*(-2*C*(381*r**2 + 6*r*(125*s - 84) + 369*s**2 - 496*s + 125) + 822*r**2 + 6*r*(281*s - 185) + 864*s**2 - 1138*s + 281)) - 9*D1*bd1*(D1*(f*(C*(117*r**2 + 206*r*s - 274*r + 89*s**2 - 246*s + 137) - 123*r**2 - 228*r*s + 286*r - 105*s**2 + 268*s - 143) + fd*(-2*C*(110*r**2 + 3*r*(92*s - 63) + 166*s**2 - 231*s + 79) + 260*r**2 + 652*r*s - 443*r + 392*s**2 - 542*s + 183)) + Dd*f*(-2*C*(220*r**2 + r*(552*s - 453) + 332*s**2 - 551*s + 223) + 520*r**2 + 8*r*(163*s - 132) + 784*s**2 - 1287*s + 516)) - 5*D1*f*(Dd*(f*(C*(1052*r**2 + 2*r*(820*s - 673) + 588*s**2 - 998*s + 557) - 1060*r**2 - 1744*r*s + 1402*r - 684*s**2 + 1120*s - 607) + fd*(-2*C*(1524*r**2 + 3000*r*s - 2139*r + 1476*s**2 - 2105*s + 748) + 3288*r**2 + 6744*r*s - 4728*r + 3456*s**2 - 4847*s + 1693)) + Ddd*f*(-C*(508*r**2 + 1000*r*s - 754*r + 492*s**2 - 742*s + 373) + 548*r**2 + 1124*r*s - 836*r + 576*s**2 - 857*s + 425)) - 5*Dd**2*f**2*(-2*C*(762*r**2 + 3*r*(500*s - 377) + 738*s**2 - 1113*s + 373) + 1644*r**2 + 12*r*(281*s - 209) + 1728*s**2 - 2571*s + 850)))/(315*d**2*k3**6) - D1**2*Pk1*Pk3*ct**6*k2**2*st**2*(8*C - 8)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k3**4) - 2*D1**2*Pk1*Pk3*ct**6*k2**2*(252*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 9*b1*(D1**2*(f*(-28*bdd1*s*(C - 1)*(2*r + 2*s - 1) + fd*(C*(-248*r*s + 124*r - 178*s**2 + 138*s - 89) + 280*r*s - 140*r + 230*s**2 - 190*s + 115) + fdd*(C*(96*r*s - 48*r + 166*s**2 - 146*s + 83) - 126*r*s + 63*r - 206*s**2 + 186*s - 103)) + fd**2*(2*C*(24*r*(2*s - 1) + 83*s**2 - 73*s - 10) - 63*r*(2*s - 1) - 206*s**2 + 186*s + 20)) - 28*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(-2*C*(124*r*(2*s - 1) + 178*s**2 - 240*s + 89) + 280*r*(2*s - 1) + 460*s**2 - 600*s + 230) + fd*(2*s - 1)*(4*C*(96*r + 166*s - 85) - 504*r - 824*s + 435)) + Ddd*f*(2*C*(96*r*s - 48*r + 166*s**2 - 190*s + 83) - 252*r*s + 126*r - 412*s**2 + 475*s - 206)) + Dd**2*f**2*(2*C*(144*r*(2*s - 1) + 498*s**2 - 570*s + 131) - 378*r*(2*s - 1) - 1236*s**2 + 1425*s - 332)) + f*(-252*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1**2*(f*(9*bdd1*s*(C*(48*r + 83*s - 68) - 63*r - 103*s + 83) - 5*fd*(C*(284*r*(3*s - 1) + 525*s**2 - 634*s + 175) - 900*r*s + 300*r - 639*s**2 + 726*s - 213) + 5*fdd*(C*(124*r*(3*s - 1) + 411*s**2 - 398*s + 137) - 141*r*(3*s - 1) - 495*s**2 + 471*s - 165)) + 5*fd**2*(2*C*(124*r*(3*s - 1) + 411*s**2 - 398*s + 62) - 282*r*(3*s - 1) - 990*s**2 + 942*s - 141)) - 9*D1*bd1*(D1*(f*s*(C*(124*r + 89*s - 164) - 140*r - 115*s + 180) + fd*(-2*C*(24*r*(4*s - 1) + 166*s**2 - 141*s + 34) + 63*r*(4*s - 1) + 412*s**2 - 352*s + 83)) + Dd*f*(-4*C*(24*r*(4*s - 1) + 166*s**2 - 163*s + 34) + 126*r*(4*s - 1) + 824*s**2 - 807*s + 166)) - 5*D1*f*(Dd*(2*f*(C*(284*r*(2*s - 1) + 350*s**2 - 492*s + 175) - 600*r*s + 300*r - 426*s**2 + 576*s - 213) + fd*(-8*C*(31*r*(12*s - 5) + 411*s**2 - 451*s + 115) + 282*r*(12*s - 5) + 3960*s**2 - 4287*s + 1083)) + Ddd*f*(C*(-248*r*(2*s - 1) - 548*s**2 + 672*s - 274) + 282*r*(2*s - 1) + 660*s**2 - 801*s + 330)) + 15*Dd**2*f**2*(2*C*(124*r*(2*s - 1) + 274*s**2 - 336*s + 87) - 282*r*(2*s - 1) - 660*s**2 + 801*s - 204)))/(315*d**2*k3**4) - 4*D1**2*Pk1*Pk3*ct**6*(126*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + 9*b1*(D1**2*(f*(10*fd*(2*s**2 - 2*s + 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(C - 1)*(56*bd1 - 28*bdd1)) - 2*fd*s*(s - 1)*(28*bd1*(C - 1) + 5*fd)) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(28*bd1*s*(C - 1) + 5*fd*(2*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(-5*f*(fd*(28*C - 42)*(3*s**2 - 2*s + 1) - fdd*(14*C - 21)*(3*s**2 - 2*s + 1) + s**2*(-18*bd1 + 9*bdd1)) + 2*s*(-126*bd1**2*s*(C - 1) + 45*bd1*fd*(1 - 2*s) + fd**2*(70*C - 105)*(3*s - 2))) - 10*D1*f*(Dd*f*(28*C - 42)*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(-9*bd1*s + fd*(14*C - 21)*(3*s - 1)) - Ddd*f*(14*C - 21)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(140*C - 210)*(6*s**2 - 6*s + 1)))/(315*d**2*k3**2) - 2*D1**2*Pk1*Pk3*ct**6*k2**4*(306*C*D1**2*b1*f*fd*r**2 + 36*C*D1**2*b1*f*fdd*r**2 + 36*C*D1**2*b1*fd**2*r**2 + 429*C*D1**2*f**2*fd*r**2 - 286*C*D1**2*f**2*fd*r + 143*C*D1**2*f**2*fd + 96*C*D1**2*f**2*fdd*r**2 - 64*C*D1**2*f**2*fdd*r + 32*C*D1**2*f**2*fdd + 192*C*D1**2*f*fd**2*r**2 - 128*C*D1**2*f*fd**2*r + 612*C*D1*Dd*b1*f**2*r**2 - 306*C*D1*Dd*b1*f**2*r + 153*C*D1*Dd*b1*f**2 + 288*C*D1*Dd*b1*f*fd*r**2 - 72*C*D1*Dd*b1*f*fd*r + 572*C*D1*Dd*f**3*r**2 - 286*C*D1*Dd*f**3*r + 143*C*D1*Dd*f**3 + 768*C*D1*Dd*f**2*fd*r**2 - 448*C*D1*Dd*f**2*fd*r + 64*C*D1*Dd*f**2*fd + 72*C*D1*Ddd*b1*f**2*r**2 - 36*C*D1*Ddd*b1*f**2*r + 18*C*D1*Ddd*b1*f**2 + 128*C*D1*Ddd*f**3*r**2 - 64*C*D1*Ddd*f**3*r + 32*C*D1*Ddd*f**3 + 216*C*Dd**2*b1*f**2*r**2 - 108*C*Dd**2*b1*f**2*r + 384*C*Dd**2*f**3*r**2 - 192*C*Dd**2*f**3*r - 378*D1**2*b1*f*fd*r**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r - 126*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 126*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(r - 1)*(2*C*(r - 1) - 7*r - 5*s + 7) - 609*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 466*D1**2*f**2*fd*r + 60*D1**2*f**2*fd*s - 203*D1**2*f**2*fd - 141*D1**2*f**2*fdd*r**2 - 45*D1**2*f**2*fdd*r*s + 109*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s - 47*D1**2*f**2*fdd - 282*D1**2*f*fd**2*r**2 - 90*D1**2*f*fd**2*r*s + 218*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s - 15*D1**2*f*fd**2 - 756*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 450*D1*Dd*b1*f**2*r + 36*D1*Dd*b1*f**2*s - 189*D1*Dd*b1*f**2 - 1008*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 612*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd - 812*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 526*D1*Dd*f**3*r + 60*D1*Dd*f**3*s - 203*D1*Dd*f**3 - 1128*D1*Dd*f**2*fd*r**2 - 360*D1*Dd*f**2*fd*r*s + 808*D1*Dd*f**2*fd*r + 105*D1*Dd*f**2*fd*s - 139*D1*Dd*f**2*fd - 252*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 216*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 63*D1*Ddd*b1*f**2 - 188*D1*Ddd*f**3*r**2 - 60*D1*Ddd*f**3*r*s + 124*D1*Ddd*f**3*r + 15*D1*Ddd*f**3*s - 47*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(f*(r - 1)*(17*C*(r - 1) - 21*r - 4*s + 21) + fd*(r**2*(8*C - 28) + r*(-8*C - 20*s + 33) + 10*s - 5)) + Dd*f*(4*C*(4*r**2 - 5*r + 1) - 56*r**2 - 40*r*(s - 2) + 25*s - 24)) - 756*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 648*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 564*Dd**2*f**3*r**2 - 180*Dd**2*f**3*r*s + 372*Dd**2*f**3*r + 45*Dd**2*f**3*s - 30*Dd**2*f**3)/(315*d**2*k1**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**6*k2**2*(3*D1*bd1*f*(D1*(4*f*s*(r - 1) + 5*fd*(4*r*s - r - 2*s + 1)) + 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) + 3*b1*(D1*Dd*f*(8*f*r*(2*s - 1) - 4*f*s + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(D1*r*(2*s - 1)*(4*f*fd + 5*f*fdd + 5*fd**2) + 5*Ddd*f**2*(r*(4*s - 2) - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + 5*f*(D1*Dd*f*(4*f*(r*(4*s - 2) - s) + fd*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(4*f*fd*(r*(3*s - 1) - s) + f*(3*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) + fd**2*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(r*(4*s - 2) - s)) + Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k1**2*k3**2) - 4*D1**2*Pk1*Pk3*ct**5*f*k2**7*st**2*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 88*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 88*D1**2*b1*f*fd*s + 44*D1**2*b1*f*fd - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 44*D1**2*b1*f*fdd*r - 33*D1**2*b1*f*fdd*s**2 + 44*D1**2*b1*f*fdd*s - 22*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 88*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 88*D1**2*b1*fd**2*s - 22*D1**2*b1*fd**2 - 11*D1**2*bdd1*f**2*(r + s - 1)**2 + 56*D1**2*f**2*fd*r**2 + 112*D1**2*f**2*fd*r*s - 84*D1**2*f**2*fd*r + 56*D1**2*f**2*fd*s**2 - 84*D1**2*f**2*fd*s + 42*D1**2*f**2*fd - 28*D1**2*f**2*fdd*r**2 - 56*D1**2*f**2*fdd*r*s + 42*D1**2*f**2*fdd*r - 28*D1**2*f**2*fdd*s**2 + 42*D1**2*f**2*fdd*s - 21*D1**2*f**2*fdd - 84*D1**2*f*fd**2*r**2 - 168*D1**2*f*fd**2*r*s + 126*D1**2*f*fd**2*r - 84*D1**2*f*fd**2*s**2 + 126*D1**2*f*fd**2*s - 42*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 176*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r + 88*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 374*D1*Dd*b1*f*fd*r - 264*D1*Dd*b1*f*fd*s**2 + 374*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 56*D1*Dd*f**3*r**2 + 112*D1*Dd*f**3*r*s - 84*D1*Dd*f**3*r + 56*D1*Dd*f**3*s**2 - 84*D1*Dd*f**3*s + 42*D1*Dd*f**3 - 224*D1*Dd*f**2*fd*r**2 - 448*D1*Dd*f**2*fd*r*s + 336*D1*Dd*f**2*fd*r - 224*D1*Dd*f**2*fd*s**2 + 336*D1*Dd*f**2*fd*s - 126*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 - 88*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r - 44*D1*Ddd*b1*f**2*s**2 + 66*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 - 56*D1*Ddd*f**3*r*s + 42*D1*Ddd*f**3*r - 28*D1*Ddd*f**3*s**2 + 42*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 + 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 132*Dd**2*b1*f**2*r**2 - 264*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r - 132*Dd**2*b1*f**2*s**2 + 198*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 84*Dd**2*f**3*r**2 - 168*Dd**2*f**3*r*s + 126*Dd**2*f**3*r - 84*Dd**2*f**3*s**2 + 126*Dd**2*f**3*s - 42*Dd**2*f**3)/(11*d**2*k1*k3**8) - D1**2*Pk1*Pk3*ct**5*f*k2**5*(363*D1**2*b1*f*fd*r**2 - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 11*D1**2*bdd1*f**2*(r - 1)**2 + 460*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd + 100*D1**2*f**2*fdd*r**2 - 50*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r + 484*D1*Dd*b1*f**2*r**2 - 242*D1*Dd*b1*f**2*r + 121*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 + 66*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 + 800*D1*Dd*f**2*fd*r**2 - 400*D1*Dd*f**2*fd*r + 50*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 + 22*D1*Ddd*b1*f**2*r - 11*D1*Ddd*b1*f**2 + 100*D1*Ddd*f**3*r**2 - 50*D1*Ddd*f**3*r + 25*D1*Ddd*f**3 + 11*D1*bd1*f*(r - 1)*(11*D1*f*(r - 1) - 6*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 132*Dd**2*b1*f**2*r**2 + 66*Dd**2*b1*f**2*r + 300*Dd**2*f**3*r**2 - 150*Dd**2*f**3*r)/(693*d**2*k1**3*k3**4) - 4*D1**2*Pk1*Pk3*ct**5*k1**3*k2**3*(3168*C*D1**2*b1*f*fd*r**2 + 6336*C*D1**2*b1*f*fd*r*s - 3168*C*D1**2*b1*f*fd*r + 3168*C*D1**2*b1*f*fd*s**2 - 3168*C*D1**2*b1*f*fd*s + 1584*C*D1**2*b1*f*fd - 3600*C*D1**2*b1*f*fdd*r**2 - 7200*C*D1**2*b1*f*fdd*r*s + 3600*C*D1**2*b1*f*fdd*r - 3600*C*D1**2*b1*f*fdd*s**2 + 3600*C*D1**2*b1*f*fdd*s - 1800*C*D1**2*b1*f*fdd - 3600*C*D1**2*b1*fd**2*r**2 - 7200*C*D1**2*b1*fd**2*r*s + 3600*C*D1**2*b1*fd**2*r - 3600*C*D1**2*b1*fd**2*s**2 + 3600*C*D1**2*b1*fd**2*s + 4080*C*D1**2*f**2*fd*r**2 + 8160*C*D1**2*f**2*fd*r*s - 5440*C*D1**2*f**2*fd*r + 4080*C*D1**2*f**2*fd*s**2 - 5440*C*D1**2*f**2*fd*s + 2720*C*D1**2*f**2*fd - 4200*C*D1**2*f**2*fdd*r**2 - 8400*C*D1**2*f**2*fdd*r*s + 5600*C*D1**2*f**2*fdd*r - 4200*C*D1**2*f**2*fdd*s**2 + 5600*C*D1**2*f**2*fdd*s - 2800*C*D1**2*f**2*fdd - 8400*C*D1**2*f*fd**2*r**2 - 16800*C*D1**2*f*fd**2*r*s + 11200*C*D1**2*f*fd**2*r - 8400*C*D1**2*f*fd**2*s**2 + 11200*C*D1**2*f*fd**2*s - 2800*C*D1**2*f*fd**2 + 6336*C*D1*Dd*b1*f**2*r**2 + 12672*C*D1*Dd*b1*f**2*r*s - 9504*C*D1*Dd*b1*f**2*r + 6336*C*D1*Dd*b1*f**2*s**2 - 9504*C*D1*Dd*b1*f**2*s + 4752*C*D1*Dd*b1*f**2 - 28800*C*D1*Dd*b1*f*fd*r**2 - 57600*C*D1*Dd*b1*f*fd*r*s + 36000*C*D1*Dd*b1*f*fd*r - 28800*C*D1*Dd*b1*f*fd*s**2 + 36000*C*D1*Dd*b1*f*fd*s - 10800*C*D1*Dd*b1*f*fd + 5440*C*D1*Dd*f**3*r**2 + 10880*C*D1*Dd*f**3*r*s - 8160*C*D1*Dd*f**3*r + 5440*C*D1*Dd*f**3*s**2 - 8160*C*D1*Dd*f**3*s + 4080*C*D1*Dd*f**3 - 33600*C*D1*Dd*f**2*fd*r**2 - 67200*C*D1*Dd*f**2*fd*r*s + 47600*C*D1*Dd*f**2*fd*r - 33600*C*D1*Dd*f**2*fd*s**2 + 47600*C*D1*Dd*f**2*fd*s - 16800*C*D1*Dd*f**2*fd - 7200*C*D1*Ddd*b1*f**2*r**2 - 14400*C*D1*Ddd*b1*f**2*r*s + 10800*C*D1*Ddd*b1*f**2*r - 7200*C*D1*Ddd*b1*f**2*s**2 + 10800*C*D1*Ddd*b1*f**2*s - 5400*C*D1*Ddd*b1*f**2 - 5600*C*D1*Ddd*f**3*r**2 - 11200*C*D1*Ddd*f**3*r*s + 8400*C*D1*Ddd*f**3*r - 5600*C*D1*Ddd*f**3*s**2 + 8400*C*D1*Ddd*f**3*s - 4200*C*D1*Ddd*f**3 - 21600*C*Dd**2*b1*f**2*r**2 - 43200*C*Dd**2*b1*f**2*r*s + 32400*C*Dd**2*b1*f**2*r - 21600*C*Dd**2*b1*f**2*s**2 + 32400*C*Dd**2*b1*f**2*s - 10800*C*Dd**2*b1*f**2 - 16800*C*Dd**2*f**3*r**2 - 33600*C*Dd**2*f**3*r*s + 25200*C*Dd**2*f**3*r - 16800*C*Dd**2*f**3*s**2 + 25200*C*Dd**2*f**3*s - 8400*C*Dd**2*f**3 - 2250*D1**2*b1*f*fd*r**2 - 4500*D1**2*b1*f*fd*r*s + 2250*D1**2*b1*f*fd*r - 2250*D1**2*b1*f*fd*s**2 + 2250*D1**2*b1*f*fd*s - 1125*D1**2*b1*f*fd + 2700*D1**2*b1*f*fdd*r**2 + 5400*D1**2*b1*f*fdd*r*s - 2700*D1**2*b1*f*fdd*r + 2700*D1**2*b1*f*fdd*s**2 - 2700*D1**2*b1*f*fdd*s + 1350*D1**2*b1*f*fdd + 2700*D1**2*b1*fd**2*r**2 + 5400*D1**2*b1*fd**2*r*s - 2700*D1**2*b1*fd**2*r + 2700*D1**2*b1*fd**2*s**2 - 2700*D1**2*b1*fd**2*s - 450*D1**2*bdd1*f**2*(4*C - 3)*(r + s - 1)**2 - 2925*D1**2*f**2*fd*r**2 - 5850*D1**2*f**2*fd*r*s + 3900*D1**2*f**2*fd*r - 2925*D1**2*f**2*fd*s**2 + 3900*D1**2*f**2*fd*s - 1950*D1**2*f**2*fd + 3150*D1**2*f**2*fdd*r**2 + 6300*D1**2*f**2*fdd*r*s - 4200*D1**2*f**2*fdd*r + 3150*D1**2*f**2*fdd*s**2 - 4200*D1**2*f**2*fdd*s + 2100*D1**2*f**2*fdd + 6300*D1**2*f*fd**2*r**2 + 12600*D1**2*f*fd**2*r*s - 8400*D1**2*f*fd**2*r + 6300*D1**2*f*fd**2*s**2 - 8400*D1**2*f*fd**2*s + 2100*D1**2*f*fd**2 - 4500*D1*Dd*b1*f**2*r**2 - 9000*D1*Dd*b1*f**2*r*s + 6750*D1*Dd*b1*f**2*r - 4500*D1*Dd*b1*f**2*s**2 + 6750*D1*Dd*b1*f**2*s - 3375*D1*Dd*b1*f**2 + 21600*D1*Dd*b1*f*fd*r**2 + 43200*D1*Dd*b1*f*fd*r*s - 27000*D1*Dd*b1*f*fd*r + 21600*D1*Dd*b1*f*fd*s**2 - 27000*D1*Dd*b1*f*fd*s + 8100*D1*Dd*b1*f*fd - 3900*D1*Dd*f**3*r**2 - 7800*D1*Dd*f**3*r*s + 5850*D1*Dd*f**3*r - 3900*D1*Dd*f**3*s**2 + 5850*D1*Dd*f**3*s - 2925*D1*Dd*f**3 + 25200*D1*Dd*f**2*fd*r**2 + 50400*D1*Dd*f**2*fd*r*s - 35700*D1*Dd*f**2*fd*r + 25200*D1*Dd*f**2*fd*s**2 - 35700*D1*Dd*f**2*fd*s + 12600*D1*Dd*f**2*fd + 5400*D1*Ddd*b1*f**2*r**2 + 10800*D1*Ddd*b1*f**2*r*s - 8100*D1*Ddd*b1*f**2*r + 5400*D1*Ddd*b1*f**2*s**2 - 8100*D1*Ddd*b1*f**2*s + 4050*D1*Ddd*b1*f**2 + 4200*D1*Ddd*f**3*r**2 + 8400*D1*Ddd*f**3*r*s - 6300*D1*Ddd*f**3*r + 4200*D1*Ddd*f**3*s**2 - 6300*D1*Ddd*f**3*s + 3150*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(D1*f*(176*C - 125)*(r + s - 1) - D1*fd*(400*C - 300)*(2*r + 2*s - 1) - Dd*f*(400*C - 300)*(4*r + 4*s - 3)) + 16200*Dd**2*b1*f**2*r**2 + 32400*Dd**2*b1*f**2*r*s - 24300*Dd**2*b1*f**2*r + 16200*Dd**2*b1*f**2*s**2 - 24300*Dd**2*b1*f**2*s + 8100*Dd**2*b1*f**2 + 12600*Dd**2*f**3*r**2 + 25200*Dd**2*f**3*r*s - 18900*Dd**2*f**3*r + 12600*Dd**2*f**3*s**2 - 18900*Dd**2*f**3*s + 6300*Dd**2*f**3)/(105*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**5*k1**3*k2*(9*b1*(D1**2*(f*(fd*(116*C - 77) + fdd*(70 - 100*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(70 - 100*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(116*C - 77)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(70 - 100*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(70 - 100*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(70 - 100*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(172*C - 115)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 14)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(98 - 140*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(116*C - 77)*(r + s - 1) - fd*(100*C - 70)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(70 - 100*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(172*C - 115)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(140*C - 98)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(98 - 140*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(98 - 140*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k3**6) - D1**2*Pk1*Pk3*ct**5*k1**3*(32*C - 20)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + 2*D1*f*(14*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(2*s**2 - 2*s + 1)) - 14*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k2*k3**4) - 4*D1**2*Pk1*Pk3*ct**5*k1*k2**5*st**2*(4032*C*D1**2*b1*f*fd*r**2 + 8064*C*D1**2*b1*f*fd*r*s - 4032*C*D1**2*b1*f*fd*r + 4032*C*D1**2*b1*f*fd*s**2 - 4032*C*D1**2*b1*f*fd*s + 2016*C*D1**2*b1*f*fd - 2520*C*D1**2*b1*f*fdd*r**2 - 5040*C*D1**2*b1*f*fdd*r*s + 2520*C*D1**2*b1*f*fdd*r - 2520*C*D1**2*b1*f*fdd*s**2 + 2520*C*D1**2*b1*f*fdd*s - 1260*C*D1**2*b1*f*fdd - 2520*C*D1**2*b1*fd**2*r**2 - 5040*C*D1**2*b1*fd**2*r*s + 2520*C*D1**2*b1*fd**2*r - 2520*C*D1**2*b1*fd**2*s**2 + 2520*C*D1**2*b1*fd**2*s + 3552*C*D1**2*f**2*fd*r**2 + 7104*C*D1**2*f**2*fd*r*s - 4736*C*D1**2*f**2*fd*r + 3552*C*D1**2*f**2*fd*s**2 - 4736*C*D1**2*f**2*fd*s + 2368*C*D1**2*f**2*fd - 2100*C*D1**2*f**2*fdd*r**2 - 4200*C*D1**2*f**2*fdd*r*s + 2800*C*D1**2*f**2*fdd*r - 2100*C*D1**2*f**2*fdd*s**2 + 2800*C*D1**2*f**2*fdd*s - 1400*C*D1**2*f**2*fdd - 4200*C*D1**2*f*fd**2*r**2 - 8400*C*D1**2*f*fd**2*r*s + 5600*C*D1**2*f*fd**2*r - 4200*C*D1**2*f*fd**2*s**2 + 5600*C*D1**2*f*fd**2*s - 1400*C*D1**2*f*fd**2 + 8064*C*D1*Dd*b1*f**2*r**2 + 16128*C*D1*Dd*b1*f**2*r*s - 12096*C*D1*Dd*b1*f**2*r + 8064*C*D1*Dd*b1*f**2*s**2 - 12096*C*D1*Dd*b1*f**2*s + 6048*C*D1*Dd*b1*f**2 - 20160*C*D1*Dd*b1*f*fd*r**2 - 40320*C*D1*Dd*b1*f*fd*r*s + 25200*C*D1*Dd*b1*f*fd*r - 20160*C*D1*Dd*b1*f*fd*s**2 + 25200*C*D1*Dd*b1*f*fd*s - 7560*C*D1*Dd*b1*f*fd + 4736*C*D1*Dd*f**3*r**2 + 9472*C*D1*Dd*f**3*r*s - 7104*C*D1*Dd*f**3*r + 4736*C*D1*Dd*f**3*s**2 - 7104*C*D1*Dd*f**3*s + 3552*C*D1*Dd*f**3 - 16800*C*D1*Dd*f**2*fd*r**2 - 33600*C*D1*Dd*f**2*fd*r*s + 23800*C*D1*Dd*f**2*fd*r - 16800*C*D1*Dd*f**2*fd*s**2 + 23800*C*D1*Dd*f**2*fd*s - 8400*C*D1*Dd*f**2*fd - 5040*C*D1*Ddd*b1*f**2*r**2 - 10080*C*D1*Ddd*b1*f**2*r*s + 7560*C*D1*Ddd*b1*f**2*r - 5040*C*D1*Ddd*b1*f**2*s**2 + 7560*C*D1*Ddd*b1*f**2*s - 3780*C*D1*Ddd*b1*f**2 - 2800*C*D1*Ddd*f**3*r**2 - 5600*C*D1*Ddd*f**3*r*s + 4200*C*D1*Ddd*f**3*r - 2800*C*D1*Ddd*f**3*s**2 + 4200*C*D1*Ddd*f**3*s - 2100*C*D1*Ddd*f**3 - 15120*C*Dd**2*b1*f**2*r**2 - 30240*C*Dd**2*b1*f**2*r*s + 22680*C*Dd**2*b1*f**2*r - 15120*C*Dd**2*b1*f**2*s**2 + 22680*C*Dd**2*b1*f**2*s - 7560*C*Dd**2*b1*f**2 - 8400*C*Dd**2*f**3*r**2 - 16800*C*Dd**2*f**3*r*s + 12600*C*Dd**2*f**3*r - 8400*C*Dd**2*f**3*s**2 + 12600*C*Dd**2*f**3*s - 4200*C*Dd**2*f**3 - 3492*D1**2*b1*f*fd*r**2 - 6984*D1**2*b1*f*fd*r*s + 3492*D1**2*b1*f*fd*r - 3492*D1**2*b1*f*fd*s**2 + 3492*D1**2*b1*f*fd*s - 1746*D1**2*b1*f*fd + 2250*D1**2*b1*f*fdd*r**2 + 4500*D1**2*b1*f*fdd*r*s - 2250*D1**2*b1*f*fdd*r + 2250*D1**2*b1*f*fdd*s**2 - 2250*D1**2*b1*f*fdd*s + 1125*D1**2*b1*f*fdd + 2250*D1**2*b1*fd**2*r**2 + 4500*D1**2*b1*fd**2*r*s - 2250*D1**2*b1*fd**2*r + 2250*D1**2*b1*fd**2*s**2 - 2250*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(28*C - 25)*(r + s - 1)**2 - 3102*D1**2*f**2*fd*r**2 - 6204*D1**2*f**2*fd*r*s + 4136*D1**2*f**2*fd*r - 3102*D1**2*f**2*fd*s**2 + 4136*D1**2*f**2*fd*s - 2068*D1**2*f**2*fd + 1875*D1**2*f**2*fdd*r**2 + 3750*D1**2*f**2*fdd*r*s - 2500*D1**2*f**2*fdd*r + 1875*D1**2*f**2*fdd*s**2 - 2500*D1**2*f**2*fdd*s + 1250*D1**2*f**2*fdd + 3750*D1**2*f*fd**2*r**2 + 7500*D1**2*f*fd**2*r*s - 5000*D1**2*f*fd**2*r + 3750*D1**2*f*fd**2*s**2 - 5000*D1**2*f*fd**2*s + 1250*D1**2*f*fd**2 - 6984*D1*Dd*b1*f**2*r**2 - 13968*D1*Dd*b1*f**2*r*s + 10476*D1*Dd*b1*f**2*r - 6984*D1*Dd*b1*f**2*s**2 + 10476*D1*Dd*b1*f**2*s - 5238*D1*Dd*b1*f**2 + 18000*D1*Dd*b1*f*fd*r**2 + 36000*D1*Dd*b1*f*fd*r*s - 22500*D1*Dd*b1*f*fd*r + 18000*D1*Dd*b1*f*fd*s**2 - 22500*D1*Dd*b1*f*fd*s + 6750*D1*Dd*b1*f*fd - 4136*D1*Dd*f**3*r**2 - 8272*D1*Dd*f**3*r*s + 6204*D1*Dd*f**3*r - 4136*D1*Dd*f**3*s**2 + 6204*D1*Dd*f**3*s - 3102*D1*Dd*f**3 + 15000*D1*Dd*f**2*fd*r**2 + 30000*D1*Dd*f**2*fd*r*s - 21250*D1*Dd*f**2*fd*r + 15000*D1*Dd*f**2*fd*s**2 - 21250*D1*Dd*f**2*fd*s + 7500*D1*Dd*f**2*fd + 4500*D1*Ddd*b1*f**2*r**2 + 9000*D1*Ddd*b1*f**2*r*s - 6750*D1*Ddd*b1*f**2*r + 4500*D1*Ddd*b1*f**2*s**2 - 6750*D1*Ddd*b1*f**2*s + 3375*D1*Ddd*b1*f**2 + 2500*D1*Ddd*f**3*r**2 + 5000*D1*Ddd*f**3*r*s - 3750*D1*Ddd*f**3*r + 2500*D1*Ddd*f**3*s**2 - 3750*D1*Ddd*f**3*s + 1875*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(112*C - 97)*(r + s - 1) - D1*fd*(140*C - 125)*(2*r + 2*s - 1) - Dd*f*(140*C - 125)*(4*r + 4*s - 3)) + 13500*Dd**2*b1*f**2*r**2 + 27000*Dd**2*b1*f**2*r*s - 20250*Dd**2*b1*f**2*r + 13500*Dd**2*b1*f**2*s**2 - 20250*Dd**2*b1*f**2*s + 6750*Dd**2*b1*f**2 + 7500*Dd**2*f**3*r**2 + 15000*Dd**2*f**3*r*s - 11250*Dd**2*f**3*r + 7500*Dd**2*f**3*s**2 - 11250*Dd**2*f**3*s + 3750*Dd**2*f**3)/(105*d**2*k3**8) + 4*D1**2*Pk1*Pk3*ct**5*k1*k2**5*(11880*C*D1**2*f**2*fd*r**2 + 23760*C*D1**2*f**2*fd*r*s - 15840*C*D1**2*f**2*fd*r + 11880*C*D1**2*f**2*fd*s**2 - 15840*C*D1**2*f**2*fd*s + 7920*C*D1**2*f**2*fd + 15840*C*D1*Dd*f**3*r**2 + 31680*C*D1*Dd*f**3*r*s - 23760*C*D1*Dd*f**3*r + 15840*C*D1*Dd*f**3*s**2 - 23760*C*D1*Dd*f**3*s + 11880*C*D1*Dd*f**3 + 2970*D1**2*K*bdd1*f**2*r**2 + 5940*D1**2*K*bdd1*f**2*r*s - 5940*D1**2*K*bdd1*f**2*r + 2970*D1**2*K*bdd1*f**2*s**2 - 5940*D1**2*K*bdd1*f**2*s + 2970*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(-42*K + 25*f + 35)*(r + s - 1)**2 + 1925*D1**2*bdd1*f**3*r**2 + 3850*D1**2*bdd1*f**3*r*s - 3850*D1**2*bdd1*f**3*r + 1925*D1**2*bdd1*f**3*s**2 - 3850*D1**2*bdd1*f**3*s + 1925*D1**2*bdd1*f**3 - 2475*D1**2*bdd1*f**2*r**2 - 4950*D1**2*bdd1*f**2*r*s + 4950*D1**2*bdd1*f**2*r - 2475*D1**2*bdd1*f**2*s**2 + 4950*D1**2*bdd1*f**2*s - 2475*D1**2*bdd1*f**2 - 8316*D1**2*bdd1*f*g2*r**2 - 16632*D1**2*bdd1*f*g2*r*s + 16632*D1**2*bdd1*f*g2*r - 8316*D1**2*bdd1*f*g2*s**2 + 16632*D1**2*bdd1*f*g2*s - 8316*D1**2*bdd1*f*g2 - 14420*D1**2*f**3*fd*r**2 - 28840*D1**2*f**3*fd*r*s + 21630*D1**2*f**3*fd*r - 14420*D1**2*f**3*fd*s**2 + 21630*D1**2*f**3*fd*s - 10815*D1**2*f**3*fd + 12600*D1**2*f**3*fdd*r**2 + 25200*D1**2*f**3*fdd*r*s - 18900*D1**2*f**3*fdd*r + 12600*D1**2*f**3*fdd*s**2 - 18900*D1**2*f**3*fdd*s + 9450*D1**2*f**3*fdd + 37800*D1**2*f**2*fd**2*r**2 + 75600*D1**2*f**2*fd**2*r*s - 56700*D1**2*f**2*fd**2*r + 37800*D1**2*f**2*fd**2*s**2 - 56700*D1**2*f**2*fd**2*s + 18900*D1**2*f**2*fd**2 - 10395*D1**2*f**2*fd*r**2 - 20790*D1**2*f**2*fd*r*s + 13860*D1**2*f**2*fd*r - 10395*D1**2*f**2*fd*s**2 + 13860*D1**2*f**2*fd*s - 6930*D1**2*f**2*fd + 9108*D1**2*f**2*gd2*r**2 + 18216*D1**2*f**2*gd2*r*s - 18216*D1**2*f**2*gd2*r + 9108*D1**2*f**2*gd2*s**2 - 18216*D1**2*f**2*gd2*s + 9108*D1**2*f**2*gd2 - 5940*D1**2*f**2*gdd2*r**2 - 11880*D1**2*f**2*gdd2*r*s + 11880*D1**2*f**2*gdd2*r - 5940*D1**2*f**2*gdd2*s**2 + 11880*D1**2*f**2*gdd2*s - 5940*D1**2*f**2*gdd2 + 18216*D1**2*f*fd*g2*r**2 + 36432*D1**2*f*fd*g2*r*s - 18216*D1**2*f*fd*g2*r + 18216*D1**2*f*fd*g2*s**2 - 18216*D1**2*f*fd*g2*s + 9108*D1**2*f*fd*g2 - 23760*D1**2*f*fd*gd2*r**2 - 47520*D1**2*f*fd*gd2*r*s + 35640*D1**2*f*fd*gd2*r - 23760*D1**2*f*fd*gd2*s**2 + 35640*D1**2*f*fd*gd2*s - 11880*D1**2*f*fd*gd2 - 11880*D1**2*f*fdd*g2*r**2 - 23760*D1**2*f*fdd*g2*r*s + 11880*D1**2*f*fdd*g2*r - 11880*D1**2*f*fdd*g2*s**2 + 11880*D1**2*f*fdd*g2*s - 5940*D1**2*f*fdd*g2 - 11880*D1**2*fd**2*g2*r**2 - 23760*D1**2*fd**2*g2*r*s + 11880*D1**2*fd**2*g2*r - 11880*D1**2*fd**2*g2*s**2 + 11880*D1**2*fd**2*g2*s - 14420*D1*Dd*f**4*r**2 - 28840*D1*Dd*f**4*r*s + 21630*D1*Dd*f**4*r - 14420*D1*Dd*f**4*s**2 + 21630*D1*Dd*f**4*s - 10815*D1*Dd*f**4 + 100800*D1*Dd*f**3*fd*r**2 + 201600*D1*Dd*f**3*fd*r*s - 151200*D1*Dd*f**3*fd*r + 100800*D1*Dd*f**3*fd*s**2 - 151200*D1*Dd*f**3*fd*s + 56700*D1*Dd*f**3*fd - 13860*D1*Dd*f**3*r**2 - 27720*D1*Dd*f**3*r*s + 20790*D1*Dd*f**3*r - 13860*D1*Dd*f**3*s**2 + 20790*D1*Dd*f**3*s - 10395*D1*Dd*f**3 + 36432*D1*Dd*f**2*g2*r**2 + 72864*D1*Dd*f**2*g2*r*s - 54648*D1*Dd*f**2*g2*r + 36432*D1*Dd*f**2*g2*s**2 - 54648*D1*Dd*f**2*g2*s + 27324*D1*Dd*f**2*g2 - 47520*D1*Dd*f**2*gd2*r**2 - 95040*D1*Dd*f**2*gd2*r*s + 83160*D1*Dd*f**2*gd2*r - 47520*D1*Dd*f**2*gd2*s**2 + 83160*D1*Dd*f**2*gd2*s - 35640*D1*Dd*f**2*gd2 - 95040*D1*Dd*f*fd*g2*r**2 - 190080*D1*Dd*f*fd*g2*r*s + 118800*D1*Dd*f*fd*g2*r - 95040*D1*Dd*f*fd*g2*s**2 + 118800*D1*Dd*f*fd*g2*s - 35640*D1*Dd*f*fd*g2 + 12600*D1*Ddd*f**4*r**2 + 25200*D1*Ddd*f**4*r*s - 18900*D1*Ddd*f**4*r + 12600*D1*Ddd*f**4*s**2 - 18900*D1*Ddd*f**4*s + 9450*D1*Ddd*f**4 - 23760*D1*Ddd*f**2*g2*r**2 - 47520*D1*Ddd*f**2*g2*r*s + 35640*D1*Ddd*f**2*g2*r - 23760*D1*Ddd*f**2*g2*s**2 + 35640*D1*Ddd*f**2*g2*s - 17820*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(125*f**3*(r + s - 1) + f**2*(-504*C*(r + s - 1) - 350*fd*(3*r + 3*s - 2) + (414*K + 117)*(r + s - 1)) - 6*f*(15*fd*(6*K - 5)*(2*r + 2*s - 1) + (182*g2 - 252*gd2)*(r + s - 1)) + 1512*fd*g2*(r + s)) - 2*Dd*f*(175*f**2 + 45*f*(6*K - 5) - 756*g2)*(4*r + 4*s - 3))*(r + s - 1) + 37800*Dd**2*f**4*r**2 + 75600*Dd**2*f**4*r*s - 56700*Dd**2*f**4*r + 37800*Dd**2*f**4*s**2 - 56700*Dd**2*f**4*s + 18900*Dd**2*f**4 - 71280*Dd**2*f**2*g2*r**2 - 142560*Dd**2*f**2*g2*r*s + 106920*Dd**2*f**2*g2*r - 71280*Dd**2*f**2*g2*s**2 + 106920*Dd**2*f**2*g2*s - 35640*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(3*f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 14*fd*(13*K - 10)*(r + s) - 21*fdd*(6*K - 5)*(r + s))) + D1*(2*Dd*(54*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(75*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (91*K - 70)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 21*fd*(6*K - 5)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-42*K + 25*f + 35)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-42*K + 25*f + 35)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(1008*C*D1**2*f*fd*r**2 + 2016*C*D1**2*f*fd*r*s - 1008*C*D1**2*f*fd*r + 1008*C*D1**2*f*fd*s**2 - 1008*C*D1**2*f*fd*s + 504*C*D1**2*f*fd + 2016*C*D1*Dd*f**2*r**2 + 4032*C*D1*Dd*f**2*r*s - 3024*C*D1*Dd*f**2*r + 2016*C*D1*Dd*f**2*s**2 - 3024*C*D1*Dd*f**2*s + 1512*C*D1*Dd*f**2 - 828*D1**2*K*f*fd*r**2 - 1656*D1**2*K*f*fd*r*s + 828*D1**2*K*f*fd*r - 828*D1**2*K*f*fd*s**2 + 828*D1**2*K*f*fd*s - 414*D1**2*K*f*fd + 540*D1**2*K*f*fdd*r**2 + 1080*D1**2*K*f*fdd*r*s - 540*D1**2*K*f*fdd*r + 540*D1**2*K*f*fdd*s**2 - 540*D1**2*K*f*fdd*s + 270*D1**2*K*f*fdd + 540*D1**2*K*fd**2*r**2 + 1080*D1**2*K*fd**2*r*s - 540*D1**2*K*fd**2*r + 540*D1**2*K*fd**2*s**2 - 540*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(-42*K + 25*f + 35)*(r + s - 1)**2 - 375*D1**2*f**2*fd*r**2 - 750*D1**2*f**2*fd*r*s + 500*D1**2*f**2*fd*r - 375*D1**2*f**2*fd*s**2 + 500*D1**2*f**2*fd*s - 250*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 700*D1**2*f**2*fdd*s + 350*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1400*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 - 234*D1**2*f*fd*r**2 - 468*D1**2*f*fd*r*s + 234*D1**2*f*fd*r - 234*D1**2*f*fd*s**2 + 234*D1**2*f*fd*s - 117*D1**2*f*fd - 450*D1**2*f*fdd*r**2 - 900*D1**2*f*fdd*r*s + 450*D1**2*f*fdd*r - 450*D1**2*f*fdd*s**2 + 450*D1**2*f*fdd*s - 225*D1**2*f*fdd + 1092*D1**2*f*gd2*r**2 + 2184*D1**2*f*gd2*r*s - 2184*D1**2*f*gd2*r + 1092*D1**2*f*gd2*s**2 - 2184*D1**2*f*gd2*s + 1092*D1**2*f*gd2 - 756*D1**2*f*gdd2*r**2 - 1512*D1**2*f*gdd2*r*s + 1512*D1**2*f*gdd2*r - 756*D1**2*f*gdd2*s**2 + 1512*D1**2*f*gdd2*s - 756*D1**2*f*gdd2 - 450*D1**2*fd**2*r**2 - 900*D1**2*fd**2*r*s + 450*D1**2*fd**2*r - 450*D1**2*fd**2*s**2 + 450*D1**2*fd**2*s + 1092*D1**2*fd*g2*r**2 + 2184*D1**2*fd*g2*r*s + 1092*D1**2*fd*g2*s**2 - 1512*D1**2*fd*gd2*r**2 - 3024*D1**2*fd*gd2*r*s + 1512*D1**2*fd*gd2*r - 1512*D1**2*fd*gd2*s**2 + 1512*D1**2*fd*gd2*s - 756*D1**2*fdd*g2*r**2 - 1512*D1**2*fdd*g2*r*s - 756*D1**2*fdd*g2*s**2 - 1656*D1*Dd*K*f**2*r**2 - 3312*D1*Dd*K*f**2*r*s + 2484*D1*Dd*K*f**2*r - 1656*D1*Dd*K*f**2*s**2 + 2484*D1*Dd*K*f**2*s - 1242*D1*Dd*K*f**2 + 4320*D1*Dd*K*f*fd*r**2 + 8640*D1*Dd*K*f*fd*r*s - 5400*D1*Dd*K*f*fd*r + 4320*D1*Dd*K*f*fd*s**2 - 5400*D1*Dd*K*f*fd*s + 1620*D1*Dd*K*f*fd - 500*D1*Dd*f**3*r**2 - 1000*D1*Dd*f**3*r*s + 750*D1*Dd*f**3*r - 500*D1*Dd*f**3*s**2 + 750*D1*Dd*f**3*s - 375*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 5950*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 5950*D1*Dd*f**2*fd*s + 2100*D1*Dd*f**2*fd - 468*D1*Dd*f**2*r**2 - 936*D1*Dd*f**2*r*s + 702*D1*Dd*f**2*r - 468*D1*Dd*f**2*s**2 + 702*D1*Dd*f**2*s - 351*D1*Dd*f**2 - 3600*D1*Dd*f*fd*r**2 - 7200*D1*Dd*f*fd*r*s + 4500*D1*Dd*f*fd*r - 3600*D1*Dd*f*fd*s**2 + 4500*D1*Dd*f*fd*s - 1350*D1*Dd*f*fd + 4368*D1*Dd*f*g2*r**2 + 8736*D1*Dd*f*g2*r*s - 6552*D1*Dd*f*g2*r + 4368*D1*Dd*f*g2*s**2 - 6552*D1*Dd*f*g2*s + 3276*D1*Dd*f*g2 - 6048*D1*Dd*f*gd2*r**2 - 12096*D1*Dd*f*gd2*r*s + 10584*D1*Dd*f*gd2*r - 6048*D1*Dd*f*gd2*s**2 + 10584*D1*Dd*f*gd2*s - 4536*D1*Dd*f*gd2 - 6048*D1*Dd*fd*g2*r**2 - 12096*D1*Dd*fd*g2*r*s + 4536*D1*Dd*fd*g2*r - 6048*D1*Dd*fd*g2*s**2 + 4536*D1*Dd*fd*g2*s + 1080*D1*Ddd*K*f**2*r**2 + 2160*D1*Ddd*K*f**2*r*s - 1620*D1*Ddd*K*f**2*r + 1080*D1*Ddd*K*f**2*s**2 - 1620*D1*Ddd*K*f**2*s + 810*D1*Ddd*K*f**2 + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 1050*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 525*D1*Ddd*f**3 - 900*D1*Ddd*f**2*r**2 - 1800*D1*Ddd*f**2*r*s + 1350*D1*Ddd*f**2*r - 900*D1*Ddd*f**2*s**2 + 1350*D1*Ddd*f**2*s - 675*D1*Ddd*f**2 - 3024*D1*Ddd*f*g2*r**2 - 6048*D1*Ddd*f*g2*r*s + 4536*D1*Ddd*f*g2*r - 3024*D1*Ddd*f*g2*s**2 + 4536*D1*Ddd*f*g2*s - 2268*D1*Ddd*f*g2 + 12*D1*bd1*(D1*(54*f**2*(r + s - 1) - 75*f*fd*(2*r + 2*s - 1) - 7*f*(13*K - 10)*(r + s - 1) + 21*fd*(6*K - 5)*(r + s)) - 3*Dd*f*(-42*K + 25*f + 35)*(4*r + 4*s - 3))*(r + s - 1) + 3240*Dd**2*K*f**2*r**2 + 6480*Dd**2*K*f**2*r*s - 4860*Dd**2*K*f**2*r + 3240*Dd**2*K*f**2*s**2 - 4860*Dd**2*K*f**2*s + 1620*Dd**2*K*f**2 + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 3150*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 1050*Dd**2*f**3 - 2700*Dd**2*f**2*r**2 - 5400*Dd**2*f**2*r*s + 4050*Dd**2*f**2*r - 2700*Dd**2*f**2*s**2 + 4050*Dd**2*f**2*s - 1350*Dd**2*f**2 - 9072*Dd**2*f*g2*r**2 - 18144*Dd**2*f*g2*r*s + 13608*Dd**2*f*g2*r - 9072*Dd**2*f*g2*s**2 + 13608*Dd**2*f*g2*s - 4536*Dd**2*f*g2))/(1155*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**5*k1*k2**3*st**2*(3*b1*(D1**2*(f*(fd*(212*C - 182) + fdd*(105 - 120*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(105 - 120*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(212*C - 182)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(105 - 120*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(105 - 120*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(105 - 120*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(364*C - 314)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (40*C - 35)*(9*bdd1*s*(r + s - 1) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(175 - 200*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(212*C - 182)*(r + s - 1) - fd*(120*C - 105)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(105 - 120*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(364*C - 314)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(200*C - 175)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(175 - 200*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(175 - 200*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**6) - 2*D1**2*Pk1*Pk3*ct**5*k1*k2**3*(84*D1*b1*bd1*(D1*(f*(14*C - 11)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(21 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(21 - 24*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 42*b1**2*(D1**2*(fd*(28*C - 22) + fdd*(21 - 24*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(14*C - 11)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(21 - 24*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(21 - 24*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(144*C - 126)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(14*D1**2*bdd1*f*(8*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1**2*(f*(fd*(8*C*(108*r**2 + 4*r*(75*s - 31) + 192*s**2 - 166*s + 83) - 742*r**2 - 2148*r*s + 906*r - 1406*s**2 + 1238*s - 619) + fdd*(-40*C*(22*r**2 + 58*r*s - 25*r + 36*s**2 - 32*s + 16) + 770*r**2 + 2124*r*s - 922*r + 1354*s**2 - 1214*s + 607)) - 2*fd**2*(20*C*(22*r**2 + 58*r*s - 25*r + 36*s**2 - 32*s - 4) - 385*r**2 - 1062*r*s + 461*r - 677*s**2 + 607*s + 70)) + D1*f*(Dd*(f*(48*C*(36*r**2 + 100*r*s - 68*r + 64*s**2 - 89*s + 41) - 1484*r**2 - 4296*r*s + 2890*r - 2812*s**2 + 3886*s - 1777) - 2*fd*(20*C*(176*r**2 + 464*r*s - 260*r + 288*s**2 - 330*s + 89) - 3080*r**2 - 8496*r*s + 4738*r - 5416*s**2 + 6198*s - 1675)) + Ddd*f*(-40*C*(44*r**2 + 116*r*s - 80*r + 72*s**2 - 101*s + 47) + 1540*r**2 + 4248*r*s - 2894*r + 2708*s**2 - 3770*s + 1739)) - 2*Dd**2*f**2*(20*C*(132*r**2 + 348*r*s - 240*r + 216*s**2 - 303*s + 94) - 2310*r**2 - 6372*r*s + 4341*r - 4062*s**2 + 5655*s - 1739)) + f*(-252*D1**2*bd1**2*(8*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(40*C*(11*r**2 + r*(29*s - 26) + 18*s**2 - 33*s + 13) - 385*r**2 + r*(910 - 1062*s) - 677*s**2 + 1202*s - 455) - 5*D1**2*(f*(fd*(56*C*(57*r**2 + 120*r*s - 78*r + 63*s**2 - 82*s + 40) - 2667*r**2 - 5874*r*s + 3736*r - 3207*s**2 + 4096*s - 1958) + fdd*(-8*C*(321*r**2 + 717*r*s - 453*r + 396*s**2 - 503*s + 239) + 2211*r**2 + 5178*r*s - 3200*r + 2967*s**2 - 3704*s + 1726)) - 2*fd**2*(4*C*(642*r**2 + 1434*r*s - 906*r + 792*s**2 - 1006*s + 239) - 2211*r**2 - 5178*r*s + 3200*r - 2967*s**2 + 3704*s - 863)) - 9*D1*bd1*(D1*(f*(8*C*(54*r**2 + 2*r*(75*s - 67) + 96*s**2 - 176*s + 67) - 371*r**2 - 1074*r*s + 910*r - 703*s**2 + 1242*s - 455) - 2*fd*(20*C*(44*r**2 + 116*r*s - 77*r + 72*s**2 - 98*s + 33) - 770*r**2 - 2124*r*s + 1371*r - 1354*s**2 + 1809*s - 601)) + 2*Dd*f*(-20*C*(88*r**2 + 8*r*(29*s - 23) + 144*s**2 - 233*s + 92) + 1540*r**2 + 9*r*(472*s - 363) + 2708*s**2 - 4289*s + 1657)) - 5*D1*f*(Dd*(f*(56*C*(76*r**2 + 2*r*(80*s - 59) + 84*s**2 - 124*s + 61) - 3556*r**2 - 7832*r*s + 5694*r - 4276*s**2 + 6234*s - 3027) + 2*fd*(-4*C*(2568*r**2 + 5736*r*s - 3888*r + 3168*s**2 - 4313*s + 1459) + 8844*r**2 + 20712*r*s - 13789*r + 11868*s**2 - 15931*s + 5304)) + Ddd*f*(-8*C*(428*r**2 + 956*r*s - 692*r + 528*s**2 - 767*s + 371) + 2948*r**2 + 6904*r*s - 4926*r + 3956*s**2 - 5682*s + 2715)) + 10*Dd**2*f**2*(4*C*(1284*r**2 + 2868*r*s - 2076*r + 1584*s**2 - 2301*s + 742) - 4422*r**2 - 10356*r*s + 7389*r - 5934*s**2 + 8523*s - 2715)))/(315*d**2*k3**6) - D1**2*Pk1*Pk3*ct**5*k1*k2*st**2*(80*C - 68)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k3**4) + D1**2*Pk1*Pk3*ct**5*k1*k2*(-84*b1**2*(D1**2*(s - 1)*(fd*(26*C - 20) + fdd*(15 - 18*C))*(r + s - 1) + D1*(Dd*(f*(26*C - 20)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(18*C - 15)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(15 - 18*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(18*C - 15)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) - 3*b1*(-3*D1**2*(f*(-8*C*fdd*(36*r*(2*s - 1) + 142*s**2 - 127*s + 71) + 28*bdd1*s*(6*C - 5)*(2*r + 2*s - 1) + fd*(8*C*(51*r*(2*s - 1) + 158*s**2 - 135*s + 79) - 680*r*s + 340*r - 1122*s**2 + 978*s - 561) + 5*fdd*(48*r*(2*s - 1) + 206*s**2 - 186*s + 103)) - 2*fd**2*(4*C*(36*r*(2*s - 1) + 142*s**2 - 127*s - 15) + 5*r*(24 - 48*s) - 515*s**2 + 465*s + 50)) + 28*D1*bd1*(D1*(f*s*(26*C - 20)*(2*r + 2*s - 1) - fd*(18*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(30 - 36*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 6*D1*f*(-8*C*Ddd*f*(36*r*(2*s - 1) + 142*s**2 - 160*s + 71) + Dd*f*(4*C*(102*r*(2*s - 1) + 316*s**2 - 367*s + 158) - 340*r*(2*s - 1) - 1122*s**2 + 1292*s - 561) - 2*Dd*fd*(2*s - 1)*(4*C*(144*r + 284*s - 145) - 480*r - 1030*s + 525) + 5*Ddd*f*(48*r*(2*s - 1) + 206*s**2 - 230*s + 103)) + 6*Dd**2*f**2*(8*C*(108*r*(2*s - 1) + 426*s**2 - 480*s + 107) - 720*r*(2*s - 1) - 3090*s**2 + 3450*s - 755)) + f*(252*D1**2*bd1**2*s*(6*C - 5)*(2*r + 2*s - 1) + D1**2*(f*(-120*C*fdd*(27*r*(3*s - 1) + 114*s**2 - 103*s + 38) - 9*bdd1*s*(8*C*(36*r + 71*s - 51) - 240*r - 515*s + 340) + 5*fd*(48*C*(21*r*(3*s - 1) + 69*s**2 - 67*s + 23) - 812*r*(3*s - 1) - 2877*s**2 + 2730*s - 959) + 95*fdd*(28*r*(3*s - 1) + 129*s**2 - 114*s + 43)) - 10*fd**2*(12*C*(54*r*(3*s - 1) + 228*s**2 - 206*s + 27) - 532*r*(3*s - 1) - 2451*s**2 + 2166*s - 266)) + 9*D1*bd1*(D1*(-8*C*fd*(36*r*(4*s - 1) + 284*s**2 - 229*s + 51) + f*s*(8*C*(51*r + 79*s - 74) - 340*r - 561*s + 484) + 10*fd*(24*r*(4*s - 1) + 206*s**2 - 161*s + 34)) - 4*Dd*f*(4*C*(36*r*(4*s - 1) + 284*s**2 - 262*s + 51) - 120*r*(4*s - 1) - 1030*s**2 + 915*s - 170)) + 10*D1*f*(Dd*(-12*C*fd*(54*r*(12*s - 5) + 912*s**2 - 949*s + 233) + f*(24*C*(42*r*(2*s - 1) + 92*s**2 - 113*s + 46) - 812*r*(2*s - 1) - 1918*s**2 + 2324*s - 959) + 76*fd*(7*r*(12*s - 5) + 129*s**2 - 132*s + 32)) + Ddd*f*(-12*C*(54*r*(2*s - 1) + 152*s**2 - 179*s + 76) + 532*r*(2*s - 1) + 1634*s**2 - 1900*s + 817)) - 10*Dd**2*f**2*(12*C*(162*r*(2*s - 1) + 456*s**2 - 537*s + 130) - 1596*r*(2*s - 1) - 4902*s**2 + 5700*s - 1349)))/(315*d**2*k3**4) - D1**2*Pk1*Pk3*ct**5*k1*(16*C - 12)*(18*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s))) + 9*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(-5*f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*s*(-9*bd1**2*s + 5*fd**2*(3*s - 2))) - 10*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) + 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(45*d**2*k2*k3**2) + 4*D1**2*Pk1*Pk3*ct**5*k2**5*st**2*(1728*C*D1**2*b1*f*fd*r**2 + 1728*C*D1**2*b1*f*fd*r*s - 864*C*D1**2*b1*f*fd*r - 360*C*D1**2*b1*f*fdd*r**2 - 360*C*D1**2*b1*f*fdd*r*s + 180*C*D1**2*b1*f*fdd*r - 360*C*D1**2*b1*fd**2*r**2 - 360*C*D1**2*b1*fd**2*r*s + 180*C*D1**2*b1*fd**2*r + 1776*C*D1**2*f**2*fd*r**2 + 1776*C*D1**2*f**2*fd*r*s - 1776*C*D1**2*f**2*fd*r - 592*C*D1**2*f**2*fd*s + 592*C*D1**2*f**2*fd - 780*C*D1**2*f**2*fdd*r**2 - 780*C*D1**2*f**2*fdd*r*s + 780*C*D1**2*f**2*fdd*r + 260*C*D1**2*f**2*fdd*s - 260*C*D1**2*f**2*fdd - 1560*C*D1**2*f*fd**2*r**2 - 1560*C*D1**2*f*fd**2*r*s + 1560*C*D1**2*f*fd**2*r + 520*C*D1**2*f*fd**2*s - 260*C*D1**2*f*fd**2 + 3456*C*D1*Dd*b1*f**2*r**2 + 3456*C*D1*Dd*b1*f**2*r*s - 3456*C*D1*Dd*b1*f**2*r - 864*C*D1*Dd*b1*f**2*s + 864*C*D1*Dd*b1*f**2 - 2880*C*D1*Dd*b1*f*fd*r**2 - 2880*C*D1*Dd*b1*f*fd*r*s + 2160*C*D1*Dd*b1*f*fd*r + 360*C*D1*Dd*b1*f*fd*s - 180*C*D1*Dd*b1*f*fd + 2368*C*D1*Dd*f**3*r**2 + 2368*C*D1*Dd*f**3*r*s - 2368*C*D1*Dd*f**3*r - 592*C*D1*Dd*f**3*s + 592*C*D1*Dd*f**3 - 6240*C*D1*Dd*f**2*fd*r**2 - 6240*C*D1*Dd*f**2*fd*r*s + 6240*C*D1*Dd*f**2*fd*r + 1820*C*D1*Dd*f**2*fd*s - 1300*C*D1*Dd*f**2*fd - 720*C*D1*Ddd*b1*f**2*r**2 - 720*C*D1*Ddd*b1*f**2*r*s + 720*C*D1*Ddd*b1*f**2*r + 180*C*D1*Ddd*b1*f**2*s - 180*C*D1*Ddd*b1*f**2 - 1040*C*D1*Ddd*f**3*r**2 - 1040*C*D1*Ddd*f**3*r*s + 1040*C*D1*Ddd*f**3*r + 260*C*D1*Ddd*f**3*s - 260*C*D1*Ddd*f**3 - 2160*C*Dd**2*b1*f**2*r**2 - 2160*C*Dd**2*b1*f**2*r*s + 2160*C*Dd**2*b1*f**2*r + 540*C*Dd**2*b1*f**2*s - 360*C*Dd**2*b1*f**2 - 3120*C*Dd**2*f**3*r**2 - 3120*C*Dd**2*f**3*r*s + 3120*C*Dd**2*f**3*r + 780*C*Dd**2*f**3*s - 520*C*Dd**2*f**3 - 2268*D1**2*b1*f*fd*r**2 - 2808*D1**2*b1*f*fd*r*s + 1404*D1**2*b1*f*fd*r - 540*D1**2*b1*f*fd*s**2 + 540*D1**2*b1*f*fd*s - 270*D1**2*b1*f*fd + 630*D1**2*b1*f*fdd*r**2 + 900*D1**2*b1*f*fdd*r*s - 450*D1**2*b1*f*fdd*r + 270*D1**2*b1*f*fdd*s**2 - 270*D1**2*b1*f*fdd*s + 135*D1**2*b1*f*fdd + 630*D1**2*b1*fd**2*r**2 + 900*D1**2*b1*fd**2*r*s - 450*D1**2*b1*fd**2*r + 270*D1**2*b1*fd**2*s**2 - 270*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)*(4*C*(r - 1) - 7*r - 3*s + 7) - 2226*D1**2*f**2*fd*r**2 - 2676*D1**2*f**2*fd*r*s + 2376*D1**2*f**2*fd*r - 450*D1**2*f**2*fd*s**2 + 1192*D1**2*f**2*fd*s - 892*D1**2*f**2*fd + 1005*D1**2*f**2*fdd*r**2 + 1230*D1**2*f**2*fdd*r*s - 1080*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 410*D1**2*f**2*fdd + 2010*D1**2*f*fd**2*r**2 + 2460*D1**2*f*fd**2*r*s - 2160*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 410*D1**2*f*fd**2 - 4536*D1*Dd*b1*f**2*r**2 - 5616*D1*Dd*b1*f**2*r*s + 5076*D1*Dd*b1*f**2*r - 1080*D1*Dd*b1*f**2*s**2 + 2484*D1*Dd*b1*f**2*s - 1674*D1*Dd*b1*f**2 + 5040*D1*Dd*b1*f*fd*r**2 + 7200*D1*Dd*b1*f*fd*r*s - 4860*D1*Dd*b1*f*fd*r + 2160*D1*Dd*b1*f*fd*s**2 - 3060*D1*Dd*b1*f*fd*s + 990*D1*Dd*b1*f*fd - 2968*D1*Dd*f**3*r**2 - 3568*D1*Dd*f**3*r*s + 3268*D1*Dd*f**3*r - 600*D1*Dd*f**3*s**2 + 1492*D1*Dd*f**3*s - 1042*D1*Dd*f**3 + 8040*D1*Dd*f**2*fd*r**2 + 9840*D1*Dd*f**2*fd*r*s - 8790*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 4370*D1*Dd*f**2*fd*s + 2200*D1*Dd*f**2*fd + 1260*D1*Ddd*b1*f**2*r**2 + 1800*D1*Ddd*b1*f**2*r*s - 1530*D1*Ddd*b1*f**2*r + 540*D1*Ddd*b1*f**2*s**2 - 990*D1*Ddd*b1*f**2*s + 585*D1*Ddd*b1*f**2 + 1340*D1*Ddd*f**3*r**2 + 1640*D1*Ddd*f**3*r*s - 1490*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 710*D1*Ddd*f**3*s + 485*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(3*f*(r + s - 1)*(16*C*(r - 1) - 21*r - 5*s + 21) - 5*fd*(2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 14*r**2 - 20*r*s + 19*r - 6*s**2 + 13*s - 5)) - 5*Dd*f*(2*C*(8*r**2 + 8*r*s - 12*r - 5*s + 4) - 28*r**2 - 40*r*s + 45*r - 12*s**2 + 31*s - 17)) + 3780*Dd**2*b1*f**2*r**2 + 5400*Dd**2*b1*f**2*r*s - 4590*Dd**2*b1*f**2*r + 1620*Dd**2*b1*f**2*s**2 - 2970*Dd**2*b1*f**2*s + 1170*Dd**2*b1*f**2 + 4020*Dd**2*f**3*r**2 + 4920*Dd**2*f**3*r*s - 4470*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 2130*Dd**2*f**3*s + 970*Dd**2*f**3)/(315*d**2*k1*k3**6) - 2*D1**2*Pk1*Pk3*ct**5*k2**5*(11880*C*D1**2*f**2*fd*r**2 + 11880*C*D1**2*f**2*fd*r*s - 11880*C*D1**2*f**2*fd*r - 3960*C*D1**2*f**2*fd*s + 3960*C*D1**2*f**2*fd + 15840*C*D1*Dd*f**3*r**2 + 15840*C*D1*Dd*f**3*r*s - 15840*C*D1*Dd*f**3*r - 3960*C*D1*Dd*f**3*s + 3960*C*D1*Dd*f**3 + 792*D1**2*K*bdd1*f**2*r**2 + 792*D1**2*K*bdd1*f**2*r*s - 792*D1**2*K*bdd1*f**2*r - 396*D1**2*bd1**2*f*(r + s - 1)*(5*f*(2*r + 2*s - 1) + 7*r + 7*s - 7) - 715*D1**2*bdd1*f**3*r**2 + 3190*D1**2*bdd1*f**3*r*s - 550*D1**2*bdd1*f**3*r + 3905*D1**2*bdd1*f**3*s**2 - 5170*D1**2*bdd1*f**3*s + 495*D1**2*bdd1*f**3 - 1782*D1**2*bdd1*f**2*r**2 - 2772*D1**2*bdd1*f**2*r*s + 2772*D1**2*bdd1*f**2*r - 990*D1**2*bdd1*f**2*s**2 + 1980*D1**2*bdd1*f**2*s - 990*D1**2*bdd1*f**2 - 13300*D1**2*f**3*fd*r**2 - 27160*D1**2*f**3*fd*r*s + 20230*D1**2*f**3*fd*r - 13860*D1**2*f**3*fd*s**2 + 20650*D1**2*f**3*fd*s - 10255*D1**2*f**3*fd + 7420*D1**2*f**3*fdd*r**2 + 24360*D1**2*f**3*fdd*r*s - 15890*D1**2*f**3*fdd*r + 16940*D1**2*f**3*fdd*s**2 - 23030*D1**2*f**3*fdd*s + 10325*D1**2*f**3*fdd + 22260*D1**2*f**2*fd**2*r**2 + 73080*D1**2*f**2*fd**2*r*s - 47670*D1**2*f**2*fd**2*r + 50820*D1**2*f**2*fd**2*s**2 - 69090*D1**2*f**2*fd**2*s + 20650*D1**2*f**2*fd**2 - 14850*D1**2*f**2*fd*r**2 - 17820*D1**2*f**2*fd*r*s + 15840*D1**2*f**2*fd*r - 2970*D1**2*f**2*fd*s**2 + 7920*D1**2*f**2*fd*s - 5940*D1**2*f**2*fd + 8712*D1**2*f**2*gd2*r**2 + 8712*D1**2*f**2*gd2*r*s - 8712*D1**2*f**2*gd2*r - 1584*D1**2*f**2*gdd2*r**2 - 1584*D1**2*f**2*gdd2*r*s + 1584*D1**2*f**2*gdd2*r + 17424*D1**2*f*fd*g2*r**2 + 17424*D1**2*f*fd*g2*r*s - 17424*D1**2*f*fd*g2*r - 8712*D1**2*f*fd*g2*s + 8712*D1**2*f*fd*g2 - 6336*D1**2*f*fd*gd2*r**2 - 6336*D1**2*f*fd*gd2*r*s + 6336*D1**2*f*fd*gd2*r + 1584*D1**2*f*fd*gd2*s - 1584*D1**2*f*fd*gd2 - 3168*D1**2*f*fdd*g2*r**2 - 3168*D1**2*f*fdd*g2*r*s + 3168*D1**2*f*fdd*g2*r + 1584*D1**2*f*fdd*g2*s - 1584*D1**2*f*fdd*g2 - 3168*D1**2*fd**2*g2*r**2 - 3168*D1**2*fd**2*g2*r*s + 3168*D1**2*fd**2*g2*r + 1584*D1**2*fd**2*g2*s - 13300*D1*Dd*f**4*r**2 - 27160*D1*Dd*f**4*r*s + 20230*D1*Dd*f**4*r - 13860*D1*Dd*f**4*s**2 + 20650*D1*Dd*f**4*s - 10255*D1*Dd*f**4 + 59360*D1*Dd*f**3*fd*r**2 + 194880*D1*Dd*f**3*fd*r*s - 127120*D1*Dd*f**3*fd*r + 135520*D1*Dd*f**3*fd*s**2 - 184240*D1*Dd*f**3*fd*s + 61950*D1*Dd*f**3*fd - 19800*D1*Dd*f**3*r**2 - 23760*D1*Dd*f**3*r*s + 21780*D1*Dd*f**3*r - 3960*D1*Dd*f**3*s**2 + 9900*D1*Dd*f**3*s - 6930*D1*Dd*f**3 + 34848*D1*Dd*f**2*g2*r**2 + 34848*D1*Dd*f**2*g2*r*s - 34848*D1*Dd*f**2*g2*r - 8712*D1*Dd*f**2*g2*s + 8712*D1*Dd*f**2*g2 - 12672*D1*Dd*f**2*gd2*r**2 - 12672*D1*Dd*f**2*gd2*r*s + 12672*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s - 1584*D1*Dd*f**2*gd2 - 25344*D1*Dd*f*fd*g2*r**2 - 25344*D1*Dd*f*fd*g2*r*s + 25344*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s - 6336*D1*Dd*f*fd*g2 + 7420*D1*Ddd*f**4*r**2 + 24360*D1*Ddd*f**4*r*s - 15890*D1*Ddd*f**4*r + 16940*D1*Ddd*f**4*s**2 - 23030*D1*Ddd*f**4*s + 10325*D1*Ddd*f**4 - 6336*D1*Ddd*f**2*g2*r**2 - 6336*D1*Ddd*f**2*g2*r*s + 6336*D1*Ddd*f**2*g2*r + 1584*D1*Ddd*f**2*g2*s - 1584*D1*Ddd*f**2*g2 + 11*D1*bd1*f*(D1*(5*f**2*(35*r**2 + 2*r*(5*s + 1) - 25*s**2 + 62*s - 9) + 2*f*(252*C*(r - 1)*(r + s - 1) - 5*fd*(39*r**2 - 174*r*s + 55*r - 213*s**2 + 265*s - 90) - (r + s - 1)*(198*K*r + 27*r - 27*s - 225)) + 36*fd*(K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 18*r**2 + r*(23 - 28*s) - 10*s**2 + 17*s - 7) + 840*g2*(r - 1)*(r + s - 1)) - 2*Dd*f*(-36*K*(8*r**2 + 8*r*(s - 1) - s + 1) + 5*f*(52*r**2 + r*(65 - 232*s) - 284*s**2 + 359*s - 99) + 648*r**2 + 1008*r*s - 918*r + 360*s**2 - 666*s + 306)) + 22260*Dd**2*f**4*r**2 + 73080*Dd**2*f**4*r*s - 47670*Dd**2*f**4*r + 50820*Dd**2*f**4*s**2 - 69090*Dd**2*f**4*s + 20650*Dd**2*f**4 - 19008*Dd**2*f**2*g2*r**2 - 19008*Dd**2*f**2*g2*r*s + 19008*Dd**2*f**2*g2*r + 4752*Dd**2*f**2*g2*s - 3168*Dd**2*f**2*g2 + 66*b1**2*(D1**2*(15*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 30*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 14*fd*(r + s)*(r*(5*K - 8) - 3*s) - 21*fdd*(r + s)**2) + D1*(2*Dd*(30*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-35*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 15*fd*(4*r + 4*s - 3)**2 + 224*r**2 + 308*r*s - 266*r + 84*s**2 - 161*s + 98) - 21*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(10*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(10*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(1008*C*D1**2*f*fd*r**2 + 1008*C*D1**2*f*fd*r*s - 504*C*D1**2*f*fd*r + 2016*C*D1*Dd*f**2*r**2 + 2016*C*D1*Dd*f**2*r*s - 2016*C*D1*Dd*f**2*r - 504*C*D1*Dd*f**2*s + 504*C*D1*Dd*f**2 - 792*D1**2*K*f*fd*r**2 - 792*D1**2*K*f*fd*r*s + 792*D1**2*K*f*fd*r + 396*D1**2*K*f*fd*s - 396*D1**2*K*f*fd + 144*D1**2*K*f*fdd*r**2 + 144*D1**2*K*f*fdd*r*s - 144*D1**2*K*f*fdd*r - 72*D1**2*K*f*fdd*s + 72*D1**2*K*f*fdd + 144*D1**2*K*fd**2*r**2 + 144*D1**2*K*fd**2*r*s - 144*D1**2*K*fd**2*r - 72*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 14*(r + s - 1)**2) + 525*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r - 375*D1**2*f**2*fd*s**2 + 140*D1**2*f**2*fd*s - 30*D1**2*f**2*fd - 195*D1**2*f**2*fdd*r**2 + 870*D1**2*f**2*fdd*r*s - 400*D1**2*f**2*fdd*r + 1065*D1**2*f**2*fdd*s**2 - 1240*D1**2*f**2*fdd*s + 600*D1**2*f**2*fdd - 390*D1**2*f*fd**2*r**2 + 1740*D1**2*f*fd**2*r*s - 800*D1**2*f*fd**2*r + 2130*D1**2*f*fd**2*s**2 - 2480*D1**2*f*fd**2*s + 390*D1**2*f*fd**2 - 108*D1**2*f*fd*r**2 - 396*D1**2*f*fd*r + 108*D1**2*f*fd*s**2 - 504*D1**2*f*fd*s + 450*D1**2*f*fd - 324*D1**2*f*fdd*r**2 - 504*D1**2*f*fdd*r*s + 324*D1**2*f*fdd*r - 180*D1**2*f*fdd*s**2 + 252*D1**2*f*fdd*s - 162*D1**2*f*fdd + 840*D1**2*f*gd2*r**2 + 840*D1**2*f*gd2*r*s - 840*D1**2*f*gd2*r - 324*D1**2*fd**2*r**2 - 504*D1**2*fd**2*r*s + 324*D1**2*fd**2*r - 180*D1**2*fd**2*s**2 + 252*D1**2*fd**2*s + 840*D1**2*fd*g2*r**2 + 840*D1**2*fd*g2*r*s - 1584*D1*Dd*K*f**2*r**2 - 1584*D1*Dd*K*f**2*r*s + 1584*D1*Dd*K*f**2*r + 396*D1*Dd*K*f**2*s - 396*D1*Dd*K*f**2 + 1152*D1*Dd*K*f*fd*r**2 + 1152*D1*Dd*K*f*fd*r*s - 1152*D1*Dd*K*f*fd*r - 432*D1*Dd*K*f*fd*s + 288*D1*Dd*K*f*fd + 700*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 450*D1*Dd*f**3*r - 500*D1*Dd*f**3*s**2 + 450*D1*Dd*f**3*s - 75*D1*Dd*f**3 - 1560*D1*Dd*f**2*fd*r**2 + 6960*D1*Dd*f**2*fd*r*s - 2950*D1*Dd*f**2*fd*r + 8520*D1*Dd*f**2*fd*s**2 - 10090*D1*Dd*f**2*fd*s + 2880*D1*Dd*f**2*fd - 216*D1*Dd*f**2*r**2 + 108*D1*Dd*f**2*r + 216*D1*Dd*f**2*s**2 - 216*D1*Dd*f**2*s + 54*D1*Dd*f**2 - 2592*D1*Dd*f*fd*r**2 - 4032*D1*Dd*f*fd*r*s + 2952*D1*Dd*f*fd*r - 1440*D1*Dd*f*fd*s**2 + 2232*D1*Dd*f*fd*s - 828*D1*Dd*f*fd + 3360*D1*Dd*f*g2*r**2 + 3360*D1*Dd*f*g2*r*s - 3360*D1*Dd*f*g2*r - 840*D1*Dd*f*g2*s + 840*D1*Dd*f*g2 + 288*D1*Ddd*K*f**2*r**2 + 288*D1*Ddd*K*f**2*r*s - 288*D1*Ddd*K*f**2*r - 72*D1*Ddd*K*f**2*s + 72*D1*Ddd*K*f**2 - 260*D1*Ddd*f**3*r**2 + 1160*D1*Ddd*f**3*r*s - 450*D1*Ddd*f**3*r + 1420*D1*Ddd*f**3*s**2 - 1710*D1*Ddd*f**3*s + 645*D1*Ddd*f**3 - 648*D1*Ddd*f**2*r**2 - 1008*D1*Ddd*f**2*r*s + 828*D1*Ddd*f**2*r - 360*D1*Ddd*f**2*s**2 + 612*D1*Ddd*f**2*s - 342*D1*Ddd*f**2 + 12*D1*bd1*(D1*(15*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(r + s - 1)*(70*K*r - 35*K + 60*fd*(2*r + 2*s - 1) - 112*r - 42*s + 77) - 42*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 3*Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 14*r + 14*s - 14)) + 864*Dd**2*K*f**2*r**2 + 864*Dd**2*K*f**2*r*s - 864*Dd**2*K*f**2*r - 216*Dd**2*K*f**2*s + 144*Dd**2*K*f**2 - 780*Dd**2*f**3*r**2 + 3480*Dd**2*f**3*r*s - 1350*Dd**2*f**3*r + 4260*Dd**2*f**3*s**2 - 5130*Dd**2*f**3*s + 1290*Dd**2*f**3 - 1944*Dd**2*f**2*r**2 - 3024*Dd**2*f**2*r*s + 2484*Dd**2*f**2*r - 1080*Dd**2*f**2*s**2 + 1836*Dd**2*f**2*s - 684*Dd**2*f**2))/(3465*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk3*ct**5*k2**3*st**2*(9*b1*(D1**2*(f*(6*fd*(r*(8*C - 13)*(2*s - 1) - 10*s**2 + 10*s - 5) - 5*fdd*(r*(2*C - 5)*(2*s - 1) - 6*s**2 + 6*s - 3)) - 5*fd**2*(r*(2*C - 5)*(2*s - 1) + s*(6 - 6*s))) + D1*f*(Dd*(6*f*(-8*C*s + r*(16*C - 26)*(2*s - 1) - 20*s**2 + 33*s - 10) - 5*fd*(2*s - 1)*(2*C*(8*r - 1) - 40*r - 24*s + 17)) + 5*Ddd*f*(2*C*s - r*(4*C - 10)*(2*s - 1) + 12*s**2 - 17*s + 6)) - 5*Dd**2*f**2*(2*C*(6*r*(2*s - 1) - 3*s + 2) + r*(30 - 60*s) - 36*s**2 + 51*s - 16)) + f*(D1**2*(f*(-45*bdd1*s*(2*C*(r - 1) - 5*r - 3*s + 5) + 2*fd*(-148*C*s + r*(148*C - 223)*(3*s - 1) - 225*s**2 + 373*s - 75) - 5*fdd*(-26*C*s + r*(26*C - 41)*(3*s - 1) - 45*s**2 + 71*s - 15)) - 5*fd**2*(26*C*(6*r*s - 2*r - 2*s + 1) - 246*r*s + 82*r - 90*s**2 + 142*s - 41)) + 9*D1*bd1*(D1*(6*f*s*(8*C*(r - 1) - 13*r - 5*s + 13) - 5*fd*(C*(8*r*s - 2*r - 4*s + 2) - 20*r*s + 5*r - 12*s**2 + 16*s - 5)) - 5*Dd*f*(2*C*(8*r*s - 2*r - 5*s + 2) - 40*r*s + 10*r - 24*s**2 + 37*s - 10)) + D1*f*(Dd*(2*f*(-148*C*s + r*(296*C - 446)*(2*s - 1) - 300*s**2 + 523*s - 150) - 5*fd*(26*C*(24*r*s - 10*r - 7*s + 3) - 984*r*s + 410*r - 360*s**2 + 587*s - 183)) + 5*Ddd*f*(26*C*s - r*(52*C - 82)*(2*s - 1) + 60*s**2 - 101*s + 30)) - 5*Dd**2*f**2*(26*C*(12*r*s - 6*r - 3*s + 2) - 492*r*s + 246*r - 180*s**2 + 303*s - 112)))/(315*d**2*k1*k3**4) + D1**2*Pk1*Pk3*ct**5*k2**3*(840*D1**2*b1*bd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 840*D1*b1**2*(C - 1)*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 9*b1*(D1**2*(f*(fd*(8*C*(5*r**2 + 18*r*s - 31*r - 11*s + 11) + 22*r**2 + 84*r*s + 134*r + 166*s**2 - 78*s - 5) + fdd*(-8*C*(6*r**2 + 2*r*s - 5*r - 2*s + 2) + 38*r**2 - 140*r*s + 38*r - 146*s**2 + 130*s - 57)) - 2*fd**2*(4*C*(6*r**2 + 2*r*s - 5*r - 2*s + 2) - 19*r**2 + 70*r*s - 19*r + 73*s**2 - 65*s - 8)) + D1*f*(Dd*(f*(4*C*(20*r**2 + r*(72*s - 46) - 18*s + 5) + 44*r**2 + 2*r*(84*s - 53) + 332*s**2 - 374*s + 177) - 2*fd*(4*C*(48*r**2 + 4*r*(4*s - 9) - 10*s + 9) - 152*r**2 + 2*r*(280*s - 89) + 584*s**2 - 622*s + 149)) + Ddd*f*(-8*C*(12*r**2 + 4*r*(s - 2) - s + 3) + 76*r**2 + r*(102 - 280*s) - 292*s**2 + 362*s - 127)) - 2*Dd**2*f**2*(4*C*(36*r**2 + 12*r*(s - 2) - 3*s + 2) - 114*r**2 + 3*r*(140*s - 51) + 438*s**2 - 543*s + 143)) - f*(3444*C*D1**2*f*fd*r**2 + 2064*C*D1**2*f*fd*r*s - 2984*C*D1**2*f*fd*r - 688*C*D1**2*f*fd*s + 1148*C*D1**2*f*fd - 264*C*D1**2*f*fdd*r**2 - 1464*C*D1**2*f*fdd*r*s + 664*C*D1**2*f*fdd*r + 488*C*D1**2*f*fdd*s - 88*C*D1**2*f*fdd - 528*C*D1**2*fd**2*r**2 - 2928*C*D1**2*fd**2*r*s + 1328*C*D1**2*fd**2*r + 976*C*D1**2*fd**2*s - 488*C*D1**2*fd**2 + 4592*C*D1*Dd*f**2*r**2 + 2752*C*D1*Dd*f**2*r*s - 3672*C*D1*Dd*f**2*r - 688*C*D1*Dd*f**2*s + 1148*C*D1*Dd*f**2 - 2112*C*D1*Dd*f*fd*r**2 - 11712*C*D1*Dd*f*fd*r*s + 6112*C*D1*Dd*f*fd*r + 3416*C*D1*Dd*f*fd*s - 1640*C*D1*Dd*f*fd - 352*C*D1*Ddd*f**2*r**2 - 1952*C*D1*Ddd*f**2*r*s + 1152*C*D1*Ddd*f**2*r + 488*C*D1*Ddd*f**2*s - 88*C*D1*Ddd*f**2 - 1056*C*Dd**2*f**2*r**2 - 5856*C*Dd**2*f**2*r*s + 3456*C*Dd**2*f**2*r + 1464*C*Dd**2*f**2*s - 976*C*Dd**2*f**2 + 9*D1**2*bdd1*f*(8*C*(3*r**2 + r*(s - 2) + s + 1) - 19*r**2 + r*(70*s + 6) + 73*s**2 - 86*s - 3) - 4215*D1**2*f*fd*r**2 - 4674*D1**2*f*fd*r*s + 4368*D1**2*f*fd*r - 1635*D1**2*f*fd*s**2 + 2648*D1**2*f*fd*s - 1950*D1**2*f*fd + 555*D1**2*f*fdd*r**2 + 3174*D1**2*f*fdd*r*s - 1428*D1**2*f*fdd*r + 1425*D1**2*f*fdd*s**2 - 2008*D1**2*f*fdd*s + 660*D1**2*f*fdd + 1110*D1**2*fd**2*r**2 + 6348*D1**2*fd**2*r*s - 2856*D1**2*fd**2*r + 2850*D1**2*fd**2*s**2 - 4016*D1**2*fd**2*s + 1058*D1**2*fd**2 - 5620*D1*Dd*f**2*r**2 - 6232*D1*Dd*f**2*r*s + 5926*D1*Dd*f**2*r - 2180*D1*Dd*f**2*s**2 + 3738*D1*Dd*f**2*s - 2495*D1*Dd*f**2 + 4440*D1*Dd*f*fd*r**2 + 25392*D1*Dd*f*fd*r*s - 13170*D1*Dd*f*fd*r + 11400*D1*Dd*f*fd*s**2 - 16906*D1*Dd*f*fd*s + 5444*D1*Dd*f*fd + 740*D1*Ddd*f**2*r**2 + 4232*D1*Ddd*f**2*r*s - 2486*D1*Ddd*f**2*r + 1900*D1*Ddd*f**2*s**2 - 2958*D1*Ddd*f**2*s + 1135*D1*Ddd*f**2 - 9*D1*bd1*(D1*(f*(4*C*(5*r**2 + 2*r*(9*s + 17) + 4*s - 17) + 11*r**2 + 6*r*(7*s - 33) + 83*s**2 - 130*s + 99) + 2*fd*(-4*C*(12*r**2 + r*(4*s - 9) - 1) + 38*r**2 + r*(13 - 140*s) - 146*s**2 + 151*s - 43)) - 2*Dd*f*(r**2*(96*C - 76) + r*(32*C*(s - 2) + 280*s - 39) + 292*s**2 + s*(12*C - 353) + 83)) + 2220*Dd**2*f**2*r**2 + 12696*Dd**2*f**2*r*s - 7458*Dd**2*f**2*r + 5700*Dd**2*f**2*s**2 - 8874*Dd**2*f**2*s + 3066*Dd**2*f**2))/(315*d**2*k1*k3**4) - 4*D1**2*Pk1*Pk3*ct**5*k2*st**2*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k1*k3**2) + D1**2*Pk1*Pk3*ct**5*k2*(840*D1*b1**2*(C - 1)*(D1*fd*r*(s - 1) + Dd*f*(r*(4*s - 2) - s)) + 3*b1*(D1**2*(f*(280*bd1*s*(C - 1)*(2*r - 1) + 3*fd*(r*(88*C - 44)*(2*s - 1) + 166*s**2 - s*(88*C + 78) + 83) - 3*fdd*(r*(16*C - 8)*(2*s - 1) + 146*s**2 - s*(16*C + 130) + 73)) - 6*fd**2*(8*C*(r*(2*s - 1) - s + 1) + r*(4 - 8*s) + 73*s**2 - 65*s - 8)) + 6*D1*f*(Dd*(f*(r*(88*C - 44)*(2*s - 1) + 166*s**2 - s*(44*C + 144) + 83) - 2*fd*(2*s - 1)*(4*C*(8*r - 3) - 16*r + 146*s - 63)) + Ddd*f*(-r*(16*C - 8)*(2*s - 1) - 146*s**2 + s*(8*C + 142) - 73)) - 6*Dd**2*f**2*(8*C*(6*r*(2*s - 1) - 3*s + 2) + r*(24 - 48*s) + 438*s**2 - 426*s + 65)) - f*(D1**2*(f*(9*bdd1*s*(r*(16*C - 8) + 73*s - 8) + 5*fd*(-32*C*s + r*(32*C - 100)*(3*s - 1) - 327*s**2 + 318*s - 109) - 5*fdd*(-16*C*s + r*(16*C - 32)*(3*s - 1) - 285*s**2 + 222*s - 95)) - 10*fd**2*(8*C*(r*(6*s - 2) - 2*s + 1) + r*(32 - 96*s) - 285*s**2 + 222*s - 16)) - 9*D1*bd1*(D1*(f*s*(r*(88*C - 44) + 83*s - 44) - 2*fd*(-8*C*s + r*(8*C - 4)*(4*s - 1) + 146*s**2 - 73*s + 4)) - 4*Dd*f*(-4*C*s + r*(8*C - 4)*(4*s - 1) + 146*s**2 - 79*s + 4)) + 10*D1*f*(Dd*(f*(-16*C*s + r*(32*C - 100)*(2*s - 1) - 218*s**2 + 268*s - 109) + 2*fd*(-4*C*(24*r*s - 10*r - 7*s + 3) + 192*r*s - 80*r + 570*s**2 - 531*s + 119)) + Ddd*f*(8*C*s - r*(16*C - 32)*(2*s - 1) + 190*s**2 - 206*s + 95)) - 10*Dd**2*f**2*(8*C*(6*r*(2*s - 1) - 3*s + 2) - 96*r*(2*s - 1) - 570*s**2 + 618*s - 127)))/(315*d**2*k1*k3**2) - 4*D1**2*Pk1*Pk3*ct**5*(D1*f*s*(-14*D1*bd1**2*s - 5*D1*bdd1*f*s + 10*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*f*(2 - 4*s))) + 7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(10*fd*(2*s**2 - 2*s + 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(28*bd1 - 14*bdd1)) - 2*fd*s*(14*bd1 + 5*fd)*(s - 1)) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(14*bd1*s + 5*fd*(2*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(35*d**2*k1*k2) - D1**2*Pk1*Pk3*ct**5*k2**3*(234*D1**2*b1*f*fd*r**2 - 54*D1**2*b1*f*fdd*r**2 - 54*D1**2*b1*fd**2*r**2 - 27*D1**2*bdd1*f**2*(r - 1)**2 + 249*D1**2*f**2*fd*r**2 - 166*D1**2*f**2*fd*r + 83*D1**2*f**2*fd + 51*D1**2*f**2*fdd*r**2 - 34*D1**2*f**2*fdd*r + 17*D1**2*f**2*fdd + 102*D1**2*f*fd**2*r**2 - 68*D1**2*f*fd**2*r + 468*D1*Dd*b1*f**2*r**2 - 234*D1*Dd*b1*f**2*r + 117*D1*Dd*b1*f**2 - 432*D1*Dd*b1*f*fd*r**2 + 108*D1*Dd*b1*f*fd*r + 332*D1*Dd*f**3*r**2 - 166*D1*Dd*f**3*r + 83*D1*Dd*f**3 + 408*D1*Dd*f**2*fd*r**2 - 238*D1*Dd*f**2*fd*r + 34*D1*Dd*f**2*fd - 108*D1*Ddd*b1*f**2*r**2 + 54*D1*Ddd*b1*f**2*r - 27*D1*Ddd*b1*f**2 + 68*D1*Ddd*f**3*r**2 - 34*D1*Ddd*f**3*r + 17*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(13*D1*f*(r - 1) - 12*D1*fd*r + 6*Dd*f*(1 - 4*r)) - 324*Dd**2*b1*f**2*r**2 + 162*Dd**2*b1*f**2*r + 204*Dd**2*f**3*r**2 - 102*Dd**2*f**3*r)/(315*d**2*k1**3*k3**2) + 4*D1**2*Pk1*Pk3*ct**4*f*k2**6*st**2*(99*D1**2*b1*f*fd*r**2 + 99*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 99*D1**2*b1*f*fdd*r**2 + 99*D1**2*b1*f*fdd*r*s - 66*D1**2*b1*f*fdd*r + 198*D1**2*b1*fd**2*r**2 + 198*D1**2*b1*fd**2*r*s - 132*D1**2*b1*fd**2*r + 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 380*D1**2*f**2*fd*r**2 + 380*D1**2*f**2*fd*r*s - 380*D1**2*f**2*fd*r - 95*D1**2*f**2*fd*s + 95*D1**2*f**2*fd - 300*D1**2*f**2*fdd*r**2 - 300*D1**2*f**2*fdd*r*s + 300*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s - 75*D1**2*f**2*fdd - 900*D1**2*f*fd**2*r**2 - 900*D1**2*f*fd**2*r*s + 900*D1**2*f*fd**2*r + 225*D1**2*f*fd**2*s - 150*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 132*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r - 33*D1*Dd*b1*f**2*s + 33*D1*Dd*b1*f**2 + 792*D1*Dd*b1*f*fd*r**2 + 792*D1*Dd*b1*f*fd*r*s - 660*D1*Dd*b1*f*fd*r - 99*D1*Dd*b1*f*fd*s + 66*D1*Dd*b1*f*fd + 380*D1*Dd*f**3*r**2 + 380*D1*Dd*f**3*r*s - 380*D1*Dd*f**3*r - 95*D1*Dd*f**3*s + 95*D1*Dd*f**3 - 2400*D1*Dd*f**2*fd*r**2 - 2400*D1*Dd*f**2*fd*r*s + 2400*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s - 450*D1*Dd*f**2*fd + 132*D1*Ddd*b1*f**2*r**2 + 132*D1*Ddd*b1*f**2*r*s - 132*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 - 300*D1*Ddd*f**3*r**2 - 300*D1*Ddd*f**3*r*s + 300*D1*Ddd*f**3*r + 75*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) + Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 396*Dd**2*b1*f**2*r**2 + 396*Dd**2*b1*f**2*r*s - 396*Dd**2*b1*f**2*r - 99*Dd**2*b1*f**2*s + 66*Dd**2*b1*f**2 - 900*Dd**2*f**3*r**2 - 900*Dd**2*f**3*r*s + 900*Dd**2*f**3*r + 225*Dd**2*f**3*s - 150*Dd**2*f**3)/(693*d**2*k1**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**4*k1**4*k2**2*(1872*C*D1**2*b1*f*fd*r**2 + 3744*C*D1**2*b1*f*fd*r*s - 1872*C*D1**2*b1*f*fd*r + 1872*C*D1**2*b1*f*fd*s**2 - 1872*C*D1**2*b1*f*fd*s + 936*C*D1**2*b1*f*fd - 2700*C*D1**2*b1*f*fdd*r**2 - 5400*C*D1**2*b1*f*fdd*r*s + 2700*C*D1**2*b1*f*fdd*r - 2700*C*D1**2*b1*f*fdd*s**2 + 2700*C*D1**2*b1*f*fdd*s - 1350*C*D1**2*b1*f*fdd - 2700*C*D1**2*b1*fd**2*r**2 - 5400*C*D1**2*b1*fd**2*r*s + 2700*C*D1**2*b1*fd**2*r - 2700*C*D1**2*b1*fd**2*s**2 + 2700*C*D1**2*b1*fd**2*s + 2520*C*D1**2*f**2*fd*r**2 + 5040*C*D1**2*f**2*fd*r*s - 3360*C*D1**2*f**2*fd*r + 2520*C*D1**2*f**2*fd*s**2 - 3360*C*D1**2*f**2*fd*s + 1680*C*D1**2*f**2*fd - 3150*C*D1**2*f**2*fdd*r**2 - 6300*C*D1**2*f**2*fdd*r*s + 4200*C*D1**2*f**2*fdd*r - 3150*C*D1**2*f**2*fdd*s**2 + 4200*C*D1**2*f**2*fdd*s - 2100*C*D1**2*f**2*fdd - 6300*C*D1**2*f*fd**2*r**2 - 12600*C*D1**2*f*fd**2*r*s + 8400*C*D1**2*f*fd**2*r - 6300*C*D1**2*f*fd**2*s**2 + 8400*C*D1**2*f*fd**2*s - 2100*C*D1**2*f*fd**2 + 3744*C*D1*Dd*b1*f**2*r**2 + 7488*C*D1*Dd*b1*f**2*r*s - 5616*C*D1*Dd*b1*f**2*r + 3744*C*D1*Dd*b1*f**2*s**2 - 5616*C*D1*Dd*b1*f**2*s + 2808*C*D1*Dd*b1*f**2 - 21600*C*D1*Dd*b1*f*fd*r**2 - 43200*C*D1*Dd*b1*f*fd*r*s + 27000*C*D1*Dd*b1*f*fd*r - 21600*C*D1*Dd*b1*f*fd*s**2 + 27000*C*D1*Dd*b1*f*fd*s - 8100*C*D1*Dd*b1*f*fd + 3360*C*D1*Dd*f**3*r**2 + 6720*C*D1*Dd*f**3*r*s - 5040*C*D1*Dd*f**3*r + 3360*C*D1*Dd*f**3*s**2 - 5040*C*D1*Dd*f**3*s + 2520*C*D1*Dd*f**3 - 25200*C*D1*Dd*f**2*fd*r**2 - 50400*C*D1*Dd*f**2*fd*r*s + 35700*C*D1*Dd*f**2*fd*r - 25200*C*D1*Dd*f**2*fd*s**2 + 35700*C*D1*Dd*f**2*fd*s - 12600*C*D1*Dd*f**2*fd - 5400*C*D1*Ddd*b1*f**2*r**2 - 10800*C*D1*Ddd*b1*f**2*r*s + 8100*C*D1*Ddd*b1*f**2*r - 5400*C*D1*Ddd*b1*f**2*s**2 + 8100*C*D1*Ddd*b1*f**2*s - 4050*C*D1*Ddd*b1*f**2 - 4200*C*D1*Ddd*f**3*r**2 - 8400*C*D1*Ddd*f**3*r*s + 6300*C*D1*Ddd*f**3*r - 4200*C*D1*Ddd*f**3*s**2 + 6300*C*D1*Ddd*f**3*s - 3150*C*D1*Ddd*f**3 - 16200*C*Dd**2*b1*f**2*r**2 - 32400*C*Dd**2*b1*f**2*r*s + 24300*C*Dd**2*b1*f**2*r - 16200*C*Dd**2*b1*f**2*s**2 + 24300*C*Dd**2*b1*f**2*s - 8100*C*Dd**2*b1*f**2 - 12600*C*Dd**2*f**3*r**2 - 25200*C*Dd**2*f**3*r*s + 18900*C*Dd**2*f**3*r - 12600*C*Dd**2*f**3*s**2 + 18900*C*Dd**2*f**3*s - 6300*C*Dd**2*f**3 - 1206*D1**2*b1*f*fd*r**2 - 2412*D1**2*b1*f*fd*r*s + 1206*D1**2*b1*f*fd*r - 1206*D1**2*b1*f*fd*s**2 + 1206*D1**2*b1*f*fd*s - 603*D1**2*b1*f*fd + 1800*D1**2*b1*f*fdd*r**2 + 3600*D1**2*b1*f*fdd*r*s - 1800*D1**2*b1*f*fdd*r + 1800*D1**2*b1*f*fdd*s**2 - 1800*D1**2*b1*f*fdd*s + 900*D1**2*b1*f*fdd + 1800*D1**2*b1*fd**2*r**2 + 3600*D1**2*b1*fd**2*r*s - 1800*D1**2*b1*fd**2*r + 1800*D1**2*b1*fd**2*s**2 - 1800*D1**2*b1*fd**2*s - 450*D1**2*bdd1*f**2*(3*C - 2)*(r + s - 1)**2 - 1635*D1**2*f**2*fd*r**2 - 3270*D1**2*f**2*fd*r*s + 2180*D1**2*f**2*fd*r - 1635*D1**2*f**2*fd*s**2 + 2180*D1**2*f**2*fd*s - 1090*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 2412*D1*Dd*b1*f**2*r**2 - 4824*D1*Dd*b1*f**2*r*s + 3618*D1*Dd*b1*f**2*r - 2412*D1*Dd*b1*f**2*s**2 + 3618*D1*Dd*b1*f**2*s - 1809*D1*Dd*b1*f**2 + 14400*D1*Dd*b1*f*fd*r**2 + 28800*D1*Dd*b1*f*fd*r*s - 18000*D1*Dd*b1*f*fd*r + 14400*D1*Dd*b1*f*fd*s**2 - 18000*D1*Dd*b1*f*fd*s + 5400*D1*Dd*b1*f*fd - 2180*D1*Dd*f**3*r**2 - 4360*D1*Dd*f**3*r*s + 3270*D1*Dd*f**3*r - 2180*D1*Dd*f**3*s**2 + 3270*D1*Dd*f**3*s - 1635*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 23800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 23800*D1*Dd*f**2*fd*s + 8400*D1*Dd*f**2*fd + 3600*D1*Ddd*b1*f**2*r**2 + 7200*D1*Ddd*b1*f**2*r*s - 5400*D1*Ddd*b1*f**2*r + 3600*D1*Ddd*b1*f**2*s**2 - 5400*D1*Ddd*b1*f**2*s + 2700*D1*Ddd*b1*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(D1*f*(104*C - 67)*(r + s - 1) - D1*fd*(300*C - 200)*(2*r + 2*s - 1) - Dd*f*(300*C - 200)*(4*r + 4*s - 3)) + 10800*Dd**2*b1*f**2*r**2 + 21600*Dd**2*b1*f**2*r*s - 16200*Dd**2*b1*f**2*r + 10800*Dd**2*b1*f**2*s**2 - 16200*Dd**2*b1*f**2*s + 5400*Dd**2*b1*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3)/(105*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**4*k1**4*(9*b1*(D1**2*(f*(fd*(44*C - 25) + fdd*(30 - 50*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(30 - 50*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(44*C - 25)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(30 - 50*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(30 - 50*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(30 - 50*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(68*C - 39)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (10*C - 6)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(42 - 70*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(44*C - 25)*(r + s - 1) - fd*(50*C - 30)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(30 - 50*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(68*C - 39)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(70*C - 42)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(42 - 70*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(42 - 70*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k3**6) - D1**2*Pk1*Pk3*ct**4*k1**4*(8*C - 4)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(14*fd*(3*s**2 - 2*s + 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + 2*D1*f*(14*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 7*fd*(3*s - 1)) - 7*Ddd*f*(2*s**2 - 2*s + 1)) - 14*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k2**2*k3**4) - 4*D1**2*Pk1*Pk3*ct**4*k1**2*k2**4*st**2*(5904*C*D1**2*b1*f*fd*r**2 + 11808*C*D1**2*b1*f*fd*r*s - 5904*C*D1**2*b1*f*fd*r + 5904*C*D1**2*b1*f*fd*s**2 - 5904*C*D1**2*b1*f*fd*s + 2952*C*D1**2*b1*f*fd - 4716*C*D1**2*b1*f*fdd*r**2 - 9432*C*D1**2*b1*f*fdd*r*s + 4716*C*D1**2*b1*f*fdd*r - 4716*C*D1**2*b1*f*fdd*s**2 + 4716*C*D1**2*b1*f*fdd*s - 2358*C*D1**2*b1*f*fdd - 4716*C*D1**2*b1*fd**2*r**2 - 9432*C*D1**2*b1*fd**2*r*s + 4716*C*D1**2*b1*fd**2*r - 4716*C*D1**2*b1*fd**2*s**2 + 4716*C*D1**2*b1*fd**2*s + 5592*C*D1**2*f**2*fd*r**2 + 11184*C*D1**2*f**2*fd*r*s - 7456*C*D1**2*f**2*fd*r + 5592*C*D1**2*f**2*fd*s**2 - 7456*C*D1**2*f**2*fd*s + 3728*C*D1**2*f**2*fd - 3930*C*D1**2*f**2*fdd*r**2 - 7860*C*D1**2*f**2*fdd*r*s + 5240*C*D1**2*f**2*fdd*r - 3930*C*D1**2*f**2*fdd*s**2 + 5240*C*D1**2*f**2*fdd*s - 2620*C*D1**2*f**2*fdd - 7860*C*D1**2*f*fd**2*r**2 - 15720*C*D1**2*f*fd**2*r*s + 10480*C*D1**2*f*fd**2*r - 7860*C*D1**2*f*fd**2*s**2 + 10480*C*D1**2*f*fd**2*s - 2620*C*D1**2*f*fd**2 + 11808*C*D1*Dd*b1*f**2*r**2 + 23616*C*D1*Dd*b1*f**2*r*s - 17712*C*D1*Dd*b1*f**2*r + 11808*C*D1*Dd*b1*f**2*s**2 - 17712*C*D1*Dd*b1*f**2*s + 8856*C*D1*Dd*b1*f**2 - 37728*C*D1*Dd*b1*f*fd*r**2 - 75456*C*D1*Dd*b1*f*fd*r*s + 47160*C*D1*Dd*b1*f*fd*r - 37728*C*D1*Dd*b1*f*fd*s**2 + 47160*C*D1*Dd*b1*f*fd*s - 14148*C*D1*Dd*b1*f*fd + 7456*C*D1*Dd*f**3*r**2 + 14912*C*D1*Dd*f**3*r*s - 11184*C*D1*Dd*f**3*r + 7456*C*D1*Dd*f**3*s**2 - 11184*C*D1*Dd*f**3*s + 5592*C*D1*Dd*f**3 - 31440*C*D1*Dd*f**2*fd*r**2 - 62880*C*D1*Dd*f**2*fd*r*s + 44540*C*D1*Dd*f**2*fd*r - 31440*C*D1*Dd*f**2*fd*s**2 + 44540*C*D1*Dd*f**2*fd*s - 15720*C*D1*Dd*f**2*fd - 9432*C*D1*Ddd*b1*f**2*r**2 - 18864*C*D1*Ddd*b1*f**2*r*s + 14148*C*D1*Ddd*b1*f**2*r - 9432*C*D1*Ddd*b1*f**2*s**2 + 14148*C*D1*Ddd*b1*f**2*s - 7074*C*D1*Ddd*b1*f**2 - 5240*C*D1*Ddd*f**3*r**2 - 10480*C*D1*Ddd*f**3*r*s + 7860*C*D1*Ddd*f**3*r - 5240*C*D1*Ddd*f**3*s**2 + 7860*C*D1*Ddd*f**3*s - 3930*C*D1*Ddd*f**3 - 28296*C*Dd**2*b1*f**2*r**2 - 56592*C*Dd**2*b1*f**2*r*s + 42444*C*Dd**2*b1*f**2*r - 28296*C*Dd**2*b1*f**2*s**2 + 42444*C*Dd**2*b1*f**2*s - 14148*C*Dd**2*b1*f**2 - 15720*C*Dd**2*f**3*r**2 - 31440*C*Dd**2*f**3*r*s + 23580*C*Dd**2*f**3*r - 15720*C*Dd**2*f**3*s**2 + 23580*C*Dd**2*f**3*s - 7860*C*Dd**2*f**3 - 4428*D1**2*b1*f*fd*r**2 - 8856*D1**2*b1*f*fd*r*s + 4428*D1**2*b1*f*fd*r - 4428*D1**2*b1*f*fd*s**2 + 4428*D1**2*b1*f*fd*s - 2214*D1**2*b1*f*fd + 3726*D1**2*b1*f*fdd*r**2 + 7452*D1**2*b1*f*fdd*r*s - 3726*D1**2*b1*f*fdd*r + 3726*D1**2*b1*f*fdd*s**2 - 3726*D1**2*b1*f*fdd*s + 1863*D1**2*b1*f*fdd + 3726*D1**2*b1*fd**2*r**2 + 7452*D1**2*b1*fd**2*r*s - 3726*D1**2*b1*fd**2*r + 3726*D1**2*b1*fd**2*s**2 - 3726*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(262*C - 207)*(r + s - 1)**2 - 4266*D1**2*f**2*fd*r**2 - 8532*D1**2*f**2*fd*r*s + 5688*D1**2*f**2*fd*r - 4266*D1**2*f**2*fd*s**2 + 5688*D1**2*f**2*fd*s - 2844*D1**2*f**2*fd + 3105*D1**2*f**2*fdd*r**2 + 6210*D1**2*f**2*fdd*r*s - 4140*D1**2*f**2*fdd*r + 3105*D1**2*f**2*fdd*s**2 - 4140*D1**2*f**2*fdd*s + 2070*D1**2*f**2*fdd + 6210*D1**2*f*fd**2*r**2 + 12420*D1**2*f*fd**2*r*s - 8280*D1**2*f*fd**2*r + 6210*D1**2*f*fd**2*s**2 - 8280*D1**2*f*fd**2*s + 2070*D1**2*f*fd**2 - 8856*D1*Dd*b1*f**2*r**2 - 17712*D1*Dd*b1*f**2*r*s + 13284*D1*Dd*b1*f**2*r - 8856*D1*Dd*b1*f**2*s**2 + 13284*D1*Dd*b1*f**2*s - 6642*D1*Dd*b1*f**2 + 29808*D1*Dd*b1*f*fd*r**2 + 59616*D1*Dd*b1*f*fd*r*s - 37260*D1*Dd*b1*f*fd*r + 29808*D1*Dd*b1*f*fd*s**2 - 37260*D1*Dd*b1*f*fd*s + 11178*D1*Dd*b1*f*fd - 5688*D1*Dd*f**3*r**2 - 11376*D1*Dd*f**3*r*s + 8532*D1*Dd*f**3*r - 5688*D1*Dd*f**3*s**2 + 8532*D1*Dd*f**3*s - 4266*D1*Dd*f**3 + 24840*D1*Dd*f**2*fd*r**2 + 49680*D1*Dd*f**2*fd*r*s - 35190*D1*Dd*f**2*fd*r + 24840*D1*Dd*f**2*fd*s**2 - 35190*D1*Dd*f**2*fd*s + 12420*D1*Dd*f**2*fd + 7452*D1*Ddd*b1*f**2*r**2 + 14904*D1*Ddd*b1*f**2*r*s - 11178*D1*Ddd*b1*f**2*r + 7452*D1*Ddd*b1*f**2*s**2 - 11178*D1*Ddd*b1*f**2*s + 5589*D1*Ddd*b1*f**2 + 4140*D1*Ddd*f**3*r**2 + 8280*D1*Ddd*f**3*r*s - 6210*D1*Ddd*f**3*r + 4140*D1*Ddd*f**3*s**2 - 6210*D1*Ddd*f**3*s + 3105*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(164*C - 123)*(r + s - 1) - D1*fd*(262*C - 207)*(2*r + 2*s - 1) - Dd*f*(262*C - 207)*(4*r + 4*s - 3)) + 22356*Dd**2*b1*f**2*r**2 + 44712*Dd**2*b1*f**2*r*s - 33534*Dd**2*b1*f**2*r + 22356*Dd**2*b1*f**2*s**2 - 33534*Dd**2*b1*f**2*s + 11178*Dd**2*b1*f**2 + 12420*Dd**2*f**3*r**2 + 24840*Dd**2*f**3*r*s - 18630*Dd**2*f**3*r + 12420*Dd**2*f**3*s**2 - 18630*Dd**2*f**3*s + 6210*Dd**2*f**3)/(105*d**2*k3**8) + 4*D1**2*Pk1*Pk3*ct**4*k1**2*k2**4*(5940*C*D1**2*f**2*fd*r**2 + 11880*C*D1**2*f**2*fd*r*s - 7920*C*D1**2*f**2*fd*r + 5940*C*D1**2*f**2*fd*s**2 - 7920*C*D1**2*f**2*fd*s + 3960*C*D1**2*f**2*fd + 7920*C*D1*Dd*f**3*r**2 + 15840*C*D1*Dd*f**3*r*s - 11880*C*D1*Dd*f**3*r + 7920*C*D1*Dd*f**3*s**2 - 11880*C*D1*Dd*f**3*s + 5940*C*D1*Dd*f**3 - 330*D1**2*bd1**2*f*(-21*K + 10*f + 14)*(r + s - 1)**2 + 165*D1**2*bdd1*f*(5*f*(3*K - 2) - 42*g2)*(r + s - 1)**2 - 3780*D1**2*f**3*fd*r**2 - 7560*D1**2*f**3*fd*r*s + 5670*D1**2*f**3*fd*r - 3780*D1**2*f**3*fd*s**2 + 5670*D1**2*f**3*fd*s - 2835*D1**2*f**3*fd + 4200*D1**2*f**3*fdd*r**2 + 8400*D1**2*f**3*fdd*r*s - 6300*D1**2*f**3*fdd*r + 4200*D1**2*f**3*fdd*s**2 - 6300*D1**2*f**3*fdd*s + 3150*D1**2*f**3*fdd + 12600*D1**2*f**2*fd**2*r**2 + 25200*D1**2*f**2*fd**2*r*s - 18900*D1**2*f**2*fd**2*r + 12600*D1**2*f**2*fd**2*s**2 - 18900*D1**2*f**2*fd**2*s + 6300*D1**2*f**2*fd**2 - 4455*D1**2*f**2*fd*r**2 - 8910*D1**2*f**2*fd*r*s + 5940*D1**2*f**2*fd*r - 4455*D1**2*f**2*fd*s**2 + 5940*D1**2*f**2*fd*s - 2970*D1**2*f**2*fd + 5742*D1**2*f**2*gd2*r**2 + 11484*D1**2*f**2*gd2*r*s - 11484*D1**2*f**2*gd2*r + 5742*D1**2*f**2*gd2*s**2 - 11484*D1**2*f**2*gd2*s + 5742*D1**2*f**2*gd2 - 4950*D1**2*f**2*gdd2*r**2 - 9900*D1**2*f**2*gdd2*r*s + 9900*D1**2*f**2*gdd2*r - 4950*D1**2*f**2*gdd2*s**2 + 9900*D1**2*f**2*gdd2*s - 4950*D1**2*f**2*gdd2 + 11484*D1**2*f*fd*g2*r**2 + 22968*D1**2*f*fd*g2*r*s - 11484*D1**2*f*fd*g2*r + 11484*D1**2*f*fd*g2*s**2 - 11484*D1**2*f*fd*g2*s + 5742*D1**2*f*fd*g2 - 19800*D1**2*f*fd*gd2*r**2 - 39600*D1**2*f*fd*gd2*r*s + 29700*D1**2*f*fd*gd2*r - 19800*D1**2*f*fd*gd2*s**2 + 29700*D1**2*f*fd*gd2*s - 9900*D1**2*f*fd*gd2 - 9900*D1**2*f*fdd*g2*r**2 - 19800*D1**2*f*fdd*g2*r*s + 9900*D1**2*f*fdd*g2*r - 9900*D1**2*f*fdd*g2*s**2 + 9900*D1**2*f*fdd*g2*s - 4950*D1**2*f*fdd*g2 - 9900*D1**2*fd**2*g2*r**2 - 19800*D1**2*fd**2*g2*r*s + 9900*D1**2*fd**2*g2*r - 9900*D1**2*fd**2*g2*s**2 + 9900*D1**2*fd**2*g2*s - 3780*D1*Dd*f**4*r**2 - 7560*D1*Dd*f**4*r*s + 5670*D1*Dd*f**4*r - 3780*D1*Dd*f**4*s**2 + 5670*D1*Dd*f**4*s - 2835*D1*Dd*f**4 + 33600*D1*Dd*f**3*fd*r**2 + 67200*D1*Dd*f**3*fd*r*s - 50400*D1*Dd*f**3*fd*r + 33600*D1*Dd*f**3*fd*s**2 - 50400*D1*Dd*f**3*fd*s + 18900*D1*Dd*f**3*fd - 5940*D1*Dd*f**3*r**2 - 11880*D1*Dd*f**3*r*s + 8910*D1*Dd*f**3*r - 5940*D1*Dd*f**3*s**2 + 8910*D1*Dd*f**3*s - 4455*D1*Dd*f**3 + 22968*D1*Dd*f**2*g2*r**2 + 45936*D1*Dd*f**2*g2*r*s - 34452*D1*Dd*f**2*g2*r + 22968*D1*Dd*f**2*g2*s**2 - 34452*D1*Dd*f**2*g2*s + 17226*D1*Dd*f**2*g2 - 39600*D1*Dd*f**2*gd2*r**2 - 79200*D1*Dd*f**2*gd2*r*s + 69300*D1*Dd*f**2*gd2*r - 39600*D1*Dd*f**2*gd2*s**2 + 69300*D1*Dd*f**2*gd2*s - 29700*D1*Dd*f**2*gd2 - 79200*D1*Dd*f*fd*g2*r**2 - 158400*D1*Dd*f*fd*g2*r*s + 99000*D1*Dd*f*fd*g2*r - 79200*D1*Dd*f*fd*g2*s**2 + 99000*D1*Dd*f*fd*g2*s - 29700*D1*Dd*f*fd*g2 + 4200*D1*Ddd*f**4*r**2 + 8400*D1*Ddd*f**4*r*s - 6300*D1*Ddd*f**4*r + 4200*D1*Ddd*f**4*s**2 - 6300*D1*Ddd*f**4*s + 3150*D1*Ddd*f**4 - 19800*D1*Ddd*f**2*g2*r**2 - 39600*D1*Ddd*f**2*g2*r*s + 29700*D1*Ddd*f**2*g2*r - 19800*D1*Ddd*f**2*g2*s**2 + 29700*D1*Ddd*f**2*g2*s - 14850*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(10*f**3*(r + s - 1) + 3*f**2*(28*C - 29*K - 4)*(r + s - 1) + 50*f*fd*(3*K - 2)*(2*r + 2*s - 1) + 210*f*(g2 - 2*gd2)*(r + s - 1) - 420*fd*g2*(r + s)) + 10*Dd*f*(5*f*(3*K - 2) - 42*g2)*(4*r + 4*s - 3))*(r + s - 1) + 12600*Dd**2*f**4*r**2 + 25200*Dd**2*f**4*r*s - 18900*Dd**2*f**4*r + 12600*Dd**2*f**4*s**2 - 18900*Dd**2*f**4*s + 6300*Dd**2*f**4 - 59400*Dd**2*f**2*g2*r**2 - 118800*Dd**2*f**2*g2*r*s + 89100*Dd**2*f**2*g2*r - 59400*Dd**2*f**2*g2*s**2 + 89100*Dd**2*f**2*g2*s - 29700*Dd**2*f**2*g2 + 11*b1**2*(D1**2*(3*f*(51*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-5*r - 5*s)*(60*fd**2*(r + s - 1) + 7*fd*(9*K - 5)*(r + s) - 21*fdd*(3*K - 2)*(r + s))) + D1*(Dd*(153*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (63*K - 35)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 210*fd*(3*K - 2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 15*Ddd*f*(-21*K + 10*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f*(-21*K + 10*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(-30*D1**2*bdd1*f*(-21*K + 10*f + 14)*(r + s - 1)**2 - 3*D1**2*(-10*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-3*fd*(28*C - 29*K - 4)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 25*fdd*(3*K - 2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*(42*gd2 - 42*gdd2)*(r + s - 1)**2) - (10*r + 10*s)*(5*fd**2*(3*K - 2)*(r + s - 1) + 21*fd*(g2*(r + s) - 2*gd2*(r + s - 1)) - 21*fdd*g2*(r + s))) + 2*D1*bd1*(D1*(153*f**2*(r + s - 1) - 5*f*(60*fd*(2*r + 2*s - 1) + (63*K - 35)*(r + s - 1)) + 210*fd*(3*K - 2)*(r + s)) - 30*Dd*f*(-21*K + 10*f + 14)*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(-10*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*f**2*(28*C - 29*K - 4)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*f*(5*fd*(3*K - 2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 21*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 42*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 420*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 5*Ddd*f*(5*f*(3*K - 2) - 42*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f*(5*f*(3*K - 2) - 42*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(385*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**4*k1**2*k2**2*st**2*(3*b1*(D1**2*(f*(fd*(288*C - 212) + fdd*(141 - 186*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(141 - 186*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(288*C - 212)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(141 - 186*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(141 - 186*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(141 - 186*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(512*C - 380)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (62*C - 47)*(9*bdd1*s*(r + s - 1) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(235 - 310*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(288*C - 212)*(r + s - 1) - fd*(186*C - 141)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(141 - 186*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(512*C - 380)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(310*C - 235)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(235 - 310*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(235 - 310*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**6) - 2*D1**2*Pk1*Pk3*ct**4*k1**2*k2**2*(84*D1*b1*bd1*(D1*(f*(11*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(27 - 36*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(27 - 36*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 42*b1**2*(D1**2*(fd*(22*C - 14) + fdd*(27 - 36*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(11*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(27 - 36*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(27 - 36*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(216*C - 162)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(42*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1**2*(f*(fd*(8*C*(113*r**2 + r*(436*s - 193) + 323*s**2 - 298*s + 149) - 654*r**2 - 4*r*(674*s - 303) - 2042*s**2 + 1906*s - 953) + fdd*(-20*C*(66*r**2 + 2*r*(94*s - 41) + 122*s**2 - 110*s + 55) + 950*r**2 + 18*r*(162*s - 71) + 1966*s**2 - 1786*s + 893)) - 2*fd**2*(20*C*(33*r**2 + r*(94*s - 41) + 61*s**2 - 55*s - 6) - 475*r**2 - 9*r*(162*s - 71) - 983*s**2 + 893*s + 90)) + D1*f*(Dd*(f*(4*C*(452*r**2 + 2*r*(872*s - 549) + 1292*s**2 - 1728*s + 759) - 1308*r**2 - 5392*r*s + 3350*r - 4084*s**2 + 5432*s - 2369) - 2*fd*(20*C*(264*r**2 + 752*r*s - 418*r + 488*s**2 - 558*s + 151) - 3800*r**2 - 11664*r*s + 6422*r - 7864*s**2 + 8962*s - 2425)) + Ddd*f*(-20*C*(132*r**2 + 376*r*s - 254*r + 244*s**2 - 338*s + 155) + 1900*r**2 + 5832*r*s - 3866*r + 3932*s**2 - 5390*s + 2441)) - 2*Dd**2*f**2*(20*C*(198*r**2 + r*(564*s - 381) + 366*s**2 - 507*s + 155) - 2850*r**2 + r*(5799 - 8748*s) - 5898*s**2 + 8085*s - 2441)) + f*(-756*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(20*C*(33*r**2 + r*(94*s - 78) + 61*s**2 - 106*s + 39) - 475*r**2 - 2*r*(729*s - 565) - 983*s**2 + 1638*s - 565) - 5*D1**2*(f*(fd*(8*C*(417*r**2 + 1119*r*s - 651*r + 702*s**2 - 841*s + 373) - 2367*r**2 - 6780*r*s + 3838*r - 4413*s**2 + 5202*s - 2260) + fdd*(-28*C*(129*r**2 + 6*r*(53*s - 32) + 189*s**2 - 232*s + 106) + 2601*r**2 + 6846*r*s - 4016*r + 4245*s**2 - 5112*s + 2282)) - 2*fd**2*(28*C*(129*r**2 + 6*r*(53*s - 32) + 189*s**2 - 232*s + 53) - 2601*r**2 - 6846*r*s + 4016*r - 4245*s**2 + 5112*s - 1141)) - 9*D1*bd1*(D1*(f*(4*C*(113*r**2 + 436*r*s - 276*r + 323*s**2 - 486*s + 138) - 327*r**2 - 1348*r*s + 790*r - 1021*s**2 + 1484*s - 395) + 2*fd*(-20*C*(66*r**2 + 188*r*s - 119*r + 122*s**2 - 161*s + 53) + 950*r**2 + 2916*r*s - 1769*r + 1966*s**2 - 2531*s + 819)) - 2*Dd*f*(20*C*(132*r**2 + 376*r*s - 283*r + 244*s**2 - 381*s + 145) - 1900*r**2 - 5832*r*s + 4193*r - 3932*s**2 + 5971*s - 2203)) - 5*D1*f*(Dd*(f*(8*C*(556*r**2 + 4*r*(373*s - 256) + 936*s**2 - 1309*s + 607) - 3156*r**2 + r*(6098 - 9040*s) - 5884*s**2 + 8144*s - 3731) + 2*fd*(-28*C*(516*r**2 + 3*r*(424*s - 277) + 756*s**2 - 1001*s + 328) + 10404*r**2 + 7*r*(3912*s - 2497) + 16980*s**2 - 22137*s + 7120)) + Ddd*f*(-28*C*(172*r**2 + r*(424*s - 298) + 252*s**2 - 358*s + 169) + 3468*r**2 + r*(9128*s - 6298) + 5660*s**2 - 7942*s + 3697)) + 10*Dd**2*f**2*(28*C*(258*r**2 + r*(636*s - 447) + 378*s**2 - 537*s + 169) - 5202*r**2 + r*(9447 - 13692*s) - 8490*s**2 + 11913*s - 3697)))/(315*d**2*k3**6) - D1**2*Pk1*Pk3*ct**4*k1**2*st**2*(488*C - 348)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(315*d**2*k3**4) + D1**2*Pk1*Pk3*ct**4*k1**2*(-84*b1**2*(D1**2*(s - 1)*(fd*(16*C - 9) + fdd*(12 - 18*C))*(r + s - 1) + D1*(Dd*(f*(16*C - 9)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(18*C - 12)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(12 - 18*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(18*C - 12)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) - 3*b1*(-3*D1**2*(f*(56*bdd1*s*(3*C - 2)*(2*r + 2*s - 1) + fd*(4*C*(74*r*(2*s - 1) + 414*s**2 - 382*s + 207) - 196*r*(2*s - 1) - 1226*s**2 + 1150*s - 613) + fdd*(-12*C*(24*r*(2*s - 1) + 118*s**2 - 108*s + 59) + 182*r*(2*s - 1) + 1054*s**2 - 974*s + 527)) - 2*fd**2*(12*C*(12*r*(2*s - 1) + 59*s**2 - 54*s - 5) - 91*r*(2*s - 1) - 527*s**2 + 487*s + 40)) + 28*D1*bd1*(D1*(f*s*(16*C - 9)*(2*r + 2*s - 1) - fd*(18*C - 12)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(24 - 36*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 6*D1*f*(Dd*(f*(4*C*(74*r*(2*s - 1) + 414*s**2 - 451*s + 207) - 392*r*s + 196*r - 1226*s**2 + 1324*s - 613) - fd*(2*s - 1)*(48*C*(24*r + 59*s - 30) - 728*r - 2108*s + 1065)) + Ddd*f*(-12*C*(24*r*(2*s - 1) + 118*s**2 - 130*s + 59) + 182*r*(2*s - 1) + 1054*s**2 - 1145*s + 527)) + 6*Dd**2*f**2*(12*C*(72*r*(2*s - 1) + 354*s**2 - 390*s + 83) - 546*r*(2*s - 1) - 3162*s**2 + 3435*s - 709)) + f*(504*D1**2*bd1**2*s*(3*C - 2)*(2*r + 2*s - 1) + D1**2*(f*(-9*bdd1*s*(12*C*(24*r + 59*s - 34) - 182*r - 527*s + 262) + 5*fd*(4*C*(182*r*(3*s - 1) + 963*s**2 - 824*s + 321) - 464*r*(3*s - 1) - 2781*s**2 + 2318*s - 927) - 5*fdd*(28*C*(22*r*(3*s - 1) + 117*s**2 - 100*s + 39) - 394*r*(3*s - 1) - 2403*s**2 + 1996*s - 801)) - 10*fd**2*(28*C*(22*r*(3*s - 1) + 117*s**2 - 100*s + 11) - 394*r*(3*s - 1) - 2403*s**2 + 1996*s - 197)) + 9*D1*bd1*(D1*(f*s*(4*C*(74*r + 207*s - 106) - 196*r - 613*s + 272) - 2*fd*(12*C*(48*r*s - 12*r + 118*s**2 - 88*s + 17) - 364*r*s + 91*r - 1054*s**2 + 749*s - 131)) + 2*Dd*f*(-24*C*(12*r*(4*s - 1) + 118*s**2 - 99*s + 17) + 182*r*(4*s - 1) + 2108*s**2 - 1669*s + 262)) + 10*D1*f*(Dd*(f*(4*C*(182*r*(2*s - 1) + 642*s**2 - 733*s + 321) - 464*r*(2*s - 1) - 1854*s**2 + 2086*s - 927) + fd*(-28*C*(22*r*(12*s - 5) + 468*s**2 - 467*s + 111) + 394*r*(12*s - 5) + 9612*s**2 - 9389*s + 2193)) + Ddd*f*(-28*C*(22*r*(2*s - 1) + 78*s**2 - 89*s + 39) + 394*r*(2*s - 1) + 1602*s**2 - 1799*s + 801)) - 10*Dd**2*f**2*(28*C*(66*r*(2*s - 1) + 234*s**2 - 267*s + 61) - 1182*r*(2*s - 1) - 4806*s**2 + 5397*s - 1195)))/(315*d**2*k3**4) - D1**2*Pk1*Pk3*ct**4*k1**2*(8*C - 4)*(18*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s))) + 9*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(-5*f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*s*(-9*bd1**2*s + 5*fd**2*(3*s - 2))) - 10*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) + 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(45*d**2*k2**2*k3**2) - D1**2*Pk1*Pk3*ct**4*k2**6*st**4*(24*C - 24)*(12*D1**2*b1*f*fd*r**2 + 24*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*r + 12*D1**2*b1*f*fd*s**2 - 12*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fd - 6*D1**2*b1*f*fdd*r**2 - 12*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*r - 6*D1**2*b1*f*fdd*s**2 + 6*D1**2*b1*f*fdd*s - 3*D1**2*b1*f*fdd - 6*D1**2*b1*fd**2*r**2 - 12*D1**2*b1*fd**2*r*s + 6*D1**2*b1*fd**2*r - 6*D1**2*b1*fd**2*s**2 + 6*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 24*D1*Dd*b1*f**2*r**2 + 48*D1*Dd*b1*f**2*r*s - 36*D1*Dd*b1*f**2*r + 24*D1*Dd*b1*f**2*s**2 - 36*D1*Dd*b1*f**2*s + 18*D1*Dd*b1*f**2 - 48*D1*Dd*b1*f*fd*r**2 - 96*D1*Dd*b1*f*fd*r*s + 60*D1*Dd*b1*f*fd*r - 48*D1*Dd*b1*f*fd*s**2 + 60*D1*Dd*b1*f*fd*s - 18*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 12*D1*Ddd*b1*f**2*r**2 - 24*D1*Ddd*b1*f**2*r*s + 18*D1*Ddd*b1*f**2*r - 12*D1*Ddd*b1*f**2*s**2 + 18*D1*Ddd*b1*f**2*s - 9*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 6*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 36*Dd**2*b1*f**2*r**2 - 72*Dd**2*b1*f**2*r*s + 54*Dd**2*b1*f**2*r - 36*Dd**2*b1*f**2*s**2 + 54*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(7*d**2*k3**8) + 4*D1**2*Pk1*Pk3*ct**4*k2**6*st**2*(3564*C*D1**2*f**2*fd*r**2 + 7128*C*D1**2*f**2*fd*r*s - 4752*C*D1**2*f**2*fd*r + 3564*C*D1**2*f**2*fd*s**2 - 4752*C*D1**2*f**2*fd*s + 2376*C*D1**2*f**2*fd + 4752*C*D1*Dd*f**3*r**2 + 9504*C*D1*Dd*f**3*r*s - 7128*C*D1*Dd*f**3*r + 4752*C*D1*Dd*f**3*s**2 - 7128*C*D1*Dd*f**3*s + 3564*C*D1*Dd*f**3 + 594*D1**2*K*bdd1*f**2*r**2 + 1188*D1**2*K*bdd1*f**2*r*s - 1188*D1**2*K*bdd1*f**2*r + 594*D1**2*K*bdd1*f**2*s**2 - 1188*D1**2*K*bdd1*f**2*s + 594*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(-14*K + 15*f + 14)*(r + s - 1)**2 + 3300*D1**2*bdd1*f**3*r**2 + 6600*D1**2*bdd1*f**3*r*s - 6600*D1**2*bdd1*f**3*r + 3300*D1**2*bdd1*f**3*s**2 - 6600*D1**2*bdd1*f**3*s + 3300*D1**2*bdd1*f**3 - 594*D1**2*bdd1*f**2*r**2 - 1188*D1**2*bdd1*f**2*r*s + 1188*D1**2*bdd1*f**2*r - 594*D1**2*bdd1*f**2*s**2 + 1188*D1**2*bdd1*f**2*s - 594*D1**2*bdd1*f**2 - 2772*D1**2*bdd1*f*g2*r**2 - 5544*D1**2*bdd1*f*g2*r*s + 5544*D1**2*bdd1*f*g2*r - 2772*D1**2*bdd1*f*g2*s**2 + 5544*D1**2*bdd1*f*g2*s - 2772*D1**2*bdd1*f*g2 - 16600*D1**2*f**3*fd*r**2 - 33200*D1**2*f**3*fd*r*s + 24900*D1**2*f**3*fd*r - 16600*D1**2*f**3*fd*s**2 + 24900*D1**2*f**3*fd*s - 12450*D1**2*f**3*fd + 10500*D1**2*f**3*fdd*r**2 + 21000*D1**2*f**3*fdd*r*s - 15750*D1**2*f**3*fdd*r + 10500*D1**2*f**3*fdd*s**2 - 15750*D1**2*f**3*fdd*s + 7875*D1**2*f**3*fdd + 31500*D1**2*f**2*fd**2*r**2 + 63000*D1**2*f**2*fd**2*r*s - 47250*D1**2*f**2*fd**2*r + 31500*D1**2*f**2*fd**2*s**2 - 47250*D1**2*f**2*fd**2*s + 15750*D1**2*f**2*fd**2 - 3564*D1**2*f**2*fd*r**2 - 7128*D1**2*f**2*fd*r*s + 4752*D1**2*f**2*fd*r - 3564*D1**2*f**2*fd*s**2 + 4752*D1**2*f**2*fd*s - 2376*D1**2*f**2*fd + 2376*D1**2*f**2*gd2*r**2 + 4752*D1**2*f**2*gd2*r*s - 4752*D1**2*f**2*gd2*r + 2376*D1**2*f**2*gd2*s**2 - 4752*D1**2*f**2*gd2*s + 2376*D1**2*f**2*gd2 - 1188*D1**2*f**2*gdd2*r**2 - 2376*D1**2*f**2*gdd2*r*s + 2376*D1**2*f**2*gdd2*r - 1188*D1**2*f**2*gdd2*s**2 + 2376*D1**2*f**2*gdd2*s - 1188*D1**2*f**2*gdd2 + 4752*D1**2*f*fd*g2*r**2 + 9504*D1**2*f*fd*g2*r*s - 4752*D1**2*f*fd*g2*r + 4752*D1**2*f*fd*g2*s**2 - 4752*D1**2*f*fd*g2*s + 2376*D1**2*f*fd*g2 - 4752*D1**2*f*fd*gd2*r**2 - 9504*D1**2*f*fd*gd2*r*s + 7128*D1**2*f*fd*gd2*r - 4752*D1**2*f*fd*gd2*s**2 + 7128*D1**2*f*fd*gd2*s - 2376*D1**2*f*fd*gd2 - 2376*D1**2*f*fdd*g2*r**2 - 4752*D1**2*f*fdd*g2*r*s + 2376*D1**2*f*fdd*g2*r - 2376*D1**2*f*fdd*g2*s**2 + 2376*D1**2*f*fdd*g2*s - 1188*D1**2*f*fdd*g2 - 2376*D1**2*fd**2*g2*r**2 - 4752*D1**2*fd**2*g2*r*s + 2376*D1**2*fd**2*g2*r - 2376*D1**2*fd**2*g2*s**2 + 2376*D1**2*fd**2*g2*s - 16600*D1*Dd*f**4*r**2 - 33200*D1*Dd*f**4*r*s + 24900*D1*Dd*f**4*r - 16600*D1*Dd*f**4*s**2 + 24900*D1*Dd*f**4*s - 12450*D1*Dd*f**4 + 84000*D1*Dd*f**3*fd*r**2 + 168000*D1*Dd*f**3*fd*r*s - 126000*D1*Dd*f**3*fd*r + 84000*D1*Dd*f**3*fd*s**2 - 126000*D1*Dd*f**3*fd*s + 47250*D1*Dd*f**3*fd - 4752*D1*Dd*f**3*r**2 - 9504*D1*Dd*f**3*r*s + 7128*D1*Dd*f**3*r - 4752*D1*Dd*f**3*s**2 + 7128*D1*Dd*f**3*s - 3564*D1*Dd*f**3 + 9504*D1*Dd*f**2*g2*r**2 + 19008*D1*Dd*f**2*g2*r*s - 14256*D1*Dd*f**2*g2*r + 9504*D1*Dd*f**2*g2*s**2 - 14256*D1*Dd*f**2*g2*s + 7128*D1*Dd*f**2*g2 - 9504*D1*Dd*f**2*gd2*r**2 - 19008*D1*Dd*f**2*gd2*r*s + 16632*D1*Dd*f**2*gd2*r - 9504*D1*Dd*f**2*gd2*s**2 + 16632*D1*Dd*f**2*gd2*s - 7128*D1*Dd*f**2*gd2 - 19008*D1*Dd*f*fd*g2*r**2 - 38016*D1*Dd*f*fd*g2*r*s + 23760*D1*Dd*f*fd*g2*r - 19008*D1*Dd*f*fd*g2*s**2 + 23760*D1*Dd*f*fd*g2*s - 7128*D1*Dd*f*fd*g2 + 10500*D1*Ddd*f**4*r**2 + 21000*D1*Ddd*f**4*r*s - 15750*D1*Ddd*f**4*r + 10500*D1*Ddd*f**4*s**2 - 15750*D1*Ddd*f**4*s + 7875*D1*Ddd*f**4 - 4752*D1*Ddd*f**2*g2*r**2 - 9504*D1*Ddd*f**2*g2*r*s + 7128*D1*Ddd*f**2*g2*r - 4752*D1*Ddd*f**2*g2*s**2 + 7128*D1*Ddd*f**2*g2*s - 3564*D1*Ddd*f**2*g2 - 132*D1*bd1*(D1*(35*f**3*(r + s - 1) + f**2*(-21*C*(r + s - 1) - 50*fd*(3*r + 3*s - 2) + (9*K + 12)*(r + s - 1)) - 3*f*(3*fd*(K - 1)*(2*r + 2*s - 1) + (14*g2 - 14*gd2)*(r + s - 1)) + 42*fd*g2*(r + s)) - Dd*f*(50*f**2 + 9*f*(K - 1) - 42*g2)*(4*r + 4*s - 3))*(r + s - 1) + 31500*Dd**2*f**4*r**2 + 63000*Dd**2*f**4*r*s - 47250*Dd**2*f**4*r + 31500*Dd**2*f**4*s**2 - 47250*Dd**2*f**4*s + 15750*Dd**2*f**4 - 14256*Dd**2*f**2*g2*r**2 - 28512*Dd**2*f**2*g2*r*s + 21384*Dd**2*f**2*g2*r - 14256*Dd**2*f**2*g2*s**2 + 21384*Dd**2*f**2*g2*s - 7128*Dd**2*f**2*g2 + 99*b1**2*(D1**2*(15*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(15*fd**2*(r + s - 1) + 14*fd*(K - 1)*(r + s) - 7*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(15*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(15*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 14*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 15*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 15*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(84*C*D1**2*f*fd*r**2 + 168*C*D1**2*f*fd*r*s - 84*C*D1**2*f*fd*r + 84*C*D1**2*f*fd*s**2 - 84*C*D1**2*f*fd*s + 42*C*D1**2*f*fd + 168*C*D1*Dd*f**2*r**2 + 336*C*D1*Dd*f**2*r*s - 252*C*D1*Dd*f**2*r + 168*C*D1*Dd*f**2*s**2 - 252*C*D1*Dd*f**2*s + 126*C*D1*Dd*f**2 - 36*D1**2*K*f*fd*r**2 - 72*D1**2*K*f*fd*r*s + 36*D1**2*K*f*fd*r - 36*D1**2*K*f*fd*s**2 + 36*D1**2*K*f*fd*s - 18*D1**2*K*f*fd + 18*D1**2*K*f*fdd*r**2 + 36*D1**2*K*f*fdd*r*s - 18*D1**2*K*f*fdd*r + 18*D1**2*K*f*fdd*s**2 - 18*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 18*D1**2*K*fd**2*r**2 + 36*D1**2*K*fd**2*r*s - 18*D1**2*K*fd**2*r + 18*D1**2*K*fd**2*s**2 - 18*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(-14*K + 15*f + 14)*(r + s - 1)**2 - 210*D1**2*f**2*fd*r**2 - 420*D1**2*f**2*fd*r*s + 280*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 280*D1**2*f**2*fd*s - 140*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 48*D1**2*f*fd*r**2 - 96*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 48*D1**2*f*fd*s - 24*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 84*D1**2*f*gd2*r**2 + 168*D1**2*f*gd2*r*s - 168*D1**2*f*gd2*r + 84*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s + 84*D1**2*f*gd2 - 42*D1**2*f*gdd2*r**2 - 84*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*r - 42*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s - 42*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 84*D1**2*fd*g2*r**2 + 168*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*s**2 - 84*D1**2*fd*gd2*r**2 - 168*D1**2*fd*gd2*r*s + 84*D1**2*fd*gd2*r - 84*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s - 42*D1**2*fdd*g2*r**2 - 84*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*s**2 - 72*D1*Dd*K*f**2*r**2 - 144*D1*Dd*K*f**2*r*s + 108*D1*Dd*K*f**2*r - 72*D1*Dd*K*f**2*s**2 + 108*D1*Dd*K*f**2*s - 54*D1*Dd*K*f**2 + 144*D1*Dd*K*f*fd*r**2 + 288*D1*Dd*K*f*fd*r*s - 180*D1*Dd*K*f*fd*r + 144*D1*Dd*K*f*fd*s**2 - 180*D1*Dd*K*f*fd*s + 54*D1*Dd*K*f*fd - 280*D1*Dd*f**3*r**2 - 560*D1*Dd*f**3*r*s + 420*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 420*D1*Dd*f**3*s - 210*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 1700*D1*Dd*f**2*fd*r + 1200*D1*Dd*f**2*fd*s**2 - 1700*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 96*D1*Dd*f**2*r**2 - 192*D1*Dd*f**2*r*s + 144*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 144*D1*Dd*f**2*s - 72*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 336*D1*Dd*f*g2*r**2 + 672*D1*Dd*f*g2*r*s - 504*D1*Dd*f*g2*r + 336*D1*Dd*f*g2*s**2 - 504*D1*Dd*f*g2*s + 252*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r**2 - 672*D1*Dd*f*gd2*r*s + 588*D1*Dd*f*gd2*r - 336*D1*Dd*f*gd2*s**2 + 588*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 336*D1*Dd*fd*g2*r**2 - 672*D1*Dd*fd*g2*r*s + 252*D1*Dd*fd*g2*r - 336*D1*Dd*fd*g2*s**2 + 252*D1*Dd*fd*g2*s + 36*D1*Ddd*K*f**2*r**2 + 72*D1*Ddd*K*f**2*r*s - 54*D1*Ddd*K*f**2*r + 36*D1*Ddd*K*f**2*s**2 - 54*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 + 200*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 300*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r**2 - 336*D1*Ddd*f*g2*r*s + 252*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s**2 + 252*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(15*f**2*(r + s - 1) - 15*f*fd*(2*r + 2*s - 1) - 14*f*(K - 1)*(r + s - 1) + 14*fd*(K - 1)*(r + s)) - Dd*f*(-14*K + 15*f + 14)*(4*r + 4*s - 3))*(r + s - 1) + 108*Dd**2*K*f**2*r**2 + 216*Dd**2*K*f**2*r*s - 162*Dd**2*K*f**2*r + 108*Dd**2*K*f**2*s**2 - 162*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 + 600*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 900*Dd**2*f**3*r + 600*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 300*Dd**2*f**3 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 504*Dd**2*f*g2*r**2 - 1008*Dd**2*f*g2*r*s + 756*Dd**2*f*g2*r - 504*Dd**2*f*g2*s**2 + 756*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(1155*d**2*k3**8) - D1**2*Pk1*Pk3*ct**4*k2**4*st**4*(16*C - 16)*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(7*d**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**4*k2**4*st**2*(252*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(-700*C*D1**2*f*fd*r**2 - 1128*C*D1**2*f*fd*r*s + 516*C*D1**2*f*fd*r - 428*C*D1**2*f*fd*s**2 + 380*C*D1**2*f*fd*s - 190*C*D1**2*f*fd + 392*C*D1**2*f*fdd*r**2 + 760*C*D1**2*f*fdd*r*s - 356*C*D1**2*f*fdd*r + 368*C*D1**2*f*fdd*s**2 - 344*C*D1**2*f*fdd*s + 172*C*D1**2*f*fdd + 392*C*D1**2*fd**2*r**2 + 760*C*D1**2*fd**2*r*s - 356*C*D1**2*fd**2*r + 368*C*D1**2*fd**2*s**2 - 344*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 1400*C*D1*Dd*f**2*r**2 - 2256*C*D1*Dd*f**2*r*s + 1828*C*D1*Dd*f**2*r - 856*C*D1*Dd*f**2*s**2 + 1420*C*D1*Dd*f**2*s - 778*C*D1*Dd*f**2 + 3136*C*D1*Dd*f*fd*r**2 + 6080*C*D1*Dd*f*fd*r*s - 3728*C*D1*Dd*f*fd*r + 2944*C*D1*Dd*f*fd*s**2 - 3608*C*D1*Dd*f*fd*s + 1044*C*D1*Dd*f*fd + 784*C*D1*Ddd*f**2*r**2 + 1520*C*D1*Ddd*f**2*r*s - 1152*C*D1*Ddd*f**2*r + 736*C*D1*Ddd*f**2*s**2 - 1116*C*D1*Ddd*f**2*s + 564*C*D1*Ddd*f**2 + 2352*C*Dd**2*f**2*r**2 + 4560*C*Dd**2*f**2*r*s - 3456*C*Dd**2*f**2*r + 2208*C*Dd**2*f**2*s**2 - 3348*C*Dd**2*f**2*s + 1128*C*Dd**2*f**2 - 28*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 684*D1**2*f*fd*r**2 + 1156*D1**2*f*fd*r*s - 530*D1**2*f*fd*r + 472*D1**2*f*fd*s**2 - 424*D1**2*f*fd*s + 212*D1**2*f*fd - 412*D1**2*f*fdd*r**2 - 830*D1**2*f*fdd*r*s + 391*D1**2*f*fdd*r - 418*D1**2*f*fdd*s**2 + 394*D1**2*f*fdd*s - 197*D1**2*f*fdd - 412*D1**2*fd**2*r**2 - 830*D1**2*fd**2*r*s + 391*D1**2*fd**2*r - 418*D1**2*fd**2*s**2 + 394*D1**2*fd**2*s + 24*D1**2*fd**2 + 1368*D1*Dd*f**2*r**2 + 2312*D1*Dd*f**2*r*s - 1840*D1*Dd*f**2*r + 944*D1*Dd*f**2*s**2 - 1522*D1*Dd*f**2*s + 814*D1*Dd*f**2 - 3296*D1*Dd*f*fd*r**2 - 6640*D1*Dd*f*fd*r*s + 4048*D1*Dd*f*fd*r - 3344*D1*Dd*f*fd*s**2 + 4078*D1*Dd*f*fd*s - 1179*D1*Dd*f*fd - 824*D1*Ddd*f**2*r**2 - 1660*D1*Ddd*f**2*r*s + 1242*D1*Ddd*f**2*r - 836*D1*Ddd*f**2*s**2 + 1251*D1*Ddd*f**2*s - 624*D1*Ddd*f**2 + 56*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2472*Dd**2*f**2*r**2 - 4980*Dd**2*f**2*r*s + 3726*Dd**2*f**2*r - 2508*Dd**2*f**2*s**2 + 3753*Dd**2*f**2*s - 1248*Dd**2*f**2) + f*(-7410*C*D1**2*f*fd*r**2 - 10644*C*D1**2*f*fd*r*s + 8488*C*D1**2*f*fd*r - 3234*C*D1**2*f*fd*s**2 + 5704*C*D1**2*f*fd*s - 3548*C*D1**2*f*fd + 4704*C*D1**2*f*fdd*r**2 + 7212*C*D1**2*f*fdd*r*s - 5540*C*D1**2*f*fdd*r + 2508*C*D1**2*f*fdd*s**2 - 4076*C*D1**2*f*fdd*s + 2404*C*D1**2*f*fdd + 9408*C*D1**2*fd**2*r**2 + 14424*C*D1**2*fd**2*r*s - 11080*C*D1**2*fd**2*r + 5016*C*D1**2*fd**2*s**2 - 8152*C*D1**2*fd**2*s + 2404*C*D1**2*fd**2 - 9880*C*D1*Dd*f**2*r**2 - 14192*C*D1*Dd*f**2*r*s + 12036*C*D1*Dd*f**2*r - 4312*C*D1*Dd*f**2*s**2 + 7860*C*D1*Dd*f**2*s - 4626*C*D1*Dd*f**2 + 37632*C*D1*Dd*f*fd*r**2 + 57696*C*D1*Dd*f*fd*r*s - 45992*C*D1*Dd*f*fd*r + 20064*C*D1*Dd*f*fd*s**2 - 33548*C*D1*Dd*f*fd*s + 13692*C*D1*Dd*f*fd + 6272*C*D1*Ddd*f**2*r**2 + 9616*C*D1*Ddd*f**2*r*s - 7944*C*D1*Ddd*f**2*r + 3344*C*D1*Ddd*f**2*s**2 - 5748*C*D1*Ddd*f**2*s + 3240*C*D1*Ddd*f**2 + 18816*C*Dd**2*f**2*r**2 + 28848*C*Dd**2*f**2*r*s - 23832*C*Dd**2*f**2*r + 10032*C*Dd**2*f**2*s**2 - 17244*C*Dd**2*f**2*s + 6480*C*Dd**2*f**2 - 504*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(4*C*(49*r**2 + 95*r*s - 104*r + 46*s**2 - 101*s + 52) - 206*r**2 - 415*r*s + 436*r - 209*s**2 + 439*s - 218) + 7122*D1**2*f*fd*r**2 + 10782*D1**2*f*fd*r*s - 8342*D1**2*f*fd*r + 3660*D1**2*f*fd*s**2 - 6034*D1**2*f*fd*s + 3594*D1**2*f*fd - 4614*D1**2*f*fdd*r**2 - 7497*D1**2*f*fdd*r*s + 5575*D1**2*f*fdd*r - 2883*D1**2*f*fdd*s**2 + 4421*D1**2*f*fdd*s - 2499*D1**2*f*fdd - 9228*D1**2*fd**2*r**2 - 14994*D1**2*fd**2*r*s + 11150*D1**2*fd**2*r - 5766*D1**2*fd**2*s**2 + 8842*D1**2*fd**2*s - 2499*D1**2*fd**2 + 9496*D1*Dd*f**2*r**2 + 14376*D1*Dd*f**2*r*s - 11936*D1*Dd*f**2*r + 4880*D1*Dd*f**2*s**2 - 8474*D1*Dd*f**2*s + 4814*D1*Dd*f**2 - 36912*D1*Dd*f*fd*r**2 - 59976*D1*Dd*f*fd*r*s + 46522*D1*Dd*f*fd*r - 23064*D1*Dd*f*fd*s**2 + 36713*D1*Dd*f*fd*s - 14417*D1*Dd*f*fd - 6152*D1*Ddd*f**2*r**2 - 9996*D1*Ddd*f**2*r*s + 8074*D1*Ddd*f**2*r - 3844*D1*Ddd*f**2*s**2 + 6343*D1*Ddd*f**2*s - 3460*D1*Ddd*f**2 - 9*D1*bd1*(D1*(f*(C*(350*r**2 + 564*r*s - 748*r + 214*s**2 - 612*s + 374) - 342*r**2 - 578*r*s + 732*r - 236*s**2 + 626*s - 366) + fd*(-4*C*(196*r**2 + 380*r*s - 297*r + 184*s**2 - 288*s + 101) + 824*r**2 + 1660*r*s - 1263*r + 836*s**2 - 1272*s + 439)) + Dd*f*(-4*C*(392*r**2 + 8*r*(95*s - 88) + 368*s**2 - 683*s + 306) + 1648*r**2 + 3320*r*s - 2986*r + 1672*s**2 - 3007*s + 1314)) - 18456*Dd**2*f**2*r**2 - 29988*Dd**2*f**2*r*s + 24222*Dd**2*f**2*r - 11532*Dd**2*f**2*s**2 + 19029*Dd**2*f**2*s - 6920*Dd**2*f**2))/(315*d**2*k3**6) + 2*D1**2*Pk1*Pk3*ct**4*k2**4*(-16632*C*D1**2*bd1*f**2*r**2 - 16632*C*D1**2*bd1*f**2*r*s + 38808*C*D1**2*bd1*f**2*r + 22176*C*D1**2*bd1*f**2*s - 19404*C*D1**2*bd1*f**2 - 41580*C*D1**2*f**2*fd*r**2 - 47520*C*D1**2*f**2*fd*r*s + 43560*C*D1**2*f**2*fd*r - 5940*C*D1**2*f**2*fd*s**2 + 19800*C*D1**2*f**2*fd*s - 15840*C*D1**2*f**2*fd - 55440*C*D1*Dd*f**3*r**2 - 63360*C*D1*Dd*f**3*r*s + 59400*C*D1*Dd*f**3*r - 7920*C*D1*Dd*f**3*s**2 + 23760*C*D1*Dd*f**3*s - 17820*C*D1*Dd*f**3 - 17094*D1**2*K*bd1**2*f*r**2 - 34188*D1**2*K*bd1**2*f*r*s + 36960*D1**2*K*bd1**2*f*r - 17094*D1**2*K*bd1**2*f*s**2 + 36960*D1**2*K*bd1**2*f*s - 19866*D1**2*K*bd1**2*f + 21483*D1**2*K*bd1*f**2*r**2 + 26730*D1**2*K*bd1*f**2*r*s - 26730*D1**2*K*bd1*f**2*r + 5247*D1**2*K*bd1*f**2*s**2 - 10494*D1**2*K*bd1*f**2*s + 5247*D1**2*K*bd1*f**2 - 41580*D1**2*K*bd1*f*fd*r**2 - 67320*D1**2*K*bd1*f*fd*r*s + 54450*D1**2*K*bd1*f*fd*r - 25740*D1**2*K*bd1*f*fd*s**2 + 42570*D1**2*K*bd1*f*fd*s - 16830*D1**2*K*bd1*f*fd - 10395*D1**2*K*bdd1*f**2*r**2 - 16830*D1**2*K*bdd1*f**2*r*s + 16830*D1**2*K*bdd1*f**2*r - 6435*D1**2*K*bdd1*f**2*s**2 + 12870*D1**2*K*bdd1*f**2*s - 6435*D1**2*K*bdd1*f**2 + 21582*D1**2*bd1**2*f**2*r**2 + 45936*D1**2*bd1**2*f**2*r*s - 40590*D1**2*bd1**2*f**2*r + 24354*D1**2*bd1**2*f**2*s**2 - 43362*D1**2*bd1**2*f**2*s + 19008*D1**2*bd1**2*f**2 + 22638*D1**2*bd1**2*f*r**2 + 48048*D1**2*bd1**2*f*r*s - 49434*D1**2*bd1**2*f*r + 25410*D1**2*bd1**2*f*s**2 - 52206*D1**2*bd1**2*f*s + 26796*D1**2*bd1**2*f - 9240*D1**2*bd1**2*g2*r**2 - 18480*D1**2*bd1**2*g2*r*s + 9240*D1**2*bd1**2*g2*r - 9240*D1**2*bd1**2*g2*s**2 + 9240*D1**2*bd1**2*g2*s - 2772*D1**2*bd1*bd2*f*r**2 - 5544*D1**2*bd1*bd2*f*r*s + 5544*D1**2*bd1*bd2*f*r - 2772*D1**2*bd1*bd2*f*s**2 + 5544*D1**2*bd1*bd2*f*s - 2772*D1**2*bd1*bd2*f - 6050*D1**2*bd1*f**3*r**2 - 990*D1**2*bd1*f**3*r*s + 4290*D1**2*bd1*f**3*r + 5060*D1**2*bd1*f**3*s**2 - 6820*D1**2*bd1*f**3*s - 880*D1**2*bd1*f**3 + 21120*D1**2*bd1*f**2*fd*r**2 - 29700*D1**2*bd1*f**2*fd*r*s - 440*D1**2*bd1*f**2*fd*r - 50820*D1**2*bd1*f**2*fd*s**2 + 59510*D1**2*bd1*f**2*fd*s - 19910*D1**2*bd1*f**2*fd - 4455*D1**2*bd1*f**2*r**2 - 11484*D1**2*bd1*f**2*r*s - 9306*D1**2*bd1*f**2*r - 7029*D1**2*bd1*f**2*s**2 - 6732*D1**2*bd1*f**2*s + 10989*D1**2*bd1*f**2 + 46332*D1**2*bd1*f*fd*r**2 + 83952*D1**2*bd1*f*fd*r*s - 65142*D1**2*bd1*f*fd*r + 37620*D1**2*bd1*f*fd*s**2 - 58608*D1**2*bd1*f*fd*s + 20988*D1**2*bd1*f*fd - 36498*D1**2*bd1*f*g2*r**2 - 45276*D1**2*bd1*f*g2*r*s + 84084*D1**2*bd1*f*g2*r - 8778*D1**2*bd1*f*g2*s**2 + 56364*D1**2*bd1*f*g2*s - 42042*D1**2*bd1*f*g2 + 34188*D1**2*bd1*f*gd2*r**2 + 68376*D1**2*bd1*f*gd2*r*s - 73920*D1**2*bd1*f*gd2*r + 34188*D1**2*bd1*f*gd2*s**2 - 73920*D1**2*bd1*f*gd2*s + 39732*D1**2*bd1*f*gd2 + 34188*D1**2*bd1*fd*g2*r**2 + 68376*D1**2*bd1*fd*g2*r*s - 34188*D1**2*bd1*fd*g2*r + 34188*D1**2*bd1*fd*g2*s**2 - 34188*D1**2*bd1*fd*g2*s + 1980*D1**2*bd2*f**2*r**2 + 3960*D1**2*bd2*f**2*r*s - 3960*D1**2*bd2*f**2*r + 1980*D1**2*bd2*f**2*s**2 - 3960*D1**2*bd2*f**2*s + 1980*D1**2*bd2*f**2 - 3960*D1**2*bd2*f*fd*r**2 - 7920*D1**2*bd2*f*fd*r*s + 5940*D1**2*bd2*f*fd*r - 3960*D1**2*bd2*f*fd*s**2 + 5940*D1**2*bd2*f*fd*s - 1980*D1**2*bd2*f*fd + 3520*D1**2*bdd1*f**3*r**2 - 4950*D1**2*bdd1*f**3*r*s - 1650*D1**2*bdd1*f**3*r - 8470*D1**2*bdd1*f**3*s**2 + 10340*D1**2*bdd1*f**3*s + 440*D1**2*bdd1*f**3 + 11583*D1**2*bdd1*f**2*r**2 + 20988*D1**2*bdd1*f**2*r*s - 20988*D1**2*bdd1*f**2*r + 9405*D1**2*bdd1*f**2*s**2 - 18810*D1**2*bdd1*f**2*s + 9405*D1**2*bdd1*f**2 + 17094*D1**2*bdd1*f*g2*r**2 + 34188*D1**2*bdd1*f*g2*r*s - 39732*D1**2*bdd1*f*g2*r + 17094*D1**2*bdd1*f*g2*s**2 - 39732*D1**2*bdd1*f*g2*s + 19866*D1**2*bdd1*f*g2 - 990*D1**2*bdd2*f**2*r**2 - 1980*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*r - 990*D1**2*bdd2*f**2*s**2 + 1980*D1**2*bdd2*f**2*s - 990*D1**2*bdd2*f**2 + 31500*D1**2*f**3*fd*r**2 + 79240*D1**2*f**3*fd*r*s - 55370*D1**2*f**3*fd*r + 47740*D1**2*f**3*fd*s**2 - 67550*D1**2*f**3*fd*s + 31745*D1**2*f**3*fd - 27300*D1**2*f**3*fdd*r**2 - 84280*D1**2*f**3*fdd*r*s + 55790*D1**2*f**3*fdd*r - 56980*D1**2*f**3*fdd*s**2 + 78050*D1**2*f**3*fdd*s - 35315*D1**2*f**3*fdd - 81900*D1**2*f**2*fd**2*r**2 - 252840*D1**2*f**2*fd**2*r*s + 167370*D1**2*f**2*fd**2*r - 170940*D1**2*f**2*fd**2*s**2 + 234150*D1**2*f**2*fd**2*s - 70630*D1**2*f**2*fd**2 + 41580*D1**2*f**2*fd*r**2 + 50490*D1**2*f**2*fd*r*s - 44550*D1**2*f**2*fd*r + 8910*D1**2*f**2*fd*s**2 - 22770*D1**2*f**2*fd*s + 16830*D1**2*f**2*fd - 42966*D1**2*f**2*gd2*r**2 - 53460*D1**2*f**2*gd2*r*s + 53460*D1**2*f**2*gd2*r - 10494*D1**2*f**2*gd2*s**2 + 20988*D1**2*f**2*gd2*s - 10494*D1**2*f**2*gd2 + 20790*D1**2*f**2*gdd2*r**2 + 33660*D1**2*f**2*gdd2*r*s - 33660*D1**2*f**2*gdd2*r + 12870*D1**2*f**2*gdd2*s**2 - 25740*D1**2*f**2*gdd2*s + 12870*D1**2*f**2*gdd2 - 85932*D1**2*f*fd*g2*r**2 - 106920*D1**2*f*fd*g2*r*s + 85932*D1**2*f*fd*g2*r - 20988*D1**2*f*fd*g2*s**2 + 53460*D1**2*f*fd*g2*s - 42966*D1**2*f*fd*g2 + 83160*D1**2*f*fd*gd2*r**2 + 134640*D1**2*f*fd*gd2*r*s - 108900*D1**2*f*fd*gd2*r + 51480*D1**2*f*fd*gd2*s**2 - 85140*D1**2*f*fd*gd2*s + 33660*D1**2*f*fd*gd2 + 41580*D1**2*f*fdd*g2*r**2 + 67320*D1**2*f*fdd*g2*r*s - 41580*D1**2*f*fdd*g2*r + 25740*D1**2*f*fdd*g2*s**2 - 33660*D1**2*f*fdd*g2*s + 20790*D1**2*f*fdd*g2 + 41580*D1**2*fd**2*g2*r**2 + 67320*D1**2*fd**2*g2*r*s - 41580*D1**2*fd**2*g2*r + 25740*D1**2*fd**2*g2*s**2 - 33660*D1**2*fd**2*g2*s - 83160*D1*Dd*K*bd1*f**2*r**2 - 134640*D1*Dd*K*bd1*f**2*r*s + 121770*D1*Dd*K*bd1*f**2*r - 51480*D1*Dd*K*bd1*f**2*s**2 + 94050*D1*Dd*K*bd1*f**2*s - 42570*D1*Dd*K*bd1*f**2 + 28160*D1*Dd*bd1*f**3*r**2 - 39600*D1*Dd*bd1*f**3*r*s - 3740*D1*Dd*bd1*f**3*r - 67760*D1*Dd*bd1*f**3*s**2 + 80190*D1*Dd*bd1*f**3*s - 19030*D1*Dd*bd1*f**3 + 92664*D1*Dd*bd1*f**2*r**2 + 167904*D1*Dd*bd1*f**2*r*s - 149094*D1*Dd*bd1*f**2*r + 75240*D1*Dd*bd1*f**2*s**2 - 133848*D1*Dd*bd1*f**2*s + 58608*D1*Dd*bd1*f**2 + 136752*D1*Dd*bd1*f*g2*r**2 + 273504*D1*Dd*bd1*f*g2*r*s - 261492*D1*Dd*bd1*f*g2*r + 136752*D1*Dd*bd1*f*g2*s**2 - 261492*D1*Dd*bd1*f*g2*s + 119196*D1*Dd*bd1*f*g2 - 7920*D1*Dd*bd2*f**2*r**2 - 15840*D1*Dd*bd2*f**2*r*s + 13860*D1*Dd*bd2*f**2*r - 7920*D1*Dd*bd2*f**2*s**2 + 13860*D1*Dd*bd2*f**2*s - 5940*D1*Dd*bd2*f**2 + 31500*D1*Dd*f**4*r**2 + 79240*D1*Dd*f**4*r*s - 55370*D1*Dd*f**4*r + 47740*D1*Dd*f**4*s**2 - 67550*D1*Dd*f**4*s + 31745*D1*Dd*f**4 - 218400*D1*Dd*f**3*fd*r**2 - 674240*D1*Dd*f**3*fd*r*s + 446320*D1*Dd*f**3*fd*r - 455840*D1*Dd*f**3*fd*s**2 + 624400*D1*Dd*f**3*fd*s - 211890*D1*Dd*f**3*fd + 55440*D1*Dd*f**3*r**2 + 67320*D1*Dd*f**3*r*s - 61380*D1*Dd*f**3*r + 11880*D1*Dd*f**3*s**2 - 28710*D1*Dd*f**3*s + 19800*D1*Dd*f**3 - 171864*D1*Dd*f**2*g2*r**2 - 213840*D1*Dd*f**2*g2*r*s + 192852*D1*Dd*f**2*g2*r - 41976*D1*Dd*f**2*g2*s**2 + 95436*D1*Dd*f**2*g2*s - 63954*D1*Dd*f**2*g2 + 166320*D1*Dd*f**2*gd2*r**2 + 269280*D1*Dd*f**2*gd2*r*s - 243540*D1*Dd*f**2*gd2*r + 102960*D1*Dd*f**2*gd2*s**2 - 188100*D1*Dd*f**2*gd2*s + 85140*D1*Dd*f**2*gd2 + 332640*D1*Dd*f*fd*g2*r**2 + 538560*D1*Dd*f*fd*g2*r*s - 384120*D1*Dd*f*fd*g2*r + 205920*D1*Dd*f*fd*g2*s**2 - 304920*D1*Dd*f*fd*g2*s + 108900*D1*Dd*f*fd*g2 - 27300*D1*Ddd*f**4*r**2 - 84280*D1*Ddd*f**4*r*s + 55790*D1*Ddd*f**4*r - 56980*D1*Ddd*f**4*s**2 + 78050*D1*Ddd*f**4*s - 35315*D1*Ddd*f**4 + 83160*D1*Ddd*f**2*g2*r**2 + 134640*D1*Ddd*f**2*g2*r*s - 108900*D1*Ddd*f**2*g2*r + 51480*D1*Ddd*f**2*g2*s**2 - 85140*D1*Ddd*f**2*g2*s + 46530*D1*Ddd*f**2*g2 - 81900*Dd**2*f**4*r**2 - 252840*Dd**2*f**4*r*s + 167370*Dd**2*f**4*r - 170940*Dd**2*f**4*s**2 + 234150*Dd**2*f**4*s - 70630*Dd**2*f**4 + 249480*Dd**2*f**2*g2*r**2 + 403920*Dd**2*f**2*g2*r*s - 326700*Dd**2*f**2*g2*r + 154440*Dd**2*f**2*g2*s**2 - 255420*Dd**2*f**2*g2*s + 93060*Dd**2*f**2*g2 + 462*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (5*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-5*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(140*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 140*C*D1**2*fd*s**2 - 280*C*D1**2*fd*s + 140*C*D1**2*fd + 560*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 840*C*D1*Dd*f*r + 560*C*D1*Dd*f*s**2 - 840*C*D1*Dd*f*s + 420*C*D1*Dd*f + 553*D1**2*K*fd*r**2 + 686*D1**2*K*fd*r*s + 168*D1**2*K*fd*r + 133*D1**2*K*fd*s**2 + 168*D1**2*K*fd*s - 84*D1**2*K*fd - 259*D1**2*K*fdd*r**2 - 518*D1**2*K*fdd*r*s - 84*D1**2*K*fdd*r - 259*D1**2*K*fdd*s**2 - 84*D1**2*K*fdd*s + 42*D1**2*K*fdd - 14*D1**2*bdd1*(-5*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 594*D1**2*f*fd*r**2 - 1272*D1**2*f*fd*r*s + 708*D1**2*f*fd*r - 678*D1**2*f*fd*s**2 + 750*D1**2*f*fd*s - 375*D1**2*f*fd + 654*D1**2*f*fdd*r**2 + 1392*D1**2*f*fdd*r*s - 816*D1**2*f*fdd*r + 738*D1**2*f*fdd*s**2 - 858*D1**2*f*fdd*s + 429*D1**2*f*fdd + 654*D1**2*fd**2*r**2 + 1392*D1**2*fd**2*r*s - 816*D1**2*fd**2*r + 738*D1**2*fd**2*s**2 - 858*D1**2*fd**2*s + 120*D1**2*fd**2 - 721*D1**2*fd*r**2 - 1106*D1**2*fd*r*s + 112*D1**2*fd*r - 385*D1**2*fd*s**2 + 112*D1**2*fd*s - 56*D1**2*fd + 343*D1**2*fdd*r**2 + 728*D1**2*fdd*r*s + 84*D1**2*fdd*r + 385*D1**2*fdd*s**2 + 84*D1**2*fdd*s - 42*D1**2*fdd + 280*D1**2*gd2*r**2 + 560*D1**2*gd2*r*s - 560*D1**2*gd2*r + 280*D1**2*gd2*s**2 - 560*D1**2*gd2*s + 280*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 + 2212*D1*Dd*K*f*r**2 + 2744*D1*Dd*K*f*r*s - 2478*D1*Dd*K*f*r + 532*D1*Dd*K*f*s**2 - 1218*D1*Dd*K*f*s + 819*D1*Dd*K*f - 2072*D1*Dd*K*fd*r**2 - 4144*D1*Dd*K*fd*r*s + 1218*D1*Dd*K*fd*r - 2072*D1*Dd*K*fd*s**2 + 1218*D1*Dd*K*fd*s + 252*D1*Dd*K*fd - 1188*D1*Dd*f**2*r**2 - 2544*D1*Dd*f**2*r*s + 1866*D1*Dd*f**2*r - 1356*D1*Dd*f**2*s**2 + 1992*D1*Dd*f**2*s - 975*D1*Dd*f**2 + 5232*D1*Dd*f*fd*r**2 + 11136*D1*Dd*f*fd*r*s - 7356*D1*Dd*f*fd*r + 5904*D1*Dd*f*fd*s**2 - 7776*D1*Dd*f*fd*s + 2532*D1*Dd*f*fd - 2884*D1*Dd*f*r**2 - 4424*D1*Dd*f*r*s + 3654*D1*Dd*f*r - 1540*D1*Dd*f*s**2 + 2646*D1*Dd*f*s - 1491*D1*Dd*f + 2744*D1*Dd*fd*r**2 + 5824*D1*Dd*fd*r*s - 1806*D1*Dd*fd*r + 3080*D1*Dd*fd*s**2 - 1932*D1*Dd*fd*s - 252*D1*Dd*fd + 1120*D1*Dd*g2*r**2 + 2240*D1*Dd*g2*r*s - 1680*D1*Dd*g2*r + 1120*D1*Dd*g2*s**2 - 1680*D1*Dd*g2*s + 840*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 - 1036*D1*Ddd*K*f*r**2 - 2072*D1*Ddd*K*f*r*s + 1554*D1*Ddd*K*f*r - 1036*D1*Ddd*K*f*s**2 + 1554*D1*Ddd*K*f*s - 777*D1*Ddd*K*f + 1308*D1*Ddd*f**2*r**2 + 2784*D1*Ddd*f**2*r*s - 2046*D1*Ddd*f**2*r + 1476*D1*Ddd*f**2*s**2 - 2172*D1*Ddd*f**2*s + 1065*D1*Ddd*f**2 + 1372*D1*Ddd*f*r**2 + 2912*D1*Ddd*f*r*s - 2142*D1*Ddd*f*r + 1540*D1*Ddd*f*s**2 - 2268*D1*Ddd*f*s + 1113*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 + 28*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (5*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-5*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 3108*Dd**2*K*f*r**2 - 6216*Dd**2*K*f*r*s + 4662*Dd**2*K*f*r - 3108*Dd**2*K*f*s**2 + 4662*Dd**2*K*f*s - 1554*Dd**2*K*f + 3924*Dd**2*f**2*r**2 + 8352*Dd**2*f**2*r*s - 6138*Dd**2*f**2*r + 4428*Dd**2*f**2*s**2 - 6516*Dd**2*f**2*s + 2130*Dd**2*f**2 + 4116*Dd**2*f*r**2 + 8736*Dd**2*f*r*s - 6426*Dd**2*f*r + 4620*Dd**2*f*s**2 - 6804*Dd**2*f*s + 2226*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) - 11*b1*(3024*C*D1**2*f*fd*r**2 + 3024*C*D1**2*f*fd*r*s - 1008*C*D1**2*f*fd*r + 504*C*D1**2*f*fd*s - 252*C*D1**2*f*fd + 6048*C*D1*Dd*f**2*r**2 + 6048*C*D1*Dd*f**2*r*s - 6048*C*D1*Dd*f**2*r - 1512*C*D1*Dd*f**2*s + 1512*C*D1*Dd*f**2 + 1554*D1**2*K*bdd1*f*r**2 + 3108*D1**2*K*bdd1*f*r*s - 3360*D1**2*K*bdd1*f*r + 1554*D1**2*K*bdd1*f*s**2 - 3360*D1**2*K*bdd1*f*s + 1680*D1**2*K*bdd1*f - 3906*D1**2*K*f*fd*r**2 - 4860*D1**2*K*f*fd*r*s + 3906*D1**2*K*f*fd*r - 954*D1**2*K*f*fd*s**2 + 2430*D1**2*K*f*fd*s - 1953*D1**2*K*f*fd + 1890*D1**2*K*f*fdd*r**2 + 3060*D1**2*K*f*fdd*r*s - 1890*D1**2*K*f*fdd*r + 1170*D1**2*K*f*fdd*s**2 - 1530*D1**2*K*f*fdd*s + 945*D1**2*K*f*fdd + 1890*D1**2*K*fd**2*r**2 + 3060*D1**2*K*fd**2*r*s - 1890*D1**2*K*fd**2*r + 1170*D1**2*K*fd**2*s**2 - 1530*D1**2*K*fd**2*s - 252*D1**2*b2*fd*r**2 - 504*D1**2*b2*fd*r*s - 252*D1**2*b2*fd*s**2 + 126*D1**2*b2*fdd*r**2 + 252*D1**2*b2*fdd*r*s + 126*D1**2*b2*fdd*s**2 + 84*D1**2*bd1**2*(-5*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 1962*D1**2*bdd1*f**2*r**2 - 4176*D1**2*bdd1*f**2*r*s + 3690*D1**2*bdd1*f**2*r - 2214*D1**2*bdd1*f**2*s**2 + 3942*D1**2*bdd1*f**2*s - 1908*D1**2*bdd1*f**2 - 2058*D1**2*bdd1*f*r**2 - 4368*D1**2*bdd1*f*r*s + 4494*D1**2*bdd1*f*r - 2310*D1**2*bdd1*f*s**2 + 4746*D1**2*bdd1*f*s - 2310*D1**2*bdd1*f + 840*D1**2*bdd1*g2*r**2 + 1680*D1**2*bdd1*g2*r*s - 840*D1**2*bdd1*g2*r + 840*D1**2*bdd1*g2*s**2 - 840*D1**2*bdd1*g2*s + 420*D1**2*bdd1*g2 + 126*D1**2*bdd2*f*r**2 + 252*D1**2*bdd2*f*r*s - 252*D1**2*bdd2*f*r + 126*D1**2*bdd2*f*s**2 - 252*D1**2*bdd2*f*s + 126*D1**2*bdd2*f + 1650*D1**2*f**2*fd*r**2 + 270*D1**2*f**2*fd*r*s - 890*D1**2*f**2*fd*r - 1380*D1**2*f**2*fd*s**2 + 1130*D1**2*f**2*fd*s - 450*D1**2*f**2*fd - 960*D1**2*f**2*fdd*r**2 + 1350*D1**2*f**2*fdd*r*s - 410*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2590*D1**2*f**2*fdd*s + 1260*D1**2*f**2*fdd - 1920*D1**2*f*fd**2*r**2 + 2700*D1**2*f*fd**2*r*s - 820*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 5180*D1**2*f*fd**2*s + 630*D1**2*f*fd**2 + 810*D1**2*f*fd*r**2 + 2088*D1**2*f*fd*r*s - 2700*D1**2*f*fd*r + 1278*D1**2*f*fd*s**2 - 2934*D1**2*f*fd*s + 2043*D1**2*f*fd - 2106*D1**2*f*fdd*r**2 - 3816*D1**2*f*fdd*r*s + 2106*D1**2*f*fdd*r - 1710*D1**2*f*fdd*s**2 + 1908*D1**2*f*fdd*s - 1053*D1**2*f*fdd + 3318*D1**2*f*gd2*r**2 + 4116*D1**2*f*gd2*r*s - 4116*D1**2*f*gd2*r + 798*D1**2*f*gd2*s**2 - 1596*D1**2*f*gd2*s + 798*D1**2*f*gd2 - 1554*D1**2*f*gdd2*r**2 - 3108*D1**2*f*gdd2*r*s + 3108*D1**2*f*gdd2*r - 1554*D1**2*f*gdd2*s**2 + 3108*D1**2*f*gdd2*s - 1554*D1**2*f*gdd2 - 2106*D1**2*fd**2*r**2 - 3816*D1**2*fd**2*r*s + 2106*D1**2*fd**2*r - 1710*D1**2*fd**2*s**2 + 1908*D1**2*fd**2*s + 3318*D1**2*fd*g2*r**2 + 4116*D1**2*fd*g2*r*s + 1008*D1**2*fd*g2*r + 798*D1**2*fd*g2*s**2 + 1008*D1**2*fd*g2*s - 504*D1**2*fd*g2 - 3108*D1**2*fd*gd2*r**2 - 6216*D1**2*fd*gd2*r*s + 2604*D1**2*fd*gd2*r - 3108*D1**2*fd*gd2*s**2 + 2604*D1**2*fd*gd2*s + 504*D1**2*fd*gd2 - 1554*D1**2*fdd*g2*r**2 - 3108*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*r - 1554*D1**2*fdd*g2*s**2 - 504*D1**2*fdd*g2*s + 252*D1**2*fdd*g2 - 7812*D1*Dd*K*f**2*r**2 - 9720*D1*Dd*K*f**2*r*s + 8766*D1*Dd*K*f**2*r - 1908*D1*Dd*K*f**2*s**2 + 4338*D1*Dd*K*f**2*s - 2907*D1*Dd*K*f**2 + 15120*D1*Dd*K*f*fd*r**2 + 24480*D1*Dd*K*f*fd*r*s - 17460*D1*Dd*K*f*fd*r + 9360*D1*Dd*K*f*fd*s**2 - 13860*D1*Dd*K*f*fd*s + 4950*D1*Dd*K*f*fd - 1008*D1*Dd*b2*f*r**2 - 2016*D1*Dd*b2*f*r*s + 1512*D1*Dd*b2*f*r - 1008*D1*Dd*b2*f*s**2 + 1512*D1*Dd*b2*f*s - 756*D1*Dd*b2*f + 1008*D1*Dd*b2*fd*r**2 + 2016*D1*Dd*b2*fd*r*s - 756*D1*Dd*b2*fd*r + 1008*D1*Dd*b2*fd*s**2 - 756*D1*Dd*b2*fd*s + 2200*D1*Dd*f**3*r**2 + 360*D1*Dd*f**3*r*s - 1280*D1*Dd*f**3*r - 1840*D1*Dd*f**3*s**2 + 1750*D1*Dd*f**3*s - 370*D1*Dd*f**3 - 7680*D1*Dd*f**2*fd*r**2 + 10800*D1*Dd*f**2*fd*r*s - 2420*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 20950*D1*Dd*f**2*fd*s + 5590*D1*Dd*f**2*fd + 1620*D1*Dd*f**2*r**2 + 4176*D1*Dd*f**2*r*s - 2898*D1*Dd*f**2*r + 2556*D1*Dd*f**2*s**2 - 3600*D1*Dd*f**2*s + 1683*D1*Dd*f**2 - 16848*D1*Dd*f*fd*r**2 - 30528*D1*Dd*f*fd*r*s + 20268*D1*Dd*f*fd*r - 13680*D1*Dd*f*fd*s**2 + 18288*D1*Dd*f*fd*s - 5922*D1*Dd*f*fd + 13272*D1*Dd*f*g2*r**2 + 16464*D1*Dd*f*g2*r*s - 14868*D1*Dd*f*g2*r + 3192*D1*Dd*f*g2*s**2 - 7308*D1*Dd*f*g2*s + 4914*D1*Dd*f*g2 - 12432*D1*Dd*f*gd2*r**2 - 24864*D1*Dd*f*gd2*r*s + 21756*D1*Dd*f*gd2*r - 12432*D1*Dd*f*gd2*s**2 + 21756*D1*Dd*f*gd2*s - 9324*D1*Dd*f*gd2 - 12432*D1*Dd*fd*g2*r**2 - 24864*D1*Dd*fd*g2*r*s + 7308*D1*Dd*fd*g2*r - 12432*D1*Dd*fd*g2*s**2 + 7308*D1*Dd*fd*g2*s + 1512*D1*Dd*fd*g2 + 3780*D1*Ddd*K*f**2*r**2 + 6120*D1*Ddd*K*f**2*r*s - 4950*D1*Ddd*K*f**2*r + 2340*D1*Ddd*K*f**2*s**2 - 3870*D1*Ddd*K*f**2*s + 2115*D1*Ddd*K*f**2 + 504*D1*Ddd*b2*f*r**2 + 1008*D1*Ddd*b2*f*r*s - 756*D1*Ddd*b2*f*r + 504*D1*Ddd*b2*f*s**2 - 756*D1*Ddd*b2*f*s + 378*D1*Ddd*b2*f - 1280*D1*Ddd*f**3*r**2 + 1800*D1*Ddd*f**3*r*s - 260*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 3530*D1*Ddd*f**3*s + 1220*D1*Ddd*f**3 - 4212*D1*Ddd*f**2*r**2 - 7632*D1*Ddd*f**2*r*s + 5922*D1*Ddd*f**2*r - 3420*D1*Ddd*f**2*s**2 + 5328*D1*Ddd*f**2*s - 2763*D1*Ddd*f**2 - 6216*D1*Ddd*f*g2*r**2 - 12432*D1*Ddd*f*g2*r*s + 9324*D1*Ddd*f*g2*r - 6216*D1*Ddd*f*g2*s**2 + 9324*D1*Ddd*f*g2*s - 4662*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(3*f**2*(99*r**2 + r*(212*s - 193) + 113*s**2 - 207*s + 100) - f*(70*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(79*r**2 + 98*r*s - 140*r + 19*s**2 - 80*s + 55) + 3*fd*(436*r**2 + r*(928*s - 682) + 492*s**2 - 724*s + 239) - 721*r**2 - 1106*r*s + 1218*r - 385*s**2 + 882*s - 525) + 7*fd*(2*K*(37*r**2 + 74*r*s - 34*r + 37*s**2 - 34*s - 3) - 98*r**2 - 208*r*s + 95*r - 110*s**2 + 101*s + 6) - 140*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 140*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + Dd*(-3*f**2*(872*r**2 + 2*r*(928*s - 751) + 984*s**2 - 1600*s + 643) + 7*f*(K*(296*r**2 + 592*r*s - 542*r + 296*s**2 - 542*s + 240) - 392*r**2 - 832*r*s + 734*r - 440*s**2 + 776*s - 333) + 140*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 252*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 11340*Dd**2*K*f**2*r**2 + 18360*Dd**2*K*f**2*r*s - 14850*Dd**2*K*f**2*r + 7020*Dd**2*K*f**2*s**2 - 11610*Dd**2*K*f**2*s + 4230*Dd**2*K*f**2 + 1512*Dd**2*b2*f*r**2 + 3024*Dd**2*b2*f*r*s - 2268*Dd**2*b2*f*r + 1512*Dd**2*b2*f*s**2 - 2268*Dd**2*b2*f*s + 756*Dd**2*b2*f - 3840*Dd**2*f**3*r**2 + 5400*Dd**2*f**3*r*s - 780*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 10590*Dd**2*f**3*s + 2440*Dd**2*f**3 - 12636*Dd**2*f**2*r**2 - 22896*Dd**2*f**2*r*s + 17766*Dd**2*f**2*r - 10260*Dd**2*f**2*s**2 + 15984*Dd**2*f**2*s - 5526*Dd**2*f**2 - 18648*Dd**2*f*g2*r**2 - 37296*Dd**2*f*g2*r*s + 27972*Dd**2*f*g2*r - 18648*Dd**2*f*g2*s**2 + 27972*Dd**2*f*g2*s - 9324*Dd**2*f*g2) + 198*b2*(-7*D1**2*bdd1*f*(r + s - 1)**2 + 5*D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 5*D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(3465*d**2*k3**6) - D1**2*Pk1*Pk3*ct**4*k2**2*st**4*(8*C - 8)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(7*d**2*k3**4) - 2*D1**2*Pk1*Pk3*ct**4*k2**2*st**2*(504*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 9*b1*(D1**2*(f*(-56*bdd1*s*(C - 1)*(2*r + 2*s - 1) + fd*(C*(-368*r*(2*s - 1) - 500*s**2 + 452*s - 250) + 370*r*(2*s - 1) + 564*s**2 - 516*s + 282) + fdd*(2*C*(92*r*(2*s - 1) + 202*s**2 - 190*s + 101) - 199*r*(2*s - 1) - 464*s**2 + 440*s - 232)) + fd**2*(4*C*(46*r*(2*s - 1) + 101*s**2 - 95*s - 6) - 199*r*(2*s - 1) - 464*s**2 + 440*s + 24)) - 56*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(-2*f*(C*(368*r*(2*s - 1) + 500*s**2 - 684*s + 250) - 740*r*s + 370*r - 564*s**2 + 749*s - 282) + fd*(2*s - 1)*(16*C*(92*r + 101*s - 59) - 1592*r - 1856*s + 1079)) + Ddd*f*(4*C*(92*r*(2*s - 1) + 202*s**2 - 248*s + 101) - 796*r*s + 398*r - 928*s**2 + 1127*s - 464)) + Dd**2*f**2*(4*C*(276*r*(2*s - 1) + 606*s**2 - 744*s + 193) - 1194*r*(2*s - 1) - 2784*s**2 + 3381*s - 862)) + f*(-504*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1**2*(f*(9*bdd1*s*(2*C*(92*r + 101*s - 104) - 199*r - 232*s + 223) - 2*fd*(C*(1236*r*(3*s - 1) + 2067*s**2 - 2614*s + 689) - 1213*r*(3*s - 1) - 2355*s**2 + 2783*s - 785) + fdd*(2*C*(744*r*(3*s - 1) + 1479*s**2 - 1730*s + 493) - 1483*r*(3*s - 1) - 3408*s**2 + 3755*s - 1136)) + fd**2*(4*C*(744*r*(3*s - 1) + 1479*s**2 - 1730*s + 372) - 2966*r*(3*s - 1) - 6816*s**2 + 7510*s - 1483)) - 9*D1*bd1*(D1*(2*f*s*(C*(184*r + 125*s - 208) - 185*r - 141*s + 209) + fd*(-4*C*(46*r*(4*s - 1) + 202*s**2 - 199*s + 52) + 199*r*(4*s - 1) + 928*s**2 - 886*s + 223)) + Dd*f*(-16*C*(23*r*(4*s - 1) + 101*s**2 - 114*s + 26) + 398*r*(4*s - 1) + 1856*s**2 - 2019*s + 446)) + D1*f*(Dd*(f*(-4*C*(1236*r*(2*s - 1) + 1378*s**2 - 1996*s + 689) + 4852*r*(2*s - 1) + 6280*s**2 - 8706*s + 3140) + fd*(8*C*(372*r*(12*s - 5) + 2958*s**2 - 3767*s + 1051) - 2966*r*(12*s - 5) - 27264*s**2 + 33101*s - 8993)) + Ddd*f*(4*C*(744*r*(2*s - 1) + 986*s**2 - 1358*s + 493) - 2966*r*(2*s - 1) - 4544*s**2 + 6027*s - 2272)) + Dd**2*f**2*(4*C*(2232*r*(2*s - 1) + 2958*s**2 - 4074*s + 1237) - 8898*r*(2*s - 1) - 13632*s**2 + 18081*s - 5238)))/(315*d**2*k3**4) + D1**2*Pk1*Pk3*ct**4*k2**2*(42*b1**2*(D1**2*(fd*(19*C*r + 39*C*(s - 1) - 13*r - 39*s + 39) + fdd*(C*(-17*r - 37*s + 37) + 14*r + 37*s - 37))*(r + s - 1) + D1*(Dd*(f*(C*(76*r**2 + 2*r*(116*s - 77) + 156*s**2 - 214*s + 97) - 52*r**2 - 26*r*(8*s - 5) - 156*s**2 + 208*s - 91) + fd*(-2*C*(68*r**2 + 216*r*s - 179*r + 148*s**2 - 249*s + 101) + 112*r**2 + 408*r*s - 334*r + 296*s**2 - 495*s + 199)) + Ddd*f*(-C*(68*r**2 + 216*r*s - 142*r + 148*s**2 - 202*s + 91) + 56*r**2 + 204*r*s - 130*r + 148*s**2 - 199*s + 88)) + Dd**2*f*(-2*C*(102*r**2 + 3*r*(108*s - 71) + 222*s**2 - 303*s + 91) + 168*r**2 + 6*r*(102*s - 65) + 444*s**2 - 597*s + 176)) + 3*b1*(124*C*D1**2*f*fd*r**2 - 1680*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*r - 1740*C*D1**2*f*fd*s**2 + 888*C*D1**2*f*fd*s - 384*C*D1**2*f*fd + 344*C*D1**2*f*fdd*r**2 + 2016*C*D1**2*f*fdd*r*s - 396*C*D1**2*f*fdd*r + 1668*C*D1**2*f*fdd*s**2 - 1032*C*D1**2*f*fdd*s + 528*C*D1**2*f*fdd + 344*C*D1**2*fd**2*r**2 + 2016*C*D1**2*fd**2*r*s - 396*C*D1**2*fd**2*r + 1668*C*D1**2*fd**2*s**2 - 1032*C*D1**2*fd**2*s - 636*C*D1**2*fd**2 + 248*C*D1*Dd*f**2*r**2 - 3360*C*D1*Dd*f**2*r*s + 1556*C*D1*Dd*f**2*r - 3480*C*D1*Dd*f**2*s**2 + 4320*C*D1*Dd*f**2*s - 1678*C*D1*Dd*f**2 + 2752*C*D1*Dd*f*fd*r**2 + 16128*C*D1*Dd*f*fd*r*s - 6304*C*D1*Dd*f*fd*r + 13344*C*D1*Dd*f*fd*s**2 - 12816*C*D1*Dd*f*fd*s + 2460*C*D1*Dd*f*fd + 688*C*D1*Ddd*f**2*r**2 + 4032*C*D1*Ddd*f**2*r*s - 2360*C*D1*Ddd*f**2*r + 3336*C*D1*Ddd*f**2*s**2 - 4344*C*D1*Ddd*f**2*s + 1840*C*D1*Ddd*f**2 + 2064*C*Dd**2*f**2*r**2 + 12096*C*Dd**2*f**2*r*s - 7080*C*Dd**2*f**2*r + 10008*C*Dd**2*f**2*s**2 - 13032*C*Dd**2*f**2*s + 3684*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(C*(34*r**2 + 2*r*(54*s - 17) + 74*s**2 - 54*s + 17) - 28*r**2 + r*(28 - 102*s) - 74*s**2 + 51*s - 14) + 152*D1**2*f*fd*r**2 + 2526*D1**2*f*fd*r*s - 507*D1**2*f*fd*r + 2478*D1**2*f*fd*s**2 - 1734*D1**2*f*fd*s + 861*D1**2*f*fd - 356*D1**2*f*fdd*r**2 - 2670*D1**2*f*fdd*r*s + 831*D1**2*f*fdd*r - 2394*D1**2*f*fdd*s**2 + 1812*D1**2*f*fdd*s - 945*D1**2*f*fdd - 356*D1**2*fd**2*r**2 - 2670*D1**2*fd**2*r*s + 831*D1**2*fd**2*r - 2394*D1**2*fd**2*s**2 + 1812*D1**2*fd**2*s + 582*D1**2*fd**2 + 304*D1*Dd*f**2*r**2 + 5052*D1*Dd*f**2*r*s - 2678*D1*Dd*f**2*r + 4956*D1*Dd*f**2*s**2 - 6219*D1*Dd*f**2*s + 2554*D1*Dd*f**2 - 2848*D1*Dd*f*fd*r**2 - 21360*D1*Dd*f*fd*r*s + 9376*D1*Dd*f*fd*r - 19152*D1*Dd*f*fd*s**2 + 19494*D1*Dd*f*fd*s - 4455*D1*Dd*f*fd - 712*D1*Ddd*f**2*r**2 - 5340*D1*Ddd*f**2*r*s + 3026*D1*Ddd*f**2*r - 4788*D1*Ddd*f**2*s**2 + 6123*D1*Ddd*f**2*s - 2572*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(C*(38*r**2 + 116*r*s - 38*r + 78*s**2 - 58*s + 19) - 26*r**2 - 104*r*s + 26*r - 78*s**2 + 52*s - 13) + fd*(-2*C*(34*r**2 + 108*r*s - 71*r + 74*s**2 - 101*s + 27) + 56*r**2 + 204*r*s - 130*r + 148*s**2 - 199*s + 51)) + 2*Dd*f*(-C*(136*r**2 + 6*r*(72*s - 35) + 296*s**2 - 310*s + 71) + 112*r**2 + 6*r*(68*s - 31) + 296*s**2 - 301*s + 65)) - 2136*Dd**2*f**2*r**2 - 16020*Dd**2*f**2*r*s + 9078*Dd**2*f**2*r - 14364*Dd**2*f**2*s**2 + 18369*Dd**2*f**2*s - 5064*Dd**2*f**2) + f*(-7872*C*D1**2*f*fd*r**2 - 16212*C*D1**2*f*fd*r*s + 10652*C*D1**2*f*fd*r - 7548*C*D1**2*f*fd*s**2 + 10436*C*D1**2*f*fd*s - 5140*C*D1**2*f*fd + 4962*C*D1**2*f*fdd*r**2 + 14532*C*D1**2*f*fdd*r*s - 8152*C*D1**2*f*fdd*r + 7068*C*D1**2*f*fdd*s**2 - 9556*C*D1**2*f*fdd*s + 4010*C*D1**2*f*fdd + 9924*C*D1**2*fd**2*r**2 + 29064*C*D1**2*fd**2*r*s - 16304*C*D1**2*fd**2*r + 14136*C*D1**2*fd**2*s**2 - 19112*C*D1**2*fd**2*s + 4844*C*D1**2*fd**2 - 10496*C*D1*Dd*f**2*r**2 - 21616*C*D1*Dd*f**2*r*s + 16056*C*D1*Dd*f**2*r - 10064*C*D1*Dd*f**2*s**2 + 15468*C*D1*Dd*f**2*s - 7656*C*D1*Dd*f**2 + 39696*C*D1*Dd*f*fd*r**2 + 116256*C*D1*Dd*f*fd*r*s - 71596*C*D1*Dd*f*fd*r + 56544*C*D1*Dd*f*fd*s**2 - 81028*C*D1*Dd*f*fd*s + 27264*C*D1*Dd*f*fd + 6616*C*D1*Ddd*f**2*r**2 + 19376*C*D1*Ddd*f**2*r*s - 12996*C*D1*Ddd*f**2*r + 9424*C*D1*Ddd*f**2*s**2 - 14268*C*D1*Ddd*f**2*s + 6366*C*D1*Ddd*f**2 + 19848*C*Dd**2*f**2*r**2 + 58128*C*Dd**2*f**2*r*s - 38988*C*Dd**2*f**2*r + 28272*C*Dd**2*f**2*s**2 - 42804*C*Dd**2*f**2*s + 14400*C*Dd**2*f**2 - 42*D1**2*bd1**2*(r**2*(34*C - 28) + 2*r*(54*C*s - 17*C - 51*s + 14) + s*(74*C*s - 54*C - 74*s + 51)) + 3*D1**2*bdd1*f*(2*C*(86*r**2 + 504*r*s - 478*r + 417*s**2 - 822*s + 239) - 178*r**2 - 1335*r*s + 860*r - 1197*s**2 + 1917*s - 430) + 7014*D1**2*f*fd*r**2 + 17685*D1**2*f*fd*r*s - 10571*D1**2*f*fd*r + 10023*D1**2*f*fd*s**2 - 12577*D1**2*f*fd*s + 5679*D1**2*f*fd - 4344*D1**2*f*fdd*r**2 - 15795*D1**2*f*fdd*r*s + 8161*D1**2*f*fdd*r - 9453*D1**2*f*fdd*s**2 + 11567*D1**2*f*fdd*s - 4599*D1**2*f*fdd - 8688*D1**2*fd**2*r**2 - 31590*D1**2*fd**2*r*s + 16322*D1**2*fd**2*r - 18906*D1**2*fd**2*s**2 + 23134*D1**2*fd**2*s - 5265*D1**2*fd**2 + 9352*D1*Dd*f**2*r**2 + 23580*D1*Dd*f**2*r*s - 16466*D1*Dd*f**2*r + 13364*D1*Dd*f**2*s**2 - 19259*D1*Dd*f**2*s + 9020*D1*Dd*f**2 - 34752*D1*Dd*f*fd*r**2 - 126360*D1*Dd*f*fd*r*s + 72922*D1*Dd*f*fd*r - 75624*D1*Dd*f*fd*s**2 + 99875*D1*Dd*f*fd*s - 31295*D1*Dd*f*fd - 5792*D1*Ddd*f**2*r**2 - 21060*D1*Ddd*f**2*r*s + 13426*D1*Ddd*f**2*r - 12604*D1*Ddd*f**2*s**2 + 17869*D1*Ddd*f**2*s - 7750*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(2*C*(31*r**2 - 420*r*s + 424*r - 435*s**2 + 846*s - 212) + 76*r**2 + 1263*r*s - 908*r + 1239*s**2 - 2007*s + 454) + fd*(4*C*(172*r**2 + 1008*r*s - 577*r + 834*s**2 - 1080*s + 411) - 712*r**2 - 5340*r*s + 2551*r - 4788*s**2 + 5646*s - 1917)) + Dd*f*(4*C*(344*r**2 + 2016*r*s - 1546*r + 1668*s**2 - 2730*s + 1061) - 1424*r**2 - 10680*r*s + 6466*r - 9576*s**2 + 13791*s - 4694)) - 17376*Dd**2*f**2*r**2 - 63180*Dd**2*f**2*r*s + 40278*Dd**2*f**2*r - 37812*Dd**2*f**2*s**2 + 53607*Dd**2*f**2*s - 16832*Dd**2*f**2))/(315*d**2*k3**4) - 4*D1**2*Pk1*Pk3*ct**4*st**2*(252*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) - 9*b1*(D1**2*(f*(fd*(36*C - 46)*(2*s**2 - 2*s + 1) - fdd*(18*C - 23)*(2*s**2 - 2*s + 1) + s**2*(C - 1)*(-112*bd1 + 56*bdd1)) + 2*fd*s*(s - 1)*(56*bd1*(C - 1) + fd*(23 - 18*C))) + 2*D1*f*(Dd*f*(36*C - 46)*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(-56*bd1*s*(C - 1) + fd*(18*C - 23)*(2*s - 1)) - Ddd*f*(18*C - 23)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(46 - 36*C)*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(-fd*(300*C - 350)*(3*s**2 - 2*s + 1) + fdd*(150*C - 175)*(3*s**2 - 2*s + 1) + s**2*(18*C - 23)*(-18*bd1 + 9*bdd1)) + 2*s*(-252*bd1**2*s*(C - 1) + 9*bd1*fd*(18*C - 23)*(2*s - 1) + fd**2*(150*C - 175)*(3*s - 2))) - 2*D1*f*(Dd*f*(300*C - 350)*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s*(18*C - 23) + fd*(150*C - 175)*(3*s - 1)) - Ddd*f*(150*C - 175)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(300*C - 350)*(6*s**2 - 6*s + 1)))/(315*d**2*k3**2) + D1**2*Pk1*Pk3*ct**4*(42*b1**2*(D1**2*(s - 1)*(3*fd*(8*C*r + 13*C*(s - 1) - 6*r - 13*s + 13) + fdd*(C*(-12*r - 37*s + 37) + 9*r + 37*s - 37)) + D1*(Dd*(6*f*(C*(16*r*s - 8*r + 26*s**2 - 30*s + 13) - 12*r*s + 6*r - 26*s**2 + 29*s - 13) + fd*(-8*C*(12*r*s - 9*r + 37*s**2 - 57*s + 20) + 72*r*s - 54*r + 296*s**2 - 453*s + 157)) + Ddd*f*(-2*C*(24*r*s - 12*r + 74*s**2 - 80*s + 37) + 36*r*s - 18*r + 148*s**2 - 157*s + 74)) + Dd**2*f*(-2*C*(36*r*(2*s - 1) + 222*s**2 - 240*s + 49) + 54*r*(2*s - 1) + 444*s**2 - 471*s + 92)) + 3*b1*(D1**2*(f*(-14*bdd1*s*(2*C*(12*r + 37*s - 6) - 18*r - 74*s + 9) + 3*fd*(88*C*r*(2*s - 1) - 16*C*(4*s**2 + 5*s + 2) + r*(44 - 88*s) + 186*s**2 - 78*s + 93) - 3*fdd*(-8*C*(r*(2 - 4*s) + 4*s**2 + 5*s + 2) + r*(8 - 16*s) + 142*s**2 - 88*s + 71)) - 6*fd**2*(4*C*(r*(4*s - 2) - 4*s**2 - 5*s + 9) + r*(4 - 8*s) + 71*s**2 - 44*s - 27)) + 14*D1*bd1*(D1*(6*f*s*(C*(8*r + 13*s - 4) - 6*r - 13*s + 3) + fd*(-4*C*(12*r*s - 6*r + 37*s**2 - 40*s + 3) + 36*r*s - 18*r + 148*s**2 - 157*s + 9)) - 2*Dd*f*(4*C*(24*r*s - 6*r + 74*s**2 - 46*s + 3) - 72*r*s + 18*r - 296*s**2 + 175*s - 9)) + 6*D1*f*(Dd*(f*(4*C*(44*r*s - 22*r - 16*s**2 + 5*s - 8) - 88*r*s + 44*r + 186*s**2 - 164*s + 93) + 4*fd*(2*s - 1)*(-4*C*(4*r - 4*s - 3) + 8*r - 71*s + 21)) + Ddd*f*(8*C*(r*(2 - 4*s) + 4*s**2 - 3*s + 2) + 16*r*s - 8*r - 142*s**2 + 138*s - 71)) - 18*Dd**2*f**2*(r*(16*C - 8)*(2*s - 1) + s**2*(142 - 32*C) + s*(24*C - 138) + 21)) + f*(-42*D1**2*bd1**2*s*(2*C*(12*r + 37*s - 6) - 18*r - 74*s + 9) + D1**2*(f*(9*bdd1*s*(-8*C*(2*r - 2*s + 7) + 8*r - 71*s + 46) - 5*fd*(2*C*(68*r*(3*s - 1) + 297*s**2 - 266*s + 99) - 384*r*s + 128*r - 843*s**2 + 690*s - 281) + 5*fdd*(2*C*(52*r*(3*s - 1) + 243*s**2 - 214*s + 81) - 246*r*s + 82*r - 705*s**2 + 552*s - 235)) + 10*fd**2*(2*C*(52*r*(3*s - 1) + 243*s**2 - 214*s + 26) - 82*r*(3*s - 1) - 705*s**2 + 552*s - 41)) + 9*D1*bd1*(D1*(f*s*(8*C*(11*r - 4*s + 7) - 44*r + 93*s - 64) - 2*fd*(4*C*(8*r*s - 2*r - 8*s**2 + 9*s - 7) - 16*r*s + 4*r + 142*s**2 - 90*s + 23)) - 4*Dd*f*(4*C*(8*r*s - 2*r - 8*s**2 + 17*s - 7) - 16*r*s + 4*r + 142*s**2 - 115*s + 23)) - 10*D1*f*(Dd*(f*(2*C*(68*r*(2*s - 1) + 198*s**2 - 232*s + 99) - 128*r*(2*s - 1) - 562*s**2 + 626*s - 281) + fd*(-8*C*(13*r*(12*s - 5) + 243*s**2 - 248*s + 60) + 82*r*(12*s - 5) + 2820*s**2 - 2637*s + 593)) + Ddd*f*(-2*C*(52*r*(2*s - 1) + 162*s**2 - 188*s + 81) + 82*r*(2*s - 1) + 470*s**2 - 511*s + 235)) + 10*Dd**2*f**2*(2*C*(156*r*(2*s - 1) + 486*s**2 - 564*s + 133) - 246*r*(2*s - 1) - 1410*s**2 + 1533*s - 317)))/(315*d**2*k3**2) + D1**2*Pk1*Pk3*ct**4*(8*C - 4)*(D1*f*s*(-14*D1*bd1**2*s - 5*D1*bdd1*f*s + 10*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*f*(2 - 4*s))) + 7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(10*fd*(2*s**2 - 2*s + 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(28*bd1 - 14*bdd1)) - 2*fd*s*(14*bd1 + 5*fd)*(s - 1)) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(14*bd1*s + 5*fd*(2*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(35*d**2*k2**2) - 2*D1**2*Pk1*Pk3*ct**4*k2**4*st**2*(216*C*D1**2*b1*f*fd*r**2 + 270*C*D1**2*b1*f*fdd*r**2 + 270*C*D1**2*b1*fd**2*r**2 + 48*C*D1**2*f**2*fd*r**2 - 32*C*D1**2*f**2*fd*r + 16*C*D1**2*f**2*fd + 57*C*D1**2*f**2*fdd*r**2 - 38*C*D1**2*f**2*fdd*r + 19*C*D1**2*f**2*fdd + 114*C*D1**2*f*fd**2*r**2 - 76*C*D1**2*f*fd**2*r + 432*C*D1*Dd*b1*f**2*r**2 - 216*C*D1*Dd*b1*f**2*r + 108*C*D1*Dd*b1*f**2 + 2160*C*D1*Dd*b1*f*fd*r**2 - 540*C*D1*Dd*b1*f*fd*r + 64*C*D1*Dd*f**3*r**2 - 32*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3 + 456*C*D1*Dd*f**2*fd*r**2 - 266*C*D1*Dd*f**2*fd*r + 38*C*D1*Dd*f**2*fd + 540*C*D1*Ddd*b1*f**2*r**2 - 270*C*D1*Ddd*b1*f**2*r + 135*C*D1*Ddd*b1*f**2 + 76*C*D1*Ddd*f**3*r**2 - 38*C*D1*Ddd*f**3*r + 19*C*D1*Ddd*f**3 + 1620*C*Dd**2*b1*f**2*r**2 - 810*C*Dd**2*b1*f**2*r + 228*C*Dd**2*f**3*r**2 - 114*C*Dd**2*f**3*r - 540*D1**2*b1*f*fd*r**2 - 324*D1**2*b1*f*fd*r*s + 162*D1**2*b1*f*fd*r - 360*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 360*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r + 45*D1**2*bdd1*f**2*(r - 1)*(3*C*(r - 1) - 4*r - s + 4) - 486*D1**2*f**2*fd*r**2 - 438*D1**2*f**2*fd*r*s + 470*D1**2*f**2*fd*r + 146*D1**2*f**2*fd*s - 162*D1**2*f**2*fd + 108*D1**2*f**2*fdd*r**2 + 165*D1**2*f**2*fdd*r*s - 127*D1**2*f**2*fdd*r - 55*D1**2*f**2*fdd*s + 36*D1**2*f**2*fdd + 216*D1**2*f*fd**2*r**2 + 330*D1**2*f*fd**2*r*s - 254*D1**2*f*fd**2*r - 110*D1**2*f*fd**2*s + 55*D1**2*f*fd**2 - 1080*D1*Dd*b1*f**2*r**2 - 648*D1*Dd*b1*f**2*r*s + 864*D1*Dd*b1*f**2*r + 162*D1*Dd*b1*f**2*s - 270*D1*Dd*b1*f**2 - 2880*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 1080*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd - 648*D1*Dd*f**3*r**2 - 584*D1*Dd*f**3*r*s + 616*D1*Dd*f**3*r + 146*D1*Dd*f**3*s - 162*D1*Dd*f**3 + 864*D1*Dd*f**2*fd*r**2 + 1320*D1*Dd*f**2*fd*r*s - 1054*D1*Dd*f**2*fd*r - 385*D1*Dd*f**2*fd*s + 237*D1*Dd*f**2*fd - 720*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 450*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 180*D1*Ddd*b1*f**2 + 144*D1*Ddd*f**3*r**2 + 220*D1*Ddd*f**3*r*s - 182*D1*Ddd*f**3*r - 55*D1*Ddd*f**3*s + 36*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(6*f*(r - 1)*(2*C*(r - 1) - 5*r - 3*s + 5) + 5*fd*(r**2*(12*C - 16) + r*(-12*C - 4*s + 17) + 2*s - 1)) + 5*Dd*f*(6*C*(4*r**2 - 5*r + 1) - 32*r**2 - 8*r*s + 42*r + 5*s - 10)) - 2160*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 1350*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 + 432*Dd**2*f**3*r**2 + 660*Dd**2*f**3*r*s - 546*Dd**2*f**3*r - 165*Dd**2*f**3*s + 110*Dd**2*f**3)/(315*d**2*k1**2*k3**4) + D1**2*Pk1*Pk3*ct**4*k2**4*(2970*C*D1**2*f**2*fd*r**2 - 1980*C*D1**2*f**2*fd*r + 990*C*D1**2*f**2*fd + 3960*C*D1*Dd*f**3*r**2 - 1980*C*D1*Dd*f**3*r + 990*C*D1*Dd*f**3 - 528*D1**2*K*bdd1*f**2*r**2 + 66*D1**2*bd1**2*f*(9*f*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 7*r**2*(2*K - 8) - 7*r*(-2*K - 6*s + 11) - 21*s + 21) - 264*D1**2*bdd1*f**3*r**2 - 1265*D1**2*bdd1*f**3*r*s + 1342*D1**2*bdd1*f**3*r + 1485*D1**2*bdd1*f**3*s - 726*D1**2*bdd1*f**3 + 726*D1**2*bdd1*f**2*r**2 + 198*D1**2*bdd1*f**2*r*s - 198*D1**2*bdd1*f**2*r + 924*D1**2*bdd1*f*g2*r**2 - 1848*D1**2*bdd1*f*g2*r + 924*D1**2*bdd1*f*g2 - 6240*D1**2*f**3*fd*r**2 + 1100*D1**2*f**3*fd*r*s + 2570*D1**2*f**3*fd*r - 275*D1**2*f**3*fd*s - 1560*D1**2*f**3*fd - 2160*D1**2*f**3*fdd*r**2 - 1100*D1**2*f**3*fdd*r*s + 1630*D1**2*f**3*fdd*r + 275*D1**2*f**3*fdd*s - 540*D1**2*f**3*fdd - 6480*D1**2*f**2*fd**2*r**2 - 3300*D1**2*f**2*fd**2*r*s + 4890*D1**2*f**2*fd**2*r + 825*D1**2*f**2*fd**2*s - 550*D1**2*f**2*fd**2 - 5940*D1**2*f**2*fd*r**2 - 2970*D1**2*f**2*fd*r*s + 4950*D1**2*f**2*fd*r + 990*D1**2*f**2*fd*s - 1980*D1**2*f**2*fd + 3894*D1**2*f**2*gd2*r**2 + 1056*D1**2*f**2*gdd2*r**2 + 7788*D1**2*f*fd*g2*r**2 - 7788*D1**2*f*fd*g2*r + 3894*D1**2*f*fd*g2 + 4224*D1**2*f*fd*gd2*r**2 - 2112*D1**2*f*fd*gd2*r + 2112*D1**2*f*fdd*g2*r**2 - 2112*D1**2*f*fdd*g2*r + 1056*D1**2*f*fdd*g2 + 2112*D1**2*fd**2*g2*r**2 - 2112*D1**2*fd**2*g2*r - 6240*D1*Dd*f**4*r**2 + 1100*D1*Dd*f**4*r*s + 2570*D1*Dd*f**4*r - 275*D1*Dd*f**4*s - 1560*D1*Dd*f**4 - 17280*D1*Dd*f**3*fd*r**2 - 8800*D1*Dd*f**3*fd*r*s + 13040*D1*Dd*f**3*fd*r + 2200*D1*Dd*f**3*fd*s - 2180*D1*Dd*f**3*fd - 7920*D1*Dd*f**3*r**2 - 3960*D1*Dd*f**3*r*s + 5940*D1*Dd*f**3*r + 990*D1*Dd*f**3*s - 1980*D1*Dd*f**3 + 15576*D1*Dd*f**2*g2*r**2 - 7788*D1*Dd*f**2*g2*r + 3894*D1*Dd*f**2*g2 + 8448*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r + 16896*D1*Dd*f*fd*g2*r**2 - 12672*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2 - 2160*D1*Ddd*f**4*r**2 - 1100*D1*Ddd*f**4*r*s + 1630*D1*Ddd*f**4*r + 275*D1*Ddd*f**4*s - 540*D1*Ddd*f**4 + 4224*D1*Ddd*f**2*g2*r**2 - 2112*D1*Ddd*f**2*g2*r + 1056*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(f**3*(84*r**2 + 275*r*s + 98*r - 135*s - 84) + f**2*(126*C*(r - 1)**2 + fd*(-144*r**2 - 690*r*s + 522*r + 385*s - 260) + 3*r**2*(47 - 59*K) + 18*r*(5*s + 16) + 126*s - 252) - 6*f*fd*(r**2*(32*K - 44) - 4*r*(4*K + 3*s - 7) + 3*s - 3) + 42*f*(r - 1)*(11*g2*(r - 1) + 4*gd2*r) + 168*fd*g2*r*(r - 1)) + Dd*f*(f**2*(-192*r**2 + r*(766 - 920*s) + 655*s - 392) - 6*f*(r**2*(64*K - 88) - 8*r*(2*K + 3*s - 5) + 3*s - 3) + 168*g2*(4*r**2 - 5*r + 1))) - 6480*Dd**2*f**4*r**2 - 3300*Dd**2*f**4*r*s + 4890*Dd**2*f**4*r + 825*Dd**2*f**4*s - 550*Dd**2*f**4 + 12672*Dd**2*f**2*g2*r**2 - 6336*Dd**2*f**2*g2*r + 33*b1**2*(D1**2*r*(6*f*(fd + 3*fdd)*(4*r + 4*s - 3) + 18*fd**2*(4*r + 4*s - 3) + fd*(-77*K*r + 133*r + 56*s) + 14*fdd*(-K*r + 4*r + 3*s)) + D1*(Dd*(12*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-77*K*(4*r**2 - 2*r + 1) + 18*fd*(8*r - 1)*(4*r + 4*s - 3) + 532*r**2 + 224*r*s - 378*r - 56*s + 133) - 14*fd*(r**2*(8*K - 32) - 2*r*(K + 12*s - 7) + 3*s)) + 2*Ddd*f*(-28*K*r**2 + 14*K*r - 7*K + 18*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 112*r**2 + 84*r*s - 98*r - 21*s + 28)) + 6*Dd**2*f*(6*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - 7*r**2*(4*K - 16) + 14*r*(K + 6*s - 7) - 21*s + 14)) + 11*b1*(252*C*D1**2*f*fd*r**2 + 504*C*D1*Dd*f**2*r**2 - 252*C*D1*Dd*f**2*r + 126*C*D1*Dd*f**2 - 354*D1**2*K*f*fd*r**2 + 354*D1**2*K*f*fd*r - 177*D1**2*K*f*fd - 96*D1**2*K*f*fdd*r**2 + 96*D1**2*K*f*fdd*r - 48*D1**2*K*f*fdd - 96*D1**2*K*fd**2*r**2 + 96*D1**2*K*fd**2*r + 6*D1**2*bdd1*f*(-14*K*r**2 + 14*K*r - 7*K + 9*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + 56*r**2 + 42*r*s - 77*r - 21*s + 28) + 252*D1**2*f**2*fd*r**2 + 825*D1**2*f**2*fd*r*s - 816*D1**2*f**2*fd*r - 140*D1**2*f**2*fd*s + 168*D1**2*f**2*fd - 72*D1**2*f**2*fdd*r**2 - 345*D1**2*f**2*fdd*r*s + 156*D1**2*f**2*fdd*r - 20*D1**2*f**2*fdd*s + 42*D1**2*f**2*fdd - 144*D1**2*f*fd**2*r**2 - 690*D1**2*f*fd**2*r*s + 312*D1**2*f*fd**2*r - 40*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 + 282*D1**2*f*fd*r**2 + 180*D1**2*f*fd*r*s - 660*D1**2*f*fd*r - 216*D1**2*f*fd*s + 393*D1**2*f*fd + 132*D1**2*f*fdd*r**2 + 36*D1**2*f*fdd*r*s - 132*D1**2*f*fdd*r - 18*D1**2*f*fdd*s + 66*D1**2*f*fdd + 462*D1**2*f*gd2*r**2 + 84*D1**2*f*gdd2*r**2 + 132*D1**2*fd**2*r**2 + 36*D1**2*fd**2*r*s - 132*D1**2*fd**2*r - 18*D1**2*fd**2*s + 462*D1**2*fd*g2*r**2 + 168*D1**2*fd*gd2*r**2 + 84*D1**2*fdd*g2*r**2 - 708*D1*Dd*K*f**2*r**2 + 354*D1*Dd*K*f**2*r - 177*D1*Dd*K*f**2 - 768*D1*Dd*K*f*fd*r**2 + 576*D1*Dd*K*f*fd*r - 96*D1*Dd*K*f*fd + 336*D1*Dd*f**3*r**2 + 1100*D1*Dd*f**3*r*s - 718*D1*Dd*f**3*r - 275*D1*Dd*f**3*s + 84*D1*Dd*f**3 - 576*D1*Dd*f**2*fd*r**2 - 2760*D1*Dd*f**2*fd*r*s + 1458*D1*Dd*f**2*fd*r + 265*D1*Dd*f**2*fd*s - 116*D1*Dd*f**2*fd + 564*D1*Dd*f**2*r**2 + 360*D1*Dd*f**2*r*s - 462*D1*Dd*f**2*r - 90*D1*Dd*f**2*s + 141*D1*Dd*f**2 + 1056*D1*Dd*f*fd*r**2 + 288*D1*Dd*f*fd*r*s - 864*D1*Dd*f*fd*r - 108*D1*Dd*f*fd*s + 168*D1*Dd*f*fd + 1848*D1*Dd*f*g2*r**2 - 924*D1*Dd*f*g2*r + 462*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r**2 - 168*D1*Dd*f*gd2*r + 672*D1*Dd*fd*g2*r**2 - 168*D1*Dd*fd*g2*r - 192*D1*Ddd*K*f**2*r**2 + 96*D1*Ddd*K*f**2*r - 48*D1*Ddd*K*f**2 - 96*D1*Ddd*f**3*r**2 - 460*D1*Ddd*f**3*r*s + 278*D1*Ddd*f**3*r + 115*D1*Ddd*f**3*s - 24*D1*Ddd*f**3 + 264*D1*Ddd*f**2*r**2 + 72*D1*Ddd*f**2*r*s - 168*D1*Ddd*f**2*r - 18*D1*Ddd*f**2*s + 66*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r**2 - 168*D1*Ddd*f*g2*r + 84*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(6*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(-77*K*(2*r**2 - 2*r + 1) + 18*fd*(4*r - 1)*(4*r + 4*s - 3) + 266*r**2 + 112*r*s - 322*r - 56*s + 133) - 14*fd*(r**2*(4*K - 16) + r*(-2*K - 12*s + 11) + 3*s)) + 2*Dd*f*(-14*K*(8*r**2 - 6*r + 1) + 9*f*(8*r - 3)*(4*r + 4*s - 3) + 448*r**2 + 336*r*s - 504*r - 126*s + 119)) - 576*Dd**2*K*f**2*r**2 + 288*Dd**2*K*f**2*r - 288*Dd**2*f**3*r**2 - 1380*Dd**2*f**3*r*s + 834*Dd**2*f**3*r + 345*Dd**2*f**3*s - 230*Dd**2*f**3 + 792*Dd**2*f**2*r**2 + 216*Dd**2*f**2*r*s - 504*Dd**2*f**2*r - 54*Dd**2*f**2*s + 36*Dd**2*f**2 + 1008*Dd**2*f*g2*r**2 - 504*Dd**2*f*g2*r))/(3465*d**2*k1**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**4*k2**2*st**2*(9*D1*bd1*f*(D1*(18*f*s*(r - 1) + 5*fd*(4*r*s - r - 2*s + 1)) + 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) + 9*b1*(D1*Dd*f*(18*f*(4*r*s - 2*r - s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(D1*r*(2*s - 1)*(18*f*fd + 5*f*fdd + 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(146*f*(4*r*s - 2*r - s) - 55*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(146*f*fd*(r*(3*s - 1) - s) + 5*f*(9*bdd1*s*(r - 1) + 11*fdd*(-3*r*s + r + s)) - 55*fd**2*(r*(6*s - 2) - 2*s + 1)) + 55*Ddd*f**2*(r*(2 - 4*s) + s)) - 55*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k1**2*k3**2) - D1**2*Pk1*Pk3*ct**4*k2**2*(42*b1**2*(C - 1)*(D1**2*r**2*(11*fd + 2*fdd) + D1*(11*Dd*f*(4*r**2 - 2*r + 1) + 4*Dd*fd*r*(4*r - 1) + 2*Ddd*f*(4*r**2 - 2*r + 1)) + 12*Dd**2*f*r*(2*r - 1)) + 3*b1*(236*C*D1**2*f*fd*r**2 - 236*C*D1**2*f*fd*r + 118*C*D1**2*f*fd + 64*C*D1**2*f*fdd*r**2 - 64*C*D1**2*f*fdd*r + 32*C*D1**2*f*fdd + 64*C*D1**2*fd**2*r**2 - 64*C*D1**2*fd**2*r + 472*C*D1*Dd*f**2*r**2 - 236*C*D1*Dd*f**2*r + 118*C*D1*Dd*f**2 + 512*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r + 64*C*D1*Dd*f*fd + 128*C*D1*Ddd*f**2*r**2 - 64*C*D1*Ddd*f**2*r + 32*C*D1*Ddd*f**2 + 384*C*Dd**2*f**2*r**2 - 192*C*Dd**2*f**2*r + 28*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 164*D1**2*f*fd*r**2 - 162*D1**2*f*fd*r*s + 317*D1**2*f*fd*r - 118*D1**2*f*fd - 16*D1**2*f*fdd*r**2 + 186*D1**2*f*fdd*r*s - 29*D1**2*f*fdd*r - 32*D1**2*f*fdd - 16*D1**2*fd**2*r**2 + 186*D1**2*fd**2*r*s - 29*D1**2*fd**2*r - 328*D1*Dd*f**2*r**2 - 324*D1*Dd*f**2*r*s + 326*D1*Dd*f**2*r + 81*D1*Dd*f**2*s - 82*D1*Dd*f**2 - 128*D1*Dd*f*fd*r**2 + 1488*D1*Dd*f*fd*r*s - 456*D1*Dd*f*fd*r - 186*D1*Dd*f*fd*s + 29*D1*Dd*f*fd - 32*D1*Ddd*f**2*r**2 + 372*D1*Ddd*f**2*r*s - 170*D1*Ddd*f**2*r - 93*D1*Ddd*f**2*s - 8*D1*Ddd*f**2 + 14*D1*bd1*(C - 1)*(11*D1*f*(2*r**2 - 2*r + 1) + 4*D1*fd*r*(2*r - 1) + 4*Dd*f*(8*r**2 - 6*r + 1)) - 96*Dd**2*f**2*r**2 + 1116*Dd**2*f**2*r*s - 510*Dd**2*f**2*r - 279*Dd**2*f**2*s + 186*Dd**2*f**2) + f*(-168*C*D1**2*f*fd*r**2 + 112*C*D1**2*f*fd*r - 56*C*D1**2*f*fd - 132*C*D1**2*f*fdd*r**2 + 88*C*D1**2*f*fdd*r - 44*C*D1**2*f*fdd - 264*C*D1**2*fd**2*r**2 + 176*C*D1**2*fd**2*r - 224*C*D1*Dd*f**2*r**2 + 112*C*D1*Dd*f**2*r - 56*C*D1*Dd*f**2 - 1056*C*D1*Dd*f*fd*r**2 + 616*C*D1*Dd*f*fd*r - 88*C*D1*Dd*f*fd - 176*C*D1*Ddd*f**2*r**2 + 88*C*D1*Ddd*f**2*r - 44*C*D1*Ddd*f**2 - 528*C*Dd**2*f**2*r**2 + 264*C*Dd**2*f**2*r + 168*D1**2*bd1**2*r*(C - 1)*(r - 1) + 3*D1**2*bdd1*f*(r**2*(32*C - 8) + r*(93*s - 48) - 93*s + 24) + 528*D1**2*f*fd*r**2 - 3*D1**2*f*fd*r*s - 351*D1**2*f*fd*r + D1**2*f*fd*s + 176*D1**2*f*fd + 222*D1**2*f*fdd*r**2 + 123*D1**2*f*fdd*r*s - 189*D1**2*f*fdd*r - 41*D1**2*f*fdd*s + 74*D1**2*f*fdd + 444*D1**2*fd**2*r**2 + 246*D1**2*fd**2*r*s - 378*D1**2*fd**2*r - 82*D1**2*fd**2*s + 41*D1**2*fd**2 + 704*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r*s - 350*D1*Dd*f**2*r + D1*Dd*f**2*s + 176*D1*Dd*f**2 + 1776*D1*Dd*f*fd*r**2 + 984*D1*Dd*f*fd*r*s - 1446*D1*Dd*f*fd*r - 287*D1*Dd*f*fd*s + 271*D1*Dd*f*fd + 296*D1*Ddd*f**2*r**2 + 164*D1*Ddd*f**2*r*s - 230*D1*Ddd*f**2*r - 41*D1*Ddd*f**2*s + 74*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(r**2*(118*C - 82) - 9*r*(9*s + 8) + 81*s + 36) + fd*(r**2*(128*C - 32) + r*(-64*C + 372*s - 125) - 186*s + 93)) + Dd*f*(r**2*(256*C - 64) + r*(-64*C + 744*s - 362) - 465*s + 234)) + 888*Dd**2*f**2*r**2 + 492*Dd**2*f**2*r*s - 690*Dd**2*f**2*r - 123*Dd**2*f**2*s + 82*Dd**2*f**2))/(315*d**2*k1**2*k3**2) + 2*D1**2*Pk1*Pk3*ct**4*(3*D1*f*(7*D1*bd1**2*s*(2*r - 1) + D1*bd1*(12*f*r*s + fd*r*(4*s - 1) - fd*s) + D1*bdd1*f*r*s + Dd*bd1*f*(r*(8*s - 2) - s)) + 7*b1**2*(D1*Dd*(4*f*(4*r*s - 2*r - s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(D1*r*(4*fd + 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(3*D1*Dd*f*(12*f*(r*(4*s - 2) - s) + fd*(8*r - 3)*(2*s - 1)) + 7*D1*bd1*(D1*(4*f*s*(2*r - 1) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + 3*D1*(D1*(12*f*fd*(r*(2*s - 1) - s) + f*(7*bdd1*s*(2*r - 1) + fdd*r*(2*s - 1) - fdd*s) + fd**2*(r*(2*s - 1) - s + 1)) + Ddd*f**2*(r*(4*s - 2) - s)) + 3*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k1**2) - 4*D1**2*Pk1*Pk3*ct**3*f*k2**7*st**4*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 88*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 88*D1**2*b1*f*fd*s + 44*D1**2*b1*f*fd - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 44*D1**2*b1*f*fdd*r - 33*D1**2*b1*f*fdd*s**2 + 44*D1**2*b1*f*fdd*s - 22*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 88*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 88*D1**2*b1*fd**2*s - 22*D1**2*b1*fd**2 - 11*D1**2*bdd1*f**2*(r + s - 1)**2 + 40*D1**2*f**2*fd*r**2 + 80*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 40*D1**2*f**2*fd*s**2 - 60*D1**2*f**2*fd*s + 30*D1**2*f**2*fd - 20*D1**2*f**2*fdd*r**2 - 40*D1**2*f**2*fdd*r*s + 30*D1**2*f**2*fdd*r - 20*D1**2*f**2*fdd*s**2 + 30*D1**2*f**2*fdd*s - 15*D1**2*f**2*fdd - 60*D1**2*f*fd**2*r**2 - 120*D1**2*f*fd**2*r*s + 90*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s**2 + 90*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 176*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r + 88*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 374*D1*Dd*b1*f*fd*r - 264*D1*Dd*b1*f*fd*s**2 + 374*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 - 160*D1*Dd*f**2*fd*r**2 - 320*D1*Dd*f**2*fd*r*s + 240*D1*Dd*f**2*fd*r - 160*D1*Dd*f**2*fd*s**2 + 240*D1*Dd*f**2*fd*s - 90*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 - 88*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r - 44*D1*Ddd*b1*f**2*s**2 + 66*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 30*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 30*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 + 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 132*Dd**2*b1*f**2*r**2 - 264*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r - 132*Dd**2*b1*f**2*s**2 + 198*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 90*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 90*Dd**2*f**3*s - 30*Dd**2*f**3)/(11*d**2*k1*k3**8) + 2*D1**2*Pk1*Pk3*ct**3*f*k2**5*st**2*(165*D1**2*b1*f*fd*r**2 - 231*D1**2*b1*f*fdd*r**2 - 462*D1**2*b1*fd**2*r**2 - 77*D1**2*bdd1*f**2*(r - 1)**2 + 292*D1**2*f**2*fd*r**2 - 146*D1**2*f**2*fd*r + 73*D1**2*f**2*fd - 212*D1**2*f**2*fdd*r**2 + 106*D1**2*f**2*fdd*r - 53*D1**2*f**2*fdd - 636*D1**2*f*fd**2*r**2 + 318*D1**2*f*fd**2*r + 220*D1*Dd*b1*f**2*r**2 - 110*D1*Dd*b1*f**2*r + 55*D1*Dd*b1*f**2 - 1848*D1*Dd*b1*f*fd*r**2 + 462*D1*Dd*b1*f*fd*r + 292*D1*Dd*f**3*r**2 - 146*D1*Dd*f**3*r + 73*D1*Dd*f**3 - 1696*D1*Dd*f**2*fd*r**2 + 848*D1*Dd*f**2*fd*r - 106*D1*Dd*f**2*fd - 308*D1*Ddd*b1*f**2*r**2 + 154*D1*Ddd*b1*f**2*r - 77*D1*Ddd*b1*f**2 - 212*D1*Ddd*f**3*r**2 + 106*D1*Ddd*f**3*r - 53*D1*Ddd*f**3 + 11*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) - 42*D1*fd*r + 14*Dd*f*(1 - 4*r)) - 924*Dd**2*b1*f**2*r**2 + 462*Dd**2*b1*f**2*r - 636*Dd**2*f**3*r**2 + 318*Dd**2*f**3*r)/(693*d**2*k1**3*k3**4) - D1**2*Pk1*Pk3*ct**3*k1**5*k2*(48*C - 28)*(54*D1**2*b1*f*fd*r**2 + 108*D1**2*b1*f*fd*r*s - 54*D1**2*b1*f*fd*r + 54*D1**2*b1*f*fd*s**2 - 54*D1**2*b1*f*fd*s + 27*D1**2*b1*f*fd - 90*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd - 90*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)**2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 216*D1*Dd*b1*f**2*r*s - 162*D1*Dd*b1*f**2*r + 108*D1*Dd*b1*f**2*s**2 - 162*D1*Dd*b1*f**2*s + 81*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 900*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 900*D1*Dd*b1*f*fd*s - 270*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 1190*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 1190*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 270*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 270*D1*Ddd*b1*f**2*s - 135*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 210*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 210*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 540*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 810*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 810*Dd**2*b1*f**2*s - 270*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 630*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 630*Dd**2*f**3*s - 210*Dd**2*f**3)/(105*d**2*k3**8) - D1**2*Pk1*Pk3*ct**3*k1**5*(16*C - 8)*(9*b1*(D1**2*(f*(3*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(3*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(2*s - 1)*(8*r + 8*s - 5)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-5*D1**2*(f*(9*bdd1*s*(r + s - 1) - 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(3*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) - 5*D1*f*(Dd*(-5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 7*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) + 7*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 35*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k2*k3**6) - 8*D1**2*Pk1*Pk3*ct**3*k1**3*k2**3*st**2*(2112*C*D1**2*b1*f*fd*r**2 + 4224*C*D1**2*b1*f*fd*r*s - 2112*C*D1**2*b1*f*fd*r + 2112*C*D1**2*b1*f*fd*s**2 - 2112*C*D1**2*b1*f*fd*s + 1056*C*D1**2*b1*f*fd - 2232*C*D1**2*b1*f*fdd*r**2 - 4464*C*D1**2*b1*f*fdd*r*s + 2232*C*D1**2*b1*f*fdd*r - 2232*C*D1**2*b1*f*fdd*s**2 + 2232*C*D1**2*b1*f*fdd*s - 1116*C*D1**2*b1*f*fdd - 2232*C*D1**2*b1*fd**2*r**2 - 4464*C*D1**2*b1*fd**2*r*s + 2232*C*D1**2*b1*fd**2*r - 2232*C*D1**2*b1*fd**2*s**2 + 2232*C*D1**2*b1*fd**2*s + 2208*C*D1**2*f**2*fd*r**2 + 4416*C*D1**2*f**2*fd*r*s - 2944*C*D1**2*f**2*fd*r + 2208*C*D1**2*f**2*fd*s**2 - 2944*C*D1**2*f**2*fd*s + 1472*C*D1**2*f**2*fd - 1860*C*D1**2*f**2*fdd*r**2 - 3720*C*D1**2*f**2*fdd*r*s + 2480*C*D1**2*f**2*fdd*r - 1860*C*D1**2*f**2*fdd*s**2 + 2480*C*D1**2*f**2*fdd*s - 1240*C*D1**2*f**2*fdd - 3720*C*D1**2*f*fd**2*r**2 - 7440*C*D1**2*f*fd**2*r*s + 4960*C*D1**2*f*fd**2*r - 3720*C*D1**2*f*fd**2*s**2 + 4960*C*D1**2*f*fd**2*s - 1240*C*D1**2*f*fd**2 + 4224*C*D1*Dd*b1*f**2*r**2 + 8448*C*D1*Dd*b1*f**2*r*s - 6336*C*D1*Dd*b1*f**2*r + 4224*C*D1*Dd*b1*f**2*s**2 - 6336*C*D1*Dd*b1*f**2*s + 3168*C*D1*Dd*b1*f**2 - 17856*C*D1*Dd*b1*f*fd*r**2 - 35712*C*D1*Dd*b1*f*fd*r*s + 22320*C*D1*Dd*b1*f*fd*r - 17856*C*D1*Dd*b1*f*fd*s**2 + 22320*C*D1*Dd*b1*f*fd*s - 6696*C*D1*Dd*b1*f*fd + 2944*C*D1*Dd*f**3*r**2 + 5888*C*D1*Dd*f**3*r*s - 4416*C*D1*Dd*f**3*r + 2944*C*D1*Dd*f**3*s**2 - 4416*C*D1*Dd*f**3*s + 2208*C*D1*Dd*f**3 - 14880*C*D1*Dd*f**2*fd*r**2 - 29760*C*D1*Dd*f**2*fd*r*s + 21080*C*D1*Dd*f**2*fd*r - 14880*C*D1*Dd*f**2*fd*s**2 + 21080*C*D1*Dd*f**2*fd*s - 7440*C*D1*Dd*f**2*fd - 4464*C*D1*Ddd*b1*f**2*r**2 - 8928*C*D1*Ddd*b1*f**2*r*s + 6696*C*D1*Ddd*b1*f**2*r - 4464*C*D1*Ddd*b1*f**2*s**2 + 6696*C*D1*Ddd*b1*f**2*s - 3348*C*D1*Ddd*b1*f**2 - 2480*C*D1*Ddd*f**3*r**2 - 4960*C*D1*Ddd*f**3*r*s + 3720*C*D1*Ddd*f**3*r - 2480*C*D1*Ddd*f**3*s**2 + 3720*C*D1*Ddd*f**3*s - 1860*C*D1*Ddd*f**3 - 13392*C*Dd**2*b1*f**2*r**2 - 26784*C*Dd**2*b1*f**2*r*s + 20088*C*Dd**2*b1*f**2*r - 13392*C*Dd**2*b1*f**2*s**2 + 20088*C*Dd**2*b1*f**2*s - 6696*C*Dd**2*b1*f**2 - 7440*C*Dd**2*f**3*r**2 - 14880*C*Dd**2*f**3*r*s + 11160*C*Dd**2*f**3*r - 7440*C*Dd**2*f**3*s**2 + 11160*C*Dd**2*f**3*s - 3720*C*Dd**2*f**3 - 1374*D1**2*b1*f*fd*r**2 - 2748*D1**2*b1*f*fd*r*s + 1374*D1**2*b1*f*fd*r - 1374*D1**2*b1*f*fd*s**2 + 1374*D1**2*b1*f*fd*s - 687*D1**2*b1*f*fd + 1548*D1**2*b1*f*fdd*r**2 + 3096*D1**2*b1*f*fdd*r*s - 1548*D1**2*b1*f*fdd*r + 1548*D1**2*b1*f*fdd*s**2 - 1548*D1**2*b1*f*fdd*s + 774*D1**2*b1*f*fdd + 1548*D1**2*b1*fd**2*r**2 + 3096*D1**2*b1*fd**2*r*s - 1548*D1**2*b1*fd**2*r + 1548*D1**2*b1*fd**2*s**2 - 1548*D1**2*b1*fd**2*s - 18*D1**2*bdd1*f**2*(62*C - 43)*(r + s - 1)**2 - 1473*D1**2*f**2*fd*r**2 - 2946*D1**2*f**2*fd*r*s + 1964*D1**2*f**2*fd*r - 1473*D1**2*f**2*fd*s**2 + 1964*D1**2*f**2*fd*s - 982*D1**2*f**2*fd + 1290*D1**2*f**2*fdd*r**2 + 2580*D1**2*f**2*fdd*r*s - 1720*D1**2*f**2*fdd*r + 1290*D1**2*f**2*fdd*s**2 - 1720*D1**2*f**2*fdd*s + 860*D1**2*f**2*fdd + 2580*D1**2*f*fd**2*r**2 + 5160*D1**2*f*fd**2*r*s - 3440*D1**2*f*fd**2*r + 2580*D1**2*f*fd**2*s**2 - 3440*D1**2*f*fd**2*s + 860*D1**2*f*fd**2 - 2748*D1*Dd*b1*f**2*r**2 - 5496*D1*Dd*b1*f**2*r*s + 4122*D1*Dd*b1*f**2*r - 2748*D1*Dd*b1*f**2*s**2 + 4122*D1*Dd*b1*f**2*s - 2061*D1*Dd*b1*f**2 + 12384*D1*Dd*b1*f*fd*r**2 + 24768*D1*Dd*b1*f*fd*r*s - 15480*D1*Dd*b1*f*fd*r + 12384*D1*Dd*b1*f*fd*s**2 - 15480*D1*Dd*b1*f*fd*s + 4644*D1*Dd*b1*f*fd - 1964*D1*Dd*f**3*r**2 - 3928*D1*Dd*f**3*r*s + 2946*D1*Dd*f**3*r - 1964*D1*Dd*f**3*s**2 + 2946*D1*Dd*f**3*s - 1473*D1*Dd*f**3 + 10320*D1*Dd*f**2*fd*r**2 + 20640*D1*Dd*f**2*fd*r*s - 14620*D1*Dd*f**2*fd*r + 10320*D1*Dd*f**2*fd*s**2 - 14620*D1*Dd*f**2*fd*s + 5160*D1*Dd*f**2*fd + 3096*D1*Ddd*b1*f**2*r**2 + 6192*D1*Ddd*b1*f**2*r*s - 4644*D1*Ddd*b1*f**2*r + 3096*D1*Ddd*b1*f**2*s**2 - 4644*D1*Ddd*b1*f**2*s + 2322*D1*Ddd*b1*f**2 + 1720*D1*Ddd*f**3*r**2 + 3440*D1*Ddd*f**3*r*s - 2580*D1*Ddd*f**3*r + 1720*D1*Ddd*f**3*s**2 - 2580*D1*Ddd*f**3*s + 1290*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(352*C - 229)*(r + s - 1) - D1*fd*(744*C - 516)*(2*r + 2*s - 1) - Dd*f*(744*C - 516)*(4*r + 4*s - 3)) + 9288*Dd**2*b1*f**2*r**2 + 18576*Dd**2*b1*f**2*r*s - 13932*Dd**2*b1*f**2*r + 9288*Dd**2*b1*f**2*s**2 - 13932*Dd**2*b1*f**2*s + 4644*Dd**2*b1*f**2 + 5160*Dd**2*f**3*r**2 + 10320*Dd**2*f**3*r*s - 7740*Dd**2*f**3*r + 5160*Dd**2*f**3*s**2 - 7740*Dd**2*f**3*s + 2580*Dd**2*f**3)/(105*d**2*k3**8) - 4*D1**2*Pk1*Pk3*ct**3*k1**3*k2**3*(-11880*C*D1**2*f**2*fd*r**2 - 23760*C*D1**2*f**2*fd*r*s + 15840*C*D1**2*f**2*fd*r - 11880*C*D1**2*f**2*fd*s**2 + 15840*C*D1**2*f**2*fd*s - 7920*C*D1**2*f**2*fd - 15840*C*D1*Dd*f**3*r**2 - 31680*C*D1*Dd*f**3*r*s + 23760*C*D1*Dd*f**3*r - 15840*C*D1*Dd*f**3*s**2 + 23760*C*D1*Dd*f**3*s - 11880*C*D1*Dd*f**3 - 9900*D1**2*K*bdd1*f**2*r**2 - 19800*D1**2*K*bdd1*f**2*r*s + 19800*D1**2*K*bdd1*f**2*r - 9900*D1**2*K*bdd1*f**2*s**2 + 19800*D1**2*K*bdd1*f**2*s - 9900*D1**2*K*bdd1*f**2 + 1980*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 + 1925*D1**2*bdd1*f**3*r**2 + 3850*D1**2*bdd1*f**3*r*s - 3850*D1**2*bdd1*f**3*r + 1925*D1**2*bdd1*f**3*s**2 - 3850*D1**2*bdd1*f**3*s + 1925*D1**2*bdd1*f**3 + 4950*D1**2*bdd1*f**2*r**2 + 9900*D1**2*bdd1*f**2*r*s - 9900*D1**2*bdd1*f**2*r + 4950*D1**2*bdd1*f**2*s**2 - 9900*D1**2*bdd1*f**2*s + 4950*D1**2*bdd1*f**2 + 27720*D1**2*bdd1*f*g2*r**2 + 55440*D1**2*bdd1*f*g2*r*s - 55440*D1**2*bdd1*f*g2*r + 27720*D1**2*bdd1*f*g2*s**2 - 55440*D1**2*bdd1*f*g2*s + 27720*D1**2*bdd1*f*g2 + 4900*D1**2*f**3*fd*r**2 + 9800*D1**2*f**3*fd*r*s - 7350*D1**2*f**3*fd*r + 4900*D1**2*f**3*fd*s**2 - 7350*D1**2*f**3*fd*s + 3675*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 + 7425*D1**2*f**2*fd*r**2 + 14850*D1**2*f**2*fd*r*s - 9900*D1**2*f**2*fd*r + 7425*D1**2*f**2*fd*s**2 - 9900*D1**2*f**2*fd*s + 4950*D1**2*f**2*fd - 17424*D1**2*f**2*gd2*r**2 - 34848*D1**2*f**2*gd2*r*s + 34848*D1**2*f**2*gd2*r - 17424*D1**2*f**2*gd2*s**2 + 34848*D1**2*f**2*gd2*s - 17424*D1**2*f**2*gd2 + 19800*D1**2*f**2*gdd2*r**2 + 39600*D1**2*f**2*gdd2*r*s - 39600*D1**2*f**2*gdd2*r + 19800*D1**2*f**2*gdd2*s**2 - 39600*D1**2*f**2*gdd2*s + 19800*D1**2*f**2*gdd2 - 34848*D1**2*f*fd*g2*r**2 - 69696*D1**2*f*fd*g2*r*s + 34848*D1**2*f*fd*g2*r - 34848*D1**2*f*fd*g2*s**2 + 34848*D1**2*f*fd*g2*s - 17424*D1**2*f*fd*g2 + 79200*D1**2*f*fd*gd2*r**2 + 158400*D1**2*f*fd*gd2*r*s - 118800*D1**2*f*fd*gd2*r + 79200*D1**2*f*fd*gd2*s**2 - 118800*D1**2*f*fd*gd2*s + 39600*D1**2*f*fd*gd2 + 39600*D1**2*f*fdd*g2*r**2 + 79200*D1**2*f*fdd*g2*r*s - 39600*D1**2*f*fdd*g2*r + 39600*D1**2*f*fdd*g2*s**2 - 39600*D1**2*f*fdd*g2*s + 19800*D1**2*f*fdd*g2 + 39600*D1**2*fd**2*g2*r**2 + 79200*D1**2*fd**2*g2*r*s - 39600*D1**2*fd**2*g2*r + 39600*D1**2*fd**2*g2*s**2 - 39600*D1**2*fd**2*g2*s + 4900*D1*Dd*f**4*r**2 + 9800*D1*Dd*f**4*r*s - 7350*D1*Dd*f**4*r + 4900*D1*Dd*f**4*s**2 - 7350*D1*Dd*f**4*s + 3675*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd + 9900*D1*Dd*f**3*r**2 + 19800*D1*Dd*f**3*r*s - 14850*D1*Dd*f**3*r + 9900*D1*Dd*f**3*s**2 - 14850*D1*Dd*f**3*s + 7425*D1*Dd*f**3 - 69696*D1*Dd*f**2*g2*r**2 - 139392*D1*Dd*f**2*g2*r*s + 104544*D1*Dd*f**2*g2*r - 69696*D1*Dd*f**2*g2*s**2 + 104544*D1*Dd*f**2*g2*s - 52272*D1*Dd*f**2*g2 + 158400*D1*Dd*f**2*gd2*r**2 + 316800*D1*Dd*f**2*gd2*r*s - 277200*D1*Dd*f**2*gd2*r + 158400*D1*Dd*f**2*gd2*s**2 - 277200*D1*Dd*f**2*gd2*s + 118800*D1*Dd*f**2*gd2 + 316800*D1*Dd*f*fd*g2*r**2 + 633600*D1*Dd*f*fd*g2*r*s - 396000*D1*Dd*f*fd*g2*r + 316800*D1*Dd*f*fd*g2*s**2 - 396000*D1*Dd*f*fd*g2*s + 118800*D1*Dd*f*fd*g2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 79200*D1*Ddd*f**2*g2*r**2 + 158400*D1*Ddd*f**2*g2*r*s - 118800*D1*Ddd*f**2*g2*r + 79200*D1*Ddd*f**2*g2*s**2 - 118800*D1*Ddd*f**2*g2*s + 59400*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(85*f**3*(r + s - 1) + f**2*(252*C*(r + s - 1) - 175*fd*(3*r + 3*s - 2) - (396*K - 9)*(r + s - 1)) + 30*f*(15*fd*(2*K - 1)*(2*r + 2*s - 1) + (28*g2 - 84*gd2)*(r + s - 1)) - 2520*fd*g2*(r + s)) - 5*Dd*f*(35*f**2 - 90*f*(2*K - 1) + 504*g2)*(4*r + 4*s - 3))*(r + s - 1) - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 237600*Dd**2*f**2*g2*r**2 + 475200*Dd**2*f**2*g2*r*s - 356400*Dd**2*f**2*g2*r + 237600*Dd**2*f**2*g2*s**2 - 356400*Dd**2*f**2*g2*s + 118800*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(3*f*(37*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-5*r - 5*s)*(60*fd**2*(r + s - 1) + 7*fd*(8*K - 3)*(r + s) - 42*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(111*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (56*K - 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 420*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 30*Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(1008*C*D1**2*f*fd*r**2 + 2016*C*D1**2*f*fd*r*s - 1008*C*D1**2*f*fd*r + 1008*C*D1**2*f*fd*s**2 - 1008*C*D1**2*f*fd*s + 504*C*D1**2*f*fd + 2016*C*D1*Dd*f**2*r**2 + 4032*C*D1*Dd*f**2*r*s - 3024*C*D1*Dd*f**2*r + 2016*C*D1*Dd*f**2*s**2 - 3024*C*D1*Dd*f**2*s + 1512*C*D1*Dd*f**2 - 1584*D1**2*K*f*fd*r**2 - 3168*D1**2*K*f*fd*r*s + 1584*D1**2*K*f*fd*r - 1584*D1**2*K*f*fd*s**2 + 1584*D1**2*K*f*fd*s - 792*D1**2*K*f*fd + 1800*D1**2*K*f*fdd*r**2 + 3600*D1**2*K*f*fdd*r*s - 1800*D1**2*K*f*fdd*r + 1800*D1**2*K*f*fdd*s**2 - 1800*D1**2*K*f*fdd*s + 900*D1**2*K*f*fdd + 1800*D1**2*K*fd**2*r**2 + 3600*D1**2*K*fd**2*r*s - 1800*D1**2*K*fd**2*r + 1800*D1**2*K*fd**2*s**2 - 1800*D1**2*K*fd**2*s - 180*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 + 510*D1**2*f**2*fd*r**2 + 1020*D1**2*f**2*fd*r*s - 680*D1**2*f**2*fd*r + 510*D1**2*f**2*fd*s**2 - 680*D1**2*f**2*fd*s + 340*D1**2*f**2*fd - 525*D1**2*f**2*fdd*r**2 - 1050*D1**2*f**2*fdd*r*s + 700*D1**2*f**2*fdd*r - 525*D1**2*f**2*fdd*s**2 + 700*D1**2*f**2*fdd*s - 350*D1**2*f**2*fdd - 1050*D1**2*f*fd**2*r**2 - 2100*D1**2*f*fd**2*r*s + 1400*D1**2*f*fd**2*r - 1050*D1**2*f*fd**2*s**2 + 1400*D1**2*f*fd**2*s - 350*D1**2*f*fd**2 + 36*D1**2*f*fd*r**2 + 72*D1**2*f*fd*r*s - 36*D1**2*f*fd*r + 36*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s + 18*D1**2*f*fd - 900*D1**2*f*fdd*r**2 - 1800*D1**2*f*fdd*r*s + 900*D1**2*f*fdd*r - 900*D1**2*f*fdd*s**2 + 900*D1**2*f*fdd*s - 450*D1**2*f*fdd + 1680*D1**2*f*gd2*r**2 + 3360*D1**2*f*gd2*r*s - 3360*D1**2*f*gd2*r + 1680*D1**2*f*gd2*s**2 - 3360*D1**2*f*gd2*s + 1680*D1**2*f*gd2 - 2520*D1**2*f*gdd2*r**2 - 5040*D1**2*f*gdd2*r*s + 5040*D1**2*f*gdd2*r - 2520*D1**2*f*gdd2*s**2 + 5040*D1**2*f*gdd2*s - 2520*D1**2*f*gdd2 - 900*D1**2*fd**2*r**2 - 1800*D1**2*fd**2*r*s + 900*D1**2*fd**2*r - 900*D1**2*fd**2*s**2 + 900*D1**2*fd**2*s + 1680*D1**2*fd*g2*r**2 + 3360*D1**2*fd*g2*r*s + 1680*D1**2*fd*g2*s**2 - 5040*D1**2*fd*gd2*r**2 - 10080*D1**2*fd*gd2*r*s + 5040*D1**2*fd*gd2*r - 5040*D1**2*fd*gd2*s**2 + 5040*D1**2*fd*gd2*s - 2520*D1**2*fdd*g2*r**2 - 5040*D1**2*fdd*g2*r*s - 2520*D1**2*fdd*g2*s**2 - 3168*D1*Dd*K*f**2*r**2 - 6336*D1*Dd*K*f**2*r*s + 4752*D1*Dd*K*f**2*r - 3168*D1*Dd*K*f**2*s**2 + 4752*D1*Dd*K*f**2*s - 2376*D1*Dd*K*f**2 + 14400*D1*Dd*K*f*fd*r**2 + 28800*D1*Dd*K*f*fd*r*s - 18000*D1*Dd*K*f*fd*r + 14400*D1*Dd*K*f*fd*s**2 - 18000*D1*Dd*K*f*fd*s + 5400*D1*Dd*K*f*fd + 680*D1*Dd*f**3*r**2 + 1360*D1*Dd*f**3*r*s - 1020*D1*Dd*f**3*r + 680*D1*Dd*f**3*s**2 - 1020*D1*Dd*f**3*s + 510*D1*Dd*f**3 - 4200*D1*Dd*f**2*fd*r**2 - 8400*D1*Dd*f**2*fd*r*s + 5950*D1*Dd*f**2*fd*r - 4200*D1*Dd*f**2*fd*s**2 + 5950*D1*Dd*f**2*fd*s - 2100*D1*Dd*f**2*fd + 72*D1*Dd*f**2*r**2 + 144*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 108*D1*Dd*f**2*s + 54*D1*Dd*f**2 - 7200*D1*Dd*f*fd*r**2 - 14400*D1*Dd*f*fd*r*s + 9000*D1*Dd*f*fd*r - 7200*D1*Dd*f*fd*s**2 + 9000*D1*Dd*f*fd*s - 2700*D1*Dd*f*fd + 6720*D1*Dd*f*g2*r**2 + 13440*D1*Dd*f*g2*r*s - 10080*D1*Dd*f*g2*r + 6720*D1*Dd*f*g2*s**2 - 10080*D1*Dd*f*g2*s + 5040*D1*Dd*f*g2 - 20160*D1*Dd*f*gd2*r**2 - 40320*D1*Dd*f*gd2*r*s + 35280*D1*Dd*f*gd2*r - 20160*D1*Dd*f*gd2*s**2 + 35280*D1*Dd*f*gd2*s - 15120*D1*Dd*f*gd2 - 20160*D1*Dd*fd*g2*r**2 - 40320*D1*Dd*fd*g2*r*s + 15120*D1*Dd*fd*g2*r - 20160*D1*Dd*fd*g2*s**2 + 15120*D1*Dd*fd*g2*s + 3600*D1*Ddd*K*f**2*r**2 + 7200*D1*Ddd*K*f**2*r*s - 5400*D1*Ddd*K*f**2*r + 3600*D1*Ddd*K*f**2*s**2 - 5400*D1*Ddd*K*f**2*s + 2700*D1*Ddd*K*f**2 - 700*D1*Ddd*f**3*r**2 - 1400*D1*Ddd*f**3*r*s + 1050*D1*Ddd*f**3*r - 700*D1*Ddd*f**3*s**2 + 1050*D1*Ddd*f**3*s - 525*D1*Ddd*f**3 - 1800*D1*Ddd*f**2*r**2 - 3600*D1*Ddd*f**2*r*s + 2700*D1*Ddd*f**2*r - 1800*D1*Ddd*f**2*s**2 + 2700*D1*Ddd*f**2*s - 1350*D1*Ddd*f**2 - 10080*D1*Ddd*f*g2*r**2 - 20160*D1*Ddd*f*g2*r*s + 15120*D1*Ddd*f*g2*r - 10080*D1*Ddd*f*g2*s**2 + 15120*D1*Ddd*f*g2*s - 7560*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(111*f**2*(r + s - 1) - 5*f*(60*fd*(2*r + 2*s - 1) + (56*K - 21)*(r + s - 1)) + 420*fd*(2*K - 1)*(r + s)) - 60*Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 10800*Dd**2*K*f**2*r**2 + 21600*Dd**2*K*f**2*r*s - 16200*Dd**2*K*f**2*r + 10800*Dd**2*K*f**2*s**2 - 16200*Dd**2*K*f**2*s + 5400*Dd**2*K*f**2 - 2100*Dd**2*f**3*r**2 - 4200*Dd**2*f**3*r*s + 3150*Dd**2*f**3*r - 2100*Dd**2*f**3*s**2 + 3150*Dd**2*f**3*s - 1050*Dd**2*f**3 - 5400*Dd**2*f**2*r**2 - 10800*Dd**2*f**2*r*s + 8100*Dd**2*f**2*r - 5400*Dd**2*f**2*s**2 + 8100*Dd**2*f**2*s - 2700*Dd**2*f**2 - 30240*Dd**2*f*g2*r**2 - 60480*Dd**2*f*g2*r*s + 45360*Dd**2*f*g2*r - 30240*Dd**2*f*g2*s**2 + 45360*Dd**2*f*g2*s - 15120*Dd**2*f*g2))/(1155*d**2*k3**8) - 16*D1**2*Pk1*Pk3*ct**3*k1**3*k2*st**2*(b1*(D1**2*(f*(fd*(281*C - 179) + fdd*(135 - 207*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(135 - 207*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(281*C - 179)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(135 - 207*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(135 - 207*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(135 - 207*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(173*C - 111)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (23*C - 15)*(9*bdd1*s*(r + s - 1) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(75 - 115*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(281*C - 179)*(r + s - 1) - fd*(207*C - 135)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(135 - 207*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(173*C - 111)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(115*C - 75)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(75 - 115*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(75 - 115*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**6) - 2*D1**2*Pk1*Pk3*ct**3*k1**3*k2*(42*D1*b1*bd1*(8*C - 5)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 42*b1**2*(8*C - 5)*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(14*D1**2*bdd1*f*(8*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1**2*(f*(fd*(8*C*(66*r**2 + 8*r*(41*s - 19) + 262*s**2 - 250*s + 125) - 318*r**2 - 1748*r*s + 814*r - 1430*s**2 + 1370*s - 685) + fdd*(-40*C*(22*r**2 + 8*r*(9*s - 4) + 50*s**2 - 46*s + 23) + 530*r**2 + 1924*r*s - 862*r + 1394*s**2 - 1294*s + 647)) - 2*fd**2*(40*C*(11*r**2 + 4*r*(9*s - 4) + 25*s**2 - 23*s - 2) - 265*r**2 - 962*r*s + 431*r - 697*s**2 + 647*s + 50)) + D1*f*(Dd*(f*(8*C*(132*r**2 + 656*r*s - 394*r + 524*s**2 - 688*s + 295) - 636*r**2 - 3496*r*s + 2066*r - 2860*s**2 + 3734*s - 1589) - 2*fd*(80*C*(44*r**2 + 144*r*s - 79*r + 100*s**2 - 114*s + 31) - 2120*r**2 - 7696*r*s + 4178*r - 5576*s**2 + 6338*s - 1725)) + Ddd*f*(-40*C*(44*r**2 + 144*r*s - 94*r + 100*s**2 - 136*s + 61) + 1060*r**2 + 3848*r*s - 2454*r + 2788*s**2 - 3750*s + 1659)) - 2*Dd**2*f**2*(40*C*(66*r**2 + 3*r*(72*s - 47) + 150*s**2 - 204*s + 61) - 1590*r**2 - 3*r*(1924*s - 1227) - 4182*s**2 + 5625*s - 1659)) + f*(-252*D1**2*bd1**2*(8*C - 5)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(40*C*(11*r**2 + r*(36*s - 26) + 25*s**2 - 40*s + 13) - 265*r**2 + r*(630 - 962*s) - 697*s**2 + 1062*s - 315) - 5*D1**2*(f*(fd*(8*C*(231*r**2 + 6*r*(130*s - 69) + 549*s**2 - 626*s + 260) - 1113*r**2 - 6*r*(685*s - 352) - 2997*s**2 + 3368*s - 1370) + fdd*(-8*C*(291*r**2 + 6*r*(137*s - 78) + 531*s**2 - 628*s + 274) + 1407*r**2 + 6*r*(725*s - 398) + 2943*s**2 - 3412*s + 1450)) + 2*fd**2*(-8*C*(291*r**2 + 6*r*(137*s - 78) + 531*s**2 - 628*s + 137) + 1407*r**2 + 6*r*(725*s - 398) + 2943*s**2 - 3412*s + 725)) - 9*D1*bd1*(D1*(f*(8*C*(33*r**2 + 164*r*s - 78*r + 131*s**2 - 176*s + 39) - 159*r**2 - 874*r*s + 378*r - 715*s**2 + 934*s - 189) - 2*fd*(40*C*(22*r**2 + 72*r*s - 42*r + 50*s**2 - 63*s + 20) - 530*r**2 - 1924*r*s + 1061*r - 1394*s**2 + 1709*s - 531)) + 2*Dd*f*(-40*C*(44*r**2 + 144*r*s - 99*r + 100*s**2 - 148*s + 53) + 1060*r**2 + 3848*r*s - 2487*r + 2788*s**2 - 3999*s + 1377)) - 5*D1*f*(Dd*(f*(8*C*(308*r**2 + 2*r*(520*s - 337) + 732*s**2 - 992*s + 443) - 1484*r**2 + r*(3482 - 5480*s) - 3996*s**2 + 5366*s - 2369) + 2*fd*(-8*C*(1164*r**2 + 3*r*(1096*s - 683) + 2124*s**2 - 2729*s + 862) + 5628*r**2 + 3*r*(5800*s - 3511) + 11772*s**2 - 14885*s + 4606)) + Ddd*f*(-8*C*(388*r**2 + 2*r*(548*s - 371) + 708*s**2 - 982*s + 451) + 1876*r**2 + r*(5800*s - 3838) + 3924*s**2 - 5374*s + 2431)) + 10*Dd**2*f**2*(8*C*(582*r**2 + 3*r*(548*s - 371) + 1062*s**2 - 1473*s + 451) - 2814*r**2 + r*(5757 - 8700*s) - 5886*s**2 + 8061*s - 2431)))/(315*d**2*k3**6) - D1**2*Pk1*Pk3*ct**3*k1**3*st**2*(256*C - 152)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(315*d**2*k2*k3**4) + D1**2*Pk1*Pk3*ct**3*k1**3*(-84*D1*b1*bd1*(2*C - 1)*(D1*(f*s*(2*r + 2*s - 1) - 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 6*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 84*b1**2*(2*C - 1)*(D1**2*(fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 9*b1*(D1**2*(f*(28*bdd1*s*(2*C - 1)*(2*r + 2*s - 1) + fd*(8*C*(20*r*s - 10*r + 118*s**2 - 115*s + 59) - 80*r*s + 40*r - 582*s**2 + 570*s - 291) + fdd*(-8*C*(24*r*s - 12*r + 94*s**2 - 89*s + 47) + 96*r*s - 48*r + 466*s**2 - 446*s + 233)) + 2*fd**2*(-4*C*(12*r*(2*s - 1) + 94*s**2 - 89*s - 5) + 24*r*(2*s - 1) + 233*s**2 - 223*s - 10)) + 2*D1*f*(Dd*(f*(8*C*(20*r*s - 10*r + 118*s**2 - 123*s + 59) - 80*r*s + 40*r - 582*s**2 + 602*s - 291) - 2*fd*(2*s - 1)*(4*C*(48*r + 188*s - 95) - 96*r - 466*s + 235)) + Ddd*f*(-8*C*(24*r*s - 12*r + 94*s**2 - 100*s + 47) + 96*r*s - 48*r + 466*s**2 - 490*s + 233)) + 2*Dd**2*f**2*(-8*C*(36*r*(2*s - 1) + 282*s**2 - 300*s + 59) + 144*r*(2*s - 1) + 1398*s**2 - 1470*s + 281)) + f*(252*D1**2*bd1**2*s*(2*C - 1)*(2*r + 2*s - 1) + D1**2*(f*(-9*bdd1*s*(8*C*(12*r + 47*s - 17) - 48*r - 233*s + 68) + 5*fd*(8*C*(69*r*s - 23*r + 246*s**2 - 187*s + 82) - 276*r*s + 92*r - 1203*s**2 + 894*s - 401) - 5*fdd*(8*C*(75*r*s - 25*r + 204*s**2 - 161*s + 68) - 300*r*s + 100*r - 993*s**2 + 762*s - 331)) - 10*fd**2*(4*C*(50*r*(3*s - 1) + 408*s**2 - 322*s + 25) - 100*r*(3*s - 1) - 993*s**2 + 762*s - 50)) + 9*D1*bd1*(D1*(f*s*(8*C*(10*r + 59*s - 13) - 40*r - 291*s + 52) - 2*fd*(4*C*(48*r*s - 12*r + 188*s**2 - 123*s + 17) - 96*r*s + 24*r - 466*s**2 + 291*s - 34)) - 4*Dd*f*(4*C*(48*r*s - 12*r + 188*s**2 - 134*s + 17) - 96*r*s + 24*r - 466*s**2 + 313*s - 34)) + 10*D1*f*(Dd*(f*(4*C*(92*r*s - 46*r + 328*s**2 - 351*s + 164) - 184*r*s + 92*r - 802*s**2 + 848*s - 401) - 4*fd*(C*(50*r*(12*s - 5) + 1632*s**2 - 1535*s + 347) - 300*r*s + 125*r - 993*s**2 + 915*s - 203)) + Ddd*f*(-4*C*(50*r*(2*s - 1) + 272*s**2 - 297*s + 136) + 100*r*(2*s - 1) + 662*s**2 - 712*s + 331)) - 10*Dd**2*f**2*(12*C*(50*r*(2*s - 1) + 272*s**2 - 297*s + 62) - 300*r*(2*s - 1) - 1986*s**2 + 2136*s - 431)))/(315*d**2*k2*k3**4) - 4*D1**2*Pk1*Pk3*ct**3*k1*k2**5*st**4*(1032*C*D1**2*b1*f*fd*r**2 + 2064*C*D1**2*b1*f*fd*r*s - 1032*C*D1**2*b1*f*fd*r + 1032*C*D1**2*b1*f*fd*s**2 - 1032*C*D1**2*b1*f*fd*s + 516*C*D1**2*b1*f*fd - 600*C*D1**2*b1*f*fdd*r**2 - 1200*C*D1**2*b1*f*fdd*r*s + 600*C*D1**2*b1*f*fdd*r - 600*C*D1**2*b1*f*fdd*s**2 + 600*C*D1**2*b1*f*fdd*s - 300*C*D1**2*b1*f*fdd - 600*C*D1**2*b1*fd**2*r**2 - 1200*C*D1**2*b1*fd**2*r*s + 600*C*D1**2*b1*fd**2*r - 600*C*D1**2*b1*fd**2*s**2 + 600*C*D1**2*b1*fd**2*s + 564*C*D1**2*f**2*fd*r**2 + 1128*C*D1**2*f**2*fd*r*s - 752*C*D1**2*f**2*fd*r + 564*C*D1**2*f**2*fd*s**2 - 752*C*D1**2*f**2*fd*s + 376*C*D1**2*f**2*fd - 300*C*D1**2*f**2*fdd*r**2 - 600*C*D1**2*f**2*fdd*r*s + 400*C*D1**2*f**2*fdd*r - 300*C*D1**2*f**2*fdd*s**2 + 400*C*D1**2*f**2*fdd*s - 200*C*D1**2*f**2*fdd - 600*C*D1**2*f*fd**2*r**2 - 1200*C*D1**2*f*fd**2*r*s + 800*C*D1**2*f*fd**2*r - 600*C*D1**2*f*fd**2*s**2 + 800*C*D1**2*f*fd**2*s - 200*C*D1**2*f*fd**2 + 2064*C*D1*Dd*b1*f**2*r**2 + 4128*C*D1*Dd*b1*f**2*r*s - 3096*C*D1*Dd*b1*f**2*r + 2064*C*D1*Dd*b1*f**2*s**2 - 3096*C*D1*Dd*b1*f**2*s + 1548*C*D1*Dd*b1*f**2 - 4800*C*D1*Dd*b1*f*fd*r**2 - 9600*C*D1*Dd*b1*f*fd*r*s + 6000*C*D1*Dd*b1*f*fd*r - 4800*C*D1*Dd*b1*f*fd*s**2 + 6000*C*D1*Dd*b1*f*fd*s - 1800*C*D1*Dd*b1*f*fd + 752*C*D1*Dd*f**3*r**2 + 1504*C*D1*Dd*f**3*r*s - 1128*C*D1*Dd*f**3*r + 752*C*D1*Dd*f**3*s**2 - 1128*C*D1*Dd*f**3*s + 564*C*D1*Dd*f**3 - 2400*C*D1*Dd*f**2*fd*r**2 - 4800*C*D1*Dd*f**2*fd*r*s + 3400*C*D1*Dd*f**2*fd*r - 2400*C*D1*Dd*f**2*fd*s**2 + 3400*C*D1*Dd*f**2*fd*s - 1200*C*D1*Dd*f**2*fd - 1200*C*D1*Ddd*b1*f**2*r**2 - 2400*C*D1*Ddd*b1*f**2*r*s + 1800*C*D1*Ddd*b1*f**2*r - 1200*C*D1*Ddd*b1*f**2*s**2 + 1800*C*D1*Ddd*b1*f**2*s - 900*C*D1*Ddd*b1*f**2 - 400*C*D1*Ddd*f**3*r**2 - 800*C*D1*Ddd*f**3*r*s + 600*C*D1*Ddd*f**3*r - 400*C*D1*Ddd*f**3*s**2 + 600*C*D1*Ddd*f**3*s - 300*C*D1*Ddd*f**3 - 3600*C*Dd**2*b1*f**2*r**2 - 7200*C*Dd**2*b1*f**2*r*s + 5400*C*Dd**2*b1*f**2*r - 3600*C*Dd**2*b1*f**2*s**2 + 5400*C*Dd**2*b1*f**2*s - 1800*C*Dd**2*b1*f**2 - 1200*C*Dd**2*f**3*r**2 - 2400*C*Dd**2*f**3*r*s + 1800*C*Dd**2*f**3*r - 1200*C*Dd**2*f**3*s**2 + 1800*C*Dd**2*f**3*s - 600*C*Dd**2*f**3 - 852*D1**2*b1*f*fd*r**2 - 1704*D1**2*b1*f*fd*r*s + 852*D1**2*b1*f*fd*r - 852*D1**2*b1*f*fd*s**2 + 852*D1**2*b1*f*fd*s - 426*D1**2*b1*f*fd + 510*D1**2*b1*f*fdd*r**2 + 1020*D1**2*b1*f*fdd*r*s - 510*D1**2*b1*f*fdd*r + 510*D1**2*b1*f*fdd*s**2 - 510*D1**2*b1*f*fdd*s + 255*D1**2*b1*f*fdd + 510*D1**2*b1*fd**2*r**2 + 1020*D1**2*b1*fd**2*r*s - 510*D1**2*b1*fd**2*r + 510*D1**2*b1*fd**2*s**2 - 510*D1**2*b1*fd**2*s - 15*D1**2*bdd1*f**2*(20*C - 17)*(r + s - 1)**2 - 474*D1**2*f**2*fd*r**2 - 948*D1**2*f**2*fd*r*s + 632*D1**2*f**2*fd*r - 474*D1**2*f**2*fd*s**2 + 632*D1**2*f**2*fd*s - 316*D1**2*f**2*fd + 255*D1**2*f**2*fdd*r**2 + 510*D1**2*f**2*fdd*r*s - 340*D1**2*f**2*fdd*r + 255*D1**2*f**2*fdd*s**2 - 340*D1**2*f**2*fdd*s + 170*D1**2*f**2*fdd + 510*D1**2*f*fd**2*r**2 + 1020*D1**2*f*fd**2*r*s - 680*D1**2*f*fd**2*r + 510*D1**2*f*fd**2*s**2 - 680*D1**2*f*fd**2*s + 170*D1**2*f*fd**2 - 1704*D1*Dd*b1*f**2*r**2 - 3408*D1*Dd*b1*f**2*r*s + 2556*D1*Dd*b1*f**2*r - 1704*D1*Dd*b1*f**2*s**2 + 2556*D1*Dd*b1*f**2*s - 1278*D1*Dd*b1*f**2 + 4080*D1*Dd*b1*f*fd*r**2 + 8160*D1*Dd*b1*f*fd*r*s - 5100*D1*Dd*b1*f*fd*r + 4080*D1*Dd*b1*f*fd*s**2 - 5100*D1*Dd*b1*f*fd*s + 1530*D1*Dd*b1*f*fd - 632*D1*Dd*f**3*r**2 - 1264*D1*Dd*f**3*r*s + 948*D1*Dd*f**3*r - 632*D1*Dd*f**3*s**2 + 948*D1*Dd*f**3*s - 474*D1*Dd*f**3 + 2040*D1*Dd*f**2*fd*r**2 + 4080*D1*Dd*f**2*fd*r*s - 2890*D1*Dd*f**2*fd*r + 2040*D1*Dd*f**2*fd*s**2 - 2890*D1*Dd*f**2*fd*s + 1020*D1*Dd*f**2*fd + 1020*D1*Ddd*b1*f**2*r**2 + 2040*D1*Ddd*b1*f**2*r*s - 1530*D1*Ddd*b1*f**2*r + 1020*D1*Ddd*b1*f**2*s**2 - 1530*D1*Ddd*b1*f**2*s + 765*D1*Ddd*b1*f**2 + 340*D1*Ddd*f**3*r**2 + 680*D1*Ddd*f**3*r*s - 510*D1*Ddd*f**3*r + 340*D1*Ddd*f**3*s**2 - 510*D1*Ddd*f**3*s + 255*D1*Ddd*f**3 + 6*D1*bd1*f*(r + s - 1)*(D1*f*(86*C - 71)*(r + s - 1) - D1*fd*(100*C - 85)*(2*r + 2*s - 1) - Dd*f*(100*C - 85)*(4*r + 4*s - 3)) + 3060*Dd**2*b1*f**2*r**2 + 6120*Dd**2*b1*f**2*r*s - 4590*Dd**2*b1*f**2*r + 3060*Dd**2*b1*f**2*s**2 - 4590*Dd**2*b1*f**2*s + 1530*Dd**2*b1*f**2 + 1020*Dd**2*f**3*r**2 + 2040*Dd**2*f**3*r*s - 1530*Dd**2*f**3*r + 1020*Dd**2*f**3*s**2 - 1530*Dd**2*f**3*s + 510*Dd**2*f**3)/(35*d**2*k3**8) + 8*D1**2*Pk1*Pk3*ct**3*k1*k2**5*st**2*(5346*C*D1**2*f**2*fd*r**2 + 10692*C*D1**2*f**2*fd*r*s - 7128*C*D1**2*f**2*fd*r + 5346*C*D1**2*f**2*fd*s**2 - 7128*C*D1**2*f**2*fd*s + 3564*C*D1**2*f**2*fd + 7128*C*D1*Dd*f**3*r**2 + 14256*C*D1*Dd*f**3*r*s - 10692*C*D1*Dd*f**3*r + 7128*C*D1*Dd*f**3*s**2 - 10692*C*D1*Dd*f**3*s + 5346*C*D1*Dd*f**3 + 1188*D1**2*K*bdd1*f**2*r**2 + 2376*D1**2*K*bdd1*f**2*r*s - 2376*D1**2*K*bdd1*f**2*r + 1188*D1**2*K*bdd1*f**2*s**2 - 2376*D1**2*K*bdd1*f**2*s + 1188*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(-28*K + 25*f + 21)*(r + s - 1)**2 + 1375*D1**2*bdd1*f**3*r**2 + 2750*D1**2*bdd1*f**3*r*s - 2750*D1**2*bdd1*f**3*r + 1375*D1**2*bdd1*f**3*s**2 - 2750*D1**2*bdd1*f**3*s + 1375*D1**2*bdd1*f**3 - 891*D1**2*bdd1*f**2*r**2 - 1782*D1**2*bdd1*f**2*r*s + 1782*D1**2*bdd1*f**2*r - 891*D1**2*bdd1*f**2*s**2 + 1782*D1**2*bdd1*f**2*s - 891*D1**2*bdd1*f**2 - 5544*D1**2*bdd1*f*g2*r**2 - 11088*D1**2*bdd1*f*g2*r*s + 11088*D1**2*bdd1*f*g2*r - 5544*D1**2*bdd1*f*g2*s**2 + 11088*D1**2*bdd1*f*g2*s - 5544*D1**2*bdd1*f*g2 - 8940*D1**2*f**3*fd*r**2 - 17880*D1**2*f**3*fd*r*s + 13410*D1**2*f**3*fd*r - 8940*D1**2*f**3*fd*s**2 + 13410*D1**2*f**3*fd*s - 6705*D1**2*f**3*fd + 7000*D1**2*f**3*fdd*r**2 + 14000*D1**2*f**3*fdd*r*s - 10500*D1**2*f**3*fdd*r + 7000*D1**2*f**3*fdd*s**2 - 10500*D1**2*f**3*fdd*s + 5250*D1**2*f**3*fdd + 21000*D1**2*f**2*fd**2*r**2 + 42000*D1**2*f**2*fd**2*r*s - 31500*D1**2*f**2*fd**2*r + 21000*D1**2*f**2*fd**2*s**2 - 31500*D1**2*f**2*fd**2*s + 10500*D1**2*f**2*fd**2 - 4455*D1**2*f**2*fd*r**2 - 8910*D1**2*f**2*fd*r*s + 5940*D1**2*f**2*fd*r - 4455*D1**2*f**2*fd*s**2 + 5940*D1**2*f**2*fd*s - 2970*D1**2*f**2*fd + 4290*D1**2*f**2*gd2*r**2 + 8580*D1**2*f**2*gd2*r*s - 8580*D1**2*f**2*gd2*r + 4290*D1**2*f**2*gd2*s**2 - 8580*D1**2*f**2*gd2*s + 4290*D1**2*f**2*gd2 - 2376*D1**2*f**2*gdd2*r**2 - 4752*D1**2*f**2*gdd2*r*s + 4752*D1**2*f**2*gdd2*r - 2376*D1**2*f**2*gdd2*s**2 + 4752*D1**2*f**2*gdd2*s - 2376*D1**2*f**2*gdd2 + 8580*D1**2*f*fd*g2*r**2 + 17160*D1**2*f*fd*g2*r*s - 8580*D1**2*f*fd*g2*r + 8580*D1**2*f*fd*g2*s**2 - 8580*D1**2*f*fd*g2*s + 4290*D1**2*f*fd*g2 - 9504*D1**2*f*fd*gd2*r**2 - 19008*D1**2*f*fd*gd2*r*s + 14256*D1**2*f*fd*gd2*r - 9504*D1**2*f*fd*gd2*s**2 + 14256*D1**2*f*fd*gd2*s - 4752*D1**2*f*fd*gd2 - 4752*D1**2*f*fdd*g2*r**2 - 9504*D1**2*f*fdd*g2*r*s + 4752*D1**2*f*fdd*g2*r - 4752*D1**2*f*fdd*g2*s**2 + 4752*D1**2*f*fdd*g2*s - 2376*D1**2*f*fdd*g2 - 4752*D1**2*fd**2*g2*r**2 - 9504*D1**2*fd**2*g2*r*s + 4752*D1**2*fd**2*g2*r - 4752*D1**2*fd**2*g2*s**2 + 4752*D1**2*fd**2*g2*s - 8940*D1*Dd*f**4*r**2 - 17880*D1*Dd*f**4*r*s + 13410*D1*Dd*f**4*r - 8940*D1*Dd*f**4*s**2 + 13410*D1*Dd*f**4*s - 6705*D1*Dd*f**4 + 56000*D1*Dd*f**3*fd*r**2 + 112000*D1*Dd*f**3*fd*r*s - 84000*D1*Dd*f**3*fd*r + 56000*D1*Dd*f**3*fd*s**2 - 84000*D1*Dd*f**3*fd*s + 31500*D1*Dd*f**3*fd - 5940*D1*Dd*f**3*r**2 - 11880*D1*Dd*f**3*r*s + 8910*D1*Dd*f**3*r - 5940*D1*Dd*f**3*s**2 + 8910*D1*Dd*f**3*s - 4455*D1*Dd*f**3 + 17160*D1*Dd*f**2*g2*r**2 + 34320*D1*Dd*f**2*g2*r*s - 25740*D1*Dd*f**2*g2*r + 17160*D1*Dd*f**2*g2*s**2 - 25740*D1*Dd*f**2*g2*s + 12870*D1*Dd*f**2*g2 - 19008*D1*Dd*f**2*gd2*r**2 - 38016*D1*Dd*f**2*gd2*r*s + 33264*D1*Dd*f**2*gd2*r - 19008*D1*Dd*f**2*gd2*s**2 + 33264*D1*Dd*f**2*gd2*s - 14256*D1*Dd*f**2*gd2 - 38016*D1*Dd*f*fd*g2*r**2 - 76032*D1*Dd*f*fd*g2*r*s + 47520*D1*Dd*f*fd*g2*r - 38016*D1*Dd*f*fd*g2*s**2 + 47520*D1*Dd*f*fd*g2*s - 14256*D1*Dd*f*fd*g2 + 7000*D1*Ddd*f**4*r**2 + 14000*D1*Ddd*f**4*r*s - 10500*D1*Ddd*f**4*r + 7000*D1*Ddd*f**4*s**2 - 10500*D1*Ddd*f**4*s + 5250*D1*Ddd*f**4 - 9504*D1*Ddd*f**2*g2*r**2 - 19008*D1*Ddd*f**2*g2*r*s + 14256*D1*Ddd*f**2*g2*r - 9504*D1*Ddd*f**2*g2*s**2 + 14256*D1*Ddd*f**2*g2*s - 7128*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(97*f**3*(r + s - 1) + f**2*(-378*C*(r + s - 1) - 250*fd*(3*r + 3*s - 2) + (195*K + 174)*(r + s - 1)) - 6*f*(9*fd*(4*K - 3)*(2*r + 2*s - 1) + (133*g2 - 168*gd2)*(r + s - 1)) + 1008*fd*g2*(r + s)) - 2*Dd*f*(125*f**2 + 27*f*(4*K - 3) - 504*g2)*(4*r + 4*s - 3))*(r + s - 1) + 21000*Dd**2*f**4*r**2 + 42000*Dd**2*f**4*r*s - 31500*Dd**2*f**4*r + 21000*Dd**2*f**4*s**2 - 31500*Dd**2*f**4*s + 10500*Dd**2*f**4 - 28512*Dd**2*f**2*g2*r**2 - 57024*Dd**2*f**2*g2*r*s + 42768*Dd**2*f**2*g2*r - 28512*Dd**2*f**2*g2*s**2 + 42768*Dd**2*f**2*g2*s - 14256*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(3*f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 7*fd*(19*K - 13)*(r + s) - 21*fdd*(4*K - 3)*(r + s))) + D1*(Dd*(108*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(150*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (133*K - 91)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(4*K - 3)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-28*K + 25*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-28*K + 25*f + 21)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(756*C*D1**2*f*fd*r**2 + 1512*C*D1**2*f*fd*r*s - 756*C*D1**2*f*fd*r + 756*C*D1**2*f*fd*s**2 - 756*C*D1**2*f*fd*s + 378*C*D1**2*f*fd + 1512*C*D1*Dd*f**2*r**2 + 3024*C*D1*Dd*f**2*r*s - 2268*C*D1*Dd*f**2*r + 1512*C*D1*Dd*f**2*s**2 - 2268*C*D1*Dd*f**2*s + 1134*C*D1*Dd*f**2 - 390*D1**2*K*f*fd*r**2 - 780*D1**2*K*f*fd*r*s + 390*D1**2*K*f*fd*r - 390*D1**2*K*f*fd*s**2 + 390*D1**2*K*f*fd*s - 195*D1**2*K*f*fd + 216*D1**2*K*f*fdd*r**2 + 432*D1**2*K*f*fdd*r*s - 216*D1**2*K*f*fdd*r + 216*D1**2*K*f*fdd*s**2 - 216*D1**2*K*f*fdd*s + 108*D1**2*K*f*fdd + 216*D1**2*K*fd**2*r**2 + 432*D1**2*K*fd**2*r*s - 216*D1**2*K*fd**2*r + 216*D1**2*K*fd**2*s**2 - 216*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(-28*K + 25*f + 21)*(r + s - 1)**2 - 291*D1**2*f**2*fd*r**2 - 582*D1**2*f**2*fd*r*s + 388*D1**2*f**2*fd*r - 291*D1**2*f**2*fd*s**2 + 388*D1**2*f**2*fd*s - 194*D1**2*f**2*fd + 375*D1**2*f**2*fdd*r**2 + 750*D1**2*f**2*fdd*r*s - 500*D1**2*f**2*fdd*r + 375*D1**2*f**2*fdd*s**2 - 500*D1**2*f**2*fdd*s + 250*D1**2*f**2*fdd + 750*D1**2*f*fd**2*r**2 + 1500*D1**2*f*fd**2*r*s - 1000*D1**2*f*fd**2*r + 750*D1**2*f*fd**2*s**2 - 1000*D1**2*f*fd**2*s + 250*D1**2*f*fd**2 - 348*D1**2*f*fd*r**2 - 696*D1**2*f*fd*r*s + 348*D1**2*f*fd*r - 348*D1**2*f*fd*s**2 + 348*D1**2*f*fd*s - 174*D1**2*f*fd - 162*D1**2*f*fdd*r**2 - 324*D1**2*f*fdd*r*s + 162*D1**2*f*fdd*r - 162*D1**2*f*fdd*s**2 + 162*D1**2*f*fdd*s - 81*D1**2*f*fdd + 798*D1**2*f*gd2*r**2 + 1596*D1**2*f*gd2*r*s - 1596*D1**2*f*gd2*r + 798*D1**2*f*gd2*s**2 - 1596*D1**2*f*gd2*s + 798*D1**2*f*gd2 - 504*D1**2*f*gdd2*r**2 - 1008*D1**2*f*gdd2*r*s + 1008*D1**2*f*gdd2*r - 504*D1**2*f*gdd2*s**2 + 1008*D1**2*f*gdd2*s - 504*D1**2*f*gdd2 - 162*D1**2*fd**2*r**2 - 324*D1**2*fd**2*r*s + 162*D1**2*fd**2*r - 162*D1**2*fd**2*s**2 + 162*D1**2*fd**2*s + 798*D1**2*fd*g2*r**2 + 1596*D1**2*fd*g2*r*s + 798*D1**2*fd*g2*s**2 - 1008*D1**2*fd*gd2*r**2 - 2016*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 1008*D1**2*fd*gd2*s**2 + 1008*D1**2*fd*gd2*s - 504*D1**2*fdd*g2*r**2 - 1008*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*s**2 - 780*D1*Dd*K*f**2*r**2 - 1560*D1*Dd*K*f**2*r*s + 1170*D1*Dd*K*f**2*r - 780*D1*Dd*K*f**2*s**2 + 1170*D1*Dd*K*f**2*s - 585*D1*Dd*K*f**2 + 1728*D1*Dd*K*f*fd*r**2 + 3456*D1*Dd*K*f*fd*r*s - 2160*D1*Dd*K*f*fd*r + 1728*D1*Dd*K*f*fd*s**2 - 2160*D1*Dd*K*f*fd*s + 648*D1*Dd*K*f*fd - 388*D1*Dd*f**3*r**2 - 776*D1*Dd*f**3*r*s + 582*D1*Dd*f**3*r - 388*D1*Dd*f**3*s**2 + 582*D1*Dd*f**3*s - 291*D1*Dd*f**3 + 3000*D1*Dd*f**2*fd*r**2 + 6000*D1*Dd*f**2*fd*r*s - 4250*D1*Dd*f**2*fd*r + 3000*D1*Dd*f**2*fd*s**2 - 4250*D1*Dd*f**2*fd*s + 1500*D1*Dd*f**2*fd - 696*D1*Dd*f**2*r**2 - 1392*D1*Dd*f**2*r*s + 1044*D1*Dd*f**2*r - 696*D1*Dd*f**2*s**2 + 1044*D1*Dd*f**2*s - 522*D1*Dd*f**2 - 1296*D1*Dd*f*fd*r**2 - 2592*D1*Dd*f*fd*r*s + 1620*D1*Dd*f*fd*r - 1296*D1*Dd*f*fd*s**2 + 1620*D1*Dd*f*fd*s - 486*D1*Dd*f*fd + 3192*D1*Dd*f*g2*r**2 + 6384*D1*Dd*f*g2*r*s - 4788*D1*Dd*f*g2*r + 3192*D1*Dd*f*g2*s**2 - 4788*D1*Dd*f*g2*s + 2394*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r**2 - 8064*D1*Dd*f*gd2*r*s + 7056*D1*Dd*f*gd2*r - 4032*D1*Dd*f*gd2*s**2 + 7056*D1*Dd*f*gd2*s - 3024*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r**2 - 8064*D1*Dd*fd*g2*r*s + 3024*D1*Dd*fd*g2*r - 4032*D1*Dd*fd*g2*s**2 + 3024*D1*Dd*fd*g2*s + 432*D1*Ddd*K*f**2*r**2 + 864*D1*Ddd*K*f**2*r*s - 648*D1*Ddd*K*f**2*r + 432*D1*Ddd*K*f**2*s**2 - 648*D1*Ddd*K*f**2*s + 324*D1*Ddd*K*f**2 + 500*D1*Ddd*f**3*r**2 + 1000*D1*Ddd*f**3*r*s - 750*D1*Ddd*f**3*r + 500*D1*Ddd*f**3*s**2 - 750*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 - 324*D1*Ddd*f**2*r**2 - 648*D1*Ddd*f**2*r*s + 486*D1*Ddd*f**2*r - 324*D1*Ddd*f**2*s**2 + 486*D1*Ddd*f**2*s - 243*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r**2 - 4032*D1*Ddd*f*g2*r*s + 3024*D1*Ddd*f*g2*r - 2016*D1*Ddd*f*g2*s**2 + 3024*D1*Ddd*f*g2*s - 1512*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(108*f**2*(r + s - 1) - 150*f*fd*(2*r + 2*s - 1) - 7*f*(19*K - 13)*(r + s - 1) + 42*fd*(4*K - 3)*(r + s)) - 6*Dd*f*(-28*K + 25*f + 21)*(4*r + 4*s - 3))*(r + s - 1) + 1296*Dd**2*K*f**2*r**2 + 2592*Dd**2*K*f**2*r*s - 1944*Dd**2*K*f**2*r + 1296*Dd**2*K*f**2*s**2 - 1944*Dd**2*K*f**2*s + 648*Dd**2*K*f**2 + 1500*Dd**2*f**3*r**2 + 3000*Dd**2*f**3*r*s - 2250*Dd**2*f**3*r + 1500*Dd**2*f**3*s**2 - 2250*Dd**2*f**3*s + 750*Dd**2*f**3 - 972*Dd**2*f**2*r**2 - 1944*Dd**2*f**2*r*s + 1458*Dd**2*f**2*r - 972*Dd**2*f**2*s**2 + 1458*Dd**2*f**2*s - 486*Dd**2*f**2 - 6048*Dd**2*f*g2*r**2 - 12096*Dd**2*f*g2*r*s + 9072*Dd**2*f*g2*r - 6048*Dd**2*f*g2*s**2 + 9072*Dd**2*f*g2*s - 3024*Dd**2*f*g2))/(1155*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**3*k1*k2**3*st**4*(b1*(D1**2*(f*(fd*(166*C - 136) + fdd*(75 - 90*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(75 - 90*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(166*C - 136)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(75 - 90*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(75 - 90*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(75 - 90*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(58*C - 48)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (30*C - 25)*(3*bdd1*s*(r + s - 1) + fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(25 - 30*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(166*C - 136)*(r + s - 1) - fd*(90*C - 75)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(75 - 90*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(58*C - 48)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(30*C - 25)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(25 - 30*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(25 - 30*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**3*k1*k2**3*st**2*(42*b1**2*(D1**2*(fd*(26*C - 20) + fdd*(15 - 18*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(13*C - 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(15 - 18*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(15 - 18*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(108*C - 90)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-2740*C*D1**2*f*fd*r**2 - 6264*C*D1**2*f*fd*r*s + 2756*C*D1**2*f*fd*r - 3524*C*D1**2*f*fd*s**2 + 3148*C*D1**2*f*fd*s - 1574*C*D1**2*f*fd + 2700*C*D1**2*f*fdd*r**2 + 6072*C*D1**2*f*fdd*r*s - 2820*C*D1**2*f*fdd*r + 3372*C*D1**2*f*fdd*s**2 - 3156*C*D1**2*f*fdd*s + 1578*C*D1**2*f*fdd + 2700*C*D1**2*fd**2*r**2 + 6072*C*D1**2*fd**2*r*s - 2820*C*D1**2*fd**2*r + 3372*C*D1**2*fd**2*s**2 - 3156*C*D1**2*fd**2*s - 216*C*D1**2*fd**2 - 5480*C*D1*Dd*f**2*r**2 - 12528*C*D1*Dd*f**2*r*s + 9004*C*D1*Dd*f**2*r - 7048*C*D1*Dd*f**2*s**2 + 10180*C*D1*Dd*f**2*s - 4894*C*D1*Dd*f**2 + 21600*C*D1*Dd*f*fd*r**2 + 48576*C*D1*Dd*f*fd*r*s - 28824*C*D1*Dd*f*fd*r + 26976*C*D1*Dd*f*fd*s**2 - 32184*C*D1*Dd*f*fd*s + 9132*C*D1*Dd*f*fd + 5400*C*D1*Ddd*f**2*r**2 + 12144*C*D1*Ddd*f**2*r*s - 8772*C*D1*Ddd*f**2*r + 6744*C*D1*Ddd*f**2*s**2 - 9780*C*D1*Ddd*f**2*s + 4722*C*D1*Ddd*f**2 + 16200*C*Dd**2*f**2*r**2 + 36432*C*Dd**2*f**2*r*s - 26316*C*Dd**2*f**2*r + 20232*C*Dd**2*f**2*s**2 - 29340*C*Dd**2*f**2*s + 9444*C*Dd**2*f**2 - 42*D1**2*bdd1*f*(6*C - 5)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2206*D1**2*f*fd*r**2 + 5172*D1**2*f*fd*r*s - 2282*D1**2*f*fd*r + 2966*D1**2*f*fd*s**2 - 2662*D1**2*f*fd*s + 1331*D1**2*f*fd - 2202*D1**2*f*fdd*r**2 - 5148*D1**2*f*fdd*r*s + 2394*D1**2*f*fdd*r - 2946*D1**2*f*fdd*s**2 + 2766*D1**2*f*fdd*s - 1383*D1**2*f*fdd - 2202*D1**2*fd**2*r**2 - 5148*D1**2*fd**2*r*s + 2394*D1**2*fd**2*r - 2946*D1**2*fd**2*s**2 + 2766*D1**2*fd**2*s + 180*D1**2*fd**2 + 4412*D1*Dd*f**2*r**2 + 10344*D1*Dd*f**2*r*s - 7378*D1*Dd*f**2*r + 5932*D1*Dd*f**2*s**2 - 8518*D1*Dd*f**2*s + 4069*D1*Dd*f**2 - 17616*D1*Dd*f*fd*r**2 - 41184*D1*Dd*f*fd*r*s + 24276*D1*Dd*f*fd*r - 23568*D1*Dd*f*fd*s**2 + 27996*D1*Dd*f*fd*s - 7926*D1*Dd*f*fd - 4404*D1*Ddd*f**2*r**2 - 10296*D1*Ddd*f**2*r*s + 7350*D1*Ddd*f**2*r - 5892*D1*Ddd*f**2*s**2 + 8466*D1*Ddd*f**2*s - 4047*D1*Ddd*f**2 + 28*D1*bd1*(D1*(f*(13*C - 10)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(15 - 18*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(15 - 18*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 13212*Dd**2*f**2*r**2 - 30888*Dd**2*f**2*r*s + 22050*Dd**2*f**2*r - 17676*Dd**2*f**2*s**2 + 25398*Dd**2*f**2*s - 8094*Dd**2*f**2) + f*(-11238*C*D1**2*f*fd*r**2 - 20076*C*D1**2*f*fd*r*s + 14184*C*D1**2*f*fd*r - 8838*C*D1**2*f*fd*s**2 + 12584*C*D1**2*f*fd*s - 6692*C*D1**2*f*fd + 9210*C*D1**2*f*fdd*r**2 + 16788*C*D1**2*f*fdd*r*s - 11736*C*D1**2*f*fdd*r + 7578*C*D1**2*f*fdd*s**2 - 10648*C*D1**2*f*fdd*s + 5596*C*D1**2*f*fdd + 18420*C*D1**2*fd**2*r**2 + 33576*C*D1**2*fd**2*r*s - 23472*C*D1**2*fd**2*r + 15156*C*D1**2*fd**2*s**2 - 21296*C*D1**2*fd**2*s + 5596*C*D1**2*fd**2 - 14984*C*D1*Dd*f**2*r**2 - 26768*C*D1*Dd*f**2*r*s + 20876*C*D1*Dd*f**2*r - 11784*C*D1*Dd*f**2*s**2 + 18476*C*D1*Dd*f**2*s - 9638*C*D1*Dd*f**2 + 73680*C*D1*Dd*f*fd*r**2 + 134304*C*D1*Dd*f*fd*r*s - 98940*C*D1*Dd*f*fd*r + 60624*C*D1*Dd*f*fd*s**2 - 89692*C*D1*Dd*f*fd*s + 33032*C*D1*Dd*f*fd + 12280*C*D1*Ddd*f**2*r**2 + 22384*C*D1*Ddd*f**2*r*s - 17332*C*D1*Ddd*f**2*r + 10104*C*D1*Ddd*f**2*s**2 - 15700*C*D1*Ddd*f**2*s + 8122*C*D1*Ddd*f**2 + 36840*C*Dd**2*f**2*r**2 + 67152*C*Dd**2*f**2*r*s - 51996*C*Dd**2*f**2*r + 30312*C*Dd**2*f**2*s**2 - 47100*C*Dd**2*f**2*s + 16244*C*Dd**2*f**2 - 252*D1**2*bd1**2*(6*C - 5)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(2*C*(225*r**2 + 506*r*s - 486*r + 281*s**2 - 542*s + 243) - 367*r**2 - 858*r*s + 794*r - 491*s**2 + 918*s - 397) + 8895*D1**2*f*fd*r**2 + 16422*D1**2*f*fd*r*s - 11404*D1**2*f*fd*r + 7527*D1**2*f*fd*s**2 - 10492*D1**2*f*fd*s + 5474*D1**2*f*fd - 7323*D1**2*f*fdd*r**2 - 13962*D1**2*f*fdd*r*s + 9536*D1**2*f*fdd*r - 6639*D1**2*f*fdd*s**2 + 9080*D1**2*f*fdd*s - 4654*D1**2*f*fdd - 14646*D1**2*fd**2*r**2 - 27924*D1**2*fd**2*r*s + 19072*D1**2*fd**2*r - 13278*D1**2*fd**2*s**2 + 18160*D1**2*fd**2*s - 4654*D1**2*fd**2 + 11860*D1*Dd*f**2*r**2 + 21896*D1*Dd*f**2*r*s - 16878*D1*Dd*f**2*r + 10036*D1*Dd*f**2*s**2 - 15510*D1*Dd*f**2*s + 7983*D1*Dd*f**2 - 58584*D1*Dd*f*fd*r**2 - 111696*D1*Dd*f*fd*r*s + 80714*D1*Dd*f*fd*r - 53112*D1*Dd*f*fd*s**2 + 76838*D1*Dd*f*fd*s - 27696*D1*Dd*f*fd - 9764*D1*Ddd*f**2*r**2 - 18616*D1*Ddd*f**2*r*s + 14190*D1*Ddd*f**2*r - 8852*D1*Ddd*f**2*s**2 + 13506*D1*Ddd*f**2*s - 6867*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(2*C*(685*r**2 + 2*r*(783*s - 779) + 881*s**2 - 1754*s + 779) - 1103*r**2 - 2586*r*s + 2510*r - 1483*s**2 + 2890*s - 1255) - 6*fd*(2*C*(450*r**2 + 1012*r*s - 721*r + 562*s**2 - 805*s + 271) - 734*r**2 - 1716*r*s + 1193*r - 982*s**2 + 1379*s - 459)) - 6*Dd*f*(2*C*(900*r**2 + 2024*r*s - 1703*r + 1124*s**2 - 1899*s + 785) - 1468*r**2 - 3432*r*s + 2813*r - 1964*s**2 + 3247*s - 1315)) - 29292*Dd**2*f**2*r**2 - 55848*Dd**2*f**2*r*s + 42570*Dd**2*f**2*r - 26556*Dd**2*f**2*s**2 + 40518*Dd**2*f**2*s - 13734*Dd**2*f**2))/(315*d**2*k3**6) + 2*D1**2*Pk1*Pk3*ct**3*k1*k2**3*(-16632*C*D1**2*bd1*f**2*r**2 - 16632*C*D1**2*bd1*f**2*r*s + 44352*C*D1**2*bd1*f**2*r + 27720*C*D1**2*bd1*f**2*s - 22176*C*D1**2*bd1*f**2 - 47520*C*D1**2*f**2*fd*r**2 - 59400*C*D1**2*f**2*fd*r*s + 51480*C*D1**2*f**2*fd*r - 11880*C*D1**2*f**2*fd*s**2 + 27720*C*D1**2*f**2*fd*s - 19800*C*D1**2*f**2*fd - 63360*C*D1*Dd*f**3*r**2 - 79200*C*D1*Dd*f**3*r*s + 71280*C*D1*Dd*f**3*r - 15840*C*D1*Dd*f**3*s**2 + 35640*C*D1*Dd*f**3*s - 23760*C*D1*Dd*f**3 - 68376*D1**2*K*bd1**2*f*r**2 - 136752*D1**2*K*bd1**2*f*r*s + 147840*D1**2*K*bd1**2*f*r - 68376*D1**2*K*bd1**2*f*s**2 + 147840*D1**2*K*bd1**2*f*s - 79464*D1**2*K*bd1**2*f + 42372*D1**2*K*bd1*f**2*r**2 + 60588*D1**2*K*bd1*f**2*r*s - 60588*D1**2*K*bd1*f**2*r + 18216*D1**2*K*bd1*f**2*s**2 - 36432*D1**2*K*bd1*f**2*s + 18216*D1**2*K*bd1*f**2 - 134640*D1**2*K*bd1*f*fd*r**2 - 237600*D1**2*K*bd1*f*fd*r*s + 186120*D1**2*K*bd1*f*fd*r - 102960*D1**2*K*bd1*f*fd*s**2 + 162360*D1**2*K*bd1*f*fd*s - 59400*D1**2*K*bd1*f*fd - 33660*D1**2*K*bdd1*f**2*r**2 - 59400*D1**2*K*bdd1*f**2*r*s + 59400*D1**2*K*bdd1*f**2*r - 25740*D1**2*K*bdd1*f**2*s**2 + 51480*D1**2*K*bdd1*f**2*s - 25740*D1**2*K*bdd1*f**2 + 40986*D1**2*bd1**2*f**2*r**2 + 93060*D1**2*bd1**2*f**2*r*s - 87516*D1**2*bd1**2*f**2*r + 52074*D1**2*bd1**2*f**2*s**2 - 98604*D1**2*bd1**2*f**2*s + 46530*D1**2*bd1**2*f**2 + 51282*D1**2*bd1**2*f*r**2 + 113652*D1**2*bd1**2*f*r*s - 116424*D1**2*bd1**2*f*r + 62370*D1**2*bd1**2*f*s**2 - 127512*D1**2*bd1**2*f*s + 65142*D1**2*bd1**2*f - 36960*D1**2*bd1**2*g2*r**2 - 73920*D1**2*bd1**2*g2*r*s + 36960*D1**2*bd1**2*g2*r - 36960*D1**2*bd1**2*g2*s**2 + 36960*D1**2*bd1**2*g2*s - 11088*D1**2*bd1*bd2*f*r**2 - 22176*D1**2*bd1*bd2*f*r*s + 22176*D1**2*bd1*bd2*f*r - 11088*D1**2*bd1*bd2*f*s**2 + 22176*D1**2*bd1*bd2*f*s - 11088*D1**2*bd1*bd2*f - 11660*D1**2*bd1*f**3*r**2 - 9680*D1**2*bd1*f**3*r*s + 18700*D1**2*bd1*f**3*r + 1980*D1**2*bd1*f**3*s**2 + 5060*D1**2*bd1*f**3*s - 8690*D1**2*bd1*f**3 + 70620*D1**2*bd1*f**2*fd*r**2 + 64680*D1**2*bd1*f**2*fd*r*s - 85580*D1**2*bd1*f**2*fd*r - 5940*D1**2*bd1*f**2*fd*s**2 - 21780*D1**2*bd1*f**2*fd*s + 13640*D1**2*bd1*f**2*fd - 14157*D1**2*bd1*f**2*r**2 - 29502*D1**2*bd1*f**2*r*s + 7326*D1**2*bd1*f**2*r - 15345*D1**2*bd1*f**2*s**2 + 8514*D1**2*bd1*f**2*s + 2673*D1**2*bd1*f**2 + 96228*D1**2*bd1*f*fd*r**2 + 189288*D1**2*bd1*f*fd*r*s - 142758*D1**2*bd1*f*fd*r + 93060*D1**2*bd1*f*fd*s**2 - 140382*D1**2*bd1*f*fd*s + 47322*D1**2*bd1*f*fd - 62832*D1**2*bd1*f*g2*r**2 - 97944*D1**2*bd1*f*g2*r*s + 151536*D1**2*bd1*f*g2*r - 35112*D1**2*bd1*f*g2*s**2 + 123816*D1**2*bd1*f*g2*s - 75768*D1**2*bd1*f*g2 + 136752*D1**2*bd1*f*gd2*r**2 + 273504*D1**2*bd1*f*gd2*r*s - 295680*D1**2*bd1*f*gd2*r + 136752*D1**2*bd1*f*gd2*s**2 - 295680*D1**2*bd1*f*gd2*s + 158928*D1**2*bd1*f*gd2 + 136752*D1**2*bd1*fd*g2*r**2 + 273504*D1**2*bd1*fd*g2*r*s - 136752*D1**2*bd1*fd*g2*r + 136752*D1**2*bd1*fd*g2*s**2 - 136752*D1**2*bd1*fd*g2*s + 5148*D1**2*bd2*f**2*r**2 + 10296*D1**2*bd2*f**2*r*s - 10296*D1**2*bd2*f**2*r + 5148*D1**2*bd2*f**2*s**2 - 10296*D1**2*bd2*f**2*s + 5148*D1**2*bd2*f**2 - 15840*D1**2*bd2*f*fd*r**2 - 31680*D1**2*bd2*f*fd*r*s + 23760*D1**2*bd2*f*fd*r - 15840*D1**2*bd2*f*fd*s**2 + 23760*D1**2*bd2*f*fd*s - 7920*D1**2*bd2*f*fd + 11770*D1**2*bdd1*f**3*r**2 + 10780*D1**2*bdd1*f**3*r*s - 20240*D1**2*bdd1*f**3*r - 990*D1**2*bdd1*f**3*s**2 - 7480*D1**2*bdd1*f**3*s + 10780*D1**2*bdd1*f**3 + 24057*D1**2*bdd1*f**2*r**2 + 47322*D1**2*bdd1*f**2*r*s - 47322*D1**2*bdd1*f**2*r + 23265*D1**2*bdd1*f**2*s**2 - 46530*D1**2*bdd1*f**2*s + 23265*D1**2*bdd1*f**2 + 68376*D1**2*bdd1*f*g2*r**2 + 136752*D1**2*bdd1*f*g2*r*s - 158928*D1**2*bdd1*f*g2*r + 68376*D1**2*bdd1*f*g2*s**2 - 158928*D1**2*bdd1*f*g2*s + 79464*D1**2*bdd1*f*g2 - 3960*D1**2*bdd2*f**2*r**2 - 7920*D1**2*bdd2*f**2*r*s + 7920*D1**2*bdd2*f**2*r - 3960*D1**2*bdd2*f**2*s**2 + 7920*D1**2*bdd2*f**2*s - 3960*D1**2*bdd2*f**2 + 28700*D1**2*f**3*fd*r**2 + 88760*D1**2*f**3*fd*r*s - 58730*D1**2*f**3*fd*r + 60060*D1**2*f**3*fd*s**2 - 82250*D1**2*f**3*fd*s + 37205*D1**2*f**3*fd - 28980*D1**2*f**3*fdd*r**2 - 98280*D1**2*f**3*fdd*r*s + 63630*D1**2*f**3*fdd*r - 69300*D1**2*f**3*fdd*s**2 + 93870*D1**2*f**3*fdd*s - 41895*D1**2*f**3*fdd - 86940*D1**2*f**2*fd**2*r**2 - 294840*D1**2*f**2*fd**2*r*s + 190890*D1**2*f**2*fd**2*r - 207900*D1**2*f**2*fd**2*s**2 + 281610*D1**2*f**2*fd**2*s - 83790*D1**2*f**2*fd**2 + 38610*D1**2*f**2*fd*r**2 + 47520*D1**2*f**2*fd*r*s - 41580*D1**2*f**2*fd*r + 8910*D1**2*f**2*fd*s**2 - 21780*D1**2*f**2*fd*s + 15840*D1**2*f**2*fd - 84744*D1**2*f**2*gd2*r**2 - 121176*D1**2*f**2*gd2*r*s + 121176*D1**2*f**2*gd2*r - 36432*D1**2*f**2*gd2*s**2 + 72864*D1**2*f**2*gd2*s - 36432*D1**2*f**2*gd2 + 67320*D1**2*f**2*gdd2*r**2 + 118800*D1**2*f**2*gdd2*r*s - 118800*D1**2*f**2*gdd2*r + 51480*D1**2*f**2*gdd2*s**2 - 102960*D1**2*f**2*gdd2*s + 51480*D1**2*f**2*gdd2 - 169488*D1**2*f*fd*g2*r**2 - 242352*D1**2*f*fd*g2*r*s + 169488*D1**2*f*fd*g2*r - 72864*D1**2*f*fd*g2*s**2 + 121176*D1**2*f*fd*g2*s - 84744*D1**2*f*fd*g2 + 269280*D1**2*f*fd*gd2*r**2 + 475200*D1**2*f*fd*gd2*r*s - 372240*D1**2*f*fd*gd2*r + 205920*D1**2*f*fd*gd2*s**2 - 324720*D1**2*f*fd*gd2*s + 118800*D1**2*f*fd*gd2 + 134640*D1**2*f*fdd*g2*r**2 + 237600*D1**2*f*fdd*g2*r*s - 134640*D1**2*f*fdd*g2*r + 102960*D1**2*f*fdd*g2*s**2 - 118800*D1**2*f*fdd*g2*s + 67320*D1**2*f*fdd*g2 + 134640*D1**2*fd**2*g2*r**2 + 237600*D1**2*fd**2*g2*r*s - 134640*D1**2*fd**2*g2*r + 102960*D1**2*fd**2*g2*s**2 - 118800*D1**2*fd**2*g2*s - 269280*D1*Dd*K*bd1*f**2*r**2 - 475200*D1*Dd*K*bd1*f**2*r*s + 423720*D1*Dd*K*bd1*f**2*r - 205920*D1*Dd*K*bd1*f**2*s**2 + 368280*D1*Dd*K*bd1*f**2*s - 162360*D1*Dd*K*bd1*f**2 + 94160*D1*Dd*bd1*f**3*r**2 + 86240*D1*Dd*bd1*f**3*r*s - 126060*D1*Dd*bd1*f**3*r - 7920*D1*Dd*bd1*f**3*s**2 - 36740*D1*Dd*bd1*f**3*s + 35200*D1*Dd*bd1*f**3 + 192456*D1*Dd*bd1*f**2*r**2 + 378576*D1*Dd*bd1*f**2*r*s - 332046*D1*Dd*bd1*f**2*r + 186120*D1*Dd*bd1*f**2*s**2 - 326502*D1*Dd*bd1*f**2*s + 140382*D1*Dd*bd1*f**2 + 547008*D1*Dd*bd1*f*g2*r**2 + 1094016*D1*Dd*bd1*f*g2*r*s - 1045968*D1*Dd*bd1*f*g2*r + 547008*D1*Dd*bd1*f*g2*s**2 - 1045968*D1*Dd*bd1*f*g2*s + 476784*D1*Dd*bd1*f*g2 - 31680*D1*Dd*bd2*f**2*r**2 - 63360*D1*Dd*bd2*f**2*r*s + 55440*D1*Dd*bd2*f**2*r - 31680*D1*Dd*bd2*f**2*s**2 + 55440*D1*Dd*bd2*f**2*s - 23760*D1*Dd*bd2*f**2 + 28700*D1*Dd*f**4*r**2 + 88760*D1*Dd*f**4*r*s - 58730*D1*Dd*f**4*r + 60060*D1*Dd*f**4*s**2 - 82250*D1*Dd*f**4*s + 37205*D1*Dd*f**4 - 231840*D1*Dd*f**3*fd*r**2 - 786240*D1*Dd*f**3*fd*r*s + 509040*D1*Dd*f**3*fd*r - 554400*D1*Dd*f**3*fd*s**2 + 750960*D1*Dd*f**3*fd*s - 251370*D1*Dd*f**3*fd + 51480*D1*Dd*f**3*r**2 + 63360*D1*Dd*f**3*r*s - 57420*D1*Dd*f**3*r + 11880*D1*Dd*f**3*s**2 - 27720*D1*Dd*f**3*s + 18810*D1*Dd*f**3 - 338976*D1*Dd*f**2*g2*r**2 - 484704*D1*Dd*f**2*g2*r*s + 411840*D1*Dd*f**2*g2*r - 145728*D1*Dd*f**2*g2*s**2 + 266904*D1*Dd*f**2*g2*s - 157608*D1*Dd*f**2*g2 + 538560*D1*Dd*f**2*gd2*r**2 + 950400*D1*Dd*f**2*gd2*r*s - 847440*D1*Dd*f**2*gd2*r + 411840*D1*Dd*f**2*gd2*s**2 - 736560*D1*Dd*f**2*gd2*s + 324720*D1*Dd*f**2*gd2 + 1077120*D1*Dd*f*fd*g2*r**2 + 1900800*D1*Dd*f*fd*g2*r*s - 1283040*D1*Dd*f*fd*g2*r + 823680*D1*Dd*f*fd*g2*s**2 - 1124640*D1*Dd*f*fd*g2*s + 372240*D1*Dd*f*fd*g2 - 28980*D1*Ddd*f**4*r**2 - 98280*D1*Ddd*f**4*r*s + 63630*D1*Ddd*f**4*r - 69300*D1*Ddd*f**4*s**2 + 93870*D1*Ddd*f**4*s - 41895*D1*Ddd*f**4 + 269280*D1*Ddd*f**2*g2*r**2 + 475200*D1*Ddd*f**2*g2*r*s - 372240*D1*Ddd*f**2*g2*r + 205920*D1*Ddd*f**2*g2*s**2 - 324720*D1*Ddd*f**2*g2*s + 170280*D1*Ddd*f**2*g2 - 86940*Dd**2*f**4*r**2 - 294840*Dd**2*f**4*r*s + 190890*Dd**2*f**4*r - 207900*Dd**2*f**4*s**2 + 281610*Dd**2*f**4*s - 83790*Dd**2*f**4 + 807840*Dd**2*f**2*g2*r**2 + 1425600*Dd**2*f**2*g2*r*s - 1116720*Dd**2*f**2*g2*r + 617760*Dd**2*f**2*g2*s**2 - 974160*Dd**2*f**2*g2*s + 340560*Dd**2*f**2*g2 - 462*b1**3*(2*D1*Dd*(5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 4*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 9*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + D1*(-D1*(8*fd - 9*fdd)*(r + s - 1)**2 + Ddd*(-20*K + 9*f + 15)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(-20*K + 9*f + 15)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1**2*(-280*C*D1**2*fd*r**2 - 560*C*D1**2*fd*r*s + 560*C*D1**2*fd*r - 280*C*D1**2*fd*s**2 + 560*C*D1**2*fd*s - 280*C*D1**2*fd - 1120*C*D1*Dd*f*r**2 - 2240*C*D1*Dd*f*r*s + 1680*C*D1*Dd*f*r - 1120*C*D1*Dd*f*s**2 + 1680*C*D1*Dd*f*s - 840*C*D1*Dd*f - 952*D1**2*K*fd*r**2 - 1484*D1**2*K*fd*r*s - 392*D1**2*K*fd*r - 532*D1**2*K*fd*s**2 - 392*D1**2*K*fd*s + 196*D1**2*K*fd + 1036*D1**2*K*fdd*r**2 + 2072*D1**2*K*fdd*r*s + 336*D1**2*K*fdd*r + 1036*D1**2*K*fdd*s**2 + 336*D1**2*K*fdd*s - 168*D1**2*K*fdd + 14*D1**2*bdd1*(-20*K + 9*f + 15)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 846*D1**2*f*fd*r**2 + 2028*D1**2*f*fd*r*s - 930*D1**2*f*fd*r + 1182*D1**2*f*fd*s**2 - 1098*D1**2*f*fd*s + 549*D1**2*f*fd - 1242*D1**2*f*fdd*r**2 - 2820*D1**2*f*fdd*r*s + 1410*D1**2*f*fdd*r - 1578*D1**2*f*fdd*s**2 + 1578*D1**2*f*fdd*s - 789*D1**2*f*fdd - 1242*D1**2*fd**2*r**2 - 2820*D1**2*fd**2*r*s + 1410*D1**2*fd**2*r - 1578*D1**2*fd**2*s**2 + 1578*D1**2*fd**2*s + 889*D1**2*fd*r**2 + 1554*D1**2*fd*r*s - 196*D1**2*fd*r + 665*D1**2*fd*s**2 - 196*D1**2*fd*s + 98*D1**2*fd - 777*D1**2*fdd*r**2 - 1722*D1**2*fdd*r*s - 252*D1**2*fdd*r - 945*D1**2*fdd*s**2 - 252*D1**2*fdd*s + 126*D1**2*fdd - 280*D1**2*gd2*r**2 - 560*D1**2*gd2*r*s + 560*D1**2*gd2*r - 280*D1**2*gd2*s**2 + 560*D1**2*gd2*s - 280*D1**2*gd2 + 560*D1**2*gdd2*r**2 + 1120*D1**2*gdd2*r*s - 1120*D1**2*gdd2*r + 560*D1**2*gdd2*s**2 - 1120*D1**2*gdd2*s + 560*D1**2*gdd2 - 3808*D1*Dd*K*f*r**2 - 5936*D1*Dd*K*f*r*s + 4872*D1*Dd*K*f*r - 2128*D1*Dd*K*f*s**2 + 3612*D1*Dd*K*f*s - 2016*D1*Dd*K*f + 8288*D1*Dd*K*fd*r**2 + 16576*D1*Dd*K*fd*r*s - 4872*D1*Dd*K*fd*r + 8288*D1*Dd*K*fd*s**2 - 4872*D1*Dd*K*fd*s - 1008*D1*Dd*K*fd + 1692*D1*Dd*f**2*r**2 + 4056*D1*Dd*f**2*r*s - 2874*D1*Dd*f**2*r + 2364*D1*Dd*f**2*s**2 - 3378*D1*Dd*f**2*s + 1605*D1*Dd*f**2 - 9936*D1*Dd*f*fd*r**2 - 22560*D1*Dd*f*fd*r*s + 13764*D1*Dd*f*fd*r - 12624*D1*Dd*f*fd*s**2 + 15444*D1*Dd*f*fd*s - 4566*D1*Dd*f*fd + 3556*D1*Dd*f*r**2 + 6216*D1*Dd*f*r*s - 4886*D1*Dd*f*r + 2660*D1*Dd*f*s**2 - 4214*D1*Dd*f*s + 2219*D1*Dd*f - 6216*D1*Dd*fd*r**2 - 13776*D1*Dd*fd*r*s + 3990*D1*Dd*fd*r - 7560*D1*Dd*fd*s**2 + 4494*D1*Dd*fd*s + 756*D1*Dd*fd - 1120*D1*Dd*g2*r**2 - 2240*D1*Dd*g2*r*s + 1680*D1*Dd*g2*r - 1120*D1*Dd*g2*s**2 + 1680*D1*Dd*g2*s - 840*D1*Dd*g2 + 4480*D1*Dd*gd2*r**2 + 8960*D1*Dd*gd2*r*s - 7840*D1*Dd*gd2*r + 4480*D1*Dd*gd2*s**2 - 7840*D1*Dd*gd2*s + 3360*D1*Dd*gd2 + 4144*D1*Ddd*K*f*r**2 + 8288*D1*Ddd*K*f*r*s - 6216*D1*Ddd*K*f*r + 4144*D1*Ddd*K*f*s**2 - 6216*D1*Ddd*K*f*s + 3108*D1*Ddd*K*f - 2484*D1*Ddd*f**2*r**2 - 5640*D1*Ddd*f**2*r*s + 4062*D1*Ddd*f**2*r - 3156*D1*Ddd*f**2*s**2 + 4566*D1*Ddd*f**2*s - 2199*D1*Ddd*f**2 - 3108*D1*Ddd*f*r**2 - 6888*D1*Ddd*f*r*s + 4998*D1*Ddd*f*r - 3780*D1*Ddd*f*s**2 + 5502*D1*Ddd*f*s - 2667*D1*Ddd*f + 2240*D1*Ddd*g2*r**2 + 4480*D1*Ddd*g2*r*s - 3360*D1*Ddd*g2*r + 2240*D1*Ddd*g2*s**2 - 3360*D1*Ddd*g2*s + 1680*D1*Ddd*g2 - 28*D1*bd1*(D1*(-5*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 4*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*(-20*K + 9*f + 15)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 12432*Dd**2*K*f*r**2 + 24864*Dd**2*K*f*r*s - 18648*Dd**2*K*f*r + 12432*Dd**2*K*f*s**2 - 18648*Dd**2*K*f*s + 6216*Dd**2*K*f - 7452*Dd**2*f**2*r**2 - 16920*Dd**2*f**2*r*s + 12186*Dd**2*f**2*r - 9468*Dd**2*f**2*s**2 + 13698*Dd**2*f**2*s - 4398*Dd**2*f**2 - 9324*Dd**2*f*r**2 - 20664*Dd**2*f*r*s + 14994*Dd**2*f*r - 11340*Dd**2*f*s**2 + 16506*Dd**2*f*s - 5334*Dd**2*f + 6720*Dd**2*g2*r**2 + 13440*Dd**2*g2*r*s - 10080*Dd**2*g2*r + 6720*Dd**2*g2*s**2 - 10080*Dd**2*g2*s + 3360*Dd**2*g2) - 11*b1*(3024*C*D1**2*f*fd*r**2 + 3024*C*D1**2*f*fd*r*s - 504*C*D1**2*f*fd*r + 1008*C*D1**2*f*fd*s - 504*C*D1**2*f*fd + 6048*C*D1*Dd*f**2*r**2 + 6048*C*D1*Dd*f**2*r*s - 6048*C*D1*Dd*f**2*r - 1512*C*D1*Dd*f**2*s + 1512*C*D1*Dd*f**2 + 6216*D1**2*K*bdd1*f*r**2 + 12432*D1**2*K*bdd1*f*r*s - 13440*D1**2*K*bdd1*f*r + 6216*D1**2*K*bdd1*f*s**2 - 13440*D1**2*K*bdd1*f*s + 6720*D1**2*K*bdd1*f - 7704*D1**2*K*f*fd*r**2 - 11016*D1**2*K*f*fd*r*s + 7704*D1**2*K*f*fd*r - 3312*D1**2*K*f*fd*s**2 + 5508*D1**2*K*f*fd*s - 3852*D1**2*K*f*fd + 6120*D1**2*K*f*fdd*r**2 + 10800*D1**2*K*f*fdd*r*s - 6120*D1**2*K*f*fdd*r + 4680*D1**2*K*f*fdd*s**2 - 5400*D1**2*K*f*fdd*s + 3060*D1**2*K*f*fdd + 6120*D1**2*K*fd**2*r**2 + 10800*D1**2*K*fd**2*r*s - 6120*D1**2*K*fd**2*r + 4680*D1**2*K*fd**2*s**2 - 5400*D1**2*K*fd**2*s - 588*D1**2*b2*fd*r**2 - 1176*D1**2*b2*fd*r*s - 588*D1**2*b2*fd*s**2 + 504*D1**2*b2*fdd*r**2 + 1008*D1**2*b2*fdd*r*s + 504*D1**2*b2*fdd*s**2 + 84*D1**2*bd1**2*(-20*K + 9*f + 15)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 3726*D1**2*bdd1*f**2*r**2 - 8460*D1**2*bdd1*f**2*r*s + 7956*D1**2*bdd1*f**2*r - 4734*D1**2*bdd1*f**2*s**2 + 8964*D1**2*bdd1*f**2*s - 4230*D1**2*bdd1*f**2 - 4662*D1**2*bdd1*f*r**2 - 10332*D1**2*bdd1*f*r*s + 10584*D1**2*bdd1*f*r - 5670*D1**2*bdd1*f*s**2 + 11592*D1**2*bdd1*f*s - 5544*D1**2*bdd1*f + 3360*D1**2*bdd1*g2*r**2 + 6720*D1**2*bdd1*g2*r*s - 3360*D1**2*bdd1*g2*r + 3360*D1**2*bdd1*g2*s**2 - 3360*D1**2*bdd1*g2*s + 1680*D1**2*bdd1*g2 + 504*D1**2*bdd2*f*r**2 + 1008*D1**2*bdd2*f*r*s - 1008*D1**2*bdd2*f*r + 504*D1**2*bdd2*f*s**2 - 1008*D1**2*bdd2*f*s + 504*D1**2*bdd2*f + 3180*D1**2*f**2*fd*r**2 + 2640*D1**2*f**2*fd*r*s - 2180*D1**2*f**2*fd*r - 540*D1**2*f**2*fd*s**2 + 300*D1**2*f**2*fd*s - 90*D1**2*f**2*fd - 3210*D1**2*f**2*fdd*r**2 - 2940*D1**2*f**2*fdd*r*s + 2260*D1**2*f**2*fdd*r + 270*D1**2*f**2*fdd*s**2 - 60*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd - 6420*D1**2*f*fd**2*r**2 - 5880*D1**2*f*fd**2*r*s + 4520*D1**2*f*fd**2*r + 540*D1**2*f*fd**2*s**2 - 120*D1**2*f*fd**2*s - 540*D1**2*f*fd**2 + 2574*D1**2*f*fd*r**2 + 5364*D1**2*f*fd*r*s - 4590*D1**2*f*fd*r + 2790*D1**2*f*fd*s**2 - 4698*D1**2*f*fd*s + 2925*D1**2*f*fd - 4374*D1**2*f*fdd*r**2 - 8604*D1**2*f*fdd*r*s + 4374*D1**2*f*fdd*r - 4230*D1**2*f*fdd*s**2 + 4302*D1**2*f*fdd*s - 2187*D1**2*f*fdd + 5712*D1**2*f*gd2*r**2 + 8904*D1**2*f*gd2*r*s - 8904*D1**2*f*gd2*r + 3192*D1**2*f*gd2*s**2 - 6384*D1**2*f*gd2*s + 3192*D1**2*f*gd2 - 6216*D1**2*f*gdd2*r**2 - 12432*D1**2*f*gdd2*r*s + 12432*D1**2*f*gdd2*r - 6216*D1**2*f*gdd2*s**2 + 12432*D1**2*f*gdd2*s - 6216*D1**2*f*gdd2 - 4374*D1**2*fd**2*r**2 - 8604*D1**2*fd**2*r*s + 4374*D1**2*fd**2*r - 4230*D1**2*fd**2*s**2 + 4302*D1**2*fd**2*s + 5712*D1**2*fd*g2*r**2 + 8904*D1**2*fd*g2*r*s + 2352*D1**2*fd*g2*r + 3192*D1**2*fd*g2*s**2 + 2352*D1**2*fd*g2*s - 1176*D1**2*fd*g2 - 12432*D1**2*fd*gd2*r**2 - 24864*D1**2*fd*gd2*r*s + 10416*D1**2*fd*gd2*r - 12432*D1**2*fd*gd2*s**2 + 10416*D1**2*fd*gd2*s + 2016*D1**2*fd*gd2 - 6216*D1**2*fdd*g2*r**2 - 12432*D1**2*fdd*g2*r*s - 2016*D1**2*fdd*g2*r - 6216*D1**2*fdd*g2*s**2 - 2016*D1**2*fdd*g2*s + 1008*D1**2*fdd*g2 - 15408*D1*Dd*K*f**2*r**2 - 22032*D1*Dd*K*f**2*r*s + 18720*D1*Dd*K*f**2*r - 6624*D1*Dd*K*f**2*s**2 + 12132*D1*Dd*K*f**2*s - 7164*D1*Dd*K*f**2 + 48960*D1*Dd*K*f*fd*r**2 + 86400*D1*Dd*K*f*fd*r*s - 58320*D1*Dd*K*f*fd*r + 37440*D1*Dd*K*f*fd*s**2 - 51120*D1*Dd*K*f*fd*s + 16920*D1*Dd*K*f*fd - 2352*D1*Dd*b2*f*r**2 - 4704*D1*Dd*b2*f*r*s + 3528*D1*Dd*b2*f*r - 2352*D1*Dd*b2*f*s**2 + 3528*D1*Dd*b2*f*s - 1764*D1*Dd*b2*f + 4032*D1*Dd*b2*fd*r**2 + 8064*D1*Dd*b2*fd*r*s - 3024*D1*Dd*b2*fd*r + 4032*D1*Dd*b2*fd*s**2 - 3024*D1*Dd*b2*fd*s + 4240*D1*Dd*f**3*r**2 + 3520*D1*Dd*f**3*r*s - 3880*D1*Dd*f**3*r - 720*D1*Dd*f**3*s**2 - 160*D1*Dd*f**3*s + 700*D1*Dd*f**3 - 25680*D1*Dd*f**2*fd*r**2 - 23520*D1*Dd*f**2*fd*r*s + 21340*D1*Dd*f**2*fd*r + 2160*D1*Dd*f**2*fd*s**2 + 1620*D1*Dd*f**2*fd*s - 2140*D1*Dd*f**2*fd + 5148*D1*Dd*f**2*r**2 + 10728*D1*Dd*f**2*r*s - 7938*D1*Dd*f**2*r + 5580*D1*Dd*f**2*s**2 - 8262*D1*Dd*f**2*s + 4077*D1*Dd*f**2 - 34992*D1*Dd*f*fd*r**2 - 68832*D1*Dd*f*fd*r*s + 43452*D1*Dd*f*fd*r - 33840*D1*Dd*f*fd*s**2 + 42732*D1*Dd*f*fd*s - 12978*D1*Dd*f*fd + 22848*D1*Dd*f*g2*r**2 + 35616*D1*Dd*f*g2*r*s - 29232*D1*Dd*f*g2*r + 12768*D1*Dd*f*g2*s**2 - 21672*D1*Dd*f*g2*s + 12096*D1*Dd*f*g2 - 49728*D1*Dd*f*gd2*r**2 - 99456*D1*Dd*f*gd2*r*s + 87024*D1*Dd*f*gd2*r - 49728*D1*Dd*f*gd2*s**2 + 87024*D1*Dd*f*gd2*s - 37296*D1*Dd*f*gd2 - 49728*D1*Dd*fd*g2*r**2 - 99456*D1*Dd*fd*g2*r*s + 29232*D1*Dd*fd*g2*r - 49728*D1*Dd*fd*g2*s**2 + 29232*D1*Dd*fd*g2*s + 6048*D1*Dd*fd*g2 + 12240*D1*Ddd*K*f**2*r**2 + 21600*D1*Ddd*K*f**2*r*s - 16920*D1*Ddd*K*f**2*r + 9360*D1*Ddd*K*f**2*s**2 - 14760*D1*Ddd*K*f**2*s + 7740*D1*Ddd*K*f**2 + 2016*D1*Ddd*b2*f*r**2 + 4032*D1*Ddd*b2*f*r*s - 3024*D1*Ddd*b2*f*r + 2016*D1*Ddd*b2*f*s**2 - 3024*D1*Ddd*b2*f*s + 1512*D1*Ddd*b2*f - 4280*D1*Ddd*f**3*r**2 - 3920*D1*Ddd*f**3*r*s + 4100*D1*Ddd*f**3*r + 360*D1*Ddd*f**3*s**2 + 620*D1*Ddd*f**3*s - 890*D1*Ddd*f**3 - 8748*D1*Ddd*f**2*r**2 - 17208*D1*Ddd*f**2*r*s + 12978*D1*Ddd*f**2*r - 8460*D1*Ddd*f**2*s**2 + 12762*D1*Ddd*f**2*s - 6417*D1*Ddd*f**2 - 24864*D1*Ddd*f*g2*r**2 - 49728*D1*Ddd*f*g2*r*s + 37296*D1*Ddd*f*g2*r - 24864*D1*Ddd*f*g2*s**2 + 37296*D1*Ddd*f*g2*s - 18648*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(56*K*fd*(37*r**2 + r*(74*s - 34) + 37*s**2 - 34*s - 3) + 3*f**2*(141*r**2 + r*(338*s - 324) + 197*s**2 - 380*s + 176) - f*(140*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*K*(68*r**2 + 106*r*s - 135*r + 38*s**2 - 105*s + 60) + 6*fd*(414*r**2 + r*(940*s - 677) + 526*s**2 - 761*s + 249) - 889*r**2 - 1554*r*s + 1568*r - 665*s**2 + 1344*s - 728) - 42*fd*(37*r**2 + r*(82*s - 36) + 45*s**2 - 40*s - 3) - 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 560*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(-3*f**2*(828*r**2 + r*(1880*s - 1561) + 1052*s**2 - 1757*s + 719) + 7*f*(4*K*(148*r**2 + 296*r*s - 271*r + 148*s**2 - 271*s + 120) - 444*r**2 - 984*r*s + 861*r - 540*s**2 + 945*s - 402) + 280*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 84*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 36720*Dd**2*K*f**2*r**2 + 64800*Dd**2*K*f**2*r*s - 50760*Dd**2*K*f**2*r + 28080*Dd**2*K*f**2*s**2 - 44280*Dd**2*K*f**2*s + 15480*Dd**2*K*f**2 + 6048*Dd**2*b2*f*r**2 + 12096*Dd**2*b2*f*r*s - 9072*Dd**2*b2*f*r + 6048*Dd**2*b2*f*s**2 - 9072*Dd**2*b2*f*s + 3024*Dd**2*b2*f - 12840*Dd**2*f**3*r**2 - 11760*Dd**2*f**3*r*s + 12300*Dd**2*f**3*r + 1080*Dd**2*f**3*s**2 + 1860*Dd**2*f**3*s - 1780*Dd**2*f**3 - 26244*Dd**2*f**2*r**2 - 51624*Dd**2*f**2*r*s + 38934*Dd**2*f**2*r - 25380*Dd**2*f**2*s**2 + 38286*Dd**2*f**2*s - 12834*Dd**2*f**2 - 74592*Dd**2*f*g2*r**2 - 149184*Dd**2*f*g2*r*s + 111888*Dd**2*f*g2*r - 74592*Dd**2*f*g2*s**2 + 111888*Dd**2*f*g2*s - 37296*Dd**2*f*g2) + 132*b2*(-42*D1**2*bdd1*f*(r + s - 1)**2 - 3*D1**2*(-f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 7*D1*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*D1*f*(Dd*(-13*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 20*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(3465*d**2*k3**6) - D1**2*Pk1*Pk3*ct**3*k1*k2*st**4*(64*C - 52)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k3**4) - 2*D1**2*Pk1*Pk3*ct**3*k1*k2*st**2*(84*b1**2*(D1**2*(s - 1)*(fd*(25*C - 19) + fdd*(12 - 15*C))*(r + s - 1) + D1*(Dd*(f*(25*C - 19)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(15*C - 12)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(12 - 15*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(15*C - 12)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 3*b1*(D1**2*(f*(-84*bdd1*s*(5*C - 4)*(2*r + 2*s - 1) + fd*(-2*C*(646*r*(2*s - 1) + 1714*s**2 - 1548*s + 857) + 980*r*(2*s - 1) + 2786*s**2 - 2526*s + 1393) + 3*fdd*(C*(332*r*(2*s - 1) + 996*s**2 - 936*s + 498) - 252*r*(2*s - 1) - 826*s**2 + 778*s - 413)) + 6*fd**2*(166*C*r*(2*s - 1) + 6*C*(83*s**2 - 78*s - 5) - 252*r*s + 126*r - 413*s**2 + 389*s + 24)) + 28*D1*bd1*(D1*(f*s*(25*C - 19)*(2*r + 2*s - 1) - fd*(15*C - 12)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(24 - 30*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(-498*C*Ddd*f*(r*(4*s - 2) + 6*s**2 - 7*s + 3) + Dd*f*(2*C*(646*r*(2*s - 1) + 1714*s**2 - 2037*s + 857) - 980*r*(2*s - 1) - 2786*s**2 + 3276*s - 1393) - 6*Dd*fd*(2*s - 1)*(C*(664*r + 996*s - 551) - 504*r - 826*s + 452) + 21*Ddd*f*(36*r*(2*s - 1) + 118*s**2 - 136*s + 59)) + 6*Dd**2*f**2*(166*C*(6*r*(2*s - 1) + 18*s**2 - 21*s + 5) - 756*r*(2*s - 1) - 2478*s**2 + 2856*s - 665)) + f*(-252*D1**2*bd1**2*s*(5*C - 4)*(2*r + 2*s - 1) + D1**2*(f*(9*bdd1*s*(C*(332*r + 498*s - 392) - 252*r - 413*s + 300) + fd*(C*(-3200*r*(3*s - 1) - 9318*s**2 + 9412*s - 3106) + 2388*r*(3*s - 1) + 7569*s**2 - 7434*s + 2523) + fdd*(C*(2392*r*(3*s - 1) + 7170*s**2 - 7172*s + 2390) - 1788*r*(3*s - 1) - 5931*s**2 + 5742*s - 1977)) + 2*fd**2*(2*C*(1196*r*(3*s - 1) + 3585*s**2 - 3586*s + 598) - 1788*r*(3*s - 1) - 5931*s**2 + 5742*s - 894)) - 3*D1*bd1*(-12*C*Dd*f*(166*r*(4*s - 1) + 996*s**2 - 973*s + 196) + D1*f*s*(2*C*(646*r + 857*s - 812) - 980*r - 1393*s + 1240) - 6*D1*fd*(2*C*(83*r*(4*s - 1) + 498*s**2 - 430*s + 98) - 126*r*(4*s - 1) - 826*s**2 + 689*s - 150) + 24*Dd*f*(63*r*(4*s - 1) + 413*s**2 - 388*s + 75)) - 2*D1*f*(Dd*(C*f*(3200*r*(2*s - 1) + 6212*s**2 - 7812*s + 3106) - 4*C*fd*(598*r*(12*s - 5) + 7170*s**2 - 8068*s + 2092) - 3*f*(796*r*(2*s - 1) + 1682*s**2 - 2080*s + 841) + 12*fd*(149*r*(12*s - 5) + 1977*s**2 - 2169*s + 553)) + Ddd*f*(C*(-2392*r*(2*s - 1) - 4780*s**2 + 5976*s - 2390) + 1788*r*(2*s - 1) + 3954*s**2 - 4848*s + 1977)) + 6*Dd**2*f**2*(2*C*(1196*r*(2*s - 1) + 2390*s**2 - 2988*s + 797) - 1788*r*(2*s - 1) - 3954*s**2 + 4848*s - 1255)))/(315*d**2*k3**4) - D1**2*Pk1*Pk3*ct**3*k1*k2*(21*b1**2*(D1**2*(fd*(4*C*(r - 49*s + 49) - 5*r + 159*s - 159) + fdd*(68*C*r + 188*C*(s - 1) - 45*r - 157*s + 157))*(r + s - 1) + D1*(Dd*(f*(4*C*(4*r**2 - 192*r*s + 94*r - 196*s**2 + 244*s - 97) - 20*r**2 + 616*r*s - 298*r + 636*s**2 - 790*s + 313) + 2*fd*(4*C*(68*r**2 + 256*r*s - 209*r + 188*s**2 - 314*s + 126) - 180*r**2 - 808*r*s + 651*r - 628*s**2 + 1043*s - 415)) + Ddd*f*(4*C*(68*r**2 + 256*r*s - 162*r + 188*s**2 - 252*s + 111) - 180*r**2 - 808*r*s + 494*r - 628*s**2 + 830*s - 359)) + 2*Dd**2*f*(12*C*(34*r**2 + r*(128*s - 81) + 94*s**2 - 126*s + 37) - 270*r**2 + r*(741 - 1212*s) - 942*s**2 + 1245*s - 359)) + 3*b1*(592*C*D1**2*f*fd*r**2 + 5216*C*D1**2*f*fd*r*s - 1912*C*D1**2*f*fd*r + 4656*C*D1**2*f*fd*s**2 - 3408*C*D1**2*f*fd*s + 1980*C*D1**2*f*fd - 1024*C*D1**2*f*fdd*r**2 - 5072*C*D1**2*f*fdd*r*s + 1600*C*D1**2*f*fdd*r - 4512*C*D1**2*f*fdd*s**2 + 3216*C*D1**2*f*fdd*s - 1788*C*D1**2*f*fdd - 1024*C*D1**2*fd**2*r**2 - 5072*C*D1**2*fd**2*r*s + 1600*C*D1**2*fd**2*r - 4512*C*D1**2*fd**2*s**2 + 3216*C*D1**2*fd**2*s + 1296*C*D1**2*fd**2 + 1184*C*D1*Dd*f**2*r**2 + 10432*C*D1*Dd*f**2*r*s - 5808*C*D1*Dd*f**2*r + 9312*C*D1*Dd*f**2*s**2 - 11920*C*D1*Dd*f**2*s + 4952*C*D1*Dd*f**2 - 8192*C*D1*Dd*f*fd*r**2 - 40576*C*D1*Dd*f*fd*r*s + 18592*C*D1*Dd*f*fd*r - 36096*C*D1*Dd*f*fd*s**2 + 35984*C*D1*Dd*f*fd*s - 8032*C*D1*Dd*f*fd - 2048*C*D1*Ddd*f**2*r**2 - 10144*C*D1*Ddd*f**2*r*s + 6096*C*D1*Ddd*f**2*r - 9024*C*D1*Ddd*f**2*s**2 + 11560*C*D1*Ddd*f**2*s - 5024*C*D1*Ddd*f**2 - 6144*C*Dd**2*f**2*r**2 - 30432*C*Dd**2*f**2*r*s + 18288*C*Dd**2*f**2*r - 27072*C*Dd**2*f**2*s**2 + 34680*C*Dd**2*f**2*s - 9584*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(4*C*(34*r**2 + 128*r*s - 34*r + 94*s**2 - 64*s + 17) - 90*r**2 - 404*r*s + 90*r - 314*s**2 + 202*s - 45) - 450*D1**2*f*fd*r**2 - 4280*D1**2*f*fd*r*s + 1702*D1**2*f*fd*r - 4212*D1**2*f*fd*s**2 + 3258*D1**2*f*fd*s - 1887*D1**2*f*fd + 666*D1**2*f*fdd*r**2 + 4184*D1**2*f*fdd*r*s - 1474*D1**2*f*fdd*r + 4164*D1**2*f*fdd*s**2 - 3162*D1**2*f*fdd*s + 1773*D1**2*f*fdd + 666*D1**2*fd**2*r**2 + 4184*D1**2*fd**2*r*s - 1474*D1**2*fd**2*r + 4164*D1**2*fd**2*s**2 - 3162*D1**2*fd**2*s - 1002*D1**2*fd**2 - 900*D1*Dd*f**2*r**2 - 8560*D1*Dd*f**2*r*s + 4730*D1*Dd*f**2*r - 8424*D1*Dd*f**2*s**2 + 10564*D1*Dd*f**2*s - 4437*D1*Dd*f**2 + 5328*D1*Dd*f*fd*r**2 + 33472*D1*Dd*f*fd*r*s - 15596*D1*Dd*f*fd*r + 33312*D1*Dd*f*fd*s**2 - 33488*D1*Dd*f*fd*s + 7798*D1*Dd*f*fd + 1332*D1*Ddd*f**2*r**2 + 8368*D1*Ddd*f**2*r*s - 4850*D1*Ddd*f**2*r + 8328*D1*Ddd*f**2*s**2 - 10420*D1*Ddd*f**2*s + 4497*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(4*C*(2*r**2 - 96*r*s - 2*r - 98*s**2 + 48*s + 1) - 10*r**2 + 308*r*s + 10*r + 318*s**2 - 154*s - 5) + 2*fd*(4*C*(34*r**2 + 128*r*s - 81*r + 94*s**2 - 126*s + 32) - 90*r**2 - 404*r*s + 247*r - 314*s**2 + 415*s - 101)) + 2*Dd*f*(4*C*(136*r**2 + 512*r*s - 230*r + 376*s**2 - 380*s + 81) - 360*r**2 - 1616*r*s + 674*r - 1256*s**2 + 1234*s - 247)) + 3996*Dd**2*f**2*r**2 + 25104*Dd**2*f**2*r*s - 14550*Dd**2*f**2*r + 24984*Dd**2*f**2*s**2 - 31260*Dd**2*f**2*s + 8348*Dd**2*f**2) + f*(8844*C*D1**2*f*fd*r**2 + 30336*C*D1**2*f*fd*r*s - 16008*C*D1**2*f*fd*r + 19524*C*D1**2*f*fd*s**2 - 23128*C*D1**2*f*fd*s + 9456*C*D1**2*f*fd - 8364*C*D1**2*f*fdd*r**2 - 28776*C*D1**2*f*fdd*r*s + 15168*C*D1**2*f*fdd*r - 18564*C*D1**2*f*fdd*s**2 + 21968*C*D1**2*f*fdd*s - 8976*C*D1**2*f*fdd - 16728*C*D1**2*fd**2*r**2 - 57552*C*D1**2*fd**2*r*s + 30336*C*D1**2*fd**2*r - 37128*C*D1**2*fd**2*s**2 + 43936*C*D1**2*fd**2*s - 9592*C*D1**2*fd**2 + 11792*C*D1*Dd*f**2*r**2 + 40448*C*D1*Dd*f**2*r*s - 26120*C*D1*Dd*f**2*r + 26032*C*D1*Dd*f**2*s**2 - 36144*C*D1*Dd*f**2*s + 15964*C*D1*Dd*f**2 - 66912*C*D1*Dd*f*fd*r**2 - 230208*C*D1*Dd*f*fd*r*s + 134952*C*D1*Dd*f*fd*r - 148512*C*D1*Dd*f*fd*s**2 + 190904*C*D1*Dd*f*fd*s - 59104*C*D1*Dd*f*fd - 11152*C*D1*Ddd*f**2*r**2 - 38368*C*D1*Ddd*f**2*r*s + 24760*C*D1*Ddd*f**2*r - 24752*C*D1*Ddd*f**2*s**2 + 34344*C*D1*Ddd*f**2*s - 15164*C*D1*Ddd*f**2 - 33456*C*Dd**2*f**2*r**2 - 115104*C*Dd**2*f**2*r*s + 74280*C*Dd**2*f**2*r - 74256*C*Dd**2*f**2*s**2 + 103032*C*Dd**2*f**2*s - 31560*C*Dd**2*f**2 + 42*D1**2*bd1**2*(r**2*(68*C - 45) + r*(4*C*(64*s - 17) - 202*s + 45) + s*(4*C*(47*s - 32) - 157*s + 101)) - 3*D1**2*bdd1*f*(4*C*(128*r**2 + 634*r*s - 490*r + 564*s**2 - 958*s + 245) - 333*r**2 - 2092*r*s + 1284*r - 2082*s**2 + 3094*s - 642) - 5796*D1**2*f*fd*r**2 - 23922*D1**2*f*fd*r*s + 11838*D1**2*f*fd*r - 17355*D1**2*f*fd*s**2 + 19544*D1**2*f*fd*s - 7717*D1**2*f*fd + 5436*D1**2*f*fdd*r**2 + 22842*D1**2*f*fdd*r*s - 11238*D1**2*f*fdd*r + 16845*D1**2*f*fdd*s**2 - 18844*D1**2*f*fdd*s + 7427*D1**2*f*fdd + 10872*D1**2*fd**2*r**2 + 45684*D1**2*fd**2*r*s - 22476*D1**2*fd**2*r + 33690*D1**2*fd**2*s**2 - 37688*D1**2*fd**2*s + 7614*D1**2*fd**2 - 7728*D1*Dd*f**2*r**2 - 31896*D1*Dd*f**2*r*s + 19812*D1*Dd*f**2*r - 23140*D1*Dd*f**2*s**2 + 31114*D1*Dd*f**2*s - 13502*D1*Dd*f**2 + 43488*D1*Dd*f*fd*r**2 + 182736*D1*Dd*f*fd*r*s - 101508*D1*Dd*f*fd*r + 134760*D1*Dd*f*fd*s**2 - 165598*D1*Dd*f*fd*s + 48926*D1*Dd*f*fd + 7248*D1*Ddd*f**2*r**2 + 30456*D1*Ddd*f**2*r*s - 18852*D1*Ddd*f**2*r + 22460*D1*Ddd*f**2*s**2 - 30074*D1*Ddd*f**2*s + 13042*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(4*C*(74*r**2 + 652*r*s - 322*r + 582*s**2 - 964*s + 161) - 225*r**2 - 2140*r*s + 888*r - 2106*s**2 + 3094*s - 444) + 2*fd*(-4*C*(256*r**2 + 1268*r*s - 690*r + 1128*s**2 - 1360*s + 479) + 666*r**2 + 4184*r*s - 2021*r + 4164*s**2 - 4675*s + 1547)) - 2*Dd*f*(4*C*(512*r**2 + 2536*r*s - 1742*r + 2256*s**2 - 3361*s + 1203) - 1332*r**2 - 8368*r*s + 4993*r - 8328*s**2 + 11398*s - 3736)) + 21744*Dd**2*f**2*r**2 + 91368*Dd**2*f**2*r*s - 56556*Dd**2*f**2*r + 67380*Dd**2*f**2*s**2 - 90222*Dd**2*f**2*s + 26458*Dd**2*f**2))/(315*d**2*k3**4) - 8*D1**2*Pk1*Pk3*ct**3*k1*st**2*(63*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) - 18*b1*(D1**2*(f*(fd*(8*C - 4)*(2*s**2 - 2*s + 1) - fdd*(4*C - 2)*(2*s**2 - 2*s + 1) + s**2*(4*C - 3)*(-14*bd1 + 7*bdd1)) + 2*fd*s*(s - 1)*(7*bd1*(4*C - 3) + fd*(2 - 4*C))) + 4*D1*f*(Dd*f*(4*C - 2)*(2*s**2 - 2*s + 1) - Dd*(2*s - 1)*(7*bd1*s*(3 - 4*C) + fd*(4*C - 2)*(2*s - 1)) - Ddd*f*(2*C - 1)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(4 - 8*C)*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(-fd*(200*C - 130)*(3*s**2 - 2*s + 1) + fdd*(100*C - 65)*(3*s**2 - 2*s + 1) + s**2*(2*C - 1)*(-72*bd1 + 36*bdd1)) + 2*s*(-63*bd1**2*s*(4*C - 3) + 36*bd1*fd*(2*C - 1)*(2*s - 1) + fd**2*(100*C - 65)*(3*s - 2))) - 2*D1*f*(Dd*f*(200*C - 130)*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(36*bd1*s*(2*C - 1) + fd*(100*C - 65)*(3*s - 1)) - Ddd*f*(100*C - 65)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(200*C - 130)*(6*s**2 - 6*s + 1)))/(315*d**2*k2*k3**2) + D1**2*Pk1*Pk3*ct**3*k1*(21*b1**2*(D1**2*(s - 1)*(fd*(8*C*r + 148*C*(s - 1) - 4*r - 111*s + 111) + fdd*(-4*C*(6*r + 31*s - 31) + 12*r + 93*s - 93)) + 2*D1*(-4*C*Ddd*f*(6*r*(2*s - 1) + 62*s**2 - 65*s + 31) + Dd*f*(4*C*(r*(4*s - 2) + 74*s**2 - 75*s + 37) + r*(4 - 8*s) - 222*s**2 + 224*s - 111) - 4*Dd*fd*(C*(6*r*(4*s - 3) + 124*s**2 - 189*s + 65) - 3*r*(4*s - 3) - 93*s**2 + 141*s - 48) + 3*Ddd*f*(r*(8*s - 4) + 62*s**2 - 64*s + 31)) - 2*Dd**2*f*(4*C*(18*r*(2*s - 1) + 186*s**2 - 195*s + 37) + r*(36 - 72*s) - 558*s**2 + 576*s - 105)) + 6*b1*(D1**2*(f*(7*bdd1*s*(-4*C*(6*r + 31*s - 3) + 12*r + 93*s - 6) - fd*(12*C - 6)*(8*s**2 - s + 4) + fdd*(12*C - 6)*(4*s**2 + 3*s + 2)) + fd**2*(12*C - 6)*(4*s**2 + 3*s - 7)) + 7*D1*bd1*(-8*C*Dd*f*(6*r*(4*s - 1) + 124*s**2 - 71*s + 3) + D1*f*s*(4*C*(2*r + 37*s - 1) - 4*r - 111*s + 2) - 2*D1*fd*(2*C*(6*r*(2*s - 1) + 62*s**2 - 65*s + 3) + r*(6 - 12*s) - 93*s**2 + 96*s - 3) + 12*Dd*f*(r*(8*s - 2) + 62*s**2 - 34*s + 1)) - D1*f*(24*C - 12)*(Dd*f*(8*s**2 - 8*s + 4) + Dd*fd*(-16*s**2 + 2*s + 3) - 2*Ddd*f*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(48*C - 24)*(6*s**2 - 6*s + 1)) + f*(-42*D1**2*bd1**2*s*(4*C*(6*r + 31*s - 3) - 12*r - 93*s + 6) + D1**2*(f*(36*bdd1*s*(2*C - 1)*(2*s - 7) - 5*fd*(4*C*(78*r*s - 26*r + 243*s**2 - 188*s + 81) - 156*r*s + 52*r - 705*s**2 + 522*s - 235) + 5*fdd*(4*C*(66*r*s - 22*r + 189*s**2 - 148*s + 63) - 132*r*s + 44*r - 555*s**2 + 414*s - 185)) + 10*fd**2*(4*C*(22*r*(3*s - 1) + 189*s**2 - 148*s + 11) - 44*r*(3*s - 1) - 555*s**2 + 414*s - 22)) + 36*D1*bd1*(2*C - 1)*(D1*f*s*(7 - 4*s) + D1*fd*(8*s**2 - 11*s + 7) + 2*Dd*f*(8*s**2 - 18*s + 7)) - 10*D1*f*(Dd*(f*(4*C*(52*r*s - 26*r + 162*s**2 - 175*s + 81) - 104*r*s + 52*r - 470*s**2 + 496*s - 235) - 4*fd*(C*(22*r*(12*s - 5) + 756*s**2 - 707*s + 159) - 132*r*s + 55*r - 555*s**2 + 501*s - 109)) + Ddd*f*(-4*C*(44*r*s - 22*r + 126*s**2 - 137*s + 63) + 88*r*s - 44*r + 370*s**2 - 392*s + 185)) + 10*Dd**2*f**2*(4*C*(66*r*(2*s - 1) + 378*s**2 - 411*s + 85) - 132*r*(2*s - 1) - 1110*s**2 + 1176*s - 229)))/(315*d**2*k2*k3**2) + 4*D1**2*Pk1*Pk3*ct**3*k2**5*st**4*(648*C*D1**2*b1*f*fd*r**2 + 648*C*D1**2*b1*f*fd*r*s - 324*C*D1**2*b1*f*fd*r - 240*C*D1**2*b1*f*fdd*r**2 - 240*C*D1**2*b1*f*fdd*r*s + 120*C*D1**2*b1*f*fdd*r - 240*C*D1**2*b1*fd**2*r**2 - 240*C*D1**2*b1*fd**2*r*s + 120*C*D1**2*b1*fd**2*r + 372*C*D1**2*f**2*fd*r**2 + 372*C*D1**2*f**2*fd*r*s - 372*C*D1**2*f**2*fd*r - 124*C*D1**2*f**2*fd*s + 124*C*D1**2*f**2*fd - 240*C*D1**2*f**2*fdd*r**2 - 240*C*D1**2*f**2*fdd*r*s + 240*C*D1**2*f**2*fdd*r + 80*C*D1**2*f**2*fdd*s - 80*C*D1**2*f**2*fdd - 480*C*D1**2*f*fd**2*r**2 - 480*C*D1**2*f*fd**2*r*s + 480*C*D1**2*f*fd**2*r + 160*C*D1**2*f*fd**2*s - 80*C*D1**2*f*fd**2 + 1296*C*D1*Dd*b1*f**2*r**2 + 1296*C*D1*Dd*b1*f**2*r*s - 1296*C*D1*Dd*b1*f**2*r - 324*C*D1*Dd*b1*f**2*s + 324*C*D1*Dd*b1*f**2 - 1920*C*D1*Dd*b1*f*fd*r**2 - 1920*C*D1*Dd*b1*f*fd*r*s + 1440*C*D1*Dd*b1*f*fd*r + 240*C*D1*Dd*b1*f*fd*s - 120*C*D1*Dd*b1*f*fd + 496*C*D1*Dd*f**3*r**2 + 496*C*D1*Dd*f**3*r*s - 496*C*D1*Dd*f**3*r - 124*C*D1*Dd*f**3*s + 124*C*D1*Dd*f**3 - 1920*C*D1*Dd*f**2*fd*r**2 - 1920*C*D1*Dd*f**2*fd*r*s + 1920*C*D1*Dd*f**2*fd*r + 560*C*D1*Dd*f**2*fd*s - 400*C*D1*Dd*f**2*fd - 480*C*D1*Ddd*b1*f**2*r**2 - 480*C*D1*Ddd*b1*f**2*r*s + 480*C*D1*Ddd*b1*f**2*r + 120*C*D1*Ddd*b1*f**2*s - 120*C*D1*Ddd*b1*f**2 - 320*C*D1*Ddd*f**3*r**2 - 320*C*D1*Ddd*f**3*r*s + 320*C*D1*Ddd*f**3*r + 80*C*D1*Ddd*f**3*s - 80*C*D1*Ddd*f**3 - 1440*C*Dd**2*b1*f**2*r**2 - 1440*C*Dd**2*b1*f**2*r*s + 1440*C*Dd**2*b1*f**2*r + 360*C*Dd**2*b1*f**2*s - 240*C*Dd**2*b1*f**2 - 960*C*Dd**2*f**3*r**2 - 960*C*Dd**2*f**3*r*s + 960*C*Dd**2*f**3*r + 240*C*Dd**2*f**3*s - 160*C*Dd**2*f**3 - 828*D1**2*b1*f*fd*r**2 - 1008*D1**2*b1*f*fd*r*s + 504*D1**2*b1*f*fd*r - 180*D1**2*b1*f*fd*s**2 + 180*D1**2*b1*f*fd*s - 90*D1**2*b1*f*fd + 330*D1**2*b1*f*fdd*r**2 + 420*D1**2*b1*f*fdd*r*s - 210*D1**2*b1*f*fdd*r + 90*D1**2*b1*f*fdd*s**2 - 90*D1**2*b1*f*fdd*s + 45*D1**2*b1*f*fdd + 330*D1**2*b1*fd**2*r**2 + 420*D1**2*b1*fd**2*r*s - 210*D1**2*b1*fd**2*r + 90*D1**2*b1*fd**2*s**2 - 90*D1**2*b1*fd**2*s - 15*D1**2*bdd1*f**2*(r + s - 1)*(8*C*(r - 1) - 11*r - 3*s + 11) - 462*D1**2*f**2*fd*r**2 - 552*D1**2*f**2*fd*r*s + 492*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 244*D1**2*f**2*fd*s - 184*D1**2*f**2*fd + 285*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 300*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 110*D1**2*f**2*fdd + 570*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 600*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s + 110*D1**2*f*fd**2 - 1656*D1*Dd*b1*f**2*r**2 - 2016*D1*Dd*b1*f**2*r*s + 1836*D1*Dd*b1*f**2*r - 360*D1*Dd*b1*f**2*s**2 + 864*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 2640*D1*Dd*b1*f*fd*r**2 + 3360*D1*Dd*b1*f*fd*r*s - 2340*D1*Dd*b1*f*fd*r + 720*D1*Dd*b1*f*fd*s**2 - 1140*D1*Dd*b1*f*fd*s + 390*D1*Dd*b1*f*fd - 616*D1*Dd*f**3*r**2 - 736*D1*Dd*f**3*r*s + 676*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 304*D1*Dd*f**3*s - 214*D1*Dd*f**3 + 2280*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 2430*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 1070*D1*Dd*f**2*fd*s + 580*D1*Dd*f**2*fd + 660*D1*Ddd*b1*f**2*r**2 + 840*D1*Ddd*b1*f**2*r*s - 750*D1*Ddd*b1*f**2*r + 180*D1*Ddd*b1*f**2*s**2 - 390*D1*Ddd*b1*f**2*s + 255*D1*Ddd*b1*f**2 + 380*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 410*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 170*D1*Ddd*f**3*s + 125*D1*Ddd*f**3 + 6*D1*bd1*f*(D1*(3*f*(r + s - 1)*(18*C*(r - 1) - 23*r - 5*s + 23) - 5*fd*(4*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 22*r**2 - 28*r*s + 29*r - 6*s**2 + 17*s - 7)) - 5*Dd*f*(4*C*(8*r**2 + 8*r*s - 12*r - 5*s + 4) - 44*r**2 - 56*r*s + 69*r - 12*s**2 + 41*s - 25)) + 1980*Dd**2*b1*f**2*r**2 + 2520*Dd**2*b1*f**2*r*s - 2250*Dd**2*b1*f**2*r + 540*Dd**2*b1*f**2*s**2 - 1170*Dd**2*b1*f**2*s + 510*Dd**2*b1*f**2 + 1140*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 1230*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 510*Dd**2*f**3*s + 250*Dd**2*f**3)/(105*d**2*k1*k3**6) - 4*D1**2*Pk1*Pk3*ct**3*k2**5*st**2*(7128*C*D1**2*f**2*fd*r**2 + 7128*C*D1**2*f**2*fd*r*s - 7128*C*D1**2*f**2*fd*r - 2376*C*D1**2*f**2*fd*s + 2376*C*D1**2*f**2*fd + 9504*C*D1*Dd*f**3*r**2 + 9504*C*D1*Dd*f**3*r*s - 9504*C*D1*Dd*f**3*r - 2376*C*D1*Dd*f**3*s + 2376*C*D1*Dd*f**3 + 1386*D1**2*K*bdd1*f**2*r**2 + 1386*D1**2*K*bdd1*f**2*r*s - 1386*D1**2*K*bdd1*f**2*r - 198*D1**2*bd1**2*f*(r + s - 1)*(-14*K*r + 7*K + 10*f*(2*r + 2*s - 1) + 28*r + 14*s - 21) + 1045*D1**2*bdd1*f**3*r**2 + 5390*D1**2*bdd1*f**3*r*s - 4070*D1**2*bdd1*f**3*r + 4345*D1**2*bdd1*f**3*s**2 - 7370*D1**2*bdd1*f**3*s + 2475*D1**2*bdd1*f**3 - 1980*D1**2*bdd1*f**2*r**2 - 2574*D1**2*bdd1*f**2*r*s + 2574*D1**2*bdd1*f**2*r - 594*D1**2*bdd1*f**2*s**2 + 1188*D1**2*bdd1*f**2*s - 594*D1**2*bdd1*f**2 - 2772*D1**2*bdd1*f*g2*r**2 - 2772*D1**2*bdd1*f*g2*r*s + 5544*D1**2*bdd1*f*g2*r + 2772*D1**2*bdd1*f*g2*s - 2772*D1**2*bdd1*f*g2 - 11740*D1**2*f**3*fd*r**2 - 21640*D1**2*f**3*fd*r*s + 16690*D1**2*f**3*fd*r - 9900*D1**2*f**3*fd*s**2 + 15310*D1**2*f**3*fd*s - 7885*D1**2*f**3*fd + 11700*D1**2*f**3*fdd*r**2 + 23800*D1**2*f**3*fdd*r*s - 17750*D1**2*f**3*fdd*r + 12100*D1**2*f**3*fdd*s**2 - 18050*D1**2*f**3*fdd*s + 8975*D1**2*f**3*fdd + 35100*D1**2*f**2*fd**2*r**2 + 71400*D1**2*f**2*fd**2*r*s - 53250*D1**2*f**2*fd**2*r + 36300*D1**2*f**2*fd**2*s**2 - 54150*D1**2*f**2*fd**2*s + 17950*D1**2*f**2*fd**2 - 8910*D1**2*f**2*fd*r**2 - 10692*D1**2*f**2*fd*r*s + 9504*D1**2*f**2*fd*r - 1782*D1**2*f**2*fd*s**2 + 4752*D1**2*f**2*fd*s - 3564*D1**2*f**2*fd + 4620*D1**2*f**2*gd2*r**2 + 4620*D1**2*f**2*gd2*r*s - 4620*D1**2*f**2*gd2*r - 2772*D1**2*f**2*gdd2*r**2 - 2772*D1**2*f**2*gdd2*r*s + 2772*D1**2*f**2*gdd2*r + 9240*D1**2*f*fd*g2*r**2 + 9240*D1**2*f*fd*g2*r*s - 9240*D1**2*f*fd*g2*r - 4620*D1**2*f*fd*g2*s + 4620*D1**2*f*fd*g2 - 11088*D1**2*f*fd*gd2*r**2 - 11088*D1**2*f*fd*gd2*r*s + 11088*D1**2*f*fd*gd2*r + 2772*D1**2*f*fd*gd2*s - 2772*D1**2*f*fd*gd2 - 5544*D1**2*f*fdd*g2*r**2 - 5544*D1**2*f*fdd*g2*r*s + 5544*D1**2*f*fdd*g2*r + 2772*D1**2*f*fdd*g2*s - 2772*D1**2*f*fdd*g2 - 5544*D1**2*fd**2*g2*r**2 - 5544*D1**2*fd**2*g2*r*s + 5544*D1**2*fd**2*g2*r + 2772*D1**2*fd**2*g2*s - 11740*D1*Dd*f**4*r**2 - 21640*D1*Dd*f**4*r*s + 16690*D1*Dd*f**4*r - 9900*D1*Dd*f**4*s**2 + 15310*D1*Dd*f**4*s - 7885*D1*Dd*f**4 + 93600*D1*Dd*f**3*fd*r**2 + 190400*D1*Dd*f**3*fd*r*s - 142000*D1*Dd*f**3*fd*r + 96800*D1*Dd*f**3*fd*s**2 - 144400*D1*Dd*f**3*fd*s + 53850*D1*Dd*f**3*fd - 11880*D1*Dd*f**3*r**2 - 14256*D1*Dd*f**3*r*s + 13068*D1*Dd*f**3*r - 2376*D1*Dd*f**3*s**2 + 5940*D1*Dd*f**3*s - 4158*D1*Dd*f**3 + 18480*D1*Dd*f**2*g2*r**2 + 18480*D1*Dd*f**2*g2*r*s - 18480*D1*Dd*f**2*g2*r - 4620*D1*Dd*f**2*g2*s + 4620*D1*Dd*f**2*g2 - 22176*D1*Dd*f**2*gd2*r**2 - 22176*D1*Dd*f**2*gd2*r*s + 22176*D1*Dd*f**2*gd2*r + 2772*D1*Dd*f**2*gd2*s - 2772*D1*Dd*f**2*gd2 - 44352*D1*Dd*f*fd*g2*r**2 - 44352*D1*Dd*f*fd*g2*r*s + 44352*D1*Dd*f*fd*g2*r + 16632*D1*Dd*f*fd*g2*s - 11088*D1*Dd*f*fd*g2 + 11700*D1*Ddd*f**4*r**2 + 23800*D1*Ddd*f**4*r*s - 17750*D1*Ddd*f**4*r + 12100*D1*Ddd*f**4*s**2 - 18050*D1*Ddd*f**4*s + 8975*D1*Ddd*f**4 - 11088*D1*Ddd*f**2*g2*r**2 - 11088*D1*Ddd*f**2*g2*r*s + 11088*D1*Ddd*f**2*g2*r + 2772*D1*Ddd*f**2*g2*s - 2772*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(f**3*(r**2 + r*(206*s - 290) + 205*s**2 - 494*s + 189) - 2*f**2*(252*C*(r - 1)*(r + s - 1) + 5*fd*(57*r**2 + 294*r*s - 191*r + 237*s**2 - 341*s + 126) - (3*r + 3*s - 3)*(35*K*r + 52*r + 3*s - 87)) - 6*f*(3*fd*(7*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 40*r**2 - 52*r*s + 46*r - 12*s**2 + 25*s - 13) + (r + s - 1)*(154*g2*(r - 1) - 84*gd2*r + 42*gd2)) + 252*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 2*Dd*f*(5*f**2*(76*r**2 + r*(392*s - 265) + 316*s**2 - 475*s + 171) + 9*f*(7*K*(8*r**2 + 8*r*(s - 1) - s + 1) - 80*r**2 - 104*r*s + 98*r - 24*s**2 + 49*s - 25) - 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 35100*Dd**2*f**4*r**2 + 71400*Dd**2*f**4*r*s - 53250*Dd**2*f**4*r + 36300*Dd**2*f**4*s**2 - 54150*Dd**2*f**4*s + 17950*Dd**2*f**4 - 33264*Dd**2*f**2*g2*r**2 - 33264*Dd**2*f**2*g2*r*s + 33264*Dd**2*f**2*g2*r + 8316*Dd**2*f**2*g2*s - 5544*Dd**2*f**2*g2 + 66*b1**2*(D1**2*(15*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 30*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 7*fd*(r + s)*(r*(11*K - 17) - 6*s) + 21*fdd*(r + s)*(r*(K - 2) - s)) + D1*(Dd*(60*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-77*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 30*fd*(4*r + 4*s - 3)**2 + 476*r**2 + 644*r*s - 560*r + 168*s**2 - 329*s + 203) + 21*fd*(r**2*(8*K - 16) + 2*r*(4*K*s - 2*K - 12*s + 5) - s*(K + 8*s - 7))) - 3*Ddd*f*(-7*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 10*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 56*r**2 + 84*r*s - 70*r + 28*s**2 - 49*s + 28)) - 3*Dd**2*f*(-7*K*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 60*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 168*r**2 + 252*r*s - 210*r + 84*s**2 - 147*s + 56)) + 11*b1*(1008*C*D1**2*f*fd*r**2 + 1008*C*D1**2*f*fd*r*s - 504*C*D1**2*f*fd*r + 2016*C*D1*Dd*f**2*r**2 + 2016*C*D1*Dd*f**2*r*s - 2016*C*D1*Dd*f**2*r - 504*C*D1*Dd*f**2*s + 504*C*D1*Dd*f**2 - 420*D1**2*K*f*fd*r**2 - 420*D1**2*K*f*fd*r*s + 420*D1**2*K*f*fd*r + 210*D1**2*K*f*fd*s - 210*D1**2*K*f*fd + 252*D1**2*K*f*fdd*r**2 + 252*D1**2*K*f*fdd*r*s - 252*D1**2*K*f*fdd*r - 126*D1**2*K*f*fdd*s + 126*D1**2*K*f*fdd + 252*D1**2*K*fd**2*r**2 + 252*D1**2*K*fd**2*r*s - 252*D1**2*K*fd**2*r - 126*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (r + s - 1)*(-7*K*(2*r - 1) + 28*r + 14*s - 21)) - 3*D1**2*f**2*fd*r**2 - 618*D1**2*f**2*fd*r*s + 124*D1**2*f**2*fd*r - 615*D1**2*f**2*fd*s**2 + 532*D1**2*f**2*fd*s - 222*D1**2*f**2*fd + 285*D1**2*f**2*fdd*r**2 + 1470*D1**2*f**2*fdd*r*s - 800*D1**2*f**2*fdd*r + 1185*D1**2*f**2*fdd*s**2 - 1400*D1**2*f**2*fdd*s + 660*D1**2*f**2*fdd + 570*D1**2*f*fd**2*r**2 + 2940*D1**2*f*fd**2*r*s - 1600*D1**2*f*fd**2*r + 2370*D1**2*f*fd**2*s**2 - 2800*D1**2*f*fd**2*s + 510*D1**2*f*fd**2 - 624*D1**2*f*fd*r**2 - 660*D1**2*f*fd*r*s + 120*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 - 174*D1**2*f*fd*s + 192*D1**2*f*fd - 360*D1**2*f*fdd*r**2 - 468*D1**2*f*fdd*r*s + 360*D1**2*f*fdd*r - 108*D1**2*f*fdd*s**2 + 234*D1**2*f*fdd*s - 180*D1**2*f*fdd + 924*D1**2*f*gd2*r**2 + 924*D1**2*f*gd2*r*s - 924*D1**2*f*gd2*r - 252*D1**2*f*gdd2*r**2 - 252*D1**2*f*gdd2*r*s + 252*D1**2*f*gdd2*r - 360*D1**2*fd**2*r**2 - 468*D1**2*fd**2*r*s + 360*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 234*D1**2*fd**2*s + 924*D1**2*fd*g2*r**2 + 924*D1**2*fd*g2*r*s - 504*D1**2*fd*gd2*r**2 - 504*D1**2*fd*gd2*r*s + 252*D1**2*fd*gd2*r - 252*D1**2*fdd*g2*r**2 - 252*D1**2*fdd*g2*r*s - 840*D1*Dd*K*f**2*r**2 - 840*D1*Dd*K*f**2*r*s + 840*D1*Dd*K*f**2*r + 210*D1*Dd*K*f**2*s - 210*D1*Dd*K*f**2 + 2016*D1*Dd*K*f*fd*r**2 + 2016*D1*Dd*K*f*fd*r*s - 2016*D1*Dd*K*f*fd*r - 756*D1*Dd*K*f*fd*s + 504*D1*Dd*K*f*fd - 4*D1*Dd*f**3*r**2 - 824*D1*Dd*f**3*r*s + 414*D1*Dd*f**3*r - 820*D1*Dd*f**3*s**2 + 1026*D1*Dd*f**3*s - 411*D1*Dd*f**3 + 2280*D1*Dd*f**2*fd*r**2 + 11760*D1*Dd*f**2*fd*r*s - 6710*D1*Dd*f**2*fd*r + 9480*D1*Dd*f**2*fd*s**2 - 11810*D1*Dd*f**2*fd*s + 3600*D1*Dd*f**2*fd - 1248*D1*Dd*f**2*r**2 - 1320*D1*Dd*f**2*r*s + 1284*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 402*D1*Dd*f**2*s - 348*D1*Dd*f**2 - 2880*D1*Dd*f*fd*r**2 - 3744*D1*Dd*f*fd*r*s + 3096*D1*Dd*f*fd*r - 864*D1*Dd*f*fd*s**2 + 1836*D1*Dd*f*fd*s - 828*D1*Dd*f*fd + 3696*D1*Dd*f*g2*r**2 + 3696*D1*Dd*f*g2*r*s - 3696*D1*Dd*f*g2*r - 924*D1*Dd*f*g2*s + 924*D1*Dd*f*g2 - 2016*D1*Dd*f*gd2*r**2 - 2016*D1*Dd*f*gd2*r*s + 2016*D1*Dd*f*gd2*r + 252*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 2016*D1*Dd*fd*g2*r**2 - 2016*D1*Dd*fd*g2*r*s + 1008*D1*Dd*fd*g2*r + 252*D1*Dd*fd*g2*s + 504*D1*Ddd*K*f**2*r**2 + 504*D1*Ddd*K*f**2*r*s - 504*D1*Ddd*K*f**2*r - 126*D1*Ddd*K*f**2*s + 126*D1*Ddd*K*f**2 + 380*D1*Ddd*f**3*r**2 + 1960*D1*Ddd*f**3*r*s - 1170*D1*Ddd*f**3*r + 1580*D1*Ddd*f**3*s**2 - 2070*D1*Ddd*f**3*s + 885*D1*Ddd*f**3 - 720*D1*Ddd*f**2*r**2 - 936*D1*Ddd*f**2*r*s + 828*D1*Ddd*f**2*r - 216*D1*Ddd*f**2*s**2 + 450*D1*Ddd*f**2*s - 288*D1*Ddd*f**2 - 1008*D1*Ddd*f*g2*r**2 - 1008*D1*Ddd*f*g2*r*s + 1008*D1*Ddd*f*g2*r + 252*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(30*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(r + s - 1)*(77*K*(2*r - 1) + 120*fd*(2*r + 2*s - 1) - 238*r - 84*s + 161) + 21*fd*(r**2*(4*K - 8) + r*(K*(4*s - 3) - 12*s + 7) - s*(K + 4*s - 5))) - 3*Dd*f*(-7*K*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 10*f*(4*r + 4*s - 3)**2 + 224*r**2 + 336*r*(s - 1) + 112*s**2 - 238*s + 119)) + 1512*Dd**2*K*f**2*r**2 + 1512*Dd**2*K*f**2*r*s - 1512*Dd**2*K*f**2*r - 378*Dd**2*K*f**2*s + 252*Dd**2*K*f**2 + 1140*Dd**2*f**3*r**2 + 5880*Dd**2*f**3*r*s - 3510*Dd**2*f**3*r + 4740*Dd**2*f**3*s**2 - 6210*Dd**2*f**3*s + 1770*Dd**2*f**3 - 2160*Dd**2*f**2*r**2 - 2808*Dd**2*f**2*r*s + 2484*Dd**2*f**2*r - 648*Dd**2*f**2*s**2 + 1350*Dd**2*f**2*s - 576*Dd**2*f**2 - 3024*Dd**2*f*g2*r**2 - 3024*Dd**2*f*g2*r*s + 3024*Dd**2*f*g2*r + 756*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(3465*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk3*ct**3*k2**3*st**4*(3*b1*(D1**2*(f*(6*fd*(r*(9*C - 14)*(2*s - 1) - 10*s**2 + 10*s - 5) - 5*fdd*(r*(4*C - 7)*(2*s - 1) - 6*s**2 + 6*s - 3)) - 5*fd**2*(r*(4*C - 7)*(2*s - 1) + s*(6 - 6*s))) + D1*f*(Dd*(6*f*(-9*C*s + r*(18*C - 28)*(2*s - 1) - 20*s**2 + 34*s - 10) - 5*fd*(2*s - 1)*(4*C*(8*r - 1) - 56*r - 24*s + 19)) + 5*Ddd*f*(4*C*s - r*(8*C - 14)*(2*s - 1) + 12*s**2 - 19*s + 6)) - 5*Dd**2*f**2*(4*C*(6*r*(2*s - 1) - 3*s + 2) + r*(42 - 84*s) - 36*s**2 + 57*s - 20)) + f*(D1**2*(f*(-15*bdd1*s*(4*C*(r - 1) - 7*r - 3*s + 7) + 2*fd*(-31*C*s + r*(31*C - 46)*(3*s - 1) - 45*s**2 + 76*s - 15) - 5*fdd*(-8*C*s + r*(8*C - 11)*(3*s - 1) - 9*s**2 + 17*s - 3)) - 5*fd**2*(8*C*(6*r*s - 2*r - 2*s + 1) - 66*r*s + 22*r - 18*s**2 + 34*s - 11)) + 3*D1*bd1*(D1*(6*f*s*(9*C*(r - 1) - 14*r - 5*s + 14) - 5*fd*(4*C*(4*r*s - r - 2*s + 1) - 28*r*s + 7*r - 12*s**2 + 20*s - 7)) - 5*Dd*f*(4*C*(8*r*s - 2*r - 5*s + 2) - 56*r*s + 14*r - 24*s**2 + 47*s - 14)) + D1*f*(Dd*(2*f*(-31*C*s + r*(62*C - 92)*(2*s - 1) - 60*s**2 + 106*s - 30) - 5*fd*(8*C*(24*r*s - 10*r - 7*s + 3) - 264*r*s + 110*r - 72*s**2 + 137*s - 45)) - 5*Ddd*f*(-8*C*s + r*(16*C - 22)*(2*s - 1) - 12*s**2 + 23*s - 6)) - 5*Dd**2*f**2*(8*C*(6*r*(2*s - 1) - 3*s + 2) - 66*r*(2*s - 1) - 36*s**2 + 69*s - 28)))/(105*d**2*k1*k3**4) + 2*D1**2*Pk1*Pk3*ct**3*k2**3*st**2*(84*b1**2*(C - 1)*(D1**2*r*(11*fd - 3*fdd)*(r + s - 1) + D1*(Dd*(11*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1*(76*C*D1**2*f*fd*r**2 - 344*C*D1**2*f*fd*r*s - 108*C*D1**2*f*fd*r - 140*C*D1**2*f*fd*s + 140*C*D1**2*f*fd - 108*C*D1**2*f*fdd*r**2 + 312*C*D1**2*f*fdd*r*s + 12*C*D1**2*f*fdd*r + 84*C*D1**2*f*fdd*s - 84*C*D1**2*f*fdd - 108*C*D1**2*fd**2*r**2 + 312*C*D1**2*fd**2*r*s + 12*C*D1**2*fd**2*r + 84*C*D1**2*fd**2*s - 84*C*D1**2*fd**2 + 152*C*D1*Dd*f**2*r**2 - 688*C*D1*Dd*f**2*r*s + 268*C*D1*Dd*f**2*r + 172*C*D1*Dd*f**2*s + 38*C*D1*Dd*f**2 - 864*C*D1*Dd*f*fd*r**2 + 2496*C*D1*Dd*f*fd*r*s - 360*C*D1*Dd*f*fd*r + 24*C*D1*Dd*f*fd*s - 180*C*D1*Dd*f*fd - 216*C*D1*Ddd*f**2*r**2 + 624*C*D1*Ddd*f**2*r*s - 204*C*D1*Ddd*f**2*r - 156*C*D1*Ddd*f**2*s - 54*C*D1*Ddd*f**2 - 648*C*Dd**2*f**2*r**2 + 1872*C*Dd**2*f**2*r*s - 612*C*Dd**2*f**2*r - 468*C*Dd**2*f**2*s + 312*C*Dd**2*f**2 - 84*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 230*D1**2*f*fd*r**2 + 1148*D1**2*f*fd*r*s - 294*D1**2*f*fd*r + 498*D1**2*f*fd*s**2 - 358*D1**2*f*fd*s + 109*D1**2*f*fd - 66*D1**2*f*fdd*r**2 - 924*D1**2*f*fdd*r*s + 294*D1**2*f*fdd*r - 438*D1**2*f*fdd*s**2 + 354*D1**2*f*fdd*s - 135*D1**2*f*fdd - 66*D1**2*fd**2*r**2 - 924*D1**2*fd**2*r*s + 294*D1**2*fd**2*r - 438*D1**2*fd**2*s**2 + 354*D1**2*fd**2*s + 84*D1**2*fd**2 + 460*D1*Dd*f**2*r**2 + 2296*D1*Dd*f**2*r*s - 1378*D1*Dd*f**2*r + 996*D1*Dd*f**2*s**2 - 1570*D1*Dd*f**2*s + 613*D1*Dd*f**2 - 528*D1*Dd*f*fd*r**2 - 7392*D1*Dd*f*fd*r*s + 3156*D1*Dd*f*fd*r - 3504*D1*Dd*f*fd*s**2 + 4092*D1*Dd*f*fd*s - 1002*D1*Dd*f*fd - 132*D1*Ddd*f**2*r**2 - 1848*D1*Ddd*f**2*r*s + 990*D1*Ddd*f**2*r - 876*D1*Ddd*f**2*s**2 + 1338*D1*Ddd*f**2*s - 471*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(D1*(11*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 396*Dd**2*f**2*r**2 - 5544*Dd**2*f**2*r*s + 2970*Dd**2*f**2*r - 2628*Dd**2*f**2*s**2 + 4014*Dd**2*f**2*s - 1362*Dd**2*f**2) - f*(1674*C*D1**2*f*fd*r**2 + 3144*C*D1**2*f*fd*r*s - 2164*C*D1**2*f*fd*r - 1048*C*D1**2*f*fd*s + 558*C*D1**2*f*fd - 1566*C*D1**2*f*fdd*r**2 - 2544*C*D1**2*f*fdd*r*s + 1892*C*D1**2*f*fdd*r + 848*C*D1**2*f*fdd*s - 522*C*D1**2*f*fdd - 3132*C*D1**2*fd**2*r**2 - 5088*C*D1**2*fd**2*r*s + 3784*C*D1**2*fd**2*r + 1696*C*D1**2*fd**2*s - 848*C*D1**2*fd**2 + 2232*C*D1*Dd*f**2*r**2 + 4192*C*D1*Dd*f**2*r*s - 3212*C*D1*Dd*f**2*r - 1048*C*D1*Dd*f**2*s + 558*C*D1*Dd*f**2 - 12528*C*D1*Dd*f*fd*r**2 - 20352*C*D1*Dd*f*fd*r*s + 15788*C*D1*Dd*f*fd*r + 5936*C*D1*Dd*f*fd*s - 3588*C*D1*Dd*f*fd - 2088*C*D1*Ddd*f**2*r**2 - 3392*C*D1*Ddd*f**2*r*s + 2740*C*D1*Ddd*f**2*r + 848*C*D1*Ddd*f**2*s - 522*C*D1*Ddd*f**2 - 6264*C*Dd**2*f**2*r**2 - 10176*C*Dd**2*f**2*r*s + 8220*C*Dd**2*f**2*r + 2544*C*Dd**2*f**2*s - 1696*C*Dd**2*f**2 + 252*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 9*D1**2*bdd1*f*(2*C*(9*r**2 - 26*r*s + 10*r + 40*s - 5) + 11*r**2 + 154*r*s - 78*r + 73*s**2 - 182*s + 39) - 2385*D1**2*f*fd*r**2 - 4998*D1**2*f*fd*r*s + 3256*D1**2*f*fd*r - 1029*D1**2*f*fd*s**2 + 2352*D1**2*f*fd*s - 1138*D1**2*f*fd + 1989*D1**2*f*fdd*r**2 + 3930*D1**2*f*fdd*r*s - 2636*D1**2*f*fdd*r + 879*D1**2*f*fdd*s**2 - 1896*D1**2*f*fdd*s + 956*D1**2*f*fdd + 3978*D1**2*fd**2*r**2 + 7860*D1**2*fd**2*r*s - 5272*D1**2*fd**2*r + 1758*D1**2*fd**2*s**2 - 3792*D1**2*fd**2*s + 1310*D1**2*fd**2 - 3180*D1*Dd*f**2*r**2 - 6664*D1*Dd*f**2*r*s + 4922*D1*Dd*f**2*r - 1372*D1*Dd*f**2*s**2 + 3038*D1*Dd*f**2*s - 1481*D1*Dd*f**2 + 15912*D1*Dd*f*fd*r**2 + 31440*D1*Dd*f*fd*r*s - 22382*D1*Dd*f*fd*r + 7032*D1*Dd*f*fd*s**2 - 15030*D1*Dd*f*fd*s + 6428*D1*Dd*f*fd + 2652*D1*Ddd*f**2*r**2 + 5240*D1*Ddd*f**2*r*s - 3946*D1*Ddd*f**2*r + 1172*D1*Ddd*f**2*s**2 - 2482*D1*Ddd*f**2*s + 1249*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(2*C*(19*r**2 - 86*r*s + 102*r + 156*s - 51) + 115*r**2 + 574*r*s - 510*r + 249*s**2 - 714*s + 255) - 6*fd*(2*C*(18*r**2 - 52*r*s + 9*r + 33*s - 20) + 22*r**2 + 308*r*s - 127*r + 146*s**2 - 241*s + 91)) - 6*Dd*f*(2*C*(36*r**2 - 104*r*s + 37*r + 93*s - 45) + 44*r**2 + 616*r*s - 321*r + 292*s**2 - 587*s + 221)) + 7956*Dd**2*f**2*r**2 + 15720*Dd**2*f**2*r*s - 11838*Dd**2*f**2*r + 3516*Dd**2*f**2*s**2 - 7446*Dd**2*f**2*s + 3206*Dd**2*f**2))/(315*d**2*k1*k3**4) + D1**2*Pk1*Pk3*ct**3*k2**3*(5940*C*D1**2*f**2*fd*r**2 - 3960*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd + 7920*C*D1*Dd*f**3*r**2 - 3960*C*D1*Dd*f**3*r + 1980*C*D1*Dd*f**3 + 1716*D1**2*K*bdd1*f**2*r**2 + 3828*D1**2*K*bdd1*f**2*r*s - 3828*D1**2*K*bdd1*f**2*r - 3168*D1**2*b2*f*fd*r**2 - 3168*D1**2*b2*f*fd*r*s + 3168*D1**2*b2*f*fd*r + 1584*D1**2*b2*f*fd*s - 1584*D1**2*b2*f*fd + 1584*D1**2*b2*f*fdd*r**2 + 1584*D1**2*b2*f*fdd*r*s - 1584*D1**2*b2*f*fdd*r - 792*D1**2*b2*f*fdd*s + 792*D1**2*b2*f*fdd + 1584*D1**2*b2*fd**2*r**2 + 1584*D1**2*b2*fd**2*r*s - 1584*D1**2*b2*fd**2*r - 792*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*f*(14*K*(6*r**2 + 2*r*s - 3*r + s - 1) + 3*f*(18*r**2 + r*(116*s - 55) + 98*s**2 - 111*s + 33) - 35*r**2 + 238*r*s - 140*r + 217*s**2 - 364*s + 147) - 1584*D1**2*bd2*f**2*r**2 - 1584*D1**2*bd2*f**2*r*s + 1584*D1**2*bd2*f**2*r + 3168*D1**2*bd2*f*fd*r**2 + 3168*D1**2*bd2*f*fd*r*s - 3168*D1**2*bd2*f*fd*r - 792*D1**2*bd2*f*fd*s + 792*D1**2*bd2*f*fd - 3410*D1**2*bdd1*f**3*r**2 - 7172*D1**2*bdd1*f**3*r*s + 6270*D1**2*bdd1*f**3*r + 2178*D1**2*bdd1*f**3*s - 3003*D1**2*bdd1*f**3 - 3729*D1**2*bdd1*f**2*r**2 - 10362*D1**2*bdd1*f**2*r*s + 10362*D1**2*bdd1*f**2*r - 4455*D1**2*bdd1*f**2*s**2 + 8910*D1**2*bdd1*f**2*s - 4455*D1**2*bdd1*f**2 + 5544*D1**2*bdd1*f*g2*r**2 + 1848*D1**2*bdd1*f*g2*r*s - 3696*D1**2*bdd1*f*g2*r + 1848*D1**2*bdd1*f*g2*s + 1848*D1**2*bdd1*f*g2 + 792*D1**2*bdd2*f**2*r**2 + 792*D1**2*bdd2*f**2*r*s - 792*D1**2*bdd2*f**2*r - 11520*D1**2*f**3*fd*r**2 - 21120*D1**2*f**3*fd*r*s + 16320*D1**2*f**3*fd*r - 19800*D1**2*f**3*fd*s**2 + 25080*D1**2*f**3*fd*s - 12780*D1**2*f**3*fd + 3120*D1**2*f**3*fdd*r**2 + 21120*D1**2*f**3*fdd*r*s - 12120*D1**2*f**3*fdd*r + 19800*D1**2*f**3*fdd*s**2 - 25080*D1**2*f**3*fdd*s + 10680*D1**2*f**3*fdd + 9360*D1**2*f**2*fd**2*r**2 + 63360*D1**2*f**2*fd**2*r*s - 36360*D1**2*f**2*fd**2*r + 59400*D1**2*f**2*fd**2*s**2 - 75240*D1**2*f**2*fd**2*s + 20460*D1**2*f**2*fd**2 - 11880*D1**2*f**2*fd*r**2 - 5940*D1**2*f**2*fd*r*s + 9900*D1**2*f**2*fd*r + 1980*D1**2*f**2*fd*s - 3960*D1**2*f**2*fd + 18876*D1**2*f**2*gd2*r**2 + 6072*D1**2*f**2*gd2*r*s - 6072*D1**2*f**2*gd2*r - 3432*D1**2*f**2*gdd2*r**2 - 7656*D1**2*f**2*gdd2*r*s + 7656*D1**2*f**2*gdd2*r + 37752*D1**2*f*fd*g2*r**2 + 12144*D1**2*f*fd*g2*r*s - 37752*D1**2*f*fd*g2*r - 6072*D1**2*f*fd*g2*s + 18876*D1**2*f*fd*g2 - 13728*D1**2*f*fd*gd2*r**2 - 30624*D1**2*f*fd*gd2*r*s + 22176*D1**2*f*fd*gd2*r + 7656*D1**2*f*fd*gd2*s - 7656*D1**2*f*fd*gd2 - 6864*D1**2*f*fdd*g2*r**2 - 15312*D1**2*f*fdd*g2*r*s + 6864*D1**2*f*fdd*g2*r + 7656*D1**2*f*fdd*g2*s - 3432*D1**2*f*fdd*g2 - 6864*D1**2*fd**2*g2*r**2 - 15312*D1**2*fd**2*g2*r*s + 6864*D1**2*fd**2*g2*r + 7656*D1**2*fd**2*g2*s + 13860*D1*Dd*b1**3*(K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) - 6336*D1*Dd*b2*f**2*r**2 - 6336*D1*Dd*b2*f**2*r*s + 6336*D1*Dd*b2*f**2*r + 1584*D1*Dd*b2*f**2*s - 1584*D1*Dd*b2*f**2 + 12672*D1*Dd*b2*f*fd*r**2 + 12672*D1*Dd*b2*f*fd*r*s - 12672*D1*Dd*b2*f*fd*r - 4752*D1*Dd*b2*f*fd*s + 3168*D1*Dd*b2*f*fd + 6336*D1*Dd*bd2*f**2*r**2 + 6336*D1*Dd*bd2*f**2*r*s - 6336*D1*Dd*bd2*f**2*r - 792*D1*Dd*bd2*f**2*s + 792*D1*Dd*bd2*f**2 - 11520*D1*Dd*f**4*r**2 - 21120*D1*Dd*f**4*r*s + 16320*D1*Dd*f**4*r - 19800*D1*Dd*f**4*s**2 + 25080*D1*Dd*f**4*s - 12780*D1*Dd*f**4 + 24960*D1*Dd*f**3*fd*r**2 + 168960*D1*Dd*f**3*fd*r*s - 96960*D1*Dd*f**3*fd*r + 158400*D1*Dd*f**3*fd*s**2 - 200640*D1*Dd*f**3*fd*s + 62280*D1*Dd*f**3*fd - 15840*D1*Dd*f**3*r**2 - 7920*D1*Dd*f**3*r*s + 11880*D1*Dd*f**3*r + 1980*D1*Dd*f**3*s - 3960*D1*Dd*f**3 + 75504*D1*Dd*f**2*g2*r**2 + 24288*D1*Dd*f**2*g2*r*s - 49896*D1*Dd*f**2*g2*r - 6072*D1*Dd*f**2*g2*s + 18876*D1*Dd*f**2*g2 - 27456*D1*Dd*f**2*gd2*r**2 - 61248*D1*Dd*f**2*gd2*r*s + 52800*D1*Dd*f**2*gd2*r + 7656*D1*Dd*f**2*gd2*s - 7656*D1*Dd*f**2*gd2 - 54912*D1*Dd*f*fd*g2*r**2 - 122496*D1*Dd*f*fd*g2*r*s + 71808*D1*Dd*f*fd*g2*r + 45936*D1*Dd*f*fd*g2*s - 22176*D1*Dd*f*fd*g2 + 3168*D1*Ddd*b2*f**2*r**2 + 3168*D1*Ddd*b2*f**2*r*s - 3168*D1*Ddd*b2*f**2*r - 792*D1*Ddd*b2*f**2*s + 792*D1*Ddd*b2*f**2 + 3120*D1*Ddd*f**4*r**2 + 21120*D1*Ddd*f**4*r*s - 12120*D1*Ddd*f**4*r + 19800*D1*Ddd*f**4*s**2 - 25080*D1*Ddd*f**4*s + 10680*D1*Ddd*f**4 - 13728*D1*Ddd*f**2*g2*r**2 - 30624*D1*Ddd*f**2*g2*r*s + 22176*D1*Ddd*f**2*g2*r + 7656*D1*Ddd*f**2*g2*s - 3432*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(f**3*(530*r**2 + 692*r*s - 330*r - 180*s**2 - 18*s + 33) - f**2*(252*C*(r**2 + 2*r*(s + 1) - 1) + 4*fd*(465*r**2 + r*(978*s - 766) - 262*s + 105) + 3*r**2*(286*K - 443) + 3*r*(92*K*(s - 1) - 446*s + 26) - 243*s**2 + 234*s + 261) + 6*f*(fd*(2*K*(52*r**2 + 116*r*s - 84*r - 29*s + 29) - 226*r**2 - 628*r*s + 427*r - 270*s**2 + 427*s - 157) - 14*g2*(7*r**2 + 24*r*s + 22*r - 6*s - 11) + 28*gd2*(6*r**2 + 2*r*s - 3*r + s - 1)) + 168*fd*g2*(6*r**2 + 2*r*(s - 3) - s)) + 2*Dd*f*(f**2*(-1240*r**2 + r*(2102 - 2608*s) + 722*s - 483) + 3*f*(K*(208*r**2 + 464*r*s - 400*r - 58*s + 58) - 452*r**2 - 1256*r*s + 1055*r - 540*s**2 + 967*s - 427) + 84*g2*(24*r**2 + 8*r*(s - 2) + 3*s))) + 9504*Dd**2*b2*f**2*r**2 + 9504*Dd**2*b2*f**2*r*s - 9504*Dd**2*b2*f**2*r - 2376*Dd**2*b2*f**2*s + 1584*Dd**2*b2*f**2 + 9360*Dd**2*f**4*r**2 + 63360*Dd**2*f**4*r*s - 36360*Dd**2*f**4*r + 59400*Dd**2*f**4*s**2 - 75240*Dd**2*f**4*s + 20460*Dd**2*f**4 - 41184*Dd**2*f**2*g2*r**2 - 91872*Dd**2*f**2*g2*r*s + 66528*Dd**2*f**2*g2*r + 22968*Dd**2*f**2*g2*s - 15312*Dd**2*f**2*g2 + 33*b1**2*(420*D1**2*bd1*(K - 1)*(3*r**2 + 3*r*(s - 1) - s + 1) - D1**2*(3*f*fdd*(36*r**2 + 2*r*(116*s - 79) + 196*s**2 - 286*s + 139) + 6*fd**2*(18*r**2 + r*(116*s - 79) + 98*s**2 - 143*s + 45) - fd*(14*K*(7*r**2 + 24*r*s - 36*r - 18*s + 18) + 3*f*(44*r**2 + 2*r*(92*s - 53) + 140*s**2 - 194*s + 89) + 7*r**2*(55 - 40*C) + 7*r*(-40*C*(s - 1) + 38*s + 32) + 119*s**2 + 252*s - 252) + 7*fdd*(4*K*(3*r**2 + r*(s - 4) - 2*s + 2) - 5*r**2 + 2*r*(17*s + 8) + 31*s**2 + 8*s - 8) + 840*gd2*r*(r + s - 1)) + D1*(Dd*(6*f**2*(44*r**2 + 2*r*(92*s - 57) + 140*s**2 - 186*s + 81) + f*(-280*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 14*K*(28*r**2 + r*(96*s - 62) - 24*s + 7) - 6*fd*(144*r**2 + 8*r*(116*s - 73) + 784*s**2 - 1080*s + 365) + 1540*r**2 + 14*r*(76*s - 93) + 476*s**2 - 742*s + 623) - 14*fd*(2*K*(24*r**2 + 8*r*(s - 3) - 9*s + 8) - 20*r**2 + 136*r*s + 3*r + 124*s**2 - 63*s - 16) - 840*g2*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*f*(28*K*(12*r**2 + 4*r*(s - 2) - s + 3) + 6*f*(36*r**2 + 2*r*(116*s - 67) + 196*s**2 - 254*s + 107) - 140*r**2 + 952*r*s - 406*r + 868*s**2 - 1106*s + 399)) - 2*Dd**2*f*(7*K*(72*r**2 + 24*r*(s - 2) - 6*s + 4) + 6*f*(54*r**2 + 3*r*(116*s - 67) + 294*s**2 - 381*s + 107) - 210*r**2 + 1428*r*s - 609*r + 1302*s**2 - 1659*s + 455)) + 11*b1*(-504*C*D1**2*f*fd*r**2 - 1008*C*D1**2*f*fd*r*s + 1512*C*D1**2*f*fd*r + 504*C*D1**2*f*fd*s - 504*C*D1**2*f*fd - 1008*C*D1*Dd*f**2*r**2 - 2016*C*D1*Dd*f**2*r*s + 1512*C*D1*Dd*f**2*r + 504*C*D1*Dd*f**2*s - 252*C*D1*Dd*f**2 - 1716*D1**2*K*f*fd*r**2 - 552*D1**2*K*f*fd*r*s + 1716*D1**2*K*f*fd*r + 276*D1**2*K*f*fd*s - 858*D1**2*K*f*fd + 312*D1**2*K*f*fdd*r**2 + 696*D1**2*K*f*fdd*r*s - 312*D1**2*K*f*fdd*r - 348*D1**2*K*f*fdd*s + 156*D1**2*K*f*fdd + 312*D1**2*K*fd**2*r**2 + 696*D1**2*K*fd**2*r*s - 312*D1**2*K*fd**2*r - 348*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(28*K*(6*r**2 + 2*r*s - 3*r + s + 1) + 3*f*(36*r**2 + 2*r*(116*s - 55) + 196*s**2 - 222*s + 75) - 70*r**2 + 476*r*s - 280*r + 434*s**2 - 728*s + 238) + 1590*D1**2*f**2*fd*r**2 + 2076*D1**2*f**2*fd*r*s - 2114*D1**2*f**2*fd*r - 540*D1**2*f**2*fd*s**2 + 46*D1**2*f**2*fd*s + 137*D1**2*f**2*fd - 930*D1**2*f**2*fdd*r**2 - 1956*D1**2*f**2*fdd*r*s + 1354*D1**2*f**2*fdd*r + 454*D1**2*f**2*fdd*s - 37*D1**2*f**2*fdd - 1860*D1**2*f*fd**2*r**2 - 3912*D1**2*f*fd**2*r*s + 2708*D1**2*f*fd**2*r + 908*D1**2*f*fd**2*s - 884*D1**2*f*fd**2 + 2658*D1**2*f*fd*r**2 + 2676*D1**2*f*fd*r*s - 3918*D1**2*f*fd*r + 486*D1**2*f*fd*s**2 - 1590*D1**2*f*fd*s + 1833*D1**2*f*fd - 678*D1**2*f*fdd*r**2 - 1884*D1**2*f*fdd*r*s + 678*D1**2*f*fdd*r - 810*D1**2*f*fdd*s**2 + 942*D1**2*f*fdd*s - 339*D1**2*f*fdd - 588*D1**2*f*gd2*r**2 - 2016*D1**2*f*gd2*r*s + 2016*D1**2*f*gd2*r + 504*D1**2*f*gdd2*r**2 + 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*r - 678*D1**2*fd**2*r**2 - 1884*D1**2*fd**2*r*s + 678*D1**2*fd**2*r - 810*D1**2*fd**2*s**2 + 942*D1**2*fd**2*s - 588*D1**2*fd*g2*r**2 - 2016*D1**2*fd*g2*r*s + 3024*D1**2*fd*g2*r + 1512*D1**2*fd*g2*s - 1512*D1**2*fd*g2 + 1008*D1**2*fd*gd2*r**2 + 336*D1**2*fd*gd2*r*s - 840*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s + 336*D1**2*fd*gd2 + 504*D1**2*fdd*g2*r**2 + 168*D1**2*fdd*g2*r*s - 672*D1**2*fdd*g2*r - 336*D1**2*fdd*g2*s + 336*D1**2*fdd*g2 - 3432*D1*Dd*K*f**2*r**2 - 1104*D1*Dd*K*f**2*r*s + 2268*D1*Dd*K*f**2*r + 276*D1*Dd*K*f**2*s - 858*D1*Dd*K*f**2 + 2496*D1*Dd*K*f*fd*r**2 + 5568*D1*Dd*K*f*fd*r*s - 3264*D1*Dd*K*f*fd*r - 2088*D1*Dd*K*f*fd*s + 1008*D1*Dd*K*f*fd + 2120*D1*Dd*f**3*r**2 + 2768*D1*Dd*f**3*r*s - 2444*D1*Dd*f**3*r - 720*D1*Dd*f**3*s**2 + 28*D1*Dd*f**3*s + 170*D1*Dd*f**3 - 7440*D1*Dd*f**2*fd*r**2 - 15648*D1*Dd*f**2*fd*r*s + 11188*D1*Dd*f**2*fd*r + 3772*D1*Dd*f**2*fd*s - 2262*D1*Dd*f**2*fd + 5316*D1*Dd*f**2*r**2 + 5352*D1*Dd*f**2*r*s - 5334*D1*Dd*f**2*r + 972*D1*Dd*f**2*s**2 - 2310*D1*Dd*f**2*s + 1815*D1*Dd*f**2 - 5424*D1*Dd*f*fd*r**2 - 15072*D1*Dd*f*fd*r*s + 7836*D1*Dd*f*fd*r - 6480*D1*Dd*f*fd*s**2 + 8892*D1*Dd*f*fd*s - 2562*D1*Dd*f*fd - 2352*D1*Dd*f*g2*r**2 - 8064*D1*Dd*f*g2*r*s + 5208*D1*Dd*f*g2*r + 2016*D1*Dd*f*g2*s - 588*D1*Dd*f*g2 + 4032*D1*Dd*f*gd2*r**2 + 1344*D1*Dd*f*gd2*r*s - 2016*D1*Dd*f*gd2*r - 168*D1*Dd*f*gd2*s + 168*D1*Dd*f*gd2 + 4032*D1*Dd*fd*g2*r**2 + 1344*D1*Dd*fd*g2*r*s - 4032*D1*Dd*fd*g2*r - 1512*D1*Dd*fd*g2*s + 1344*D1*Dd*fd*g2 + 624*D1*Ddd*K*f**2*r**2 + 1392*D1*Ddd*K*f**2*r*s - 1008*D1*Ddd*K*f**2*r - 348*D1*Ddd*K*f**2*s + 156*D1*Ddd*K*f**2 - 1240*D1*Ddd*f**3*r**2 - 2608*D1*Ddd*f**3*r*s + 1924*D1*Ddd*f**3*r + 652*D1*Ddd*f**3*s - 310*D1*Ddd*f**3 - 1356*D1*Ddd*f**2*r**2 - 3768*D1*Ddd*f**2*r*s + 2562*D1*Ddd*f**2*r - 1620*D1*Ddd*f**2*s**2 + 2562*D1*Ddd*f**2*s - 1149*D1*Ddd*f**2 + 2016*D1*Ddd*f*g2*r**2 + 672*D1*Ddd*f*g2*r*s - 1344*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s + 504*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(3*f**2*(44*r**2 + 2*r*(92*s - 61) + 140*s**2 - 178*s + 73) - 2*f*(140*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 7*K*(14*r**2 + 48*r*s - 2*r - 6*s - 11) + 12*fd*(18*r**2 + r*(116*s - 67) + 98*s**2 - 127*s + 34) - 385*r**2 - 266*r*s + 630*r - 119*s**2 + 378*s - 378) - 28*fd*(K*(12*r**2 + 4*r*s - 11*r - 3*s + 2) - 5*r**2 + 34*r*s - 2*r + 31*s**2 - 22*s - 2) - 840*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 2*Dd*f*(14*K*(48*r**2 + 4*r*(4*s - 7) + 2*s + 1) + 3*f*(144*r**2 + 8*r*(116*s - 61) + 784*s**2 - 952*s + 277) - 280*r**2 + 1904*r*s - 966*r + 1736*s**2 - 2562*s + 868)) + 1872*Dd**2*K*f**2*r**2 + 4176*Dd**2*K*f**2*r*s - 3024*Dd**2*K*f**2*r - 1044*Dd**2*K*f**2*s + 696*Dd**2*K*f**2 - 3720*Dd**2*f**3*r**2 - 7824*Dd**2*f**3*r*s + 5772*Dd**2*f**3*r + 1956*Dd**2*f**3*s - 1304*Dd**2*f**3 - 4068*Dd**2*f**2*r**2 - 11304*Dd**2*f**2*r*s + 7686*Dd**2*f**2*r - 4860*Dd**2*f**2*s**2 + 7686*Dd**2*f**2*s - 2694*Dd**2*f**2 + 6048*Dd**2*f*g2*r**2 + 2016*Dd**2*f*g2*r*s - 4032*Dd**2*f*g2*r - 504*Dd**2*f*g2*s + 336*Dd**2*f*g2))/(3465*d**2*k1*k3**4) - 4*D1**2*Pk1*Pk3*ct**3*k2*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(7*d**2*k1*k3**2) + 2*D1**2*Pk1*Pk3*ct**3*k2*st**2*(-84*b1**2*(C - 1)*(D1*Dd*(11*f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(11*fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 3*b1*(D1**2*(f*(-84*bdd1*s*(C - 1)*(2*r - 1) + fd*(r*(140*C + 4)*(2*s - 1) + 498*s**2 - s*(140*C + 358) + 249) - 3*fdd*(r*(28*C - 4)*(2*s - 1) + 146*s**2 - s*(28*C + 118) + 73)) - 6*fd**2*(14*C*(r*(2*s - 1) - s + 1) + r*(2 - 4*s) + 73*s**2 - 59*s - 14)) - 28*D1*bd1*(C - 1)*(D1*(11*f*s*(1 - 2*r) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + 2*D1*f*(Dd*(f*(r*(140*C + 4)*(2*s - 1) + 498*s**2 - s*(70*C + 500) + 249) - 6*fd*(2*s - 1)*(7*C*(8*r - 3) - 8*r + 146*s - 58)) - 3*Ddd*f*(r*(28*C - 4)*(2*s - 1) + 146*s**2 - s*(14*C + 144) + 73)) - 6*Dd**2*f**2*(14*C*(6*r*(2*s - 1) - 3*s + 2) + r*(12 - 24*s) + 438*s**2 - 432*s + 69)) + f*(-252*D1**2*bd1**2*s*(C - 1)*(2*r - 1) + D1**2*(f*(-9*bdd1*s*(r*(28*C - 4) + 73*s - 24) + fd*(-r*(176*C - 348)*(3*s - 1) + 1029*s**2 + s*(176*C - 1034) + 343) + fdd*(r*(160*C - 264)*(3*s - 1) - 879*s**2 + s*(850 - 160*C) - 293)) + 2*fd**2*(80*C*(r*(6*s - 2) - 2*s + 1) - 264*r*(3*s - 1) - 879*s**2 + 850*s - 132)) + 3*D1*bd1*(D1*(f*s*(140*C*r + 4*r + 249*s - 144) - 6*fd*(-14*C*s + r*(14*C - 2)*(4*s - 1) + 146*s**2 - 83*s + 12)) - 12*Dd*f*(-7*C*s + r*(14*C - 2)*(4*s - 1) + 146*s**2 - 96*s + 12)) - 2*D1*f*(Dd*(f*(r*(176*C - 348)*(2*s - 1) - 686*s**2 + s*(860 - 88*C) - 343) + 2*fd*(-40*C*(2*r*(12*s - 5) - 7*s + 3) + 132*r*(12*s - 5) + 1758*s**2 - 1927*s + 491)) + Ddd*f*(-r*(160*C - 264)*(2*s - 1) + 586*s**2 + s*(80*C - 718) + 293)) + 2*Dd**2*f**2*(80*C*(6*r*(2*s - 1) - 3*s + 2) - 792*r*(2*s - 1) - 1758*s**2 + 2154*s - 557)))/(315*d**2*k1*k3**2) - 2*D1**2*Pk1*Pk3*ct**3*k2*(-84*b1**2*(C - 1)*(D1*Dd*(2*f*(-4*r*s + 2*r + s) + fd*(8*r*s - 6*r - s + 1)) - D1*(D1*r*(2*fd - fdd)*(s - 1) + Ddd*f*(-4*r*s + 2*r + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 3*b1*(D1**2*(f*(-28*bdd1*s*(C - 1)*(2*r - 1) + fd*(64*C*(2*r**2 + 4*r*(s - 1) - 2*s + 1) - 64*r**2 - 124*r*s + 158*r + 294*s**2 - 166*s + 99) - 2*fdd*(C*(4*r**2 + 92*r*s - 50*r - 46*s + 2) - 2*r**2 - 38*r*s + 22*r + 147*s**2 - 101*s + 72)) + 2*fd**2*(C*(-4*r**2 - 92*r*s + 50*r + 46*s - 46) + 2*r**2 + 38*r*s - 22*r - 147*s**2 + 101*s + 46)) - 28*D1*bd1*(C - 1)*(D1*(2*f*s*(1 - 2*r) + fd*r*(4*s - 2) - fd*s + fd) + 2*Dd*f*(r*(8*s - 2) - 3*s + 1)) + 2*D1*f*(Dd*(f*(32*C*(4*r**2 + 8*r*s - 6*r - 2*s + 1) - 64*r**2 - 124*r*s + 94*r + 294*s**2 - 263*s + 131) - 2*fd*(C*(16*r**2 + 4*r*(92*s - 49) - 138*s + 71) - 8*r**2 - 152*r*s + 84*r + 588*s**2 - 477*s + 90)) + Ddd*f*(-2*C*(4*r**2 + 92*r*s - 48*r - 23*s + 1) + 4*r**2 + 76*r*s - 40*r - 294*s**2 + 275*s - 146)) - 2*Dd**2*f**2*(2*C*(12*r**2 + 12*r*(23*s - 12) - 69*s + 46) - 12*r**2 + r*(120 - 228*s) + 882*s**2 - 825*s + 109)) - f*(384*C*D1**2*f*fd*r**2 + 432*C*D1**2*f*fd*r*s - 400*C*D1**2*f*fd*r - 144*C*D1**2*f*fd*s + 128*C*D1**2*f*fd - 84*C*D1**2*f*fdd*r**2 - 432*C*D1**2*f*fdd*r*s + 200*C*D1**2*f*fdd*r + 144*C*D1**2*f*fdd*s - 28*C*D1**2*f*fdd - 168*C*D1**2*fd**2*r**2 - 864*C*D1**2*fd**2*r*s + 400*C*D1**2*fd**2*r + 288*C*D1**2*fd**2*s - 144*C*D1**2*fd**2 + 512*C*D1*Dd*f**2*r**2 + 576*C*D1*Dd*f**2*r*s - 544*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s + 128*C*D1*Dd*f**2 - 672*C*D1*Dd*f*fd*r**2 - 3456*C*D1*Dd*f*fd*r*s + 1832*C*D1*Dd*f*fd*r + 1008*C*D1*Dd*f*fd*s - 488*C*D1*Dd*f*fd - 112*C*D1*Ddd*f**2*r**2 - 576*C*D1*Ddd*f**2*r*s + 344*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s - 28*C*D1*Ddd*f**2 - 336*C*Dd**2*f**2*r**2 - 1728*C*Dd**2*f**2*r*s + 1032*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s - 288*C*Dd**2*f**2 + 84*D1**2*bd1**2*s*(C - 1)*(2*r - 1) + 3*D1**2*bdd1*f*(r**2*(4*C - 2) + r*(92*C*s - 38*s - 2) + 147*s**2 - 54*s + 1) - 384*D1**2*f*fd*r**2 - 942*D1**2*f*fd*r*s + 570*D1**2*f*fd*r - 837*D1**2*f*fd*s**2 + 872*D1**2*f*fd*s - 407*D1**2*f*fd + 84*D1**2*f*fdd*r**2 + 822*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 837*D1**2*f*fdd*s**2 - 832*D1**2*f*fdd*s + 307*D1**2*f*fdd + 168*D1**2*fd**2*r**2 + 1644*D1**2*fd**2*r*s - 660*D1**2*fd**2*r + 1674*D1**2*fd**2*s**2 - 1664*D1**2*fd**2*s + 274*D1**2*fd**2 - 512*D1*Dd*f**2*r**2 - 1256*D1*Dd*f**2*r*s + 884*D1*Dd*f**2*r - 1116*D1*Dd*f**2*s**2 + 1430*D1*Dd*f**2*s - 686*D1*Dd*f**2 + 672*D1*Dd*f*fd*r**2 + 6576*D1*Dd*f*fd*r*s - 3132*D1*Dd*f*fd*r + 6696*D1*Dd*f*fd*s**2 - 7498*D1*Dd*f*fd*s + 1994*D1*Dd*f*fd + 112*D1*Ddd*f**2*r**2 + 1096*D1*Ddd*f**2*r*s - 604*D1*Ddd*f**2*r + 1116*D1*Ddd*f**2*s**2 - 1390*D1*Ddd*f**2*s + 586*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r**2*(64*C - 32) + 2*r*(64*C*s - 31*s - 16) + 147*s**2 - 66*s + 16) + 2*fd*(46*C*s + r**2*(4 - 8*C) + r*(-184*C*s + 50*C + 76*s - 20) - 294*s**2 + 155*s - 27)) - 2*Dd*f*(-46*C*s + r**2*(16*C - 8) + 4*r*(92*C*s - 24*C - 38*s + 9) + 588*s**2 - 383*s + 55)) + 336*Dd**2*f**2*r**2 + 3288*Dd**2*f**2*r*s - 1812*Dd**2*f**2*r + 3348*Dd**2*f**2*s**2 - 4170*Dd**2*f**2*s + 1106*Dd**2*f**2))/(315*d**2*k1*k3**2) - 8*D1**2*Pk1*Pk3*ct**3*st**2*(D1*f*s*(-14*D1*bd1**2*s - 3*D1*bdd1*f*s + 6*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*f*(2 - 4*s))) + 7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(6*fd*(2*s**2 - 2*s + 1) + fdd*(-6*s**2 + 6*s - 3) + s**2*(28*bd1 - 14*bdd1)) - 2*fd*s*(14*bd1 + 3*fd)*(s - 1)) + 2*D1*f*(6*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(14*bd1*s + fd*(6*s - 3)) - 3*Ddd*f*(2*s**2 - 2*s + 1)) - 6*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(35*d**2*k1*k2) + D1**2*Pk1*Pk3*ct**3*(-D1*f*(434*D1*bd1**2*s**2 + 3*D1*bdd1*f*s*(r*(8 - 16*C) + 45*s) - 3*bd1*(D1*(f*s*(r*(16 - 32*C) + 55*s) + 2*fd*(r*(8*C - 4)*(4*s - 1) + s*(-8*C - 90*s + 49))) + 4*Dd*f*(r*(8*C - 4)*(4*s - 1) + s*(-4*C - 90*s + 47)))) + 7*b1**2*(D1**2*(37*fd - 31*fdd)*(s - 1)**2 + 2*D1*(37*Dd*f*(2*s**2 - 2*s + 1) - 62*Dd*fd*(2*s**2 - 3*s + 1) - 31*Ddd*f*(2*s**2 - 2*s + 1)) - 62*Dd**2*f*(6*s**2 - 6*s + 1)) - b1*(D1**2*(868*bd1*fd*s*(s - 1) + 3*f*fd*(r*(32*C - 16)*(2*s - 1) - 110*s**2 + s*(126 - 32*C) - 55) - 3*f*fdd*(r*(16*C - 8)*(2*s - 1) - 90*s**2 + s*(98 - 16*C) - 45) + f*s**2*(-518*bd1 + 434*bdd1) - 6*fd**2*(8*C*(r*(2*s - 1) - s + 1) + r*(4 - 8*s) - 45*s**2 + 49*s - 4)) + 2*D1*f*(Dd*(3*f*(-16*C*s + r*(32*C - 16)*(2*s - 1) - 110*s**2 + 118*s - 55) + (4*s - 2)*(434*bd1*s + fd*(-96*C*r + 36*C + 48*r + 270*s - 153))) + 3*Ddd*f*(8*C*s - r*(16*C - 8)*(2*s - 1) + 90*s**2 - 94*s + 45)) - 6*Dd**2*f**2*(8*C*(6*r*(2*s - 1) - 3*s + 2) + r*(24 - 48*s) - 270*s**2 + 282*s - 53)))/(105*d**2*k1*k2) + 2*D1**2*Pk1*Pk3*ct**3*k2**3*st**2*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 195*D1**2*f**2*fd*r**2 - 130*D1**2*f**2*fd*r + 65*D1**2*f**2*fd - 111*D1**2*f**2*fdd*r**2 + 74*D1**2*f**2*fdd*r - 37*D1**2*f**2*fdd - 222*D1**2*f*fd**2*r**2 + 148*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 260*D1*Dd*f**3*r**2 - 130*D1*Dd*f**3*r + 65*D1*Dd*f**3 - 888*D1*Dd*f**2*fd*r**2 + 518*D1*Dd*f**2*fd*r - 74*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 148*D1*Ddd*f**3*r**2 + 74*D1*Ddd*f**3*r - 37*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 444*Dd**2*f**3*r**2 + 222*Dd**2*f**3*r)/(315*d**2*k1**3*k3**2) - D1**2*Pk1*Pk3*ct**3*k2**3*(D1*f*r*(2*D1*bd1**2*(6*f - 7)*(r - 1) + D1*bdd1*f*r*(14*f + 13) + bd1*(D1*f*r*(26*f + 23) + D1*fd*(28*f*(3*r - 1) + 52*r - 26) + 2*Dd*f*(14*f + 13)*(4*r - 1))) + b1**2*(D1**2*r**2*(12*fd**2 + fd*(60*f + 49) + fdd*(12*f - 7)) + D1*(Dd*(30*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(96*fd + 196) - r*(24*fd + 98) + 49) + 14*fd*r*(1 - 4*r)) + Ddd*f*(6*f - 7)*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(6*f - 7)*(2*r - 1)) + b1*(D1**2*bdd1*f*(6*f - 7)*(2*r**2 - 2*r + 1) + 78*D1**2*f**2*fd*r**2 - 52*D1**2*f**2*fd*r + 26*D1**2*f**2*fd + 42*D1**2*f**2*fdd*r**2 - 28*D1**2*f**2*fdd*r + 14*D1**2*f**2*fdd + 84*D1**2*f*fd**2*r**2 - 56*D1**2*f*fd**2*r + 46*D1**2*f*fd*r**2 - 46*D1**2*f*fd*r + 23*D1**2*f*fd + 26*D1**2*f*fdd*r**2 - 26*D1**2*f*fdd*r + 13*D1**2*f*fdd + 26*D1**2*fd**2*r**2 - 26*D1**2*fd**2*r + 104*D1*Dd*f**3*r**2 - 52*D1*Dd*f**3*r + 26*D1*Dd*f**3 + 336*D1*Dd*f**2*fd*r**2 - 196*D1*Dd*f**2*fd*r + 28*D1*Dd*f**2*fd + 92*D1*Dd*f**2*r**2 - 46*D1*Dd*f**2*r + 23*D1*Dd*f**2 + 208*D1*Dd*f*fd*r**2 - 156*D1*Dd*f*fd*r + 26*D1*Dd*f*fd + 56*D1*Ddd*f**3*r**2 - 28*D1*Ddd*f**3*r + 14*D1*Ddd*f**3 + 52*D1*Ddd*f**2*r**2 - 26*D1*Ddd*f**2*r + 13*D1*Ddd*f**2 + D1*bd1*(D1*(30*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(48*fd + 98) - r*(24*fd + 98) + 49) + 14*fd*r*(1 - 2*r)) + 2*Dd*f*(6*f - 7)*(8*r**2 - 6*r + 1)) + 168*Dd**2*f**3*r**2 - 84*Dd**2*f**3*r + 156*Dd**2*f**2*r**2 - 78*Dd**2*f**2*r))/(105*d**2*k1**3*k3**2) - D1**2*Pk1*Pk3*ct**3*k2*(D1*f*r*(-14*D1*bd1**2*(r - 1) + D1*bd1*(23*f*r + 26*fd*(2*r - 1)) + 13*D1*bdd1*f*r + 26*Dd*bd1*f*(4*r - 1)) + 7*b1**2*(D1**2*r**2*(7*fd - fdd) + D1*(7*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) + b1*(-7*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 46*D1**2*f*fd*r**2 - 46*D1**2*f*fd*r + 23*D1**2*f*fd + 26*D1**2*f*fdd*r**2 - 26*D1**2*f*fdd*r + 13*D1**2*f*fdd + 26*D1**2*fd**2*r**2 - 26*D1**2*fd**2*r + 92*D1*Dd*f**2*r**2 - 46*D1*Dd*f**2*r + 23*D1*Dd*f**2 + 208*D1*Dd*f*fd*r**2 - 156*D1*Dd*f*fd*r + 26*D1*Dd*f*fd + 52*D1*Ddd*f**2*r**2 - 26*D1*Ddd*f**2*r + 13*D1*Ddd*f**2 + 7*D1*bd1*(7*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 2*r) - 2*Dd*f*(8*r**2 - 6*r + 1)) + 156*Dd**2*f**2*r**2 - 78*Dd**2*f**2*r))/(105*d**2*k1**3) + 4*D1**2*Pk1*Pk3*ct**2*f*k2**6*st**4*(99*D1**2*b1*f*fd*r**2 + 99*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r - 99*D1**2*b1*f*fdd*r**2 - 99*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 198*D1**2*b1*fd**2*r**2 - 198*D1**2*b1*fd**2*r*s + 132*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 92*D1**2*f**2*fd*r**2 + 92*D1**2*f**2*fd*r*s - 92*D1**2*f**2*fd*r - 23*D1**2*f**2*fd*s + 23*D1**2*f**2*fd - 156*D1**2*f**2*fdd*r**2 - 156*D1**2*f**2*fdd*r*s + 156*D1**2*f**2*fdd*r + 39*D1**2*f**2*fdd*s - 39*D1**2*f**2*fdd - 468*D1**2*f*fd**2*r**2 - 468*D1**2*f*fd**2*r*s + 468*D1**2*f*fd**2*r + 117*D1**2*f*fd**2*s - 78*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 132*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r - 33*D1*Dd*b1*f**2*s + 33*D1*Dd*b1*f**2 - 792*D1*Dd*b1*f*fd*r**2 - 792*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r + 99*D1*Dd*b1*f*fd*s - 66*D1*Dd*b1*f*fd + 92*D1*Dd*f**3*r**2 + 92*D1*Dd*f**3*r*s - 92*D1*Dd*f**3*r - 23*D1*Dd*f**3*s + 23*D1*Dd*f**3 - 1248*D1*Dd*f**2*fd*r**2 - 1248*D1*Dd*f**2*fd*r*s + 1248*D1*Dd*f**2*fd*r + 312*D1*Dd*f**2*fd*s - 234*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 156*D1*Ddd*f**3*r**2 - 156*D1*Ddd*f**3*r*s + 156*D1*Ddd*f**3*r + 39*D1*Ddd*f**3*s - 39*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r + 99*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 468*Dd**2*f**3*r**2 - 468*Dd**2*f**3*r*s + 468*Dd**2*f**3*r + 117*Dd**2*f**3*s - 78*Dd**2*f**3)/(231*d**2*k1**2*k3**6) - D1**2*Pk1*Pk3*ct**2*k1**6*(8*C - 4)*(54*D1**2*b1*f*fd*r**2 + 108*D1**2*b1*f*fd*r*s - 54*D1**2*b1*f*fd*r + 54*D1**2*b1*f*fd*s**2 - 54*D1**2*b1*f*fd*s + 27*D1**2*b1*f*fd - 90*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd - 90*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)**2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 216*D1*Dd*b1*f**2*r*s - 162*D1*Dd*b1*f**2*r + 108*D1*Dd*b1*f**2*s**2 - 162*D1*Dd*b1*f**2*s + 81*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 900*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 900*D1*Dd*b1*f*fd*s - 270*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 1190*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 1190*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 270*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 270*D1*Ddd*b1*f**2*s - 135*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 210*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 210*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 540*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 810*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 810*Dd**2*b1*f**2*s - 270*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 630*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 630*Dd**2*f**3*s - 210*Dd**2*f**3)/(105*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**2*k1**4*k2**2*st**2*(726*C*D1**2*b1*f*fd*r**2 + 1452*C*D1**2*b1*f*fd*r*s - 726*C*D1**2*b1*f*fd*r + 726*C*D1**2*b1*f*fd*s**2 - 726*C*D1**2*b1*f*fd*s + 363*C*D1**2*b1*f*fd - 1098*C*D1**2*b1*f*fdd*r**2 - 2196*C*D1**2*b1*f*fdd*r*s + 1098*C*D1**2*b1*f*fdd*r - 1098*C*D1**2*b1*f*fdd*s**2 + 1098*C*D1**2*b1*f*fdd*s - 549*C*D1**2*b1*f*fdd - 1098*C*D1**2*b1*fd**2*r**2 - 2196*C*D1**2*b1*fd**2*r*s + 1098*C*D1**2*b1*fd**2*r - 1098*C*D1**2*b1*fd**2*s**2 + 1098*C*D1**2*b1*fd**2*s + 885*C*D1**2*f**2*fd*r**2 + 1770*C*D1**2*f**2*fd*r*s - 1180*C*D1**2*f**2*fd*r + 885*C*D1**2*f**2*fd*s**2 - 1180*C*D1**2*f**2*fd*s + 590*C*D1**2*f**2*fd - 915*C*D1**2*f**2*fdd*r**2 - 1830*C*D1**2*f**2*fdd*r*s + 1220*C*D1**2*f**2*fdd*r - 915*C*D1**2*f**2*fdd*s**2 + 1220*C*D1**2*f**2*fdd*s - 610*C*D1**2*f**2*fdd - 1830*C*D1**2*f*fd**2*r**2 - 3660*C*D1**2*f*fd**2*r*s + 2440*C*D1**2*f*fd**2*r - 1830*C*D1**2*f*fd**2*s**2 + 2440*C*D1**2*f*fd**2*s - 610*C*D1**2*f*fd**2 + 1452*C*D1*Dd*b1*f**2*r**2 + 2904*C*D1*Dd*b1*f**2*r*s - 2178*C*D1*Dd*b1*f**2*r + 1452*C*D1*Dd*b1*f**2*s**2 - 2178*C*D1*Dd*b1*f**2*s + 1089*C*D1*Dd*b1*f**2 - 8784*C*D1*Dd*b1*f*fd*r**2 - 17568*C*D1*Dd*b1*f*fd*r*s + 10980*C*D1*Dd*b1*f*fd*r - 8784*C*D1*Dd*b1*f*fd*s**2 + 10980*C*D1*Dd*b1*f*fd*s - 3294*C*D1*Dd*b1*f*fd + 1180*C*D1*Dd*f**3*r**2 + 2360*C*D1*Dd*f**3*r*s - 1770*C*D1*Dd*f**3*r + 1180*C*D1*Dd*f**3*s**2 - 1770*C*D1*Dd*f**3*s + 885*C*D1*Dd*f**3 - 7320*C*D1*Dd*f**2*fd*r**2 - 14640*C*D1*Dd*f**2*fd*r*s + 10370*C*D1*Dd*f**2*fd*r - 7320*C*D1*Dd*f**2*fd*s**2 + 10370*C*D1*Dd*f**2*fd*s - 3660*C*D1*Dd*f**2*fd - 2196*C*D1*Ddd*b1*f**2*r**2 - 4392*C*D1*Ddd*b1*f**2*r*s + 3294*C*D1*Ddd*b1*f**2*r - 2196*C*D1*Ddd*b1*f**2*s**2 + 3294*C*D1*Ddd*b1*f**2*s - 1647*C*D1*Ddd*b1*f**2 - 1220*C*D1*Ddd*f**3*r**2 - 2440*C*D1*Ddd*f**3*r*s + 1830*C*D1*Ddd*f**3*r - 1220*C*D1*Ddd*f**3*s**2 + 1830*C*D1*Ddd*f**3*s - 915*C*D1*Ddd*f**3 - 6588*C*Dd**2*b1*f**2*r**2 - 13176*C*Dd**2*b1*f**2*r*s + 9882*C*Dd**2*b1*f**2*r - 6588*C*Dd**2*b1*f**2*s**2 + 9882*C*Dd**2*b1*f**2*s - 3294*C*Dd**2*b1*f**2 - 3660*C*Dd**2*f**3*r**2 - 7320*C*Dd**2*f**3*r*s + 5490*C*Dd**2*f**3*r - 3660*C*Dd**2*f**3*s**2 + 5490*C*Dd**2*f**3*s - 1830*C*Dd**2*f**3 - 408*D1**2*b1*f*fd*r**2 - 816*D1**2*b1*f*fd*r*s + 408*D1**2*b1*f*fd*r - 408*D1**2*b1*f*fd*s**2 + 408*D1**2*b1*f*fd*s - 204*D1**2*b1*f*fd + 666*D1**2*b1*f*fdd*r**2 + 1332*D1**2*b1*f*fdd*r*s - 666*D1**2*b1*f*fdd*r + 666*D1**2*b1*f*fdd*s**2 - 666*D1**2*b1*f*fdd*s + 333*D1**2*b1*f*fdd + 666*D1**2*b1*fd**2*r**2 + 1332*D1**2*b1*fd**2*r*s - 666*D1**2*b1*fd**2*r + 666*D1**2*b1*fd**2*s**2 - 666*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(61*C - 37)*(r + s - 1)**2 - 516*D1**2*f**2*fd*r**2 - 1032*D1**2*f**2*fd*r*s + 688*D1**2*f**2*fd*r - 516*D1**2*f**2*fd*s**2 + 688*D1**2*f**2*fd*s - 344*D1**2*f**2*fd + 555*D1**2*f**2*fdd*r**2 + 1110*D1**2*f**2*fdd*r*s - 740*D1**2*f**2*fdd*r + 555*D1**2*f**2*fdd*s**2 - 740*D1**2*f**2*fdd*s + 370*D1**2*f**2*fdd + 1110*D1**2*f*fd**2*r**2 + 2220*D1**2*f*fd**2*r*s - 1480*D1**2*f*fd**2*r + 1110*D1**2*f*fd**2*s**2 - 1480*D1**2*f*fd**2*s + 370*D1**2*f*fd**2 - 816*D1*Dd*b1*f**2*r**2 - 1632*D1*Dd*b1*f**2*r*s + 1224*D1*Dd*b1*f**2*r - 816*D1*Dd*b1*f**2*s**2 + 1224*D1*Dd*b1*f**2*s - 612*D1*Dd*b1*f**2 + 5328*D1*Dd*b1*f*fd*r**2 + 10656*D1*Dd*b1*f*fd*r*s - 6660*D1*Dd*b1*f*fd*r + 5328*D1*Dd*b1*f*fd*s**2 - 6660*D1*Dd*b1*f*fd*s + 1998*D1*Dd*b1*f*fd - 688*D1*Dd*f**3*r**2 - 1376*D1*Dd*f**3*r*s + 1032*D1*Dd*f**3*r - 688*D1*Dd*f**3*s**2 + 1032*D1*Dd*f**3*s - 516*D1*Dd*f**3 + 4440*D1*Dd*f**2*fd*r**2 + 8880*D1*Dd*f**2*fd*r*s - 6290*D1*Dd*f**2*fd*r + 4440*D1*Dd*f**2*fd*s**2 - 6290*D1*Dd*f**2*fd*s + 2220*D1*Dd*f**2*fd + 1332*D1*Ddd*b1*f**2*r**2 + 2664*D1*Ddd*b1*f**2*r*s - 1998*D1*Ddd*b1*f**2*r + 1332*D1*Ddd*b1*f**2*s**2 - 1998*D1*Ddd*b1*f**2*s + 999*D1*Ddd*b1*f**2 + 740*D1*Ddd*f**3*r**2 + 1480*D1*Ddd*f**3*r*s - 1110*D1*Ddd*f**3*r + 740*D1*Ddd*f**3*s**2 - 1110*D1*Ddd*f**3*s + 555*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(121*C - 68)*(r + s - 1) - D1*fd*(366*C - 222)*(2*r + 2*s - 1) - Dd*f*(366*C - 222)*(4*r + 4*s - 3)) + 3996*Dd**2*b1*f**2*r**2 + 7992*Dd**2*b1*f**2*r*s - 5994*Dd**2*b1*f**2*r + 3996*Dd**2*b1*f**2*s**2 - 5994*Dd**2*b1*f**2*s + 1998*Dd**2*b1*f**2 + 2220*Dd**2*f**3*r**2 + 4440*Dd**2*f**3*r*s - 3330*Dd**2*f**3*r + 2220*Dd**2*f**3*s**2 - 3330*Dd**2*f**3*s + 1110*Dd**2*f**3)/(105*d**2*k3**8) - 4*D1**2*Pk1*Pk3*ct**2*k1**4*k2**2*(-2970*C*D1**2*f**2*fd*r**2 - 5940*C*D1**2*f**2*fd*r*s + 3960*C*D1**2*f**2*fd*r - 2970*C*D1**2*f**2*fd*s**2 + 3960*C*D1**2*f**2*fd*s - 1980*C*D1**2*f**2*fd - 3960*C*D1*Dd*f**3*r**2 - 7920*C*D1*Dd*f**3*r*s + 5940*C*D1*Dd*f**3*r - 3960*C*D1*Dd*f**3*s**2 + 5940*C*D1*Dd*f**3*s - 2970*C*D1*Dd*f**3 - 7425*D1**2*K*bdd1*f**2*r**2 - 14850*D1**2*K*bdd1*f**2*r*s + 14850*D1**2*K*bdd1*f**2*r - 7425*D1**2*K*bdd1*f**2*s**2 + 14850*D1**2*K*bdd1*f**2*s - 7425*D1**2*K*bdd1*f**2 + 990*D1**2*bd1**2*f*(-21*K + 5*f + 7)*(r + s - 1)**2 + 1540*D1**2*bdd1*f**3*r**2 + 3080*D1**2*bdd1*f**3*r*s - 3080*D1**2*bdd1*f**3*r + 1540*D1**2*bdd1*f**3*s**2 - 3080*D1**2*bdd1*f**3*s + 1540*D1**2*bdd1*f**3 + 2475*D1**2*bdd1*f**2*r**2 + 4950*D1**2*bdd1*f**2*r*s - 4950*D1**2*bdd1*f**2*r + 2475*D1**2*bdd1*f**2*s**2 - 4950*D1**2*bdd1*f**2*s + 2475*D1**2*bdd1*f**2 + 20790*D1**2*bdd1*f*g2*r**2 + 41580*D1**2*bdd1*f*g2*r*s - 41580*D1**2*bdd1*f*g2*r + 20790*D1**2*bdd1*f*g2*s**2 - 41580*D1**2*bdd1*f*g2*s + 20790*D1**2*bdd1*f*g2 + 980*D1**2*f**3*fd*r**2 + 1960*D1**2*f**3*fd*r*s - 1470*D1**2*f**3*fd*r + 980*D1**2*f**3*fd*s**2 - 1470*D1**2*f**3*fd*s + 735*D1**2*f**3*fd - 1260*D1**2*f**3*fdd*r**2 - 2520*D1**2*f**3*fdd*r*s + 1890*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s**2 + 1890*D1**2*f**3*fdd*s - 945*D1**2*f**3*fdd - 3780*D1**2*f**2*fd**2*r**2 - 7560*D1**2*f**2*fd**2*r*s + 5670*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s**2 + 5670*D1**2*f**2*fd**2*s - 1890*D1**2*f**2*fd**2 + 1485*D1**2*f**2*fd*r**2 + 2970*D1**2*f**2*fd*r*s - 1980*D1**2*f**2*fd*r + 1485*D1**2*f**2*fd*s**2 - 1980*D1**2*f**2*fd*s + 990*D1**2*f**2*fd - 10296*D1**2*f**2*gd2*r**2 - 20592*D1**2*f**2*gd2*r*s + 20592*D1**2*f**2*gd2*r - 10296*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s - 10296*D1**2*f**2*gd2 + 14850*D1**2*f**2*gdd2*r**2 + 29700*D1**2*f**2*gdd2*r*s - 29700*D1**2*f**2*gdd2*r + 14850*D1**2*f**2*gdd2*s**2 - 29700*D1**2*f**2*gdd2*s + 14850*D1**2*f**2*gdd2 - 20592*D1**2*f*fd*g2*r**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 20592*D1**2*f*fd*g2*s**2 + 20592*D1**2*f*fd*g2*s - 10296*D1**2*f*fd*g2 + 59400*D1**2*f*fd*gd2*r**2 + 118800*D1**2*f*fd*gd2*r*s - 89100*D1**2*f*fd*gd2*r + 59400*D1**2*f*fd*gd2*s**2 - 89100*D1**2*f*fd*gd2*s + 29700*D1**2*f*fd*gd2 + 29700*D1**2*f*fdd*g2*r**2 + 59400*D1**2*f*fdd*g2*r*s - 29700*D1**2*f*fdd*g2*r + 29700*D1**2*f*fdd*g2*s**2 - 29700*D1**2*f*fdd*g2*s + 14850*D1**2*f*fdd*g2 + 29700*D1**2*fd**2*g2*r**2 + 59400*D1**2*fd**2*g2*r*s - 29700*D1**2*fd**2*g2*r + 29700*D1**2*fd**2*g2*s**2 - 29700*D1**2*fd**2*g2*s + 980*D1*Dd*f**4*r**2 + 1960*D1*Dd*f**4*r*s - 1470*D1*Dd*f**4*r + 980*D1*Dd*f**4*s**2 - 1470*D1*Dd*f**4*s + 735*D1*Dd*f**4 - 10080*D1*Dd*f**3*fd*r**2 - 20160*D1*Dd*f**3*fd*r*s + 15120*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s**2 + 15120*D1*Dd*f**3*fd*s - 5670*D1*Dd*f**3*fd + 1980*D1*Dd*f**3*r**2 + 3960*D1*Dd*f**3*r*s - 2970*D1*Dd*f**3*r + 1980*D1*Dd*f**3*s**2 - 2970*D1*Dd*f**3*s + 1485*D1*Dd*f**3 - 41184*D1*Dd*f**2*g2*r**2 - 82368*D1*Dd*f**2*g2*r*s + 61776*D1*Dd*f**2*g2*r - 41184*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 30888*D1*Dd*f**2*g2 + 118800*D1*Dd*f**2*gd2*r**2 + 237600*D1*Dd*f**2*gd2*r*s - 207900*D1*Dd*f**2*gd2*r + 118800*D1*Dd*f**2*gd2*s**2 - 207900*D1*Dd*f**2*gd2*s + 89100*D1*Dd*f**2*gd2 + 237600*D1*Dd*f*fd*g2*r**2 + 475200*D1*Dd*f*fd*g2*r*s - 297000*D1*Dd*f*fd*g2*r + 237600*D1*Dd*f*fd*g2*s**2 - 297000*D1*Dd*f*fd*g2*s + 89100*D1*Dd*f*fd*g2 - 1260*D1*Ddd*f**4*r**2 - 2520*D1*Ddd*f**4*r*s + 1890*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s**2 + 1890*D1*Ddd*f**4*s - 945*D1*Ddd*f**4 + 59400*D1*Ddd*f**2*g2*r**2 + 118800*D1*Ddd*f**2*g2*r*s - 89100*D1*Ddd*f**2*g2*r + 59400*D1*Ddd*f**2*g2*s**2 - 89100*D1*Ddd*f**2*g2*s + 44550*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(50*f**3*(r + s - 1) + f**2*(63*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) - (234*K - 36)*(r + s - 1)) + 15*f*(15*fd*(3*K - 1)*(2*r + 2*s - 1) + (28*g2 - 126*gd2)*(r + s - 1)) - 1890*fd*g2*(r + s)) - 5*Dd*f*(28*f**2 - 45*f*(3*K - 1) + 378*g2)*(4*r + 4*s - 3))*(r + s - 1) - 3780*Dd**2*f**4*r**2 - 7560*Dd**2*f**4*r*s + 5670*Dd**2*f**4*r - 3780*Dd**2*f**4*s**2 + 5670*Dd**2*f**4*s - 1890*Dd**2*f**4 + 178200*Dd**2*f**2*g2*r**2 + 356400*Dd**2*f**2*g2*r*s - 267300*Dd**2*f**2*g2*r + 178200*Dd**2*f**2*g2*s**2 - 267300*Dd**2*f**2*g2*s + 89100*Dd**2*f**2*g2 - 165*b1**2*(D1**2*(3*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(30*fd**2*(r + s - 1) + 7*fd*(4*K - 1)*(r + s) - 21*fdd*(3*K - 1)*(r + s))) + D1*(Dd*(9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(30*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (28*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(3*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-21*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-21*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(252*C*D1**2*f*fd*r**2 + 504*C*D1**2*f*fd*r*s - 252*C*D1**2*f*fd*r + 252*C*D1**2*f*fd*s**2 - 252*C*D1**2*f*fd*s + 126*C*D1**2*f*fd + 504*C*D1*Dd*f**2*r**2 + 1008*C*D1*Dd*f**2*r*s - 756*C*D1*Dd*f**2*r + 504*C*D1*Dd*f**2*s**2 - 756*C*D1*Dd*f**2*s + 378*C*D1*Dd*f**2 - 936*D1**2*K*f*fd*r**2 - 1872*D1**2*K*f*fd*r*s + 936*D1**2*K*f*fd*r - 936*D1**2*K*f*fd*s**2 + 936*D1**2*K*f*fd*s - 468*D1**2*K*f*fd + 1350*D1**2*K*f*fdd*r**2 + 2700*D1**2*K*f*fdd*r*s - 1350*D1**2*K*f*fdd*r + 1350*D1**2*K*f*fdd*s**2 - 1350*D1**2*K*f*fdd*s + 675*D1**2*K*f*fdd + 1350*D1**2*K*fd**2*r**2 + 2700*D1**2*K*fd**2*r*s - 1350*D1**2*K*fd**2*r + 1350*D1**2*K*fd**2*s**2 - 1350*D1**2*K*fd**2*s - 90*D1**2*bdd1*f*(-21*K + 5*f + 7)*(r + s - 1)**2 + 300*D1**2*f**2*fd*r**2 + 600*D1**2*f**2*fd*r*s - 400*D1**2*f**2*fd*r + 300*D1**2*f**2*fd*s**2 - 400*D1**2*f**2*fd*s + 200*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 144*D1**2*f*fd*r**2 + 288*D1**2*f*fd*r*s - 144*D1**2*f*fd*r + 144*D1**2*f*fd*s**2 - 144*D1**2*f*fd*s + 72*D1**2*f*fd - 450*D1**2*f*fdd*r**2 - 900*D1**2*f*fdd*r*s + 450*D1**2*f*fdd*r - 450*D1**2*f*fdd*s**2 + 450*D1**2*f*fdd*s - 225*D1**2*f*fdd + 840*D1**2*f*gd2*r**2 + 1680*D1**2*f*gd2*r*s - 1680*D1**2*f*gd2*r + 840*D1**2*f*gd2*s**2 - 1680*D1**2*f*gd2*s + 840*D1**2*f*gd2 - 1890*D1**2*f*gdd2*r**2 - 3780*D1**2*f*gdd2*r*s + 3780*D1**2*f*gdd2*r - 1890*D1**2*f*gdd2*s**2 + 3780*D1**2*f*gdd2*s - 1890*D1**2*f*gdd2 - 450*D1**2*fd**2*r**2 - 900*D1**2*fd**2*r*s + 450*D1**2*fd**2*r - 450*D1**2*fd**2*s**2 + 450*D1**2*fd**2*s + 840*D1**2*fd*g2*r**2 + 1680*D1**2*fd*g2*r*s + 840*D1**2*fd*g2*s**2 - 3780*D1**2*fd*gd2*r**2 - 7560*D1**2*fd*gd2*r*s + 3780*D1**2*fd*gd2*r - 3780*D1**2*fd*gd2*s**2 + 3780*D1**2*fd*gd2*s - 1890*D1**2*fdd*g2*r**2 - 3780*D1**2*fdd*g2*r*s - 1890*D1**2*fdd*g2*s**2 - 1872*D1*Dd*K*f**2*r**2 - 3744*D1*Dd*K*f**2*r*s + 2808*D1*Dd*K*f**2*r - 1872*D1*Dd*K*f**2*s**2 + 2808*D1*Dd*K*f**2*s - 1404*D1*Dd*K*f**2 + 10800*D1*Dd*K*f*fd*r**2 + 21600*D1*Dd*K*f*fd*r*s - 13500*D1*Dd*K*f*fd*r + 10800*D1*Dd*K*f*fd*s**2 - 13500*D1*Dd*K*f*fd*s + 4050*D1*Dd*K*f*fd + 400*D1*Dd*f**3*r**2 + 800*D1*Dd*f**3*r*s - 600*D1*Dd*f**3*r + 400*D1*Dd*f**3*s**2 - 600*D1*Dd*f**3*s + 300*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd + 288*D1*Dd*f**2*r**2 + 576*D1*Dd*f**2*r*s - 432*D1*Dd*f**2*r + 288*D1*Dd*f**2*s**2 - 432*D1*Dd*f**2*s + 216*D1*Dd*f**2 - 3600*D1*Dd*f*fd*r**2 - 7200*D1*Dd*f*fd*r*s + 4500*D1*Dd*f*fd*r - 3600*D1*Dd*f*fd*s**2 + 4500*D1*Dd*f*fd*s - 1350*D1*Dd*f*fd + 3360*D1*Dd*f*g2*r**2 + 6720*D1*Dd*f*g2*r*s - 5040*D1*Dd*f*g2*r + 3360*D1*Dd*f*g2*s**2 - 5040*D1*Dd*f*g2*s + 2520*D1*Dd*f*g2 - 15120*D1*Dd*f*gd2*r**2 - 30240*D1*Dd*f*gd2*r*s + 26460*D1*Dd*f*gd2*r - 15120*D1*Dd*f*gd2*s**2 + 26460*D1*Dd*f*gd2*s - 11340*D1*Dd*f*gd2 - 15120*D1*Dd*fd*g2*r**2 - 30240*D1*Dd*fd*g2*r*s + 11340*D1*Dd*fd*g2*r - 15120*D1*Dd*fd*g2*s**2 + 11340*D1*Dd*fd*g2*s + 2700*D1*Ddd*K*f**2*r**2 + 5400*D1*Ddd*K*f**2*r*s - 4050*D1*Ddd*K*f**2*r + 2700*D1*Ddd*K*f**2*s**2 - 4050*D1*Ddd*K*f**2*s + 2025*D1*Ddd*K*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 900*D1*Ddd*f**2*r**2 - 1800*D1*Ddd*f**2*r*s + 1350*D1*Ddd*f**2*r - 900*D1*Ddd*f**2*s**2 + 1350*D1*Ddd*f**2*s - 675*D1*Ddd*f**2 - 7560*D1*Ddd*f*g2*r**2 - 15120*D1*Ddd*f*g2*r*s + 11340*D1*Ddd*f*g2*r - 7560*D1*Ddd*f*g2*s**2 + 11340*D1*Ddd*f*g2*s - 5670*D1*Ddd*f*g2 + 30*D1*bd1*(D1*(9*f**2*(r + s - 1) - 30*f*fd*(2*r + 2*s - 1) - 7*f*(4*K - 1)*(r + s - 1) + 42*fd*(3*K - 1)*(r + s)) - 6*Dd*f*(-21*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 8100*Dd**2*K*f**2*r**2 + 16200*Dd**2*K*f**2*r*s - 12150*Dd**2*K*f**2*r + 8100*Dd**2*K*f**2*s**2 - 12150*Dd**2*K*f**2*s + 4050*Dd**2*K*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 2700*Dd**2*f**2*r**2 - 5400*Dd**2*f**2*r*s + 4050*Dd**2*f**2*r - 2700*Dd**2*f**2*s**2 + 4050*Dd**2*f**2*s - 1350*Dd**2*f**2 - 22680*Dd**2*f*g2*r**2 - 45360*Dd**2*f*g2*r*s + 34020*Dd**2*f*g2*r - 22680*Dd**2*f*g2*s**2 + 34020*Dd**2*f*g2*s - 11340*Dd**2*f*g2))/(1155*d**2*k3**8) - D1**2*Pk1*Pk3*ct**2*k1**4*st**2*(128*C - 72)*(b1*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 9*fd*(2*s - 1)*(8*r + 8*s - 5)) - 9*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 9*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(7*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**6) - 2*D1**2*Pk1*Pk3*ct**2*k1**4*(42*D1*b1*bd1*(2*C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 42*b1**2*(2*C - 1)*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(14*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1**2*(f*(fd*(6*C*(22*r**2 + 156*r*s - 74*r + 134*s**2 - 130*s + 65) - 66*r**2 - 536*r*s + 256*r - 470*s**2 + 458*s - 229) + fdd*(-10*C*(22*r**2 + 100*r*s - 46*r + 78*s**2 - 74*s + 37) + 110*r**2 + 576*r*s - 268*r + 466*s**2 - 446*s + 223)) + 2*fd**2*(-10*C*(11*r**2 + 50*r*s - 23*r + 39*s**2 - 37*s - 2) + 55*r**2 + 288*r*s - 134*r + 233*s**2 - 223*s - 10)) + D1*f*(Dd*(f*(6*C*(44*r**2 + 312*r*s - 178*r + 268*s**2 - 346*s + 145) - 132*r**2 - 1072*r*s + 602*r - 940*s**2 + 1208*s - 503) - 4*fd*(5*C*(88*r**2 + 400*r*s - 214*r + 312*s**2 - 354*s + 97) - 220*r**2 - 1152*r*s + 611*r - 932*s**2 + 1056*s - 290)) + Ddd*f*(-10*C*(44*r**2 + 200*r*s - 122*r + 156*s**2 - 206*s + 89) + 220*r**2 + 1152*r*s - 686*r + 932*s**2 - 1220*s + 521)) + 2*Dd**2*f**2*(-10*C*(66*r**2 + 3*r*(100*s - 61) + 234*s**2 - 309*s + 89) + 330*r**2 + 3*r*(576*s - 343) + 1398*s**2 - 1830*s + 521)) + f*(-252*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(10*C*(11*r**2 + r*(50*s - 26) + 39*s**2 - 54*s + 13) - 55*r**2 + r*(130 - 288*s) - 233*s**2 + 308*s - 65) - 5*D1**2*(f*(fd*(2*C*(219*r**2 + 6*r*(173*s - 82) + 819*s**2 - 892*s + 346) - 219*r**2 - 1176*r*s + 538*r - 957*s**2 + 1030*s - 392) + fdd*(-2*C*(285*r**2 + 6*r*(181*s - 92) + 801*s**2 - 896*s + 362) + 285*r**2 + 1236*r*s - 602*r + 951*s**2 - 1046*s + 412)) + 2*fd**2*(-2*C*(285*r**2 + 6*r*(181*s - 92) + 801*s**2 - 896*s + 181) + 285*r**2 + 1236*r*s - 602*r + 951*s**2 - 1046*s + 206)) - 9*D1*bd1*(D1*(f*(6*C*(11*r**2 + 78*r*s - 26*r + 67*s**2 - 82*s + 13) - 33*r**2 - 268*r*s + 78*r - 235*s**2 + 280*s - 39) - 2*fd*(10*C*(22*r**2 + 100*r*s - 49*r + 78*s**2 - 91*s + 27) - 110*r**2 - 576*r*s + 264*r - 466*s**2 + 531*s - 154)) + 2*Dd*f*(-10*C*(44*r**2 + r*(200*s - 113) + 156*s**2 - 211*s + 67) + 220*r**2 + 9*r*(128*s - 67) + 932*s**2 - 1226*s + 373)) - 5*D1*f*(Dd*(f*(2*C*(292*r**2 + 1384*r*s - 838*r + 1092*s**2 - 1438*s + 619) - 292*r**2 - 1568*r*s + 930*r - 1276*s**2 + 1668*s - 711) + 2*fd*(-2*C*(1140*r**2 + 4344*r*s - 2475*r + 3204*s**2 - 3937*s + 1172) + 1140*r**2 + 4944*r*s - 2725*r + 3804*s**2 - 4612*s + 1347)) + Ddd*f*(-2*C*(380*r**2 + 2*r*(724*s - 457) + 1068*s**2 - 1430*s + 629) + 380*r**2 + 2*r*(824*s - 507) + 1268*s**2 - 1680*s + 729)) - 10*Dd**2*f**2*(-2*C*(570*r**2 + 3*r*(724*s - 457) + 1602*s**2 - 2145*s + 629) + 570*r**2 + 3*r*(824*s - 507) + 1902*s**2 - 2520*s + 729)))/(315*d**2*k3**6) - D1**2*Pk1*Pk3*ct**2*k1**4*st**2*(16*C - 8)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(10*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(105*d**2*k2**2*k3**4) + D1**2*Pk1*Pk3*ct**2*k1**4*(2*C - 1)*(7*b1*(D1**2*(f*(7*fd - 5*fdd)*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1)) + 2*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(1 - 2*s)**2 - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(35*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(49*bd1 - 35*bdd1)) + 10*fd*s*(bd1*(7 - 14*s) + 5*fd*(2 - 3*s))) + 10*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(7*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 50*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(35*d**2*k2**2*k3**4) - 4*D1**2*Pk1*Pk3*ct**2*k1**2*k2**4*st**4*(1044*C*D1**2*b1*f*fd*r**2 + 2088*C*D1**2*b1*f*fd*r*s - 1044*C*D1**2*b1*f*fd*r + 1044*C*D1**2*b1*f*fd*s**2 - 1044*C*D1**2*b1*f*fd*s + 522*C*D1**2*b1*f*fd - 732*C*D1**2*b1*f*fdd*r**2 - 1464*C*D1**2*b1*f*fdd*r*s + 732*C*D1**2*b1*f*fdd*r - 732*C*D1**2*b1*f*fdd*s**2 + 732*C*D1**2*b1*f*fdd*s - 366*C*D1**2*b1*f*fdd - 732*C*D1**2*b1*fd**2*r**2 - 1464*C*D1**2*b1*fd**2*r*s + 732*C*D1**2*b1*fd**2*r - 732*C*D1**2*b1*fd**2*s**2 + 732*C*D1**2*b1*fd**2*s + 642*C*D1**2*f**2*fd*r**2 + 1284*C*D1**2*f**2*fd*r*s - 856*C*D1**2*f**2*fd*r + 642*C*D1**2*f**2*fd*s**2 - 856*C*D1**2*f**2*fd*s + 428*C*D1**2*f**2*fd - 366*C*D1**2*f**2*fdd*r**2 - 732*C*D1**2*f**2*fdd*r*s + 488*C*D1**2*f**2*fdd*r - 366*C*D1**2*f**2*fdd*s**2 + 488*C*D1**2*f**2*fdd*s - 244*C*D1**2*f**2*fdd - 732*C*D1**2*f*fd**2*r**2 - 1464*C*D1**2*f*fd**2*r*s + 976*C*D1**2*f*fd**2*r - 732*C*D1**2*f*fd**2*s**2 + 976*C*D1**2*f*fd**2*s - 244*C*D1**2*f*fd**2 + 2088*C*D1*Dd*b1*f**2*r**2 + 4176*C*D1*Dd*b1*f**2*r*s - 3132*C*D1*Dd*b1*f**2*r + 2088*C*D1*Dd*b1*f**2*s**2 - 3132*C*D1*Dd*b1*f**2*s + 1566*C*D1*Dd*b1*f**2 - 5856*C*D1*Dd*b1*f*fd*r**2 - 11712*C*D1*Dd*b1*f*fd*r*s + 7320*C*D1*Dd*b1*f*fd*r - 5856*C*D1*Dd*b1*f*fd*s**2 + 7320*C*D1*Dd*b1*f*fd*s - 2196*C*D1*Dd*b1*f*fd + 856*C*D1*Dd*f**3*r**2 + 1712*C*D1*Dd*f**3*r*s - 1284*C*D1*Dd*f**3*r + 856*C*D1*Dd*f**3*s**2 - 1284*C*D1*Dd*f**3*s + 642*C*D1*Dd*f**3 - 2928*C*D1*Dd*f**2*fd*r**2 - 5856*C*D1*Dd*f**2*fd*r*s + 4148*C*D1*Dd*f**2*fd*r - 2928*C*D1*Dd*f**2*fd*s**2 + 4148*C*D1*Dd*f**2*fd*s - 1464*C*D1*Dd*f**2*fd - 1464*C*D1*Ddd*b1*f**2*r**2 - 2928*C*D1*Ddd*b1*f**2*r*s + 2196*C*D1*Ddd*b1*f**2*r - 1464*C*D1*Ddd*b1*f**2*s**2 + 2196*C*D1*Ddd*b1*f**2*s - 1098*C*D1*Ddd*b1*f**2 - 488*C*D1*Ddd*f**3*r**2 - 976*C*D1*Ddd*f**3*r*s + 732*C*D1*Ddd*f**3*r - 488*C*D1*Ddd*f**3*s**2 + 732*C*D1*Ddd*f**3*s - 366*C*D1*Ddd*f**3 - 4392*C*Dd**2*b1*f**2*r**2 - 8784*C*Dd**2*b1*f**2*r*s + 6588*C*Dd**2*b1*f**2*r - 4392*C*Dd**2*b1*f**2*s**2 + 6588*C*Dd**2*b1*f**2*s - 2196*C*Dd**2*b1*f**2 - 1464*C*Dd**2*f**3*r**2 - 2928*C*Dd**2*f**3*r*s + 2196*C*Dd**2*f**3*r - 1464*C*Dd**2*f**3*s**2 + 2196*C*Dd**2*f**3*s - 732*C*Dd**2*f**3 - 708*D1**2*b1*f*fd*r**2 - 1416*D1**2*b1*f*fd*r*s + 708*D1**2*b1*f*fd*r - 708*D1**2*b1*f*fd*s**2 + 708*D1**2*b1*f*fd*s - 354*D1**2*b1*f*fd + 522*D1**2*b1*f*fdd*r**2 + 1044*D1**2*b1*f*fdd*r*s - 522*D1**2*b1*f*fdd*r + 522*D1**2*b1*f*fdd*s**2 - 522*D1**2*b1*f*fdd*s + 261*D1**2*b1*f*fdd + 522*D1**2*b1*fd**2*r**2 + 1044*D1**2*b1*fd**2*r*s - 522*D1**2*b1*fd**2*r + 522*D1**2*b1*fd**2*s**2 - 522*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(122*C - 87)*(r + s - 1)**2 - 450*D1**2*f**2*fd*r**2 - 900*D1**2*f**2*fd*r*s + 600*D1**2*f**2*fd*r - 450*D1**2*f**2*fd*s**2 + 600*D1**2*f**2*fd*s - 300*D1**2*f**2*fd + 261*D1**2*f**2*fdd*r**2 + 522*D1**2*f**2*fdd*r*s - 348*D1**2*f**2*fdd*r + 261*D1**2*f**2*fdd*s**2 - 348*D1**2*f**2*fdd*s + 174*D1**2*f**2*fdd + 522*D1**2*f*fd**2*r**2 + 1044*D1**2*f*fd**2*r*s - 696*D1**2*f*fd**2*r + 522*D1**2*f*fd**2*s**2 - 696*D1**2*f*fd**2*s + 174*D1**2*f*fd**2 - 1416*D1*Dd*b1*f**2*r**2 - 2832*D1*Dd*b1*f**2*r*s + 2124*D1*Dd*b1*f**2*r - 1416*D1*Dd*b1*f**2*s**2 + 2124*D1*Dd*b1*f**2*s - 1062*D1*Dd*b1*f**2 + 4176*D1*Dd*b1*f*fd*r**2 + 8352*D1*Dd*b1*f*fd*r*s - 5220*D1*Dd*b1*f*fd*r + 4176*D1*Dd*b1*f*fd*s**2 - 5220*D1*Dd*b1*f*fd*s + 1566*D1*Dd*b1*f*fd - 600*D1*Dd*f**3*r**2 - 1200*D1*Dd*f**3*r*s + 900*D1*Dd*f**3*r - 600*D1*Dd*f**3*s**2 + 900*D1*Dd*f**3*s - 450*D1*Dd*f**3 + 2088*D1*Dd*f**2*fd*r**2 + 4176*D1*Dd*f**2*fd*r*s - 2958*D1*Dd*f**2*fd*r + 2088*D1*Dd*f**2*fd*s**2 - 2958*D1*Dd*f**2*fd*s + 1044*D1*Dd*f**2*fd + 1044*D1*Ddd*b1*f**2*r**2 + 2088*D1*Ddd*b1*f**2*r*s - 1566*D1*Ddd*b1*f**2*r + 1044*D1*Ddd*b1*f**2*s**2 - 1566*D1*Ddd*b1*f**2*s + 783*D1*Ddd*b1*f**2 + 348*D1*Ddd*f**3*r**2 + 696*D1*Ddd*f**3*r*s - 522*D1*Ddd*f**3*r + 348*D1*Ddd*f**3*s**2 - 522*D1*Ddd*f**3*s + 261*D1*Ddd*f**3 + 6*D1*bd1*f*(r + s - 1)*(D1*f*(87*C - 59)*(r + s - 1) - D1*fd*(122*C - 87)*(2*r + 2*s - 1) - Dd*f*(122*C - 87)*(4*r + 4*s - 3)) + 3132*Dd**2*b1*f**2*r**2 + 6264*Dd**2*b1*f**2*r*s - 4698*Dd**2*b1*f**2*r + 3132*Dd**2*b1*f**2*s**2 - 4698*Dd**2*b1*f**2*s + 1566*Dd**2*b1*f**2 + 1044*Dd**2*f**3*r**2 + 2088*Dd**2*f**3*r*s - 1566*Dd**2*f**3*r + 1044*Dd**2*f**3*s**2 - 1566*Dd**2*f**3*s + 522*Dd**2*f**3)/(35*d**2*k3**8) + 4*D1**2*Pk1*Pk3*ct**2*k1**2*k2**4*st**2*(-396*D1**2*bd1**2*f*(-14*K + 10*f + 7)*(r + s - 1)**2 + 198*D1**2*bdd1*f*(f*(6*K - 3) - 28*g2)*(r + s - 1)**2 + 2*D1**2*(-10*f**3*(37*fd - 35*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(2100*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(627*C - 429)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (1991*gd2 - 1188*gdd2)*(r + s - 1)**2) + 11*f*(fd*(181*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 216*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 108*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2376*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 11*D1*bd1*(D1*(36*f**3*(r + s - 1) + f**2*(266*C - 181*K - 95)*(r + s - 1) + 2*f*(54*fd*(2*K - 1)*(2*r + 2*s - 1) + (329*g2 - 504*gd2)*(r + s - 1)) - 1008*fd*g2*(r + s)) + 36*Dd*f*(f*(6*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(370*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(627*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 700*fd*(4*r + 4*s - 3)**2 - 1716*r**2 - 429*r*(8*s - 6) - 1716*s**2 + 2574*s - 1287) - 1991*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2376*f*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2376*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2*Ddd*f*(175*f**2 - 594*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 24*Dd**2*f**2*(175*f**2 - 594*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 11*b1**2*(D1**2*(12*f*(16*fd - 15*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(360*fd**2*(r + s - 1) + 7*fd*(47*K - 21)*(r + s) - 126*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(192*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(360*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (329*K - 147)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 252*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 18*Ddd*f*(-14*K + 10*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*f*(-14*K + 10*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(532*C*D1**2*f*fd*r**2 + 1064*C*D1**2*f*fd*r*s - 532*C*D1**2*f*fd*r + 532*C*D1**2*f*fd*s**2 - 532*C*D1**2*f*fd*s + 266*C*D1**2*f*fd + 1064*C*D1*Dd*f**2*r**2 + 2128*C*D1*Dd*f**2*r*s - 1596*C*D1*Dd*f**2*r + 1064*C*D1*Dd*f**2*s**2 - 1596*C*D1*Dd*f**2*s + 798*C*D1*Dd*f**2 - 362*D1**2*K*f*fd*r**2 - 724*D1**2*K*f*fd*r*s + 362*D1**2*K*f*fd*r - 362*D1**2*K*f*fd*s**2 + 362*D1**2*K*f*fd*s - 181*D1**2*K*f*fd + 216*D1**2*K*f*fdd*r**2 + 432*D1**2*K*f*fdd*r*s - 216*D1**2*K*f*fdd*r + 216*D1**2*K*f*fdd*s**2 - 216*D1**2*K*f*fdd*s + 108*D1**2*K*f*fdd + 216*D1**2*K*fd**2*r**2 + 432*D1**2*K*fd**2*r*s - 216*D1**2*K*fd**2*r + 216*D1**2*K*fd**2*s**2 - 216*D1**2*K*fd**2*s - 36*D1**2*bdd1*f*(-14*K + 10*f + 7)*(r + s - 1)**2 + 108*D1**2*f**2*fd*r**2 + 216*D1**2*f**2*fd*r*s - 144*D1**2*f**2*fd*r + 108*D1**2*f**2*fd*s**2 - 144*D1**2*f**2*fd*s + 72*D1**2*f**2*fd - 190*D1**2*f*fd*r**2 - 380*D1**2*f*fd*r*s + 190*D1**2*f*fd*r - 190*D1**2*f*fd*s**2 + 190*D1**2*f*fd*s - 95*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 216*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*r - 108*D1**2*f*fdd*s**2 + 108*D1**2*f*fdd*s - 54*D1**2*f*fdd + 658*D1**2*f*gd2*r**2 + 1316*D1**2*f*gd2*r*s - 1316*D1**2*f*gd2*r + 658*D1**2*f*gd2*s**2 - 1316*D1**2*f*gd2*s + 658*D1**2*f*gd2 - 504*D1**2*f*gdd2*r**2 - 1008*D1**2*f*gdd2*r*s + 1008*D1**2*f*gdd2*r - 504*D1**2*f*gdd2*s**2 + 1008*D1**2*f*gdd2*s - 504*D1**2*f*gdd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 108*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 108*D1**2*fd**2*s + 658*D1**2*fd*g2*r**2 + 1316*D1**2*fd*g2*r*s + 658*D1**2*fd*g2*s**2 - 1008*D1**2*fd*gd2*r**2 - 2016*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 1008*D1**2*fd*gd2*s**2 + 1008*D1**2*fd*gd2*s - 504*D1**2*fdd*g2*r**2 - 1008*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*s**2 - 724*D1*Dd*K*f**2*r**2 - 1448*D1*Dd*K*f**2*r*s + 1086*D1*Dd*K*f**2*r - 724*D1*Dd*K*f**2*s**2 + 1086*D1*Dd*K*f**2*s - 543*D1*Dd*K*f**2 + 1728*D1*Dd*K*f*fd*r**2 + 3456*D1*Dd*K*f*fd*r*s - 2160*D1*Dd*K*f*fd*r + 1728*D1*Dd*K*f*fd*s**2 - 2160*D1*Dd*K*f*fd*s + 648*D1*Dd*K*f*fd + 144*D1*Dd*f**3*r**2 + 288*D1*Dd*f**3*r*s - 216*D1*Dd*f**3*r + 144*D1*Dd*f**3*s**2 - 216*D1*Dd*f**3*s + 108*D1*Dd*f**3 - 380*D1*Dd*f**2*r**2 - 760*D1*Dd*f**2*r*s + 570*D1*Dd*f**2*r - 380*D1*Dd*f**2*s**2 + 570*D1*Dd*f**2*s - 285*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 1728*D1*Dd*f*fd*r*s + 1080*D1*Dd*f*fd*r - 864*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 324*D1*Dd*f*fd + 2632*D1*Dd*f*g2*r**2 + 5264*D1*Dd*f*g2*r*s - 3948*D1*Dd*f*g2*r + 2632*D1*Dd*f*g2*s**2 - 3948*D1*Dd*f*g2*s + 1974*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r**2 - 8064*D1*Dd*f*gd2*r*s + 7056*D1*Dd*f*gd2*r - 4032*D1*Dd*f*gd2*s**2 + 7056*D1*Dd*f*gd2*s - 3024*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r**2 - 8064*D1*Dd*fd*g2*r*s + 3024*D1*Dd*fd*g2*r - 4032*D1*Dd*fd*g2*s**2 + 3024*D1*Dd*fd*g2*s + 432*D1*Ddd*K*f**2*r**2 + 864*D1*Ddd*K*f**2*r*s - 648*D1*Ddd*K*f**2*r + 432*D1*Ddd*K*f**2*s**2 - 648*D1*Ddd*K*f**2*s + 324*D1*Ddd*K*f**2 - 216*D1*Ddd*f**2*r**2 - 432*D1*Ddd*f**2*r*s + 324*D1*Ddd*f**2*r - 216*D1*Ddd*f**2*s**2 + 324*D1*Ddd*f**2*s - 162*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r**2 - 4032*D1*Ddd*f*g2*r*s + 3024*D1*Ddd*f*g2*r - 2016*D1*Ddd*f*g2*s**2 + 3024*D1*Ddd*f*g2*s - 1512*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(192*f**2*(r + s - 1) - 360*f*fd*(2*r + 2*s - 1) - 7*f*(47*K - 21)*(r + s - 1) + 252*fd*(2*K - 1)*(r + s)) - 36*Dd*f*(-14*K + 10*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 1296*Dd**2*K*f**2*r**2 + 2592*Dd**2*K*f**2*r*s - 1944*Dd**2*K*f**2*r + 1296*Dd**2*K*f**2*s**2 - 1944*Dd**2*K*f**2*s + 648*Dd**2*K*f**2 - 648*Dd**2*f**2*r**2 - 1296*Dd**2*f**2*r*s + 972*Dd**2*f**2*r - 648*Dd**2*f**2*s**2 + 972*Dd**2*f**2*s - 324*Dd**2*f**2 - 6048*Dd**2*f*g2*r**2 - 12096*Dd**2*f*g2*r*s + 9072*Dd**2*f*g2*r - 6048*Dd**2*f*g2*s**2 + 9072*Dd**2*f*g2*s - 3024*Dd**2*f*g2))/(385*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**2*k1**2*k2**2*st**4*(b1*(D1**2*(f*(fd*(164*C - 111) + fdd*(66 - 96*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(66 - 96*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(164*C - 111)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(66 - 96*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(66 - 96*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(66 - 96*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(60*C - 41)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (32*C - 22)*(3*bdd1*s*(r + s - 1) + fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(22 - 32*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(164*C - 111)*(r + s - 1) - fd*(96*C - 66)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(66 - 96*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(60*C - 41)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(32*C - 22)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(22 - 32*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(22 - 32*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**2*k1**2*k2**2*st**2*(42*b1**2*(D1**2*(fd*(13*C - 6) + fdd*(13 - 19*C))*(r + s - 1)**2 + D1*(Dd*(f*(13*C - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(26 - 38*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(19*C - 13)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(114*C - 78)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-1658*C*D1**2*f*fd*r**2 - 5308*C*D1**2*f*fd*r*s + 2338*C*D1**2*f*fd*r - 3650*C*D1**2*f*fd*s**2 + 3334*C*D1**2*f*fd*s - 1667*C*D1**2*f*fd + 2446*C*D1**2*f*fdd*r**2 + 6140*C*D1**2*f*fdd*r*s - 2842*C*D1**2*f*fdd*r + 3694*C*D1**2*f*fdd*s**2 - 3466*C*D1**2*f*fdd*s + 1733*C*D1**2*f*fdd + 2446*C*D1**2*fd**2*r**2 + 6140*C*D1**2*fd**2*r*s - 2842*C*D1**2*fd**2*r + 3694*C*D1**2*fd**2*s**2 - 3466*C*D1**2*fd**2*s - 228*C*D1**2*fd**2 - 3316*C*D1*Dd*f**2*r**2 - 10616*C*D1*Dd*f**2*r*s + 6966*C*D1*Dd*f**2*r - 7300*C*D1*Dd*f**2*s**2 + 9954*C*D1*Dd*f**2*s - 4479*C*D1*Dd*f**2 + 19568*C*D1*Dd*f*fd*r**2 + 49120*C*D1*Dd*f*fd*r*s - 28540*C*D1*Dd*f*fd*r + 29552*C*D1*Dd*f*fd*s**2 - 34780*C*D1*Dd*f*fd*s + 9774*C*D1*Dd*f*fd + 4892*C*D1*Ddd*f**2*r**2 + 12280*C*D1*Ddd*f**2*r*s - 8586*C*D1*Ddd*f**2*r + 7388*C*D1*Ddd*f**2*s**2 - 10458*C*D1*Ddd*f**2*s + 4917*C*D1*Ddd*f**2 + 14676*C*Dd**2*f**2*r**2 + 36840*C*Dd**2*f**2*r*s - 25758*C*Dd**2*f**2*r + 22164*C*Dd**2*f**2*s**2 - 31374*C*Dd**2*f**2*s + 9834*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(19*C - 13)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 1146*D1**2*f*fd*r**2 + 3708*D1**2*f*fd*r*s - 1654*D1**2*f*fd*r + 2562*D1**2*f*fd*s**2 - 2362*D1**2*f*fd*s + 1181*D1**2*f*fd - 1630*D1**2*f*fdd*r**2 - 4304*D1**2*f*fdd*r*s + 1996*D1**2*f*fdd*r - 2674*D1**2*f*fdd*s**2 + 2518*D1**2*f*fdd*s - 1259*D1**2*f*fdd - 1630*D1**2*fd**2*r**2 - 4304*D1**2*fd**2*r*s + 1996*D1**2*fd**2*r - 2674*D1**2*fd**2*s**2 + 2518*D1**2*fd**2*s + 156*D1**2*fd**2 + 2292*D1*Dd*f**2*r**2 + 7416*D1*Dd*f**2*r*s - 4854*D1*Dd*f**2*r + 5124*D1*Dd*f**2*s**2 - 6978*D1*Dd*f**2*s + 3135*D1*Dd*f**2 - 13040*D1*Dd*f*fd*r**2 - 34432*D1*Dd*f*fd*r*s + 19852*D1*Dd*f*fd*r - 21392*D1*Dd*f*fd*s**2 + 25072*D1*Dd*f*fd*s - 7032*D1*Dd*f*fd - 3260*D1*Ddd*f**2*r**2 - 8608*D1*Ddd*f**2*r*s + 5934*D1*Ddd*f**2*r - 5348*D1*Ddd*f**2*s**2 + 7500*D1*Ddd*f**2*s - 3489*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(13*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(26 - 38*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(26 - 38*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 9780*Dd**2*f**2*r**2 - 25824*Dd**2*f**2*r*s + 17802*Dd**2*f**2*r - 16044*Dd**2*f**2*s**2 + 22500*Dd**2*f**2*s - 6978*Dd**2*f**2) + f*(-7815*C*D1**2*f*fd*r**2 - 16698*C*D1**2*f*fd*r*s + 10776*C*D1**2*f*fd*r - 8883*C*D1**2*f*fd*s**2 + 11488*C*D1**2*f*fd*s - 5566*C*D1**2*f*fd + 7701*C*D1**2*f*fdd*r**2 + 15882*C*D1**2*f*fdd*r*s - 10428*C*D1**2*f*fdd*r + 8181*C*D1**2*f*fdd*s**2 - 10748*C*D1**2*f*fdd*s + 5294*C*D1**2*f*fdd + 15402*C*D1**2*fd**2*r**2 + 31764*C*D1**2*fd**2*r*s - 20856*C*D1**2*fd**2*r + 16362*C*D1**2*fd**2*s**2 - 21496*C*D1**2*fd**2*s + 5294*C*D1**2*fd**2 - 10420*C*D1*Dd*f**2*r**2 - 22264*C*D1*Dd*f**2*r*s + 16342*C*D1*Dd*f**2*r - 11844*C*D1*Dd*f**2*s**2 + 17410*C*D1*Dd*f**2*s - 8527*C*D1*Dd*f**2 + 61608*C*D1*Dd*f*fd*r**2 + 127056*C*D1*Dd*f*fd*r*s - 88878*C*D1*Dd*f*fd*r + 65448*C*D1*Dd*f*fd*s**2 - 91598*C*D1*Dd*f*fd*s + 31924*C*D1*Dd*f*fd + 10268*C*D1*Ddd*f**2*r**2 + 21176*C*D1*Ddd*f**2*r*s - 15722*C*D1*Ddd*f**2*r + 10908*C*D1*Ddd*f**2*s**2 - 16202*C*D1*Ddd*f**2*s + 8021*C*D1*Ddd*f**2 + 30804*C*Dd**2*f**2*r**2 + 63528*C*Dd**2*f**2*r*s - 47166*C*Dd**2*f**2*r + 32724*C*Dd**2*f**2*s**2 - 48606*C*Dd**2*f**2*s + 16042*C*Dd**2*f**2 - 84*D1**2*bd1**2*(19*C - 13)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*D1**2*bdd1*f*(C*(1223*r**2 + 3070*r*s - 2674*r + 1847*s**2 - 3298*s + 1337) - 815*r**2 - 2152*r*s + 1786*r - 1337*s**2 + 2308*s - 893) + 5205*D1**2*f*fd*r**2 + 11478*D1**2*f*fd*r*s - 7296*D1**2*f*fd*r + 6273*D1**2*f*fd*s**2 - 8008*D1**2*f*fd*s + 3826*D1**2*f*fd - 5073*D1**2*f*fdd*r**2 - 11004*D1**2*f*fdd*r*s + 7050*D1**2*f*fdd*r - 5931*D1**2*f*fdd*s**2 + 7622*D1**2*f*fdd*s - 3668*D1**2*f*fdd - 10146*D1**2*fd**2*r**2 - 22008*D1**2*fd**2*r*s + 14100*D1**2*fd**2*r - 11862*D1**2*fd**2*s**2 + 15244*D1**2*fd**2*s - 3668*D1**2*fd**2 + 6940*D1*Dd*f**2*r**2 + 15304*D1*Dd*f**2*r*s - 11122*D1*Dd*f**2*r + 8364*D1*Dd*f**2*s**2 - 12190*D1*Dd*f**2*s + 5917*D1*Dd*f**2 - 40584*D1*Dd*f*fd*r**2 - 88032*D1*Dd*f*fd*r*s + 60354*D1*Dd*f*fd*r - 47448*D1*Dd*f*fd*s**2 + 65216*D1*Dd*f*fd*s - 22294*D1*Dd*f*fd - 6764*D1*Ddd*f**2*r**2 - 14672*D1*Ddd*f**2*r*s + 10718*D1*Ddd*f**2*r - 7908*D1*Ddd*f**2*s**2 + 11576*D1*Ddd*f**2*s - 5645*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(C*(829*r**2 + 2654*r*s - 1974*r + 1825*s**2 - 2970*s + 987) - 573*r**2 - 1854*r*s + 1346*r - 1281*s**2 + 2054*s - 673) + 2*fd*(-C*(2446*r**2 + 6140*r*s - 4095*r + 3694*s**2 - 5031*s + 1649) + 1630*r**2 + 4304*r*s - 2784*r + 2674*s**2 - 3567*s + 1154)) - 2*Dd*f*(C*(4892*r**2 + 12280*r*s - 9641*r + 7388*s**2 - 11825*s + 4635) - 3260*r**2 - 8608*r*s + 6539*r - 5348*s**2 + 8366*s - 3201)) - 20292*Dd**2*f**2*r**2 - 44016*Dd**2*f**2*r*s + 32154*Dd**2*f**2*r - 23724*Dd**2*f**2*s**2 + 34728*Dd**2*f**2*s - 11290*Dd**2*f**2))/(315*d**2*k3**6) + 2*D1**2*Pk1*Pk3*ct**2*k1**2*k2**2*(-5544*C*D1**2*bd1*f**2*r**2 - 5544*C*D1**2*bd1*f**2*r*s + 16632*C*D1**2*bd1*f**2*r + 11088*C*D1**2*bd1*f**2*s - 8316*C*D1**2*bd1*f**2 - 17820*C*D1**2*f**2*fd*r**2 - 23760*C*D1**2*f**2*fd*r*s + 19800*C*D1**2*f**2*fd*r - 5940*C*D1**2*f**2*fd*s**2 + 11880*C*D1**2*f**2*fd*s - 7920*C*D1**2*f**2*fd - 23760*C*D1*Dd*f**3*r**2 - 31680*C*D1*Dd*f**3*r*s + 27720*C*D1*Dd*f**3*r - 7920*C*D1*Dd*f**3*s**2 + 15840*C*D1*Dd*f**3*s - 9900*C*D1*Dd*f**3 - 102564*D1**2*K*bd1**2*f*r**2 - 205128*D1**2*K*bd1**2*f*r*s + 221760*D1**2*K*bd1**2*f*r - 102564*D1**2*K*bd1**2*f*s**2 + 221760*D1**2*K*bd1**2*f*s - 119196*D1**2*K*bd1**2*f + 43164*D1**2*K*bd1*f**2*r**2 + 67716*D1**2*K*bd1*f**2*r*s - 67716*D1**2*K*bd1*f**2*r + 24552*D1**2*K*bd1*f**2*s**2 - 49104*D1**2*K*bd1*f**2*s + 24552*D1**2*K*bd1*f**2 - 186120*D1**2*K*bd1*f*fd*r**2 - 340560*D1**2*K*bd1*f*fd*r*s + 263340*D1**2*K*bd1*f*fd*r - 154440*D1**2*K*bd1*f*fd*s**2 + 239580*D1**2*K*bd1*f*fd*s - 85140*D1**2*K*bd1*f*fd - 46530*D1**2*K*bdd1*f**2*r**2 - 85140*D1**2*K*bdd1*f**2*r*s + 85140*D1**2*K*bdd1*f**2*r - 38610*D1**2*K*bdd1*f**2*s**2 + 77220*D1**2*K*bdd1*f**2*s - 38610*D1**2*K*bdd1*f**2 + 33066*D1**2*bd1**2*f**2*r**2 + 82764*D1**2*bd1**2*f**2*r*s - 78408*D1**2*bd1**2*f**2*r + 49698*D1**2*bd1**2*f**2*s**2 - 95040*D1**2*bd1**2*f**2*s + 45342*D1**2*bd1**2*f**2 + 45738*D1**2*bd1**2*f*r**2 + 108108*D1**2*bd1**2*f*r*s - 108108*D1**2*bd1**2*f*r + 62370*D1**2*bd1**2*f*s**2 - 124740*D1**2*bd1**2*f*s + 62370*D1**2*bd1**2*f - 55440*D1**2*bd1**2*g2*r**2 - 110880*D1**2*bd1**2*g2*r*s + 55440*D1**2*bd1**2*g2*r - 55440*D1**2*bd1**2*g2*s**2 + 55440*D1**2*bd1**2*g2*s - 16632*D1**2*bd1*bd2*f*r**2 - 33264*D1**2*bd1*bd2*f*r*s + 33264*D1**2*bd1*bd2*f*r - 16632*D1**2*bd1*bd2*f*s**2 + 33264*D1**2*bd1*bd2*f*s - 16632*D1**2*bd1*bd2*f - 11330*D1**2*bd1*f**3*r**2 - 17050*D1**2*bd1*f**3*r*s + 23980*D1**2*bd1*f**3*r - 5720*D1**2*bd1*f**3*s**2 + 18370*D1**2*bd1*f**3*s - 13200*D1**2*bd1*f**3 + 78540*D1**2*bd1*f**2*fd*r**2 + 131340*D1**2*bd1*f**2*fd*r*s - 127600*D1**2*bd1*f**2*fd*r + 52800*D1**2*bd1*f**2*fd*s**2 - 106150*D1**2*bd1*f**2*fd*s + 44880*D1**2*bd1*f**2*fd - 13959*D1**2*bd1*f**2*r**2 - 27918*D1**2*bd1*f**2*r*s + 20988*D1**2*bd1*f**2*r - 13959*D1**2*bd1*f**2*s**2 + 20988*D1**2*bd1*f**2*s - 8415*D1**2*bd1*f**2 + 81972*D1**2*bd1*f*fd*r**2 + 175032*D1**2*bd1*f*fd*r*s - 128502*D1**2*bd1*f*fd*r + 93060*D1**2*bd1*f*fd*s**2 - 136818*D1**2*bd1*f*fd*s + 43758*D1**2*bd1*f*fd - 61908*D1**2*bd1*f*g2*r**2 - 114576*D1**2*bd1*f*g2*r*s + 144144*D1**2*bd1*f*g2*r - 52668*D1**2*bd1*f*g2*s**2 + 134904*D1**2*bd1*f*g2*s - 72072*D1**2*bd1*f*g2 + 205128*D1**2*bd1*f*gd2*r**2 + 410256*D1**2*bd1*f*gd2*r*s - 443520*D1**2*bd1*f*gd2*r + 205128*D1**2*bd1*f*gd2*s**2 - 443520*D1**2*bd1*f*gd2*s + 238392*D1**2*bd1*f*gd2 + 205128*D1**2*bd1*fd*g2*r**2 + 410256*D1**2*bd1*fd*g2*r*s - 205128*D1**2*bd1*fd*g2*r + 205128*D1**2*bd1*fd*g2*s**2 - 205128*D1**2*bd1*fd*g2*s + 4950*D1**2*bd2*f**2*r**2 + 9900*D1**2*bd2*f**2*r*s - 9900*D1**2*bd2*f**2*r + 4950*D1**2*bd2*f**2*s**2 - 9900*D1**2*bd2*f**2*s + 4950*D1**2*bd2*f**2 - 23760*D1**2*bd2*f*fd*r**2 - 47520*D1**2*bd2*f*fd*r*s + 35640*D1**2*bd2*f*fd*r - 23760*D1**2*bd2*f*fd*s**2 + 35640*D1**2*bd2*f*fd*s - 11880*D1**2*bd2*f*fd + 13090*D1**2*bdd1*f**3*r**2 + 21890*D1**2*bdd1*f**3*r*s - 28820*D1**2*bdd1*f**3*r + 8800*D1**2*bdd1*f**3*s**2 - 24530*D1**2*bdd1*f**3*s + 16500*D1**2*bdd1*f**3 + 20493*D1**2*bdd1*f**2*r**2 + 43758*D1**2*bdd1*f**2*r*s - 43758*D1**2*bdd1*f**2*r + 23265*D1**2*bdd1*f**2*s**2 - 46530*D1**2*bdd1*f**2*s + 23265*D1**2*bdd1*f**2 + 102564*D1**2*bdd1*f*g2*r**2 + 205128*D1**2*bdd1*f*g2*r*s - 238392*D1**2*bdd1*f*g2*r + 102564*D1**2*bdd1*f*g2*s**2 - 238392*D1**2*bdd1*f*g2*s + 119196*D1**2*bdd1*f*g2 - 5940*D1**2*bdd2*f**2*r**2 - 11880*D1**2*bdd2*f**2*r*s + 11880*D1**2*bdd2*f**2*r - 5940*D1**2*bdd2*f**2*s**2 + 11880*D1**2*bdd2*f**2*s - 5940*D1**2*bdd2*f**2 + 9100*D1**2*f**3*fd*r**2 + 41440*D1**2*f**3*fd*r*s - 25270*D1**2*f**3*fd*r + 32340*D1**2*f**3*fd*s**2 - 42700*D1**2*f**3*fd*s + 18445*D1**2*f**3*fd - 9940*D1**2*f**3*fdd*r**2 - 45360*D1**2*f**3*fdd*r*s + 27650*D1**2*f**3*fdd*r - 35420*D1**2*f**3*fdd*s**2 + 46760*D1**2*f**3*fdd*s - 20195*D1**2*f**3*fdd - 29820*D1**2*f**2*fd**2*r**2 - 136080*D1**2*f**2*fd**2*r*s + 82950*D1**2*f**2*fd**2*r - 106260*D1**2*f**2*fd**2*s**2 + 140280*D1**2*f**2*fd**2*s - 40390*D1**2*f**2*fd**2 + 11880*D1**2*f**2*fd*r**2 + 14850*D1**2*f**2*fd*r*s - 12870*D1**2*f**2*fd*r + 2970*D1**2*f**2*fd*s**2 - 6930*D1**2*f**2*fd*s + 4950*D1**2*f**2*fd - 86328*D1**2*f**2*gd2*r**2 - 135432*D1**2*f**2*gd2*r*s + 135432*D1**2*f**2*gd2*r - 49104*D1**2*f**2*gd2*s**2 + 98208*D1**2*f**2*gd2*s - 49104*D1**2*f**2*gd2 + 93060*D1**2*f**2*gdd2*r**2 + 170280*D1**2*f**2*gdd2*r*s - 170280*D1**2*f**2*gdd2*r + 77220*D1**2*f**2*gdd2*s**2 - 154440*D1**2*f**2*gdd2*s + 77220*D1**2*f**2*gdd2 - 172656*D1**2*f*fd*g2*r**2 - 270864*D1**2*f*fd*g2*r*s + 172656*D1**2*f*fd*g2*r - 98208*D1**2*f*fd*g2*s**2 + 135432*D1**2*f*fd*g2*s - 86328*D1**2*f*fd*g2 + 372240*D1**2*f*fd*gd2*r**2 + 681120*D1**2*f*fd*gd2*r*s - 526680*D1**2*f*fd*gd2*r + 308880*D1**2*f*fd*gd2*s**2 - 479160*D1**2*f*fd*gd2*s + 170280*D1**2*f*fd*gd2 + 186120*D1**2*f*fdd*g2*r**2 + 340560*D1**2*f*fdd*g2*r*s - 186120*D1**2*f*fdd*g2*r + 154440*D1**2*f*fdd*g2*s**2 - 170280*D1**2*f*fdd*g2*s + 93060*D1**2*f*fdd*g2 + 186120*D1**2*fd**2*g2*r**2 + 340560*D1**2*fd**2*g2*r*s - 186120*D1**2*fd**2*g2*r + 154440*D1**2*fd**2*g2*s**2 - 170280*D1**2*fd**2*g2*s - 372240*D1*Dd*K*bd1*f**2*r**2 - 681120*D1*Dd*K*bd1*f**2*r*s + 603900*D1*Dd*K*bd1*f**2*r - 308880*D1*Dd*K*bd1*f**2*s**2 + 548460*D1*Dd*K*bd1*f**2*s - 239580*D1*Dd*K*bd1*f**2 + 104720*D1*Dd*bd1*f**3*r**2 + 175120*D1*Dd*bd1*f**3*r*s - 185240*D1*Dd*bd1*f**3*r + 70400*D1*Dd*bd1*f**3*s**2 - 155210*D1*Dd*bd1*f**3*s + 77880*D1*Dd*bd1*f**3 + 163944*D1*Dd*bd1*f**2*r**2 + 350064*D1*Dd*bd1*f**2*r*s - 303534*D1*Dd*bd1*f**2*r + 186120*D1*Dd*bd1*f**2*s**2 - 322938*D1*Dd*bd1*f**2*s + 136818*D1*Dd*bd1*f**2 + 820512*D1*Dd*bd1*f*g2*r**2 + 1641024*D1*Dd*bd1*f*g2*r*s - 1568952*D1*Dd*bd1*f*g2*r + 820512*D1*Dd*bd1*f*g2*s**2 - 1568952*D1*Dd*bd1*f*g2*s + 715176*D1*Dd*bd1*f*g2 - 47520*D1*Dd*bd2*f**2*r**2 - 95040*D1*Dd*bd2*f**2*r*s + 83160*D1*Dd*bd2*f**2*r - 47520*D1*Dd*bd2*f**2*s**2 + 83160*D1*Dd*bd2*f**2*s - 35640*D1*Dd*bd2*f**2 + 9100*D1*Dd*f**4*r**2 + 41440*D1*Dd*f**4*r*s - 25270*D1*Dd*f**4*r + 32340*D1*Dd*f**4*s**2 - 42700*D1*Dd*f**4*s + 18445*D1*Dd*f**4 - 79520*D1*Dd*f**3*fd*r**2 - 362880*D1*Dd*f**3*fd*r*s + 221200*D1*Dd*f**3*fd*r - 283360*D1*Dd*f**3*fd*s**2 + 374080*D1*Dd*f**3*fd*s - 121170*D1*Dd*f**3*fd + 15840*D1*Dd*f**3*r**2 + 19800*D1*Dd*f**3*r*s - 17820*D1*Dd*f**3*r + 3960*D1*Dd*f**3*s**2 - 8910*D1*Dd*f**3*s + 5940*D1*Dd*f**3 - 345312*D1*Dd*f**2*g2*r**2 - 541728*D1*Dd*f**2*g2*r*s + 443520*D1*Dd*f**2*g2*r - 196416*D1*Dd*f**2*g2*s**2 + 331848*D1*Dd*f**2*g2*s - 184536*D1*Dd*f**2*g2 + 744480*D1*Dd*f**2*gd2*r**2 + 1362240*D1*Dd*f**2*gd2*r*s - 1207800*D1*Dd*f**2*gd2*r + 617760*D1*Dd*f**2*gd2*s**2 - 1096920*D1*Dd*f**2*gd2*s + 479160*D1*Dd*f**2*gd2 + 1488960*D1*Dd*f*fd*g2*r**2 + 2724480*D1*Dd*f*fd*g2*r*s - 1797840*D1*Dd*f*fd*g2*r + 1235520*D1*Dd*f*fd*g2*s**2 - 1639440*D1*Dd*f*fd*g2*s + 526680*D1*Dd*f*fd*g2 - 9940*D1*Ddd*f**4*r**2 - 45360*D1*Ddd*f**4*r*s + 27650*D1*Ddd*f**4*r - 35420*D1*Ddd*f**4*s**2 + 46760*D1*Ddd*f**4*s - 20195*D1*Ddd*f**4 + 372240*D1*Ddd*f**2*g2*r**2 + 681120*D1*Ddd*f**2*g2*r*s - 526680*D1*Ddd*f**2*g2*r + 308880*D1*Ddd*f**2*g2*s**2 - 479160*D1*Ddd*f**2*g2*s + 247500*D1*Ddd*f**2*g2 - 29820*Dd**2*f**4*r**2 - 136080*Dd**2*f**4*r*s + 82950*Dd**2*f**4*r - 106260*Dd**2*f**4*s**2 + 140280*Dd**2*f**4*s - 40390*Dd**2*f**4 + 1116720*Dd**2*f**2*g2*r**2 + 2043360*Dd**2*f**2*g2*r*s - 1580040*Dd**2*f**2*g2*r + 926640*Dd**2*f**2*g2*s**2 - 1437480*Dd**2*f**2*g2*s + 495000*Dd**2*f**2*g2 + 1386*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (5*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(140*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 140*C*D1**2*fd*s**2 - 280*C*D1**2*fd*s + 140*C*D1**2*fd + 560*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 840*C*D1*Dd*f*r + 560*C*D1*Dd*f*s**2 - 840*C*D1*Dd*f*s + 420*C*D1*Dd*f + 938*D1**2*K*fd*r**2 + 1736*D1**2*K*fd*r*s + 308*D1**2*K*fd*r + 798*D1**2*K*fd*s**2 + 308*D1**2*K*fd*s - 154*D1**2*K*fd - 1554*D1**2*K*fdd*r**2 - 3108*D1**2*K*fdd*r*s - 504*D1**2*K*fdd*r - 1554*D1**2*K*fdd*s**2 - 504*D1**2*K*fdd*s + 252*D1**2*K*fdd - 42*D1**2*bdd1*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 702*D1**2*f*fd*r**2 - 1908*D1**2*f*fd*r*s + 882*D1**2*f*fd*r - 1206*D1**2*f*fd*s**2 + 1134*D1**2*f*fd*s - 567*D1**2*f*fd + 1002*D1**2*f*fdd*r**2 + 2508*D1**2*f*fdd*r*s - 1134*D1**2*f*fdd*r + 1506*D1**2*f*fdd*s**2 - 1386*D1**2*f*fdd*s + 693*D1**2*f*fdd + 1002*D1**2*fd**2*r**2 + 2508*D1**2*fd**2*r*s - 1134*D1**2*fd**2*r + 1506*D1**2*fd**2*s**2 - 1386*D1**2*fd**2*s - 120*D1**2*fd**2 - 511*D1**2*fd*r**2 - 1036*D1**2*fd*r*s + 56*D1**2*fd*r - 525*D1**2*fd*s**2 + 56*D1**2*fd*s - 28*D1**2*fd + 693*D1**2*fdd*r**2 + 1638*D1**2*fdd*r*s + 252*D1**2*fdd*r + 945*D1**2*fdd*s**2 + 252*D1**2*fdd*s - 126*D1**2*fdd - 420*D1**2*gd2*r**2 - 840*D1**2*gd2*r*s + 840*D1**2*gd2*r - 420*D1**2*gd2*s**2 + 840*D1**2*gd2*s - 420*D1**2*gd2 - 840*D1**2*gdd2*r**2 - 1680*D1**2*gdd2*r*s + 1680*D1**2*gdd2*r - 840*D1**2*gdd2*s**2 + 1680*D1**2*gdd2*s - 840*D1**2*gdd2 + 3752*D1*Dd*K*f*r**2 + 6944*D1*Dd*K*f*r*s - 5348*D1*Dd*K*f*r + 3192*D1*Dd*K*f*s**2 - 4928*D1*Dd*K*f*s + 2534*D1*Dd*K*f - 12432*D1*Dd*K*fd*r**2 - 24864*D1*Dd*K*fd*r*s + 7308*D1*Dd*K*fd*r - 12432*D1*Dd*K*fd*s**2 + 7308*D1*Dd*K*fd*s + 1512*D1*Dd*K*fd - 1404*D1*Dd*f**2*r**2 - 3816*D1*Dd*f**2*r*s + 2610*D1*Dd*f**2*r - 2412*D1*Dd*f**2*s**2 + 3366*D1*Dd*f**2*s - 1557*D1*Dd*f**2 + 8016*D1*Dd*f*fd*r**2 + 20064*D1*Dd*f*fd*r*s - 11556*D1*Dd*f*fd*r + 12048*D1*Dd*f*fd*s**2 - 14076*D1*Dd*f*fd*s + 3906*D1*Dd*f*fd - 2044*D1*Dd*f*r**2 - 4144*D1*Dd*f*r*s + 3094*D1*Dd*f*r - 2100*D1*Dd*f*s**2 + 3136*D1*Dd*f*s - 1561*D1*Dd*f + 5544*D1*Dd*fd*r**2 + 13104*D1*Dd*fd*r*s - 3654*D1*Dd*fd*r + 7560*D1*Dd*fd*s**2 - 4410*D1*Dd*fd*s - 756*D1*Dd*fd - 1680*D1*Dd*g2*r**2 - 3360*D1*Dd*g2*r*s + 2520*D1*Dd*g2*r - 1680*D1*Dd*g2*s**2 + 2520*D1*Dd*g2*s - 1260*D1*Dd*g2 - 6720*D1*Dd*gd2*r**2 - 13440*D1*Dd*gd2*r*s + 11760*D1*Dd*gd2*r - 6720*D1*Dd*gd2*s**2 + 11760*D1*Dd*gd2*s - 5040*D1*Dd*gd2 - 6216*D1*Ddd*K*f*r**2 - 12432*D1*Ddd*K*f*r*s + 9324*D1*Ddd*K*f*r - 6216*D1*Ddd*K*f*s**2 + 9324*D1*Ddd*K*f*s - 4662*D1*Ddd*K*f + 2004*D1*Ddd*f**2*r**2 + 5016*D1*Ddd*f**2*r*s - 3510*D1*Ddd*f**2*r + 3012*D1*Ddd*f**2*s**2 - 4266*D1*Ddd*f**2*s + 2007*D1*Ddd*f**2 + 2772*D1*Ddd*f*r**2 + 6552*D1*Ddd*f*r*s - 4662*D1*Ddd*f*r + 3780*D1*Ddd*f*s**2 - 5418*D1*Ddd*f*s + 2583*D1*Ddd*f - 3360*D1*Ddd*g2*r**2 - 6720*D1*Ddd*g2*r*s + 5040*D1*Ddd*g2*r - 3360*D1*Ddd*g2*s**2 + 5040*D1*Ddd*g2*s - 2520*D1*Ddd*g2 + 42*D1*bd1*(D1*(f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (5*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-10*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 18648*Dd**2*K*f*r**2 - 37296*Dd**2*K*f*r*s + 27972*Dd**2*K*f*r - 18648*Dd**2*K*f*s**2 + 27972*Dd**2*K*f*s - 9324*Dd**2*K*f + 6012*Dd**2*f**2*r**2 + 15048*Dd**2*f**2*r*s - 10530*Dd**2*f**2*r + 9036*Dd**2*f**2*s**2 - 12798*Dd**2*f**2*s + 4014*Dd**2*f**2 + 8316*Dd**2*f*r**2 + 19656*Dd**2*f*r*s - 13986*Dd**2*f*r + 11340*Dd**2*f*s**2 - 16254*Dd**2*f*s + 5166*Dd**2*f - 10080*Dd**2*g2*r**2 - 20160*Dd**2*g2*r*s + 15120*Dd**2*g2*r - 10080*Dd**2*g2*s**2 + 15120*Dd**2*g2*s - 5040*Dd**2*g2) - 11*b1*(1008*C*D1**2*f*fd*r**2 + 1008*C*D1**2*f*fd*r*s + 504*C*D1**2*f*fd*s - 252*C*D1**2*f*fd + 2016*C*D1*Dd*f**2*r**2 + 2016*C*D1*Dd*f**2*r*s - 2016*C*D1*Dd*f**2*r - 504*C*D1*Dd*f**2*s + 504*C*D1*Dd*f**2 + 9324*D1**2*K*bdd1*f*r**2 + 18648*D1**2*K*bdd1*f*r*s - 20160*D1**2*K*bdd1*f*r + 9324*D1**2*K*bdd1*f*s**2 - 20160*D1**2*K*bdd1*f*s + 10080*D1**2*K*bdd1*f - 7848*D1**2*K*f*fd*r**2 - 12312*D1**2*K*f*fd*r*s + 7848*D1**2*K*f*fd*r - 4464*D1**2*K*f*fd*s**2 + 6156*D1**2*K*f*fd*s - 3924*D1**2*K*f*fd + 8460*D1**2*K*f*fdd*r**2 + 15480*D1**2*K*f*fdd*r*s - 8460*D1**2*K*f*fdd*r + 7020*D1**2*K*f*fdd*s**2 - 7740*D1**2*K*f*fdd*s + 4230*D1**2*K*f*fdd + 8460*D1**2*K*fd**2*r**2 + 15480*D1**2*K*fd**2*r*s - 8460*D1**2*K*fd**2*r + 7020*D1**2*K*fd**2*s**2 - 7740*D1**2*K*fd**2*s - 462*D1**2*b2*fd*r**2 - 924*D1**2*b2*fd*r*s - 462*D1**2*b2*fd*s**2 + 756*D1**2*b2*fdd*r**2 + 1512*D1**2*b2*fdd*r*s + 756*D1**2*b2*fdd*s**2 + 252*D1**2*bd1**2*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 3006*D1**2*bdd1*f**2*r**2 - 7524*D1**2*bdd1*f**2*r*s + 7128*D1**2*bdd1*f**2*r - 4518*D1**2*bdd1*f**2*s**2 + 8640*D1**2*bdd1*f**2*s - 3942*D1**2*bdd1*f**2 - 4158*D1**2*bdd1*f*r**2 - 9828*D1**2*bdd1*f*r*s + 9828*D1**2*bdd1*f*r - 5670*D1**2*bdd1*f*s**2 + 11340*D1**2*bdd1*f*s - 5292*D1**2*bdd1*f + 5040*D1**2*bdd1*g2*r**2 + 10080*D1**2*bdd1*g2*r*s - 5040*D1**2*bdd1*g2*r + 5040*D1**2*bdd1*g2*s**2 - 5040*D1**2*bdd1*g2*s + 2520*D1**2*bdd1*g2 + 756*D1**2*bdd2*f*r**2 + 1512*D1**2*bdd2*f*r*s - 1512*D1**2*bdd2*f*r + 756*D1**2*bdd2*f*s**2 - 1512*D1**2*bdd2*f*s + 756*D1**2*bdd2*f + 3090*D1**2*f**2*fd*r**2 + 4650*D1**2*f**2*fd*r*s - 2980*D1**2*f**2*fd*r + 1560*D1**2*f**2*fd*s**2 - 1960*D1**2*f**2*fd*s + 870*D1**2*f**2*fd - 3570*D1**2*f**2*fdd*r**2 - 5970*D1**2*f**2*fdd*r*s + 3740*D1**2*f**2*fdd*r - 2400*D1**2*f**2*fdd*s**2 + 2960*D1**2*f**2*fdd*s - 1290*D1**2*f**2*fdd - 7140*D1**2*f*fd**2*r**2 - 11940*D1**2*f*fd**2*r*s + 7480*D1**2*f*fd**2*r - 4800*D1**2*f*fd**2*s**2 + 5920*D1**2*f*fd**2*s - 1500*D1**2*f*fd**2 + 2538*D1**2*f*fd*r**2 + 5076*D1**2*f*fd*r*s - 3168*D1**2*f*fd*r + 2538*D1**2*f*fd*s**2 - 3168*D1**2*f*fd*s + 1773*D1**2*f*fd - 3726*D1**2*f*fdd*r**2 - 7956*D1**2*f*fdd*r*s + 3726*D1**2*f*fdd*r - 4230*D1**2*f*fdd*s**2 + 3978*D1**2*f*fdd*s - 1863*D1**2*f*fdd + 5628*D1**2*f*gd2*r**2 + 10416*D1**2*f*gd2*r*s - 10416*D1**2*f*gd2*r + 4788*D1**2*f*gd2*s**2 - 9576*D1**2*f*gd2*s + 4788*D1**2*f*gd2 - 9324*D1**2*f*gdd2*r**2 - 18648*D1**2*f*gdd2*r*s + 18648*D1**2*f*gdd2*r - 9324*D1**2*f*gdd2*s**2 + 18648*D1**2*f*gdd2*s - 9324*D1**2*f*gdd2 - 3726*D1**2*fd**2*r**2 - 7956*D1**2*fd**2*r*s + 3726*D1**2*fd**2*r - 4230*D1**2*fd**2*s**2 + 3978*D1**2*fd**2*s + 5628*D1**2*fd*g2*r**2 + 10416*D1**2*fd*g2*r*s + 1848*D1**2*fd*g2*r + 4788*D1**2*fd*g2*s**2 + 1848*D1**2*fd*g2*s - 924*D1**2*fd*g2 - 18648*D1**2*fd*gd2*r**2 - 37296*D1**2*fd*gd2*r*s + 15624*D1**2*fd*gd2*r - 18648*D1**2*fd*gd2*s**2 + 15624*D1**2*fd*gd2*s + 3024*D1**2*fd*gd2 - 9324*D1**2*fdd*g2*r**2 - 18648*D1**2*fdd*g2*r*s - 3024*D1**2*fdd*g2*r - 9324*D1**2*fdd*g2*s**2 - 3024*D1**2*fdd*g2*s + 1512*D1**2*fdd*g2 - 15696*D1*Dd*K*f**2*r**2 - 24624*D1*Dd*K*f**2*r*s + 20160*D1*Dd*K*f**2*r - 8928*D1*Dd*K*f**2*s**2 + 15084*D1*Dd*K*f**2*s - 8388*D1*Dd*K*f**2 + 67680*D1*Dd*K*f*fd*r**2 + 123840*D1*Dd*K*f*fd*r*s - 81720*D1*Dd*K*f*fd*r + 56160*D1*Dd*K*f*fd*s**2 - 74520*D1*Dd*K*f*fd*s + 23940*D1*Dd*K*f*fd - 1848*D1*Dd*b2*f*r**2 - 3696*D1*Dd*b2*f*r*s + 2772*D1*Dd*b2*f*r - 1848*D1*Dd*b2*f*s**2 + 2772*D1*Dd*b2*f*s - 1386*D1*Dd*b2*f + 6048*D1*Dd*b2*fd*r**2 + 12096*D1*Dd*b2*fd*r*s - 4536*D1*Dd*b2*fd*r + 6048*D1*Dd*b2*fd*s**2 - 4536*D1*Dd*b2*fd*s + 4120*D1*Dd*f**3*r**2 + 6200*D1*Dd*f**3*r*s - 5160*D1*Dd*f**3*r + 2080*D1*Dd*f**3*s**2 - 3630*D1*Dd*f**3*s + 2070*D1*Dd*f**3 - 28560*D1*Dd*f**2*fd*r**2 - 47760*D1*Dd*f**2*fd*r*s + 34040*D1*Dd*f**2*fd*r - 19200*D1*Dd*f**2*fd*s**2 + 27410*D1*Dd*f**2*fd*s - 9660*D1*Dd*f**2*fd + 5076*D1*Dd*f**2*r**2 + 10152*D1*Dd*f**2*r*s - 7614*D1*Dd*f**2*r + 5076*D1*Dd*f**2*s**2 - 7614*D1*Dd*f**2*s + 3807*D1*Dd*f**2 - 29808*D1*Dd*f*fd*r**2 - 63648*D1*Dd*f*fd*r*s + 38268*D1*Dd*f*fd*r - 33840*D1*Dd*f*fd*s**2 + 40788*D1*Dd*f*fd*s - 11682*D1*Dd*f*fd + 22512*D1*Dd*f*g2*r**2 + 41664*D1*Dd*f*g2*r*s - 32088*D1*Dd*f*g2*r + 19152*D1*Dd*f*g2*s**2 - 29568*D1*Dd*f*g2*s + 15204*D1*Dd*f*g2 - 74592*D1*Dd*f*gd2*r**2 - 149184*D1*Dd*f*gd2*r*s + 130536*D1*Dd*f*gd2*r - 74592*D1*Dd*f*gd2*s**2 + 130536*D1*Dd*f*gd2*s - 55944*D1*Dd*f*gd2 - 74592*D1*Dd*fd*g2*r**2 - 149184*D1*Dd*fd*g2*r*s + 43848*D1*Dd*fd*g2*r - 74592*D1*Dd*fd*g2*s**2 + 43848*D1*Dd*fd*g2*s + 9072*D1*Dd*fd*g2 + 16920*D1*Ddd*K*f**2*r**2 + 30960*D1*Ddd*K*f**2*r*s - 23940*D1*Ddd*K*f**2*r + 14040*D1*Ddd*K*f**2*s**2 - 21780*D1*Ddd*K*f**2*s + 11250*D1*Ddd*K*f**2 + 3024*D1*Ddd*b2*f*r**2 + 6048*D1*Ddd*b2*f*r*s - 4536*D1*Ddd*b2*f*r + 3024*D1*Ddd*b2*f*s**2 - 4536*D1*Ddd*b2*f*s + 2268*D1*Ddd*b2*f - 4760*D1*Ddd*f**3*r**2 - 7960*D1*Ddd*f**3*r*s + 6360*D1*Ddd*f**3*r - 3200*D1*Ddd*f**3*s**2 + 5190*D1*Ddd*f**3*s - 2790*D1*Ddd*f**3 - 7452*D1*Ddd*f**2*r**2 - 15912*D1*Ddd*f**2*r*s + 11682*D1*Ddd*f**2*r - 8460*D1*Ddd*f**2*s**2 + 12438*D1*Ddd*f**2*s - 6093*D1*Ddd*f**2 - 37296*D1*Ddd*f*g2*r**2 - 74592*D1*Ddd*f*g2*r*s + 55944*D1*Ddd*f*g2*r - 37296*D1*Ddd*f*g2*s**2 + 55944*D1*Ddd*f*g2*s - 27972*D1*Ddd*f*g2 + 6*D1*bd1*(9*D1*f**2*(39*r**2 + 2*r*(53*s - 48) + 67*s**2 - 124*s + 55) - D1*f*(70*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(134*r**2 + 8*r*(31*s - 35) + 114*s**2 - 260*s + 135) + 6*fd*(334*r**2 + r*(836*s - 585) + 502*s**2 - 711*s + 230) - 511*r**2 - 1036*r*s + 1001*r - 525*s**2 + 1015*s - 504) + 42*D1*(fd*(2*K*(37*r**2 + 74*r*s - 34*r + 37*s**2 - 34*s - 3) - 33*r**2 - 78*r*s + 33*r - 45*s**2 + 39*s + 3) + 5*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f**2*(668*r**2 + r*(1672*s - 1377) + 1004*s**2 - 1671*s + 678) + 42*Dd*f*(K*(296*r**2 + r*(592*s - 542) + 296*s**2 - 542*s + 240) - 132*r**2 - 3*r*(104*s - 89) - 180*s**2 + 309*s - 129) + 840*Dd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 42*D1*bd2*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) + 50760*Dd**2*K*f**2*r**2 + 92880*Dd**2*K*f**2*r*s - 71820*Dd**2*K*f**2*r + 42120*Dd**2*K*f**2*s**2 - 65340*Dd**2*K*f**2*s + 22500*Dd**2*K*f**2 + 9072*Dd**2*b2*f*r**2 + 18144*Dd**2*b2*f*r*s - 13608*Dd**2*b2*f*r + 9072*Dd**2*b2*f*s**2 - 13608*Dd**2*b2*f*s + 4536*Dd**2*b2*f - 14280*Dd**2*f**3*r**2 - 23880*Dd**2*f**3*r*s + 19080*Dd**2*f**3*r - 9600*Dd**2*f**3*s**2 + 15570*Dd**2*f**3*s - 5580*Dd**2*f**3 - 22356*Dd**2*f**2*r**2 - 47736*Dd**2*f**2*r*s + 35046*Dd**2*f**2*r - 25380*Dd**2*f**2*s**2 + 37314*Dd**2*f**2*s - 12186*Dd**2*f**2 - 111888*Dd**2*f*g2*r**2 - 223776*Dd**2*f*g2*r*s + 167832*Dd**2*f*g2*r - 111888*Dd**2*f*g2*s**2 + 167832*Dd**2*f*g2*s - 55944*Dd**2*f*g2) + 66*b2*(-126*D1**2*bdd1*f*(r + s - 1)**2 + 15*D1**2*(f*(5*fd - 6*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 7*D1*bd1*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) + 15*D1*f*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 540*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(3465*d**2*k3**6) - D1**2*Pk1*Pk3*ct**2*k1**2*st**4*(288*C - 188)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(105*d**2*k3**4) - 2*D1**2*Pk1*Pk3*ct**2*k1**2*st**2*(14*b1**2*(D1**2*(s - 1)*(fd*(28*C - 15) + fdd*(15 - 24*C))*(r + s - 1) + D1*(Dd*(f*(28*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(24*C - 15)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(15 - 24*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(24*C - 15)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(D1**2*(f*(-42*bdd1*s*(8*C - 5)*(2*r + 2*s - 1) + fd*(C*(-632*r*(2*s - 1) - 2926*s**2 + 2694*s - 1463) + 394*r*(2*s - 1) + 1994*s**2 - 1856*s + 997) + fdd*(C*(624*r*(2*s - 1) + 2506*s**2 - 2362*s + 1253) - 744*r*s + 372*r - 1690*s**2 + 1600*s - 845)) + 2*fd**2*(C*(312*r*(2*s - 1) + 1253*s**2 - 1181*s - 72) - 186*r*(2*s - 1) - 845*s**2 + 800*s + 45)) + 14*D1*bd1*(D1*(f*s*(28*C - 15)*(2*r + 2*s - 1) - fd*(24*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(30 - 48*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(C*(632*r*(2*s - 1) + 2926*s**2 - 3242*s + 1463) - 788*r*s + 394*r - 1994*s**2 + 2191*s - 997) - 2*fd*(2*s - 1)*(C*(1248*r + 2506*s - 1337) - 744*r - 1690*s + 893)) + Ddd*f*(C*(-624*r*(2*s - 1) - 2506*s**2 + 2818*s - 1253) + 372*r*(2*s - 1) + 1690*s**2 - 1876*s + 845)) + 2*Dd**2*f**2*(C*(1872*r*(2*s - 1) + 7518*s**2 - 8454*s + 1877) - 1116*r*(2*s - 1) - 5070*s**2 + 5628*s - 1217)) + f*(-42*D1**2*bd1**2*s*(8*C - 5)*(2*r + 2*s - 1) + D1**2*(f*(bdd1*s*(C*(624*r + 1253*s - 768) - 372*r - 845*s + 462) + fd*(C*(-552*r*(3*s - 1) - 2481*s**2 + 2206*s - 827) + 332*r*(3*s - 1) + 1665*s**2 - 1442*s + 555) + fdd*(C*(480*r*(3*s - 1) + 1947*s**2 - 1778*s + 649) - 286*r*(3*s - 1) - 1305*s**2 + 1156*s - 435)) + 2*fd**2*(C*(480*r*(3*s - 1) + 1947*s**2 - 1778*s + 240) - 286*r*(3*s - 1) - 1305*s**2 + 1156*s - 143)) + D1*bd1*(D1*(f*s*(C*(-632*r - 1463*s + 864) + 394*r + 997*s - 532) + 2*fd*(C*(312*r*(4*s - 1) + 2506*s**2 - 1949*s + 384) - 744*r*s + 186*r - 1690*s**2 + 1262*s - 231)) + 4*Dd*f*(C*(312*r*(4*s - 1) + 2506*s**2 - 2177*s + 384) - 744*r*s + 186*r - 1690*s**2 + 1400*s - 231)) - 2*D1*f*(Dd*(f*(C*(552*r*(2*s - 1) + 1654*s**2 - 1930*s + 827) - 332*r*(2*s - 1) - 1110*s**2 + 1276*s - 555) + fd*(C*(-480*r*(12*s - 5) - 7788*s**2 + 8170*s - 2018) + 286*r*(12*s - 5) + 5220*s**2 - 5351*s + 1299)) + Ddd*f*(C*(-480*r*(2*s - 1) - 1298*s**2 + 1538*s - 649) + 286*r*(2*s - 1) + 870*s**2 - 1013*s + 435)) + 2*Dd**2*f**2*(C*(1440*r*(2*s - 1) + 3894*s**2 - 4614*s + 1129) - 858*r*(2*s - 1) - 2610*s**2 + 3039*s - 721)))/(105*d**2*k3**4) - D1**2*Pk1*Pk3*ct**2*k1**2*(21*b1**2*(D1**2*(fd*(2*C*(r - 79*s + 79) - r + 101*s - 101) + fdd*(34*C*r + 154*C*(s - 1) - 17*r - 103*s + 103))*(r + s - 1) + D1*(Dd*(f*(C*(8*r**2 - 624*r*s + 308*r - 632*s**2 + 788*s - 314) - 4*r**2 + 400*r*s - 198*r + 404*s**2 - 504*s + 201) + 2*fd*(2*C*(68*r**2 + 376*r*s - 299*r + 308*s**2 - 509*s + 201) - 68*r**2 - 480*r*s + 377*r - 412*s**2 + 678*s - 266)) + Ddd*f*(2*C*(68*r**2 + 376*r*s - 222*r + 308*s**2 - 402*s + 171) - 68*r**2 - 480*r*s + 274*r - 412*s**2 + 532*s - 223)) + 2*Dd**2*f*(6*C*(34*r**2 + r*(188*s - 111) + 154*s**2 - 201*s + 57) - 102*r**2 + r*(411 - 720*s) - 618*s**2 + 798*s - 223)) + 3*b1*(392*C*D1**2*f*fd*r**2 + 4000*C*D1**2*f*fd*r*s - 1748*C*D1**2*f*fd*r + 4232*C*D1**2*f*fd*s**2 - 3404*C*D1**2*f*fd*s + 1990*C*D1**2*f*fd - 560*C*D1**2*f*fdd*r**2 - 3904*C*D1**2*f*fdd*r*s + 1532*C*D1**2*f*fdd*r - 4160*C*D1**2*f*fdd*s**2 + 3284*C*D1**2*f*fdd*s - 1870*C*D1**2*f*fdd - 560*C*D1**2*fd**2*r**2 - 3904*C*D1**2*fd**2*r*s + 1532*C*D1**2*fd**2*r - 4160*C*D1**2*fd**2*s**2 + 3284*C*D1**2*fd**2*s + 876*C*D1**2*fd**2 + 784*C*D1*Dd*f**2*r**2 + 8000*C*D1*Dd*f**2*r*s - 4392*C*D1*Dd*f**2*r + 8464*C*D1*Dd*f**2*s**2 - 10464*C*D1*Dd*f**2*s + 4428*C*D1*Dd*f**2 - 4480*C*D1*Dd*f*fd*r**2 - 31232*C*D1*Dd*f*fd*r*s + 15056*C*D1*Dd*f*fd*r - 33280*C*D1*Dd*f*fd*s**2 + 33680*C*D1*Dd*f*fd*s - 8100*C*D1*Dd*f*fd - 1120*C*D1*Ddd*f**2*r**2 - 7808*C*D1*Ddd*f**2*r*s + 4464*C*D1*Ddd*f**2*r - 8320*C*D1*Ddd*f**2*s**2 + 10272*C*D1*Ddd*f**2*s - 4440*C*D1*Ddd*f**2 - 3360*C*Dd**2*f**2*r**2 - 23424*C*Dd**2*f**2*r*s + 13392*C*Dd**2*f**2*r - 24960*C*Dd**2*f**2*s**2 + 30816*C*Dd**2*f**2*s - 8064*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(2*C*(34*r**2 + 188*r*s - 34*r + 154*s**2 - 94*s + 17) - 34*r**2 - 240*r*s + 34*r - 206*s**2 + 120*s - 17) - 196*D1**2*f*fd*r**2 - 2490*D1**2*f*fd*r*s + 1119*D1**2*f*fd*r - 3044*D1**2*f*fd*s**2 + 2528*D1**2*f*fd*s - 1459*D1**2*f*fd + 280*D1**2*f*fdd*r**2 + 2442*D1**2*f*fdd*r*s - 1011*D1**2*f*fdd*r + 3020*D1**2*f*fdd*s**2 - 2468*D1**2*f*fdd*s + 1405*D1**2*f*fdd + 280*D1**2*fd**2*r**2 + 2442*D1**2*fd**2*r*s - 1011*D1**2*fd**2*r + 3020*D1**2*fd**2*s**2 - 2468*D1**2*fd**2*s - 552*D1**2*fd**2 - 392*D1*Dd*f**2*r**2 - 4980*D1*Dd*f**2*r*s + 2686*D1*Dd*f**2*r - 6088*D1*Dd*f**2*s**2 + 7333*D1*Dd*f**2*s - 3142*D1*Dd*f**2 + 2240*D1*Dd*f*fd*r**2 + 19536*D1*Dd*f*fd*r*s - 9488*D1*Dd*f*fd*r + 24160*D1*Dd*f*fd*s**2 - 24394*D1*Dd*f*fd*s + 5947*D1*Dd*f*fd + 560*D1*Ddd*f**2*r**2 + 4884*D1*Ddd*f**2*r*s - 2722*D1*Ddd*f**2*r + 6040*D1*Ddd*f**2*s**2 - 7261*D1*Ddd*f**2*s + 3160*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(2*C*(2*r**2 - 2*r*(78*s + 1) - 158*s**2 + 78*s + 1) - 2*r**2 + 200*r*s + 2*r + 202*s**2 - 100*s - 1) + 2*fd*(C*(68*r**2 + 376*r*s - 222*r + 308*s**2 - 402*s + 94) - 34*r**2 - 240*r*s + 137*r - 206*s**2 + 266*s - 60)) + 2*Dd*f*(2*C*(136*r**2 + 752*r*s - 290*r + 616*s**2 - 590*s + 111) - 136*r**2 - 960*r*s + 342*r - 824*s**2 + 772*s - 137)) + 1680*Dd**2*f**2*r**2 + 14652*Dd**2*f**2*r*s - 8166*Dd**2*f**2*r + 18120*Dd**2*f**2*s**2 - 21783*Dd**2*f**2*s + 5462*Dd**2*f**2) + f*(3558*C*D1**2*f*fd*r**2 + 20292*C*D1**2*f*fd*r*s - 9136*C*D1**2*f*fd*r + 16782*C*D1**2*f*fd*s**2 - 17952*C*D1**2*f*fd*s + 6780*C*D1**2*f*fd - 3858*C*D1**2*f*fdd*r**2 - 19812*C*D1**2*f*fdd*r*s + 9176*C*D1**2*f*fdd*r - 16302*C*D1**2*f*fdd*s**2 + 17472*C*D1**2*f*fdd*s - 6720*C*D1**2*f*fdd - 7716*C*D1**2*fd**2*r**2 - 39624*C*D1**2*fd**2*r*s + 18352*C*D1**2*fd**2*r - 32604*C*D1**2*fd**2*s**2 + 34944*C*D1**2*fd**2*s - 6604*C*D1**2*fd**2 + 4744*C*D1*Dd*f**2*r**2 + 27056*C*D1*Dd*f**2*r*s - 15900*C*D1*Dd*f**2*r + 22376*C*D1*Dd*f**2*s**2 - 29140*C*D1*Dd*f**2*s + 12374*C*D1*Dd*f**2 - 30864*C*D1*Dd*f*fd*r**2 - 158496*C*D1*Dd*f*fd*r*s + 84044*C*D1*Dd*f*fd*r - 130416*C*D1*Dd*f*fd*s**2 + 154908*C*D1*Dd*f*fd*s - 44120*C*D1*Dd*f*fd - 5144*C*D1*Ddd*f**2*r**2 - 26416*C*D1*Ddd*f**2*r*s + 15780*C*D1*Ddd*f**2*r - 21736*C*D1*Ddd*f**2*s**2 + 28340*C*D1*Ddd*f**2*s - 12154*C*D1*Ddd*f**2 - 15432*C*Dd**2*f**2*r**2 - 79248*C*Dd**2*f**2*r*s + 47340*C*Dd**2*f**2*r - 65208*C*Dd**2*f**2*s**2 + 85020*C*Dd**2*f**2*s - 24076*C*Dd**2*f**2 + 42*D1**2*bd1**2*(r**2*(34*C - 17) + r*(188*C*s - 34*C - 120*s + 17) + s*(154*C*s - 94*C - 103*s + 60)) - 3*D1**2*bdd1*f*(2*C*(140*r**2 + 976*r*s - 490*r + 1040*s**2 - 1414*s + 245) - 140*r**2 - 1221*r*s + 490*r - 1510*s**2 + 1773*s - 245) - 1779*D1**2*f*fd*r**2 - 12603*D1**2*f*fd*r*s + 5387*D1**2*f*fd*r - 11829*D1**2*f*fd*s**2 + 12087*D1**2*f*fd*s - 4536*D1**2*f*fd + 1929*D1**2*f*fdd*r**2 + 12363*D1**2*f*fdd*r*s - 5407*D1**2*f*fdd*r + 11679*D1**2*f*fdd*s**2 - 11907*D1**2*f*fdd*s + 4536*D1**2*f*fdd + 3858*D1**2*fd**2*r**2 + 24726*D1**2*fd**2*r*s - 10814*D1**2*fd**2*r + 23358*D1**2*fd**2*s**2 - 23814*D1**2*fd**2*s + 4121*D1**2*fd**2 - 2372*D1*Dd*f**2*r**2 - 16804*D1*Dd*f**2*r*s + 9588*D1*Dd*f**2*r - 15772*D1*Dd*f**2*s**2 + 19973*D1*Dd*f**2*s - 8479*D1*Dd*f**2 + 15432*D1*Dd*f*fd*r**2 + 98904*D1*Dd*f*fd*r*s - 50212*D1*Dd*f*fd*r + 93432*D1*Dd*f*fd*s**2 - 106707*D1*Dd*f*fd*s + 29221*D1*Dd*f*fd + 2572*D1*Ddd*f**2*r**2 + 16484*D1*Ddd*f**2*r*s - 9528*D1*Ddd*f**2*r + 15572*D1*Ddd*f**2*s**2 - 19693*D1*Ddd*f**2*s + 8429*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(2*C*(98*r**2 + 1000*r*s - 322*r + 1058*s**2 - 1414*s + 161) - 98*r**2 - 1245*r*s + 322*r - 1522*s**2 + 1761*s - 161) + fd*(-4*C*(280*r**2 + 1952*r*s - 873*r + 2080*s**2 - 2235*s + 707) + 560*r**2 + 4884*r*s - 1991*r + 6040*s**2 - 6014*s + 1773)) + Dd*f*(-4*C*(560*r**2 + 3904*r*s - 2096*r + 4160*s**2 - 5396*s + 1659) + 1120*r**2 + 9768*r*s - 4682*r + 12080*s**2 - 14353*s + 4036)) + 7716*Dd**2*f**2*r**2 + 49452*Dd**2*f**2*r*s - 28584*Dd**2*f**2*r + 46716*Dd**2*f**2*s**2 - 59079*Dd**2*f**2*s + 16028*Dd**2*f**2))/(315*d**2*k3**4) - D1**2*Pk1*Pk3*ct**2*k1**2*st**2*(16*C - 8)*(42*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s))) + 21*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(-5*f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*s*(-21*bd1**2*s + 5*fd**2*(3*s - 2))) - 10*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) + 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(105*d**2*k2**2*k3**2) + D1**2*Pk1*Pk3*ct**2*k1**2*(2*C - 1)*(14*D1*b1*s*(-5*D1*bdd1*f*s + bd1*(7*D1*f*s - 10*D1*fd*(s - 1) + 20*Dd*f*(1 - 2*s))) + 7*b1**2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + 2*D1*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(2*s**2 - 3*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(-3*f*(7*fd - 5*fdd)*(3*s**2 - 2*s + 1) + 10*s*(-7*bd1**2*s + fd**2*(9*s - 6))) - 6*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(6*s**2 - 5*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) + 30*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k2**2*k3**2) - D1**2*Pk1*Pk3*ct**2*k2**6*st**6*(8*C - 8)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(21*d**2*k3**8) + 4*D1**2*Pk1*Pk3*ct**2*k2**6*st**4*(198*C*D1**2*f**2*fd*r**2 + 396*C*D1**2*f**2*fd*r*s - 264*C*D1**2*f**2*fd*r + 198*C*D1**2*f**2*fd*s**2 - 264*C*D1**2*f**2*fd*s + 132*C*D1**2*f**2*fd + 264*C*D1*Dd*f**3*r**2 + 528*C*D1*Dd*f**3*r*s - 396*C*D1*Dd*f**3*r + 264*C*D1*Dd*f**3*s**2 - 396*C*D1*Dd*f**3*s + 198*C*D1*Dd*f**3 + 33*D1**2*K*bdd1*f**2*r**2 + 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*r + 33*D1**2*K*bdd1*f**2*s**2 - 66*D1**2*K*bdd1*f**2*s + 33*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(-7*K + 15*f + 7)*(r + s - 1)**2 + 660*D1**2*bdd1*f**3*r**2 + 1320*D1**2*bdd1*f**3*r*s - 1320*D1**2*bdd1*f**3*r + 660*D1**2*bdd1*f**3*s**2 - 1320*D1**2*bdd1*f**3*s + 660*D1**2*bdd1*f**3 - 33*D1**2*bdd1*f**2*r**2 - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r - 33*D1**2*bdd1*f**2*s**2 + 66*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 - 462*D1**2*bdd1*f*g2*r**2 - 924*D1**2*bdd1*f*g2*r*s + 924*D1**2*bdd1*f*g2*r - 462*D1**2*bdd1*f*g2*s**2 + 924*D1**2*bdd1*f*g2*s - 462*D1**2*bdd1*f*g2 - 2560*D1**2*f**3*fd*r**2 - 5120*D1**2*f**3*fd*r*s + 3840*D1**2*f**3*fd*r - 2560*D1**2*f**3*fd*s**2 + 3840*D1**2*f**3*fd*s - 1920*D1**2*f**3*fd + 1500*D1**2*f**3*fdd*r**2 + 3000*D1**2*f**3*fdd*r*s - 2250*D1**2*f**3*fdd*r + 1500*D1**2*f**3*fdd*s**2 - 2250*D1**2*f**3*fdd*s + 1125*D1**2*f**3*fdd + 4500*D1**2*f**2*fd**2*r**2 + 9000*D1**2*f**2*fd**2*r*s - 6750*D1**2*f**2*fd**2*r + 4500*D1**2*f**2*fd**2*s**2 - 6750*D1**2*f**2*fd**2*s + 2250*D1**2*f**2*fd**2 - 198*D1**2*f**2*fd*r**2 - 396*D1**2*f**2*fd*r*s + 264*D1**2*f**2*fd*r - 198*D1**2*f**2*fd*s**2 + 264*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 132*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*r + 132*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gd2 - 66*D1**2*f**2*gdd2*r**2 - 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*r - 66*D1**2*f**2*gdd2*s**2 + 132*D1**2*f**2*gdd2*s - 66*D1**2*f**2*gdd2 + 264*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 264*D1**2*f*fd*gd2*r**2 - 528*D1**2*f*fd*gd2*r*s + 396*D1**2*f*fd*gd2*r - 264*D1**2*f*fd*gd2*s**2 + 396*D1**2*f*fd*gd2*s - 132*D1**2*f*fd*gd2 - 132*D1**2*f*fdd*g2*r**2 - 264*D1**2*f*fdd*g2*r*s + 132*D1**2*f*fdd*g2*r - 132*D1**2*f*fdd*g2*s**2 + 132*D1**2*f*fdd*g2*s - 66*D1**2*f*fdd*g2 - 132*D1**2*fd**2*g2*r**2 - 264*D1**2*fd**2*g2*r*s + 132*D1**2*fd**2*g2*r - 132*D1**2*fd**2*g2*s**2 + 132*D1**2*fd**2*g2*s - 2560*D1*Dd*f**4*r**2 - 5120*D1*Dd*f**4*r*s + 3840*D1*Dd*f**4*r - 2560*D1*Dd*f**4*s**2 + 3840*D1*Dd*f**4*s - 1920*D1*Dd*f**4 + 12000*D1*Dd*f**3*fd*r**2 + 24000*D1*Dd*f**3*fd*r*s - 18000*D1*Dd*f**3*fd*r + 12000*D1*Dd*f**3*fd*s**2 - 18000*D1*Dd*f**3*fd*s + 6750*D1*Dd*f**3*fd - 264*D1*Dd*f**3*r**2 - 528*D1*Dd*f**3*r*s + 396*D1*Dd*f**3*r - 264*D1*Dd*f**3*s**2 + 396*D1*Dd*f**3*s - 198*D1*Dd*f**3 + 528*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 396*D1*Dd*f**2*g2 - 528*D1*Dd*f**2*gd2*r**2 - 1056*D1*Dd*f**2*gd2*r*s + 924*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s**2 + 924*D1*Dd*f**2*gd2*s - 396*D1*Dd*f**2*gd2 - 1056*D1*Dd*f*fd*g2*r**2 - 2112*D1*Dd*f*fd*g2*r*s + 1320*D1*Dd*f*fd*g2*r - 1056*D1*Dd*f*fd*g2*s**2 + 1320*D1*Dd*f*fd*g2*s - 396*D1*Dd*f*fd*g2 + 1500*D1*Ddd*f**4*r**2 + 3000*D1*Ddd*f**4*r*s - 2250*D1*Ddd*f**4*r + 1500*D1*Ddd*f**4*s**2 - 2250*D1*Ddd*f**4*s + 1125*D1*Ddd*f**4 - 264*D1*Ddd*f**2*g2*r**2 - 528*D1*Ddd*f**2*g2*r*s + 396*D1*Ddd*f**2*g2*r - 264*D1*Ddd*f**2*g2*s**2 + 396*D1*Ddd*f**2*g2*s - 198*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(15*f**3*(r + s - 1) + f**2*(-7*C*(r + s - 1) - 20*fd*(3*r + 3*s - 2) + (K + 6)*(r + s - 1)) + f*(-fd*(K - 1)*(2*r + 2*s - 1) + (-14*g2 + 14*gd2)*(r + s - 1)) + 14*fd*g2*(r + s)) - Dd*f*(20*f**2 + f*(K - 1) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) + 4500*Dd**2*f**4*r**2 + 9000*Dd**2*f**4*r*s - 6750*Dd**2*f**4*r + 4500*Dd**2*f**4*s**2 - 6750*Dd**2*f**4*s + 2250*Dd**2*f**4 - 792*Dd**2*f**2*g2*r**2 - 1584*Dd**2*f**2*g2*r*s + 1188*Dd**2*f**2*g2*r - 792*Dd**2*f**2*g2*s**2 + 1188*Dd**2*f**2*g2*s - 396*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(15*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(30*fd**2*(r + s - 1) + 14*fd*(K - 1)*(r + s) - 7*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(15*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(15*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (7*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-7*K + 15*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-7*K + 15*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(28*C*D1**2*f*fd*r**2 + 56*C*D1**2*f*fd*r*s - 28*C*D1**2*f*fd*r + 28*C*D1**2*f*fd*s**2 - 28*C*D1**2*f*fd*s + 14*C*D1**2*f*fd + 56*C*D1*Dd*f**2*r**2 + 112*C*D1*Dd*f**2*r*s - 84*C*D1*Dd*f**2*r + 56*C*D1*Dd*f**2*s**2 - 84*C*D1*Dd*f**2*s + 42*C*D1*Dd*f**2 - 4*D1**2*K*f*fd*r**2 - 8*D1**2*K*f*fd*r*s + 4*D1**2*K*f*fd*r - 4*D1**2*K*f*fd*s**2 + 4*D1**2*K*f*fd*s - 2*D1**2*K*f*fd + 2*D1**2*K*f*fdd*r**2 + 4*D1**2*K*f*fdd*r*s - 2*D1**2*K*f*fdd*r + 2*D1**2*K*f*fdd*s**2 - 2*D1**2*K*f*fdd*s + D1**2*K*f*fdd + 2*D1**2*K*fd**2*r**2 + 4*D1**2*K*fd**2*r*s - 2*D1**2*K*fd**2*r + 2*D1**2*K*fd**2*s**2 - 2*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-7*K + 15*f + 7)*(r + s - 1)**2 - 90*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 120*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 80*D1**2*f**2*fdd*s + 40*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 240*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 160*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 24*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 24*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd + 28*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r + 28*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s + 28*D1**2*f*gd2 - 14*D1**2*f*gdd2*r**2 - 28*D1**2*f*gdd2*r*s + 28*D1**2*f*gdd2*r - 14*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 14*D1**2*f*gdd2 - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s + 28*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*s**2 - 28*D1**2*fd*gd2*r**2 - 56*D1**2*fd*gd2*r*s + 28*D1**2*fd*gd2*r - 28*D1**2*fd*gd2*s**2 + 28*D1**2*fd*gd2*s - 14*D1**2*fdd*g2*r**2 - 28*D1**2*fdd*g2*r*s - 14*D1**2*fdd*g2*s**2 - 8*D1*Dd*K*f**2*r**2 - 16*D1*Dd*K*f**2*r*s + 12*D1*Dd*K*f**2*r - 8*D1*Dd*K*f**2*s**2 + 12*D1*Dd*K*f**2*s - 6*D1*Dd*K*f**2 + 16*D1*Dd*K*f*fd*r**2 + 32*D1*Dd*K*f*fd*r*s - 20*D1*Dd*K*f*fd*r + 16*D1*Dd*K*f*fd*s**2 - 20*D1*Dd*K*f*fd*s + 6*D1*Dd*K*f*fd - 120*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 180*D1*Dd*f**3*s - 90*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 960*D1*Dd*f**2*fd*r*s - 680*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 680*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd - 48*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 72*D1*Dd*f**2*s - 36*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd*s - 6*D1*Dd*f*fd + 112*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 112*D1*Dd*f*g2*s**2 - 168*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*r**2 - 224*D1*Dd*f*gd2*r*s + 196*D1*Dd*f*gd2*r - 112*D1*Dd*f*gd2*s**2 + 196*D1*Dd*f*gd2*s - 84*D1*Dd*f*gd2 - 112*D1*Dd*fd*g2*r**2 - 224*D1*Dd*fd*g2*r*s + 84*D1*Dd*fd*g2*r - 112*D1*Dd*fd*g2*s**2 + 84*D1*Dd*fd*g2*s + 4*D1*Ddd*K*f**2*r**2 + 8*D1*Ddd*K*f**2*r*s - 6*D1*Ddd*K*f**2*r + 4*D1*Ddd*K*f**2*s**2 - 6*D1*Ddd*K*f**2*s + 3*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r**2 + 160*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 120*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 - 56*D1*Ddd*f*g2*r**2 - 112*D1*Ddd*f*g2*r*s + 84*D1*Ddd*f*g2*r - 56*D1*Ddd*f*g2*s**2 + 84*D1*Ddd*f*g2*s - 42*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(15*f**2*(r + s - 1) - 15*f*fd*(2*r + 2*s - 1) - 7*f*(K - 1)*(r + s - 1) + 7*fd*(K - 1)*(r + s)) - Dd*f*(-7*K + 15*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 12*Dd**2*K*f**2*r**2 + 24*Dd**2*K*f**2*r*s - 18*Dd**2*K*f**2*r + 12*Dd**2*K*f**2*s**2 - 18*Dd**2*K*f**2*s + 6*Dd**2*K*f**2 + 240*Dd**2*f**3*r**2 + 480*Dd**2*f**3*r*s - 360*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 360*Dd**2*f**3*s + 120*Dd**2*f**3 - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2 - 168*Dd**2*f*g2*r**2 - 336*Dd**2*f*g2*r*s + 252*Dd**2*f*g2*r - 168*Dd**2*f*g2*s**2 + 252*Dd**2*f*g2*s - 84*Dd**2*f*g2))/(385*d**2*k3**8) - D1**2*Pk1*Pk3*ct**2*k2**4*st**6*(16*C - 16)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(63*d**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**2*k2**4*st**4*(42*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-586*C*D1**2*f*fd*r**2 - 876*C*D1**2*f*fd*r*s + 430*C*D1**2*f*fd*r - 290*C*D1**2*f*fd*s**2 + 282*C*D1**2*f*fd*s - 141*C*D1**2*f*fd + 342*C*D1**2*f*fdd*r**2 + 564*C*D1**2*f*fdd*r*s - 278*C*D1**2*f*fdd*r + 222*C*D1**2*f*fdd*s**2 - 218*C*D1**2*f*fdd*s + 109*C*D1**2*f*fdd + 342*C*D1**2*fd**2*r**2 + 564*C*D1**2*fd**2*r*s - 278*C*D1**2*fd**2*r + 222*C*D1**2*fd**2*s**2 - 218*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 - 1172*C*D1*Dd*f**2*r**2 - 1752*C*D1*Dd*f**2*r*s + 1462*C*D1*Dd*f**2*r - 580*C*D1*Dd*f**2*s**2 + 1018*C*D1*Dd*f**2*s - 583*C*D1*Dd*f**2 + 2736*C*D1*Dd*f*fd*r**2 + 4512*C*D1*Dd*f*fd*r*s - 2924*C*D1*Dd*f*fd*r + 1776*C*D1*Dd*f*fd*s**2 - 2324*C*D1*Dd*f*fd*s + 714*C*D1*Dd*f*fd + 684*C*D1*Ddd*f**2*r**2 + 1128*C*D1*Ddd*f**2*r*s - 906*C*D1*Ddd*f**2*r + 444*C*D1*Ddd*f**2*s**2 - 726*C*D1*Ddd*f**2*s + 393*C*D1*Ddd*f**2 + 2052*C*Dd**2*f**2*r**2 + 3384*C*Dd**2*f**2*r*s - 2718*C*Dd**2*f**2*r + 1332*C*Dd**2*f**2*s**2 - 2178*C*Dd**2*f**2*s + 786*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 518*D1**2*f*fd*r**2 + 800*D1**2*f*fd*r*s - 392*D1**2*f*fd*r + 282*D1**2*f*fd*s**2 - 274*D1**2*f*fd*s + 137*D1**2*f*fd - 322*D1**2*f*fdd*r**2 - 554*D1**2*f*fdd*r*s + 273*D1**2*f*fdd*r - 232*D1**2*f*fdd*s**2 + 228*D1**2*f*fdd*s - 114*D1**2*f*fdd - 322*D1**2*fd**2*r**2 - 554*D1**2*fd**2*r*s + 273*D1**2*fd**2*r - 232*D1**2*fd**2*s**2 + 228*D1**2*fd**2*s + 4*D1**2*fd**2 + 1036*D1*Dd*f**2*r**2 + 1600*D1*Dd*f**2*r*s - 1318*D1*Dd*f**2*r + 564*D1*Dd*f**2*s**2 - 964*D1*Dd*f**2*s + 541*D1*Dd*f**2 - 2576*D1*Dd*f*fd*r**2 - 4432*D1*Dd*f*fd*r*s + 2844*D1*Dd*f*fd*r - 1856*D1*Dd*f*fd*s**2 + 2394*D1*Dd*f*fd*s - 729*D1*Dd*f*fd - 644*D1*Ddd*f**2*r**2 - 1108*D1*Ddd*f**2*r*s + 876*D1*Ddd*f**2*r - 464*D1*Ddd*f**2*s**2 + 741*D1*Ddd*f**2*s - 393*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 1932*Dd**2*f**2*r**2 - 3324*Dd**2*f**2*r*s + 2628*Dd**2*f**2*r - 1392*Dd**2*f**2*s**2 + 2223*Dd**2*f**2*s - 786*Dd**2*f**2) + f*(-1119*C*D1**2*f*fd*r**2 - 1482*C*D1**2*f*fd*r*s + 1240*C*D1**2*f*fd*r - 363*C*D1**2*f*fd*s**2 + 736*C*D1**2*f*fd*s - 494*C*D1**2*f*fd + 771*C*D1**2*f*fdd*r**2 + 1002*C*D1**2*f*fdd*r*s - 848*C*D1**2*f*fdd*r + 231*C*D1**2*f*fdd*s**2 - 488*C*D1**2*f*fdd*s + 334*C*D1**2*f*fdd + 1542*C*D1**2*fd**2*r**2 + 2004*C*D1**2*fd**2*r*s - 1696*C*D1**2*fd**2*r + 462*C*D1**2*fd**2*s**2 - 976*C*D1**2*fd**2*s + 334*C*D1**2*fd**2 - 1492*C*D1*Dd*f**2*r**2 - 1976*C*D1*Dd*f**2*r*s + 1734*C*D1*Dd*f**2*r - 484*C*D1*Dd*f**2*s**2 + 978*C*D1*Dd*f**2*s - 615*C*D1*Dd*f**2 + 6168*C*D1*Dd*f*fd*r**2 + 8016*C*D1*Dd*f*fd*r*s - 6938*C*D1*Dd*f*fd*r + 1848*C*D1*Dd*f*fd*s**2 - 3878*C*D1*Dd*f*fd*s + 1824*C*D1*Dd*f*fd + 1028*C*D1*Ddd*f**2*r**2 + 1336*C*D1*Ddd*f**2*r*s - 1182*C*D1*Ddd*f**2*r + 308*C*D1*Ddd*f**2*s**2 - 642*C*D1*Ddd*f**2*s + 411*C*D1*Ddd*f**2 + 3084*C*Dd**2*f**2*r**2 + 4008*C*Dd**2*f**2*r*s - 3546*C*Dd**2*f**2*r + 924*C*Dd**2*f**2*s**2 - 1926*C*Dd**2*f**2*s + 822*C*Dd**2*f**2 - 84*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*D1**2*bdd1*f*(C*(171*r**2 + r*(282*s - 346) + 111*s**2 - 286*s + 173) - 161*r**2 + r*(326 - 277*s) - 116*s**2 + 281*s - 163) + 993*D1**2*f*fd*r**2 + 1368*D1**2*f*fd*r*s - 1118*D1**2*f*fd*r + 375*D1**2*f*fd*s**2 - 706*D1**2*f*fd*s + 456*D1**2*f*fd - 681*D1**2*f*fdd*r**2 - 927*D1**2*f*fdd*r*s + 763*D1**2*f*fdd*r - 246*D1**2*f*fdd*s**2 + 473*D1**2*f*fdd*s - 309*D1**2*f*fdd - 1362*D1**2*fd**2*r**2 - 1854*D1**2*fd**2*r*s + 1526*D1**2*fd**2*r - 492*D1**2*fd**2*s**2 + 946*D1**2*fd**2*s - 309*D1**2*fd**2 + 1324*D1*Dd*f**2*r**2 + 1824*D1*Dd*f**2*r*s - 1574*D1*Dd*f**2*r + 500*D1*Dd*f**2*s**2 - 956*D1*Dd*f**2*s + 581*D1*Dd*f**2 - 5448*D1*Dd*f*fd*r**2 - 7416*D1*Dd*f*fd*r*s + 6268*D1*Dd*f*fd*r - 1968*D1*Dd*f*fd*s**2 + 3803*D1*Dd*f*fd*s - 1709*D1*Dd*f*fd - 908*D1*Ddd*f**2*r**2 - 1236*D1*Ddd*f**2*r*s + 1072*D1*Ddd*f**2*r - 328*D1*Ddd*f**2*s**2 + 637*D1*Ddd*f**2*s - 391*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(C*(293*r**2 + 6*r*(73*s - 99) + 145*s**2 - 446*s + 297) - 259*r**2 - 400*r*s + 526*r - 141*s**2 + 408*s - 263) + fd*(-2*C*(342*r**2 + 564*r*s - 485*r + 222*s**2 - 395*s + 143) + 644*r**2 + 1108*r*s - 925*r + 464*s**2 - 790*s + 281)) + Dd*f*(-2*C*(684*r**2 + r*(1128*s - 1145) + 444*s**2 - 935*s + 459) + 1288*r**2 + 4*r*(554*s - 545) + 928*s**2 - 1865*s + 888)) - 2724*Dd**2*f**2*r**2 - 3708*Dd**2*f**2*r*s + 3216*Dd**2*f**2*r - 984*Dd**2*f**2*s**2 + 1911*Dd**2*f**2*s - 782*Dd**2*f**2))/(105*d**2*k3**6) + 2*D1**2*Pk1*Pk3*ct**2*k2**4*st**2*(-8932*C*D1**2*bd1*f**2*r**2 - 10472*C*D1**2*bd1*f**2*r*s + 18480*C*D1**2*bd1*f**2*r - 1540*C*D1**2*bd1*f**2*s**2 + 11088*C*D1**2*bd1*f**2*s - 9240*C*D1**2*bd1*f**2 - 11880*C*D1**2*f**2*fd*r**2 - 14256*C*D1**2*f**2*fd*r*s + 12672*C*D1**2*f**2*fd*r - 2376*C*D1**2*f**2*fd*s**2 + 6336*C*D1**2*f**2*fd*s - 4752*C*D1**2*f**2*fd - 15840*C*D1*Dd*f**3*r**2 - 19008*C*D1*Dd*f**3*r*s + 17424*C*D1*Dd*f**3*r - 3168*C*D1*Dd*f**3*s**2 + 7920*C*D1*Dd*f**3*s - 5544*C*D1*Dd*f**3 - 12782*D1**2*K*bd1**2*f*r**2 - 20020*D1**2*K*bd1**2*f*r*s + 23100*D1**2*K*bd1**2*f*r - 7238*D1**2*K*bd1**2*f*s**2 + 17556*D1**2*K*bd1**2*f*s - 10318*D1**2*K*bd1**2*f + 5511*D1**2*K*bd1*f**2*r**2 + 7018*D1**2*K*bd1*f**2*r*s - 7018*D1**2*K*bd1*f**2*r + 1507*D1**2*K*bd1*f**2*s**2 - 3014*D1**2*K*bd1*f**2*s + 1507*D1**2*K*bd1*f**2 - 15796*D1**2*K*bd1*f*fd*r**2 - 20504*D1**2*K*bd1*f*fd*r*s + 18150*D1**2*K*bd1*f*fd*r - 4708*D1**2*K*bd1*f*fd*s**2 + 9834*D1**2*K*bd1*f*fd*s - 5126*D1**2*K*bd1*f*fd - 3949*D1**2*K*bdd1*f**2*r**2 - 5126*D1**2*K*bdd1*f**2*r*s + 5126*D1**2*K*bdd1*f**2*r - 1177*D1**2*K*bdd1*f**2*s**2 + 2354*D1**2*K*bdd1*f**2*s - 1177*D1**2*K*bdd1*f**2 + 11220*D1**2*bd1**2*f**2*r**2 + 24288*D1**2*bd1**2*f**2*r*s - 21780*D1**2*bd1**2*f**2*r + 13068*D1**2*bd1**2*f**2*s**2 - 23628*D1**2*bd1**2*f**2*s + 10560*D1**2*bd1**2*f**2 + 12782*D1**2*bd1**2*f*r**2 + 21868*D1**2*bd1**2*f*r*s - 24024*D1**2*bd1**2*f*r + 9086*D1**2*bd1**2*f*s**2 - 20328*D1**2*bd1**2*f*s + 11242*D1**2*bd1**2*f - 3080*D1**2*bd1**2*g2*r**2 - 6160*D1**2*bd1**2*g2*r*s + 3080*D1**2*bd1**2*g2*r - 3080*D1**2*bd1**2*g2*s**2 + 3080*D1**2*bd1**2*g2*s - 1848*D1**2*bd1*bd2*f*r**2 - 3696*D1**2*bd1*bd2*f*r*s + 3696*D1**2*bd1*bd2*f*r - 1848*D1**2*bd1*bd2*f*s**2 + 3696*D1**2*bd1*bd2*f*s - 1848*D1**2*bd1*bd2*f - 1276*D1**2*bd1*f**3*r**2 + 1188*D1**2*bd1*f**3*r*s - 528*D1**2*bd1*f**3*r + 2464*D1**2*bd1*f**3*s**2 - 4268*D1**2*bd1*f**3*s + 880*D1**2*bd1*f**3 + 2640*D1**2*bd1*f**2*fd*r**2 - 21384*D1**2*bd1*f**2*fd*r*s + 9152*D1**2*bd1*f**2*fd*r - 24024*D1**2*bd1*f**2*fd*s**2 + 31372*D1**2*bd1*f**2*fd*s - 10780*D1**2*bd1*f**2*fd + 3245*D1**2*bd1*f**2*r**2 + 2794*D1**2*bd1*f**2*r*s - 9878*D1**2*bd1*f**2*r - 451*D1**2*bd1*f**2*s**2 - 6182*D1**2*bd1*f**2*s + 6325*D1**2*bd1*f**2 + 13684*D1**2*bd1*f*fd*r**2 + 19976*D1**2*bd1*f*fd*r*s - 16830*D1**2*bd1*f*fd*r + 6292*D1**2*bd1*f*fd*s**2 - 11286*D1**2*bd1*f*fd*s + 4994*D1**2*bd1*f*fd - 20174*D1**2*bd1*f*g2*r**2 - 26180*D1**2*bd1*f*g2*r*s + 41580*D1**2*bd1*f*g2*r - 6006*D1**2*bd1*f*g2*s**2 + 27412*D1**2*bd1*f*g2*s - 20790*D1**2*bd1*f*g2 + 25564*D1**2*bd1*f*gd2*r**2 + 40040*D1**2*bd1*f*gd2*r*s - 46200*D1**2*bd1*f*gd2*r + 14476*D1**2*bd1*f*gd2*s**2 - 35112*D1**2*bd1*f*gd2*s + 20636*D1**2*bd1*f*gd2 + 25564*D1**2*bd1*fd*g2*r**2 + 40040*D1**2*bd1*fd*g2*r*s - 25564*D1**2*bd1*fd*g2*r + 14476*D1**2*bd1*fd*g2*s**2 - 20020*D1**2*bd1*fd*g2*s + 792*D1**2*bd2*f**2*r**2 + 1584*D1**2*bd2*f**2*r*s - 1584*D1**2*bd2*f**2*r + 792*D1**2*bd2*f**2*s**2 - 1584*D1**2*bd2*f**2*s + 792*D1**2*bd2*f**2 - 1584*D1**2*bd2*f*fd*r**2 - 3168*D1**2*bd2*f*fd*r*s + 2376*D1**2*bd2*f*fd*r - 1584*D1**2*bd2*f*fd*s**2 + 2376*D1**2*bd2*f*fd*s - 792*D1**2*bd2*f*fd + 440*D1**2*bdd1*f**3*r**2 - 3564*D1**2*bdd1*f**3*r*s + 1452*D1**2*bdd1*f**3*r - 4004*D1**2*bdd1*f**3*s**2 + 5896*D1**2*bdd1*f**3*s - 1232*D1**2*bdd1*f**3 + 3421*D1**2*bdd1*f**2*r**2 + 4994*D1**2*bdd1*f**2*r*s - 4994*D1**2*bdd1*f**2*r + 1573*D1**2*bdd1*f**2*s**2 - 3146*D1**2*bdd1*f**2*s + 1573*D1**2*bdd1*f**2 + 12782*D1**2*bdd1*f*g2*r**2 + 20020*D1**2*bdd1*f*g2*r*s - 26180*D1**2*bdd1*f*g2*r + 7238*D1**2*bdd1*f*g2*s**2 - 20636*D1**2*bdd1*f*g2*s + 13090*D1**2*bdd1*f*g2 - 396*D1**2*bdd2*f**2*r**2 - 792*D1**2*bdd2*f**2*r*s + 792*D1**2*bdd2*f**2*r - 396*D1**2*bdd2*f**2*s**2 + 792*D1**2*bdd2*f**2*s - 396*D1**2*bdd2*f**2 + 11400*D1**2*f**3*fd*r**2 + 25040*D1**2*f**3*fd*r*s - 18220*D1**2*f**3*fd*r + 13640*D1**2*f**3*fd*s**2 - 19900*D1**2*f**3*fd*s + 9670*D1**2*f**3*fd - 11640*D1**2*f**3*fdd*r**2 - 27920*D1**2*f**3*fdd*r*s + 19780*D1**2*f**3*fdd*r - 16280*D1**2*f**3*fdd*s**2 + 23260*D1**2*f**3*fdd*s - 11050*D1**2*f**3*fdd - 34920*D1**2*f**2*fd**2*r**2 - 83760*D1**2*f**2*fd**2*r*s + 59340*D1**2*f**2*fd**2*r - 48840*D1**2*f**2*fd**2*s**2 + 69780*D1**2*f**2*fd**2*s - 22100*D1**2*f**2*fd**2 + 10692*D1**2*f**2*fd*r**2 + 13068*D1**2*f**2*fd*r*s - 11484*D1**2*f**2*fd*r + 2376*D1**2*f**2*fd*s**2 - 5940*D1**2*f**2*fd*s + 4356*D1**2*f**2*fd - 11022*D1**2*f**2*gd2*r**2 - 14036*D1**2*f**2*gd2*r*s + 14036*D1**2*f**2*gd2*r - 3014*D1**2*f**2*gd2*s**2 + 6028*D1**2*f**2*gd2*s - 3014*D1**2*f**2*gd2 + 7898*D1**2*f**2*gdd2*r**2 + 10252*D1**2*f**2*gdd2*r*s - 10252*D1**2*f**2*gdd2*r + 2354*D1**2*f**2*gdd2*s**2 - 4708*D1**2*f**2*gdd2*s + 2354*D1**2*f**2*gdd2 - 22044*D1**2*f*fd*g2*r**2 - 28072*D1**2*f*fd*g2*r*s + 22044*D1**2*f*fd*g2*r - 6028*D1**2*f*fd*g2*s**2 + 14036*D1**2*f*fd*g2*s - 11022*D1**2*f*fd*g2 + 31592*D1**2*f*fd*gd2*r**2 + 41008*D1**2*f*fd*gd2*r*s - 36300*D1**2*f*fd*gd2*r + 9416*D1**2*f*fd*gd2*s**2 - 19668*D1**2*f*fd*gd2*s + 10252*D1**2*f*fd*gd2 + 15796*D1**2*f*fdd*g2*r**2 + 20504*D1**2*f*fdd*g2*r*s - 15796*D1**2*f*fdd*g2*r + 4708*D1**2*f*fdd*g2*s**2 - 10252*D1**2*f*fdd*g2*s + 7898*D1**2*f*fdd*g2 + 15796*D1**2*fd**2*g2*r**2 + 20504*D1**2*fd**2*g2*r*s - 15796*D1**2*fd**2*g2*r + 4708*D1**2*fd**2*g2*s**2 - 10252*D1**2*fd**2*g2*s - 31592*D1*Dd*K*bd1*f**2*r**2 - 41008*D1*Dd*K*bd1*f**2*r*s + 38654*D1*Dd*K*bd1*f**2*r - 9416*D1*Dd*K*bd1*f**2*s**2 + 19250*D1*Dd*K*bd1*f**2*s - 9834*D1*Dd*K*bd1*f**2 + 3520*D1*Dd*bd1*f**3*r**2 - 28512*D1*Dd*bd1*f**3*r*s + 12056*D1*Dd*bd1*f**3*r - 32032*D1*Dd*bd1*f**3*s**2 + 43164*D1*Dd*bd1*f**3*s - 13244*D1*Dd*bd1*f**3 + 27368*D1*Dd*bd1*f**2*r**2 + 39952*D1*Dd*bd1*f**2*r*s - 36806*D1*Dd*bd1*f**2*r + 12584*D1*Dd*bd1*f**2*s**2 - 23870*D1*Dd*bd1*f**2*s + 11286*D1*Dd*bd1*f**2 + 102256*D1*Dd*bd1*f*g2*r**2 + 160160*D1*Dd*bd1*f*g2*r*s - 170324*D1*Dd*bd1*f*g2*r + 57904*D1*Dd*bd1*f*g2*s**2 - 131516*D1*Dd*bd1*f*g2*s + 67452*D1*Dd*bd1*f*g2 - 3168*D1*Dd*bd2*f**2*r**2 - 6336*D1*Dd*bd2*f**2*r*s + 5544*D1*Dd*bd2*f**2*r - 3168*D1*Dd*bd2*f**2*s**2 + 5544*D1*Dd*bd2*f**2*s - 2376*D1*Dd*bd2*f**2 + 11400*D1*Dd*f**4*r**2 + 25040*D1*Dd*f**4*r*s - 18220*D1*Dd*f**4*r + 13640*D1*Dd*f**4*s**2 - 19900*D1*Dd*f**4*s + 9670*D1*Dd*f**4 - 93120*D1*Dd*f**3*fd*r**2 - 223360*D1*Dd*f**3*fd*r*s + 158240*D1*Dd*f**3*fd*r - 130240*D1*Dd*f**3*fd*s**2 + 186080*D1*Dd*f**3*fd*s - 66300*D1*Dd*f**3*fd + 14256*D1*Dd*f**3*r**2 + 17424*D1*Dd*f**3*r*s - 15840*D1*Dd*f**3*r + 3168*D1*Dd*f**3*s**2 - 7524*D1*Dd*f**3*s + 5148*D1*Dd*f**3 - 44088*D1*Dd*f**2*g2*r**2 - 56144*D1*Dd*f**2*g2*r*s + 50116*D1*Dd*f**2*g2*r - 12056*D1*Dd*f**2*g2*s**2 + 26092*D1*Dd*f**2*g2*s - 17050*D1*Dd*f**2*g2 + 63184*D1*Dd*f**2*gd2*r**2 + 82016*D1*Dd*f**2*gd2*r*s - 77308*D1*Dd*f**2*gd2*r + 18832*D1*Dd*f**2*gd2*s**2 - 38500*D1*Dd*f**2*gd2*s + 19668*D1*Dd*f**2*gd2 + 126368*D1*Dd*f*fd*g2*r**2 + 164032*D1*Dd*f*fd*g2*r*s - 135784*D1*Dd*f*fd*g2*r + 37664*D1*Dd*f*fd*g2*s**2 - 80344*D1*Dd*f*fd*g2*s + 36300*D1*Dd*f*fd*g2 - 11640*D1*Ddd*f**4*r**2 - 27920*D1*Ddd*f**4*r*s + 19780*D1*Ddd*f**4*r - 16280*D1*Ddd*f**4*s**2 + 23260*D1*Ddd*f**4*s - 11050*D1*Ddd*f**4 + 31592*D1*Ddd*f**2*g2*r**2 + 41008*D1*Ddd*f**2*g2*r*s - 36300*D1*Ddd*f**2*g2*r + 9416*D1*Ddd*f**2*g2*s**2 - 19668*D1*Ddd*f**2*g2*s + 12606*D1*Ddd*f**2*g2 - 34920*Dd**2*f**4*r**2 - 83760*Dd**2*f**4*r*s + 59340*Dd**2*f**4*r - 48840*Dd**2*f**4*s**2 + 69780*Dd**2*f**4*s - 22100*Dd**2*f**4 + 94776*Dd**2*f**2*g2*r**2 + 123024*Dd**2*f**2*g2*r*s - 108900*Dd**2*f**2*g2*r + 28248*Dd**2*f**2*g2*s**2 - 59004*Dd**2*f**2*g2*s + 25212*Dd**2*f**2*g2 + 154*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (5*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-5*K + 6*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 6*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(140*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 140*C*D1**2*fd*s**2 - 280*C*D1**2*fd*s + 140*C*D1**2*fd + 560*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 840*C*D1*Dd*f*r + 560*C*D1*Dd*f*s**2 - 840*C*D1*Dd*f*s + 420*C*D1*Dd*f + 917*D1**2*K*fd*r**2 + 1190*D1**2*K*fd*r*s + 56*D1**2*K*fd*r + 273*D1**2*K*fd*s**2 + 56*D1**2*K*fd*s - 28*D1**2*K*fd - 581*D1**2*K*fdd*r**2 - 910*D1**2*K*fdd*r*s - 28*D1**2*K*fdd*r - 329*D1**2*K*fdd*s**2 - 28*D1**2*K*fdd*s + 14*D1**2*K*fdd - 14*D1**2*bdd1*(-5*K + 6*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 948*D1**2*f*fd*r**2 - 2064*D1**2*f*fd*r*s + 1152*D1**2*f*fd*r - 1116*D1**2*f*fd*s**2 + 1236*D1**2*f*fd*s - 618*D1**2*f*fd + 1020*D1**2*f*fdd*r**2 + 2208*D1**2*f*fdd*r*s - 1248*D1**2*f*fdd*r + 1188*D1**2*f*fdd*s**2 - 1332*D1**2*f*fdd*s + 666*D1**2*f*fdd + 1020*D1**2*fd**2*r**2 + 2208*D1**2*fd**2*r*s - 1248*D1**2*fd**2*r + 1188*D1**2*fd**2*s**2 - 1332*D1**2*fd**2*s + 144*D1**2*fd**2 - 917*D1**2*fd*r**2 - 1358*D1**2*fd*r*s + 224*D1**2*fd*r - 441*D1**2*fd*s**2 + 224*D1**2*fd*s - 112*D1**2*fd + 581*D1**2*fdd*r**2 + 994*D1**2*fdd*r*s + 28*D1**2*fdd*r + 413*D1**2*fdd*s**2 + 28*D1**2*fdd*s - 14*D1**2*fdd + 280*D1**2*gd2*r**2 + 560*D1**2*gd2*r*s - 560*D1**2*gd2*r + 280*D1**2*gd2*s**2 - 560*D1**2*gd2*s + 280*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 + 3668*D1*Dd*K*f*r**2 + 4760*D1*Dd*K*f*r*s - 4214*D1*Dd*K*f*r + 1092*D1*Dd*K*f*s**2 - 2282*D1*Dd*K*f*s + 1463*D1*Dd*K*f - 4648*D1*Dd*K*fd*r**2 - 7280*D1*Dd*K*fd*r*s + 2870*D1*Dd*K*fd*r - 2632*D1*Dd*K*fd*s**2 + 2114*D1*Dd*K*fd*s + 84*D1*Dd*K*fd - 1896*D1*Dd*f**2*r**2 - 4128*D1*Dd*f**2*r*s + 3012*D1*Dd*f**2*r - 2232*D1*Dd*f**2*s**2 + 3264*D1*Dd*f**2*s - 1590*D1*Dd*f**2 + 8160*D1*Dd*f*fd*r**2 + 17664*D1*Dd*f*fd*r*s - 11448*D1*Dd*f*fd*r + 9504*D1*Dd*f*fd*s**2 - 12288*D1*Dd*f*fd*s + 3912*D1*Dd*f*fd - 3668*D1*Dd*f*r**2 - 5432*D1*Dd*f*r*s + 4550*D1*Dd*f*r - 1764*D1*Dd*f*s**2 + 3122*D1*Dd*f*s - 1799*D1*Dd*f + 4648*D1*Dd*fd*r**2 + 7952*D1*Dd*fd*r*s - 3038*D1*Dd*fd*r + 3304*D1*Dd*fd*s**2 - 2534*D1*Dd*fd*s - 84*D1*Dd*fd + 1120*D1*Dd*g2*r**2 + 2240*D1*Dd*g2*r*s - 1680*D1*Dd*g2*r + 1120*D1*Dd*g2*s**2 - 1680*D1*Dd*g2*s + 840*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 - 2324*D1*Ddd*K*f*r**2 - 3640*D1*Ddd*K*f*r*s + 2982*D1*Ddd*K*f*r - 1316*D1*Ddd*K*f*s**2 + 2226*D1*Ddd*K*f*s - 1239*D1*Ddd*K*f + 2040*D1*Ddd*f**2*r**2 + 4416*D1*Ddd*f**2*r*s - 3228*D1*Ddd*f**2*r + 2376*D1*Ddd*f**2*s**2 - 3480*D1*Ddd*f**2*s + 1698*D1*Ddd*f**2 + 2324*D1*Ddd*f*r**2 + 3976*D1*Ddd*f*r*s - 3150*D1*Ddd*f*r + 1652*D1*Ddd*f*s**2 - 2646*D1*Ddd*f*s + 1407*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 + 28*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (5*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-5*K + 6*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 6972*Dd**2*K*f*r**2 - 10920*Dd**2*K*f*r*s + 8946*Dd**2*K*f*r - 3948*Dd**2*K*f*s**2 + 6678*Dd**2*K*f*s - 2478*Dd**2*K*f + 6120*Dd**2*f**2*r**2 + 13248*Dd**2*f**2*r*s - 9684*Dd**2*f**2*r + 7128*Dd**2*f**2*s**2 - 10440*Dd**2*f**2*s + 3396*Dd**2*f**2 + 6972*Dd**2*f*r**2 + 11928*Dd**2*f*r*s - 9450*Dd**2*f*r + 4956*Dd**2*f*s**2 - 7938*Dd**2*f*s + 2814*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) - 11*b1*(1624*C*D1**2*f*fd*r**2 + 1904*C*D1**2*f*fd*r*s - 896*C*D1**2*f*fd*r + 280*C*D1**2*f*fd*s**2 - 224*C*D1**2*f*fd*s + 112*C*D1**2*f*fd + 3248*C*D1*Dd*f**2*r**2 + 3808*C*D1*Dd*f**2*r*s - 3528*C*D1*Dd*f**2*r + 560*C*D1*Dd*f**2*s**2 - 1512*C*D1*Dd*f**2*s + 1092*C*D1*Dd*f**2 + 1162*D1**2*K*bdd1*f*r**2 + 1820*D1**2*K*bdd1*f*r*s - 2100*D1**2*K*bdd1*f*r + 658*D1**2*K*bdd1*f*s**2 - 1596*D1**2*K*bdd1*f*s + 924*D1**2*K*bdd1*f - 1002*D1**2*K*f*fd*r**2 - 1276*D1**2*K*f*fd*r*s + 1002*D1**2*K*f*fd*r - 274*D1**2*K*f*fd*s**2 + 638*D1**2*K*f*fd*s - 501*D1**2*K*f*fd + 718*D1**2*K*f*fdd*r**2 + 932*D1**2*K*f*fdd*r*s - 718*D1**2*K*f*fdd*r + 214*D1**2*K*f*fdd*s**2 - 466*D1**2*K*f*fdd*s + 359*D1**2*K*f*fdd + 718*D1**2*K*fd**2*r**2 + 932*D1**2*K*fd**2*r*s - 718*D1**2*K*fd**2*r + 214*D1**2*K*fd**2*s**2 - 466*D1**2*K*fd**2*s - 168*D1**2*b2*fd*r**2 - 336*D1**2*b2*fd*r*s - 168*D1**2*b2*fd*s**2 + 84*D1**2*b2*fdd*r**2 + 168*D1**2*b2*fdd*r*s + 84*D1**2*b2*fdd*s**2 + 28*D1**2*bd1**2*(-5*K + 6*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 1020*D1**2*bdd1*f**2*r**2 - 2208*D1**2*bdd1*f**2*r*s + 1980*D1**2*bdd1*f**2*r - 1188*D1**2*bdd1*f**2*s**2 + 2148*D1**2*bdd1*f**2*s - 1032*D1**2*bdd1*f**2 - 1162*D1**2*bdd1*f*r**2 - 1988*D1**2*bdd1*f*r*s + 2184*D1**2*bdd1*f*r - 826*D1**2*bdd1*f*s**2 + 1848*D1**2*bdd1*f*s - 1008*D1**2*bdd1*f + 280*D1**2*bdd1*g2*r**2 + 560*D1**2*bdd1*g2*r*s - 280*D1**2*bdd1*g2*r + 280*D1**2*bdd1*g2*s**2 - 280*D1**2*bdd1*g2*s + 140*D1**2*bdd1*g2 + 84*D1**2*bdd2*f*r**2 + 168*D1**2*bdd2*f*r*s - 168*D1**2*bdd2*f*r + 84*D1**2*bdd2*f*s**2 - 168*D1**2*bdd2*f*s + 84*D1**2*bdd2*f + 348*D1**2*f**2*fd*r**2 - 324*D1**2*f**2*fd*r*s - 64*D1**2*f**2*fd*r - 672*D1**2*f**2*fd*s**2 + 616*D1**2*f**2*fd*s - 252*D1**2*f**2*fd - 120*D1**2*f**2*fdd*r**2 + 972*D1**2*f**2*fdd*r*s - 436*D1**2*f**2*fdd*r + 1092*D1**2*f**2*fdd*s**2 - 1244*D1**2*f**2*fdd*s + 576*D1**2*f**2*fdd - 240*D1**2*f*fd**2*r**2 + 1944*D1**2*f*fd**2*r*s - 872*D1**2*f*fd**2*r + 2184*D1**2*f*fd**2*s**2 - 2488*D1**2*f*fd**2*s + 396*D1**2*f*fd**2 - 590*D1**2*f*fd*r**2 - 508*D1**2*f*fd*r*s - 54*D1**2*f*fd*r + 82*D1**2*f*fd*s**2 - 390*D1**2*f*fd*s + 321*D1**2*f*fd - 622*D1**2*f*fdd*r**2 - 908*D1**2*f*fdd*r*s + 622*D1**2*f*fdd*r - 286*D1**2*f*fdd*s**2 + 454*D1**2*f*fdd*s - 311*D1**2*f*fdd + 1834*D1**2*f*gd2*r**2 + 2380*D1**2*f*gd2*r*s - 2380*D1**2*f*gd2*r + 546*D1**2*f*gd2*s**2 - 1092*D1**2*f*gd2*s + 546*D1**2*f*gd2 - 1162*D1**2*f*gdd2*r**2 - 1820*D1**2*f*gdd2*r*s + 1820*D1**2*f*gdd2*r - 658*D1**2*f*gdd2*s**2 + 1316*D1**2*f*gdd2*s - 658*D1**2*f*gdd2 - 622*D1**2*fd**2*r**2 - 908*D1**2*fd**2*r*s + 622*D1**2*fd**2*r - 286*D1**2*fd**2*s**2 + 454*D1**2*fd**2*s + 1834*D1**2*fd*g2*r**2 + 2380*D1**2*fd*g2*r*s + 112*D1**2*fd*g2*r + 546*D1**2*fd*g2*s**2 + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 - 2324*D1**2*fd*gd2*r**2 - 3640*D1**2*fd*gd2*r*s + 1764*D1**2*fd*gd2*r - 1316*D1**2*fd*gd2*s**2 + 1260*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 - 1162*D1**2*fdd*g2*r**2 - 1820*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r - 658*D1**2*fdd*g2*s**2 - 56*D1**2*fdd*g2*s + 28*D1**2*fdd*g2 - 2004*D1*Dd*K*f**2*r**2 - 2552*D1*Dd*K*f**2*r*s + 2278*D1*Dd*K*f**2*r - 548*D1*Dd*K*f**2*s**2 + 1186*D1*Dd*K*f**2*s - 775*D1*Dd*K*f**2 + 5744*D1*Dd*K*f*fd*r**2 + 7456*D1*Dd*K*f*fd*r*s - 6172*D1*Dd*K*f*fd*r + 1712*D1*Dd*K*f*fd*s**2 - 3652*D1*Dd*K*f*fd*s + 1650*D1*Dd*K*f*fd - 672*D1*Dd*b2*f*r**2 - 1344*D1*Dd*b2*f*r*s + 1008*D1*Dd*b2*f*r - 672*D1*Dd*b2*f*s**2 + 1008*D1*Dd*b2*f*s - 504*D1*Dd*b2*f + 672*D1*Dd*b2*fd*r**2 + 1344*D1*Dd*b2*fd*r*s - 504*D1*Dd*b2*fd*r + 672*D1*Dd*b2*fd*s**2 - 504*D1*Dd*b2*fd*s + 464*D1*Dd*f**3*r**2 - 432*D1*Dd*f**3*r*s - 16*D1*Dd*f**3*r - 896*D1*Dd*f**3*s**2 + 1004*D1*Dd*f**3*s - 332*D1*Dd*f**3 - 960*D1*Dd*f**2*fd*r**2 + 7776*D1*Dd*f**2*fd*r*s - 3448*D1*Dd*f**2*fd*r + 8736*D1*Dd*f**2*fd*s**2 - 10316*D1*Dd*f**2*fd*s + 2924*D1*Dd*f**2*fd - 1180*D1*Dd*f**2*r**2 - 1016*D1*Dd*f**2*r*s + 1098*D1*Dd*f**2*r + 164*D1*Dd*f**2*s**2 + 90*D1*Dd*f**2*s - 213*D1*Dd*f**2 - 4976*D1*Dd*f*fd*r**2 - 7264*D1*Dd*f*fd*r*s + 5548*D1*Dd*f*fd*r - 2288*D1*Dd*f*fd*s**2 + 3868*D1*Dd*f*fd*s - 1530*D1*Dd*f*fd + 7336*D1*Dd*f*g2*r**2 + 9520*D1*Dd*f*g2*r*s - 8428*D1*Dd*f*g2*r + 2184*D1*Dd*f*g2*s**2 - 4564*D1*Dd*f*g2*s + 2926*D1*Dd*f*g2 - 9296*D1*Dd*f*gd2*r**2 - 14560*D1*Dd*f*gd2*r*s + 13244*D1*Dd*f*gd2*r - 5264*D1*Dd*f*gd2*s**2 + 9716*D1*Dd*f*gd2*s - 4452*D1*Dd*f*gd2 - 9296*D1*Dd*fd*g2*r**2 - 14560*D1*Dd*fd*g2*r*s + 5740*D1*Dd*fd*g2*r - 5264*D1*Dd*fd*g2*s**2 + 4228*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 + 1436*D1*Ddd*K*f**2*r**2 + 1864*D1*Ddd*K*f**2*r*s - 1650*D1*Ddd*K*f**2*r + 428*D1*Ddd*K*f**2*s**2 - 894*D1*Ddd*K*f**2*s + 573*D1*Ddd*K*f**2 + 336*D1*Ddd*b2*f*r**2 + 672*D1*Ddd*b2*f*r*s - 504*D1*Ddd*b2*f*r + 336*D1*Ddd*b2*f*s**2 - 504*D1*Ddd*b2*f*s + 252*D1*Ddd*b2*f - 160*D1*Ddd*f**3*r**2 + 1296*D1*Ddd*f**3*r*s - 568*D1*Ddd*f**3*r + 1456*D1*Ddd*f**3*s**2 - 1780*D1*Ddd*f**3*s + 688*D1*Ddd*f**3 - 1244*D1*Ddd*f**2*r**2 - 1816*D1*Ddd*f**2*r*s + 1530*D1*Ddd*f**2*r - 572*D1*Ddd*f**2*s**2 + 1026*D1*Ddd*f**2*s - 597*D1*Ddd*f**2 - 4648*D1*Ddd*f*g2*r**2 - 7280*D1*Ddd*f*g2*r*s + 5964*D1*Ddd*f*g2*r - 2632*D1*Ddd*f*g2*s**2 + 4452*D1*Ddd*f*g2*s - 2478*D1*Ddd*f*g2 + 2*D1*bd1*(6*D1*f**2*(79*r**2 + r*(172*s - 155) + 93*s**2 - 169*s + 81) - D1*f*(70*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(131*r**2 + 170*r*s - 220*r + 39*s**2 - 128*s + 87) + 6*fd*(340*r**2 + r*(736*s - 538) + 396*s**2 - 580*s + 191) - 917*r**2 - 1358*r*s + 1484*r - 441*s**2 + 1008*s - 623) + 14*D1*(fd*(K*(83*r**2 + 130*r*s - 73*r + 47*s**2 - 55*s - 1) - 83*r**2 - 142*r*s + 76*r - 59*s**2 + 64*s + 1) - 10*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 10*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f**2*(680*r**2 + 2*r*(736*s - 599) + 792*s**2 - 1296*s + 523) + 14*Dd*f*(K*(332*r**2 + r*(520*s - 513) + 188*s**2 - 387*s + 189) - 332*r**2 + r*(537 - 568*s) - 236*s**2 + 453*s - 210) + 140*Dd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 168*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 4308*Dd**2*K*f**2*r**2 + 5592*Dd**2*K*f**2*r*s - 4950*Dd**2*K*f**2*r + 1284*Dd**2*K*f**2*s**2 - 2682*Dd**2*K*f**2*s + 1146*Dd**2*K*f**2 + 1008*Dd**2*b2*f*r**2 + 2016*Dd**2*b2*f*r*s - 1512*Dd**2*b2*f*r + 1008*Dd**2*b2*f*s**2 - 1512*Dd**2*b2*f*s + 504*Dd**2*b2*f - 480*Dd**2*f**3*r**2 + 3888*Dd**2*f**3*r*s - 1704*Dd**2*f**3*r + 4368*Dd**2*f**3*s**2 - 5340*Dd**2*f**3*s + 1376*Dd**2*f**3 - 3732*Dd**2*f**2*r**2 - 5448*Dd**2*f**2*r*s + 4590*Dd**2*f**2*r - 1716*Dd**2*f**2*s**2 + 3078*Dd**2*f**2*s - 1194*Dd**2*f**2 - 13944*Dd**2*f*g2*r**2 - 21840*Dd**2*f*g2*r*s + 17892*Dd**2*f*g2*r - 7896*Dd**2*f*g2*s**2 + 13356*Dd**2*f*g2*s - 4956*Dd**2*f*g2) + 132*b2*(-7*D1**2*bdd1*f*(r + s - 1)**2 + 3*D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 3*D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(1155*d**2*k3**6) - D1**2*Pk1*Pk3*ct**2*k2**2*st**6*(8*C - 8)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k3**4) - 2*D1**2*Pk1*Pk3*ct**2*k2**2*st**4*(84*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 3*b1*(D1**2*(f*(-28*bdd1*s*(C - 1)*(2*r + 2*s - 1) + fd*(C*(-324*r*(2*s - 1) - 402*s**2 + 394*s - 201) + 280*r*(2*s - 1) + 374*s**2 - 366*s + 187) + fdd*(C*(176*r*(2*s - 1) + 278*s**2 - 274*s + 139) - 161*r*(2*s - 1) - 278*s**2 + 274*s - 139)) + fd**2*(2*C*(88*r*(2*s - 1) + 139*s**2 - 137*s - 2) - 161*r*(2*s - 1) - 278*s**2 + 274*s + 4)) - 28*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(-2*f*(3*C*(108*r*(2*s - 1) + 134*s**2 - 188*s + 67) - 560*r*s + 280*r - 374*s**2 + 514*s - 187) + fd*(2*s - 1)*(4*C*(352*r + 278*s - 181) - 1288*r - 1112*s + 709)) + Ddd*f*(C*(352*r*(2*s - 1) + 556*s**2 - 732*s + 278) - 644*r*s + 322*r - 556*s**2 + 717*s - 278)) + 3*Dd**2*f**2*(C*(352*r*(2*s - 1) + 556*s**2 - 732*s + 210) - 322*r*(2*s - 1) - 556*s**2 + 717*s - 200)) + f*(-84*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1**2*(f*(3*bdd1*s*(C*(176*r + 139*s - 180) - 161*r - 139*s + 165) + fd*(C*(-388*r*(3*s - 1) - 543*s**2 + 750*s - 181) + 336*r*(3*s - 1) + 525*s**2 - 686*s + 175) + fdd*(C*(260*r*(3*s - 1) + 321*s**2 - 474*s + 107) - 675*r*s + 225*r - 321*s**2 + 439*s - 107)) + fd**2*(2*C*(260*r*(3*s - 1) + 321*s**2 - 474*s + 130) - 450*r*(3*s - 1) - 642*s**2 + 878*s - 225)) - 3*D1*bd1*(D1*(f*s*(C*(324*r + 201*s - 332) - 280*r - 187*s + 288) + fd*(-2*C*(88*r*(4*s - 1) + 278*s**2 - 317*s + 90) + 161*r*(4*s - 1) + 556*s**2 - 604*s + 165)) + Dd*f*(-4*C*(88*r*(4*s - 1) + 278*s**2 - 363*s + 90) + 322*r*(4*s - 1) + 1112*s**2 - 1377*s + 330)) + D1*f*(Dd*(-2*f*(C*(388*r*(2*s - 1) + 362*s**2 - 556*s + 181) - 336*r*(2*s - 1) - 350*s**2 + 518*s - 175) + fd*(8*C*(65*r*(12*s - 5) + 321*s**2 - 495*s + 151) - 450*r*(12*s - 5) - 2568*s**2 + 3715*s - 1103)) + Ddd*f*(2*C*(260*r*(2*s - 1) + 214*s**2 - 344*s + 107) - 450*r*(2*s - 1) - 428*s**2 + 653*s - 214)) + Dd**2*f**2*(2*C*(780*r*(2*s - 1) + 642*s**2 - 1032*s + 367) - 1350*r*(2*s - 1) - 1284*s**2 + 1959*s - 664)))/(105*d**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**2*k2**2*st**2*(7*b1**2*(D1**2*(fd*(59*C*r + 39*C*(s - 1) - 47*r - 39*s + 39) + fdd*(-37*C*(r + s - 1) + 31*r + 37*s - 37))*(r + s - 1) + D1*(Dd*(f*(C*(236*r**2 + 392*r*s - 314*r + 156*s**2 - 254*s + 137) - 188*r**2 - 344*r*s + 266*r - 156*s**2 + 242*s - 125) + 2*fd*(-37*C*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 124*r**2 + 272*r*s - 235*r + 148*s**2 - 256*s + 108)) + Ddd*f*(-37*C*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 124*r**2 + 272*r*s - 198*r + 148*s**2 - 216*s + 105)) - 6*Dd**2*f*(37*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 62*r**2 + r*(99 - 136*s) - 74*s**2 + 108*s - 35)) + b1*(-82*C*D1**2*f*fd*r**2 - 2496*C*D1**2*f*fd*r*s + 654*C*D1**2*f*fd*r - 1482*C*D1**2*f*fd*s**2 + 1092*C*D1**2*f*fd*s - 444*C*D1**2*f*fd + 566*C*D1**2*f*fdd*r**2 + 2536*C*D1**2*f*fdd*r*s - 838*C*D1**2*f*fdd*r + 1406*C*D1**2*f*fdd*s**2 - 1120*C*D1**2*f*fdd*s + 488*C*D1**2*f*fdd + 566*C*D1**2*fd**2*r**2 + 2536*C*D1**2*fd**2*r*s - 838*C*D1**2*fd**2*r + 1406*C*D1**2*fd**2*s**2 - 1120*C*D1**2*fd**2*s - 286*C*D1**2*fd**2 - 164*C*D1*Dd*f**2*r**2 - 4992*C*D1*Dd*f**2*r*s + 2578*C*D1*Dd*f**2*r - 2964*C*D1*Dd*f**2*s**2 + 4212*C*D1*Dd*f**2*s - 1523*C*D1*Dd*f**2 + 4528*C*D1*Dd*f*fd*r**2 + 20288*C*D1*Dd*f*fd*r*s - 9556*C*D1*Dd*f*fd*r + 11248*C*D1*Dd*f*fd*s**2 - 12640*C*D1*Dd*f*fd*s + 3078*C*D1*Dd*f*fd + 1132*C*D1*Ddd*f**2*r**2 + 5072*C*D1*Ddd*f**2*r*s - 3102*C*D1*Ddd*f**2*r + 2812*C*D1*Ddd*f**2*s**2 - 4080*C*D1*Ddd*f**2*s + 1689*C*D1*Ddd*f**2 + 3396*C*Dd**2*f**2*r**2 + 15216*C*Dd**2*f**2*r*s - 9306*C*Dd**2*f**2*r + 8436*C*Dd**2*f**2*s**2 - 12240*C*Dd**2*f**2*s + 3942*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(37*C*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 62*r**2 - 136*r*s + 62*r - 74*s**2 + 68*s - 31) + 264*D1**2*f*fd*r**2 + 2642*D1**2*f*fd*r*s - 839*D1**2*f*fd*r + 1614*D1**2*f*fd*s**2 - 1280*D1**2*f*fd*s + 566*D1**2*f*fd - 524*D1**2*f*fdd*r**2 - 2602*D1**2*f*fdd*r*s + 955*D1**2*f*fdd*r - 1598*D1**2*f*fdd*s**2 + 1354*D1**2*f*fdd*s - 626*D1**2*f*fdd - 524*D1**2*fd**2*r**2 - 2602*D1**2*fd**2*r*s + 955*D1**2*fd**2*r - 1598*D1**2*fd**2*s**2 + 1354*D1**2*fd**2*s + 244*D1**2*fd**2 + 528*D1*Dd*f**2*r**2 + 5284*D1*Dd*f**2*r*s - 2906*D1*Dd*f**2*r + 3228*D1*Dd*f**2*s**2 - 4549*D1*Dd*f**2*s + 1746*D1*Dd*f**2 - 4192*D1*Dd*f*fd*r**2 - 20816*D1*Dd*f*fd*r*s + 10072*D1*Dd*f*fd*r - 12784*D1*Dd*f*fd*s**2 + 14410*D1*Dd*f*fd*s - 3663*D1*Dd*f*fd - 1048*D1*Ddd*f**2*r**2 - 5204*D1*Ddd*f**2*r*s + 3126*D1*Ddd*f**2*r - 3196*D1*Ddd*f**2*s**2 + 4497*D1*Ddd*f**2*s - 1860*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(C*(118*r**2 + 2*r*(98*s - 59) + 78*s**2 - 98*s + 59) - 94*r**2 - 172*r*s + 94*r - 78*s**2 + 86*s - 47) - 2*fd*(37*C*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 62*r**2 - 136*r*s + 99*r - 74*s**2 + 108*s - 34)) + 2*Dd*f*(-37*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 248*r**2 + 544*r*s - 322*r + 296*s**2 - 352*s + 99)) - 3144*Dd**2*f**2*r**2 - 15612*Dd**2*f**2*r*s + 9378*Dd**2*f**2*r - 9588*Dd**2*f**2*s**2 + 13491*Dd**2*f**2*s - 4200*Dd**2*f**2) + f*(-1416*C*D1**2*f*fd*r**2 - 3426*C*D1**2*f*fd*r*s + 2086*C*D1**2*f*fd*r - 942*C*D1**2*f*fd*s**2 + 1770*C*D1**2*f*fd*s - 786*C*D1**2*f*fd + 1482*C*D1**2*f*fdd*r**2 + 3054*C*D1**2*f*fdd*r*s - 2006*C*D1**2*f*fdd*r + 858*C*D1**2*f*fdd*s**2 - 1590*C*D1**2*f*fdd*s + 780*C*D1**2*f*fdd + 2964*C*D1**2*fd**2*r**2 + 6108*C*D1**2*fd**2*r*s - 4012*C*D1**2*fd**2*r + 1716*C*D1**2*fd**2*s**2 - 3180*C*D1**2*fd**2*s + 1018*C*D1**2*fd**2 - 1888*C*D1*Dd*f**2*r**2 - 4568*C*D1*Dd*f**2*r*s + 3228*C*D1*Dd*f**2*r - 1256*C*D1*Dd*f**2*s**2 + 2398*C*D1*Dd*f**2*s - 1100*C*D1*Dd*f**2 + 11856*C*D1*Dd*f*fd*r**2 + 24432*C*D1*Dd*f*fd*r*s - 17096*C*D1*Dd*f*fd*r + 6864*C*D1*Dd*f*fd*s**2 - 12846*C*D1*Dd*f*fd*s + 5186*C*D1*Dd*f*fd + 1976*C*D1*Ddd*f**2*r**2 + 4072*C*D1*Ddd*f**2*r*s - 3024*C*D1*Ddd*f**2*r + 1144*C*D1*Ddd*f**2*s**2 - 2162*C*D1*Ddd*f**2*s + 1066*C*D1*Ddd*f**2 + 5928*C*Dd**2*f**2*r**2 + 12216*C*Dd**2*f**2*r*s - 9072*C*Dd**2*f**2*r + 3432*C*Dd**2*f**2*s**2 - 6486*C*Dd**2*f**2*s + 2608*C*Dd**2*f**2 - 14*D1**2*bd1**2*(r**2*(37*C - 31) + r*(37*C*(2*s - 1) - 68*s + 31) + s*(37*C*(s - 1) - 37*s + 34)) + D1**2*bdd1*f*(C*(283*r**2 + 1268*r*s - 996*r + 703*s**2 - 1554*s + 498) - 262*r**2 - 1301*r*s + 870*r - 799*s**2 + 1545*s - 435) + 1191*D1**2*f*fd*r**2 + 3225*D1**2*f*fd*r*s - 1869*D1**2*f*fd*r + 1068*D1**2*f*fd*s**2 - 1787*D1**2*f*fd*s + 753*D1**2*f*fd - 1185*D1**2*f*fdd*r**2 - 2823*D1**2*f*fdd*r*s + 1731*D1**2*f*fdd*r - 1002*D1**2*f*fdd*s**2 + 1609*D1**2*f*fdd*s - 729*D1**2*f*fdd - 2370*D1**2*fd**2*r**2 - 5646*D1**2*fd**2*r*s + 3462*D1**2*fd**2*r - 2004*D1**2*fd**2*s**2 + 3218*D1**2*fd**2*s - 941*D1**2*fd**2 + 1588*D1*Dd*f**2*r**2 + 4300*D1*Dd*f**2*r*s - 2944*D1*Dd*f**2*r + 1424*D1*Dd*f**2*s**2 - 2499*D1*Dd*f**2*s + 1109*D1*Dd*f**2 - 9480*D1*Dd*f*fd*r**2 - 22584*D1*Dd*f*fd*r*s + 14940*D1*Dd*f*fd*r - 8016*D1*Dd*f*fd*s**2 + 13267*D1*Dd*f*fd*s - 4949*D1*Dd*f*fd - 1580*D1*Ddd*f**2*r**2 - 3764*D1*Ddd*f**2*r*s + 2672*D1*Ddd*f**2*r - 1336*D1*Ddd*f**2*s**2 + 2277*D1*Ddd*f**2*s - 1063*D1*Ddd*f**2 + D1*bd1*(D1*(f*(-C*(41*r**2 + 1248*r*s - 676*r + 741*s**2 - 1638*s + 338) + 132*r**2 + 1321*r*s - 746*r + 807*s**2 - 1655*s + 373) + fd*(2*C*(566*r**2 + 2536*r*s - 1415*r + 1406*s**2 - 2114*s + 777) - 1048*r**2 - 5204*r*s + 2695*r - 3196*s**2 + 4444*s - 1545)) + Dd*f*(2*C*(1132*r**2 + 5072*r*s - 3543*r + 2812*s**2 - 5148*s + 2052) - 2096*r**2 - 10408*r*s + 6606*r - 6392*s**2 + 10677*s - 3960)) - 4740*Dd**2*f**2*r**2 - 11292*Dd**2*f**2*r*s + 8016*Dd**2*f**2*r - 4008*Dd**2*f**2*s**2 + 6831*Dd**2*f**2*s - 2550*Dd**2*f**2))/(105*d**2*k3**4) - D1**2*Pk1*Pk3*ct**2*k2**2*(4158*C*D1**2*bd1*f**2*r**2 + 5544*C*D1**2*bd1*f**2*r*s + 2772*C*D1**2*bd1*f**2*r - 1386*C*D1**2*bd1*f**2 - 2970*C*D1**2*f**2*fd*r**2 + 1980*C*D1**2*f**2*fd*r - 990*C*D1**2*f**2*fd - 3960*C*D1*Dd*f**3*r**2 + 1980*C*D1*Dd*f**3*r - 990*C*D1*Dd*f**3 - 10164*D1**2*K*bd1**2*f*r**2 - 36960*D1**2*K*bd1**2*f*r*s + 47586*D1**2*K*bd1**2*f*r - 21252*D1**2*K*bd1**2*f*s**2 + 53130*D1**2*K*bd1**2*f*s - 31878*D1**2*K*bd1**2*f + 23628*D1**2*K*bd1*f**2*r**2 + 21714*D1**2*K*bd1*f**2*r*s - 21714*D1**2*K*bd1*f**2*r + 6303*D1**2*K*bd1*f**2*s**2 - 12606*D1**2*K*bd1*f**2*s + 6303*D1**2*K*bd1*f**2 - 64812*D1**2*K*bd1*f*fd*r**2 - 109032*D1**2*K*bd1*f*fd*r*s + 86922*D1**2*K*bd1*f*fd*r - 31548*D1**2*K*bd1*f*fd*s**2 + 58806*D1**2*K*bd1*f*fd*s - 27258*D1**2*K*bd1*f*fd - 16203*D1**2*K*bdd1*f**2*r**2 - 27258*D1**2*K*bdd1*f**2*r*s + 27258*D1**2*K*bdd1*f**2*r - 7887*D1**2*K*bdd1*f**2*s**2 + 15774*D1**2*K*bdd1*f**2*s - 7887*D1**2*K*bdd1*f**2 + 12870*D1**2*bd1**2*f**2*r**2 + 57222*D1**2*bd1**2*f**2*r*s - 39699*D1**2*bd1**2*f**2*r + 44352*D1**2*bd1**2*f**2*s**2 - 64845*D1**2*bd1**2*f**2*s + 26631*D1**2*bd1**2*f**2 + 12936*D1**2*bd1**2*f*r**2 + 59598*D1**2*bd1**2*f*r*s - 55209*D1**2*bd1**2*f*r + 41118*D1**2*bd1**2*f*s**2 - 81081*D1**2*bd1**2*f*s + 39963*D1**2*bd1**2*f - 32340*D1**2*bd1**2*g2*r**2 - 64680*D1**2*bd1**2*g2*r*s + 32340*D1**2*bd1**2*g2*r - 32340*D1**2*bd1**2*g2*s**2 + 32340*D1**2*bd1**2*g2*s - 11550*D1**2*bd1*bd2*f*r**2 - 23100*D1**2*bd1*bd2*f*r*s + 23100*D1**2*bd1*bd2*f*r - 11550*D1**2*bd1*bd2*f*s**2 + 23100*D1**2*bd1*bd2*f*s - 11550*D1**2*bd1*bd2*f - 10131*D1**2*bd1*f**3*r**2 - 16940*D1**2*bd1*f**3*r*s + 17435*D1**2*bd1*f**3*r - 2079*D1**2*bd1*f**3*s**2 + 10395*D1**2*bd1*f**3*s - 8305*D1**2*bd1*f**3 + 50886*D1**2*bd1*f**2*fd*r**2 + 116160*D1**2*bd1*f**2*fd*r*s - 95392*D1**2*bd1*f**2*fd*r + 30294*D1**2*bd1*f**2*fd*s**2 - 68266*D1**2*bd1*f**2*fd*s + 26895*D1**2*bd1*f**2*fd - 20196*D1**2*bd1*f**2*r**2 - 26697*D1**2*bd1*f**2*r*s + 18381*D1**2*bd1*f**2*r - 10164*D1**2*bd1*f**2*s**2 + 18942*D1**2*bd1*f**2*s - 7392*D1**2*bd1*f**2 + 48708*D1**2*bd1*f*fd*r**2 + 119460*D1**2*bd1*f*fd*r*s - 84084*D1**2*bd1*f*fd*r + 57288*D1**2*bd1*f*fd*s**2 - 87153*D1**2*bd1*f*fd*s + 29865*D1**2*bd1*f*fd + 5082*D1**2*bd1*f*g2*r**2 + 51744*D1**2*bd1*f*g2*r - 24024*D1**2*bd1*f*g2*s**2 + 30492*D1**2*bd1*f*g2*s - 25872*D1**2*bd1*f*g2 + 20328*D1**2*bd1*f*gd2*r**2 + 73920*D1**2*bd1*f*gd2*r*s - 95172*D1**2*bd1*f*gd2*r + 42504*D1**2*bd1*f*gd2*s**2 - 106260*D1**2*bd1*f*gd2*s + 63756*D1**2*bd1*f*gd2 + 20328*D1**2*bd1*fd*g2*r**2 + 73920*D1**2*bd1*fd*g2*r*s - 20328*D1**2*bd1*fd*g2*r + 42504*D1**2*bd1*fd*g2*s**2 - 36960*D1**2*bd1*fd*g2*s + 6831*D1**2*bd2*f**2*r**2 + 8910*D1**2*bd2*f**2*r*s - 8910*D1**2*bd2*f**2*r + 2079*D1**2*bd2*f**2*s**2 - 4158*D1**2*bd2*f**2*s + 2079*D1**2*bd2*f**2 - 23364*D1**2*bd2*f*fd*r**2 - 37224*D1**2*bd2*f*fd*r*s + 30294*D1**2*bd2*f*fd*r - 13860*D1**2*bd2*f*fd*s**2 + 23166*D1**2*bd2*f*fd*s - 9306*D1**2*bd2*f*fd + 8481*D1**2*bdd1*f**3*r**2 + 19360*D1**2*bdd1*f**3*r*s - 19855*D1**2*bdd1*f**3*r + 5049*D1**2*bdd1*f**3*s**2 - 14355*D1**2*bdd1*f**3*s + 10835*D1**2*bdd1*f**3 + 12177*D1**2*bdd1*f**2*r**2 + 29865*D1**2*bdd1*f**2*r*s - 29865*D1**2*bdd1*f**2*r + 14322*D1**2*bdd1*f**2*s**2 - 28644*D1**2*bdd1*f**2*s + 14322*D1**2*bdd1*f**2 + 10164*D1**2*bdd1*f*g2*r**2 + 36960*D1**2*bdd1*f*g2*r*s - 58212*D1**2*bdd1*f*g2*r + 21252*D1**2*bdd1*f*g2*s**2 - 63756*D1**2*bdd1*f*g2*s + 29106*D1**2*bdd1*f*g2 - 5841*D1**2*bdd2*f**2*r**2 - 9306*D1**2*bdd2*f**2*r*s + 9306*D1**2*bdd2*f**2*r - 3465*D1**2*bdd2*f**2*s**2 + 6930*D1**2*bdd2*f**2*s - 3465*D1**2*bdd2*f**2 + 7580*D1**2*f**3*fd*r**2 + 33660*D1**2*f**3*fd*r*s - 20620*D1**2*f**3*fd*r + 35640*D1**2*f**3*fd*s**2 - 44055*D1**2*f**3*fd*s + 19715*D1**2*f**3*fd - 4780*D1**2*f**3*fdd*r**2 - 33660*D1**2*f**3*fdd*r*s + 19220*D1**2*f**3*fdd*r - 35640*D1**2*f**3*fdd*s**2 + 44055*D1**2*f**3*fdd*s - 19015*D1**2*f**3*fdd - 14340*D1**2*f**2*fd**2*r**2 - 100980*D1**2*f**2*fd**2*r*s + 57660*D1**2*f**2*fd**2*r - 106920*D1**2*f**2*fd**2*s**2 + 132165*D1**2*f**2*fd**2*s - 34650*D1**2*f**2*fd**2 + 5940*D1**2*f**2*fd*r**2 + 2970*D1**2*f**2*fd*r*s - 4950*D1**2*f**2*fd*r - 990*D1**2*f**2*fd*s + 1980*D1**2*f**2*fd - 47256*D1**2*f**2*gd2*r**2 - 43428*D1**2*f**2*gd2*r*s + 43428*D1**2*f**2*gd2*r - 12606*D1**2*f**2*gd2*s**2 + 25212*D1**2*f**2*gd2*s - 12606*D1**2*f**2*gd2 + 32406*D1**2*f**2*gdd2*r**2 + 54516*D1**2*f**2*gdd2*r*s - 54516*D1**2*f**2*gdd2*r + 15774*D1**2*f**2*gdd2*s**2 - 31548*D1**2*f**2*gdd2*s + 15774*D1**2*f**2*gdd2 - 94512*D1**2*f*fd*g2*r**2 - 86856*D1**2*f*fd*g2*r*s + 94512*D1**2*f*fd*g2*r - 25212*D1**2*f*fd*g2*s**2 + 43428*D1**2*f*fd*g2*s - 47256*D1**2*f*fd*g2 + 129624*D1**2*f*fd*gd2*r**2 + 218064*D1**2*f*fd*gd2*r*s - 173844*D1**2*f*fd*gd2*r + 63096*D1**2*f*fd*gd2*s**2 - 117612*D1**2*f*fd*gd2*s + 54516*D1**2*f*fd*gd2 + 64812*D1**2*f*fdd*g2*r**2 + 109032*D1**2*f*fdd*g2*r*s - 64812*D1**2*f*fdd*g2*r + 31548*D1**2*f*fdd*g2*s**2 - 54516*D1**2*f*fdd*g2*s + 32406*D1**2*f*fdd*g2 + 64812*D1**2*fd**2*g2*r**2 + 109032*D1**2*fd**2*g2*r*s - 64812*D1**2*fd**2*g2*r + 31548*D1**2*fd**2*g2*s**2 - 54516*D1**2*fd**2*g2*s - 129624*D1*Dd*K*bd1*f**2*r**2 - 218064*D1*Dd*K*bd1*f**2*r*s + 195954*D1*Dd*K*bd1*f**2*r - 63096*D1*Dd*K*bd1*f**2*s**2 + 121902*D1*Dd*K*bd1*f**2*s - 58806*D1*Dd*K*bd1*f**2 + 67848*D1*Dd*bd1*f**3*r**2 + 154880*D1*Dd*bd1*f**3*r*s - 135102*D1*Dd*bd1*f**3*r + 40392*D1*Dd*bd1*f**3*s**2 - 96976*D1*Dd*bd1*f**3*s + 48565*D1*Dd*bd1*f**3 + 97416*D1*Dd*bd1*f**2*r**2 + 238920*D1*Dd*bd1*f**2*r*s - 203544*D1*Dd*bd1*f**2*r + 114576*D1*Dd*bd1*f**2*s**2 - 201729*D1*Dd*bd1*f**2*s + 87153*D1*Dd*bd1*f**2 + 81312*D1*Dd*bd1*f*g2*r**2 + 295680*D1*Dd*bd1*f*g2*r*s - 327096*D1*Dd*bd1*f*g2*r + 170016*D1*Dd*bd1*f*g2*s**2 - 376992*D1*Dd*bd1*f*g2*s + 185724*D1*Dd*bd1*f*g2 - 46728*D1*Dd*bd2*f**2*r**2 - 74448*D1*Dd*bd2*f**2*r*s + 67518*D1*Dd*bd2*f**2*r - 27720*D1*Dd*bd2*f**2*s**2 + 50886*D1*Dd*bd2*f**2*s - 23166*D1*Dd*bd2*f**2 + 7580*D1*Dd*f**4*r**2 + 33660*D1*Dd*f**4*r*s - 20620*D1*Dd*f**4*r + 35640*D1*Dd*f**4*s**2 - 44055*D1*Dd*f**4*s + 19715*D1*Dd*f**4 - 38240*D1*Dd*f**3*fd*r**2 - 269280*D1*Dd*f**3*fd*r*s + 153760*D1*Dd*f**3*fd*r - 285120*D1*Dd*f**3*fd*s**2 + 352440*D1*Dd*f**3*fd*s - 107330*D1*Dd*f**3*fd + 7920*D1*Dd*f**3*r**2 + 3960*D1*Dd*f**3*r*s - 5940*D1*Dd*f**3*r - 990*D1*Dd*f**3*s + 1980*D1*Dd*f**3 - 189024*D1*Dd*f**2*g2*r**2 - 173712*D1*Dd*f**2*g2*r*s + 181368*D1*Dd*f**2*g2*r - 50424*D1*Dd*f**2*g2*s**2 + 93852*D1*Dd*f**2*g2*s - 72468*D1*Dd*f**2*g2 + 259248*D1*Dd*f**2*gd2*r**2 + 436128*D1*Dd*f**2*gd2*r*s - 391908*D1*Dd*f**2*gd2*r + 126192*D1*Dd*f**2*gd2*s**2 - 243804*D1*Dd*f**2*gd2*s + 117612*D1*Dd*f**2*gd2 + 518496*D1*Dd*f*fd*g2*r**2 + 872256*D1*Dd*f*fd*g2*r*s - 606936*D1*Dd*f*fd*g2*r + 252384*D1*Dd*f*fd*g2*s**2 - 453288*D1*Dd*f*fd*g2*s + 173844*D1*Dd*f*fd*g2 - 4780*D1*Ddd*f**4*r**2 - 33660*D1*Ddd*f**4*r*s + 19220*D1*Ddd*f**4*r - 35640*D1*Ddd*f**4*s**2 + 44055*D1*Ddd*f**4*s - 19015*D1*Ddd*f**4 + 129624*D1*Ddd*f**2*g2*r**2 + 218064*D1*Ddd*f**2*g2*r*s - 173844*D1*Ddd*f**2*g2*r + 63096*D1*Ddd*f**2*g2*s**2 - 117612*D1*Ddd*f**2*g2*s + 63954*D1*Ddd*f**2*g2 - 14340*Dd**2*f**4*r**2 - 100980*Dd**2*f**4*r*s + 57660*Dd**2*f**4*r - 106920*Dd**2*f**4*s**2 + 132165*Dd**2*f**4*s - 34650*Dd**2*f**4 + 388872*Dd**2*f**2*g2*r**2 + 654192*Dd**2*f**2*g2*r*s - 521532*Dd**2*f**2*g2*r + 189288*Dd**2*f**2*g2*s**2 - 352836*Dd**2*f**2*g2*s + 140580*Dd**2*f**2*g2 + 1155*b1**3*(D1**2*(fd*(r + 3*s - 3) + fdd*(-3*r - 5*s + 5))*(r + s - 1) + D1*(Dd*(-20*K*r**2 + 8*K*r*s + 6*K*r + 28*K*s**2 - 30*K*s + 9*K + f*(4*r**2 + 2*r*(8*s - 5) + 12*s**2 - 16*s + 7) - 2*fd*(12*r**2 + 32*r*s - 27*r + 20*s**2 - 34*s + 14) + 4*r**2 - 24*r*s + 10*r - 28*s**2 + 34*s - 13) - Ddd*(-7*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(12*r**2 + r*(32*s - 22) + 20*s**2 - 28*s + 13) + 20*r**2 + 48*r*s - 34*r + 28*s**2 - 40*s + 19)) - 2*Dd**2*(-21*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(18*r**2 + r*(48*s - 33) + 30*s**2 - 42*s + 13) + 30*r**2 + 72*r*s - 51*r + 42*s**2 - 60*s + 19)) + 33*b1**2*(280*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 1120*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 1120*C*D1*Dd*f*r - 280*C*D1*Dd*f*s + 280*C*D1*Dd*f - 77*D1**2*K*fd*r**2 + 938*D1**2*K*fd*r + 364*D1**2*K*fd*s**2 + 462*D1**2*K*fd*s - 469*D1**2*K*fd - 154*D1**2*K*fdd*r**2 - 560*D1**2*K*fdd*r*s - 574*D1**2*K*fdd*r - 322*D1**2*K*fdd*s**2 - 406*D1**2*K*fdd*s + 287*D1**2*K*fdd - 35*D1**2*bdd1*(-7*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(9*r**2 + 2*r*(12*s - 7) + 15*s**2 - 18*s + 8) + 15*r**2 + 36*r*s - 22*r + 21*s**2 - 26*s + 12) - 318*D1**2*f*fd*r**2 - 1494*D1**2*f*fd*r*s + 729*D1**2*f*fd*r - 1176*D1**2*f*fd*s**2 + 1374*D1**2*f*fd*s - 660*D1**2*f*fd + 390*D1**2*f*fdd*r**2 + 1734*D1**2*f*fdd*r*s - 921*D1**2*f*fdd*r + 1344*D1**2*f*fdd*s**2 - 1590*D1**2*f*fdd*s + 792*D1**2*f*fdd + 390*D1**2*fd**2*r**2 + 1734*D1**2*fd**2*r*s - 921*D1**2*fd**2*r + 1344*D1**2*fd**2*s**2 - 1590*D1**2*fd**2*s + 246*D1**2*fd**2 - 427*D1**2*fd*r**2 - 651*D1**2*fd*r*s - 336*D1**2*fd*r - 511*D1**2*fd*s**2 - 266*D1**2*fd*s + 273*D1**2*fd + 196*D1**2*fdd*r**2 + 903*D1**2*fdd*r*s + 378*D1**2*fdd*r + 623*D1**2*fdd*s**2 + 308*D1**2*fdd*s - 189*D1**2*fdd + 350*D1**2*gd2*r**2 - 140*D1**2*gd2*r*s + 140*D1**2*gd2*r - 490*D1**2*gd2*s**2 + 980*D1**2*gd2*s - 490*D1**2*gd2 - 490*D1**2*gdd2*r**2 - 980*D1**2*gdd2*r*s + 980*D1**2*gdd2*r - 490*D1**2*gdd2*s**2 + 980*D1**2*gdd2*s - 490*D1**2*gdd2 - 308*D1*Dd*K*f*r**2 + 154*D1*Dd*K*f*r + 1456*D1*Dd*K*f*s**2 - 1456*D1*Dd*K*f*s + 651*D1*Dd*K*f - 1232*D1*Dd*K*fd*r**2 - 4480*D1*Dd*K*fd*r*s - 868*D1*Dd*K*fd*r - 2576*D1*Dd*K*fd*s**2 + 224*D1*Dd*K*fd*s + 1386*D1*Dd*K*fd - 636*D1*Dd*f**2*r**2 - 2988*D1*Dd*f**2*r*s + 1812*D1*Dd*f**2*r - 2352*D1*Dd*f**2*s**2 + 3099*D1*Dd*f**2*s - 1335*D1*Dd*f**2 + 3120*D1*Dd*f*fd*r**2 + 13872*D1*Dd*f*fd*r*s - 7932*D1*Dd*f*fd*r + 10752*D1*Dd*f*fd*s**2 - 13470*D1*Dd*f*fd*s + 4101*D1*Dd*f*fd - 1708*D1*Dd*f*r**2 - 2604*D1*Dd*f*r*s + 2156*D1*Dd*f*r - 2044*D1*Dd*f*s**2 + 2695*D1*Dd*f*s - 1449*D1*Dd*f + 1568*D1*Dd*fd*r**2 + 7224*D1*Dd*fd*r*s - 686*D1*Dd*fd*r + 4984*D1*Dd*fd*s**2 - 2163*D1*Dd*fd*s - 994*D1*Dd*fd + 1400*D1*Dd*g2*r**2 - 560*D1*Dd*g2*r*s - 420*D1*Dd*g2*r - 1960*D1*Dd*g2*s**2 + 2100*D1*Dd*g2*s - 630*D1*Dd*g2 - 3920*D1*Dd*gd2*r**2 - 7840*D1*Dd*gd2*r*s + 6860*D1*Dd*gd2*r - 3920*D1*Dd*gd2*s**2 + 6860*D1*Dd*gd2*s - 2940*D1*Dd*gd2 - 616*D1*Ddd*K*f*r**2 - 2240*D1*Ddd*K*f*r*s + 1428*D1*Ddd*K*f*r - 1288*D1*Ddd*K*f*s**2 + 1848*D1*Ddd*K*f*s - 798*D1*Ddd*K*f + 780*D1*Ddd*f**2*r**2 + 3468*D1*Ddd*f**2*r*s - 2124*D1*Ddd*f**2*r + 2688*D1*Ddd*f**2*s**2 - 3555*D1*Ddd*f**2*s + 1539*D1*Ddd*f**2 + 784*D1*Ddd*f*r**2 + 3612*D1*Ddd*f*r*s - 2198*D1*Ddd*f*r + 2492*D1*Ddd*f*s**2 - 3395*D1*Ddd*f*s + 1442*D1*Ddd*f - 1960*D1*Ddd*g2*r**2 - 3920*D1*Ddd*g2*r*s + 2940*D1*Ddd*g2*r - 1960*D1*Ddd*g2*s**2 + 2940*D1*Ddd*g2*s - 1470*D1*Ddd*g2 + 35*D1*bd1*(D1*(-15*K*r**2 + 6*K*r*s + 8*K*r + 21*K*s**2 - 16*K*s + 2*K + f*(3*r**2 + 6*r*(2*s - 1) + 9*s**2 - 10*s + 4) - 2*fd*(9*r**2 + 24*r*s - 19*r + 15*s**2 - 24*s + 9) + 3*r**2 - 18*r*s + 4*r - 21*s**2 + 20*s - 6) - 2*Dd*(-7*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(36*r**2 + r*(96*s - 61) + 60*s**2 - 78*s + 25) + 60*r**2 + 144*r*s - 95*r + 84*s**2 - 112*s + 37)) - 1848*Dd**2*K*f*r**2 - 6720*Dd**2*K*f*r*s + 4284*Dd**2*K*f*r - 3864*Dd**2*K*f*s**2 + 5544*Dd**2*K*f*s - 1764*Dd**2*K*f + 2340*Dd**2*f**2*r**2 + 10404*Dd**2*f**2*r*s - 6372*Dd**2*f**2*r + 8064*Dd**2*f**2*s**2 - 10665*Dd**2*f**2*s + 3078*Dd**2*f**2 + 2352*Dd**2*f*r**2 + 10836*Dd**2*f*r*s - 6594*Dd**2*f*r + 7476*Dd**2*f*s**2 - 10185*Dd**2*f*s + 3052*Dd**2*f - 5880*Dd**2*g2*r**2 - 11760*Dd**2*g2*r*s + 8820*Dd**2*g2*r - 5880*Dd**2*g2*s**2 + 8820*Dd**2*g2*s - 2940*Dd**2*g2) - 11*b1*(-756*C*D1**2*f*fd*r**2 - 1008*C*D1**2*f*fd*r*s + 1512*C*D1**2*f*fd*r + 504*C*D1**2*f*fd*s - 504*C*D1**2*f*fd - 1512*C*D1*Dd*f**2*r**2 - 2016*C*D1*Dd*f**2*r*s + 1764*C*D1*Dd*f**2*r + 504*C*D1*Dd*f**2*s - 378*C*D1*Dd*f**2 + 924*D1**2*K*bdd1*f*r**2 + 3360*D1**2*K*bdd1*f*r*s - 4326*D1**2*K*bdd1*f*r + 1932*D1**2*K*bdd1*f*s**2 - 4830*D1**2*K*bdd1*f*s + 2289*D1**2*K*bdd1*f - 4296*D1**2*K*f*fd*r**2 - 3948*D1**2*K*f*fd*r*s + 4296*D1**2*K*f*fd*r - 1146*D1**2*K*f*fd*s**2 + 1974*D1**2*K*f*fd*s - 2148*D1**2*K*f*fd + 2946*D1**2*K*f*fdd*r**2 + 4956*D1**2*K*f*fdd*r*s - 2946*D1**2*K*f*fdd*r + 1434*D1**2*K*f*fdd*s**2 - 2478*D1**2*K*f*fdd*s + 1473*D1**2*K*f*fdd + 2946*D1**2*K*fd**2*r**2 + 4956*D1**2*K*fd**2*r*s - 2946*D1**2*K*fd**2*r + 1434*D1**2*K*fd**2*s**2 - 2478*D1**2*K*fd**2*s - 315*D1**2*b2*fd*r**2 - 630*D1**2*b2*fd*r*s - 315*D1**2*b2*fd*s**2 + 525*D1**2*b2*fdd*r**2 + 1050*D1**2*b2*fdd*r*s + 525*D1**2*b2*fdd*s**2 + 210*D1**2*bd1**2*(-7*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(9*r**2 + 2*r*(12*s - 7) + 15*s**2 - 18*s + 4) + 15*r**2 + 36*r*s - 22*r + 21*s**2 - 26*s + 6) - 1170*D1**2*bdd1*f**2*r**2 - 5202*D1**2*bdd1*f**2*r*s + 3609*D1**2*bdd1*f**2*r - 4032*D1**2*bdd1*f**2*s**2 + 5895*D1**2*bdd1*f**2*s - 2241*D1**2*bdd1*f**2 - 1176*D1**2*bdd1*f*r**2 - 5418*D1**2*bdd1*f*r*s + 5019*D1**2*bdd1*f*r - 3738*D1**2*bdd1*f*s**2 + 7371*D1**2*bdd1*f*s - 3024*D1**2*bdd1*f + 2940*D1**2*bdd1*g2*r**2 + 5880*D1**2*bdd1*g2*r*s - 2940*D1**2*bdd1*g2*r + 2940*D1**2*bdd1*g2*s**2 - 2940*D1**2*bdd1*g2*s + 1470*D1**2*bdd1*g2 + 525*D1**2*bdd2*f*r**2 + 1050*D1**2*bdd2*f*r*s - 1050*D1**2*bdd2*f*r + 525*D1**2*bdd2*f*s**2 - 1050*D1**2*bdd2*f*s + 525*D1**2*bdd2*f + 2763*D1**2*f**2*fd*r**2 + 4620*D1**2*f**2*fd*r*s - 3337*D1**2*f**2*fd*r + 567*D1**2*f**2*fd*s**2 - 1351*D1**2*f**2*fd*s + 544*D1**2*f**2*fd - 2313*D1**2*f**2*fdd*r**2 - 5280*D1**2*f**2*fdd*r*s + 3257*D1**2*f**2*fdd*r - 1377*D1**2*f**2*fdd*s**2 + 2291*D1**2*f**2*fdd*s - 704*D1**2*f**2*fdd - 4626*D1**2*f*fd**2*r**2 - 10560*D1**2*f*fd**2*r*s + 6514*D1**2*f*fd**2*r - 2754*D1**2*f*fd**2*s**2 + 4582*D1**2*f*fd**2*s - 1993*D1**2*f*fd**2 + 3672*D1**2*f*fd*r**2 + 4854*D1**2*f*fd*r*s - 4428*D1**2*f*fd*r + 1848*D1**2*f*fd*s**2 - 2553*D1**2*f*fd*s + 2088*D1**2*f*fd - 2214*D1**2*f*fdd*r**2 - 5430*D1**2*f*fdd*r*s + 2214*D1**2*f*fdd*r - 2604*D1**2*f*fdd*s**2 + 2715*D1**2*f*fdd*s - 1107*D1**2*f*fdd - 462*D1**2*f*gd2*r**2 + 2184*D1**2*f*gd2*s**2 - 4368*D1**2*f*gd2*s + 2184*D1**2*f*gd2 - 924*D1**2*f*gdd2*r**2 - 3360*D1**2*f*gdd2*r*s + 3360*D1**2*f*gdd2*r - 1932*D1**2*f*gdd2*s**2 + 3864*D1**2*f*gdd2*s - 1932*D1**2*f*gdd2 - 2214*D1**2*fd**2*r**2 - 5430*D1**2*fd**2*r*s + 2214*D1**2*fd**2*r - 2604*D1**2*fd**2*s**2 + 2715*D1**2*fd**2*s - 462*D1**2*fd*g2*r**2 + 5628*D1**2*fd*g2*r + 2184*D1**2*fd*g2*s**2 + 2772*D1**2*fd*g2*s - 2814*D1**2*fd*g2 - 1848*D1**2*fd*gd2*r**2 - 6720*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*r - 3864*D1**2*fd*gd2*s**2 + 1428*D1**2*fd*gd2*s + 2436*D1**2*fd*gd2 - 924*D1**2*fdd*g2*r**2 - 3360*D1**2*fdd*g2*r*s - 3444*D1**2*fdd*g2*r - 1932*D1**2*fdd*g2*s**2 - 2436*D1**2*fdd*g2*s + 1722*D1**2*fdd*g2 - 8592*D1*Dd*K*f**2*r**2 - 7896*D1*Dd*K*f**2*r*s + 8244*D1*Dd*K*f**2*r - 2292*D1*Dd*K*f**2*s**2 + 4266*D1*Dd*K*f**2*s - 3294*D1*Dd*K*f**2 + 23568*D1*Dd*K*f*fd*r**2 + 39648*D1*Dd*K*f*fd*r*s - 27588*D1*Dd*K*f*fd*r + 11472*D1*Dd*K*f*fd*s**2 - 20604*D1*Dd*K*f*fd*s + 7902*D1*Dd*K*f*fd - 1260*D1*Dd*b2*f*r**2 - 2520*D1*Dd*b2*f*r*s + 1890*D1*Dd*b2*f*r - 1260*D1*Dd*b2*f*s**2 + 1890*D1*Dd*b2*f*s - 945*D1*Dd*b2*f + 4200*D1*Dd*b2*fd*r**2 + 8400*D1*Dd*b2*fd*r*s - 3150*D1*Dd*b2*fd*r + 4200*D1*Dd*b2*fd*s**2 - 3150*D1*Dd*b2*fd*s + 3684*D1*Dd*f**3*r**2 + 6160*D1*Dd*f**3*r*s - 4922*D1*Dd*f**3*r + 756*D1*Dd*f**3*s**2 - 2296*D1*Dd*f**3*s + 1299*D1*Dd*f**3 - 18504*D1*Dd*f**2*fd*r**2 - 42240*D1*Dd*f**2*fd*r*s + 28214*D1*Dd*f**2*fd*r - 11016*D1*Dd*f**2*fd*s**2 + 19952*D1*Dd*f**2*fd*s - 7839*D1*Dd*f**2*fd + 7344*D1*Dd*f**2*r**2 + 9708*D1*Dd*f**2*r*s - 8526*D1*Dd*f**2*r + 3696*D1*Dd*f**2*s**2 - 6123*D1*Dd*f**2*s + 3684*D1*Dd*f**2 - 17712*D1*Dd*f*fd*r**2 - 43440*D1*Dd*f*fd*r*s + 24144*D1*Dd*f*fd*r - 20832*D1*Dd*f*fd*s**2 + 26706*D1*Dd*f*fd*s - 7644*D1*Dd*f*fd - 1848*D1*Dd*f*g2*r**2 + 924*D1*Dd*f*g2*r + 8736*D1*Dd*f*g2*s**2 - 8736*D1*Dd*f*g2*s + 3906*D1*Dd*f*g2 - 7392*D1*Dd*f*gd2*r**2 - 26880*D1*Dd*f*gd2*r*s + 22008*D1*Dd*f*gd2*r - 15456*D1*Dd*f*gd2*s**2 + 26544*D1*Dd*f*gd2*s - 11088*D1*Dd*f*gd2 - 7392*D1*Dd*fd*g2*r**2 - 26880*D1*Dd*fd*g2*r*s - 5208*D1*Dd*fd*g2*r - 15456*D1*Dd*fd*g2*s**2 + 1344*D1*Dd*fd*g2*s + 8316*D1*Dd*fd*g2 + 5892*D1*Ddd*K*f**2*r**2 + 9912*D1*Ddd*K*f**2*r*s - 7902*D1*Ddd*K*f**2*r + 2868*D1*Ddd*K*f**2*s**2 - 5346*D1*Ddd*K*f**2*s + 2907*D1*Ddd*K*f**2 + 2100*D1*Ddd*b2*f*r**2 + 4200*D1*Ddd*b2*f*r*s - 3150*D1*Ddd*b2*f*r + 2100*D1*Ddd*b2*f*s**2 - 3150*D1*Ddd*b2*f*s + 1575*D1*Ddd*b2*f - 3084*D1*Ddd*f**3*r**2 - 7040*D1*Ddd*f**3*r*s + 5062*D1*Ddd*f**3*r - 1836*D1*Ddd*f**3*s**2 + 3596*D1*Ddd*f**3*s - 1689*D1*Ddd*f**3 - 4428*D1*Ddd*f**2*r**2 - 10860*D1*Ddd*f**2*r*s + 7644*D1*Ddd*f**2*r - 5208*D1*Ddd*f**2*s**2 + 7923*D1*Ddd*f**2*s - 3711*D1*Ddd*f**2 - 3696*D1*Ddd*f*g2*r**2 - 13440*D1*Ddd*f*g2*r*s + 8568*D1*Ddd*f*g2*r - 7728*D1*Ddd*f*g2*s**2 + 11088*D1*Ddd*f*g2*s - 4788*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(3*f**2*(106*r**2 + r*(498*s - 361) + 392*s**2 - 575*s + 225) + f*(-280*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 14*K*(11*r**2 + 56*r - 52*s**2 + 85*s - 54) - 3*fd*(520*r**2 + 8*r*(289*s - 177) + 1792*s**2 - 2370*s + 675) + 854*r**2 + 1302*r*s - 1841*r + 1022*s**2 - 1939*s + 1211) + 7*fd*(2*K*(44*r**2 + r*(160*s - 21) + 92*s**2 - 57*s - 29) - 112*r**2 + r*(131 - 516*s) - 356*s**2 + 263*s + 44) - 70*g2*(10*r**2 - 2*r*(2*s + 5) - 14*s**2 + 2*s + 5) + 980*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*(-3*f**2*(1040*r**2 + 4*r*(1156*s - 755) + 3584*s**2 - 4990*s + 1711) + 7*f*(2*K*(176*r**2 + 8*r*(80*s - 77) + 368*s**2 - 724*s + 333) - 448*r**2 - 48*r*(43*s - 33) - 1424*s**2 + 2374*s - 941) + 980*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 105*D1*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 17676*Dd**2*K*f**2*r**2 + 29736*Dd**2*K*f**2*r*s - 23706*Dd**2*K*f**2*r + 8604*Dd**2*K*f**2*s**2 - 16038*Dd**2*K*f**2*s + 6390*Dd**2*K*f**2 + 6300*Dd**2*b2*f*r**2 + 12600*Dd**2*b2*f*r*s - 9450*Dd**2*b2*f*r + 6300*Dd**2*b2*f*s**2 - 9450*Dd**2*b2*f*s + 3150*Dd**2*b2*f - 9252*Dd**2*f**3*r**2 - 21120*Dd**2*f**3*r*s + 15186*Dd**2*f**3*r - 5508*Dd**2*f**3*s**2 + 10788*Dd**2*f**3*s - 4438*Dd**2*f**3 - 13284*Dd**2*f**2*r**2 - 32580*Dd**2*f**2*r*s + 22932*Dd**2*f**2*r - 15624*Dd**2*f**2*s**2 + 23769*Dd**2*f**2*s - 8034*Dd**2*f**2 - 11088*Dd**2*f*g2*r**2 - 40320*Dd**2*f*g2*r*s + 25704*Dd**2*f*g2*r - 23184*Dd**2*f*g2*s**2 + 33264*Dd**2*f*g2*s - 10584*Dd**2*f*g2) + 33*b2*(-175*D1**2*bdd1*f*(r + s - 1)**2 + 3*D1**2*(f*(3*fd*(46*r**2 + r*(60*s - 46) + 14*s**2 - 30*s + 23) - fdd*(118*r**2 + 2*r*(94*s - 59) + 70*s**2 - 94*s + 59)) - 2*fd**2*(59*r**2 + r*(94*s - 59) + s*(35*s - 47))) + 35*D1*bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 3*D1*f*(Dd*(3*f*(92*r**2 + 2*r*(60*s - 53) + 28*s**2 - 58*s + 37) - 2*fd*(472*r**2 + r*(752*s - 542) + 280*s**2 - 422*s + 153)) - Ddd*f*(236*r**2 + r*(376*s - 306) + 140*s**2 - 234*s + 129)) - 18*Dd**2*f**2*(118*r**2 + r*(188*s - 153) + 70*s**2 - 117*s + 43)))/(3465*d**2*k3**4) - 4*D1**2*Pk1*Pk3*ct**2*st**4*(42*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) - 3*b1*(D1**2*(f*(fd*(56*C - 46)*(2*s**2 - 2*s + 1) - fdd*(28*C - 23)*(2*s**2 - 2*s + 1) + s**2*(C - 1)*(-56*bd1 + 28*bdd1)) + 2*fd*s*(s - 1)*(28*bd1*(C - 1) + fd*(23 - 28*C))) + 2*D1*f*(Dd*f*(56*C - 46)*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(-28*bd1*s*(C - 1) + fd*(28*C - 23)*(2*s - 1)) - Ddd*f*(28*C - 23)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(46 - 56*C)*(6*s**2 - 6*s + 1)) + f*(D1**2*(-84*bd1**2*s**2*(C - 1) + 6*bd1*fd*s*(28*C - 23)*(2*s - 1) - f*fd*(60*C - 50)*(3*s**2 - 2*s + 1) + f*fdd*(30*C - 25)*(3*s**2 - 2*s + 1) - f*s**2*(28*C - 23)*(6*bd1 - 3*bdd1) + fd**2*s*(60*C - 50)*(3*s - 2)) - 2*D1*f*(Dd*f*(60*C - 50)*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(3*bd1*s*(28*C - 23) + fd*(30*C - 25)*(3*s - 1)) - Ddd*f*(30*C - 25)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(60*C - 50)*(6*s**2 - 6*s + 1)))/(105*d**2*k3**2) + 2*D1**2*Pk1*Pk3*ct**2*st**2*(7*b1**2*(D1**2*(s - 1)*(fd*(48*C*r + 39*C*(s - 1) - 36*r - 39*s + 39) + fdd*(C*(-24*r - 37*s + 37) + 18*r + 37*s - 37)) + 2*D1*(Dd*(3*f*(C*(32*r*s - 16*r + 26*s**2 - 34*s + 13) - 24*r*s + 12*r - 26*s**2 + 32*s - 13) + fd*(-2*C*(48*r*s - 36*r + 74*s**2 - 117*s + 43) + 72*r*s - 54*r + 148*s**2 - 231*s + 83)) + Ddd*f*(C*(-48*r*s + 24*r - 74*s**2 + 86*s - 37) + 36*r*s - 18*r + 74*s**2 - 83*s + 37)) - 2*Dd**2*f*(C*(72*r*(2*s - 1) + 222*s**2 - 258*s + 61) - 54*r*(2*s - 1) - 222*s**2 + 249*s - 55)) + b1*(D1**2*(f*(-14*bdd1*s*(C*(24*r + 37*s - 12) - 18*r - 37*s + 9) + fd*(C*(56*r*(2*s - 1) - 738*s**2 + 514*s - 369) + 7*r*(4 - 8*s) + 714*s**2 - 546*s + 357) + fdd*(C*(614*s**2 - 446*s + 307) - 602*s**2 + 476*s - 301)) + 2*fd**2*(s - 1)*(C*(307*s + 84) - 301*s - 63)) + 14*D1*bd1*(D1*(3*f*s*(C*(16*r + 13*s - 8) - 12*r - 13*s + 6) + fd*(-2*C*(24*r*s - 12*r + 37*s**2 - 43*s + 6) + 36*r*s - 18*r + 74*s**2 - 83*s + 9)) - 2*Dd*f*(2*C*(48*r*s - 12*r + 74*s**2 - 55*s + 6) - 72*r*s + 18*r - 148*s**2 + 101*s - 9)) + 2*D1*f*(Dd*f*(C*(56*r*(2*s - 1) - 738*s**2 + 710*s - 369) + 7*r*(4 - 8*s) + 714*s**2 - 700*s + 357) + 2*Dd*fd*(2*s - 1)*(C*(614*s - 223) - 602*s + 238) + Ddd*f*(307*C - 301)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(614*C - 602)*(6*s**2 - 6*s + 1)) + f*(-14*D1**2*bd1**2*s*(C*(24*r + 37*s - 12) - 18*r - 37*s + 9) + D1**2*(f*(bdd1*s*(C*(307*s - 168) - 301*s + 126) - 2*fd*(C*(64*r*(3*s - 1) + 297*s**2 - 262*s + 99) - 138*r*s + 46*r - 303*s**2 + 248*s - 101) + 2*fdd*(C*(68*r*(3*s - 1) + 243*s**2 - 230*s + 81) - 141*r*s + 47*r - 246*s**2 + 211*s - 82)) + 2*fd**2*(2*C*(68*r*(3*s - 1) + 243*s**2 - 230*s + 34) - 94*r*(3*s - 1) - 492*s**2 + 422*s - 47)) + D1*bd1*(D1*(f*s*(C*(56*r - 369*s + 168) - 28*r + 357*s - 140) + 2*fd*(C*(614*s**2 - 391*s + 84) - 602*s**2 + 364*s - 63)) + 4*Dd*f*(2*s - 1)*(C*(307*s - 84) - 301*s + 63)) - 2*D1*f*(Dd*(2*f*(C*(64*r*(2*s - 1) + 198*s**2 - 230*s + 99) + r*(46 - 92*s) - 202*s**2 + 225*s - 101) + fd*(-8*C*(17*r*(12*s - 5) + 243*s**2 - 262*s + 66) + 94*r*(12*s - 5) + 1968*s**2 - 1969*s + 469)) + Ddd*f*(-2*C*(68*r*(2*s - 1) + 162*s**2 - 196*s + 81) + 94*r*(2*s - 1) + 328*s**2 - 375*s + 164)) + 2*Dd**2*f**2*(2*C*(204*r*(2*s - 1) + 486*s**2 - 588*s + 149) - 282*r*(2*s - 1) - 984*s**2 + 1125*s - 258)))/(105*d**2*k3**2) + D1**2*Pk1*Pk3*ct**2*(21*b1**2*(D1**2*(fd*(2*C*(5*r**2 - 30*r*(s - 1) - 36*(s - 1)**2) - 5*r**2 + 45*r*(s - 1) + 72*(s - 1)**2) + fdd*(2*C*(5*r**2 + 30*r*(s - 1) + 38*(s - 1)**2) - 5*r**2 - 45*r*(s - 1) - 76*(s - 1)**2)) + D1*(Dd*(f*(2*C*(20*r**2 + r*(50 - 120*s) - 144*s**2 + 174*s - 67) - 20*r**2 + 20*r*(9*s - 4) + 288*s**2 - 333*s + 139) + fd*(4*C*(20*r**2 + 5*r*(24*s - 19) + 152*s**2 - 243*s + 91) - 40*r**2 - 40*r*(9*s - 7) - 608*s**2 + 957*s - 349)) + Ddd*f*(2*C*(20*r**2 + 10*r*(12*s - 7) + 152*s**2 - 182*s + 81) - 20*r**2 - 20*r*(9*s - 5) - 304*s**2 + 349*s - 157)) + Dd**2*f*(4*C*(30*r**2 + 15*r*(12*s - 7) + 228*s**2 - 273*s + 68) - 60*r**2 - 60*r*(9*s - 5) - 912*s**2 + 1047*s - 242)) + 3*b1*(-304*C*D1**2*f*fd*r*s + 292*C*D1**2*f*fd*r + 328*C*D1**2*f*fd*s**2 + 244*C*D1**2*f*fd*s + 94*C*D1**2*f*fd + 208*C*D1**2*f*fdd*r*s - 244*C*D1**2*f*fdd*r - 304*C*D1**2*f*fdd*s**2 - 220*C*D1**2*f*fdd*s - 82*C*D1**2*f*fdd + 208*C*D1**2*fd**2*r*s - 244*C*D1**2*fd**2*r - 304*C*D1**2*fd**2*s**2 - 220*C*D1**2*fd**2*s + 524*C*D1**2*fd**2 - 608*C*D1*Dd*f**2*r*s + 304*C*D1*Dd*f**2*r + 656*C*D1*Dd*f**2*s**2 - 504*C*D1*Dd*f**2*s + 328*C*D1*Dd*f**2 + 1664*C*D1*Dd*f*fd*r*s - 1392*C*D1*Dd*f*fd*r - 2432*C*D1*Dd*f*fd*s**2 + 128*C*D1*Dd*f*fd*s + 684*C*D1*Dd*f*fd + 416*C*D1*Ddd*f**2*r*s - 208*C*D1*Ddd*f**2*r - 608*C*D1*Ddd*f**2*s**2 + 504*C*D1*Ddd*f**2*s - 304*C*D1*Ddd*f**2 + 1248*C*Dd**2*f**2*r*s - 624*C*Dd**2*f**2*r - 1824*C*Dd**2*f**2*s**2 + 1512*C*Dd**2*f**2*s - 96*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(2*C*(10*r**2 + 10*r*(6*s - 1) + 76*s**2 - 30*s + 5) - 10*r**2 + r*(10 - 90*s) - 152*s**2 + 45*s - 5) + 152*D1**2*f*fd*r*s - 146*D1**2*f*fd*r - 580*D1**2*f*fd*s**2 + 151*D1**2*f*fd*s - 255*D1**2*f*fd - 104*D1**2*f*fdd*r*s + 122*D1**2*f*fdd*r + 556*D1**2*f*fdd*s**2 - 163*D1**2*f*fdd*s + 243*D1**2*f*fdd - 104*D1**2*fd**2*r*s + 122*D1**2*fd**2*r + 556*D1**2*fd**2*s**2 - 163*D1**2*fd**2*s - 393*D1**2*fd**2 + 304*D1*Dd*f**2*r*s - 152*D1*Dd*f**2*r - 1160*D1*Dd*f**2*s**2 + 1084*D1*Dd*f**2*s - 580*D1*Dd*f**2 - 832*D1*Dd*f*fd*r*s + 696*D1*Dd*f*fd*r + 4448*D1*Dd*f*fd*s**2 - 2772*D1*Dd*f*fd*s + 204*D1*Dd*f*fd - 208*D1*Ddd*f**2*r*s + 104*D1*Ddd*f**2*r + 1112*D1*Ddd*f**2*s**2 - 1060*D1*Ddd*f**2*s + 556*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(2*C*(10*r**2 - 10*r*(6*s + 1) - 72*s**2 + 30*s + 5) - 10*r**2 + 10*r*(9*s + 1) + 144*s**2 - 45*s - 5) + fd*(4*C*(10*r**2 + 5*r*(12*s - 7) + 76*s**2 - 91*s + 15) - 20*r**2 - 20*r*(9*s - 5) - 304*s**2 + 349*s - 45)) + 2*Dd*f*(2*C*(40*r**2 + 30*r*(8*s - 3) + 304*s**2 - 242*s + 35) - 40*r**2 - 120*r*(3*s - 1) - 608*s**2 + 439*s - 50)) - 624*Dd**2*f**2*r*s + 312*Dd**2*f**2*r + 3336*Dd**2*f**2*s**2 - 3180*Dd**2*f**2*s + 452*Dd**2*f**2) + f*(978*C*D1**2*f*fd*r**2 + 3564*C*D1**2*f*fd*r*s - 1840*C*D1**2*f*fd*r + 2268*C*D1**2*f*fd*s**2 - 2700*C*D1**2*f*fd*s + 1082*C*D1**2*f*fd - 678*C*D1**2*f*fdd*r**2 - 3564*C*D1**2*f*fdd*r*s + 1640*C*D1**2*f*fdd*r - 2268*C*D1**2*f*fdd*s**2 + 2700*C*D1**2*f*fdd*s - 982*C*D1**2*f*fdd - 1356*C*D1**2*fd**2*r**2 - 7128*C*D1**2*fd**2*r*s + 3280*C*D1**2*fd**2*r - 4536*C*D1**2*fd**2*s**2 + 5400*C*D1**2*fd**2*s - 1188*C*D1**2*fd**2 + 1304*C*D1*Dd*f**2*r**2 + 4752*C*D1*Dd*f**2*r*s - 3028*C*D1*Dd*f**2*r + 3024*C*D1*Dd*f**2*s**2 - 4212*C*D1*Dd*f**2*s + 1838*C*D1*Dd*f**2 - 5424*C*D1*Dd*f*fd*r**2 - 28512*C*D1*Dd*f*fd*r*s + 15044*C*D1*Dd*f*fd*r - 18144*C*D1*Dd*f*fd*s**2 + 23436*C*D1*Dd*f*fd*s - 7040*C*D1*Dd*f*fd - 904*C*D1*Ddd*f**2*r**2 - 4752*C*D1*Ddd*f**2*r*s + 2828*C*D1*Ddd*f**2*r - 3024*C*D1*Ddd*f**2*s**2 + 4212*C*D1*Ddd*f**2*s - 1738*C*D1*Ddd*f**2 - 2712*C*Dd**2*f**2*r**2 - 14256*C*Dd**2*f**2*r*s + 8484*C*Dd**2*f**2*r - 9072*C*Dd**2*f**2*s**2 + 12636*C*Dd**2*f**2*s - 3888*C*Dd**2*f**2 + 21*D1**2*bd1**2*(r**2*(20*C - 10) + 10*r*(12*C*s - 2*C - 9*s + 1) + s*(152*C*s - 60*C - 152*s + 45)) + 3*D1**2*bdd1*f*(2*C*(52*r*s + 70*r - 76*s**2 + 210*s - 35) - 52*r*s - 70*r + 278*s**2 - 341*s + 35) - 489*D1**2*f*fd*r**2 - 2859*D1**2*f*fd*r*s + 1279*D1**2*f*fd*r - 3078*D1**2*f*fd*s**2 + 3005*D1**2*f*fd*s - 1189*D1**2*f*fd + 339*D1**2*f*fdd*r**2 + 2739*D1**2*f*fdd*r*s - 1139*D1**2*f*fdd*r + 3078*D1**2*f*fdd*s**2 - 2965*D1**2*f*fdd*s + 1139*D1**2*f*fdd + 678*D1**2*fd**2*r**2 + 5478*D1**2*fd**2*r*s - 2278*D1**2*fd**2*r + 6156*D1**2*fd**2*s**2 - 5930*D1**2*fd**2*s + 913*D1**2*fd**2 - 652*D1*Dd*f**2*r**2 - 3812*D1*Dd*f**2*r*s + 2232*D1*Dd*f**2*r - 4104*D1*Dd*f**2*s**2 + 5057*D1*Dd*f**2*s - 2215*D1*Dd*f**2 + 2712*D1*Dd*f*fd*r**2 + 21912*D1*Dd*f*fd*r*s - 10712*D1*Dd*f*fd*r + 24624*D1*Dd*f*fd*s**2 - 26911*D1*Dd*f*fd*s + 7069*D1*Dd*f*fd + 452*D1*Ddd*f**2*r**2 + 3652*D1*Ddd*f**2*r*s - 2052*D1*Ddd*f**2*r + 4104*D1*Ddd*f**2*s**2 - 5017*D1*Ddd*f**2*s + 2165*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(2*C*(76*r*s + 70*r - 82*s**2 + 210*s - 35) - 76*r*s - 70*r + 290*s**2 - 353*s + 35) + fd*(-4*C*(104*r*s + 9*r - 152*s**2 + 155*s - 105) + 208*r*s + 18*r - 1112*s**2 + 845*s - 341)) - 4*Dd*f*(C*(8*r*(26*s + 11) - 304*s**2 + 546*s - 245) - 4*r*(26*s + 11) + 556*s**2 - 606*s + 188)) + 1356*Dd**2*f**2*r**2 + 10956*Dd**2*f**2*r*s - 6156*Dd**2*f**2*r + 12312*Dd**2*f**2*s**2 - 15051*Dd**2*f**2*s + 3878*Dd**2*f**2))/(315*d**2*k3**2) + D1**2*Pk1*Pk3*ct**2*st**2*(16*C - 8)*(D1*f*s*(-14*D1*bd1**2*s - 3*D1*bdd1*f*s + 6*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*f*(2 - 4*s))) + 7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(6*fd*(2*s**2 - 2*s + 1) + fdd*(-6*s**2 + 6*s - 3) + s**2*(28*bd1 - 14*bdd1)) - 2*fd*s*(14*bd1 + 3*fd)*(s - 1)) + 2*D1*f*(6*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(14*bd1*s + fd*(6*s - 3)) - 3*Ddd*f*(2*s**2 - 2*s + 1)) - 6*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(35*d**2*k2**2) - D1**2*Pk1*Pk3*ct**2*(2*C - 1)*(D1*f*s*(-50*D1*bd1**2*s + 3*D1*bd1*(7*f*s + fd*(10 - 20*s)) - 15*D1*bdd1*f*s + 60*Dd*bd1*f*(1 - 2*s)) + 5*b1**2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + 2*D1*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(2*s**2 - 3*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(21*fd*(2*s**2 - 2*s + 1) + 5*fdd*(-6*s**2 + 6*s - 3) + s**2*(70*bd1 - 50*bdd1)) - 10*fd*s*(10*bd1 + 3*fd)*(s - 1)) + 2*D1*f*(21*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*(2*s - 1)*(10*bd1*s + fd*(6*s - 3)) - 15*Ddd*f*(2*s**2 - 2*s + 1)) - 30*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(15*d**2*k2**2) - 2*D1**2*Pk1*Pk3*ct**2*k2**4*st**4*(30*C*D1**2*b1*f*fd*r**2 + 48*C*D1**2*b1*f*fdd*r**2 + 48*C*D1**2*b1*fd**2*r**2 + 75*C*D1**2*f**2*fd*r**2 - 50*C*D1**2*f**2*fd*r + 25*C*D1**2*f**2*fd - 114*C*D1**2*f**2*fdd*r**2 + 76*C*D1**2*f**2*fdd*r - 38*C*D1**2*f**2*fdd - 228*C*D1**2*f*fd**2*r**2 + 152*C*D1**2*f*fd**2*r + 60*C*D1*Dd*b1*f**2*r**2 - 30*C*D1*Dd*b1*f**2*r + 15*C*D1*Dd*b1*f**2 + 384*C*D1*Dd*b1*f*fd*r**2 - 96*C*D1*Dd*b1*f*fd*r + 100*C*D1*Dd*f**3*r**2 - 50*C*D1*Dd*f**3*r + 25*C*D1*Dd*f**3 - 912*C*D1*Dd*f**2*fd*r**2 + 532*C*D1*Dd*f**2*fd*r - 76*C*D1*Dd*f**2*fd + 96*C*D1*Ddd*b1*f**2*r**2 - 48*C*D1*Ddd*b1*f**2*r + 24*C*D1*Ddd*b1*f**2 - 152*C*D1*Ddd*f**3*r**2 + 76*C*D1*Ddd*f**3*r - 38*C*D1*Ddd*f**3 + 288*C*Dd**2*b1*f**2*r**2 - 144*C*Dd**2*b1*f**2*r - 456*C*Dd**2*f**3*r**2 + 228*C*Dd**2*f**3*r - 174*D1**2*b1*f*fd*r**2 - 144*D1**2*b1*f*fd*r*s + 72*D1**2*b1*f*fd*r - 18*D1**2*b1*f*fdd*r**2 + 30*D1**2*b1*f*fdd*r*s - 15*D1**2*b1*f*fdd*r - 18*D1**2*b1*fd**2*r**2 + 30*D1**2*b1*fd**2*r*s - 15*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(r - 1)*(8*C*(r - 1) - 3*r + 5*s + 3) - 171*D1**2*f**2*fd*r**2 - 96*D1**2*f**2*fd*r*s + 146*D1**2*f**2*fd*r + 32*D1**2*f**2*fd*s - 57*D1**2*f**2*fd + 189*D1**2*f**2*fdd*r**2 + 75*D1**2*f**2*fdd*r*s - 151*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd*s + 63*D1**2*f**2*fdd + 378*D1**2*f*fd**2*r**2 + 150*D1**2*f*fd**2*r*s - 302*D1**2*f*fd**2*r - 50*D1**2*f*fd**2*s + 25*D1**2*f*fd**2 - 348*D1*Dd*b1*f**2*r**2 - 288*D1*Dd*b1*f**2*r*s + 318*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s - 87*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 + 240*D1*Dd*b1*f*fd*r*s - 84*D1*Dd*b1*f*fd*r - 30*D1*Dd*b1*f*fd*s + 15*D1*Dd*b1*f*fd - 228*D1*Dd*f**3*r**2 - 128*D1*Dd*f**3*r*s + 178*D1*Dd*f**3*r + 32*D1*Dd*f**3*s - 57*D1*Dd*f**3 + 1512*D1*Dd*f**2*fd*r**2 + 600*D1*Dd*f**2*fd*r*s - 1132*D1*Dd*f**2*fd*r - 175*D1*Dd*f**2*fd*s + 201*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 + 60*D1*Ddd*b1*f**2*r*s - 12*D1*Ddd*b1*f**2*r - 15*D1*Ddd*b1*f**2*s - 9*D1*Ddd*b1*f**2 + 252*D1*Ddd*f**3*r**2 + 100*D1*Ddd*f**3*r*s - 176*D1*Ddd*f**3*r - 25*D1*Ddd*f**3*s + 63*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(r - 1)*(5*C*(r - 1) - 29*r - 24*s + 29) + fd*(r**2*(32*C - 12) + r*(-32*C + 20*s + 7) - 10*s + 5)) + Dd*f*(16*C*(4*r**2 - 5*r + 1) - 24*r**2 + 40*r*s + 20*r - 25*s + 4)) - 108*Dd**2*b1*f**2*r**2 + 180*Dd**2*b1*f**2*r*s - 36*Dd**2*b1*f**2*r - 45*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 756*Dd**2*f**3*r**2 + 300*Dd**2*f**3*r*s - 528*Dd**2*f**3*r - 75*Dd**2*f**3*s + 50*Dd**2*f**3)/(105*d**2*k1**2*k3**4) + D1**2*Pk1*Pk3*ct**2*k2**4*st**2*(1188*C*D1**2*f**2*fd*r**2 - 792*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd + 1584*C*D1*Dd*f**3*r**2 - 792*C*D1*Dd*f**3*r + 396*C*D1*Dd*f**3 + 341*D1**2*K*bdd1*f**2*r**2 - 22*D1**2*bd1**2*f*(6*f*(4*r**2 + r*(4*s - 5) - 2*s + 1) + r*(49*K - 49)*(r - 1)) - 792*D1**2*bdd1*f**3*r**2 - 286*D1**2*bdd1*f**3*r*s + 836*D1**2*bdd1*f**3*r - 330*D1**2*bdd1*f**3*s - 264*D1**2*bdd1*f**3 - 869*D1**2*bdd1*f**2*r**2 - 528*D1**2*bdd1*f**2*r*s + 528*D1**2*bdd1*f**2*r + 1078*D1**2*bdd1*f*g2*r**2 - 2156*D1**2*bdd1*f*g2*r + 1078*D1**2*bdd1*f*g2 - 96*D1**2*f**3*fd*r**2 - 3080*D1**2*f**3*fd*r*s + 1588*D1**2*f**3*fd*r + 770*D1**2*f**3*fd*s - 24*D1**2*f**3*fd + 576*D1**2*f**3*fdd*r**2 + 3080*D1**2*f**3*fdd*r*s - 1828*D1**2*f**3*fdd*r - 770*D1**2*f**3*fdd*s + 144*D1**2*f**3*fdd + 1728*D1**2*f**2*fd**2*r**2 + 9240*D1**2*f**2*fd**2*r*s - 5484*D1**2*f**2*fd**2*r - 2310*D1**2*f**2*fd**2*s + 1540*D1**2*f**2*fd**2 - 2376*D1**2*f**2*fd*r**2 - 1188*D1**2*f**2*fd*r*s + 1980*D1**2*f**2*fd*r + 396*D1**2*f**2*fd*s - 792*D1**2*f**2*fd + 286*D1**2*f**2*gd2*r**2 - 682*D1**2*f**2*gdd2*r**2 + 572*D1**2*f*fd*g2*r**2 - 572*D1**2*f*fd*g2*r + 286*D1**2*f*fd*g2 - 2728*D1**2*f*fd*gd2*r**2 + 1364*D1**2*f*fd*gd2*r - 1364*D1**2*f*fdd*g2*r**2 + 1364*D1**2*f*fdd*g2*r - 682*D1**2*f*fdd*g2 - 1364*D1**2*fd**2*g2*r**2 + 1364*D1**2*fd**2*g2*r - 96*D1*Dd*f**4*r**2 - 3080*D1*Dd*f**4*r*s + 1588*D1*Dd*f**4*r + 770*D1*Dd*f**4*s - 24*D1*Dd*f**4 + 4608*D1*Dd*f**3*fd*r**2 + 24640*D1*Dd*f**3*fd*r*s - 14624*D1*Dd*f**3*fd*r - 6160*D1*Dd*f**3*fd*s + 3368*D1*Dd*f**3*fd - 3168*D1*Dd*f**3*r**2 - 1584*D1*Dd*f**3*r*s + 2376*D1*Dd*f**3*r + 396*D1*Dd*f**3*s - 792*D1*Dd*f**3 + 1144*D1*Dd*f**2*g2*r**2 - 572*D1*Dd*f**2*g2*r + 286*D1*Dd*f**2*g2 - 5456*D1*Dd*f**2*gd2*r**2 + 1364*D1*Dd*f**2*gd2*r - 10912*D1*Dd*f*fd*g2*r**2 + 8184*D1*Dd*f*fd*g2*r - 1364*D1*Dd*f*fd*g2 + 576*D1*Ddd*f**4*r**2 + 3080*D1*Ddd*f**4*r*s - 1828*D1*Ddd*f**4*r - 770*D1*Ddd*f**4*s + 144*D1*Ddd*f**4 - 2728*D1*Ddd*f**2*g2*r**2 + 1364*D1*Ddd*f**2*g2*r - 682*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(2*f**3*(24*r**2 + r*(5*s - 22) + 15*s + 6) + f**2*(84*C*(r - 1)**2 - 13*K*r**2 - 2*fd*(216*r**2 + 78*r*s - 174*r + 17*s - 16) - 87*r**2 - 16*r*s + 268*r + 84*s - 168) + 2*f*(fd*(r**2*(62*K - 158) + r*(-31*K - 96*s + 127) + 24*s - 24) + (7*r - 7)*(g2*(r - 1) + 14*gd2*r)) + 196*fd*g2*r*(r - 1)) - 2*Dd*f*(f**2*(288*r**2 + 2*r*(52*s - 125) + 47*s + 8) + f*(r**2*(316 - 124*K) + r*(31*K + 192*s - 223) - 24*s + 24) - 98*g2*(4*r**2 - 5*r + 1))) + 1728*Dd**2*f**4*r**2 + 9240*Dd**2*f**4*r*s - 5484*Dd**2*f**4*r - 2310*Dd**2*f**4*s + 1540*Dd**2*f**4 - 8184*Dd**2*f**2*g2*r**2 + 4092*Dd**2*f**2*g2*r + 11*b1**2*(D1**2*r*(12*f*(2*fd - fdd)*(4*r + 4*s - 3) - 12*fd**2*(4*r + 4*s - 3) - 7*fd*r*(K - 21) + 140*fd*s - 49*fdd*r*(K - 1)) + D1*(Dd*(48*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-28*K*r**2 + 14*K*r - 7*K - 12*fd*(8*r - 1)*(4*r + 4*s - 3) + 588*r**2 + 560*r*s - 574*r - 140*s + 147) - 98*fd*r*(K - 1)*(4*r - 1)) + Ddd*f*(-24*f*(4*r**2 + 4*r*(s - 1) - s + 1) + (49 - 49*K)*(4*r**2 - 2*r + 1))) - 6*Dd**2*f*(4*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + r*(49*K - 49)*(2*r - 1))) + 11*b1*(168*C*D1**2*f*fd*r**2 + 336*C*D1*Dd*f**2*r**2 - 168*C*D1*Dd*f**2*r + 84*C*D1*Dd*f**2 - 26*D1**2*K*f*fd*r**2 + 26*D1**2*K*f*fd*r - 13*D1**2*K*f*fd + 62*D1**2*K*f*fdd*r**2 - 62*D1**2*K*f*fdd*r + 31*D1**2*K*f*fdd + 62*D1**2*K*fd**2*r**2 - 62*D1**2*K*fd**2*r + D1**2*bdd1*f*(-12*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + (49 - 49*K)*(2*r**2 - 2*r + 1)) + 144*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 72*D1**2*f**2*fd*r - 40*D1**2*f**2*fd*s + 36*D1**2*f**2*fd - 216*D1**2*f**2*fdd*r**2 - 78*D1**2*f**2*fdd*r*s + 120*D1**2*f**2*fdd*r + 56*D1**2*f**2*fdd*s - 48*D1**2*f**2*fdd - 432*D1**2*f*fd**2*r**2 - 156*D1**2*f*fd**2*r*s + 240*D1**2*f*fd**2*r + 112*D1**2*f*fd**2*s - 84*D1**2*f*fd**2 - 174*D1**2*f*fd*r**2 - 32*D1**2*f*fd*r*s - 78*D1**2*f*fd*r - 68*D1**2*f*fd*s + 81*D1**2*f*fd - 158*D1**2*f*fdd*r**2 - 96*D1**2*f*fdd*r*s + 158*D1**2*f*fdd*r + 48*D1**2*f*fdd*s - 79*D1**2*f*fdd + 14*D1**2*f*gd2*r**2 + 98*D1**2*f*gdd2*r**2 - 158*D1**2*fd**2*r**2 - 96*D1**2*fd**2*r*s + 158*D1**2*fd**2*r + 48*D1**2*fd**2*s + 14*D1**2*fd*g2*r**2 + 196*D1**2*fd*gd2*r**2 + 98*D1**2*fdd*g2*r**2 - 52*D1*Dd*K*f**2*r**2 + 26*D1*Dd*K*f**2*r - 13*D1*Dd*K*f**2 + 496*D1*Dd*K*f*fd*r**2 - 372*D1*Dd*K*f*fd*r + 62*D1*Dd*K*f*fd + 192*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 116*D1*Dd*f**3*r - 10*D1*Dd*f**3*s + 48*D1*Dd*f**3 - 1728*D1*Dd*f**2*fd*r**2 - 624*D1*Dd*f**2*fd*r*s + 1068*D1*Dd*f**2*fd*r + 302*D1*Dd*f**2*fd*s - 232*D1*Dd*f**2*fd - 348*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 206*D1*Dd*f**2*r + 16*D1*Dd*f**2*s - 87*D1*Dd*f**2 - 1264*D1*Dd*f*fd*r**2 - 768*D1*Dd*f*fd*r*s + 1140*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s - 254*D1*Dd*f*fd + 56*D1*Dd*f*g2*r**2 - 28*D1*Dd*f*g2*r + 14*D1*Dd*f*g2 + 784*D1*Dd*f*gd2*r**2 - 196*D1*Dd*f*gd2*r + 784*D1*Dd*fd*g2*r**2 - 196*D1*Dd*fd*g2*r + 124*D1*Ddd*K*f**2*r**2 - 62*D1*Ddd*K*f**2*r + 31*D1*Ddd*K*f**2 - 288*D1*Ddd*f**3*r**2 - 104*D1*Ddd*f**3*r*s + 196*D1*Ddd*f**3*r + 26*D1*Ddd*f**3*s - 72*D1*Ddd*f**3 - 316*D1*Ddd*f**2*r**2 - 192*D1*Ddd*f**2*r*s + 254*D1*Ddd*f**2*r + 48*D1*Ddd*f**2*s - 79*D1*Ddd*f**2 + 392*D1*Ddd*f*g2*r**2 - 196*D1*Ddd*f*g2*r + 98*D1*Ddd*f*g2 + D1*bd1*(D1*(24*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(-14*K*r**2 + 14*K*r - 7*K - 12*fd*(4*r - 1)*(4*r + 4*s - 3) + 294*r**2 + 280*r*s - 434*r - 140*s + 147) - 98*fd*r*(K - 1)*(2*r - 1)) - 2*Dd*f*(6*f*(8*r - 3)*(4*r + 4*s - 3) + (49*K - 49)*(8*r**2 - 6*r + 1))) + 372*Dd**2*K*f**2*r**2 - 186*Dd**2*K*f**2*r - 864*Dd**2*f**3*r**2 - 312*Dd**2*f**3*r*s + 588*Dd**2*f**3*r + 78*Dd**2*f**3*s - 52*Dd**2*f**3 - 948*Dd**2*f**2*r**2 - 576*Dd**2*f**2*r*s + 762*Dd**2*f**2*r + 144*Dd**2*f**2*s - 96*Dd**2*f**2 + 1176*Dd**2*f*g2*r**2 - 588*Dd**2*f*g2*r))/(1155*d**2*k1**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**2*k2**2*st**4*(3*D1*bd1*f*(D1*(24*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 3*b1*(D1*Dd*f*(24*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(24*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(32*f*(4*r*s - 2*r - s) - 25*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(32*f*fd*(r*(3*s - 1) - s) + 5*f*(-3*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(r*(2 - 4*s) + s)) - 25*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k1**2*k3**2) - 2*D1**2*Pk1*Pk3*ct**2*k2**2*st**2*(7*b1**2*(C - 1)*(D1**2*r**2*(fd + 7*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 14*Dd*fd*r*(4*r - 1) + 7*Ddd*f*(4*r**2 - 2*r + 1)) + 42*Dd**2*f*r*(2*r - 1)) + b1*(26*C*D1**2*f*fd*r**2 - 26*C*D1**2*f*fd*r + 13*C*D1**2*f*fd - 62*C*D1**2*f*fdd*r**2 + 62*C*D1**2*f*fdd*r - 31*C*D1**2*f*fdd - 62*C*D1**2*fd**2*r**2 + 62*C*D1**2*fd**2*r + 52*C*D1*Dd*f**2*r**2 - 26*C*D1*Dd*f**2*r + 13*C*D1*Dd*f**2 - 496*C*D1*Dd*f*fd*r**2 + 372*C*D1*Dd*f*fd*r - 62*C*D1*Dd*f*fd - 124*C*D1*Ddd*f**2*r**2 + 62*C*D1*Ddd*f**2*r - 31*C*D1*Ddd*f**2 - 372*C*Dd**2*f**2*r**2 + 186*C*Dd**2*f**2*r + 49*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 68*D1**2*f*fd*r**2 + 54*D1**2*f*fd*r*s - D1**2*f*fd*r - 13*D1**2*f*fd + 104*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s - 59*D1**2*f*fdd*r + 31*D1**2*f*fdd + 104*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s - 59*D1**2*fd**2*r - 136*D1*Dd*f**2*r**2 + 108*D1*Dd*f**2*r*s + 14*D1*Dd*f**2*r - 27*D1*Dd*f**2*s - 34*D1*Dd*f**2 + 832*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s - 432*D1*Dd*f*fd*r + 6*D1*Dd*f*fd*s + 59*D1*Dd*f*fd + 208*D1*Ddd*f**2*r**2 - 12*D1*Ddd*f**2*r*s - 98*D1*Ddd*f**2*r + 3*D1*Ddd*f**2*s + 52*D1*Ddd*f**2 + 7*D1*bd1*(C - 1)*(D1*f*(2*r**2 - 2*r + 1) + 14*D1*fd*r*(2*r - 1) + 14*Dd*f*(8*r**2 - 6*r + 1)) + 624*Dd**2*f**2*r**2 - 36*Dd**2*f**2*r*s - 294*Dd**2*f**2*r + 9*Dd**2*f**2*s - 6*Dd**2*f**2) + f*(12*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 + 16*C*D1**2*f*fdd*r - 8*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r**2 + 32*C*D1**2*fd**2*r + 16*C*D1*Dd*f**2*r**2 - 8*C*D1*Dd*f**2*r + 4*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 + 112*C*D1*Dd*f*fd*r - 16*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r**2 + 16*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r**2 + 48*C*Dd**2*f**2*r + 98*D1**2*bd1**2*r*(C - 1)*(r - 1) + D1**2*bdd1*f*(r**2*(52 - 31*C) - 3*r*(s + 14) + 3*s + 21) - 21*D1**2*f*fd*r**2 + 213*D1**2*f*fd*r*s - 57*D1**2*f*fd*r - 71*D1**2*f*fd*s - 7*D1**2*f*fd - 21*D1**2*f*fdd*r**2 - 165*D1**2*f*fdd*r*s + 69*D1**2*f*fdd*r + 55*D1**2*f*fdd*s - 7*D1**2*f*fdd - 42*D1**2*fd**2*r**2 - 330*D1**2*fd**2*r*s + 138*D1**2*fd**2*r + 110*D1**2*fd**2*s - 55*D1**2*fd**2 - 28*D1*Dd*f**2*r**2 + 284*D1*Dd*f**2*r*s - 128*D1*Dd*f**2*r - 71*D1*Dd*f**2*s - 7*D1*Dd*f**2 - 168*D1*Dd*f*fd*r**2 - 1320*D1*Dd*f*fd*r*s + 648*D1*Dd*f*fd*r + 385*D1*Dd*f*fd*s - 179*D1*Dd*f*fd - 28*D1*Ddd*f**2*r**2 - 220*D1*Ddd*f**2*r*s + 124*D1*Ddd*f**2*r + 55*D1*Ddd*f**2*s - 7*D1*Ddd*f**2 + D1*bd1*(D1*(f*(r**2*(13*C - 34) + 3*r*(9*s + 14) - 27*s - 21) + fd*(-r**2*(124*C - 208) + r*(62*C - 12*s - 143) + 6*s - 3)) + Dd*f*(-r**2*(248*C - 416) + r*(62*C - 24*s - 266) + 15*s + 36)) - 84*Dd**2*f**2*r**2 - 660*Dd**2*f**2*r*s + 372*Dd**2*f**2*r + 165*Dd**2*f**2*s - 110*Dd**2*f**2))/(105*d**2*k1**2*k3**2) - D1**2*Pk1*Pk3*ct**2*k2**2*(-10*D1**2*K*bdd1*f**2*r**2 - 16*D1**2*b2*f*fd*r**2 + 16*D1**2*b2*f*fd*r - 8*D1**2*b2*f*fd - 20*D1**2*b2*f*fdd*r**2 + 20*D1**2*b2*f*fdd*r - 10*D1**2*b2*f*fdd - 20*D1**2*b2*fd**2*r**2 + 20*D1**2*b2*fd**2*r + D1**2*bd1**2*(f**2*(40*r**2 + r*(84*s - 81) - 42*s + 21) + 7*f*(16*r**2 + 22*r*s - 27*r - 11*s + 11) - 280*g2*r*(r - 1)) - 8*D1**2*bd2*f**2*r**2 - 40*D1**2*bd2*f*fd*r**2 + 20*D1**2*bd2*f*fd*r + 12*D1**2*bdd1*f**3*r**2 - 18*D1**2*bdd1*f**3*r*s + 9*D1**2*bdd1*f**3*r + 12*D1**2*bdd1*f**2*r**2 - 17*D1**2*bdd1*f**2*r*s + 17*D1**2*bdd1*f**2*r - 10*D1**2*bdd2*f**2*r**2 + 16*D1**2*f**2*gd2*r**2 + 20*D1**2*f**2*gdd2*r**2 + 32*D1**2*f*fd*g2*r**2 - 32*D1**2*f*fd*g2*r + 16*D1**2*f*fd*g2 + 80*D1**2*f*fd*gd2*r**2 - 40*D1**2*f*fd*gd2*r + 40*D1**2*f*fdd*g2*r**2 - 40*D1**2*f*fdd*g2*r + 20*D1**2*f*fdd*g2 + 40*D1**2*fd**2*g2*r**2 - 40*D1**2*fd**2*g2*r - 32*D1*Dd*b2*f**2*r**2 + 16*D1*Dd*b2*f**2*r - 8*D1*Dd*b2*f**2 - 160*D1*Dd*b2*f*fd*r**2 + 120*D1*Dd*b2*f*fd*r - 20*D1*Dd*b2*f*fd - 80*D1*Dd*bd2*f**2*r**2 + 20*D1*Dd*bd2*f**2*r + 64*D1*Dd*f**2*g2*r**2 - 32*D1*Dd*f**2*g2*r + 16*D1*Dd*f**2*g2 + 160*D1*Dd*f**2*gd2*r**2 - 40*D1*Dd*f**2*gd2*r + 320*D1*Dd*f*fd*g2*r**2 - 240*D1*Dd*f*fd*g2*r + 40*D1*Dd*f*fd*g2 - 40*D1*Ddd*b2*f**2*r**2 + 20*D1*Ddd*b2*f**2*r - 10*D1*Ddd*b2*f**2 + 80*D1*Ddd*f**2*g2*r**2 - 40*D1*Ddd*f**2*g2*r + 20*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(fd*(3*f*(24*r**2 + r*(10 - 36*s) + 6*s - 3) + r**2*(48 - 40*K) + 2*r*(10*K - 34*s + 5) + 17*s - 17) + r*(3*f**2*(16*r + 6*s - 3) - f*(r*(42*C + 8*K - 102) + s - 1) - 210*g2*r)) + Dd*f*(3*f*(32*r**2 + r*(16 - 48*s) + 6*s - 3) + r**2*(96 - 80*K) + 2*r*(10*K - 68*s + 39) + 17*s - 17)) - 120*Dd**2*b2*f**2*r**2 + 60*Dd**2*b2*f**2*r + 240*Dd**2*f**2*g2*r**2 - 120*Dd**2*f**2*g2*r + 35*b1**3*(K - 1)*(D1*(5*Dd + 2*Ddd)*(4*r**2 - 2*r + 1) + 12*Dd**2*r*(2*r - 1)) + b1**2*(-70*C*D1**2*fd*r**2 - 280*C*D1*Dd*f*r**2 + 140*C*D1*Dd*f*r - 70*C*D1*Dd*f + 105*D1**2*K*fd*r**2 - 210*D1**2*K*fd*r + 105*D1**2*K*fd + 70*D1**2*bdd1*(K - 1)*(3*r**2 - 2*r + 1) + 32*D1**2*f*fd*r**2 - 84*D1**2*f*fd*r*s + 79*D1**2*f*fd*r - 8*D1**2*f*fd + 40*D1**2*f*fdd*r**2 + 84*D1**2*f*fdd*r*s - 43*D1**2*f*fdd*r - 10*D1**2*f*fdd + 40*D1**2*fd**2*r**2 + 84*D1**2*fd**2*r*s - 43*D1**2*fd**2*r - 7*D1**2*fd*r**2 - 119*D1**2*fd*r*s + 210*D1**2*fd*r - 105*D1**2*fd + 56*D1**2*fdd*r**2 + 77*D1**2*fdd*r*s - 350*D1**2*gd2*r**2 - 140*D1**2*gdd2*r**2 + 420*D1*Dd*K*f*r**2 - 210*D1*Dd*K*f*r + 105*D1*Dd*K*f + 64*D1*Dd*f**2*r**2 - 168*D1*Dd*f**2*r*s + 52*D1*Dd*f**2*r + 42*D1*Dd*f**2*s + 16*D1*Dd*f**2 + 320*D1*Dd*f*fd*r**2 + 672*D1*Dd*f*fd*r*s - 420*D1*Dd*f*fd*r - 84*D1*Dd*f*fd*s + 43*D1*Dd*f*fd - 28*D1*Dd*f*r**2 - 476*D1*Dd*f*r*s + 252*D1*Dd*f*r + 119*D1*Dd*f*s - 7*D1*Dd*f + 448*D1*Dd*fd*r**2 + 616*D1*Dd*fd*r*s - 266*D1*Dd*fd*r - 77*D1*Dd*fd*s - 1400*D1*Dd*g2*r**2 + 700*D1*Dd*g2*r - 350*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 + 280*D1*Dd*gd2*r + 80*D1*Ddd*f**2*r**2 + 168*D1*Ddd*f**2*r*s - 124*D1*Ddd*f**2*r - 42*D1*Ddd*f**2*s + 20*D1*Ddd*f**2 + 224*D1*Ddd*f*r**2 + 308*D1*Ddd*f*r*s - 266*D1*Ddd*f*r - 77*D1*Ddd*f*s + 56*D1*Ddd*f - 560*D1*Ddd*g2*r**2 + 280*D1*Ddd*g2*r - 140*D1*Ddd*g2 + 35*D1*bd1*(K - 1)*(5*D1*(3*r**2 - 2*r + 1) + 4*Dd*(12*r**2 - 7*r + 1)) + 240*Dd**2*f**2*r**2 + 504*Dd**2*f**2*r*s - 372*Dd**2*f**2*r - 126*Dd**2*f**2*s + 84*Dd**2*f**2 + 672*Dd**2*f*r**2 + 924*Dd**2*f*r*s - 798*Dd**2*f*r - 231*Dd**2*f*s + 154*Dd**2*f - 1680*Dd**2*g2*r**2 + 840*Dd**2*g2*r) + b1*(-84*C*D1**2*f*fd*r**2 + 84*C*D1**2*f*fd*r - 42*C*D1**2*f*fd - 168*C*D1*Dd*f**2*r**2 + 84*C*D1*Dd*f**2*r - 42*C*D1*Dd*f**2 - 16*D1**2*K*f*fd*r**2 + 16*D1**2*K*f*fd*r - 8*D1**2*K*f*fd - 20*D1**2*K*f*fdd*r**2 + 20*D1**2*K*f*fdd*r - 10*D1**2*K*f*fdd - 20*D1**2*K*fd**2*r**2 + 20*D1**2*K*fd**2*r + 140*D1**2*bd1**2*r*(K - 1)*(3*r - 2) + D1**2*bdd1*(f**2*(40*r**2 + r*(84*s - 81) - 42*s + 30) + 7*f*(16*r**2 + r*(22*s - 27) - 11*s + 8) - 140*g2*(2*r**2 - 2*r + 1)) + 144*D1**2*f**2*fd*r**2 + 54*D1**2*f**2*fd*r*s - 123*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s + 48*D1**2*f**2*fd + 36*D1**2*f**2*fdd*r**2 - 54*D1**2*f**2*fdd*r*s + 3*D1**2*f**2*fdd*r + 18*D1**2*f**2*fdd*s + 12*D1**2*f**2*fdd + 72*D1**2*f*fd**2*r**2 - 108*D1**2*f*fd**2*r*s + 6*D1**2*f*fd**2*r + 36*D1**2*f*fd**2*s - 27*D1**2*f*fd**2 + 204*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r*s - 204*D1**2*f*fd*r + D1**2*f*fd*s + 102*D1**2*f*fd + 24*D1**2*f*fdd*r**2 - 34*D1**2*f*fdd*r*s - 24*D1**2*f*fdd*r + 17*D1**2*f*fdd*s + 12*D1**2*f*fdd - 210*D1**2*f*gd2*r**2 + 24*D1**2*fd**2*r**2 - 34*D1**2*fd**2*r*s - 24*D1**2*fd**2*r + 17*D1**2*fd**2*s - 210*D1**2*fd*g2*r**2 + 420*D1**2*fd*g2*r - 210*D1**2*fd*g2 - 32*D1*Dd*K*f**2*r**2 + 16*D1*Dd*K*f**2*r - 8*D1*Dd*K*f**2 - 160*D1*Dd*K*f*fd*r**2 + 120*D1*Dd*K*f*fd*r - 20*D1*Dd*K*f*fd + 192*D1*Dd*f**3*r**2 + 72*D1*Dd*f**3*r*s - 132*D1*Dd*f**3*r - 18*D1*Dd*f**3*s + 48*D1*Dd*f**3 + 288*D1*Dd*f**2*fd*r**2 - 432*D1*Dd*f**2*fd*r*s + 48*D1*Dd*f**2*fd*r + 126*D1*Dd*f**2*fd*s - 39*D1*Dd*f**2*fd + 408*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r*s - 202*D1*Dd*f**2*r + D1*Dd*f**2*s + 102*D1*Dd*f**2 + 192*D1*Dd*f*fd*r**2 - 272*D1*Dd*f*fd*r*s - 76*D1*Dd*f*fd*r + 102*D1*Dd*f*fd*s - 10*D1*Dd*f*fd - 840*D1*Dd*f*g2*r**2 + 420*D1*Dd*f*g2*r - 210*D1*Dd*f*g2 - 40*D1*Ddd*K*f**2*r**2 + 20*D1*Ddd*K*f**2*r - 10*D1*Ddd*K*f**2 + 48*D1*Ddd*f**3*r**2 - 72*D1*Ddd*f**3*r*s + 12*D1*Ddd*f**3*r + 18*D1*Ddd*f**3*s + 12*D1*Ddd*f**3 + 48*D1*Ddd*f**2*r**2 - 68*D1*Ddd*f**2*r*s + 10*D1*Ddd*f**2*r + 17*D1*Ddd*f**2*s + 12*D1*Ddd*f**2 + D1*bd1*(D1*(f**2*(32*r**2 - 3*r*(28*s + 9) + 42*s + 24) + f*(-70*C*(2*r**2 - 2*r + 1) + fd*(160*r**2 + 8*r*(42*s - 31) - 84*s + 63) + 7*r**2*(30*K - 2) - 7*r*(34*s + 11) + 119*s + 98) + 7*fd*(32*r**2 + 44*r*s - 27*r - 11*s) - 350*g2*(2*r**2 - 2*r + 1) + 280*gd2*r*(1 - 2*r)) + Dd*(f**2*(320*r**2 + r*(672*s - 572) - 252*s + 165) + 7*f*(128*r**2 + 8*r*(22*s - 23) - 66*s + 49) - 280*g2*(8*r**2 - 6*r + 1))) - 120*Dd**2*K*f**2*r**2 + 60*Dd**2*K*f**2*r + 144*Dd**2*f**3*r**2 - 216*Dd**2*f**3*r*s + 36*Dd**2*f**3*r + 54*Dd**2*f**3*s - 36*Dd**2*f**3 + 144*Dd**2*f**2*r**2 - 204*Dd**2*f**2*r*s + 30*Dd**2*f**2*r + 51*Dd**2*f**2*s - 34*Dd**2*f**2))/(105*d**2*k1**2*k3**2) + 4*D1**2*Pk1*Pk3*ct**2*st**2*(35*D1*b1**2*(D1*fd*r*(s - 1) + Dd*f*(4*r*s - 2*r - s)) + D1*f*(D1*bd1*(17*f*r*s + 12*fd*(-4*r*s + r + s)) - 12*D1*bdd1*f*r*s + 12*Dd*bd1*f*(r*(2 - 8*s) + s)) + b1*(D1*Dd*f*(17*f*(4*r*s - 2*r - s) - 12*fd*(8*r - 3)*(2*s - 1)) + D1*(D1*(17*f*fd*(r*(2*s - 1) - s) + f*(35*bd1*s*(2*r - 1) + 12*fdd*(-2*r*s + r + s)) - 12*fd**2*(r*(2*s - 1) - s + 1)) + 12*Ddd*f**2*(r*(2 - 4*s) + s)) - 12*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k1**2) + D1**2*Pk1*Pk3*ct**2*(D1*f*(-77*D1*bd1**2*s*(2*r - 1) + D1*bdd1*f*r*(r*(20*C - 10) + 17*s) + bd1*(D1*(f*r*(r*(16*C - 8) - 41*s) + fd*(r**2*(80*C - 40) + r*(-40*C + 68*s + 3) - 17*s)) + Dd*f*(r**2*(160*C - 80) - 2*r*(20*C - 68*s + 7) - 17*s))) - 7*b1**2*(D1*Dd*(7*f*(-4*r*s + 2*r + s) + 11*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(7*fd - 11*fdd)*(s - 1) + 11*Ddd*f*(4*r*s - 2*r - s)) + 11*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(D1**2*(f*(77*bdd1*s*(1 - 2*r) + fd*(16*C*(2*r**2 - 2*r + 1) - 16*r**2 - 82*r*s + 57*r + 41*s - 8) + fdd*(20*C*(2*r**2 - 2*r + 1) - 20*r**2 + 34*r*s + 3*r - 17*s - 10)) + fd**2*(r**2*(40*C - 20) + r*(-40*C + 34*s + 3) - 17*s + 17)) + 7*D1*bd1*(D1*(7*f*s*(2*r - 1) - 11*fd*(4*r*s - 2*r - s + 1)) - 22*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*f*(Dd*(f*(16*C*(4*r**2 - 2*r + 1) - 32*r**2 - 164*r*s + 98*r + 41*s - 8) + fd*(40*C*(8*r**2 - 6*r + 1) - 160*r**2 + 272*r*s - 16*r - 102*s + 31)) + Ddd*f*(20*C*(4*r**2 - 2*r + 1) - 40*r**2 + 68*r*s - 14*r - 17*s - 10)) + Dd**2*f**2*(r**2*(240*C - 120) - 6*r*(20*C - 34*s + 7) - 51*s + 34)))/(105*d**2*k1**2) - 4*D1**2*Pk1*Pk3*ct*f*k2**7*st**6*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 88*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 88*D1**2*b1*f*fd*s + 44*D1**2*b1*f*fd - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 44*D1**2*b1*f*fdd*r - 33*D1**2*b1*f*fdd*s**2 + 44*D1**2*b1*f*fdd*s - 22*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 88*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 88*D1**2*b1*fd**2*s - 22*D1**2*b1*fd**2 - 11*D1**2*bdd1*f**2*(r + s - 1)**2 + 24*D1**2*f**2*fd*r**2 + 48*D1**2*f**2*fd*r*s - 36*D1**2*f**2*fd*r + 24*D1**2*f**2*fd*s**2 - 36*D1**2*f**2*fd*s + 18*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 - 24*D1**2*f**2*fdd*r*s + 18*D1**2*f**2*fdd*r - 12*D1**2*f**2*fdd*s**2 + 18*D1**2*f**2*fdd*s - 9*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r**2 - 72*D1**2*f*fd**2*r*s + 54*D1**2*f*fd**2*r - 36*D1**2*f*fd**2*s**2 + 54*D1**2*f*fd**2*s - 18*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 176*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r + 88*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 374*D1*Dd*b1*f*fd*r - 264*D1*Dd*b1*f*fd*s**2 + 374*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 - 192*D1*Dd*f**2*fd*r*s + 144*D1*Dd*f**2*fd*r - 96*D1*Dd*f**2*fd*s**2 + 144*D1*Dd*f**2*fd*s - 54*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 - 88*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r - 44*D1*Ddd*b1*f**2*s**2 + 66*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 24*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 18*D1*Ddd*f**3*s - 9*D1*Ddd*f**3 + 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 132*Dd**2*b1*f**2*r**2 - 264*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r - 132*Dd**2*b1*f**2*s**2 + 198*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 72*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 54*Dd**2*f**3*s - 18*Dd**2*f**3)/(33*d**2*k1*k3**8) + D1**2*Pk1*Pk3*ct*f*k2**5*st**4*(231*D1**2*b1*f*fd*r**2 - 165*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 55*D1**2*bdd1*f**2*(r - 1)**2 + 92*D1**2*f**2*fd*r**2 - 46*D1**2*f**2*fd*r + 23*D1**2*f**2*fd + 20*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 - 30*D1**2*f*fd**2*r + 308*D1*Dd*b1*f**2*r**2 - 154*D1*Dd*b1*f**2*r + 77*D1*Dd*b1*f**2 - 1320*D1*Dd*b1*f*fd*r**2 + 330*D1*Dd*b1*f*fd*r + 92*D1*Dd*f**3*r**2 - 46*D1*Dd*f**3*r + 23*D1*Dd*f**3 + 160*D1*Dd*f**2*fd*r**2 - 80*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd - 220*D1*Ddd*b1*f**2*r**2 + 110*D1*Ddd*b1*f**2*r - 55*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 11*D1*bd1*f*(r - 1)*(7*D1*f*(r - 1) - 30*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 660*Dd**2*b1*f**2*r**2 + 330*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(231*d**2*k1**3*k3**4) - 4*D1**2*Pk1*Pk3*ct*k1**5*k2*st**2*(168*C*D1**2*b1*f*fd*r**2 + 336*C*D1**2*b1*f*fd*r*s - 168*C*D1**2*b1*f*fd*r + 168*C*D1**2*b1*f*fd*s**2 - 168*C*D1**2*b1*f*fd*s + 84*C*D1**2*b1*f*fd - 504*C*D1**2*b1*f*fdd*r**2 - 1008*C*D1**2*b1*f*fdd*r*s + 504*C*D1**2*b1*f*fdd*r - 504*C*D1**2*b1*f*fdd*s**2 + 504*C*D1**2*b1*f*fdd*s - 252*C*D1**2*b1*f*fdd - 504*C*D1**2*b1*fd**2*r**2 - 1008*C*D1**2*b1*fd**2*r*s + 504*C*D1**2*b1*fd**2*r - 504*C*D1**2*b1*fd**2*s**2 + 504*C*D1**2*b1*fd**2*s + 300*C*D1**2*f**2*fd*r**2 + 600*C*D1**2*f**2*fd*r*s - 400*C*D1**2*f**2*fd*r + 300*C*D1**2*f**2*fd*s**2 - 400*C*D1**2*f**2*fd*s + 200*C*D1**2*f**2*fd - 420*C*D1**2*f**2*fdd*r**2 - 840*C*D1**2*f**2*fdd*r*s + 560*C*D1**2*f**2*fdd*r - 420*C*D1**2*f**2*fdd*s**2 + 560*C*D1**2*f**2*fdd*s - 280*C*D1**2*f**2*fdd - 840*C*D1**2*f*fd**2*r**2 - 1680*C*D1**2*f*fd**2*r*s + 1120*C*D1**2*f*fd**2*r - 840*C*D1**2*f*fd**2*s**2 + 1120*C*D1**2*f*fd**2*s - 280*C*D1**2*f*fd**2 + 336*C*D1*Dd*b1*f**2*r**2 + 672*C*D1*Dd*b1*f**2*r*s - 504*C*D1*Dd*b1*f**2*r + 336*C*D1*Dd*b1*f**2*s**2 - 504*C*D1*Dd*b1*f**2*s + 252*C*D1*Dd*b1*f**2 - 4032*C*D1*Dd*b1*f*fd*r**2 - 8064*C*D1*Dd*b1*f*fd*r*s + 5040*C*D1*Dd*b1*f*fd*r - 4032*C*D1*Dd*b1*f*fd*s**2 + 5040*C*D1*Dd*b1*f*fd*s - 1512*C*D1*Dd*b1*f*fd + 400*C*D1*Dd*f**3*r**2 + 800*C*D1*Dd*f**3*r*s - 600*C*D1*Dd*f**3*r + 400*C*D1*Dd*f**3*s**2 - 600*C*D1*Dd*f**3*s + 300*C*D1*Dd*f**3 - 3360*C*D1*Dd*f**2*fd*r**2 - 6720*C*D1*Dd*f**2*fd*r*s + 4760*C*D1*Dd*f**2*fd*r - 3360*C*D1*Dd*f**2*fd*s**2 + 4760*C*D1*Dd*f**2*fd*s - 1680*C*D1*Dd*f**2*fd - 1008*C*D1*Ddd*b1*f**2*r**2 - 2016*C*D1*Ddd*b1*f**2*r*s + 1512*C*D1*Ddd*b1*f**2*r - 1008*C*D1*Ddd*b1*f**2*s**2 + 1512*C*D1*Ddd*b1*f**2*s - 756*C*D1*Ddd*b1*f**2 - 560*C*D1*Ddd*f**3*r**2 - 1120*C*D1*Ddd*f**3*r*s + 840*C*D1*Ddd*f**3*r - 560*C*D1*Ddd*f**3*s**2 + 840*C*D1*Ddd*f**3*s - 420*C*D1*Ddd*f**3 - 3024*C*Dd**2*b1*f**2*r**2 - 6048*C*Dd**2*b1*f**2*r*s + 4536*C*Dd**2*b1*f**2*r - 3024*C*Dd**2*b1*f**2*s**2 + 4536*C*Dd**2*b1*f**2*s - 1512*C*Dd**2*b1*f**2 - 1680*C*Dd**2*f**3*r**2 - 3360*C*Dd**2*f**3*r*s + 2520*C*Dd**2*f**3*r - 1680*C*Dd**2*f**3*s**2 + 2520*C*Dd**2*f**3*s - 840*C*Dd**2*f**3 - 78*D1**2*b1*f*fd*r**2 - 156*D1**2*b1*f*fd*r*s + 78*D1**2*b1*f*fd*r - 78*D1**2*b1*f*fd*s**2 + 78*D1**2*b1*f*fd*s - 39*D1**2*b1*f*fd + 270*D1**2*b1*f*fdd*r**2 + 540*D1**2*b1*f*fdd*r*s - 270*D1**2*b1*f*fdd*r + 270*D1**2*b1*f*fdd*s**2 - 270*D1**2*b1*f*fdd*s + 135*D1**2*b1*f*fdd + 270*D1**2*b1*fd**2*r**2 + 540*D1**2*b1*fd**2*r*s - 270*D1**2*b1*fd**2*r + 270*D1**2*b1*fd**2*s**2 - 270*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(28*C - 15)*(r + s - 1)**2 - 153*D1**2*f**2*fd*r**2 - 306*D1**2*f**2*fd*r*s + 204*D1**2*f**2*fd*r - 153*D1**2*f**2*fd*s**2 + 204*D1**2*f**2*fd*s - 102*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 450*D1**2*f**2*fdd*r*s - 300*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 300*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 900*D1**2*f*fd**2*r*s - 600*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 600*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 156*D1*Dd*b1*f**2*r**2 - 312*D1*Dd*b1*f**2*r*s + 234*D1*Dd*b1*f**2*r - 156*D1*Dd*b1*f**2*s**2 + 234*D1*Dd*b1*f**2*s - 117*D1*Dd*b1*f**2 + 2160*D1*Dd*b1*f*fd*r**2 + 4320*D1*Dd*b1*f*fd*r*s - 2700*D1*Dd*b1*f*fd*r + 2160*D1*Dd*b1*f*fd*s**2 - 2700*D1*Dd*b1*f*fd*s + 810*D1*Dd*b1*f*fd - 204*D1*Dd*f**3*r**2 - 408*D1*Dd*f**3*r*s + 306*D1*Dd*f**3*r - 204*D1*Dd*f**3*s**2 + 306*D1*Dd*f**3*s - 153*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 3600*D1*Dd*f**2*fd*r*s - 2550*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 2550*D1*Dd*f**2*fd*s + 900*D1*Dd*f**2*fd + 540*D1*Ddd*b1*f**2*r**2 + 1080*D1*Ddd*b1*f**2*r*s - 810*D1*Ddd*b1*f**2*r + 540*D1*Ddd*b1*f**2*s**2 - 810*D1*Ddd*b1*f**2*s + 405*D1*Ddd*b1*f**2 + 300*D1*Ddd*f**3*r**2 + 600*D1*Ddd*f**3*r*s - 450*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 450*D1*Ddd*f**3*s + 225*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(28*C - 13)*(r + s - 1) - D1*fd*(168*C - 90)*(2*r + 2*s - 1) - Dd*f*(168*C - 90)*(4*r + 4*s - 3)) + 1620*Dd**2*b1*f**2*r**2 + 3240*Dd**2*b1*f**2*r*s - 2430*Dd**2*b1*f**2*r + 1620*Dd**2*b1*f**2*s**2 - 2430*Dd**2*b1*f**2*s + 810*Dd**2*b1*f**2 + 900*Dd**2*f**3*r**2 + 1800*Dd**2*f**3*r*s - 1350*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 1350*Dd**2*f**3*s + 450*Dd**2*f**3)/(105*d**2*k3**8) - 4*D1**2*Pk1*Pk3*ct*k1**5*k2*(-270*D1**2*K*bdd1*f**2*r**2 - 540*D1**2*K*bdd1*f**2*r*s + 540*D1**2*K*bdd1*f**2*r - 270*D1**2*K*bdd1*f**2*s**2 + 540*D1**2*K*bdd1*f**2*s - 270*D1**2*K*bdd1*f**2 + 18*D1**2*bd1**2*f*(-42*K + 5*f + 7)*(r + s - 1)**2 + 35*D1**2*bdd1*f**3*r**2 + 70*D1**2*bdd1*f**3*r*s - 70*D1**2*bdd1*f**3*r + 35*D1**2*bdd1*f**3*s**2 - 70*D1**2*bdd1*f**3*s + 35*D1**2*bdd1*f**3 + 45*D1**2*bdd1*f**2*r**2 + 90*D1**2*bdd1*f**2*r*s - 90*D1**2*bdd1*f**2*r + 45*D1**2*bdd1*f**2*s**2 - 90*D1**2*bdd1*f**2*s + 45*D1**2*bdd1*f**2 + 756*D1**2*bdd1*f*g2*r**2 + 1512*D1**2*bdd1*f*g2*r*s - 1512*D1**2*bdd1*f*g2*r + 756*D1**2*bdd1*f*g2*s**2 - 1512*D1**2*bdd1*f*g2*s + 756*D1**2*bdd1*f*g2 - 324*D1**2*f**2*gd2*r**2 - 648*D1**2*f**2*gd2*r*s + 648*D1**2*f**2*gd2*r - 324*D1**2*f**2*gd2*s**2 + 648*D1**2*f**2*gd2*s - 324*D1**2*f**2*gd2 + 540*D1**2*f**2*gdd2*r**2 + 1080*D1**2*f**2*gdd2*r*s - 1080*D1**2*f**2*gdd2*r + 540*D1**2*f**2*gdd2*s**2 - 1080*D1**2*f**2*gdd2*s + 540*D1**2*f**2*gdd2 - 648*D1**2*f*fd*g2*r**2 - 1296*D1**2*f*fd*g2*r*s + 648*D1**2*f*fd*g2*r - 648*D1**2*f*fd*g2*s**2 + 648*D1**2*f*fd*g2*s - 324*D1**2*f*fd*g2 + 2160*D1**2*f*fd*gd2*r**2 + 4320*D1**2*f*fd*gd2*r*s - 3240*D1**2*f*fd*gd2*r + 2160*D1**2*f*fd*gd2*s**2 - 3240*D1**2*f*fd*gd2*s + 1080*D1**2*f*fd*gd2 + 1080*D1**2*f*fdd*g2*r**2 + 2160*D1**2*f*fdd*g2*r*s - 1080*D1**2*f*fdd*g2*r + 1080*D1**2*f*fdd*g2*s**2 - 1080*D1**2*f*fdd*g2*s + 540*D1**2*f*fdd*g2 + 1080*D1**2*fd**2*g2*r**2 + 2160*D1**2*fd**2*g2*r*s - 1080*D1**2*fd**2*g2*r + 1080*D1**2*fd**2*g2*s**2 - 1080*D1**2*fd**2*g2*s - 1296*D1*Dd*f**2*g2*r**2 - 2592*D1*Dd*f**2*g2*r*s + 1944*D1*Dd*f**2*g2*r - 1296*D1*Dd*f**2*g2*s**2 + 1944*D1*Dd*f**2*g2*s - 972*D1*Dd*f**2*g2 + 4320*D1*Dd*f**2*gd2*r**2 + 8640*D1*Dd*f**2*gd2*r*s - 7560*D1*Dd*f**2*gd2*r + 4320*D1*Dd*f**2*gd2*s**2 - 7560*D1*Dd*f**2*gd2*s + 3240*D1*Dd*f**2*gd2 + 8640*D1*Dd*f*fd*g2*r**2 + 17280*D1*Dd*f*fd*g2*r*s - 10800*D1*Dd*f*fd*g2*r + 8640*D1*Dd*f*fd*g2*s**2 - 10800*D1*Dd*f*fd*g2*s + 3240*D1*Dd*f*fd*g2 + 2160*D1*Ddd*f**2*g2*r**2 + 4320*D1*Ddd*f**2*g2*r*s - 3240*D1*Ddd*f**2*g2*r + 2160*D1*Ddd*f**2*g2*s**2 - 3240*D1*Ddd*f**2*g2*s + 1620*D1*Ddd*f**2*g2 - D1*bd1*(D1*(25*f**3*(r + s - 1) + f**2*(-70*fd*(3*r + 3*s - 2) + (27 - 162*K)*(r + s - 1)) + 18*f*(5*fd*(6*K - 1)*(2*r + 2*s - 1) + (14*g2 - 84*gd2)*(r + s - 1)) - 1512*fd*g2*(r + s)) - 2*Dd*f*(35*f**2 - 45*f*(6*K - 1) + 756*g2)*(4*r + 4*s - 3))*(r + s - 1) + 6480*Dd**2*f**2*g2*r**2 + 12960*Dd**2*f**2*g2*r*s - 9720*Dd**2*f**2*g2*r + 6480*Dd**2*f**2*g2*s**2 - 9720*Dd**2*f**2*g2*s + 3240*Dd**2*f**2*g2 - 3*b1**2*(D1**2*(3*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(30*fd**2*(r + s - 1) + 7*fd*(6*K - 1)*(r + s) - 21*fdd*(6*K - 1)*(r + s))) + D1*(Dd*(9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(30*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (42*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(6*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-42*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-42*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(324*D1**2*K*f*fd*r**2 + 648*D1**2*K*f*fd*r*s - 324*D1**2*K*f*fd*r + 324*D1**2*K*f*fd*s**2 - 324*D1**2*K*f*fd*s + 162*D1**2*K*f*fd - 540*D1**2*K*f*fdd*r**2 - 1080*D1**2*K*f*fdd*r*s + 540*D1**2*K*f*fdd*r - 540*D1**2*K*f*fdd*s**2 + 540*D1**2*K*f*fdd*s - 270*D1**2*K*f*fdd - 540*D1**2*K*fd**2*r**2 - 1080*D1**2*K*fd**2*r*s + 540*D1**2*K*fd**2*r - 540*D1**2*K*fd**2*s**2 + 540*D1**2*K*fd**2*s + 18*D1**2*bdd1*f*(-42*K + 5*f + 7)*(r + s - 1)**2 - 75*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 + 210*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 70*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 + 420*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s + 70*D1**2*f*fd**2 - 54*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 54*D1**2*f*fd*r - 54*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 180*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 90*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 45*D1**2*f*fdd - 252*D1**2*f*gd2*r**2 - 504*D1**2*f*gd2*r*s + 504*D1**2*f*gd2*r - 252*D1**2*f*gd2*s**2 + 504*D1**2*f*gd2*s - 252*D1**2*f*gd2 + 756*D1**2*f*gdd2*r**2 + 1512*D1**2*f*gdd2*r*s - 1512*D1**2*f*gdd2*r + 756*D1**2*f*gdd2*s**2 - 1512*D1**2*f*gdd2*s + 756*D1**2*f*gdd2 + 90*D1**2*fd**2*r**2 + 180*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 90*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 252*D1**2*fd*g2*r**2 - 504*D1**2*fd*g2*r*s - 252*D1**2*fd*g2*s**2 + 1512*D1**2*fd*gd2*r**2 + 3024*D1**2*fd*gd2*r*s - 1512*D1**2*fd*gd2*r + 1512*D1**2*fd*gd2*s**2 - 1512*D1**2*fd*gd2*s + 756*D1**2*fdd*g2*r**2 + 1512*D1**2*fdd*g2*r*s + 756*D1**2*fdd*g2*s**2 + 648*D1*Dd*K*f**2*r**2 + 1296*D1*Dd*K*f**2*r*s - 972*D1*Dd*K*f**2*r + 648*D1*Dd*K*f**2*s**2 - 972*D1*Dd*K*f**2*s + 486*D1*Dd*K*f**2 - 4320*D1*Dd*K*f*fd*r**2 - 8640*D1*Dd*K*f*fd*r*s + 5400*D1*Dd*K*f*fd*r - 4320*D1*Dd*K*f*fd*s**2 + 5400*D1*Dd*K*f*fd*s - 1620*D1*Dd*K*f*fd - 100*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 75*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 + 1680*D1*Dd*f**2*fd*r*s - 1190*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 1190*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 162*D1*Dd*f**2*r - 108*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1440*D1*Dd*f*fd*r*s - 900*D1*Dd*f*fd*r + 720*D1*Dd*f*fd*s**2 - 900*D1*Dd*f*fd*s + 270*D1*Dd*f*fd - 1008*D1*Dd*f*g2*r**2 - 2016*D1*Dd*f*g2*r*s + 1512*D1*Dd*f*g2*r - 1008*D1*Dd*f*g2*s**2 + 1512*D1*Dd*f*g2*s - 756*D1*Dd*f*g2 + 6048*D1*Dd*f*gd2*r**2 + 12096*D1*Dd*f*gd2*r*s - 10584*D1*Dd*f*gd2*r + 6048*D1*Dd*f*gd2*s**2 - 10584*D1*Dd*f*gd2*s + 4536*D1*Dd*f*gd2 + 6048*D1*Dd*fd*g2*r**2 + 12096*D1*Dd*fd*g2*r*s - 4536*D1*Dd*fd*g2*r + 6048*D1*Dd*fd*g2*s**2 - 4536*D1*Dd*fd*g2*s - 1080*D1*Ddd*K*f**2*r**2 - 2160*D1*Ddd*K*f**2*r*s + 1620*D1*Ddd*K*f**2*r - 1080*D1*Ddd*K*f**2*s**2 + 1620*D1*Ddd*K*f**2*s - 810*D1*Ddd*K*f**2 + 140*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r*s - 210*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 210*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 + 360*D1*Ddd*f**2*r*s - 270*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s**2 - 270*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 + 3024*D1*Ddd*f*g2*r**2 + 6048*D1*Ddd*f*g2*r*s - 4536*D1*Ddd*f*g2*r + 3024*D1*Ddd*f*g2*s**2 - 4536*D1*Ddd*f*g2*s + 2268*D1*Ddd*f*g2 - 6*D1*bd1*(D1*(9*f**2*(r + s - 1) - 30*f*fd*(2*r + 2*s - 1) - 7*f*(6*K - 1)*(r + s - 1) + 42*fd*(6*K - 1)*(r + s)) - 6*Dd*f*(-42*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) - 3240*Dd**2*K*f**2*r**2 - 6480*Dd**2*K*f**2*r*s + 4860*Dd**2*K*f**2*r - 3240*Dd**2*K*f**2*s**2 + 4860*Dd**2*K*f**2*s - 1620*Dd**2*K*f**2 + 420*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r*s - 630*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 630*Dd**2*f**3*s + 210*Dd**2*f**3 + 540*Dd**2*f**2*r**2 + 1080*Dd**2*f**2*r*s - 810*Dd**2*f**2*r + 540*Dd**2*f**2*s**2 - 810*Dd**2*f**2*s + 270*Dd**2*f**2 + 9072*Dd**2*f*g2*r**2 + 18144*Dd**2*f*g2*r*s - 13608*Dd**2*f*g2*r + 9072*Dd**2*f*g2*s**2 - 13608*Dd**2*f*g2*s + 4536*Dd**2*f*g2))/(105*d**2*k3**8) - D1**2*Pk1*Pk3*ct*k1**5*st**2*(16*C - 8)*(b1*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 9*fd*(2*s - 1)*(8*r + 8*s - 5)) - 9*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 9*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(7*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k2*k3**6) + D1**2*Pk1*Pk3*ct*k1**5*(16*C - 8)*(7*b1*(D1**2*(f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-7*bdd1*s*(r + s - 1) + 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 7*D1*bd1*(D1*(f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 5*D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k2*k3**6) - 4*D1**2*Pk1*Pk3*ct*k1**3*k2**3*st**4*(432*C*D1**2*b1*f*fd*r**2 + 864*C*D1**2*b1*f*fd*r*s - 432*C*D1**2*b1*f*fd*r + 432*C*D1**2*b1*f*fd*s**2 - 432*C*D1**2*b1*f*fd*s + 216*C*D1**2*b1*f*fd - 384*C*D1**2*b1*f*fdd*r**2 - 768*C*D1**2*b1*f*fdd*r*s + 384*C*D1**2*b1*f*fdd*r - 384*C*D1**2*b1*f*fdd*s**2 + 384*C*D1**2*b1*f*fdd*s - 192*C*D1**2*b1*f*fdd - 384*C*D1**2*b1*fd**2*r**2 - 768*C*D1**2*b1*fd**2*r*s + 384*C*D1**2*b1*fd**2*r - 384*C*D1**2*b1*fd**2*s**2 + 384*C*D1**2*b1*fd**2*s + 312*C*D1**2*f**2*fd*r**2 + 624*C*D1**2*f**2*fd*r*s - 416*C*D1**2*f**2*fd*r + 312*C*D1**2*f**2*fd*s**2 - 416*C*D1**2*f**2*fd*s + 208*C*D1**2*f**2*fd - 192*C*D1**2*f**2*fdd*r**2 - 384*C*D1**2*f**2*fdd*r*s + 256*C*D1**2*f**2*fdd*r - 192*C*D1**2*f**2*fdd*s**2 + 256*C*D1**2*f**2*fdd*s - 128*C*D1**2*f**2*fdd - 384*C*D1**2*f*fd**2*r**2 - 768*C*D1**2*f*fd**2*r*s + 512*C*D1**2*f*fd**2*r - 384*C*D1**2*f*fd**2*s**2 + 512*C*D1**2*f*fd**2*s - 128*C*D1**2*f*fd**2 + 864*C*D1*Dd*b1*f**2*r**2 + 1728*C*D1*Dd*b1*f**2*r*s - 1296*C*D1*Dd*b1*f**2*r + 864*C*D1*Dd*b1*f**2*s**2 - 1296*C*D1*Dd*b1*f**2*s + 648*C*D1*Dd*b1*f**2 - 3072*C*D1*Dd*b1*f*fd*r**2 - 6144*C*D1*Dd*b1*f*fd*r*s + 3840*C*D1*Dd*b1*f*fd*r - 3072*C*D1*Dd*b1*f*fd*s**2 + 3840*C*D1*Dd*b1*f*fd*s - 1152*C*D1*Dd*b1*f*fd + 416*C*D1*Dd*f**3*r**2 + 832*C*D1*Dd*f**3*r*s - 624*C*D1*Dd*f**3*r + 416*C*D1*Dd*f**3*s**2 - 624*C*D1*Dd*f**3*s + 312*C*D1*Dd*f**3 - 1536*C*D1*Dd*f**2*fd*r**2 - 3072*C*D1*Dd*f**2*fd*r*s + 2176*C*D1*Dd*f**2*fd*r - 1536*C*D1*Dd*f**2*fd*s**2 + 2176*C*D1*Dd*f**2*fd*s - 768*C*D1*Dd*f**2*fd - 768*C*D1*Ddd*b1*f**2*r**2 - 1536*C*D1*Ddd*b1*f**2*r*s + 1152*C*D1*Ddd*b1*f**2*r - 768*C*D1*Ddd*b1*f**2*s**2 + 1152*C*D1*Ddd*b1*f**2*s - 576*C*D1*Ddd*b1*f**2 - 256*C*D1*Ddd*f**3*r**2 - 512*C*D1*Ddd*f**3*r*s + 384*C*D1*Ddd*f**3*r - 256*C*D1*Ddd*f**3*s**2 + 384*C*D1*Ddd*f**3*s - 192*C*D1*Ddd*f**3 - 2304*C*Dd**2*b1*f**2*r**2 - 4608*C*Dd**2*b1*f**2*r*s + 3456*C*Dd**2*b1*f**2*r - 2304*C*Dd**2*b1*f**2*s**2 + 3456*C*Dd**2*b1*f**2*s - 1152*C*Dd**2*b1*f**2 - 768*C*Dd**2*f**3*r**2 - 1536*C*Dd**2*f**3*r*s + 1152*C*Dd**2*f**3*r - 768*C*Dd**2*f**3*s**2 + 1152*C*Dd**2*f**3*s - 384*C*Dd**2*f**3 - 246*D1**2*b1*f*fd*r**2 - 492*D1**2*b1*f*fd*r*s + 246*D1**2*b1*f*fd*r - 246*D1**2*b1*f*fd*s**2 + 246*D1**2*b1*f*fd*s - 123*D1**2*b1*f*fd + 228*D1**2*b1*f*fdd*r**2 + 456*D1**2*b1*f*fdd*r*s - 228*D1**2*b1*f*fdd*r + 228*D1**2*b1*f*fdd*s**2 - 228*D1**2*b1*f*fdd*s + 114*D1**2*b1*f*fdd + 228*D1**2*b1*fd**2*r**2 + 456*D1**2*b1*fd**2*r*s - 228*D1**2*b1*fd**2*r + 228*D1**2*b1*fd**2*s**2 - 228*D1**2*b1*fd**2*s - 6*D1**2*bdd1*f**2*(32*C - 19)*(r + s - 1)**2 - 183*D1**2*f**2*fd*r**2 - 366*D1**2*f**2*fd*r*s + 244*D1**2*f**2*fd*r - 183*D1**2*f**2*fd*s**2 + 244*D1**2*f**2*fd*s - 122*D1**2*f**2*fd + 114*D1**2*f**2*fdd*r**2 + 228*D1**2*f**2*fdd*r*s - 152*D1**2*f**2*fdd*r + 114*D1**2*f**2*fdd*s**2 - 152*D1**2*f**2*fdd*s + 76*D1**2*f**2*fdd + 228*D1**2*f*fd**2*r**2 + 456*D1**2*f*fd**2*r*s - 304*D1**2*f*fd**2*r + 228*D1**2*f*fd**2*s**2 - 304*D1**2*f*fd**2*s + 76*D1**2*f*fd**2 - 492*D1*Dd*b1*f**2*r**2 - 984*D1*Dd*b1*f**2*r*s + 738*D1*Dd*b1*f**2*r - 492*D1*Dd*b1*f**2*s**2 + 738*D1*Dd*b1*f**2*s - 369*D1*Dd*b1*f**2 + 1824*D1*Dd*b1*f*fd*r**2 + 3648*D1*Dd*b1*f*fd*r*s - 2280*D1*Dd*b1*f*fd*r + 1824*D1*Dd*b1*f*fd*s**2 - 2280*D1*Dd*b1*f*fd*s + 684*D1*Dd*b1*f*fd - 244*D1*Dd*f**3*r**2 - 488*D1*Dd*f**3*r*s + 366*D1*Dd*f**3*r - 244*D1*Dd*f**3*s**2 + 366*D1*Dd*f**3*s - 183*D1*Dd*f**3 + 912*D1*Dd*f**2*fd*r**2 + 1824*D1*Dd*f**2*fd*r*s - 1292*D1*Dd*f**2*fd*r + 912*D1*Dd*f**2*fd*s**2 - 1292*D1*Dd*f**2*fd*s + 456*D1*Dd*f**2*fd + 456*D1*Ddd*b1*f**2*r**2 + 912*D1*Ddd*b1*f**2*r*s - 684*D1*Ddd*b1*f**2*r + 456*D1*Ddd*b1*f**2*s**2 - 684*D1*Ddd*b1*f**2*s + 342*D1*Ddd*b1*f**2 + 152*D1*Ddd*f**3*r**2 + 304*D1*Ddd*f**3*r*s - 228*D1*Ddd*f**3*r + 152*D1*Ddd*f**3*s**2 - 228*D1*Ddd*f**3*s + 114*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(72*C - 41)*(r + s - 1) - D1*fd*(128*C - 76)*(2*r + 2*s - 1) - Dd*f*(128*C - 76)*(4*r + 4*s - 3)) + 1368*Dd**2*b1*f**2*r**2 + 2736*Dd**2*b1*f**2*r*s - 2052*Dd**2*b1*f**2*r + 1368*Dd**2*b1*f**2*s**2 - 2052*Dd**2*b1*f**2*s + 684*Dd**2*b1*f**2 + 456*Dd**2*f**3*r**2 + 912*Dd**2*f**3*r*s - 684*Dd**2*f**3*r + 456*Dd**2*f**3*s**2 - 684*Dd**2*f**3*s + 228*Dd**2*f**3)/(35*d**2*k3**8) - 4*D1**2*Pk1*Pk3*ct*k1**3*k2**3*st**2*(-4752*C*D1**2*f**2*fd*r**2 - 9504*C*D1**2*f**2*fd*r*s + 6336*C*D1**2*f**2*fd*r - 4752*C*D1**2*f**2*fd*s**2 + 6336*C*D1**2*f**2*fd*s - 3168*C*D1**2*f**2*fd - 6336*C*D1*Dd*f**3*r**2 - 12672*C*D1*Dd*f**3*r*s + 9504*C*D1*Dd*f**3*r - 6336*C*D1*Dd*f**3*s**2 + 9504*C*D1*Dd*f**3*s - 4752*C*D1*Dd*f**3 - 2376*D1**2*K*bdd1*f**2*r**2 - 4752*D1**2*K*bdd1*f**2*r*s + 4752*D1**2*K*bdd1*f**2*r - 2376*D1**2*K*bdd1*f**2*s**2 + 4752*D1**2*K*bdd1*f**2*s - 2376*D1**2*K*bdd1*f**2 + 396*D1**2*bd1**2*f*(-28*K + 15*f + 7)*(r + s - 1)**2 + 825*D1**2*bdd1*f**3*r**2 + 1650*D1**2*bdd1*f**3*r*s - 1650*D1**2*bdd1*f**3*r + 825*D1**2*bdd1*f**3*s**2 - 1650*D1**2*bdd1*f**3*s + 825*D1**2*bdd1*f**3 + 594*D1**2*bdd1*f**2*r**2 + 1188*D1**2*bdd1*f**2*r*s - 1188*D1**2*bdd1*f**2*r + 594*D1**2*bdd1*f**2*s**2 - 1188*D1**2*bdd1*f**2*s + 594*D1**2*bdd1*f**2 + 11088*D1**2*bdd1*f*g2*r**2 + 22176*D1**2*bdd1*f*g2*r*s - 22176*D1**2*bdd1*f*g2*r + 11088*D1**2*bdd1*f*g2*s**2 - 22176*D1**2*bdd1*f*g2*s + 11088*D1**2*bdd1*f*g2 + 1780*D1**2*f**3*fd*r**2 + 3560*D1**2*f**3*fd*r*s - 2670*D1**2*f**3*fd*r + 1780*D1**2*f**3*fd*s**2 - 2670*D1**2*f**3*fd*s + 1335*D1**2*f**3*fd - 2100*D1**2*f**3*fdd*r**2 - 4200*D1**2*f**3*fdd*r*s + 3150*D1**2*f**3*fdd*r - 2100*D1**2*f**3*fdd*s**2 + 3150*D1**2*f**3*fdd*s - 1575*D1**2*f**3*fdd - 6300*D1**2*f**2*fd**2*r**2 - 12600*D1**2*f**2*fd**2*r*s + 9450*D1**2*f**2*fd**2*r - 6300*D1**2*f**2*fd**2*s**2 + 9450*D1**2*f**2*fd**2*s - 3150*D1**2*f**2*fd**2 + 2673*D1**2*f**2*fd*r**2 + 5346*D1**2*f**2*fd*r*s - 3564*D1**2*f**2*fd*r + 2673*D1**2*f**2*fd*s**2 - 3564*D1**2*f**2*fd*s + 1782*D1**2*f**2*fd - 7656*D1**2*f**2*gd2*r**2 - 15312*D1**2*f**2*gd2*r*s + 15312*D1**2*f**2*gd2*r - 7656*D1**2*f**2*gd2*s**2 + 15312*D1**2*f**2*gd2*s - 7656*D1**2*f**2*gd2 + 4752*D1**2*f**2*gdd2*r**2 + 9504*D1**2*f**2*gdd2*r*s - 9504*D1**2*f**2*gdd2*r + 4752*D1**2*f**2*gdd2*s**2 - 9504*D1**2*f**2*gdd2*s + 4752*D1**2*f**2*gdd2 - 15312*D1**2*f*fd*g2*r**2 - 30624*D1**2*f*fd*g2*r*s + 15312*D1**2*f*fd*g2*r - 15312*D1**2*f*fd*g2*s**2 + 15312*D1**2*f*fd*g2*s - 7656*D1**2*f*fd*g2 + 19008*D1**2*f*fd*gd2*r**2 + 38016*D1**2*f*fd*gd2*r*s - 28512*D1**2*f*fd*gd2*r + 19008*D1**2*f*fd*gd2*s**2 - 28512*D1**2*f*fd*gd2*s + 9504*D1**2*f*fd*gd2 + 9504*D1**2*f*fdd*g2*r**2 + 19008*D1**2*f*fdd*g2*r*s - 9504*D1**2*f*fdd*g2*r + 9504*D1**2*f*fdd*g2*s**2 - 9504*D1**2*f*fdd*g2*s + 4752*D1**2*f*fdd*g2 + 9504*D1**2*fd**2*g2*r**2 + 19008*D1**2*fd**2*g2*r*s - 9504*D1**2*fd**2*g2*r + 9504*D1**2*fd**2*g2*s**2 - 9504*D1**2*fd**2*g2*s + 1780*D1*Dd*f**4*r**2 + 3560*D1*Dd*f**4*r*s - 2670*D1*Dd*f**4*r + 1780*D1*Dd*f**4*s**2 - 2670*D1*Dd*f**4*s + 1335*D1*Dd*f**4 - 16800*D1*Dd*f**3*fd*r**2 - 33600*D1*Dd*f**3*fd*r*s + 25200*D1*Dd*f**3*fd*r - 16800*D1*Dd*f**3*fd*s**2 + 25200*D1*Dd*f**3*fd*s - 9450*D1*Dd*f**3*fd + 3564*D1*Dd*f**3*r**2 + 7128*D1*Dd*f**3*r*s - 5346*D1*Dd*f**3*r + 3564*D1*Dd*f**3*s**2 - 5346*D1*Dd*f**3*s + 2673*D1*Dd*f**3 - 30624*D1*Dd*f**2*g2*r**2 - 61248*D1*Dd*f**2*g2*r*s + 45936*D1*Dd*f**2*g2*r - 30624*D1*Dd*f**2*g2*s**2 + 45936*D1*Dd*f**2*g2*s - 22968*D1*Dd*f**2*g2 + 38016*D1*Dd*f**2*gd2*r**2 + 76032*D1*Dd*f**2*gd2*r*s - 66528*D1*Dd*f**2*gd2*r + 38016*D1*Dd*f**2*gd2*s**2 - 66528*D1*Dd*f**2*gd2*s + 28512*D1*Dd*f**2*gd2 + 76032*D1*Dd*f*fd*g2*r**2 + 152064*D1*Dd*f*fd*g2*r*s - 95040*D1*Dd*f*fd*g2*r + 76032*D1*Dd*f*fd*g2*s**2 - 95040*D1*Dd*f*fd*g2*s + 28512*D1*Dd*f*fd*g2 - 2100*D1*Ddd*f**4*r**2 - 4200*D1*Ddd*f**4*r*s + 3150*D1*Ddd*f**4*r - 2100*D1*Ddd*f**4*s**2 + 3150*D1*Ddd*f**4*s - 1575*D1*Ddd*f**4 + 19008*D1*Ddd*f**2*g2*r**2 + 38016*D1*Ddd*f**2*g2*r*s - 28512*D1*Ddd*f**2*g2*r + 19008*D1*Ddd*f**2*g2*s**2 - 28512*D1*Ddd*f**2*g2*s + 14256*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(19*f**3*(r + s - 1) + f**2*(56*C*(r + s - 1) - 25*fd*(3*r + 3*s - 2) - (58*K + 17)*(r + s - 1)) + 2*f*(9*fd*(4*K - 1)*(2*r + 2*s - 1) + (98*g2 - 168*gd2)*(r + s - 1)) - 336*fd*g2*(r + s)) - Dd*f*(25*f**2 + f*(18 - 72*K) + 336*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6300*Dd**2*f**4*r**2 - 12600*Dd**2*f**4*r*s + 9450*Dd**2*f**4*r - 6300*Dd**2*f**4*s**2 + 9450*Dd**2*f**4*s - 3150*Dd**2*f**4 + 57024*Dd**2*f**2*g2*r**2 + 114048*Dd**2*f**2*g2*r*s - 85536*Dd**2*f**2*g2*r + 57024*Dd**2*f**2*g2*s**2 - 85536*Dd**2*f**2*g2*s + 28512*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(15*f*(5*fd - 6*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(180*fd**2*(r + s - 1) + 49*fd*(4*K - 1)*(r + s) - 42*fdd*(4*K - 1)*(r + s))) + D1*(Dd*(75*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(180*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (196*K - 49)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 84*fd*(4*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-28*K + 15*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-28*K + 15*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(224*C*D1**2*f*fd*r**2 + 448*C*D1**2*f*fd*r*s - 224*C*D1**2*f*fd*r + 224*C*D1**2*f*fd*s**2 - 224*C*D1**2*f*fd*s + 112*C*D1**2*f*fd + 448*C*D1*Dd*f**2*r**2 + 896*C*D1*Dd*f**2*r*s - 672*C*D1*Dd*f**2*r + 448*C*D1*Dd*f**2*s**2 - 672*C*D1*Dd*f**2*s + 336*C*D1*Dd*f**2 - 232*D1**2*K*f*fd*r**2 - 464*D1**2*K*f*fd*r*s + 232*D1**2*K*f*fd*r - 232*D1**2*K*f*fd*s**2 + 232*D1**2*K*f*fd*s - 116*D1**2*K*f*fd + 144*D1**2*K*f*fdd*r**2 + 288*D1**2*K*f*fdd*r*s - 144*D1**2*K*f*fdd*r + 144*D1**2*K*f*fdd*s**2 - 144*D1**2*K*f*fdd*s + 72*D1**2*K*f*fdd + 144*D1**2*K*fd**2*r**2 + 288*D1**2*K*fd**2*r*s - 144*D1**2*K*fd**2*r + 144*D1**2*K*fd**2*s**2 - 144*D1**2*K*fd**2*s - 12*D1**2*bdd1*f*(-28*K + 15*f + 7)*(r + s - 1)**2 + 114*D1**2*f**2*fd*r**2 + 228*D1**2*f**2*fd*r*s - 152*D1**2*f**2*fd*r + 114*D1**2*f**2*fd*s**2 - 152*D1**2*f**2*fd*s + 76*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 - 68*D1**2*f*fd*r**2 - 136*D1**2*f*fd*r*s + 68*D1**2*f*fd*r - 68*D1**2*f*fd*s**2 + 68*D1**2*f*fd*s - 34*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd + 392*D1**2*f*gd2*r**2 + 784*D1**2*f*gd2*r*s - 784*D1**2*f*gd2*r + 392*D1**2*f*gd2*s**2 - 784*D1**2*f*gd2*s + 392*D1**2*f*gd2 - 336*D1**2*f*gdd2*r**2 - 672*D1**2*f*gdd2*r*s + 672*D1**2*f*gdd2*r - 336*D1**2*f*gdd2*s**2 + 672*D1**2*f*gdd2*s - 336*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 392*D1**2*fd*g2*r**2 + 784*D1**2*fd*g2*r*s + 392*D1**2*fd*g2*s**2 - 672*D1**2*fd*gd2*r**2 - 1344*D1**2*fd*gd2*r*s + 672*D1**2*fd*gd2*r - 672*D1**2*fd*gd2*s**2 + 672*D1**2*fd*gd2*s - 336*D1**2*fdd*g2*r**2 - 672*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*s**2 - 464*D1*Dd*K*f**2*r**2 - 928*D1*Dd*K*f**2*r*s + 696*D1*Dd*K*f**2*r - 464*D1*Dd*K*f**2*s**2 + 696*D1*Dd*K*f**2*s - 348*D1*Dd*K*f**2 + 1152*D1*Dd*K*f*fd*r**2 + 2304*D1*Dd*K*f*fd*r*s - 1440*D1*Dd*K*f*fd*r + 1152*D1*Dd*K*f*fd*s**2 - 1440*D1*Dd*K*f*fd*s + 432*D1*Dd*K*f*fd + 152*D1*Dd*f**3*r**2 + 304*D1*Dd*f**3*r*s - 228*D1*Dd*f**3*r + 152*D1*Dd*f**3*s**2 - 228*D1*Dd*f**3*s + 114*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 136*D1*Dd*f**2*r**2 - 272*D1*Dd*f**2*r*s + 204*D1*Dd*f**2*r - 136*D1*Dd*f**2*s**2 + 204*D1*Dd*f**2*s - 102*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 1568*D1*Dd*f*g2*r**2 + 3136*D1*Dd*f*g2*r*s - 2352*D1*Dd*f*g2*r + 1568*D1*Dd*f*g2*s**2 - 2352*D1*Dd*f*g2*s + 1176*D1*Dd*f*g2 - 2688*D1*Dd*f*gd2*r**2 - 5376*D1*Dd*f*gd2*r*s + 4704*D1*Dd*f*gd2*r - 2688*D1*Dd*f*gd2*s**2 + 4704*D1*Dd*f*gd2*s - 2016*D1*Dd*f*gd2 - 2688*D1*Dd*fd*g2*r**2 - 5376*D1*Dd*fd*g2*r*s + 2016*D1*Dd*fd*g2*r - 2688*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s + 288*D1*Ddd*K*f**2*r**2 + 576*D1*Ddd*K*f**2*r*s - 432*D1*Ddd*K*f**2*r + 288*D1*Ddd*K*f**2*s**2 - 432*D1*Ddd*K*f**2*s + 216*D1*Ddd*K*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 - 1344*D1*Ddd*f*g2*r**2 - 2688*D1*Ddd*f*g2*r*s + 2016*D1*Ddd*f*g2*r - 1344*D1*Ddd*f*g2*s**2 + 2016*D1*Ddd*f*g2*s - 1008*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(75*f**2*(r + s - 1) - 180*f*fd*(2*r + 2*s - 1) - 49*f*(4*K - 1)*(r + s - 1) + 84*fd*(4*K - 1)*(r + s)) - 12*Dd*f*(-28*K + 15*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 864*Dd**2*K*f**2*r**2 + 1728*Dd**2*K*f**2*r*s - 1296*Dd**2*K*f**2*r + 864*Dd**2*K*f**2*s**2 - 1296*Dd**2*K*f**2*s + 432*Dd**2*K*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3 - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 - 4032*Dd**2*f*g2*r**2 - 8064*Dd**2*f*g2*r*s + 6048*Dd**2*f*g2*r - 4032*Dd**2*f*g2*s**2 + 6048*Dd**2*f*g2*s - 2016*Dd**2*f*g2))/(1155*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct*k1**3*k2*st**4*(b1*(D1**2*(f*(fd*(70*C - 41) + fdd*(24 - 42*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(24 - 42*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(70*C - 41)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(24 - 42*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(24 - 42*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(24 - 42*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(26*C - 15)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (14*C - 8)*(3*bdd1*s*(r + s - 1) + fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(8 - 14*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(70*C - 41)*(r + s - 1) - fd*(42*C - 24)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(24 - 42*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(26*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(14*C - 8)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(8 - 14*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(8 - 14*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k3**6) + 2*D1**2*Pk1*Pk3*ct*k1**3*k2*st**2*(42*b1**2*(D1**2*(fd*(8*C - 7) + fdd*(16*C - 9))*(r + s - 1)**2 + D1*(Dd*(f*(8*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(32*C - 18)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(16*C - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Dd**2*f*(96*C - 54)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(896*C*D1**2*f*fd*r**2 + 4176*C*D1**2*f*fd*r*s - 1928*C*D1**2*f*fd*r + 3280*C*D1**2*f*fd*s**2 - 3120*C*D1**2*f*fd*s + 1560*C*D1**2*f*fd - 1792*C*D1**2*f*fdd*r**2 - 5168*C*D1**2*f*fdd*r*s + 2392*C*D1**2*f*fdd*r - 3376*C*D1**2*f*fdd*s**2 + 3184*C*D1**2*f*fdd*s - 1592*C*D1**2*f*fdd - 1792*C*D1**2*fd**2*r**2 - 5168*C*D1**2*fd**2*r*s + 2392*C*D1**2*fd**2*r - 3376*C*D1**2*fd**2*s**2 + 3184*C*D1**2*fd**2*s + 192*C*D1**2*fd**2 + 1792*C*D1*Dd*f**2*r**2 + 8352*C*D1*Dd*f**2*r*s - 5072*C*D1*Dd*f**2*r + 6560*C*D1*Dd*f**2*s**2 - 8648*C*D1*Dd*f**2*s + 3728*C*D1*Dd*f**2 - 14336*C*D1*Dd*f*fd*r**2 - 41344*C*D1*Dd*f*fd*r*s + 23488*C*D1*Dd*f*fd*r - 27008*C*D1*Dd*f*fd*s**2 + 31408*C*D1*Dd*f*fd*s - 8760*C*D1*Dd*f*fd - 3584*C*D1*Ddd*f**2*r**2 - 10336*C*D1*Ddd*f**2*r*s + 6960*C*D1*Ddd*f**2*r - 6752*C*D1*Ddd*f**2*s**2 + 9336*C*D1*Ddd*f**2*s - 4272*C*D1*Ddd*f**2 - 10752*C*Dd**2*f**2*r**2 - 31008*C*Dd**2*f**2*r*s + 20880*C*Dd**2*f**2*r - 20256*C*Dd**2*f**2*s**2 + 28008*C*Dd**2*f**2*s - 8544*C*Dd**2*f**2 + 14*D1**2*bdd1*f*(16*C - 9)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 534*D1**2*f*fd*r**2 - 2452*D1**2*f*fd*r*s + 1150*D1**2*f*fd*r - 1918*D1**2*f*fd*s**2 + 1842*D1**2*f*fd*s - 921*D1**2*f*fd + 1002*D1**2*f*fdd*r**2 + 3060*D1**2*f*fdd*r*s - 1422*D1**2*f*fdd*r + 2058*D1**2*f*fdd*s**2 - 1950*D1**2*f*fdd*s + 975*D1**2*f*fdd + 1002*D1**2*fd**2*r**2 + 3060*D1**2*fd**2*r*s - 1422*D1**2*fd**2*r + 2058*D1**2*fd**2*s**2 - 1950*D1**2*fd**2*s - 108*D1**2*fd**2 - 1068*D1*Dd*f**2*r**2 - 4904*D1*Dd*f**2*r*s + 2986*D1*Dd*f**2*r - 3836*D1*Dd*f**2*s**2 + 5062*D1*Dd*f**2*s - 2185*D1*Dd*f**2 + 8016*D1*Dd*f*fd*r**2 + 24480*D1*Dd*f*fd*r*s - 13812*D1*Dd*f*fd*r + 16464*D1*Dd*f*fd*s**2 - 19092*D1*Dd*f*fd*s + 5322*D1*Dd*f*fd + 2004*D1*Ddd*f**2*r**2 + 6120*D1*Ddd*f**2*r*s - 4062*D1*Ddd*f**2*r + 4116*D1*Ddd*f**2*s**2 - 5646*D1*Ddd*f**2*s + 2559*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(8*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(32*C - 18)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(32*C - 18)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 6012*Dd**2*f**2*r**2 + 18360*Dd**2*f**2*r*s - 12186*Dd**2*f**2*r + 12348*Dd**2*f**2*s**2 - 16938*Dd**2*f**2*s + 5118*Dd**2*f**2) + f*(4704*C*D1**2*f*fd*r**2 + 12216*C*D1**2*f*fd*r*s - 7208*C*D1**2*f*fd*r + 7512*C*D1**2*f*fd*s**2 - 9080*C*D1**2*f*fd*s + 4072*C*D1**2*f*fd - 5376*C*D1**2*f*fdd*r**2 - 12696*C*D1**2*f*fdd*r*s + 7816*C*D1**2*f*fdd*r - 7320*C*D1**2*f*fdd*s**2 + 9112*C*D1**2*f*fdd*s - 4232*C*D1**2*f*fdd - 10752*C*D1**2*fd**2*r**2 - 25392*C*D1**2*fd**2*r*s + 15632*C*D1**2*fd**2*r - 14640*C*D1**2*fd**2*s**2 + 18224*C*D1**2*fd**2*s - 4232*C*D1**2*fd**2 + 6272*C*D1*Dd*f**2*r**2 + 16288*C*D1*Dd*f**2*r*s - 11280*C*D1*Dd*f**2*r + 10016*C*D1*Dd*f**2*s**2 - 14088*C*D1*Dd*f**2*s + 6576*C*D1*Dd*f**2 - 43008*C*D1*Dd*f*fd*r**2 - 101568*C*D1*Dd*f*fd*r*s + 67408*C*D1*Dd*f*fd*r - 58560*C*D1*Dd*f*fd*s**2 + 78424*C*D1*Dd*f*fd*s - 26040*C*D1*Dd*f*fd - 7168*C*D1*Ddd*f**2*r**2 - 16928*C*D1*Ddd*f**2*r*s + 12048*C*D1*Ddd*f**2*r - 9760*C*D1*Ddd*f**2*s**2 + 13992*C*D1*Ddd*f**2*s - 6672*C*D1*Ddd*f**2 - 21504*C*Dd**2*f**2*r**2 - 50784*C*Dd**2*f**2*r*s + 36144*C*Dd**2*f**2*r - 29280*C*Dd**2*f**2*s**2 + 41976*C*Dd**2*f**2*s - 13344*C*Dd**2*f**2 + 84*D1**2*bd1**2*(16*C - 9)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 3*D1**2*bdd1*f*(8*C*(112*r**2 + 323*r*s - 248*r + 211*s**2 - 347*s + 124) - 501*r**2 - 1530*r*s + 1110*r - 1029*s**2 + 1638*s - 555) - 2661*D1**2*f*fd*r**2 - 7110*D1**2*f*fd*r*s + 4144*D1**2*f*fd*r - 4449*D1**2*f*fd*s**2 + 5336*D1**2*f*fd*s - 2370*D1**2*f*fd + 2991*D1**2*f*fdd*r**2 + 7470*D1**2*f*fdd*r*s - 4484*D1**2*f*fdd*r + 4479*D1**2*f*fdd*s**2 - 5476*D1**2*f*fdd*s + 2490*D1**2*f*fdd + 5982*D1**2*fd**2*r**2 + 14940*D1**2*fd**2*r*s - 8968*D1**2*fd**2*r + 8958*D1**2*fd**2*s**2 - 10952*D1**2*fd**2*s + 2490*D1**2*fd**2 - 3548*D1*Dd*f**2*r**2 - 9480*D1*Dd*f**2*r*s + 6514*D1*Dd*f**2*r - 5932*D1*Dd*f**2*s**2 + 8302*D1*Dd*f**2*s - 3853*D1*Dd*f**2 + 23928*D1*Dd*f*fd*r**2 + 59760*D1*Dd*f*fd*r*s - 38858*D1*Dd*f*fd*r + 35832*D1*Dd*f*fd*s**2 - 47290*D1*Dd*f*fd*s + 15436*D1*Dd*f*fd + 3988*D1*Ddd*f**2*r**2 + 9960*D1*Ddd*f**2*r*s - 6974*D1*Ddd*f**2*r + 5972*D1*Ddd*f**2*s**2 - 8462*D1*Ddd*f**2*s + 3983*D1*Ddd*f**2 + 3*D1*bd1*(-8*C*Dd*f*(896*r**2 + 38*r*(68*s - 49) + 1688*s**2 - 2555*s + 942) + D1*(-8*C*fd*(448*r**2 + r*(1292*s - 795) + 844*s**2 - 1092*s + 347) + f*(8*C*(56*r**2 + 3*r*(87*s - 44) + 205*s**2 - 281*s + 66) - 267*r**2 - 1226*r*s + 610*r - 959*s**2 + 1302*s - 305) + 6*fd*(334*r**2 + r*(1020*s - 607) + 686*s**2 - 871*s + 273)) + 6*Dd*f*(668*r**2 + r*(2040*s - 1417) + 1372*s**2 - 2033*s + 731)) + 11964*Dd**2*f**2*r**2 + 29880*Dd**2*f**2*r*s - 20922*Dd**2*f**2*r + 17916*Dd**2*f**2*s**2 - 25386*Dd**2*f**2*s + 7966*Dd**2*f**2))/(315*d**2*k3**6) + 2*D1**2*Pk1*Pk3*ct*k1**3*k2*(-6216*D1**2*K*bd1**2*f*r**2 - 12432*D1**2*K*bd1**2*f*r*s + 13440*D1**2*K*bd1**2*f*r - 6216*D1**2*K*bd1**2*f*s**2 + 13440*D1**2*K*bd1**2*f*s - 7224*D1**2*K*bd1**2*f + 2124*D1**2*K*bd1*f**2*r**2 + 3528*D1**2*K*bd1*f**2*r*s - 3528*D1**2*K*bd1*f**2*r + 1404*D1**2*K*bd1*f**2*s**2 - 2808*D1**2*K*bd1*f**2*s + 1404*D1**2*K*bd1*f**2 - 10800*D1**2*K*bd1*f*fd*r**2 - 20160*D1**2*K*bd1*f*fd*r*s + 15480*D1**2*K*bd1*f*fd*r - 9360*D1**2*K*bd1*f*fd*s**2 + 14400*D1**2*K*bd1*f*fd*s - 5040*D1**2*K*bd1*f*fd - 2700*D1**2*K*bdd1*f**2*r**2 - 5040*D1**2*K*bdd1*f**2*r*s + 5040*D1**2*K*bdd1*f**2*r - 2340*D1**2*K*bdd1*f**2*s**2 + 4680*D1**2*K*bdd1*f**2*s - 2340*D1**2*K*bdd1*f**2 + 882*D1**2*bd1**2*f**2*r**2 + 2772*D1**2*bd1**2*f**2*r*s - 2448*D1**2*bd1**2*f**2*r + 1890*D1**2*bd1**2*f**2*s**2 - 3456*D1**2*bd1**2*f**2*s + 1566*D1**2*bd1**2*f**2 + 1302*D1**2*bd1**2*f*r**2 + 3612*D1**2*bd1**2*f*r*s - 3360*D1**2*bd1**2*f*r + 2310*D1**2*bd1**2*f*s**2 - 4368*D1**2*bd1**2*f*s + 2058*D1**2*bd1**2*f - 3360*D1**2*bd1**2*g2*r**2 - 6720*D1**2*bd1**2*g2*r*s + 3360*D1**2*bd1**2*g2*r - 3360*D1**2*bd1**2*g2*s**2 + 3360*D1**2*bd1**2*g2*s - 1008*D1**2*bd1*bd2*f*r**2 - 2016*D1**2*bd1*bd2*f*r*s + 2016*D1**2*bd1*bd2*f*r - 1008*D1**2*bd1*bd2*f*s**2 + 2016*D1**2*bd1*bd2*f*s - 1008*D1**2*bd1*bd2*f - 355*D1**2*bd1*f**3*r**2 - 810*D1**2*bd1*f**3*r*s + 990*D1**2*bd1*f**3*r - 455*D1**2*bd1*f**3*s**2 + 1090*D1**2*bd1*f**3*s - 635*D1**2*bd1*f**3 + 2550*D1**2*bd1*f**2*fd*r**2 + 5940*D1**2*bd1*f**2*fd*r*s - 5170*D1**2*bd1*f**2*fd*r + 3390*D1**2*bd1*f**2*fd*s**2 - 5870*D1**2*bd1*f**2*fd*s + 2300*D1**2*bd1*f**2*fd - 441*D1**2*bd1*f**2*r**2 - 954*D1**2*bd1*f**2*r*s + 954*D1**2*bd1*f**2*r - 513*D1**2*bd1*f**2*s**2 + 1026*D1**2*bd1*f**2*s - 513*D1**2*bd1*f**2 + 2268*D1**2*bd1*f*fd*r**2 + 5688*D1**2*bd1*f*fd*r*s - 3978*D1**2*bd1*f*fd*r + 3420*D1**2*bd1*f*fd*s**2 - 4842*D1**2*bd1*f*fd*s + 1422*D1**2*bd1*f*fd - 3192*D1**2*bd1*f*g2*r**2 - 6384*D1**2*bd1*f*g2*r*s + 7056*D1**2*bd1*f*g2*r - 3192*D1**2*bd1*f*g2*s**2 + 7056*D1**2*bd1*f*g2*s - 3528*D1**2*bd1*f*g2 + 12432*D1**2*bd1*f*gd2*r**2 + 24864*D1**2*bd1*f*gd2*r*s - 26880*D1**2*bd1*f*gd2*r + 12432*D1**2*bd1*f*gd2*s**2 - 26880*D1**2*bd1*f*gd2*s + 14448*D1**2*bd1*f*gd2 + 12432*D1**2*bd1*fd*g2*r**2 + 24864*D1**2*bd1*fd*g2*r*s - 12432*D1**2*bd1*fd*g2*r + 12432*D1**2*bd1*fd*g2*s**2 - 12432*D1**2*bd1*fd*g2*s + 216*D1**2*bd2*f**2*r**2 + 432*D1**2*bd2*f**2*r*s - 432*D1**2*bd2*f**2*r + 216*D1**2*bd2*f**2*s**2 - 432*D1**2*bd2*f**2*s + 216*D1**2*bd2*f**2 - 1440*D1**2*bd2*f*fd*r**2 - 2880*D1**2*bd2*f*fd*r*s + 2160*D1**2*bd2*f*fd*r - 1440*D1**2*bd2*f*fd*s**2 + 2160*D1**2*bd2*f*fd*s - 720*D1**2*bd2*f*fd + 425*D1**2*bdd1*f**3*r**2 + 990*D1**2*bdd1*f**3*r*s - 1170*D1**2*bdd1*f**3*r + 565*D1**2*bdd1*f**3*s**2 - 1310*D1**2*bdd1*f**3*s + 745*D1**2*bdd1*f**3 + 567*D1**2*bdd1*f**2*r**2 + 1422*D1**2*bdd1*f**2*r*s - 1422*D1**2*bdd1*f**2*r + 855*D1**2*bdd1*f**2*s**2 - 1710*D1**2*bdd1*f**2*s + 855*D1**2*bdd1*f**2 + 6216*D1**2*bdd1*f*g2*r**2 + 12432*D1**2*bdd1*f*g2*r*s - 14448*D1**2*bdd1*f*g2*r + 6216*D1**2*bdd1*f*g2*s**2 - 14448*D1**2*bdd1*f*g2*s + 7224*D1**2*bdd1*f*g2 - 360*D1**2*bdd2*f**2*r**2 - 720*D1**2*bdd2*f**2*r*s + 720*D1**2*bdd2*f**2*r - 360*D1**2*bdd2*f**2*s**2 + 720*D1**2*bdd2*f**2*s - 360*D1**2*bdd2*f**2 + 560*D1**2*f**3*fd*r*s - 280*D1**2*f**3*fd*r + 560*D1**2*f**3*fd*s**2 - 700*D1**2*f**3*fd*s + 280*D1**2*f**3*fd - 560*D1**2*f**3*fdd*r*s + 280*D1**2*f**3*fdd*r - 560*D1**2*f**3*fdd*s**2 + 700*D1**2*f**3*fdd*s - 280*D1**2*f**3*fdd - 1680*D1**2*f**2*fd**2*r*s + 840*D1**2*f**2*fd**2*r - 1680*D1**2*f**2*fd**2*s**2 + 2100*D1**2*f**2*fd**2*s - 560*D1**2*f**2*fd**2 - 4248*D1**2*f**2*gd2*r**2 - 7056*D1**2*f**2*gd2*r*s + 7056*D1**2*f**2*gd2*r - 2808*D1**2*f**2*gd2*s**2 + 5616*D1**2*f**2*gd2*s - 2808*D1**2*f**2*gd2 + 5400*D1**2*f**2*gdd2*r**2 + 10080*D1**2*f**2*gdd2*r*s - 10080*D1**2*f**2*gdd2*r + 4680*D1**2*f**2*gdd2*s**2 - 9360*D1**2*f**2*gdd2*s + 4680*D1**2*f**2*gdd2 - 8496*D1**2*f*fd*g2*r**2 - 14112*D1**2*f*fd*g2*r*s + 8496*D1**2*f*fd*g2*r - 5616*D1**2*f*fd*g2*s**2 + 7056*D1**2*f*fd*g2*s - 4248*D1**2*f*fd*g2 + 21600*D1**2*f*fd*gd2*r**2 + 40320*D1**2*f*fd*gd2*r*s - 30960*D1**2*f*fd*gd2*r + 18720*D1**2*f*fd*gd2*s**2 - 28800*D1**2*f*fd*gd2*s + 10080*D1**2*f*fd*gd2 + 10800*D1**2*f*fdd*g2*r**2 + 20160*D1**2*f*fdd*g2*r*s - 10800*D1**2*f*fdd*g2*r + 9360*D1**2*f*fdd*g2*s**2 - 10080*D1**2*f*fdd*g2*s + 5400*D1**2*f*fdd*g2 + 10800*D1**2*fd**2*g2*r**2 + 20160*D1**2*fd**2*g2*r*s - 10800*D1**2*fd**2*g2*r + 9360*D1**2*fd**2*g2*s**2 - 10080*D1**2*fd**2*g2*s - 21600*D1*Dd*K*bd1*f**2*r**2 - 40320*D1*Dd*K*bd1*f**2*r*s + 35640*D1*Dd*K*bd1*f**2*r - 18720*D1*Dd*K*bd1*f**2*s**2 + 33120*D1*Dd*K*bd1*f**2*s - 14400*D1*Dd*K*bd1*f**2 + 3400*D1*Dd*bd1*f**3*r**2 + 7920*D1*Dd*bd1*f**3*r*s - 7510*D1*Dd*bd1*f**3*r + 4520*D1*Dd*bd1*f**3*s**2 - 8490*D1*Dd*bd1*f**3*s + 3790*D1*Dd*bd1*f**3 + 4536*D1*Dd*bd1*f**2*r**2 + 11376*D1*Dd*bd1*f**2*r*s - 9666*D1*Dd*bd1*f**2*r + 6840*D1*Dd*bd1*f**2*s**2 - 11682*D1*Dd*bd1*f**2*s + 4842*D1*Dd*bd1*f**2 + 49728*D1*Dd*bd1*f*g2*r**2 + 99456*D1*Dd*bd1*f*g2*r*s - 95088*D1*Dd*bd1*f*g2*r + 49728*D1*Dd*bd1*f*g2*s**2 - 95088*D1*Dd*bd1*f*g2*s + 43344*D1*Dd*bd1*f*g2 - 2880*D1*Dd*bd2*f**2*r**2 - 5760*D1*Dd*bd2*f**2*r*s + 5040*D1*Dd*bd2*f**2*r - 2880*D1*Dd*bd2*f**2*s**2 + 5040*D1*Dd*bd2*f**2*s - 2160*D1*Dd*bd2*f**2 + 560*D1*Dd*f**4*r*s - 280*D1*Dd*f**4*r + 560*D1*Dd*f**4*s**2 - 700*D1*Dd*f**4*s + 280*D1*Dd*f**4 - 4480*D1*Dd*f**3*fd*r*s + 2240*D1*Dd*f**3*fd*r - 4480*D1*Dd*f**3*fd*s**2 + 5600*D1*Dd*f**3*fd*s - 1680*D1*Dd*f**3*fd - 16992*D1*Dd*f**2*g2*r**2 - 28224*D1*Dd*f**2*g2*r*s + 22608*D1*Dd*f**2*g2*r - 11232*D1*Dd*f**2*g2*s**2 + 18288*D1*Dd*f**2*g2*s - 9864*D1*Dd*f**2*g2 + 43200*D1*Dd*f**2*gd2*r**2 + 80640*D1*Dd*f**2*gd2*r*s - 71280*D1*Dd*f**2*gd2*r + 37440*D1*Dd*f**2*gd2*s**2 - 66240*D1*Dd*f**2*gd2*s + 28800*D1*Dd*f**2*gd2 + 86400*D1*Dd*f*fd*g2*r**2 + 161280*D1*Dd*f*fd*g2*r*s - 105120*D1*Dd*f*fd*g2*r + 74880*D1*Dd*f*fd*g2*s**2 - 97920*D1*Dd*f*fd*g2*s + 30960*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**4*r*s + 280*D1*Ddd*f**4*r - 560*D1*Ddd*f**4*s**2 + 700*D1*Ddd*f**4*s - 280*D1*Ddd*f**4 + 21600*D1*Ddd*f**2*g2*r**2 + 40320*D1*Ddd*f**2*g2*r*s - 30960*D1*Ddd*f**2*g2*r + 18720*D1*Ddd*f**2*g2*s**2 - 28800*D1*Ddd*f**2*g2*s + 14760*D1*Ddd*f**2*g2 - 1680*Dd**2*f**4*r*s + 840*Dd**2*f**4*r - 1680*Dd**2*f**4*s**2 + 2100*Dd**2*f**4*s - 560*Dd**2*f**4 + 64800*Dd**2*f**2*g2*r**2 + 120960*Dd**2*f**2*g2*r*s - 92880*Dd**2*f**2*g2*r + 56160*Dd**2*f**2*g2*s**2 - 86400*Dd**2*f**2*g2*s + 29520*Dd**2*f**2*g2 + 42*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (20*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-20*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-20*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(532*D1**2*K*fd*r**2 + 1064*D1**2*K*fd*r*s + 112*D1**2*K*fd*r + 532*D1**2*K*fd*s**2 + 112*D1**2*K*fd*s - 56*D1**2*K*fd - 1036*D1**2*K*fdd*r**2 - 2072*D1**2*K*fdd*r*s - 336*D1**2*K*fdd*r - 1036*D1**2*K*fdd*s**2 - 336*D1**2*K*fdd*s + 168*D1**2*K*fdd - 14*D1**2*bdd1*(-20*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 210*D1**2*f*fd*r**2 - 756*D1**2*f*fd*r*s + 342*D1**2*f*fd*r - 546*D1**2*f*fd*s**2 + 510*D1**2*f*fd*s - 255*D1**2*f*fd + 294*D1**2*f*fdd*r**2 + 924*D1**2*f*fdd*r*s - 402*D1**2*f*fdd*r + 630*D1**2*f*fdd*s**2 - 570*D1**2*f*fdd*s + 285*D1**2*f*fdd + 294*D1**2*fd**2*r**2 + 924*D1**2*fd**2*r*s - 402*D1**2*fd**2*r + 630*D1**2*fd**2*s**2 - 570*D1**2*fd**2*s - 60*D1**2*fd**2 - 119*D1**2*fd*r**2 - 294*D1**2*fd*r*s - 28*D1**2*fd*r - 175*D1**2*fd*s**2 - 28*D1**2*fd*s + 14*D1**2*fd + 217*D1**2*fdd*r**2 + 602*D1**2*fdd*r*s + 84*D1**2*fdd*r + 385*D1**2*fdd*s**2 + 84*D1**2*fdd*s - 42*D1**2*fdd - 560*D1**2*gd2*r**2 - 1120*D1**2*gd2*r*s + 1120*D1**2*gd2*r - 560*D1**2*gd2*s**2 + 1120*D1**2*gd2*s - 560*D1**2*gd2 - 560*D1**2*gdd2*r**2 - 1120*D1**2*gdd2*r*s + 1120*D1**2*gdd2*r - 560*D1**2*gdd2*s**2 + 1120*D1**2*gdd2*s - 560*D1**2*gdd2 + 2128*D1*Dd*K*f*r**2 + 4256*D1*Dd*K*f*r*s - 3192*D1*Dd*K*f*r + 2128*D1*Dd*K*f*s**2 - 3192*D1*Dd*K*f*s + 1596*D1*Dd*K*f - 8288*D1*Dd*K*fd*r**2 - 16576*D1*Dd*K*fd*r*s + 4872*D1*Dd*K*fd*r - 8288*D1*Dd*K*fd*s**2 + 4872*D1*Dd*K*fd*s + 1008*D1*Dd*K*fd - 420*D1*Dd*f**2*r**2 - 1512*D1*Dd*f**2*r*s + 966*D1*Dd*f**2*r - 1092*D1*Dd*f**2*s**2 + 1470*D1*Dd*f**2*s - 651*D1*Dd*f**2 + 2352*D1*Dd*f*fd*r**2 + 7392*D1*Dd*f*fd*r*s - 4044*D1*Dd*f*fd*r + 5040*D1*Dd*f*fd*s**2 - 5724*D1*Dd*f*fd*s + 1542*D1*Dd*f*fd - 476*D1*Dd*f*r**2 - 1176*D1*Dd*f*r*s + 826*D1*Dd*f*r - 700*D1*Dd*f*s**2 + 994*D1*Dd*f*s - 469*D1*Dd*f + 1736*D1*Dd*fd*r**2 + 4816*D1*Dd*fd*r*s - 1302*D1*Dd*fd*r + 3080*D1*Dd*fd*s**2 - 1806*D1*Dd*fd*s - 252*D1*Dd*fd - 2240*D1*Dd*g2*r**2 - 4480*D1*Dd*g2*r*s + 3360*D1*Dd*g2*r - 2240*D1*Dd*g2*s**2 + 3360*D1*Dd*g2*s - 1680*D1*Dd*g2 - 4480*D1*Dd*gd2*r**2 - 8960*D1*Dd*gd2*r*s + 7840*D1*Dd*gd2*r - 4480*D1*Dd*gd2*s**2 + 7840*D1*Dd*gd2*s - 3360*D1*Dd*gd2 - 4144*D1*Ddd*K*f*r**2 - 8288*D1*Ddd*K*f*r*s + 6216*D1*Ddd*K*f*r - 4144*D1*Ddd*K*f*s**2 + 6216*D1*Ddd*K*f*s - 3108*D1*Ddd*K*f + 588*D1*Ddd*f**2*r**2 + 1848*D1*Ddd*f**2*r*s - 1218*D1*Ddd*f**2*r + 1260*D1*Ddd*f**2*s**2 - 1722*D1*Ddd*f**2*s + 777*D1*Ddd*f**2 + 868*D1*Ddd*f*r**2 + 2408*D1*Ddd*f*r*s - 1638*D1*Ddd*f*r + 1540*D1*Ddd*f*s**2 - 2142*D1*Ddd*f*s + 987*D1*Ddd*f - 2240*D1*Ddd*g2*r**2 - 4480*D1*Ddd*g2*r*s + 3360*D1*Ddd*g2*r - 2240*D1*Ddd*g2*s**2 + 3360*D1*Ddd*g2*s - 1680*D1*Ddd*g2 + 14*D1*bd1*(D1*(f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (20*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-20*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 12432*Dd**2*K*f*r**2 - 24864*Dd**2*K*f*r*s + 18648*Dd**2*K*f*r - 12432*Dd**2*K*f*s**2 + 18648*Dd**2*K*f*s - 6216*Dd**2*K*f + 1764*Dd**2*f**2*r**2 + 5544*Dd**2*f**2*r*s - 3654*Dd**2*f**2*r + 3780*Dd**2*f**2*s**2 - 5166*Dd**2*f**2*s + 1554*Dd**2*f**2 + 2604*Dd**2*f*r**2 + 7224*Dd**2*f*r*s - 4914*Dd**2*f*r + 4620*Dd**2*f*s**2 - 6426*Dd**2*f*s + 1974*Dd**2*f - 6720*Dd**2*g2*r**2 - 13440*Dd**2*g2*r*s + 10080*Dd**2*g2*r - 6720*Dd**2*g2*s**2 + 10080*Dd**2*g2*s - 3360*Dd**2*g2) - b1*(6216*D1**2*K*bdd1*f*r**2 + 12432*D1**2*K*bdd1*f*r*s - 13440*D1**2*K*bdd1*f*r + 6216*D1**2*K*bdd1*f*s**2 - 13440*D1**2*K*bdd1*f*s + 6720*D1**2*K*bdd1*f - 4248*D1**2*K*f*fd*r**2 - 7056*D1**2*K*f*fd*r*s + 4248*D1**2*K*f*fd*r - 2808*D1**2*K*f*fd*s**2 + 3528*D1**2*K*f*fd*s - 2124*D1**2*K*f*fd + 5400*D1**2*K*f*fdd*r**2 + 10080*D1**2*K*f*fdd*r*s - 5400*D1**2*K*f*fdd*r + 4680*D1**2*K*f*fdd*s**2 - 5040*D1**2*K*f*fdd*s + 2700*D1**2*K*f*fdd + 5400*D1**2*K*fd**2*r**2 + 10080*D1**2*K*fd**2*r*s - 5400*D1**2*K*fd**2*r + 4680*D1**2*K*fd**2*s**2 - 5040*D1**2*K*fd**2*s - 168*D1**2*b2*fd*r**2 - 336*D1**2*b2*fd*r*s - 168*D1**2*b2*fd*s**2 + 504*D1**2*b2*fdd*r**2 + 1008*D1**2*b2*fdd*r*s + 504*D1**2*b2*fdd*s**2 + 84*D1**2*bd1**2*(-20*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 882*D1**2*bdd1*f**2*r**2 - 2772*D1**2*bdd1*f**2*r*s + 2448*D1**2*bdd1*f**2*r - 1890*D1**2*bdd1*f**2*s**2 + 3456*D1**2*bdd1*f**2*s - 1476*D1**2*bdd1*f**2 - 1302*D1**2*bdd1*f*r**2 - 3612*D1**2*bdd1*f*r*s + 3360*D1**2*bdd1*f*r - 2310*D1**2*bdd1*f*s**2 + 4368*D1**2*bdd1*f*s - 1932*D1**2*bdd1*f + 3360*D1**2*bdd1*g2*r**2 + 6720*D1**2*bdd1*g2*r*s - 3360*D1**2*bdd1*g2*r + 3360*D1**2*bdd1*g2*s**2 - 3360*D1**2*bdd1*g2*s + 1680*D1**2*bdd1*g2 + 504*D1**2*bdd2*f*r**2 + 1008*D1**2*bdd2*f*r*s - 1008*D1**2*bdd2*f*r + 504*D1**2*bdd2*f*s**2 - 1008*D1**2*bdd2*f*s + 504*D1**2*bdd2*f + 1065*D1**2*f**2*fd*r**2 + 2430*D1**2*f**2*fd*r*s - 1340*D1**2*f**2*fd*r + 1365*D1**2*f**2*fd*s**2 - 1540*D1**2*f**2*fd*s + 630*D1**2*f**2*fd - 1275*D1**2*f**2*fdd*r**2 - 2970*D1**2*f**2*fdd*r*s + 1660*D1**2*f**2*fdd*r - 1695*D1**2*f**2*fdd*s**2 + 1940*D1**2*f**2*fdd*s - 810*D1**2*f**2*fdd - 2550*D1**2*f*fd**2*r**2 - 5940*D1**2*f*fd**2*r*s + 3320*D1**2*f*fd**2*r - 3390*D1**2*f*fd**2*s**2 + 3880*D1**2*f*fd**2*s - 810*D1**2*f*fd**2 + 882*D1**2*f*fd*r**2 + 1908*D1**2*f*fd*r*s - 882*D1**2*f*fd*r + 1026*D1**2*f*fd*s**2 - 954*D1**2*f*fd*s + 441*D1**2*f*fd - 1134*D1**2*f*fdd*r**2 - 2844*D1**2*f*fdd*r*s + 1134*D1**2*f*fdd*r - 1710*D1**2*f*fdd*s**2 + 1422*D1**2*f*fdd*s - 567*D1**2*f*fdd + 3192*D1**2*f*gd2*r**2 + 6384*D1**2*f*gd2*r*s - 6384*D1**2*f*gd2*r + 3192*D1**2*f*gd2*s**2 - 6384*D1**2*f*gd2*s + 3192*D1**2*f*gd2 - 6216*D1**2*f*gdd2*r**2 - 12432*D1**2*f*gdd2*r*s + 12432*D1**2*f*gdd2*r - 6216*D1**2*f*gdd2*s**2 + 12432*D1**2*f*gdd2*s - 6216*D1**2*f*gdd2 - 1134*D1**2*fd**2*r**2 - 2844*D1**2*fd**2*r*s + 1134*D1**2*fd**2*r - 1710*D1**2*fd**2*s**2 + 1422*D1**2*fd**2*s + 3192*D1**2*fd*g2*r**2 + 6384*D1**2*fd*g2*r*s + 672*D1**2*fd*g2*r + 3192*D1**2*fd*g2*s**2 + 672*D1**2*fd*g2*s - 336*D1**2*fd*g2 - 12432*D1**2*fd*gd2*r**2 - 24864*D1**2*fd*gd2*r*s + 10416*D1**2*fd*gd2*r - 12432*D1**2*fd*gd2*s**2 + 10416*D1**2*fd*gd2*s + 2016*D1**2*fd*gd2 - 6216*D1**2*fdd*g2*r**2 - 12432*D1**2*fdd*g2*r*s - 2016*D1**2*fdd*g2*r - 6216*D1**2*fdd*g2*s**2 - 2016*D1**2*fdd*g2*s + 1008*D1**2*fdd*g2 - 8496*D1*Dd*K*f**2*r**2 - 14112*D1*Dd*K*f**2*r*s + 11304*D1*Dd*K*f**2*r - 5616*D1*Dd*K*f**2*s**2 + 9144*D1*Dd*K*f**2*s - 4932*D1*Dd*K*f**2 + 43200*D1*Dd*K*f*fd*r**2 + 80640*D1*Dd*K*f*fd*r*s - 52560*D1*Dd*K*f*fd*r + 37440*D1*Dd*K*f*fd*s**2 - 48960*D1*Dd*K*f*fd*s + 15480*D1*Dd*K*f*fd - 672*D1*Dd*b2*f*r**2 - 1344*D1*Dd*b2*f*r*s + 1008*D1*Dd*b2*f*r - 672*D1*Dd*b2*f*s**2 + 1008*D1*Dd*b2*f*s - 504*D1*Dd*b2*f + 4032*D1*Dd*b2*fd*r**2 + 8064*D1*Dd*b2*fd*r*s - 3024*D1*Dd*b2*fd*r + 4032*D1*Dd*b2*fd*s**2 - 3024*D1*Dd*b2*fd*s + 1420*D1*Dd*f**3*r**2 + 3240*D1*Dd*f**3*r*s - 2330*D1*Dd*f**3*r + 1820*D1*Dd*f**3*s**2 - 2630*D1*Dd*f**3*s + 1265*D1*Dd*f**3 - 10200*D1*Dd*f**2*fd*r**2 - 23760*D1*Dd*f**2*fd*r*s + 15130*D1*Dd*f**2*fd*r - 13560*D1*Dd*f**2*fd*s**2 + 17510*D1*Dd*f**2*fd*s - 5540*D1*Dd*f**2*fd + 1764*D1*Dd*f**2*r**2 + 3816*D1*Dd*f**2*r*s - 2790*D1*Dd*f**2*r + 2052*D1*Dd*f**2*s**2 - 3006*D1*Dd*f**2*s + 1467*D1*Dd*f**2 - 9072*D1*Dd*f*fd*r**2 - 22752*D1*Dd*f*fd*r*s + 12492*D1*Dd*f*fd*r - 13680*D1*Dd*f*fd*s**2 + 15372*D1*Dd*f*fd*s - 3978*D1*Dd*f*fd + 12768*D1*Dd*f*g2*r**2 + 25536*D1*Dd*f*g2*r*s - 19152*D1*Dd*f*g2*r + 12768*D1*Dd*f*g2*s**2 - 19152*D1*Dd*f*g2*s + 9576*D1*Dd*f*g2 - 49728*D1*Dd*f*gd2*r**2 - 99456*D1*Dd*f*gd2*r*s + 87024*D1*Dd*f*gd2*r - 49728*D1*Dd*f*gd2*s**2 + 87024*D1*Dd*f*gd2*s - 37296*D1*Dd*f*gd2 - 49728*D1*Dd*fd*g2*r**2 - 99456*D1*Dd*fd*g2*r*s + 29232*D1*Dd*fd*g2*r - 49728*D1*Dd*fd*g2*s**2 + 29232*D1*Dd*fd*g2*s + 6048*D1*Dd*fd*g2 + 10800*D1*Ddd*K*f**2*r**2 + 20160*D1*Ddd*K*f**2*r*s - 15480*D1*Ddd*K*f**2*r + 9360*D1*Ddd*K*f**2*s**2 - 14400*D1*Ddd*K*f**2*s + 7380*D1*Ddd*K*f**2 + 2016*D1*Ddd*b2*f*r**2 + 4032*D1*Ddd*b2*f*r*s - 3024*D1*Ddd*b2*f*r + 2016*D1*Ddd*b2*f*s**2 - 3024*D1*Ddd*b2*f*s + 1512*D1*Ddd*b2*f - 1700*D1*Ddd*f**3*r**2 - 3960*D1*Ddd*f**3*r*s + 2830*D1*Ddd*f**3*r - 2260*D1*Ddd*f**3*s**2 + 3250*D1*Ddd*f**3*s - 1555*D1*Ddd*f**3 - 2268*D1*Ddd*f**2*r**2 - 5688*D1*Ddd*f**2*r*s + 3978*D1*Ddd*f**2*r - 3420*D1*Ddd*f**2*s**2 + 4842*D1*Ddd*f**2*s - 2277*D1*Ddd*f**2 - 24864*D1*Ddd*f*g2*r**2 - 49728*D1*Ddd*f*g2*r*s + 37296*D1*Ddd*f*g2*r - 24864*D1*Ddd*f*g2*s**2 + 37296*D1*Ddd*f*g2*s - 18648*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(3*f**2*(35*r**2 + 2*r*(63*s - 52) + 91*s**2 - 160*s + 66) - 7*f*(4*K*(19*r**2 + 38*r*s - 40*r + 19*s**2 - 40*s + 20) + 6*fd*(14*r**2 + r*(44*s - 29) + 30*s**2 - 41*s + 13) - 17*r**2 - 42*r*s + 40*r - 25*s**2 + 48*s - 22) + 14*fd*(4*K*(37*r**2 + 74*r*s - 34*r + 37*s**2 - 34*s - 3) - 31*r**2 - 86*r*s + 34*r - 55*s**2 + 46*s + 3) + 280*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 560*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(-3*f**2*(196*r**2 + r*(616*s - 475) + 420*s**2 - 671*s + 260) + 7*f*(4*K*(148*r**2 + 296*r*s - 271*r + 148*s**2 - 271*s + 120) - 124*r**2 - 344*r*s + 277*r - 220*s**2 + 361*s - 144) + 280*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 168*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 32400*Dd**2*K*f**2*r**2 + 60480*Dd**2*K*f**2*r*s - 46440*Dd**2*K*f**2*r + 28080*Dd**2*K*f**2*s**2 - 43200*Dd**2*K*f**2*s + 14760*Dd**2*K*f**2 + 6048*Dd**2*b2*f*r**2 + 12096*Dd**2*b2*f*r*s - 9072*Dd**2*b2*f*r + 6048*Dd**2*b2*f*s**2 - 9072*Dd**2*b2*f*s + 3024*Dd**2*b2*f - 5100*Dd**2*f**3*r**2 - 11880*Dd**2*f**3*r*s + 8490*Dd**2*f**3*r - 6780*Dd**2*f**3*s**2 + 9750*Dd**2*f**3*s - 3110*Dd**2*f**3 - 6804*Dd**2*f**2*r**2 - 17064*Dd**2*f**2*r*s + 11934*Dd**2*f**2*r - 10260*Dd**2*f**2*s**2 + 14526*Dd**2*f**2*s - 4554*Dd**2*f**2 - 74592*Dd**2*f*g2*r**2 - 149184*Dd**2*f*g2*r*s + 111888*Dd**2*f*g2*r - 74592*Dd**2*f*g2*s**2 + 111888*Dd**2*f*g2*s - 37296*Dd**2*f*g2) + 24*b2*(-21*D1**2*bdd1*f*(r + s - 1)**2 - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 7*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(315*d**2*k3**6) - D1**2*Pk1*Pk3*ct*k1**3*st**4*(96*C - 52)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(105*d**2*k2*k3**4) + D1**2*Pk1*Pk3*ct*k1**3*st**2*(-28*b1**2*(2*C - 1)*(D1**2*(fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(D1**2*(f*(84*bdd1*s*(2*C - 1)*(2*r + 2*s - 1) + fd*(8*C*(64*r*s - 32*r + 260*s**2 - 249*s + 130) - 256*r*s + 128*r - 1182*s**2 + 1138*s - 591) + fdd*(-8*C*(30*r*(2*s - 1) + 200*s**2 - 191*s + 100) + 120*r*(2*s - 1) + 906*s**2 - 870*s + 453)) + 2*fd**2*(-4*C*(30*r*(2*s - 1) + 200*s**2 - 191*s - 9) + 60*r*(2*s - 1) + 453*s**2 - 435*s - 18)) + 28*D1*bd1*(2*C - 1)*(D1*(f*s*(-2*r - 2*s + 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 6*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + 2*D1*f*(Dd*(f*(16*C*(32*r*s - 16*r + 130*s**2 - 138*s + 65) - 256*r*s + 128*r - 1182*s**2 + 1246*s - 591) - 2*fd*(2*s - 1)*(8*C*(60*r + 200*s - 103) - 240*r - 906*s + 465)) + Ddd*f*(-40*C*(6*r*(2*s - 1) + 40*s**2 - 43*s + 20) + 120*r*(2*s - 1) + 906*s**2 - 966*s + 453)) - 2*Dd**2*f**2*(40*C*(18*r*(2*s - 1) + 120*s**2 - 129*s + 26) - 360*r*(2*s - 1) - 2718*s**2 + 2898*s - 573)) + f*(84*D1**2*bd1**2*s*(2*C - 1)*(2*r + 2*s - 1) + D1**2*(f*(bdd1*s*(-8*C*(30*r + 100*s - 39) + 120*r + 453*s - 156) + 5*fd*(8*C*(5*r*(3*s - 1) + 39*s**2 - 31*s + 13) + r*(20 - 60*s) - 177*s**2 + 138*s - 59) + fdd*(-8*C*(23*r*(3*s - 1) + 147*s**2 - 121*s + 49) + 92*r*(3*s - 1) + 663*s**2 - 534*s + 221)) - 2*fd**2*(4*C*(46*r*(3*s - 1) + 294*s**2 - 242*s + 23) - 92*r*(3*s - 1) - 663*s**2 + 534*s - 46)) + D1*bd1*(D1*(f*s*(8*C*(32*r + 130*s - 43) - 128*r - 591*s + 172) - 2*fd*(4*C*(30*r*(4*s - 1) + 400*s**2 - 269*s + 39) - 240*r*s + 60*r - 906*s**2 + 591*s - 78)) - 4*Dd*f*(4*C*(30*r*(4*s - 1) + 400*s**2 - 293*s + 39) - 240*r*s + 60*r - 906*s**2 + 639*s - 78)) + 2*D1*f*(Dd*(5*f*(4*C*(20*r*s - 10*r + 52*s**2 - 57*s + 26) - 40*r*s + 20*r - 118*s**2 + 128*s - 59) - 4*fd*(C*(46*r*(12*s - 5) + 1176*s**2 - 1141*s + 265) - 276*r*s + 115*r - 663*s**2 + 633*s - 145)) + Ddd*f*(-4*C*(46*r*(2*s - 1) + 196*s**2 - 219*s + 98) + 92*r*(2*s - 1) + 442*s**2 - 488*s + 221)) + 2*Dd**2*f**2*(-12*C*(46*r*(2*s - 1) + 196*s**2 - 219*s + 48) + 276*r*(2*s - 1) + 1326*s**2 - 1464*s + 313)))/(105*d**2*k2*k3**4) + D1**2*Pk1*Pk3*ct*k1**3*(140*b1**2*(2*C - 1)*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 7*b1*(D1**2*(f*(-20*bdd1*s*(2*C - 1)*(2*r + 2*s - 1) + fd*(-8*C*(16*r*s - 8*r + 26*s**2 - 23*s + 13) + 64*r*s - 32*r + 126*s**2 - 114*s + 63) + fdd*(8*C*(16*r*s - 8*r + 26*s**2 - 23*s + 13) - 64*r*s + 32*r - 126*s**2 + 114*s - 63)) + 2*fd**2*(4*C*(8*r*(2*s - 1) + 26*s**2 - 23*s - 3) + r*(16 - 32*s) - 63*s**2 + 57*s + 6)) - 20*D1*bd1*(2*C - 1)*(D1*(f*s*(-2*r - 2*s + 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(8*C*(16*r*s - 8*r + 26*s**2 - 30*s + 13) - 64*r*s + 32*r - 126*s**2 + 142*s - 63) - 2*fd*(2*s - 1)*(4*C*(32*r + 52*s - 27) - 64*r - 126*s + 65)) + Ddd*f*(-8*C*(16*r*s - 8*r + 26*s**2 - 30*s + 13) + 64*r*s - 32*r + 126*s**2 - 142*s + 63)) + 2*Dd**2*f**2*(24*C*(8*r*(2*s - 1) + 26*s**2 - 30*s + 7) - 96*r*(2*s - 1) - 378*s**2 + 426*s - 95)) + f*(-140*D1**2*bd1**2*s*(2*C - 1)*(2*r + 2*s - 1) + D1**2*(f*(7*bdd1*s*(8*C*(8*r + 13*s - 11) - 32*r - 63*s + 44) - 3*fd*(8*C*(57*r*s - 19*r + 72*s**2 - 67*s + 24) - 228*r*s + 76*r - 339*s**2 + 302*s - 113) + 3*fdd*(8*C*(57*r*s - 19*r + 72*s**2 - 67*s + 24) - 228*r*s + 76*r - 339*s**2 + 302*s - 113)) + 6*fd**2*(4*C*(38*r*(3*s - 1) + 144*s**2 - 134*s + 19) - 76*r*(3*s - 1) - 339*s**2 + 302*s - 38)) - 7*D1*bd1*(D1*(f*s*(8*C*(8*r + 13*s - 11) - 32*r - 63*s + 44) + fd*(-8*C*(8*r*(4*s - 1) + 52*s**2 - 45*s + 11) + 32*r*(4*s - 1) + 252*s**2 - 202*s + 44)) - 4*Dd*f*(4*C*(8*r*(4*s - 1) + 52*s**2 - 52*s + 11) + r*(16 - 64*s) - 126*s**2 + 115*s - 22)) - 6*D1*f*(Dd*(f*(4*C*(76*r*s - 38*r + 96*s**2 - 115*s + 48) - 152*r*s + 76*r - 226*s**2 + 264*s - 113) - 4*fd*(C*(38*r*(12*s - 5) + 576*s**2 - 613*s + 153) - 228*r*s + 95*r - 339*s**2 + 349*s - 85)) + Ddd*f*(-4*C*(38*r*(2*s - 1) + 96*s**2 - 115*s + 48) + 76*r*(2*s - 1) + 226*s**2 - 264*s + 113)) + 6*Dd**2*f**2*(4*C*(114*r*(2*s - 1) + 288*s**2 - 345*s + 86) - 228*r*(2*s - 1) - 678*s**2 + 792*s - 189)))/(105*d**2*k2*k3**4) - D1**2*Pk1*Pk3*ct*k1*k2**5*st**6*(16*C - 12)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(21*d**2*k3**8) + 4*D1**2*Pk1*Pk3*ct*k1*k2**5*st**4*(396*C*D1**2*f**2*fd*r**2 + 792*C*D1**2*f**2*fd*r*s - 528*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 528*C*D1**2*f**2*fd*s + 264*C*D1**2*f**2*fd + 528*C*D1*Dd*f**3*r**2 + 1056*C*D1*Dd*f**3*r*s - 792*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 792*C*D1*Dd*f**3*s + 396*C*D1*Dd*f**3 + 66*D1**2*K*bdd1*f**2*r**2 + 132*D1**2*K*bdd1*f**2*r*s - 132*D1**2*K*bdd1*f**2*r + 66*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s + 66*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(-14*K + 25*f + 7)*(r + s - 1)**2 + 275*D1**2*bdd1*f**3*r**2 + 550*D1**2*bdd1*f**3*r*s - 550*D1**2*bdd1*f**3*r + 275*D1**2*bdd1*f**3*s**2 - 550*D1**2*bdd1*f**3*s + 275*D1**2*bdd1*f**3 - 33*D1**2*bdd1*f**2*r**2 - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r - 33*D1**2*bdd1*f**2*s**2 + 66*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 - 924*D1**2*bdd1*f*g2*r**2 - 1848*D1**2*bdd1*f*g2*r*s + 1848*D1**2*bdd1*f*g2*r - 924*D1**2*bdd1*f*g2*s**2 + 1848*D1**2*bdd1*f*g2*s - 924*D1**2*bdd1*f*g2 - 1516*D1**2*f**3*fd*r**2 - 3032*D1**2*f**3*fd*r*s + 2274*D1**2*f**3*fd*r - 1516*D1**2*f**3*fd*s**2 + 2274*D1**2*f**3*fd*s - 1137*D1**2*f**3*fd + 1000*D1**2*f**3*fdd*r**2 + 2000*D1**2*f**3*fdd*r*s - 1500*D1**2*f**3*fdd*r + 1000*D1**2*f**3*fdd*s**2 - 1500*D1**2*f**3*fdd*s + 750*D1**2*f**3*fdd + 3000*D1**2*f**2*fd**2*r**2 + 6000*D1**2*f**2*fd**2*r*s - 4500*D1**2*f**2*fd**2*r + 3000*D1**2*f**2*fd**2*s**2 - 4500*D1**2*f**2*fd**2*s + 1500*D1**2*f**2*fd**2 - 297*D1**2*f**2*fd*r**2 - 594*D1**2*f**2*fd*r*s + 396*D1**2*f**2*fd*r - 297*D1**2*f**2*fd*s**2 + 396*D1**2*f**2*fd*s - 198*D1**2*f**2*fd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 1516*D1*Dd*f**4*r**2 - 3032*D1*Dd*f**4*r*s + 2274*D1*Dd*f**4*r - 1516*D1*Dd*f**4*s**2 + 2274*D1*Dd*f**4*s - 1137*D1*Dd*f**4 + 8000*D1*Dd*f**3*fd*r**2 + 16000*D1*Dd*f**3*fd*r*s - 12000*D1*Dd*f**3*fd*r + 8000*D1*Dd*f**3*fd*s**2 - 12000*D1*Dd*f**3*fd*s + 4500*D1*Dd*f**3*fd - 396*D1*Dd*f**3*r**2 - 792*D1*Dd*f**3*r*s + 594*D1*Dd*f**3*r - 396*D1*Dd*f**3*s**2 + 594*D1*Dd*f**3*s - 297*D1*Dd*f**3 + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 1000*D1*Ddd*f**4*r**2 + 2000*D1*Ddd*f**4*r*s - 1500*D1*Ddd*f**4*r + 1000*D1*Ddd*f**4*s**2 - 1500*D1*Ddd*f**4*s + 750*D1*Ddd*f**4 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(23*f**3*(r + s - 1) + f**2*(-84*C*(r + s - 1) - 50*fd*(3*r + 3*s - 2) + (12*K + 57)*(r + s - 1)) - 6*f*(fd*(2*K - 1)*(2*r + 2*s - 1) + (28*g2 - 28*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 2*Dd*f*(25*f**2 + f*(6*K - 3) - 84*g2)*(4*r + 4*s - 3))*(r + s - 1) + 3000*Dd**2*f**4*r**2 + 6000*Dd**2*f**4*r*s - 4500*Dd**2*f**4*r + 3000*Dd**2*f**4*s**2 - 4500*Dd**2*f**4*s + 1500*Dd**2*f**4 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(25*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 25*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 25*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(168*C*D1**2*f*fd*r**2 + 336*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r + 168*C*D1**2*f*fd*s**2 - 168*C*D1**2*f*fd*s + 84*C*D1**2*f*fd + 336*C*D1*Dd*f**2*r**2 + 672*C*D1*Dd*f**2*r*s - 504*C*D1*Dd*f**2*r + 336*C*D1*Dd*f**2*s**2 - 504*C*D1*Dd*f**2*s + 252*C*D1*Dd*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 12*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 12*D1**2*K*f*fdd*s**2 - 12*D1**2*K*f*fdd*s + 6*D1**2*K*f*fdd + 12*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 12*D1**2*K*fd**2*s**2 - 12*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-14*K + 25*f + 7)*(r + s - 1)**2 - 69*D1**2*f**2*fd*r**2 - 138*D1**2*f**2*fd*r*s + 92*D1**2*f**2*fd*r - 69*D1**2*f**2*fd*s**2 + 92*D1**2*f**2*fd*s - 46*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 - 114*D1**2*f*fd*r**2 - 228*D1**2*f*fd*r*s + 114*D1**2*f*fd*r - 114*D1**2*f*fd*s**2 + 114*D1**2*f*fd*s - 57*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 3*D1**2*f*fdd + 168*D1**2*f*gd2*r**2 + 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r + 168*D1**2*f*gd2*s**2 - 336*D1**2*f*gd2*s + 168*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s + 168*D1**2*fd*g2*r**2 + 336*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 96*D1*Dd*K*f*fd*r**2 + 192*D1*Dd*K*f*fd*r*s - 120*D1*Dd*K*f*fd*r + 96*D1*Dd*K*f*fd*s**2 - 120*D1*Dd*K*f*fd*s + 36*D1*Dd*K*f*fd - 92*D1*Dd*f**3*r**2 - 184*D1*Dd*f**3*r*s + 138*D1*Dd*f**3*r - 92*D1*Dd*f**3*s**2 + 138*D1*Dd*f**3*s - 69*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 850*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 850*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd - 228*D1*Dd*f**2*r**2 - 456*D1*Dd*f**2*r*s + 342*D1*Dd*f**2*r - 228*D1*Dd*f**2*s**2 + 342*D1*Dd*f**2*s - 171*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 18*D1*Dd*f*fd + 672*D1*Dd*f*g2*r**2 + 1344*D1*Dd*f*g2*r*s - 1008*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 1008*D1*Dd*f*g2*s + 504*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s + 24*D1*Ddd*K*f**2*r**2 + 48*D1*Ddd*K*f**2*r*s - 36*D1*Ddd*K*f**2*r + 24*D1*Ddd*K*f**2*s**2 - 36*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 - 12*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 18*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 12*D1*bd1*(D1*(18*f**2*(r + s - 1) - 25*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 25*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 72*Dd**2*K*f**2*r**2 + 144*Dd**2*K*f**2*r*s - 108*Dd**2*K*f**2*r + 72*Dd**2*K*f**2*s**2 - 108*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 - 36*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 54*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 18*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(385*d**2*k3**8) - D1**2*Pk1*Pk3*ct*k1*k2**3*st**6*(32*C - 24)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(63*d**2*k3**6) - 2*D1**2*Pk1*Pk3*ct*k1*k2**3*st**4*(42*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-856*C*D1**2*f*fd*r**2 - 1680*C*D1**2*f*fd*r*s + 808*C*D1**2*f*fd*r - 824*C*D1**2*f*fd*s**2 + 792*C*D1**2*f*fd*s - 396*C*D1**2*f*fd + 792*C*D1**2*f*fdd*r**2 + 1568*C*D1**2*f*fdd*r*s - 768*C*D1**2*f*fdd*r + 776*C*D1**2*f*fdd*s**2 - 760*C*D1**2*f*fdd*s + 380*C*D1**2*f*fdd + 792*C*D1**2*fd**2*r**2 + 1568*C*D1**2*fd**2*r*s - 768*C*D1**2*fd**2*r + 776*C*D1**2*fd**2*s**2 - 760*C*D1**2*fd**2*s - 16*C*D1**2*fd**2 - 1712*C*D1*Dd*f**2*r**2 - 3360*C*D1*Dd*f**2*r*s + 2536*C*D1*Dd*f**2*r - 1648*C*D1*Dd*f**2*s**2 + 2488*C*D1*Dd*f**2*s - 1252*C*D1*Dd*f**2 + 6336*C*D1*Dd*f*fd*r**2 + 12544*C*D1*Dd*f*fd*r*s - 7792*C*D1*Dd*f*fd*r + 6208*C*D1*Dd*f*fd*s**2 - 7712*C*D1*Dd*f*fd*s + 2288*C*D1*Dd*f*fd + 1584*C*D1*Ddd*f**2*r**2 + 3136*C*D1*Ddd*f**2*r*s - 2360*C*D1*Ddd*f**2*r + 1552*C*D1*Ddd*f**2*s**2 - 2336*C*D1*Ddd*f**2*s + 1172*C*D1*Ddd*f**2 + 4752*C*Dd**2*f**2*r**2 + 9408*C*Dd**2*f**2*r*s - 7080*C*Dd**2*f**2*r + 4656*C*Dd**2*f**2*s**2 - 7008*C*Dd**2*f**2*s + 2344*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 622*D1**2*f*fd*r**2 + 1204*D1**2*f*fd*r*s - 578*D1**2*f*fd*r + 582*D1**2*f*fd*s**2 - 558*D1**2*f*fd*s + 279*D1**2*f*fd - 570*D1**2*f*fdd*r**2 - 1148*D1**2*f*fdd*r*s + 562*D1**2*f*fdd*r - 578*D1**2*f*fdd*s**2 + 566*D1**2*f*fdd*s - 283*D1**2*f*fdd - 570*D1**2*fd**2*r**2 - 1148*D1**2*fd**2*r*s + 562*D1**2*fd**2*r - 578*D1**2*fd**2*s**2 + 566*D1**2*fd**2*s + 12*D1**2*fd**2 + 1244*D1*Dd*f**2*r**2 + 2408*D1*Dd*f**2*r*s - 1826*D1*Dd*f**2*r + 1164*D1*Dd*f**2*s**2 - 1766*D1*Dd*f**2*s + 893*D1*Dd*f**2 - 4560*D1*Dd*f*fd*r**2 - 9184*D1*Dd*f*fd*r*s + 5684*D1*Dd*f*fd*r - 4624*D1*Dd*f*fd*s**2 + 5724*D1*Dd*f*fd*s - 1694*D1*Dd*f*fd - 1140*D1*Ddd*f**2*r**2 - 2296*D1*Ddd*f**2*r*s + 1718*D1*Ddd*f**2*r - 1156*D1*Ddd*f**2*s**2 + 1730*D1*Ddd*f**2*s - 863*D1*Ddd*f**2 + 28*D1*bd1*(4*C - 3)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 3420*Dd**2*f**2*r**2 - 6888*Dd**2*f**2*r*s + 5154*Dd**2*f**2*r - 3468*Dd**2*f**2*s**2 + 5190*Dd**2*f**2*s - 1726*Dd**2*f**2) + f*(-1956*C*D1**2*f*fd*r**2 - 3000*C*D1**2*f*fd*r*s + 2304*C*D1**2*f*fd*r - 1044*C*D1**2*f*fd*s**2 + 1696*C*D1**2*f*fd*s - 1000*C*D1**2*f*fd + 1500*C*D1**2*f*fdd*r**2 + 2256*C*D1**2*f*fdd*r*s - 1752*C*D1**2*f*fdd*r + 756*C*D1**2*f*fdd*s**2 - 1256*C*D1**2*f*fdd*s + 752*C*D1**2*f*fdd + 3000*C*D1**2*fd**2*r**2 + 4512*C*D1**2*fd**2*r*s - 3504*C*D1**2*fd**2*r + 1512*C*D1**2*fd**2*s**2 - 2512*C*D1**2*fd**2*s + 752*C*D1**2*fd**2 - 2608*C*D1*Dd*f**2*r**2 - 4000*C*D1*Dd*f**2*r*s + 3304*C*D1*Dd*f**2*r - 1392*C*D1*Dd*f**2*s**2 + 2392*C*D1*Dd*f**2*s - 1348*C*D1*Dd*f**2 + 12000*C*D1*Dd*f*fd*r**2 + 18048*C*D1*Dd*f*fd*r*s - 14520*C*D1*Dd*f*fd*r + 6048*C*D1*Dd*f*fd*s**2 - 10304*C*D1*Dd*f*fd*s + 4264*C*D1*Dd*f*fd + 2000*C*D1*Ddd*f**2*r**2 + 3008*C*D1*Ddd*f**2*r*s - 2504*C*D1*Ddd*f**2*r + 1008*C*D1*Ddd*f**2*s**2 - 1760*C*D1*Ddd*f**2*s + 1004*C*D1*Ddd*f**2 + 6000*C*Dd**2*f**2*r**2 + 9024*C*Dd**2*f**2*r*s - 7512*C*Dd**2*f**2*r + 3024*C*Dd**2*f**2*s**2 - 5280*C*Dd**2*f**2*s + 2008*C*Dd**2*f**2 - 84*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*D1**2*bdd1*f*(4*C*(99*r**2 + 2*r*(98*s - 101) + 97*s**2 - 200*s + 101) - 285*r**2 + r*(582 - 574*s) - 289*s**2 + 586*s - 291) + 1365*D1**2*f*fd*r**2 + 2118*D1**2*f*fd*r*s - 1616*D1**2*f*fd*r + 753*D1**2*f*fd*s**2 - 1208*D1**2*f*fd*s + 706*D1**2*f*fd - 1029*D1**2*f*fdd*r**2 - 1590*D1**2*f*fdd*r*s + 1216*D1**2*f*fdd*r - 561*D1**2*f*fdd*s**2 + 904*D1**2*f*fdd*s - 530*D1**2*f*fdd - 2058*D1**2*fd**2*r**2 - 3180*D1**2*fd**2*r*s + 2432*D1**2*fd**2*r - 1122*D1**2*fd**2*s**2 + 1808*D1**2*fd**2*s - 530*D1**2*fd**2 + 1820*D1*Dd*f**2*r**2 + 2824*D1*Dd*f**2*r*s - 2322*D1*Dd*f**2*r + 1004*D1*Dd*f**2*s**2 - 1710*D1*Dd*f**2*s + 957*D1*Dd*f**2 - 8232*D1*Dd*f*fd*r**2 - 12720*D1*Dd*f*fd*r*s + 10102*D1*Dd*f*fd*r - 4488*D1*Dd*f*fd*s**2 + 7450*D1*Dd*f*fd*s - 3024*D1*Dd*f*fd - 1372*D1*Ddd*f**2*r**2 - 2120*D1*Ddd*f**2*r*s + 1746*D1*Ddd*f**2*r - 748*D1*Ddd*f**2*s**2 + 1278*D1*Ddd*f**2*s - 717*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(C*(428*r**2 + 840*r*s - 888*r + 412*s**2 - 872*s + 444) - 311*r**2 - 602*r*s + 646*r - 291*s**2 + 626*s - 323) - 2*fd*(4*C*(198*r**2 + 392*r*s - 298*r + 194*s**2 - 295*s + 100) - 570*r**2 - 1148*r*s + 863*r - 578*s**2 + 869*s - 293)) + 2*Dd*f*(-4*C*(396*r**2 + r*(784*s - 699) + 388*s**2 - 692*s + 301) + 1140*r**2 + 7*r*(328*s - 289) + 1156*s**2 - 2037*s + 877)) - 4116*Dd**2*f**2*r**2 - 6360*Dd**2*f**2*r*s + 5238*Dd**2*f**2*r - 2244*Dd**2*f**2*s**2 + 3834*Dd**2*f**2*s - 1434*Dd**2*f**2))/(105*d**2*k3**6) + 2*D1**2*Pk1*Pk3*ct*k1*k2**3*st**2*(-16632*C*D1**2*bd1*f**2*r**2 - 20328*C*D1**2*bd1*f**2*r*s + 36960*C*D1**2*bd1*f**2*r - 3696*C*D1**2*bd1*f**2*s**2 + 24024*C*D1**2*bd1*f**2*s - 18480*C*D1**2*bd1*f**2 - 23760*C*D1**2*f**2*fd*r**2 - 30888*C*D1**2*f**2*fd*r*s + 26136*C*D1**2*f**2*fd*r - 7128*C*D1**2*f**2*fd*s**2 + 15048*C*D1**2*f**2*fd*s - 10296*C*D1**2*f**2*fd - 31680*C*D1*Dd*f**3*r**2 - 41184*C*D1*Dd*f**3*r*s + 36432*C*D1*Dd*f**3*r - 9504*C*D1*Dd*f**3*s**2 + 19800*C*D1*Dd*f**3*s - 12672*C*D1*Dd*f**3 - 60060*D1**2*K*bd1**2*f*r**2 - 103488*D1**2*K*bd1**2*f*r*s + 113652*D1**2*K*bd1**2*f*r - 43428*D1**2*K*bd1**2*f*s**2 + 97020*D1**2*K*bd1**2*f*s - 53592*D1**2*K*bd1**2*f + 19206*D1**2*K*bd1*f**2*r**2 + 27324*D1**2*K*bd1*f**2*r*s - 27324*D1**2*K*bd1*f**2*r + 8118*D1**2*K*bd1*f**2*s**2 - 16236*D1**2*K*bd1*f**2*s + 8118*D1**2*K*bd1*f**2 - 61512*D1**2*K*bd1*f*fd*r**2 - 89760*D1**2*K*bd1*f*fd*r*s + 75636*D1**2*K*bd1*f*fd*r - 28248*D1**2*K*bd1*f*fd*s**2 + 50688*D1**2*K*bd1*f*fd*s - 22440*D1**2*K*bd1*f*fd - 15378*D1**2*K*bdd1*f**2*r**2 - 22440*D1**2*K*bdd1*f**2*r*s + 22440*D1**2*K*bdd1*f**2*r - 7062*D1**2*K*bdd1*f**2*s**2 + 14124*D1**2*K*bdd1*f**2*s - 7062*D1**2*K*bdd1*f**2 + 36234*D1**2*bd1**2*f**2*r**2 + 83556*D1**2*bd1**2*f**2*r*s - 78012*D1**2*bd1**2*f**2*r + 47322*D1**2*bd1**2*f**2*s**2 - 89100*D1**2*bd1**2*f**2*s + 41778*D1**2*bd1**2*f**2 + 30030*D1**2*bd1**2*f*r**2 + 54516*D1**2*bd1**2*f*r*s - 58212*D1**2*bd1**2*f*r + 24486*D1**2*bd1**2*f*s**2 - 52668*D1**2*bd1**2*f*s + 28182*D1**2*bd1**2*f - 18480*D1**2*bd1**2*g2*r**2 - 36960*D1**2*bd1**2*g2*r*s + 18480*D1**2*bd1**2*g2*r - 18480*D1**2*bd1**2*g2*s**2 + 18480*D1**2*bd1**2*g2*s - 11088*D1**2*bd1*bd2*f*r**2 - 22176*D1**2*bd1*bd2*f*r*s + 22176*D1**2*bd1*bd2*f*r - 11088*D1**2*bd1*bd2*f*s**2 + 22176*D1**2*bd1*bd2*f*s - 11088*D1**2*bd1*bd2*f - 6468*D1**2*bd1*f**3*r**2 - 5280*D1**2*bd1*f**3*r*s + 9372*D1**2*bd1*f**3*r + 1188*D1**2*bd1*f**3*s**2 + 1716*D1**2*bd1*f**3*s - 3894*D1**2*bd1*f**3 + 38412*D1**2*bd1*f**2*fd*r**2 + 27720*D1**2*bd1*f**2*fd*r*s - 42108*D1**2*bd1*f**2*fd*r - 10692*D1**2*bd1*f**2*fd*s**2 - 1188*D1**2*bd1*f**2*fd*s + 4488*D1**2*bd1*f**2*fd + 2607*D1**2*bd1*f**2*r**2 - 330*D1**2*bd1*f**2*r*s - 12606*D1**2*bd1*f**2*r - 2937*D1**2*bd1*f**2*s**2 - 7062*D1**2*bd1*f**2*s + 8613*D1**2*bd1*f**2 + 27588*D1**2*bd1*f*fd*r**2 + 44088*D1**2*bd1*f*fd*r*s - 35838*D1**2*bd1*f*fd*r + 16500*D1**2*bd1*f*fd*s**2 - 27522*D1**2*bd1*f*fd*s + 11022*D1**2*bd1*f*fd - 60060*D1**2*bd1*f*g2*r**2 - 86856*D1**2*bd1*f*g2*r*s + 127512*D1**2*bd1*f*g2*r - 26796*D1**2*bd1*f*g2*s**2 + 94248*D1**2*bd1*f*g2*s - 63756*D1**2*bd1*f*g2 + 120120*D1**2*bd1*f*gd2*r**2 + 206976*D1**2*bd1*f*gd2*r*s - 227304*D1**2*bd1*f*gd2*r + 86856*D1**2*bd1*f*gd2*s**2 - 194040*D1**2*bd1*f*gd2*s + 107184*D1**2*bd1*f*gd2 + 120120*D1**2*bd1*fd*g2*r**2 + 206976*D1**2*bd1*fd*g2*r*s - 120120*D1**2*bd1*fd*g2*r + 86856*D1**2*bd1*fd*g2*s**2 - 103488*D1**2*bd1*fd*g2*s + 3828*D1**2*bd2*f**2*r**2 + 7656*D1**2*bd2*f**2*r*s - 7656*D1**2*bd2*f**2*r + 3828*D1**2*bd2*f**2*s**2 - 7656*D1**2*bd2*f**2*s + 3828*D1**2*bd2*f**2 - 9504*D1**2*bd2*f*fd*r**2 - 19008*D1**2*bd2*f*fd*r*s + 14256*D1**2*bd2*f*fd*r - 9504*D1**2*bd2*f*fd*s**2 + 14256*D1**2*bd2*f*fd*s - 4752*D1**2*bd2*f*fd + 6402*D1**2*bdd1*f**3*r**2 + 4620*D1**2*bdd1*f**3*r*s - 10032*D1**2*bdd1*f**3*r - 1782*D1**2*bdd1*f**3*s**2 - 1848*D1**2*bdd1*f**3*s + 4620*D1**2*bdd1*f**3 + 6897*D1**2*bdd1*f**2*r**2 + 11022*D1**2*bdd1*f**2*r*s - 11022*D1**2*bdd1*f**2*r + 4125*D1**2*bdd1*f**2*s**2 - 8250*D1**2*bdd1*f**2*s + 4125*D1**2*bdd1*f**2 + 60060*D1**2*bdd1*f*g2*r**2 + 103488*D1**2*bdd1*f*g2*r*s - 123816*D1**2*bdd1*f*g2*r + 43428*D1**2*bdd1*f*g2*s**2 - 107184*D1**2*bdd1*f*g2*s + 61908*D1**2*bdd1*f*g2 - 2376*D1**2*bdd2*f**2*r**2 - 4752*D1**2*bdd2*f**2*r*s + 4752*D1**2*bdd2*f**2*r - 2376*D1**2*bdd2*f**2*s**2 + 4752*D1**2*bdd2*f**2*s - 2376*D1**2*bdd2*f**2 + 16460*D1**2*f**3*fd*r**2 + 42200*D1**2*f**3*fd*r*s - 29330*D1**2*f**3*fd*r + 25740*D1**2*f**3*fd*s**2 - 36290*D1**2*f**3*fd*s + 16985*D1**2*f**3*fd - 16260*D1**2*f**3*fdd*r**2 - 45960*D1**2*f**3*fdd*r*s + 31110*D1**2*f**3*fdd*r - 29700*D1**2*f**3*fdd*s**2 + 41190*D1**2*f**3*fdd*s - 18915*D1**2*f**3*fdd - 48780*D1**2*f**2*fd**2*r**2 - 137880*D1**2*f**2*fd**2*r*s + 93330*D1**2*f**2*fd**2*r - 89100*D1**2*f**2*fd**2*s**2 + 123570*D1**2*f**2*fd**2*s - 37830*D1**2*f**2*fd**2 + 17226*D1**2*f**2*fd*r**2 + 21384*D1**2*f**2*fd*r*s - 18612*D1**2*f**2*fd*r + 4158*D1**2*f**2*fd*s**2 - 9900*D1**2*f**2*fd*s + 7128*D1**2*f**2*fd - 38412*D1**2*f**2*gd2*r**2 - 54648*D1**2*f**2*gd2*r*s + 54648*D1**2*f**2*gd2*r - 16236*D1**2*f**2*gd2*s**2 + 32472*D1**2*f**2*gd2*s - 16236*D1**2*f**2*gd2 + 30756*D1**2*f**2*gdd2*r**2 + 44880*D1**2*f**2*gdd2*r*s - 44880*D1**2*f**2*gdd2*r + 14124*D1**2*f**2*gdd2*s**2 - 28248*D1**2*f**2*gdd2*s + 14124*D1**2*f**2*gdd2 - 76824*D1**2*f*fd*g2*r**2 - 109296*D1**2*f*fd*g2*r*s + 76824*D1**2*f*fd*g2*r - 32472*D1**2*f*fd*g2*s**2 + 54648*D1**2*f*fd*g2*s - 38412*D1**2*f*fd*g2 + 123024*D1**2*f*fd*gd2*r**2 + 179520*D1**2*f*fd*gd2*r*s - 151272*D1**2*f*fd*gd2*r + 56496*D1**2*f*fd*gd2*s**2 - 101376*D1**2*f*fd*gd2*s + 44880*D1**2*f*fd*gd2 + 61512*D1**2*f*fdd*g2*r**2 + 89760*D1**2*f*fdd*g2*r*s - 61512*D1**2*f*fdd*g2*r + 28248*D1**2*f*fdd*g2*s**2 - 44880*D1**2*f*fdd*g2*s + 30756*D1**2*f*fdd*g2 + 61512*D1**2*fd**2*g2*r**2 + 89760*D1**2*fd**2*g2*r*s - 61512*D1**2*fd**2*g2*r + 28248*D1**2*fd**2*g2*s**2 - 44880*D1**2*fd**2*g2*s - 123024*D1*Dd*K*bd1*f**2*r**2 - 179520*D1*Dd*K*bd1*f**2*r*s + 165396*D1*Dd*K*bd1*f**2*r - 56496*D1*Dd*K*bd1*f**2*s**2 + 107184*D1*Dd*K*bd1*f**2*s - 50688*D1*Dd*K*bd1*f**2 + 51216*D1*Dd*bd1*f**3*r**2 + 36960*D1*Dd*bd1*f**3*r*s - 62172*D1*Dd*bd1*f**3*r - 14256*D1*Dd*bd1*f**3*s**2 - 4884*D1*Dd*bd1*f**3*s + 13728*D1*Dd*bd1*f**3 + 55176*D1*Dd*bd1*f**2*r**2 + 88176*D1*Dd*bd1*f**2*r*s - 79926*D1*Dd*bd1*f**2*r + 33000*D1*Dd*bd1*f**2*s**2 - 60522*D1*Dd*bd1*f**2*s + 27522*D1*Dd*bd1*f**2 + 480480*D1*Dd*bd1*f*g2*r**2 + 827904*D1*Dd*bd1*f*g2*r*s - 822360*D1*Dd*bd1*f*g2*r + 347424*D1*Dd*bd1*f*g2*s**2 - 705936*D1*Dd*bd1*f*g2*s + 338184*D1*Dd*bd1*f*g2 - 19008*D1*Dd*bd2*f**2*r**2 - 38016*D1*Dd*bd2*f**2*r*s + 33264*D1*Dd*bd2*f**2*r - 19008*D1*Dd*bd2*f**2*s**2 + 33264*D1*Dd*bd2*f**2*s - 14256*D1*Dd*bd2*f**2 + 16460*D1*Dd*f**4*r**2 + 42200*D1*Dd*f**4*r*s - 29330*D1*Dd*f**4*r + 25740*D1*Dd*f**4*s**2 - 36290*D1*Dd*f**4*s + 16985*D1*Dd*f**4 - 130080*D1*Dd*f**3*fd*r**2 - 367680*D1*Dd*f**3*fd*r*s + 248880*D1*Dd*f**3*fd*r - 237600*D1*Dd*f**3*fd*s**2 + 329520*D1*Dd*f**3*fd*s - 113490*D1*Dd*f**3*fd + 22968*D1*Dd*f**3*r**2 + 28512*D1*Dd*f**3*r*s - 25740*D1*Dd*f**3*r + 5544*D1*Dd*f**3*s**2 - 12672*D1*Dd*f**3*s + 8514*D1*Dd*f**3 - 153648*D1*Dd*f**2*g2*r**2 - 218592*D1*Dd*f**2*g2*r*s + 186120*D1*Dd*f**2*g2*r - 64944*D1*Dd*f**2*g2*s**2 + 119592*D1*Dd*f**2*g2*s - 70884*D1*Dd*f**2*g2 + 246048*D1*Dd*f**2*gd2*r**2 + 359040*D1*Dd*f**2*gd2*r*s - 330792*D1*Dd*f**2*gd2*r + 112992*D1*Dd*f**2*gd2*s**2 - 214368*D1*Dd*f**2*gd2*s + 101376*D1*Dd*f**2*gd2 + 492096*D1*Dd*f*fd*g2*r**2 + 718080*D1*Dd*f*fd*g2*r*s - 548592*D1*Dd*f*fd*g2*r + 225984*D1*Dd*f*fd*g2*s**2 - 382272*D1*Dd*f*fd*g2*s + 151272*D1*Dd*f*fd*g2 - 16260*D1*Ddd*f**4*r**2 - 45960*D1*Ddd*f**4*r*s + 31110*D1*Ddd*f**4*r - 29700*D1*Ddd*f**4*s**2 + 41190*D1*Ddd*f**4*s - 18915*D1*Ddd*f**4 + 123024*D1*Ddd*f**2*g2*r**2 + 179520*D1*Ddd*f**2*g2*r*s - 151272*D1*Ddd*f**2*g2*r + 56496*D1*Ddd*f**2*g2*s**2 - 101376*D1*Ddd*f**2*g2*s + 59004*D1*Ddd*f**2*g2 - 48780*Dd**2*f**4*r**2 - 137880*Dd**2*f**4*r*s + 93330*Dd**2*f**4*r - 89100*Dd**2*f**4*s**2 + 123570*Dd**2*f**4*s - 37830*Dd**2*f**4 + 369072*Dd**2*f**2*g2*r**2 + 538560*Dd**2*f**2*g2*r*s - 453816*Dd**2*f**2*g2*r + 169488*Dd**2*f**2*g2*s**2 - 304128*Dd**2*f**2*g2*s + 118008*Dd**2*f**2*g2 + 462*b1**3*(D1**2*(8*fd - 9*fdd)*(r + s - 1)**2 + D1*(2*Dd*(4*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 9*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 9*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 9*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(280*C*D1**2*fd*r**2 + 560*C*D1**2*fd*r*s - 560*C*D1**2*fd*r + 280*C*D1**2*fd*s**2 - 560*C*D1**2*fd*s + 280*C*D1**2*fd + 1120*C*D1*Dd*f*r**2 + 2240*C*D1*Dd*f*r*s - 1680*C*D1*Dd*f*r + 1120*C*D1*Dd*f*s**2 - 1680*C*D1*Dd*f*s + 840*C*D1*Dd*f + 910*D1**2*K*fd*r**2 + 1316*D1**2*K*fd*r*s + 112*D1**2*K*fd*r + 406*D1**2*K*fd*s**2 + 112*D1**2*K*fd*s - 56*D1**2*K*fd - 910*D1**2*K*fdd*r**2 - 1568*D1**2*K*fdd*r*s - 56*D1**2*K*fdd*r - 658*D1**2*K*fdd*s**2 - 56*D1**2*K*fdd*s + 28*D1**2*K*fdd - 14*D1**2*bdd1*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 782*D1**2*f*fd*r**2 - 1900*D1**2*f*fd*r*s + 866*D1**2*f*fd*r - 1118*D1**2*f*fd*s**2 + 1034*D1**2*f*fd*s - 517*D1**2*f*fd + 1098*D1**2*f*fdd*r**2 + 2532*D1**2*f*fdd*r*s - 1266*D1**2*f*fdd*r + 1434*D1**2*f*fdd*s**2 - 1434*D1**2*f*fdd*s + 717*D1**2*f*fdd + 1098*D1**2*fd**2*r**2 + 2532*D1**2*fd**2*r*s - 1266*D1**2*fd**2*r + 1434*D1**2*fd**2*s**2 - 1434*D1**2*fd**2*s - 735*D1**2*fd*r**2 - 1162*D1**2*fd*r*s + 364*D1**2*fd*r - 427*D1**2*fd*s**2 + 364*D1**2*fd*s - 182*D1**2*fd + 455*D1**2*fdd*r**2 + 826*D1**2*fdd*r*s + 28*D1**2*fdd*r + 371*D1**2*fdd*s**2 + 28*D1**2*fdd*s - 14*D1**2*fdd + 560*D1**2*gd2*r**2 + 1120*D1**2*gd2*r*s - 1120*D1**2*gd2*r + 560*D1**2*gd2*s**2 - 1120*D1**2*gd2*s + 560*D1**2*gd2 - 280*D1**2*gdd2*r**2 - 560*D1**2*gdd2*r*s + 560*D1**2*gdd2*r - 280*D1**2*gdd2*s**2 + 560*D1**2*gdd2*s - 280*D1**2*gdd2 + 3640*D1*Dd*K*f*r**2 + 5264*D1*Dd*K*f*r*s - 4452*D1*Dd*K*f*r + 1624*D1*Dd*K*f*s**2 - 2940*D1*Dd*K*f*s + 1722*D1*Dd*K*f - 7280*D1*Dd*K*fd*r**2 - 12544*D1*Dd*K*fd*r*s + 4732*D1*Dd*K*fd*r - 5264*D1*Dd*K*fd*s**2 + 3976*D1*Dd*K*fd*s + 168*D1*Dd*K*fd - 1564*D1*Dd*f**2*r**2 - 3800*D1*Dd*f**2*r*s + 2682*D1*Dd*f**2*r - 2236*D1*Dd*f**2*s**2 + 3186*D1*Dd*f**2*s - 1509*D1*Dd*f**2 + 8784*D1*Dd*f*fd*r**2 + 20256*D1*Dd*f*fd*r*s - 12324*D1*Dd*f*fd*r + 11472*D1*Dd*f*fd*s**2 - 14004*D1*Dd*f*fd*s + 4134*D1*Dd*f*fd - 2940*D1*Dd*f*r**2 - 4648*D1*Dd*f*r*s + 3794*D1*Dd*f*r - 1708*D1*Dd*f*s**2 + 2870*D1*Dd*f*s - 1589*D1*Dd*f + 3640*D1*Dd*fd*r**2 + 6608*D1*Dd*fd*r*s - 2450*D1*Dd*fd*r + 2968*D1*Dd*fd*s**2 - 2198*D1*Dd*fd*s - 84*D1*Dd*fd + 2240*D1*Dd*g2*r**2 + 4480*D1*Dd*g2*r*s - 3360*D1*Dd*g2*r + 2240*D1*Dd*g2*s**2 - 3360*D1*Dd*g2*s + 1680*D1*Dd*g2 - 2240*D1*Dd*gd2*r**2 - 4480*D1*Dd*gd2*r*s + 3920*D1*Dd*gd2*r - 2240*D1*Dd*gd2*s**2 + 3920*D1*Dd*gd2*s - 1680*D1*Dd*gd2 - 3640*D1*Ddd*K*f*r**2 - 6272*D1*Ddd*K*f*r*s + 4956*D1*Ddd*K*f*r - 2632*D1*Ddd*K*f*s**2 + 4200*D1*Ddd*K*f*s - 2226*D1*Ddd*K*f + 2196*D1*Ddd*f**2*r**2 + 5064*D1*Ddd*f**2*r*s - 3630*D1*Ddd*f**2*r + 2868*D1*Ddd*f**2*s**2 - 4134*D1*Ddd*f**2*s + 1983*D1*Ddd*f**2 + 1820*D1*Ddd*f*r**2 + 3304*D1*Ddd*f*r*s - 2562*D1*Ddd*f*r + 1484*D1*Ddd*f*s**2 - 2310*D1*Ddd*f*s + 1197*D1*Ddd*f - 1120*D1*Ddd*g2*r**2 - 2240*D1*Ddd*g2*r*s + 1680*D1*Ddd*g2*r - 1120*D1*Ddd*g2*s**2 + 1680*D1*Ddd*g2*s - 840*D1*Ddd*g2 + 28*D1*bd1*(D1*(4*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-10*K + 9*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 10920*Dd**2*K*f*r**2 - 18816*Dd**2*K*f*r*s + 14868*Dd**2*K*f*r - 7896*Dd**2*K*f*s**2 + 12600*Dd**2*K*f*s - 4452*Dd**2*K*f + 6588*Dd**2*f**2*r**2 + 15192*Dd**2*f**2*r*s - 10890*Dd**2*f**2*r + 8604*Dd**2*f**2*s**2 - 12402*Dd**2*f**2*s + 3966*Dd**2*f**2 + 5460*Dd**2*f*r**2 + 9912*Dd**2*f*r*s - 7686*Dd**2*f*r + 4452*Dd**2*f*s**2 - 6930*Dd**2*f*s + 2394*Dd**2*f - 3360*Dd**2*g2*r**2 - 6720*Dd**2*g2*r*s + 5040*Dd**2*g2*r - 3360*Dd**2*g2*s**2 + 5040*Dd**2*g2*s - 1680*Dd**2*g2) - 33*b1*(1008*C*D1**2*f*fd*r**2 + 1232*C*D1**2*f*fd*r*s - 504*C*D1**2*f*fd*r + 224*C*D1**2*f*fd*s**2 - 112*C*D1**2*f*fd*s + 56*C*D1**2*f*fd + 2016*C*D1*Dd*f**2*r**2 + 2464*C*D1*Dd*f**2*r*s - 2240*C*D1*Dd*f**2*r + 448*C*D1*Dd*f**2*s**2 - 1064*C*D1*Dd*f**2*s + 728*C*D1*Dd*f**2 + 1820*D1**2*K*bdd1*f*r**2 + 3136*D1**2*K*bdd1*f*r*s - 3444*D1**2*K*bdd1*f*r + 1316*D1**2*K*bdd1*f*s**2 - 2940*D1**2*K*bdd1*f*s + 1596*D1**2*K*bdd1*f - 1164*D1**2*K*f*fd*r**2 - 1656*D1**2*K*f*fd*r*s + 1164*D1**2*K*f*fd*r - 492*D1**2*K*f*fd*s**2 + 828*D1**2*K*f*fd*s - 582*D1**2*K*f*fd + 932*D1**2*K*f*fdd*r**2 + 1360*D1**2*K*f*fdd*r*s - 932*D1**2*K*f*fdd*r + 428*D1**2*K*f*fdd*s**2 - 680*D1**2*K*f*fdd*s + 466*D1**2*K*f*fdd + 932*D1**2*K*fd**2*r**2 + 1360*D1**2*K*fd**2*r*s - 932*D1**2*K*fd**2*r + 428*D1**2*K*fd**2*s**2 - 680*D1**2*K*fd**2*s - 196*D1**2*b2*fd*r**2 - 392*D1**2*b2*fd*r*s - 196*D1**2*b2*fd*s**2 + 168*D1**2*b2*fdd*r**2 + 336*D1**2*b2*fdd*r*s + 168*D1**2*b2*fdd*s**2 + 28*D1**2*bd1**2*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 1098*D1**2*bdd1*f**2*r**2 - 2532*D1**2*bdd1*f**2*r*s + 2364*D1**2*bdd1*f**2*r - 1434*D1**2*bdd1*f**2*s**2 + 2700*D1**2*bdd1*f**2*s - 1266*D1**2*bdd1*f**2 - 910*D1**2*bdd1*f*r**2 - 1652*D1**2*bdd1*f*r*s + 1764*D1**2*bdd1*f*r - 742*D1**2*bdd1*f*s**2 + 1596*D1**2*bdd1*f*s - 840*D1**2*bdd1*f + 560*D1**2*bdd1*g2*r**2 + 1120*D1**2*bdd1*g2*r*s - 560*D1**2*bdd1*g2*r + 560*D1**2*bdd1*g2*s**2 - 560*D1**2*bdd1*g2*s + 280*D1**2*bdd1*g2 + 168*D1**2*bdd2*f*r**2 + 336*D1**2*bdd2*f*r*s - 336*D1**2*bdd2*f*r + 168*D1**2*bdd2*f*s**2 - 336*D1**2*bdd2*f*s + 168*D1**2*bdd2*f + 588*D1**2*f**2*fd*r**2 + 480*D1**2*f**2*fd*r*s - 428*D1**2*f**2*fd*r - 108*D1**2*f**2*fd*s**2 + 36*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 582*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 364*D1**2*f**2*fdd*r + 162*D1**2*f**2*fdd*s**2 - 132*D1**2*f**2*fdd*s + 54*D1**2*f**2*fdd - 1164*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 728*D1**2*f*fd**2*r + 324*D1**2*f*fd**2*s**2 - 264*D1**2*f*fd**2*s - 36*D1**2*f*fd**2 - 158*D1**2*f*fd*r**2 + 20*D1**2*f*fd*r*s - 234*D1**2*f*fd*r + 178*D1**2*f*fd*s**2 - 402*D1**2*f*fd*s + 271*D1**2*f*fd - 418*D1**2*f*fdd*r**2 - 668*D1**2*f*fdd*r*s + 418*D1**2*f*fdd*r - 250*D1**2*f*fdd*s**2 + 334*D1**2*f*fdd*s - 209*D1**2*f*fdd + 1820*D1**2*f*gd2*r**2 + 2632*D1**2*f*gd2*r*s - 2632*D1**2*f*gd2*r + 812*D1**2*f*gd2*s**2 - 1624*D1**2*f*gd2*s + 812*D1**2*f*gd2 - 1820*D1**2*f*gdd2*r**2 - 3136*D1**2*f*gdd2*r*s + 3136*D1**2*f*gdd2*r - 1316*D1**2*f*gdd2*s**2 + 2632*D1**2*f*gdd2*s - 1316*D1**2*f*gdd2 - 418*D1**2*fd**2*r**2 - 668*D1**2*fd**2*r*s + 418*D1**2*fd**2*r - 250*D1**2*fd**2*s**2 + 334*D1**2*fd**2*s + 1820*D1**2*fd*g2*r**2 + 2632*D1**2*fd*g2*r*s + 224*D1**2*fd*g2*r + 812*D1**2*fd*g2*s**2 + 224*D1**2*fd*g2*s - 112*D1**2*fd*g2 - 3640*D1**2*fd*gd2*r**2 - 6272*D1**2*fd*gd2*r*s + 3024*D1**2*fd*gd2*r - 2632*D1**2*fd*gd2*s**2 + 2520*D1**2*fd*gd2*s + 112*D1**2*fd*gd2 - 1820*D1**2*fdd*g2*r**2 - 3136*D1**2*fdd*g2*r*s - 112*D1**2*fdd*g2*r - 1316*D1**2*fdd*g2*s**2 - 112*D1**2*fdd*g2*s + 56*D1**2*fdd*g2 - 2328*D1*Dd*K*f**2*r**2 - 3312*D1*Dd*K*f**2*r*s + 2820*D1*Dd*K*f**2*r - 984*D1*Dd*K*f**2*s**2 + 1812*D1*Dd*K*f**2*s - 1074*D1*Dd*K*f**2 + 7456*D1*Dd*K*f*fd*r**2 + 10880*D1*Dd*K*f*fd*r*s - 8312*D1*Dd*K*f*fd*r + 3424*D1*Dd*K*f*fd*s**2 - 5792*D1*Dd*K*f*fd*s + 2292*D1*Dd*K*f*fd - 784*D1*Dd*b2*f*r**2 - 1568*D1*Dd*b2*f*r*s + 1176*D1*Dd*b2*f*r - 784*D1*Dd*b2*f*s**2 + 1176*D1*Dd*b2*f*s - 588*D1*Dd*b2*f + 1344*D1*Dd*b2*fd*r**2 + 2688*D1*Dd*b2*fd*r*s - 1008*D1*Dd*b2*fd*r + 1344*D1*Dd*b2*fd*s**2 - 1008*D1*Dd*b2*fd*s + 784*D1*Dd*f**3*r**2 + 640*D1*Dd*f**3*r*s - 712*D1*Dd*f**3*r - 144*D1*Dd*f**3*s**2 - 16*D1*Dd*f**3*s + 124*D1*Dd*f**3 - 4656*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3460*D1*Dd*f**2*fd*r + 1296*D1*Dd*f**2*fd*s**2 - 756*D1*Dd*f**2*fd*s - 100*D1*Dd*f**2*fd - 316*D1*Dd*f**2*r**2 + 40*D1*Dd*f**2*r*s + 138*D1*Dd*f**2*r + 356*D1*Dd*f**2*s**2 - 366*D1*Dd*f**2*s + 99*D1*Dd*f**2 - 3344*D1*Dd*f*fd*r**2 - 5344*D1*Dd*f*fd*r*s + 3844*D1*Dd*f*fd*r - 2000*D1*Dd*f*fd*s**2 + 3004*D1*Dd*f*fd*s - 1086*D1*Dd*f*fd + 7280*D1*Dd*f*g2*r**2 + 10528*D1*Dd*f*g2*r*s - 8904*D1*Dd*f*g2*r + 3248*D1*Dd*f*g2*s**2 - 5880*D1*Dd*f*g2*s + 3444*D1*Dd*f*g2 - 14560*D1*Dd*f*gd2*r**2 - 25088*D1*Dd*f*gd2*r*s + 22456*D1*Dd*f*gd2*r - 10528*D1*Dd*f*gd2*s**2 + 18928*D1*Dd*f*gd2*s - 8400*D1*Dd*f*gd2 - 14560*D1*Dd*fd*g2*r**2 - 25088*D1*Dd*fd*g2*r*s + 9464*D1*Dd*fd*g2*r - 10528*D1*Dd*fd*g2*s**2 + 7952*D1*Dd*fd*g2*s + 336*D1*Dd*fd*g2 + 1864*D1*Ddd*K*f**2*r**2 + 2720*D1*Ddd*K*f**2*r*s - 2292*D1*Ddd*K*f**2*r + 856*D1*Ddd*K*f**2*s**2 - 1536*D1*Ddd*K*f**2*s + 894*D1*Ddd*K*f**2 + 672*D1*Ddd*b2*f*r**2 + 1344*D1*Ddd*b2*f*r*s - 1008*D1*Ddd*b2*f*r + 672*D1*Ddd*b2*f*s**2 - 1008*D1*Ddd*b2*f*s + 504*D1*Ddd*b2*f - 776*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 668*D1*Ddd*f**3*r + 216*D1*Ddd*f**3*s**2 - 76*D1*Ddd*f**3*s - 86*D1*Ddd*f**3 - 836*D1*Ddd*f**2*r**2 - 1336*D1*Ddd*f**2*r*s + 1086*D1*Ddd*f**2*r - 500*D1*Ddd*f**2*s**2 + 834*D1*Ddd*f**2*s - 459*D1*Ddd*f**2 - 7280*D1*Ddd*f*g2*r**2 - 12544*D1*Ddd*f*g2*r*s + 9912*D1*Ddd*f*g2*r - 5264*D1*Ddd*f*g2*s**2 + 8400*D1*Ddd*f*g2*s - 4452*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*(391*r**2 + r*(950*s - 908) + 559*s**2 - 1076*s + 496) - f*(140*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*K*(65*r**2 + 94*r*s - 116*r + 29*s**2 - 80*s + 49) + 6*fd*(366*r**2 + r*(844*s - 605) + 478*s**2 - 689*s + 225) - 735*r**2 - 1162*r*s + 1134*r - 427*s**2 + 826*s - 490) + 14*fd*(K*(130*r**2 + 7*r*(32*s - 17) + 94*s**2 - 101*s - 2) - 65*r**2 - 118*r*s + 61*r - 53*s**2 + 55*s + 1) - 280*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 280*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(-3*f**2*(732*r**2 + r*(1688*s - 1393) + 956*s**2 - 1589*s + 647) + 7*f*(K*(520*r**2 + 896*r*s - 846*r + 376*s**2 - 720*s + 333) - 260*r**2 - 472*r*s + 435*r - 212*s**2 + 393*s - 177) + 140*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 28*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 5592*Dd**2*K*f**2*r**2 + 8160*Dd**2*K*f**2*r*s - 6876*Dd**2*K*f**2*r + 2568*Dd**2*K*f**2*s**2 - 4608*Dd**2*K*f**2*s + 1788*Dd**2*K*f**2 + 2016*Dd**2*b2*f*r**2 + 4032*Dd**2*b2*f*r*s - 3024*Dd**2*b2*f*r + 2016*Dd**2*b2*f*s**2 - 3024*Dd**2*b2*f*s + 1008*Dd**2*b2*f - 2328*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 2004*Dd**2*f**3*r + 648*Dd**2*f**3*s**2 - 228*Dd**2*f**3*s - 172*Dd**2*f**3 - 2508*Dd**2*f**2*r**2 - 4008*Dd**2*f**2*r*s + 3258*Dd**2*f**2*r - 1500*Dd**2*f**2*s**2 + 2502*Dd**2*f**2*s - 918*Dd**2*f**2 - 21840*Dd**2*f*g2*r**2 - 37632*Dd**2*f*g2*r*s + 29736*Dd**2*f*g2*r - 15792*Dd**2*f*g2*s**2 + 25200*Dd**2*f*g2*s - 8904*Dd**2*f*g2) + 132*b2*(-42*D1**2*bdd1*f*(r + s - 1)**2 + 58*D1**2*f*fd*r**2 + 116*D1**2*f*fd*r*s - 58*D1**2*f*fd*r + 58*D1**2*f*fd*s**2 - 58*D1**2*f*fd*s + 29*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 116*D1*Dd*f**2*r**2 + 232*D1*Dd*f**2*r*s - 174*D1*Dd*f**2*r + 116*D1*Dd*f**2*s**2 - 174*D1*Dd*f**2*s + 87*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 + 7*D1*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2))/(3465*d**2*k3**6) - D1**2*Pk1*Pk3*ct*k1*k2*st**6*(16*C - 12)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k3**4) + D1**2*Pk1*Pk3*ct*k1*k2*st**4*(-84*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) - 3*b1*(D1**2*(f*(-28*bdd1*s*(4*C - 3)*(2*r + 2*s - 1) + fd*(-4*C*(116*r*(2*s - 1) + 258*s**2 - 250*s + 129) + 324*r*(2*s - 1) + 746*s**2 - 722*s + 373) + fdd*(4*C*(86*r*(2*s - 1) + 206*s**2 - 202*s + 103) - 232*r*(2*s - 1) - 590*s**2 + 578*s - 295)) + 2*fd**2*(4*C*(43*r*(2*s - 1) + 103*s**2 - 101*s - 2) - 116*r*(2*s - 1) - 295*s**2 + 289*s + 6)) - 28*D1*bd1*(4*C - 3)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(4*C*(116*r*(2*s - 1) + 258*s**2 - 316*s + 129) - 648*r*s + 324*r - 746*s**2 + 908*s - 373) - 2*fd*(2*s - 1)*(C*(688*r + 824*s - 490) - 464*r - 590*s + 347)) + Ddd*f*(-4*C*(86*r*(2*s - 1) + 206*s**2 - 249*s + 103) + 232*r*(2*s - 1) + 590*s**2 - 706*s + 295)) + 2*Dd**2*f**2*(12*C*(86*r*(2*s - 1) + 206*s**2 - 249*s + 63) - 696*r*(2*s - 1) - 1770*s**2 + 2118*s - 527)) + f*(84*D1**2*bd1**2*s*(4*C - 3)*(2*r + 2*s - 1) + D1**2*(f*(3*bdd1*s*(-4*C*(86*r + 103*s - 90) + 232*r + 295*s - 244) + fd*(4*C*(148*r*(3*s - 1) + 327*s**2 - 366*s + 109) - 388*r*(3*s - 1) - 915*s**2 + 998*s - 305) + fdd*(-4*C*(110*r*(3*s - 1) + 213*s**2 - 252*s + 71) + 284*r*(3*s - 1) + 597*s**2 - 682*s + 199)) - 2*fd**2*(4*C*(110*r*(3*s - 1) + 213*s**2 - 252*s + 55) - 284*r*(3*s - 1) - 597*s**2 + 682*s - 142)) + 3*D1*bd1*(D1*(f*s*(C*(464*r + 516*s - 496) - 324*r - 373*s + 348) - 2*fd*(4*C*(43*r*(4*s - 1) + 206*s**2 - 191*s + 45) - 464*r*s + 116*r - 590*s**2 + 533*s - 122)) - 4*Dd*f*(2*C*(86*r*(4*s - 1) + 412*s**2 - 429*s + 90) - 464*r*s + 116*r - 590*s**2 + 597*s - 122)) + 2*D1*f*(Dd*(f*(4*C*(148*r*(2*s - 1) + 218*s**2 - 292*s + 109) - 776*r*s + 388*r - 610*s**2 + 804*s - 305) - 4*fd*(C*(110*r*(12*s - 5) + 852*s**2 - 1095*s + 307) - 852*r*s + 355*r - 597*s**2 + 746*s - 206)) + Ddd*f*(-4*C*(110*r*(2*s - 1) + 142*s**2 - 197*s + 71) + 284*r*(2*s - 1) + 398*s**2 - 540*s + 199)) + 2*Dd**2*f**2*(-4*C*(330*r*(2*s - 1) + 426*s**2 - 591*s + 181) + 852*r*(2*s - 1) + 1194*s**2 - 1620*s + 483)))/(105*d**2*k3**4) - D1**2*Pk1*Pk3*ct*k1*k2*st**2*(21*b1**2*(D1**2*(fd*(4*C*(r - 31*s + 31) - 5*r + 87*s - 87) + fdd*(68*C*r + 132*C*(s - 1) - 45*r - 101*s + 101))*(r + s - 1) + D1*(Dd*(f*(4*C*(4*r**2 - 120*r*s + 58*r - 124*s**2 + 154*s - 61) - 20*r**2 + 328*r*s - 154*r + 348*s**2 - 430*s + 169) + 2*fd*(4*C*(68*r**2 + 200*r*s - 167*r + 132*s**2 - 223*s + 91) - 180*r**2 - 584*r*s + 483*r - 404*s**2 + 679*s - 275)) + Ddd*f*(4*C*(68*r**2 + 200*r*s - 134*r + 132*s**2 - 182*s + 83) - 180*r**2 - 584*r*s + 382*r - 404*s**2 + 550*s - 247)) + 2*Dd**2*f*(4*C*(102*r**2 + 3*r*(100*s - 67) + 198*s**2 - 273*s + 83) - 270*r**2 + r*(573 - 876*s) - 606*s**2 + 825*s - 247)) + 3*b1*(576*C*D1**2*f*fd*r**2 + 5840*C*D1**2*f*fd*r*s - 2208*C*D1**2*f*fd*r + 4296*C*D1**2*f*fd*s**2 - 3664*C*D1**2*f*fd*s + 1792*C*D1**2*f*fd - 1296*C*D1**2*f*fdd*r**2 - 5888*C*D1**2*f*fdd*r*s + 2280*C*D1**2*f*fdd*r - 4136*C*D1**2*f*fdd*s**2 + 3568*C*D1**2*f*fdd*s - 1736*C*D1**2*f*fdd - 1296*C*D1**2*fd**2*r**2 - 5888*C*D1**2*fd**2*r*s + 2280*C*D1**2*fd**2*r - 4136*C*D1**2*fd**2*s**2 + 3568*C*D1**2*fd**2*s + 568*C*D1**2*fd**2 + 1152*C*D1*Dd*f**2*r**2 + 11680*C*D1*Dd*f**2*r*s - 6416*C*D1*Dd*f**2*r + 8592*C*D1*Dd*f**2*s**2 - 11512*C*D1*Dd*f**2*s + 4584*C*D1*Dd*f**2 - 10368*C*D1*Dd*f*fd*r**2 - 47104*C*D1*Dd*f*fd*r*s + 23488*C*D1*Dd*f*fd*r - 33088*C*D1*Dd*f*fd*s**2 + 36704*C*D1*Dd*f*fd*s - 9416*C*D1*Dd*f*fd - 2592*C*D1*Ddd*f**2*r**2 - 11776*C*D1*Ddd*f**2*r*s + 7184*C*D1*Ddd*f**2*r - 8272*C*D1*Ddd*f**2*s**2 + 11216*C*D1*Ddd*f**2*s - 4784*C*D1*Ddd*f**2 - 7776*C*Dd**2*f**2*r**2 - 35328*C*Dd**2*f**2*r*s + 21552*C*Dd**2*f**2*r - 24816*C*Dd**2*f**2*s**2 + 33648*C*Dd**2*f**2*s - 10024*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(4*C*(34*r**2 + 2*r*(50*s - 17) + 66*s**2 - 50*s + 17) - 90*r**2 + r*(90 - 292*s) - 202*s**2 + 146*s - 45) - 442*D1**2*f*fd*r**2 - 4104*D1**2*f*fd*r*s + 1602*D1**2*f*fd*r - 3044*D1**2*f*fd*s**2 + 2614*D1**2*f*fd*s - 1297*D1**2*f*fd + 802*D1**2*f*fdd*r**2 + 4152*D1**2*f*fdd*r*s - 1662*D1**2*f*fdd*r + 3076*D1**2*f*fdd*s**2 - 2686*D1**2*f*fdd*s + 1331*D1**2*f*fdd + 802*D1**2*fd**2*r**2 + 4152*D1**2*fd**2*r*s - 1662*D1**2*fd**2*r + 3076*D1**2*fd**2*s**2 - 2686*D1**2*fd**2*s - 390*D1**2*fd**2 - 884*D1*Dd*f**2*r**2 - 8208*D1*Dd*f**2*r*s + 4546*D1*Dd*f**2*r - 6088*D1*Dd*f**2*s**2 + 8140*D1*Dd*f**2*s - 3265*D1*Dd*f**2 + 6416*D1*Dd*f*fd*r**2 + 33216*D1*Dd*f*fd*r*s - 16556*D1*Dd*f*fd*r + 24608*D1*Dd*f*fd*s**2 - 27200*D1*Dd*f*fd*s + 7034*D1*Dd*f*fd + 1604*D1*Ddd*f**2*r**2 + 8304*D1*Ddd*f**2*r*s - 4954*D1*Ddd*f**2*r + 6152*D1*Ddd*f**2*s**2 - 8228*D1*Ddd*f**2*s + 3477*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(4*C*(2*r**2 - 2*r*(30*s + 1) - 62*s**2 + 30*s + 1) - 10*r**2 + 2*r*(82*s + 5) + 174*s**2 - 82*s - 5) + 2*fd*(4*C*(34*r**2 + r*(100*s - 67) + 66*s**2 - 91*s + 25) - 90*r**2 + r*(191 - 292*s) - 202*s**2 + 275*s - 73)) + 2*Dd*f*(4*C*(136*r**2 + r*(400*s - 202) + 264*s**2 - 282*s + 67) - 360*r**2 + r*(562 - 1168*s) - 808*s**2 + 842*s - 191)) + 4812*Dd**2*f**2*r**2 + 24912*Dd**2*f**2*r*s - 14862*Dd**2*f**2*r + 18456*Dd**2*f**2*s**2 - 24684*Dd**2*f**2*s + 7228*Dd**2*f**2) + f*(6132*C*D1**2*f*fd*r**2 + 18096*C*D1**2*f*fd*r*s - 10120*C*D1**2*f*fd*r + 7704*C*D1**2*f*fd*s**2 - 11168*C*D1**2*f*fd*s + 4612*C*D1**2*f*fd - 6468*C*D1**2*f*fdd*r**2 - 16824*C*D1**2*f*fdd*r*s + 9920*C*D1**2*f*fdd*r - 7200*C*D1**2*f*fdd*s**2 + 10408*C*D1**2*f*fdd*s - 4556*C*D1**2*f*fdd - 12936*C*D1**2*fd**2*r**2 - 33648*C*D1**2*fd**2*r*s + 19840*C*D1**2*fd**2*r - 14400*C*D1**2*fd**2*s**2 + 20816*C*D1**2*fd**2*s - 5608*C*D1**2*fd**2 + 8176*C*D1*Dd*f**2*r**2 + 24128*C*D1*Dd*f**2*r*s - 16152*C*D1*Dd*f**2*r + 10272*C*D1*Dd*f**2*s**2 - 16304*C*D1*Dd*f**2*s + 7180*C*D1*Dd*f**2 - 51744*C*D1*Dd*f*fd*r**2 - 134592*C*D1*Dd*f*fd*r*s + 86264*C*D1*Dd*f*fd*r - 57600*C*D1*Dd*f*fd*s**2 + 87256*C*D1*Dd*f*fd*s - 30736*C*D1*Dd*f*fd - 8624*C*D1*Ddd*f**2*r**2 - 22432*C*D1*Ddd*f**2*r*s + 15528*C*D1*Ddd*f**2*r - 9600*C*D1*Ddd*f**2*s**2 + 15208*C*D1*Ddd*f**2*s - 6956*C*D1*Ddd*f**2 - 25872*C*Dd**2*f**2*r**2 - 67296*C*Dd**2*f**2*r*s + 46584*C*Dd**2*f**2*r - 28800*C*Dd**2*f**2*s**2 + 45624*C*Dd**2*f**2*s - 16016*C*Dd**2*f**2 + 42*D1**2*bd1**2*(r**2*(68*C - 45) + r*(4*C*(50*s - 17) - 146*s + 45) + s*(4*C*(33*s - 25) - 101*s + 73)) - 3*D1**2*bdd1*f*(4*C*(162*r**2 + 736*r*s - 490*r + 517*s**2 - 878*s + 245) - 401*r**2 - 2076*r*s + 1216*r - 1538*s**2 + 2466*s - 608) - 3756*D1**2*f*fd*r**2 - 12402*D1**2*f*fd*r*s + 6638*D1**2*f*fd*r - 5571*D1**2*f*fd*s**2 + 7848*D1**2*f*fd*s - 3109*D1**2*f*fd + 3876*D1**2*f*fdd*r**2 + 11466*D1**2*f*fdd*r*s - 6406*D1**2*f*fdd*r + 5445*D1**2*f*fdd*s**2 - 7452*D1**2*f*fdd*s + 3107*D1**2*f*fdd + 7752*D1**2*fd**2*r**2 + 22932*D1**2*fd**2*r*s - 12812*D1**2*fd**2*r + 10890*D1**2*fd**2*s**2 - 14904*D1**2*fd**2*s + 3822*D1**2*fd**2 - 5008*D1*Dd*f**2*r**2 - 16536*D1*Dd*f**2*r*s + 10772*D1*Dd*f**2*r - 7428*D1*Dd*f**2*s**2 + 11562*D1*Dd*f**2*s - 4966*D1*Dd*f**2 + 31008*D1*Dd*f*fd*r**2 + 91728*D1*Dd*f*fd*r*s - 56308*D1*Dd*f*fd*r + 43560*D1*Dd*f*fd*s**2 - 63054*D1*Dd*f*fd*s + 21310*D1*Dd*f*fd + 5168*D1*Ddd*f**2*r**2 + 15288*D1*Ddd*f**2*r*s - 10228*D1*Ddd*f**2*r + 7260*D1*Ddd*f**2*s**2 - 11082*D1*Ddd*f**2*s + 4922*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(4*C*(72*r**2 + 730*r*s - 322*r + 537*s**2 - 888*s + 161) - 221*r**2 - 2052*r*s + 892*r - 1522*s**2 + 2482*s - 446) + 2*fd*(-4*C*(324*r**2 + 1472*r*s - 775*r + 1034*s**2 - 1324*s + 439) + 802*r**2 + 4152*r*s - 2047*r + 3076*s**2 - 3809*s + 1233)) - 2*Dd*f*(4*C*(648*r**2 + 2944*r*s - 1878*r + 2068*s**2 - 3158*s + 1123) - 1604*r**2 - 8304*r*s + 4909*r - 6152*s**2 + 9046*s - 3074)) + 15504*Dd**2*f**2*r**2 + 45864*Dd**2*f**2*r*s - 30684*Dd**2*f**2*r + 21780*Dd**2*f**2*s**2 - 33246*Dd**2*f**2*s + 11274*Dd**2*f**2))/(315*d**2*k3**4) - D1**2*Pk1*Pk3*ct*k1*k2*(-3024*D1**2*K*bd1**2*f*r**2 - 7224*D1**2*K*bd1**2*f*r*s + 9072*D1**2*K*bd1**2*f*r - 3864*D1**2*K*bd1**2*f*s**2 + 9408*D1**2*K*bd1**2*f*s - 5544*D1**2*K*bd1**2*f + 2430*D1**2*K*bd1*f**2*r**2 + 3120*D1**2*K*bd1*f**2*r*s - 3120*D1**2*K*bd1*f**2*r + 1146*D1**2*K*bd1*f**2*s**2 - 2292*D1**2*K*bd1*f**2*s + 1146*D1**2*K*bd1*f**2 - 9144*D1**2*K*bd1*f*fd*r**2 - 15648*D1**2*K*bd1*f*fd*r*s + 12396*D1**2*K*bd1*f*fd*r - 5736*D1**2*K*bd1*f*fd*s**2 + 9648*D1**2*K*bd1*f*fd*s - 3912*D1**2*K*bd1*f*fd - 2286*D1**2*K*bdd1*f**2*r**2 - 3912*D1**2*K*bdd1*f**2*r*s + 3912*D1**2*K*bdd1*f**2*r - 1434*D1**2*K*bdd1*f**2*s**2 + 2868*D1**2*K*bdd1*f**2*s - 1434*D1**2*K*bdd1*f**2 + 630*D1**2*bd1**2*f**2*r**2 + 3528*D1**2*bd1**2*f**2*r*s - 2664*D1**2*bd1**2*f**2*r + 2898*D1**2*bd1**2*f**2*s**2 - 4860*D1**2*bd1**2*f**2*s + 2214*D1**2*bd1**2*f**2 + 1050*D1**2*bd1**2*f*r**2 + 4368*D1**2*bd1**2*f*r*s - 4032*D1**2*bd1**2*f*r + 2982*D1**2*bd1**2*f*s**2 - 6048*D1**2*bd1**2*f*s + 3066*D1**2*bd1**2*f - 5880*D1**2*bd1**2*g2*r**2 - 11760*D1**2*bd1**2*g2*r*s + 5880*D1**2*bd1**2*g2*r - 5880*D1**2*bd1**2*g2*s**2 + 5880*D1**2*bd1**2*g2*s - 2100*D1**2*bd1*bd2*f*r**2 - 4200*D1**2*bd1*bd2*f*r*s + 4200*D1**2*bd1*bd2*f*r - 2100*D1**2*bd1*bd2*f*s**2 + 4200*D1**2*bd1*bd2*f*s - 2100*D1**2*bd1*bd2*f - 530*D1**2*bd1*f**3*r**2 - 1438*D1**2*bd1*f**3*r*s + 1582*D1**2*bd1*f**3*r - 585*D1**2*bd1*f**3*s**2 + 1620*D1**2*bd1*f**3*s - 972*D1**2*bd1*f**3 + 2940*D1**2*bd1*f**2*fd*r**2 + 9228*D1**2*bd1*f**2*fd*r*s - 7420*D1**2*bd1*f**2*fd*r + 4050*D1**2*bd1*f**2*fd*s**2 - 7838*D1**2*bd1*f**2*fd*s + 3158*D1**2*bd1*f**2*fd - 774*D1**2*bd1*f**2*r**2 - 1494*D1**2*bd1*f**2*r*s + 1494*D1**2*bd1*f**2*r - 888*D1**2*bd1*f**2*s**2 + 1776*D1**2*bd1*f**2*s - 888*D1**2*bd1*f**2 + 2808*D1**2*bd1*f*fd*r**2 + 8280*D1**2*bd1*f*fd*r*s - 5544*D1**2*bd1*f*fd*r + 4632*D1**2*bd1*f*fd*s**2 - 6702*D1**2*bd1*f*fd*s + 2070*D1**2*bd1*f*fd - 1848*D1**2*bd1*f*g2*r**2 - 5208*D1**2*bd1*f*g2*r*s + 7560*D1**2*bd1*f*g2*r - 4368*D1**2*bd1*f*g2*s**2 + 7056*D1**2*bd1*f*g2*s - 3780*D1**2*bd1*f*g2 + 6048*D1**2*bd1*f*gd2*r**2 + 14448*D1**2*bd1*f*gd2*r*s - 18144*D1**2*bd1*f*gd2*r + 7728*D1**2*bd1*f*gd2*s**2 - 18816*D1**2*bd1*f*gd2*s + 11088*D1**2*bd1*f*gd2 + 6048*D1**2*bd1*fd*g2*r**2 + 14448*D1**2*bd1*fd*g2*r*s - 6048*D1**2*bd1*fd*g2*r + 7728*D1**2*bd1*fd*g2*s**2 - 7224*D1**2*bd1*fd*g2*s + 810*D1**2*bd2*f**2*r**2 + 1188*D1**2*bd2*f**2*r*s - 1188*D1**2*bd2*f**2*r + 378*D1**2*bd2*f**2*s**2 - 756*D1**2*bd2*f**2*s + 378*D1**2*bd2*f**2 - 3384*D1**2*bd2*f*fd*r**2 - 5904*D1**2*bd2*f*fd*r*s + 4644*D1**2*bd2*f*fd*r - 2520*D1**2*bd2*f*fd*s**2 + 3996*D1**2*bd2*f*fd*s - 1476*D1**2*bd2*f*fd + 490*D1**2*bdd1*f**3*r**2 + 1538*D1**2*bdd1*f**3*r*s - 1682*D1**2*bdd1*f**3*r + 675*D1**2*bdd1*f**3*s**2 - 1800*D1**2*bdd1*f**3*s + 1062*D1**2*bdd1*f**3 + 702*D1**2*bdd1*f**2*r**2 + 2070*D1**2*bdd1*f**2*r*s - 2070*D1**2*bdd1*f**2*r + 1158*D1**2*bdd1*f**2*s**2 - 2316*D1**2*bdd1*f**2*s + 1158*D1**2*bdd1*f**2 + 3024*D1**2*bdd1*f*g2*r**2 + 7224*D1**2*bdd1*f*g2*r*s - 10920*D1**2*bdd1*f*g2*r + 3864*D1**2*bdd1*f*g2*s**2 - 11088*D1**2*bdd1*f*g2*s + 5460*D1**2*bdd1*f*g2 - 846*D1**2*bdd2*f**2*r**2 - 1476*D1**2*bdd2*f**2*r*s + 1476*D1**2*bdd2*f**2*r - 630*D1**2*bdd2*f**2*s**2 + 1260*D1**2*bdd2*f**2*s - 630*D1**2*bdd2*f**2 + 1040*D1**2*f**3*fd*r*s - 520*D1**2*f**3*fd*r + 1620*D1**2*f**3*fd*s**2 - 1880*D1**2*f**3*fd*s + 810*D1**2*f**3*fd - 1040*D1**2*f**3*fdd*r*s + 520*D1**2*f**3*fdd*r - 1620*D1**2*f**3*fdd*s**2 + 1880*D1**2*f**3*fdd*s - 810*D1**2*f**3*fdd - 3120*D1**2*f**2*fd**2*r*s + 1560*D1**2*f**2*fd**2*r - 4860*D1**2*f**2*fd**2*s**2 + 5640*D1**2*f**2*fd**2*s - 1330*D1**2*f**2*fd**2 - 4860*D1**2*f**2*gd2*r**2 - 6240*D1**2*f**2*gd2*r*s + 6240*D1**2*f**2*gd2*r - 2292*D1**2*f**2*gd2*s**2 + 4584*D1**2*f**2*gd2*s - 2292*D1**2*f**2*gd2 + 4572*D1**2*f**2*gdd2*r**2 + 7824*D1**2*f**2*gdd2*r*s - 7824*D1**2*f**2*gdd2*r + 2868*D1**2*f**2*gdd2*s**2 - 5736*D1**2*f**2*gdd2*s + 2868*D1**2*f**2*gdd2 - 9720*D1**2*f*fd*g2*r**2 - 12480*D1**2*f*fd*g2*r*s + 9720*D1**2*f*fd*g2*r - 4584*D1**2*f*fd*g2*s**2 + 6240*D1**2*f*fd*g2*s - 4860*D1**2*f*fd*g2 + 18288*D1**2*f*fd*gd2*r**2 + 31296*D1**2*f*fd*gd2*r*s - 24792*D1**2*f*fd*gd2*r + 11472*D1**2*f*fd*gd2*s**2 - 19296*D1**2*f*fd*gd2*s + 7824*D1**2*f*fd*gd2 + 9144*D1**2*f*fdd*g2*r**2 + 15648*D1**2*f*fdd*g2*r*s - 9144*D1**2*f*fdd*g2*r + 5736*D1**2*f*fdd*g2*s**2 - 7824*D1**2*f*fdd*g2*s + 4572*D1**2*f*fdd*g2 + 9144*D1**2*fd**2*g2*r**2 + 15648*D1**2*fd**2*g2*r*s - 9144*D1**2*fd**2*g2*r + 5736*D1**2*fd**2*g2*s**2 - 7824*D1**2*fd**2*g2*s - 18288*D1*Dd*K*bd1*f**2*r**2 - 31296*D1*Dd*K*bd1*f**2*r*s + 28044*D1*Dd*K*bd1*f**2*r - 11472*D1*Dd*K*bd1*f**2*s**2 + 21120*D1*Dd*K*bd1*f**2*s - 9648*D1*Dd*K*bd1*f**2 + 3920*D1*Dd*bd1*f**3*r**2 + 12304*D1*Dd*bd1*f**3*r*s - 10784*D1*Dd*bd1*f**3*r + 5400*D1*Dd*bd1*f**3*s**2 - 11438*D1*Dd*bd1*f**3*s + 5282*D1*Dd*bd1*f**3 + 5616*D1*Dd*bd1*f**2*r**2 + 16560*D1*Dd*bd1*f**2*r*s - 13824*D1*Dd*bd1*f**2*r + 9264*D1*Dd*bd1*f**2*s**2 - 15966*D1*Dd*bd1*f**2*s + 6702*D1*Dd*bd1*f**2 + 24192*D1*Dd*bd1*f*g2*r**2 + 57792*D1*Dd*bd1*f*g2*r*s - 64176*D1*Dd*bd1*f*g2*r + 30912*D1*Dd*bd1*f*g2*s**2 - 67032*D1*Dd*bd1*f*g2*s + 33096*D1*Dd*bd1*f*g2 - 6768*D1*Dd*bd2*f**2*r**2 - 11808*D1*Dd*bd2*f**2*r*s + 10548*D1*Dd*bd2*f**2*r - 5040*D1*Dd*bd2*f**2*s**2 + 9036*D1*Dd*bd2*f**2*s - 3996*D1*Dd*bd2*f**2 + 1040*D1*Dd*f**4*r*s - 520*D1*Dd*f**4*r + 1620*D1*Dd*f**4*s**2 - 1880*D1*Dd*f**4*s + 810*D1*Dd*f**4 - 8320*D1*Dd*f**3*fd*r*s + 4160*D1*Dd*f**3*fd*r - 12960*D1*Dd*f**3*fd*s**2 + 15040*D1*Dd*f**3*fd*s - 4280*D1*Dd*f**3*fd - 19440*D1*Dd*f**2*g2*r**2 - 24960*D1*Dd*f**2*g2*r*s + 22200*D1*Dd*f**2*g2*r - 9168*D1*Dd*f**2*g2*s**2 + 15408*D1*Dd*f**2*g2*s - 9444*D1*Dd*f**2*g2 + 36576*D1*Dd*f**2*gd2*r**2 + 62592*D1*Dd*f**2*gd2*r*s - 56088*D1*Dd*f**2*gd2*r + 22944*D1*Dd*f**2*gd2*s**2 - 42240*D1*Dd*f**2*gd2*s + 19296*D1*Dd*f**2*gd2 + 73152*D1*Dd*f*fd*g2*r**2 + 125184*D1*Dd*f*fd*g2*r*s - 86160*D1*Dd*f*fd*g2*r + 45888*D1*Dd*f*fd*g2*s**2 - 69888*D1*Dd*f*fd*g2*s + 24792*D1*Dd*f*fd*g2 - 1040*D1*Ddd*f**4*r*s + 520*D1*Ddd*f**4*r - 1620*D1*Ddd*f**4*s**2 + 1880*D1*Ddd*f**4*s - 810*D1*Ddd*f**4 + 18288*D1*Ddd*f**2*g2*r**2 + 31296*D1*Ddd*f**2*g2*r*s - 24792*D1*Ddd*f**2*g2*r + 11472*D1*Ddd*f**2*g2*s**2 - 19296*D1*Ddd*f**2*g2*s + 10308*D1*Ddd*f**2*g2 - 3120*Dd**2*f**4*r*s + 1560*Dd**2*f**4*r - 4860*Dd**2*f**4*s**2 + 5640*Dd**2*f**4*s - 1330*Dd**2*f**4 + 54864*Dd**2*f**2*g2*r**2 + 93888*Dd**2*f**2*g2*r*s - 74376*Dd**2*f**2*g2*r + 34416*Dd**2*f**2*g2*s**2 - 57888*Dd**2*f**2*g2*s + 21384*Dd**2*f**2*g2 + 105*b1**3*(D1**2*(fd*(r + 5*s - 5) + fdd*(-3*r - 7*s + 7))*(r + s - 1) + D1*(Dd*(56*K*r**2 + 112*K*r*s - 84*K*r + 56*K*s**2 - 84*K*s + 42*K + f*(4*r**2 + 2*r*(12*s - 7) + 20*s**2 - 26*s + 11) - 2*fd*(12*r**2 + 40*r*s - 33*r + 28*s**2 - 47*s + 19) - 20*r**2 - 56*r*s + 38*r - 36*s**2 + 50*s - 23) - Ddd*(-14*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(12*r**2 + r*(40*s - 26) + 28*s**2 - 38*s + 17) + 20*r**2 + 56*r*s - 38*r + 36*s**2 - 50*s + 23)) - 2*Dd**2*(-42*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(18*r**2 + r*(60*s - 39) + 42*s**2 - 57*s + 17) + 30*r**2 + 84*r*s - 57*r + 54*s**2 - 75*s + 23)) + 3*b1**2*(308*D1**2*K*fd*r**2 + 868*D1**2*K*fd*r*s + 644*D1**2*K*fd*r + 728*D1**2*K*fd*s**2 + 308*D1**2*K*fd*s - 322*D1**2*K*fd - 504*D1**2*K*fdd*r**2 - 1204*D1**2*K*fdd*r*s - 812*D1**2*K*fdd*r - 644*D1**2*K*fdd*s**2 - 644*D1**2*K*fdd*s + 406*D1**2*K*fdd - 35*D1**2*bdd1*(-14*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(9*r**2 + 2*r*(15*s - 8) + 21*s**2 - 24*s + 10) + 15*r**2 + 42*r*s - 24*r + 27*s**2 - 32*s + 14) - 210*D1**2*f*fd*r**2 - 1176*D1**2*f*fd*r*s + 534*D1**2*f*fd*r - 966*D1**2*f*fd*s**2 + 960*D1**2*f*fd*s - 498*D1**2*f*fd + 210*D1**2*f*fdd*r**2 + 1176*D1**2*f*fdd*r*s - 498*D1**2*f*fdd*r + 966*D1**2*f*fdd*s**2 - 900*D1**2*f*fdd*s + 480*D1**2*f*fdd + 210*D1**2*fd**2*r**2 + 1176*D1**2*fd**2*r*s - 498*D1**2*fd**2*r + 966*D1**2*fd**2*s**2 - 900*D1**2*fd**2*s - 66*D1**2*fd**2 - 175*D1**2*fd*r**2 - 476*D1**2*fd*r*s - 182*D1**2*fd*r - 469*D1**2*fd*s**2 - 98*D1**2*fd*s + 91*D1**2*fd + 175*D1**2*fdd*r**2 + 728*D1**2*fdd*r*s + 266*D1**2*fdd*r + 497*D1**2*fdd*s**2 + 294*D1**2*fdd*s - 133*D1**2*fdd - 980*D1**2*gd2*r**2 - 1960*D1**2*gd2*r*s + 1960*D1**2*gd2*r - 980*D1**2*gd2*s**2 + 1960*D1**2*gd2*s - 980*D1**2*gd2 - 980*D1**2*gdd2*r**2 - 1960*D1**2*gdd2*r*s + 1960*D1**2*gdd2*r - 980*D1**2*gdd2*s**2 + 1960*D1**2*gdd2*s - 980*D1**2*gdd2 + 1232*D1*Dd*K*f*r**2 + 3472*D1*Dd*K*f*r*s - 2352*D1*Dd*K*f*r + 2912*D1*Dd*K*f*s**2 - 3780*D1*Dd*K*f*s + 1764*D1*Dd*K*f - 4032*D1*Dd*K*fd*r**2 - 9632*D1*Dd*K*fd*r*s + 168*D1*Dd*K*fd*r - 5152*D1*Dd*K*fd*s**2 + 1204*D1*Dd*K*fd*s + 2100*D1*Dd*K*fd - 420*D1*Dd*f**2*r**2 - 2352*D1*Dd*f**2*r*s + 1386*D1*Dd*f**2*r - 1932*D1*Dd*f**2*s**2 + 2520*D1*Dd*f**2*s - 1071*D1*Dd*f**2 + 1680*D1*Dd*f*fd*r**2 + 9408*D1*Dd*f*fd*r*s - 4764*D1*Dd*f*fd*r + 7728*D1*Dd*f*fd*s**2 - 8640*D1*Dd*f*fd*s + 2298*D1*Dd*f*fd - 700*D1*Dd*f*r**2 - 1904*D1*Dd*f*r*s + 1302*D1*Dd*f*r - 1876*D1*Dd*f*s**2 + 2352*D1*Dd*f*s - 1113*D1*Dd*f + 1400*D1*Dd*fd*r**2 + 5824*D1*Dd*fd*r*s - 742*D1*Dd*fd*r + 3976*D1*Dd*fd*s**2 - 1540*D1*Dd*fd*s - 854*D1*Dd*fd - 3920*D1*Dd*g2*r**2 - 7840*D1*Dd*g2*r*s + 5880*D1*Dd*g2*r - 3920*D1*Dd*g2*s**2 + 5880*D1*Dd*g2*s - 2940*D1*Dd*g2 - 7840*D1*Dd*gd2*r**2 - 15680*D1*Dd*gd2*r*s + 13720*D1*Dd*gd2*r - 7840*D1*Dd*gd2*s**2 + 13720*D1*Dd*gd2*s - 5880*D1*Dd*gd2 - 2016*D1*Ddd*K*f*r**2 - 4816*D1*Ddd*K*f*r*s + 3416*D1*Ddd*K*f*r - 2576*D1*Ddd*K*f*s**2 + 3780*D1*Ddd*K*f*s - 1792*D1*Ddd*K*f + 420*D1*Ddd*f**2*r**2 + 2352*D1*Ddd*f**2*r*s - 1386*D1*Ddd*f**2*r + 1932*D1*Ddd*f**2*s**2 - 2520*D1*Ddd*f**2*s + 1071*D1*Ddd*f**2 + 700*D1*Ddd*f*r**2 + 2912*D1*Ddd*f*r*s - 1806*D1*Ddd*f*r + 1988*D1*Ddd*f*s**2 - 2716*D1*Ddd*f*s + 1169*D1*Ddd*f - 3920*D1*Ddd*g2*r**2 - 7840*D1*Ddd*g2*r*s + 5880*D1*Ddd*g2*r - 3920*D1*Ddd*g2*s**2 + 5880*D1*Ddd*g2*s - 2940*D1*Ddd*g2 + 35*D1*bd1*(D1*(42*K*r**2 + 84*K*r*s - 56*K*r + 42*K*s**2 - 56*K*s + 28*K + f*(3*r**2 + 2*r*(9*s - 4) + 15*s**2 - 16*s + 6) - 2*fd*(9*r**2 + 30*r*s - 23*r + 21*s**2 - 33*s + 12) - 15*r**2 - 42*r*s + 24*r - 27*s**2 + 32*s - 14) - 2*Dd*(-14*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(36*r**2 + r*(120*s - 71) + 84*s**2 - 105*s + 32) + 60*r**2 + 168*r*s - 105*r + 108*s**2 - 139*s + 44)) - 6048*Dd**2*K*f*r**2 - 14448*Dd**2*K*f*r*s + 10248*Dd**2*K*f*r - 7728*Dd**2*K*f*s**2 + 11340*Dd**2*K*f*s - 3696*Dd**2*K*f + 1260*Dd**2*f**2*r**2 + 7056*Dd**2*f**2*r*s - 4158*Dd**2*f**2*r + 5796*Dd**2*f**2*s**2 - 7560*Dd**2*f**2*s + 2142*Dd**2*f**2 + 2100*Dd**2*f*r**2 + 8736*Dd**2*f*r*s - 5418*Dd**2*f*r + 5964*Dd**2*f*s**2 - 8148*Dd**2*f*s + 2450*Dd**2*f - 11760*Dd**2*g2*r**2 - 23520*Dd**2*g2*r*s + 17640*Dd**2*g2*r - 11760*Dd**2*g2*s**2 + 17640*Dd**2*g2*s - 5880*Dd**2*g2) - b1*(3024*D1**2*K*bdd1*f*r**2 + 7224*D1**2*K*bdd1*f*r*s - 9072*D1**2*K*bdd1*f*r + 3864*D1**2*K*bdd1*f*s**2 - 9408*D1**2*K*bdd1*f*s + 4662*D1**2*K*bdd1*f - 4860*D1**2*K*f*fd*r**2 - 6240*D1**2*K*f*fd*r*s + 4860*D1**2*K*f*fd*r - 2292*D1**2*K*f*fd*s**2 + 3120*D1**2*K*f*fd*s - 2430*D1**2*K*f*fd + 4572*D1**2*K*f*fdd*r**2 + 7824*D1**2*K*f*fdd*r*s - 4572*D1**2*K*f*fdd*r + 2868*D1**2*K*f*fdd*s**2 - 3912*D1**2*K*f*fdd*s + 2286*D1**2*K*f*fdd + 4572*D1**2*K*fd**2*r**2 + 7824*D1**2*K*fd**2*r*s - 4572*D1**2*K*fd**2*r + 2868*D1**2*K*fd**2*s**2 - 3912*D1**2*K*fd**2*s - 630*D1**2*b2*fd*r**2 - 1260*D1**2*b2*fd*r*s - 630*D1**2*b2*fd*s**2 + 1050*D1**2*b2*fdd*r**2 + 2100*D1**2*b2*fdd*r*s + 1050*D1**2*b2*fdd*s**2 + 210*D1**2*bd1**2*(-14*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(9*r**2 + 2*r*(15*s - 8) + 21*s**2 - 24*s + 5) + 15*r**2 + 42*r*s - 24*r + 27*s**2 - 32*s + 7) - 630*D1**2*bdd1*f**2*r**2 - 3528*D1**2*bdd1*f**2*r*s + 2664*D1**2*bdd1*f**2*r - 2898*D1**2*bdd1*f**2*s**2 + 4860*D1**2*bdd1*f**2*s - 1773*D1**2*bdd1*f**2 - 1050*D1**2*bdd1*f*r**2 - 4368*D1**2*bdd1*f*r*s + 4032*D1**2*bdd1*f*r - 2982*D1**2*bdd1*f*s**2 + 6048*D1**2*bdd1*f*s - 2415*D1**2*bdd1*f + 5880*D1**2*bdd1*g2*r**2 + 11760*D1**2*bdd1*g2*r*s - 5880*D1**2*bdd1*g2*r + 5880*D1**2*bdd1*g2*s**2 - 5880*D1**2*bdd1*g2*s + 2940*D1**2*bdd1*g2 + 1050*D1**2*bdd2*f*r**2 + 2100*D1**2*bdd2*f*r*s - 2100*D1**2*bdd2*f*r + 1050*D1**2*bdd2*f*s**2 - 2100*D1**2*bdd2*f*s + 1050*D1**2*bdd2*f + 1590*D1**2*f**2*fd*r**2 + 4314*D1**2*f**2*fd*r*s - 2354*D1**2*f**2*fd*r + 1755*D1**2*f**2*fd*s**2 - 2158*D1**2*f**2*fd*s + 728*D1**2*f**2*fd - 1470*D1**2*f**2*fdd*r**2 - 4614*D1**2*f**2*fdd*r*s + 2374*D1**2*f**2*fdd*r - 2025*D1**2*f**2*fdd*s**2 + 2438*D1**2*f**2*fdd*s - 778*D1**2*f**2*fdd - 2940*D1**2*f*fd**2*r**2 - 9228*D1**2*f*fd**2*r*s + 4748*D1**2*f*fd**2*r - 4050*D1**2*f*fd**2*s**2 + 4876*D1**2*f*fd**2*s - 1268*D1**2*f*fd**2 + 1548*D1**2*f*fd*r**2 + 2988*D1**2*f*fd*r*s - 1548*D1**2*f*fd*r + 1776*D1**2*f*fd*s**2 - 1494*D1**2*f*fd*s + 774*D1**2*f*fd - 1404*D1**2*f*fdd*r**2 - 4140*D1**2*f*fdd*r*s + 1404*D1**2*f*fdd*r - 2316*D1**2*f*fdd*s**2 + 2070*D1**2*f*fdd*s - 702*D1**2*f*fdd + 1848*D1**2*f*gd2*r**2 + 5208*D1**2*f*gd2*r*s - 5208*D1**2*f*gd2*r + 4368*D1**2*f*gd2*s**2 - 8736*D1**2*f*gd2*s + 4368*D1**2*f*gd2 - 3024*D1**2*f*gdd2*r**2 - 7224*D1**2*f*gdd2*r*s + 7224*D1**2*f*gdd2*r - 3864*D1**2*f*gdd2*s**2 + 7728*D1**2*f*gdd2*s - 3864*D1**2*f*gdd2 - 1404*D1**2*fd**2*r**2 - 4140*D1**2*fd**2*r*s + 1404*D1**2*fd**2*r - 2316*D1**2*fd**2*s**2 + 2070*D1**2*fd**2*s + 1848*D1**2*fd*g2*r**2 + 5208*D1**2*fd*g2*r*s + 3864*D1**2*fd*g2*r + 4368*D1**2*fd*g2*s**2 + 1848*D1**2*fd*g2*s - 1932*D1**2*fd*g2 - 6048*D1**2*fd*gd2*r**2 - 14448*D1**2*fd*gd2*r*s + 2352*D1**2*fd*gd2*r - 7728*D1**2*fd*gd2*s**2 + 3864*D1**2*fd*gd2*s + 3864*D1**2*fd*gd2 - 3024*D1**2*fdd*g2*r**2 - 7224*D1**2*fdd*g2*r*s - 4872*D1**2*fdd*g2*r - 3864*D1**2*fdd*g2*s**2 - 3864*D1**2*fdd*g2*s + 2436*D1**2*fdd*g2 - 9720*D1*Dd*K*f**2*r**2 - 12480*D1*Dd*K*f**2*r*s + 11100*D1*Dd*K*f**2*r - 4584*D1*Dd*K*f**2*s**2 + 7704*D1*Dd*K*f**2*s - 4722*D1*Dd*K*f**2 + 36576*D1*Dd*K*f*fd*r**2 + 62592*D1*Dd*K*f*fd*r*s - 43080*D1*Dd*K*f*fd*r + 22944*D1*Dd*K*f*fd*s**2 - 34944*D1*Dd*K*f*fd*s + 12396*D1*Dd*K*f*fd - 2520*D1*Dd*b2*f*r**2 - 5040*D1*Dd*b2*f*r*s + 3780*D1*Dd*b2*f*r - 2520*D1*Dd*b2*f*s**2 + 3780*D1*Dd*b2*f*s - 1890*D1*Dd*b2*f + 8400*D1*Dd*b2*fd*r**2 + 16800*D1*Dd*b2*fd*r*s - 6300*D1*Dd*b2*fd*r + 8400*D1*Dd*b2*fd*s**2 - 6300*D1*Dd*b2*fd*s + 2120*D1*Dd*f**3*r**2 + 5752*D1*Dd*f**3*r*s - 3936*D1*Dd*f**3*r + 2340*D1*Dd*f**3*s**2 - 3778*D1*Dd*f**3*s + 1700*D1*Dd*f**3 - 11760*D1*Dd*f**2*fd*r**2 - 36912*D1*Dd*f**2*fd*r*s + 21664*D1*Dd*f**2*fd*r - 16200*D1*Dd*f**2*fd*s**2 + 22466*D1*Dd*f**2*fd*s - 7250*D1*Dd*f**2*fd + 3096*D1*Dd*f**2*r**2 + 5976*D1*Dd*f**2*r*s - 4536*D1*Dd*f**2*r + 3552*D1*Dd*f**2*s**2 - 5046*D1*Dd*f**2*s + 2550*D1*Dd*f**2 - 11232*D1*Dd*f*fd*r**2 - 33120*D1*Dd*f*fd*r*s + 16704*D1*Dd*f*fd*r - 18528*D1*Dd*f*fd*s**2 + 21684*D1*Dd*f*fd*s - 5544*D1*Dd*f*fd + 7392*D1*Dd*f*g2*r**2 + 20832*D1*Dd*f*g2*r*s - 14112*D1*Dd*f*g2*r + 17472*D1*Dd*f*g2*s**2 - 22680*D1*Dd*f*g2*s + 10584*D1*Dd*f*g2 - 24192*D1*Dd*f*gd2*r**2 - 57792*D1*Dd*f*gd2*r*s + 49392*D1*Dd*f*gd2*r - 30912*D1*Dd*f*gd2*s**2 + 53592*D1*Dd*f*gd2*s - 22680*D1*Dd*f*gd2 - 24192*D1*Dd*fd*g2*r**2 - 57792*D1*Dd*fd*g2*r*s + 1008*D1*Dd*fd*g2*r - 30912*D1*Dd*fd*g2*s**2 + 7224*D1*Dd*fd*g2*s + 12600*D1*Dd*fd*g2 + 9144*D1*Ddd*K*f**2*r**2 + 15648*D1*Ddd*K*f**2*r*s - 12396*D1*Ddd*K*f**2*r + 5736*D1*Ddd*K*f**2*s**2 - 9648*D1*Ddd*K*f**2*s + 5154*D1*Ddd*K*f**2 + 4200*D1*Ddd*b2*f*r**2 + 8400*D1*Ddd*b2*f*r*s - 6300*D1*Ddd*b2*f*r + 4200*D1*Ddd*b2*f*s**2 - 6300*D1*Ddd*b2*f*s + 3150*D1*Ddd*b2*f - 1960*D1*Ddd*f**3*r**2 - 6152*D1*Ddd*f**3*r*s + 4056*D1*Ddd*f**3*r - 2700*D1*Ddd*f**3*s**2 + 4238*D1*Ddd*f**3*s - 1840*D1*Ddd*f**3 - 2808*D1*Ddd*f**2*r**2 - 8280*D1*Ddd*f**2*r*s + 5544*D1*Ddd*f**2*r - 4632*D1*Ddd*f**2*s**2 + 6702*D1*Ddd*f**2*s - 3018*D1*Ddd*f**2 - 12096*D1*Ddd*f*g2*r**2 - 28896*D1*Ddd*f*g2*r*s + 20496*D1*Ddd*f*g2*r - 15456*D1*Ddd*f*g2*s**2 + 22680*D1*Ddd*f*g2*s - 10752*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(3*f**2*(70*r**2 + 4*r*(98*s - 71) + 322*s**2 - 520*s + 191) - 7*f*(2*K*(44*r**2 + 4*r*(31*s - 38) + 104*s**2 - 188*s + 97) + 6*fd*(20*r**2 + 2*r*(56*s - 33) + 92*s**2 - 120*s + 35) - 50*r**2 - 136*r*s + 144*r - 134*s**2 + 216*s - 105) + 14*fd*(2*K*(72*r**2 + 172*r*s - 50*r + 92*s**2 - 66*s - 23) - 50*r**2 - 208*r*s + 58*r - 142*s**2 + 102*s + 21) + 980*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 1960*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 4*Dd*(3*f**2*(140*r**2 + r*(784*s - 527) + 644*s**2 - 960*s + 344) - 7*f*(K*(288*r**2 + 688*r*s - 676*r + 368*s**2 - 718*s + 332) - 100*r**2 - 416*r*s + 321*r - 284*s**2 + 482*s - 192) - 490*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 210*D1*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 27432*Dd**2*K*f**2*r**2 + 46944*Dd**2*K*f**2*r*s - 37188*Dd**2*K*f**2*r + 17208*Dd**2*K*f**2*s**2 - 28944*Dd**2*K*f**2*s + 10692*Dd**2*K*f**2 + 12600*Dd**2*b2*f*r**2 + 25200*Dd**2*b2*f*r*s - 18900*Dd**2*b2*f*r + 12600*Dd**2*b2*f*s**2 - 18900*Dd**2*b2*f*s + 6300*Dd**2*b2*f - 5880*Dd**2*f**3*r**2 - 18456*Dd**2*f**3*r*s + 12168*Dd**2*f**3*r - 8100*Dd**2*f**3*s**2 + 12714*Dd**2*f**3*s - 4426*Dd**2*f**3 - 8424*Dd**2*f**2*r**2 - 24840*Dd**2*f**2*r*s + 16632*Dd**2*f**2*r - 13896*Dd**2*f**2*s**2 + 20106*Dd**2*f**2*s - 6456*Dd**2*f**2 - 36288*Dd**2*f*g2*r**2 - 86688*Dd**2*f*g2*r*s + 61488*Dd**2*f*g2*r - 46368*Dd**2*f*g2*s**2 + 68040*Dd**2*f*g2*s - 22176*Dd**2*f*g2) + 6*b2*(-175*D1**2*bdd1*f*(r + s - 1)**2 + 3*D1**2*(f*(3*fd*(30*r**2 + 44*r*s - 30*r + 14*s**2 - 22*s + 15) - fdd*(94*r**2 + 164*r*s - 94*r + 70*s**2 - 82*s + 47)) - 2*fd**2*(47*r**2 + r*(82*s - 47) + s*(35*s - 41))) + 35*D1*bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 3*D1*f*(Dd*(3*f*(60*r**2 + 88*r*s - 74*r + 28*s**2 - 50*s + 29) - 2*fd*(376*r**2 + 656*r*s - 446*r + 280*s**2 - 386*s + 129)) - Ddd*f*(188*r**2 + r*(328*s - 258) + 140*s**2 - 222*s + 117)) - 18*Dd**2*f**2*(94*r**2 + r*(164*s - 129) + 70*s**2 - 111*s + 39)))/(315*d**2*k3**4) - 4*D1**2*Pk1*Pk3*ct*k1*st**4*(21*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) - 6*b1*(D1**2*(f*(fd*(16*C - 8)*(2*s**2 - 2*s + 1) - fdd*(8*C - 4)*(2*s**2 - 2*s + 1) + s**2*(4*C - 3)*(-14*bd1 + 7*bdd1)) + 2*fd*s*(s - 1)*(7*bd1*(4*C - 3) + fd*(4 - 8*C))) + 4*D1*f*(Dd*f*(8*C - 4)*(2*s**2 - 2*s + 1) - Dd*(2*s - 1)*(7*bd1*s*(3 - 4*C) + fd*(8*C - 4)*(2*s - 1)) - Ddd*f*(4*C - 2)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(8 - 16*C)*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(-fd*(40*C - 22)*(3*s**2 - 2*s + 1) + fdd*(20*C - 11)*(3*s**2 - 2*s + 1) + s**2*(2*C - 1)*(-48*bd1 + 24*bdd1)) + 2*s*(21*bd1**2*s*(3 - 4*C) + 24*bd1*fd*(2*C - 1)*(2*s - 1) + fd**2*(20*C - 11)*(3*s - 2))) - 2*D1*f*(Dd*f*(40*C - 22)*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(24*bd1*s*(2*C - 1) + fd*(20*C - 11)*(3*s - 1)) - Ddd*f*(20*C - 11)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(40*C - 22)*(6*s**2 - 6*s + 1)))/(105*d**2*k2*k3**2) + D1**2*Pk1*Pk3*ct*k1*st**2*(7*b1**2*(D1**2*(s - 1)*(fd*(8*C*r + 148*C*(s - 1) - 4*r - 111*s + 111) + fdd*(-4*C*(6*r + 31*s - 31) + 12*r + 93*s - 93)) + 2*D1*(-4*C*Ddd*f*(6*r*(2*s - 1) + 62*s**2 - 65*s + 31) + Dd*f*(4*C*(r*(4*s - 2) + 74*s**2 - 75*s + 37) + r*(4 - 8*s) - 222*s**2 + 224*s - 111) - 4*Dd*fd*(C*(6*r*(4*s - 3) + 124*s**2 - 189*s + 65) - 3*r*(4*s - 3) - 93*s**2 + 141*s - 48) + 3*Ddd*f*(r*(8*s - 4) + 62*s**2 - 64*s + 31)) - 2*Dd**2*f*(4*C*(18*r*(2*s - 1) + 186*s**2 - 195*s + 37) + r*(36 - 72*s) - 558*s**2 + 576*s - 105)) + 2*b1*(D1**2*(f*(7*bdd1*s*(-4*C*(6*r + 31*s - 3) + 12*r + 93*s - 6) - fd*(4*C - 2)*(118*s**2 - 97*s + 59) + fdd*(4*C - 2)*(94*s**2 - 73*s + 47)) + fd**2*(4*C - 2)*(94*s**2 - 73*s - 21)) + 7*D1*bd1*(-8*C*Dd*f*(6*r*(4*s - 1) + 124*s**2 - 71*s + 3) + D1*f*s*(4*C*(2*r + 37*s - 1) - 4*r - 111*s + 2) - 2*D1*fd*(2*C*(6*r*(2*s - 1) + 62*s**2 - 65*s + 3) + r*(6 - 12*s) - 93*s**2 + 96*s - 3) + 12*Dd*f*(r*(8*s - 2) + 62*s**2 - 34*s + 1)) - D1*f*(8*C - 4)*(59*Dd*f*(2*s**2 - 2*s + 1) + Dd*fd*(-376*s**2 + 334*s - 73) - 47*Ddd*f*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(376*C - 188)*(6*s**2 - 6*s + 1)) + f*(-14*D1**2*bd1**2*s*(4*C*(6*r + 31*s - 3) - 12*r - 93*s + 6) + D1**2*(f*(4*bdd1*s*(2*C - 1)*(47*s - 21) + fd*(-4*C*(22*r*(3*s - 1) + 243*s**2 - 184*s + 81) + 44*r*(3*s - 1) + 591*s**2 - 438*s + 197) + fdd*(4*C*(26*r*(3*s - 1) + 189*s**2 - 152*s + 63) - 52*r*(3*s - 1) - 453*s**2 + 354*s - 151)) + 2*fd**2*(4*C*(26*r*(3*s - 1) + 189*s**2 - 152*s + 13) - 52*r*(3*s - 1) - 453*s**2 + 354*s - 26)) + 4*D1*bd1*(2*C - 1)*(D1*f*s*(21 - 59*s) + D1*fd*(188*s**2 - 115*s + 21) + 2*Dd*f*(188*s**2 - 136*s + 21)) - 2*D1*f*(Dd*(f*(4*C*(44*r*s - 22*r + 162*s**2 - 173*s + 81) - 88*r*s + 44*r - 394*s**2 + 416*s - 197) - 4*fd*(C*(26*r*(12*s - 5) + 756*s**2 - 721*s + 165) - 156*r*s + 65*r - 453*s**2 + 423*s - 95)) + Ddd*f*(-4*C*(26*r*(2*s - 1) + 126*s**2 - 139*s + 63) + 52*r*(2*s - 1) + 302*s**2 - 328*s + 151)) + 2*Dd**2*f**2*(4*C*(78*r*(2*s - 1) + 378*s**2 - 417*s + 89) - 156*r*(2*s - 1) - 906*s**2 + 984*s - 203)))/(105*d**2*k2*k3**2) + D1**2*Pk1*Pk3*ct*k1*(-35*b1**2*(D1**2*(fd - fdd)*(s - 1)*(4*C*(2*r + 5*s - 5) - 4*r - 15*s + 15) + 2*D1*(Dd*(f*(4*C*(4*r*s - 2*r + 10*s**2 - 11*s + 5) - 8*r*s + 4*r - 30*s**2 + 32*s - 15) - 4*fd*(C*(8*r*s - 6*r + 20*s**2 - 31*s + 11) - 4*r*s + 3*r - 15*s**2 + 23*s - 8)) + Ddd*f*(-4*C*(4*r*s - 2*r + 10*s**2 - 11*s + 5) + 8*r*s - 4*r + 30*s**2 - 32*s + 15)) + 2*Dd**2*f*(-4*C*(6*r*(2*s - 1) + 30*s**2 - 33*s + 7) + 12*r*(2*s - 1) + 90*s**2 - 96*s + 19)) - 14*b1*(D1**2*(f*(-5*bdd1*s*(4*C*(2*r + 5*s - 1) - 4*r - 15*s + 2) + fd*(2 - 4*C)*(4*s**2 + s + 2) + fdd*(4*C - 2)*(4*s**2 + s + 2)) + fd**2*(4*C - 2)*(4*s**2 + s - 5)) + 5*D1*bd1*(D1*(f*s*(4*C*(2*r + 5*s - 1) - 4*r - 15*s + 2) + fd*(-4*C*(4*r*s - 2*r + 10*s**2 - 11*s + 1) + 8*r*s - 4*r + 30*s**2 - 32*s + 2)) - 4*Dd*f*(2*C*(8*r*s - 2*r + 20*s**2 - 13*s + 1) - 8*r*s + 2*r - 30*s**2 + 18*s - 1)) - D1*f*(8*C - 4)*(Dd*(f*(4*s**2 - 4*s + 2) - 16*fd*s**2 + 6*fd*s + fd) - 2*Ddd*f*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(16*C - 8)*(6*s**2 - 6*s + 1)) + f*(70*D1**2*bd1**2*s*(4*C*(2*r + 5*s - 1) - 4*r - 15*s + 2) + D1**2*(f*(-28*bdd1*s*(2*C - 1)*(2*s - 5) + 3*fd*(12*C*(18*r*s - 6*r + 21*s**2 - 20*s + 7) - 108*r*s + 36*r - 177*s**2 + 154*s - 59) - 3*fdd*(12*C*(18*r*s - 6*r + 21*s**2 - 20*s + 7) - 108*r*s + 36*r - 177*s**2 + 154*s - 59)) - 6*fd**2*(12*C*(6*r*(3*s - 1) + 21*s**2 - 20*s + 3) - 36*r*(3*s - 1) - 177*s**2 + 154*s - 18)) - 28*D1*bd1*(2*C - 1)*(D1*f*s*(5 - 2*s) + D1*fd*(8*s**2 - 9*s + 5) + 2*Dd*f*(8*s**2 - 14*s + 5)) + 6*D1*f*(Dd*(f*(12*C*(12*r*s - 6*r + 14*s**2 - 17*s + 7) - 72*r*s + 36*r - 118*s**2 + 136*s - 59) - 4*fd*(3*C*(72*r*s - 30*r + 84*s**2 - 91*s + 23) - 108*r*s + 45*r - 177*s**2 + 179*s - 43)) + Ddd*f*(-12*C*(12*r*s - 6*r + 14*s**2 - 17*s + 7) + 72*r*s - 36*r + 118*s**2 - 136*s + 59)) - 6*Dd**2*f**2*(12*C*(18*r*(2*s - 1) + 42*s**2 - 51*s + 13) - 108*r*(2*s - 1) - 354*s**2 + 408*s - 95)))/(105*d**2*k2*k3**2) + 4*D1**2*Pk1*Pk3*ct*k2**5*st**6*(144*C*D1**2*b1*f*fd*r**2 + 144*C*D1**2*b1*f*fd*r*s - 72*C*D1**2*b1*f*fd*r - 72*C*D1**2*b1*f*fdd*r**2 - 72*C*D1**2*b1*f*fdd*r*s + 36*C*D1**2*b1*f*fdd*r - 72*C*D1**2*b1*fd**2*r**2 - 72*C*D1**2*b1*fd**2*r*s + 36*C*D1**2*b1*fd**2*r + 24*C*D1**2*f**2*fd*r**2 + 24*C*D1**2*f**2*fd*r*s - 24*C*D1**2*f**2*fd*r - 8*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r**2 - 12*C*D1**2*f**2*fdd*r*s + 12*C*D1**2*f**2*fdd*r + 4*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r**2 - 24*C*D1**2*f*fd**2*r*s + 24*C*D1**2*f*fd**2*r + 8*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 288*C*D1*Dd*b1*f**2*r**2 + 288*C*D1*Dd*b1*f**2*r*s - 288*C*D1*Dd*b1*f**2*r - 72*C*D1*Dd*b1*f**2*s + 72*C*D1*Dd*b1*f**2 - 576*C*D1*Dd*b1*f*fd*r**2 - 576*C*D1*Dd*b1*f*fd*r*s + 432*C*D1*Dd*b1*f*fd*r + 72*C*D1*Dd*b1*f*fd*s - 36*C*D1*Dd*b1*f*fd + 32*C*D1*Dd*f**3*r**2 + 32*C*D1*Dd*f**3*r*s - 32*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r**2 - 96*C*D1*Dd*f**2*fd*r*s + 96*C*D1*Dd*f**2*fd*r + 28*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 144*C*D1*Ddd*b1*f**2*r**2 - 144*C*D1*Ddd*b1*f**2*r*s + 144*C*D1*Ddd*b1*f**2*r + 36*C*D1*Ddd*b1*f**2*s - 36*C*D1*Ddd*b1*f**2 - 16*C*D1*Ddd*f**3*r**2 - 16*C*D1*Ddd*f**3*r*s + 16*C*D1*Ddd*f**3*r + 4*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 432*C*Dd**2*b1*f**2*r**2 - 432*C*Dd**2*b1*f**2*r*s + 432*C*Dd**2*b1*f**2*r + 108*C*Dd**2*b1*f**2*s - 72*C*Dd**2*b1*f**2 - 48*C*Dd**2*f**3*r**2 - 48*C*Dd**2*f**3*r*s + 48*C*Dd**2*f**3*r + 12*C*Dd**2*f**3*s - 8*C*Dd**2*f**3 - 180*D1**2*b1*f*fd*r**2 - 216*D1**2*b1*f*fd*r*s + 108*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 90*D1**2*b1*f*fdd*r**2 + 108*D1**2*b1*f*fdd*r*s - 54*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 90*D1**2*b1*fd**2*r**2 + 108*D1**2*b1*fd**2*r*s - 54*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)*(4*C*(r - 1) - 5*r - s + 5) - 30*D1**2*f**2*fd*r**2 - 36*D1**2*f**2*fd*r*s + 32*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 16*D1**2*f**2*fd*s - 12*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 18*D1**2*f**2*fdd*r*s - 16*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 8*D1**2*f**2*fdd*s + 6*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 36*D1**2*f*fd**2*r*s - 32*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 16*D1**2*f*fd**2*s + 6*D1**2*f*fd**2 - 360*D1*Dd*b1*f**2*r**2 - 432*D1*Dd*b1*f**2*r*s + 396*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 180*D1*Dd*b1*f**2*s - 126*D1*Dd*b1*f**2 + 720*D1*Dd*b1*f*fd*r**2 + 864*D1*Dd*b1*f*fd*r*s - 612*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 252*D1*Dd*b1*f*fd*s + 90*D1*Dd*b1*f*fd - 40*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 14*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 144*D1*Dd*f**2*fd*r*s - 130*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 62*D1*Dd*f**2*fd*s + 32*D1*Dd*f**2*fd + 180*D1*Ddd*b1*f**2*r**2 + 216*D1*Ddd*b1*f**2*r*s - 198*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 90*D1*Ddd*b1*f**2*s + 63*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 24*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 10*D1*Ddd*f**3*s + 7*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1)*(4*C*(r - 1) - 5*r - s + 5) + fd*(-2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 10*r**2 + 12*r*s - 13*r + 2*s**2 - 7*s + 3)) + Dd*f*(-2*C*(8*r**2 + 8*r*s - 12*r - 5*s + 4) + 20*r**2 + 24*r*s - 31*r + 4*s**2 - 17*s + 11)) + 540*Dd**2*b1*f**2*r**2 + 648*Dd**2*b1*f**2*r*s - 594*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 270*Dd**2*b1*f**2*s + 126*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 72*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 30*Dd**2*f**3*s + 14*Dd**2*f**3)/(63*d**2*k1*k3**6) - 2*D1**2*Pk1*Pk3*ct*k2**5*st**4*(792*C*D1**2*f**2*fd*r**2 + 792*C*D1**2*f**2*fd*r*s - 792*C*D1**2*f**2*fd*r - 264*C*D1**2*f**2*fd*s + 264*C*D1**2*f**2*fd + 1056*C*D1*Dd*f**3*r**2 + 1056*C*D1*Dd*f**3*r*s - 1056*C*D1*Dd*f**3*r - 264*C*D1*Dd*f**3*s + 264*C*D1*Dd*f**3 + 132*D1**2*K*bdd1*f**2*r**2 + 132*D1**2*K*bdd1*f**2*r*s - 132*D1**2*K*bdd1*f**2*r - 132*D1**2*bd1**2*f*(r + s - 1)*(-14*K*r + 7*K + 5*f*(2*r + 2*s - 1) + 21*r + 7*s - 14) + 935*D1**2*bdd1*f**3*r**2 + 2530*D1**2*bdd1*f**3*r*s - 2530*D1**2*bdd1*f**3*r + 1595*D1**2*bdd1*f**3*s**2 - 3190*D1**2*bdd1*f**3*s + 1485*D1**2*bdd1*f**3 - 198*D1**2*bdd1*f**2*r**2 - 264*D1**2*bdd1*f**2*r*s + 264*D1**2*bdd1*f**2*r - 66*D1**2*bdd1*f**2*s**2 + 132*D1**2*bdd1*f**2*s - 66*D1**2*bdd1*f**2 - 1848*D1**2*bdd1*f*g2*r**2 - 1848*D1**2*bdd1*f*g2*r*s + 3696*D1**2*bdd1*f*g2*r + 1848*D1**2*bdd1*f*g2*s - 1848*D1**2*bdd1*f*g2 - 2796*D1**2*f**3*fd*r**2 - 4776*D1**2*f**3*fd*r*s + 3786*D1**2*f**3*fd*r - 1980*D1**2*f**3*fd*s**2 + 3174*D1**2*f**3*fd*s - 1689*D1**2*f**3*fd + 3620*D1**2*f**3*fdd*r**2 + 6040*D1**2*f**3*fdd*r*s - 4830*D1**2*f**3*fdd*r + 2420*D1**2*f**3*fdd*s**2 - 3930*D1**2*f**3*fdd*s + 2115*D1**2*f**3*fdd + 10860*D1**2*f**2*fd**2*r**2 + 18120*D1**2*f**2*fd**2*r*s - 14490*D1**2*f**2*fd**2*r + 7260*D1**2*f**2*fd**2*s**2 - 11790*D1**2*f**2*fd**2*s + 4230*D1**2*f**2*fd**2 - 990*D1**2*f**2*fd*r**2 - 1188*D1**2*f**2*fd*r*s + 1056*D1**2*f**2*fd*r - 198*D1**2*f**2*fd*s**2 + 528*D1**2*f**2*fd*s - 396*D1**2*f**2*fd + 528*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r - 264*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r + 1056*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 1056*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s + 528*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 1056*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 528*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s - 264*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 528*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s - 2796*D1*Dd*f**4*r**2 - 4776*D1*Dd*f**4*r*s + 3786*D1*Dd*f**4*r - 1980*D1*Dd*f**4*s**2 + 3174*D1*Dd*f**4*s - 1689*D1*Dd*f**4 + 28960*D1*Dd*f**3*fd*r**2 + 48320*D1*Dd*f**3*fd*r*s - 38640*D1*Dd*f**3*fd*r + 19360*D1*Dd*f**3*fd*s**2 - 31440*D1*Dd*f**3*fd*s + 12690*D1*Dd*f**3*fd - 1320*D1*Dd*f**3*r**2 - 1584*D1*Dd*f**3*r*s + 1452*D1*Dd*f**3*r - 264*D1*Dd*f**3*s**2 + 660*D1*Dd*f**3*s - 462*D1*Dd*f**3 + 2112*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 2112*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s + 528*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 2112*D1*Dd*f**2*gd2*r + 264*D1*Dd*f**2*gd2*s - 264*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 4224*D1*Dd*f*fd*g2*r + 1584*D1*Dd*f*fd*g2*s - 1056*D1*Dd*f*fd*g2 + 3620*D1*Ddd*f**4*r**2 + 6040*D1*Ddd*f**4*r*s - 4830*D1*Ddd*f**4*r + 2420*D1*Ddd*f**4*s**2 - 3930*D1*Ddd*f**4*s + 2115*D1*Ddd*f**4 - 1056*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 1056*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s - 264*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(f**3*(59*r**2 + 2*r*(77*s - 95) + 95*s**2 - 226*s + 111) - 2*f**2*(84*C*(r - 1)*(r + s - 1) + 5*fd*(51*r**2 + 138*r*s - 109*r + 87*s**2 - 139*s + 54) - (3*r + 3*s - 3)*(4*K*r + 29*r + 5*s - 33)) - 12*f*(fd*(K*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*r**2 + r*(7 - 8*s) - 2*(s - 1)**2) + (r + s - 1)*(28*g2*(r - 1) - 28*gd2*r + 14*gd2)) + 168*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 2*Dd*f*(5*f**2*(68*r**2 + r*(184*s - 155) + 116*s**2 - 197*s + 81) + 6*f*(K*(8*r**2 + 8*r*(s - 1) - s + 1) - 12*r**2 + r*(15 - 16*s) - 4*(s - 1)**2) - 84*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 10860*Dd**2*f**4*r**2 + 18120*Dd**2*f**4*r*s - 14490*Dd**2*f**4*r + 7260*Dd**2*f**4*s**2 - 11790*Dd**2*f**4*s + 4230*Dd**2*f**4 - 3168*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 3168*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s - 528*Dd**2*f**2*g2 + 66*b1**2*(D1**2*(5*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd**2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 14*fd*(r + s)*(2*K*r - 3*r - s) + 7*fdd*(r + s)*(2*K*r - 3*r - s)) + D1*(2*Dd*(10*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-7*K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 5*fd*(4*r + 4*s - 3)**2 + 84*r**2 + 112*r*s - 98*r + 28*s**2 - 56*s + 35) + 7*fd*(r**2*(8*K - 12) + r*(8*K*s - 4*K - 16*s + 7) - s*(K + 4*s - 4))) - Ddd*f*(-7*K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 10*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 84*r**2 + 112*r*s - 98*r + 28*s**2 - 56*s + 35)) - 2*Dd**2*f*(-7*K*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 30*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 126*r**2 + 168*r*s - 147*r + 42*s**2 - 84*s + 35)) + 11*b1*(336*C*D1**2*f*fd*r**2 + 336*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r + 672*C*D1*Dd*f**2*r**2 + 672*C*D1*Dd*f**2*r*s - 672*C*D1*Dd*f**2*r - 168*C*D1*Dd*f**2*s + 168*C*D1*Dd*f**2 - 48*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 48*D1**2*K*f*fd*r + 24*D1**2*K*f*fd*s - 24*D1**2*K*f*fd + 24*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r*s - 24*D1**2*K*f*fdd*r - 12*D1**2*K*f*fdd*s + 12*D1**2*K*f*fdd + 24*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r*s - 24*D1**2*K*fd**2*r - 12*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s - 1)*(-28*K*r + 14*K + 42*r + 14*s - 28)) - 177*D1**2*f**2*fd*r**2 - 462*D1**2*f**2*fd*r*s + 236*D1**2*f**2*fd*r - 285*D1**2*f**2*fd*s**2 + 308*D1**2*f**2*fd*s - 138*D1**2*f**2*fd + 255*D1**2*f**2*fdd*r**2 + 690*D1**2*f**2*fdd*r*s - 400*D1**2*f**2*fdd*r + 435*D1**2*f**2*fdd*s**2 - 520*D1**2*f**2*fdd*s + 240*D1**2*f**2*fdd + 510*D1**2*f*fd**2*r**2 + 1380*D1**2*f*fd**2*r*s - 800*D1**2*f*fd**2*r + 870*D1**2*f*fd**2*s**2 - 1040*D1**2*f*fd**2*s + 210*D1**2*f*fd**2 - 348*D1**2*f*fd*r**2 - 408*D1**2*f*fd*r*s + 180*D1**2*f*fd*r - 60*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 6*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 48*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s - 18*D1**2*f*fdd + 336*D1**2*f*gd2*r**2 + 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r - 168*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 36*D1**2*fd**2*r**2 - 48*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s + 336*D1**2*fd*g2*r**2 + 336*D1**2*fd*g2*r*s - 336*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 96*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 96*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s - 24*D1*Dd*K*f**2 + 192*D1*Dd*K*f*fd*r**2 + 192*D1*Dd*K*f*fd*r*s - 192*D1*Dd*K*f*fd*r - 72*D1*Dd*K*f*fd*s + 48*D1*Dd*K*f*fd - 236*D1*Dd*f**3*r**2 - 616*D1*Dd*f**3*r*s + 426*D1*Dd*f**3*r - 380*D1*Dd*f**3*s**2 + 534*D1*Dd*f**3*s - 249*D1*Dd*f**3 + 2040*D1*Dd*f**2*fd*r**2 + 5520*D1*Dd*f**2*fd*r*s - 3490*D1*Dd*f**2*fd*r + 3480*D1*Dd*f**2*fd*s**2 - 4510*D1*Dd*f**2*fd*s + 1440*D1*Dd*f**2*fd - 696*D1*Dd*f**2*r**2 - 816*D1*Dd*f**2*r*s + 756*D1*Dd*f**2*r - 120*D1*Dd*f**2*s**2 + 324*D1*Dd*f**2*s - 234*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 384*D1*Dd*f*fd*r*s + 312*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 192*D1*Dd*f*fd*s - 84*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r**2 + 1344*D1*Dd*f*g2*r*s - 1344*D1*Dd*f*g2*r - 336*D1*Dd*f*g2*s + 336*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1344*D1*Dd*f*gd2*r + 168*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 672*D1*Dd*fd*g2*r + 168*D1*Dd*fd*g2*s + 48*D1*Ddd*K*f**2*r**2 + 48*D1*Ddd*K*f**2*r*s - 48*D1*Ddd*K*f**2*r - 12*D1*Ddd*K*f**2*s + 12*D1*Ddd*K*f**2 + 340*D1*Ddd*f**3*r**2 + 920*D1*Ddd*f**3*r*s - 630*D1*Ddd*f**3*r + 580*D1*Ddd*f**3*s**2 - 810*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 - 72*D1*Ddd*f**2*r**2 - 96*D1*Ddd*f**2*r*s + 84*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 48*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 672*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 + 12*D1*bd1*(5*D1*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*D1*f*(r + s - 1)*(14*K*r - 7*K + 10*fd*(2*r + 2*s - 1) - 21*r - 7*s + 14) + 7*D1*fd*(r**2*(4*K - 6) + r*(4*K*s - 3*K - 8*s + 5) - s*(K + 2*s - 3)) - 5*Dd*f**2*(4*r + 4*s - 3)**2 + 7*Dd*f*(K*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) - 24*r**2 - 32*r*s + 34*r - 8*s**2 + 20*s - 11)) + 144*Dd**2*K*f**2*r**2 + 144*Dd**2*K*f**2*r*s - 144*Dd**2*K*f**2*r - 36*Dd**2*K*f**2*s + 24*Dd**2*K*f**2 + 1020*Dd**2*f**3*r**2 + 2760*Dd**2*f**3*r*s - 1890*Dd**2*f**3*r + 1740*Dd**2*f**3*s**2 - 2430*Dd**2*f**3*s + 750*Dd**2*f**3 - 216*Dd**2*f**2*r**2 - 288*Dd**2*f**2*r*s + 252*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 144*Dd**2*f**2*s - 60*Dd**2*f**2 - 2016*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 2016*Dd**2*f*g2*r + 504*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(1155*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk3*ct*k2**3*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*C - 3)*(2*s - 1) - 2*s**2 + 2*s - 1) + fd**2*(r*(C*(2 - 4*s) + 6*s - 3) + s*(2*s - 2))) + D1*f*(Dd*(2*f*(-2*C*s + r*(4*C - 6)*(2*s - 1) - 4*s**2 + 7*s - 2) - fd*(2*s - 1)*(2*C*(8*r - 1) - 24*r - 8*s + 7)) + Ddd*f*(2*C*s - r*(4*C - 6)*(2*s - 1) + 4*s**2 - 7*s + 2)) + Dd**2*f**2*(C*(r*(12 - 24*s) + 6*s - 4) + 18*r*(2*s - 1) + 12*s**2 - 21*s + 8)) + f*(D1**2*(f*(9*bdd1*s*(-2*C*(r - 1) + 3*r + s - 3) + 2*fd*(-2*C*s + r*(2*C - 3)*(3*s - 1) - 3*s**2 + 5*s - 1) + fdd*(2*C*s + r*(-6*C*s + 2*C + 9*s - 3) + 3*s**2 - 5*s + 1)) + fd**2*(C*(r*(4 - 12*s) + 4*s - 2) + 6*r*(3*s - 1) + 6*s**2 - 10*s + 3)) + 9*D1*bd1*(D1*(2*f*s*(2*C*(r - 1) - 3*r - s + 3) + fd*(C*(-8*r*s + 2*r + 4*s - 2) + 12*r*s - 3*r + 4*s**2 - 8*s + 3)) + Dd*f*(-2*C*(8*r*s - 2*r - 5*s + 2) + 24*r*s - 6*r + 8*s**2 - 19*s + 6)) + D1*f*(Dd*(2*f*(-2*C*s + r*(4*C - 6)*(2*s - 1) - 4*s**2 + 7*s - 2) + fd*(C*(-48*r*s + 20*r + 14*s - 6) + 72*r*s - 30*r + 24*s**2 - 41*s + 13)) + Ddd*f*(2*C*s - r*(4*C - 6)*(2*s - 1) + 4*s**2 - 7*s + 2)) + Dd**2*f**2*(C*(r*(12 - 24*s) + 6*s - 4) + 18*r*(2*s - 1) + 12*s**2 - 21*s + 8)))/(63*d**2*k1*k3**4) + D1**2*Pk1*Pk3*ct*k2**3*st**4*(168*b1**2*(C - 1)*(D1**2*r*(2*fd - fdd)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-8*r**2 - 8*r*(s - 1) + s - 1)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + 3*b1*(-96*C*D1**2*f*fd*r**2 - 352*C*D1**2*f*fd*r*s + 144*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s + 16*C*D1**2*f*fd + 104*C*D1**2*f*fdd*r**2 + 288*C*D1**2*f*fdd*r*s - 128*C*D1**2*f*fdd*r + 8*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd + 104*C*D1**2*fd**2*r**2 + 288*C*D1**2*fd**2*r*s - 128*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 - 192*C*D1*Dd*f**2*r**2 - 704*C*D1*Dd*f**2*r*s + 448*C*D1*Dd*f**2*r + 176*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 832*C*D1*Dd*f*fd*r**2 + 2304*C*D1*Dd*f*fd*r*s - 1296*C*D1*Dd*f*fd*r - 256*C*D1*Dd*f*fd*s + 112*C*D1*Dd*f*fd + 208*C*D1*Ddd*f**2*r**2 + 576*C*D1*Ddd*f**2*r*s - 392*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s + 52*C*D1*Ddd*f**2 + 624*C*Dd**2*f**2*r**2 + 1728*C*Dd**2*f**2*r*s - 1176*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s + 288*C*Dd**2*f**2 - 56*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 238*D1**2*f*fd*r**2 + 660*D1**2*f*fd*r*s - 298*D1**2*f*fd*r + 166*D1**2*f*fd*s**2 - 150*D1**2*f*fd*s + 67*D1**2*f*fd - 210*D1**2*f*fdd*r**2 - 540*D1**2*f*fdd*r*s + 254*D1**2*f*fdd*r - 146*D1**2*f*fdd*s**2 + 138*D1**2*f*fdd*s - 65*D1**2*f*fdd - 210*D1**2*fd**2*r**2 - 540*D1**2*fd**2*r*s + 254*D1**2*fd**2*r - 146*D1**2*fd**2*s**2 + 138*D1**2*fd**2*s + 8*D1**2*fd**2 + 476*D1*Dd*f**2*r**2 + 1320*D1*Dd*f**2*r*s - 898*D1*Dd*f**2*r + 332*D1*Dd*f**2*s**2 - 662*D1*Dd*f**2*s + 285*D1*Dd*f**2 - 1680*D1*Dd*f*fd*r**2 - 4320*D1*Dd*f*fd*r*s + 2516*D1*Dd*f*fd*r - 1168*D1*Dd*f*fd*s**2 + 1676*D1*Dd*f*fd*s - 530*D1*Dd*f*fd - 420*D1*Ddd*f**2*r**2 - 1080*D1*Ddd*f**2*r*s + 750*D1*Ddd*f**2*r - 292*D1*Ddd*f**2*s**2 + 562*D1*Ddd*f**2*s - 251*D1*Ddd*f**2 + 56*D1*bd1*(C - 1)*(D1*(f*(4*r**2 + 4*r*(s - 1) - 2*s + 2) + fd*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 1260*Dd**2*f**2*r**2 - 3240*Dd**2*f**2*r*s + 2250*Dd**2*f**2*r - 876*Dd**2*f**2*s**2 + 1686*Dd**2*f**2*s - 686*Dd**2*f**2) - f*(624*C*D1**2*f*fd*r**2 + 576*C*D1**2*f*fd*r*s - 608*C*D1**2*f*fd*r - 192*C*D1**2*f*fd*s + 208*C*D1**2*f*fd - 780*C*D1**2*f*fdd*r**2 - 504*C*D1**2*f*fdd*r*s + 688*C*D1**2*f*fdd*r + 168*C*D1**2*f*fdd*s - 260*C*D1**2*f*fdd - 1560*C*D1**2*fd**2*r**2 - 1008*C*D1**2*fd**2*r*s + 1376*C*D1**2*fd**2*r + 336*C*D1**2*fd**2*s - 168*C*D1**2*fd**2 + 832*C*D1*Dd*f**2*r**2 + 768*C*D1*Dd*f**2*r*s - 800*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s + 208*C*D1*Dd*f**2 - 6240*C*D1*Dd*f*fd*r**2 - 4032*C*D1*Dd*f*fd*r*s + 5320*C*D1*Dd*f*fd*r + 1176*C*D1*Dd*f*fd*s - 1024*C*D1*Dd*f*fd - 1040*C*D1*Ddd*f**2*r**2 - 672*C*D1*Ddd*f**2*r*s + 856*C*D1*Ddd*f**2*r + 168*C*D1*Ddd*f**2*s - 260*C*D1*Ddd*f**2 - 3120*C*Dd**2*f**2*r**2 - 2016*C*Dd**2*f**2*r*s + 2568*C*Dd**2*f**2*r + 504*C*Dd**2*f**2*s - 336*C*Dd**2*f**2 + 168*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) - 3*D1**2*bdd1*f*(4*C*(13*r**2 + 6*r*(6*s - 5) - 38*s + 15) - 105*r**2 - 270*r*s + 226*r - 73*s**2 + 278*s - 113) - 681*D1**2*f*fd*r**2 - 846*D1**2*f*fd*r*s + 736*D1**2*f*fd*r - 141*D1**2*f*fd*s**2 + 376*D1**2*f*fd*s - 274*D1**2*f*fd + 741*D1**2*f*fdd*r**2 + 666*D1**2*f*fdd*r*s - 716*D1**2*f*fdd*r + 111*D1**2*f*fdd*s**2 - 296*D1**2*f*fdd*s + 284*D1**2*f*fdd + 1482*D1**2*fd**2*r**2 + 1332*D1**2*fd**2*r*s - 1432*D1**2*fd**2*r + 222*D1**2*fd**2*s**2 - 592*D1**2*fd**2*s + 222*D1**2*fd**2 - 908*D1*Dd*f**2*r**2 - 1128*D1*Dd*f**2*r*s + 1018*D1*Dd*f**2*r - 188*D1*Dd*f**2*s**2 + 470*D1*Dd*f**2*s - 321*D1*Dd*f**2 + 5928*D1*Dd*f*fd*r**2 + 5328*D1*Dd*f*fd*r*s - 5678*D1*Dd*f*fd*r + 888*D1*Dd*f*fd*s**2 - 2294*D1*Dd*f*fd*s + 1308*D1*Dd*f*fd + 988*D1*Ddd*f**2*r**2 + 888*D1*Ddd*f**2*r*s - 938*D1*Ddd*f**2*r + 148*D1*Ddd*f**2*s**2 - 370*D1*Ddd*f**2*s + 321*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(16*C*(3*r**2 + 11*r*s - 8*r - 12*s + 4) - 119*r**2 - 330*r*s + 270*r - 83*s**2 + 346*s - 135) + 2*fd*(-4*C*(26*r**2 + 72*r*s - 46*r - 37*s + 19) + 210*r**2 + 540*r*s - 353*r + 146*s**2 - 347*s + 139)) + 2*Dd*f*(-4*C*(52*r**2 + 144*r*s - 109*r - 94*s + 53) + 420*r**2 + 1080*r*s - 827*r + 292*s**2 - 837*s + 391)) + 2964*Dd**2*f**2*r**2 + 2664*Dd**2*f**2*r*s - 2814*Dd**2*f**2*r + 444*Dd**2*f**2*s**2 - 1110*Dd**2*f**2*s + 518*Dd**2*f**2))/(105*d**2*k1*k3**4) + D1**2*Pk1*Pk3*ct*k2**3*st**2*(1188*C*D1**2*f**2*fd*r**2 - 792*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd + 1584*C*D1*Dd*f**3*r**2 - 792*C*D1*Dd*f**3*r + 396*C*D1*Dd*f**3 + 1914*D1**2*K*bdd1*f**2*r**2 + 1232*D1**2*K*bdd1*f**2*r*s - 1232*D1**2*K*bdd1*f**2*r - 880*D1**2*b2*f*fd*r**2 - 880*D1**2*b2*f*fd*r*s + 880*D1**2*b2*f*fd*r + 440*D1**2*b2*f*fd*s - 440*D1**2*b2*f*fd + 1056*D1**2*b2*f*fdd*r**2 + 1056*D1**2*b2*f*fdd*r*s - 1056*D1**2*b2*f*fdd*r - 528*D1**2*b2*f*fdd*s + 528*D1**2*b2*f*fdd + 1056*D1**2*b2*fd**2*r**2 + 1056*D1**2*b2*fd**2*r*s - 1056*D1**2*b2*fd**2*r - 528*D1**2*b2*fd**2*s - 22*D1**2*bd1**2*(3*f**2*(50*r**2 + r*(148*s - 103) + 98*s**2 - 131*s + 45) - 7*f*(2*K*(7*r**2 + 2*r*(7*s - 8) - 8*s + 8) - 45*r**2 - 90*r*s + 94*r - 31*s**2 + 78*s - 47) - 140*g2*(2*r**2 + 2*r*(s - 1) - s)) - 440*D1**2*bd2*f**2*r**2 - 440*D1**2*bd2*f**2*r*s + 440*D1**2*bd2*f**2*r + 2112*D1**2*bd2*f*fd*r**2 + 2112*D1**2*bd2*f*fd*r*s - 2112*D1**2*bd2*f*fd*r - 528*D1**2*bd2*f*fd*s + 528*D1**2*bd2*f*fd - 1562*D1**2*bdd1*f**3*r**2 - 836*D1**2*bdd1*f**3*r*s + 1386*D1**2*bdd1*f**3*r + 924*D1**2*bdd1*f**3*s**2 - 1782*D1**2*bdd1*f**3*s - 33*D1**2*bdd1*f**3 - 2101*D1**2*bdd1*f**2*r**2 - 2398*D1**2*bdd1*f**2*r*s + 2398*D1**2*bdd1*f**2*r - 583*D1**2*bdd1*f**2*s**2 + 1166*D1**2*bdd1*f**2*s - 583*D1**2*bdd1*f**2 - 2156*D1**2*bdd1*f*g2*r**2 - 4312*D1**2*bdd1*f*g2*r*s + 5544*D1**2*bdd1*f*g2*r + 4928*D1**2*bdd1*f*g2*s - 2772*D1**2*bdd1*f*g2 + 528*D1**2*bdd2*f**2*r**2 + 528*D1**2*bdd2*f**2*r*s - 528*D1**2*bdd2*f**2*r - 2160*D1**2*f**3*fd*r**2 - 8448*D1**2*f**3*fd*r*s + 5304*D1**2*f**3*fd*r - 3960*D1**2*f**3*fd*s**2 + 6072*D1**2*f**3*fd*s - 2520*D1**2*f**3*fd + 2400*D1**2*f**3*fdd*r**2 + 8448*D1**2*f**3*fdd*r*s - 5424*D1**2*f**3*fdd*r + 3960*D1**2*f**3*fdd*s**2 - 6072*D1**2*f**3*fdd*s + 2580*D1**2*f**3*fdd + 7200*D1**2*f**2*fd**2*r**2 + 25344*D1**2*f**2*fd**2*r*s - 16272*D1**2*f**2*fd**2*r + 11880*D1**2*f**2*fd**2*s**2 - 18216*D1**2*f**2*fd**2*s + 6204*D1**2*f**2*fd**2 - 2376*D1**2*f**2*fd*r**2 - 1188*D1**2*f**2*fd*r*s + 1980*D1**2*f**2*fd*r + 396*D1**2*f**2*fd*s - 792*D1**2*f**2*fd + 2728*D1**2*f**2*gd2*r**2 + 2464*D1**2*f**2*gd2*r*s - 2464*D1**2*f**2*gd2*r - 3828*D1**2*f**2*gdd2*r**2 - 2464*D1**2*f**2*gdd2*r*s + 2464*D1**2*f**2*gdd2*r + 5456*D1**2*f*fd*g2*r**2 + 4928*D1**2*f*fd*g2*r*s - 5456*D1**2*f*fd*g2*r - 2464*D1**2*f*fd*g2*s + 2728*D1**2*f*fd*g2 - 15312*D1**2*f*fd*gd2*r**2 - 9856*D1**2*f*fd*gd2*r*s + 12584*D1**2*f*fd*gd2*r + 2464*D1**2*f*fd*gd2*s - 2464*D1**2*f*fd*gd2 - 7656*D1**2*f*fdd*g2*r**2 - 4928*D1**2*f*fdd*g2*r*s + 7656*D1**2*f*fdd*g2*r + 2464*D1**2*f*fdd*g2*s - 3828*D1**2*f*fdd*g2 - 7656*D1**2*fd**2*g2*r**2 - 4928*D1**2*fd**2*g2*r*s + 7656*D1**2*fd**2*g2*r + 2464*D1**2*fd**2*g2*s - 1760*D1*Dd*b2*f**2*r**2 - 1760*D1*Dd*b2*f**2*r*s + 1760*D1*Dd*b2*f**2*r + 440*D1*Dd*b2*f**2*s - 440*D1*Dd*b2*f**2 + 8448*D1*Dd*b2*f*fd*r**2 + 8448*D1*Dd*b2*f*fd*r*s - 8448*D1*Dd*b2*f*fd*r - 3168*D1*Dd*b2*f*fd*s + 2112*D1*Dd*b2*f*fd + 4224*D1*Dd*bd2*f**2*r**2 + 4224*D1*Dd*bd2*f**2*r*s - 4224*D1*Dd*bd2*f**2*r - 528*D1*Dd*bd2*f**2*s + 528*D1*Dd*bd2*f**2 - 2160*D1*Dd*f**4*r**2 - 8448*D1*Dd*f**4*r*s + 5304*D1*Dd*f**4*r - 3960*D1*Dd*f**4*s**2 + 6072*D1*Dd*f**4*s - 2520*D1*Dd*f**4 + 19200*D1*Dd*f**3*fd*r**2 + 67584*D1*Dd*f**3*fd*r*s - 43392*D1*Dd*f**3*fd*r + 31680*D1*Dd*f**3*fd*s**2 - 48576*D1*Dd*f**3*fd*s + 17568*D1*Dd*f**3*fd - 3168*D1*Dd*f**3*r**2 - 1584*D1*Dd*f**3*r*s + 2376*D1*Dd*f**3*r + 396*D1*Dd*f**3*s - 792*D1*Dd*f**3 + 10912*D1*Dd*f**2*g2*r**2 + 9856*D1*Dd*f**2*g2*r*s - 10384*D1*Dd*f**2*g2*r - 2464*D1*Dd*f**2*g2*s + 2728*D1*Dd*f**2*g2 - 30624*D1*Dd*f**2*gd2*r**2 - 19712*D1*Dd*f**2*gd2*r*s + 22440*D1*Dd*f**2*gd2*r + 2464*D1*Dd*f**2*gd2*s - 2464*D1*Dd*f**2*gd2 - 61248*D1*Dd*f*fd*g2*r**2 - 39424*D1*Dd*f*fd*g2*r*s + 55792*D1*Dd*f*fd*g2*r + 14784*D1*Dd*f*fd*g2*s - 12584*D1*Dd*f*fd*g2 + 2112*D1*Ddd*b2*f**2*r**2 + 2112*D1*Ddd*b2*f**2*r*s - 2112*D1*Ddd*b2*f**2*r - 528*D1*Ddd*b2*f**2*s + 528*D1*Ddd*b2*f**2 + 2400*D1*Ddd*f**4*r**2 + 8448*D1*Ddd*f**4*r*s - 5424*D1*Ddd*f**4*r + 3960*D1*Ddd*f**4*s**2 - 6072*D1*Ddd*f**4*s + 2580*D1*Ddd*f**4 - 15312*D1*Ddd*f**2*g2*r**2 - 9856*D1*Ddd*f**2*g2*r*s + 12584*D1*Ddd*f**2*g2*r + 2464*D1*Ddd*f**2*g2*s - 3828*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(f**3*(122*r**2 + r*(20*s - 78) - 120*s**2 + 198*s - 21) + f**2*(28*C*(r**2 - 2*r*(s + 3) + 3) - 124*K*r**2 - 112*K*r*s + 112*K*r + fd*(-852*r**2 - 456*r*s + 688*r + 504*s**2 - 584*s + 204) + 53*r**2 + 198*r*s + 110*r + 43*s**2 - 2*s - 125) + 2*f*(fd*(K*(348*r**2 + 224*r*s - 286*r - 56*s + 56) - 382*r**2 - 436*r*s + 409*r - 106*s**2 + 215*s - 109) + 56*g2*(r**2 + 2*r*(s - 2) - 3*s + 2) + 28*gd2*(-7*r**2 - 14*r*s + 16*r + 8*s - 8)) - 392*fd*g2*(r**2 + r*(2*s - 1) - s)) - 2*Dd*f*(f**2*(568*r**2 + r*(304*s - 470) - 336*s**2 + 454*s - 99) + f*(K*(-696*r**2 - 448*r*s + 510*r + 56*s - 56) + 764*r**2 + 872*r*s - 845*r + 212*s**2 - 427*s + 215) + 28*g2*(28*r**2 + r*(56*s - 57) - 39*s + 25))) + 6336*Dd**2*b2*f**2*r**2 + 6336*Dd**2*b2*f**2*r*s - 6336*Dd**2*b2*f**2*r - 1584*Dd**2*b2*f**2*s + 1056*Dd**2*b2*f**2 + 7200*Dd**2*f**4*r**2 + 25344*Dd**2*f**4*r*s - 16272*Dd**2*f**4*r + 11880*Dd**2*f**4*s**2 - 18216*Dd**2*f**4*s + 6204*Dd**2*f**4 - 45936*Dd**2*f**2*g2*r**2 - 29568*Dd**2*f**2*g2*r*s + 37752*Dd**2*f**2*g2*r + 7392*Dd**2*f**2*g2*s - 4928*Dd**2*f**2*g2 + 1540*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + 4*r*(s - 1) - s + 1) + Dd**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + 11*b1**2*(-280*C*D1**2*fd*r**2 - 280*C*D1**2*fd*r*s + 280*C*D1**2*fd*r - 1120*C*D1*Dd*f*r**2 - 1120*C*D1*Dd*f*r*s + 1120*C*D1*Dd*f*r + 280*C*D1*Dd*f*s - 280*C*D1*Dd*f - 56*D1**2*K*fd*r**2 - 112*D1**2*K*fd*r*s - 112*D1**2*K*fd*r - 56*D1**2*K*fd*s + 56*D1**2*K*fd + 98*D1**2*K*fdd*r**2 + 196*D1**2*K*fdd*r*s + 56*D1**2*K*fdd*r + 28*D1**2*K*fdd*s - 28*D1**2*K*fdd - 140*D1**2*bdd1*(K - 1)*(3*r**2 + 3*r*(s - 1) - s + 1) + 292*D1**2*f*fd*r**2 + 712*D1**2*f*fd*r*s - 454*D1**2*f*fd*r + 420*D1**2*f*fd*s**2 - 590*D1**2*f*fd*s + 275*D1**2*f*fd - 300*D1**2*f*fdd*r**2 - 888*D1**2*f*fdd*r*s + 570*D1**2*f*fdd*r - 588*D1**2*f*fdd*s**2 + 834*D1**2*f*fdd*s - 393*D1**2*f*fdd - 300*D1**2*fd**2*r**2 - 888*D1**2*fd**2*r*s + 570*D1**2*fd**2*r - 588*D1**2*fd**2*s**2 + 834*D1**2*fd**2*s - 246*D1**2*fd**2 + 595*D1**2*fd*r**2 + 770*D1**2*fd*r*s - 168*D1**2*fd*r + 119*D1**2*fd*s**2 + 56*D1**2*fd*s - 56*D1**2*fd - 315*D1**2*fdd*r**2 - 630*D1**2*fdd*r*s - 56*D1**2*fdd*r - 217*D1**2*fdd*s**2 - 28*D1**2*fdd*s + 28*D1**2*fdd - 560*D1**2*gd2*r**2 - 560*D1**2*gd2*r*s + 560*D1**2*gd2*r + 280*D1**2*gdd2*r**2 + 280*D1**2*gdd2*r*s - 280*D1**2*gdd2*r - 224*D1*Dd*K*f*r**2 - 448*D1*Dd*K*f*r*s + 336*D1*Dd*K*f*r + 112*D1*Dd*K*f*s - 56*D1*Dd*K*f + 784*D1*Dd*K*fd*r**2 + 1568*D1*Dd*K*fd*r*s - 364*D1*Dd*K*fd*r - 84*D1*Dd*K*fd*s - 112*D1*Dd*K*fd + 584*D1*Dd*f**2*r**2 + 1424*D1*Dd*f**2*r*s - 1004*D1*Dd*f**2*r + 840*D1*Dd*f**2*s**2 - 1196*D1*Dd*f**2*s + 566*D1*Dd*f**2 - 2400*D1*Dd*f*fd*r**2 - 7104*D1*Dd*f*fd*r*s + 4656*D1*Dd*f*fd*r - 4704*D1*Dd*f*fd*s**2 + 6576*D1*Dd*f*fd*s - 2238*D1*Dd*f*fd + 2380*D1*Dd*f*r**2 + 3080*D1*Dd*f*r*s - 2730*D1*Dd*f*r + 476*D1*Dd*f*s**2 - 1246*D1*Dd*f*s + 833*D1*Dd*f - 2520*D1*Dd*fd*r**2 - 5040*D1*Dd*fd*r*s + 1666*D1*Dd*fd*r - 1736*D1*Dd*fd*s**2 + 1386*D1*Dd*fd*s + 112*D1*Dd*fd - 2240*D1*Dd*g2*r**2 - 2240*D1*Dd*g2*r*s + 2240*D1*Dd*g2*r + 560*D1*Dd*g2*s - 560*D1*Dd*g2 + 2240*D1*Dd*gd2*r**2 + 2240*D1*Dd*gd2*r*s - 2240*D1*Dd*gd2*r - 280*D1*Dd*gd2*s + 280*D1*Dd*gd2 + 392*D1*Ddd*K*f*r**2 + 784*D1*Ddd*K*f*r*s - 588*D1*Ddd*K*f*r - 196*D1*Ddd*K*f*s + 98*D1*Ddd*K*f - 600*D1*Ddd*f**2*r**2 - 1776*D1*Ddd*f**2*r*s + 1188*D1*Ddd*f**2*r - 1176*D1*Ddd*f**2*s**2 + 1620*D1*Ddd*f**2*s - 738*D1*Ddd*f**2 - 1260*D1*Ddd*f*r**2 - 2520*D1*Ddd*f*r*s + 1890*D1*Ddd*f*r - 868*D1*Ddd*f*s**2 + 1498*D1*Ddd*f*s - 749*D1*Ddd*f + 1120*D1*Ddd*g2*r**2 + 1120*D1*Ddd*g2*r*s - 1120*D1*Ddd*g2*r - 280*D1*Ddd*g2*s + 280*D1*Ddd*g2 + 140*D1*bd1*(K - 1)*(D1*(6*r**2 + 6*r*(s - 1) - 2*s + 2) + Dd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + 1176*Dd**2*K*f*r**2 + 2352*Dd**2*K*f*r*s - 1764*Dd**2*K*f*r - 588*Dd**2*K*f*s + 392*Dd**2*K*f - 1800*Dd**2*f**2*r**2 - 5328*Dd**2*f**2*r*s + 3564*Dd**2*f**2*r - 3528*Dd**2*f**2*s**2 + 4860*Dd**2*f**2*s - 1476*Dd**2*f**2 - 3780*Dd**2*f*r**2 - 7560*Dd**2*f*r*s + 5670*Dd**2*f*r - 2604*Dd**2*f*s**2 + 4494*Dd**2*f*s - 1694*Dd**2*f + 3360*Dd**2*g2*r**2 + 3360*Dd**2*g2*r*s - 3360*Dd**2*g2*r - 840*Dd**2*g2*s + 560*Dd**2*g2) - 11*b1*(-56*C*D1**2*f*fd*r**2 + 112*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r - 56*C*D1**2*f*fd*s + 56*C*D1**2*f*fd - 112*C*D1*Dd*f**2*r**2 + 224*C*D1*Dd*f**2*r*s - 56*C*D1*Dd*f**2*r - 56*C*D1*Dd*f**2*s - 28*C*D1*Dd*f**2 + 248*D1**2*K*f*fd*r**2 + 224*D1**2*K*f*fd*r*s - 248*D1**2*K*f*fd*r - 112*D1**2*K*f*fd*s + 124*D1**2*K*f*fd - 348*D1**2*K*f*fdd*r**2 - 224*D1**2*K*f*fdd*r*s + 348*D1**2*K*f*fdd*r + 112*D1**2*K*f*fdd*s - 174*D1**2*K*f*fdd - 348*D1**2*K*fd**2*r**2 - 224*D1**2*K*fd**2*r*s + 348*D1**2*K*fd**2*r + 112*D1**2*K*fd**2*s + 140*D1**2*bd1**2*(K - 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + D1**2*bdd1*(f**2*(300*r**2 + r*(888*s - 618) + 588*s**2 - 786*s + 345) - 14*f*(K*(14*r**2 + 4*r*(7*s - 8) - 16*s + 9) - 45*r**2 - 90*r*s + 94*r - 31*s**2 + 78*s - 40) - 280*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 366*D1**2*f**2*fd*r**2 - 60*D1**2*f**2*fd*r*s + 206*D1**2*f**2*fd*r + 360*D1**2*f**2*fd*s**2 - 262*D1**2*f**2*fd*s + 97*D1**2*f**2*fd + 426*D1**2*f**2*fdd*r**2 + 228*D1**2*f**2*fdd*r*s - 310*D1**2*f**2*fdd*r - 252*D1**2*f**2*fdd*s**2 + 98*D1**2*f**2*fdd*s - 29*D1**2*f**2*fdd + 852*D1**2*f*fd**2*r**2 + 456*D1**2*f*fd**2*r*s - 620*D1**2*f*fd**2*r - 504*D1**2*f*fd**2*s**2 + 196*D1**2*f*fd**2*s + 188*D1**2*f*fd**2 - 106*D1**2*f*fd*r**2 - 396*D1**2*f*fd*r*s + 414*D1**2*f*fd*r - 86*D1**2*f*fd*s**2 + 282*D1**2*f*fd*s - 221*D1**2*f*fd + 382*D1**2*f*fdd*r**2 + 436*D1**2*f*fdd*r*s - 382*D1**2*f*fdd*r + 106*D1**2*f*fdd*s**2 - 218*D1**2*f*fdd*s + 191*D1**2*f*fdd - 112*D1**2*f*gd2*r**2 - 224*D1**2*f*gd2*r*s + 224*D1**2*f*gd2*r + 196*D1**2*f*gdd2*r**2 + 392*D1**2*f*gdd2*r*s - 392*D1**2*f*gdd2*r + 382*D1**2*fd**2*r**2 + 436*D1**2*fd**2*r*s - 382*D1**2*fd**2*r + 106*D1**2*fd**2*s**2 - 218*D1**2*fd**2*s - 112*D1**2*fd*g2*r**2 - 224*D1**2*fd*g2*r*s - 224*D1**2*fd*g2*r - 112*D1**2*fd*g2*s + 112*D1**2*fd*g2 + 392*D1**2*fd*gd2*r**2 + 784*D1**2*fd*gd2*r*s - 280*D1**2*fd*gd2*r + 56*D1**2*fd*gd2*s - 56*D1**2*fd*gd2 + 196*D1**2*fdd*g2*r**2 + 392*D1**2*fdd*g2*r*s + 112*D1**2*fdd*g2*r + 56*D1**2*fdd*g2*s - 56*D1**2*fdd*g2 + 496*D1*Dd*K*f**2*r**2 + 448*D1*Dd*K*f**2*r*s - 472*D1*Dd*K*f**2*r - 112*D1*Dd*K*f**2*s + 124*D1*Dd*K*f**2 - 2784*D1*Dd*K*f*fd*r**2 - 1792*D1*Dd*K*f*fd*r*s + 2536*D1*Dd*K*f*fd*r + 672*D1*Dd*K*f*fd*s - 572*D1*Dd*K*f*fd - 488*D1*Dd*f**3*r**2 - 80*D1*Dd*f**3*r*s + 284*D1*Dd*f**3*r + 480*D1*Dd*f**3*s**2 - 460*D1*Dd*f**3*s + 118*D1*Dd*f**3 + 3408*D1*Dd*f**2*fd*r**2 + 1824*D1*Dd*f**2*fd*r*s - 2548*D1*Dd*f**2*fd*r - 2016*D1*Dd*f**2*fd*s**2 + 1172*D1*Dd*f**2*fd*s + 114*D1*Dd*f**2*fd - 212*D1*Dd*f**2*r**2 - 792*D1*Dd*f**2*r*s + 502*D1*Dd*f**2*r - 172*D1*Dd*f**2*s**2 + 370*D1*Dd*f**2*s - 139*D1*Dd*f**2 + 3056*D1*Dd*f*fd*r**2 + 3488*D1*Dd*f*fd*r*s - 3164*D1*Dd*f*fd*r + 848*D1*Dd*f*fd*s**2 - 1732*D1*Dd*f*fd*s + 818*D1*Dd*f*fd - 448*D1*Dd*f*g2*r**2 - 896*D1*Dd*f*g2*r*s + 672*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s - 112*D1*Dd*f*g2 + 1568*D1*Dd*f*gd2*r**2 + 3136*D1*Dd*f*gd2*r*s - 2744*D1*Dd*f*gd2*r - 392*D1*Dd*f*gd2*s + 392*D1*Dd*f*gd2 + 1568*D1*Dd*fd*g2*r**2 + 3136*D1*Dd*fd*g2*r*s - 728*D1*Dd*fd*g2*r - 168*D1*Dd*fd*g2*s - 224*D1*Dd*fd*g2 - 696*D1*Ddd*K*f**2*r**2 - 448*D1*Ddd*K*f**2*r*s + 572*D1*Ddd*K*f**2*r + 112*D1*Ddd*K*f**2*s - 174*D1*Ddd*K*f**2 + 568*D1*Ddd*f**3*r**2 + 304*D1*Ddd*f**3*r*s - 436*D1*Ddd*f**3*r - 336*D1*Ddd*f**3*s**2 + 260*D1*Ddd*f**3*s - 26*D1*Ddd*f**3 + 764*D1*Ddd*f**2*r**2 + 872*D1*Ddd*f**2*r*s - 818*D1*Ddd*f**2*r + 212*D1*Ddd*f**2*s**2 - 430*D1*Ddd*f**2*s + 297*D1*Ddd*f**2 + 784*D1*Ddd*f*g2*r**2 + 1568*D1*Ddd*f*g2*r*s - 1176*D1*Ddd*f*g2*r - 392*D1*Ddd*f*g2*s + 196*D1*Ddd*f*g2 + D1*bd1*(D1*(-f**2*(292*r**2 + r*(712*s - 550) + 420*s**2 - 606*s + 291) + 2*f*(140*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 28*K*(2*r**2 + 4*r*s - 6*r - 3*s + 2) + 12*fd*(50*r**2 + r*(148*s - 99) + 98*s**2 - 135*s + 40) - 595*r**2 - 770*r*s + 896*r - 119*s**2 + 532*s - 385) - 28*fd*(K*(14*r**2 + 4*r*(7*s - 3) - 6*s - 1) - 45*r**2 + r*(43 - 90*s) - 31*s**2 + 37*s + 1) + 280*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) + 280*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) + 2*Dd*(3*f**2*(400*r**2 + 8*r*(148*s - 101) + 784*s**2 - 1064*s + 365) - 14*f*(2*K*(28*r**2 + 56*r*s - 53*r - 23*s + 16) - 180*r**2 - 360*r*s + 323*r - 124*s**2 + 263*s - 125) - 280*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 2088*Dd**2*K*f**2*r**2 - 1344*Dd**2*K*f**2*r*s + 1716*Dd**2*K*f**2*r + 336*Dd**2*K*f**2*s - 224*Dd**2*K*f**2 + 1704*Dd**2*f**3*r**2 + 912*Dd**2*f**3*r*s - 1308*Dd**2*f**3*r - 1008*Dd**2*f**3*s**2 + 780*Dd**2*f**3*s - 16*Dd**2*f**3 + 2292*Dd**2*f**2*r**2 + 2616*Dd**2*f**2*r*s - 2454*Dd**2*f**2*r + 636*Dd**2*f**2*s**2 - 1290*Dd**2*f**2*s + 542*Dd**2*f**2 + 2352*Dd**2*f*g2*r**2 + 4704*Dd**2*f*g2*r*s - 3528*Dd**2*f*g2*r - 1176*Dd**2*f*g2*s + 784*Dd**2*f*g2))/(1155*d**2*k1*k3**4) - 4*D1**2*Pk1*Pk3*ct*k2*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k1*k3**2) + D1**2*Pk1*Pk3*ct*k2*st**4*(-168*b1**2*(C - 1)*(D1*Dd*(2*f*(-4*r*s + 2*r + s) + fd*(8*r*s - 6*r - s + 1)) - D1*(D1*r*(2*fd - fdd)*(s - 1) + Ddd*f*(-4*r*s + 2*r + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 3*b1*(D1**2*(f*(-56*bdd1*s*(C - 1)*(2*r - 1) + fd*(r*(16*C + 36)*(2*s - 1) + 166*s**2 - s*(16*C + 150) + 83) + fdd*(-r*(8*C + 32)*(2*s - 1) - 146*s**2 + s*(8*C + 138) - 73)) + 2*fd**2*(4*C*(-2*r*s + r + s - 1) + r*(16 - 32*s) - 73*s**2 + 69*s + 4)) - 56*D1*bd1*(C - 1)*(D1*(2*f*s*(1 - 2*r) + fd*r*(4*s - 2) - fd*s + fd) + 2*Dd*f*(r*(8*s - 2) - 3*s + 1)) + 2*D1*f*(Dd*(f*(r*(16*C + 36)*(2*s - 1) + 166*s**2 - s*(8*C + 184) + 83) - 2*fd*(2*s - 1)*(2*C*(8*r - 3) + 64*r + 146*s - 77)) + Ddd*f*(-r*(8*C + 32)*(2*s - 1) - 146*s**2 + s*(4*C + 162) - 73)) - 2*Dd**2*f**2*(4*C*(6*r*(2*s - 1) - 3*s + 2) + 96*r*(2*s - 1) + 438*s**2 - 486*s + 105)) - f*(168*D1**2*bd1**2*s*(C - 1)*(2*r - 1) + D1**2*(f*(3*bdd1*s*(r*(8*C + 32) + 73*s - 40) + fd*(-64*C*s + r*(64*C - 76)*(3*s - 1) - 141*s**2 + 170*s - 47) + fdd*(80*C*s - r*(80*C - 80)*(3*s - 1) + 111*s**2 - 154*s + 37)) + 2*fd**2*(-40*C*(r*(6*s - 2) - 2*s + 1) + 80*r*(3*s - 1) + 111*s**2 - 154*s + 40)) - 3*D1*bd1*(D1*(f*s*(r*(16*C + 36) + 83*s - 52) + fd*(8*C*s - r*(8*C + 32)*(4*s - 1) - 292*s**2 + 218*s - 40)) - 4*Dd*f*(-2*C*s + r*(4*C + 16)*(4*s - 1) + 146*s**2 - 121*s + 20)) + 2*D1*f*(Dd*(f*(r*(64*C - 76)*(2*s - 1) - 94*s**2 - s*(32*C - 132) - 47) + 2*fd*(-20*C*(2*r*(12*s - 5) - 7*s + 3) + 40*r*(12*s - 5) + 222*s**2 - 325*s + 97)) + Ddd*f*(-r*(80*C - 80)*(2*s - 1) + 74*s**2 + s*(40*C - 114) + 37)) + 2*Dd**2*f**2*(-40*C*(6*r*(2*s - 1) - 3*s + 2) + 240*r*(2*s - 1) + 222*s**2 - 342*s + 117)))/(105*d**2*k1*k3**2) - 2*D1**2*Pk1*Pk3*ct*k2*st**2*(-28*b1**2*(C - 1)*(D1*Dd*(11*f*(-4*r*s + 2*r + s) + 8*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(11*fd - 8*fdd)*(s - 1) + 8*Ddd*f*(4*r*s - 2*r - s)) + 8*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(D1**2*(f*(-224*bdd1*s*(C - 1)*(2*r - 1) + 2*fd*(10*C*(6*r**2 + 10*r*s - 11*r - 5*s + 3) - 30*r**2 + 74*r*s + 8*r + 147*s**2 - 97*s + 51) - fdd*(8*C*(18*r**2 + 16*r*s - 26*r - 8*s + 9) - 72*r**2 + 172*r*s + 22*r + 294*s**2 - 230*s + 93)) - 2*fd**2*(8*C*(9*r**2 + r*(8*s - 13) - 4*s + 4) - 36*r**2 + r*(86*s + 11) + 147*s**2 - 115*s - 32)) - 28*D1*bd1*(C - 1)*(D1*(11*f*s*(1 - 2*r) + 8*fd*(4*r*s - 2*r - s + 1)) + 16*Dd*f*(r*(8*s - 2) - 3*s + 1)) + 2*D1*f*(Dd*(f*(10*C*(12*r**2 + 4*r*(5*s - 4) - 5*s + 3) - 60*r**2 + 148*r*s - 44*r + 294*s**2 - 331*s + 132) + fd*(-8*C*(72*r**2 + 64*r*s - 86*r - 24*s + 21) + 288*r**2 - 688*r*s + 56*r - 1176*s**2 + 1134*s - 219)) + Ddd*f*(-4*C*(36*r**2 + 32*r*s - 34*r - 8*s + 9) + 72*r**2 - 172*r*s + 50*r - 294*s**2 + 337*s - 129)) - 2*Dd**2*f**2*(8*C*(54*r**2 + r*(48*s - 51) - 12*s + 8) - 216*r**2 + 6*r*(86*s - 25) + 882*s**2 - 1011*s + 233)) - f*(132*C*D1**2*f*fd*r**2 + 288*C*D1**2*f*fd*r*s - 184*C*D1**2*f*fd*r - 96*C*D1**2*f*fd*s + 44*C*D1**2*f*fd - 120*C*D1**2*f*fdd*r**2 - 288*C*D1**2*f*fdd*r*s + 176*C*D1**2*f*fdd*r + 96*C*D1**2*f*fdd*s - 40*C*D1**2*f*fdd - 240*C*D1**2*fd**2*r**2 - 576*C*D1**2*fd**2*r*s + 352*C*D1**2*fd**2*r + 192*C*D1**2*fd**2*s - 96*C*D1**2*fd**2 + 176*C*D1*Dd*f**2*r**2 + 384*C*D1*Dd*f**2*r*s - 280*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s + 44*C*D1*Dd*f**2 - 960*C*D1*Dd*f*fd*r**2 - 2304*C*D1*Dd*f*fd*r*s + 1520*C*D1*Dd*f*fd*r + 672*C*D1*Dd*f*fd*s - 368*C*D1*Dd*f*fd - 160*C*D1*Ddd*f**2*r**2 - 384*C*D1*Ddd*f**2*r*s + 272*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s - 40*C*D1*Ddd*f**2 - 480*C*Dd**2*f**2*r**2 - 1152*C*Dd**2*f**2*r*s + 816*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s - 192*C*Dd**2*f**2 + 224*D1**2*bd1**2*s*(C - 1)*(2*r - 1) + D1**2*bdd1*f*(r**2*(72*C - 36) + r*(64*C*s + 86*s - 36) + 147*s**2 - 150*s + 18) - 84*D1**2*f*fd*r**2 - 402*D1**2*f*fd*r*s + 190*D1**2*f*fd*r - 117*D1**2*f*fd*s**2 + 212*D1**2*f*fd*s - 67*D1**2*f*fd + 96*D1**2*f*fdd*r**2 + 354*D1**2*f*fdd*r*s - 182*D1**2*f*fdd*r + 117*D1**2*f*fdd*s**2 - 196*D1**2*f*fdd*s + 71*D1**2*f*fdd + 192*D1**2*fd**2*r**2 + 708*D1**2*fd**2*r*s - 364*D1**2*fd**2*r + 234*D1**2*fd**2*s**2 - 392*D1**2*fd**2*s + 118*D1**2*fd**2 - 112*D1*Dd*f**2*r**2 - 536*D1*Dd*f**2*r*s + 324*D1*Dd*f**2*r - 156*D1*Dd*f**2*s**2 + 290*D1*Dd*f**2*s - 106*D1*Dd*f**2 + 768*D1*Dd*f*fd*r**2 + 2832*D1*Dd*f*fd*r*s - 1628*D1*Dd*f*fd*r + 936*D1*Dd*f*fd*s**2 - 1606*D1*Dd*f*fd*s + 574*D1*Dd*f*fd + 128*D1*Ddd*f**2*r**2 + 472*D1*Ddd*f**2*r*s - 300*D1*Ddd*f**2*r + 156*D1*Ddd*f**2*s**2 - 274*D1*Ddd*f**2*s + 110*D1*Ddd*f**2 - D1*bd1*(D1*(f*(r**2*(60*C - 30) + 2*r*(50*C*s + 37*s - 15) + 147*s**2 - 174*s + 15) + 2*fd*(32*C*s - r**2*(144*C - 72) + r*(-128*C*s + 104*C - 172*s + 25) - 294*s**2 + 265*s - 75)) + 2*Dd*f*(32*C*s - r**2*(288*C - 144) - 2*r*(128*C*s - 68*C + 172*s - 61) - 588*s**2 + 637*s - 168)) + 384*Dd**2*f**2*r**2 + 1416*Dd**2*f**2*r*s - 900*Dd**2*f**2*r + 468*Dd**2*f**2*s**2 - 822*Dd**2*f**2*s + 314*Dd**2*f**2))/(105*d**2*k1*k3**2) + D1**2*Pk1*Pk3*ct*k2*(-36*D1**2*K*bdd1*f**2*r**2 - 56*D1**2*K*bdd1*f**2*r*s + 56*D1**2*K*bdd1*f**2*r + 144*D1**2*b2*f*fd*r**2 + 112*D1**2*b2*f*fd*r*s - 144*D1**2*b2*f*fd*r - 56*D1**2*b2*f*fd*s + 72*D1**2*b2*f*fd - 72*D1**2*b2*f*fdd*r**2 - 112*D1**2*b2*f*fdd*r*s + 72*D1**2*b2*f*fdd*r + 56*D1**2*b2*f*fdd*s - 36*D1**2*b2*f*fdd - 72*D1**2*b2*fd**2*r**2 - 112*D1**2*b2*fd**2*r*s + 72*D1**2*b2*fd**2*r + 56*D1**2*b2*fd**2*s + 2*D1**2*bd1**2*(f**2*(2*r*(56*s - 23) + 210*s**2 - 189*s + 56) + 7*f*(12*K*r**2 + 2*r*(6*K*s - 3*K + 8*s - 7) + 25*s**2 - 39*s + 14) + 140*g2*s*(1 - 2*r)) + 72*D1**2*bd2*f**2*r**2 + 56*D1**2*bd2*f**2*r*s - 56*D1**2*bd2*f**2*r - 144*D1**2*bd2*f*fd*r**2 - 224*D1**2*bd2*f*fd*r*s + 184*D1**2*bd2*f*fd*r + 56*D1**2*bd2*f*fd*s - 56*D1**2*bd2*f*fd + 20*D1**2*bdd1*f**3*r**2 + 144*D1**2*bdd1*f**3*r*s - 96*D1**2*bdd1*f**3*r + 126*D1**2*bdd1*f**3*s**2 - 126*D1**2*bdd1*f**3*s + 63*D1**2*bdd1*f**3 + 36*D1**2*bdd1*f**2*r**2 + 132*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*r + 77*D1**2*bdd1*f**2*s**2 - 154*D1**2*bdd1*f**2*s + 77*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r**2 - 168*D1**2*bdd1*f*g2*r*s - 36*D1**2*bdd2*f**2*r**2 - 56*D1**2*bdd2*f**2*r*s + 56*D1**2*bdd2*f**2*r - 144*D1**2*f**2*gd2*r**2 - 112*D1**2*f**2*gd2*r*s + 112*D1**2*f**2*gd2*r + 72*D1**2*f**2*gdd2*r**2 + 112*D1**2*f**2*gdd2*r*s - 112*D1**2*f**2*gdd2*r - 288*D1**2*f*fd*g2*r**2 - 224*D1**2*f*fd*g2*r*s + 288*D1**2*f*fd*g2*r + 112*D1**2*f*fd*g2*s - 144*D1**2*f*fd*g2 + 288*D1**2*f*fd*gd2*r**2 + 448*D1**2*f*fd*gd2*r*s - 368*D1**2*f*fd*gd2*r - 112*D1**2*f*fd*gd2*s + 112*D1**2*f*fd*gd2 + 144*D1**2*f*fdd*g2*r**2 + 224*D1**2*f*fdd*g2*r*s - 144*D1**2*f*fdd*g2*r - 112*D1**2*f*fdd*g2*s + 72*D1**2*f*fdd*g2 + 144*D1**2*fd**2*g2*r**2 + 224*D1**2*fd**2*g2*r*s - 144*D1**2*fd**2*g2*r - 112*D1**2*fd**2*g2*s + 288*D1*Dd*b2*f**2*r**2 + 224*D1*Dd*b2*f**2*r*s - 256*D1*Dd*b2*f**2*r - 56*D1*Dd*b2*f**2*s + 72*D1*Dd*b2*f**2 - 576*D1*Dd*b2*f*fd*r**2 - 896*D1*Dd*b2*f*fd*r*s + 656*D1*Dd*b2*f*fd*r + 336*D1*Dd*b2*f*fd*s - 184*D1*Dd*b2*f*fd - 288*D1*Dd*bd2*f**2*r**2 - 448*D1*Dd*bd2*f**2*r*s + 408*D1*Dd*bd2*f**2*r + 56*D1*Dd*bd2*f**2*s - 56*D1*Dd*bd2*f**2 - 576*D1*Dd*f**2*g2*r**2 - 448*D1*Dd*f**2*g2*r*s + 512*D1*Dd*f**2*g2*r + 112*D1*Dd*f**2*g2*s - 144*D1*Dd*f**2*g2 + 576*D1*Dd*f**2*gd2*r**2 + 896*D1*Dd*f**2*gd2*r*s - 816*D1*Dd*f**2*gd2*r - 112*D1*Dd*f**2*gd2*s + 112*D1*Dd*f**2*gd2 + 1152*D1*Dd*f*fd*g2*r**2 + 1792*D1*Dd*f*fd*g2*r*s - 1312*D1*Dd*f*fd*g2*r - 672*D1*Dd*f*fd*g2*s + 368*D1*Dd*f*fd*g2 - 144*D1*Ddd*b2*f**2*r**2 - 224*D1*Ddd*b2*f**2*r*s + 184*D1*Ddd*b2*f**2*r + 56*D1*Ddd*b2*f**2*s - 36*D1*Ddd*b2*f**2 + 288*D1*Ddd*f**2*g2*r**2 + 448*D1*Ddd*f**2*g2*r*s - 368*D1*Ddd*f**2*g2*r - 112*D1*Ddd*f**2*g2*s + 72*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-f**3*(40*r**2 + 48*r*(3*s - 2) + 126*s**2 - 126*s + 63) + f**2*(2*fd*(60*r**2 + 4*r*(108*s - 65) + 378*s**2 - 450*s + 111) + r**2*(72*K - 72) + r*(56*K - 96)*(s - 1) - 77*(s - 1)**2) - 4*f*fd*(2*K*(18*r**2 + r*(28*s - 23) - 7*s + 7) - 36*r**2 - 132*r*s + 84*r - 77*s**2 + 110*s - 33) + 56*f*r*(g2*(6*r + s) + gd2*(-6*r - 6*s + 3)) - 168*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + 4*Dd*f*(f**2*(40*r**2 + 288*r*s - 178*r + 252*s**2 - 288*s + 87) - 2*f*(K*(36*r**2 + 56*r*s - 51*r - 7*s + 7) - 36*r**2 - 132*r*s + 108*r - 77*s**2 + 132*s - 55) - 42*g2*(8*r**2 + r*(8*s - 4) - s))) - 432*Dd**2*b2*f**2*r**2 - 672*Dd**2*b2*f**2*r*s + 552*Dd**2*b2*f**2*r + 168*Dd**2*b2*f**2*s - 112*Dd**2*b2*f**2 + 864*Dd**2*f**2*g2*r**2 + 1344*Dd**2*f**2*g2*r*s - 1104*Dd**2*f**2*g2*r - 336*Dd**2*f**2*g2*s + 224*Dd**2*f**2*g2 + 140*b1**3*(K - 1)*(D1*Dd*(r*(4*s - 2) - s) + D1*Ddd*(r*(4*s - 2) - s) + Dd**2*(6*r*(2*s - 1) - 3*s + 2)) + b1**2*(D1**2*(140*bdd1*(K - 1)*(r*(3*s - 1) - s) + f*fdd*(4*r*(56*s - 33) + 420*s**2 - 574*s + 297) + 2*fd**2*(112*r*s - 66*r + 210*s**2 - 287*s + 77) - fd*(28*K*(r - 1)*(6*r + s - 6) + f*(32*r*(7*s - 3) + 420*s**2 - 574*s + 279) + 84*r*(s + 2) + 175*s**2 + 28*s - 84) + 7*fdd*(12*K*(r - 1)*(r + s - 1) + 4*r*(4*s + 3) + 25*s**2 + 12*s - 6) + r*(-280*gd2 - 280*gdd2)*(s - 1)) + 140*D1*bd1*(K - 1)*(D1*(r*(3*s - 1) - s) + Dd*(2*r*(12*s - 5) - 7*s + 3)) - 2*D1*(Dd*(14*f**2*(8*r*(2*s - 1) + 30*s**2 - 34*s + 15) + f*(14*K*(24*r**2 + 4*r*s - 14*r - s + 6) - 4*fd*(224*r*s - 122*r + 420*s**2 - 525*s + 160) + 168*r*s - 84*r + 350*s**2 - 392*s + 175) - 14*fd*(3*K*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4) + 4*r*(8*s + 1) + 50*s**2 - 17*s - 9) + 140*g2*r*(4*s - 2) - 140*g2*s + 140*gd2*r*(8*s - 6) - 140*gd2*s + 140*gd2) - 7*Ddd*(2*f**2*(8*r*(2*s - 1) + 30*s**2 - 34*s + 15) + f*(6*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 32*r*s - 16*r + 50*s**2 - 58*s + 25) + 20*g2*(r*(2 - 4*s) + s))) + 14*Dd**2*(2*f**2*(24*r*(2*s - 1) + 90*s**2 - 102*s + 23) + f*(6*K*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 96*r*s - 48*r + 150*s**2 - 174*s + 41) - 20*g2*(6*r*(2*s - 1) - 3*s + 2))) + b1*(144*D1**2*K*f*fd*r**2 + 112*D1**2*K*f*fd*r*s - 144*D1**2*K*f*fd*r - 56*D1**2*K*f*fd*s + 72*D1**2*K*f*fd - 72*D1**2*K*f*fdd*r**2 - 112*D1**2*K*f*fdd*r*s + 72*D1**2*K*f*fdd*r + 56*D1**2*K*f*fdd*s - 36*D1**2*K*f*fdd - 72*D1**2*K*fd**2*r**2 - 112*D1**2*K*fd**2*r*s + 72*D1**2*K*fd**2*r + 56*D1**2*K*fd**2*s + 140*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) - 2*s + 1) + D1**2*bdd1*(f**2*(4*r*(56*s - 23) + 420*s**2 - 378*s + 123) + 7*f*(24*K*r**2 + 4*r*(6*K*s - 3*K + 8*s - 7) + 50*s**2 - 78*s + 31) + 280*g2*s*(1 - 2*r)) - 120*D1**2*f**2*fd*r**2 - 432*D1**2*f**2*fd*r*s + 272*D1**2*f**2*fd*r - 378*D1**2*f**2*fd*s**2 + 522*D1**2*f**2*fd*s - 229*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 432*D1**2*f**2*fdd*r*s - 232*D1**2*f**2*fdd*r + 378*D1**2*f**2*fdd*s**2 - 522*D1**2*f**2*fdd*s + 209*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 864*D1**2*f*fd**2*r*s - 464*D1**2*f*fd**2*r + 756*D1**2*f*fd**2*s**2 - 1044*D1**2*f*fd**2*s + 318*D1**2*f*fd**2 - 144*D1**2*f*fd*r**2 - 192*D1**2*f*fd*r*s + 144*D1**2*f*fd*r - 154*D1**2*f*fd*s**2 + 96*D1**2*f*fd*s - 72*D1**2*f*fd + 72*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*r + 154*D1**2*f*fdd*s**2 - 132*D1**2*f*fdd*s + 36*D1**2*f*fdd + 336*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r - 168*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r + 72*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 72*D1**2*fd**2*r + 154*D1**2*fd**2*s**2 - 132*D1**2*fd**2*s + 336*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s - 672*D1**2*fd*g2*r - 56*D1**2*fd*g2*s + 336*D1**2*fd*g2 - 336*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 504*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s - 168*D1**2*fd*gd2 - 168*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s + 336*D1**2*fdd*g2*r + 168*D1**2*fdd*g2*s - 168*D1**2*fdd*g2 + 288*D1*Dd*K*f**2*r**2 + 224*D1*Dd*K*f**2*r*s - 256*D1*Dd*K*f**2*r - 56*D1*Dd*K*f**2*s + 72*D1*Dd*K*f**2 - 576*D1*Dd*K*f*fd*r**2 - 896*D1*Dd*K*f*fd*r*s + 656*D1*Dd*K*f*fd*r + 336*D1*Dd*K*f*fd*s - 184*D1*Dd*K*f*fd - 160*D1*Dd*f**3*r**2 - 576*D1*Dd*f**3*r*s + 368*D1*Dd*f**3*r - 504*D1*Dd*f**3*s**2 + 648*D1*Dd*f**3*s - 292*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 3456*D1*Dd*f**2*fd*r*s - 1912*D1*Dd*f**2*fd*r + 3024*D1*Dd*f**2*fd*s**2 - 4032*D1*Dd*f**2*fd*s + 1276*D1*Dd*f**2*fd - 288*D1*Dd*f**2*r**2 - 384*D1*Dd*f**2*r*s + 336*D1*Dd*f**2*r - 308*D1*Dd*f**2*s**2 + 404*D1*Dd*f**2*s - 226*D1*Dd*f**2 + 576*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 960*D1*Dd*f*fd*r + 1232*D1*Dd*f*fd*s**2 - 1408*D1*Dd*f*fd*s + 336*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 784*D1*Dd*f*g2*r - 56*D1*Dd*f*g2*s + 336*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1344*D1*Dd*f*gd2*r + 168*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 2016*D1*Dd*fd*g2*r + 840*D1*Dd*fd*g2*s - 672*D1*Dd*fd*g2 - 144*D1*Ddd*K*f**2*r**2 - 224*D1*Ddd*K*f**2*r*s + 184*D1*Ddd*K*f**2*r + 56*D1*Ddd*K*f**2*s - 36*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r**2 + 576*D1*Ddd*f**3*r*s - 328*D1*Ddd*f**3*r + 504*D1*Ddd*f**3*s**2 - 648*D1*Ddd*f**3*s + 272*D1*Ddd*f**3 + 144*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 336*D1*Ddd*f**2*r + 308*D1*Ddd*f**2*s**2 - 440*D1*Ddd*f**2*s + 190*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 672*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 + D1*bd1*(-D1*(f**2*(32*r*(7*s - 4) + 420*s**2 - 378*s + 141) - 7*f*(-48*K*r**2 + 2*fd*(32*r*(2*s - 1) + 120*s**2 - 136*s + 27) - 4*r*(2*K*s - K + 6*s - 9) - 50*s**2 + 66*s - 37) - 14*fd*(6*K*(4*r**2 + r*(4*s - 5) - 2*s + 1) + r*(32*s - 2) + 50*s**2 - 27*s - 6) + 280*g2*s*(2*r - 1) + 280*gd2*r*(4*s - 2) - 280*gd2*s + 280*gd2) + 4*Dd*(f**2*(4*r*(112*s - 51) + 840*s**2 - 854*s + 212) + 7*f*(K*(48*r**2 + 48*r*s - 36*r - 6*s + 3) + 64*r*s - 44*r + 100*s**2 - 136*s + 46) - 140*g2*(r*(8*s - 2) - 3*s + 1))) - 432*Dd**2*K*f**2*r**2 - 672*Dd**2*K*f**2*r*s + 552*Dd**2*K*f**2*r + 168*Dd**2*K*f**2*s - 112*Dd**2*K*f**2 + 240*Dd**2*f**3*r**2 + 1728*Dd**2*f**3*r*s - 984*Dd**2*f**3*r + 1512*Dd**2*f**3*s**2 - 1944*Dd**2*f**3*s + 540*Dd**2*f**3 + 432*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 1008*Dd**2*f**2*r + 924*Dd**2*f**2*s**2 - 1320*Dd**2*f**2*s + 418*Dd**2*f**2 - 2016*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 2016*Dd**2*f*g2*r + 504*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(105*d**2*k1*k3**2) - 4*D1**2*Pk1*Pk3*ct*st**4*(D1*f*s*(-14*D1*bd1**2*s - D1*bdd1*f*s + 2*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*f*(2 - 4*s))) + 7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(fd*(4*s**2 - 4*s + 2) + fdd*(-2*s**2 + 2*s - 1) + s**2*(28*bd1 - 14*bdd1)) - 2*fd*s*(14*bd1 + fd)*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(14*bd1*s + fd*(2*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(35*d**2*k1*k2) + D1**2*Pk1*Pk3*ct*st**2*(-D1*f*(434*D1*bd1**2*s**2 + D1*bdd1*f*s*(r*(48 - 96*C) + 53*s) + bd1*(D1*(f*s*(r*(80*C - 40) - 71*s) + fd*(r*(48 - 96*C)*(4*s - 1) + 2*s*(48*C + 106*s - 77))) - 4*Dd*f*(r*(48*C - 24)*(4*s - 1) + s*(-24*C - 106*s + 65)))) + 7*b1**2*(D1**2*(37*fd - 31*fdd)*(s - 1)**2 + 2*D1*(37*Dd*f*(2*s**2 - 2*s + 1) - 62*Dd*fd*(2*s**2 - 3*s + 1) - 31*Ddd*f*(2*s**2 - 2*s + 1)) - 62*Dd**2*f*(6*s**2 - 6*s + 1)) - b1*(D1**2*(f*(fd*(-80*C*s + r*(80*C - 40)*(2*s - 1) - 142*s**2 + 182*s - 71) + fdd*(96*C*s - r*(96*C - 48)*(2*s - 1) + 106*s**2 - 154*s + 53) + s**2*(-518*bd1 + 434*bdd1)) + 2*fd*(434*bd1*s*(s - 1) + fd*(-48*C*(2*r*s - r - s + 1) + 48*r*s - 24*r + 53*s**2 - 77*s + 24))) + 2*D1*f*(Dd*(f*(-40*C*s + r*(80*C - 40)*(2*s - 1) - 142*s**2 + 162*s - 71) + (4*s - 2)*(434*bd1*s + fd*(-192*C*r + 72*C + 96*r + 106*s - 89))) + Ddd*f*(48*C*s - r*(96*C - 48)*(2*s - 1) + 106*s**2 - 130*s + 53)) + 2*Dd**2*f**2*(-48*C*(6*r*(2*s - 1) - 3*s + 2) + 144*r*(2*s - 1) + 318*s**2 - 390*s + 101)))/(105*d**2*k1*k2) + D1**2*Pk1*Pk3*ct*(D1*f*(50*D1*bd1**2*s**2 + D1*bdd1*f*s*(r*(8 - 16*C) + 11*s) + bd1*(D1*(f*s*(r*(16*C - 8) - 11*s) + fd*(r*(8 - 16*C)*(4*s - 1) + 2*s*(8*C + 22*s - 15))) - 4*Dd*f*(r*(8*C - 4)*(4*s - 1) + s*(-4*C - 22*s + 13)))) - 25*b1**2*(D1**2*(fd - fdd)*(s - 1)**2 + 2*D1*(Dd*(2*f*s**2 - 2*f*s + f - 4*fd*s**2 + 6*fd*s - 2*fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(fd*(-16*C*s + r*(16*C - 8)*(2*s - 1) - 22*s**2 + 30*s - 11) + fdd*(16*C*s - r*(16*C - 8)*(2*s - 1) + 22*s**2 - 30*s + 11) + s**2*(-50*bd1 + 50*bdd1)) + 2*fd*(50*bd1*s*(s - 1) + fd*(8*C*(-2*r*s + r + s - 1) + 8*r*s - 4*r + 11*s**2 - 15*s + 4))) + 2*D1*f*(Dd*(f*(-8*C*s + r*(16*C - 8)*(2*s - 1) - 22*s**2 + 26*s - 11) + (4*s - 2)*(50*bd1*s + fd*(-32*C*r + 12*C + 16*r + 22*s - 17))) + Ddd*f*(8*C*s - r*(16*C - 8)*(2*s - 1) + 22*s**2 - 26*s + 11)) + 2*Dd**2*f**2*(-8*C*(6*r*(2*s - 1) - 3*s + 2) + 24*r*(2*s - 1) + 66*s**2 - 78*s + 19)))/(15*d**2*k1*k2) + D1**2*Pk1*Pk3*ct*k2**3*st**4*(114*D1**2*b1*f*fd*r**2 - 78*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*fd**2*r**2 - 39*D1**2*bdd1*f**2*(r - 1)**2 + 21*D1**2*f**2*fd*r**2 - 14*D1**2*f**2*fd*r + 7*D1**2*f**2*fd + 39*D1**2*f**2*fdd*r**2 - 26*D1**2*f**2*fdd*r + 13*D1**2*f**2*fdd + 78*D1**2*f*fd**2*r**2 - 52*D1**2*f*fd**2*r + 228*D1*Dd*b1*f**2*r**2 - 114*D1*Dd*b1*f**2*r + 57*D1*Dd*b1*f**2 - 624*D1*Dd*b1*f*fd*r**2 + 156*D1*Dd*b1*f*fd*r + 28*D1*Dd*f**3*r**2 - 14*D1*Dd*f**3*r + 7*D1*Dd*f**3 + 312*D1*Dd*f**2*fd*r**2 - 182*D1*Dd*f**2*fd*r + 26*D1*Dd*f**2*fd - 156*D1*Ddd*b1*f**2*r**2 + 78*D1*Ddd*b1*f**2*r - 39*D1*Ddd*b1*f**2 + 52*D1*Ddd*f**3*r**2 - 26*D1*Ddd*f**3*r + 13*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(19*D1*f*(r - 1) - 52*D1*fd*r + 26*Dd*f*(1 - 4*r)) - 468*Dd**2*b1*f**2*r**2 + 234*Dd**2*b1*f**2*r + 156*Dd**2*f**3*r**2 - 78*Dd**2*f**3*r)/(105*d**2*k1**3*k3**2) + D1**2*Pk1*Pk3*ct*k2**3*st**2*(D1*f*r*(-2*D1*bd1**2*(54*f + 49)*(r - 1) + D1*bdd1*f*r*(7 - 6*f) + bd1*(3*D1*f*r*(10*f + 7) - 2*D1*fd*(6*f*(3*r - 1) - 14*r + 7) - 2*Dd*f*(6*f - 7)*(4*r - 1))) + b1**2*(D1**2*r**2*(-108*fd**2 + fd*(132*f + 63) - fdd*(108*f + 49)) + D1*(Dd*(66*f**2*(4*r**2 - 2*r + 1) - 9*f*(r**2*(96*fd - 28) + r*(14 - 24*fd) - 7) + 98*fd*r*(1 - 4*r)) - Ddd*f*(54*f + 49)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(54*f + 49)*(2*r - 1)) + b1*(-D1**2*bdd1*f*(54*f + 49)*(2*r**2 - 2*r + 1) + 90*D1**2*f**2*fd*r**2 - 60*D1**2*f**2*fd*r + 30*D1**2*f**2*fd - 18*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r - 6*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r**2 + 24*D1**2*f*fd**2*r + 42*D1**2*f*fd*r**2 - 42*D1**2*f*fd*r + 21*D1**2*f*fd + 14*D1**2*f*fdd*r**2 - 14*D1**2*f*fdd*r + 7*D1**2*f*fdd + 14*D1**2*fd**2*r**2 - 14*D1**2*fd**2*r + 120*D1*Dd*f**3*r**2 - 60*D1*Dd*f**3*r + 30*D1*Dd*f**3 - 144*D1*Dd*f**2*fd*r**2 + 84*D1*Dd*f**2*fd*r - 12*D1*Dd*f**2*fd + 84*D1*Dd*f**2*r**2 - 42*D1*Dd*f**2*r + 21*D1*Dd*f**2 + 112*D1*Dd*f*fd*r**2 - 84*D1*Dd*f*fd*r + 14*D1*Dd*f*fd - 24*D1*Ddd*f**3*r**2 + 12*D1*Ddd*f**3*r - 6*D1*Ddd*f**3 + 28*D1*Ddd*f**2*r**2 - 14*D1*Ddd*f**2*r + 7*D1*Ddd*f**2 + D1*bd1*(D1*(66*f**2*(2*r**2 - 2*r + 1) - 9*f*(r**2*(48*fd - 14) + r*(14 - 24*fd) - 7) + 98*fd*r*(1 - 2*r)) - 2*Dd*f*(54*f + 49)*(8*r**2 - 6*r + 1)) - 72*Dd**2*f**3*r**2 + 36*Dd**2*f**3*r + 84*Dd**2*f**2*r**2 - 42*Dd**2*f**2*r))/(105*d**2*k1**3*k3**2) + D1**2*Pk1*Pk3*ct*k2*st**2*(D1*f*r*(-14*D1*bd1**2*(r - 1) + D1*bdd1*f*r + bd1*(3*D1*f*r + D1*fd*(4*r - 2) + 2*Dd*f*(4*r - 1))) + b1**2*(D1**2*r**2*(9*fd - 7*fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 14*Dd*fd*r*(1 - 4*r) - 7*Ddd*f*(4*r**2 - 2*r + 1)) + 42*Dd**2*f*r*(1 - 2*r)) + b1*(-7*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 6*D1**2*f*fd*r**2 - 6*D1**2*f*fd*r + 3*D1**2*f*fd + 2*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r + D1**2*f*fdd + 2*D1**2*fd**2*r**2 - 2*D1**2*fd**2*r + 12*D1*Dd*f**2*r**2 - 6*D1*Dd*f**2*r + 3*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 - 12*D1*Dd*f*fd*r + 2*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 - 2*D1*Ddd*f**2*r + D1*Ddd*f**2 + D1*bd1*(9*D1*f*(2*r**2 - 2*r + 1) + 14*D1*fd*r*(1 - 2*r) - 14*Dd*f*(8*r**2 - 6*r + 1)) + 12*Dd**2*f**2*r**2 - 6*Dd**2*f**2*r))/(15*d**2*k1**3) - D1**2*Pk1*Pk3*ct*k2*(2*D1**2*bd1**2*f*r**2*(9*f + 7) + 2*D1*b1*r*(7*D1*bd1**2*(3*f + 5)*(3*r - 2) + D1*bdd1*f*r*(9*f + 7) + bd1*(3*D1*f*r*(f + 7) + 2*D1*fd*(18*f*r - 9*f + 7*r - 7) + 2*Dd*f*(9*f + 7)*(4*r - 1))) - 7*b1**3*(D1**2*r**2*(fd - 3*fdd) + D1*Dd*(f*(4*r**2 - 2*r + 1) - r**2*(24*fd + 20) + r*(6*fd + 10) - 5) - D1*Ddd*(3*f + 5)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(3*f + 5)*(2*r - 1)) + b1**2*(7*D1**2*bdd1*(3*f + 5)*(3*r**2 - 2*r + 1) + 6*D1**2*f*fd*r**2 - 6*D1**2*f*fd*r + 3*D1**2*f*fd + 18*D1**2*f*fdd*r**2 - 18*D1**2*f*fdd*r + 9*D1**2*f*fdd + 18*D1**2*fd**2*r**2 - 18*D1**2*fd**2*r + 21*D1**2*fd*r**2 - 42*D1**2*fd*r + 21*D1**2*fd + 7*D1**2*fdd*r**2 - 14*D1**2*fdd*r + 7*D1**2*fdd + 12*D1*Dd*f**2*r**2 - 6*D1*Dd*f**2*r + 3*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 - 108*D1*Dd*f*fd*r + 18*D1*Dd*f*fd + 84*D1*Dd*f*r**2 - 42*D1*Dd*f*r + 21*D1*Dd*f + 56*D1*Dd*fd*r**2 - 70*D1*Dd*fd*r + 14*D1*Dd*fd + 36*D1*Ddd*f**2*r**2 - 18*D1*Ddd*f**2*r + 9*D1*Ddd*f**2 + 28*D1*Ddd*f*r**2 - 14*D1*Ddd*f*r + 7*D1*Ddd*f - 7*D1*bd1*(D1*(f*(3*r**2 - 2*r + 1) - r**2*(18*fd + 15) + r*(6*fd + 10) - 5) - 2*Dd*(3*f + 5)*(12*r**2 - 7*r + 1)) + 108*Dd**2*f**2*r**2 - 54*Dd**2*f**2*r + 84*Dd**2*f*r**2 - 42*Dd**2*f*r))/(105*d**2*k1**3) + 4*D1**2*Pk1*Pk3*f*k2**6*st**6*(165*D1**2*b1*f*fd*r**2 + 165*D1**2*b1*f*fd*r*s - 110*D1**2*b1*f*fd*r - 231*D1**2*b1*f*fdd*r**2 - 231*D1**2*b1*f*fdd*r*s + 154*D1**2*b1*f*fdd*r - 462*D1**2*b1*fd**2*r**2 - 462*D1**2*b1*fd**2*r*s + 308*D1**2*b1*fd**2*r - 77*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 36*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 36*D1**2*f**2*fd*r - 9*D1**2*f**2*fd*s + 9*D1**2*f**2*fd - 84*D1**2*f**2*fdd*r**2 - 84*D1**2*f**2*fdd*r*s + 84*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s - 21*D1**2*f**2*fdd - 252*D1**2*f*fd**2*r**2 - 252*D1**2*f*fd**2*r*s + 252*D1**2*f*fd**2*r + 63*D1**2*f*fd**2*s - 42*D1**2*f*fd**2 + 220*D1*Dd*b1*f**2*r**2 + 220*D1*Dd*b1*f**2*r*s - 220*D1*Dd*b1*f**2*r - 55*D1*Dd*b1*f**2*s + 55*D1*Dd*b1*f**2 - 1848*D1*Dd*b1*f*fd*r**2 - 1848*D1*Dd*b1*f*fd*r*s + 1540*D1*Dd*b1*f*fd*r + 231*D1*Dd*b1*f*fd*s - 154*D1*Dd*b1*f*fd + 36*D1*Dd*f**3*r**2 + 36*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r - 9*D1*Dd*f**3*s + 9*D1*Dd*f**3 - 672*D1*Dd*f**2*fd*r**2 - 672*D1*Dd*f**2*fd*r*s + 672*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s - 126*D1*Dd*f**2*fd - 308*D1*Ddd*b1*f**2*r**2 - 308*D1*Ddd*b1*f**2*r*s + 308*D1*Ddd*b1*f**2*r + 77*D1*Ddd*b1*f**2*s - 77*D1*Ddd*b1*f**2 - 84*D1*Ddd*f**3*r**2 - 84*D1*Ddd*f**3*r*s + 84*D1*Ddd*f**3*r + 21*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 + 11*D1*bd1*f*(D1*(5*f*(r - 1)*(r + s - 1) - 7*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 7*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 924*Dd**2*b1*f**2*r**2 - 924*Dd**2*b1*f**2*r*s + 924*Dd**2*b1*f**2*r + 231*Dd**2*b1*f**2*s - 154*Dd**2*b1*f**2 - 252*Dd**2*f**3*r**2 - 252*Dd**2*f**3*r*s + 252*Dd**2*f**3*r + 63*Dd**2*f**3*s - 42*Dd**2*f**3)/(693*d**2*k1**2*k3**6) + D1**2*Pk1*Pk3*k1**6*st**2*(8*C - 4)*(6*D1**2*b1*f*fd*r**2 + 12*D1**2*b1*f*fd*r*s - 6*D1**2*b1*f*fd*r + 6*D1**2*b1*f*fd*s**2 - 6*D1**2*b1*f*fd*s + 3*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(r + s - 1)**2 - 3*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s**2 + 4*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 + 12*D1*Dd*b1*f**2*r**2 + 24*D1*Dd*b1*f**2*r*s - 18*D1*Dd*b1*f**2*r + 12*D1*Dd*b1*f**2*s**2 - 18*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 6*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 170*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 170*D1*Dd*f**2*fd*s + 60*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + 6*D1*fd*(2*r + 2*s - 1) + 6*Dd*f*(4*r + 4*s - 3)) + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 30*Dd**2*f**3)/(105*d**2*k3**8) - 4*D1**2*Pk1*Pk3*k1**6*(7*D1**2*K*b1**2*fd*r**2 + 14*D1**2*K*b1**2*fd*r*s + 7*D1**2*K*b1**2*fd*s**2 - 21*D1**2*K*b1**2*fdd*r**2 - 42*D1**2*K*b1**2*fdd*r*s - 21*D1**2*K*b1**2*fdd*s**2 + 18*D1**2*K*b1*f*fd*r**2 + 36*D1**2*K*b1*f*fd*r*s - 18*D1**2*K*b1*f*fd*r + 18*D1**2*K*b1*f*fd*s**2 - 18*D1**2*K*b1*f*fd*s + 9*D1**2*K*b1*f*fd - 30*D1**2*K*b1*f*fdd*r**2 - 60*D1**2*K*b1*f*fdd*r*s + 30*D1**2*K*b1*f*fdd*r - 30*D1**2*K*b1*f*fdd*s**2 + 30*D1**2*K*b1*f*fdd*s - 15*D1**2*K*b1*f*fdd - 30*D1**2*K*b1*fd**2*r**2 - 60*D1**2*K*b1*fd**2*r*s + 30*D1**2*K*b1*fd**2*r - 30*D1**2*K*b1*fd**2*s**2 + 30*D1**2*K*b1*fd**2*s - 42*D1**2*K*bd1**2*f*(r + s - 1)**2 - 14*D1**2*b1*f*gd2*r**2 - 28*D1**2*b1*f*gd2*r*s + 28*D1**2*b1*f*gd2*r - 14*D1**2*b1*f*gd2*s**2 + 28*D1**2*b1*f*gd2*s - 14*D1**2*b1*f*gd2 + 42*D1**2*b1*f*gdd2*r**2 + 84*D1**2*b1*f*gdd2*r*s - 84*D1**2*b1*f*gdd2*r + 42*D1**2*b1*f*gdd2*s**2 - 84*D1**2*b1*f*gdd2*s + 42*D1**2*b1*f*gdd2 - 14*D1**2*b1*fd*g2*r**2 - 28*D1**2*b1*fd*g2*r*s - 14*D1**2*b1*fd*g2*s**2 + 84*D1**2*b1*fd*gd2*r**2 + 168*D1**2*b1*fd*gd2*r*s - 84*D1**2*b1*fd*gd2*r + 84*D1**2*b1*fd*gd2*s**2 - 84*D1**2*b1*fd*gd2*s + 42*D1**2*b1*fdd*g2*r**2 + 84*D1**2*b1*fdd*g2*r*s + 42*D1**2*b1*fdd*g2*s**2 - 3*D1**2*bdd1*f*(r + s - 1)**2*(14*K*b1 + 5*K*f - 14*g2) - 18*D1**2*f**2*gd2*r**2 - 36*D1**2*f**2*gd2*r*s + 36*D1**2*f**2*gd2*r - 18*D1**2*f**2*gd2*s**2 + 36*D1**2*f**2*gd2*s - 18*D1**2*f**2*gd2 + 30*D1**2*f**2*gdd2*r**2 + 60*D1**2*f**2*gdd2*r*s - 60*D1**2*f**2*gdd2*r + 30*D1**2*f**2*gdd2*s**2 - 60*D1**2*f**2*gdd2*s + 30*D1**2*f**2*gdd2 - 36*D1**2*f*fd*g2*r**2 - 72*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r - 36*D1**2*f*fd*g2*s**2 + 36*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 + 120*D1**2*f*fd*gd2*r**2 + 240*D1**2*f*fd*gd2*r*s - 180*D1**2*f*fd*gd2*r + 120*D1**2*f*fd*gd2*s**2 - 180*D1**2*f*fd*gd2*s + 60*D1**2*f*fd*gd2 + 60*D1**2*f*fdd*g2*r**2 + 120*D1**2*f*fdd*g2*r*s - 60*D1**2*f*fdd*g2*r + 60*D1**2*f*fdd*g2*s**2 - 60*D1**2*f*fdd*g2*s + 30*D1**2*f*fdd*g2 + 60*D1**2*fd**2*g2*r**2 + 120*D1**2*fd**2*g2*r*s - 60*D1**2*fd**2*g2*r + 60*D1**2*fd**2*g2*s**2 - 60*D1**2*fd**2*g2*s + 28*D1*Dd*K*b1**2*f*r**2 + 56*D1*Dd*K*b1**2*f*r*s - 42*D1*Dd*K*b1**2*f*r + 28*D1*Dd*K*b1**2*f*s**2 - 42*D1*Dd*K*b1**2*f*s + 21*D1*Dd*K*b1**2*f - 168*D1*Dd*K*b1**2*fd*r**2 - 336*D1*Dd*K*b1**2*fd*r*s + 126*D1*Dd*K*b1**2*fd*r - 168*D1*Dd*K*b1**2*fd*s**2 + 126*D1*Dd*K*b1**2*fd*s + 36*D1*Dd*K*b1*f**2*r**2 + 72*D1*Dd*K*b1*f**2*r*s - 54*D1*Dd*K*b1*f**2*r + 36*D1*Dd*K*b1*f**2*s**2 - 54*D1*Dd*K*b1*f**2*s + 27*D1*Dd*K*b1*f**2 - 240*D1*Dd*K*b1*f*fd*r**2 - 480*D1*Dd*K*b1*f*fd*r*s + 300*D1*Dd*K*b1*f*fd*r - 240*D1*Dd*K*b1*f*fd*s**2 + 300*D1*Dd*K*b1*f*fd*s - 90*D1*Dd*K*b1*f*fd - 56*D1*Dd*b1*f*g2*r**2 - 112*D1*Dd*b1*f*g2*r*s + 84*D1*Dd*b1*f*g2*r - 56*D1*Dd*b1*f*g2*s**2 + 84*D1*Dd*b1*f*g2*s - 42*D1*Dd*b1*f*g2 + 336*D1*Dd*b1*f*gd2*r**2 + 672*D1*Dd*b1*f*gd2*r*s - 588*D1*Dd*b1*f*gd2*r + 336*D1*Dd*b1*f*gd2*s**2 - 588*D1*Dd*b1*f*gd2*s + 252*D1*Dd*b1*f*gd2 + 336*D1*Dd*b1*fd*g2*r**2 + 672*D1*Dd*b1*fd*g2*r*s - 252*D1*Dd*b1*fd*g2*r + 336*D1*Dd*b1*fd*g2*s**2 - 252*D1*Dd*b1*fd*g2*s - 72*D1*Dd*f**2*g2*r**2 - 144*D1*Dd*f**2*g2*r*s + 108*D1*Dd*f**2*g2*r - 72*D1*Dd*f**2*g2*s**2 + 108*D1*Dd*f**2*g2*s - 54*D1*Dd*f**2*g2 + 240*D1*Dd*f**2*gd2*r**2 + 480*D1*Dd*f**2*gd2*r*s - 420*D1*Dd*f**2*gd2*r + 240*D1*Dd*f**2*gd2*s**2 - 420*D1*Dd*f**2*gd2*s + 180*D1*Dd*f**2*gd2 + 480*D1*Dd*f*fd*g2*r**2 + 960*D1*Dd*f*fd*g2*r*s - 600*D1*Dd*f*fd*g2*r + 480*D1*Dd*f*fd*g2*s**2 - 600*D1*Dd*f*fd*g2*s + 180*D1*Dd*f*fd*g2 - 84*D1*Ddd*K*b1**2*f*r**2 - 168*D1*Ddd*K*b1**2*f*r*s + 126*D1*Ddd*K*b1**2*f*r - 84*D1*Ddd*K*b1**2*f*s**2 + 126*D1*Ddd*K*b1**2*f*s - 63*D1*Ddd*K*b1**2*f - 60*D1*Ddd*K*b1*f**2*r**2 - 120*D1*Ddd*K*b1*f**2*r*s + 90*D1*Ddd*K*b1*f**2*r - 60*D1*Ddd*K*b1*f**2*s**2 + 90*D1*Ddd*K*b1*f**2*s - 45*D1*Ddd*K*b1*f**2 + 168*D1*Ddd*b1*f*g2*r**2 + 336*D1*Ddd*b1*f*g2*r*s - 252*D1*Ddd*b1*f*g2*r + 168*D1*Ddd*b1*f*g2*s**2 - 252*D1*Ddd*b1*f*g2*s + 126*D1*Ddd*b1*f*g2 + 120*D1*Ddd*f**2*g2*r**2 + 240*D1*Ddd*f**2*g2*r*s - 180*D1*Ddd*f**2*g2*r + 120*D1*Ddd*f**2*g2*s**2 - 180*D1*Ddd*f**2*g2*s + 90*D1*Ddd*f**2*g2 + D1*bd1*(D1*(9*K*f**2*(r + s - 1) - 2*f*(-7*K*b1*(r + s - 1) + 15*K*fd*(2*r + 2*s - 1) + 7*g2*(r + s - 1) - 42*gd2*(r + s - 1)) + 84*fd*(r + s)*(-K*b1 + g2)) - 6*Dd*f*(4*r + 4*s - 3)*(14*K*b1 + 5*K*f - 14*g2))*(r + s - 1) - 252*Dd**2*K*b1**2*f*r**2 - 504*Dd**2*K*b1**2*f*r*s + 378*Dd**2*K*b1**2*f*r - 252*Dd**2*K*b1**2*f*s**2 + 378*Dd**2*K*b1**2*f*s - 126*Dd**2*K*b1**2*f - 180*Dd**2*K*b1*f**2*r**2 - 360*Dd**2*K*b1*f**2*r*s + 270*Dd**2*K*b1*f**2*r - 180*Dd**2*K*b1*f**2*s**2 + 270*Dd**2*K*b1*f**2*s - 90*Dd**2*K*b1*f**2 + 504*Dd**2*b1*f*g2*r**2 + 1008*Dd**2*b1*f*g2*r*s - 756*Dd**2*b1*f*g2*r + 504*Dd**2*b1*f*g2*s**2 - 756*Dd**2*b1*f*g2*s + 252*Dd**2*b1*f*g2 + 360*Dd**2*f**2*g2*r**2 + 720*Dd**2*f**2*g2*r*s - 540*Dd**2*f**2*g2*r + 360*Dd**2*f**2*g2*s**2 - 540*Dd**2*f**2*g2*s + 180*Dd**2*f**2*g2)/(35*d**2*k3**8) - D1**2*Pk1*Pk3*k1**4*k2**2*st**4*(24*C - 12)*(10*D1**2*b1*f*fd*r**2 + 20*D1**2*b1*f*fd*r*s - 10*D1**2*b1*f*fd*r + 10*D1**2*b1*f*fd*s**2 - 10*D1**2*b1*f*fd*s + 5*D1**2*b1*f*fd - 12*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 12*D1**2*b1*f*fdd*r - 12*D1**2*b1*f*fdd*s**2 + 12*D1**2*b1*f*fdd*s - 6*D1**2*b1*f*fdd - 12*D1**2*b1*fd**2*r**2 - 24*D1**2*b1*fd**2*r*s + 12*D1**2*b1*fd**2*r - 12*D1**2*b1*fd**2*s**2 + 12*D1**2*b1*fd**2*s - 6*D1**2*bdd1*f**2*(r + s - 1)**2 + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 6*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 8*D1**2*f**2*fdd*r - 6*D1**2*f**2*fdd*s**2 + 8*D1**2*f**2*fdd*s - 4*D1**2*f**2*fdd - 12*D1**2*f*fd**2*r**2 - 24*D1**2*f*fd**2*r*s + 16*D1**2*f*fd**2*r - 12*D1**2*f*fd**2*s**2 + 16*D1**2*f*fd**2*s - 4*D1**2*f*fd**2 + 20*D1*Dd*b1*f**2*r**2 + 40*D1*Dd*b1*f**2*r*s - 30*D1*Dd*b1*f**2*r + 20*D1*Dd*b1*f**2*s**2 - 30*D1*Dd*b1*f**2*s + 15*D1*Dd*b1*f**2 - 96*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 120*D1*Dd*b1*f*fd*r - 96*D1*Dd*b1*f*fd*s**2 + 120*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 - 48*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 68*D1*Dd*f**2*fd*r - 48*D1*Dd*f**2*fd*s**2 + 68*D1*Dd*f**2*fd*s - 24*D1*Dd*f**2*fd - 24*D1*Ddd*b1*f**2*r**2 - 48*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 24*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 8*D1*Ddd*f**3*r**2 - 16*D1*Ddd*f**3*r*s + 12*D1*Ddd*f**3*r - 8*D1*Ddd*f**3*s**2 + 12*D1*Ddd*f**3*s - 6*D1*Ddd*f**3 + D1*bd1*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*b1*f**2*r**2 - 144*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 72*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 36*Dd**2*b1*f**2 - 24*Dd**2*f**3*r**2 - 48*Dd**2*f**3*r*s + 36*Dd**2*f**3*r - 24*Dd**2*f**3*s**2 + 36*Dd**2*f**3*s - 12*Dd**2*f**3)/(35*d**2*k3**8) - 4*D1**2*Pk1*Pk3*k1**4*k2**2*st**2*(-594*C*D1**2*f**2*fd*r**2 - 1188*C*D1**2*f**2*fd*r*s + 792*C*D1**2*f**2*fd*r - 594*C*D1**2*f**2*fd*s**2 + 792*C*D1**2*f**2*fd*s - 396*C*D1**2*f**2*fd - 792*C*D1*Dd*f**3*r**2 - 1584*C*D1*Dd*f**3*r*s + 1188*C*D1*Dd*f**3*r - 792*C*D1*Dd*f**3*s**2 + 1188*C*D1*Dd*f**3*s - 594*C*D1*Dd*f**3 - 594*D1**2*K*bdd1*f**2*r**2 - 1188*D1**2*K*bdd1*f**2*r*s + 1188*D1**2*K*bdd1*f**2*r - 594*D1**2*K*bdd1*f**2*s**2 + 1188*D1**2*K*bdd1*f**2*s - 594*D1**2*K*bdd1*f**2 + 198*D1**2*bd1**2*f*(-14*K + 5*f)*(r + s - 1)**2 + 220*D1**2*bdd1*f**3*r**2 + 440*D1**2*bdd1*f**3*r*s - 440*D1**2*bdd1*f**3*r + 220*D1**2*bdd1*f**3*s**2 - 440*D1**2*bdd1*f**3*s + 220*D1**2*bdd1*f**3 + 2772*D1**2*bdd1*f*g2*r**2 + 5544*D1**2*bdd1*f*g2*r*s - 5544*D1**2*bdd1*f*g2*r + 2772*D1**2*bdd1*f*g2*s**2 - 5544*D1**2*bdd1*f*g2*s + 2772*D1**2*bdd1*f*g2 + 60*D1**2*f**3*fd*r**2 + 120*D1**2*f**3*fd*r*s - 90*D1**2*f**3*fd*r + 60*D1**2*f**3*fd*s**2 - 90*D1**2*f**3*fd*s + 45*D1**2*f**3*fd - 140*D1**2*f**3*fdd*r**2 - 280*D1**2*f**3*fdd*r*s + 210*D1**2*f**3*fdd*r - 140*D1**2*f**3*fdd*s**2 + 210*D1**2*f**3*fdd*s - 105*D1**2*f**3*fdd - 420*D1**2*f**2*fd**2*r**2 - 840*D1**2*f**2*fd**2*r*s + 630*D1**2*f**2*fd**2*r - 420*D1**2*f**2*fd**2*s**2 + 630*D1**2*f**2*fd**2*s - 210*D1**2*f**2*fd**2 + 297*D1**2*f**2*fd*r**2 + 594*D1**2*f**2*fd*r*s - 396*D1**2*f**2*fd*r + 297*D1**2*f**2*fd*s**2 - 396*D1**2*f**2*fd*s + 198*D1**2*f**2*fd - 1914*D1**2*f**2*gd2*r**2 - 3828*D1**2*f**2*gd2*r*s + 3828*D1**2*f**2*gd2*r - 1914*D1**2*f**2*gd2*s**2 + 3828*D1**2*f**2*gd2*s - 1914*D1**2*f**2*gd2 + 1188*D1**2*f**2*gdd2*r**2 + 2376*D1**2*f**2*gdd2*r*s - 2376*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 2376*D1**2*f**2*gdd2*s + 1188*D1**2*f**2*gdd2 - 3828*D1**2*f*fd*g2*r**2 - 7656*D1**2*f*fd*g2*r*s + 3828*D1**2*f*fd*g2*r - 3828*D1**2*f*fd*g2*s**2 + 3828*D1**2*f*fd*g2*s - 1914*D1**2*f*fd*g2 + 4752*D1**2*f*fd*gd2*r**2 + 9504*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2376*D1**2*f*fd*gd2 + 2376*D1**2*f*fdd*g2*r**2 + 4752*D1**2*f*fdd*g2*r*s - 2376*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 2376*D1**2*fd**2*g2*r**2 + 4752*D1**2*fd**2*g2*r*s - 2376*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 60*D1*Dd*f**4*r**2 + 120*D1*Dd*f**4*r*s - 90*D1*Dd*f**4*r + 60*D1*Dd*f**4*s**2 - 90*D1*Dd*f**4*s + 45*D1*Dd*f**4 - 1120*D1*Dd*f**3*fd*r**2 - 2240*D1*Dd*f**3*fd*r*s + 1680*D1*Dd*f**3*fd*r - 1120*D1*Dd*f**3*fd*s**2 + 1680*D1*Dd*f**3*fd*s - 630*D1*Dd*f**3*fd + 396*D1*Dd*f**3*r**2 + 792*D1*Dd*f**3*r*s - 594*D1*Dd*f**3*r + 396*D1*Dd*f**3*s**2 - 594*D1*Dd*f**3*s + 297*D1*Dd*f**3 - 7656*D1*Dd*f**2*g2*r**2 - 15312*D1*Dd*f**2*g2*r*s + 11484*D1*Dd*f**2*g2*r - 7656*D1*Dd*f**2*g2*s**2 + 11484*D1*Dd*f**2*g2*s - 5742*D1*Dd*f**2*g2 + 9504*D1*Dd*f**2*gd2*r**2 + 19008*D1*Dd*f**2*gd2*r*s - 16632*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 19008*D1*Dd*f*fd*g2*r**2 + 38016*D1*Dd*f*fd*g2*r*s - 23760*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 23760*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**4*r**2 - 280*D1*Ddd*f**4*r*s + 210*D1*Ddd*f**4*r - 140*D1*Ddd*f**4*s**2 + 210*D1*Ddd*f**4*s - 105*D1*Ddd*f**4 + 4752*D1*Ddd*f**2*g2*r**2 + 9504*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(22*f**3*(r + s - 1) + f**2*(42*C*(r + s - 1) - 87*K*r - 87*K*s + 87*K + 54*b1*(r + s - 1) - 120*fd*r - 120*fd*s + 80*fd - 21*r - 21*s + 21) - 6*f*(49*K*b1*(r + s - 1) - 18*K*fd*(2*r + 2*s - 1) + 30*b1*fd*(2*r + 2*s - 1) - 49*g2*(r + s - 1) + 84*gd2*(r + s - 1)) - 504*fd*(r + s)*(-K*b1 + g2)) - 4*Dd*f*(4*r + 4*s - 3)*(-27*K*f + 9*b1*(-14*K + 5*f) + 10*f**2 + 126*g2))*(r + s - 1) - 420*Dd**2*f**4*r**2 - 840*Dd**2*f**4*r*s + 630*Dd**2*f**4*r - 420*Dd**2*f**4*s**2 + 630*Dd**2*f**4*s - 210*Dd**2*f**4 + 14256*Dd**2*f**2*g2*r**2 + 28512*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 7128*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(3*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(49*K*fd*(r + s) - 42*K*fdd*(r + s) + 30*fd**2*(r + s - 1))) + D1*(Dd*(84*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(49*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 30*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 3*Ddd*f*(-14*K + 5*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-14*K + 5*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(18*D1**2*bdd1*f*(-14*K + 5*f)*(r + s - 1)**2 + D1**2*(-2*f**2*(11*fd - 10*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-54*K*fdd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 3*fd*(14*C - 29*K - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 294*gd2*(r + s - 1)**2 + 252*gdd2*(r + s - 1)**2) + (-6*r - 6*s)*(18*K*fd**2*(r + s - 1) + 49*fd*g2*(r + s) - 84*fd*gd2*(r + s - 1) - 42*fdd*g2*(r + s))) + D1*(Dd*(-22*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-42*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 40*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + (87*K + 21)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 6*f*(49*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (-3*K*fd*(2*r + 2*s - 1) + 14*gd2*(r + s - 1))*(-24*r - 24*s + 18)) + 504*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 2*Ddd*f*(-27*K*f + 10*f**2 + 126*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f*(-27*K*f + 10*f**2 + 126*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(1155*d**2*k3**8) - D1**2*Pk1*Pk3*k1**4*st**4*(16*C - 8)*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(35*d**2*k3**6) + 2*D1**2*Pk1*Pk3*k1**4*st**2*(42*b1**2*(2*C - 1)*(D1**2*(3*fd + fdd)*(r + s - 1)**2 + D1*(Dd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(68*C*D1**2*f*fd*r**2 + 584*C*D1**2*f*fd*r*s - 300*C*D1**2*f*fd*r + 516*C*D1**2*f*fd*s**2 - 524*C*D1**2*f*fd*s + 262*C*D1**2*f*fd - 188*C*D1**2*f*fdd*r**2 - 712*C*D1**2*f*fdd*r*s + 332*C*D1**2*f*fdd*r - 524*C*D1**2*f*fdd*s**2 + 500*C*D1**2*f*fdd*s - 250*C*D1**2*f*fdd - 188*C*D1**2*fd**2*r**2 - 712*C*D1**2*fd**2*r*s + 332*C*D1**2*fd**2*r - 524*C*D1**2*fd**2*s**2 + 500*C*D1**2*fd**2*s + 24*C*D1**2*fd**2 + 136*C*D1*Dd*f**2*r**2 + 1168*C*D1*Dd*f**2*r*s - 652*C*D1*Dd*f**2*r + 1032*C*D1*Dd*f**2*s**2 - 1324*C*D1*Dd*f**2*s + 550*C*D1*Dd*f**2 - 1504*C*D1*Dd*f*fd*r**2 - 5696*C*D1*Dd*f*fd*r*s + 3128*C*D1*Dd*f*fd*r - 4192*C*D1*Dd*f*fd*s**2 + 4808*C*D1*Dd*f*fd*s - 1332*C*D1*Dd*f*fd - 376*C*D1*Ddd*f**2*r**2 - 1424*C*D1*Ddd*f**2*r*s + 900*C*D1*Ddd*f**2*r - 1048*C*D1*Ddd*f**2*s**2 + 1404*C*D1*Ddd*f**2*s - 618*C*D1*Ddd*f**2 - 1128*C*Dd**2*f**2*r**2 - 4272*C*Dd**2*f**2*r*s + 2700*C*Dd**2*f**2*r - 3144*C*Dd**2*f**2*s**2 + 4212*C*Dd**2*f**2*s - 1236*C*Dd**2*f**2 + 14*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 34*D1**2*f*fd*r**2 - 288*D1**2*f*fd*r*s + 148*D1**2*f*fd*r - 254*D1**2*f*fd*s**2 + 258*D1**2*f*fd*s - 129*D1**2*f*fd + 94*D1**2*f*fdd*r**2 + 368*D1**2*f*fdd*r*s - 172*D1**2*f*fdd*r + 274*D1**2*f*fdd*s**2 - 262*D1**2*f*fdd*s + 131*D1**2*f*fdd + 94*D1**2*fd**2*r**2 + 368*D1**2*fd**2*r*s - 172*D1**2*fd**2*r + 274*D1**2*fd**2*s**2 - 262*D1**2*fd**2*s - 12*D1**2*fd**2 - 68*D1*Dd*f**2*r**2 - 576*D1*Dd*f**2*r*s + 322*D1*Dd*f**2*r - 508*D1*Dd*f**2*s**2 + 652*D1*Dd*f**2*s - 271*D1*Dd*f**2 + 752*D1*Dd*f*fd*r**2 + 2944*D1*Dd*f*fd*r*s - 1612*D1*Dd*f*fd*r + 2192*D1*Dd*f*fd*s**2 - 2512*D1*Dd*f*fd*s + 696*D1*Dd*f*fd + 188*D1*Ddd*f**2*r**2 + 736*D1*Ddd*f**2*r*s - 462*D1*Ddd*f**2*r + 548*D1*Ddd*f**2*s**2 - 732*D1*Ddd*f**2*s + 321*D1*Ddd*f**2 + 14*D1*bd1*(2*C - 1)*(D1*(3*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 564*Dd**2*f**2*r**2 + 2208*Dd**2*f**2*r*s - 1386*Dd**2*f**2*r + 1644*Dd**2*f**2*s**2 - 2196*Dd**2*f**2*s + 642*Dd**2*f**2) + f*(390*C*D1**2*f*fd*r**2 + 1452*C*D1**2*f*fd*r*s - 744*C*D1**2*f*fd*r + 1062*C*D1**2*f*fd*s**2 - 1192*C*D1**2*f*fd*s + 484*C*D1**2*f*fd - 546*C*D1**2*f*fdd*r**2 - 1644*C*D1**2*f*fdd*r*s + 912*C*D1**2*f*fdd*r - 1098*C*D1**2*f*fdd*s**2 + 1280*C*D1**2*f*fdd*s - 548*C*D1**2*f*fdd - 1092*C*D1**2*fd**2*r**2 - 3288*C*D1**2*fd**2*r*s + 1824*C*D1**2*fd**2*r - 2196*C*D1**2*fd**2*s**2 + 2560*C*D1**2*fd**2*s - 548*C*D1**2*fd**2 + 520*C*D1*Dd*f**2*r**2 + 1936*C*D1*Dd*f**2*r*s - 1228*C*D1*Dd*f**2*r + 1416*C*D1*Dd*f**2*s**2 - 1900*C*D1*Dd*f**2*s + 838*C*D1*Dd*f**2 - 4368*C*D1*Dd*f*fd*r**2 - 13152*C*D1*Dd*f*fd*r*s + 8028*C*D1*Dd*f*fd*r - 8784*C*D1*Dd*f*fd*s**2 + 11156*C*D1*Dd*f*fd*s - 3472*C*D1*Dd*f*fd - 728*C*D1*Ddd*f**2*r**2 - 2192*C*D1*Ddd*f**2*r*s + 1460*C*D1*Ddd*f**2*r - 1464*C*D1*Ddd*f**2*s**2 + 2012*C*D1*Ddd*f**2*s - 914*C*D1*Ddd*f**2 - 2184*C*Dd**2*f**2*r**2 - 6576*C*Dd**2*f**2*r*s + 4380*C*Dd**2*f**2*r - 4392*C*Dd**2*f**2*s**2 + 6036*C*Dd**2*f**2*s - 1828*C*Dd**2*f**2 + 84*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 3*D1**2*bdd1*f*(2*C*(47*r**2 + 2*r*(89*s - 53) + 131*s**2 - 190*s + 53) - 47*r**2 - 184*r*s + 106*r - 137*s**2 + 196*s - 53) - 195*D1**2*f*fd*r**2 - 732*D1**2*f*fd*r*s + 374*D1**2*f*fd*r - 537*D1**2*f*fd*s**2 + 602*D1**2*f*fd*s - 244*D1**2*f*fd + 273*D1**2*f*fdd*r**2 + 852*D1**2*f*fdd*r*s - 466*D1**2*f*fdd*r + 579*D1**2*f*fdd*s**2 - 670*D1**2*f*fdd*s + 284*D1**2*f*fdd + 546*D1**2*fd**2*r**2 + 1704*D1**2*fd**2*r*s - 932*D1**2*fd**2*r + 1158*D1**2*fd**2*s**2 - 1340*D1**2*fd**2*s + 284*D1**2*fd**2 - 260*D1*Dd*f**2*r**2 - 976*D1*Dd*f**2*r*s + 618*D1*Dd*f**2*r - 716*D1*Dd*f**2*s**2 + 960*D1*Dd*f**2*s - 423*D1*Dd*f**2 + 2184*D1*Dd*f*fd*r**2 + 6816*D1*Dd*f*fd*r*s - 4114*D1*Dd*f*fd*r + 4632*D1*Dd*f*fd*s**2 - 5848*D1*Dd*f*fd*s + 1806*D1*Dd*f*fd + 364*D1*Ddd*f**2*r**2 + 1136*D1*Ddd*f**2*r*s - 750*D1*Ddd*f**2*r + 772*D1*Ddd*f**2*s**2 - 1056*D1*Ddd*f**2*s + 477*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(C*(34*r**2 + 292*r*s - 60*r + 258*s**2 - 284*s + 30) - 17*r**2 - 144*r*s + 30*r - 127*s**2 + 140*s - 15) - 2*fd*(2*C*(94*r**2 + 356*r*s - 189*r + 262*s**2 - 315*s + 95) - 94*r**2 - 368*r*s + 192*r - 274*s**2 + 327*s - 98)) - 2*Dd*f*(2*C*(188*r**2 + 712*r*s - 437*r + 524*s**2 - 731*s + 243) - 188*r**2 - 736*r*s + 443*r - 548*s**2 + 758*s - 249)) + 1092*Dd**2*f**2*r**2 + 3408*Dd**2*f**2*r*s - 2250*Dd**2*f**2*r + 2316*Dd**2*f**2*s**2 - 3168*Dd**2*f**2*s + 954*Dd**2*f**2))/(315*d**2*k3**6) + 2*D1**2*Pk1*Pk3*k1**4*(-518*D1**2*K*bd1**2*f*r**2 - 1036*D1**2*K*bd1**2*f*r*s + 1120*D1**2*K*bd1**2*f*r - 518*D1**2*K*bd1**2*f*s**2 + 1120*D1**2*K*bd1**2*f*s - 602*D1**2*K*bd1**2*f + 165*D1**2*K*bd1*f**2*r**2 + 282*D1**2*K*bd1*f**2*r*s - 282*D1**2*K*bd1*f**2*r + 117*D1**2*K*bd1*f**2*s**2 - 234*D1**2*K*bd1*f**2*s + 117*D1**2*K*bd1*f**2 - 876*D1**2*K*bd1*f*fd*r**2 - 1656*D1**2*K*bd1*f*fd*r*s + 1266*D1**2*K*bd1*f*fd*r - 780*D1**2*K*bd1*f*fd*s**2 + 1194*D1**2*K*bd1*f*fd*s - 414*D1**2*K*bd1*f*fd - 219*D1**2*K*bdd1*f**2*r**2 - 414*D1**2*K*bdd1*f**2*r*s + 414*D1**2*K*bdd1*f**2*r - 195*D1**2*K*bdd1*f**2*s**2 + 390*D1**2*K*bdd1*f**2*s - 195*D1**2*K*bdd1*f**2 + 84*D1**2*bd1**2*f**2*r*s - 42*D1**2*bd1**2*f**2*r + 84*D1**2*bd1**2*f**2*s**2 - 126*D1**2*bd1**2*f**2*s + 42*D1**2*bd1**2*f**2 + 84*D1**2*bd1**2*f*r*s - 42*D1**2*bd1**2*f*r + 84*D1**2*bd1**2*f*s**2 - 126*D1**2*bd1**2*f*s + 42*D1**2*bd1**2*f - 280*D1**2*bd1**2*g2*r**2 - 560*D1**2*bd1**2*g2*r*s + 280*D1**2*bd1**2*g2*r - 280*D1**2*bd1**2*g2*s**2 + 280*D1**2*bd1**2*g2*s - 84*D1**2*bd1*bd2*f*r**2 - 168*D1**2*bd1*bd2*f*r*s + 168*D1**2*bd1*bd2*f*r - 84*D1**2*bd1*bd2*f*s**2 + 168*D1**2*bd1*bd2*f*s - 84*D1**2*bd1*bd2*f - 30*D1**2*bd1*f**3*r*s + 30*D1**2*bd1*f**3*r - 30*D1**2*bd1*f**3*s**2 + 60*D1**2*bd1*f**3*s - 30*D1**2*bd1*f**3 + 180*D1**2*bd1*f**2*fd*r*s - 120*D1**2*bd1*f**2*fd*r + 180*D1**2*bd1*f**2*fd*s**2 - 270*D1**2*bd1*f**2*fd*s + 90*D1**2*bd1*f**2*fd - 18*D1**2*bd1*f**2*r*s + 18*D1**2*bd1*f**2*r - 18*D1**2*bd1*f**2*s**2 + 36*D1**2*bd1*f**2*s - 18*D1**2*bd1*f**2 + 120*D1**2*bd1*f*fd*r*s - 60*D1**2*bd1*f*fd*r + 120*D1**2*bd1*f*fd*s**2 - 150*D1**2*bd1*f*fd*s + 30*D1**2*bd1*f*fd - 266*D1**2*bd1*f*g2*r**2 - 532*D1**2*bd1*f*g2*r*s + 588*D1**2*bd1*f*g2*r - 266*D1**2*bd1*f*g2*s**2 + 588*D1**2*bd1*f*g2*s - 294*D1**2*bd1*f*g2 + 1036*D1**2*bd1*f*gd2*r**2 + 2072*D1**2*bd1*f*gd2*r*s - 2240*D1**2*bd1*f*gd2*r + 1036*D1**2*bd1*f*gd2*s**2 - 2240*D1**2*bd1*f*gd2*s + 1204*D1**2*bd1*f*gd2 + 1036*D1**2*bd1*fd*g2*r**2 + 2072*D1**2*bd1*fd*g2*r*s - 1036*D1**2*bd1*fd*g2*r + 1036*D1**2*bd1*fd*g2*s**2 - 1036*D1**2*bd1*fd*g2*s + 18*D1**2*bd2*f**2*r**2 + 36*D1**2*bd2*f**2*r*s - 36*D1**2*bd2*f**2*r + 18*D1**2*bd2*f**2*s**2 - 36*D1**2*bd2*f**2*s + 18*D1**2*bd2*f**2 - 120*D1**2*bd2*f*fd*r**2 - 240*D1**2*bd2*f*fd*r*s + 180*D1**2*bd2*f*fd*r - 120*D1**2*bd2*f*fd*s**2 + 180*D1**2*bd2*f*fd*s - 60*D1**2*bd2*f*fd + 30*D1**2*bdd1*f**3*r*s - 30*D1**2*bdd1*f**3*r + 30*D1**2*bdd1*f**3*s**2 - 60*D1**2*bdd1*f**3*s + 30*D1**2*bdd1*f**3 + 30*D1**2*bdd1*f**2*r*s - 30*D1**2*bdd1*f**2*r + 30*D1**2*bdd1*f**2*s**2 - 60*D1**2*bdd1*f**2*s + 30*D1**2*bdd1*f**2 + 518*D1**2*bdd1*f*g2*r**2 + 1036*D1**2*bdd1*f*g2*r*s - 1204*D1**2*bdd1*f*g2*r + 518*D1**2*bdd1*f*g2*s**2 - 1204*D1**2*bdd1*f*g2*s + 602*D1**2*bdd1*f*g2 - 30*D1**2*bdd2*f**2*r**2 - 60*D1**2*bdd2*f**2*r*s + 60*D1**2*bdd2*f**2*r - 30*D1**2*bdd2*f**2*s**2 + 60*D1**2*bdd2*f**2*s - 30*D1**2*bdd2*f**2 - 330*D1**2*f**2*gd2*r**2 - 564*D1**2*f**2*gd2*r*s + 564*D1**2*f**2*gd2*r - 234*D1**2*f**2*gd2*s**2 + 468*D1**2*f**2*gd2*s - 234*D1**2*f**2*gd2 + 438*D1**2*f**2*gdd2*r**2 + 828*D1**2*f**2*gdd2*r*s - 828*D1**2*f**2*gdd2*r + 390*D1**2*f**2*gdd2*s**2 - 780*D1**2*f**2*gdd2*s + 390*D1**2*f**2*gdd2 - 660*D1**2*f*fd*g2*r**2 - 1128*D1**2*f*fd*g2*r*s + 660*D1**2*f*fd*g2*r - 468*D1**2*f*fd*g2*s**2 + 564*D1**2*f*fd*g2*s - 330*D1**2*f*fd*g2 + 1752*D1**2*f*fd*gd2*r**2 + 3312*D1**2*f*fd*gd2*r*s - 2532*D1**2*f*fd*gd2*r + 1560*D1**2*f*fd*gd2*s**2 - 2388*D1**2*f*fd*gd2*s + 828*D1**2*f*fd*gd2 + 876*D1**2*f*fdd*g2*r**2 + 1656*D1**2*f*fdd*g2*r*s - 876*D1**2*f*fdd*g2*r + 780*D1**2*f*fdd*g2*s**2 - 828*D1**2*f*fdd*g2*s + 438*D1**2*f*fdd*g2 + 876*D1**2*fd**2*g2*r**2 + 1656*D1**2*fd**2*g2*r*s - 876*D1**2*fd**2*g2*r + 780*D1**2*fd**2*g2*s**2 - 828*D1**2*fd**2*g2*s - 1752*D1*Dd*K*bd1*f**2*r**2 - 3312*D1*Dd*K*bd1*f**2*r*s + 2922*D1*Dd*K*bd1*f**2*r - 1560*D1*Dd*K*bd1*f**2*s**2 + 2754*D1*Dd*K*bd1*f**2*s - 1194*D1*Dd*K*bd1*f**2 + 240*D1*Dd*bd1*f**3*r*s - 180*D1*Dd*bd1*f**3*r + 240*D1*Dd*bd1*f**3*s**2 - 390*D1*Dd*bd1*f**3*s + 150*D1*Dd*bd1*f**3 + 240*D1*Dd*bd1*f**2*r*s - 180*D1*Dd*bd1*f**2*r + 240*D1*Dd*bd1*f**2*s**2 - 390*D1*Dd*bd1*f**2*s + 150*D1*Dd*bd1*f**2 + 4144*D1*Dd*bd1*f*g2*r**2 + 8288*D1*Dd*bd1*f*g2*r*s - 7924*D1*Dd*bd1*f*g2*r + 4144*D1*Dd*bd1*f*g2*s**2 - 7924*D1*Dd*bd1*f*g2*s + 3612*D1*Dd*bd1*f*g2 - 240*D1*Dd*bd2*f**2*r**2 - 480*D1*Dd*bd2*f**2*r*s + 420*D1*Dd*bd2*f**2*r - 240*D1*Dd*bd2*f**2*s**2 + 420*D1*Dd*bd2*f**2*s - 180*D1*Dd*bd2*f**2 - 1320*D1*Dd*f**2*g2*r**2 - 2256*D1*Dd*f**2*g2*r*s + 1788*D1*Dd*f**2*g2*r - 936*D1*Dd*f**2*g2*s**2 + 1500*D1*Dd*f**2*g2*s - 798*D1*Dd*f**2*g2 + 3504*D1*Dd*f**2*gd2*r**2 + 6624*D1*Dd*f**2*gd2*r*s - 5844*D1*Dd*f**2*gd2*r + 3120*D1*Dd*f**2*gd2*s**2 - 5508*D1*Dd*f**2*gd2*s + 2388*D1*Dd*f**2*gd2 + 7008*D1*Dd*f*fd*g2*r**2 + 13248*D1*Dd*f*fd*g2*r*s - 8568*D1*Dd*f*fd*g2*r + 6240*D1*Dd*f*fd*g2*s**2 - 8088*D1*Dd*f*fd*g2*s + 2532*D1*Dd*f*fd*g2 + 1752*D1*Ddd*f**2*g2*r**2 + 3312*D1*Ddd*f**2*g2*r*s - 2532*D1*Ddd*f**2*g2*r + 1560*D1*Ddd*f**2*g2*s**2 - 2388*D1*Ddd*f**2*g2*s + 1218*D1*Ddd*f**2*g2 + 14*D1*b2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 5256*Dd**2*f**2*g2*r**2 + 9936*Dd**2*f**2*g2*r*s - 7596*Dd**2*f**2*g2*r + 4680*Dd**2*f**2*g2*s**2 - 7164*Dd**2*f**2*g2*s + 2436*Dd**2*f**2*g2 + 70*K*b1**3*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 7*b1**2*(D1**2*(-30*K*bd1*r**2 - 60*K*bd1*r*s + 40*K*bd1*r - 30*K*bd1*s**2 + 40*K*bd1*s - 20*K*bd1 - 30*K*bdd1*r**2 - 60*K*bdd1*r*s + 40*K*bdd1*r - 30*K*bdd1*s**2 + 40*K*bdd1*s - 20*K*bdd1 - 19*K*fd*r**2 - 38*K*fd*r*s - 4*K*fd*r - 19*K*fd*s**2 - 4*K*fd*s + 2*K*fd + 37*K*fdd*r**2 + 74*K*fdd*r*s + 12*K*fdd*r + 37*K*fdd*s**2 + 12*K*fdd*s - 6*K*fdd + 6*f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 12*fd**2*r*s + 6*fd**2*r - 12*fd**2*s**2 + 12*fd**2*s + 2*fd*r*s + 2*fd*s**2 - 6*fdd*r*s - 6*fdd*s**2 + 20*gd2*(r + s - 1)**2 + 20*gdd2*r**2 + 40*gdd2*r*s - 40*gdd2*r + 20*gdd2*s**2 - 40*gdd2*s + 20*gdd2) + D1*(Dd*(-240*K*bd1*r**2 - 480*K*bd1*r*s + 340*K*bd1*r - 240*K*bd1*s**2 + 340*K*bd1*s - 120*K*bd1 + 296*K*fd*r**2 + 592*K*fd*r*s - 174*K*fd*r + 296*K*fd*s**2 - 174*K*fd*s - 36*K*fd + 6*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - f*(19*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 6*fd*(2*s - 1)*(8*r + 8*s - 5) - 8*r*s + 4*r - 8*s**2 + 10*s - 4) - 48*fd*r*s + 12*fd*r - 48*fd*s**2 + 30*fd*s + 20*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 40*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*(-6*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(37*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 24*r*s + 12*r - 24*s**2 + 30*s - 12) + 20*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) - 6*Dd**2*(f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4) + f*(-37*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 12*r*s - 6*r + 12*s**2 - 15*s + 4) - 20*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + b1*(140*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 518*D1**2*K*bdd1*f*r**2 - 1036*D1**2*K*bdd1*f*r*s + 1120*D1**2*K*bdd1*f*r - 518*D1**2*K*bdd1*f*s**2 + 1120*D1**2*K*bdd1*f*s - 560*D1**2*K*bdd1*f + 330*D1**2*K*f*fd*r**2 + 564*D1**2*K*f*fd*r*s - 330*D1**2*K*f*fd*r + 234*D1**2*K*f*fd*s**2 - 282*D1**2*K*f*fd*s + 165*D1**2*K*f*fd - 438*D1**2*K*f*fdd*r**2 - 828*D1**2*K*f*fdd*r*s + 438*D1**2*K*f*fdd*r - 390*D1**2*K*f*fdd*s**2 + 414*D1**2*K*f*fdd*s - 219*D1**2*K*f*fdd - 438*D1**2*K*fd**2*r**2 - 828*D1**2*K*fd**2*r*s + 438*D1**2*K*fd**2*r - 390*D1**2*K*fd**2*s**2 + 414*D1**2*K*fd**2*s + 14*D1**2*b2*fd*r**2 + 28*D1**2*b2*fd*r*s + 14*D1**2*b2*fd*s**2 - 42*D1**2*b2*fdd*r**2 - 84*D1**2*b2*fdd*r*s - 42*D1**2*b2*fdd*s**2 + 84*D1**2*bdd1*f**2*r*s - 42*D1**2*bdd1*f**2*r + 84*D1**2*bdd1*f**2*s**2 - 126*D1**2*bdd1*f**2*s + 42*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*r*s - 42*D1**2*bdd1*f*r + 84*D1**2*bdd1*f*s**2 - 126*D1**2*bdd1*f*s + 42*D1**2*bdd1*f - 280*D1**2*bdd1*g2*r**2 - 560*D1**2*bdd1*g2*r*s + 280*D1**2*bdd1*g2*r - 280*D1**2*bdd1*g2*s**2 + 280*D1**2*bdd1*g2*s - 140*D1**2*bdd1*g2 - 42*D1**2*bdd2*f*r**2 - 84*D1**2*bdd2*f*r*s + 84*D1**2*bdd2*f*r - 42*D1**2*bdd2*f*s**2 + 84*D1**2*bdd2*f*s - 42*D1**2*bdd2*f - 90*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 90*D1**2*f**2*fd*s - 30*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r*s - 30*D1**2*f**2*fdd*r + 90*D1**2*f**2*fdd*s**2 - 90*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r*s - 60*D1**2*f*fd**2*r + 180*D1**2*f*fd**2*s**2 - 180*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 - 36*D1**2*f*fd*r*s - 36*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s + 60*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s - 266*D1**2*f*gd2*r**2 - 532*D1**2*f*gd2*r*s + 532*D1**2*f*gd2*r - 266*D1**2*f*gd2*s**2 + 532*D1**2*f*gd2*s - 266*D1**2*f*gd2 + 518*D1**2*f*gdd2*r**2 + 1036*D1**2*f*gdd2*r*s - 1036*D1**2*f*gdd2*r + 518*D1**2*f*gdd2*s**2 - 1036*D1**2*f*gdd2*s + 518*D1**2*f*gdd2 + 60*D1**2*fd**2*r*s + 60*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s - 266*D1**2*fd*g2*r**2 - 532*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r - 266*D1**2*fd*g2*s**2 - 56*D1**2*fd*g2*s + 28*D1**2*fd*g2 + 1036*D1**2*fd*gd2*r**2 + 2072*D1**2*fd*gd2*r*s - 868*D1**2*fd*gd2*r + 1036*D1**2*fd*gd2*s**2 - 868*D1**2*fd*gd2*s - 168*D1**2*fd*gd2 + 518*D1**2*fdd*g2*r**2 + 1036*D1**2*fdd*g2*r*s + 168*D1**2*fdd*g2*r + 518*D1**2*fdd*g2*s**2 + 168*D1**2*fdd*g2*s - 84*D1**2*fdd*g2 + 660*D1*Dd*K*f**2*r**2 + 1128*D1*Dd*K*f**2*r*s - 894*D1*Dd*K*f**2*r + 468*D1*Dd*K*f**2*s**2 - 750*D1*Dd*K*f**2*s + 399*D1*Dd*K*f**2 - 3504*D1*Dd*K*f*fd*r**2 - 6624*D1*Dd*K*f*fd*r*s + 4284*D1*Dd*K*f*fd*r - 3120*D1*Dd*K*f*fd*s**2 + 4044*D1*Dd*K*f*fd*s - 1266*D1*Dd*K*f*fd + 56*D1*Dd*b2*f*r**2 + 112*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 56*D1*Dd*b2*f*s**2 - 84*D1*Dd*b2*f*s + 42*D1*Dd*b2*f - 336*D1*Dd*b2*fd*r**2 - 672*D1*Dd*b2*fd*r*s + 252*D1*Dd*b2*fd*r - 336*D1*Dd*b2*fd*s**2 + 252*D1*Dd*b2*fd*s - 120*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r*s - 300*D1*Dd*f**2*fd*r + 720*D1*Dd*f**2*fd*s**2 - 810*D1*Dd*f**2*fd*s + 210*D1*Dd*f**2*fd - 72*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 90*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 480*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 420*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 1064*D1*Dd*f*g2*r**2 - 2128*D1*Dd*f*g2*r*s + 1596*D1*Dd*f*g2*r - 1064*D1*Dd*f*g2*s**2 + 1596*D1*Dd*f*g2*s - 798*D1*Dd*f*g2 + 4144*D1*Dd*f*gd2*r**2 + 8288*D1*Dd*f*gd2*r*s - 7252*D1*Dd*f*gd2*r + 4144*D1*Dd*f*gd2*s**2 - 7252*D1*Dd*f*gd2*s + 3108*D1*Dd*f*gd2 + 4144*D1*Dd*fd*g2*r**2 + 8288*D1*Dd*fd*g2*r*s - 2436*D1*Dd*fd*g2*r + 4144*D1*Dd*fd*g2*s**2 - 2436*D1*Dd*fd*g2*s - 504*D1*Dd*fd*g2 - 876*D1*Ddd*K*f**2*r**2 - 1656*D1*Ddd*K*f**2*r*s + 1266*D1*Ddd*K*f**2*r - 780*D1*Ddd*K*f**2*s**2 + 1194*D1*Ddd*K*f**2*s - 609*D1*Ddd*K*f**2 - 168*D1*Ddd*b2*f*r**2 - 336*D1*Ddd*b2*f*r*s + 252*D1*Ddd*b2*f*r - 168*D1*Ddd*b2*f*s**2 + 252*D1*Ddd*b2*f*s - 126*D1*Ddd*b2*f + 120*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 120*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 120*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 60*D1*Ddd*f**2 + 2072*D1*Ddd*f*g2*r**2 + 4144*D1*Ddd*f*g2*r*s - 3108*D1*Ddd*f*g2*r + 2072*D1*Ddd*f*g2*s**2 - 3108*D1*Ddd*f*g2*s + 1554*D1*Ddd*f*g2 - 14*D1*bd1*(D1*(74*K*fd*r**2 + 148*K*fd*r*s - 68*K*fd*r + 74*K*fd*s**2 - 68*K*fd*s - 6*K*fd + 3*f**2*(2*s - 1)*(r + s - 1) - f*(K*(19*r**2 + 38*r*s - 40*r + 19*s**2 - 40*s + 20) + 3*fd*(2*s - 1)*(4*r + 4*s - 3) - (2*s - 1)*(r + s - 1)) - 12*fd*r*s + 3*fd*r - 12*fd*s**2 + 9*fd*s + 10*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*gd2*r**2 + 80*gd2*r*s - 60*gd2*r + 40*gd2*s**2 - 60*gd2*s + 20*gd2) + Dd*(-3*f**2*(2*s - 1)*(8*r + 8*s - 7) + f*(K*(296*r**2 + 592*r*s - 542*r + 296*s**2 - 542*s + 240) + (3 - 6*s)*(8*r + 8*s - 7)) + 20*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 14*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 2628*Dd**2*K*f**2*r**2 - 4968*Dd**2*K*f**2*r*s + 3798*Dd**2*K*f**2*r - 2340*Dd**2*K*f**2*s**2 + 3582*Dd**2*K*f**2*s - 1218*Dd**2*K*f**2 - 504*Dd**2*b2*f*r**2 - 1008*Dd**2*b2*f*r*s + 756*Dd**2*b2*f*r - 504*Dd**2*b2*f*s**2 + 756*Dd**2*b2*f*s - 252*Dd**2*b2*f + 360*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 360*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 120*Dd**2*f**3 + 360*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 120*Dd**2*f**2 + 6216*Dd**2*f*g2*r**2 + 12432*Dd**2*f*g2*r*s - 9324*Dd**2*f*g2*r + 6216*Dd**2*f*g2*s**2 - 9324*Dd**2*f*g2*s + 3108*Dd**2*f*g2) - 6*b2*(7*D1**2*bdd1*f*(r + s - 1)**2 + D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(-3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(105*d**2*k3**6) - D1**2*Pk1*Pk3*k1**4*st**4*(8*C - 4)*(3*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(6*bd1 - 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(3*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(105*d**2*k2**2*k3**4) + D1**2*Pk1*Pk3*k1**4*st**2*(2*C - 1)*(7*b1*(D1**2*(f*(7*fd - 5*fdd)*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1)) + 2*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(1 - 2*s)**2 - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(21*fd*(3*s**2 - 2*s + 1) - 15*fdd*(3*s**2 - 2*s + 1) + s**2*(49*bd1 - 35*bdd1)) + 10*fd*s*(bd1*(7 - 14*s) + fd*(6 - 9*s))) + 2*D1*f*(21*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*(2*s - 1)*(7*bd1*s + fd*(9*s - 3)) - 15*Ddd*f*(2*s**2 - 2*s + 1)) - 30*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(105*d**2*k2**2*k3**4) - D1**2*Pk1*Pk3*k1**4*(2*C - 1)*(5*b1*(D1**2*(f*(fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(9*s**2 - 6*s + 3) + fdd*(-9*s**2 + 6*s - 3) + s**2*(5*bd1 - 5*bdd1)) + 2*fd*s*(bd1*(5 - 10*s) + fd*(6 - 9*s))) + 2*D1*f*(Dd*f*(6*s**2 - 6*s + 3) - 2*Dd*(2*s - 1)*(5*bd1*s + fd*(9*s - 3)) - 3*Ddd*f*(2*s**2 - 2*s + 1)) - 6*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(15*d**2*k2**2*k3**4) - D1**2*Pk1*Pk3*k1**2*k2**4*st**6*(8*C - 4)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(21*d**2*k3**8) - 4*D1**2*Pk1*Pk3*k1**2*k2**4*st**4*(-198*C*D1**2*f**2*fd*r**2 - 396*C*D1**2*f**2*fd*r*s + 264*C*D1**2*f**2*fd*r - 198*C*D1**2*f**2*fd*s**2 + 264*C*D1**2*f**2*fd*s - 132*C*D1**2*f**2*fd - 264*C*D1*Dd*f**3*r**2 - 528*C*D1*Dd*f**3*r*s + 396*C*D1*Dd*f**3*r - 264*C*D1*Dd*f**3*s**2 + 396*C*D1*Dd*f**3*s - 198*C*D1*Dd*f**3 - 33*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*K*bdd1*f**2*r*s + 66*D1**2*K*bdd1*f**2*r - 33*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s - 33*D1**2*K*bdd1*f**2 + 66*D1**2*bd1**2*f*(-7*K + 10*f)*(r + s - 1)**2 + 462*D1**2*bdd1*f*g2*r**2 + 924*D1**2*bdd1*f*g2*r*s - 924*D1**2*bdd1*f*g2*r + 462*D1**2*bdd1*f*g2*s**2 - 924*D1**2*bdd1*f*g2*s + 462*D1**2*bdd1*f*g2 + 268*D1**2*f**3*fd*r**2 + 536*D1**2*f**3*fd*r*s - 402*D1**2*f**3*fd*r + 268*D1**2*f**3*fd*s**2 - 402*D1**2*f**3*fd*s + 201*D1**2*f**3*fd - 200*D1**2*f**3*fdd*r**2 - 400*D1**2*f**3*fdd*r*s + 300*D1**2*f**3*fdd*r - 200*D1**2*f**3*fdd*s**2 + 300*D1**2*f**3*fdd*s - 150*D1**2*f**3*fdd - 600*D1**2*f**2*fd**2*r**2 - 1200*D1**2*f**2*fd**2*r*s + 900*D1**2*f**2*fd**2*r - 600*D1**2*f**2*fd**2*s**2 + 900*D1**2*f**2*fd**2*s - 300*D1**2*f**2*fd**2 + 99*D1**2*f**2*fd*r**2 + 198*D1**2*f**2*fd*r*s - 132*D1**2*f**2*fd*r + 99*D1**2*f**2*fd*s**2 - 132*D1**2*f**2*fd*s + 66*D1**2*f**2*fd - 132*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*r - 132*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s - 132*D1**2*f**2*gd2 + 66*D1**2*f**2*gdd2*r**2 + 132*D1**2*f**2*gdd2*r*s - 132*D1**2*f**2*gdd2*r + 66*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 66*D1**2*f**2*gdd2 - 264*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 + 528*D1**2*f*fd*gd2*r*s - 396*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 396*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r**2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 268*D1*Dd*f**4*r**2 + 536*D1*Dd*f**4*r*s - 402*D1*Dd*f**4*r + 268*D1*Dd*f**4*s**2 - 402*D1*Dd*f**4*s + 201*D1*Dd*f**4 - 1600*D1*Dd*f**3*fd*r**2 - 3200*D1*Dd*f**3*fd*r*s + 2400*D1*Dd*f**3*fd*r - 1600*D1*Dd*f**3*fd*s**2 + 2400*D1*Dd*f**3*fd*s - 900*D1*Dd*f**3*fd + 132*D1*Dd*f**3*r**2 + 264*D1*Dd*f**3*r*s - 198*D1*Dd*f**3*r + 132*D1*Dd*f**3*s**2 - 198*D1*Dd*f**3*s + 99*D1*Dd*f**3 - 528*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s + 792*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 792*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 + 1056*D1*Dd*f**2*gd2*r*s - 924*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 924*D1*Dd*f**2*gd2*s + 396*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r**2 + 2112*D1*Dd*f*fd*g2*r*s - 1320*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1320*D1*Dd*f*fd*g2*s + 396*D1*Dd*f*fd*g2 - 200*D1*Ddd*f**4*r**2 - 400*D1*Ddd*f**4*r*s + 300*D1*Ddd*f**4*r - 200*D1*Ddd*f**4*s**2 + 300*D1*Ddd*f**4*s - 150*D1*Ddd*f**4 + 264*D1*Ddd*f**2*g2*r**2 + 528*D1*Ddd*f**2*g2*r*s - 396*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 396*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(2*f**3*(r + s - 1) + f**2*(r + s - 1)*(14*C - 2*K + 26*b1 - 7) - 2*f*(14*K*b1*(r + s - 1) - 2*K*fd*r - 2*K*fd*s + K*fd + 20*b1*fd*(2*r + 2*s - 1) - 14*g2*(r + s - 1) + 14*gd2*r + 14*gd2*s - 14*gd2) - 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(-14*K*b1 - K*f + 20*b1*f + 14*g2))*(r + s - 1) - 600*Dd**2*f**4*r**2 - 1200*Dd**2*f**4*r*s + 900*Dd**2*f**4*r - 600*Dd**2*f**4*s**2 + 900*Dd**2*f**4*s - 300*Dd**2*f**4 + 792*Dd**2*f**2*g2*r**2 + 1584*Dd**2*f**2*g2*r*s - 1188*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 1188*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(14*K*fd*(r + s) - 7*K*fdd*(r + s) + 20*fd**2*(r + s - 1))) + D1*(Dd*(14*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 13*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(7*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - Ddd*f*(-7*K + 10*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-7*K + 10*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(2*D1**2*bdd1*f*(-7*K + 10*f)*(r + s - 1)**2 - D1**2*(2*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(2*K*fdd*r**2 + 4*K*fdd*r*s - 2*K*fdd*r + 2*K*fdd*s**2 - 2*K*fdd*s + K*fdd + fd*(14*C - 2*K - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*gd2*(r + s - 1)**2 - 14*gdd2*r**2 - 28*gdd2*r*s + 28*gdd2*r - 14*gdd2*s**2 + 28*gdd2*s - 14*gdd2) + (2*r + 2*s)*(K*fd**2*(r + s - 1) + 14*fd*g2*(r + s) - 14*fd*gd2*(r + s - 1) - 7*fdd*g2*(r + s))) + D1*(Dd*(-2*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(14*C - 2*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 28*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*f*(K*fd*(-2*r - 2*s + 1) + 14*gd2*(r + s - 1))*(4*r + 4*s - 3) + 28*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + Ddd*f*(-K*f + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(K*f - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(385*d**2*k3**8) - D1**2*Pk1*Pk3*k1**2*k2**2*st**6*(16*C - 8)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(63*d**2*k3**6) - 2*D1**2*Pk1*Pk3*k1**2*k2**2*st**4*(14*b1**2*(2*C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-188*C*D1**2*f*fd*r**2 - 504*C*D1**2*f*fd*r*s + 236*C*D1**2*f*fd*r - 316*C*D1**2*f*fd*s**2 + 300*C*D1**2*f*fd*s - 150*C*D1**2*f*fd + 276*C*D1**2*f*fdd*r**2 + 616*C*D1**2*f*fdd*r*s - 300*C*D1**2*f*fdd*r + 340*C*D1**2*f*fdd*s**2 - 332*C*D1**2*f*fdd*s + 166*C*D1**2*f*fdd + 276*C*D1**2*fd**2*r**2 + 616*C*D1**2*fd**2*r*s - 300*C*D1**2*fd**2*r + 340*C*D1**2*fd**2*s**2 - 332*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 - 376*C*D1*Dd*f**2*r**2 - 1008*C*D1*Dd*f**2*r*s + 692*C*D1*Dd*f**2*r - 632*C*D1*Dd*f**2*s**2 + 884*C*D1*Dd*f**2*s - 410*C*D1*Dd*f**2 + 2208*C*D1*Dd*f*fd*r**2 + 4928*C*D1*Dd*f*fd*r*s - 2984*C*D1*Dd*f*fd*r + 2720*C*D1*Dd*f*fd*s**2 - 3304*C*D1*Dd*f*fd*s + 964*C*D1*Dd*f*fd + 552*C*D1*Ddd*f**2*r**2 + 1232*C*D1*Ddd*f**2*r*s - 892*C*D1*Ddd*f**2*r + 680*C*D1*Ddd*f**2*s**2 - 988*C*D1*Ddd*f**2*s + 478*C*D1*Ddd*f**2 + 1656*C*Dd**2*f**2*r**2 + 3696*C*Dd**2*f**2*r*s - 2676*C*Dd**2*f**2*r + 2040*C*Dd**2*f**2*s**2 - 2964*C*Dd**2*f**2*s + 956*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 118*D1**2*f*fd*r**2 + 272*D1**2*f*fd*r*s - 128*D1**2*f*fd*r + 154*D1**2*f*fd*s**2 - 146*D1**2*f*fd*s + 73*D1**2*f*fd - 150*D1**2*f*fdd*r**2 - 332*D1**2*f*fdd*r*s + 162*D1**2*f*fdd*r - 182*D1**2*f*fdd*s**2 + 178*D1**2*f*fdd*s - 89*D1**2*f*fdd - 150*D1**2*fd**2*r**2 - 332*D1**2*fd**2*r*s + 162*D1**2*fd**2*r - 182*D1**2*fd**2*s**2 + 178*D1**2*fd**2*s + 4*D1**2*fd**2 + 236*D1*Dd*f**2*r**2 + 544*D1*Dd*f**2*r*s - 390*D1*Dd*f**2*r + 308*D1*Dd*f**2*s**2 - 444*D1*Dd*f**2*s + 213*D1*Dd*f**2 - 1200*D1*Dd*f*fd*r**2 - 2656*D1*Dd*f*fd*r*s + 1612*D1*Dd*f*fd*r - 1456*D1*Dd*f*fd*s**2 + 1772*D1*Dd*f*fd*s - 518*D1*Dd*f*fd - 300*D1*Ddd*f**2*r**2 - 664*D1*Ddd*f**2*r*s + 482*D1*Ddd*f**2*r - 364*D1*Ddd*f**2*s**2 + 530*D1*Ddd*f**2*s - 257*D1*Ddd*f**2 + 28*D1*bd1*(2*C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 900*Dd**2*f**2*r**2 - 1992*Dd**2*f**2*r*s + 1446*Dd**2*f**2*r - 1092*Dd**2*f**2*s**2 + 1590*Dd**2*f**2*s - 514*Dd**2*f**2) + f*(-174*C*D1**2*f*fd*r**2 - 300*C*D1**2*f*fd*r*s + 216*C*D1**2*f*fd*r - 126*C*D1**2*f*fd*s**2 + 184*C*D1**2*f*fd*s - 100*C*D1**2*f*fd + 150*C*D1**2*f*fdd*r**2 + 252*C*D1**2*f*fdd*r*s - 184*C*D1**2*f*fdd*r + 102*C*D1**2*f*fdd*s**2 - 152*C*D1**2*f*fdd*s + 84*C*D1**2*f*fdd + 300*C*D1**2*fd**2*r**2 + 504*C*D1**2*fd**2*r*s - 368*C*D1**2*fd**2*r + 204*C*D1**2*fd**2*s**2 - 304*C*D1**2*fd**2*s + 84*C*D1**2*fd**2 - 232*C*D1*Dd*f**2*r**2 - 400*C*D1*Dd*f**2*r*s + 316*C*D1*Dd*f**2*r - 168*C*D1*Dd*f**2*s**2 + 268*C*D1*Dd*f**2*s - 142*C*D1*Dd*f**2 + 1200*C*D1*Dd*f*fd*r**2 + 2016*C*D1*Dd*f*fd*r*s - 1540*C*D1*Dd*f*fd*r + 816*C*D1*Dd*f*fd*s**2 - 1268*C*D1*Dd*f*fd*s + 488*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*r**2 + 336*C*D1*Ddd*f**2*r*s - 268*C*D1*Ddd*f**2*r + 136*C*D1*Ddd*f**2*s**2 - 220*C*D1*Ddd*f**2*s + 118*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*r**2 + 1008*C*Dd**2*f**2*r*s - 804*C*Dd**2*f**2*r + 408*C*Dd**2*f**2*s**2 - 660*C*Dd**2*f**2*s + 236*C*Dd**2*f**2 - 28*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1**2*bdd1*f*(2*C*(69*r**2 + 2*r*(77*s - 71) + 85*s**2 - 158*s + 71) - 75*r**2 - 2*r*(83*s - 77) - 91*s**2 + 170*s - 77) + 99*D1**2*f*fd*r**2 + 168*D1**2*f*fd*r*s - 122*D1**2*f*fd*r + 69*D1**2*f*fd*s**2 - 102*D1**2*f*fd*s + 56*D1**2*f*fd - 81*D1**2*f*fdd*r**2 - 138*D1**2*f*fdd*r*s + 100*D1**2*f*fdd*r - 57*D1**2*f*fdd*s**2 + 84*D1**2*f*fdd*s - 46*D1**2*f*fdd - 162*D1**2*fd**2*r**2 - 276*D1**2*fd**2*r*s + 200*D1**2*fd**2*r - 114*D1**2*fd**2*s**2 + 168*D1**2*fd**2*s - 46*D1**2*fd**2 + 132*D1*Dd*f**2*r**2 + 224*D1*Dd*f**2*r*s - 178*D1*Dd*f**2*r + 92*D1*Dd*f**2*s**2 - 148*D1*Dd*f**2*s + 79*D1*Dd*f**2 - 648*D1*Dd*f*fd*r**2 - 1104*D1*Dd*f*fd*r*s + 838*D1*Dd*f*fd*r - 456*D1*Dd*f*fd*s**2 + 702*D1*Dd*f*fd*s - 268*D1*Dd*f*fd - 108*D1*Ddd*f**2*r**2 - 184*D1*Ddd*f**2*r*s + 146*D1*Ddd*f**2*r - 76*D1*Ddd*f**2*s**2 + 122*D1*Ddd*f**2*s - 65*D1*Ddd*f**2 + D1*bd1*(D1*(f*(-2*C*(47*r**2 + 6*r*(21*s - 17) + 79*s**2 - 134*s + 51) + 59*r**2 + 2*r*(68*s - 63) + 77*s**2 - 144*s + 63) + 2*fd*(2*C*(138*r**2 + 7*r*(44*s - 31) + 170*s**2 - 241*s + 79) - 150*r**2 + r*(235 - 332*s) - 182*s**2 + 259*s - 85)) + 2*Dd*f*(2*C*(276*r**2 + r*(616*s - 507) + 340*s**2 - 563*s + 229) - 300*r**2 + r*(549 - 664*s) - 364*s**2 + 605*s - 247)) - 324*Dd**2*f**2*r**2 - 552*Dd**2*f**2*r*s + 438*Dd**2*f**2*r - 228*Dd**2*f**2*s**2 + 366*Dd**2*f**2*s - 130*Dd**2*f**2))/(35*d**2*k3**6) + 2*D1**2*Pk1*Pk3*k1**2*k2**2*st**2*(-1848*C*D1**2*bd1*f**2*r**2 - 1848*C*D1**2*bd1*f**2*r*s + 5544*C*D1**2*bd1*f**2*r + 3696*C*D1**2*bd1*f**2*s - 2772*C*D1**2*bd1*f**2 - 3564*C*D1**2*f**2*fd*r**2 - 4752*C*D1**2*f**2*fd*r*s + 3960*C*D1**2*f**2*fd*r - 1188*C*D1**2*f**2*fd*s**2 + 2376*C*D1**2*f**2*fd*s - 1584*C*D1**2*f**2*fd - 4752*C*D1*Dd*f**3*r**2 - 6336*C*D1*Dd*f**3*r*s + 5544*C*D1*Dd*f**3*r - 1584*C*D1*Dd*f**3*s**2 + 3168*C*D1*Dd*f**3*s - 1980*C*D1*Dd*f**3 - 27258*D1**2*K*bd1**2*f*r**2 - 48972*D1**2*K*bd1**2*f*r*s + 52668*D1**2*K*bd1**2*f*r - 21714*D1**2*K*bd1**2*f*s**2 + 47124*D1**2*K*bd1**2*f*s - 25410*D1**2*K*bd1**2*f + 7755*D1**2*K*bd1*f**2*r**2 + 11814*D1**2*K*bd1*f**2*r*s - 11814*D1**2*K*bd1*f**2*r + 4059*D1**2*K*bd1*f**2*s**2 - 8118*D1**2*K*bd1*f**2*s + 4059*D1**2*K*bd1*f**2 - 25212*D1**2*K*bd1*f*fd*r**2 - 39336*D1**2*K*bd1*f*fd*r*s + 32274*D1**2*K*bd1*f*fd*r - 14124*D1**2*K*bd1*f*fd*s**2 + 23958*D1**2*K*bd1*f*fd*s - 9834*D1**2*K*bd1*f*fd - 6303*D1**2*K*bdd1*f**2*r**2 - 9834*D1**2*K*bdd1*f**2*r*s + 9834*D1**2*K*bdd1*f**2*r - 3531*D1**2*K*bdd1*f**2*s**2 + 7062*D1**2*K*bdd1*f**2*s - 3531*D1**2*K*bdd1*f**2 + 10494*D1**2*bd1**2*f**2*r**2 + 26532*D1**2*bd1**2*f**2*r*s - 24552*D1**2*bd1**2*f**2*r + 16038*D1**2*bd1**2*f**2*s**2 - 30096*D1**2*bd1**2*f**2*s + 14058*D1**2*bd1**2*f**2 + 2772*D1**2*bd1**2*f*r**2 + 5544*D1**2*bd1**2*f*r*s - 5544*D1**2*bd1**2*f*r + 2772*D1**2*bd1**2*f*s**2 - 5544*D1**2*bd1**2*f*s + 2772*D1**2*bd1**2*f - 9240*D1**2*bd1**2*g2*r**2 - 18480*D1**2*bd1**2*g2*r*s + 9240*D1**2*bd1**2*g2*r - 9240*D1**2*bd1**2*g2*s**2 + 9240*D1**2*bd1**2*g2*s - 5544*D1**2*bd1*bd2*f*r**2 - 11088*D1**2*bd1*bd2*f*r*s + 11088*D1**2*bd1*bd2*f*r - 5544*D1**2*bd1*bd2*f*s**2 + 11088*D1**2*bd1*bd2*f*s - 5544*D1**2*bd1*bd2*f - 2354*D1**2*bd1*f**3*r**2 - 3454*D1**2*bd1*f**3*r*s + 4840*D1**2*bd1*f**3*r - 1100*D1**2*bd1*f**3*s**2 + 3586*D1**2*bd1*f**3*s - 2508*D1**2*bd1*f**3 + 15972*D1**2*bd1*f**2*fd*r**2 + 25212*D1**2*bd1*f**2*fd*r*s - 24904*D1**2*bd1*f**2*fd*r + 9240*D1**2*bd1*f**2*fd*s**2 - 19294*D1**2*bd1*f**2*fd*s + 8448*D1**2*bd1*f**2*fd + 198*D1**2*bd1*f**2*r**2 - 528*D1**2*bd1*f**2*r*s - 1782*D1**2*bd1*f**2*r - 726*D1**2*bd1*f**2*s**2 - 858*D1**2*bd1*f**2*s + 1122*D1**2*bd1*f**2 + 2376*D1**2*bd1*f*fd*r**2 + 4752*D1**2*bd1*f*fd*r*s - 3564*D1**2*bd1*f*fd*r + 2376*D1**2*bd1*f*fd*s**2 - 3564*D1**2*bd1*f*fd*s + 1188*D1**2*bd1*f*fd - 24486*D1**2*bd1*f*g2*r**2 - 37884*D1**2*bd1*f*g2*r*s + 52668*D1**2*bd1*f*g2*r - 13398*D1**2*bd1*f*g2*s**2 + 41580*D1**2*bd1*f*g2*s - 26334*D1**2*bd1*f*g2 + 54516*D1**2*bd1*f*gd2*r**2 + 97944*D1**2*bd1*f*gd2*r*s - 105336*D1**2*bd1*f*gd2*r + 43428*D1**2*bd1*f*gd2*s**2 - 94248*D1**2*bd1*f*gd2*s + 50820*D1**2*bd1*f*gd2 + 54516*D1**2*bd1*fd*g2*r**2 + 97944*D1**2*bd1*fd*g2*r*s - 54516*D1**2*bd1*fd*g2*r + 43428*D1**2*bd1*fd*g2*s**2 - 48972*D1**2*bd1*fd*g2*s + 1914*D1**2*bd2*f**2*r**2 + 3828*D1**2*bd2*f**2*r*s - 3828*D1**2*bd2*f**2*r + 1914*D1**2*bd2*f**2*s**2 - 3828*D1**2*bd2*f**2*s + 1914*D1**2*bd2*f**2 - 4752*D1**2*bd2*f*fd*r**2 - 9504*D1**2*bd2*f*fd*r*s + 7128*D1**2*bd2*f*fd*r - 4752*D1**2*bd2*f*fd*s**2 + 7128*D1**2*bd2*f*fd*s - 2376*D1**2*bd2*f*fd + 2662*D1**2*bdd1*f**3*r**2 + 4202*D1**2*bdd1*f**3*r*s - 5588*D1**2*bdd1*f**3*r + 1540*D1**2*bdd1*f**3*s**2 - 4466*D1**2*bdd1*f**3*s + 3036*D1**2*bdd1*f**3 + 594*D1**2*bdd1*f**2*r**2 + 1188*D1**2*bdd1*f**2*r*s - 1188*D1**2*bdd1*f**2*r + 594*D1**2*bdd1*f**2*s**2 - 1188*D1**2*bdd1*f**2*s + 594*D1**2*bdd1*f**2 + 27258*D1**2*bdd1*f*g2*r**2 + 48972*D1**2*bdd1*f*g2*r*s - 56364*D1**2*bdd1*f*g2*r + 21714*D1**2*bdd1*f*g2*s**2 - 50820*D1**2*bdd1*f*g2*s + 28182*D1**2*bdd1*f*g2 - 1188*D1**2*bdd2*f**2*r**2 - 2376*D1**2*bdd2*f**2*r*s + 2376*D1**2*bdd2*f**2*r - 1188*D1**2*bdd2*f**2*s**2 + 2376*D1**2*bdd2*f**2*s - 1188*D1**2*bdd2*f**2 + 1940*D1**2*f**3*fd*r**2 + 6560*D1**2*f**3*fd*r*s - 4250*D1**2*f**3*fd*r + 4620*D1**2*f**3*fd*s**2 - 6260*D1**2*f**3*fd*s + 2795*D1**2*f**3*fd - 1740*D1**2*f**3*fdd*r**2 - 6800*D1**2*f**3*fdd*r*s + 4270*D1**2*f**3*fdd*r - 5060*D1**2*f**3*fdd*s**2 + 6760*D1**2*f**3*fdd*s - 2965*D1**2*f**3*fdd - 5220*D1**2*f**2*fd**2*r**2 - 20400*D1**2*f**2*fd**2*r*s + 12810*D1**2*f**2*fd**2*r - 15180*D1**2*f**2*fd**2*s**2 + 20280*D1**2*f**2*fd**2*s - 5930*D1**2*f**2*fd**2 + 2376*D1**2*f**2*fd*r**2 + 2970*D1**2*f**2*fd*r*s - 2574*D1**2*f**2*fd*r + 594*D1**2*f**2*fd*s**2 - 1386*D1**2*f**2*fd*s + 990*D1**2*f**2*fd - 15510*D1**2*f**2*gd2*r**2 - 23628*D1**2*f**2*gd2*r*s + 23628*D1**2*f**2*gd2*r - 8118*D1**2*f**2*gd2*s**2 + 16236*D1**2*f**2*gd2*s - 8118*D1**2*f**2*gd2 + 12606*D1**2*f**2*gdd2*r**2 + 19668*D1**2*f**2*gdd2*r*s - 19668*D1**2*f**2*gdd2*r + 7062*D1**2*f**2*gdd2*s**2 - 14124*D1**2*f**2*gdd2*s + 7062*D1**2*f**2*gdd2 - 31020*D1**2*f*fd*g2*r**2 - 47256*D1**2*f*fd*g2*r*s + 31020*D1**2*f*fd*g2*r - 16236*D1**2*f*fd*g2*s**2 + 23628*D1**2*f*fd*g2*s - 15510*D1**2*f*fd*g2 + 50424*D1**2*f*fd*gd2*r**2 + 78672*D1**2*f*fd*gd2*r*s - 64548*D1**2*f*fd*gd2*r + 28248*D1**2*f*fd*gd2*s**2 - 47916*D1**2*f*fd*gd2*s + 19668*D1**2*f*fd*gd2 + 25212*D1**2*f*fdd*g2*r**2 + 39336*D1**2*f*fdd*g2*r*s - 25212*D1**2*f*fdd*g2*r + 14124*D1**2*f*fdd*g2*s**2 - 19668*D1**2*f*fdd*g2*s + 12606*D1**2*f*fdd*g2 + 25212*D1**2*fd**2*g2*r**2 + 39336*D1**2*fd**2*g2*r*s - 25212*D1**2*fd**2*g2*r + 14124*D1**2*fd**2*g2*s**2 - 19668*D1**2*fd**2*g2*s - 50424*D1*Dd*K*bd1*f**2*r**2 - 78672*D1*Dd*K*bd1*f**2*r*s + 71610*D1*Dd*K*bd1*f**2*r - 28248*D1*Dd*K*bd1*f**2*s**2 + 52206*D1*Dd*K*bd1*f**2*s - 23958*D1*Dd*K*bd1*f**2 + 21296*D1*Dd*bd1*f**3*r**2 + 33616*D1*Dd*bd1*f**3*r*s - 36080*D1*Dd*bd1*f**3*r + 12320*D1*Dd*bd1*f**3*s**2 - 28226*D1*Dd*bd1*f**3*s + 14520*D1*Dd*bd1*f**3 + 4752*D1*Dd*bd1*f**2*r**2 + 9504*D1*Dd*bd1*f**2*r*s - 8316*D1*Dd*bd1*f**2*r + 4752*D1*Dd*bd1*f**2*s**2 - 8316*D1*Dd*bd1*f**2*s + 3564*D1*Dd*bd1*f**2 + 218064*D1*Dd*bd1*f*g2*r**2 + 391776*D1*Dd*bd1*f*g2*r*s - 377916*D1*Dd*bd1*f*g2*r + 173712*D1*Dd*bd1*f*g2*s**2 - 339108*D1*Dd*bd1*f*g2*s + 158004*D1*Dd*bd1*f*g2 - 9504*D1*Dd*bd2*f**2*r**2 - 19008*D1*Dd*bd2*f**2*r*s + 16632*D1*Dd*bd2*f**2*r - 9504*D1*Dd*bd2*f**2*s**2 + 16632*D1*Dd*bd2*f**2*s - 7128*D1*Dd*bd2*f**2 + 1940*D1*Dd*f**4*r**2 + 6560*D1*Dd*f**4*r*s - 4250*D1*Dd*f**4*r + 4620*D1*Dd*f**4*s**2 - 6260*D1*Dd*f**4*s + 2795*D1*Dd*f**4 - 13920*D1*Dd*f**3*fd*r**2 - 54400*D1*Dd*f**3*fd*r*s + 34160*D1*Dd*f**3*fd*r - 40480*D1*Dd*f**3*fd*s**2 + 54080*D1*Dd*f**3*fd*s - 17790*D1*Dd*f**3*fd + 3168*D1*Dd*f**3*r**2 + 3960*D1*Dd*f**3*r*s - 3564*D1*Dd*f**3*r + 792*D1*Dd*f**3*s**2 - 1782*D1*Dd*f**3*s + 1188*D1*Dd*f**3 - 62040*D1*Dd*f**2*g2*r**2 - 94512*D1*Dd*f**2*g2*r*s + 78276*D1*Dd*f**2*g2*r - 32472*D1*Dd*f**2*g2*s**2 + 56100*D1*Dd*f**2*g2*s - 31746*D1*Dd*f**2*g2 + 100848*D1*Dd*f**2*gd2*r**2 + 157344*D1*Dd*f**2*gd2*r*s - 143220*D1*Dd*f**2*gd2*r + 56496*D1*Dd*f**2*gd2*s**2 - 104412*D1*Dd*f**2*gd2*s + 47916*D1*Dd*f**2*gd2 + 201696*D1*Dd*f*fd*g2*r**2 + 314688*D1*Dd*f*fd*g2*r*s - 229944*D1*Dd*f*fd*g2*r + 112992*D1*Dd*f*fd*g2*s**2 - 174504*D1*Dd*f*fd*g2*s + 64548*D1*Dd*f*fd*g2 - 1740*D1*Ddd*f**4*r**2 - 6800*D1*Ddd*f**4*r*s + 4270*D1*Ddd*f**4*r - 5060*D1*Ddd*f**4*s**2 + 6760*D1*Ddd*f**4*s - 2965*D1*Ddd*f**4 + 50424*D1*Ddd*f**2*g2*r**2 + 78672*D1*Ddd*f**2*g2*r*s - 64548*D1*Ddd*f**2*g2*r + 28248*D1*Ddd*f**2*g2*s**2 - 47916*D1*Ddd*f**2*g2*s + 26730*D1*Ddd*f**2*g2 - 5220*Dd**2*f**4*r**2 - 20400*Dd**2*f**4*r*s + 12810*Dd**2*f**4*r - 15180*Dd**2*f**4*s**2 + 20280*Dd**2*f**4*s - 5930*Dd**2*f**4 + 151272*Dd**2*f**2*g2*r**2 + 236016*Dd**2*f**2*g2*r*s - 193644*Dd**2*f**2*g2*r + 84744*Dd**2*f**2*g2*s**2 - 143748*Dd**2*f**2*g2*s + 53460*Dd**2*f**2*g2 + 462*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(-10*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*(-5*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 3*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(140*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 140*C*D1**2*fd*s**2 - 280*C*D1**2*fd*s + 140*C*D1**2*fd + 560*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 840*C*D1*Dd*f*r + 560*C*D1*Dd*f*s**2 - 840*C*D1*Dd*f*s + 420*C*D1*Dd*f + 371*D1**2*K*fd*r**2 + 574*D1**2*K*fd*r*s + 56*D1**2*K*fd*r + 203*D1**2*K*fd*s**2 + 56*D1**2*K*fd*s - 28*D1**2*K*fd - 413*D1**2*K*fdd*r**2 - 742*D1**2*K*fdd*r*s - 28*D1**2*K*fdd*r - 329*D1**2*K*fdd*s**2 - 28*D1**2*K*fdd*s + 14*D1**2*K*fdd - 14*D1**2*bdd1*(-5*K + 3*f)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 202*D1**2*f*fd*r**2 - 572*D1**2*f*fd*r*s + 238*D1**2*f*fd*r - 370*D1**2*f*fd*s**2 + 322*D1**2*f*fd*s - 161*D1**2*f*fd + 318*D1**2*f*fdd*r**2 + 804*D1**2*f*fdd*r*s - 378*D1**2*f*fdd*r + 486*D1**2*f*fdd*s**2 - 462*D1**2*f*fdd*s + 231*D1**2*f*fdd + 318*D1**2*fd**2*r**2 + 804*D1**2*fd**2*r*s - 378*D1**2*fd**2*r + 486*D1**2*fd**2*s**2 - 462*D1**2*fd**2*s - 24*D1**2*fd**2 - 154*D1**2*fd*r**2 - 238*D1**2*fd*r*s + 140*D1**2*fd*r - 84*D1**2*fd*s**2 + 140*D1**2*fd*s - 70*D1**2*fd + 42*D1**2*fdd*r**2 + 84*D1**2*fdd*r*s + 42*D1**2*fdd*s**2 + 280*D1**2*gd2*r**2 + 560*D1**2*gd2*r*s - 560*D1**2*gd2*r + 280*D1**2*gd2*s**2 - 560*D1**2*gd2*s + 280*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 + 1484*D1*Dd*K*f*r**2 + 2296*D1*Dd*K*f*r*s - 1890*D1*Dd*K*f*r + 812*D1*Dd*K*f*s**2 - 1386*D1*Dd*K*f*s + 777*D1*Dd*K*f - 3304*D1*Dd*K*fd*r**2 - 5936*D1*Dd*K*fd*r*s + 2198*D1*Dd*K*fd*r - 2632*D1*Dd*K*fd*s**2 + 1946*D1*Dd*K*fd*s + 84*D1*Dd*K*fd - 404*D1*Dd*f**2*r**2 - 1144*D1*Dd*f**2*r*s + 774*D1*Dd*f**2*r - 740*D1*Dd*f**2*s**2 + 1026*D1*Dd*f**2*s - 471*D1*Dd*f**2 + 2544*D1*Dd*f*fd*r**2 + 6432*D1*Dd*f*fd*r*s - 3756*D1*Dd*f*fd*r + 3888*D1*Dd*f*fd*s**2 - 4596*D1*Dd*f*fd*s + 1302*D1*Dd*f*fd - 616*D1*Dd*f*r**2 - 952*D1*Dd*f*r*s + 784*D1*Dd*f*r - 336*D1*Dd*f*s**2 + 574*D1*Dd*f*s - 322*D1*Dd*f + 336*D1*Dd*fd*r**2 + 672*D1*Dd*fd*r*s - 252*D1*Dd*fd*r + 336*D1*Dd*fd*s**2 - 252*D1*Dd*fd*s + 1120*D1*Dd*g2*r**2 + 2240*D1*Dd*g2*r*s - 1680*D1*Dd*g2*r + 1120*D1*Dd*g2*s**2 - 1680*D1*Dd*g2*s + 840*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 - 1652*D1*Ddd*K*f*r**2 - 2968*D1*Ddd*K*f*r*s + 2310*D1*Ddd*K*f*r - 1316*D1*Ddd*K*f*s**2 + 2058*D1*Ddd*K*f*s - 1071*D1*Ddd*K*f + 636*D1*Ddd*f**2*r**2 + 1608*D1*Ddd*f**2*r*s - 1122*D1*Ddd*f**2*r + 972*D1*Ddd*f**2*s**2 - 1374*D1*Ddd*f**2*s + 645*D1*Ddd*f**2 + 168*D1*Ddd*f*r**2 + 336*D1*Ddd*f*r*s - 252*D1*Ddd*f*r + 168*D1*Ddd*f*s**2 - 252*D1*Ddd*f*s + 126*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 + 14*D1*bd1*(D1*(-10*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - 2*Dd*(-5*K + 3*f)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 4956*Dd**2*K*f*r**2 - 8904*Dd**2*K*f*r*s + 6930*Dd**2*K*f*r - 3948*Dd**2*K*f*s**2 + 6174*Dd**2*K*f*s - 2142*Dd**2*K*f + 1908*Dd**2*f**2*r**2 + 4824*Dd**2*f**2*r*s - 3366*Dd**2*f**2*r + 2916*Dd**2*f**2*s**2 - 4122*Dd**2*f**2*s + 1290*Dd**2*f**2 + 504*Dd**2*f*r**2 + 1008*Dd**2*f*r*s - 756*Dd**2*f*r + 504*Dd**2*f*s**2 - 756*Dd**2*f*s + 252*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) - 11*b1*(336*C*D1**2*f*fd*r**2 + 336*C*D1**2*f*fd*r*s + 168*C*D1**2*f*fd*s - 84*C*D1**2*f*fd + 672*C*D1*Dd*f**2*r**2 + 672*C*D1*Dd*f**2*r*s - 672*C*D1*Dd*f**2*r - 168*C*D1*Dd*f**2*s + 168*C*D1*Dd*f**2 + 2478*D1**2*K*bdd1*f*r**2 + 4452*D1**2*K*bdd1*f*r*s - 4788*D1**2*K*bdd1*f*r + 1974*D1**2*K*bdd1*f*s**2 - 4284*D1**2*K*bdd1*f*s + 2268*D1**2*K*bdd1*f - 1410*D1**2*K*f*fd*r**2 - 2148*D1**2*K*f*fd*r*s + 1410*D1**2*K*f*fd*r - 738*D1**2*K*f*fd*s**2 + 1074*D1**2*K*f*fd*s - 705*D1**2*K*f*fd + 1146*D1**2*K*f*fdd*r**2 + 1788*D1**2*K*f*fdd*r*s - 1146*D1**2*K*f*fdd*r + 642*D1**2*K*f*fdd*s**2 - 894*D1**2*K*f*fdd*s + 573*D1**2*K*f*fdd + 1146*D1**2*K*fd**2*r**2 + 1788*D1**2*K*fd**2*r*s - 1146*D1**2*K*fd**2*r + 642*D1**2*K*fd**2*s**2 - 894*D1**2*K*fd**2*s - 294*D1**2*b2*fd*r**2 - 588*D1**2*b2*fd*r*s - 294*D1**2*b2*fd*s**2 + 252*D1**2*b2*fdd*r**2 + 504*D1**2*b2*fdd*r*s + 252*D1**2*b2*fdd*s**2 + 84*D1**2*bd1**2*(-5*K + 3*f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 954*D1**2*bdd1*f**2*r**2 - 2412*D1**2*bdd1*f**2*r*s + 2232*D1**2*bdd1*f**2*r - 1458*D1**2*bdd1*f**2*s**2 + 2736*D1**2*bdd1*f**2*s - 1242*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*r**2 - 504*D1**2*bdd1*f*r*s + 504*D1**2*bdd1*f*r - 252*D1**2*bdd1*f*s**2 + 504*D1**2*bdd1*f*s - 252*D1**2*bdd1*f + 840*D1**2*bdd1*g2*r**2 + 1680*D1**2*bdd1*g2*r*s - 840*D1**2*bdd1*g2*r + 840*D1**2*bdd1*g2*s**2 - 840*D1**2*bdd1*g2*s + 420*D1**2*bdd1*g2 + 252*D1**2*bdd2*f*r**2 + 504*D1**2*bdd2*f*r*s - 504*D1**2*bdd2*f*r + 252*D1**2*bdd2*f*s**2 - 504*D1**2*bdd2*f*s + 252*D1**2*bdd2*f + 642*D1**2*f**2*fd*r**2 + 942*D1**2*f**2*fd*r*s - 616*D1**2*f**2*fd*r + 300*D1**2*f**2*fd*s**2 - 388*D1**2*f**2*fd*s + 186*D1**2*f**2*fd - 726*D1**2*f**2*fdd*r**2 - 1146*D1**2*f**2*fdd*r*s + 740*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 536*D1**2*f**2*fdd*s - 246*D1**2*f**2*fdd - 1452*D1**2*f*fd**2*r**2 - 2292*D1**2*f*fd**2*r*s + 1480*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1072*D1**2*f*fd**2*s - 276*D1**2*f*fd**2 - 36*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s - 174*D1**2*f*fd*r + 132*D1**2*f*fd*s**2 - 258*D1**2*f*fd*s + 150*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 216*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*r - 108*D1**2*f*fdd*s**2 + 108*D1**2*f*fdd*s - 54*D1**2*f*fdd + 2226*D1**2*f*gd2*r**2 + 3444*D1**2*f*gd2*r*s - 3444*D1**2*f*gd2*r + 1218*D1**2*f*gd2*s**2 - 2436*D1**2*f*gd2*s + 1218*D1**2*f*gd2 - 2478*D1**2*f*gdd2*r**2 - 4452*D1**2*f*gdd2*r*s + 4452*D1**2*f*gdd2*r - 1974*D1**2*f*gdd2*s**2 + 3948*D1**2*f*gdd2*s - 1974*D1**2*f*gdd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 108*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 108*D1**2*fd**2*s + 2226*D1**2*fd*g2*r**2 + 3444*D1**2*fd*g2*r*s + 336*D1**2*fd*g2*r + 1218*D1**2*fd*g2*s**2 + 336*D1**2*fd*g2*s - 168*D1**2*fd*g2 - 4956*D1**2*fd*gd2*r**2 - 8904*D1**2*fd*gd2*r*s + 4284*D1**2*fd*gd2*r - 3948*D1**2*fd*gd2*s**2 + 3780*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 - 2478*D1**2*fdd*g2*r**2 - 4452*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r - 1974*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 - 2820*D1*Dd*K*f**2*r**2 - 4296*D1*Dd*K*f**2*r*s + 3558*D1*Dd*K*f**2*r - 1476*D1*Dd*K*f**2*s**2 + 2550*D1*Dd*K*f**2*s - 1443*D1*Dd*K*f**2 + 9168*D1*Dd*K*f*fd*r**2 + 14304*D1*Dd*K*f*fd*r*s - 10452*D1*Dd*K*f*fd*r + 5136*D1*Dd*K*f*fd*s**2 - 7932*D1*Dd*K*f*fd*s + 2934*D1*Dd*K*f*fd - 1176*D1*Dd*b2*f*r**2 - 2352*D1*Dd*b2*f*r*s + 1764*D1*Dd*b2*f*r - 1176*D1*Dd*b2*f*s**2 + 1764*D1*Dd*b2*f*s - 882*D1*Dd*b2*f + 2016*D1*Dd*b2*fd*r**2 + 4032*D1*Dd*b2*fd*r*s - 1512*D1*Dd*b2*fd*r + 2016*D1*Dd*b2*fd*s**2 - 1512*D1*Dd*b2*fd*s + 856*D1*Dd*f**3*r**2 + 1256*D1*Dd*f**3*r*s - 1056*D1*Dd*f**3*r + 400*D1*Dd*f**3*s**2 - 714*D1*Dd*f**3*s + 414*D1*Dd*f**3 - 5808*D1*Dd*f**2*fd*r**2 - 9168*D1*Dd*f**2*fd*r*s + 6704*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4970*D1*Dd*f**2*fd*s - 1812*D1*Dd*f**2*fd - 72*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s - 60*D1*Dd*f**2*r + 264*D1*Dd*f**2*s**2 - 312*D1*Dd*f**2*s + 114*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 1728*D1*Dd*f*fd*r*s + 1080*D1*Dd*f*fd*r - 864*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 324*D1*Dd*f*fd + 8904*D1*Dd*f*g2*r**2 + 13776*D1*Dd*f*g2*r*s - 11340*D1*Dd*f*g2*r + 4872*D1*Dd*f*g2*s**2 - 8316*D1*Dd*f*g2*s + 4662*D1*Dd*f*g2 - 19824*D1*Dd*f*gd2*r**2 - 35616*D1*Dd*f*gd2*r*s + 31668*D1*Dd*f*gd2*r - 15792*D1*Dd*f*gd2*s**2 + 28140*D1*Dd*f*gd2*s - 12348*D1*Dd*f*gd2 - 19824*D1*Dd*fd*g2*r**2 - 35616*D1*Dd*fd*g2*r*s + 13188*D1*Dd*fd*g2*r - 15792*D1*Dd*fd*g2*s**2 + 11676*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 + 2292*D1*Ddd*K*f**2*r**2 + 3576*D1*Ddd*K*f**2*r*s - 2934*D1*Ddd*K*f**2*r + 1284*D1*Ddd*K*f**2*s**2 - 2178*D1*Ddd*K*f**2*s + 1215*D1*Ddd*K*f**2 + 1008*D1*Ddd*b2*f*r**2 + 2016*D1*Ddd*b2*f*r*s - 1512*D1*Ddd*b2*f*r + 1008*D1*Ddd*b2*f*s**2 - 1512*D1*Ddd*b2*f*s + 756*D1*Ddd*b2*f - 968*D1*Ddd*f**3*r**2 - 1528*D1*Ddd*f**3*r*s + 1248*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 942*D1*Ddd*f**3*s - 522*D1*Ddd*f**3 - 216*D1*Ddd*f**2*r**2 - 432*D1*Ddd*f**2*r*s + 324*D1*Ddd*f**2*r - 216*D1*Ddd*f**2*s**2 + 324*D1*Ddd*f**2*s - 162*D1*Ddd*f**2 - 9912*D1*Ddd*f*g2*r**2 - 17808*D1*Ddd*f*g2*r*s + 13860*D1*Ddd*f*g2*r - 7896*D1*Ddd*f*g2*s**2 + 12348*D1*Ddd*f*g2*s - 6426*D1*Ddd*f*g2 + 6*D1*bd1*(D1*f**2*(101*r**2 + r*(286*s - 268) + 185*s**2 - 352*s + 155) - D1*f*(70*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(53*r**2 + 82*r*s - 98*r + 29*s**2 - 74*s + 43) + 6*fd*(106*r**2 + r*(268*s - 187) + 162*s**2 - 229*s + 74) - 154*r**2 - 238*r*s + 203*r - 84*s**2 + 133*s - 84) - 14*D1*(fd*(K*(-59*r**2 + r*(55 - 106*s) - 47*s**2 + 49*s + 1) + 6*r**2 + 6*r*(2*s - 1) + 6*s*(s - 1)) + 10*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 6*Dd*f**2*(212*r**2 + r*(536*s - 435) + 324*s**2 - 533*s + 214) + 14*Dd*f*(K*(236*r**2 + r*(424*s - 393) + 188*s**2 - 351*s + 159) - 24*r**2 - 6*r*(8*s - 7) - 24*s**2 + 42*s - 18) + 140*Dd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 42*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 6876*Dd**2*K*f**2*r**2 + 10728*Dd**2*K*f**2*r*s - 8802*Dd**2*K*f**2*r + 3852*Dd**2*K*f**2*s**2 - 6534*Dd**2*K*f**2*s + 2430*Dd**2*K*f**2 + 3024*Dd**2*b2*f*r**2 + 6048*Dd**2*b2*f*r*s - 4536*Dd**2*b2*f*r + 3024*Dd**2*b2*f*s**2 - 4536*Dd**2*b2*f*s + 1512*Dd**2*b2*f - 2904*Dd**2*f**3*r**2 - 4584*Dd**2*f**3*r*s + 3744*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2826*Dd**2*f**3*s - 1044*Dd**2*f**3 - 648*Dd**2*f**2*r**2 - 1296*Dd**2*f**2*r*s + 972*Dd**2*f**2*r - 648*Dd**2*f**2*s**2 + 972*Dd**2*f**2*s - 324*Dd**2*f**2 - 29736*Dd**2*f*g2*r**2 - 53424*Dd**2*f*g2*r*s + 41580*Dd**2*f*g2*r - 23688*Dd**2*f*g2*s**2 + 37044*Dd**2*f*g2*s - 12852*Dd**2*f*g2) + 66*b2*(-42*D1**2*bdd1*f*(r + s - 1)**2 + 58*D1**2*f*fd*r**2 + 116*D1**2*f*fd*r*s - 58*D1**2*f*fd*r + 58*D1**2*f*fd*s**2 - 58*D1**2*f*fd*s + 29*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 116*D1*Dd*f**2*r**2 + 232*D1*Dd*f**2*r*s - 174*D1*Dd*f**2*r + 116*D1*Dd*f**2*s**2 - 174*D1*Dd*f**2*s + 87*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 + 7*D1*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2))/(3465*d**2*k3**6) - D1**2*Pk1*Pk3*k1**2*st**6*(8*C - 4)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k3**4) + D1**2*Pk1*Pk3*k1**2*st**4*(-84*b1**2*(2*C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) - 3*b1*(D1**2*(f*(-28*bdd1*s*(2*C - 1)*(2*r + 2*s - 1) + fd*(-2*C*(68*r*(2*s - 1) + 218*s**2 - 210*s + 109) + 72*r*(2*s - 1) + 234*s**2 - 226*s + 117) + fdd*(2*C*(48*r*(2*s - 1) + 158*s**2 - 154*s + 79) - 50*r*(2*s - 1) - 166*s**2 + 162*s - 83)) + 2*fd**2*(2*C*(24*r*(2*s - 1) + 79*s**2 - 77*s - 2) + r*(25 - 50*s) - 83*s**2 + 81*s + 2)) - 28*D1*bd1*(2*C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(2*C*(68*r*(2*s - 1) + 218*s**2 - 252*s + 109) - 72*r*(2*s - 1) - 234*s**2 + 270*s - 117) - fd*(2*s - 1)*(4*C*(96*r + 158*s - 89) - 200*r - 332*s + 187)) + Ddd*f*(-2*C*(48*r*(2*s - 1) + 158*s**2 - 182*s + 79) + 50*r*(2*s - 1) + 166*s**2 - 191*s + 83)) + 2*Dd**2*f**2*(2*C*(144*r*(2*s - 1) + 474*s**2 - 546*s + 127) - 150*r*(2*s - 1) - 498*s**2 + 573*s - 133)) + f*(84*D1**2*bd1**2*s*(2*C - 1)*(2*r + 2*s - 1) + D1**2*(f*(-3*bdd1*s*(2*C*(48*r + 79*s - 52) - 50*r - 83*s + 54) + fd*(2*C*(68*r*(3*s - 1) + 219*s**2 - 214*s + 73) - 72*r*(3*s - 1) - 243*s**2 + 234*s - 81) + fdd*(-2*C*(52*r*(3*s - 1) + 141*s**2 - 146*s + 47) + 54*r*(3*s - 1) + 153*s**2 - 156*s + 51)) + 2*fd**2*(-2*C*(52*r*(3*s - 1) + 141*s**2 - 146*s + 26) + 54*r*(3*s - 1) + 153*s**2 - 156*s + 27)) + 3*D1*bd1*(-8*C*Dd*f*(24*r*(4*s - 1) + 158*s**2 - 143*s + 26) + D1*f*s*(2*C*(68*r + 109*s - 76) - 72*r - 117*s + 80) + D1*fd*(-4*C*(24*r*(4*s - 1) + 158*s**2 - 129*s + 26) + 50*r*(4*s - 1) + 332*s**2 - 270*s + 54) + 2*Dd*f*(4*s - 1)*(50*r + 83*s - 54)) + 2*D1*f*(-2*C*Ddd*f*(52*r*(2*s - 1) + 94*s**2 - 120*s + 47) + Dd*f*(2*C*(68*r*(2*s - 1) + 146*s**2 - 180*s + 73) - 72*r*(2*s - 1) - 162*s**2 + 198*s - 81) + Dd*fd*(-8*C*(13*r*(12*s - 5) + 141*s**2 - 163*s + 43) + 54*r*(12*s - 5) + 612*s**2 - 699*s + 183) + 3*Ddd*f*(18*r*(2*s - 1) + 34*s**2 - 43*s + 17)) - 6*Dd**2*f**2*(2*C*(52*r*(2*s - 1) + 94*s**2 - 120*s + 33) - 54*r*(2*s - 1) - 102*s**2 + 129*s - 35)))/(105*d**2*k3**4) - D1**2*Pk1*Pk3*k1**2*st**2*(21*b1**2*(D1**2*(fd*(C*(34*r - 46*s + 46) - 17*r + 17*s - 17) + fdd*(18*C*r + 58*C*(s - 1) - 9*r - 31*s + 31))*(r + s - 1) + D1*(Dd*(f*(2*C*(68*r**2 - 2*r*(12*s + 11) - 92*s**2 + 98*s - 29) - 68*r**2 + 34*r + 17*(1 - 2*s)**2) + 2*fd*(2*C*(36*r**2 + 152*r*s - 123*r + 116*s**2 - 193*s + 77) - 36*r**2 - 160*r*s + 129*r - 124*s**2 + 206*s - 82)) + Ddd*f*(2*C*(36*r**2 + 152*r*s - 94*r + 116*s**2 - 154*s + 67) - 36*r**2 - 160*r*s + 98*r - 124*s**2 + 164*s - 71)) + 2*Dd**2*f*(2*C*(54*r**2 + 3*r*(76*s - 47) + 174*s**2 - 231*s + 67) - 54*r**2 - 3*r*(80*s - 49) - 186*s**2 + 246*s - 71)) + 3*b1*(224*C*D1**2*f*fd*r**2 + 1808*C*D1**2*f*fd*r*s - 820*C*D1**2*f*fd*r + 1524*C*D1**2*f*fd*s**2 - 1392*C*D1**2*f*fd*s + 720*C*D1**2*f*fd - 280*C*D1**2*f*fdd*r**2 - 1744*C*D1**2*f*fdd*r*s + 732*C*D1**2*f*fdd*r - 1476*C*D1**2*f*fdd*s**2 + 1312*C*D1**2*f*fdd*s - 668*C*D1**2*f*fdd - 280*C*D1**2*fd**2*r**2 - 1744*C*D1**2*fd**2*r*s + 732*C*D1**2*fd**2*r - 1476*C*D1**2*fd**2*s**2 + 1312*C*D1**2*fd**2*s + 164*C*D1**2*fd**2 + 448*C*D1*Dd*f**2*r**2 + 3616*C*D1*Dd*f**2*r*s - 2032*C*D1*Dd*f**2*r + 3048*C*D1*Dd*f**2*s**2 - 3952*C*D1*Dd*f**2*s + 1636*C*D1*Dd*f**2 - 2240*C*D1*Dd*f*fd*r**2 - 13952*C*D1*Dd*f*fd*r*s + 6976*C*D1*Dd*f*fd*r - 11808*C*D1*Dd*f*fd*s**2 + 12896*C*D1*Dd*f*fd*s - 3356*C*D1*Dd*f*fd - 560*C*D1*Ddd*f**2*r**2 - 3488*C*D1*Ddd*f**2*r*s + 2024*C*D1*Ddd*f**2*r - 2952*C*D1*Ddd*f**2*s**2 + 3824*C*D1*Ddd*f**2*s - 1616*C*D1*Ddd*f**2 - 1680*C*Dd**2*f**2*r**2 - 10464*C*Dd**2*f**2*r*s + 6072*C*Dd**2*f**2*r - 8856*C*Dd**2*f**2*s**2 + 11472*C*Dd**2*f**2*s - 3220*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(2*C*(18*r**2 + 76*r*s - 18*r + 58*s**2 - 38*s + 9) - 18*r**2 - 80*r*s + 18*r - 62*s**2 + 40*s - 9) - 112*D1**2*f*fd*r**2 - 974*D1**2*f*fd*r*s + 445*D1**2*f*fd*r - 844*D1**2*f*fd*s**2 + 780*D1**2*f*fd*s - 401*D1**2*f*fd + 140*D1**2*f*fdd*r**2 + 942*D1**2*f*fdd*r*s - 401*D1**2*f*fdd*r + 828*D1**2*f*fdd*s**2 - 740*D1**2*f*fdd*s + 379*D1**2*f*fdd + 140*D1**2*fd**2*r**2 + 942*D1**2*fd**2*r*s - 401*D1**2*fd**2*r + 828*D1**2*fd**2*s**2 - 740*D1**2*fd**2*s - 88*D1**2*fd**2 - 224*D1*Dd*f**2*r**2 - 1948*D1*Dd*f**2*r*s + 1086*D1*Dd*f**2*r - 1688*D1*Dd*f**2*s**2 + 2175*D1*Dd*f**2*s - 900*D1*Dd*f**2 + 1120*D1*Dd*f*fd*r**2 + 7536*D1*Dd*f*fd*r*s - 3768*D1*Dd*f*fd*r + 6624*D1*Dd*f*fd*s**2 - 7214*D1*Dd*f*fd*s + 1881*D1*Dd*f*fd + 280*D1*Ddd*f**2*r**2 + 1884*D1*Ddd*f**2*r*s - 1082*D1*Ddd*f**2*r + 1656*D1*Ddd*f**2*s**2 - 2127*D1*Ddd*f**2*s + 898*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(2*C*(34*r**2 - 2*r*(6*s + 17) - 46*s**2 + 6*s + 17) - 34*r**2 + 34*r + 34*s**2 - 17) + 2*fd*(2*C*(18*r**2 + 76*r*s - 47*r + 58*s**2 - 77*s + 19) - 18*r**2 - 80*r*s + 49*r - 62*s**2 + 82*s - 20)) + 2*Dd*f*(2*C*(72*r**2 + 304*r*s - 130*r + 232*s**2 - 230*s + 47) - 72*r**2 - 320*r*s + 134*r - 248*s**2 + 244*s - 49)) + 840*Dd**2*f**2*r**2 + 5652*Dd**2*f**2*r*s - 3246*Dd**2*f**2*r + 4968*Dd**2*f**2*s**2 - 6381*Dd**2*f**2*s + 1770*Dd**2*f**2) + f*(1110*C*D1**2*f*fd*r**2 + 4380*C*D1**2*f*fd*r*s - 2200*C*D1**2*f*fd*r + 2436*C*D1**2*f*fd*s**2 - 3084*C*D1**2*f*fd*s + 1182*C*D1**2*f*fd - 1122*C*D1**2*f*fdd*r**2 - 4188*C*D1**2*f*fdd*r*s + 2144*C*D1**2*f*fdd*r - 2352*C*D1**2*f*fdd*s**2 + 2964*C*D1**2*f*fdd*s - 1158*C*D1**2*f*fdd - 2244*C*D1**2*fd**2*r**2 - 8376*C*D1**2*fd**2*r*s + 4288*C*D1**2*fd**2*r - 4704*C*D1**2*fd**2*s**2 + 5928*C*D1**2*fd**2*s - 1396*C*D1**2*fd**2 + 1480*C*D1*Dd*f**2*r**2 + 5840*C*D1*Dd*f**2*r*s - 3660*C*D1*Dd*f**2*r + 3248*C*D1*Dd*f**2*s**2 - 4708*C*D1*Dd*f**2*s + 1994*C*D1*Dd*f**2 - 8976*C*D1*Dd*f*fd*r**2 - 33504*C*D1*Dd*f*fd*r*s + 19196*C*D1*Dd*f*fd*r - 18816*C*D1*Dd*f*fd*s**2 + 25452*C*D1*Dd*f*fd*s - 8072*C*D1*Dd*f*fd - 1496*C*D1*Ddd*f**2*r**2 - 5584*C*D1*Ddd*f**2*r*s + 3540*C*D1*Ddd*f**2*r - 3136*C*D1*Ddd*f**2*s**2 + 4532*C*D1*Ddd*f**2*s - 1942*C*D1*Ddd*f**2 - 4488*C*Dd**2*f**2*r**2 - 16752*C*Dd**2*f**2*r*s + 10620*C*Dd**2*f**2*r - 9408*C*Dd**2*f**2*s**2 + 13596*C*Dd**2*f**2*s - 4360*C*Dd**2*f**2 + 42*D1**2*bd1**2*(r**2*(18*C - 9) + r*(76*C*s - 18*C - 40*s + 9) + s*(58*C*s - 38*C - 31*s + 20)) - 3*D1**2*bdd1*f*(2*C*(70*r**2 + 436*r*s - 210*r + 369*s**2 - 518*s + 105) - 70*r**2 - 471*r*s + 210*r - 414*s**2 + 559*s - 105) - 555*D1**2*f*fd*r**2 - 2379*D1**2*f*fd*r*s + 1163*D1**2*f*fd*r - 1389*D1**2*f*fd*s**2 + 1719*D1**2*f*fd*s - 648*D1**2*f*fd + 561*D1**2*f*fdd*r**2 + 2283*D1**2*f*fdd*r*s - 1135*D1**2*f*fdd*r + 1383*D1**2*f*fdd*s**2 - 1683*D1**2*f*fdd*s + 648*D1**2*f*fdd + 1122*D1**2*fd**2*r**2 + 4566*D1**2*fd**2*r*s - 2270*D1**2*fd**2*r + 2766*D1**2*fd**2*s**2 - 3366*D1**2*fd**2*s + 761*D1**2*fd**2 - 740*D1*Dd*f**2*r**2 - 3172*D1*Dd*f**2*r*s + 1956*D1*Dd*f**2*r - 1852*D1*Dd*f**2*s**2 + 2645*D1*Dd*f**2*s - 1111*D1*Dd*f**2 + 4488*D1*Dd*f*fd*r**2 + 18264*D1*Dd*f*fd*r*s - 10228*D1*Dd*f*fd*r + 11064*D1*Dd*f*fd*s**2 - 14547*D1*Dd*f*fd*s + 4501*D1*Dd*f*fd + 748*D1*Ddd*f**2*r**2 + 3044*D1*Ddd*f**2*r*s - 1896*D1*Ddd*f**2*r + 1844*D1*Ddd*f**2*s**2 - 2605*D1*Ddd*f**2*s + 1109*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(2*C*(56*r**2 + 452*r*s - 154*r + 381*s**2 - 518*s + 77) - 56*r**2 - 487*r*s + 154*r - 422*s**2 + 551*s - 77) + fd*(-4*C*(140*r**2 + 872*r*s - 393*r + 738*s**2 - 846*s + 259) + 280*r**2 + 1884*r*s - 821*r + 1656*s**2 - 1858*s + 559)) + Dd*f*(-4*C*(280*r**2 + 1744*r*s - 926*r + 1476*s**2 - 1992*s + 623) + 560*r**2 + 3768*r*s - 1922*r + 3312*s**2 - 4363*s + 1328)) + 2244*Dd**2*f**2*r**2 + 9132*Dd**2*f**2*r*s - 5688*Dd**2*f**2*r + 5532*Dd**2*f**2*s**2 - 7815*Dd**2*f**2*s + 2444*Dd**2*f**2))/(315*d**2*k3**4) - D1**2*Pk1*Pk3*k1**2*(-560*D1**2*K*bd1**2*f*r**2 - 1232*D1**2*K*bd1**2*f*r*s + 1526*D1**2*K*bd1**2*f*r - 644*D1**2*K*bd1**2*f*s**2 + 1554*D1**2*K*bd1**2*f*s - 910*D1**2*K*bd1**2*f + 321*D1**2*K*bd1*f**2*r**2 + 474*D1**2*K*bd1*f**2*r*s - 474*D1**2*K*bd1*f**2*r + 191*D1**2*K*bd1*f**2*s**2 - 382*D1**2*K*bd1*f**2*s + 191*D1**2*K*bd1*f**2 - 1356*D1**2*K*bd1*f*fd*r**2 - 2376*D1**2*K*bd1*f*fd*r*s + 1866*D1**2*K*bd1*f*fd*r - 956*D1**2*K*bd1*f*fd*s**2 + 1550*D1**2*K*bd1*f*fd*s - 594*D1**2*K*bd1*f*fd - 339*D1**2*K*bdd1*f**2*r**2 - 594*D1**2*K*bdd1*f**2*r*s + 594*D1**2*K*bdd1*f**2*r - 239*D1**2*K*bdd1*f**2*s**2 + 478*D1**2*K*bdd1*f**2*s - 239*D1**2*K*bdd1*f**2 + 210*D1**2*bd1**2*f**2*r*s - 105*D1**2*bd1**2*f**2*r + 210*D1**2*bd1**2*f**2*s**2 - 357*D1**2*bd1**2*f**2*s + 147*D1**2*bd1**2*f**2 + 210*D1**2*bd1**2*f*r*s - 105*D1**2*bd1**2*f*r + 182*D1**2*bd1**2*f*s**2 - 329*D1**2*bd1**2*f*s + 147*D1**2*bd1**2*f - 980*D1**2*bd1**2*g2*r**2 - 1960*D1**2*bd1**2*g2*r*s + 980*D1**2*bd1**2*g2*r - 980*D1**2*bd1**2*g2*s**2 + 980*D1**2*bd1**2*g2*s - 350*D1**2*bd1*bd2*f*r**2 - 700*D1**2*bd1*bd2*f*r*s + 700*D1**2*bd1*bd2*f*r - 350*D1**2*bd1*bd2*f*s**2 + 700*D1**2*bd1*bd2*f*s - 350*D1**2*bd1*bd2*f - 105*D1**2*bd1*f**3*r*s + 105*D1**2*bd1*f**3*r - 72*D1**2*bd1*f**3*s**2 + 186*D1**2*bd1*f**3*s - 93*D1**2*bd1*f**3 + 630*D1**2*bd1*f**2*fd*r*s - 420*D1**2*bd1*f**2*fd*r + 432*D1**2*bd1*f**2*fd*s**2 - 765*D1**2*bd1*f**2*fd*s + 291*D1**2*bd1*f**2*fd - 63*D1**2*bd1*f**2*r*s + 63*D1**2*bd1*f**2*r - 69*D1**2*bd1*f**2*s**2 + 138*D1**2*bd1*f**2*s - 69*D1**2*bd1*f**2 + 420*D1**2*bd1*f*fd*r*s - 210*D1**2*bd1*f*fd*r + 348*D1**2*bd1*f*fd*s**2 - 453*D1**2*bd1*f*fd*s + 105*D1**2*bd1*f*fd - 420*D1**2*bd1*f*g2*r**2 - 1064*D1**2*bd1*f*g2*r*s + 1260*D1**2*bd1*f*g2*r - 728*D1**2*bd1*f*g2*s**2 + 1260*D1**2*bd1*f*g2*s - 630*D1**2*bd1*f*g2 + 1120*D1**2*bd1*f*gd2*r**2 + 2464*D1**2*bd1*f*gd2*r*s - 3052*D1**2*bd1*f*gd2*r + 1288*D1**2*bd1*f*gd2*s**2 - 3108*D1**2*bd1*f*gd2*s + 1820*D1**2*bd1*f*gd2 + 1120*D1**2*bd1*fd*g2*r**2 + 2464*D1**2*bd1*fd*g2*r*s - 1120*D1**2*bd1*fd*g2*r + 1288*D1**2*bd1*fd*g2*s**2 - 1232*D1**2*bd1*fd*g2*s + 111*D1**2*bd2*f**2*r**2 + 174*D1**2*bd2*f**2*r*s - 174*D1**2*bd2*f**2*r + 63*D1**2*bd2*f**2*s**2 - 126*D1**2*bd2*f**2*s + 63*D1**2*bd2*f**2 - 516*D1**2*bd2*f*fd*r**2 - 936*D1**2*bd2*f*fd*r*s + 726*D1**2*bd2*f*fd*r - 420*D1**2*bd2*f*fd*s**2 + 654*D1**2*bd2*f*fd*s - 234*D1**2*bd2*f*fd + 105*D1**2*bdd1*f**3*r*s - 105*D1**2*bdd1*f**3*r + 72*D1**2*bdd1*f**3*s**2 - 186*D1**2*bdd1*f**3*s + 93*D1**2*bdd1*f**3 + 105*D1**2*bdd1*f**2*r*s - 105*D1**2*bdd1*f**2*r + 87*D1**2*bdd1*f**2*s**2 - 174*D1**2*bdd1*f**2*s + 87*D1**2*bdd1*f**2 + 560*D1**2*bdd1*f*g2*r**2 + 1232*D1**2*bdd1*f*g2*r*s - 1820*D1**2*bdd1*f*g2*r + 644*D1**2*bdd1*f*g2*s**2 - 1820*D1**2*bdd1*f*g2*s + 910*D1**2*bdd1*f*g2 - 129*D1**2*bdd2*f**2*r**2 - 234*D1**2*bdd2*f**2*r*s + 234*D1**2*bdd2*f**2*r - 105*D1**2*bdd2*f**2*s**2 + 210*D1**2*bdd2*f**2*s - 105*D1**2*bdd2*f**2 + 60*D1**2*f**3*fd*s**2 - 60*D1**2*f**3*fd*s + 30*D1**2*f**3*fd - 60*D1**2*f**3*fdd*s**2 + 60*D1**2*f**3*fdd*s - 30*D1**2*f**3*fdd - 180*D1**2*f**2*fd**2*s**2 + 180*D1**2*f**2*fd**2*s - 30*D1**2*f**2*fd**2 - 642*D1**2*f**2*gd2*r**2 - 948*D1**2*f**2*gd2*r*s + 948*D1**2*f**2*gd2*r - 382*D1**2*f**2*gd2*s**2 + 764*D1**2*f**2*gd2*s - 382*D1**2*f**2*gd2 + 678*D1**2*f**2*gdd2*r**2 + 1188*D1**2*f**2*gdd2*r*s - 1188*D1**2*f**2*gdd2*r + 478*D1**2*f**2*gdd2*s**2 - 956*D1**2*f**2*gdd2*s + 478*D1**2*f**2*gdd2 - 1284*D1**2*f*fd*g2*r**2 - 1896*D1**2*f*fd*g2*r*s + 1284*D1**2*f*fd*g2*r - 764*D1**2*f*fd*g2*s**2 + 948*D1**2*f*fd*g2*s - 642*D1**2*f*fd*g2 + 2712*D1**2*f*fd*gd2*r**2 + 4752*D1**2*f*fd*gd2*r*s - 3732*D1**2*f*fd*gd2*r + 1912*D1**2*f*fd*gd2*s**2 - 3100*D1**2*f*fd*gd2*s + 1188*D1**2*f*fd*gd2 + 1356*D1**2*f*fdd*g2*r**2 + 2376*D1**2*f*fdd*g2*r*s - 1356*D1**2*f*fdd*g2*r + 956*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 678*D1**2*f*fdd*g2 + 1356*D1**2*fd**2*g2*r**2 + 2376*D1**2*fd**2*g2*r*s - 1356*D1**2*fd**2*g2*r + 956*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s - 2712*D1*Dd*K*bd1*f**2*r**2 - 4752*D1*Dd*K*bd1*f**2*r*s + 4242*D1*Dd*K*bd1*f**2*r - 1912*D1*Dd*K*bd1*f**2*s**2 + 3462*D1*Dd*K*bd1*f**2*s - 1550*D1*Dd*K*bd1*f**2 + 840*D1*Dd*bd1*f**3*r*s - 630*D1*Dd*bd1*f**3*r + 576*D1*Dd*bd1*f**3*s**2 - 1137*D1*Dd*bd1*f**3*s + 477*D1*Dd*bd1*f**3 + 840*D1*Dd*bd1*f**2*r*s - 630*D1*Dd*bd1*f**2*r + 696*D1*Dd*bd1*f**2*s**2 - 1149*D1*Dd*bd1*f**2*s + 453*D1*Dd*bd1*f**2 + 4480*D1*Dd*bd1*f*g2*r**2 + 9856*D1*Dd*bd1*f*g2*r*s - 10864*D1*Dd*bd1*f*g2*r + 5152*D1*Dd*bd1*f*g2*s**2 - 11088*D1*Dd*bd1*f*g2*s + 5460*D1*Dd*bd1*f*g2 - 1032*D1*Dd*bd2*f**2*r**2 - 1872*D1*Dd*bd2*f**2*r*s + 1662*D1*Dd*bd2*f**2*r - 840*D1*Dd*bd2*f**2*s**2 + 1494*D1*Dd*bd2*f**2*s - 654*D1*Dd*bd2*f**2 + 60*D1*Dd*f**4*s**2 - 60*D1*Dd*f**4*s + 30*D1*Dd*f**4 - 480*D1*Dd*f**3*fd*s**2 + 480*D1*Dd*f**3*fd*s - 120*D1*Dd*f**3*fd - 2568*D1*Dd*f**2*g2*r**2 - 3792*D1*Dd*f**2*g2*r*s + 3180*D1*Dd*f**2*g2*r - 1528*D1*Dd*f**2*g2*s**2 + 2476*D1*Dd*f**2*g2*s - 1406*D1*Dd*f**2*g2 + 5424*D1*Dd*f**2*gd2*r**2 + 9504*D1*Dd*f**2*gd2*r*s - 8484*D1*Dd*f**2*gd2*r + 3824*D1*Dd*f**2*gd2*s**2 - 6924*D1*Dd*f**2*gd2*s + 3100*D1*Dd*f**2*gd2 + 10848*D1*Dd*f*fd*g2*r**2 + 19008*D1*Dd*f*fd*g2*r*s - 12888*D1*Dd*f*fd*g2*r + 7648*D1*Dd*f*fd*g2*s**2 - 10952*D1*Dd*f*fd*g2*s + 3732*D1*Dd*f*fd*g2 - 60*D1*Ddd*f**4*s**2 + 60*D1*Ddd*f**4*s - 30*D1*Ddd*f**4 + 2712*D1*Ddd*f**2*g2*r**2 + 4752*D1*Ddd*f**2*g2*r*s - 3732*D1*Ddd*f**2*g2*r + 1912*D1*Ddd*f**2*g2*s**2 - 3100*D1*Ddd*f**2*g2*s + 1634*D1*Ddd*f**2*g2 - 180*Dd**2*f**4*s**2 + 180*Dd**2*f**4*s - 30*Dd**2*f**4 + 8136*Dd**2*f**2*g2*r**2 + 14256*Dd**2*f**2*g2*r*s - 11196*Dd**2*f**2*g2*r + 5736*Dd**2*f**2*g2*s**2 - 9300*Dd**2*f**2*g2*s + 3332*Dd**2*f**2*g2 + 35*b1**3*(2*D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(28*K*r**2 + 56*K*r*s - 42*K*r + 28*K*s**2 - 42*K*s + 21*K + 2*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 2*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5) - 8*r*s + 4*r - 8*s**2 + 10*s - 4) + Ddd*(7*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 8*r*s + 4*r - 8*s**2 + 10*s - 4)) - 2*Dd**2*(-21*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4) + 12*r*s - 6*r + 12*s**2 - 15*s + 4)) + 7*b1**2*(30*D1**2*K*fd*r**2 + 76*D1**2*K*fd*r*s + 30*D1**2*K*fd*r + 52*D1**2*K*fd*s**2 + 14*D1**2*K*fd*s - 15*D1**2*K*fd - 40*D1**2*K*fdd*r**2 - 88*D1**2*K*fdd*r*s - 50*D1**2*K*fdd*r - 46*D1**2*K*fdd*s**2 - 42*D1**2*K*fdd*s + 25*D1**2*K*fdd - 5*D1**2*bdd1*(-7*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + 6*r*s - 2*r + 6*s**2 - 6*s + 2) - 30*D1**2*f*fd*r*s + 15*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 15*D1**2*f*fd + 30*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 24*D1**2*f*fdd*s + 15*D1**2*f*fdd + 30*D1**2*fd**2*r*s - 15*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 24*D1**2*fd**2*s - 6*D1**2*fd**2 - 5*D1**2*fd*r*s - 11*D1**2*fd*s**2 - 2*D1**2*fd*s + 15*D1**2*fdd*r*s + 13*D1**2*fdd*s**2 + 6*D1**2*fdd*s - 70*D1**2*gd2*r**2 - 140*D1**2*gd2*r*s + 140*D1**2*gd2*r - 70*D1**2*gd2*s**2 + 140*D1**2*gd2*s - 70*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 + 120*D1*Dd*K*f*r**2 + 304*D1*Dd*K*f*r*s - 212*D1*Dd*K*f*r + 208*D1*Dd*K*f*s**2 - 284*D1*Dd*K*f*s + 134*D1*Dd*K*f - 320*D1*Dd*K*fd*r**2 - 704*D1*Dd*K*fd*r*s + 56*D1*Dd*K*fd*r - 368*D1*Dd*K*fd*s**2 + 104*D1*Dd*K*fd*s + 134*D1*Dd*K*fd - 60*D1*Dd*f**2*r*s + 30*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 75*D1*Dd*f**2*s - 30*D1*Dd*f**2 + 240*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 246*D1*Dd*f*fd*s + 63*D1*Dd*f*fd - 20*D1*Dd*f*r*s + 10*D1*Dd*f*r - 44*D1*Dd*f*s**2 + 49*D1*Dd*f*s - 22*D1*Dd*f + 120*D1*Dd*fd*r*s - 30*D1*Dd*fd*r + 104*D1*Dd*fd*s**2 - 43*D1*Dd*fd*s - 12*D1*Dd*fd - 280*D1*Dd*g2*r**2 - 560*D1*Dd*g2*r*s + 420*D1*Dd*g2*r - 280*D1*Dd*g2*s**2 + 420*D1*Dd*g2*s - 210*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 - 160*D1*Ddd*K*f*r**2 - 352*D1*Ddd*K*f*r*s + 256*D1*Ddd*K*f*r - 184*D1*Ddd*K*f*s**2 + 272*D1*Ddd*K*f*s - 132*D1*Ddd*K*f + 60*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 75*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + 60*D1*Ddd*f*r*s - 30*D1*Ddd*f*r + 52*D1*Ddd*f*s**2 - 67*D1*Ddd*f*s + 26*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 5*D1*bd1*(D1*(21*K*r**2 + 42*K*r*s - 28*K*r + 21*K*s**2 - 28*K*s + 14*K + f*(r*(6*s - 2) + 6*s**2 - 6*s + 2) - 2*fd*(6*r*s - 4*r + 6*s**2 - 9*s + 3) - 6*r*s + 2*r - 6*s**2 + 6*s - 2) - 2*Dd*(-7*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + 24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 480*Dd**2*K*f*r**2 - 1056*Dd**2*K*f*r*s + 768*Dd**2*K*f*r - 552*Dd**2*K*f*s**2 + 816*Dd**2*K*f*s - 268*Dd**2*K*f + 180*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 225*Dd**2*f**2*s + 60*Dd**2*f**2 + 180*Dd**2*f*r*s - 90*Dd**2*f*r + 156*Dd**2*f*s**2 - 201*Dd**2*f*s + 56*Dd**2*f - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) - b1*(560*D1**2*K*bdd1*f*r**2 + 1232*D1**2*K*bdd1*f*r*s - 1526*D1**2*K*bdd1*f*r + 644*D1**2*K*bdd1*f*s**2 - 1554*D1**2*K*bdd1*f*s + 777*D1**2*K*bdd1*f - 642*D1**2*K*f*fd*r**2 - 948*D1**2*K*f*fd*r*s + 642*D1**2*K*f*fd*r - 382*D1**2*K*f*fd*s**2 + 474*D1**2*K*f*fd*s - 321*D1**2*K*f*fd + 678*D1**2*K*f*fdd*r**2 + 1188*D1**2*K*f*fdd*r*s - 678*D1**2*K*f*fdd*r + 478*D1**2*K*f*fdd*s**2 - 594*D1**2*K*f*fdd*s + 339*D1**2*K*f*fdd + 678*D1**2*K*fd**2*r**2 + 1188*D1**2*K*fd**2*r*s - 678*D1**2*K*fd**2*r + 478*D1**2*K*fd**2*s**2 - 594*D1**2*K*fd**2*s - 105*D1**2*b2*fd*r**2 - 210*D1**2*b2*fd*r*s - 105*D1**2*b2*fd*s**2 + 175*D1**2*b2*fdd*r**2 + 350*D1**2*b2*fdd*r*s + 175*D1**2*b2*fdd*s**2 + 70*D1**2*bd1**2*(-7*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*r*s - 2*r + 6*s**2 - 6*s + 1) - 210*D1**2*bdd1*f**2*r*s + 105*D1**2*bdd1*f**2*r - 210*D1**2*bdd1*f**2*s**2 + 357*D1**2*bdd1*f**2*s - 105*D1**2*bdd1*f**2 - 210*D1**2*bdd1*f*r*s + 105*D1**2*bdd1*f*r - 182*D1**2*bdd1*f*s**2 + 329*D1**2*bdd1*f*s - 91*D1**2*bdd1*f + 980*D1**2*bdd1*g2*r**2 + 1960*D1**2*bdd1*g2*r*s - 980*D1**2*bdd1*g2*r + 980*D1**2*bdd1*g2*s**2 - 980*D1**2*bdd1*g2*s + 490*D1**2*bdd1*g2 + 175*D1**2*bdd2*f*r**2 + 350*D1**2*bdd2*f*r*s - 350*D1**2*bdd2*f*r + 175*D1**2*bdd2*f*s**2 - 350*D1**2*bdd2*f*s + 175*D1**2*bdd2*f + 315*D1**2*f**2*fd*r*s - 105*D1**2*f**2*fd*r + 216*D1**2*f**2*fd*s**2 - 207*D1**2*f**2*fd*s + 51*D1**2*f**2*fd - 315*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r - 216*D1**2*f**2*fdd*s**2 + 207*D1**2*f**2*fdd*s - 51*D1**2*f**2*fdd - 630*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r - 432*D1**2*f*fd**2*s**2 + 414*D1**2*f*fd**2*s - 63*D1**2*f*fd**2 + 126*D1**2*f*fd*r*s + 138*D1**2*f*fd*s**2 - 63*D1**2*f*fd*s - 210*D1**2*f*fdd*r*s - 174*D1**2*f*fdd*s**2 + 105*D1**2*f*fdd*s + 420*D1**2*f*gd2*r**2 + 1064*D1**2*f*gd2*r*s - 1064*D1**2*f*gd2*r + 728*D1**2*f*gd2*s**2 - 1456*D1**2*f*gd2*s + 728*D1**2*f*gd2 - 560*D1**2*f*gdd2*r**2 - 1232*D1**2*f*gdd2*r*s + 1232*D1**2*f*gdd2*r - 644*D1**2*f*gdd2*s**2 + 1288*D1**2*f*gdd2*s - 644*D1**2*f*gdd2 - 210*D1**2*fd**2*r*s - 174*D1**2*fd**2*s**2 + 105*D1**2*fd**2*s + 420*D1**2*fd*g2*r**2 + 1064*D1**2*fd*g2*r*s + 420*D1**2*fd*g2*r + 728*D1**2*fd*g2*s**2 + 196*D1**2*fd*g2*s - 210*D1**2*fd*g2 - 1120*D1**2*fd*gd2*r**2 - 2464*D1**2*fd*gd2*r*s + 532*D1**2*fd*gd2*r - 1288*D1**2*fd*gd2*s**2 + 700*D1**2*fd*gd2*s + 588*D1**2*fd*gd2 - 560*D1**2*fdd*g2*r**2 - 1232*D1**2*fdd*g2*r*s - 700*D1**2*fdd*g2*r - 644*D1**2*fdd*g2*s**2 - 588*D1**2*fdd*g2*s + 350*D1**2*fdd*g2 - 1284*D1*Dd*K*f**2*r**2 - 1896*D1*Dd*K*f**2*r*s + 1590*D1*Dd*K*f**2*r - 764*D1*Dd*K*f**2*s**2 + 1238*D1*Dd*K*f**2*s - 703*D1*Dd*K*f**2 + 5424*D1*Dd*K*f*fd*r**2 + 9504*D1*Dd*K*f*fd*r*s - 6444*D1*Dd*K*f*fd*r + 3824*D1*Dd*K*f*fd*s**2 - 5476*D1*Dd*K*f*fd*s + 1866*D1*Dd*K*f*fd - 420*D1*Dd*b2*f*r**2 - 840*D1*Dd*b2*f*r*s + 630*D1*Dd*b2*f*r - 420*D1*Dd*b2*f*s**2 + 630*D1*Dd*b2*f*s - 315*D1*Dd*b2*f + 1400*D1*Dd*b2*fd*r**2 + 2800*D1*Dd*b2*fd*r*s - 1050*D1*Dd*b2*fd*r + 1400*D1*Dd*b2*fd*s**2 - 1050*D1*Dd*b2*fd*s + 420*D1*Dd*f**3*r*s - 210*D1*Dd*f**3*r + 288*D1*Dd*f**3*s**2 - 393*D1*Dd*f**3*s + 144*D1*Dd*f**3 - 2520*D1*Dd*f**2*fd*r*s + 1050*D1*Dd*f**2*fd*r - 1728*D1*Dd*f**2*fd*s**2 + 2007*D1*Dd*f**2*fd*s - 519*D1*Dd*f**2*fd + 252*D1*Dd*f**2*r*s - 126*D1*Dd*f**2*r + 276*D1*Dd*f**2*s**2 - 339*D1*Dd*f**2*s + 138*D1*Dd*f**2 - 1680*D1*Dd*f*fd*r*s + 420*D1*Dd*f*fd*r - 1392*D1*Dd*f*fd*s**2 + 1326*D1*Dd*f*fd*s - 210*D1*Dd*f*fd + 1680*D1*Dd*f*g2*r**2 + 4256*D1*Dd*f*g2*r*s - 2968*D1*Dd*f*g2*r + 2912*D1*Dd*f*g2*s**2 - 3976*D1*Dd*f*g2*s + 1876*D1*Dd*f*g2 - 4480*D1*Dd*f*gd2*r**2 - 9856*D1*Dd*f*gd2*r*s + 8512*D1*Dd*f*gd2*r - 5152*D1*Dd*f*gd2*s**2 + 8960*D1*Dd*f*gd2*s - 3808*D1*Dd*f*gd2 - 4480*D1*Dd*fd*g2*r**2 - 9856*D1*Dd*fd*g2*r*s + 784*D1*Dd*fd*g2*r - 5152*D1*Dd*fd*g2*s**2 + 1456*D1*Dd*fd*g2*s + 1876*D1*Dd*fd*g2 + 1356*D1*Ddd*K*f**2*r**2 + 2376*D1*Ddd*K*f**2*r*s - 1866*D1*Ddd*K*f**2*r + 956*D1*Ddd*K*f**2*s**2 - 1550*D1*Ddd*K*f**2*s + 817*D1*Ddd*K*f**2 + 700*D1*Ddd*b2*f*r**2 + 1400*D1*Ddd*b2*f*r*s - 1050*D1*Ddd*b2*f*r + 700*D1*Ddd*b2*f*s**2 - 1050*D1*Ddd*b2*f*s + 525*D1*Ddd*b2*f - 420*D1*Ddd*f**3*r*s + 210*D1*Ddd*f**3*r - 288*D1*Ddd*f**3*s**2 + 393*D1*Ddd*f**3*s - 144*D1*Ddd*f**3 - 420*D1*Ddd*f**2*r*s + 210*D1*Ddd*f**2*r - 348*D1*Ddd*f**2*s**2 + 453*D1*Ddd*f**2*s - 174*D1*Ddd*f**2 - 2240*D1*Ddd*f*g2*r**2 - 4928*D1*Ddd*f*g2*r*s + 3584*D1*Ddd*f*g2*r - 2576*D1*Ddd*f*g2*s**2 + 3808*D1*Ddd*f*g2*s - 1848*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(3*f**2*(5*r*(2*s - 1) + 10*s**2 - 17*s + 5) - f*(K*(60*r**2 + 2*r*(76*s - 83) + 104*s**2 - 194*s + 97) + 15*fd*(2*s - 1)*(4*r + 4*s - 3) - 10*r*s + 5*r - 22*s**2 + 29*s - 11) + fd*(2*K*(80*r**2 + r*(176*s - 59) + 92*s**2 - 69*s - 21) + r*(15 - 60*s) - 52*s**2 + 35*s + 6) + 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*(-3*f**2*(2*s - 1)*(40*r + 40*s - 39) + f*(2*K*(320*r**2 + 704*r*s - 692*r + 368*s**2 - 716*s + 331) - (2*s - 1)*(120*r + 104*s - 109)) + 140*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 35*D1*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 4068*Dd**2*K*f**2*r**2 + 7128*Dd**2*K*f**2*r*s - 5598*Dd**2*K*f**2*r + 2868*Dd**2*K*f**2*s**2 - 4650*Dd**2*K*f**2*s + 1666*Dd**2*K*f**2 + 2100*Dd**2*b2*f*r**2 + 4200*Dd**2*b2*f*r*s - 3150*Dd**2*b2*f*r + 2100*Dd**2*b2*f*s**2 - 3150*Dd**2*b2*f*s + 1050*Dd**2*b2*f - 1260*Dd**2*f**3*r*s + 630*Dd**2*f**3*r - 864*Dd**2*f**3*s**2 + 1179*Dd**2*f**3*s - 354*Dd**2*f**3 - 1260*Dd**2*f**2*r*s + 630*Dd**2*f**2*r - 1044*Dd**2*f**2*s**2 + 1359*Dd**2*f**2*s - 384*Dd**2*f**2 - 6720*Dd**2*f*g2*r**2 - 14784*Dd**2*f*g2*r*s + 10752*Dd**2*f*g2*r - 7728*Dd**2*f*g2*s**2 + 11424*Dd**2*f*g2*s - 3752*Dd**2*f*g2) + b2*(-175*D1**2*bdd1*f*(r + s - 1)**2 + 3*D1**2*(f*(fd*(74*r**2 + 116*r*s - 74*r + 42*s**2 - 58*s + 37) - fdd*(86*r**2 + 156*r*s - 86*r + 70*s**2 - 78*s + 43)) - 2*fd**2*(43*r**2 + r*(78*s - 43) + s*(35*s - 39))) + 35*D1*bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 3*D1*f*(Dd*(f*(148*r**2 + 232*r*s - 190*r + 84*s**2 - 142*s + 79) - 2*fd*(344*r**2 + 624*r*s - 414*r + 280*s**2 - 374*s + 121)) - Ddd*f*(172*r**2 + r*(312*s - 242) + 140*s**2 - 218*s + 113)) - 6*Dd**2*f**2*(258*r**2 + r*(468*s - 363) + 210*s**2 - 327*s + 113)))/(105*d**2*k3**4) - D1**2*Pk1*Pk3*k1**2*st**4*(8*C - 4)*(42*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s))) + 21*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(-f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*s*(-21*bd1**2*s + fd**2*(3*s - 2))) + 2*D1*f*(2*Dd*(f*(-2*s**2 + 2*s - 1) + fd*(6*s**2 - 5*s + 1)) + Ddd*f*(2*s**2 - 2*s + 1)) + 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(105*d**2*k2**2*k3**2) + D1**2*Pk1*Pk3*k1**2*st**2*(2*C - 1)*(70*D1*b1*s*(-5*D1*bdd1*f*s + bd1*(7*D1*f*s - 10*D1*fd*(s - 1) + 20*Dd*f*(1 - 2*s))) + 35*b1**2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + 2*D1*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(2*s**2 - 3*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(-3*f*(7*fd - 5*fdd)*(3*s**2 - 2*s + 1) + 10*s*(-35*bd1**2*s + fd**2*(9*s - 6))) - 6*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(6*s**2 - 5*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) + 30*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(105*d**2*k2**2*k3**2) - D1**2*Pk1*Pk3*k1**2*(2*C - 1)*(10*D1*b1*s*(-D1*bdd1*f*s + bd1*(D1*f*s - 2*D1*fd*(s - 1) + Dd*f*(4 - 8*s))) + 5*b1**2*(D1**2*(fd - fdd)*(s - 1)**2 + 2*D1*(Dd*(2*f*s**2 - 2*f*s + f - 4*fd*s**2 + 6*fd*s - 2*fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(-f*(fd - fdd)*(3*s**2 - 2*s + 1) + 2*s*(-5*bd1**2*s + fd**2*(3*s - 2))) + 2*D1*f*(-Dd*f*(2*s**2 - 2*s + 1) + 2*Dd*fd*(6*s**2 - 5*s + 1) + Ddd*f*(2*s**2 - 2*s + 1)) + 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(5*d**2*k2**2*k3**2) + 4*D1**2*Pk1*Pk3*k2**6*st**6*(99*b1**2*(D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*f*(-9*D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 18*D1*bd1*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 2*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f**2*(-198*D1**2*bd1**2*(r + s - 1)**2 + 44*D1**2*bdd1*f*(r + s - 1)**2 - 15*D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 88*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 15*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**8) + 4*D1**2*Pk1*Pk3*k2**4*st**6*(216*C*D1**2*b1*f*fd*r**2 + 288*C*D1**2*b1*f*fd*r*s - 144*C*D1**2*b1*f*fd*r + 72*C*D1**2*b1*f*fd*s**2 - 72*C*D1**2*b1*f*fd*s + 36*C*D1**2*b1*f*fd - 108*C*D1**2*b1*f*fdd*r**2 - 144*C*D1**2*b1*f*fdd*r*s + 72*C*D1**2*b1*f*fdd*r - 36*C*D1**2*b1*f*fdd*s**2 + 36*C*D1**2*b1*f*fdd*s - 18*C*D1**2*b1*f*fdd - 108*C*D1**2*b1*fd**2*r**2 - 144*C*D1**2*b1*fd**2*r*s + 72*C*D1**2*b1*fd**2*r - 36*C*D1**2*b1*fd**2*s**2 + 36*C*D1**2*b1*fd**2*s + 36*C*D1**2*f**2*fd*r**2 + 48*C*D1**2*f**2*fd*r*s - 40*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 16*C*D1**2*f**2*fd - 18*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 20*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 36*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 40*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 432*C*D1*Dd*b1*f**2*r**2 + 576*C*D1*Dd*b1*f**2*r*s - 504*C*D1*Dd*b1*f**2*r + 144*C*D1*Dd*b1*f**2*s**2 - 288*C*D1*Dd*b1*f**2*s + 180*C*D1*Dd*b1*f**2 - 864*C*D1*Dd*b1*f*fd*r**2 - 1152*C*D1*Dd*b1*f*fd*r*s + 792*C*D1*Dd*b1*f*fd*r - 288*C*D1*Dd*b1*f*fd*s**2 + 432*C*D1*Dd*b1*f*fd*s - 144*C*D1*Dd*b1*f*fd + 48*C*D1*Dd*f**3*r**2 + 64*C*D1*Dd*f**3*r*s - 56*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 32*C*D1*Dd*f**3*s + 20*C*D1*Dd*f**3 - 144*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 164*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 96*C*D1*Dd*f**2*fd*s - 44*C*D1*Dd*f**2*fd - 216*C*D1*Ddd*b1*f**2*r**2 - 288*C*D1*Ddd*b1*f**2*r*s + 252*C*D1*Ddd*b1*f**2*r - 72*C*D1*Ddd*b1*f**2*s**2 + 144*C*D1*Ddd*b1*f**2*s - 90*C*D1*Ddd*b1*f**2 - 24*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 28*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 16*C*D1*Ddd*f**3*s - 10*C*D1*Ddd*f**3 - 648*C*Dd**2*b1*f**2*r**2 - 864*C*Dd**2*b1*f**2*r*s + 756*C*Dd**2*b1*f**2*r - 216*C*Dd**2*b1*f**2*s**2 + 432*C*Dd**2*b1*f**2*s - 180*C*Dd**2*b1*f**2 - 72*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 84*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 48*C*Dd**2*f**3*s - 20*C*Dd**2*f**3 - 144*D1**2*b1*f*fd*r**2 - 180*D1**2*b1*f*fd*r*s + 90*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 72*D1**2*b1*f*fdd*r**2 + 90*D1**2*b1*f*fdd*r*s - 45*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 72*D1**2*b1*fd**2*r**2 + 90*D1**2*b1*fd**2*r*s - 45*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)*(2*C*(3*r + s - 3) - 4*r - s + 4) - 24*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 26*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 14*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 13*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 7*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 24*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 26*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 14*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 - 288*D1*Dd*b1*f**2*r**2 - 360*D1*Dd*b1*f**2*r*s + 324*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 162*D1*Dd*b1*f**2*s - 108*D1*Dd*b1*f**2 + 576*D1*Dd*b1*f*fd*r**2 + 720*D1*Dd*b1*f*fd*r*s - 504*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 234*D1*Dd*b1*f*fd*s + 81*D1*Dd*b1*f*fd - 32*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 18*D1*Dd*f**3*s - 12*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 106*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 55*D1*Dd*f**2*fd*s + 27*D1*Dd*f**2*fd + 144*D1*Ddd*b1*f**2*r**2 + 180*D1*Ddd*b1*f**2*r*s - 162*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 81*D1*Ddd*b1*f**2*s + 54*D1*Ddd*b1*f**2 + 16*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 18*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 9*D1*Ddd*f**3*s + 6*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(2*f*(r + s - 1)*(2*C*(3*r + s - 3) - 4*r - s + 4) + fd*(-4*C*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + 16*r**2 + 20*r*s - 21*r + 4*s**2 - 12*s + 5)) + Dd*f*(-4*C*(12*r**2 + 16*r*s - 19*r + 4*s**2 - 12*s + 7) + 32*r**2 + 40*r*s - 50*r + 8*s**2 - 29*s + 18)) + 432*Dd**2*b1*f**2*r**2 + 540*Dd**2*b1*f**2*r*s - 486*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 243*Dd**2*b1*f**2*s + 108*Dd**2*b1*f**2 + 48*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 54*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 27*Dd**2*f**3*s + 12*Dd**2*f**3)/(63*d**2*k3**6) + 2*D1**2*Pk1*Pk3*k2**4*st**4*(-2772*C*D1**2*bd1*f**2*r**2 - 3696*C*D1**2*bd1*f**2*r*s + 5544*C*D1**2*bd1*f**2*r - 924*C*D1**2*bd1*f**2*s**2 + 3696*C*D1**2*bd1*f**2*s - 2772*C*D1**2*bd1*f**2 - 1188*C*D1**2*f**2*fd*r**2 - 1584*C*D1**2*f**2*fd*r*s + 1320*C*D1**2*f**2*fd*r - 396*C*D1**2*f**2*fd*s**2 + 792*C*D1**2*f**2*fd*s - 528*C*D1**2*f**2*fd - 1584*C*D1*Dd*f**3*r**2 - 2112*C*D1*Dd*f**3*r*s + 1848*C*D1*Dd*f**3*r - 528*C*D1*Dd*f**3*s**2 + 1056*C*D1*Dd*f**3*s - 660*C*D1*Dd*f**3 - 2772*D1**2*K*bd1**2*f*r**2 - 3696*D1**2*K*bd1**2*f*r*s + 4620*D1**2*K*bd1**2*f*r - 924*D1**2*K*bd1**2*f*s**2 + 2772*D1**2*K*bd1**2*f*s - 1848*D1**2*K*bd1**2*f + 396*D1**2*K*bd1*f**2*r**2 + 528*D1**2*K*bd1*f**2*r*s - 528*D1**2*K*bd1*f**2*r + 132*D1**2*K*bd1*f**2*s**2 - 264*D1**2*K*bd1*f**2*s + 132*D1**2*K*bd1*f**2 - 792*D1**2*K*bd1*f*fd*r**2 - 1056*D1**2*K*bd1*f*fd*r*s + 924*D1**2*K*bd1*f*fd*r - 264*D1**2*K*bd1*f*fd*s**2 + 528*D1**2*K*bd1*f*fd*s - 264*D1**2*K*bd1*f*fd - 198*D1**2*K*bdd1*f**2*r**2 - 264*D1**2*K*bdd1*f**2*r*s + 264*D1**2*K*bdd1*f**2*r - 66*D1**2*K*bdd1*f**2*s**2 + 132*D1**2*K*bdd1*f**2*s - 66*D1**2*K*bdd1*f**2 + 4026*D1**2*bd1**2*f**2*r**2 + 8976*D1**2*bd1**2*f**2*r*s - 8250*D1**2*bd1**2*f**2*r + 4950*D1**2*bd1**2*f**2*s**2 - 9174*D1**2*bd1**2*f**2*s + 4224*D1**2*bd1**2*f**2 + 924*D1**2*bd1**2*f*r**2 + 924*D1**2*bd1**2*f*r*s - 1386*D1**2*bd1**2*f*r - 462*D1**2*bd1**2*f*s + 462*D1**2*bd1**2*f - 924*D1**2*bd1*bd2*f*r**2 - 1848*D1**2*bd1*bd2*f*r*s + 1848*D1**2*bd1*bd2*f*r - 924*D1**2*bd1*bd2*f*s**2 + 1848*D1**2*bd1*bd2*f*s - 924*D1**2*bd1*bd2*f - 22*D1**2*bd1*f**3*r**2 + 462*D1**2*bd1*f**3*r*s - 462*D1**2*bd1*f**3*r + 484*D1**2*bd1*f**3*s**2 - 968*D1**2*bd1*f**3*s + 352*D1**2*bd1*f**3 - 528*D1**2*bd1*f**2*fd*r**2 - 5148*D1**2*bd1*f**2*fd*r*s + 3080*D1**2*bd1*f**2*fd*r - 4620*D1**2*bd1*f**2*fd*s**2 + 6490*D1**2*bd1*f**2*fd*s - 2266*D1**2*bd1*f**2*fd + 1716*D1**2*bd1*f**2*r**2 + 2178*D1**2*bd1*f**2*r*s - 3564*D1**2*bd1*f**2*r + 462*D1**2*bd1*f**2*s**2 - 2310*D1**2*bd1*f**2*s + 1848*D1**2*bd1*f**2 + 264*D1**2*bd1*f*fd*r**2 + 264*D1**2*bd1*f*fd*r*s - 264*D1**2*bd1*f*fd*r - 66*D1**2*bd1*f*fd*s + 66*D1**2*bd1*f*fd - 5544*D1**2*bd1*f*g2*r**2 - 7392*D1**2*bd1*f*g2*r*s + 11088*D1**2*bd1*f*g2*r - 1848*D1**2*bd1*f*g2*s**2 + 7392*D1**2*bd1*f*g2*s - 5544*D1**2*bd1*f*g2 + 5544*D1**2*bd1*f*gd2*r**2 + 7392*D1**2*bd1*f*gd2*r*s - 9240*D1**2*bd1*f*gd2*r + 1848*D1**2*bd1*f*gd2*s**2 - 5544*D1**2*bd1*f*gd2*s + 3696*D1**2*bd1*f*gd2 + 5544*D1**2*bd1*fd*g2*r**2 + 7392*D1**2*bd1*fd*g2*r*s - 5544*D1**2*bd1*fd*g2*r + 1848*D1**2*bd1*fd*g2*s**2 - 3696*D1**2*bd1*fd*g2*s + 132*D1**2*bd2*f**2*r**2 + 264*D1**2*bd2*f**2*r*s - 264*D1**2*bd2*f**2*r + 132*D1**2*bd2*f**2*s**2 - 264*D1**2*bd2*f**2*s + 132*D1**2*bd2*f**2 - 264*D1**2*bd2*f*fd*r**2 - 528*D1**2*bd2*f*fd*r*s + 396*D1**2*bd2*f*fd*r - 264*D1**2*bd2*f*fd*s**2 + 396*D1**2*bd2*f*fd*s - 132*D1**2*bd2*f*fd - 88*D1**2*bdd1*f**3*r**2 - 858*D1**2*bdd1*f**3*r*s + 594*D1**2*bdd1*f**3*r - 770*D1**2*bdd1*f**3*s**2 + 1276*D1**2*bdd1*f**3*s - 440*D1**2*bdd1*f**3 + 66*D1**2*bdd1*f**2*r**2 + 66*D1**2*bdd1*f**2*r*s - 66*D1**2*bdd1*f**2*r + 2772*D1**2*bdd1*f*g2*r**2 + 3696*D1**2*bdd1*f*g2*r*s - 5544*D1**2*bdd1*f*g2*r + 924*D1**2*bdd1*f*g2*s**2 - 3696*D1**2*bdd1*f*g2*s + 2772*D1**2*bdd1*f*g2 - 66*D1**2*bdd2*f**2*r**2 - 132*D1**2*bdd2*f**2*r*s + 132*D1**2*bdd2*f**2*r - 66*D1**2*bdd2*f**2*s**2 + 132*D1**2*bdd2*f**2*s - 66*D1**2*bdd2*f**2 + 1380*D1**2*f**3*fd*r**2 + 2744*D1**2*f**3*fd*r*s - 2062*D1**2*f**3*fd*r + 1364*D1**2*f**3*fd*s**2 - 2050*D1**2*f**3*fd*s + 1027*D1**2*f**3*fd - 1548*D1**2*f**3*fdd*r**2 - 3176*D1**2*f**3*fdd*r*s + 2362*D1**2*f**3*fdd*r - 1628*D1**2*f**3*fdd*s**2 + 2422*D1**2*f**3*fdd*s - 1201*D1**2*f**3*fdd - 4644*D1**2*f**2*fd**2*r**2 - 9528*D1**2*f**2*fd**2*r*s + 7086*D1**2*f**2*fd**2*r - 4884*D1**2*f**2*fd**2*s**2 + 7266*D1**2*f**2*fd**2*s - 2402*D1**2*f**2*fd**2 + 792*D1**2*f**2*fd*r**2 + 990*D1**2*f**2*fd*r*s - 858*D1**2*f**2*fd*r + 198*D1**2*f**2*fd*s**2 - 462*D1**2*f**2*fd*s + 330*D1**2*f**2*fd - 792*D1**2*f**2*gd2*r**2 - 1056*D1**2*f**2*gd2*r*s + 1056*D1**2*f**2*gd2*r - 264*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s - 264*D1**2*f**2*gd2 + 396*D1**2*f**2*gdd2*r**2 + 528*D1**2*f**2*gdd2*r*s - 528*D1**2*f**2*gdd2*r + 132*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 132*D1**2*f**2*gdd2 - 1584*D1**2*f*fd*g2*r**2 - 2112*D1**2*f*fd*g2*r*s + 1584*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 792*D1**2*f*fd*g2 + 1584*D1**2*f*fd*gd2*r**2 + 2112*D1**2*f*fd*gd2*r*s - 1848*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 1056*D1**2*f*fd*gd2*s + 528*D1**2*f*fd*gd2 + 792*D1**2*f*fdd*g2*r**2 + 1056*D1**2*f*fdd*g2*r*s - 792*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 528*D1**2*f*fdd*g2*s + 396*D1**2*f*fdd*g2 + 792*D1**2*fd**2*g2*r**2 + 1056*D1**2*fd**2*g2*r*s - 792*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 528*D1**2*fd**2*g2*s - 1584*D1*Dd*K*bd1*f**2*r**2 - 2112*D1*Dd*K*bd1*f**2*r*s + 1980*D1*Dd*K*bd1*f**2*r - 528*D1*Dd*K*bd1*f**2*s**2 + 1056*D1*Dd*K*bd1*f**2*s - 528*D1*Dd*K*bd1*f**2 - 704*D1*Dd*bd1*f**3*r**2 - 6864*D1*Dd*bd1*f**3*r*s + 4268*D1*Dd*bd1*f**3*r - 6160*D1*Dd*bd1*f**3*s**2 + 9042*D1*Dd*bd1*f**3*s - 3146*D1*Dd*bd1*f**3 + 528*D1*Dd*bd1*f**2*r**2 + 528*D1*Dd*bd1*f**2*r*s - 528*D1*Dd*bd1*f**2*r - 66*D1*Dd*bd1*f**2*s + 66*D1*Dd*bd1*f**2 + 22176*D1*Dd*bd1*f*g2*r**2 + 29568*D1*Dd*bd1*f*g2*r*s - 35112*D1*Dd*bd1*f*g2*r + 7392*D1*Dd*bd1*f*g2*s**2 - 22176*D1*Dd*bd1*f*g2*s + 12936*D1*Dd*bd1*f*g2 - 528*D1*Dd*bd2*f**2*r**2 - 1056*D1*Dd*bd2*f**2*r*s + 924*D1*Dd*bd2*f**2*r - 528*D1*Dd*bd2*f**2*s**2 + 924*D1*Dd*bd2*f**2*s - 396*D1*Dd*bd2*f**2 + 1380*D1*Dd*f**4*r**2 + 2744*D1*Dd*f**4*r*s - 2062*D1*Dd*f**4*r + 1364*D1*Dd*f**4*s**2 - 2050*D1*Dd*f**4*s + 1027*D1*Dd*f**4 - 12384*D1*Dd*f**3*fd*r**2 - 25408*D1*Dd*f**3*fd*r*s + 18896*D1*Dd*f**3*fd*r - 13024*D1*Dd*f**3*fd*s**2 + 19376*D1*Dd*f**3*fd*s - 7206*D1*Dd*f**3*fd + 1056*D1*Dd*f**3*r**2 + 1320*D1*Dd*f**3*r*s - 1188*D1*Dd*f**3*r + 264*D1*Dd*f**3*s**2 - 594*D1*Dd*f**3*s + 396*D1*Dd*f**3 - 3168*D1*Dd*f**2*g2*r**2 - 4224*D1*Dd*f**2*g2*r*s + 3696*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 2112*D1*Dd*f**2*g2*s - 1320*D1*Dd*f**2*g2 + 3168*D1*Dd*f**2*gd2*r**2 + 4224*D1*Dd*f**2*gd2*r*s - 3960*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 2112*D1*Dd*f**2*gd2*s + 1056*D1*Dd*f**2*gd2 + 6336*D1*Dd*f*fd*g2*r**2 + 8448*D1*Dd*f*fd*g2*r*s - 6864*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 4224*D1*Dd*f*fd*g2*s + 1848*D1*Dd*f*fd*g2 - 1548*D1*Ddd*f**4*r**2 - 3176*D1*Ddd*f**4*r*s + 2362*D1*Ddd*f**4*r - 1628*D1*Ddd*f**4*s**2 + 2422*D1*Ddd*f**4*s - 1201*D1*Ddd*f**4 + 1584*D1*Ddd*f**2*g2*r**2 + 2112*D1*Ddd*f**2*g2*r*s - 1848*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 1056*D1*Ddd*f**2*g2*s + 660*D1*Ddd*f**2*g2 - 4644*Dd**2*f**4*r**2 - 9528*Dd**2*f**4*r*s + 7086*Dd**2*f**4*r - 4884*Dd**2*f**4*s**2 + 7266*Dd**2*f**4*s - 2402*Dd**2*f**4 + 4752*Dd**2*f**2*g2*r**2 + 6336*Dd**2*f**2*g2*r*s - 5544*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 3168*Dd**2*f**2*g2*s + 1320*Dd**2*f**2*g2 + 462*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(84*D1**2*K*fd*r**2 + 112*D1**2*K*fd*r*s + 28*D1**2*K*fd*s**2 - 42*D1**2*K*fdd*r**2 - 56*D1**2*K*fdd*r*s - 14*D1**2*K*fdd*s**2 - 14*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 118*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r*s + 148*D1**2*f*fd*r - 146*D1**2*f*fd*s**2 + 162*D1**2*f*fd*s - 81*D1**2*f*fd + 122*D1**2*f*fdd*r**2 + 272*D1**2*f*fdd*r*s - 144*D1**2*f*fdd*r + 150*D1**2*f*fdd*s**2 - 158*D1**2*f*fdd*s + 79*D1**2*f*fdd + 122*D1**2*fd**2*r**2 + 272*D1**2*fd**2*r*s - 144*D1**2*fd**2*r + 150*D1**2*fd**2*s**2 - 158*D1**2*fd**2*s + 8*D1**2*fd**2 - 28*D1**2*fd*r**2 - 28*D1**2*fd*r*s + 14*D1**2*fdd*r**2 + 14*D1**2*fdd*r*s + 336*D1*Dd*K*f*r**2 + 448*D1*Dd*K*f*r*s - 392*D1*Dd*K*f*r + 112*D1*Dd*K*f*s**2 - 224*D1*Dd*K*f*s + 140*D1*Dd*K*f - 336*D1*Dd*K*fd*r**2 - 448*D1*Dd*K*fd*r*s + 196*D1*Dd*K*fd*r - 112*D1*Dd*K*fd*s**2 + 112*D1*Dd*K*fd*s - 236*D1*Dd*f**2*r**2 - 528*D1*Dd*f**2*r*s + 382*D1*Dd*f**2*r - 292*D1*Dd*f**2*s**2 + 424*D1*Dd*f**2*s - 205*D1*Dd*f**2 + 976*D1*Dd*f*fd*r**2 + 2176*D1*Dd*f*fd*r*s - 1364*D1*Dd*f*fd*r + 1200*D1*Dd*f*fd*s**2 - 1504*D1*Dd*f*fd*s + 460*D1*Dd*f*fd - 112*D1*Dd*f*r**2 - 112*D1*Dd*f*r*s + 112*D1*Dd*f*r + 28*D1*Dd*f*s - 28*D1*Dd*f + 112*D1*Dd*fd*r**2 + 112*D1*Dd*fd*r*s - 56*D1*Dd*fd*r - 14*D1*Dd*fd*s - 168*D1*Ddd*K*f*r**2 - 224*D1*Ddd*K*f*r*s + 196*D1*Ddd*K*f*r - 56*D1*Ddd*K*f*s**2 + 112*D1*Ddd*K*f*s - 70*D1*Ddd*K*f + 244*D1*Ddd*f**2*r**2 + 544*D1*Ddd*f**2*r*s - 394*D1*Ddd*f**2*r + 300*D1*Ddd*f**2*s**2 - 436*D1*Ddd*f**2*s + 211*D1*Ddd*f**2 + 56*D1*Ddd*f*r**2 + 56*D1*Ddd*f*r*s - 56*D1*Ddd*f*r - 14*D1*Ddd*f*s + 14*D1*Ddd*f + 28*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 504*Dd**2*K*f*r**2 - 672*Dd**2*K*f*r*s + 588*Dd**2*K*f*r - 168*Dd**2*K*f*s**2 + 336*Dd**2*K*f*s - 140*Dd**2*K*f + 732*Dd**2*f**2*r**2 + 1632*Dd**2*f**2*r*s - 1182*Dd**2*f**2*r + 900*Dd**2*f**2*s**2 - 1308*Dd**2*f**2*s + 422*Dd**2*f**2 + 168*Dd**2*f*r**2 + 168*Dd**2*f*r*s - 168*Dd**2*f*r - 42*Dd**2*f*s + 28*Dd**2*f) - 22*b1*(252*C*D1**2*f*fd*r**2 + 336*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r + 84*C*D1**2*f*fd*s**2 - 84*C*D1**2*f*fd*s + 42*C*D1**2*f*fd + 504*C*D1*Dd*f**2*r**2 + 672*C*D1*Dd*f**2*r*s - 588*C*D1*Dd*f**2*r + 168*C*D1*Dd*f**2*s**2 - 336*C*D1*Dd*f**2*s + 210*C*D1*Dd*f**2 + 126*D1**2*K*bdd1*f*r**2 + 168*D1**2*K*bdd1*f*r*s - 210*D1**2*K*bdd1*f*r + 42*D1**2*K*bdd1*f*s**2 - 126*D1**2*K*bdd1*f*s + 84*D1**2*K*bdd1*f - 36*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 36*D1**2*K*f*fd*r - 12*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 18*D1**2*K*f*fd + 18*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r*s - 18*D1**2*K*f*fdd*r + 6*D1**2*K*f*fdd*s**2 - 12*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 18*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r*s - 18*D1**2*K*fd**2*r + 6*D1**2*K*fd**2*s**2 - 12*D1**2*K*fd**2*s - 42*D1**2*b2*fd*r**2 - 84*D1**2*b2*fd*r*s - 42*D1**2*b2*fd*s**2 + 21*D1**2*b2*fdd*r**2 + 42*D1**2*b2*fdd*r*s + 21*D1**2*b2*fdd*s**2 + 42*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 183*D1**2*bdd1*f**2*r**2 - 408*D1**2*bdd1*f**2*r*s + 375*D1**2*bdd1*f**2*r - 225*D1**2*bdd1*f**2*s**2 + 417*D1**2*bdd1*f**2*s - 198*D1**2*bdd1*f**2 - 42*D1**2*bdd1*f*r**2 - 42*D1**2*bdd1*f*r*s + 63*D1**2*bdd1*f*r + 21*D1**2*bdd1*f*s - 21*D1**2*bdd1*f + 21*D1**2*bdd2*f*r**2 + 42*D1**2*bdd2*f*r*s - 42*D1**2*bdd2*f*r + 21*D1**2*bdd2*f*s**2 - 42*D1**2*bdd2*f*s + 21*D1**2*bdd2*f + 3*D1**2*f**2*fd*r**2 - 63*D1**2*f**2*fd*r*s + 19*D1**2*f**2*fd*r - 66*D1**2*f**2*fd*s**2 + 65*D1**2*f**2*fd*s - 27*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 117*D1**2*f**2*fdd*r*s - 59*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 121*D1**2*f**2*fdd*s + 54*D1**2*f**2*fdd + 24*D1**2*f*fd**2*r**2 + 234*D1**2*f*fd**2*r*s - 118*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 242*D1**2*f*fd**2*s + 45*D1**2*f*fd**2 - 156*D1**2*f*fd*r**2 - 198*D1**2*f*fd*r*s + 93*D1**2*f*fd*r - 42*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 15*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r + 3*D1**2*f*fdd*s - 3*D1**2*f*fdd + 252*D1**2*f*gd2*r**2 + 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r + 84*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s + 84*D1**2*f*gd2 - 126*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 42*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s - 42*D1**2*f*gdd2 - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 3*D1**2*fd**2*s + 252*D1**2*fd*g2*r**2 + 336*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*s**2 - 252*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 84*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s - 126*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*s**2 - 72*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 84*D1*Dd*K*f**2*r - 24*D1*Dd*K*f**2*s**2 + 48*D1*Dd*K*f**2*s - 30*D1*Dd*K*f**2 + 144*D1*Dd*K*f*fd*r**2 + 192*D1*Dd*K*f*fd*r*s - 156*D1*Dd*K*f*fd*r + 48*D1*Dd*K*f*fd*s**2 - 96*D1*Dd*K*f*fd*s + 42*D1*Dd*K*f*fd - 168*D1*Dd*b2*f*r**2 - 336*D1*Dd*b2*f*r*s + 252*D1*Dd*b2*f*r - 168*D1*Dd*b2*f*s**2 + 252*D1*Dd*b2*f*s - 126*D1*Dd*b2*f + 168*D1*Dd*b2*fd*r**2 + 336*D1*Dd*b2*fd*r*s - 126*D1*Dd*b2*fd*r + 168*D1*Dd*b2*fd*s**2 - 126*D1*Dd*b2*fd*s + 4*D1*Dd*f**3*r**2 - 84*D1*Dd*f**3*r*s + 40*D1*Dd*f**3*r - 88*D1*Dd*f**3*s**2 + 109*D1*Dd*f**3*s - 43*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 936*D1*Dd*f**2*fd*r*s - 494*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 1021*D1*Dd*f**2*fd*s + 301*D1*Dd*f**2*fd - 312*D1*Dd*f**2*r**2 - 396*D1*Dd*f**2*r*s + 354*D1*Dd*f**2*r - 84*D1*Dd*f**2*s**2 + 183*D1*Dd*f**2*s - 120*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r + 18*D1*Dd*f*fd*s - 12*D1*Dd*f*fd + 1008*D1*Dd*f*g2*r**2 + 1344*D1*Dd*f*g2*r*s - 1176*D1*Dd*f*g2*r + 336*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 420*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1260*D1*Dd*f*gd2*r - 336*D1*Dd*f*gd2*s**2 + 672*D1*Dd*f*gd2*s - 336*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 588*D1*Dd*fd*g2*r - 336*D1*Dd*fd*g2*s**2 + 336*D1*Dd*fd*g2*s + 36*D1*Ddd*K*f**2*r**2 + 48*D1*Ddd*K*f**2*r*s - 42*D1*Ddd*K*f**2*r + 12*D1*Ddd*K*f**2*s**2 - 24*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 + 84*D1*Ddd*b2*f*r**2 + 168*D1*Ddd*b2*f*r*s - 126*D1*Ddd*b2*f*r + 84*D1*Ddd*b2*f*s**2 - 126*D1*Ddd*b2*f*s + 63*D1*Ddd*b2*f + 16*D1*Ddd*f**3*r**2 + 156*D1*Ddd*f**3*r*s - 86*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 179*D1*Ddd*f**3*s + 74*D1*Ddd*f**3 - 12*D1*Ddd*f**2*r**2 - 12*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r + 3*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 588*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s**2 + 336*D1*Ddd*f*g2*s - 210*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(f**2*(59*r**2 + 3*r*(44*s - 39) + 73*s**2 - 131*s + 62) - f*(fd*(244*r**2 + r*(544*s - 394) + 300*s**2 - 436*s + 143) + (14*r + 14*s - 14)*(2*K*(3*r + s - 2) - 2*r + 1)) + 7*fd*(K*s*(4*s - 6) + r**2*(12*K - 4) + r*(2*K*(8*s - 5) - 4*s + 3) + s)) + Dd*f*(14*K*(24*r**2 + 32*r*s - 34*r + 8*s**2 - 20*s + 11) - f*(488*r**2 + 2*r*(544*s - 447) + 600*s**2 - 992*s + 403) - 112*r**2 - 112*r*s + 140*r + 42*s - 35)) - 42*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 108*Dd**2*K*f**2*r**2 + 144*Dd**2*K*f**2*r*s - 126*Dd**2*K*f**2*r + 36*Dd**2*K*f**2*s**2 - 72*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 + 252*Dd**2*b2*f*r**2 + 504*Dd**2*b2*f*r*s - 378*Dd**2*b2*f*r + 252*Dd**2*b2*f*s**2 - 378*Dd**2*b2*f*s + 126*Dd**2*b2*f + 48*Dd**2*f**3*r**2 + 468*Dd**2*f**3*r*s - 258*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 537*Dd**2*f**3*s + 148*Dd**2*f**3 - 36*Dd**2*f**2*r**2 - 36*Dd**2*f**2*r*s + 36*Dd**2*f**2*r + 9*Dd**2*f**2*s - 6*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1764*Dd**2*f*g2*r - 504*Dd**2*f*g2*s**2 + 1008*Dd**2*f*g2*s - 420*Dd**2*f*g2) + 66*b2*(-7*D1**2*bdd1*f*(r + s - 1)**2 + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd*s - 6*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2))/(1155*d**2*k3**6) + 2*D1**2*Pk1*Pk3*k2**2*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(4*C*(r*(4*s - 2) + 2*s**2 - 2*s + 1) + r*(5 - 10*s) - 4*s**2 + 4*s - 2) + fd**2*(-r*(8*C - 5)*(2*s - 1) + 4*s*(-2*C*(s - 1) + s - 1))) + D1*f*(Dd*(2*f*(8*C*(2*s - 1)*(2*r + s - 1) - 20*r*s + 10*r - 8*s**2 + 13*s - 4) - fd*(2*s - 1)*(8*C*(8*r + 4*s - 3) - 40*r - 16*s + 13)) + Ddd*f*(-8*C*(2*s - 1)*(2*r + s - 1) + 20*r*s - 10*r + 8*s**2 - 13*s + 4)) + Dd**2*f**2*(-24*C*(2*s - 1)*(2*r + s - 1) + 30*r*(2*s - 1) + 24*s**2 - 39*s + 14)) + f*(D1**2*(f*(-9*bdd1*s*(4*C*(2*r + s - 2) - 5*r - 2*s + 5) + 2*fd*(4*C*(3*s - 1)*(2*r + s - 1) - 15*r*s + 5*r - 6*s**2 + 9*s - 2) + fdd*(-4*C*(3*s - 1)*(2*r + s - 1) + 15*r*s - 5*r + 6*s**2 - 9*s + 2)) + fd**2*(-8*C*(3*s - 1)*(2*r + s - 1) + 10*r*(3*s - 1) + 12*s**2 - 18*s + 5)) + 9*D1*bd1*(D1*(2*f*s*(4*C*(2*r + s - 2) - 5*r - 2*s + 5) + fd*(-8*C*(4*r*s - r + 2*s**2 - 3*s + 1) + 20*r*s - 5*r + 8*s**2 - 14*s + 5)) + Dd*f*(-8*C*(8*r*s - 2*r + 4*s**2 - 7*s + 2) + 40*r*s - 10*r + 16*s**2 - 33*s + 10)) + D1*f*(Dd*(2*f*(8*C*(2*s - 1)*(2*r + s - 1) - 20*r*s + 10*r - 8*s**2 + 13*s - 4) + fd*(-8*C*(12*s - 5)*(2*r + s - 1) + 120*r*s - 50*r + 48*s**2 - 75*s + 23)) + Ddd*f*(-8*C*(2*s - 1)*(2*r + s - 1) + 20*r*s - 10*r + 8*s**2 - 13*s + 4)) + Dd**2*f**2*(-24*C*(2*s - 1)*(2*r + s - 1) + 30*r*(2*s - 1) + 24*s**2 - 39*s + 14)))/(63*d**2*k3**4) + D1**2*Pk1*Pk3*k2**2*st**4*(42*b1**2*(4*C - 3)*(D1**2*r*(2*fd - fdd)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-8*r**2 - 8*r*(s - 1) + s - 1)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + 3*b1*(-144*C*D1**2*f*fd*r**2 - 672*C*D1**2*f*fd*r*s + 304*C*D1**2*f*fd*r - 288*C*D1**2*f*fd*s**2 + 272*C*D1**2*f*fd*s - 128*C*D1**2*f*fd + 268*C*D1**2*f*fdd*r**2 + 672*C*D1**2*f*fdd*r*s - 320*C*D1**2*f*fdd*r + 256*C*D1**2*f*fdd*s**2 - 248*C*D1**2*f*fdd*s + 120*C*D1**2*f*fdd + 268*C*D1**2*fd**2*r**2 + 672*C*D1**2*fd**2*r*s - 320*C*D1**2*fd**2*r + 256*C*D1**2*fd**2*s**2 - 248*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 - 288*C*D1*Dd*f**2*r**2 - 1344*C*D1*Dd*f**2*r*s + 816*C*D1*Dd*f**2*r - 576*C*D1*Dd*f**2*s**2 + 912*C*D1*Dd*f**2*s - 360*C*D1*Dd*f**2 + 2144*C*D1*Dd*f*fd*r**2 + 5376*C*D1*Dd*f*fd*r*s - 3160*C*D1*Dd*f*fd*r + 2048*C*D1*Dd*f*fd*s**2 - 2688*C*D1*Dd*f*fd*s + 816*C*D1*Dd*f*fd + 536*C*D1*Ddd*f**2*r**2 + 1344*C*D1*Ddd*f**2*r*s - 940*C*D1*Ddd*f**2*r + 512*C*D1*Ddd*f**2*s**2 - 848*C*D1*Ddd*f**2*s + 390*C*D1*Ddd*f**2 + 1608*C*Dd**2*f**2*r**2 + 4032*C*Dd**2*f**2*r*s - 2820*C*Dd**2*f**2*r + 1536*C*Dd**2*f**2*s**2 - 2544*C*Dd**2*f**2*s + 928*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + 2*r*(s - 1) - s + 1) + 120*D1**2*f*fd*r**2 + 434*D1**2*f*fd*r*s - 193*D1**2*f*fd*r + 130*D1**2*f*fd*s**2 - 118*D1**2*f*fd*s + 53*D1**2*f*fd - 172*D1**2*f*fdd*r**2 - 434*D1**2*f*fdd*r*s + 205*D1**2*f*fdd*r - 142*D1**2*f*fdd*s**2 + 136*D1**2*f*fdd*s - 65*D1**2*f*fdd - 172*D1**2*fd**2*r**2 - 434*D1**2*fd**2*r*s + 205*D1**2*fd**2*r - 142*D1**2*fd**2*s**2 + 136*D1**2*fd**2*s + 6*D1**2*fd**2 + 240*D1*Dd*f**2*r**2 + 868*D1*Dd*f**2*r*s - 554*D1*Dd*f**2*r + 260*D1*Dd*f**2*s**2 - 477*D1*Dd*f**2*s + 190*D1*Dd*f**2 - 1376*D1*Dd*f*fd*r**2 - 3472*D1*Dd*f*fd*r*s + 2032*D1*Dd*f*fd*r - 1136*D1*Dd*f*fd*s**2 + 1546*D1*Dd*f*fd*s - 477*D1*Dd*f*fd - 344*D1*Ddd*f**2*r**2 - 868*D1*Ddd*f**2*r*s + 606*D1*Ddd*f**2*r - 284*D1*Ddd*f**2*s**2 + 501*D1*Ddd*f**2*s - 228*D1*Ddd*f**2 + 14*D1*bd1*(4*C - 3)*(D1*(f*(4*r**2 + 4*r*(s - 1) - 2*s + 2) + fd*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 1032*Dd**2*f**2*r**2 - 2604*Dd**2*f**2*r*s + 1818*Dd**2*f**2*r - 852*Dd**2*f**2*s**2 + 1503*Dd**2*f**2*s - 576*Dd**2*f**2) + f*(-456*C*D1**2*f*fd*r**2 - 720*C*D1**2*f*fd*r*s + 544*C*D1**2*f*fd*r - 192*C*D1**2*f*fd*s**2 + 368*C*D1**2*f*fd*s - 216*C*D1**2*f*fd + 534*C*D1**2*f*fdd*r**2 + 648*C*D1**2*f*fdd*r*s - 572*C*D1**2*f*fdd*r + 168*C*D1**2*f*fdd*s**2 - 328*C*D1**2*f*fdd*s + 234*C*D1**2*f*fdd + 1068*C*D1**2*fd**2*r**2 + 1296*C*D1**2*fd**2*r*s - 1144*C*D1**2*fd**2*r + 336*C*D1**2*fd**2*s**2 - 656*C*D1**2*fd**2*s + 216*C*D1**2*fd**2 - 608*C*D1*Dd*f**2*r**2 - 960*C*D1*Dd*f**2*r*s + 784*C*D1*Dd*f**2*r - 256*C*D1*Dd*f**2*s**2 + 496*C*D1*Dd*f**2*s - 280*C*D1*Dd*f**2 + 4272*C*D1*Dd*f*fd*r**2 + 5184*C*D1*Dd*f*fd*r*s - 4652*C*D1*Dd*f*fd*r + 1344*C*D1*Dd*f*fd*s**2 - 2632*C*D1*Dd*f*fd*s + 1228*C*D1*Dd*f*fd + 712*C*D1*Ddd*f**2*r**2 + 864*C*D1*Ddd*f**2*r*s - 788*C*D1*Ddd*f**2*r + 224*C*D1*Ddd*f**2*s**2 - 440*C*D1*Ddd*f**2*s + 290*C*D1*Ddd*f**2 + 2136*C*Dd**2*f**2*r**2 + 2592*C*Dd**2*f**2*r*s - 2364*C*Dd**2*f**2*r + 672*C*Dd**2*f**2*s**2 - 1320*C*Dd**2*f**2*s + 544*C*Dd**2*f**2 - 42*D1**2*bd1**2*(4*C - 3)*(2*r**2 + 2*r*(s - 1) - s) + 3*D1**2*bdd1*f*(2*C*(67*r**2 + 2*r*(84*s - 71) + 64*s**2 - 172*s + 71) - 86*r**2 + r*(184 - 217*s) - 71*s**2 + 223*s - 92) + 300*D1**2*f*fd*r**2 + 507*D1**2*f*fd*r*s - 369*D1**2*f*fd*r + 111*D1**2*f*fd*s**2 - 243*D1**2*f*fd*s + 137*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 429*D1**2*f*fdd*r*s + 363*D1**2*f*fdd*r - 105*D1**2*f*fdd*s**2 + 213*D1**2*f*fdd*s - 145*D1**2*f*fdd - 660*D1**2*fd**2*r**2 - 858*D1**2*fd**2*r*s + 726*D1**2*fd**2*r - 210*D1**2*fd**2*s**2 + 426*D1**2*fd**2*s - 143*D1**2*fd**2 + 400*D1*Dd*f**2*r**2 + 676*D1*Dd*f**2*r*s - 538*D1*Dd*f**2*r + 148*D1*Dd*f**2*s**2 - 317*D1*Dd*f**2*s + 174*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 3432*D1*Dd*f*fd*r*s + 2970*D1*Dd*f*fd*r - 840*D1*Dd*f*fd*s**2 + 1701*D1*Dd*f*fd*s - 789*D1*Dd*f*fd - 440*D1*Ddd*f**2*r**2 - 572*D1*Ddd*f**2*r*s + 506*D1*Ddd*f**2*r - 140*D1*Ddd*f**2*s**2 + 283*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(8*C*(9*r**2 + 42*r*s - 22*r + 18*s**2 - 44*s + 11) - 60*r**2 - 217*r*s + 144*r - 65*s**2 + 229*s - 72) + fd*(-8*C*(67*r**2 + 3*r*(56*s - 37) + 64*s**2 - 117*s + 43) + 344*r**2 + 868*r*s - 573*r + 284*s**2 - 582*s + 223)) + Dd*f*(-4*C*(268*r**2 + r*(672*s - 519) + 256*s**2 - 556*s + 243) + 688*r**2 + 2*r*(868*s - 671) + 568*s**2 - 1393*s + 630)) - 1320*Dd**2*f**2*r**2 - 1716*Dd**2*f**2*r*s + 1518*Dd**2*f**2*r - 420*Dd**2*f**2*s**2 + 849*Dd**2*f**2*s - 356*Dd**2*f**2))/(105*d**2*k3**4) - D1**2*Pk1*Pk3*k2**2*st**2*(1386*C*D1**2*bd1*f**2*r**2 + 1848*C*D1**2*bd1*f**2*r*s + 924*C*D1**2*bd1*f**2*r - 462*C*D1**2*bd1*f**2 - 594*C*D1**2*f**2*fd*r**2 + 396*C*D1**2*f**2*fd*r - 198*C*D1**2*f**2*fd - 792*C*D1*Dd*f**3*r**2 + 396*C*D1*Dd*f**3*r - 198*C*D1*Dd*f**3 - 21714*D1**2*K*bd1**2*f*r**2 - 36960*D1**2*K*bd1**2*f*r*s + 42042*D1**2*K*bd1**2*f*r - 12012*D1**2*K*bd1**2*f*s**2 + 31416*D1**2*K*bd1**2*f*s - 19404*D1**2*K*bd1**2*f + 4554*D1**2*K*bd1*f**2*r**2 + 5016*D1**2*K*bd1*f**2*r*s - 5016*D1**2*K*bd1*f**2*r + 660*D1**2*K*bd1*f**2*s**2 - 1320*D1**2*K*bd1*f**2*s + 660*D1**2*K*bd1*f**2 - 23892*D1**2*K*bd1*f*fd*r**2 - 24816*D1**2*K*bd1*f*fd*r*s + 24354*D1**2*K*bd1*f*fd*r - 5016*D1**2*K*bd1*f*fd*s**2 + 11220*D1**2*K*bd1*f*fd*s - 6204*D1**2*K*bd1*f*fd - 5973*D1**2*K*bdd1*f**2*r**2 - 6204*D1**2*K*bdd1*f**2*r*s + 6204*D1**2*K*bdd1*f**2*r - 1254*D1**2*K*bdd1*f**2*s**2 + 2508*D1**2*K*bdd1*f**2*s - 1254*D1**2*K*bdd1*f**2 + 9966*D1**2*bd1**2*f**2*r**2 + 33990*D1**2*bd1**2*f**2*r*s - 27159*D1**2*bd1**2*f**2*r + 24024*D1**2*bd1**2*f**2*s**2 - 38841*D1**2*bd1**2*f**2*s + 16599*D1**2*bd1**2*f**2 + 6930*D1**2*bd1**2*f*r**2 + 13398*D1**2*bd1**2*f*r*s - 14553*D1**2*bd1**2*f*r + 3234*D1**2*bd1**2*f*s**2 - 10395*D1**2*bd1**2*f*s + 7161*D1**2*bd1**2*f - 18480*D1**2*bd1**2*g2*r**2 - 18480*D1**2*bd1**2*g2*r*s + 18480*D1**2*bd1**2*g2*r + 9240*D1**2*bd1**2*g2*s - 11550*D1**2*bd1*bd2*f*r**2 - 23100*D1**2*bd1*bd2*f*r*s + 23100*D1**2*bd1*bd2*f*r - 11550*D1**2*bd1*bd2*f*s**2 + 23100*D1**2*bd1*bd2*f*s - 11550*D1**2*bd1*bd2*f - 3399*D1**2*bd1*f**3*r**2 - 4004*D1**2*bd1*f**3*r*s + 5489*D1**2*bd1*f**3*r + 693*D1**2*bd1*f**3*s**2 + 693*D1**2*bd1*f**3*s - 1837*D1**2*bd1*f**3 + 19998*D1**2*bd1*f**2*fd*r**2 + 27456*D1**2*bd1*f**2*fd*r*s - 27940*D1**2*bd1*f**2*fd*r - 594*D1**2*bd1*f**2*fd*s**2 - 7150*D1**2*bd1*f**2*fd*s + 4521*D1**2*bd1*f**2*fd - 2442*D1**2*bd1*f**2*r**2 - 4389*D1**2*bd1*f**2*r*s + 1617*D1**2*bd1*f**2*r - 693*D1**2*bd1*f**2*s**2 + 924*D1**2*bd1*f**2*s + 231*D1**2*bd1*f**2 + 6732*D1**2*bd1*f*fd*r**2 + 10164*D1**2*bd1*f*fd*r*s - 8448*D1**2*bd1*f*fd*r + 2772*D1**2*bd1*f*fd*s**2 - 5313*D1**2*bd1*f*fd*s + 2541*D1**2*bd1*f*fd - 11088*D1**2*bd1*f*g2*r**2 - 18480*D1**2*bd1*f*g2*r*s + 29568*D1**2*bd1*f*g2*r - 5544*D1**2*bd1*f*g2*s**2 + 22176*D1**2*bd1*f*g2*s - 14784*D1**2*bd1*f*g2 + 43428*D1**2*bd1*f*gd2*r**2 + 73920*D1**2*bd1*f*gd2*r*s - 84084*D1**2*bd1*f*gd2*r + 24024*D1**2*bd1*f*gd2*s**2 - 62832*D1**2*bd1*f*gd2*s + 38808*D1**2*bd1*f*gd2 + 43428*D1**2*bd1*fd*g2*r**2 + 73920*D1**2*bd1*fd*g2*r*s - 43428*D1**2*bd1*fd*g2*r + 24024*D1**2*bd1*fd*g2*s**2 - 36960*D1**2*bd1*fd*g2*s + 2013*D1**2*bd2*f**2*r**2 + 2706*D1**2*bd2*f**2*r*s - 2706*D1**2*bd2*f**2*r + 693*D1**2*bd2*f**2*s**2 - 1386*D1**2*bd2*f**2*s + 693*D1**2*bd2*f**2 - 10956*D1**2*bd2*f*fd*r**2 - 15576*D1**2*bd2*f*fd*r*s + 13266*D1**2*bd2*f*fd*r - 4620*D1**2*bd2*f*fd*s**2 + 8514*D1**2*bd2*f*fd*s - 3894*D1**2*bd2*f*fd + 3333*D1**2*bdd1*f**3*r**2 + 4576*D1**2*bdd1*f**3*r*s - 6061*D1**2*bdd1*f**3*r - 99*D1**2*bdd1*f**3*s**2 - 1485*D1**2*bdd1*f**3*s + 2255*D1**2*bdd1*f**3 + 1683*D1**2*bdd1*f**2*r**2 + 2541*D1**2*bdd1*f**2*r*s - 2541*D1**2*bdd1*f**2*r + 693*D1**2*bdd1*f**2*s**2 - 1386*D1**2*bdd1*f**2*s + 693*D1**2*bdd1*f**2 + 21714*D1**2*bdd1*f*g2*r**2 + 36960*D1**2*bdd1*f*g2*r*s - 47124*D1**2*bdd1*f*g2*r + 12012*D1**2*bdd1*f*g2*s**2 - 38808*D1**2*bdd1*f*g2*s + 23562*D1**2*bdd1*f*g2 - 2739*D1**2*bdd2*f**2*r**2 - 3894*D1**2*bdd2*f**2*r*s + 3894*D1**2*bdd2*f**2*r - 1155*D1**2*bdd2*f**2*s**2 + 2310*D1**2*bdd2*f**2*s - 1155*D1**2*bdd2*f**2 + 1820*D1**2*f**3*fd*r**2 + 9900*D1**2*f**3*fd*r*s - 5860*D1**2*f**3*fd*r + 7128*D1**2*f**3*fd*s**2 - 9603*D1**2*f**3*fd*s + 4019*D1**2*f**3*fd - 1900*D1**2*f**3*fdd*r**2 - 9900*D1**2*f**3*fdd*r*s + 5900*D1**2*f**3*fdd*r - 7128*D1**2*f**3*fdd*s**2 + 9603*D1**2*f**3*fdd*s - 4039*D1**2*f**3*fdd - 5700*D1**2*f**2*fd**2*r**2 - 29700*D1**2*f**2*fd**2*r*s + 17700*D1**2*f**2*fd**2*r - 21384*D1**2*f**2*fd**2*s**2 + 28809*D1**2*f**2*fd**2*s - 8514*D1**2*f**2*fd**2 + 1188*D1**2*f**2*fd*r**2 + 594*D1**2*f**2*fd*r*s - 990*D1**2*f**2*fd*r - 198*D1**2*f**2*fd*s + 396*D1**2*f**2*fd - 9108*D1**2*f**2*gd2*r**2 - 10032*D1**2*f**2*gd2*r*s + 10032*D1**2*f**2*gd2*r - 1320*D1**2*f**2*gd2*s**2 + 2640*D1**2*f**2*gd2*s - 1320*D1**2*f**2*gd2 + 11946*D1**2*f**2*gdd2*r**2 + 12408*D1**2*f**2*gdd2*r*s - 12408*D1**2*f**2*gdd2*r + 2508*D1**2*f**2*gdd2*s**2 - 5016*D1**2*f**2*gdd2*s + 2508*D1**2*f**2*gdd2 - 18216*D1**2*f*fd*g2*r**2 - 20064*D1**2*f*fd*g2*r*s + 18216*D1**2*f*fd*g2*r - 2640*D1**2*f*fd*g2*s**2 + 10032*D1**2*f*fd*g2*s - 9108*D1**2*f*fd*g2 + 47784*D1**2*f*fd*gd2*r**2 + 49632*D1**2*f*fd*gd2*r*s - 48708*D1**2*f*fd*gd2*r + 10032*D1**2*f*fd*gd2*s**2 - 22440*D1**2*f*fd*gd2*s + 12408*D1**2*f*fd*gd2 + 23892*D1**2*f*fdd*g2*r**2 + 24816*D1**2*f*fdd*g2*r*s - 23892*D1**2*f*fdd*g2*r + 5016*D1**2*f*fdd*g2*s**2 - 12408*D1**2*f*fdd*g2*s + 11946*D1**2*f*fdd*g2 + 23892*D1**2*fd**2*g2*r**2 + 24816*D1**2*fd**2*g2*r*s - 23892*D1**2*fd**2*g2*r + 5016*D1**2*fd**2*g2*s**2 - 12408*D1**2*fd**2*g2*s - 47784*D1*Dd*K*bd1*f**2*r**2 - 49632*D1*Dd*K*bd1*f**2*r*s + 49170*D1*Dd*K*bd1*f**2*r - 10032*D1*Dd*K*bd1*f**2*s**2 + 21252*D1*Dd*K*bd1*f**2*s - 11220*D1*Dd*K*bd1*f**2 + 26664*D1*Dd*bd1*f**3*r**2 + 36608*D1*Dd*bd1*f**3*r*s - 40062*D1*Dd*bd1*f**3*r - 792*D1*Dd*bd1*f**3*s**2 - 10120*D1*Dd*bd1*f**3*s + 9031*D1*Dd*bd1*f**3 + 13464*D1*Dd*bd1*f**2*r**2 + 20328*D1*Dd*bd1*f**2*r*s - 18612*D1*Dd*bd1*f**2*r + 5544*D1*Dd*bd1*f**2*s**2 - 10857*D1*Dd*bd1*f**2*s + 5313*D1*Dd*bd1*f**2 + 173712*D1*Dd*bd1*f*g2*r**2 + 295680*D1*Dd*bd1*f*g2*r*s - 305844*D1*Dd*bd1*f*g2*r + 96096*D1*Dd*bd1*f*g2*s**2 - 240240*D1*Dd*bd1*f*g2*s + 124740*D1*Dd*bd1*f*g2 - 21912*D1*Dd*bd2*f**2*r**2 - 31152*D1*Dd*bd2*f**2*r*s + 28842*D1*Dd*bd2*f**2*r - 9240*D1*Dd*bd2*f**2*s**2 + 17754*D1*Dd*bd2*f**2*s - 8514*D1*Dd*bd2*f**2 + 1820*D1*Dd*f**4*r**2 + 9900*D1*Dd*f**4*r*s - 5860*D1*Dd*f**4*r + 7128*D1*Dd*f**4*s**2 - 9603*D1*Dd*f**4*s + 4019*D1*Dd*f**4 - 15200*D1*Dd*f**3*fd*r**2 - 79200*D1*Dd*f**3*fd*r*s + 47200*D1*Dd*f**3*fd*r - 57024*D1*Dd*f**3*fd*s**2 + 76824*D1*Dd*f**3*fd*s - 25106*D1*Dd*f**3*fd + 1584*D1*Dd*f**3*r**2 + 792*D1*Dd*f**3*r*s - 1188*D1*Dd*f**3*r - 198*D1*Dd*f**3*s + 396*D1*Dd*f**3 - 36432*D1*Dd*f**2*g2*r**2 - 40128*D1*Dd*f**2*g2*r*s + 38280*D1*Dd*f**2*g2*r - 5280*D1*Dd*f**2*g2*s**2 + 15312*D1*Dd*f**2*g2*s - 11748*D1*Dd*f**2*g2 + 95568*D1*Dd*f**2*gd2*r**2 + 99264*D1*Dd*f**2*gd2*r*s - 98340*D1*Dd*f**2*gd2*r + 20064*D1*Dd*f**2*gd2*s**2 - 42504*D1*Dd*f**2*gd2*s + 22440*D1*Dd*f**2*gd2 + 191136*D1*Dd*f*fd*g2*r**2 + 198528*D1*Dd*f*fd*g2*r*s - 192984*D1*Dd*f*fd*g2*r + 40128*D1*Dd*f*fd*g2*s**2 - 94512*D1*Dd*f*fd*g2*s + 48708*D1*Dd*f*fd*g2 - 1900*D1*Ddd*f**4*r**2 - 9900*D1*Ddd*f**4*r*s + 5900*D1*Ddd*f**4*r - 7128*D1*Ddd*f**4*s**2 + 9603*D1*Ddd*f**4*s - 4039*D1*Ddd*f**4 + 47784*D1*Ddd*f**2*g2*r**2 + 49632*D1*Ddd*f**2*g2*r*s - 48708*D1*Ddd*f**2*g2*r + 10032*D1*Ddd*f**2*g2*s**2 - 22440*D1*Ddd*f**2*g2*s + 16962*D1*Ddd*f**2*g2 - 5700*Dd**2*f**4*r**2 - 29700*Dd**2*f**4*r*s + 17700*Dd**2*f**4*r - 21384*Dd**2*f**4*s**2 + 28809*Dd**2*f**4*s - 8514*Dd**2*f**4 + 143352*Dd**2*f**2*g2*r**2 + 148896*Dd**2*f**2*g2*r*s - 146124*Dd**2*f**2*g2*r + 30096*Dd**2*f**2*g2*s**2 - 67320*Dd**2*f**2*g2*s + 29832*Dd**2*f**2*g2 + 1155*b1**3*(D1**2*(fd*(r + 3*s - 3) + fdd*(-3*r - 5*s + 5))*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 2*r*(8*s - 5) + 12*s**2 - 16*s + 7) - 2*fd*(12*r**2 + r*(32*s - 27) + 20*s**2 - 34*s + 14) - 2*(4*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*f*(12*r**2 + r*(32*s - 22) + 20*s**2 - 28*s + 13) + 2*Ddd*(2*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 2*Dd**2*(f*(18*r**2 + r*(48*s - 33) + 30*s**2 - 42*s + 13) - (2*K - 1)*(12*r**2 + 12*r*(s - 1) - 3*s + 2))) + 33*b1**2*(280*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 1120*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 1120*C*D1*Dd*f*r - 280*C*D1*Dd*f*s + 280*C*D1*Dd*f + 168*D1**2*K*fd*r**2 + 280*D1**2*K*fd*r*s + 112*D1**2*K*fd*r + 84*D1**2*K*fd*s**2 + 56*D1**2*K*fd*s - 56*D1**2*K*fd - 329*D1**2*K*fdd*r**2 - 560*D1**2*K*fdd*r*s - 56*D1**2*K*fdd*r - 182*D1**2*K*fdd*s**2 - 28*D1**2*K*fdd*s + 28*D1**2*K*fdd - 35*D1**2*bdd1*(f*(9*r**2 + 2*r*(12*s - 7) + 15*s**2 - 18*s + 8) + (2 - 4*K)*(3*r**2 + 3*r*(s - 1) - s + 1)) - 310*D1**2*f*fd*r**2 - 982*D1**2*f*fd*r*s + 493*D1**2*f*fd*r - 672*D1**2*f*fd*s**2 + 734*D1**2*f*fd*s - 356*D1**2*f*fd + 302*D1**2*f*fdd*r**2 + 1030*D1**2*f*fdd*r*s - 509*D1**2*f*fdd*r + 728*D1**2*f*fdd*s**2 - 794*D1**2*f*fdd*s + 388*D1**2*f*fdd + 302*D1**2*fd**2*r**2 + 1030*D1**2*fd**2*r*s - 509*D1**2*fd**2*r + 728*D1**2*fd**2*s**2 - 794*D1**2*fd**2*s + 66*D1**2*fd**2 - 350*D1**2*fd*r**2 - 371*D1**2*fd*r*s + 154*D1**2*fd*r + 7*D1**2*fd*s**2 - 28*D1**2*fd*s + 28*D1**2*fd + 105*D1**2*fdd*r**2 + 203*D1**2*fdd*r*s + 28*D1**2*fdd*r + 49*D1**2*fdd*s**2 + 14*D1**2*fdd*s - 14*D1**2*fdd + 560*D1**2*gd2*r**2 + 560*D1**2*gd2*r*s - 560*D1**2*gd2*r - 280*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r + 672*D1*Dd*K*f*r**2 + 1120*D1*Dd*K*f*r*s - 896*D1*Dd*K*f*r + 336*D1*Dd*K*f*s**2 - 616*D1*Dd*K*f*s + 336*D1*Dd*K*f - 2632*D1*Dd*K*fd*r**2 - 4480*D1*Dd*K*fd*r*s + 1554*D1*Dd*K*fd*r - 1456*D1*Dd*K*fd*s**2 + 1176*D1*Dd*K*fd*s + 112*D1*Dd*K*fd - 620*D1*Dd*f**2*r**2 - 1964*D1*Dd*f**2*r*s + 1292*D1*Dd*f**2*r - 1344*D1*Dd*f**2*s**2 + 1835*D1*Dd*f**2*s - 827*D1*Dd*f**2 + 2416*D1*Dd*f*fd*r**2 + 8240*D1*Dd*f*fd*r*s - 4700*D1*Dd*f*fd*r + 5824*D1*Dd*f*fd*s**2 - 7118*D1*Dd*f*fd*s + 2097*D1*Dd*f*fd - 1400*D1*Dd*f*r**2 - 1484*D1*Dd*f*r*s + 1442*D1*Dd*f*r + 28*D1*Dd*f*s**2 + 343*D1*Dd*f*s - 336*D1*Dd*f + 840*D1*Dd*fd*r**2 + 1624*D1*Dd*fd*r*s - 504*D1*Dd*fd*r + 392*D1*Dd*fd*s**2 - 343*D1*Dd*fd*s - 56*D1*Dd*fd + 2240*D1*Dd*g2*r**2 + 2240*D1*Dd*g2*r*s - 2240*D1*Dd*g2*r - 560*D1*Dd*g2*s + 560*D1*Dd*g2 - 2240*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 2240*D1*Dd*gd2*r + 280*D1*Dd*gd2*s - 280*D1*Dd*gd2 - 1316*D1*Ddd*K*f*r**2 - 2240*D1*Ddd*K*f*r*s + 1778*D1*Ddd*K*f*r - 728*D1*Ddd*K*f*s**2 + 1288*D1*Ddd*K*f*s - 693*D1*Ddd*K*f + 604*D1*Ddd*f**2*r**2 + 2060*D1*Ddd*f**2*r*s - 1332*D1*Ddd*f**2*r + 1456*D1*Ddd*f**2*s**2 - 1971*D1*Ddd*f**2*s + 879*D1*Ddd*f**2 + 420*D1*Ddd*f*r**2 + 812*D1*Ddd*f*r*s - 616*D1*Ddd*f*r + 196*D1*Ddd*f*s**2 - 399*D1*Ddd*f*s + 203*D1*Ddd*f - 1120*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 1120*D1*Ddd*g2*r + 280*D1*Ddd*g2*s - 280*D1*Ddd*g2 + 35*D1*bd1*(D1*(f*(3*r**2 + 6*r*(2*s - 1) + 9*s**2 - 10*s + 4) - 2*fd*(9*r**2 + 24*r*s - 19*r + 15*s**2 - 24*s + 9) - 2*(4*K - 2)*(3*r**2 + 3*r*(s - 1) - s + 1)) - 2*Dd*f*(36*r**2 + r*(96*s - 61) + 60*s**2 - 78*s + 25) + 2*Dd*(2*K - 1)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 3948*Dd**2*K*f*r**2 - 6720*Dd**2*K*f*r*s + 5334*Dd**2*K*f*r - 2184*Dd**2*K*f*s**2 + 3864*Dd**2*K*f*s - 1484*Dd**2*K*f + 1812*Dd**2*f**2*r**2 + 6180*Dd**2*f**2*r*s - 3996*Dd**2*f**2*r + 4368*Dd**2*f**2*s**2 - 5913*Dd**2*f**2*s + 1758*Dd**2*f**2 + 1260*Dd**2*f*r**2 + 2436*Dd**2*f*r*s - 1848*Dd**2*f*r + 588*Dd**2*f*s**2 - 1197*Dd**2*f*s + 504*Dd**2*f - 3360*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 3360*Dd**2*g2*r + 840*Dd**2*g2*s - 560*Dd**2*g2) - 11*b1*(-252*C*D1**2*f*fd*r**2 - 336*C*D1**2*f*fd*r*s + 504*C*D1**2*f*fd*r + 168*C*D1**2*f*fd*s - 168*C*D1**2*f*fd - 504*C*D1*Dd*f**2*r**2 - 672*C*D1*Dd*f**2*r*s + 588*C*D1*Dd*f**2*r + 168*C*D1*Dd*f**2*s - 126*C*D1*Dd*f**2 + 1974*D1**2*K*bdd1*f*r**2 + 3360*D1**2*K*bdd1*f*r*s - 3822*D1**2*K*bdd1*f*r + 1092*D1**2*K*bdd1*f*s**2 - 2856*D1**2*K*bdd1*f*s + 1617*D1**2*K*bdd1*f - 828*D1**2*K*f*fd*r**2 - 912*D1**2*K*f*fd*r*s + 828*D1**2*K*f*fd*r - 120*D1**2*K*f*fd*s**2 + 456*D1**2*K*f*fd*s - 414*D1**2*K*f*fd + 1086*D1**2*K*f*fdd*r**2 + 1128*D1**2*K*f*fdd*r*s - 1086*D1**2*K*f*fdd*r + 228*D1**2*K*f*fdd*s**2 - 564*D1**2*K*f*fdd*s + 543*D1**2*K*f*fdd + 1086*D1**2*K*fd**2*r**2 + 1128*D1**2*K*fd**2*r*s - 1086*D1**2*K*fd**2*r + 228*D1**2*K*fd**2*s**2 - 564*D1**2*K*fd**2*s - 315*D1**2*b2*fd*r**2 - 630*D1**2*b2*fd*r*s - 315*D1**2*b2*fd*s**2 + 525*D1**2*b2*fdd*r**2 + 1050*D1**2*b2*fdd*r*s + 525*D1**2*b2*fdd*s**2 + 210*D1**2*bd1**2*(f*(9*r**2 + 2*r*(12*s - 7) + 15*s**2 - 18*s + 4) - (2*K - 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) - 906*D1**2*bdd1*f**2*r**2 - 3090*D1**2*bdd1*f**2*r*s + 2469*D1**2*bdd1*f**2*r - 2184*D1**2*bdd1*f**2*s**2 + 3531*D1**2*bdd1*f**2*s - 1473*D1**2*bdd1*f**2 - 630*D1**2*bdd1*f*r**2 - 1218*D1**2*bdd1*f*r*s + 1323*D1**2*bdd1*f*r - 294*D1**2*bdd1*f*s**2 + 945*D1**2*bdd1*f*s - 504*D1**2*bdd1*f + 1680*D1**2*bdd1*g2*r**2 + 1680*D1**2*bdd1*g2*r*s - 1680*D1**2*bdd1*g2*r - 840*D1**2*bdd1*g2*s + 840*D1**2*bdd1*g2 + 525*D1**2*bdd2*f*r**2 + 1050*D1**2*bdd2*f*r*s - 1050*D1**2*bdd2*f*r + 525*D1**2*bdd2*f*s**2 - 1050*D1**2*bdd2*f*s + 525*D1**2*bdd2*f + 927*D1**2*f**2*fd*r**2 + 1092*D1**2*f**2*fd*r*s - 847*D1**2*f**2*fd*r - 189*D1**2*f**2*fd*s**2 - 49*D1**2*f**2*fd*s + 16*D1**2*f**2*fd - 909*D1**2*f**2*fdd*r**2 - 1248*D1**2*f**2*fdd*r*s + 887*D1**2*f**2*fdd*r + 27*D1**2*f**2*fdd*s**2 + 245*D1**2*f**2*fdd*s - 80*D1**2*f**2*fdd - 1818*D1**2*f*fd**2*r**2 - 2496*D1**2*f*fd**2*r*s + 1774*D1**2*f*fd**2*r + 54*D1**2*f*fd**2*s**2 + 490*D1**2*f*fd**2*s - 403*D1**2*f*fd**2 + 444*D1**2*f*fd*r**2 + 798*D1**2*f*fd*r*s - 696*D1**2*f*fd*r + 126*D1**2*f*fd*s**2 - 441*D1**2*f*fd*s + 306*D1**2*f*fd - 306*D1**2*f*fdd*r**2 - 462*D1**2*f*fdd*r*s + 306*D1**2*f*fdd*r - 126*D1**2*f*fdd*s**2 + 231*D1**2*f*fdd*s - 153*D1**2*f*fdd + 1008*D1**2*f*gd2*r**2 + 1680*D1**2*f*gd2*r*s - 1680*D1**2*f*gd2*r + 504*D1**2*f*gd2*s**2 - 1008*D1**2*f*gd2*s + 504*D1**2*f*gd2 - 1974*D1**2*f*gdd2*r**2 - 3360*D1**2*f*gdd2*r*s + 3360*D1**2*f*gdd2*r - 1092*D1**2*f*gdd2*s**2 + 2184*D1**2*f*gdd2*s - 1092*D1**2*f*gdd2 - 306*D1**2*fd**2*r**2 - 462*D1**2*fd**2*r*s + 306*D1**2*fd**2*r - 126*D1**2*fd**2*s**2 + 231*D1**2*fd**2*s + 1008*D1**2*fd*g2*r**2 + 1680*D1**2*fd*g2*r*s + 672*D1**2*fd*g2*r + 504*D1**2*fd*g2*s**2 + 336*D1**2*fd*g2*s - 336*D1**2*fd*g2 - 3948*D1**2*fd*gd2*r**2 - 6720*D1**2*fd*gd2*r*s + 3024*D1**2*fd*gd2*r - 2184*D1**2*fd*gd2*s**2 + 2016*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 - 1974*D1**2*fdd*g2*r**2 - 3360*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*r - 1092*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 168*D1**2*fdd*g2 - 1656*D1*Dd*K*f**2*r**2 - 1824*D1*Dd*K*f**2*r*s + 1740*D1*Dd*K*f**2*r - 240*D1*Dd*K*f**2*s**2 + 696*D1*Dd*K*f**2*s - 534*D1*Dd*K*f**2 + 8688*D1*Dd*K*f*fd*r**2 + 9024*D1*Dd*K*f*fd*r*s - 8772*D1*Dd*K*f*fd*r + 1824*D1*Dd*K*f*fd*s**2 - 4296*D1*Dd*K*f*fd*s + 2214*D1*Dd*K*f*fd - 1260*D1*Dd*b2*f*r**2 - 2520*D1*Dd*b2*f*r*s + 1890*D1*Dd*b2*f*r - 1260*D1*Dd*b2*f*s**2 + 1890*D1*Dd*b2*f*s - 945*D1*Dd*b2*f + 4200*D1*Dd*b2*fd*r**2 + 8400*D1*Dd*b2*fd*r*s - 3150*D1*Dd*b2*fd*r + 4200*D1*Dd*b2*fd*s**2 - 3150*D1*Dd*b2*fd*s + 1236*D1*Dd*f**3*r**2 + 1456*D1*Dd*f**3*r*s - 1346*D1*Dd*f**3*r - 252*D1*Dd*f**3*s**2 - 112*D1*Dd*f**3*s + 183*D1*Dd*f**3 - 7272*D1*Dd*f**2*fd*r**2 - 9984*D1*Dd*f**2*fd*r*s + 7862*D1*Dd*f**2*fd*r + 216*D1*Dd*f**2*fd*s**2 + 2120*D1*Dd*f**2*fd*s - 1377*D1*Dd*f**2*fd + 888*D1*Dd*f**2*r**2 + 1596*D1*Dd*f**2*r*s - 1242*D1*Dd*f**2*r + 252*D1*Dd*f**2*s**2 - 651*D1*Dd*f**2*s + 348*D1*Dd*f**2 - 2448*D1*Dd*f*fd*r**2 - 3696*D1*Dd*f*fd*r*s + 2760*D1*Dd*f*fd*r - 1008*D1*Dd*f*fd*s**2 + 1890*D1*Dd*f*fd*s - 768*D1*Dd*f*fd + 4032*D1*Dd*f*g2*r**2 + 6720*D1*Dd*f*g2*r*s - 5376*D1*Dd*f*g2*r + 2016*D1*Dd*f*g2*s**2 - 3696*D1*Dd*f*g2*s + 2016*D1*Dd*f*g2 - 15792*D1*Dd*f*gd2*r**2 - 26880*D1*Dd*f*gd2*r*s + 24108*D1*Dd*f*gd2*r - 8736*D1*Dd*f*gd2*s**2 + 16464*D1*Dd*f*gd2*s - 7728*D1*Dd*f*gd2 - 15792*D1*Dd*fd*g2*r**2 - 26880*D1*Dd*fd*g2*r*s + 9324*D1*Dd*fd*g2*r - 8736*D1*Dd*fd*g2*s**2 + 7056*D1*Dd*fd*g2*s + 672*D1*Dd*fd*g2 + 2172*D1*Ddd*K*f**2*r**2 + 2256*D1*Ddd*K*f**2*r*s - 2214*D1*Ddd*K*f**2*r + 456*D1*Ddd*K*f**2*s**2 - 1020*D1*Ddd*K*f**2*s + 771*D1*Ddd*K*f**2 + 2100*D1*Ddd*b2*f*r**2 + 4200*D1*Ddd*b2*f*r*s - 3150*D1*Ddd*b2*f*r + 2100*D1*Ddd*b2*f*s**2 - 3150*D1*Ddd*b2*f*s + 1575*D1*Ddd*b2*f - 1212*D1*Ddd*f**3*r**2 - 1664*D1*Ddd*f**3*r*s + 1438*D1*Ddd*f**3*r + 36*D1*Ddd*f**3*s**2 + 380*D1*Ddd*f**3*s - 285*D1*Ddd*f**3 - 612*D1*Ddd*f**2*r**2 - 924*D1*Ddd*f**2*r*s + 768*D1*Ddd*f**2*r - 252*D1*Ddd*f**2*s**2 + 483*D1*Ddd*f**2*s - 279*D1*Ddd*f**2 - 7896*D1*Ddd*f*g2*r**2 - 13440*D1*Ddd*f*g2*r*s + 10668*D1*Ddd*f*g2*r - 4368*D1*Ddd*f*g2*s**2 + 7728*D1*Ddd*f*g2*s - 4158*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(f**2*(310*r**2 + r*(982*s - 799) + 672*s**2 - 1101*s + 471) - f*(280*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 28*K*(12*r**2 + 20*r*s - 26*r + 6*s**2 - 18*s + 11) + fd*(1208*r**2 + 8*r*(515*s - 333) + 2912*s**2 - 3942*s + 1189) - 700*r**2 - 742*r*s + 917*r + 14*s**2 + 385*s - 371) + 7*fd*(2*K*(94*r**2 + 160*r*s - 83*r + 52*s**2 - 64*s - 2) - 60*r**2 - 116*r*s + 55*r - 28*s**2 + 41*s + 2) - 280*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 280*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd*(-f**2*(2416*r**2 + r*(8240*s - 5956) + 5824*s**2 - 8650*s + 3177) + 7*f*(2*K*(376*r**2 + 640*r*s - 618*r + 208*s**2 - 456*s + 227) - 240*r**2 - 464*r*s + 428*r - 112*s**2 + 294*s - 153) + 560*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 105*D1*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 6516*Dd**2*K*f**2*r**2 + 6768*Dd**2*K*f**2*r*s - 6642*Dd**2*K*f**2*r + 1368*Dd**2*K*f**2*s**2 - 3060*Dd**2*K*f**2*s + 1356*Dd**2*K*f**2 + 6300*Dd**2*b2*f*r**2 + 12600*Dd**2*b2*f*r*s - 9450*Dd**2*b2*f*r + 6300*Dd**2*b2*f*s**2 - 9450*Dd**2*b2*f*s + 3150*Dd**2*b2*f - 3636*Dd**2*f**3*r**2 - 4992*Dd**2*f**3*r*s + 4314*Dd**2*f**3*r + 108*Dd**2*f**3*s**2 + 1140*Dd**2*f**3*s - 814*Dd**2*f**3 - 1836*Dd**2*f**2*r**2 - 2772*Dd**2*f**2*r*s + 2304*Dd**2*f**2*r - 756*Dd**2*f**2*s**2 + 1449*Dd**2*f**2*s - 588*Dd**2*f**2 - 23688*Dd**2*f*g2*r**2 - 40320*Dd**2*f*g2*r*s + 32004*Dd**2*f*g2*r - 13104*Dd**2*f*g2*s**2 + 23184*Dd**2*f*g2*s - 8904*Dd**2*f*g2) + 33*b2*(-175*D1**2*bdd1*f*(r + s - 1)**2 + 122*D1**2*f*fd*r**2 + 164*D1**2*f*fd*r*s - 122*D1**2*f*fd*r + 42*D1**2*f*fd*s**2 - 82*D1**2*f*fd*s + 61*D1**2*f*fd - 166*D1**2*f*fdd*r**2 - 236*D1**2*f*fdd*r*s + 166*D1**2*f*fdd*r - 70*D1**2*f*fdd*s**2 + 118*D1**2*f*fdd*s - 83*D1**2*f*fdd - 166*D1**2*fd**2*r**2 - 236*D1**2*fd**2*r*s + 166*D1**2*fd**2*r - 70*D1**2*fd**2*s**2 + 118*D1**2*fd**2*s + 244*D1*Dd*f**2*r**2 + 328*D1*Dd*f**2*r*s - 286*D1*Dd*f**2*r + 84*D1*Dd*f**2*s**2 - 166*D1*Dd*f**2*s + 103*D1*Dd*f**2 - 1328*D1*Dd*f*fd*r**2 - 1888*D1*Dd*f*fd*r*s + 1468*D1*Dd*f*fd*r - 560*D1*Dd*f*fd*s**2 + 988*D1*Dd*f*fd*s - 402*D1*Dd*f*fd - 332*D1*Ddd*f**2*r**2 - 472*D1*Ddd*f**2*r*s + 402*D1*Ddd*f**2*r - 140*D1*Ddd*f**2*s**2 + 258*D1*Ddd*f**2*s - 153*D1*Ddd*f**2 + 35*D1*bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) - 996*Dd**2*f**2*r**2 - 1416*Dd**2*f**2*r*s + 1206*Dd**2*f**2*r - 420*Dd**2*f**2*s**2 + 774*Dd**2*f**2*s - 306*Dd**2*f**2))/(3465*d**2*k3**4) + D1**2*Pk1*Pk3*st**6*(8*C - 4)*(9*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(9*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(63*d**2*k3**2) + D1**2*Pk1*Pk3*st**4*(-42*b1**2*(4*C - 3)*(D1*Dd*(2*f*(-4*r*s + 2*r + s) + fd*(8*r*s - 6*r - s + 1)) - D1*(D1*r*(2*fd - fdd)*(s - 1) + Ddd*f*(-4*r*s + 2*r + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 3*b1*(D1**2*(f*(-14*bdd1*s*(4*C - 3)*(2*r - 1) + fd*(-2*C*(40*r*s - 20*r + 154*s**2 - 146*s + 77) + 40*r*s - 20*r + 170*s**2 - 158*s + 85) + fdd*(2*C*(48*r*s - 24*r + 126*s**2 - 122*s + 63) - 48*r*s + 24*r - 134*s**2 + 128*s - 67)) + 2*fd**2*(2*C*(12*r*(2*s - 1) + 63*s**2 - 61*s - 2) + r*(12 - 24*s) - 67*s**2 + 64*s + 3)) - 14*D1*bd1*(4*C - 3)*(D1*(2*f*s*(1 - 2*r) + fd*r*(4*s - 2) - fd*s + fd) + 2*Dd*f*(r*(8*s - 2) - 3*s + 1)) - 2*D1*f*(Dd*(f*(2*C*(40*r*s - 20*r + 154*s**2 - 164*s + 77) - 40*r*s + 20*r - 170*s**2 + 180*s - 85) - 4*fd*(2*s - 1)*(C*(48*r + 126*s - 67) - 24*r - 67*s + 35)) + Ddd*f*(-6*C*(16*r*s - 8*r + 42*s**2 - 46*s + 21) + 48*r*s - 24*r + 134*s**2 - 146*s + 67)) + 2*Dd**2*f**2*(6*C*(24*r*(2*s - 1) + 126*s**2 - 138*s + 29) - 72*r*(2*s - 1) - 402*s**2 + 438*s - 91)) + f*(-42*D1**2*bd1**2*s*(4*C - 3)*(2*r - 1) + D1**2*(f*(3*bdd1*s*(2*C*(24*r + 63*s - 28) - 24*r - 67*s + 30) + fd*(-2*C*(60*r*s - 20*r + 99*s**2 - 86*s + 33) + 72*r*s - 24*r + 123*s**2 - 106*s + 41) + fdd*(2*C*(84*r*s - 28*r + 81*s**2 - 82*s + 27) - 90*r*s + 30*r - 93*s**2 + 92*s - 31)) + 2*fd**2*(2*C*(28*r*(3*s - 1) + 81*s**2 - 82*s + 14) + r*(30 - 90*s) - 93*s**2 + 92*s - 15)) - 3*D1*bd1*(D1*(f*s*(2*C*(20*r + 77*s - 28) - 20*r - 85*s + 32) - 2*fd*(2*C*(48*r*s - 12*r + 126*s**2 - 89*s + 14) - 48*r*s + 12*r - 134*s**2 + 94*s - 15)) - 4*Dd*f*(2*C*(48*r*s - 12*r + 126*s**2 - 97*s + 14) - 48*r*s + 12*r - 134*s**2 + 103*s - 15)) - 2*D1*f*(Dd*(f*(2*C*(20*r*(2*s - 1) + 66*s**2 - 76*s + 33) + r*(24 - 48*s) - 82*s**2 + 94*s - 41) + fd*(-8*C*(7*r*(12*s - 5) + 81*s**2 - 92*s + 24) + 30*r*(12*s - 5) + 372*s**2 - 415*s + 107)) + Ddd*f*(-2*C*(28*r*(2*s - 1) + 54*s**2 - 68*s + 27) + 30*r*(2*s - 1) + 62*s**2 - 77*s + 31)) + 2*Dd**2*f**2*(2*C*(84*r*(2*s - 1) + 162*s**2 - 204*s + 55) - 90*r*(2*s - 1) - 186*s**2 + 231*s - 61)))/(105*d**2*k3**2) + D1**2*Pk1*Pk3*st**2*(21*b1**2*(D1**2*(fd*(2*C*(5*r**2 - 30*r*(s - 1) + 3*(s - 1)**2) - 5*r**2 + 45*r*(s - 1) - 6*(s - 1)**2) + fdd*(2*C*(5*r**2 + 30*r*(s - 1) + (s - 1)**2) - 5*r**2 - 45*r*(s - 1) - 2*(s - 1)**2)) + D1*(Dd*(f*(2*C*(20*r**2 + r*(50 - 120*s) + 12*s**2 + 18*s + 11) - 20*r**2 + 20*r*(9*s - 4) - 24*s**2 - 21*s - 17) + fd*(4*C*(20*r**2 + 5*r*(24*s - 19) + 4*s**2 - 21*s + 17) - 40*r**2 - 40*r*(9*s - 7) - 16*s**2 + 69*s - 53)) + Ddd*f*(2*C*(20*r**2 + 10*r*(12*s - 7) + 4*s**2 - 34*s + 7) - 20*r**2 - 20*r*(9*s - 5) - 8*s**2 + 53*s - 9)) + Dd**2*f*(4*C*(30*r**2 + 15*r*(12*s - 7) + 6*s**2 - 51*s + 31) - 60*r**2 - 60*r*(9*s - 5) - 24*s**2 + 159*s - 94)) + 3*b1*(544*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*r + 844*C*D1**2*f*fd*s**2 - 696*C*D1**2*f*fd*s + 352*C*D1**2*f*fd - 608*C*D1**2*f*fdd*r*s + 164*C*D1**2*f*fdd*r - 828*C*D1**2*f*fdd*s**2 + 712*C*D1**2*f*fdd*s - 344*C*D1**2*f*fdd - 608*C*D1**2*fd**2*r*s + 164*C*D1**2*fd**2*r - 828*C*D1**2*fd**2*s**2 + 712*C*D1**2*fd**2*s + 116*C*D1**2*fd**2 + 1088*C*D1*Dd*f**2*r*s - 544*C*D1*Dd*f**2*r + 1688*C*D1*Dd*f**2*s**2 - 1960*C*D1*Dd*f**2*s + 844*C*D1*Dd*f**2 - 4864*C*D1*Dd*f*fd*r*s + 1872*C*D1*Dd*f*fd*r - 6624*C*D1*Dd*f*fd*s**2 + 6768*C*D1*Dd*f*fd*s - 1588*C*D1*Dd*f*fd - 1216*C*D1*Ddd*f**2*r*s + 608*C*D1*Ddd*f**2*r - 1656*C*D1*Ddd*f**2*s**2 + 1960*C*D1*Ddd*f**2*s - 828*C*D1*Ddd*f**2 - 3648*C*Dd**2*f**2*r*s + 1824*C*Dd**2*f**2*r - 4968*C*Dd**2*f**2*s**2 + 5880*C*Dd**2*f**2*s - 1436*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(2*C*(10*r**2 + 10*r*(6*s - 1) + 2*s**2 - 30*s + 5) - 10*r**2 + r*(10 - 90*s) - 4*s**2 + 45*s - 5) - 272*D1**2*f*fd*r*s + 66*D1**2*f*fd*r - 508*D1**2*f*fd*s**2 + 397*D1**2*f*fd*s - 219*D1**2*f*fd + 304*D1**2*f*fdd*r*s - 82*D1**2*f*fdd*r + 492*D1**2*f*fdd*s**2 - 405*D1**2*f*fdd*s + 211*D1**2*f*fdd + 304*D1**2*fd**2*r*s - 82*D1**2*fd**2*r + 492*D1**2*fd**2*s**2 - 405*D1**2*fd**2*s - 87*D1**2*fd**2 - 544*D1*Dd*f**2*r*s + 272*D1*Dd*f**2*r - 1016*D1*Dd*f**2*s**2 + 1152*D1*Dd*f**2*s - 508*D1*Dd*f**2 + 2432*D1*Dd*f*fd*r*s - 936*D1*Dd*f*fd*r + 3936*D1*Dd*f*fd*s**2 - 3892*D1*Dd*f*fd*s + 892*D1*Dd*f*fd + 608*D1*Ddd*f**2*r*s - 304*D1*Ddd*f**2*r + 984*D1*Ddd*f**2*s**2 - 1136*D1*Ddd*f**2*s + 492*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(2*C*(10*r**2 - 10*r*(6*s + 1) + 6*s**2 + 30*s + 5) - 10*r**2 + 10*r*(9*s + 1) - 12*s**2 - 45*s - 5) + fd*(4*C*(10*r**2 + 5*r*(12*s - 7) + 2*s**2 - 17*s + 15) - 20*r**2 - 20*r*(9*s - 5) - 8*s**2 + 53*s - 45)) + 2*Dd*f*(2*C*(40*r**2 + 30*r*(8*s - 3) + 8*s**2 - 94*s + 35) - 40*r**2 - 120*r*(3*s - 1) - 16*s**2 + 143*s - 50)) + 1824*Dd**2*f**2*r*s - 912*Dd**2*f**2*r + 2952*Dd**2*f**2*s**2 - 3408*Dd**2*f**2*s + 796*Dd**2*f**2) + f*(402*C*D1**2*f*fd*r**2 + 1620*C*D1**2*f*fd*r*s - 808*C*D1**2*f*fd*r + 756*C*D1**2*f*fd*s**2 - 1044*C*D1**2*f*fd*s + 386*C*D1**2*f*fd - 390*C*D1**2*f*fdd*r**2 - 1620*C*D1**2*f*fdd*r*s + 800*C*D1**2*f*fdd*r - 756*C*D1**2*f*fdd*s**2 + 1044*C*D1**2*f*fdd*s - 382*C*D1**2*f*fdd - 780*C*D1**2*fd**2*r**2 - 3240*C*D1**2*fd**2*r*s + 1600*C*D1**2*fd**2*r - 1512*C*D1**2*fd**2*s**2 + 2088*C*D1**2*fd**2*s - 540*C*D1**2*fd**2 + 536*C*D1*Dd*f**2*r**2 + 2160*C*D1*Dd*f**2*r*s - 1348*C*D1*Dd*f**2*r + 1008*C*D1*Dd*f**2*s**2 - 1548*C*D1*Dd*f**2*s + 638*C*D1*Dd*f**2 - 3120*C*D1*Dd*f*fd*r**2 - 12960*C*D1*Dd*f*fd*r*s + 7220*C*D1*Dd*f*fd*r - 6048*C*D1*Dd*f*fd*s**2 + 8820*C*D1*Dd*f*fd*s - 2888*C*D1*Dd*f*fd - 520*C*D1*Ddd*f**2*r**2 - 2160*C*D1*Ddd*f**2*r*s + 1340*C*D1*Ddd*f**2*r - 1008*C*D1*Ddd*f**2*s**2 + 1548*C*D1*Ddd*f**2*s - 634*C*D1*Ddd*f**2 - 1560*C*Dd**2*f**2*r**2 - 6480*C*Dd**2*f**2*r*s + 4020*C*Dd**2*f**2*r - 3024*C*Dd**2*f**2*s**2 + 4644*C*Dd**2*f**2*s - 1584*C*Dd**2*f**2 + 21*D1**2*bd1**2*(r**2*(20*C - 10) + 10*r*(2*C*(6*s - 1) - 9*s + 1) + s*(4*C*(s - 15) - 4*s + 45)) - 3*D1**2*bdd1*f*(2*C*(152*r*s - 70*r + 207*s**2 - 210*s + 35) - 152*r*s + 70*r - 246*s**2 + 239*s - 35) - 201*D1**2*f*fd*r**2 - 987*D1**2*f*fd*r*s + 463*D1**2*f*fd*r - 540*D1**2*f*fd*s**2 + 689*D1**2*f*fd*s - 247*D1**2*f*fd + 195*D1**2*f*fdd*r**2 + 939*D1**2*f*fdd*r*s - 443*D1**2*f*fdd*r + 540*D1**2*f*fdd*s**2 - 673*D1**2*f*fdd*s + 245*D1**2*f*fdd + 390*D1**2*fd**2*r**2 + 1878*D1**2*fd**2*r*s - 886*D1**2*fd**2*r + 1080*D1**2*fd**2*s**2 - 1346*D1**2*fd**2*s + 313*D1**2*fd**2 - 268*D1*Dd*f**2*r**2 - 1316*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 720*D1*Dd*f**2*s**2 + 1049*D1*Dd*f**2*s - 427*D1*Dd*f**2 + 1560*D1*Dd*f*fd*r**2 + 7512*D1*Dd*f*fd*r*s - 4040*D1*Dd*f*fd*r + 4320*D1*Dd*f*fd*s**2 - 5791*D1*Dd*f*fd*s + 1789*D1*Dd*f*fd + 260*D1*Ddd*f**2*r**2 + 1252*D1*Ddd*f**2*r*s - 756*D1*Ddd*f**2*r + 720*D1*Ddd*f**2*s**2 - 1033*D1*Ddd*f**2*s + 425*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(2*C*(136*r*s - 70*r + 211*s**2 - 210*s + 35) - 136*r*s + 70*r - 254*s**2 + 247*s - 35) + fd*(-4*C*(304*r*s - 111*r + 414*s**2 - 388*s + 105) + 608*r*s - 222*r + 984*s**2 - 883*s + 239)) - 4*Dd*f*(C*(608*r*s - 292*r + 828*s**2 - 910*s + 245) - 304*r*s + 146*r - 492*s**2 + 523*s - 137)) + 780*Dd**2*f**2*r**2 + 3756*Dd**2*f**2*r*s - 2268*Dd**2*f**2*r + 2160*Dd**2*f**2*s**2 - 3099*Dd**2*f**2*s + 986*Dd**2*f**2))/(315*d**2*k3**2) + D1**2*Pk1*Pk3*(-168*D1**2*K*bd1**2*f*r*s + 294*D1**2*K*bd1**2*f*r - 168*D1**2*K*bd1**2*f*s**2 + 378*D1**2*K*bd1**2*f*s - 210*D1**2*K*bd1**2*f + 99*D1**2*K*bd1*f**2*r**2 + 126*D1**2*K*bd1*f**2*r*s - 126*D1**2*K*bd1*f**2*r + 35*D1**2*K*bd1*f**2*s**2 - 70*D1**2*K*bd1*f**2*s + 35*D1**2*K*bd1*f**2 - 324*D1**2*K*bd1*f*fd*r**2 - 504*D1**2*K*bd1*f*fd*r*s + 414*D1**2*K*bd1*f*fd*r - 140*D1**2*K*bd1*f*fd*s**2 + 266*D1**2*K*bd1*f*fd*s - 126*D1**2*K*bd1*f*fd - 81*D1**2*K*bdd1*f**2*r**2 - 126*D1**2*K*bdd1*f**2*r*s + 126*D1**2*K*bdd1*f**2*r - 35*D1**2*K*bdd1*f**2*s**2 + 70*D1**2*K*bdd1*f**2*s - 35*D1**2*K*bdd1*f**2 + 140*D1**2*bd1**2*f**2*s**2 - 133*D1**2*bd1**2*f**2*s + 63*D1**2*bd1**2*f**2 + 98*D1**2*bd1**2*f*s**2 - 161*D1**2*bd1**2*f*s + 63*D1**2*bd1**2*f - 420*D1**2*bd1**2*g2*r**2 - 840*D1**2*bd1**2*g2*r*s + 420*D1**2*bd1**2*g2*r - 140*D1**2*bd1**2*g2*s**2 + 420*D1**2*bd1**2*g2*s - 210*D1**2*bd1*bd2*f*r**2 - 420*D1**2*bd1*bd2*f*r*s + 420*D1**2*bd1*bd2*f*r - 210*D1**2*bd1*bd2*f*s**2 + 420*D1**2*bd1*bd2*f*s - 210*D1**2*bd1*bd2*f - 45*D1**2*bd1*f**3*r*s + 45*D1**2*bd1*f**3*r - 63*D1**2*bd1*f**3*s**2 + 84*D1**2*bd1*f**3*s - 42*D1**2*bd1*f**3 + 270*D1**2*bd1*f**2*fd*r*s - 180*D1**2*bd1*f**2*fd*r + 378*D1**2*bd1*f**2*fd*s**2 - 465*D1**2*bd1*f**2*fd*s + 129*D1**2*bd1*f**2*fd - 27*D1**2*bd1*f**2*r*s + 27*D1**2*bd1*f**2*r - 42*D1**2*bd1*f**2*s**2 + 84*D1**2*bd1*f**2*s - 42*D1**2*bd1*f**2 + 180*D1**2*bd1*f*fd*r*s - 90*D1**2*bd1*f*fd*r + 168*D1**2*bd1*f*fd*s**2 - 213*D1**2*bd1*f*fd*s + 45*D1**2*bd1*f*fd - 336*D1**2*bd1*f*g2*r*s + 420*D1**2*bd1*f*g2*r - 196*D1**2*bd1*f*g2*s**2 + 420*D1**2*bd1*f*g2*s - 210*D1**2*bd1*f*g2 + 336*D1**2*bd1*f*gd2*r*s - 588*D1**2*bd1*f*gd2*r + 336*D1**2*bd1*f*gd2*s**2 - 756*D1**2*bd1*f*gd2*s + 420*D1**2*bd1*f*gd2 + 336*D1**2*bd1*fd*g2*r*s + 336*D1**2*bd1*fd*g2*s**2 - 168*D1**2*bd1*fd*g2*s + 99*D1**2*bd2*f**2*r**2 + 126*D1**2*bd2*f**2*r*s - 126*D1**2*bd2*f**2*r + 35*D1**2*bd2*f**2*s**2 - 70*D1**2*bd2*f**2*s + 35*D1**2*bd2*f**2 - 324*D1**2*bd2*f*fd*r**2 - 504*D1**2*bd2*f*fd*r*s + 414*D1**2*bd2*f*fd*r - 140*D1**2*bd2*f*fd*s**2 + 266*D1**2*bd2*f*fd*s - 126*D1**2*bd2*f*fd + 45*D1**2*bdd1*f**3*r*s - 45*D1**2*bdd1*f**3*r + 63*D1**2*bdd1*f**3*s**2 - 84*D1**2*bdd1*f**3*s + 42*D1**2*bdd1*f**3 + 45*D1**2*bdd1*f**2*r*s - 45*D1**2*bdd1*f**2*r + 42*D1**2*bdd1*f**2*s**2 - 84*D1**2*bdd1*f**2*s + 42*D1**2*bdd1*f**2 + 168*D1**2*bdd1*f*g2*r*s - 420*D1**2*bdd1*f*g2*r + 168*D1**2*bdd1*f*g2*s**2 - 420*D1**2*bdd1*f*g2*s + 210*D1**2*bdd1*f*g2 - 81*D1**2*bdd2*f**2*r**2 - 126*D1**2*bdd2*f**2*r*s + 126*D1**2*bdd2*f**2*r - 35*D1**2*bdd2*f**2*s**2 + 70*D1**2*bdd2*f**2*s - 35*D1**2*bdd2*f**2 - 198*D1**2*f**2*gd2*r**2 - 252*D1**2*f**2*gd2*r*s + 252*D1**2*f**2*gd2*r - 70*D1**2*f**2*gd2*s**2 + 140*D1**2*f**2*gd2*s - 70*D1**2*f**2*gd2 + 162*D1**2*f**2*gdd2*r**2 + 252*D1**2*f**2*gdd2*r*s - 252*D1**2*f**2*gdd2*r + 70*D1**2*f**2*gdd2*s**2 - 140*D1**2*f**2*gdd2*s + 70*D1**2*f**2*gdd2 - 396*D1**2*f*fd*g2*r**2 - 504*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 140*D1**2*f*fd*g2*s**2 + 252*D1**2*f*fd*g2*s - 198*D1**2*f*fd*g2 + 648*D1**2*f*fd*gd2*r**2 + 1008*D1**2*f*fd*gd2*r*s - 828*D1**2*f*fd*gd2*r + 280*D1**2*f*fd*gd2*s**2 - 532*D1**2*f*fd*gd2*s + 252*D1**2*f*fd*gd2 + 324*D1**2*f*fdd*g2*r**2 + 504*D1**2*f*fdd*g2*r*s - 324*D1**2*f*fdd*g2*r + 140*D1**2*f*fdd*g2*s**2 - 252*D1**2*f*fdd*g2*s + 162*D1**2*f*fdd*g2 + 324*D1**2*fd**2*g2*r**2 + 504*D1**2*fd**2*g2*r*s - 324*D1**2*fd**2*g2*r + 140*D1**2*fd**2*g2*s**2 - 252*D1**2*fd**2*g2*s - 648*D1*Dd*K*bd1*f**2*r**2 - 1008*D1*Dd*K*bd1*f**2*r*s + 918*D1*Dd*K*bd1*f**2*r - 280*D1*Dd*K*bd1*f**2*s**2 + 546*D1*Dd*K*bd1*f**2*s - 266*D1*Dd*K*bd1*f**2 + 360*D1*Dd*bd1*f**3*r*s - 270*D1*Dd*bd1*f**3*r + 504*D1*Dd*bd1*f**3*s**2 - 633*D1*Dd*bd1*f**3*s + 213*D1*Dd*bd1*f**3 + 360*D1*Dd*bd1*f**2*r*s - 270*D1*Dd*bd1*f**2*r + 336*D1*Dd*bd1*f**2*s**2 - 549*D1*Dd*bd1*f**2*s + 213*D1*Dd*bd1*f**2 + 1344*D1*Dd*bd1*f*g2*r*s - 2016*D1*Dd*bd1*f*g2*r + 1344*D1*Dd*bd1*f*g2*s**2 - 2520*D1*Dd*bd1*f*g2*s + 1260*D1*Dd*bd1*f*g2 - 648*D1*Dd*bd2*f**2*r**2 - 1008*D1*Dd*bd2*f**2*r*s + 918*D1*Dd*bd2*f**2*r - 280*D1*Dd*bd2*f**2*s**2 + 546*D1*Dd*bd2*f**2*s - 266*D1*Dd*bd2*f**2 - 792*D1*Dd*f**2*g2*r**2 - 1008*D1*Dd*f**2*g2*r*s + 900*D1*Dd*f**2*g2*r - 280*D1*Dd*f**2*g2*s**2 + 532*D1*Dd*f**2*g2*s - 338*D1*Dd*f**2*g2 + 1296*D1*Dd*f**2*gd2*r**2 + 2016*D1*Dd*f**2*gd2*r*s - 1836*D1*Dd*f**2*gd2*r + 560*D1*Dd*f**2*gd2*s**2 - 1092*D1*Dd*f**2*gd2*s + 532*D1*Dd*f**2*gd2 + 2592*D1*Dd*f*fd*g2*r**2 + 4032*D1*Dd*f*fd*g2*r*s - 2952*D1*Dd*f*fd*g2*r + 1120*D1*Dd*f*fd*g2*s**2 - 2072*D1*Dd*f*fd*g2*s + 828*D1*Dd*f*fd*g2 + 648*D1*Ddd*f**2*g2*r**2 + 1008*D1*Ddd*f**2*g2*r*s - 828*D1*Ddd*f**2*g2*r + 280*D1*Ddd*f**2*g2*s**2 - 532*D1*Ddd*f**2*g2*s + 302*D1*Ddd*f**2*g2 + 1944*Dd**2*f**2*g2*r**2 + 3024*Dd**2*f**2*g2*r*s - 2484*Dd**2*f**2*g2*r + 840*Dd**2*f**2*g2*s**2 - 1596*Dd**2*f**2*g2*s + 644*Dd**2*f**2*g2 + 35*b1**3*(3*D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(12*K*r**2 + 24*K*r*s - 18*K*r + 4*K*s**2 - 10*K*s + 5*K + 3*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 3*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5) - 12*r*s + 6*r - 4*s**2 + 7*s - 2) + Ddd*(K*(12*r**2 + 6*r*(4*s - 3) + 4*s**2 - 10*s + 5) - 3*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 12*r*s + 6*r - 4*s**2 + 7*s - 2)) + Dd**2*(2*K*(18*r**2 + 9*r*(4*s - 3) + 6*s**2 - 15*s + 7) - 3*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4) - 36*r*s + 18*r - 12*s**2 + 21*s - 8)) + 7*b1**2*(24*D1**2*K*fd*r*s + 30*D1**2*K*fd*r + 14*D1**2*K*fd*s**2 + 6*D1**2*K*fd*s - 15*D1**2*K*fd - 12*D1**2*K*fdd*r*s - 30*D1**2*K*fdd*r - 12*D1**2*K*fdd*s**2 - 18*D1**2*K*fdd*s + 15*D1**2*K*fdd - 5*D1**2*bdd1*(-K*(9*r**2 + 6*r*(3*s - 2) + 3*s**2 - 8*s + 4) + f*(r*(9*s - 3) + 9*s**2 - 9*s + 3) + 9*r*s - 3*r + 3*s**2 - 5*s + 1) - 20*D1**2*f*fd*s**2 + 21*D1**2*f*fd*s - 15*D1**2*f*fd + 20*D1**2*f*fdd*s**2 - 21*D1**2*f*fdd*s + 15*D1**2*f*fdd + 20*D1**2*fd**2*s**2 - 21*D1**2*fd**2*s + D1**2*fd**2 - 9*D1**2*fd*s**2 - 3*D1**2*fd*s + 7*D1**2*fdd*s**2 + 9*D1**2*fdd*s - 30*D1**2*gd2*r**2 - 60*D1**2*gd2*r*s + 60*D1**2*gd2*r - 10*D1**2*gd2*s**2 + 20*D1**2*gd2*s - 10*D1**2*gd2 - 30*D1**2*gdd2*r**2 - 60*D1**2*gdd2*r*s + 60*D1**2*gdd2*r - 10*D1**2*gdd2*s**2 + 20*D1**2*gdd2*s - 10*D1**2*gdd2 + 96*D1*Dd*K*f*r*s - 48*D1*Dd*K*f*r + 56*D1*Dd*K*f*s**2 - 80*D1*Dd*K*f*s + 28*D1*Dd*K*f - 96*D1*Dd*K*fd*r*s - 96*D1*Dd*K*fd*r - 96*D1*Dd*K*fd*s**2 - 12*D1*Dd*K*fd*s + 66*D1*Dd*K*fd - 40*D1*Dd*f**2*s**2 + 40*D1*Dd*f**2*s - 20*D1*Dd*f**2 + 160*D1*Dd*f*fd*s**2 - 164*D1*Dd*f*fd*s + 42*D1*Dd*f*fd - 36*D1*Dd*f*s**2 + 36*D1*Dd*f*s - 18*D1*Dd*f + 56*D1*Dd*fd*s**2 + 8*D1*Dd*fd*s - 18*D1*Dd*fd - 120*D1*Dd*g2*r**2 - 240*D1*Dd*g2*r*s + 180*D1*Dd*g2*r - 40*D1*Dd*g2*s**2 + 100*D1*Dd*g2*s - 50*D1*Dd*g2 - 240*D1*Dd*gd2*r**2 - 480*D1*Dd*gd2*r*s + 420*D1*Dd*gd2*r - 80*D1*Dd*gd2*s**2 + 180*D1*Dd*gd2*s - 100*D1*Dd*gd2 - 48*D1*Ddd*K*f*r*s + 24*D1*Ddd*K*f*r - 48*D1*Ddd*K*f*s**2 + 60*D1*Ddd*K*f*s - 24*D1*Ddd*K*f + 40*D1*Ddd*f**2*s**2 - 40*D1*Ddd*f**2*s + 20*D1*Ddd*f**2 + 28*D1*Ddd*f*s**2 - 28*D1*Ddd*f*s + 14*D1*Ddd*f - 120*D1*Ddd*g2*r**2 - 240*D1*Ddd*g2*r*s + 180*D1*Ddd*g2*r - 40*D1*Ddd*g2*s**2 + 100*D1*Ddd*g2*s - 50*D1*Ddd*g2 + 5*D1*bd1*(D1*(9*K*r**2 + 18*K*r*s - 12*K*r + 3*K*s**2 - 8*K*s + 4*K + f*(r*(9*s - 3) + 9*s**2 - 9*s + 3) - 3*fd*(6*r*s - 4*r + 6*s**2 - 9*s + 3) - 9*r*s + 3*r - 3*s**2 + 5*s - 1) + Dd*(2*K*(36*r**2 + 72*r*s - 51*r + 12*s**2 - 31*s + 14) - 3*f*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) - 72*r*s + 30*r - 24*s**2 + 41*s - 13)) - 144*Dd**2*K*f*r*s + 72*Dd**2*K*f*r - 144*Dd**2*K*f*s**2 + 180*Dd**2*K*f*s - 48*Dd**2*K*f + 120*Dd**2*f**2*s**2 - 120*Dd**2*f**2*s + 20*Dd**2*f**2 + 84*Dd**2*f*s**2 - 84*Dd**2*f*s + 14*Dd**2*f - 360*Dd**2*g2*r**2 - 720*Dd**2*g2*r*s + 540*Dd**2*g2*r - 120*Dd**2*g2*s**2 + 300*Dd**2*g2*s - 140*Dd**2*g2) - b1*(168*D1**2*K*bdd1*f*r*s - 294*D1**2*K*bdd1*f*r + 168*D1**2*K*bdd1*f*s**2 - 378*D1**2*K*bdd1*f*s + 189*D1**2*K*bdd1*f - 198*D1**2*K*f*fd*r**2 - 252*D1**2*K*f*fd*r*s + 198*D1**2*K*f*fd*r - 70*D1**2*K*f*fd*s**2 + 126*D1**2*K*f*fd*s - 99*D1**2*K*f*fd + 162*D1**2*K*f*fdd*r**2 + 252*D1**2*K*f*fdd*r*s - 162*D1**2*K*f*fdd*r + 70*D1**2*K*f*fdd*s**2 - 126*D1**2*K*f*fdd*s + 81*D1**2*K*f*fdd + 162*D1**2*K*fd**2*r**2 + 252*D1**2*K*fd**2*r*s - 162*D1**2*K*fd**2*r + 70*D1**2*K*fd**2*s**2 - 126*D1**2*K*fd**2*s - 105*D1**2*b2*fd*r**2 - 210*D1**2*b2*fd*r*s - 105*D1**2*b2*fd*s**2 + 105*D1**2*b2*fdd*r**2 + 210*D1**2*b2*fdd*r*s + 105*D1**2*b2*fdd*s**2 + 35*D1**2*bd1**2*(-2*K*(9*r**2 + 6*r*(3*s - 2) + 3*s**2 - 8*s + 3) + 3*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 18*r*s - 6*r + 6*s**2 - 10*s + 3) - 140*D1**2*bdd1*f**2*s**2 + 133*D1**2*bdd1*f**2*s - 35*D1**2*bdd1*f**2 - 98*D1**2*bdd1*f*s**2 + 161*D1**2*bdd1*f*s - 49*D1**2*bdd1*f + 420*D1**2*bdd1*g2*r**2 + 840*D1**2*bdd1*g2*r*s - 420*D1**2*bdd1*g2*r + 140*D1**2*bdd1*g2*s**2 - 420*D1**2*bdd1*g2*s + 210*D1**2*bdd1*g2 + 105*D1**2*bdd2*f*r**2 + 210*D1**2*bdd2*f*r*s - 210*D1**2*bdd2*f*r + 105*D1**2*bdd2*f*s**2 - 210*D1**2*bdd2*f*s + 105*D1**2*bdd2*f + 135*D1**2*f**2*fd*r*s - 45*D1**2*f**2*fd*r + 189*D1**2*f**2*fd*s**2 - 213*D1**2*f**2*fd*s + 84*D1**2*f**2*fd - 135*D1**2*f**2*fdd*r*s + 45*D1**2*f**2*fdd*r - 189*D1**2*f**2*fdd*s**2 + 213*D1**2*f**2*fdd*s - 84*D1**2*f**2*fdd - 270*D1**2*f*fd**2*r*s + 90*D1**2*f*fd**2*r - 378*D1**2*f*fd**2*s**2 + 426*D1**2*f*fd**2*s - 87*D1**2*f*fd**2 + 54*D1**2*f*fd*r*s + 84*D1**2*f*fd*s**2 - 27*D1**2*f*fd*s - 90*D1**2*f*fdd*r*s - 84*D1**2*f*fdd*s**2 + 45*D1**2*f*fdd*s + 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r + 196*D1**2*f*gd2*s**2 - 392*D1**2*f*gd2*s + 196*D1**2*f*gd2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 168*D1**2*f*gdd2*s**2 + 336*D1**2*f*gdd2*s - 168*D1**2*f*gdd2 - 90*D1**2*fd**2*r*s - 84*D1**2*fd**2*s**2 + 45*D1**2*fd**2*s + 336*D1**2*fd*g2*r*s + 420*D1**2*fd*g2*r + 196*D1**2*fd*g2*s**2 + 84*D1**2*fd*g2*s - 210*D1**2*fd*g2 - 336*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s + 252*D1**2*fd*gd2 - 168*D1**2*fdd*g2*r*s - 420*D1**2*fdd*g2*r - 168*D1**2*fdd*g2*s**2 - 252*D1**2*fdd*g2*s + 210*D1**2*fdd*g2 - 396*D1*Dd*K*f**2*r**2 - 504*D1*Dd*K*f**2*r*s + 450*D1*Dd*K*f**2*r - 140*D1*Dd*K*f**2*s**2 + 266*D1*Dd*K*f**2*s - 169*D1*Dd*K*f**2 + 1296*D1*Dd*K*f*fd*r**2 + 2016*D1*Dd*K*f*fd*r*s - 1476*D1*Dd*K*f*fd*r + 560*D1*Dd*K*f*fd*s**2 - 1036*D1*Dd*K*f*fd*s + 414*D1*Dd*K*f*fd - 420*D1*Dd*b2*f*r**2 - 840*D1*Dd*b2*f*r*s + 630*D1*Dd*b2*f*r - 420*D1*Dd*b2*f*s**2 + 630*D1*Dd*b2*f*s - 315*D1*Dd*b2*f + 840*D1*Dd*b2*fd*r**2 + 1680*D1*Dd*b2*fd*r*s - 630*D1*Dd*b2*fd*r + 840*D1*Dd*b2*fd*s**2 - 630*D1*Dd*b2*fd*s + 180*D1*Dd*f**3*r*s - 90*D1*Dd*f**3*r + 252*D1*Dd*f**3*s**2 - 297*D1*Dd*f**3*s + 126*D1*Dd*f**3 - 1080*D1*Dd*f**2*fd*r*s + 450*D1*Dd*f**2*fd*r - 1512*D1*Dd*f**2*fd*s**2 + 1743*D1*Dd*f**2*fd*s - 471*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r*s - 54*D1*Dd*f**2*r + 168*D1*Dd*f**2*s**2 - 195*D1*Dd*f**2*s + 84*D1*Dd*f**2 - 720*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 672*D1*Dd*f*fd*s**2 + 606*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r*s - 672*D1*Dd*f*g2*r + 784*D1*Dd*f*g2*s**2 - 1120*D1*Dd*f*g2*s + 392*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 2184*D1*Dd*f*gd2*s - 840*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r*s - 1344*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s + 924*D1*Dd*fd*g2 + 324*D1*Ddd*K*f**2*r**2 + 504*D1*Ddd*K*f**2*r*s - 414*D1*Ddd*K*f**2*r + 140*D1*Ddd*K*f**2*s**2 - 266*D1*Ddd*K*f**2*s + 151*D1*Ddd*K*f**2 + 420*D1*Ddd*b2*f*r**2 + 840*D1*Ddd*b2*f*r*s - 630*D1*Ddd*b2*f*r + 420*D1*Ddd*b2*f*s**2 - 630*D1*Ddd*b2*f*s + 315*D1*Ddd*b2*f - 180*D1*Ddd*f**3*r*s + 90*D1*Ddd*f**3*r - 252*D1*Ddd*f**3*s**2 + 297*D1*Ddd*f**3*s - 126*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 168*D1*Ddd*f**2*s**2 + 213*D1*Ddd*f**2*s - 84*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r*s + 336*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 840*D1*Ddd*f*g2*s - 336*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(f**2*(20*s**2 - 19*s + 5) + f*(K*(-48*r*s + 54*r - 28*s**2 + 58*s - 29) - 10*fd*(8*s**2 - 8*s + 1) + 18*s**2 - 21*s + 9) + fd*(6*K*(r*(8*s + 3) + 8*s**2 - 3*s - 3) - 28*s**2 + 5*s + 9) + 10*g2*(6*r**2 + 6*r*(2*s - 1) + 2*s**2 - 6*s + 3) + 20*gd2*(6*r**2 + 3*r*(4*s - 3) + 2*s**2 - 5*s + 3)) - 2*Dd*(f**2*(80*s**2 - 78*s + 19) + f*(-3*K*(4*r*(8*s - 9) + 32*s**2 - 56*s + 25) + 56*s**2 - 74*s + 23) - 10*g2*(24*r**2 + 6*r*(8*s - 5) + 8*s**2 - 22*s + 9))) - 105*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(r + s) - 2*Dd*f*(4*r + 4*s - 3)) + 972*Dd**2*K*f**2*r**2 + 1512*Dd**2*K*f**2*r*s - 1242*Dd**2*K*f**2*r + 420*Dd**2*K*f**2*s**2 - 798*Dd**2*K*f**2*s + 322*Dd**2*K*f**2 + 1260*Dd**2*b2*f*r**2 + 2520*Dd**2*b2*f*r*s - 1890*Dd**2*b2*f*r + 1260*Dd**2*b2*f*s**2 - 1890*Dd**2*b2*f*s + 630*Dd**2*b2*f - 540*Dd**2*f**3*r*s + 270*Dd**2*f**3*r - 756*Dd**2*f**3*s**2 + 891*Dd**2*f**3*s - 216*Dd**2*f**3 - 540*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 504*Dd**2*f**2*s**2 + 639*Dd**2*f**2*s - 174*Dd**2*f**2 - 2016*Dd**2*f*g2*r*s + 1008*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 2520*Dd**2*f*g2*s - 672*Dd**2*f*g2) + b2*(-105*D1**2*bdd1*f*(r + s - 1)**2 + 198*D1**2*f*fd*r**2 + 252*D1**2*f*fd*r*s - 198*D1**2*f*fd*r + 70*D1**2*f*fd*s**2 - 126*D1**2*f*fd*s + 99*D1**2*f*fd - 162*D1**2*f*fdd*r**2 - 252*D1**2*f*fdd*r*s + 162*D1**2*f*fdd*r - 70*D1**2*f*fdd*s**2 + 126*D1**2*f*fdd*s - 81*D1**2*f*fdd - 162*D1**2*fd**2*r**2 - 252*D1**2*fd**2*r*s + 162*D1**2*fd**2*r - 70*D1**2*fd**2*s**2 + 126*D1**2*fd**2*s + 396*D1*Dd*f**2*r**2 + 504*D1*Dd*f**2*r*s - 450*D1*Dd*f**2*r + 140*D1*Dd*f**2*s**2 - 266*D1*Dd*f**2*s + 169*D1*Dd*f**2 - 1296*D1*Dd*f*fd*r**2 - 2016*D1*Dd*f*fd*r*s + 1476*D1*Dd*f*fd*r - 560*D1*Dd*f*fd*s**2 + 1036*D1*Dd*f*fd*s - 414*D1*Dd*f*fd - 324*D1*Ddd*f**2*r**2 - 504*D1*Ddd*f**2*r*s + 414*D1*Ddd*f**2*r - 140*D1*Ddd*f**2*s**2 + 266*D1*Ddd*f**2*s - 151*D1*Ddd*f**2 + 105*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(r + s) - 2*Dd*f*(4*r + 4*s - 3)) - 972*Dd**2*f**2*r**2 - 1512*Dd**2*f**2*r*s + 1242*Dd**2*f**2*r - 420*Dd**2*f**2*s**2 + 798*Dd**2*f**2*s - 322*Dd**2*f**2))/(105*d**2*k3**2) + D1**2*Pk1*Pk3*st**4*(8*C - 4)*(D1*f*s*(-14*D1*bd1**2*s - D1*bdd1*f*s + 2*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*f*(2 - 4*s))) + 7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(fd*(4*s**2 - 4*s + 2) + fdd*(-2*s**2 + 2*s - 1) + s**2*(28*bd1 - 14*bdd1)) - 2*fd*s*(14*bd1 + fd)*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(14*bd1*s + fd*(2*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(35*d**2*k2**2) - D1**2*Pk1*Pk3*st**2*(2*C - 1)*(D1*f*s*(-50*D1*bd1**2*s + D1*bd1*(7*f*s + fd*(10 - 20*s)) - 5*D1*bdd1*f*s + 20*Dd*bd1*f*(1 - 2*s)) + 5*b1**2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + 2*D1*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(2*s**2 - 3*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(7*f*fd*(2*s**2 - 2*s + 1) - 5*f*(fdd*(2*s**2 - 2*s + 1) + s**2*(-14*bd1 + 10*bdd1)) - 10*fd*s*(10*bd1 + fd)*(s - 1)) + 2*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*(2*s - 1)*(10*bd1*s + fd*(2*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(15*d**2*k2**2) + D1**2*Pk1*Pk3*(2*C - 1)*(D1*f*s*(-6*D1*bd1**2*s - D1*bdd1*f*s + bd1*(D1*f*s + D1*fd*(2 - 4*s) + Dd*f*(4 - 8*s))) + 3*b1**2*(D1**2*(fd - fdd)*(s - 1)**2 + 2*D1*(Dd*(2*f*s**2 - 2*f*s + f - 4*fd*s**2 + 6*fd*s - 2*fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(fd*(2*s**2 - 2*s + 1) + fdd*(-2*s**2 + 2*s - 1) + s**2*(6*bd1 - 6*bdd1)) - 2*fd*s*(6*bd1 + fd)*(s - 1)) + 2*D1*f*(Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(6*bd1*s + fd*(2*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(3*d**2*k2**2) - 2*D1**2*Pk1*Pk3*k2**4*st**6*(36*C*D1**2*b1*f*fd*r**2 - 18*C*D1**2*b1*f*fdd*r**2 - 18*C*D1**2*b1*fd**2*r**2 + 6*C*D1**2*f**2*fd*r**2 - 4*C*D1**2*f**2*fd*r + 2*C*D1**2*f**2*fd - 3*C*D1**2*f**2*fdd*r**2 + 2*C*D1**2*f**2*fdd*r - C*D1**2*f**2*fdd - 6*C*D1**2*f*fd**2*r**2 + 4*C*D1**2*f*fd**2*r + 72*C*D1*Dd*b1*f**2*r**2 - 36*C*D1*Dd*b1*f**2*r + 18*C*D1*Dd*b1*f**2 - 144*C*D1*Dd*b1*f*fd*r**2 + 36*C*D1*Dd*b1*f*fd*r + 8*C*D1*Dd*f**3*r**2 - 4*C*D1*Dd*f**3*r + 2*C*D1*Dd*f**3 - 24*C*D1*Dd*f**2*fd*r**2 + 14*C*D1*Dd*f**2*fd*r - 2*C*D1*Dd*f**2*fd - 36*C*D1*Ddd*b1*f**2*r**2 + 18*C*D1*Ddd*b1*f**2*r - 9*C*D1*Ddd*b1*f**2 - 4*C*D1*Ddd*f**3*r**2 + 2*C*D1*Ddd*f**3*r - C*D1*Ddd*f**3 - 108*C*Dd**2*b1*f**2*r**2 + 54*C*Dd**2*b1*f**2*r - 12*C*Dd**2*f**3*r**2 + 6*C*Dd**2*f**3*r - 72*D1**2*b1*f*fd*r**2 - 36*D1**2*b1*f*fd*r*s + 18*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 36*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(r - 1)*(C*(r - 1) - 2*r - s + 2) - 12*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 10*D1**2*f**2*fd*r + 2*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 5*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd + 12*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 10*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 - 144*D1*Dd*b1*f**2*r**2 - 72*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r + 18*D1*Dd*b1*f**2*s - 36*D1*Dd*b1*f**2 + 288*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 144*D1*Dd*b1*f*fd*r - 18*D1*Dd*b1*f*fd*s + 9*D1*Dd*b1*f*fd - 16*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r + 2*D1*Dd*f**3*s - 4*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 38*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 7*D1*Dd*f**2*fd + 72*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 + 8*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 6*D1*Ddd*f**3*r - D1*Ddd*f**3*s + 2*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(2*f*(r - 1)*(C*(r - 1) - 2*r - s + 2) + fd*(-r**2*(4*C - 8) + r*(4*C + 4*s - 9) - 2*s + 1)) + Dd*f*(-2*C*(4*r**2 - 5*r + 1) + 16*r**2 + 8*r*s - 22*r - 5*s + 6)) + 216*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r - 27*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 24*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 18*Dd**2*f**3*r - 3*Dd**2*f**3*s + 2*Dd**2*f**3)/(63*d**2*k1**2*k3**4) + D1**2*Pk1*Pk3*k2**4*st**4*(198*C*D1**2*f**2*fd*r**2 - 132*C*D1**2*f**2*fd*r + 66*C*D1**2*f**2*fd + 264*C*D1*Dd*f**3*r**2 - 132*C*D1*Dd*f**3*r + 66*C*D1*Dd*f**3 + 33*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*bd1**2*f*(5*f*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 7*r**2*(K - 3) + 7*r*(K + 2*s - 4) - 7*s + 7) + 605*D1**2*bdd1*f**3*r*s - 550*D1**2*bdd1*f**3*r - 825*D1**2*bdd1*f**3*s + 330*D1**2*bdd1*f**3 - 99*D1**2*bdd1*f**2*r**2 - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r - 462*D1**2*bdd1*f*g2*r**2 + 924*D1**2*bdd1*f*g2*r - 462*D1**2*bdd1*f*g2 - 384*D1**2*f**3*fd*r**2 - 1100*D1**2*f**3*fd*r*s + 742*D1**2*f**3*fd*r + 275*D1**2*f**3*fd*s - 96*D1**2*f**3*fd + 720*D1**2*f**3*fdd*r**2 + 1100*D1**2*f**3*fdd*r*s - 910*D1**2*f**3*fdd*r - 275*D1**2*f**3*fdd*s + 180*D1**2*f**3*fdd + 2160*D1**2*f**2*fd**2*r**2 + 3300*D1**2*f**2*fd**2*r*s - 2730*D1**2*f**2*fd**2*r - 825*D1**2*f**2*fd**2*s + 550*D1**2*f**2*fd**2 - 396*D1**2*f**2*fd*r**2 - 198*D1**2*f**2*fd*r*s + 330*D1**2*f**2*fd*r + 66*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 132*D1**2*f**2*gd2*r**2 - 66*D1**2*f**2*gdd2*r**2 + 264*D1**2*f*fd*g2*r**2 - 264*D1**2*f*fd*g2*r + 132*D1**2*f*fd*g2 - 264*D1**2*f*fd*gd2*r**2 + 132*D1**2*f*fd*gd2*r - 132*D1**2*f*fdd*g2*r**2 + 132*D1**2*f*fdd*g2*r - 66*D1**2*f*fdd*g2 - 132*D1**2*fd**2*g2*r**2 + 132*D1**2*fd**2*g2*r - 384*D1*Dd*f**4*r**2 - 1100*D1*Dd*f**4*r*s + 742*D1*Dd*f**4*r + 275*D1*Dd*f**4*s - 96*D1*Dd*f**4 + 5760*D1*Dd*f**3*fd*r**2 + 8800*D1*Dd*f**3*fd*r*s - 7280*D1*Dd*f**3*fd*r - 2200*D1*Dd*f**3*fd*s + 1460*D1*Dd*f**3*fd - 528*D1*Dd*f**3*r**2 - 264*D1*Dd*f**3*r*s + 396*D1*Dd*f**3*r + 66*D1*Dd*f**3*s - 132*D1*Dd*f**3 + 528*D1*Dd*f**2*g2*r**2 - 264*D1*Dd*f**2*g2*r + 132*D1*Dd*f**2*g2 - 528*D1*Dd*f**2*gd2*r**2 + 132*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f*fd*g2*r**2 + 792*D1*Dd*f*fd*g2*r - 132*D1*Dd*f*fd*g2 + 720*D1*Ddd*f**4*r**2 + 1100*D1*Ddd*f**4*r*s - 910*D1*Ddd*f**4*r - 275*D1*Ddd*f**4*s + 180*D1*Ddd*f**4 - 264*D1*Ddd*f**2*g2*r**2 + 132*D1*Ddd*f**2*g2*r - 66*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(f**3*(12*r**2 + r*(71*s - 46) - 75*s + 24) + f**2*(-42*C*(r - 1)**2 - 5*fd*(6*r*(11*s - 7) - 41*s + 28) + 6*r**2*(K + 11) + 6*r*(5*s - 26) - 42*s + 84) - 6*f*(fd*(r**2*(2*K - 6) - r*(K + 4*s - 5) + s - 1) + (14*r - 14)*(g2*(r - 1) - gd2*r)) + 84*fd*g2*r*(r - 1)) + Dd*f*(-5*f**2*(r*(88*s - 62) - 71*s + 40) - 6*f*(r**2*(4*K - 12) - r*(K + 8*s - 9) + s - 1) + 84*g2*(4*r**2 - 5*r + 1))) + 2160*Dd**2*f**4*r**2 + 3300*Dd**2*f**4*r*s - 2730*Dd**2*f**4*r - 825*Dd**2*f**4*s + 550*Dd**2*f**4 - 792*Dd**2*f**2*g2*r**2 + 396*Dd**2*f**2*g2*r + 33*b1**2*(D1**2*r*(2*f*(3*fd - 5*fdd)*(4*r + 4*s - 3) - 10*fd**2*(4*r + 4*s - 3) - 14*fd*r*(K - 3) + 28*fd*s + 7*fdd*r*(K - 3) - 14*fdd*s) + D1*(2*Dd*(6*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-28*K*r**2 + 14*K*r - 7*K - 5*fd*(8*r - 1)*(4*r + 4*s - 3) + 84*r**2 + 56*r*s - 70*r - 14*s + 21) + 7*fd*(r**2*(4*K - 12) - r*(K + 8*s - 5) + s)) + Ddd*f*(28*K*r**2 - 14*K*r + 7*K - 20*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 84*r**2 - 56*r*s + 70*r + 14*s - 21)) - 2*Dd**2*f*(10*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - 7*r**2*(6*K - 18) + 21*r*(K + 4*s - 5) - 21*s + 14)) + 11*b1*(84*C*D1**2*f*fd*r**2 + 168*C*D1*Dd*f**2*r**2 - 84*C*D1*Dd*f**2*r + 42*C*D1*Dd*f**2 - 12*D1**2*K*f*fd*r**2 + 12*D1**2*K*f*fd*r - 6*D1**2*K*f*fd + 6*D1**2*K*f*fdd*r**2 - 6*D1**2*K*f*fdd*r + 3*D1**2*K*f*fdd + 6*D1**2*K*fd**2*r**2 - 6*D1**2*K*fd**2*r - 3*D1**2*bdd1*f*(-14*K*r**2 + 14*K*r - 7*K + 10*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + 42*r**2 + 28*r*s - 56*r - 14*s + 21) - 36*D1**2*f**2*fd*r**2 - 213*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 4*D1**2*f**2*fd*s + 12*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 20*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 40*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 - 132*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s + 6*D1**2*f*fd*r - 12*D1**2*f*fd*s + 18*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r + 6*D1**2*f*fdd*s - 9*D1**2*f*fdd + 84*D1**2*f*gd2*r**2 - 42*D1**2*f*gdd2*r**2 - 18*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 18*D1**2*fd**2*r + 6*D1**2*fd**2*s + 84*D1**2*fd*g2*r**2 - 84*D1**2*fd*gd2*r**2 - 42*D1**2*fdd*g2*r**2 - 24*D1*Dd*K*f**2*r**2 + 12*D1*Dd*K*f**2*r - 6*D1*Dd*K*f**2 + 48*D1*Dd*K*f*fd*r**2 - 36*D1*Dd*K*f*fd*r + 6*D1*Dd*K*f*fd - 48*D1*Dd*f**3*r**2 - 284*D1*Dd*f**3*r*s + 166*D1*Dd*f**3*r + 71*D1*Dd*f**3*s - 12*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r*s - 570*D1*Dd*f**2*fd*r - 85*D1*Dd*f**2*fd*s + 20*D1*Dd*f**2*fd - 264*D1*Dd*f**2*r**2 - 120*D1*Dd*f**2*r*s + 192*D1*Dd*f**2*r + 30*D1*Dd*f**2*s - 66*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 132*D1*Dd*f*fd*r + 36*D1*Dd*f*fd*s - 30*D1*Dd*f*fd + 336*D1*Dd*f*g2*r**2 - 168*D1*Dd*f*g2*r + 84*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r**2 + 84*D1*Dd*f*gd2*r - 336*D1*Dd*fd*g2*r**2 + 84*D1*Dd*fd*g2*r + 12*D1*Ddd*K*f**2*r**2 - 6*D1*Ddd*K*f**2*r + 3*D1*Ddd*K*f**2 + 220*D1*Ddd*f**3*r*s - 110*D1*Ddd*f**3*r - 55*D1*Ddd*f**3*s - 36*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r + 6*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r**2 + 84*D1*Ddd*f*g2*r - 42*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(3*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(-14*K*r**2 + 14*K*r - 7*K - 5*fd*(4*r - 1)*(4*r + 4*s - 3) + 42*r**2 + 28*r*s - 56*r - 14*s + 21) + 7*fd*(r**2*(2*K - 6) - r*(K + 4*s - 4) + s)) + Dd*f*(56*K*r**2 - 42*K*r + 7*K - 5*f*(8*r - 3)*(4*r + 4*s - 3) - 168*r**2 - 112*r*s + 182*r + 42*s - 42)) + 36*Dd**2*K*f**2*r**2 - 18*Dd**2*K*f**2*r + 660*Dd**2*f**3*r*s - 330*Dd**2*f**3*r - 165*Dd**2*f**3*s + 110*Dd**2*f**3 - 108*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 90*Dd**2*f**2*r + 18*Dd**2*f**2*s - 12*Dd**2*f**2 - 504*Dd**2*f*g2*r**2 + 252*Dd**2*f*g2*r))/(1155*d**2*k1**2*k3**4) + 2*D1**2*Pk1*Pk3*k2**2*st**6*(9*D1*bd1*f*(D1*(2*f*s*(r - 1) + fd*(-4*r*s + r + 2*s - 1)) + Dd*f*(r*(2 - 8*s) + 5*s - 2)) - 9*b1*(D1*Dd*f*(2*f*(-4*r*s + 2*r + s) + fd*(8*r - 1)*(2*s - 1)) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + 2*r + s)) + Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(2*f*(4*r*s - 2*r - s) + fd*(-24*r*s + 10*r + 7*s - 3)) + D1*(D1*(2*f*fd*(r*(3*s - 1) - s) + f*(-9*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) + fd**2*(r*(2 - 6*s) + 2*s - 1)) + Ddd*f**2*(r*(2 - 4*s) + s)) + Dd**2*f**2*(r*(6 - 12*s) + 3*s - 2)))/(63*d**2*k1**2*k3**2) + D1**2*Pk1*Pk3*k2**2*st**4*(-42*b1**2*(C - 1)*(D1**2*r**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*r*(1 - 4*r)) + D1*Ddd*f*(-4*r**2 + 2*r - 1) + 6*Dd**2*f*r*(1 - 2*r)) - 3*b1*(8*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 + 4*C*D1**2*f*fdd*r - 2*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 + 4*C*D1**2*fd**2*r + 16*C*D1*Dd*f**2*r**2 - 8*C*D1*Dd*f**2*r + 4*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 + 24*C*D1*Dd*f*fd*r - 4*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 + 4*C*D1*Ddd*f**2*r - 2*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 + 12*C*Dd**2*f**2*r - 14*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) + 4*D1**2*f*fd*r**2 + 90*D1**2*f*fd*r*s - 37*D1**2*f*fd*r - 4*D1**2*f*fd - 16*D1**2*f*fdd*r**2 - 66*D1**2*f*fdd*r*s + 29*D1**2*f*fdd*r + 2*D1**2*f*fdd - 16*D1**2*fd**2*r**2 - 66*D1**2*fd**2*r*s + 29*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 + 180*D1*Dd*f**2*r*s - 94*D1*Dd*f**2*r - 45*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 128*D1*Dd*f*fd*r**2 - 528*D1*Dd*f*fd*r*s + 280*D1*Dd*f*fd*r + 66*D1*Dd*f*fd*s - 29*D1*Dd*f*fd - 32*D1*Ddd*f**2*r**2 - 132*D1*Ddd*f**2*r*s + 82*D1*Ddd*f**2*r + 33*D1*Ddd*f**2*s - 8*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(1 - 2*r) + Dd*f*(-8*r**2 + 6*r - 1)) - 96*Dd**2*f**2*r**2 - 396*Dd**2*f**2*r*s + 246*Dd**2*f**2*r + 99*Dd**2*f**2*s - 66*Dd**2*f**2) + f*(48*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r + 16*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r**2 + 40*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd - 120*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r + 64*C*D1*Dd*f**2*r**2 - 32*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r**2 + 280*C*D1*Dd*f*fd*r - 40*C*D1*Dd*f*fd - 80*C*D1*Ddd*f**2*r**2 + 40*C*D1*Ddd*f**2*r - 20*C*D1*Ddd*f**2 - 240*C*Dd**2*f**2*r**2 + 120*C*Dd**2*f**2*r + 84*D1**2*bd1**2*r*(C - 1)*(r - 1) + 3*D1**2*bdd1*f*(r**2*(2*C + 8) + r*(33*s - 20) - 33*s + 10) - 30*D1**2*f*fd*r**2 - 75*D1**2*f*fd*r*s + 45*D1**2*f*fd*r + 25*D1**2*f*fd*s - 10*D1**2*f*fd + 60*D1**2*f*fdd*r**2 + 51*D1**2*f*fdd*r*s - 57*D1**2*f*fdd*r - 17*D1**2*f*fdd*s + 20*D1**2*f*fdd + 120*D1**2*fd**2*r**2 + 102*D1**2*fd**2*r*s - 114*D1**2*fd**2*r - 34*D1**2*fd**2*s + 17*D1**2*fd**2 - 40*D1*Dd*f**2*r**2 - 100*D1*Dd*f**2*r*s + 70*D1*Dd*f**2*r + 25*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 + 408*D1*Dd*f*fd*r*s - 450*D1*Dd*f*fd*r - 119*D1*Dd*f*fd*s + 91*D1*Dd*f*fd + 80*D1*Ddd*f**2*r**2 + 68*D1*Ddd*f**2*r*s - 74*D1*Ddd*f**2*r - 17*D1*Ddd*f**2*s + 20*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r**2*(4*C + 2) + 3*r*(15*s - 4) - 45*s + 6) + fd*(-r**2*(8*C + 32) + r*(4*C - 132*s + 69) + 66*s - 33)) + Dd*f*(-r**2*(16*C + 64) + 2*r*(2*C - 132*s + 81) + 165*s - 86)) + 240*Dd**2*f**2*r**2 + 204*Dd**2*f**2*r*s - 222*Dd**2*f**2*r - 51*Dd**2*f**2*s + 34*Dd**2*f**2))/(105*d**2*k1**2*k3**2) + D1**2*Pk1*Pk3*k2**2*st**2*(-12*D1**2*K*bdd1*f**2*r**2 + 20*D1**2*b2*f*fd*r**2 - 20*D1**2*b2*f*fd*r + 10*D1**2*b2*f*fd - 24*D1**2*b2*f*fdd*r**2 + 24*D1**2*b2*f*fdd*r - 12*D1**2*b2*f*fdd - 24*D1**2*b2*fd**2*r**2 + 24*D1**2*b2*fd**2*r + D1**2*bd1**2*(3*f**2*(16*r**2 + r*(84*s - 45) - 42*s + 21) + 7*f*(r**2*(2*K + 10) + r*(26*s - 25) - 13*s + 13) - 140*g2*r*(r - 1)) + 10*D1**2*bd2*f**2*r**2 - 48*D1**2*bd2*f*fd*r**2 + 24*D1**2*bd2*f*fd*r + 24*D1**2*bdd1*f**3*r**2 + 54*D1**2*bdd1*f**3*r*s - 27*D1**2*bdd1*f**3*r + 18*D1**2*bdd1*f**2*r**2 + 23*D1**2*bdd1*f**2*r*s - 23*D1**2*bdd1*f**2*r - 14*D1**2*bdd1*f*g2*r**2 - 12*D1**2*bdd2*f**2*r**2 - 20*D1**2*f**2*gd2*r**2 + 24*D1**2*f**2*gdd2*r**2 - 40*D1**2*f*fd*g2*r**2 + 40*D1**2*f*fd*g2*r - 20*D1**2*f*fd*g2 + 96*D1**2*f*fd*gd2*r**2 - 48*D1**2*f*fd*gd2*r + 48*D1**2*f*fdd*g2*r**2 - 48*D1**2*f*fdd*g2*r + 24*D1**2*f*fdd*g2 + 48*D1**2*fd**2*g2*r**2 - 48*D1**2*fd**2*g2*r + 40*D1*Dd*b2*f**2*r**2 - 20*D1*Dd*b2*f**2*r + 10*D1*Dd*b2*f**2 - 192*D1*Dd*b2*f*fd*r**2 + 144*D1*Dd*b2*f*fd*r - 24*D1*Dd*b2*f*fd - 96*D1*Dd*bd2*f**2*r**2 + 24*D1*Dd*bd2*f**2*r - 80*D1*Dd*f**2*g2*r**2 + 40*D1*Dd*f**2*g2*r - 20*D1*Dd*f**2*g2 + 192*D1*Dd*f**2*gd2*r**2 - 48*D1*Dd*f**2*gd2*r + 384*D1*Dd*f*fd*g2*r**2 - 288*D1*Dd*f*fd*g2*r + 48*D1*Dd*f*fd*g2 - 48*D1*Ddd*b2*f**2*r**2 + 24*D1*Ddd*b2*f**2*r - 12*D1*Ddd*b2*f**2 + 96*D1*Ddd*f**2*g2*r**2 - 48*D1*Ddd*f**2*g2*r + 24*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-3*f**3*r*(4*r + 18*s - 9) + f**2*(3*fd*(48*r**2 + 2*r*(54*s - 35) - 18*s + 9) + r*(r*(14*C + 10*K - 8) - 25*s + 25)) + f*(fd*(r**2*(72 - 48*K) + r*(24*K + 92*s - 82) - 23*s + 23) + r**2*(28*g2 - 28*gd2)) - 28*fd*g2*r*(r - 1)) + Dd*f*(3*f**2*(64*r**2 + 8*r*(18*s - 11) - 18*s + 9) + f*(r**2*(144 - 96*K) + 2*r*(12*K + 92*s - 87) - 23*s + 23) + 28*g2*r*(1 - 4*r))) - 144*Dd**2*b2*f**2*r**2 + 72*Dd**2*b2*f**2*r + 288*Dd**2*f**2*g2*r**2 - 144*Dd**2*f**2*g2*r - 35*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(1 - 2*r)) + b1**2*(70*C*D1**2*fd*r**2 + 280*C*D1*Dd*f*r**2 - 140*C*D1*Dd*f*r + 70*C*D1*Dd*f - 14*D1**2*K*fd*r**2 + 28*D1**2*K*fd*r - 14*D1**2*K*fd + 7*D1**2*K*fdd*r**2 - 14*D1**2*K*fdd*r + 7*D1**2*K*fdd + 35*D1**2*bdd1*(K - 1)*(3*r**2 - 2*r + 1) - 40*D1**2*f*fd*r**2 - 252*D1**2*f*fd*r*s + 169*D1**2*f*fd*r + 10*D1**2*f*fd + 48*D1**2*f*fdd*r**2 + 252*D1**2*f*fdd*r*s - 165*D1**2*f*fdd*r - 12*D1**2*f*fdd + 48*D1**2*fd**2*r**2 + 252*D1**2*fd**2*r*s - 165*D1**2*fd**2*r - 70*D1**2*fd*r**2 - 77*D1**2*fd*r*s - 28*D1**2*fd*r + 14*D1**2*fd + 35*D1**2*fdd*r**2 + 91*D1**2*fdd*r*s + 14*D1**2*fdd*r - 7*D1**2*fdd + 140*D1**2*gd2*r**2 - 70*D1**2*gdd2*r**2 - 56*D1*Dd*K*f*r**2 + 28*D1*Dd*K*f*r - 14*D1*Dd*K*f + 56*D1*Dd*K*fd*r**2 - 70*D1*Dd*K*fd*r + 14*D1*Dd*K*fd - 80*D1*Dd*f**2*r**2 - 504*D1*Dd*f**2*r*s + 292*D1*Dd*f**2*r + 126*D1*Dd*f**2*s - 20*D1*Dd*f**2 + 384*D1*Dd*f*fd*r**2 + 2016*D1*Dd*f*fd*r*s - 1260*D1*Dd*f*fd*r - 252*D1*Dd*f*fd*s + 165*D1*Dd*f*fd - 280*D1*Dd*f*r**2 - 308*D1*Dd*f*r*s + 294*D1*Dd*f*r + 77*D1*Dd*f*s - 70*D1*Dd*f + 280*D1*Dd*fd*r**2 + 728*D1*Dd*fd*r*s - 196*D1*Dd*fd*r - 91*D1*Dd*fd*s - 14*D1*Dd*fd + 560*D1*Dd*g2*r**2 - 280*D1*Dd*g2*r + 140*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 + 140*D1*Dd*gd2*r + 28*D1*Ddd*K*f*r**2 - 14*D1*Ddd*K*f*r + 7*D1*Ddd*K*f + 96*D1*Ddd*f**2*r**2 + 504*D1*Ddd*f**2*r*s - 300*D1*Ddd*f**2*r - 126*D1*Ddd*f**2*s + 24*D1*Ddd*f**2 + 140*D1*Ddd*f*r**2 + 364*D1*Ddd*f*r*s - 252*D1*Ddd*f*r - 91*D1*Ddd*f*s + 35*D1*Ddd*f - 280*D1*Ddd*g2*r**2 + 140*D1*Ddd*g2*r - 70*D1*Ddd*g2 - 70*D1*bd1*(K - 1)*(D1*(3*r**2 - 2*r + 1) + Dd*(-12*r**2 + 7*r - 1)) + 84*Dd**2*K*f*r**2 - 42*Dd**2*K*f*r + 288*Dd**2*f**2*r**2 + 1512*Dd**2*f**2*r*s - 900*Dd**2*f**2*r - 378*Dd**2*f**2*s + 252*Dd**2*f**2 + 420*Dd**2*f*r**2 + 1092*Dd**2*f*r*s - 756*Dd**2*f*r - 273*Dd**2*f*s + 182*Dd**2*f - 840*Dd**2*g2*r**2 + 420*Dd**2*g2*r) + b1*(28*C*D1**2*f*fd*r**2 - 28*C*D1**2*f*fd*r + 14*C*D1**2*f*fd + 56*C*D1*Dd*f**2*r**2 - 28*C*D1*Dd*f**2*r + 14*C*D1*Dd*f**2 + 20*D1**2*K*f*fd*r**2 - 20*D1**2*K*f*fd*r + 10*D1**2*K*f*fd - 24*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r - 12*D1**2*K*f*fdd - 24*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r + 70*D1**2*bd1**2*r*(K - 1)*(3*r - 2) + D1**2*bdd1*(3*f**2*(16*r**2 + r*(84*s - 45) - 42*s + 12) + 7*f*(r**2*(2*K + 10) + r*(26*s - 25) - 13*s + 6) - 70*g2*(2*r**2 - 2*r + 1)) - 36*D1**2*f**2*fd*r**2 - 162*D1**2*f**2*fd*r*s + 105*D1**2*f**2*fd*r + 54*D1**2*f**2*fd*s - 12*D1**2*f**2*fd + 72*D1**2*f**2*fdd*r**2 + 162*D1**2*f**2*fdd*r*s - 129*D1**2*f**2*fdd*r - 54*D1**2*f**2*fdd*s + 24*D1**2*f**2*fdd + 144*D1**2*f*fd**2*r**2 + 324*D1**2*f*fd**2*r*s - 258*D1**2*f*fd**2*r - 108*D1**2*f*fd**2*s + 81*D1**2*f*fd**2 - 16*D1**2*f*fd*r**2 - 50*D1**2*f*fd*r*s + 16*D1**2*f*fd*r + 25*D1**2*f*fd*s - 8*D1**2*f*fd + 36*D1**2*f*fdd*r**2 + 46*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r - 23*D1**2*f*fdd*s + 18*D1**2*f*fdd + 28*D1**2*f*gd2*r**2 - 14*D1**2*f*gdd2*r**2 + 36*D1**2*fd**2*r**2 + 46*D1**2*fd**2*r*s - 36*D1**2*fd**2*r - 23*D1**2*fd**2*s + 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r + 28*D1**2*fd*g2 - 28*D1**2*fd*gd2*r**2 + 28*D1**2*fd*gd2*r - 14*D1**2*fdd*g2*r**2 + 28*D1**2*fdd*g2*r - 14*D1**2*fdd*g2 + 40*D1*Dd*K*f**2*r**2 - 20*D1*Dd*K*f**2*r + 10*D1*Dd*K*f**2 - 192*D1*Dd*K*f*fd*r**2 + 144*D1*Dd*K*f*fd*r - 24*D1*Dd*K*f*fd - 48*D1*Dd*f**3*r**2 - 216*D1*Dd*f**3*r*s + 132*D1*Dd*f**3*r + 54*D1*Dd*f**3*s - 12*D1*Dd*f**3 + 576*D1*Dd*f**2*fd*r**2 + 1296*D1*Dd*f**2*fd*r*s - 984*D1*Dd*f**2*fd*r - 378*D1*Dd*f**2*fd*s + 237*D1*Dd*f**2*fd - 32*D1*Dd*f**2*r**2 - 100*D1*Dd*f**2*r*s + 66*D1*Dd*f**2*r + 25*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 288*D1*Dd*f*fd*r**2 + 368*D1*Dd*f*fd*r*s - 308*D1*Dd*f*fd*r - 138*D1*Dd*f*fd*s + 82*D1*Dd*f*fd + 112*D1*Dd*f*g2*r**2 - 56*D1*Dd*f*g2*r + 28*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*r**2 + 28*D1*Dd*f*gd2*r - 112*D1*Dd*fd*g2*r**2 + 140*D1*Dd*fd*g2*r - 28*D1*Dd*fd*g2 - 48*D1*Ddd*K*f**2*r**2 + 24*D1*Ddd*K*f**2*r - 12*D1*Ddd*K*f**2 + 96*D1*Ddd*f**3*r**2 + 216*D1*Ddd*f**3*r*s - 156*D1*Ddd*f**3*r - 54*D1*Ddd*f**3*s + 24*D1*Ddd*f**3 + 72*D1*Ddd*f**2*r**2 + 92*D1*Ddd*f**2*r*s - 82*D1*Ddd*f**2*r - 23*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 - 56*D1*Ddd*f*g2*r**2 + 28*D1*Ddd*f*g2*r - 14*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(-40*r**2 - 252*r*s + 123*r + 126*s - 30) + f*(70*C*(2*r**2 - 2*r + 1) + 3*fd*(64*r**2 + 8*r*(42*s - 25) - 84*s + 63) - 7*r**2*(4*K + 20) - 7*r*(22*s - 35) + 77*s - 84) + 7*fd*(r**2*(4*K + 20) + r*(-4*K + 52*s - 21) - 13*s) + 140*g2*(2*r**2 - 2*r + 1) + 140*gd2*r*(1 - 2*r)) + Dd*(3*f**2*(128*r**2 + 4*r*(168*s - 95) - 252*s + 129) + 7*f*(r**2*(16*K + 80) - 4*r*(K - 52*s + 43) - 78*s + 51) - 140*g2*(8*r**2 - 6*r + 1))) - 144*Dd**2*K*f**2*r**2 + 72*Dd**2*K*f**2*r + 288*Dd**2*f**3*r**2 + 648*Dd**2*f**3*r*s - 468*Dd**2*f**3*r - 162*Dd**2*f**3*s + 108*Dd**2*f**3 + 216*Dd**2*f**2*r**2 + 276*Dd**2*f**2*r*s - 246*Dd**2*f**2*r - 69*Dd**2*f**2*s + 46*Dd**2*f**2 - 168*Dd**2*f*g2*r**2 + 84*Dd**2*f*g2*r))/(105*d**2*k1**2*k3**2) + 2*D1**2*Pk1*Pk3*st**4*(D1*f*(7*D1*bd1**2*s*(1 - 2*r) + D1*bd1*(2*f*r*s + fd*(-4*r*s + r + s)) - D1*bdd1*f*r*s + Dd*bd1*f*(r*(2 - 8*s) + s)) - 7*b1**2*(D1*Dd*(2*f*(-4*r*s + 2*r + s) + fd*(8*r*s - 6*r - s + 1)) - D1*(D1*r*(2*fd - fdd)*(s - 1) + Ddd*f*(-4*r*s + 2*r + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(D1*Dd*f*(4*f*r*(2*s - 1) - 2*f*s - fd*(8*r - 3)*(2*s - 1)) + 7*D1*bd1*(D1*(2*f*s*(2*r - 1) + fd*(-4*r*s + 2*r + s - 1)) - 2*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(7*bdd1*f*s*(1 - 2*r) + 2*f*fd*r*(2*s - 1) - 2*f*fd*s + f*fdd*(-2*r*s + r + s) + fd**2*(-2*r*s + r + s - 1)) + Ddd*f**2*(r*(2 - 4*s) + s)) + Dd**2*f**2*(r*(6 - 12*s) + 3*s - 2)))/(35*d**2*k1**2) + D1**2*Pk1*Pk3*st**2*(D1*f*(91*D1*bd1**2*s*(2*r - 1) + D1*bdd1*f*r*(r*(12 - 24*C) + 23*s) + bd1*(D1*(f*r*(r*(20*C - 10) - 39*s) + fd*(r**2*(48 - 96*C) + r*(48*C + 92*s - 47) - 23*s)) + Dd*f*(r**2*(96 - 192*C) + 2*r*(24*C + 92*s - 35) - 23*s))) + 7*b1**2*(D1*Dd*(21*f*(-4*r*s + 2*r + s) + 13*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(21*fd - 13*fdd)*(s - 1) + 13*Ddd*f*(4*r*s - 2*r - s)) + 13*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(D1**2*(f*(91*bdd1*s*(2*r - 1) + fd*(20*C*(2*r**2 - 2*r + 1) - 20*r**2 - 78*r*s + 59*r + 39*s - 10) + fdd*(-24*C*(2*r**2 - 2*r + 1) + 24*r**2 + 46*r*s - 47*r - 23*s + 12)) + fd**2*(r**2*(24 - 48*C) + r*(48*C + 46*s - 47) - 23*s + 23)) - 7*D1*bd1*(D1*(21*f*s*(2*r - 1) - 13*fd*(4*r*s - 2*r - s + 1)) - 26*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*f*(Dd*(f*(20*C*(4*r**2 - 2*r + 1) - 40*r**2 + r*(98 - 156*s) + 39*s - 10) + fd*(-48*C*(8*r**2 - 6*r + 1) + 192*r**2 + 8*r*(46*s - 41) - 138*s + 93)) + Ddd*f*(-24*C*(4*r**2 - 2*r + 1) + 48*r**2 + r*(92*s - 70) - 23*s + 12)) + Dd**2*f**2*(-r**2*(288*C - 144) + 6*r*(24*C + 46*s - 35) - 69*s + 46)))/(105*d**2*k1**2) - D1**2*Pk1*Pk3*(D1*r*(D1*bd1**2*f*(4*K*r + f*(3 - 6*s) - 6*s + 3) + 2*D1*bdd1*f*r*(b2 - 2*g2) + 4*bd1*(D1*f*r*(bd2 + 2*g2 - 2*gd2) - 2*D1*fd*g2*(r - 1) + 2*Dd*f*g2*(1 - 4*r) + b2*(-D1*f*r + D1*fd*(r - 1) + Dd*f*(4*r - 1)))) - 5*b1**3*(D1*Dd*(fd*(8*r*s - 6*r - s + 1) - (f - 1)*(4*r*s - 2*r - s)) + D1*(-D1*r*(fd - fdd)*(s - 1) + Ddd*(f + 1)*(4*r*s - 2*r - s)) + Dd**2*(f + 1)*(6*r*(2*s - 1) - 3*s + 2)) + b1**2*(-D1*Dd*(4*K*f*(4*r**2 - 2*r + 1) - 4*K*fd*(4*r**2 - 5*r + 1) + 3*f*fd*(8*r - 3)*(2*s - 1) - f*(3*f + 1)*(r*(4*s - 2) - s) + 3*fd*(r*(8*s - 2) - 5*s + 2)) + 5*D1*bd1*(D1*(fd*(-6*r*s + 4*r + s - 1) + (f - 1)*(3*r*s - r - s)) - Dd*(f + 1)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(-5*bdd1*(f + 1)*(r*(3*s - 1) - s) + 3*fd**2*(-2*r*s + r + s - 1) - fd*(4*K*(r - 1)**2 + 3*f*(-2*r*s + r + s) - r*s + s) + fdd*(2*K*(r - 1)**2 + 3*f*(-2*r*s + r + s) - 3*r*s + 3*s)) + Ddd*f*(K*(8*r**2 - 4*r + 2) - (3*f + 3)*(r*(4*s - 2) - s))) - 3*Dd**2*f*(-8*K*r**2 + f*(6*r*(2*s - 1) - 3*s + 2) + 2*r*(2*K + 6*s - 3) - 3*s + 2)) + b1*(4*D1**2*K*bdd1*f*r**2 - 5*D1**2*bd1**2*(f + 1)*(r*(6*s - 2) - 2*s + 1) - 4*D1**2*bd2*f*r**2 + 4*D1**2*bd2*fd*r**2 - 4*D1**2*bd2*fd*r - 6*D1**2*bdd1*f**2*r*s + 3*D1**2*bdd1*f**2*r - 6*D1**2*bdd1*f*r*s + 3*D1**2*bdd1*f*r + 2*D1**2*bdd2*f*r**2 + 8*D1**2*f*gd2*r**2 - 4*D1**2*f*gdd2*r**2 + 8*D1**2*fd*g2*r**2 - 16*D1**2*fd*g2*r + 8*D1**2*fd*g2 - 8*D1**2*fd*gd2*r**2 + 8*D1**2*fd*gd2*r - 4*D1**2*fdd*g2*r**2 + 8*D1**2*fdd*g2*r - 4*D1**2*fdd*g2 + 16*D1*Dd*bd2*f*r**2 - 4*D1*Dd*bd2*f*r + 32*D1*Dd*f*g2*r**2 - 16*D1*Dd*f*g2*r + 8*D1*Dd*f*g2 - 32*D1*Dd*f*gd2*r**2 + 8*D1*Dd*f*gd2*r - 32*D1*Dd*fd*g2*r**2 + 40*D1*Dd*fd*g2*r - 8*D1*Dd*fd*g2 - 16*D1*Ddd*f*g2*r**2 + 8*D1*Ddd*f*g2*r - 4*D1*Ddd*f*g2 + D1*bd1*(-D1*(f*r*(8*K*r + f*(3 - 6*s) - 2*s + 1) + fd*(-8*K*r**2 + 3*f*(4*r - 1)*(2*s - 1) + r*(8*K + 12*s - 3) - 6*s + 3)) + Dd*f*(32*K*r**2 - 3*f*(8*r - 1)*(2*s - 1) - 8*r*(K + 6*s - 3) + 6*s - 3)) - 48*Dd**2*f*g2*r**2 + 24*Dd**2*f*g2*r - 2*b2*(D1**2*(2*fd - fdd)*(r - 1)**2 + 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*(-4*r**2 + 5*r - 1)) + D1*Ddd*f*(-4*r**2 + 2*r - 1) + 6*Dd**2*f*r*(1 - 2*r))))/(15*d**2*k1**2) + D1**2*Pk1*Pkd3*ct**8*k2**6*(C - 1)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 42*D1**2*f**2*fd*r**2 + 84*D1**2*f**2*fd*r*s - 56*D1**2*f**2*fd*r + 42*D1**2*f**2*fd*s**2 - 56*D1**2*f**2*fd*s + 28*D1**2*f**2*fd - 21*D1**2*f**2*fdd*r**2 - 42*D1**2*f**2*fdd*r*s + 28*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd*s**2 + 28*D1**2*f**2*fdd*s - 14*D1**2*f**2*fdd - 42*D1**2*f*fd**2*r**2 - 84*D1**2*f*fd**2*r*s + 56*D1**2*f*fd**2*r - 42*D1**2*f*fd**2*s**2 + 56*D1**2*f*fd**2*s - 14*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 56*D1*Dd*f**3*r**2 + 112*D1*Dd*f**3*r*s - 84*D1*Dd*f**3*r + 56*D1*Dd*f**3*s**2 - 84*D1*Dd*f**3*s + 42*D1*Dd*f**3 - 168*D1*Dd*f**2*fd*r**2 - 336*D1*Dd*f**2*fd*r*s + 238*D1*Dd*f**2*fd*r - 168*D1*Dd*f**2*fd*s**2 + 238*D1*Dd*f**2*fd*s - 84*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 - 56*D1*Ddd*f**3*r*s + 42*D1*Ddd*f**3*r - 28*D1*Ddd*f**3*s**2 + 42*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 84*Dd**2*f**3*r**2 - 168*Dd**2*f**3*r*s + 126*Dd**2*f**3*r - 84*Dd**2*f**3*s**2 + 126*Dd**2*f**3*s - 42*Dd**2*f**3)/(7*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**8*k2**4*(4*C - 4)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 14*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 7*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 7*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(63*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**7*f*k2**7*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 88*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 88*D1**2*b1*f*fd*s + 44*D1**2*b1*f*fd - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 44*D1**2*b1*f*fdd*r - 33*D1**2*b1*f*fdd*s**2 + 44*D1**2*b1*f*fdd*s - 22*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 88*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 88*D1**2*b1*fd**2*s - 22*D1**2*b1*fd**2 - 11*D1**2*bdd1*f**2*(r + s - 1)**2 + 72*D1**2*f**2*fd*r**2 + 144*D1**2*f**2*fd*r*s - 108*D1**2*f**2*fd*r + 72*D1**2*f**2*fd*s**2 - 108*D1**2*f**2*fd*s + 54*D1**2*f**2*fd - 36*D1**2*f**2*fdd*r**2 - 72*D1**2*f**2*fdd*r*s + 54*D1**2*f**2*fdd*r - 36*D1**2*f**2*fdd*s**2 + 54*D1**2*f**2*fdd*s - 27*D1**2*f**2*fdd - 108*D1**2*f*fd**2*r**2 - 216*D1**2*f*fd**2*r*s + 162*D1**2*f*fd**2*r - 108*D1**2*f*fd**2*s**2 + 162*D1**2*f*fd**2*s - 54*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 176*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r + 88*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 374*D1*Dd*b1*f*fd*r - 264*D1*Dd*b1*f*fd*s**2 + 374*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 72*D1*Dd*f**3*r**2 + 144*D1*Dd*f**3*r*s - 108*D1*Dd*f**3*r + 72*D1*Dd*f**3*s**2 - 108*D1*Dd*f**3*s + 54*D1*Dd*f**3 - 288*D1*Dd*f**2*fd*r**2 - 576*D1*Dd*f**2*fd*r*s + 432*D1*Dd*f**2*fd*r - 288*D1*Dd*f**2*fd*s**2 + 432*D1*Dd*f**2*fd*s - 162*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 - 88*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r - 44*D1*Ddd*b1*f**2*s**2 + 66*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 36*D1*Ddd*f**3*r**2 - 72*D1*Ddd*f**3*r*s + 54*D1*Ddd*f**3*r - 36*D1*Ddd*f**3*s**2 + 54*D1*Ddd*f**3*s - 27*D1*Ddd*f**3 + 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 132*Dd**2*b1*f**2*r**2 - 264*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r - 132*Dd**2*b1*f**2*s**2 + 198*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 108*Dd**2*f**3*r**2 - 216*Dd**2*f**3*r*s + 162*Dd**2*f**3*r - 108*Dd**2*f**3*s**2 + 162*Dd**2*f**3*s - 54*Dd**2*f**3)/(22*d**2*k1*k3**7) + D1**2*Pk1*Pkd3*ct**7*k1*k2**5*(1656*C*D1**2*b1*f*fd*r**2 + 3312*C*D1**2*b1*f*fd*r*s - 1656*C*D1**2*b1*f*fd*r + 1656*C*D1**2*b1*f*fd*s**2 - 1656*C*D1**2*b1*f*fd*s + 828*C*D1**2*b1*f*fd - 1080*C*D1**2*b1*f*fdd*r**2 - 2160*C*D1**2*b1*f*fdd*r*s + 1080*C*D1**2*b1*f*fdd*r - 1080*C*D1**2*b1*f*fdd*s**2 + 1080*C*D1**2*b1*f*fdd*s - 540*C*D1**2*b1*f*fdd - 1080*C*D1**2*b1*fd**2*r**2 - 2160*C*D1**2*b1*fd**2*r*s + 1080*C*D1**2*b1*fd**2*r - 1080*C*D1**2*b1*fd**2*s**2 + 1080*C*D1**2*b1*fd**2*s + 1980*C*D1**2*f**2*fd*r**2 + 3960*C*D1**2*f**2*fd*r*s - 2640*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd*s**2 - 2640*C*D1**2*f**2*fd*s + 1320*C*D1**2*f**2*fd - 1260*C*D1**2*f**2*fdd*r**2 - 2520*C*D1**2*f**2*fdd*r*s + 1680*C*D1**2*f**2*fdd*r - 1260*C*D1**2*f**2*fdd*s**2 + 1680*C*D1**2*f**2*fdd*s - 840*C*D1**2*f**2*fdd - 2520*C*D1**2*f*fd**2*r**2 - 5040*C*D1**2*f*fd**2*r*s + 3360*C*D1**2*f*fd**2*r - 2520*C*D1**2*f*fd**2*s**2 + 3360*C*D1**2*f*fd**2*s - 840*C*D1**2*f*fd**2 + 3312*C*D1*Dd*b1*f**2*r**2 + 6624*C*D1*Dd*b1*f**2*r*s - 4968*C*D1*Dd*b1*f**2*r + 3312*C*D1*Dd*b1*f**2*s**2 - 4968*C*D1*Dd*b1*f**2*s + 2484*C*D1*Dd*b1*f**2 - 8640*C*D1*Dd*b1*f*fd*r**2 - 17280*C*D1*Dd*b1*f*fd*r*s + 10800*C*D1*Dd*b1*f*fd*r - 8640*C*D1*Dd*b1*f*fd*s**2 + 10800*C*D1*Dd*b1*f*fd*s - 3240*C*D1*Dd*b1*f*fd + 2640*C*D1*Dd*f**3*r**2 + 5280*C*D1*Dd*f**3*r*s - 3960*C*D1*Dd*f**3*r + 2640*C*D1*Dd*f**3*s**2 - 3960*C*D1*Dd*f**3*s + 1980*C*D1*Dd*f**3 - 10080*C*D1*Dd*f**2*fd*r**2 - 20160*C*D1*Dd*f**2*fd*r*s + 14280*C*D1*Dd*f**2*fd*r - 10080*C*D1*Dd*f**2*fd*s**2 + 14280*C*D1*Dd*f**2*fd*s - 5040*C*D1*Dd*f**2*fd - 2160*C*D1*Ddd*b1*f**2*r**2 - 4320*C*D1*Ddd*b1*f**2*r*s + 3240*C*D1*Ddd*b1*f**2*r - 2160*C*D1*Ddd*b1*f**2*s**2 + 3240*C*D1*Ddd*b1*f**2*s - 1620*C*D1*Ddd*b1*f**2 - 1680*C*D1*Ddd*f**3*r**2 - 3360*C*D1*Ddd*f**3*r*s + 2520*C*D1*Ddd*f**3*r - 1680*C*D1*Ddd*f**3*s**2 + 2520*C*D1*Ddd*f**3*s - 1260*C*D1*Ddd*f**3 - 6480*C*Dd**2*b1*f**2*r**2 - 12960*C*Dd**2*b1*f**2*r*s + 9720*C*Dd**2*b1*f**2*r - 6480*C*Dd**2*b1*f**2*s**2 + 9720*C*Dd**2*b1*f**2*s - 3240*C*Dd**2*b1*f**2 - 5040*C*Dd**2*f**3*r**2 - 10080*C*Dd**2*f**3*r*s + 7560*C*Dd**2*f**3*r - 5040*C*Dd**2*f**3*s**2 + 7560*C*Dd**2*f**3*s - 2520*C*Dd**2*f**3 - 1476*D1**2*b1*f*fd*r**2 - 2952*D1**2*b1*f*fd*r*s + 1476*D1**2*b1*f*fd*r - 1476*D1**2*b1*f*fd*s**2 + 1476*D1**2*b1*f*fd*s - 738*D1**2*b1*f*fd + 990*D1**2*b1*f*fdd*r**2 + 1980*D1**2*b1*f*fdd*r*s - 990*D1**2*b1*f*fdd*r + 990*D1**2*b1*f*fdd*s**2 - 990*D1**2*b1*f*fdd*s + 495*D1**2*b1*f*fdd + 990*D1**2*b1*fd**2*r**2 + 1980*D1**2*b1*fd**2*r*s - 990*D1**2*b1*fd**2*r + 990*D1**2*b1*fd**2*s**2 - 990*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(12*C - 11)*(r + s - 1)**2 - 1770*D1**2*f**2*fd*r**2 - 3540*D1**2*f**2*fd*r*s + 2360*D1**2*f**2*fd*r - 1770*D1**2*f**2*fd*s**2 + 2360*D1**2*f**2*fd*s - 1180*D1**2*f**2*fd + 1155*D1**2*f**2*fdd*r**2 + 2310*D1**2*f**2*fdd*r*s - 1540*D1**2*f**2*fdd*r + 1155*D1**2*f**2*fdd*s**2 - 1540*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd + 2310*D1**2*f*fd**2*r**2 + 4620*D1**2*f*fd**2*r*s - 3080*D1**2*f*fd**2*r + 2310*D1**2*f*fd**2*s**2 - 3080*D1**2*f*fd**2*s + 770*D1**2*f*fd**2 - 2952*D1*Dd*b1*f**2*r**2 - 5904*D1*Dd*b1*f**2*r*s + 4428*D1*Dd*b1*f**2*r - 2952*D1*Dd*b1*f**2*s**2 + 4428*D1*Dd*b1*f**2*s - 2214*D1*Dd*b1*f**2 + 7920*D1*Dd*b1*f*fd*r**2 + 15840*D1*Dd*b1*f*fd*r*s - 9900*D1*Dd*b1*f*fd*r + 7920*D1*Dd*b1*f*fd*s**2 - 9900*D1*Dd*b1*f*fd*s + 2970*D1*Dd*b1*f*fd - 2360*D1*Dd*f**3*r**2 - 4720*D1*Dd*f**3*r*s + 3540*D1*Dd*f**3*r - 2360*D1*Dd*f**3*s**2 + 3540*D1*Dd*f**3*s - 1770*D1*Dd*f**3 + 9240*D1*Dd*f**2*fd*r**2 + 18480*D1*Dd*f**2*fd*r*s - 13090*D1*Dd*f**2*fd*r + 9240*D1*Dd*f**2*fd*s**2 - 13090*D1*Dd*f**2*fd*s + 4620*D1*Dd*f**2*fd + 1980*D1*Ddd*b1*f**2*r**2 + 3960*D1*Ddd*b1*f**2*r*s - 2970*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s**2 - 2970*D1*Ddd*b1*f**2*s + 1485*D1*Ddd*b1*f**2 + 1540*D1*Ddd*f**3*r**2 + 3080*D1*Ddd*f**3*r*s - 2310*D1*Ddd*f**3*r + 1540*D1*Ddd*f**3*s**2 - 2310*D1*Ddd*f**3*s + 1155*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(46*C - 41)*(r + s - 1) - D1*fd*(60*C - 55)*(2*r + 2*s - 1) - Dd*f*(60*C - 55)*(4*r + 4*s - 3)) + 5940*Dd**2*b1*f**2*r**2 + 11880*Dd**2*b1*f**2*r*s - 8910*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s**2 - 8910*Dd**2*b1*f**2*s + 2970*Dd**2*b1*f**2 + 4620*Dd**2*f**3*r**2 + 9240*Dd**2*f**3*r*s - 6930*Dd**2*f**3*r + 4620*Dd**2*f**3*s**2 - 6930*Dd**2*f**3*s + 2310*Dd**2*f**3)/(70*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct**7*k1*k2**3*(9*b1*(D1**2*(f*(fd*(86*C - 76) + fdd*(45 - 50*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(45 - 50*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(86*C - 76)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(45 - 50*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(45 - 50*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(45 - 50*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(122*C - 108)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (10*C - 9)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(63 - 70*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(86*C - 76)*(r + s - 1) - fd*(50*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(45 - 50*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(122*C - 108)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(70*C - 63)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(63 - 70*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(63 - 70*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k3**5) - D1**2*Pk1*Pkd3*ct**7*k2**5*(1008*C*D1**2*b1*f*fd*r**2 + 1008*C*D1**2*b1*f*fd*r*s - 504*C*D1**2*b1*f*fd*r + 1560*C*D1**2*f**2*fd*r**2 + 1560*C*D1**2*f**2*fd*r*s - 1560*C*D1**2*f**2*fd*r - 520*C*D1**2*f**2*fd*s + 520*C*D1**2*f**2*fd - 240*C*D1**2*f**2*fdd*r**2 - 240*C*D1**2*f**2*fdd*r*s + 240*C*D1**2*f**2*fdd*r + 80*C*D1**2*f**2*fdd*s - 80*C*D1**2*f**2*fdd - 480*C*D1**2*f*fd**2*r**2 - 480*C*D1**2*f*fd**2*r*s + 480*C*D1**2*f*fd**2*r + 160*C*D1**2*f*fd**2*s - 80*C*D1**2*f*fd**2 + 2016*C*D1*Dd*b1*f**2*r**2 + 2016*C*D1*Dd*b1*f**2*r*s - 2016*C*D1*Dd*b1*f**2*r - 504*C*D1*Dd*b1*f**2*s + 504*C*D1*Dd*b1*f**2 + 2080*C*D1*Dd*f**3*r**2 + 2080*C*D1*Dd*f**3*r*s - 2080*C*D1*Dd*f**3*r - 520*C*D1*Dd*f**3*s + 520*C*D1*Dd*f**3 - 1920*C*D1*Dd*f**2*fd*r**2 - 1920*C*D1*Dd*f**2*fd*r*s + 1920*C*D1*Dd*f**2*fd*r + 560*C*D1*Dd*f**2*fd*s - 400*C*D1*Dd*f**2*fd - 320*C*D1*Ddd*f**3*r**2 - 320*C*D1*Ddd*f**3*r*s + 320*C*D1*Ddd*f**3*r + 80*C*D1*Ddd*f**3*s - 80*C*D1*Ddd*f**3 - 960*C*Dd**2*f**3*r**2 - 960*C*Dd**2*f**3*r*s + 960*C*Dd**2*f**3*r + 240*C*Dd**2*f**3*s - 160*C*Dd**2*f**3 - 1908*D1**2*b1*f*fd*r**2 - 2808*D1**2*b1*f*fd*r*s + 1404*D1**2*b1*f*fd*r - 900*D1**2*b1*f*fd*s**2 + 900*D1**2*b1*f*fd*s - 450*D1**2*b1*f*fd + 450*D1**2*b1*f*fdd*r**2 + 900*D1**2*b1*f*fdd*r*s - 450*D1**2*b1*f*fdd*r + 450*D1**2*b1*f*fdd*s**2 - 450*D1**2*b1*f*fdd*s + 225*D1**2*b1*f*fdd + 450*D1**2*b1*fd**2*r**2 + 900*D1**2*b1*fd**2*r*s - 450*D1**2*b1*fd**2*r + 450*D1**2*b1*fd**2*s**2 - 450*D1**2*b1*fd**2*s + 225*D1**2*bdd1*f**2*(r + s - 1)**2 - 2610*D1**2*f**2*fd*r**2 - 3660*D1**2*f**2*fd*r*s + 2960*D1**2*f**2*fd*r - 1050*D1**2*f**2*fd*s**2 + 1920*D1**2*f**2*fd*s - 1220*D1**2*f**2*fd + 765*D1**2*f**2*fdd*r**2 + 1290*D1**2*f**2*fdd*r*s - 940*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 780*D1**2*f**2*fdd*s + 430*D1**2*f**2*fdd + 1530*D1**2*f*fd**2*r**2 + 2580*D1**2*f*fd**2*r*s - 1880*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1560*D1**2*f*fd**2*s + 430*D1**2*f*fd**2 - 3816*D1*Dd*b1*f**2*r**2 - 5616*D1*Dd*b1*f**2*r*s + 4716*D1*Dd*b1*f**2*r - 1800*D1*Dd*b1*f**2*s**2 + 3204*D1*Dd*b1*f**2*s - 1854*D1*Dd*b1*f**2 + 3600*D1*Dd*b1*f*fd*r**2 + 7200*D1*Dd*b1*f*fd*r*s - 4500*D1*Dd*b1*f*fd*r + 3600*D1*Dd*b1*f*fd*s**2 - 4500*D1*Dd*b1*f*fd*s + 1350*D1*Dd*b1*f*fd - 3480*D1*Dd*f**3*r**2 - 4880*D1*Dd*f**3*r*s + 4180*D1*Dd*f**3*r - 1400*D1*Dd*f**3*s**2 + 2620*D1*Dd*f**3*s - 1570*D1*Dd*f**3 + 6120*D1*Dd*f**2*fd*r**2 + 10320*D1*Dd*f**2*fd*r*s - 7870*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 6510*D1*Dd*f**2*fd*s + 2500*D1*Dd*f**2*fd + 900*D1*Ddd*b1*f**2*r**2 + 1800*D1*Ddd*b1*f**2*r*s - 1350*D1*Ddd*b1*f**2*r + 900*D1*Ddd*b1*f**2*s**2 - 1350*D1*Ddd*b1*f**2*s + 675*D1*Ddd*b1*f**2 + 1020*D1*Ddd*f**3*r**2 + 1720*D1*Ddd*f**3*r*s - 1370*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1130*D1*Ddd*f**3*s + 605*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(28*C*(r - 1) - 53*r - 25*s + 53) + 25*D1*fd*(2*r + 2*s - 1) + 25*Dd*f*(4*r + 4*s - 3)) + 2700*Dd**2*b1*f**2*r**2 + 5400*Dd**2*b1*f**2*r*s - 4050*Dd**2*b1*f**2*r + 2700*Dd**2*b1*f**2*s**2 - 4050*Dd**2*b1*f**2*s + 1350*Dd**2*b1*f**2 + 3060*Dd**2*f**3*r**2 + 5160*Dd**2*f**3*r*s - 4110*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3390*Dd**2*f**3*s + 1210*Dd**2*f**3)/(630*d**2*k1*k3**5) + 2*D1**2*Pk1*Pkd3*ct**7*k2**3*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 14*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 7*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 7*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(63*d**2*k1*k3**3) - D1**2*Pk1*Pkd3*ct**6*f*k2**6*(-33*D1**2*b1*f*fd*r**2 - 33*D1**2*b1*f*fd*r*s + 22*D1**2*b1*f*fd*r + 165*D1**2*b1*f*fdd*r**2 + 165*D1**2*b1*f*fdd*r*s - 110*D1**2*b1*f*fdd*r + 330*D1**2*b1*fd**2*r**2 + 330*D1**2*b1*fd**2*r*s - 220*D1**2*b1*fd**2*r + 55*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 140*D1**2*f**2*fd*r**2 + 140*D1**2*f**2*fd*r*s - 140*D1**2*f**2*fd*r - 35*D1**2*f**2*fd*s + 35*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r**2 + 84*D1**2*f**2*fdd*r*s - 84*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd + 252*D1**2*f*fd**2*r**2 + 252*D1**2*f*fd**2*r*s - 252*D1**2*f*fd**2*r - 63*D1**2*f*fd**2*s + 42*D1**2*f*fd**2 - 44*D1*Dd*b1*f**2*r**2 - 44*D1*Dd*b1*f**2*r*s + 44*D1*Dd*b1*f**2*r + 11*D1*Dd*b1*f**2*s - 11*D1*Dd*b1*f**2 + 1320*D1*Dd*b1*f*fd*r**2 + 1320*D1*Dd*b1*f*fd*r*s - 1100*D1*Dd*b1*f*fd*r - 165*D1*Dd*b1*f*fd*s + 110*D1*Dd*b1*f*fd + 140*D1*Dd*f**3*r**2 + 140*D1*Dd*f**3*r*s - 140*D1*Dd*f**3*r - 35*D1*Dd*f**3*s + 35*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r**2 + 672*D1*Dd*f**2*fd*r*s - 672*D1*Dd*f**2*fd*r - 168*D1*Dd*f**2*fd*s + 126*D1*Dd*f**2*fd + 220*D1*Ddd*b1*f**2*r**2 + 220*D1*Ddd*b1*f**2*r*s - 220*D1*Ddd*b1*f**2*r - 55*D1*Ddd*b1*f**2*s + 55*D1*Ddd*b1*f**2 + 84*D1*Ddd*f**3*r**2 + 84*D1*Ddd*f**3*r*s - 84*D1*Ddd*f**3*r - 21*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 - 11*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) - 5*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 660*Dd**2*b1*f**2*r**2 + 660*Dd**2*b1*f**2*r*s - 660*Dd**2*b1*f**2*r - 165*Dd**2*b1*f**2*s + 110*Dd**2*b1*f**2 + 252*Dd**2*f**3*r**2 + 252*Dd**2*f**3*r*s - 252*Dd**2*f**3*r - 63*Dd**2*f**3*s + 42*Dd**2*f**3)/(693*d**2*k1**2*k3**5) + D1**2*Pk1*Pkd3*ct**6*k1**2*k2**4*(3132*C*D1**2*b1*f*fd*r**2 + 6264*C*D1**2*b1*f*fd*r*s - 3132*C*D1**2*b1*f*fd*r + 3132*C*D1**2*b1*f*fd*s**2 - 3132*C*D1**2*b1*f*fd*s + 1566*C*D1**2*b1*f*fd - 2700*C*D1**2*b1*f*fdd*r**2 - 5400*C*D1**2*b1*f*fdd*r*s + 2700*C*D1**2*b1*f*fdd*r - 2700*C*D1**2*b1*f*fdd*s**2 + 2700*C*D1**2*b1*f*fdd*s - 1350*C*D1**2*b1*f*fdd - 2700*C*D1**2*b1*fd**2*r**2 - 5400*C*D1**2*b1*fd**2*r*s + 2700*C*D1**2*b1*fd**2*r - 2700*C*D1**2*b1*fd**2*s**2 + 2700*C*D1**2*b1*fd**2*s + 3870*C*D1**2*f**2*fd*r**2 + 7740*C*D1**2*f**2*fd*r*s - 5160*C*D1**2*f**2*fd*r + 3870*C*D1**2*f**2*fd*s**2 - 5160*C*D1**2*f**2*fd*s + 2580*C*D1**2*f**2*fd - 3150*C*D1**2*f**2*fdd*r**2 - 6300*C*D1**2*f**2*fdd*r*s + 4200*C*D1**2*f**2*fdd*r - 3150*C*D1**2*f**2*fdd*s**2 + 4200*C*D1**2*f**2*fdd*s - 2100*C*D1**2*f**2*fdd - 6300*C*D1**2*f*fd**2*r**2 - 12600*C*D1**2*f*fd**2*r*s + 8400*C*D1**2*f*fd**2*r - 6300*C*D1**2*f*fd**2*s**2 + 8400*C*D1**2*f*fd**2*s - 2100*C*D1**2*f*fd**2 + 6264*C*D1*Dd*b1*f**2*r**2 + 12528*C*D1*Dd*b1*f**2*r*s - 9396*C*D1*Dd*b1*f**2*r + 6264*C*D1*Dd*b1*f**2*s**2 - 9396*C*D1*Dd*b1*f**2*s + 4698*C*D1*Dd*b1*f**2 - 21600*C*D1*Dd*b1*f*fd*r**2 - 43200*C*D1*Dd*b1*f*fd*r*s + 27000*C*D1*Dd*b1*f*fd*r - 21600*C*D1*Dd*b1*f*fd*s**2 + 27000*C*D1*Dd*b1*f*fd*s - 8100*C*D1*Dd*b1*f*fd + 5160*C*D1*Dd*f**3*r**2 + 10320*C*D1*Dd*f**3*r*s - 7740*C*D1*Dd*f**3*r + 5160*C*D1*Dd*f**3*s**2 - 7740*C*D1*Dd*f**3*s + 3870*C*D1*Dd*f**3 - 25200*C*D1*Dd*f**2*fd*r**2 - 50400*C*D1*Dd*f**2*fd*r*s + 35700*C*D1*Dd*f**2*fd*r - 25200*C*D1*Dd*f**2*fd*s**2 + 35700*C*D1*Dd*f**2*fd*s - 12600*C*D1*Dd*f**2*fd - 5400*C*D1*Ddd*b1*f**2*r**2 - 10800*C*D1*Ddd*b1*f**2*r*s + 8100*C*D1*Ddd*b1*f**2*r - 5400*C*D1*Ddd*b1*f**2*s**2 + 8100*C*D1*Ddd*b1*f**2*s - 4050*C*D1*Ddd*b1*f**2 - 4200*C*D1*Ddd*f**3*r**2 - 8400*C*D1*Ddd*f**3*r*s + 6300*C*D1*Ddd*f**3*r - 4200*C*D1*Ddd*f**3*s**2 + 6300*C*D1*Ddd*f**3*s - 3150*C*D1*Ddd*f**3 - 16200*C*Dd**2*b1*f**2*r**2 - 32400*C*Dd**2*b1*f**2*r*s + 24300*C*Dd**2*b1*f**2*r - 16200*C*Dd**2*b1*f**2*s**2 + 24300*C*Dd**2*b1*f**2*s - 8100*C*Dd**2*b1*f**2 - 12600*C*Dd**2*f**3*r**2 - 25200*C*Dd**2*f**3*r*s + 18900*C*Dd**2*f**3*r - 12600*C*Dd**2*f**3*s**2 + 18900*C*Dd**2*f**3*s - 6300*C*Dd**2*f**3 - 2484*D1**2*b1*f*fd*r**2 - 4968*D1**2*b1*f*fd*r*s + 2484*D1**2*b1*f*fd*r - 2484*D1**2*b1*f*fd*s**2 + 2484*D1**2*b1*f*fd*s - 1242*D1**2*b1*f*fd + 2250*D1**2*b1*f*fdd*r**2 + 4500*D1**2*b1*f*fdd*r*s - 2250*D1**2*b1*f*fdd*r + 2250*D1**2*b1*f*fdd*s**2 - 2250*D1**2*b1*f*fdd*s + 1125*D1**2*b1*f*fdd + 2250*D1**2*b1*fd**2*r**2 + 4500*D1**2*b1*fd**2*r*s - 2250*D1**2*b1*fd**2*r + 2250*D1**2*b1*fd**2*s**2 - 2250*D1**2*b1*fd**2*s - 225*D1**2*bdd1*f**2*(6*C - 5)*(r + s - 1)**2 - 3090*D1**2*f**2*fd*r**2 - 6180*D1**2*f**2*fd*r*s + 4120*D1**2*f**2*fd*r - 3090*D1**2*f**2*fd*s**2 + 4120*D1**2*f**2*fd*s - 2060*D1**2*f**2*fd + 2625*D1**2*f**2*fdd*r**2 + 5250*D1**2*f**2*fdd*r*s - 3500*D1**2*f**2*fdd*r + 2625*D1**2*f**2*fdd*s**2 - 3500*D1**2*f**2*fdd*s + 1750*D1**2*f**2*fdd + 5250*D1**2*f*fd**2*r**2 + 10500*D1**2*f*fd**2*r*s - 7000*D1**2*f*fd**2*r + 5250*D1**2*f*fd**2*s**2 - 7000*D1**2*f*fd**2*s + 1750*D1**2*f*fd**2 - 4968*D1*Dd*b1*f**2*r**2 - 9936*D1*Dd*b1*f**2*r*s + 7452*D1*Dd*b1*f**2*r - 4968*D1*Dd*b1*f**2*s**2 + 7452*D1*Dd*b1*f**2*s - 3726*D1*Dd*b1*f**2 + 18000*D1*Dd*b1*f*fd*r**2 + 36000*D1*Dd*b1*f*fd*r*s - 22500*D1*Dd*b1*f*fd*r + 18000*D1*Dd*b1*f*fd*s**2 - 22500*D1*Dd*b1*f*fd*s + 6750*D1*Dd*b1*f*fd - 4120*D1*Dd*f**3*r**2 - 8240*D1*Dd*f**3*r*s + 6180*D1*Dd*f**3*r - 4120*D1*Dd*f**3*s**2 + 6180*D1*Dd*f**3*s - 3090*D1*Dd*f**3 + 21000*D1*Dd*f**2*fd*r**2 + 42000*D1*Dd*f**2*fd*r*s - 29750*D1*Dd*f**2*fd*r + 21000*D1*Dd*f**2*fd*s**2 - 29750*D1*Dd*f**2*fd*s + 10500*D1*Dd*f**2*fd + 4500*D1*Ddd*b1*f**2*r**2 + 9000*D1*Ddd*b1*f**2*r*s - 6750*D1*Ddd*b1*f**2*r + 4500*D1*Ddd*b1*f**2*s**2 - 6750*D1*Ddd*b1*f**2*s + 3375*D1*Ddd*b1*f**2 + 3500*D1*Ddd*f**3*r**2 + 7000*D1*Ddd*f**3*r*s - 5250*D1*Ddd*f**3*r + 3500*D1*Ddd*f**3*s**2 - 5250*D1*Ddd*f**3*s + 2625*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(87*C - 69)*(r + s - 1) - D1*fd*(150*C - 125)*(2*r + 2*s - 1) - Dd*f*(150*C - 125)*(4*r + 4*s - 3)) + 13500*Dd**2*b1*f**2*r**2 + 27000*Dd**2*b1*f**2*r*s - 20250*Dd**2*b1*f**2*r + 13500*Dd**2*b1*f**2*s**2 - 20250*Dd**2*b1*f**2*s + 6750*Dd**2*b1*f**2 + 10500*Dd**2*f**3*r**2 + 21000*Dd**2*f**3*r*s - 15750*Dd**2*f**3*r + 10500*Dd**2*f**3*s**2 - 15750*Dd**2*f**3*s + 5250*Dd**2*f**3)/(70*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct**6*k1**2*k2**2*(9*b1*(D1**2*(f*(fd*(144*C - 111) + fdd*(80 - 100*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(80 - 100*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(144*C - 111)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(80 - 100*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(80 - 100*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(80 - 100*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(208*C - 161)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 16)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(112 - 140*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(144*C - 111)*(r + s - 1) - fd*(100*C - 80)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(80 - 100*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(208*C - 161)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(140*C - 112)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(112 - 140*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(112 - 140*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**6*k2**6*st**2*(3*C - 3)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 20*D1**2*f**2*fdd*s - 10*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 40*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 170*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 170*D1*Dd*f**2*fd*s - 60*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 30*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 30*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 90*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 90*Dd**2*f**3*s - 30*Dd**2*f**3)/(7*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**6*k2**6*(-2970*C*D1**2*f**2*fd*r**2 - 5940*C*D1**2*f**2*fd*r*s + 3960*C*D1**2*f**2*fd*r - 2970*C*D1**2*f**2*fd*s**2 + 3960*C*D1**2*f**2*fd*s - 1980*C*D1**2*f**2*fd - 3960*C*D1*Dd*f**3*r**2 - 7920*C*D1*Dd*f**3*r*s + 5940*C*D1*Dd*f**3*r - 3960*C*D1*Dd*f**3*s**2 + 5940*C*D1*Dd*f**3*s - 2970*C*D1*Dd*f**3 - 495*D1**2*K*bdd1*f**2*r**2 - 990*D1**2*K*bdd1*f**2*r*s + 990*D1**2*K*bdd1*f**2*r - 495*D1**2*K*bdd1*f**2*s**2 + 990*D1**2*K*bdd1*f**2*s - 495*D1**2*K*bdd1*f**2 + 198*D1**2*bd1**2*f*(-7*K + 5*f + 7)*(r + s - 1)**2 - 1540*D1**2*bdd1*f**3*r**2 - 3080*D1**2*bdd1*f**3*r*s + 3080*D1**2*bdd1*f**3*r - 1540*D1**2*bdd1*f**3*s**2 + 3080*D1**2*bdd1*f**3*s - 1540*D1**2*bdd1*f**3 + 495*D1**2*bdd1*f**2*r**2 + 990*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*r + 495*D1**2*bdd1*f**2*s**2 - 990*D1**2*bdd1*f**2*s + 495*D1**2*bdd1*f**2 + 1386*D1**2*bdd1*f*g2*r**2 + 2772*D1**2*bdd1*f*g2*r*s - 2772*D1**2*bdd1*f*g2*r + 1386*D1**2*bdd1*f*g2*s**2 - 2772*D1**2*bdd1*f*g2*s + 1386*D1**2*bdd1*f*g2 + 9520*D1**2*f**3*fd*r**2 + 19040*D1**2*f**3*fd*r*s - 14280*D1**2*f**3*fd*r + 9520*D1**2*f**3*fd*s**2 - 14280*D1**2*f**3*fd*s + 7140*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 + 2970*D1**2*f**2*fd*r**2 + 5940*D1**2*f**2*fd*r*s - 3960*D1**2*f**2*fd*r + 2970*D1**2*f**2*fd*s**2 - 3960*D1**2*f**2*fd*s + 1980*D1**2*f**2*fd - 1980*D1**2*f**2*gd2*r**2 - 3960*D1**2*f**2*gd2*r*s + 3960*D1**2*f**2*gd2*r - 1980*D1**2*f**2*gd2*s**2 + 3960*D1**2*f**2*gd2*s - 1980*D1**2*f**2*gd2 + 990*D1**2*f**2*gdd2*r**2 + 1980*D1**2*f**2*gdd2*r*s - 1980*D1**2*f**2*gdd2*r + 990*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 990*D1**2*f**2*gdd2 - 3960*D1**2*f*fd*g2*r**2 - 7920*D1**2*f*fd*g2*r*s + 3960*D1**2*f*fd*g2*r - 3960*D1**2*f*fd*g2*s**2 + 3960*D1**2*f*fd*g2*s - 1980*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r**2 + 7920*D1**2*f*fd*gd2*r*s - 5940*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 5940*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r**2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r**2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 9520*D1*Dd*f**4*r**2 + 19040*D1*Dd*f**4*r*s - 14280*D1*Dd*f**4*r + 9520*D1*Dd*f**4*s**2 - 14280*D1*Dd*f**4*s + 7140*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd + 3960*D1*Dd*f**3*r**2 + 7920*D1*Dd*f**3*r*s - 5940*D1*Dd*f**3*r + 3960*D1*Dd*f**3*s**2 - 5940*D1*Dd*f**3*s + 2970*D1*Dd*f**3 - 7920*D1*Dd*f**2*g2*r**2 - 15840*D1*Dd*f**2*g2*r*s + 11880*D1*Dd*f**2*g2*r - 7920*D1*Dd*f**2*g2*s**2 + 11880*D1*Dd*f**2*g2*s - 5940*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r**2 + 15840*D1*Dd*f**2*gd2*r*s - 13860*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 13860*D1*Dd*f**2*gd2*s + 5940*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r**2 + 31680*D1*Dd*f*fd*g2*r*s - 19800*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 19800*D1*Dd*f*fd*g2*s + 5940*D1*Dd*f*fd*g2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 3960*D1*Ddd*f**2*g2*r**2 + 7920*D1*Ddd*f**2*g2*r*s - 5940*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 5940*D1*Ddd*f**2*g2*s + 2970*D1*Ddd*f**2*g2 + 22*D1*bd1*(D1*(95*f**3*(r + s - 1) + f**2*(-63*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) + (45*K + 18)*(r + s - 1)) - 9*f*(5*fd*(K - 1)*(2*r + 2*s - 1) + (14*g2 - 14*gd2)*(r + s - 1)) + 126*fd*g2*(r + s)) - Dd*f*(140*f**2 + 45*f*(K - 1) - 126*g2)*(4*r + 4*s - 3))*(r + s - 1) - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 11880*Dd**2*f**2*g2*r**2 + 23760*Dd**2*f**2*g2*r*s - 17820*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 17820*Dd**2*f**2*g2*s + 5940*Dd**2*f**2*g2 - 99*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(K - 1)*(r + s) - 7*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (7*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-7*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-7*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(252*C*D1**2*f*fd*r**2 + 504*C*D1**2*f*fd*r*s - 252*C*D1**2*f*fd*r + 252*C*D1**2*f*fd*s**2 - 252*C*D1**2*f*fd*s + 126*C*D1**2*f*fd + 504*C*D1*Dd*f**2*r**2 + 1008*C*D1*Dd*f**2*r*s - 756*C*D1*Dd*f**2*r + 504*C*D1*Dd*f**2*s**2 - 756*C*D1*Dd*f**2*s + 378*C*D1*Dd*f**2 - 180*D1**2*K*f*fd*r**2 - 360*D1**2*K*f*fd*r*s + 180*D1**2*K*f*fd*r - 180*D1**2*K*f*fd*s**2 + 180*D1**2*K*f*fd*s - 90*D1**2*K*f*fd + 90*D1**2*K*f*fdd*r**2 + 180*D1**2*K*f*fdd*r*s - 90*D1**2*K*f*fdd*r + 90*D1**2*K*f*fdd*s**2 - 90*D1**2*K*f*fdd*s + 45*D1**2*K*f*fdd + 90*D1**2*K*fd**2*r**2 + 180*D1**2*K*fd**2*r*s - 90*D1**2*K*fd**2*r + 90*D1**2*K*fd**2*s**2 - 90*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(-7*K + 5*f + 7)*(r + s - 1)**2 - 570*D1**2*f**2*fd*r**2 - 1140*D1**2*f**2*fd*r*s + 760*D1**2*f**2*fd*r - 570*D1**2*f**2*fd*s**2 + 760*D1**2*f**2*fd*s - 380*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 72*D1**2*f*fd*r**2 - 144*D1**2*f*fd*r*s + 72*D1**2*f*fd*r - 72*D1**2*f*fd*s**2 + 72*D1**2*f*fd*s - 36*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 45*D1**2*f*fdd + 252*D1**2*f*gd2*r**2 + 504*D1**2*f*gd2*r*s - 504*D1**2*f*gd2*r + 252*D1**2*f*gd2*s**2 - 504*D1**2*f*gd2*s + 252*D1**2*f*gd2 - 126*D1**2*f*gdd2*r**2 - 252*D1**2*f*gdd2*r*s + 252*D1**2*f*gdd2*r - 126*D1**2*f*gdd2*s**2 + 252*D1**2*f*gdd2*s - 126*D1**2*f*gdd2 - 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 252*D1**2*fd*g2*r**2 + 504*D1**2*fd*g2*r*s + 252*D1**2*fd*g2*s**2 - 252*D1**2*fd*gd2*r**2 - 504*D1**2*fd*gd2*r*s + 252*D1**2*fd*gd2*r - 252*D1**2*fd*gd2*s**2 + 252*D1**2*fd*gd2*s - 126*D1**2*fdd*g2*r**2 - 252*D1**2*fdd*g2*r*s - 126*D1**2*fdd*g2*s**2 - 360*D1*Dd*K*f**2*r**2 - 720*D1*Dd*K*f**2*r*s + 540*D1*Dd*K*f**2*r - 360*D1*Dd*K*f**2*s**2 + 540*D1*Dd*K*f**2*s - 270*D1*Dd*K*f**2 + 720*D1*Dd*K*f*fd*r**2 + 1440*D1*Dd*K*f*fd*r*s - 900*D1*Dd*K*f*fd*r + 720*D1*Dd*K*f*fd*s**2 - 900*D1*Dd*K*f*fd*s + 270*D1*Dd*K*f*fd - 760*D1*Dd*f**3*r**2 - 1520*D1*Dd*f**3*r*s + 1140*D1*Dd*f**3*r - 760*D1*Dd*f**3*s**2 + 1140*D1*Dd*f**3*s - 570*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 144*D1*Dd*f**2*r**2 - 288*D1*Dd*f**2*r*s + 216*D1*Dd*f**2*r - 144*D1*Dd*f**2*s**2 + 216*D1*Dd*f**2*s - 108*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 900*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 270*D1*Dd*f*fd + 1008*D1*Dd*f*g2*r**2 + 2016*D1*Dd*f*g2*r*s - 1512*D1*Dd*f*g2*r + 1008*D1*Dd*f*g2*s**2 - 1512*D1*Dd*f*g2*s + 756*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 2016*D1*Dd*f*gd2*r*s + 1764*D1*Dd*f*gd2*r - 1008*D1*Dd*f*gd2*s**2 + 1764*D1*Dd*f*gd2*s - 756*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 2016*D1*Dd*fd*g2*r*s + 756*D1*Dd*fd*g2*r - 1008*D1*Dd*fd*g2*s**2 + 756*D1*Dd*fd*g2*s + 180*D1*Ddd*K*f**2*r**2 + 360*D1*Ddd*K*f**2*r*s - 270*D1*Ddd*K*f**2*r + 180*D1*Ddd*K*f**2*s**2 - 270*D1*Ddd*K*f**2*s + 135*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 1008*D1*Ddd*f*g2*r*s + 756*D1*Ddd*f*g2*r - 504*D1*Ddd*f*g2*s**2 + 756*D1*Ddd*f*g2*s - 378*D1*Ddd*f*g2 + 36*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(K - 1)*(r + s - 1) + 7*fd*(K - 1)*(r + s)) - Dd*f*(-7*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 540*Dd**2*K*f**2*r**2 + 1080*Dd**2*K*f**2*r*s - 810*Dd**2*K*f**2*r + 540*Dd**2*K*f**2*s**2 - 810*Dd**2*K*f**2*s + 270*Dd**2*K*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 270*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 3024*Dd**2*f*g2*r*s + 2268*Dd**2*f*g2*r - 1512*Dd**2*f*g2*s**2 + 2268*Dd**2*f*g2*s - 756*Dd**2*f*g2))/(770*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**6*k2**4*st**2*(4*C - 4)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 10*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 5*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**6*k2**4*(630*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(-468*C*D1**2*f*fd*r**2 - 824*C*D1**2*f*fd*r*s + 212*C*D1**2*f*fd*r - 356*C*D1**2*f*fd*s**2 + 156*C*D1**2*f*fd*s - 78*C*D1**2*f*fd + 220*C*D1**2*f*fdd*r**2 + 552*C*D1**2*f*fdd*r*s - 176*C*D1**2*f*fdd*r + 332*C*D1**2*f*fdd*s**2 - 232*C*D1**2*f*fdd*s + 116*C*D1**2*f*fdd + 220*C*D1**2*fd**2*r**2 + 552*C*D1**2*fd**2*r*s - 176*C*D1**2*fd**2*r + 332*C*D1**2*fd**2*s**2 - 232*C*D1**2*fd**2*s - 100*C*D1**2*fd**2 - 936*C*D1*Dd*f**2*r**2 - 1648*C*D1*Dd*f**2*r*s + 1292*C*D1*Dd*f**2*r - 712*C*D1*Dd*f**2*s**2 + 1124*C*D1*Dd*f**2*s - 590*C*D1*Dd*f**2 + 1760*C*D1*Dd*f*fd*r**2 + 4416*C*D1*Dd*f*fd*r*s - 2248*C*D1*Dd*f*fd*r + 2656*C*D1*Dd*f*fd*s**2 - 2808*C*D1*Dd*f*fd*s + 640*C*D1*Dd*f*fd + 440*C*D1*Ddd*f**2*r**2 + 1104*C*D1*Ddd*f**2*r*s - 772*C*D1*Ddd*f**2*r + 664*C*D1*Ddd*f**2*s**2 - 940*C*D1*Ddd*f**2*s + 442*C*D1*Ddd*f**2 + 1320*C*Dd**2*f**2*r**2 + 3312*C*Dd**2*f**2*r*s - 2316*C*Dd**2*f**2*r + 1992*C*Dd**2*f**2*s**2 - 2820*C*Dd**2*f**2*s + 884*C*Dd**2*f**2 - 70*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 588*D1**2*f*fd*r**2 + 1104*D1**2*f*fd*r*s - 352*D1**2*f*fd*r + 516*D1**2*f*fd*s**2 - 316*D1**2*f*fd*s + 158*D1**2*f*fd - 350*D1**2*f*fdd*r**2 - 832*D1**2*f*fdd*r*s + 316*D1**2*f*fdd*r - 482*D1**2*f*fdd*s**2 + 382*D1**2*f*fdd*s - 191*D1**2*f*fdd - 350*D1**2*fd**2*r**2 - 832*D1**2*fd**2*r*s + 316*D1**2*fd**2*r - 482*D1**2*fd**2*s**2 + 382*D1**2*fd**2*s + 100*D1**2*fd**2 + 1176*D1*Dd*f**2*r**2 + 2208*D1*Dd*f**2*r*s - 1692*D1*Dd*f**2*r + 1032*D1*Dd*f**2*s**2 - 1584*D1*Dd*f**2*s + 810*D1*Dd*f**2 - 2800*D1*Dd*f*fd*r**2 - 6656*D1*Dd*f*fd*r*s + 3628*D1*Dd*f*fd*r - 3856*D1*Dd*f*fd*s**2 + 4288*D1*Dd*f*fd*s - 1080*D1*Dd*f*fd - 700*D1*Ddd*f**2*r**2 - 1664*D1*Ddd*f**2*r*s + 1182*D1*Ddd*f**2*r - 964*D1*Ddd*f**2*s**2 + 1380*D1*Ddd*f**2*s - 657*D1*Ddd*f**2 + 140*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2100*Dd**2*f**2*r**2 - 4992*Dd**2*f**2*r*s + 3546*Dd**2*f**2*r - 2892*Dd**2*f**2*s**2 + 4140*Dd**2*f**2*s - 1314*Dd**2*f**2) + f*(-1260*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(2*C*(55*r**2 + 2*r*(69*s - 80) + 83*s**2 - 188*s + 80) - 175*r**2 + r*(450 - 416*s) - 241*s**2 + 516*s - 225) - 5*D1**2*(f*(2*fd*(C*(915*r**2 + 6*r*(247*s - 184) + 567*s**2 - 872*s + 494) - 1029*r**2 - 6*r*(296*s - 213) - 747*s**2 + 1090*s - 592) + fdd*(-8*C*(111*r**2 + 3*r*(73*s - 49) + 108*s**2 - 145*s + 73) + 1137*r**2 + 6*r*(386*s - 255) + 1179*s**2 - 1558*s + 772)) + 2*fd**2*(-4*C*(222*r**2 + 6*r*(73*s - 49) + 216*s**2 - 290*s + 73) + 1137*r**2 + 6*r*(386*s - 255) + 1179*s**2 - 1558*s + 386)) - 18*D1*bd1*(D1*(f*(C*(117*r**2 + 206*r*s - 334*r + 89*s**2 - 306*s + 167) - 147*r**2 - 276*r*s + 394*r - 129*s**2 + 376*s - 197) + fd*(-4*C*(55*r**2 + 6*r*(23*s - 17) + 83*s**2 - 123*s + 47) + 350*r**2 + 832*r*s - 608*r + 482*s**2 - 707*s + 258)) + Dd*f*(-2*C*(220*r**2 + 552*r*s - 513*r + 332*s**2 - 611*s + 268) + 700*r**2 + 1664*r*s - 1491*r + 964*s**2 - 1722*s + 741)) - 5*D1*f*(2*Dd*(f*(C*(1220*r**2 + 2*r*(988*s - 799) + 756*s**2 - 1250*s + 683) - 1372*r**2 - 2368*r*s + 1870*r - 996*s**2 + 1588*s - 841) + fd*(-4*C*(888*r**2 + 24*r*(73*s - 52) + 864*s**2 - 1231*s + 437) + 4548*r**2 + 9264*r*s - 6513*r + 4716*s**2 - 6632*s + 2323)) + Ddd*f*(-8*C*(148*r**2 + 4*r*(73*s - 55) + 144*s**2 - 217*s + 109) + 1516*r**2 + 3088*r*s - 2302*r + 1572*s**2 - 2344*s + 1165)) - 10*Dd**2*f**2*(-4*C*(444*r**2 + 12*r*(73*s - 55) + 432*s**2 - 651*s + 218) + 2274*r**2 + r*(4632*s - 3453) + 2358*s**2 - 3516*s + 1165)))/(630*d**2*k3**5) + 2*D1**2*Pk1*Pkd3*ct**6*k2**2*(126*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 9*b1*(D1**2*(f*(-14*bdd1*s*(C - 1)*(2*r + 2*s - 1) + fd*(13*r*(2*s - 1) + 26*s**2 - s*(20*C + 6) + 13) + 10*fdd*(C*s - 2*r*s + r - 2*s**2 + s - 1)) + 10*fd**2*(C*(s - 1) - 2*r*s + r - 2*s**2 + s + 1)) - 14*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(13*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 10*fd*(2*s - 1)*(2*C - 8*r - 8*s + 3)) - 10*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 10*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) - f*(126*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) - 9*D1**2*bd1*(f*s*(20*C + 13*r + 13*s - 33) - 10*fd*(C*(s - 1) + 4*r*s - r + 4*s**2 - 5*s + 2)) + 5*D1**2*(f*(18*bdd1*s*(C + r + s - 2) + fd*(28*C - 47)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 2*fdd*(7*C - 14)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(28 - 14*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 90*D1*Dd*bd1*f*(C*(4*s - 2) + r*(8*s - 2) + 8*s**2 - 13*s + 4) + 5*D1*f*(Dd*(f*(28*C - 47)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(14*C - 28)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(28 - 14*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f**2*(70*C - 140)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k3**3) - D1**2*Pk1*Pkd3*ct**6*k2**4*(24*D1**2*b1*f*fd*r**2 + 24*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*r + 30*D1**2*b1*f*fdd*r**2 + 30*D1**2*b1*f*fdd*r*s - 15*D1**2*b1*f*fdd*r + 30*D1**2*b1*fd**2*r**2 + 30*D1**2*b1*fd**2*r*s - 15*D1**2*b1*fd**2*r + 15*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 60*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r - 20*D1**2*f**2*fd*s + 20*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r - 10*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 + 48*D1*Dd*b1*f**2*r**2 + 48*D1*Dd*b1*f**2*r*s - 48*D1*Dd*b1*f**2*r - 12*D1*Dd*b1*f**2*s + 12*D1*Dd*b1*f**2 + 240*D1*Dd*b1*f*fd*r**2 + 240*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r - 30*D1*Dd*b1*f*fd*s + 15*D1*Dd*b1*f*fd + 80*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 80*D1*Dd*f**3*r - 20*D1*Dd*f**3*s + 20*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 120*D1*Dd*f**2*fd*r - 35*D1*Dd*f**2*fd*s + 25*D1*Dd*f**2*fd + 60*D1*Ddd*b1*f**2*r**2 + 60*D1*Ddd*b1*f**2*r*s - 60*D1*Ddd*b1*f**2*r - 15*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r - 5*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) + 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 180*Dd**2*b1*f**2*r**2 + 180*Dd**2*b1*f**2*r*s - 180*Dd**2*b1*f**2*r - 45*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 60*Dd**2*f**3*r - 15*Dd**2*f**3*s + 10*Dd**2*f**3)/(105*d**2*k1**2*k3**3) + 3*D1**2*Pk1*Pkd3*ct**5*f*k2**7*st**2*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 88*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 88*D1**2*b1*f*fd*s + 44*D1**2*b1*f*fd - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 44*D1**2*b1*f*fdd*r - 33*D1**2*b1*f*fdd*s**2 + 44*D1**2*b1*f*fdd*s - 22*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 88*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 88*D1**2*b1*fd**2*s - 22*D1**2*b1*fd**2 - 11*D1**2*bdd1*f**2*(r + s - 1)**2 + 56*D1**2*f**2*fd*r**2 + 112*D1**2*f**2*fd*r*s - 84*D1**2*f**2*fd*r + 56*D1**2*f**2*fd*s**2 - 84*D1**2*f**2*fd*s + 42*D1**2*f**2*fd - 28*D1**2*f**2*fdd*r**2 - 56*D1**2*f**2*fdd*r*s + 42*D1**2*f**2*fdd*r - 28*D1**2*f**2*fdd*s**2 + 42*D1**2*f**2*fdd*s - 21*D1**2*f**2*fdd - 84*D1**2*f*fd**2*r**2 - 168*D1**2*f*fd**2*r*s + 126*D1**2*f*fd**2*r - 84*D1**2*f*fd**2*s**2 + 126*D1**2*f*fd**2*s - 42*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 176*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r + 88*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 374*D1*Dd*b1*f*fd*r - 264*D1*Dd*b1*f*fd*s**2 + 374*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 56*D1*Dd*f**3*r**2 + 112*D1*Dd*f**3*r*s - 84*D1*Dd*f**3*r + 56*D1*Dd*f**3*s**2 - 84*D1*Dd*f**3*s + 42*D1*Dd*f**3 - 224*D1*Dd*f**2*fd*r**2 - 448*D1*Dd*f**2*fd*r*s + 336*D1*Dd*f**2*fd*r - 224*D1*Dd*f**2*fd*s**2 + 336*D1*Dd*f**2*fd*s - 126*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 - 88*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r - 44*D1*Ddd*b1*f**2*s**2 + 66*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 - 56*D1*Ddd*f**3*r*s + 42*D1*Ddd*f**3*r - 28*D1*Ddd*f**3*s**2 + 42*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 + 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 132*Dd**2*b1*f**2*r**2 - 264*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r - 132*Dd**2*b1*f**2*s**2 + 198*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 84*Dd**2*f**3*r**2 - 168*Dd**2*f**3*r*s + 126*Dd**2*f**3*r - 84*Dd**2*f**3*s**2 + 126*Dd**2*f**3*s - 42*Dd**2*f**3)/(22*d**2*k1*k3**7) + D1**2*Pk1*Pkd3*ct**5*k1**3*k2**3*(3168*C*D1**2*b1*f*fd*r**2 + 6336*C*D1**2*b1*f*fd*r*s - 3168*C*D1**2*b1*f*fd*r + 3168*C*D1**2*b1*f*fd*s**2 - 3168*C*D1**2*b1*f*fd*s + 1584*C*D1**2*b1*f*fd - 3600*C*D1**2*b1*f*fdd*r**2 - 7200*C*D1**2*b1*f*fdd*r*s + 3600*C*D1**2*b1*f*fdd*r - 3600*C*D1**2*b1*f*fdd*s**2 + 3600*C*D1**2*b1*f*fdd*s - 1800*C*D1**2*b1*f*fdd - 3600*C*D1**2*b1*fd**2*r**2 - 7200*C*D1**2*b1*fd**2*r*s + 3600*C*D1**2*b1*fd**2*r - 3600*C*D1**2*b1*fd**2*s**2 + 3600*C*D1**2*b1*fd**2*s + 4080*C*D1**2*f**2*fd*r**2 + 8160*C*D1**2*f**2*fd*r*s - 5440*C*D1**2*f**2*fd*r + 4080*C*D1**2*f**2*fd*s**2 - 5440*C*D1**2*f**2*fd*s + 2720*C*D1**2*f**2*fd - 4200*C*D1**2*f**2*fdd*r**2 - 8400*C*D1**2*f**2*fdd*r*s + 5600*C*D1**2*f**2*fdd*r - 4200*C*D1**2*f**2*fdd*s**2 + 5600*C*D1**2*f**2*fdd*s - 2800*C*D1**2*f**2*fdd - 8400*C*D1**2*f*fd**2*r**2 - 16800*C*D1**2*f*fd**2*r*s + 11200*C*D1**2*f*fd**2*r - 8400*C*D1**2*f*fd**2*s**2 + 11200*C*D1**2*f*fd**2*s - 2800*C*D1**2*f*fd**2 + 6336*C*D1*Dd*b1*f**2*r**2 + 12672*C*D1*Dd*b1*f**2*r*s - 9504*C*D1*Dd*b1*f**2*r + 6336*C*D1*Dd*b1*f**2*s**2 - 9504*C*D1*Dd*b1*f**2*s + 4752*C*D1*Dd*b1*f**2 - 28800*C*D1*Dd*b1*f*fd*r**2 - 57600*C*D1*Dd*b1*f*fd*r*s + 36000*C*D1*Dd*b1*f*fd*r - 28800*C*D1*Dd*b1*f*fd*s**2 + 36000*C*D1*Dd*b1*f*fd*s - 10800*C*D1*Dd*b1*f*fd + 5440*C*D1*Dd*f**3*r**2 + 10880*C*D1*Dd*f**3*r*s - 8160*C*D1*Dd*f**3*r + 5440*C*D1*Dd*f**3*s**2 - 8160*C*D1*Dd*f**3*s + 4080*C*D1*Dd*f**3 - 33600*C*D1*Dd*f**2*fd*r**2 - 67200*C*D1*Dd*f**2*fd*r*s + 47600*C*D1*Dd*f**2*fd*r - 33600*C*D1*Dd*f**2*fd*s**2 + 47600*C*D1*Dd*f**2*fd*s - 16800*C*D1*Dd*f**2*fd - 7200*C*D1*Ddd*b1*f**2*r**2 - 14400*C*D1*Ddd*b1*f**2*r*s + 10800*C*D1*Ddd*b1*f**2*r - 7200*C*D1*Ddd*b1*f**2*s**2 + 10800*C*D1*Ddd*b1*f**2*s - 5400*C*D1*Ddd*b1*f**2 - 5600*C*D1*Ddd*f**3*r**2 - 11200*C*D1*Ddd*f**3*r*s + 8400*C*D1*Ddd*f**3*r - 5600*C*D1*Ddd*f**3*s**2 + 8400*C*D1*Ddd*f**3*s - 4200*C*D1*Ddd*f**3 - 21600*C*Dd**2*b1*f**2*r**2 - 43200*C*Dd**2*b1*f**2*r*s + 32400*C*Dd**2*b1*f**2*r - 21600*C*Dd**2*b1*f**2*s**2 + 32400*C*Dd**2*b1*f**2*s - 10800*C*Dd**2*b1*f**2 - 16800*C*Dd**2*f**3*r**2 - 33600*C*Dd**2*f**3*r*s + 25200*C*Dd**2*f**3*r - 16800*C*Dd**2*f**3*s**2 + 25200*C*Dd**2*f**3*s - 8400*C*Dd**2*f**3 - 2250*D1**2*b1*f*fd*r**2 - 4500*D1**2*b1*f*fd*r*s + 2250*D1**2*b1*f*fd*r - 2250*D1**2*b1*f*fd*s**2 + 2250*D1**2*b1*f*fd*s - 1125*D1**2*b1*f*fd + 2700*D1**2*b1*f*fdd*r**2 + 5400*D1**2*b1*f*fdd*r*s - 2700*D1**2*b1*f*fdd*r + 2700*D1**2*b1*f*fdd*s**2 - 2700*D1**2*b1*f*fdd*s + 1350*D1**2*b1*f*fdd + 2700*D1**2*b1*fd**2*r**2 + 5400*D1**2*b1*fd**2*r*s - 2700*D1**2*b1*fd**2*r + 2700*D1**2*b1*fd**2*s**2 - 2700*D1**2*b1*fd**2*s - 450*D1**2*bdd1*f**2*(4*C - 3)*(r + s - 1)**2 - 2925*D1**2*f**2*fd*r**2 - 5850*D1**2*f**2*fd*r*s + 3900*D1**2*f**2*fd*r - 2925*D1**2*f**2*fd*s**2 + 3900*D1**2*f**2*fd*s - 1950*D1**2*f**2*fd + 3150*D1**2*f**2*fdd*r**2 + 6300*D1**2*f**2*fdd*r*s - 4200*D1**2*f**2*fdd*r + 3150*D1**2*f**2*fdd*s**2 - 4200*D1**2*f**2*fdd*s + 2100*D1**2*f**2*fdd + 6300*D1**2*f*fd**2*r**2 + 12600*D1**2*f*fd**2*r*s - 8400*D1**2*f*fd**2*r + 6300*D1**2*f*fd**2*s**2 - 8400*D1**2*f*fd**2*s + 2100*D1**2*f*fd**2 - 4500*D1*Dd*b1*f**2*r**2 - 9000*D1*Dd*b1*f**2*r*s + 6750*D1*Dd*b1*f**2*r - 4500*D1*Dd*b1*f**2*s**2 + 6750*D1*Dd*b1*f**2*s - 3375*D1*Dd*b1*f**2 + 21600*D1*Dd*b1*f*fd*r**2 + 43200*D1*Dd*b1*f*fd*r*s - 27000*D1*Dd*b1*f*fd*r + 21600*D1*Dd*b1*f*fd*s**2 - 27000*D1*Dd*b1*f*fd*s + 8100*D1*Dd*b1*f*fd - 3900*D1*Dd*f**3*r**2 - 7800*D1*Dd*f**3*r*s + 5850*D1*Dd*f**3*r - 3900*D1*Dd*f**3*s**2 + 5850*D1*Dd*f**3*s - 2925*D1*Dd*f**3 + 25200*D1*Dd*f**2*fd*r**2 + 50400*D1*Dd*f**2*fd*r*s - 35700*D1*Dd*f**2*fd*r + 25200*D1*Dd*f**2*fd*s**2 - 35700*D1*Dd*f**2*fd*s + 12600*D1*Dd*f**2*fd + 5400*D1*Ddd*b1*f**2*r**2 + 10800*D1*Ddd*b1*f**2*r*s - 8100*D1*Ddd*b1*f**2*r + 5400*D1*Ddd*b1*f**2*s**2 - 8100*D1*Ddd*b1*f**2*s + 4050*D1*Ddd*b1*f**2 + 4200*D1*Ddd*f**3*r**2 + 8400*D1*Ddd*f**3*r*s - 6300*D1*Ddd*f**3*r + 4200*D1*Ddd*f**3*s**2 - 6300*D1*Ddd*f**3*s + 3150*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(D1*f*(176*C - 125)*(r + s - 1) - D1*fd*(400*C - 300)*(2*r + 2*s - 1) - Dd*f*(400*C - 300)*(4*r + 4*s - 3)) + 16200*Dd**2*b1*f**2*r**2 + 32400*Dd**2*b1*f**2*r*s - 24300*Dd**2*b1*f**2*r + 16200*Dd**2*b1*f**2*s**2 - 24300*Dd**2*b1*f**2*s + 8100*Dd**2*b1*f**2 + 12600*Dd**2*f**3*r**2 + 25200*Dd**2*f**3*r*s - 18900*Dd**2*f**3*r + 12600*Dd**2*f**3*s**2 - 18900*Dd**2*f**3*s + 6300*Dd**2*f**3)/(70*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct**5*k1**3*k2*(9*b1*(D1**2*(f*(fd*(116*C - 77) + fdd*(70 - 100*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(70 - 100*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(116*C - 77)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(70 - 100*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(70 - 100*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(70 - 100*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(172*C - 115)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 14)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(98 - 140*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(116*C - 77)*(r + s - 1) - fd*(100*C - 70)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(70 - 100*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(172*C - 115)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(140*C - 98)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(98 - 140*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(98 - 140*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**5*k1*k2**5*st**2*(4032*C*D1**2*b1*f*fd*r**2 + 8064*C*D1**2*b1*f*fd*r*s - 4032*C*D1**2*b1*f*fd*r + 4032*C*D1**2*b1*f*fd*s**2 - 4032*C*D1**2*b1*f*fd*s + 2016*C*D1**2*b1*f*fd - 2520*C*D1**2*b1*f*fdd*r**2 - 5040*C*D1**2*b1*f*fdd*r*s + 2520*C*D1**2*b1*f*fdd*r - 2520*C*D1**2*b1*f*fdd*s**2 + 2520*C*D1**2*b1*f*fdd*s - 1260*C*D1**2*b1*f*fdd - 2520*C*D1**2*b1*fd**2*r**2 - 5040*C*D1**2*b1*fd**2*r*s + 2520*C*D1**2*b1*fd**2*r - 2520*C*D1**2*b1*fd**2*s**2 + 2520*C*D1**2*b1*fd**2*s + 3552*C*D1**2*f**2*fd*r**2 + 7104*C*D1**2*f**2*fd*r*s - 4736*C*D1**2*f**2*fd*r + 3552*C*D1**2*f**2*fd*s**2 - 4736*C*D1**2*f**2*fd*s + 2368*C*D1**2*f**2*fd - 2100*C*D1**2*f**2*fdd*r**2 - 4200*C*D1**2*f**2*fdd*r*s + 2800*C*D1**2*f**2*fdd*r - 2100*C*D1**2*f**2*fdd*s**2 + 2800*C*D1**2*f**2*fdd*s - 1400*C*D1**2*f**2*fdd - 4200*C*D1**2*f*fd**2*r**2 - 8400*C*D1**2*f*fd**2*r*s + 5600*C*D1**2*f*fd**2*r - 4200*C*D1**2*f*fd**2*s**2 + 5600*C*D1**2*f*fd**2*s - 1400*C*D1**2*f*fd**2 + 8064*C*D1*Dd*b1*f**2*r**2 + 16128*C*D1*Dd*b1*f**2*r*s - 12096*C*D1*Dd*b1*f**2*r + 8064*C*D1*Dd*b1*f**2*s**2 - 12096*C*D1*Dd*b1*f**2*s + 6048*C*D1*Dd*b1*f**2 - 20160*C*D1*Dd*b1*f*fd*r**2 - 40320*C*D1*Dd*b1*f*fd*r*s + 25200*C*D1*Dd*b1*f*fd*r - 20160*C*D1*Dd*b1*f*fd*s**2 + 25200*C*D1*Dd*b1*f*fd*s - 7560*C*D1*Dd*b1*f*fd + 4736*C*D1*Dd*f**3*r**2 + 9472*C*D1*Dd*f**3*r*s - 7104*C*D1*Dd*f**3*r + 4736*C*D1*Dd*f**3*s**2 - 7104*C*D1*Dd*f**3*s + 3552*C*D1*Dd*f**3 - 16800*C*D1*Dd*f**2*fd*r**2 - 33600*C*D1*Dd*f**2*fd*r*s + 23800*C*D1*Dd*f**2*fd*r - 16800*C*D1*Dd*f**2*fd*s**2 + 23800*C*D1*Dd*f**2*fd*s - 8400*C*D1*Dd*f**2*fd - 5040*C*D1*Ddd*b1*f**2*r**2 - 10080*C*D1*Ddd*b1*f**2*r*s + 7560*C*D1*Ddd*b1*f**2*r - 5040*C*D1*Ddd*b1*f**2*s**2 + 7560*C*D1*Ddd*b1*f**2*s - 3780*C*D1*Ddd*b1*f**2 - 2800*C*D1*Ddd*f**3*r**2 - 5600*C*D1*Ddd*f**3*r*s + 4200*C*D1*Ddd*f**3*r - 2800*C*D1*Ddd*f**3*s**2 + 4200*C*D1*Ddd*f**3*s - 2100*C*D1*Ddd*f**3 - 15120*C*Dd**2*b1*f**2*r**2 - 30240*C*Dd**2*b1*f**2*r*s + 22680*C*Dd**2*b1*f**2*r - 15120*C*Dd**2*b1*f**2*s**2 + 22680*C*Dd**2*b1*f**2*s - 7560*C*Dd**2*b1*f**2 - 8400*C*Dd**2*f**3*r**2 - 16800*C*Dd**2*f**3*r*s + 12600*C*Dd**2*f**3*r - 8400*C*Dd**2*f**3*s**2 + 12600*C*Dd**2*f**3*s - 4200*C*Dd**2*f**3 - 3492*D1**2*b1*f*fd*r**2 - 6984*D1**2*b1*f*fd*r*s + 3492*D1**2*b1*f*fd*r - 3492*D1**2*b1*f*fd*s**2 + 3492*D1**2*b1*f*fd*s - 1746*D1**2*b1*f*fd + 2250*D1**2*b1*f*fdd*r**2 + 4500*D1**2*b1*f*fdd*r*s - 2250*D1**2*b1*f*fdd*r + 2250*D1**2*b1*f*fdd*s**2 - 2250*D1**2*b1*f*fdd*s + 1125*D1**2*b1*f*fdd + 2250*D1**2*b1*fd**2*r**2 + 4500*D1**2*b1*fd**2*r*s - 2250*D1**2*b1*fd**2*r + 2250*D1**2*b1*fd**2*s**2 - 2250*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(28*C - 25)*(r + s - 1)**2 - 3102*D1**2*f**2*fd*r**2 - 6204*D1**2*f**2*fd*r*s + 4136*D1**2*f**2*fd*r - 3102*D1**2*f**2*fd*s**2 + 4136*D1**2*f**2*fd*s - 2068*D1**2*f**2*fd + 1875*D1**2*f**2*fdd*r**2 + 3750*D1**2*f**2*fdd*r*s - 2500*D1**2*f**2*fdd*r + 1875*D1**2*f**2*fdd*s**2 - 2500*D1**2*f**2*fdd*s + 1250*D1**2*f**2*fdd + 3750*D1**2*f*fd**2*r**2 + 7500*D1**2*f*fd**2*r*s - 5000*D1**2*f*fd**2*r + 3750*D1**2*f*fd**2*s**2 - 5000*D1**2*f*fd**2*s + 1250*D1**2*f*fd**2 - 6984*D1*Dd*b1*f**2*r**2 - 13968*D1*Dd*b1*f**2*r*s + 10476*D1*Dd*b1*f**2*r - 6984*D1*Dd*b1*f**2*s**2 + 10476*D1*Dd*b1*f**2*s - 5238*D1*Dd*b1*f**2 + 18000*D1*Dd*b1*f*fd*r**2 + 36000*D1*Dd*b1*f*fd*r*s - 22500*D1*Dd*b1*f*fd*r + 18000*D1*Dd*b1*f*fd*s**2 - 22500*D1*Dd*b1*f*fd*s + 6750*D1*Dd*b1*f*fd - 4136*D1*Dd*f**3*r**2 - 8272*D1*Dd*f**3*r*s + 6204*D1*Dd*f**3*r - 4136*D1*Dd*f**3*s**2 + 6204*D1*Dd*f**3*s - 3102*D1*Dd*f**3 + 15000*D1*Dd*f**2*fd*r**2 + 30000*D1*Dd*f**2*fd*r*s - 21250*D1*Dd*f**2*fd*r + 15000*D1*Dd*f**2*fd*s**2 - 21250*D1*Dd*f**2*fd*s + 7500*D1*Dd*f**2*fd + 4500*D1*Ddd*b1*f**2*r**2 + 9000*D1*Ddd*b1*f**2*r*s - 6750*D1*Ddd*b1*f**2*r + 4500*D1*Ddd*b1*f**2*s**2 - 6750*D1*Ddd*b1*f**2*s + 3375*D1*Ddd*b1*f**2 + 2500*D1*Ddd*f**3*r**2 + 5000*D1*Ddd*f**3*r*s - 3750*D1*Ddd*f**3*r + 2500*D1*Ddd*f**3*s**2 - 3750*D1*Ddd*f**3*s + 1875*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(112*C - 97)*(r + s - 1) - D1*fd*(140*C - 125)*(2*r + 2*s - 1) - Dd*f*(140*C - 125)*(4*r + 4*s - 3)) + 13500*Dd**2*b1*f**2*r**2 + 27000*Dd**2*b1*f**2*r*s - 20250*Dd**2*b1*f**2*r + 13500*Dd**2*b1*f**2*s**2 - 20250*Dd**2*b1*f**2*s + 6750*Dd**2*b1*f**2 + 7500*Dd**2*f**3*r**2 + 15000*Dd**2*f**3*r*s - 11250*Dd**2*f**3*r + 7500*Dd**2*f**3*s**2 - 11250*Dd**2*f**3*s + 3750*Dd**2*f**3)/(70*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**5*k1*k2**5*(-11880*C*D1**2*f**2*fd*r**2 - 23760*C*D1**2*f**2*fd*r*s + 15840*C*D1**2*f**2*fd*r - 11880*C*D1**2*f**2*fd*s**2 + 15840*C*D1**2*f**2*fd*s - 7920*C*D1**2*f**2*fd - 15840*C*D1*Dd*f**3*r**2 - 31680*C*D1*Dd*f**3*r*s + 23760*C*D1*Dd*f**3*r - 15840*C*D1*Dd*f**3*s**2 + 23760*C*D1*Dd*f**3*s - 11880*C*D1*Dd*f**3 - 2970*D1**2*K*bdd1*f**2*r**2 - 5940*D1**2*K*bdd1*f**2*r*s + 5940*D1**2*K*bdd1*f**2*r - 2970*D1**2*K*bdd1*f**2*s**2 + 5940*D1**2*K*bdd1*f**2*s - 2970*D1**2*K*bdd1*f**2 + 198*D1**2*bd1**2*f*(-42*K + 25*f + 35)*(r + s - 1)**2 - 1925*D1**2*bdd1*f**3*r**2 - 3850*D1**2*bdd1*f**3*r*s + 3850*D1**2*bdd1*f**3*r - 1925*D1**2*bdd1*f**3*s**2 + 3850*D1**2*bdd1*f**3*s - 1925*D1**2*bdd1*f**3 + 2475*D1**2*bdd1*f**2*r**2 + 4950*D1**2*bdd1*f**2*r*s - 4950*D1**2*bdd1*f**2*r + 2475*D1**2*bdd1*f**2*s**2 - 4950*D1**2*bdd1*f**2*s + 2475*D1**2*bdd1*f**2 + 8316*D1**2*bdd1*f*g2*r**2 + 16632*D1**2*bdd1*f*g2*r*s - 16632*D1**2*bdd1*f*g2*r + 8316*D1**2*bdd1*f*g2*s**2 - 16632*D1**2*bdd1*f*g2*s + 8316*D1**2*bdd1*f*g2 + 14420*D1**2*f**3*fd*r**2 + 28840*D1**2*f**3*fd*r*s - 21630*D1**2*f**3*fd*r + 14420*D1**2*f**3*fd*s**2 - 21630*D1**2*f**3*fd*s + 10815*D1**2*f**3*fd - 12600*D1**2*f**3*fdd*r**2 - 25200*D1**2*f**3*fdd*r*s + 18900*D1**2*f**3*fdd*r - 12600*D1**2*f**3*fdd*s**2 + 18900*D1**2*f**3*fdd*s - 9450*D1**2*f**3*fdd - 37800*D1**2*f**2*fd**2*r**2 - 75600*D1**2*f**2*fd**2*r*s + 56700*D1**2*f**2*fd**2*r - 37800*D1**2*f**2*fd**2*s**2 + 56700*D1**2*f**2*fd**2*s - 18900*D1**2*f**2*fd**2 + 10395*D1**2*f**2*fd*r**2 + 20790*D1**2*f**2*fd*r*s - 13860*D1**2*f**2*fd*r + 10395*D1**2*f**2*fd*s**2 - 13860*D1**2*f**2*fd*s + 6930*D1**2*f**2*fd - 9108*D1**2*f**2*gd2*r**2 - 18216*D1**2*f**2*gd2*r*s + 18216*D1**2*f**2*gd2*r - 9108*D1**2*f**2*gd2*s**2 + 18216*D1**2*f**2*gd2*s - 9108*D1**2*f**2*gd2 + 5940*D1**2*f**2*gdd2*r**2 + 11880*D1**2*f**2*gdd2*r*s - 11880*D1**2*f**2*gdd2*r + 5940*D1**2*f**2*gdd2*s**2 - 11880*D1**2*f**2*gdd2*s + 5940*D1**2*f**2*gdd2 - 18216*D1**2*f*fd*g2*r**2 - 36432*D1**2*f*fd*g2*r*s + 18216*D1**2*f*fd*g2*r - 18216*D1**2*f*fd*g2*s**2 + 18216*D1**2*f*fd*g2*s - 9108*D1**2*f*fd*g2 + 23760*D1**2*f*fd*gd2*r**2 + 47520*D1**2*f*fd*gd2*r*s - 35640*D1**2*f*fd*gd2*r + 23760*D1**2*f*fd*gd2*s**2 - 35640*D1**2*f*fd*gd2*s + 11880*D1**2*f*fd*gd2 + 11880*D1**2*f*fdd*g2*r**2 + 23760*D1**2*f*fdd*g2*r*s - 11880*D1**2*f*fdd*g2*r + 11880*D1**2*f*fdd*g2*s**2 - 11880*D1**2*f*fdd*g2*s + 5940*D1**2*f*fdd*g2 + 11880*D1**2*fd**2*g2*r**2 + 23760*D1**2*fd**2*g2*r*s - 11880*D1**2*fd**2*g2*r + 11880*D1**2*fd**2*g2*s**2 - 11880*D1**2*fd**2*g2*s + 14420*D1*Dd*f**4*r**2 + 28840*D1*Dd*f**4*r*s - 21630*D1*Dd*f**4*r + 14420*D1*Dd*f**4*s**2 - 21630*D1*Dd*f**4*s + 10815*D1*Dd*f**4 - 100800*D1*Dd*f**3*fd*r**2 - 201600*D1*Dd*f**3*fd*r*s + 151200*D1*Dd*f**3*fd*r - 100800*D1*Dd*f**3*fd*s**2 + 151200*D1*Dd*f**3*fd*s - 56700*D1*Dd*f**3*fd + 13860*D1*Dd*f**3*r**2 + 27720*D1*Dd*f**3*r*s - 20790*D1*Dd*f**3*r + 13860*D1*Dd*f**3*s**2 - 20790*D1*Dd*f**3*s + 10395*D1*Dd*f**3 - 36432*D1*Dd*f**2*g2*r**2 - 72864*D1*Dd*f**2*g2*r*s + 54648*D1*Dd*f**2*g2*r - 36432*D1*Dd*f**2*g2*s**2 + 54648*D1*Dd*f**2*g2*s - 27324*D1*Dd*f**2*g2 + 47520*D1*Dd*f**2*gd2*r**2 + 95040*D1*Dd*f**2*gd2*r*s - 83160*D1*Dd*f**2*gd2*r + 47520*D1*Dd*f**2*gd2*s**2 - 83160*D1*Dd*f**2*gd2*s + 35640*D1*Dd*f**2*gd2 + 95040*D1*Dd*f*fd*g2*r**2 + 190080*D1*Dd*f*fd*g2*r*s - 118800*D1*Dd*f*fd*g2*r + 95040*D1*Dd*f*fd*g2*s**2 - 118800*D1*Dd*f*fd*g2*s + 35640*D1*Dd*f*fd*g2 - 12600*D1*Ddd*f**4*r**2 - 25200*D1*Ddd*f**4*r*s + 18900*D1*Ddd*f**4*r - 12600*D1*Ddd*f**4*s**2 + 18900*D1*Ddd*f**4*s - 9450*D1*Ddd*f**4 + 23760*D1*Ddd*f**2*g2*r**2 + 47520*D1*Ddd*f**2*g2*r*s - 35640*D1*Ddd*f**2*g2*r + 23760*D1*Ddd*f**2*g2*s**2 - 35640*D1*Ddd*f**2*g2*s + 17820*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(125*f**3*(r + s - 1) + f**2*(-504*C*(r + s - 1) - 350*fd*(3*r + 3*s - 2) + (414*K + 117)*(r + s - 1)) - 6*f*(15*fd*(6*K - 5)*(2*r + 2*s - 1) + (182*g2 - 252*gd2)*(r + s - 1)) + 1512*fd*g2*(r + s)) - 2*Dd*f*(175*f**2 + 45*f*(6*K - 5) - 756*g2)*(4*r + 4*s - 3))*(r + s - 1) - 37800*Dd**2*f**4*r**2 - 75600*Dd**2*f**4*r*s + 56700*Dd**2*f**4*r - 37800*Dd**2*f**4*s**2 + 56700*Dd**2*f**4*s - 18900*Dd**2*f**4 + 71280*Dd**2*f**2*g2*r**2 + 142560*Dd**2*f**2*g2*r*s - 106920*Dd**2*f**2*g2*r + 71280*Dd**2*f**2*g2*s**2 - 106920*Dd**2*f**2*g2*s + 35640*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(3*f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 14*fd*(13*K - 10)*(r + s) - 21*fdd*(6*K - 5)*(r + s))) + D1*(2*Dd*(54*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(75*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (91*K - 70)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 21*fd*(6*K - 5)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-42*K + 25*f + 35)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-42*K + 25*f + 35)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(1008*C*D1**2*f*fd*r**2 + 2016*C*D1**2*f*fd*r*s - 1008*C*D1**2*f*fd*r + 1008*C*D1**2*f*fd*s**2 - 1008*C*D1**2*f*fd*s + 504*C*D1**2*f*fd + 2016*C*D1*Dd*f**2*r**2 + 4032*C*D1*Dd*f**2*r*s - 3024*C*D1*Dd*f**2*r + 2016*C*D1*Dd*f**2*s**2 - 3024*C*D1*Dd*f**2*s + 1512*C*D1*Dd*f**2 - 828*D1**2*K*f*fd*r**2 - 1656*D1**2*K*f*fd*r*s + 828*D1**2*K*f*fd*r - 828*D1**2*K*f*fd*s**2 + 828*D1**2*K*f*fd*s - 414*D1**2*K*f*fd + 540*D1**2*K*f*fdd*r**2 + 1080*D1**2*K*f*fdd*r*s - 540*D1**2*K*f*fdd*r + 540*D1**2*K*f*fdd*s**2 - 540*D1**2*K*f*fdd*s + 270*D1**2*K*f*fdd + 540*D1**2*K*fd**2*r**2 + 1080*D1**2*K*fd**2*r*s - 540*D1**2*K*fd**2*r + 540*D1**2*K*fd**2*s**2 - 540*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(-42*K + 25*f + 35)*(r + s - 1)**2 - 375*D1**2*f**2*fd*r**2 - 750*D1**2*f**2*fd*r*s + 500*D1**2*f**2*fd*r - 375*D1**2*f**2*fd*s**2 + 500*D1**2*f**2*fd*s - 250*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 700*D1**2*f**2*fdd*s + 350*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1400*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 - 234*D1**2*f*fd*r**2 - 468*D1**2*f*fd*r*s + 234*D1**2*f*fd*r - 234*D1**2*f*fd*s**2 + 234*D1**2*f*fd*s - 117*D1**2*f*fd - 450*D1**2*f*fdd*r**2 - 900*D1**2*f*fdd*r*s + 450*D1**2*f*fdd*r - 450*D1**2*f*fdd*s**2 + 450*D1**2*f*fdd*s - 225*D1**2*f*fdd + 1092*D1**2*f*gd2*r**2 + 2184*D1**2*f*gd2*r*s - 2184*D1**2*f*gd2*r + 1092*D1**2*f*gd2*s**2 - 2184*D1**2*f*gd2*s + 1092*D1**2*f*gd2 - 756*D1**2*f*gdd2*r**2 - 1512*D1**2*f*gdd2*r*s + 1512*D1**2*f*gdd2*r - 756*D1**2*f*gdd2*s**2 + 1512*D1**2*f*gdd2*s - 756*D1**2*f*gdd2 - 450*D1**2*fd**2*r**2 - 900*D1**2*fd**2*r*s + 450*D1**2*fd**2*r - 450*D1**2*fd**2*s**2 + 450*D1**2*fd**2*s + 1092*D1**2*fd*g2*r**2 + 2184*D1**2*fd*g2*r*s + 1092*D1**2*fd*g2*s**2 - 1512*D1**2*fd*gd2*r**2 - 3024*D1**2*fd*gd2*r*s + 1512*D1**2*fd*gd2*r - 1512*D1**2*fd*gd2*s**2 + 1512*D1**2*fd*gd2*s - 756*D1**2*fdd*g2*r**2 - 1512*D1**2*fdd*g2*r*s - 756*D1**2*fdd*g2*s**2 - 1656*D1*Dd*K*f**2*r**2 - 3312*D1*Dd*K*f**2*r*s + 2484*D1*Dd*K*f**2*r - 1656*D1*Dd*K*f**2*s**2 + 2484*D1*Dd*K*f**2*s - 1242*D1*Dd*K*f**2 + 4320*D1*Dd*K*f*fd*r**2 + 8640*D1*Dd*K*f*fd*r*s - 5400*D1*Dd*K*f*fd*r + 4320*D1*Dd*K*f*fd*s**2 - 5400*D1*Dd*K*f*fd*s + 1620*D1*Dd*K*f*fd - 500*D1*Dd*f**3*r**2 - 1000*D1*Dd*f**3*r*s + 750*D1*Dd*f**3*r - 500*D1*Dd*f**3*s**2 + 750*D1*Dd*f**3*s - 375*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 5950*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 5950*D1*Dd*f**2*fd*s + 2100*D1*Dd*f**2*fd - 468*D1*Dd*f**2*r**2 - 936*D1*Dd*f**2*r*s + 702*D1*Dd*f**2*r - 468*D1*Dd*f**2*s**2 + 702*D1*Dd*f**2*s - 351*D1*Dd*f**2 - 3600*D1*Dd*f*fd*r**2 - 7200*D1*Dd*f*fd*r*s + 4500*D1*Dd*f*fd*r - 3600*D1*Dd*f*fd*s**2 + 4500*D1*Dd*f*fd*s - 1350*D1*Dd*f*fd + 4368*D1*Dd*f*g2*r**2 + 8736*D1*Dd*f*g2*r*s - 6552*D1*Dd*f*g2*r + 4368*D1*Dd*f*g2*s**2 - 6552*D1*Dd*f*g2*s + 3276*D1*Dd*f*g2 - 6048*D1*Dd*f*gd2*r**2 - 12096*D1*Dd*f*gd2*r*s + 10584*D1*Dd*f*gd2*r - 6048*D1*Dd*f*gd2*s**2 + 10584*D1*Dd*f*gd2*s - 4536*D1*Dd*f*gd2 - 6048*D1*Dd*fd*g2*r**2 - 12096*D1*Dd*fd*g2*r*s + 4536*D1*Dd*fd*g2*r - 6048*D1*Dd*fd*g2*s**2 + 4536*D1*Dd*fd*g2*s + 1080*D1*Ddd*K*f**2*r**2 + 2160*D1*Ddd*K*f**2*r*s - 1620*D1*Ddd*K*f**2*r + 1080*D1*Ddd*K*f**2*s**2 - 1620*D1*Ddd*K*f**2*s + 810*D1*Ddd*K*f**2 + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 1050*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 525*D1*Ddd*f**3 - 900*D1*Ddd*f**2*r**2 - 1800*D1*Ddd*f**2*r*s + 1350*D1*Ddd*f**2*r - 900*D1*Ddd*f**2*s**2 + 1350*D1*Ddd*f**2*s - 675*D1*Ddd*f**2 - 3024*D1*Ddd*f*g2*r**2 - 6048*D1*Ddd*f*g2*r*s + 4536*D1*Ddd*f*g2*r - 3024*D1*Ddd*f*g2*s**2 + 4536*D1*Ddd*f*g2*s - 2268*D1*Ddd*f*g2 + 12*D1*bd1*(D1*(54*f**2*(r + s - 1) - 75*f*fd*(2*r + 2*s - 1) - 7*f*(13*K - 10)*(r + s - 1) + 21*fd*(6*K - 5)*(r + s)) - 3*Dd*f*(-42*K + 25*f + 35)*(4*r + 4*s - 3))*(r + s - 1) + 3240*Dd**2*K*f**2*r**2 + 6480*Dd**2*K*f**2*r*s - 4860*Dd**2*K*f**2*r + 3240*Dd**2*K*f**2*s**2 - 4860*Dd**2*K*f**2*s + 1620*Dd**2*K*f**2 + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 3150*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 1050*Dd**2*f**3 - 2700*Dd**2*f**2*r**2 - 5400*Dd**2*f**2*r*s + 4050*Dd**2*f**2*r - 2700*Dd**2*f**2*s**2 + 4050*Dd**2*f**2*s - 1350*Dd**2*f**2 - 9072*Dd**2*f*g2*r**2 - 18144*Dd**2*f*g2*r*s + 13608*Dd**2*f*g2*r - 9072*Dd**2*f*g2*s**2 + 13608*Dd**2*f*g2*s - 4536*Dd**2*f*g2))/(770*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct**5*k1*k2**3*st**2*(3*b1*(D1**2*(f*(fd*(212*C - 182) + fdd*(105 - 120*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(105 - 120*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(212*C - 182)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(105 - 120*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(105 - 120*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(105 - 120*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(364*C - 314)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (40*C - 35)*(9*bdd1*s*(r + s - 1) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(175 - 200*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(212*C - 182)*(r + s - 1) - fd*(120*C - 105)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(105 - 120*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(364*C - 314)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(200*C - 175)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(175 - 200*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(175 - 200*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**5*k1*k2**3*(105*b1**2*(D1**2*(fd*(28*C - 22) + fdd*(21 - 24*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(14*C - 11)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(21 - 24*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(21 - 24*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(144*C - 126)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-105*D1**2*bdd1*f*(8*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 3*D1**2*(f*(4*fd*(C*(216*r**2 + 600*r*s - 170*r + 384*s**2 - 254*s + 127) - 199*r**2 - 564*r*s + 177*r - 365*s**2 + 260*s - 130) + fdd*(-40*C*(22*r**2 + 58*r*s - 19*r + 36*s**2 - 26*s + 13) + 860*r**2 + 2304*r*s - 802*r + 1444*s**2 - 1094*s + 547)) - 2*fd**2*(20*C*(22*r**2 + 58*r*s - 19*r + 36*s**2 - 26*s - 10) - 430*r**2 - 1152*r*s + 401*r - 722*s**2 + 547*s + 175)) + 70*D1*bd1*(D1*(f*(14*C - 11)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(21 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(21 - 24*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 6*D1*f*(Dd*(f*(24*C*(36*r**2 + 100*r*s - 68*r + 64*s**2 - 89*s + 41) - 796*r**2 - 2256*r*s + 1526*r - 1460*s**2 + 2024*s - 929) + fd*(-20*C*(176*r**2 + 464*r*s - 236*r + 288*s**2 - 306*s + 71) + 3440*r**2 + 9216*r*s - 4768*r + 5776*s**2 - 6228*s + 1495)) + Ddd*f*(-20*C*(44*r**2 + 116*r*s - 80*r + 72*s**2 - 101*s + 47) + 860*r**2 + 2304*r*s - 1582*r + 1444*s**2 - 2020*s + 937)) + 12*Dd**2*f**2*(10*C*(132*r**2 + 348*r*s - 240*r + 216*s**2 - 303*s + 94) - 1290*r**2 - 3456*r*s + 2373*r - 2166*s**2 + 3030*s - 937)) + f*(-630*D1**2*bd1**2*(8*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(40*C*(11*r**2 + r*(29*s - 32) + 18*s**2 - 39*s + 16) - 430*r**2 - 2*r*(576*s - 605) - 722*s**2 + 1502*s - 605) - 5*D1**2*(f*(4*fd*(C*(969*r**2 + 6*r*(337*s - 220) + 1053*s**2 - 1376*s + 674) - 840*r**2 - 5*r*(363*s - 233) - 975*s**2 + 1255*s - 605) + fdd*(-8*C*(384*r**2 + 843*r*s - 537*r + 459*s**2 - 587*s + 281) + 2841*r**2 + 6438*r*s - 4040*r + 3597*s**2 - 4544*s + 2146)) + 2*fd**2*(-4*C*(768*r**2 + 6*r*(281*s - 179) + 918*s**2 - 1174*s + 281) + 2841*r**2 + 6438*r*s - 4040*r + 3597*s**2 - 4544*s + 1073)) - 18*D1*bd1*(D1*(f*(C*(216*r**2 + r*(600*s - 692) + 384*s**2 - 860*s + 346) - 199*r**2 + r*(608 - 564*s) - 365*s**2 + 774*s - 304) + fd*(-20*C*(44*r**2 + r*(116*s - 83) + 72*s**2 - 104*s + 39) + 860*r**2 + 9*r*(256*s - 179) + 1444*s**2 - 2049*s + 751)) + Dd*f*(-20*C*(88*r**2 + 8*r*(29*s - 26) + 144*s**2 - 257*s + 110) + 1720*r**2 + 6*r*(768*s - 667) + 2888*s**2 - 5024*s + 2107)) - 5*D1*f*(2*Dd*(2*f*(C*(1292*r**2 + 2696*r*s - 1994*r + 1404*s**2 - 2078*s + 1025) - 1120*r**2 - 2420*r*s + 1770*r - 1300*s**2 + 1905*s - 930) + fd*(-4*C*(3072*r**2 + 6744*r*s - 4602*r + 3672*s**2 - 5027*s + 1711) + 11364*r**2 + 25752*r*s - 17359*r + 14388*s**2 - 19501*s + 6564)) + Ddd*f*(-8*C*(512*r**2 + 1124*r*s - 818*r + 612*s**2 - 893*s + 434) + 3788*r**2 + 8584*r*s - 6186*r + 4796*s**2 - 6942*s + 3345)) + 10*Dd**2*f**2*(4*C*(1536*r**2 + 6*r*(562*s - 409) + 1836*s**2 - 2679*s + 868) - 5682*r**2 - 3*r*(4292*s - 3093) - 7194*s**2 + 10413*s - 3345)))/(630*d**2*k3**5) + 2*D1**2*Pk1*Pkd3*ct**5*k1*k2*(7*b1**2*(D1**2*(s - 1)*(fd*(26*C - 20) + fdd*(15 - 18*C))*(r + s - 1) + D1*(Dd*(f*(26*C - 20)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(18*C - 15)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(15 - 18*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(18*C - 15)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(-3*D1**2*(f*(7*bdd1*s*(6*C - 5)*(2*r + 2*s - 1) - fd*(-46*C*s + r*(6*s - 3) + 6*s**2 + 30*s + 3) + 5*fdd*(-6*C*s + 2*r*s - r + 2*s**2 + 3*s + 1)) - 5*fd**2*(6*C*(s - 1) - 2*r*s + r - 2*s**2 - 3*s + 5)) + 7*D1*bd1*(D1*(f*s*(26*C - 20)*(2*r + 2*s - 1) - fd*(18*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(30 - 36*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 3*D1*f*(Dd*(-3*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(2*s - 1)*(12*C - 8*r - 8*s - 5)) + 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 15*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) - f*(21*D1**2*bd1**2*s*(6*C - 5)*(2*r + 2*s - 1) + 5*D1**2*(f*(3*bdd1*s*(6*C + r + s - 6) + fd*(22*C - 19)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(14*C - 14)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(14 - 14*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 3*D1*bd1*(D1*(f*s*(46*C + 3*r + 3*s - 39) - 5*fd*(6*C*(s - 1) + 4*r*s - r + 4*s**2 - 9*s + 6)) - 5*Dd*f*(12*C*(2*s - 1) + 8*r*s - 2*r + 8*s**2 - 29*s + 12)) + 5*D1*f*(Dd*(f*(22*C - 19)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(14*C - 14)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(14 - 14*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(14 - 14*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**3) - D1**2*Pk1*Pkd3*ct**5*k2**5*st**2*(3456*C*D1**2*b1*f*fd*r**2 + 3456*C*D1**2*b1*f*fd*r*s - 1728*C*D1**2*b1*f*fd*r - 720*C*D1**2*b1*f*fdd*r**2 - 720*C*D1**2*b1*f*fdd*r*s + 360*C*D1**2*b1*f*fdd*r - 720*C*D1**2*b1*fd**2*r**2 - 720*C*D1**2*b1*fd**2*r*s + 360*C*D1**2*b1*fd**2*r + 3552*C*D1**2*f**2*fd*r**2 + 3552*C*D1**2*f**2*fd*r*s - 3552*C*D1**2*f**2*fd*r - 1184*C*D1**2*f**2*fd*s + 1184*C*D1**2*f**2*fd - 1560*C*D1**2*f**2*fdd*r**2 - 1560*C*D1**2*f**2*fdd*r*s + 1560*C*D1**2*f**2*fdd*r + 520*C*D1**2*f**2*fdd*s - 520*C*D1**2*f**2*fdd - 3120*C*D1**2*f*fd**2*r**2 - 3120*C*D1**2*f*fd**2*r*s + 3120*C*D1**2*f*fd**2*r + 1040*C*D1**2*f*fd**2*s - 520*C*D1**2*f*fd**2 + 6912*C*D1*Dd*b1*f**2*r**2 + 6912*C*D1*Dd*b1*f**2*r*s - 6912*C*D1*Dd*b1*f**2*r - 1728*C*D1*Dd*b1*f**2*s + 1728*C*D1*Dd*b1*f**2 - 5760*C*D1*Dd*b1*f*fd*r**2 - 5760*C*D1*Dd*b1*f*fd*r*s + 4320*C*D1*Dd*b1*f*fd*r + 720*C*D1*Dd*b1*f*fd*s - 360*C*D1*Dd*b1*f*fd + 4736*C*D1*Dd*f**3*r**2 + 4736*C*D1*Dd*f**3*r*s - 4736*C*D1*Dd*f**3*r - 1184*C*D1*Dd*f**3*s + 1184*C*D1*Dd*f**3 - 12480*C*D1*Dd*f**2*fd*r**2 - 12480*C*D1*Dd*f**2*fd*r*s + 12480*C*D1*Dd*f**2*fd*r + 3640*C*D1*Dd*f**2*fd*s - 2600*C*D1*Dd*f**2*fd - 1440*C*D1*Ddd*b1*f**2*r**2 - 1440*C*D1*Ddd*b1*f**2*r*s + 1440*C*D1*Ddd*b1*f**2*r + 360*C*D1*Ddd*b1*f**2*s - 360*C*D1*Ddd*b1*f**2 - 2080*C*D1*Ddd*f**3*r**2 - 2080*C*D1*Ddd*f**3*r*s + 2080*C*D1*Ddd*f**3*r + 520*C*D1*Ddd*f**3*s - 520*C*D1*Ddd*f**3 - 4320*C*Dd**2*b1*f**2*r**2 - 4320*C*Dd**2*b1*f**2*r*s + 4320*C*Dd**2*b1*f**2*r + 1080*C*Dd**2*b1*f**2*s - 720*C*Dd**2*b1*f**2 - 6240*C*Dd**2*f**3*r**2 - 6240*C*Dd**2*f**3*r*s + 6240*C*Dd**2*f**3*r + 1560*C*Dd**2*f**3*s - 1040*C*Dd**2*f**3 - 6156*D1**2*b1*f*fd*r**2 - 8856*D1**2*b1*f*fd*r*s + 4428*D1**2*b1*f*fd*r - 2700*D1**2*b1*f*fd*s**2 + 2700*D1**2*b1*f*fd*s - 1350*D1**2*b1*f*fd + 2070*D1**2*b1*f*fdd*r**2 + 3420*D1**2*b1*f*fdd*r*s - 1710*D1**2*b1*f*fdd*r + 1350*D1**2*b1*f*fdd*s**2 - 1350*D1**2*b1*f*fdd*s + 675*D1**2*b1*f*fdd + 2070*D1**2*b1*fd**2*r**2 + 3420*D1**2*b1*fd**2*r*s - 1710*D1**2*b1*fd**2*r + 1350*D1**2*b1*fd**2*s**2 - 1350*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)*(8*C*(r - 1) - 23*r - 15*s + 23) - 5802*D1**2*f**2*fd*r**2 - 8052*D1**2*f**2*fd*r*s + 6552*D1**2*f**2*fd*r - 2250*D1**2*f**2*fd*s**2 + 4184*D1**2*f**2*fd*s - 2684*D1**2*f**2*fd + 2685*D1**2*f**2*fdd*r**2 + 3810*D1**2*f**2*fdd*r*s - 3060*D1**2*f**2*fdd*r + 1125*D1**2*f**2*fdd*s**2 - 2020*D1**2*f**2*fdd*s + 1270*D1**2*f**2*fdd + 5370*D1**2*f*fd**2*r**2 + 7620*D1**2*f*fd**2*r*s - 6120*D1**2*f*fd**2*r + 2250*D1**2*f*fd**2*s**2 - 4040*D1**2*f*fd**2*s + 1270*D1**2*f*fd**2 - 12312*D1*Dd*b1*f**2*r**2 - 17712*D1*Dd*b1*f**2*r*s + 15012*D1*Dd*b1*f**2*r - 5400*D1*Dd*b1*f**2*s**2 + 9828*D1*Dd*b1*f**2*s - 5778*D1*Dd*b1*f**2 + 16560*D1*Dd*b1*f*fd*r**2 + 27360*D1*Dd*b1*f*fd*r*s - 17820*D1*Dd*b1*f*fd*r + 10800*D1*Dd*b1*f*fd*s**2 - 14220*D1*Dd*b1*f*fd*s + 4410*D1*Dd*b1*f*fd - 7736*D1*Dd*f**3*r**2 - 10736*D1*Dd*f**3*r*s + 9236*D1*Dd*f**3*r - 3000*D1*Dd*f**3*s**2 + 5684*D1*Dd*f**3*s - 3434*D1*Dd*f**3 + 21480*D1*Dd*f**2*fd*r**2 + 30480*D1*Dd*f**2*fd*r*s - 25230*D1*Dd*f**2*fd*r + 9000*D1*Dd*f**2*fd*s**2 - 16390*D1*Dd*f**2*fd*s + 7100*D1*Dd*f**2*fd + 4140*D1*Ddd*b1*f**2*r**2 + 6840*D1*Ddd*b1*f**2*r*s - 5490*D1*Ddd*b1*f**2*r + 2700*D1*Ddd*b1*f**2*s**2 - 4410*D1*Ddd*b1*f**2*s + 2385*D1*Ddd*b1*f**2 + 3580*D1*Ddd*f**3*r**2 + 5080*D1*Ddd*f**3*r*s - 4330*D1*Ddd*f**3*r + 1500*D1*Ddd*f**3*s**2 - 2770*D1*Ddd*f**3*s + 1645*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(3*f*(r + s - 1)*(32*C*(r - 1) - 57*r - 25*s + 57) - 5*fd*(4*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 46*r**2 - 76*r*s + 65*r - 30*s**2 + 53*s - 19)) - 5*Dd*f*(4*C*(8*r**2 + 8*r*s - 12*r - 5*s + 4) - 92*r**2 - 152*r*s + 153*r - 60*s**2 + 125*s - 61)) + 12420*Dd**2*b1*f**2*r**2 + 20520*Dd**2*b1*f**2*r*s - 16470*Dd**2*b1*f**2*r + 8100*Dd**2*b1*f**2*s**2 - 13230*Dd**2*b1*f**2*s + 4770*Dd**2*b1*f**2 + 10740*Dd**2*f**3*r**2 + 15240*Dd**2*f**3*r*s - 12990*Dd**2*f**3*r + 4500*Dd**2*f**3*s**2 - 8310*Dd**2*f**3*s + 3290*Dd**2*f**3)/(630*d**2*k1*k3**5) + D1**2*Pk1*Pkd3*ct**5*k2**5*(11880*C*D1**2*f**2*fd*r**2 + 11880*C*D1**2*f**2*fd*r*s - 11880*C*D1**2*f**2*fd*r - 3960*C*D1**2*f**2*fd*s + 3960*C*D1**2*f**2*fd + 15840*C*D1*Dd*f**3*r**2 + 15840*C*D1*Dd*f**3*r*s - 15840*C*D1*Dd*f**3*r - 3960*C*D1*Dd*f**3*s + 3960*C*D1*Dd*f**3 + 792*D1**2*K*bdd1*f**2*r**2 + 792*D1**2*K*bdd1*f**2*r*s - 792*D1**2*K*bdd1*f**2*r - 990*D1**2*bd1**2*f*(r + s - 1)*(5*f*(2*r + 2*s - 1) + 7*r + 7*s - 7) - 3025*D1**2*bdd1*f**3*r**2 - 1430*D1**2*bdd1*f**3*r*s + 1760*D1**2*bdd1*f**3*r + 1595*D1**2*bdd1*f**3*s**2 - 2860*D1**2*bdd1*f**3*s - 660*D1**2*bdd1*f**3 - 3267*D1**2*bdd1*f**2*r**2 - 5742*D1**2*bdd1*f**2*r*s + 5742*D1**2*bdd1*f**2*r - 2475*D1**2*bdd1*f**2*s**2 + 4950*D1**2*bdd1*f**2*s - 2475*D1**2*bdd1*f**2 - 13300*D1**2*f**3*fd*r**2 - 27160*D1**2*f**3*fd*r*s + 20230*D1**2*f**3*fd*r - 13860*D1**2*f**3*fd*s**2 + 20650*D1**2*f**3*fd*s - 10255*D1**2*f**3*fd + 7420*D1**2*f**3*fdd*r**2 + 24360*D1**2*f**3*fdd*r*s - 15890*D1**2*f**3*fdd*r + 16940*D1**2*f**3*fdd*s**2 - 23030*D1**2*f**3*fdd*s + 10325*D1**2*f**3*fdd + 22260*D1**2*f**2*fd**2*r**2 + 73080*D1**2*f**2*fd**2*r*s - 47670*D1**2*f**2*fd**2*r + 50820*D1**2*f**2*fd**2*s**2 - 69090*D1**2*f**2*fd**2*s + 20650*D1**2*f**2*fd**2 - 19305*D1**2*f**2*fd*r**2 - 26730*D1**2*f**2*fd*r*s + 21780*D1**2*f**2*fd*r - 7425*D1**2*f**2*fd*s**2 + 13860*D1**2*f**2*fd*s - 8910*D1**2*f**2*fd + 8712*D1**2*f**2*gd2*r**2 + 8712*D1**2*f**2*gd2*r*s - 8712*D1**2*f**2*gd2*r - 1584*D1**2*f**2*gdd2*r**2 - 1584*D1**2*f**2*gdd2*r*s + 1584*D1**2*f**2*gdd2*r + 17424*D1**2*f*fd*g2*r**2 + 17424*D1**2*f*fd*g2*r*s - 17424*D1**2*f*fd*g2*r - 8712*D1**2*f*fd*g2*s + 8712*D1**2*f*fd*g2 - 6336*D1**2*f*fd*gd2*r**2 - 6336*D1**2*f*fd*gd2*r*s + 6336*D1**2*f*fd*gd2*r + 1584*D1**2*f*fd*gd2*s - 1584*D1**2*f*fd*gd2 - 3168*D1**2*f*fdd*g2*r**2 - 3168*D1**2*f*fdd*g2*r*s + 3168*D1**2*f*fdd*g2*r + 1584*D1**2*f*fdd*g2*s - 1584*D1**2*f*fdd*g2 - 3168*D1**2*fd**2*g2*r**2 - 3168*D1**2*fd**2*g2*r*s + 3168*D1**2*fd**2*g2*r + 1584*D1**2*fd**2*g2*s - 13300*D1*Dd*f**4*r**2 - 27160*D1*Dd*f**4*r*s + 20230*D1*Dd*f**4*r - 13860*D1*Dd*f**4*s**2 + 20650*D1*Dd*f**4*s - 10255*D1*Dd*f**4 + 59360*D1*Dd*f**3*fd*r**2 + 194880*D1*Dd*f**3*fd*r*s - 127120*D1*Dd*f**3*fd*r + 135520*D1*Dd*f**3*fd*s**2 - 184240*D1*Dd*f**3*fd*s + 61950*D1*Dd*f**3*fd - 25740*D1*Dd*f**3*r**2 - 35640*D1*Dd*f**3*r*s + 30690*D1*Dd*f**3*r - 9900*D1*Dd*f**3*s**2 + 18810*D1*Dd*f**3*s - 11385*D1*Dd*f**3 + 34848*D1*Dd*f**2*g2*r**2 + 34848*D1*Dd*f**2*g2*r*s - 34848*D1*Dd*f**2*g2*r - 8712*D1*Dd*f**2*g2*s + 8712*D1*Dd*f**2*g2 - 12672*D1*Dd*f**2*gd2*r**2 - 12672*D1*Dd*f**2*gd2*r*s + 12672*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s - 1584*D1*Dd*f**2*gd2 - 25344*D1*Dd*f*fd*g2*r**2 - 25344*D1*Dd*f*fd*g2*r*s + 25344*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s - 6336*D1*Dd*f*fd*g2 + 7420*D1*Ddd*f**4*r**2 + 24360*D1*Ddd*f**4*r*s - 15890*D1*Ddd*f**4*r + 16940*D1*Ddd*f**4*s**2 - 23030*D1*Ddd*f**4*s + 10325*D1*Ddd*f**4 - 6336*D1*Ddd*f**2*g2*r**2 - 6336*D1*Ddd*f**2*g2*r*s + 6336*D1*Ddd*f**2*g2*r + 1584*D1*Ddd*f**2*g2*s - 1584*D1*Ddd*f**2*g2 + 11*D1*bd1*f*(D1*(5*f**2*(119*r**2 + 2*r*(89*s - 41) + 59*s**2 - 22*s + 33) + f*(504*C*(r - 1)*(r + s - 1) - 10*fd*(165*r**2 + 78*r*s - 113*r - 87*s**2 + 97*s - 48) - (r + s - 1)*(396*K*r - 27*r - 135*s - 369)) + 18*fd*(4*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 66*r**2 + r*(91 - 116*s) - 50*s**2 + 79*s - 29) + 840*g2*(r - 1)*(r + s - 1)) - 2*Dd*f*(-36*K*(8*r**2 + 8*r*(s - 1) - s + 1) + 5*f*(220*r**2 + r*(104*s - 145) - 116*s**2 + 149*s - 36) + 1188*r**2 + 2088*r*s - 1863*r + 900*s**2 - 1611*s + 711)) + 22260*Dd**2*f**4*r**2 + 73080*Dd**2*f**4*r*s - 47670*Dd**2*f**4*r + 50820*Dd**2*f**4*s**2 - 69090*Dd**2*f**4*s + 20650*Dd**2*f**4 - 19008*Dd**2*f**2*g2*r**2 - 19008*Dd**2*f**2*g2*r*s + 19008*Dd**2*f**2*g2*r + 4752*Dd**2*f**2*g2*s - 3168*Dd**2*f**2*g2 + 165*b1**2*(D1**2*(15*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 30*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 14*fd*(r + s)*(r*(2*K - 5) - 3*s) - 21*fdd*(r + s)**2) + D1*(2*Dd*(30*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-7*K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 15*fd*(4*r + 4*s - 3)**2 + 140*r**2 + 224*r*s - 182*r + 84*s**2 - 140*s + 77) - 21*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(10*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(10*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(1008*C*D1**2*f*fd*r**2 + 1008*C*D1**2*f*fd*r*s - 504*C*D1**2*f*fd*r + 2016*C*D1*Dd*f**2*r**2 + 2016*C*D1*Dd*f**2*r*s - 2016*C*D1*Dd*f**2*r - 504*C*D1*Dd*f**2*s + 504*C*D1*Dd*f**2 - 792*D1**2*K*f*fd*r**2 - 792*D1**2*K*f*fd*r*s + 792*D1**2*K*f*fd*r + 396*D1**2*K*f*fd*s - 396*D1**2*K*f*fd + 144*D1**2*K*f*fdd*r**2 + 144*D1**2*K*f*fdd*r*s - 144*D1**2*K*f*fdd*r - 72*D1**2*K*f*fdd*s + 72*D1**2*K*f*fdd + 144*D1**2*K*fd**2*r**2 + 144*D1**2*K*fd**2*r*s - 144*D1**2*K*fd**2*r - 72*D1**2*K*fd**2*s - 45*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 14*(r + s - 1)**2) + 1785*D1**2*f**2*fd*r**2 + 2670*D1**2*f**2*fd*r*s - 2560*D1**2*f**2*fd*r + 885*D1**2*f**2*fd*s**2 - 1960*D1**2*f**2*fd*s + 1020*D1**2*f**2*fd - 825*D1**2*f**2*fdd*r**2 - 390*D1**2*f**2*fdd*r*s + 650*D1**2*f**2*fdd*r + 435*D1**2*f**2*fdd*s**2 - 190*D1**2*f**2*fdd*s + 75*D1**2*f**2*fdd - 1650*D1**2*f*fd**2*r**2 - 780*D1**2*f*fd**2*r*s + 1300*D1**2*f*fd**2*r + 870*D1**2*f*fd**2*s**2 - 380*D1**2*f*fd**2*s - 450*D1**2*f*fd**2 + 54*D1**2*f*fd*r**2 + 324*D1**2*f*fd*r*s - 558*D1**2*f*fd*r + 270*D1**2*f*fd*s**2 - 666*D1**2*f*fd*s + 531*D1**2*f*fd - 594*D1**2*f*fdd*r**2 - 1044*D1**2*f*fdd*r*s + 594*D1**2*f*fdd*r - 450*D1**2*f*fdd*s**2 + 522*D1**2*f*fdd*s - 297*D1**2*f*fdd + 840*D1**2*f*gd2*r**2 + 840*D1**2*f*gd2*r*s - 840*D1**2*f*gd2*r - 594*D1**2*fd**2*r**2 - 1044*D1**2*fd**2*r*s + 594*D1**2*fd**2*r - 450*D1**2*fd**2*s**2 + 522*D1**2*fd**2*s + 840*D1**2*fd*g2*r**2 + 840*D1**2*fd*g2*r*s - 1584*D1*Dd*K*f**2*r**2 - 1584*D1*Dd*K*f**2*r*s + 1584*D1*Dd*K*f**2*r + 396*D1*Dd*K*f**2*s - 396*D1*Dd*K*f**2 + 1152*D1*Dd*K*f*fd*r**2 + 1152*D1*Dd*K*f*fd*r*s - 1152*D1*Dd*K*f*fd*r - 432*D1*Dd*K*f*fd*s + 288*D1*Dd*K*f*fd + 2380*D1*Dd*f**3*r**2 + 3560*D1*Dd*f**3*r*s - 2970*D1*Dd*f**3*r + 1180*D1*Dd*f**3*s**2 - 2070*D1*Dd*f**3*s + 1185*D1*Dd*f**3 - 6600*D1*Dd*f**2*fd*r**2 - 3120*D1*Dd*f**2*fd*r*s + 5030*D1*Dd*f**2*fd*r + 3480*D1*Dd*f**2*fd*s**2 - 2110*D1*Dd*f**2*fd*s - 270*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 + 648*D1*Dd*f**2*r*s - 378*D1*Dd*f**2*r + 540*D1*Dd*f**2*s**2 - 702*D1*Dd*f**2*s + 297*D1*Dd*f**2 - 4752*D1*Dd*f*fd*r**2 - 8352*D1*Dd*f*fd*r*s + 5652*D1*Dd*f*fd*r - 3600*D1*Dd*f*fd*s**2 + 4932*D1*Dd*f*fd*s - 1638*D1*Dd*f*fd + 3360*D1*Dd*f*g2*r**2 + 3360*D1*Dd*f*g2*r*s - 3360*D1*Dd*f*g2*r - 840*D1*Dd*f*g2*s + 840*D1*Dd*f*g2 + 288*D1*Ddd*K*f**2*r**2 + 288*D1*Ddd*K*f**2*r*s - 288*D1*Ddd*K*f**2*r - 72*D1*Ddd*K*f**2*s + 72*D1*Ddd*K*f**2 - 1100*D1*Ddd*f**3*r**2 - 520*D1*Ddd*f**3*r*s + 810*D1*Ddd*f**3*r + 580*D1*Ddd*f**3*s**2 - 450*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 - 1188*D1*Ddd*f**2*r**2 - 2088*D1*Ddd*f**2*r*s + 1638*D1*Ddd*f**2*r - 900*D1*Ddd*f**2*s**2 + 1422*D1*Ddd*f**2*s - 747*D1*Ddd*f**2 + 30*D1*bd1*(D1*(15*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(r + s - 1)*(14*K*r - 7*K + 30*fd*(2*r + 2*s - 1) - 35*r - 21*s + 28) - 42*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 3*Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 14*r + 14*s - 14)) + 864*Dd**2*K*f**2*r**2 + 864*Dd**2*K*f**2*r*s - 864*Dd**2*K*f**2*r - 216*Dd**2*K*f**2*s + 144*Dd**2*K*f**2 - 3300*Dd**2*f**3*r**2 - 1560*Dd**2*f**3*r*s + 2430*Dd**2*f**3*r + 1740*Dd**2*f**3*s**2 - 1350*Dd**2*f**3*s + 30*Dd**2*f**3 - 3564*Dd**2*f**2*r**2 - 6264*Dd**2*f**2*r*s + 4914*Dd**2*f**2*r - 2700*Dd**2*f**2*s**2 + 4266*Dd**2*f**2*s - 1494*Dd**2*f**2))/(6930*d**2*k1*k3**5) + 2*D1**2*Pk1*Pkd3*ct**5*k2**3*st**2*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 10*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 5*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k1*k3**3) - D1**2*Pk1*Pkd3*ct**5*k2**3*(42*D1*b1*bd1*(D1*(f*(20*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 46*r**2 - 52*r*s + 46*r - 6*s**2 + 26*s - 23) + 3*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 21*b1**2*(D1**2*(fd*(r*(40*C - 46) - 6*s + 6) + 3*fdd*(r + s - 1))*(r + s - 1) + D1*(2*Dd*(f*(20*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 92*r**2 - 104*r*s + 98*r - 12*s**2 + 38*s - 29) + 3*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(7*D1**2*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1**2*(f*(fd*(88*C*(2*r - 1)*(r + s - 1) - 134*r**2 + 2*r*(6*s + 95) + 146*s**2 - 38*s - 25) + fdd*(-16*C*(2*r - 1)*(r + s - 1) + 32*r**2 - 2*r*(52*s - 5) - 136*s**2 + 110*s - 47)) - 2*fd**2*(8*C*(2*r - 1)*(r + s - 1) - 16*r**2 + r*(52*s - 5) + 68*s**2 - 55*s - 13)) + D1*f*(Dd*(f*(88*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 268*r**2 + 24*r*s + 122*r + 292*s**2 - 298*s + 79) - 2*fd*(8*C*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) - 128*r**2 + 416*r*s - 92*r + 544*s**2 - 544*s + 115)) - 4*Ddd*f*(4*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 16*r**2 + 52*r*s - 18*r + 68*s**2 - 81*s + 30)) - 4*Dd**2*f**2*(4*C*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - 48*r**2 + 6*r*(26*s - 9) + 204*s**2 - 243*s + 60)) - f*(-126*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(r**2*(16*C - 16) + 2*r*(s*(8*C + 26) - 5) + 68*s**2 - 78*s + 5) + 5*D1**2*(f*(fd*(32*C*(3*r**2 + 3*r*(s - 1) - s + 1) - 291*r**2 - 618*r*s + 400*r - 327*s**2 + 424*s - 206) + fdd*(-16*C*(3*r**2 + 3*r*(s - 1) - s + 1) + 105*r**2 + 5*r*(78*s - 40) + 285*s**2 - 320*s + 130)) + 2*fd**2*(-8*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 105*r**2 + 5*r*(78*s - 40) + 285*s**2 - 320*s + 65)) - 9*D1*bd1*(D1*(f*(r**2*(88*C - 67) + r*(88*C*s + 6*s - 62) + 73*s**2 - 114*s + 31) + 2*fd*(8*C*s - r**2*(32*C - 32) + r*(-32*C*s + 24*C - 104*s + 15) - 136*s**2 + 133*s - 39)) - 2*Dd*f*(-8*C*s + r**2*(64*C - 64) + 8*r*(8*C*s - 4*C + 26*s - 7) + 272*s**2 - 318*s + 83)) + 5*D1*f*(-16*C*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1) + Dd*f*(32*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 388*r**2 - 824*r*s + 606*r - 436*s**2 + 642*s - 315) + 2*Dd*fd*(-8*C*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 420*r**2 + 5*r*(312*s - 179) + 1140*s**2 - 1405*s + 420) + 5*Ddd*f*(28*r**2 + 2*r*(52*s - 33) + 76*s**2 - 102*s + 45)) - 10*Dd**2*f**2*(8*C*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - 210*r**2 - 15*r*(52*s - 33) - 570*s**2 + 765*s - 225)))/(630*d**2*k1*k3**3) + 2*D1**2*Pk1*Pkd3*ct**5*k2*(D1*f*(-7*D1*bd1**2*s*(2*r + 2*s - 1) - 5*D1*bdd1*f*s*(r + s) - 5*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 2) + s*(8*s - 5)))) + 7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(-7*bdd1*s*(2*r + 2*s - 1) + 10*fd*(2*s - 1)*(r + s - 1) - 5*fdd*(2*s - 1)*(r + s - 1)) - 5*fd**2*(2*s - 1)*(r + s - 1)) + 7*D1*bd1*(2*D1*f*s*(2*r + 2*s - 1) - D1*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k1*k3) - D1**2*Pk1*Pkd3*ct**4*f*k2**6*st**2*(99*D1**2*b1*f*fd*r**2 + 99*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 99*D1**2*b1*f*fdd*r**2 + 99*D1**2*b1*f*fdd*r*s - 66*D1**2*b1*f*fdd*r + 198*D1**2*b1*fd**2*r**2 + 198*D1**2*b1*fd**2*r*s - 132*D1**2*b1*fd**2*r + 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 380*D1**2*f**2*fd*r**2 + 380*D1**2*f**2*fd*r*s - 380*D1**2*f**2*fd*r - 95*D1**2*f**2*fd*s + 95*D1**2*f**2*fd - 300*D1**2*f**2*fdd*r**2 - 300*D1**2*f**2*fdd*r*s + 300*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s - 75*D1**2*f**2*fdd - 900*D1**2*f*fd**2*r**2 - 900*D1**2*f*fd**2*r*s + 900*D1**2*f*fd**2*r + 225*D1**2*f*fd**2*s - 150*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 132*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r - 33*D1*Dd*b1*f**2*s + 33*D1*Dd*b1*f**2 + 792*D1*Dd*b1*f*fd*r**2 + 792*D1*Dd*b1*f*fd*r*s - 660*D1*Dd*b1*f*fd*r - 99*D1*Dd*b1*f*fd*s + 66*D1*Dd*b1*f*fd + 380*D1*Dd*f**3*r**2 + 380*D1*Dd*f**3*r*s - 380*D1*Dd*f**3*r - 95*D1*Dd*f**3*s + 95*D1*Dd*f**3 - 2400*D1*Dd*f**2*fd*r**2 - 2400*D1*Dd*f**2*fd*r*s + 2400*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s - 450*D1*Dd*f**2*fd + 132*D1*Ddd*b1*f**2*r**2 + 132*D1*Ddd*b1*f**2*r*s - 132*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 - 300*D1*Ddd*f**3*r**2 - 300*D1*Ddd*f**3*r*s + 300*D1*Ddd*f**3*r + 75*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) + Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 396*Dd**2*b1*f**2*r**2 + 396*Dd**2*b1*f**2*r*s - 396*Dd**2*b1*f**2*r - 99*Dd**2*b1*f**2*s + 66*Dd**2*b1*f**2 - 900*Dd**2*f**3*r**2 - 900*Dd**2*f**3*r*s + 900*Dd**2*f**3*r + 225*Dd**2*f**3*s - 150*Dd**2*f**3)/(693*d**2*k1**2*k3**5) + D1**2*Pk1*Pkd3*ct**4*k1**4*k2**2*(1872*C*D1**2*b1*f*fd*r**2 + 3744*C*D1**2*b1*f*fd*r*s - 1872*C*D1**2*b1*f*fd*r + 1872*C*D1**2*b1*f*fd*s**2 - 1872*C*D1**2*b1*f*fd*s + 936*C*D1**2*b1*f*fd - 2700*C*D1**2*b1*f*fdd*r**2 - 5400*C*D1**2*b1*f*fdd*r*s + 2700*C*D1**2*b1*f*fdd*r - 2700*C*D1**2*b1*f*fdd*s**2 + 2700*C*D1**2*b1*f*fdd*s - 1350*C*D1**2*b1*f*fdd - 2700*C*D1**2*b1*fd**2*r**2 - 5400*C*D1**2*b1*fd**2*r*s + 2700*C*D1**2*b1*fd**2*r - 2700*C*D1**2*b1*fd**2*s**2 + 2700*C*D1**2*b1*fd**2*s + 2520*C*D1**2*f**2*fd*r**2 + 5040*C*D1**2*f**2*fd*r*s - 3360*C*D1**2*f**2*fd*r + 2520*C*D1**2*f**2*fd*s**2 - 3360*C*D1**2*f**2*fd*s + 1680*C*D1**2*f**2*fd - 3150*C*D1**2*f**2*fdd*r**2 - 6300*C*D1**2*f**2*fdd*r*s + 4200*C*D1**2*f**2*fdd*r - 3150*C*D1**2*f**2*fdd*s**2 + 4200*C*D1**2*f**2*fdd*s - 2100*C*D1**2*f**2*fdd - 6300*C*D1**2*f*fd**2*r**2 - 12600*C*D1**2*f*fd**2*r*s + 8400*C*D1**2*f*fd**2*r - 6300*C*D1**2*f*fd**2*s**2 + 8400*C*D1**2*f*fd**2*s - 2100*C*D1**2*f*fd**2 + 3744*C*D1*Dd*b1*f**2*r**2 + 7488*C*D1*Dd*b1*f**2*r*s - 5616*C*D1*Dd*b1*f**2*r + 3744*C*D1*Dd*b1*f**2*s**2 - 5616*C*D1*Dd*b1*f**2*s + 2808*C*D1*Dd*b1*f**2 - 21600*C*D1*Dd*b1*f*fd*r**2 - 43200*C*D1*Dd*b1*f*fd*r*s + 27000*C*D1*Dd*b1*f*fd*r - 21600*C*D1*Dd*b1*f*fd*s**2 + 27000*C*D1*Dd*b1*f*fd*s - 8100*C*D1*Dd*b1*f*fd + 3360*C*D1*Dd*f**3*r**2 + 6720*C*D1*Dd*f**3*r*s - 5040*C*D1*Dd*f**3*r + 3360*C*D1*Dd*f**3*s**2 - 5040*C*D1*Dd*f**3*s + 2520*C*D1*Dd*f**3 - 25200*C*D1*Dd*f**2*fd*r**2 - 50400*C*D1*Dd*f**2*fd*r*s + 35700*C*D1*Dd*f**2*fd*r - 25200*C*D1*Dd*f**2*fd*s**2 + 35700*C*D1*Dd*f**2*fd*s - 12600*C*D1*Dd*f**2*fd - 5400*C*D1*Ddd*b1*f**2*r**2 - 10800*C*D1*Ddd*b1*f**2*r*s + 8100*C*D1*Ddd*b1*f**2*r - 5400*C*D1*Ddd*b1*f**2*s**2 + 8100*C*D1*Ddd*b1*f**2*s - 4050*C*D1*Ddd*b1*f**2 - 4200*C*D1*Ddd*f**3*r**2 - 8400*C*D1*Ddd*f**3*r*s + 6300*C*D1*Ddd*f**3*r - 4200*C*D1*Ddd*f**3*s**2 + 6300*C*D1*Ddd*f**3*s - 3150*C*D1*Ddd*f**3 - 16200*C*Dd**2*b1*f**2*r**2 - 32400*C*Dd**2*b1*f**2*r*s + 24300*C*Dd**2*b1*f**2*r - 16200*C*Dd**2*b1*f**2*s**2 + 24300*C*Dd**2*b1*f**2*s - 8100*C*Dd**2*b1*f**2 - 12600*C*Dd**2*f**3*r**2 - 25200*C*Dd**2*f**3*r*s + 18900*C*Dd**2*f**3*r - 12600*C*Dd**2*f**3*s**2 + 18900*C*Dd**2*f**3*s - 6300*C*Dd**2*f**3 - 1206*D1**2*b1*f*fd*r**2 - 2412*D1**2*b1*f*fd*r*s + 1206*D1**2*b1*f*fd*r - 1206*D1**2*b1*f*fd*s**2 + 1206*D1**2*b1*f*fd*s - 603*D1**2*b1*f*fd + 1800*D1**2*b1*f*fdd*r**2 + 3600*D1**2*b1*f*fdd*r*s - 1800*D1**2*b1*f*fdd*r + 1800*D1**2*b1*f*fdd*s**2 - 1800*D1**2*b1*f*fdd*s + 900*D1**2*b1*f*fdd + 1800*D1**2*b1*fd**2*r**2 + 3600*D1**2*b1*fd**2*r*s - 1800*D1**2*b1*fd**2*r + 1800*D1**2*b1*fd**2*s**2 - 1800*D1**2*b1*fd**2*s - 450*D1**2*bdd1*f**2*(3*C - 2)*(r + s - 1)**2 - 1635*D1**2*f**2*fd*r**2 - 3270*D1**2*f**2*fd*r*s + 2180*D1**2*f**2*fd*r - 1635*D1**2*f**2*fd*s**2 + 2180*D1**2*f**2*fd*s - 1090*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 2412*D1*Dd*b1*f**2*r**2 - 4824*D1*Dd*b1*f**2*r*s + 3618*D1*Dd*b1*f**2*r - 2412*D1*Dd*b1*f**2*s**2 + 3618*D1*Dd*b1*f**2*s - 1809*D1*Dd*b1*f**2 + 14400*D1*Dd*b1*f*fd*r**2 + 28800*D1*Dd*b1*f*fd*r*s - 18000*D1*Dd*b1*f*fd*r + 14400*D1*Dd*b1*f*fd*s**2 - 18000*D1*Dd*b1*f*fd*s + 5400*D1*Dd*b1*f*fd - 2180*D1*Dd*f**3*r**2 - 4360*D1*Dd*f**3*r*s + 3270*D1*Dd*f**3*r - 2180*D1*Dd*f**3*s**2 + 3270*D1*Dd*f**3*s - 1635*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 23800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 23800*D1*Dd*f**2*fd*s + 8400*D1*Dd*f**2*fd + 3600*D1*Ddd*b1*f**2*r**2 + 7200*D1*Ddd*b1*f**2*r*s - 5400*D1*Ddd*b1*f**2*r + 3600*D1*Ddd*b1*f**2*s**2 - 5400*D1*Ddd*b1*f**2*s + 2700*D1*Ddd*b1*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(D1*f*(104*C - 67)*(r + s - 1) - D1*fd*(300*C - 200)*(2*r + 2*s - 1) - Dd*f*(300*C - 200)*(4*r + 4*s - 3)) + 10800*Dd**2*b1*f**2*r**2 + 21600*Dd**2*b1*f**2*r*s - 16200*Dd**2*b1*f**2*r + 10800*Dd**2*b1*f**2*s**2 - 16200*Dd**2*b1*f**2*s + 5400*Dd**2*b1*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3)/(70*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct**4*k1**4*(9*b1*(D1**2*(f*(fd*(44*C - 25) + fdd*(30 - 50*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(30 - 50*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(44*C - 25)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(30 - 50*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(30 - 50*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(30 - 50*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(68*C - 39)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (10*C - 6)*(9*bdd1*s*(r + s - 1) + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(42 - 70*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(f*s*(44*C - 25)*(r + s - 1) - fd*(50*C - 30)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(30 - 50*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(68*C - 39)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(70*C - 42)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(42 - 70*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(42 - 70*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**4*k1**2*k2**4*st**2*(5904*C*D1**2*b1*f*fd*r**2 + 11808*C*D1**2*b1*f*fd*r*s - 5904*C*D1**2*b1*f*fd*r + 5904*C*D1**2*b1*f*fd*s**2 - 5904*C*D1**2*b1*f*fd*s + 2952*C*D1**2*b1*f*fd - 4716*C*D1**2*b1*f*fdd*r**2 - 9432*C*D1**2*b1*f*fdd*r*s + 4716*C*D1**2*b1*f*fdd*r - 4716*C*D1**2*b1*f*fdd*s**2 + 4716*C*D1**2*b1*f*fdd*s - 2358*C*D1**2*b1*f*fdd - 4716*C*D1**2*b1*fd**2*r**2 - 9432*C*D1**2*b1*fd**2*r*s + 4716*C*D1**2*b1*fd**2*r - 4716*C*D1**2*b1*fd**2*s**2 + 4716*C*D1**2*b1*fd**2*s + 5592*C*D1**2*f**2*fd*r**2 + 11184*C*D1**2*f**2*fd*r*s - 7456*C*D1**2*f**2*fd*r + 5592*C*D1**2*f**2*fd*s**2 - 7456*C*D1**2*f**2*fd*s + 3728*C*D1**2*f**2*fd - 3930*C*D1**2*f**2*fdd*r**2 - 7860*C*D1**2*f**2*fdd*r*s + 5240*C*D1**2*f**2*fdd*r - 3930*C*D1**2*f**2*fdd*s**2 + 5240*C*D1**2*f**2*fdd*s - 2620*C*D1**2*f**2*fdd - 7860*C*D1**2*f*fd**2*r**2 - 15720*C*D1**2*f*fd**2*r*s + 10480*C*D1**2*f*fd**2*r - 7860*C*D1**2*f*fd**2*s**2 + 10480*C*D1**2*f*fd**2*s - 2620*C*D1**2*f*fd**2 + 11808*C*D1*Dd*b1*f**2*r**2 + 23616*C*D1*Dd*b1*f**2*r*s - 17712*C*D1*Dd*b1*f**2*r + 11808*C*D1*Dd*b1*f**2*s**2 - 17712*C*D1*Dd*b1*f**2*s + 8856*C*D1*Dd*b1*f**2 - 37728*C*D1*Dd*b1*f*fd*r**2 - 75456*C*D1*Dd*b1*f*fd*r*s + 47160*C*D1*Dd*b1*f*fd*r - 37728*C*D1*Dd*b1*f*fd*s**2 + 47160*C*D1*Dd*b1*f*fd*s - 14148*C*D1*Dd*b1*f*fd + 7456*C*D1*Dd*f**3*r**2 + 14912*C*D1*Dd*f**3*r*s - 11184*C*D1*Dd*f**3*r + 7456*C*D1*Dd*f**3*s**2 - 11184*C*D1*Dd*f**3*s + 5592*C*D1*Dd*f**3 - 31440*C*D1*Dd*f**2*fd*r**2 - 62880*C*D1*Dd*f**2*fd*r*s + 44540*C*D1*Dd*f**2*fd*r - 31440*C*D1*Dd*f**2*fd*s**2 + 44540*C*D1*Dd*f**2*fd*s - 15720*C*D1*Dd*f**2*fd - 9432*C*D1*Ddd*b1*f**2*r**2 - 18864*C*D1*Ddd*b1*f**2*r*s + 14148*C*D1*Ddd*b1*f**2*r - 9432*C*D1*Ddd*b1*f**2*s**2 + 14148*C*D1*Ddd*b1*f**2*s - 7074*C*D1*Ddd*b1*f**2 - 5240*C*D1*Ddd*f**3*r**2 - 10480*C*D1*Ddd*f**3*r*s + 7860*C*D1*Ddd*f**3*r - 5240*C*D1*Ddd*f**3*s**2 + 7860*C*D1*Ddd*f**3*s - 3930*C*D1*Ddd*f**3 - 28296*C*Dd**2*b1*f**2*r**2 - 56592*C*Dd**2*b1*f**2*r*s + 42444*C*Dd**2*b1*f**2*r - 28296*C*Dd**2*b1*f**2*s**2 + 42444*C*Dd**2*b1*f**2*s - 14148*C*Dd**2*b1*f**2 - 15720*C*Dd**2*f**3*r**2 - 31440*C*Dd**2*f**3*r*s + 23580*C*Dd**2*f**3*r - 15720*C*Dd**2*f**3*s**2 + 23580*C*Dd**2*f**3*s - 7860*C*Dd**2*f**3 - 4428*D1**2*b1*f*fd*r**2 - 8856*D1**2*b1*f*fd*r*s + 4428*D1**2*b1*f*fd*r - 4428*D1**2*b1*f*fd*s**2 + 4428*D1**2*b1*f*fd*s - 2214*D1**2*b1*f*fd + 3726*D1**2*b1*f*fdd*r**2 + 7452*D1**2*b1*f*fdd*r*s - 3726*D1**2*b1*f*fdd*r + 3726*D1**2*b1*f*fdd*s**2 - 3726*D1**2*b1*f*fdd*s + 1863*D1**2*b1*f*fdd + 3726*D1**2*b1*fd**2*r**2 + 7452*D1**2*b1*fd**2*r*s - 3726*D1**2*b1*fd**2*r + 3726*D1**2*b1*fd**2*s**2 - 3726*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(262*C - 207)*(r + s - 1)**2 - 4266*D1**2*f**2*fd*r**2 - 8532*D1**2*f**2*fd*r*s + 5688*D1**2*f**2*fd*r - 4266*D1**2*f**2*fd*s**2 + 5688*D1**2*f**2*fd*s - 2844*D1**2*f**2*fd + 3105*D1**2*f**2*fdd*r**2 + 6210*D1**2*f**2*fdd*r*s - 4140*D1**2*f**2*fdd*r + 3105*D1**2*f**2*fdd*s**2 - 4140*D1**2*f**2*fdd*s + 2070*D1**2*f**2*fdd + 6210*D1**2*f*fd**2*r**2 + 12420*D1**2*f*fd**2*r*s - 8280*D1**2*f*fd**2*r + 6210*D1**2*f*fd**2*s**2 - 8280*D1**2*f*fd**2*s + 2070*D1**2*f*fd**2 - 8856*D1*Dd*b1*f**2*r**2 - 17712*D1*Dd*b1*f**2*r*s + 13284*D1*Dd*b1*f**2*r - 8856*D1*Dd*b1*f**2*s**2 + 13284*D1*Dd*b1*f**2*s - 6642*D1*Dd*b1*f**2 + 29808*D1*Dd*b1*f*fd*r**2 + 59616*D1*Dd*b1*f*fd*r*s - 37260*D1*Dd*b1*f*fd*r + 29808*D1*Dd*b1*f*fd*s**2 - 37260*D1*Dd*b1*f*fd*s + 11178*D1*Dd*b1*f*fd - 5688*D1*Dd*f**3*r**2 - 11376*D1*Dd*f**3*r*s + 8532*D1*Dd*f**3*r - 5688*D1*Dd*f**3*s**2 + 8532*D1*Dd*f**3*s - 4266*D1*Dd*f**3 + 24840*D1*Dd*f**2*fd*r**2 + 49680*D1*Dd*f**2*fd*r*s - 35190*D1*Dd*f**2*fd*r + 24840*D1*Dd*f**2*fd*s**2 - 35190*D1*Dd*f**2*fd*s + 12420*D1*Dd*f**2*fd + 7452*D1*Ddd*b1*f**2*r**2 + 14904*D1*Ddd*b1*f**2*r*s - 11178*D1*Ddd*b1*f**2*r + 7452*D1*Ddd*b1*f**2*s**2 - 11178*D1*Ddd*b1*f**2*s + 5589*D1*Ddd*b1*f**2 + 4140*D1*Ddd*f**3*r**2 + 8280*D1*Ddd*f**3*r*s - 6210*D1*Ddd*f**3*r + 4140*D1*Ddd*f**3*s**2 - 6210*D1*Ddd*f**3*s + 3105*D1*Ddd*f**3 + 18*D1*bd1*f*(r + s - 1)*(D1*f*(164*C - 123)*(r + s - 1) - D1*fd*(262*C - 207)*(2*r + 2*s - 1) - Dd*f*(262*C - 207)*(4*r + 4*s - 3)) + 22356*Dd**2*b1*f**2*r**2 + 44712*Dd**2*b1*f**2*r*s - 33534*Dd**2*b1*f**2*r + 22356*Dd**2*b1*f**2*s**2 - 33534*Dd**2*b1*f**2*s + 11178*Dd**2*b1*f**2 + 12420*Dd**2*f**3*r**2 + 24840*Dd**2*f**3*r*s - 18630*Dd**2*f**3*r + 12420*Dd**2*f**3*s**2 - 18630*Dd**2*f**3*s + 6210*Dd**2*f**3)/(70*d**2*k3**7) - 3*D1**2*Pk1*Pkd3*ct**4*k1**2*k2**4*(5940*C*D1**2*f**2*fd*r**2 + 11880*C*D1**2*f**2*fd*r*s - 7920*C*D1**2*f**2*fd*r + 5940*C*D1**2*f**2*fd*s**2 - 7920*C*D1**2*f**2*fd*s + 3960*C*D1**2*f**2*fd + 7920*C*D1*Dd*f**3*r**2 + 15840*C*D1*Dd*f**3*r*s - 11880*C*D1*Dd*f**3*r + 7920*C*D1*Dd*f**3*s**2 - 11880*C*D1*Dd*f**3*s + 5940*C*D1*Dd*f**3 - 330*D1**2*bd1**2*f*(-21*K + 10*f + 14)*(r + s - 1)**2 + 165*D1**2*bdd1*f*(5*f*(3*K - 2) - 42*g2)*(r + s - 1)**2 - 3780*D1**2*f**3*fd*r**2 - 7560*D1**2*f**3*fd*r*s + 5670*D1**2*f**3*fd*r - 3780*D1**2*f**3*fd*s**2 + 5670*D1**2*f**3*fd*s - 2835*D1**2*f**3*fd + 4200*D1**2*f**3*fdd*r**2 + 8400*D1**2*f**3*fdd*r*s - 6300*D1**2*f**3*fdd*r + 4200*D1**2*f**3*fdd*s**2 - 6300*D1**2*f**3*fdd*s + 3150*D1**2*f**3*fdd + 12600*D1**2*f**2*fd**2*r**2 + 25200*D1**2*f**2*fd**2*r*s - 18900*D1**2*f**2*fd**2*r + 12600*D1**2*f**2*fd**2*s**2 - 18900*D1**2*f**2*fd**2*s + 6300*D1**2*f**2*fd**2 - 4455*D1**2*f**2*fd*r**2 - 8910*D1**2*f**2*fd*r*s + 5940*D1**2*f**2*fd*r - 4455*D1**2*f**2*fd*s**2 + 5940*D1**2*f**2*fd*s - 2970*D1**2*f**2*fd + 5742*D1**2*f**2*gd2*r**2 + 11484*D1**2*f**2*gd2*r*s - 11484*D1**2*f**2*gd2*r + 5742*D1**2*f**2*gd2*s**2 - 11484*D1**2*f**2*gd2*s + 5742*D1**2*f**2*gd2 - 4950*D1**2*f**2*gdd2*r**2 - 9900*D1**2*f**2*gdd2*r*s + 9900*D1**2*f**2*gdd2*r - 4950*D1**2*f**2*gdd2*s**2 + 9900*D1**2*f**2*gdd2*s - 4950*D1**2*f**2*gdd2 + 11484*D1**2*f*fd*g2*r**2 + 22968*D1**2*f*fd*g2*r*s - 11484*D1**2*f*fd*g2*r + 11484*D1**2*f*fd*g2*s**2 - 11484*D1**2*f*fd*g2*s + 5742*D1**2*f*fd*g2 - 19800*D1**2*f*fd*gd2*r**2 - 39600*D1**2*f*fd*gd2*r*s + 29700*D1**2*f*fd*gd2*r - 19800*D1**2*f*fd*gd2*s**2 + 29700*D1**2*f*fd*gd2*s - 9900*D1**2*f*fd*gd2 - 9900*D1**2*f*fdd*g2*r**2 - 19800*D1**2*f*fdd*g2*r*s + 9900*D1**2*f*fdd*g2*r - 9900*D1**2*f*fdd*g2*s**2 + 9900*D1**2*f*fdd*g2*s - 4950*D1**2*f*fdd*g2 - 9900*D1**2*fd**2*g2*r**2 - 19800*D1**2*fd**2*g2*r*s + 9900*D1**2*fd**2*g2*r - 9900*D1**2*fd**2*g2*s**2 + 9900*D1**2*fd**2*g2*s - 3780*D1*Dd*f**4*r**2 - 7560*D1*Dd*f**4*r*s + 5670*D1*Dd*f**4*r - 3780*D1*Dd*f**4*s**2 + 5670*D1*Dd*f**4*s - 2835*D1*Dd*f**4 + 33600*D1*Dd*f**3*fd*r**2 + 67200*D1*Dd*f**3*fd*r*s - 50400*D1*Dd*f**3*fd*r + 33600*D1*Dd*f**3*fd*s**2 - 50400*D1*Dd*f**3*fd*s + 18900*D1*Dd*f**3*fd - 5940*D1*Dd*f**3*r**2 - 11880*D1*Dd*f**3*r*s + 8910*D1*Dd*f**3*r - 5940*D1*Dd*f**3*s**2 + 8910*D1*Dd*f**3*s - 4455*D1*Dd*f**3 + 22968*D1*Dd*f**2*g2*r**2 + 45936*D1*Dd*f**2*g2*r*s - 34452*D1*Dd*f**2*g2*r + 22968*D1*Dd*f**2*g2*s**2 - 34452*D1*Dd*f**2*g2*s + 17226*D1*Dd*f**2*g2 - 39600*D1*Dd*f**2*gd2*r**2 - 79200*D1*Dd*f**2*gd2*r*s + 69300*D1*Dd*f**2*gd2*r - 39600*D1*Dd*f**2*gd2*s**2 + 69300*D1*Dd*f**2*gd2*s - 29700*D1*Dd*f**2*gd2 - 79200*D1*Dd*f*fd*g2*r**2 - 158400*D1*Dd*f*fd*g2*r*s + 99000*D1*Dd*f*fd*g2*r - 79200*D1*Dd*f*fd*g2*s**2 + 99000*D1*Dd*f*fd*g2*s - 29700*D1*Dd*f*fd*g2 + 4200*D1*Ddd*f**4*r**2 + 8400*D1*Ddd*f**4*r*s - 6300*D1*Ddd*f**4*r + 4200*D1*Ddd*f**4*s**2 - 6300*D1*Ddd*f**4*s + 3150*D1*Ddd*f**4 - 19800*D1*Ddd*f**2*g2*r**2 - 39600*D1*Ddd*f**2*g2*r*s + 29700*D1*Ddd*f**2*g2*r - 19800*D1*Ddd*f**2*g2*s**2 + 29700*D1*Ddd*f**2*g2*s - 14850*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(10*f**3*(r + s - 1) + 3*f**2*(28*C - 29*K - 4)*(r + s - 1) + 50*f*fd*(3*K - 2)*(2*r + 2*s - 1) + 210*f*(g2 - 2*gd2)*(r + s - 1) - 420*fd*g2*(r + s)) + 10*Dd*f*(5*f*(3*K - 2) - 42*g2)*(4*r + 4*s - 3))*(r + s - 1) + 12600*Dd**2*f**4*r**2 + 25200*Dd**2*f**4*r*s - 18900*Dd**2*f**4*r + 12600*Dd**2*f**4*s**2 - 18900*Dd**2*f**4*s + 6300*Dd**2*f**4 - 59400*Dd**2*f**2*g2*r**2 - 118800*Dd**2*f**2*g2*r*s + 89100*Dd**2*f**2*g2*r - 59400*Dd**2*f**2*g2*s**2 + 89100*Dd**2*f**2*g2*s - 29700*Dd**2*f**2*g2 + 11*b1**2*(D1**2*(3*f*(51*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-5*r - 5*s)*(60*fd**2*(r + s - 1) + 7*fd*(9*K - 5)*(r + s) - 21*fdd*(3*K - 2)*(r + s))) + D1*(Dd*(153*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (63*K - 35)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 210*fd*(3*K - 2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 15*Ddd*f*(-21*K + 10*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f*(-21*K + 10*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(-30*D1**2*bdd1*f*(-21*K + 10*f + 14)*(r + s - 1)**2 - 3*D1**2*(-10*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-3*fd*(28*C - 29*K - 4)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 25*fdd*(3*K - 2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*(42*gd2 - 42*gdd2)*(r + s - 1)**2) - (10*r + 10*s)*(5*fd**2*(3*K - 2)*(r + s - 1) + 21*fd*(g2*(r + s) - 2*gd2*(r + s - 1)) - 21*fdd*g2*(r + s))) + 2*D1*bd1*(D1*(153*f**2*(r + s - 1) - 5*f*(60*fd*(2*r + 2*s - 1) + (63*K - 35)*(r + s - 1)) + 210*fd*(3*K - 2)*(r + s)) - 30*Dd*f*(-21*K + 10*f + 14)*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(-10*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*f**2*(28*C - 29*K - 4)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*f*(5*fd*(3*K - 2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 21*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 42*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 420*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 5*Ddd*f*(5*f*(3*K - 2) - 42*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f*(5*f*(3*K - 2) - 42*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(770*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct**4*k1**2*k2**2*st**2*(3*b1*(D1**2*(f*(fd*(288*C - 212) + fdd*(141 - 186*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(141 - 186*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(288*C - 212)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(141 - 186*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(141 - 186*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(141 - 186*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(512*C - 380)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (62*C - 47)*(9*bdd1*s*(r + s - 1) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(235 - 310*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(288*C - 212)*(r + s - 1) - fd*(186*C - 141)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(141 - 186*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(512*C - 380)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(310*C - 235)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(235 - 310*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(235 - 310*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**4*k1**2*k2**2*(105*b1**2*(D1**2*(fd*(22*C - 14) + fdd*(27 - 36*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(11*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(27 - 36*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(27 - 36*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(216*C - 162)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-315*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 3*D1**2*(f*(2*fd*(C*(452*r**2 + 2*r*(872*s - 311) + 1292*s**2 - 1042*s + 521) - 336*r**2 - 1366*r*s + 513*r - 1030*s**2 + 860*s - 430) + fdd*(-40*C*(33*r**2 + r*(94*s - 32) + 61*s**2 - 46*s + 23) + 980*r**2 + 6*r*(496*s - 173) + 1996*s**2 - 1546*s + 773)) - 2*fd**2*(20*C*(33*r**2 + r*(94*s - 32) + 61*s**2 - 46*s - 15) - 490*r**2 + r*(519 - 1488*s) - 998*s**2 + 773*s + 225)) + 70*D1*bd1*(D1*(f*(11*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(27 - 36*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(27 - 36*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 6*D1*f*(Dd*(f*(2*C*(452*r**2 + 2*r*(872*s - 549) + 1292*s**2 - 1728*s + 759) - 672*r**2 + r*(1702 - 2732*s) - 2060*s**2 + 2743*s - 1198) + fd*(-40*C*(132*r**2 + r*(376*s - 191) + 244*s**2 - 261*s + 62) + 3920*r**2 + 16*r*(744*s - 377) + 7984*s**2 - 8572*s + 2065)) + Ddd*f*(-10*C*(132*r**2 + r*(376*s - 254) + 244*s**2 - 338*s + 155) + 980*r**2 + 2*r*(1488*s - 989) + 1996*s**2 - 2740*s + 1243)) + 12*Dd**2*f**2*(10*C*(198*r**2 + r*(564*s - 381) + 366*s**2 - 507*s + 155) - 1470*r**2 + r*(2967 - 4464*s) - 2994*s**2 + 4110*s - 1243)) + f*(-1890*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(20*C*(33*r**2 + r*(94*s - 96) + 61*s**2 - 124*s + 48) - 490*r**2 - 2*r*(744*s - 715) - 998*s**2 + 1938*s - 715) - 5*D1**2*(f*(2*fd*(C*(2019*r**2 + 6*r*(863*s - 512) + 3159*s**2 - 3832*s + 1726) - 1449*r**2 - 3921*r*s + 2273*r - 2472*s**2 + 2955*s - 1307) + fdd*(-112*C*(39*r**2 + 93*r*s - 57*r + 54*s**2 - 67*s + 31) + 3231*r**2 + 8106*r*s - 4856*r + 4875*s**2 - 5952*s + 2702)) - 2*fd**2*(56*C*(78*r**2 + 6*r*(31*s - 19) + 108*s**2 - 134*s + 31) - 3231*r**2 - 8106*r*s + 4856*r - 4875*s**2 + 5952*s - 1351)) - 18*D1*bd1*(D1*(f*(C*(226*r**2 + 872*r*s - 702*r + 646*s**2 - 1122*s + 351) - 168*r**2 - 683*r*s + 506*r - 515*s**2 + 853*s - 253) + fd*(-40*C*(33*r**2 + 94*r*s - 64*r + 61*s**2 - 85*s + 31) + 980*r**2 + 2976*r*s - 1949*r + 1996*s**2 - 2711*s + 969)) + Dd*f*(-20*C*(132*r**2 + 376*r*s - 319*r + 244*s**2 - 417*s + 172) + 1960*r**2 + 5952*r*s - 4838*r + 3992*s**2 - 6616*s + 2653)) - 5*D1*f*(2*Dd*(f*(C*(2692*r**2 + r*(6904*s - 4798) + 4212*s**2 - 5938*s + 2779) - 1932*r**2 + r*(3580 - 5228*s) - 3296*s**2 + 4603*s - 2131) + fd*(-56*C*(312*r**2 + 12*r*(62*s - 41) + 432*s**2 - 577*s + 191) + 12924*r**2 + 7*r*(4632*s - 3007) + 19500*s**2 - 25707*s + 8380)) + Ddd*f*(-112*C*(52*r**2 + 4*r*(31*s - 22) + 72*s**2 - 103*s + 49) + 4308*r**2 + 2*r*(5404*s - 3779) + 6500*s**2 - 9202*s + 4327)) + 10*Dd**2*f**2*(56*C*(156*r**2 + 12*r*(31*s - 22) + 216*s**2 - 309*s + 98) - 6462*r**2 - 3*r*(5404*s - 3779) - 9750*s**2 + 13803*s - 4327)))/(630*d**2*k3**5) + 2*D1**2*Pk1*Pkd3*ct**4*k1**2*(3*D1*b1*(3*D1*(f*fd*s*(19 - 32*C) + f*s*(6*C - 4)*(-7*bdd1*(2*r + 2*s - 1) + 5*fdd) + fd**2*(30*C - 20)*(s - 1)) + Dd*f*fd*(180*C - 120)*(2*s - 1) - 7*bd1*(D1*(-f*s*(16*C - 9)*(2*r + 2*s - 1) + fd*(18*C - 12)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(36*C - 24)*(r*(8*s - 2) + 8*s**2 - 7*s + 1))) + 21*b1**2*(D1**2*(s - 1)*(fd*(16*C - 9) + fdd*(12 - 18*C))*(r + s - 1) + D1*(Dd*(f*(16*C - 9)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(18*C - 12)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(12 - 18*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(18*C - 12)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-126*D1**2*bd1**2*s*(3*C - 2)*(2*r + 2*s - 1) - 5*D1**2*(f*(fd*(48*C - 29)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (6*C - 4)*(-9*bdd1*s + 7*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(28 - 42*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*f*s*(32*C - 19) + D1*fd*(20 - 30*C)*(s - 1) - Dd*f*(60*C - 40)*(2*s - 1)) - 5*D1*f*(Dd*(f*(48*C - 29)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(42*C - 28)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(28 - 42*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(28 - 42*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**4*k2**6*st**4*(9*C - 9)*(12*D1**2*b1*f*fd*r**2 + 24*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*r + 12*D1**2*b1*f*fd*s**2 - 12*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fd - 6*D1**2*b1*f*fdd*r**2 - 12*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*r - 6*D1**2*b1*f*fdd*s**2 + 6*D1**2*b1*f*fdd*s - 3*D1**2*b1*f*fdd - 6*D1**2*b1*fd**2*r**2 - 12*D1**2*b1*fd**2*r*s + 6*D1**2*b1*fd**2*r - 6*D1**2*b1*fd**2*s**2 + 6*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 24*D1*Dd*b1*f**2*r**2 + 48*D1*Dd*b1*f**2*r*s - 36*D1*Dd*b1*f**2*r + 24*D1*Dd*b1*f**2*s**2 - 36*D1*Dd*b1*f**2*s + 18*D1*Dd*b1*f**2 - 48*D1*Dd*b1*f*fd*r**2 - 96*D1*Dd*b1*f*fd*r*s + 60*D1*Dd*b1*f*fd*r - 48*D1*Dd*b1*f*fd*s**2 + 60*D1*Dd*b1*f*fd*s - 18*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 12*D1*Ddd*b1*f**2*r**2 - 24*D1*Ddd*b1*f**2*r*s + 18*D1*Ddd*b1*f**2*r - 12*D1*Ddd*b1*f**2*s**2 + 18*D1*Ddd*b1*f**2*s - 9*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 6*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 36*Dd**2*b1*f**2*r**2 - 72*Dd**2*b1*f**2*r*s + 54*Dd**2*b1*f**2*r - 36*Dd**2*b1*f**2*s**2 + 54*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(7*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**4*k2**6*st**2*(-3564*C*D1**2*f**2*fd*r**2 - 7128*C*D1**2*f**2*fd*r*s + 4752*C*D1**2*f**2*fd*r - 3564*C*D1**2*f**2*fd*s**2 + 4752*C*D1**2*f**2*fd*s - 2376*C*D1**2*f**2*fd - 4752*C*D1*Dd*f**3*r**2 - 9504*C*D1*Dd*f**3*r*s + 7128*C*D1*Dd*f**3*r - 4752*C*D1*Dd*f**3*s**2 + 7128*C*D1*Dd*f**3*s - 3564*C*D1*Dd*f**3 - 594*D1**2*K*bdd1*f**2*r**2 - 1188*D1**2*K*bdd1*f**2*r*s + 1188*D1**2*K*bdd1*f**2*r - 594*D1**2*K*bdd1*f**2*s**2 + 1188*D1**2*K*bdd1*f**2*s - 594*D1**2*K*bdd1*f**2 + 198*D1**2*bd1**2*f*(-14*K + 15*f + 14)*(r + s - 1)**2 - 3300*D1**2*bdd1*f**3*r**2 - 6600*D1**2*bdd1*f**3*r*s + 6600*D1**2*bdd1*f**3*r - 3300*D1**2*bdd1*f**3*s**2 + 6600*D1**2*bdd1*f**3*s - 3300*D1**2*bdd1*f**3 + 594*D1**2*bdd1*f**2*r**2 + 1188*D1**2*bdd1*f**2*r*s - 1188*D1**2*bdd1*f**2*r + 594*D1**2*bdd1*f**2*s**2 - 1188*D1**2*bdd1*f**2*s + 594*D1**2*bdd1*f**2 + 2772*D1**2*bdd1*f*g2*r**2 + 5544*D1**2*bdd1*f*g2*r*s - 5544*D1**2*bdd1*f*g2*r + 2772*D1**2*bdd1*f*g2*s**2 - 5544*D1**2*bdd1*f*g2*s + 2772*D1**2*bdd1*f*g2 + 16600*D1**2*f**3*fd*r**2 + 33200*D1**2*f**3*fd*r*s - 24900*D1**2*f**3*fd*r + 16600*D1**2*f**3*fd*s**2 - 24900*D1**2*f**3*fd*s + 12450*D1**2*f**3*fd - 10500*D1**2*f**3*fdd*r**2 - 21000*D1**2*f**3*fdd*r*s + 15750*D1**2*f**3*fdd*r - 10500*D1**2*f**3*fdd*s**2 + 15750*D1**2*f**3*fdd*s - 7875*D1**2*f**3*fdd - 31500*D1**2*f**2*fd**2*r**2 - 63000*D1**2*f**2*fd**2*r*s + 47250*D1**2*f**2*fd**2*r - 31500*D1**2*f**2*fd**2*s**2 + 47250*D1**2*f**2*fd**2*s - 15750*D1**2*f**2*fd**2 + 3564*D1**2*f**2*fd*r**2 + 7128*D1**2*f**2*fd*r*s - 4752*D1**2*f**2*fd*r + 3564*D1**2*f**2*fd*s**2 - 4752*D1**2*f**2*fd*s + 2376*D1**2*f**2*fd - 2376*D1**2*f**2*gd2*r**2 - 4752*D1**2*f**2*gd2*r*s + 4752*D1**2*f**2*gd2*r - 2376*D1**2*f**2*gd2*s**2 + 4752*D1**2*f**2*gd2*s - 2376*D1**2*f**2*gd2 + 1188*D1**2*f**2*gdd2*r**2 + 2376*D1**2*f**2*gdd2*r*s - 2376*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 2376*D1**2*f**2*gdd2*s + 1188*D1**2*f**2*gdd2 - 4752*D1**2*f*fd*g2*r**2 - 9504*D1**2*f*fd*g2*r*s + 4752*D1**2*f*fd*g2*r - 4752*D1**2*f*fd*g2*s**2 + 4752*D1**2*f*fd*g2*s - 2376*D1**2*f*fd*g2 + 4752*D1**2*f*fd*gd2*r**2 + 9504*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2376*D1**2*f*fd*gd2 + 2376*D1**2*f*fdd*g2*r**2 + 4752*D1**2*f*fdd*g2*r*s - 2376*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 2376*D1**2*fd**2*g2*r**2 + 4752*D1**2*fd**2*g2*r*s - 2376*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 16600*D1*Dd*f**4*r**2 + 33200*D1*Dd*f**4*r*s - 24900*D1*Dd*f**4*r + 16600*D1*Dd*f**4*s**2 - 24900*D1*Dd*f**4*s + 12450*D1*Dd*f**4 - 84000*D1*Dd*f**3*fd*r**2 - 168000*D1*Dd*f**3*fd*r*s + 126000*D1*Dd*f**3*fd*r - 84000*D1*Dd*f**3*fd*s**2 + 126000*D1*Dd*f**3*fd*s - 47250*D1*Dd*f**3*fd + 4752*D1*Dd*f**3*r**2 + 9504*D1*Dd*f**3*r*s - 7128*D1*Dd*f**3*r + 4752*D1*Dd*f**3*s**2 - 7128*D1*Dd*f**3*s + 3564*D1*Dd*f**3 - 9504*D1*Dd*f**2*g2*r**2 - 19008*D1*Dd*f**2*g2*r*s + 14256*D1*Dd*f**2*g2*r - 9504*D1*Dd*f**2*g2*s**2 + 14256*D1*Dd*f**2*g2*s - 7128*D1*Dd*f**2*g2 + 9504*D1*Dd*f**2*gd2*r**2 + 19008*D1*Dd*f**2*gd2*r*s - 16632*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 19008*D1*Dd*f*fd*g2*r**2 + 38016*D1*Dd*f*fd*g2*r*s - 23760*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 23760*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 10500*D1*Ddd*f**4*r**2 - 21000*D1*Ddd*f**4*r*s + 15750*D1*Ddd*f**4*r - 10500*D1*Ddd*f**4*s**2 + 15750*D1*Ddd*f**4*s - 7875*D1*Ddd*f**4 + 4752*D1*Ddd*f**2*g2*r**2 + 9504*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 + 132*D1*bd1*(D1*(35*f**3*(r + s - 1) + f**2*(-21*C*(r + s - 1) - 50*fd*(3*r + 3*s - 2) + (9*K + 12)*(r + s - 1)) - 3*f*(3*fd*(K - 1)*(2*r + 2*s - 1) + (14*g2 - 14*gd2)*(r + s - 1)) + 42*fd*g2*(r + s)) - Dd*f*(50*f**2 + 9*f*(K - 1) - 42*g2)*(4*r + 4*s - 3))*(r + s - 1) - 31500*Dd**2*f**4*r**2 - 63000*Dd**2*f**4*r*s + 47250*Dd**2*f**4*r - 31500*Dd**2*f**4*s**2 + 47250*Dd**2*f**4*s - 15750*Dd**2*f**4 + 14256*Dd**2*f**2*g2*r**2 + 28512*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 7128*Dd**2*f**2*g2 - 99*b1**2*(D1**2*(15*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(15*fd**2*(r + s - 1) + 14*fd*(K - 1)*(r + s) - 7*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(15*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(15*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 14*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 15*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 15*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 66*b1*(84*C*D1**2*f*fd*r**2 + 168*C*D1**2*f*fd*r*s - 84*C*D1**2*f*fd*r + 84*C*D1**2*f*fd*s**2 - 84*C*D1**2*f*fd*s + 42*C*D1**2*f*fd + 168*C*D1*Dd*f**2*r**2 + 336*C*D1*Dd*f**2*r*s - 252*C*D1*Dd*f**2*r + 168*C*D1*Dd*f**2*s**2 - 252*C*D1*Dd*f**2*s + 126*C*D1*Dd*f**2 - 36*D1**2*K*f*fd*r**2 - 72*D1**2*K*f*fd*r*s + 36*D1**2*K*f*fd*r - 36*D1**2*K*f*fd*s**2 + 36*D1**2*K*f*fd*s - 18*D1**2*K*f*fd + 18*D1**2*K*f*fdd*r**2 + 36*D1**2*K*f*fdd*r*s - 18*D1**2*K*f*fdd*r + 18*D1**2*K*f*fdd*s**2 - 18*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 18*D1**2*K*fd**2*r**2 + 36*D1**2*K*fd**2*r*s - 18*D1**2*K*fd**2*r + 18*D1**2*K*fd**2*s**2 - 18*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(-14*K + 15*f + 14)*(r + s - 1)**2 - 210*D1**2*f**2*fd*r**2 - 420*D1**2*f**2*fd*r*s + 280*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 280*D1**2*f**2*fd*s - 140*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 48*D1**2*f*fd*r**2 - 96*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 48*D1**2*f*fd*s - 24*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 84*D1**2*f*gd2*r**2 + 168*D1**2*f*gd2*r*s - 168*D1**2*f*gd2*r + 84*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s + 84*D1**2*f*gd2 - 42*D1**2*f*gdd2*r**2 - 84*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*r - 42*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s - 42*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 84*D1**2*fd*g2*r**2 + 168*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*s**2 - 84*D1**2*fd*gd2*r**2 - 168*D1**2*fd*gd2*r*s + 84*D1**2*fd*gd2*r - 84*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s - 42*D1**2*fdd*g2*r**2 - 84*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*s**2 - 72*D1*Dd*K*f**2*r**2 - 144*D1*Dd*K*f**2*r*s + 108*D1*Dd*K*f**2*r - 72*D1*Dd*K*f**2*s**2 + 108*D1*Dd*K*f**2*s - 54*D1*Dd*K*f**2 + 144*D1*Dd*K*f*fd*r**2 + 288*D1*Dd*K*f*fd*r*s - 180*D1*Dd*K*f*fd*r + 144*D1*Dd*K*f*fd*s**2 - 180*D1*Dd*K*f*fd*s + 54*D1*Dd*K*f*fd - 280*D1*Dd*f**3*r**2 - 560*D1*Dd*f**3*r*s + 420*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 420*D1*Dd*f**3*s - 210*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 1700*D1*Dd*f**2*fd*r + 1200*D1*Dd*f**2*fd*s**2 - 1700*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 96*D1*Dd*f**2*r**2 - 192*D1*Dd*f**2*r*s + 144*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 144*D1*Dd*f**2*s - 72*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 336*D1*Dd*f*g2*r**2 + 672*D1*Dd*f*g2*r*s - 504*D1*Dd*f*g2*r + 336*D1*Dd*f*g2*s**2 - 504*D1*Dd*f*g2*s + 252*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r**2 - 672*D1*Dd*f*gd2*r*s + 588*D1*Dd*f*gd2*r - 336*D1*Dd*f*gd2*s**2 + 588*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 336*D1*Dd*fd*g2*r**2 - 672*D1*Dd*fd*g2*r*s + 252*D1*Dd*fd*g2*r - 336*D1*Dd*fd*g2*s**2 + 252*D1*Dd*fd*g2*s + 36*D1*Ddd*K*f**2*r**2 + 72*D1*Ddd*K*f**2*r*s - 54*D1*Ddd*K*f**2*r + 36*D1*Ddd*K*f**2*s**2 - 54*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 + 200*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 300*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r**2 - 336*D1*Ddd*f*g2*r*s + 252*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s**2 + 252*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(15*f**2*(r + s - 1) - 15*f*fd*(2*r + 2*s - 1) - 14*f*(K - 1)*(r + s - 1) + 14*fd*(K - 1)*(r + s)) - Dd*f*(-14*K + 15*f + 14)*(4*r + 4*s - 3))*(r + s - 1) + 108*Dd**2*K*f**2*r**2 + 216*Dd**2*K*f**2*r*s - 162*Dd**2*K*f**2*r + 108*Dd**2*K*f**2*s**2 - 162*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 + 600*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 900*Dd**2*f**3*r + 600*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 300*Dd**2*f**3 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 504*Dd**2*f*g2*r**2 - 1008*Dd**2*f*g2*r*s + 756*Dd**2*f*g2*r - 504*Dd**2*f*g2*s**2 + 756*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(770*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**4*k2**4*st**4*(4*C - 4)*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(7*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**4*k2**4*st**2*(1260*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(-1616*C*D1**2*f*fd*r**2 - 2688*C*D1**2*f*fd*r*s + 1104*C*D1**2*f*fd*r - 1072*C*D1**2*f*fd*s**2 + 832*C*D1**2*f*fd*s - 416*C*D1**2*f*fd + 892*C*D1**2*f*fdd*r**2 + 1736*C*D1**2*f*fdd*r*s - 748*C*D1**2*f*fdd*r + 844*C*D1**2*f*fdd*s**2 - 724*C*D1**2*f*fdd*s + 362*C*D1**2*f*fdd + 892*C*D1**2*fd**2*r**2 + 1736*C*D1**2*fd**2*r*s - 748*C*D1**2*fd**2*r + 844*C*D1**2*fd**2*s**2 - 724*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 - 3232*C*D1*Dd*f**2*r**2 - 5376*C*D1*Dd*f**2*r*s + 4304*C*D1*Dd*f**2*r - 2144*C*D1*Dd*f**2*s**2 + 3488*C*D1*Dd*f**2*s - 1880*C*D1*Dd*f**2 + 7136*C*D1*Dd*f*fd*r**2 + 13888*C*D1*Dd*f*fd*r*s - 8248*C*D1*Dd*f*fd*r + 6752*C*D1*Dd*f*fd*s**2 - 8008*C*D1*Dd*f*fd*s + 2196*C*D1*Dd*f*fd + 1784*C*D1*Ddd*f**2*r**2 + 3472*C*D1*Ddd*f**2*r*s - 2628*C*D1*Ddd*f**2*r + 1688*C*D1*Ddd*f**2*s**2 - 2556*C*D1*Ddd*f**2*s + 1290*C*D1*Ddd*f**2 + 5352*C*Dd**2*f**2*r**2 + 10416*C*Dd**2*f**2*r*s - 7884*C*Dd**2*f**2*r + 5064*C*Dd**2*f**2*s**2 - 7668*C*Dd**2*f**2*s + 2580*C*Dd**2*f**2 - 140*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 1716*D1**2*f*fd*r**2 + 3008*D1**2*f*fd*r*s - 1264*D1**2*f*fd*r + 1292*D1**2*f*fd*s**2 - 1052*D1**2*f*fd*s + 526*D1**2*f*fd - 1082*D1**2*f*fdd*r**2 - 2176*D1**2*f*fdd*r*s + 968*D1**2*f*fdd*r - 1094*D1**2*f*fdd*s**2 + 974*D1**2*f*fdd*s - 487*D1**2*f*fdd - 1082*D1**2*fd**2*r**2 - 2176*D1**2*fd**2*r*s + 968*D1**2*fd**2*r - 1094*D1**2*fd**2*s**2 + 974*D1**2*fd**2*s + 120*D1**2*fd**2 + 3432*D1*Dd*f**2*r**2 + 6016*D1*Dd*f**2*r*s - 4724*D1*Dd*f**2*r + 2584*D1*Dd*f**2*s**2 - 4088*D1*Dd*f**2*s + 2150*D1*Dd*f**2 - 8656*D1*Dd*f*fd*r**2 - 17408*D1*Dd*f*fd*r*s + 10388*D1*Dd*f*fd*r - 8752*D1*Dd*f*fd*s**2 + 10448*D1*Dd*f*fd*s - 2916*D1*Dd*f*fd - 2164*D1*Ddd*f**2*r**2 - 4352*D1*Ddd*f**2*r*s + 3258*D1*Ddd*f**2*r - 2188*D1*Ddd*f**2*s**2 + 3276*D1*Ddd*f**2*s - 1635*D1*Ddd*f**2 + 280*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 6492*Dd**2*f**2*r**2 - 13056*Dd**2*f**2*r*s + 9774*Dd**2*f**2*r - 6564*Dd**2*f**2*s**2 + 9828*Dd**2*f**2*s - 3270*Dd**2*f**2) + f*(-17520*C*D1**2*f*fd*r**2 - 26688*C*D1**2*f*fd*r*s + 20576*C*D1**2*f*fd*r - 9168*C*D1**2*f*fd*s**2 + 15008*C*D1**2*f*fd*s - 8896*C*D1**2*f*fd + 10758*C*D1**2*f*fdd*r**2 + 17124*C*D1**2*f*fdd*r*s - 12880*C*D1**2*f*fdd*r + 6366*C*D1**2*f*fdd*s**2 - 9952*C*D1**2*f*fdd*s + 5708*C*D1**2*f*fdd + 21516*C*D1**2*fd**2*r**2 + 34248*C*D1**2*fd**2*r*s - 25760*C*D1**2*fd**2*r + 12732*C*D1**2*fd**2*s**2 - 19904*C*D1**2*fd**2*s + 5708*C*D1**2*fd**2 - 23360*C*D1*Dd*f**2*r**2 - 35584*C*D1*Dd*f**2*r*s + 29472*C*D1*Dd*f**2*r - 12224*C*D1*Dd*f**2*s**2 + 21120*C*D1*Dd*f**2*s - 11952*C*D1*Dd*f**2 + 86064*C*D1*Dd*f*fd*r**2 + 136992*C*D1*Dd*f*fd*r*s - 107284*C*D1*Dd*f*fd*r + 50928*C*D1*Dd*f*fd*s**2 - 82396*C*D1*Dd*f*fd*s + 32784*C*D1*Dd*f*fd + 14344*C*D1*Ddd*f**2*r**2 + 22832*C*D1*Ddd*f**2*r*s - 18588*C*D1*Ddd*f**2*r + 8488*C*D1*Ddd*f**2*s**2 - 14196*C*D1*Ddd*f**2*s + 7830*C*D1*Ddd*f**2 + 43032*C*Dd**2*f**2*r**2 + 68496*C*Dd**2*f**2*r*s - 55764*C*Dd**2*f**2*r + 25464*C*Dd**2*f**2*s**2 - 42588*C*Dd**2*f**2*s + 15660*C*Dd**2*f**2 - 2520*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(2*C*(223*r**2 + 434*r*s - 506*r + 211*s**2 - 494*s + 253) - 541*r**2 - 1088*r*s + 1202*r - 547*s**2 + 1208*s - 601) + 18222*D1**2*f*fd*r**2 + 29520*D1**2*f*fd*r*s - 21988*D1**2*f*fd*r + 11298*D1**2*f*fd*s**2 - 17372*D1**2*f*fd*s + 9840*D1**2*f*fd - 11703*D1**2*f*fdd*r**2 - 19944*D1**2*f*fdd*r*s + 14450*D1**2*f*fdd*r - 8241*D1**2*f*fdd*s**2 + 12142*D1**2*f*fdd*s - 6648*D1**2*f*fdd - 23406*D1**2*fd**2*r**2 - 39888*D1**2*fd**2*r*s + 28900*D1**2*fd**2*r - 16482*D1**2*fd**2*s**2 + 24284*D1**2*fd**2*s - 6648*D1**2*fd**2 + 24296*D1*Dd*f**2*r**2 + 39360*D1*Dd*f**2*r*s - 31828*D1*Dd*f**2*r + 15064*D1*Dd*f**2*s**2 - 24904*D1*Dd*f**2*s + 13606*D1*Dd*f**2 - 93624*D1*Dd*f*fd*r**2 - 159552*D1*Dd*f*fd*r*s + 121094*D1*Dd*f*fd*r - 65928*D1*Dd*f*fd*s**2 + 101476*D1*Dd*f*fd*s - 38734*D1*Dd*f*fd - 15604*D1*Ddd*f**2*r**2 - 26592*D1*Ddd*f**2*r*s + 21098*D1*Ddd*f**2*r - 10988*D1*Ddd*f**2*s**2 + 17636*D1*Ddd*f**2*s - 9395*D1*Ddd*f**2 - 18*D1*bd1*(D1*(f*(4*C*(101*r**2 + 8*r*(21*s - 29) + 67*s**2 - 198*s + 116) - 429*r**2 - 752*r*s + 978*r - 323*s**2 + 872*s - 489) + fd*(-2*C*(446*r**2 + 868*r*s - 693*r + 422*s**2 - 675*s + 247) + 1082*r**2 + 2176*r*s - 1686*r + 1094*s**2 - 1695*s + 604)) + Dd*f*(-2*C*(892*r**2 + 1736*r*s - 1669*r + 844*s**2 - 1627*s + 747) + 2164*r**2 + 4352*r*s - 4033*r + 2188*s**2 - 4054*s + 1809)) - 46812*Dd**2*f**2*r**2 - 79776*Dd**2*f**2*r*s + 63294*Dd**2*f**2*r - 32964*Dd**2*f**2*s**2 + 52908*Dd**2*f**2*s - 18790*Dd**2*f**2))/(630*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**4*k2**4*(16632*C*D1**2*bd1*f**2*r**2 + 16632*C*D1**2*bd1*f**2*r*s - 47124*C*D1**2*bd1*f**2*r - 30492*C*D1**2*bd1*f**2*s + 23562*C*D1**2*bd1*f**2 + 50490*C*D1**2*f**2*fd*r**2 + 65340*C*D1**2*f**2*fd*r*s - 55440*C*D1**2*f**2*fd*r + 14850*C*D1**2*f**2*fd*s**2 - 31680*C*D1**2*f**2*fd*s + 21780*C*D1**2*f**2*fd + 67320*C*D1*Dd*f**3*r**2 + 87120*C*D1*Dd*f**3*r*s - 77220*C*D1*Dd*f**3*r + 19800*C*D1*Dd*f**3*s**2 - 41580*C*D1*Dd*f**3*s + 26730*C*D1*Dd*f**3 + 17094*D1**2*K*bd1**2*f*r**2 + 34188*D1**2*K*bd1**2*f*r*s - 41118*D1**2*K*bd1**2*f*r + 17094*D1**2*K*bd1**2*f*s**2 - 41118*D1**2*K*bd1**2*f*s + 24024*D1**2*K*bd1**2*f - 24453*D1**2*K*bd1*f**2*r**2 - 32670*D1**2*K*bd1*f**2*r*s + 32670*D1**2*K*bd1*f**2*r - 8217*D1**2*K*bd1*f**2*s**2 + 16434*D1**2*K*bd1*f**2*s - 8217*D1**2*K*bd1*f**2 + 47520*D1**2*K*bd1*f*fd*r**2 + 79200*D1**2*K*bd1*f*fd*r*s - 63360*D1**2*K*bd1*f*fd*r + 31680*D1**2*K*bd1*f*fd*s**2 - 51480*D1**2*K*bd1*f*fd*s + 19800*D1**2*K*bd1*f*fd + 11880*D1**2*K*bdd1*f**2*r**2 + 19800*D1**2*K*bdd1*f**2*r*s - 19800*D1**2*K*bdd1*f**2*r + 7920*D1**2*K*bdd1*f**2*s**2 - 15840*D1**2*K*bdd1*f**2*s + 7920*D1**2*K*bdd1*f**2 - 39402*D1**2*bd1**2*f**2*r**2 - 81576*D1**2*bd1**2*f**2*r*s + 70290*D1**2*bd1**2*f**2*r - 42174*D1**2*bd1**2*f**2*s**2 + 73062*D1**2*bd1**2*f**2*s - 30888*D1**2*bd1**2*f**2 - 35112*D1**2*bd1**2*f*r**2 - 72996*D1**2*bd1**2*f*r*s + 78540*D1**2*bd1**2*f*r - 37884*D1**2*bd1**2*f*s**2 + 81312*D1**2*bd1**2*f*s - 43428*D1**2*bd1**2*f + 23100*D1**2*bd1**2*g2*r**2 + 46200*D1**2*bd1**2*g2*r*s - 23100*D1**2*bd1**2*g2*r + 23100*D1**2*bd1**2*g2*s**2 - 23100*D1**2*bd1**2*g2*s + 6930*D1**2*bd1*bd2*f*r**2 + 13860*D1**2*bd1*bd2*f*r*s - 13860*D1**2*bd1*bd2*f*r + 6930*D1**2*bd1*bd2*f*s**2 - 13860*D1**2*bd1*bd2*f*s + 6930*D1**2*bd1*bd2*f + 16280*D1**2*bd1*f**3*r**2 + 21450*D1**2*bd1*f**3*r*s - 16830*D1**2*bd1*f**3*r + 5170*D1**2*bd1*f**3*s**2 - 5720*D1**2*bd1*f**3*s + 7150*D1**2*bd1*f**3 - 69630*D1**2*bd1*f**2*fd*r**2 - 67320*D1**2*bd1*f**2*fd*r*s + 67430*D1**2*bd1*f**2*fd*r + 2310*D1**2*bd1*f**2*fd*s**2 + 7480*D1**2*bd1*f**2*fd*s + 1430*D1**2*bd1*f**2*fd + 10098*D1**2*bd1*f**2*r**2 + 22770*D1**2*bd1*f**2*r*s + 6336*D1**2*bd1*f**2*r + 12672*D1**2*bd1*f**2*s**2 + 3762*D1**2*bd1*f**2*s - 9504*D1**2*bd1*f**2 - 70092*D1**2*bd1*f*fd*r**2 - 131472*D1**2*bd1*f*fd*r*s + 100782*D1**2*bd1*f*fd*r - 61380*D1**2*bd1*f*fd*s**2 + 94248*D1**2*bd1*f*fd*s - 32868*D1**2*bd1*f*fd + 36498*D1**2*bd1*f*g2*r**2 + 45276*D1**2*bd1*f*g2*r*s - 100716*D1**2*bd1*f*g2*r + 8778*D1**2*bd1*f*g2*s**2 - 72996*D1**2*bd1*f*g2*s + 50358*D1**2*bd1*f*g2 - 34188*D1**2*bd1*f*gd2*r**2 - 68376*D1**2*bd1*f*gd2*r*s + 82236*D1**2*bd1*f*gd2*r - 34188*D1**2*bd1*f*gd2*s**2 + 82236*D1**2*bd1*f*gd2*s - 48048*D1**2*bd1*f*gd2 - 34188*D1**2*bd1*fd*g2*r**2 - 68376*D1**2*bd1*fd*g2*r*s + 34188*D1**2*bd1*fd*g2*r - 34188*D1**2*bd1*fd*g2*s**2 + 34188*D1**2*bd1*fd*g2*s - 4950*D1**2*bd2*f**2*r**2 - 9900*D1**2*bd2*f**2*r*s + 9900*D1**2*bd2*f**2*r - 4950*D1**2*bd2*f**2*s**2 + 9900*D1**2*bd2*f**2*s - 4950*D1**2*bd2*f**2 + 9900*D1**2*bd2*f*fd*r**2 + 19800*D1**2*bd2*f*fd*r*s - 14850*D1**2*bd2*f*fd*r + 9900*D1**2*bd2*f*fd*s**2 - 14850*D1**2*bd2*f*fd*s + 4950*D1**2*bd2*f*fd - 11605*D1**2*bdd1*f**3*r**2 - 11220*D1**2*bdd1*f**3*r*s + 10890*D1**2*bdd1*f**3*r + 385*D1**2*bdd1*f**3*s**2 - 1100*D1**2*bdd1*f**3*s - 5060*D1**2*bdd1*f**3 - 17523*D1**2*bdd1*f**2*r**2 - 32868*D1**2*bdd1*f**2*r*s + 32868*D1**2*bdd1*f**2*r - 15345*D1**2*bdd1*f**2*s**2 + 30690*D1**2*bdd1*f**2*s - 15345*D1**2*bdd1*f**2 - 17094*D1**2*bdd1*f*g2*r**2 - 34188*D1**2*bdd1*f*g2*r*s + 48048*D1**2*bdd1*f*g2*r - 17094*D1**2*bdd1*f*g2*s**2 + 48048*D1**2*bdd1*f*g2*s - 24024*D1**2*bdd1*f*g2 + 2475*D1**2*bdd2*f**2*r**2 + 4950*D1**2*bdd2*f**2*r*s - 4950*D1**2*bdd2*f**2*r + 2475*D1**2*bdd2*f**2*s**2 - 4950*D1**2*bdd2*f**2*s + 2475*D1**2*bdd2*f**2 - 31500*D1**2*f**3*fd*r**2 - 79240*D1**2*f**3*fd*r*s + 55370*D1**2*f**3*fd*r - 47740*D1**2*f**3*fd*s**2 + 67550*D1**2*f**3*fd*s - 31745*D1**2*f**3*fd + 27300*D1**2*f**3*fdd*r**2 + 84280*D1**2*f**3*fdd*r*s - 55790*D1**2*f**3*fdd*r + 56980*D1**2*f**3*fdd*s**2 - 78050*D1**2*f**3*fdd*s + 35315*D1**2*f**3*fdd + 81900*D1**2*f**2*fd**2*r**2 + 252840*D1**2*f**2*fd**2*r*s - 167370*D1**2*f**2*fd**2*r + 170940*D1**2*f**2*fd**2*s**2 - 234150*D1**2*f**2*fd**2*s + 70630*D1**2*f**2*fd**2 - 54945*D1**2*f**2*fd*r**2 - 77220*D1**2*f**2*fd*r*s + 62370*D1**2*f**2*fd*r - 22275*D1**2*f**2*fd*s**2 + 40590*D1**2*f**2*fd*s - 25740*D1**2*f**2*fd + 48906*D1**2*f**2*gd2*r**2 + 65340*D1**2*f**2*gd2*r*s - 65340*D1**2*f**2*gd2*r + 16434*D1**2*f**2*gd2*s**2 - 32868*D1**2*f**2*gd2*s + 16434*D1**2*f**2*gd2 - 23760*D1**2*f**2*gdd2*r**2 - 39600*D1**2*f**2*gdd2*r*s + 39600*D1**2*f**2*gdd2*r - 15840*D1**2*f**2*gdd2*s**2 + 31680*D1**2*f**2*gdd2*s - 15840*D1**2*f**2*gdd2 + 97812*D1**2*f*fd*g2*r**2 + 130680*D1**2*f*fd*g2*r*s - 97812*D1**2*f*fd*g2*r + 32868*D1**2*f*fd*g2*s**2 - 65340*D1**2*f*fd*g2*s + 48906*D1**2*f*fd*g2 - 95040*D1**2*f*fd*gd2*r**2 - 158400*D1**2*f*fd*gd2*r*s + 126720*D1**2*f*fd*gd2*r - 63360*D1**2*f*fd*gd2*s**2 + 102960*D1**2*f*fd*gd2*s - 39600*D1**2*f*fd*gd2 - 47520*D1**2*f*fdd*g2*r**2 - 79200*D1**2*f*fdd*g2*r*s + 47520*D1**2*f*fdd*g2*r - 31680*D1**2*f*fdd*g2*s**2 + 39600*D1**2*f*fdd*g2*s - 23760*D1**2*f*fdd*g2 - 47520*D1**2*fd**2*g2*r**2 - 79200*D1**2*fd**2*g2*r*s + 47520*D1**2*fd**2*g2*r - 31680*D1**2*fd**2*g2*s**2 + 39600*D1**2*fd**2*g2*s + 95040*D1*Dd*K*bd1*f**2*r**2 + 158400*D1*Dd*K*bd1*f**2*r*s - 142560*D1*Dd*K*bd1*f**2*r + 63360*D1*Dd*K*bd1*f**2*s**2 - 114840*D1*Dd*K*bd1*f**2*s + 51480*D1*Dd*K*bd1*f**2 - 92840*D1*Dd*bd1*f**3*r**2 - 89760*D1*Dd*bd1*f**3*r*s + 89210*D1*Dd*bd1*f**3*r + 3080*D1*Dd*bd1*f**3*s**2 + 5280*D1*Dd*bd1*f**3*s - 8690*D1*Dd*bd1*f**3 - 140184*D1*Dd*bd1*f**2*r**2 - 262944*D1*Dd*bd1*f**2*r*s + 232254*D1*Dd*bd1*f**2*r - 122760*D1*Dd*bd1*f**2*s**2 + 217008*D1*Dd*bd1*f**2*s - 94248*D1*Dd*bd1*f**2 - 136752*D1*Dd*bd1*f*g2*r**2 - 273504*D1*Dd*bd1*f*g2*r*s + 294756*D1*Dd*bd1*f*g2*r - 136752*D1*Dd*bd1*f*g2*s**2 + 294756*D1*Dd*bd1*f*g2*s - 144144*D1*Dd*bd1*f*g2 + 19800*D1*Dd*bd2*f**2*r**2 + 39600*D1*Dd*bd2*f**2*r*s - 34650*D1*Dd*bd2*f**2*r + 19800*D1*Dd*bd2*f**2*s**2 - 34650*D1*Dd*bd2*f**2*s + 14850*D1*Dd*bd2*f**2 - 31500*D1*Dd*f**4*r**2 - 79240*D1*Dd*f**4*r*s + 55370*D1*Dd*f**4*r - 47740*D1*Dd*f**4*s**2 + 67550*D1*Dd*f**4*s - 31745*D1*Dd*f**4 + 218400*D1*Dd*f**3*fd*r**2 + 674240*D1*Dd*f**3*fd*r*s - 446320*D1*Dd*f**3*fd*r + 455840*D1*Dd*f**3*fd*s**2 - 624400*D1*Dd*f**3*fd*s + 211890*D1*Dd*f**3*fd - 73260*D1*Dd*f**3*r**2 - 102960*D1*Dd*f**3*r*s + 88110*D1*Dd*f**3*r - 29700*D1*Dd*f**3*s**2 + 55440*D1*Dd*f**3*s - 33165*D1*Dd*f**3 + 195624*D1*Dd*f**2*g2*r**2 + 261360*D1*Dd*f**2*g2*r*s - 228492*D1*Dd*f**2*g2*r + 65736*D1*Dd*f**2*g2*s**2 - 131076*D1*Dd*f**2*g2*s + 81774*D1*Dd*f**2*g2 - 190080*D1*Dd*f**2*gd2*r**2 - 316800*D1*Dd*f**2*gd2*r*s + 285120*D1*Dd*f**2*gd2*r - 126720*D1*Dd*f**2*gd2*s**2 + 229680*D1*Dd*f**2*gd2*s - 102960*D1*Dd*f**2*gd2 - 380160*D1*Dd*f*fd*g2*r**2 - 633600*D1*Dd*f*fd*g2*r*s + 443520*D1*Dd*f*fd*g2*r - 253440*D1*Dd*f*fd*g2*s**2 + 364320*D1*Dd*f*fd*g2*s - 126720*D1*Dd*f*fd*g2 + 27300*D1*Ddd*f**4*r**2 + 84280*D1*Ddd*f**4*r*s - 55790*D1*Ddd*f**4*r + 56980*D1*Ddd*f**4*s**2 - 78050*D1*Ddd*f**4*s + 35315*D1*Ddd*f**4 - 95040*D1*Ddd*f**2*g2*r**2 - 158400*D1*Ddd*f**2*g2*r*s + 126720*D1*Ddd*f**2*g2*r - 63360*D1*Ddd*f**2*g2*s**2 + 102960*D1*Ddd*f**2*g2*s - 55440*D1*Ddd*f**2*g2 + 81900*Dd**2*f**4*r**2 + 252840*Dd**2*f**4*r*s - 167370*Dd**2*f**4*r + 170940*Dd**2*f**4*s**2 - 234150*Dd**2*f**4*s + 70630*Dd**2*f**4 - 285120*Dd**2*f**2*g2*r**2 - 475200*Dd**2*f**2*g2*r*s + 380160*Dd**2*f**2*g2*r - 190080*Dd**2*f**2*g2*s**2 + 308880*Dd**2*f**2*g2*s - 110880*Dd**2*f**2*g2 - 1155*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (5*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-5*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1**2*(350*C*D1**2*fd*r**2 + 700*C*D1**2*fd*r*s - 700*C*D1**2*fd*r + 350*C*D1**2*fd*s**2 - 700*C*D1**2*fd*s + 350*C*D1**2*fd + 1400*C*D1*Dd*f*r**2 + 2800*C*D1*Dd*f*r*s - 2100*C*D1*Dd*f*r + 1400*C*D1*Dd*f*s**2 - 2100*C*D1*Dd*f*s + 1050*C*D1*Dd*f + 553*D1**2*K*fd*r**2 + 686*D1**2*K*fd*r*s + 420*D1**2*K*fd*r + 133*D1**2*K*fd*s**2 + 420*D1**2*K*fd*s - 210*D1**2*K*fd - 259*D1**2*K*fdd*r**2 - 518*D1**2*K*fdd*r*s - 210*D1**2*K*fdd*r - 259*D1**2*K*fdd*s**2 - 210*D1**2*K*fdd*s + 105*D1**2*K*fdd - 35*D1**2*bdd1*(-5*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 1170*D1**2*f*fd*r**2 - 2424*D1**2*f*fd*r*s + 1392*D1**2*f*fd*r - 1254*D1**2*f*fd*s**2 + 1434*D1**2*f*fd*s - 717*D1**2*f*fd + 1194*D1**2*f*fdd*r**2 + 2472*D1**2*f*fdd*r*s - 1536*D1**2*f*fdd*r + 1278*D1**2*f*fdd*s**2 - 1578*D1**2*f*fdd*s + 789*D1**2*f*fdd + 1194*D1**2*fd**2*r**2 + 2472*D1**2*fd**2*r*s - 1536*D1**2*fd**2*r + 1278*D1**2*fd**2*s**2 - 1578*D1**2*fd**2*s + 300*D1**2*fd**2 - 1099*D1**2*fd*r**2 - 1862*D1**2*fd*r*s + 280*D1**2*fd*r - 763*D1**2*fd*s**2 + 280*D1**2*fd*s - 140*D1**2*fd + 532*D1**2*fdd*r**2 + 1106*D1**2*fdd*r*s + 210*D1**2*fdd*r + 574*D1**2*fdd*s**2 + 210*D1**2*fdd*s - 105*D1**2*fdd + 700*D1**2*gd2*r**2 + 1400*D1**2*gd2*r*s - 1400*D1**2*gd2*r + 700*D1**2*gd2*s**2 - 1400*D1**2*gd2*s + 700*D1**2*gd2 - 350*D1**2*gdd2*r**2 - 700*D1**2*gdd2*r*s + 700*D1**2*gdd2*r - 350*D1**2*gdd2*s**2 + 700*D1**2*gdd2*s - 350*D1**2*gdd2 + 2212*D1*Dd*K*f*r**2 + 2744*D1*Dd*K*f*r*s - 2478*D1*Dd*K*f*r + 532*D1*Dd*K*f*s**2 - 1218*D1*Dd*K*f*s + 819*D1*Dd*K*f - 2072*D1*Dd*K*fd*r**2 - 4144*D1*Dd*K*fd*r*s + 714*D1*Dd*K*fd*r - 2072*D1*Dd*K*fd*s**2 + 714*D1*Dd*K*fd*s + 630*D1*Dd*K*fd - 2340*D1*Dd*f**2*r**2 - 4848*D1*Dd*f**2*r*s + 3594*D1*Dd*f**2*r - 2508*D1*Dd*f**2*s**2 + 3720*D1*Dd*f**2*s - 1839*D1*Dd*f**2 + 9552*D1*Dd*f*fd*r**2 + 19776*D1*Dd*f*fd*r*s - 13476*D1*Dd*f*fd*r + 10224*D1*Dd*f*fd*s**2 - 13896*D1*Dd*f*fd*s + 4692*D1*Dd*f*fd - 4396*D1*Dd*f*r**2 - 7448*D1*Dd*f*r*s + 5922*D1*Dd*f*r - 3052*D1*Dd*f*s**2 + 4914*D1*Dd*f*s - 2625*D1*Dd*f + 4256*D1*Dd*fd*r**2 + 8848*D1*Dd*fd*r*s - 2436*D1*Dd*fd*r + 4592*D1*Dd*fd*s**2 - 2562*D1*Dd*fd*s - 630*D1*Dd*fd + 2800*D1*Dd*g2*r**2 + 5600*D1*Dd*g2*r*s - 4200*D1*Dd*g2*r + 2800*D1*Dd*g2*s**2 - 4200*D1*Dd*g2*s + 2100*D1*Dd*g2 - 2800*D1*Dd*gd2*r**2 - 5600*D1*Dd*gd2*r*s + 4900*D1*Dd*gd2*r - 2800*D1*Dd*gd2*s**2 + 4900*D1*Dd*gd2*s - 2100*D1*Dd*gd2 - 1036*D1*Ddd*K*f*r**2 - 2072*D1*Ddd*K*f*r*s + 1554*D1*Ddd*K*f*r - 1036*D1*Ddd*K*f*s**2 + 1554*D1*Ddd*K*f*s - 777*D1*Ddd*K*f + 2388*D1*Ddd*f**2*r**2 + 4944*D1*Ddd*f**2*r*s - 3666*D1*Ddd*f**2*r + 2556*D1*Ddd*f**2*s**2 - 3792*D1*Ddd*f**2*s + 1875*D1*Ddd*f**2 + 2128*D1*Ddd*f*r**2 + 4424*D1*Ddd*f*r*s - 3276*D1*Ddd*f*r + 2296*D1*Ddd*f*s**2 - 3402*D1*Ddd*f*s + 1680*D1*Ddd*f - 1400*D1*Ddd*g2*r**2 - 2800*D1*Ddd*g2*r*s + 2100*D1*Ddd*g2*r - 1400*D1*Ddd*g2*s**2 + 2100*D1*Ddd*g2*s - 1050*D1*Ddd*g2 + 70*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (5*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-5*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 3108*Dd**2*K*f*r**2 - 6216*Dd**2*K*f*r*s + 4662*Dd**2*K*f*r - 3108*Dd**2*K*f*s**2 + 4662*Dd**2*K*f*s - 1554*Dd**2*K*f + 7164*Dd**2*f**2*r**2 + 14832*Dd**2*f**2*r*s - 10998*Dd**2*f**2*r + 7668*Dd**2*f**2*s**2 - 11376*Dd**2*f**2*s + 3750*Dd**2*f**2 + 6384*Dd**2*f*r**2 + 13272*Dd**2*f*r*s - 9828*Dd**2*f*r + 6888*Dd**2*f*s**2 - 10206*Dd**2*f*s + 3360*Dd**2*f - 4200*Dd**2*g2*r**2 - 8400*Dd**2*g2*r*s + 6300*Dd**2*g2*r - 4200*Dd**2*g2*s**2 + 6300*Dd**2*g2*s - 2100*Dd**2*g2) + 11*b1*(3024*C*D1**2*f*fd*r**2 + 3024*C*D1**2*f*fd*r*s - 252*C*D1**2*f*fd*r + 1260*C*D1**2*f*fd*s - 630*C*D1**2*f*fd + 6048*C*D1*Dd*f**2*r**2 + 6048*C*D1*Dd*f**2*r*s - 6048*C*D1*Dd*f**2*r - 1512*C*D1*Dd*f**2*s + 1512*C*D1*Dd*f**2 + 1554*D1**2*K*bdd1*f*r**2 + 3108*D1**2*K*bdd1*f*r*s - 3738*D1**2*K*bdd1*f*r + 1554*D1**2*K*bdd1*f*s**2 - 3738*D1**2*K*bdd1*f*s + 1869*D1**2*K*bdd1*f - 4446*D1**2*K*f*fd*r**2 - 5940*D1**2*K*f*fd*r*s + 4446*D1**2*K*f*fd*r - 1494*D1**2*K*f*fd*s**2 + 2970*D1**2*K*f*fd*s - 2223*D1**2*K*f*fd + 2160*D1**2*K*f*fdd*r**2 + 3600*D1**2*K*f*fdd*r*s - 2160*D1**2*K*f*fdd*r + 1440*D1**2*K*f*fdd*s**2 - 1800*D1**2*K*f*fdd*s + 1080*D1**2*K*f*fdd + 2160*D1**2*K*fd**2*r**2 + 3600*D1**2*K*fd**2*r*s - 2160*D1**2*K*fd**2*r + 1440*D1**2*K*fd**2*s**2 - 1800*D1**2*K*fd**2*s - 630*D1**2*b2*fd*r**2 - 1260*D1**2*b2*fd*r*s - 630*D1**2*b2*fd*s**2 + 315*D1**2*b2*fdd*r**2 + 630*D1**2*b2*fdd*r*s + 315*D1**2*b2*fdd*s**2 + 210*D1**2*bd1**2*(-5*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 3582*D1**2*bdd1*f**2*r**2 - 7416*D1**2*bdd1*f**2*r*s + 6390*D1**2*bdd1*f**2*r - 3834*D1**2*bdd1*f**2*s**2 + 6642*D1**2*bdd1*f**2*s - 3258*D1**2*bdd1*f**2 - 3192*D1**2*bdd1*f*r**2 - 6636*D1**2*bdd1*f*r*s + 7140*D1**2*bdd1*f*r - 3444*D1**2*bdd1*f*s**2 + 7392*D1**2*bdd1*f*s - 3633*D1**2*bdd1*f + 2100*D1**2*bdd1*g2*r**2 + 4200*D1**2*bdd1*g2*r*s - 2100*D1**2*bdd1*g2*r + 2100*D1**2*bdd1*g2*s**2 - 2100*D1**2*bdd1*g2*s + 1050*D1**2*bdd1*g2 + 315*D1**2*bdd2*f*r**2 + 630*D1**2*bdd2*f*r*s - 630*D1**2*bdd2*f*r + 315*D1**2*bdd2*f*s**2 - 630*D1**2*bdd2*f*s + 315*D1**2*bdd2*f + 4440*D1**2*f**2*fd*r**2 + 5850*D1**2*f**2*fd*r*s - 5330*D1**2*f**2*fd*r + 1410*D1**2*f**2*fd*s**2 - 3310*D1**2*f**2*fd*s + 1770*D1**2*f**2*fd - 3165*D1**2*f**2*fdd*r**2 - 3060*D1**2*f**2*fdd*r*s + 3160*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 + 980*D1**2*f**2*fdd*s - 525*D1**2*f**2*fdd - 6330*D1**2*f*fd**2*r**2 - 6120*D1**2*f*fd**2*r*s + 6320*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 + 1960*D1**2*f*fd**2*s - 2100*D1**2*f*fd**2 + 1836*D1**2*f*fd*r**2 + 4140*D1**2*f*fd*r*s - 4482*D1**2*f*fd*r + 2304*D1**2*f*fd*s**2 - 4716*D1**2*f*fd*s + 2934*D1**2*f*fd - 3186*D1**2*f*fdd*r**2 - 5976*D1**2*f*fdd*r*s + 3186*D1**2*f*fdd*r - 2790*D1**2*f*fdd*s**2 + 2988*D1**2*f*fdd*s - 1593*D1**2*f*fdd + 3318*D1**2*f*gd2*r**2 + 4116*D1**2*f*gd2*r*s - 4116*D1**2*f*gd2*r + 798*D1**2*f*gd2*s**2 - 1596*D1**2*f*gd2*s + 798*D1**2*f*gd2 - 1554*D1**2*f*gdd2*r**2 - 3108*D1**2*f*gdd2*r*s + 3108*D1**2*f*gdd2*r - 1554*D1**2*f*gdd2*s**2 + 3108*D1**2*f*gdd2*s - 1554*D1**2*f*gdd2 - 3186*D1**2*fd**2*r**2 - 5976*D1**2*fd**2*r*s + 3186*D1**2*fd**2*r - 2790*D1**2*fd**2*s**2 + 2988*D1**2*fd**2*s + 3318*D1**2*fd*g2*r**2 + 4116*D1**2*fd*g2*r*s + 2520*D1**2*fd*g2*r + 798*D1**2*fd*g2*s**2 + 2520*D1**2*fd*g2*s - 1260*D1**2*fd*g2 - 3108*D1**2*fd*gd2*r**2 - 6216*D1**2*fd*gd2*r*s + 1848*D1**2*fd*gd2*r - 3108*D1**2*fd*gd2*s**2 + 1848*D1**2*fd*gd2*s + 1260*D1**2*fd*gd2 - 1554*D1**2*fdd*g2*r**2 - 3108*D1**2*fdd*g2*r*s - 1260*D1**2*fdd*g2*r - 1554*D1**2*fdd*g2*s**2 - 1260*D1**2*fdd*g2*s + 630*D1**2*fdd*g2 - 8892*D1*Dd*K*f**2*r**2 - 11880*D1*Dd*K*f**2*r*s + 10386*D1*Dd*K*f**2*r - 2988*D1*Dd*K*f**2*s**2 + 5958*D1*Dd*K*f**2*s - 3717*D1*Dd*K*f**2 + 17280*D1*Dd*K*f*fd*r**2 + 28800*D1*Dd*K*f*fd*r*s - 20160*D1*Dd*K*f*fd*r + 11520*D1*Dd*K*f*fd*s**2 - 16560*D1*Dd*K*f*fd*s + 5760*D1*Dd*K*f*fd - 2520*D1*Dd*b2*f*r**2 - 5040*D1*Dd*b2*f*r*s + 3780*D1*Dd*b2*f*r - 2520*D1*Dd*b2*f*s**2 + 3780*D1*Dd*b2*f*s - 1890*D1*Dd*b2*f + 2520*D1*Dd*b2*fd*r**2 + 5040*D1*Dd*b2*fd*r*s - 1890*D1*Dd*b2*fd*r + 2520*D1*Dd*b2*fd*s**2 - 1890*D1*Dd*b2*fd*s + 5920*D1*Dd*f**3*r**2 + 7800*D1*Dd*f**3*r*s - 6860*D1*Dd*f**3*r + 1880*D1*Dd*f**3*s**2 - 3830*D1*Dd*f**3*s + 2420*D1*Dd*f**3 - 25320*D1*Dd*f**2*fd*r**2 - 24480*D1*Dd*f**2*fd*r*s + 25090*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 + 6560*D1*Dd*f**2*fd*s - 5120*D1*Dd*f**2*fd + 3672*D1*Dd*f**2*r**2 + 8280*D1*Dd*f**2*r*s - 5976*D1*Dd*f**2*r + 4608*D1*Dd*f**2*s**2 - 6678*D1*Dd*f**2*s + 3222*D1*Dd*f**2 - 25488*D1*Dd*f*fd*r**2 - 47808*D1*Dd*f*fd*r*s + 31068*D1*Dd*f*fd*r - 22320*D1*Dd*f*fd*s**2 + 29088*D1*Dd*f*fd*s - 9162*D1*Dd*f*fd + 13272*D1*Dd*f*g2*r**2 + 16464*D1*Dd*f*g2*r*s - 14868*D1*Dd*f*g2*r + 3192*D1*Dd*f*g2*s**2 - 7308*D1*Dd*f*g2*s + 4914*D1*Dd*f*g2 - 12432*D1*Dd*f*gd2*r**2 - 24864*D1*Dd*f*gd2*r*s + 21756*D1*Dd*f*gd2*r - 12432*D1*Dd*f*gd2*s**2 + 21756*D1*Dd*f*gd2*s - 9324*D1*Dd*f*gd2 - 12432*D1*Dd*fd*g2*r**2 - 24864*D1*Dd*fd*g2*r*s + 4284*D1*Dd*fd*g2*r - 12432*D1*Dd*fd*g2*s**2 + 4284*D1*Dd*fd*g2*s + 3780*D1*Dd*fd*g2 + 4320*D1*Ddd*K*f**2*r**2 + 7200*D1*Ddd*K*f**2*r*s - 5760*D1*Ddd*K*f**2*r + 2880*D1*Ddd*K*f**2*s**2 - 4680*D1*Ddd*K*f**2*s + 2520*D1*Ddd*K*f**2 + 1260*D1*Ddd*b2*f*r**2 + 2520*D1*Ddd*b2*f*r*s - 1890*D1*Ddd*b2*f*r + 1260*D1*Ddd*b2*f*s**2 - 1890*D1*Ddd*b2*f*s + 945*D1*Ddd*b2*f - 4220*D1*Ddd*f**3*r**2 - 4080*D1*Ddd*f**3*r*s + 4150*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 + 880*D1*Ddd*f**3*s - 985*D1*Ddd*f**3 - 6372*D1*Ddd*f**2*r**2 - 11952*D1*Ddd*f**2*r*s + 9162*D1*Ddd*f**2*r - 5580*D1*Ddd*f**2*s**2 + 8568*D1*Ddd*f**2*s - 4383*D1*Ddd*f**2 - 6216*D1*Ddd*f*g2*r**2 - 12432*D1*Ddd*f*g2*r*s + 9324*D1*Ddd*f*g2*r - 6216*D1*Ddd*f*g2*s**2 + 9324*D1*Ddd*f*g2*s - 4662*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(3*f**2*(195*r**2 + r*(404*s - 367) + 209*s**2 - 381*s + 187) - f*(175*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(79*r**2 + 98*r*s - 158*r + 19*s**2 - 98*s + 64) + 3*fd*(796*r**2 + 2*r*(824*s - 611) + 852*s**2 - 1264*s + 419) - 1099*r**2 - 1862*r*s + 1890*r - 763*s**2 + 1554*s - 861) + 7*fd*(K*(74*r**2 + 148*r*s - 59*r + 74*s**2 - 59*s - 15) - 152*r**2 - 316*r*s + 140*r - 164*s**2 + 146*s + 15) - 350*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 350*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + Dd*(-3*f**2*(1592*r**2 + r*(3296*s - 2642) + 1704*s**2 - 2740*s + 1093) + 7*f*(K*(296*r**2 + 592*r*s - 578*r + 296*s**2 - 578*s + 267) - 608*r**2 - 1264*r*s + 1148*r - 656*s**2 + 1190*s - 522) + 350*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 630*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 12960*Dd**2*K*f**2*r**2 + 21600*Dd**2*K*f**2*r*s - 17280*Dd**2*K*f**2*r + 8640*Dd**2*K*f**2*s**2 - 14040*Dd**2*K*f**2*s + 5040*Dd**2*K*f**2 + 3780*Dd**2*b2*f*r**2 + 7560*Dd**2*b2*f*r*s - 5670*Dd**2*b2*f*r + 3780*Dd**2*b2*f*s**2 - 5670*Dd**2*b2*f*s + 1890*Dd**2*b2*f - 12660*Dd**2*f**3*r**2 - 12240*Dd**2*f**3*r*s + 12450*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 + 2640*Dd**2*f**3*s - 1970*Dd**2*f**3 - 19116*Dd**2*f**2*r**2 - 35856*Dd**2*f**2*r*s + 27486*Dd**2*f**2*r - 16740*Dd**2*f**2*s**2 + 25704*Dd**2*f**2*s - 8766*Dd**2*f**2 - 18648*Dd**2*f*g2*r**2 - 37296*Dd**2*f*g2*r*s + 27972*Dd**2*f*g2*r - 18648*Dd**2*f*g2*s**2 + 27972*Dd**2*f*g2*s - 9324*Dd**2*f*g2) - 495*b2*(-7*D1**2*bdd1*f*(r + s - 1)**2 + 5*D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 5*D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(6930*d**2*k3**5) + 2*D1**2*Pk1*Pkd3*ct**4*k2**2*st**2*(84*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 3*b1*(D1**2*(f*(-28*bdd1*s*(C - 1)*(2*r + 2*s - 1) - 4*fd*(3*C*(6*r*s - 3*r + 6*s**2 - 4*s + 3) - 26*r*s + 13*r - 26*s**2 + 20*s - 13) + 3*fdd*(2*C*(6*r*s - 3*r + 6*s**2 - 4*s + 3) - 22*r*s + 11*r - 22*s**2 + 18*s - 11)) + 3*fd**2*(2*C*(r*(6*s - 3) + 6*s**2 - 4*s - 2) + r*(11 - 22*s) - 22*s**2 + 18*s + 4)) - 28*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(52 - 36*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + 3*fd*(2*s - 1)*(C*(48*r + 48*s - 22) - 88*r - 88*s + 47)) + Ddd*f*(18*C - 33)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(18*C - 33)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-84*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1**2*(f*(9*bdd1*s*(2*C*(3*r + 3*s - 5) - 11*r - 11*s + 15) + fd*(132 - 100*C)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(50*C - 75)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(50*C - 75)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 3*D1*bd1*(D1*(4*f*s*(3*C*(3*r + 3*s - 5) - 13*r - 13*s + 19) - 3*fd*(2*C*(12*r*s - 3*r + 12*s**2 - 14*s + 5) - 44*r*s + 11*r - 44*s**2 + 48*s - 15)) - 3*Dd*f*(2*C*(24*r*s - 6*r + 24*s**2 - 35*s + 10) - 88*r*s + 22*r - 88*s**2 + 115*s - 30)) + D1*f*(Dd*(f*(132 - 100*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(50*C - 75)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(50*C - 75)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(50*C - 75)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**4*k2**2*(-7*b1**2*(D1**2*(fd*(10*C*(5*r + 9*s - 9) - 34*r - 86*s + 86) + fdd*(-40*C*(r + 2*s - 2) + 37*r + 83*s - 83))*(r + s - 1) + D1*(2*Dd*(f*(5*C*(20*r**2 + 56*r*s - 38*r + 36*s**2 - 50*s + 23) - 68*r**2 - 240*r*s + 154*r - 172*s**2 + 232*s - 103) + fd*(-20*C*(8*r**2 + 4*r*(6*s - 5) + 16*s**2 - 27*s + 11) + 148*r**2 + 480*r*s - 397*r + 332*s**2 - 558*s + 226)) + Ddd*f*(-40*C*(4*r**2 + 12*r*s - 8*r + 8*s**2 - 11*s + 5) + 148*r**2 + 480*r*s - 314*r + 332*s**2 - 452*s + 203)) - 2*Dd**2*f*(20*C*(12*r**2 + 36*r*s - 24*r + 24*s**2 - 33*s + 10) - 222*r**2 - 720*r*s + 471*r - 498*s**2 + 678*s - 203)) - b1*(-7*D1**2*bdd1*f*(40*C*(2*r**2 + r*(6*s - 2) + 4*s**2 - 3*s + 1) - 74*r**2 + r*(74 - 240*s) - 166*s**2 + 120*s - 37) + 3*D1**2*(f*(fd*(2*C*(140*r**2 + 2*r*(64*s - 123) - 12*s**2 - 150*s + 85) - 166*r**2 + 4*r*(28*s + 57) + 278*s**2 + 2*s - 3) - fdd*(2*C*(42*r**2 + 2*r*(18*s - 65) - 6*s**2 - 110*s + 53) - 48*r**2 + 4*r*(49*s + 25) + 244*s**2 - 20*s + 23)) - 4*fd**2*(C*(21*r**2 + r*(18*s - 65) - 3*s**2 - 55*s + 58) - 12*r**2 + r*(49*s + 25) + 61*s**2 - 5*s - 56)) + 14*D1*bd1*(D1*(f*(5*C*(10*r**2 + 28*r*s - 10*r + 18*s**2 - 14*s + 5) - 34*r**2 - 120*r*s + 34*r - 86*s**2 + 60*s - 17) + fd*(-20*C*(4*r**2 + 12*r*s - 8*r + 8*s**2 - 11*s + 3) + 74*r**2 + 240*r*s - 157*r + 166*s**2 - 226*s + 60)) + Dd*f*(-40*C*(8*r**2 + 24*r*s - 12*r + 16*s**2 - 17*s + 4) + 296*r**2 + 960*r*s - 462*r + 664*s**2 - 692*s + 157)) + 3*D1*f*(Dd*(f*(4*C*(140*r**2 + 2*r*(64*s - 67) - 12*s**2 - 20*s + 29) - 332*r**2 + 224*r*s + 54*r + 556*s**2 - 612*s + 195) - 4*fd*(C*(168*r**2 + 144*r*s - 338*r - 24*s**2 - 226*s + 175) - 96*r**2 + 392*r*s + 26*r + 488*s**2 - 313*s - 15)) - 2*Ddd*f*(3*C*(28*r**2 + 24*r*s - 26*r - 4*s**2 - 2*s + 5) - 48*r**2 + 196*r*s - 74*r + 244*s**2 - 293*s + 110)) + 6*Dd**2*f**2*(-6*C*(42*r**2 + r*(36*s - 39) - 6*s**2 - 3*s + 5) + 144*r**2 - 6*r*(98*s - 37) - 732*s**2 + 879*s - 220)) + f*(14*D1**2*bd1**2*(r**2*(40*C - 37) + r*(40*C*(3*s - 1) - 120*s + 37) + s*(20*C*(4*s - 3) - 83*s + 60)) + 3*D1**2*bdd1*f*(2*C*(21*r**2 + 2*r*(9*s + 35) - 3*s**2 + 98*s - 35) - 24*r**2 + 2*r*(49*s - 75) + 122*s**2 - 322*s + 75) + 5*D1**2*(f*(fd*(2*C*(75*r**2 + 6*r*(29*s - 18) + 99*s**2 - 124*s + 58) - 165*r**2 - 11*r*(48*s - 26) - 363*s**2 + 418*s - 176) + fdd*(-2*C*(69*r**2 + 150*r*s - 96*r + 81*s**2 - 104*s + 50) + 141*r**2 + 462*r*s - 248*r + 321*s**2 - 368*s + 154)) + 2*fd**2*(-2*C*(69*r**2 + 150*r*s - 96*r + 81*s**2 - 104*s + 25) + 141*r**2 + 462*r*s - 248*r + 321*s**2 - 368*s + 77)) - 3*D1*bd1*(D1*(f*(2*C*(70*r**2 + r*(64*s + 42) - 6*s**2 + 98*s - 21) - 83*r**2 + 2*r*(28*s - 59) + 139*s**2 - 336*s + 59) - 2*fd*(2*C*(42*r**2 + r*(36*s + 5) - 6*s**2 + 43*s - 49) - 48*r**2 + 4*r*(49*s - 25) + 244*s**2 - 332*s + 161)) - 2*Dd*f*(2*C*(84*r**2 + r*(72*s + 101) - 12*s**2 + 193*s - 133) - 96*r**2 + r*(392*s - 374) + 488*s**2 - 937*s + 397)) + 5*D1*f*(Dd*(f*(2*C*(100*r**2 + 232*r*s - 166*r + 132*s**2 - 190*s + 91) - 220*r**2 - 704*r*s + 462*r - 484*s**2 + 660*s - 297) - 2*fd*(2*C*(276*r**2 + 600*r*s - 411*r + 324*s**2 - 445*s + 152) - 564*r**2 - 1848*r*s + 1099*r - 1284*s**2 + 1609*s - 492)) + Ddd*f*(-2*C*(92*r**2 + 200*r*s - 146*r + 108*s**2 - 158*s + 77) + 188*r**2 + 616*r*s - 402*r + 428*s**2 - 582*s + 261)) - 10*Dd**2*f**2*(2*C*(138*r**2 + 300*r*s - 219*r + 162*s**2 - 237*s + 77) - 282*r**2 - 924*r*s + 603*r - 642*s**2 + 873*s - 261)))/(210*d**2*k3**3) - 2*D1**2*Pk1*Pkd3*ct**4*(-3*D1*f*(14*D1*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1*bd1*(-f*s*(20*C - 13)*(r + s) + fd*(10*C - 10)*(r*(4*s - 1) + s*(4*s - 3))) + 10*D1*bdd1*f*s*(C - 1)*(r + s) + 10*Dd*bd1*f*(C - 1)*(r*(8*s - 2) + s*(8*s - 5))) + 7*b1**2*(D1**2*(s - 1)*(fd*(12*C - 7) - fdd*(6*C - 6))*(r + s - 1) + D1*(Dd*(f*(12*C - 7)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(6*C - 6)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(6 - 6*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(6*C - 6)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(3*D1**2*(f*fd*(20*C - 13)*(2*s - 1)*(r + s - 1) - f*(2*C - 2)*(7*bdd1*s*(2*r + 2*s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) - fd**2*(10*C - 10)*(2*s - 1)*(r + s - 1)) + 7*D1*bd1*(D1*(f*s*(12*C - 7)*(2*r + 2*s - 1) - fd*(6*C - 6)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(12 - 12*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + 3*D1*f*(Dd*(f*(20*C - 13)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(10 - 10*C)*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(10 - 10*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 3*Dd**2*f**2*(10 - 10*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3) - D1**2*Pk1*Pkd3*ct**4*k2**4*st**2*(324*D1**2*b1*f*fd*r**2 + 324*D1**2*b1*f*fd*r*s - 162*D1**2*b1*f*fd*r + 90*D1**2*b1*f*fdd*r**2 + 90*D1**2*b1*f*fdd*r*s - 45*D1**2*b1*f*fdd*r + 90*D1**2*b1*fd**2*r**2 + 90*D1**2*b1*fd**2*r*s - 45*D1**2*b1*fd**2*r + 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 438*D1**2*f**2*fd*r**2 + 438*D1**2*f**2*fd*r*s - 438*D1**2*f**2*fd*r - 146*D1**2*f**2*fd*s + 146*D1**2*f**2*fd - 165*D1**2*f**2*fdd*r**2 - 165*D1**2*f**2*fdd*r*s + 165*D1**2*f**2*fdd*r + 55*D1**2*f**2*fdd*s - 55*D1**2*f**2*fdd - 330*D1**2*f*fd**2*r**2 - 330*D1**2*f*fd**2*r*s + 330*D1**2*f*fd**2*r + 110*D1**2*f*fd**2*s - 55*D1**2*f*fd**2 + 648*D1*Dd*b1*f**2*r**2 + 648*D1*Dd*b1*f**2*r*s - 648*D1*Dd*b1*f**2*r - 162*D1*Dd*b1*f**2*s + 162*D1*Dd*b1*f**2 + 720*D1*Dd*b1*f*fd*r**2 + 720*D1*Dd*b1*f*fd*r*s - 540*D1*Dd*b1*f*fd*r - 90*D1*Dd*b1*f*fd*s + 45*D1*Dd*b1*f*fd + 584*D1*Dd*f**3*r**2 + 584*D1*Dd*f**3*r*s - 584*D1*Dd*f**3*r - 146*D1*Dd*f**3*s + 146*D1*Dd*f**3 - 1320*D1*Dd*f**2*fd*r**2 - 1320*D1*Dd*f**2*fd*r*s + 1320*D1*Dd*f**2*fd*r + 385*D1*Dd*f**2*fd*s - 275*D1*Dd*f**2*fd + 180*D1*Ddd*b1*f**2*r**2 + 180*D1*Ddd*b1*f**2*r*s - 180*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2*s + 45*D1*Ddd*b1*f**2 - 220*D1*Ddd*f**3*r**2 - 220*D1*Ddd*f**3*r*s + 220*D1*Ddd*f**3*r + 55*D1*Ddd*f**3*s - 55*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(18*f*(r - 1)*(r + s - 1) + 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 540*Dd**2*b1*f**2*r**2 + 540*Dd**2*b1*f**2*r*s - 540*Dd**2*b1*f**2*r - 135*Dd**2*b1*f**2*s + 90*Dd**2*b1*f**2 - 660*Dd**2*f**3*r**2 - 660*Dd**2*f**3*r*s + 660*Dd**2*f**3*r + 165*Dd**2*f**3*s - 110*Dd**2*f**3)/(315*d**2*k1**2*k3**3) - D1**2*Pk1*Pkd3*ct**4*k2**4*(D1*f*(9*D1*bd1**2*(3*f*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + (14*r - 7)*(r + s - 1)) + bd1*(D1*(35*f**2*r*(2*r + 2*s - 1) + f*(5*fd*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1) + (45*r + 63)*(r + s - 1)) + 9*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*f*(5*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 72*r**2 + 72*r*(s - 1) - 9*s + 9)) + f*(D1*(bdd1*r*(5*f*(2*r + 2*s - 1) + 9*r + 9*s - 9) - 45*fd*(3*r**2 + 3*r*(s - 1) - s + 1)) - 45*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1))) + 3*b1**2*(D1**2*r*(3*f*(fd + 3*fdd)*(4*r + 4*s - 3) + 9*fd**2*(4*r + 4*s - 3) + 28*fd*(r + s) + 21*fdd*(r + s)) + D1*(Dd*(6*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(9*fd*(8*r - 1)*(4*r + 4*s - 3) + 112*r**2 + 112*r*(s - 1) - 28*s + 28) + 21*fd*(8*r**2 + r*(8*s - 4) - s)) + 3*Ddd*f*(6*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*Dd**2*f*(6*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(9*D1**2*bdd1*f*(3*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + (14*r - 7)*(r + s - 1)) + 210*D1**2*f**2*fd*r**2 + 210*D1**2*f**2*fd*r*s - 245*D1**2*f**2*fd*r - 70*D1**2*f**2*fd*s + 70*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 35*D1**2*f**2*fdd*r - 10*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 70*D1**2*f*fd**2*r - 20*D1**2*f*fd**2*s + 15*D1**2*f*fd**2 + 90*D1**2*f*fd*r**2 + 90*D1**2*f*fd*r*s - 153*D1**2*f*fd*r - 108*D1**2*f*fd*s + 108*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*r - 9*D1**2*fd**2*s + 280*D1*Dd*f**3*r**2 + 280*D1*Dd*f**3*r*s - 280*D1*Dd*f**3*r - 70*D1*Dd*f**3*s + 70*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 260*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd*s + 55*D1*Dd*f**2*fd + 180*D1*Dd*f**2*r**2 + 180*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r - 45*D1*Dd*f**2*s + 45*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 144*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r - 54*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 40*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 40*D1*Ddd*f**3*r - 10*D1*Ddd*f**3*s + 10*D1*Ddd*f**3 + 36*D1*Ddd*f**2*r**2 + 36*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r - 9*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 3*D1*bd1*(D1*(3*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(9*fd*(4*r - 1)*(4*r + 4*s - 3) + (56*r - 28)*(r + s - 1)) + 21*fd*(4*r**2 + r*(4*s - 3) - s)) + 3*Dd*f*(3*f*(8*r - 3)*(4*r + 4*s - 3) + 112*r**2 + 28*r*(4*s - 5) - 42*s + 35)) + 120*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 120*Dd**2*f**3*r - 30*Dd**2*f**3*s + 20*Dd**2*f**3 + 108*Dd**2*f**2*r**2 + 108*Dd**2*f**2*r*s - 108*Dd**2*f**2*r - 27*Dd**2*f**2*s + 18*Dd**2*f**2))/(315*d**2*k1**2*k3**3) - D1**2*Pk1*Pkd3*ct**4*k2**2*(3*D1*f*(7*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + D1*bdd1*f*r*(r + s) + bd1*(D1*(12*f*r*(r + s) + fd*(4*r**2 + 4*r*s - 3*r - s)) + Dd*f*(8*r**2 + r*(8*s - 4) - s))) + 7*b1**2*(D1**2*r*(4*fd + 3*fdd)*(r + s - 1) + D1*(Dd*(4*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(21*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*D1**2*(2*r - 1)*(f*(12*fd + fdd) + fd**2)*(r + s - 1) + 7*D1*bd1*(D1*(f*(8*r**2 + 8*r*(s - 1) - 4*s + 4) + 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 3*D1*f*(Dd*(12*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(105*d**2*k1**2*k3) + 3*D1**2*Pk1*Pkd3*ct**3*f*k2**7*st**4*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 88*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 88*D1**2*b1*f*fd*s + 44*D1**2*b1*f*fd - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 44*D1**2*b1*f*fdd*r - 33*D1**2*b1*f*fdd*s**2 + 44*D1**2*b1*f*fdd*s - 22*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 88*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 88*D1**2*b1*fd**2*s - 22*D1**2*b1*fd**2 - 11*D1**2*bdd1*f**2*(r + s - 1)**2 + 40*D1**2*f**2*fd*r**2 + 80*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 40*D1**2*f**2*fd*s**2 - 60*D1**2*f**2*fd*s + 30*D1**2*f**2*fd - 20*D1**2*f**2*fdd*r**2 - 40*D1**2*f**2*fdd*r*s + 30*D1**2*f**2*fdd*r - 20*D1**2*f**2*fdd*s**2 + 30*D1**2*f**2*fdd*s - 15*D1**2*f**2*fdd - 60*D1**2*f*fd**2*r**2 - 120*D1**2*f*fd**2*r*s + 90*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s**2 + 90*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 176*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r + 88*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 374*D1*Dd*b1*f*fd*r - 264*D1*Dd*b1*f*fd*s**2 + 374*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 - 160*D1*Dd*f**2*fd*r**2 - 320*D1*Dd*f**2*fd*r*s + 240*D1*Dd*f**2*fd*r - 160*D1*Dd*f**2*fd*s**2 + 240*D1*Dd*f**2*fd*s - 90*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 - 88*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r - 44*D1*Ddd*b1*f**2*s**2 + 66*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 30*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 30*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 + 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 132*Dd**2*b1*f**2*r**2 - 264*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r - 132*Dd**2*b1*f**2*s**2 + 198*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 90*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 90*Dd**2*f**3*s - 30*Dd**2*f**3)/(22*d**2*k1*k3**7) + D1**2*Pk1*Pkd3*ct**3*k1**5*k2*(12*C - 7)*(54*D1**2*b1*f*fd*r**2 + 108*D1**2*b1*f*fd*r*s - 54*D1**2*b1*f*fd*r + 54*D1**2*b1*f*fd*s**2 - 54*D1**2*b1*f*fd*s + 27*D1**2*b1*f*fd - 90*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd - 90*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)**2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 216*D1*Dd*b1*f**2*r*s - 162*D1*Dd*b1*f**2*r + 108*D1*Dd*b1*f**2*s**2 - 162*D1*Dd*b1*f**2*s + 81*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 900*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 900*D1*Dd*b1*f*fd*s - 270*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 1190*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 1190*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 270*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 270*D1*Ddd*b1*f**2*s - 135*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 210*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 210*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 540*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 810*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 810*Dd**2*b1*f**2*s - 270*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 630*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 630*Dd**2*f**3*s - 210*Dd**2*f**3)/(70*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**3*k1**5*(4*C - 2)*(9*b1*(D1**2*(f*(3*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(3*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(2*s - 1)*(8*r + 8*s - 5)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-5*D1**2*(f*(9*bdd1*s*(r + s - 1) - 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(D1*(3*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) - 5*D1*f*(Dd*(-5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 7*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) + 7*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 35*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k2*k3**5) + D1**2*Pk1*Pkd3*ct**3*k1**3*k2**3*st**2*(2112*C*D1**2*b1*f*fd*r**2 + 4224*C*D1**2*b1*f*fd*r*s - 2112*C*D1**2*b1*f*fd*r + 2112*C*D1**2*b1*f*fd*s**2 - 2112*C*D1**2*b1*f*fd*s + 1056*C*D1**2*b1*f*fd - 2232*C*D1**2*b1*f*fdd*r**2 - 4464*C*D1**2*b1*f*fdd*r*s + 2232*C*D1**2*b1*f*fdd*r - 2232*C*D1**2*b1*f*fdd*s**2 + 2232*C*D1**2*b1*f*fdd*s - 1116*C*D1**2*b1*f*fdd - 2232*C*D1**2*b1*fd**2*r**2 - 4464*C*D1**2*b1*fd**2*r*s + 2232*C*D1**2*b1*fd**2*r - 2232*C*D1**2*b1*fd**2*s**2 + 2232*C*D1**2*b1*fd**2*s + 2208*C*D1**2*f**2*fd*r**2 + 4416*C*D1**2*f**2*fd*r*s - 2944*C*D1**2*f**2*fd*r + 2208*C*D1**2*f**2*fd*s**2 - 2944*C*D1**2*f**2*fd*s + 1472*C*D1**2*f**2*fd - 1860*C*D1**2*f**2*fdd*r**2 - 3720*C*D1**2*f**2*fdd*r*s + 2480*C*D1**2*f**2*fdd*r - 1860*C*D1**2*f**2*fdd*s**2 + 2480*C*D1**2*f**2*fdd*s - 1240*C*D1**2*f**2*fdd - 3720*C*D1**2*f*fd**2*r**2 - 7440*C*D1**2*f*fd**2*r*s + 4960*C*D1**2*f*fd**2*r - 3720*C*D1**2*f*fd**2*s**2 + 4960*C*D1**2*f*fd**2*s - 1240*C*D1**2*f*fd**2 + 4224*C*D1*Dd*b1*f**2*r**2 + 8448*C*D1*Dd*b1*f**2*r*s - 6336*C*D1*Dd*b1*f**2*r + 4224*C*D1*Dd*b1*f**2*s**2 - 6336*C*D1*Dd*b1*f**2*s + 3168*C*D1*Dd*b1*f**2 - 17856*C*D1*Dd*b1*f*fd*r**2 - 35712*C*D1*Dd*b1*f*fd*r*s + 22320*C*D1*Dd*b1*f*fd*r - 17856*C*D1*Dd*b1*f*fd*s**2 + 22320*C*D1*Dd*b1*f*fd*s - 6696*C*D1*Dd*b1*f*fd + 2944*C*D1*Dd*f**3*r**2 + 5888*C*D1*Dd*f**3*r*s - 4416*C*D1*Dd*f**3*r + 2944*C*D1*Dd*f**3*s**2 - 4416*C*D1*Dd*f**3*s + 2208*C*D1*Dd*f**3 - 14880*C*D1*Dd*f**2*fd*r**2 - 29760*C*D1*Dd*f**2*fd*r*s + 21080*C*D1*Dd*f**2*fd*r - 14880*C*D1*Dd*f**2*fd*s**2 + 21080*C*D1*Dd*f**2*fd*s - 7440*C*D1*Dd*f**2*fd - 4464*C*D1*Ddd*b1*f**2*r**2 - 8928*C*D1*Ddd*b1*f**2*r*s + 6696*C*D1*Ddd*b1*f**2*r - 4464*C*D1*Ddd*b1*f**2*s**2 + 6696*C*D1*Ddd*b1*f**2*s - 3348*C*D1*Ddd*b1*f**2 - 2480*C*D1*Ddd*f**3*r**2 - 4960*C*D1*Ddd*f**3*r*s + 3720*C*D1*Ddd*f**3*r - 2480*C*D1*Ddd*f**3*s**2 + 3720*C*D1*Ddd*f**3*s - 1860*C*D1*Ddd*f**3 - 13392*C*Dd**2*b1*f**2*r**2 - 26784*C*Dd**2*b1*f**2*r*s + 20088*C*Dd**2*b1*f**2*r - 13392*C*Dd**2*b1*f**2*s**2 + 20088*C*Dd**2*b1*f**2*s - 6696*C*Dd**2*b1*f**2 - 7440*C*Dd**2*f**3*r**2 - 14880*C*Dd**2*f**3*r*s + 11160*C*Dd**2*f**3*r - 7440*C*Dd**2*f**3*s**2 + 11160*C*Dd**2*f**3*s - 3720*C*Dd**2*f**3 - 1374*D1**2*b1*f*fd*r**2 - 2748*D1**2*b1*f*fd*r*s + 1374*D1**2*b1*f*fd*r - 1374*D1**2*b1*f*fd*s**2 + 1374*D1**2*b1*f*fd*s - 687*D1**2*b1*f*fd + 1548*D1**2*b1*f*fdd*r**2 + 3096*D1**2*b1*f*fdd*r*s - 1548*D1**2*b1*f*fdd*r + 1548*D1**2*b1*f*fdd*s**2 - 1548*D1**2*b1*f*fdd*s + 774*D1**2*b1*f*fdd + 1548*D1**2*b1*fd**2*r**2 + 3096*D1**2*b1*fd**2*r*s - 1548*D1**2*b1*fd**2*r + 1548*D1**2*b1*fd**2*s**2 - 1548*D1**2*b1*fd**2*s - 18*D1**2*bdd1*f**2*(62*C - 43)*(r + s - 1)**2 - 1473*D1**2*f**2*fd*r**2 - 2946*D1**2*f**2*fd*r*s + 1964*D1**2*f**2*fd*r - 1473*D1**2*f**2*fd*s**2 + 1964*D1**2*f**2*fd*s - 982*D1**2*f**2*fd + 1290*D1**2*f**2*fdd*r**2 + 2580*D1**2*f**2*fdd*r*s - 1720*D1**2*f**2*fdd*r + 1290*D1**2*f**2*fdd*s**2 - 1720*D1**2*f**2*fdd*s + 860*D1**2*f**2*fdd + 2580*D1**2*f*fd**2*r**2 + 5160*D1**2*f*fd**2*r*s - 3440*D1**2*f*fd**2*r + 2580*D1**2*f*fd**2*s**2 - 3440*D1**2*f*fd**2*s + 860*D1**2*f*fd**2 - 2748*D1*Dd*b1*f**2*r**2 - 5496*D1*Dd*b1*f**2*r*s + 4122*D1*Dd*b1*f**2*r - 2748*D1*Dd*b1*f**2*s**2 + 4122*D1*Dd*b1*f**2*s - 2061*D1*Dd*b1*f**2 + 12384*D1*Dd*b1*f*fd*r**2 + 24768*D1*Dd*b1*f*fd*r*s - 15480*D1*Dd*b1*f*fd*r + 12384*D1*Dd*b1*f*fd*s**2 - 15480*D1*Dd*b1*f*fd*s + 4644*D1*Dd*b1*f*fd - 1964*D1*Dd*f**3*r**2 - 3928*D1*Dd*f**3*r*s + 2946*D1*Dd*f**3*r - 1964*D1*Dd*f**3*s**2 + 2946*D1*Dd*f**3*s - 1473*D1*Dd*f**3 + 10320*D1*Dd*f**2*fd*r**2 + 20640*D1*Dd*f**2*fd*r*s - 14620*D1*Dd*f**2*fd*r + 10320*D1*Dd*f**2*fd*s**2 - 14620*D1*Dd*f**2*fd*s + 5160*D1*Dd*f**2*fd + 3096*D1*Ddd*b1*f**2*r**2 + 6192*D1*Ddd*b1*f**2*r*s - 4644*D1*Ddd*b1*f**2*r + 3096*D1*Ddd*b1*f**2*s**2 - 4644*D1*Ddd*b1*f**2*s + 2322*D1*Ddd*b1*f**2 + 1720*D1*Ddd*f**3*r**2 + 3440*D1*Ddd*f**3*r*s - 2580*D1*Ddd*f**3*r + 1720*D1*Ddd*f**3*s**2 - 2580*D1*Ddd*f**3*s + 1290*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(352*C - 229)*(r + s - 1) - D1*fd*(744*C - 516)*(2*r + 2*s - 1) - Dd*f*(744*C - 516)*(4*r + 4*s - 3)) + 9288*Dd**2*b1*f**2*r**2 + 18576*Dd**2*b1*f**2*r*s - 13932*Dd**2*b1*f**2*r + 9288*Dd**2*b1*f**2*s**2 - 13932*Dd**2*b1*f**2*s + 4644*Dd**2*b1*f**2 + 5160*Dd**2*f**3*r**2 + 10320*Dd**2*f**3*r*s - 7740*Dd**2*f**3*r + 5160*Dd**2*f**3*s**2 - 7740*Dd**2*f**3*s + 2580*Dd**2*f**3)/(35*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**3*k1**3*k2**3*(-11880*C*D1**2*f**2*fd*r**2 - 23760*C*D1**2*f**2*fd*r*s + 15840*C*D1**2*f**2*fd*r - 11880*C*D1**2*f**2*fd*s**2 + 15840*C*D1**2*f**2*fd*s - 7920*C*D1**2*f**2*fd - 15840*C*D1*Dd*f**3*r**2 - 31680*C*D1*Dd*f**3*r*s + 23760*C*D1*Dd*f**3*r - 15840*C*D1*Dd*f**3*s**2 + 23760*C*D1*Dd*f**3*s - 11880*C*D1*Dd*f**3 - 9900*D1**2*K*bdd1*f**2*r**2 - 19800*D1**2*K*bdd1*f**2*r*s + 19800*D1**2*K*bdd1*f**2*r - 9900*D1**2*K*bdd1*f**2*s**2 + 19800*D1**2*K*bdd1*f**2*s - 9900*D1**2*K*bdd1*f**2 + 1980*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 + 1925*D1**2*bdd1*f**3*r**2 + 3850*D1**2*bdd1*f**3*r*s - 3850*D1**2*bdd1*f**3*r + 1925*D1**2*bdd1*f**3*s**2 - 3850*D1**2*bdd1*f**3*s + 1925*D1**2*bdd1*f**3 + 4950*D1**2*bdd1*f**2*r**2 + 9900*D1**2*bdd1*f**2*r*s - 9900*D1**2*bdd1*f**2*r + 4950*D1**2*bdd1*f**2*s**2 - 9900*D1**2*bdd1*f**2*s + 4950*D1**2*bdd1*f**2 + 27720*D1**2*bdd1*f*g2*r**2 + 55440*D1**2*bdd1*f*g2*r*s - 55440*D1**2*bdd1*f*g2*r + 27720*D1**2*bdd1*f*g2*s**2 - 55440*D1**2*bdd1*f*g2*s + 27720*D1**2*bdd1*f*g2 + 4900*D1**2*f**3*fd*r**2 + 9800*D1**2*f**3*fd*r*s - 7350*D1**2*f**3*fd*r + 4900*D1**2*f**3*fd*s**2 - 7350*D1**2*f**3*fd*s + 3675*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 + 7425*D1**2*f**2*fd*r**2 + 14850*D1**2*f**2*fd*r*s - 9900*D1**2*f**2*fd*r + 7425*D1**2*f**2*fd*s**2 - 9900*D1**2*f**2*fd*s + 4950*D1**2*f**2*fd - 17424*D1**2*f**2*gd2*r**2 - 34848*D1**2*f**2*gd2*r*s + 34848*D1**2*f**2*gd2*r - 17424*D1**2*f**2*gd2*s**2 + 34848*D1**2*f**2*gd2*s - 17424*D1**2*f**2*gd2 + 19800*D1**2*f**2*gdd2*r**2 + 39600*D1**2*f**2*gdd2*r*s - 39600*D1**2*f**2*gdd2*r + 19800*D1**2*f**2*gdd2*s**2 - 39600*D1**2*f**2*gdd2*s + 19800*D1**2*f**2*gdd2 - 34848*D1**2*f*fd*g2*r**2 - 69696*D1**2*f*fd*g2*r*s + 34848*D1**2*f*fd*g2*r - 34848*D1**2*f*fd*g2*s**2 + 34848*D1**2*f*fd*g2*s - 17424*D1**2*f*fd*g2 + 79200*D1**2*f*fd*gd2*r**2 + 158400*D1**2*f*fd*gd2*r*s - 118800*D1**2*f*fd*gd2*r + 79200*D1**2*f*fd*gd2*s**2 - 118800*D1**2*f*fd*gd2*s + 39600*D1**2*f*fd*gd2 + 39600*D1**2*f*fdd*g2*r**2 + 79200*D1**2*f*fdd*g2*r*s - 39600*D1**2*f*fdd*g2*r + 39600*D1**2*f*fdd*g2*s**2 - 39600*D1**2*f*fdd*g2*s + 19800*D1**2*f*fdd*g2 + 39600*D1**2*fd**2*g2*r**2 + 79200*D1**2*fd**2*g2*r*s - 39600*D1**2*fd**2*g2*r + 39600*D1**2*fd**2*g2*s**2 - 39600*D1**2*fd**2*g2*s + 4900*D1*Dd*f**4*r**2 + 9800*D1*Dd*f**4*r*s - 7350*D1*Dd*f**4*r + 4900*D1*Dd*f**4*s**2 - 7350*D1*Dd*f**4*s + 3675*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd + 9900*D1*Dd*f**3*r**2 + 19800*D1*Dd*f**3*r*s - 14850*D1*Dd*f**3*r + 9900*D1*Dd*f**3*s**2 - 14850*D1*Dd*f**3*s + 7425*D1*Dd*f**3 - 69696*D1*Dd*f**2*g2*r**2 - 139392*D1*Dd*f**2*g2*r*s + 104544*D1*Dd*f**2*g2*r - 69696*D1*Dd*f**2*g2*s**2 + 104544*D1*Dd*f**2*g2*s - 52272*D1*Dd*f**2*g2 + 158400*D1*Dd*f**2*gd2*r**2 + 316800*D1*Dd*f**2*gd2*r*s - 277200*D1*Dd*f**2*gd2*r + 158400*D1*Dd*f**2*gd2*s**2 - 277200*D1*Dd*f**2*gd2*s + 118800*D1*Dd*f**2*gd2 + 316800*D1*Dd*f*fd*g2*r**2 + 633600*D1*Dd*f*fd*g2*r*s - 396000*D1*Dd*f*fd*g2*r + 316800*D1*Dd*f*fd*g2*s**2 - 396000*D1*Dd*f*fd*g2*s + 118800*D1*Dd*f*fd*g2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 79200*D1*Ddd*f**2*g2*r**2 + 158400*D1*Ddd*f**2*g2*r*s - 118800*D1*Ddd*f**2*g2*r + 79200*D1*Ddd*f**2*g2*s**2 - 118800*D1*Ddd*f**2*g2*s + 59400*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(85*f**3*(r + s - 1) + f**2*(252*C*(r + s - 1) - 175*fd*(3*r + 3*s - 2) - (396*K - 9)*(r + s - 1)) + 30*f*(15*fd*(2*K - 1)*(2*r + 2*s - 1) + (28*g2 - 84*gd2)*(r + s - 1)) - 2520*fd*g2*(r + s)) - 5*Dd*f*(35*f**2 - 90*f*(2*K - 1) + 504*g2)*(4*r + 4*s - 3))*(r + s - 1) - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 237600*Dd**2*f**2*g2*r**2 + 475200*Dd**2*f**2*g2*r*s - 356400*Dd**2*f**2*g2*r + 237600*Dd**2*f**2*g2*s**2 - 356400*Dd**2*f**2*g2*s + 118800*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(3*f*(37*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-5*r - 5*s)*(60*fd**2*(r + s - 1) + 7*fd*(8*K - 3)*(r + s) - 42*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(111*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (56*K - 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 420*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 30*Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(1008*C*D1**2*f*fd*r**2 + 2016*C*D1**2*f*fd*r*s - 1008*C*D1**2*f*fd*r + 1008*C*D1**2*f*fd*s**2 - 1008*C*D1**2*f*fd*s + 504*C*D1**2*f*fd + 2016*C*D1*Dd*f**2*r**2 + 4032*C*D1*Dd*f**2*r*s - 3024*C*D1*Dd*f**2*r + 2016*C*D1*Dd*f**2*s**2 - 3024*C*D1*Dd*f**2*s + 1512*C*D1*Dd*f**2 - 1584*D1**2*K*f*fd*r**2 - 3168*D1**2*K*f*fd*r*s + 1584*D1**2*K*f*fd*r - 1584*D1**2*K*f*fd*s**2 + 1584*D1**2*K*f*fd*s - 792*D1**2*K*f*fd + 1800*D1**2*K*f*fdd*r**2 + 3600*D1**2*K*f*fdd*r*s - 1800*D1**2*K*f*fdd*r + 1800*D1**2*K*f*fdd*s**2 - 1800*D1**2*K*f*fdd*s + 900*D1**2*K*f*fdd + 1800*D1**2*K*fd**2*r**2 + 3600*D1**2*K*fd**2*r*s - 1800*D1**2*K*fd**2*r + 1800*D1**2*K*fd**2*s**2 - 1800*D1**2*K*fd**2*s - 180*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 + 510*D1**2*f**2*fd*r**2 + 1020*D1**2*f**2*fd*r*s - 680*D1**2*f**2*fd*r + 510*D1**2*f**2*fd*s**2 - 680*D1**2*f**2*fd*s + 340*D1**2*f**2*fd - 525*D1**2*f**2*fdd*r**2 - 1050*D1**2*f**2*fdd*r*s + 700*D1**2*f**2*fdd*r - 525*D1**2*f**2*fdd*s**2 + 700*D1**2*f**2*fdd*s - 350*D1**2*f**2*fdd - 1050*D1**2*f*fd**2*r**2 - 2100*D1**2*f*fd**2*r*s + 1400*D1**2*f*fd**2*r - 1050*D1**2*f*fd**2*s**2 + 1400*D1**2*f*fd**2*s - 350*D1**2*f*fd**2 + 36*D1**2*f*fd*r**2 + 72*D1**2*f*fd*r*s - 36*D1**2*f*fd*r + 36*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s + 18*D1**2*f*fd - 900*D1**2*f*fdd*r**2 - 1800*D1**2*f*fdd*r*s + 900*D1**2*f*fdd*r - 900*D1**2*f*fdd*s**2 + 900*D1**2*f*fdd*s - 450*D1**2*f*fdd + 1680*D1**2*f*gd2*r**2 + 3360*D1**2*f*gd2*r*s - 3360*D1**2*f*gd2*r + 1680*D1**2*f*gd2*s**2 - 3360*D1**2*f*gd2*s + 1680*D1**2*f*gd2 - 2520*D1**2*f*gdd2*r**2 - 5040*D1**2*f*gdd2*r*s + 5040*D1**2*f*gdd2*r - 2520*D1**2*f*gdd2*s**2 + 5040*D1**2*f*gdd2*s - 2520*D1**2*f*gdd2 - 900*D1**2*fd**2*r**2 - 1800*D1**2*fd**2*r*s + 900*D1**2*fd**2*r - 900*D1**2*fd**2*s**2 + 900*D1**2*fd**2*s + 1680*D1**2*fd*g2*r**2 + 3360*D1**2*fd*g2*r*s + 1680*D1**2*fd*g2*s**2 - 5040*D1**2*fd*gd2*r**2 - 10080*D1**2*fd*gd2*r*s + 5040*D1**2*fd*gd2*r - 5040*D1**2*fd*gd2*s**2 + 5040*D1**2*fd*gd2*s - 2520*D1**2*fdd*g2*r**2 - 5040*D1**2*fdd*g2*r*s - 2520*D1**2*fdd*g2*s**2 - 3168*D1*Dd*K*f**2*r**2 - 6336*D1*Dd*K*f**2*r*s + 4752*D1*Dd*K*f**2*r - 3168*D1*Dd*K*f**2*s**2 + 4752*D1*Dd*K*f**2*s - 2376*D1*Dd*K*f**2 + 14400*D1*Dd*K*f*fd*r**2 + 28800*D1*Dd*K*f*fd*r*s - 18000*D1*Dd*K*f*fd*r + 14400*D1*Dd*K*f*fd*s**2 - 18000*D1*Dd*K*f*fd*s + 5400*D1*Dd*K*f*fd + 680*D1*Dd*f**3*r**2 + 1360*D1*Dd*f**3*r*s - 1020*D1*Dd*f**3*r + 680*D1*Dd*f**3*s**2 - 1020*D1*Dd*f**3*s + 510*D1*Dd*f**3 - 4200*D1*Dd*f**2*fd*r**2 - 8400*D1*Dd*f**2*fd*r*s + 5950*D1*Dd*f**2*fd*r - 4200*D1*Dd*f**2*fd*s**2 + 5950*D1*Dd*f**2*fd*s - 2100*D1*Dd*f**2*fd + 72*D1*Dd*f**2*r**2 + 144*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 108*D1*Dd*f**2*s + 54*D1*Dd*f**2 - 7200*D1*Dd*f*fd*r**2 - 14400*D1*Dd*f*fd*r*s + 9000*D1*Dd*f*fd*r - 7200*D1*Dd*f*fd*s**2 + 9000*D1*Dd*f*fd*s - 2700*D1*Dd*f*fd + 6720*D1*Dd*f*g2*r**2 + 13440*D1*Dd*f*g2*r*s - 10080*D1*Dd*f*g2*r + 6720*D1*Dd*f*g2*s**2 - 10080*D1*Dd*f*g2*s + 5040*D1*Dd*f*g2 - 20160*D1*Dd*f*gd2*r**2 - 40320*D1*Dd*f*gd2*r*s + 35280*D1*Dd*f*gd2*r - 20160*D1*Dd*f*gd2*s**2 + 35280*D1*Dd*f*gd2*s - 15120*D1*Dd*f*gd2 - 20160*D1*Dd*fd*g2*r**2 - 40320*D1*Dd*fd*g2*r*s + 15120*D1*Dd*fd*g2*r - 20160*D1*Dd*fd*g2*s**2 + 15120*D1*Dd*fd*g2*s + 3600*D1*Ddd*K*f**2*r**2 + 7200*D1*Ddd*K*f**2*r*s - 5400*D1*Ddd*K*f**2*r + 3600*D1*Ddd*K*f**2*s**2 - 5400*D1*Ddd*K*f**2*s + 2700*D1*Ddd*K*f**2 - 700*D1*Ddd*f**3*r**2 - 1400*D1*Ddd*f**3*r*s + 1050*D1*Ddd*f**3*r - 700*D1*Ddd*f**3*s**2 + 1050*D1*Ddd*f**3*s - 525*D1*Ddd*f**3 - 1800*D1*Ddd*f**2*r**2 - 3600*D1*Ddd*f**2*r*s + 2700*D1*Ddd*f**2*r - 1800*D1*Ddd*f**2*s**2 + 2700*D1*Ddd*f**2*s - 1350*D1*Ddd*f**2 - 10080*D1*Ddd*f*g2*r**2 - 20160*D1*Ddd*f*g2*r*s + 15120*D1*Ddd*f*g2*r - 10080*D1*Ddd*f*g2*s**2 + 15120*D1*Ddd*f*g2*s - 7560*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(111*f**2*(r + s - 1) - 5*f*(60*fd*(2*r + 2*s - 1) + (56*K - 21)*(r + s - 1)) + 420*fd*(2*K - 1)*(r + s)) - 60*Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 10800*Dd**2*K*f**2*r**2 + 21600*Dd**2*K*f**2*r*s - 16200*Dd**2*K*f**2*r + 10800*Dd**2*K*f**2*s**2 - 16200*Dd**2*K*f**2*s + 5400*Dd**2*K*f**2 - 2100*Dd**2*f**3*r**2 - 4200*Dd**2*f**3*r*s + 3150*Dd**2*f**3*r - 2100*Dd**2*f**3*s**2 + 3150*Dd**2*f**3*s - 1050*Dd**2*f**3 - 5400*Dd**2*f**2*r**2 - 10800*Dd**2*f**2*r*s + 8100*Dd**2*f**2*r - 5400*Dd**2*f**2*s**2 + 8100*Dd**2*f**2*s - 2700*Dd**2*f**2 - 30240*Dd**2*f*g2*r**2 - 60480*Dd**2*f*g2*r*s + 45360*Dd**2*f*g2*r - 30240*Dd**2*f*g2*s**2 + 45360*Dd**2*f*g2*s - 15120*Dd**2*f*g2))/(770*d**2*k3**7) + 4*D1**2*Pk1*Pkd3*ct**3*k1**3*k2*st**2*(b1*(D1**2*(f*(fd*(281*C - 179) + fdd*(135 - 207*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(135 - 207*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(281*C - 179)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(135 - 207*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(135 - 207*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(135 - 207*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(173*C - 111)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (23*C - 15)*(9*bdd1*s*(r + s - 1) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(75 - 115*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(281*C - 179)*(r + s - 1) - fd*(207*C - 135)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(135 - 207*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(173*C - 111)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(115*C - 75)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(75 - 115*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(75 - 115*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**3*k1**3*k2*(105*b1**2*(8*C - 5)*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-105*D1**2*bdd1*f*(8*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*D1**2*(f*(fd*(8*C*(33*r**2 + 164*r*s - 67*r + 131*s**2 - 116*s + 58) - 159*r**2 - 874*r*s + 362*r - 715*s**2 + 640*s - 320) + fdd*(-40*C*(11*r**2 + 36*r*s - 13*r + 25*s**2 - 20*s + 10) + 265*r**2 + 962*r*s - 356*r + 697*s**2 - 572*s + 286)) + fd**2*(-40*C*(11*r**2 + 36*r*s - 13*r + 25*s**2 - 20*s - 5) + 265*r**2 + 962*r*s - 356*r + 697*s**2 - 572*s - 125)) + 35*D1*bd1*(8*C - 5)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 3*D1*f*(Dd*(f*(8*C*(132*r**2 + 656*r*s - 394*r + 524*s**2 - 688*s + 295) - 636*r**2 - 3496*r*s + 2066*r - 2860*s**2 + 3734*s - 1589) - 4*fd*(20*C*(88*r**2 + 288*r*s - 146*r + 200*s**2 - 216*s + 53) - 1060*r**2 - 3848*r*s + 1939*r - 2788*s**2 + 3019*s - 750)) + Ddd*f*(-40*C*(44*r**2 + 144*r*s - 94*r + 100*s**2 - 136*s + 61) + 1060*r**2 + 3848*r*s - 2454*r + 2788*s**2 - 3750*s + 1659)) + 6*Dd**2*f**2*(40*C*(66*r**2 + 3*r*(72*s - 47) + 150*s**2 - 204*s + 61) - 1590*r**2 - 3*r*(1924*s - 1227) - 4182*s**2 + 5625*s - 1659)) + f*(-630*D1**2*bd1**2*(8*C - 5)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(40*C*(11*r**2 + 4*r*(9*s - 8) + 25*s**2 - 46*s + 16) - 265*r**2 + r*(780 - 962*s) - 697*s**2 + 1212*s - 390) - 10*D1**2*(f*(fd*(8*C*(138*r**2 + 3*r*(145*s - 79) + 297*s**2 - 343*s + 145) - 669*r**2 - 6*r*(380*s - 201) - 1611*s**2 + 1834*s - 760) + fdd*(-8*C*(177*r**2 + 6*r*(79*s - 46) + 297*s**2 - 356*s + 158) + 861*r**2 + 6*r*(415*s - 234) + 1629*s**2 - 1916*s + 830)) + 2*fd**2*(-8*C*(177*r**2 + 6*r*(79*s - 46) + 297*s**2 - 356*s + 79) + 861*r**2 + 6*r*(415*s - 234) + 1629*s**2 - 1916*s + 415)) - 9*D1*bd1*(D1*(f*(8*C*(33*r**2 + 164*r*s - 96*r + 131*s**2 - 194*s + 48) - 159*r**2 - 874*r*s + 468*r - 715*s**2 + 1024*s - 234) - 4*fd*(20*C*(22*r**2 + 9*r*(8*s - 5) + 50*s**2 - 66*s + 23) - 265*r**2 - 962*r*s + 568*r - 697*s**2 + 892*s - 303)) + 2*Dd*f*(-40*C*(44*r**2 + 144*r*s - 111*r + 100*s**2 - 160*s + 62) + 1060*r**2 + 3848*r*s - 2787*r + 2788*s**2 - 4299*s + 1602)) - 10*D1*f*(Dd*(f*(8*C*(184*r**2 + 580*r*s - 382*r + 396*s**2 - 541*s + 244) - 892*r**2 - 3040*r*s + 1966*r - 2148*s**2 + 2908*s - 1297) - 2*fd*(8*C*(708*r**2 + 3*r*(632*s - 401) + 1188*s**2 - 1543*s + 494) - 3444*r**2 - 9960*r*s + 6159*r - 6516*s**2 + 8335*s - 2618)) + Ddd*f*(-8*C*(236*r**2 + 632*r*s - 434*r + 396*s**2 - 554*s + 257) + 1148*r**2 + 3320*r*s - 2234*r + 2172*s**2 - 3002*s + 1373)) - 20*Dd**2*f**2*(-8*C*(354*r**2 + r*(948*s - 651) + 594*s**2 - 831*s + 257) + 1722*r**2 + r*(4980*s - 3351) + 3258*s**2 - 4503*s + 1373)))/(630*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**3*k1**3*(4*C - 2)*(3*D1*b1*(-3*D1*(3*f*fd*s + f*s*(7*bdd1*(2*r + 2*s - 1) - 5*fdd) - 5*fd**2*(s - 1)) - 30*Dd*f*fd*(1 - 2*s) - 7*bd1*(D1*(f*s*(-2*r - 2*s + 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 6*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1))) + 21*b1**2*(D1**2*(fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-63*D1**2*bd1**2*s*(2*r + 2*s - 1) - 5*D1**2*(f*(9*bdd1*s + 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 9*D1*bd1*(3*D1*f*s - 5*D1*fd*(s - 1) + 10*Dd*f*(1 - 2*s)) - 5*D1*f*(Dd*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 7*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 7*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 35*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(315*d**2*k2*k3**3) + 3*D1**2*Pk1*Pkd3*ct**3*k1*k2**5*st**4*(1032*C*D1**2*b1*f*fd*r**2 + 2064*C*D1**2*b1*f*fd*r*s - 1032*C*D1**2*b1*f*fd*r + 1032*C*D1**2*b1*f*fd*s**2 - 1032*C*D1**2*b1*f*fd*s + 516*C*D1**2*b1*f*fd - 600*C*D1**2*b1*f*fdd*r**2 - 1200*C*D1**2*b1*f*fdd*r*s + 600*C*D1**2*b1*f*fdd*r - 600*C*D1**2*b1*f*fdd*s**2 + 600*C*D1**2*b1*f*fdd*s - 300*C*D1**2*b1*f*fdd - 600*C*D1**2*b1*fd**2*r**2 - 1200*C*D1**2*b1*fd**2*r*s + 600*C*D1**2*b1*fd**2*r - 600*C*D1**2*b1*fd**2*s**2 + 600*C*D1**2*b1*fd**2*s + 564*C*D1**2*f**2*fd*r**2 + 1128*C*D1**2*f**2*fd*r*s - 752*C*D1**2*f**2*fd*r + 564*C*D1**2*f**2*fd*s**2 - 752*C*D1**2*f**2*fd*s + 376*C*D1**2*f**2*fd - 300*C*D1**2*f**2*fdd*r**2 - 600*C*D1**2*f**2*fdd*r*s + 400*C*D1**2*f**2*fdd*r - 300*C*D1**2*f**2*fdd*s**2 + 400*C*D1**2*f**2*fdd*s - 200*C*D1**2*f**2*fdd - 600*C*D1**2*f*fd**2*r**2 - 1200*C*D1**2*f*fd**2*r*s + 800*C*D1**2*f*fd**2*r - 600*C*D1**2*f*fd**2*s**2 + 800*C*D1**2*f*fd**2*s - 200*C*D1**2*f*fd**2 + 2064*C*D1*Dd*b1*f**2*r**2 + 4128*C*D1*Dd*b1*f**2*r*s - 3096*C*D1*Dd*b1*f**2*r + 2064*C*D1*Dd*b1*f**2*s**2 - 3096*C*D1*Dd*b1*f**2*s + 1548*C*D1*Dd*b1*f**2 - 4800*C*D1*Dd*b1*f*fd*r**2 - 9600*C*D1*Dd*b1*f*fd*r*s + 6000*C*D1*Dd*b1*f*fd*r - 4800*C*D1*Dd*b1*f*fd*s**2 + 6000*C*D1*Dd*b1*f*fd*s - 1800*C*D1*Dd*b1*f*fd + 752*C*D1*Dd*f**3*r**2 + 1504*C*D1*Dd*f**3*r*s - 1128*C*D1*Dd*f**3*r + 752*C*D1*Dd*f**3*s**2 - 1128*C*D1*Dd*f**3*s + 564*C*D1*Dd*f**3 - 2400*C*D1*Dd*f**2*fd*r**2 - 4800*C*D1*Dd*f**2*fd*r*s + 3400*C*D1*Dd*f**2*fd*r - 2400*C*D1*Dd*f**2*fd*s**2 + 3400*C*D1*Dd*f**2*fd*s - 1200*C*D1*Dd*f**2*fd - 1200*C*D1*Ddd*b1*f**2*r**2 - 2400*C*D1*Ddd*b1*f**2*r*s + 1800*C*D1*Ddd*b1*f**2*r - 1200*C*D1*Ddd*b1*f**2*s**2 + 1800*C*D1*Ddd*b1*f**2*s - 900*C*D1*Ddd*b1*f**2 - 400*C*D1*Ddd*f**3*r**2 - 800*C*D1*Ddd*f**3*r*s + 600*C*D1*Ddd*f**3*r - 400*C*D1*Ddd*f**3*s**2 + 600*C*D1*Ddd*f**3*s - 300*C*D1*Ddd*f**3 - 3600*C*Dd**2*b1*f**2*r**2 - 7200*C*Dd**2*b1*f**2*r*s + 5400*C*Dd**2*b1*f**2*r - 3600*C*Dd**2*b1*f**2*s**2 + 5400*C*Dd**2*b1*f**2*s - 1800*C*Dd**2*b1*f**2 - 1200*C*Dd**2*f**3*r**2 - 2400*C*Dd**2*f**3*r*s + 1800*C*Dd**2*f**3*r - 1200*C*Dd**2*f**3*s**2 + 1800*C*Dd**2*f**3*s - 600*C*Dd**2*f**3 - 852*D1**2*b1*f*fd*r**2 - 1704*D1**2*b1*f*fd*r*s + 852*D1**2*b1*f*fd*r - 852*D1**2*b1*f*fd*s**2 + 852*D1**2*b1*f*fd*s - 426*D1**2*b1*f*fd + 510*D1**2*b1*f*fdd*r**2 + 1020*D1**2*b1*f*fdd*r*s - 510*D1**2*b1*f*fdd*r + 510*D1**2*b1*f*fdd*s**2 - 510*D1**2*b1*f*fdd*s + 255*D1**2*b1*f*fdd + 510*D1**2*b1*fd**2*r**2 + 1020*D1**2*b1*fd**2*r*s - 510*D1**2*b1*fd**2*r + 510*D1**2*b1*fd**2*s**2 - 510*D1**2*b1*fd**2*s - 15*D1**2*bdd1*f**2*(20*C - 17)*(r + s - 1)**2 - 474*D1**2*f**2*fd*r**2 - 948*D1**2*f**2*fd*r*s + 632*D1**2*f**2*fd*r - 474*D1**2*f**2*fd*s**2 + 632*D1**2*f**2*fd*s - 316*D1**2*f**2*fd + 255*D1**2*f**2*fdd*r**2 + 510*D1**2*f**2*fdd*r*s - 340*D1**2*f**2*fdd*r + 255*D1**2*f**2*fdd*s**2 - 340*D1**2*f**2*fdd*s + 170*D1**2*f**2*fdd + 510*D1**2*f*fd**2*r**2 + 1020*D1**2*f*fd**2*r*s - 680*D1**2*f*fd**2*r + 510*D1**2*f*fd**2*s**2 - 680*D1**2*f*fd**2*s + 170*D1**2*f*fd**2 - 1704*D1*Dd*b1*f**2*r**2 - 3408*D1*Dd*b1*f**2*r*s + 2556*D1*Dd*b1*f**2*r - 1704*D1*Dd*b1*f**2*s**2 + 2556*D1*Dd*b1*f**2*s - 1278*D1*Dd*b1*f**2 + 4080*D1*Dd*b1*f*fd*r**2 + 8160*D1*Dd*b1*f*fd*r*s - 5100*D1*Dd*b1*f*fd*r + 4080*D1*Dd*b1*f*fd*s**2 - 5100*D1*Dd*b1*f*fd*s + 1530*D1*Dd*b1*f*fd - 632*D1*Dd*f**3*r**2 - 1264*D1*Dd*f**3*r*s + 948*D1*Dd*f**3*r - 632*D1*Dd*f**3*s**2 + 948*D1*Dd*f**3*s - 474*D1*Dd*f**3 + 2040*D1*Dd*f**2*fd*r**2 + 4080*D1*Dd*f**2*fd*r*s - 2890*D1*Dd*f**2*fd*r + 2040*D1*Dd*f**2*fd*s**2 - 2890*D1*Dd*f**2*fd*s + 1020*D1*Dd*f**2*fd + 1020*D1*Ddd*b1*f**2*r**2 + 2040*D1*Ddd*b1*f**2*r*s - 1530*D1*Ddd*b1*f**2*r + 1020*D1*Ddd*b1*f**2*s**2 - 1530*D1*Ddd*b1*f**2*s + 765*D1*Ddd*b1*f**2 + 340*D1*Ddd*f**3*r**2 + 680*D1*Ddd*f**3*r*s - 510*D1*Ddd*f**3*r + 340*D1*Ddd*f**3*s**2 - 510*D1*Ddd*f**3*s + 255*D1*Ddd*f**3 + 6*D1*bd1*f*(r + s - 1)*(D1*f*(86*C - 71)*(r + s - 1) - D1*fd*(100*C - 85)*(2*r + 2*s - 1) - Dd*f*(100*C - 85)*(4*r + 4*s - 3)) + 3060*Dd**2*b1*f**2*r**2 + 6120*Dd**2*b1*f**2*r*s - 4590*Dd**2*b1*f**2*r + 3060*Dd**2*b1*f**2*s**2 - 4590*Dd**2*b1*f**2*s + 1530*Dd**2*b1*f**2 + 1020*Dd**2*f**3*r**2 + 2040*Dd**2*f**3*r*s - 1530*Dd**2*f**3*r + 1020*Dd**2*f**3*s**2 - 1530*Dd**2*f**3*s + 510*Dd**2*f**3)/(70*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**3*k1*k2**5*st**2*(-5346*C*D1**2*f**2*fd*r**2 - 10692*C*D1**2*f**2*fd*r*s + 7128*C*D1**2*f**2*fd*r - 5346*C*D1**2*f**2*fd*s**2 + 7128*C*D1**2*f**2*fd*s - 3564*C*D1**2*f**2*fd - 7128*C*D1*Dd*f**3*r**2 - 14256*C*D1*Dd*f**3*r*s + 10692*C*D1*Dd*f**3*r - 7128*C*D1*Dd*f**3*s**2 + 10692*C*D1*Dd*f**3*s - 5346*C*D1*Dd*f**3 - 1188*D1**2*K*bdd1*f**2*r**2 - 2376*D1**2*K*bdd1*f**2*r*s + 2376*D1**2*K*bdd1*f**2*r - 1188*D1**2*K*bdd1*f**2*s**2 + 2376*D1**2*K*bdd1*f**2*s - 1188*D1**2*K*bdd1*f**2 + 198*D1**2*bd1**2*f*(-28*K + 25*f + 21)*(r + s - 1)**2 - 1375*D1**2*bdd1*f**3*r**2 - 2750*D1**2*bdd1*f**3*r*s + 2750*D1**2*bdd1*f**3*r - 1375*D1**2*bdd1*f**3*s**2 + 2750*D1**2*bdd1*f**3*s - 1375*D1**2*bdd1*f**3 + 891*D1**2*bdd1*f**2*r**2 + 1782*D1**2*bdd1*f**2*r*s - 1782*D1**2*bdd1*f**2*r + 891*D1**2*bdd1*f**2*s**2 - 1782*D1**2*bdd1*f**2*s + 891*D1**2*bdd1*f**2 + 5544*D1**2*bdd1*f*g2*r**2 + 11088*D1**2*bdd1*f*g2*r*s - 11088*D1**2*bdd1*f*g2*r + 5544*D1**2*bdd1*f*g2*s**2 - 11088*D1**2*bdd1*f*g2*s + 5544*D1**2*bdd1*f*g2 + 8940*D1**2*f**3*fd*r**2 + 17880*D1**2*f**3*fd*r*s - 13410*D1**2*f**3*fd*r + 8940*D1**2*f**3*fd*s**2 - 13410*D1**2*f**3*fd*s + 6705*D1**2*f**3*fd - 7000*D1**2*f**3*fdd*r**2 - 14000*D1**2*f**3*fdd*r*s + 10500*D1**2*f**3*fdd*r - 7000*D1**2*f**3*fdd*s**2 + 10500*D1**2*f**3*fdd*s - 5250*D1**2*f**3*fdd - 21000*D1**2*f**2*fd**2*r**2 - 42000*D1**2*f**2*fd**2*r*s + 31500*D1**2*f**2*fd**2*r - 21000*D1**2*f**2*fd**2*s**2 + 31500*D1**2*f**2*fd**2*s - 10500*D1**2*f**2*fd**2 + 4455*D1**2*f**2*fd*r**2 + 8910*D1**2*f**2*fd*r*s - 5940*D1**2*f**2*fd*r + 4455*D1**2*f**2*fd*s**2 - 5940*D1**2*f**2*fd*s + 2970*D1**2*f**2*fd - 4290*D1**2*f**2*gd2*r**2 - 8580*D1**2*f**2*gd2*r*s + 8580*D1**2*f**2*gd2*r - 4290*D1**2*f**2*gd2*s**2 + 8580*D1**2*f**2*gd2*s - 4290*D1**2*f**2*gd2 + 2376*D1**2*f**2*gdd2*r**2 + 4752*D1**2*f**2*gdd2*r*s - 4752*D1**2*f**2*gdd2*r + 2376*D1**2*f**2*gdd2*s**2 - 4752*D1**2*f**2*gdd2*s + 2376*D1**2*f**2*gdd2 - 8580*D1**2*f*fd*g2*r**2 - 17160*D1**2*f*fd*g2*r*s + 8580*D1**2*f*fd*g2*r - 8580*D1**2*f*fd*g2*s**2 + 8580*D1**2*f*fd*g2*s - 4290*D1**2*f*fd*g2 + 9504*D1**2*f*fd*gd2*r**2 + 19008*D1**2*f*fd*gd2*r*s - 14256*D1**2*f*fd*gd2*r + 9504*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4752*D1**2*f*fd*gd2 + 4752*D1**2*f*fdd*g2*r**2 + 9504*D1**2*f*fdd*g2*r*s - 4752*D1**2*f*fdd*g2*r + 4752*D1**2*f*fdd*g2*s**2 - 4752*D1**2*f*fdd*g2*s + 2376*D1**2*f*fdd*g2 + 4752*D1**2*fd**2*g2*r**2 + 9504*D1**2*fd**2*g2*r*s - 4752*D1**2*fd**2*g2*r + 4752*D1**2*fd**2*g2*s**2 - 4752*D1**2*fd**2*g2*s + 8940*D1*Dd*f**4*r**2 + 17880*D1*Dd*f**4*r*s - 13410*D1*Dd*f**4*r + 8940*D1*Dd*f**4*s**2 - 13410*D1*Dd*f**4*s + 6705*D1*Dd*f**4 - 56000*D1*Dd*f**3*fd*r**2 - 112000*D1*Dd*f**3*fd*r*s + 84000*D1*Dd*f**3*fd*r - 56000*D1*Dd*f**3*fd*s**2 + 84000*D1*Dd*f**3*fd*s - 31500*D1*Dd*f**3*fd + 5940*D1*Dd*f**3*r**2 + 11880*D1*Dd*f**3*r*s - 8910*D1*Dd*f**3*r + 5940*D1*Dd*f**3*s**2 - 8910*D1*Dd*f**3*s + 4455*D1*Dd*f**3 - 17160*D1*Dd*f**2*g2*r**2 - 34320*D1*Dd*f**2*g2*r*s + 25740*D1*Dd*f**2*g2*r - 17160*D1*Dd*f**2*g2*s**2 + 25740*D1*Dd*f**2*g2*s - 12870*D1*Dd*f**2*g2 + 19008*D1*Dd*f**2*gd2*r**2 + 38016*D1*Dd*f**2*gd2*r*s - 33264*D1*Dd*f**2*gd2*r + 19008*D1*Dd*f**2*gd2*s**2 - 33264*D1*Dd*f**2*gd2*s + 14256*D1*Dd*f**2*gd2 + 38016*D1*Dd*f*fd*g2*r**2 + 76032*D1*Dd*f*fd*g2*r*s - 47520*D1*Dd*f*fd*g2*r + 38016*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 - 7000*D1*Ddd*f**4*r**2 - 14000*D1*Ddd*f**4*r*s + 10500*D1*Ddd*f**4*r - 7000*D1*Ddd*f**4*s**2 + 10500*D1*Ddd*f**4*s - 5250*D1*Ddd*f**4 + 9504*D1*Ddd*f**2*g2*r**2 + 19008*D1*Ddd*f**2*g2*r*s - 14256*D1*Ddd*f**2*g2*r + 9504*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 7128*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(97*f**3*(r + s - 1) + f**2*(-378*C*(r + s - 1) - 250*fd*(3*r + 3*s - 2) + (195*K + 174)*(r + s - 1)) - 6*f*(9*fd*(4*K - 3)*(2*r + 2*s - 1) + (133*g2 - 168*gd2)*(r + s - 1)) + 1008*fd*g2*(r + s)) - 2*Dd*f*(125*f**2 + 27*f*(4*K - 3) - 504*g2)*(4*r + 4*s - 3))*(r + s - 1) - 21000*Dd**2*f**4*r**2 - 42000*Dd**2*f**4*r*s + 31500*Dd**2*f**4*r - 21000*Dd**2*f**4*s**2 + 31500*Dd**2*f**4*s - 10500*Dd**2*f**4 + 28512*Dd**2*f**2*g2*r**2 + 57024*Dd**2*f**2*g2*r*s - 42768*Dd**2*f**2*g2*r + 28512*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 14256*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(3*f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 7*fd*(19*K - 13)*(r + s) - 21*fdd*(4*K - 3)*(r + s))) + D1*(Dd*(108*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(150*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (133*K - 91)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(4*K - 3)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-28*K + 25*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-28*K + 25*f + 21)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(756*C*D1**2*f*fd*r**2 + 1512*C*D1**2*f*fd*r*s - 756*C*D1**2*f*fd*r + 756*C*D1**2*f*fd*s**2 - 756*C*D1**2*f*fd*s + 378*C*D1**2*f*fd + 1512*C*D1*Dd*f**2*r**2 + 3024*C*D1*Dd*f**2*r*s - 2268*C*D1*Dd*f**2*r + 1512*C*D1*Dd*f**2*s**2 - 2268*C*D1*Dd*f**2*s + 1134*C*D1*Dd*f**2 - 390*D1**2*K*f*fd*r**2 - 780*D1**2*K*f*fd*r*s + 390*D1**2*K*f*fd*r - 390*D1**2*K*f*fd*s**2 + 390*D1**2*K*f*fd*s - 195*D1**2*K*f*fd + 216*D1**2*K*f*fdd*r**2 + 432*D1**2*K*f*fdd*r*s - 216*D1**2*K*f*fdd*r + 216*D1**2*K*f*fdd*s**2 - 216*D1**2*K*f*fdd*s + 108*D1**2*K*f*fdd + 216*D1**2*K*fd**2*r**2 + 432*D1**2*K*fd**2*r*s - 216*D1**2*K*fd**2*r + 216*D1**2*K*fd**2*s**2 - 216*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(-28*K + 25*f + 21)*(r + s - 1)**2 - 291*D1**2*f**2*fd*r**2 - 582*D1**2*f**2*fd*r*s + 388*D1**2*f**2*fd*r - 291*D1**2*f**2*fd*s**2 + 388*D1**2*f**2*fd*s - 194*D1**2*f**2*fd + 375*D1**2*f**2*fdd*r**2 + 750*D1**2*f**2*fdd*r*s - 500*D1**2*f**2*fdd*r + 375*D1**2*f**2*fdd*s**2 - 500*D1**2*f**2*fdd*s + 250*D1**2*f**2*fdd + 750*D1**2*f*fd**2*r**2 + 1500*D1**2*f*fd**2*r*s - 1000*D1**2*f*fd**2*r + 750*D1**2*f*fd**2*s**2 - 1000*D1**2*f*fd**2*s + 250*D1**2*f*fd**2 - 348*D1**2*f*fd*r**2 - 696*D1**2*f*fd*r*s + 348*D1**2*f*fd*r - 348*D1**2*f*fd*s**2 + 348*D1**2*f*fd*s - 174*D1**2*f*fd - 162*D1**2*f*fdd*r**2 - 324*D1**2*f*fdd*r*s + 162*D1**2*f*fdd*r - 162*D1**2*f*fdd*s**2 + 162*D1**2*f*fdd*s - 81*D1**2*f*fdd + 798*D1**2*f*gd2*r**2 + 1596*D1**2*f*gd2*r*s - 1596*D1**2*f*gd2*r + 798*D1**2*f*gd2*s**2 - 1596*D1**2*f*gd2*s + 798*D1**2*f*gd2 - 504*D1**2*f*gdd2*r**2 - 1008*D1**2*f*gdd2*r*s + 1008*D1**2*f*gdd2*r - 504*D1**2*f*gdd2*s**2 + 1008*D1**2*f*gdd2*s - 504*D1**2*f*gdd2 - 162*D1**2*fd**2*r**2 - 324*D1**2*fd**2*r*s + 162*D1**2*fd**2*r - 162*D1**2*fd**2*s**2 + 162*D1**2*fd**2*s + 798*D1**2*fd*g2*r**2 + 1596*D1**2*fd*g2*r*s + 798*D1**2*fd*g2*s**2 - 1008*D1**2*fd*gd2*r**2 - 2016*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 1008*D1**2*fd*gd2*s**2 + 1008*D1**2*fd*gd2*s - 504*D1**2*fdd*g2*r**2 - 1008*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*s**2 - 780*D1*Dd*K*f**2*r**2 - 1560*D1*Dd*K*f**2*r*s + 1170*D1*Dd*K*f**2*r - 780*D1*Dd*K*f**2*s**2 + 1170*D1*Dd*K*f**2*s - 585*D1*Dd*K*f**2 + 1728*D1*Dd*K*f*fd*r**2 + 3456*D1*Dd*K*f*fd*r*s - 2160*D1*Dd*K*f*fd*r + 1728*D1*Dd*K*f*fd*s**2 - 2160*D1*Dd*K*f*fd*s + 648*D1*Dd*K*f*fd - 388*D1*Dd*f**3*r**2 - 776*D1*Dd*f**3*r*s + 582*D1*Dd*f**3*r - 388*D1*Dd*f**3*s**2 + 582*D1*Dd*f**3*s - 291*D1*Dd*f**3 + 3000*D1*Dd*f**2*fd*r**2 + 6000*D1*Dd*f**2*fd*r*s - 4250*D1*Dd*f**2*fd*r + 3000*D1*Dd*f**2*fd*s**2 - 4250*D1*Dd*f**2*fd*s + 1500*D1*Dd*f**2*fd - 696*D1*Dd*f**2*r**2 - 1392*D1*Dd*f**2*r*s + 1044*D1*Dd*f**2*r - 696*D1*Dd*f**2*s**2 + 1044*D1*Dd*f**2*s - 522*D1*Dd*f**2 - 1296*D1*Dd*f*fd*r**2 - 2592*D1*Dd*f*fd*r*s + 1620*D1*Dd*f*fd*r - 1296*D1*Dd*f*fd*s**2 + 1620*D1*Dd*f*fd*s - 486*D1*Dd*f*fd + 3192*D1*Dd*f*g2*r**2 + 6384*D1*Dd*f*g2*r*s - 4788*D1*Dd*f*g2*r + 3192*D1*Dd*f*g2*s**2 - 4788*D1*Dd*f*g2*s + 2394*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r**2 - 8064*D1*Dd*f*gd2*r*s + 7056*D1*Dd*f*gd2*r - 4032*D1*Dd*f*gd2*s**2 + 7056*D1*Dd*f*gd2*s - 3024*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r**2 - 8064*D1*Dd*fd*g2*r*s + 3024*D1*Dd*fd*g2*r - 4032*D1*Dd*fd*g2*s**2 + 3024*D1*Dd*fd*g2*s + 432*D1*Ddd*K*f**2*r**2 + 864*D1*Ddd*K*f**2*r*s - 648*D1*Ddd*K*f**2*r + 432*D1*Ddd*K*f**2*s**2 - 648*D1*Ddd*K*f**2*s + 324*D1*Ddd*K*f**2 + 500*D1*Ddd*f**3*r**2 + 1000*D1*Ddd*f**3*r*s - 750*D1*Ddd*f**3*r + 500*D1*Ddd*f**3*s**2 - 750*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 - 324*D1*Ddd*f**2*r**2 - 648*D1*Ddd*f**2*r*s + 486*D1*Ddd*f**2*r - 324*D1*Ddd*f**2*s**2 + 486*D1*Ddd*f**2*s - 243*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r**2 - 4032*D1*Ddd*f*g2*r*s + 3024*D1*Ddd*f*g2*r - 2016*D1*Ddd*f*g2*s**2 + 3024*D1*Ddd*f*g2*s - 1512*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(108*f**2*(r + s - 1) - 150*f*fd*(2*r + 2*s - 1) - 7*f*(19*K - 13)*(r + s - 1) + 42*fd*(4*K - 3)*(r + s)) - 6*Dd*f*(-28*K + 25*f + 21)*(4*r + 4*s - 3))*(r + s - 1) + 1296*Dd**2*K*f**2*r**2 + 2592*Dd**2*K*f**2*r*s - 1944*Dd**2*K*f**2*r + 1296*Dd**2*K*f**2*s**2 - 1944*Dd**2*K*f**2*s + 648*Dd**2*K*f**2 + 1500*Dd**2*f**3*r**2 + 3000*Dd**2*f**3*r*s - 2250*Dd**2*f**3*r + 1500*Dd**2*f**3*s**2 - 2250*Dd**2*f**3*s + 750*Dd**2*f**3 - 972*Dd**2*f**2*r**2 - 1944*Dd**2*f**2*r*s + 1458*Dd**2*f**2*r - 972*Dd**2*f**2*s**2 + 1458*Dd**2*f**2*s - 486*Dd**2*f**2 - 6048*Dd**2*f*g2*r**2 - 12096*Dd**2*f*g2*r*s + 9072*Dd**2*f*g2*r - 6048*Dd**2*f*g2*s**2 + 9072*Dd**2*f*g2*s - 3024*Dd**2*f*g2))/(385*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct**3*k1*k2**3*st**4*(b1*(D1**2*(f*(fd*(166*C - 136) + fdd*(75 - 90*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(75 - 90*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(166*C - 136)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(75 - 90*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(75 - 90*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(75 - 90*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(58*C - 48)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (30*C - 25)*(3*bdd1*s*(r + s - 1) + fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(25 - 30*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(166*C - 136)*(r + s - 1) - fd*(90*C - 75)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(75 - 90*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(58*C - 48)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(30*C - 25)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(25 - 30*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(25 - 30*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**3*k1*k2**3*st**2*(105*b1**2*(D1**2*(fd*(26*C - 20) + fdd*(15 - 18*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(13*C - 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(15 - 18*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(15 - 18*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(108*C - 90)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-3112*C*D1**2*f*fd*r**2 - 7008*C*D1**2*f*fd*r*s + 2564*C*D1**2*f*fd*r - 3896*C*D1**2*f*fd*s**2 + 2956*C*D1**2*f*fd*s - 1478*C*D1**2*f*fd + 3096*C*D1**2*f*fdd*r**2 + 6864*C*D1**2*f*fdd*r*s - 2892*C*D1**2*f*fdd*r + 3768*C*D1**2*f*fdd*s**2 - 3228*C*D1**2*f*fdd*s + 1614*C*D1**2*f*fdd + 3096*C*D1**2*fd**2*r**2 + 6864*C*D1**2*fd**2*r*s - 2892*C*D1**2*fd**2*r + 3768*C*D1**2*fd**2*s**2 - 3228*C*D1**2*fd**2*s - 540*C*D1**2*fd**2 - 6224*C*D1*Dd*f**2*r**2 - 14016*C*D1*Dd*f**2*r*s + 10120*C*D1*Dd*f**2*r - 7792*C*D1*Dd*f**2*s**2 + 11296*C*D1*Dd*f**2*s - 5452*C*D1*Dd*f**2 + 24768*C*D1*Dd*f*fd*r**2 + 54912*C*D1*Dd*f*fd*r*s - 31488*C*D1*Dd*f*fd*r + 30144*C*D1*Dd*f*fd*s**2 - 34848*C*D1*Dd*f*fd*s + 9348*C*D1*Dd*f*fd + 6192*C*D1*Ddd*f**2*r**2 + 13728*C*D1*Ddd*f**2*r*s - 9960*C*D1*Ddd*f**2*r + 7536*C*D1*Ddd*f**2*s**2 - 10968*C*D1*Ddd*f**2*s + 5316*C*D1*Ddd*f**2 + 18576*C*Dd**2*f**2*r**2 + 41184*C*Dd**2*f**2*r*s - 29880*C*Dd**2*f**2*r + 22608*C*Dd**2*f**2*s**2 - 32904*C*Dd**2*f**2*s + 10632*C*Dd**2*f**2 - 105*D1**2*bdd1*f*(6*C - 5)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2488*D1**2*f*fd*r**2 + 5736*D1**2*f*fd*r*s - 2108*D1**2*f*fd*r + 3248*D1**2*f*fd*s**2 - 2488*D1**2*f*fd*s + 1244*D1**2*f*fd - 2616*D1**2*f*fdd*r**2 - 5976*D1**2*f*fdd*r*s + 2538*D1**2*f*fdd*r - 3360*D1**2*f*fdd*s**2 + 2910*D1**2*f*fdd*s - 1455*D1**2*f*fdd - 2616*D1**2*fd**2*r**2 - 5976*D1**2*fd**2*r*s + 2538*D1**2*fd**2*r - 3360*D1**2*fd**2*s**2 + 2910*D1**2*fd**2*s + 450*D1**2*fd**2 + 4976*D1*Dd*f**2*r**2 + 11472*D1*Dd*f**2*r*s - 8224*D1*Dd*f**2*r + 6496*D1*Dd*f**2*s**2 - 9364*D1*Dd*f**2*s + 4492*D1*Dd*f**2 - 20928*D1*Dd*f*fd*r**2 - 47808*D1*Dd*f*fd*r*s + 27336*D1*Dd*f*fd*r - 26880*D1*Dd*f*fd*s**2 + 31056*D1*Dd*f*fd*s - 8358*D1*Dd*f*fd - 5232*D1*Ddd*f**2*r**2 - 11952*D1*Ddd*f**2*r*s + 8592*D1*Ddd*f**2*r - 6720*D1*Ddd*f**2*s**2 + 9708*D1*Ddd*f**2*s - 4668*D1*Ddd*f**2 + 70*D1*bd1*(D1*(f*(13*C - 10)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(15 - 18*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(15 - 18*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 15696*Dd**2*f**2*r**2 - 35856*Dd**2*f**2*r*s + 25776*Dd**2*f**2*r - 20160*Dd**2*f**2*s**2 + 29124*Dd**2*f**2*s - 9336*Dd**2*f**2) + f*(-13866*C*D1**2*f*fd*r**2 - 25332*C*D1**2*f*fd*r*s + 17688*C*D1**2*f*fd*r - 11466*C*D1**2*f*fd*s**2 + 16088*C*D1**2*f*fd*s - 8444*C*D1**2*f*fd + 11010*C*D1**2*f*fdd*r**2 + 20388*C*D1**2*f*fdd*r*s - 14136*C*D1**2*f*fdd*r + 9378*C*D1**2*f*fdd*s**2 - 13048*C*D1**2*f*fdd*s + 6796*C*D1**2*f*fdd + 22020*C*D1**2*fd**2*r**2 + 40776*C*D1**2*fd**2*r*s - 28272*C*D1**2*fd**2*r + 18756*C*D1**2*fd**2*s**2 - 26096*C*D1**2*fd**2*s + 6796*C*D1**2*fd**2 - 18488*C*D1*Dd*f**2*r**2 - 33776*C*D1*Dd*f**2*r*s + 26132*C*D1*Dd*f**2*r - 15288*C*D1*Dd*f**2*s**2 + 23732*C*D1*Dd*f**2*s - 12266*C*D1*Dd*f**2 + 88080*C*D1*Dd*f*fd*r**2 + 163104*C*D1*Dd*f*fd*r*s - 119340*C*D1*Dd*f*fd*r + 75024*C*D1*Dd*f*fd*s**2 - 110092*C*D1*Dd*f*fd*s + 40232*C*D1*Dd*f*fd + 14680*C*D1*Ddd*f**2*r**2 + 27184*C*D1*Ddd*f**2*r*s - 20932*C*D1*Ddd*f**2*r + 12504*C*D1*Ddd*f**2*s**2 - 19300*C*D1*Ddd*f**2*s + 9922*C*D1*Ddd*f**2 + 44040*C*Dd**2*f**2*r**2 + 81552*C*Dd**2*f**2*r*s - 62796*C*Dd**2*f**2*r + 37512*C*Dd**2*f**2*s**2 - 57900*C*Dd**2*f**2*s + 19844*C*Dd**2*f**2 - 630*D1**2*bd1**2*(6*C - 5)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(2*C*(258*r**2 + 572*r*s - 606*r + 314*s**2 - 662*s + 303) - 436*r**2 - 996*r*s + 1022*r - 560*s**2 + 1146*s - 511) + 11100*D1**2*f*fd*r**2 + 20832*D1**2*f*fd*r*s - 14344*D1**2*f*fd*r + 9732*D1**2*f*fd*s**2 - 13432*D1**2*f*fd*s + 6944*D1**2*f*fd - 9033*D1**2*f*fdd*r**2 - 17382*D1**2*f*fdd*r*s + 11816*D1**2*f*fdd*r - 8349*D1**2*f*fdd*s**2 + 11360*D1**2*f*fdd*s - 5794*D1**2*f*fdd - 18066*D1**2*fd**2*r**2 - 34764*D1**2*fd**2*r*s + 23632*D1**2*fd**2*r - 16698*D1**2*fd**2*s**2 + 22720*D1**2*fd**2*s - 5794*D1**2*fd**2 + 14800*D1*Dd*f**2*r**2 + 27776*D1*Dd*f**2*r*s - 21288*D1*Dd*f**2*r + 12976*D1*Dd*f**2*s**2 - 19920*D1*Dd*f**2*s + 10188*D1*Dd*f**2 - 72264*D1*Dd*f*fd*r**2 - 139056*D1*Dd*f*fd*r*s + 100094*D1*Dd*f*fd*r - 66792*D1*Dd*f*fd*s**2 + 96218*D1*Dd*f*fd*s - 34536*D1*Dd*f*fd - 12044*D1*Ddd*f**2*r**2 - 23176*D1*Ddd*f**2*r*s + 17610*D1*Ddd*f**2*r - 11132*D1*Ddd*f**2*s**2 + 16926*D1*Ddd*f**2*s - 8577*D1*Ddd*f**2 - 6*D1*bd1*(D1*(f*(C*(778*r**2 + 1752*r*s - 2026*r + 974*s**2 - 2222*s + 1013) - 622*r**2 - 1434*r*s + 1624*r - 812*s**2 + 1814*s - 812) + 3*fd*(-2*C*(516*r**2 + 1144*r*s - 847*r + 628*s**2 - 931*s + 331) + 872*r**2 + 1992*r*s - 1445*r + 1120*s**2 - 1631*s + 573)) - 3*Dd*f*(2*C*(1032*r**2 + 2288*r*s - 2042*r + 1256*s**2 - 2238*s + 965) - 1744*r**2 - 3984*r*s + 3476*r - 2240*s**2 + 3910*s - 1657)) - 36132*Dd**2*f**2*r**2 - 69528*Dd**2*f**2*r*s + 52830*Dd**2*f**2*r - 33396*Dd**2*f**2*s**2 + 50778*Dd**2*f**2*s - 17154*Dd**2*f**2))/(315*d**2*k3**5) - D1**2*Pk1*Pkd3*ct**3*k1*k2**3*(-16632*C*D1**2*bd1*f**2*r**2 - 16632*C*D1**2*bd1*f**2*r*s + 60984*C*D1**2*bd1*f**2*r + 44352*C*D1**2*bd1*f**2*s - 30492*C*D1**2*bd1*f**2 - 65340*C*D1**2*f**2*fd*r**2 - 95040*C*D1**2*f**2*fd*r*s + 75240*C*D1**2*f**2*fd*r - 29700*C*D1**2*f**2*fd*s**2 + 51480*C*D1**2*f**2*fd*s - 31680*C*D1**2*f**2*fd - 87120*C*D1*Dd*f**3*r**2 - 126720*C*D1*Dd*f**3*r*s + 106920*C*D1*Dd*f**3*r - 39600*C*D1*Dd*f**3*s**2 + 71280*C*D1*Dd*f**3*s - 41580*C*D1*Dd*f**3 - 68376*D1**2*K*bd1**2*f*r**2 - 136752*D1**2*K*bd1**2*f*r*s + 164472*D1**2*K*bd1**2*f*r - 68376*D1**2*K*bd1**2*f*s**2 + 164472*D1**2*K*bd1**2*f*s - 96096*D1**2*K*bd1**2*f + 50094*D1**2*K*bd1*f**2*r**2 + 76032*D1**2*K*bd1*f**2*r*s - 76032*D1**2*K*bd1*f**2*r + 25938*D1**2*K*bd1*f**2*s**2 - 51876*D1**2*K*bd1*f**2*s + 25938*D1**2*K*bd1*f**2 - 158400*D1**2*K*bd1*f*fd*r**2 - 285120*D1**2*K*bd1*f*fd*r*s + 221760*D1**2*K*bd1*f*fd*r - 126720*D1**2*K*bd1*f*fd*s**2 + 198000*D1**2*K*bd1*f*fd*s - 71280*D1**2*K*bd1*f*fd - 39600*D1**2*K*bdd1*f**2*r**2 - 71280*D1**2*K*bdd1*f**2*r*s + 71280*D1**2*K*bdd1*f**2*r - 31680*D1**2*K*bdd1*f**2*s**2 + 63360*D1**2*K*bdd1*f**2*s - 31680*D1**2*K*bdd1*f**2 + 58806*D1**2*bd1**2*f**2*r**2 + 128700*D1**2*bd1**2*f**2*r*s - 123156*D1**2*bd1**2*f**2*r + 69894*D1**2*bd1**2*f**2*s**2 - 134244*D1**2*bd1**2*f**2*s + 64350*D1**2*bd1**2*f**2 + 63756*D1**2*bd1**2*f*r**2 + 138600*D1**2*bd1**2*f*r*s - 153846*D1**2*bd1**2*f*r + 74844*D1**2*bd1**2*f*s**2 - 164934*D1**2*bd1**2*f*s + 90090*D1**2*bd1**2*f - 92400*D1**2*bd1**2*g2*r**2 - 184800*D1**2*bd1**2*g2*r*s + 92400*D1**2*bd1**2*g2*r - 92400*D1**2*bd1**2*g2*s**2 + 92400*D1**2*bd1**2*g2*s - 27720*D1**2*bd1*bd2*f*r**2 - 55440*D1**2*bd1*bd2*f*r*s + 55440*D1**2*bd1*bd2*f*r - 27720*D1**2*bd1*bd2*f*s**2 + 55440*D1**2*bd1*bd2*f*s - 27720*D1**2*bd1*bd2*f - 20570*D1**2*bd1*f**3*r**2 - 27500*D1**2*bd1*f**3*r*s + 31570*D1**2*bd1*f**3*r - 6930*D1**2*bd1*f**3*s**2 + 17930*D1**2*bd1*f**3*s - 15125*D1**2*bd1*f**3 + 132990*D1**2*bd1*f**2*fd*r**2 + 189420*D1**2*bd1*f**2*fd*r*s - 175670*D1**2*bd1*f**2*fd*r + 56430*D1**2*bd1*f**2*fd*s**2 - 111870*D1**2*bd1*f**2*fd*s + 41360*D1**2*bd1*f**2*fd - 21582*D1**2*bd1*f**2*r**2 - 44352*D1**2*bd1*f**2*r*s + 9702*D1**2*bd1*f**2*r - 22770*D1**2*bd1*f**2*s**2 + 10890*D1**2*bd1*f**2*s + 1485*D1**2*bd1*f**2 + 131868*D1**2*bd1*f*fd*r**2 + 260568*D1**2*bd1*f*fd*r*s - 196218*D1**2*bd1*f*fd*r + 128700*D1**2*bd1*f*fd*s**2 - 193842*D1**2*bd1*f*fd*s + 65142*D1**2*bd1*f*fd - 62832*D1**2*bd1*f*g2*r**2 - 97944*D1**2*bd1*f*g2*r*s + 190344*D1**2*bd1*f*g2*r - 35112*D1**2*bd1*f*g2*s**2 + 162624*D1**2*bd1*f*g2*s - 95172*D1**2*bd1*f*g2 + 136752*D1**2*bd1*f*gd2*r**2 + 273504*D1**2*bd1*f*gd2*r*s - 328944*D1**2*bd1*f*gd2*r + 136752*D1**2*bd1*f*gd2*s**2 - 328944*D1**2*bd1*f*gd2*s + 192192*D1**2*bd1*f*gd2 + 136752*D1**2*bd1*fd*g2*r**2 + 273504*D1**2*bd1*fd*g2*r*s - 136752*D1**2*bd1*fd*g2*r + 136752*D1**2*bd1*fd*g2*s**2 - 136752*D1**2*bd1*fd*g2*s + 12870*D1**2*bd2*f**2*r**2 + 25740*D1**2*bd2*f**2*r*s - 25740*D1**2*bd2*f**2*r + 12870*D1**2*bd2*f**2*s**2 - 25740*D1**2*bd2*f**2*s + 12870*D1**2*bd2*f**2 - 39600*D1**2*bd2*f*fd*r**2 - 79200*D1**2*bd2*f*fd*r*s + 59400*D1**2*bd2*f*fd*r - 39600*D1**2*bd2*f*fd*s**2 + 59400*D1**2*bd2*f*fd*s - 19800*D1**2*bd2*f*fd + 22165*D1**2*bdd1*f**3*r**2 + 31570*D1**2*bdd1*f**3*r*s - 34100*D1**2*bdd1*f**3*r + 9405*D1**2*bdd1*f**3*s**2 - 21340*D1**2*bdd1*f**3*s + 17710*D1**2*bdd1*f**3 + 32967*D1**2*bdd1*f**2*r**2 + 65142*D1**2*bdd1*f**2*r*s - 65142*D1**2*bdd1*f**2*r + 32175*D1**2*bdd1*f**2*s**2 - 64350*D1**2*bdd1*f**2*s + 32175*D1**2*bdd1*f**2 + 68376*D1**2*bdd1*f*g2*r**2 + 136752*D1**2*bdd1*f*g2*r*s - 192192*D1**2*bdd1*f*g2*r + 68376*D1**2*bdd1*f*g2*s**2 - 192192*D1**2*bdd1*f*g2*s + 96096*D1**2*bdd1*f*g2 - 9900*D1**2*bdd2*f**2*r**2 - 19800*D1**2*bdd2*f**2*r*s + 19800*D1**2*bdd2*f**2*r - 9900*D1**2*bdd2*f**2*s**2 + 19800*D1**2*bdd2*f**2*s - 9900*D1**2*bdd2*f**2 + 28700*D1**2*f**3*fd*r**2 + 88760*D1**2*f**3*fd*r*s - 58730*D1**2*f**3*fd*r + 60060*D1**2*f**3*fd*s**2 - 82250*D1**2*f**3*fd*s + 37205*D1**2*f**3*fd - 28980*D1**2*f**3*fdd*r**2 - 98280*D1**2*f**3*fdd*r*s + 63630*D1**2*f**3*fdd*r - 69300*D1**2*f**3*fdd*s**2 + 93870*D1**2*f**3*fdd*s - 41895*D1**2*f**3*fdd - 86940*D1**2*f**2*fd**2*r**2 - 294840*D1**2*f**2*fd**2*r*s + 190890*D1**2*f**2*fd**2*r - 207900*D1**2*f**2*fd**2*s**2 + 281610*D1**2*f**2*fd**2*s - 83790*D1**2*f**2*fd**2 + 51975*D1**2*f**2*fd*r**2 + 74250*D1**2*f**2*fd*r*s - 59400*D1**2*f**2*fd*r + 22275*D1**2*f**2*fd*s**2 - 39600*D1**2*f**2*fd*s + 24750*D1**2*f**2*fd - 100188*D1**2*f**2*gd2*r**2 - 152064*D1**2*f**2*gd2*r*s + 152064*D1**2*f**2*gd2*r - 51876*D1**2*f**2*gd2*s**2 + 103752*D1**2*f**2*gd2*s - 51876*D1**2*f**2*gd2 + 79200*D1**2*f**2*gdd2*r**2 + 142560*D1**2*f**2*gdd2*r*s - 142560*D1**2*f**2*gdd2*r + 63360*D1**2*f**2*gdd2*s**2 - 126720*D1**2*f**2*gdd2*s + 63360*D1**2*f**2*gdd2 - 200376*D1**2*f*fd*g2*r**2 - 304128*D1**2*f*fd*g2*r*s + 200376*D1**2*f*fd*g2*r - 103752*D1**2*f*fd*g2*s**2 + 152064*D1**2*f*fd*g2*s - 100188*D1**2*f*fd*g2 + 316800*D1**2*f*fd*gd2*r**2 + 570240*D1**2*f*fd*gd2*r*s - 443520*D1**2*f*fd*gd2*r + 253440*D1**2*f*fd*gd2*s**2 - 396000*D1**2*f*fd*gd2*s + 142560*D1**2*f*fd*gd2 + 158400*D1**2*f*fdd*g2*r**2 + 285120*D1**2*f*fdd*g2*r*s - 158400*D1**2*f*fdd*g2*r + 126720*D1**2*f*fdd*g2*s**2 - 142560*D1**2*f*fdd*g2*s + 79200*D1**2*f*fdd*g2 + 158400*D1**2*fd**2*g2*r**2 + 285120*D1**2*fd**2*g2*r*s - 158400*D1**2*fd**2*g2*r + 126720*D1**2*fd**2*g2*s**2 - 142560*D1**2*fd**2*g2*s - 316800*D1*Dd*K*bd1*f**2*r**2 - 570240*D1*Dd*K*bd1*f**2*r*s + 506880*D1*Dd*K*bd1*f**2*r - 253440*D1*Dd*K*bd1*f**2*s**2 + 451440*D1*Dd*K*bd1*f**2*s - 198000*D1*Dd*K*bd1*f**2 + 177320*D1*Dd*bd1*f**3*r**2 + 252560*D1*Dd*bd1*f**3*r*s - 243870*D1*Dd*bd1*f**3*r + 75240*D1*Dd*bd1*f**3*s**2 - 154550*D1*Dd*bd1*f**3*s + 76780*D1*Dd*bd1*f**3 + 263736*D1*Dd*bd1*f**2*r**2 + 521136*D1*Dd*bd1*f**2*r*s - 456786*D1*Dd*bd1*f**2*r + 257400*D1*Dd*bd1*f**2*s**2 - 451242*D1*Dd*bd1*f**2*s + 193842*D1*Dd*bd1*f**2 + 547008*D1*Dd*bd1*f*g2*r**2 + 1094016*D1*Dd*bd1*f*g2*r*s - 1179024*D1*Dd*bd1*f*g2*r + 547008*D1*Dd*bd1*f*g2*s**2 - 1179024*D1*Dd*bd1*f*g2*s + 576576*D1*Dd*bd1*f*g2 - 79200*D1*Dd*bd2*f**2*r**2 - 158400*D1*Dd*bd2*f**2*r*s + 138600*D1*Dd*bd2*f**2*r - 79200*D1*Dd*bd2*f**2*s**2 + 138600*D1*Dd*bd2*f**2*s - 59400*D1*Dd*bd2*f**2 + 28700*D1*Dd*f**4*r**2 + 88760*D1*Dd*f**4*r*s - 58730*D1*Dd*f**4*r + 60060*D1*Dd*f**4*s**2 - 82250*D1*Dd*f**4*s + 37205*D1*Dd*f**4 - 231840*D1*Dd*f**3*fd*r**2 - 786240*D1*Dd*f**3*fd*r*s + 509040*D1*Dd*f**3*fd*r - 554400*D1*Dd*f**3*fd*s**2 + 750960*D1*Dd*f**3*fd*s - 251370*D1*Dd*f**3*fd + 69300*D1*Dd*f**3*r**2 + 99000*D1*Dd*f**3*r*s - 84150*D1*Dd*f**3*r + 29700*D1*Dd*f**3*s**2 - 54450*D1*Dd*f**3*s + 32175*D1*Dd*f**3 - 400752*D1*Dd*f**2*g2*r**2 - 608256*D1*Dd*f**2*g2*r*s + 504504*D1*Dd*f**2*g2*r - 207504*D1*Dd*f**2*g2*s**2 + 359568*D1*Dd*f**2*g2*s - 203940*D1*Dd*f**2*g2 + 633600*D1*Dd*f**2*gd2*r**2 + 1140480*D1*Dd*f**2*gd2*r*s - 1013760*D1*Dd*f**2*gd2*r + 506880*D1*Dd*f**2*gd2*s**2 - 902880*D1*Dd*f**2*gd2*s + 396000*D1*Dd*f**2*gd2 + 1267200*D1*Dd*f*fd*g2*r**2 + 2280960*D1*Dd*f*fd*g2*r*s - 1520640*D1*Dd*f*fd*g2*r + 1013760*D1*Dd*f*fd*g2*s**2 - 1362240*D1*Dd*f*fd*g2*s + 443520*D1*Dd*f*fd*g2 - 28980*D1*Ddd*f**4*r**2 - 98280*D1*Ddd*f**4*r*s + 63630*D1*Ddd*f**4*r - 69300*D1*Ddd*f**4*s**2 + 93870*D1*Ddd*f**4*s - 41895*D1*Ddd*f**4 + 316800*D1*Ddd*f**2*g2*r**2 + 570240*D1*Ddd*f**2*g2*r*s - 443520*D1*Ddd*f**2*g2*r + 253440*D1*Ddd*f**2*g2*s**2 - 396000*D1*Ddd*f**2*g2*s + 205920*D1*Ddd*f**2*g2 - 86940*Dd**2*f**4*r**2 - 294840*Dd**2*f**4*r*s + 190890*Dd**2*f**4*r - 207900*Dd**2*f**4*s**2 + 281610*Dd**2*f**4*s - 83790*Dd**2*f**4 + 950400*Dd**2*f**2*g2*r**2 + 1710720*Dd**2*f**2*g2*r*s - 1330560*Dd**2*f**2*g2*r + 760320*Dd**2*f**2*g2*s**2 - 1188000*Dd**2*f**2*g2*s + 411840*Dd**2*f**2*g2 - 1155*b1**3*(2*D1*Dd*(5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 4*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 9*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + D1*(-D1*(8*fd - 9*fdd)*(r + s - 1)**2 + Ddd*(-20*K + 9*f + 15)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(-20*K + 9*f + 15)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1**2*(-700*C*D1**2*fd*r**2 - 1400*C*D1**2*fd*r*s + 1400*C*D1**2*fd*r - 700*C*D1**2*fd*s**2 + 1400*C*D1**2*fd*s - 700*C*D1**2*fd - 2800*C*D1*Dd*f*r**2 - 5600*C*D1*Dd*f*r*s + 4200*C*D1*Dd*f*r - 2800*C*D1*Dd*f*s**2 + 4200*C*D1*Dd*f*s - 2100*C*D1*Dd*f - 952*D1**2*K*fd*r**2 - 1484*D1**2*K*fd*r*s - 980*D1**2*K*fd*r - 532*D1**2*K*fd*s**2 - 980*D1**2*K*fd*s + 490*D1**2*K*fd + 1036*D1**2*K*fdd*r**2 + 2072*D1**2*K*fdd*r*s + 840*D1**2*K*fdd*r + 1036*D1**2*K*fdd*s**2 + 840*D1**2*K*fdd*s - 420*D1**2*K*fdd + 35*D1**2*bdd1*(-20*K + 9*f + 15)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 1170*D1**2*f*fd*r**2 + 2676*D1**2*f*fd*r*s - 1128*D1**2*f*fd*r + 1506*D1**2*f*fd*s**2 - 1296*D1**2*f*fd*s + 648*D1**2*f*fd - 1782*D1**2*f*fdd*r**2 - 3900*D1**2*f*fdd*r*s + 1950*D1**2*f*fdd*r - 2118*D1**2*f*fdd*s**2 + 2118*D1**2*f*fdd*s - 1059*D1**2*f*fdd - 1782*D1**2*fd**2*r**2 - 3900*D1**2*fd**2*r*s + 1950*D1**2*fd**2*r - 2118*D1**2*fd**2*s**2 + 2118*D1**2*fd**2*s + 1267*D1**2*fd*r**2 + 2310*D1**2*fd*r*s - 490*D1**2*fd*r + 1043*D1**2*fd*s**2 - 490*D1**2*fd*s + 245*D1**2*fd - 966*D1**2*fdd*r**2 - 2100*D1**2*fdd*r*s - 630*D1**2*fdd*r - 1134*D1**2*fdd*s**2 - 630*D1**2*fdd*s + 315*D1**2*fdd - 700*D1**2*gd2*r**2 - 1400*D1**2*gd2*r*s + 1400*D1**2*gd2*r - 700*D1**2*gd2*s**2 + 1400*D1**2*gd2*s - 700*D1**2*gd2 + 1400*D1**2*gdd2*r**2 + 2800*D1**2*gdd2*r*s - 2800*D1**2*gdd2*r + 1400*D1**2*gdd2*s**2 - 2800*D1**2*gdd2*s + 1400*D1**2*gdd2 - 3808*D1*Dd*K*f*r**2 - 5936*D1*Dd*K*f*r*s + 4872*D1*Dd*K*f*r - 2128*D1*Dd*K*f*s**2 + 3612*D1*Dd*K*f*s - 2016*D1*Dd*K*f + 8288*D1*Dd*K*fd*r**2 + 16576*D1*Dd*K*fd*r*s - 2856*D1*Dd*K*fd*r + 8288*D1*Dd*K*fd*s**2 - 2856*D1*Dd*K*fd*s - 2520*D1*Dd*K*fd + 2340*D1*Dd*f**2*r**2 + 5352*D1*Dd*f**2*r*s - 3846*D1*Dd*f**2*r + 3012*D1*Dd*f**2*s**2 - 4350*D1*Dd*f**2*s + 2091*D1*Dd*f**2 - 14256*D1*Dd*f*fd*r**2 - 31200*D1*Dd*f*fd*r*s + 19164*D1*Dd*f*fd*r - 16944*D1*Dd*f*fd*s**2 + 20844*D1*Dd*f*fd*s - 6186*D1*Dd*f*fd + 5068*D1*Dd*f*r**2 + 9240*D1*Dd*f*r*s - 7154*D1*Dd*f*r + 4172*D1*Dd*f*s**2 - 6482*D1*Dd*f*s + 3353*D1*Dd*f - 7728*D1*Dd*fd*r**2 - 16800*D1*Dd*fd*r*s + 3612*D1*Dd*fd*r - 9072*D1*Dd*fd*s**2 + 4116*D1*Dd*fd*s + 1890*D1*Dd*fd - 2800*D1*Dd*g2*r**2 - 5600*D1*Dd*g2*r*s + 4200*D1*Dd*g2*r - 2800*D1*Dd*g2*s**2 + 4200*D1*Dd*g2*s - 2100*D1*Dd*g2 + 11200*D1*Dd*gd2*r**2 + 22400*D1*Dd*gd2*r*s - 19600*D1*Dd*gd2*r + 11200*D1*Dd*gd2*s**2 - 19600*D1*Dd*gd2*s + 8400*D1*Dd*gd2 + 4144*D1*Ddd*K*f*r**2 + 8288*D1*Ddd*K*f*r*s - 6216*D1*Ddd*K*f*r + 4144*D1*Ddd*K*f*s**2 - 6216*D1*Ddd*K*f*s + 3108*D1*Ddd*K*f - 3564*D1*Ddd*f**2*r**2 - 7800*D1*Ddd*f**2*r*s + 5682*D1*Ddd*f**2*r - 4236*D1*Ddd*f**2*s**2 + 6186*D1*Ddd*f**2*s - 3009*D1*Ddd*f**2 - 3864*D1*Ddd*f*r**2 - 8400*D1*Ddd*f*r*s + 6132*D1*Ddd*f*r - 4536*D1*Ddd*f*s**2 + 6636*D1*Ddd*f*s - 3234*D1*Ddd*f + 5600*D1*Ddd*g2*r**2 + 11200*D1*Ddd*g2*r*s - 8400*D1*Ddd*g2*r + 5600*D1*Ddd*g2*s**2 - 8400*D1*Ddd*g2*s + 4200*D1*Ddd*g2 - 70*D1*bd1*(D1*(-5*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 4*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*(-20*K + 9*f + 15)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 12432*Dd**2*K*f*r**2 + 24864*Dd**2*K*f*r*s - 18648*Dd**2*K*f*r + 12432*Dd**2*K*f*s**2 - 18648*Dd**2*K*f*s + 6216*Dd**2*K*f - 10692*Dd**2*f**2*r**2 - 23400*Dd**2*f**2*r*s + 17046*Dd**2*f**2*r - 12708*Dd**2*f**2*s**2 + 18558*Dd**2*f**2*s - 6018*Dd**2*f**2 - 11592*Dd**2*f*r**2 - 25200*Dd**2*f*r*s + 18396*Dd**2*f*r - 13608*Dd**2*f*s**2 + 19908*Dd**2*f*s - 6468*Dd**2*f + 16800*Dd**2*g2*r**2 + 33600*Dd**2*g2*r*s - 25200*Dd**2*g2*r + 16800*Dd**2*g2*s**2 - 25200*Dd**2*g2*s + 8400*Dd**2*g2) - 11*b1*(3024*C*D1**2*f*fd*r**2 + 3024*C*D1**2*f*fd*r*s + 1008*C*D1**2*f*fd*r + 2520*C*D1**2*f*fd*s - 1260*C*D1**2*f*fd + 6048*C*D1*Dd*f**2*r**2 + 6048*C*D1*Dd*f**2*r*s - 6048*C*D1*Dd*f**2*r - 1512*C*D1*Dd*f**2*s + 1512*C*D1*Dd*f**2 + 6216*D1**2*K*bdd1*f*r**2 + 12432*D1**2*K*bdd1*f*r*s - 14952*D1**2*K*bdd1*f*r + 6216*D1**2*K*bdd1*f*s**2 - 14952*D1**2*K*bdd1*f*s + 7476*D1**2*K*bdd1*f - 9108*D1**2*K*f*fd*r**2 - 13824*D1**2*K*f*fd*r*s + 9108*D1**2*K*f*fd*r - 4716*D1**2*K*f*fd*s**2 + 6912*D1**2*K*f*fd*s - 4554*D1**2*K*f*fd + 7200*D1**2*K*f*fdd*r**2 + 12960*D1**2*K*f*fdd*r*s - 7200*D1**2*K*f*fdd*r + 5760*D1**2*K*f*fdd*s**2 - 6480*D1**2*K*f*fdd*s + 3600*D1**2*K*f*fdd + 7200*D1**2*K*fd**2*r**2 + 12960*D1**2*K*fd**2*r*s - 7200*D1**2*K*fd**2*r + 5760*D1**2*K*fd**2*s**2 - 6480*D1**2*K*fd**2*s - 1470*D1**2*b2*fd*r**2 - 2940*D1**2*b2*fd*r*s - 1470*D1**2*b2*fd*s**2 + 1260*D1**2*b2*fdd*r**2 + 2520*D1**2*b2*fdd*r*s + 1260*D1**2*b2*fdd*s**2 + 210*D1**2*bd1**2*(-20*K + 9*f + 15)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 5346*D1**2*bdd1*f**2*r**2 - 11700*D1**2*bdd1*f**2*r*s + 11196*D1**2*bdd1*f**2*r - 6354*D1**2*bdd1*f**2*s**2 + 12204*D1**2*bdd1*f**2*s - 5850*D1**2*bdd1*f**2 - 5796*D1**2*bdd1*f*r**2 - 12600*D1**2*bdd1*f*r*s + 13986*D1**2*bdd1*f*r - 6804*D1**2*bdd1*f*s**2 + 14994*D1**2*bdd1*f*s - 7245*D1**2*bdd1*f + 8400*D1**2*bdd1*g2*r**2 + 16800*D1**2*bdd1*g2*r*s - 8400*D1**2*bdd1*g2*r + 8400*D1**2*bdd1*g2*s**2 - 8400*D1**2*bdd1*g2*s + 4200*D1**2*bdd1*g2 + 1260*D1**2*bdd2*f*r**2 + 2520*D1**2*bdd2*f*r*s - 2520*D1**2*bdd2*f*r + 1260*D1**2*bdd2*f*s**2 - 2520*D1**2*bdd2*f*s + 1260*D1**2*bdd2*f + 5610*D1**2*f**2*fd*r**2 + 7500*D1**2*f**2*fd*r*s - 5870*D1**2*f**2*fd*r + 1890*D1**2*f**2*fd*s**2 - 3390*D1**2*f**2*fd*s + 1755*D1**2*f**2*fd - 6045*D1**2*f**2*fdd*r**2 - 8610*D1**2*f**2*fdd*r*s + 6670*D1**2*f**2*fdd*r - 2565*D1**2*f**2*fdd*s**2 + 4350*D1**2*f**2*fdd*s - 2115*D1**2*f**2*fdd - 12090*D1**2*f*fd**2*r**2 - 17220*D1**2*f*fd**2*r*s + 13340*D1**2*f*fd**2*r - 5130*D1**2*f*fd**2*s**2 + 8700*D1**2*f*fd**2*s - 3690*D1**2*f*fd**2 + 3924*D1**2*f*fd*r**2 + 8064*D1**2*f*fd*r*s - 7074*D1**2*f*fd*r + 4140*D1**2*f*fd*s**2 - 7182*D1**2*f*fd*s + 4167*D1**2*f*fd - 5994*D1**2*f*fdd*r**2 - 11844*D1**2*f*fdd*r*s + 5994*D1**2*f*fdd*r - 5850*D1**2*f*fdd*s**2 + 5922*D1**2*f*fdd*s - 2997*D1**2*f*fdd + 5712*D1**2*f*gd2*r**2 + 8904*D1**2*f*gd2*r*s - 8904*D1**2*f*gd2*r + 3192*D1**2*f*gd2*s**2 - 6384*D1**2*f*gd2*s + 3192*D1**2*f*gd2 - 6216*D1**2*f*gdd2*r**2 - 12432*D1**2*f*gdd2*r*s + 12432*D1**2*f*gdd2*r - 6216*D1**2*f*gdd2*s**2 + 12432*D1**2*f*gdd2*s - 6216*D1**2*f*gdd2 - 5994*D1**2*fd**2*r**2 - 11844*D1**2*fd**2*r*s + 5994*D1**2*fd**2*r - 5850*D1**2*fd**2*s**2 + 5922*D1**2*fd**2*s + 5712*D1**2*fd*g2*r**2 + 8904*D1**2*fd*g2*r*s + 5880*D1**2*fd*g2*r + 3192*D1**2*fd*g2*s**2 + 5880*D1**2*fd*g2*s - 2940*D1**2*fd*g2 - 12432*D1**2*fd*gd2*r**2 - 24864*D1**2*fd*gd2*r*s + 7392*D1**2*fd*gd2*r - 12432*D1**2*fd*gd2*s**2 + 7392*D1**2*fd*gd2*s + 5040*D1**2*fd*gd2 - 6216*D1**2*fdd*g2*r**2 - 12432*D1**2*fdd*g2*r*s - 5040*D1**2*fdd*g2*r - 6216*D1**2*fdd*g2*s**2 - 5040*D1**2*fdd*g2*s + 2520*D1**2*fdd*g2 - 18216*D1*Dd*K*f**2*r**2 - 27648*D1*Dd*K*f**2*r*s + 22932*D1*Dd*K*f**2*r - 9432*D1*Dd*K*f**2*s**2 + 16344*D1*Dd*K*f**2*s - 9270*D1*Dd*K*f**2 + 57600*D1*Dd*K*f*fd*r**2 + 103680*D1*Dd*K*f*fd*r*s - 69120*D1*Dd*K*f*fd*r + 46080*D1*Dd*K*f*fd*s**2 - 61920*D1*Dd*K*f*fd*s + 20160*D1*Dd*K*f*fd - 5880*D1*Dd*b2*f*r**2 - 11760*D1*Dd*b2*f*r*s + 8820*D1*Dd*b2*f*r - 5880*D1*Dd*b2*f*s**2 + 8820*D1*Dd*b2*f*s - 4410*D1*Dd*b2*f + 10080*D1*Dd*b2*fd*r**2 + 20160*D1*Dd*b2*fd*r*s - 7560*D1*Dd*b2*fd*r + 10080*D1*Dd*b2*fd*s**2 - 7560*D1*Dd*b2*fd*s + 7480*D1*Dd*f**3*r**2 + 10000*D1*Dd*f**3*r*s - 8740*D1*Dd*f**3*r + 2520*D1*Dd*f**3*s**2 - 5020*D1*Dd*f**3*s + 3130*D1*Dd*f**3 - 48360*D1*Dd*f**2*fd*r**2 - 68880*D1*Dd*f**2*fd*r*s + 55990*D1*Dd*f**2*fd*r - 20520*D1*Dd*f**2*fd*s**2 + 36270*D1*Dd*f**2*fd*s - 15370*D1*Dd*f**2*fd + 7848*D1*Dd*f**2*r**2 + 16128*D1*Dd*f**2*r*s - 11988*D1*Dd*f**2*r + 8280*D1*Dd*f**2*s**2 - 12312*D1*Dd*f**2*s + 6102*D1*Dd*f**2 - 47952*D1*Dd*f*fd*r**2 - 94752*D1*Dd*f*fd*r*s + 59652*D1*Dd*f*fd*r - 46800*D1*Dd*f*fd*s**2 + 58932*D1*Dd*f*fd*s - 17838*D1*Dd*f*fd + 22848*D1*Dd*f*g2*r**2 + 35616*D1*Dd*f*g2*r*s - 29232*D1*Dd*f*g2*r + 12768*D1*Dd*f*g2*s**2 - 21672*D1*Dd*f*g2*s + 12096*D1*Dd*f*g2 - 49728*D1*Dd*f*gd2*r**2 - 99456*D1*Dd*f*gd2*r*s + 87024*D1*Dd*f*gd2*r - 49728*D1*Dd*f*gd2*s**2 + 87024*D1*Dd*f*gd2*s - 37296*D1*Dd*f*gd2 - 49728*D1*Dd*fd*g2*r**2 - 99456*D1*Dd*fd*g2*r*s + 17136*D1*Dd*fd*g2*r - 49728*D1*Dd*fd*g2*s**2 + 17136*D1*Dd*fd*g2*s + 15120*D1*Dd*fd*g2 + 14400*D1*Ddd*K*f**2*r**2 + 25920*D1*Ddd*K*f**2*r*s - 20160*D1*Ddd*K*f**2*r + 11520*D1*Ddd*K*f**2*s**2 - 18000*D1*Ddd*K*f**2*s + 9360*D1*Ddd*K*f**2 + 5040*D1*Ddd*b2*f*r**2 + 10080*D1*Ddd*b2*f*r*s - 7560*D1*Ddd*b2*f*r + 5040*D1*Ddd*b2*f*s**2 - 7560*D1*Ddd*b2*f*s + 3780*D1*Ddd*b2*f - 8060*D1*Ddd*f**3*r**2 - 11480*D1*Ddd*f**3*r*s + 9770*D1*Ddd*f**3*r - 3420*D1*Ddd*f**3*s**2 + 6290*D1*Ddd*f**3*s - 3725*D1*Ddd*f**3 - 11988*D1*Ddd*f**2*r**2 - 23688*D1*Ddd*f**2*r*s + 17838*D1*Ddd*f**2*r - 11700*D1*Ddd*f**2*s**2 + 17622*D1*Ddd*f**2*s - 8847*D1*Ddd*f**2 - 24864*D1*Ddd*f*g2*r**2 - 49728*D1*Ddd*f*g2*r*s + 37296*D1*Ddd*f*g2*r - 24864*D1*Ddd*f*g2*s**2 + 37296*D1*Ddd*f*g2*s - 18648*D1*Ddd*f*g2 + 3*D1*bd1*(3*D1*f**2*(390*r**2 + r*(892*s - 906) + 502*s**2 - 1018*s + 481) - D1*f*(700*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*K*(136*r**2 + 4*r*(53*s - 78) + 76*s**2 - 252*s + 141) + 12*fd*(594*r**2 + r*(1300*s - 947) + 706*s**2 - 1031*s + 339) - 2534*r**2 - 4620*r*s + 4354*r - 2086*s**2 + 3906*s - 2065) + 14*D1*(4*K*fd*(74*r**2 + r*(148*s - 59) + 74*s**2 - 59*s - 15) + 3*fd*(-92*r**2 + r*(81 - 200*s) - 108*s**2 + 89*s + 15) - 50*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 200*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 12*Dd*f**2*(1188*r**2 + r*(2600*s - 2191) + 1412*s**2 - 2387*s + 989) + 14*Dd*f*(4*K*(296*r**2 + r*(592*s - 578) + 296*s**2 - 578*s + 267) - 1104*r**2 - 96*r*(25*s - 23) - 1296*s**2 + 2376*s - 1047) + 2800*Dd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 210*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 43200*Dd**2*K*f**2*r**2 + 77760*Dd**2*K*f**2*r*s - 60480*Dd**2*K*f**2*r + 34560*Dd**2*K*f**2*s**2 - 54000*Dd**2*K*f**2*s + 18720*Dd**2*K*f**2 + 15120*Dd**2*b2*f*r**2 + 30240*Dd**2*b2*f*r*s - 22680*Dd**2*b2*f*r + 15120*Dd**2*b2*f*s**2 - 22680*Dd**2*b2*f*s + 7560*Dd**2*b2*f - 24180*Dd**2*f**3*r**2 - 34440*Dd**2*f**3*r*s + 29310*Dd**2*f**3*r - 10260*Dd**2*f**3*s**2 + 18870*Dd**2*f**3*s - 7450*Dd**2*f**3 - 35964*Dd**2*f**2*r**2 - 71064*Dd**2*f**2*r*s + 53514*Dd**2*f**2*r - 35100*Dd**2*f**2*s**2 + 52866*Dd**2*f**2*s - 17694*Dd**2*f**2 - 74592*Dd**2*f*g2*r**2 - 149184*Dd**2*f*g2*r*s + 111888*Dd**2*f*g2*r - 74592*Dd**2*f*g2*s**2 + 111888*Dd**2*f*g2*s - 37296*Dd**2*f*g2) + 330*b2*(-42*D1**2*bdd1*f*(r + s - 1)**2 - 3*D1**2*(-f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 7*D1*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*D1*f*(Dd*(-13*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 20*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(6930*d**2*k3**5) + 4*D1**2*Pk1*Pkd3*ct**3*k1*k2*st**2*(7*b1**2*(D1**2*(s - 1)*(fd*(25*C - 19) + fdd*(12 - 15*C))*(r + s - 1) + D1*(Dd*(f*(25*C - 19)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(15*C - 12)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(12 - 15*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(15*C - 12)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(D1**2*(f*(fd*(C*(-110*r*s + 55*r - 110*s**2 + 27*s - 55) + 74*r*s - 37*r + 74*s**2 - 9*s + 37) + (15*C - 12)*(-7*bdd1*s*(2*r + 2*s - 1) + fdd*(6*r*s - 3*r + 6*s**2 - 3*s + 3))) + fd**2*(45*C - 36)*(r*(2*s - 1) + 2*s**2 - s - 1)) + 7*D1*bd1*(D1*(f*s*(25*C - 19)*(2*r + 2*s - 1) - fd*(15*C - 12)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(24 - 30*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(-f*(55*C - 37)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(45*C - 36)*(2*s - 1)*(8*r + 8*s - 3)) + Ddd*f*(45*C - 36)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(45*C - 36)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-21*D1**2*bd1**2*s*(5*C - 4)*(2*r + 2*s - 1) + D1**2*(f*(fd*(62 - 82*C)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + (5*C - 4)*(9*bdd1*s*(r + s - 2) + 10*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(50*C - 40)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(C*(-55*r - 55*s + 138) + 37*r + 37*s - 102) + fd*(45*C - 36)*(r*(4*s - 1) + 4*s**2 - 5*s + 2)) + Dd*f*(45*C - 36)*(r*(8*s - 2) + 8*s**2 - 13*s + 4)) - 2*D1*f*(Dd*(f*(41*C - 31)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(25*C - 20)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(20 - 25*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(50*C - 40)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**3*k1*k2*(-14*b1**2*(D1**2*(fd*(100*C*(s - 1) + r - 81*s + 81) + fdd*(-20*C*(2*r + 5*s - 5) + 27*r + 83*s - 83))*(r + s - 1) + D1*(Dd*(f*(100*C*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 4*r**2 - 320*r*s + 158*r - 324*s**2 + 404*s - 161) + 2*fd*(-10*C*(16*r**2 + 56*r*s - 46*r + 40*s**2 - 67*s + 27) + 108*r**2 + 440*r*s - 357*r + 332*s**2 - 553*s + 221)) + Ddd*f*(-20*C*(8*r**2 + 28*r*s - 18*r + 20*s**2 - 27*s + 12) + 108*r**2 + 440*r*s - 274*r + 332*s**2 - 442*s + 193)) - 2*Dd**2*f*(30*C*(8*r**2 + 2*r*(14*s - 9) + 20*s**2 - 27*s + 8) - 162*r**2 + r*(411 - 660*s) - 498*s**2 + 663*s - 193)) + b1*(14*D1**2*bdd1*f*(20*C*(4*r**2 + 2*r*(7*s - 2) + 10*s**2 - 7*s + 2) - 54*r**2 + r*(54 - 220*s) - 166*s**2 + 110*s - 27) - 3*D1**2*(f*(fd*(4*C*(22*r**2 - 2*r*(2*s + 31) - 26*s**2 - 84*s + 19) - 50*r**2 + 2*r*(54*s + 55) + 158*s**2 + 178*s - 3) - fdd*(4*C*(18*r**2 + 2*r*(6*s - 47) - 6*s**2 - 112*s + 41) - 46*r**2 + r*(68*s + 202) + 114*s**2 + 250*s - 61)) - 2*fd**2*(4*C*(9*r**2 + r*(6*s - 47) - 3*s**2 - 56*s + 59) - 23*r**2 + r*(34*s + 101) + 57*s**2 + 125*s - 182)) - 14*D1*bd1*(D1*(f*(2*r**2 + r*s*(200*C - 160) - 2*r + s**2*(200*C - 162) - s*(100*C - 80) + 1) - 2*fd*(10*C*(8*r**2 + 2*r*(14*s - 9) + 20*s**2 - 27*s + 7) - 54*r**2 + r*(137 - 220*s) - 166*s**2 + 221*s - 55)) - 2*Dd*f*(20*C*(16*r**2 + r*(56*s - 26) + 40*s**2 - 41*s + 9) - 216*r**2 + r*(382 - 880*s) - 664*s**2 + 662*s - 137)) - 3*D1*f*(Dd*(f*(4*C*(44*r**2 - 2*r*(4*s + 9) - 52*s**2 + 54*s - 15) - 100*r**2 + 216*r*s - 58*r + 316*s**2 - 370*s + 133) - 2*fd*(4*C*(72*r**2 + 48*r*s - 218*r - 24*s**2 - 218*s + 159) - 184*r**2 + 272*r*s + 382*r + 456*s**2 + 238*s - 351)) - Ddd*f*(12*C*(12*r**2 + 8*r*s - 10*r - 4*s**2 + 2*s + 1) - 92*r**2 + 136*r*s - 22*r + 228*s**2 - 262*s + 91)) + 6*Dd**2*f**2*(12*C*(18*r**2 + 3*r*(4*s - 5) - 6*s**2 + 3*s + 1) - 138*r**2 + 3*r*(68*s - 11) + 342*s**2 - 393*s + 91)) + f*(28*D1**2*bd1**2*(r**2*(40*C - 27) + r*(20*C*(7*s - 2) - 110*s + 27) + s*(10*C*(10*s - 7) - 83*s + 55)) + 3*D1**2*bdd1*f*(4*C*(9*r**2 + r*(6*s + 70) - 3*s**2 + 112*s - 35) - 23*r**2 + 2*r*(17*s - 95) + 57*s**2 - 398*s + 95) + 5*D1**2*(f*(fd*(4*C*(51*r**2 + 168*r*s - 90*r + 117*s**2 - 134*s + 56) - 135*r**2 - 570*r*s + 280*r - 435*s**2 + 480*s - 190) + fdd*(-4*C*(57*r**2 + 156*r*s - 90*r + 99*s**2 - 118*s + 52) + 153*r**2 + 546*r*s - 284*r + 393*s**2 - 444*s + 182)) + 2*fd**2*(-4*C*(57*r**2 + 156*r*s - 90*r + 99*s**2 - 118*s + 26) + 153*r**2 + 546*r*s - 284*r + 393*s**2 - 444*s + 91)) - 3*D1*bd1*(D1*(f*(4*C*(11*r**2 - 2*r*(s - 21) - 13*s**2 + 112*s - 21) - 25*r**2 + 6*r*(9*s - 19) + 79*s**2 - 390*s + 57) - 2*fd*(4*C*(18*r**2 + r*(12*s + 23) - 6*s**2 + 56*s - 56) - 46*r**2 + r*(68*s - 89) + 114*s**2 - 273*s + 199)) - 2*Dd*f*(4*C*(36*r**2 + r*(24*s + 125) - 12*s**2 + 227*s - 147) - 92*r**2 + 17*r*(8*s - 23) + 228*s**2 - 927*s + 493)) + 5*D1*f*(Dd*(f*(4*C*(68*r**2 + 224*r*s - 146*r + 156*s**2 - 212*s + 95) - 180*r**2 - 760*r*s + 470*r - 580*s**2 + 770*s - 335) - 2*fd*(4*C*(228*r**2 + 624*r*s - 393*r + 396*s**2 - 512*s + 163) - 612*r**2 - 2184*r*s + 1267*r - 1572*s**2 + 1947*s - 586)) + Ddd*f*(-4*C*(76*r**2 + 208*r*s - 142*r + 132*s**2 - 184*s + 85) + 204*r**2 + 728*r*s - 466*r + 524*s**2 - 706*s + 313)) - 10*Dd**2*f**2*(4*C*(114*r**2 + 312*r*s - 213*r + 198*s**2 - 276*s + 85) - 306*r**2 - 1092*r*s + 699*r - 786*s**2 + 1059*s - 313)))/(210*d**2*k3**3) - D1**2*Pk1*Pkd3*ct**3*k1*(4*C - 2)*(-3*D1*f*(7*D1*bd1**2*s*(2*r + 2*s - 1) + D1*bd1*(-3*f*s*(r + s) + 5*fd*(r*(4*s - 1) + s*(4*s - 3))) + 5*D1*bdd1*f*s*(r + s) + 5*Dd*bd1*f*(r*(8*s - 2) + s*(8*s - 5))) + 7*b1**2*(D1**2*(fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(-3*D1**2*(f*(7*bdd1*s*(2*r + 2*s - 1) - 3*fd*(2*s - 1)*(r + s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) + 5*fd**2*(2*s - 1)*(r + s - 1)) + 7*D1*bd1*(D1*(f*s*(2*r + 2*s - 1) - 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 6*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 3*D1*f*(Dd*(-3*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 5*fd*(2*s - 1)*(8*r + 8*s - 7)) + 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 15*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k2*k3) - D1**2*Pk1*Pkd3*ct**3*k2**5*st**4*(1296*C*D1**2*b1*f*fd*r**2 + 1296*C*D1**2*b1*f*fd*r*s - 648*C*D1**2*b1*f*fd*r - 480*C*D1**2*b1*f*fdd*r**2 - 480*C*D1**2*b1*f*fdd*r*s + 240*C*D1**2*b1*f*fdd*r - 480*C*D1**2*b1*fd**2*r**2 - 480*C*D1**2*b1*fd**2*r*s + 240*C*D1**2*b1*fd**2*r + 744*C*D1**2*f**2*fd*r**2 + 744*C*D1**2*f**2*fd*r*s - 744*C*D1**2*f**2*fd*r - 248*C*D1**2*f**2*fd*s + 248*C*D1**2*f**2*fd - 480*C*D1**2*f**2*fdd*r**2 - 480*C*D1**2*f**2*fdd*r*s + 480*C*D1**2*f**2*fdd*r + 160*C*D1**2*f**2*fdd*s - 160*C*D1**2*f**2*fdd - 960*C*D1**2*f*fd**2*r**2 - 960*C*D1**2*f*fd**2*r*s + 960*C*D1**2*f*fd**2*r + 320*C*D1**2*f*fd**2*s - 160*C*D1**2*f*fd**2 + 2592*C*D1*Dd*b1*f**2*r**2 + 2592*C*D1*Dd*b1*f**2*r*s - 2592*C*D1*Dd*b1*f**2*r - 648*C*D1*Dd*b1*f**2*s + 648*C*D1*Dd*b1*f**2 - 3840*C*D1*Dd*b1*f*fd*r**2 - 3840*C*D1*Dd*b1*f*fd*r*s + 2880*C*D1*Dd*b1*f*fd*r + 480*C*D1*Dd*b1*f*fd*s - 240*C*D1*Dd*b1*f*fd + 992*C*D1*Dd*f**3*r**2 + 992*C*D1*Dd*f**3*r*s - 992*C*D1*Dd*f**3*r - 248*C*D1*Dd*f**3*s + 248*C*D1*Dd*f**3 - 3840*C*D1*Dd*f**2*fd*r**2 - 3840*C*D1*Dd*f**2*fd*r*s + 3840*C*D1*Dd*f**2*fd*r + 1120*C*D1*Dd*f**2*fd*s - 800*C*D1*Dd*f**2*fd - 960*C*D1*Ddd*b1*f**2*r**2 - 960*C*D1*Ddd*b1*f**2*r*s + 960*C*D1*Ddd*b1*f**2*r + 240*C*D1*Ddd*b1*f**2*s - 240*C*D1*Ddd*b1*f**2 - 640*C*D1*Ddd*f**3*r**2 - 640*C*D1*Ddd*f**3*r*s + 640*C*D1*Ddd*f**3*r + 160*C*D1*Ddd*f**3*s - 160*C*D1*Ddd*f**3 - 2880*C*Dd**2*b1*f**2*r**2 - 2880*C*Dd**2*b1*f**2*r*s + 2880*C*Dd**2*b1*f**2*r + 720*C*Dd**2*b1*f**2*s - 480*C*Dd**2*b1*f**2 - 1920*C*Dd**2*f**3*r**2 - 1920*C*Dd**2*f**3*r*s + 1920*C*Dd**2*f**3*r + 480*C*Dd**2*f**3*s - 320*C*Dd**2*f**3 - 2196*D1**2*b1*f*fd*r**2 - 3096*D1**2*b1*f*fd*r*s + 1548*D1**2*b1*f*fd*r - 900*D1**2*b1*f*fd*s**2 + 900*D1**2*b1*f*fd*s - 450*D1**2*b1*f*fd + 930*D1**2*b1*f*fdd*r**2 + 1380*D1**2*b1*f*fdd*r*s - 690*D1**2*b1*f*fdd*r + 450*D1**2*b1*f*fdd*s**2 - 450*D1**2*b1*f*fdd*s + 225*D1**2*b1*f*fdd + 930*D1**2*b1*fd**2*r**2 + 1380*D1**2*b1*fd**2*r*s - 690*D1**2*b1*fd**2*r + 450*D1**2*b1*fd**2*s**2 - 450*D1**2*b1*fd**2*s - 15*D1**2*bdd1*f**2*(r + s - 1)*(16*C*(r - 1) - 31*r - 15*s + 31) - 1194*D1**2*f**2*fd*r**2 - 1644*D1**2*f**2*fd*r*s + 1344*D1**2*f**2*fd*r - 450*D1**2*f**2*fd*s**2 + 848*D1**2*f**2*fd*s - 548*D1**2*f**2*fd + 705*D1**2*f**2*fdd*r**2 + 930*D1**2*f**2*fdd*r*s - 780*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 460*D1**2*f**2*fdd*s + 310*D1**2*f**2*fdd + 1410*D1**2*f*fd**2*r**2 + 1860*D1**2*f*fd**2*r*s - 1560*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 920*D1**2*f*fd**2*s + 310*D1**2*f*fd**2 - 4392*D1*Dd*b1*f**2*r**2 - 6192*D1*Dd*b1*f**2*r*s + 5292*D1*Dd*b1*f**2*r - 1800*D1*Dd*b1*f**2*s**2 + 3348*D1*Dd*b1*f**2*s - 1998*D1*Dd*b1*f**2 + 7440*D1*Dd*b1*f*fd*r**2 + 11040*D1*Dd*b1*f*fd*r*s - 7380*D1*Dd*b1*f*fd*r + 3600*D1*Dd*b1*f*fd*s**2 - 4980*D1*Dd*b1*f*fd*s + 1590*D1*Dd*b1*f*fd - 1592*D1*Dd*f**3*r**2 - 2192*D1*Dd*f**3*r*s + 1892*D1*Dd*f**3*r - 600*D1*Dd*f**3*s**2 + 1148*D1*Dd*f**3*s - 698*D1*Dd*f**3 + 5640*D1*Dd*f**2*fd*r**2 + 7440*D1*Dd*f**2*fd*r*s - 6390*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 3670*D1*Dd*f**2*fd*s + 1700*D1*Dd*f**2*fd + 1860*D1*Ddd*b1*f**2*r**2 + 2760*D1*Ddd*b1*f**2*r*s - 2310*D1*Ddd*b1*f**2*r + 900*D1*Ddd*b1*f**2*s**2 - 1590*D1*Ddd*b1*f**2*s + 915*D1*Ddd*b1*f**2 + 940*D1*Ddd*f**3*r**2 + 1240*D1*Ddd*f**3*r*s - 1090*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 610*D1*Ddd*f**3*s + 385*D1*Ddd*f**3 + 6*D1*bd1*f*(D1*(3*f*(r + s - 1)*(36*C*(r - 1) - 61*r - 25*s + 61) - 5*fd*(8*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 62*r**2 - 92*r*s + 85*r - 30*s**2 + 61*s - 23)) - 5*Dd*f*(8*C*(8*r**2 + 8*r*s - 12*r - 5*s + 4) - 124*r**2 - 184*r*s + 201*r - 60*s**2 + 145*s - 77)) + 5580*Dd**2*b1*f**2*r**2 + 8280*Dd**2*b1*f**2*r*s - 6930*Dd**2*b1*f**2*r + 2700*Dd**2*b1*f**2*s**2 - 4770*Dd**2*b1*f**2*s + 1830*Dd**2*b1*f**2 + 2820*Dd**2*f**3*r**2 + 3720*Dd**2*f**3*r*s - 3270*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 1830*Dd**2*f**3*s + 770*Dd**2*f**3)/(210*d**2*k1*k3**5) + D1**2*Pk1*Pkd3*ct**3*k2**5*st**2*(7128*C*D1**2*f**2*fd*r**2 + 7128*C*D1**2*f**2*fd*r*s - 7128*C*D1**2*f**2*fd*r - 2376*C*D1**2*f**2*fd*s + 2376*C*D1**2*f**2*fd + 9504*C*D1*Dd*f**3*r**2 + 9504*C*D1*Dd*f**3*r*s - 9504*C*D1*Dd*f**3*r - 2376*C*D1*Dd*f**3*s + 2376*C*D1*Dd*f**3 + 1386*D1**2*K*bdd1*f**2*r**2 + 1386*D1**2*K*bdd1*f**2*r*s - 1386*D1**2*K*bdd1*f**2*r - 198*D1**2*bd1**2*f*(r + s - 1)*(-14*K*r + 7*K + 25*f*(2*r + 2*s - 1) + 49*r + 35*s - 42) - 605*D1**2*bdd1*f**3*r**2 + 2090*D1**2*bdd1*f**3*r*s - 2420*D1**2*bdd1*f**3*r + 2695*D1**2*bdd1*f**3*s**2 - 5720*D1**2*bdd1*f**3*s + 1650*D1**2*bdd1*f**3 - 2871*D1**2*bdd1*f**2*r**2 - 4356*D1**2*bdd1*f**2*r*s + 4356*D1**2*bdd1*f**2*r - 1485*D1**2*bdd1*f**2*s**2 + 2970*D1**2*bdd1*f**2*s - 1485*D1**2*bdd1*f**2 - 2772*D1**2*bdd1*f*g2*r**2 - 2772*D1**2*bdd1*f*g2*r*s + 5544*D1**2*bdd1*f*g2*r + 2772*D1**2*bdd1*f*g2*s - 2772*D1**2*bdd1*f*g2 - 11740*D1**2*f**3*fd*r**2 - 21640*D1**2*f**3*fd*r*s + 16690*D1**2*f**3*fd*r - 9900*D1**2*f**3*fd*s**2 + 15310*D1**2*f**3*fd*s - 7885*D1**2*f**3*fd + 11700*D1**2*f**3*fdd*r**2 + 23800*D1**2*f**3*fdd*r*s - 17750*D1**2*f**3*fdd*r + 12100*D1**2*f**3*fdd*s**2 - 18050*D1**2*f**3*fdd*s + 8975*D1**2*f**3*fdd + 35100*D1**2*f**2*fd**2*r**2 + 71400*D1**2*f**2*fd**2*r*s - 53250*D1**2*f**2*fd**2*r + 36300*D1**2*f**2*fd**2*s**2 - 54150*D1**2*f**2*fd**2*s + 17950*D1**2*f**2*fd**2 - 11583*D1**2*f**2*fd*r**2 - 16038*D1**2*f**2*fd*r*s + 13068*D1**2*f**2*fd*r - 4455*D1**2*f**2*fd*s**2 + 8316*D1**2*f**2*fd*s - 5346*D1**2*f**2*fd + 4620*D1**2*f**2*gd2*r**2 + 4620*D1**2*f**2*gd2*r*s - 4620*D1**2*f**2*gd2*r - 2772*D1**2*f**2*gdd2*r**2 - 2772*D1**2*f**2*gdd2*r*s + 2772*D1**2*f**2*gdd2*r + 9240*D1**2*f*fd*g2*r**2 + 9240*D1**2*f*fd*g2*r*s - 9240*D1**2*f*fd*g2*r - 4620*D1**2*f*fd*g2*s + 4620*D1**2*f*fd*g2 - 11088*D1**2*f*fd*gd2*r**2 - 11088*D1**2*f*fd*gd2*r*s + 11088*D1**2*f*fd*gd2*r + 2772*D1**2*f*fd*gd2*s - 2772*D1**2*f*fd*gd2 - 5544*D1**2*f*fdd*g2*r**2 - 5544*D1**2*f*fdd*g2*r*s + 5544*D1**2*f*fdd*g2*r + 2772*D1**2*f*fdd*g2*s - 2772*D1**2*f*fdd*g2 - 5544*D1**2*fd**2*g2*r**2 - 5544*D1**2*fd**2*g2*r*s + 5544*D1**2*fd**2*g2*r + 2772*D1**2*fd**2*g2*s - 11740*D1*Dd*f**4*r**2 - 21640*D1*Dd*f**4*r*s + 16690*D1*Dd*f**4*r - 9900*D1*Dd*f**4*s**2 + 15310*D1*Dd*f**4*s - 7885*D1*Dd*f**4 + 93600*D1*Dd*f**3*fd*r**2 + 190400*D1*Dd*f**3*fd*r*s - 142000*D1*Dd*f**3*fd*r + 96800*D1*Dd*f**3*fd*s**2 - 144400*D1*Dd*f**3*fd*s + 53850*D1*Dd*f**3*fd - 15444*D1*Dd*f**3*r**2 - 21384*D1*Dd*f**3*r*s + 18414*D1*Dd*f**3*r - 5940*D1*Dd*f**3*s**2 + 11286*D1*Dd*f**3*s - 6831*D1*Dd*f**3 + 18480*D1*Dd*f**2*g2*r**2 + 18480*D1*Dd*f**2*g2*r*s - 18480*D1*Dd*f**2*g2*r - 4620*D1*Dd*f**2*g2*s + 4620*D1*Dd*f**2*g2 - 22176*D1*Dd*f**2*gd2*r**2 - 22176*D1*Dd*f**2*gd2*r*s + 22176*D1*Dd*f**2*gd2*r + 2772*D1*Dd*f**2*gd2*s - 2772*D1*Dd*f**2*gd2 - 44352*D1*Dd*f*fd*g2*r**2 - 44352*D1*Dd*f*fd*g2*r*s + 44352*D1*Dd*f*fd*g2*r + 16632*D1*Dd*f*fd*g2*s - 11088*D1*Dd*f*fd*g2 + 11700*D1*Ddd*f**4*r**2 + 23800*D1*Ddd*f**4*r*s - 17750*D1*Ddd*f**4*r + 12100*D1*Ddd*f**4*s**2 - 18050*D1*Ddd*f**4*s + 8975*D1*Ddd*f**4 - 11088*D1*Ddd*f**2*g2*r**2 - 11088*D1*Ddd*f**2*g2*r*s + 11088*D1*Ddd*f**2*g2*r + 2772*D1*Ddd*f**2*g2*s - 2772*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(f**3*(299*r**2 + 2*r*(197*s - 5) + 95*s**2 + 194*s - 39) + f**2*(504*C*(r - 1)*(r + s - 1) - 10*fd*(33*r**2 - 114*r*s + 71*r - 147*s**2 + 221*s - 96) - (3*r + 3*s - 3)*(70*K*r + 113*r + 15*s - 183)) + 6*f*(3*fd*(7*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 58*r**2 - 88*r*s + 73*r - 30*s**2 + 52*s - 22) + (r + s - 1)*(154*g2*(r - 1) - 84*gd2*r + 42*gd2)) - 252*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 2*Dd*f*(5*f**2*(44*r**2 + r*(115 - 152*s) - 196*s**2 + 325*s - 126) - 9*f*(7*K*(8*r**2 + 8*r*(s - 1) - s + 1) - 116*r**2 - 176*r*s + 161*r - 60*s**2 + 112*s - 52) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 35100*Dd**2*f**4*r**2 + 71400*Dd**2*f**4*r*s - 53250*Dd**2*f**4*r + 36300*Dd**2*f**4*s**2 - 54150*Dd**2*f**4*s + 17950*Dd**2*f**4 - 33264*Dd**2*f**2*g2*r**2 - 33264*Dd**2*f**2*g2*r*s + 33264*Dd**2*f**2*g2*r + 8316*Dd**2*f**2*g2*s - 5544*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(75*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 150*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 14*fd*(r + s)*(r*(11*K - 26) - 15*s) + 21*fdd*(r + s)*(r*(2*K - 7) - 5*s)) + D1*(2*Dd*(150*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-77*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 75*fd*(4*r + 4*s - 3)**2 + 728*r**2 + 14*r*(82*s - 67) + 420*s**2 - 707*s + 392) + 21*fd*(r**2*(8*K - 28) + r*(K*(8*s - 4) - 48*s + 19) - s*(K + 20*s - 16))) - 3*Ddd*f*(-7*K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 50*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 196*r**2 + 336*r*s - 266*r + 140*s**2 - 224*s + 119)) - 6*Dd**2*f*(-7*K*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 150*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 294*r**2 + 504*r*s - 399*r + 210*s**2 - 336*s + 119)) + 11*b1*(1008*C*D1**2*f*fd*r**2 + 1008*C*D1**2*f*fd*r*s - 504*C*D1**2*f*fd*r + 2016*C*D1*Dd*f**2*r**2 + 2016*C*D1*Dd*f**2*r*s - 2016*C*D1*Dd*f**2*r - 504*C*D1*Dd*f**2*s + 504*C*D1*Dd*f**2 - 420*D1**2*K*f*fd*r**2 - 420*D1**2*K*f*fd*r*s + 420*D1**2*K*f*fd*r + 210*D1**2*K*f*fd*s - 210*D1**2*K*f*fd + 252*D1**2*K*f*fdd*r**2 + 252*D1**2*K*f*fdd*r*s - 252*D1**2*K*f*fdd*r - 126*D1**2*K*f*fdd*s + 126*D1**2*K*f*fdd + 252*D1**2*K*fd**2*r**2 + 252*D1**2*K*fd**2*r*s - 252*D1**2*K*fd**2*r - 126*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(25*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s - 1)*(-28*K*r + 14*K + 98*r + 70*s - 84)) + 897*D1**2*f**2*fd*r**2 + 1182*D1**2*f**2*fd*r*s - 1376*D1**2*f**2*fd*r + 285*D1**2*f**2*fd*s**2 - 968*D1**2*f**2*fd*s + 528*D1**2*f**2*fd - 165*D1**2*f**2*fdd*r**2 + 570*D1**2*f**2*fdd*r*s - 50*D1**2*f**2*fdd*r + 735*D1**2*f**2*fdd*s**2 - 650*D1**2*f**2*fdd*s + 285*D1**2*f**2*fdd - 330*D1**2*f*fd**2*r**2 + 1140*D1**2*f*fd**2*r*s - 100*D1**2*f*fd**2*r + 1470*D1**2*f*fd**2*s**2 - 1300*D1**2*f*fd**2*s - 90*D1**2*f*fd**2 - 678*D1**2*f*fd*r**2 - 768*D1**2*f*fd*r*s + 174*D1**2*f*fd*r - 90*D1**2*f*fd*s**2 - 120*D1**2*f*fd*s + 165*D1**2*f*fd - 522*D1**2*f*fdd*r**2 - 792*D1**2*f*fdd*r*s + 522*D1**2*f*fdd*r - 270*D1**2*f*fdd*s**2 + 396*D1**2*f*fdd*s - 261*D1**2*f*fdd + 924*D1**2*f*gd2*r**2 + 924*D1**2*f*gd2*r*s - 924*D1**2*f*gd2*r - 252*D1**2*f*gdd2*r**2 - 252*D1**2*f*gdd2*r*s + 252*D1**2*f*gdd2*r - 522*D1**2*fd**2*r**2 - 792*D1**2*fd**2*r*s + 522*D1**2*fd**2*r - 270*D1**2*fd**2*s**2 + 396*D1**2*fd**2*s + 924*D1**2*fd*g2*r**2 + 924*D1**2*fd*g2*r*s - 504*D1**2*fd*gd2*r**2 - 504*D1**2*fd*gd2*r*s + 252*D1**2*fd*gd2*r - 252*D1**2*fdd*g2*r**2 - 252*D1**2*fdd*g2*r*s - 840*D1*Dd*K*f**2*r**2 - 840*D1*Dd*K*f**2*r*s + 840*D1*Dd*K*f**2*r + 210*D1*Dd*K*f**2*s - 210*D1*Dd*K*f**2 + 2016*D1*Dd*K*f*fd*r**2 + 2016*D1*Dd*K*f*fd*r*s - 2016*D1*Dd*K*f*fd*r - 756*D1*Dd*K*f*fd*s + 504*D1*Dd*K*f*fd + 1196*D1*Dd*f**3*r**2 + 1576*D1*Dd*f**3*r*s - 1386*D1*Dd*f**3*r + 380*D1*Dd*f**3*s**2 - 774*D1*Dd*f**3*s + 489*D1*Dd*f**3 - 1320*D1*Dd*f**2*fd*r**2 + 4560*D1*Dd*f**2*fd*r*s - 1010*D1*Dd*f**2*fd*r + 5880*D1*Dd*f**2*fd*s**2 - 6110*D1*Dd*f**2*fd*s + 1350*D1*Dd*f**2*fd - 1356*D1*Dd*f**2*r**2 - 1536*D1*Dd*f**2*r*s + 1446*D1*Dd*f**2*r - 180*D1*Dd*f**2*s**2 + 564*D1*Dd*f**2*s - 429*D1*Dd*f**2 - 4176*D1*Dd*f*fd*r**2 - 6336*D1*Dd*f*fd*r*s + 4716*D1*Dd*f*fd*r - 2160*D1*Dd*f*fd*s**2 + 3456*D1*Dd*f*fd*s - 1314*D1*Dd*f*fd + 3696*D1*Dd*f*g2*r**2 + 3696*D1*Dd*f*g2*r*s - 3696*D1*Dd*f*g2*r - 924*D1*Dd*f*g2*s + 924*D1*Dd*f*g2 - 2016*D1*Dd*f*gd2*r**2 - 2016*D1*Dd*f*gd2*r*s + 2016*D1*Dd*f*gd2*r + 252*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 2016*D1*Dd*fd*g2*r**2 - 2016*D1*Dd*fd*g2*r*s + 1008*D1*Dd*fd*g2*r + 252*D1*Dd*fd*g2*s + 504*D1*Ddd*K*f**2*r**2 + 504*D1*Ddd*K*f**2*r*s - 504*D1*Ddd*K*f**2*r - 126*D1*Ddd*K*f**2*s + 126*D1*Ddd*K*f**2 - 220*D1*Ddd*f**3*r**2 + 760*D1*Ddd*f**3*r*s - 270*D1*Ddd*f**3*r + 980*D1*Ddd*f**3*s**2 - 1170*D1*Ddd*f**3*s + 435*D1*Ddd*f**3 - 1044*D1*Ddd*f**2*r**2 - 1584*D1*Ddd*f**2*r*s + 1314*D1*Ddd*f**2*r - 540*D1*Ddd*f**2*s**2 + 936*D1*Ddd*f**2*s - 531*D1*Ddd*f**2 - 1008*D1*Ddd*f*g2*r**2 - 1008*D1*Ddd*f*g2*r*s + 1008*D1*Ddd*f*g2*r + 252*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(75*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(r + s - 1)*(154*K*r - 77*K + 300*fd*(2*r + 2*s - 1) - 364*r - 210*s + 287) + 21*fd*(r**2*(4*K - 14) + r*(4*K*s - 3*K - 24*s + 13) - s*(K + 10*s - 11))) - 3*Dd*f*(-7*K*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 25*f*(4*r + 4*s - 3)**2 + 392*r**2 + 672*r*s - 630*r + 280*s**2 - 532*s + 245)) + 1512*Dd**2*K*f**2*r**2 + 1512*Dd**2*K*f**2*r*s - 1512*Dd**2*K*f**2*r - 378*Dd**2*K*f**2*s + 252*Dd**2*K*f**2 - 660*Dd**2*f**3*r**2 + 2280*Dd**2*f**3*r*s - 810*Dd**2*f**3*r + 2940*Dd**2*f**3*s**2 - 3510*Dd**2*f**3*s + 870*Dd**2*f**3 - 3132*Dd**2*f**2*r**2 - 4752*Dd**2*f**2*r*s + 3942*Dd**2*f**2*r - 1620*Dd**2*f**2*s**2 + 2808*Dd**2*f**2*s - 1062*Dd**2*f**2 - 3024*Dd**2*f*g2*r**2 - 3024*Dd**2*f*g2*r*s + 3024*Dd**2*f*g2*r + 756*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(3465*d**2*k1*k3**5) + 2*D1**2*Pk1*Pkd3*ct**3*k2**3*st**4*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(7*d**2*k1*k3**3) - D1**2*Pk1*Pkd3*ct**3*k2**3*st**2*(21*b1**2*(D1**2*(fd*(r*(44*C - 50) - 6*s + 6) - 3*fdd*(r*(4*C - 5) - s + 1))*(r + s - 1) + D1*(2*Dd*(f*(22*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 100*r**2 - 112*r*s + 106*r - 12*s**2 + 40*s - 31) + 3*fd*(-2*C*(8*r**2 + 8*r*(s - 1) - s + 1) + 20*r**2 + 24*r*s - 23*r + 4*s**2 - 9*s + 5)) + 3*Ddd*f*(-4*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 20*r**2 + 24*r*s - 22*r + 4*s**2 - 10*s + 7)) - 6*Dd**2*f*(C*(24*r**2 + 24*r*(s - 1) - 6*s + 4) - 30*r**2 + r*(33 - 36*s) - 6*s**2 + 15*s - 7)) + 3*b1*(280*C*D1**2*f*fd*r**2 + 280*C*D1**2*f*fd*r*s - 420*C*D1**2*f*fd*r - 140*C*D1**2*f*fd*s + 140*C*D1**2*f*fd - 168*C*D1**2*f*fdd*r**2 - 168*C*D1**2*f*fdd*r*s + 252*C*D1**2*f*fdd*r + 84*C*D1**2*f*fdd*s - 84*C*D1**2*f*fdd - 168*C*D1**2*fd**2*r**2 - 168*C*D1**2*fd**2*r*s + 252*C*D1**2*fd**2*r + 84*C*D1**2*fd**2*s - 84*C*D1**2*fd**2 + 560*C*D1*Dd*f**2*r**2 + 560*C*D1*Dd*f**2*r*s - 560*C*D1*Dd*f**2*r - 140*C*D1*Dd*f**2*s + 140*C*D1*Dd*f**2 - 1344*C*D1*Dd*f*fd*r**2 - 1344*C*D1*Dd*f*fd*r*s + 1680*C*D1*Dd*f*fd*r + 504*C*D1*Dd*f*fd*s - 420*C*D1*Dd*f*fd - 336*C*D1*Ddd*f**2*r**2 - 336*C*D1*Ddd*f**2*r*s + 336*C*D1*Ddd*f**2*r + 84*C*D1*Ddd*f**2*s - 84*C*D1*Ddd*f**2 - 1008*C*Dd**2*f**2*r**2 - 1008*C*Dd**2*f**2*r*s + 1008*C*Dd**2*f**2*r + 252*C*Dd**2*f**2*s - 168*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(C*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 10*r**2 - 12*r*s + 10*r - 2*s**2 + 6*s - 5) - 10*D1**2*f*fd*r**2 + 452*D1**2*f*fd*r*s + 90*D1**2*f*fd*r + 462*D1**2*f*fd*s**2 - 286*D1**2*f*fd*s + 73*D1**2*f*fd + 12*D1**2*f*fdd*r**2 - 408*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 420*D1**2*f*fdd*s**2 + 318*D1**2*f*fdd*s - 117*D1**2*f*fdd + 12*D1**2*fd**2*r**2 - 408*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 420*D1**2*fd**2*s**2 + 318*D1**2*fd**2*s + 102*D1**2*fd**2 - 20*D1*Dd*f**2*r**2 + 904*D1*Dd*f**2*r*s - 442*D1*Dd*f**2*r + 924*D1*Dd*f**2*s**2 - 1150*D1*Dd*f**2*s + 457*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 - 3264*D1*Dd*f*fd*r*s + 864*D1*Dd*f*fd*r - 3360*D1*Dd*f*fd*s**2 + 3360*D1*Dd*f*fd*s - 654*D1*Dd*f*fd + 24*D1*Ddd*f**2*r**2 - 816*D1*Ddd*f**2*r*s + 396*D1*Ddd*f**2*r - 840*D1*Ddd*f**2*s**2 + 1044*D1*Ddd*f**2*s - 414*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(22*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 50*r**2 - 56*r*s + 50*r - 6*s**2 + 28*s - 25) + 3*fd*(C*(-8*r**2 - 8*r*s + 8*r + 2*s - 2) + 10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3)) - 3*Dd*f*(4*C*(8*r**2 + 8*r*(s - 1) - 3*s + 2) - 40*r**2 - 48*r*s + 42*r - 8*s**2 + 22*s - 11)) + 72*Dd**2*f**2*r**2 - 2448*Dd**2*f**2*r*s + 1188*Dd**2*f**2*r - 2520*Dd**2*f**2*s**2 + 3132*Dd**2*f**2*s - 828*Dd**2*f**2) - f*(528*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s - 528*C*D1**2*f*fd*r - 176*C*D1**2*f*fd*s + 176*C*D1**2*f*fd - 480*C*D1**2*f*fdd*r**2 - 480*C*D1**2*f*fdd*r*s + 480*C*D1**2*f*fdd*r + 160*C*D1**2*f*fdd*s - 160*C*D1**2*f*fdd - 960*C*D1**2*fd**2*r**2 - 960*C*D1**2*fd**2*r*s + 960*C*D1**2*fd**2*r + 320*C*D1**2*fd**2*s - 160*C*D1**2*fd**2 + 704*C*D1*Dd*f**2*r**2 + 704*C*D1*Dd*f**2*r*s - 704*C*D1*Dd*f**2*r - 176*C*D1*Dd*f**2*s + 176*C*D1*Dd*f**2 - 3840*C*D1*Dd*f*fd*r**2 - 3840*C*D1*Dd*f*fd*r*s + 3840*C*D1*Dd*f*fd*r + 1120*C*D1*Dd*f*fd*s - 800*C*D1*Dd*f*fd - 640*C*D1*Ddd*f**2*r**2 - 640*C*D1*Ddd*f**2*r*s + 640*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s - 160*C*D1*Ddd*f**2 - 1920*C*Dd**2*f**2*r**2 - 1920*C*Dd**2*f**2*r*s + 1920*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s - 320*C*Dd**2*f**2 + 126*D1**2*bd1**2*(r**2*(4*C - 5) + r*(4*C*(s - 1) - 6*s + 5) - s*(2*C + s - 3)) + 9*D1**2*bdd1*f*(r**2*(28*C - 2) + r*(s*(28*C + 68) - 58) + 70*s**2 - 102*s + 29) - 1353*D1**2*f*fd*r**2 - 2382*D1**2*f*fd*r*s + 1696*D1**2*f*fd*r - 1029*D1**2*f*fd*s**2 + 1480*D1**2*f*fd*s - 794*D1**2*f*fd + 987*D1**2*f*fdd*r**2 + 1866*D1**2*f*fdd*r*s - 1280*D1**2*f*fdd*r + 879*D1**2*f*fdd*s**2 - 1208*D1**2*f*fdd*s + 622*D1**2*f*fdd + 1974*D1**2*fd**2*r**2 + 3732*D1**2*fd**2*r*s - 2560*D1**2*fd**2*r + 1758*D1**2*fd**2*s**2 - 2416*D1**2*fd**2*s + 622*D1**2*fd**2 - 1804*D1*Dd*f**2*r**2 - 3176*D1*Dd*f**2*r*s + 2490*D1*Dd*f**2*r - 1372*D1*Dd*f**2*s**2 + 2166*D1*Dd*f**2*s - 1137*D1*Dd*f**2 + 7896*D1*Dd*f*fd*r**2 + 14928*D1*Dd*f*fd*r*s - 10826*D1*Dd*f*fd*r + 7032*D1*Dd*f*fd*s**2 - 10214*D1*Dd*f*fd*s + 3696*D1*Dd*f*fd + 1316*D1*Ddd*f**2*r**2 + 2488*D1*Ddd*f**2*r*s - 1902*D1*Ddd*f**2*r + 1172*D1*Ddd*f**2*s**2 - 1794*D1*Ddd*f**2*s + 915*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r**2*(140*C - 5) + 2*r*(70*C*s + 113*s - 153) + 231*s**2 - 402*s + 153) - 6*fd*(-14*C*s + r**2*(56*C - 4) + r*(56*C*s - 42*C + 136*s - 61) + 140*s**2 - 155*s + 51)) - 6*Dd*f*(r**2*(112*C - 8) + 2*r*(28*C*(2*s - 1) + 136*s - 91) + 280*s**2 - s*(14*C + 378) + 131)) + 3948*Dd**2*f**2*r**2 + 7464*Dd**2*f**2*r*s - 5706*Dd**2*f**2*r + 3516*Dd**2*f**2*s**2 - 5382*Dd**2*f**2*s + 1830*Dd**2*f**2))/(315*d**2*k1*k3**3) + D1**2*Pk1*Pkd3*ct**3*k2**3*(-72*D1**2*K*bdd1*f**2*r**2 - 72*D1**2*K*bdd1*f**2*r*s + 72*D1**2*K*bdd1*f**2*r + 288*D1**2*b2*f*fd*r**2 + 288*D1**2*b2*f*fd*r*s - 288*D1**2*b2*f*fd*r - 144*D1**2*b2*f*fd*s + 144*D1**2*b2*f*fd - 144*D1**2*b2*f*fdd*r**2 - 144*D1**2*b2*f*fdd*r*s + 144*D1**2*b2*f*fdd*r + 72*D1**2*b2*f*fdd*s - 72*D1**2*b2*f*fdd - 144*D1**2*b2*fd**2*r**2 - 144*D1**2*b2*fd**2*r*s + 144*D1**2*b2*fd**2*r + 72*D1**2*b2*fd**2*s + 6*D1**2*bd1**2*f*(3*f*(13*r**2 + 2*r*(53*s - 25) + 93*s**2 - 106*s + 33) + 7*r**2*(8*K - 4) + 7*r*(8*K*s - 4*K + 24*s - 19) + 196*s**2 - 329*s + 133) + 144*D1**2*bd2*f**2*r**2 + 144*D1**2*bd2*f**2*r*s - 144*D1**2*bd2*f**2*r - 288*D1**2*bd2*f*fd*r**2 - 288*D1**2*bd2*f*fd*r*s + 288*D1**2*bd2*f*fd*r + 72*D1**2*bd2*f*fd*s - 72*D1**2*bd2*f*fd + 310*D1**2*bdd1*f**3*r**2 + 940*D1**2*bdd1*f**3*r*s - 510*D1**2*bdd1*f**3*r + 630*D1**2*bdd1*f**3*s**2 - 630*D1**2*bdd1*f**3*s + 315*D1**2*bdd1*f**3 + 261*D1**2*bdd1*f**2*r**2 + 666*D1**2*bdd1*f**2*r*s - 666*D1**2*bdd1*f**2*r + 405*D1**2*bdd1*f**2*s**2 - 810*D1**2*bdd1*f**2*s + 405*D1**2*bdd1*f**2 - 336*D1**2*bdd1*f*g2*r**2 - 336*D1**2*bdd1*f*g2*r*s - 72*D1**2*bdd2*f**2*r**2 - 72*D1**2*bdd2*f**2*r*s + 72*D1**2*bdd2*f**2*r + 540*D1**2*f**2*fd*r**2 + 540*D1**2*f**2*fd*r*s - 540*D1**2*f**2*fd*r - 180*D1**2*f**2*fd*s + 180*D1**2*f**2*fd - 288*D1**2*f**2*gd2*r**2 - 288*D1**2*f**2*gd2*r*s + 288*D1**2*f**2*gd2*r + 144*D1**2*f**2*gdd2*r**2 + 144*D1**2*f**2*gdd2*r*s - 144*D1**2*f**2*gdd2*r - 576*D1**2*f*fd*g2*r**2 - 576*D1**2*f*fd*g2*r*s + 576*D1**2*f*fd*g2*r + 288*D1**2*f*fd*g2*s - 288*D1**2*f*fd*g2 + 576*D1**2*f*fd*gd2*r**2 + 576*D1**2*f*fd*gd2*r*s - 576*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s + 144*D1**2*f*fd*gd2 + 288*D1**2*f*fdd*g2*r**2 + 288*D1**2*f*fdd*g2*r*s - 288*D1**2*f*fdd*g2*r - 144*D1**2*f*fdd*g2*s + 144*D1**2*f*fdd*g2 + 288*D1**2*fd**2*g2*r**2 + 288*D1**2*fd**2*g2*r*s - 288*D1**2*fd**2*g2*r - 144*D1**2*fd**2*g2*s + 576*D1*Dd*b2*f**2*r**2 + 576*D1*Dd*b2*f**2*r*s - 576*D1*Dd*b2*f**2*r - 144*D1*Dd*b2*f**2*s + 144*D1*Dd*b2*f**2 - 1152*D1*Dd*b2*f*fd*r**2 - 1152*D1*Dd*b2*f*fd*r*s + 1152*D1*Dd*b2*f*fd*r + 432*D1*Dd*b2*f*fd*s - 288*D1*Dd*b2*f*fd - 576*D1*Dd*bd2*f**2*r**2 - 576*D1*Dd*bd2*f**2*r*s + 576*D1*Dd*bd2*f**2*r + 72*D1*Dd*bd2*f**2*s - 72*D1*Dd*bd2*f**2 + 720*D1*Dd*f**3*r**2 + 720*D1*Dd*f**3*r*s - 720*D1*Dd*f**3*r - 180*D1*Dd*f**3*s + 180*D1*Dd*f**3 - 1152*D1*Dd*f**2*g2*r**2 - 1152*D1*Dd*f**2*g2*r*s + 1152*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s - 288*D1*Dd*f**2*g2 + 1152*D1*Dd*f**2*gd2*r**2 + 1152*D1*Dd*f**2*gd2*r*s - 1152*D1*Dd*f**2*gd2*r - 144*D1*Dd*f**2*gd2*s + 144*D1*Dd*f**2*gd2 + 2304*D1*Dd*f*fd*g2*r**2 + 2304*D1*Dd*f*fd*g2*r*s - 2304*D1*Dd*f*fd*g2*r - 864*D1*Dd*f*fd*g2*s + 576*D1*Dd*f*fd*g2 - 288*D1*Ddd*b2*f**2*r**2 - 288*D1*Ddd*b2*f**2*r*s + 288*D1*Ddd*b2*f**2*r + 72*D1*Ddd*b2*f**2*s - 72*D1*Ddd*b2*f**2 + 576*D1*Ddd*f**2*g2*r**2 + 576*D1*Ddd*f**2*g2*r*s - 576*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s + 144*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(106*r**2 + 2*r*(98*s - 57) + 90*s**2 - 90*s + 45) + f**2*(20*fd*(93*r**2 + 2*r*(141*s - 88) + 189*s**2 - 236*s + 57) + 9*r**2*(56*C + 16*K - 114) + 18*r*(28*C*s + 8*K*(s - 1) - 74*s + 25) - 306*s**2 + 234*s + 9) - 6*f*(3*fd*(4*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 58*r**2 - 148*r*s + 103*r - 90*s**2 + 127*s - 37) + 28*r*(-9*g2*(r + s) + gd2*(4*r + 4*s - 2))) - 336*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + 2*Dd*f*(5*f**2*(248*r**2 + r*(752*s - 454) + 504*s**2 - 598*s + 177) - 9*f*(4*K*(8*r**2 + 8*r*(s - 1) - s + 1) - 116*r**2 - 296*r*s + 251*r - 180*s**2 + 307*s - 127) - 168*g2*(8*r**2 + r*(8*s - 4) - s))) - 864*Dd**2*b2*f**2*r**2 - 864*Dd**2*b2*f**2*r*s + 864*Dd**2*b2*f**2*r + 216*Dd**2*b2*f**2*s - 144*Dd**2*b2*f**2 + 1728*Dd**2*f**2*g2*r**2 + 1728*Dd**2*f**2*g2*r*s - 1728*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s + 288*Dd**2*f**2*g2 + 21*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(-30*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 140*r**2 - 5*r*(30 - 32*s) + 5*(3 - 2*s)**2) - Ddd*(3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(280*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 1120*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 1120*C*D1*Dd*f*r - 280*C*D1*Dd*f*s + 280*C*D1*Dd*f - 252*D1**2*K*fd*r**2 - 252*D1**2*K*fd*r*s + 504*D1**2*K*fd*r + 252*D1**2*K*fd*s - 252*D1**2*K*fd + 56*D1**2*K*fdd*r**2 + 56*D1**2*K*fdd*r*s - 112*D1**2*K*fdd*r - 56*D1**2*K*fdd*s + 56*D1**2*K*fdd - 7*D1**2*bdd1*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 72*D1**2*f*fd*r**2 - 432*D1**2*f*fd*r*s + 198*D1**2*f*fd*r - 360*D1**2*f*fd*s**2 + 462*D1**2*f*fd*s - 207*D1**2*f*fd + 78*D1**2*f*fdd*r**2 + 636*D1**2*f*fdd*r*s - 414*D1**2*f*fdd*r + 558*D1**2*f*fdd*s**2 - 798*D1**2*f*fdd*s + 387*D1**2*f*fdd + 78*D1**2*fd**2*r**2 + 636*D1**2*fd**2*r*s - 414*D1**2*fd**2*r + 558*D1**2*fd**2*s**2 - 798*D1**2*fd**2*s + 240*D1**2*fd**2 - 224*D1**2*fd*r**2 - 336*D1**2*fd*r*s - 238*D1**2*fd*r - 112*D1**2*fd*s**2 - 266*D1**2*fd*s + 259*D1**2*fd - 28*D1**2*fdd*r**2 + 168*D1**2*fdd*r*s + 154*D1**2*fdd*r + 196*D1**2*fdd*s**2 + 98*D1**2*fdd*s - 77*D1**2*fdd + 840*D1**2*gd2*r**2 + 840*D1**2*gd2*r*s - 840*D1**2*gd2*r - 1008*D1*Dd*K*f*r**2 - 1008*D1*Dd*K*f*r*s + 1008*D1*Dd*K*f*r + 252*D1*Dd*K*f*s - 252*D1*Dd*K*f + 448*D1*Dd*K*fd*r**2 + 448*D1*Dd*K*fd*r*s - 672*D1*Dd*K*fd*r - 280*D1*Dd*K*fd*s + 224*D1*Dd*K*fd - 144*D1*Dd*f**2*r**2 - 864*D1*Dd*f**2*r*s + 504*D1*Dd*f**2*r - 720*D1*Dd*f**2*s**2 + 936*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 624*D1*Dd*f*fd*r**2 + 5088*D1*Dd*f*fd*r*s - 3084*D1*Dd*f*fd*r + 4464*D1*Dd*f*fd*s**2 - 6060*D1*Dd*f*fd*s + 2010*D1*Dd*f*fd - 896*D1*Dd*f*r**2 - 1344*D1*Dd*f*r*s + 1120*D1*Dd*f*r - 448*D1*Dd*f*s**2 + 784*D1*Dd*f*s - 448*D1*Dd*f - 224*D1*Dd*fd*r**2 + 1344*D1*Dd*fd*r*s + 336*D1*Dd*fd*r + 1568*D1*Dd*fd*s**2 - 560*D1*Dd*fd*s - 350*D1*Dd*fd + 3360*D1*Dd*g2*r**2 + 3360*D1*Dd*g2*r*s - 3360*D1*Dd*g2*r - 840*D1*Dd*g2*s + 840*D1*Dd*g2 + 224*D1*Ddd*K*f*r**2 + 224*D1*Ddd*K*f*r*s - 224*D1*Ddd*K*f*r - 56*D1*Ddd*K*f*s + 56*D1*Ddd*K*f + 156*D1*Ddd*f**2*r**2 + 1272*D1*Ddd*f**2*r*s - 714*D1*Ddd*f**2*r + 1116*D1*Ddd*f**2*s**2 - 1434*D1*Ddd*f**2*s + 597*D1*Ddd*f**2 - 112*D1*Ddd*f*r**2 + 672*D1*Ddd*f*r*s - 280*D1*Ddd*f*r + 784*D1*Ddd*f*s**2 - 952*D1*Ddd*f*s + 364*D1*Ddd*f + 14*D1*bd1*(D1*(-30*K*(3*r**2 + 3*r*(s - 1) - s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 105*r**2 + 120*r*s - 110*r + 15*s**2 - 50*s + 40) - Dd*(3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 672*Dd**2*K*f*r**2 + 672*Dd**2*K*f*r*s - 672*Dd**2*K*f*r - 168*Dd**2*K*f*s + 112*Dd**2*K*f + 468*Dd**2*f**2*r**2 + 3816*Dd**2*f**2*r*s - 2142*Dd**2*f**2*r + 3348*Dd**2*f**2*s**2 - 4302*Dd**2*f**2*s + 1194*Dd**2*f**2 - 336*Dd**2*f*r**2 + 2016*Dd**2*f*r*s - 840*Dd**2*f*r + 2352*Dd**2*f*s**2 - 2856*Dd**2*f*s + 728*Dd**2*f) + b1*(1008*C*D1**2*f*fd*r**2 + 1008*C*D1**2*f*fd*r*s - 1512*C*D1**2*f*fd*r - 504*C*D1**2*f*fd*s + 504*C*D1**2*f*fd + 2016*C*D1*Dd*f**2*r**2 + 2016*C*D1*Dd*f**2*r*s - 2016*C*D1*Dd*f**2*r - 504*C*D1*Dd*f**2*s + 504*C*D1*Dd*f**2 + 288*D1**2*K*f*fd*r**2 + 288*D1**2*K*f*fd*r*s - 288*D1**2*K*f*fd*r - 144*D1**2*K*f*fd*s + 144*D1**2*K*f*fd - 144*D1**2*K*f*fdd*r**2 - 144*D1**2*K*f*fdd*r*s + 144*D1**2*K*f*fdd*r + 72*D1**2*K*f*fdd*s - 72*D1**2*K*f*fdd - 144*D1**2*K*fd**2*r**2 - 144*D1**2*K*fd**2*r*s + 144*D1**2*K*fd**2*r + 72*D1**2*K*fd**2*s - 42*D1**2*bd1**2*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 3*D1**2*bdd1*f*(6*f*(13*r**2 + 2*r*(53*s - 25) + 93*s**2 - 106*s + 35) + 7*r**2*(16*K - 8) + 14*r*(8*K*s - 4*K + 24*s - 19) + 392*s**2 - 658*s + 245) - 1590*D1**2*f**2*fd*r**2 - 2940*D1**2*f**2*fd*r*s + 2450*D1**2*f**2*fd*r - 1350*D1**2*f**2*fd*s**2 + 2330*D1**2*f**2*fd*s - 1205*D1**2*f**2*fd + 930*D1**2*f**2*fdd*r**2 + 2820*D1**2*f**2*fdd*r*s - 1990*D1**2*f**2*fdd*r + 1890*D1**2*f**2*fdd*s**2 - 2830*D1**2*f**2*fdd*s + 1255*D1**2*f**2*fdd + 1860*D1**2*f*fd**2*r**2 + 5640*D1**2*f*fd**2*r*s - 3980*D1**2*f*fd**2*r + 3780*D1**2*f*fd**2*s**2 - 5660*D1**2*f*fd**2*s + 2000*D1**2*f*fd**2 - 2052*D1**2*f*fd*r**2 - 2664*D1**2*f*fd*r*s + 2934*D1**2*f*fd*r - 612*D1**2*f*fd*s**2 + 1710*D1**2*f*fd*s - 1341*D1**2*f*fd + 522*D1**2*f*fdd*r**2 + 1332*D1**2*f*fdd*r*s - 522*D1**2*f*fdd*r + 810*D1**2*f*fdd*s**2 - 666*D1**2*f*fdd*s + 261*D1**2*f*fdd + 1512*D1**2*f*gd2*r**2 + 1512*D1**2*f*gd2*r*s - 1512*D1**2*f*gd2*r - 336*D1**2*f*gdd2*r**2 - 336*D1**2*f*gdd2*r*s + 336*D1**2*f*gdd2*r + 522*D1**2*fd**2*r**2 + 1332*D1**2*fd**2*r*s - 522*D1**2*fd**2*r + 810*D1**2*fd**2*s**2 - 666*D1**2*fd**2*s + 1512*D1**2*fd*g2*r**2 + 1512*D1**2*fd*g2*r*s - 3024*D1**2*fd*g2*r - 1512*D1**2*fd*g2*s + 1512*D1**2*fd*g2 - 672*D1**2*fd*gd2*r**2 - 672*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r + 336*D1**2*fd*gd2*s - 336*D1**2*fd*gd2 - 336*D1**2*fdd*g2*r**2 - 336*D1**2*fdd*g2*r*s + 672*D1**2*fdd*g2*r + 336*D1**2*fdd*g2*s - 336*D1**2*fdd*g2 + 576*D1*Dd*K*f**2*r**2 + 576*D1*Dd*K*f**2*r*s - 576*D1*Dd*K*f**2*r - 144*D1*Dd*K*f**2*s + 144*D1*Dd*K*f**2 - 1152*D1*Dd*K*f*fd*r**2 - 1152*D1*Dd*K*f*fd*r*s + 1152*D1*Dd*K*f*fd*r + 432*D1*Dd*K*f*fd*s - 288*D1*Dd*K*f*fd - 2120*D1*Dd*f**3*r**2 - 3920*D1*Dd*f**3*r*s + 3020*D1*Dd*f**3*r - 1800*D1*Dd*f**3*s**2 + 2780*D1*Dd*f**3*s - 1430*D1*Dd*f**3 + 7440*D1*Dd*f**2*fd*r**2 + 22560*D1*Dd*f**2*fd*r*s - 15460*D1*Dd*f**2*fd*r + 15120*D1*Dd*f**2*fd*s**2 - 21700*D1*Dd*f**2*fd*s + 7650*D1*Dd*f**2*fd - 4104*D1*Dd*f**2*r**2 - 5328*D1*Dd*f**2*r*s + 4716*D1*Dd*f**2*r - 1224*D1*Dd*f**2*s**2 + 2556*D1*Dd*f**2*s - 1638*D1*Dd*f**2 + 4176*D1*Dd*f*fd*r**2 + 10656*D1*Dd*f*fd*r*s - 5796*D1*Dd*f*fd*r + 6480*D1*Dd*f*fd*s**2 - 7236*D1*Dd*f*fd*s + 1854*D1*Dd*f*fd + 6048*D1*Dd*f*g2*r**2 + 6048*D1*Dd*f*g2*r*s - 6048*D1*Dd*f*g2*r - 1512*D1*Dd*f*g2*s + 1512*D1*Dd*f*g2 - 2688*D1*Dd*f*gd2*r**2 - 2688*D1*Dd*f*gd2*r*s + 2688*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s - 336*D1*Dd*f*gd2 - 2688*D1*Dd*fd*g2*r**2 - 2688*D1*Dd*fd*g2*r*s + 4032*D1*Dd*fd*g2*r + 1680*D1*Dd*fd*g2*s - 1344*D1*Dd*fd*g2 - 288*D1*Ddd*K*f**2*r**2 - 288*D1*Ddd*K*f**2*r*s + 288*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s - 72*D1*Ddd*K*f**2 + 1240*D1*Ddd*f**3*r**2 + 3760*D1*Ddd*f**3*r*s - 2500*D1*Ddd*f**3*r + 2520*D1*Ddd*f**3*s**2 - 3460*D1*Ddd*f**3*s + 1570*D1*Ddd*f**3 + 1044*D1*Ddd*f**2*r**2 + 2664*D1*Ddd*f**2*r*s - 1854*D1*Ddd*f**2*r + 1620*D1*Ddd*f**2*s**2 - 2286*D1*Ddd*f**2*s + 1071*D1*Ddd*f**2 - 1344*D1*Ddd*f*g2*r**2 - 1344*D1*Ddd*f*g2*r*s + 1344*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s - 336*D1*Ddd*f*g2 - 3*D1*bd1*(D1*(3*f**2*(24*r**2 + 6*r*(24*s - 17) + 120*s**2 - 158*s + 63) + f*(-280*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 12*fd*(26*r**2 + r*(212*s - 119) + 186*s**2 - 239*s + 63) + 7*r**2*(72*K + 64) + 14*r*(36*K*s - 18*K + 48*s - 73) + 224*s**2 - 826*s + 595) - 14*fd*(4*K*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 8*r**2 + 48*r*s + 3*r + 56*s**2 - 33*s - 7) - 840*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 2*Dd*f*(7*K*(64*r**2 + 16*r*(4*s - 3) - 8*s + 4) + 6*f*(52*r**2 + r*(424*s - 219) + 372*s**2 - 451*s + 131) - 224*r**2 + 28*r*(48*s - 29) + 1568*s**2 - 2268*s + 791)) - 864*Dd**2*K*f**2*r**2 - 864*Dd**2*K*f**2*r*s + 864*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s - 144*Dd**2*K*f**2 + 3720*Dd**2*f**3*r**2 + 11280*Dd**2*f**3*r*s - 7500*Dd**2*f**3*r + 7560*Dd**2*f**3*s**2 - 10380*Dd**2*f**3*s + 3140*Dd**2*f**3 + 3132*Dd**2*f**2*r**2 + 7992*Dd**2*f**2*r*s - 5562*Dd**2*f**2*r + 4860*Dd**2*f**2*s**2 - 6858*Dd**2*f**2*s + 2142*Dd**2*f**2 - 4032*Dd**2*f*g2*r**2 - 4032*Dd**2*f*g2*r*s + 4032*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s - 672*Dd**2*f*g2))/(630*d**2*k1*k3**3) + 4*D1**2*Pk1*Pkd3*ct**3*k2*st**2*(D1*f*(-7*D1*bd1**2*s*(2*r + 2*s - 1) - 3*D1*bdd1*f*s*(r + s) - 3*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 2) + s*(8*s - 5)))) + 7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(-7*bdd1*s*(2*r + 2*s - 1) + 6*fd*(2*s - 1)*(r + s - 1) - 3*fdd*(2*s - 1)*(r + s - 1)) - 3*fd**2*(2*s - 1)*(r + s - 1)) + 7*D1*bd1*(2*D1*f*s*(2*r + 2*s - 1) - D1*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + 3*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 3*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k1*k3) + D1**2*Pk1*Pkd3*ct**3*k2*(D1*f*(-14*D1*bd1**2*(r**2 - r*(30*s + 1) + s*(15 - 31*s)) - 3*D1*bdd1*f*(r + s)*(r*(16*C - 13) - 45*s) - 3*bd1*(D1*(-f*(r + s)*(r*(32*C - 19) - 55*s) + 4*fd*(r**2*(16*C - 13) + r*(4*C*(4*s - 3) - 58*s + 21) + s*(-4*C - 45*s + 37))) + 2*Dd*f*(r**2*(64*C - 52) + r*(64*C*s - 32*C - 232*s + 71) + s*(-8*C - 180*s + 119)))) + 7*b1**2*(D1**2*(fd*(7*r - 37*s + 37) - fdd*(r - 31*s + 31))*(r + s - 1) + D1*(Dd*(f*(28*r**2 - 120*r*s + 46*r - 148*s**2 + 178*s - 67) + 2*fd*(-4*r**2 + 120*r*s - 89*r + 124*s**2 - 201*s + 77)) + Ddd*f*(-4*r**2 + 2*r*(60*s - 29) + 124*s**2 - 154*s + 61)) + 2*Dd**2*f*(-6*r**2 + 3*r*(60*s - 29) + 186*s**2 - 231*s + 61)) + b1*(-7*D1**2*bdd1*f*(2*r**2 - 2*r*(30*s + 1) - 62*s**2 + 30*s + 1) + 6*D1**2*(f*(fd*(32*C*r - 16*C - 19*r - 55*s + 37) + fdd*(-16*C*r + 8*C + 13*r + 45*s - 29)) + fd**2*(C*(8 - 16*r) + 13*r + 45*s - 29))*(r + s - 1) + 7*D1*bd1*(D1*(f*(14*r**2 - 2*r*(30*s + 7) - 74*s**2 + 30*s + 7) + 2*fd*(-2*r**2 + r*(60*s - 29) + 62*s**2 - 77*s + 15)) + 2*Dd*f*(-8*r**2 + 6*r*(40*s - 9) + 248*s**2 - 214*s + 29)) + 3*D1*f*(Dd*(f*(32*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 76*r**2 - 296*r*s + 186*r - 220*s**2 + 294*s - 129) - 4*fd*(4*C*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) - 52*r**2 - 232*r*s + 155*r - 180*s**2 + 267*s - 95)) + Ddd*f*(-16*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 52*r**2 + 232*r*s - 142*r + 180*s**2 - 238*s + 103)) + 6*Dd**2*f**2*(-8*C*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 78*r**2 + 3*r*(116*s - 71) + 270*s**2 - 357*s + 103)))/(210*d**2*k1*k3) + D1**2*Pk1*Pkd3*ct**2*f*k2**6*st**4*(-99*D1**2*b1*f*fd*r**2 - 99*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r + 99*D1**2*b1*f*fdd*r**2 + 99*D1**2*b1*f*fdd*r*s - 66*D1**2*b1*f*fdd*r + 198*D1**2*b1*fd**2*r**2 + 198*D1**2*b1*fd**2*r*s - 132*D1**2*b1*fd**2*r + 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 92*D1**2*f**2*fd*r**2 - 92*D1**2*f**2*fd*r*s + 92*D1**2*f**2*fd*r + 23*D1**2*f**2*fd*s - 23*D1**2*f**2*fd + 156*D1**2*f**2*fdd*r**2 + 156*D1**2*f**2*fdd*r*s - 156*D1**2*f**2*fdd*r - 39*D1**2*f**2*fdd*s + 39*D1**2*f**2*fdd + 468*D1**2*f*fd**2*r**2 + 468*D1**2*f*fd**2*r*s - 468*D1**2*f*fd**2*r - 117*D1**2*f*fd**2*s + 78*D1**2*f*fd**2 - 132*D1*Dd*b1*f**2*r**2 - 132*D1*Dd*b1*f**2*r*s + 132*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2*s - 33*D1*Dd*b1*f**2 + 792*D1*Dd*b1*f*fd*r**2 + 792*D1*Dd*b1*f*fd*r*s - 660*D1*Dd*b1*f*fd*r - 99*D1*Dd*b1*f*fd*s + 66*D1*Dd*b1*f*fd - 92*D1*Dd*f**3*r**2 - 92*D1*Dd*f**3*r*s + 92*D1*Dd*f**3*r + 23*D1*Dd*f**3*s - 23*D1*Dd*f**3 + 1248*D1*Dd*f**2*fd*r**2 + 1248*D1*Dd*f**2*fd*r*s - 1248*D1*Dd*f**2*fd*r - 312*D1*Dd*f**2*fd*s + 234*D1*Dd*f**2*fd + 132*D1*Ddd*b1*f**2*r**2 + 132*D1*Ddd*b1*f**2*r*s - 132*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 + 156*D1*Ddd*f**3*r**2 + 156*D1*Ddd*f**3*r*s - 156*D1*Ddd*f**3*r - 39*D1*Ddd*f**3*s + 39*D1*Ddd*f**3 - 33*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) + 396*Dd**2*b1*f**2*r**2 + 396*Dd**2*b1*f**2*r*s - 396*Dd**2*b1*f**2*r - 99*Dd**2*b1*f**2*s + 66*Dd**2*b1*f**2 + 468*Dd**2*f**3*r**2 + 468*Dd**2*f**3*r*s - 468*Dd**2*f**3*r - 117*Dd**2*f**3*s + 78*Dd**2*f**3)/(231*d**2*k1**2*k3**5) + D1**2*Pk1*Pkd3*ct**2*k1**6*(2*C - 1)*(54*D1**2*b1*f*fd*r**2 + 108*D1**2*b1*f*fd*r*s - 54*D1**2*b1*f*fd*r + 54*D1**2*b1*f*fd*s**2 - 54*D1**2*b1*f*fd*s + 27*D1**2*b1*f*fd - 90*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd - 90*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)**2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 216*D1*Dd*b1*f**2*r*s - 162*D1*Dd*b1*f**2*r + 108*D1*Dd*b1*f**2*s**2 - 162*D1*Dd*b1*f**2*s + 81*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 900*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 900*D1*Dd*b1*f*fd*s - 270*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 1190*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 1190*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 270*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 270*D1*Ddd*b1*f**2*s - 135*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 210*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 210*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 540*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 810*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 810*Dd**2*b1*f**2*s - 270*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 630*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 630*Dd**2*f**3*s - 210*Dd**2*f**3)/(70*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**2*k1**4*k2**2*st**2*(726*C*D1**2*b1*f*fd*r**2 + 1452*C*D1**2*b1*f*fd*r*s - 726*C*D1**2*b1*f*fd*r + 726*C*D1**2*b1*f*fd*s**2 - 726*C*D1**2*b1*f*fd*s + 363*C*D1**2*b1*f*fd - 1098*C*D1**2*b1*f*fdd*r**2 - 2196*C*D1**2*b1*f*fdd*r*s + 1098*C*D1**2*b1*f*fdd*r - 1098*C*D1**2*b1*f*fdd*s**2 + 1098*C*D1**2*b1*f*fdd*s - 549*C*D1**2*b1*f*fdd - 1098*C*D1**2*b1*fd**2*r**2 - 2196*C*D1**2*b1*fd**2*r*s + 1098*C*D1**2*b1*fd**2*r - 1098*C*D1**2*b1*fd**2*s**2 + 1098*C*D1**2*b1*fd**2*s + 885*C*D1**2*f**2*fd*r**2 + 1770*C*D1**2*f**2*fd*r*s - 1180*C*D1**2*f**2*fd*r + 885*C*D1**2*f**2*fd*s**2 - 1180*C*D1**2*f**2*fd*s + 590*C*D1**2*f**2*fd - 915*C*D1**2*f**2*fdd*r**2 - 1830*C*D1**2*f**2*fdd*r*s + 1220*C*D1**2*f**2*fdd*r - 915*C*D1**2*f**2*fdd*s**2 + 1220*C*D1**2*f**2*fdd*s - 610*C*D1**2*f**2*fdd - 1830*C*D1**2*f*fd**2*r**2 - 3660*C*D1**2*f*fd**2*r*s + 2440*C*D1**2*f*fd**2*r - 1830*C*D1**2*f*fd**2*s**2 + 2440*C*D1**2*f*fd**2*s - 610*C*D1**2*f*fd**2 + 1452*C*D1*Dd*b1*f**2*r**2 + 2904*C*D1*Dd*b1*f**2*r*s - 2178*C*D1*Dd*b1*f**2*r + 1452*C*D1*Dd*b1*f**2*s**2 - 2178*C*D1*Dd*b1*f**2*s + 1089*C*D1*Dd*b1*f**2 - 8784*C*D1*Dd*b1*f*fd*r**2 - 17568*C*D1*Dd*b1*f*fd*r*s + 10980*C*D1*Dd*b1*f*fd*r - 8784*C*D1*Dd*b1*f*fd*s**2 + 10980*C*D1*Dd*b1*f*fd*s - 3294*C*D1*Dd*b1*f*fd + 1180*C*D1*Dd*f**3*r**2 + 2360*C*D1*Dd*f**3*r*s - 1770*C*D1*Dd*f**3*r + 1180*C*D1*Dd*f**3*s**2 - 1770*C*D1*Dd*f**3*s + 885*C*D1*Dd*f**3 - 7320*C*D1*Dd*f**2*fd*r**2 - 14640*C*D1*Dd*f**2*fd*r*s + 10370*C*D1*Dd*f**2*fd*r - 7320*C*D1*Dd*f**2*fd*s**2 + 10370*C*D1*Dd*f**2*fd*s - 3660*C*D1*Dd*f**2*fd - 2196*C*D1*Ddd*b1*f**2*r**2 - 4392*C*D1*Ddd*b1*f**2*r*s + 3294*C*D1*Ddd*b1*f**2*r - 2196*C*D1*Ddd*b1*f**2*s**2 + 3294*C*D1*Ddd*b1*f**2*s - 1647*C*D1*Ddd*b1*f**2 - 1220*C*D1*Ddd*f**3*r**2 - 2440*C*D1*Ddd*f**3*r*s + 1830*C*D1*Ddd*f**3*r - 1220*C*D1*Ddd*f**3*s**2 + 1830*C*D1*Ddd*f**3*s - 915*C*D1*Ddd*f**3 - 6588*C*Dd**2*b1*f**2*r**2 - 13176*C*Dd**2*b1*f**2*r*s + 9882*C*Dd**2*b1*f**2*r - 6588*C*Dd**2*b1*f**2*s**2 + 9882*C*Dd**2*b1*f**2*s - 3294*C*Dd**2*b1*f**2 - 3660*C*Dd**2*f**3*r**2 - 7320*C*Dd**2*f**3*r*s + 5490*C*Dd**2*f**3*r - 3660*C*Dd**2*f**3*s**2 + 5490*C*Dd**2*f**3*s - 1830*C*Dd**2*f**3 - 408*D1**2*b1*f*fd*r**2 - 816*D1**2*b1*f*fd*r*s + 408*D1**2*b1*f*fd*r - 408*D1**2*b1*f*fd*s**2 + 408*D1**2*b1*f*fd*s - 204*D1**2*b1*f*fd + 666*D1**2*b1*f*fdd*r**2 + 1332*D1**2*b1*f*fdd*r*s - 666*D1**2*b1*f*fdd*r + 666*D1**2*b1*f*fdd*s**2 - 666*D1**2*b1*f*fdd*s + 333*D1**2*b1*f*fdd + 666*D1**2*b1*fd**2*r**2 + 1332*D1**2*b1*fd**2*r*s - 666*D1**2*b1*fd**2*r + 666*D1**2*b1*fd**2*s**2 - 666*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(61*C - 37)*(r + s - 1)**2 - 516*D1**2*f**2*fd*r**2 - 1032*D1**2*f**2*fd*r*s + 688*D1**2*f**2*fd*r - 516*D1**2*f**2*fd*s**2 + 688*D1**2*f**2*fd*s - 344*D1**2*f**2*fd + 555*D1**2*f**2*fdd*r**2 + 1110*D1**2*f**2*fdd*r*s - 740*D1**2*f**2*fdd*r + 555*D1**2*f**2*fdd*s**2 - 740*D1**2*f**2*fdd*s + 370*D1**2*f**2*fdd + 1110*D1**2*f*fd**2*r**2 + 2220*D1**2*f*fd**2*r*s - 1480*D1**2*f*fd**2*r + 1110*D1**2*f*fd**2*s**2 - 1480*D1**2*f*fd**2*s + 370*D1**2*f*fd**2 - 816*D1*Dd*b1*f**2*r**2 - 1632*D1*Dd*b1*f**2*r*s + 1224*D1*Dd*b1*f**2*r - 816*D1*Dd*b1*f**2*s**2 + 1224*D1*Dd*b1*f**2*s - 612*D1*Dd*b1*f**2 + 5328*D1*Dd*b1*f*fd*r**2 + 10656*D1*Dd*b1*f*fd*r*s - 6660*D1*Dd*b1*f*fd*r + 5328*D1*Dd*b1*f*fd*s**2 - 6660*D1*Dd*b1*f*fd*s + 1998*D1*Dd*b1*f*fd - 688*D1*Dd*f**3*r**2 - 1376*D1*Dd*f**3*r*s + 1032*D1*Dd*f**3*r - 688*D1*Dd*f**3*s**2 + 1032*D1*Dd*f**3*s - 516*D1*Dd*f**3 + 4440*D1*Dd*f**2*fd*r**2 + 8880*D1*Dd*f**2*fd*r*s - 6290*D1*Dd*f**2*fd*r + 4440*D1*Dd*f**2*fd*s**2 - 6290*D1*Dd*f**2*fd*s + 2220*D1*Dd*f**2*fd + 1332*D1*Ddd*b1*f**2*r**2 + 2664*D1*Ddd*b1*f**2*r*s - 1998*D1*Ddd*b1*f**2*r + 1332*D1*Ddd*b1*f**2*s**2 - 1998*D1*Ddd*b1*f**2*s + 999*D1*Ddd*b1*f**2 + 740*D1*Ddd*f**3*r**2 + 1480*D1*Ddd*f**3*r*s - 1110*D1*Ddd*f**3*r + 740*D1*Ddd*f**3*s**2 - 1110*D1*Ddd*f**3*s + 555*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(121*C - 68)*(r + s - 1) - D1*fd*(366*C - 222)*(2*r + 2*s - 1) - Dd*f*(366*C - 222)*(4*r + 4*s - 3)) + 3996*Dd**2*b1*f**2*r**2 + 7992*Dd**2*b1*f**2*r*s - 5994*Dd**2*b1*f**2*r + 3996*Dd**2*b1*f**2*s**2 - 5994*Dd**2*b1*f**2*s + 1998*Dd**2*b1*f**2 + 2220*Dd**2*f**3*r**2 + 4440*Dd**2*f**3*r*s - 3330*Dd**2*f**3*r + 2220*Dd**2*f**3*s**2 - 3330*Dd**2*f**3*s + 1110*Dd**2*f**3)/(35*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**2*k1**4*k2**2*(-2970*C*D1**2*f**2*fd*r**2 - 5940*C*D1**2*f**2*fd*r*s + 3960*C*D1**2*f**2*fd*r - 2970*C*D1**2*f**2*fd*s**2 + 3960*C*D1**2*f**2*fd*s - 1980*C*D1**2*f**2*fd - 3960*C*D1*Dd*f**3*r**2 - 7920*C*D1*Dd*f**3*r*s + 5940*C*D1*Dd*f**3*r - 3960*C*D1*Dd*f**3*s**2 + 5940*C*D1*Dd*f**3*s - 2970*C*D1*Dd*f**3 - 7425*D1**2*K*bdd1*f**2*r**2 - 14850*D1**2*K*bdd1*f**2*r*s + 14850*D1**2*K*bdd1*f**2*r - 7425*D1**2*K*bdd1*f**2*s**2 + 14850*D1**2*K*bdd1*f**2*s - 7425*D1**2*K*bdd1*f**2 + 990*D1**2*bd1**2*f*(-21*K + 5*f + 7)*(r + s - 1)**2 + 1540*D1**2*bdd1*f**3*r**2 + 3080*D1**2*bdd1*f**3*r*s - 3080*D1**2*bdd1*f**3*r + 1540*D1**2*bdd1*f**3*s**2 - 3080*D1**2*bdd1*f**3*s + 1540*D1**2*bdd1*f**3 + 2475*D1**2*bdd1*f**2*r**2 + 4950*D1**2*bdd1*f**2*r*s - 4950*D1**2*bdd1*f**2*r + 2475*D1**2*bdd1*f**2*s**2 - 4950*D1**2*bdd1*f**2*s + 2475*D1**2*bdd1*f**2 + 20790*D1**2*bdd1*f*g2*r**2 + 41580*D1**2*bdd1*f*g2*r*s - 41580*D1**2*bdd1*f*g2*r + 20790*D1**2*bdd1*f*g2*s**2 - 41580*D1**2*bdd1*f*g2*s + 20790*D1**2*bdd1*f*g2 + 980*D1**2*f**3*fd*r**2 + 1960*D1**2*f**3*fd*r*s - 1470*D1**2*f**3*fd*r + 980*D1**2*f**3*fd*s**2 - 1470*D1**2*f**3*fd*s + 735*D1**2*f**3*fd - 1260*D1**2*f**3*fdd*r**2 - 2520*D1**2*f**3*fdd*r*s + 1890*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s**2 + 1890*D1**2*f**3*fdd*s - 945*D1**2*f**3*fdd - 3780*D1**2*f**2*fd**2*r**2 - 7560*D1**2*f**2*fd**2*r*s + 5670*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s**2 + 5670*D1**2*f**2*fd**2*s - 1890*D1**2*f**2*fd**2 + 1485*D1**2*f**2*fd*r**2 + 2970*D1**2*f**2*fd*r*s - 1980*D1**2*f**2*fd*r + 1485*D1**2*f**2*fd*s**2 - 1980*D1**2*f**2*fd*s + 990*D1**2*f**2*fd - 10296*D1**2*f**2*gd2*r**2 - 20592*D1**2*f**2*gd2*r*s + 20592*D1**2*f**2*gd2*r - 10296*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s - 10296*D1**2*f**2*gd2 + 14850*D1**2*f**2*gdd2*r**2 + 29700*D1**2*f**2*gdd2*r*s - 29700*D1**2*f**2*gdd2*r + 14850*D1**2*f**2*gdd2*s**2 - 29700*D1**2*f**2*gdd2*s + 14850*D1**2*f**2*gdd2 - 20592*D1**2*f*fd*g2*r**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 20592*D1**2*f*fd*g2*s**2 + 20592*D1**2*f*fd*g2*s - 10296*D1**2*f*fd*g2 + 59400*D1**2*f*fd*gd2*r**2 + 118800*D1**2*f*fd*gd2*r*s - 89100*D1**2*f*fd*gd2*r + 59400*D1**2*f*fd*gd2*s**2 - 89100*D1**2*f*fd*gd2*s + 29700*D1**2*f*fd*gd2 + 29700*D1**2*f*fdd*g2*r**2 + 59400*D1**2*f*fdd*g2*r*s - 29700*D1**2*f*fdd*g2*r + 29700*D1**2*f*fdd*g2*s**2 - 29700*D1**2*f*fdd*g2*s + 14850*D1**2*f*fdd*g2 + 29700*D1**2*fd**2*g2*r**2 + 59400*D1**2*fd**2*g2*r*s - 29700*D1**2*fd**2*g2*r + 29700*D1**2*fd**2*g2*s**2 - 29700*D1**2*fd**2*g2*s + 980*D1*Dd*f**4*r**2 + 1960*D1*Dd*f**4*r*s - 1470*D1*Dd*f**4*r + 980*D1*Dd*f**4*s**2 - 1470*D1*Dd*f**4*s + 735*D1*Dd*f**4 - 10080*D1*Dd*f**3*fd*r**2 - 20160*D1*Dd*f**3*fd*r*s + 15120*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s**2 + 15120*D1*Dd*f**3*fd*s - 5670*D1*Dd*f**3*fd + 1980*D1*Dd*f**3*r**2 + 3960*D1*Dd*f**3*r*s - 2970*D1*Dd*f**3*r + 1980*D1*Dd*f**3*s**2 - 2970*D1*Dd*f**3*s + 1485*D1*Dd*f**3 - 41184*D1*Dd*f**2*g2*r**2 - 82368*D1*Dd*f**2*g2*r*s + 61776*D1*Dd*f**2*g2*r - 41184*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 30888*D1*Dd*f**2*g2 + 118800*D1*Dd*f**2*gd2*r**2 + 237600*D1*Dd*f**2*gd2*r*s - 207900*D1*Dd*f**2*gd2*r + 118800*D1*Dd*f**2*gd2*s**2 - 207900*D1*Dd*f**2*gd2*s + 89100*D1*Dd*f**2*gd2 + 237600*D1*Dd*f*fd*g2*r**2 + 475200*D1*Dd*f*fd*g2*r*s - 297000*D1*Dd*f*fd*g2*r + 237600*D1*Dd*f*fd*g2*s**2 - 297000*D1*Dd*f*fd*g2*s + 89100*D1*Dd*f*fd*g2 - 1260*D1*Ddd*f**4*r**2 - 2520*D1*Ddd*f**4*r*s + 1890*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s**2 + 1890*D1*Ddd*f**4*s - 945*D1*Ddd*f**4 + 59400*D1*Ddd*f**2*g2*r**2 + 118800*D1*Ddd*f**2*g2*r*s - 89100*D1*Ddd*f**2*g2*r + 59400*D1*Ddd*f**2*g2*s**2 - 89100*D1*Ddd*f**2*g2*s + 44550*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(50*f**3*(r + s - 1) + f**2*(63*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) - (234*K - 36)*(r + s - 1)) + 15*f*(15*fd*(3*K - 1)*(2*r + 2*s - 1) + (28*g2 - 126*gd2)*(r + s - 1)) - 1890*fd*g2*(r + s)) - 5*Dd*f*(28*f**2 - 45*f*(3*K - 1) + 378*g2)*(4*r + 4*s - 3))*(r + s - 1) - 3780*Dd**2*f**4*r**2 - 7560*Dd**2*f**4*r*s + 5670*Dd**2*f**4*r - 3780*Dd**2*f**4*s**2 + 5670*Dd**2*f**4*s - 1890*Dd**2*f**4 + 178200*Dd**2*f**2*g2*r**2 + 356400*Dd**2*f**2*g2*r*s - 267300*Dd**2*f**2*g2*r + 178200*Dd**2*f**2*g2*s**2 - 267300*Dd**2*f**2*g2*s + 89100*Dd**2*f**2*g2 - 165*b1**2*(D1**2*(3*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(30*fd**2*(r + s - 1) + 7*fd*(4*K - 1)*(r + s) - 21*fdd*(3*K - 1)*(r + s))) + D1*(Dd*(9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(30*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (28*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(3*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-21*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-21*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(252*C*D1**2*f*fd*r**2 + 504*C*D1**2*f*fd*r*s - 252*C*D1**2*f*fd*r + 252*C*D1**2*f*fd*s**2 - 252*C*D1**2*f*fd*s + 126*C*D1**2*f*fd + 504*C*D1*Dd*f**2*r**2 + 1008*C*D1*Dd*f**2*r*s - 756*C*D1*Dd*f**2*r + 504*C*D1*Dd*f**2*s**2 - 756*C*D1*Dd*f**2*s + 378*C*D1*Dd*f**2 - 936*D1**2*K*f*fd*r**2 - 1872*D1**2*K*f*fd*r*s + 936*D1**2*K*f*fd*r - 936*D1**2*K*f*fd*s**2 + 936*D1**2*K*f*fd*s - 468*D1**2*K*f*fd + 1350*D1**2*K*f*fdd*r**2 + 2700*D1**2*K*f*fdd*r*s - 1350*D1**2*K*f*fdd*r + 1350*D1**2*K*f*fdd*s**2 - 1350*D1**2*K*f*fdd*s + 675*D1**2*K*f*fdd + 1350*D1**2*K*fd**2*r**2 + 2700*D1**2*K*fd**2*r*s - 1350*D1**2*K*fd**2*r + 1350*D1**2*K*fd**2*s**2 - 1350*D1**2*K*fd**2*s - 90*D1**2*bdd1*f*(-21*K + 5*f + 7)*(r + s - 1)**2 + 300*D1**2*f**2*fd*r**2 + 600*D1**2*f**2*fd*r*s - 400*D1**2*f**2*fd*r + 300*D1**2*f**2*fd*s**2 - 400*D1**2*f**2*fd*s + 200*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 144*D1**2*f*fd*r**2 + 288*D1**2*f*fd*r*s - 144*D1**2*f*fd*r + 144*D1**2*f*fd*s**2 - 144*D1**2*f*fd*s + 72*D1**2*f*fd - 450*D1**2*f*fdd*r**2 - 900*D1**2*f*fdd*r*s + 450*D1**2*f*fdd*r - 450*D1**2*f*fdd*s**2 + 450*D1**2*f*fdd*s - 225*D1**2*f*fdd + 840*D1**2*f*gd2*r**2 + 1680*D1**2*f*gd2*r*s - 1680*D1**2*f*gd2*r + 840*D1**2*f*gd2*s**2 - 1680*D1**2*f*gd2*s + 840*D1**2*f*gd2 - 1890*D1**2*f*gdd2*r**2 - 3780*D1**2*f*gdd2*r*s + 3780*D1**2*f*gdd2*r - 1890*D1**2*f*gdd2*s**2 + 3780*D1**2*f*gdd2*s - 1890*D1**2*f*gdd2 - 450*D1**2*fd**2*r**2 - 900*D1**2*fd**2*r*s + 450*D1**2*fd**2*r - 450*D1**2*fd**2*s**2 + 450*D1**2*fd**2*s + 840*D1**2*fd*g2*r**2 + 1680*D1**2*fd*g2*r*s + 840*D1**2*fd*g2*s**2 - 3780*D1**2*fd*gd2*r**2 - 7560*D1**2*fd*gd2*r*s + 3780*D1**2*fd*gd2*r - 3780*D1**2*fd*gd2*s**2 + 3780*D1**2*fd*gd2*s - 1890*D1**2*fdd*g2*r**2 - 3780*D1**2*fdd*g2*r*s - 1890*D1**2*fdd*g2*s**2 - 1872*D1*Dd*K*f**2*r**2 - 3744*D1*Dd*K*f**2*r*s + 2808*D1*Dd*K*f**2*r - 1872*D1*Dd*K*f**2*s**2 + 2808*D1*Dd*K*f**2*s - 1404*D1*Dd*K*f**2 + 10800*D1*Dd*K*f*fd*r**2 + 21600*D1*Dd*K*f*fd*r*s - 13500*D1*Dd*K*f*fd*r + 10800*D1*Dd*K*f*fd*s**2 - 13500*D1*Dd*K*f*fd*s + 4050*D1*Dd*K*f*fd + 400*D1*Dd*f**3*r**2 + 800*D1*Dd*f**3*r*s - 600*D1*Dd*f**3*r + 400*D1*Dd*f**3*s**2 - 600*D1*Dd*f**3*s + 300*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd + 288*D1*Dd*f**2*r**2 + 576*D1*Dd*f**2*r*s - 432*D1*Dd*f**2*r + 288*D1*Dd*f**2*s**2 - 432*D1*Dd*f**2*s + 216*D1*Dd*f**2 - 3600*D1*Dd*f*fd*r**2 - 7200*D1*Dd*f*fd*r*s + 4500*D1*Dd*f*fd*r - 3600*D1*Dd*f*fd*s**2 + 4500*D1*Dd*f*fd*s - 1350*D1*Dd*f*fd + 3360*D1*Dd*f*g2*r**2 + 6720*D1*Dd*f*g2*r*s - 5040*D1*Dd*f*g2*r + 3360*D1*Dd*f*g2*s**2 - 5040*D1*Dd*f*g2*s + 2520*D1*Dd*f*g2 - 15120*D1*Dd*f*gd2*r**2 - 30240*D1*Dd*f*gd2*r*s + 26460*D1*Dd*f*gd2*r - 15120*D1*Dd*f*gd2*s**2 + 26460*D1*Dd*f*gd2*s - 11340*D1*Dd*f*gd2 - 15120*D1*Dd*fd*g2*r**2 - 30240*D1*Dd*fd*g2*r*s + 11340*D1*Dd*fd*g2*r - 15120*D1*Dd*fd*g2*s**2 + 11340*D1*Dd*fd*g2*s + 2700*D1*Ddd*K*f**2*r**2 + 5400*D1*Ddd*K*f**2*r*s - 4050*D1*Ddd*K*f**2*r + 2700*D1*Ddd*K*f**2*s**2 - 4050*D1*Ddd*K*f**2*s + 2025*D1*Ddd*K*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 900*D1*Ddd*f**2*r**2 - 1800*D1*Ddd*f**2*r*s + 1350*D1*Ddd*f**2*r - 900*D1*Ddd*f**2*s**2 + 1350*D1*Ddd*f**2*s - 675*D1*Ddd*f**2 - 7560*D1*Ddd*f*g2*r**2 - 15120*D1*Ddd*f*g2*r*s + 11340*D1*Ddd*f*g2*r - 7560*D1*Ddd*f*g2*s**2 + 11340*D1*Ddd*f*g2*s - 5670*D1*Ddd*f*g2 + 30*D1*bd1*(D1*(9*f**2*(r + s - 1) - 30*f*fd*(2*r + 2*s - 1) - 7*f*(4*K - 1)*(r + s - 1) + 42*fd*(3*K - 1)*(r + s)) - 6*Dd*f*(-21*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 8100*Dd**2*K*f**2*r**2 + 16200*Dd**2*K*f**2*r*s - 12150*Dd**2*K*f**2*r + 8100*Dd**2*K*f**2*s**2 - 12150*Dd**2*K*f**2*s + 4050*Dd**2*K*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 2700*Dd**2*f**2*r**2 - 5400*Dd**2*f**2*r*s + 4050*Dd**2*f**2*r - 2700*Dd**2*f**2*s**2 + 4050*Dd**2*f**2*s - 1350*Dd**2*f**2 - 22680*Dd**2*f*g2*r**2 - 45360*Dd**2*f*g2*r*s + 34020*Dd**2*f*g2*r - 22680*Dd**2*f*g2*s**2 + 34020*Dd**2*f*g2*s - 11340*Dd**2*f*g2))/(770*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**2*k1**4*st**2*(32*C - 18)*(b1*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 9*fd*(2*s - 1)*(8*r + 8*s - 5)) - 9*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 9*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(7*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**2*k1**4*(105*b1**2*(2*C - 1)*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-105*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*D1**2*(f*(fd*(6*C*(11*r**2 + 78*r*s - 34*r + 67*s**2 - 62*s + 31) - 33*r**2 - 268*r*s + 119*r - 235*s**2 + 220*s - 110) + fdd*(-10*C*(11*r**2 + 50*r*s - 20*r + 39*s**2 - 34*s + 17) + 55*r**2 + 288*r*s - 119*r + 233*s**2 - 208*s + 104)) + fd**2*(-10*C*(11*r**2 + 50*r*s - 20*r + 39*s**2 - 34*s - 5) + 55*r**2 + 288*r*s - 119*r + 233*s**2 - 208*s - 25)) + 35*D1*bd1*(2*C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 3*D1*f*(Dd*(f*(6*C*(44*r**2 + 312*r*s - 178*r + 268*s**2 - 346*s + 145) - 132*r**2 - 1072*r*s + 602*r - 940*s**2 + 1208*s - 503) + 2*fd*(-20*C*(44*r**2 + 200*r*s - 101*r + 156*s**2 - 171*s + 44) + 440*r**2 + 2304*r*s - 1162*r + 1864*s**2 - 2052*s + 535)) + Ddd*f*(-10*C*(44*r**2 + 200*r*s - 122*r + 156*s**2 - 206*s + 89) + 220*r**2 + 1152*r*s - 686*r + 932*s**2 - 1220*s + 521)) - 6*Dd**2*f**2*(-10*C*(66*r**2 + 3*r*(100*s - 61) + 234*s**2 - 309*s + 89) + 330*r**2 + 3*r*(576*s - 343) + 1398*s**2 - 1830*s + 521)) + f*(-630*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(10*C*(11*r**2 + r*(50*s - 32) + 39*s**2 - 60*s + 16) - 55*r**2 - 32*r*(9*s - 5) - 233*s**2 + 338*s - 80) - 10*D1**2*(f*(fd*(8*C*(33*r**2 + 141*r*s - 69*r + 108*s**2 - 119*s + 47) - 132*r**2 - 633*r*s + 299*r - 501*s**2 + 545*s - 211) + fdd*(-4*C*(87*r**2 + 303*r*s - 159*r + 216*s**2 - 245*s + 101) + 174*r**2 + 681*r*s - 343*r + 507*s**2 - 565*s + 227)) + fd**2*(-4*C*(174*r**2 + 606*r*s - 318*r + 432*s**2 - 490*s + 101) + 348*r**2 + 1362*r*s - 686*r + 1014*s**2 - 1130*s + 227)) - 9*D1*bd1*(D1*(f*(6*C*(11*r**2 + 78*r*s - 32*r + 67*s**2 - 88*s + 16) - 33*r**2 - 268*r*s + 96*r - 235*s**2 + 298*s - 48) - 2*fd*(20*C*(11*r**2 + 50*r*s - 26*r + 39*s**2 - 47*s + 15) - 110*r**2 - 576*r*s + 279*r - 466*s**2 + 546*s - 169)) + 2*Dd*f*(-10*C*(44*r**2 + 25*r*(8*s - 5) + 156*s**2 - 223*s + 76) + 220*r**2 + 1152*r*s - 663*r + 932*s**2 - 1286*s + 418)) - 10*D1*f*(Dd*(f*(8*C*(44*r**2 + 4*r*(47*s - 29) + 144*s**2 - 191*s + 83) - 176*r**2 - 844*r*s + 510*r - 668*s**2 + 879*s - 378) + fd*(-4*C*(696*r**2 + 24*r*(101*s - 59) + 1728*s**2 - 2147*s + 649) + 1392*r**2 + 5448*r*s - 3082*r + 4056*s**2 - 4969*s + 1473)) + Ddd*f*(-4*C*(116*r**2 + 404*r*s - 260*r + 288*s**2 - 389*s + 173) + 232*r**2 + 908*r*s - 570*r + 676*s**2 - 903*s + 396)) - 10*Dd**2*f**2*(-4*C*(348*r**2 + 1212*r*s - 780*r + 864*s**2 - 1167*s + 346) + 696*r**2 + 2724*r*s - 1710*r + 2028*s**2 - 2709*s + 792)))/(630*d**2*k3**5) + 3*D1**2*Pk1*Pkd3*ct**2*k1**2*k2**4*st**4*(1044*C*D1**2*b1*f*fd*r**2 + 2088*C*D1**2*b1*f*fd*r*s - 1044*C*D1**2*b1*f*fd*r + 1044*C*D1**2*b1*f*fd*s**2 - 1044*C*D1**2*b1*f*fd*s + 522*C*D1**2*b1*f*fd - 732*C*D1**2*b1*f*fdd*r**2 - 1464*C*D1**2*b1*f*fdd*r*s + 732*C*D1**2*b1*f*fdd*r - 732*C*D1**2*b1*f*fdd*s**2 + 732*C*D1**2*b1*f*fdd*s - 366*C*D1**2*b1*f*fdd - 732*C*D1**2*b1*fd**2*r**2 - 1464*C*D1**2*b1*fd**2*r*s + 732*C*D1**2*b1*fd**2*r - 732*C*D1**2*b1*fd**2*s**2 + 732*C*D1**2*b1*fd**2*s + 642*C*D1**2*f**2*fd*r**2 + 1284*C*D1**2*f**2*fd*r*s - 856*C*D1**2*f**2*fd*r + 642*C*D1**2*f**2*fd*s**2 - 856*C*D1**2*f**2*fd*s + 428*C*D1**2*f**2*fd - 366*C*D1**2*f**2*fdd*r**2 - 732*C*D1**2*f**2*fdd*r*s + 488*C*D1**2*f**2*fdd*r - 366*C*D1**2*f**2*fdd*s**2 + 488*C*D1**2*f**2*fdd*s - 244*C*D1**2*f**2*fdd - 732*C*D1**2*f*fd**2*r**2 - 1464*C*D1**2*f*fd**2*r*s + 976*C*D1**2*f*fd**2*r - 732*C*D1**2*f*fd**2*s**2 + 976*C*D1**2*f*fd**2*s - 244*C*D1**2*f*fd**2 + 2088*C*D1*Dd*b1*f**2*r**2 + 4176*C*D1*Dd*b1*f**2*r*s - 3132*C*D1*Dd*b1*f**2*r + 2088*C*D1*Dd*b1*f**2*s**2 - 3132*C*D1*Dd*b1*f**2*s + 1566*C*D1*Dd*b1*f**2 - 5856*C*D1*Dd*b1*f*fd*r**2 - 11712*C*D1*Dd*b1*f*fd*r*s + 7320*C*D1*Dd*b1*f*fd*r - 5856*C*D1*Dd*b1*f*fd*s**2 + 7320*C*D1*Dd*b1*f*fd*s - 2196*C*D1*Dd*b1*f*fd + 856*C*D1*Dd*f**3*r**2 + 1712*C*D1*Dd*f**3*r*s - 1284*C*D1*Dd*f**3*r + 856*C*D1*Dd*f**3*s**2 - 1284*C*D1*Dd*f**3*s + 642*C*D1*Dd*f**3 - 2928*C*D1*Dd*f**2*fd*r**2 - 5856*C*D1*Dd*f**2*fd*r*s + 4148*C*D1*Dd*f**2*fd*r - 2928*C*D1*Dd*f**2*fd*s**2 + 4148*C*D1*Dd*f**2*fd*s - 1464*C*D1*Dd*f**2*fd - 1464*C*D1*Ddd*b1*f**2*r**2 - 2928*C*D1*Ddd*b1*f**2*r*s + 2196*C*D1*Ddd*b1*f**2*r - 1464*C*D1*Ddd*b1*f**2*s**2 + 2196*C*D1*Ddd*b1*f**2*s - 1098*C*D1*Ddd*b1*f**2 - 488*C*D1*Ddd*f**3*r**2 - 976*C*D1*Ddd*f**3*r*s + 732*C*D1*Ddd*f**3*r - 488*C*D1*Ddd*f**3*s**2 + 732*C*D1*Ddd*f**3*s - 366*C*D1*Ddd*f**3 - 4392*C*Dd**2*b1*f**2*r**2 - 8784*C*Dd**2*b1*f**2*r*s + 6588*C*Dd**2*b1*f**2*r - 4392*C*Dd**2*b1*f**2*s**2 + 6588*C*Dd**2*b1*f**2*s - 2196*C*Dd**2*b1*f**2 - 1464*C*Dd**2*f**3*r**2 - 2928*C*Dd**2*f**3*r*s + 2196*C*Dd**2*f**3*r - 1464*C*Dd**2*f**3*s**2 + 2196*C*Dd**2*f**3*s - 732*C*Dd**2*f**3 - 708*D1**2*b1*f*fd*r**2 - 1416*D1**2*b1*f*fd*r*s + 708*D1**2*b1*f*fd*r - 708*D1**2*b1*f*fd*s**2 + 708*D1**2*b1*f*fd*s - 354*D1**2*b1*f*fd + 522*D1**2*b1*f*fdd*r**2 + 1044*D1**2*b1*f*fdd*r*s - 522*D1**2*b1*f*fdd*r + 522*D1**2*b1*f*fdd*s**2 - 522*D1**2*b1*f*fdd*s + 261*D1**2*b1*f*fdd + 522*D1**2*b1*fd**2*r**2 + 1044*D1**2*b1*fd**2*r*s - 522*D1**2*b1*fd**2*r + 522*D1**2*b1*fd**2*s**2 - 522*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(122*C - 87)*(r + s - 1)**2 - 450*D1**2*f**2*fd*r**2 - 900*D1**2*f**2*fd*r*s + 600*D1**2*f**2*fd*r - 450*D1**2*f**2*fd*s**2 + 600*D1**2*f**2*fd*s - 300*D1**2*f**2*fd + 261*D1**2*f**2*fdd*r**2 + 522*D1**2*f**2*fdd*r*s - 348*D1**2*f**2*fdd*r + 261*D1**2*f**2*fdd*s**2 - 348*D1**2*f**2*fdd*s + 174*D1**2*f**2*fdd + 522*D1**2*f*fd**2*r**2 + 1044*D1**2*f*fd**2*r*s - 696*D1**2*f*fd**2*r + 522*D1**2*f*fd**2*s**2 - 696*D1**2*f*fd**2*s + 174*D1**2*f*fd**2 - 1416*D1*Dd*b1*f**2*r**2 - 2832*D1*Dd*b1*f**2*r*s + 2124*D1*Dd*b1*f**2*r - 1416*D1*Dd*b1*f**2*s**2 + 2124*D1*Dd*b1*f**2*s - 1062*D1*Dd*b1*f**2 + 4176*D1*Dd*b1*f*fd*r**2 + 8352*D1*Dd*b1*f*fd*r*s - 5220*D1*Dd*b1*f*fd*r + 4176*D1*Dd*b1*f*fd*s**2 - 5220*D1*Dd*b1*f*fd*s + 1566*D1*Dd*b1*f*fd - 600*D1*Dd*f**3*r**2 - 1200*D1*Dd*f**3*r*s + 900*D1*Dd*f**3*r - 600*D1*Dd*f**3*s**2 + 900*D1*Dd*f**3*s - 450*D1*Dd*f**3 + 2088*D1*Dd*f**2*fd*r**2 + 4176*D1*Dd*f**2*fd*r*s - 2958*D1*Dd*f**2*fd*r + 2088*D1*Dd*f**2*fd*s**2 - 2958*D1*Dd*f**2*fd*s + 1044*D1*Dd*f**2*fd + 1044*D1*Ddd*b1*f**2*r**2 + 2088*D1*Ddd*b1*f**2*r*s - 1566*D1*Ddd*b1*f**2*r + 1044*D1*Ddd*b1*f**2*s**2 - 1566*D1*Ddd*b1*f**2*s + 783*D1*Ddd*b1*f**2 + 348*D1*Ddd*f**3*r**2 + 696*D1*Ddd*f**3*r*s - 522*D1*Ddd*f**3*r + 348*D1*Ddd*f**3*s**2 - 522*D1*Ddd*f**3*s + 261*D1*Ddd*f**3 + 6*D1*bd1*f*(r + s - 1)*(D1*f*(87*C - 59)*(r + s - 1) - D1*fd*(122*C - 87)*(2*r + 2*s - 1) - Dd*f*(122*C - 87)*(4*r + 4*s - 3)) + 3132*Dd**2*b1*f**2*r**2 + 6264*Dd**2*b1*f**2*r*s - 4698*Dd**2*b1*f**2*r + 3132*Dd**2*b1*f**2*s**2 - 4698*Dd**2*b1*f**2*s + 1566*Dd**2*b1*f**2 + 1044*Dd**2*f**3*r**2 + 2088*Dd**2*f**3*r*s - 1566*Dd**2*f**3*r + 1044*Dd**2*f**3*s**2 - 1566*Dd**2*f**3*s + 522*Dd**2*f**3)/(70*d**2*k3**7) - 3*D1**2*Pk1*Pkd3*ct**2*k1**2*k2**4*st**2*(-396*D1**2*bd1**2*f*(-14*K + 10*f + 7)*(r + s - 1)**2 + 198*D1**2*bdd1*f*(f*(6*K - 3) - 28*g2)*(r + s - 1)**2 + 2*D1**2*(-10*f**3*(37*fd - 35*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(2100*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(627*C - 429)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (1991*gd2 - 1188*gdd2)*(r + s - 1)**2) + 11*f*(fd*(181*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 216*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 108*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2376*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 11*D1*bd1*(D1*(36*f**3*(r + s - 1) + f**2*(266*C - 181*K - 95)*(r + s - 1) + 2*f*(54*fd*(2*K - 1)*(2*r + 2*s - 1) + (329*g2 - 504*gd2)*(r + s - 1)) - 1008*fd*g2*(r + s)) + 36*Dd*f*(f*(6*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(370*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(627*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 700*fd*(4*r + 4*s - 3)**2 - 1716*r**2 - 429*r*(8*s - 6) - 1716*s**2 + 2574*s - 1287) - 1991*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2376*f*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2376*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2*Ddd*f*(175*f**2 - 594*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 24*Dd**2*f**2*(175*f**2 - 594*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 11*b1**2*(D1**2*(12*f*(16*fd - 15*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(360*fd**2*(r + s - 1) + 7*fd*(47*K - 21)*(r + s) - 126*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(192*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(360*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (329*K - 147)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 252*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 18*Ddd*f*(-14*K + 10*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*f*(-14*K + 10*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(532*C*D1**2*f*fd*r**2 + 1064*C*D1**2*f*fd*r*s - 532*C*D1**2*f*fd*r + 532*C*D1**2*f*fd*s**2 - 532*C*D1**2*f*fd*s + 266*C*D1**2*f*fd + 1064*C*D1*Dd*f**2*r**2 + 2128*C*D1*Dd*f**2*r*s - 1596*C*D1*Dd*f**2*r + 1064*C*D1*Dd*f**2*s**2 - 1596*C*D1*Dd*f**2*s + 798*C*D1*Dd*f**2 - 362*D1**2*K*f*fd*r**2 - 724*D1**2*K*f*fd*r*s + 362*D1**2*K*f*fd*r - 362*D1**2*K*f*fd*s**2 + 362*D1**2*K*f*fd*s - 181*D1**2*K*f*fd + 216*D1**2*K*f*fdd*r**2 + 432*D1**2*K*f*fdd*r*s - 216*D1**2*K*f*fdd*r + 216*D1**2*K*f*fdd*s**2 - 216*D1**2*K*f*fdd*s + 108*D1**2*K*f*fdd + 216*D1**2*K*fd**2*r**2 + 432*D1**2*K*fd**2*r*s - 216*D1**2*K*fd**2*r + 216*D1**2*K*fd**2*s**2 - 216*D1**2*K*fd**2*s - 36*D1**2*bdd1*f*(-14*K + 10*f + 7)*(r + s - 1)**2 + 108*D1**2*f**2*fd*r**2 + 216*D1**2*f**2*fd*r*s - 144*D1**2*f**2*fd*r + 108*D1**2*f**2*fd*s**2 - 144*D1**2*f**2*fd*s + 72*D1**2*f**2*fd - 190*D1**2*f*fd*r**2 - 380*D1**2*f*fd*r*s + 190*D1**2*f*fd*r - 190*D1**2*f*fd*s**2 + 190*D1**2*f*fd*s - 95*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 216*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*r - 108*D1**2*f*fdd*s**2 + 108*D1**2*f*fdd*s - 54*D1**2*f*fdd + 658*D1**2*f*gd2*r**2 + 1316*D1**2*f*gd2*r*s - 1316*D1**2*f*gd2*r + 658*D1**2*f*gd2*s**2 - 1316*D1**2*f*gd2*s + 658*D1**2*f*gd2 - 504*D1**2*f*gdd2*r**2 - 1008*D1**2*f*gdd2*r*s + 1008*D1**2*f*gdd2*r - 504*D1**2*f*gdd2*s**2 + 1008*D1**2*f*gdd2*s - 504*D1**2*f*gdd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 108*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 108*D1**2*fd**2*s + 658*D1**2*fd*g2*r**2 + 1316*D1**2*fd*g2*r*s + 658*D1**2*fd*g2*s**2 - 1008*D1**2*fd*gd2*r**2 - 2016*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 1008*D1**2*fd*gd2*s**2 + 1008*D1**2*fd*gd2*s - 504*D1**2*fdd*g2*r**2 - 1008*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*s**2 - 724*D1*Dd*K*f**2*r**2 - 1448*D1*Dd*K*f**2*r*s + 1086*D1*Dd*K*f**2*r - 724*D1*Dd*K*f**2*s**2 + 1086*D1*Dd*K*f**2*s - 543*D1*Dd*K*f**2 + 1728*D1*Dd*K*f*fd*r**2 + 3456*D1*Dd*K*f*fd*r*s - 2160*D1*Dd*K*f*fd*r + 1728*D1*Dd*K*f*fd*s**2 - 2160*D1*Dd*K*f*fd*s + 648*D1*Dd*K*f*fd + 144*D1*Dd*f**3*r**2 + 288*D1*Dd*f**3*r*s - 216*D1*Dd*f**3*r + 144*D1*Dd*f**3*s**2 - 216*D1*Dd*f**3*s + 108*D1*Dd*f**3 - 380*D1*Dd*f**2*r**2 - 760*D1*Dd*f**2*r*s + 570*D1*Dd*f**2*r - 380*D1*Dd*f**2*s**2 + 570*D1*Dd*f**2*s - 285*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 1728*D1*Dd*f*fd*r*s + 1080*D1*Dd*f*fd*r - 864*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 324*D1*Dd*f*fd + 2632*D1*Dd*f*g2*r**2 + 5264*D1*Dd*f*g2*r*s - 3948*D1*Dd*f*g2*r + 2632*D1*Dd*f*g2*s**2 - 3948*D1*Dd*f*g2*s + 1974*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r**2 - 8064*D1*Dd*f*gd2*r*s + 7056*D1*Dd*f*gd2*r - 4032*D1*Dd*f*gd2*s**2 + 7056*D1*Dd*f*gd2*s - 3024*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r**2 - 8064*D1*Dd*fd*g2*r*s + 3024*D1*Dd*fd*g2*r - 4032*D1*Dd*fd*g2*s**2 + 3024*D1*Dd*fd*g2*s + 432*D1*Ddd*K*f**2*r**2 + 864*D1*Ddd*K*f**2*r*s - 648*D1*Ddd*K*f**2*r + 432*D1*Ddd*K*f**2*s**2 - 648*D1*Ddd*K*f**2*s + 324*D1*Ddd*K*f**2 - 216*D1*Ddd*f**2*r**2 - 432*D1*Ddd*f**2*r*s + 324*D1*Ddd*f**2*r - 216*D1*Ddd*f**2*s**2 + 324*D1*Ddd*f**2*s - 162*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r**2 - 4032*D1*Ddd*f*g2*r*s + 3024*D1*Ddd*f*g2*r - 2016*D1*Ddd*f*g2*s**2 + 3024*D1*Ddd*f*g2*s - 1512*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(192*f**2*(r + s - 1) - 360*f*fd*(2*r + 2*s - 1) - 7*f*(47*K - 21)*(r + s - 1) + 252*fd*(2*K - 1)*(r + s)) - 36*Dd*f*(-14*K + 10*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 1296*Dd**2*K*f**2*r**2 + 2592*Dd**2*K*f**2*r*s - 1944*Dd**2*K*f**2*r + 1296*Dd**2*K*f**2*s**2 - 1944*Dd**2*K*f**2*s + 648*Dd**2*K*f**2 - 648*Dd**2*f**2*r**2 - 1296*Dd**2*f**2*r*s + 972*Dd**2*f**2*r - 648*Dd**2*f**2*s**2 + 972*Dd**2*f**2*s - 324*Dd**2*f**2 - 6048*Dd**2*f*g2*r**2 - 12096*Dd**2*f*g2*r*s + 9072*Dd**2*f*g2*r - 6048*Dd**2*f*g2*s**2 + 9072*Dd**2*f*g2*s - 3024*Dd**2*f*g2))/(770*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct**2*k1**2*k2**2*st**4*(b1*(D1**2*(f*(fd*(164*C - 111) + fdd*(66 - 96*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(66 - 96*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(164*C - 111)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(66 - 96*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(66 - 96*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(66 - 96*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(60*C - 41)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (32*C - 22)*(3*bdd1*s*(r + s - 1) + fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(22 - 32*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(164*C - 111)*(r + s - 1) - fd*(96*C - 66)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(66 - 96*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(60*C - 41)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(32*C - 22)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(22 - 32*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(22 - 32*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**2*k1**2*k2**2*st**2*(105*b1**2*(D1**2*(fd*(13*C - 6) + fdd*(13 - 19*C))*(r + s - 1)**2 + D1*(Dd*(f*(13*C - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(26 - 38*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(19*C - 13)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(114*C - 78)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-1724*C*D1**2*f*fd*r**2 - 5440*C*D1**2*f*fd*r*s + 1930*C*D1**2*f*fd*r - 3716*C*D1**2*f*fd*s**2 + 2926*C*D1**2*f*fd*s - 1463*C*D1**2*f*fd + 2752*C*D1**2*f*fdd*r**2 + 6752*C*D1**2*f*fdd*r*s - 2806*C*D1**2*f*fdd*r + 4000*C*D1**2*f*fdd*s**2 - 3430*C*D1**2*f*fdd*s + 1715*C*D1**2*f*fdd + 2752*C*D1**2*fd**2*r**2 + 6752*C*D1**2*fd**2*r*s - 2806*C*D1**2*fd**2*r + 4000*C*D1**2*fd**2*s**2 - 3430*C*D1**2*fd**2*s - 570*C*D1**2*fd**2 - 3448*C*D1*Dd*f**2*r**2 - 10880*C*D1*Dd*f**2*r*s + 7164*C*D1*Dd*f**2*r - 7432*C*D1*Dd*f**2*s**2 + 10152*C*D1*Dd*f**2*s - 4578*C*D1*Dd*f**2 + 22016*C*D1*Dd*f*fd*r**2 + 54016*C*D1*Dd*f*fd*r*s - 30232*C*D1*Dd*f*fd*r + 32000*C*D1*Dd*f*fd*s**2 - 36472*C*D1*Dd*f*fd*s + 9666*C*D1*Dd*f*fd + 5504*C*D1*Ddd*f**2*r**2 + 13504*C*D1*Ddd*f**2*r*s - 9504*C*D1*Ddd*f**2*r + 8000*C*D1*Ddd*f**2*s**2 - 11376*C*D1*Ddd*f**2*s + 5376*C*D1*Ddd*f**2 + 16512*C*Dd**2*f**2*r**2 + 40512*C*Dd**2*f**2*r*s - 28512*C*Dd**2*f**2*r + 24000*C*Dd**2*f**2*s**2 - 34128*C*Dd**2*f**2*s + 10752*C*Dd**2*f**2 - 35*D1**2*bdd1*f*(19*C - 13)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 1164*D1**2*f*fd*r**2 + 3744*D1**2*f*fd*r*s - 1372*D1**2*f*fd*r + 2580*D1**2*f*fd*s**2 - 2080*D1**2*f*fd*s + 1040*D1**2*f*fd - 1828*D1**2*f*fdd*r**2 - 4700*D1**2*f*fdd*r*s + 1960*D1**2*f*fdd*r - 2872*D1**2*f*fdd*s**2 + 2482*D1**2*f*fdd*s - 1241*D1**2*f*fdd - 1828*D1**2*fd**2*r**2 - 4700*D1**2*fd**2*r*s + 1960*D1**2*fd**2*r - 2872*D1**2*fd**2*s**2 + 2482*D1**2*fd**2*s + 390*D1**2*fd**2 + 2328*D1*Dd*f**2*r**2 + 7488*D1*Dd*f**2*r*s - 4908*D1*Dd*f**2*r + 5160*D1*Dd*f**2*s**2 - 7032*D1*Dd*f**2*s + 3162*D1*Dd*f**2 - 14624*D1*Dd*f*fd*r**2 - 37600*D1*Dd*f*fd*r*s + 20896*D1*Dd*f*fd*r - 22976*D1*Dd*f*fd*s**2 + 26116*D1*Dd*f*fd*s - 6924*D1*Dd*f*fd - 3656*D1*Ddd*f**2*r**2 - 9400*D1*Ddd*f**2*r*s + 6528*D1*Ddd*f**2*r - 5744*D1*Ddd*f**2*s**2 + 8094*D1*Ddd*f**2*s - 3786*D1*Ddd*f**2 + 35*D1*bd1*(D1*(f*(13*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(26 - 38*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(26 - 38*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 10968*Dd**2*f**2*r**2 - 28200*Dd**2*f**2*r*s + 19584*Dd**2*f**2*r - 17232*Dd**2*f**2*s**2 + 24282*Dd**2*f**2*s - 7572*Dd**2*f**2) + f*(-9597*C*D1**2*f*fd*r**2 - 20262*C*D1**2*f*fd*r*s + 13152*C*D1**2*f*fd*r - 10665*C*D1**2*f*fd*s**2 + 13864*C*D1**2*f*fd*s - 6754*C*D1**2*f*fd + 9321*C*D1**2*f*fdd*r**2 + 19122*C*D1**2*f*fdd*r*s - 12588*C*D1**2*f*fdd*r + 9801*C*D1**2*f*fdd*s**2 - 12908*C*D1**2*f*fdd*s + 6374*C*D1**2*f*fdd + 18642*C*D1**2*fd**2*r**2 + 38244*C*D1**2*fd**2*r*s - 25176*C*D1**2*fd**2*r + 19602*C*D1**2*fd**2*s**2 - 25816*C*D1**2*fd**2*s + 6374*C*D1**2*fd**2 - 12796*C*D1*Dd*f**2*r**2 - 27016*C*D1*Dd*f**2*r*s + 19906*C*D1*Dd*f**2*r - 14220*C*D1*Dd*f**2*s**2 + 20974*C*D1*Dd*f**2*s - 10309*C*D1*Dd*f**2 + 74568*C*D1*Dd*f*fd*r**2 + 152976*C*D1*Dd*f*fd*r*s - 107238*C*D1*Dd*f*fd*r + 78408*C*D1*Dd*f*fd*s**2 - 109958*C*D1*Dd*f*fd*s + 38404*C*D1*Dd*f*fd + 12428*C*D1*Ddd*f**2*r**2 + 25496*C*D1*Ddd*f**2*r*s - 18962*C*D1*Ddd*f**2*r + 13068*C*D1*Ddd*f**2*s**2 - 19442*C*D1*Ddd*f**2*s + 9641*C*D1*Ddd*f**2 + 37284*C*Dd**2*f**2*r**2 + 76488*C*Dd**2*f**2*r*s - 56886*C*Dd**2*f**2*r + 39204*C*Dd**2*f**2*s**2 - 58326*C*Dd**2*f**2*s + 19282*C*Dd**2*f**2 - 210*D1**2*bd1**2*(19*C - 13)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*D1**2*bdd1*f*(C*(1376*r**2 + 3376*r*s - 3322*r + 2000*s**2 - 3946*s + 1661) - 914*r**2 - 2350*r*s + 2218*r - 1436*s**2 + 2740*s - 1109) + 6312*D1**2*f*fd*r**2 + 13692*D1**2*f*fd*r*s - 8772*D1**2*f*fd*r + 7380*D1**2*f*fd*s**2 - 9484*D1**2*f*fd*s + 4564*D1**2*f*fd - 6153*D1**2*f*fdd*r**2 - 13164*D1**2*f*fdd*r*s + 8490*D1**2*f*fdd*r - 7011*D1**2*f*fdd*s**2 + 9062*D1**2*f*fdd*s - 4388*D1**2*f*fdd - 12306*D1**2*fd**2*r**2 - 26328*D1**2*fd**2*r*s + 16980*D1**2*fd**2*r - 14022*D1**2*fd**2*s**2 + 18124*D1**2*fd**2*s - 4388*D1**2*fd**2 + 8416*D1*Dd*f**2*r**2 + 18256*D1*Dd*f**2*r*s - 13336*D1*Dd*f**2*r + 9840*D1*Dd*f**2*s**2 - 14404*D1*Dd*f**2*s + 7024*D1*Dd*f**2 - 49224*D1*Dd*f*fd*r**2 - 105312*D1*Dd*f*fd*r*s + 72594*D1*Dd*f*fd*r - 56088*D1*Dd*f*fd*s**2 + 77456*D1*Dd*f*fd*s - 26614*D1*Dd*f*fd - 8204*D1*Ddd*f**2*r**2 - 17552*D1*Ddd*f**2*r*s + 12878*D1*Ddd*f**2*r - 9348*D1*Ddd*f**2*s**2 + 13736*D1*Ddd*f**2*s - 6725*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(C*(862*r**2 + r*(2720*s - 2514) + 1858*s**2 - 3510*s + 1257) - 582*r**2 - 208*r*(9*s - 8) - 1290*s**2 + 2372*s - 832) + 2*fd*(-C*(2752*r**2 + 6752*r*s - 4725*r + 4000*s**2 - 5661*s + 1973) + 1828*r**2 + 4700*r*s - 3198*r + 2872*s**2 - 3981*s + 1370)) - 2*Dd*f*(C*(5504*r**2 + 4*r*(3376*s - 2849) + 8000*s**2 - 13580*s + 5607) - 3656*r**2 - 9400*r*s + 7700*r - 5744*s**2 + 9527*s - 3849)) - 24612*Dd**2*f**2*r**2 - 52656*Dd**2*f**2*r*s + 38634*Dd**2*f**2*r - 28044*Dd**2*f**2*s**2 + 41208*Dd**2*f**2*s - 13450*Dd**2*f**2))/(315*d**2*k3**5) - D1**2*Pk1*Pkd3*ct**2*k1**2*k2**2*(-5544*C*D1**2*bd1*f**2*r**2 - 5544*C*D1**2*bd1*f**2*r*s + 24948*C*D1**2*bd1*f**2*r + 19404*C*D1**2*bd1*f**2*s - 12474*C*D1**2*bd1*f**2 - 26730*C*D1**2*f**2*fd*r**2 - 41580*C*D1**2*f**2*fd*r*s + 31680*C*D1**2*f**2*fd*r - 14850*C*D1**2*f**2*fd*s**2 + 23760*C*D1**2*f**2*fd*s - 13860*C*D1**2*f**2*fd - 35640*C*D1*Dd*f**3*r**2 - 55440*C*D1*Dd*f**3*r*s + 45540*C*D1*Dd*f**3*r - 19800*C*D1*Dd*f**3*s**2 + 33660*C*D1*Dd*f**3*s - 18810*C*D1*Dd*f**3 - 102564*D1**2*K*bd1**2*f*r**2 - 205128*D1**2*K*bd1**2*f*r*s + 246708*D1**2*K*bd1**2*f*r - 102564*D1**2*K*bd1**2*f*s**2 + 246708*D1**2*K*bd1**2*f*s - 144144*D1**2*K*bd1**2*f + 50589*D1**2*K*bd1*f**2*r**2 + 82566*D1**2*K*bd1*f**2*r*s - 82566*D1**2*K*bd1*f**2*r + 31977*D1**2*K*bd1*f**2*s**2 - 63954*D1**2*K*bd1*f**2*s + 31977*D1**2*K*bd1*f**2 - 221760*D1**2*K*bd1*f*fd*r**2 - 411840*D1**2*K*bd1*f*fd*r*s + 316800*D1**2*K*bd1*f*fd*r - 190080*D1**2*K*bd1*f*fd*s**2 + 293040*D1**2*K*bd1*f*fd*s - 102960*D1**2*K*bd1*f*fd - 55440*D1**2*K*bdd1*f**2*r**2 - 102960*D1**2*K*bdd1*f**2*r*s + 102960*D1**2*K*bdd1*f**2*r - 47520*D1**2*K*bdd1*f**2*s**2 + 95040*D1**2*K*bdd1*f**2*s - 47520*D1**2*K*bdd1*f**2 + 39006*D1**2*bd1**2*f**2*r**2 + 94644*D1**2*bd1**2*f**2*r*s - 96228*D1**2*bd1**2*f**2*r + 55638*D1**2*bd1**2*f**2*s**2 - 112860*D1**2*bd1**2*f**2*s + 57222*D1**2*bd1**2*f**2 + 49896*D1**2*bd1**2*f*r**2 + 116424*D1**2*bd1**2*f*r*s - 128898*D1**2*bd1**2*f*r + 66528*D1**2*bd1**2*f*s**2 - 145530*D1**2*bd1**2*f*s + 79002*D1**2*bd1**2*f - 138600*D1**2*bd1**2*g2*r**2 - 277200*D1**2*bd1**2*g2*r*s + 138600*D1**2*bd1**2*g2*r - 138600*D1**2*bd1**2*g2*s**2 + 138600*D1**2*bd1**2*g2*s - 41580*D1**2*bd1*bd2*f*r**2 - 83160*D1**2*bd1*bd2*f*r*s + 83160*D1**2*bd1*bd2*f*r - 41580*D1**2*bd1*bd2*f*s**2 + 83160*D1**2*bd1*bd2*f*s - 41580*D1**2*bd1*bd2*f - 15455*D1**2*bd1*f**3*r**2 - 25300*D1**2*bd1*f**3*r*s + 30580*D1**2*bd1*f**3*r - 9845*D1**2*bd1*f**3*s**2 + 24970*D1**2*bd1*f**3*s - 16500*D1**2*bd1*f**3 + 113190*D1**2*bd1*f**2*fd*r**2 + 200640*D1**2*bd1*f**2*fd*r*s - 180730*D1**2*bd1*f**2*fd*r + 87450*D1**2*bd1*f**2*fd*s**2 - 159280*D1**2*bd1*f**2*fd*s + 63360*D1**2*bd1*f**2*fd - 17523*D1**2*bd1*f**2*r**2 - 35046*D1**2*bd1*f**2*r*s + 23958*D1**2*bd1*f**2*r - 17523*D1**2*bd1*f**2*s**2 + 23958*D1**2*bd1*f**2*s - 9900*D1**2*bd1*f**2 + 105732*D1**2*bd1*f*fd*r**2 + 222552*D1**2*bd1*f*fd*r*s - 164142*D1**2*bd1*f*fd*r + 116820*D1**2*bd1*f*fd*s**2 - 172458*D1**2*bd1*f*fd*s + 55638*D1**2*bd1*f*fd - 61908*D1**2*bd1*f*g2*r**2 - 114576*D1**2*bd1*f*g2*r*s + 174636*D1**2*bd1*f*g2*r - 52668*D1**2*bd1*f*g2*s**2 + 165396*D1**2*bd1*f*g2*s - 87318*D1**2*bd1*f*g2 + 205128*D1**2*bd1*f*gd2*r**2 + 410256*D1**2*bd1*f*gd2*r*s - 493416*D1**2*bd1*f*gd2*r + 205128*D1**2*bd1*f*gd2*s**2 - 493416*D1**2*bd1*f*gd2*s + 288288*D1**2*bd1*f*gd2 + 205128*D1**2*bd1*fd*g2*r**2 + 410256*D1**2*bd1*fd*g2*r*s - 205128*D1**2*bd1*fd*g2*r + 205128*D1**2*bd1*fd*g2*s**2 - 205128*D1**2*bd1*fd*g2*s + 12375*D1**2*bd2*f**2*r**2 + 24750*D1**2*bd2*f**2*r*s - 24750*D1**2*bd2*f**2*r + 12375*D1**2*bd2*f**2*s**2 - 24750*D1**2*bd2*f**2*s + 12375*D1**2*bd2*f**2 - 59400*D1**2*bd2*f*fd*r**2 - 118800*D1**2*bd2*f*fd*r*s + 89100*D1**2*bd2*f*fd*r - 59400*D1**2*bd2*f*fd*s**2 + 89100*D1**2*bd2*f*fd*s - 29700*D1**2*bd2*f*fd + 18865*D1**2*bdd1*f**3*r**2 + 33440*D1**2*bdd1*f**3*r*s - 38060*D1**2*bdd1*f**3*r + 14575*D1**2*bdd1*f**3*s**2 - 33770*D1**2*bdd1*f**3*s + 21120*D1**2*bdd1*f**3 + 26433*D1**2*bdd1*f**2*r**2 + 55638*D1**2*bdd1*f**2*r*s - 55638*D1**2*bdd1*f**2*r + 29205*D1**2*bdd1*f**2*s**2 - 58410*D1**2*bdd1*f**2*s + 29205*D1**2*bdd1*f**2 + 102564*D1**2*bdd1*f*g2*r**2 + 205128*D1**2*bdd1*f*g2*r*s - 288288*D1**2*bdd1*f*g2*r + 102564*D1**2*bdd1*f*g2*s**2 - 288288*D1**2*bdd1*f*g2*s + 144144*D1**2*bdd1*f*g2 - 14850*D1**2*bdd2*f**2*r**2 - 29700*D1**2*bdd2*f**2*r*s + 29700*D1**2*bdd2*f**2*r - 14850*D1**2*bdd2*f**2*s**2 + 29700*D1**2*bdd2*f**2*s - 14850*D1**2*bdd2*f**2 + 9100*D1**2*f**3*fd*r**2 + 41440*D1**2*f**3*fd*r*s - 25270*D1**2*f**3*fd*r + 32340*D1**2*f**3*fd*s**2 - 42700*D1**2*f**3*fd*s + 18445*D1**2*f**3*fd - 9940*D1**2*f**3*fdd*r**2 - 45360*D1**2*f**3*fdd*r*s + 27650*D1**2*f**3*fdd*r - 35420*D1**2*f**3*fdd*s**2 + 46760*D1**2*f**3*fdd*s - 20195*D1**2*f**3*fdd - 29820*D1**2*f**2*fd**2*r**2 - 136080*D1**2*f**2*fd**2*r*s + 82950*D1**2*f**2*fd**2*r - 106260*D1**2*f**2*fd**2*s**2 + 140280*D1**2*f**2*fd**2*s - 40390*D1**2*f**2*fd**2 + 16335*D1**2*f**2*fd*r**2 + 23760*D1**2*f**2*fd*r*s - 18810*D1**2*f**2*fd*r + 7425*D1**2*f**2*fd*s**2 - 12870*D1**2*f**2*fd*s + 7920*D1**2*f**2*fd - 101178*D1**2*f**2*gd2*r**2 - 165132*D1**2*f**2*gd2*r*s + 165132*D1**2*f**2*gd2*r - 63954*D1**2*f**2*gd2*s**2 + 127908*D1**2*f**2*gd2*s - 63954*D1**2*f**2*gd2 + 110880*D1**2*f**2*gdd2*r**2 + 205920*D1**2*f**2*gdd2*r*s - 205920*D1**2*f**2*gdd2*r + 95040*D1**2*f**2*gdd2*s**2 - 190080*D1**2*f**2*gdd2*s + 95040*D1**2*f**2*gdd2 - 202356*D1**2*f*fd*g2*r**2 - 330264*D1**2*f*fd*g2*r*s + 202356*D1**2*f*fd*g2*r - 127908*D1**2*f*fd*g2*s**2 + 165132*D1**2*f*fd*g2*s - 101178*D1**2*f*fd*g2 + 443520*D1**2*f*fd*gd2*r**2 + 823680*D1**2*f*fd*gd2*r*s - 633600*D1**2*f*fd*gd2*r + 380160*D1**2*f*fd*gd2*s**2 - 586080*D1**2*f*fd*gd2*s + 205920*D1**2*f*fd*gd2 + 221760*D1**2*f*fdd*g2*r**2 + 411840*D1**2*f*fdd*g2*r*s - 221760*D1**2*f*fdd*g2*r + 190080*D1**2*f*fdd*g2*s**2 - 205920*D1**2*f*fdd*g2*s + 110880*D1**2*f*fdd*g2 + 221760*D1**2*fd**2*g2*r**2 + 411840*D1**2*fd**2*g2*r*s - 221760*D1**2*fd**2*g2*r + 190080*D1**2*fd**2*g2*s**2 - 205920*D1**2*fd**2*g2*s - 443520*D1*Dd*K*bd1*f**2*r**2 - 823680*D1*Dd*K*bd1*f**2*r*s + 728640*D1*Dd*K*bd1*f**2*r - 380160*D1*Dd*K*bd1*f**2*s**2 + 673200*D1*Dd*K*bd1*f**2*s - 293040*D1*Dd*K*bd1*f**2 + 150920*D1*Dd*bd1*f**3*r**2 + 267520*D1*Dd*bd1*f**3*r*s - 256850*D1*Dd*bd1*f**3*r + 116600*D1*Dd*bd1*f**3*s**2 - 226820*D1*Dd*bd1*f**3*s + 105600*D1*Dd*bd1*f**3 + 211464*D1*Dd*bd1*f**2*r**2 + 445104*D1*Dd*bd1*f**2*r*s - 386694*D1*Dd*bd1*f**2*r + 233640*D1*Dd*bd1*f**2*s**2 - 406098*D1*Dd*bd1*f**2*s + 172458*D1*Dd*bd1*f**2 + 820512*D1*Dd*bd1*f*g2*r**2 + 1641024*D1*Dd*bd1*f*g2*r*s - 1768536*D1*Dd*bd1*f*g2*r + 820512*D1*Dd*bd1*f*g2*s**2 - 1768536*D1*Dd*bd1*f*g2*s + 864864*D1*Dd*bd1*f*g2 - 118800*D1*Dd*bd2*f**2*r**2 - 237600*D1*Dd*bd2*f**2*r*s + 207900*D1*Dd*bd2*f**2*r - 118800*D1*Dd*bd2*f**2*s**2 + 207900*D1*Dd*bd2*f**2*s - 89100*D1*Dd*bd2*f**2 + 9100*D1*Dd*f**4*r**2 + 41440*D1*Dd*f**4*r*s - 25270*D1*Dd*f**4*r + 32340*D1*Dd*f**4*s**2 - 42700*D1*Dd*f**4*s + 18445*D1*Dd*f**4 - 79520*D1*Dd*f**3*fd*r**2 - 362880*D1*Dd*f**3*fd*r*s + 221200*D1*Dd*f**3*fd*r - 283360*D1*Dd*f**3*fd*s**2 + 374080*D1*Dd*f**3*fd*s - 121170*D1*Dd*f**3*fd + 21780*D1*Dd*f**3*r**2 + 31680*D1*Dd*f**3*r*s - 26730*D1*Dd*f**3*r + 9900*D1*Dd*f**3*s**2 - 17820*D1*Dd*f**3*s + 10395*D1*Dd*f**3 - 404712*D1*Dd*f**2*g2*r**2 - 660528*D1*Dd*f**2*g2*r*s + 532620*D1*Dd*f**2*g2*r - 255816*D1*Dd*f**2*g2*s**2 + 420948*D1*Dd*f**2*g2*s - 229086*D1*Dd*f**2*g2 + 887040*D1*Dd*f**2*gd2*r**2 + 1647360*D1*Dd*f**2*gd2*r*s - 1457280*D1*Dd*f**2*gd2*r + 760320*D1*Dd*f**2*gd2*s**2 - 1346400*D1*Dd*f**2*gd2*s + 586080*D1*Dd*f**2*gd2 + 1774080*D1*Dd*f*fd*g2*r**2 + 3294720*D1*Dd*f*fd*g2*r*s - 2154240*D1*Dd*f*fd*g2*r + 1520640*D1*Dd*f*fd*g2*s**2 - 1995840*D1*Dd*f*fd*g2*s + 633600*D1*Dd*f*fd*g2 - 9940*D1*Ddd*f**4*r**2 - 45360*D1*Ddd*f**4*r*s + 27650*D1*Ddd*f**4*r - 35420*D1*Ddd*f**4*s**2 + 46760*D1*Ddd*f**4*s - 20195*D1*Ddd*f**4 + 443520*D1*Ddd*f**2*g2*r**2 + 823680*D1*Ddd*f**2*g2*r*s - 633600*D1*Ddd*f**2*g2*r + 380160*D1*Ddd*f**2*g2*s**2 - 586080*D1*Ddd*f**2*g2*s + 300960*D1*Ddd*f**2*g2 - 29820*Dd**2*f**4*r**2 - 136080*Dd**2*f**4*r*s + 82950*Dd**2*f**4*r - 106260*Dd**2*f**4*s**2 + 140280*Dd**2*f**4*s - 40390*Dd**2*f**4 + 1330560*Dd**2*f**2*g2*r**2 + 2471040*Dd**2*f**2*g2*r*s - 1900800*Dd**2*f**2*g2*r + 1140480*Dd**2*f**2*g2*s**2 - 1758240*Dd**2*f**2*g2*s + 601920*Dd**2*f**2*g2 + 3465*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (5*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(350*C*D1**2*fd*r**2 + 700*C*D1**2*fd*r*s - 700*C*D1**2*fd*r + 350*C*D1**2*fd*s**2 - 700*C*D1**2*fd*s + 350*C*D1**2*fd + 1400*C*D1*Dd*f*r**2 + 2800*C*D1*Dd*f*r*s - 2100*C*D1*Dd*f*r + 1400*C*D1*Dd*f*s**2 - 2100*C*D1*Dd*f*s + 1050*C*D1*Dd*f + 938*D1**2*K*fd*r**2 + 1736*D1**2*K*fd*r*s + 770*D1**2*K*fd*r + 798*D1**2*K*fd*s**2 + 770*D1**2*K*fd*s - 385*D1**2*K*fd - 1554*D1**2*K*fdd*r**2 - 3108*D1**2*K*fdd*r*s - 1260*D1**2*K*fdd*r - 1554*D1**2*K*fdd*s**2 - 1260*D1**2*K*fdd*s + 630*D1**2*K*fdd - 105*D1**2*bdd1*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 810*D1**2*f*fd*r**2 - 2124*D1**2*f*fd*r*s + 882*D1**2*f*fd*r - 1314*D1**2*f*fd*s**2 + 1134*D1**2*f*fd*s - 567*D1**2*f*fd + 1182*D1**2*f*fdd*r**2 + 2868*D1**2*f*fdd*r*s - 1134*D1**2*f*fdd*r + 1686*D1**2*f*fdd*s**2 - 1386*D1**2*f*fdd*s + 693*D1**2*f*fdd + 1182*D1**2*fd**2*r**2 + 2868*D1**2*fd**2*r*s - 1134*D1**2*fd**2*r + 1686*D1**2*fd**2*s**2 - 1386*D1**2*fd**2*s - 300*D1**2*fd**2 - 637*D1**2*fd*r**2 - 1288*D1**2*fd*r*s + 140*D1**2*fd*r - 651*D1**2*fd*s**2 + 140*D1**2*fd*s - 70*D1**2*fd + 756*D1**2*fdd*r**2 + 1764*D1**2*fdd*r*s + 630*D1**2*fdd*r + 1008*D1**2*fdd*s**2 + 630*D1**2*fdd*s - 315*D1**2*fdd - 1050*D1**2*gd2*r**2 - 2100*D1**2*gd2*r*s + 2100*D1**2*gd2*r - 1050*D1**2*gd2*s**2 + 2100*D1**2*gd2*s - 1050*D1**2*gd2 - 2100*D1**2*gdd2*r**2 - 4200*D1**2*gdd2*r*s + 4200*D1**2*gdd2*r - 2100*D1**2*gdd2*s**2 + 4200*D1**2*gdd2*s - 2100*D1**2*gdd2 + 3752*D1*Dd*K*f*r**2 + 6944*D1*Dd*K*f*r*s - 5348*D1*Dd*K*f*r + 3192*D1*Dd*K*f*s**2 - 4928*D1*Dd*K*f*s + 2534*D1*Dd*K*f - 12432*D1*Dd*K*fd*r**2 - 24864*D1*Dd*K*fd*r*s + 4284*D1*Dd*K*fd*r - 12432*D1*Dd*K*fd*s**2 + 4284*D1*Dd*K*fd*s + 3780*D1*Dd*K*fd - 1620*D1*Dd*f**2*r**2 - 4248*D1*Dd*f**2*r*s + 2934*D1*Dd*f**2*r - 2628*D1*Dd*f**2*s**2 + 3690*D1*Dd*f**2*s - 1719*D1*Dd*f**2 + 9456*D1*Dd*f*fd*r**2 + 22944*D1*Dd*f*fd*r*s - 12636*D1*Dd*f*fd*r + 13488*D1*Dd*f*fd*s**2 - 15156*D1*Dd*f*fd*s + 3906*D1*Dd*f*fd - 2548*D1*Dd*f*r**2 - 5152*D1*Dd*f*r*s + 3850*D1*Dd*f*r - 2604*D1*Dd*f*s**2 + 3892*D1*Dd*f*s - 1939*D1*Dd*f + 6048*D1*Dd*fd*r**2 + 14112*D1*Dd*fd*r*s - 2520*D1*Dd*fd*r + 8064*D1*Dd*fd*s**2 - 3276*D1*Dd*fd*s - 1890*D1*Dd*fd - 4200*D1*Dd*g2*r**2 - 8400*D1*Dd*g2*r*s + 6300*D1*Dd*g2*r - 4200*D1*Dd*g2*s**2 + 6300*D1*Dd*g2*s - 3150*D1*Dd*g2 - 16800*D1*Dd*gd2*r**2 - 33600*D1*Dd*gd2*r*s + 29400*D1*Dd*gd2*r - 16800*D1*Dd*gd2*s**2 + 29400*D1*Dd*gd2*s - 12600*D1*Dd*gd2 - 6216*D1*Ddd*K*f*r**2 - 12432*D1*Ddd*K*f*r*s + 9324*D1*Ddd*K*f*r - 6216*D1*Ddd*K*f*s**2 + 9324*D1*Ddd*K*f*s - 4662*D1*Ddd*K*f + 2364*D1*Ddd*f**2*r**2 + 5736*D1*Ddd*f**2*r*s - 4050*D1*Ddd*f**2*r + 3372*D1*Ddd*f**2*s**2 - 4806*D1*Ddd*f**2*s + 2277*D1*Ddd*f**2 + 3024*D1*Ddd*f*r**2 + 7056*D1*Ddd*f*r*s - 5040*D1*Ddd*f*r + 4032*D1*Ddd*f*s**2 - 5796*D1*Ddd*f*s + 2772*D1*Ddd*f - 8400*D1*Ddd*g2*r**2 - 16800*D1*Ddd*g2*r*s + 12600*D1*Ddd*g2*r - 8400*D1*Ddd*g2*s**2 + 12600*D1*Ddd*g2*s - 6300*D1*Ddd*g2 + 105*D1*bd1*(D1*(f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (5*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-10*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 18648*Dd**2*K*f*r**2 - 37296*Dd**2*K*f*r*s + 27972*Dd**2*K*f*r - 18648*Dd**2*K*f*s**2 + 27972*Dd**2*K*f*s - 9324*Dd**2*K*f + 7092*Dd**2*f**2*r**2 + 17208*Dd**2*f**2*r*s - 12150*Dd**2*f**2*r + 10116*Dd**2*f**2*s**2 - 14418*Dd**2*f**2*s + 4554*Dd**2*f**2 + 9072*Dd**2*f*r**2 + 21168*Dd**2*f*r*s - 15120*Dd**2*f*r + 12096*Dd**2*f*s**2 - 17388*Dd**2*f*s + 5544*Dd**2*f - 25200*Dd**2*g2*r**2 - 50400*Dd**2*g2*r*s + 37800*Dd**2*g2*r - 25200*Dd**2*g2*s**2 + 37800*Dd**2*g2*s - 12600*Dd**2*g2) - 11*b1*(1008*C*D1**2*f*fd*r**2 + 1008*C*D1**2*f*fd*r*s + 756*C*D1**2*f*fd*r + 1260*C*D1**2*f*fd*s - 630*C*D1**2*f*fd + 2016*C*D1*Dd*f**2*r**2 + 2016*C*D1*Dd*f**2*r*s - 2016*C*D1*Dd*f**2*r - 504*C*D1*Dd*f**2*s + 504*C*D1*Dd*f**2 + 9324*D1**2*K*bdd1*f*r**2 + 18648*D1**2*K*bdd1*f*r*s - 22428*D1**2*K*bdd1*f*r + 9324*D1**2*K*bdd1*f*s**2 - 22428*D1**2*K*bdd1*f*s + 11214*D1**2*K*bdd1*f - 9198*D1**2*K*f*fd*r**2 - 15012*D1**2*K*f*fd*r*s + 9198*D1**2*K*f*fd*r - 5814*D1**2*K*f*fd*s**2 + 7506*D1**2*K*f*fd*s - 4599*D1**2*K*f*fd + 10080*D1**2*K*f*fdd*r**2 + 18720*D1**2*K*f*fdd*r*s - 10080*D1**2*K*f*fdd*r + 8640*D1**2*K*f*fdd*s**2 - 9360*D1**2*K*f*fdd*s + 5040*D1**2*K*f*fdd + 10080*D1**2*K*fd**2*r**2 + 18720*D1**2*K*fd**2*r*s - 10080*D1**2*K*fd**2*r + 8640*D1**2*K*fd**2*s**2 - 9360*D1**2*K*fd**2*s - 1155*D1**2*b2*fd*r**2 - 2310*D1**2*b2*fd*r*s - 1155*D1**2*b2*fd*s**2 + 1890*D1**2*b2*fdd*r**2 + 3780*D1**2*b2*fdd*r*s + 1890*D1**2*b2*fdd*s**2 + 630*D1**2*bd1**2*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 3546*D1**2*bdd1*f**2*r**2 - 8604*D1**2*bdd1*f**2*r*s + 8748*D1**2*bdd1*f**2*r - 5058*D1**2*bdd1*f**2*s**2 + 10260*D1**2*bdd1*f**2*s - 4752*D1**2*bdd1*f**2 - 4536*D1**2*bdd1*f*r**2 - 10584*D1**2*bdd1*f*r*s + 11718*D1**2*bdd1*f*r - 6048*D1**2*bdd1*f*s**2 + 13230*D1**2*bdd1*f*s - 6237*D1**2*bdd1*f + 12600*D1**2*bdd1*g2*r**2 + 25200*D1**2*bdd1*g2*r*s - 12600*D1**2*bdd1*g2*r + 12600*D1**2*bdd1*g2*s**2 - 12600*D1**2*bdd1*g2*s + 6300*D1**2*bdd1*g2 + 1890*D1**2*bdd2*f*r**2 + 3780*D1**2*bdd2*f*r*s - 3780*D1**2*bdd2*f*r + 1890*D1**2*bdd2*f*s**2 - 3780*D1**2*bdd2*f*s + 1890*D1**2*bdd2*f + 4215*D1**2*f**2*fd*r**2 + 6900*D1**2*f**2*fd*r*s - 4630*D1**2*f**2*fd*r + 2685*D1**2*f**2*fd*s**2 - 3610*D1**2*f**2*fd*s + 1695*D1**2*f**2*fd - 5145*D1**2*f**2*fdd*r**2 - 9120*D1**2*f**2*fdd*r*s + 6050*D1**2*f**2*fdd*r - 3975*D1**2*f**2*fdd*s**2 + 5270*D1**2*f**2*fdd*s - 2445*D1**2*f**2*fdd - 10290*D1**2*f*fd**2*r**2 - 18240*D1**2*f*fd**2*r*s + 12100*D1**2*f*fd**2*r - 7950*D1**2*f*fd**2*s**2 + 10540*D1**2*f*fd**2*s - 2970*D1**2*f*fd**2 + 3186*D1**2*f*fd*r**2 + 6372*D1**2*f*fd*r*s - 4194*D1**2*f*fd*r + 3186*D1**2*f*fd*s**2 - 4194*D1**2*f*fd*s + 2286*D1**2*f*fd - 4806*D1**2*f*fdd*r**2 - 10116*D1**2*f*fdd*r*s + 4806*D1**2*f*fdd*r - 5310*D1**2*f*fdd*s**2 + 5058*D1**2*f*fdd*s - 2403*D1**2*f*fdd + 5628*D1**2*f*gd2*r**2 + 10416*D1**2*f*gd2*r*s - 10416*D1**2*f*gd2*r + 4788*D1**2*f*gd2*s**2 - 9576*D1**2*f*gd2*s + 4788*D1**2*f*gd2 - 9324*D1**2*f*gdd2*r**2 - 18648*D1**2*f*gdd2*r*s + 18648*D1**2*f*gdd2*r - 9324*D1**2*f*gdd2*s**2 + 18648*D1**2*f*gdd2*s - 9324*D1**2*f*gdd2 - 4806*D1**2*fd**2*r**2 - 10116*D1**2*fd**2*r*s + 4806*D1**2*fd**2*r - 5310*D1**2*fd**2*s**2 + 5058*D1**2*fd**2*s + 5628*D1**2*fd*g2*r**2 + 10416*D1**2*fd*g2*r*s + 4620*D1**2*fd*g2*r + 4788*D1**2*fd*g2*s**2 + 4620*D1**2*fd*g2*s - 2310*D1**2*fd*g2 - 18648*D1**2*fd*gd2*r**2 - 37296*D1**2*fd*gd2*r*s + 11088*D1**2*fd*gd2*r - 18648*D1**2*fd*gd2*s**2 + 11088*D1**2*fd*gd2*s + 7560*D1**2*fd*gd2 - 9324*D1**2*fdd*g2*r**2 - 18648*D1**2*fdd*g2*r*s - 7560*D1**2*fdd*g2*r - 9324*D1**2*fdd*g2*s**2 - 7560*D1**2*fdd*g2*s + 3780*D1**2*fdd*g2 - 18396*D1*Dd*K*f**2*r**2 - 30024*D1*Dd*K*f**2*r*s + 24210*D1*Dd*K*f**2*r - 11628*D1*Dd*K*f**2*s**2 + 19134*D1*Dd*K*f**2*s - 10413*D1*Dd*K*f**2 + 80640*D1*Dd*K*f*fd*r**2 + 149760*D1*Dd*K*f*fd*r*s - 97920*D1*Dd*K*f*fd*r + 69120*D1*Dd*K*f*fd*s**2 - 90720*D1*Dd*K*f*fd*s + 28800*D1*Dd*K*f*fd - 4620*D1*Dd*b2*f*r**2 - 9240*D1*Dd*b2*f*r*s + 6930*D1*Dd*b2*f*r - 4620*D1*Dd*b2*f*s**2 + 6930*D1*Dd*b2*f*s - 3465*D1*Dd*b2*f + 15120*D1*Dd*b2*fd*r**2 + 30240*D1*Dd*b2*fd*r*s - 11340*D1*Dd*b2*fd*r + 15120*D1*Dd*b2*fd*s**2 - 11340*D1*Dd*b2*fd*s + 5620*D1*Dd*f**3*r**2 + 9200*D1*Dd*f**3*r*s - 7410*D1*Dd*f**3*r + 3580*D1*Dd*f**3*s**2 - 5880*D1*Dd*f**3*s + 3195*D1*Dd*f**3 - 41160*D1*Dd*f**2*fd*r**2 - 72960*D1*Dd*f**2*fd*r*s + 52730*D1*Dd*f**2*fd*r - 31800*D1*Dd*f**2*fd*s**2 + 46100*D1*Dd*f**2*fd*s - 16590*D1*Dd*f**2*fd + 6372*D1*Dd*f**2*r**2 + 12744*D1*Dd*f**2*r*s - 9558*D1*Dd*f**2*r + 6372*D1*Dd*f**2*s**2 - 9558*D1*Dd*f**2*s + 4779*D1*Dd*f**2 - 38448*D1*Dd*f*fd*r**2 - 80928*D1*Dd*f*fd*r*s + 49068*D1*Dd*f*fd*r - 42480*D1*Dd*f*fd*s**2 + 51588*D1*Dd*f*fd*s - 14922*D1*Dd*f*fd + 22512*D1*Dd*f*g2*r**2 + 41664*D1*Dd*f*g2*r*s - 32088*D1*Dd*f*g2*r + 19152*D1*Dd*f*g2*s**2 - 29568*D1*Dd*f*g2*s + 15204*D1*Dd*f*g2 - 74592*D1*Dd*f*gd2*r**2 - 149184*D1*Dd*f*gd2*r*s + 130536*D1*Dd*f*gd2*r - 74592*D1*Dd*f*gd2*s**2 + 130536*D1*Dd*f*gd2*s - 55944*D1*Dd*f*gd2 - 74592*D1*Dd*fd*g2*r**2 - 149184*D1*Dd*fd*g2*r*s + 25704*D1*Dd*fd*g2*r - 74592*D1*Dd*fd*g2*s**2 + 25704*D1*Dd*fd*g2*s + 22680*D1*Dd*fd*g2 + 20160*D1*Ddd*K*f**2*r**2 + 37440*D1*Ddd*K*f**2*r*s - 28800*D1*Ddd*K*f**2*r + 17280*D1*Ddd*K*f**2*s**2 - 26640*D1*Ddd*K*f**2*s + 13680*D1*Ddd*K*f**2 + 7560*D1*Ddd*b2*f*r**2 + 15120*D1*Ddd*b2*f*r*s - 11340*D1*Ddd*b2*f*r + 7560*D1*Ddd*b2*f*s**2 - 11340*D1*Ddd*b2*f*s + 5670*D1*Ddd*b2*f - 6860*D1*Ddd*f**3*r**2 - 12160*D1*Ddd*f**3*r*s + 9510*D1*Ddd*f**3*r - 5300*D1*Ddd*f**3*s**2 + 8340*D1*Ddd*f**3*s - 4365*D1*Ddd*f**3 - 9612*D1*Ddd*f**2*r**2 - 20232*D1*Ddd*f**2*r*s + 14922*D1*Ddd*f**2*r - 10620*D1*Ddd*f**2*s**2 + 15678*D1*Ddd*f**2*s - 7713*D1*Ddd*f**2 - 37296*D1*Ddd*f*g2*r**2 - 74592*D1*Ddd*f*g2*r*s + 55944*D1*Ddd*f*g2*r - 37296*D1*Ddd*f*g2*s**2 + 55944*D1*Ddd*f*g2*s - 27972*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(18*f**2*(45*r**2 + 2*r*(59*s - 57) + 73*s**2 - 142*s + 64) - f*(350*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(268*r**2 + 496*r*s - 626*r + 228*s**2 - 586*s + 303) + 12*fd*(394*r**2 + r*(956*s - 675) + 562*s**2 - 801*s + 260) - 1274*r**2 - 2576*r*s + 2422*r - 1302*s**2 + 2450*s - 1218) + 42*fd*(2*K*(74*r**2 + 148*r*s - 59*r + 74*s**2 - 59*s - 15) - 72*r**2 - 168*r*s + 63*r - 96*s**2 + 75*s + 15) + 1050*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 4200*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*(2*f**2*(788*r**2 + r*(1912*s - 1647) + 1124*s**2 - 1941*s + 813) - 7*f*(2*K*(296*r**2 + r*(592*s - 578) + 296*s**2 - 578*s + 267) - 288*r**2 - 12*r*(56*s - 51) - 384*s**2 + 696*s - 303) - 700*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 105*D1*bd2*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) + 60480*Dd**2*K*f**2*r**2 + 112320*Dd**2*K*f**2*r*s - 86400*Dd**2*K*f**2*r + 51840*Dd**2*K*f**2*s**2 - 79920*Dd**2*K*f**2*s + 27360*Dd**2*K*f**2 + 22680*Dd**2*b2*f*r**2 + 45360*Dd**2*b2*f*r*s - 34020*Dd**2*b2*f*r + 22680*Dd**2*b2*f*s**2 - 34020*Dd**2*b2*f*s + 11340*Dd**2*b2*f - 20580*Dd**2*f**3*r**2 - 36480*Dd**2*f**3*r*s + 28530*Dd**2*f**3*r - 15900*Dd**2*f**3*s**2 + 25020*Dd**2*f**3*s - 8730*Dd**2*f**3 - 28836*Dd**2*f**2*r**2 - 60696*Dd**2*f**2*r*s + 44766*Dd**2*f**2*r - 31860*Dd**2*f**2*s**2 + 47034*Dd**2*f**2*s - 15426*Dd**2*f**2 - 111888*Dd**2*f*g2*r**2 - 223776*Dd**2*f*g2*r*s + 167832*Dd**2*f*g2*r - 111888*Dd**2*f*g2*s**2 + 167832*Dd**2*f*g2*s - 55944*Dd**2*f*g2) + 165*b2*(-126*D1**2*bdd1*f*(r + s - 1)**2 + 15*D1**2*(f*(5*fd - 6*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 7*D1*bd1*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) + 15*D1*f*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 540*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(6930*d**2*k3**5) + 2*D1**2*Pk1*Pkd3*ct**2*k1**2*st**2*(7*b1**2*(D1**2*(s - 1)*(fd*(28*C - 15) + fdd*(15 - 24*C))*(r + s - 1) + D1*(Dd*(f*(28*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(24*C - 15)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(15 - 24*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(24*C - 15)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(-D1**2*(f*(21*bdd1*s*(8*C - 5)*(2*r + 2*s - 1) + fd*(4*C*(8*r*s - 4*r + 8*s**2 + 21*s + 4) - 16*r*s + 8*r - 16*s**2 - 53*s - 8) - 9*fdd*(C*(8*r*s - 4*r + 8*s**2 + 4) - 4*r*s + 2*r - 4*s**2 - s - 2)) - 9*fd**2*(C*(8*r*s - 4*r + 8*s**2 - 8) - 4*r*s + 2*r - 4*s**2 - s + 5)) + 7*D1*bd1*(D1*(f*s*(28*C - 15)*(2*r + 2*s - 1) - fd*(24*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(30 - 48*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(2*Dd*(f*(4*C - 2)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 9*fd*(2*s - 1)*(C*(8*r + 8*s - 1) - 4*r - 4*s)) + Ddd*f*(9 - 18*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(36*C - 18)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-21*D1**2*bd1**2*s*(8*C - 5)*(2*r + 2*s - 1) + D1**2*(f*(9*bdd1*s*(4*C*(r + s - 3) - 2*r - 2*s + 7) - fd*(84*C - 49)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(60*C - 35)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(60*C - 35)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(-4*C*(4*r + 4*s - 33) + 8*r + 8*s - 77) + 9*fd*(4*C*(4*r*s - r + 4*s**2 - 6*s + 3) - 8*r*s + 2*r - 8*s**2 + 13*s - 7)) + 18*Dd*f*(2*C*(8*r*s - 2*r + 8*s**2 - 17*s + 6) - 8*r*s + 2*r - 8*s**2 + 19*s - 7)) - D1*f*(12*C - 7)*(Dd*(7*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(60*C - 35)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**2*k1**2*(-42*b1**2*(D1**2*(fd*(80*C - 51)*(s - 1) + fdd*(-20*C*(r + 4*s - 4) + 10*r + 53*s - 53))*(r + s - 1) + D1*(Dd*(f*(80*C - 51)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(-20*C*(8*r**2 + 8*r*(5*s - 4) + 32*s**2 - 53*s + 21) + 80*r**2 + 504*r*s - 398*r + 424*s**2 - 699*s + 275)) + Ddd*f*(-20*C*(4*r**2 + 4*r*(5*s - 3) + 16*s**2 - 21*s + 9) + 40*r**2 + 252*r*s - 146*r + 212*s**2 - 275*s + 116)) + Dd**2*f*(-60*C*(4*r**2 + 4*r*(5*s - 3) + 16*s**2 - 21*s + 6) + 120*r**2 + 6*r*(126*s - 73) + 636*s**2 - 825*s + 232)) + 3*b1*(14*D1**2*bdd1*f*(20*C*(2*r**2 + 2*r*(5*s - 1) + 8*s**2 - 5*s + 1) - 20*r**2 + r*(20 - 126*s) - 106*s**2 + 63*s - 10) - 3*D1**2*(f*(fd*(2*C*(6*r**2 - 20*r*s - 38*r - 26*s**2 - 118*s + 11) - 6*r**2 + 20*r*s + 38*r + 26*s**2 + 152*s - 11) + fdd*(-2*C*(10*r**2 + 4*r*s - 82*r - 6*s**2 - 150*s + 37) + 10*r**2 + 4*r*s - 82*r - 6*s**2 - 188*s + 37)) - 2*fd**2*(2*C*(5*r**2 + 2*r*s - 41*r - 3*s**2 - 75*s + 78) - 5*r**2 - 2*r*s + 41*r + 3*s**2 + 94*s - 97)) - 14*D1*bd1*(D1*(f*s*(80*C - 51)*(2*r + 2*s - 1) + fd*(-20*C*(4*r**2 + 4*r*(5*s - 3) + 16*s**2 - 21*s + 5) + 40*r**2 + 252*r*s - 146*r + 212*s**2 - 275*s + 63)) - 2*Dd*f*(20*C*(8*r**2 + 8*r*(5*s - 2) + 32*s**2 - 31*s + 6) - 80*r**2 - 504*r*s + 186*r - 424*s**2 + 401*s - 73)) - 3*D1*f*(Dd*(f*(2*C - 1)*(12*r**2 + r*(14 - 40*s) - 52*s**2 + 62*s - 23) + 2*fd*(C*(-80*r**2 - 4*r*(8*s - 89) + 48*s**2 + 580*s - 382) + 40*r**2 + 2*r*(8*s - 89) - 24*s**2 - 366*s + 229)) - Ddd*f*(2*C - 1)*(20*r**2 + 2*r*(4*s - 7) - 12*s**2 + 10*s - 1)) - 3*Dd**2*f**2*(2 - 4*C)*(30*r**2 + 3*r*(4*s - 7) - 18*s**2 + 15*s - 1)) + f*(42*D1**2*bd1**2*(r**2*(40*C - 20) + 2*r*(20*C*(5*s - 1) - 63*s + 10) + s*(20*C*(8*s - 5) - 106*s + 63)) + 9*D1**2*bdd1*f*(2*C*(5*r**2 + 2*r*(s + 35) - 3*s**2 + 154*s - 35) - 5*r**2 - 2*r*(s + 35) + 3*s**2 - 192*s + 35) + 5*D1**2*(f*(fd*(2*C*(129*r**2 + 642*r*s - 300*r + 513*s**2 - 556*s + 214) - 129*r**2 - 780*r*s + 346*r - 651*s**2 + 694*s - 260) + fdd*(-2*C*(159*r**2 + 618*r*s - 312*r + 459*s**2 - 512*s + 206) + 159*r**2 + 768*r*s - 362*r + 609*s**2 - 662*s + 256)) - 2*fd**2*(2*C*(159*r**2 + 618*r*s - 312*r + 459*s**2 - 512*s + 103) - 159*r**2 - 768*r*s + 362*r - 609*s**2 + 662*s - 128)) - 9*D1*bd1*(D1*(f*(C*(6*r**2 - 20*r*s + 84*r - 26*s**2 + 308*s - 42) - 3*r**2 + 10*r*s - 42*r + 13*s**2 - 188*s + 21) - 2*fd*(2*C*(10*r**2 + 4*r*s + 29*r - 6*s**2 + 79*s - 77) - 10*r**2 - 4*r*s - 29*r + 6*s**2 - 98*s + 96)) + 2*Dd*f*(-2*C*(20*r**2 + 8*r*s + 133*r - 12*s**2 + 313*s - 189) + 20*r**2 + 8*r*s + 133*r - 12*s**2 + 389*s - 227)) + 5*D1*f*(Dd*(f*(2*C*(172*r**2 + 856*r*s - 514*r + 684*s**2 - 898*s + 385) - 172*r**2 - 1040*r*s + 606*r - 868*s**2 + 1128*s - 477) + 2*fd*(-2*C*(636*r**2 + 3*r*(824*s - 467) + 1836*s**2 - 2251*s + 668) + 636*r**2 + 3072*r*s - 1651*r + 2436*s**2 - 2926*s + 843)) + Ddd*f*(-2*C*(212*r**2 + 824*r*s - 518*r + 612*s**2 - 818*s + 359) + 212*r**2 + 1024*r*s - 618*r + 812*s**2 - 1068*s + 459)) + 10*Dd**2*f**2*(-2*C*(318*r**2 + 1236*r*s - 777*r + 918*s**2 - 1227*s + 359) + 318*r**2 + 1536*r*s - 927*r + 1218*s**2 - 1602*s + 459)))/(630*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**2*k2**6*st**6*(C - 1)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(7*d**2*k3**7) - 3*D1**2*Pk1*Pkd3*ct**2*k2**6*st**4*(198*C*D1**2*f**2*fd*r**2 + 396*C*D1**2*f**2*fd*r*s - 264*C*D1**2*f**2*fd*r + 198*C*D1**2*f**2*fd*s**2 - 264*C*D1**2*f**2*fd*s + 132*C*D1**2*f**2*fd + 264*C*D1*Dd*f**3*r**2 + 528*C*D1*Dd*f**3*r*s - 396*C*D1*Dd*f**3*r + 264*C*D1*Dd*f**3*s**2 - 396*C*D1*Dd*f**3*s + 198*C*D1*Dd*f**3 + 33*D1**2*K*bdd1*f**2*r**2 + 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*r + 33*D1**2*K*bdd1*f**2*s**2 - 66*D1**2*K*bdd1*f**2*s + 33*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(-7*K + 15*f + 7)*(r + s - 1)**2 + 660*D1**2*bdd1*f**3*r**2 + 1320*D1**2*bdd1*f**3*r*s - 1320*D1**2*bdd1*f**3*r + 660*D1**2*bdd1*f**3*s**2 - 1320*D1**2*bdd1*f**3*s + 660*D1**2*bdd1*f**3 - 33*D1**2*bdd1*f**2*r**2 - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r - 33*D1**2*bdd1*f**2*s**2 + 66*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 - 462*D1**2*bdd1*f*g2*r**2 - 924*D1**2*bdd1*f*g2*r*s + 924*D1**2*bdd1*f*g2*r - 462*D1**2*bdd1*f*g2*s**2 + 924*D1**2*bdd1*f*g2*s - 462*D1**2*bdd1*f*g2 - 2560*D1**2*f**3*fd*r**2 - 5120*D1**2*f**3*fd*r*s + 3840*D1**2*f**3*fd*r - 2560*D1**2*f**3*fd*s**2 + 3840*D1**2*f**3*fd*s - 1920*D1**2*f**3*fd + 1500*D1**2*f**3*fdd*r**2 + 3000*D1**2*f**3*fdd*r*s - 2250*D1**2*f**3*fdd*r + 1500*D1**2*f**3*fdd*s**2 - 2250*D1**2*f**3*fdd*s + 1125*D1**2*f**3*fdd + 4500*D1**2*f**2*fd**2*r**2 + 9000*D1**2*f**2*fd**2*r*s - 6750*D1**2*f**2*fd**2*r + 4500*D1**2*f**2*fd**2*s**2 - 6750*D1**2*f**2*fd**2*s + 2250*D1**2*f**2*fd**2 - 198*D1**2*f**2*fd*r**2 - 396*D1**2*f**2*fd*r*s + 264*D1**2*f**2*fd*r - 198*D1**2*f**2*fd*s**2 + 264*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 132*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*r + 132*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gd2 - 66*D1**2*f**2*gdd2*r**2 - 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*r - 66*D1**2*f**2*gdd2*s**2 + 132*D1**2*f**2*gdd2*s - 66*D1**2*f**2*gdd2 + 264*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 264*D1**2*f*fd*gd2*r**2 - 528*D1**2*f*fd*gd2*r*s + 396*D1**2*f*fd*gd2*r - 264*D1**2*f*fd*gd2*s**2 + 396*D1**2*f*fd*gd2*s - 132*D1**2*f*fd*gd2 - 132*D1**2*f*fdd*g2*r**2 - 264*D1**2*f*fdd*g2*r*s + 132*D1**2*f*fdd*g2*r - 132*D1**2*f*fdd*g2*s**2 + 132*D1**2*f*fdd*g2*s - 66*D1**2*f*fdd*g2 - 132*D1**2*fd**2*g2*r**2 - 264*D1**2*fd**2*g2*r*s + 132*D1**2*fd**2*g2*r - 132*D1**2*fd**2*g2*s**2 + 132*D1**2*fd**2*g2*s - 2560*D1*Dd*f**4*r**2 - 5120*D1*Dd*f**4*r*s + 3840*D1*Dd*f**4*r - 2560*D1*Dd*f**4*s**2 + 3840*D1*Dd*f**4*s - 1920*D1*Dd*f**4 + 12000*D1*Dd*f**3*fd*r**2 + 24000*D1*Dd*f**3*fd*r*s - 18000*D1*Dd*f**3*fd*r + 12000*D1*Dd*f**3*fd*s**2 - 18000*D1*Dd*f**3*fd*s + 6750*D1*Dd*f**3*fd - 264*D1*Dd*f**3*r**2 - 528*D1*Dd*f**3*r*s + 396*D1*Dd*f**3*r - 264*D1*Dd*f**3*s**2 + 396*D1*Dd*f**3*s - 198*D1*Dd*f**3 + 528*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 396*D1*Dd*f**2*g2 - 528*D1*Dd*f**2*gd2*r**2 - 1056*D1*Dd*f**2*gd2*r*s + 924*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s**2 + 924*D1*Dd*f**2*gd2*s - 396*D1*Dd*f**2*gd2 - 1056*D1*Dd*f*fd*g2*r**2 - 2112*D1*Dd*f*fd*g2*r*s + 1320*D1*Dd*f*fd*g2*r - 1056*D1*Dd*f*fd*g2*s**2 + 1320*D1*Dd*f*fd*g2*s - 396*D1*Dd*f*fd*g2 + 1500*D1*Ddd*f**4*r**2 + 3000*D1*Ddd*f**4*r*s - 2250*D1*Ddd*f**4*r + 1500*D1*Ddd*f**4*s**2 - 2250*D1*Ddd*f**4*s + 1125*D1*Ddd*f**4 - 264*D1*Ddd*f**2*g2*r**2 - 528*D1*Ddd*f**2*g2*r*s + 396*D1*Ddd*f**2*g2*r - 264*D1*Ddd*f**2*g2*s**2 + 396*D1*Ddd*f**2*g2*s - 198*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(15*f**3*(r + s - 1) + f**2*(-7*C*(r + s - 1) - 20*fd*(3*r + 3*s - 2) + (K + 6)*(r + s - 1)) + f*(-fd*(K - 1)*(2*r + 2*s - 1) + (-14*g2 + 14*gd2)*(r + s - 1)) + 14*fd*g2*(r + s)) - Dd*f*(20*f**2 + f*(K - 1) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) + 4500*Dd**2*f**4*r**2 + 9000*Dd**2*f**4*r*s - 6750*Dd**2*f**4*r + 4500*Dd**2*f**4*s**2 - 6750*Dd**2*f**4*s + 2250*Dd**2*f**4 - 792*Dd**2*f**2*g2*r**2 - 1584*Dd**2*f**2*g2*r*s + 1188*Dd**2*f**2*g2*r - 792*Dd**2*f**2*g2*s**2 + 1188*Dd**2*f**2*g2*s - 396*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(15*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(30*fd**2*(r + s - 1) + 14*fd*(K - 1)*(r + s) - 7*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(15*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(15*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (7*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-7*K + 15*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-7*K + 15*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(28*C*D1**2*f*fd*r**2 + 56*C*D1**2*f*fd*r*s - 28*C*D1**2*f*fd*r + 28*C*D1**2*f*fd*s**2 - 28*C*D1**2*f*fd*s + 14*C*D1**2*f*fd + 56*C*D1*Dd*f**2*r**2 + 112*C*D1*Dd*f**2*r*s - 84*C*D1*Dd*f**2*r + 56*C*D1*Dd*f**2*s**2 - 84*C*D1*Dd*f**2*s + 42*C*D1*Dd*f**2 - 4*D1**2*K*f*fd*r**2 - 8*D1**2*K*f*fd*r*s + 4*D1**2*K*f*fd*r - 4*D1**2*K*f*fd*s**2 + 4*D1**2*K*f*fd*s - 2*D1**2*K*f*fd + 2*D1**2*K*f*fdd*r**2 + 4*D1**2*K*f*fdd*r*s - 2*D1**2*K*f*fdd*r + 2*D1**2*K*f*fdd*s**2 - 2*D1**2*K*f*fdd*s + D1**2*K*f*fdd + 2*D1**2*K*fd**2*r**2 + 4*D1**2*K*fd**2*r*s - 2*D1**2*K*fd**2*r + 2*D1**2*K*fd**2*s**2 - 2*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-7*K + 15*f + 7)*(r + s - 1)**2 - 90*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 120*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 80*D1**2*f**2*fdd*s + 40*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 240*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 160*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 24*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 24*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd + 28*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r + 28*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s + 28*D1**2*f*gd2 - 14*D1**2*f*gdd2*r**2 - 28*D1**2*f*gdd2*r*s + 28*D1**2*f*gdd2*r - 14*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 14*D1**2*f*gdd2 - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s + 28*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*s**2 - 28*D1**2*fd*gd2*r**2 - 56*D1**2*fd*gd2*r*s + 28*D1**2*fd*gd2*r - 28*D1**2*fd*gd2*s**2 + 28*D1**2*fd*gd2*s - 14*D1**2*fdd*g2*r**2 - 28*D1**2*fdd*g2*r*s - 14*D1**2*fdd*g2*s**2 - 8*D1*Dd*K*f**2*r**2 - 16*D1*Dd*K*f**2*r*s + 12*D1*Dd*K*f**2*r - 8*D1*Dd*K*f**2*s**2 + 12*D1*Dd*K*f**2*s - 6*D1*Dd*K*f**2 + 16*D1*Dd*K*f*fd*r**2 + 32*D1*Dd*K*f*fd*r*s - 20*D1*Dd*K*f*fd*r + 16*D1*Dd*K*f*fd*s**2 - 20*D1*Dd*K*f*fd*s + 6*D1*Dd*K*f*fd - 120*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 180*D1*Dd*f**3*s - 90*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 960*D1*Dd*f**2*fd*r*s - 680*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 680*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd - 48*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 72*D1*Dd*f**2*s - 36*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd*s - 6*D1*Dd*f*fd + 112*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 112*D1*Dd*f*g2*s**2 - 168*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*r**2 - 224*D1*Dd*f*gd2*r*s + 196*D1*Dd*f*gd2*r - 112*D1*Dd*f*gd2*s**2 + 196*D1*Dd*f*gd2*s - 84*D1*Dd*f*gd2 - 112*D1*Dd*fd*g2*r**2 - 224*D1*Dd*fd*g2*r*s + 84*D1*Dd*fd*g2*r - 112*D1*Dd*fd*g2*s**2 + 84*D1*Dd*fd*g2*s + 4*D1*Ddd*K*f**2*r**2 + 8*D1*Ddd*K*f**2*r*s - 6*D1*Ddd*K*f**2*r + 4*D1*Ddd*K*f**2*s**2 - 6*D1*Ddd*K*f**2*s + 3*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r**2 + 160*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 120*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 - 56*D1*Ddd*f*g2*r**2 - 112*D1*Ddd*f*g2*r*s + 84*D1*Ddd*f*g2*r - 56*D1*Ddd*f*g2*s**2 + 84*D1*Ddd*f*g2*s - 42*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(15*f**2*(r + s - 1) - 15*f*fd*(2*r + 2*s - 1) - 7*f*(K - 1)*(r + s - 1) + 7*fd*(K - 1)*(r + s)) - Dd*f*(-7*K + 15*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 12*Dd**2*K*f**2*r**2 + 24*Dd**2*K*f**2*r*s - 18*Dd**2*K*f**2*r + 12*Dd**2*K*f**2*s**2 - 18*Dd**2*K*f**2*s + 6*Dd**2*K*f**2 + 240*Dd**2*f**3*r**2 + 480*Dd**2*f**3*r*s - 360*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 360*Dd**2*f**3*s + 120*Dd**2*f**3 - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2 - 168*Dd**2*f*g2*r**2 - 336*Dd**2*f*g2*r*s + 252*Dd**2*f*g2*r - 168*Dd**2*f*g2*s**2 + 252*Dd**2*f*g2*s - 84*Dd**2*f*g2))/(770*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**2*k2**4*st**6*(4*C - 4)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(63*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**2*k2**4*st**4*(210*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-1508*C*D1**2*f*fd*r**2 - 2424*C*D1**2*f*fd*r*s + 1172*C*D1**2*f*fd*r - 916*C*D1**2*f*fd*s**2 + 876*C*D1**2*f*fd*s - 438*C*D1**2*f*fd + 852*C*D1**2*f*fdd*r**2 + 1464*C*D1**2*f*fdd*r*s - 712*C*D1**2*f*fdd*r + 612*C*D1**2*f*fdd*s**2 - 592*C*D1**2*f*fdd*s + 296*C*D1**2*f*fdd + 852*C*D1**2*fd**2*r**2 + 1464*C*D1**2*fd**2*r*s - 712*C*D1**2*fd**2*r + 612*C*D1**2*fd**2*s**2 - 592*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 3016*C*D1*Dd*f**2*r**2 - 4848*C*D1*Dd*f**2*r*s + 3932*C*D1*Dd*f**2*r - 1832*C*D1*Dd*f**2*s**2 + 3044*C*D1*Dd*f**2*s - 1670*C*D1*Dd*f**2 + 6816*C*D1*Dd*f*fd*r**2 + 11712*C*D1*Dd*f*fd*r*s - 7480*C*D1*Dd*f*fd*r + 4896*C*D1*Dd*f*fd*s**2 - 6280*C*D1*Dd*f*fd*s + 1896*C*D1*Dd*f*fd + 1704*C*D1*Ddd*f**2*r**2 + 2928*C*D1*Ddd*f**2*r*s - 2316*C*D1*Ddd*f**2*r + 1224*C*D1*Ddd*f**2*s**2 - 1956*C*D1*Ddd*f**2*s + 1038*C*D1*Ddd*f**2 + 5112*C*Dd**2*f**2*r**2 + 8784*C*Dd**2*f**2*r*s - 6948*C*Dd**2*f**2*r + 3672*C*Dd**2*f**2*s**2 - 5868*C*Dd**2*f**2*s + 2076*C*Dd**2*f**2 - 70*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 1348*D1**2*f*fd*r**2 + 2224*D1**2*f*fd*r*s - 1072*D1**2*f*fd*r + 876*D1**2*f*fd*s**2 - 836*D1**2*f*fd*s + 418*D1**2*f*fd - 842*D1**2*f*fdd*r**2 - 1504*D1**2*f*fdd*r*s + 732*D1**2*f*fdd*r - 662*D1**2*f*fdd*s**2 + 642*D1**2*f*fdd*s - 321*D1**2*f*fdd - 842*D1**2*fd**2*r**2 - 1504*D1**2*fd**2*r*s + 732*D1**2*fd**2*r - 662*D1**2*fd**2*s**2 + 642*D1**2*fd**2*s + 20*D1**2*fd**2 + 2696*D1*Dd*f**2*r**2 + 4448*D1*Dd*f**2*r*s - 3572*D1*Dd*f**2*r + 1752*D1*Dd*f**2*s**2 - 2864*D1*Dd*f**2*s + 1550*D1*Dd*f**2 - 6736*D1*Dd*f*fd*r**2 - 12032*D1*Dd*f*fd*r*s + 7620*D1*Dd*f*fd*r - 5296*D1*Dd*f*fd*s**2 + 6720*D1*Dd*f*fd*s - 2016*D1*Dd*f*fd - 1684*D1*Ddd*f**2*r**2 - 3008*D1*Ddd*f**2*r*s + 2346*D1*Ddd*f**2*r - 1324*D1*Ddd*f**2*s**2 + 2076*D1*Ddd*f**2*s - 1083*D1*Ddd*f**2 + 140*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5052*Dd**2*f**2*r**2 - 9024*Dd**2*f**2*r*s + 7038*Dd**2*f**2*r - 3972*Dd**2*f**2*s**2 + 6228*Dd**2*f**2*s - 2166*Dd**2*f**2) + f*(-2778*C*D1**2*f*fd*r**2 - 4044*C*D1**2*f*fd*r*s + 3200*C*D1**2*f*fd*r - 1266*C*D1**2*f*fd*s**2 + 2192*C*D1**2*f*fd*s - 1348*C*D1**2*f*fd + 1812*C*D1**2*f*fdd*r**2 + 2544*C*D1**2*f*fdd*r*s - 2056*C*D1**2*f*fdd*r + 732*C*D1**2*f*fdd*s**2 - 1336*C*D1**2*f*fdd*s + 848*C*D1**2*f*fdd + 3624*C*D1**2*fd**2*r**2 + 5088*C*D1**2*fd**2*r*s - 4112*C*D1**2*fd**2*r + 1464*C*D1**2*fd**2*s**2 - 2672*C*D1**2*fd**2*s + 848*C*D1**2*fd**2 - 3704*C*D1*Dd*f**2*r**2 - 5392*C*D1*Dd*f**2*r*s + 4548*C*D1*Dd*f**2*r - 1688*C*D1*Dd*f**2*s**2 + 3036*C*D1*Dd*f**2*s - 1770*C*D1*Dd*f**2 + 14496*C*D1*Dd*f*fd*r**2 + 20352*C*D1*Dd*f*fd*r*s - 16936*C*D1*Dd*f*fd*r + 5856*C*D1*Dd*f*fd*s**2 - 10816*C*D1*Dd*f*fd*s + 4728*C*D1*Dd*f*fd + 2416*C*D1*Ddd*f**2*r**2 + 3392*C*D1*Ddd*f**2*r*s - 2904*C*D1*Ddd*f**2*r + 976*C*D1*Ddd*f**2*s**2 - 1824*C*D1*Ddd*f**2*s + 1092*C*D1*Ddd*f**2 + 7248*C*Dd**2*f**2*r**2 + 10176*C*Dd**2*f**2*r*s - 8712*C*Dd**2*f**2*r + 2928*C*Dd**2*f**2*s**2 - 5472*C*Dd**2*f**2*s + 2184*C*Dd**2*f**2 - 420*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*D1**2*bdd1*f*(C*(426*r**2 + r*(732*s - 872) + 306*s**2 - 752*s + 436) - 421*r**2 + r*(862 - 752*s) - 331*s**2 + 772*s - 431) + 2562*D1**2*f*fd*r**2 + 3888*D1**2*f*fd*r*s - 3004*D1**2*f*fd*r + 1326*D1**2*f*fd*s**2 - 2180*D1**2*f*fd*s + 1296*D1**2*f*fd - 1677*D1**2*f*fdd*r**2 - 2484*D1**2*f*fdd*r*s + 1946*D1**2*f*fdd*r - 807*D1**2*f*fdd*s**2 + 1366*D1**2*f*fdd*s - 828*D1**2*f*fdd - 3354*D1**2*fd**2*r**2 - 4968*D1**2*fd**2*r*s + 3892*D1**2*fd**2*r - 1614*D1**2*fd**2*s**2 + 2732*D1**2*fd**2*s - 828*D1**2*fd**2 + 3416*D1*Dd*f**2*r**2 + 5184*D1*Dd*f**2*r*s - 4300*D1*Dd*f**2*r + 1768*D1*Dd*f**2*s**2 - 3064*D1*Dd*f**2*s + 1738*D1*Dd*f**2 - 13416*D1*Dd*f*fd*r**2 - 19872*D1*Dd*f*fd*r*s + 16106*D1*Dd*f*fd*r - 6456*D1*Dd*f*fd*s**2 + 11176*D1*Dd*f*fd*s - 4678*D1*Dd*f*fd - 2236*D1*Ddd*f**2*r**2 - 3312*D1*Ddd*f**2*r*s + 2774*D1*Ddd*f**2*r - 1076*D1*Ddd*f**2*s**2 + 1904*D1*Ddd*f**2*s - 1097*D1*Ddd*f**2 - 6*D1*bd1*(D1*(f*(C*(377*r**2 + r*(606*s - 774) + 229*s**2 - 626*s + 387) - 337*r**2 + r*(694 - 556*s) - 219*s**2 + 576*s - 347) + fd*(-4*C*(213*r**2 + r*(366*s - 307) + 153*s**2 - 262*s + 94) + 842*r**2 + 4*r*(376*s - 307) + 662*s**2 - 1093*s + 386)) + Dd*f*(-2*C*(852*r**2 + r*(1464*s - 1451) + 612*s**2 - 1241*s + 594) + 1684*r**2 + r*(3008*s - 2897) + 1324*s**2 - 2582*s + 1203)) - 6708*Dd**2*f**2*r**2 - 9936*Dd**2*f**2*r*s + 8322*Dd**2*f**2*r - 3228*Dd**2*f**2*s**2 + 5712*Dd**2*f**2*s - 2194*Dd**2*f**2))/(210*d**2*k3**5) - D1**2*Pk1*Pkd3*ct**2*k2**4*st**2*(-11242*C*D1**2*bd1*f**2*r**2 - 15092*C*D1**2*bd1*f**2*r*s + 24024*C*D1**2*bd1*f**2*r - 3850*C*D1**2*bd1*f**2*s**2 + 16632*C*D1**2*bd1*f**2*s - 12012*C*D1**2*bd1*f**2 - 15444*C*D1**2*f**2*fd*r**2 - 21384*C*D1**2*f**2*fd*r*s + 17424*C*D1**2*f**2*fd*r - 5940*C*D1**2*f**2*fd*s**2 + 11088*C*D1**2*f**2*fd*s - 7128*C*D1**2*f**2*fd - 20592*C*D1*Dd*f**3*r**2 - 28512*C*D1*Dd*f**3*r*s + 24552*C*D1*Dd*f**3*r - 7920*C*D1*Dd*f**3*s**2 + 15048*C*D1*Dd*f**3*s - 9108*C*D1*Dd*f**3 - 15092*D1**2*K*bd1**2*f*r**2 - 24640*D1**2*K*bd1**2*f*r*s + 28182*D1**2*K*bd1**2*f*r - 9548*D1**2*K*bd1**2*f*s**2 + 22638*D1**2*K*bd1**2*f*s - 13090*D1**2*K*bd1**2*f + 6699*D1**2*K*bd1*f**2*r**2 + 9394*D1**2*K*bd1*f**2*r*s - 9394*D1**2*K*bd1*f**2*r + 2695*D1**2*K*bd1*f**2*s**2 - 5390*D1**2*K*bd1*f**2*s + 2695*D1**2*K*bd1*f**2 - 18172*D1**2*K*bd1*f*fd*r**2 - 25256*D1**2*K*bd1*f*fd*r*s + 21714*D1**2*K*bd1*f*fd*r - 7084*D1**2*K*bd1*f*fd*s**2 + 13398*D1**2*K*bd1*f*fd*s - 6314*D1**2*K*bd1*f*fd - 4543*D1**2*K*bdd1*f**2*r**2 - 6314*D1**2*K*bdd1*f**2*r*s + 6314*D1**2*K*bdd1*f**2*r - 1771*D1**2*K*bdd1*f**2*s**2 + 3542*D1**2*K*bdd1*f**2*s - 1771*D1**2*K*bdd1*f**2 + 18348*D1**2*bd1**2*f**2*r**2 + 38544*D1**2*bd1**2*f**2*r*s - 33660*D1**2*bd1**2*f**2*r + 20196*D1**2*bd1**2*f**2*s**2 - 35508*D1**2*bd1**2*f**2*s + 15312*D1**2*bd1**2*f**2 + 17864*D1**2*bd1**2*f*r**2 + 32032*D1**2*bd1**2*f*r*s - 34650*D1**2*bd1**2*f*r + 14168*D1**2*bd1**2*f*s**2 - 30954*D1**2*bd1**2*f*s + 16786*D1**2*bd1**2*f - 7700*D1**2*bd1**2*g2*r**2 - 15400*D1**2*bd1**2*g2*r*s + 7700*D1**2*bd1**2*g2*r - 7700*D1**2*bd1**2*g2*s**2 + 7700*D1**2*bd1**2*g2*s - 4620*D1**2*bd1*bd2*f*r**2 - 9240*D1**2*bd1*bd2*f*r*s + 9240*D1**2*bd1*bd2*f*r - 4620*D1**2*bd1*bd2*f*s**2 + 9240*D1**2*bd1*bd2*f*s - 4620*D1**2*bd1*bd2*f - 4708*D1**2*bd1*f**3*r**2 - 5676*D1**2*bd1*f**3*r*s + 3564*D1**2*bd1*f**3*r - 968*D1**2*bd1*f**3*s**2 - 176*D1**2*bd1*f**3*s - 1166*D1**2*bd1*f**3 + 16500*D1**2*bd1*f**2*fd*r**2 + 6336*D1**2*bd1*f**2*fd*r*s - 9988*D1**2*bd1*f**2*fd*r - 10164*D1**2*bd1*f**2*fd*s**2 + 12232*D1**2*bd1*f**2*fd*s - 5500*D1**2*bd1*f**2*fd + 3641*D1**2*bd1*f**2*r**2 + 3586*D1**2*bd1*f**2*r*s - 11594*D1**2*bd1*f**2*r - 55*D1**2*bd1*f**2*s**2 - 7898*D1**2*bd1*f**2*s + 7183*D1**2*bd1*f**2 + 18436*D1**2*bd1*f*fd*r**2 + 29480*D1**2*bd1*f*fd*r*s - 23958*D1**2*bd1*f*fd*r + 11044*D1**2*bd1*f*fd*s**2 - 18414*D1**2*bd1*f*fd*s + 7370*D1**2*bd1*f*fd - 24794*D1**2*bd1*f*g2*r**2 - 35420*D1**2*bd1*f*g2*r*s + 52668*D1**2*bd1*f*g2*r - 10626*D1**2*bd1*f*g2*s**2 + 38500*D1**2*bd1*f*g2*s - 26334*D1**2*bd1*f*g2 + 30184*D1**2*bd1*f*gd2*r**2 + 49280*D1**2*bd1*f*gd2*r*s - 56364*D1**2*bd1*f*gd2*r + 19096*D1**2*bd1*f*gd2*s**2 - 45276*D1**2*bd1*f*gd2*s + 26180*D1**2*bd1*f*gd2 + 30184*D1**2*bd1*fd*g2*r**2 + 49280*D1**2*bd1*fd*g2*r*s - 30184*D1**2*bd1*fd*g2*r + 19096*D1**2*bd1*fd*g2*s**2 - 24640*D1**2*bd1*fd*g2*s + 1980*D1**2*bd2*f**2*r**2 + 3960*D1**2*bd2*f**2*r*s - 3960*D1**2*bd2*f**2*r + 1980*D1**2*bd2*f**2*s**2 - 3960*D1**2*bd2*f**2*s + 1980*D1**2*bd2*f**2 - 3960*D1**2*bd2*f*fd*r**2 - 7920*D1**2*bd2*f*fd*r*s + 5940*D1**2*bd2*f*fd*r - 3960*D1**2*bd2*f*fd*s**2 + 5940*D1**2*bd2*f*fd*s - 1980*D1**2*bd2*f*fd + 2750*D1**2*bdd1*f**3*r**2 + 1056*D1**2*bdd1*f**3*r*s - 1188*D1**2*bdd1*f**3*r - 1694*D1**2*bdd1*f**3*s**2 + 3256*D1**2*bdd1*f**3*s + 88*D1**2*bdd1*f**3 + 4609*D1**2*bdd1*f**2*r**2 + 7370*D1**2*bdd1*f**2*r*s - 7370*D1**2*bdd1*f**2*r + 2761*D1**2*bdd1*f**2*s**2 - 5522*D1**2*bdd1*f**2*s + 2761*D1**2*bdd1*f**2 + 15092*D1**2*bdd1*f*g2*r**2 + 24640*D1**2*bdd1*f*g2*r*s - 31724*D1**2*bdd1*f*g2*r + 9548*D1**2*bdd1*f*g2*s**2 - 26180*D1**2*bdd1*f*g2*s + 15862*D1**2*bdd1*f*g2 - 990*D1**2*bdd2*f**2*r**2 - 1980*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*r - 990*D1**2*bdd2*f**2*s**2 + 1980*D1**2*bdd2*f**2*s - 990*D1**2*bdd2*f**2 + 11400*D1**2*f**3*fd*r**2 + 25040*D1**2*f**3*fd*r*s - 18220*D1**2*f**3*fd*r + 13640*D1**2*f**3*fd*s**2 - 19900*D1**2*f**3*fd*s + 9670*D1**2*f**3*fd - 11640*D1**2*f**3*fdd*r**2 - 27920*D1**2*f**3*fdd*r*s + 19780*D1**2*f**3*fdd*r - 16280*D1**2*f**3*fdd*s**2 + 23260*D1**2*f**3*fdd*s - 11050*D1**2*f**3*fdd - 34920*D1**2*f**2*fd**2*r**2 - 83760*D1**2*f**2*fd**2*r*s + 59340*D1**2*f**2*fd**2*r - 48840*D1**2*f**2*fd**2*s**2 + 69780*D1**2*f**2*fd**2*s - 22100*D1**2*f**2*fd**2 + 14256*D1**2*f**2*fd*r**2 + 20196*D1**2*f**2*fd*r*s - 16236*D1**2*f**2*fd*r + 5940*D1**2*f**2*fd*s**2 - 10692*D1**2*f**2*fd*s + 6732*D1**2*f**2*fd - 13398*D1**2*f**2*gd2*r**2 - 18788*D1**2*f**2*gd2*r*s + 18788*D1**2*f**2*gd2*r - 5390*D1**2*f**2*gd2*s**2 + 10780*D1**2*f**2*gd2*s - 5390*D1**2*f**2*gd2 + 9086*D1**2*f**2*gdd2*r**2 + 12628*D1**2*f**2*gdd2*r*s - 12628*D1**2*f**2*gdd2*r + 3542*D1**2*f**2*gdd2*s**2 - 7084*D1**2*f**2*gdd2*s + 3542*D1**2*f**2*gdd2 - 26796*D1**2*f*fd*g2*r**2 - 37576*D1**2*f*fd*g2*r*s + 26796*D1**2*f*fd*g2*r - 10780*D1**2*f*fd*g2*s**2 + 18788*D1**2*f*fd*g2*s - 13398*D1**2*f*fd*g2 + 36344*D1**2*f*fd*gd2*r**2 + 50512*D1**2*f*fd*gd2*r*s - 43428*D1**2*f*fd*gd2*r + 14168*D1**2*f*fd*gd2*s**2 - 26796*D1**2*f*fd*gd2*s + 12628*D1**2*f*fd*gd2 + 18172*D1**2*f*fdd*g2*r**2 + 25256*D1**2*f*fdd*g2*r*s - 18172*D1**2*f*fdd*g2*r + 7084*D1**2*f*fdd*g2*s**2 - 12628*D1**2*f*fdd*g2*s + 9086*D1**2*f*fdd*g2 + 18172*D1**2*fd**2*g2*r**2 + 25256*D1**2*fd**2*g2*r*s - 18172*D1**2*fd**2*g2*r + 7084*D1**2*fd**2*g2*s**2 - 12628*D1**2*fd**2*g2*s - 36344*D1*Dd*K*bd1*f**2*r**2 - 50512*D1*Dd*K*bd1*f**2*r*s + 46970*D1*Dd*K*bd1*f**2*r - 14168*D1*Dd*K*bd1*f**2*s**2 + 27566*D1*Dd*K*bd1*f**2*s - 13398*D1*Dd*K*bd1*f**2 + 22000*D1*Dd*bd1*f**3*r**2 + 8448*D1*Dd*bd1*f**3*r*s - 12364*D1*Dd*bd1*f**3*r - 13552*D1*Dd*bd1*f**3*s**2 + 18744*D1*Dd*bd1*f**3*s - 5324*D1*Dd*bd1*f**3 + 36872*D1*Dd*bd1*f**2*r**2 + 58960*D1*Dd*bd1*f**2*r*s - 53438*D1*Dd*bd1*f**2*r + 22088*D1*Dd*bd1*f**2*s**2 - 40502*D1*Dd*bd1*f**2*s + 18414*D1*Dd*bd1*f**2 + 120736*D1*Dd*bd1*f*g2*r**2 + 197120*D1*Dd*bd1*f*g2*r*s - 206360*D1*Dd*bd1*f*g2*r + 76384*D1*Dd*bd1*f*g2*s**2 - 167552*D1*Dd*bd1*f*g2*s + 84084*D1*Dd*bd1*f*g2 - 7920*D1*Dd*bd2*f**2*r**2 - 15840*D1*Dd*bd2*f**2*r*s + 13860*D1*Dd*bd2*f**2*r - 7920*D1*Dd*bd2*f**2*s**2 + 13860*D1*Dd*bd2*f**2*s - 5940*D1*Dd*bd2*f**2 + 11400*D1*Dd*f**4*r**2 + 25040*D1*Dd*f**4*r*s - 18220*D1*Dd*f**4*r + 13640*D1*Dd*f**4*s**2 - 19900*D1*Dd*f**4*s + 9670*D1*Dd*f**4 - 93120*D1*Dd*f**3*fd*r**2 - 223360*D1*Dd*f**3*fd*r*s + 158240*D1*Dd*f**3*fd*r - 130240*D1*Dd*f**3*fd*s**2 + 186080*D1*Dd*f**3*fd*s - 66300*D1*Dd*f**3*fd + 19008*D1*Dd*f**3*r**2 + 26928*D1*Dd*f**3*r*s - 22968*D1*Dd*f**3*r + 7920*D1*Dd*f**3*s**2 - 14652*D1*Dd*f**3*s + 8712*D1*Dd*f**3 - 53592*D1*Dd*f**2*g2*r**2 - 75152*D1*Dd*f**2*g2*r*s + 64372*D1*Dd*f**2*g2*r - 21560*D1*Dd*f**2*g2*s**2 + 40348*D1*Dd*f**2*g2*s - 24178*D1*Dd*f**2*g2 + 72688*D1*Dd*f**2*gd2*r**2 + 101024*D1*Dd*f**2*gd2*r*s - 93940*D1*Dd*f**2*gd2*r + 28336*D1*Dd*f**2*gd2*s**2 - 55132*D1*Dd*f**2*gd2*s + 26796*D1*Dd*f**2*gd2 + 145376*D1*Dd*f*fd*g2*r**2 + 202048*D1*Dd*f*fd*g2*r*s - 159544*D1*Dd*f*fd*g2*r + 56672*D1*Dd*f*fd*g2*s**2 - 104104*D1*Dd*f*fd*g2*s + 43428*D1*Dd*f*fd*g2 - 11640*D1*Ddd*f**4*r**2 - 27920*D1*Ddd*f**4*r*s + 19780*D1*Ddd*f**4*r - 16280*D1*Ddd*f**4*s**2 + 23260*D1*Ddd*f**4*s - 11050*D1*Ddd*f**4 + 36344*D1*Ddd*f**2*g2*r**2 + 50512*D1*Ddd*f**2*g2*r*s - 43428*D1*Ddd*f**2*g2*r + 14168*D1*Ddd*f**2*g2*s**2 - 26796*D1*Ddd*f**2*g2*s + 16170*D1*Ddd*f**2*g2 - 34920*Dd**2*f**4*r**2 - 83760*Dd**2*f**4*r*s + 59340*Dd**2*f**4*r - 48840*Dd**2*f**4*s**2 + 69780*Dd**2*f**4*s - 22100*Dd**2*f**4 + 109032*Dd**2*f**2*g2*r**2 + 151536*Dd**2*f**2*g2*r*s - 130284*Dd**2*f**2*g2*r + 42504*Dd**2*f**2*g2*s**2 - 80388*Dd**2*f**2*g2*s + 32340*Dd**2*f**2*g2 + 385*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (5*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-5*K + 6*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 6*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(350*C*D1**2*fd*r**2 + 700*C*D1**2*fd*r*s - 700*C*D1**2*fd*r + 350*C*D1**2*fd*s**2 - 700*C*D1**2*fd*s + 350*C*D1**2*fd + 1400*C*D1*Dd*f*r**2 + 2800*C*D1*Dd*f*r*s - 2100*C*D1*Dd*f*r + 1400*C*D1*Dd*f*s**2 - 2100*C*D1*Dd*f*s + 1050*C*D1*Dd*f + 1127*D1**2*K*fd*r**2 + 1610*D1**2*K*fd*r*s + 140*D1**2*K*fd*r + 483*D1**2*K*fd*s**2 + 140*D1**2*K*fd*s - 70*D1**2*K*fd - 686*D1**2*K*fdd*r**2 - 1120*D1**2*K*fdd*r*s - 70*D1**2*K*fdd*r - 434*D1**2*K*fdd*s**2 - 70*D1**2*K*fdd*s + 35*D1**2*K*fdd - 35*D1**2*bdd1*(-5*K + 6*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 1740*D1**2*f*fd*r**2 - 3648*D1**2*f*fd*r*s + 2124*D1**2*f*fd*r - 1908*D1**2*f*fd*s**2 + 2208*D1**2*f*fd*s - 1104*D1**2*f*fd + 1668*D1**2*f*fdd*r**2 + 3504*D1**2*f*fdd*r*s - 2112*D1**2*f*fdd*r + 1836*D1**2*f*fdd*s**2 - 2196*D1**2*f*fdd*s + 1098*D1**2*f*fdd + 1668*D1**2*fd**2*r**2 + 3504*D1**2*fd**2*r*s - 2112*D1**2*fd**2*r + 1836*D1**2*fd**2*s**2 - 2196*D1**2*fd**2*s + 360*D1**2*fd**2 - 1379*D1**2*fd*r**2 - 2282*D1**2*fd*r*s + 560*D1**2*fd*r - 903*D1**2*fd*s**2 + 560*D1**2*fd*s - 280*D1**2*fd + 812*D1**2*fdd*r**2 + 1456*D1**2*fdd*r*s + 70*D1**2*fdd*r + 644*D1**2*fdd*s**2 + 70*D1**2*fdd*s - 35*D1**2*fdd + 700*D1**2*gd2*r**2 + 1400*D1**2*gd2*r*s - 1400*D1**2*gd2*r + 700*D1**2*gd2*s**2 - 1400*D1**2*gd2*s + 700*D1**2*gd2 - 350*D1**2*gdd2*r**2 - 700*D1**2*gdd2*r*s + 700*D1**2*gdd2*r - 350*D1**2*gdd2*s**2 + 700*D1**2*gdd2*s - 350*D1**2*gdd2 + 4508*D1*Dd*K*f*r**2 + 6440*D1*Dd*K*f*r*s - 5474*D1*Dd*K*f*r + 1932*D1*Dd*K*f*s**2 - 3542*D1*Dd*K*f*s + 2093*D1*Dd*K*f - 5488*D1*Dd*K*fd*r**2 - 8960*D1*Dd*K*fd*r*s + 3332*D1*Dd*K*fd*r - 3472*D1*Dd*K*fd*s**2 + 2576*D1*Dd*K*fd*s + 210*D1*Dd*K*fd - 3480*D1*Dd*f**2*r**2 - 7296*D1*Dd*f**2*r*s + 5388*D1*Dd*f**2*r - 3816*D1*Dd*f**2*s**2 + 5640*D1*Dd*f**2*s - 2778*D1*Dd*f**2 + 13344*D1*Dd*f*fd*r**2 + 28032*D1*Dd*f*fd*r*s - 18792*D1*Dd*f*fd*r + 14688*D1*Dd*f*fd*s**2 - 19632*D1*Dd*f*fd*s + 6504*D1*Dd*f*fd - 5516*D1*Dd*f*r**2 - 9128*D1*Dd*f*r*s + 7322*D1*Dd*f*r - 3612*D1*Dd*f*s**2 + 5894*D1*Dd*f*s - 3185*D1*Dd*f + 6496*D1*Dd*fd*r**2 + 11648*D1*Dd*fd*r*s - 4256*D1*Dd*fd*r + 5152*D1*Dd*fd*s**2 - 3752*D1*Dd*fd*s - 210*D1*Dd*fd + 2800*D1*Dd*g2*r**2 + 5600*D1*Dd*g2*r*s - 4200*D1*Dd*g2*r + 2800*D1*Dd*g2*s**2 - 4200*D1*Dd*g2*s + 2100*D1*Dd*g2 - 2800*D1*Dd*gd2*r**2 - 5600*D1*Dd*gd2*r*s + 4900*D1*Dd*gd2*r - 2800*D1*Dd*gd2*s**2 + 4900*D1*Dd*gd2*s - 2100*D1*Dd*gd2 - 2744*D1*Ddd*K*f*r**2 - 4480*D1*Ddd*K*f*r*s + 3612*D1*Ddd*K*f*r - 1736*D1*Ddd*K*f*s**2 + 2856*D1*Ddd*K*f*s - 1554*D1*Ddd*K*f + 3336*D1*Ddd*f**2*r**2 + 7008*D1*Ddd*f**2*r*s - 5172*D1*Ddd*f**2*r + 3672*D1*Ddd*f**2*s**2 - 5424*D1*Ddd*f**2*s + 2670*D1*Ddd*f**2 + 3248*D1*Ddd*f*r**2 + 5824*D1*Ddd*f*r*s - 4536*D1*Ddd*f*r + 2576*D1*Ddd*f*s**2 - 4032*D1*Ddd*f*s + 2100*D1*Ddd*f - 1400*D1*Ddd*g2*r**2 - 2800*D1*Ddd*g2*r*s + 2100*D1*Ddd*g2*r - 1400*D1*Ddd*g2*s**2 + 2100*D1*Ddd*g2*s - 1050*D1*Ddd*g2 + 70*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (5*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-5*K + 6*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 8232*Dd**2*K*f*r**2 - 13440*Dd**2*K*f*r*s + 10836*Dd**2*K*f*r - 5208*Dd**2*K*f*s**2 + 8568*Dd**2*K*f*s - 3108*Dd**2*K*f + 10008*Dd**2*f**2*r**2 + 21024*Dd**2*f**2*r*s - 15516*Dd**2*f**2*r + 11016*Dd**2*f**2*s**2 - 16272*Dd**2*f**2*s + 5340*Dd**2*f**2 + 9744*Dd**2*f*r**2 + 17472*Dd**2*f*r*s - 13608*Dd**2*f*r + 7728*Dd**2*f*s**2 - 12096*Dd**2*f*s + 4200*Dd**2*f - 4200*Dd**2*g2*r**2 - 8400*Dd**2*g2*r*s + 6300*Dd**2*g2*r - 4200*Dd**2*g2*s**2 + 6300*Dd**2*g2*s - 2100*Dd**2*g2) - 11*b1*(2044*C*D1**2*f*fd*r**2 + 2744*C*D1**2*f*fd*r*s - 1232*C*D1**2*f*fd*r + 700*C*D1**2*f*fd*s**2 - 560*C*D1**2*f*fd*s + 280*C*D1**2*f*fd + 4088*C*D1*Dd*f**2*r**2 + 5488*C*D1*Dd*f**2*r*s - 4788*C*D1*Dd*f**2*r + 1400*C*D1*Dd*f**2*s**2 - 2772*C*D1*Dd*f**2*s + 1722*C*D1*Dd*f**2 + 1372*D1**2*K*bdd1*f*r**2 + 2240*D1**2*K*bdd1*f*r*s - 2562*D1**2*K*bdd1*f*r + 868*D1**2*K*bdd1*f*s**2 - 2058*D1**2*K*bdd1*f*s + 1155*D1**2*K*bdd1*f - 1218*D1**2*K*f*fd*r**2 - 1708*D1**2*K*f*fd*r*s + 1218*D1**2*K*f*fd*r - 490*D1**2*K*f*fd*s**2 + 854*D1**2*K*f*fd*s - 609*D1**2*K*f*fd + 826*D1**2*K*f*fdd*r**2 + 1148*D1**2*K*f*fdd*r*s - 826*D1**2*K*f*fdd*r + 322*D1**2*K*f*fdd*s**2 - 574*D1**2*K*f*fdd*s + 413*D1**2*K*f*fdd + 826*D1**2*K*fd**2*r**2 + 1148*D1**2*K*fd**2*r*s - 826*D1**2*K*fd**2*r + 322*D1**2*K*fd**2*s**2 - 574*D1**2*K*fd**2*s - 420*D1**2*b2*fd*r**2 - 840*D1**2*b2*fd*r*s - 420*D1**2*b2*fd*s**2 + 210*D1**2*b2*fdd*r**2 + 420*D1**2*b2*fdd*r*s + 210*D1**2*b2*fdd*s**2 + 70*D1**2*bd1**2*(-5*K + 6*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 1668*D1**2*bdd1*f**2*r**2 - 3504*D1**2*bdd1*f**2*r*s + 3060*D1**2*bdd1*f**2*r - 1836*D1**2*bdd1*f**2*s**2 + 3228*D1**2*bdd1*f**2*s - 1572*D1**2*bdd1*f**2 - 1624*D1**2*bdd1*f*r**2 - 2912*D1**2*bdd1*f*r*s + 3150*D1**2*bdd1*f*r - 1288*D1**2*bdd1*f*s**2 + 2814*D1**2*bdd1*f*s - 1491*D1**2*bdd1*f + 700*D1**2*bdd1*g2*r**2 + 1400*D1**2*bdd1*g2*r*s - 700*D1**2*bdd1*g2*r + 700*D1**2*bdd1*g2*s**2 - 700*D1**2*bdd1*g2*s + 350*D1**2*bdd1*g2 + 210*D1**2*bdd2*f*r**2 + 420*D1**2*bdd2*f*r*s - 420*D1**2*bdd2*f*r + 210*D1**2*bdd2*f*s**2 - 420*D1**2*bdd2*f*s + 210*D1**2*bdd2*f + 1284*D1**2*f**2*fd*r**2 + 1548*D1**2*f**2*fd*r*s - 1564*D1**2*f**2*fd*r + 264*D1**2*f**2*fd*s**2 - 884*D1**2*f**2*fd*s + 498*D1**2*f**2*fd - 750*D1**2*f**2*fdd*r**2 - 288*D1**2*f**2*fdd*r*s + 584*D1**2*f**2*fdd*r + 462*D1**2*f**2*fdd*s**2 - 224*D1**2*f**2*fdd*s + 66*D1**2*f**2*fdd - 1500*D1**2*f*fd**2*r**2 - 576*D1**2*f*fd**2*r*s + 1168*D1**2*f*fd**2*r + 924*D1**2*f*fd**2*s**2 - 448*D1**2*f*fd**2*s - 384*D1**2*f*fd**2 - 662*D1**2*f*fd*r**2 - 652*D1**2*f*fd*r*s - 66*D1**2*f*fd*r + 10*D1**2*f*fd*s**2 - 402*D1**2*f*fd*s + 327*D1**2*f*fd - 838*D1**2*f*fdd*r**2 - 1340*D1**2*f*fdd*r*s + 838*D1**2*f*fdd*r - 502*D1**2*f*fdd*s**2 + 670*D1**2*f*fdd*s - 419*D1**2*f*fdd + 2254*D1**2*f*gd2*r**2 + 3220*D1**2*f*gd2*r*s - 3220*D1**2*f*gd2*r + 966*D1**2*f*gd2*s**2 - 1932*D1**2*f*gd2*s + 966*D1**2*f*gd2 - 1372*D1**2*f*gdd2*r**2 - 2240*D1**2*f*gdd2*r*s + 2240*D1**2*f*gdd2*r - 868*D1**2*f*gdd2*s**2 + 1736*D1**2*f*gdd2*s - 868*D1**2*f*gdd2 - 838*D1**2*fd**2*r**2 - 1340*D1**2*fd**2*r*s + 838*D1**2*fd**2*r - 502*D1**2*fd**2*s**2 + 670*D1**2*fd**2*s + 2254*D1**2*fd*g2*r**2 + 3220*D1**2*fd*g2*r*s + 280*D1**2*fd*g2*r + 966*D1**2*fd*g2*s**2 + 280*D1**2*fd*g2*s - 140*D1**2*fd*g2 - 2744*D1**2*fd*gd2*r**2 - 4480*D1**2*fd*gd2*r*s + 2100*D1**2*fd*gd2*r - 1736*D1**2*fd*gd2*s**2 + 1596*D1**2*fd*gd2*s + 140*D1**2*fd*gd2 - 1372*D1**2*fdd*g2*r**2 - 2240*D1**2*fdd*g2*r*s - 140*D1**2*fdd*g2*r - 868*D1**2*fdd*g2*s**2 - 140*D1**2*fdd*g2*s + 70*D1**2*fdd*g2 - 2436*D1*Dd*K*f**2*r**2 - 3416*D1*Dd*K*f**2*r*s + 2926*D1*Dd*K*f**2*r - 980*D1*Dd*K*f**2*s**2 + 1834*D1*Dd*K*f**2*s - 1099*D1*Dd*K*f**2 + 6608*D1*Dd*K*f*fd*r**2 + 9184*D1*Dd*K*f*fd*r*s - 7252*D1*Dd*K*f*fd*r + 2576*D1*Dd*K*f*fd*s**2 - 4732*D1*Dd*K*f*fd*s + 1974*D1*Dd*K*f*fd - 1680*D1*Dd*b2*f*r**2 - 3360*D1*Dd*b2*f*r*s + 2520*D1*Dd*b2*f*r - 1680*D1*Dd*b2*f*s**2 + 2520*D1*Dd*b2*f*s - 1260*D1*Dd*b2*f + 1680*D1*Dd*b2*fd*r**2 + 3360*D1*Dd*b2*fd*r*s - 1260*D1*Dd*b2*fd*r + 1680*D1*Dd*b2*fd*s**2 - 1260*D1*Dd*b2*fd*s + 1712*D1*Dd*f**3*r**2 + 2064*D1*Dd*f**3*r*s - 1888*D1*Dd*f**3*r + 352*D1*Dd*f**3*s**2 - 868*D1*Dd*f**3*s + 604*D1*Dd*f**3 - 6000*D1*Dd*f**2*fd*r**2 - 2304*D1*Dd*f**2*fd*r*s + 4412*D1*Dd*f**2*fd*r + 3696*D1*Dd*f**2*fd*s**2 - 2456*D1*Dd*f**2*fd*s - 136*D1*Dd*f**2*fd - 1324*D1*Dd*f**2*r**2 - 1304*D1*Dd*f**2*r*s + 1314*D1*Dd*f**2*r + 20*D1*Dd*f**2*s**2 + 306*D1*Dd*f**2*s - 321*D1*Dd*f**2 - 6704*D1*Dd*f*fd*r**2 - 10720*D1*Dd*f*fd*r*s + 7708*D1*Dd*f*fd*r - 4016*D1*Dd*f*fd*s**2 + 6028*D1*Dd*f*fd*s - 2178*D1*Dd*f*fd + 9016*D1*Dd*f*g2*r**2 + 12880*D1*Dd*f*g2*r*s - 10948*D1*Dd*f*g2*r + 3864*D1*Dd*f*g2*s**2 - 7084*D1*Dd*f*g2*s + 4186*D1*Dd*f*g2 - 10976*D1*Dd*f*gd2*r**2 - 17920*D1*Dd*f*gd2*r*s + 16184*D1*Dd*f*gd2*r - 6944*D1*Dd*f*gd2*s**2 + 12656*D1*Dd*f*gd2*s - 5712*D1*Dd*f*gd2 - 10976*D1*Dd*fd*g2*r**2 - 17920*D1*Dd*fd*g2*r*s + 6664*D1*Dd*fd*g2*r - 6944*D1*Dd*fd*g2*s**2 + 5152*D1*Dd*fd*g2*s + 420*D1*Dd*fd*g2 + 1652*D1*Ddd*K*f**2*r**2 + 2296*D1*Ddd*K*f**2*r*s - 1974*D1*Ddd*K*f**2*r + 644*D1*Ddd*K*f**2*s**2 - 1218*D1*Ddd*K*f**2*s + 735*D1*Ddd*K*f**2 + 840*D1*Ddd*b2*f*r**2 + 1680*D1*Ddd*b2*f*r*s - 1260*D1*Ddd*b2*f*r + 840*D1*Ddd*b2*f*s**2 - 1260*D1*Ddd*b2*f*s + 630*D1*Ddd*b2*f - 1000*D1*Ddd*f**3*r**2 - 384*D1*Ddd*f**3*r*s + 692*D1*Ddd*f**3*r + 616*D1*Ddd*f**3*s**2 - 520*D1*Ddd*f**3*s + 58*D1*Ddd*f**3 - 1676*D1*Ddd*f**2*r**2 - 2680*D1*Ddd*f**2*r*s + 2178*D1*Ddd*f**2*r - 1004*D1*Ddd*f**2*s**2 + 1674*D1*Ddd*f**2*s - 921*D1*Ddd*f**2 - 5488*D1*Ddd*f*g2*r**2 - 8960*D1*Ddd*f*g2*r*s + 7224*D1*Ddd*f*g2*r - 3472*D1*Ddd*f*g2*s**2 + 5712*D1*Ddd*f*g2*s - 3108*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(3*f**2*(290*r**2 + 32*r*(19*s - 17) + 318*s**2 - 572*s + 279) - f*(175*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(161*r**2 + 230*r*s - 286*r + 69*s**2 - 194*s + 120) + 6*fd*(556*r**2 + 2*r*(584*s - 431) + 612*s**2 - 904*s + 299) - 1379*r**2 - 2282*r*s + 2240*r - 903*s**2 + 1764*s - 1001) + 7*fd*(K*(196*r**2 + 320*r*s - 173*r + 124*s**2 - 137*s - 5) - 232*r**2 - 416*r*s + 215*r - 184*s**2 + 191*s + 5) - 350*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 350*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + Dd*(-6*f**2*(1112*r**2 + 2*r*(1168*s - 941) + 1224*s**2 - 1980*s + 793) + 7*f*(K*(784*r**2 + 32*r*(40*s - 39) + 496*s**2 - 996*s + 477) - 928*r**2 - 1664*r*s + 1548*r - 736*s**2 + 1380*s - 627) + 350*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 420*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 4956*Dd**2*K*f**2*r**2 + 6888*Dd**2*K*f**2*r*s - 5922*Dd**2*K*f**2*r + 1932*Dd**2*K*f**2*s**2 - 3654*Dd**2*K*f**2*s + 1470*Dd**2*K*f**2 + 2520*Dd**2*b2*f*r**2 + 5040*Dd**2*b2*f*r*s - 3780*Dd**2*b2*f*r + 2520*Dd**2*b2*f*s**2 - 3780*Dd**2*b2*f*s + 1260*Dd**2*b2*f - 3000*Dd**2*f**3*r**2 - 1152*Dd**2*f**3*r*s + 2076*Dd**2*f**3*r + 1848*Dd**2*f**3*s**2 - 1560*Dd**2*f**3*s + 116*Dd**2*f**3 - 5028*Dd**2*f**2*r**2 - 8040*Dd**2*f**2*r*s + 6534*Dd**2*f**2*r - 3012*Dd**2*f**2*s**2 + 5022*Dd**2*f**2*s - 1842*Dd**2*f**2 - 16464*Dd**2*f*g2*r**2 - 26880*Dd**2*f*g2*r*s + 21672*Dd**2*f*g2*r - 10416*Dd**2*f*g2*s**2 + 17136*Dd**2*f*g2*s - 6216*Dd**2*f*g2) + 330*b2*(-7*D1**2*bdd1*f*(r + s - 1)**2 + 3*D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 3*D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(2310*d**2*k3**5) + 2*D1**2*Pk1*Pkd3*ct**2*k2**2*st**4*(14*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(fd*(-4*C*(28*r*s - 14*r + 28*s**2 - 27*s + 14) + 98*r*s - 49*r + 98*s**2 - 94*s + 49) + (2*C - 2)*(-7*bdd1*s*(2*r + 2*s - 1) + fdd*(28*r*s - 14*r + 28*s**2 - 27*s + 14))) + fd**2*(2*C - 2)*(14*r*(2*s - 1) + 28*s**2 - 27*s - 1)) - 14*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(-f*(56*C - 49)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(8*C - 8)*(2*s - 1)*(28*r + 28*s - 17)) + Ddd*f*(28*C - 28)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(28*C - 28)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-14*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1**2*(f*(-fd*(20*C - 19)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + (2*C - 2)*(bdd1*s*(14*r + 14*s - 15) + 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(10*C - 10)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(C*(-56*r - 56*s + 60) + 49*r + 49*s - 53) + fd*(2*C - 2)*(14*r*(4*s - 1) + 56*s**2 - 57*s + 15)) + Dd*f*(4*C - 4)*(14*r*(4*s - 1) + 56*s**2 - 65*s + 15)) + D1*f*(Dd*(-f*(20*C - 19)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(10*C - 10)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(10*C - 10)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(10*C - 10)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**2*k2**2*st**2*(-7*b1**2*(D1**2*(fd*(71*C*r + 51*C*(s - 1) - 54*r - 46*s + 46) + fdd*(-43*C*(r + s - 1) + 37*r + 43*s - 43))*(r + s - 1) + D1*(Dd*(f*(C*(284*r**2 + 488*r*s - 386*r + 204*s**2 - 326*s + 173) - 216*r**2 - 400*r*s + 308*r - 184*s**2 + 284*s - 146) + 2*fd*(-43*C*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 148*r**2 + 320*r*s - 277*r + 172*s**2 - 298*s + 126)) + Ddd*f*(-43*C*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 148*r**2 + 320*r*s - 234*r + 172*s**2 - 252*s + 123)) - 6*Dd**2*f*(43*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 74*r**2 + r*(117 - 160*s) - 86*s**2 + 126*s - 41)) + b1*(-414*C*D1**2*f*fd*r**2 + 252*C*D1**2*f*fd*r*s + 540*C*D1**2*f*fd*r + 666*C*D1**2*f*fd*s**2 - 204*C*D1**2*f*fd*s + 46*C*D1**2*f*fdd*r**2 - 532*C*D1**2*f*fdd*r*s - 200*C*D1**2*f*fdd*r - 578*C*D1**2*f*fdd*s**2 + 256*C*D1**2*f*fdd*s - 56*C*D1**2*f*fdd + 46*C*D1**2*fd**2*r**2 - 532*C*D1**2*fd**2*r*s - 200*C*D1**2*fd**2*r - 578*C*D1**2*fd**2*s**2 + 256*C*D1**2*fd**2*s + 322*C*D1**2*fd**2 - 828*C*D1*Dd*f**2*r**2 + 504*C*D1*Dd*f**2*r*s + 162*C*D1*Dd*f**2*r + 1332*C*D1*Dd*f**2*s**2 - 1458*C*D1*Dd*f**2*s + 459*C*D1*Dd*f**2 + 368*C*D1*Dd*f*fd*r**2 - 4256*C*D1*Dd*f*fd*r*s + 172*C*D1*Dd*f*fd*r - 4624*C*D1*Dd*f*fd*s**2 + 3868*C*D1*Dd*f*fd*s - 312*C*D1*Dd*f*fd + 92*C*D1*Ddd*f**2*r**2 - 1064*C*D1*Ddd*f**2*r*s + 486*C*D1*Ddd*f**2*r - 1156*C*D1*Ddd*f**2*s**2 + 1422*C*D1*Ddd*f**2*s - 555*C*D1*Ddd*f**2 + 276*C*Dd**2*f**2*r**2 - 3192*C*Dd**2*f**2*r*s + 1458*C*Dd**2*f**2*r - 3468*C*Dd**2*f**2*s**2 + 4266*C*Dd**2*f**2*s - 1110*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(43*C*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 74*r**2 - 160*r*s + 74*r - 86*s**2 + 80*s - 37) + 176*D1**2*f*fd*r**2 - 636*D1**2*f*fd*r*s - 222*D1**2*f*fd*r - 812*D1**2*f*fd*s**2 + 420*D1**2*f*fd*s - 136*D1**2*f*fd + 38*D1**2*f*fdd*r**2 + 808*D1**2*f*fdd*r*s - 22*D1**2*f*fdd*r + 770*D1**2*f*fdd*s**2 - 490*D1**2*f*fdd*s + 194*D1**2*f*fdd + 38*D1**2*fd**2*r**2 + 808*D1**2*fd**2*r*s - 22*D1**2*fd**2*r + 770*D1**2*fd**2*s**2 - 490*D1**2*fd**2*s - 280*D1**2*fd**2 + 352*D1*Dd*f**2*r**2 - 1272*D1*Dd*f**2*r*s + 460*D1*Dd*f**2*r - 1624*D1*Dd*f**2*s**2 + 1942*D1*Dd*f**2*s - 724*D1*Dd*f**2 + 304*D1*Dd*f*fd*r**2 + 6464*D1*Dd*f*fd*r*s - 1780*D1*Dd*f*fd*r + 6160*D1*Dd*f*fd*s**2 - 5848*D1*Dd*f*fd*s + 1002*D1*Dd*f*fd + 76*D1*Ddd*f**2*r**2 + 1616*D1*Ddd*f**2*r*s - 846*D1*Ddd*f**2*r + 1540*D1*Ddd*f**2*s**2 - 1944*D1*Ddd*f**2*s + 789*D1*Ddd*f**2 - 7*D1*bd1*(D1*(f*(C*(142*r**2 + 244*r*s - 142*r + 102*s**2 - 122*s + 71) - 108*r**2 - 200*r*s + 108*r - 92*s**2 + 100*s - 54) - 2*fd*(43*C*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 74*r**2 - 160*r*s + 117*r - 86*s**2 + 126*s - 40)) + 2*Dd*f*(-43*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 296*r**2 + 640*r*s - 382*r + 344*s**2 - 412*s + 117)) + 228*Dd**2*f**2*r**2 + 4848*Dd**2*f**2*r*s - 2538*Dd**2*f**2*r + 4620*Dd**2*f**2*s**2 - 5832*Dd**2*f**2*s + 1578*Dd**2*f**2) + f*(14*D1**2*bd1**2*(r**2*(43*C - 37) + r*(43*C*(2*s - 1) - 80*s + 37) + s*(43*C*(s - 1) - 43*s + 40)) + D1**2*bdd1*f*(C*(23*r**2 + r*(420 - 266*s) - 289*s**2 + 588*s - 210) + 19*r**2 + r*(404*s - 420) + 385*s**2 - 684*s + 210) + 6*D1**2*(f*(fd*(C*(87*r**2 + 6*r*(31*s - 20) + 99*s**2 - 128*s + 62) - 87*r**2 + r*(127 - 207*s) - 120*s**2 + 149*s - 69) + fdd*(-C*(93*r**2 + 6*r*(29*s - 20) + 81*s**2 - 112*s + 58) + 81*r**2 + 2*r*(93*s - 58) + 105*s**2 - 132*s + 62)) + 2*fd**2*(-C*(93*r**2 + 6*r*(29*s - 20) + 81*s**2 - 112*s + 29) + 81*r**2 + 2*r*(93*s - 58) + 105*s**2 - 132*s + 31)) + D1*bd1*(D1*(f*(-3*C*(69*r**2 - 42*r*(s - 2) - 111*s**2 + 196*s - 42) + 88*r**2 - 318*r*s + 364*r - 406*s**2 + 710*s - 182) + 2*fd*(C*(46*r**2 - 532*r*s + 320*r - 578*s**2 + 716*s - 294) + 38*r**2 + 808*r*s - 431*r + 770*s**2 - 929*s + 342)) + 2*Dd*f*(C*(92*r**2 - 19*r*(56*s - 57) - 1156*s**2 + 1887*s - 798) + 76*r**2 + 1616*r*s - 1263*r + 1540*s**2 - 2340*s + 894)) + 6*D1*f*(Dd*(f*(C*(116*r**2 + 248*r*s - 182*r + 132*s**2 - 194*s + 95) - 116*r**2 - 276*r*s + 196*r - 160*s**2 + 229*s - 109) - 2*fd*(C*(372*r**2 + 696*r*s - 507*r + 324*s**2 - 473*s + 172) - 324*r**2 - 744*r*s + 499*r - 420*s**2 + 567*s - 190)) + Ddd*f*(-C*(124*r**2 + 232*r*s - 178*r + 108*s**2 - 166*s + 85) + 108*r**2 + 248*r*s - 178*r + 140*s**2 - 202*s + 97)) + 12*Dd**2*f**2*(-C*(186*r**2 + 3*r*(116*s - 89) + 162*s**2 - 249*s + 85) + 162*r**2 + 3*r*(124*s - 89) + 210*s**2 - 303*s + 97)))/(105*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**2*k2**2*(630*C*D1**2*bd1*f**2*r**2 + 756*C*D1**2*bd1*f**2*r*s + 126*C*D1**2*bd1*f**2*s**2 + 798*D1**2*K*bd1**2*f*r**2 + 588*D1**2*K*bd1**2*f*r*s + 756*D1**2*K*bd1**2*f*r - 210*D1**2*K*bd1**2*f*s**2 + 1260*D1**2*K*bd1**2*f*s - 1050*D1**2*K*bd1**2*f + 621*D1**2*K*bd1*f**2*r**2 + 810*D1**2*K*bd1*f**2*r*s - 810*D1**2*K*bd1*f**2*r + 189*D1**2*K*bd1*f**2*s**2 - 378*D1**2*K*bd1*f**2*s + 189*D1**2*K*bd1*f**2 - 2124*D1**2*K*bd1*f*fd*r**2 - 3384*D1**2*K*bd1*f*fd*r*s + 2754*D1**2*K*bd1*f*fd*r - 1260*D1**2*K*bd1*f*fd*s**2 + 2106*D1**2*K*bd1*f*fd*s - 846*D1**2*K*bd1*f*fd - 531*D1**2*K*bdd1*f**2*r**2 - 846*D1**2*K*bdd1*f**2*r*s + 846*D1**2*K*bdd1*f**2*r - 315*D1**2*K*bdd1*f**2*s**2 + 630*D1**2*K*bdd1*f**2*s - 315*D1**2*K*bdd1*f**2 + 360*D1**2*bd1**2*f**2*r**2 + 2952*D1**2*bd1**2*f**2*r*s - 1854*D1**2*bd1**2*f**2*r + 2592*D1**2*bd1**2*f**2*s**2 - 3510*D1**2*bd1**2*f**2*s + 1476*D1**2*bd1**2*f**2 - 42*D1**2*bd1**2*f*r**2 + 1848*D1**2*bd1**2*f*r*s - 2268*D1**2*bd1**2*f*r + 1890*D1**2*bd1**2*f*s**2 - 3990*D1**2*bd1**2*f*s + 2100*D1**2*bd1**2*f - 3360*D1**2*bd1**2*g2*r**2 - 6720*D1**2*bd1**2*g2*r*s + 3360*D1**2*bd1**2*g2*r - 3360*D1**2*bd1**2*g2*s**2 + 3360*D1**2*bd1**2*g2*s - 924*D1**2*bd1*bd2*f*r**2 - 1848*D1**2*bd1*bd2*f*r*s + 1974*D1**2*bd1*bd2*f*r - 924*D1**2*bd1*bd2*f*s**2 + 1974*D1**2*bd1*bd2*f*s - 1050*D1**2*bd1*bd2*f - 595*D1**2*bd1*f**3*r**2 - 1540*D1**2*bd1*f**3*r*s + 1020*D1**2*bd1*f**3*r - 945*D1**2*bd1*f**3*s**2 + 1080*D1**2*bd1*f**3*s - 540*D1**2*bd1*f**3 + 3270*D1**2*bd1*f**2*fd*r**2 + 10560*D1**2*bd1*f**2*fd*r*s - 6890*D1**2*bd1*f**2*fd*r + 7290*D1**2*bd1*f**2*fd*s**2 - 9500*D1**2*bd1*f**2*fd*s + 2580*D1**2*bd1*f**2*fd - 1089*D1**2*bd1*f**2*r**2 - 1692*D1**2*bd1*f**2*r*s + 1062*D1**2*bd1*f**2*r - 603*D1**2*bd1*f**2*s**2 + 954*D1**2*bd1*f**2*s - 414*D1**2*bd1*f**2 + 2304*D1**2*bd1*f*fd*r**2 + 5904*D1**2*bd1*f*fd*r*s - 4104*D1**2*bd1*f*fd*r + 3600*D1**2*bd1*f*fd*s**2 - 5076*D1**2*bd1*f*fd*s + 1476*D1**2*bd1*f*fd + 2436*D1**2*bd1*f*g2*r**2 + 2016*D1**2*bd1*f*g2*r*s + 1260*D1**2*bd1*f*g2*r - 420*D1**2*bd1*f*g2*s**2 + 1260*D1**2*bd1*f*g2*s - 630*D1**2*bd1*f*g2 - 1596*D1**2*bd1*f*gd2*r**2 - 1176*D1**2*bd1*f*gd2*r*s - 1512*D1**2*bd1*f*gd2*r + 420*D1**2*bd1*f*gd2*s**2 - 2520*D1**2*bd1*f*gd2*s + 2100*D1**2*bd1*f*gd2 - 1596*D1**2*bd1*fd*g2*r**2 - 1176*D1**2*bd1*fd*g2*r*s + 1596*D1**2*bd1*fd*g2*r + 420*D1**2*bd1*fd*g2*s**2 + 588*D1**2*bd1*fd*g2*s + 621*D1**2*bd2*f**2*r**2 + 810*D1**2*bd2*f**2*r*s - 810*D1**2*bd2*f**2*r + 189*D1**2*bd2*f**2*s**2 - 378*D1**2*bd2*f**2*s + 189*D1**2*bd2*f**2 - 2124*D1**2*bd2*f*fd*r**2 - 3384*D1**2*bd2*f*fd*r*s + 2754*D1**2*bd2*f*fd*r - 1260*D1**2*bd2*f*fd*s**2 + 2106*D1**2*bd2*f*fd*s - 846*D1**2*bd2*f*fd + 545*D1**2*bdd1*f**3*r**2 + 1760*D1**2*bdd1*f**3*r*s - 1140*D1**2*bdd1*f**3*r + 1215*D1**2*bdd1*f**3*s**2 - 1440*D1**2*bdd1*f**3*s + 720*D1**2*bdd1*f**3 + 576*D1**2*bdd1*f**2*r**2 + 1476*D1**2*bdd1*f**2*r*s - 1476*D1**2*bdd1*f**2*r + 900*D1**2*bdd1*f**2*s**2 - 1800*D1**2*bdd1*f**2*s + 900*D1**2*bdd1*f**2 - 798*D1**2*bdd1*f*g2*r**2 - 588*D1**2*bdd1*f*g2*r*s - 2100*D1**2*bdd1*f*g2*r + 210*D1**2*bdd1*f*g2*s**2 - 2100*D1**2*bdd1*f*g2*s + 1050*D1**2*bdd1*f*g2 - 531*D1**2*bdd2*f**2*r**2 - 846*D1**2*bdd2*f**2*r*s + 846*D1**2*bdd2*f**2*r - 315*D1**2*bdd2*f**2*s**2 + 630*D1**2*bdd2*f**2*s - 315*D1**2*bdd2*f**2 + 270*D1**2*f**2*fd*r**2 + 270*D1**2*f**2*fd*r*s - 270*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 1242*D1**2*f**2*gd2*r**2 - 1620*D1**2*f**2*gd2*r*s + 1620*D1**2*f**2*gd2*r - 378*D1**2*f**2*gd2*s**2 + 756*D1**2*f**2*gd2*s - 378*D1**2*f**2*gd2 + 1062*D1**2*f**2*gdd2*r**2 + 1692*D1**2*f**2*gdd2*r*s - 1692*D1**2*f**2*gdd2*r + 630*D1**2*f**2*gdd2*s**2 - 1260*D1**2*f**2*gdd2*s + 630*D1**2*f**2*gdd2 - 2484*D1**2*f*fd*g2*r**2 - 3240*D1**2*f*fd*g2*r*s + 2484*D1**2*f*fd*g2*r - 756*D1**2*f*fd*g2*s**2 + 1620*D1**2*f*fd*g2*s - 1242*D1**2*f*fd*g2 + 4248*D1**2*f*fd*gd2*r**2 + 6768*D1**2*f*fd*gd2*r*s - 5508*D1**2*f*fd*gd2*r + 2520*D1**2*f*fd*gd2*s**2 - 4212*D1**2*f*fd*gd2*s + 1692*D1**2*f*fd*gd2 + 2124*D1**2*f*fdd*g2*r**2 + 3384*D1**2*f*fdd*g2*r*s - 2124*D1**2*f*fdd*g2*r + 1260*D1**2*f*fdd*g2*s**2 - 1692*D1**2*f*fdd*g2*s + 1062*D1**2*f*fdd*g2 + 2124*D1**2*fd**2*g2*r**2 + 3384*D1**2*fd**2*g2*r*s - 2124*D1**2*fd**2*g2*r + 1260*D1**2*fd**2*g2*s**2 - 1692*D1**2*fd**2*g2*s - 4248*D1*Dd*K*bd1*f**2*r**2 - 6768*D1*Dd*K*bd1*f**2*r*s + 6138*D1*Dd*K*bd1*f**2*r - 2520*D1*Dd*K*bd1*f**2*s**2 + 4626*D1*Dd*K*bd1*f**2*s - 2106*D1*Dd*K*bd1*f**2 + 4360*D1*Dd*bd1*f**3*r**2 + 14080*D1*Dd*bd1*f**3*r*s - 9170*D1*Dd*bd1*f**3*r + 9720*D1*Dd*bd1*f**3*s**2 - 12380*D1*Dd*bd1*f**3*s + 4020*D1*Dd*bd1*f**3 + 4608*D1*Dd*bd1*f**2*r**2 + 11808*D1*Dd*bd1*f**2*r*s - 10008*D1*Dd*bd1*f**2*r + 7200*D1*Dd*bd1*f**2*s**2 - 12276*D1*Dd*bd1*f**2*s + 5076*D1*Dd*bd1*f**2 - 6384*D1*Dd*bd1*f*g2*r**2 - 4704*D1*Dd*bd1*f*g2*r*s - 5628*D1*Dd*bd1*f*g2*r + 1680*D1*Dd*bd1*f*g2*s**2 - 8652*D1*Dd*bd1*f*g2*s + 6300*D1*Dd*bd1*f*g2 - 4248*D1*Dd*bd2*f**2*r**2 - 6768*D1*Dd*bd2*f**2*r*s + 6138*D1*Dd*bd2*f**2*r - 2520*D1*Dd*bd2*f**2*s**2 + 4626*D1*Dd*bd2*f**2*s - 2106*D1*Dd*bd2*f**2 + 360*D1*Dd*f**3*r**2 + 360*D1*Dd*f**3*r*s - 360*D1*Dd*f**3*r - 90*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 4968*D1*Dd*f**2*g2*r**2 - 6480*D1*Dd*f**2*g2*r*s + 5724*D1*Dd*f**2*g2*r - 1512*D1*Dd*f**2*g2*s**2 + 3132*D1*Dd*f**2*g2*s - 1998*D1*Dd*f**2*g2 + 8496*D1*Dd*f**2*gd2*r**2 + 13536*D1*Dd*f**2*gd2*r*s - 12276*D1*Dd*f**2*gd2*r + 5040*D1*Dd*f**2*gd2*s**2 - 9252*D1*Dd*f**2*gd2*s + 4212*D1*Dd*f**2*gd2 + 16992*D1*Dd*f*fd*g2*r**2 + 27072*D1*Dd*f*fd*g2*r*s - 19512*D1*Dd*f*fd*g2*r + 10080*D1*Dd*f*fd*g2*s**2 - 15192*D1*Dd*f*fd*g2*s + 5508*D1*Dd*f*fd*g2 + 4248*D1*Ddd*f**2*g2*r**2 + 6768*D1*Ddd*f**2*g2*r*s - 5508*D1*Ddd*f**2*g2*r + 2520*D1*Ddd*f**2*g2*s**2 - 4212*D1*Ddd*f**2*g2*s + 2322*D1*Ddd*f**2*g2 + 12744*Dd**2*f**2*g2*r**2 + 20304*Dd**2*f**2*g2*r*s - 16524*Dd**2*f**2*g2*r + 7560*Dd**2*f**2*g2*s**2 - 12636*Dd**2*f**2*g2*s + 4644*Dd**2*f**2*g2 + 21*b1**3*(D1**2*(r + s - 1)*(7*fd*r + 17*fd*(s - 1) + fdd*(-21*r - 31*s + 31)) + D1*(Dd*(-5*K*(28*r**2 + 8*r*s - 18*r - 20*s**2 + 18*s - 3) + f*(28*r**2 + r*(96*s - 62) + 68*s**2 - 92*s + 41) - 2*fd*(84*r**2 + 208*r*s - 177*r + 124*s**2 - 212*s + 88) - 20*r**2 - 200*r*s + 110*r - 180*s**2 + 230*s - 95) - Ddd*f*(84*r**2 + 2*r*(104*s - 73) + 124*s**2 - 176*s + 83) + 5*Ddd*(8*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 28*r**2 + r*(46 - 64*s) - 36*s**2 + 52*s - 25)) - 2*Dd**2*(-120*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(126*r**2 + 3*r*(104*s - 73) + 186*s**2 - 264*s + 83) + 210*r**2 + 480*r*s - 345*r + 270*s**2 - 390*s + 125)) + 3*b1**2*(350*C*D1**2*fd*r**2 + 420*C*D1**2*fd*r*s - 420*C*D1**2*fd*r + 70*C*D1**2*fd*s**2 - 140*C*D1**2*fd*s + 70*C*D1**2*fd + 1400*C*D1*Dd*f*r**2 + 1680*C*D1*Dd*f*r*s - 1540*C*D1*Dd*f*r + 280*C*D1*Dd*f*s**2 - 700*C*D1*Dd*f*s + 490*C*D1*Dd*f + 840*D1**2*K*bdd1*r**2 + 1680*D1**2*K*bdd1*r*s - 1120*D1**2*K*bdd1*r + 840*D1**2*K*bdd1*s**2 - 1120*D1**2*K*bdd1*s + 560*D1**2*K*bdd1 - 406*D1**2*K*fd*r**2 - 336*D1**2*K*fd*r*s + 1022*D1**2*K*fd*r + 70*D1**2*K*fd*s**2 + 546*D1**2*K*fd*s - 511*D1**2*K*fd + 133*D1**2*K*fdd*r**2 + 98*D1**2*K*fdd*r*s - 616*D1**2*K*fdd*r - 35*D1**2*K*fdd*s**2 - 448*D1**2*K*fdd*s + 308*D1**2*K*fdd - 441*D1**2*bdd1*f*r**2 - 1092*D1**2*bdd1*f*r*s + 658*D1**2*bdd1*f*r - 651*D1**2*bdd1*f*s**2 + 798*D1**2*bdd1*f*s - 364*D1**2*bdd1*f - 735*D1**2*bdd1*r**2 - 1680*D1**2*bdd1*r*s + 1050*D1**2*bdd1*r - 945*D1**2*bdd1*s**2 + 1190*D1**2*bdd1*s - 560*D1**2*bdd1 + 35*D1**2*bdd2*r**2 + 70*D1**2*bdd2*r*s - 70*D1**2*bdd2*r + 35*D1**2*bdd2*s**2 - 70*D1**2*bdd2*s + 35*D1**2*bdd2 - 72*D1**2*f*fd*r**2 - 792*D1**2*f*fd*r*s + 342*D1**2*f*fd*r - 720*D1**2*f*fd*s**2 + 882*D1**2*f*fd*s - 414*D1**2*f*fd + 120*D1**2*f*fdd*r**2 + 984*D1**2*f*fdd*r*s - 486*D1**2*f*fdd*r + 864*D1**2*f*fdd*s**2 - 1050*D1**2*f*fdd*s + 522*D1**2*f*fdd + 120*D1**2*fd**2*r**2 + 984*D1**2*fd**2*r*s - 486*D1**2*fd**2*r + 864*D1**2*fd**2*s**2 - 1050*D1**2*fd**2*s + 186*D1**2*fd**2 - 196*D1**2*fd*r**2 - 476*D1**2*fd*r*s - 294*D1**2*fd*r - 280*D1**2*fd*s**2 - 224*D1**2*fd*s + 252*D1**2*fd - 7*D1**2*fdd*r**2 + 308*D1**2*fdd*r*s + 462*D1**2*fdd*r + 315*D1**2*fdd*s**2 + 392*D1**2*fdd*s - 231*D1**2*fdd + 490*D1**2*gd2*r**2 + 140*D1**2*gd2*r*s - 140*D1**2*gd2*r - 350*D1**2*gd2*s**2 + 700*D1**2*gd2*s - 350*D1**2*gd2 - 560*D1**2*gdd2*r**2 - 1120*D1**2*gdd2*r*s + 1120*D1**2*gdd2*r - 560*D1**2*gdd2*s**2 + 1120*D1**2*gdd2*s - 560*D1**2*gdd2 - 1624*D1*Dd*K*f*r**2 - 1344*D1*Dd*K*f*r*s + 1484*D1*Dd*K*f*r + 280*D1*Dd*K*f*s**2 + 56*D1*Dd*K*f*s - 266*D1*Dd*K*f + 1064*D1*Dd*K*fd*r**2 + 784*D1*Dd*K*fd*r*s - 2926*D1*Dd*K*fd*r - 280*D1*Dd*K*fd*s**2 - 1750*D1*Dd*K*fd*s + 1512*D1*Dd*K*fd - 280*D1*Dd*b2*r**2 - 560*D1*Dd*b2*r*s + 420*D1*Dd*b2*r - 280*D1*Dd*b2*s**2 + 420*D1*Dd*b2*s - 210*D1*Dd*b2 - 144*D1*Dd*f**2*r**2 - 1584*D1*Dd*f**2*r*s + 864*D1*Dd*f**2*r - 1440*D1*Dd*f**2*s**2 + 1836*D1*Dd*f**2*s - 756*D1*Dd*f**2 + 960*D1*Dd*f*fd*r**2 + 7872*D1*Dd*f*fd*r*s - 4152*D1*Dd*f*fd*r + 6912*D1*Dd*f*fd*s**2 - 8640*D1*Dd*f*fd*s + 2586*D1*Dd*f*fd - 784*D1*Dd*f*r**2 - 1904*D1*Dd*f*r*s + 1344*D1*Dd*f*r - 1120*D1*Dd*f*s**2 + 1596*D1*Dd*f*s - 756*D1*Dd*f - 56*D1*Dd*fd*r**2 + 2464*D1*Dd*fd*r*s + 1246*D1*Dd*fd*r + 2520*D1*Dd*fd*s**2 - 1246*D1*Dd*fd + 1960*D1*Dd*g2*r**2 + 560*D1*Dd*g2*r*s - 1260*D1*Dd*g2*r - 1400*D1*Dd*g2*s**2 + 1260*D1*Dd*g2*s - 210*D1*Dd*g2 - 4480*D1*Dd*gd2*r**2 - 8960*D1*Dd*gd2*r*s + 7840*D1*Dd*gd2*r - 4480*D1*Dd*gd2*s**2 + 7840*D1*Dd*gd2*s - 3360*D1*Dd*gd2 + 532*D1*Ddd*K*f*r**2 + 392*D1*Ddd*K*f*r*s - 462*D1*Ddd*K*f*r - 140*D1*Ddd*K*f*s**2 + 42*D1*Ddd*K*f*s + 63*D1*Ddd*K*f + 140*D1*Ddd*b2*r**2 + 280*D1*Ddd*b2*r*s - 210*D1*Ddd*b2*r + 140*D1*Ddd*b2*s**2 - 210*D1*Ddd*b2*s + 105*D1*Ddd*b2 + 240*D1*Ddd*f**2*r**2 + 1968*D1*Ddd*f**2*r*s - 1104*D1*Ddd*f**2*r + 1728*D1*Ddd*f**2*s**2 - 2220*D1*Ddd*f**2*s + 924*D1*Ddd*f**2 - 28*D1*Ddd*f*r**2 + 1232*D1*Ddd*f*r*s - 602*D1*Ddd*f*r + 1260*D1*Ddd*f*s**2 - 1568*D1*Ddd*f*s + 623*D1*Ddd*f - 2240*D1*Ddd*g2*r**2 - 4480*D1*Ddd*g2*r*s + 3360*D1*Ddd*g2*r - 2240*D1*Ddd*g2*s**2 + 3360*D1*Ddd*g2*s - 1680*D1*Ddd*g2 + 7*D1*bd1*(D1*(-5*K*(21*r**2 + 2*r*(3*s - 8) - 15*s**2 + 8*s + 2) + f*(21*r**2 + r*(72*s - 38) + 51*s**2 - 58*s + 24) - 2*fd*(63*r**2 + r*(156*s - 125) + 93*s**2 - 150*s + 57) - 15*r**2 - 30*r*(5*s - 2) - 135*s**2 + 140*s - 50) - 2*Dd*(-40*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + f*(252*r**2 + r*(624*s - 407) + 372*s**2 - 492*s + 161) + 420*r**2 + 15*r*(64*s - 43) + 540*s**2 - 730*s + 245)) - 70*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) + 1596*Dd**2*K*f*r**2 + 1176*Dd**2*K*f*r*s - 1386*Dd**2*K*f*r - 420*Dd**2*K*f*s**2 + 126*Dd**2*K*f*s + 126*Dd**2*K*f + 420*Dd**2*b2*r**2 + 840*Dd**2*b2*r*s - 630*Dd**2*b2*r + 420*Dd**2*b2*s**2 - 630*Dd**2*b2*s + 210*Dd**2*b2 + 720*Dd**2*f**2*r**2 + 5904*Dd**2*f**2*r*s - 3312*Dd**2*f**2*r + 5184*Dd**2*f**2*s**2 - 6660*Dd**2*f**2*s + 1848*Dd**2*f**2 - 84*Dd**2*f*r**2 + 3696*Dd**2*f*r*s - 1806*Dd**2*f*r + 3780*Dd**2*f*s**2 - 4704*Dd**2*f*s + 1246*Dd**2*f - 6720*Dd**2*g2*r**2 - 13440*Dd**2*g2*r*s + 10080*Dd**2*g2*r - 6720*Dd**2*g2*s**2 + 10080*Dd**2*g2*s - 3360*Dd**2*g2) + b1*(1260*C*D1**2*f*fd*r**2 + 1512*C*D1**2*f*fd*r*s - 2016*C*D1**2*f*fd*r + 252*C*D1**2*f*fd*s**2 - 1008*C*D1**2*f*fd*s + 756*C*D1**2*f*fd + 2520*C*D1*Dd*f**2*r**2 + 3024*C*D1*Dd*f**2*r*s - 2772*C*D1*Dd*f**2*r + 504*C*D1*Dd*f**2*s**2 - 1260*C*D1*Dd*f**2*s + 882*C*D1*Dd*f**2 + 798*D1**2*K*bdd1*f*r**2 + 588*D1**2*K*bdd1*f*r*s + 756*D1**2*K*bdd1*f*r - 210*D1**2*K*bdd1*f*s**2 + 1260*D1**2*K*bdd1*f*s - 630*D1**2*K*bdd1*f + 1242*D1**2*K*f*fd*r**2 + 1620*D1**2*K*f*fd*r*s - 1242*D1**2*K*f*fd*r + 378*D1**2*K*f*fd*s**2 - 810*D1**2*K*f*fd*s + 621*D1**2*K*f*fd - 1062*D1**2*K*f*fdd*r**2 - 1692*D1**2*K*f*fdd*r*s + 1062*D1**2*K*f*fdd*r - 630*D1**2*K*f*fdd*s**2 + 846*D1**2*K*f*fdd*s - 531*D1**2*K*f*fdd - 1062*D1**2*K*fd**2*r**2 - 1692*D1**2*K*fd**2*r*s + 1062*D1**2*K*fd**2*r - 630*D1**2*K*fd**2*s**2 + 846*D1**2*K*fd**2*s - 42*D1**2*bd1**2*(-40*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(63*r**2 + 2*r*(78*s - 47) + 93*s**2 - 114*s + 26) + 105*r**2 + 240*r*s - 150*r + 135*s**2 - 170*s + 40) + 189*D1**2*bd2*f*r**2 + 378*D1**2*bd2*f*r*s - 378*D1**2*bd2*f*r + 189*D1**2*bd2*f*s**2 - 378*D1**2*bd2*f*s + 189*D1**2*bd2*f - 924*D1**2*bd2*fd*r**2 - 1848*D1**2*bd2*fd*r*s + 798*D1**2*bd2*fd*r - 924*D1**2*bd2*fd*s**2 + 798*D1**2*bd2*fd*s + 126*D1**2*bd2*fd + 360*D1**2*bdd1*f**2*r**2 + 2952*D1**2*bdd1*f**2*r*s - 1854*D1**2*bdd1*f**2*r + 2592*D1**2*bdd1*f**2*s**2 - 3510*D1**2*bdd1*f**2*s + 1206*D1**2*bdd1*f**2 - 42*D1**2*bdd1*f*r**2 + 1848*D1**2*bdd1*f*r*s - 2268*D1**2*bdd1*f*r + 1890*D1**2*bdd1*f*s**2 - 3990*D1**2*bdd1*f*s + 1617*D1**2*bdd1*f - 3360*D1**2*bdd1*g2*r**2 - 6720*D1**2*bdd1*g2*r*s + 3360*D1**2*bdd1*g2*r - 3360*D1**2*bdd1*g2*s**2 + 3360*D1**2*bdd1*g2*s - 1680*D1**2*bdd1*g2 - 462*D1**2*bdd2*f*r**2 - 924*D1**2*bdd2*f*r*s + 924*D1**2*bdd2*f*r - 462*D1**2*bdd2*f*s**2 + 924*D1**2*bdd2*f*s - 462*D1**2*bdd2*f - 1785*D1**2*f**2*fd*r**2 - 4620*D1**2*f**2*fd*r*s + 3250*D1**2*f**2*fd*r - 2835*D1**2*f**2*fd*s**2 + 4240*D1**2*f**2*fd*s - 1945*D1**2*f**2*fd + 1635*D1**2*f**2*fdd*r**2 + 5280*D1**2*f**2*fdd*r*s - 3470*D1**2*f**2*fdd*r + 3645*D1**2*f**2*fdd*s**2 - 5180*D1**2*f**2*fdd*s + 2255*D1**2*f**2*fdd + 3270*D1**2*f*fd**2*r**2 + 10560*D1**2*f*fd**2*r*s - 6940*D1**2*f*fd**2*r + 7290*D1**2*f*fd**2*s**2 - 10360*D1**2*f*fd**2*s + 3370*D1**2*f*fd**2 - 2178*D1**2*f*fd*r**2 - 3384*D1**2*f*fd*r*s + 2808*D1**2*f*fd*r - 1206*D1**2*f*fd*s**2 + 1944*D1**2*f*fd*s - 1278*D1**2*f*fd + 1152*D1**2*f*fdd*r**2 + 2952*D1**2*f*fdd*r*s - 1152*D1**2*f*fdd*r + 1800*D1**2*f*fdd*s**2 - 1476*D1**2*f*fdd*s + 576*D1**2*f*fdd + 2436*D1**2*f*gd2*r**2 + 2016*D1**2*f*gd2*r*s - 2016*D1**2*f*gd2*r - 420*D1**2*f*gd2*s**2 + 840*D1**2*f*gd2*s - 420*D1**2*f*gd2 - 798*D1**2*f*gdd2*r**2 - 588*D1**2*f*gdd2*r*s + 588*D1**2*f*gdd2*r + 210*D1**2*f*gdd2*s**2 - 420*D1**2*f*gdd2*s + 210*D1**2*f*gdd2 + 1152*D1**2*fd**2*r**2 + 2952*D1**2*fd**2*r*s - 1152*D1**2*fd**2*r + 1800*D1**2*fd**2*s**2 - 1476*D1**2*fd**2*s + 2436*D1**2*fd*g2*r**2 + 2016*D1**2*fd*g2*r*s - 6132*D1**2*fd*g2*r - 420*D1**2*fd*g2*s**2 - 3276*D1**2*fd*g2*s + 3066*D1**2*fd*g2 - 1596*D1**2*fd*gd2*r**2 - 1176*D1**2*fd*gd2*r*s + 4284*D1**2*fd*gd2*r + 420*D1**2*fd*gd2*s**2 + 2268*D1**2*fd*gd2*s - 2688*D1**2*fd*gd2 - 798*D1**2*fdd*g2*r**2 - 588*D1**2*fdd*g2*r*s + 3696*D1**2*fdd*g2*r + 210*D1**2*fdd*g2*s**2 + 2688*D1**2*fdd*g2*s - 1848*D1**2*fdd*g2 + 2484*D1*Dd*K*f**2*r**2 + 3240*D1*Dd*K*f**2*r*s - 2862*D1*Dd*K*f**2*r + 756*D1*Dd*K*f**2*s**2 - 1566*D1*Dd*K*f**2*s + 999*D1*Dd*K*f**2 - 8496*D1*Dd*K*f*fd*r**2 - 13536*D1*Dd*K*f*fd*r*s + 9756*D1*Dd*K*f*fd*r - 5040*D1*Dd*K*f*fd*s**2 + 7596*D1*Dd*K*f*fd*s - 2754*D1*Dd*K*f*fd - 3696*D1*Dd*bd2*f*r**2 - 7392*D1*Dd*bd2*f*r*s + 6468*D1*Dd*bd2*f*r - 3696*D1*Dd*bd2*f*s**2 + 6468*D1*Dd*bd2*f*s - 2772*D1*Dd*bd2*f - 2380*D1*Dd*f**3*r**2 - 6160*D1*Dd*f**3*r*s + 4270*D1*Dd*f**3*r - 3780*D1*Dd*f**3*s**2 + 5320*D1*Dd*f**3*s - 2485*D1*Dd*f**3 + 13080*D1*Dd*f**2*fd*r**2 + 42240*D1*Dd*f**2*fd*r*s - 27710*D1*Dd*f**2*fd*r + 29160*D1*Dd*f**2*fd*s**2 - 40580*D1*Dd*f**2*fd*s + 13830*D1*Dd*f**2*fd - 4356*D1*Dd*f**2*r**2 - 6768*D1*Dd*f**2*r*s + 5562*D1*Dd*f**2*r - 2412*D1*Dd*f**2*s**2 + 4104*D1*Dd*f**2*s - 2295*D1*Dd*f**2 + 9216*D1*Dd*f*fd*r**2 + 23616*D1*Dd*f*fd*r*s - 12816*D1*Dd*f*fd*r + 14400*D1*Dd*f*fd*s**2 - 16056*D1*Dd*f*fd*s + 4104*D1*Dd*f*fd + 9744*D1*Dd*f*g2*r**2 + 8064*D1*Dd*f*g2*r*s - 8904*D1*Dd*f*g2*r - 1680*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 1596*D1*Dd*f*g2 - 6384*D1*Dd*f*gd2*r**2 - 4704*D1*Dd*f*gd2*r*s + 5124*D1*Dd*f*gd2*r + 1680*D1*Dd*f*gd2*s**2 - 1932*D1*Dd*f*gd2*s + 252*D1*Dd*f*gd2 - 6384*D1*Dd*fd*g2*r**2 - 4704*D1*Dd*fd*g2*r*s + 17556*D1*Dd*fd*g2*r + 1680*D1*Dd*fd*g2*s**2 + 10500*D1*Dd*fd*g2*s - 9072*D1*Dd*fd*g2 - 2124*D1*Ddd*K*f**2*r**2 - 3384*D1*Ddd*K*f**2*r*s + 2754*D1*Ddd*K*f**2*r - 1260*D1*Ddd*K*f**2*s**2 + 2106*D1*Ddd*K*f**2*s - 1161*D1*Ddd*K*f**2 + 2180*D1*Ddd*f**3*r**2 + 7040*D1*Ddd*f**3*r*s - 4610*D1*Ddd*f**3*r + 4860*D1*Ddd*f**3*s**2 - 6620*D1*Ddd*f**3*s + 2975*D1*Ddd*f**3 + 2304*D1*Ddd*f**2*r**2 + 5904*D1*Ddd*f**2*r*s - 4104*D1*Ddd*f**2*r + 3600*D1*Ddd*f**2*s**2 - 5076*D1*Ddd*f**2*s + 2376*D1*Ddd*f**2 - 3192*D1*Ddd*f*g2*r**2 - 2352*D1*Ddd*f*g2*r*s + 2772*D1*Ddd*f*g2*r + 840*D1*Ddd*f*g2*s**2 - 252*D1*Ddd*f*g2*s - 378*D1*Ddd*f*g2 + 3*D1*bd1*(70*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-18*f**2*(4*r**2 + r*(44*s - 29) + 40*s**2 - 53*s + 19) + f*(70*C*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) - 7*K*(116*r**2 + 96*r*s - 18*r - 20*s**2 + 50*s - 25) + 6*fd*(80*r**2 + 16*r*(41*s - 23) + 576*s**2 - 740*s + 195) - 392*r**2 - 952*r*s + 1162*r - 560*s**2 + 1260*s - 728) + 14*fd*(2*K*(19*r**2 + 7*r*(2*s - 5) - 5*s**2 - 17*s + 16) - 2*r**2 + 88*r*s + 12*r + 90*s**2 - 39*s - 28) + 70*g2*(14*r**2 + 4*r*s - 14*r - 10*s**2 - 2*s + 7) - 1120*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(3*f**2*(160*r**2 + 4*r*(328*s - 195) + 1152*s**2 - 1520*s + 493) + 14*f*(K*(76*r**2 + 56*r*s + 3*r - 20*s**2 + 63*s - 39) - 4*r**2 + 176*r*s - 151*r + 180*s**2 - 302*s + 122) - 560*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 6372*Dd**2*K*f**2*r**2 - 10152*Dd**2*K*f**2*r*s + 8262*Dd**2*K*f**2*r - 3780*Dd**2*K*f**2*s**2 + 6318*Dd**2*K*f**2*s - 2322*Dd**2*K*f**2 + 6540*Dd**2*f**3*r**2 + 21120*Dd**2*f**3*r*s - 13830*Dd**2*f**3*r + 14580*Dd**2*f**3*s**2 - 19860*Dd**2*f**3*s + 5950*Dd**2*f**3 + 6912*Dd**2*f**2*r**2 + 17712*Dd**2*f**2*r*s - 12312*Dd**2*f**2*r + 10800*Dd**2*f**2*s**2 - 15228*Dd**2*f**2*s + 4752*Dd**2*f**2 - 9576*Dd**2*f*g2*r**2 - 7056*Dd**2*f*g2*r*s + 8316*Dd**2*f*g2*r + 2520*Dd**2*f*g2*s**2 - 756*Dd**2*f*g2*s - 756*Dd**2*f*g2 - 21*b2*(-5*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 9*D1**2*fd*r**2 - 18*D1**2*fd*r*s - 12*D1**2*fd*r - 9*D1**2*fd*s**2 - 12*D1**2*fd*s + 6*D1**2*fd + 22*D1**2*fdd*r**2 + 44*D1**2*fdd*r*s + 6*D1**2*fdd*r + 22*D1**2*fdd*s**2 + 6*D1**2*fdd*s - 3*D1**2*fdd - 36*D1*Dd*f*r**2 - 72*D1*Dd*f*r*s + 54*D1*Dd*f*r - 36*D1*Dd*f*s**2 + 54*D1*Dd*f*s - 27*D1*Dd*f + 176*D1*Dd*fd*r**2 + 352*D1*Dd*fd*r*s - 108*D1*Dd*fd*r + 176*D1*Dd*fd*s**2 - 108*D1*Dd*fd*s - 18*D1*Dd*fd + 88*D1*Ddd*f*r**2 + 176*D1*Ddd*f*r*s - 132*D1*Ddd*f*r + 88*D1*Ddd*f*s**2 - 132*D1*Ddd*f*s + 66*D1*Ddd*f + 10*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 264*Dd**2*f*r**2 + 528*Dd**2*f*r*s - 396*Dd**2*f*r + 264*Dd**2*f*s**2 - 396*Dd**2*f*s + 132*Dd**2*f)) + 3*b2*(70*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 7*D1**2*bdd1*f*(22*r**2 + r*(44*s - 50) + 22*s**2 - 50*s + 25) + 3*D1**2*(f*(3*fd*(46*r**2 + r*(60*s - 46) + 14*s**2 - 30*s + 23) - fdd*(118*r**2 + 2*r*(94*s - 59) + 70*s**2 - 94*s + 59)) - 2*fd**2*(59*r**2 + r*(94*s - 59) + s*(35*s - 47))) + 7*D1*bd1*(D1*(3*f*(3*r**2 + 2*r*(3*s - 5) + 3*s**2 - 10*s + 5) - 44*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(88*r**2 + 2*r*(88*s - 83) + 88*s**2 - 166*s + 75)) + 3*D1*f*(Dd*(3*f*(92*r**2 + 2*r*(60*s - 53) + 28*s**2 - 58*s + 37) - 2*fd*(472*r**2 + r*(752*s - 542) + 280*s**2 - 422*s + 153)) - Ddd*f*(236*r**2 + r*(376*s - 306) + 140*s**2 - 234*s + 129)) - 18*Dd**2*f**2*(118*r**2 + r*(188*s - 153) + 70*s**2 - 117*s + 43)))/(630*d**2*k3**3) - 2*D1**2*Pk1*Pkd3*ct**2*st**2*(D1*f*(-21*D1*bd1**2*s*(4*C - 3)*(2*r + 2*s - 1) + D1*bd1*(f*s*(72*C - 47)*(r + s) - fd*(36*C - 27)*(r*(4*s - 1) + s*(4*s - 3))) - 9*D1*bdd1*f*s*(4*C - 3)*(r + s) - 9*Dd*bd1*f*(4*C - 3)*(r*(8*s - 2) + s*(8*s - 5))) + 7*b1**2*(D1**2*(s - 1)*(fd*(24*C - 13) + fdd*(9 - 12*C))*(r + s - 1) + D1*(Dd*(f*(24*C - 13)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(12*C - 9)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(9 - 12*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(12*C - 9)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(D1**2*(f*fd*(72*C - 47)*(2*s - 1)*(r + s - 1) - f*(12*C - 9)*(7*bdd1*s*(2*r + 2*s - 1) + 3*fdd*(2*s - 1)*(r + s - 1)) - fd**2*(36*C - 27)*(2*s - 1)*(r + s - 1)) + 7*D1*bd1*(D1*(f*s*(24*C - 13)*(2*r + 2*s - 1) - fd*(12*C - 9)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(18 - 24*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(72*C - 47)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(27 - 36*C)*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(27 - 36*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(27 - 36*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k3) + D1**2*Pk1*Pkd3*ct**2*(D1*f*(-14*D1*bd1**2*(r**2*(10*C - 5) + r*(60*C*s - 10*C - 56*s + 5) + s*(50*C*s - 30*C - 51*s + 28)) - 3*D1*bdd1*f*(r + s)*(r*(30*C - 15) + s*(70*C - 73)) - 3*bd1*(D1*(-f*(r + s)*(r*(18*C - 9) + s*(98*C - 83)) + 2*fd*(r**2*(60*C - 30) + r*(40*C*(5*s - 2) - 176*s + 59) + s*(20*C*(7*s - 6) - 146*s + 117))) + 2*Dd*f*(r**2*(120*C - 60) + r*(400*C*s - 130*C - 352*s + 103) + 2*s*(140*C*s - 95*C - 146*s + 95)))) - 7*b1**2*(D1**2*(fd*(10*C*(r - 7*s + 7) - 5*r + 57*s - 57) + fdd*(10*C*(r + 5*s - 5) - 5*r - 51*s + 51))*(r + s - 1) + D1*(Dd*(f*(10*C*(4*r**2 - 24*r*s + 10*r - 28*s**2 + 34*s - 13) - 20*r**2 + 208*r*s - 94*r + 228*s**2 - 280*s + 109) + 2*fd*(10*C*(4*r**2 + 24*r*s - 19*r + 20*s**2 - 33*s + 13) - 20*r**2 - 224*r*s + 173*r - 204*s**2 + 334*s - 130)) + Ddd*f*(10*C*(4*r**2 + 24*r*s - 14*r + 20*s**2 - 26*s + 11) - 20*r**2 - 224*r*s + 122*r - 204*s**2 + 260*s - 107)) + 2*Dd**2*f*(10*C*(6*r**2 + 36*r*s - 21*r + 30*s**2 - 39*s + 11) - 30*r**2 - 336*r*s + 183*r - 306*s**2 + 390*s - 107)) + b1*(-7*D1**2*bdd1*f*(10*C*(2*r**2 + 2*r*(6*s - 1) + 10*s**2 - 6*s + 1) - 10*r**2 - 2*r*(56*s - 5) - 102*s**2 + 56*s - 5) + 6*D1**2*(f*(fd*(2*C*(9*r + 49*s - 29) - 9*r - 83*s + 46) + fdd*(-10*C*(3*r + 7*s - 5) + 15*r + 73*s - 44)) + fd**2*(-10*C*(3*r + 7*s - 5) + 15*r + 73*s - 44))*(r + s - 1) - 7*D1*bd1*(D1*(f*(10*C*(2*r**2 - 2*r*(6*s + 1) - 14*s**2 + 6*s + 1) - 10*r**2 + 2*r*(52*s + 5) + 114*s**2 - 52*s - 5) + 2*fd*(10*C*(2*r**2 + r*(12*s - 7) + 10*s**2 - 13*s + 3) - 10*r**2 - 112*r*s + 61*r - 102*s**2 + 130*s - 28)) + 2*Dd*f*(10*C*(8*r**2 + 6*r*(8*s - 3) + 40*s**2 - 38*s + 7) - 40*r**2 + r*(142 - 448*s) - 408*s**2 + 372*s - 61)) + 3*D1*f*(Dd*(f*(C*(72*r**2 + 464*r*s - 268*r + 392*s**2 - 508*s + 214) - 36*r**2 - 368*r*s + 202*r - 332*s**2 + 424*s - 175) - 2*fd*(20*C*(12*r**2 + 40*r*s - 29*r + 28*s**2 - 43*s + 16) - 120*r**2 - 704*r*s + 442*r - 584*s**2 + 848*s - 293)) + Ddd*f*(-10*C*(12*r**2 + 40*r*s - 26*r + 28*s**2 - 38*s + 17) + 60*r**2 + 352*r*s - 206*r + 292*s**2 - 380*s + 161)) - 6*Dd**2*f**2*(10*C*(18*r**2 + r*(60*s - 39) + 42*s**2 - 57*s + 17) - 90*r**2 + r*(309 - 528*s) - 438*s**2 + 570*s - 161)))/(210*d**2*k3) + D1**2*Pk1*Pkd3*ct**2*k2**4*st**4*(-144*D1**2*b1*f*fd*r**2 - 144*D1**2*b1*f*fd*r*s + 72*D1**2*b1*f*fd*r + 30*D1**2*b1*f*fdd*r**2 + 30*D1**2*b1*f*fdd*r*s - 15*D1**2*b1*f*fdd*r + 30*D1**2*b1*fd**2*r**2 + 30*D1**2*b1*fd**2*r*s - 15*D1**2*b1*fd**2*r + 15*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 96*D1**2*f**2*fd*r**2 - 96*D1**2*f**2*fd*r*s + 96*D1**2*f**2*fd*r + 32*D1**2*f**2*fd*s - 32*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 75*D1**2*f**2*fdd*r*s - 75*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd*s + 25*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 150*D1**2*f*fd**2*r*s - 150*D1**2*f*fd**2*r - 50*D1**2*f*fd**2*s + 25*D1**2*f*fd**2 - 288*D1*Dd*b1*f**2*r**2 - 288*D1*Dd*b1*f**2*r*s + 288*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s - 72*D1*Dd*b1*f**2 + 240*D1*Dd*b1*f*fd*r**2 + 240*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r - 30*D1*Dd*b1*f*fd*s + 15*D1*Dd*b1*f*fd - 128*D1*Dd*f**3*r**2 - 128*D1*Dd*f**3*r*s + 128*D1*Dd*f**3*r + 32*D1*Dd*f**3*s - 32*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 600*D1*Dd*f**2*fd*r*s - 600*D1*Dd*f**2*fd*r - 175*D1*Dd*f**2*fd*s + 125*D1*Dd*f**2*fd + 60*D1*Ddd*b1*f**2*r**2 + 60*D1*Ddd*b1*f**2*r*s - 60*D1*Ddd*b1*f**2*r - 15*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 100*D1*Ddd*f**3*r**2 + 100*D1*Ddd*f**3*r*s - 100*D1*Ddd*f**3*r - 25*D1*Ddd*f**3*s + 25*D1*Ddd*f**3 - 3*D1*bd1*f*(D1*(24*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 180*Dd**2*b1*f**2*r**2 + 180*Dd**2*b1*f**2*r*s - 180*Dd**2*b1*f**2*r - 45*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 300*Dd**2*f**3*r**2 + 300*Dd**2*f**3*r*s - 300*Dd**2*f**3*r - 75*Dd**2*f**3*s + 50*Dd**2*f**3)/(105*d**2*k1**2*k3**3) - 2*D1**2*Pk1*Pkd3*ct**2*k2**4*st**2*(D1*f*(-3*D1*bd1**2*f*(4*r**2 + r*(4*s - 5) - 2*s + 1) + bd1*(D1*(5*f**2*r*(2*r + 2*s - 1) - f*(7*fd*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1) + (4*r - 21)*(r + s - 1)) - 12*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd*f*(7*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 96*r**2 + 96*r*(s - 1) - 12*s + 12)) - f*(D1*(bdd1*r*(7*f*(2*r + 2*s - 1) + 12*r + 12*s - 12) + 9*fd*(3*r**2 + 3*r*(s - 1) - s + 1)) + 9*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1))) + b1**2*(D1**2*r*(3*f*(2*fd - fdd)*(4*r + 4*s - 3) + fd*(-3*fd*(4*r + 4*s - 3) + 35*r + 35*s)) + D1*f*(Dd*(12*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r - 1)*(4*r + 4*s - 3) + 140*r**2 + 140*r*(s - 1) - 35*s + 35) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-3*D1**2*bdd1*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + 30*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 35*D1**2*f**2*fd*r - 10*D1**2*f**2*fd*s + 10*D1**2*f**2*fd - 42*D1**2*f**2*fdd*r**2 - 42*D1**2*f**2*fdd*r*s + 49*D1**2*f**2*fdd*r + 14*D1**2*f**2*fdd*s - 14*D1**2*f**2*fdd - 84*D1**2*f*fd**2*r**2 - 84*D1**2*f*fd**2*r*s + 98*D1**2*f*fd**2*r + 28*D1**2*f*fd**2*s - 21*D1**2*f*fd**2 - 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s - 13*D1**2*f*fd*r - 17*D1**2*f*fd*s + 17*D1**2*f*fd - 24*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 24*D1**2*f*fdd*r + 12*D1**2*f*fdd*s - 12*D1**2*f*fdd - 24*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 24*D1**2*fd**2*r + 12*D1**2*fd**2*s + 40*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 40*D1*Dd*f**3*r - 10*D1*Dd*f**3*s + 10*D1*Dd*f**3 - 336*D1*Dd*f**2*fd*r**2 - 336*D1*Dd*f**2*fd*r*s + 364*D1*Dd*f**2*fd*r + 98*D1*Dd*f**2*fd*s - 77*D1*Dd*f**2*fd - 16*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 16*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 - 192*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 192*D1*Dd*f*fd*r + 72*D1*Dd*f*fd*s - 48*D1*Dd*f*fd - 56*D1*Ddd*f**3*r**2 - 56*D1*Ddd*f**3*r*s + 56*D1*Ddd*f**3*r + 14*D1*Ddd*f**3*s - 14*D1*Ddd*f**3 - 48*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 48*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s - 12*D1*Ddd*f**2 + D1*bd1*f*(D1*(6*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 3*fd*(4*r - 1)*(4*r + 4*s - 3) + (70*r - 35)*(r + s - 1)) - 3*Dd*f*(8*r - 3)*(4*r + 4*s - 3)) - 168*Dd**2*f**3*r**2 - 168*Dd**2*f**3*r*s + 168*Dd**2*f**3*r + 42*Dd**2*f**3*s - 28*Dd**2*f**3 - 144*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 144*Dd**2*f**2*r + 36*Dd**2*f**2*s - 24*Dd**2*f**2))/(105*d**2*k1**2*k3**3) - 2*D1**2*Pk1*Pkd3*ct**2*k2**2*st**2*(35*D1*b1**2*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + D1*f*(D1*bd1*(17*f*r*(r + s) - 12*fd*(4*r**2 + r*(4*s - 3) - s)) - 12*D1*bdd1*f*r*(r + s) - 12*Dd*bd1*f*(8*r**2 + r*(8*s - 4) - s)) + b1*(35*D1**2*bd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + D1**2*(2*r - 1)*(r + s - 1)*(17*f*fd - 12*f*fdd - 12*fd**2) + D1*f*(Dd*(17*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 12*fd*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) - 12*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(105*d**2*k1**2*k3) - D1**2*Pk1*Pkd3*ct**2*k2**2*(-D1**2*bd1*f*r*(bd1*(3*f + 7)*(2*r + 2*s - 1) + 21*f*(r + s)) + D1*b1*(7*D1*bd1**2*(f + 5)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + bd1*(D1*(27*f**2*r*(2*r + 2*s - 1) + f*(-3*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + 98*r**2 + 98*r*s - 14*r + 35*s - 35) - 7*fd*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(3*f + 7)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1)) - f*(D1*(bdd1*r*(3*f + 7)*(2*r + 2*s - 1) + 21*fd*(2*r - 1)*(r + s - 1)) + 21*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1))) + 7*b1**3*(D1**2*r*(3*fd + fdd)*(r + s - 1) + D1*(Dd*(3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(8*r**2 + 8*r*(s - 1) - s + 1) + 80*r**2 + 80*r*(s - 1) - 20*s + 20) + Ddd*(f + 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd**2*(f + 5)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(7*D1**2*bdd1*(f + 5)*(3*r**2 + 3*r*(s - 1) - s + 1) + 54*D1**2*f*fd*r**2 + 54*D1**2*f*fd*r*s - 81*D1**2*f*fd*r - 27*D1**2*f*fd*s + 27*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r + 3*D1**2*f*fdd*s - 3*D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 9*D1**2*fd**2*r + 3*D1**2*fd**2*s - 3*D1**2*fd**2 + 49*D1**2*fd*r**2 + 49*D1**2*fd*r*s - 133*D1**2*fd*r - 84*D1**2*fd*s + 84*D1**2*fd - 7*D1**2*fdd*r**2 - 7*D1**2*fdd*r*s + 14*D1**2*fdd*r + 7*D1**2*fdd*s - 7*D1**2*fdd + 108*D1*Dd*f**2*r**2 + 108*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r - 27*D1*Dd*f**2*s + 27*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r + 18*D1*Dd*f*fd*s - 15*D1*Dd*f*fd + 196*D1*Dd*f*r**2 + 196*D1*Dd*f*r*s - 196*D1*Dd*f*r - 49*D1*Dd*f*s + 49*D1*Dd*f - 56*D1*Dd*fd*r**2 - 56*D1*Dd*fd*r*s + 84*D1*Dd*fd*r + 35*D1*Dd*fd*s - 28*D1*Dd*fd - 12*D1*Ddd*f**2*r**2 - 12*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r + 3*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 - 28*D1*Ddd*f*r**2 - 28*D1*Ddd*f*r*s + 28*D1*Ddd*f*r + 7*D1*Ddd*f*s - 7*D1*Ddd*f + 7*D1*bd1*(D1*(f*(9*r**2 + 9*r*(s - 1) - 3*s + 3) + fd*(6*r**2 + 6*r*(s - 1) - s + 1) + 60*r**2 + 60*r*(s - 1) - 20*s + 20) + Dd*(f + 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 36*Dd**2*f**2*r**2 - 36*Dd**2*f**2*r*s + 36*Dd**2*f**2*r + 9*Dd**2*f**2*s - 6*Dd**2*f**2 - 84*Dd**2*f*r**2 - 84*Dd**2*f*r*s + 84*Dd**2*f*r + 21*Dd**2*f*s - 14*Dd**2*f))/(105*d**2*k1**2*k3) + D1**2*Pk1*Pkd3*ct*f*k2**7*st**6*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 88*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 88*D1**2*b1*f*fd*s + 44*D1**2*b1*f*fd - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 44*D1**2*b1*f*fdd*r - 33*D1**2*b1*f*fdd*s**2 + 44*D1**2*b1*f*fdd*s - 22*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 88*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 88*D1**2*b1*fd**2*s - 22*D1**2*b1*fd**2 - 11*D1**2*bdd1*f**2*(r + s - 1)**2 + 24*D1**2*f**2*fd*r**2 + 48*D1**2*f**2*fd*r*s - 36*D1**2*f**2*fd*r + 24*D1**2*f**2*fd*s**2 - 36*D1**2*f**2*fd*s + 18*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 - 24*D1**2*f**2*fdd*r*s + 18*D1**2*f**2*fdd*r - 12*D1**2*f**2*fdd*s**2 + 18*D1**2*f**2*fdd*s - 9*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r**2 - 72*D1**2*f*fd**2*r*s + 54*D1**2*f*fd**2*r - 36*D1**2*f*fd**2*s**2 + 54*D1**2*f*fd**2*s - 18*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 176*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r + 88*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 374*D1*Dd*b1*f*fd*r - 264*D1*Dd*b1*f*fd*s**2 + 374*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 - 192*D1*Dd*f**2*fd*r*s + 144*D1*Dd*f**2*fd*r - 96*D1*Dd*f**2*fd*s**2 + 144*D1*Dd*f**2*fd*s - 54*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 - 88*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r - 44*D1*Ddd*b1*f**2*s**2 + 66*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 24*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 18*D1*Ddd*f**3*s - 9*D1*Ddd*f**3 + 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 132*Dd**2*b1*f**2*r**2 - 264*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r - 132*Dd**2*b1*f**2*s**2 + 198*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 72*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 54*Dd**2*f**3*s - 18*Dd**2*f**3)/(22*d**2*k1*k3**7) + D1**2*Pk1*Pkd3*ct*k1**5*k2*st**2*(168*C*D1**2*b1*f*fd*r**2 + 336*C*D1**2*b1*f*fd*r*s - 168*C*D1**2*b1*f*fd*r + 168*C*D1**2*b1*f*fd*s**2 - 168*C*D1**2*b1*f*fd*s + 84*C*D1**2*b1*f*fd - 504*C*D1**2*b1*f*fdd*r**2 - 1008*C*D1**2*b1*f*fdd*r*s + 504*C*D1**2*b1*f*fdd*r - 504*C*D1**2*b1*f*fdd*s**2 + 504*C*D1**2*b1*f*fdd*s - 252*C*D1**2*b1*f*fdd - 504*C*D1**2*b1*fd**2*r**2 - 1008*C*D1**2*b1*fd**2*r*s + 504*C*D1**2*b1*fd**2*r - 504*C*D1**2*b1*fd**2*s**2 + 504*C*D1**2*b1*fd**2*s + 300*C*D1**2*f**2*fd*r**2 + 600*C*D1**2*f**2*fd*r*s - 400*C*D1**2*f**2*fd*r + 300*C*D1**2*f**2*fd*s**2 - 400*C*D1**2*f**2*fd*s + 200*C*D1**2*f**2*fd - 420*C*D1**2*f**2*fdd*r**2 - 840*C*D1**2*f**2*fdd*r*s + 560*C*D1**2*f**2*fdd*r - 420*C*D1**2*f**2*fdd*s**2 + 560*C*D1**2*f**2*fdd*s - 280*C*D1**2*f**2*fdd - 840*C*D1**2*f*fd**2*r**2 - 1680*C*D1**2*f*fd**2*r*s + 1120*C*D1**2*f*fd**2*r - 840*C*D1**2*f*fd**2*s**2 + 1120*C*D1**2*f*fd**2*s - 280*C*D1**2*f*fd**2 + 336*C*D1*Dd*b1*f**2*r**2 + 672*C*D1*Dd*b1*f**2*r*s - 504*C*D1*Dd*b1*f**2*r + 336*C*D1*Dd*b1*f**2*s**2 - 504*C*D1*Dd*b1*f**2*s + 252*C*D1*Dd*b1*f**2 - 4032*C*D1*Dd*b1*f*fd*r**2 - 8064*C*D1*Dd*b1*f*fd*r*s + 5040*C*D1*Dd*b1*f*fd*r - 4032*C*D1*Dd*b1*f*fd*s**2 + 5040*C*D1*Dd*b1*f*fd*s - 1512*C*D1*Dd*b1*f*fd + 400*C*D1*Dd*f**3*r**2 + 800*C*D1*Dd*f**3*r*s - 600*C*D1*Dd*f**3*r + 400*C*D1*Dd*f**3*s**2 - 600*C*D1*Dd*f**3*s + 300*C*D1*Dd*f**3 - 3360*C*D1*Dd*f**2*fd*r**2 - 6720*C*D1*Dd*f**2*fd*r*s + 4760*C*D1*Dd*f**2*fd*r - 3360*C*D1*Dd*f**2*fd*s**2 + 4760*C*D1*Dd*f**2*fd*s - 1680*C*D1*Dd*f**2*fd - 1008*C*D1*Ddd*b1*f**2*r**2 - 2016*C*D1*Ddd*b1*f**2*r*s + 1512*C*D1*Ddd*b1*f**2*r - 1008*C*D1*Ddd*b1*f**2*s**2 + 1512*C*D1*Ddd*b1*f**2*s - 756*C*D1*Ddd*b1*f**2 - 560*C*D1*Ddd*f**3*r**2 - 1120*C*D1*Ddd*f**3*r*s + 840*C*D1*Ddd*f**3*r - 560*C*D1*Ddd*f**3*s**2 + 840*C*D1*Ddd*f**3*s - 420*C*D1*Ddd*f**3 - 3024*C*Dd**2*b1*f**2*r**2 - 6048*C*Dd**2*b1*f**2*r*s + 4536*C*Dd**2*b1*f**2*r - 3024*C*Dd**2*b1*f**2*s**2 + 4536*C*Dd**2*b1*f**2*s - 1512*C*Dd**2*b1*f**2 - 1680*C*Dd**2*f**3*r**2 - 3360*C*Dd**2*f**3*r*s + 2520*C*Dd**2*f**3*r - 1680*C*Dd**2*f**3*s**2 + 2520*C*Dd**2*f**3*s - 840*C*Dd**2*f**3 - 78*D1**2*b1*f*fd*r**2 - 156*D1**2*b1*f*fd*r*s + 78*D1**2*b1*f*fd*r - 78*D1**2*b1*f*fd*s**2 + 78*D1**2*b1*f*fd*s - 39*D1**2*b1*f*fd + 270*D1**2*b1*f*fdd*r**2 + 540*D1**2*b1*f*fdd*r*s - 270*D1**2*b1*f*fdd*r + 270*D1**2*b1*f*fdd*s**2 - 270*D1**2*b1*f*fdd*s + 135*D1**2*b1*f*fdd + 270*D1**2*b1*fd**2*r**2 + 540*D1**2*b1*fd**2*r*s - 270*D1**2*b1*fd**2*r + 270*D1**2*b1*fd**2*s**2 - 270*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(28*C - 15)*(r + s - 1)**2 - 153*D1**2*f**2*fd*r**2 - 306*D1**2*f**2*fd*r*s + 204*D1**2*f**2*fd*r - 153*D1**2*f**2*fd*s**2 + 204*D1**2*f**2*fd*s - 102*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 450*D1**2*f**2*fdd*r*s - 300*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 300*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 900*D1**2*f*fd**2*r*s - 600*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 600*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 156*D1*Dd*b1*f**2*r**2 - 312*D1*Dd*b1*f**2*r*s + 234*D1*Dd*b1*f**2*r - 156*D1*Dd*b1*f**2*s**2 + 234*D1*Dd*b1*f**2*s - 117*D1*Dd*b1*f**2 + 2160*D1*Dd*b1*f*fd*r**2 + 4320*D1*Dd*b1*f*fd*r*s - 2700*D1*Dd*b1*f*fd*r + 2160*D1*Dd*b1*f*fd*s**2 - 2700*D1*Dd*b1*f*fd*s + 810*D1*Dd*b1*f*fd - 204*D1*Dd*f**3*r**2 - 408*D1*Dd*f**3*r*s + 306*D1*Dd*f**3*r - 204*D1*Dd*f**3*s**2 + 306*D1*Dd*f**3*s - 153*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 3600*D1*Dd*f**2*fd*r*s - 2550*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 2550*D1*Dd*f**2*fd*s + 900*D1*Dd*f**2*fd + 540*D1*Ddd*b1*f**2*r**2 + 1080*D1*Ddd*b1*f**2*r*s - 810*D1*Ddd*b1*f**2*r + 540*D1*Ddd*b1*f**2*s**2 - 810*D1*Ddd*b1*f**2*s + 405*D1*Ddd*b1*f**2 + 300*D1*Ddd*f**3*r**2 + 600*D1*Ddd*f**3*r*s - 450*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 450*D1*Ddd*f**3*s + 225*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(28*C - 13)*(r + s - 1) - D1*fd*(168*C - 90)*(2*r + 2*s - 1) - Dd*f*(168*C - 90)*(4*r + 4*s - 3)) + 1620*Dd**2*b1*f**2*r**2 + 3240*Dd**2*b1*f**2*r*s - 2430*Dd**2*b1*f**2*r + 1620*Dd**2*b1*f**2*s**2 - 2430*Dd**2*b1*f**2*s + 810*Dd**2*b1*f**2 + 900*Dd**2*f**3*r**2 + 1800*Dd**2*f**3*r*s - 1350*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 1350*Dd**2*f**3*s + 450*Dd**2*f**3)/(70*d**2*k3**7) + D1**2*Pk1*Pkd3*ct*k1**5*k2*(-270*D1**2*K*bdd1*f**2*r**2 - 540*D1**2*K*bdd1*f**2*r*s + 540*D1**2*K*bdd1*f**2*r - 270*D1**2*K*bdd1*f**2*s**2 + 540*D1**2*K*bdd1*f**2*s - 270*D1**2*K*bdd1*f**2 + 18*D1**2*bd1**2*f*(-42*K + 5*f + 7)*(r + s - 1)**2 + 35*D1**2*bdd1*f**3*r**2 + 70*D1**2*bdd1*f**3*r*s - 70*D1**2*bdd1*f**3*r + 35*D1**2*bdd1*f**3*s**2 - 70*D1**2*bdd1*f**3*s + 35*D1**2*bdd1*f**3 + 45*D1**2*bdd1*f**2*r**2 + 90*D1**2*bdd1*f**2*r*s - 90*D1**2*bdd1*f**2*r + 45*D1**2*bdd1*f**2*s**2 - 90*D1**2*bdd1*f**2*s + 45*D1**2*bdd1*f**2 + 756*D1**2*bdd1*f*g2*r**2 + 1512*D1**2*bdd1*f*g2*r*s - 1512*D1**2*bdd1*f*g2*r + 756*D1**2*bdd1*f*g2*s**2 - 1512*D1**2*bdd1*f*g2*s + 756*D1**2*bdd1*f*g2 - 324*D1**2*f**2*gd2*r**2 - 648*D1**2*f**2*gd2*r*s + 648*D1**2*f**2*gd2*r - 324*D1**2*f**2*gd2*s**2 + 648*D1**2*f**2*gd2*s - 324*D1**2*f**2*gd2 + 540*D1**2*f**2*gdd2*r**2 + 1080*D1**2*f**2*gdd2*r*s - 1080*D1**2*f**2*gdd2*r + 540*D1**2*f**2*gdd2*s**2 - 1080*D1**2*f**2*gdd2*s + 540*D1**2*f**2*gdd2 - 648*D1**2*f*fd*g2*r**2 - 1296*D1**2*f*fd*g2*r*s + 648*D1**2*f*fd*g2*r - 648*D1**2*f*fd*g2*s**2 + 648*D1**2*f*fd*g2*s - 324*D1**2*f*fd*g2 + 2160*D1**2*f*fd*gd2*r**2 + 4320*D1**2*f*fd*gd2*r*s - 3240*D1**2*f*fd*gd2*r + 2160*D1**2*f*fd*gd2*s**2 - 3240*D1**2*f*fd*gd2*s + 1080*D1**2*f*fd*gd2 + 1080*D1**2*f*fdd*g2*r**2 + 2160*D1**2*f*fdd*g2*r*s - 1080*D1**2*f*fdd*g2*r + 1080*D1**2*f*fdd*g2*s**2 - 1080*D1**2*f*fdd*g2*s + 540*D1**2*f*fdd*g2 + 1080*D1**2*fd**2*g2*r**2 + 2160*D1**2*fd**2*g2*r*s - 1080*D1**2*fd**2*g2*r + 1080*D1**2*fd**2*g2*s**2 - 1080*D1**2*fd**2*g2*s - 1296*D1*Dd*f**2*g2*r**2 - 2592*D1*Dd*f**2*g2*r*s + 1944*D1*Dd*f**2*g2*r - 1296*D1*Dd*f**2*g2*s**2 + 1944*D1*Dd*f**2*g2*s - 972*D1*Dd*f**2*g2 + 4320*D1*Dd*f**2*gd2*r**2 + 8640*D1*Dd*f**2*gd2*r*s - 7560*D1*Dd*f**2*gd2*r + 4320*D1*Dd*f**2*gd2*s**2 - 7560*D1*Dd*f**2*gd2*s + 3240*D1*Dd*f**2*gd2 + 8640*D1*Dd*f*fd*g2*r**2 + 17280*D1*Dd*f*fd*g2*r*s - 10800*D1*Dd*f*fd*g2*r + 8640*D1*Dd*f*fd*g2*s**2 - 10800*D1*Dd*f*fd*g2*s + 3240*D1*Dd*f*fd*g2 + 2160*D1*Ddd*f**2*g2*r**2 + 4320*D1*Ddd*f**2*g2*r*s - 3240*D1*Ddd*f**2*g2*r + 2160*D1*Ddd*f**2*g2*s**2 - 3240*D1*Ddd*f**2*g2*s + 1620*D1*Ddd*f**2*g2 - D1*bd1*(D1*(25*f**3*(r + s - 1) + f**2*(-70*fd*(3*r + 3*s - 2) + (27 - 162*K)*(r + s - 1)) + 18*f*(5*fd*(6*K - 1)*(2*r + 2*s - 1) + (14*g2 - 84*gd2)*(r + s - 1)) - 1512*fd*g2*(r + s)) - 2*Dd*f*(35*f**2 - 45*f*(6*K - 1) + 756*g2)*(4*r + 4*s - 3))*(r + s - 1) + 6480*Dd**2*f**2*g2*r**2 + 12960*Dd**2*f**2*g2*r*s - 9720*Dd**2*f**2*g2*r + 6480*Dd**2*f**2*g2*s**2 - 9720*Dd**2*f**2*g2*s + 3240*Dd**2*f**2*g2 - 3*b1**2*(D1**2*(3*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(30*fd**2*(r + s - 1) + 7*fd*(6*K - 1)*(r + s) - 21*fdd*(6*K - 1)*(r + s))) + D1*(Dd*(9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(30*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (42*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(6*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-42*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-42*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(324*D1**2*K*f*fd*r**2 + 648*D1**2*K*f*fd*r*s - 324*D1**2*K*f*fd*r + 324*D1**2*K*f*fd*s**2 - 324*D1**2*K*f*fd*s + 162*D1**2*K*f*fd - 540*D1**2*K*f*fdd*r**2 - 1080*D1**2*K*f*fdd*r*s + 540*D1**2*K*f*fdd*r - 540*D1**2*K*f*fdd*s**2 + 540*D1**2*K*f*fdd*s - 270*D1**2*K*f*fdd - 540*D1**2*K*fd**2*r**2 - 1080*D1**2*K*fd**2*r*s + 540*D1**2*K*fd**2*r - 540*D1**2*K*fd**2*s**2 + 540*D1**2*K*fd**2*s + 18*D1**2*bdd1*f*(-42*K + 5*f + 7)*(r + s - 1)**2 - 75*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 + 210*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 70*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 + 420*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s + 70*D1**2*f*fd**2 - 54*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 54*D1**2*f*fd*r - 54*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 180*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 90*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 45*D1**2*f*fdd - 252*D1**2*f*gd2*r**2 - 504*D1**2*f*gd2*r*s + 504*D1**2*f*gd2*r - 252*D1**2*f*gd2*s**2 + 504*D1**2*f*gd2*s - 252*D1**2*f*gd2 + 756*D1**2*f*gdd2*r**2 + 1512*D1**2*f*gdd2*r*s - 1512*D1**2*f*gdd2*r + 756*D1**2*f*gdd2*s**2 - 1512*D1**2*f*gdd2*s + 756*D1**2*f*gdd2 + 90*D1**2*fd**2*r**2 + 180*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 90*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 252*D1**2*fd*g2*r**2 - 504*D1**2*fd*g2*r*s - 252*D1**2*fd*g2*s**2 + 1512*D1**2*fd*gd2*r**2 + 3024*D1**2*fd*gd2*r*s - 1512*D1**2*fd*gd2*r + 1512*D1**2*fd*gd2*s**2 - 1512*D1**2*fd*gd2*s + 756*D1**2*fdd*g2*r**2 + 1512*D1**2*fdd*g2*r*s + 756*D1**2*fdd*g2*s**2 + 648*D1*Dd*K*f**2*r**2 + 1296*D1*Dd*K*f**2*r*s - 972*D1*Dd*K*f**2*r + 648*D1*Dd*K*f**2*s**2 - 972*D1*Dd*K*f**2*s + 486*D1*Dd*K*f**2 - 4320*D1*Dd*K*f*fd*r**2 - 8640*D1*Dd*K*f*fd*r*s + 5400*D1*Dd*K*f*fd*r - 4320*D1*Dd*K*f*fd*s**2 + 5400*D1*Dd*K*f*fd*s - 1620*D1*Dd*K*f*fd - 100*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 75*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 + 1680*D1*Dd*f**2*fd*r*s - 1190*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 1190*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 162*D1*Dd*f**2*r - 108*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1440*D1*Dd*f*fd*r*s - 900*D1*Dd*f*fd*r + 720*D1*Dd*f*fd*s**2 - 900*D1*Dd*f*fd*s + 270*D1*Dd*f*fd - 1008*D1*Dd*f*g2*r**2 - 2016*D1*Dd*f*g2*r*s + 1512*D1*Dd*f*g2*r - 1008*D1*Dd*f*g2*s**2 + 1512*D1*Dd*f*g2*s - 756*D1*Dd*f*g2 + 6048*D1*Dd*f*gd2*r**2 + 12096*D1*Dd*f*gd2*r*s - 10584*D1*Dd*f*gd2*r + 6048*D1*Dd*f*gd2*s**2 - 10584*D1*Dd*f*gd2*s + 4536*D1*Dd*f*gd2 + 6048*D1*Dd*fd*g2*r**2 + 12096*D1*Dd*fd*g2*r*s - 4536*D1*Dd*fd*g2*r + 6048*D1*Dd*fd*g2*s**2 - 4536*D1*Dd*fd*g2*s - 1080*D1*Ddd*K*f**2*r**2 - 2160*D1*Ddd*K*f**2*r*s + 1620*D1*Ddd*K*f**2*r - 1080*D1*Ddd*K*f**2*s**2 + 1620*D1*Ddd*K*f**2*s - 810*D1*Ddd*K*f**2 + 140*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r*s - 210*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 210*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 + 360*D1*Ddd*f**2*r*s - 270*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s**2 - 270*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 + 3024*D1*Ddd*f*g2*r**2 + 6048*D1*Ddd*f*g2*r*s - 4536*D1*Ddd*f*g2*r + 3024*D1*Ddd*f*g2*s**2 - 4536*D1*Ddd*f*g2*s + 2268*D1*Ddd*f*g2 - 6*D1*bd1*(D1*(9*f**2*(r + s - 1) - 30*f*fd*(2*r + 2*s - 1) - 7*f*(6*K - 1)*(r + s - 1) + 42*fd*(6*K - 1)*(r + s)) - 6*Dd*f*(-42*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) - 3240*Dd**2*K*f**2*r**2 - 6480*Dd**2*K*f**2*r*s + 4860*Dd**2*K*f**2*r - 3240*Dd**2*K*f**2*s**2 + 4860*Dd**2*K*f**2*s - 1620*Dd**2*K*f**2 + 420*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r*s - 630*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 630*Dd**2*f**3*s + 210*Dd**2*f**3 + 540*Dd**2*f**2*r**2 + 1080*Dd**2*f**2*r*s - 810*Dd**2*f**2*r + 540*Dd**2*f**2*s**2 - 810*Dd**2*f**2*s + 270*Dd**2*f**2 + 9072*Dd**2*f*g2*r**2 + 18144*Dd**2*f*g2*r*s - 13608*Dd**2*f*g2*r + 9072*Dd**2*f*g2*s**2 - 13608*Dd**2*f*g2*s + 4536*Dd**2*f*g2))/(70*d**2*k3**7) + D1**2*Pk1*Pkd3*ct*k1**5*st**2*(4*C - 2)*(b1*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 9*fd*(2*s - 1)*(8*r + 8*s - 5)) - 9*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 9*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(7*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k2*k3**5) - D1**2*Pk1*Pkd3*ct*k1**5*(4*C - 2)*(7*b1*(D1**2*(f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-7*bdd1*s*(r + s - 1) + 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 7*D1*bd1*(D1*(f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 5*D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k2*k3**5) + 3*D1**2*Pk1*Pkd3*ct*k1**3*k2**3*st**4*(432*C*D1**2*b1*f*fd*r**2 + 864*C*D1**2*b1*f*fd*r*s - 432*C*D1**2*b1*f*fd*r + 432*C*D1**2*b1*f*fd*s**2 - 432*C*D1**2*b1*f*fd*s + 216*C*D1**2*b1*f*fd - 384*C*D1**2*b1*f*fdd*r**2 - 768*C*D1**2*b1*f*fdd*r*s + 384*C*D1**2*b1*f*fdd*r - 384*C*D1**2*b1*f*fdd*s**2 + 384*C*D1**2*b1*f*fdd*s - 192*C*D1**2*b1*f*fdd - 384*C*D1**2*b1*fd**2*r**2 - 768*C*D1**2*b1*fd**2*r*s + 384*C*D1**2*b1*fd**2*r - 384*C*D1**2*b1*fd**2*s**2 + 384*C*D1**2*b1*fd**2*s + 312*C*D1**2*f**2*fd*r**2 + 624*C*D1**2*f**2*fd*r*s - 416*C*D1**2*f**2*fd*r + 312*C*D1**2*f**2*fd*s**2 - 416*C*D1**2*f**2*fd*s + 208*C*D1**2*f**2*fd - 192*C*D1**2*f**2*fdd*r**2 - 384*C*D1**2*f**2*fdd*r*s + 256*C*D1**2*f**2*fdd*r - 192*C*D1**2*f**2*fdd*s**2 + 256*C*D1**2*f**2*fdd*s - 128*C*D1**2*f**2*fdd - 384*C*D1**2*f*fd**2*r**2 - 768*C*D1**2*f*fd**2*r*s + 512*C*D1**2*f*fd**2*r - 384*C*D1**2*f*fd**2*s**2 + 512*C*D1**2*f*fd**2*s - 128*C*D1**2*f*fd**2 + 864*C*D1*Dd*b1*f**2*r**2 + 1728*C*D1*Dd*b1*f**2*r*s - 1296*C*D1*Dd*b1*f**2*r + 864*C*D1*Dd*b1*f**2*s**2 - 1296*C*D1*Dd*b1*f**2*s + 648*C*D1*Dd*b1*f**2 - 3072*C*D1*Dd*b1*f*fd*r**2 - 6144*C*D1*Dd*b1*f*fd*r*s + 3840*C*D1*Dd*b1*f*fd*r - 3072*C*D1*Dd*b1*f*fd*s**2 + 3840*C*D1*Dd*b1*f*fd*s - 1152*C*D1*Dd*b1*f*fd + 416*C*D1*Dd*f**3*r**2 + 832*C*D1*Dd*f**3*r*s - 624*C*D1*Dd*f**3*r + 416*C*D1*Dd*f**3*s**2 - 624*C*D1*Dd*f**3*s + 312*C*D1*Dd*f**3 - 1536*C*D1*Dd*f**2*fd*r**2 - 3072*C*D1*Dd*f**2*fd*r*s + 2176*C*D1*Dd*f**2*fd*r - 1536*C*D1*Dd*f**2*fd*s**2 + 2176*C*D1*Dd*f**2*fd*s - 768*C*D1*Dd*f**2*fd - 768*C*D1*Ddd*b1*f**2*r**2 - 1536*C*D1*Ddd*b1*f**2*r*s + 1152*C*D1*Ddd*b1*f**2*r - 768*C*D1*Ddd*b1*f**2*s**2 + 1152*C*D1*Ddd*b1*f**2*s - 576*C*D1*Ddd*b1*f**2 - 256*C*D1*Ddd*f**3*r**2 - 512*C*D1*Ddd*f**3*r*s + 384*C*D1*Ddd*f**3*r - 256*C*D1*Ddd*f**3*s**2 + 384*C*D1*Ddd*f**3*s - 192*C*D1*Ddd*f**3 - 2304*C*Dd**2*b1*f**2*r**2 - 4608*C*Dd**2*b1*f**2*r*s + 3456*C*Dd**2*b1*f**2*r - 2304*C*Dd**2*b1*f**2*s**2 + 3456*C*Dd**2*b1*f**2*s - 1152*C*Dd**2*b1*f**2 - 768*C*Dd**2*f**3*r**2 - 1536*C*Dd**2*f**3*r*s + 1152*C*Dd**2*f**3*r - 768*C*Dd**2*f**3*s**2 + 1152*C*Dd**2*f**3*s - 384*C*Dd**2*f**3 - 246*D1**2*b1*f*fd*r**2 - 492*D1**2*b1*f*fd*r*s + 246*D1**2*b1*f*fd*r - 246*D1**2*b1*f*fd*s**2 + 246*D1**2*b1*f*fd*s - 123*D1**2*b1*f*fd + 228*D1**2*b1*f*fdd*r**2 + 456*D1**2*b1*f*fdd*r*s - 228*D1**2*b1*f*fdd*r + 228*D1**2*b1*f*fdd*s**2 - 228*D1**2*b1*f*fdd*s + 114*D1**2*b1*f*fdd + 228*D1**2*b1*fd**2*r**2 + 456*D1**2*b1*fd**2*r*s - 228*D1**2*b1*fd**2*r + 228*D1**2*b1*fd**2*s**2 - 228*D1**2*b1*fd**2*s - 6*D1**2*bdd1*f**2*(32*C - 19)*(r + s - 1)**2 - 183*D1**2*f**2*fd*r**2 - 366*D1**2*f**2*fd*r*s + 244*D1**2*f**2*fd*r - 183*D1**2*f**2*fd*s**2 + 244*D1**2*f**2*fd*s - 122*D1**2*f**2*fd + 114*D1**2*f**2*fdd*r**2 + 228*D1**2*f**2*fdd*r*s - 152*D1**2*f**2*fdd*r + 114*D1**2*f**2*fdd*s**2 - 152*D1**2*f**2*fdd*s + 76*D1**2*f**2*fdd + 228*D1**2*f*fd**2*r**2 + 456*D1**2*f*fd**2*r*s - 304*D1**2*f*fd**2*r + 228*D1**2*f*fd**2*s**2 - 304*D1**2*f*fd**2*s + 76*D1**2*f*fd**2 - 492*D1*Dd*b1*f**2*r**2 - 984*D1*Dd*b1*f**2*r*s + 738*D1*Dd*b1*f**2*r - 492*D1*Dd*b1*f**2*s**2 + 738*D1*Dd*b1*f**2*s - 369*D1*Dd*b1*f**2 + 1824*D1*Dd*b1*f*fd*r**2 + 3648*D1*Dd*b1*f*fd*r*s - 2280*D1*Dd*b1*f*fd*r + 1824*D1*Dd*b1*f*fd*s**2 - 2280*D1*Dd*b1*f*fd*s + 684*D1*Dd*b1*f*fd - 244*D1*Dd*f**3*r**2 - 488*D1*Dd*f**3*r*s + 366*D1*Dd*f**3*r - 244*D1*Dd*f**3*s**2 + 366*D1*Dd*f**3*s - 183*D1*Dd*f**3 + 912*D1*Dd*f**2*fd*r**2 + 1824*D1*Dd*f**2*fd*r*s - 1292*D1*Dd*f**2*fd*r + 912*D1*Dd*f**2*fd*s**2 - 1292*D1*Dd*f**2*fd*s + 456*D1*Dd*f**2*fd + 456*D1*Ddd*b1*f**2*r**2 + 912*D1*Ddd*b1*f**2*r*s - 684*D1*Ddd*b1*f**2*r + 456*D1*Ddd*b1*f**2*s**2 - 684*D1*Ddd*b1*f**2*s + 342*D1*Ddd*b1*f**2 + 152*D1*Ddd*f**3*r**2 + 304*D1*Ddd*f**3*r*s - 228*D1*Ddd*f**3*r + 152*D1*Ddd*f**3*s**2 - 228*D1*Ddd*f**3*s + 114*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(72*C - 41)*(r + s - 1) - D1*fd*(128*C - 76)*(2*r + 2*s - 1) - Dd*f*(128*C - 76)*(4*r + 4*s - 3)) + 1368*Dd**2*b1*f**2*r**2 + 2736*Dd**2*b1*f**2*r*s - 2052*Dd**2*b1*f**2*r + 1368*Dd**2*b1*f**2*s**2 - 2052*Dd**2*b1*f**2*s + 684*Dd**2*b1*f**2 + 456*Dd**2*f**3*r**2 + 912*Dd**2*f**3*r*s - 684*Dd**2*f**3*r + 456*Dd**2*f**3*s**2 - 684*Dd**2*f**3*s + 228*Dd**2*f**3)/(70*d**2*k3**7) + D1**2*Pk1*Pkd3*ct*k1**3*k2**3*st**2*(-4752*C*D1**2*f**2*fd*r**2 - 9504*C*D1**2*f**2*fd*r*s + 6336*C*D1**2*f**2*fd*r - 4752*C*D1**2*f**2*fd*s**2 + 6336*C*D1**2*f**2*fd*s - 3168*C*D1**2*f**2*fd - 6336*C*D1*Dd*f**3*r**2 - 12672*C*D1*Dd*f**3*r*s + 9504*C*D1*Dd*f**3*r - 6336*C*D1*Dd*f**3*s**2 + 9504*C*D1*Dd*f**3*s - 4752*C*D1*Dd*f**3 - 2376*D1**2*K*bdd1*f**2*r**2 - 4752*D1**2*K*bdd1*f**2*r*s + 4752*D1**2*K*bdd1*f**2*r - 2376*D1**2*K*bdd1*f**2*s**2 + 4752*D1**2*K*bdd1*f**2*s - 2376*D1**2*K*bdd1*f**2 + 396*D1**2*bd1**2*f*(-28*K + 15*f + 7)*(r + s - 1)**2 + 825*D1**2*bdd1*f**3*r**2 + 1650*D1**2*bdd1*f**3*r*s - 1650*D1**2*bdd1*f**3*r + 825*D1**2*bdd1*f**3*s**2 - 1650*D1**2*bdd1*f**3*s + 825*D1**2*bdd1*f**3 + 594*D1**2*bdd1*f**2*r**2 + 1188*D1**2*bdd1*f**2*r*s - 1188*D1**2*bdd1*f**2*r + 594*D1**2*bdd1*f**2*s**2 - 1188*D1**2*bdd1*f**2*s + 594*D1**2*bdd1*f**2 + 11088*D1**2*bdd1*f*g2*r**2 + 22176*D1**2*bdd1*f*g2*r*s - 22176*D1**2*bdd1*f*g2*r + 11088*D1**2*bdd1*f*g2*s**2 - 22176*D1**2*bdd1*f*g2*s + 11088*D1**2*bdd1*f*g2 + 1780*D1**2*f**3*fd*r**2 + 3560*D1**2*f**3*fd*r*s - 2670*D1**2*f**3*fd*r + 1780*D1**2*f**3*fd*s**2 - 2670*D1**2*f**3*fd*s + 1335*D1**2*f**3*fd - 2100*D1**2*f**3*fdd*r**2 - 4200*D1**2*f**3*fdd*r*s + 3150*D1**2*f**3*fdd*r - 2100*D1**2*f**3*fdd*s**2 + 3150*D1**2*f**3*fdd*s - 1575*D1**2*f**3*fdd - 6300*D1**2*f**2*fd**2*r**2 - 12600*D1**2*f**2*fd**2*r*s + 9450*D1**2*f**2*fd**2*r - 6300*D1**2*f**2*fd**2*s**2 + 9450*D1**2*f**2*fd**2*s - 3150*D1**2*f**2*fd**2 + 2673*D1**2*f**2*fd*r**2 + 5346*D1**2*f**2*fd*r*s - 3564*D1**2*f**2*fd*r + 2673*D1**2*f**2*fd*s**2 - 3564*D1**2*f**2*fd*s + 1782*D1**2*f**2*fd - 7656*D1**2*f**2*gd2*r**2 - 15312*D1**2*f**2*gd2*r*s + 15312*D1**2*f**2*gd2*r - 7656*D1**2*f**2*gd2*s**2 + 15312*D1**2*f**2*gd2*s - 7656*D1**2*f**2*gd2 + 4752*D1**2*f**2*gdd2*r**2 + 9504*D1**2*f**2*gdd2*r*s - 9504*D1**2*f**2*gdd2*r + 4752*D1**2*f**2*gdd2*s**2 - 9504*D1**2*f**2*gdd2*s + 4752*D1**2*f**2*gdd2 - 15312*D1**2*f*fd*g2*r**2 - 30624*D1**2*f*fd*g2*r*s + 15312*D1**2*f*fd*g2*r - 15312*D1**2*f*fd*g2*s**2 + 15312*D1**2*f*fd*g2*s - 7656*D1**2*f*fd*g2 + 19008*D1**2*f*fd*gd2*r**2 + 38016*D1**2*f*fd*gd2*r*s - 28512*D1**2*f*fd*gd2*r + 19008*D1**2*f*fd*gd2*s**2 - 28512*D1**2*f*fd*gd2*s + 9504*D1**2*f*fd*gd2 + 9504*D1**2*f*fdd*g2*r**2 + 19008*D1**2*f*fdd*g2*r*s - 9504*D1**2*f*fdd*g2*r + 9504*D1**2*f*fdd*g2*s**2 - 9504*D1**2*f*fdd*g2*s + 4752*D1**2*f*fdd*g2 + 9504*D1**2*fd**2*g2*r**2 + 19008*D1**2*fd**2*g2*r*s - 9504*D1**2*fd**2*g2*r + 9504*D1**2*fd**2*g2*s**2 - 9504*D1**2*fd**2*g2*s + 1780*D1*Dd*f**4*r**2 + 3560*D1*Dd*f**4*r*s - 2670*D1*Dd*f**4*r + 1780*D1*Dd*f**4*s**2 - 2670*D1*Dd*f**4*s + 1335*D1*Dd*f**4 - 16800*D1*Dd*f**3*fd*r**2 - 33600*D1*Dd*f**3*fd*r*s + 25200*D1*Dd*f**3*fd*r - 16800*D1*Dd*f**3*fd*s**2 + 25200*D1*Dd*f**3*fd*s - 9450*D1*Dd*f**3*fd + 3564*D1*Dd*f**3*r**2 + 7128*D1*Dd*f**3*r*s - 5346*D1*Dd*f**3*r + 3564*D1*Dd*f**3*s**2 - 5346*D1*Dd*f**3*s + 2673*D1*Dd*f**3 - 30624*D1*Dd*f**2*g2*r**2 - 61248*D1*Dd*f**2*g2*r*s + 45936*D1*Dd*f**2*g2*r - 30624*D1*Dd*f**2*g2*s**2 + 45936*D1*Dd*f**2*g2*s - 22968*D1*Dd*f**2*g2 + 38016*D1*Dd*f**2*gd2*r**2 + 76032*D1*Dd*f**2*gd2*r*s - 66528*D1*Dd*f**2*gd2*r + 38016*D1*Dd*f**2*gd2*s**2 - 66528*D1*Dd*f**2*gd2*s + 28512*D1*Dd*f**2*gd2 + 76032*D1*Dd*f*fd*g2*r**2 + 152064*D1*Dd*f*fd*g2*r*s - 95040*D1*Dd*f*fd*g2*r + 76032*D1*Dd*f*fd*g2*s**2 - 95040*D1*Dd*f*fd*g2*s + 28512*D1*Dd*f*fd*g2 - 2100*D1*Ddd*f**4*r**2 - 4200*D1*Ddd*f**4*r*s + 3150*D1*Ddd*f**4*r - 2100*D1*Ddd*f**4*s**2 + 3150*D1*Ddd*f**4*s - 1575*D1*Ddd*f**4 + 19008*D1*Ddd*f**2*g2*r**2 + 38016*D1*Ddd*f**2*g2*r*s - 28512*D1*Ddd*f**2*g2*r + 19008*D1*Ddd*f**2*g2*s**2 - 28512*D1*Ddd*f**2*g2*s + 14256*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(19*f**3*(r + s - 1) + f**2*(56*C*(r + s - 1) - 25*fd*(3*r + 3*s - 2) - (58*K + 17)*(r + s - 1)) + 2*f*(9*fd*(4*K - 1)*(2*r + 2*s - 1) + (98*g2 - 168*gd2)*(r + s - 1)) - 336*fd*g2*(r + s)) - Dd*f*(25*f**2 + f*(18 - 72*K) + 336*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6300*Dd**2*f**4*r**2 - 12600*Dd**2*f**4*r*s + 9450*Dd**2*f**4*r - 6300*Dd**2*f**4*s**2 + 9450*Dd**2*f**4*s - 3150*Dd**2*f**4 + 57024*Dd**2*f**2*g2*r**2 + 114048*Dd**2*f**2*g2*r*s - 85536*Dd**2*f**2*g2*r + 57024*Dd**2*f**2*g2*s**2 - 85536*Dd**2*f**2*g2*s + 28512*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(15*f*(5*fd - 6*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(180*fd**2*(r + s - 1) + 49*fd*(4*K - 1)*(r + s) - 42*fdd*(4*K - 1)*(r + s))) + D1*(Dd*(75*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(180*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (196*K - 49)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 84*fd*(4*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-28*K + 15*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-28*K + 15*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(224*C*D1**2*f*fd*r**2 + 448*C*D1**2*f*fd*r*s - 224*C*D1**2*f*fd*r + 224*C*D1**2*f*fd*s**2 - 224*C*D1**2*f*fd*s + 112*C*D1**2*f*fd + 448*C*D1*Dd*f**2*r**2 + 896*C*D1*Dd*f**2*r*s - 672*C*D1*Dd*f**2*r + 448*C*D1*Dd*f**2*s**2 - 672*C*D1*Dd*f**2*s + 336*C*D1*Dd*f**2 - 232*D1**2*K*f*fd*r**2 - 464*D1**2*K*f*fd*r*s + 232*D1**2*K*f*fd*r - 232*D1**2*K*f*fd*s**2 + 232*D1**2*K*f*fd*s - 116*D1**2*K*f*fd + 144*D1**2*K*f*fdd*r**2 + 288*D1**2*K*f*fdd*r*s - 144*D1**2*K*f*fdd*r + 144*D1**2*K*f*fdd*s**2 - 144*D1**2*K*f*fdd*s + 72*D1**2*K*f*fdd + 144*D1**2*K*fd**2*r**2 + 288*D1**2*K*fd**2*r*s - 144*D1**2*K*fd**2*r + 144*D1**2*K*fd**2*s**2 - 144*D1**2*K*fd**2*s - 12*D1**2*bdd1*f*(-28*K + 15*f + 7)*(r + s - 1)**2 + 114*D1**2*f**2*fd*r**2 + 228*D1**2*f**2*fd*r*s - 152*D1**2*f**2*fd*r + 114*D1**2*f**2*fd*s**2 - 152*D1**2*f**2*fd*s + 76*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 - 68*D1**2*f*fd*r**2 - 136*D1**2*f*fd*r*s + 68*D1**2*f*fd*r - 68*D1**2*f*fd*s**2 + 68*D1**2*f*fd*s - 34*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd + 392*D1**2*f*gd2*r**2 + 784*D1**2*f*gd2*r*s - 784*D1**2*f*gd2*r + 392*D1**2*f*gd2*s**2 - 784*D1**2*f*gd2*s + 392*D1**2*f*gd2 - 336*D1**2*f*gdd2*r**2 - 672*D1**2*f*gdd2*r*s + 672*D1**2*f*gdd2*r - 336*D1**2*f*gdd2*s**2 + 672*D1**2*f*gdd2*s - 336*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 392*D1**2*fd*g2*r**2 + 784*D1**2*fd*g2*r*s + 392*D1**2*fd*g2*s**2 - 672*D1**2*fd*gd2*r**2 - 1344*D1**2*fd*gd2*r*s + 672*D1**2*fd*gd2*r - 672*D1**2*fd*gd2*s**2 + 672*D1**2*fd*gd2*s - 336*D1**2*fdd*g2*r**2 - 672*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*s**2 - 464*D1*Dd*K*f**2*r**2 - 928*D1*Dd*K*f**2*r*s + 696*D1*Dd*K*f**2*r - 464*D1*Dd*K*f**2*s**2 + 696*D1*Dd*K*f**2*s - 348*D1*Dd*K*f**2 + 1152*D1*Dd*K*f*fd*r**2 + 2304*D1*Dd*K*f*fd*r*s - 1440*D1*Dd*K*f*fd*r + 1152*D1*Dd*K*f*fd*s**2 - 1440*D1*Dd*K*f*fd*s + 432*D1*Dd*K*f*fd + 152*D1*Dd*f**3*r**2 + 304*D1*Dd*f**3*r*s - 228*D1*Dd*f**3*r + 152*D1*Dd*f**3*s**2 - 228*D1*Dd*f**3*s + 114*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 136*D1*Dd*f**2*r**2 - 272*D1*Dd*f**2*r*s + 204*D1*Dd*f**2*r - 136*D1*Dd*f**2*s**2 + 204*D1*Dd*f**2*s - 102*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 1568*D1*Dd*f*g2*r**2 + 3136*D1*Dd*f*g2*r*s - 2352*D1*Dd*f*g2*r + 1568*D1*Dd*f*g2*s**2 - 2352*D1*Dd*f*g2*s + 1176*D1*Dd*f*g2 - 2688*D1*Dd*f*gd2*r**2 - 5376*D1*Dd*f*gd2*r*s + 4704*D1*Dd*f*gd2*r - 2688*D1*Dd*f*gd2*s**2 + 4704*D1*Dd*f*gd2*s - 2016*D1*Dd*f*gd2 - 2688*D1*Dd*fd*g2*r**2 - 5376*D1*Dd*fd*g2*r*s + 2016*D1*Dd*fd*g2*r - 2688*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s + 288*D1*Ddd*K*f**2*r**2 + 576*D1*Ddd*K*f**2*r*s - 432*D1*Ddd*K*f**2*r + 288*D1*Ddd*K*f**2*s**2 - 432*D1*Ddd*K*f**2*s + 216*D1*Ddd*K*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 - 1344*D1*Ddd*f*g2*r**2 - 2688*D1*Ddd*f*g2*r*s + 2016*D1*Ddd*f*g2*r - 1344*D1*Ddd*f*g2*s**2 + 2016*D1*Ddd*f*g2*s - 1008*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(75*f**2*(r + s - 1) - 180*f*fd*(2*r + 2*s - 1) - 49*f*(4*K - 1)*(r + s - 1) + 84*fd*(4*K - 1)*(r + s)) - 12*Dd*f*(-28*K + 15*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 864*Dd**2*K*f**2*r**2 + 1728*Dd**2*K*f**2*r*s - 1296*Dd**2*K*f**2*r + 864*Dd**2*K*f**2*s**2 - 1296*Dd**2*K*f**2*s + 432*Dd**2*K*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3 - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 - 4032*Dd**2*f*g2*r**2 - 8064*Dd**2*f*g2*r*s + 6048*Dd**2*f*g2*r - 4032*Dd**2*f*g2*s**2 + 6048*Dd**2*f*g2*s - 2016*Dd**2*f*g2))/(770*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct*k1**3*k2*st**4*(b1*(D1**2*(f*(fd*(70*C - 41) + fdd*(24 - 42*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(24 - 42*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(70*C - 41)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(24 - 42*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(24 - 42*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(24 - 42*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(26*C - 15)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (14*C - 8)*(3*bdd1*s*(r + s - 1) + fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(8 - 14*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(70*C - 41)*(r + s - 1) - fd*(42*C - 24)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(24 - 42*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(26*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(14*C - 8)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(8 - 14*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(8 - 14*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k3**5) + D1**2*Pk1*Pkd3*ct*k1**3*k2*st**2*(-105*b1**2*(D1**2*(fd*(8*C - 7) + fdd*(16*C - 9))*(r + s - 1)**2 + D1*(Dd*(f*(8*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(32*C - 18)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(16*C - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Dd**2*f*(96*C - 54)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(848*C*D1**2*f*fd*r**2 + 4080*C*D1**2*f*fd*r*s - 1640*C*D1**2*f*fd*r + 3232*C*D1**2*f*fd*s**2 - 2832*C*D1**2*f*fd*s + 1416*C*D1**2*f*fd - 1936*C*D1**2*f*fdd*r**2 - 5456*C*D1**2*f*fdd*r*s + 2248*C*D1**2*f*fdd*r - 3520*C*D1**2*f*fdd*s**2 + 3040*C*D1**2*f*fdd*s - 1520*C*D1**2*f*fdd - 1936*C*D1**2*fd**2*r**2 - 5456*C*D1**2*fd**2*r*s + 2248*C*D1**2*fd**2*r - 3520*C*D1**2*fd**2*s**2 + 3040*C*D1**2*fd**2*s + 480*C*D1**2*fd**2 + 1696*C*D1*Dd*f**2*r**2 + 8160*C*D1*Dd*f**2*r*s - 4928*C*D1*Dd*f**2*r + 6464*C*D1*Dd*f**2*s**2 - 8504*C*D1*Dd*f**2*s + 3656*C*D1*Dd*f**2 - 15488*C*D1*Dd*f*fd*r**2 - 43648*C*D1*Dd*f*fd*r*s + 23776*C*D1*Dd*f*fd*r - 28160*C*D1*Dd*f*fd*s**2 + 31696*C*D1*Dd*f*fd*s - 8328*C*D1*Dd*f*fd - 3872*C*D1*Ddd*f**2*r**2 - 10912*C*D1*Ddd*f**2*r*s + 7392*C*D1*Ddd*f**2*r - 7040*C*D1*Ddd*f**2*s**2 + 9768*C*D1*Ddd*f**2*s - 4488*C*D1*Ddd*f**2 - 11616*C*Dd**2*f**2*r**2 - 32736*C*Dd**2*f**2*r*s + 22176*C*Dd**2*f**2*r - 21120*C*Dd**2*f**2*s**2 + 29304*C*Dd**2*f**2*s - 8976*C*Dd**2*f**2 + 35*D1**2*bdd1*f*(16*C - 9)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 510*D1**2*f*fd*r**2 - 2404*D1**2*f*fd*r*s + 1012*D1**2*f*fd*r - 1894*D1**2*f*fd*s**2 + 1704*D1**2*f*fd*s - 852*D1**2*f*fd + 1074*D1**2*f*fdd*r**2 + 3204*D1**2*f*fdd*r*s - 1332*D1**2*f*fdd*r + 2130*D1**2*f*fdd*s**2 - 1860*D1**2*f*fdd*s + 930*D1**2*f*fdd + 1074*D1**2*fd**2*r**2 + 3204*D1**2*fd**2*r*s - 1332*D1**2*fd**2*r + 2130*D1**2*fd**2*s**2 - 1860*D1**2*fd**2*s - 270*D1**2*fd**2 - 1020*D1*Dd*f**2*r**2 - 4808*D1*Dd*f**2*r*s + 2914*D1*Dd*f**2*r - 3788*D1*Dd*f**2*s**2 + 4990*D1*Dd*f**2*s - 2149*D1*Dd*f**2 + 8592*D1*Dd*f*fd*r**2 + 25632*D1*Dd*f*fd*r*s - 13884*D1*Dd*f*fd*r + 17040*D1*Dd*f*fd*s**2 - 19164*D1*Dd*f*fd*s + 5052*D1*Dd*f*fd + 2148*D1*Ddd*f**2*r**2 + 6408*D1*Ddd*f**2*r*s - 4278*D1*Ddd*f**2*r + 4260*D1*Ddd*f**2*s**2 - 5862*D1*Ddd*f**2*s + 2667*D1*Ddd*f**2 + 35*D1*bd1*(D1*(f*(8*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(32*C - 18)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(32*C - 18)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 6444*Dd**2*f**2*r**2 + 19224*Dd**2*f**2*r*s - 12834*Dd**2*f**2*r + 12780*Dd**2*f**2*s**2 - 17586*Dd**2*f**2*s + 5334*Dd**2*f**2) + f*(-210*D1**2*bd1**2*(16*C - 9)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*D1**2*bdd1*f*(8*C*(121*r**2 + 341*r*s - 302*r + 220*s**2 - 401*s + 151) - 537*r**2 - 1602*r*s + 1344*r - 1065*s**2 + 1872*s - 672) - 2*D1**2*(-4*C*fd**2*(1614*r**2 + r*(3714*s - 2314) + 2100*s**2 - 2638*s + 619) + f*fd*(4*C*(696*r**2 + 1743*r*s - 1045*r + 1047*s**2 - 1279*s + 581) - 1551*r**2 - 3996*r*s + 2366*r - 2445*s**2 + 2962*s - 1332) - 4*f*fdd*(C*(807*r**2 + 1857*r*s - 1157*r + 1050*s**2 - 1319*s + 619) - 447*r**2 - 1080*r*s + 658*r - 633*s**2 + 782*s - 360) + 8*fd**2*(447*r**2 + 2*r*(540*s - 329) + 633*s**2 - 782*s + 180)) - 3*D1*bd1*(-8*C*Dd*f*(968*r**2 + 4*r*(682*s - 533) + 1760*s**2 - 2825*s + 1104) + D1*(-8*C*fd*(484*r**2 + r*(1364*s - 885) + 880*s**2 - 1182*s + 401) + f*(8*C*(53*r**2 + 3*r*(85*s - 52) + 202*s**2 - 305*s + 78) - 255*r**2 - 1202*r*s + 700*r - 947*s**2 + 1392*s - 350) + 12*fd*(179*r**2 + r*(534*s - 335) + 355*s**2 - 467*s + 156)) + 6*Dd*f*(716*r**2 + r*(2136*s - 1609) + 1420*s**2 - 2225*s + 848)) - 2*D1*f*(Dd*(f*(4*C*(928*r**2 + 2324*r*s - 1626*r + 1396*s**2 - 1977*s + 930) - 2068*r**2 - 5328*r*s + 3698*r - 3260*s**2 + 4592*s - 2147) - 4*fd*(C*(6456*r**2 + 14856*r*s - 9956*r + 8400*s**2 - 11333*s + 3795) - 3576*r**2 - 8640*r*s + 5686*r - 5064*s**2 + 6740*s - 2222)) - 4*Ddd*f*(C*(1076*r**2 + 4*r*(619*s - 444) + 1400*s**2 - 2019*s + 969) - 596*r**2 - 1440*r*s + 1018*r - 844*s**2 + 1204*s - 571)) + 8*Dd**2*f**2*(3*C*(1076*r**2 + 4*r*(619*s - 444) + 1400*s**2 - 2019*s + 646) - 1788*r**2 - 6*r*(720*s - 509) - 2532*s**2 + 3612*s - 1142)))/(630*d**2*k3**5) + D1**2*Pk1*Pkd3*ct*k1**3*k2*(3240*D1**2*K*bdd1*f**2*r**2 + 6120*D1**2*K*bdd1*f**2*r*s - 6120*D1**2*K*bdd1*f**2*r + 2880*D1**2*K*bdd1*f**2*s**2 - 5760*D1**2*K*bdd1*f**2*s + 2880*D1**2*K*bdd1*f**2 - 6*D1**2*bd1**2*(r + s - 1)*(3*f**2*(49*r + 105*s - 102) - 7*f*(4*K*(37*r + 37*s - 52) - 31*r - 55*s + 58) - 1400*g2*(r + s)) - 540*D1**2*bd2*f**2*r**2 - 1080*D1**2*bd2*f**2*r*s + 1080*D1**2*bd2*f**2*r - 540*D1**2*bd2*f**2*s**2 + 1080*D1**2*bd2*f**2*s - 540*D1**2*bd2*f**2 + 3600*D1**2*bd2*f*fd*r**2 + 7200*D1**2*bd2*f*fd*r*s - 5400*D1**2*bd2*f*fd*r + 3600*D1**2*bd2*f*fd*s**2 - 5400*D1**2*bd2*f*fd*s + 1800*D1**2*bd2*f*fd - 530*D1**2*bdd1*f**3*r**2 - 1200*D1**2*bdd1*f**3*r*s + 1380*D1**2*bdd1*f**3*r - 670*D1**2*bdd1*f**3*s**2 + 1520*D1**2*bdd1*f**3*s - 850*D1**2*bdd1*f**3 - 702*D1**2*bdd1*f**2*r**2 - 1692*D1**2*bdd1*f**2*r*s + 1692*D1**2*bdd1*f**2*r - 990*D1**2*bdd1*f**2*s**2 + 1980*D1**2*bdd1*f**2*s - 990*D1**2*bdd1*f**2 - 6216*D1**2*bdd1*f*g2*r**2 - 12432*D1**2*bdd1*f*g2*r*s + 17472*D1**2*bdd1*f*g2*r - 6216*D1**2*bdd1*f*g2*s**2 + 17472*D1**2*bdd1*f*g2*s - 8736*D1**2*bdd1*f*g2 + 900*D1**2*bdd2*f**2*r**2 + 1800*D1**2*bdd2*f**2*r*s - 1800*D1**2*bdd2*f**2*r + 900*D1**2*bdd2*f**2*s**2 - 1800*D1**2*bdd2*f**2*s + 900*D1**2*bdd2*f**2 - 560*D1**2*f**3*fd*r*s + 280*D1**2*f**3*fd*r - 560*D1**2*f**3*fd*s**2 + 700*D1**2*f**3*fd*s - 280*D1**2*f**3*fd + 560*D1**2*f**3*fdd*r*s - 280*D1**2*f**3*fdd*r + 560*D1**2*f**3*fdd*s**2 - 700*D1**2*f**3*fdd*s + 280*D1**2*f**3*fdd + 1680*D1**2*f**2*fd**2*r*s - 840*D1**2*f**2*fd**2*r + 1680*D1**2*f**2*fd**2*s**2 - 2100*D1**2*f**2*fd**2*s + 560*D1**2*f**2*fd**2 + 4896*D1**2*f**2*gd2*r**2 + 8352*D1**2*f**2*gd2*r*s - 8352*D1**2*f**2*gd2*r + 3456*D1**2*f**2*gd2*s**2 - 6912*D1**2*f**2*gd2*s + 3456*D1**2*f**2*gd2 - 6480*D1**2*f**2*gdd2*r**2 - 12240*D1**2*f**2*gdd2*r*s + 12240*D1**2*f**2*gdd2*r - 5760*D1**2*f**2*gdd2*s**2 + 11520*D1**2*f**2*gdd2*s - 5760*D1**2*f**2*gdd2 + 9792*D1**2*f*fd*g2*r**2 + 16704*D1**2*f*fd*g2*r*s - 9792*D1**2*f*fd*g2*r + 6912*D1**2*f*fd*g2*s**2 - 8352*D1**2*f*fd*g2*s + 4896*D1**2*f*fd*g2 - 25920*D1**2*f*fd*gd2*r**2 - 48960*D1**2*f*fd*gd2*r*s + 37440*D1**2*f*fd*gd2*r - 23040*D1**2*f*fd*gd2*s**2 + 35280*D1**2*f*fd*gd2*s - 12240*D1**2*f*fd*gd2 - 12960*D1**2*f*fdd*g2*r**2 - 24480*D1**2*f*fdd*g2*r*s + 12960*D1**2*f*fdd*g2*r - 11520*D1**2*f*fdd*g2*s**2 + 12240*D1**2*f*fdd*g2*s - 6480*D1**2*f*fdd*g2 - 12960*D1**2*fd**2*g2*r**2 - 24480*D1**2*fd**2*g2*r*s + 12960*D1**2*fd**2*g2*r - 11520*D1**2*fd**2*g2*s**2 + 12240*D1**2*fd**2*g2*s + 7200*D1*Dd*bd2*f**2*r**2 + 14400*D1*Dd*bd2*f**2*r*s - 12600*D1*Dd*bd2*f**2*r + 7200*D1*Dd*bd2*f**2*s**2 - 12600*D1*Dd*bd2*f**2*s + 5400*D1*Dd*bd2*f**2 - 560*D1*Dd*f**4*r*s + 280*D1*Dd*f**4*r - 560*D1*Dd*f**4*s**2 + 700*D1*Dd*f**4*s - 280*D1*Dd*f**4 + 4480*D1*Dd*f**3*fd*r*s - 2240*D1*Dd*f**3*fd*r + 4480*D1*Dd*f**3*fd*s**2 - 5600*D1*Dd*f**3*fd*s + 1680*D1*Dd*f**3*fd + 19584*D1*Dd*f**2*g2*r**2 + 33408*D1*Dd*f**2*g2*r*s - 26496*D1*Dd*f**2*g2*r + 13824*D1*Dd*f**2*g2*s**2 - 22176*D1*Dd*f**2*g2*s + 11808*D1*Dd*f**2*g2 - 51840*D1*Dd*f**2*gd2*r**2 - 97920*D1*Dd*f**2*gd2*r*s + 86400*D1*Dd*f**2*gd2*r - 46080*D1*Dd*f**2*gd2*s**2 + 81360*D1*Dd*f**2*gd2*s - 35280*D1*Dd*f**2*gd2 - 103680*D1*Dd*f*fd*g2*r**2 - 195840*D1*Dd*f*fd*g2*r*s + 126720*D1*Dd*f*fd*g2*r - 92160*D1*Dd*f*fd*g2*s**2 + 119520*D1*Dd*f*fd*g2*s - 37440*D1*Dd*f*fd*g2 + 560*D1*Ddd*f**4*r*s - 280*D1*Ddd*f**4*r + 560*D1*Ddd*f**4*s**2 - 700*D1*Ddd*f**4*s + 280*D1*Ddd*f**4 - 25920*D1*Ddd*f**2*g2*r**2 - 48960*D1*Ddd*f**2*g2*r*s + 37440*D1*Ddd*f**2*g2*r - 23040*D1*Ddd*f**2*g2*s**2 + 35280*D1*Ddd*f**2*g2*s - 18000*D1*Ddd*f**2*g2 - 2*D1*bd1*(-1260*D1*bd2*f*(r + s - 1)**2 + D1*(-5*f**3*(43*r**2 + 6*r*(16*s - 19) + 53*s**2 - 124*s + 71) + f**2*(10*fd*(159*r**2 + r*(360*s - 311) + 201*s**2 - 346*s + 136) + (r + s - 1)*(1224*K*r + 864*K*(s - 1) - 261*r - 297*s + 297)) - 6*f*(3*fd*(10*K*(36*r**2 + 68*r*s - 52*r + 32*s**2 - 49*s + 17) - 78*r**2 - 188*r*s + 133*r - 110*s**2 + 157*s - 47) + 14*g2*(19*r**2 + 38*r*s - 48*r + 19*s**2 - 48*s + 24) - 28*gd2*(37*r**2 + 74*r*s - 89*r + 37*s**2 - 89*s + 52)) + 6216*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(5*f**2*(212*r**2 + r*(480*s - 449) + 268*s**2 - 498*s + 221) - 9*f*(10*K*(72*r**2 + 8*r*(17*s - 15) + 64*s**2 - 113*s + 49) - 156*r**2 - 376*r*s + 321*r - 220*s**2 + 377*s - 157) + 84*g2*(148*r**2 + r*(296*s - 319) + 148*s**2 - 319*s + 156))) + 1680*Dd**2*f**4*r*s - 840*Dd**2*f**4*r + 1680*Dd**2*f**4*s**2 - 2100*Dd**2*f**4*s + 560*Dd**2*f**4 - 77760*Dd**2*f**2*g2*r**2 - 146880*Dd**2*f**2*g2*r*s + 112320*Dd**2*f**2*g2*r - 69120*Dd**2*f**2*g2*s**2 + 105840*Dd**2*f**2*g2*s - 36000*Dd**2*f**2*g2 - 105*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (20*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-20*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-20*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1**2*(532*D1**2*K*fd*r**2 + 1064*D1**2*K*fd*r*s + 280*D1**2*K*fd*r + 532*D1**2*K*fd*s**2 + 280*D1**2*K*fd*s - 140*D1**2*K*fd - 1036*D1**2*K*fdd*r**2 - 2072*D1**2*K*fdd*r*s - 840*D1**2*K*fdd*r - 1036*D1**2*K*fdd*s**2 - 840*D1**2*K*fdd*s + 420*D1**2*K*fdd - 35*D1**2*bdd1*(-20*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 210*D1**2*f*fd*r**2 - 756*D1**2*f*fd*r*s + 288*D1**2*f*fd*r - 546*D1**2*f*fd*s**2 + 456*D1**2*f*fd*s - 228*D1**2*f*fd + 294*D1**2*f*fdd*r**2 + 924*D1**2*f*fdd*r*s - 312*D1**2*f*fdd*r + 630*D1**2*f*fdd*s**2 - 480*D1**2*f*fdd*s + 240*D1**2*f*fdd + 294*D1**2*fd**2*r**2 + 924*D1**2*fd**2*r*s - 312*D1**2*fd**2*r + 630*D1**2*fd**2*s**2 - 480*D1**2*fd**2*s - 150*D1**2*fd**2 - 119*D1**2*fd*r**2 - 294*D1**2*fd*r*s - 70*D1**2*fd*r - 175*D1**2*fd*s**2 - 70*D1**2*fd*s + 35*D1**2*fd + 217*D1**2*fdd*r**2 + 602*D1**2*fdd*r*s + 210*D1**2*fdd*r + 385*D1**2*fdd*s**2 + 210*D1**2*fdd*s - 105*D1**2*fdd - 1400*D1**2*gd2*r**2 - 2800*D1**2*gd2*r*s + 2800*D1**2*gd2*r - 1400*D1**2*gd2*s**2 + 2800*D1**2*gd2*s - 1400*D1**2*gd2 - 1400*D1**2*gdd2*r**2 - 2800*D1**2*gdd2*r*s + 2800*D1**2*gdd2*r - 1400*D1**2*gdd2*s**2 + 2800*D1**2*gdd2*s - 1400*D1**2*gdd2 + 2128*D1*Dd*K*f*r**2 + 4256*D1*Dd*K*f*r*s - 3192*D1*Dd*K*f*r + 2128*D1*Dd*K*f*s**2 - 3192*D1*Dd*K*f*s + 1596*D1*Dd*K*f - 8288*D1*Dd*K*fd*r**2 - 16576*D1*Dd*K*fd*r*s + 2856*D1*Dd*K*fd*r - 8288*D1*Dd*K*fd*s**2 + 2856*D1*Dd*K*fd*s + 2520*D1*Dd*K*fd - 420*D1*Dd*f**2*r**2 - 1512*D1*Dd*f**2*r*s + 966*D1*Dd*f**2*r - 1092*D1*Dd*f**2*s**2 + 1470*D1*Dd*f**2*s - 651*D1*Dd*f**2 + 2352*D1*Dd*f*fd*r**2 + 7392*D1*Dd*f*fd*r*s - 3684*D1*Dd*f*fd*r + 5040*D1*Dd*f*fd*s**2 - 5364*D1*Dd*f*fd*s + 1272*D1*Dd*f*fd - 476*D1*Dd*f*r**2 - 1176*D1*Dd*f*r*s + 826*D1*Dd*f*r - 700*D1*Dd*f*s**2 + 994*D1*Dd*f*s - 469*D1*Dd*f + 1736*D1*Dd*fd*r**2 + 4816*D1*Dd*fd*r*s - 798*D1*Dd*fd*r + 3080*D1*Dd*fd*s**2 - 1302*D1*Dd*fd*s - 630*D1*Dd*fd - 5600*D1*Dd*g2*r**2 - 11200*D1*Dd*g2*r*s + 8400*D1*Dd*g2*r - 5600*D1*Dd*g2*s**2 + 8400*D1*Dd*g2*s - 4200*D1*Dd*g2 - 11200*D1*Dd*gd2*r**2 - 22400*D1*Dd*gd2*r*s + 19600*D1*Dd*gd2*r - 11200*D1*Dd*gd2*s**2 + 19600*D1*Dd*gd2*s - 8400*D1*Dd*gd2 - 4144*D1*Ddd*K*f*r**2 - 8288*D1*Ddd*K*f*r*s + 6216*D1*Ddd*K*f*r - 4144*D1*Ddd*K*f*s**2 + 6216*D1*Ddd*K*f*s - 3108*D1*Ddd*K*f + 588*D1*Ddd*f**2*r**2 + 1848*D1*Ddd*f**2*r*s - 1218*D1*Ddd*f**2*r + 1260*D1*Ddd*f**2*s**2 - 1722*D1*Ddd*f**2*s + 777*D1*Ddd*f**2 + 868*D1*Ddd*f*r**2 + 2408*D1*Ddd*f*r*s - 1638*D1*Ddd*f*r + 1540*D1*Ddd*f*s**2 - 2142*D1*Ddd*f*s + 987*D1*Ddd*f - 5600*D1*Ddd*g2*r**2 - 11200*D1*Ddd*g2*r*s + 8400*D1*Ddd*g2*r - 5600*D1*Ddd*g2*s**2 + 8400*D1*Ddd*g2*s - 4200*D1*Ddd*g2 + 35*D1*bd1*(D1*(f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (20*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-20*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 12432*Dd**2*K*f*r**2 - 24864*Dd**2*K*f*r*s + 18648*Dd**2*K*f*r - 12432*Dd**2*K*f*s**2 + 18648*Dd**2*K*f*s - 6216*Dd**2*K*f + 1764*Dd**2*f**2*r**2 + 5544*Dd**2*f**2*r*s - 3654*Dd**2*f**2*r + 3780*Dd**2*f**2*s**2 - 5166*Dd**2*f**2*s + 1554*Dd**2*f**2 + 2604*Dd**2*f*r**2 + 7224*Dd**2*f*r*s - 4914*Dd**2*f*r + 4620*Dd**2*f*s**2 - 6426*Dd**2*f*s + 1974*Dd**2*f - 16800*Dd**2*g2*r**2 - 33600*Dd**2*g2*r*s + 25200*Dd**2*g2*r - 16800*Dd**2*g2*s**2 + 25200*Dd**2*g2*s - 8400*Dd**2*g2) + b1*(6216*D1**2*K*bdd1*f*r**2 + 12432*D1**2*K*bdd1*f*r*s - 14952*D1**2*K*bdd1*f*r + 6216*D1**2*K*bdd1*f*s**2 - 14952*D1**2*K*bdd1*f*s + 7476*D1**2*K*bdd1*f - 4896*D1**2*K*f*fd*r**2 - 8352*D1**2*K*f*fd*r*s + 4896*D1**2*K*f*fd*r - 3456*D1**2*K*f*fd*s**2 + 4176*D1**2*K*f*fd*s - 2448*D1**2*K*f*fd + 6480*D1**2*K*f*fdd*r**2 + 12240*D1**2*K*f*fdd*r*s - 6480*D1**2*K*f*fdd*r + 5760*D1**2*K*f*fdd*s**2 - 6120*D1**2*K*f*fdd*s + 3240*D1**2*K*f*fdd + 6480*D1**2*K*fd**2*r**2 + 12240*D1**2*K*fd**2*r*s - 6480*D1**2*K*fd**2*r + 5760*D1**2*K*fd**2*s**2 - 6120*D1**2*K*fd**2*s - 420*D1**2*b2*fd*r**2 - 840*D1**2*b2*fd*r*s - 420*D1**2*b2*fd*s**2 + 1260*D1**2*b2*fdd*r**2 + 2520*D1**2*b2*fdd*r*s + 1260*D1**2*b2*fdd*s**2 + 210*D1**2*bd1**2*(-20*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 882*D1**2*bdd1*f**2*r**2 - 2772*D1**2*bdd1*f**2*r*s + 2718*D1**2*bdd1*f**2*r - 1890*D1**2*bdd1*f**2*s**2 + 3726*D1**2*bdd1*f**2*s - 1611*D1**2*bdd1*f**2 - 1302*D1**2*bdd1*f*r**2 - 3612*D1**2*bdd1*f*r*s + 3738*D1**2*bdd1*f*r - 2310*D1**2*bdd1*f*s**2 + 4746*D1**2*bdd1*f*s - 2121*D1**2*bdd1*f + 8400*D1**2*bdd1*g2*r**2 + 16800*D1**2*bdd1*g2*r*s - 8400*D1**2*bdd1*g2*r + 8400*D1**2*bdd1*g2*s**2 - 8400*D1**2*bdd1*g2*s + 4200*D1**2*bdd1*g2 + 1260*D1**2*bdd2*f*r**2 + 2520*D1**2*bdd2*f*r*s - 2520*D1**2*bdd2*f*r + 1260*D1**2*bdd2*f*s**2 - 2520*D1**2*bdd2*f*s + 1260*D1**2*bdd2*f + 1290*D1**2*f**2*fd*r**2 + 2880*D1**2*f**2*fd*r*s - 1640*D1**2*f**2*fd*r + 1590*D1**2*f**2*fd*s**2 - 1840*D1**2*f**2*fd*s + 780*D1**2*f**2*fd - 1590*D1**2*f**2*fdd*r**2 - 3600*D1**2*f**2*fdd*r*s + 2080*D1**2*f**2*fdd*r - 2010*D1**2*f**2*fdd*s**2 + 2360*D1**2*f**2*fdd*s - 1020*D1**2*f**2*fdd - 3180*D1**2*f*fd**2*r**2 - 7200*D1**2*f*fd**2*r*s + 4160*D1**2*f*fd**2*r - 4020*D1**2*f*fd**2*s**2 + 4720*D1**2*f*fd**2*s - 1020*D1**2*f*fd**2 + 1044*D1**2*f*fd*r**2 + 2232*D1**2*f*fd*r*s - 1044*D1**2*f*fd*r + 1188*D1**2*f*fd*s**2 - 1116*D1**2*f*fd*s + 522*D1**2*f*fd - 1404*D1**2*f*fdd*r**2 - 3384*D1**2*f*fdd*r*s + 1404*D1**2*f*fdd*r - 1980*D1**2*f*fdd*s**2 + 1692*D1**2*f*fdd*s - 702*D1**2*f*fdd + 3192*D1**2*f*gd2*r**2 + 6384*D1**2*f*gd2*r*s - 6384*D1**2*f*gd2*r + 3192*D1**2*f*gd2*s**2 - 6384*D1**2*f*gd2*s + 3192*D1**2*f*gd2 - 6216*D1**2*f*gdd2*r**2 - 12432*D1**2*f*gdd2*r*s + 12432*D1**2*f*gdd2*r - 6216*D1**2*f*gdd2*s**2 + 12432*D1**2*f*gdd2*s - 6216*D1**2*f*gdd2 - 1404*D1**2*fd**2*r**2 - 3384*D1**2*fd**2*r*s + 1404*D1**2*fd**2*r - 1980*D1**2*fd**2*s**2 + 1692*D1**2*fd**2*s + 3192*D1**2*fd*g2*r**2 + 6384*D1**2*fd*g2*r*s + 1680*D1**2*fd*g2*r + 3192*D1**2*fd*g2*s**2 + 1680*D1**2*fd*g2*s - 840*D1**2*fd*g2 - 12432*D1**2*fd*gd2*r**2 - 24864*D1**2*fd*gd2*r*s + 7392*D1**2*fd*gd2*r - 12432*D1**2*fd*gd2*s**2 + 7392*D1**2*fd*gd2*s + 5040*D1**2*fd*gd2 - 6216*D1**2*fdd*g2*r**2 - 12432*D1**2*fdd*g2*r*s - 5040*D1**2*fdd*g2*r - 6216*D1**2*fdd*g2*s**2 - 5040*D1**2*fdd*g2*s + 2520*D1**2*fdd*g2 - 9792*D1*Dd*K*f**2*r**2 - 16704*D1*Dd*K*f**2*r*s + 13248*D1*Dd*K*f**2*r - 6912*D1*Dd*K*f**2*s**2 + 11088*D1*Dd*K*f**2*s - 5904*D1*Dd*K*f**2 + 51840*D1*Dd*K*f*fd*r**2 + 97920*D1*Dd*K*f*fd*r*s - 63360*D1*Dd*K*f*fd*r + 46080*D1*Dd*K*f*fd*s**2 - 59760*D1*Dd*K*f*fd*s + 18720*D1*Dd*K*f*fd - 1680*D1*Dd*b2*f*r**2 - 3360*D1*Dd*b2*f*r*s + 2520*D1*Dd*b2*f*r - 1680*D1*Dd*b2*f*s**2 + 2520*D1*Dd*b2*f*s - 1260*D1*Dd*b2*f + 10080*D1*Dd*b2*fd*r**2 + 20160*D1*Dd*b2*fd*r*s - 7560*D1*Dd*b2*fd*r + 10080*D1*Dd*b2*fd*s**2 - 7560*D1*Dd*b2*fd*s + 1720*D1*Dd*f**3*r**2 + 3840*D1*Dd*f**3*r*s - 2780*D1*Dd*f**3*r + 2120*D1*Dd*f**3*s**2 - 3080*D1*Dd*f**3*s + 1490*D1*Dd*f**3 - 12720*D1*Dd*f**2*fd*r**2 - 28800*D1*Dd*f**2*fd*r*s + 18700*D1*Dd*f**2*fd*r - 16080*D1*Dd*f**2*fd*s**2 + 21080*D1*Dd*f**2*fd*s - 6800*D1*Dd*f**2*fd + 2088*D1*Dd*f**2*r**2 + 4464*D1*Dd*f**2*r*s - 3276*D1*Dd*f**2*r + 2376*D1*Dd*f**2*s**2 - 3492*D1*Dd*f**2*s + 1710*D1*Dd*f**2 - 11232*D1*Dd*f*fd*r**2 - 27072*D1*Dd*f*fd*r*s + 15192*D1*Dd*f*fd*r - 15840*D1*Dd*f*fd*s**2 + 18072*D1*Dd*f*fd*s - 4788*D1*Dd*f*fd + 12768*D1*Dd*f*g2*r**2 + 25536*D1*Dd*f*g2*r*s - 19152*D1*Dd*f*g2*r + 12768*D1*Dd*f*g2*s**2 - 19152*D1*Dd*f*g2*s + 9576*D1*Dd*f*g2 - 49728*D1*Dd*f*gd2*r**2 - 99456*D1*Dd*f*gd2*r*s + 87024*D1*Dd*f*gd2*r - 49728*D1*Dd*f*gd2*s**2 + 87024*D1*Dd*f*gd2*s - 37296*D1*Dd*f*gd2 - 49728*D1*Dd*fd*g2*r**2 - 99456*D1*Dd*fd*g2*r*s + 17136*D1*Dd*fd*g2*r - 49728*D1*Dd*fd*g2*s**2 + 17136*D1*Dd*fd*g2*s + 15120*D1*Dd*fd*g2 + 12960*D1*Ddd*K*f**2*r**2 + 24480*D1*Ddd*K*f**2*r*s - 18720*D1*Ddd*K*f**2*r + 11520*D1*Ddd*K*f**2*s**2 - 17640*D1*Ddd*K*f**2*s + 9000*D1*Ddd*K*f**2 + 5040*D1*Ddd*b2*f*r**2 + 10080*D1*Ddd*b2*f*r*s - 7560*D1*Ddd*b2*f*r + 5040*D1*Ddd*b2*f*s**2 - 7560*D1*Ddd*b2*f*s + 3780*D1*Ddd*b2*f - 2120*D1*Ddd*f**3*r**2 - 4800*D1*Ddd*f**3*r*s + 3460*D1*Ddd*f**3*r - 2680*D1*Ddd*f**3*s**2 + 3880*D1*Ddd*f**3*s - 1870*D1*Ddd*f**3 - 2808*D1*Ddd*f**2*r**2 - 6768*D1*Ddd*f**2*r*s + 4788*D1*Ddd*f**2*r - 3960*D1*Ddd*f**2*s**2 + 5652*D1*Ddd*f**2*s - 2682*D1*Ddd*f**2 - 24864*D1*Ddd*f*g2*r**2 - 49728*D1*Ddd*f*g2*r*s + 37296*D1*Ddd*f*g2*r - 24864*D1*Ddd*f*g2*s**2 + 37296*D1*Ddd*f*g2*s - 18648*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(3*f**2*(70*r**2 + r*(252*s - 226) + 182*s**2 - 338*s + 141) - 7*f*(4*K*(38*r**2 + 76*r*s - 86*r + 38*s**2 - 86*s + 43) + 12*fd*(14*r**2 + r*(44*s - 29) + 30*s**2 - 41*s + 13) - 34*r**2 - 84*r*s + 86*r - 50*s**2 + 102*s - 47) + 14*fd*(4*K*(74*r**2 + 148*r*s - 59*r + 74*s**2 - 59*s - 15) - 62*r**2 - 172*r*s + 59*r - 110*s**2 + 83*s + 15) + 1400*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2800*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(-3*f**2*(392*r**2 + 2*r*(616*s - 505) + 840*s**2 - 1402*s + 565) + 7*f*(4*K*(296*r**2 + 592*r*s - 578*r + 296*s**2 - 578*s + 267) - 248*r**2 - 688*r*s + 590*r - 440*s**2 + 758*s - 315) + 1400*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 420*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 38880*Dd**2*K*f**2*r**2 + 73440*Dd**2*K*f**2*r*s - 56160*Dd**2*K*f**2*r + 34560*Dd**2*K*f**2*s**2 - 52920*Dd**2*K*f**2*s + 18000*Dd**2*K*f**2 + 15120*Dd**2*b2*f*r**2 + 30240*Dd**2*b2*f*r*s - 22680*Dd**2*b2*f*r + 15120*Dd**2*b2*f*s**2 - 22680*Dd**2*b2*f*s + 7560*Dd**2*b2*f - 6360*Dd**2*f**3*r**2 - 14400*Dd**2*f**3*r*s + 10380*Dd**2*f**3*r - 8040*Dd**2*f**3*s**2 + 11640*Dd**2*f**3*s - 3740*Dd**2*f**3 - 8424*Dd**2*f**2*r**2 - 20304*Dd**2*f**2*r*s + 14364*Dd**2*f**2*r - 11880*Dd**2*f**2*s**2 + 16956*Dd**2*f**2*s - 5364*Dd**2*f**2 - 74592*Dd**2*f*g2*r**2 - 149184*Dd**2*f*g2*r*s + 111888*Dd**2*f*g2*r - 74592*Dd**2*f*g2*s**2 + 111888*Dd**2*f*g2*s - 37296*Dd**2*f*g2) - 60*b2*(-21*D1**2*bdd1*f*(r + s - 1)**2 - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 7*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**5) + D1**2*Pk1*Pkd3*ct*k1**3*st**2*(4*C - 2)*(D1*b1*(D1*(-11*f*fd*s + 3*f*s*(-7*bdd1*(2*r + 2*s - 1) + 3*fdd) + 9*fd**2*(s - 1)) + 18*Dd*f*fd*(2*s - 1) - 7*bd1*(D1*(f*s*(-2*r - 2*s + 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 6*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1))) + 7*b1**2*(D1**2*(fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-21*D1**2*bd1**2*s*(2*r + 2*s - 1) + D1**2*(f*(-9*bdd1*s - 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(11*D1*f*s - 9*D1*fd*(s - 1) + 18*Dd*f*(1 - 2*s)) + D1*f*(Dd*(-7*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 5*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) + 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k2*k3**3) - D1**2*Pk1*Pkd3*ct*k1**3*(4*C - 2)*(7*D1*b1*(D1*(-3*f*fd*s + f*s*(-5*bdd1*(2*r + 2*s - 1) + 3*fdd) + 3*fd**2*(s - 1)) + 6*Dd*f*fd*(2*s - 1) - 5*bd1*(D1*(f*s*(-2*r - 2*s + 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1))) + 35*b1**2*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(-35*D1**2*bd1**2*s*(2*r + 2*s - 1) - 3*D1**2*(f*(7*bdd1*s + 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 21*D1*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s)) - 15*D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + 15*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k2*k3**3) + D1**2*Pk1*Pkd3*ct*k1*k2**5*st**6*(4*C - 3)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(14*d**2*k3**7) - 3*D1**2*Pk1*Pkd3*ct*k1*k2**5*st**4*(396*C*D1**2*f**2*fd*r**2 + 792*C*D1**2*f**2*fd*r*s - 528*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 528*C*D1**2*f**2*fd*s + 264*C*D1**2*f**2*fd + 528*C*D1*Dd*f**3*r**2 + 1056*C*D1*Dd*f**3*r*s - 792*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 792*C*D1*Dd*f**3*s + 396*C*D1*Dd*f**3 + 66*D1**2*K*bdd1*f**2*r**2 + 132*D1**2*K*bdd1*f**2*r*s - 132*D1**2*K*bdd1*f**2*r + 66*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s + 66*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(-14*K + 25*f + 7)*(r + s - 1)**2 + 275*D1**2*bdd1*f**3*r**2 + 550*D1**2*bdd1*f**3*r*s - 550*D1**2*bdd1*f**3*r + 275*D1**2*bdd1*f**3*s**2 - 550*D1**2*bdd1*f**3*s + 275*D1**2*bdd1*f**3 - 33*D1**2*bdd1*f**2*r**2 - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r - 33*D1**2*bdd1*f**2*s**2 + 66*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 - 924*D1**2*bdd1*f*g2*r**2 - 1848*D1**2*bdd1*f*g2*r*s + 1848*D1**2*bdd1*f*g2*r - 924*D1**2*bdd1*f*g2*s**2 + 1848*D1**2*bdd1*f*g2*s - 924*D1**2*bdd1*f*g2 - 1516*D1**2*f**3*fd*r**2 - 3032*D1**2*f**3*fd*r*s + 2274*D1**2*f**3*fd*r - 1516*D1**2*f**3*fd*s**2 + 2274*D1**2*f**3*fd*s - 1137*D1**2*f**3*fd + 1000*D1**2*f**3*fdd*r**2 + 2000*D1**2*f**3*fdd*r*s - 1500*D1**2*f**3*fdd*r + 1000*D1**2*f**3*fdd*s**2 - 1500*D1**2*f**3*fdd*s + 750*D1**2*f**3*fdd + 3000*D1**2*f**2*fd**2*r**2 + 6000*D1**2*f**2*fd**2*r*s - 4500*D1**2*f**2*fd**2*r + 3000*D1**2*f**2*fd**2*s**2 - 4500*D1**2*f**2*fd**2*s + 1500*D1**2*f**2*fd**2 - 297*D1**2*f**2*fd*r**2 - 594*D1**2*f**2*fd*r*s + 396*D1**2*f**2*fd*r - 297*D1**2*f**2*fd*s**2 + 396*D1**2*f**2*fd*s - 198*D1**2*f**2*fd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 1516*D1*Dd*f**4*r**2 - 3032*D1*Dd*f**4*r*s + 2274*D1*Dd*f**4*r - 1516*D1*Dd*f**4*s**2 + 2274*D1*Dd*f**4*s - 1137*D1*Dd*f**4 + 8000*D1*Dd*f**3*fd*r**2 + 16000*D1*Dd*f**3*fd*r*s - 12000*D1*Dd*f**3*fd*r + 8000*D1*Dd*f**3*fd*s**2 - 12000*D1*Dd*f**3*fd*s + 4500*D1*Dd*f**3*fd - 396*D1*Dd*f**3*r**2 - 792*D1*Dd*f**3*r*s + 594*D1*Dd*f**3*r - 396*D1*Dd*f**3*s**2 + 594*D1*Dd*f**3*s - 297*D1*Dd*f**3 + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 1000*D1*Ddd*f**4*r**2 + 2000*D1*Ddd*f**4*r*s - 1500*D1*Ddd*f**4*r + 1000*D1*Ddd*f**4*s**2 - 1500*D1*Ddd*f**4*s + 750*D1*Ddd*f**4 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(23*f**3*(r + s - 1) + f**2*(-84*C*(r + s - 1) - 50*fd*(3*r + 3*s - 2) + (12*K + 57)*(r + s - 1)) - 6*f*(fd*(2*K - 1)*(2*r + 2*s - 1) + (28*g2 - 28*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 2*Dd*f*(25*f**2 + f*(6*K - 3) - 84*g2)*(4*r + 4*s - 3))*(r + s - 1) + 3000*Dd**2*f**4*r**2 + 6000*Dd**2*f**4*r*s - 4500*Dd**2*f**4*r + 3000*Dd**2*f**4*s**2 - 4500*Dd**2*f**4*s + 1500*Dd**2*f**4 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(25*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 25*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 25*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(168*C*D1**2*f*fd*r**2 + 336*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r + 168*C*D1**2*f*fd*s**2 - 168*C*D1**2*f*fd*s + 84*C*D1**2*f*fd + 336*C*D1*Dd*f**2*r**2 + 672*C*D1*Dd*f**2*r*s - 504*C*D1*Dd*f**2*r + 336*C*D1*Dd*f**2*s**2 - 504*C*D1*Dd*f**2*s + 252*C*D1*Dd*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 12*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 12*D1**2*K*f*fdd*s**2 - 12*D1**2*K*f*fdd*s + 6*D1**2*K*f*fdd + 12*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 12*D1**2*K*fd**2*s**2 - 12*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-14*K + 25*f + 7)*(r + s - 1)**2 - 69*D1**2*f**2*fd*r**2 - 138*D1**2*f**2*fd*r*s + 92*D1**2*f**2*fd*r - 69*D1**2*f**2*fd*s**2 + 92*D1**2*f**2*fd*s - 46*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 - 114*D1**2*f*fd*r**2 - 228*D1**2*f*fd*r*s + 114*D1**2*f*fd*r - 114*D1**2*f*fd*s**2 + 114*D1**2*f*fd*s - 57*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 3*D1**2*f*fdd + 168*D1**2*f*gd2*r**2 + 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r + 168*D1**2*f*gd2*s**2 - 336*D1**2*f*gd2*s + 168*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s + 168*D1**2*fd*g2*r**2 + 336*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 96*D1*Dd*K*f*fd*r**2 + 192*D1*Dd*K*f*fd*r*s - 120*D1*Dd*K*f*fd*r + 96*D1*Dd*K*f*fd*s**2 - 120*D1*Dd*K*f*fd*s + 36*D1*Dd*K*f*fd - 92*D1*Dd*f**3*r**2 - 184*D1*Dd*f**3*r*s + 138*D1*Dd*f**3*r - 92*D1*Dd*f**3*s**2 + 138*D1*Dd*f**3*s - 69*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 850*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 850*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd - 228*D1*Dd*f**2*r**2 - 456*D1*Dd*f**2*r*s + 342*D1*Dd*f**2*r - 228*D1*Dd*f**2*s**2 + 342*D1*Dd*f**2*s - 171*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 18*D1*Dd*f*fd + 672*D1*Dd*f*g2*r**2 + 1344*D1*Dd*f*g2*r*s - 1008*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 1008*D1*Dd*f*g2*s + 504*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s + 24*D1*Ddd*K*f**2*r**2 + 48*D1*Ddd*K*f**2*r*s - 36*D1*Ddd*K*f**2*r + 24*D1*Ddd*K*f**2*s**2 - 36*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 - 12*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 18*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 12*D1*bd1*(D1*(18*f**2*(r + s - 1) - 25*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 25*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 72*Dd**2*K*f**2*r**2 + 144*Dd**2*K*f**2*r*s - 108*Dd**2*K*f**2*r + 72*Dd**2*K*f**2*s**2 - 108*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 - 36*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 54*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 18*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(770*d**2*k3**7) + D1**2*Pk1*Pkd3*ct*k1*k2**3*st**6*(8*C - 6)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(63*d**2*k3**5) + D1**2*Pk1*Pkd3*ct*k1*k2**3*st**4*(105*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-1120*C*D1**2*f*fd*r**2 - 2208*C*D1**2*f*fd*r*s + 1024*C*D1**2*f*fd*r - 1088*C*D1**2*f*fd*s**2 + 1008*C*D1**2*f*fd*s - 504*C*D1**2*f*fd + 1008*C*D1**2*f*fdd*r**2 + 2000*C*D1**2*f*fdd*r*s - 960*C*D1**2*f*fdd*r + 992*C*D1**2*f*fdd*s**2 - 952*C*D1**2*f*fdd*s + 476*C*D1**2*f*fdd + 1008*C*D1**2*fd**2*r**2 + 2000*C*D1**2*fd**2*r*s - 960*C*D1**2*fd**2*r + 992*C*D1**2*fd**2*s**2 - 952*C*D1**2*fd**2*s - 40*C*D1**2*fd**2 - 2240*C*D1*Dd*f**2*r**2 - 4416*C*D1*Dd*f**2*r*s + 3328*C*D1*Dd*f**2*r - 2176*C*D1*Dd*f**2*s**2 + 3280*C*D1*Dd*f**2*s - 1648*C*D1*Dd*f**2 + 8064*C*D1*Dd*f*fd*r**2 + 16000*C*D1*Dd*f*fd*r*s - 9856*C*D1*Dd*f*fd*r + 7936*C*D1*Dd*f*fd*s**2 - 9776*C*D1*Dd*f*fd*s + 2864*C*D1*Dd*f*fd + 2016*C*D1*Ddd*f**2*r**2 + 4000*C*D1*Ddd*f**2*r*s - 3008*C*D1*Ddd*f**2*r + 1984*C*D1*Ddd*f**2*s**2 - 2984*C*D1*Ddd*f**2*s + 1496*C*D1*Ddd*f**2 + 6048*C*Dd**2*f**2*r**2 + 12000*C*Dd**2*f**2*r*s - 9024*C*Dd**2*f**2*r + 5952*C*Dd**2*f**2*s**2 - 8952*C*Dd**2*f**2*s + 2992*C*Dd**2*f**2 - 35*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 772*D1**2*f*fd*r**2 + 1504*D1**2*f*fd*r*s - 692*D1**2*f*fd*r + 732*D1**2*f*fd*s**2 - 672*D1**2*f*fd*s + 336*D1**2*f*fd - 708*D1**2*f*fdd*r**2 - 1424*D1**2*f*fdd*r*s + 682*D1**2*f*fdd*r - 716*D1**2*f*fdd*s**2 + 686*D1**2*f*fdd*s - 343*D1**2*f*fdd - 708*D1**2*fd**2*r**2 - 1424*D1**2*fd**2*r*s + 682*D1**2*fd**2*r - 716*D1**2*fd**2*s**2 + 686*D1**2*fd**2*s + 30*D1**2*fd**2 + 1544*D1*Dd*f**2*r**2 + 3008*D1*Dd*f**2*r*s - 2276*D1*Dd*f**2*r + 1464*D1*Dd*f**2*s**2 - 2216*D1*Dd*f**2*s + 1118*D1*Dd*f**2 - 5664*D1*Dd*f*fd*r**2 - 11392*D1*Dd*f*fd*r*s + 6992*D1*Dd*f*fd*r - 5728*D1*Dd*f*fd*s**2 + 7032*D1*Dd*f*fd*s - 2054*D1*Dd*f*fd - 1416*D1*Ddd*f**2*r**2 - 2848*D1*Ddd*f**2*r*s + 2132*D1*Ddd*f**2*r - 1432*D1*Ddd*f**2*s**2 + 2144*D1*Ddd*f**2*s - 1070*D1*Ddd*f**2 + 70*D1*bd1*(4*C - 3)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 4248*Dd**2*f**2*r**2 - 8544*Dd**2*f**2*r*s + 6396*Dd**2*f**2*r - 4296*Dd**2*f**2*s**2 + 6432*Dd**2*f**2*s - 2140*Dd**2*f**2) + f*(-2568*C*D1**2*f*fd*r**2 - 4224*C*D1**2*f*fd*r*s + 3120*C*D1**2*f*fd*r - 1656*C*D1**2*f*fd*s**2 + 2512*C*D1**2*f*fd*s - 1408*C*D1**2*f*fd + 1860*C*D1**2*f*fdd*r**2 + 2976*C*D1**2*f*fdd*r*s - 2232*C*D1**2*f*fdd*r + 1116*C*D1**2*f*fdd*s**2 - 1736*C*D1**2*f*fdd*s + 992*C*D1**2*f*fdd + 3720*C*D1**2*fd**2*r**2 + 5952*C*D1**2*fd**2*r*s - 4464*C*D1**2*fd**2*r + 2232*C*D1**2*fd**2*s**2 - 3472*C*D1**2*fd**2*s + 992*C*D1**2*fd**2 - 3424*C*D1*Dd*f**2*r**2 - 5632*C*D1*Dd*f**2*r*s + 4528*C*D1*Dd*f**2*r - 2208*C*D1*Dd*f**2*s**2 + 3616*C*D1*Dd*f**2*s - 1960*C*D1*Dd*f**2 + 14880*C*D1*Dd*f*fd*r**2 + 23808*C*D1*Dd*f*fd*r*s - 18600*C*D1*Dd*f*fd*r + 8928*C*D1*Dd*f*fd*s**2 - 14384*C*D1*Dd*f*fd*s + 5704*C*D1*Dd*f*fd + 2480*C*D1*Ddd*f**2*r**2 + 3968*C*D1*Ddd*f**2*r*s - 3224*C*D1*Ddd*f**2*r + 1488*C*D1*Ddd*f**2*s**2 - 2480*C*D1*Ddd*f**2*s + 1364*C*D1*Ddd*f**2 + 7440*C*Dd**2*f**2*r**2 + 11904*C*Dd**2*f**2*r*s - 9672*C*Dd**2*f**2*r + 4464*C*Dd**2*f**2*s**2 - 7440*C*Dd**2*f**2*s + 2728*C*Dd**2*f**2 - 210*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*D1**2*bdd1*f*(4*C*(126*r**2 + 250*r*s - 262*r + 124*s**2 - 260*s + 131) - 354*r**2 - 712*r*s + 738*r - 358*s**2 + 742*s - 369) + 1752*D1**2*f*fd*r**2 + 2892*D1**2*f*fd*r*s - 2132*D1**2*f*fd*r + 1140*D1**2*f*fd*s**2 - 1724*D1**2*f*fd*s + 964*D1**2*f*fd - 1263*D1**2*f*fdd*r**2 - 2058*D1**2*f*fdd*r*s + 1528*D1**2*f*fdd*r - 795*D1**2*f*fdd*s**2 + 1216*D1**2*f*fdd*s - 686*D1**2*f*fdd - 2526*D1**2*fd**2*r**2 - 4116*D1**2*fd**2*r*s + 3056*D1**2*fd**2*r - 1590*D1**2*fd**2*s**2 + 2432*D1**2*fd**2*s - 686*D1**2*fd**2 + 2336*D1*Dd*f**2*r**2 + 3856*D1*Dd*f**2*r*s - 3096*D1*Dd*f**2*r + 1520*D1*Dd*f**2*s**2 - 2484*D1*Dd*f**2*s + 1344*D1*Dd*f**2 - 10104*D1*Dd*f*fd*r**2 - 16464*D1*Dd*f*fd*r*s + 12754*D1*Dd*f*fd*r - 6360*D1*Dd*f*fd*s**2 + 10102*D1*Dd*f*fd*s - 3960*D1*Dd*f*fd - 1684*D1*Ddd*f**2*r**2 - 2744*D1*Ddd*f**2*r*s + 2214*D1*Ddd*f**2*r - 1060*D1*Ddd*f**2*s**2 + 1746*D1*Ddd*f**2*s - 951*D1*Ddd*f**2 - 6*D1*bd1*(D1*(f*(4*C*(70*r**2 + 6*r*(23*s - 25) + 68*s**2 - 148*s + 75) - 193*r**2 - 376*r*s + 416*r - 183*s**2 + 406*s - 208) + fd*(-4*C*(252*r**2 + 500*r*s - 382*r + 248*s**2 - 379*s + 130) + 708*r**2 + 1424*r*s - 1079*r + 716*s**2 - 1085*s + 371)) + Dd*f*(-4*C*(504*r**2 + 100*r*(10*s - 9) + 496*s**2 - 893*s + 391) + 1416*r**2 + 2848*r*s - 2542*r + 1432*s**2 - 2556*s + 1111)) - 5052*Dd**2*f**2*r**2 - 8232*Dd**2*f**2*r*s + 6642*Dd**2*f**2*r - 3180*Dd**2*f**2*s**2 + 5238*Dd**2*f**2*s - 1902*Dd**2*f**2))/(210*d**2*k3**5) - D1**2*Pk1*Pkd3*ct*k1*k2**3*st**2*(-22176*C*D1**2*bd1*f**2*r**2 - 31416*C*D1**2*bd1*f**2*r*s + 53592*C*D1**2*bd1*f**2*r - 9240*C*D1**2*bd1*f**2*s**2 + 40656*C*D1**2*bd1*f**2*s - 26796*C*D1**2*bd1*f**2 - 34452*C*D1**2*f**2*fd*r**2 - 52272*C*D1**2*f**2*fd*r*s + 40392*C*D1**2*f**2*fd*r - 17820*C*D1**2*f**2*fd*s**2 + 29304*C*D1**2*f**2*fd*s - 17424*C*D1**2*f**2*fd - 45936*C*D1*Dd*f**3*r**2 - 69696*C*D1*Dd*f**3*r*s + 57816*C*D1*Dd*f**3*r - 23760*C*D1*Dd*f**3*s**2 + 41184*C*D1*Dd*f**3*s - 23364*C*D1*Dd*f**3 - 73920*D1**2*K*bd1**2*f*r**2 - 131208*D1**2*K*bd1**2*f*r*s + 144144*D1**2*K*bd1**2*f*r - 57288*D1**2*K*bd1**2*f*s**2 + 127512*D1**2*K*bd1**2*f*s - 70224*D1**2*K*bd1**2*f + 24948*D1**2*K*bd1*f**2*r**2 + 38808*D1**2*K*bd1*f**2*r*s - 38808*D1**2*K*bd1*f**2*r + 13860*D1**2*K*bd1*f**2*s**2 - 27720*D1**2*K*bd1*f**2*s + 13860*D1**2*K*bd1*f**2 - 75768*D1**2*K*bd1*f*fd*r**2 - 118272*D1**2*K*bd1*f*fd*r*s + 97020*D1**2*K*bd1*f*fd*r - 42504*D1**2*K*bd1*f*fd*s**2 + 72072*D1**2*K*bd1*f*fd*s - 29568*D1**2*K*bd1*f*fd - 18942*D1**2*K*bdd1*f**2*r**2 - 29568*D1**2*K*bdd1*f**2*r*s + 29568*D1**2*K*bdd1*f**2*r - 10626*D1**2*K*bdd1*f**2*s**2 + 21252*D1**2*K*bdd1*f**2*s - 10626*D1**2*K*bdd1*f**2 + 46926*D1**2*bd1**2*f**2*r**2 + 104940*D1**2*bd1**2*f**2*r*s - 99396*D1**2*bd1**2*f**2*r + 58014*D1**2*bd1**2*f**2*s**2 - 110484*D1**2*bd1**2*f**2*s + 52470*D1**2*bd1**2*f**2 + 36960*D1**2*bd1**2*f*r**2 + 68376*D1**2*bd1**2*f*r*s - 73458*D1**2*bd1**2*f*r + 31416*D1**2*bd1**2*f*s**2 - 67914*D1**2*bd1**2*f*s + 36498*D1**2*bd1**2*f - 46200*D1**2*bd1**2*g2*r**2 - 92400*D1**2*bd1**2*g2*r*s + 46200*D1**2*bd1**2*g2*r - 46200*D1**2*bd1**2*g2*s**2 + 46200*D1**2*bd1**2*g2*s - 27720*D1**2*bd1*bd2*f*r**2 - 55440*D1**2*bd1*bd2*f*r*s + 55440*D1**2*bd1*bd2*f*r - 27720*D1**2*bd1*bd2*f*s**2 + 55440*D1**2*bd1*bd2*f*s - 27720*D1**2*bd1*bd2*f - 11814*D1**2*bd1*f**3*r**2 - 15972*D1**2*bd1*f**3*r*s + 17094*D1**2*bd1*f**3*r - 4158*D1**2*bd1*f**3*s**2 + 9438*D1**2*bd1*f**3*s - 7755*D1**2*bd1*f**3 + 65142*D1**2*bd1*f**2*fd*r**2 + 81180*D1**2*bd1*f**2*fd*r*s - 80718*D1**2*bd1*f**2*fd*r + 16038*D1**2*bd1*f**2*fd*s**2 - 39798*D1**2*bd1*f**2*fd*s + 16368*D1**2*bd1*f**2*fd + 2508*D1**2*bd1*f**2*r**2 - 528*D1**2*bd1*f**2*r*s - 16566*D1**2*bd1*f**2*r - 3036*D1**2*bd1*f**2*s**2 - 11022*D1**2*bd1*f**2*s + 10593*D1**2*bd1*f**2 + 34716*D1**2*bd1*f*fd*r**2 + 58344*D1**2*bd1*f*fd*r*s - 46530*D1**2*bd1*f*fd*r + 23628*D1**2*bd1*f*fd*s**2 - 38214*D1**2*bd1*f*fd*s + 14586*D1**2*bd1*f*fd - 73920*D1**2*bd1*f*g2*r**2 - 114576*D1**2*bd1*f*g2*r*s + 166320*D1**2*bd1*f*g2*r - 40656*D1**2*bd1*f*g2*s**2 + 133056*D1**2*bd1*f*g2*s - 83160*D1**2*bd1*f*g2 + 147840*D1**2*bd1*f*gd2*r**2 + 262416*D1**2*bd1*f*gd2*r*s - 288288*D1**2*bd1*f*gd2*r + 114576*D1**2*bd1*f*gd2*s**2 - 255024*D1**2*bd1*f*gd2*s + 140448*D1**2*bd1*f*gd2 + 147840*D1**2*bd1*fd*g2*r**2 + 262416*D1**2*bd1*fd*g2*r*s - 147840*D1**2*bd1*fd*g2*r + 114576*D1**2*bd1*fd*g2*s**2 - 131208*D1**2*bd1*fd*g2*s + 9570*D1**2*bd2*f**2*r**2 + 19140*D1**2*bd2*f**2*r*s - 19140*D1**2*bd2*f**2*r + 9570*D1**2*bd2*f**2*s**2 - 19140*D1**2*bd2*f**2*s + 9570*D1**2*bd2*f**2 - 23760*D1**2*bd2*f*fd*r**2 - 47520*D1**2*bd2*f*fd*r*s + 35640*D1**2*bd2*f*fd*r - 23760*D1**2*bd2*f*fd*s**2 + 35640*D1**2*bd2*f*fd*s - 11880*D1**2*bd2*f*fd + 10857*D1**2*bdd1*f**3*r**2 + 13530*D1**2*bdd1*f**3*r*s - 15972*D1**2*bdd1*f**3*r + 2673*D1**2*bdd1*f**3*s**2 - 7788*D1**2*bdd1*f**3*s + 7590*D1**2*bdd1*f**3 + 8679*D1**2*bdd1*f**2*r**2 + 14586*D1**2*bdd1*f**2*r*s - 14586*D1**2*bdd1*f**2*r + 5907*D1**2*bdd1*f**2*s**2 - 11814*D1**2*bdd1*f**2*s + 5907*D1**2*bdd1*f**2 + 73920*D1**2*bdd1*f*g2*r**2 + 131208*D1**2*bdd1*f*g2*r*s - 157080*D1**2*bdd1*f*g2*r + 57288*D1**2*bdd1*f*g2*s**2 - 140448*D1**2*bdd1*f*g2*s + 78540*D1**2*bdd1*f*g2 - 5940*D1**2*bdd2*f**2*r**2 - 11880*D1**2*bdd2*f**2*r*s + 11880*D1**2*bdd2*f**2*r - 5940*D1**2*bdd2*f**2*s**2 + 11880*D1**2*bdd2*f**2*s - 5940*D1**2*bdd2*f**2 + 16460*D1**2*f**3*fd*r**2 + 42200*D1**2*f**3*fd*r*s - 29330*D1**2*f**3*fd*r + 25740*D1**2*f**3*fd*s**2 - 36290*D1**2*f**3*fd*s + 16985*D1**2*f**3*fd - 16260*D1**2*f**3*fdd*r**2 - 45960*D1**2*f**3*fdd*r*s + 31110*D1**2*f**3*fdd*r - 29700*D1**2*f**3*fdd*s**2 + 41190*D1**2*f**3*fdd*s - 18915*D1**2*f**3*fdd - 48780*D1**2*f**2*fd**2*r**2 - 137880*D1**2*f**2*fd**2*r*s + 93330*D1**2*f**2*fd**2*r - 89100*D1**2*f**2*fd**2*s**2 + 123570*D1**2*f**2*fd**2*s - 37830*D1**2*f**2*fd**2 + 23463*D1**2*f**2*fd*r**2 + 33858*D1**2*f**2*fd*r*s - 26928*D1**2*f**2*fd*r + 10395*D1**2*f**2*fd*s**2 - 18216*D1**2*f**2*fd*s + 11286*D1**2*f**2*fd - 49896*D1**2*f**2*gd2*r**2 - 77616*D1**2*f**2*gd2*r*s + 77616*D1**2*f**2*gd2*r - 27720*D1**2*f**2*gd2*s**2 + 55440*D1**2*f**2*gd2*s - 27720*D1**2*f**2*gd2 + 37884*D1**2*f**2*gdd2*r**2 + 59136*D1**2*f**2*gdd2*r*s - 59136*D1**2*f**2*gdd2*r + 21252*D1**2*f**2*gdd2*s**2 - 42504*D1**2*f**2*gdd2*s + 21252*D1**2*f**2*gdd2 - 99792*D1**2*f*fd*g2*r**2 - 155232*D1**2*f*fd*g2*r*s + 99792*D1**2*f*fd*g2*r - 55440*D1**2*f*fd*g2*s**2 + 77616*D1**2*f*fd*g2*s - 49896*D1**2*f*fd*g2 + 151536*D1**2*f*fd*gd2*r**2 + 236544*D1**2*f*fd*gd2*r*s - 194040*D1**2*f*fd*gd2*r + 85008*D1**2*f*fd*gd2*s**2 - 144144*D1**2*f*fd*gd2*s + 59136*D1**2*f*fd*gd2 + 75768*D1**2*f*fdd*g2*r**2 + 118272*D1**2*f*fdd*g2*r*s - 75768*D1**2*f*fdd*g2*r + 42504*D1**2*f*fdd*g2*s**2 - 59136*D1**2*f*fdd*g2*s + 37884*D1**2*f*fdd*g2 + 75768*D1**2*fd**2*g2*r**2 + 118272*D1**2*fd**2*g2*r*s - 75768*D1**2*fd**2*g2*r + 42504*D1**2*fd**2*g2*s**2 - 59136*D1**2*fd**2*g2*s - 151536*D1*Dd*K*bd1*f**2*r**2 - 236544*D1*Dd*K*bd1*f**2*r*s + 215292*D1*Dd*K*bd1*f**2*r - 85008*D1*Dd*K*bd1*f**2*s**2 + 157080*D1*Dd*K*bd1*f**2*s - 72072*D1*Dd*K*bd1*f**2 + 86856*D1*Dd*bd1*f**3*r**2 + 108240*D1*Dd*bd1*f**3*r*s - 112662*D1*Dd*bd1*f**3*r + 21384*D1*Dd*bd1*f**3*s**2 - 55374*D1*Dd*bd1*f**3*s + 31548*D1*Dd*bd1*f**3 + 69432*D1*Dd*bd1*f**2*r**2 + 116688*D1*Dd*bd1*f**2*r*s - 104874*D1*Dd*bd1*f**2*r + 47256*D1*Dd*bd1*f**2*s**2 - 85470*D1*Dd*bd1*f**2*s + 38214*D1*Dd*bd1*f**2 + 591360*D1*Dd*bd1*f*g2*r**2 + 1049664*D1*Dd*bd1*f*g2*r*s - 1038576*D1*Dd*bd1*f*g2*r + 458304*D1*Dd*bd1*f*g2*s**2 - 922152*D1*Dd*bd1*f*g2*s + 437976*D1*Dd*bd1*f*g2 - 47520*D1*Dd*bd2*f**2*r**2 - 95040*D1*Dd*bd2*f**2*r*s + 83160*D1*Dd*bd2*f**2*r - 47520*D1*Dd*bd2*f**2*s**2 + 83160*D1*Dd*bd2*f**2*s - 35640*D1*Dd*bd2*f**2 + 16460*D1*Dd*f**4*r**2 + 42200*D1*Dd*f**4*r*s - 29330*D1*Dd*f**4*r + 25740*D1*Dd*f**4*s**2 - 36290*D1*Dd*f**4*s + 16985*D1*Dd*f**4 - 130080*D1*Dd*f**3*fd*r**2 - 367680*D1*Dd*f**3*fd*r*s + 248880*D1*Dd*f**3*fd*r - 237600*D1*Dd*f**3*fd*s**2 + 329520*D1*Dd*f**3*fd*s - 113490*D1*Dd*f**3*fd + 31284*D1*Dd*f**3*r**2 + 45144*D1*Dd*f**3*r*s - 38214*D1*Dd*f**3*r + 13860*D1*Dd*f**3*s**2 - 25146*D1*Dd*f**3*s + 14751*D1*Dd*f**3 - 199584*D1*Dd*f**2*g2*r**2 - 310464*D1*Dd*f**2*g2*r*s + 255024*D1*Dd*f**2*g2*r - 110880*D1*Dd*f**2*g2*s**2 + 188496*D1*Dd*f**2*g2*s - 105336*D1*Dd*f**2*g2 + 303072*D1*Dd*f**2*gd2*r**2 + 473088*D1*Dd*f**2*gd2*r*s - 430584*D1*Dd*f**2*gd2*r + 170016*D1*Dd*f**2*gd2*s**2 - 314160*D1*Dd*f**2*gd2*s + 144144*D1*Dd*f**2*gd2 + 606144*D1*Dd*f*fd*g2*r**2 + 946176*D1*Dd*f*fd*g2*r*s - 691152*D1*Dd*f*fd*g2*r + 340032*D1*Dd*f*fd*g2*s**2 - 524832*D1*Dd*f*fd*g2*s + 194040*D1*Dd*f*fd*g2 - 16260*D1*Ddd*f**4*r**2 - 45960*D1*Ddd*f**4*r*s + 31110*D1*Ddd*f**4*r - 29700*D1*Ddd*f**4*s**2 + 41190*D1*Ddd*f**4*s - 18915*D1*Ddd*f**4 + 151536*D1*Ddd*f**2*g2*r**2 + 236544*D1*Ddd*f**2*g2*r*s - 194040*D1*Ddd*f**2*g2*r + 85008*D1*Ddd*f**2*g2*s**2 - 144144*D1*Ddd*f**2*g2*s + 80388*D1*Ddd*f**2*g2 - 48780*Dd**2*f**4*r**2 - 137880*Dd**2*f**4*r*s + 93330*Dd**2*f**4*r - 89100*Dd**2*f**4*s**2 + 123570*Dd**2*f**4*s - 37830*Dd**2*f**4 + 454608*Dd**2*f**2*g2*r**2 + 709632*Dd**2*f**2*g2*r*s - 582120*Dd**2*f**2*g2*r + 255024*Dd**2*f**2*g2*s**2 - 432432*Dd**2*f**2*g2*s + 160776*Dd**2*f**2*g2 + 1155*b1**3*(D1**2*(8*fd - 9*fdd)*(r + s - 1)**2 + D1*(2*Dd*(4*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 9*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 9*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 9*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(700*C*D1**2*fd*r**2 + 1400*C*D1**2*fd*r*s - 1400*C*D1**2*fd*r + 700*C*D1**2*fd*s**2 - 1400*C*D1**2*fd*s + 700*C*D1**2*fd + 2800*C*D1*Dd*f*r**2 + 5600*C*D1*Dd*f*r*s - 4200*C*D1*Dd*f*r + 2800*C*D1*Dd*f*s**2 - 4200*C*D1*Dd*f*s + 2100*C*D1*Dd*f + 1120*D1**2*K*fd*r**2 + 1736*D1**2*K*fd*r*s + 280*D1**2*K*fd*r + 616*D1**2*K*fd*s**2 + 280*D1**2*K*fd*s - 140*D1**2*K*fd - 1120*D1**2*K*fdd*r**2 - 1988*D1**2*K*fdd*r*s - 140*D1**2*K*fdd*r - 868*D1**2*K*fdd*s**2 - 140*D1**2*K*fdd*s + 70*D1**2*K*fdd - 35*D1**2*bdd1*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 1010*D1**2*f*fd*r**2 - 2356*D1**2*f*fd*r*s + 968*D1**2*f*fd*r - 1346*D1**2*f*fd*s**2 + 1136*D1**2*f*fd*s - 568*D1**2*f*fd + 1422*D1**2*f*fdd*r**2 + 3180*D1**2*f*fdd*r*s - 1590*D1**2*f*fdd*r + 1758*D1**2*f*fdd*s**2 - 1758*D1**2*f*fdd*s + 879*D1**2*f*fdd + 1422*D1**2*fd**2*r**2 + 3180*D1**2*fd**2*r*s - 1590*D1**2*fd**2*r + 1758*D1**2*fd**2*s**2 - 1758*D1**2*fd**2*s - 1155*D1**2*fd*r**2 - 2002*D1**2*fd*r*s + 910*D1**2*fd*r - 847*D1**2*fd*s**2 + 910*D1**2*fd*s - 455*D1**2*fd + 560*D1**2*fdd*r**2 + 1036*D1**2*fdd*r*s + 70*D1**2*fdd*r + 476*D1**2*fdd*s**2 + 70*D1**2*fdd*s - 35*D1**2*fdd + 1400*D1**2*gd2*r**2 + 2800*D1**2*gd2*r*s - 2800*D1**2*gd2*r + 1400*D1**2*gd2*s**2 - 2800*D1**2*gd2*s + 1400*D1**2*gd2 - 700*D1**2*gdd2*r**2 - 1400*D1**2*gdd2*r*s + 1400*D1**2*gdd2*r - 700*D1**2*gdd2*s**2 + 1400*D1**2*gdd2*s - 700*D1**2*gdd2 + 4480*D1*Dd*K*f*r**2 + 6944*D1*Dd*K*f*r*s - 5712*D1*Dd*K*f*r + 2464*D1*Dd*K*f*s**2 - 4200*D1*Dd*K*f*s + 2352*D1*Dd*K*f - 8960*D1*Dd*K*fd*r**2 - 15904*D1*Dd*K*fd*r*s + 5656*D1*Dd*K*fd*r - 6944*D1*Dd*K*fd*s**2 + 4900*D1*Dd*K*fd*s + 420*D1*Dd*K*fd - 2020*D1*Dd*f**2*r**2 - 4712*D1*Dd*f**2*r*s + 3366*D1*Dd*f**2*r - 2692*D1*Dd*f**2*s**2 + 3870*D1*Dd*f**2*s - 1851*D1*Dd*f**2 + 11376*D1*Dd*f*fd*r**2 + 25440*D1*Dd*f*fd*r*s - 15564*D1*Dd*f*fd*r + 14064*D1*Dd*f*fd*s**2 - 17244*D1*Dd*f*fd*s + 5106*D1*Dd*f*fd - 4620*D1*Dd*f*r**2 - 8008*D1*Dd*f*r*s + 6314*D1*Dd*f*r - 3388*D1*Dd*f*s**2 + 5390*D1*Dd*f*s - 2849*D1*Dd*f + 4480*D1*Dd*fd*r**2 + 8288*D1*Dd*fd*r*s - 2912*D1*Dd*fd*r + 3808*D1*Dd*fd*s**2 - 2660*D1*Dd*fd*s - 210*D1*Dd*fd + 5600*D1*Dd*g2*r**2 + 11200*D1*Dd*g2*r*s - 8400*D1*Dd*g2*r + 5600*D1*Dd*g2*s**2 - 8400*D1*Dd*g2*s + 4200*D1*Dd*g2 - 5600*D1*Dd*gd2*r**2 - 11200*D1*Dd*gd2*r*s + 9800*D1*Dd*gd2*r - 5600*D1*Dd*gd2*s**2 + 9800*D1*Dd*gd2*s - 4200*D1*Dd*gd2 - 4480*D1*Ddd*K*f*r**2 - 7952*D1*Ddd*K*f*r*s + 6216*D1*Ddd*K*f*r - 3472*D1*Ddd*K*f*s**2 + 5460*D1*Ddd*K*f*s - 2856*D1*Ddd*K*f + 2844*D1*Ddd*f**2*r**2 + 6360*D1*Ddd*f**2*r*s - 4602*D1*Ddd*f**2*r + 3516*D1*Ddd*f**2*s**2 - 5106*D1*Ddd*f**2*s + 2469*D1*Ddd*f**2 + 2240*D1*Ddd*f*r**2 + 4144*D1*Ddd*f*r*s - 3192*D1*Ddd*f*r + 1904*D1*Ddd*f*s**2 - 2940*D1*Ddd*f*s + 1512*D1*Ddd*f - 2800*D1*Ddd*g2*r**2 - 5600*D1*Ddd*g2*r*s + 4200*D1*Ddd*g2*r - 2800*D1*Ddd*g2*s**2 + 4200*D1*Ddd*g2*s - 2100*D1*Ddd*g2 + 70*D1*bd1*(D1*(4*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-10*K + 9*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 13440*Dd**2*K*f*r**2 - 23856*Dd**2*K*f*r*s + 18648*Dd**2*K*f*r - 10416*Dd**2*K*f*s**2 + 16380*Dd**2*K*f*s - 5712*Dd**2*K*f + 8532*Dd**2*f**2*r**2 + 19080*Dd**2*f**2*r*s - 13806*Dd**2*f**2*r + 10548*Dd**2*f**2*s**2 - 15318*Dd**2*f**2*s + 4938*Dd**2*f**2 + 6720*Dd**2*f*r**2 + 12432*Dd**2*f*r*s - 9576*Dd**2*f*r + 5712*Dd**2*f*s**2 - 8820*Dd**2*f*s + 3024*Dd**2*f - 8400*Dd**2*g2*r**2 - 16800*Dd**2*g2*r*s + 12600*Dd**2*g2*r - 8400*Dd**2*g2*s**2 + 12600*Dd**2*g2*s - 4200*Dd**2*g2) - 33*b1*(1344*C*D1**2*f*fd*r**2 + 1904*C*D1**2*f*fd*r*s - 672*C*D1**2*f*fd*r + 560*C*D1**2*f*fd*s**2 - 280*C*D1**2*f*fd*s + 140*C*D1**2*f*fd + 2688*C*D1*Dd*f**2*r**2 + 3808*C*D1*Dd*f**2*r*s - 3248*C*D1*Dd*f**2*r + 1120*C*D1*Dd*f**2*s**2 - 2072*C*D1*Dd*f**2*s + 1232*C*D1*Dd*f**2 + 2240*D1**2*K*bdd1*f*r**2 + 3976*D1**2*K*bdd1*f*r*s - 4368*D1**2*K*bdd1*f*r + 1736*D1**2*K*bdd1*f*s**2 - 3864*D1**2*K*bdd1*f*s + 2058*D1**2*K*bdd1*f - 1512*D1**2*K*f*fd*r**2 - 2352*D1**2*K*f*fd*r*s + 1512*D1**2*K*f*fd*r - 840*D1**2*K*f*fd*s**2 + 1176*D1**2*K*f*fd*s - 756*D1**2*K*f*fd + 1148*D1**2*K*f*fdd*r**2 + 1792*D1**2*K*f*fdd*r*s - 1148*D1**2*K*f*fdd*r + 644*D1**2*K*f*fdd*s**2 - 896*D1**2*K*f*fdd*s + 574*D1**2*K*f*fdd + 1148*D1**2*K*fd**2*r**2 + 1792*D1**2*K*fd**2*r*s - 1148*D1**2*K*fd**2*r + 644*D1**2*K*fd**2*s**2 - 896*D1**2*K*fd**2*s - 490*D1**2*b2*fd*r**2 - 980*D1**2*b2*fd*r*s - 490*D1**2*b2*fd*s**2 + 420*D1**2*b2*fdd*r**2 + 840*D1**2*b2*fdd*r*s + 420*D1**2*b2*fdd*s**2 + 70*D1**2*bd1**2*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 1422*D1**2*bdd1*f**2*r**2 - 3180*D1**2*bdd1*f**2*r*s + 3012*D1**2*bdd1*f**2*r - 1758*D1**2*bdd1*f**2*s**2 + 3348*D1**2*bdd1*f**2*s - 1590*D1**2*bdd1*f**2 - 1120*D1**2*bdd1*f*r**2 - 2072*D1**2*bdd1*f*r*s + 2226*D1**2*bdd1*f*r - 952*D1**2*bdd1*f*s**2 + 2058*D1**2*bdd1*f*s - 1071*D1**2*bdd1*f + 1400*D1**2*bdd1*g2*r**2 + 2800*D1**2*bdd1*g2*r*s - 1400*D1**2*bdd1*g2*r + 1400*D1**2*bdd1*g2*s**2 - 1400*D1**2*bdd1*g2*s + 700*D1**2*bdd1*g2 + 420*D1**2*bdd2*f*r**2 + 840*D1**2*bdd2*f*r*s - 840*D1**2*bdd2*f*r + 420*D1**2*bdd2*f*s**2 - 840*D1**2*bdd2*f*s + 420*D1**2*bdd2*f + 1074*D1**2*f**2*fd*r**2 + 1452*D1**2*f**2*fd*r*s - 1166*D1**2*f**2*fd*r + 378*D1**2*f**2*fd*s**2 - 702*D1**2*f**2*fd*s + 375*D1**2*f**2*fd - 987*D1**2*f**2*fdd*r**2 - 1230*D1**2*f**2*fdd*r*s + 994*D1**2*f**2*fdd*r - 243*D1**2*f**2*fdd*s**2 + 498*D1**2*f**2*fdd*s - 261*D1**2*f**2*fdd - 1974*D1**2*f*fd**2*r**2 - 2460*D1**2*f*fd**2*r*s + 1988*D1**2*f*fd**2*r - 486*D1**2*f*fd**2*s**2 + 996*D1**2*f*fd**2*s - 486*D1**2*f*fd**2 - 152*D1**2*f*fd*r**2 + 32*D1**2*f*fd*r*s - 366*D1**2*f*fd*r + 184*D1**2*f*fd*s**2 - 534*D1**2*f*fd*s + 337*D1**2*f*fd - 526*D1**2*f*fdd*r**2 - 884*D1**2*f*fdd*r*s + 526*D1**2*f*fdd*r - 358*D1**2*f*fdd*s**2 + 442*D1**2*f*fdd*s - 263*D1**2*f*fdd + 2240*D1**2*f*gd2*r**2 + 3472*D1**2*f*gd2*r*s - 3472*D1**2*f*gd2*r + 1232*D1**2*f*gd2*s**2 - 2464*D1**2*f*gd2*s + 1232*D1**2*f*gd2 - 2240*D1**2*f*gdd2*r**2 - 3976*D1**2*f*gdd2*r*s + 3976*D1**2*f*gdd2*r - 1736*D1**2*f*gdd2*s**2 + 3472*D1**2*f*gdd2*s - 1736*D1**2*f*gdd2 - 526*D1**2*fd**2*r**2 - 884*D1**2*fd**2*r*s + 526*D1**2*fd**2*r - 358*D1**2*fd**2*s**2 + 442*D1**2*fd**2*s + 2240*D1**2*fd*g2*r**2 + 3472*D1**2*fd*g2*r*s + 560*D1**2*fd*g2*r + 1232*D1**2*fd*g2*s**2 + 560*D1**2*fd*g2*s - 280*D1**2*fd*g2 - 4480*D1**2*fd*gd2*r**2 - 7952*D1**2*fd*gd2*r*s + 3696*D1**2*fd*gd2*r - 3472*D1**2*fd*gd2*s**2 + 3192*D1**2*fd*gd2*s + 280*D1**2*fd*gd2 - 2240*D1**2*fdd*g2*r**2 - 3976*D1**2*fdd*g2*r*s - 280*D1**2*fdd*g2*r - 1736*D1**2*fdd*g2*s**2 - 280*D1**2*fdd*g2*s + 140*D1**2*fdd*g2 - 3024*D1*Dd*K*f**2*r**2 - 4704*D1*Dd*K*f**2*r*s + 3864*D1*Dd*K*f**2*r - 1680*D1*Dd*K*f**2*s**2 + 2856*D1*Dd*K*f**2*s - 1596*D1*Dd*K*f**2 + 9184*D1*Dd*K*f*fd*r**2 + 14336*D1*Dd*K*f*fd*r*s - 10472*D1*Dd*K*f*fd*r + 5152*D1*Dd*K*f*fd*s**2 - 7952*D1*Dd*K*f*fd*s + 2940*D1*Dd*K*f*fd - 1960*D1*Dd*b2*f*r**2 - 3920*D1*Dd*b2*f*r*s + 2940*D1*Dd*b2*f*r - 1960*D1*Dd*b2*f*s**2 + 2940*D1*Dd*b2*f*s - 1470*D1*Dd*b2*f + 3360*D1*Dd*b2*fd*r**2 + 6720*D1*Dd*b2*fd*r*s - 2520*D1*Dd*b2*fd*r + 3360*D1*Dd*b2*fd*s**2 - 2520*D1*Dd*b2*fd*s + 1432*D1*Dd*f**3*r**2 + 1936*D1*Dd*f**3*r*s - 1684*D1*Dd*f**3*r + 504*D1*Dd*f**3*s**2 - 988*D1*Dd*f**3*s + 610*D1*Dd*f**3 - 7896*D1*Dd*f**2*fd*r**2 - 9840*D1*Dd*f**2*fd*r*s + 8410*D1*Dd*f**2*fd*r - 1944*D1*Dd*f**2*fd*s**2 + 4194*D1*Dd*f**2*fd*s - 1990*D1*Dd*f**2*fd - 304*D1*Dd*f**2*r**2 + 64*D1*Dd*f**2*r*s + 120*D1*Dd*f**2*r + 368*D1*Dd*f**2*s**2 - 384*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 4208*D1*Dd*f*fd*r**2 - 7072*D1*Dd*f*fd*r*s + 4924*D1*Dd*f*fd*r - 2864*D1*Dd*f*fd*s**2 + 4084*D1*Dd*f*fd*s - 1410*D1*Dd*f*fd + 8960*D1*Dd*f*g2*r**2 + 13888*D1*Dd*f*g2*r*s - 11424*D1*Dd*f*g2*r + 4928*D1*Dd*f*g2*s**2 - 8400*D1*Dd*f*g2*s + 4704*D1*Dd*f*g2 - 17920*D1*Dd*f*gd2*r**2 - 31808*D1*Dd*f*gd2*r*s + 28336*D1*Dd*f*gd2*r - 13888*D1*Dd*f*gd2*s**2 + 24808*D1*Dd*f*gd2*s - 10920*D1*Dd*f*gd2 - 17920*D1*Dd*fd*g2*r**2 - 31808*D1*Dd*fd*g2*r*s + 11312*D1*Dd*fd*g2*r - 13888*D1*Dd*fd*g2*s**2 + 9800*D1*Dd*fd*g2*s + 840*D1*Dd*fd*g2 + 2296*D1*Ddd*K*f**2*r**2 + 3584*D1*Ddd*K*f**2*r*s - 2940*D1*Ddd*K*f**2*r + 1288*D1*Ddd*K*f**2*s**2 - 2184*D1*Ddd*K*f**2*s + 1218*D1*Ddd*K*f**2 + 1680*D1*Ddd*b2*f*r**2 + 3360*D1*Ddd*b2*f*r*s - 2520*D1*Ddd*b2*f*r + 1680*D1*Ddd*b2*f*s**2 - 2520*D1*Ddd*b2*f*s + 1260*D1*Ddd*b2*f - 1316*D1*Ddd*f**3*r**2 - 1640*D1*Ddd*f**3*r*s + 1478*D1*Ddd*f**3*r - 324*D1*Ddd*f**3*s**2 + 734*D1*Ddd*f**3*s - 491*D1*Ddd*f**3 - 1052*D1*Ddd*f**2*r**2 - 1768*D1*Ddd*f**2*r*s + 1410*D1*Ddd*f**2*r - 716*D1*Ddd*f**2*s**2 + 1158*D1*Ddd*f**2*s - 621*D1*Ddd*f**2 - 8960*D1*Ddd*f*g2*r**2 - 15904*D1*Ddd*f*g2*r*s + 12432*D1*Ddd*f*g2*r - 6944*D1*Ddd*f*g2*s**2 + 10920*D1*Ddd*f*g2*s - 5712*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(1010*r**2 + r*(2356*s - 2398) + 1346*s**2 - 2734*s + 1283) - f*(700*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*K*(80*r**2 + 4*r*(31*s - 38) + 44*s**2 - 116*s + 67) + 12*fd*(474*r**2 + r*(1060*s - 767) + 586*s**2 - 851*s + 279) - 2310*r**2 - 4004*r*s + 3402*r - 1694*s**2 + 2786*s - 1547) + 14*fd*(2*K*(160*r**2 + 284*r*s - 146*r + 124*s**2 - 128*s - 5) - 160*r**2 - 296*r*s + 149*r - 136*s**2 + 137*s + 5) - 1400*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 1400*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*(6*f**2*(948*r**2 + r*(2120*s - 1771) + 1172*s**2 - 1967*s + 809) - 7*f*(4*K*(320*r**2 + 568*r*s - 534*r + 248*s**2 - 471*s + 216) - 640*r**2 - 1184*r*s + 1092*r - 544*s**2 + 1008*s - 453) - 700*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 70*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 6888*Dd**2*K*f**2*r**2 + 10752*Dd**2*K*f**2*r*s - 8820*Dd**2*K*f**2*r + 3864*Dd**2*K*f**2*s**2 - 6552*Dd**2*K*f**2*s + 2436*Dd**2*K*f**2 + 5040*Dd**2*b2*f*r**2 + 10080*Dd**2*b2*f*r*s - 7560*Dd**2*b2*f*r + 5040*Dd**2*b2*f*s**2 - 7560*Dd**2*b2*f*s + 2520*Dd**2*b2*f - 3948*Dd**2*f**3*r**2 - 4920*Dd**2*f**3*r*s + 4434*Dd**2*f**3*r - 972*Dd**2*f**3*s**2 + 2202*Dd**2*f**3*s - 982*Dd**2*f**3 - 3156*Dd**2*f**2*r**2 - 5304*Dd**2*f**2*r*s + 4230*Dd**2*f**2*r - 2148*Dd**2*f**2*s**2 + 3474*Dd**2*f**2*s - 1242*Dd**2*f**2 - 26880*Dd**2*f*g2*r**2 - 47712*Dd**2*f*g2*r*s + 37296*Dd**2*f*g2*r - 20832*Dd**2*f*g2*s**2 + 32760*Dd**2*f*g2*s - 11424*Dd**2*f*g2) + 330*b2*(-42*D1**2*bdd1*f*(r + s - 1)**2 + 58*D1**2*f*fd*r**2 + 116*D1**2*f*fd*r*s - 58*D1**2*f*fd*r + 58*D1**2*f*fd*s**2 - 58*D1**2*f*fd*s + 29*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 116*D1*Dd*f**2*r**2 + 232*D1*Dd*f**2*r*s - 174*D1*Dd*f**2*r + 116*D1*Dd*f**2*s**2 - 174*D1*Dd*f**2*s + 87*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 + 7*D1*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2))/(6930*d**2*k3**5) + 2*D1**2*Pk1*Pkd3*ct*k1*k2*st**4*(7*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(C*fdd*(26*r*(2*s - 1) + 52*s**2 - 48*s + 26) - 7*bdd1*s*(4*C - 3)*(2*r + 2*s - 1) + fd*(C*(-76*r*s + 38*r - 76*s**2 + 68*s - 38) + 46*r*s - 23*r + 46*s**2 - 40*s + 23) - 3*fdd*(5*r*(2*s - 1) + 10*s**2 - 9*s + 5)) + fd**2*(C*(26*r*(2*s - 1) + 52*s**2 - 48*s - 4) + r*(15 - 30*s) - 30*s**2 + 27*s + 3)) - 7*D1*bd1*(4*C - 3)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(-f*(38*C - 23)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(2*s - 1)*(2*C*(104*r + 104*s - 61) - 120*r - 120*s + 69)) + Ddd*f*(26*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(26*C - 15)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-7*D1**2*bd1**2*s*(4*C - 3)*(2*r + 2*s - 1) + D1**2*(f*(bdd1*s*(C*(26*r + 26*s - 30) - 15*r - 15*s + 18) - fd*(18*C - 11)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(10*C - 6)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(10*C - 6)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(C*Dd*f*(52*r*(4*s - 1) + 208*s**2 - 250*s + 60) + D1*f*s*(C*(-38*r - 38*s + 46) + 23*r + 23*s - 29) + D1*fd*(2*C*(13*r*(4*s - 1) + 52*s**2 - 54*s + 15) - 15*r*(4*s - 1) - 60*s**2 + 63*s - 18) - 3*Dd*f*(10*r*(4*s - 1) + 40*s**2 - 49*s + 12)) + D1*f*(Dd*(-f*(18*C - 11)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(10*C - 6)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(10*C - 6)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(10*C - 6)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k3**3) - D1**2*Pk1*Pkd3*ct*k1*k2*st**2*(42*b1**2*(D1**2*(fd*(64*C*(s - 1) + 3*r - 43*s + 43) + 2*fdd*(-4*C*(5*r + 9*s - 9) + 13*r + 27*s - 27))*(r + s - 1) + D1*(Dd*(f*(64*C*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 12*r**2 - 160*r*s + 74*r - 172*s**2 + 212*s - 83) + 4*fd*(-4*C*(20*r**2 + 56*r*s - 47*r + 36*s**2 - 61*s + 25) + 52*r**2 + 160*r*s - 133*r + 108*s**2 - 182*s + 74)) - 2*Ddd*f*(4*C*(20*r**2 + 56*r*s - 38*r + 36*s**2 - 50*s + 23) - 52*r**2 - 160*r*s + 106*r - 108*s**2 + 148*s - 67)) - 4*Dd**2*f*(4*C*(30*r**2 + 84*r*s - 57*r + 54*s**2 - 75*s + 23) - 78*r**2 - 240*r*s + 159*r - 162*s**2 + 222*s - 67)) + 3*b1*(296*C*D1**2*f*fd*r**2 - 1248*C*D1**2*f*fd*r*s - 176*C*D1**2*f*fd*r - 1544*C*D1**2*f*fd*s**2 + 824*C*D1**2*f*fd*s - 372*C*D1**2*f*fd + 104*C*D1**2*f*fdd*r**2 + 1408*C*D1**2*f*fdd*r*s + 32*C*D1**2*f*fdd*r + 1304*C*D1**2*f*fdd*s**2 - 664*C*D1**2*f*fdd*s + 284*C*D1**2*f*fdd + 104*C*D1**2*fd**2*r**2 + 1408*C*D1**2*fd**2*r*s + 32*C*D1**2*fd**2*r + 1304*C*D1**2*fd**2*s**2 - 664*C*D1**2*fd**2*s - 640*C*D1**2*fd**2 + 592*C*D1*Dd*f**2*r**2 - 2496*C*D1*Dd*f**2*r*s + 952*C*D1*Dd*f**2*r - 3088*C*D1*Dd*f**2*s**2 + 3712*C*D1*Dd*f**2*s - 1396*C*D1*Dd*f**2 + 832*C*D1*Dd*f*fd*r**2 + 11264*C*D1*Dd*f*fd*r*s - 2896*C*D1*Dd*f*fd*r + 10432*C*D1*Dd*f*fd*s**2 - 9280*C*D1*Dd*f*fd*s + 1296*C*D1*Dd*f*fd + 208*C*D1*Ddd*f**2*r**2 + 2816*C*D1*Ddd*f**2*r*s - 1512*C*D1*Ddd*f**2*r + 2608*C*D1*Ddd*f**2*s**2 - 3312*C*D1*Ddd*f**2*s + 1356*C*D1*Ddd*f**2 + 624*C*Dd**2*f**2*r**2 + 8448*C*Dd**2*f**2*r*s - 4536*C*Dd**2*f**2*r + 7824*C*Dd**2*f**2*s**2 - 9936*C*Dd**2*f**2*s + 2712*C*Dd**2*f**2 - 28*D1**2*bdd1*f*(4*C*(10*r**2 + 2*r*(14*s - 5) + 18*s**2 - 14*s + 5) - 26*r**2 + r*(26 - 80*s) - 54*s**2 + 40*s - 13) - 146*D1**2*f*fd*r**2 + 780*D1**2*f*fd*r*s + 102*D1**2*f*fd*r + 926*D1**2*f*fd*s**2 - 454*D1**2*f*fd*s + 217*D1**2*f*fd - 46*D1**2*f*fdd*r**2 - 908*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r - 862*D1**2*f*fdd*s**2 + 430*D1**2*f*fdd*s - 203*D1**2*f*fdd - 46*D1**2*fd**2*r**2 - 908*D1**2*fd**2*r*s - 2*D1**2*fd**2*r - 862*D1**2*fd**2*s**2 + 430*D1**2*fd**2*s + 432*D1**2*fd**2 - 292*D1*Dd*f**2*r**2 + 1560*D1*Dd*f**2*r*s - 634*D1*Dd*f**2*r + 1852*D1*Dd*f**2*s**2 - 2242*D1*Dd*f**2*s + 853*D1*Dd*f**2 - 368*D1*Dd*f*fd*r**2 - 7264*D1*Dd*f*fd*r*s + 1900*D1*Dd*f*fd*r - 6896*D1*Dd*f*fd*s**2 + 6076*D1*Dd*f*fd*s - 858*D1*Dd*f*fd - 92*D1*Ddd*f**2*r**2 - 1816*D1*Ddd*f**2*r*s + 954*D1*Ddd*f**2*r - 1724*D1*Ddd*f**2*s**2 + 2178*D1*Ddd*f**2*s - 885*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(6*r**2 + 2*r*(s*(64*C - 40) - 3) + s**2*(128*C - 86) - s*(64*C - 40) + 3) - 4*fd*(4*C*(10*r**2 + r*(28*s - 19) + 18*s**2 - 25*s + 7) - 26*r**2 + r*(53 - 80*s) - 54*s**2 + 74*s - 20)) - 4*Dd*f*(4*C*(40*r**2 + 2*r*(56*s - 29) + 72*s**2 - 78*s + 19) - 104*r**2 + r*(158 - 320*s) - 216*s**2 + 228*s - 53)) - 276*Dd**2*f**2*r**2 - 5448*Dd**2*f**2*r*s + 2862*Dd**2*f**2*r - 5172*Dd**2*f**2*s**2 + 6534*Dd**2*f**2*s - 1770*Dd**2*f**2) + f*(-2268*C*D1**2*f*fd*r**2 - 6480*C*D1**2*f*fd*r*s + 3672*C*D1**2*f*fd*r - 4212*C*D1**2*f*fd*s**2 + 4968*C*D1**2*f*fd*s - 2160*C*D1**2*f*fd + 2484*C*D1**2*f*fdd*r**2 + 6048*C*D1**2*f*fdd*r*s - 3672*C*D1**2*f*fdd*r + 3564*C*D1**2*f*fdd*s**2 - 4392*C*D1**2*f*fdd*s + 2016*C*D1**2*f*fdd + 4968*C*D1**2*fd**2*r**2 + 12096*C*D1**2*fd**2*r*s - 7344*C*D1**2*fd**2*r + 7128*C*D1**2*fd**2*s**2 - 8784*C*D1**2*fd**2*s + 2016*C*D1**2*fd**2 - 3024*C*D1*Dd*f**2*r**2 - 8640*C*D1*Dd*f**2*r*s + 5832*C*D1*Dd*f**2*r - 5616*C*D1*Dd*f**2*s**2 + 7776*C*D1*Dd*f**2*s - 3564*C*D1*Dd*f**2 + 19872*C*D1*Dd*f*fd*r**2 + 48384*C*D1*Dd*f*fd*r*s - 31752*C*D1*Dd*f*fd*r + 28512*C*D1*Dd*f*fd*s**2 - 37872*C*D1*Dd*f*fd*s + 12456*C*D1*Dd*f*fd + 3312*C*D1*Ddd*f**2*r**2 + 8064*C*D1*Ddd*f**2*r*s - 5688*C*D1*Ddd*f**2*r + 4752*C*D1*Ddd*f**2*s**2 - 6768*C*D1*Ddd*f**2*s + 3204*C*D1*Ddd*f**2 + 9936*C*Dd**2*f**2*r**2 + 24192*C*Dd**2*f**2*r*s - 17064*C*Dd**2*f**2*r + 14256*C*Dd**2*f**2*s**2 - 20304*C*Dd**2*f**2*s + 6408*C*Dd**2*f**2 - 168*D1**2*bd1**2*(r**2*(20*C - 13) + r*(4*C*(14*s - 5) - 40*s + 13) + s*(4*C*(9*s - 7) - 27*s + 20)) + 3*D1**2*bdd1*f*(4*C*(13*r**2 + 176*r*s - 210*r + 163*s**2 - 336*s + 105) - 23*r**2 - 454*r*s + 502*r - 431*s**2 + 886*s - 251) + 1425*D1**2*f*fd*r**2 + 4206*D1**2*f*fd*r*s - 2352*D1**2*f*fd*r + 2781*D1**2*f*fd*s**2 - 3256*D1**2*f*fd*s + 1402*D1**2*f*fd - 1455*D1**2*f*fdd*r**2 - 3966*D1**2*f*fdd*r*s + 2292*D1**2*f*fdd*r - 2511*D1**2*f*fdd*s**2 + 2996*D1**2*f*fdd*s - 1322*D1**2*f*fdd - 2910*D1**2*fd**2*r**2 - 7932*D1**2*fd**2*r*s + 4584*D1**2*fd**2*r - 5022*D1**2*fd**2*s**2 + 5992*D1**2*fd**2*s - 1322*D1**2*fd**2 + 1900*D1*Dd*f**2*r**2 + 5608*D1*Dd*f**2*r*s - 3754*D1*Dd*f**2*r + 3708*D1*Dd*f**2*s**2 - 5110*D1*Dd*f**2*s + 2329*D1*Dd*f**2 - 11640*D1*Dd*f*fd*r**2 - 31728*D1*Dd*f*fd*r*s + 20010*D1*Dd*f*fd*r - 20088*D1*Dd*f*fd*s**2 + 25994*D1*Dd*f*fd*s - 8284*D1*Dd*f*fd - 1940*D1*Ddd*f**2*r**2 - 5288*D1*Ddd*f**2*r*s + 3614*D1*Ddd*f**2*r - 3348*D1*Ddd*f**2*s**2 + 4670*D1*Ddd*f**2*s - 2159*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(4*C*(37*r**2 - 156*r*s + 126*r - 193*s**2 + 336*s - 63) - 73*r**2 + 390*r*s - 346*r + 463*s**2 - 862*s + 173) + 2*fd*(4*C*(26*r**2 + 352*r*s - 206*r + 326*s**2 - 419*s + 168) - 46*r**2 - 908*r*s + 501*r - 862*s**2 + 1101*s - 443)) + 2*Dd*f*(4*C*(52*r**2 + 704*r*s - 609*r + 652*s**2 - 1086*s + 441) - 92*r**2 - 1816*r*s + 1481*r - 1724*s**2 + 2861*s - 1137)) - 5820*Dd**2*f**2*r**2 - 15864*Dd**2*f**2*r*s + 10842*Dd**2*f**2*r - 10044*Dd**2*f**2*s**2 + 14010*Dd**2*f**2*s - 4318*Dd**2*f**2))/(630*d**2*k3**3) + D1**2*Pk1*Pkd3*ct*k1*k2*(588*D1**2*K*bd1**2*f*r**2 + 168*D1**2*K*bd1**2*f*r*s + 2016*D1**2*K*bd1**2*f*r - 420*D1**2*K*bd1**2*f*s**2 + 2520*D1**2*K*bd1**2*f*s - 2100*D1**2*K*bd1**2*f + 810*D1**2*K*bd1*f**2*r**2 + 1188*D1**2*K*bd1*f**2*r*s - 1188*D1**2*K*bd1*f**2*r + 378*D1**2*K*bd1*f**2*s**2 - 756*D1**2*K*bd1*f**2*s + 378*D1**2*K*bd1*f**2 - 3384*D1**2*K*bd1*f*fd*r**2 - 5904*D1**2*K*bd1*f*fd*r*s + 4644*D1**2*K*bd1*f*fd*r - 2520*D1**2*K*bd1*f*fd*s**2 + 3996*D1**2*K*bd1*f*fd*s - 1476*D1**2*K*bd1*f*fd - 846*D1**2*K*bdd1*f**2*r**2 - 1476*D1**2*K*bdd1*f**2*r*s + 1476*D1**2*K*bdd1*f**2*r - 630*D1**2*K*bdd1*f**2*s**2 + 1260*D1**2*K*bdd1*f**2*s - 630*D1**2*K*bdd1*f**2 - 90*D1**2*bd1**2*f**2*r**2 + 828*D1**2*bd1**2*f**2*r*s - 684*D1**2*bd1**2*f**2*r + 918*D1**2*bd1**2*f**2*s**2 - 1620*D1**2*bd1**2*f**2*s + 954*D1**2*bd1**2*f**2 - 126*D1**2*bd1**2*f*r**2 + 588*D1**2*bd1**2*f*r*s - 1092*D1**2*bd1**2*f*r + 714*D1**2*bd1**2*f*s**2 - 2016*D1**2*bd1**2*f*s + 1302*D1**2*bd1**2*f - 6720*D1**2*bd1**2*g2*r**2 - 13440*D1**2*bd1**2*g2*r*s + 6720*D1**2*bd1**2*g2*r - 6720*D1**2*bd1**2*g2*s**2 + 6720*D1**2*bd1**2*g2*s - 1848*D1**2*bd1*bd2*f*r**2 - 3696*D1**2*bd1*bd2*f*r*s + 3948*D1**2*bd1*bd2*f*r - 1848*D1**2*bd1*bd2*f*s**2 + 3948*D1**2*bd1*bd2*f*s - 2100*D1**2*bd1*bd2*f - 205*D1**2*bd1*f**3*r**2 - 790*D1**2*bd1*f**3*r*s + 610*D1**2*bd1*f**3*r - 585*D1**2*bd1*f**3*s**2 + 810*D1**2*bd1*f**3*s - 405*D1**2*bd1*f**3 + 1290*D1**2*bd1*f**2*fd*r**2 + 5340*D1**2*bd1*f**2*fd*r*s - 3630*D1**2*bd1*f**2*fd*r + 4050*D1**2*bd1*f**2*fd*s**2 - 5570*D1**2*bd1*f**2*fd*s + 1700*D1**2*bd1*f**2*fd - 279*D1**2*bd1*f**2*r**2 - 630*D1**2*bd1*f**2*r*s + 630*D1**2*bd1*f**2*r - 351*D1**2*bd1*f**2*s**2 + 702*D1**2*bd1*f**2*s - 351*D1**2*bd1*f**2 + 1188*D1**2*bd1*f*fd*r**2 + 3528*D1**2*bd1*f*fd*r*s - 2358*D1**2*bd1*f*fd*r + 2340*D1**2*bd1*f*fd*s**2 - 3222*D1**2*bd1*f*fd*s + 882*D1**2*bd1*f*fd + 756*D1**2*bd1*f*g2*r**2 - 504*D1**2*bd1*f*g2*r*s + 2520*D1**2*bd1*f*g2*r - 1260*D1**2*bd1*f*g2*s**2 + 2520*D1**2*bd1*f*g2*s - 1260*D1**2*bd1*f*g2 - 1176*D1**2*bd1*f*gd2*r**2 - 336*D1**2*bd1*f*gd2*r*s - 4032*D1**2*bd1*f*gd2*r + 840*D1**2*bd1*f*gd2*s**2 - 5040*D1**2*bd1*f*gd2*s + 4200*D1**2*bd1*f*gd2 - 1176*D1**2*bd1*fd*g2*r**2 - 336*D1**2*bd1*fd*g2*r*s + 1176*D1**2*bd1*fd*g2*r + 840*D1**2*bd1*fd*g2*s**2 + 168*D1**2*bd1*fd*g2*s + 810*D1**2*bd2*f**2*r**2 + 1188*D1**2*bd2*f**2*r*s - 1188*D1**2*bd2*f**2*r + 378*D1**2*bd2*f**2*s**2 - 756*D1**2*bd2*f**2*s + 378*D1**2*bd2*f**2 - 3384*D1**2*bd2*f*fd*r**2 - 5904*D1**2*bd2*f*fd*r*s + 4644*D1**2*bd2*f*fd*r - 2520*D1**2*bd2*f*fd*s**2 + 3996*D1**2*bd2*f*fd*s - 1476*D1**2*bd2*f*fd + 215*D1**2*bdd1*f**3*r**2 + 890*D1**2*bdd1*f**3*r*s - 710*D1**2*bdd1*f**3*r + 675*D1**2*bdd1*f**3*s**2 - 990*D1**2*bdd1*f**3*s + 495*D1**2*bdd1*f**3 + 297*D1**2*bdd1*f**2*r**2 + 882*D1**2*bdd1*f**2*r*s - 882*D1**2*bdd1*f**2*r + 585*D1**2*bdd1*f**2*s**2 - 1170*D1**2*bdd1*f**2*s + 585*D1**2*bdd1*f**2 - 588*D1**2*bdd1*f*g2*r**2 - 168*D1**2*bdd1*f*g2*r*s - 4200*D1**2*bdd1*f*g2*r + 420*D1**2*bdd1*f*g2*s**2 - 4200*D1**2*bdd1*f*g2*s + 2100*D1**2*bdd1*f*g2 - 846*D1**2*bdd2*f**2*r**2 - 1476*D1**2*bdd2*f**2*r*s + 1476*D1**2*bdd2*f**2*r - 630*D1**2*bdd2*f**2*s**2 + 1260*D1**2*bdd2*f**2*s - 630*D1**2*bdd2*f**2 - 1620*D1**2*f**2*gd2*r**2 - 2376*D1**2*f**2*gd2*r*s + 2376*D1**2*f**2*gd2*r - 756*D1**2*f**2*gd2*s**2 + 1512*D1**2*f**2*gd2*s - 756*D1**2*f**2*gd2 + 1692*D1**2*f**2*gdd2*r**2 + 2952*D1**2*f**2*gdd2*r*s - 2952*D1**2*f**2*gdd2*r + 1260*D1**2*f**2*gdd2*s**2 - 2520*D1**2*f**2*gdd2*s + 1260*D1**2*f**2*gdd2 - 3240*D1**2*f*fd*g2*r**2 - 4752*D1**2*f*fd*g2*r*s + 3240*D1**2*f*fd*g2*r - 1512*D1**2*f*fd*g2*s**2 + 2376*D1**2*f*fd*g2*s - 1620*D1**2*f*fd*g2 + 6768*D1**2*f*fd*gd2*r**2 + 11808*D1**2*f*fd*gd2*r*s - 9288*D1**2*f*fd*gd2*r + 5040*D1**2*f*fd*gd2*s**2 - 7992*D1**2*f*fd*gd2*s + 2952*D1**2*f*fd*gd2 + 3384*D1**2*f*fdd*g2*r**2 + 5904*D1**2*f*fdd*g2*r*s - 3384*D1**2*f*fdd*g2*r + 2520*D1**2*f*fdd*g2*s**2 - 2952*D1**2*f*fdd*g2*s + 1692*D1**2*f*fdd*g2 + 3384*D1**2*fd**2*g2*r**2 + 5904*D1**2*fd**2*g2*r*s - 3384*D1**2*fd**2*g2*r + 2520*D1**2*fd**2*g2*s**2 - 2952*D1**2*fd**2*g2*s - 6768*D1*Dd*K*bd1*f**2*r**2 - 11808*D1*Dd*K*bd1*f**2*r*s + 10548*D1*Dd*K*bd1*f**2*r - 5040*D1*Dd*K*bd1*f**2*s**2 + 9036*D1*Dd*K*bd1*f**2*s - 3996*D1*Dd*K*bd1*f**2 + 1720*D1*Dd*bd1*f**3*r**2 + 7120*D1*Dd*bd1*f**3*r*s - 5050*D1*Dd*bd1*f**3*r + 5400*D1*Dd*bd1*f**3*s**2 - 7550*D1*Dd*bd1*f**3*s + 2690*D1*Dd*bd1*f**3 + 2376*D1*Dd*bd1*f**2*r**2 + 7056*D1*Dd*bd1*f**2*r*s - 5886*D1*Dd*bd1*f**2*r + 4680*D1*Dd*bd1*f**2*s**2 - 7902*D1*Dd*bd1*f**2*s + 3222*D1*Dd*bd1*f**2 - 4704*D1*Dd*bd1*f*g2*r**2 - 1344*D1*Dd*bd1*f*g2*r*s - 15288*D1*Dd*bd1*f*g2*r + 3360*D1*Dd*bd1*f*g2*s**2 - 18312*D1*Dd*bd1*f*g2*s + 12600*D1*Dd*bd1*f*g2 - 6768*D1*Dd*bd2*f**2*r**2 - 11808*D1*Dd*bd2*f**2*r*s + 10548*D1*Dd*bd2*f**2*r - 5040*D1*Dd*bd2*f**2*s**2 + 9036*D1*Dd*bd2*f**2*s - 3996*D1*Dd*bd2*f**2 - 6480*D1*Dd*f**2*g2*r**2 - 9504*D1*Dd*f**2*g2*r*s + 7992*D1*Dd*f**2*g2*r - 3024*D1*Dd*f**2*g2*s**2 + 5400*D1*Dd*f**2*g2*s - 3132*D1*Dd*f**2*g2 + 13536*D1*Dd*f**2*gd2*r**2 + 23616*D1*Dd*f**2*gd2*r*s - 21096*D1*Dd*f**2*gd2*r + 10080*D1*Dd*f**2*gd2*s**2 - 18072*D1*Dd*f**2*gd2*s + 7992*D1*Dd*f**2*gd2 + 27072*D1*Dd*f*fd*g2*r**2 + 47232*D1*Dd*f*fd*g2*r*s - 32112*D1*Dd*f*fd*g2*r + 20160*D1*Dd*f*fd*g2*s**2 - 27792*D1*Dd*f*fd*g2*s + 9288*D1*Dd*f*fd*g2 + 6768*D1*Ddd*f**2*g2*r**2 + 11808*D1*Ddd*f**2*g2*r*s - 9288*D1*Ddd*f**2*g2*r + 5040*D1*Ddd*f**2*g2*s**2 - 7992*D1*Ddd*f**2*g2*s + 4212*D1*Ddd*f**2*g2 + 20304*Dd**2*f**2*g2*r**2 + 35424*Dd**2*f**2*g2*r*s - 27864*Dd**2*f**2*g2*r + 15120*Dd**2*f**2*g2*s**2 - 23976*Dd**2*f**2*g2*s + 8424*Dd**2*f**2*g2 + 42*b1**3*(D1**2*(r + s - 1)*(3*fd*r + 13*fd*(s - 1) + fdd*(-9*r - 19*s + 19)) + D1*(Dd*(40*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(12*r**2 + r*(64*s - 38) + 52*s**2 - 68*s + 29) - 2*fd*(36*r**2 + r*(112*s - 93) + 76*s**2 - 128*s + 52) - 60*r**2 - 160*r*s + 110*r - 100*s**2 + 140*s - 65) - Ddd*f*(36*r**2 + 2*r*(56*s - 37) + 76*s**2 - 104*s + 47) + 5*Ddd*(8*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*r**2 + r*(22 - 32*s) - 20*s**2 + 28*s - 13)) - 2*Dd**2*(-120*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(54*r**2 + 3*r*(56*s - 37) + 114*s**2 - 156*s + 47) + 90*r**2 + 240*r*s - 165*r + 150*s**2 - 210*s + 65)) + 3*b1**2*(1680*D1**2*K*bdd1*r**2 + 3360*D1**2*K*bdd1*r*s - 2240*D1**2*K*bdd1*r + 1680*D1**2*K*bdd1*s**2 - 2240*D1**2*K*bdd1*s + 1120*D1**2*K*bdd1 - 126*D1**2*K*fd*r**2 + 84*D1**2*K*fd*r*s + 672*D1**2*K*fd*r + 210*D1**2*K*fd*s**2 + 336*D1**2*K*fd*s - 336*D1**2*K*fd + 98*D1**2*K*fdd*r**2 + 28*D1**2*K*fdd*r*s - 896*D1**2*K*fdd*r - 70*D1**2*K*fdd*s**2 - 728*D1**2*K*fdd*s + 448*D1**2*K*fdd - 378*D1**2*bdd1*f*r**2 - 1176*D1**2*bdd1*f*r*s + 644*D1**2*bdd1*f*r - 798*D1**2*bdd1*f*s**2 + 924*D1**2*bdd1*f*s - 392*D1**2*bdd1*f - 630*D1**2*bdd1*r**2 - 1680*D1**2*bdd1*r*s + 980*D1**2*bdd1*r - 1050*D1**2*bdd1*s**2 + 1260*D1**2*bdd1*s - 560*D1**2*bdd1 + 70*D1**2*bdd2*r**2 + 140*D1**2*bdd2*r*s - 140*D1**2*bdd2*r + 70*D1**2*bdd2*s**2 - 140*D1**2*bdd2*s + 70*D1**2*bdd2 + 18*D1**2*f*fd*r**2 - 300*D1**2*f*fd*r*s + 78*D1**2*f*fd*r - 318*D1**2*f*fd*s**2 + 294*D1**2*f*fd*s - 165*D1**2*f*fd - 30*D1**2*f*fdd*r**2 + 276*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r + 306*D1**2*f*fdd*s**2 - 210*D1**2*f*fdd*s + 135*D1**2*f*fdd - 30*D1**2*fd**2*r**2 + 276*D1**2*fd**2*r*s - 18*D1**2*fd**2*r + 306*D1**2*fd**2*s**2 - 210*D1**2*fd**2*s - 96*D1**2*fd**2 + 7*D1**2*fd*r**2 - 126*D1**2*fd*r*s - 196*D1**2*fd*r - 133*D1**2*fd*s**2 - 112*D1**2*fd*s + 98*D1**2*fd - 21*D1**2*fdd*r**2 + 98*D1**2*fdd*r*s + 308*D1**2*fdd*r + 119*D1**2*fdd*s**2 + 336*D1**2*fdd*s - 154*D1**2*fdd - 1120*D1**2*gd2*r**2 - 2240*D1**2*gd2*r*s + 2240*D1**2*gd2*r - 1120*D1**2*gd2*s**2 + 2240*D1**2*gd2*s - 1120*D1**2*gd2 - 1120*D1**2*gdd2*r**2 - 2240*D1**2*gdd2*r*s + 2240*D1**2*gdd2*r - 1120*D1**2*gdd2*s**2 + 2240*D1**2*gdd2*s - 1120*D1**2*gdd2 - 504*D1*Dd*K*f*r**2 + 336*D1*Dd*K*f*r*s + 84*D1*Dd*K*f*r + 840*D1*Dd*K*f*s**2 - 924*D1*Dd*K*f*s + 294*D1*Dd*K*f + 784*D1*Dd*K*fd*r**2 + 224*D1*Dd*K*fd*r*s - 3836*D1*Dd*K*fd*r - 560*D1*Dd*K*fd*s**2 - 2660*D1*Dd*K*fd*s + 2352*D1*Dd*K*fd + 280*D1*Dd*b2*r**2 + 560*D1*Dd*b2*r*s - 420*D1*Dd*b2*r + 280*D1*Dd*b2*s**2 - 420*D1*Dd*b2*s + 210*D1*Dd*b2 + 36*D1*Dd*f**2*r**2 - 600*D1*Dd*f**2*r*s + 282*D1*Dd*f**2*r - 636*D1*Dd*f**2*s**2 + 786*D1*Dd*f**2*s - 309*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 + 2208*D1*Dd*f*fd*r*s - 564*D1*Dd*f*fd*r + 2448*D1*Dd*f*fd*s**2 - 2340*D1*Dd*f*fd*s + 438*D1*Dd*f*fd + 28*D1*Dd*f*r**2 - 504*D1*Dd*f*r*s + 238*D1*Dd*f*r - 532*D1*Dd*f*s**2 + 658*D1*Dd*f*s - 259*D1*Dd*f - 168*D1*Dd*fd*r**2 + 784*D1*Dd*fd*r*s + 1078*D1*Dd*fd*r + 952*D1*Dd*fd*s**2 + 770*D1*Dd*fd*s - 980*D1*Dd*fd - 4480*D1*Dd*g2*r**2 - 8960*D1*Dd*g2*r*s + 6720*D1*Dd*g2*r - 4480*D1*Dd*g2*s**2 + 6720*D1*Dd*g2*s - 3360*D1*Dd*g2 - 8960*D1*Dd*gd2*r**2 - 17920*D1*Dd*gd2*r*s + 15680*D1*Dd*gd2*r - 8960*D1*Dd*gd2*s**2 + 15680*D1*Dd*gd2*s - 6720*D1*Dd*gd2 + 392*D1*Ddd*K*f*r**2 + 112*D1*Ddd*K*f*r*s - 252*D1*Ddd*K*f*r - 280*D1*Ddd*K*f*s**2 + 252*D1*Ddd*K*f*s - 42*D1*Ddd*K*f + 280*D1*Ddd*b2*r**2 + 560*D1*Ddd*b2*r*s - 420*D1*Ddd*b2*r + 280*D1*Ddd*b2*s**2 - 420*D1*Ddd*b2*s + 210*D1*Ddd*b2 - 60*D1*Ddd*f**2*r**2 + 552*D1*Ddd*f**2*r*s - 246*D1*Ddd*f**2*r + 612*D1*Ddd*f**2*s**2 - 750*D1*Ddd*f**2*s + 291*D1*Ddd*f**2 - 84*D1*Ddd*f*r**2 + 392*D1*Ddd*f*r*s - 154*D1*Ddd*f*r + 476*D1*Ddd*f*s**2 - 574*D1*Ddd*f*s + 217*D1*Ddd*f - 4480*D1*Ddd*g2*r**2 - 8960*D1*Ddd*g2*r*s + 6720*D1*Ddd*g2*r - 4480*D1*Ddd*g2*s**2 + 6720*D1*Ddd*g2*s - 3360*D1*Ddd*g2 + 14*D1*bd1*(D1*f*(9*r**2 + r*(48*s - 22) + 39*s**2 - 42*s + 16) - 2*D1*fd*(27*r**2 + r*(84*s - 65) + 57*s**2 - 90*s + 33) + 5*D1*(8*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*r**2 + r*(14 - 24*s) - 15*s**2 + 18*s - 8) - 2*Dd*f*(108*r**2 + 7*r*(48*s - 29) + 228*s**2 - 288*s + 89) + 10*Dd*(8*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 36*r**2 + r*(61 - 96*s) - 60*s**2 + 78*s - 25)) + 70*D1*bd2*(D1*(r + s - 1) + 2*Dd*(4*r + 4*s - 3))*(r + s - 1) + 1176*Dd**2*K*f*r**2 + 336*Dd**2*K*f*r*s - 756*Dd**2*K*f*r - 840*Dd**2*K*f*s**2 + 756*Dd**2*K*f*s - 84*Dd**2*K*f + 840*Dd**2*b2*r**2 + 1680*Dd**2*b2*r*s - 1260*Dd**2*b2*r + 840*Dd**2*b2*s**2 - 1260*Dd**2*b2*s + 420*Dd**2*b2 - 180*Dd**2*f**2*r**2 + 1656*Dd**2*f**2*r*s - 738*Dd**2*f**2*r + 1836*Dd**2*f**2*s**2 - 2250*Dd**2*f**2*s + 582*Dd**2*f**2 - 252*Dd**2*f*r**2 + 1176*Dd**2*f*r*s - 462*Dd**2*f*r + 1428*Dd**2*f*s**2 - 1722*Dd**2*f*s + 434*Dd**2*f - 13440*Dd**2*g2*r**2 - 26880*Dd**2*g2*r*s + 20160*Dd**2*g2*r - 13440*Dd**2*g2*s**2 + 20160*Dd**2*g2*s - 6720*Dd**2*g2) + b1*(588*D1**2*K*bdd1*f*r**2 + 168*D1**2*K*bdd1*f*r*s + 2016*D1**2*K*bdd1*f*r - 420*D1**2*K*bdd1*f*s**2 + 2520*D1**2*K*bdd1*f*s - 1260*D1**2*K*bdd1*f + 1620*D1**2*K*f*fd*r**2 + 2376*D1**2*K*f*fd*r*s - 1620*D1**2*K*f*fd*r + 756*D1**2*K*f*fd*s**2 - 1188*D1**2*K*f*fd*s + 810*D1**2*K*f*fd - 1692*D1**2*K*f*fdd*r**2 - 2952*D1**2*K*f*fdd*r*s + 1692*D1**2*K*f*fdd*r - 1260*D1**2*K*f*fdd*s**2 + 1476*D1**2*K*f*fdd*s - 846*D1**2*K*f*fdd - 1692*D1**2*K*fd**2*r**2 - 2952*D1**2*K*fd**2*r*s + 1692*D1**2*K*fd**2*r - 1260*D1**2*K*fd**2*s**2 + 1476*D1**2*K*fd**2*s - 84*D1**2*bd1**2*(-40*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(27*r**2 + r*(84*s - 46) + 57*s**2 - 66*s + 14) + 45*r**2 + 120*r*s - 70*r + 75*s**2 - 90*s + 20) + 588*D1**2*bd2*f*r**2 + 1176*D1**2*bd2*f*r*s - 1176*D1**2*bd2*f*r + 588*D1**2*bd2*f*s**2 - 1176*D1**2*bd2*f*s + 588*D1**2*bd2*f - 1848*D1**2*bd2*fd*r**2 - 3696*D1**2*bd2*fd*r*s + 1596*D1**2*bd2*fd*r - 1848*D1**2*bd2*fd*s**2 + 1596*D1**2*bd2*fd*s + 252*D1**2*bd2*fd - 90*D1**2*bdd1*f**2*r**2 + 828*D1**2*bdd1*f**2*r*s - 684*D1**2*bdd1*f**2*r + 918*D1**2*bdd1*f**2*s**2 - 1620*D1**2*bdd1*f**2*s + 468*D1**2*bdd1*f**2 - 126*D1**2*bdd1*f*r**2 + 588*D1**2*bdd1*f*r*s - 1092*D1**2*bdd1*f*r + 714*D1**2*bdd1*f*s**2 - 2016*D1**2*bdd1*f*s + 756*D1**2*bdd1*f - 6720*D1**2*bdd1*g2*r**2 - 13440*D1**2*bdd1*g2*r*s + 6720*D1**2*bdd1*g2*r - 6720*D1**2*bdd1*g2*s**2 + 6720*D1**2*bdd1*g2*s - 3360*D1**2*bdd1*g2 - 924*D1**2*bdd2*f*r**2 - 1848*D1**2*bdd2*f*r*s + 1848*D1**2*bdd2*f*r - 924*D1**2*bdd2*f*s**2 + 1848*D1**2*bdd2*f*s - 924*D1**2*bdd2*f - 615*D1**2*f**2*fd*r**2 - 2370*D1**2*f**2*fd*r*s + 1380*D1**2*f**2*fd*r - 1755*D1**2*f**2*fd*s**2 + 2320*D1**2*f**2*fd*s - 970*D1**2*f**2*fd + 645*D1**2*f**2*fdd*r**2 + 2670*D1**2*f**2*fdd*r*s - 1500*D1**2*f**2*fdd*r + 2025*D1**2*f**2*fdd*s**2 - 2600*D1**2*f**2*fdd*s + 1070*D1**2*f**2*fdd + 1290*D1**2*f*fd**2*r**2 + 5340*D1**2*f*fd**2*r*s - 3000*D1**2*f*fd**2*r + 4050*D1**2*f*fd**2*s**2 - 5200*D1**2*f*fd**2*s + 1430*D1**2*f*fd**2 - 558*D1**2*f*fd*r**2 - 1260*D1**2*f*fd*r*s + 558*D1**2*f*fd*r - 702*D1**2*f*fd*s**2 + 630*D1**2*f*fd*s - 279*D1**2*f*fd + 594*D1**2*f*fdd*r**2 + 1764*D1**2*f*fdd*r*s - 594*D1**2*f*fdd*r + 1170*D1**2*f*fdd*s**2 - 882*D1**2*f*fdd*s + 297*D1**2*f*fdd + 756*D1**2*f*gd2*r**2 - 504*D1**2*f*gd2*r*s + 504*D1**2*f*gd2*r - 1260*D1**2*f*gd2*s**2 + 2520*D1**2*f*gd2*s - 1260*D1**2*f*gd2 - 588*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r + 420*D1**2*f*gdd2*s**2 - 840*D1**2*f*gdd2*s + 420*D1**2*f*gdd2 + 594*D1**2*fd**2*r**2 + 1764*D1**2*fd**2*r*s - 594*D1**2*fd**2*r + 1170*D1**2*fd**2*s**2 - 882*D1**2*fd**2*s + 756*D1**2*fd*g2*r**2 - 504*D1**2*fd*g2*r*s - 4032*D1**2*fd*g2*r - 1260*D1**2*fd*g2*s**2 - 2016*D1**2*fd*g2*s + 2016*D1**2*fd*g2 - 1176*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 5544*D1**2*fd*gd2*r + 840*D1**2*fd*gd2*s**2 + 3528*D1**2*fd*gd2*s - 4368*D1**2*fd*gd2 - 588*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s + 5376*D1**2*fdd*g2*r + 420*D1**2*fdd*g2*s**2 + 4368*D1**2*fdd*g2*s - 2688*D1**2*fdd*g2 + 3240*D1*Dd*K*f**2*r**2 + 4752*D1*Dd*K*f**2*r*s - 3996*D1*Dd*K*f**2*r + 1512*D1*Dd*K*f**2*s**2 - 2700*D1*Dd*K*f**2*s + 1566*D1*Dd*K*f**2 - 13536*D1*Dd*K*f*fd*r**2 - 23616*D1*Dd*K*f*fd*r*s + 16056*D1*Dd*K*f*fd*r - 10080*D1*Dd*K*f*fd*s**2 + 13896*D1*Dd*K*f*fd*s - 4644*D1*Dd*K*f*fd - 7392*D1*Dd*bd2*f*r**2 - 14784*D1*Dd*bd2*f*r*s + 12936*D1*Dd*bd2*f*r - 7392*D1*Dd*bd2*f*s**2 + 12936*D1*Dd*bd2*f*s - 5544*D1*Dd*bd2*f - 820*D1*Dd*f**3*r**2 - 3160*D1*Dd*f**3*r*s + 1990*D1*Dd*f**3*r - 2340*D1*Dd*f**3*s**2 + 3130*D1*Dd*f**3*s - 1375*D1*Dd*f**3 + 5160*D1*Dd*f**2*fd*r**2 + 21360*D1*Dd*f**2*fd*r*s - 12630*D1*Dd*f**2*fd*r + 16200*D1*Dd*f**2*fd*s**2 - 21170*D1*Dd*f**2*fd*s + 6700*D1*Dd*f**2*fd - 1116*D1*Dd*f**2*r**2 - 2520*D1*Dd*f**2*r*s + 1818*D1*Dd*f**2*r - 1404*D1*Dd*f**2*s**2 + 2034*D1*Dd*f**2*s - 981*D1*Dd*f**2 + 4752*D1*Dd*f*fd*r**2 + 14112*D1*Dd*f*fd*r*s - 7092*D1*Dd*f*fd*r + 9360*D1*Dd*f*fd*s**2 - 9972*D1*Dd*f*fd*s + 2358*D1*Dd*f*fd + 3024*D1*Dd*f*g2*r**2 - 2016*D1*Dd*f*g2*r*s - 504*D1*Dd*f*g2*r - 5040*D1*Dd*f*g2*s**2 + 5544*D1*Dd*f*g2*s - 1764*D1*Dd*f*g2 - 4704*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 2184*D1*Dd*f*gd2*r + 3360*D1*Dd*f*gd2*s**2 - 4872*D1*Dd*f*gd2*s + 1512*D1*Dd*f*gd2 - 4704*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 23016*D1*Dd*fd*g2*r + 3360*D1*Dd*fd*g2*s**2 + 15960*D1*Dd*fd*g2*s - 14112*D1*Dd*fd*g2 - 3384*D1*Ddd*K*f**2*r**2 - 5904*D1*Ddd*K*f**2*r*s + 4644*D1*Ddd*K*f**2*r - 2520*D1*Ddd*K*f**2*s**2 + 3996*D1*Ddd*K*f**2*s - 2106*D1*Ddd*K*f**2 + 860*D1*Ddd*f**3*r**2 + 3560*D1*Ddd*f**3*r*s - 2210*D1*Ddd*f**3*r + 2700*D1*Ddd*f**3*s**2 - 3590*D1*Ddd*f**3*s + 1565*D1*Ddd*f**3 + 1188*D1*Ddd*f**2*r**2 + 3528*D1*Ddd*f**2*r*s - 2358*D1*Ddd*f**2*r + 2340*D1*Ddd*f**2*s**2 - 3222*D1*Ddd*f**2*s + 1467*D1*Ddd*f**2 - 2352*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 1512*D1*Ddd*f*g2*r + 1680*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 252*D1*Ddd*f*g2 + 6*D1*bd1*(70*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(3*f**2*(3*r**2 + r*(34 - 50*s) - 53*s**2 + 82*s - 24) + f*(-42*K*(3*r**2 - 2*r*(s - 3) - 5*(s - 1)**2) - 6*fd*(10*r**2 + r*(41 - 92*s) - 102*s**2 + 125*s - 30) + 7*r**2 - 126*r*s + 154*r - 133*s**2 + 252*s - 112) + 14*fd*(2*K*(7*r**2 + 2*r*(s - 10) - 5*s**2 - 11*s + 13) - 3*r**2 + 14*r*s + 9*r + 17*s**2 - 12) - 560*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 1120*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*(f**2*(60*r**2 + r*(351 - 552*s) - 612*s**2 + 915*s - 327) - 7*f*(2*K*(28*r**2 + r*(8*s + 39) - 20*s**2 + 69*s - 42) - 12*r**2 + 7*r*(8*s - 9) + 68*s**2 - 137*s + 61) + 560*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 10152*Dd**2*K*f**2*r**2 - 17712*Dd**2*K*f**2*r*s + 13932*Dd**2*K*f**2*r - 7560*Dd**2*K*f**2*s**2 + 11988*Dd**2*K*f**2*s - 4212*Dd**2*K*f**2 + 2580*Dd**2*f**3*r**2 + 10680*Dd**2*f**3*r*s - 6630*Dd**2*f**3*r + 8100*Dd**2*f**3*s**2 - 10770*Dd**2*f**3*s + 3130*Dd**2*f**3 + 3564*Dd**2*f**2*r**2 + 10584*Dd**2*f**2*r*s - 7074*Dd**2*f**2*r + 7020*Dd**2*f**2*s**2 - 9666*Dd**2*f**2*s + 2934*Dd**2*f**2 - 7056*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 4536*Dd**2*f*g2*r + 5040*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 504*Dd**2*f*g2 + 42*b2*(5*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 14*D1**2*fd*r**2 + 28*D1**2*fd*r*s + 2*D1**2*fd*r + 14*D1**2*fd*s**2 + 2*D1**2*fd*s - D1**2*fd - 22*D1**2*fdd*r**2 - 44*D1**2*fdd*r*s - 6*D1**2*fdd*r - 22*D1**2*fdd*s**2 - 6*D1**2*fdd*s + 3*D1**2*fdd + 56*D1*Dd*f*r**2 + 112*D1*Dd*f*r*s - 84*D1*Dd*f*r + 56*D1*Dd*f*s**2 - 84*D1*Dd*f*s + 42*D1*Dd*f - 176*D1*Dd*fd*r**2 - 352*D1*Dd*fd*r*s + 108*D1*Dd*fd*r - 176*D1*Dd*fd*s**2 + 108*D1*Dd*fd*s + 18*D1*Dd*fd - 88*D1*Ddd*f*r**2 - 176*D1*Ddd*f*r*s + 132*D1*Ddd*f*r - 88*D1*Ddd*f*s**2 + 132*D1*Ddd*f*s - 66*D1*Ddd*f + 5*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 264*Dd**2*f*r**2 - 528*Dd**2*f*r*s + 396*Dd**2*f*r - 264*Dd**2*f*s**2 + 396*Dd**2*f*s - 132*Dd**2*f)) + 6*b2*(70*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 7*D1**2*bdd1*f*(22*r**2 + r*(44*s - 50) + 22*s**2 - 50*s + 25) + 3*D1**2*(f*(3*fd*(30*r**2 + 44*r*s - 30*r + 14*s**2 - 22*s + 15) - fdd*(94*r**2 + 164*r*s - 94*r + 70*s**2 - 82*s + 47)) - 2*fd**2*(47*r**2 + r*(82*s - 47) + s*(35*s - 41))) + 7*D1*bd1*(D1*(f*(14*r**2 + r*(28*s - 30) + 14*s**2 - 30*s + 15) - 44*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(88*r**2 + 2*r*(88*s - 83) + 88*s**2 - 166*s + 75)) + 3*D1*f*(Dd*(3*f*(60*r**2 + 88*r*s - 74*r + 28*s**2 - 50*s + 29) - 2*fd*(376*r**2 + 656*r*s - 446*r + 280*s**2 - 386*s + 129)) - Ddd*f*(188*r**2 + r*(328*s - 258) + 140*s**2 - 222*s + 117)) - 18*Dd**2*f**2*(94*r**2 + r*(164*s - 129) + 70*s**2 - 111*s + 39)))/(630*d**2*k3**3) - D1**2*Pk1*Pkd3*ct*k1*st**2*(4*C - 2)*(D1*f*(-21*D1*bd1**2*s*(2*r + 2*s - 1) + D1*bd1*(11*f*s*(r + s) - 9*fd*(r*(4*s - 1) + s*(4*s - 3))) - 9*D1*bdd1*f*s*(r + s) - 9*Dd*bd1*f*(r*(8*s - 2) + s*(8*s - 5))) + 7*b1**2*(D1**2*(fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(D1**2*(f*(-21*bdd1*s*(2*r + 2*s - 1) + 11*fd*(2*s - 1)*(r + s - 1) - 9*fdd*(2*s - 1)*(r + s - 1)) - 9*fd**2*(2*s - 1)*(r + s - 1)) + 7*D1*bd1*(D1*(f*s*(2*r + 2*s - 1) - 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 6*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(11*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 9*fd*(2*s - 1)*(8*r + 8*s - 7)) - 9*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 9*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(105*d**2*k2*k3) + D1**2*Pk1*Pkd3*ct*k1*(4*C - 2)*(D1*f*(-5*D1*bd1**2*s*(2*r + 2*s - 1) - 3*D1*bdd1*f*s*(r + s) - 3*bd1*(D1*(-f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 2) + s*(8*s - 5)))) + 5*b1**2*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(-5*bdd1*s*(2*r + 2*s - 1) + 3*fd*(2*s - 1)*(r + s - 1) - 3*fdd*(2*s - 1)*(r + s - 1)) - 3*fd**2*(2*s - 1)*(r + s - 1)) + 5*D1*bd1*(-D1*(f*s*(-2*r - 2*s + 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + 3*D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 3*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(15*d**2*k2*k3) - D1**2*Pk1*Pkd3*ct*k2**5*st**6*(288*C*D1**2*b1*f*fd*r**2 + 288*C*D1**2*b1*f*fd*r*s - 144*C*D1**2*b1*f*fd*r - 144*C*D1**2*b1*f*fdd*r**2 - 144*C*D1**2*b1*f*fdd*r*s + 72*C*D1**2*b1*f*fdd*r - 144*C*D1**2*b1*fd**2*r**2 - 144*C*D1**2*b1*fd**2*r*s + 72*C*D1**2*b1*fd**2*r + 48*C*D1**2*f**2*fd*r**2 + 48*C*D1**2*f**2*fd*r*s - 48*C*D1**2*f**2*fd*r - 16*C*D1**2*f**2*fd*s + 16*C*D1**2*f**2*fd - 24*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 24*C*D1**2*f**2*fdd*r + 8*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 48*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 48*C*D1**2*f*fd**2*r + 16*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 576*C*D1*Dd*b1*f**2*r**2 + 576*C*D1*Dd*b1*f**2*r*s - 576*C*D1*Dd*b1*f**2*r - 144*C*D1*Dd*b1*f**2*s + 144*C*D1*Dd*b1*f**2 - 1152*C*D1*Dd*b1*f*fd*r**2 - 1152*C*D1*Dd*b1*f*fd*r*s + 864*C*D1*Dd*b1*f*fd*r + 144*C*D1*Dd*b1*f*fd*s - 72*C*D1*Dd*b1*f*fd + 64*C*D1*Dd*f**3*r**2 + 64*C*D1*Dd*f**3*r*s - 64*C*D1*Dd*f**3*r - 16*C*D1*Dd*f**3*s + 16*C*D1*Dd*f**3 - 192*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 192*C*D1*Dd*f**2*fd*r + 56*C*D1*Dd*f**2*fd*s - 40*C*D1*Dd*f**2*fd - 288*C*D1*Ddd*b1*f**2*r**2 - 288*C*D1*Ddd*b1*f**2*r*s + 288*C*D1*Ddd*b1*f**2*r + 72*C*D1*Ddd*b1*f**2*s - 72*C*D1*Ddd*b1*f**2 - 32*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 32*C*D1*Ddd*f**3*r + 8*C*D1*Ddd*f**3*s - 8*C*D1*Ddd*f**3 - 864*C*Dd**2*b1*f**2*r**2 - 864*C*Dd**2*b1*f**2*r*s + 864*C*Dd**2*b1*f**2*r + 216*C*Dd**2*b1*f**2*s - 144*C*Dd**2*b1*f**2 - 96*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 96*C*Dd**2*f**3*r + 24*C*Dd**2*f**3*s - 16*C*Dd**2*f**3 - 468*D1**2*b1*f*fd*r**2 - 648*D1**2*b1*f*fd*r*s + 324*D1**2*b1*f*fd*r - 180*D1**2*b1*f*fd*s**2 + 180*D1**2*b1*f*fd*s - 90*D1**2*b1*f*fd + 234*D1**2*b1*f*fdd*r**2 + 324*D1**2*b1*f*fdd*r*s - 162*D1**2*b1*f*fdd*r + 90*D1**2*b1*f*fdd*s**2 - 90*D1**2*b1*f*fdd*s + 45*D1**2*b1*f*fdd + 234*D1**2*b1*fd**2*r**2 + 324*D1**2*b1*fd**2*r*s - 162*D1**2*b1*fd**2*r + 90*D1**2*b1*fd**2*s**2 - 90*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)*(8*C*(r - 1) - 13*r - 5*s + 13) - 78*D1**2*f**2*fd*r**2 - 108*D1**2*f**2*fd*r*s + 88*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 56*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 39*D1**2*f**2*fdd*r**2 + 54*D1**2*f**2*fdd*r*s - 44*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 28*D1**2*f**2*fdd*s + 18*D1**2*f**2*fdd + 78*D1**2*f*fd**2*r**2 + 108*D1**2*f*fd**2*r*s - 88*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 56*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 - 936*D1*Dd*b1*f**2*r**2 - 1296*D1*Dd*b1*f**2*r*s + 1116*D1*Dd*b1*f**2*r - 360*D1*Dd*b1*f**2*s**2 + 684*D1*Dd*b1*f**2*s - 414*D1*Dd*b1*f**2 + 1872*D1*Dd*b1*f*fd*r**2 + 2592*D1*Dd*b1*f*fd*r*s - 1764*D1*Dd*b1*f*fd*r + 720*D1*Dd*b1*f*fd*s**2 - 1044*D1*Dd*b1*f*fd*s + 342*D1*Dd*b1*f*fd - 104*D1*Dd*f**3*r**2 - 144*D1*Dd*f**3*r*s + 124*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 76*D1*Dd*f**3*s - 46*D1*Dd*f**3 + 312*D1*Dd*f**2*fd*r**2 + 432*D1*Dd*f**2*fd*r*s - 362*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 226*D1*Dd*f**2*fd*s + 100*D1*Dd*f**2*fd + 468*D1*Ddd*b1*f**2*r**2 + 648*D1*Ddd*b1*f**2*r*s - 558*D1*Ddd*b1*f**2*r + 180*D1*Ddd*b1*f**2*s**2 - 342*D1*Ddd*b1*f**2*s + 207*D1*Ddd*b1*f**2 + 52*D1*Ddd*f**3*r**2 + 72*D1*Ddd*f**3*r*s - 62*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 38*D1*Ddd*f**3*s + 23*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1)*(8*C*(r - 1) - 13*r - 5*s + 13) + fd*(-4*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 26*r**2 + 36*r*s - 35*r + 10*s**2 - 23*s + 9)) + Dd*f*(-4*C*(8*r**2 + 8*r*s - 12*r - 5*s + 4) + 52*r**2 + 72*r*s - 83*r + 20*s**2 - 55*s + 31)) + 1404*Dd**2*b1*f**2*r**2 + 1944*Dd**2*b1*f**2*r*s - 1674*Dd**2*b1*f**2*r + 540*Dd**2*b1*f**2*s**2 - 1026*Dd**2*b1*f**2*s + 414*Dd**2*b1*f**2 + 156*Dd**2*f**3*r**2 + 216*Dd**2*f**3*r*s - 186*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 114*Dd**2*f**3*s + 46*Dd**2*f**3)/(126*d**2*k1*k3**5) + D1**2*Pk1*Pkd3*ct*k2**5*st**4*(792*C*D1**2*f**2*fd*r**2 + 792*C*D1**2*f**2*fd*r*s - 792*C*D1**2*f**2*fd*r - 264*C*D1**2*f**2*fd*s + 264*C*D1**2*f**2*fd + 1056*C*D1*Dd*f**3*r**2 + 1056*C*D1*Dd*f**3*r*s - 1056*C*D1*Dd*f**3*r - 264*C*D1*Dd*f**3*s + 264*C*D1*Dd*f**3 + 132*D1**2*K*bdd1*f**2*r**2 + 132*D1**2*K*bdd1*f**2*r*s - 132*D1**2*K*bdd1*f**2*r - 66*D1**2*bd1**2*f*(r + s - 1)*(-7*K*(4*r - 2) + 25*f*(2*r + 2*s - 1) + 63*r + 35*s - 49) + 605*D1**2*bdd1*f**3*r**2 + 1870*D1**2*bdd1*f**3*r*s - 2200*D1**2*bdd1*f**3*r + 1265*D1**2*bdd1*f**3*s**2 - 2860*D1**2*bdd1*f**3*s + 1320*D1**2*bdd1*f**3 - 297*D1**2*bdd1*f**2*r**2 - 462*D1**2*bdd1*f**2*r*s + 462*D1**2*bdd1*f**2*r - 165*D1**2*bdd1*f**2*s**2 + 330*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 - 1848*D1**2*bdd1*f*g2*r**2 - 1848*D1**2*bdd1*f*g2*r*s + 3696*D1**2*bdd1*f*g2*r + 1848*D1**2*bdd1*f*g2*s - 1848*D1**2*bdd1*f*g2 - 2796*D1**2*f**3*fd*r**2 - 4776*D1**2*f**3*fd*r*s + 3786*D1**2*f**3*fd*r - 1980*D1**2*f**3*fd*s**2 + 3174*D1**2*f**3*fd*s - 1689*D1**2*f**3*fd + 3620*D1**2*f**3*fdd*r**2 + 6040*D1**2*f**3*fdd*r*s - 4830*D1**2*f**3*fdd*r + 2420*D1**2*f**3*fdd*s**2 - 3930*D1**2*f**3*fdd*s + 2115*D1**2*f**3*fdd + 10860*D1**2*f**2*fd**2*r**2 + 18120*D1**2*f**2*fd**2*r*s - 14490*D1**2*f**2*fd**2*r + 7260*D1**2*f**2*fd**2*s**2 - 11790*D1**2*f**2*fd**2*s + 4230*D1**2*f**2*fd**2 - 1287*D1**2*f**2*fd*r**2 - 1782*D1**2*f**2*fd*r*s + 1452*D1**2*f**2*fd*r - 495*D1**2*f**2*fd*s**2 + 924*D1**2*f**2*fd*s - 594*D1**2*f**2*fd + 528*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r - 264*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r + 1056*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 1056*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s + 528*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 1056*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 528*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s - 264*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 528*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s - 2796*D1*Dd*f**4*r**2 - 4776*D1*Dd*f**4*r*s + 3786*D1*Dd*f**4*r - 1980*D1*Dd*f**4*s**2 + 3174*D1*Dd*f**4*s - 1689*D1*Dd*f**4 + 28960*D1*Dd*f**3*fd*r**2 + 48320*D1*Dd*f**3*fd*r*s - 38640*D1*Dd*f**3*fd*r + 19360*D1*Dd*f**3*fd*s**2 - 31440*D1*Dd*f**3*fd*s + 12690*D1*Dd*f**3*fd - 1716*D1*Dd*f**3*r**2 - 2376*D1*Dd*f**3*r*s + 2046*D1*Dd*f**3*r - 660*D1*Dd*f**3*s**2 + 1254*D1*Dd*f**3*s - 759*D1*Dd*f**3 + 2112*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 2112*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s + 528*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 2112*D1*Dd*f**2*gd2*r + 264*D1*Dd*f**2*gd2*s - 264*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 4224*D1*Dd*f*fd*g2*r + 1584*D1*Dd*f*fd*g2*s - 1056*D1*Dd*f*fd*g2 + 3620*D1*Ddd*f**4*r**2 + 6040*D1*Ddd*f**4*r*s - 4830*D1*Ddd*f**4*r + 2420*D1*Ddd*f**4*s**2 - 3930*D1*Ddd*f**4*s + 2115*D1*Ddd*f**4 - 1056*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 1056*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s - 264*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(f**3*(r**2 + r*(130 - 34*s) - 35*s**2 + 166*s - 81) + f**2*(168*C*(r - 1)*(r + s - 1) + 10*fd*(33*r**2 + 17*r*(6*s - 5) + 69*s**2 - 115*s + 48) - (3*r + 3*s - 3)*(r*(8*K + 73) + 25*s - 81)) + 6*f*(fd*(K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 18*r**2 - 28*r*s + 23*r - 10*s**2 + 17*s - 7) + (r + s - 1)*(56*g2*(r - 1) - 56*gd2*r + 28*gd2)) - 168*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + 2*Dd*f*(5*f**2*(44*r**2 + r*(136*s - 125) + 92*s**2 - 167*s + 72) + 3*f*(2*K*(8*r**2 + 8*r*(s - 1) - s + 1) - 36*r**2 - 56*r*s + 51*r - 20*s**2 + 37*s - 17) - 84*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 10860*Dd**2*f**4*r**2 + 18120*Dd**2*f**4*r*s - 14490*Dd**2*f**4*r + 7260*Dd**2*f**4*s**2 - 11790*Dd**2*f**4*s + 4230*Dd**2*f**4 - 3168*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 3168*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s - 528*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(25*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 50*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 14*fd*(r + s)*(r*(4*K - 9) - 5*s) + 7*fdd*(r + s)*(r*(4*K - 9) - 5*s)) + D1*(2*Dd*(50*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-28*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 25*fd*(4*r + 4*s - 3)**2 + 252*r**2 + 392*r*s - 322*r + 140*s**2 - 238*s + 133) + 7*fd*(r**2*(16*K - 36) + r*(16*K*s - 8*K - 56*s + 23) + s*(-2*K - 20*s + 17))) - Ddd*f*(-28*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 50*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 252*r**2 + 392*r*s - 322*r + 140*s**2 - 238*s + 133)) - 2*Dd**2*f*(-7*K*(24*r**2 + 24*r*(s - 1) - 6*s + 4) + 150*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 378*r**2 + 588*r*s - 483*r + 210*s**2 - 357*s + 133)) + 11*b1*(336*C*D1**2*f*fd*r**2 + 336*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r + 672*C*D1*Dd*f**2*r**2 + 672*C*D1*Dd*f**2*r*s - 672*C*D1*Dd*f**2*r - 168*C*D1*Dd*f**2*s + 168*C*D1*Dd*f**2 - 48*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 48*D1**2*K*f*fd*r + 24*D1**2*K*f*fd*s - 24*D1**2*K*f*fd + 24*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r*s - 24*D1**2*K*f*fdd*r - 12*D1**2*K*f*fdd*s + 12*D1**2*K*f*fdd + 24*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r*s - 24*D1**2*K*fd**2*r - 12*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(25*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s - 1)*(-56*K*r + 28*K + 126*r + 70*s - 98)) + 3*D1**2*f**2*fd*r**2 - 102*D1**2*f**2*fd*r*s - 64*D1**2*f**2*fd*r - 105*D1**2*f**2*fd*s**2 + 8*D1**2*f**2*fd*s + 12*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 510*D1**2*f**2*fdd*r*s - 250*D1**2*f**2*fdd*r + 345*D1**2*f**2*fdd*s**2 - 370*D1**2*f**2*fdd*s + 165*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 1020*D1**2*f*fd**2*r*s - 500*D1**2*f*fd**2*r + 690*D1**2*f*fd**2*s**2 - 740*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 438*D1**2*f*fd*r**2 - 588*D1**2*f*fd*r*s + 270*D1**2*f*fd*r - 150*D1**2*f*fd*s**2 + 126*D1**2*f*fd*s - 51*D1**2*f*fd - 54*D1**2*f*fdd*r**2 - 84*D1**2*f*fdd*r*s + 54*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 42*D1**2*f*fdd*s - 27*D1**2*f*fdd + 336*D1**2*f*gd2*r**2 + 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r - 168*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 54*D1**2*fd**2*r**2 - 84*D1**2*fd**2*r*s + 54*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 42*D1**2*fd**2*s + 336*D1**2*fd*g2*r**2 + 336*D1**2*fd*g2*r*s - 336*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 96*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 96*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s - 24*D1*Dd*K*f**2 + 192*D1*Dd*K*f*fd*r**2 + 192*D1*Dd*K*f*fd*r*s - 192*D1*Dd*K*f*fd*r - 72*D1*Dd*K*f*fd*s + 48*D1*Dd*K*f*fd + 4*D1*Dd*f**3*r**2 - 136*D1*Dd*f**3*r*s + 66*D1*Dd*f**3*r - 140*D1*Dd*f**3*s**2 + 174*D1*Dd*f**3*s - 69*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 4080*D1*Dd*f**2*fd*r*s - 2350*D1*Dd*f**2*fd*r + 2760*D1*Dd*f**2*fd*s**2 - 3370*D1*Dd*f**2*fd*s + 990*D1*Dd*f**2*fd - 876*D1*Dd*f**2*r**2 - 1176*D1*Dd*f**2*r*s + 1026*D1*Dd*f**2*r - 300*D1*Dd*f**2*s**2 + 594*D1*Dd*f**2*s - 369*D1*Dd*f**2 - 432*D1*Dd*f*fd*r**2 - 672*D1*Dd*f*fd*r*s + 492*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 372*D1*Dd*f*fd*s - 138*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r**2 + 1344*D1*Dd*f*g2*r*s - 1344*D1*Dd*f*g2*r - 336*D1*Dd*f*g2*s + 336*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1344*D1*Dd*f*gd2*r + 168*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 672*D1*Dd*fd*g2*r + 168*D1*Dd*fd*g2*s + 48*D1*Ddd*K*f**2*r**2 + 48*D1*Ddd*K*f**2*r*s - 48*D1*Ddd*K*f**2*r - 12*D1*Ddd*K*f**2*s + 12*D1*Ddd*K*f**2 + 220*D1*Ddd*f**3*r**2 + 680*D1*Ddd*f**3*r*s - 450*D1*Ddd*f**3*r + 460*D1*Ddd*f**3*s**2 - 630*D1*Ddd*f**3*s + 285*D1*Ddd*f**3 - 108*D1*Ddd*f**2*r**2 - 168*D1*Ddd*f**2*r*s + 138*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 102*D1*Ddd*f**2*s - 57*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 672*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 + 6*D1*bd1*(25*D1*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*D1*f*(r + s - 1)*(28*K*r - 14*K + 50*fd*(2*r + 2*s - 1) - 63*r - 35*s + 49) + 14*D1*fd*(r**2*(4*K - 9) + r*(4*K*s - 3*K - 14*s + 8) - s*(K + 5*s - 6)) - 25*Dd*f**2*(4*r + 4*s - 3)**2 + 14*Dd*f*(K*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) - 36*r**2 - 56*r*s + 55*r - 20*s**2 + 41*s - 20)) + 144*Dd**2*K*f**2*r**2 + 144*Dd**2*K*f**2*r*s - 144*Dd**2*K*f**2*r - 36*Dd**2*K*f**2*s + 24*Dd**2*K*f**2 + 660*Dd**2*f**3*r**2 + 2040*Dd**2*f**3*r*s - 1350*Dd**2*f**3*r + 1380*Dd**2*f**3*s**2 - 1890*Dd**2*f**3*s + 570*Dd**2*f**3 - 324*Dd**2*f**2*r**2 - 504*Dd**2*f**2*r*s + 414*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 306*Dd**2*f**2*s - 114*Dd**2*f**2 - 2016*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 2016*Dd**2*f*g2*r + 504*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(2310*d**2*k1*k3**5) + 2*D1**2*Pk1*Pkd3*ct*k2**3*st**6*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(63*d**2*k1*k3**3) + D1**2*Pk1*Pkd3*ct*k2**3*st**4*(-21*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)*(r*(8*C - 9) - s + 1) + D1*(2*Dd*(f*(8*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 36*r**2 - 40*r*s + 38*r - 4*s**2 + 14*s - 11) + fd*(-4*C*(8*r**2 + 8*r*(s - 1) - s + 1) + 36*r**2 + 40*r*s - 39*r + 4*s**2 - 11*s + 7)) + Ddd*f*(-8*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 36*r**2 + 40*r*s - 38*r + 4*s**2 - 14*s + 11)) - 2*Dd**2*f*(4*C*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - 54*r**2 + r*(57 - 60*s) - 6*s**2 + 21*s - 11)) - 3*b1*(32*C*D1**2*f*fd*r**2 + 32*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s + 16*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r**2 - 16*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r + 8*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r**2 - 16*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 + 64*C*D1*Dd*f**2*r**2 + 64*C*D1*Dd*f**2*r*s - 64*C*D1*Dd*f**2*r - 16*C*D1*Dd*f**2*s + 16*C*D1*Dd*f**2 - 128*C*D1*Dd*f*fd*r**2 - 128*C*D1*Dd*f*fd*r*s + 160*C*D1*Dd*f*fd*r + 48*C*D1*Dd*f*fd*s - 40*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r**2 - 32*C*D1*Ddd*f**2*r*s + 32*C*D1*Ddd*f**2*r + 8*C*D1*Ddd*f**2*s - 8*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r**2 - 96*C*Dd**2*f**2*r*s + 96*C*Dd**2*f**2*r + 24*C*Dd**2*f**2*s - 16*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(8*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 18*r**2 - 20*r*s + 18*r - 2*s**2 + 10*s - 9) + 106*D1**2*f*fd*r**2 + 268*D1**2*f*fd*r*s - 98*D1**2*f*fd*r + 162*D1**2*f*fd*s**2 - 142*D1**2*f*fd*s + 63*D1**2*f*fd - 88*D1**2*f*fdd*r**2 - 232*D1**2*f*fdd*r*s + 98*D1**2*f*fdd*r - 144*D1**2*f*fdd*s**2 + 134*D1**2*f*fdd*s - 63*D1**2*f*fdd - 88*D1**2*fd**2*r**2 - 232*D1**2*fd**2*r*s + 98*D1**2*fd**2*r - 144*D1**2*fd**2*s**2 + 134*D1**2*fd**2*s + 10*D1**2*fd**2 + 212*D1*Dd*f**2*r**2 + 536*D1*Dd*f**2*r*s - 374*D1*Dd*f**2*r + 324*D1*Dd*f**2*s**2 - 458*D1*Dd*f**2*s + 215*D1*Dd*f**2 - 704*D1*Dd*f*fd*r**2 - 1856*D1*Dd*f*fd*r*s + 1032*D1*Dd*f*fd*r - 1152*D1*Dd*f*fd*s**2 + 1344*D1*Dd*f*fd*s - 366*D1*Dd*f*fd - 176*D1*Ddd*f**2*r**2 - 464*D1*Ddd*f**2*r*s + 320*D1*Ddd*f**2*r - 288*D1*Ddd*f**2*s**2 + 404*D1*Ddd*f**2*s - 188*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(8*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 18*r**2 - 20*r*s + 18*r - 2*s**2 + 10*s - 9) + fd*(-4*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 18*r**2 + 20*r*s - 19*r + 2*s**2 - 7*s + 5)) + Dd*f*(-8*C*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 72*r**2 + 80*r*s - 74*r + 8*s**2 - 34*s + 19)) - 528*Dd**2*f**2*r**2 - 1392*Dd**2*f**2*r*s + 960*Dd**2*f**2*r - 864*Dd**2*f**2*s**2 + 1212*Dd**2*f**2*s - 376*Dd**2*f**2) + f*(192*C*D1**2*f*fd*r**2 + 192*C*D1**2*f*fd*r*s - 192*C*D1**2*f*fd*r - 64*C*D1**2*f*fd*s + 64*C*D1**2*f*fd - 240*C*D1**2*f*fdd*r**2 - 240*C*D1**2*f*fdd*r*s + 240*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s - 80*C*D1**2*f*fdd - 480*C*D1**2*fd**2*r**2 - 480*C*D1**2*fd**2*r*s + 480*C*D1**2*fd**2*r + 160*C*D1**2*fd**2*s - 80*C*D1**2*fd**2 + 256*C*D1*Dd*f**2*r**2 + 256*C*D1*Dd*f**2*r*s - 256*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s + 64*C*D1*Dd*f**2 - 1920*C*D1*Dd*f*fd*r**2 - 1920*C*D1*Dd*f*fd*r*s + 1920*C*D1*Dd*f*fd*r + 560*C*D1*Dd*f*fd*s - 400*C*D1*Dd*f*fd - 320*C*D1*Ddd*f**2*r**2 - 320*C*D1*Ddd*f**2*r*s + 320*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s - 80*C*D1*Ddd*f**2 - 960*C*Dd**2*f**2*r**2 - 960*C*Dd**2*f**2*r*s + 960*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s - 160*C*Dd**2*f**2 + 42*D1**2*bd1**2*(r**2*(8*C - 9) + r*(8*C*(s - 1) - 10*s + 9) - s*(4*C + s - 5)) + 3*D1**2*bdd1*f*(r**2*(8*C + 44) + 2*r*(4*C*s + 58*s - 53) + 72*s**2 - 126*s + 53) - 321*D1**2*f*fd*r**2 - 462*D1**2*f*fd*r*s + 368*D1**2*f*fd*r - 141*D1**2*f*fd*s**2 + 248*D1**2*f*fd*s - 154*D1**2*f*fd + 291*D1**2*f*fdd*r**2 + 402*D1**2*f*fdd*r*s - 328*D1**2*f*fdd*r + 111*D1**2*f*fdd*s**2 - 208*D1**2*f*fdd*s + 134*D1**2*f*fdd + 582*D1**2*fd**2*r**2 + 804*D1**2*fd**2*r*s - 656*D1**2*fd**2*r + 222*D1**2*fd**2*s**2 - 416*D1**2*fd**2*s + 134*D1**2*fd**2 - 428*D1*Dd*f**2*r**2 - 616*D1*Dd*f**2*r*s + 522*D1*Dd*f**2*r - 188*D1*Dd*f**2*s**2 + 342*D1*Dd*f**2*s - 201*D1*Dd*f**2 + 2328*D1*Dd*f*fd*r**2 + 3216*D1*Dd*f*fd*r*s - 2698*D1*Dd*f*fd*r + 888*D1*Dd*f*fd*s**2 - 1678*D1*Dd*f*fd*s + 744*D1*Dd*f*fd + 388*D1*Ddd*f**2*r**2 + 536*D1*Ddd*f**2*r*s - 462*D1*Ddd*f**2*r + 148*D1*Ddd*f**2*s**2 - 282*D1*Ddd*f**2*s + 171*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(r**2*(16*C + 53) + 2*r*(8*C*s + 67*s - 71) + 81*s**2 - 154*s + 71) - 2*fd*(-4*C*s + r**2*(16*C + 88) + r*(4*C*(4*s - 3) + 232*s - 155) + 144*s**2 - 193*s + 63)) - 2*Dd*f*(-4*C*s + r**2*(32*C + 176) + 4*r*(8*C*s - 4*C + 116*s - 93) + 288*s**2 - 454*s + 179)) + 1164*Dd**2*f**2*r**2 + 1608*Dd**2*f**2*r*s - 1386*Dd**2*f**2*r + 444*Dd**2*f**2*s**2 - 846*Dd**2*f**2*s + 342*Dd**2*f**2))/(210*d**2*k1*k3**3) + D1**2*Pk1*Pkd3*ct*k2**3*st**2*(-48*D1**2*K*bdd1*f**2*r**2 - 48*D1**2*K*bdd1*f**2*r*s + 48*D1**2*K*bdd1*f**2*r + 80*D1**2*b2*f*fd*r**2 + 80*D1**2*b2*f*fd*r*s - 80*D1**2*b2*f*fd*r - 40*D1**2*b2*f*fd*s + 40*D1**2*b2*f*fd - 96*D1**2*b2*f*fdd*r**2 - 96*D1**2*b2*f*fdd*r*s + 96*D1**2*b2*f*fdd*r + 48*D1**2*b2*f*fdd*s - 48*D1**2*b2*f*fdd - 96*D1**2*b2*fd**2*r**2 - 96*D1**2*b2*fd**2*r*s + 96*D1**2*b2*fd**2*r + 48*D1**2*b2*fd**2*s + 2*D1**2*bd1**2*(3*f**2*(47*r**2 + 2*r*(71*s - 50) + 95*s**2 - 128*s + 45) + 7*f*(r**2*(4*K + 26) + r*(4*K*s - 2*K + 56*s - 59) + 30*s**2 - 61*s + 31) - 140*g2*(2*r**2 + 2*r*(s - 1) - s)) + 40*D1**2*bd2*f**2*r**2 + 40*D1**2*bd2*f**2*r*s - 40*D1**2*bd2*f**2*r - 192*D1**2*bd2*f*fd*r**2 - 192*D1**2*bd2*f*fd*r*s + 192*D1**2*bd2*f*fd*r + 48*D1**2*bd2*f*fd*s - 48*D1**2*bd2*f*fd + 142*D1**2*bdd1*f**3*r**2 + 268*D1**2*bdd1*f**3*r*s - 150*D1**2*bdd1*f**3*r + 126*D1**2*bdd1*f**3*s**2 - 126*D1**2*bdd1*f**3*s + 63*D1**2*bdd1*f**3 + 101*D1**2*bdd1*f**2*r**2 + 154*D1**2*bdd1*f**2*r*s - 154*D1**2*bdd1*f**2*r + 53*D1**2*bdd1*f**2*s**2 - 106*D1**2*bdd1*f**2*s + 53*D1**2*bdd1*f**2 - 56*D1**2*bdd1*f*g2*r**2 - 56*D1**2*bdd1*f*g2*r*s - 48*D1**2*bdd2*f**2*r**2 - 48*D1**2*bdd2*f**2*r*s + 48*D1**2*bdd2*f**2*r + 108*D1**2*f**2*fd*r**2 + 108*D1**2*f**2*fd*r*s - 108*D1**2*f**2*fd*r - 36*D1**2*f**2*fd*s + 36*D1**2*f**2*fd - 80*D1**2*f**2*gd2*r**2 - 80*D1**2*f**2*gd2*r*s + 80*D1**2*f**2*gd2*r + 96*D1**2*f**2*gdd2*r**2 + 96*D1**2*f**2*gdd2*r*s - 96*D1**2*f**2*gdd2*r - 160*D1**2*f*fd*g2*r**2 - 160*D1**2*f*fd*g2*r*s + 160*D1**2*f*fd*g2*r + 80*D1**2*f*fd*g2*s - 80*D1**2*f*fd*g2 + 384*D1**2*f*fd*gd2*r**2 + 384*D1**2*f*fd*gd2*r*s - 384*D1**2*f*fd*gd2*r - 96*D1**2*f*fd*gd2*s + 96*D1**2*f*fd*gd2 + 192*D1**2*f*fdd*g2*r**2 + 192*D1**2*f*fdd*g2*r*s - 192*D1**2*f*fdd*g2*r - 96*D1**2*f*fdd*g2*s + 96*D1**2*f*fdd*g2 + 192*D1**2*fd**2*g2*r**2 + 192*D1**2*fd**2*g2*r*s - 192*D1**2*fd**2*g2*r - 96*D1**2*fd**2*g2*s + 160*D1*Dd*b2*f**2*r**2 + 160*D1*Dd*b2*f**2*r*s - 160*D1*Dd*b2*f**2*r - 40*D1*Dd*b2*f**2*s + 40*D1*Dd*b2*f**2 - 768*D1*Dd*b2*f*fd*r**2 - 768*D1*Dd*b2*f*fd*r*s + 768*D1*Dd*b2*f*fd*r + 288*D1*Dd*b2*f*fd*s - 192*D1*Dd*b2*f*fd - 384*D1*Dd*bd2*f**2*r**2 - 384*D1*Dd*bd2*f**2*r*s + 384*D1*Dd*bd2*f**2*r + 48*D1*Dd*bd2*f**2*s - 48*D1*Dd*bd2*f**2 + 144*D1*Dd*f**3*r**2 + 144*D1*Dd*f**3*r*s - 144*D1*Dd*f**3*r - 36*D1*Dd*f**3*s + 36*D1*Dd*f**3 - 320*D1*Dd*f**2*g2*r**2 - 320*D1*Dd*f**2*g2*r*s + 320*D1*Dd*f**2*g2*r + 80*D1*Dd*f**2*g2*s - 80*D1*Dd*f**2*g2 + 768*D1*Dd*f**2*gd2*r**2 + 768*D1*Dd*f**2*gd2*r*s - 768*D1*Dd*f**2*gd2*r - 96*D1*Dd*f**2*gd2*s + 96*D1*Dd*f**2*gd2 + 1536*D1*Dd*f*fd*g2*r**2 + 1536*D1*Dd*f*fd*g2*r*s - 1536*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s + 384*D1*Dd*f*fd*g2 - 192*D1*Ddd*b2*f**2*r**2 - 192*D1*Ddd*b2*f**2*r*s + 192*D1*Ddd*b2*f**2*r + 48*D1*Ddd*b2*f**2*s - 48*D1*Ddd*b2*f**2 + 384*D1*Ddd*f**2*g2*r**2 + 384*D1*Ddd*f**2*g2*r*s - 384*D1*Ddd*f**2*g2*r - 96*D1*Ddd*f**2*g2*s + 96*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-f**3*(122*r**2 + 212*r*s - 114*r + 90*s**2 - 90*s + 45) + f**2*(4*fd*(213*r**2 + r*(402*s - 280) + 189*s**2 - 256*s + 69) + r**2*(56*C + 40*K - 90) + 2*r*(28*C*s + 20*K*(s - 1) - 70*s - 7) - 50*s**2 + 2*s + 41) - 2*f*fd*(24*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 202*r**2 + r*(255 - 308*s) - 106*s**2 + 183*s - 77) + 56*f*r*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1)) - 56*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + 2*Dd*f*(f**2*(568*r**2 + 2*r*(536*s - 355) + 504*s**2 - 638*s + 201) + f*(-24*K*(8*r**2 + 8*r*(s - 1) - s + 1) + 404*r**2 + 616*r*s - 563*r + 212*s**2 - 395*s + 183) - 28*g2*(8*r**2 + r*(8*s - 4) - s))) - 576*Dd**2*b2*f**2*r**2 - 576*Dd**2*b2*f**2*r*s + 576*Dd**2*b2*f**2*r + 144*Dd**2*b2*f**2*s - 96*Dd**2*b2*f**2 + 1152*Dd**2*f**2*g2*r**2 + 1152*Dd**2*f**2*g2*r*s - 1152*Dd**2*f**2*g2*r - 288*Dd**2*f**2*g2*s + 192*Dd**2*f**2*g2 + 7*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(-20*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 100*r**2 + 120*r*s - 110*r + 20*s**2 - 50*s + 35) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*Ddd*(4*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 20*r**2 + r*(22 - 24*s) - 4*s**2 + 10*s - 7)) - 2*Dd**2*(-5*K*(24*r**2 + 24*r*(s - 1) - 6*s + 4) + 9*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 150*r**2 + 180*r*s - 165*r + 30*s**2 - 75*s + 35)) + b1**2*(280*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 1120*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 1120*C*D1*Dd*f*r - 280*C*D1*Dd*f*s + 280*C*D1*Dd*f - 56*D1**2*K*fd*r**2 - 56*D1**2*K*fd*r*s + 112*D1**2*K*fd*r + 56*D1**2*K*fd*s - 56*D1**2*K*fd + 28*D1**2*K*fdd*r**2 + 28*D1**2*K*fdd*r*s - 56*D1**2*K*fdd*r - 28*D1**2*K*fdd*s + 28*D1**2*K*fdd - 7*D1**2*bdd1*(-20*K*(3*r**2 + 3*r*(s - 1) - s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 75*r**2 + 90*r*s - 80*r + 15*s**2 - 40*s + 30) - 256*D1**2*f*fd*r**2 - 640*D1**2*f*fd*r*s + 382*D1**2*f*fd*r - 384*D1**2*f*fd*s**2 + 518*D1**2*f*fd*s - 239*D1**2*f*fd + 282*D1**2*f*fdd*r**2 + 852*D1**2*f*fdd*r*s - 534*D1**2*f*fdd*r + 570*D1**2*f*fdd*s**2 - 798*D1**2*f*fdd*s + 375*D1**2*f*fdd + 282*D1**2*fd**2*r**2 + 852*D1**2*fd**2*r*s - 534*D1**2*fd**2*r + 570*D1**2*fd**2*s**2 - 798*D1**2*fd**2*s + 228*D1**2*fd**2 - 504*D1**2*fd*r**2 - 644*D1**2*fd*r*s + 210*D1**2*fd*r - 140*D1**2*fd*s**2 - 14*D1**2*fd*s + 35*D1**2*fd + 182*D1**2*fdd*r**2 + 392*D1**2*fdd*r*s + 70*D1**2*fdd*r + 210*D1**2*fdd*s**2 + 42*D1**2*fdd*s - 35*D1**2*fdd + 560*D1**2*gd2*r**2 + 560*D1**2*gd2*r*s - 560*D1**2*gd2*r - 280*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 224*D1*Dd*K*f*r**2 - 224*D1*Dd*K*f*r*s + 224*D1*Dd*K*f*r + 56*D1*Dd*K*f*s - 56*D1*Dd*K*f + 224*D1*Dd*K*fd*r**2 + 224*D1*Dd*K*fd*r*s - 336*D1*Dd*K*fd*r - 140*D1*Dd*K*fd*s + 112*D1*Dd*K*fd - 512*D1*Dd*f**2*r**2 - 1280*D1*Dd*f**2*r*s + 896*D1*Dd*f**2*r - 768*D1*Dd*f**2*s**2 + 1088*D1*Dd*f**2*s - 512*D1*Dd*f**2 + 2256*D1*Dd*f*fd*r**2 + 6816*D1*Dd*f*fd*r*s - 4404*D1*Dd*f*fd*r + 4560*D1*Dd*f*fd*s**2 - 6324*D1*Dd*f*fd*s + 2130*D1*Dd*f*fd - 2016*D1*Dd*f*r**2 - 2576*D1*Dd*f*r*s + 2296*D1*Dd*f*r - 560*D1*Dd*f*s**2 + 1204*D1*Dd*f*s - 784*D1*Dd*f + 1456*D1*Dd*fd*r**2 + 3136*D1*Dd*fd*r*s - 868*D1*Dd*fd*r + 1680*D1*Dd*fd*s**2 - 1064*D1*Dd*fd*s - 154*D1*Dd*fd + 2240*D1*Dd*g2*r**2 + 2240*D1*Dd*g2*r*s - 2240*D1*Dd*g2*r - 560*D1*Dd*g2*s + 560*D1*Dd*g2 - 2240*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 2240*D1*Dd*gd2*r + 280*D1*Dd*gd2*s - 280*D1*Dd*gd2 + 112*D1*Ddd*K*f*r**2 + 112*D1*Ddd*K*f*r*s - 112*D1*Ddd*K*f*r - 28*D1*Ddd*K*f*s + 28*D1*Ddd*K*f + 564*D1*Ddd*f**2*r**2 + 1704*D1*Ddd*f**2*r*s - 1134*D1*Ddd*f**2*r + 1140*D1*Ddd*f**2*s**2 - 1566*D1*Ddd*f**2*s + 711*D1*Ddd*f**2 + 728*D1*Ddd*f*r**2 + 1568*D1*Ddd*f*r*s - 1148*D1*Ddd*f*r + 840*D1*Ddd*f*s**2 - 1232*D1*Ddd*f*s + 602*D1*Ddd*f - 1120*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 1120*D1*Ddd*g2*r + 280*D1*Ddd*g2*s - 280*D1*Ddd*g2 + 14*D1*bd1*(D1*(-20*K*(3*r**2 + 3*r*(s - 1) - s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 75*r**2 + 90*r*s - 80*r + 15*s**2 - 40*s + 30) - 3*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 5*Dd*(2*K*(24*r**2 + 24*r*(s - 1) - 7*s + 5) - 60*r**2 + r*(65 - 72*s) - 12*s**2 + 31*s - 16)) + 336*Dd**2*K*f*r**2 + 336*Dd**2*K*f*r*s - 336*Dd**2*K*f*r - 84*Dd**2*K*f*s + 56*Dd**2*K*f + 1692*Dd**2*f**2*r**2 + 5112*Dd**2*f**2*r*s - 3402*Dd**2*f**2*r + 3420*Dd**2*f**2*s**2 - 4698*Dd**2*f**2*s + 1422*Dd**2*f**2 + 2184*Dd**2*f*r**2 + 4704*Dd**2*f*r*s - 3444*Dd**2*f*r + 2520*Dd**2*f*s**2 - 3696*Dd**2*f*s + 1204*Dd**2*f - 3360*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 3360*Dd**2*g2*r + 840*Dd**2*g2*s - 560*Dd**2*g2) + b1*(112*C*D1**2*f*fd*r**2 + 112*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r - 56*C*D1**2*f*fd*s + 56*C*D1**2*f*fd + 224*C*D1*Dd*f**2*r**2 + 224*C*D1*Dd*f**2*r*s - 224*C*D1*Dd*f**2*r - 56*C*D1*Dd*f**2*s + 56*C*D1*Dd*f**2 + 80*D1**2*K*f*fd*r**2 + 80*D1**2*K*f*fd*r*s - 80*D1**2*K*f*fd*r - 40*D1**2*K*f*fd*s + 40*D1**2*K*f*fd - 96*D1**2*K*f*fdd*r**2 - 96*D1**2*K*f*fdd*r*s + 96*D1**2*K*f*fdd*r + 48*D1**2*K*f*fdd*s - 48*D1**2*K*f*fdd - 96*D1**2*K*fd**2*r**2 - 96*D1**2*K*fd**2*r*s + 96*D1**2*K*fd**2*r + 48*D1**2*K*fd**2*s - 14*D1**2*bd1**2*(-10*K*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 75*r**2 + 90*r*s - 80*r + 15*s**2 - 40*s + 15) + D1**2*bdd1*(6*f**2*(47*r**2 + 2*r*(71*s - 50) + 95*s**2 - 128*s + 56) + 7*f*(r**2*(8*K + 52) + 2*r*(4*K*s - 2*K + 56*s - 59) + 60*s**2 - 122*s + 61) - 280*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 366*D1**2*f**2*fd*r**2 - 636*D1**2*f**2*fd*r*s + 554*D1**2*f**2*fd*r - 270*D1**2*f**2*fd*s**2 + 482*D1**2*f**2*fd*s - 257*D1**2*f**2*fd + 426*D1**2*f**2*fdd*r**2 + 804*D1**2*f**2*fdd*r*s - 670*D1**2*f**2*fdd*r + 378*D1**2*f**2*fdd*s**2 - 646*D1**2*f**2*fdd*s + 331*D1**2*f**2*fdd + 852*D1**2*f*fd**2*r**2 + 1608*D1**2*f*fd**2*r*s - 1340*D1**2*f*fd**2*r + 756*D1**2*f*fd**2*s**2 - 1292*D1**2*f*fd**2*s + 512*D1**2*f*fd**2 - 180*D1**2*f*fd*r**2 - 280*D1**2*f*fd*r*s + 334*D1**2*f*fd*r - 100*D1**2*f*fd*s**2 + 238*D1**2*f*fd*s - 181*D1**2*f*fd + 202*D1**2*f*fdd*r**2 + 308*D1**2*f*fdd*r*s - 202*D1**2*f*fdd*r + 106*D1**2*f*fdd*s**2 - 154*D1**2*f*fdd*s + 101*D1**2*f*fdd + 112*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r - 56*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r + 202*D1**2*fd**2*r**2 + 308*D1**2*fd**2*r*s - 202*D1**2*fd**2*r + 106*D1**2*fd**2*s**2 - 154*D1**2*fd**2*s + 112*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s - 224*D1**2*fd*g2*r - 112*D1**2*fd*g2*s + 112*D1**2*fd*g2 - 112*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r + 56*D1**2*fd*gd2*s - 56*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s + 112*D1**2*fdd*g2*r + 56*D1**2*fdd*g2*s - 56*D1**2*fdd*g2 + 160*D1*Dd*K*f**2*r**2 + 160*D1*Dd*K*f**2*r*s - 160*D1*Dd*K*f**2*r - 40*D1*Dd*K*f**2*s + 40*D1*Dd*K*f**2 - 768*D1*Dd*K*f*fd*r**2 - 768*D1*Dd*K*f*fd*r*s + 768*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s - 192*D1*Dd*K*f*fd - 488*D1*Dd*f**3*r**2 - 848*D1*Dd*f**3*r*s + 668*D1*Dd*f**3*r - 360*D1*Dd*f**3*s**2 + 572*D1*Dd*f**3*s - 302*D1*Dd*f**3 + 3408*D1*Dd*f**2*fd*r**2 + 6432*D1*Dd*f**2*fd*r*s - 5140*D1*Dd*f**2*fd*r + 3024*D1*Dd*f**2*fd*s**2 - 4900*D1*Dd*f**2*fd*s + 1962*D1*Dd*f**2*fd - 360*D1*Dd*f**2*r**2 - 560*D1*Dd*f**2*r*s + 460*D1*Dd*f**2*r - 200*D1*Dd*f**2*s**2 + 340*D1*Dd*f**2*s - 190*D1*Dd*f**2 + 1616*D1*Dd*f*fd*r**2 + 2464*D1*Dd*f*fd*r*s - 1828*D1*Dd*f*fd*r + 848*D1*Dd*f*fd*s**2 - 1348*D1*Dd*f*fd*s + 510*D1*Dd*f*fd + 448*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 448*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s + 112*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 448*D1*Dd*f*gd2*r + 56*D1*Dd*f*gd2*s - 56*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 672*D1*Dd*fd*g2*r + 280*D1*Dd*fd*g2*s - 224*D1*Dd*fd*g2 - 192*D1*Ddd*K*f**2*r**2 - 192*D1*Ddd*K*f**2*r*s + 192*D1*Ddd*K*f**2*r + 48*D1*Ddd*K*f**2*s - 48*D1*Ddd*K*f**2 + 568*D1*Ddd*f**3*r**2 + 1072*D1*Ddd*f**3*r*s - 820*D1*Ddd*f**3*r + 504*D1*Ddd*f**3*s**2 - 772*D1*Ddd*f**3*s + 394*D1*Ddd*f**3 + 404*D1*Ddd*f**2*r**2 + 616*D1*Ddd*f**2*r*s - 510*D1*Ddd*f**2*r + 212*D1*Ddd*f**2*s**2 - 366*D1*Ddd*f**2*s + 207*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 224*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s - 56*D1*Ddd*f*g2 + D1*bd1*(D1*(-f**2*(256*r**2 + r*(640*s - 514) + 384*s**2 - 570*s + 273) + f*(280*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 12*fd*(94*r**2 + r*(284*s - 189) + 190*s**2 - 261*s + 77) - 7*r**2*(16*K + 144) - 14*r*(8*K*s - 4*K + 92*s - 103) - 280*s**2 + 938*s - 679) + 14*fd*(2*K*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 52*r**2 + 7*r*(16*s - 7) + 60*s**2 - 55*s - 3) + 280*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) + 280*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) + 2*Dd*(6*f**2*(188*r**2 + r*(568*s - 389) + 380*s**2 - 517*s + 178) + 7*f*(K*(32*r**2 + 8*r*(4*s - 3) - 4*s + 2) + 208*r**2 + 448*r*s - 400*r + 240*s**2 - 420*s + 181) - 280*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 576*Dd**2*K*f**2*r**2 - 576*Dd**2*K*f**2*r*s + 576*Dd**2*K*f**2*r + 144*Dd**2*K*f**2*s - 96*Dd**2*K*f**2 + 1704*Dd**2*f**3*r**2 + 3216*Dd**2*f**3*r*s - 2460*Dd**2*f**3*r + 1512*Dd**2*f**3*s**2 - 2316*Dd**2*f**3*s + 788*Dd**2*f**3 + 1212*Dd**2*f**2*r**2 + 1848*Dd**2*f**2*r*s - 1530*Dd**2*f**2*r + 636*Dd**2*f**2*s**2 - 1098*Dd**2*f**2*s + 414*Dd**2*f**2 - 672*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 672*Dd**2*f*g2*r + 168*Dd**2*f*g2*s - 112*Dd**2*f*g2))/(210*d**2*k1*k3**3) + 2*D1**2*Pk1*Pkd3*ct*k2*st**4*(D1*f*(-7*D1*bd1**2*s*(2*r + 2*s - 1) - D1*bdd1*f*s*(r + s) + bd1*(2*D1*f*s*(r + s) + D1*fd*(-4*r*s + r + s*(3 - 4*s)) + Dd*f*r*(2 - 8*s) + Dd*f*s*(5 - 8*s))) + 7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(-7*bdd1*s*(2*r + 2*s - 1) + 2*fd*(2*s - 1)*(r + s - 1) - fdd*(2*s - 1)*(r + s - 1)) - fd**2*(2*s - 1)*(r + s - 1)) + 7*D1*bd1*(2*D1*f*s*(2*r + 2*s - 1) - D1*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(35*d**2*k1*k3) + D1**2*Pk1*Pkd3*ct*k2*st**2*(D1*f*(14*D1*bd1**2*(7*r**2 + r*(38*s - 7) + s*(31*s - 19)) - D1*bdd1*f*(r + s)*(r*(96*C - 77) - 53*s) + bd1*(D1*(f*(r + s)*(r*(80*C - 91) - 71*s) - 4*fd*(r**2*(96*C - 77) + r*(96*C*s - 72*C - 130*s + 71) + s*(-24*C - 53*s + 59))) + 2*Dd*f*(r**2*(308 - 384*C) + r*(-384*C*s + 192*C + 520*s - 207) + s*(48*C + 212*s - 171)))) - 7*b1**2*(D1**2*(r + s - 1)*(9*fd*r + 37*fd*(s - 1) + fdd*(-7*r - 31*s + 31)) + D1*(Dd*(f*(36*r**2 + 2*r*(92*s - 55) + 148*s**2 - 194*s + 83) - 2*fd*(28*r**2 + r*(152*s - 121) + 124*s**2 - 205*s + 81)) - Ddd*f*(28*r**2 + 2*r*(76*s - 45) + 124*s**2 - 162*s + 69)) - 6*Dd**2*f*(14*r**2 + r*(76*s - 45) + 62*s**2 - 81*s + 23)) + b1*(160*C*D1**2*f*fd*r**2 + 160*C*D1**2*f*fd*r*s - 240*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s + 80*C*D1**2*f*fd - 192*C*D1**2*f*fdd*r**2 - 192*C*D1**2*f*fdd*r*s + 288*C*D1**2*f*fdd*r + 96*C*D1**2*f*fdd*s - 96*C*D1**2*f*fdd - 192*C*D1**2*fd**2*r**2 - 192*C*D1**2*fd**2*r*s + 288*C*D1**2*fd**2*r + 96*C*D1**2*fd**2*s - 96*C*D1**2*fd**2 + 320*C*D1*Dd*f**2*r**2 + 320*C*D1*Dd*f**2*r*s - 320*C*D1*Dd*f**2*r - 80*C*D1*Dd*f**2*s + 80*C*D1*Dd*f**2 - 1536*C*D1*Dd*f*fd*r**2 - 1536*C*D1*Dd*f*fd*r*s + 1920*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s - 480*C*D1*Dd*f*fd - 384*C*D1*Ddd*f**2*r**2 - 384*C*D1*Ddd*f**2*r*s + 384*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s - 96*C*D1*Ddd*f**2 - 1152*C*Dd**2*f**2*r**2 - 1152*C*Dd**2*f**2*r*s + 1152*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s - 192*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(14*r**2 + 76*r*s - 14*r + 62*s**2 - 38*s + 7) - 182*D1**2*f*fd*r**2 - 324*D1**2*f*fd*r*s + 344*D1**2*f*fd*r - 142*D1**2*f*fd*s**2 + 304*D1**2*f*fd*s - 162*D1**2*f*fd + 154*D1**2*f*fdd*r**2 + 260*D1**2*f*fdd*r*s - 284*D1**2*f*fdd*r + 106*D1**2*f*fdd*s**2 - 236*D1**2*f*fdd*s + 130*D1**2*f*fdd + 154*D1**2*fd**2*r**2 + 260*D1**2*fd**2*r*s - 284*D1**2*fd**2*r + 106*D1**2*fd**2*s**2 - 236*D1**2*fd**2*s + 130*D1**2*fd**2 - 364*D1*Dd*f**2*r**2 - 648*D1*Dd*f**2*r*s + 506*D1*Dd*f**2*r - 284*D1*Dd*f**2*s**2 + 446*D1*Dd*f**2*s - 233*D1*Dd*f**2 + 1232*D1*Dd*f*fd*r**2 + 2080*D1*Dd*f*fd*r*s - 1964*D1*Dd*f*fd*r + 848*D1*Dd*f*fd*s**2 - 1628*D1*Dd*f*fd*s + 756*D1*Dd*f*fd + 308*D1*Ddd*f**2*r**2 + 520*D1*Ddd*f**2*r*s - 414*D1*Ddd*f**2*r + 212*D1*Ddd*f**2*s**2 - 342*D1*Ddd*f**2*s + 183*D1*Ddd*f**2 - 7*D1*bd1*(D1*(f*(18*r**2 + 92*r*s - 18*r + 74*s**2 - 46*s + 9) - 2*fd*(14*r**2 + 76*r*s - 45*r + 62*s**2 - 81*s + 19)) - 2*Dd*f*(56*r**2 + 2*r*(152*s - 59) + 248*s**2 - 238*s + 45)) + 924*Dd**2*f**2*r**2 + 1560*Dd**2*f**2*r*s - 1242*Dd**2*f**2*r + 636*Dd**2*f**2*s**2 - 1026*Dd**2*f**2*s + 366*Dd**2*f**2))/(210*d**2*k1*k3) + D1**2*Pk1*Pkd3*ct*k2*(2*D1*(D1*bd1**2*f*(r**2*(-56*K + 27*f + 49) + r*(2*s - 1)*(-28*K + 45*f + 63) + s*(63*f + 77)*(s - 1)) - 28*D1*bdd1*f*r*(b2 - 2*g2)*(r + s) - 28*bd1*(D1*b2*(-2*f*r*(r + s) + fd*(2*r**2 + 2*r*(s - 1) - s)) + D1*bd2*f*r*(2*r + 2*s - 1) + 2*D1*(f*r*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1)) + fd*g2*(-2*r**2 - 2*r*(s - 1) + s)) + Dd*b2*f*(8*r**2 + r*(8*s - 4) - s) + 2*Dd*f*g2*(-8*r**2 + r*(4 - 8*s) + s))) - 7*b1**3*(D1**2*(fd - 3*fdd)*(r**2 + 6*r*(s - 1) + 5*(s - 1)**2) + D1*(Dd*(f*(4*r**2 + 2*r*(12*s - 7) + 20*s**2 - 26*s + 11) - 6*fd*(4*r**2 + 24*r*s - 19*r + 20*s**2 - 33*s + 13) - 20*r**2 - 120*r*s + 70*r - 100*s**2 + 130*s - 55) - Ddd*(3*f + 5)*(4*r**2 + 2*r*(12*s - 7) + 20*s**2 - 26*s + 11)) - 2*Dd**2*(3*f + 5)*(6*r**2 + 3*r*(12*s - 7) + 30*s**2 - 39*s + 11)) + b1**2*(112*D1**2*K*fd*r**2 + 112*D1**2*K*fd*r*s - 224*D1**2*K*fd*r - 112*D1**2*K*fd*s + 112*D1**2*K*fd - 56*D1**2*K*fdd*r**2 - 56*D1**2*K*fdd*r*s + 112*D1**2*K*fdd*r + 56*D1**2*K*fdd*s - 56*D1**2*K*fdd + 7*D1**2*bdd1*(3*f + 5)*(3*r**2 + 2*r*(9*s - 4) + 15*s**2 - 16*s + 6) - 66*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 120*D1**2*f*fd*r - 42*D1**2*f*fd*s**2 + 96*D1**2*f*fd*s - 54*D1**2*f*fd + 54*D1**2*f*fdd*r**2 + 180*D1**2*f*fdd*r*s - 144*D1**2*f*fdd*r + 126*D1**2*f*fdd*s**2 - 216*D1**2*f*fdd*s + 90*D1**2*f*fdd + 54*D1**2*fd**2*r**2 + 180*D1**2*fd**2*r*s - 144*D1**2*fd**2*r + 126*D1**2*fd**2*s**2 - 216*D1**2*fd**2*s + 90*D1**2*fd**2 - 63*D1**2*fd*r**2 - 42*D1**2*fd*r*s + 126*D1**2*fd*r + 21*D1**2*fd*s**2 + 42*D1**2*fd*s - 63*D1**2*fd + 49*D1**2*fdd*r**2 + 126*D1**2*fdd*r*s - 98*D1**2*fdd*r + 77*D1**2*fdd*s**2 - 126*D1**2*fdd*s + 49*D1**2*fdd + 448*D1*Dd*K*f*r**2 + 448*D1*Dd*K*f*r*s - 448*D1*Dd*K*f*r - 112*D1*Dd*K*f*s + 112*D1*Dd*K*f - 448*D1*Dd*K*fd*r**2 - 448*D1*Dd*K*fd*r*s + 672*D1*Dd*K*fd*r + 280*D1*Dd*K*fd*s - 224*D1*Dd*K*fd - 132*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 174*D1*Dd*f**2*r - 84*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 75*D1*Dd*f**2 + 432*D1*Dd*f*fd*r**2 + 1440*D1*Dd*f*fd*r*s - 1044*D1*Dd*f*fd*r + 1008*D1*Dd*f*fd*s**2 - 1548*D1*Dd*f*fd*s + 576*D1*Dd*f*fd - 252*D1*Dd*f*r**2 - 168*D1*Dd*f*r*s + 210*D1*Dd*f*r + 84*D1*Dd*f*s**2 - 42*D1*Dd*f*s - 21*D1*Dd*f + 392*D1*Dd*fd*r**2 + 1008*D1*Dd*fd*r*s - 742*D1*Dd*fd*r + 616*D1*Dd*fd*s**2 - 938*D1*Dd*fd*s + 350*D1*Dd*fd - 224*D1*Ddd*K*f*r**2 - 224*D1*Ddd*K*f*r*s + 224*D1*Ddd*K*f*r + 56*D1*Ddd*K*f*s - 56*D1*Ddd*K*f + 108*D1*Ddd*f**2*r**2 + 360*D1*Ddd*f**2*r*s - 234*D1*Ddd*f**2*r + 252*D1*Ddd*f**2*s**2 - 342*D1*Ddd*f**2*s + 153*D1*Ddd*f**2 + 196*D1*Ddd*f*r**2 + 504*D1*Ddd*f*r*s - 350*D1*Ddd*f*r + 308*D1*Ddd*f*s**2 - 434*D1*Ddd*f*s + 203*D1*Ddd*f - 7*D1*bd1*(D1*(f*(3*r**2 + 2*r*(9*s - 4) + 15*s**2 - 16*s + 6) - 6*fd*(3*r**2 + 18*r*s - 13*r + 15*s**2 - 23*s + 8) - 15*r**2 - 90*r*s + 40*r - 75*s**2 + 80*s - 30) - 2*Dd*(3*f + 5)*(12*r**2 + r*(72*s - 37) + 60*s**2 - 71*s + 20)) - 672*Dd**2*K*f*r**2 - 672*Dd**2*K*f*r*s + 672*Dd**2*K*f*r + 168*Dd**2*K*f*s - 112*Dd**2*K*f + 324*Dd**2*f**2*r**2 + 1080*Dd**2*f**2*r*s - 702*Dd**2*f**2*r + 756*Dd**2*f**2*s**2 - 1026*Dd**2*f**2*s + 306*Dd**2*f**2 + 588*Dd**2*f*r**2 + 1512*Dd**2*f*r*s - 1050*Dd**2*f*r + 924*Dd**2*f*s**2 - 1302*Dd**2*f*s + 406*Dd**2*f) + b1*(14*D1**2*bd1**2*(3*f + 5)*(3*r**2 + 2*r*(9*s - 4) + 15*s**2 - 16*s + 3) + D1**2*bdd1*f*(9*f*(6*r**2 + 20*r*s - 10*r + 14*s**2 - 14*s + 7) + r**2*(98 - 112*K) - r*(56*K - 126)*(2*s - 1) + 154*s**2 - 154*s + 77) - 56*D1**2*bdd2*f*r**2 - 56*D1**2*bdd2*f*r*s + 56*D1**2*bdd2*f*r - 224*D1**2*f*gd2*r**2 - 224*D1**2*f*gd2*r*s + 224*D1**2*f*gd2*r + 112*D1**2*f*gdd2*r**2 + 112*D1**2*f*gdd2*r*s - 112*D1**2*f*gdd2*r - 224*D1**2*fd*g2*r**2 - 224*D1**2*fd*g2*r*s + 448*D1**2*fd*g2*r + 224*D1**2*fd*g2*s - 224*D1**2*fd*g2 + 224*D1**2*fd*gd2*r**2 + 224*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*r - 112*D1**2*fd*gd2*s + 112*D1**2*fd*gd2 + 112*D1**2*fdd*g2*r**2 + 112*D1**2*fdd*g2*r*s - 224*D1**2*fdd*g2*r - 112*D1**2*fdd*g2*s + 112*D1**2*fdd*g2 - 896*D1*Dd*f*g2*r**2 - 896*D1*Dd*f*g2*r*s + 896*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s - 224*D1*Dd*f*g2 + 896*D1*Dd*f*gd2*r**2 + 896*D1*Dd*f*gd2*r*s - 896*D1*Dd*f*gd2*r - 112*D1*Dd*f*gd2*s + 112*D1*Dd*f*gd2 + 896*D1*Dd*fd*g2*r**2 + 896*D1*Dd*fd*g2*r*s - 1344*D1*Dd*fd*g2*r - 560*D1*Dd*fd*g2*s + 448*D1*Dd*fd*g2 + 448*D1*Ddd*f*g2*r**2 + 448*D1*Ddd*f*g2*r*s - 448*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s + 112*D1*Ddd*f*g2 + D1*bd1*(D1*(-3*f**2*(22*r**2 + 36*r*s - 18*r + 14*s**2 - 14*s + 7) + f*(36*fd*(6*r**2 + r*(20*s - 13) + 14*s**2 - 19*s + 6) + 7*r**2*(32*K - 18) + 7*r*(16*K - 6)*(2*s - 1) + 42*s**2 - 42*s + 21) - 14*fd*(4*K*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 14*r**2 - 36*r*s + 23*r - 22*s**2 + 29*s - 9)) + 2*Dd*f*(-7*K*(64*r**2 + 64*r*s - 48*r - 8*s + 4) + 9*f*(24*r**2 + r*(80*s - 46) + 56*s**2 - 66*s + 19) + 392*r**2 + 1008*r*s - 602*r + 616*s**2 - 742*s + 217)) + 56*D1*bd2*(D1*(r + s - 1)*(2*f*r - 2*fd*r + fd) - Dd*f*(8*r**2 + 8*r*(s - 1) - s + 1)) + 1344*Dd**2*f*g2*r**2 + 1344*Dd**2*f*g2*r*s - 1344*Dd**2*f*g2*r - 336*Dd**2*f*g2*s + 224*Dd**2*f*g2 + 56*b2*(D1**2*(2*fd - fdd)*(r - 1)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2))))/(210*d**2*k1*k3) + D1**2*Pk1*Pkd3*f*k2**6*st**6*(-165*D1**2*b1*f*fd*r**2 - 165*D1**2*b1*f*fd*r*s + 110*D1**2*b1*f*fd*r + 231*D1**2*b1*f*fdd*r**2 + 231*D1**2*b1*f*fdd*r*s - 154*D1**2*b1*f*fdd*r + 462*D1**2*b1*fd**2*r**2 + 462*D1**2*b1*fd**2*r*s - 308*D1**2*b1*fd**2*r + 77*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 36*D1**2*f**2*fd*r**2 - 36*D1**2*f**2*fd*r*s + 36*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s - 9*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r**2 + 84*D1**2*f**2*fdd*r*s - 84*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd + 252*D1**2*f*fd**2*r**2 + 252*D1**2*f*fd**2*r*s - 252*D1**2*f*fd**2*r - 63*D1**2*f*fd**2*s + 42*D1**2*f*fd**2 - 220*D1*Dd*b1*f**2*r**2 - 220*D1*Dd*b1*f**2*r*s + 220*D1*Dd*b1*f**2*r + 55*D1*Dd*b1*f**2*s - 55*D1*Dd*b1*f**2 + 1848*D1*Dd*b1*f*fd*r**2 + 1848*D1*Dd*b1*f*fd*r*s - 1540*D1*Dd*b1*f*fd*r - 231*D1*Dd*b1*f*fd*s + 154*D1*Dd*b1*f*fd - 36*D1*Dd*f**3*r**2 - 36*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r + 9*D1*Dd*f**3*s - 9*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r**2 + 672*D1*Dd*f**2*fd*r*s - 672*D1*Dd*f**2*fd*r - 168*D1*Dd*f**2*fd*s + 126*D1*Dd*f**2*fd + 308*D1*Ddd*b1*f**2*r**2 + 308*D1*Ddd*b1*f**2*r*s - 308*D1*Ddd*b1*f**2*r - 77*D1*Ddd*b1*f**2*s + 77*D1*Ddd*b1*f**2 + 84*D1*Ddd*f**3*r**2 + 84*D1*Ddd*f**3*r*s - 84*D1*Ddd*f**3*r - 21*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 - 11*D1*bd1*f*(D1*(5*f*(r - 1)*(r + s - 1) - 7*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 7*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 924*Dd**2*b1*f**2*r**2 + 924*Dd**2*b1*f**2*r*s - 924*Dd**2*b1*f**2*r - 231*Dd**2*b1*f**2*s + 154*Dd**2*b1*f**2 + 252*Dd**2*f**3*r**2 + 252*Dd**2*f**3*r*s - 252*Dd**2*f**3*r - 63*Dd**2*f**3*s + 42*Dd**2*f**3)/(693*d**2*k1**2*k3**5) - D1**2*Pk1*Pkd3*k1**6*st**2*(2*C - 1)*(6*D1**2*b1*f*fd*r**2 + 12*D1**2*b1*f*fd*r*s - 6*D1**2*b1*f*fd*r + 6*D1**2*b1*f*fd*s**2 - 6*D1**2*b1*f*fd*s + 3*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(r + s - 1)**2 - 3*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s**2 + 4*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 + 12*D1*Dd*b1*f**2*r**2 + 24*D1*Dd*b1*f**2*r*s - 18*D1*Dd*b1*f**2*r + 12*D1*Dd*b1*f**2*s**2 - 18*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 6*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 170*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 170*D1*Dd*f**2*fd*s + 60*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + 6*D1*fd*(2*r + 2*s - 1) + 6*Dd*f*(4*r + 4*s - 3)) + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 30*Dd**2*f**3)/(70*d**2*k3**7) + 3*D1**2*Pk1*Pkd3*k1**6*(7*D1**2*K*b1**2*fd*r**2 + 14*D1**2*K*b1**2*fd*r*s + 7*D1**2*K*b1**2*fd*s**2 - 21*D1**2*K*b1**2*fdd*r**2 - 42*D1**2*K*b1**2*fdd*r*s - 21*D1**2*K*b1**2*fdd*s**2 + 18*D1**2*K*b1*f*fd*r**2 + 36*D1**2*K*b1*f*fd*r*s - 18*D1**2*K*b1*f*fd*r + 18*D1**2*K*b1*f*fd*s**2 - 18*D1**2*K*b1*f*fd*s + 9*D1**2*K*b1*f*fd - 30*D1**2*K*b1*f*fdd*r**2 - 60*D1**2*K*b1*f*fdd*r*s + 30*D1**2*K*b1*f*fdd*r - 30*D1**2*K*b1*f*fdd*s**2 + 30*D1**2*K*b1*f*fdd*s - 15*D1**2*K*b1*f*fdd - 30*D1**2*K*b1*fd**2*r**2 - 60*D1**2*K*b1*fd**2*r*s + 30*D1**2*K*b1*fd**2*r - 30*D1**2*K*b1*fd**2*s**2 + 30*D1**2*K*b1*fd**2*s - 42*D1**2*K*bd1**2*f*(r + s - 1)**2 - 14*D1**2*b1*f*gd2*r**2 - 28*D1**2*b1*f*gd2*r*s + 28*D1**2*b1*f*gd2*r - 14*D1**2*b1*f*gd2*s**2 + 28*D1**2*b1*f*gd2*s - 14*D1**2*b1*f*gd2 + 42*D1**2*b1*f*gdd2*r**2 + 84*D1**2*b1*f*gdd2*r*s - 84*D1**2*b1*f*gdd2*r + 42*D1**2*b1*f*gdd2*s**2 - 84*D1**2*b1*f*gdd2*s + 42*D1**2*b1*f*gdd2 - 14*D1**2*b1*fd*g2*r**2 - 28*D1**2*b1*fd*g2*r*s - 14*D1**2*b1*fd*g2*s**2 + 84*D1**2*b1*fd*gd2*r**2 + 168*D1**2*b1*fd*gd2*r*s - 84*D1**2*b1*fd*gd2*r + 84*D1**2*b1*fd*gd2*s**2 - 84*D1**2*b1*fd*gd2*s + 42*D1**2*b1*fdd*g2*r**2 + 84*D1**2*b1*fdd*g2*r*s + 42*D1**2*b1*fdd*g2*s**2 - 3*D1**2*bdd1*f*(r + s - 1)**2*(14*K*b1 + 5*K*f - 14*g2) - 18*D1**2*f**2*gd2*r**2 - 36*D1**2*f**2*gd2*r*s + 36*D1**2*f**2*gd2*r - 18*D1**2*f**2*gd2*s**2 + 36*D1**2*f**2*gd2*s - 18*D1**2*f**2*gd2 + 30*D1**2*f**2*gdd2*r**2 + 60*D1**2*f**2*gdd2*r*s - 60*D1**2*f**2*gdd2*r + 30*D1**2*f**2*gdd2*s**2 - 60*D1**2*f**2*gdd2*s + 30*D1**2*f**2*gdd2 - 36*D1**2*f*fd*g2*r**2 - 72*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r - 36*D1**2*f*fd*g2*s**2 + 36*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 + 120*D1**2*f*fd*gd2*r**2 + 240*D1**2*f*fd*gd2*r*s - 180*D1**2*f*fd*gd2*r + 120*D1**2*f*fd*gd2*s**2 - 180*D1**2*f*fd*gd2*s + 60*D1**2*f*fd*gd2 + 60*D1**2*f*fdd*g2*r**2 + 120*D1**2*f*fdd*g2*r*s - 60*D1**2*f*fdd*g2*r + 60*D1**2*f*fdd*g2*s**2 - 60*D1**2*f*fdd*g2*s + 30*D1**2*f*fdd*g2 + 60*D1**2*fd**2*g2*r**2 + 120*D1**2*fd**2*g2*r*s - 60*D1**2*fd**2*g2*r + 60*D1**2*fd**2*g2*s**2 - 60*D1**2*fd**2*g2*s + 28*D1*Dd*K*b1**2*f*r**2 + 56*D1*Dd*K*b1**2*f*r*s - 42*D1*Dd*K*b1**2*f*r + 28*D1*Dd*K*b1**2*f*s**2 - 42*D1*Dd*K*b1**2*f*s + 21*D1*Dd*K*b1**2*f - 168*D1*Dd*K*b1**2*fd*r**2 - 336*D1*Dd*K*b1**2*fd*r*s + 126*D1*Dd*K*b1**2*fd*r - 168*D1*Dd*K*b1**2*fd*s**2 + 126*D1*Dd*K*b1**2*fd*s + 36*D1*Dd*K*b1*f**2*r**2 + 72*D1*Dd*K*b1*f**2*r*s - 54*D1*Dd*K*b1*f**2*r + 36*D1*Dd*K*b1*f**2*s**2 - 54*D1*Dd*K*b1*f**2*s + 27*D1*Dd*K*b1*f**2 - 240*D1*Dd*K*b1*f*fd*r**2 - 480*D1*Dd*K*b1*f*fd*r*s + 300*D1*Dd*K*b1*f*fd*r - 240*D1*Dd*K*b1*f*fd*s**2 + 300*D1*Dd*K*b1*f*fd*s - 90*D1*Dd*K*b1*f*fd - 56*D1*Dd*b1*f*g2*r**2 - 112*D1*Dd*b1*f*g2*r*s + 84*D1*Dd*b1*f*g2*r - 56*D1*Dd*b1*f*g2*s**2 + 84*D1*Dd*b1*f*g2*s - 42*D1*Dd*b1*f*g2 + 336*D1*Dd*b1*f*gd2*r**2 + 672*D1*Dd*b1*f*gd2*r*s - 588*D1*Dd*b1*f*gd2*r + 336*D1*Dd*b1*f*gd2*s**2 - 588*D1*Dd*b1*f*gd2*s + 252*D1*Dd*b1*f*gd2 + 336*D1*Dd*b1*fd*g2*r**2 + 672*D1*Dd*b1*fd*g2*r*s - 252*D1*Dd*b1*fd*g2*r + 336*D1*Dd*b1*fd*g2*s**2 - 252*D1*Dd*b1*fd*g2*s - 72*D1*Dd*f**2*g2*r**2 - 144*D1*Dd*f**2*g2*r*s + 108*D1*Dd*f**2*g2*r - 72*D1*Dd*f**2*g2*s**2 + 108*D1*Dd*f**2*g2*s - 54*D1*Dd*f**2*g2 + 240*D1*Dd*f**2*gd2*r**2 + 480*D1*Dd*f**2*gd2*r*s - 420*D1*Dd*f**2*gd2*r + 240*D1*Dd*f**2*gd2*s**2 - 420*D1*Dd*f**2*gd2*s + 180*D1*Dd*f**2*gd2 + 480*D1*Dd*f*fd*g2*r**2 + 960*D1*Dd*f*fd*g2*r*s - 600*D1*Dd*f*fd*g2*r + 480*D1*Dd*f*fd*g2*s**2 - 600*D1*Dd*f*fd*g2*s + 180*D1*Dd*f*fd*g2 - 84*D1*Ddd*K*b1**2*f*r**2 - 168*D1*Ddd*K*b1**2*f*r*s + 126*D1*Ddd*K*b1**2*f*r - 84*D1*Ddd*K*b1**2*f*s**2 + 126*D1*Ddd*K*b1**2*f*s - 63*D1*Ddd*K*b1**2*f - 60*D1*Ddd*K*b1*f**2*r**2 - 120*D1*Ddd*K*b1*f**2*r*s + 90*D1*Ddd*K*b1*f**2*r - 60*D1*Ddd*K*b1*f**2*s**2 + 90*D1*Ddd*K*b1*f**2*s - 45*D1*Ddd*K*b1*f**2 + 168*D1*Ddd*b1*f*g2*r**2 + 336*D1*Ddd*b1*f*g2*r*s - 252*D1*Ddd*b1*f*g2*r + 168*D1*Ddd*b1*f*g2*s**2 - 252*D1*Ddd*b1*f*g2*s + 126*D1*Ddd*b1*f*g2 + 120*D1*Ddd*f**2*g2*r**2 + 240*D1*Ddd*f**2*g2*r*s - 180*D1*Ddd*f**2*g2*r + 120*D1*Ddd*f**2*g2*s**2 - 180*D1*Ddd*f**2*g2*s + 90*D1*Ddd*f**2*g2 + D1*bd1*(D1*(9*K*f**2*(r + s - 1) - 2*f*(-7*K*b1*(r + s - 1) + 15*K*fd*(2*r + 2*s - 1) + 7*g2*(r + s - 1) - 42*gd2*(r + s - 1)) + 84*fd*(r + s)*(-K*b1 + g2)) - 6*Dd*f*(4*r + 4*s - 3)*(14*K*b1 + 5*K*f - 14*g2))*(r + s - 1) - 252*Dd**2*K*b1**2*f*r**2 - 504*Dd**2*K*b1**2*f*r*s + 378*Dd**2*K*b1**2*f*r - 252*Dd**2*K*b1**2*f*s**2 + 378*Dd**2*K*b1**2*f*s - 126*Dd**2*K*b1**2*f - 180*Dd**2*K*b1*f**2*r**2 - 360*Dd**2*K*b1*f**2*r*s + 270*Dd**2*K*b1*f**2*r - 180*Dd**2*K*b1*f**2*s**2 + 270*Dd**2*K*b1*f**2*s - 90*Dd**2*K*b1*f**2 + 504*Dd**2*b1*f*g2*r**2 + 1008*Dd**2*b1*f*g2*r*s - 756*Dd**2*b1*f*g2*r + 504*Dd**2*b1*f*g2*s**2 - 756*Dd**2*b1*f*g2*s + 252*Dd**2*b1*f*g2 + 360*Dd**2*f**2*g2*r**2 + 720*Dd**2*f**2*g2*r*s - 540*Dd**2*f**2*g2*r + 360*Dd**2*f**2*g2*s**2 - 540*Dd**2*f**2*g2*s + 180*Dd**2*f**2*g2)/(70*d**2*k3**7) + D1**2*Pk1*Pkd3*k1**4*k2**2*st**4*(18*C - 9)*(10*D1**2*b1*f*fd*r**2 + 20*D1**2*b1*f*fd*r*s - 10*D1**2*b1*f*fd*r + 10*D1**2*b1*f*fd*s**2 - 10*D1**2*b1*f*fd*s + 5*D1**2*b1*f*fd - 12*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 12*D1**2*b1*f*fdd*r - 12*D1**2*b1*f*fdd*s**2 + 12*D1**2*b1*f*fdd*s - 6*D1**2*b1*f*fdd - 12*D1**2*b1*fd**2*r**2 - 24*D1**2*b1*fd**2*r*s + 12*D1**2*b1*fd**2*r - 12*D1**2*b1*fd**2*s**2 + 12*D1**2*b1*fd**2*s - 6*D1**2*bdd1*f**2*(r + s - 1)**2 + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 6*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 8*D1**2*f**2*fdd*r - 6*D1**2*f**2*fdd*s**2 + 8*D1**2*f**2*fdd*s - 4*D1**2*f**2*fdd - 12*D1**2*f*fd**2*r**2 - 24*D1**2*f*fd**2*r*s + 16*D1**2*f*fd**2*r - 12*D1**2*f*fd**2*s**2 + 16*D1**2*f*fd**2*s - 4*D1**2*f*fd**2 + 20*D1*Dd*b1*f**2*r**2 + 40*D1*Dd*b1*f**2*r*s - 30*D1*Dd*b1*f**2*r + 20*D1*Dd*b1*f**2*s**2 - 30*D1*Dd*b1*f**2*s + 15*D1*Dd*b1*f**2 - 96*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 120*D1*Dd*b1*f*fd*r - 96*D1*Dd*b1*f*fd*s**2 + 120*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 - 48*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 68*D1*Dd*f**2*fd*r - 48*D1*Dd*f**2*fd*s**2 + 68*D1*Dd*f**2*fd*s - 24*D1*Dd*f**2*fd - 24*D1*Ddd*b1*f**2*r**2 - 48*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 24*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 8*D1*Ddd*f**3*r**2 - 16*D1*Ddd*f**3*r*s + 12*D1*Ddd*f**3*r - 8*D1*Ddd*f**3*s**2 + 12*D1*Ddd*f**3*s - 6*D1*Ddd*f**3 + D1*bd1*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*b1*f**2*r**2 - 144*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 72*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 36*Dd**2*b1*f**2 - 24*Dd**2*f**3*r**2 - 48*Dd**2*f**3*r*s + 36*Dd**2*f**3*r - 24*Dd**2*f**3*s**2 + 36*Dd**2*f**3*s - 12*Dd**2*f**3)/(70*d**2*k3**7) + D1**2*Pk1*Pkd3*k1**4*k2**2*st**2*(-594*C*D1**2*f**2*fd*r**2 - 1188*C*D1**2*f**2*fd*r*s + 792*C*D1**2*f**2*fd*r - 594*C*D1**2*f**2*fd*s**2 + 792*C*D1**2*f**2*fd*s - 396*C*D1**2*f**2*fd - 792*C*D1*Dd*f**3*r**2 - 1584*C*D1*Dd*f**3*r*s + 1188*C*D1*Dd*f**3*r - 792*C*D1*Dd*f**3*s**2 + 1188*C*D1*Dd*f**3*s - 594*C*D1*Dd*f**3 - 594*D1**2*K*bdd1*f**2*r**2 - 1188*D1**2*K*bdd1*f**2*r*s + 1188*D1**2*K*bdd1*f**2*r - 594*D1**2*K*bdd1*f**2*s**2 + 1188*D1**2*K*bdd1*f**2*s - 594*D1**2*K*bdd1*f**2 + 198*D1**2*bd1**2*f*(-14*K + 5*f)*(r + s - 1)**2 + 220*D1**2*bdd1*f**3*r**2 + 440*D1**2*bdd1*f**3*r*s - 440*D1**2*bdd1*f**3*r + 220*D1**2*bdd1*f**3*s**2 - 440*D1**2*bdd1*f**3*s + 220*D1**2*bdd1*f**3 + 2772*D1**2*bdd1*f*g2*r**2 + 5544*D1**2*bdd1*f*g2*r*s - 5544*D1**2*bdd1*f*g2*r + 2772*D1**2*bdd1*f*g2*s**2 - 5544*D1**2*bdd1*f*g2*s + 2772*D1**2*bdd1*f*g2 + 60*D1**2*f**3*fd*r**2 + 120*D1**2*f**3*fd*r*s - 90*D1**2*f**3*fd*r + 60*D1**2*f**3*fd*s**2 - 90*D1**2*f**3*fd*s + 45*D1**2*f**3*fd - 140*D1**2*f**3*fdd*r**2 - 280*D1**2*f**3*fdd*r*s + 210*D1**2*f**3*fdd*r - 140*D1**2*f**3*fdd*s**2 + 210*D1**2*f**3*fdd*s - 105*D1**2*f**3*fdd - 420*D1**2*f**2*fd**2*r**2 - 840*D1**2*f**2*fd**2*r*s + 630*D1**2*f**2*fd**2*r - 420*D1**2*f**2*fd**2*s**2 + 630*D1**2*f**2*fd**2*s - 210*D1**2*f**2*fd**2 + 297*D1**2*f**2*fd*r**2 + 594*D1**2*f**2*fd*r*s - 396*D1**2*f**2*fd*r + 297*D1**2*f**2*fd*s**2 - 396*D1**2*f**2*fd*s + 198*D1**2*f**2*fd - 1914*D1**2*f**2*gd2*r**2 - 3828*D1**2*f**2*gd2*r*s + 3828*D1**2*f**2*gd2*r - 1914*D1**2*f**2*gd2*s**2 + 3828*D1**2*f**2*gd2*s - 1914*D1**2*f**2*gd2 + 1188*D1**2*f**2*gdd2*r**2 + 2376*D1**2*f**2*gdd2*r*s - 2376*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 2376*D1**2*f**2*gdd2*s + 1188*D1**2*f**2*gdd2 - 3828*D1**2*f*fd*g2*r**2 - 7656*D1**2*f*fd*g2*r*s + 3828*D1**2*f*fd*g2*r - 3828*D1**2*f*fd*g2*s**2 + 3828*D1**2*f*fd*g2*s - 1914*D1**2*f*fd*g2 + 4752*D1**2*f*fd*gd2*r**2 + 9504*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2376*D1**2*f*fd*gd2 + 2376*D1**2*f*fdd*g2*r**2 + 4752*D1**2*f*fdd*g2*r*s - 2376*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 2376*D1**2*fd**2*g2*r**2 + 4752*D1**2*fd**2*g2*r*s - 2376*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 60*D1*Dd*f**4*r**2 + 120*D1*Dd*f**4*r*s - 90*D1*Dd*f**4*r + 60*D1*Dd*f**4*s**2 - 90*D1*Dd*f**4*s + 45*D1*Dd*f**4 - 1120*D1*Dd*f**3*fd*r**2 - 2240*D1*Dd*f**3*fd*r*s + 1680*D1*Dd*f**3*fd*r - 1120*D1*Dd*f**3*fd*s**2 + 1680*D1*Dd*f**3*fd*s - 630*D1*Dd*f**3*fd + 396*D1*Dd*f**3*r**2 + 792*D1*Dd*f**3*r*s - 594*D1*Dd*f**3*r + 396*D1*Dd*f**3*s**2 - 594*D1*Dd*f**3*s + 297*D1*Dd*f**3 - 7656*D1*Dd*f**2*g2*r**2 - 15312*D1*Dd*f**2*g2*r*s + 11484*D1*Dd*f**2*g2*r - 7656*D1*Dd*f**2*g2*s**2 + 11484*D1*Dd*f**2*g2*s - 5742*D1*Dd*f**2*g2 + 9504*D1*Dd*f**2*gd2*r**2 + 19008*D1*Dd*f**2*gd2*r*s - 16632*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 19008*D1*Dd*f*fd*g2*r**2 + 38016*D1*Dd*f*fd*g2*r*s - 23760*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 23760*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**4*r**2 - 280*D1*Ddd*f**4*r*s + 210*D1*Ddd*f**4*r - 140*D1*Ddd*f**4*s**2 + 210*D1*Ddd*f**4*s - 105*D1*Ddd*f**4 + 4752*D1*Ddd*f**2*g2*r**2 + 9504*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(22*f**3*(r + s - 1) + f**2*(42*C*(r + s - 1) - 87*K*r - 87*K*s + 87*K + 54*b1*(r + s - 1) - 120*fd*r - 120*fd*s + 80*fd - 21*r - 21*s + 21) - 6*f*(49*K*b1*(r + s - 1) - 18*K*fd*(2*r + 2*s - 1) + 30*b1*fd*(2*r + 2*s - 1) - 49*g2*(r + s - 1) + 84*gd2*(r + s - 1)) - 504*fd*(r + s)*(-K*b1 + g2)) - 4*Dd*f*(4*r + 4*s - 3)*(-27*K*f + 9*b1*(-14*K + 5*f) + 10*f**2 + 126*g2))*(r + s - 1) - 420*Dd**2*f**4*r**2 - 840*Dd**2*f**4*r*s + 630*Dd**2*f**4*r - 420*Dd**2*f**4*s**2 + 630*Dd**2*f**4*s - 210*Dd**2*f**4 + 14256*Dd**2*f**2*g2*r**2 + 28512*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 7128*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(3*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(49*K*fd*(r + s) - 42*K*fdd*(r + s) + 30*fd**2*(r + s - 1))) + D1*(Dd*(84*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(49*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 30*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 3*Ddd*f*(-14*K + 5*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-14*K + 5*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(18*D1**2*bdd1*f*(-14*K + 5*f)*(r + s - 1)**2 + D1**2*(-2*f**2*(11*fd - 10*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-54*K*fdd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 3*fd*(14*C - 29*K - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 294*gd2*(r + s - 1)**2 + 252*gdd2*(r + s - 1)**2) + (-6*r - 6*s)*(18*K*fd**2*(r + s - 1) + 49*fd*g2*(r + s) - 84*fd*gd2*(r + s - 1) - 42*fdd*g2*(r + s))) + D1*(Dd*(-22*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-42*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 40*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + (87*K + 21)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 6*f*(49*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (-3*K*fd*(2*r + 2*s - 1) + 14*gd2*(r + s - 1))*(-24*r - 24*s + 18)) + 504*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 2*Ddd*f*(-27*K*f + 10*f**2 + 126*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f*(-27*K*f + 10*f**2 + 126*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(770*d**2*k3**7) + D1**2*Pk1*Pkd3*k1**4*st**4*(4*C - 2)*(3*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-3*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 3*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(35*d**2*k3**5) + D1**2*Pk1*Pkd3*k1**4*st**2*(-105*b1**2*(2*C - 1)*(D1**2*(3*fd + fdd)*(r + s - 1)**2 + D1*(Dd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(68*C*D1**2*f*fd*r**2 + 584*C*D1**2*f*fd*r*s - 312*C*D1**2*f*fd*r + 516*C*D1**2*f*fd*s**2 - 536*C*D1**2*f*fd*s + 268*C*D1**2*f*fd - 188*C*D1**2*f*fdd*r**2 - 712*C*D1**2*f*fdd*r*s + 296*C*D1**2*f*fdd*r - 524*C*D1**2*f*fdd*s**2 + 464*C*D1**2*f*fdd*s - 232*C*D1**2*f*fdd - 188*C*D1**2*fd**2*r**2 - 712*C*D1**2*fd**2*r*s + 296*C*D1**2*fd**2*r - 524*C*D1**2*fd**2*s**2 + 464*C*D1**2*fd**2*s + 60*C*D1**2*fd**2 + 136*C*D1*Dd*f**2*r**2 + 1168*C*D1*Dd*f**2*r*s - 652*C*D1*Dd*f**2*r + 1032*C*D1*Dd*f**2*s**2 - 1324*C*D1*Dd*f**2*s + 550*C*D1*Dd*f**2 - 1504*C*D1*Dd*f*fd*r**2 - 5696*C*D1*Dd*f*fd*r*s + 2984*C*D1*Dd*f*fd*r - 4192*C*D1*Dd*f*fd*s**2 + 4664*C*D1*Dd*f*fd*s - 1224*C*D1*Dd*f*fd - 376*C*D1*Ddd*f**2*r**2 - 1424*C*D1*Ddd*f**2*r*s + 900*C*D1*Ddd*f**2*r - 1048*C*D1*Ddd*f**2*s**2 + 1404*C*D1*Ddd*f**2*s - 618*C*D1*Ddd*f**2 - 1128*C*Dd**2*f**2*r**2 - 4272*C*Dd**2*f**2*r*s + 2700*C*Dd**2*f**2*r - 3144*C*Dd**2*f**2*s**2 + 4212*C*Dd**2*f**2*s - 1236*C*Dd**2*f**2 + 35*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 34*D1**2*f*fd*r**2 - 288*D1**2*f*fd*r*s + 154*D1**2*f*fd*r - 254*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd + 94*D1**2*f*fdd*r**2 + 368*D1**2*f*fdd*r*s - 154*D1**2*f*fdd*r + 274*D1**2*f*fdd*s**2 - 244*D1**2*f*fdd*s + 122*D1**2*f*fdd + 94*D1**2*fd**2*r**2 + 368*D1**2*fd**2*r*s - 154*D1**2*fd**2*r + 274*D1**2*fd**2*s**2 - 244*D1**2*fd**2*s - 30*D1**2*fd**2 - 68*D1*Dd*f**2*r**2 - 576*D1*Dd*f**2*r*s + 322*D1*Dd*f**2*r - 508*D1*Dd*f**2*s**2 + 652*D1*Dd*f**2*s - 271*D1*Dd*f**2 + 752*D1*Dd*f*fd*r**2 + 2944*D1*Dd*f*fd*r*s - 1540*D1*Dd*f*fd*r + 2192*D1*Dd*f*fd*s**2 - 2440*D1*Dd*f*fd*s + 642*D1*Dd*f*fd + 188*D1*Ddd*f**2*r**2 + 736*D1*Ddd*f**2*r*s - 462*D1*Ddd*f**2*r + 548*D1*Ddd*f**2*s**2 - 732*D1*Ddd*f**2*s + 321*D1*Ddd*f**2 + 35*D1*bd1*(2*C - 1)*(D1*(3*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 564*Dd**2*f**2*r**2 + 2208*Dd**2*f**2*r*s - 1386*Dd**2*f**2*r + 1644*Dd**2*f**2*s**2 - 2196*Dd**2*f**2*s + 642*Dd**2*f**2) + f*(-210*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*D1**2*bdd1*f*(2*C*(47*r**2 + 2*r*(89*s - 62) + 131*s**2 - 208*s + 62) - 47*r**2 - 4*r*(46*s - 31) - 137*s**2 + 214*s - 62) - 2*D1**2*(f*(fd*(4*C*(51*r**2 + 186*r*s - 96*r + 135*s**2 - 152*s + 62) - 102*r**2 - 375*r*s + 193*r - 273*s**2 + 307*s - 125) + fdd*(-2*C*(159*r**2 + 6*r*(76*s - 43) + 297*s**2 - 350*s + 152) + 159*r**2 + 471*r*s - 263*r + 312*s**2 - 365*s + 157)) + fd**2*(-4*C*(159*r**2 + 6*r*(76*s - 43) + 297*s**2 - 350*s + 76) + 318*r**2 + 942*r*s - 526*r + 624*s**2 - 730*s + 157)) - 3*D1*bd1*(D1*(f*(C*(34*r**2 + 292*r*s - 48*r + 258*s**2 - 272*s + 24) - 17*r**2 - 144*r*s + 24*r - 127*s**2 + 134*s - 12) - 2*fd*(4*C*(47*r**2 + 178*r*s - 99*r + 131*s**2 - 162*s + 52) - 94*r**2 - 368*r*s + 201*r - 274*s**2 + 336*s - 107)) - 2*Dd*f*(2*C*(188*r**2 + 712*r*s - 473*r + 524*s**2 - 767*s + 270) - 188*r**2 - 736*r*s + 479*r - 548*s**2 + 794*s - 276)) - 2*D1*f*(Dd*(f*(4*C*(68*r**2 + 2*r*(124*s - 79) + 180*s**2 - 242*s + 107) - 136*r**2 + r*(318 - 500*s) - 364*s**2 + 489*s - 216) + fd*(-4*C*(636*r**2 + 3*r*(608*s - 377) + 1188*s**2 - 1522*s + 479) + 1272*r**2 + 8*r*(471*s - 289) + 2496*s**2 - 3179*s + 993)) + Ddd*f*(-2*C*(212*r**2 + r*(608*s - 410) + 396*s**2 - 548*s + 251) + 212*r**2 + r*(628*s - 420) + 416*s**2 - 573*s + 261)) - 2*Dd**2*f**2*(-4*C*(318*r**2 + r*(912*s - 615) + 594*s**2 - 822*s + 251) + 636*r**2 + 3*r*(628*s - 420) + 1248*s**2 - 1719*s + 522)))/(630*d**2*k3**5) - D1**2*Pk1*Pkd3*k1**4*(-518*D1**2*K*bd1**2*f*r**2 - 1036*D1**2*K*bd1**2*f*r*s + 1246*D1**2*K*bd1**2*f*r - 518*D1**2*K*bd1**2*f*s**2 + 1246*D1**2*K*bd1**2*f*s - 728*D1**2*K*bd1**2*f + 192*D1**2*K*bd1*f**2*r**2 + 336*D1**2*K*bd1*f**2*r*s - 336*D1**2*K*bd1*f**2*r + 144*D1**2*K*bd1*f**2*s**2 - 288*D1**2*K*bd1*f**2*s + 144*D1**2*K*bd1*f**2 - 1056*D1**2*K*bd1*f*fd*r**2 - 2016*D1**2*K*bd1*f*fd*r*s + 1536*D1**2*K*bd1*f*fd*r - 960*D1**2*K*bd1*f*fd*s**2 + 1464*D1**2*K*bd1*f*fd*s - 504*D1**2*K*bd1*f*fd - 264*D1**2*K*bdd1*f**2*r**2 - 504*D1**2*K*bdd1*f**2*r*s + 504*D1**2*K*bdd1*f**2*r - 240*D1**2*K*bdd1*f**2*s**2 + 480*D1**2*K*bdd1*f**2*s - 240*D1**2*K*bdd1*f**2 + 84*D1**2*bd1**2*f**2*r*s - 42*D1**2*bd1**2*f**2*r + 84*D1**2*bd1**2*f**2*s**2 - 126*D1**2*bd1**2*f**2*s + 42*D1**2*bd1**2*f**2 + 84*D1**2*bd1**2*f*r*s - 42*D1**2*bd1**2*f*r + 84*D1**2*bd1**2*f*s**2 - 126*D1**2*bd1**2*f*s + 42*D1**2*bd1**2*f - 700*D1**2*bd1**2*g2*r**2 - 1400*D1**2*bd1**2*g2*r*s + 700*D1**2*bd1**2*g2*r - 700*D1**2*bd1**2*g2*s**2 + 700*D1**2*bd1**2*g2*s - 210*D1**2*bd1*bd2*f*r**2 - 420*D1**2*bd1*bd2*f*r*s + 420*D1**2*bd1*bd2*f*r - 210*D1**2*bd1*bd2*f*s**2 + 420*D1**2*bd1*bd2*f*s - 210*D1**2*bd1*bd2*f - 30*D1**2*bd1*f**3*r*s + 30*D1**2*bd1*f**3*r - 30*D1**2*bd1*f**3*s**2 + 60*D1**2*bd1*f**3*s - 30*D1**2*bd1*f**3 + 180*D1**2*bd1*f**2*fd*r*s - 120*D1**2*bd1*f**2*fd*r + 180*D1**2*bd1*f**2*fd*s**2 - 270*D1**2*bd1*f**2*fd*s + 90*D1**2*bd1*f**2*fd - 18*D1**2*bd1*f**2*r*s + 18*D1**2*bd1*f**2*r - 18*D1**2*bd1*f**2*s**2 + 36*D1**2*bd1*f**2*s - 18*D1**2*bd1*f**2 + 120*D1**2*bd1*f*fd*r*s - 60*D1**2*bd1*f*fd*r + 120*D1**2*bd1*f*fd*s**2 - 150*D1**2*bd1*f*fd*s + 30*D1**2*bd1*f*fd - 266*D1**2*bd1*f*g2*r**2 - 532*D1**2*bd1*f*g2*r*s + 672*D1**2*bd1*f*g2*r - 266*D1**2*bd1*f*g2*s**2 + 672*D1**2*bd1*f*g2*s - 336*D1**2*bd1*f*g2 + 1036*D1**2*bd1*f*gd2*r**2 + 2072*D1**2*bd1*f*gd2*r*s - 2492*D1**2*bd1*f*gd2*r + 1036*D1**2*bd1*f*gd2*s**2 - 2492*D1**2*bd1*f*gd2*s + 1456*D1**2*bd1*f*gd2 + 1036*D1**2*bd1*fd*g2*r**2 + 2072*D1**2*bd1*fd*g2*r*s - 1036*D1**2*bd1*fd*g2*r + 1036*D1**2*bd1*fd*g2*s**2 - 1036*D1**2*bd1*fd*g2*s + 45*D1**2*bd2*f**2*r**2 + 90*D1**2*bd2*f**2*r*s - 90*D1**2*bd2*f**2*r + 45*D1**2*bd2*f**2*s**2 - 90*D1**2*bd2*f**2*s + 45*D1**2*bd2*f**2 - 300*D1**2*bd2*f*fd*r**2 - 600*D1**2*bd2*f*fd*r*s + 450*D1**2*bd2*f*fd*r - 300*D1**2*bd2*f*fd*s**2 + 450*D1**2*bd2*f*fd*s - 150*D1**2*bd2*f*fd + 30*D1**2*bdd1*f**3*r*s - 30*D1**2*bdd1*f**3*r + 30*D1**2*bdd1*f**3*s**2 - 60*D1**2*bdd1*f**3*s + 30*D1**2*bdd1*f**3 + 30*D1**2*bdd1*f**2*r*s - 30*D1**2*bdd1*f**2*r + 30*D1**2*bdd1*f**2*s**2 - 60*D1**2*bdd1*f**2*s + 30*D1**2*bdd1*f**2 + 518*D1**2*bdd1*f*g2*r**2 + 1036*D1**2*bdd1*f*g2*r*s - 1456*D1**2*bdd1*f*g2*r + 518*D1**2*bdd1*f*g2*s**2 - 1456*D1**2*bdd1*f*g2*s + 728*D1**2*bdd1*f*g2 - 75*D1**2*bdd2*f**2*r**2 - 150*D1**2*bdd2*f**2*r*s + 150*D1**2*bdd2*f**2*r - 75*D1**2*bdd2*f**2*s**2 + 150*D1**2*bdd2*f**2*s - 75*D1**2*bdd2*f**2 - 384*D1**2*f**2*gd2*r**2 - 672*D1**2*f**2*gd2*r*s + 672*D1**2*f**2*gd2*r - 288*D1**2*f**2*gd2*s**2 + 576*D1**2*f**2*gd2*s - 288*D1**2*f**2*gd2 + 528*D1**2*f**2*gdd2*r**2 + 1008*D1**2*f**2*gdd2*r*s - 1008*D1**2*f**2*gdd2*r + 480*D1**2*f**2*gdd2*s**2 - 960*D1**2*f**2*gdd2*s + 480*D1**2*f**2*gdd2 - 768*D1**2*f*fd*g2*r**2 - 1344*D1**2*f*fd*g2*r*s + 768*D1**2*f*fd*g2*r - 576*D1**2*f*fd*g2*s**2 + 672*D1**2*f*fd*g2*s - 384*D1**2*f*fd*g2 + 2112*D1**2*f*fd*gd2*r**2 + 4032*D1**2*f*fd*gd2*r*s - 3072*D1**2*f*fd*gd2*r + 1920*D1**2*f*fd*gd2*s**2 - 2928*D1**2*f*fd*gd2*s + 1008*D1**2*f*fd*gd2 + 1056*D1**2*f*fdd*g2*r**2 + 2016*D1**2*f*fdd*g2*r*s - 1056*D1**2*f*fdd*g2*r + 960*D1**2*f*fdd*g2*s**2 - 1008*D1**2*f*fdd*g2*s + 528*D1**2*f*fdd*g2 + 1056*D1**2*fd**2*g2*r**2 + 2016*D1**2*fd**2*g2*r*s - 1056*D1**2*fd**2*g2*r + 960*D1**2*fd**2*g2*s**2 - 1008*D1**2*fd**2*g2*s - 2112*D1*Dd*K*bd1*f**2*r**2 - 4032*D1*Dd*K*bd1*f**2*r*s + 3552*D1*Dd*K*bd1*f**2*r - 1920*D1*Dd*K*bd1*f**2*s**2 + 3384*D1*Dd*K*bd1*f**2*s - 1464*D1*Dd*K*bd1*f**2 + 240*D1*Dd*bd1*f**3*r*s - 180*D1*Dd*bd1*f**3*r + 240*D1*Dd*bd1*f**3*s**2 - 390*D1*Dd*bd1*f**3*s + 150*D1*Dd*bd1*f**3 + 240*D1*Dd*bd1*f**2*r*s - 180*D1*Dd*bd1*f**2*r + 240*D1*Dd*bd1*f**2*s**2 - 390*D1*Dd*bd1*f**2*s + 150*D1*Dd*bd1*f**2 + 4144*D1*Dd*bd1*f*g2*r**2 + 8288*D1*Dd*bd1*f*g2*r*s - 8932*D1*Dd*bd1*f*g2*r + 4144*D1*Dd*bd1*f*g2*s**2 - 8932*D1*Dd*bd1*f*g2*s + 4368*D1*Dd*bd1*f*g2 - 600*D1*Dd*bd2*f**2*r**2 - 1200*D1*Dd*bd2*f**2*r*s + 1050*D1*Dd*bd2*f**2*r - 600*D1*Dd*bd2*f**2*s**2 + 1050*D1*Dd*bd2*f**2*s - 450*D1*Dd*bd2*f**2 - 1536*D1*Dd*f**2*g2*r**2 - 2688*D1*Dd*f**2*g2*r*s + 2112*D1*Dd*f**2*g2*r - 1152*D1*Dd*f**2*g2*s**2 + 1824*D1*Dd*f**2*g2*s - 960*D1*Dd*f**2*g2 + 4224*D1*Dd*f**2*gd2*r**2 + 8064*D1*Dd*f**2*gd2*r*s - 7104*D1*Dd*f**2*gd2*r + 3840*D1*Dd*f**2*gd2*s**2 - 6768*D1*Dd*f**2*gd2*s + 2928*D1*Dd*f**2*gd2 + 8448*D1*Dd*f*fd*g2*r**2 + 16128*D1*Dd*f*fd*g2*r*s - 10368*D1*Dd*f*fd*g2*r + 7680*D1*Dd*f*fd*g2*s**2 - 9888*D1*Dd*f*fd*g2*s + 3072*D1*Dd*f*fd*g2 + 2112*D1*Ddd*f**2*g2*r**2 + 4032*D1*Ddd*f**2*g2*r*s - 3072*D1*Ddd*f**2*g2*r + 1920*D1*Ddd*f**2*g2*s**2 - 2928*D1*Ddd*f**2*g2*s + 1488*D1*Ddd*f**2*g2 + 6336*Dd**2*f**2*g2*r**2 + 12096*Dd**2*f**2*g2*r*s - 9216*Dd**2*f**2*g2*r + 5760*Dd**2*f**2*g2*s**2 - 8784*Dd**2*f**2*g2*s + 2976*Dd**2*f**2*g2 + 175*K*b1**3*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 7*b1**2*(D1**2*(-75*K*bd1*r**2 - 150*K*bd1*r*s + 100*K*bd1*r - 75*K*bd1*s**2 + 100*K*bd1*s - 50*K*bd1 - 75*K*bdd1*r**2 - 150*K*bdd1*r*s + 100*K*bdd1*r - 75*K*bdd1*s**2 + 100*K*bdd1*s - 50*K*bdd1 - 19*K*fd*r**2 - 38*K*fd*r*s - 10*K*fd*r - 19*K*fd*s**2 - 10*K*fd*s + 5*K*fd + 37*K*fdd*r**2 + 74*K*fdd*r*s + 30*K*fdd*r + 37*K*fdd*s**2 + 30*K*fdd*s - 15*K*fdd + 6*f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 12*fd**2*r*s + 6*fd**2*r - 12*fd**2*s**2 + 12*fd**2*s + 2*fd*r*s + 2*fd*s**2 - 6*fdd*r*s - 6*fdd*s**2 + 50*gd2*(r + s - 1)**2 + 50*gdd2*r**2 + 100*gdd2*r*s - 100*gdd2*r + 50*gdd2*s**2 - 100*gdd2*s + 50*gdd2) + D1*(Dd*(-600*K*bd1*r**2 - 1200*K*bd1*r*s + 850*K*bd1*r - 600*K*bd1*s**2 + 850*K*bd1*s - 300*K*bd1 + 296*K*fd*r**2 + 592*K*fd*r*s - 102*K*fd*r + 296*K*fd*s**2 - 102*K*fd*s - 90*K*fd + 6*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - f*(19*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 6*fd*(2*s - 1)*(8*r + 8*s - 5) - 8*r*s + 4*r - 8*s**2 + 10*s - 4) - 48*fd*r*s + 12*fd*r - 48*fd*s**2 + 30*fd*s + 50*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 100*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*(-6*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(37*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 24*r*s + 12*r - 24*s**2 + 30*s - 12) + 50*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) - 6*Dd**2*(f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4) + f*(-37*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 12*r*s - 6*r + 12*s**2 - 15*s + 4) - 50*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + b1*(350*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 518*D1**2*K*bdd1*f*r**2 - 1036*D1**2*K*bdd1*f*r*s + 1246*D1**2*K*bdd1*f*r - 518*D1**2*K*bdd1*f*s**2 + 1246*D1**2*K*bdd1*f*s - 623*D1**2*K*bdd1*f + 384*D1**2*K*f*fd*r**2 + 672*D1**2*K*f*fd*r*s - 384*D1**2*K*f*fd*r + 288*D1**2*K*f*fd*s**2 - 336*D1**2*K*f*fd*s + 192*D1**2*K*f*fd - 528*D1**2*K*f*fdd*r**2 - 1008*D1**2*K*f*fdd*r*s + 528*D1**2*K*f*fdd*r - 480*D1**2*K*f*fdd*s**2 + 504*D1**2*K*f*fdd*s - 264*D1**2*K*f*fdd - 528*D1**2*K*fd**2*r**2 - 1008*D1**2*K*fd**2*r*s + 528*D1**2*K*fd**2*r - 480*D1**2*K*fd**2*s**2 + 504*D1**2*K*fd**2*s + 35*D1**2*b2*fd*r**2 + 70*D1**2*b2*fd*r*s + 35*D1**2*b2*fd*s**2 - 105*D1**2*b2*fdd*r**2 - 210*D1**2*b2*fdd*r*s - 105*D1**2*b2*fdd*s**2 + 84*D1**2*bdd1*f**2*r*s - 42*D1**2*bdd1*f**2*r + 84*D1**2*bdd1*f**2*s**2 - 126*D1**2*bdd1*f**2*s + 42*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*r*s - 42*D1**2*bdd1*f*r + 84*D1**2*bdd1*f*s**2 - 126*D1**2*bdd1*f*s + 42*D1**2*bdd1*f - 700*D1**2*bdd1*g2*r**2 - 1400*D1**2*bdd1*g2*r*s + 700*D1**2*bdd1*g2*r - 700*D1**2*bdd1*g2*s**2 + 700*D1**2*bdd1*g2*s - 350*D1**2*bdd1*g2 - 105*D1**2*bdd2*f*r**2 - 210*D1**2*bdd2*f*r*s + 210*D1**2*bdd2*f*r - 105*D1**2*bdd2*f*s**2 + 210*D1**2*bdd2*f*s - 105*D1**2*bdd2*f - 90*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 90*D1**2*f**2*fd*s - 30*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r*s - 30*D1**2*f**2*fdd*r + 90*D1**2*f**2*fdd*s**2 - 90*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r*s - 60*D1**2*f*fd**2*r + 180*D1**2*f*fd**2*s**2 - 180*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 - 36*D1**2*f*fd*r*s - 36*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s + 60*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s - 266*D1**2*f*gd2*r**2 - 532*D1**2*f*gd2*r*s + 532*D1**2*f*gd2*r - 266*D1**2*f*gd2*s**2 + 532*D1**2*f*gd2*s - 266*D1**2*f*gd2 + 518*D1**2*f*gdd2*r**2 + 1036*D1**2*f*gdd2*r*s - 1036*D1**2*f*gdd2*r + 518*D1**2*f*gdd2*s**2 - 1036*D1**2*f*gdd2*s + 518*D1**2*f*gdd2 + 60*D1**2*fd**2*r*s + 60*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s - 266*D1**2*fd*g2*r**2 - 532*D1**2*fd*g2*r*s - 140*D1**2*fd*g2*r - 266*D1**2*fd*g2*s**2 - 140*D1**2*fd*g2*s + 70*D1**2*fd*g2 + 1036*D1**2*fd*gd2*r**2 + 2072*D1**2*fd*gd2*r*s - 616*D1**2*fd*gd2*r + 1036*D1**2*fd*gd2*s**2 - 616*D1**2*fd*gd2*s - 420*D1**2*fd*gd2 + 518*D1**2*fdd*g2*r**2 + 1036*D1**2*fdd*g2*r*s + 420*D1**2*fdd*g2*r + 518*D1**2*fdd*g2*s**2 + 420*D1**2*fdd*g2*s - 210*D1**2*fdd*g2 + 768*D1*Dd*K*f**2*r**2 + 1344*D1*Dd*K*f**2*r*s - 1056*D1*Dd*K*f**2*r + 576*D1*Dd*K*f**2*s**2 - 912*D1*Dd*K*f**2*s + 480*D1*Dd*K*f**2 - 4224*D1*Dd*K*f*fd*r**2 - 8064*D1*Dd*K*f*fd*r*s + 5184*D1*Dd*K*f*fd*r - 3840*D1*Dd*K*f*fd*s**2 + 4944*D1*Dd*K*f*fd*s - 1536*D1*Dd*K*f*fd + 140*D1*Dd*b2*f*r**2 + 280*D1*Dd*b2*f*r*s - 210*D1*Dd*b2*f*r + 140*D1*Dd*b2*f*s**2 - 210*D1*Dd*b2*f*s + 105*D1*Dd*b2*f - 840*D1*Dd*b2*fd*r**2 - 1680*D1*Dd*b2*fd*r*s + 630*D1*Dd*b2*fd*r - 840*D1*Dd*b2*fd*s**2 + 630*D1*Dd*b2*fd*s - 120*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r*s - 300*D1*Dd*f**2*fd*r + 720*D1*Dd*f**2*fd*s**2 - 810*D1*Dd*f**2*fd*s + 210*D1*Dd*f**2*fd - 72*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 90*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 480*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 420*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 1064*D1*Dd*f*g2*r**2 - 2128*D1*Dd*f*g2*r*s + 1596*D1*Dd*f*g2*r - 1064*D1*Dd*f*g2*s**2 + 1596*D1*Dd*f*g2*s - 798*D1*Dd*f*g2 + 4144*D1*Dd*f*gd2*r**2 + 8288*D1*Dd*f*gd2*r*s - 7252*D1*Dd*f*gd2*r + 4144*D1*Dd*f*gd2*s**2 - 7252*D1*Dd*f*gd2*s + 3108*D1*Dd*f*gd2 + 4144*D1*Dd*fd*g2*r**2 + 8288*D1*Dd*fd*g2*r*s - 1428*D1*Dd*fd*g2*r + 4144*D1*Dd*fd*g2*s**2 - 1428*D1*Dd*fd*g2*s - 1260*D1*Dd*fd*g2 - 1056*D1*Ddd*K*f**2*r**2 - 2016*D1*Ddd*K*f**2*r*s + 1536*D1*Ddd*K*f**2*r - 960*D1*Ddd*K*f**2*s**2 + 1464*D1*Ddd*K*f**2*s - 744*D1*Ddd*K*f**2 - 420*D1*Ddd*b2*f*r**2 - 840*D1*Ddd*b2*f*r*s + 630*D1*Ddd*b2*f*r - 420*D1*Ddd*b2*f*s**2 + 630*D1*Ddd*b2*f*s - 315*D1*Ddd*b2*f + 120*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 120*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 120*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 60*D1*Ddd*f**2 + 2072*D1*Ddd*f*g2*r**2 + 4144*D1*Ddd*f*g2*r*s - 3108*D1*Ddd*f*g2*r + 2072*D1*Ddd*f*g2*s**2 - 3108*D1*Ddd*f*g2*s + 1554*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(-K*f*(38*r**2 + r*(76*s - 86) + 38*s**2 - 86*s + 43) + 6*f**2*(2*s - 1)*(r + s - 1) - 6*f*fd*(2*s - 1)*(4*r + 4*s - 3) + 2*f*(2*s - 1)*(r + s - 1) + 2*fd*(K*(74*r**2 + r*(148*s - 59) + 74*s**2 - 59*s - 15) - 12*r*s + 3*r + 3*s*(3 - 4*s)) + 50*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 100*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(3*f**2*(2*s - 1)*(8*r + 8*s - 7) + f*(-K*(296*r**2 + 592*r*s - 578*r + 296*s**2 - 578*s + 267) + (6*s - 3)*(8*r + 8*s - 7)) - 50*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 35*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 3168*Dd**2*K*f**2*r**2 - 6048*Dd**2*K*f**2*r*s + 4608*Dd**2*K*f**2*r - 2880*Dd**2*K*f**2*s**2 + 4392*Dd**2*K*f**2*s - 1488*Dd**2*K*f**2 - 1260*Dd**2*b2*f*r**2 - 2520*Dd**2*b2*f*r*s + 1890*Dd**2*b2*f*r - 1260*Dd**2*b2*f*s**2 + 1890*Dd**2*b2*f*s - 630*Dd**2*b2*f + 360*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 360*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 120*Dd**2*f**3 + 360*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 120*Dd**2*f**2 + 6216*Dd**2*f*g2*r**2 + 12432*Dd**2*f*g2*r*s - 9324*Dd**2*f*g2*r + 6216*Dd**2*f*g2*s**2 - 9324*Dd**2*f*g2*s + 3108*Dd**2*f*g2) + 5*b2*(-21*D1**2*bdd1*f*(r + s - 1)**2 - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 7*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**5) + D1**2*Pk1*Pkd3*k1**2*k2**4*st**6*(2*C - 1)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(14*d**2*k3**7) + 3*D1**2*Pk1*Pkd3*k1**2*k2**4*st**4*(-198*C*D1**2*f**2*fd*r**2 - 396*C*D1**2*f**2*fd*r*s + 264*C*D1**2*f**2*fd*r - 198*C*D1**2*f**2*fd*s**2 + 264*C*D1**2*f**2*fd*s - 132*C*D1**2*f**2*fd - 264*C*D1*Dd*f**3*r**2 - 528*C*D1*Dd*f**3*r*s + 396*C*D1*Dd*f**3*r - 264*C*D1*Dd*f**3*s**2 + 396*C*D1*Dd*f**3*s - 198*C*D1*Dd*f**3 - 33*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*K*bdd1*f**2*r*s + 66*D1**2*K*bdd1*f**2*r - 33*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s - 33*D1**2*K*bdd1*f**2 + 66*D1**2*bd1**2*f*(-7*K + 10*f)*(r + s - 1)**2 + 462*D1**2*bdd1*f*g2*r**2 + 924*D1**2*bdd1*f*g2*r*s - 924*D1**2*bdd1*f*g2*r + 462*D1**2*bdd1*f*g2*s**2 - 924*D1**2*bdd1*f*g2*s + 462*D1**2*bdd1*f*g2 + 268*D1**2*f**3*fd*r**2 + 536*D1**2*f**3*fd*r*s - 402*D1**2*f**3*fd*r + 268*D1**2*f**3*fd*s**2 - 402*D1**2*f**3*fd*s + 201*D1**2*f**3*fd - 200*D1**2*f**3*fdd*r**2 - 400*D1**2*f**3*fdd*r*s + 300*D1**2*f**3*fdd*r - 200*D1**2*f**3*fdd*s**2 + 300*D1**2*f**3*fdd*s - 150*D1**2*f**3*fdd - 600*D1**2*f**2*fd**2*r**2 - 1200*D1**2*f**2*fd**2*r*s + 900*D1**2*f**2*fd**2*r - 600*D1**2*f**2*fd**2*s**2 + 900*D1**2*f**2*fd**2*s - 300*D1**2*f**2*fd**2 + 99*D1**2*f**2*fd*r**2 + 198*D1**2*f**2*fd*r*s - 132*D1**2*f**2*fd*r + 99*D1**2*f**2*fd*s**2 - 132*D1**2*f**2*fd*s + 66*D1**2*f**2*fd - 132*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*r - 132*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s - 132*D1**2*f**2*gd2 + 66*D1**2*f**2*gdd2*r**2 + 132*D1**2*f**2*gdd2*r*s - 132*D1**2*f**2*gdd2*r + 66*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 66*D1**2*f**2*gdd2 - 264*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 + 528*D1**2*f*fd*gd2*r*s - 396*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 396*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r**2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 268*D1*Dd*f**4*r**2 + 536*D1*Dd*f**4*r*s - 402*D1*Dd*f**4*r + 268*D1*Dd*f**4*s**2 - 402*D1*Dd*f**4*s + 201*D1*Dd*f**4 - 1600*D1*Dd*f**3*fd*r**2 - 3200*D1*Dd*f**3*fd*r*s + 2400*D1*Dd*f**3*fd*r - 1600*D1*Dd*f**3*fd*s**2 + 2400*D1*Dd*f**3*fd*s - 900*D1*Dd*f**3*fd + 132*D1*Dd*f**3*r**2 + 264*D1*Dd*f**3*r*s - 198*D1*Dd*f**3*r + 132*D1*Dd*f**3*s**2 - 198*D1*Dd*f**3*s + 99*D1*Dd*f**3 - 528*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s + 792*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 792*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 + 1056*D1*Dd*f**2*gd2*r*s - 924*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 924*D1*Dd*f**2*gd2*s + 396*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r**2 + 2112*D1*Dd*f*fd*g2*r*s - 1320*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1320*D1*Dd*f*fd*g2*s + 396*D1*Dd*f*fd*g2 - 200*D1*Ddd*f**4*r**2 - 400*D1*Ddd*f**4*r*s + 300*D1*Ddd*f**4*r - 200*D1*Ddd*f**4*s**2 + 300*D1*Ddd*f**4*s - 150*D1*Ddd*f**4 + 264*D1*Ddd*f**2*g2*r**2 + 528*D1*Ddd*f**2*g2*r*s - 396*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 396*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(2*f**3*(r + s - 1) + f**2*(r + s - 1)*(14*C - 2*K + 26*b1 - 7) - 2*f*(14*K*b1*(r + s - 1) - 2*K*fd*r - 2*K*fd*s + K*fd + 20*b1*fd*(2*r + 2*s - 1) - 14*g2*(r + s - 1) + 14*gd2*r + 14*gd2*s - 14*gd2) - 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(-14*K*b1 - K*f + 20*b1*f + 14*g2))*(r + s - 1) - 600*Dd**2*f**4*r**2 - 1200*Dd**2*f**4*r*s + 900*Dd**2*f**4*r - 600*Dd**2*f**4*s**2 + 900*Dd**2*f**4*s - 300*Dd**2*f**4 + 792*Dd**2*f**2*g2*r**2 + 1584*Dd**2*f**2*g2*r*s - 1188*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 1188*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(14*K*fd*(r + s) - 7*K*fdd*(r + s) + 20*fd**2*(r + s - 1))) + D1*(Dd*(14*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 13*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(7*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - Ddd*f*(-7*K + 10*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-7*K + 10*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(2*D1**2*bdd1*f*(-7*K + 10*f)*(r + s - 1)**2 - D1**2*(2*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(2*K*fdd*r**2 + 4*K*fdd*r*s - 2*K*fdd*r + 2*K*fdd*s**2 - 2*K*fdd*s + K*fdd + fd*(14*C - 2*K - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*gd2*(r + s - 1)**2 - 14*gdd2*r**2 - 28*gdd2*r*s + 28*gdd2*r - 14*gdd2*s**2 + 28*gdd2*s - 14*gdd2) + (2*r + 2*s)*(K*fd**2*(r + s - 1) + 14*fd*g2*(r + s) - 14*fd*gd2*(r + s - 1) - 7*fdd*g2*(r + s))) + D1*(Dd*(-2*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(14*C - 2*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 28*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*f*(K*fd*(-2*r - 2*s + 1) + 14*gd2*(r + s - 1))*(4*r + 4*s - 3) + 28*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + Ddd*f*(-K*f + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(K*f - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(770*d**2*k3**7) + D1**2*Pk1*Pkd3*k1**2*k2**2*st**6*(4*C - 2)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(63*d**2*k3**5) + D1**2*Pk1*Pkd3*k1**2*k2**2*st**4*(35*b1**2*(2*C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-224*C*D1**2*f*fd*r**2 - 576*C*D1**2*f*fd*r*s + 248*C*D1**2*f*fd*r - 352*C*D1**2*f*fd*s**2 + 312*C*D1**2*f*fd*s - 156*C*D1**2*f*fd + 336*C*D1**2*f*fdd*r**2 + 736*C*D1**2*f*fdd*r*s - 348*C*D1**2*f*fdd*r + 400*C*D1**2*f*fdd*s**2 - 380*C*D1**2*f*fdd*s + 190*C*D1**2*f*fdd + 336*C*D1**2*fd**2*r**2 + 736*C*D1**2*fd**2*r*s - 348*C*D1**2*fd**2*r + 400*C*D1**2*fd**2*s**2 - 380*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 448*C*D1*Dd*f**2*r**2 - 1152*C*D1*Dd*f**2*r*s + 800*C*D1*Dd*f**2*r - 704*C*D1*Dd*f**2*s**2 + 992*C*D1*Dd*f**2*s - 464*C*D1*Dd*f**2 + 2688*C*D1*Dd*f*fd*r**2 + 5888*C*D1*Dd*f*fd*r*s - 3536*C*D1*Dd*f*fd*r + 3200*C*D1*Dd*f*fd*s**2 - 3856*C*D1*Dd*f*fd*s + 1108*C*D1*Dd*f*fd + 672*C*D1*Ddd*f**2*r**2 + 1472*C*D1*Ddd*f**2*r*s - 1072*C*D1*Ddd*f**2*r + 800*C*D1*Ddd*f**2*s**2 - 1168*C*D1*Ddd*f**2*s + 568*C*D1*Ddd*f**2 + 2016*C*Dd**2*f**2*r**2 + 4416*C*Dd**2*f**2*r*s - 3216*C*Dd**2*f**2*r + 2400*C*Dd**2*f**2*s**2 - 3504*C*Dd**2*f**2*s + 1136*C*Dd**2*f**2 - 35*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 136*D1**2*f*fd*r**2 + 308*D1**2*f*fd*r*s - 134*D1**2*f*fd*r + 172*D1**2*f*fd*s**2 - 152*D1**2*f*fd*s + 76*D1**2*f*fd - 180*D1**2*f*fdd*r**2 - 392*D1**2*f*fdd*r*s + 186*D1**2*f*fdd*r - 212*D1**2*f*fdd*s**2 + 202*D1**2*f*fdd*s - 101*D1**2*f*fdd - 180*D1**2*fd**2*r**2 - 392*D1**2*fd**2*r*s + 186*D1**2*fd**2*r - 212*D1**2*fd**2*s**2 + 202*D1**2*fd**2*s + 10*D1**2*fd**2 + 272*D1*Dd*f**2*r**2 + 616*D1*Dd*f**2*r*s - 444*D1*Dd*f**2*r + 344*D1*Dd*f**2*s**2 - 498*D1*Dd*f**2*s + 240*D1*Dd*f**2 - 1440*D1*Dd*f*fd*r**2 - 3136*D1*Dd*f*fd*r*s + 1888*D1*Dd*f*fd*r - 1696*D1*Dd*f*fd*s**2 + 2048*D1*Dd*f*fd*s - 590*D1*Dd*f*fd - 360*D1*Ddd*f**2*r**2 - 784*D1*Ddd*f**2*r*s + 572*D1*Ddd*f**2*r - 424*D1*Ddd*f**2*s**2 + 620*D1*Ddd*f**2*s - 302*D1*Ddd*f**2 + 70*D1*bd1*(2*C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 1080*Dd**2*f**2*r**2 - 2352*Dd**2*f**2*r*s + 1716*Dd**2*f**2*r - 1272*Dd**2*f**2*s**2 + 1860*Dd**2*f**2*s - 604*Dd**2*f**2) + f*(-228*C*D1**2*f*fd*r**2 - 408*C*D1**2*f*fd*r*s + 288*C*D1**2*f*fd*r - 180*C*D1**2*f*fd*s**2 + 256*C*D1**2*f*fd*s - 136*C*D1**2*f*fd + 186*C*D1**2*f*fdd*r**2 + 324*C*D1**2*f*fdd*r*s - 232*C*D1**2*f*fdd*r + 138*C*D1**2*f*fdd*s**2 - 200*C*D1**2*f*fdd*s + 108*C*D1**2*f*fdd + 372*C*D1**2*fd**2*r**2 + 648*C*D1**2*fd**2*r*s - 464*C*D1**2*fd**2*r + 276*C*D1**2*fd**2*s**2 - 400*C*D1**2*fd**2*s + 108*C*D1**2*fd**2 - 304*C*D1*Dd*f**2*r**2 - 544*C*D1*Dd*f**2*r*s + 424*C*D1*Dd*f**2*r - 240*C*D1*Dd*f**2*s**2 + 376*C*D1*Dd*f**2*s - 196*C*D1*Dd*f**2 + 1488*C*D1*Dd*f*fd*r**2 + 2592*C*D1*Dd*f*fd*r*s - 1948*C*D1*Dd*f*fd*r + 1104*C*D1*Dd*f*fd*s**2 - 1676*C*D1*Dd*f*fd*s + 632*C*D1*Dd*f*fd + 248*C*D1*Ddd*f**2*r**2 + 432*C*D1*Ddd*f**2*r*s - 340*C*D1*Ddd*f**2*r + 184*C*D1*Ddd*f**2*s**2 - 292*C*D1*Ddd*f**2*s + 154*C*D1*Ddd*f**2 + 744*C*Dd**2*f**2*r**2 + 1296*C*Dd**2*f**2*r*s - 1020*C*Dd**2*f**2*r + 552*C*Dd**2*f**2*s**2 - 876*C*Dd**2*f**2*s + 308*C*Dd**2*f**2 - 70*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1**2*bdd1*f*(2*C*(84*r**2 + 2*r*(92*s - 89) + 100*s**2 - 194*s + 89) - 90*r**2 - 196*r*s + 190*r - 106*s**2 + 206*s - 95) + 126*D1**2*f*fd*r**2 + 222*D1**2*f*fd*r*s - 158*D1**2*f*fd*r + 96*D1**2*f*fd*s**2 - 138*D1**2*f*fd*s + 74*D1**2*f*fd - 99*D1**2*f*fdd*r**2 - 174*D1**2*f*fdd*r*s + 124*D1**2*f*fdd*r - 75*D1**2*f*fdd*s**2 + 108*D1**2*f*fdd*s - 58*D1**2*f*fdd - 198*D1**2*fd**2*r**2 - 348*D1**2*fd**2*r*s + 248*D1**2*fd**2*r - 150*D1**2*fd**2*s**2 + 216*D1**2*fd**2*s - 58*D1**2*fd**2 + 168*D1*Dd*f**2*r**2 + 296*D1*Dd*f**2*r*s - 232*D1*Dd*f**2*r + 128*D1*Dd*f**2*s**2 - 202*D1*Dd*f**2*s + 106*D1*Dd*f**2 - 792*D1*Dd*f*fd*r**2 - 1392*D1*Dd*f*fd*r*s + 1042*D1*Dd*f*fd*r - 600*D1*Dd*f*fd*s**2 + 906*D1*Dd*f*fd*s - 340*D1*Dd*f*fd - 132*D1*Ddd*f**2*r**2 - 232*D1*Ddd*f**2*r*s + 182*D1*Ddd*f**2*r - 100*D1*Ddd*f**2*s**2 + 158*D1*Ddd*f**2*s - 83*D1*Ddd*f**2 - 2*D1*bd1*(D1*(f*(2*C*(28*r**2 + 72*r*s - 66*r + 44*s**2 - 82*s + 33) - 34*r**2 - 77*r*s + 78*r - 43*s**2 + 87*s - 39) + fd*(-2*C*(168*r**2 + 368*r*s - 265*r + 200*s**2 - 289*s + 97) + 180*r**2 + 392*r*s - 283*r + 212*s**2 - 307*s + 103)) + Dd*f*(-2*C*(336*r**2 + 736*r*s - 624*r + 400*s**2 - 680*s + 283) + 360*r**2 + 784*r*s - 666*r + 424*s**2 - 722*s + 301)) - 396*Dd**2*f**2*r**2 - 696*Dd**2*f**2*r*s + 546*Dd**2*f**2*r - 300*Dd**2*f**2*s**2 + 474*Dd**2*f**2*s - 166*Dd**2*f**2))/(70*d**2*k3**5) - D1**2*Pk1*Pkd3*k1**2*k2**2*st**2*(-1848*C*D1**2*bd1*f**2*r**2 - 1848*C*D1**2*bd1*f**2*r*s + 8316*C*D1**2*bd1*f**2*r + 6468*C*D1**2*bd1*f**2*s - 4158*C*D1**2*bd1*f**2 - 5346*C*D1**2*f**2*fd*r**2 - 8316*C*D1**2*f**2*fd*r*s + 6336*C*D1**2*f**2*fd*r - 2970*C*D1**2*f**2*fd*s**2 + 4752*C*D1**2*f**2*fd*s - 2772*C*D1**2*f**2*fd - 7128*C*D1*Dd*f**3*r**2 - 11088*C*D1*Dd*f**3*r*s + 9108*C*D1*Dd*f**3*r - 3960*C*D1*Dd*f**3*s**2 + 6732*C*D1*Dd*f**3*s - 3762*C*D1*Dd*f**3 - 34188*D1**2*K*bd1**2*f*r**2 - 62832*D1**2*K*bd1**2*f*r*s + 67914*D1**2*K*bd1**2*f*r - 28644*D1**2*K*bd1**2*f*s**2 + 62370*D1**2*K*bd1**2*f*s - 33726*D1**2*K*bd1**2*f + 10626*D1**2*K*bd1*f**2*r**2 + 17556*D1**2*K*bd1*f**2*r*s - 17556*D1**2*K*bd1*f**2*r + 6930*D1**2*K*bd1*f**2*s**2 - 13860*D1**2*K*bd1*f**2*s + 6930*D1**2*K*bd1*f**2 - 32340*D1**2*K*bd1*f*fd*r**2 - 53592*D1**2*K*bd1*f*fd*r*s + 42966*D1**2*K*bd1*f*fd*r - 21252*D1**2*K*bd1*f*fd*s**2 + 34650*D1**2*K*bd1*f*fd*s - 13398*D1**2*K*bd1*f*fd - 8085*D1**2*K*bdd1*f**2*r**2 - 13398*D1**2*K*bdd1*f**2*r*s + 13398*D1**2*K*bdd1*f**2*r - 5313*D1**2*K*bdd1*f**2*s**2 + 10626*D1**2*K*bdd1*f**2*s - 5313*D1**2*K*bdd1*f**2 + 11682*D1**2*bd1**2*f**2*r**2 + 28908*D1**2*bd1**2*f**2*r*s - 28116*D1**2*bd1**2*f**2*r + 17226*D1**2*bd1**2*f**2*s**2 - 33660*D1**2*bd1**2*f**2*s + 16434*D1**2*bd1**2*f**2 + 2772*D1**2*bd1**2*f*r**2 + 5544*D1**2*bd1**2*f*r*s - 5544*D1**2*bd1**2*f*r + 2772*D1**2*bd1**2*f*s**2 - 5544*D1**2*bd1**2*f*s + 2772*D1**2*bd1**2*f - 23100*D1**2*bd1**2*g2*r**2 - 46200*D1**2*bd1**2*g2*r*s + 23100*D1**2*bd1**2*g2*r - 23100*D1**2*bd1**2*g2*s**2 + 23100*D1**2*bd1**2*g2*s - 13860*D1**2*bd1*bd2*f*r**2 - 27720*D1**2*bd1*bd2*f*r*s + 27720*D1**2*bd1*bd2*f*r - 13860*D1**2*bd1*bd2*f*s**2 + 27720*D1**2*bd1*bd2*f*s - 13860*D1**2*bd1*bd2*f - 3113*D1**2*bd1*f**3*r**2 - 4972*D1**2*bd1*f**3*r*s + 6292*D1**2*bd1*f**3*r - 1859*D1**2*bd1*f**3*s**2 + 5038*D1**2*bd1*f**3*s - 3234*D1**2*bd1*f**3 + 20922*D1**2*bd1*f**2*fd*r**2 + 35112*D1**2*bd1*f**2*fd*r*s - 32494*D1**2*bd1*f**2*fd*r + 14190*D1**2*bd1*f**2*fd*s**2 - 26884*D1**2*bd1*f**2*fd*s + 11088*D1**2*bd1*f**2*fd + 198*D1**2*bd1*f**2*r**2 - 528*D1**2*bd1*f**2*r*s - 3168*D1**2*bd1*f**2*r - 726*D1**2*bd1*f**2*s**2 - 2244*D1**2*bd1*f**2*s + 1815*D1**2*bd1*f**2 + 2376*D1**2*bd1*f*fd*r**2 + 4752*D1**2*bd1*f*fd*r*s - 3564*D1**2*bd1*f*fd*r + 2376*D1**2*bd1*f*fd*s**2 - 3564*D1**2*bd1*f*fd*s + 1188*D1**2*bd1*f*fd - 31416*D1**2*bd1*f*g2*r**2 - 51744*D1**2*bd1*f*g2*r*s + 72072*D1**2*bd1*f*g2*r - 20328*D1**2*bd1*f*g2*s**2 + 60984*D1**2*bd1*f*g2*s - 36036*D1**2*bd1*f*g2 + 68376*D1**2*bd1*f*gd2*r**2 + 125664*D1**2*bd1*f*gd2*r*s - 135828*D1**2*bd1*f*gd2*r + 57288*D1**2*bd1*f*gd2*s**2 - 124740*D1**2*bd1*f*gd2*s + 67452*D1**2*bd1*f*gd2 + 68376*D1**2*bd1*fd*g2*r**2 + 125664*D1**2*bd1*fd*g2*r*s - 68376*D1**2*bd1*fd*g2*r + 57288*D1**2*bd1*fd*g2*s**2 - 62832*D1**2*bd1*fd*g2*s + 4785*D1**2*bd2*f**2*r**2 + 9570*D1**2*bd2*f**2*r*s - 9570*D1**2*bd2*f**2*r + 4785*D1**2*bd2*f**2*s**2 - 9570*D1**2*bd2*f**2*s + 4785*D1**2*bd2*f**2 - 11880*D1**2*bd2*f*fd*r**2 - 23760*D1**2*bd2*f*fd*r*s + 17820*D1**2*bd2*f*fd*r - 11880*D1**2*bd2*f*fd*s**2 + 17820*D1**2*bd2*f*fd*s - 5940*D1**2*bd2*f*fd + 3487*D1**2*bdd1*f**3*r**2 + 5852*D1**2*bdd1*f**3*r*s - 6908*D1**2*bdd1*f**3*r + 2365*D1**2*bdd1*f**3*s**2 - 5786*D1**2*bdd1*f**3*s + 3696*D1**2*bdd1*f**3 + 594*D1**2*bdd1*f**2*r**2 + 1188*D1**2*bdd1*f**2*r*s - 1188*D1**2*bdd1*f**2*r + 594*D1**2*bdd1*f**2*s**2 - 1188*D1**2*bdd1*f**2*s + 594*D1**2*bdd1*f**2 + 34188*D1**2*bdd1*f*g2*r**2 + 62832*D1**2*bdd1*f*g2*r*s - 72996*D1**2*bdd1*f*g2*r + 28644*D1**2*bdd1*f*g2*s**2 - 67452*D1**2*bdd1*f*g2*s + 36498*D1**2*bdd1*f*g2 - 2970*D1**2*bdd2*f**2*r**2 - 5940*D1**2*bdd2*f**2*r*s + 5940*D1**2*bdd2*f**2*r - 2970*D1**2*bdd2*f**2*s**2 + 5940*D1**2*bdd2*f**2*s - 2970*D1**2*bdd2*f**2 + 1940*D1**2*f**3*fd*r**2 + 6560*D1**2*f**3*fd*r*s - 4250*D1**2*f**3*fd*r + 4620*D1**2*f**3*fd*s**2 - 6260*D1**2*f**3*fd*s + 2795*D1**2*f**3*fd - 1740*D1**2*f**3*fdd*r**2 - 6800*D1**2*f**3*fdd*r*s + 4270*D1**2*f**3*fdd*r - 5060*D1**2*f**3*fdd*s**2 + 6760*D1**2*f**3*fdd*s - 2965*D1**2*f**3*fdd - 5220*D1**2*f**2*fd**2*r**2 - 20400*D1**2*f**2*fd**2*r*s + 12810*D1**2*f**2*fd**2*r - 15180*D1**2*f**2*fd**2*s**2 + 20280*D1**2*f**2*fd**2*s - 5930*D1**2*f**2*fd**2 + 3267*D1**2*f**2*fd*r**2 + 4752*D1**2*f**2*fd*r*s - 3762*D1**2*f**2*fd*r + 1485*D1**2*f**2*fd*s**2 - 2574*D1**2*f**2*fd*s + 1584*D1**2*f**2*fd - 21252*D1**2*f**2*gd2*r**2 - 35112*D1**2*f**2*gd2*r*s + 35112*D1**2*f**2*gd2*r - 13860*D1**2*f**2*gd2*s**2 + 27720*D1**2*f**2*gd2*s - 13860*D1**2*f**2*gd2 + 16170*D1**2*f**2*gdd2*r**2 + 26796*D1**2*f**2*gdd2*r*s - 26796*D1**2*f**2*gdd2*r + 10626*D1**2*f**2*gdd2*s**2 - 21252*D1**2*f**2*gdd2*s + 10626*D1**2*f**2*gdd2 - 42504*D1**2*f*fd*g2*r**2 - 70224*D1**2*f*fd*g2*r*s + 42504*D1**2*f*fd*g2*r - 27720*D1**2*f*fd*g2*s**2 + 35112*D1**2*f*fd*g2*s - 21252*D1**2*f*fd*g2 + 64680*D1**2*f*fd*gd2*r**2 + 107184*D1**2*f*fd*gd2*r*s - 85932*D1**2*f*fd*gd2*r + 42504*D1**2*f*fd*gd2*s**2 - 69300*D1**2*f*fd*gd2*s + 26796*D1**2*f*fd*gd2 + 32340*D1**2*f*fdd*g2*r**2 + 53592*D1**2*f*fdd*g2*r*s - 32340*D1**2*f*fdd*g2*r + 21252*D1**2*f*fdd*g2*s**2 - 26796*D1**2*f*fdd*g2*s + 16170*D1**2*f*fdd*g2 + 32340*D1**2*fd**2*g2*r**2 + 53592*D1**2*fd**2*g2*r*s - 32340*D1**2*fd**2*g2*r + 21252*D1**2*fd**2*g2*s**2 - 26796*D1**2*fd**2*g2*s - 64680*D1*Dd*K*bd1*f**2*r**2 - 107184*D1*Dd*K*bd1*f**2*r*s + 96558*D1*Dd*K*bd1*f**2*r - 42504*D1*Dd*K*bd1*f**2*s**2 + 77154*D1*Dd*K*bd1*f**2*s - 34650*D1*Dd*K*bd1*f**2 + 27896*D1*Dd*bd1*f**3*r**2 + 46816*D1*Dd*bd1*f**3*r*s - 46310*D1*Dd*bd1*f**3*r + 18920*D1*Dd*bd1*f**3*s**2 - 38456*D1*Dd*bd1*f**3*s + 18480*D1*Dd*bd1*f**3 + 4752*D1*Dd*bd1*f**2*r**2 + 9504*D1*Dd*bd1*f**2*r*s - 8316*D1*Dd*bd1*f**2*r + 4752*D1*Dd*bd1*f**2*s**2 - 8316*D1*Dd*bd1*f**2*s + 3564*D1*Dd*bd1*f**2 + 273504*D1*Dd*bd1*f*g2*r**2 + 502656*D1*Dd*bd1*f*g2*r*s - 486024*D1*Dd*bd1*f*g2*r + 229152*D1*Dd*bd1*f*g2*s**2 - 447216*D1*Dd*bd1*f*g2*s + 207900*D1*Dd*bd1*f*g2 - 23760*D1*Dd*bd2*f**2*r**2 - 47520*D1*Dd*bd2*f**2*r*s + 41580*D1*Dd*bd2*f**2*r - 23760*D1*Dd*bd2*f**2*s**2 + 41580*D1*Dd*bd2*f**2*s - 17820*D1*Dd*bd2*f**2 + 1940*D1*Dd*f**4*r**2 + 6560*D1*Dd*f**4*r*s - 4250*D1*Dd*f**4*r + 4620*D1*Dd*f**4*s**2 - 6260*D1*Dd*f**4*s + 2795*D1*Dd*f**4 - 13920*D1*Dd*f**3*fd*r**2 - 54400*D1*Dd*f**3*fd*r*s + 34160*D1*Dd*f**3*fd*r - 40480*D1*Dd*f**3*fd*s**2 + 54080*D1*Dd*f**3*fd*s - 17790*D1*Dd*f**3*fd + 4356*D1*Dd*f**3*r**2 + 6336*D1*Dd*f**3*r*s - 5346*D1*Dd*f**3*r + 1980*D1*Dd*f**3*s**2 - 3564*D1*Dd*f**3*s + 2079*D1*Dd*f**3 - 85008*D1*Dd*f**2*g2*r**2 - 140448*D1*Dd*f**2*g2*r*s + 112728*D1*Dd*f**2*g2*r - 55440*D1*Dd*f**2*g2*s**2 + 90552*D1*Dd*f**2*g2*s - 48972*D1*Dd*f**2*g2 + 129360*D1*Dd*f**2*gd2*r**2 + 214368*D1*Dd*f**2*gd2*r*s - 193116*D1*Dd*f**2*gd2*r + 85008*D1*Dd*f**2*gd2*s**2 - 154308*D1*Dd*f**2*gd2*s + 69300*D1*Dd*f**2*gd2 + 258720*D1*Dd*f*fd*g2*r**2 + 428736*D1*Dd*f*fd*g2*r*s - 301224*D1*Dd*f*fd*g2*r + 170016*D1*Dd*f*fd*g2*s**2 - 245784*D1*Dd*f*fd*g2*s + 85932*D1*Dd*f*fd*g2 - 1740*D1*Ddd*f**4*r**2 - 6800*D1*Ddd*f**4*r*s + 4270*D1*Ddd*f**4*r - 5060*D1*Ddd*f**4*s**2 + 6760*D1*Ddd*f**4*s - 2965*D1*Ddd*f**4 + 64680*D1*Ddd*f**2*g2*r**2 + 107184*D1*Ddd*f**2*g2*r*s - 85932*D1*Ddd*f**2*g2*r + 42504*D1*Ddd*f**2*g2*s**2 - 69300*D1*Ddd*f**2*g2*s + 37422*D1*Ddd*f**2*g2 - 5220*Dd**2*f**4*r**2 - 20400*Dd**2*f**4*r*s + 12810*Dd**2*f**4*r - 15180*Dd**2*f**4*s**2 + 20280*Dd**2*f**4*s - 5930*Dd**2*f**4 + 194040*Dd**2*f**2*g2*r**2 + 321552*Dd**2*f**2*g2*r*s - 257796*Dd**2*f**2*g2*r + 127512*Dd**2*f**2*g2*s**2 - 207900*Dd**2*f**2*g2*s + 74844*Dd**2*f**2*g2 + 1155*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(-10*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*(-5*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 3*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(350*C*D1**2*fd*r**2 + 700*C*D1**2*fd*r*s - 700*C*D1**2*fd*r + 350*C*D1**2*fd*s**2 - 700*C*D1**2*fd*s + 350*C*D1**2*fd + 1400*C*D1*Dd*f*r**2 + 2800*C*D1*Dd*f*r*s - 2100*C*D1*Dd*f*r + 1400*C*D1*Dd*f*s**2 - 2100*C*D1*Dd*f*s + 1050*C*D1*Dd*f + 476*D1**2*K*fd*r**2 + 784*D1**2*K*fd*r*s + 140*D1**2*K*fd*r + 308*D1**2*K*fd*s**2 + 140*D1**2*K*fd*s - 70*D1**2*K*fd - 518*D1**2*K*fdd*r**2 - 952*D1**2*K*fdd*r*s - 70*D1**2*K*fdd*r - 434*D1**2*K*fdd*s**2 - 70*D1**2*K*fdd*s + 35*D1**2*K*fdd - 35*D1**2*bdd1*(-5*K + 3*f)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 190*D1**2*f*fd*r**2 - 548*D1**2*f*fd*r*s + 154*D1**2*f*fd*r - 358*D1**2*f*fd*s**2 + 238*D1**2*f*fd*s - 119*D1**2*f*fd + 354*D1**2*f*fdd*r**2 + 876*D1**2*f*fdd*r*s - 378*D1**2*f*fdd*r + 522*D1**2*f*fdd*s**2 - 462*D1**2*f*fdd*s + 231*D1**2*f*fdd + 354*D1**2*fd**2*r**2 + 876*D1**2*fd**2*r*s - 378*D1**2*fd**2*r + 522*D1**2*fd**2*s**2 - 462*D1**2*fd**2*s - 60*D1**2*fd**2 - 259*D1**2*fd*r**2 - 448*D1**2*fd*r*s + 350*D1**2*fd*r - 189*D1**2*fd*s**2 + 350*D1**2*fd*s - 175*D1**2*fd + 42*D1**2*fdd*r**2 + 84*D1**2*fdd*r*s + 42*D1**2*fdd*s**2 + 700*D1**2*gd2*r**2 + 1400*D1**2*gd2*r*s - 1400*D1**2*gd2*r + 700*D1**2*gd2*s**2 - 1400*D1**2*gd2*s + 700*D1**2*gd2 - 350*D1**2*gdd2*r**2 - 700*D1**2*gdd2*r*s + 700*D1**2*gdd2*r - 350*D1**2*gdd2*s**2 + 700*D1**2*gdd2*s - 350*D1**2*gdd2 + 1904*D1*Dd*K*f*r**2 + 3136*D1*Dd*K*f*r*s - 2520*D1*Dd*K*f*r + 1232*D1*Dd*K*f*s**2 - 2016*D1*Dd*K*f*s + 1092*D1*Dd*K*f - 4144*D1*Dd*K*fd*r**2 - 7616*D1*Dd*K*fd*r*s + 2660*D1*Dd*K*fd*r - 3472*D1*Dd*K*fd*s**2 + 2408*D1*Dd*K*fd*s + 210*D1*Dd*K*fd - 380*D1*Dd*f**2*r**2 - 1096*D1*Dd*f**2*r*s + 738*D1*Dd*f**2*r - 716*D1*Dd*f**2*s**2 + 990*D1*Dd*f**2*s - 453*D1*Dd*f**2 + 2832*D1*Dd*f*fd*r**2 + 7008*D1*Dd*f*fd*r*s - 3972*D1*Dd*f*fd*r + 4176*D1*Dd*f*fd*s**2 - 4812*D1*Dd*f*fd*s + 1302*D1*Dd*f*fd - 1036*D1*Dd*f*r**2 - 1792*D1*Dd*f*r*s + 1414*D1*Dd*f*r - 756*D1*Dd*f*s**2 + 1204*D1*Dd*f*s - 637*D1*Dd*f + 336*D1*Dd*fd*r**2 + 672*D1*Dd*fd*r*s - 252*D1*Dd*fd*r + 336*D1*Dd*fd*s**2 - 252*D1*Dd*fd*s + 2800*D1*Dd*g2*r**2 + 5600*D1*Dd*g2*r*s - 4200*D1*Dd*g2*r + 2800*D1*Dd*g2*s**2 - 4200*D1*Dd*g2*s + 2100*D1*Dd*g2 - 2800*D1*Dd*gd2*r**2 - 5600*D1*Dd*gd2*r*s + 4900*D1*Dd*gd2*r - 2800*D1*Dd*gd2*s**2 + 4900*D1*Dd*gd2*s - 2100*D1*Dd*gd2 - 2072*D1*Ddd*K*f*r**2 - 3808*D1*Ddd*K*f*r*s + 2940*D1*Ddd*K*f*r - 1736*D1*Ddd*K*f*s**2 + 2688*D1*Ddd*K*f*s - 1386*D1*Ddd*K*f + 708*D1*Ddd*f**2*r**2 + 1752*D1*Ddd*f**2*r*s - 1230*D1*Ddd*f**2*r + 1044*D1*Ddd*f**2*s**2 - 1482*D1*Ddd*f**2*s + 699*D1*Ddd*f**2 + 168*D1*Ddd*f*r**2 + 336*D1*Ddd*f*r*s - 252*D1*Ddd*f*r + 168*D1*Ddd*f*s**2 - 252*D1*Ddd*f*s + 126*D1*Ddd*f - 1400*D1*Ddd*g2*r**2 - 2800*D1*Ddd*g2*r*s + 2100*D1*Ddd*g2*r - 1400*D1*Ddd*g2*s**2 + 2100*D1*Ddd*g2*s - 1050*D1*Ddd*g2 + 35*D1*bd1*(D1*(-10*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - 2*Dd*(-5*K + 3*f)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 6216*Dd**2*K*f*r**2 - 11424*Dd**2*K*f*r*s + 8820*Dd**2*K*f*r - 5208*Dd**2*K*f*s**2 + 8064*Dd**2*K*f*s - 2772*Dd**2*K*f + 2124*Dd**2*f**2*r**2 + 5256*Dd**2*f**2*r*s - 3690*Dd**2*f**2*r + 3132*Dd**2*f**2*s**2 - 4446*Dd**2*f**2*s + 1398*Dd**2*f**2 + 504*Dd**2*f*r**2 + 1008*Dd**2*f*r*s - 756*Dd**2*f*r + 504*Dd**2*f*s**2 - 756*Dd**2*f*s + 252*Dd**2*f - 4200*Dd**2*g2*r**2 - 8400*Dd**2*g2*r*s + 6300*Dd**2*g2*r - 4200*Dd**2*g2*s**2 + 6300*Dd**2*g2*s - 2100*Dd**2*g2) - 11*b1*(336*C*D1**2*f*fd*r**2 + 336*C*D1**2*f*fd*r*s + 252*C*D1**2*f*fd*r + 420*C*D1**2*f*fd*s - 210*C*D1**2*f*fd + 672*C*D1*Dd*f**2*r**2 + 672*C*D1*Dd*f**2*r*s - 672*C*D1*Dd*f**2*r - 168*C*D1*Dd*f**2*s + 168*C*D1*Dd*f**2 + 3108*D1**2*K*bdd1*f*r**2 + 5712*D1**2*K*bdd1*f*r*s - 6174*D1**2*K*bdd1*f*r + 2604*D1**2*K*bdd1*f*s**2 - 5670*D1**2*K*bdd1*f*s + 2961*D1**2*K*bdd1*f - 1932*D1**2*K*f*fd*r**2 - 3192*D1**2*K*f*fd*r*s + 1932*D1**2*K*f*fd*r - 1260*D1**2*K*f*fd*s**2 + 1596*D1**2*K*f*fd*s - 966*D1**2*K*f*fd + 1470*D1**2*K*f*fdd*r**2 + 2436*D1**2*K*f*fdd*r*s - 1470*D1**2*K*f*fdd*r + 966*D1**2*K*f*fdd*s**2 - 1218*D1**2*K*f*fdd*s + 735*D1**2*K*f*fdd + 1470*D1**2*K*fd**2*r**2 + 2436*D1**2*K*fd**2*r*s - 1470*D1**2*K*fd**2*r + 966*D1**2*K*fd**2*s**2 - 1218*D1**2*K*fd**2*s - 735*D1**2*b2*fd*r**2 - 1470*D1**2*b2*fd*r*s - 735*D1**2*b2*fd*s**2 + 630*D1**2*b2*fdd*r**2 + 1260*D1**2*b2*fdd*r*s + 630*D1**2*b2*fdd*s**2 + 210*D1**2*bd1**2*(-5*K + 3*f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 1062*D1**2*bdd1*f**2*r**2 - 2628*D1**2*bdd1*f**2*r*s + 2556*D1**2*bdd1*f**2*r - 1566*D1**2*bdd1*f**2*s**2 + 3060*D1**2*bdd1*f**2*s - 1404*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*r**2 - 504*D1**2*bdd1*f*r*s + 504*D1**2*bdd1*f*r - 252*D1**2*bdd1*f*s**2 + 504*D1**2*bdd1*f*s - 252*D1**2*bdd1*f + 2100*D1**2*bdd1*g2*r**2 + 4200*D1**2*bdd1*g2*r*s - 2100*D1**2*bdd1*g2*r + 2100*D1**2*bdd1*g2*s**2 - 2100*D1**2*bdd1*g2*s + 1050*D1**2*bdd1*g2 + 630*D1**2*bdd2*f*r**2 + 1260*D1**2*bdd2*f*r*s - 1260*D1**2*bdd2*f*r + 630*D1**2*bdd2*f*s**2 - 1260*D1**2*bdd2*f*s + 630*D1**2*bdd2*f + 849*D1**2*f**2*fd*r**2 + 1356*D1**2*f**2*fd*r*s - 898*D1**2*f**2*fd*r + 507*D1**2*f**2*fd*s**2 - 670*D1**2*f**2*fd*s + 327*D1**2*f**2*fd - 951*D1**2*f**2*fdd*r**2 - 1596*D1**2*f**2*fdd*r*s + 1070*D1**2*f**2*fdd*r - 645*D1**2*f**2*fdd*s**2 + 866*D1**2*f**2*fdd*s - 411*D1**2*f**2*fdd - 1902*D1**2*f*fd**2*r**2 - 3192*D1**2*f*fd**2*r*s + 2140*D1**2*f*fd**2*r - 1290*D1**2*f*fd**2*s**2 + 1732*D1**2*f*fd**2*s - 486*D1**2*f*fd**2 - 36*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s - 300*D1**2*f*fd*r + 132*D1**2*f*fd*s**2 - 384*D1**2*f*fd*s + 213*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 216*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*r - 108*D1**2*f*fdd*s**2 + 108*D1**2*f*fdd*s - 54*D1**2*f*fdd + 2856*D1**2*f*gd2*r**2 + 4704*D1**2*f*gd2*r*s - 4704*D1**2*f*gd2*r + 1848*D1**2*f*gd2*s**2 - 3696*D1**2*f*gd2*s + 1848*D1**2*f*gd2 - 3108*D1**2*f*gdd2*r**2 - 5712*D1**2*f*gdd2*r*s + 5712*D1**2*f*gdd2*r - 2604*D1**2*f*gdd2*s**2 + 5208*D1**2*f*gdd2*s - 2604*D1**2*f*gdd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 108*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 108*D1**2*fd**2*s + 2856*D1**2*fd*g2*r**2 + 4704*D1**2*fd*g2*r*s + 840*D1**2*fd*g2*r + 1848*D1**2*fd*g2*s**2 + 840*D1**2*fd*g2*s - 420*D1**2*fd*g2 - 6216*D1**2*fd*gd2*r**2 - 11424*D1**2*fd*gd2*r*s + 5292*D1**2*fd*gd2*r - 5208*D1**2*fd*gd2*s**2 + 4788*D1**2*fd*gd2*s + 420*D1**2*fd*gd2 - 3108*D1**2*fdd*g2*r**2 - 5712*D1**2*fdd*g2*r*s - 420*D1**2*fdd*g2*r - 2604*D1**2*fdd*g2*s**2 - 420*D1**2*fdd*g2*s + 210*D1**2*fdd*g2 - 3864*D1*Dd*K*f**2*r**2 - 6384*D1*Dd*K*f**2*r*s + 5124*D1*Dd*K*f**2*r - 2520*D1*Dd*K*f**2*s**2 + 4116*D1*Dd*K*f**2*s - 2226*D1*Dd*K*f**2 + 11760*D1*Dd*K*f*fd*r**2 + 19488*D1*Dd*K*f*fd*r*s - 13692*D1*Dd*K*f*fd*r + 7728*D1*Dd*K*f*fd*s**2 - 11172*D1*Dd*K*f*fd*s + 3906*D1*Dd*K*f*fd - 2940*D1*Dd*b2*f*r**2 - 5880*D1*Dd*b2*f*r*s + 4410*D1*Dd*b2*f*r - 2940*D1*Dd*b2*f*s**2 + 4410*D1*Dd*b2*f*s - 2205*D1*Dd*b2*f + 5040*D1*Dd*b2*fd*r**2 + 10080*D1*Dd*b2*fd*r*s - 3780*D1*Dd*b2*fd*r + 5040*D1*Dd*b2*fd*s**2 - 3780*D1*Dd*b2*fd*s + 1132*D1*Dd*f**3*r**2 + 1808*D1*Dd*f**3*r*s - 1470*D1*Dd*f**3*r + 676*D1*Dd*f**3*s**2 - 1128*D1*Dd*f**3*s + 621*D1*Dd*f**3 - 7608*D1*Dd*f**2*fd*r**2 - 12768*D1*Dd*f**2*fd*r*s + 9374*D1*Dd*f**2*fd*r - 5160*D1*Dd*f**2*fd*s**2 + 7640*D1*Dd*f**2*fd*s - 2802*D1*Dd*f**2*fd - 72*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s - 60*D1*Dd*f**2*r + 264*D1*Dd*f**2*s**2 - 312*D1*Dd*f**2*s + 114*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 1728*D1*Dd*f*fd*r*s + 1080*D1*Dd*f*fd*r - 864*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 324*D1*Dd*f*fd + 11424*D1*Dd*f*g2*r**2 + 18816*D1*Dd*f*g2*r*s - 15120*D1*Dd*f*g2*r + 7392*D1*Dd*f*g2*s**2 - 12096*D1*Dd*f*g2*s + 6552*D1*Dd*f*g2 - 24864*D1*Dd*f*gd2*r**2 - 45696*D1*Dd*f*gd2*r*s + 40488*D1*Dd*f*gd2*r - 20832*D1*Dd*f*gd2*s**2 + 36960*D1*Dd*f*gd2*s - 16128*D1*Dd*f*gd2 - 24864*D1*Dd*fd*g2*r**2 - 45696*D1*Dd*fd*g2*r*s + 15960*D1*Dd*fd*g2*r - 20832*D1*Dd*fd*g2*s**2 + 14448*D1*Dd*fd*g2*s + 1260*D1*Dd*fd*g2 + 2940*D1*Ddd*K*f**2*r**2 + 4872*D1*Ddd*K*f**2*r*s - 3906*D1*Ddd*K*f**2*r + 1932*D1*Ddd*K*f**2*s**2 - 3150*D1*Ddd*K*f**2*s + 1701*D1*Ddd*K*f**2 + 2520*D1*Ddd*b2*f*r**2 + 5040*D1*Ddd*b2*f*r*s - 3780*D1*Ddd*b2*f*r + 2520*D1*Ddd*b2*f*s**2 - 3780*D1*Ddd*b2*f*s + 1890*D1*Ddd*b2*f - 1268*D1*Ddd*f**3*r**2 - 2128*D1*Ddd*f**3*r*s + 1698*D1*Ddd*f**3*r - 860*D1*Ddd*f**3*s**2 + 1392*D1*Ddd*f**3*s - 747*D1*Ddd*f**3 - 216*D1*Ddd*f**2*r**2 - 432*D1*Ddd*f**2*r*s + 324*D1*Ddd*f**2*r - 216*D1*Ddd*f**2*s**2 + 324*D1*Ddd*f**2*s - 162*D1*Ddd*f**2 - 12432*D1*Ddd*f*g2*r**2 - 22848*D1*Ddd*f*g2*r*s + 17640*D1*Ddd*f*g2*r - 10416*D1*Ddd*f*g2*s**2 + 16128*D1*Ddd*f*g2*s - 8316*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(2*f**2*(95*r**2 + r*(274*s - 292) + 179*s**2 - 376*s + 167) - f*(350*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*K*(68*r**2 + 2*r*(56*s - 67) + 44*s**2 - 110*s + 61) + 12*fd*(118*r**2 + r*(292*s - 205) + 174*s**2 - 247*s + 80) - 518*r**2 - 896*r*s + 616*r - 378*s**2 + 476*s - 273) + 14*fd*(K*(148*r**2 + r*(272*s - 137) + 124*s**2 - 125*s - 5) - 12*r**2 - 12*r*(2*s - 1) - 12*s*(s - 1)) - 700*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 700*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(-7*K*f*(592*r**2 + 16*r*(68*s - 63) + 496*s**2 - 924*s + 417) + 6*f**2*(236*r**2 + r*(584*s - 489) + 348*s**2 - 587*s + 241) + 84*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 350*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 105*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 8820*Dd**2*K*f**2*r**2 + 14616*Dd**2*K*f**2*r*s - 11718*Dd**2*K*f**2*r + 5796*Dd**2*K*f**2*s**2 - 9450*Dd**2*K*f**2*s + 3402*Dd**2*K*f**2 + 7560*Dd**2*b2*f*r**2 + 15120*Dd**2*b2*f*r*s - 11340*Dd**2*b2*f*r + 7560*Dd**2*b2*f*s**2 - 11340*Dd**2*b2*f*s + 3780*Dd**2*b2*f - 3804*Dd**2*f**3*r**2 - 6384*Dd**2*f**3*r*s + 5094*Dd**2*f**3*r - 2580*Dd**2*f**3*s**2 + 4176*Dd**2*f**3*s - 1494*Dd**2*f**3 - 648*Dd**2*f**2*r**2 - 1296*Dd**2*f**2*r*s + 972*Dd**2*f**2*r - 648*Dd**2*f**2*s**2 + 972*Dd**2*f**2*s - 324*Dd**2*f**2 - 37296*Dd**2*f*g2*r**2 - 68544*Dd**2*f*g2*r*s + 52920*Dd**2*f*g2*r - 31248*Dd**2*f*g2*s**2 + 48384*Dd**2*f*g2*s - 16632*Dd**2*f*g2) + 165*b2*(-42*D1**2*bdd1*f*(r + s - 1)**2 + 58*D1**2*f*fd*r**2 + 116*D1**2*f*fd*r*s - 58*D1**2*f*fd*r + 58*D1**2*f*fd*s**2 - 58*D1**2*f*fd*s + 29*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 116*D1*Dd*f**2*r**2 + 232*D1*Dd*f**2*r*s - 174*D1*Dd*f**2*r + 116*D1*Dd*f**2*s**2 - 174*D1*Dd*f**2*s + 87*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 + 7*D1*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2))/(6930*d**2*k3**5) + D1**2*Pk1*Pkd3*k1**2*st**4*(4*C - 2)*(7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(-D1**2*(f*(7*bdd1*s*(2*r + 2*s - 1) + fd*(r*(8*s - 4) + 8*s**2 - 6*s + 4) + fdd*(-4*r*s + 2*r - 4*s**2 + 3*s - 2)) + fd**2*(r*(2 - 4*s) - 4*s**2 + 3*s + 1)) + 7*D1*bd1*(2*D1*f*s*(2*r + 2*s - 1) - D1*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(2*Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 2*fd*(2*s - 1)*(2*r + 2*s - 1)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + 2*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-7*D1**2*bd1**2*s*(2*r + 2*s - 1) + D1**2*(f*(bdd1*s*(2*r + 2*s - 3) + fd*(r*(2 - 6*s) - 6*s**2 + 6*s - 2) + fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-2*f*s*(2*r + 2*s - 3) + fd*(8*r*s - 2*r + 8*s**2 - 9*s + 3)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 11*s + 3)) + D1*f*(Dd*(-2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) + Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(35*d**2*k3**3) + D1**2*Pk1*Pkd3*k1**2*st**2*(42*b1**2*(D1**2*(fd*(20*C*(r - s + 1) - 10*r + 7*s - 7) + fdd*(10*C*(r + 3*s - 3) - 5*r - 16*s + 16))*(r + s - 1) + D1*(Dd*(f*(20*C*(4*r**2 - 2*r - 4*s**2 + 4*s - 1) - 40*r**2 - 12*r*s + 26*r + 28*s**2 - 25*s + 4) + fd*(20*C*(4*r**2 + 16*r*s - 13*r + 12*s**2 - 20*s + 8) - 40*r**2 - 168*r*s + 136*r - 128*s**2 + 213*s - 85)) + Ddd*f*(10*C*(4*r**2 + 2*r*(8*s - 5) + 12*s**2 - 16*s + 7) - 20*r**2 - 84*r*s + 52*r - 64*s**2 + 85*s - 37)) + Dd**2*f*(20*C*(6*r**2 + 3*r*(8*s - 5) + 18*s**2 - 24*s + 7) - 60*r**2 - 252*r*s + 156*r - 192*s**2 + 255*s - 74)) + 3*b1*(4*C*D1**2*f*fd*r**2 + 360*C*D1**2*f*fd*r*s - 100*C*D1**2*f*fd*r + 356*C*D1**2*f*fd*s**2 - 228*C*D1**2*f*fd*s + 138*C*D1**2*f*fd + 12*C*D1**2*f*fdd*r**2 - 264*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*r - 276*C*D1**2*f*fdd*s**2 + 100*C*D1**2*f*fdd*s - 62*C*D1**2*f*fdd + 12*C*D1**2*fd**2*r**2 - 264*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*r - 276*C*D1**2*fd**2*s**2 + 100*C*D1**2*fd**2*s + 176*C*D1**2*fd**2 + 8*C*D1*Dd*f**2*r**2 + 720*C*D1*Dd*f**2*r*s - 364*C*D1*Dd*f**2*r + 712*C*D1*Dd*f**2*s**2 - 892*C*D1*Dd*f**2*s + 358*C*D1*Dd*f**2 + 96*C*D1*Dd*f*fd*r**2 - 2112*C*D1*Dd*f*fd*r*s + 424*C*D1*Dd*f*fd*r - 2208*C*D1*Dd*f*fd*s**2 + 1768*C*D1*Dd*f*fd*s - 180*C*D1*Dd*f*fd + 24*C*D1*Ddd*f**2*r**2 - 528*C*D1*Ddd*f**2*r*s + 252*C*D1*Ddd*f**2*r - 552*C*D1*Ddd*f**2*s**2 + 684*C*D1*Ddd*f**2*s - 270*C*D1*Ddd*f**2 + 72*C*Dd**2*f**2*r**2 - 1584*C*Dd**2*f**2*r*s + 756*C*Dd**2*f**2*r - 1656*C*Dd**2*f**2*s**2 + 2052*C*Dd**2*f**2*s - 540*C*Dd**2*f**2 + 14*D1**2*bdd1*f*(10*C*(2*r**2 + 8*r*s - 2*r + 6*s**2 - 4*s + 1) - 10*r**2 - 42*r*s + 10*r - 32*s**2 + 21*s - 5) - 2*D1**2*f*fd*r**2 - 180*D1**2*f*fd*r*s + 50*D1**2*f*fd*r - 178*D1**2*f*fd*s**2 + 116*D1**2*f*fd*s - 69*D1**2*f*fd - 6*D1**2*f*fdd*r**2 + 132*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r + 138*D1**2*f*fdd*s**2 - 44*D1**2*f*fdd*s + 31*D1**2*f*fdd - 6*D1**2*fd**2*r**2 + 132*D1**2*fd**2*r*s + 10*D1**2*fd**2*r + 138*D1**2*fd**2*s**2 - 44*D1**2*fd**2*s - 94*D1**2*fd**2 - 4*D1*Dd*f**2*r**2 - 360*D1*Dd*f**2*r*s + 182*D1*Dd*f**2*r - 356*D1*Dd*f**2*s**2 + 446*D1*Dd*f**2*s - 179*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 + 1056*D1*Dd*f*fd*r*s - 212*D1*Dd*f*fd*r + 1104*D1*Dd*f*fd*s**2 - 860*D1*Dd*f*fd*s + 78*D1*Dd*f*fd - 12*D1*Ddd*f**2*r**2 + 264*D1*Ddd*f**2*r*s - 126*D1*Ddd*f**2*r + 276*D1*Ddd*f**2*s**2 - 342*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(20*C*(2*r**2 - 2*r - 2*s**2 + 1) - 20*r**2 - 6*r*s + 20*r + 14*s**2 + 3*s - 10) + fd*(20*C*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 8*s + 2) - 20*r**2 - 84*r*s + 52*r - 64*s**2 + 85*s - 21)) + 2*Dd*f*(10*C*(8*r**2 + 32*r*s - 14*r + 24*s**2 - 24*s + 5) - 40*r**2 - 168*r*s + 72*r - 128*s**2 + 127*s - 26)) - 36*Dd**2*f**2*r**2 + 792*Dd**2*f**2*r*s - 378*Dd**2*f**2*r + 828*Dd**2*f**2*s**2 - 1026*Dd**2*f**2*s + 270*Dd**2*f**2) + f*(354*C*D1**2*f*fd*r**2 + 1380*C*D1**2*f*fd*r*s - 696*C*D1**2*f*fd*r + 1026*C*D1**2*f*fd*s**2 - 1144*C*D1**2*f*fd*s + 460*C*D1**2*f*fd - 366*C*D1**2*f*fdd*r**2 - 1284*C*D1**2*f*fdd*r*s + 672*C*D1**2*f*fdd*r - 918*C*D1**2*f*fdd*s**2 + 1040*C*D1**2*f*fdd*s - 428*C*D1**2*f*fdd - 732*C*D1**2*fd**2*r**2 - 2568*C*D1**2*fd**2*r*s + 1344*C*D1**2*fd**2*r - 1836*C*D1**2*fd**2*s**2 + 2080*C*D1**2*fd**2*s - 428*C*D1**2*fd**2 + 472*C*D1*Dd*f**2*r**2 + 1840*C*D1*Dd*f**2*r*s - 1156*C*D1*Dd*f**2*r + 1368*C*D1*Dd*f**2*s**2 - 1828*C*D1*Dd*f**2*s + 802*C*D1*Dd*f**2 - 2928*C*D1*Dd*f*fd*r**2 - 10272*C*D1*Dd*f*fd*r*s + 5988*C*D1*Dd*f*fd*r - 7344*C*D1*Dd*f*fd*s**2 + 9116*C*D1*Dd*f*fd*s - 2752*C*D1*Dd*f*fd - 488*C*D1*Ddd*f**2*r**2 - 1712*C*D1*Ddd*f**2*r*s + 1100*C*D1*Ddd*f**2*r - 1224*C*D1*Ddd*f**2*s**2 + 1652*C*D1*Ddd*f**2*s - 734*C*D1*Ddd*f**2 - 1464*C*Dd**2*f**2*r**2 - 5136*C*Dd**2*f**2*r*s + 3300*C*Dd**2*f**2*r - 3672*C*Dd**2*f**2*s**2 + 4956*C*Dd**2*f**2*s - 1468*C*Dd**2*f**2 + 42*D1**2*bd1**2*(r**2*(20*C - 10) + 2*r*(40*C*s - 10*C - 21*s + 5) + s*(60*C*s - 40*C - 32*s + 21)) + 3*D1**2*bdd1*f*(2*C*(3*r**2 - 66*r*s + 70*r - 69*s**2 + 154*s - 35) - 3*r**2 + 66*r*s - 70*r + 69*s**2 - 160*s + 35) - 177*D1**2*f*fd*r**2 - 696*D1**2*f*fd*r*s + 350*D1**2*f*fd*r - 519*D1**2*f*fd*s**2 + 578*D1**2*f*fd*s - 232*D1**2*f*fd + 183*D1**2*f*fdd*r**2 + 672*D1**2*f*fdd*r*s - 346*D1**2*f*fdd*r + 489*D1**2*f*fdd*s**2 - 550*D1**2*f*fdd*s + 224*D1**2*f*fdd + 366*D1**2*fd**2*r**2 + 1344*D1**2*fd**2*r*s - 692*D1**2*fd**2*r + 978*D1**2*fd**2*s**2 - 1100*D1**2*fd**2*s + 224*D1**2*fd**2 - 236*D1*Dd*f**2*r**2 - 928*D1*Dd*f**2*r*s + 582*D1*Dd*f**2*r - 692*D1*Dd*f**2*s**2 + 924*D1*Dd*f**2*s - 405*D1*Dd*f**2 + 1464*D1*Dd*f*fd*r**2 + 5376*D1*Dd*f*fd*r*s - 3094*D1*Dd*f*fd*r + 3912*D1*Dd*f*fd*s**2 - 4828*D1*Dd*f*fd*s + 1446*D1*Dd*f*fd + 244*D1*Ddd*f**2*r**2 + 896*D1*Ddd*f**2*r*s - 570*D1*Ddd*f**2*r + 652*D1*Ddd*f**2*s**2 - 876*D1*Ddd*f**2*s + 387*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(2*C*(r**2 + 90*r*s - 42*r + 89*s**2 - 154*s + 21) - r**2 - 90*r*s + 42*r - 89*s**2 + 152*s - 21) + 2*fd*(2*C*(6*r**2 - 132*r*s + 65*r - 138*s**2 + 179*s - 77) - 6*r**2 + 132*r*s - 65*r + 138*s**2 - 182*s + 80)) + 2*Dd*f*(C*(24*r**2 - 528*r*s + 406*r - 552*s**2 + 958*s - 378) - 12*r**2 + 264*r*s - 203*r + 276*s**2 - 491*s + 195)) + 732*Dd**2*f**2*r**2 + 2688*Dd**2*f**2*r*s - 1710*Dd**2*f**2*r + 1956*Dd**2*f**2*s**2 - 2628*Dd**2*f**2*s + 774*Dd**2*f**2))/(630*d**2*k3**3) + D1**2*Pk1*Pkd3*k1**2*(42*D1**2*K*bd1**2*f*r**2 - 28*D1**2*K*bd1**2*f*r*s + 364*D1**2*K*bd1**2*f*r - 70*D1**2*K*bd1**2*f*s**2 + 420*D1**2*K*bd1**2*f*s - 350*D1**2*K*bd1**2*f + 111*D1**2*K*bd1*f**2*r**2 + 174*D1**2*K*bd1*f**2*r*s - 174*D1**2*K*bd1*f**2*r + 63*D1**2*K*bd1*f**2*s**2 - 126*D1**2*K*bd1*f**2*s + 63*D1**2*K*bd1*f**2 - 516*D1**2*K*bd1*f*fd*r**2 - 936*D1**2*K*bd1*f*fd*r*s + 726*D1**2*K*bd1*f*fd*r - 420*D1**2*K*bd1*f*fd*s**2 + 654*D1**2*K*bd1*f*fd*s - 234*D1**2*K*bd1*f*fd - 129*D1**2*K*bdd1*f**2*r**2 - 234*D1**2*K*bdd1*f**2*r*s + 234*D1**2*K*bdd1*f**2*r - 105*D1**2*K*bdd1*f**2*s**2 + 210*D1**2*K*bdd1*f**2*s - 105*D1**2*K*bdd1*f**2 - 42*D1**2*bd1**2*f**2*s + 42*D1**2*bd1**2*f**2 - 42*D1**2*bd1**2*f*s + 42*D1**2*bd1**2*f - 1120*D1**2*bd1**2*g2*r**2 - 2240*D1**2*bd1**2*g2*r*s + 1120*D1**2*bd1**2*g2*r - 1120*D1**2*bd1**2*g2*s**2 + 1120*D1**2*bd1**2*g2*s - 308*D1**2*bd1*bd2*f*r**2 - 616*D1**2*bd1*bd2*f*r*s + 658*D1**2*bd1*bd2*f*r - 308*D1**2*bd1*bd2*f*s**2 + 658*D1**2*bd1*bd2*f*s - 350*D1**2*bd1*bd2*f - 30*D1**2*bd1*f**3*r*s + 30*D1**2*bd1*f**3*r - 30*D1**2*bd1*f**3*s**2 + 60*D1**2*bd1*f**3*s - 30*D1**2*bd1*f**3 + 180*D1**2*bd1*f**2*fd*r*s - 120*D1**2*bd1*f**2*fd*r + 180*D1**2*bd1*f**2*fd*s**2 - 270*D1**2*bd1*f**2*fd*s + 90*D1**2*bd1*f**2*fd - 18*D1**2*bd1*f**2*r*s + 18*D1**2*bd1*f**2*r - 18*D1**2*bd1*f**2*s**2 + 36*D1**2*bd1*f**2*s - 18*D1**2*bd1*f**2 + 120*D1**2*bd1*f*fd*r*s - 60*D1**2*bd1*f*fd*r + 120*D1**2*bd1*f*fd*s**2 - 150*D1**2*bd1*f*fd*s + 30*D1**2*bd1*f*fd + 14*D1**2*bd1*f*g2*r**2 - 196*D1**2*bd1*f*g2*r*s + 420*D1**2*bd1*f*g2*r - 210*D1**2*bd1*f*g2*s**2 + 420*D1**2*bd1*f*g2*s - 210*D1**2*bd1*f*g2 - 84*D1**2*bd1*f*gd2*r**2 + 56*D1**2*bd1*f*gd2*r*s - 728*D1**2*bd1*f*gd2*r + 140*D1**2*bd1*f*gd2*s**2 - 840*D1**2*bd1*f*gd2*s + 700*D1**2*bd1*f*gd2 - 84*D1**2*bd1*fd*g2*r**2 + 56*D1**2*bd1*fd*g2*r*s + 84*D1**2*bd1*fd*g2*r + 140*D1**2*bd1*fd*g2*s**2 - 28*D1**2*bd1*fd*g2*s + 111*D1**2*bd2*f**2*r**2 + 174*D1**2*bd2*f**2*r*s - 174*D1**2*bd2*f**2*r + 63*D1**2*bd2*f**2*s**2 - 126*D1**2*bd2*f**2*s + 63*D1**2*bd2*f**2 - 516*D1**2*bd2*f*fd*r**2 - 936*D1**2*bd2*f*fd*r*s + 726*D1**2*bd2*f*fd*r - 420*D1**2*bd2*f*fd*s**2 + 654*D1**2*bd2*f*fd*s - 234*D1**2*bd2*f*fd + 30*D1**2*bdd1*f**3*r*s - 30*D1**2*bdd1*f**3*r + 30*D1**2*bdd1*f**3*s**2 - 60*D1**2*bdd1*f**3*s + 30*D1**2*bdd1*f**3 + 30*D1**2*bdd1*f**2*r*s - 30*D1**2*bdd1*f**2*r + 30*D1**2*bdd1*f**2*s**2 - 60*D1**2*bdd1*f**2*s + 30*D1**2*bdd1*f**2 - 42*D1**2*bdd1*f*g2*r**2 + 28*D1**2*bdd1*f*g2*r*s - 700*D1**2*bdd1*f*g2*r + 70*D1**2*bdd1*f*g2*s**2 - 700*D1**2*bdd1*f*g2*s + 350*D1**2*bdd1*f*g2 - 129*D1**2*bdd2*f**2*r**2 - 234*D1**2*bdd2*f**2*r*s + 234*D1**2*bdd2*f**2*r - 105*D1**2*bdd2*f**2*s**2 + 210*D1**2*bdd2*f**2*s - 105*D1**2*bdd2*f**2 - 222*D1**2*f**2*gd2*r**2 - 348*D1**2*f**2*gd2*r*s + 348*D1**2*f**2*gd2*r - 126*D1**2*f**2*gd2*s**2 + 252*D1**2*f**2*gd2*s - 126*D1**2*f**2*gd2 + 258*D1**2*f**2*gdd2*r**2 + 468*D1**2*f**2*gdd2*r*s - 468*D1**2*f**2*gdd2*r + 210*D1**2*f**2*gdd2*s**2 - 420*D1**2*f**2*gdd2*s + 210*D1**2*f**2*gdd2 - 444*D1**2*f*fd*g2*r**2 - 696*D1**2*f*fd*g2*r*s + 444*D1**2*f*fd*g2*r - 252*D1**2*f*fd*g2*s**2 + 348*D1**2*f*fd*g2*s - 222*D1**2*f*fd*g2 + 1032*D1**2*f*fd*gd2*r**2 + 1872*D1**2*f*fd*gd2*r*s - 1452*D1**2*f*fd*gd2*r + 840*D1**2*f*fd*gd2*s**2 - 1308*D1**2*f*fd*gd2*s + 468*D1**2*f*fd*gd2 + 516*D1**2*f*fdd*g2*r**2 + 936*D1**2*f*fdd*g2*r*s - 516*D1**2*f*fdd*g2*r + 420*D1**2*f*fdd*g2*s**2 - 468*D1**2*f*fdd*g2*s + 258*D1**2*f*fdd*g2 + 516*D1**2*fd**2*g2*r**2 + 936*D1**2*fd**2*g2*r*s - 516*D1**2*fd**2*g2*r + 420*D1**2*fd**2*g2*s**2 - 468*D1**2*fd**2*g2*s - 1032*D1*Dd*K*bd1*f**2*r**2 - 1872*D1*Dd*K*bd1*f**2*r*s + 1662*D1*Dd*K*bd1*f**2*r - 840*D1*Dd*K*bd1*f**2*s**2 + 1494*D1*Dd*K*bd1*f**2*s - 654*D1*Dd*K*bd1*f**2 + 240*D1*Dd*bd1*f**3*r*s - 180*D1*Dd*bd1*f**3*r + 240*D1*Dd*bd1*f**3*s**2 - 390*D1*Dd*bd1*f**3*s + 150*D1*Dd*bd1*f**3 + 240*D1*Dd*bd1*f**2*r*s - 180*D1*Dd*bd1*f**2*r + 240*D1*Dd*bd1*f**2*s**2 - 390*D1*Dd*bd1*f**2*s + 150*D1*Dd*bd1*f**2 - 336*D1*Dd*bd1*f*g2*r**2 + 224*D1*Dd*bd1*f*g2*r*s - 2772*D1*Dd*bd1*f*g2*r + 560*D1*Dd*bd1*f*g2*s**2 - 3108*D1*Dd*bd1*f*g2*s + 2100*D1*Dd*bd1*f*g2 - 1032*D1*Dd*bd2*f**2*r**2 - 1872*D1*Dd*bd2*f**2*r*s + 1662*D1*Dd*bd2*f**2*r - 840*D1*Dd*bd2*f**2*s**2 + 1494*D1*Dd*bd2*f**2*s - 654*D1*Dd*bd2*f**2 - 888*D1*Dd*f**2*g2*r**2 - 1392*D1*Dd*f**2*g2*r*s + 1140*D1*Dd*f**2*g2*r - 504*D1*Dd*f**2*g2*s**2 + 852*D1*Dd*f**2*g2*s - 474*D1*Dd*f**2*g2 + 2064*D1*Dd*f**2*gd2*r**2 + 3744*D1*Dd*f**2*gd2*r*s - 3324*D1*Dd*f**2*gd2*r + 1680*D1*Dd*f**2*gd2*s**2 - 2988*D1*Dd*f**2*gd2*s + 1308*D1*Dd*f**2*gd2 + 4128*D1*Dd*f*fd*g2*r**2 + 7488*D1*Dd*f*fd*g2*r*s - 4968*D1*Dd*f*fd*g2*r + 3360*D1*Dd*f*fd*g2*s**2 - 4488*D1*Dd*f*fd*g2*s + 1452*D1*Dd*f*fd*g2 + 1032*D1*Ddd*f**2*g2*r**2 + 1872*D1*Ddd*f**2*g2*r*s - 1452*D1*Ddd*f**2*g2*r + 840*D1*Ddd*f**2*g2*s**2 - 1308*D1*Ddd*f**2*g2*s + 678*D1*Ddd*f**2*g2 + 3096*Dd**2*f**2*g2*r**2 + 5616*Dd**2*f**2*g2*r*s - 4356*Dd**2*f**2*g2*r + 2520*Dd**2*f**2*g2*s**2 - 3924*Dd**2*f**2*g2*s + 1356*Dd**2*f**2*g2 + 70*b1**3*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(16*K*r**2 + 32*K*r*s - 24*K*r + 16*K*s**2 - 24*K*s + 12*K + f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5) - 4*r*s + 2*r - 4*s**2 + 5*s - 2) + Ddd*(4*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2) - 4*r*s + 2*r - 4*s**2 + 5*s - 2)) + Dd**2*(24*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4) - 12*r*s + 6*r - 12*s**2 + 15*s - 4)) + 7*b1**2*(120*D1**2*K*bdd1*r**2 + 240*D1**2*K*bdd1*r*s - 160*D1**2*K*bdd1*r + 120*D1**2*K*bdd1*s**2 - 160*D1**2*K*bdd1*s + 80*D1**2*K*bdd1 - D1**2*K*fd*r**2 + 14*D1**2*K*fd*r*s + 32*D1**2*K*fd*r + 15*D1**2*K*fd*s**2 + 16*D1**2*K*fd*s - 16*D1**2*K*fd + 3*D1**2*K*fdd*r**2 - 2*D1**2*K*fdd*r*s - 56*D1**2*K*fdd*r - 5*D1**2*K*fdd*s**2 - 48*D1**2*K*fdd*s + 28*D1**2*K*fdd - 30*D1**2*bdd1*f*r*s + 10*D1**2*bdd1*f*r - 30*D1**2*bdd1*f*s**2 + 30*D1**2*bdd1*f*s - 10*D1**2*bdd1*f - 30*D1**2*bdd1*r*s + 10*D1**2*bdd1*r - 30*D1**2*bdd1*s**2 + 30*D1**2*bdd1*s - 10*D1**2*bdd1 + 5*D1**2*bdd2*r**2 + 10*D1**2*bdd2*r*s - 10*D1**2*bdd2*r + 5*D1**2*bdd2*s**2 - 10*D1**2*bdd2*s + 5*D1**2*bdd2 - 6*D1**2*f*fd*s + 6*D1**2*f*fdd*s + 6*D1**2*fd**2*s - 6*D1**2*fd**2 - 2*D1**2*fd*s + 6*D1**2*fdd*s - 80*D1**2*gd2*r**2 - 160*D1**2*gd2*r*s + 160*D1**2*gd2*r - 80*D1**2*gd2*s**2 + 160*D1**2*gd2*s - 80*D1**2*gd2 - 80*D1**2*gdd2*r**2 - 160*D1**2*gdd2*r*s + 160*D1**2*gdd2*r - 80*D1**2*gdd2*s**2 + 160*D1**2*gdd2*s - 80*D1**2*gdd2 - 4*D1*Dd*K*f*r**2 + 56*D1*Dd*K*f*r*s - 26*D1*Dd*K*f*r + 60*D1*Dd*K*f*s**2 - 74*D1*Dd*K*f*s + 29*D1*Dd*K*f + 24*D1*Dd*K*fd*r**2 - 16*D1*Dd*K*fd*r*s - 226*D1*Dd*K*fd*r - 40*D1*Dd*K*fd*s**2 - 170*D1*Dd*K*fd*s + 152*D1*Dd*K*fd + 20*D1*Dd*b2*r**2 + 40*D1*Dd*b2*r*s - 30*D1*Dd*b2*r + 20*D1*Dd*b2*s**2 - 30*D1*Dd*b2*s + 15*D1*Dd*b2 + 24*D1*Dd*f*fd*s - 12*D1*Dd*f*fd + 24*D1*Dd*fd*s - 12*D1*Dd*fd - 320*D1*Dd*g2*r**2 - 640*D1*Dd*g2*r*s + 480*D1*Dd*g2*r - 320*D1*Dd*g2*s**2 + 480*D1*Dd*g2*s - 240*D1*Dd*g2 - 640*D1*Dd*gd2*r**2 - 1280*D1*Dd*gd2*r*s + 1120*D1*Dd*gd2*r - 640*D1*Dd*gd2*s**2 + 1120*D1*Dd*gd2*s - 480*D1*Dd*gd2 + 12*D1*Ddd*K*f*r**2 - 8*D1*Ddd*K*f*r*s - 2*D1*Ddd*K*f*r - 20*D1*Ddd*K*f*s**2 + 22*D1*Ddd*K*f*s - 7*D1*Ddd*K*f + 20*D1*Ddd*b2*r**2 + 40*D1*Ddd*b2*r*s - 30*D1*Ddd*b2*r + 20*D1*Ddd*b2*s**2 - 30*D1*Ddd*b2*s + 15*D1*Ddd*b2 - 320*D1*Ddd*g2*r**2 - 640*D1*Ddd*g2*r*s + 480*D1*Ddd*g2*r - 320*D1*Ddd*g2*s**2 + 480*D1*Ddd*g2*s - 240*D1*Ddd*g2 + 10*D1*bd1*(D1*(12*K*r**2 + 24*K*r*s - 16*K*r + 12*K*s**2 - 16*K*s + 8*K + f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd*(-6*r*s + 4*r - 6*s**2 + 9*s - 3) - 3*r*s + r - 3*s**2 + 3*s - 1) + Dd*(8*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(r*(10 - 24*s) - 24*s**2 + 27*s - 7) - 24*r*s + 10*r - 24*s**2 + 27*s - 7)) + 5*D1*bd2*(D1*(r + s - 1) + 2*Dd*(4*r + 4*s - 3))*(r + s - 1) + 36*Dd**2*K*f*r**2 - 24*Dd**2*K*f*r*s - 6*Dd**2*K*f*r - 60*Dd**2*K*f*s**2 + 66*Dd**2*K*f*s - 14*Dd**2*K*f + 60*Dd**2*b2*r**2 + 120*Dd**2*b2*r*s - 90*Dd**2*b2*r + 60*Dd**2*b2*s**2 - 90*Dd**2*b2*s + 30*Dd**2*b2 - 960*Dd**2*g2*r**2 - 1920*Dd**2*g2*r*s + 1440*Dd**2*g2*r - 960*Dd**2*g2*s**2 + 1440*Dd**2*g2*s - 480*Dd**2*g2) + b1*(42*D1**2*K*bdd1*f*r**2 - 28*D1**2*K*bdd1*f*r*s + 364*D1**2*K*bdd1*f*r - 70*D1**2*K*bdd1*f*s**2 + 420*D1**2*K*bdd1*f*s - 210*D1**2*K*bdd1*f + 222*D1**2*K*f*fd*r**2 + 348*D1**2*K*f*fd*r*s - 222*D1**2*K*f*fd*r + 126*D1**2*K*f*fd*s**2 - 174*D1**2*K*f*fd*s + 111*D1**2*K*f*fd - 258*D1**2*K*f*fdd*r**2 - 468*D1**2*K*f*fdd*r*s + 258*D1**2*K*f*fdd*r - 210*D1**2*K*f*fdd*s**2 + 234*D1**2*K*f*fdd*s - 129*D1**2*K*f*fdd - 258*D1**2*K*fd**2*r**2 - 468*D1**2*K*fd**2*r*s + 258*D1**2*K*fd**2*r - 210*D1**2*K*fd**2*s**2 + 234*D1**2*K*fd**2*s - 70*D1**2*bd1**2*(-8*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*r*s - 2*r + 6*s**2 - 6*s + 1) + 98*D1**2*bd2*f*r**2 + 196*D1**2*bd2*f*r*s - 196*D1**2*bd2*f*r + 98*D1**2*bd2*f*s**2 - 196*D1**2*bd2*f*s + 98*D1**2*bd2*f - 308*D1**2*bd2*fd*r**2 - 616*D1**2*bd2*fd*r*s + 266*D1**2*bd2*fd*r - 308*D1**2*bd2*fd*s**2 + 266*D1**2*bd2*fd*s + 42*D1**2*bd2*fd - 42*D1**2*bdd1*f**2*s - 42*D1**2*bdd1*f*s - 1120*D1**2*bdd1*g2*r**2 - 2240*D1**2*bdd1*g2*r*s + 1120*D1**2*bdd1*g2*r - 1120*D1**2*bdd1*g2*s**2 + 1120*D1**2*bdd1*g2*s - 560*D1**2*bdd1*g2 - 154*D1**2*bdd2*f*r**2 - 308*D1**2*bdd2*f*r*s + 308*D1**2*bdd2*f*r - 154*D1**2*bdd2*f*s**2 + 308*D1**2*bdd2*f*s - 154*D1**2*bdd2*f - 90*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 90*D1**2*f**2*fd*s - 30*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r*s - 30*D1**2*f**2*fdd*r + 90*D1**2*f**2*fdd*s**2 - 90*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r*s - 60*D1**2*f*fd**2*r + 180*D1**2*f*fd**2*s**2 - 180*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 - 36*D1**2*f*fd*r*s - 36*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s + 60*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s + 14*D1**2*f*gd2*r**2 - 196*D1**2*f*gd2*r*s + 196*D1**2*f*gd2*r - 210*D1**2*f*gd2*s**2 + 420*D1**2*f*gd2*s - 210*D1**2*f*gd2 - 42*D1**2*f*gdd2*r**2 + 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r + 70*D1**2*f*gdd2*s**2 - 140*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 + 60*D1**2*fd**2*r*s + 60*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s + 14*D1**2*fd*g2*r**2 - 196*D1**2*fd*g2*r*s - 448*D1**2*fd*g2*r - 210*D1**2*fd*g2*s**2 - 224*D1**2*fd*g2*s + 224*D1**2*fd*g2 - 84*D1**2*fd*gd2*r**2 + 56*D1**2*fd*gd2*r*s + 756*D1**2*fd*gd2*r + 140*D1**2*fd*gd2*s**2 + 532*D1**2*fd*gd2*s - 672*D1**2*fd*gd2 - 42*D1**2*fdd*g2*r**2 + 28*D1**2*fdd*g2*r*s + 784*D1**2*fdd*g2*r + 70*D1**2*fdd*g2*s**2 + 672*D1**2*fdd*g2*s - 392*D1**2*fdd*g2 + 444*D1*Dd*K*f**2*r**2 + 696*D1*Dd*K*f**2*r*s - 570*D1*Dd*K*f**2*r + 252*D1*Dd*K*f**2*s**2 - 426*D1*Dd*K*f**2*s + 237*D1*Dd*K*f**2 - 2064*D1*Dd*K*f*fd*r**2 - 3744*D1*Dd*K*f*fd*r*s + 2484*D1*Dd*K*f*fd*r - 1680*D1*Dd*K*f*fd*s**2 + 2244*D1*Dd*K*f*fd*s - 726*D1*Dd*K*f*fd - 1232*D1*Dd*bd2*f*r**2 - 2464*D1*Dd*bd2*f*r*s + 2156*D1*Dd*bd2*f*r - 1232*D1*Dd*bd2*f*s**2 + 2156*D1*Dd*bd2*f*s - 924*D1*Dd*bd2*f - 120*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r*s - 300*D1*Dd*f**2*fd*r + 720*D1*Dd*f**2*fd*s**2 - 810*D1*Dd*f**2*fd*s + 210*D1*Dd*f**2*fd - 72*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 90*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 480*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 420*D1*Dd*f*fd*s + 60*D1*Dd*f*fd + 56*D1*Dd*f*g2*r**2 - 784*D1*Dd*f*g2*r*s + 364*D1*Dd*f*g2*r - 840*D1*Dd*f*g2*s**2 + 1036*D1*Dd*f*g2*s - 406*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r**2 + 224*D1*Dd*f*gd2*r*s - 84*D1*Dd*f*gd2*r + 560*D1*Dd*f*gd2*s**2 - 868*D1*Dd*f*gd2*s + 308*D1*Dd*f*gd2 - 336*D1*Dd*fd*g2*r**2 + 224*D1*Dd*fd*g2*r*s + 3164*D1*Dd*fd*g2*r + 560*D1*Dd*fd*g2*s**2 + 2380*D1*Dd*fd*g2*s - 2128*D1*Dd*fd*g2 - 516*D1*Ddd*K*f**2*r**2 - 936*D1*Ddd*K*f**2*r*s + 726*D1*Ddd*K*f**2*r - 420*D1*Ddd*K*f**2*s**2 + 654*D1*Ddd*K*f**2*s - 339*D1*Ddd*K*f**2 + 120*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 120*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 120*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 60*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r**2 + 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r + 280*D1*Ddd*f*g2*s**2 - 308*D1*Ddd*f*g2*s + 98*D1*Ddd*f*g2 + 14*D1*bd1*(5*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-K*f*r**2 + 14*K*f*r*s - 22*K*f*r + 15*K*f*s**2 - 30*K*f*s + 15*K*f + 2*K*fd*(3*r**2 - r*(2*s + 15) - 5*s**2 - 9*s + 12) + 3*f**2*s + f*s + 3*fd*(s - 1) - 40*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 160*gd2*r**2 - 320*gd2*r*s + 240*gd2*r - 160*gd2*s**2 + 240*gd2*s - 80*gd2) - 2*Dd*(f**2*(6*s - 3) + f*(K*(-12*r**2 + 8*r*s - 51*r + 20*s**2 - 71*s + 43) + 6*s - 3) + 40*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 1548*Dd**2*K*f**2*r**2 - 2808*Dd**2*K*f**2*r*s + 2178*Dd**2*K*f**2*r - 1260*Dd**2*K*f**2*s**2 + 1962*Dd**2*K*f**2*s - 678*Dd**2*K*f**2 + 360*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 360*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 120*Dd**2*f**3 + 360*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 120*Dd**2*f**2 - 504*Dd**2*f*g2*r**2 + 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r + 840*Dd**2*f*g2*s**2 - 924*Dd**2*f*g2*s + 196*Dd**2*f*g2 + 7*b2*(5*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 14*D1**2*fd*r**2 + 28*D1**2*fd*r*s + 2*D1**2*fd*r + 14*D1**2*fd*s**2 + 2*D1**2*fd*s - D1**2*fd - 22*D1**2*fdd*r**2 - 44*D1**2*fdd*r*s - 6*D1**2*fdd*r - 22*D1**2*fdd*s**2 - 6*D1**2*fdd*s + 3*D1**2*fdd + 56*D1*Dd*f*r**2 + 112*D1*Dd*f*r*s - 84*D1*Dd*f*r + 56*D1*Dd*f*s**2 - 84*D1*Dd*f*s + 42*D1*Dd*f - 176*D1*Dd*fd*r**2 - 352*D1*Dd*fd*r*s + 108*D1*Dd*fd*r - 176*D1*Dd*fd*s**2 + 108*D1*Dd*fd*s + 18*D1*Dd*fd - 88*D1*Ddd*f*r**2 - 176*D1*Ddd*f*r*s + 132*D1*Ddd*f*r - 88*D1*Ddd*f*s**2 + 132*D1*Ddd*f*s - 66*D1*Ddd*f + 5*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 264*Dd**2*f*r**2 - 528*Dd**2*f*r*s + 396*Dd**2*f*r - 264*Dd**2*f*s**2 + 396*Dd**2*f*s - 132*Dd**2*f)) + b2*(70*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 7*D1**2*bdd1*f*(22*r**2 + r*(44*s - 50) + 22*s**2 - 50*s + 25) + 3*D1**2*(f*(fd*(74*r**2 + 116*r*s - 74*r + 42*s**2 - 58*s + 37) - fdd*(86*r**2 + 156*r*s - 86*r + 70*s**2 - 78*s + 43)) - 2*fd**2*(43*r**2 + r*(78*s - 43) + s*(35*s - 39))) + 7*D1*bd1*(D1*(f*(14*r**2 + r*(28*s - 30) + 14*s**2 - 30*s + 15) - 44*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(88*r**2 + 2*r*(88*s - 83) + 88*s**2 - 166*s + 75)) + 3*D1*f*(Dd*(f*(148*r**2 + 232*r*s - 190*r + 84*s**2 - 142*s + 79) - 2*fd*(344*r**2 + 624*r*s - 414*r + 280*s**2 - 374*s + 121)) - Ddd*f*(172*r**2 + r*(312*s - 242) + 140*s**2 - 218*s + 113)) - 6*Dd**2*f**2*(258*r**2 + r*(468*s - 363) + 210*s**2 - 327*s + 113)))/(210*d**2*k3**3) - D1**2*Pk1*Pkd3*k2**6*st**6*(99*b1**2*(D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*f*(-9*D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 18*D1*bd1*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 2*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f**2*(-198*D1**2*bd1**2*(r + s - 1)**2 + 44*D1**2*bdd1*f*(r + s - 1)**2 - 15*D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 88*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 15*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(154*d**2*k3**7) + D1**2*Pk1*Pkd3*k2**4*st**6*(-648*C*D1**2*b1*f*fd*r**2 - 1008*C*D1**2*b1*f*fd*r*s + 504*C*D1**2*b1*f*fd*r - 360*C*D1**2*b1*f*fd*s**2 + 360*C*D1**2*b1*f*fd*s - 180*C*D1**2*b1*f*fd + 324*C*D1**2*b1*f*fdd*r**2 + 504*C*D1**2*b1*f*fdd*r*s - 252*C*D1**2*b1*f*fdd*r + 180*C*D1**2*b1*f*fdd*s**2 - 180*C*D1**2*b1*f*fdd*s + 90*C*D1**2*b1*f*fdd + 324*C*D1**2*b1*fd**2*r**2 + 504*C*D1**2*b1*fd**2*r*s - 252*C*D1**2*b1*fd**2*r + 180*C*D1**2*b1*fd**2*s**2 - 180*C*D1**2*b1*fd**2*s - 108*C*D1**2*f**2*fd*r**2 - 168*C*D1**2*f**2*fd*r*s + 128*C*D1**2*f**2*fd*r - 60*C*D1**2*f**2*fd*s**2 + 96*C*D1**2*f**2*fd*s - 56*C*D1**2*f**2*fd + 54*C*D1**2*f**2*fdd*r**2 + 84*C*D1**2*f**2*fdd*r*s - 64*C*D1**2*f**2*fdd*r + 30*C*D1**2*f**2*fdd*s**2 - 48*C*D1**2*f**2*fdd*s + 28*C*D1**2*f**2*fdd + 108*C*D1**2*f*fd**2*r**2 + 168*C*D1**2*f*fd**2*r*s - 128*C*D1**2*f*fd**2*r + 60*C*D1**2*f*fd**2*s**2 - 96*C*D1**2*f*fd**2*s + 28*C*D1**2*f*fd**2 - 1296*C*D1*Dd*b1*f**2*r**2 - 2016*C*D1*Dd*b1*f**2*r*s + 1656*C*D1*Dd*b1*f**2*r - 720*C*D1*Dd*b1*f**2*s**2 + 1224*C*D1*Dd*b1*f**2*s - 684*C*D1*Dd*b1*f**2 + 2592*C*D1*Dd*b1*f*fd*r**2 + 4032*C*D1*Dd*b1*f*fd*r*s - 2664*C*D1*Dd*b1*f*fd*r + 1440*C*D1*Dd*b1*f*fd*s**2 - 1944*C*D1*Dd*b1*f*fd*s + 612*C*D1*Dd*b1*f*fd - 144*C*D1*Dd*f**3*r**2 - 224*C*D1*Dd*f**3*r*s + 184*C*D1*Dd*f**3*r - 80*C*D1*Dd*f**3*s**2 + 136*C*D1*Dd*f**3*s - 76*C*D1*Dd*f**3 + 432*C*D1*Dd*f**2*fd*r**2 + 672*C*D1*Dd*f**2*fd*r*s - 532*C*D1*Dd*f**2*fd*r + 240*C*D1*Dd*f**2*fd*s**2 - 396*C*D1*Dd*f**2*fd*s + 160*C*D1*Dd*f**2*fd + 648*C*D1*Ddd*b1*f**2*r**2 + 1008*C*D1*Ddd*b1*f**2*r*s - 828*C*D1*Ddd*b1*f**2*r + 360*C*D1*Ddd*b1*f**2*s**2 - 612*C*D1*Ddd*b1*f**2*s + 342*C*D1*Ddd*b1*f**2 + 72*C*D1*Ddd*f**3*r**2 + 112*C*D1*Ddd*f**3*r*s - 92*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s**2 - 68*C*D1*Ddd*f**3*s + 38*C*D1*Ddd*f**3 + 1944*C*Dd**2*b1*f**2*r**2 + 3024*C*Dd**2*b1*f**2*r*s - 2484*C*Dd**2*b1*f**2*r + 1080*C*Dd**2*b1*f**2*s**2 - 1836*C*Dd**2*b1*f**2*s + 684*C*Dd**2*b1*f**2 + 216*C*Dd**2*f**3*r**2 + 336*C*Dd**2*f**3*r*s - 276*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s**2 - 204*C*Dd**2*f**3*s + 76*C*Dd**2*f**3 + 396*D1**2*b1*f*fd*r**2 + 576*D1**2*b1*f*fd*r*s - 288*D1**2*b1*f*fd*r + 180*D1**2*b1*f*fd*s**2 - 180*D1**2*b1*f*fd*s + 90*D1**2*b1*f*fd - 198*D1**2*b1*f*fdd*r**2 - 288*D1**2*b1*f*fdd*r*s + 144*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd - 198*D1**2*b1*fd**2*r**2 - 288*D1**2*b1*fd**2*r*s + 144*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(r + s - 1)*(2*C*(9*r + 5*s - 9) - 11*r - 5*s + 11) + 66*D1**2*f**2*fd*r**2 + 96*D1**2*f**2*fd*r*s - 76*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 52*D1**2*f**2*fd*s + 32*D1**2*f**2*fd - 33*D1**2*f**2*fdd*r**2 - 48*D1**2*f**2*fdd*r*s + 38*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 26*D1**2*f**2*fdd*s - 16*D1**2*f**2*fdd - 66*D1**2*f*fd**2*r**2 - 96*D1**2*f*fd**2*r*s + 76*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 52*D1**2*f*fd**2*s - 16*D1**2*f*fd**2 + 792*D1*Dd*b1*f**2*r**2 + 1152*D1*Dd*b1*f**2*r*s - 972*D1*Dd*b1*f**2*r + 360*D1*Dd*b1*f**2*s**2 - 648*D1*Dd*b1*f**2*s + 378*D1*Dd*b1*f**2 - 1584*D1*Dd*b1*f*fd*r**2 - 2304*D1*Dd*b1*f*fd*r*s + 1548*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 1008*D1*Dd*b1*f*fd*s - 324*D1*Dd*b1*f*fd + 88*D1*Dd*f**3*r**2 + 128*D1*Dd*f**3*r*s - 108*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 72*D1*Dd*f**3*s + 42*D1*Dd*f**3 - 264*D1*Dd*f**2*fd*r**2 - 384*D1*Dd*f**2*fd*r*s + 314*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 212*D1*Dd*f**2*fd*s - 90*D1*Dd*f**2*fd - 396*D1*Ddd*b1*f**2*r**2 - 576*D1*Ddd*b1*f**2*r*s + 486*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 324*D1*Ddd*b1*f**2*s - 189*D1*Ddd*b1*f**2 - 44*D1*Ddd*f**3*r**2 - 64*D1*Ddd*f**3*r*s + 54*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 36*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 - 18*D1*bd1*f*(D1*(f*(r + s - 1)*(2*C*(9*r + 5*s - 9) - 11*r - 5*s + 11) + fd*(-2*C*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) + 22*r**2 + 32*r*s - 30*r + 10*s**2 - 21*s + 8)) + Dd*f*(-2*C*(36*r**2 + 56*r*s - 59*r + 20*s**2 - 45*s + 23) + 44*r**2 + 64*r*s - 71*r + 20*s**2 - 50*s + 27)) - 1188*Dd**2*b1*f**2*r**2 - 1728*Dd**2*b1*f**2*r*s + 1458*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 972*Dd**2*b1*f**2*s - 378*Dd**2*b1*f**2 - 132*Dd**2*f**3*r**2 - 192*Dd**2*f**3*r*s + 162*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 108*Dd**2*f**3*s - 42*Dd**2*f**3)/(126*d**2*k3**5) - D1**2*Pk1*Pkd3*k2**4*st**4*(-4158*C*D1**2*bd1*f**2*r**2 - 6468*C*D1**2*bd1*f**2*r*s + 8316*C*D1**2*bd1*f**2*r - 2310*C*D1**2*bd1*f**2*s**2 + 6468*C*D1**2*bd1*f**2*s - 4158*C*D1**2*bd1*f**2 - 1782*C*D1**2*f**2*fd*r**2 - 2772*C*D1**2*f**2*fd*r*s + 2112*C*D1**2*f**2*fd*r - 990*C*D1**2*f**2*fd*s**2 + 1584*C*D1**2*f**2*fd*s - 924*C*D1**2*f**2*fd - 2376*C*D1*Dd*f**3*r**2 - 3696*C*D1*Dd*f**3*r*s + 3036*C*D1*Dd*f**3*r - 1320*C*D1*Dd*f**3*s**2 + 2244*C*D1*Dd*f**3*s - 1254*C*D1*Dd*f**3 - 4158*D1**2*K*bd1**2*f*r**2 - 6468*D1**2*K*bd1**2*f*r*s + 7392*D1**2*K*bd1**2*f*r - 2310*D1**2*K*bd1**2*f*s**2 + 5544*D1**2*K*bd1**2*f*s - 3234*D1**2*K*bd1**2*f + 594*D1**2*K*bd1*f**2*r**2 + 924*D1**2*K*bd1*f**2*r*s - 924*D1**2*K*bd1*f**2*r + 330*D1**2*K*bd1*f**2*s**2 - 660*D1**2*K*bd1*f**2*s + 330*D1**2*K*bd1*f**2 - 1188*D1**2*K*bd1*f*fd*r**2 - 1848*D1**2*K*bd1*f*fd*r*s + 1518*D1**2*K*bd1*f*fd*r - 660*D1**2*K*bd1*f*fd*s**2 + 1122*D1**2*K*bd1*f*fd*s - 462*D1**2*K*bd1*f*fd - 297*D1**2*K*bdd1*f**2*r**2 - 462*D1**2*K*bdd1*f**2*r*s + 462*D1**2*K*bdd1*f**2*r - 165*D1**2*K*bdd1*f**2*s**2 + 330*D1**2*K*bdd1*f**2*s - 165*D1**2*K*bdd1*f**2 + 5214*D1**2*bd1**2*f**2*r**2 + 11352*D1**2*bd1**2*f**2*r*s - 10230*D1**2*bd1**2*f**2*r + 6138*D1**2*bd1**2*f**2*s**2 - 11154*D1**2*bd1**2*f**2*s + 5016*D1**2*bd1**2*f**2 + 924*D1**2*bd1**2*f*r**2 + 924*D1**2*bd1**2*f*r*s - 1386*D1**2*bd1**2*f*r - 462*D1**2*bd1**2*f*s + 462*D1**2*bd1**2*f - 2310*D1**2*bd1*bd2*f*r**2 - 4620*D1**2*bd1*bd2*f*r*s + 4620*D1**2*bd1*bd2*f*r - 2310*D1**2*bd1*bd2*f*s**2 + 4620*D1**2*bd1*bd2*f*s - 2310*D1**2*bd1*bd2*f - 484*D1**2*bd1*f**3*r**2 - 462*D1**2*bd1*f**3*r*s + 66*D1**2*bd1*f**3*r + 22*D1**2*bd1*f**3*s**2 - 440*D1**2*bd1*f**3*s + 88*D1**2*bd1*f**3 + 858*D1**2*bd1*f**2*fd*r**2 - 2376*D1**2*bd1*f**2*fd*r*s + 1166*D1**2*bd1*f**2*fd*r - 3234*D1**2*bd1*f**2*fd*s**2 + 4576*D1**2*bd1*f**2*fd*s - 1738*D1**2*bd1*f**2*fd + 2409*D1**2*bd1*f**2*r**2 + 3564*D1**2*bd1*f**2*r*s - 4950*D1**2*bd1*f**2*r + 1155*D1**2*bd1*f**2*s**2 - 3696*D1**2*bd1*f**2*s + 2541*D1**2*bd1*f**2 + 264*D1**2*bd1*f*fd*r**2 + 264*D1**2*bd1*f*fd*r*s - 264*D1**2*bd1*f*fd*r - 66*D1**2*bd1*f*fd*s + 66*D1**2*bd1*f*fd - 8316*D1**2*bd1*f*g2*r**2 - 12936*D1**2*bd1*f*g2*r*s + 16632*D1**2*bd1*f*g2*r - 4620*D1**2*bd1*f*g2*s**2 + 12936*D1**2*bd1*f*g2*s - 8316*D1**2*bd1*f*g2 + 8316*D1**2*bd1*f*gd2*r**2 + 12936*D1**2*bd1*f*gd2*r*s - 14784*D1**2*bd1*f*gd2*r + 4620*D1**2*bd1*f*gd2*s**2 - 11088*D1**2*bd1*f*gd2*s + 6468*D1**2*bd1*f*gd2 + 8316*D1**2*bd1*fd*g2*r**2 + 12936*D1**2*bd1*fd*g2*r*s - 8316*D1**2*bd1*fd*g2*r + 4620*D1**2*bd1*fd*g2*s**2 - 6468*D1**2*bd1*fd*g2*s + 330*D1**2*bd2*f**2*r**2 + 660*D1**2*bd2*f**2*r*s - 660*D1**2*bd2*f**2*r + 330*D1**2*bd2*f**2*s**2 - 660*D1**2*bd2*f**2*s + 330*D1**2*bd2*f**2 - 660*D1**2*bd2*f*fd*r**2 - 1320*D1**2*bd2*f*fd*r*s + 990*D1**2*bd2*f*fd*r - 660*D1**2*bd2*f*fd*s**2 + 990*D1**2*bd2*f*fd*s - 330*D1**2*bd2*f*fd + 143*D1**2*bdd1*f**3*r**2 - 396*D1**2*bdd1*f**3*r*s + 330*D1**2*bdd1*f**3*r - 539*D1**2*bdd1*f**3*s**2 + 1012*D1**2*bdd1*f**3*s - 308*D1**2*bdd1*f**3 + 66*D1**2*bdd1*f**2*r**2 + 66*D1**2*bdd1*f**2*r*s - 66*D1**2*bdd1*f**2*r + 4158*D1**2*bdd1*f*g2*r**2 + 6468*D1**2*bdd1*f*g2*r*s - 8316*D1**2*bdd1*f*g2*r + 2310*D1**2*bdd1*f*g2*s**2 - 6468*D1**2*bdd1*f*g2*s + 4158*D1**2*bdd1*f*g2 - 165*D1**2*bdd2*f**2*r**2 - 330*D1**2*bdd2*f**2*r*s + 330*D1**2*bdd2*f**2*r - 165*D1**2*bdd2*f**2*s**2 + 330*D1**2*bdd2*f**2*s - 165*D1**2*bdd2*f**2 + 1380*D1**2*f**3*fd*r**2 + 2744*D1**2*f**3*fd*r*s - 2062*D1**2*f**3*fd*r + 1364*D1**2*f**3*fd*s**2 - 2050*D1**2*f**3*fd*s + 1027*D1**2*f**3*fd - 1548*D1**2*f**3*fdd*r**2 - 3176*D1**2*f**3*fdd*r*s + 2362*D1**2*f**3*fdd*r - 1628*D1**2*f**3*fdd*s**2 + 2422*D1**2*f**3*fdd*s - 1201*D1**2*f**3*fdd - 4644*D1**2*f**2*fd**2*r**2 - 9528*D1**2*f**2*fd**2*r*s + 7086*D1**2*f**2*fd**2*r - 4884*D1**2*f**2*fd**2*s**2 + 7266*D1**2*f**2*fd**2*s - 2402*D1**2*f**2*fd**2 + 1089*D1**2*f**2*fd*r**2 + 1584*D1**2*f**2*fd*r*s - 1254*D1**2*f**2*fd*r + 495*D1**2*f**2*fd*s**2 - 858*D1**2*f**2*fd*s + 528*D1**2*f**2*fd - 1188*D1**2*f**2*gd2*r**2 - 1848*D1**2*f**2*gd2*r*s + 1848*D1**2*f**2*gd2*r - 660*D1**2*f**2*gd2*s**2 + 1320*D1**2*f**2*gd2*s - 660*D1**2*f**2*gd2 + 594*D1**2*f**2*gdd2*r**2 + 924*D1**2*f**2*gdd2*r*s - 924*D1**2*f**2*gdd2*r + 330*D1**2*f**2*gdd2*s**2 - 660*D1**2*f**2*gdd2*s + 330*D1**2*f**2*gdd2 - 2376*D1**2*f*fd*g2*r**2 - 3696*D1**2*f*fd*g2*r*s + 2376*D1**2*f*fd*g2*r - 1320*D1**2*f*fd*g2*s**2 + 1848*D1**2*f*fd*g2*s - 1188*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r**2 + 3696*D1**2*f*fd*gd2*r*s - 3036*D1**2*f*fd*gd2*r + 1320*D1**2*f*fd*gd2*s**2 - 2244*D1**2*f*fd*gd2*s + 924*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r**2 + 1848*D1**2*f*fdd*g2*r*s - 1188*D1**2*f*fdd*g2*r + 660*D1**2*f*fdd*g2*s**2 - 924*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r**2 + 1848*D1**2*fd**2*g2*r*s - 1188*D1**2*fd**2*g2*r + 660*D1**2*fd**2*g2*s**2 - 924*D1**2*fd**2*g2*s - 2376*D1*Dd*K*bd1*f**2*r**2 - 3696*D1*Dd*K*bd1*f**2*r*s + 3366*D1*Dd*K*bd1*f**2*r - 1320*D1*Dd*K*bd1*f**2*s**2 + 2442*D1*Dd*K*bd1*f**2*s - 1122*D1*Dd*K*bd1*f**2 + 1144*D1*Dd*bd1*f**3*r**2 - 3168*D1*Dd*bd1*f**3*r*s + 1826*D1*Dd*bd1*f**3*r - 4312*D1*Dd*bd1*f**3*s**2 + 6600*D1*Dd*bd1*f**3*s - 2354*D1*Dd*bd1*f**3 + 528*D1*Dd*bd1*f**2*r**2 + 528*D1*Dd*bd1*f**2*r*s - 528*D1*Dd*bd1*f**2*r - 66*D1*Dd*bd1*f**2*s + 66*D1*Dd*bd1*f**2 + 33264*D1*Dd*bd1*f*g2*r**2 + 51744*D1*Dd*bd1*f*g2*r*s - 54516*D1*Dd*bd1*f*g2*r + 18480*D1*Dd*bd1*f*g2*s**2 - 41580*D1*Dd*bd1*f*g2*s + 21252*D1*Dd*bd1*f*g2 - 1320*D1*Dd*bd2*f**2*r**2 - 2640*D1*Dd*bd2*f**2*r*s + 2310*D1*Dd*bd2*f**2*r - 1320*D1*Dd*bd2*f**2*s**2 + 2310*D1*Dd*bd2*f**2*s - 990*D1*Dd*bd2*f**2 + 1380*D1*Dd*f**4*r**2 + 2744*D1*Dd*f**4*r*s - 2062*D1*Dd*f**4*r + 1364*D1*Dd*f**4*s**2 - 2050*D1*Dd*f**4*s + 1027*D1*Dd*f**4 - 12384*D1*Dd*f**3*fd*r**2 - 25408*D1*Dd*f**3*fd*r*s + 18896*D1*Dd*f**3*fd*r - 13024*D1*Dd*f**3*fd*s**2 + 19376*D1*Dd*f**3*fd*s - 7206*D1*Dd*f**3*fd + 1452*D1*Dd*f**3*r**2 + 2112*D1*Dd*f**3*r*s - 1782*D1*Dd*f**3*r + 660*D1*Dd*f**3*s**2 - 1188*D1*Dd*f**3*s + 693*D1*Dd*f**3 - 4752*D1*Dd*f**2*g2*r**2 - 7392*D1*Dd*f**2*g2*r*s + 6072*D1*Dd*f**2*g2*r - 2640*D1*Dd*f**2*g2*s**2 + 4488*D1*Dd*f**2*g2*s - 2508*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r**2 + 7392*D1*Dd*f**2*gd2*r*s - 6732*D1*Dd*f**2*gd2*r + 2640*D1*Dd*f**2*gd2*s**2 - 4884*D1*Dd*f**2*gd2*s + 2244*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r**2 + 14784*D1*Dd*f*fd*g2*r*s - 10824*D1*Dd*f*fd*g2*r + 5280*D1*Dd*f*fd*g2*s**2 - 8184*D1*Dd*f*fd*g2*s + 3036*D1*Dd*f*fd*g2 - 1548*D1*Ddd*f**4*r**2 - 3176*D1*Ddd*f**4*r*s + 2362*D1*Ddd*f**4*r - 1628*D1*Ddd*f**4*s**2 + 2422*D1*Ddd*f**4*s - 1201*D1*Ddd*f**4 + 2376*D1*Ddd*f**2*g2*r**2 + 3696*D1*Ddd*f**2*g2*r*s - 3036*D1*Ddd*f**2*g2*r + 1320*D1*Ddd*f**2*g2*s**2 - 2244*D1*Ddd*f**2*g2*s + 1254*D1*Ddd*f**2*g2 - 4644*Dd**2*f**4*r**2 - 9528*Dd**2*f**4*r*s + 7086*Dd**2*f**4*r - 4884*Dd**2*f**4*s**2 + 7266*Dd**2*f**4*s - 2402*Dd**2*f**4 + 7128*Dd**2*f**2*g2*r**2 + 11088*Dd**2*f**2*g2*r*s - 9108*Dd**2*f**2*g2*r + 3960*Dd**2*f**2*g2*s**2 - 6732*Dd**2*f**2*g2*s + 2508*Dd**2*f**2*g2 + 1155*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(126*D1**2*K*fd*r**2 + 196*D1**2*K*fd*r*s + 70*D1**2*K*fd*s**2 - 63*D1**2*K*fdd*r**2 - 98*D1**2*K*fdd*r*s - 35*D1**2*K*fdd*s**2 - 35*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 190*D1**2*f*fd*r**2 - 408*D1**2*f*fd*r*s + 244*D1**2*f*fd*r - 218*D1**2*f*fd*s**2 + 258*D1**2*f*fd*s - 129*D1**2*f*fd + 158*D1**2*f*fdd*r**2 + 344*D1**2*f*fdd*r*s - 192*D1**2*f*fdd*r + 186*D1**2*f*fdd*s**2 - 206*D1**2*f*fdd*s + 103*D1**2*f*fdd + 158*D1**2*fd**2*r**2 + 344*D1**2*fd**2*r*s - 192*D1**2*fd**2*r + 186*D1**2*fd**2*s**2 - 206*D1**2*fd**2*s + 20*D1**2*fd**2 - 28*D1**2*fd*r**2 - 28*D1**2*fd*r*s + 14*D1**2*fdd*r**2 + 14*D1**2*fdd*r*s + 504*D1*Dd*K*f*r**2 + 784*D1*Dd*K*f*r*s - 644*D1*Dd*K*f*r + 280*D1*Dd*K*f*s**2 - 476*D1*Dd*K*f*s + 266*D1*Dd*K*f - 504*D1*Dd*K*fd*r**2 - 784*D1*Dd*K*fd*r*s + 322*D1*Dd*K*fd*r - 280*D1*Dd*K*fd*s**2 + 238*D1*Dd*K*fd*s - 380*D1*Dd*f**2*r**2 - 816*D1*Dd*f**2*r*s + 598*D1*Dd*f**2*r - 436*D1*Dd*f**2*s**2 + 640*D1*Dd*f**2*s - 313*D1*Dd*f**2 + 1264*D1*Dd*f*fd*r**2 + 2752*D1*Dd*f*fd*r*s - 1772*D1*Dd*f*fd*r + 1488*D1*Dd*f*fd*s**2 - 1912*D1*Dd*f*fd*s + 604*D1*Dd*f*fd - 112*D1*Dd*f*r**2 - 112*D1*Dd*f*r*s + 112*D1*Dd*f*r + 28*D1*Dd*f*s - 28*D1*Dd*f + 112*D1*Dd*fd*r**2 + 112*D1*Dd*fd*r*s - 56*D1*Dd*fd*r - 14*D1*Dd*fd*s - 252*D1*Ddd*K*f*r**2 - 392*D1*Ddd*K*f*r*s + 322*D1*Ddd*K*f*r - 140*D1*Ddd*K*f*s**2 + 238*D1*Ddd*K*f*s - 133*D1*Ddd*K*f + 316*D1*Ddd*f**2*r**2 + 688*D1*Ddd*f**2*r*s - 502*D1*Ddd*f**2*r + 372*D1*Ddd*f**2*s**2 - 544*D1*Ddd*f**2*s + 265*D1*Ddd*f**2 + 56*D1*Ddd*f*r**2 + 56*D1*Ddd*f*r*s - 56*D1*Ddd*f*r - 14*D1*Ddd*f*s + 14*D1*Ddd*f + 70*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 756*Dd**2*K*f*r**2 - 1176*Dd**2*K*f*r*s + 966*Dd**2*K*f*r - 420*Dd**2*K*f*s**2 + 714*Dd**2*K*f*s - 266*Dd**2*K*f + 948*Dd**2*f**2*r**2 + 2064*Dd**2*f**2*r*s - 1506*Dd**2*f**2*r + 1116*Dd**2*f**2*s**2 - 1632*Dd**2*f**2*s + 530*Dd**2*f**2 + 168*Dd**2*f*r**2 + 168*Dd**2*f*r*s - 168*Dd**2*f*r - 42*Dd**2*f*s + 28*Dd**2*f) - 11*b1*(756*C*D1**2*f*fd*r**2 + 1176*C*D1**2*f*fd*r*s - 588*C*D1**2*f*fd*r + 420*C*D1**2*f*fd*s**2 - 420*C*D1**2*f*fd*s + 210*C*D1**2*f*fd + 1512*C*D1*Dd*f**2*r**2 + 2352*C*D1*Dd*f**2*r*s - 1932*C*D1*Dd*f**2*r + 840*C*D1*Dd*f**2*s**2 - 1428*C*D1*Dd*f**2*s + 798*C*D1*Dd*f**2 + 378*D1**2*K*bdd1*f*r**2 + 588*D1**2*K*bdd1*f*r*s - 672*D1**2*K*bdd1*f*r + 210*D1**2*K*bdd1*f*s**2 - 504*D1**2*K*bdd1*f*s + 294*D1**2*K*bdd1*f - 108*D1**2*K*f*fd*r**2 - 168*D1**2*K*f*fd*r*s + 108*D1**2*K*f*fd*r - 60*D1**2*K*f*fd*s**2 + 84*D1**2*K*f*fd*s - 54*D1**2*K*f*fd + 54*D1**2*K*f*fdd*r**2 + 84*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 42*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 54*D1**2*K*fd**2*r**2 + 84*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 42*D1**2*K*fd**2*s - 210*D1**2*b2*fd*r**2 - 420*D1**2*b2*fd*r*s - 210*D1**2*b2*fd*s**2 + 105*D1**2*b2*fdd*r**2 + 210*D1**2*b2*fdd*r*s + 105*D1**2*b2*fdd*s**2 + 210*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 474*D1**2*bdd1*f**2*r**2 - 1032*D1**2*bdd1*f**2*r*s + 930*D1**2*bdd1*f**2*r - 558*D1**2*bdd1*f**2*s**2 + 1014*D1**2*bdd1*f**2*s - 486*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*r**2 - 84*D1**2*bdd1*f*r*s + 126*D1**2*bdd1*f*r + 42*D1**2*bdd1*f*s - 42*D1**2*bdd1*f + 105*D1**2*bdd2*f*r**2 + 210*D1**2*bdd2*f*r*s - 210*D1**2*bdd2*f*r + 105*D1**2*bdd2*f*s**2 - 210*D1**2*bdd2*f*s + 105*D1**2*bdd2*f + 132*D1**2*f**2*fd*r**2 + 126*D1**2*f**2*fd*r*s - 166*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 - 74*D1**2*f**2*fd*s + 48*D1**2*f**2*fd - 39*D1**2*f**2*fdd*r**2 + 108*D1**2*f**2*fdd*r*s - 16*D1**2*f**2*fdd*r + 147*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 57*D1**2*f**2*fdd - 78*D1**2*f*fd**2*r**2 + 216*D1**2*f*fd**2*r*s - 32*D1**2*f*fd**2*r + 294*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s + 12*D1**2*f*fd**2 - 438*D1**2*f*fd*r**2 - 648*D1**2*f*fd*r*s + 312*D1**2*f*fd*r - 210*D1**2*f*fd*s**2 + 198*D1**2*f*fd*s - 93*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r + 6*D1**2*f*fdd*s - 6*D1**2*f*fdd + 756*D1**2*f*gd2*r**2 + 1176*D1**2*f*gd2*r*s - 1176*D1**2*f*gd2*r + 420*D1**2*f*gd2*s**2 - 840*D1**2*f*gd2*s + 420*D1**2*f*gd2 - 378*D1**2*f*gdd2*r**2 - 588*D1**2*f*gdd2*r*s + 588*D1**2*f*gdd2*r - 210*D1**2*f*gdd2*s**2 + 420*D1**2*f*gdd2*s - 210*D1**2*f*gdd2 - 12*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 12*D1**2*fd**2*r + 6*D1**2*fd**2*s + 756*D1**2*fd*g2*r**2 + 1176*D1**2*fd*g2*r*s + 420*D1**2*fd*g2*s**2 - 756*D1**2*fd*gd2*r**2 - 1176*D1**2*fd*gd2*r*s + 588*D1**2*fd*gd2*r - 420*D1**2*fd*gd2*s**2 + 420*D1**2*fd*gd2*s - 378*D1**2*fdd*g2*r**2 - 588*D1**2*fdd*g2*r*s - 210*D1**2*fdd*g2*s**2 - 216*D1*Dd*K*f**2*r**2 - 336*D1*Dd*K*f**2*r*s + 276*D1*Dd*K*f**2*r - 120*D1*Dd*K*f**2*s**2 + 204*D1*Dd*K*f**2*s - 114*D1*Dd*K*f**2 + 432*D1*Dd*K*f*fd*r**2 + 672*D1*Dd*K*f*fd*r*s - 492*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 372*D1*Dd*K*f*fd*s + 138*D1*Dd*K*f*fd - 840*D1*Dd*b2*f*r**2 - 1680*D1*Dd*b2*f*r*s + 1260*D1*Dd*b2*f*r - 840*D1*Dd*b2*f*s**2 + 1260*D1*Dd*b2*f*s - 630*D1*Dd*b2*f + 840*D1*Dd*b2*fd*r**2 + 1680*D1*Dd*b2*fd*r*s - 630*D1*Dd*b2*fd*r + 840*D1*Dd*b2*fd*s**2 - 630*D1*Dd*b2*fd*s + 176*D1*Dd*f**3*r**2 + 168*D1*Dd*f**3*r*s - 172*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 - 34*D1*Dd*f**3*s + 40*D1*Dd*f**3 - 312*D1*Dd*f**2*fd*r**2 + 864*D1*Dd*f**2*fd*r*s - 202*D1*Dd*f**2*fd*r + 1176*D1*Dd*f**2*fd*s**2 - 1256*D1*Dd*f**2*fd*s + 296*D1*Dd*f**2*fd - 876*D1*Dd*f**2*r**2 - 1296*D1*Dd*f**2*r*s + 1086*D1*Dd*f**2*r - 420*D1*Dd*f**2*s**2 + 744*D1*Dd*f**2*s - 429*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 96*D1*Dd*f*fd*r + 36*D1*Dd*f*fd*s - 24*D1*Dd*f*fd + 3024*D1*Dd*f*g2*r**2 + 4704*D1*Dd*f*g2*r*s - 3864*D1*Dd*f*g2*r + 1680*D1*Dd*f*g2*s**2 - 2856*D1*Dd*f*g2*s + 1596*D1*Dd*f*g2 - 3024*D1*Dd*f*gd2*r**2 - 4704*D1*Dd*f*gd2*r*s + 4284*D1*Dd*f*gd2*r - 1680*D1*Dd*f*gd2*s**2 + 3108*D1*Dd*f*gd2*s - 1428*D1*Dd*f*gd2 - 3024*D1*Dd*fd*g2*r**2 - 4704*D1*Dd*fd*g2*r*s + 1932*D1*Dd*fd*g2*r - 1680*D1*Dd*fd*g2*s**2 + 1428*D1*Dd*fd*g2*s + 108*D1*Ddd*K*f**2*r**2 + 168*D1*Ddd*K*f**2*r*s - 138*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 102*D1*Ddd*K*f**2*s + 57*D1*Ddd*K*f**2 + 420*D1*Ddd*b2*f*r**2 + 840*D1*Ddd*b2*f*r*s - 630*D1*Ddd*b2*f*r + 420*D1*Ddd*b2*f*s**2 - 630*D1*Ddd*b2*f*s + 315*D1*Ddd*b2*f - 52*D1*Ddd*f**3*r**2 + 144*D1*Ddd*f**3*r*s - 46*D1*Ddd*f**3*r + 196*D1*Ddd*f**3*s**2 - 232*D1*Ddd*f**3*s + 85*D1*Ddd*f**3 - 24*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r + 6*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 - 1512*D1*Ddd*f*g2*r**2 - 2352*D1*Ddd*f*g2*r*s + 1932*D1*Ddd*f*g2*r - 840*D1*Ddd*f*g2*s**2 + 1428*D1*Ddd*f*g2*s - 798*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(f**2*(95*r**2 + 3*r*(68*s - 59) + 109*s**2 - 191*s + 92) - f*(fd*(316*r**2 + r*(688*s - 502) + 372*s**2 - 544*s + 179) + (14*r + 14*s - 14)*(K*(9*r + 5*s - 7) - 2*r + 1)) + 7*fd*(2*K*s*(5*s - 6) + r**2*(18*K - 4) + r*(4*K*(7*s - 4) - 4*s + 3) + s)) + Dd*f*(14*K*(36*r**2 + 56*r*s - 55*r + 20*s**2 - 41*s + 20) - f*(632*r**2 + 2*r*(688*s - 561) + 744*s**2 - 1220*s + 493) - 112*r**2 - 112*r*s + 140*r + 42*s - 35)) - 210*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 324*Dd**2*K*f**2*r**2 + 504*Dd**2*K*f**2*r*s - 414*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 306*Dd**2*K*f**2*s + 114*Dd**2*K*f**2 + 1260*Dd**2*b2*f*r**2 + 2520*Dd**2*b2*f*r*s - 1890*Dd**2*b2*f*r + 1260*Dd**2*b2*f*s**2 - 1890*Dd**2*b2*f*s + 630*Dd**2*b2*f - 156*Dd**2*f**3*r**2 + 432*Dd**2*f**3*r*s - 138*Dd**2*f**3*r + 588*Dd**2*f**3*s**2 - 696*Dd**2*f**3*s + 170*Dd**2*f**3 - 72*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 72*Dd**2*f**2*r + 18*Dd**2*f**2*s - 12*Dd**2*f**2 - 4536*Dd**2*f*g2*r**2 - 7056*Dd**2*f*g2*r*s + 5796*Dd**2*f*g2*r - 2520*Dd**2*f*g2*s**2 + 4284*Dd**2*f*g2*s - 1596*Dd**2*f*g2) + 165*b2*(-7*D1**2*bdd1*f*(r + s - 1)**2 + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd*s - 6*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2))/(2310*d**2*k3**5) - D1**2*Pk1*Pkd3*k2**2*st**6*(4*C - 2)*(9*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-9*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 9*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(63*d**2*k3**3) + D1**2*Pk1*Pkd3*k2**2*st**4*(-7*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)*(2*C*(5*r + s - 1) - 7*r - s + 1) + D1*(2*Dd*(f*(2*C*(20*r**2 + r*(24*s - 22) + 4*s**2 - 10*s + 7) - 28*r**2 + r*(30 - 32*s) - (3 - 2*s)**2) + fd*(-2*C*(20*r**2 + r*(24*s - 23) + 4*s**2 - 9*s + 5) + 28*r**2 + r*(32*s - 31) + 4*s**2 - 10*s + 6)) + Ddd*f*(-2*C*(20*r**2 + r*(24*s - 22) + 4*s**2 - 10*s + 7) + 28*r**2 + r*(32*s - 30) + (3 - 2*s)**2)) - 2*Dd**2*f*(2*C*(30*r**2 + r*(36*s - 33) + 6*s**2 - 15*s + 7) - 42*r**2 - 3*r*(16*s - 15) - 6*s**2 + 18*s - 9)) + b1*(44*C*D1**2*f*fd*r**2 + 344*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*r + 300*C*D1**2*f*fd*s**2 - 276*C*D1**2*f*fd*s + 130*C*D1**2*f*fd - 120*C*D1**2*f*fdd*r**2 - 368*C*D1**2*f*fdd*r*s + 164*C*D1**2*f*fdd*r - 248*C*D1**2*f*fdd*s**2 + 236*C*D1**2*f*fdd*s - 114*C*D1**2*f*fdd - 120*C*D1**2*fd**2*r**2 - 368*C*D1**2*fd**2*r*s + 164*C*D1**2*fd**2*r - 248*C*D1**2*fd**2*s**2 + 236*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 + 88*C*D1*Dd*f**2*r**2 + 688*C*D1*Dd*f**2*r*s - 388*C*D1*Dd*f**2*r + 600*C*D1*Dd*f**2*s**2 - 772*C*D1*Dd*f**2*s + 322*C*D1*Dd*f**2 - 960*C*D1*Dd*f*fd*r**2 - 2944*C*D1*Dd*f*fd*r*s + 1632*C*D1*Dd*f*fd*r - 1984*C*D1*Dd*f*fd*s**2 + 2304*C*D1*Dd*f*fd*s - 636*C*D1*Dd*f*fd - 240*C*D1*Ddd*f**2*r**2 - 736*C*D1*Ddd*f**2*r*s + 488*C*D1*Ddd*f**2*r - 496*C*D1*Ddd*f**2*s**2 + 680*C*D1*Ddd*f**2*s - 308*C*D1*Ddd*f**2 - 720*C*Dd**2*f**2*r**2 - 2208*C*Dd**2*f**2*r*s + 1464*C*Dd**2*f**2*r - 1488*C*Dd**2*f**2*s**2 + 2040*C*Dd**2*f**2*s - 616*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(2*C*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) - 14*r**2 - 16*r*s + 14*r - 2*s**2 + 8*s - 7) - 38*D1**2*f*fd*r**2 - 184*D1**2*f*fd*r*s + 64*D1**2*f*fd*r - 146*D1**2*f*fd*s**2 + 130*D1**2*f*fd*s - 59*D1**2*f*fd + 68*D1**2*f*fdd*r**2 + 204*D1**2*f*fdd*r*s - 88*D1**2*f*fdd*r + 136*D1**2*f*fdd*s**2 - 128*D1**2*f*fdd*s + 61*D1**2*f*fdd + 68*D1**2*fd**2*r**2 + 204*D1**2*fd**2*r*s - 88*D1**2*fd**2*r + 136*D1**2*fd**2*s**2 - 128*D1**2*fd**2*s - 8*D1**2*fd**2 - 76*D1*Dd*f**2*r**2 - 368*D1*Dd*f**2*r*s + 222*D1*Dd*f**2*r - 292*D1*Dd*f**2*s**2 + 384*D1*Dd*f**2*s - 165*D1*Dd*f**2 + 544*D1*Dd*f*fd*r**2 + 1632*D1*Dd*f*fd*r*s - 896*D1*Dd*f*fd*r + 1088*D1*Dd*f*fd*s**2 - 1260*D1*Dd*f*fd*s + 344*D1*Dd*f*fd + 136*D1*Ddd*f**2*r**2 + 408*D1*Ddd*f**2*r*s - 272*D1*Ddd*f**2*r + 272*D1*Ddd*f**2*s**2 - 374*D1*Ddd*f**2*s + 170*D1*Ddd*f**2 - 14*D1*bd1*(D1*(f*(2*C*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) - 14*r**2 - 16*r*s + 14*r - 2*s**2 + 8*s - 7) + fd*(-2*C*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + 14*r**2 + 16*r*s - 15*r + 2*s**2 - 6*s + 4)) + Dd*f*(-2*C*(40*r**2 + 6*r*(8*s - 7) + 8*s**2 - 22*s + 11) + 56*r**2 + 64*r*s - 58*r + 8*s**2 - 28*s + 15)) + 408*Dd**2*f**2*r**2 + 1224*Dd**2*f**2*r*s - 816*Dd**2*f**2*r + 816*Dd**2*f**2*s**2 - 1122*Dd**2*f**2*s + 340*Dd**2*f**2) + f*(66*C*D1**2*f*fd*r**2 + 132*C*D1**2*f*fd*r*s - 88*C*D1**2*f*fd*r + 66*C*D1**2*f*fd*s**2 - 88*C*D1**2*f*fd*s + 44*C*D1**2*f*fd - 78*C*D1**2*f*fdd*r**2 - 132*C*D1**2*f*fdd*r*s + 96*C*D1**2*f*fdd*r - 54*C*D1**2*f*fdd*s**2 + 80*C*D1**2*f*fdd*s - 44*C*D1**2*f*fdd - 156*C*D1**2*fd**2*r**2 - 264*C*D1**2*fd**2*r*s + 192*C*D1**2*fd**2*r - 108*C*D1**2*fd**2*s**2 + 160*C*D1**2*fd**2*s - 44*C*D1**2*fd**2 + 88*C*D1*Dd*f**2*r**2 + 176*C*D1*Dd*f**2*r*s - 132*C*D1*Dd*f**2*r + 88*C*D1*Dd*f**2*s**2 - 132*C*D1*Dd*f**2*s + 66*C*D1*Dd*f**2 - 624*C*D1*Dd*f*fd*r**2 - 1056*C*D1*Dd*f*fd*r*s + 804*C*D1*Dd*f*fd*r - 432*C*D1*Dd*f*fd*s**2 + 668*C*D1*Dd*f*fd*s - 256*C*D1*Dd*f*fd - 104*C*D1*Ddd*f**2*r**2 - 176*C*D1*Ddd*f**2*r*s + 140*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 116*C*D1*Ddd*f**2*s - 62*C*D1*Ddd*f**2 - 312*C*Dd**2*f**2*r**2 - 528*C*Dd**2*f**2*r*s + 420*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 348*C*Dd**2*f**2*s - 124*C*Dd**2*f**2 + 14*D1**2*bd1**2*(r**2*(10*C - 7) + r*(2*C*(6*s - 5) - 8*s + 7) + s*(2*C*(s - 3) - s + 4)) + D1**2*bdd1*f*(-2*C*(30*r**2 + r*(92*s - 70) + 62*s**2 - 98*s + 35) + 34*r**2 + 2*r*(51*s - 41) + 68*s**2 - 110*s + 41) - 45*D1**2*f*fd*r**2 - 84*D1**2*f*fd*r*s + 58*D1**2*f*fd*r - 39*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s - 28*D1**2*f*fd + 45*D1**2*f*fdd*r**2 + 78*D1**2*f*fdd*r*s - 56*D1**2*f*fdd*r + 33*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 26*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 156*D1**2*fd**2*r*s - 112*D1**2*fd**2*r + 66*D1**2*fd**2*s**2 - 96*D1**2*fd**2*s + 26*D1**2*fd**2 - 60*D1*Dd*f**2*r**2 - 112*D1*Dd*f**2*r*s + 86*D1*Dd*f**2*r - 52*D1*Dd*f**2*s**2 + 80*D1*Dd*f**2*s - 41*D1*Dd*f**2 + 360*D1*Dd*f*fd*r**2 + 624*D1*Dd*f*fd*r*s - 470*D1*Dd*f*fd*r + 264*D1*Dd*f*fd*s**2 - 402*D1*Dd*f*fd*s + 152*D1*Dd*f*fd + 60*D1*Ddd*f**2*r**2 + 104*D1*Ddd*f**2*r*s - 82*D1*Ddd*f**2*r + 44*D1*Ddd*f**2*s**2 - 70*D1*Ddd*f**2*s + 37*D1*Ddd*f**2 + D1*bd1*(D1*(f*(2*C*(11*r**2 + r*(86*s - 42) + 75*s**2 - 98*s + 21) - 19*r**2 + r*(66 - 92*s) - 73*s**2 + 108*s - 33) + 2*fd*(-2*C*(60*r**2 + r*(184*s - 111) + 124*s**2 - 157*s + 49) + 68*r**2 + 6*r*(34*s - 21) + 136*s**2 - 174*s + 55)) + 2*Dd*f*(-2*C*(120*r**2 + r*(368*s - 262) + 248*s**2 - 366*s + 133) + 136*r**2 + 12*r*(34*s - 25) + 272*s**2 - 407*s + 151)) + 180*Dd**2*f**2*r**2 + 312*Dd**2*f**2*r*s - 246*Dd**2*f**2*r + 132*Dd**2*f**2*s**2 - 210*Dd**2*f**2*s + 74*Dd**2*f**2))/(70*d**2*k3**3) + D1**2*Pk1*Pkd3*k2**2*st**2*(210*C*D1**2*bd1*f**2*r**2 + 252*C*D1**2*bd1*f**2*r*s + 42*C*D1**2*bd1*f**2*s**2 - 840*D1**2*K*bd1**2*f*r**2 - 1848*D1**2*K*bd1**2*f*r*s + 1974*D1**2*K*bd1**2*f*r - 1008*D1**2*K*bd1**2*f*s**2 + 2058*D1**2*K*bd1**2*f*s - 1050*D1**2*K*bd1**2*f + 183*D1**2*K*bd1*f**2*r**2 + 246*D1**2*K*bd1*f**2*r*s - 246*D1**2*K*bd1*f**2*r + 63*D1**2*K*bd1*f**2*s**2 - 126*D1**2*K*bd1*f**2*s + 63*D1**2*K*bd1*f**2 - 996*D1**2*K*bd1*f*fd*r**2 - 1416*D1**2*K*bd1*f*fd*r*s + 1206*D1**2*K*bd1*f*fd*r - 420*D1**2*K*bd1*f*fd*s**2 + 774*D1**2*K*bd1*f*fd*s - 354*D1**2*K*bd1*f*fd - 249*D1**2*K*bdd1*f**2*r**2 - 354*D1**2*K*bdd1*f**2*r*s + 354*D1**2*K*bdd1*f**2*r - 105*D1**2*K*bdd1*f**2*s**2 + 210*D1**2*K*bdd1*f**2*s - 105*D1**2*K*bdd1*f**2 + 240*D1**2*bd1**2*f**2*r**2 + 1128*D1**2*bd1**2*f**2*r*s - 858*D1**2*bd1**2*f**2*r + 888*D1**2*bd1**2*f**2*s**2 - 1290*D1**2*bd1**2*f**2*s + 564*D1**2*bd1**2*f**2 + 168*D1**2*bd1**2*f*r**2 + 420*D1**2*bd1**2*f*r*s - 462*D1**2*bd1**2*f*r + 252*D1**2*bd1**2*f*s**2 - 504*D1**2*bd1**2*f*s + 252*D1**2*bd1**2*f - 2100*D1**2*bd1**2*g2*r**2 - 2520*D1**2*bd1**2*g2*r*s + 2100*D1**2*bd1**2*g2*r - 420*D1**2*bd1**2*g2*s**2 + 1260*D1**2*bd1**2*g2*s - 1008*D1**2*bd1*bd2*f*r**2 - 2016*D1**2*bd1*bd2*f*r*s + 2058*D1**2*bd1*bd2*f*r - 1008*D1**2*bd1*bd2*f*s**2 + 2058*D1**2*bd1*bd2*f*s - 1050*D1**2*bd1*bd2*f - 175*D1**2*bd1*f**3*r**2 - 364*D1**2*bd1*f**3*r*s + 228*D1**2*bd1*f**3*r - 189*D1**2*bd1*f**3*s**2 + 216*D1**2*bd1*f**3*s - 108*D1**2*bd1*f**3 + 1038*D1**2*bd1*f**2*fd*r**2 + 2496*D1**2*bd1*f**2*fd*r*s - 1730*D1**2*bd1*f**2*fd*r + 1458*D1**2*bd1*f**2*fd*s**2 - 1964*D1**2*bd1*f**2*fd*s + 564*D1**2*bd1*f**2*fd - 213*D1**2*bd1*f**2*r**2 - 300*D1**2*bd1*f**2*r*s + 90*D1**2*bd1*f**2*r - 87*D1**2*bd1*f**2*s**2 + 90*D1**2*bd1*f**2*s - 24*D1**2*bd1*f**2 + 216*D1**2*bd1*f*fd*r**2 + 432*D1**2*bd1*f*fd*r*s - 324*D1**2*bd1*f*fd*r + 216*D1**2*bd1*f*fd*s**2 - 324*D1**2*bd1*f*fd*s + 108*D1**2*bd1*f*fd - 210*D1**2*bd1*f*g2*r**2 - 756*D1**2*bd1*f*g2*r*s + 1260*D1**2*bd1*f*g2*r - 546*D1**2*bd1*f*g2*s**2 + 1260*D1**2*bd1*f*g2*s - 630*D1**2*bd1*f*g2 + 1680*D1**2*bd1*f*gd2*r**2 + 3696*D1**2*bd1*f*gd2*r*s - 3948*D1**2*bd1*f*gd2*r + 2016*D1**2*bd1*f*gd2*s**2 - 4116*D1**2*bd1*f*gd2*s + 2100*D1**2*bd1*f*gd2 + 1680*D1**2*bd1*fd*g2*r**2 + 3696*D1**2*bd1*fd*g2*r*s - 1680*D1**2*bd1*fd*g2*r + 2016*D1**2*bd1*fd*g2*s**2 - 1848*D1**2*bd1*fd*g2*s + 183*D1**2*bd2*f**2*r**2 + 246*D1**2*bd2*f**2*r*s - 246*D1**2*bd2*f**2*r + 63*D1**2*bd2*f**2*s**2 - 126*D1**2*bd2*f**2*s + 63*D1**2*bd2*f**2 - 996*D1**2*bd2*f*fd*r**2 - 1416*D1**2*bd2*f*fd*r*s + 1206*D1**2*bd2*f*fd*r - 420*D1**2*bd2*f*fd*s**2 + 774*D1**2*bd2*f*fd*s - 354*D1**2*bd2*f*fd + 173*D1**2*bdd1*f**3*r**2 + 416*D1**2*bdd1*f**3*r*s - 276*D1**2*bdd1*f**3*r + 243*D1**2*bdd1*f**3*s**2 - 288*D1**2*bdd1*f**3*s + 144*D1**2*bdd1*f**3 + 54*D1**2*bdd1*f**2*r**2 + 108*D1**2*bdd1*f**2*r*s - 108*D1**2*bdd1*f**2*r + 54*D1**2*bdd1*f**2*s**2 - 108*D1**2*bdd1*f**2*s + 54*D1**2*bdd1*f**2 + 840*D1**2*bdd1*f*g2*r**2 + 1848*D1**2*bdd1*f*g2*r*s - 2100*D1**2*bdd1*f*g2*r + 1008*D1**2*bdd1*f*g2*s**2 - 2100*D1**2*bdd1*f*g2*s + 1050*D1**2*bdd1*f*g2 - 249*D1**2*bdd2*f**2*r**2 - 354*D1**2*bdd2*f**2*r*s + 354*D1**2*bdd2*f**2*r - 105*D1**2*bdd2*f**2*s**2 + 210*D1**2*bdd2*f**2*s - 105*D1**2*bdd2*f**2 + 54*D1**2*f**2*fd*r**2 + 54*D1**2*f**2*fd*r*s - 54*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s + 18*D1**2*f**2*fd - 366*D1**2*f**2*gd2*r**2 - 492*D1**2*f**2*gd2*r*s + 492*D1**2*f**2*gd2*r - 126*D1**2*f**2*gd2*s**2 + 252*D1**2*f**2*gd2*s - 126*D1**2*f**2*gd2 + 498*D1**2*f**2*gdd2*r**2 + 708*D1**2*f**2*gdd2*r*s - 708*D1**2*f**2*gdd2*r + 210*D1**2*f**2*gdd2*s**2 - 420*D1**2*f**2*gdd2*s + 210*D1**2*f**2*gdd2 - 732*D1**2*f*fd*g2*r**2 - 984*D1**2*f*fd*g2*r*s + 732*D1**2*f*fd*g2*r - 252*D1**2*f*fd*g2*s**2 + 492*D1**2*f*fd*g2*s - 366*D1**2*f*fd*g2 + 1992*D1**2*f*fd*gd2*r**2 + 2832*D1**2*f*fd*gd2*r*s - 2412*D1**2*f*fd*gd2*r + 840*D1**2*f*fd*gd2*s**2 - 1548*D1**2*f*fd*gd2*s + 708*D1**2*f*fd*gd2 + 996*D1**2*f*fdd*g2*r**2 + 1416*D1**2*f*fdd*g2*r*s - 996*D1**2*f*fdd*g2*r + 420*D1**2*f*fdd*g2*s**2 - 708*D1**2*f*fdd*g2*s + 498*D1**2*f*fdd*g2 + 996*D1**2*fd**2*g2*r**2 + 1416*D1**2*fd**2*g2*r*s - 996*D1**2*fd**2*g2*r + 420*D1**2*fd**2*g2*s**2 - 708*D1**2*fd**2*g2*s - 1992*D1*Dd*K*bd1*f**2*r**2 - 2832*D1*Dd*K*bd1*f**2*r*s + 2622*D1*Dd*K*bd1*f**2*r - 840*D1*Dd*K*bd1*f**2*s**2 + 1614*D1*Dd*K*bd1*f**2*s - 774*D1*Dd*K*bd1*f**2 + 1384*D1*Dd*bd1*f**3*r**2 + 3328*D1*Dd*bd1*f**3*r*s - 2282*D1*Dd*bd1*f**3*r + 1944*D1*Dd*bd1*f**3*s**2 - 2540*D1*Dd*bd1*f**3*s + 852*D1*Dd*bd1*f**3 + 432*D1*Dd*bd1*f**2*r**2 + 864*D1*Dd*bd1*f**2*r*s - 756*D1*Dd*bd1*f**2*r + 432*D1*Dd*bd1*f**2*s**2 - 756*D1*Dd*bd1*f**2*s + 324*D1*Dd*bd1*f**2 + 6720*D1*Dd*bd1*f*g2*r**2 + 14784*D1*Dd*bd1*f*g2*r*s - 13776*D1*Dd*bd1*f*g2*r + 8064*D1*Dd*bd1*f*g2*s**2 - 14280*D1*Dd*bd1*f*g2*s + 6300*D1*Dd*bd1*f*g2 - 1992*D1*Dd*bd2*f**2*r**2 - 2832*D1*Dd*bd2*f**2*r*s + 2622*D1*Dd*bd2*f**2*r - 840*D1*Dd*bd2*f**2*s**2 + 1614*D1*Dd*bd2*f**2*s - 774*D1*Dd*bd2*f**2 + 72*D1*Dd*f**3*r**2 + 72*D1*Dd*f**3*r*s - 72*D1*Dd*f**3*r - 18*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 1464*D1*Dd*f**2*g2*r**2 - 1968*D1*Dd*f**2*g2*r*s + 1716*D1*Dd*f**2*g2*r - 504*D1*Dd*f**2*g2*s**2 + 996*D1*Dd*f**2*g2*s - 618*D1*Dd*f**2*g2 + 3984*D1*Dd*f**2*gd2*r**2 + 5664*D1*Dd*f**2*gd2*r*s - 5244*D1*Dd*f**2*gd2*r + 1680*D1*Dd*f**2*gd2*s**2 - 3228*D1*Dd*f**2*gd2*s + 1548*D1*Dd*f**2*gd2 + 7968*D1*Dd*f*fd*g2*r**2 + 11328*D1*Dd*f*fd*g2*r*s - 8808*D1*Dd*f*fd*g2*r + 3360*D1*Dd*f*fd*g2*s**2 - 5928*D1*Dd*f*fd*g2*s + 2412*D1*Dd*f*fd*g2 + 1992*D1*Ddd*f**2*g2*r**2 + 2832*D1*Ddd*f**2*g2*r*s - 2412*D1*Ddd*f**2*g2*r + 840*D1*Ddd*f**2*g2*s**2 - 1548*D1*Ddd*f**2*g2*s + 918*D1*Ddd*f**2*g2 + 5976*Dd**2*f**2*g2*r**2 + 8496*Dd**2*f**2*g2*r*s - 7236*Dd**2*f**2*g2*r + 2520*Dd**2*f**2*g2*s**2 - 4644*Dd**2*f**2*g2*s + 1836*Dd**2*f**2*g2 + 21*b1**3*(D1**2*(r + s - 1)*(9*fd*r + 19*fd*(s - 1) + fdd*(-17*r - 27*s + 27)) + D1*(Dd*f*(36*r**2 + 2*r*(56*s - 37) + 76*s**2 - 104*s + 47) - 2*Dd*(5*K*(20*r**2 + 24*r*s - 22*r + 4*s**2 - 10*s + 7) + fd*(68*r**2 + 176*r*s - 149*r + 108*s**2 - 184*s + 76) - 40*r**2 - 40*r*s + 40*r + 10*s - 10) - Ddd*f*(68*r**2 + 2*r*(88*s - 61) + 108*s**2 - 152*s + 71) + 5*Ddd*(K*(20*r**2 + r*(24*s - 22) + 4*s**2 - 10*s + 7) - 8*r**2 - 8*r*s + 8*r + 2*s - 2)) - 2*Dd**2*(-5*K*(30*r**2 + r*(36*s - 33) + 6*s**2 - 15*s + 7) + f*(102*r**2 + 3*r*(88*s - 61) + 162*s**2 - 228*s + 71) + 60*r**2 + 60*r*(s - 1) - 15*s + 10)) + 3*b1**2*(350*C*D1**2*fd*r**2 + 420*C*D1**2*fd*r*s - 420*C*D1**2*fd*r + 70*C*D1**2*fd*s**2 - 140*C*D1**2*fd*s + 70*C*D1**2*fd + 1400*C*D1*Dd*f*r**2 + 1680*C*D1*Dd*f*r*s - 1540*C*D1*Dd*f*r + 280*C*D1*Dd*f*s**2 - 700*C*D1*Dd*f*s + 490*C*D1*Dd*f + 525*D1**2*K*bdd1*r**2 + 630*D1**2*K*bdd1*r*s - 560*D1**2*K*bdd1*r + 105*D1**2*K*bdd1*s**2 - 280*D1**2*K*bdd1*s + 210*D1**2*K*bdd1 + 35*D1**2*K*fd*r**2 + 126*D1**2*K*fd*r*s + 140*D1**2*K*fd*r + 91*D1**2*K*fd*s**2 + 84*D1**2*K*fd*s - 70*D1**2*K*fd - 140*D1**2*K*fdd*r**2 - 308*D1**2*K*fdd*r*s - 70*D1**2*K*fdd*r - 168*D1**2*K*fdd*s**2 - 42*D1**2*K*fdd*s + 35*D1**2*K*fdd - 357*D1**2*bdd1*f*r**2 - 924*D1**2*bdd1*f*r*s + 546*D1**2*bdd1*f*r - 567*D1**2*bdd1*f*s**2 + 686*D1**2*bdd1*f*s - 308*D1**2*bdd1*f - 210*D1**2*bdd1*r**2 - 210*D1**2*bdd1*r*s + 210*D1**2*bdd1*r + 70*D1**2*bdd1*s - 70*D1**2*bdd1 + 35*D1**2*bdd2*r**2 + 70*D1**2*bdd2*r*s - 70*D1**2*bdd2*r + 35*D1**2*bdd2*s**2 - 70*D1**2*bdd2*s + 35*D1**2*bdd2 - 76*D1**2*f*fd*r**2 - 304*D1**2*f*fd*r*s + 130*D1**2*f*fd*r - 228*D1**2*f*fd*s**2 + 266*D1**2*f*fd*s - 122*D1**2*f*fd + 80*D1**2*f*fdd*r**2 + 376*D1**2*f*fdd*r*s - 170*D1**2*f*fdd*r + 296*D1**2*f*fdd*s**2 - 350*D1**2*f*fdd*s + 166*D1**2*f*fdd + 80*D1**2*fd**2*r**2 + 376*D1**2*fd**2*r*s - 170*D1**2*fd**2*r + 296*D1**2*fd**2*s**2 - 350*D1**2*fd**2*s + 54*D1**2*fd**2 - 301*D1**2*fd*r**2 - 350*D1**2*fd*r*s + 224*D1**2*fd*r - 49*D1**2*fd*s**2 + 42*D1**2*fd*s - 7*D1**2*fd + 28*D1**2*fdd*r**2 + 70*D1**2*fdd*r*s + 28*D1**2*fdd*r + 42*D1**2*fdd*s**2 + 14*D1**2*fdd*s - 14*D1**2*fdd + 700*D1**2*gd2*r**2 + 840*D1**2*gd2*r*s - 840*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 350*D1**2*gdd2*r**2 - 420*D1**2*gdd2*r*s + 420*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 + 140*D1*Dd*K*f*r**2 + 504*D1*Dd*K*f*r*s - 322*D1*Dd*K*f*r + 364*D1*Dd*K*f*s**2 - 490*D1*Dd*K*f*s + 217*D1*Dd*K*f - 1120*D1*Dd*K*fd*r**2 - 2464*D1*Dd*K*fd*r*s + 616*D1*Dd*K*fd*r - 1344*D1*Dd*K*fd*s**2 + 812*D1*Dd*K*fd*s + 154*D1*Dd*K*fd - 280*D1*Dd*b2*r**2 - 560*D1*Dd*b2*r*s + 420*D1*Dd*b2*r - 280*D1*Dd*b2*s**2 + 420*D1*Dd*b2*s - 210*D1*Dd*b2 - 152*D1*Dd*f**2*r**2 - 608*D1*Dd*f**2*r*s + 380*D1*Dd*f**2*r - 456*D1*Dd*f**2*s**2 + 608*D1*Dd*f**2*s - 266*D1*Dd*f**2 + 640*D1*Dd*f*fd*r**2 + 3008*D1*Dd*f*fd*r*s - 1592*D1*Dd*f*fd*r + 2368*D1*Dd*f*fd*s**2 - 2960*D1*Dd*f*fd*s + 870*D1*Dd*f*fd - 1204*D1*Dd*f*r**2 - 1400*D1*Dd*f*r*s + 1302*D1*Dd*f*r - 196*D1*Dd*f*s**2 + 546*D1*Dd*f*s - 399*D1*Dd*f + 224*D1*Dd*fd*r**2 + 560*D1*Dd*fd*r*s - 84*D1*Dd*fd*r + 336*D1*Dd*fd*s**2 - 182*D1*Dd*fd*s - 56*D1*Dd*fd + 2800*D1*Dd*g2*r**2 + 3360*D1*Dd*g2*r*s - 3080*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 1400*D1*Dd*g2*s + 980*D1*Dd*g2 - 2800*D1*Dd*gd2*r**2 - 3360*D1*Dd*gd2*r*s + 3220*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 1260*D1*Dd*gd2*s - 700*D1*Dd*gd2 - 560*D1*Ddd*K*f*r**2 - 1232*D1*Ddd*K*f*r*s + 896*D1*Ddd*K*f*r - 672*D1*Ddd*K*f*s**2 + 980*D1*Ddd*K*f*s - 476*D1*Ddd*K*f + 140*D1*Ddd*b2*r**2 + 280*D1*Ddd*b2*r*s - 210*D1*Ddd*b2*r + 140*D1*Ddd*b2*s**2 - 210*D1*Ddd*b2*s + 105*D1*Ddd*b2 + 160*D1*Ddd*f**2*r**2 + 752*D1*Ddd*f**2*r*s - 456*D1*Ddd*f**2*r + 592*D1*Ddd*f**2*s**2 - 780*D1*Ddd*f**2*s + 336*D1*Ddd*f**2 + 112*D1*Ddd*f*r**2 + 280*D1*Ddd*f*r*s - 196*D1*Ddd*f*r + 168*D1*Ddd*f*s**2 - 238*D1*Ddd*f*s + 112*D1*Ddd*f - 1400*D1*Ddd*g2*r**2 - 1680*D1*Ddd*g2*r*s + 1540*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 700*D1*Ddd*g2*s - 490*D1*Ddd*g2 + 7*D1*bd1*(D1*f*(27*r**2 + r*(84*s - 46) + 57*s**2 - 66*s + 28) - 2*D1*(5*K*(15*r**2 + 2*r*(9*s - 8) + 3*s**2 - 8*s + 6) + fd*(51*r**2 + 3*r*(44*s - 35) + 81*s**2 - 130*s + 49) - 30*r**2 - 30*r*s + 30*r + 10*s - 10) - 2*Dd*f*(204*r**2 + r*(528*s - 339) + 324*s**2 - 424*s + 137) + 10*Dd*(K*(60*r**2 + r*(72*s - 65) + 12*s**2 - 31*s + 16) - 24*r**2 - 24*r*(s - 1) + 7*s - 5)) - 70*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 1680*Dd**2*K*f*r**2 - 3696*Dd**2*K*f*r*s + 2688*Dd**2*K*f*r - 2016*Dd**2*K*f*s**2 + 2940*Dd**2*K*f*s - 952*Dd**2*K*f + 420*Dd**2*b2*r**2 + 840*Dd**2*b2*r*s - 630*Dd**2*b2*r + 420*Dd**2*b2*s**2 - 630*Dd**2*b2*s + 210*Dd**2*b2 + 480*Dd**2*f**2*r**2 + 2256*Dd**2*f**2*r*s - 1368*Dd**2*f**2*r + 1776*Dd**2*f**2*s**2 - 2340*Dd**2*f**2*s + 672*Dd**2*f**2 + 336*Dd**2*f*r**2 + 840*Dd**2*f*r*s - 588*Dd**2*f*r + 504*Dd**2*f*s**2 - 714*Dd**2*f*s + 224*Dd**2*f - 4200*Dd**2*g2*r**2 - 5040*Dd**2*g2*r*s + 4620*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 2100*Dd**2*g2*s - 980*Dd**2*g2) + b1*(420*C*D1**2*f*fd*r**2 + 504*C*D1**2*f*fd*r*s - 672*C*D1**2*f*fd*r + 84*C*D1**2*f*fd*s**2 - 336*C*D1**2*f*fd*s + 252*C*D1**2*f*fd + 840*C*D1*Dd*f**2*r**2 + 1008*C*D1*Dd*f**2*r*s - 924*C*D1*Dd*f**2*r + 168*C*D1*Dd*f**2*s**2 - 420*C*D1*Dd*f**2*s + 294*C*D1*Dd*f**2 - 840*D1**2*K*bdd1*f*r**2 - 1848*D1**2*K*bdd1*f*r*s + 1974*D1**2*K*bdd1*f*r - 1008*D1**2*K*bdd1*f*s**2 + 2058*D1**2*K*bdd1*f*s - 1029*D1**2*K*bdd1*f + 366*D1**2*K*f*fd*r**2 + 492*D1**2*K*f*fd*r*s - 366*D1**2*K*f*fd*r + 126*D1**2*K*f*fd*s**2 - 246*D1**2*K*f*fd*s + 183*D1**2*K*f*fd - 498*D1**2*K*f*fdd*r**2 - 708*D1**2*K*f*fdd*r*s + 498*D1**2*K*f*fdd*r - 210*D1**2*K*f*fdd*s**2 + 354*D1**2*K*f*fdd*s - 249*D1**2*K*f*fdd - 498*D1**2*K*fd**2*r**2 - 708*D1**2*K*fd**2*r*s + 498*D1**2*K*fd**2*r - 210*D1**2*K*fd**2*s**2 + 354*D1**2*K*fd**2*s - 42*D1**2*bd1**2*(-5*K*(15*r**2 + 2*r*(9*s - 8) + 3*s**2 - 8*s + 3) + f*(51*r**2 + 6*r*(22*s - 13) + 81*s**2 - 98*s + 22) + 30*r**2 + 30*r*s - 30*r - 10*s + 5) + 273*D1**2*bd2*f*r**2 + 546*D1**2*bd2*f*r*s - 546*D1**2*bd2*f*r + 273*D1**2*bd2*f*s**2 - 546*D1**2*bd2*f*s + 273*D1**2*bd2*f - 1008*D1**2*bd2*fd*r**2 - 2016*D1**2*bd2*fd*r*s + 966*D1**2*bd2*fd*r - 1008*D1**2*bd2*fd*s**2 + 966*D1**2*bd2*fd*s + 42*D1**2*bd2*fd + 240*D1**2*bdd1*f**2*r**2 + 1128*D1**2*bdd1*f**2*r*s - 858*D1**2*bdd1*f**2*r + 888*D1**2*bdd1*f**2*s**2 - 1290*D1**2*bdd1*f**2*s + 510*D1**2*bdd1*f**2 + 168*D1**2*bdd1*f*r**2 + 420*D1**2*bdd1*f*r*s - 462*D1**2*bdd1*f*r + 252*D1**2*bdd1*f*s**2 - 504*D1**2*bdd1*f*s + 252*D1**2*bdd1*f - 2100*D1**2*bdd1*g2*r**2 - 2520*D1**2*bdd1*g2*r*s + 2100*D1**2*bdd1*g2*r - 420*D1**2*bdd1*g2*s**2 + 1260*D1**2*bdd1*g2*s - 1050*D1**2*bdd1*g2 - 504*D1**2*bdd2*f*r**2 - 1008*D1**2*bdd2*f*r*s + 1008*D1**2*bdd2*f*r - 504*D1**2*bdd2*f*s**2 + 1008*D1**2*bdd2*f*s - 504*D1**2*bdd2*f - 525*D1**2*f**2*fd*r**2 - 1092*D1**2*f**2*fd*r*s + 850*D1**2*f**2*fd*r - 567*D1**2*f**2*fd*s**2 + 904*D1**2*f**2*fd*s - 445*D1**2*f**2*fd + 519*D1**2*f**2*fdd*r**2 + 1248*D1**2*f**2*fdd*r*s - 902*D1**2*f**2*fdd*r + 729*D1**2*f**2*fdd*s**2 - 1100*D1**2*f**2*fdd*s + 515*D1**2*f**2*fdd + 1038*D1**2*f*fd**2*r**2 + 2496*D1**2*f*fd**2*r*s - 1804*D1**2*f*fd**2*r + 1458*D1**2*f*fd**2*s**2 - 2200*D1**2*f*fd**2*s + 754*D1**2*f*fd**2 - 426*D1**2*f*fd*r**2 - 600*D1**2*f*fd*r*s + 636*D1**2*f*fd*r - 174*D1**2*f*fd*s**2 + 384*D1**2*f*fd*s - 276*D1**2*f*fd + 108*D1**2*f*fdd*r**2 + 216*D1**2*f*fdd*r*s - 108*D1**2*f*fdd*r + 108*D1**2*f*fdd*s**2 - 108*D1**2*f*fdd*s + 54*D1**2*f*fdd - 210*D1**2*f*gd2*r**2 - 756*D1**2*f*gd2*r*s + 756*D1**2*f*gd2*r - 546*D1**2*f*gd2*s**2 + 1092*D1**2*f*gd2*s - 546*D1**2*f*gd2 + 840*D1**2*f*gdd2*r**2 + 1848*D1**2*f*gdd2*r*s - 1848*D1**2*f*gdd2*r + 1008*D1**2*f*gdd2*s**2 - 2016*D1**2*f*gdd2*s + 1008*D1**2*f*gdd2 + 108*D1**2*fd**2*r**2 + 216*D1**2*fd**2*r*s - 108*D1**2*fd**2*r + 108*D1**2*fd**2*s**2 - 108*D1**2*fd**2*s - 210*D1**2*fd*g2*r**2 - 756*D1**2*fd*g2*r*s - 840*D1**2*fd*g2*r - 546*D1**2*fd*g2*s**2 - 504*D1**2*fd*g2*s + 420*D1**2*fd*g2 + 1680*D1**2*fd*gd2*r**2 + 3696*D1**2*fd*gd2*r*s - 1428*D1**2*fd*gd2*r + 2016*D1**2*fd*gd2*s**2 - 1764*D1**2*fd*gd2*s - 252*D1**2*fd*gd2 + 840*D1**2*fdd*g2*r**2 + 1848*D1**2*fdd*g2*r*s + 420*D1**2*fdd*g2*r + 1008*D1**2*fdd*g2*s**2 + 252*D1**2*fdd*g2*s - 210*D1**2*fdd*g2 + 732*D1*Dd*K*f**2*r**2 + 984*D1*Dd*K*f**2*r*s - 858*D1*Dd*K*f**2*r + 252*D1*Dd*K*f**2*s**2 - 498*D1*Dd*K*f**2*s + 309*D1*Dd*K*f**2 - 3984*D1*Dd*K*f*fd*r**2 - 5664*D1*Dd*K*f*fd*r*s + 4404*D1*Dd*K*f*fd*r - 1680*D1*Dd*K*f*fd*s**2 + 2964*D1*Dd*K*f*fd*s - 1206*D1*Dd*K*f*fd - 4032*D1*Dd*bd2*f*r**2 - 8064*D1*Dd*bd2*f*r*s + 7056*D1*Dd*bd2*f*r - 4032*D1*Dd*bd2*f*s**2 + 7056*D1*Dd*bd2*f*s - 3024*D1*Dd*bd2*f - 700*D1*Dd*f**3*r**2 - 1456*D1*Dd*f**3*r*s + 1078*D1*Dd*f**3*r - 756*D1*Dd*f**3*s**2 + 1120*D1*Dd*f**3*s - 553*D1*Dd*f**3 + 4152*D1*Dd*f**2*fd*r**2 + 9984*D1*Dd*f**2*fd*r*s - 7142*D1*Dd*f**2*fd*r + 5832*D1*Dd*f**2*fd*s**2 - 8564*D1*Dd*f**2*fd*s + 3102*D1*Dd*f**2*fd - 852*D1*Dd*f**2*r**2 - 1200*D1*Dd*f**2*r*s + 1026*D1*Dd*f**2*r - 348*D1*Dd*f**2*s**2 + 648*D1*Dd*f**2*s - 387*D1*Dd*f**2 + 864*D1*Dd*f*fd*r**2 + 1728*D1*Dd*f*fd*r*s - 1080*D1*Dd*f*fd*r + 864*D1*Dd*f*fd*s**2 - 1080*D1*Dd*f*fd*s + 324*D1*Dd*f*fd - 840*D1*Dd*f*g2*r**2 - 3024*D1*Dd*f*g2*r*s + 1932*D1*Dd*f*g2*r - 2184*D1*Dd*f*g2*s**2 + 2940*D1*Dd*f*g2*s - 1302*D1*Dd*f*g2 + 6720*D1*Dd*f*gd2*r**2 + 14784*D1*Dd*f*gd2*r*s - 12768*D1*Dd*f*gd2*r + 8064*D1*Dd*f*gd2*s**2 - 13944*D1*Dd*f*gd2*s + 5880*D1*Dd*f*gd2 + 6720*D1*Dd*fd*g2*r**2 + 14784*D1*Dd*fd*g2*r*s - 3696*D1*Dd*fd*g2*r + 8064*D1*Dd*fd*g2*s**2 - 4872*D1*Dd*fd*g2*s - 924*D1*Dd*fd*g2 - 996*D1*Ddd*K*f**2*r**2 - 1416*D1*Ddd*K*f**2*r*s + 1206*D1*Ddd*K*f**2*r - 420*D1*Ddd*K*f**2*s**2 + 774*D1*Ddd*K*f**2*s - 459*D1*Ddd*K*f**2 + 692*D1*Ddd*f**3*r**2 + 1664*D1*Ddd*f**3*r*s - 1178*D1*Ddd*f**3*r + 972*D1*Ddd*f**3*s**2 - 1388*D1*Ddd*f**3*s + 659*D1*Ddd*f**3 + 216*D1*Ddd*f**2*r**2 + 432*D1*Ddd*f**2*r*s - 324*D1*Ddd*f**2*r + 216*D1*Ddd*f**2*s**2 - 324*D1*Ddd*f**2*s + 162*D1*Ddd*f**2 + 3360*D1*Ddd*f*g2*r**2 + 7392*D1*Ddd*f*g2*r*s - 5376*D1*Ddd*f*g2*r + 4032*D1*Ddd*f*g2*s**2 - 5880*D1*Ddd*f*g2*s + 2856*D1*Ddd*f*g2 + 3*D1*bd1*(70*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-2*f**2*(38*r**2 + 152*r*s - 125*r + 114*s**2 - 171*s + 72) + f*(70*C*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) + 14*K*(5*r**2 + 6*r*(3*s - 4) + 13*s**2 - 28*s + 14) + 2*fd*(160*r**2 + 8*r*(94*s - 57) + 592*s**2 - 780*s + 215) - 602*r**2 - 700*r*s + 728*r - 98*s**2 + 406*s - 343) - 14*fd*(K*(40*r**2 + 88*r*s - 37*r + 48*s**2 - 43*s - 3) - 8*r**2 - 20*r*s + 7*r - 12*s**2 + 10*s + 1) + 140*g2*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) - 140*gd2*(10*r**2 + r*(12*s - 11) + 2*s**2 - 5*s + 3)) + 2*Dd*(f**2*(320*r**2 + 4*r*(376*s - 257) + 1184*s**2 - 1640*s + 573) - 7*f*(K*(160*r**2 + 4*r*(88*s - 79) + 192*s**2 - 336*s + 145) - 32*r**2 - 80*r*s + 72*r - 48*s**2 + 82*s - 35) - 70*g2*(40*r**2 + 6*r*(8*s - 7) + 8*s**2 - 22*s + 11))) - 2988*Dd**2*K*f**2*r**2 - 4248*Dd**2*K*f**2*r*s + 3618*Dd**2*K*f**2*r - 1260*Dd**2*K*f**2*s**2 + 2322*Dd**2*K*f**2*s - 918*Dd**2*K*f**2 + 2076*Dd**2*f**3*r**2 + 4992*Dd**2*f**3*r*s - 3534*Dd**2*f**3*r + 2916*Dd**2*f**3*s**2 - 4164*Dd**2*f**3*s + 1318*Dd**2*f**3 + 648*Dd**2*f**2*r**2 + 1296*Dd**2*f**2*r*s - 972*Dd**2*f**2*r + 648*Dd**2*f**2*s**2 - 972*Dd**2*f**2*s + 324*Dd**2*f**2 + 10080*Dd**2*f*g2*r**2 + 22176*Dd**2*f*g2*r*s - 16128*Dd**2*f*g2*r + 12096*Dd**2*f*g2*s**2 - 17640*Dd**2*f*g2*s + 5712*Dd**2*f*g2 - 21*b2*(-5*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 13*D1**2*fd*r**2 - 26*D1**2*fd*r*s - 4*D1**2*fd*r - 13*D1**2*fd*s**2 - 4*D1**2*fd*s + 2*D1**2*fd + 24*D1**2*fdd*r**2 + 48*D1**2*fdd*r*s + 2*D1**2*fdd*r + 24*D1**2*fdd*s**2 + 2*D1**2*fdd*s - D1**2*fdd - 52*D1*Dd*f*r**2 - 104*D1*Dd*f*r*s + 78*D1*Dd*f*r - 52*D1*Dd*f*s**2 + 78*D1*Dd*f*s - 39*D1*Dd*f + 192*D1*Dd*fd*r**2 + 384*D1*Dd*fd*r*s - 136*D1*Dd*fd*r + 192*D1*Dd*fd*s**2 - 136*D1*Dd*fd*s - 6*D1*Dd*fd + 96*D1*Ddd*f*r**2 + 192*D1*Ddd*f*r*s - 144*D1*Ddd*f*r + 96*D1*Ddd*f*s**2 - 144*D1*Ddd*f*s + 72*D1*Ddd*f + 10*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 288*Dd**2*f*r**2 + 576*Dd**2*f*r*s - 432*Dd**2*f*r + 288*Dd**2*f*s**2 - 432*Dd**2*f*s + 144*Dd**2*f)) + 3*b2*(70*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 7*D1**2*bdd1*f*(24*r**2 + 48*r*s - 50*r + 24*s**2 - 50*s + 25) + 122*D1**2*f*fd*r**2 + 164*D1**2*f*fd*r*s - 122*D1**2*f*fd*r + 42*D1**2*f*fd*s**2 - 82*D1**2*f*fd*s + 61*D1**2*f*fd - 166*D1**2*f*fdd*r**2 - 236*D1**2*f*fdd*r*s + 166*D1**2*f*fdd*r - 70*D1**2*f*fdd*s**2 + 118*D1**2*f*fdd*s - 83*D1**2*f*fdd - 166*D1**2*fd**2*r**2 - 236*D1**2*fd**2*r*s + 166*D1**2*fd**2*r - 70*D1**2*fd**2*s**2 + 118*D1**2*fd**2*s + 244*D1*Dd*f**2*r**2 + 328*D1*Dd*f**2*r*s - 286*D1*Dd*f**2*r + 84*D1*Dd*f**2*s**2 - 166*D1*Dd*f**2*s + 103*D1*Dd*f**2 - 1328*D1*Dd*f*fd*r**2 - 1888*D1*Dd*f*fd*r*s + 1468*D1*Dd*f*fd*r - 560*D1*Dd*f*fd*s**2 + 988*D1*Dd*f*fd*s - 402*D1*Dd*f*fd - 332*D1*Ddd*f**2*r**2 - 472*D1*Ddd*f**2*r*s + 402*D1*Ddd*f**2*r - 140*D1*Ddd*f**2*s**2 + 258*D1*Ddd*f**2*s - 153*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(13*r**2 + r*(26*s - 30) + 13*s**2 - 30*s + 15) - 48*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(96*r**2 + 4*r*(48*s - 43) + 96*s**2 - 172*s + 75)) - 996*Dd**2*f**2*r**2 - 1416*Dd**2*f**2*r*s + 1206*Dd**2*f**2*r - 420*Dd**2*f**2*s**2 + 774*Dd**2*f**2*s - 306*Dd**2*f**2))/(630*d**2*k3**3) - D1**2*Pk1*Pkd3*st**4*(4*C - 2)*(D1*f*(-7*D1*bd1**2*s*(2*r + 2*s - 1) - D1*bdd1*f*s*(r + s) + bd1*(2*D1*f*s*(r + s) + D1*fd*(-4*r*s + r + s*(3 - 4*s)) + Dd*f*r*(2 - 8*s) + Dd*f*s*(5 - 8*s))) + 7*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(-7*bdd1*s*(2*r + 2*s - 1) + 2*fd*(2*s - 1)*(r + s - 1) - fdd*(2*s - 1)*(r + s - 1)) - fd**2*(2*s - 1)*(r + s - 1)) + 7*D1*bd1*(2*D1*f*s*(2*r + 2*s - 1) - D1*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(35*d**2*k3) - D1**2*Pk1*Pkd3*st**2*(D1*f*(14*D1*bd1**2*(r**2*(10*C - 5) + r*(60*C*s - 10*C - 32*s + 5) + s*(50*C*s - 30*C - 27*s + 16)) + D1*bdd1*f*(r + s)*(r*(46*C - 23) + s*(70*C - 41)) + bd1*(D1*(-f*(r + s)*(r*(50*C - 25) + s*(98*C - 47)) + 2*fd*(r**2*(92*C - 46) + r*(8*C*(29*s - 13) - 128*s + 55) + s*(4*C*(35*s - 32) - 82*s + 73))) + 2*Dd*f*(r**2*(184*C - 92) + r*(464*C*s - 162*C - 256*s + 87) + 2*s*(140*C*s - 99*C - 82*s + 57)))) + 7*b1**2*(D1**2*(fd*(10*C*(r - 7*s + 7) - 5*r + 29*s - 29) + fdd*(10*C*(r + 5*s - 5) - 5*r - 27*s + 27))*(r + s - 1) + D1*(Dd*(f*(10*C*(4*r**2 - 24*r*s + 10*r - 28*s**2 + 34*s - 13) - 20*r**2 + 96*r*s - 38*r + 116*s**2 - 140*s + 53) + 2*fd*(10*C*(4*r**2 + 24*r*s - 19*r + 20*s**2 - 33*s + 13) - 20*r**2 - 128*r*s + 101*r - 108*s**2 + 178*s - 70)) + Ddd*f*(10*C*(4*r**2 + 24*r*s - 14*r + 20*s**2 - 26*s + 11) - 20*r**2 - 128*r*s + 74*r - 108*s**2 + 140*s - 59)) + 2*Dd**2*f*(10*C*(6*r**2 + 36*r*s - 21*r + 30*s**2 - 39*s + 11) - 30*r**2 - 192*r*s + 111*r - 162*s**2 + 210*s - 59)) + b1*(-100*C*D1**2*f*fd*r**2 - 296*C*D1**2*f*fd*r*s + 248*C*D1**2*f*fd*r - 196*C*D1**2*f*fd*s**2 + 344*C*D1**2*f*fd*s - 148*C*D1**2*f*fd + 92*C*D1**2*f*fdd*r**2 + 232*C*D1**2*f*fdd*r*s - 208*C*D1**2*f*fdd*r + 140*C*D1**2*f*fdd*s**2 - 256*C*D1**2*f*fdd*s + 116*C*D1**2*f*fdd + 92*C*D1**2*fd**2*r**2 + 232*C*D1**2*fd**2*r*s - 208*C*D1**2*fd**2*r + 140*C*D1**2*fd**2*s**2 - 256*C*D1**2*fd**2*s + 116*C*D1**2*fd**2 - 200*C*D1*Dd*f**2*r**2 - 592*C*D1*Dd*f**2*r*s + 396*C*D1*Dd*f**2*r - 392*C*D1*Dd*f**2*s**2 + 540*C*D1*Dd*f**2*s - 246*C*D1*Dd*f**2 + 736*C*D1*Dd*f*fd*r**2 + 1856*C*D1*Dd*f*fd*r*s - 1480*C*D1*Dd*f*fd*r + 1120*C*D1*Dd*f*fd*s**2 - 1816*C*D1*Dd*f*fd*s + 720*C*D1*Dd*f*fd + 184*C*D1*Ddd*f**2*r**2 + 464*C*D1*Ddd*f**2*r*s - 324*C*D1*Ddd*f**2*r + 280*C*D1*Ddd*f**2*s**2 - 396*C*D1*Ddd*f**2*s + 186*C*D1*Ddd*f**2 + 552*C*Dd**2*f**2*r**2 + 1392*C*Dd**2*f**2*r*s - 972*C*Dd**2*f**2*r + 840*C*Dd**2*f**2*s**2 - 1188*C*Dd**2*f**2*s + 372*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(10*C*(2*r**2 + 12*r*s - 2*r + 10*s**2 - 6*s + 1) - 10*r**2 - 64*r*s + 10*r - 54*s**2 + 32*s - 5) + 50*D1**2*f*fd*r**2 + 144*D1**2*f*fd*r*s - 122*D1**2*f*fd*r + 94*D1**2*f*fd*s**2 - 166*D1**2*f*fd*s + 72*D1**2*f*fd - 46*D1**2*f*fdd*r**2 - 128*D1**2*f*fdd*r*s + 110*D1**2*f*fdd*r - 82*D1**2*f*fdd*s**2 + 146*D1**2*f*fdd*s - 64*D1**2*f*fdd - 46*D1**2*fd**2*r**2 - 128*D1**2*fd**2*r*s + 110*D1**2*fd**2*r - 82*D1**2*fd**2*s**2 + 146*D1**2*fd**2*s - 64*D1**2*fd**2 + 100*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 194*D1*Dd*f**2*r + 188*D1*Dd*f**2*s**2 - 260*D1*Dd*f**2*s + 119*D1*Dd*f**2 - 368*D1*Dd*f*fd*r**2 - 1024*D1*Dd*f*fd*r*s + 788*D1*Dd*f*fd*r - 656*D1*Dd*f*fd*s**2 + 1040*D1*Dd*f*fd*s - 402*D1*Dd*f*fd - 92*D1*Ddd*f**2*r**2 - 256*D1*Ddd*f**2*r*s + 174*D1*Ddd*f**2*r - 164*D1*Ddd*f**2*s**2 + 228*D1*Ddd*f**2*s - 105*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(10*C*(2*r**2 - 2*r*(6*s + 1) - 14*s**2 + 6*s + 1) - 10*r**2 + 48*r*s + 10*r + 58*s**2 - 24*s - 5) + 2*fd*(10*C*(2*r**2 + 12*r*s - 7*r + 10*s**2 - 13*s + 3) - 10*r**2 - 64*r*s + 37*r - 54*s**2 + 70*s - 16)) + 2*Dd*f*(10*C*(8*r**2 + 6*r*(8*s - 3) + 40*s**2 - 38*s + 7) - 40*r**2 - 256*r*s + 94*r - 216*s**2 + 204*s - 37)) - 276*Dd**2*f**2*r**2 - 768*Dd**2*f**2*r*s + 522*Dd**2*f**2*r - 492*Dd**2*f**2*s**2 + 684*Dd**2*f**2*s - 210*Dd**2*f**2))/(210*d**2*k3) - D1**2*Pk1*Pkd3*(D1*(-2*D1*bd1**2*(f**2*(r*(6*s - 3) + s*(6*s - 6)) + f*(-13*K*r**2 - r*(9*K - 3)*(2*s - 1) - s*(5*K - 6)*(s - 1)) + 30*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*D1*bdd1*f*g2*(13*r**2 + 18*r*s + 5*s**2) + b2*(30*D1*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*bdd1*f*(13*r**2 + 18*r*s + 5*s**2) + bd1*(D1*(f*(-11*r**2 - 6*r*s + 5*s**2) + 2*fd*(13*r**2 + r*(18*s - 13) + s*(5*s - 9))) + 2*Dd*f*(52*r**2 + r*(72*s - 31) + s*(20*s - 19)))) - 2*bd1*(D1*bd2*f*(-13*r**2 + r*(9 - 18*s) - s*(5*s - 5)) + D1*(f*(g2*(-11*r**2 - 6*r*s + 5*s**2) + 2*gd2*(13*r**2 + 9*r*(2*s - 1) + s*(5*s - 5))) + 2*fd*g2*(13*r**2 + r*(18*s - 13) + s*(5*s - 9))) + 2*Dd*f*g2*(52*r**2 + r*(72*s - 31) + s*(20*s - 19)))) + 5*b1**3*(2*D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(12*K*r**2 + 24*K*r*s - 18*K*r + 12*K*s**2 - 18*K*s + 9*K + 2*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 2*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5) - 8*r*s + 4*r - 8*s**2 + 10*s - 4) + Ddd*(3*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 8*r*s + 4*r - 8*s**2 + 10*s - 4)) + 2*Dd**2*(9*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4) - 12*r*s + 6*r - 12*s**2 + 15*s - 4)) + b1**2*(45*D1**2*K*bdd1*r**2 + 90*D1**2*K*bdd1*r*s - 60*D1**2*K*bdd1*r + 45*D1**2*K*bdd1*s**2 - 60*D1**2*K*bdd1*s + 30*D1**2*K*bdd1 - 11*D1**2*K*fd*r**2 - 6*D1**2*K*fd*r*s + 22*D1**2*K*fd*r + 5*D1**2*K*fd*s**2 + 6*D1**2*K*fd*s - 11*D1**2*K*fd + 13*D1**2*K*fdd*r**2 + 18*D1**2*K*fdd*r*s - 26*D1**2*K*fdd*r + 5*D1**2*K*fdd*s**2 - 18*D1**2*K*fdd*s + 13*D1**2*K*fdd - 30*D1**2*bdd1*f*r*s + 10*D1**2*bdd1*f*r - 30*D1**2*bdd1*f*s**2 + 30*D1**2*bdd1*f*s - 10*D1**2*bdd1*f - 30*D1**2*bdd1*r*s + 10*D1**2*bdd1*r - 30*D1**2*bdd1*s**2 + 30*D1**2*bdd1*s - 10*D1**2*bdd1 + 15*D1**2*bdd2*r**2 + 30*D1**2*bdd2*r*s - 30*D1**2*bdd2*r + 15*D1**2*bdd2*s**2 - 30*D1**2*bdd2*s + 15*D1**2*bdd2 + 12*D1**2*f*fd*r*s - 6*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 6*D1**2*f*fd - 12*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s - 6*D1**2*fd**2 + 2*D1**2*fd*r*s + 2*D1**2*fd*s**2 - 2*D1**2*fd*s - 6*D1**2*fdd*r*s - 6*D1**2*fdd*s**2 + 6*D1**2*fdd*s - 30*D1**2*gd2*r**2 - 60*D1**2*gd2*r*s + 60*D1**2*gd2*r - 30*D1**2*gd2*s**2 + 60*D1**2*gd2*s - 30*D1**2*gd2 - 30*D1**2*gdd2*r**2 - 60*D1**2*gdd2*r*s + 60*D1**2*gdd2*r - 30*D1**2*gdd2*s**2 + 60*D1**2*gdd2*s - 30*D1**2*gdd2 - 44*D1*Dd*K*f*r**2 - 24*D1*Dd*K*f*r*s + 34*D1*Dd*K*f*r + 20*D1*Dd*K*f*s**2 - 14*D1*Dd*K*f*s - D1*Dd*K*f + 104*D1*Dd*K*fd*r**2 + 144*D1*Dd*K*fd*r*s - 166*D1*Dd*K*fd*r + 40*D1*Dd*K*fd*s**2 - 110*D1*Dd*K*fd*s + 62*D1*Dd*K*fd + 60*D1*Dd*b2*r**2 + 120*D1*Dd*b2*r*s - 90*D1*Dd*b2*r + 60*D1*Dd*b2*s**2 - 90*D1*Dd*b2*s + 45*D1*Dd*b2 + 24*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 30*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 96*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 132*D1*Dd*f*fd*s - 42*D1*Dd*f*fd + 8*D1*Dd*f*r*s - 4*D1*Dd*f*r + 8*D1*Dd*f*s**2 - 10*D1*Dd*f*s + 4*D1*Dd*f - 48*D1*Dd*fd*r*s + 12*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 + 54*D1*Dd*fd*s - 12*D1*Dd*fd - 120*D1*Dd*g2*r**2 - 240*D1*Dd*g2*r*s + 180*D1*Dd*g2*r - 120*D1*Dd*g2*s**2 + 180*D1*Dd*g2*s - 90*D1*Dd*g2 - 240*D1*Dd*gd2*r**2 - 480*D1*Dd*gd2*r*s + 420*D1*Dd*gd2*r - 240*D1*Dd*gd2*s**2 + 420*D1*Dd*gd2*s - 180*D1*Dd*gd2 + 52*D1*Ddd*K*f*r**2 + 72*D1*Ddd*K*f*r*s - 62*D1*Ddd*K*f*r + 20*D1*Ddd*K*f*s**2 - 38*D1*Ddd*K*f*s + 23*D1*Ddd*K*f + 60*D1*Ddd*b2*r**2 + 120*D1*Ddd*b2*r*s - 90*D1*Ddd*b2*r + 60*D1*Ddd*b2*s**2 - 90*D1*Ddd*b2*s + 45*D1*Ddd*b2 - 24*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 12*D1*Ddd*f**2 - 24*D1*Ddd*f*r*s + 12*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 30*D1*Ddd*f*s - 12*D1*Ddd*f - 120*D1*Ddd*g2*r**2 - 240*D1*Ddd*g2*r*s + 180*D1*Ddd*g2*r - 120*D1*Ddd*g2*s**2 + 180*D1*Ddd*g2*s - 90*D1*Ddd*g2 + 5*D1*bd1*(D1*(9*K*r**2 + 18*K*r*s - 12*K*r + 9*K*s**2 - 12*K*s + 6*K + f*(r*(6*s - 2) + 6*s**2 - 6*s + 2) - 2*fd*(6*r*s - 4*r + 6*s**2 - 9*s + 3) - 6*r*s + 2*r - 6*s**2 + 6*s - 2) - 2*Dd*(-3*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + 24*r*s - 10*r + 24*s**2 - 27*s + 7)) + 15*D1*bd2*(D1*(r + s - 1) + 2*Dd*(4*r + 4*s - 3))*(r + s - 1) + 156*Dd**2*K*f*r**2 + 216*Dd**2*K*f*r*s - 186*Dd**2*K*f*r + 60*Dd**2*K*f*s**2 - 114*Dd**2*K*f*s + 46*Dd**2*K*f + 180*Dd**2*b2*r**2 + 360*Dd**2*b2*r*s - 270*Dd**2*b2*r + 180*Dd**2*b2*s**2 - 270*Dd**2*b2*s + 90*Dd**2*b2 - 72*Dd**2*f**2*r*s + 36*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 24*Dd**2*f**2 - 72*Dd**2*f*r*s + 36*Dd**2*f*r - 72*Dd**2*f*s**2 + 90*Dd**2*f*s - 24*Dd**2*f - 360*Dd**2*g2*r**2 - 720*Dd**2*g2*r*s + 540*Dd**2*g2*r - 360*Dd**2*g2*s**2 + 540*Dd**2*g2*s - 180*Dd**2*g2) + b1*(26*D1**2*K*bdd1*f*r**2 + 36*D1**2*K*bdd1*f*r*s - 18*D1**2*K*bdd1*f*r + 10*D1**2*K*bdd1*f*s**2 - 10*D1**2*K*bdd1*f*s + 5*D1**2*K*bdd1*f - 10*D1**2*bd1**2*(-3*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*r*s - 2*r + 6*s**2 - 6*s + 1) - 11*D1**2*bd2*f*r**2 - 6*D1**2*bd2*f*r*s + 6*D1**2*bd2*f*r + 5*D1**2*bd2*f*s**2 - 10*D1**2*bd2*f*s + 5*D1**2*bd2*f + 26*D1**2*bd2*fd*r**2 + 36*D1**2*bd2*fd*r*s - 44*D1**2*bd2*fd*r + 10*D1**2*bd2*fd*s**2 - 28*D1**2*bd2*fd*s + 18*D1**2*bd2*fd - 12*D1**2*bdd1*f**2*r*s + 6*D1**2*bdd1*f**2*r - 12*D1**2*bdd1*f**2*s**2 + 12*D1**2*bdd1*f**2*s - 6*D1**2*bdd1*f**2 - 12*D1**2*bdd1*f*r*s + 6*D1**2*bdd1*f*r - 12*D1**2*bdd1*f*s**2 + 12*D1**2*bdd1*f*s - 6*D1**2*bdd1*f - 60*D1**2*bdd1*g2*r**2 - 120*D1**2*bdd1*g2*r*s + 60*D1**2*bdd1*g2*r - 60*D1**2*bdd1*g2*s**2 + 60*D1**2*bdd1*g2*s - 30*D1**2*bdd1*g2 + 13*D1**2*bdd2*f*r**2 + 18*D1**2*bdd2*f*r*s - 18*D1**2*bdd2*f*r + 5*D1**2*bdd2*f*s**2 - 10*D1**2*bdd2*f*s + 5*D1**2*bdd2*f + 22*D1**2*f*gd2*r**2 + 12*D1**2*f*gd2*r*s - 12*D1**2*f*gd2*r - 10*D1**2*f*gd2*s**2 + 20*D1**2*f*gd2*s - 10*D1**2*f*gd2 - 26*D1**2*f*gdd2*r**2 - 36*D1**2*f*gdd2*r*s + 36*D1**2*f*gdd2*r - 10*D1**2*f*gdd2*s**2 + 20*D1**2*f*gdd2*s - 10*D1**2*f*gdd2 + 22*D1**2*fd*g2*r**2 + 12*D1**2*fd*g2*r*s - 44*D1**2*fd*g2*r - 10*D1**2*fd*g2*s**2 - 12*D1**2*fd*g2*s + 22*D1**2*fd*g2 - 52*D1**2*fd*gd2*r**2 - 72*D1**2*fd*gd2*r*s + 88*D1**2*fd*gd2*r - 20*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 36*D1**2*fd*gd2 - 26*D1**2*fdd*g2*r**2 - 36*D1**2*fdd*g2*r*s + 52*D1**2*fdd*g2*r - 10*D1**2*fdd*g2*s**2 + 36*D1**2*fdd*g2*s - 26*D1**2*fdd*g2 + 104*D1*Dd*bd2*f*r**2 + 144*D1*Dd*bd2*f*r*s - 134*D1*Dd*bd2*f*r + 40*D1*Dd*bd2*f*s**2 - 78*D1*Dd*bd2*f*s + 38*D1*Dd*bd2*f + 88*D1*Dd*f*g2*r**2 + 48*D1*Dd*f*g2*r*s - 68*D1*Dd*f*g2*r - 40*D1*Dd*f*g2*s**2 + 28*D1*Dd*f*g2*s + 2*D1*Dd*f*g2 - 208*D1*Dd*f*gd2*r**2 - 288*D1*Dd*f*gd2*r*s + 268*D1*Dd*f*gd2*r - 80*D1*Dd*f*gd2*s**2 + 156*D1*Dd*f*gd2*s - 76*D1*Dd*f*gd2 - 208*D1*Dd*fd*g2*r**2 - 288*D1*Dd*fd*g2*r*s + 332*D1*Dd*fd*g2*r - 80*D1*Dd*fd*g2*s**2 + 220*D1*Dd*fd*g2*s - 124*D1*Dd*fd*g2 - 104*D1*Ddd*f*g2*r**2 - 144*D1*Ddd*f*g2*r*s + 124*D1*Ddd*f*g2*r - 40*D1*Ddd*f*g2*s**2 + 76*D1*Ddd*f*g2*s - 46*D1*Ddd*f*g2 + D1*bd1*(30*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(2*K*fd*(26*r**2 + r*(36*s - 35) + 10*s**2 - 23*s + 9) + 6*f**2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + f*(K*(-22*r**2 - 12*r*s + 6*r + 10*s**2 - 10*s + 5) - 6*fd*(2*s - 1)*(4*r + 4*s - 3) + 4*r*s - 2*r + 4*s**2 - 4*s + 2) - 6*fd*(r*(4*s - 1) + (1 - 2*s)**2) - 30*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 60*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(3*f**2*(2*s - 1)*(8*r + 8*s - 5) + f*(-K*(104*r**2 + 144*r*s - 98*r + 40*s**2 - 58*s + 19) + (6*s - 3)*(8*r + 8*s - 5)) + 30*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 312*Dd**2*f*g2*r**2 - 432*Dd**2*f*g2*r*s + 372*Dd**2*f*g2*r - 120*Dd**2*f*g2*s**2 + 228*Dd**2*f*g2*s - 92*Dd**2*f*g2 + b2*(15*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 11*D1**2*fd*r**2 - 6*D1**2*fd*r*s + 22*D1**2*fd*r + 5*D1**2*fd*s**2 + 6*D1**2*fd*s - 11*D1**2*fd + 13*D1**2*fdd*r**2 + 18*D1**2*fdd*r*s - 26*D1**2*fdd*r + 5*D1**2*fdd*s**2 - 18*D1**2*fdd*s + 13*D1**2*fdd - 44*D1*Dd*f*r**2 - 24*D1*Dd*f*r*s + 34*D1*Dd*f*r + 20*D1*Dd*f*s**2 - 14*D1*Dd*f*s - D1*Dd*f + 104*D1*Dd*fd*r**2 + 144*D1*Dd*fd*r*s - 166*D1*Dd*fd*r + 40*D1*Dd*fd*s**2 - 110*D1*Dd*fd*s + 62*D1*Dd*fd + 52*D1*Ddd*f*r**2 + 72*D1*Ddd*f*r*s - 62*D1*Ddd*f*r + 20*D1*Ddd*f*s**2 - 38*D1*Ddd*f*s + 23*D1*Ddd*f + 15*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 156*Dd**2*f*r**2 + 216*Dd**2*f*r*s - 186*Dd**2*f*r + 60*Dd**2*f*s**2 - 114*Dd**2*f*s + 46*Dd**2*f)))/(30*d**2*k3) + D1**2*Pk1*Pkd3*k2**4*st**6*(-36*D1**2*b1*f*fd*r**2 - 36*D1**2*b1*f*fd*r*s + 18*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 18*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 6*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r + 2*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 - 72*D1*Dd*b1*f**2*r**2 - 72*D1*Dd*b1*f**2*r*s + 72*D1*Dd*b1*f**2*r + 18*D1*Dd*b1*f**2*s - 18*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 108*D1*Dd*b1*f*fd*r - 18*D1*Dd*b1*f*fd*s + 9*D1*Dd*b1*f*fd - 8*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 8*D1*Dd*f**3*r + 2*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 24*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 5*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 4*D1*Ddd*f**3*r - D1*Ddd*f**3*s + D1*Ddd*f**3 - 9*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) + 108*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r - 27*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 12*Dd**2*f**3*r - 3*Dd**2*f**3*s + 2*Dd**2*f**3)/(63*d**2*k1**2*k3**3) + D1**2*Pk1*Pkd3*k2**4*st**4*(D1*f*(3*D1*bd1**2*(5*f*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + (14*r - 7)*(r + s - 1)) + bd1*(D1*(f**2*r*(-2*r - 2*s + 1) + f*(5*fd*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1) + (15*r - 21)*(r + s - 1)) + 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*f*(5*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 24*r**2 + 24*r*(s - 1) - 3*s + 3)) + f*(D1*(bdd1*r*(5*f*(2*r + 2*s - 1) + 3*r + 3*s - 3) + fd*(9*r**2 + 9*r*(s - 1) - 3*s + 3)) + 3*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1))) - 3*b1**2*(D1**2*r*(f*(3*fd - 5*fdd)*(4*r + 4*s - 3) - 5*fd**2*(4*r + 4*s - 3) + 14*fd*(r + s) - 7*fdd*(r + s)) + D1*(Dd*(6*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-5*fd*(8*r - 1)*(4*r + 4*s - 3) + 56*r**2 + 56*r*(s - 1) - 14*s + 14) + 7*fd*(-8*r**2 + r*(4 - 8*s) + s)) - Ddd*f*(10*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(10*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(3*D1**2*bdd1*f*(5*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + (14*r - 7)*(r + s - 1)) - 6*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 7*D1**2*f**2*fd*r + 2*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 35*D1**2*f**2*fdd*r - 10*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 70*D1**2*f*fd**2*r - 20*D1**2*f*fd**2*s + 15*D1**2*f*fd**2 + 30*D1**2*f*fd*r**2 + 30*D1**2*f*fd*r*s - 9*D1**2*f*fd*r + 6*D1**2*f*fd*s - 6*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 3*D1**2*fd**2*s - 8*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 8*D1*Dd*f**3*r + 2*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 260*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd*s + 55*D1*Dd*f**2*fd + 60*D1*Dd*f**2*r**2 + 60*D1*Dd*f**2*r*s - 60*D1*Dd*f**2*r - 15*D1*Dd*f**2*s + 15*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 48*D1*Dd*f*fd*r - 18*D1*Dd*f*fd*s + 12*D1*Dd*f*fd + 40*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 40*D1*Ddd*f**3*r - 10*D1*Ddd*f**3*s + 10*D1*Ddd*f**3 + 12*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r - 3*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 - 3*D1*bd1*(D1*(3*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(-5*fd*(4*r - 1)*(4*r + 4*s - 3) + (28*r - 14)*(r + s - 1)) + 7*fd*(-4*r**2 + r*(3 - 4*s) + s)) - Dd*f*(5*f*(8*r - 3)*(4*r + 4*s - 3) + 112*r**2 + 28*r*(4*s - 5) - 42*s + 35)) + 120*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 120*Dd**2*f**3*r - 30*Dd**2*f**3*s + 20*Dd**2*f**3 + 36*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s - 36*Dd**2*f**2*r - 9*Dd**2*f**2*s + 6*Dd**2*f**2))/(105*d**2*k1**2*k3**3) + D1**2*Pk1*Pkd3*k2**2*st**4*(D1*f*(7*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + D1*bdd1*f*r*(r + s) + bd1*(D1*(-2*f*r*(r + s) + fd*(4*r**2 + 4*r*s - 3*r - s)) + Dd*f*(8*r**2 + r*(8*s - 4) - s))) - 7*b1**2*(D1**2*r*(2*fd - fdd)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-8*r**2 - 8*r*(s - 1) + s - 1)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + b1*(7*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 2*D1**2*f*fd*s - 2*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r - D1**2*f*fdd*s + D1**2*f*fdd + 2*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r*s - 3*D1**2*fd**2*r - D1**2*fd**2*s + D1**2*fd**2 - 8*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r + 2*D1*Dd*f**2*s - 2*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 16*D1*Dd*f*fd*r*s - 20*D1*Dd*f*fd*r - 6*D1*Dd*f*fd*s + 5*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 + 4*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r - D1*Ddd*f**2*s + D1*Ddd*f**2 - 7*D1*bd1*(D1*(f*(4*r**2 + 4*r*(s - 1) - 2*s + 2) + fd*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 12*Dd**2*f**2*r**2 + 12*Dd**2*f**2*r*s - 12*Dd**2*f**2*r - 3*Dd**2*f**2*s + 2*Dd**2*f**2))/(35*d**2*k1**2*k3) + D1**2*Pk1*Pkd3*k2**2*st**2*(D1**2*bd1*f*r*(bd1*(9*f + 7)*(2*r + 2*s - 1) + 7*f*(r + s)) + D1*b1*(7*D1*bd1**2*(3*f + 5)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + bd1*(D1*(3*f**2*r*(2*r + 2*s - 1) + f*(9*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + 42*r**2 + 7*r*(6*s - 8) - 35*s + 35) + 7*fd*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(9*f + 7)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1)) + f*(D1*(bdd1*r*(9*f + 7)*(2*r + 2*s - 1) + 7*fd*(2*r - 1)*(r + s - 1)) + 7*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1))) - 7*b1**3*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + 40*r**2 + 40*r*(s - 1) - 10*s + 10) - Ddd*(3*f + 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(3*f + 5)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(7*D1**2*bdd1*(3*f + 5)*(3*r**2 + 3*r*(s - 1) - s + 1) + 6*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s - 9*D1**2*f*fd*r - 3*D1**2*f*fd*s + 3*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 18*D1**2*f*fdd*r*s - 27*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 18*D1**2*fd**2*r*s - 27*D1**2*fd**2*r - 9*D1**2*fd**2*s + 9*D1**2*fd**2 + 21*D1**2*fd*r**2 + 21*D1**2*fd*r*s - 7*D1**2*fd*r + 14*D1**2*fd*s - 14*D1**2*fd + 7*D1**2*fdd*r**2 + 7*D1**2*fdd*r*s - 14*D1**2*fdd*r - 7*D1**2*fdd*s + 7*D1**2*fdd + 12*D1*Dd*f**2*r**2 + 12*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r - 3*D1*Dd*f**2*s + 3*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 144*D1*Dd*f*fd*r*s - 180*D1*Dd*f*fd*r - 54*D1*Dd*f*fd*s + 45*D1*Dd*f*fd + 84*D1*Dd*f*r**2 + 84*D1*Dd*f*r*s - 84*D1*Dd*f*r - 21*D1*Dd*f*s + 21*D1*Dd*f + 56*D1*Dd*fd*r**2 + 56*D1*Dd*fd*r*s - 84*D1*Dd*fd*r - 35*D1*Dd*fd*s + 28*D1*Dd*fd + 36*D1*Ddd*f**2*r**2 + 36*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r - 9*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 28*D1*Ddd*f*r**2 + 28*D1*Ddd*f*r*s - 28*D1*Ddd*f*r - 7*D1*Ddd*f*s + 7*D1*Ddd*f - 7*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + 30*r**2 + 30*r*(s - 1) - 10*s + 10) - Dd*(3*f + 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 108*Dd**2*f**2*r**2 + 108*Dd**2*f**2*r*s - 108*Dd**2*f**2*r - 27*Dd**2*f**2*s + 18*Dd**2*f**2 + 84*Dd**2*f*r**2 + 84*Dd**2*f*r*s - 84*Dd**2*f*r - 21*Dd**2*f*s + 14*Dd**2*f))/(105*d**2*k1**2*k3) - D1**2*Pk1*Pkdd3*ct**8*k2**6*(C - 1)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 42*D1**2*f**2*fd*r**2 + 84*D1**2*f**2*fd*r*s - 56*D1**2*f**2*fd*r + 42*D1**2*f**2*fd*s**2 - 56*D1**2*f**2*fd*s + 28*D1**2*f**2*fd - 21*D1**2*f**2*fdd*r**2 - 42*D1**2*f**2*fdd*r*s + 28*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd*s**2 + 28*D1**2*f**2*fdd*s - 14*D1**2*f**2*fdd - 42*D1**2*f*fd**2*r**2 - 84*D1**2*f*fd**2*r*s + 56*D1**2*f*fd**2*r - 42*D1**2*f*fd**2*s**2 + 56*D1**2*f*fd**2*s - 14*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 56*D1*Dd*f**3*r**2 + 112*D1*Dd*f**3*r*s - 84*D1*Dd*f**3*r + 56*D1*Dd*f**3*s**2 - 84*D1*Dd*f**3*s + 42*D1*Dd*f**3 - 168*D1*Dd*f**2*fd*r**2 - 336*D1*Dd*f**2*fd*r*s + 238*D1*Dd*f**2*fd*r - 168*D1*Dd*f**2*fd*s**2 + 238*D1*Dd*f**2*fd*s - 84*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 - 56*D1*Ddd*f**3*r*s + 42*D1*Ddd*f**3*r - 28*D1*Ddd*f**3*s**2 + 42*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 84*Dd**2*f**3*r**2 - 168*Dd**2*f**3*r*s + 126*Dd**2*f**3*r - 84*Dd**2*f**3*s**2 + 126*Dd**2*f**3*s - 42*Dd**2*f**3)/(63*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**7*f*k2**7*(-66*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 88*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fd*s**2 + 88*D1**2*b1*f*fd*s - 44*D1**2*b1*f*fd + 33*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*f*fdd*r*s - 44*D1**2*b1*f*fdd*r + 33*D1**2*b1*f*fdd*s**2 - 44*D1**2*b1*f*fdd*s + 22*D1**2*b1*f*fdd + 66*D1**2*b1*fd**2*r**2 + 132*D1**2*b1*fd**2*r*s - 88*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 88*D1**2*b1*fd**2*s + 22*D1**2*b1*fd**2 + 11*D1**2*bdd1*f**2*(r + s - 1)**2 - 72*D1**2*f**2*fd*r**2 - 144*D1**2*f**2*fd*r*s + 108*D1**2*f**2*fd*r - 72*D1**2*f**2*fd*s**2 + 108*D1**2*f**2*fd*s - 54*D1**2*f**2*fd + 36*D1**2*f**2*fdd*r**2 + 72*D1**2*f**2*fdd*r*s - 54*D1**2*f**2*fdd*r + 36*D1**2*f**2*fdd*s**2 - 54*D1**2*f**2*fdd*s + 27*D1**2*f**2*fdd + 108*D1**2*f*fd**2*r**2 + 216*D1**2*f*fd**2*r*s - 162*D1**2*f*fd**2*r + 108*D1**2*f*fd**2*s**2 - 162*D1**2*f*fd**2*s + 54*D1**2*f*fd**2 - 88*D1*Dd*b1*f**2*r**2 - 176*D1*Dd*b1*f**2*r*s + 132*D1*Dd*b1*f**2*r - 88*D1*Dd*b1*f**2*s**2 + 132*D1*Dd*b1*f**2*s - 66*D1*Dd*b1*f**2 + 264*D1*Dd*b1*f*fd*r**2 + 528*D1*Dd*b1*f*fd*r*s - 374*D1*Dd*b1*f*fd*r + 264*D1*Dd*b1*f*fd*s**2 - 374*D1*Dd*b1*f*fd*s + 132*D1*Dd*b1*f*fd - 72*D1*Dd*f**3*r**2 - 144*D1*Dd*f**3*r*s + 108*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 108*D1*Dd*f**3*s - 54*D1*Dd*f**3 + 288*D1*Dd*f**2*fd*r**2 + 576*D1*Dd*f**2*fd*r*s - 432*D1*Dd*f**2*fd*r + 288*D1*Dd*f**2*fd*s**2 - 432*D1*Dd*f**2*fd*s + 162*D1*Dd*f**2*fd + 44*D1*Ddd*b1*f**2*r**2 + 88*D1*Ddd*b1*f**2*r*s - 66*D1*Ddd*b1*f**2*r + 44*D1*Ddd*b1*f**2*s**2 - 66*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 + 36*D1*Ddd*f**3*r**2 + 72*D1*Ddd*f**3*r*s - 54*D1*Ddd*f**3*r + 36*D1*Ddd*f**3*s**2 - 54*D1*Ddd*f**3*s + 27*D1*Ddd*f**3 - 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + 132*Dd**2*b1*f**2*r**2 + 264*Dd**2*b1*f**2*r*s - 198*Dd**2*b1*f**2*r + 132*Dd**2*b1*f**2*s**2 - 198*Dd**2*b1*f**2*s + 66*Dd**2*b1*f**2 + 108*Dd**2*f**3*r**2 + 216*Dd**2*f**3*r*s - 162*Dd**2*f**3*r + 108*Dd**2*f**3*s**2 - 162*Dd**2*f**3*s + 54*Dd**2*f**3)/(198*d**2*k1*k3**6) + D1**2*Pk1*Pkdd3*ct**7*k1*k2**5*(-1656*C*D1**2*b1*f*fd*r**2 - 3312*C*D1**2*b1*f*fd*r*s + 1656*C*D1**2*b1*f*fd*r - 1656*C*D1**2*b1*f*fd*s**2 + 1656*C*D1**2*b1*f*fd*s - 828*C*D1**2*b1*f*fd + 1080*C*D1**2*b1*f*fdd*r**2 + 2160*C*D1**2*b1*f*fdd*r*s - 1080*C*D1**2*b1*f*fdd*r + 1080*C*D1**2*b1*f*fdd*s**2 - 1080*C*D1**2*b1*f*fdd*s + 540*C*D1**2*b1*f*fdd + 1080*C*D1**2*b1*fd**2*r**2 + 2160*C*D1**2*b1*fd**2*r*s - 1080*C*D1**2*b1*fd**2*r + 1080*C*D1**2*b1*fd**2*s**2 - 1080*C*D1**2*b1*fd**2*s - 1980*C*D1**2*f**2*fd*r**2 - 3960*C*D1**2*f**2*fd*r*s + 2640*C*D1**2*f**2*fd*r - 1980*C*D1**2*f**2*fd*s**2 + 2640*C*D1**2*f**2*fd*s - 1320*C*D1**2*f**2*fd + 1260*C*D1**2*f**2*fdd*r**2 + 2520*C*D1**2*f**2*fdd*r*s - 1680*C*D1**2*f**2*fdd*r + 1260*C*D1**2*f**2*fdd*s**2 - 1680*C*D1**2*f**2*fdd*s + 840*C*D1**2*f**2*fdd + 2520*C*D1**2*f*fd**2*r**2 + 5040*C*D1**2*f*fd**2*r*s - 3360*C*D1**2*f*fd**2*r + 2520*C*D1**2*f*fd**2*s**2 - 3360*C*D1**2*f*fd**2*s + 840*C*D1**2*f*fd**2 - 3312*C*D1*Dd*b1*f**2*r**2 - 6624*C*D1*Dd*b1*f**2*r*s + 4968*C*D1*Dd*b1*f**2*r - 3312*C*D1*Dd*b1*f**2*s**2 + 4968*C*D1*Dd*b1*f**2*s - 2484*C*D1*Dd*b1*f**2 + 8640*C*D1*Dd*b1*f*fd*r**2 + 17280*C*D1*Dd*b1*f*fd*r*s - 10800*C*D1*Dd*b1*f*fd*r + 8640*C*D1*Dd*b1*f*fd*s**2 - 10800*C*D1*Dd*b1*f*fd*s + 3240*C*D1*Dd*b1*f*fd - 2640*C*D1*Dd*f**3*r**2 - 5280*C*D1*Dd*f**3*r*s + 3960*C*D1*Dd*f**3*r - 2640*C*D1*Dd*f**3*s**2 + 3960*C*D1*Dd*f**3*s - 1980*C*D1*Dd*f**3 + 10080*C*D1*Dd*f**2*fd*r**2 + 20160*C*D1*Dd*f**2*fd*r*s - 14280*C*D1*Dd*f**2*fd*r + 10080*C*D1*Dd*f**2*fd*s**2 - 14280*C*D1*Dd*f**2*fd*s + 5040*C*D1*Dd*f**2*fd + 2160*C*D1*Ddd*b1*f**2*r**2 + 4320*C*D1*Ddd*b1*f**2*r*s - 3240*C*D1*Ddd*b1*f**2*r + 2160*C*D1*Ddd*b1*f**2*s**2 - 3240*C*D1*Ddd*b1*f**2*s + 1620*C*D1*Ddd*b1*f**2 + 1680*C*D1*Ddd*f**3*r**2 + 3360*C*D1*Ddd*f**3*r*s - 2520*C*D1*Ddd*f**3*r + 1680*C*D1*Ddd*f**3*s**2 - 2520*C*D1*Ddd*f**3*s + 1260*C*D1*Ddd*f**3 + 6480*C*Dd**2*b1*f**2*r**2 + 12960*C*Dd**2*b1*f**2*r*s - 9720*C*Dd**2*b1*f**2*r + 6480*C*Dd**2*b1*f**2*s**2 - 9720*C*Dd**2*b1*f**2*s + 3240*C*Dd**2*b1*f**2 + 5040*C*Dd**2*f**3*r**2 + 10080*C*Dd**2*f**3*r*s - 7560*C*Dd**2*f**3*r + 5040*C*Dd**2*f**3*s**2 - 7560*C*Dd**2*f**3*s + 2520*C*Dd**2*f**3 + 1476*D1**2*b1*f*fd*r**2 + 2952*D1**2*b1*f*fd*r*s - 1476*D1**2*b1*f*fd*r + 1476*D1**2*b1*f*fd*s**2 - 1476*D1**2*b1*f*fd*s + 738*D1**2*b1*f*fd - 990*D1**2*b1*f*fdd*r**2 - 1980*D1**2*b1*f*fdd*r*s + 990*D1**2*b1*f*fdd*r - 990*D1**2*b1*f*fdd*s**2 + 990*D1**2*b1*f*fdd*s - 495*D1**2*b1*f*fdd - 990*D1**2*b1*fd**2*r**2 - 1980*D1**2*b1*fd**2*r*s + 990*D1**2*b1*fd**2*r - 990*D1**2*b1*fd**2*s**2 + 990*D1**2*b1*fd**2*s + 45*D1**2*bdd1*f**2*(12*C - 11)*(r + s - 1)**2 + 1770*D1**2*f**2*fd*r**2 + 3540*D1**2*f**2*fd*r*s - 2360*D1**2*f**2*fd*r + 1770*D1**2*f**2*fd*s**2 - 2360*D1**2*f**2*fd*s + 1180*D1**2*f**2*fd - 1155*D1**2*f**2*fdd*r**2 - 2310*D1**2*f**2*fdd*r*s + 1540*D1**2*f**2*fdd*r - 1155*D1**2*f**2*fdd*s**2 + 1540*D1**2*f**2*fdd*s - 770*D1**2*f**2*fdd - 2310*D1**2*f*fd**2*r**2 - 4620*D1**2*f*fd**2*r*s + 3080*D1**2*f*fd**2*r - 2310*D1**2*f*fd**2*s**2 + 3080*D1**2*f*fd**2*s - 770*D1**2*f*fd**2 + 2952*D1*Dd*b1*f**2*r**2 + 5904*D1*Dd*b1*f**2*r*s - 4428*D1*Dd*b1*f**2*r + 2952*D1*Dd*b1*f**2*s**2 - 4428*D1*Dd*b1*f**2*s + 2214*D1*Dd*b1*f**2 - 7920*D1*Dd*b1*f*fd*r**2 - 15840*D1*Dd*b1*f*fd*r*s + 9900*D1*Dd*b1*f*fd*r - 7920*D1*Dd*b1*f*fd*s**2 + 9900*D1*Dd*b1*f*fd*s - 2970*D1*Dd*b1*f*fd + 2360*D1*Dd*f**3*r**2 + 4720*D1*Dd*f**3*r*s - 3540*D1*Dd*f**3*r + 2360*D1*Dd*f**3*s**2 - 3540*D1*Dd*f**3*s + 1770*D1*Dd*f**3 - 9240*D1*Dd*f**2*fd*r**2 - 18480*D1*Dd*f**2*fd*r*s + 13090*D1*Dd*f**2*fd*r - 9240*D1*Dd*f**2*fd*s**2 + 13090*D1*Dd*f**2*fd*s - 4620*D1*Dd*f**2*fd - 1980*D1*Ddd*b1*f**2*r**2 - 3960*D1*Ddd*b1*f**2*r*s + 2970*D1*Ddd*b1*f**2*r - 1980*D1*Ddd*b1*f**2*s**2 + 2970*D1*Ddd*b1*f**2*s - 1485*D1*Ddd*b1*f**2 - 1540*D1*Ddd*f**3*r**2 - 3080*D1*Ddd*f**3*r*s + 2310*D1*Ddd*f**3*r - 1540*D1*Ddd*f**3*s**2 + 2310*D1*Ddd*f**3*s - 1155*D1*Ddd*f**3 - 18*D1*bd1*f*(r + s - 1)*(D1*f*(46*C - 41)*(r + s - 1) - D1*fd*(60*C - 55)*(2*r + 2*s - 1) - Dd*f*(60*C - 55)*(4*r + 4*s - 3)) - 5940*Dd**2*b1*f**2*r**2 - 11880*Dd**2*b1*f**2*r*s + 8910*Dd**2*b1*f**2*r - 5940*Dd**2*b1*f**2*s**2 + 8910*Dd**2*b1*f**2*s - 2970*Dd**2*b1*f**2 - 4620*Dd**2*f**3*r**2 - 9240*Dd**2*f**3*r*s + 6930*Dd**2*f**3*r - 4620*Dd**2*f**3*s**2 + 6930*Dd**2*f**3*s - 2310*Dd**2*f**3)/(630*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**7*k2**5*(-36*D1**2*b1*f*fd*r**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(r + s - 1)**2 - 42*D1**2*f**2*fd*r**2 - 84*D1**2*f**2*fd*r*s + 56*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 56*D1**2*f**2*fd*s - 28*D1**2*f**2*fd + 21*D1**2*f**2*fdd*r**2 + 42*D1**2*f**2*fdd*r*s - 28*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s**2 - 28*D1**2*f**2*fdd*s + 14*D1**2*f**2*fdd + 42*D1**2*f*fd**2*r**2 + 84*D1**2*f*fd**2*r*s - 56*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s**2 - 56*D1**2*f*fd**2*s + 14*D1**2*f*fd**2 - 72*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 108*D1*Dd*b1*f**2*s - 54*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 56*D1*Dd*f**3*r**2 - 112*D1*Dd*f**3*r*s + 84*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 84*D1*Dd*f**3*s - 42*D1*Dd*f**3 + 168*D1*Dd*f**2*fd*r**2 + 336*D1*Dd*f**2*fd*r*s - 238*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s**2 - 238*D1*Dd*f**2*fd*s + 84*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 28*D1*Ddd*f**3*r**2 + 56*D1*Ddd*f**3*r*s - 42*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 42*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 - 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 84*Dd**2*f**3*r**2 + 168*Dd**2*f**3*r*s - 126*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 126*Dd**2*f**3*s + 42*Dd**2*f**3)/(126*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct**6*k1**2*k2**4*(-3132*C*D1**2*b1*f*fd*r**2 - 6264*C*D1**2*b1*f*fd*r*s + 3132*C*D1**2*b1*f*fd*r - 3132*C*D1**2*b1*f*fd*s**2 + 3132*C*D1**2*b1*f*fd*s - 1566*C*D1**2*b1*f*fd + 2700*C*D1**2*b1*f*fdd*r**2 + 5400*C*D1**2*b1*f*fdd*r*s - 2700*C*D1**2*b1*f*fdd*r + 2700*C*D1**2*b1*f*fdd*s**2 - 2700*C*D1**2*b1*f*fdd*s + 1350*C*D1**2*b1*f*fdd + 2700*C*D1**2*b1*fd**2*r**2 + 5400*C*D1**2*b1*fd**2*r*s - 2700*C*D1**2*b1*fd**2*r + 2700*C*D1**2*b1*fd**2*s**2 - 2700*C*D1**2*b1*fd**2*s - 3870*C*D1**2*f**2*fd*r**2 - 7740*C*D1**2*f**2*fd*r*s + 5160*C*D1**2*f**2*fd*r - 3870*C*D1**2*f**2*fd*s**2 + 5160*C*D1**2*f**2*fd*s - 2580*C*D1**2*f**2*fd + 3150*C*D1**2*f**2*fdd*r**2 + 6300*C*D1**2*f**2*fdd*r*s - 4200*C*D1**2*f**2*fdd*r + 3150*C*D1**2*f**2*fdd*s**2 - 4200*C*D1**2*f**2*fdd*s + 2100*C*D1**2*f**2*fdd + 6300*C*D1**2*f*fd**2*r**2 + 12600*C*D1**2*f*fd**2*r*s - 8400*C*D1**2*f*fd**2*r + 6300*C*D1**2*f*fd**2*s**2 - 8400*C*D1**2*f*fd**2*s + 2100*C*D1**2*f*fd**2 - 6264*C*D1*Dd*b1*f**2*r**2 - 12528*C*D1*Dd*b1*f**2*r*s + 9396*C*D1*Dd*b1*f**2*r - 6264*C*D1*Dd*b1*f**2*s**2 + 9396*C*D1*Dd*b1*f**2*s - 4698*C*D1*Dd*b1*f**2 + 21600*C*D1*Dd*b1*f*fd*r**2 + 43200*C*D1*Dd*b1*f*fd*r*s - 27000*C*D1*Dd*b1*f*fd*r + 21600*C*D1*Dd*b1*f*fd*s**2 - 27000*C*D1*Dd*b1*f*fd*s + 8100*C*D1*Dd*b1*f*fd - 5160*C*D1*Dd*f**3*r**2 - 10320*C*D1*Dd*f**3*r*s + 7740*C*D1*Dd*f**3*r - 5160*C*D1*Dd*f**3*s**2 + 7740*C*D1*Dd*f**3*s - 3870*C*D1*Dd*f**3 + 25200*C*D1*Dd*f**2*fd*r**2 + 50400*C*D1*Dd*f**2*fd*r*s - 35700*C*D1*Dd*f**2*fd*r + 25200*C*D1*Dd*f**2*fd*s**2 - 35700*C*D1*Dd*f**2*fd*s + 12600*C*D1*Dd*f**2*fd + 5400*C*D1*Ddd*b1*f**2*r**2 + 10800*C*D1*Ddd*b1*f**2*r*s - 8100*C*D1*Ddd*b1*f**2*r + 5400*C*D1*Ddd*b1*f**2*s**2 - 8100*C*D1*Ddd*b1*f**2*s + 4050*C*D1*Ddd*b1*f**2 + 4200*C*D1*Ddd*f**3*r**2 + 8400*C*D1*Ddd*f**3*r*s - 6300*C*D1*Ddd*f**3*r + 4200*C*D1*Ddd*f**3*s**2 - 6300*C*D1*Ddd*f**3*s + 3150*C*D1*Ddd*f**3 + 16200*C*Dd**2*b1*f**2*r**2 + 32400*C*Dd**2*b1*f**2*r*s - 24300*C*Dd**2*b1*f**2*r + 16200*C*Dd**2*b1*f**2*s**2 - 24300*C*Dd**2*b1*f**2*s + 8100*C*Dd**2*b1*f**2 + 12600*C*Dd**2*f**3*r**2 + 25200*C*Dd**2*f**3*r*s - 18900*C*Dd**2*f**3*r + 12600*C*Dd**2*f**3*s**2 - 18900*C*Dd**2*f**3*s + 6300*C*Dd**2*f**3 + 2484*D1**2*b1*f*fd*r**2 + 4968*D1**2*b1*f*fd*r*s - 2484*D1**2*b1*f*fd*r + 2484*D1**2*b1*f*fd*s**2 - 2484*D1**2*b1*f*fd*s + 1242*D1**2*b1*f*fd - 2250*D1**2*b1*f*fdd*r**2 - 4500*D1**2*b1*f*fdd*r*s + 2250*D1**2*b1*f*fdd*r - 2250*D1**2*b1*f*fdd*s**2 + 2250*D1**2*b1*f*fdd*s - 1125*D1**2*b1*f*fdd - 2250*D1**2*b1*fd**2*r**2 - 4500*D1**2*b1*fd**2*r*s + 2250*D1**2*b1*fd**2*r - 2250*D1**2*b1*fd**2*s**2 + 2250*D1**2*b1*fd**2*s + 225*D1**2*bdd1*f**2*(6*C - 5)*(r + s - 1)**2 + 3090*D1**2*f**2*fd*r**2 + 6180*D1**2*f**2*fd*r*s - 4120*D1**2*f**2*fd*r + 3090*D1**2*f**2*fd*s**2 - 4120*D1**2*f**2*fd*s + 2060*D1**2*f**2*fd - 2625*D1**2*f**2*fdd*r**2 - 5250*D1**2*f**2*fdd*r*s + 3500*D1**2*f**2*fdd*r - 2625*D1**2*f**2*fdd*s**2 + 3500*D1**2*f**2*fdd*s - 1750*D1**2*f**2*fdd - 5250*D1**2*f*fd**2*r**2 - 10500*D1**2*f*fd**2*r*s + 7000*D1**2*f*fd**2*r - 5250*D1**2*f*fd**2*s**2 + 7000*D1**2*f*fd**2*s - 1750*D1**2*f*fd**2 + 4968*D1*Dd*b1*f**2*r**2 + 9936*D1*Dd*b1*f**2*r*s - 7452*D1*Dd*b1*f**2*r + 4968*D1*Dd*b1*f**2*s**2 - 7452*D1*Dd*b1*f**2*s + 3726*D1*Dd*b1*f**2 - 18000*D1*Dd*b1*f*fd*r**2 - 36000*D1*Dd*b1*f*fd*r*s + 22500*D1*Dd*b1*f*fd*r - 18000*D1*Dd*b1*f*fd*s**2 + 22500*D1*Dd*b1*f*fd*s - 6750*D1*Dd*b1*f*fd + 4120*D1*Dd*f**3*r**2 + 8240*D1*Dd*f**3*r*s - 6180*D1*Dd*f**3*r + 4120*D1*Dd*f**3*s**2 - 6180*D1*Dd*f**3*s + 3090*D1*Dd*f**3 - 21000*D1*Dd*f**2*fd*r**2 - 42000*D1*Dd*f**2*fd*r*s + 29750*D1*Dd*f**2*fd*r - 21000*D1*Dd*f**2*fd*s**2 + 29750*D1*Dd*f**2*fd*s - 10500*D1*Dd*f**2*fd - 4500*D1*Ddd*b1*f**2*r**2 - 9000*D1*Ddd*b1*f**2*r*s + 6750*D1*Ddd*b1*f**2*r - 4500*D1*Ddd*b1*f**2*s**2 + 6750*D1*Ddd*b1*f**2*s - 3375*D1*Ddd*b1*f**2 - 3500*D1*Ddd*f**3*r**2 - 7000*D1*Ddd*f**3*r*s + 5250*D1*Ddd*f**3*r - 3500*D1*Ddd*f**3*s**2 + 5250*D1*Ddd*f**3*s - 2625*D1*Ddd*f**3 - 18*D1*bd1*f*(r + s - 1)*(D1*f*(87*C - 69)*(r + s - 1) - D1*fd*(150*C - 125)*(2*r + 2*s - 1) - Dd*f*(150*C - 125)*(4*r + 4*s - 3)) - 13500*Dd**2*b1*f**2*r**2 - 27000*Dd**2*b1*f**2*r*s + 20250*Dd**2*b1*f**2*r - 13500*Dd**2*b1*f**2*s**2 + 20250*Dd**2*b1*f**2*s - 6750*Dd**2*b1*f**2 - 10500*Dd**2*f**3*r**2 - 21000*Dd**2*f**3*r*s + 15750*Dd**2*f**3*r - 10500*Dd**2*f**3*s**2 + 15750*Dd**2*f**3*s - 5250*Dd**2*f**3)/(630*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**6*k2**6*st**2*(C - 1)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 20*D1**2*f**2*fdd*s - 10*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 40*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 170*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 170*D1*Dd*f**2*fd*s - 60*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 30*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 30*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 90*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 90*Dd**2*f**3*s - 30*Dd**2*f**3)/(21*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**6*k2**6*(2970*C*D1**2*f**2*fd*r**2 + 5940*C*D1**2*f**2*fd*r*s - 3960*C*D1**2*f**2*fd*r + 2970*C*D1**2*f**2*fd*s**2 - 3960*C*D1**2*f**2*fd*s + 1980*C*D1**2*f**2*fd + 3960*C*D1*Dd*f**3*r**2 + 7920*C*D1*Dd*f**3*r*s - 5940*C*D1*Dd*f**3*r + 3960*C*D1*Dd*f**3*s**2 - 5940*C*D1*Dd*f**3*s + 2970*C*D1*Dd*f**3 + 495*D1**2*K*bdd1*f**2*r**2 + 990*D1**2*K*bdd1*f**2*r*s - 990*D1**2*K*bdd1*f**2*r + 495*D1**2*K*bdd1*f**2*s**2 - 990*D1**2*K*bdd1*f**2*s + 495*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(-7*K + 5*f + 7)*(r + s - 1)**2 + 1540*D1**2*bdd1*f**3*r**2 + 3080*D1**2*bdd1*f**3*r*s - 3080*D1**2*bdd1*f**3*r + 1540*D1**2*bdd1*f**3*s**2 - 3080*D1**2*bdd1*f**3*s + 1540*D1**2*bdd1*f**3 - 495*D1**2*bdd1*f**2*r**2 - 990*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*r - 495*D1**2*bdd1*f**2*s**2 + 990*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 1386*D1**2*bdd1*f*g2*r**2 - 2772*D1**2*bdd1*f*g2*r*s + 2772*D1**2*bdd1*f*g2*r - 1386*D1**2*bdd1*f*g2*s**2 + 2772*D1**2*bdd1*f*g2*s - 1386*D1**2*bdd1*f*g2 - 9520*D1**2*f**3*fd*r**2 - 19040*D1**2*f**3*fd*r*s + 14280*D1**2*f**3*fd*r - 9520*D1**2*f**3*fd*s**2 + 14280*D1**2*f**3*fd*s - 7140*D1**2*f**3*fd + 6300*D1**2*f**3*fdd*r**2 + 12600*D1**2*f**3*fdd*r*s - 9450*D1**2*f**3*fdd*r + 6300*D1**2*f**3*fdd*s**2 - 9450*D1**2*f**3*fdd*s + 4725*D1**2*f**3*fdd + 18900*D1**2*f**2*fd**2*r**2 + 37800*D1**2*f**2*fd**2*r*s - 28350*D1**2*f**2*fd**2*r + 18900*D1**2*f**2*fd**2*s**2 - 28350*D1**2*f**2*fd**2*s + 9450*D1**2*f**2*fd**2 - 2970*D1**2*f**2*fd*r**2 - 5940*D1**2*f**2*fd*r*s + 3960*D1**2*f**2*fd*r - 2970*D1**2*f**2*fd*s**2 + 3960*D1**2*f**2*fd*s - 1980*D1**2*f**2*fd + 1980*D1**2*f**2*gd2*r**2 + 3960*D1**2*f**2*gd2*r*s - 3960*D1**2*f**2*gd2*r + 1980*D1**2*f**2*gd2*s**2 - 3960*D1**2*f**2*gd2*s + 1980*D1**2*f**2*gd2 - 990*D1**2*f**2*gdd2*r**2 - 1980*D1**2*f**2*gdd2*r*s + 1980*D1**2*f**2*gdd2*r - 990*D1**2*f**2*gdd2*s**2 + 1980*D1**2*f**2*gdd2*s - 990*D1**2*f**2*gdd2 + 3960*D1**2*f*fd*g2*r**2 + 7920*D1**2*f*fd*g2*r*s - 3960*D1**2*f*fd*g2*r + 3960*D1**2*f*fd*g2*s**2 - 3960*D1**2*f*fd*g2*s + 1980*D1**2*f*fd*g2 - 3960*D1**2*f*fd*gd2*r**2 - 7920*D1**2*f*fd*gd2*r*s + 5940*D1**2*f*fd*gd2*r - 3960*D1**2*f*fd*gd2*s**2 + 5940*D1**2*f*fd*gd2*s - 1980*D1**2*f*fd*gd2 - 1980*D1**2*f*fdd*g2*r**2 - 3960*D1**2*f*fdd*g2*r*s + 1980*D1**2*f*fdd*g2*r - 1980*D1**2*f*fdd*g2*s**2 + 1980*D1**2*f*fdd*g2*s - 990*D1**2*f*fdd*g2 - 1980*D1**2*fd**2*g2*r**2 - 3960*D1**2*fd**2*g2*r*s + 1980*D1**2*fd**2*g2*r - 1980*D1**2*fd**2*g2*s**2 + 1980*D1**2*fd**2*g2*s - 9520*D1*Dd*f**4*r**2 - 19040*D1*Dd*f**4*r*s + 14280*D1*Dd*f**4*r - 9520*D1*Dd*f**4*s**2 + 14280*D1*Dd*f**4*s - 7140*D1*Dd*f**4 + 50400*D1*Dd*f**3*fd*r**2 + 100800*D1*Dd*f**3*fd*r*s - 75600*D1*Dd*f**3*fd*r + 50400*D1*Dd*f**3*fd*s**2 - 75600*D1*Dd*f**3*fd*s + 28350*D1*Dd*f**3*fd - 3960*D1*Dd*f**3*r**2 - 7920*D1*Dd*f**3*r*s + 5940*D1*Dd*f**3*r - 3960*D1*Dd*f**3*s**2 + 5940*D1*Dd*f**3*s - 2970*D1*Dd*f**3 + 7920*D1*Dd*f**2*g2*r**2 + 15840*D1*Dd*f**2*g2*r*s - 11880*D1*Dd*f**2*g2*r + 7920*D1*Dd*f**2*g2*s**2 - 11880*D1*Dd*f**2*g2*s + 5940*D1*Dd*f**2*g2 - 7920*D1*Dd*f**2*gd2*r**2 - 15840*D1*Dd*f**2*gd2*r*s + 13860*D1*Dd*f**2*gd2*r - 7920*D1*Dd*f**2*gd2*s**2 + 13860*D1*Dd*f**2*gd2*s - 5940*D1*Dd*f**2*gd2 - 15840*D1*Dd*f*fd*g2*r**2 - 31680*D1*Dd*f*fd*g2*r*s + 19800*D1*Dd*f*fd*g2*r - 15840*D1*Dd*f*fd*g2*s**2 + 19800*D1*Dd*f*fd*g2*s - 5940*D1*Dd*f*fd*g2 + 6300*D1*Ddd*f**4*r**2 + 12600*D1*Ddd*f**4*r*s - 9450*D1*Ddd*f**4*r + 6300*D1*Ddd*f**4*s**2 - 9450*D1*Ddd*f**4*s + 4725*D1*Ddd*f**4 - 3960*D1*Ddd*f**2*g2*r**2 - 7920*D1*Ddd*f**2*g2*r*s + 5940*D1*Ddd*f**2*g2*r - 3960*D1*Ddd*f**2*g2*s**2 + 5940*D1*Ddd*f**2*g2*s - 2970*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(95*f**3*(r + s - 1) + f**2*(-63*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) + (45*K + 18)*(r + s - 1)) - 9*f*(5*fd*(K - 1)*(2*r + 2*s - 1) + (14*g2 - 14*gd2)*(r + s - 1)) + 126*fd*g2*(r + s)) - Dd*f*(140*f**2 + 45*f*(K - 1) - 126*g2)*(4*r + 4*s - 3))*(r + s - 1) + 18900*Dd**2*f**4*r**2 + 37800*Dd**2*f**4*r*s - 28350*Dd**2*f**4*r + 18900*Dd**2*f**4*s**2 - 28350*Dd**2*f**4*s + 9450*Dd**2*f**4 - 11880*Dd**2*f**2*g2*r**2 - 23760*Dd**2*f**2*g2*r*s + 17820*Dd**2*f**2*g2*r - 11880*Dd**2*f**2*g2*s**2 + 17820*Dd**2*f**2*g2*s - 5940*Dd**2*f**2*g2 + 99*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(K - 1)*(r + s) - 7*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (7*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-7*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-7*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(252*C*D1**2*f*fd*r**2 + 504*C*D1**2*f*fd*r*s - 252*C*D1**2*f*fd*r + 252*C*D1**2*f*fd*s**2 - 252*C*D1**2*f*fd*s + 126*C*D1**2*f*fd + 504*C*D1*Dd*f**2*r**2 + 1008*C*D1*Dd*f**2*r*s - 756*C*D1*Dd*f**2*r + 504*C*D1*Dd*f**2*s**2 - 756*C*D1*Dd*f**2*s + 378*C*D1*Dd*f**2 - 180*D1**2*K*f*fd*r**2 - 360*D1**2*K*f*fd*r*s + 180*D1**2*K*f*fd*r - 180*D1**2*K*f*fd*s**2 + 180*D1**2*K*f*fd*s - 90*D1**2*K*f*fd + 90*D1**2*K*f*fdd*r**2 + 180*D1**2*K*f*fdd*r*s - 90*D1**2*K*f*fdd*r + 90*D1**2*K*f*fdd*s**2 - 90*D1**2*K*f*fdd*s + 45*D1**2*K*f*fdd + 90*D1**2*K*fd**2*r**2 + 180*D1**2*K*fd**2*r*s - 90*D1**2*K*fd**2*r + 90*D1**2*K*fd**2*s**2 - 90*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(-7*K + 5*f + 7)*(r + s - 1)**2 - 570*D1**2*f**2*fd*r**2 - 1140*D1**2*f**2*fd*r*s + 760*D1**2*f**2*fd*r - 570*D1**2*f**2*fd*s**2 + 760*D1**2*f**2*fd*s - 380*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 72*D1**2*f*fd*r**2 - 144*D1**2*f*fd*r*s + 72*D1**2*f*fd*r - 72*D1**2*f*fd*s**2 + 72*D1**2*f*fd*s - 36*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 45*D1**2*f*fdd + 252*D1**2*f*gd2*r**2 + 504*D1**2*f*gd2*r*s - 504*D1**2*f*gd2*r + 252*D1**2*f*gd2*s**2 - 504*D1**2*f*gd2*s + 252*D1**2*f*gd2 - 126*D1**2*f*gdd2*r**2 - 252*D1**2*f*gdd2*r*s + 252*D1**2*f*gdd2*r - 126*D1**2*f*gdd2*s**2 + 252*D1**2*f*gdd2*s - 126*D1**2*f*gdd2 - 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 252*D1**2*fd*g2*r**2 + 504*D1**2*fd*g2*r*s + 252*D1**2*fd*g2*s**2 - 252*D1**2*fd*gd2*r**2 - 504*D1**2*fd*gd2*r*s + 252*D1**2*fd*gd2*r - 252*D1**2*fd*gd2*s**2 + 252*D1**2*fd*gd2*s - 126*D1**2*fdd*g2*r**2 - 252*D1**2*fdd*g2*r*s - 126*D1**2*fdd*g2*s**2 - 360*D1*Dd*K*f**2*r**2 - 720*D1*Dd*K*f**2*r*s + 540*D1*Dd*K*f**2*r - 360*D1*Dd*K*f**2*s**2 + 540*D1*Dd*K*f**2*s - 270*D1*Dd*K*f**2 + 720*D1*Dd*K*f*fd*r**2 + 1440*D1*Dd*K*f*fd*r*s - 900*D1*Dd*K*f*fd*r + 720*D1*Dd*K*f*fd*s**2 - 900*D1*Dd*K*f*fd*s + 270*D1*Dd*K*f*fd - 760*D1*Dd*f**3*r**2 - 1520*D1*Dd*f**3*r*s + 1140*D1*Dd*f**3*r - 760*D1*Dd*f**3*s**2 + 1140*D1*Dd*f**3*s - 570*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 144*D1*Dd*f**2*r**2 - 288*D1*Dd*f**2*r*s + 216*D1*Dd*f**2*r - 144*D1*Dd*f**2*s**2 + 216*D1*Dd*f**2*s - 108*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 900*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 270*D1*Dd*f*fd + 1008*D1*Dd*f*g2*r**2 + 2016*D1*Dd*f*g2*r*s - 1512*D1*Dd*f*g2*r + 1008*D1*Dd*f*g2*s**2 - 1512*D1*Dd*f*g2*s + 756*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 2016*D1*Dd*f*gd2*r*s + 1764*D1*Dd*f*gd2*r - 1008*D1*Dd*f*gd2*s**2 + 1764*D1*Dd*f*gd2*s - 756*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 2016*D1*Dd*fd*g2*r*s + 756*D1*Dd*fd*g2*r - 1008*D1*Dd*fd*g2*s**2 + 756*D1*Dd*fd*g2*s + 180*D1*Ddd*K*f**2*r**2 + 360*D1*Ddd*K*f**2*r*s - 270*D1*Ddd*K*f**2*r + 180*D1*Ddd*K*f**2*s**2 - 270*D1*Ddd*K*f**2*s + 135*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 1008*D1*Ddd*f*g2*r*s + 756*D1*Ddd*f*g2*r - 504*D1*Ddd*f*g2*s**2 + 756*D1*Ddd*f*g2*s - 378*D1*Ddd*f*g2 + 36*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(K - 1)*(r + s - 1) + 7*fd*(K - 1)*(r + s)) - Dd*f*(-7*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 540*Dd**2*K*f**2*r**2 + 1080*Dd**2*K*f**2*r*s - 810*Dd**2*K*f**2*r + 540*Dd**2*K*f**2*s**2 - 810*Dd**2*K*f**2*s + 270*Dd**2*K*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 270*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 3024*Dd**2*f*g2*r*s + 2268*Dd**2*f*g2*r - 1512*Dd**2*f*g2*s**2 + 2268*Dd**2*f*g2*s - 756*Dd**2*f*g2))/(6930*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**6*k2**4*(-126*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(-40*C*D1**2*f*fd*r - 40*C*D1**2*f*fd*s + 20*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r + 20*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r + 20*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 + 80*C*D1*Dd*f*fd*r + 80*C*D1*Dd*f*fd*s - 60*C*D1*Dd*f*fd - 14*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 32*D1**2*f*fd*r**2 + 64*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 32*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 4*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 20*D1**2*fd**2 + 64*D1*Dd*f**2*r**2 + 128*D1*Dd*f**2*r*s - 96*D1*Dd*f**2*r + 64*D1*Dd*f**2*s**2 - 96*D1*Dd*f**2*s + 48*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 220*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 220*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2) + f*(252*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 45*D1**2*bdd1*f*(C*(4*r + 4*s - 2) + 3*r**2 + 2*r*(3*s - 5) + 3*s**2 - 10*s + 5) + 5*D1**2*(f*(fd*(28*C - 52) + fdd*(35 - 14*C))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(70 - 28*C)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 18*D1*bd1*(2*D1*f*(5*C*(2*r + 2*s - 1) + 4*r**2 + 2*r*(4*s - 9) + 4*s**2 - 18*s + 9) - 5*D1*fd*(r + s - 1)*(2*C + 6*r + 6*s - 5) - 5*Dd*f*(4*r + 4*s - 3)*(2*C + 3*r + 3*s - 5)) + 5*D1*f*(2*Dd*(f*(14*C - 26)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(14*C - 35)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + Ddd*f*(35 - 14*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 5*Dd**2*f**2*(210 - 84*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**5*f*k2**7*st**2*(-66*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 88*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fd*s**2 + 88*D1**2*b1*f*fd*s - 44*D1**2*b1*f*fd + 33*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*f*fdd*r*s - 44*D1**2*b1*f*fdd*r + 33*D1**2*b1*f*fdd*s**2 - 44*D1**2*b1*f*fdd*s + 22*D1**2*b1*f*fdd + 66*D1**2*b1*fd**2*r**2 + 132*D1**2*b1*fd**2*r*s - 88*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 88*D1**2*b1*fd**2*s + 22*D1**2*b1*fd**2 + 11*D1**2*bdd1*f**2*(r + s - 1)**2 - 56*D1**2*f**2*fd*r**2 - 112*D1**2*f**2*fd*r*s + 84*D1**2*f**2*fd*r - 56*D1**2*f**2*fd*s**2 + 84*D1**2*f**2*fd*s - 42*D1**2*f**2*fd + 28*D1**2*f**2*fdd*r**2 + 56*D1**2*f**2*fdd*r*s - 42*D1**2*f**2*fdd*r + 28*D1**2*f**2*fdd*s**2 - 42*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd + 84*D1**2*f*fd**2*r**2 + 168*D1**2*f*fd**2*r*s - 126*D1**2*f*fd**2*r + 84*D1**2*f*fd**2*s**2 - 126*D1**2*f*fd**2*s + 42*D1**2*f*fd**2 - 88*D1*Dd*b1*f**2*r**2 - 176*D1*Dd*b1*f**2*r*s + 132*D1*Dd*b1*f**2*r - 88*D1*Dd*b1*f**2*s**2 + 132*D1*Dd*b1*f**2*s - 66*D1*Dd*b1*f**2 + 264*D1*Dd*b1*f*fd*r**2 + 528*D1*Dd*b1*f*fd*r*s - 374*D1*Dd*b1*f*fd*r + 264*D1*Dd*b1*f*fd*s**2 - 374*D1*Dd*b1*f*fd*s + 132*D1*Dd*b1*f*fd - 56*D1*Dd*f**3*r**2 - 112*D1*Dd*f**3*r*s + 84*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 84*D1*Dd*f**3*s - 42*D1*Dd*f**3 + 224*D1*Dd*f**2*fd*r**2 + 448*D1*Dd*f**2*fd*r*s - 336*D1*Dd*f**2*fd*r + 224*D1*Dd*f**2*fd*s**2 - 336*D1*Dd*f**2*fd*s + 126*D1*Dd*f**2*fd + 44*D1*Ddd*b1*f**2*r**2 + 88*D1*Ddd*b1*f**2*r*s - 66*D1*Ddd*b1*f**2*r + 44*D1*Ddd*b1*f**2*s**2 - 66*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 + 28*D1*Ddd*f**3*r**2 + 56*D1*Ddd*f**3*r*s - 42*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 42*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 - 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + 132*Dd**2*b1*f**2*r**2 + 264*Dd**2*b1*f**2*r*s - 198*Dd**2*b1*f**2*r + 132*Dd**2*b1*f**2*s**2 - 198*Dd**2*b1*f**2*s + 66*Dd**2*b1*f**2 + 84*Dd**2*f**3*r**2 + 168*Dd**2*f**3*r*s - 126*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 126*Dd**2*f**3*s + 42*Dd**2*f**3)/(66*d**2*k1*k3**6) + D1**2*Pk1*Pkdd3*ct**5*k1**3*k2**3*(-3168*C*D1**2*b1*f*fd*r**2 - 6336*C*D1**2*b1*f*fd*r*s + 3168*C*D1**2*b1*f*fd*r - 3168*C*D1**2*b1*f*fd*s**2 + 3168*C*D1**2*b1*f*fd*s - 1584*C*D1**2*b1*f*fd + 3600*C*D1**2*b1*f*fdd*r**2 + 7200*C*D1**2*b1*f*fdd*r*s - 3600*C*D1**2*b1*f*fdd*r + 3600*C*D1**2*b1*f*fdd*s**2 - 3600*C*D1**2*b1*f*fdd*s + 1800*C*D1**2*b1*f*fdd + 3600*C*D1**2*b1*fd**2*r**2 + 7200*C*D1**2*b1*fd**2*r*s - 3600*C*D1**2*b1*fd**2*r + 3600*C*D1**2*b1*fd**2*s**2 - 3600*C*D1**2*b1*fd**2*s - 4080*C*D1**2*f**2*fd*r**2 - 8160*C*D1**2*f**2*fd*r*s + 5440*C*D1**2*f**2*fd*r - 4080*C*D1**2*f**2*fd*s**2 + 5440*C*D1**2*f**2*fd*s - 2720*C*D1**2*f**2*fd + 4200*C*D1**2*f**2*fdd*r**2 + 8400*C*D1**2*f**2*fdd*r*s - 5600*C*D1**2*f**2*fdd*r + 4200*C*D1**2*f**2*fdd*s**2 - 5600*C*D1**2*f**2*fdd*s + 2800*C*D1**2*f**2*fdd + 8400*C*D1**2*f*fd**2*r**2 + 16800*C*D1**2*f*fd**2*r*s - 11200*C*D1**2*f*fd**2*r + 8400*C*D1**2*f*fd**2*s**2 - 11200*C*D1**2*f*fd**2*s + 2800*C*D1**2*f*fd**2 - 6336*C*D1*Dd*b1*f**2*r**2 - 12672*C*D1*Dd*b1*f**2*r*s + 9504*C*D1*Dd*b1*f**2*r - 6336*C*D1*Dd*b1*f**2*s**2 + 9504*C*D1*Dd*b1*f**2*s - 4752*C*D1*Dd*b1*f**2 + 28800*C*D1*Dd*b1*f*fd*r**2 + 57600*C*D1*Dd*b1*f*fd*r*s - 36000*C*D1*Dd*b1*f*fd*r + 28800*C*D1*Dd*b1*f*fd*s**2 - 36000*C*D1*Dd*b1*f*fd*s + 10800*C*D1*Dd*b1*f*fd - 5440*C*D1*Dd*f**3*r**2 - 10880*C*D1*Dd*f**3*r*s + 8160*C*D1*Dd*f**3*r - 5440*C*D1*Dd*f**3*s**2 + 8160*C*D1*Dd*f**3*s - 4080*C*D1*Dd*f**3 + 33600*C*D1*Dd*f**2*fd*r**2 + 67200*C*D1*Dd*f**2*fd*r*s - 47600*C*D1*Dd*f**2*fd*r + 33600*C*D1*Dd*f**2*fd*s**2 - 47600*C*D1*Dd*f**2*fd*s + 16800*C*D1*Dd*f**2*fd + 7200*C*D1*Ddd*b1*f**2*r**2 + 14400*C*D1*Ddd*b1*f**2*r*s - 10800*C*D1*Ddd*b1*f**2*r + 7200*C*D1*Ddd*b1*f**2*s**2 - 10800*C*D1*Ddd*b1*f**2*s + 5400*C*D1*Ddd*b1*f**2 + 5600*C*D1*Ddd*f**3*r**2 + 11200*C*D1*Ddd*f**3*r*s - 8400*C*D1*Ddd*f**3*r + 5600*C*D1*Ddd*f**3*s**2 - 8400*C*D1*Ddd*f**3*s + 4200*C*D1*Ddd*f**3 + 21600*C*Dd**2*b1*f**2*r**2 + 43200*C*Dd**2*b1*f**2*r*s - 32400*C*Dd**2*b1*f**2*r + 21600*C*Dd**2*b1*f**2*s**2 - 32400*C*Dd**2*b1*f**2*s + 10800*C*Dd**2*b1*f**2 + 16800*C*Dd**2*f**3*r**2 + 33600*C*Dd**2*f**3*r*s - 25200*C*Dd**2*f**3*r + 16800*C*Dd**2*f**3*s**2 - 25200*C*Dd**2*f**3*s + 8400*C*Dd**2*f**3 + 2250*D1**2*b1*f*fd*r**2 + 4500*D1**2*b1*f*fd*r*s - 2250*D1**2*b1*f*fd*r + 2250*D1**2*b1*f*fd*s**2 - 2250*D1**2*b1*f*fd*s + 1125*D1**2*b1*f*fd - 2700*D1**2*b1*f*fdd*r**2 - 5400*D1**2*b1*f*fdd*r*s + 2700*D1**2*b1*f*fdd*r - 2700*D1**2*b1*f*fdd*s**2 + 2700*D1**2*b1*f*fdd*s - 1350*D1**2*b1*f*fdd - 2700*D1**2*b1*fd**2*r**2 - 5400*D1**2*b1*fd**2*r*s + 2700*D1**2*b1*fd**2*r - 2700*D1**2*b1*fd**2*s**2 + 2700*D1**2*b1*fd**2*s + 450*D1**2*bdd1*f**2*(4*C - 3)*(r + s - 1)**2 + 2925*D1**2*f**2*fd*r**2 + 5850*D1**2*f**2*fd*r*s - 3900*D1**2*f**2*fd*r + 2925*D1**2*f**2*fd*s**2 - 3900*D1**2*f**2*fd*s + 1950*D1**2*f**2*fd - 3150*D1**2*f**2*fdd*r**2 - 6300*D1**2*f**2*fdd*r*s + 4200*D1**2*f**2*fdd*r - 3150*D1**2*f**2*fdd*s**2 + 4200*D1**2*f**2*fdd*s - 2100*D1**2*f**2*fdd - 6300*D1**2*f*fd**2*r**2 - 12600*D1**2*f*fd**2*r*s + 8400*D1**2*f*fd**2*r - 6300*D1**2*f*fd**2*s**2 + 8400*D1**2*f*fd**2*s - 2100*D1**2*f*fd**2 + 4500*D1*Dd*b1*f**2*r**2 + 9000*D1*Dd*b1*f**2*r*s - 6750*D1*Dd*b1*f**2*r + 4500*D1*Dd*b1*f**2*s**2 - 6750*D1*Dd*b1*f**2*s + 3375*D1*Dd*b1*f**2 - 21600*D1*Dd*b1*f*fd*r**2 - 43200*D1*Dd*b1*f*fd*r*s + 27000*D1*Dd*b1*f*fd*r - 21600*D1*Dd*b1*f*fd*s**2 + 27000*D1*Dd*b1*f*fd*s - 8100*D1*Dd*b1*f*fd + 3900*D1*Dd*f**3*r**2 + 7800*D1*Dd*f**3*r*s - 5850*D1*Dd*f**3*r + 3900*D1*Dd*f**3*s**2 - 5850*D1*Dd*f**3*s + 2925*D1*Dd*f**3 - 25200*D1*Dd*f**2*fd*r**2 - 50400*D1*Dd*f**2*fd*r*s + 35700*D1*Dd*f**2*fd*r - 25200*D1*Dd*f**2*fd*s**2 + 35700*D1*Dd*f**2*fd*s - 12600*D1*Dd*f**2*fd - 5400*D1*Ddd*b1*f**2*r**2 - 10800*D1*Ddd*b1*f**2*r*s + 8100*D1*Ddd*b1*f**2*r - 5400*D1*Ddd*b1*f**2*s**2 + 8100*D1*Ddd*b1*f**2*s - 4050*D1*Ddd*b1*f**2 - 4200*D1*Ddd*f**3*r**2 - 8400*D1*Ddd*f**3*r*s + 6300*D1*Ddd*f**3*r - 4200*D1*Ddd*f**3*s**2 + 6300*D1*Ddd*f**3*s - 3150*D1*Ddd*f**3 - 9*D1*bd1*f*(r + s - 1)*(D1*f*(176*C - 125)*(r + s - 1) - D1*fd*(400*C - 300)*(2*r + 2*s - 1) - Dd*f*(400*C - 300)*(4*r + 4*s - 3)) - 16200*Dd**2*b1*f**2*r**2 - 32400*Dd**2*b1*f**2*r*s + 24300*Dd**2*b1*f**2*r - 16200*Dd**2*b1*f**2*s**2 + 24300*Dd**2*b1*f**2*s - 8100*Dd**2*b1*f**2 - 12600*Dd**2*f**3*r**2 - 25200*Dd**2*f**3*r*s + 18900*Dd**2*f**3*r - 12600*Dd**2*f**3*s**2 + 18900*Dd**2*f**3*s - 6300*Dd**2*f**3)/(630*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**5*k1*k2**5*st**2*(-4032*C*D1**2*b1*f*fd*r**2 - 8064*C*D1**2*b1*f*fd*r*s + 4032*C*D1**2*b1*f*fd*r - 4032*C*D1**2*b1*f*fd*s**2 + 4032*C*D1**2*b1*f*fd*s - 2016*C*D1**2*b1*f*fd + 2520*C*D1**2*b1*f*fdd*r**2 + 5040*C*D1**2*b1*f*fdd*r*s - 2520*C*D1**2*b1*f*fdd*r + 2520*C*D1**2*b1*f*fdd*s**2 - 2520*C*D1**2*b1*f*fdd*s + 1260*C*D1**2*b1*f*fdd + 2520*C*D1**2*b1*fd**2*r**2 + 5040*C*D1**2*b1*fd**2*r*s - 2520*C*D1**2*b1*fd**2*r + 2520*C*D1**2*b1*fd**2*s**2 - 2520*C*D1**2*b1*fd**2*s - 3552*C*D1**2*f**2*fd*r**2 - 7104*C*D1**2*f**2*fd*r*s + 4736*C*D1**2*f**2*fd*r - 3552*C*D1**2*f**2*fd*s**2 + 4736*C*D1**2*f**2*fd*s - 2368*C*D1**2*f**2*fd + 2100*C*D1**2*f**2*fdd*r**2 + 4200*C*D1**2*f**2*fdd*r*s - 2800*C*D1**2*f**2*fdd*r + 2100*C*D1**2*f**2*fdd*s**2 - 2800*C*D1**2*f**2*fdd*s + 1400*C*D1**2*f**2*fdd + 4200*C*D1**2*f*fd**2*r**2 + 8400*C*D1**2*f*fd**2*r*s - 5600*C*D1**2*f*fd**2*r + 4200*C*D1**2*f*fd**2*s**2 - 5600*C*D1**2*f*fd**2*s + 1400*C*D1**2*f*fd**2 - 8064*C*D1*Dd*b1*f**2*r**2 - 16128*C*D1*Dd*b1*f**2*r*s + 12096*C*D1*Dd*b1*f**2*r - 8064*C*D1*Dd*b1*f**2*s**2 + 12096*C*D1*Dd*b1*f**2*s - 6048*C*D1*Dd*b1*f**2 + 20160*C*D1*Dd*b1*f*fd*r**2 + 40320*C*D1*Dd*b1*f*fd*r*s - 25200*C*D1*Dd*b1*f*fd*r + 20160*C*D1*Dd*b1*f*fd*s**2 - 25200*C*D1*Dd*b1*f*fd*s + 7560*C*D1*Dd*b1*f*fd - 4736*C*D1*Dd*f**3*r**2 - 9472*C*D1*Dd*f**3*r*s + 7104*C*D1*Dd*f**3*r - 4736*C*D1*Dd*f**3*s**2 + 7104*C*D1*Dd*f**3*s - 3552*C*D1*Dd*f**3 + 16800*C*D1*Dd*f**2*fd*r**2 + 33600*C*D1*Dd*f**2*fd*r*s - 23800*C*D1*Dd*f**2*fd*r + 16800*C*D1*Dd*f**2*fd*s**2 - 23800*C*D1*Dd*f**2*fd*s + 8400*C*D1*Dd*f**2*fd + 5040*C*D1*Ddd*b1*f**2*r**2 + 10080*C*D1*Ddd*b1*f**2*r*s - 7560*C*D1*Ddd*b1*f**2*r + 5040*C*D1*Ddd*b1*f**2*s**2 - 7560*C*D1*Ddd*b1*f**2*s + 3780*C*D1*Ddd*b1*f**2 + 2800*C*D1*Ddd*f**3*r**2 + 5600*C*D1*Ddd*f**3*r*s - 4200*C*D1*Ddd*f**3*r + 2800*C*D1*Ddd*f**3*s**2 - 4200*C*D1*Ddd*f**3*s + 2100*C*D1*Ddd*f**3 + 15120*C*Dd**2*b1*f**2*r**2 + 30240*C*Dd**2*b1*f**2*r*s - 22680*C*Dd**2*b1*f**2*r + 15120*C*Dd**2*b1*f**2*s**2 - 22680*C*Dd**2*b1*f**2*s + 7560*C*Dd**2*b1*f**2 + 8400*C*Dd**2*f**3*r**2 + 16800*C*Dd**2*f**3*r*s - 12600*C*Dd**2*f**3*r + 8400*C*Dd**2*f**3*s**2 - 12600*C*Dd**2*f**3*s + 4200*C*Dd**2*f**3 + 3492*D1**2*b1*f*fd*r**2 + 6984*D1**2*b1*f*fd*r*s - 3492*D1**2*b1*f*fd*r + 3492*D1**2*b1*f*fd*s**2 - 3492*D1**2*b1*f*fd*s + 1746*D1**2*b1*f*fd - 2250*D1**2*b1*f*fdd*r**2 - 4500*D1**2*b1*f*fdd*r*s + 2250*D1**2*b1*f*fdd*r - 2250*D1**2*b1*f*fdd*s**2 + 2250*D1**2*b1*f*fdd*s - 1125*D1**2*b1*f*fdd - 2250*D1**2*b1*fd**2*r**2 - 4500*D1**2*b1*fd**2*r*s + 2250*D1**2*b1*fd**2*r - 2250*D1**2*b1*fd**2*s**2 + 2250*D1**2*b1*fd**2*s + 45*D1**2*bdd1*f**2*(28*C - 25)*(r + s - 1)**2 + 3102*D1**2*f**2*fd*r**2 + 6204*D1**2*f**2*fd*r*s - 4136*D1**2*f**2*fd*r + 3102*D1**2*f**2*fd*s**2 - 4136*D1**2*f**2*fd*s + 2068*D1**2*f**2*fd - 1875*D1**2*f**2*fdd*r**2 - 3750*D1**2*f**2*fdd*r*s + 2500*D1**2*f**2*fdd*r - 1875*D1**2*f**2*fdd*s**2 + 2500*D1**2*f**2*fdd*s - 1250*D1**2*f**2*fdd - 3750*D1**2*f*fd**2*r**2 - 7500*D1**2*f*fd**2*r*s + 5000*D1**2*f*fd**2*r - 3750*D1**2*f*fd**2*s**2 + 5000*D1**2*f*fd**2*s - 1250*D1**2*f*fd**2 + 6984*D1*Dd*b1*f**2*r**2 + 13968*D1*Dd*b1*f**2*r*s - 10476*D1*Dd*b1*f**2*r + 6984*D1*Dd*b1*f**2*s**2 - 10476*D1*Dd*b1*f**2*s + 5238*D1*Dd*b1*f**2 - 18000*D1*Dd*b1*f*fd*r**2 - 36000*D1*Dd*b1*f*fd*r*s + 22500*D1*Dd*b1*f*fd*r - 18000*D1*Dd*b1*f*fd*s**2 + 22500*D1*Dd*b1*f*fd*s - 6750*D1*Dd*b1*f*fd + 4136*D1*Dd*f**3*r**2 + 8272*D1*Dd*f**3*r*s - 6204*D1*Dd*f**3*r + 4136*D1*Dd*f**3*s**2 - 6204*D1*Dd*f**3*s + 3102*D1*Dd*f**3 - 15000*D1*Dd*f**2*fd*r**2 - 30000*D1*Dd*f**2*fd*r*s + 21250*D1*Dd*f**2*fd*r - 15000*D1*Dd*f**2*fd*s**2 + 21250*D1*Dd*f**2*fd*s - 7500*D1*Dd*f**2*fd - 4500*D1*Ddd*b1*f**2*r**2 - 9000*D1*Ddd*b1*f**2*r*s + 6750*D1*Ddd*b1*f**2*r - 4500*D1*Ddd*b1*f**2*s**2 + 6750*D1*Ddd*b1*f**2*s - 3375*D1*Ddd*b1*f**2 - 2500*D1*Ddd*f**3*r**2 - 5000*D1*Ddd*f**3*r*s + 3750*D1*Ddd*f**3*r - 2500*D1*Ddd*f**3*s**2 + 3750*D1*Ddd*f**3*s - 1875*D1*Ddd*f**3 - 18*D1*bd1*f*(r + s - 1)*(D1*f*(112*C - 97)*(r + s - 1) - D1*fd*(140*C - 125)*(2*r + 2*s - 1) - Dd*f*(140*C - 125)*(4*r + 4*s - 3)) - 13500*Dd**2*b1*f**2*r**2 - 27000*Dd**2*b1*f**2*r*s + 20250*Dd**2*b1*f**2*r - 13500*Dd**2*b1*f**2*s**2 + 20250*Dd**2*b1*f**2*s - 6750*Dd**2*b1*f**2 - 7500*Dd**2*f**3*r**2 - 15000*Dd**2*f**3*r*s + 11250*Dd**2*f**3*r - 7500*Dd**2*f**3*s**2 + 11250*Dd**2*f**3*s - 3750*Dd**2*f**3)/(630*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**5*k1*k2**5*(11880*C*D1**2*f**2*fd*r**2 + 23760*C*D1**2*f**2*fd*r*s - 15840*C*D1**2*f**2*fd*r + 11880*C*D1**2*f**2*fd*s**2 - 15840*C*D1**2*f**2*fd*s + 7920*C*D1**2*f**2*fd + 15840*C*D1*Dd*f**3*r**2 + 31680*C*D1*Dd*f**3*r*s - 23760*C*D1*Dd*f**3*r + 15840*C*D1*Dd*f**3*s**2 - 23760*C*D1*Dd*f**3*s + 11880*C*D1*Dd*f**3 + 2970*D1**2*K*bdd1*f**2*r**2 + 5940*D1**2*K*bdd1*f**2*r*s - 5940*D1**2*K*bdd1*f**2*r + 2970*D1**2*K*bdd1*f**2*s**2 - 5940*D1**2*K*bdd1*f**2*s + 2970*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(-42*K + 25*f + 35)*(r + s - 1)**2 + 1925*D1**2*bdd1*f**3*r**2 + 3850*D1**2*bdd1*f**3*r*s - 3850*D1**2*bdd1*f**3*r + 1925*D1**2*bdd1*f**3*s**2 - 3850*D1**2*bdd1*f**3*s + 1925*D1**2*bdd1*f**3 - 2475*D1**2*bdd1*f**2*r**2 - 4950*D1**2*bdd1*f**2*r*s + 4950*D1**2*bdd1*f**2*r - 2475*D1**2*bdd1*f**2*s**2 + 4950*D1**2*bdd1*f**2*s - 2475*D1**2*bdd1*f**2 - 8316*D1**2*bdd1*f*g2*r**2 - 16632*D1**2*bdd1*f*g2*r*s + 16632*D1**2*bdd1*f*g2*r - 8316*D1**2*bdd1*f*g2*s**2 + 16632*D1**2*bdd1*f*g2*s - 8316*D1**2*bdd1*f*g2 - 14420*D1**2*f**3*fd*r**2 - 28840*D1**2*f**3*fd*r*s + 21630*D1**2*f**3*fd*r - 14420*D1**2*f**3*fd*s**2 + 21630*D1**2*f**3*fd*s - 10815*D1**2*f**3*fd + 12600*D1**2*f**3*fdd*r**2 + 25200*D1**2*f**3*fdd*r*s - 18900*D1**2*f**3*fdd*r + 12600*D1**2*f**3*fdd*s**2 - 18900*D1**2*f**3*fdd*s + 9450*D1**2*f**3*fdd + 37800*D1**2*f**2*fd**2*r**2 + 75600*D1**2*f**2*fd**2*r*s - 56700*D1**2*f**2*fd**2*r + 37800*D1**2*f**2*fd**2*s**2 - 56700*D1**2*f**2*fd**2*s + 18900*D1**2*f**2*fd**2 - 10395*D1**2*f**2*fd*r**2 - 20790*D1**2*f**2*fd*r*s + 13860*D1**2*f**2*fd*r - 10395*D1**2*f**2*fd*s**2 + 13860*D1**2*f**2*fd*s - 6930*D1**2*f**2*fd + 9108*D1**2*f**2*gd2*r**2 + 18216*D1**2*f**2*gd2*r*s - 18216*D1**2*f**2*gd2*r + 9108*D1**2*f**2*gd2*s**2 - 18216*D1**2*f**2*gd2*s + 9108*D1**2*f**2*gd2 - 5940*D1**2*f**2*gdd2*r**2 - 11880*D1**2*f**2*gdd2*r*s + 11880*D1**2*f**2*gdd2*r - 5940*D1**2*f**2*gdd2*s**2 + 11880*D1**2*f**2*gdd2*s - 5940*D1**2*f**2*gdd2 + 18216*D1**2*f*fd*g2*r**2 + 36432*D1**2*f*fd*g2*r*s - 18216*D1**2*f*fd*g2*r + 18216*D1**2*f*fd*g2*s**2 - 18216*D1**2*f*fd*g2*s + 9108*D1**2*f*fd*g2 - 23760*D1**2*f*fd*gd2*r**2 - 47520*D1**2*f*fd*gd2*r*s + 35640*D1**2*f*fd*gd2*r - 23760*D1**2*f*fd*gd2*s**2 + 35640*D1**2*f*fd*gd2*s - 11880*D1**2*f*fd*gd2 - 11880*D1**2*f*fdd*g2*r**2 - 23760*D1**2*f*fdd*g2*r*s + 11880*D1**2*f*fdd*g2*r - 11880*D1**2*f*fdd*g2*s**2 + 11880*D1**2*f*fdd*g2*s - 5940*D1**2*f*fdd*g2 - 11880*D1**2*fd**2*g2*r**2 - 23760*D1**2*fd**2*g2*r*s + 11880*D1**2*fd**2*g2*r - 11880*D1**2*fd**2*g2*s**2 + 11880*D1**2*fd**2*g2*s - 14420*D1*Dd*f**4*r**2 - 28840*D1*Dd*f**4*r*s + 21630*D1*Dd*f**4*r - 14420*D1*Dd*f**4*s**2 + 21630*D1*Dd*f**4*s - 10815*D1*Dd*f**4 + 100800*D1*Dd*f**3*fd*r**2 + 201600*D1*Dd*f**3*fd*r*s - 151200*D1*Dd*f**3*fd*r + 100800*D1*Dd*f**3*fd*s**2 - 151200*D1*Dd*f**3*fd*s + 56700*D1*Dd*f**3*fd - 13860*D1*Dd*f**3*r**2 - 27720*D1*Dd*f**3*r*s + 20790*D1*Dd*f**3*r - 13860*D1*Dd*f**3*s**2 + 20790*D1*Dd*f**3*s - 10395*D1*Dd*f**3 + 36432*D1*Dd*f**2*g2*r**2 + 72864*D1*Dd*f**2*g2*r*s - 54648*D1*Dd*f**2*g2*r + 36432*D1*Dd*f**2*g2*s**2 - 54648*D1*Dd*f**2*g2*s + 27324*D1*Dd*f**2*g2 - 47520*D1*Dd*f**2*gd2*r**2 - 95040*D1*Dd*f**2*gd2*r*s + 83160*D1*Dd*f**2*gd2*r - 47520*D1*Dd*f**2*gd2*s**2 + 83160*D1*Dd*f**2*gd2*s - 35640*D1*Dd*f**2*gd2 - 95040*D1*Dd*f*fd*g2*r**2 - 190080*D1*Dd*f*fd*g2*r*s + 118800*D1*Dd*f*fd*g2*r - 95040*D1*Dd*f*fd*g2*s**2 + 118800*D1*Dd*f*fd*g2*s - 35640*D1*Dd*f*fd*g2 + 12600*D1*Ddd*f**4*r**2 + 25200*D1*Ddd*f**4*r*s - 18900*D1*Ddd*f**4*r + 12600*D1*Ddd*f**4*s**2 - 18900*D1*Ddd*f**4*s + 9450*D1*Ddd*f**4 - 23760*D1*Ddd*f**2*g2*r**2 - 47520*D1*Ddd*f**2*g2*r*s + 35640*D1*Ddd*f**2*g2*r - 23760*D1*Ddd*f**2*g2*s**2 + 35640*D1*Ddd*f**2*g2*s - 17820*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(125*f**3*(r + s - 1) + f**2*(-504*C*(r + s - 1) - 350*fd*(3*r + 3*s - 2) + (414*K + 117)*(r + s - 1)) - 6*f*(15*fd*(6*K - 5)*(2*r + 2*s - 1) + (182*g2 - 252*gd2)*(r + s - 1)) + 1512*fd*g2*(r + s)) - 2*Dd*f*(175*f**2 + 45*f*(6*K - 5) - 756*g2)*(4*r + 4*s - 3))*(r + s - 1) + 37800*Dd**2*f**4*r**2 + 75600*Dd**2*f**4*r*s - 56700*Dd**2*f**4*r + 37800*Dd**2*f**4*s**2 - 56700*Dd**2*f**4*s + 18900*Dd**2*f**4 - 71280*Dd**2*f**2*g2*r**2 - 142560*Dd**2*f**2*g2*r*s + 106920*Dd**2*f**2*g2*r - 71280*Dd**2*f**2*g2*s**2 + 106920*Dd**2*f**2*g2*s - 35640*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(3*f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 14*fd*(13*K - 10)*(r + s) - 21*fdd*(6*K - 5)*(r + s))) + D1*(2*Dd*(54*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(75*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (91*K - 70)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 21*fd*(6*K - 5)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-42*K + 25*f + 35)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-42*K + 25*f + 35)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(1008*C*D1**2*f*fd*r**2 + 2016*C*D1**2*f*fd*r*s - 1008*C*D1**2*f*fd*r + 1008*C*D1**2*f*fd*s**2 - 1008*C*D1**2*f*fd*s + 504*C*D1**2*f*fd + 2016*C*D1*Dd*f**2*r**2 + 4032*C*D1*Dd*f**2*r*s - 3024*C*D1*Dd*f**2*r + 2016*C*D1*Dd*f**2*s**2 - 3024*C*D1*Dd*f**2*s + 1512*C*D1*Dd*f**2 - 828*D1**2*K*f*fd*r**2 - 1656*D1**2*K*f*fd*r*s + 828*D1**2*K*f*fd*r - 828*D1**2*K*f*fd*s**2 + 828*D1**2*K*f*fd*s - 414*D1**2*K*f*fd + 540*D1**2*K*f*fdd*r**2 + 1080*D1**2*K*f*fdd*r*s - 540*D1**2*K*f*fdd*r + 540*D1**2*K*f*fdd*s**2 - 540*D1**2*K*f*fdd*s + 270*D1**2*K*f*fdd + 540*D1**2*K*fd**2*r**2 + 1080*D1**2*K*fd**2*r*s - 540*D1**2*K*fd**2*r + 540*D1**2*K*fd**2*s**2 - 540*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(-42*K + 25*f + 35)*(r + s - 1)**2 - 375*D1**2*f**2*fd*r**2 - 750*D1**2*f**2*fd*r*s + 500*D1**2*f**2*fd*r - 375*D1**2*f**2*fd*s**2 + 500*D1**2*f**2*fd*s - 250*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 700*D1**2*f**2*fdd*s + 350*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1400*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 - 234*D1**2*f*fd*r**2 - 468*D1**2*f*fd*r*s + 234*D1**2*f*fd*r - 234*D1**2*f*fd*s**2 + 234*D1**2*f*fd*s - 117*D1**2*f*fd - 450*D1**2*f*fdd*r**2 - 900*D1**2*f*fdd*r*s + 450*D1**2*f*fdd*r - 450*D1**2*f*fdd*s**2 + 450*D1**2*f*fdd*s - 225*D1**2*f*fdd + 1092*D1**2*f*gd2*r**2 + 2184*D1**2*f*gd2*r*s - 2184*D1**2*f*gd2*r + 1092*D1**2*f*gd2*s**2 - 2184*D1**2*f*gd2*s + 1092*D1**2*f*gd2 - 756*D1**2*f*gdd2*r**2 - 1512*D1**2*f*gdd2*r*s + 1512*D1**2*f*gdd2*r - 756*D1**2*f*gdd2*s**2 + 1512*D1**2*f*gdd2*s - 756*D1**2*f*gdd2 - 450*D1**2*fd**2*r**2 - 900*D1**2*fd**2*r*s + 450*D1**2*fd**2*r - 450*D1**2*fd**2*s**2 + 450*D1**2*fd**2*s + 1092*D1**2*fd*g2*r**2 + 2184*D1**2*fd*g2*r*s + 1092*D1**2*fd*g2*s**2 - 1512*D1**2*fd*gd2*r**2 - 3024*D1**2*fd*gd2*r*s + 1512*D1**2*fd*gd2*r - 1512*D1**2*fd*gd2*s**2 + 1512*D1**2*fd*gd2*s - 756*D1**2*fdd*g2*r**2 - 1512*D1**2*fdd*g2*r*s - 756*D1**2*fdd*g2*s**2 - 1656*D1*Dd*K*f**2*r**2 - 3312*D1*Dd*K*f**2*r*s + 2484*D1*Dd*K*f**2*r - 1656*D1*Dd*K*f**2*s**2 + 2484*D1*Dd*K*f**2*s - 1242*D1*Dd*K*f**2 + 4320*D1*Dd*K*f*fd*r**2 + 8640*D1*Dd*K*f*fd*r*s - 5400*D1*Dd*K*f*fd*r + 4320*D1*Dd*K*f*fd*s**2 - 5400*D1*Dd*K*f*fd*s + 1620*D1*Dd*K*f*fd - 500*D1*Dd*f**3*r**2 - 1000*D1*Dd*f**3*r*s + 750*D1*Dd*f**3*r - 500*D1*Dd*f**3*s**2 + 750*D1*Dd*f**3*s - 375*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 5950*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 5950*D1*Dd*f**2*fd*s + 2100*D1*Dd*f**2*fd - 468*D1*Dd*f**2*r**2 - 936*D1*Dd*f**2*r*s + 702*D1*Dd*f**2*r - 468*D1*Dd*f**2*s**2 + 702*D1*Dd*f**2*s - 351*D1*Dd*f**2 - 3600*D1*Dd*f*fd*r**2 - 7200*D1*Dd*f*fd*r*s + 4500*D1*Dd*f*fd*r - 3600*D1*Dd*f*fd*s**2 + 4500*D1*Dd*f*fd*s - 1350*D1*Dd*f*fd + 4368*D1*Dd*f*g2*r**2 + 8736*D1*Dd*f*g2*r*s - 6552*D1*Dd*f*g2*r + 4368*D1*Dd*f*g2*s**2 - 6552*D1*Dd*f*g2*s + 3276*D1*Dd*f*g2 - 6048*D1*Dd*f*gd2*r**2 - 12096*D1*Dd*f*gd2*r*s + 10584*D1*Dd*f*gd2*r - 6048*D1*Dd*f*gd2*s**2 + 10584*D1*Dd*f*gd2*s - 4536*D1*Dd*f*gd2 - 6048*D1*Dd*fd*g2*r**2 - 12096*D1*Dd*fd*g2*r*s + 4536*D1*Dd*fd*g2*r - 6048*D1*Dd*fd*g2*s**2 + 4536*D1*Dd*fd*g2*s + 1080*D1*Ddd*K*f**2*r**2 + 2160*D1*Ddd*K*f**2*r*s - 1620*D1*Ddd*K*f**2*r + 1080*D1*Ddd*K*f**2*s**2 - 1620*D1*Ddd*K*f**2*s + 810*D1*Ddd*K*f**2 + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 1050*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 525*D1*Ddd*f**3 - 900*D1*Ddd*f**2*r**2 - 1800*D1*Ddd*f**2*r*s + 1350*D1*Ddd*f**2*r - 900*D1*Ddd*f**2*s**2 + 1350*D1*Ddd*f**2*s - 675*D1*Ddd*f**2 - 3024*D1*Ddd*f*g2*r**2 - 6048*D1*Ddd*f*g2*r*s + 4536*D1*Ddd*f*g2*r - 3024*D1*Ddd*f*g2*s**2 + 4536*D1*Ddd*f*g2*s - 2268*D1*Ddd*f*g2 + 12*D1*bd1*(D1*(54*f**2*(r + s - 1) - 75*f*fd*(2*r + 2*s - 1) - 7*f*(13*K - 10)*(r + s - 1) + 21*fd*(6*K - 5)*(r + s)) - 3*Dd*f*(-42*K + 25*f + 35)*(4*r + 4*s - 3))*(r + s - 1) + 3240*Dd**2*K*f**2*r**2 + 6480*Dd**2*K*f**2*r*s - 4860*Dd**2*K*f**2*r + 3240*Dd**2*K*f**2*s**2 - 4860*Dd**2*K*f**2*s + 1620*Dd**2*K*f**2 + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 3150*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 1050*Dd**2*f**3 - 2700*Dd**2*f**2*r**2 - 5400*Dd**2*f**2*r*s + 4050*Dd**2*f**2*r - 2700*Dd**2*f**2*s**2 + 4050*Dd**2*f**2*s - 1350*Dd**2*f**2 - 9072*Dd**2*f*g2*r**2 - 18144*Dd**2*f*g2*r*s + 13608*Dd**2*f*g2*r - 9072*Dd**2*f*g2*s**2 + 13608*Dd**2*f*g2*s - 4536*Dd**2*f*g2))/(6930*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**5*k1*k2**3*(-42*D1*b1*bd1*(D1*(f*(14*C - 11)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(21 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(21 - 24*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 21*b1**2*(D1**2*(fd*(28*C - 22) + fdd*(21 - 24*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(14*C - 11)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(21 - 24*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(21 - 24*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(144*C - 126)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(7*D1**2*bdd1*f*(8*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1**2*(f*fd*(52*C*(2*r + 2*s - 1) - 18*r**2 - 6*r*(6*s + 11) - 18*s**2 - 66*s + 33) + 10*f*fdd*(C*(-8*r - 8*s + 4) + 3*r**2 + r*(6*s + 4) + 3*s**2 + 4*s - 2) - 10*fd**2*(r + s - 1)*(8*C - 3*r - 3*s - 7)) + D1*f*(-Dd*(9*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 20*fd*(4*r + 4*s - 3)*(4*C - 3*r - 3*s - 2)) + 15*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(126*D1**2*bd1**2*(8*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 45*D1**2*bdd1*f*(8*C*(2*r + 2*s - 1) + 3*r**2 + r*(6*s - 20) + 3*s**2 - 20*s + 10) + 5*D1**2*(f*(fd*(76*C - 77) + fdd*(70 - 56*C))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(140 - 112*C)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 9*D1*bd1*(D1*(52*C*f*(2*r + 2*s - 1) + 3*f*(3*r**2 + r*(6*s - 34) + 3*s**2 - 34*s + 17) - 20*fd*(r + s - 1)*(4*C + 3*r + 3*s - 5)) - 10*Dd*f*(4*r + 4*s - 3)*(8*C + 3*r + 3*s - 10)) + 5*D1*f*(Dd*(f*(76*C - 77)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(112*C - 140)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + Ddd*f*(70 - 56*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 5*Dd**2*f**2*(420 - 336*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**5*k2**5*st**2*(-36*D1**2*b1*f*fd*r**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(r + s - 1)**2 - 30*D1**2*f**2*fd*r**2 - 60*D1**2*f**2*fd*r*s + 40*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 40*D1**2*f**2*fd*s - 20*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 - 72*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 108*D1*Dd*b1*f**2*s - 54*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 40*D1*Dd*f**3*r**2 - 80*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 60*D1*Dd*f**3*s - 30*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 170*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 170*D1*Dd*f**2*fd*s + 60*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 - 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 30*Dd**2*f**3)/(42*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct**5*k2**5*(D1*f*(18*D1*bd1**2*(r + s - 1)*(5*f*(2*r + 2*s - 1) + 7*r + 7*s - 7) + bd1*(D1*(-70*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(r + s - 1)*(140*fd*(3*r + 3*s - 1) - 27*r - 27*s + 27) + 90*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 10*Dd*f*(4*r + 4*s - 3)*(7*f*(2*r + 2*s - 1) + 9*r + 9*s - 9)) + 5*f*(7*D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 9*D1*bdd1*(r + s - 1)**2 + 9*D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 9*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) - 9*b1**2*(D1**2*(5*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 14*fd*(r + s)**2 - 7*fdd*(r + s)**2) + D1*(2*Dd*(10*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-5*fd*(4*r + 4*s - 3)**2 + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) - 7*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(10*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(10*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(9*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 14*(r + s - 1)**2) - 420*D1**2*f**2*fd*r**2 - 840*D1**2*f**2*fd*r*s + 700*D1**2*f**2*fd*r - 420*D1**2*f**2*fd*s**2 + 700*D1**2*f**2*fd*s - 350*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r**2 + 420*D1**2*f**2*fdd*r*s - 350*D1**2*f**2*fdd*r + 210*D1**2*f**2*fdd*s**2 - 350*D1**2*f**2*fdd*s + 175*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r**2 + 840*D1**2*f*fd**2*r*s - 700*D1**2*f*fd**2*r + 420*D1**2*f*fd**2*s**2 - 700*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 54*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 54*D1**2*f*fd*r - 54*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 180*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 90*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 45*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 180*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 90*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 560*D1*Dd*f**3*r**2 - 1120*D1*Dd*f**3*r*s + 840*D1*Dd*f**3*r - 560*D1*Dd*f**3*s**2 + 840*D1*Dd*f**3*s - 420*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r**2 + 3360*D1*Dd*f**2*fd*r*s - 2660*D1*Dd*f**2*fd*r + 1680*D1*Dd*f**2*fd*s**2 - 2660*D1*Dd*f**2*fd*s + 1050*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 162*D1*Dd*f**2*r - 108*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1440*D1*Dd*f*fd*r*s - 900*D1*Dd*f*fd*r + 720*D1*Dd*f*fd*s**2 - 900*D1*Dd*f*fd*s + 270*D1*Dd*f*fd + 280*D1*Ddd*f**3*r**2 + 560*D1*Ddd*f**3*r*s - 420*D1*Ddd*f**3*r + 280*D1*Ddd*f**3*s**2 - 420*D1*Ddd*f**3*s + 210*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 + 360*D1*Ddd*f**2*r*s - 270*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s**2 - 270*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 - 18*D1*bd1*(D1*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(r + s - 1)*(10*fd*(2*r + 2*s - 1) - 7*r - 7*s + 7) - 14*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 14*r + 14*s - 14)) + 840*Dd**2*f**3*r**2 + 1680*Dd**2*f**3*r*s - 1260*Dd**2*f**3*r + 840*Dd**2*f**3*s**2 - 1260*Dd**2*f**3*s + 420*Dd**2*f**3 + 540*Dd**2*f**2*r**2 + 1080*Dd**2*f**2*r*s - 810*Dd**2*f**2*r + 540*Dd**2*f**2*s**2 - 810*Dd**2*f**2*s + 270*Dd**2*f**2))/(630*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct**5*k2**3*(D1*f*(r + s)*(14*D1*bd1**2*(r + s - 1) + 5*D1*bdd1*f*(r + s) + 10*bd1*(-D1*f*(r + s) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) - 7*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(7*D1**2*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*D1**2*(r + s - 1)**2*(2*f*fd - f*fdd - fd**2) - 14*D1*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k1*k3**2) + D1**2*Pk1*Pkdd3*ct**4*k1**4*k2**2*(-1872*C*D1**2*b1*f*fd*r**2 - 3744*C*D1**2*b1*f*fd*r*s + 1872*C*D1**2*b1*f*fd*r - 1872*C*D1**2*b1*f*fd*s**2 + 1872*C*D1**2*b1*f*fd*s - 936*C*D1**2*b1*f*fd + 2700*C*D1**2*b1*f*fdd*r**2 + 5400*C*D1**2*b1*f*fdd*r*s - 2700*C*D1**2*b1*f*fdd*r + 2700*C*D1**2*b1*f*fdd*s**2 - 2700*C*D1**2*b1*f*fdd*s + 1350*C*D1**2*b1*f*fdd + 2700*C*D1**2*b1*fd**2*r**2 + 5400*C*D1**2*b1*fd**2*r*s - 2700*C*D1**2*b1*fd**2*r + 2700*C*D1**2*b1*fd**2*s**2 - 2700*C*D1**2*b1*fd**2*s - 2520*C*D1**2*f**2*fd*r**2 - 5040*C*D1**2*f**2*fd*r*s + 3360*C*D1**2*f**2*fd*r - 2520*C*D1**2*f**2*fd*s**2 + 3360*C*D1**2*f**2*fd*s - 1680*C*D1**2*f**2*fd + 3150*C*D1**2*f**2*fdd*r**2 + 6300*C*D1**2*f**2*fdd*r*s - 4200*C*D1**2*f**2*fdd*r + 3150*C*D1**2*f**2*fdd*s**2 - 4200*C*D1**2*f**2*fdd*s + 2100*C*D1**2*f**2*fdd + 6300*C*D1**2*f*fd**2*r**2 + 12600*C*D1**2*f*fd**2*r*s - 8400*C*D1**2*f*fd**2*r + 6300*C*D1**2*f*fd**2*s**2 - 8400*C*D1**2*f*fd**2*s + 2100*C*D1**2*f*fd**2 - 3744*C*D1*Dd*b1*f**2*r**2 - 7488*C*D1*Dd*b1*f**2*r*s + 5616*C*D1*Dd*b1*f**2*r - 3744*C*D1*Dd*b1*f**2*s**2 + 5616*C*D1*Dd*b1*f**2*s - 2808*C*D1*Dd*b1*f**2 + 21600*C*D1*Dd*b1*f*fd*r**2 + 43200*C*D1*Dd*b1*f*fd*r*s - 27000*C*D1*Dd*b1*f*fd*r + 21600*C*D1*Dd*b1*f*fd*s**2 - 27000*C*D1*Dd*b1*f*fd*s + 8100*C*D1*Dd*b1*f*fd - 3360*C*D1*Dd*f**3*r**2 - 6720*C*D1*Dd*f**3*r*s + 5040*C*D1*Dd*f**3*r - 3360*C*D1*Dd*f**3*s**2 + 5040*C*D1*Dd*f**3*s - 2520*C*D1*Dd*f**3 + 25200*C*D1*Dd*f**2*fd*r**2 + 50400*C*D1*Dd*f**2*fd*r*s - 35700*C*D1*Dd*f**2*fd*r + 25200*C*D1*Dd*f**2*fd*s**2 - 35700*C*D1*Dd*f**2*fd*s + 12600*C*D1*Dd*f**2*fd + 5400*C*D1*Ddd*b1*f**2*r**2 + 10800*C*D1*Ddd*b1*f**2*r*s - 8100*C*D1*Ddd*b1*f**2*r + 5400*C*D1*Ddd*b1*f**2*s**2 - 8100*C*D1*Ddd*b1*f**2*s + 4050*C*D1*Ddd*b1*f**2 + 4200*C*D1*Ddd*f**3*r**2 + 8400*C*D1*Ddd*f**3*r*s - 6300*C*D1*Ddd*f**3*r + 4200*C*D1*Ddd*f**3*s**2 - 6300*C*D1*Ddd*f**3*s + 3150*C*D1*Ddd*f**3 + 16200*C*Dd**2*b1*f**2*r**2 + 32400*C*Dd**2*b1*f**2*r*s - 24300*C*Dd**2*b1*f**2*r + 16200*C*Dd**2*b1*f**2*s**2 - 24300*C*Dd**2*b1*f**2*s + 8100*C*Dd**2*b1*f**2 + 12600*C*Dd**2*f**3*r**2 + 25200*C*Dd**2*f**3*r*s - 18900*C*Dd**2*f**3*r + 12600*C*Dd**2*f**3*s**2 - 18900*C*Dd**2*f**3*s + 6300*C*Dd**2*f**3 + 1206*D1**2*b1*f*fd*r**2 + 2412*D1**2*b1*f*fd*r*s - 1206*D1**2*b1*f*fd*r + 1206*D1**2*b1*f*fd*s**2 - 1206*D1**2*b1*f*fd*s + 603*D1**2*b1*f*fd - 1800*D1**2*b1*f*fdd*r**2 - 3600*D1**2*b1*f*fdd*r*s + 1800*D1**2*b1*f*fdd*r - 1800*D1**2*b1*f*fdd*s**2 + 1800*D1**2*b1*f*fdd*s - 900*D1**2*b1*f*fdd - 1800*D1**2*b1*fd**2*r**2 - 3600*D1**2*b1*fd**2*r*s + 1800*D1**2*b1*fd**2*r - 1800*D1**2*b1*fd**2*s**2 + 1800*D1**2*b1*fd**2*s + 450*D1**2*bdd1*f**2*(3*C - 2)*(r + s - 1)**2 + 1635*D1**2*f**2*fd*r**2 + 3270*D1**2*f**2*fd*r*s - 2180*D1**2*f**2*fd*r + 1635*D1**2*f**2*fd*s**2 - 2180*D1**2*f**2*fd*s + 1090*D1**2*f**2*fd - 2100*D1**2*f**2*fdd*r**2 - 4200*D1**2*f**2*fdd*r*s + 2800*D1**2*f**2*fdd*r - 2100*D1**2*f**2*fdd*s**2 + 2800*D1**2*f**2*fdd*s - 1400*D1**2*f**2*fdd - 4200*D1**2*f*fd**2*r**2 - 8400*D1**2*f*fd**2*r*s + 5600*D1**2*f*fd**2*r - 4200*D1**2*f*fd**2*s**2 + 5600*D1**2*f*fd**2*s - 1400*D1**2*f*fd**2 + 2412*D1*Dd*b1*f**2*r**2 + 4824*D1*Dd*b1*f**2*r*s - 3618*D1*Dd*b1*f**2*r + 2412*D1*Dd*b1*f**2*s**2 - 3618*D1*Dd*b1*f**2*s + 1809*D1*Dd*b1*f**2 - 14400*D1*Dd*b1*f*fd*r**2 - 28800*D1*Dd*b1*f*fd*r*s + 18000*D1*Dd*b1*f*fd*r - 14400*D1*Dd*b1*f*fd*s**2 + 18000*D1*Dd*b1*f*fd*s - 5400*D1*Dd*b1*f*fd + 2180*D1*Dd*f**3*r**2 + 4360*D1*Dd*f**3*r*s - 3270*D1*Dd*f**3*r + 2180*D1*Dd*f**3*s**2 - 3270*D1*Dd*f**3*s + 1635*D1*Dd*f**3 - 16800*D1*Dd*f**2*fd*r**2 - 33600*D1*Dd*f**2*fd*r*s + 23800*D1*Dd*f**2*fd*r - 16800*D1*Dd*f**2*fd*s**2 + 23800*D1*Dd*f**2*fd*s - 8400*D1*Dd*f**2*fd - 3600*D1*Ddd*b1*f**2*r**2 - 7200*D1*Ddd*b1*f**2*r*s + 5400*D1*Ddd*b1*f**2*r - 3600*D1*Ddd*b1*f**2*s**2 + 5400*D1*Ddd*b1*f**2*s - 2700*D1*Ddd*b1*f**2 - 2800*D1*Ddd*f**3*r**2 - 5600*D1*Ddd*f**3*r*s + 4200*D1*Ddd*f**3*r - 2800*D1*Ddd*f**3*s**2 + 4200*D1*Ddd*f**3*s - 2100*D1*Ddd*f**3 - 9*D1*bd1*f*(r + s - 1)*(D1*f*(104*C - 67)*(r + s - 1) - D1*fd*(300*C - 200)*(2*r + 2*s - 1) - Dd*f*(300*C - 200)*(4*r + 4*s - 3)) - 10800*Dd**2*b1*f**2*r**2 - 21600*Dd**2*b1*f**2*r*s + 16200*Dd**2*b1*f**2*r - 10800*Dd**2*b1*f**2*s**2 + 16200*Dd**2*b1*f**2*s - 5400*Dd**2*b1*f**2 - 8400*Dd**2*f**3*r**2 - 16800*Dd**2*f**3*r*s + 12600*Dd**2*f**3*r - 8400*Dd**2*f**3*s**2 + 12600*Dd**2*f**3*s - 4200*Dd**2*f**3)/(630*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**4*k1**2*k2**4*st**2*(-5904*C*D1**2*b1*f*fd*r**2 - 11808*C*D1**2*b1*f*fd*r*s + 5904*C*D1**2*b1*f*fd*r - 5904*C*D1**2*b1*f*fd*s**2 + 5904*C*D1**2*b1*f*fd*s - 2952*C*D1**2*b1*f*fd + 4716*C*D1**2*b1*f*fdd*r**2 + 9432*C*D1**2*b1*f*fdd*r*s - 4716*C*D1**2*b1*f*fdd*r + 4716*C*D1**2*b1*f*fdd*s**2 - 4716*C*D1**2*b1*f*fdd*s + 2358*C*D1**2*b1*f*fdd + 4716*C*D1**2*b1*fd**2*r**2 + 9432*C*D1**2*b1*fd**2*r*s - 4716*C*D1**2*b1*fd**2*r + 4716*C*D1**2*b1*fd**2*s**2 - 4716*C*D1**2*b1*fd**2*s - 5592*C*D1**2*f**2*fd*r**2 - 11184*C*D1**2*f**2*fd*r*s + 7456*C*D1**2*f**2*fd*r - 5592*C*D1**2*f**2*fd*s**2 + 7456*C*D1**2*f**2*fd*s - 3728*C*D1**2*f**2*fd + 3930*C*D1**2*f**2*fdd*r**2 + 7860*C*D1**2*f**2*fdd*r*s - 5240*C*D1**2*f**2*fdd*r + 3930*C*D1**2*f**2*fdd*s**2 - 5240*C*D1**2*f**2*fdd*s + 2620*C*D1**2*f**2*fdd + 7860*C*D1**2*f*fd**2*r**2 + 15720*C*D1**2*f*fd**2*r*s - 10480*C*D1**2*f*fd**2*r + 7860*C*D1**2*f*fd**2*s**2 - 10480*C*D1**2*f*fd**2*s + 2620*C*D1**2*f*fd**2 - 11808*C*D1*Dd*b1*f**2*r**2 - 23616*C*D1*Dd*b1*f**2*r*s + 17712*C*D1*Dd*b1*f**2*r - 11808*C*D1*Dd*b1*f**2*s**2 + 17712*C*D1*Dd*b1*f**2*s - 8856*C*D1*Dd*b1*f**2 + 37728*C*D1*Dd*b1*f*fd*r**2 + 75456*C*D1*Dd*b1*f*fd*r*s - 47160*C*D1*Dd*b1*f*fd*r + 37728*C*D1*Dd*b1*f*fd*s**2 - 47160*C*D1*Dd*b1*f*fd*s + 14148*C*D1*Dd*b1*f*fd - 7456*C*D1*Dd*f**3*r**2 - 14912*C*D1*Dd*f**3*r*s + 11184*C*D1*Dd*f**3*r - 7456*C*D1*Dd*f**3*s**2 + 11184*C*D1*Dd*f**3*s - 5592*C*D1*Dd*f**3 + 31440*C*D1*Dd*f**2*fd*r**2 + 62880*C*D1*Dd*f**2*fd*r*s - 44540*C*D1*Dd*f**2*fd*r + 31440*C*D1*Dd*f**2*fd*s**2 - 44540*C*D1*Dd*f**2*fd*s + 15720*C*D1*Dd*f**2*fd + 9432*C*D1*Ddd*b1*f**2*r**2 + 18864*C*D1*Ddd*b1*f**2*r*s - 14148*C*D1*Ddd*b1*f**2*r + 9432*C*D1*Ddd*b1*f**2*s**2 - 14148*C*D1*Ddd*b1*f**2*s + 7074*C*D1*Ddd*b1*f**2 + 5240*C*D1*Ddd*f**3*r**2 + 10480*C*D1*Ddd*f**3*r*s - 7860*C*D1*Ddd*f**3*r + 5240*C*D1*Ddd*f**3*s**2 - 7860*C*D1*Ddd*f**3*s + 3930*C*D1*Ddd*f**3 + 28296*C*Dd**2*b1*f**2*r**2 + 56592*C*Dd**2*b1*f**2*r*s - 42444*C*Dd**2*b1*f**2*r + 28296*C*Dd**2*b1*f**2*s**2 - 42444*C*Dd**2*b1*f**2*s + 14148*C*Dd**2*b1*f**2 + 15720*C*Dd**2*f**3*r**2 + 31440*C*Dd**2*f**3*r*s - 23580*C*Dd**2*f**3*r + 15720*C*Dd**2*f**3*s**2 - 23580*C*Dd**2*f**3*s + 7860*C*Dd**2*f**3 + 4428*D1**2*b1*f*fd*r**2 + 8856*D1**2*b1*f*fd*r*s - 4428*D1**2*b1*f*fd*r + 4428*D1**2*b1*f*fd*s**2 - 4428*D1**2*b1*f*fd*s + 2214*D1**2*b1*f*fd - 3726*D1**2*b1*f*fdd*r**2 - 7452*D1**2*b1*f*fdd*r*s + 3726*D1**2*b1*f*fdd*r - 3726*D1**2*b1*f*fdd*s**2 + 3726*D1**2*b1*f*fdd*s - 1863*D1**2*b1*f*fdd - 3726*D1**2*b1*fd**2*r**2 - 7452*D1**2*b1*fd**2*r*s + 3726*D1**2*b1*fd**2*r - 3726*D1**2*b1*fd**2*s**2 + 3726*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(262*C - 207)*(r + s - 1)**2 + 4266*D1**2*f**2*fd*r**2 + 8532*D1**2*f**2*fd*r*s - 5688*D1**2*f**2*fd*r + 4266*D1**2*f**2*fd*s**2 - 5688*D1**2*f**2*fd*s + 2844*D1**2*f**2*fd - 3105*D1**2*f**2*fdd*r**2 - 6210*D1**2*f**2*fdd*r*s + 4140*D1**2*f**2*fdd*r - 3105*D1**2*f**2*fdd*s**2 + 4140*D1**2*f**2*fdd*s - 2070*D1**2*f**2*fdd - 6210*D1**2*f*fd**2*r**2 - 12420*D1**2*f*fd**2*r*s + 8280*D1**2*f*fd**2*r - 6210*D1**2*f*fd**2*s**2 + 8280*D1**2*f*fd**2*s - 2070*D1**2*f*fd**2 + 8856*D1*Dd*b1*f**2*r**2 + 17712*D1*Dd*b1*f**2*r*s - 13284*D1*Dd*b1*f**2*r + 8856*D1*Dd*b1*f**2*s**2 - 13284*D1*Dd*b1*f**2*s + 6642*D1*Dd*b1*f**2 - 29808*D1*Dd*b1*f*fd*r**2 - 59616*D1*Dd*b1*f*fd*r*s + 37260*D1*Dd*b1*f*fd*r - 29808*D1*Dd*b1*f*fd*s**2 + 37260*D1*Dd*b1*f*fd*s - 11178*D1*Dd*b1*f*fd + 5688*D1*Dd*f**3*r**2 + 11376*D1*Dd*f**3*r*s - 8532*D1*Dd*f**3*r + 5688*D1*Dd*f**3*s**2 - 8532*D1*Dd*f**3*s + 4266*D1*Dd*f**3 - 24840*D1*Dd*f**2*fd*r**2 - 49680*D1*Dd*f**2*fd*r*s + 35190*D1*Dd*f**2*fd*r - 24840*D1*Dd*f**2*fd*s**2 + 35190*D1*Dd*f**2*fd*s - 12420*D1*Dd*f**2*fd - 7452*D1*Ddd*b1*f**2*r**2 - 14904*D1*Ddd*b1*f**2*r*s + 11178*D1*Ddd*b1*f**2*r - 7452*D1*Ddd*b1*f**2*s**2 + 11178*D1*Ddd*b1*f**2*s - 5589*D1*Ddd*b1*f**2 - 4140*D1*Ddd*f**3*r**2 - 8280*D1*Ddd*f**3*r*s + 6210*D1*Ddd*f**3*r - 4140*D1*Ddd*f**3*s**2 + 6210*D1*Ddd*f**3*s - 3105*D1*Ddd*f**3 - 18*D1*bd1*f*(r + s - 1)*(D1*f*(164*C - 123)*(r + s - 1) - D1*fd*(262*C - 207)*(2*r + 2*s - 1) - Dd*f*(262*C - 207)*(4*r + 4*s - 3)) - 22356*Dd**2*b1*f**2*r**2 - 44712*Dd**2*b1*f**2*r*s + 33534*Dd**2*b1*f**2*r - 22356*Dd**2*b1*f**2*s**2 + 33534*Dd**2*b1*f**2*s - 11178*Dd**2*b1*f**2 - 12420*Dd**2*f**3*r**2 - 24840*Dd**2*f**3*r*s + 18630*Dd**2*f**3*r - 12420*Dd**2*f**3*s**2 + 18630*Dd**2*f**3*s - 6210*Dd**2*f**3)/(630*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**4*k1**2*k2**4*(5940*C*D1**2*f**2*fd*r**2 + 11880*C*D1**2*f**2*fd*r*s - 7920*C*D1**2*f**2*fd*r + 5940*C*D1**2*f**2*fd*s**2 - 7920*C*D1**2*f**2*fd*s + 3960*C*D1**2*f**2*fd + 7920*C*D1*Dd*f**3*r**2 + 15840*C*D1*Dd*f**3*r*s - 11880*C*D1*Dd*f**3*r + 7920*C*D1*Dd*f**3*s**2 - 11880*C*D1*Dd*f**3*s + 5940*C*D1*Dd*f**3 - 330*D1**2*bd1**2*f*(-21*K + 10*f + 14)*(r + s - 1)**2 + 165*D1**2*bdd1*f*(5*f*(3*K - 2) - 42*g2)*(r + s - 1)**2 - 3780*D1**2*f**3*fd*r**2 - 7560*D1**2*f**3*fd*r*s + 5670*D1**2*f**3*fd*r - 3780*D1**2*f**3*fd*s**2 + 5670*D1**2*f**3*fd*s - 2835*D1**2*f**3*fd + 4200*D1**2*f**3*fdd*r**2 + 8400*D1**2*f**3*fdd*r*s - 6300*D1**2*f**3*fdd*r + 4200*D1**2*f**3*fdd*s**2 - 6300*D1**2*f**3*fdd*s + 3150*D1**2*f**3*fdd + 12600*D1**2*f**2*fd**2*r**2 + 25200*D1**2*f**2*fd**2*r*s - 18900*D1**2*f**2*fd**2*r + 12600*D1**2*f**2*fd**2*s**2 - 18900*D1**2*f**2*fd**2*s + 6300*D1**2*f**2*fd**2 - 4455*D1**2*f**2*fd*r**2 - 8910*D1**2*f**2*fd*r*s + 5940*D1**2*f**2*fd*r - 4455*D1**2*f**2*fd*s**2 + 5940*D1**2*f**2*fd*s - 2970*D1**2*f**2*fd + 5742*D1**2*f**2*gd2*r**2 + 11484*D1**2*f**2*gd2*r*s - 11484*D1**2*f**2*gd2*r + 5742*D1**2*f**2*gd2*s**2 - 11484*D1**2*f**2*gd2*s + 5742*D1**2*f**2*gd2 - 4950*D1**2*f**2*gdd2*r**2 - 9900*D1**2*f**2*gdd2*r*s + 9900*D1**2*f**2*gdd2*r - 4950*D1**2*f**2*gdd2*s**2 + 9900*D1**2*f**2*gdd2*s - 4950*D1**2*f**2*gdd2 + 11484*D1**2*f*fd*g2*r**2 + 22968*D1**2*f*fd*g2*r*s - 11484*D1**2*f*fd*g2*r + 11484*D1**2*f*fd*g2*s**2 - 11484*D1**2*f*fd*g2*s + 5742*D1**2*f*fd*g2 - 19800*D1**2*f*fd*gd2*r**2 - 39600*D1**2*f*fd*gd2*r*s + 29700*D1**2*f*fd*gd2*r - 19800*D1**2*f*fd*gd2*s**2 + 29700*D1**2*f*fd*gd2*s - 9900*D1**2*f*fd*gd2 - 9900*D1**2*f*fdd*g2*r**2 - 19800*D1**2*f*fdd*g2*r*s + 9900*D1**2*f*fdd*g2*r - 9900*D1**2*f*fdd*g2*s**2 + 9900*D1**2*f*fdd*g2*s - 4950*D1**2*f*fdd*g2 - 9900*D1**2*fd**2*g2*r**2 - 19800*D1**2*fd**2*g2*r*s + 9900*D1**2*fd**2*g2*r - 9900*D1**2*fd**2*g2*s**2 + 9900*D1**2*fd**2*g2*s - 3780*D1*Dd*f**4*r**2 - 7560*D1*Dd*f**4*r*s + 5670*D1*Dd*f**4*r - 3780*D1*Dd*f**4*s**2 + 5670*D1*Dd*f**4*s - 2835*D1*Dd*f**4 + 33600*D1*Dd*f**3*fd*r**2 + 67200*D1*Dd*f**3*fd*r*s - 50400*D1*Dd*f**3*fd*r + 33600*D1*Dd*f**3*fd*s**2 - 50400*D1*Dd*f**3*fd*s + 18900*D1*Dd*f**3*fd - 5940*D1*Dd*f**3*r**2 - 11880*D1*Dd*f**3*r*s + 8910*D1*Dd*f**3*r - 5940*D1*Dd*f**3*s**2 + 8910*D1*Dd*f**3*s - 4455*D1*Dd*f**3 + 22968*D1*Dd*f**2*g2*r**2 + 45936*D1*Dd*f**2*g2*r*s - 34452*D1*Dd*f**2*g2*r + 22968*D1*Dd*f**2*g2*s**2 - 34452*D1*Dd*f**2*g2*s + 17226*D1*Dd*f**2*g2 - 39600*D1*Dd*f**2*gd2*r**2 - 79200*D1*Dd*f**2*gd2*r*s + 69300*D1*Dd*f**2*gd2*r - 39600*D1*Dd*f**2*gd2*s**2 + 69300*D1*Dd*f**2*gd2*s - 29700*D1*Dd*f**2*gd2 - 79200*D1*Dd*f*fd*g2*r**2 - 158400*D1*Dd*f*fd*g2*r*s + 99000*D1*Dd*f*fd*g2*r - 79200*D1*Dd*f*fd*g2*s**2 + 99000*D1*Dd*f*fd*g2*s - 29700*D1*Dd*f*fd*g2 + 4200*D1*Ddd*f**4*r**2 + 8400*D1*Ddd*f**4*r*s - 6300*D1*Ddd*f**4*r + 4200*D1*Ddd*f**4*s**2 - 6300*D1*Ddd*f**4*s + 3150*D1*Ddd*f**4 - 19800*D1*Ddd*f**2*g2*r**2 - 39600*D1*Ddd*f**2*g2*r*s + 29700*D1*Ddd*f**2*g2*r - 19800*D1*Ddd*f**2*g2*s**2 + 29700*D1*Ddd*f**2*g2*s - 14850*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(10*f**3*(r + s - 1) + 3*f**2*(28*C - 29*K - 4)*(r + s - 1) + 50*f*fd*(3*K - 2)*(2*r + 2*s - 1) + 210*f*(g2 - 2*gd2)*(r + s - 1) - 420*fd*g2*(r + s)) + 10*Dd*f*(5*f*(3*K - 2) - 42*g2)*(4*r + 4*s - 3))*(r + s - 1) + 12600*Dd**2*f**4*r**2 + 25200*Dd**2*f**4*r*s - 18900*Dd**2*f**4*r + 12600*Dd**2*f**4*s**2 - 18900*Dd**2*f**4*s + 6300*Dd**2*f**4 - 59400*Dd**2*f**2*g2*r**2 - 118800*Dd**2*f**2*g2*r*s + 89100*Dd**2*f**2*g2*r - 59400*Dd**2*f**2*g2*s**2 + 89100*Dd**2*f**2*g2*s - 29700*Dd**2*f**2*g2 + 11*b1**2*(D1**2*(3*f*(51*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-5*r - 5*s)*(60*fd**2*(r + s - 1) + 7*fd*(9*K - 5)*(r + s) - 21*fdd*(3*K - 2)*(r + s))) + D1*(Dd*(153*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (63*K - 35)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 210*fd*(3*K - 2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 15*Ddd*f*(-21*K + 10*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f*(-21*K + 10*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(-30*D1**2*bdd1*f*(-21*K + 10*f + 14)*(r + s - 1)**2 - 3*D1**2*(-10*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-3*fd*(28*C - 29*K - 4)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 25*fdd*(3*K - 2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*(42*gd2 - 42*gdd2)*(r + s - 1)**2) - (10*r + 10*s)*(5*fd**2*(3*K - 2)*(r + s - 1) + 21*fd*(g2*(r + s) - 2*gd2*(r + s - 1)) - 21*fdd*g2*(r + s))) + 2*D1*bd1*(D1*(153*f**2*(r + s - 1) - 5*f*(60*fd*(2*r + 2*s - 1) + (63*K - 35)*(r + s - 1)) + 210*fd*(3*K - 2)*(r + s)) - 30*Dd*f*(-21*K + 10*f + 14)*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(-10*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*f**2*(28*C - 29*K - 4)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*f*(5*fd*(3*K - 2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 21*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 42*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 420*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 5*Ddd*f*(5*f*(3*K - 2) - 42*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f*(5*f*(3*K - 2) - 42*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(2310*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**4*k1**2*k2**2*(-42*D1*b1*bd1*(D1*(f*(11*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(27 - 36*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(27 - 36*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 21*b1**2*(D1**2*(fd*(22*C - 14) + fdd*(27 - 36*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(11*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(27 - 36*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(27 - 36*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(216*C - 162)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(21*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1**2*(f*fd*(50*C*(2*r + 2*s - 1) - 6*r**2 - 2*r*(6*s + 31) - 6*s**2 - 62*s + 31) + 10*f*fdd*(-6*C*(2*r + 2*s - 1) + r**2 + 2*r*(s + 4) + s**2 + 8*s - 4) - 10*fd**2*(r + s - 1)*(12*C - r - s - 9)) + D1*f*(Dd*(-3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 20*fd*(4*r + 4*s - 3)*(6*C - r - s - 4)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(378*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 45*D1**2*bdd1*f*(12*C*(2*r + 2*s - 1) + r**2 + 2*r*(s - 10) + s**2 - 20*s + 10) + 5*D1**2*(f*(fd*(78*C - 59) + fdd*(70 - 84*C))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(140 - 168*C)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 9*D1*bd1*(D1*f*(50*C*(2*r + 2*s - 1) + 3*r**2 + r*(6*s - 74) + 3*s**2 - 74*s + 37) - 20*D1*fd*(r + s - 1)*(6*C + r + s - 5) - 10*Dd*f*(4*r + 4*s - 3)*(12*C + r + s - 10)) + 5*D1*f*(Dd*(f*(78*C - 59)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(168*C - 140)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + Ddd*f*(70 - 84*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 5*Dd**2*f**2*(504*C - 420)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) - D1**2*Pk1*Pkdd3*ct**4*k2**6*st**4*(C - 1)*(12*D1**2*b1*f*fd*r**2 + 24*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*r + 12*D1**2*b1*f*fd*s**2 - 12*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fd - 6*D1**2*b1*f*fdd*r**2 - 12*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*r - 6*D1**2*b1*f*fdd*s**2 + 6*D1**2*b1*f*fdd*s - 3*D1**2*b1*f*fdd - 6*D1**2*b1*fd**2*r**2 - 12*D1**2*b1*fd**2*r*s + 6*D1**2*b1*fd**2*r - 6*D1**2*b1*fd**2*s**2 + 6*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 24*D1*Dd*b1*f**2*r**2 + 48*D1*Dd*b1*f**2*r*s - 36*D1*Dd*b1*f**2*r + 24*D1*Dd*b1*f**2*s**2 - 36*D1*Dd*b1*f**2*s + 18*D1*Dd*b1*f**2 - 48*D1*Dd*b1*f*fd*r**2 - 96*D1*Dd*b1*f*fd*r*s + 60*D1*Dd*b1*f*fd*r - 48*D1*Dd*b1*f*fd*s**2 + 60*D1*Dd*b1*f*fd*s - 18*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 12*D1*Ddd*b1*f**2*r**2 - 24*D1*Ddd*b1*f**2*r*s + 18*D1*Ddd*b1*f**2*r - 12*D1*Ddd*b1*f**2*s**2 + 18*D1*Ddd*b1*f**2*s - 9*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 6*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 36*Dd**2*b1*f**2*r**2 - 72*Dd**2*b1*f**2*r*s + 54*Dd**2*b1*f**2*r - 36*Dd**2*b1*f**2*s**2 + 54*Dd**2*b1*f**2*s - 18*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(7*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**4*k2**6*st**2*(3564*C*D1**2*f**2*fd*r**2 + 7128*C*D1**2*f**2*fd*r*s - 4752*C*D1**2*f**2*fd*r + 3564*C*D1**2*f**2*fd*s**2 - 4752*C*D1**2*f**2*fd*s + 2376*C*D1**2*f**2*fd + 4752*C*D1*Dd*f**3*r**2 + 9504*C*D1*Dd*f**3*r*s - 7128*C*D1*Dd*f**3*r + 4752*C*D1*Dd*f**3*s**2 - 7128*C*D1*Dd*f**3*s + 3564*C*D1*Dd*f**3 + 594*D1**2*K*bdd1*f**2*r**2 + 1188*D1**2*K*bdd1*f**2*r*s - 1188*D1**2*K*bdd1*f**2*r + 594*D1**2*K*bdd1*f**2*s**2 - 1188*D1**2*K*bdd1*f**2*s + 594*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(-14*K + 15*f + 14)*(r + s - 1)**2 + 3300*D1**2*bdd1*f**3*r**2 + 6600*D1**2*bdd1*f**3*r*s - 6600*D1**2*bdd1*f**3*r + 3300*D1**2*bdd1*f**3*s**2 - 6600*D1**2*bdd1*f**3*s + 3300*D1**2*bdd1*f**3 - 594*D1**2*bdd1*f**2*r**2 - 1188*D1**2*bdd1*f**2*r*s + 1188*D1**2*bdd1*f**2*r - 594*D1**2*bdd1*f**2*s**2 + 1188*D1**2*bdd1*f**2*s - 594*D1**2*bdd1*f**2 - 2772*D1**2*bdd1*f*g2*r**2 - 5544*D1**2*bdd1*f*g2*r*s + 5544*D1**2*bdd1*f*g2*r - 2772*D1**2*bdd1*f*g2*s**2 + 5544*D1**2*bdd1*f*g2*s - 2772*D1**2*bdd1*f*g2 - 16600*D1**2*f**3*fd*r**2 - 33200*D1**2*f**3*fd*r*s + 24900*D1**2*f**3*fd*r - 16600*D1**2*f**3*fd*s**2 + 24900*D1**2*f**3*fd*s - 12450*D1**2*f**3*fd + 10500*D1**2*f**3*fdd*r**2 + 21000*D1**2*f**3*fdd*r*s - 15750*D1**2*f**3*fdd*r + 10500*D1**2*f**3*fdd*s**2 - 15750*D1**2*f**3*fdd*s + 7875*D1**2*f**3*fdd + 31500*D1**2*f**2*fd**2*r**2 + 63000*D1**2*f**2*fd**2*r*s - 47250*D1**2*f**2*fd**2*r + 31500*D1**2*f**2*fd**2*s**2 - 47250*D1**2*f**2*fd**2*s + 15750*D1**2*f**2*fd**2 - 3564*D1**2*f**2*fd*r**2 - 7128*D1**2*f**2*fd*r*s + 4752*D1**2*f**2*fd*r - 3564*D1**2*f**2*fd*s**2 + 4752*D1**2*f**2*fd*s - 2376*D1**2*f**2*fd + 2376*D1**2*f**2*gd2*r**2 + 4752*D1**2*f**2*gd2*r*s - 4752*D1**2*f**2*gd2*r + 2376*D1**2*f**2*gd2*s**2 - 4752*D1**2*f**2*gd2*s + 2376*D1**2*f**2*gd2 - 1188*D1**2*f**2*gdd2*r**2 - 2376*D1**2*f**2*gdd2*r*s + 2376*D1**2*f**2*gdd2*r - 1188*D1**2*f**2*gdd2*s**2 + 2376*D1**2*f**2*gdd2*s - 1188*D1**2*f**2*gdd2 + 4752*D1**2*f*fd*g2*r**2 + 9504*D1**2*f*fd*g2*r*s - 4752*D1**2*f*fd*g2*r + 4752*D1**2*f*fd*g2*s**2 - 4752*D1**2*f*fd*g2*s + 2376*D1**2*f*fd*g2 - 4752*D1**2*f*fd*gd2*r**2 - 9504*D1**2*f*fd*gd2*r*s + 7128*D1**2*f*fd*gd2*r - 4752*D1**2*f*fd*gd2*s**2 + 7128*D1**2*f*fd*gd2*s - 2376*D1**2*f*fd*gd2 - 2376*D1**2*f*fdd*g2*r**2 - 4752*D1**2*f*fdd*g2*r*s + 2376*D1**2*f*fdd*g2*r - 2376*D1**2*f*fdd*g2*s**2 + 2376*D1**2*f*fdd*g2*s - 1188*D1**2*f*fdd*g2 - 2376*D1**2*fd**2*g2*r**2 - 4752*D1**2*fd**2*g2*r*s + 2376*D1**2*fd**2*g2*r - 2376*D1**2*fd**2*g2*s**2 + 2376*D1**2*fd**2*g2*s - 16600*D1*Dd*f**4*r**2 - 33200*D1*Dd*f**4*r*s + 24900*D1*Dd*f**4*r - 16600*D1*Dd*f**4*s**2 + 24900*D1*Dd*f**4*s - 12450*D1*Dd*f**4 + 84000*D1*Dd*f**3*fd*r**2 + 168000*D1*Dd*f**3*fd*r*s - 126000*D1*Dd*f**3*fd*r + 84000*D1*Dd*f**3*fd*s**2 - 126000*D1*Dd*f**3*fd*s + 47250*D1*Dd*f**3*fd - 4752*D1*Dd*f**3*r**2 - 9504*D1*Dd*f**3*r*s + 7128*D1*Dd*f**3*r - 4752*D1*Dd*f**3*s**2 + 7128*D1*Dd*f**3*s - 3564*D1*Dd*f**3 + 9504*D1*Dd*f**2*g2*r**2 + 19008*D1*Dd*f**2*g2*r*s - 14256*D1*Dd*f**2*g2*r + 9504*D1*Dd*f**2*g2*s**2 - 14256*D1*Dd*f**2*g2*s + 7128*D1*Dd*f**2*g2 - 9504*D1*Dd*f**2*gd2*r**2 - 19008*D1*Dd*f**2*gd2*r*s + 16632*D1*Dd*f**2*gd2*r - 9504*D1*Dd*f**2*gd2*s**2 + 16632*D1*Dd*f**2*gd2*s - 7128*D1*Dd*f**2*gd2 - 19008*D1*Dd*f*fd*g2*r**2 - 38016*D1*Dd*f*fd*g2*r*s + 23760*D1*Dd*f*fd*g2*r - 19008*D1*Dd*f*fd*g2*s**2 + 23760*D1*Dd*f*fd*g2*s - 7128*D1*Dd*f*fd*g2 + 10500*D1*Ddd*f**4*r**2 + 21000*D1*Ddd*f**4*r*s - 15750*D1*Ddd*f**4*r + 10500*D1*Ddd*f**4*s**2 - 15750*D1*Ddd*f**4*s + 7875*D1*Ddd*f**4 - 4752*D1*Ddd*f**2*g2*r**2 - 9504*D1*Ddd*f**2*g2*r*s + 7128*D1*Ddd*f**2*g2*r - 4752*D1*Ddd*f**2*g2*s**2 + 7128*D1*Ddd*f**2*g2*s - 3564*D1*Ddd*f**2*g2 - 132*D1*bd1*(D1*(35*f**3*(r + s - 1) + f**2*(-21*C*(r + s - 1) - 50*fd*(3*r + 3*s - 2) + (9*K + 12)*(r + s - 1)) - 3*f*(3*fd*(K - 1)*(2*r + 2*s - 1) + (14*g2 - 14*gd2)*(r + s - 1)) + 42*fd*g2*(r + s)) - Dd*f*(50*f**2 + 9*f*(K - 1) - 42*g2)*(4*r + 4*s - 3))*(r + s - 1) + 31500*Dd**2*f**4*r**2 + 63000*Dd**2*f**4*r*s - 47250*Dd**2*f**4*r + 31500*Dd**2*f**4*s**2 - 47250*Dd**2*f**4*s + 15750*Dd**2*f**4 - 14256*Dd**2*f**2*g2*r**2 - 28512*Dd**2*f**2*g2*r*s + 21384*Dd**2*f**2*g2*r - 14256*Dd**2*f**2*g2*s**2 + 21384*Dd**2*f**2*g2*s - 7128*Dd**2*f**2*g2 + 99*b1**2*(D1**2*(15*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(15*fd**2*(r + s - 1) + 14*fd*(K - 1)*(r + s) - 7*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(15*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(15*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 14*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 15*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 15*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(84*C*D1**2*f*fd*r**2 + 168*C*D1**2*f*fd*r*s - 84*C*D1**2*f*fd*r + 84*C*D1**2*f*fd*s**2 - 84*C*D1**2*f*fd*s + 42*C*D1**2*f*fd + 168*C*D1*Dd*f**2*r**2 + 336*C*D1*Dd*f**2*r*s - 252*C*D1*Dd*f**2*r + 168*C*D1*Dd*f**2*s**2 - 252*C*D1*Dd*f**2*s + 126*C*D1*Dd*f**2 - 36*D1**2*K*f*fd*r**2 - 72*D1**2*K*f*fd*r*s + 36*D1**2*K*f*fd*r - 36*D1**2*K*f*fd*s**2 + 36*D1**2*K*f*fd*s - 18*D1**2*K*f*fd + 18*D1**2*K*f*fdd*r**2 + 36*D1**2*K*f*fdd*r*s - 18*D1**2*K*f*fdd*r + 18*D1**2*K*f*fdd*s**2 - 18*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 18*D1**2*K*fd**2*r**2 + 36*D1**2*K*fd**2*r*s - 18*D1**2*K*fd**2*r + 18*D1**2*K*fd**2*s**2 - 18*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(-14*K + 15*f + 14)*(r + s - 1)**2 - 210*D1**2*f**2*fd*r**2 - 420*D1**2*f**2*fd*r*s + 280*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 280*D1**2*f**2*fd*s - 140*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 48*D1**2*f*fd*r**2 - 96*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 48*D1**2*f*fd*s - 24*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 84*D1**2*f*gd2*r**2 + 168*D1**2*f*gd2*r*s - 168*D1**2*f*gd2*r + 84*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s + 84*D1**2*f*gd2 - 42*D1**2*f*gdd2*r**2 - 84*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*r - 42*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s - 42*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 84*D1**2*fd*g2*r**2 + 168*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*s**2 - 84*D1**2*fd*gd2*r**2 - 168*D1**2*fd*gd2*r*s + 84*D1**2*fd*gd2*r - 84*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s - 42*D1**2*fdd*g2*r**2 - 84*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*s**2 - 72*D1*Dd*K*f**2*r**2 - 144*D1*Dd*K*f**2*r*s + 108*D1*Dd*K*f**2*r - 72*D1*Dd*K*f**2*s**2 + 108*D1*Dd*K*f**2*s - 54*D1*Dd*K*f**2 + 144*D1*Dd*K*f*fd*r**2 + 288*D1*Dd*K*f*fd*r*s - 180*D1*Dd*K*f*fd*r + 144*D1*Dd*K*f*fd*s**2 - 180*D1*Dd*K*f*fd*s + 54*D1*Dd*K*f*fd - 280*D1*Dd*f**3*r**2 - 560*D1*Dd*f**3*r*s + 420*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 420*D1*Dd*f**3*s - 210*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 1700*D1*Dd*f**2*fd*r + 1200*D1*Dd*f**2*fd*s**2 - 1700*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 96*D1*Dd*f**2*r**2 - 192*D1*Dd*f**2*r*s + 144*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 144*D1*Dd*f**2*s - 72*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 336*D1*Dd*f*g2*r**2 + 672*D1*Dd*f*g2*r*s - 504*D1*Dd*f*g2*r + 336*D1*Dd*f*g2*s**2 - 504*D1*Dd*f*g2*s + 252*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r**2 - 672*D1*Dd*f*gd2*r*s + 588*D1*Dd*f*gd2*r - 336*D1*Dd*f*gd2*s**2 + 588*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 336*D1*Dd*fd*g2*r**2 - 672*D1*Dd*fd*g2*r*s + 252*D1*Dd*fd*g2*r - 336*D1*Dd*fd*g2*s**2 + 252*D1*Dd*fd*g2*s + 36*D1*Ddd*K*f**2*r**2 + 72*D1*Ddd*K*f**2*r*s - 54*D1*Ddd*K*f**2*r + 36*D1*Ddd*K*f**2*s**2 - 54*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 + 200*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 300*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r**2 - 336*D1*Ddd*f*g2*r*s + 252*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s**2 + 252*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(15*f**2*(r + s - 1) - 15*f*fd*(2*r + 2*s - 1) - 14*f*(K - 1)*(r + s - 1) + 14*fd*(K - 1)*(r + s)) - Dd*f*(-14*K + 15*f + 14)*(4*r + 4*s - 3))*(r + s - 1) + 108*Dd**2*K*f**2*r**2 + 216*Dd**2*K*f**2*r*s - 162*Dd**2*K*f**2*r + 108*Dd**2*K*f**2*s**2 - 162*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 + 600*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 900*Dd**2*f**3*r + 600*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 300*Dd**2*f**3 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 504*Dd**2*f*g2*r**2 - 1008*Dd**2*f*g2*r*s + 756*Dd**2*f*g2*r - 504*Dd**2*f*g2*s**2 + 756*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(6930*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**4*k2**4*st**2*(-252*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(-72*C*D1**2*f*fd*r**2 - 144*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s - 12*C*D1**2*f*fd + 36*C*D1**2*f*fdd*r**2 + 72*C*D1**2*f*fdd*r*s - 12*C*D1**2*f*fdd*r + 36*C*D1**2*f*fdd*s**2 - 12*C*D1**2*f*fdd*s + 6*C*D1**2*f*fdd + 36*C*D1**2*fd**2*r**2 + 72*C*D1**2*fd**2*r*s - 12*C*D1**2*fd**2*r + 36*C*D1**2*fd**2*s**2 - 12*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 144*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 216*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 216*C*D1*Dd*f**2*s - 108*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r**2 + 576*C*D1*Dd*f*fd*r*s - 264*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 264*C*D1*Dd*f*fd*s + 36*C*D1*Dd*f*fd + 72*C*D1*Ddd*f**2*r**2 + 144*C*D1*Ddd*f**2*r*s - 108*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s**2 - 108*C*D1*Ddd*f**2*s + 54*C*D1*Ddd*f**2 + 216*C*Dd**2*f**2*r**2 + 432*C*Dd**2*f**2*r*s - 324*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s**2 - 324*C*Dd**2*f**2*s + 108*C*Dd**2*f**2 - 28*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 116*D1**2*f*fd*r**2 + 232*D1**2*f*fd*r*s - 68*D1**2*f*fd*r + 116*D1**2*f*fd*s**2 - 68*D1**2*f*fd*s + 34*D1**2*f*fd - 86*D1**2*f*fdd*r**2 - 172*D1**2*f*fdd*r*s + 62*D1**2*f*fdd*r - 86*D1**2*f*fdd*s**2 + 62*D1**2*f*fdd*s - 31*D1**2*f*fdd - 86*D1**2*fd**2*r**2 - 172*D1**2*fd**2*r*s + 62*D1**2*fd**2*r - 86*D1**2*fd**2*s**2 + 62*D1**2*fd**2*s + 24*D1**2*fd**2 + 232*D1*Dd*f**2*r**2 + 464*D1*Dd*f**2*r*s - 348*D1*Dd*f**2*r + 232*D1*Dd*f**2*s**2 - 348*D1*Dd*f**2*s + 174*D1*Dd*f**2 - 688*D1*Dd*f*fd*r**2 - 1376*D1*Dd*f*fd*r*s + 764*D1*Dd*f*fd*r - 688*D1*Dd*f*fd*s**2 + 764*D1*Dd*f*fd*s - 186*D1*Dd*f*fd - 172*D1*Ddd*f**2*r**2 - 344*D1*Ddd*f**2*r*s + 258*D1*Ddd*f**2*r - 172*D1*Ddd*f**2*s**2 + 258*D1*Ddd*f**2*s - 129*D1*Ddd*f**2 + 56*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 516*Dd**2*f**2*r**2 - 1032*Dd**2*f**2*r*s + 774*Dd**2*f**2*r - 516*Dd**2*f**2*s**2 + 774*Dd**2*f**2*s - 258*Dd**2*f**2) + f*(900*C*D1**2*f*fd*r**2 + 1800*C*D1**2*f*fd*r*s - 1200*C*D1**2*f*fd*r + 900*C*D1**2*f*fd*s**2 - 1200*C*D1**2*f*fd*s + 600*C*D1**2*f*fd - 450*C*D1**2*f*fdd*r**2 - 900*C*D1**2*f*fdd*r*s + 600*C*D1**2*f*fdd*r - 450*C*D1**2*f*fdd*s**2 + 600*C*D1**2*f*fdd*s - 300*C*D1**2*f*fdd - 900*C*D1**2*fd**2*r**2 - 1800*C*D1**2*fd**2*r*s + 1200*C*D1**2*fd**2*r - 900*C*D1**2*fd**2*s**2 + 1200*C*D1**2*fd**2*s - 300*C*D1**2*fd**2 + 1200*C*D1*Dd*f**2*r**2 + 2400*C*D1*Dd*f**2*r*s - 1800*C*D1*Dd*f**2*r + 1200*C*D1*Dd*f**2*s**2 - 1800*C*D1*Dd*f**2*s + 900*C*D1*Dd*f**2 - 3600*C*D1*Dd*f*fd*r**2 - 7200*C*D1*Dd*f*fd*r*s + 5100*C*D1*Dd*f*fd*r - 3600*C*D1*Dd*f*fd*s**2 + 5100*C*D1*Dd*f*fd*s - 1800*C*D1*Dd*f*fd - 600*C*D1*Ddd*f**2*r**2 - 1200*C*D1*Ddd*f**2*r*s + 900*C*D1*Ddd*f**2*r - 600*C*D1*Ddd*f**2*s**2 + 900*C*D1*Ddd*f**2*s - 450*C*D1*Ddd*f**2 - 1800*C*Dd**2*f**2*r**2 - 3600*C*Dd**2*f**2*r*s + 2700*C*Dd**2*f**2*r - 1800*C*Dd**2*f**2*s**2 + 2700*C*Dd**2*f**2*s - 900*C*Dd**2*f**2 + 504*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 9*D1**2*bdd1*f*(6*C*(3*r**2 + 6*r*s - 10*r + 3*s**2 - 10*s + 5) - 43*r**2 - 86*r*s + 110*r - 43*s**2 + 110*s - 55) - 1326*D1**2*f*fd*r**2 - 2652*D1**2*f*fd*r*s + 1768*D1**2*f*fd*r - 1326*D1**2*f*fd*s**2 + 1768*D1**2*f*fd*s - 884*D1**2*f*fd + 825*D1**2*f*fdd*r**2 + 1650*D1**2*f*fdd*r*s - 1100*D1**2*f*fdd*r + 825*D1**2*f*fdd*s**2 - 1100*D1**2*f*fdd*s + 550*D1**2*f*fdd + 1650*D1**2*fd**2*r**2 + 3300*D1**2*fd**2*r*s - 2200*D1**2*fd**2*r + 1650*D1**2*fd**2*s**2 - 2200*D1**2*fd**2*s + 550*D1**2*fd**2 - 1768*D1*Dd*f**2*r**2 - 3536*D1*Dd*f**2*r*s + 2652*D1*Dd*f**2*r - 1768*D1*Dd*f**2*s**2 + 2652*D1*Dd*f**2*s - 1326*D1*Dd*f**2 + 6600*D1*Dd*f*fd*r**2 + 13200*D1*Dd*f*fd*r*s - 9350*D1*Dd*f*fd*r + 6600*D1*Dd*f*fd*s**2 - 9350*D1*Dd*f*fd*s + 3300*D1*Dd*f*fd + 1100*D1*Ddd*f**2*r**2 + 2200*D1*Ddd*f**2*r*s - 1650*D1*Ddd*f**2*r + 1100*D1*Ddd*f**2*s**2 - 1650*D1*Ddd*f**2*s + 825*D1*Ddd*f**2 + 18*D1*bd1*(D1*(f*(6*C*(3*r**2 + 6*r*s - 10*r + 3*s**2 - 10*s + 5) - 29*r**2 - 58*r*s + 82*r - 29*s**2 + 82*s - 41) - fd*(r + s - 1)*(6*C*(6*r + 6*s - 5) - 86*r - 86*s + 55)) - Dd*f*(4*r + 4*s - 3)*(6*C*(3*r + 3*s - 5) - 43*r - 43*s + 55)) + 3300*Dd**2*f**2*r**2 + 6600*Dd**2*f**2*r*s - 4950*Dd**2*f**2*r + 3300*Dd**2*f**2*s**2 - 4950*Dd**2*f**2*s + 1650*Dd**2*f**2))/(630*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**4*k2**4*(252*C*D1**2*bd1*f**2*r + 252*C*D1**2*bd1*f**2*s - 126*C*D1**2*bd1*f**2 - 270*C*D1**2*f**2*fd*r**2 - 540*C*D1**2*f**2*fd*r*s + 360*C*D1**2*f**2*fd*r - 270*C*D1**2*f**2*fd*s**2 + 360*C*D1**2*f**2*fd*s - 180*C*D1**2*f**2*fd - 360*C*D1*Dd*f**3*r**2 - 720*C*D1*Dd*f**3*r*s + 540*C*D1*Dd*f**3*r - 360*C*D1*Dd*f**3*s**2 + 540*C*D1*Dd*f**3*s - 270*C*D1*Dd*f**3 + 126*D1**2*K*bd1**2*f*r + 126*D1**2*K*bd1**2*f*s - 126*D1**2*K*bd1**2*f + 90*D1**2*K*bd1*f**2*r**2 + 180*D1**2*K*bd1*f**2*r*s - 180*D1**2*K*bd1*f**2*r + 90*D1**2*K*bd1*f**2*s**2 - 180*D1**2*K*bd1*f**2*s + 90*D1**2*K*bd1*f**2 - 180*D1**2*K*bd1*f*fd*r**2 - 360*D1**2*K*bd1*f*fd*r*s + 270*D1**2*K*bd1*f*fd*r - 180*D1**2*K*bd1*f*fd*s**2 + 270*D1**2*K*bd1*f*fd*s - 90*D1**2*K*bd1*f*fd - 45*D1**2*K*bdd1*f**2*r**2 - 90*D1**2*K*bdd1*f**2*r*s + 90*D1**2*K*bdd1*f**2*r - 45*D1**2*K*bdd1*f**2*s**2 + 90*D1**2*K*bdd1*f**2*s - 45*D1**2*K*bdd1*f**2 + 540*D1**2*bd1**2*f**2*r**2 + 1080*D1**2*bd1**2*f**2*r*s - 900*D1**2*bd1**2*f**2*r + 540*D1**2*bd1**2*f**2*s**2 - 900*D1**2*bd1**2*f**2*s + 360*D1**2*bd1**2*f**2 + 378*D1**2*bd1**2*f*r**2 + 756*D1**2*bd1**2*f*r*s - 882*D1**2*bd1**2*f*r + 378*D1**2*bd1**2*f*s**2 - 882*D1**2*bd1**2*f*s + 504*D1**2*bd1**2*f - 420*D1**2*bd1**2*g2*r**2 - 840*D1**2*bd1**2*g2*r*s + 420*D1**2*bd1**2*g2*r - 420*D1**2*bd1**2*g2*s**2 + 420*D1**2*bd1**2*g2*s - 126*D1**2*bd1*bd2*f*r**2 - 252*D1**2*bd1*bd2*f*r*s + 252*D1**2*bd1*bd2*f*r - 126*D1**2*bd1*bd2*f*s**2 + 252*D1**2*bd1*bd2*f*s - 126*D1**2*bd1*bd2*f - 310*D1**2*bd1*f**3*r**2 - 620*D1**2*bd1*f**3*r*s + 380*D1**2*bd1*f**3*r - 310*D1**2*bd1*f**3*s**2 + 380*D1**2*bd1*f**3*s - 190*D1**2*bd1*f**3 + 1470*D1**2*bd1*f**2*fd*r**2 + 2940*D1**2*bd1*f**2*fd*r*s - 2030*D1**2*bd1*f**2*fd*r + 1470*D1**2*bd1*f**2*fd*s**2 - 2030*D1**2*bd1*f**2*fd*s + 560*D1**2*bd1*f**2*fd - 171*D1**2*bd1*f**2*r**2 - 342*D1**2*bd1*f**2*r*s + 90*D1**2*bd1*f**2*r - 171*D1**2*bd1*f**2*s**2 + 90*D1**2*bd1*f**2*s - 45*D1**2*bd1*f**2 + 720*D1**2*bd1*f*fd*r**2 + 1440*D1**2*bd1*f*fd*r*s - 1080*D1**2*bd1*f*fd*r + 720*D1**2*bd1*f*fd*s**2 - 1080*D1**2*bd1*f*fd*s + 360*D1**2*bd1*f*fd + 504*D1**2*bd1*f*g2*r + 504*D1**2*bd1*f*g2*s - 252*D1**2*bd1*f*g2 - 252*D1**2*bd1*f*gd2*r - 252*D1**2*bd1*f*gd2*s + 252*D1**2*bd1*f*gd2 + 90*D1**2*bd2*f**2*r**2 + 180*D1**2*bd2*f**2*r*s - 180*D1**2*bd2*f**2*r + 90*D1**2*bd2*f**2*s**2 - 180*D1**2*bd2*f**2*s + 90*D1**2*bd2*f**2 - 180*D1**2*bd2*f*fd*r**2 - 360*D1**2*bd2*f*fd*r*s + 270*D1**2*bd2*f*fd*r - 180*D1**2*bd2*f*fd*s**2 + 270*D1**2*bd2*f*fd*s - 90*D1**2*bd2*f*fd + 245*D1**2*bdd1*f**3*r**2 + 490*D1**2*bdd1*f**3*r*s - 280*D1**2*bdd1*f**3*r + 245*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 140*D1**2*bdd1*f**3 + 180*D1**2*bdd1*f**2*r**2 + 360*D1**2*bdd1*f**2*r*s - 360*D1**2*bdd1*f**2*r + 180*D1**2*bdd1*f**2*s**2 - 360*D1**2*bdd1*f**2*s + 180*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r - 252*D1**2*bdd1*f*g2*s + 126*D1**2*bdd1*f*g2 - 45*D1**2*bdd2*f**2*r**2 - 90*D1**2*bdd2*f**2*r*s + 90*D1**2*bdd2*f**2*r - 45*D1**2*bdd2*f**2*s**2 + 90*D1**2*bdd2*f**2*s - 45*D1**2*bdd2*f**2 + 405*D1**2*f**2*fd*r**2 + 810*D1**2*f**2*fd*r*s - 540*D1**2*f**2*fd*r + 405*D1**2*f**2*fd*s**2 - 540*D1**2*f**2*fd*s + 270*D1**2*f**2*fd - 180*D1**2*f**2*gd2*r**2 - 360*D1**2*f**2*gd2*r*s + 360*D1**2*f**2*gd2*r - 180*D1**2*f**2*gd2*s**2 + 360*D1**2*f**2*gd2*s - 180*D1**2*f**2*gd2 + 90*D1**2*f**2*gdd2*r**2 + 180*D1**2*f**2*gdd2*r*s - 180*D1**2*f**2*gdd2*r + 90*D1**2*f**2*gdd2*s**2 - 180*D1**2*f**2*gdd2*s + 90*D1**2*f**2*gdd2 - 360*D1**2*f*fd*g2*r**2 - 720*D1**2*f*fd*g2*r*s + 360*D1**2*f*fd*g2*r - 360*D1**2*f*fd*g2*s**2 + 360*D1**2*f*fd*g2*s - 180*D1**2*f*fd*g2 + 360*D1**2*f*fd*gd2*r**2 + 720*D1**2*f*fd*gd2*r*s - 540*D1**2*f*fd*gd2*r + 360*D1**2*f*fd*gd2*s**2 - 540*D1**2*f*fd*gd2*s + 180*D1**2*f*fd*gd2 + 180*D1**2*f*fdd*g2*r**2 + 360*D1**2*f*fdd*g2*r*s - 180*D1**2*f*fdd*g2*r + 180*D1**2*f*fdd*g2*s**2 - 180*D1**2*f*fdd*g2*s + 90*D1**2*f*fdd*g2 + 180*D1**2*fd**2*g2*r**2 + 360*D1**2*fd**2*g2*r*s - 180*D1**2*fd**2*g2*r + 180*D1**2*fd**2*g2*s**2 - 180*D1**2*fd**2*g2*s - 360*D1*Dd*K*bd1*f**2*r**2 - 720*D1*Dd*K*bd1*f**2*r*s + 630*D1*Dd*K*bd1*f**2*r - 360*D1*Dd*K*bd1*f**2*s**2 + 630*D1*Dd*K*bd1*f**2*s - 270*D1*Dd*K*bd1*f**2 + 1960*D1*Dd*bd1*f**3*r**2 + 3920*D1*Dd*bd1*f**3*r*s - 2590*D1*Dd*bd1*f**3*r + 1960*D1*Dd*bd1*f**3*s**2 - 2590*D1*Dd*bd1*f**3*s + 840*D1*Dd*bd1*f**3 + 1440*D1*Dd*bd1*f**2*r**2 + 2880*D1*Dd*bd1*f**2*r*s - 2520*D1*Dd*bd1*f**2*r + 1440*D1*Dd*bd1*f**2*s**2 - 2520*D1*Dd*bd1*f**2*s + 1080*D1*Dd*bd1*f**2 - 1008*D1*Dd*bd1*f*g2*r - 1008*D1*Dd*bd1*f*g2*s + 756*D1*Dd*bd1*f*g2 - 360*D1*Dd*bd2*f**2*r**2 - 720*D1*Dd*bd2*f**2*r*s + 630*D1*Dd*bd2*f**2*r - 360*D1*Dd*bd2*f**2*s**2 + 630*D1*Dd*bd2*f**2*s - 270*D1*Dd*bd2*f**2 + 540*D1*Dd*f**3*r**2 + 1080*D1*Dd*f**3*r*s - 810*D1*Dd*f**3*r + 540*D1*Dd*f**3*s**2 - 810*D1*Dd*f**3*s + 405*D1*Dd*f**3 - 720*D1*Dd*f**2*g2*r**2 - 1440*D1*Dd*f**2*g2*r*s + 1080*D1*Dd*f**2*g2*r - 720*D1*Dd*f**2*g2*s**2 + 1080*D1*Dd*f**2*g2*s - 540*D1*Dd*f**2*g2 + 720*D1*Dd*f**2*gd2*r**2 + 1440*D1*Dd*f**2*gd2*r*s - 1260*D1*Dd*f**2*gd2*r + 720*D1*Dd*f**2*gd2*s**2 - 1260*D1*Dd*f**2*gd2*s + 540*D1*Dd*f**2*gd2 + 1440*D1*Dd*f*fd*g2*r**2 + 2880*D1*Dd*f*fd*g2*r*s - 1800*D1*Dd*f*fd*g2*r + 1440*D1*Dd*f*fd*g2*s**2 - 1800*D1*Dd*f*fd*g2*s + 540*D1*Dd*f*fd*g2 + 360*D1*Ddd*f**2*g2*r**2 + 720*D1*Ddd*f**2*g2*r*s - 540*D1*Ddd*f**2*g2*r + 360*D1*Ddd*f**2*g2*s**2 - 540*D1*Ddd*f**2*g2*s + 270*D1*Ddd*f**2*g2 + 1080*Dd**2*f**2*g2*r**2 + 2160*Dd**2*f**2*g2*r*s - 1620*Dd**2*f**2*g2*r + 1080*Dd**2*f**2*g2*s**2 - 1620*Dd**2*f**2*g2*s + 540*Dd**2*f**2*g2 + 21*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (5*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-5*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(70*C*D1**2*fd*r**2 + 140*C*D1**2*fd*r*s - 140*C*D1**2*fd*r + 70*C*D1**2*fd*s**2 - 140*C*D1**2*fd*s + 70*C*D1**2*fd + 280*C*D1*Dd*f*r**2 + 560*C*D1*Dd*f*r*s - 420*C*D1*Dd*f*r + 280*C*D1*Dd*f*s**2 - 420*C*D1*Dd*f*s + 210*C*D1*Dd*f + 84*D1**2*K*fd*r + 84*D1**2*K*fd*s - 42*D1**2*K*fd - 42*D1**2*K*fdd*r - 42*D1**2*K*fdd*s + 21*D1**2*K*fdd - 7*D1**2*bdd1*(-5*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 192*D1**2*f*fd*r**2 - 384*D1**2*f*fd*r*s + 228*D1**2*f*fd*r - 192*D1**2*f*fd*s**2 + 228*D1**2*f*fd*s - 114*D1**2*f*fd + 180*D1**2*f*fdd*r**2 + 360*D1**2*f*fdd*r*s - 240*D1**2*f*fdd*r + 180*D1**2*f*fdd*s**2 - 240*D1**2*f*fdd*s + 120*D1**2*f*fdd + 180*D1**2*fd**2*r**2 + 360*D1**2*fd**2*r*s - 240*D1**2*fd**2*r + 180*D1**2*fd**2*s**2 - 240*D1**2*fd**2*s + 60*D1**2*fd**2 - 126*D1**2*fd*r**2 - 252*D1**2*fd*r*s + 56*D1**2*fd*r - 126*D1**2*fd*s**2 + 56*D1**2*fd*s - 28*D1**2*fd + 63*D1**2*fdd*r**2 + 126*D1**2*fdd*r*s + 42*D1**2*fdd*r + 63*D1**2*fdd*s**2 + 42*D1**2*fdd*s - 21*D1**2*fdd + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 - 168*D1*Dd*K*fd*r - 168*D1*Dd*K*fd*s + 126*D1*Dd*K*fd - 384*D1*Dd*f**2*r**2 - 768*D1*Dd*f**2*r*s + 576*D1*Dd*f**2*r - 384*D1*Dd*f**2*s**2 + 576*D1*Dd*f**2*s - 288*D1*Dd*f**2 + 1440*D1*Dd*f*fd*r**2 + 2880*D1*Dd*f*fd*r*s - 2040*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 2040*D1*Dd*f*fd*s + 720*D1*Dd*f*fd - 504*D1*Dd*f*r**2 - 1008*D1*Dd*f*r*s + 756*D1*Dd*f*r - 504*D1*Dd*f*s**2 + 756*D1*Dd*f*s - 378*D1*Dd*f + 504*D1*Dd*fd*r**2 + 1008*D1*Dd*fd*r*s - 210*D1*Dd*fd*r + 504*D1*Dd*fd*s**2 - 210*D1*Dd*fd*s - 126*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 + 360*D1*Ddd*f**2*r**2 + 720*D1*Ddd*f**2*r*s - 540*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 540*D1*Ddd*f**2*s + 270*D1*Ddd*f**2 + 252*D1*Ddd*f*r**2 + 504*D1*Ddd*f*r*s - 378*D1*Ddd*f*r + 252*D1*Ddd*f*s**2 - 378*D1*Ddd*f*s + 189*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 14*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (5*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-5*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 1080*Dd**2*f**2*r**2 + 2160*Dd**2*f**2*r*s - 1620*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1620*Dd**2*f**2*s + 540*Dd**2*f**2 + 756*Dd**2*f*r**2 + 1512*Dd**2*f*r*s - 1134*Dd**2*f*r + 756*Dd**2*f*s**2 - 1134*Dd**2*f*s + 378*Dd**2*f - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) + b1*(-252*C*D1**2*f*fd*r - 252*C*D1**2*f*fd*s + 126*C*D1**2*f*fd + 126*D1**2*K*bdd1*f*r + 126*D1**2*K*bdd1*f*s - 63*D1**2*K*bdd1*f + 180*D1**2*K*f*fd*r**2 + 360*D1**2*K*f*fd*r*s - 180*D1**2*K*f*fd*r + 180*D1**2*K*f*fd*s**2 - 180*D1**2*K*f*fd*s + 90*D1**2*K*f*fd - 90*D1**2*K*f*fdd*r**2 - 180*D1**2*K*f*fdd*r*s + 90*D1**2*K*f*fdd*r - 90*D1**2*K*f*fdd*s**2 + 90*D1**2*K*f*fdd*s - 45*D1**2*K*f*fdd - 90*D1**2*K*fd**2*r**2 - 180*D1**2*K*fd**2*r*s + 90*D1**2*K*fd**2*r - 90*D1**2*K*fd**2*s**2 + 90*D1**2*K*fd**2*s + 126*D1**2*b2*fd*r**2 + 252*D1**2*b2*fd*r*s + 126*D1**2*b2*fd*s**2 - 63*D1**2*b2*fdd*r**2 - 126*D1**2*b2*fdd*r*s - 63*D1**2*b2*fdd*s**2 - 42*D1**2*bd1**2*(-5*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 540*D1**2*bdd1*f**2*r**2 + 1080*D1**2*bdd1*f**2*r*s - 900*D1**2*bdd1*f**2*r + 540*D1**2*bdd1*f**2*s**2 - 900*D1**2*bdd1*f**2*s + 450*D1**2*bdd1*f**2 + 378*D1**2*bdd1*f*r**2 + 756*D1**2*bdd1*f*r*s - 882*D1**2*bdd1*f*r + 378*D1**2*bdd1*f*s**2 - 882*D1**2*bdd1*f*s + 441*D1**2*bdd1*f - 420*D1**2*bdd1*g2*r**2 - 840*D1**2*bdd1*g2*r*s + 420*D1**2*bdd1*g2*r - 420*D1**2*bdd1*g2*s**2 + 420*D1**2*bdd1*g2*s - 210*D1**2*bdd1*g2 - 63*D1**2*bdd2*f*r**2 - 126*D1**2*bdd2*f*r*s + 126*D1**2*bdd2*f*r - 63*D1**2*bdd2*f*s**2 + 126*D1**2*bdd2*f*s - 63*D1**2*bdd2*f - 930*D1**2*f**2*fd*r**2 - 1860*D1**2*f**2*fd*r*s + 1480*D1**2*f**2*fd*r - 930*D1**2*f**2*fd*s**2 + 1480*D1**2*f**2*fd*s - 740*D1**2*f**2*fd + 735*D1**2*f**2*fdd*r**2 + 1470*D1**2*f**2*fdd*r*s - 1190*D1**2*f**2*fdd*r + 735*D1**2*f**2*fdd*s**2 - 1190*D1**2*f**2*fdd*s + 595*D1**2*f**2*fdd + 1470*D1**2*f*fd**2*r**2 + 2940*D1**2*f*fd**2*r*s - 2380*D1**2*f*fd**2*r + 1470*D1**2*f*fd**2*s**2 - 2380*D1**2*f*fd**2*s + 910*D1**2*f*fd**2 - 342*D1**2*f*fd*r**2 - 684*D1**2*f*fd*r*s + 594*D1**2*f*fd*r - 342*D1**2*f*fd*s**2 + 594*D1**2*f*fd*s - 297*D1**2*f*fd + 360*D1**2*f*fdd*r**2 + 720*D1**2*f*fdd*r*s - 360*D1**2*f*fdd*r + 360*D1**2*f*fdd*s**2 - 360*D1**2*f*fdd*s + 180*D1**2*f*fdd + 360*D1**2*fd**2*r**2 + 720*D1**2*fd**2*r*s - 360*D1**2*fd**2*r + 360*D1**2*fd**2*s**2 - 360*D1**2*fd**2*s - 504*D1**2*fd*g2*r - 504*D1**2*fd*g2*s + 252*D1**2*fd*g2 + 252*D1**2*fd*gd2*r + 252*D1**2*fd*gd2*s - 252*D1**2*fd*gd2 + 252*D1**2*fdd*g2*r + 252*D1**2*fdd*g2*s - 126*D1**2*fdd*g2 + 360*D1*Dd*K*f**2*r**2 + 720*D1*Dd*K*f**2*r*s - 540*D1*Dd*K*f**2*r + 360*D1*Dd*K*f**2*s**2 - 540*D1*Dd*K*f**2*s + 270*D1*Dd*K*f**2 - 720*D1*Dd*K*f*fd*r**2 - 1440*D1*Dd*K*f*fd*r*s + 900*D1*Dd*K*f*fd*r - 720*D1*Dd*K*f*fd*s**2 + 900*D1*Dd*K*f*fd*s - 270*D1*Dd*K*f*fd + 504*D1*Dd*b2*f*r**2 + 1008*D1*Dd*b2*f*r*s - 756*D1*Dd*b2*f*r + 504*D1*Dd*b2*f*s**2 - 756*D1*Dd*b2*f*s + 378*D1*Dd*b2*f - 504*D1*Dd*b2*fd*r**2 - 1008*D1*Dd*b2*fd*r*s + 378*D1*Dd*b2*fd*r - 504*D1*Dd*b2*fd*s**2 + 378*D1*Dd*b2*fd*s - 1240*D1*Dd*f**3*r**2 - 2480*D1*Dd*f**3*r*s + 1860*D1*Dd*f**3*r - 1240*D1*Dd*f**3*s**2 + 1860*D1*Dd*f**3*s - 930*D1*Dd*f**3 + 5880*D1*Dd*f**2*fd*r**2 + 11760*D1*Dd*f**2*fd*r*s - 9170*D1*Dd*f**2*fd*r + 5880*D1*Dd*f**2*fd*s**2 - 9170*D1*Dd*f**2*fd*s + 3570*D1*Dd*f**2*fd - 684*D1*Dd*f**2*r**2 - 1368*D1*Dd*f**2*r*s + 1026*D1*Dd*f**2*r - 684*D1*Dd*f**2*s**2 + 1026*D1*Dd*f**2*s - 513*D1*Dd*f**2 + 2880*D1*Dd*f*fd*r**2 + 5760*D1*Dd*f*fd*r*s - 3600*D1*Dd*f*fd*r + 2880*D1*Dd*f*fd*s**2 - 3600*D1*Dd*f*fd*s + 1080*D1*Dd*f*fd + 1008*D1*Dd*fd*g2*r + 1008*D1*Dd*fd*g2*s - 756*D1*Dd*fd*g2 - 180*D1*Ddd*K*f**2*r**2 - 360*D1*Ddd*K*f**2*r*s + 270*D1*Ddd*K*f**2*r - 180*D1*Ddd*K*f**2*s**2 + 270*D1*Ddd*K*f**2*s - 135*D1*Ddd*K*f**2 - 252*D1*Ddd*b2*f*r**2 - 504*D1*Ddd*b2*f*r*s + 378*D1*Ddd*b2*f*r - 252*D1*Ddd*b2*f*s**2 + 378*D1*Ddd*b2*f*s - 189*D1*Ddd*b2*f + 980*D1*Ddd*f**3*r**2 + 1960*D1*Ddd*f**3*r*s - 1470*D1*Ddd*f**3*r + 980*D1*Ddd*f**3*s**2 - 1470*D1*Ddd*f**3*s + 735*D1*Ddd*f**3 + 720*D1*Ddd*f**2*r**2 + 1440*D1*Ddd*f**2*r*s - 1080*D1*Ddd*f**2*r + 720*D1*Ddd*f**2*s**2 - 1080*D1*Ddd*f**2*s + 540*D1*Ddd*f**2 - 6*D1*bd1*(D1*(3*f**2*(32*r**2 + r*(64*s - 58) + 32*s**2 - 58*s + 29) + f*(-35*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(6*r + 6*s - 3) - 180*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 126*r**2 + 28*r*(9*s - 8) + 126*s**2 - 224*s + 112) + 21*fd*(r + s - 1)*(K - 6*r - 6*s - 1) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - Dd*(4*r + 4*s - 3)*(30*f**2*(6*r + 6*s - 5) + 21*f*(K + 6*r + 6*s - 7) - 70*g2*(2*r + 2*s - 1))) + 126*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 540*Dd**2*K*f**2*r**2 - 1080*Dd**2*K*f**2*r*s + 810*Dd**2*K*f**2*r - 540*Dd**2*K*f**2*s**2 + 810*Dd**2*K*f**2*s - 270*Dd**2*K*f**2 - 756*Dd**2*b2*f*r**2 - 1512*Dd**2*b2*f*r*s + 1134*Dd**2*b2*f*r - 756*Dd**2*b2*f*s**2 + 1134*Dd**2*b2*f*s - 378*Dd**2*b2*f + 2940*Dd**2*f**3*r**2 + 5880*Dd**2*f**3*r*s - 4410*Dd**2*f**3*r + 2940*Dd**2*f**3*s**2 - 4410*Dd**2*f**3*s + 1470*Dd**2*f**3 + 2160*Dd**2*f**2*r**2 + 4320*Dd**2*f**2*r*s - 3240*Dd**2*f**2*r + 2160*Dd**2*f**2*s**2 - 3240*Dd**2*f**2*s + 1080*Dd**2*f**2) + 9*b2*(-7*D1**2*bdd1*f*(r + s - 1)**2 + 5*D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 5*D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**4*k2**2*(-3*D1*f*(r + s)*(14*D1*bd1**2*(2*C - 3)*(r + s - 1) + 5*D1*bdd1*f*(2*C - 3)*(r + s) + 2*bd1*(-D1*f*(10*C - 8)*(r + s) + D1*fd*(20*C - 30)*(r + s - 1) + Dd*f*(10*C - 15)*(4*r + 4*s - 3))) + 7*b1**2*(D1**2*(fd*(12*C - 8) + fdd*(9 - 6*C))*(r + s - 1)**2 + D1*(Dd*f*(12*C - 8)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + Dd*fd*(18 - 12*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - Ddd*f*(6*C - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(36*C - 54)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*D1**2*(r + s - 1)**2*(f*fd*(20*C - 16) + f*fdd*(15 - 10*C) + fd**2*(15 - 10*C)) + 14*D1*bd1*(D1*(f*(6*C - 4)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(9 - 6*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(9 - 6*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 3*D1*f*(-4*Dd*(f*(5*C - 4)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(15 - 10*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(10*C - 15)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 3*Dd**2*f**2*(60*C - 90)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct**3*f*k2**7*st**4*(-66*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 88*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fd*s**2 + 88*D1**2*b1*f*fd*s - 44*D1**2*b1*f*fd + 33*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*f*fdd*r*s - 44*D1**2*b1*f*fdd*r + 33*D1**2*b1*f*fdd*s**2 - 44*D1**2*b1*f*fdd*s + 22*D1**2*b1*f*fdd + 66*D1**2*b1*fd**2*r**2 + 132*D1**2*b1*fd**2*r*s - 88*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 88*D1**2*b1*fd**2*s + 22*D1**2*b1*fd**2 + 11*D1**2*bdd1*f**2*(r + s - 1)**2 - 40*D1**2*f**2*fd*r**2 - 80*D1**2*f**2*fd*r*s + 60*D1**2*f**2*fd*r - 40*D1**2*f**2*fd*s**2 + 60*D1**2*f**2*fd*s - 30*D1**2*f**2*fd + 20*D1**2*f**2*fdd*r**2 + 40*D1**2*f**2*fdd*r*s - 30*D1**2*f**2*fdd*r + 20*D1**2*f**2*fdd*s**2 - 30*D1**2*f**2*fdd*s + 15*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 + 120*D1**2*f*fd**2*r*s - 90*D1**2*f*fd**2*r + 60*D1**2*f*fd**2*s**2 - 90*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 - 88*D1*Dd*b1*f**2*r**2 - 176*D1*Dd*b1*f**2*r*s + 132*D1*Dd*b1*f**2*r - 88*D1*Dd*b1*f**2*s**2 + 132*D1*Dd*b1*f**2*s - 66*D1*Dd*b1*f**2 + 264*D1*Dd*b1*f*fd*r**2 + 528*D1*Dd*b1*f*fd*r*s - 374*D1*Dd*b1*f*fd*r + 264*D1*Dd*b1*f*fd*s**2 - 374*D1*Dd*b1*f*fd*s + 132*D1*Dd*b1*f*fd - 40*D1*Dd*f**3*r**2 - 80*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 60*D1*Dd*f**3*s - 30*D1*Dd*f**3 + 160*D1*Dd*f**2*fd*r**2 + 320*D1*Dd*f**2*fd*r*s - 240*D1*Dd*f**2*fd*r + 160*D1*Dd*f**2*fd*s**2 - 240*D1*Dd*f**2*fd*s + 90*D1*Dd*f**2*fd + 44*D1*Ddd*b1*f**2*r**2 + 88*D1*Ddd*b1*f**2*r*s - 66*D1*Ddd*b1*f**2*r + 44*D1*Ddd*b1*f**2*s**2 - 66*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 - 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + 132*Dd**2*b1*f**2*r**2 + 264*Dd**2*b1*f**2*r*s - 198*Dd**2*b1*f**2*r + 132*Dd**2*b1*f**2*s**2 - 198*Dd**2*b1*f**2*s + 66*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 30*Dd**2*f**3)/(66*d**2*k1*k3**6) - D1**2*Pk1*Pkdd3*ct**3*k1**5*k2*(12*C - 7)*(54*D1**2*b1*f*fd*r**2 + 108*D1**2*b1*f*fd*r*s - 54*D1**2*b1*f*fd*r + 54*D1**2*b1*f*fd*s**2 - 54*D1**2*b1*f*fd*s + 27*D1**2*b1*f*fd - 90*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd - 90*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)**2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 216*D1*Dd*b1*f**2*r*s - 162*D1*Dd*b1*f**2*r + 108*D1*Dd*b1*f**2*s**2 - 162*D1*Dd*b1*f**2*s + 81*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 900*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 900*D1*Dd*b1*f*fd*s - 270*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 1190*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 1190*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 270*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 270*D1*Ddd*b1*f**2*s - 135*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 210*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 210*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 540*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 810*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 810*Dd**2*b1*f**2*s - 270*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 630*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 630*Dd**2*f**3*s - 210*Dd**2*f**3)/(630*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**3*k1**3*k2**3*st**2*(-2112*C*D1**2*b1*f*fd*r**2 - 4224*C*D1**2*b1*f*fd*r*s + 2112*C*D1**2*b1*f*fd*r - 2112*C*D1**2*b1*f*fd*s**2 + 2112*C*D1**2*b1*f*fd*s - 1056*C*D1**2*b1*f*fd + 2232*C*D1**2*b1*f*fdd*r**2 + 4464*C*D1**2*b1*f*fdd*r*s - 2232*C*D1**2*b1*f*fdd*r + 2232*C*D1**2*b1*f*fdd*s**2 - 2232*C*D1**2*b1*f*fdd*s + 1116*C*D1**2*b1*f*fdd + 2232*C*D1**2*b1*fd**2*r**2 + 4464*C*D1**2*b1*fd**2*r*s - 2232*C*D1**2*b1*fd**2*r + 2232*C*D1**2*b1*fd**2*s**2 - 2232*C*D1**2*b1*fd**2*s - 2208*C*D1**2*f**2*fd*r**2 - 4416*C*D1**2*f**2*fd*r*s + 2944*C*D1**2*f**2*fd*r - 2208*C*D1**2*f**2*fd*s**2 + 2944*C*D1**2*f**2*fd*s - 1472*C*D1**2*f**2*fd + 1860*C*D1**2*f**2*fdd*r**2 + 3720*C*D1**2*f**2*fdd*r*s - 2480*C*D1**2*f**2*fdd*r + 1860*C*D1**2*f**2*fdd*s**2 - 2480*C*D1**2*f**2*fdd*s + 1240*C*D1**2*f**2*fdd + 3720*C*D1**2*f*fd**2*r**2 + 7440*C*D1**2*f*fd**2*r*s - 4960*C*D1**2*f*fd**2*r + 3720*C*D1**2*f*fd**2*s**2 - 4960*C*D1**2*f*fd**2*s + 1240*C*D1**2*f*fd**2 - 4224*C*D1*Dd*b1*f**2*r**2 - 8448*C*D1*Dd*b1*f**2*r*s + 6336*C*D1*Dd*b1*f**2*r - 4224*C*D1*Dd*b1*f**2*s**2 + 6336*C*D1*Dd*b1*f**2*s - 3168*C*D1*Dd*b1*f**2 + 17856*C*D1*Dd*b1*f*fd*r**2 + 35712*C*D1*Dd*b1*f*fd*r*s - 22320*C*D1*Dd*b1*f*fd*r + 17856*C*D1*Dd*b1*f*fd*s**2 - 22320*C*D1*Dd*b1*f*fd*s + 6696*C*D1*Dd*b1*f*fd - 2944*C*D1*Dd*f**3*r**2 - 5888*C*D1*Dd*f**3*r*s + 4416*C*D1*Dd*f**3*r - 2944*C*D1*Dd*f**3*s**2 + 4416*C*D1*Dd*f**3*s - 2208*C*D1*Dd*f**3 + 14880*C*D1*Dd*f**2*fd*r**2 + 29760*C*D1*Dd*f**2*fd*r*s - 21080*C*D1*Dd*f**2*fd*r + 14880*C*D1*Dd*f**2*fd*s**2 - 21080*C*D1*Dd*f**2*fd*s + 7440*C*D1*Dd*f**2*fd + 4464*C*D1*Ddd*b1*f**2*r**2 + 8928*C*D1*Ddd*b1*f**2*r*s - 6696*C*D1*Ddd*b1*f**2*r + 4464*C*D1*Ddd*b1*f**2*s**2 - 6696*C*D1*Ddd*b1*f**2*s + 3348*C*D1*Ddd*b1*f**2 + 2480*C*D1*Ddd*f**3*r**2 + 4960*C*D1*Ddd*f**3*r*s - 3720*C*D1*Ddd*f**3*r + 2480*C*D1*Ddd*f**3*s**2 - 3720*C*D1*Ddd*f**3*s + 1860*C*D1*Ddd*f**3 + 13392*C*Dd**2*b1*f**2*r**2 + 26784*C*Dd**2*b1*f**2*r*s - 20088*C*Dd**2*b1*f**2*r + 13392*C*Dd**2*b1*f**2*s**2 - 20088*C*Dd**2*b1*f**2*s + 6696*C*Dd**2*b1*f**2 + 7440*C*Dd**2*f**3*r**2 + 14880*C*Dd**2*f**3*r*s - 11160*C*Dd**2*f**3*r + 7440*C*Dd**2*f**3*s**2 - 11160*C*Dd**2*f**3*s + 3720*C*Dd**2*f**3 + 1374*D1**2*b1*f*fd*r**2 + 2748*D1**2*b1*f*fd*r*s - 1374*D1**2*b1*f*fd*r + 1374*D1**2*b1*f*fd*s**2 - 1374*D1**2*b1*f*fd*s + 687*D1**2*b1*f*fd - 1548*D1**2*b1*f*fdd*r**2 - 3096*D1**2*b1*f*fdd*r*s + 1548*D1**2*b1*f*fdd*r - 1548*D1**2*b1*f*fdd*s**2 + 1548*D1**2*b1*f*fdd*s - 774*D1**2*b1*f*fdd - 1548*D1**2*b1*fd**2*r**2 - 3096*D1**2*b1*fd**2*r*s + 1548*D1**2*b1*fd**2*r - 1548*D1**2*b1*fd**2*s**2 + 1548*D1**2*b1*fd**2*s + 18*D1**2*bdd1*f**2*(62*C - 43)*(r + s - 1)**2 + 1473*D1**2*f**2*fd*r**2 + 2946*D1**2*f**2*fd*r*s - 1964*D1**2*f**2*fd*r + 1473*D1**2*f**2*fd*s**2 - 1964*D1**2*f**2*fd*s + 982*D1**2*f**2*fd - 1290*D1**2*f**2*fdd*r**2 - 2580*D1**2*f**2*fdd*r*s + 1720*D1**2*f**2*fdd*r - 1290*D1**2*f**2*fdd*s**2 + 1720*D1**2*f**2*fdd*s - 860*D1**2*f**2*fdd - 2580*D1**2*f*fd**2*r**2 - 5160*D1**2*f*fd**2*r*s + 3440*D1**2*f*fd**2*r - 2580*D1**2*f*fd**2*s**2 + 3440*D1**2*f*fd**2*s - 860*D1**2*f*fd**2 + 2748*D1*Dd*b1*f**2*r**2 + 5496*D1*Dd*b1*f**2*r*s - 4122*D1*Dd*b1*f**2*r + 2748*D1*Dd*b1*f**2*s**2 - 4122*D1*Dd*b1*f**2*s + 2061*D1*Dd*b1*f**2 - 12384*D1*Dd*b1*f*fd*r**2 - 24768*D1*Dd*b1*f*fd*r*s + 15480*D1*Dd*b1*f*fd*r - 12384*D1*Dd*b1*f*fd*s**2 + 15480*D1*Dd*b1*f*fd*s - 4644*D1*Dd*b1*f*fd + 1964*D1*Dd*f**3*r**2 + 3928*D1*Dd*f**3*r*s - 2946*D1*Dd*f**3*r + 1964*D1*Dd*f**3*s**2 - 2946*D1*Dd*f**3*s + 1473*D1*Dd*f**3 - 10320*D1*Dd*f**2*fd*r**2 - 20640*D1*Dd*f**2*fd*r*s + 14620*D1*Dd*f**2*fd*r - 10320*D1*Dd*f**2*fd*s**2 + 14620*D1*Dd*f**2*fd*s - 5160*D1*Dd*f**2*fd - 3096*D1*Ddd*b1*f**2*r**2 - 6192*D1*Ddd*b1*f**2*r*s + 4644*D1*Ddd*b1*f**2*r - 3096*D1*Ddd*b1*f**2*s**2 + 4644*D1*Ddd*b1*f**2*s - 2322*D1*Ddd*b1*f**2 - 1720*D1*Ddd*f**3*r**2 - 3440*D1*Ddd*f**3*r*s + 2580*D1*Ddd*f**3*r - 1720*D1*Ddd*f**3*s**2 + 2580*D1*Ddd*f**3*s - 1290*D1*Ddd*f**3 - 3*D1*bd1*f*(r + s - 1)*(D1*f*(352*C - 229)*(r + s - 1) - D1*fd*(744*C - 516)*(2*r + 2*s - 1) - Dd*f*(744*C - 516)*(4*r + 4*s - 3)) - 9288*Dd**2*b1*f**2*r**2 - 18576*Dd**2*b1*f**2*r*s + 13932*Dd**2*b1*f**2*r - 9288*Dd**2*b1*f**2*s**2 + 13932*Dd**2*b1*f**2*s - 4644*Dd**2*b1*f**2 - 5160*Dd**2*f**3*r**2 - 10320*Dd**2*f**3*r*s + 7740*Dd**2*f**3*r - 5160*Dd**2*f**3*s**2 + 7740*Dd**2*f**3*s - 2580*Dd**2*f**3)/(315*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**3*k1**3*k2**3*(-11880*C*D1**2*f**2*fd*r**2 - 23760*C*D1**2*f**2*fd*r*s + 15840*C*D1**2*f**2*fd*r - 11880*C*D1**2*f**2*fd*s**2 + 15840*C*D1**2*f**2*fd*s - 7920*C*D1**2*f**2*fd - 15840*C*D1*Dd*f**3*r**2 - 31680*C*D1*Dd*f**3*r*s + 23760*C*D1*Dd*f**3*r - 15840*C*D1*Dd*f**3*s**2 + 23760*C*D1*Dd*f**3*s - 11880*C*D1*Dd*f**3 - 9900*D1**2*K*bdd1*f**2*r**2 - 19800*D1**2*K*bdd1*f**2*r*s + 19800*D1**2*K*bdd1*f**2*r - 9900*D1**2*K*bdd1*f**2*s**2 + 19800*D1**2*K*bdd1*f**2*s - 9900*D1**2*K*bdd1*f**2 + 1980*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 + 1925*D1**2*bdd1*f**3*r**2 + 3850*D1**2*bdd1*f**3*r*s - 3850*D1**2*bdd1*f**3*r + 1925*D1**2*bdd1*f**3*s**2 - 3850*D1**2*bdd1*f**3*s + 1925*D1**2*bdd1*f**3 + 4950*D1**2*bdd1*f**2*r**2 + 9900*D1**2*bdd1*f**2*r*s - 9900*D1**2*bdd1*f**2*r + 4950*D1**2*bdd1*f**2*s**2 - 9900*D1**2*bdd1*f**2*s + 4950*D1**2*bdd1*f**2 + 27720*D1**2*bdd1*f*g2*r**2 + 55440*D1**2*bdd1*f*g2*r*s - 55440*D1**2*bdd1*f*g2*r + 27720*D1**2*bdd1*f*g2*s**2 - 55440*D1**2*bdd1*f*g2*s + 27720*D1**2*bdd1*f*g2 + 4900*D1**2*f**3*fd*r**2 + 9800*D1**2*f**3*fd*r*s - 7350*D1**2*f**3*fd*r + 4900*D1**2*f**3*fd*s**2 - 7350*D1**2*f**3*fd*s + 3675*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 + 7425*D1**2*f**2*fd*r**2 + 14850*D1**2*f**2*fd*r*s - 9900*D1**2*f**2*fd*r + 7425*D1**2*f**2*fd*s**2 - 9900*D1**2*f**2*fd*s + 4950*D1**2*f**2*fd - 17424*D1**2*f**2*gd2*r**2 - 34848*D1**2*f**2*gd2*r*s + 34848*D1**2*f**2*gd2*r - 17424*D1**2*f**2*gd2*s**2 + 34848*D1**2*f**2*gd2*s - 17424*D1**2*f**2*gd2 + 19800*D1**2*f**2*gdd2*r**2 + 39600*D1**2*f**2*gdd2*r*s - 39600*D1**2*f**2*gdd2*r + 19800*D1**2*f**2*gdd2*s**2 - 39600*D1**2*f**2*gdd2*s + 19800*D1**2*f**2*gdd2 - 34848*D1**2*f*fd*g2*r**2 - 69696*D1**2*f*fd*g2*r*s + 34848*D1**2*f*fd*g2*r - 34848*D1**2*f*fd*g2*s**2 + 34848*D1**2*f*fd*g2*s - 17424*D1**2*f*fd*g2 + 79200*D1**2*f*fd*gd2*r**2 + 158400*D1**2*f*fd*gd2*r*s - 118800*D1**2*f*fd*gd2*r + 79200*D1**2*f*fd*gd2*s**2 - 118800*D1**2*f*fd*gd2*s + 39600*D1**2*f*fd*gd2 + 39600*D1**2*f*fdd*g2*r**2 + 79200*D1**2*f*fdd*g2*r*s - 39600*D1**2*f*fdd*g2*r + 39600*D1**2*f*fdd*g2*s**2 - 39600*D1**2*f*fdd*g2*s + 19800*D1**2*f*fdd*g2 + 39600*D1**2*fd**2*g2*r**2 + 79200*D1**2*fd**2*g2*r*s - 39600*D1**2*fd**2*g2*r + 39600*D1**2*fd**2*g2*s**2 - 39600*D1**2*fd**2*g2*s + 4900*D1*Dd*f**4*r**2 + 9800*D1*Dd*f**4*r*s - 7350*D1*Dd*f**4*r + 4900*D1*Dd*f**4*s**2 - 7350*D1*Dd*f**4*s + 3675*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd + 9900*D1*Dd*f**3*r**2 + 19800*D1*Dd*f**3*r*s - 14850*D1*Dd*f**3*r + 9900*D1*Dd*f**3*s**2 - 14850*D1*Dd*f**3*s + 7425*D1*Dd*f**3 - 69696*D1*Dd*f**2*g2*r**2 - 139392*D1*Dd*f**2*g2*r*s + 104544*D1*Dd*f**2*g2*r - 69696*D1*Dd*f**2*g2*s**2 + 104544*D1*Dd*f**2*g2*s - 52272*D1*Dd*f**2*g2 + 158400*D1*Dd*f**2*gd2*r**2 + 316800*D1*Dd*f**2*gd2*r*s - 277200*D1*Dd*f**2*gd2*r + 158400*D1*Dd*f**2*gd2*s**2 - 277200*D1*Dd*f**2*gd2*s + 118800*D1*Dd*f**2*gd2 + 316800*D1*Dd*f*fd*g2*r**2 + 633600*D1*Dd*f*fd*g2*r*s - 396000*D1*Dd*f*fd*g2*r + 316800*D1*Dd*f*fd*g2*s**2 - 396000*D1*Dd*f*fd*g2*s + 118800*D1*Dd*f*fd*g2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 79200*D1*Ddd*f**2*g2*r**2 + 158400*D1*Ddd*f**2*g2*r*s - 118800*D1*Ddd*f**2*g2*r + 79200*D1*Ddd*f**2*g2*s**2 - 118800*D1*Ddd*f**2*g2*s + 59400*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(85*f**3*(r + s - 1) + f**2*(252*C*(r + s - 1) - 175*fd*(3*r + 3*s - 2) - (396*K - 9)*(r + s - 1)) + 30*f*(15*fd*(2*K - 1)*(2*r + 2*s - 1) + (28*g2 - 84*gd2)*(r + s - 1)) - 2520*fd*g2*(r + s)) - 5*Dd*f*(35*f**2 - 90*f*(2*K - 1) + 504*g2)*(4*r + 4*s - 3))*(r + s - 1) - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 237600*Dd**2*f**2*g2*r**2 + 475200*Dd**2*f**2*g2*r*s - 356400*Dd**2*f**2*g2*r + 237600*Dd**2*f**2*g2*s**2 - 356400*Dd**2*f**2*g2*s + 118800*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(3*f*(37*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-5*r - 5*s)*(60*fd**2*(r + s - 1) + 7*fd*(8*K - 3)*(r + s) - 42*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(111*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (56*K - 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 420*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 30*Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(1008*C*D1**2*f*fd*r**2 + 2016*C*D1**2*f*fd*r*s - 1008*C*D1**2*f*fd*r + 1008*C*D1**2*f*fd*s**2 - 1008*C*D1**2*f*fd*s + 504*C*D1**2*f*fd + 2016*C*D1*Dd*f**2*r**2 + 4032*C*D1*Dd*f**2*r*s - 3024*C*D1*Dd*f**2*r + 2016*C*D1*Dd*f**2*s**2 - 3024*C*D1*Dd*f**2*s + 1512*C*D1*Dd*f**2 - 1584*D1**2*K*f*fd*r**2 - 3168*D1**2*K*f*fd*r*s + 1584*D1**2*K*f*fd*r - 1584*D1**2*K*f*fd*s**2 + 1584*D1**2*K*f*fd*s - 792*D1**2*K*f*fd + 1800*D1**2*K*f*fdd*r**2 + 3600*D1**2*K*f*fdd*r*s - 1800*D1**2*K*f*fdd*r + 1800*D1**2*K*f*fdd*s**2 - 1800*D1**2*K*f*fdd*s + 900*D1**2*K*f*fdd + 1800*D1**2*K*fd**2*r**2 + 3600*D1**2*K*fd**2*r*s - 1800*D1**2*K*fd**2*r + 1800*D1**2*K*fd**2*s**2 - 1800*D1**2*K*fd**2*s - 180*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 + 510*D1**2*f**2*fd*r**2 + 1020*D1**2*f**2*fd*r*s - 680*D1**2*f**2*fd*r + 510*D1**2*f**2*fd*s**2 - 680*D1**2*f**2*fd*s + 340*D1**2*f**2*fd - 525*D1**2*f**2*fdd*r**2 - 1050*D1**2*f**2*fdd*r*s + 700*D1**2*f**2*fdd*r - 525*D1**2*f**2*fdd*s**2 + 700*D1**2*f**2*fdd*s - 350*D1**2*f**2*fdd - 1050*D1**2*f*fd**2*r**2 - 2100*D1**2*f*fd**2*r*s + 1400*D1**2*f*fd**2*r - 1050*D1**2*f*fd**2*s**2 + 1400*D1**2*f*fd**2*s - 350*D1**2*f*fd**2 + 36*D1**2*f*fd*r**2 + 72*D1**2*f*fd*r*s - 36*D1**2*f*fd*r + 36*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s + 18*D1**2*f*fd - 900*D1**2*f*fdd*r**2 - 1800*D1**2*f*fdd*r*s + 900*D1**2*f*fdd*r - 900*D1**2*f*fdd*s**2 + 900*D1**2*f*fdd*s - 450*D1**2*f*fdd + 1680*D1**2*f*gd2*r**2 + 3360*D1**2*f*gd2*r*s - 3360*D1**2*f*gd2*r + 1680*D1**2*f*gd2*s**2 - 3360*D1**2*f*gd2*s + 1680*D1**2*f*gd2 - 2520*D1**2*f*gdd2*r**2 - 5040*D1**2*f*gdd2*r*s + 5040*D1**2*f*gdd2*r - 2520*D1**2*f*gdd2*s**2 + 5040*D1**2*f*gdd2*s - 2520*D1**2*f*gdd2 - 900*D1**2*fd**2*r**2 - 1800*D1**2*fd**2*r*s + 900*D1**2*fd**2*r - 900*D1**2*fd**2*s**2 + 900*D1**2*fd**2*s + 1680*D1**2*fd*g2*r**2 + 3360*D1**2*fd*g2*r*s + 1680*D1**2*fd*g2*s**2 - 5040*D1**2*fd*gd2*r**2 - 10080*D1**2*fd*gd2*r*s + 5040*D1**2*fd*gd2*r - 5040*D1**2*fd*gd2*s**2 + 5040*D1**2*fd*gd2*s - 2520*D1**2*fdd*g2*r**2 - 5040*D1**2*fdd*g2*r*s - 2520*D1**2*fdd*g2*s**2 - 3168*D1*Dd*K*f**2*r**2 - 6336*D1*Dd*K*f**2*r*s + 4752*D1*Dd*K*f**2*r - 3168*D1*Dd*K*f**2*s**2 + 4752*D1*Dd*K*f**2*s - 2376*D1*Dd*K*f**2 + 14400*D1*Dd*K*f*fd*r**2 + 28800*D1*Dd*K*f*fd*r*s - 18000*D1*Dd*K*f*fd*r + 14400*D1*Dd*K*f*fd*s**2 - 18000*D1*Dd*K*f*fd*s + 5400*D1*Dd*K*f*fd + 680*D1*Dd*f**3*r**2 + 1360*D1*Dd*f**3*r*s - 1020*D1*Dd*f**3*r + 680*D1*Dd*f**3*s**2 - 1020*D1*Dd*f**3*s + 510*D1*Dd*f**3 - 4200*D1*Dd*f**2*fd*r**2 - 8400*D1*Dd*f**2*fd*r*s + 5950*D1*Dd*f**2*fd*r - 4200*D1*Dd*f**2*fd*s**2 + 5950*D1*Dd*f**2*fd*s - 2100*D1*Dd*f**2*fd + 72*D1*Dd*f**2*r**2 + 144*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 108*D1*Dd*f**2*s + 54*D1*Dd*f**2 - 7200*D1*Dd*f*fd*r**2 - 14400*D1*Dd*f*fd*r*s + 9000*D1*Dd*f*fd*r - 7200*D1*Dd*f*fd*s**2 + 9000*D1*Dd*f*fd*s - 2700*D1*Dd*f*fd + 6720*D1*Dd*f*g2*r**2 + 13440*D1*Dd*f*g2*r*s - 10080*D1*Dd*f*g2*r + 6720*D1*Dd*f*g2*s**2 - 10080*D1*Dd*f*g2*s + 5040*D1*Dd*f*g2 - 20160*D1*Dd*f*gd2*r**2 - 40320*D1*Dd*f*gd2*r*s + 35280*D1*Dd*f*gd2*r - 20160*D1*Dd*f*gd2*s**2 + 35280*D1*Dd*f*gd2*s - 15120*D1*Dd*f*gd2 - 20160*D1*Dd*fd*g2*r**2 - 40320*D1*Dd*fd*g2*r*s + 15120*D1*Dd*fd*g2*r - 20160*D1*Dd*fd*g2*s**2 + 15120*D1*Dd*fd*g2*s + 3600*D1*Ddd*K*f**2*r**2 + 7200*D1*Ddd*K*f**2*r*s - 5400*D1*Ddd*K*f**2*r + 3600*D1*Ddd*K*f**2*s**2 - 5400*D1*Ddd*K*f**2*s + 2700*D1*Ddd*K*f**2 - 700*D1*Ddd*f**3*r**2 - 1400*D1*Ddd*f**3*r*s + 1050*D1*Ddd*f**3*r - 700*D1*Ddd*f**3*s**2 + 1050*D1*Ddd*f**3*s - 525*D1*Ddd*f**3 - 1800*D1*Ddd*f**2*r**2 - 3600*D1*Ddd*f**2*r*s + 2700*D1*Ddd*f**2*r - 1800*D1*Ddd*f**2*s**2 + 2700*D1*Ddd*f**2*s - 1350*D1*Ddd*f**2 - 10080*D1*Ddd*f*g2*r**2 - 20160*D1*Ddd*f*g2*r*s + 15120*D1*Ddd*f*g2*r - 10080*D1*Ddd*f*g2*s**2 + 15120*D1*Ddd*f*g2*s - 7560*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(111*f**2*(r + s - 1) - 5*f*(60*fd*(2*r + 2*s - 1) + (56*K - 21)*(r + s - 1)) + 420*fd*(2*K - 1)*(r + s)) - 60*Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 10800*Dd**2*K*f**2*r**2 + 21600*Dd**2*K*f**2*r*s - 16200*Dd**2*K*f**2*r + 10800*Dd**2*K*f**2*s**2 - 16200*Dd**2*K*f**2*s + 5400*Dd**2*K*f**2 - 2100*Dd**2*f**3*r**2 - 4200*Dd**2*f**3*r*s + 3150*Dd**2*f**3*r - 2100*Dd**2*f**3*s**2 + 3150*Dd**2*f**3*s - 1050*Dd**2*f**3 - 5400*Dd**2*f**2*r**2 - 10800*Dd**2*f**2*r*s + 8100*Dd**2*f**2*r - 5400*Dd**2*f**2*s**2 + 8100*Dd**2*f**2*s - 2700*Dd**2*f**2 - 30240*Dd**2*f*g2*r**2 - 60480*Dd**2*f*g2*r*s + 45360*Dd**2*f*g2*r - 30240*Dd**2*f*g2*s**2 + 45360*Dd**2*f*g2*s - 15120*Dd**2*f*g2))/(6930*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**3*k1**3*k2*(8*C - 5)*(3*D1*b1*(-21*D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 3*D1*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) + 30*D1*fd**2*(r + s - 1) + 30*Dd*f*fd*(4*r + 4*s - 3) + 7*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 21*b1**2*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(-126*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 45*D1**2*bdd1*f*(2*r + 2*s - 1) - 5*D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 9*D1*bd1*(D1*f*(6*r + 6*s - 3) - 10*D1*fd*(r + s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 5*D1*f*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 14*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 210*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**3*k1*k2**5*st**4*(-1032*C*D1**2*b1*f*fd*r**2 - 2064*C*D1**2*b1*f*fd*r*s + 1032*C*D1**2*b1*f*fd*r - 1032*C*D1**2*b1*f*fd*s**2 + 1032*C*D1**2*b1*f*fd*s - 516*C*D1**2*b1*f*fd + 600*C*D1**2*b1*f*fdd*r**2 + 1200*C*D1**2*b1*f*fdd*r*s - 600*C*D1**2*b1*f*fdd*r + 600*C*D1**2*b1*f*fdd*s**2 - 600*C*D1**2*b1*f*fdd*s + 300*C*D1**2*b1*f*fdd + 600*C*D1**2*b1*fd**2*r**2 + 1200*C*D1**2*b1*fd**2*r*s - 600*C*D1**2*b1*fd**2*r + 600*C*D1**2*b1*fd**2*s**2 - 600*C*D1**2*b1*fd**2*s - 564*C*D1**2*f**2*fd*r**2 - 1128*C*D1**2*f**2*fd*r*s + 752*C*D1**2*f**2*fd*r - 564*C*D1**2*f**2*fd*s**2 + 752*C*D1**2*f**2*fd*s - 376*C*D1**2*f**2*fd + 300*C*D1**2*f**2*fdd*r**2 + 600*C*D1**2*f**2*fdd*r*s - 400*C*D1**2*f**2*fdd*r + 300*C*D1**2*f**2*fdd*s**2 - 400*C*D1**2*f**2*fdd*s + 200*C*D1**2*f**2*fdd + 600*C*D1**2*f*fd**2*r**2 + 1200*C*D1**2*f*fd**2*r*s - 800*C*D1**2*f*fd**2*r + 600*C*D1**2*f*fd**2*s**2 - 800*C*D1**2*f*fd**2*s + 200*C*D1**2*f*fd**2 - 2064*C*D1*Dd*b1*f**2*r**2 - 4128*C*D1*Dd*b1*f**2*r*s + 3096*C*D1*Dd*b1*f**2*r - 2064*C*D1*Dd*b1*f**2*s**2 + 3096*C*D1*Dd*b1*f**2*s - 1548*C*D1*Dd*b1*f**2 + 4800*C*D1*Dd*b1*f*fd*r**2 + 9600*C*D1*Dd*b1*f*fd*r*s - 6000*C*D1*Dd*b1*f*fd*r + 4800*C*D1*Dd*b1*f*fd*s**2 - 6000*C*D1*Dd*b1*f*fd*s + 1800*C*D1*Dd*b1*f*fd - 752*C*D1*Dd*f**3*r**2 - 1504*C*D1*Dd*f**3*r*s + 1128*C*D1*Dd*f**3*r - 752*C*D1*Dd*f**3*s**2 + 1128*C*D1*Dd*f**3*s - 564*C*D1*Dd*f**3 + 2400*C*D1*Dd*f**2*fd*r**2 + 4800*C*D1*Dd*f**2*fd*r*s - 3400*C*D1*Dd*f**2*fd*r + 2400*C*D1*Dd*f**2*fd*s**2 - 3400*C*D1*Dd*f**2*fd*s + 1200*C*D1*Dd*f**2*fd + 1200*C*D1*Ddd*b1*f**2*r**2 + 2400*C*D1*Ddd*b1*f**2*r*s - 1800*C*D1*Ddd*b1*f**2*r + 1200*C*D1*Ddd*b1*f**2*s**2 - 1800*C*D1*Ddd*b1*f**2*s + 900*C*D1*Ddd*b1*f**2 + 400*C*D1*Ddd*f**3*r**2 + 800*C*D1*Ddd*f**3*r*s - 600*C*D1*Ddd*f**3*r + 400*C*D1*Ddd*f**3*s**2 - 600*C*D1*Ddd*f**3*s + 300*C*D1*Ddd*f**3 + 3600*C*Dd**2*b1*f**2*r**2 + 7200*C*Dd**2*b1*f**2*r*s - 5400*C*Dd**2*b1*f**2*r + 3600*C*Dd**2*b1*f**2*s**2 - 5400*C*Dd**2*b1*f**2*s + 1800*C*Dd**2*b1*f**2 + 1200*C*Dd**2*f**3*r**2 + 2400*C*Dd**2*f**3*r*s - 1800*C*Dd**2*f**3*r + 1200*C*Dd**2*f**3*s**2 - 1800*C*Dd**2*f**3*s + 600*C*Dd**2*f**3 + 852*D1**2*b1*f*fd*r**2 + 1704*D1**2*b1*f*fd*r*s - 852*D1**2*b1*f*fd*r + 852*D1**2*b1*f*fd*s**2 - 852*D1**2*b1*f*fd*s + 426*D1**2*b1*f*fd - 510*D1**2*b1*f*fdd*r**2 - 1020*D1**2*b1*f*fdd*r*s + 510*D1**2*b1*f*fdd*r - 510*D1**2*b1*f*fdd*s**2 + 510*D1**2*b1*f*fdd*s - 255*D1**2*b1*f*fdd - 510*D1**2*b1*fd**2*r**2 - 1020*D1**2*b1*fd**2*r*s + 510*D1**2*b1*fd**2*r - 510*D1**2*b1*fd**2*s**2 + 510*D1**2*b1*fd**2*s + 15*D1**2*bdd1*f**2*(20*C - 17)*(r + s - 1)**2 + 474*D1**2*f**2*fd*r**2 + 948*D1**2*f**2*fd*r*s - 632*D1**2*f**2*fd*r + 474*D1**2*f**2*fd*s**2 - 632*D1**2*f**2*fd*s + 316*D1**2*f**2*fd - 255*D1**2*f**2*fdd*r**2 - 510*D1**2*f**2*fdd*r*s + 340*D1**2*f**2*fdd*r - 255*D1**2*f**2*fdd*s**2 + 340*D1**2*f**2*fdd*s - 170*D1**2*f**2*fdd - 510*D1**2*f*fd**2*r**2 - 1020*D1**2*f*fd**2*r*s + 680*D1**2*f*fd**2*r - 510*D1**2*f*fd**2*s**2 + 680*D1**2*f*fd**2*s - 170*D1**2*f*fd**2 + 1704*D1*Dd*b1*f**2*r**2 + 3408*D1*Dd*b1*f**2*r*s - 2556*D1*Dd*b1*f**2*r + 1704*D1*Dd*b1*f**2*s**2 - 2556*D1*Dd*b1*f**2*s + 1278*D1*Dd*b1*f**2 - 4080*D1*Dd*b1*f*fd*r**2 - 8160*D1*Dd*b1*f*fd*r*s + 5100*D1*Dd*b1*f*fd*r - 4080*D1*Dd*b1*f*fd*s**2 + 5100*D1*Dd*b1*f*fd*s - 1530*D1*Dd*b1*f*fd + 632*D1*Dd*f**3*r**2 + 1264*D1*Dd*f**3*r*s - 948*D1*Dd*f**3*r + 632*D1*Dd*f**3*s**2 - 948*D1*Dd*f**3*s + 474*D1*Dd*f**3 - 2040*D1*Dd*f**2*fd*r**2 - 4080*D1*Dd*f**2*fd*r*s + 2890*D1*Dd*f**2*fd*r - 2040*D1*Dd*f**2*fd*s**2 + 2890*D1*Dd*f**2*fd*s - 1020*D1*Dd*f**2*fd - 1020*D1*Ddd*b1*f**2*r**2 - 2040*D1*Ddd*b1*f**2*r*s + 1530*D1*Ddd*b1*f**2*r - 1020*D1*Ddd*b1*f**2*s**2 + 1530*D1*Ddd*b1*f**2*s - 765*D1*Ddd*b1*f**2 - 340*D1*Ddd*f**3*r**2 - 680*D1*Ddd*f**3*r*s + 510*D1*Ddd*f**3*r - 340*D1*Ddd*f**3*s**2 + 510*D1*Ddd*f**3*s - 255*D1*Ddd*f**3 - 6*D1*bd1*f*(r + s - 1)*(D1*f*(86*C - 71)*(r + s - 1) - D1*fd*(100*C - 85)*(2*r + 2*s - 1) - Dd*f*(100*C - 85)*(4*r + 4*s - 3)) - 3060*Dd**2*b1*f**2*r**2 - 6120*Dd**2*b1*f**2*r*s + 4590*Dd**2*b1*f**2*r - 3060*Dd**2*b1*f**2*s**2 + 4590*Dd**2*b1*f**2*s - 1530*Dd**2*b1*f**2 - 1020*Dd**2*f**3*r**2 - 2040*Dd**2*f**3*r*s + 1530*Dd**2*f**3*r - 1020*Dd**2*f**3*s**2 + 1530*Dd**2*f**3*s - 510*Dd**2*f**3)/(210*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**3*k1*k2**5*st**2*(5346*C*D1**2*f**2*fd*r**2 + 10692*C*D1**2*f**2*fd*r*s - 7128*C*D1**2*f**2*fd*r + 5346*C*D1**2*f**2*fd*s**2 - 7128*C*D1**2*f**2*fd*s + 3564*C*D1**2*f**2*fd + 7128*C*D1*Dd*f**3*r**2 + 14256*C*D1*Dd*f**3*r*s - 10692*C*D1*Dd*f**3*r + 7128*C*D1*Dd*f**3*s**2 - 10692*C*D1*Dd*f**3*s + 5346*C*D1*Dd*f**3 + 1188*D1**2*K*bdd1*f**2*r**2 + 2376*D1**2*K*bdd1*f**2*r*s - 2376*D1**2*K*bdd1*f**2*r + 1188*D1**2*K*bdd1*f**2*s**2 - 2376*D1**2*K*bdd1*f**2*s + 1188*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(-28*K + 25*f + 21)*(r + s - 1)**2 + 1375*D1**2*bdd1*f**3*r**2 + 2750*D1**2*bdd1*f**3*r*s - 2750*D1**2*bdd1*f**3*r + 1375*D1**2*bdd1*f**3*s**2 - 2750*D1**2*bdd1*f**3*s + 1375*D1**2*bdd1*f**3 - 891*D1**2*bdd1*f**2*r**2 - 1782*D1**2*bdd1*f**2*r*s + 1782*D1**2*bdd1*f**2*r - 891*D1**2*bdd1*f**2*s**2 + 1782*D1**2*bdd1*f**2*s - 891*D1**2*bdd1*f**2 - 5544*D1**2*bdd1*f*g2*r**2 - 11088*D1**2*bdd1*f*g2*r*s + 11088*D1**2*bdd1*f*g2*r - 5544*D1**2*bdd1*f*g2*s**2 + 11088*D1**2*bdd1*f*g2*s - 5544*D1**2*bdd1*f*g2 - 8940*D1**2*f**3*fd*r**2 - 17880*D1**2*f**3*fd*r*s + 13410*D1**2*f**3*fd*r - 8940*D1**2*f**3*fd*s**2 + 13410*D1**2*f**3*fd*s - 6705*D1**2*f**3*fd + 7000*D1**2*f**3*fdd*r**2 + 14000*D1**2*f**3*fdd*r*s - 10500*D1**2*f**3*fdd*r + 7000*D1**2*f**3*fdd*s**2 - 10500*D1**2*f**3*fdd*s + 5250*D1**2*f**3*fdd + 21000*D1**2*f**2*fd**2*r**2 + 42000*D1**2*f**2*fd**2*r*s - 31500*D1**2*f**2*fd**2*r + 21000*D1**2*f**2*fd**2*s**2 - 31500*D1**2*f**2*fd**2*s + 10500*D1**2*f**2*fd**2 - 4455*D1**2*f**2*fd*r**2 - 8910*D1**2*f**2*fd*r*s + 5940*D1**2*f**2*fd*r - 4455*D1**2*f**2*fd*s**2 + 5940*D1**2*f**2*fd*s - 2970*D1**2*f**2*fd + 4290*D1**2*f**2*gd2*r**2 + 8580*D1**2*f**2*gd2*r*s - 8580*D1**2*f**2*gd2*r + 4290*D1**2*f**2*gd2*s**2 - 8580*D1**2*f**2*gd2*s + 4290*D1**2*f**2*gd2 - 2376*D1**2*f**2*gdd2*r**2 - 4752*D1**2*f**2*gdd2*r*s + 4752*D1**2*f**2*gdd2*r - 2376*D1**2*f**2*gdd2*s**2 + 4752*D1**2*f**2*gdd2*s - 2376*D1**2*f**2*gdd2 + 8580*D1**2*f*fd*g2*r**2 + 17160*D1**2*f*fd*g2*r*s - 8580*D1**2*f*fd*g2*r + 8580*D1**2*f*fd*g2*s**2 - 8580*D1**2*f*fd*g2*s + 4290*D1**2*f*fd*g2 - 9504*D1**2*f*fd*gd2*r**2 - 19008*D1**2*f*fd*gd2*r*s + 14256*D1**2*f*fd*gd2*r - 9504*D1**2*f*fd*gd2*s**2 + 14256*D1**2*f*fd*gd2*s - 4752*D1**2*f*fd*gd2 - 4752*D1**2*f*fdd*g2*r**2 - 9504*D1**2*f*fdd*g2*r*s + 4752*D1**2*f*fdd*g2*r - 4752*D1**2*f*fdd*g2*s**2 + 4752*D1**2*f*fdd*g2*s - 2376*D1**2*f*fdd*g2 - 4752*D1**2*fd**2*g2*r**2 - 9504*D1**2*fd**2*g2*r*s + 4752*D1**2*fd**2*g2*r - 4752*D1**2*fd**2*g2*s**2 + 4752*D1**2*fd**2*g2*s - 8940*D1*Dd*f**4*r**2 - 17880*D1*Dd*f**4*r*s + 13410*D1*Dd*f**4*r - 8940*D1*Dd*f**4*s**2 + 13410*D1*Dd*f**4*s - 6705*D1*Dd*f**4 + 56000*D1*Dd*f**3*fd*r**2 + 112000*D1*Dd*f**3*fd*r*s - 84000*D1*Dd*f**3*fd*r + 56000*D1*Dd*f**3*fd*s**2 - 84000*D1*Dd*f**3*fd*s + 31500*D1*Dd*f**3*fd - 5940*D1*Dd*f**3*r**2 - 11880*D1*Dd*f**3*r*s + 8910*D1*Dd*f**3*r - 5940*D1*Dd*f**3*s**2 + 8910*D1*Dd*f**3*s - 4455*D1*Dd*f**3 + 17160*D1*Dd*f**2*g2*r**2 + 34320*D1*Dd*f**2*g2*r*s - 25740*D1*Dd*f**2*g2*r + 17160*D1*Dd*f**2*g2*s**2 - 25740*D1*Dd*f**2*g2*s + 12870*D1*Dd*f**2*g2 - 19008*D1*Dd*f**2*gd2*r**2 - 38016*D1*Dd*f**2*gd2*r*s + 33264*D1*Dd*f**2*gd2*r - 19008*D1*Dd*f**2*gd2*s**2 + 33264*D1*Dd*f**2*gd2*s - 14256*D1*Dd*f**2*gd2 - 38016*D1*Dd*f*fd*g2*r**2 - 76032*D1*Dd*f*fd*g2*r*s + 47520*D1*Dd*f*fd*g2*r - 38016*D1*Dd*f*fd*g2*s**2 + 47520*D1*Dd*f*fd*g2*s - 14256*D1*Dd*f*fd*g2 + 7000*D1*Ddd*f**4*r**2 + 14000*D1*Ddd*f**4*r*s - 10500*D1*Ddd*f**4*r + 7000*D1*Ddd*f**4*s**2 - 10500*D1*Ddd*f**4*s + 5250*D1*Ddd*f**4 - 9504*D1*Ddd*f**2*g2*r**2 - 19008*D1*Ddd*f**2*g2*r*s + 14256*D1*Ddd*f**2*g2*r - 9504*D1*Ddd*f**2*g2*s**2 + 14256*D1*Ddd*f**2*g2*s - 7128*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(97*f**3*(r + s - 1) + f**2*(-378*C*(r + s - 1) - 250*fd*(3*r + 3*s - 2) + (195*K + 174)*(r + s - 1)) - 6*f*(9*fd*(4*K - 3)*(2*r + 2*s - 1) + (133*g2 - 168*gd2)*(r + s - 1)) + 1008*fd*g2*(r + s)) - 2*Dd*f*(125*f**2 + 27*f*(4*K - 3) - 504*g2)*(4*r + 4*s - 3))*(r + s - 1) + 21000*Dd**2*f**4*r**2 + 42000*Dd**2*f**4*r*s - 31500*Dd**2*f**4*r + 21000*Dd**2*f**4*s**2 - 31500*Dd**2*f**4*s + 10500*Dd**2*f**4 - 28512*Dd**2*f**2*g2*r**2 - 57024*Dd**2*f**2*g2*r*s + 42768*Dd**2*f**2*g2*r - 28512*Dd**2*f**2*g2*s**2 + 42768*Dd**2*f**2*g2*s - 14256*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(3*f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 7*fd*(19*K - 13)*(r + s) - 21*fdd*(4*K - 3)*(r + s))) + D1*(Dd*(108*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(150*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (133*K - 91)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(4*K - 3)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-28*K + 25*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-28*K + 25*f + 21)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(756*C*D1**2*f*fd*r**2 + 1512*C*D1**2*f*fd*r*s - 756*C*D1**2*f*fd*r + 756*C*D1**2*f*fd*s**2 - 756*C*D1**2*f*fd*s + 378*C*D1**2*f*fd + 1512*C*D1*Dd*f**2*r**2 + 3024*C*D1*Dd*f**2*r*s - 2268*C*D1*Dd*f**2*r + 1512*C*D1*Dd*f**2*s**2 - 2268*C*D1*Dd*f**2*s + 1134*C*D1*Dd*f**2 - 390*D1**2*K*f*fd*r**2 - 780*D1**2*K*f*fd*r*s + 390*D1**2*K*f*fd*r - 390*D1**2*K*f*fd*s**2 + 390*D1**2*K*f*fd*s - 195*D1**2*K*f*fd + 216*D1**2*K*f*fdd*r**2 + 432*D1**2*K*f*fdd*r*s - 216*D1**2*K*f*fdd*r + 216*D1**2*K*f*fdd*s**2 - 216*D1**2*K*f*fdd*s + 108*D1**2*K*f*fdd + 216*D1**2*K*fd**2*r**2 + 432*D1**2*K*fd**2*r*s - 216*D1**2*K*fd**2*r + 216*D1**2*K*fd**2*s**2 - 216*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(-28*K + 25*f + 21)*(r + s - 1)**2 - 291*D1**2*f**2*fd*r**2 - 582*D1**2*f**2*fd*r*s + 388*D1**2*f**2*fd*r - 291*D1**2*f**2*fd*s**2 + 388*D1**2*f**2*fd*s - 194*D1**2*f**2*fd + 375*D1**2*f**2*fdd*r**2 + 750*D1**2*f**2*fdd*r*s - 500*D1**2*f**2*fdd*r + 375*D1**2*f**2*fdd*s**2 - 500*D1**2*f**2*fdd*s + 250*D1**2*f**2*fdd + 750*D1**2*f*fd**2*r**2 + 1500*D1**2*f*fd**2*r*s - 1000*D1**2*f*fd**2*r + 750*D1**2*f*fd**2*s**2 - 1000*D1**2*f*fd**2*s + 250*D1**2*f*fd**2 - 348*D1**2*f*fd*r**2 - 696*D1**2*f*fd*r*s + 348*D1**2*f*fd*r - 348*D1**2*f*fd*s**2 + 348*D1**2*f*fd*s - 174*D1**2*f*fd - 162*D1**2*f*fdd*r**2 - 324*D1**2*f*fdd*r*s + 162*D1**2*f*fdd*r - 162*D1**2*f*fdd*s**2 + 162*D1**2*f*fdd*s - 81*D1**2*f*fdd + 798*D1**2*f*gd2*r**2 + 1596*D1**2*f*gd2*r*s - 1596*D1**2*f*gd2*r + 798*D1**2*f*gd2*s**2 - 1596*D1**2*f*gd2*s + 798*D1**2*f*gd2 - 504*D1**2*f*gdd2*r**2 - 1008*D1**2*f*gdd2*r*s + 1008*D1**2*f*gdd2*r - 504*D1**2*f*gdd2*s**2 + 1008*D1**2*f*gdd2*s - 504*D1**2*f*gdd2 - 162*D1**2*fd**2*r**2 - 324*D1**2*fd**2*r*s + 162*D1**2*fd**2*r - 162*D1**2*fd**2*s**2 + 162*D1**2*fd**2*s + 798*D1**2*fd*g2*r**2 + 1596*D1**2*fd*g2*r*s + 798*D1**2*fd*g2*s**2 - 1008*D1**2*fd*gd2*r**2 - 2016*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 1008*D1**2*fd*gd2*s**2 + 1008*D1**2*fd*gd2*s - 504*D1**2*fdd*g2*r**2 - 1008*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*s**2 - 780*D1*Dd*K*f**2*r**2 - 1560*D1*Dd*K*f**2*r*s + 1170*D1*Dd*K*f**2*r - 780*D1*Dd*K*f**2*s**2 + 1170*D1*Dd*K*f**2*s - 585*D1*Dd*K*f**2 + 1728*D1*Dd*K*f*fd*r**2 + 3456*D1*Dd*K*f*fd*r*s - 2160*D1*Dd*K*f*fd*r + 1728*D1*Dd*K*f*fd*s**2 - 2160*D1*Dd*K*f*fd*s + 648*D1*Dd*K*f*fd - 388*D1*Dd*f**3*r**2 - 776*D1*Dd*f**3*r*s + 582*D1*Dd*f**3*r - 388*D1*Dd*f**3*s**2 + 582*D1*Dd*f**3*s - 291*D1*Dd*f**3 + 3000*D1*Dd*f**2*fd*r**2 + 6000*D1*Dd*f**2*fd*r*s - 4250*D1*Dd*f**2*fd*r + 3000*D1*Dd*f**2*fd*s**2 - 4250*D1*Dd*f**2*fd*s + 1500*D1*Dd*f**2*fd - 696*D1*Dd*f**2*r**2 - 1392*D1*Dd*f**2*r*s + 1044*D1*Dd*f**2*r - 696*D1*Dd*f**2*s**2 + 1044*D1*Dd*f**2*s - 522*D1*Dd*f**2 - 1296*D1*Dd*f*fd*r**2 - 2592*D1*Dd*f*fd*r*s + 1620*D1*Dd*f*fd*r - 1296*D1*Dd*f*fd*s**2 + 1620*D1*Dd*f*fd*s - 486*D1*Dd*f*fd + 3192*D1*Dd*f*g2*r**2 + 6384*D1*Dd*f*g2*r*s - 4788*D1*Dd*f*g2*r + 3192*D1*Dd*f*g2*s**2 - 4788*D1*Dd*f*g2*s + 2394*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r**2 - 8064*D1*Dd*f*gd2*r*s + 7056*D1*Dd*f*gd2*r - 4032*D1*Dd*f*gd2*s**2 + 7056*D1*Dd*f*gd2*s - 3024*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r**2 - 8064*D1*Dd*fd*g2*r*s + 3024*D1*Dd*fd*g2*r - 4032*D1*Dd*fd*g2*s**2 + 3024*D1*Dd*fd*g2*s + 432*D1*Ddd*K*f**2*r**2 + 864*D1*Ddd*K*f**2*r*s - 648*D1*Ddd*K*f**2*r + 432*D1*Ddd*K*f**2*s**2 - 648*D1*Ddd*K*f**2*s + 324*D1*Ddd*K*f**2 + 500*D1*Ddd*f**3*r**2 + 1000*D1*Ddd*f**3*r*s - 750*D1*Ddd*f**3*r + 500*D1*Ddd*f**3*s**2 - 750*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 - 324*D1*Ddd*f**2*r**2 - 648*D1*Ddd*f**2*r*s + 486*D1*Ddd*f**2*r - 324*D1*Ddd*f**2*s**2 + 486*D1*Ddd*f**2*s - 243*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r**2 - 4032*D1*Ddd*f*g2*r*s + 3024*D1*Ddd*f*g2*r - 2016*D1*Ddd*f*g2*s**2 + 3024*D1*Ddd*f*g2*s - 1512*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(108*f**2*(r + s - 1) - 150*f*fd*(2*r + 2*s - 1) - 7*f*(19*K - 13)*(r + s - 1) + 42*fd*(4*K - 3)*(r + s)) - 6*Dd*f*(-28*K + 25*f + 21)*(4*r + 4*s - 3))*(r + s - 1) + 1296*Dd**2*K*f**2*r**2 + 2592*Dd**2*K*f**2*r*s - 1944*Dd**2*K*f**2*r + 1296*Dd**2*K*f**2*s**2 - 1944*Dd**2*K*f**2*s + 648*Dd**2*K*f**2 + 1500*Dd**2*f**3*r**2 + 3000*Dd**2*f**3*r*s - 2250*Dd**2*f**3*r + 1500*Dd**2*f**3*s**2 - 2250*Dd**2*f**3*s + 750*Dd**2*f**3 - 972*Dd**2*f**2*r**2 - 1944*Dd**2*f**2*r*s + 1458*Dd**2*f**2*r - 972*Dd**2*f**2*s**2 + 1458*Dd**2*f**2*s - 486*Dd**2*f**2 - 6048*Dd**2*f*g2*r**2 - 12096*Dd**2*f*g2*r*s + 9072*Dd**2*f*g2*r - 6048*Dd**2*f*g2*s**2 + 9072*Dd**2*f*g2*s - 3024*Dd**2*f*g2))/(3465*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**3*k1*k2**3*st**2*(-21*b1**2*(D1**2*(fd*(26*C - 20) + fdd*(15 - 18*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(13*C - 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(15 - 18*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(15 - 18*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(108*C - 90)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(-124*C*D1**2*f*fd*r**2 - 248*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*r - 124*C*D1**2*f*fd*s**2 - 64*C*D1**2*f*fd*s + 32*C*D1**2*f*fd + 132*C*D1**2*f*fdd*r**2 + 264*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 132*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 132*C*D1**2*fd**2*r**2 + 264*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 132*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 108*C*D1**2*fd**2 - 248*C*D1*Dd*f**2*r**2 - 496*C*D1*Dd*f**2*r*s + 372*C*D1*Dd*f**2*r - 248*C*D1*Dd*f**2*s**2 + 372*C*D1*Dd*f**2*s - 186*C*D1*Dd*f**2 + 1056*C*D1*Dd*f*fd*r**2 + 2112*C*D1*Dd*f*fd*r*s - 888*C*D1*Dd*f*fd*r + 1056*C*D1*Dd*f*fd*s**2 - 888*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 264*C*D1*Ddd*f**2*r**2 + 528*C*D1*Ddd*f**2*r*s - 396*C*D1*Ddd*f**2*r + 264*C*D1*Ddd*f**2*s**2 - 396*C*D1*Ddd*f**2*s + 198*C*D1*Ddd*f**2 + 792*C*Dd**2*f**2*r**2 + 1584*C*Dd**2*f**2*r*s - 1188*C*Dd**2*f**2*r + 792*C*Dd**2*f**2*s**2 - 1188*C*Dd**2*f**2*s + 396*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(6*C - 5)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 94*D1**2*f*fd*r**2 + 188*D1**2*f*fd*r*s + 58*D1**2*f*fd*r + 94*D1**2*f*fd*s**2 + 58*D1**2*f*fd*s - 29*D1**2*f*fd - 138*D1**2*f*fdd*r**2 - 276*D1**2*f*fdd*r*s + 48*D1**2*f*fdd*r - 138*D1**2*f*fdd*s**2 + 48*D1**2*f*fdd*s - 24*D1**2*f*fdd - 138*D1**2*fd**2*r**2 - 276*D1**2*fd**2*r*s + 48*D1**2*fd**2*r - 138*D1**2*fd**2*s**2 + 48*D1**2*fd**2*s + 90*D1**2*fd**2 + 188*D1*Dd*f**2*r**2 + 376*D1*Dd*f**2*r*s - 282*D1*Dd*f**2*r + 188*D1*Dd*f**2*s**2 - 282*D1*Dd*f**2*s + 141*D1*Dd*f**2 - 1104*D1*Dd*f*fd*r**2 - 2208*D1*Dd*f*fd*r*s + 1020*D1*Dd*f*fd*r - 1104*D1*Dd*f*fd*s**2 + 1020*D1*Dd*f*fd*s - 144*D1*Dd*f*fd - 276*D1*Ddd*f**2*r**2 - 552*D1*Ddd*f**2*r*s + 414*D1*Ddd*f**2*r - 276*D1*Ddd*f**2*s**2 + 414*D1*Ddd*f**2*s - 207*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(13*C - 10)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(15 - 18*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(15 - 18*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 828*Dd**2*f**2*r**2 - 1656*Dd**2*f**2*r*s + 1242*Dd**2*f**2*r - 828*Dd**2*f**2*s**2 + 1242*Dd**2*f**2*s - 414*Dd**2*f**2) + f*(876*C*D1**2*f*fd*r**2 + 1752*C*D1**2*f*fd*r*s - 1168*C*D1**2*f*fd*r + 876*C*D1**2*f*fd*s**2 - 1168*C*D1**2*f*fd*s + 584*C*D1**2*f*fd - 600*C*D1**2*f*fdd*r**2 - 1200*C*D1**2*f*fdd*r*s + 800*C*D1**2*f*fdd*r - 600*C*D1**2*f*fdd*s**2 + 800*C*D1**2*f*fdd*s - 400*C*D1**2*f*fdd - 1200*C*D1**2*fd**2*r**2 - 2400*C*D1**2*fd**2*r*s + 1600*C*D1**2*fd**2*r - 1200*C*D1**2*fd**2*s**2 + 1600*C*D1**2*fd**2*s - 400*C*D1**2*fd**2 + 1168*C*D1*Dd*f**2*r**2 + 2336*C*D1*Dd*f**2*r*s - 1752*C*D1*Dd*f**2*r + 1168*C*D1*Dd*f**2*s**2 - 1752*C*D1*Dd*f**2*s + 876*C*D1*Dd*f**2 - 4800*C*D1*Dd*f*fd*r**2 - 9600*C*D1*Dd*f*fd*r*s + 6800*C*D1*Dd*f*fd*r - 4800*C*D1*Dd*f*fd*s**2 + 6800*C*D1*Dd*f*fd*s - 2400*C*D1*Dd*f*fd - 800*C*D1*Ddd*f**2*r**2 - 1600*C*D1*Ddd*f**2*r*s + 1200*C*D1*Ddd*f**2*r - 800*C*D1*Ddd*f**2*s**2 + 1200*C*D1*Ddd*f**2*s - 600*C*D1*Ddd*f**2 - 2400*C*Dd**2*f**2*r**2 - 4800*C*Dd**2*f**2*r*s + 3600*C*Dd**2*f**2*r - 2400*C*Dd**2*f**2*s**2 + 3600*C*Dd**2*f**2*s - 1200*C*Dd**2*f**2 + 126*D1**2*bd1**2*(6*C - 5)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 9*D1**2*bdd1*f*(C*(22*r**2 + 44*r*s - 80*r + 22*s**2 - 80*s + 40) - 23*r**2 - 46*r*s + 76*r - 23*s**2 + 76*s - 38) - 735*D1**2*f*fd*r**2 - 1470*D1**2*f*fd*r*s + 980*D1**2*f*fd*r - 735*D1**2*f*fd*s**2 + 980*D1**2*f*fd*s - 490*D1**2*f*fd + 570*D1**2*f*fdd*r**2 + 1140*D1**2*f*fdd*r*s - 760*D1**2*f*fdd*r + 570*D1**2*f*fdd*s**2 - 760*D1**2*f*fdd*s + 380*D1**2*f*fdd + 1140*D1**2*fd**2*r**2 + 2280*D1**2*fd**2*r*s - 1520*D1**2*fd**2*r + 1140*D1**2*fd**2*s**2 - 1520*D1**2*fd**2*s + 380*D1**2*fd**2 - 980*D1*Dd*f**2*r**2 - 1960*D1*Dd*f**2*r*s + 1470*D1*Dd*f**2*r - 980*D1*Dd*f**2*s**2 + 1470*D1*Dd*f**2*s - 735*D1*Dd*f**2 + 4560*D1*Dd*f*fd*r**2 + 9120*D1*Dd*f*fd*r*s - 6460*D1*Dd*f*fd*r + 4560*D1*Dd*f*fd*s**2 - 6460*D1*Dd*f*fd*s + 2280*D1*Dd*f*fd + 760*D1*Ddd*f**2*r**2 + 1520*D1*Ddd*f**2*r*s - 1140*D1*Ddd*f**2*r + 760*D1*Ddd*f**2*s**2 - 1140*D1*Ddd*f**2*s + 570*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(2*C*(31*r**2 + 62*r*s - 156*r + 31*s**2 - 156*s + 78) - 47*r**2 - 94*r*s + 246*r - 47*s**2 + 246*s - 123) - 12*fd*(r + s - 1)*(C*(22*r + 22*s - 20) - 23*r - 23*s + 19)) - 6*Dd*f*(4*r + 4*s - 3)*(C*(22*r + 22*s - 40) - 23*r - 23*s + 38)) + 2280*Dd**2*f**2*r**2 + 4560*Dd**2*f**2*r*s - 3420*Dd**2*f**2*r + 2280*Dd**2*f**2*s**2 - 3420*Dd**2*f**2*s + 1140*Dd**2*f**2))/(315*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**3*k1*k2**3*(168*C*D1**2*bd1*f**2*r + 168*C*D1**2*bd1*f**2*s - 84*C*D1**2*bd1*f**2 - 180*C*D1**2*f**2*fd*r**2 - 360*C*D1**2*f**2*fd*r*s + 240*C*D1**2*f**2*fd*r - 180*C*D1**2*f**2*fd*s**2 + 240*C*D1**2*f**2*fd*s - 120*C*D1**2*f**2*fd - 240*C*D1*Dd*f**3*r**2 - 480*C*D1*Dd*f**3*r*s + 360*C*D1*Dd*f**3*r - 240*C*D1*Dd*f**3*s**2 + 360*C*D1*Dd*f**3*s - 180*C*D1*Dd*f**3 + 168*D1**2*K*bd1**2*f*r + 168*D1**2*K*bd1**2*f*s - 168*D1**2*K*bd1**2*f + 78*D1**2*K*bd1*f**2*r**2 + 156*D1**2*K*bd1*f**2*r*s - 156*D1**2*K*bd1*f**2*r + 78*D1**2*K*bd1*f**2*s**2 - 156*D1**2*K*bd1*f**2*s + 78*D1**2*K*bd1*f**2 - 240*D1**2*K*bd1*f*fd*r**2 - 480*D1**2*K*bd1*f*fd*r*s + 360*D1**2*K*bd1*f*fd*r - 240*D1**2*K*bd1*f*fd*s**2 + 360*D1**2*K*bd1*f*fd*s - 120*D1**2*K*bd1*f*fd - 60*D1**2*K*bdd1*f**2*r**2 - 120*D1**2*K*bdd1*f**2*r*s + 120*D1**2*K*bdd1*f**2*r - 60*D1**2*K*bdd1*f**2*s**2 + 120*D1**2*K*bdd1*f**2*s - 60*D1**2*K*bdd1*f**2 + 180*D1**2*bd1**2*f**2*r**2 + 360*D1**2*bd1**2*f**2*r*s - 360*D1**2*bd1**2*f**2*r + 180*D1**2*bd1**2*f**2*s**2 - 360*D1**2*bd1**2*f**2*s + 180*D1**2*bd1**2*f**2 + 126*D1**2*bd1**2*f*r**2 + 252*D1**2*bd1**2*f*r*s - 378*D1**2*bd1**2*f*r + 126*D1**2*bd1**2*f*s**2 - 378*D1**2*bd1**2*f*s + 252*D1**2*bd1**2*f - 560*D1**2*bd1**2*g2*r**2 - 1120*D1**2*bd1**2*g2*r*s + 560*D1**2*bd1**2*g2*r - 560*D1**2*bd1**2*g2*s**2 + 560*D1**2*bd1**2*g2*s - 168*D1**2*bd1*bd2*f*r**2 - 336*D1**2*bd1*bd2*f*r*s + 336*D1**2*bd1*bd2*f*r - 168*D1**2*bd1*bd2*f*s**2 + 336*D1**2*bd1*bd2*f*s - 168*D1**2*bd1*bd2*f - 90*D1**2*bd1*f**3*r**2 - 180*D1**2*bd1*f**3*r*s + 130*D1**2*bd1*f**3*r - 90*D1**2*bd1*f**3*s**2 + 130*D1**2*bd1*f**3*s - 65*D1**2*bd1*f**3 + 630*D1**2*bd1*f**2*fd*r**2 + 1260*D1**2*bd1*f**2*fd*r*s - 910*D1**2*bd1*f**2*fd*r + 630*D1**2*bd1*f**2*fd*s**2 - 910*D1**2*bd1*f**2*fd*s + 280*D1**2*bd1*f**2*fd - 75*D1**2*bd1*f**2*r**2 - 150*D1**2*bd1*f**2*r*s + 24*D1**2*bd1*f**2*r - 75*D1**2*bd1*f**2*s**2 + 24*D1**2*bd1*f**2*s - 12*D1**2*bd1*f**2 + 360*D1**2*bd1*f*fd*r**2 + 720*D1**2*bd1*f*fd*r*s - 540*D1**2*bd1*f*fd*r + 360*D1**2*bd1*f*fd*s**2 - 540*D1**2*bd1*f*fd*s + 180*D1**2*bd1*f*fd + 392*D1**2*bd1*f*g2*r + 392*D1**2*bd1*f*g2*s - 196*D1**2*bd1*f*g2 - 336*D1**2*bd1*f*gd2*r - 336*D1**2*bd1*f*gd2*s + 336*D1**2*bd1*f*gd2 + 78*D1**2*bd2*f**2*r**2 + 156*D1**2*bd2*f**2*r*s - 156*D1**2*bd2*f**2*r + 78*D1**2*bd2*f**2*s**2 - 156*D1**2*bd2*f**2*s + 78*D1**2*bd2*f**2 - 240*D1**2*bd2*f*fd*r**2 - 480*D1**2*bd2*f*fd*r*s + 360*D1**2*bd2*f*fd*r - 240*D1**2*bd2*f*fd*s**2 + 360*D1**2*bd2*f*fd*s - 120*D1**2*bd2*f*fd + 105*D1**2*bdd1*f**3*r**2 + 210*D1**2*bdd1*f**3*r*s - 140*D1**2*bdd1*f**3*r + 105*D1**2*bdd1*f**3*s**2 - 140*D1**2*bdd1*f**3*s + 70*D1**2*bdd1*f**3 + 90*D1**2*bdd1*f**2*r**2 + 180*D1**2*bdd1*f**2*r*s - 180*D1**2*bdd1*f**2*r + 90*D1**2*bdd1*f**2*s**2 - 180*D1**2*bdd1*f**2*s + 90*D1**2*bdd1*f**2 - 336*D1**2*bdd1*f*g2*r - 336*D1**2*bdd1*f*g2*s + 168*D1**2*bdd1*f*g2 - 60*D1**2*bdd2*f**2*r**2 - 120*D1**2*bdd2*f**2*r*s + 120*D1**2*bdd2*f**2*r - 60*D1**2*bdd2*f**2*s**2 + 120*D1**2*bdd2*f**2*s - 60*D1**2*bdd2*f**2 + 135*D1**2*f**2*fd*r**2 + 270*D1**2*f**2*fd*r*s - 180*D1**2*f**2*fd*r + 135*D1**2*f**2*fd*s**2 - 180*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 156*D1**2*f**2*gd2*r**2 - 312*D1**2*f**2*gd2*r*s + 312*D1**2*f**2*gd2*r - 156*D1**2*f**2*gd2*s**2 + 312*D1**2*f**2*gd2*s - 156*D1**2*f**2*gd2 + 120*D1**2*f**2*gdd2*r**2 + 240*D1**2*f**2*gdd2*r*s - 240*D1**2*f**2*gdd2*r + 120*D1**2*f**2*gdd2*s**2 - 240*D1**2*f**2*gdd2*s + 120*D1**2*f**2*gdd2 - 312*D1**2*f*fd*g2*r**2 - 624*D1**2*f*fd*g2*r*s + 312*D1**2*f*fd*g2*r - 312*D1**2*f*fd*g2*s**2 + 312*D1**2*f*fd*g2*s - 156*D1**2*f*fd*g2 + 480*D1**2*f*fd*gd2*r**2 + 960*D1**2*f*fd*gd2*r*s - 720*D1**2*f*fd*gd2*r + 480*D1**2*f*fd*gd2*s**2 - 720*D1**2*f*fd*gd2*s + 240*D1**2*f*fd*gd2 + 240*D1**2*f*fdd*g2*r**2 + 480*D1**2*f*fdd*g2*r*s - 240*D1**2*f*fdd*g2*r + 240*D1**2*f*fdd*g2*s**2 - 240*D1**2*f*fdd*g2*s + 120*D1**2*f*fdd*g2 + 240*D1**2*fd**2*g2*r**2 + 480*D1**2*fd**2*g2*r*s - 240*D1**2*fd**2*g2*r + 240*D1**2*fd**2*g2*s**2 - 240*D1**2*fd**2*g2*s - 480*D1*Dd*K*bd1*f**2*r**2 - 960*D1*Dd*K*bd1*f**2*r*s + 840*D1*Dd*K*bd1*f**2*r - 480*D1*Dd*K*bd1*f**2*s**2 + 840*D1*Dd*K*bd1*f**2*s - 360*D1*Dd*K*bd1*f**2 + 840*D1*Dd*bd1*f**3*r**2 + 1680*D1*Dd*bd1*f**3*r*s - 1190*D1*Dd*bd1*f**3*r + 840*D1*Dd*bd1*f**3*s**2 - 1190*D1*Dd*bd1*f**3*s + 420*D1*Dd*bd1*f**3 + 720*D1*Dd*bd1*f**2*r**2 + 1440*D1*Dd*bd1*f**2*r*s - 1260*D1*Dd*bd1*f**2*r + 720*D1*Dd*bd1*f**2*s**2 - 1260*D1*Dd*bd1*f**2*s + 540*D1*Dd*bd1*f**2 - 1344*D1*Dd*bd1*f*g2*r - 1344*D1*Dd*bd1*f*g2*s + 1008*D1*Dd*bd1*f*g2 - 480*D1*Dd*bd2*f**2*r**2 - 960*D1*Dd*bd2*f**2*r*s + 840*D1*Dd*bd2*f**2*r - 480*D1*Dd*bd2*f**2*s**2 + 840*D1*Dd*bd2*f**2*s - 360*D1*Dd*bd2*f**2 + 180*D1*Dd*f**3*r**2 + 360*D1*Dd*f**3*r*s - 270*D1*Dd*f**3*r + 180*D1*Dd*f**3*s**2 - 270*D1*Dd*f**3*s + 135*D1*Dd*f**3 - 624*D1*Dd*f**2*g2*r**2 - 1248*D1*Dd*f**2*g2*r*s + 936*D1*Dd*f**2*g2*r - 624*D1*Dd*f**2*g2*s**2 + 936*D1*Dd*f**2*g2*s - 468*D1*Dd*f**2*g2 + 960*D1*Dd*f**2*gd2*r**2 + 1920*D1*Dd*f**2*gd2*r*s - 1680*D1*Dd*f**2*gd2*r + 960*D1*Dd*f**2*gd2*s**2 - 1680*D1*Dd*f**2*gd2*s + 720*D1*Dd*f**2*gd2 + 1920*D1*Dd*f*fd*g2*r**2 + 3840*D1*Dd*f*fd*g2*r*s - 2400*D1*Dd*f*fd*g2*r + 1920*D1*Dd*f*fd*g2*s**2 - 2400*D1*Dd*f*fd*g2*s + 720*D1*Dd*f*fd*g2 + 480*D1*Ddd*f**2*g2*r**2 + 960*D1*Ddd*f**2*g2*r*s - 720*D1*Ddd*f**2*g2*r + 480*D1*Ddd*f**2*g2*s**2 - 720*D1*Ddd*f**2*g2*s + 360*D1*Ddd*f**2*g2 + 14*D1*b2*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 1440*Dd**2*f**2*g2*r**2 + 2880*Dd**2*f**2*g2*r*s - 2160*Dd**2*f**2*g2*r + 1440*Dd**2*f**2*g2*s**2 - 2160*Dd**2*f**2*g2*s + 720*Dd**2*f**2*g2 - 7*b1**3*(2*D1*Dd*(5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 4*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 9*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + D1*(-D1*(8*fd - 9*fdd)*(r + s - 1)**2 + Ddd*(-20*K + 9*f + 15)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(-20*K + 9*f + 15)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(140*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 140*C*D1**2*fd*s**2 - 280*C*D1**2*fd*s + 140*C*D1**2*fd + 560*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 840*C*D1*Dd*f*r + 560*C*D1*Dd*f*s**2 - 840*C*D1*Dd*f*s + 420*C*D1*Dd*f + 196*D1**2*K*fd*r + 196*D1**2*K*fd*s - 98*D1**2*K*fd - 168*D1**2*K*fdd*r - 168*D1**2*K*fdd*s + 84*D1**2*K*fdd - 7*D1**2*bdd1*(-20*K + 9*f + 15)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 108*D1**2*f*fd*r**2 - 216*D1**2*f*fd*r*s + 66*D1**2*f*fd*r - 108*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 33*D1**2*f*fd + 180*D1**2*f*fdd*r**2 + 360*D1**2*f*fdd*r*s - 180*D1**2*f*fdd*r + 180*D1**2*f*fdd*s**2 - 180*D1**2*f*fdd*s + 90*D1**2*f*fdd + 180*D1**2*fd**2*r**2 + 360*D1**2*fd**2*r*s - 180*D1**2*fd**2*r + 180*D1**2*fd**2*s**2 - 180*D1**2*fd**2*s - 126*D1**2*fd*r**2 - 252*D1**2*fd*r*s + 98*D1**2*fd*r - 126*D1**2*fd*s**2 + 98*D1**2*fd*s - 49*D1**2*fd + 63*D1**2*fdd*r**2 + 126*D1**2*fdd*r*s + 126*D1**2*fdd*r + 63*D1**2*fdd*s**2 + 126*D1**2*fdd*s - 63*D1**2*fdd + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 280*D1**2*gdd2*r**2 - 560*D1**2*gdd2*r*s + 560*D1**2*gdd2*r - 280*D1**2*gdd2*s**2 + 560*D1**2*gdd2*s - 280*D1**2*gdd2 - 672*D1*Dd*K*fd*r - 672*D1*Dd*K*fd*s + 504*D1*Dd*K*fd - 216*D1*Dd*f**2*r**2 - 432*D1*Dd*f**2*r*s + 324*D1*Dd*f**2*r - 216*D1*Dd*f**2*s**2 + 324*D1*Dd*f**2*s - 162*D1*Dd*f**2 + 1440*D1*Dd*f*fd*r**2 + 2880*D1*Dd*f*fd*r*s - 1800*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 1800*D1*Dd*f*fd*s + 540*D1*Dd*f*fd - 504*D1*Dd*f*r**2 - 1008*D1*Dd*f*r*s + 756*D1*Dd*f*r - 504*D1*Dd*f*s**2 + 756*D1*Dd*f*s - 378*D1*Dd*f + 504*D1*Dd*fd*r**2 + 1008*D1*Dd*fd*r*s + 126*D1*Dd*fd*r + 504*D1*Dd*fd*s**2 + 126*D1*Dd*fd*s - 378*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 - 2240*D1*Dd*gd2*r**2 - 4480*D1*Dd*gd2*r*s + 3920*D1*Dd*gd2*r - 2240*D1*Dd*gd2*s**2 + 3920*D1*Dd*gd2*s - 1680*D1*Dd*gd2 + 360*D1*Ddd*f**2*r**2 + 720*D1*Ddd*f**2*r*s - 540*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 540*D1*Ddd*f**2*s + 270*D1*Ddd*f**2 + 252*D1*Ddd*f*r**2 + 504*D1*Ddd*f*r*s - 378*D1*Ddd*f*r + 252*D1*Ddd*f*s**2 - 378*D1*Ddd*f*s + 189*D1*Ddd*f - 1120*D1*Ddd*g2*r**2 - 2240*D1*Ddd*g2*r*s + 1680*D1*Ddd*g2*r - 1120*D1*Ddd*g2*s**2 + 1680*D1*Ddd*g2*s - 840*D1*Ddd*g2 + 14*D1*bd1*(D1*(-5*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 4*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*(-20*K + 9*f + 15)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 1080*Dd**2*f**2*r**2 + 2160*Dd**2*f**2*r*s - 1620*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1620*Dd**2*f**2*s + 540*Dd**2*f**2 + 756*Dd**2*f*r**2 + 1512*Dd**2*f*r*s - 1134*Dd**2*f*r + 756*Dd**2*f*s**2 - 1134*Dd**2*f*s + 378*Dd**2*f - 3360*Dd**2*g2*r**2 - 6720*Dd**2*g2*r*s + 5040*Dd**2*g2*r - 3360*Dd**2*g2*s**2 + 5040*Dd**2*g2*s - 1680*Dd**2*g2) + b1*(-168*C*D1**2*f*fd*r - 168*C*D1**2*f*fd*s + 84*C*D1**2*f*fd + 168*D1**2*K*bdd1*f*r + 168*D1**2*K*bdd1*f*s - 84*D1**2*K*bdd1*f + 156*D1**2*K*f*fd*r**2 + 312*D1**2*K*f*fd*r*s - 156*D1**2*K*f*fd*r + 156*D1**2*K*f*fd*s**2 - 156*D1**2*K*f*fd*s + 78*D1**2*K*f*fd - 120*D1**2*K*f*fdd*r**2 - 240*D1**2*K*f*fdd*r*s + 120*D1**2*K*f*fdd*r - 120*D1**2*K*f*fdd*s**2 + 120*D1**2*K*f*fdd*s - 60*D1**2*K*f*fdd - 120*D1**2*K*fd**2*r**2 - 240*D1**2*K*fd**2*r*s + 120*D1**2*K*fd**2*r - 120*D1**2*K*fd**2*s**2 + 120*D1**2*K*fd**2*s + 98*D1**2*b2*fd*r**2 + 196*D1**2*b2*fd*r*s + 98*D1**2*b2*fd*s**2 - 84*D1**2*b2*fdd*r**2 - 168*D1**2*b2*fdd*r*s - 84*D1**2*b2*fdd*s**2 - 14*D1**2*bd1**2*(-20*K + 9*f + 15)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 180*D1**2*bdd1*f**2*r**2 + 360*D1**2*bdd1*f**2*r*s - 360*D1**2*bdd1*f**2*r + 180*D1**2*bdd1*f**2*s**2 - 360*D1**2*bdd1*f**2*s + 180*D1**2*bdd1*f**2 + 126*D1**2*bdd1*f*r**2 + 252*D1**2*bdd1*f*r*s - 378*D1**2*bdd1*f*r + 126*D1**2*bdd1*f*s**2 - 378*D1**2*bdd1*f*s + 189*D1**2*bdd1*f - 560*D1**2*bdd1*g2*r**2 - 1120*D1**2*bdd1*g2*r*s + 560*D1**2*bdd1*g2*r - 560*D1**2*bdd1*g2*s**2 + 560*D1**2*bdd1*g2*s - 280*D1**2*bdd1*g2 - 84*D1**2*bdd2*f*r**2 - 168*D1**2*bdd2*f*r*s + 168*D1**2*bdd2*f*r - 84*D1**2*bdd2*f*s**2 + 168*D1**2*bdd2*f*s - 84*D1**2*bdd2*f - 270*D1**2*f**2*fd*r**2 - 540*D1**2*f**2*fd*r*s + 410*D1**2*f**2*fd*r - 270*D1**2*f**2*fd*s**2 + 410*D1**2*f**2*fd*s - 205*D1**2*f**2*fd + 315*D1**2*f**2*fdd*r**2 + 630*D1**2*f**2*fdd*r*s - 490*D1**2*f**2*fdd*r + 315*D1**2*f**2*fdd*s**2 - 490*D1**2*f**2*fdd*s + 245*D1**2*f**2*fdd + 630*D1**2*f*fd**2*r**2 + 1260*D1**2*f*fd**2*r*s - 980*D1**2*f*fd**2*r + 630*D1**2*f*fd**2*s**2 - 980*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 - 150*D1**2*f*fd*r**2 - 300*D1**2*f*fd*r*s + 276*D1**2*f*fd*r - 150*D1**2*f*fd*s**2 + 276*D1**2*f*fd*s - 138*D1**2*f*fd + 180*D1**2*f*fdd*r**2 + 360*D1**2*f*fdd*r*s - 180*D1**2*f*fdd*r + 180*D1**2*f*fdd*s**2 - 180*D1**2*f*fdd*s + 90*D1**2*f*fdd + 180*D1**2*fd**2*r**2 + 360*D1**2*fd**2*r*s - 180*D1**2*fd**2*r + 180*D1**2*fd**2*s**2 - 180*D1**2*fd**2*s - 392*D1**2*fd*g2*r - 392*D1**2*fd*g2*s + 196*D1**2*fd*g2 + 336*D1**2*fd*gd2*r + 336*D1**2*fd*gd2*s - 336*D1**2*fd*gd2 + 336*D1**2*fdd*g2*r + 336*D1**2*fdd*g2*s - 168*D1**2*fdd*g2 + 312*D1*Dd*K*f**2*r**2 + 624*D1*Dd*K*f**2*r*s - 468*D1*Dd*K*f**2*r + 312*D1*Dd*K*f**2*s**2 - 468*D1*Dd*K*f**2*s + 234*D1*Dd*K*f**2 - 960*D1*Dd*K*f*fd*r**2 - 1920*D1*Dd*K*f*fd*r*s + 1200*D1*Dd*K*f*fd*r - 960*D1*Dd*K*f*fd*s**2 + 1200*D1*Dd*K*f*fd*s - 360*D1*Dd*K*f*fd + 392*D1*Dd*b2*f*r**2 + 784*D1*Dd*b2*f*r*s - 588*D1*Dd*b2*f*r + 392*D1*Dd*b2*f*s**2 - 588*D1*Dd*b2*f*s + 294*D1*Dd*b2*f - 672*D1*Dd*b2*fd*r**2 - 1344*D1*Dd*b2*fd*r*s + 504*D1*Dd*b2*fd*r - 672*D1*Dd*b2*fd*s**2 + 504*D1*Dd*b2*fd*s - 360*D1*Dd*f**3*r**2 - 720*D1*Dd*f**3*r*s + 540*D1*Dd*f**3*r - 360*D1*Dd*f**3*s**2 + 540*D1*Dd*f**3*s - 270*D1*Dd*f**3 + 2520*D1*Dd*f**2*fd*r**2 + 5040*D1*Dd*f**2*fd*r*s - 3850*D1*Dd*f**2*fd*r + 2520*D1*Dd*f**2*fd*s**2 - 3850*D1*Dd*f**2*fd*s + 1470*D1*Dd*f**2*fd - 300*D1*Dd*f**2*r**2 - 600*D1*Dd*f**2*r*s + 450*D1*Dd*f**2*r - 300*D1*Dd*f**2*s**2 + 450*D1*Dd*f**2*s - 225*D1*Dd*f**2 + 1440*D1*Dd*f*fd*r**2 + 2880*D1*Dd*f*fd*r*s - 1800*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 1800*D1*Dd*f*fd*s + 540*D1*Dd*f*fd + 1344*D1*Dd*fd*g2*r + 1344*D1*Dd*fd*g2*s - 1008*D1*Dd*fd*g2 - 240*D1*Ddd*K*f**2*r**2 - 480*D1*Ddd*K*f**2*r*s + 360*D1*Ddd*K*f**2*r - 240*D1*Ddd*K*f**2*s**2 + 360*D1*Ddd*K*f**2*s - 180*D1*Ddd*K*f**2 - 336*D1*Ddd*b2*f*r**2 - 672*D1*Ddd*b2*f*r*s + 504*D1*Ddd*b2*f*r - 336*D1*Ddd*b2*f*s**2 + 504*D1*Ddd*b2*f*s - 252*D1*Ddd*b2*f + 420*D1*Ddd*f**3*r**2 + 840*D1*Ddd*f**3*r*s - 630*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s**2 - 630*D1*Ddd*f**3*s + 315*D1*Ddd*f**3 + 360*D1*Ddd*f**2*r**2 + 720*D1*Ddd*f**2*r*s - 540*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 540*D1*Ddd*f**2*s + 270*D1*Ddd*f**2 + D1*bd1*(-D1*(3*f**2*(36*r**2 + r*(72*s - 86) + 36*s**2 - 86*s + 43) + f*(-140*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 98*K*(2*r + 2*s - 1) - 360*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 252*r**2 + 504*r*s - 406*r + 252*s**2 - 406*s + 203) + 42*fd*(r + s - 1)*(4*K - 6*r - 6*s - 3) - 140*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 560*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(4*r + 4*s - 3)*(180*f**2*(r + s - 1) + 21*f*(4*K + 6*r + 6*s - 9) - 280*g2*(2*r + 2*s - 1))) + 14*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 720*Dd**2*K*f**2*r**2 - 1440*Dd**2*K*f**2*r*s + 1080*Dd**2*K*f**2*r - 720*Dd**2*K*f**2*s**2 + 1080*Dd**2*K*f**2*s - 360*Dd**2*K*f**2 - 1008*Dd**2*b2*f*r**2 - 2016*Dd**2*b2*f*r*s + 1512*Dd**2*b2*f*r - 1008*Dd**2*b2*f*s**2 + 1512*Dd**2*b2*f*s - 504*Dd**2*b2*f + 1260*Dd**2*f**3*r**2 + 2520*Dd**2*f**3*r*s - 1890*Dd**2*f**3*r + 1260*Dd**2*f**3*s**2 - 1890*Dd**2*f**3*s + 630*Dd**2*f**3 + 1080*Dd**2*f**2*r**2 + 2160*Dd**2*f**2*r*s - 1620*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1620*Dd**2*f**2*s + 540*Dd**2*f**2) - 6*b2*(14*D1**2*bdd1*f*(r + s - 1)**2 + D1**2*(-f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(-13*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 20*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**3*k1*k2*(4*C - 3)*(-3*D1*f*(r + s)*(14*D1*bd1**2*(r + s - 1) + 5*D1*bdd1*f*(r + s) + bd1*(-3*D1*f*(r + s) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3))) + 7*b1**2*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*D1**2*(r + s - 1)**2*(3*f*fd - 5*f*fdd - 5*fd**2) + 7*D1*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 20*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct**3*k2**5*st**4*(-12*D1**2*b1*f*fd*r**2 - 24*D1**2*b1*f*fd*r*s + 12*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s**2 + 12*D1**2*b1*f*fd*s - 6*D1**2*b1*f*fd + 6*D1**2*b1*f*fdd*r**2 + 12*D1**2*b1*f*fdd*r*s - 6*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 - 6*D1**2*b1*f*fdd*s + 3*D1**2*b1*f*fdd + 6*D1**2*b1*fd**2*r**2 + 12*D1**2*b1*fd**2*r*s - 6*D1**2*b1*fd**2*r + 6*D1**2*b1*fd**2*s**2 - 6*D1**2*b1*fd**2*s + 3*D1**2*bdd1*f**2*(r + s - 1)**2 - 6*D1**2*f**2*fd*r**2 - 12*D1**2*f**2*fd*r*s + 8*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 8*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 6*D1**2*f**2*fdd*r*s - 4*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 4*D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 12*D1**2*f*fd**2*r*s - 8*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 8*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 - 24*D1*Dd*b1*f**2*r**2 - 48*D1*Dd*b1*f**2*r*s + 36*D1*Dd*b1*f**2*r - 24*D1*Dd*b1*f**2*s**2 + 36*D1*Dd*b1*f**2*s - 18*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 96*D1*Dd*b1*f*fd*r*s - 60*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 60*D1*Dd*b1*f*fd*s + 18*D1*Dd*b1*f*fd - 8*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 48*D1*Dd*f**2*fd*r*s - 34*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 34*D1*Dd*f**2*fd*s + 12*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 + 24*D1*Ddd*b1*f**2*r*s - 18*D1*Ddd*b1*f**2*r + 12*D1*Ddd*b1*f**2*s**2 - 18*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 8*D1*Ddd*f**3*r*s - 6*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 6*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 - 6*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 36*Dd**2*b1*f**2*r**2 + 72*Dd**2*b1*f**2*r*s - 54*Dd**2*b1*f**2*r + 36*Dd**2*b1*f**2*s**2 - 54*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 24*Dd**2*f**3*r*s - 18*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 18*Dd**2*f**3*s + 6*Dd**2*f**3)/(14*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct**3*k2**5*st**2*(D1*f*(18*D1*bd1**2*(r + s - 1)*(5*f*(2*r + 2*s - 1) + 7*r + 7*s - 7) + bd1*(D1*(-50*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(r + s - 1)*(100*fd*(3*r + 3*s - 1) + 9*r + 9*s - 9) + 54*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(4*r + 4*s - 3)*(25*f*(2*r + 2*s - 1) + 27*r + 27*s - 27)) + f*(D1*bdd1*(25*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 27*(r + s - 1)**2) + 27*D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 27*Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 9*b1**2*(D1**2*(5*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 14*fd*(r + s)**2 - 7*fdd*(r + s)**2) + D1*(2*Dd*(10*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-5*fd*(4*r + 4*s - 3)**2 + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) - 7*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(10*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(10*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(9*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 14*(r + s - 1)**2) - 300*D1**2*f**2*fd*r**2 - 600*D1**2*f**2*fd*r*s + 500*D1**2*f**2*fd*r - 300*D1**2*f**2*fd*s**2 + 500*D1**2*f**2*fd*s - 250*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s - 250*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s**2 - 250*D1**2*f**2*fdd*s + 125*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s - 500*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s**2 - 500*D1**2*f*fd**2*s + 200*D1**2*f*fd**2 + 18*D1**2*f*fd*r**2 + 36*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 18*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 9*D1**2*f*fd + 54*D1**2*f*fdd*r**2 + 108*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r + 54*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 27*D1**2*f*fdd + 54*D1**2*fd**2*r**2 + 108*D1**2*fd**2*r*s - 54*D1**2*fd**2*r + 54*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s - 400*D1*Dd*f**3*r**2 - 800*D1*Dd*f**3*r*s + 600*D1*Dd*f**3*r - 400*D1*Dd*f**3*s**2 + 600*D1*Dd*f**3*s - 300*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 1900*D1*Dd*f**2*fd*r + 1200*D1*Dd*f**2*fd*s**2 - 1900*D1*Dd*f**2*fd*s + 750*D1*Dd*f**2*fd + 36*D1*Dd*f**2*r**2 + 72*D1*Dd*f**2*r*s - 54*D1*Dd*f**2*r + 36*D1*Dd*f**2*s**2 - 54*D1*Dd*f**2*s + 27*D1*Dd*f**2 + 432*D1*Dd*f*fd*r**2 + 864*D1*Dd*f*fd*r*s - 540*D1*Dd*f*fd*r + 432*D1*Dd*f*fd*s**2 - 540*D1*Dd*f*fd*s + 162*D1*Dd*f*fd + 200*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 300*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 + 108*D1*Ddd*f**2*r**2 + 216*D1*Ddd*f**2*r*s - 162*D1*Ddd*f**2*r + 108*D1*Ddd*f**2*s**2 - 162*D1*Ddd*f**2*s + 81*D1*Ddd*f**2 - 18*D1*bd1*(D1*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(r + s - 1)*(10*fd*(2*r + 2*s - 1) - 7*r - 7*s + 7) - 14*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 14*r + 14*s - 14)) + 600*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 900*Dd**2*f**3*r + 600*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 300*Dd**2*f**3 + 324*Dd**2*f**2*r**2 + 648*Dd**2*f**2*r*s - 486*Dd**2*f**2*r + 324*Dd**2*f**2*s**2 - 486*Dd**2*f**2*s + 162*Dd**2*f**2))/(315*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct**3*k2**3*st**2*(D1*f*(r + s)*(14*D1*bd1**2*(r + s - 1) + 3*D1*bdd1*f*(r + s) + 6*bd1*(-D1*f*(r + s) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) - 7*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(7*D1**2*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*D1**2*(r + s - 1)**2*(2*f*fd - f*fdd - fd**2) - 14*D1*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 3*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(35*d**2*k1*k3**2) + D1**2*Pk1*Pkdd3*ct**3*k2**3*(3*D1**2*bd1*f*(r + s)*(2*bd1*(5*f + 7)*(r + s - 1) + 7*f*(r + s)) + D1*b1*(14*D1*bd1**2*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + bd1*(D1*(-30*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(60*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 14*r**2 - 28*r*s + 14*r - 14*s**2 + 14*s - 7) + 42*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*Dd*f*(5*f + 7)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 3*f*(D1*bdd1*(5*f + 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*D1*fd*(r + s - 1)**2 + 7*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) - 7*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 20*r**2 + 40*r*s - 30*r + 20*s**2 - 30*s + 15) - Ddd*(3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(7*D1**2*bdd1*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 60*D1**2*f*fd*r**2 - 120*D1**2*f*fd*r*s + 120*D1**2*f*fd*r - 60*D1**2*f*fd*s**2 + 120*D1**2*f*fd*s - 60*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s + 30*D1**2*f*fdd + 30*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 60*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s + 30*D1**2*fd**2 - 7*D1**2*fd*r**2 - 14*D1**2*fd*r*s + 14*D1**2*fd*r - 7*D1**2*fd*s**2 + 14*D1**2*fd*s - 7*D1**2*fd + 21*D1**2*fdd*r**2 + 42*D1**2*fdd*r*s - 42*D1**2*fdd*r + 21*D1**2*fdd*s**2 - 42*D1**2*fdd*s + 21*D1**2*fdd - 120*D1*Dd*f**2*r**2 - 240*D1*Dd*f**2*r*s + 180*D1*Dd*f**2*r - 120*D1*Dd*f**2*s**2 + 180*D1*Dd*f**2*s - 90*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 420*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 420*D1*Dd*f*fd*s + 180*D1*Dd*f*fd - 28*D1*Dd*f*r**2 - 56*D1*Dd*f*r*s + 42*D1*Dd*f*r - 28*D1*Dd*f*s**2 + 42*D1*Dd*f*s - 21*D1*Dd*f + 168*D1*Dd*fd*r**2 + 336*D1*Dd*fd*r*s - 294*D1*Dd*fd*r + 168*D1*Dd*fd*s**2 - 294*D1*Dd*fd*s + 126*D1*Dd*fd + 60*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 90*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 90*D1*Ddd*f**2*s + 45*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 + 168*D1*Ddd*f*r*s - 126*D1*Ddd*f*r + 84*D1*Ddd*f*s**2 - 126*D1*Ddd*f*s + 63*D1*Ddd*f - 14*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 15*r**2 + 30*r*s - 20*r + 15*s**2 - 20*s + 10) - Dd*(3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 180*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 270*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 270*Dd**2*f**2*s + 90*Dd**2*f**2 + 252*Dd**2*f*r**2 + 504*Dd**2*f*r*s - 378*Dd**2*f*r + 252*Dd**2*f*s**2 - 378*Dd**2*f*s + 126*Dd**2*f))/(210*d**2*k1*k3**2) - D1**2*Pk1*Pkdd3*ct**2*k1**6*(2*C - 1)*(54*D1**2*b1*f*fd*r**2 + 108*D1**2*b1*f*fd*r*s - 54*D1**2*b1*f*fd*r + 54*D1**2*b1*f*fd*s**2 - 54*D1**2*b1*f*fd*s + 27*D1**2*b1*f*fd - 90*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd - 90*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s - 45*D1**2*bdd1*f**2*(r + s - 1)**2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 216*D1*Dd*b1*f**2*r*s - 162*D1*Dd*b1*f**2*r + 108*D1*Dd*b1*f**2*s**2 - 162*D1*Dd*b1*f**2*s + 81*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 900*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 900*D1*Dd*b1*f*fd*s - 270*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 1190*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 1190*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 270*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 270*D1*Ddd*b1*f**2*s - 135*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 210*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 210*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 + 9*D1*bd1*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 540*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 810*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 810*Dd**2*b1*f**2*s - 270*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 630*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 630*Dd**2*f**3*s - 210*Dd**2*f**3)/(630*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**2*k1**4*k2**2*st**2*(-726*C*D1**2*b1*f*fd*r**2 - 1452*C*D1**2*b1*f*fd*r*s + 726*C*D1**2*b1*f*fd*r - 726*C*D1**2*b1*f*fd*s**2 + 726*C*D1**2*b1*f*fd*s - 363*C*D1**2*b1*f*fd + 1098*C*D1**2*b1*f*fdd*r**2 + 2196*C*D1**2*b1*f*fdd*r*s - 1098*C*D1**2*b1*f*fdd*r + 1098*C*D1**2*b1*f*fdd*s**2 - 1098*C*D1**2*b1*f*fdd*s + 549*C*D1**2*b1*f*fdd + 1098*C*D1**2*b1*fd**2*r**2 + 2196*C*D1**2*b1*fd**2*r*s - 1098*C*D1**2*b1*fd**2*r + 1098*C*D1**2*b1*fd**2*s**2 - 1098*C*D1**2*b1*fd**2*s - 885*C*D1**2*f**2*fd*r**2 - 1770*C*D1**2*f**2*fd*r*s + 1180*C*D1**2*f**2*fd*r - 885*C*D1**2*f**2*fd*s**2 + 1180*C*D1**2*f**2*fd*s - 590*C*D1**2*f**2*fd + 915*C*D1**2*f**2*fdd*r**2 + 1830*C*D1**2*f**2*fdd*r*s - 1220*C*D1**2*f**2*fdd*r + 915*C*D1**2*f**2*fdd*s**2 - 1220*C*D1**2*f**2*fdd*s + 610*C*D1**2*f**2*fdd + 1830*C*D1**2*f*fd**2*r**2 + 3660*C*D1**2*f*fd**2*r*s - 2440*C*D1**2*f*fd**2*r + 1830*C*D1**2*f*fd**2*s**2 - 2440*C*D1**2*f*fd**2*s + 610*C*D1**2*f*fd**2 - 1452*C*D1*Dd*b1*f**2*r**2 - 2904*C*D1*Dd*b1*f**2*r*s + 2178*C*D1*Dd*b1*f**2*r - 1452*C*D1*Dd*b1*f**2*s**2 + 2178*C*D1*Dd*b1*f**2*s - 1089*C*D1*Dd*b1*f**2 + 8784*C*D1*Dd*b1*f*fd*r**2 + 17568*C*D1*Dd*b1*f*fd*r*s - 10980*C*D1*Dd*b1*f*fd*r + 8784*C*D1*Dd*b1*f*fd*s**2 - 10980*C*D1*Dd*b1*f*fd*s + 3294*C*D1*Dd*b1*f*fd - 1180*C*D1*Dd*f**3*r**2 - 2360*C*D1*Dd*f**3*r*s + 1770*C*D1*Dd*f**3*r - 1180*C*D1*Dd*f**3*s**2 + 1770*C*D1*Dd*f**3*s - 885*C*D1*Dd*f**3 + 7320*C*D1*Dd*f**2*fd*r**2 + 14640*C*D1*Dd*f**2*fd*r*s - 10370*C*D1*Dd*f**2*fd*r + 7320*C*D1*Dd*f**2*fd*s**2 - 10370*C*D1*Dd*f**2*fd*s + 3660*C*D1*Dd*f**2*fd + 2196*C*D1*Ddd*b1*f**2*r**2 + 4392*C*D1*Ddd*b1*f**2*r*s - 3294*C*D1*Ddd*b1*f**2*r + 2196*C*D1*Ddd*b1*f**2*s**2 - 3294*C*D1*Ddd*b1*f**2*s + 1647*C*D1*Ddd*b1*f**2 + 1220*C*D1*Ddd*f**3*r**2 + 2440*C*D1*Ddd*f**3*r*s - 1830*C*D1*Ddd*f**3*r + 1220*C*D1*Ddd*f**3*s**2 - 1830*C*D1*Ddd*f**3*s + 915*C*D1*Ddd*f**3 + 6588*C*Dd**2*b1*f**2*r**2 + 13176*C*Dd**2*b1*f**2*r*s - 9882*C*Dd**2*b1*f**2*r + 6588*C*Dd**2*b1*f**2*s**2 - 9882*C*Dd**2*b1*f**2*s + 3294*C*Dd**2*b1*f**2 + 3660*C*Dd**2*f**3*r**2 + 7320*C*Dd**2*f**3*r*s - 5490*C*Dd**2*f**3*r + 3660*C*Dd**2*f**3*s**2 - 5490*C*Dd**2*f**3*s + 1830*C*Dd**2*f**3 + 408*D1**2*b1*f*fd*r**2 + 816*D1**2*b1*f*fd*r*s - 408*D1**2*b1*f*fd*r + 408*D1**2*b1*f*fd*s**2 - 408*D1**2*b1*f*fd*s + 204*D1**2*b1*f*fd - 666*D1**2*b1*f*fdd*r**2 - 1332*D1**2*b1*f*fdd*r*s + 666*D1**2*b1*f*fdd*r - 666*D1**2*b1*f*fdd*s**2 + 666*D1**2*b1*f*fdd*s - 333*D1**2*b1*f*fdd - 666*D1**2*b1*fd**2*r**2 - 1332*D1**2*b1*fd**2*r*s + 666*D1**2*b1*fd**2*r - 666*D1**2*b1*fd**2*s**2 + 666*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(61*C - 37)*(r + s - 1)**2 + 516*D1**2*f**2*fd*r**2 + 1032*D1**2*f**2*fd*r*s - 688*D1**2*f**2*fd*r + 516*D1**2*f**2*fd*s**2 - 688*D1**2*f**2*fd*s + 344*D1**2*f**2*fd - 555*D1**2*f**2*fdd*r**2 - 1110*D1**2*f**2*fdd*r*s + 740*D1**2*f**2*fdd*r - 555*D1**2*f**2*fdd*s**2 + 740*D1**2*f**2*fdd*s - 370*D1**2*f**2*fdd - 1110*D1**2*f*fd**2*r**2 - 2220*D1**2*f*fd**2*r*s + 1480*D1**2*f*fd**2*r - 1110*D1**2*f*fd**2*s**2 + 1480*D1**2*f*fd**2*s - 370*D1**2*f*fd**2 + 816*D1*Dd*b1*f**2*r**2 + 1632*D1*Dd*b1*f**2*r*s - 1224*D1*Dd*b1*f**2*r + 816*D1*Dd*b1*f**2*s**2 - 1224*D1*Dd*b1*f**2*s + 612*D1*Dd*b1*f**2 - 5328*D1*Dd*b1*f*fd*r**2 - 10656*D1*Dd*b1*f*fd*r*s + 6660*D1*Dd*b1*f*fd*r - 5328*D1*Dd*b1*f*fd*s**2 + 6660*D1*Dd*b1*f*fd*s - 1998*D1*Dd*b1*f*fd + 688*D1*Dd*f**3*r**2 + 1376*D1*Dd*f**3*r*s - 1032*D1*Dd*f**3*r + 688*D1*Dd*f**3*s**2 - 1032*D1*Dd*f**3*s + 516*D1*Dd*f**3 - 4440*D1*Dd*f**2*fd*r**2 - 8880*D1*Dd*f**2*fd*r*s + 6290*D1*Dd*f**2*fd*r - 4440*D1*Dd*f**2*fd*s**2 + 6290*D1*Dd*f**2*fd*s - 2220*D1*Dd*f**2*fd - 1332*D1*Ddd*b1*f**2*r**2 - 2664*D1*Ddd*b1*f**2*r*s + 1998*D1*Ddd*b1*f**2*r - 1332*D1*Ddd*b1*f**2*s**2 + 1998*D1*Ddd*b1*f**2*s - 999*D1*Ddd*b1*f**2 - 740*D1*Ddd*f**3*r**2 - 1480*D1*Ddd*f**3*r*s + 1110*D1*Ddd*f**3*r - 740*D1*Ddd*f**3*s**2 + 1110*D1*Ddd*f**3*s - 555*D1*Ddd*f**3 - 3*D1*bd1*f*(r + s - 1)*(D1*f*(121*C - 68)*(r + s - 1) - D1*fd*(366*C - 222)*(2*r + 2*s - 1) - Dd*f*(366*C - 222)*(4*r + 4*s - 3)) - 3996*Dd**2*b1*f**2*r**2 - 7992*Dd**2*b1*f**2*r*s + 5994*Dd**2*b1*f**2*r - 3996*Dd**2*b1*f**2*s**2 + 5994*Dd**2*b1*f**2*s - 1998*Dd**2*b1*f**2 - 2220*Dd**2*f**3*r**2 - 4440*Dd**2*f**3*r*s + 3330*Dd**2*f**3*r - 2220*Dd**2*f**3*s**2 + 3330*Dd**2*f**3*s - 1110*Dd**2*f**3)/(315*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**2*k1**4*k2**2*(-2970*C*D1**2*f**2*fd*r**2 - 5940*C*D1**2*f**2*fd*r*s + 3960*C*D1**2*f**2*fd*r - 2970*C*D1**2*f**2*fd*s**2 + 3960*C*D1**2*f**2*fd*s - 1980*C*D1**2*f**2*fd - 3960*C*D1*Dd*f**3*r**2 - 7920*C*D1*Dd*f**3*r*s + 5940*C*D1*Dd*f**3*r - 3960*C*D1*Dd*f**3*s**2 + 5940*C*D1*Dd*f**3*s - 2970*C*D1*Dd*f**3 - 7425*D1**2*K*bdd1*f**2*r**2 - 14850*D1**2*K*bdd1*f**2*r*s + 14850*D1**2*K*bdd1*f**2*r - 7425*D1**2*K*bdd1*f**2*s**2 + 14850*D1**2*K*bdd1*f**2*s - 7425*D1**2*K*bdd1*f**2 + 990*D1**2*bd1**2*f*(-21*K + 5*f + 7)*(r + s - 1)**2 + 1540*D1**2*bdd1*f**3*r**2 + 3080*D1**2*bdd1*f**3*r*s - 3080*D1**2*bdd1*f**3*r + 1540*D1**2*bdd1*f**3*s**2 - 3080*D1**2*bdd1*f**3*s + 1540*D1**2*bdd1*f**3 + 2475*D1**2*bdd1*f**2*r**2 + 4950*D1**2*bdd1*f**2*r*s - 4950*D1**2*bdd1*f**2*r + 2475*D1**2*bdd1*f**2*s**2 - 4950*D1**2*bdd1*f**2*s + 2475*D1**2*bdd1*f**2 + 20790*D1**2*bdd1*f*g2*r**2 + 41580*D1**2*bdd1*f*g2*r*s - 41580*D1**2*bdd1*f*g2*r + 20790*D1**2*bdd1*f*g2*s**2 - 41580*D1**2*bdd1*f*g2*s + 20790*D1**2*bdd1*f*g2 + 980*D1**2*f**3*fd*r**2 + 1960*D1**2*f**3*fd*r*s - 1470*D1**2*f**3*fd*r + 980*D1**2*f**3*fd*s**2 - 1470*D1**2*f**3*fd*s + 735*D1**2*f**3*fd - 1260*D1**2*f**3*fdd*r**2 - 2520*D1**2*f**3*fdd*r*s + 1890*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s**2 + 1890*D1**2*f**3*fdd*s - 945*D1**2*f**3*fdd - 3780*D1**2*f**2*fd**2*r**2 - 7560*D1**2*f**2*fd**2*r*s + 5670*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s**2 + 5670*D1**2*f**2*fd**2*s - 1890*D1**2*f**2*fd**2 + 1485*D1**2*f**2*fd*r**2 + 2970*D1**2*f**2*fd*r*s - 1980*D1**2*f**2*fd*r + 1485*D1**2*f**2*fd*s**2 - 1980*D1**2*f**2*fd*s + 990*D1**2*f**2*fd - 10296*D1**2*f**2*gd2*r**2 - 20592*D1**2*f**2*gd2*r*s + 20592*D1**2*f**2*gd2*r - 10296*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s - 10296*D1**2*f**2*gd2 + 14850*D1**2*f**2*gdd2*r**2 + 29700*D1**2*f**2*gdd2*r*s - 29700*D1**2*f**2*gdd2*r + 14850*D1**2*f**2*gdd2*s**2 - 29700*D1**2*f**2*gdd2*s + 14850*D1**2*f**2*gdd2 - 20592*D1**2*f*fd*g2*r**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 20592*D1**2*f*fd*g2*s**2 + 20592*D1**2*f*fd*g2*s - 10296*D1**2*f*fd*g2 + 59400*D1**2*f*fd*gd2*r**2 + 118800*D1**2*f*fd*gd2*r*s - 89100*D1**2*f*fd*gd2*r + 59400*D1**2*f*fd*gd2*s**2 - 89100*D1**2*f*fd*gd2*s + 29700*D1**2*f*fd*gd2 + 29700*D1**2*f*fdd*g2*r**2 + 59400*D1**2*f*fdd*g2*r*s - 29700*D1**2*f*fdd*g2*r + 29700*D1**2*f*fdd*g2*s**2 - 29700*D1**2*f*fdd*g2*s + 14850*D1**2*f*fdd*g2 + 29700*D1**2*fd**2*g2*r**2 + 59400*D1**2*fd**2*g2*r*s - 29700*D1**2*fd**2*g2*r + 29700*D1**2*fd**2*g2*s**2 - 29700*D1**2*fd**2*g2*s + 980*D1*Dd*f**4*r**2 + 1960*D1*Dd*f**4*r*s - 1470*D1*Dd*f**4*r + 980*D1*Dd*f**4*s**2 - 1470*D1*Dd*f**4*s + 735*D1*Dd*f**4 - 10080*D1*Dd*f**3*fd*r**2 - 20160*D1*Dd*f**3*fd*r*s + 15120*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s**2 + 15120*D1*Dd*f**3*fd*s - 5670*D1*Dd*f**3*fd + 1980*D1*Dd*f**3*r**2 + 3960*D1*Dd*f**3*r*s - 2970*D1*Dd*f**3*r + 1980*D1*Dd*f**3*s**2 - 2970*D1*Dd*f**3*s + 1485*D1*Dd*f**3 - 41184*D1*Dd*f**2*g2*r**2 - 82368*D1*Dd*f**2*g2*r*s + 61776*D1*Dd*f**2*g2*r - 41184*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 30888*D1*Dd*f**2*g2 + 118800*D1*Dd*f**2*gd2*r**2 + 237600*D1*Dd*f**2*gd2*r*s - 207900*D1*Dd*f**2*gd2*r + 118800*D1*Dd*f**2*gd2*s**2 - 207900*D1*Dd*f**2*gd2*s + 89100*D1*Dd*f**2*gd2 + 237600*D1*Dd*f*fd*g2*r**2 + 475200*D1*Dd*f*fd*g2*r*s - 297000*D1*Dd*f*fd*g2*r + 237600*D1*Dd*f*fd*g2*s**2 - 297000*D1*Dd*f*fd*g2*s + 89100*D1*Dd*f*fd*g2 - 1260*D1*Ddd*f**4*r**2 - 2520*D1*Ddd*f**4*r*s + 1890*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s**2 + 1890*D1*Ddd*f**4*s - 945*D1*Ddd*f**4 + 59400*D1*Ddd*f**2*g2*r**2 + 118800*D1*Ddd*f**2*g2*r*s - 89100*D1*Ddd*f**2*g2*r + 59400*D1*Ddd*f**2*g2*s**2 - 89100*D1*Ddd*f**2*g2*s + 44550*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(50*f**3*(r + s - 1) + f**2*(63*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) - (234*K - 36)*(r + s - 1)) + 15*f*(15*fd*(3*K - 1)*(2*r + 2*s - 1) + (28*g2 - 126*gd2)*(r + s - 1)) - 1890*fd*g2*(r + s)) - 5*Dd*f*(28*f**2 - 45*f*(3*K - 1) + 378*g2)*(4*r + 4*s - 3))*(r + s - 1) - 3780*Dd**2*f**4*r**2 - 7560*Dd**2*f**4*r*s + 5670*Dd**2*f**4*r - 3780*Dd**2*f**4*s**2 + 5670*Dd**2*f**4*s - 1890*Dd**2*f**4 + 178200*Dd**2*f**2*g2*r**2 + 356400*Dd**2*f**2*g2*r*s - 267300*Dd**2*f**2*g2*r + 178200*Dd**2*f**2*g2*s**2 - 267300*Dd**2*f**2*g2*s + 89100*Dd**2*f**2*g2 - 165*b1**2*(D1**2*(3*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(30*fd**2*(r + s - 1) + 7*fd*(4*K - 1)*(r + s) - 21*fdd*(3*K - 1)*(r + s))) + D1*(Dd*(9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(30*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (28*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(3*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-21*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-21*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(252*C*D1**2*f*fd*r**2 + 504*C*D1**2*f*fd*r*s - 252*C*D1**2*f*fd*r + 252*C*D1**2*f*fd*s**2 - 252*C*D1**2*f*fd*s + 126*C*D1**2*f*fd + 504*C*D1*Dd*f**2*r**2 + 1008*C*D1*Dd*f**2*r*s - 756*C*D1*Dd*f**2*r + 504*C*D1*Dd*f**2*s**2 - 756*C*D1*Dd*f**2*s + 378*C*D1*Dd*f**2 - 936*D1**2*K*f*fd*r**2 - 1872*D1**2*K*f*fd*r*s + 936*D1**2*K*f*fd*r - 936*D1**2*K*f*fd*s**2 + 936*D1**2*K*f*fd*s - 468*D1**2*K*f*fd + 1350*D1**2*K*f*fdd*r**2 + 2700*D1**2*K*f*fdd*r*s - 1350*D1**2*K*f*fdd*r + 1350*D1**2*K*f*fdd*s**2 - 1350*D1**2*K*f*fdd*s + 675*D1**2*K*f*fdd + 1350*D1**2*K*fd**2*r**2 + 2700*D1**2*K*fd**2*r*s - 1350*D1**2*K*fd**2*r + 1350*D1**2*K*fd**2*s**2 - 1350*D1**2*K*fd**2*s - 90*D1**2*bdd1*f*(-21*K + 5*f + 7)*(r + s - 1)**2 + 300*D1**2*f**2*fd*r**2 + 600*D1**2*f**2*fd*r*s - 400*D1**2*f**2*fd*r + 300*D1**2*f**2*fd*s**2 - 400*D1**2*f**2*fd*s + 200*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 144*D1**2*f*fd*r**2 + 288*D1**2*f*fd*r*s - 144*D1**2*f*fd*r + 144*D1**2*f*fd*s**2 - 144*D1**2*f*fd*s + 72*D1**2*f*fd - 450*D1**2*f*fdd*r**2 - 900*D1**2*f*fdd*r*s + 450*D1**2*f*fdd*r - 450*D1**2*f*fdd*s**2 + 450*D1**2*f*fdd*s - 225*D1**2*f*fdd + 840*D1**2*f*gd2*r**2 + 1680*D1**2*f*gd2*r*s - 1680*D1**2*f*gd2*r + 840*D1**2*f*gd2*s**2 - 1680*D1**2*f*gd2*s + 840*D1**2*f*gd2 - 1890*D1**2*f*gdd2*r**2 - 3780*D1**2*f*gdd2*r*s + 3780*D1**2*f*gdd2*r - 1890*D1**2*f*gdd2*s**2 + 3780*D1**2*f*gdd2*s - 1890*D1**2*f*gdd2 - 450*D1**2*fd**2*r**2 - 900*D1**2*fd**2*r*s + 450*D1**2*fd**2*r - 450*D1**2*fd**2*s**2 + 450*D1**2*fd**2*s + 840*D1**2*fd*g2*r**2 + 1680*D1**2*fd*g2*r*s + 840*D1**2*fd*g2*s**2 - 3780*D1**2*fd*gd2*r**2 - 7560*D1**2*fd*gd2*r*s + 3780*D1**2*fd*gd2*r - 3780*D1**2*fd*gd2*s**2 + 3780*D1**2*fd*gd2*s - 1890*D1**2*fdd*g2*r**2 - 3780*D1**2*fdd*g2*r*s - 1890*D1**2*fdd*g2*s**2 - 1872*D1*Dd*K*f**2*r**2 - 3744*D1*Dd*K*f**2*r*s + 2808*D1*Dd*K*f**2*r - 1872*D1*Dd*K*f**2*s**2 + 2808*D1*Dd*K*f**2*s - 1404*D1*Dd*K*f**2 + 10800*D1*Dd*K*f*fd*r**2 + 21600*D1*Dd*K*f*fd*r*s - 13500*D1*Dd*K*f*fd*r + 10800*D1*Dd*K*f*fd*s**2 - 13500*D1*Dd*K*f*fd*s + 4050*D1*Dd*K*f*fd + 400*D1*Dd*f**3*r**2 + 800*D1*Dd*f**3*r*s - 600*D1*Dd*f**3*r + 400*D1*Dd*f**3*s**2 - 600*D1*Dd*f**3*s + 300*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd + 288*D1*Dd*f**2*r**2 + 576*D1*Dd*f**2*r*s - 432*D1*Dd*f**2*r + 288*D1*Dd*f**2*s**2 - 432*D1*Dd*f**2*s + 216*D1*Dd*f**2 - 3600*D1*Dd*f*fd*r**2 - 7200*D1*Dd*f*fd*r*s + 4500*D1*Dd*f*fd*r - 3600*D1*Dd*f*fd*s**2 + 4500*D1*Dd*f*fd*s - 1350*D1*Dd*f*fd + 3360*D1*Dd*f*g2*r**2 + 6720*D1*Dd*f*g2*r*s - 5040*D1*Dd*f*g2*r + 3360*D1*Dd*f*g2*s**2 - 5040*D1*Dd*f*g2*s + 2520*D1*Dd*f*g2 - 15120*D1*Dd*f*gd2*r**2 - 30240*D1*Dd*f*gd2*r*s + 26460*D1*Dd*f*gd2*r - 15120*D1*Dd*f*gd2*s**2 + 26460*D1*Dd*f*gd2*s - 11340*D1*Dd*f*gd2 - 15120*D1*Dd*fd*g2*r**2 - 30240*D1*Dd*fd*g2*r*s + 11340*D1*Dd*fd*g2*r - 15120*D1*Dd*fd*g2*s**2 + 11340*D1*Dd*fd*g2*s + 2700*D1*Ddd*K*f**2*r**2 + 5400*D1*Ddd*K*f**2*r*s - 4050*D1*Ddd*K*f**2*r + 2700*D1*Ddd*K*f**2*s**2 - 4050*D1*Ddd*K*f**2*s + 2025*D1*Ddd*K*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 900*D1*Ddd*f**2*r**2 - 1800*D1*Ddd*f**2*r*s + 1350*D1*Ddd*f**2*r - 900*D1*Ddd*f**2*s**2 + 1350*D1*Ddd*f**2*s - 675*D1*Ddd*f**2 - 7560*D1*Ddd*f*g2*r**2 - 15120*D1*Ddd*f*g2*r*s + 11340*D1*Ddd*f*g2*r - 7560*D1*Ddd*f*g2*s**2 + 11340*D1*Ddd*f*g2*s - 5670*D1*Ddd*f*g2 + 30*D1*bd1*(D1*(9*f**2*(r + s - 1) - 30*f*fd*(2*r + 2*s - 1) - 7*f*(4*K - 1)*(r + s - 1) + 42*fd*(3*K - 1)*(r + s)) - 6*Dd*f*(-21*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 8100*Dd**2*K*f**2*r**2 + 16200*Dd**2*K*f**2*r*s - 12150*Dd**2*K*f**2*r + 8100*Dd**2*K*f**2*s**2 - 12150*Dd**2*K*f**2*s + 4050*Dd**2*K*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 2700*Dd**2*f**2*r**2 - 5400*Dd**2*f**2*r*s + 4050*Dd**2*f**2*r - 2700*Dd**2*f**2*s**2 + 4050*Dd**2*f**2*s - 1350*Dd**2*f**2 - 22680*Dd**2*f*g2*r**2 - 45360*Dd**2*f*g2*r*s + 34020*Dd**2*f*g2*r - 22680*Dd**2*f*g2*s**2 + 34020*Dd**2*f*g2*s - 11340*Dd**2*f*g2))/(6930*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**2*k1**4*(2*C - 1)*(3*D1*b1*(-21*D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 3*D1*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) + 30*D1*fd**2*(r + s - 1) + 30*Dd*f*fd*(4*r + 4*s - 3) + 7*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 21*b1**2*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(-126*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 45*D1**2*bdd1*f*(2*r + 2*s - 1) - 5*D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 9*D1*bd1*(D1*f*(6*r + 6*s - 3) - 10*D1*fd*(r + s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 5*D1*f*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 14*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 210*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**2*k1**2*k2**4*st**4*(-1044*C*D1**2*b1*f*fd*r**2 - 2088*C*D1**2*b1*f*fd*r*s + 1044*C*D1**2*b1*f*fd*r - 1044*C*D1**2*b1*f*fd*s**2 + 1044*C*D1**2*b1*f*fd*s - 522*C*D1**2*b1*f*fd + 732*C*D1**2*b1*f*fdd*r**2 + 1464*C*D1**2*b1*f*fdd*r*s - 732*C*D1**2*b1*f*fdd*r + 732*C*D1**2*b1*f*fdd*s**2 - 732*C*D1**2*b1*f*fdd*s + 366*C*D1**2*b1*f*fdd + 732*C*D1**2*b1*fd**2*r**2 + 1464*C*D1**2*b1*fd**2*r*s - 732*C*D1**2*b1*fd**2*r + 732*C*D1**2*b1*fd**2*s**2 - 732*C*D1**2*b1*fd**2*s - 642*C*D1**2*f**2*fd*r**2 - 1284*C*D1**2*f**2*fd*r*s + 856*C*D1**2*f**2*fd*r - 642*C*D1**2*f**2*fd*s**2 + 856*C*D1**2*f**2*fd*s - 428*C*D1**2*f**2*fd + 366*C*D1**2*f**2*fdd*r**2 + 732*C*D1**2*f**2*fdd*r*s - 488*C*D1**2*f**2*fdd*r + 366*C*D1**2*f**2*fdd*s**2 - 488*C*D1**2*f**2*fdd*s + 244*C*D1**2*f**2*fdd + 732*C*D1**2*f*fd**2*r**2 + 1464*C*D1**2*f*fd**2*r*s - 976*C*D1**2*f*fd**2*r + 732*C*D1**2*f*fd**2*s**2 - 976*C*D1**2*f*fd**2*s + 244*C*D1**2*f*fd**2 - 2088*C*D1*Dd*b1*f**2*r**2 - 4176*C*D1*Dd*b1*f**2*r*s + 3132*C*D1*Dd*b1*f**2*r - 2088*C*D1*Dd*b1*f**2*s**2 + 3132*C*D1*Dd*b1*f**2*s - 1566*C*D1*Dd*b1*f**2 + 5856*C*D1*Dd*b1*f*fd*r**2 + 11712*C*D1*Dd*b1*f*fd*r*s - 7320*C*D1*Dd*b1*f*fd*r + 5856*C*D1*Dd*b1*f*fd*s**2 - 7320*C*D1*Dd*b1*f*fd*s + 2196*C*D1*Dd*b1*f*fd - 856*C*D1*Dd*f**3*r**2 - 1712*C*D1*Dd*f**3*r*s + 1284*C*D1*Dd*f**3*r - 856*C*D1*Dd*f**3*s**2 + 1284*C*D1*Dd*f**3*s - 642*C*D1*Dd*f**3 + 2928*C*D1*Dd*f**2*fd*r**2 + 5856*C*D1*Dd*f**2*fd*r*s - 4148*C*D1*Dd*f**2*fd*r + 2928*C*D1*Dd*f**2*fd*s**2 - 4148*C*D1*Dd*f**2*fd*s + 1464*C*D1*Dd*f**2*fd + 1464*C*D1*Ddd*b1*f**2*r**2 + 2928*C*D1*Ddd*b1*f**2*r*s - 2196*C*D1*Ddd*b1*f**2*r + 1464*C*D1*Ddd*b1*f**2*s**2 - 2196*C*D1*Ddd*b1*f**2*s + 1098*C*D1*Ddd*b1*f**2 + 488*C*D1*Ddd*f**3*r**2 + 976*C*D1*Ddd*f**3*r*s - 732*C*D1*Ddd*f**3*r + 488*C*D1*Ddd*f**3*s**2 - 732*C*D1*Ddd*f**3*s + 366*C*D1*Ddd*f**3 + 4392*C*Dd**2*b1*f**2*r**2 + 8784*C*Dd**2*b1*f**2*r*s - 6588*C*Dd**2*b1*f**2*r + 4392*C*Dd**2*b1*f**2*s**2 - 6588*C*Dd**2*b1*f**2*s + 2196*C*Dd**2*b1*f**2 + 1464*C*Dd**2*f**3*r**2 + 2928*C*Dd**2*f**3*r*s - 2196*C*Dd**2*f**3*r + 1464*C*Dd**2*f**3*s**2 - 2196*C*Dd**2*f**3*s + 732*C*Dd**2*f**3 + 708*D1**2*b1*f*fd*r**2 + 1416*D1**2*b1*f*fd*r*s - 708*D1**2*b1*f*fd*r + 708*D1**2*b1*f*fd*s**2 - 708*D1**2*b1*f*fd*s + 354*D1**2*b1*f*fd - 522*D1**2*b1*f*fdd*r**2 - 1044*D1**2*b1*f*fdd*r*s + 522*D1**2*b1*f*fdd*r - 522*D1**2*b1*f*fdd*s**2 + 522*D1**2*b1*f*fdd*s - 261*D1**2*b1*f*fdd - 522*D1**2*b1*fd**2*r**2 - 1044*D1**2*b1*fd**2*r*s + 522*D1**2*b1*fd**2*r - 522*D1**2*b1*fd**2*s**2 + 522*D1**2*b1*fd**2*s + 3*D1**2*bdd1*f**2*(122*C - 87)*(r + s - 1)**2 + 450*D1**2*f**2*fd*r**2 + 900*D1**2*f**2*fd*r*s - 600*D1**2*f**2*fd*r + 450*D1**2*f**2*fd*s**2 - 600*D1**2*f**2*fd*s + 300*D1**2*f**2*fd - 261*D1**2*f**2*fdd*r**2 - 522*D1**2*f**2*fdd*r*s + 348*D1**2*f**2*fdd*r - 261*D1**2*f**2*fdd*s**2 + 348*D1**2*f**2*fdd*s - 174*D1**2*f**2*fdd - 522*D1**2*f*fd**2*r**2 - 1044*D1**2*f*fd**2*r*s + 696*D1**2*f*fd**2*r - 522*D1**2*f*fd**2*s**2 + 696*D1**2*f*fd**2*s - 174*D1**2*f*fd**2 + 1416*D1*Dd*b1*f**2*r**2 + 2832*D1*Dd*b1*f**2*r*s - 2124*D1*Dd*b1*f**2*r + 1416*D1*Dd*b1*f**2*s**2 - 2124*D1*Dd*b1*f**2*s + 1062*D1*Dd*b1*f**2 - 4176*D1*Dd*b1*f*fd*r**2 - 8352*D1*Dd*b1*f*fd*r*s + 5220*D1*Dd*b1*f*fd*r - 4176*D1*Dd*b1*f*fd*s**2 + 5220*D1*Dd*b1*f*fd*s - 1566*D1*Dd*b1*f*fd + 600*D1*Dd*f**3*r**2 + 1200*D1*Dd*f**3*r*s - 900*D1*Dd*f**3*r + 600*D1*Dd*f**3*s**2 - 900*D1*Dd*f**3*s + 450*D1*Dd*f**3 - 2088*D1*Dd*f**2*fd*r**2 - 4176*D1*Dd*f**2*fd*r*s + 2958*D1*Dd*f**2*fd*r - 2088*D1*Dd*f**2*fd*s**2 + 2958*D1*Dd*f**2*fd*s - 1044*D1*Dd*f**2*fd - 1044*D1*Ddd*b1*f**2*r**2 - 2088*D1*Ddd*b1*f**2*r*s + 1566*D1*Ddd*b1*f**2*r - 1044*D1*Ddd*b1*f**2*s**2 + 1566*D1*Ddd*b1*f**2*s - 783*D1*Ddd*b1*f**2 - 348*D1*Ddd*f**3*r**2 - 696*D1*Ddd*f**3*r*s + 522*D1*Ddd*f**3*r - 348*D1*Ddd*f**3*s**2 + 522*D1*Ddd*f**3*s - 261*D1*Ddd*f**3 - 6*D1*bd1*f*(r + s - 1)*(D1*f*(87*C - 59)*(r + s - 1) - D1*fd*(122*C - 87)*(2*r + 2*s - 1) - Dd*f*(122*C - 87)*(4*r + 4*s - 3)) - 3132*Dd**2*b1*f**2*r**2 - 6264*Dd**2*b1*f**2*r*s + 4698*Dd**2*b1*f**2*r - 3132*Dd**2*b1*f**2*s**2 + 4698*Dd**2*b1*f**2*s - 1566*Dd**2*b1*f**2 - 1044*Dd**2*f**3*r**2 - 2088*Dd**2*f**3*r*s + 1566*Dd**2*f**3*r - 1044*Dd**2*f**3*s**2 + 1566*Dd**2*f**3*s - 522*Dd**2*f**3)/(210*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**2*k1**2*k2**4*st**2*(-396*D1**2*bd1**2*f*(-14*K + 10*f + 7)*(r + s - 1)**2 + 198*D1**2*bdd1*f*(f*(6*K - 3) - 28*g2)*(r + s - 1)**2 + 2*D1**2*(-10*f**3*(37*fd - 35*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(2100*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(627*C - 429)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (1991*gd2 - 1188*gdd2)*(r + s - 1)**2) + 11*f*(fd*(181*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 216*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 108*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2376*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 11*D1*bd1*(D1*(36*f**3*(r + s - 1) + f**2*(266*C - 181*K - 95)*(r + s - 1) + 2*f*(54*fd*(2*K - 1)*(2*r + 2*s - 1) + (329*g2 - 504*gd2)*(r + s - 1)) - 1008*fd*g2*(r + s)) + 36*Dd*f*(f*(6*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(370*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(627*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 700*fd*(4*r + 4*s - 3)**2 - 1716*r**2 - 429*r*(8*s - 6) - 1716*s**2 + 2574*s - 1287) - 1991*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2376*f*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2376*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2*Ddd*f*(175*f**2 - 594*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 24*Dd**2*f**2*(175*f**2 - 594*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 11*b1**2*(D1**2*(12*f*(16*fd - 15*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(360*fd**2*(r + s - 1) + 7*fd*(47*K - 21)*(r + s) - 126*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(192*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(360*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (329*K - 147)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 252*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 18*Ddd*f*(-14*K + 10*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*f*(-14*K + 10*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(532*C*D1**2*f*fd*r**2 + 1064*C*D1**2*f*fd*r*s - 532*C*D1**2*f*fd*r + 532*C*D1**2*f*fd*s**2 - 532*C*D1**2*f*fd*s + 266*C*D1**2*f*fd + 1064*C*D1*Dd*f**2*r**2 + 2128*C*D1*Dd*f**2*r*s - 1596*C*D1*Dd*f**2*r + 1064*C*D1*Dd*f**2*s**2 - 1596*C*D1*Dd*f**2*s + 798*C*D1*Dd*f**2 - 362*D1**2*K*f*fd*r**2 - 724*D1**2*K*f*fd*r*s + 362*D1**2*K*f*fd*r - 362*D1**2*K*f*fd*s**2 + 362*D1**2*K*f*fd*s - 181*D1**2*K*f*fd + 216*D1**2*K*f*fdd*r**2 + 432*D1**2*K*f*fdd*r*s - 216*D1**2*K*f*fdd*r + 216*D1**2*K*f*fdd*s**2 - 216*D1**2*K*f*fdd*s + 108*D1**2*K*f*fdd + 216*D1**2*K*fd**2*r**2 + 432*D1**2*K*fd**2*r*s - 216*D1**2*K*fd**2*r + 216*D1**2*K*fd**2*s**2 - 216*D1**2*K*fd**2*s - 36*D1**2*bdd1*f*(-14*K + 10*f + 7)*(r + s - 1)**2 + 108*D1**2*f**2*fd*r**2 + 216*D1**2*f**2*fd*r*s - 144*D1**2*f**2*fd*r + 108*D1**2*f**2*fd*s**2 - 144*D1**2*f**2*fd*s + 72*D1**2*f**2*fd - 190*D1**2*f*fd*r**2 - 380*D1**2*f*fd*r*s + 190*D1**2*f*fd*r - 190*D1**2*f*fd*s**2 + 190*D1**2*f*fd*s - 95*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 216*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*r - 108*D1**2*f*fdd*s**2 + 108*D1**2*f*fdd*s - 54*D1**2*f*fdd + 658*D1**2*f*gd2*r**2 + 1316*D1**2*f*gd2*r*s - 1316*D1**2*f*gd2*r + 658*D1**2*f*gd2*s**2 - 1316*D1**2*f*gd2*s + 658*D1**2*f*gd2 - 504*D1**2*f*gdd2*r**2 - 1008*D1**2*f*gdd2*r*s + 1008*D1**2*f*gdd2*r - 504*D1**2*f*gdd2*s**2 + 1008*D1**2*f*gdd2*s - 504*D1**2*f*gdd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 108*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 108*D1**2*fd**2*s + 658*D1**2*fd*g2*r**2 + 1316*D1**2*fd*g2*r*s + 658*D1**2*fd*g2*s**2 - 1008*D1**2*fd*gd2*r**2 - 2016*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 1008*D1**2*fd*gd2*s**2 + 1008*D1**2*fd*gd2*s - 504*D1**2*fdd*g2*r**2 - 1008*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*s**2 - 724*D1*Dd*K*f**2*r**2 - 1448*D1*Dd*K*f**2*r*s + 1086*D1*Dd*K*f**2*r - 724*D1*Dd*K*f**2*s**2 + 1086*D1*Dd*K*f**2*s - 543*D1*Dd*K*f**2 + 1728*D1*Dd*K*f*fd*r**2 + 3456*D1*Dd*K*f*fd*r*s - 2160*D1*Dd*K*f*fd*r + 1728*D1*Dd*K*f*fd*s**2 - 2160*D1*Dd*K*f*fd*s + 648*D1*Dd*K*f*fd + 144*D1*Dd*f**3*r**2 + 288*D1*Dd*f**3*r*s - 216*D1*Dd*f**3*r + 144*D1*Dd*f**3*s**2 - 216*D1*Dd*f**3*s + 108*D1*Dd*f**3 - 380*D1*Dd*f**2*r**2 - 760*D1*Dd*f**2*r*s + 570*D1*Dd*f**2*r - 380*D1*Dd*f**2*s**2 + 570*D1*Dd*f**2*s - 285*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 1728*D1*Dd*f*fd*r*s + 1080*D1*Dd*f*fd*r - 864*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 324*D1*Dd*f*fd + 2632*D1*Dd*f*g2*r**2 + 5264*D1*Dd*f*g2*r*s - 3948*D1*Dd*f*g2*r + 2632*D1*Dd*f*g2*s**2 - 3948*D1*Dd*f*g2*s + 1974*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r**2 - 8064*D1*Dd*f*gd2*r*s + 7056*D1*Dd*f*gd2*r - 4032*D1*Dd*f*gd2*s**2 + 7056*D1*Dd*f*gd2*s - 3024*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r**2 - 8064*D1*Dd*fd*g2*r*s + 3024*D1*Dd*fd*g2*r - 4032*D1*Dd*fd*g2*s**2 + 3024*D1*Dd*fd*g2*s + 432*D1*Ddd*K*f**2*r**2 + 864*D1*Ddd*K*f**2*r*s - 648*D1*Ddd*K*f**2*r + 432*D1*Ddd*K*f**2*s**2 - 648*D1*Ddd*K*f**2*s + 324*D1*Ddd*K*f**2 - 216*D1*Ddd*f**2*r**2 - 432*D1*Ddd*f**2*r*s + 324*D1*Ddd*f**2*r - 216*D1*Ddd*f**2*s**2 + 324*D1*Ddd*f**2*s - 162*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r**2 - 4032*D1*Ddd*f*g2*r*s + 3024*D1*Ddd*f*g2*r - 2016*D1*Ddd*f*g2*s**2 + 3024*D1*Ddd*f*g2*s - 1512*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(192*f**2*(r + s - 1) - 360*f*fd*(2*r + 2*s - 1) - 7*f*(47*K - 21)*(r + s - 1) + 252*fd*(2*K - 1)*(r + s)) - 36*Dd*f*(-14*K + 10*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 1296*Dd**2*K*f**2*r**2 + 2592*Dd**2*K*f**2*r*s - 1944*Dd**2*K*f**2*r + 1296*Dd**2*K*f**2*s**2 - 1944*Dd**2*K*f**2*s + 648*Dd**2*K*f**2 - 648*Dd**2*f**2*r**2 - 1296*Dd**2*f**2*r*s + 972*Dd**2*f**2*r - 648*Dd**2*f**2*s**2 + 972*Dd**2*f**2*s - 324*Dd**2*f**2 - 6048*Dd**2*f*g2*r**2 - 12096*Dd**2*f*g2*r*s + 9072*Dd**2*f*g2*r - 6048*Dd**2*f*g2*s**2 + 9072*Dd**2*f*g2*s - 3024*Dd**2*f*g2))/(2310*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**2*k1**2*k2**2*st**2*(7*b1**2*(D1**2*(fd*(13*C - 6) + fdd*(13 - 19*C))*(r + s - 1)**2 + D1*(Dd*(f*(13*C - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(26 - 38*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(19*C - 13)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(114*C - 78)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-22*C*D1**2*f*fd*r**2 - 44*C*D1**2*f*fd*r*s - 136*C*D1**2*f*fd*r - 22*C*D1**2*f*fd*s**2 - 136*C*D1**2*f*fd*s + 68*C*D1**2*f*fd + 102*C*D1**2*f*fdd*r**2 + 204*C*D1**2*f*fdd*r*s + 12*C*D1**2*f*fdd*r + 102*C*D1**2*f*fdd*s**2 + 12*C*D1**2*f*fdd*s - 6*C*D1**2*f*fdd + 102*C*D1**2*fd**2*r**2 + 204*C*D1**2*fd**2*r*s + 12*C*D1**2*fd**2*r + 102*C*D1**2*fd**2*s**2 + 12*C*D1**2*fd**2*s - 114*C*D1**2*fd**2 - 44*C*D1*Dd*f**2*r**2 - 88*C*D1*Dd*f**2*r*s + 66*C*D1*Dd*f**2*r - 44*C*D1*Dd*f**2*s**2 + 66*C*D1*Dd*f**2*s - 33*C*D1*Dd*f**2 + 816*C*D1*Dd*f*fd*r**2 + 1632*C*D1*Dd*f*fd*r*s - 564*C*D1*Dd*f*fd*r + 816*C*D1*Dd*f*fd*s**2 - 564*C*D1*Dd*f*fd*s - 36*C*D1*Dd*f*fd + 204*C*D1*Ddd*f**2*r**2 + 408*C*D1*Ddd*f**2*r*s - 306*C*D1*Ddd*f**2*r + 204*C*D1*Ddd*f**2*s**2 - 306*C*D1*Ddd*f**2*s + 153*C*D1*Ddd*f**2 + 612*C*Dd**2*f**2*r**2 + 1224*C*Dd**2*f**2*r*s - 918*C*Dd**2*f**2*r + 612*C*Dd**2*f**2*s**2 - 918*C*Dd**2*f**2*s + 306*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(19*C - 13)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 6*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s + 94*D1**2*f*fd*r + 6*D1**2*f*fd*s**2 + 94*D1**2*f*fd*s - 47*D1**2*f*fd - 66*D1**2*f*fdd*r**2 - 132*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r - 66*D1**2*f*fdd*s**2 - 12*D1**2*f*fdd*s + 6*D1**2*f*fdd - 66*D1**2*fd**2*r**2 - 132*D1**2*fd**2*r*s - 12*D1**2*fd**2*r - 66*D1**2*fd**2*s**2 - 12*D1**2*fd**2*s + 78*D1**2*fd**2 + 12*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 12*D1*Dd*f**2*s**2 - 18*D1*Dd*f**2*s + 9*D1*Dd*f**2 - 528*D1*Dd*f*fd*r**2 - 1056*D1*Dd*f*fd*r*s + 348*D1*Dd*f*fd*r - 528*D1*Dd*f*fd*s**2 + 348*D1*Dd*f*fd*s + 36*D1*Dd*f*fd - 132*D1*Ddd*f**2*r**2 - 264*D1*Ddd*f**2*r*s + 198*D1*Ddd*f**2*r - 132*D1*Ddd*f**2*s**2 + 198*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(13*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(26 - 38*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(26 - 38*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 396*Dd**2*f**2*r**2 - 792*Dd**2*f**2*r*s + 594*Dd**2*f**2*r - 396*Dd**2*f**2*s**2 + 594*Dd**2*f**2*s - 198*Dd**2*f**2) + f*(-198*C*D1**2*f*fd*r**2 - 396*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*r - 198*C*D1**2*f*fd*s**2 + 264*C*D1**2*f*fd*s - 132*C*D1**2*f*fd + 180*C*D1**2*f*fdd*r**2 + 360*C*D1**2*f*fdd*r*s - 240*C*D1**2*f*fdd*r + 180*C*D1**2*f*fdd*s**2 - 240*C*D1**2*f*fdd*s + 120*C*D1**2*f*fdd + 360*C*D1**2*fd**2*r**2 + 720*C*D1**2*fd**2*r*s - 480*C*D1**2*fd**2*r + 360*C*D1**2*fd**2*s**2 - 480*C*D1**2*fd**2*s + 120*C*D1**2*fd**2 - 264*C*D1*Dd*f**2*r**2 - 528*C*D1*Dd*f**2*r*s + 396*C*D1*Dd*f**2*r - 264*C*D1*Dd*f**2*s**2 + 396*C*D1*Dd*f**2*s - 198*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r**2 + 2880*C*D1*Dd*f*fd*r*s - 2040*C*D1*Dd*f*fd*r + 1440*C*D1*Dd*f*fd*s**2 - 2040*C*D1*Dd*f*fd*s + 720*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 360*C*Dd**2*f**2 - 14*D1**2*bd1**2*(19*C - 13)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*D1**2*bdd1*f*(C*(17*r**2 + 34*r*s - 72*r + 17*s**2 - 72*s + 36) - 11*r**2 - 22*r*s + 48*r - 11*s**2 + 48*s - 24) + 123*D1**2*f*fd*r**2 + 246*D1**2*f*fd*r*s - 164*D1**2*f*fd*r + 123*D1**2*f*fd*s**2 - 164*D1**2*f*fd*s + 82*D1**2*f*fd - 120*D1**2*f*fdd*r**2 - 240*D1**2*f*fdd*r*s + 160*D1**2*f*fdd*r - 120*D1**2*f*fdd*s**2 + 160*D1**2*f*fdd*s - 80*D1**2*f*fdd - 240*D1**2*fd**2*r**2 - 480*D1**2*fd**2*r*s + 320*D1**2*fd**2*r - 240*D1**2*fd**2*s**2 + 320*D1**2*fd**2*s - 80*D1**2*fd**2 + 164*D1*Dd*f**2*r**2 + 328*D1*Dd*f**2*r*s - 246*D1*Dd*f**2*r + 164*D1*Dd*f**2*s**2 - 246*D1*Dd*f**2*s + 123*D1*Dd*f**2 - 960*D1*Dd*f*fd*r**2 - 1920*D1*Dd*f*fd*r*s + 1360*D1*Dd*f*fd*r - 960*D1*Dd*f*fd*s**2 + 1360*D1*Dd*f*fd*s - 480*D1*Dd*f*fd - 160*D1*Ddd*f**2*r**2 - 320*D1*Ddd*f**2*r*s + 240*D1*Ddd*f**2*r - 160*D1*Ddd*f**2*s**2 + 240*D1*Ddd*f**2*s - 120*D1*Ddd*f**2 + D1*bd1*(D1*(f*(-C*(11*r**2 + 22*r*s - 180*r + 11*s**2 - 180*s + 90) + 3*r**2 + 6*r*s - 106*r + 3*s**2 - 106*s + 53) + 12*fd*(r + s - 1)*(C*(17*r + 17*s - 18) - 11*r - 11*s + 12)) + 6*Dd*f*(4*r + 4*s - 3)*(C*(17*r + 17*s - 36) - 11*r - 11*s + 24)) - 480*Dd**2*f**2*r**2 - 960*Dd**2*f**2*r*s + 720*Dd**2*f**2*r - 480*Dd**2*f**2*s**2 + 720*Dd**2*f**2*s - 240*Dd**2*f**2))/(105*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**2*k1**2*k2**2*(252*C*D1**2*bd1*f**2*r + 252*C*D1**2*bd1*f**2*s - 126*C*D1**2*bd1*f**2 - 270*C*D1**2*f**2*fd*r**2 - 540*C*D1**2*f**2*fd*r*s + 360*C*D1**2*f**2*fd*r - 270*C*D1**2*f**2*fd*s**2 + 360*C*D1**2*f**2*fd*s - 180*C*D1**2*f**2*fd - 360*C*D1*Dd*f**3*r**2 - 720*C*D1*Dd*f**3*r*s + 540*C*D1*Dd*f**3*r - 360*C*D1*Dd*f**3*s**2 + 540*C*D1*Dd*f**3*s - 270*C*D1*Dd*f**3 + 756*D1**2*K*bd1**2*f*r + 756*D1**2*K*bd1**2*f*s - 756*D1**2*K*bd1**2*f + 225*D1**2*K*bd1*f**2*r**2 + 450*D1**2*K*bd1*f**2*r*s - 450*D1**2*K*bd1*f**2*r + 225*D1**2*K*bd1*f**2*s**2 - 450*D1**2*K*bd1*f**2*s + 225*D1**2*K*bd1*f**2 - 1080*D1**2*K*bd1*f*fd*r**2 - 2160*D1**2*K*bd1*f*fd*r*s + 1620*D1**2*K*bd1*f*fd*r - 1080*D1**2*K*bd1*f*fd*s**2 + 1620*D1**2*K*bd1*f*fd*s - 540*D1**2*K*bd1*f*fd - 270*D1**2*K*bdd1*f**2*r**2 - 540*D1**2*K*bdd1*f**2*r*s + 540*D1**2*K*bdd1*f**2*r - 270*D1**2*K*bdd1*f**2*s**2 + 540*D1**2*K*bdd1*f**2*s - 270*D1**2*K*bdd1*f**2 + 180*D1**2*bd1**2*f**2*r**2 + 360*D1**2*bd1**2*f**2*r*s - 540*D1**2*bd1**2*f**2*r + 180*D1**2*bd1**2*f**2*s**2 - 540*D1**2*bd1**2*f**2*s + 360*D1**2*bd1**2*f**2 + 126*D1**2*bd1**2*f*r**2 + 252*D1**2*bd1**2*f*r*s - 630*D1**2*bd1**2*f*r + 126*D1**2*bd1**2*f*s**2 - 630*D1**2*bd1**2*f*s + 504*D1**2*bd1**2*f - 2520*D1**2*bd1**2*g2*r**2 - 5040*D1**2*bd1**2*g2*r*s + 2520*D1**2*bd1**2*g2*r - 2520*D1**2*bd1**2*g2*s**2 + 2520*D1**2*bd1**2*g2*s - 756*D1**2*bd1*bd2*f*r**2 - 1512*D1**2*bd1*bd2*f*r*s + 1512*D1**2*bd1*bd2*f*r - 756*D1**2*bd1*bd2*f*s**2 + 1512*D1**2*bd1*bd2*f*s - 756*D1**2*bd1*bd2*f - 125*D1**2*bd1*f**3*r**2 - 250*D1**2*bd1*f**3*r*s + 200*D1**2*bd1*f**3*r - 125*D1**2*bd1*f**3*s**2 + 200*D1**2*bd1*f**3*s - 100*D1**2*bd1*f**3 + 1050*D1**2*bd1*f**2*fd*r**2 + 2100*D1**2*bd1*f**2*fd*r*s - 1610*D1**2*bd1*f**2*fd*r + 1050*D1**2*bd1*f**2*fd*s**2 - 1610*D1**2*bd1*f**2*fd*s + 560*D1**2*bd1*f**2*fd - 108*D1**2*bd1*f**2*r**2 - 216*D1**2*bd1*f**2*r*s + 90*D1**2*bd1*f**2*r - 108*D1**2*bd1*f**2*s**2 + 90*D1**2*bd1*f**2*s - 45*D1**2*bd1*f**2 + 720*D1**2*bd1*f*fd*r**2 + 1440*D1**2*bd1*f*fd*r*s - 1080*D1**2*bd1*f*fd*r + 720*D1**2*bd1*f*fd*s**2 - 1080*D1**2*bd1*f*fd*s + 360*D1**2*bd1*f*fd + 924*D1**2*bd1*f*g2*r + 924*D1**2*bd1*f*g2*s - 462*D1**2*bd1*f*g2 - 1512*D1**2*bd1*f*gd2*r - 1512*D1**2*bd1*f*gd2*s + 1512*D1**2*bd1*f*gd2 + 225*D1**2*bd2*f**2*r**2 + 450*D1**2*bd2*f**2*r*s - 450*D1**2*bd2*f**2*r + 225*D1**2*bd2*f**2*s**2 - 450*D1**2*bd2*f**2*s + 225*D1**2*bd2*f**2 - 1080*D1**2*bd2*f*fd*r**2 - 2160*D1**2*bd2*f*fd*r*s + 1620*D1**2*bd2*f*fd*r - 1080*D1**2*bd2*f*fd*s**2 + 1620*D1**2*bd2*f*fd*s - 540*D1**2*bd2*f*fd + 175*D1**2*bdd1*f**3*r**2 + 350*D1**2*bdd1*f**3*r*s - 280*D1**2*bdd1*f**3*r + 175*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 140*D1**2*bdd1*f**3 + 180*D1**2*bdd1*f**2*r**2 + 360*D1**2*bdd1*f**2*r*s - 360*D1**2*bdd1*f**2*r + 180*D1**2*bdd1*f**2*s**2 - 360*D1**2*bdd1*f**2*s + 180*D1**2*bdd1*f**2 - 1512*D1**2*bdd1*f*g2*r - 1512*D1**2*bdd1*f*g2*s + 756*D1**2*bdd1*f*g2 - 270*D1**2*bdd2*f**2*r**2 - 540*D1**2*bdd2*f**2*r*s + 540*D1**2*bdd2*f**2*r - 270*D1**2*bdd2*f**2*s**2 + 540*D1**2*bdd2*f**2*s - 270*D1**2*bdd2*f**2 + 135*D1**2*f**2*fd*r**2 + 270*D1**2*f**2*fd*r*s - 180*D1**2*f**2*fd*r + 135*D1**2*f**2*fd*s**2 - 180*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 450*D1**2*f**2*gd2*r**2 - 900*D1**2*f**2*gd2*r*s + 900*D1**2*f**2*gd2*r - 450*D1**2*f**2*gd2*s**2 + 900*D1**2*f**2*gd2*s - 450*D1**2*f**2*gd2 + 540*D1**2*f**2*gdd2*r**2 + 1080*D1**2*f**2*gdd2*r*s - 1080*D1**2*f**2*gdd2*r + 540*D1**2*f**2*gdd2*s**2 - 1080*D1**2*f**2*gdd2*s + 540*D1**2*f**2*gdd2 - 900*D1**2*f*fd*g2*r**2 - 1800*D1**2*f*fd*g2*r*s + 900*D1**2*f*fd*g2*r - 900*D1**2*f*fd*g2*s**2 + 900*D1**2*f*fd*g2*s - 450*D1**2*f*fd*g2 + 2160*D1**2*f*fd*gd2*r**2 + 4320*D1**2*f*fd*gd2*r*s - 3240*D1**2*f*fd*gd2*r + 2160*D1**2*f*fd*gd2*s**2 - 3240*D1**2*f*fd*gd2*s + 1080*D1**2*f*fd*gd2 + 1080*D1**2*f*fdd*g2*r**2 + 2160*D1**2*f*fdd*g2*r*s - 1080*D1**2*f*fdd*g2*r + 1080*D1**2*f*fdd*g2*s**2 - 1080*D1**2*f*fdd*g2*s + 540*D1**2*f*fdd*g2 + 1080*D1**2*fd**2*g2*r**2 + 2160*D1**2*fd**2*g2*r*s - 1080*D1**2*fd**2*g2*r + 1080*D1**2*fd**2*g2*s**2 - 1080*D1**2*fd**2*g2*s - 2160*D1*Dd*K*bd1*f**2*r**2 - 4320*D1*Dd*K*bd1*f**2*r*s + 3780*D1*Dd*K*bd1*f**2*r - 2160*D1*Dd*K*bd1*f**2*s**2 + 3780*D1*Dd*K*bd1*f**2*s - 1620*D1*Dd*K*bd1*f**2 + 1400*D1*Dd*bd1*f**3*r**2 + 2800*D1*Dd*bd1*f**3*r*s - 2170*D1*Dd*bd1*f**3*r + 1400*D1*Dd*bd1*f**3*s**2 - 2170*D1*Dd*bd1*f**3*s + 840*D1*Dd*bd1*f**3 + 1440*D1*Dd*bd1*f**2*r**2 + 2880*D1*Dd*bd1*f**2*r*s - 2520*D1*Dd*bd1*f**2*r + 1440*D1*Dd*bd1*f**2*s**2 - 2520*D1*Dd*bd1*f**2*s + 1080*D1*Dd*bd1*f**2 - 6048*D1*Dd*bd1*f*g2*r - 6048*D1*Dd*bd1*f*g2*s + 4536*D1*Dd*bd1*f*g2 - 2160*D1*Dd*bd2*f**2*r**2 - 4320*D1*Dd*bd2*f**2*r*s + 3780*D1*Dd*bd2*f**2*r - 2160*D1*Dd*bd2*f**2*s**2 + 3780*D1*Dd*bd2*f**2*s - 1620*D1*Dd*bd2*f**2 + 180*D1*Dd*f**3*r**2 + 360*D1*Dd*f**3*r*s - 270*D1*Dd*f**3*r + 180*D1*Dd*f**3*s**2 - 270*D1*Dd*f**3*s + 135*D1*Dd*f**3 - 1800*D1*Dd*f**2*g2*r**2 - 3600*D1*Dd*f**2*g2*r*s + 2700*D1*Dd*f**2*g2*r - 1800*D1*Dd*f**2*g2*s**2 + 2700*D1*Dd*f**2*g2*s - 1350*D1*Dd*f**2*g2 + 4320*D1*Dd*f**2*gd2*r**2 + 8640*D1*Dd*f**2*gd2*r*s - 7560*D1*Dd*f**2*gd2*r + 4320*D1*Dd*f**2*gd2*s**2 - 7560*D1*Dd*f**2*gd2*s + 3240*D1*Dd*f**2*gd2 + 8640*D1*Dd*f*fd*g2*r**2 + 17280*D1*Dd*f*fd*g2*r*s - 10800*D1*Dd*f*fd*g2*r + 8640*D1*Dd*f*fd*g2*s**2 - 10800*D1*Dd*f*fd*g2*s + 3240*D1*Dd*f*fd*g2 + 2160*D1*Ddd*f**2*g2*r**2 + 4320*D1*Ddd*f**2*g2*r*s - 3240*D1*Ddd*f**2*g2*r + 2160*D1*Ddd*f**2*g2*s**2 - 3240*D1*Ddd*f**2*g2*s + 1620*D1*Ddd*f**2*g2 + 6480*Dd**2*f**2*g2*r**2 + 12960*Dd**2*f**2*g2*r*s - 9720*Dd**2*f**2*g2*r + 6480*Dd**2*f**2*g2*s**2 - 9720*Dd**2*f**2*g2*s + 3240*Dd**2*f**2*g2 + 63*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (5*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(70*C*D1**2*fd*r**2 + 140*C*D1**2*fd*r*s - 140*C*D1**2*fd*r + 70*C*D1**2*fd*s**2 - 140*C*D1**2*fd*s + 70*C*D1**2*fd + 280*C*D1*Dd*f*r**2 + 560*C*D1*Dd*f*r*s - 420*C*D1*Dd*f*r + 280*C*D1*Dd*f*s**2 - 420*C*D1*Dd*f*s + 210*C*D1*Dd*f + 154*D1**2*K*fd*r + 154*D1**2*K*fd*s - 77*D1**2*K*fd - 252*D1**2*K*fdd*r - 252*D1**2*K*fdd*s + 126*D1**2*K*fdd - 21*D1**2*bdd1*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 36*D1**2*f*fd*r**2 - 72*D1**2*f*fd*r*s - 36*D1**2*f*fd*s**2 + 60*D1**2*f*fdd*r**2 + 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*s**2 + 60*D1**2*fd**2*r**2 + 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*s**2 - 60*D1**2*fd**2 - 42*D1**2*fd*r**2 - 84*D1**2*fd*r*s + 28*D1**2*fd*r - 42*D1**2*fd*s**2 + 28*D1**2*fd*s - 14*D1**2*fd + 21*D1**2*fdd*r**2 + 42*D1**2*fdd*r*s + 126*D1**2*fdd*r + 21*D1**2*fdd*s**2 + 126*D1**2*fdd*s - 63*D1**2*fdd - 210*D1**2*gd2*r**2 - 420*D1**2*gd2*r*s + 420*D1**2*gd2*r - 210*D1**2*gd2*s**2 + 420*D1**2*gd2*s - 210*D1**2*gd2 - 420*D1**2*gdd2*r**2 - 840*D1**2*gdd2*r*s + 840*D1**2*gdd2*r - 420*D1**2*gdd2*s**2 + 840*D1**2*gdd2*s - 420*D1**2*gdd2 - 1008*D1*Dd*K*fd*r - 1008*D1*Dd*K*fd*s + 756*D1*Dd*K*fd - 72*D1*Dd*f**2*r**2 - 144*D1*Dd*f**2*r*s + 108*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 108*D1*Dd*f**2*s - 54*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 + 960*D1*Dd*f*fd*r*s - 360*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 360*D1*Dd*f*fd*s - 168*D1*Dd*f*r**2 - 336*D1*Dd*f*r*s + 252*D1*Dd*f*r - 168*D1*Dd*f*s**2 + 252*D1*Dd*f*s - 126*D1*Dd*f + 168*D1*Dd*fd*r**2 + 336*D1*Dd*fd*r*s + 378*D1*Dd*fd*r + 168*D1*Dd*fd*s**2 + 378*D1*Dd*fd*s - 378*D1*Dd*fd - 840*D1*Dd*g2*r**2 - 1680*D1*Dd*g2*r*s + 1260*D1*Dd*g2*r - 840*D1*Dd*g2*s**2 + 1260*D1*Dd*g2*s - 630*D1*Dd*g2 - 3360*D1*Dd*gd2*r**2 - 6720*D1*Dd*gd2*r*s + 5880*D1*Dd*gd2*r - 3360*D1*Dd*gd2*s**2 + 5880*D1*Dd*gd2*s - 2520*D1*Dd*gd2 + 120*D1*Ddd*f**2*r**2 + 240*D1*Ddd*f**2*r*s - 180*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 180*D1*Ddd*f**2*s + 90*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 + 168*D1*Ddd*f*r*s - 126*D1*Ddd*f*r + 84*D1*Ddd*f*s**2 - 126*D1*Ddd*f*s + 63*D1*Ddd*f - 1680*D1*Ddd*g2*r**2 - 3360*D1*Ddd*g2*r*s + 2520*D1*Ddd*g2*r - 1680*D1*Ddd*g2*s**2 + 2520*D1*Ddd*g2*s - 1260*D1*Ddd*g2 + 21*D1*bd1*(D1*(f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (5*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-10*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 360*Dd**2*f**2*r**2 + 720*Dd**2*f**2*r*s - 540*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 540*Dd**2*f**2*s + 180*Dd**2*f**2 + 252*Dd**2*f*r**2 + 504*Dd**2*f*r*s - 378*Dd**2*f*r + 252*Dd**2*f*s**2 - 378*Dd**2*f*s + 126*Dd**2*f - 5040*Dd**2*g2*r**2 - 10080*Dd**2*g2*r*s + 7560*Dd**2*g2*r - 5040*Dd**2*g2*s**2 + 7560*Dd**2*g2*s - 2520*Dd**2*g2) + b1*(-252*C*D1**2*f*fd*r - 252*C*D1**2*f*fd*s + 126*C*D1**2*f*fd + 756*D1**2*K*bdd1*f*r + 756*D1**2*K*bdd1*f*s - 378*D1**2*K*bdd1*f + 450*D1**2*K*f*fd*r**2 + 900*D1**2*K*f*fd*r*s - 450*D1**2*K*f*fd*r + 450*D1**2*K*f*fd*s**2 - 450*D1**2*K*f*fd*s + 225*D1**2*K*f*fd - 540*D1**2*K*f*fdd*r**2 - 1080*D1**2*K*f*fdd*r*s + 540*D1**2*K*f*fdd*r - 540*D1**2*K*f*fdd*s**2 + 540*D1**2*K*f*fdd*s - 270*D1**2*K*f*fdd - 540*D1**2*K*fd**2*r**2 - 1080*D1**2*K*fd**2*r*s + 540*D1**2*K*fd**2*r - 540*D1**2*K*fd**2*s**2 + 540*D1**2*K*fd**2*s + 231*D1**2*b2*fd*r**2 + 462*D1**2*b2*fd*r*s + 231*D1**2*b2*fd*s**2 - 378*D1**2*b2*fdd*r**2 - 756*D1**2*b2*fdd*r*s - 378*D1**2*b2*fdd*s**2 - 126*D1**2*bd1**2*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 180*D1**2*bdd1*f**2*r**2 + 360*D1**2*bdd1*f**2*r*s - 540*D1**2*bdd1*f**2*r + 180*D1**2*bdd1*f**2*s**2 - 540*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 + 126*D1**2*bdd1*f*r**2 + 252*D1**2*bdd1*f*r*s - 630*D1**2*bdd1*f*r + 126*D1**2*bdd1*f*s**2 - 630*D1**2*bdd1*f*s + 315*D1**2*bdd1*f - 2520*D1**2*bdd1*g2*r**2 - 5040*D1**2*bdd1*g2*r*s + 2520*D1**2*bdd1*g2*r - 2520*D1**2*bdd1*g2*s**2 + 2520*D1**2*bdd1*g2*s - 1260*D1**2*bdd1*g2 - 378*D1**2*bdd2*f*r**2 - 756*D1**2*bdd2*f*r*s + 756*D1**2*bdd2*f*r - 378*D1**2*bdd2*f*s**2 + 756*D1**2*bdd2*f*s - 378*D1**2*bdd2*f - 375*D1**2*f**2*fd*r**2 - 750*D1**2*f**2*fd*r*s + 550*D1**2*f**2*fd*r - 375*D1**2*f**2*fd*s**2 + 550*D1**2*f**2*fd*s - 275*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 770*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 770*D1**2*f**2*fdd*s + 385*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1540*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1540*D1**2*f*fd**2*s + 490*D1**2*f*fd**2 - 216*D1**2*f*fd*r**2 - 432*D1**2*f*fd*r*s + 342*D1**2*f*fd*r - 216*D1**2*f*fd*s**2 + 342*D1**2*f*fd*s - 171*D1**2*f*fd + 360*D1**2*f*fdd*r**2 + 720*D1**2*f*fdd*r*s - 360*D1**2*f*fdd*r + 360*D1**2*f*fdd*s**2 - 360*D1**2*f*fdd*s + 180*D1**2*f*fdd + 360*D1**2*fd**2*r**2 + 720*D1**2*fd**2*r*s - 360*D1**2*fd**2*r + 360*D1**2*fd**2*s**2 - 360*D1**2*fd**2*s - 924*D1**2*fd*g2*r - 924*D1**2*fd*g2*s + 462*D1**2*fd*g2 + 1512*D1**2*fd*gd2*r + 1512*D1**2*fd*gd2*s - 1512*D1**2*fd*gd2 + 1512*D1**2*fdd*g2*r + 1512*D1**2*fdd*g2*s - 756*D1**2*fdd*g2 + 900*D1*Dd*K*f**2*r**2 + 1800*D1*Dd*K*f**2*r*s - 1350*D1*Dd*K*f**2*r + 900*D1*Dd*K*f**2*s**2 - 1350*D1*Dd*K*f**2*s + 675*D1*Dd*K*f**2 - 4320*D1*Dd*K*f*fd*r**2 - 8640*D1*Dd*K*f*fd*r*s + 5400*D1*Dd*K*f*fd*r - 4320*D1*Dd*K*f*fd*s**2 + 5400*D1*Dd*K*f*fd*s - 1620*D1*Dd*K*f*fd + 924*D1*Dd*b2*f*r**2 + 1848*D1*Dd*b2*f*r*s - 1386*D1*Dd*b2*f*r + 924*D1*Dd*b2*f*s**2 - 1386*D1*Dd*b2*f*s + 693*D1*Dd*b2*f - 3024*D1*Dd*b2*fd*r**2 - 6048*D1*Dd*b2*fd*r*s + 2268*D1*Dd*b2*fd*r - 3024*D1*Dd*b2*fd*s**2 + 2268*D1*Dd*b2*fd*s - 500*D1*Dd*f**3*r**2 - 1000*D1*Dd*f**3*r*s + 750*D1*Dd*f**3*r - 500*D1*Dd*f**3*s**2 + 750*D1*Dd*f**3*s - 375*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 6230*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 6230*D1*Dd*f**2*fd*s + 2310*D1*Dd*f**2*fd - 432*D1*Dd*f**2*r**2 - 864*D1*Dd*f**2*r*s + 648*D1*Dd*f**2*r - 432*D1*Dd*f**2*s**2 + 648*D1*Dd*f**2*s - 324*D1*Dd*f**2 + 2880*D1*Dd*f*fd*r**2 + 5760*D1*Dd*f*fd*r*s - 3600*D1*Dd*f*fd*r + 2880*D1*Dd*f*fd*s**2 - 3600*D1*Dd*f*fd*s + 1080*D1*Dd*f*fd + 6048*D1*Dd*fd*g2*r + 6048*D1*Dd*fd*g2*s - 4536*D1*Dd*fd*g2 - 1080*D1*Ddd*K*f**2*r**2 - 2160*D1*Ddd*K*f**2*r*s + 1620*D1*Ddd*K*f**2*r - 1080*D1*Ddd*K*f**2*s**2 + 1620*D1*Ddd*K*f**2*s - 810*D1*Ddd*K*f**2 - 1512*D1*Ddd*b2*f*r**2 - 3024*D1*Ddd*b2*f*r*s + 2268*D1*Ddd*b2*f*r - 1512*D1*Ddd*b2*f*s**2 + 2268*D1*Ddd*b2*f*s - 1134*D1*Ddd*b2*f + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 1050*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 525*D1*Ddd*f**3 + 720*D1*Ddd*f**2*r**2 + 1440*D1*Ddd*f**2*r*s - 1080*D1*Ddd*f**2*r + 720*D1*Ddd*f**2*s**2 - 1080*D1*Ddd*f**2*s + 540*D1*Ddd*f**2 - 3*D1*bd1*(D1*(18*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + f*(-70*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 77*K*(2*r + 2*s - 1) - 120*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 84*r**2 + 28*r*(6*s - 5) + 84*s**2 - 140*s + 70) + 42*fd*(r + s - 1)*(6*K - 2*r - 2*s - 3) + 210*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 840*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 6*Dd*(4*r + 4*s - 3)*(10*f**2*(2*r + 2*s - 3) + 7*f*(6*K + 2*r + 2*s - 5) - 140*g2*(2*r + 2*s - 1))) + 21*D1*bd2*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) - 3240*Dd**2*K*f**2*r**2 - 6480*Dd**2*K*f**2*r*s + 4860*Dd**2*K*f**2*r - 3240*Dd**2*K*f**2*s**2 + 4860*Dd**2*K*f**2*s - 1620*Dd**2*K*f**2 - 4536*Dd**2*b2*f*r**2 - 9072*Dd**2*b2*f*r*s + 6804*Dd**2*b2*f*r - 4536*Dd**2*b2*f*s**2 + 6804*Dd**2*b2*f*s - 2268*Dd**2*b2*f + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 3150*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 1050*Dd**2*f**3 + 2160*Dd**2*f**2*r**2 + 4320*Dd**2*f**2*r*s - 3240*Dd**2*f**2*r + 2160*Dd**2*f**2*s**2 - 3240*Dd**2*f**2*s + 1080*Dd**2*f**2) + 3*b2*(-126*D1**2*bdd1*f*(r + s - 1)**2 + 15*D1**2*(f*(5*fd - 6*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 7*D1*bd1*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) + 15*D1*f*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 540*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**2*k1**2*(2*C - 1)*(-3*D1*f*(r + s)*(14*D1*bd1**2*(r + s - 1) + 5*D1*bdd1*f*(r + s) + bd1*(-3*D1*f*(r + s) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3))) + 7*b1**2*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-21*D1**2*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*D1**2*(r + s - 1)**2*(3*f*fd - 5*f*fdd - 5*fd**2) + 7*D1*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 20*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**2) - D1**2*Pk1*Pkdd3*ct**2*k2**6*st**6*(C - 1)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(63*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**2*k2**6*st**4*(198*C*D1**2*f**2*fd*r**2 + 396*C*D1**2*f**2*fd*r*s - 264*C*D1**2*f**2*fd*r + 198*C*D1**2*f**2*fd*s**2 - 264*C*D1**2*f**2*fd*s + 132*C*D1**2*f**2*fd + 264*C*D1*Dd*f**3*r**2 + 528*C*D1*Dd*f**3*r*s - 396*C*D1*Dd*f**3*r + 264*C*D1*Dd*f**3*s**2 - 396*C*D1*Dd*f**3*s + 198*C*D1*Dd*f**3 + 33*D1**2*K*bdd1*f**2*r**2 + 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*r + 33*D1**2*K*bdd1*f**2*s**2 - 66*D1**2*K*bdd1*f**2*s + 33*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(-7*K + 15*f + 7)*(r + s - 1)**2 + 660*D1**2*bdd1*f**3*r**2 + 1320*D1**2*bdd1*f**3*r*s - 1320*D1**2*bdd1*f**3*r + 660*D1**2*bdd1*f**3*s**2 - 1320*D1**2*bdd1*f**3*s + 660*D1**2*bdd1*f**3 - 33*D1**2*bdd1*f**2*r**2 - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r - 33*D1**2*bdd1*f**2*s**2 + 66*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 - 462*D1**2*bdd1*f*g2*r**2 - 924*D1**2*bdd1*f*g2*r*s + 924*D1**2*bdd1*f*g2*r - 462*D1**2*bdd1*f*g2*s**2 + 924*D1**2*bdd1*f*g2*s - 462*D1**2*bdd1*f*g2 - 2560*D1**2*f**3*fd*r**2 - 5120*D1**2*f**3*fd*r*s + 3840*D1**2*f**3*fd*r - 2560*D1**2*f**3*fd*s**2 + 3840*D1**2*f**3*fd*s - 1920*D1**2*f**3*fd + 1500*D1**2*f**3*fdd*r**2 + 3000*D1**2*f**3*fdd*r*s - 2250*D1**2*f**3*fdd*r + 1500*D1**2*f**3*fdd*s**2 - 2250*D1**2*f**3*fdd*s + 1125*D1**2*f**3*fdd + 4500*D1**2*f**2*fd**2*r**2 + 9000*D1**2*f**2*fd**2*r*s - 6750*D1**2*f**2*fd**2*r + 4500*D1**2*f**2*fd**2*s**2 - 6750*D1**2*f**2*fd**2*s + 2250*D1**2*f**2*fd**2 - 198*D1**2*f**2*fd*r**2 - 396*D1**2*f**2*fd*r*s + 264*D1**2*f**2*fd*r - 198*D1**2*f**2*fd*s**2 + 264*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 132*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*r + 132*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gd2 - 66*D1**2*f**2*gdd2*r**2 - 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*r - 66*D1**2*f**2*gdd2*s**2 + 132*D1**2*f**2*gdd2*s - 66*D1**2*f**2*gdd2 + 264*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 264*D1**2*f*fd*gd2*r**2 - 528*D1**2*f*fd*gd2*r*s + 396*D1**2*f*fd*gd2*r - 264*D1**2*f*fd*gd2*s**2 + 396*D1**2*f*fd*gd2*s - 132*D1**2*f*fd*gd2 - 132*D1**2*f*fdd*g2*r**2 - 264*D1**2*f*fdd*g2*r*s + 132*D1**2*f*fdd*g2*r - 132*D1**2*f*fdd*g2*s**2 + 132*D1**2*f*fdd*g2*s - 66*D1**2*f*fdd*g2 - 132*D1**2*fd**2*g2*r**2 - 264*D1**2*fd**2*g2*r*s + 132*D1**2*fd**2*g2*r - 132*D1**2*fd**2*g2*s**2 + 132*D1**2*fd**2*g2*s - 2560*D1*Dd*f**4*r**2 - 5120*D1*Dd*f**4*r*s + 3840*D1*Dd*f**4*r - 2560*D1*Dd*f**4*s**2 + 3840*D1*Dd*f**4*s - 1920*D1*Dd*f**4 + 12000*D1*Dd*f**3*fd*r**2 + 24000*D1*Dd*f**3*fd*r*s - 18000*D1*Dd*f**3*fd*r + 12000*D1*Dd*f**3*fd*s**2 - 18000*D1*Dd*f**3*fd*s + 6750*D1*Dd*f**3*fd - 264*D1*Dd*f**3*r**2 - 528*D1*Dd*f**3*r*s + 396*D1*Dd*f**3*r - 264*D1*Dd*f**3*s**2 + 396*D1*Dd*f**3*s - 198*D1*Dd*f**3 + 528*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 396*D1*Dd*f**2*g2 - 528*D1*Dd*f**2*gd2*r**2 - 1056*D1*Dd*f**2*gd2*r*s + 924*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s**2 + 924*D1*Dd*f**2*gd2*s - 396*D1*Dd*f**2*gd2 - 1056*D1*Dd*f*fd*g2*r**2 - 2112*D1*Dd*f*fd*g2*r*s + 1320*D1*Dd*f*fd*g2*r - 1056*D1*Dd*f*fd*g2*s**2 + 1320*D1*Dd*f*fd*g2*s - 396*D1*Dd*f*fd*g2 + 1500*D1*Ddd*f**4*r**2 + 3000*D1*Ddd*f**4*r*s - 2250*D1*Ddd*f**4*r + 1500*D1*Ddd*f**4*s**2 - 2250*D1*Ddd*f**4*s + 1125*D1*Ddd*f**4 - 264*D1*Ddd*f**2*g2*r**2 - 528*D1*Ddd*f**2*g2*r*s + 396*D1*Ddd*f**2*g2*r - 264*D1*Ddd*f**2*g2*s**2 + 396*D1*Ddd*f**2*g2*s - 198*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(15*f**3*(r + s - 1) + f**2*(-7*C*(r + s - 1) - 20*fd*(3*r + 3*s - 2) + (K + 6)*(r + s - 1)) + f*(-fd*(K - 1)*(2*r + 2*s - 1) + (-14*g2 + 14*gd2)*(r + s - 1)) + 14*fd*g2*(r + s)) - Dd*f*(20*f**2 + f*(K - 1) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) + 4500*Dd**2*f**4*r**2 + 9000*Dd**2*f**4*r*s - 6750*Dd**2*f**4*r + 4500*Dd**2*f**4*s**2 - 6750*Dd**2*f**4*s + 2250*Dd**2*f**4 - 792*Dd**2*f**2*g2*r**2 - 1584*Dd**2*f**2*g2*r*s + 1188*Dd**2*f**2*g2*r - 792*Dd**2*f**2*g2*s**2 + 1188*Dd**2*f**2*g2*s - 396*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(15*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(30*fd**2*(r + s - 1) + 14*fd*(K - 1)*(r + s) - 7*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(15*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(15*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (7*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-7*K + 15*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-7*K + 15*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(28*C*D1**2*f*fd*r**2 + 56*C*D1**2*f*fd*r*s - 28*C*D1**2*f*fd*r + 28*C*D1**2*f*fd*s**2 - 28*C*D1**2*f*fd*s + 14*C*D1**2*f*fd + 56*C*D1*Dd*f**2*r**2 + 112*C*D1*Dd*f**2*r*s - 84*C*D1*Dd*f**2*r + 56*C*D1*Dd*f**2*s**2 - 84*C*D1*Dd*f**2*s + 42*C*D1*Dd*f**2 - 4*D1**2*K*f*fd*r**2 - 8*D1**2*K*f*fd*r*s + 4*D1**2*K*f*fd*r - 4*D1**2*K*f*fd*s**2 + 4*D1**2*K*f*fd*s - 2*D1**2*K*f*fd + 2*D1**2*K*f*fdd*r**2 + 4*D1**2*K*f*fdd*r*s - 2*D1**2*K*f*fdd*r + 2*D1**2*K*f*fdd*s**2 - 2*D1**2*K*f*fdd*s + D1**2*K*f*fdd + 2*D1**2*K*fd**2*r**2 + 4*D1**2*K*fd**2*r*s - 2*D1**2*K*fd**2*r + 2*D1**2*K*fd**2*s**2 - 2*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-7*K + 15*f + 7)*(r + s - 1)**2 - 90*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 120*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 80*D1**2*f**2*fdd*s + 40*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 240*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 160*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 24*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 24*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd + 28*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r + 28*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s + 28*D1**2*f*gd2 - 14*D1**2*f*gdd2*r**2 - 28*D1**2*f*gdd2*r*s + 28*D1**2*f*gdd2*r - 14*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 14*D1**2*f*gdd2 - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s + 28*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*s**2 - 28*D1**2*fd*gd2*r**2 - 56*D1**2*fd*gd2*r*s + 28*D1**2*fd*gd2*r - 28*D1**2*fd*gd2*s**2 + 28*D1**2*fd*gd2*s - 14*D1**2*fdd*g2*r**2 - 28*D1**2*fdd*g2*r*s - 14*D1**2*fdd*g2*s**2 - 8*D1*Dd*K*f**2*r**2 - 16*D1*Dd*K*f**2*r*s + 12*D1*Dd*K*f**2*r - 8*D1*Dd*K*f**2*s**2 + 12*D1*Dd*K*f**2*s - 6*D1*Dd*K*f**2 + 16*D1*Dd*K*f*fd*r**2 + 32*D1*Dd*K*f*fd*r*s - 20*D1*Dd*K*f*fd*r + 16*D1*Dd*K*f*fd*s**2 - 20*D1*Dd*K*f*fd*s + 6*D1*Dd*K*f*fd - 120*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 180*D1*Dd*f**3*s - 90*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 960*D1*Dd*f**2*fd*r*s - 680*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 680*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd - 48*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 72*D1*Dd*f**2*s - 36*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd*s - 6*D1*Dd*f*fd + 112*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 112*D1*Dd*f*g2*s**2 - 168*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*r**2 - 224*D1*Dd*f*gd2*r*s + 196*D1*Dd*f*gd2*r - 112*D1*Dd*f*gd2*s**2 + 196*D1*Dd*f*gd2*s - 84*D1*Dd*f*gd2 - 112*D1*Dd*fd*g2*r**2 - 224*D1*Dd*fd*g2*r*s + 84*D1*Dd*fd*g2*r - 112*D1*Dd*fd*g2*s**2 + 84*D1*Dd*fd*g2*s + 4*D1*Ddd*K*f**2*r**2 + 8*D1*Ddd*K*f**2*r*s - 6*D1*Ddd*K*f**2*r + 4*D1*Ddd*K*f**2*s**2 - 6*D1*Ddd*K*f**2*s + 3*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r**2 + 160*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 120*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 - 56*D1*Ddd*f*g2*r**2 - 112*D1*Ddd*f*g2*r*s + 84*D1*Ddd*f*g2*r - 56*D1*Ddd*f*g2*s**2 + 84*D1*Ddd*f*g2*s - 42*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(15*f**2*(r + s - 1) - 15*f*fd*(2*r + 2*s - 1) - 7*f*(K - 1)*(r + s - 1) + 7*fd*(K - 1)*(r + s)) - Dd*f*(-7*K + 15*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 12*Dd**2*K*f**2*r**2 + 24*Dd**2*K*f**2*r*s - 18*Dd**2*K*f**2*r + 12*Dd**2*K*f**2*s**2 - 18*Dd**2*K*f**2*s + 6*Dd**2*K*f**2 + 240*Dd**2*f**3*r**2 + 480*Dd**2*f**3*r*s - 360*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 360*Dd**2*f**3*s + 120*Dd**2*f**3 - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2 - 168*Dd**2*f*g2*r**2 - 336*Dd**2*f*g2*r*s + 252*Dd**2*f*g2*r - 168*Dd**2*f*g2*s**2 + 252*Dd**2*f*g2*s - 84*Dd**2*f*g2))/(2310*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**2*k2**4*st**4*(-42*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(-112*C*D1**2*f*fd*r**2 - 224*C*D1**2*f*fd*r*s + 104*C*D1**2*f*fd*r - 112*C*D1**2*f*fd*s**2 + 104*C*D1**2*f*fd*s - 52*C*D1**2*f*fd + 56*C*D1**2*f*fdd*r**2 + 112*C*D1**2*f*fdd*r*s - 52*C*D1**2*f*fdd*r + 56*C*D1**2*f*fdd*s**2 - 52*C*D1**2*f*fdd*s + 26*C*D1**2*f*fdd + 56*C*D1**2*fd**2*r**2 + 112*C*D1**2*fd**2*r*s - 52*C*D1**2*fd**2*r + 56*C*D1**2*fd**2*s**2 - 52*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 - 224*C*D1*Dd*f**2*r**2 - 448*C*D1*Dd*f**2*r*s + 336*C*D1*Dd*f**2*r - 224*C*D1*Dd*f**2*s**2 + 336*C*D1*Dd*f**2*s - 168*C*D1*Dd*f**2 + 448*C*D1*Dd*f*fd*r**2 + 896*C*D1*Dd*f*fd*r*s - 544*C*D1*Dd*f*fd*r + 448*C*D1*Dd*f*fd*s**2 - 544*C*D1*Dd*f*fd*s + 156*C*D1*Dd*f*fd + 112*C*D1*Ddd*f**2*r**2 + 224*C*D1*Ddd*f**2*r*s - 168*C*D1*Ddd*f**2*r + 112*C*D1*Ddd*f**2*s**2 - 168*C*D1*Ddd*f**2*s + 84*C*D1*Ddd*f**2 + 336*C*Dd**2*f**2*r**2 + 672*C*Dd**2*f**2*r*s - 504*C*Dd**2*f**2*r + 336*C*Dd**2*f**2*s**2 - 504*C*Dd**2*f**2*s + 168*C*Dd**2*f**2 - 14*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 104*D1**2*f*fd*r**2 + 208*D1**2*f*fd*r*s - 96*D1**2*f*fd*r + 104*D1**2*f*fd*s**2 - 96*D1**2*f*fd*s + 48*D1**2*f*fd - 66*D1**2*f*fdd*r**2 - 132*D1**2*f*fdd*r*s + 62*D1**2*f*fdd*r - 66*D1**2*f*fdd*s**2 + 62*D1**2*f*fdd*s - 31*D1**2*f*fdd - 66*D1**2*fd**2*r**2 - 132*D1**2*fd**2*r*s + 62*D1**2*fd**2*r - 66*D1**2*fd**2*s**2 + 62*D1**2*fd**2*s + 4*D1**2*fd**2 + 208*D1*Dd*f**2*r**2 + 416*D1*Dd*f**2*r*s - 312*D1*Dd*f**2*r + 208*D1*Dd*f**2*s**2 - 312*D1*Dd*f**2*s + 156*D1*Dd*f**2 - 528*D1*Dd*f*fd*r**2 - 1056*D1*Dd*f*fd*r*s + 644*D1*Dd*f*fd*r - 528*D1*Dd*f*fd*s**2 + 644*D1*Dd*f*fd*s - 186*D1*Dd*f*fd - 132*D1*Ddd*f**2*r**2 - 264*D1*Ddd*f**2*r*s + 198*D1*Ddd*f**2*r - 132*D1*Ddd*f**2*s**2 + 198*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 + 28*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 396*Dd**2*f**2*r**2 - 792*Dd**2*f**2*r*s + 594*Dd**2*f**2*r - 396*Dd**2*f**2*s**2 + 594*Dd**2*f**2*s - 198*Dd**2*f**2) + f*(180*C*D1**2*f*fd*r**2 + 360*C*D1**2*f*fd*r*s - 240*C*D1**2*f*fd*r + 180*C*D1**2*f*fd*s**2 - 240*C*D1**2*f*fd*s + 120*C*D1**2*f*fd - 90*C*D1**2*f*fdd*r**2 - 180*C*D1**2*f*fdd*r*s + 120*C*D1**2*f*fdd*r - 90*C*D1**2*f*fdd*s**2 + 120*C*D1**2*f*fdd*s - 60*C*D1**2*f*fdd - 180*C*D1**2*fd**2*r**2 - 360*C*D1**2*fd**2*r*s + 240*C*D1**2*fd**2*r - 180*C*D1**2*fd**2*s**2 + 240*C*D1**2*fd**2*s - 60*C*D1**2*fd**2 + 240*C*D1*Dd*f**2*r**2 + 480*C*D1*Dd*f**2*r*s - 360*C*D1*Dd*f**2*r + 240*C*D1*Dd*f**2*s**2 - 360*C*D1*Dd*f**2*s + 180*C*D1*Dd*f**2 - 720*C*D1*Dd*f*fd*r**2 - 1440*C*D1*Dd*f*fd*r*s + 1020*C*D1*Dd*f*fd*r - 720*C*D1*Dd*f*fd*s**2 + 1020*C*D1*Dd*f*fd*s - 360*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r**2 - 240*C*D1*Ddd*f**2*r*s + 180*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 180*C*D1*Ddd*f**2*s - 90*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r**2 - 720*C*Dd**2*f**2*r*s + 540*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 540*C*Dd**2*f**2*s - 180*C*Dd**2*f**2 + 84*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 3*D1**2*bdd1*f*(C*(28*r**2 + 56*r*s - 60*r + 28*s**2 - 60*s + 30) - 33*r**2 - 66*r*s + 70*r - 33*s**2 + 70*s - 35) - 192*D1**2*f*fd*r**2 - 384*D1**2*f*fd*r*s + 256*D1**2*f*fd*r - 192*D1**2*f*fd*s**2 + 256*D1**2*f*fd*s - 128*D1**2*f*fd + 105*D1**2*f*fdd*r**2 + 210*D1**2*f*fdd*r*s - 140*D1**2*f*fdd*r + 105*D1**2*f*fdd*s**2 - 140*D1**2*f*fdd*s + 70*D1**2*f*fdd + 210*D1**2*fd**2*r**2 + 420*D1**2*fd**2*r*s - 280*D1**2*fd**2*r + 210*D1**2*fd**2*s**2 - 280*D1**2*fd**2*s + 70*D1**2*fd**2 - 256*D1*Dd*f**2*r**2 - 512*D1*Dd*f**2*r*s + 384*D1*Dd*f**2*r - 256*D1*Dd*f**2*s**2 + 384*D1*Dd*f**2*s - 192*D1*Dd*f**2 + 840*D1*Dd*f*fd*r**2 + 1680*D1*Dd*f*fd*r*s - 1190*D1*Dd*f*fd*r + 840*D1*Dd*f*fd*s**2 - 1190*D1*Dd*f*fd*s + 420*D1*Dd*f*fd + 140*D1*Ddd*f**2*r**2 + 280*D1*Ddd*f**2*r*s - 210*D1*Ddd*f**2*r + 140*D1*Ddd*f**2*s**2 - 210*D1*Ddd*f**2*s + 105*D1*Ddd*f**2 + 6*D1*bd1*(D1*(f*(C*(28*r**2 + 56*r*s - 60*r + 28*s**2 - 60*s + 30) - 26*r**2 - 52*r*s + 56*r - 26*s**2 + 56*s - 28) - fd*(r + s - 1)*(C*(56*r + 56*s - 30) - 66*r - 66*s + 35)) - Dd*f*(4*r + 4*s - 3)*(C*(28*r + 28*s - 30) - 33*r - 33*s + 35)) + 420*Dd**2*f**2*r**2 + 840*Dd**2*f**2*r*s - 630*Dd**2*f**2*r + 420*Dd**2*f**2*s**2 - 630*Dd**2*f**2*s + 210*Dd**2*f**2))/(210*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**2*k2**4*st**2*(-108*C*D1**2*f**2*fd*r**2 - 216*C*D1**2*f**2*fd*r*s + 144*C*D1**2*f**2*fd*r - 108*C*D1**2*f**2*fd*s**2 + 144*C*D1**2*f**2*fd*s - 72*C*D1**2*f**2*fd - 144*C*D1*Dd*f**3*r**2 - 288*C*D1*Dd*f**3*r*s + 216*C*D1*Dd*f**3*r - 144*C*D1*Dd*f**3*s**2 + 216*C*D1*Dd*f**3*s - 108*C*D1*Dd*f**3 - 18*D1**2*K*bdd1*f**2*r**2 - 36*D1**2*K*bdd1*f**2*r*s + 36*D1**2*K*bdd1*f**2*r - 18*D1**2*K*bdd1*f**2*s**2 + 36*D1**2*K*bdd1*f**2*s - 18*D1**2*K*bdd1*f**2 + 2*D1**2*bd1**2*(r + s - 1)*(36*f**2*(3*r + 3*s - 2) - 7*f*(K*(5*r + 5*s - 6) - 11*r - 11*s + 12) - 70*g2*(r + s)) + 36*D1**2*bd2*f**2*r**2 + 72*D1**2*bd2*f**2*r*s - 72*D1**2*bd2*f**2*r + 36*D1**2*bd2*f**2*s**2 - 72*D1**2*bd2*f**2*s + 36*D1**2*bd2*f**2 - 72*D1**2*bd2*f*fd*r**2 - 144*D1**2*bd2*f*fd*r*s + 108*D1**2*bd2*f*fd*r - 72*D1**2*bd2*f*fd*s**2 + 108*D1**2*bd2*f*fd*s - 36*D1**2*bd2*f*fd + 70*D1**2*bdd1*f**3*r**2 + 140*D1**2*bdd1*f**3*r*s - 80*D1**2*bdd1*f**3*r + 70*D1**2*bdd1*f**3*s**2 - 80*D1**2*bdd1*f**3*s + 40*D1**2*bdd1*f**3 + 36*D1**2*bdd1*f**2*r**2 + 72*D1**2*bdd1*f**2*r*s - 72*D1**2*bdd1*f**2*r + 36*D1**2*bdd1*f**2*s**2 - 72*D1**2*bdd1*f**2*s + 36*D1**2*bdd1*f**2 + 70*D1**2*bdd1*f*g2*r**2 + 140*D1**2*bdd1*f*g2*r*s - 168*D1**2*bdd1*f*g2*r + 70*D1**2*bdd1*f*g2*s**2 - 168*D1**2*bdd1*f*g2*s + 84*D1**2*bdd1*f*g2 - 18*D1**2*bdd2*f**2*r**2 - 36*D1**2*bdd2*f**2*r*s + 36*D1**2*bdd2*f**2*r - 18*D1**2*bdd2*f**2*s**2 + 36*D1**2*bdd2*f**2*s - 18*D1**2*bdd2*f**2 + 108*D1**2*f**2*fd*r**2 + 216*D1**2*f**2*fd*r*s - 144*D1**2*f**2*fd*r + 108*D1**2*f**2*fd*s**2 - 144*D1**2*f**2*fd*s + 72*D1**2*f**2*fd - 72*D1**2*f**2*gd2*r**2 - 144*D1**2*f**2*gd2*r*s + 144*D1**2*f**2*gd2*r - 72*D1**2*f**2*gd2*s**2 + 144*D1**2*f**2*gd2*s - 72*D1**2*f**2*gd2 + 36*D1**2*f**2*gdd2*r**2 + 72*D1**2*f**2*gdd2*r*s - 72*D1**2*f**2*gdd2*r + 36*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2*s + 36*D1**2*f**2*gdd2 - 144*D1**2*f*fd*g2*r**2 - 288*D1**2*f*fd*g2*r*s + 144*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r*s - 216*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 216*D1**2*f*fd*gd2*s + 72*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*r*s - 72*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*r*s - 72*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 144*D1*Dd*bd2*f**2*r**2 - 288*D1*Dd*bd2*f**2*r*s + 252*D1*Dd*bd2*f**2*r - 144*D1*Dd*bd2*f**2*s**2 + 252*D1*Dd*bd2*f**2*s - 108*D1*Dd*bd2*f**2 + 144*D1*Dd*f**3*r**2 + 288*D1*Dd*f**3*r*s - 216*D1*Dd*f**3*r + 144*D1*Dd*f**3*s**2 - 216*D1*Dd*f**3*s + 108*D1*Dd*f**3 - 288*D1*Dd*f**2*g2*r**2 - 576*D1*Dd*f**2*g2*r*s + 432*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 432*D1*Dd*f**2*g2*s - 216*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r**2 + 576*D1*Dd*f**2*gd2*r*s - 504*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 504*D1*Dd*f**2*gd2*s + 216*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r**2 + 1152*D1*Dd*f*fd*g2*r*s - 720*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 720*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 + 144*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r*s - 216*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 216*D1*Ddd*f**2*g2*s + 108*D1*Ddd*f**2*g2 + 2*D1*bd1*(-42*D1*bd2*f*(r + s - 1)**2 + D1*(-f**3*(52*r**2 + 2*r*(52*s - 31) + 52*s**2 - 62*s + 31) + f**2*(-7*C*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) + 18*K*r**2 + 36*K*r*s - 36*K*r + 18*K*s**2 - 36*K*s + 18*K + 10*fd*(21*r**2 + 42*r*s - 29*r + 21*s**2 - 29*s + 8) + 6*r**2 + 12*r*s - 26*r + 6*s**2 - 26*s + 13) - 2*f*(9*fd*(K - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*g2*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) - 7*gd2*(5*r**2 + r*(10*s - 11) + 5*s**2 - 11*s + 6)) + 70*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(4*r + 4*s - 3)*(5*f**2*(7*r + 7*s - 4) - 9*f*(K - 2)*(r + s - 1) + 7*g2*(5*r + 5*s - 6))) + 432*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r*s - 648*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 648*Dd**2*f**2*g2*s + 216*Dd**2*f**2*g2 + 7*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (5*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-5*K + 6*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 6*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(70*C*D1**2*fd*r**2 + 140*C*D1**2*fd*r*s - 140*C*D1**2*fd*r + 70*C*D1**2*fd*s**2 - 140*C*D1**2*fd*s + 70*C*D1**2*fd + 280*C*D1*Dd*f*r**2 + 560*C*D1*Dd*f*r*s - 420*C*D1*Dd*f*r + 280*C*D1*Dd*f*s**2 - 420*C*D1*Dd*f*s + 210*C*D1*Dd*f + 70*D1**2*K*fd*r**2 + 140*D1**2*K*fd*r*s + 28*D1**2*K*fd*r + 70*D1**2*K*fd*s**2 + 28*D1**2*K*fd*s - 14*D1**2*K*fd - 35*D1**2*K*fdd*r**2 - 70*D1**2*K*fdd*r*s - 14*D1**2*K*fdd*r - 35*D1**2*K*fdd*s**2 - 14*D1**2*K*fdd*s + 7*D1**2*K*fdd - 7*D1**2*bdd1*(-5*K + 6*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 324*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 324*D1**2*f*fd*s - 162*D1**2*f*fd + 216*D1**2*f*fdd*r**2 + 432*D1**2*f*fdd*r*s - 288*D1**2*f*fdd*r + 216*D1**2*f*fdd*s**2 - 288*D1**2*f*fdd*s + 144*D1**2*f*fdd + 216*D1**2*fd**2*r**2 + 432*D1**2*fd**2*r*s - 288*D1**2*fd**2*r + 216*D1**2*fd**2*s**2 - 288*D1**2*fd**2*s + 72*D1**2*fd**2 - 154*D1**2*fd*r**2 - 308*D1**2*fd*r*s + 112*D1**2*fd*r - 154*D1**2*fd*s**2 + 112*D1**2*fd*s - 56*D1**2*fd + 77*D1**2*fdd*r**2 + 154*D1**2*fdd*r*s + 14*D1**2*fdd*r + 77*D1**2*fdd*s**2 + 14*D1**2*fdd*s - 7*D1**2*fdd + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 + 280*D1*Dd*K*f*r**2 + 560*D1*Dd*K*f*r*s - 420*D1*Dd*K*f*r + 280*D1*Dd*K*f*s**2 - 420*D1*Dd*K*f*s + 210*D1*Dd*K*f - 280*D1*Dd*K*fd*r**2 - 560*D1*Dd*K*fd*r*s + 154*D1*Dd*K*fd*r - 280*D1*Dd*K*fd*s**2 + 154*D1*Dd*K*fd*s + 42*D1*Dd*K*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 1728*D1*Dd*f*fd*r**2 + 3456*D1*Dd*f*fd*r*s - 2448*D1*Dd*f*fd*r + 1728*D1*Dd*f*fd*s**2 - 2448*D1*Dd*f*fd*s + 864*D1*Dd*f*fd - 616*D1*Dd*f*r**2 - 1232*D1*Dd*f*r*s + 924*D1*Dd*f*r - 616*D1*Dd*f*s**2 + 924*D1*Dd*f*s - 462*D1*Dd*f + 616*D1*Dd*fd*r**2 + 1232*D1*Dd*fd*r*s - 406*D1*Dd*fd*r + 616*D1*Dd*fd*s**2 - 406*D1*Dd*fd*s - 42*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 - 140*D1*Ddd*K*f*r**2 - 280*D1*Ddd*K*f*r*s + 210*D1*Ddd*K*f*r - 140*D1*Ddd*K*f*s**2 + 210*D1*Ddd*K*f*s - 105*D1*Ddd*K*f + 432*D1*Ddd*f**2*r**2 + 864*D1*Ddd*f**2*r*s - 648*D1*Ddd*f**2*r + 432*D1*Ddd*f**2*s**2 - 648*D1*Ddd*f**2*s + 324*D1*Ddd*f**2 + 308*D1*Ddd*f*r**2 + 616*D1*Ddd*f*r*s - 462*D1*Ddd*f*r + 308*D1*Ddd*f*s**2 - 462*D1*Ddd*f*s + 231*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 14*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (5*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-5*K + 6*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 420*Dd**2*K*f*r**2 - 840*Dd**2*K*f*r*s + 630*Dd**2*K*f*r - 420*Dd**2*K*f*s**2 + 630*Dd**2*K*f*s - 210*Dd**2*K*f + 1296*Dd**2*f**2*r**2 + 2592*Dd**2*f**2*r*s - 1944*Dd**2*f**2*r + 1296*Dd**2*f**2*s**2 - 1944*Dd**2*f**2*s + 648*Dd**2*f**2 + 924*Dd**2*f*r**2 + 1848*Dd**2*f*r*s - 1386*Dd**2*f*r + 924*Dd**2*f*s**2 - 1386*Dd**2*f*s + 462*Dd**2*f - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) + b1*(-140*C*D1**2*f*fd*r**2 - 280*C*D1**2*f*fd*r*s + 112*C*D1**2*f*fd*r - 140*C*D1**2*f*fd*s**2 + 112*C*D1**2*f*fd*s - 56*C*D1**2*f*fd - 280*C*D1*Dd*f**2*r**2 - 560*C*D1*Dd*f**2*r*s + 420*C*D1*Dd*f**2*r - 280*C*D1*Dd*f**2*s**2 + 420*C*D1*Dd*f**2*s - 210*C*D1*Dd*f**2 - 70*D1**2*K*bdd1*f*r**2 - 140*D1**2*K*bdd1*f*r*s + 154*D1**2*K*bdd1*f*r - 70*D1**2*K*bdd1*f*s**2 + 154*D1**2*K*bdd1*f*s - 77*D1**2*K*bdd1*f + 72*D1**2*K*f*fd*r**2 + 144*D1**2*K*f*fd*r*s - 72*D1**2*K*f*fd*r + 72*D1**2*K*f*fd*s**2 - 72*D1**2*K*f*fd*s + 36*D1**2*K*f*fd - 36*D1**2*K*f*fdd*r**2 - 72*D1**2*K*f*fdd*r*s + 36*D1**2*K*f*fdd*r - 36*D1**2*K*f*fdd*s**2 + 36*D1**2*K*f*fdd*s - 18*D1**2*K*f*fdd - 36*D1**2*K*fd**2*r**2 - 72*D1**2*K*fd**2*r*s + 36*D1**2*K*fd**2*r - 36*D1**2*K*fd**2*s**2 + 36*D1**2*K*fd**2*s + 84*D1**2*b2*fd*r**2 + 168*D1**2*b2*fd*r*s + 84*D1**2*b2*fd*s**2 - 42*D1**2*b2*fdd*r**2 - 84*D1**2*b2*fdd*r*s - 42*D1**2*b2*fdd*s**2 - 14*D1**2*bd1**2*(-5*K + 6*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 216*D1**2*bdd1*f**2*r**2 + 432*D1**2*bdd1*f**2*r*s - 360*D1**2*bdd1*f**2*r + 216*D1**2*bdd1*f**2*s**2 - 360*D1**2*bdd1*f**2*s + 180*D1**2*bdd1*f**2 + 154*D1**2*bdd1*f*r**2 + 308*D1**2*bdd1*f*r*s - 322*D1**2*bdd1*f*r + 154*D1**2*bdd1*f*s**2 - 322*D1**2*bdd1*f*s + 161*D1**2*bdd1*f - 140*D1**2*bdd1*g2*r**2 - 280*D1**2*bdd1*g2*r*s + 140*D1**2*bdd1*g2*r - 140*D1**2*bdd1*g2*s**2 + 140*D1**2*bdd1*g2*s - 70*D1**2*bdd1*g2 - 42*D1**2*bdd2*f*r**2 - 84*D1**2*bdd2*f*r*s + 84*D1**2*bdd2*f*r - 42*D1**2*bdd2*f*s**2 + 84*D1**2*bdd2*f*s - 42*D1**2*bdd2*f - 312*D1**2*f**2*fd*r**2 - 624*D1**2*f**2*fd*r*s + 500*D1**2*f**2*fd*r - 312*D1**2*f**2*fd*s**2 + 500*D1**2*f**2*fd*s - 250*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r**2 + 420*D1**2*f**2*fdd*r*s - 340*D1**2*f**2*fdd*r + 210*D1**2*f**2*fdd*s**2 - 340*D1**2*f**2*fdd*s + 170*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r**2 + 840*D1**2*f*fd**2*r*s - 680*D1**2*f*fd**2*r + 420*D1**2*f*fd**2*s**2 - 680*D1**2*f*fd**2*s + 260*D1**2*f*fd**2 + 24*D1**2*f*fd*r**2 + 48*D1**2*f*fd*r*s + 4*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 2*D1**2*f*fd + 72*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*r + 72*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 36*D1**2*f*fdd - 140*D1**2*f*gd2*r**2 - 280*D1**2*f*gd2*r*s + 280*D1**2*f*gd2*r - 140*D1**2*f*gd2*s**2 + 280*D1**2*f*gd2*s - 140*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 140*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*r + 70*D1**2*f*gdd2*s**2 - 140*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 + 72*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s - 72*D1**2*fd**2*r + 72*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s - 140*D1**2*fd*g2*r**2 - 280*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r - 140*D1**2*fd*g2*s**2 - 56*D1**2*fd*g2*s + 28*D1**2*fd*g2 + 140*D1**2*fd*gd2*r**2 + 280*D1**2*fd*gd2*r*s - 112*D1**2*fd*gd2*r + 140*D1**2*fd*gd2*s**2 - 112*D1**2*fd*gd2*s - 28*D1**2*fd*gd2 + 70*D1**2*fdd*g2*r**2 + 140*D1**2*fdd*g2*r*s + 28*D1**2*fdd*g2*r + 70*D1**2*fdd*g2*s**2 + 28*D1**2*fdd*g2*s - 14*D1**2*fdd*g2 + 144*D1*Dd*K*f**2*r**2 + 288*D1*Dd*K*f**2*r*s - 216*D1*Dd*K*f**2*r + 144*D1*Dd*K*f**2*s**2 - 216*D1*Dd*K*f**2*s + 108*D1*Dd*K*f**2 - 288*D1*Dd*K*f*fd*r**2 - 576*D1*Dd*K*f*fd*r*s + 360*D1*Dd*K*f*fd*r - 288*D1*Dd*K*f*fd*s**2 + 360*D1*Dd*K*f*fd*s - 108*D1*Dd*K*f*fd + 336*D1*Dd*b2*f*r**2 + 672*D1*Dd*b2*f*r*s - 504*D1*Dd*b2*f*r + 336*D1*Dd*b2*f*s**2 - 504*D1*Dd*b2*f*s + 252*D1*Dd*b2*f - 336*D1*Dd*b2*fd*r**2 - 672*D1*Dd*b2*fd*r*s + 252*D1*Dd*b2*fd*r - 336*D1*Dd*b2*fd*s**2 + 252*D1*Dd*b2*fd*s - 416*D1*Dd*f**3*r**2 - 832*D1*Dd*f**3*r*s + 624*D1*Dd*f**3*r - 416*D1*Dd*f**3*s**2 + 624*D1*Dd*f**3*s - 312*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r**2 + 3360*D1*Dd*f**2*fd*r*s - 2620*D1*Dd*f**2*fd*r + 1680*D1*Dd*f**2*fd*s**2 - 2620*D1*Dd*f**2*fd*s + 1020*D1*Dd*f**2*fd + 48*D1*Dd*f**2*r**2 + 96*D1*Dd*f**2*r*s - 72*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 36*D1*Dd*f**2 + 576*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 720*D1*Dd*f*fd*r + 576*D1*Dd*f*fd*s**2 - 720*D1*Dd*f*fd*s + 216*D1*Dd*f*fd - 560*D1*Dd*f*g2*r**2 - 1120*D1*Dd*f*g2*r*s + 840*D1*Dd*f*g2*r - 560*D1*Dd*f*g2*s**2 + 840*D1*Dd*f*g2*s - 420*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 1120*D1*Dd*f*gd2*r*s - 980*D1*Dd*f*gd2*r + 560*D1*Dd*f*gd2*s**2 - 980*D1*Dd*f*gd2*s + 420*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 1120*D1*Dd*fd*g2*r*s - 308*D1*Dd*fd*g2*r + 560*D1*Dd*fd*g2*s**2 - 308*D1*Dd*fd*g2*s - 84*D1*Dd*fd*g2 - 72*D1*Ddd*K*f**2*r**2 - 144*D1*Ddd*K*f**2*r*s + 108*D1*Ddd*K*f**2*r - 72*D1*Ddd*K*f**2*s**2 + 108*D1*Ddd*K*f**2*s - 54*D1*Ddd*K*f**2 - 168*D1*Ddd*b2*f*r**2 - 336*D1*Ddd*b2*f*r*s + 252*D1*Ddd*b2*f*r - 168*D1*Ddd*b2*f*s**2 + 252*D1*Ddd*b2*f*s - 126*D1*Ddd*b2*f + 280*D1*Ddd*f**3*r**2 + 560*D1*Ddd*f**3*r*s - 420*D1*Ddd*f**3*r + 280*D1*Ddd*f**3*s**2 - 420*D1*Ddd*f**3*s + 210*D1*Ddd*f**3 + 144*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 216*D1*Ddd*f**2*r + 144*D1*Ddd*f**2*s**2 - 216*D1*Ddd*f**2*s + 108*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 560*D1*Ddd*f*g2*r*s - 420*D1*Ddd*f*g2*r + 280*D1*Ddd*f*g2*s**2 - 420*D1*Ddd*f*g2*s + 210*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(3*f**2*(44*r**2 + r*(88*s - 78) + 44*s**2 - 78*s + 39) - f*(35*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(10*r**2 + 20*r*s - 22*r + 10*s**2 - 22*s + 11) + 216*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 154*r**2 - 308*r*s + 252*r - 154*s**2 + 252*s - 126) + 7*fd*(r + s - 1)*(10*K*r + 10*K*s + K - 22*r - 22*s - 1) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - Dd*(4*r + 4*s - 3)*(36*f**2*(6*r + 6*s - 5) - 7*f*(K*(10*r + 10*s - 11) - 22*r - 22*s + 23) - 70*g2*(2*r + 2*s - 1))) + 84*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 216*Dd**2*K*f**2*r**2 - 432*Dd**2*K*f**2*r*s + 324*Dd**2*K*f**2*r - 216*Dd**2*K*f**2*s**2 + 324*Dd**2*K*f**2*s - 108*Dd**2*K*f**2 - 504*Dd**2*b2*f*r**2 - 1008*Dd**2*b2*f*r*s + 756*Dd**2*b2*f*r - 504*Dd**2*b2*f*s**2 + 756*Dd**2*b2*f*s - 252*Dd**2*b2*f + 840*Dd**2*f**3*r**2 + 1680*Dd**2*f**3*r*s - 1260*Dd**2*f**3*r + 840*Dd**2*f**3*s**2 - 1260*Dd**2*f**3*s + 420*Dd**2*f**3 + 432*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 648*Dd**2*f**2*r + 432*Dd**2*f**2*s**2 - 648*Dd**2*f**2*s + 216*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 1680*Dd**2*f*g2*r*s - 1260*Dd**2*f*g2*r + 840*Dd**2*f*g2*s**2 - 1260*Dd**2*f*g2*s + 420*Dd**2*f*g2) + 6*b2*(-7*D1**2*bdd1*f*(r + s - 1)**2 + 3*D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 3*D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**2*k2**2*st**2*(-D1*f*(r + s)*(84*D1*bd1**2*(C - 1)*(r + s - 1) + 18*D1*bdd1*f*(C - 1)*(r + s) + bd1*(-D1*f*(36*C - 29)*(r + s) + D1*fd*(72*C - 72)*(r + s - 1) + Dd*f*(36*C - 36)*(4*r + 4*s - 3))) + 7*b1**2*(D1**2*(fd*(12*C - 7) - fdd*(6*C - 6))*(r + s - 1)**2 + D1*(Dd*(f*(12*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(12 - 12*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(6 - 6*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(36*C - 36)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(72*C*D1**2*f*fd*r**2 + 144*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s**2 - 144*C*D1**2*f*fd*s + 72*C*D1**2*f*fd - 36*C*D1**2*f*fdd*r**2 - 72*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*r - 36*C*D1**2*f*fdd*s**2 + 72*C*D1**2*f*fdd*s - 36*C*D1**2*f*fdd - 36*C*D1**2*fd**2*r**2 - 72*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*r - 36*C*D1**2*fd**2*s**2 + 72*C*D1**2*fd**2*s - 36*C*D1**2*fd**2 + 144*C*D1*Dd*f**2*r**2 + 288*C*D1*Dd*f**2*r*s - 216*C*D1*Dd*f**2*r + 144*C*D1*Dd*f**2*s**2 - 216*C*D1*Dd*f**2*s + 108*C*D1*Dd*f**2 - 288*C*D1*Dd*f*fd*r**2 - 576*C*D1*Dd*f*fd*r*s + 504*C*D1*Dd*f*fd*r - 288*C*D1*Dd*f*fd*s**2 + 504*C*D1*Dd*f*fd*s - 216*C*D1*Dd*f*fd - 72*C*D1*Ddd*f**2*r**2 - 144*C*D1*Ddd*f**2*r*s + 108*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 108*C*D1*Ddd*f**2*s - 54*C*D1*Ddd*f**2 - 216*C*Dd**2*f**2*r**2 - 432*C*Dd**2*f**2*r*s + 324*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 324*C*Dd**2*f**2*s - 108*C*Dd**2*f**2 - 42*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 58*D1**2*f*fd*r**2 - 116*D1**2*f*fd*r*s + 116*D1**2*f*fd*r - 58*D1**2*f*fd*s**2 + 116*D1**2*f*fd*s - 58*D1**2*f*fd + 36*D1**2*f*fdd*r**2 + 72*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 36*D1**2*f*fdd + 36*D1**2*fd**2*r**2 + 72*D1**2*fd**2*r*s - 72*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s + 36*D1**2*fd**2 - 116*D1*Dd*f**2*r**2 - 232*D1*Dd*f**2*r*s + 174*D1*Dd*f**2*r - 116*D1*Dd*f**2*s**2 + 174*D1*Dd*f**2*s - 87*D1*Dd*f**2 + 288*D1*Dd*f*fd*r**2 + 576*D1*Dd*f*fd*r*s - 504*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s**2 - 504*D1*Dd*f*fd*s + 216*D1*Dd*f*fd + 72*D1*Ddd*f**2*r**2 + 144*D1*Ddd*f**2*r*s - 108*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 108*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(12*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(12 - 12*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(12 - 12*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 216*Dd**2*f**2*r**2 + 432*Dd**2*f**2*r*s - 324*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 324*Dd**2*f**2*s + 108*Dd**2*f**2))/(105*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct**2*k2**2*(-D1*(r + s)*(-2*D1*bd1**2*(30*f**2 - 21*f*(K - 2) + 70*g2)*(r + s - 1) - 42*D1*bdd1*f*g2*(r + s) + 7*b2*(10*D1*bd1**2*(r + s - 1) + 3*D1*bdd1*f*(r + s) + 6*bd1*(-D1*f*(r + s) + D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + 21*bd1*(2*D1*bd2*f*(r + s - 1) + D1*(-4*f*gd2*(r + s - 1) + f*(r + s)*(f*(2*C - 1) + 4*g2) - 4*fd*g2*(r + s - 1)) - 4*Dd*f*g2*(4*r + 4*s - 3))) - 7*b1**3*(2*D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (5*K + 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-5*K + 6*f + 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 6*f + 10)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-70*C*D1**2*fd*r**2 - 140*C*D1**2*fd*r*s + 140*C*D1**2*fd*r - 70*C*D1**2*fd*s**2 + 140*C*D1**2*fd*s - 70*C*D1**2*fd - 280*C*D1*Dd*f*r**2 - 560*C*D1*Dd*f*r*s + 420*C*D1*Dd*f*r - 280*C*D1*Dd*f*s**2 + 420*C*D1*Dd*f*s - 210*C*D1*Dd*f - 105*D1**2*K*bdd1*r**2 - 210*D1**2*K*bdd1*r*s + 140*D1**2*K*bdd1*r - 105*D1**2*K*bdd1*s**2 + 140*D1**2*K*bdd1*s - 70*D1**2*K*bdd1 + 42*D1**2*K*fd*r**2 + 84*D1**2*K*fd*r*s - 84*D1**2*K*fd*r + 42*D1**2*K*fd*s**2 - 84*D1**2*K*fd*s + 42*D1**2*K*fd - 21*D1**2*K*fdd*r**2 - 42*D1**2*K*fdd*r*s + 42*D1**2*K*fdd*r - 21*D1**2*K*fdd*s**2 + 42*D1**2*K*fdd*s - 21*D1**2*K*fdd + 126*D1**2*bdd1*f*r**2 + 252*D1**2*bdd1*f*r*s - 168*D1**2*bdd1*f*r + 126*D1**2*bdd1*f*s**2 - 168*D1**2*bdd1*f*s + 84*D1**2*bdd1*f + 210*D1**2*bdd1*r**2 + 420*D1**2*bdd1*r*s - 280*D1**2*bdd1*r + 210*D1**2*bdd1*s**2 - 280*D1**2*bdd1*s + 140*D1**2*bdd1 - 35*D1**2*bdd2*r**2 - 70*D1**2*bdd2*r*s + 70*D1**2*bdd2*r - 35*D1**2*bdd2*s**2 + 70*D1**2*bdd2*s - 35*D1**2*bdd2 - 36*D1**2*f*fd*r**2 - 72*D1**2*f*fd*r*s + 72*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 72*D1**2*f*fd*s - 36*D1**2*f*fd + 60*D1**2*f*fdd*r**2 + 120*D1**2*f*fdd*r*s - 120*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 - 120*D1**2*f*fdd*s + 60*D1**2*f*fdd + 60*D1**2*fd**2*r**2 + 120*D1**2*fd**2*r*s - 120*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 120*D1**2*fd**2*s + 60*D1**2*fd**2 + 21*D1**2*fd*r**2 + 42*D1**2*fd*r*s - 42*D1**2*fd*r + 21*D1**2*fd*s**2 - 42*D1**2*fd*s + 21*D1**2*fd + 42*D1**2*fdd*r**2 + 84*D1**2*fdd*r*s - 84*D1**2*fdd*r + 42*D1**2*fdd*s**2 - 84*D1**2*fdd*s + 42*D1**2*fdd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 + 70*D1**2*gdd2*r**2 + 140*D1**2*gdd2*r*s - 140*D1**2*gdd2*r + 70*D1**2*gdd2*s**2 - 140*D1**2*gdd2*s + 70*D1**2*gdd2 + 168*D1*Dd*K*f*r**2 + 336*D1*Dd*K*f*r*s - 252*D1*Dd*K*f*r + 168*D1*Dd*K*f*s**2 - 252*D1*Dd*K*f*s + 126*D1*Dd*K*f - 168*D1*Dd*K*fd*r**2 - 336*D1*Dd*K*fd*r*s + 294*D1*Dd*K*fd*r - 168*D1*Dd*K*fd*s**2 + 294*D1*Dd*K*fd*s - 126*D1*Dd*K*fd + 280*D1*Dd*b2*r**2 + 560*D1*Dd*b2*r*s - 420*D1*Dd*b2*r + 280*D1*Dd*b2*s**2 - 420*D1*Dd*b2*s + 210*D1*Dd*b2 - 72*D1*Dd*f**2*r**2 - 144*D1*Dd*f**2*r*s + 108*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 108*D1*Dd*f**2*s - 54*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 + 960*D1*Dd*f*fd*r*s - 840*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 840*D1*Dd*f*fd*s + 360*D1*Dd*f*fd + 84*D1*Dd*f*r**2 + 168*D1*Dd*f*r*s - 126*D1*Dd*f*r + 84*D1*Dd*f*s**2 - 126*D1*Dd*f*s + 63*D1*Dd*f + 336*D1*Dd*fd*r**2 + 672*D1*Dd*fd*r*s - 588*D1*Dd*fd*r + 336*D1*Dd*fd*s**2 - 588*D1*Dd*fd*s + 252*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 + 1120*D1*Dd*gd2*r*s - 980*D1*Dd*gd2*r + 560*D1*Dd*gd2*s**2 - 980*D1*Dd*gd2*s + 420*D1*Dd*gd2 - 84*D1*Ddd*K*f*r**2 - 168*D1*Ddd*K*f*r*s + 126*D1*Ddd*K*f*r - 84*D1*Ddd*K*f*s**2 + 126*D1*Ddd*K*f*s - 63*D1*Ddd*K*f - 140*D1*Ddd*b2*r**2 - 280*D1*Ddd*b2*r*s + 210*D1*Ddd*b2*r - 140*D1*Ddd*b2*s**2 + 210*D1*Ddd*b2*s - 105*D1*Ddd*b2 + 120*D1*Ddd*f**2*r**2 + 240*D1*Ddd*f**2*r*s - 180*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 180*D1*Ddd*f**2*s + 90*D1*Ddd*f**2 + 168*D1*Ddd*f*r**2 + 336*D1*Ddd*f*r*s - 252*D1*Ddd*f*r + 168*D1*Ddd*f*s**2 - 252*D1*Ddd*f*s + 126*D1*Ddd*f + 280*D1*Ddd*g2*r**2 + 560*D1*Ddd*g2*r*s - 420*D1*Ddd*g2*r + 280*D1*Ddd*g2*s**2 - 420*D1*Ddd*g2*s + 210*D1*Ddd*g2 - 14*D1*bd1*(D1*(f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (5*K + 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-5*K + 6*f + 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 70*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 252*Dd**2*K*f*r**2 - 504*Dd**2*K*f*r*s + 378*Dd**2*K*f*r - 252*Dd**2*K*f*s**2 + 378*Dd**2*K*f*s - 126*Dd**2*K*f - 420*Dd**2*b2*r**2 - 840*Dd**2*b2*r*s + 630*Dd**2*b2*r - 420*Dd**2*b2*s**2 + 630*Dd**2*b2*s - 210*Dd**2*b2 + 360*Dd**2*f**2*r**2 + 720*Dd**2*f**2*r*s - 540*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 540*Dd**2*f**2*s + 180*Dd**2*f**2 + 504*Dd**2*f*r**2 + 1008*Dd**2*f*r*s - 756*Dd**2*f*r + 504*Dd**2*f*s**2 - 756*Dd**2*f*s + 252*Dd**2*f + 840*Dd**2*g2*r**2 + 1680*Dd**2*g2*r*s - 1260*Dd**2*g2*r + 840*Dd**2*g2*s**2 - 1260*Dd**2*g2*s + 420*Dd**2*g2) + b1*(-84*C*D1**2*f*fd*r**2 - 168*C*D1**2*f*fd*r*s + 168*C*D1**2*f*fd*r - 84*C*D1**2*f*fd*s**2 + 168*C*D1**2*f*fd*s - 84*C*D1**2*f*fd - 168*C*D1*Dd*f**2*r**2 - 336*C*D1*Dd*f**2*r*s + 252*C*D1*Dd*f**2*r - 168*C*D1*Dd*f**2*s**2 + 252*C*D1*Dd*f**2*s - 126*C*D1*Dd*f**2 - 42*D1**2*K*bdd1*f*r**2 - 84*D1**2*K*bdd1*f*r*s + 42*D1**2*K*bdd1*f*r - 42*D1**2*K*bdd1*f*s**2 + 42*D1**2*K*bdd1*f*s - 21*D1**2*K*bdd1*f + 14*D1**2*bd1**2*(-5*K + 6*f + 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 42*D1**2*bd2*f*r**2 + 84*D1**2*bd2*f*r*s - 84*D1**2*bd2*f*r + 42*D1**2*bd2*f*s**2 - 84*D1**2*bd2*f*s + 42*D1**2*bd2*f - 42*D1**2*bd2*fd*r**2 - 84*D1**2*bd2*fd*r*s + 84*D1**2*bd2*fd*r - 42*D1**2*bd2*fd*s**2 + 84*D1**2*bd2*fd*s - 42*D1**2*bd2*fd + 60*D1**2*bdd1*f**2*r**2 + 120*D1**2*bdd1*f**2*r*s - 60*D1**2*bdd1*f**2*r + 60*D1**2*bdd1*f**2*s**2 - 60*D1**2*bdd1*f**2*s + 30*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*r**2 + 168*D1**2*bdd1*f*r*s - 84*D1**2*bdd1*f*r + 84*D1**2*bdd1*f*s**2 - 84*D1**2*bdd1*f*s + 42*D1**2*bdd1*f + 140*D1**2*bdd1*g2*r**2 + 280*D1**2*bdd1*g2*r*s - 140*D1**2*bdd1*g2*r + 140*D1**2*bdd1*g2*s**2 - 140*D1**2*bdd1*g2*s + 70*D1**2*bdd1*g2 - 21*D1**2*bdd2*f*r**2 - 42*D1**2*bdd2*f*r*s + 42*D1**2*bdd2*f*r - 21*D1**2*bdd2*f*s**2 + 42*D1**2*bdd2*f*s - 21*D1**2*bdd2*f + 42*D1**2*f*fd*r**2 + 84*D1**2*f*fd*r*s - 84*D1**2*f*fd*r + 42*D1**2*f*fd*s**2 - 84*D1**2*f*fd*s + 42*D1**2*f*fd - 84*D1**2*f*gd2*r**2 - 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*r - 84*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s - 84*D1**2*f*gd2 + 42*D1**2*f*gdd2*r**2 + 84*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*r + 42*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 42*D1**2*f*gdd2 - 84*D1**2*fd*g2*r**2 - 168*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*r - 84*D1**2*fd*g2*s**2 + 168*D1**2*fd*g2*s - 84*D1**2*fd*g2 + 84*D1**2*fd*gd2*r**2 + 168*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*r + 84*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 + 42*D1**2*fdd*g2*r**2 + 84*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r + 42*D1**2*fdd*g2*s**2 - 84*D1**2*fdd*g2*s + 42*D1**2*fdd*g2 - 168*D1*Dd*bd2*f*r**2 - 336*D1*Dd*bd2*f*r*s + 294*D1*Dd*bd2*f*r - 168*D1*Dd*bd2*f*s**2 + 294*D1*Dd*bd2*f*s - 126*D1*Dd*bd2*f + 84*D1*Dd*f**2*r**2 + 168*D1*Dd*f**2*r*s - 126*D1*Dd*f**2*r + 84*D1*Dd*f**2*s**2 - 126*D1*Dd*f**2*s + 63*D1*Dd*f**2 - 336*D1*Dd*f*g2*r**2 - 672*D1*Dd*f*g2*r*s + 504*D1*Dd*f*g2*r - 336*D1*Dd*f*g2*s**2 + 504*D1*Dd*f*g2*s - 252*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 + 672*D1*Dd*f*gd2*r*s - 588*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s**2 - 588*D1*Dd*f*gd2*s + 252*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r**2 + 672*D1*Dd*fd*g2*r*s - 588*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s**2 - 588*D1*Dd*fd*g2*s + 252*D1*Dd*fd*g2 + 168*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r*s - 252*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s**2 - 252*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 + D1*bd1*(-70*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-18*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(-70*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 120*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 3*(14*K + 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) - 42*fd*(K - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 140*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 140*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(30*f**2 - 21*f*(K - 2) + 70*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 504*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r*s - 756*Dd**2*f*g2*r + 504*Dd**2*f*g2*s**2 - 756*Dd**2*f*g2*s + 252*Dd**2*f*g2 + 7*b2*(-5*D1**2*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + 10*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 3*D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(210*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct*f*k2**7*st**6*(-66*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 88*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fd*s**2 + 88*D1**2*b1*f*fd*s - 44*D1**2*b1*f*fd + 33*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*f*fdd*r*s - 44*D1**2*b1*f*fdd*r + 33*D1**2*b1*f*fdd*s**2 - 44*D1**2*b1*f*fdd*s + 22*D1**2*b1*f*fdd + 66*D1**2*b1*fd**2*r**2 + 132*D1**2*b1*fd**2*r*s - 88*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 88*D1**2*b1*fd**2*s + 22*D1**2*b1*fd**2 + 11*D1**2*bdd1*f**2*(r + s - 1)**2 - 24*D1**2*f**2*fd*r**2 - 48*D1**2*f**2*fd*r*s + 36*D1**2*f**2*fd*r - 24*D1**2*f**2*fd*s**2 + 36*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 24*D1**2*f**2*fdd*r*s - 18*D1**2*f**2*fdd*r + 12*D1**2*f**2*fdd*s**2 - 18*D1**2*f**2*fdd*s + 9*D1**2*f**2*fdd + 36*D1**2*f*fd**2*r**2 + 72*D1**2*f*fd**2*r*s - 54*D1**2*f*fd**2*r + 36*D1**2*f*fd**2*s**2 - 54*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 - 88*D1*Dd*b1*f**2*r**2 - 176*D1*Dd*b1*f**2*r*s + 132*D1*Dd*b1*f**2*r - 88*D1*Dd*b1*f**2*s**2 + 132*D1*Dd*b1*f**2*s - 66*D1*Dd*b1*f**2 + 264*D1*Dd*b1*f*fd*r**2 + 528*D1*Dd*b1*f*fd*r*s - 374*D1*Dd*b1*f*fd*r + 264*D1*Dd*b1*f*fd*s**2 - 374*D1*Dd*b1*f*fd*s + 132*D1*Dd*b1*f*fd - 24*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 36*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 192*D1*Dd*f**2*fd*r*s - 144*D1*Dd*f**2*fd*r + 96*D1*Dd*f**2*fd*s**2 - 144*D1*Dd*f**2*fd*s + 54*D1*Dd*f**2*fd + 44*D1*Ddd*b1*f**2*r**2 + 88*D1*Ddd*b1*f**2*r*s - 66*D1*Ddd*b1*f**2*r + 44*D1*Ddd*b1*f**2*s**2 - 66*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*r**2 + 24*D1*Ddd*f**3*r*s - 18*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 18*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 - 22*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + 132*Dd**2*b1*f**2*r**2 + 264*Dd**2*b1*f**2*r*s - 198*Dd**2*b1*f**2*r + 132*Dd**2*b1*f**2*s**2 - 198*Dd**2*b1*f**2*s + 66*Dd**2*b1*f**2 + 36*Dd**2*f**3*r**2 + 72*Dd**2*f**3*r*s - 54*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 54*Dd**2*f**3*s + 18*Dd**2*f**3)/(198*d**2*k1*k3**6) + D1**2*Pk1*Pkdd3*ct*k1**5*k2*st**2*(-168*C*D1**2*b1*f*fd*r**2 - 336*C*D1**2*b1*f*fd*r*s + 168*C*D1**2*b1*f*fd*r - 168*C*D1**2*b1*f*fd*s**2 + 168*C*D1**2*b1*f*fd*s - 84*C*D1**2*b1*f*fd + 504*C*D1**2*b1*f*fdd*r**2 + 1008*C*D1**2*b1*f*fdd*r*s - 504*C*D1**2*b1*f*fdd*r + 504*C*D1**2*b1*f*fdd*s**2 - 504*C*D1**2*b1*f*fdd*s + 252*C*D1**2*b1*f*fdd + 504*C*D1**2*b1*fd**2*r**2 + 1008*C*D1**2*b1*fd**2*r*s - 504*C*D1**2*b1*fd**2*r + 504*C*D1**2*b1*fd**2*s**2 - 504*C*D1**2*b1*fd**2*s - 300*C*D1**2*f**2*fd*r**2 - 600*C*D1**2*f**2*fd*r*s + 400*C*D1**2*f**2*fd*r - 300*C*D1**2*f**2*fd*s**2 + 400*C*D1**2*f**2*fd*s - 200*C*D1**2*f**2*fd + 420*C*D1**2*f**2*fdd*r**2 + 840*C*D1**2*f**2*fdd*r*s - 560*C*D1**2*f**2*fdd*r + 420*C*D1**2*f**2*fdd*s**2 - 560*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 840*C*D1**2*f*fd**2*r**2 + 1680*C*D1**2*f*fd**2*r*s - 1120*C*D1**2*f*fd**2*r + 840*C*D1**2*f*fd**2*s**2 - 1120*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 336*C*D1*Dd*b1*f**2*r**2 - 672*C*D1*Dd*b1*f**2*r*s + 504*C*D1*Dd*b1*f**2*r - 336*C*D1*Dd*b1*f**2*s**2 + 504*C*D1*Dd*b1*f**2*s - 252*C*D1*Dd*b1*f**2 + 4032*C*D1*Dd*b1*f*fd*r**2 + 8064*C*D1*Dd*b1*f*fd*r*s - 5040*C*D1*Dd*b1*f*fd*r + 4032*C*D1*Dd*b1*f*fd*s**2 - 5040*C*D1*Dd*b1*f*fd*s + 1512*C*D1*Dd*b1*f*fd - 400*C*D1*Dd*f**3*r**2 - 800*C*D1*Dd*f**3*r*s + 600*C*D1*Dd*f**3*r - 400*C*D1*Dd*f**3*s**2 + 600*C*D1*Dd*f**3*s - 300*C*D1*Dd*f**3 + 3360*C*D1*Dd*f**2*fd*r**2 + 6720*C*D1*Dd*f**2*fd*r*s - 4760*C*D1*Dd*f**2*fd*r + 3360*C*D1*Dd*f**2*fd*s**2 - 4760*C*D1*Dd*f**2*fd*s + 1680*C*D1*Dd*f**2*fd + 1008*C*D1*Ddd*b1*f**2*r**2 + 2016*C*D1*Ddd*b1*f**2*r*s - 1512*C*D1*Ddd*b1*f**2*r + 1008*C*D1*Ddd*b1*f**2*s**2 - 1512*C*D1*Ddd*b1*f**2*s + 756*C*D1*Ddd*b1*f**2 + 560*C*D1*Ddd*f**3*r**2 + 1120*C*D1*Ddd*f**3*r*s - 840*C*D1*Ddd*f**3*r + 560*C*D1*Ddd*f**3*s**2 - 840*C*D1*Ddd*f**3*s + 420*C*D1*Ddd*f**3 + 3024*C*Dd**2*b1*f**2*r**2 + 6048*C*Dd**2*b1*f**2*r*s - 4536*C*Dd**2*b1*f**2*r + 3024*C*Dd**2*b1*f**2*s**2 - 4536*C*Dd**2*b1*f**2*s + 1512*C*Dd**2*b1*f**2 + 1680*C*Dd**2*f**3*r**2 + 3360*C*Dd**2*f**3*r*s - 2520*C*Dd**2*f**3*r + 1680*C*Dd**2*f**3*s**2 - 2520*C*Dd**2*f**3*s + 840*C*Dd**2*f**3 + 78*D1**2*b1*f*fd*r**2 + 156*D1**2*b1*f*fd*r*s - 78*D1**2*b1*f*fd*r + 78*D1**2*b1*f*fd*s**2 - 78*D1**2*b1*f*fd*s + 39*D1**2*b1*f*fd - 270*D1**2*b1*f*fdd*r**2 - 540*D1**2*b1*f*fdd*r*s + 270*D1**2*b1*f*fdd*r - 270*D1**2*b1*f*fdd*s**2 + 270*D1**2*b1*f*fdd*s - 135*D1**2*b1*f*fdd - 270*D1**2*b1*fd**2*r**2 - 540*D1**2*b1*fd**2*r*s + 270*D1**2*b1*fd**2*r - 270*D1**2*b1*fd**2*s**2 + 270*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(28*C - 15)*(r + s - 1)**2 + 153*D1**2*f**2*fd*r**2 + 306*D1**2*f**2*fd*r*s - 204*D1**2*f**2*fd*r + 153*D1**2*f**2*fd*s**2 - 204*D1**2*f**2*fd*s + 102*D1**2*f**2*fd - 225*D1**2*f**2*fdd*r**2 - 450*D1**2*f**2*fdd*r*s + 300*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 300*D1**2*f**2*fdd*s - 150*D1**2*f**2*fdd - 450*D1**2*f*fd**2*r**2 - 900*D1**2*f*fd**2*r*s + 600*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 600*D1**2*f*fd**2*s - 150*D1**2*f*fd**2 + 156*D1*Dd*b1*f**2*r**2 + 312*D1*Dd*b1*f**2*r*s - 234*D1*Dd*b1*f**2*r + 156*D1*Dd*b1*f**2*s**2 - 234*D1*Dd*b1*f**2*s + 117*D1*Dd*b1*f**2 - 2160*D1*Dd*b1*f*fd*r**2 - 4320*D1*Dd*b1*f*fd*r*s + 2700*D1*Dd*b1*f*fd*r - 2160*D1*Dd*b1*f*fd*s**2 + 2700*D1*Dd*b1*f*fd*s - 810*D1*Dd*b1*f*fd + 204*D1*Dd*f**3*r**2 + 408*D1*Dd*f**3*r*s - 306*D1*Dd*f**3*r + 204*D1*Dd*f**3*s**2 - 306*D1*Dd*f**3*s + 153*D1*Dd*f**3 - 1800*D1*Dd*f**2*fd*r**2 - 3600*D1*Dd*f**2*fd*r*s + 2550*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 2550*D1*Dd*f**2*fd*s - 900*D1*Dd*f**2*fd - 540*D1*Ddd*b1*f**2*r**2 - 1080*D1*Ddd*b1*f**2*r*s + 810*D1*Ddd*b1*f**2*r - 540*D1*Ddd*b1*f**2*s**2 + 810*D1*Ddd*b1*f**2*s - 405*D1*Ddd*b1*f**2 - 300*D1*Ddd*f**3*r**2 - 600*D1*Ddd*f**3*r*s + 450*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 450*D1*Ddd*f**3*s - 225*D1*Ddd*f**3 - 3*D1*bd1*f*(r + s - 1)*(D1*f*(28*C - 13)*(r + s - 1) - D1*fd*(168*C - 90)*(2*r + 2*s - 1) - Dd*f*(168*C - 90)*(4*r + 4*s - 3)) - 1620*Dd**2*b1*f**2*r**2 - 3240*Dd**2*b1*f**2*r*s + 2430*Dd**2*b1*f**2*r - 1620*Dd**2*b1*f**2*s**2 + 2430*Dd**2*b1*f**2*s - 810*Dd**2*b1*f**2 - 900*Dd**2*f**3*r**2 - 1800*Dd**2*f**3*r*s + 1350*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 1350*Dd**2*f**3*s - 450*Dd**2*f**3)/(630*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct*k1**5*k2*(-270*D1**2*K*bdd1*f**2*r**2 - 540*D1**2*K*bdd1*f**2*r*s + 540*D1**2*K*bdd1*f**2*r - 270*D1**2*K*bdd1*f**2*s**2 + 540*D1**2*K*bdd1*f**2*s - 270*D1**2*K*bdd1*f**2 + 18*D1**2*bd1**2*f*(-42*K + 5*f + 7)*(r + s - 1)**2 + 35*D1**2*bdd1*f**3*r**2 + 70*D1**2*bdd1*f**3*r*s - 70*D1**2*bdd1*f**3*r + 35*D1**2*bdd1*f**3*s**2 - 70*D1**2*bdd1*f**3*s + 35*D1**2*bdd1*f**3 + 45*D1**2*bdd1*f**2*r**2 + 90*D1**2*bdd1*f**2*r*s - 90*D1**2*bdd1*f**2*r + 45*D1**2*bdd1*f**2*s**2 - 90*D1**2*bdd1*f**2*s + 45*D1**2*bdd1*f**2 + 756*D1**2*bdd1*f*g2*r**2 + 1512*D1**2*bdd1*f*g2*r*s - 1512*D1**2*bdd1*f*g2*r + 756*D1**2*bdd1*f*g2*s**2 - 1512*D1**2*bdd1*f*g2*s + 756*D1**2*bdd1*f*g2 - 324*D1**2*f**2*gd2*r**2 - 648*D1**2*f**2*gd2*r*s + 648*D1**2*f**2*gd2*r - 324*D1**2*f**2*gd2*s**2 + 648*D1**2*f**2*gd2*s - 324*D1**2*f**2*gd2 + 540*D1**2*f**2*gdd2*r**2 + 1080*D1**2*f**2*gdd2*r*s - 1080*D1**2*f**2*gdd2*r + 540*D1**2*f**2*gdd2*s**2 - 1080*D1**2*f**2*gdd2*s + 540*D1**2*f**2*gdd2 - 648*D1**2*f*fd*g2*r**2 - 1296*D1**2*f*fd*g2*r*s + 648*D1**2*f*fd*g2*r - 648*D1**2*f*fd*g2*s**2 + 648*D1**2*f*fd*g2*s - 324*D1**2*f*fd*g2 + 2160*D1**2*f*fd*gd2*r**2 + 4320*D1**2*f*fd*gd2*r*s - 3240*D1**2*f*fd*gd2*r + 2160*D1**2*f*fd*gd2*s**2 - 3240*D1**2*f*fd*gd2*s + 1080*D1**2*f*fd*gd2 + 1080*D1**2*f*fdd*g2*r**2 + 2160*D1**2*f*fdd*g2*r*s - 1080*D1**2*f*fdd*g2*r + 1080*D1**2*f*fdd*g2*s**2 - 1080*D1**2*f*fdd*g2*s + 540*D1**2*f*fdd*g2 + 1080*D1**2*fd**2*g2*r**2 + 2160*D1**2*fd**2*g2*r*s - 1080*D1**2*fd**2*g2*r + 1080*D1**2*fd**2*g2*s**2 - 1080*D1**2*fd**2*g2*s - 1296*D1*Dd*f**2*g2*r**2 - 2592*D1*Dd*f**2*g2*r*s + 1944*D1*Dd*f**2*g2*r - 1296*D1*Dd*f**2*g2*s**2 + 1944*D1*Dd*f**2*g2*s - 972*D1*Dd*f**2*g2 + 4320*D1*Dd*f**2*gd2*r**2 + 8640*D1*Dd*f**2*gd2*r*s - 7560*D1*Dd*f**2*gd2*r + 4320*D1*Dd*f**2*gd2*s**2 - 7560*D1*Dd*f**2*gd2*s + 3240*D1*Dd*f**2*gd2 + 8640*D1*Dd*f*fd*g2*r**2 + 17280*D1*Dd*f*fd*g2*r*s - 10800*D1*Dd*f*fd*g2*r + 8640*D1*Dd*f*fd*g2*s**2 - 10800*D1*Dd*f*fd*g2*s + 3240*D1*Dd*f*fd*g2 + 2160*D1*Ddd*f**2*g2*r**2 + 4320*D1*Ddd*f**2*g2*r*s - 3240*D1*Ddd*f**2*g2*r + 2160*D1*Ddd*f**2*g2*s**2 - 3240*D1*Ddd*f**2*g2*s + 1620*D1*Ddd*f**2*g2 - D1*bd1*(D1*(25*f**3*(r + s - 1) + f**2*(-70*fd*(3*r + 3*s - 2) + (27 - 162*K)*(r + s - 1)) + 18*f*(5*fd*(6*K - 1)*(2*r + 2*s - 1) + (14*g2 - 84*gd2)*(r + s - 1)) - 1512*fd*g2*(r + s)) - 2*Dd*f*(35*f**2 - 45*f*(6*K - 1) + 756*g2)*(4*r + 4*s - 3))*(r + s - 1) + 6480*Dd**2*f**2*g2*r**2 + 12960*Dd**2*f**2*g2*r*s - 9720*Dd**2*f**2*g2*r + 6480*Dd**2*f**2*g2*s**2 - 9720*Dd**2*f**2*g2*s + 3240*Dd**2*f**2*g2 - 3*b1**2*(D1**2*(3*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(30*fd**2*(r + s - 1) + 7*fd*(6*K - 1)*(r + s) - 21*fdd*(6*K - 1)*(r + s))) + D1*(Dd*(9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(30*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (42*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(6*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-42*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-42*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(324*D1**2*K*f*fd*r**2 + 648*D1**2*K*f*fd*r*s - 324*D1**2*K*f*fd*r + 324*D1**2*K*f*fd*s**2 - 324*D1**2*K*f*fd*s + 162*D1**2*K*f*fd - 540*D1**2*K*f*fdd*r**2 - 1080*D1**2*K*f*fdd*r*s + 540*D1**2*K*f*fdd*r - 540*D1**2*K*f*fdd*s**2 + 540*D1**2*K*f*fdd*s - 270*D1**2*K*f*fdd - 540*D1**2*K*fd**2*r**2 - 1080*D1**2*K*fd**2*r*s + 540*D1**2*K*fd**2*r - 540*D1**2*K*fd**2*s**2 + 540*D1**2*K*fd**2*s + 18*D1**2*bdd1*f*(-42*K + 5*f + 7)*(r + s - 1)**2 - 75*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 + 210*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 70*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 + 420*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s + 70*D1**2*f*fd**2 - 54*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 54*D1**2*f*fd*r - 54*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 180*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 90*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 45*D1**2*f*fdd - 252*D1**2*f*gd2*r**2 - 504*D1**2*f*gd2*r*s + 504*D1**2*f*gd2*r - 252*D1**2*f*gd2*s**2 + 504*D1**2*f*gd2*s - 252*D1**2*f*gd2 + 756*D1**2*f*gdd2*r**2 + 1512*D1**2*f*gdd2*r*s - 1512*D1**2*f*gdd2*r + 756*D1**2*f*gdd2*s**2 - 1512*D1**2*f*gdd2*s + 756*D1**2*f*gdd2 + 90*D1**2*fd**2*r**2 + 180*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 90*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 252*D1**2*fd*g2*r**2 - 504*D1**2*fd*g2*r*s - 252*D1**2*fd*g2*s**2 + 1512*D1**2*fd*gd2*r**2 + 3024*D1**2*fd*gd2*r*s - 1512*D1**2*fd*gd2*r + 1512*D1**2*fd*gd2*s**2 - 1512*D1**2*fd*gd2*s + 756*D1**2*fdd*g2*r**2 + 1512*D1**2*fdd*g2*r*s + 756*D1**2*fdd*g2*s**2 + 648*D1*Dd*K*f**2*r**2 + 1296*D1*Dd*K*f**2*r*s - 972*D1*Dd*K*f**2*r + 648*D1*Dd*K*f**2*s**2 - 972*D1*Dd*K*f**2*s + 486*D1*Dd*K*f**2 - 4320*D1*Dd*K*f*fd*r**2 - 8640*D1*Dd*K*f*fd*r*s + 5400*D1*Dd*K*f*fd*r - 4320*D1*Dd*K*f*fd*s**2 + 5400*D1*Dd*K*f*fd*s - 1620*D1*Dd*K*f*fd - 100*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 75*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 + 1680*D1*Dd*f**2*fd*r*s - 1190*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 1190*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 162*D1*Dd*f**2*r - 108*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1440*D1*Dd*f*fd*r*s - 900*D1*Dd*f*fd*r + 720*D1*Dd*f*fd*s**2 - 900*D1*Dd*f*fd*s + 270*D1*Dd*f*fd - 1008*D1*Dd*f*g2*r**2 - 2016*D1*Dd*f*g2*r*s + 1512*D1*Dd*f*g2*r - 1008*D1*Dd*f*g2*s**2 + 1512*D1*Dd*f*g2*s - 756*D1*Dd*f*g2 + 6048*D1*Dd*f*gd2*r**2 + 12096*D1*Dd*f*gd2*r*s - 10584*D1*Dd*f*gd2*r + 6048*D1*Dd*f*gd2*s**2 - 10584*D1*Dd*f*gd2*s + 4536*D1*Dd*f*gd2 + 6048*D1*Dd*fd*g2*r**2 + 12096*D1*Dd*fd*g2*r*s - 4536*D1*Dd*fd*g2*r + 6048*D1*Dd*fd*g2*s**2 - 4536*D1*Dd*fd*g2*s - 1080*D1*Ddd*K*f**2*r**2 - 2160*D1*Ddd*K*f**2*r*s + 1620*D1*Ddd*K*f**2*r - 1080*D1*Ddd*K*f**2*s**2 + 1620*D1*Ddd*K*f**2*s - 810*D1*Ddd*K*f**2 + 140*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r*s - 210*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 210*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 + 360*D1*Ddd*f**2*r*s - 270*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s**2 - 270*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 + 3024*D1*Ddd*f*g2*r**2 + 6048*D1*Ddd*f*g2*r*s - 4536*D1*Ddd*f*g2*r + 3024*D1*Ddd*f*g2*s**2 - 4536*D1*Ddd*f*g2*s + 2268*D1*Ddd*f*g2 - 6*D1*bd1*(D1*(9*f**2*(r + s - 1) - 30*f*fd*(2*r + 2*s - 1) - 7*f*(6*K - 1)*(r + s - 1) + 42*fd*(6*K - 1)*(r + s)) - 6*Dd*f*(-42*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) - 3240*Dd**2*K*f**2*r**2 - 6480*Dd**2*K*f**2*r*s + 4860*Dd**2*K*f**2*r - 3240*Dd**2*K*f**2*s**2 + 4860*Dd**2*K*f**2*s - 1620*Dd**2*K*f**2 + 420*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r*s - 630*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 630*Dd**2*f**3*s + 210*Dd**2*f**3 + 540*Dd**2*f**2*r**2 + 1080*Dd**2*f**2*r*s - 810*Dd**2*f**2*r + 540*Dd**2*f**2*s**2 - 810*Dd**2*f**2*s + 270*Dd**2*f**2 + 9072*Dd**2*f*g2*r**2 + 18144*Dd**2*f*g2*r*s - 13608*Dd**2*f*g2*r + 9072*Dd**2*f*g2*s**2 - 13608*Dd**2*f*g2*s + 4536*Dd**2*f*g2))/(630*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct*k1**3*k2**3*st**4*(-432*C*D1**2*b1*f*fd*r**2 - 864*C*D1**2*b1*f*fd*r*s + 432*C*D1**2*b1*f*fd*r - 432*C*D1**2*b1*f*fd*s**2 + 432*C*D1**2*b1*f*fd*s - 216*C*D1**2*b1*f*fd + 384*C*D1**2*b1*f*fdd*r**2 + 768*C*D1**2*b1*f*fdd*r*s - 384*C*D1**2*b1*f*fdd*r + 384*C*D1**2*b1*f*fdd*s**2 - 384*C*D1**2*b1*f*fdd*s + 192*C*D1**2*b1*f*fdd + 384*C*D1**2*b1*fd**2*r**2 + 768*C*D1**2*b1*fd**2*r*s - 384*C*D1**2*b1*fd**2*r + 384*C*D1**2*b1*fd**2*s**2 - 384*C*D1**2*b1*fd**2*s - 312*C*D1**2*f**2*fd*r**2 - 624*C*D1**2*f**2*fd*r*s + 416*C*D1**2*f**2*fd*r - 312*C*D1**2*f**2*fd*s**2 + 416*C*D1**2*f**2*fd*s - 208*C*D1**2*f**2*fd + 192*C*D1**2*f**2*fdd*r**2 + 384*C*D1**2*f**2*fdd*r*s - 256*C*D1**2*f**2*fdd*r + 192*C*D1**2*f**2*fdd*s**2 - 256*C*D1**2*f**2*fdd*s + 128*C*D1**2*f**2*fdd + 384*C*D1**2*f*fd**2*r**2 + 768*C*D1**2*f*fd**2*r*s - 512*C*D1**2*f*fd**2*r + 384*C*D1**2*f*fd**2*s**2 - 512*C*D1**2*f*fd**2*s + 128*C*D1**2*f*fd**2 - 864*C*D1*Dd*b1*f**2*r**2 - 1728*C*D1*Dd*b1*f**2*r*s + 1296*C*D1*Dd*b1*f**2*r - 864*C*D1*Dd*b1*f**2*s**2 + 1296*C*D1*Dd*b1*f**2*s - 648*C*D1*Dd*b1*f**2 + 3072*C*D1*Dd*b1*f*fd*r**2 + 6144*C*D1*Dd*b1*f*fd*r*s - 3840*C*D1*Dd*b1*f*fd*r + 3072*C*D1*Dd*b1*f*fd*s**2 - 3840*C*D1*Dd*b1*f*fd*s + 1152*C*D1*Dd*b1*f*fd - 416*C*D1*Dd*f**3*r**2 - 832*C*D1*Dd*f**3*r*s + 624*C*D1*Dd*f**3*r - 416*C*D1*Dd*f**3*s**2 + 624*C*D1*Dd*f**3*s - 312*C*D1*Dd*f**3 + 1536*C*D1*Dd*f**2*fd*r**2 + 3072*C*D1*Dd*f**2*fd*r*s - 2176*C*D1*Dd*f**2*fd*r + 1536*C*D1*Dd*f**2*fd*s**2 - 2176*C*D1*Dd*f**2*fd*s + 768*C*D1*Dd*f**2*fd + 768*C*D1*Ddd*b1*f**2*r**2 + 1536*C*D1*Ddd*b1*f**2*r*s - 1152*C*D1*Ddd*b1*f**2*r + 768*C*D1*Ddd*b1*f**2*s**2 - 1152*C*D1*Ddd*b1*f**2*s + 576*C*D1*Ddd*b1*f**2 + 256*C*D1*Ddd*f**3*r**2 + 512*C*D1*Ddd*f**3*r*s - 384*C*D1*Ddd*f**3*r + 256*C*D1*Ddd*f**3*s**2 - 384*C*D1*Ddd*f**3*s + 192*C*D1*Ddd*f**3 + 2304*C*Dd**2*b1*f**2*r**2 + 4608*C*Dd**2*b1*f**2*r*s - 3456*C*Dd**2*b1*f**2*r + 2304*C*Dd**2*b1*f**2*s**2 - 3456*C*Dd**2*b1*f**2*s + 1152*C*Dd**2*b1*f**2 + 768*C*Dd**2*f**3*r**2 + 1536*C*Dd**2*f**3*r*s - 1152*C*Dd**2*f**3*r + 768*C*Dd**2*f**3*s**2 - 1152*C*Dd**2*f**3*s + 384*C*Dd**2*f**3 + 246*D1**2*b1*f*fd*r**2 + 492*D1**2*b1*f*fd*r*s - 246*D1**2*b1*f*fd*r + 246*D1**2*b1*f*fd*s**2 - 246*D1**2*b1*f*fd*s + 123*D1**2*b1*f*fd - 228*D1**2*b1*f*fdd*r**2 - 456*D1**2*b1*f*fdd*r*s + 228*D1**2*b1*f*fdd*r - 228*D1**2*b1*f*fdd*s**2 + 228*D1**2*b1*f*fdd*s - 114*D1**2*b1*f*fdd - 228*D1**2*b1*fd**2*r**2 - 456*D1**2*b1*fd**2*r*s + 228*D1**2*b1*fd**2*r - 228*D1**2*b1*fd**2*s**2 + 228*D1**2*b1*fd**2*s + 6*D1**2*bdd1*f**2*(32*C - 19)*(r + s - 1)**2 + 183*D1**2*f**2*fd*r**2 + 366*D1**2*f**2*fd*r*s - 244*D1**2*f**2*fd*r + 183*D1**2*f**2*fd*s**2 - 244*D1**2*f**2*fd*s + 122*D1**2*f**2*fd - 114*D1**2*f**2*fdd*r**2 - 228*D1**2*f**2*fdd*r*s + 152*D1**2*f**2*fdd*r - 114*D1**2*f**2*fdd*s**2 + 152*D1**2*f**2*fdd*s - 76*D1**2*f**2*fdd - 228*D1**2*f*fd**2*r**2 - 456*D1**2*f*fd**2*r*s + 304*D1**2*f*fd**2*r - 228*D1**2*f*fd**2*s**2 + 304*D1**2*f*fd**2*s - 76*D1**2*f*fd**2 + 492*D1*Dd*b1*f**2*r**2 + 984*D1*Dd*b1*f**2*r*s - 738*D1*Dd*b1*f**2*r + 492*D1*Dd*b1*f**2*s**2 - 738*D1*Dd*b1*f**2*s + 369*D1*Dd*b1*f**2 - 1824*D1*Dd*b1*f*fd*r**2 - 3648*D1*Dd*b1*f*fd*r*s + 2280*D1*Dd*b1*f*fd*r - 1824*D1*Dd*b1*f*fd*s**2 + 2280*D1*Dd*b1*f*fd*s - 684*D1*Dd*b1*f*fd + 244*D1*Dd*f**3*r**2 + 488*D1*Dd*f**3*r*s - 366*D1*Dd*f**3*r + 244*D1*Dd*f**3*s**2 - 366*D1*Dd*f**3*s + 183*D1*Dd*f**3 - 912*D1*Dd*f**2*fd*r**2 - 1824*D1*Dd*f**2*fd*r*s + 1292*D1*Dd*f**2*fd*r - 912*D1*Dd*f**2*fd*s**2 + 1292*D1*Dd*f**2*fd*s - 456*D1*Dd*f**2*fd - 456*D1*Ddd*b1*f**2*r**2 - 912*D1*Ddd*b1*f**2*r*s + 684*D1*Ddd*b1*f**2*r - 456*D1*Ddd*b1*f**2*s**2 + 684*D1*Ddd*b1*f**2*s - 342*D1*Ddd*b1*f**2 - 152*D1*Ddd*f**3*r**2 - 304*D1*Ddd*f**3*r*s + 228*D1*Ddd*f**3*r - 152*D1*Ddd*f**3*s**2 + 228*D1*Ddd*f**3*s - 114*D1*Ddd*f**3 - 3*D1*bd1*f*(r + s - 1)*(D1*f*(72*C - 41)*(r + s - 1) - D1*fd*(128*C - 76)*(2*r + 2*s - 1) - Dd*f*(128*C - 76)*(4*r + 4*s - 3)) - 1368*Dd**2*b1*f**2*r**2 - 2736*Dd**2*b1*f**2*r*s + 2052*Dd**2*b1*f**2*r - 1368*Dd**2*b1*f**2*s**2 + 2052*Dd**2*b1*f**2*s - 684*Dd**2*b1*f**2 - 456*Dd**2*f**3*r**2 - 912*Dd**2*f**3*r*s + 684*Dd**2*f**3*r - 456*Dd**2*f**3*s**2 + 684*Dd**2*f**3*s - 228*Dd**2*f**3)/(210*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct*k1**3*k2**3*st**2*(-4752*C*D1**2*f**2*fd*r**2 - 9504*C*D1**2*f**2*fd*r*s + 6336*C*D1**2*f**2*fd*r - 4752*C*D1**2*f**2*fd*s**2 + 6336*C*D1**2*f**2*fd*s - 3168*C*D1**2*f**2*fd - 6336*C*D1*Dd*f**3*r**2 - 12672*C*D1*Dd*f**3*r*s + 9504*C*D1*Dd*f**3*r - 6336*C*D1*Dd*f**3*s**2 + 9504*C*D1*Dd*f**3*s - 4752*C*D1*Dd*f**3 - 2376*D1**2*K*bdd1*f**2*r**2 - 4752*D1**2*K*bdd1*f**2*r*s + 4752*D1**2*K*bdd1*f**2*r - 2376*D1**2*K*bdd1*f**2*s**2 + 4752*D1**2*K*bdd1*f**2*s - 2376*D1**2*K*bdd1*f**2 + 396*D1**2*bd1**2*f*(-28*K + 15*f + 7)*(r + s - 1)**2 + 825*D1**2*bdd1*f**3*r**2 + 1650*D1**2*bdd1*f**3*r*s - 1650*D1**2*bdd1*f**3*r + 825*D1**2*bdd1*f**3*s**2 - 1650*D1**2*bdd1*f**3*s + 825*D1**2*bdd1*f**3 + 594*D1**2*bdd1*f**2*r**2 + 1188*D1**2*bdd1*f**2*r*s - 1188*D1**2*bdd1*f**2*r + 594*D1**2*bdd1*f**2*s**2 - 1188*D1**2*bdd1*f**2*s + 594*D1**2*bdd1*f**2 + 11088*D1**2*bdd1*f*g2*r**2 + 22176*D1**2*bdd1*f*g2*r*s - 22176*D1**2*bdd1*f*g2*r + 11088*D1**2*bdd1*f*g2*s**2 - 22176*D1**2*bdd1*f*g2*s + 11088*D1**2*bdd1*f*g2 + 1780*D1**2*f**3*fd*r**2 + 3560*D1**2*f**3*fd*r*s - 2670*D1**2*f**3*fd*r + 1780*D1**2*f**3*fd*s**2 - 2670*D1**2*f**3*fd*s + 1335*D1**2*f**3*fd - 2100*D1**2*f**3*fdd*r**2 - 4200*D1**2*f**3*fdd*r*s + 3150*D1**2*f**3*fdd*r - 2100*D1**2*f**3*fdd*s**2 + 3150*D1**2*f**3*fdd*s - 1575*D1**2*f**3*fdd - 6300*D1**2*f**2*fd**2*r**2 - 12600*D1**2*f**2*fd**2*r*s + 9450*D1**2*f**2*fd**2*r - 6300*D1**2*f**2*fd**2*s**2 + 9450*D1**2*f**2*fd**2*s - 3150*D1**2*f**2*fd**2 + 2673*D1**2*f**2*fd*r**2 + 5346*D1**2*f**2*fd*r*s - 3564*D1**2*f**2*fd*r + 2673*D1**2*f**2*fd*s**2 - 3564*D1**2*f**2*fd*s + 1782*D1**2*f**2*fd - 7656*D1**2*f**2*gd2*r**2 - 15312*D1**2*f**2*gd2*r*s + 15312*D1**2*f**2*gd2*r - 7656*D1**2*f**2*gd2*s**2 + 15312*D1**2*f**2*gd2*s - 7656*D1**2*f**2*gd2 + 4752*D1**2*f**2*gdd2*r**2 + 9504*D1**2*f**2*gdd2*r*s - 9504*D1**2*f**2*gdd2*r + 4752*D1**2*f**2*gdd2*s**2 - 9504*D1**2*f**2*gdd2*s + 4752*D1**2*f**2*gdd2 - 15312*D1**2*f*fd*g2*r**2 - 30624*D1**2*f*fd*g2*r*s + 15312*D1**2*f*fd*g2*r - 15312*D1**2*f*fd*g2*s**2 + 15312*D1**2*f*fd*g2*s - 7656*D1**2*f*fd*g2 + 19008*D1**2*f*fd*gd2*r**2 + 38016*D1**2*f*fd*gd2*r*s - 28512*D1**2*f*fd*gd2*r + 19008*D1**2*f*fd*gd2*s**2 - 28512*D1**2*f*fd*gd2*s + 9504*D1**2*f*fd*gd2 + 9504*D1**2*f*fdd*g2*r**2 + 19008*D1**2*f*fdd*g2*r*s - 9504*D1**2*f*fdd*g2*r + 9504*D1**2*f*fdd*g2*s**2 - 9504*D1**2*f*fdd*g2*s + 4752*D1**2*f*fdd*g2 + 9504*D1**2*fd**2*g2*r**2 + 19008*D1**2*fd**2*g2*r*s - 9504*D1**2*fd**2*g2*r + 9504*D1**2*fd**2*g2*s**2 - 9504*D1**2*fd**2*g2*s + 1780*D1*Dd*f**4*r**2 + 3560*D1*Dd*f**4*r*s - 2670*D1*Dd*f**4*r + 1780*D1*Dd*f**4*s**2 - 2670*D1*Dd*f**4*s + 1335*D1*Dd*f**4 - 16800*D1*Dd*f**3*fd*r**2 - 33600*D1*Dd*f**3*fd*r*s + 25200*D1*Dd*f**3*fd*r - 16800*D1*Dd*f**3*fd*s**2 + 25200*D1*Dd*f**3*fd*s - 9450*D1*Dd*f**3*fd + 3564*D1*Dd*f**3*r**2 + 7128*D1*Dd*f**3*r*s - 5346*D1*Dd*f**3*r + 3564*D1*Dd*f**3*s**2 - 5346*D1*Dd*f**3*s + 2673*D1*Dd*f**3 - 30624*D1*Dd*f**2*g2*r**2 - 61248*D1*Dd*f**2*g2*r*s + 45936*D1*Dd*f**2*g2*r - 30624*D1*Dd*f**2*g2*s**2 + 45936*D1*Dd*f**2*g2*s - 22968*D1*Dd*f**2*g2 + 38016*D1*Dd*f**2*gd2*r**2 + 76032*D1*Dd*f**2*gd2*r*s - 66528*D1*Dd*f**2*gd2*r + 38016*D1*Dd*f**2*gd2*s**2 - 66528*D1*Dd*f**2*gd2*s + 28512*D1*Dd*f**2*gd2 + 76032*D1*Dd*f*fd*g2*r**2 + 152064*D1*Dd*f*fd*g2*r*s - 95040*D1*Dd*f*fd*g2*r + 76032*D1*Dd*f*fd*g2*s**2 - 95040*D1*Dd*f*fd*g2*s + 28512*D1*Dd*f*fd*g2 - 2100*D1*Ddd*f**4*r**2 - 4200*D1*Ddd*f**4*r*s + 3150*D1*Ddd*f**4*r - 2100*D1*Ddd*f**4*s**2 + 3150*D1*Ddd*f**4*s - 1575*D1*Ddd*f**4 + 19008*D1*Ddd*f**2*g2*r**2 + 38016*D1*Ddd*f**2*g2*r*s - 28512*D1*Ddd*f**2*g2*r + 19008*D1*Ddd*f**2*g2*s**2 - 28512*D1*Ddd*f**2*g2*s + 14256*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(19*f**3*(r + s - 1) + f**2*(56*C*(r + s - 1) - 25*fd*(3*r + 3*s - 2) - (58*K + 17)*(r + s - 1)) + 2*f*(9*fd*(4*K - 1)*(2*r + 2*s - 1) + (98*g2 - 168*gd2)*(r + s - 1)) - 336*fd*g2*(r + s)) - Dd*f*(25*f**2 + f*(18 - 72*K) + 336*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6300*Dd**2*f**4*r**2 - 12600*Dd**2*f**4*r*s + 9450*Dd**2*f**4*r - 6300*Dd**2*f**4*s**2 + 9450*Dd**2*f**4*s - 3150*Dd**2*f**4 + 57024*Dd**2*f**2*g2*r**2 + 114048*Dd**2*f**2*g2*r*s - 85536*Dd**2*f**2*g2*r + 57024*Dd**2*f**2*g2*s**2 - 85536*Dd**2*f**2*g2*s + 28512*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(15*f*(5*fd - 6*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(180*fd**2*(r + s - 1) + 49*fd*(4*K - 1)*(r + s) - 42*fdd*(4*K - 1)*(r + s))) + D1*(Dd*(75*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(180*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (196*K - 49)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 84*fd*(4*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-28*K + 15*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-28*K + 15*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(224*C*D1**2*f*fd*r**2 + 448*C*D1**2*f*fd*r*s - 224*C*D1**2*f*fd*r + 224*C*D1**2*f*fd*s**2 - 224*C*D1**2*f*fd*s + 112*C*D1**2*f*fd + 448*C*D1*Dd*f**2*r**2 + 896*C*D1*Dd*f**2*r*s - 672*C*D1*Dd*f**2*r + 448*C*D1*Dd*f**2*s**2 - 672*C*D1*Dd*f**2*s + 336*C*D1*Dd*f**2 - 232*D1**2*K*f*fd*r**2 - 464*D1**2*K*f*fd*r*s + 232*D1**2*K*f*fd*r - 232*D1**2*K*f*fd*s**2 + 232*D1**2*K*f*fd*s - 116*D1**2*K*f*fd + 144*D1**2*K*f*fdd*r**2 + 288*D1**2*K*f*fdd*r*s - 144*D1**2*K*f*fdd*r + 144*D1**2*K*f*fdd*s**2 - 144*D1**2*K*f*fdd*s + 72*D1**2*K*f*fdd + 144*D1**2*K*fd**2*r**2 + 288*D1**2*K*fd**2*r*s - 144*D1**2*K*fd**2*r + 144*D1**2*K*fd**2*s**2 - 144*D1**2*K*fd**2*s - 12*D1**2*bdd1*f*(-28*K + 15*f + 7)*(r + s - 1)**2 + 114*D1**2*f**2*fd*r**2 + 228*D1**2*f**2*fd*r*s - 152*D1**2*f**2*fd*r + 114*D1**2*f**2*fd*s**2 - 152*D1**2*f**2*fd*s + 76*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 - 68*D1**2*f*fd*r**2 - 136*D1**2*f*fd*r*s + 68*D1**2*f*fd*r - 68*D1**2*f*fd*s**2 + 68*D1**2*f*fd*s - 34*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd + 392*D1**2*f*gd2*r**2 + 784*D1**2*f*gd2*r*s - 784*D1**2*f*gd2*r + 392*D1**2*f*gd2*s**2 - 784*D1**2*f*gd2*s + 392*D1**2*f*gd2 - 336*D1**2*f*gdd2*r**2 - 672*D1**2*f*gdd2*r*s + 672*D1**2*f*gdd2*r - 336*D1**2*f*gdd2*s**2 + 672*D1**2*f*gdd2*s - 336*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 392*D1**2*fd*g2*r**2 + 784*D1**2*fd*g2*r*s + 392*D1**2*fd*g2*s**2 - 672*D1**2*fd*gd2*r**2 - 1344*D1**2*fd*gd2*r*s + 672*D1**2*fd*gd2*r - 672*D1**2*fd*gd2*s**2 + 672*D1**2*fd*gd2*s - 336*D1**2*fdd*g2*r**2 - 672*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*s**2 - 464*D1*Dd*K*f**2*r**2 - 928*D1*Dd*K*f**2*r*s + 696*D1*Dd*K*f**2*r - 464*D1*Dd*K*f**2*s**2 + 696*D1*Dd*K*f**2*s - 348*D1*Dd*K*f**2 + 1152*D1*Dd*K*f*fd*r**2 + 2304*D1*Dd*K*f*fd*r*s - 1440*D1*Dd*K*f*fd*r + 1152*D1*Dd*K*f*fd*s**2 - 1440*D1*Dd*K*f*fd*s + 432*D1*Dd*K*f*fd + 152*D1*Dd*f**3*r**2 + 304*D1*Dd*f**3*r*s - 228*D1*Dd*f**3*r + 152*D1*Dd*f**3*s**2 - 228*D1*Dd*f**3*s + 114*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 136*D1*Dd*f**2*r**2 - 272*D1*Dd*f**2*r*s + 204*D1*Dd*f**2*r - 136*D1*Dd*f**2*s**2 + 204*D1*Dd*f**2*s - 102*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 1568*D1*Dd*f*g2*r**2 + 3136*D1*Dd*f*g2*r*s - 2352*D1*Dd*f*g2*r + 1568*D1*Dd*f*g2*s**2 - 2352*D1*Dd*f*g2*s + 1176*D1*Dd*f*g2 - 2688*D1*Dd*f*gd2*r**2 - 5376*D1*Dd*f*gd2*r*s + 4704*D1*Dd*f*gd2*r - 2688*D1*Dd*f*gd2*s**2 + 4704*D1*Dd*f*gd2*s - 2016*D1*Dd*f*gd2 - 2688*D1*Dd*fd*g2*r**2 - 5376*D1*Dd*fd*g2*r*s + 2016*D1*Dd*fd*g2*r - 2688*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s + 288*D1*Ddd*K*f**2*r**2 + 576*D1*Ddd*K*f**2*r*s - 432*D1*Ddd*K*f**2*r + 288*D1*Ddd*K*f**2*s**2 - 432*D1*Ddd*K*f**2*s + 216*D1*Ddd*K*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 - 1344*D1*Ddd*f*g2*r**2 - 2688*D1*Ddd*f*g2*r*s + 2016*D1*Ddd*f*g2*r - 1344*D1*Ddd*f*g2*s**2 + 2016*D1*Ddd*f*g2*s - 1008*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(75*f**2*(r + s - 1) - 180*f*fd*(2*r + 2*s - 1) - 49*f*(4*K - 1)*(r + s - 1) + 84*fd*(4*K - 1)*(r + s)) - 12*Dd*f*(-28*K + 15*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 864*Dd**2*K*f**2*r**2 + 1728*Dd**2*K*f**2*r*s - 1296*Dd**2*K*f**2*r + 864*Dd**2*K*f**2*s**2 - 1296*Dd**2*K*f**2*s + 432*Dd**2*K*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3 - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 - 4032*Dd**2*f*g2*r**2 - 8064*Dd**2*f*g2*r*s + 6048*Dd**2*f*g2*r - 4032*Dd**2*f*g2*s**2 + 6048*Dd**2*f*g2*s - 2016*Dd**2*f*g2))/(6930*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct*k1**3*k2*st**2*(21*b1**2*(D1**2*(fd*(8*C - 7) + fdd*(16*C - 9))*(r + s - 1)**2 + D1*(Dd*(f*(8*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(32*C - 18)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(16*C - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Dd**2*f*(96*C - 54)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-16*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 48*C*D1**2*f*fd - 48*C*D1**2*f*fdd*r**2 - 96*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r - 48*C*D1**2*f*fdd*s**2 - 48*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r**2 - 96*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r - 48*C*D1**2*fd**2*s**2 - 48*C*D1**2*fd**2*s + 96*C*D1**2*fd**2 - 32*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 - 384*C*D1*Dd*f*fd*r**2 - 768*C*D1*Dd*f*fd*r*s + 96*C*D1*Dd*f*fd*r - 384*C*D1*Dd*f*fd*s**2 + 96*C*D1*Dd*f*fd*s + 144*C*D1*Dd*f*fd - 96*C*D1*Ddd*f**2*r**2 - 192*C*D1*Ddd*f**2*r*s + 144*C*D1*Ddd*f**2*r - 96*C*D1*Ddd*f**2*s**2 + 144*C*D1*Ddd*f**2*s - 72*C*D1*Ddd*f**2 - 288*C*Dd**2*f**2*r**2 - 576*C*Dd**2*f**2*r*s + 432*C*Dd**2*f**2*r - 288*C*Dd**2*f**2*s**2 + 432*C*Dd**2*f**2*s - 144*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(16*C - 9)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 46*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 46*D1**2*f*fd*s + 23*D1**2*f*fd + 24*D1**2*f*fdd*r**2 + 48*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r + 24*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 24*D1**2*fd**2*r**2 + 48*D1**2*fd**2*r*s + 30*D1**2*fd**2*r + 24*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s - 54*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 + 192*D1*Dd*f*fd*r**2 + 384*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 192*D1*Dd*f*fd*s**2 - 24*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 48*D1*Ddd*f**2*r**2 + 96*D1*Ddd*f**2*r*s - 72*D1*Ddd*f**2*r + 48*D1*Ddd*f**2*s**2 - 72*D1*Ddd*f**2*s + 36*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(8*C - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(32*C - 18)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(32*C - 18)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 144*Dd**2*f**2*r**2 + 288*Dd**2*f**2*r*s - 216*Dd**2*f**2*r + 144*Dd**2*f**2*s**2 - 216*Dd**2*f**2*s + 72*Dd**2*f**2) + f*(288*C*D1**2*f*fd*r**2 + 576*C*D1**2*f*fd*r*s - 384*C*D1**2*f*fd*r + 288*C*D1**2*f*fd*s**2 - 384*C*D1**2*f*fd*s + 192*C*D1**2*f*fd - 360*C*D1**2*f*fdd*r**2 - 720*C*D1**2*f*fdd*r*s + 480*C*D1**2*f*fdd*r - 360*C*D1**2*f*fdd*s**2 + 480*C*D1**2*f*fdd*s - 240*C*D1**2*f*fdd - 720*C*D1**2*fd**2*r**2 - 1440*C*D1**2*fd**2*r*s + 960*C*D1**2*fd**2*r - 720*C*D1**2*fd**2*s**2 + 960*C*D1**2*fd**2*s - 240*C*D1**2*fd**2 + 384*C*D1*Dd*f**2*r**2 + 768*C*D1*Dd*f**2*r*s - 576*C*D1*Dd*f**2*r + 384*C*D1*Dd*f**2*s**2 - 576*C*D1*Dd*f**2*s + 288*C*D1*Dd*f**2 - 2880*C*D1*Dd*f*fd*r**2 - 5760*C*D1*Dd*f*fd*r*s + 4080*C*D1*Dd*f*fd*r - 2880*C*D1*Dd*f*fd*s**2 + 4080*C*D1*Dd*f*fd*s - 1440*C*D1*Dd*f*fd - 480*C*D1*Ddd*f**2*r**2 - 960*C*D1*Ddd*f**2*r*s + 720*C*D1*Ddd*f**2*r - 480*C*D1*Ddd*f**2*s**2 + 720*C*D1*Ddd*f**2*s - 360*C*D1*Ddd*f**2 - 1440*C*Dd**2*f**2*r**2 - 2880*C*Dd**2*f**2*r*s + 2160*C*Dd**2*f**2*r - 1440*C*Dd**2*f**2*s**2 + 2160*C*Dd**2*f**2*s - 720*C*Dd**2*f**2 + 42*D1**2*bd1**2*(16*C - 9)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 9*D1**2*bdd1*f*(8*C*(r**2 + 2*r*(s - 3) + s**2 - 6*s + 3) - 4*r**2 - 8*r*s + 26*r - 4*s**2 + 26*s - 13) - 147*D1**2*f*fd*r**2 - 294*D1**2*f*fd*r*s + 196*D1**2*f*fd*r - 147*D1**2*f*fd*s**2 + 196*D1**2*f*fd*s - 98*D1**2*f*fd + 195*D1**2*f*fdd*r**2 + 390*D1**2*f*fdd*r*s - 260*D1**2*f*fdd*r + 195*D1**2*f*fdd*s**2 - 260*D1**2*f*fdd*s + 130*D1**2*f*fdd + 390*D1**2*fd**2*r**2 + 780*D1**2*fd**2*r*s - 520*D1**2*fd**2*r + 390*D1**2*fd**2*s**2 - 520*D1**2*fd**2*s + 130*D1**2*fd**2 - 196*D1*Dd*f**2*r**2 - 392*D1*Dd*f**2*r*s + 294*D1*Dd*f**2*r - 196*D1*Dd*f**2*s**2 + 294*D1*Dd*f**2*s - 147*D1*Dd*f**2 + 1560*D1*Dd*f*fd*r**2 + 3120*D1*Dd*f*fd*r*s - 2210*D1*Dd*f*fd*r + 1560*D1*Dd*f*fd*s**2 - 2210*D1*Dd*f*fd*s + 780*D1*Dd*f*fd + 260*D1*Ddd*f**2*r**2 + 520*D1*Ddd*f**2*r*s - 390*D1*Ddd*f**2*r + 260*D1*Ddd*f**2*s**2 - 390*D1*Ddd*f**2*s + 195*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(8*C*(r**2 + 2*r*(s + 4) + s**2 + 8*s - 4) - 4*r**2 - 8*r*s - 30*r - 4*s**2 - 30*s + 15) + 6*fd*(r + s - 1)*(8*C*(2*r + 2*s - 3) - 8*r - 8*s + 13)) + 6*Dd*f*(4*r + 4*s - 3)*(8*C*(r + s - 3) - 4*r - 4*s + 13)) + 780*Dd**2*f**2*r**2 + 1560*Dd**2*f**2*r*s - 1170*Dd**2*f**2*r + 780*Dd**2*f**2*s**2 - 1170*Dd**2*f**2*s + 390*Dd**2*f**2))/(630*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct*k1**3*k2*(504*D1**2*K*bd1**2*f*r + 504*D1**2*K*bd1**2*f*s - 504*D1**2*K*bd1**2*f + 108*D1**2*K*bd1*f**2*r**2 + 216*D1**2*K*bd1*f**2*r*s - 216*D1**2*K*bd1*f**2*r + 108*D1**2*K*bd1*f**2*s**2 - 216*D1**2*K*bd1*f**2*s + 108*D1**2*K*bd1*f**2 - 720*D1**2*K*bd1*f*fd*r**2 - 1440*D1**2*K*bd1*f*fd*r*s + 1080*D1**2*K*bd1*f*fd*r - 720*D1**2*K*bd1*f*fd*s**2 + 1080*D1**2*K*bd1*f*fd*s - 360*D1**2*K*bd1*f*fd - 180*D1**2*K*bdd1*f**2*r**2 - 360*D1**2*K*bdd1*f**2*r*s + 360*D1**2*K*bdd1*f**2*r - 180*D1**2*K*bdd1*f**2*s**2 + 360*D1**2*K*bdd1*f**2*s - 180*D1**2*K*bdd1*f**2 - 90*D1**2*bd1**2*f**2*r - 90*D1**2*bd1**2*f**2*s + 90*D1**2*bd1**2*f**2 - 126*D1**2*bd1**2*f*r - 126*D1**2*bd1**2*f*s + 126*D1**2*bd1**2*f - 1680*D1**2*bd1**2*g2*r**2 - 3360*D1**2*bd1**2*g2*r*s + 1680*D1**2*bd1**2*g2*r - 1680*D1**2*bd1**2*g2*s**2 + 1680*D1**2*bd1**2*g2*s - 504*D1**2*bd1*bd2*f*r**2 - 1008*D1**2*bd1*bd2*f*r*s + 1008*D1**2*bd1*bd2*f*r - 504*D1**2*bd1*bd2*f*s**2 + 1008*D1**2*bd1*bd2*f*s - 504*D1**2*bd1*bd2*f - 25*D1**2*bd1*f**3*r**2 - 50*D1**2*bd1*f**3*r*s + 50*D1**2*bd1*f**3*r - 25*D1**2*bd1*f**3*s**2 + 50*D1**2*bd1*f**3*s - 25*D1**2*bd1*f**3 + 210*D1**2*bd1*f**2*fd*r**2 + 420*D1**2*bd1*f**2*fd*r*s - 350*D1**2*bd1*f**2*fd*r + 210*D1**2*bd1*f**2*fd*s**2 - 350*D1**2*bd1*f**2*fd*s + 140*D1**2*bd1*f**2*fd - 27*D1**2*bd1*f**2*r**2 - 54*D1**2*bd1*f**2*r*s + 54*D1**2*bd1*f**2*r - 27*D1**2*bd1*f**2*s**2 + 54*D1**2*bd1*f**2*s - 27*D1**2*bd1*f**2 + 180*D1**2*bd1*f*fd*r**2 + 360*D1**2*bd1*f*fd*r*s - 270*D1**2*bd1*f*fd*r + 180*D1**2*bd1*f*fd*s**2 - 270*D1**2*bd1*f*fd*s + 90*D1**2*bd1*f*fd + 336*D1**2*bd1*f*g2*r + 336*D1**2*bd1*f*g2*s - 168*D1**2*bd1*f*g2 - 1008*D1**2*bd1*f*gd2*r - 1008*D1**2*bd1*f*gd2*s + 1008*D1**2*bd1*f*gd2 + 108*D1**2*bd2*f**2*r**2 + 216*D1**2*bd2*f**2*r*s - 216*D1**2*bd2*f**2*r + 108*D1**2*bd2*f**2*s**2 - 216*D1**2*bd2*f**2*s + 108*D1**2*bd2*f**2 - 720*D1**2*bd2*f*fd*r**2 - 1440*D1**2*bd2*f*fd*r*s + 1080*D1**2*bd2*f*fd*r - 720*D1**2*bd2*f*fd*s**2 + 1080*D1**2*bd2*f*fd*s - 360*D1**2*bd2*f*fd + 35*D1**2*bdd1*f**3*r**2 + 70*D1**2*bdd1*f**3*r*s - 70*D1**2*bdd1*f**3*r + 35*D1**2*bdd1*f**3*s**2 - 70*D1**2*bdd1*f**3*s + 35*D1**2*bdd1*f**3 + 45*D1**2*bdd1*f**2*r**2 + 90*D1**2*bdd1*f**2*r*s - 90*D1**2*bdd1*f**2*r + 45*D1**2*bdd1*f**2*s**2 - 90*D1**2*bdd1*f**2*s + 45*D1**2*bdd1*f**2 - 1008*D1**2*bdd1*f*g2*r - 1008*D1**2*bdd1*f*g2*s + 504*D1**2*bdd1*f*g2 - 180*D1**2*bdd2*f**2*r**2 - 360*D1**2*bdd2*f**2*r*s + 360*D1**2*bdd2*f**2*r - 180*D1**2*bdd2*f**2*s**2 + 360*D1**2*bdd2*f**2*s - 180*D1**2*bdd2*f**2 - 216*D1**2*f**2*gd2*r**2 - 432*D1**2*f**2*gd2*r*s + 432*D1**2*f**2*gd2*r - 216*D1**2*f**2*gd2*s**2 + 432*D1**2*f**2*gd2*s - 216*D1**2*f**2*gd2 + 360*D1**2*f**2*gdd2*r**2 + 720*D1**2*f**2*gdd2*r*s - 720*D1**2*f**2*gdd2*r + 360*D1**2*f**2*gdd2*s**2 - 720*D1**2*f**2*gdd2*s + 360*D1**2*f**2*gdd2 - 432*D1**2*f*fd*g2*r**2 - 864*D1**2*f*fd*g2*r*s + 432*D1**2*f*fd*g2*r - 432*D1**2*f*fd*g2*s**2 + 432*D1**2*f*fd*g2*s - 216*D1**2*f*fd*g2 + 1440*D1**2*f*fd*gd2*r**2 + 2880*D1**2*f*fd*gd2*r*s - 2160*D1**2*f*fd*gd2*r + 1440*D1**2*f*fd*gd2*s**2 - 2160*D1**2*f*fd*gd2*s + 720*D1**2*f*fd*gd2 + 720*D1**2*f*fdd*g2*r**2 + 1440*D1**2*f*fdd*g2*r*s - 720*D1**2*f*fdd*g2*r + 720*D1**2*f*fdd*g2*s**2 - 720*D1**2*f*fdd*g2*s + 360*D1**2*f*fdd*g2 + 720*D1**2*fd**2*g2*r**2 + 1440*D1**2*fd**2*g2*r*s - 720*D1**2*fd**2*g2*r + 720*D1**2*fd**2*g2*s**2 - 720*D1**2*fd**2*g2*s - 1440*D1*Dd*K*bd1*f**2*r**2 - 2880*D1*Dd*K*bd1*f**2*r*s + 2520*D1*Dd*K*bd1*f**2*r - 1440*D1*Dd*K*bd1*f**2*s**2 + 2520*D1*Dd*K*bd1*f**2*s - 1080*D1*Dd*K*bd1*f**2 + 280*D1*Dd*bd1*f**3*r**2 + 560*D1*Dd*bd1*f**3*r*s - 490*D1*Dd*bd1*f**3*r + 280*D1*Dd*bd1*f**3*s**2 - 490*D1*Dd*bd1*f**3*s + 210*D1*Dd*bd1*f**3 + 360*D1*Dd*bd1*f**2*r**2 + 720*D1*Dd*bd1*f**2*r*s - 630*D1*Dd*bd1*f**2*r + 360*D1*Dd*bd1*f**2*s**2 - 630*D1*Dd*bd1*f**2*s + 270*D1*Dd*bd1*f**2 - 4032*D1*Dd*bd1*f*g2*r - 4032*D1*Dd*bd1*f*g2*s + 3024*D1*Dd*bd1*f*g2 - 1440*D1*Dd*bd2*f**2*r**2 - 2880*D1*Dd*bd2*f**2*r*s + 2520*D1*Dd*bd2*f**2*r - 1440*D1*Dd*bd2*f**2*s**2 + 2520*D1*Dd*bd2*f**2*s - 1080*D1*Dd*bd2*f**2 - 864*D1*Dd*f**2*g2*r**2 - 1728*D1*Dd*f**2*g2*r*s + 1296*D1*Dd*f**2*g2*r - 864*D1*Dd*f**2*g2*s**2 + 1296*D1*Dd*f**2*g2*s - 648*D1*Dd*f**2*g2 + 2880*D1*Dd*f**2*gd2*r**2 + 5760*D1*Dd*f**2*gd2*r*s - 5040*D1*Dd*f**2*gd2*r + 2880*D1*Dd*f**2*gd2*s**2 - 5040*D1*Dd*f**2*gd2*s + 2160*D1*Dd*f**2*gd2 + 5760*D1*Dd*f*fd*g2*r**2 + 11520*D1*Dd*f*fd*g2*r*s - 7200*D1*Dd*f*fd*g2*r + 5760*D1*Dd*f*fd*g2*s**2 - 7200*D1*Dd*f*fd*g2*s + 2160*D1*Dd*f*fd*g2 + 1440*D1*Ddd*f**2*g2*r**2 + 2880*D1*Ddd*f**2*g2*r*s - 2160*D1*Ddd*f**2*g2*r + 1440*D1*Ddd*f**2*g2*s**2 - 2160*D1*Ddd*f**2*g2*s + 1080*D1*Ddd*f**2*g2 + 84*D1*b2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 4320*Dd**2*f**2*g2*r**2 + 8640*Dd**2*f**2*g2*r*s - 6480*Dd**2*f**2*g2*r + 4320*Dd**2*f**2*g2*s**2 - 6480*Dd**2*f**2*g2*s + 2160*Dd**2*f**2*g2 + 21*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (20*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-20*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-20*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(56*D1**2*K*fd*r + 56*D1**2*K*fd*s - 28*D1**2*K*fd - 168*D1**2*K*fdd*r - 168*D1**2*K*fdd*s + 84*D1**2*K*fdd - 7*D1**2*bdd1*(-20*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*D1**2*f*fd*r - 18*D1**2*f*fd*s + 9*D1**2*f*fd + 30*D1**2*f*fdd*r + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 30*D1**2*fd**2*r + 30*D1**2*fd**2*s - 30*D1**2*fd**2 - 14*D1**2*fd*r - 14*D1**2*fd*s + 7*D1**2*fd + 42*D1**2*fdd*r + 42*D1**2*fdd*s - 21*D1**2*fdd - 280*D1**2*gd2*r**2 - 560*D1**2*gd2*r*s + 560*D1**2*gd2*r - 280*D1**2*gd2*s**2 + 560*D1**2*gd2*s - 280*D1**2*gd2 - 280*D1**2*gdd2*r**2 - 560*D1**2*gdd2*r*s + 560*D1**2*gdd2*r - 280*D1**2*gdd2*s**2 + 560*D1**2*gdd2*s - 280*D1**2*gdd2 - 672*D1*Dd*K*fd*r - 672*D1*Dd*K*fd*s + 504*D1*Dd*K*fd + 120*D1*Dd*f*fd*r + 120*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 168*D1*Dd*fd*r + 168*D1*Dd*fd*s - 126*D1*Dd*fd - 1120*D1*Dd*g2*r**2 - 2240*D1*Dd*g2*r*s + 1680*D1*Dd*g2*r - 1120*D1*Dd*g2*s**2 + 1680*D1*Dd*g2*s - 840*D1*Dd*g2 - 2240*D1*Dd*gd2*r**2 - 4480*D1*Dd*gd2*r*s + 3920*D1*Dd*gd2*r - 2240*D1*Dd*gd2*s**2 + 3920*D1*Dd*gd2*s - 1680*D1*Dd*gd2 - 1120*D1*Ddd*g2*r**2 - 2240*D1*Ddd*g2*r*s + 1680*D1*Ddd*g2*r - 1120*D1*Ddd*g2*s**2 + 1680*D1*Ddd*g2*s - 840*D1*Ddd*g2 + 7*D1*bd1*(D1*(f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (20*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-20*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 3360*Dd**2*g2*r**2 - 6720*Dd**2*g2*r*s + 5040*Dd**2*g2*r - 3360*Dd**2*g2*s**2 + 5040*Dd**2*g2*s - 1680*Dd**2*g2) - b1*(-504*D1**2*K*bdd1*f*r - 504*D1**2*K*bdd1*f*s + 252*D1**2*K*bdd1*f - 216*D1**2*K*f*fd*r**2 - 432*D1**2*K*f*fd*r*s + 216*D1**2*K*f*fd*r - 216*D1**2*K*f*fd*s**2 + 216*D1**2*K*f*fd*s - 108*D1**2*K*f*fd + 360*D1**2*K*f*fdd*r**2 + 720*D1**2*K*f*fdd*r*s - 360*D1**2*K*f*fdd*r + 360*D1**2*K*f*fdd*s**2 - 360*D1**2*K*f*fdd*s + 180*D1**2*K*f*fdd + 360*D1**2*K*fd**2*r**2 + 720*D1**2*K*fd**2*r*s - 360*D1**2*K*fd**2*r + 360*D1**2*K*fd**2*s**2 - 360*D1**2*K*fd**2*s - 84*D1**2*b2*fd*r**2 - 168*D1**2*b2*fd*r*s - 84*D1**2*b2*fd*s**2 + 252*D1**2*b2*fdd*r**2 + 504*D1**2*b2*fdd*r*s + 252*D1**2*b2*fdd*s**2 + 42*D1**2*bd1**2*(-20*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 90*D1**2*bdd1*f**2*r + 90*D1**2*bdd1*f**2*s - 45*D1**2*bdd1*f**2 + 126*D1**2*bdd1*f*r + 126*D1**2*bdd1*f*s - 63*D1**2*bdd1*f + 1680*D1**2*bdd1*g2*r**2 + 3360*D1**2*bdd1*g2*r*s - 1680*D1**2*bdd1*g2*r + 1680*D1**2*bdd1*g2*s**2 - 1680*D1**2*bdd1*g2*s + 840*D1**2*bdd1*g2 + 252*D1**2*bdd2*f*r**2 + 504*D1**2*bdd2*f*r*s - 504*D1**2*bdd2*f*r + 252*D1**2*bdd2*f*s**2 - 504*D1**2*bdd2*f*s + 252*D1**2*bdd2*f + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 54*D1**2*f*fd*r**2 + 108*D1**2*f*fd*r*s - 54*D1**2*f*fd*r + 54*D1**2*f*fd*s**2 - 54*D1**2*f*fd*s + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 45*D1**2*f*fdd - 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 336*D1**2*fd*g2*r + 336*D1**2*fd*g2*s - 168*D1**2*fd*g2 - 1008*D1**2*fd*gd2*r - 1008*D1**2*fd*gd2*s + 1008*D1**2*fd*gd2 - 1008*D1**2*fdd*g2*r - 1008*D1**2*fdd*g2*s + 504*D1**2*fdd*g2 - 432*D1*Dd*K*f**2*r**2 - 864*D1*Dd*K*f**2*r*s + 648*D1*Dd*K*f**2*r - 432*D1*Dd*K*f**2*s**2 + 648*D1*Dd*K*f**2*s - 324*D1*Dd*K*f**2 + 2880*D1*Dd*K*f*fd*r**2 + 5760*D1*Dd*K*f*fd*r*s - 3600*D1*Dd*K*f*fd*r + 2880*D1*Dd*K*f*fd*s**2 - 3600*D1*Dd*K*f*fd*s + 1080*D1*Dd*K*f*fd - 336*D1*Dd*b2*f*r**2 - 672*D1*Dd*b2*f*r*s + 504*D1*Dd*b2*f*r - 336*D1*Dd*b2*f*s**2 + 504*D1*Dd*b2*f*s - 252*D1*Dd*b2*f + 2016*D1*Dd*b2*fd*r**2 + 4032*D1*Dd*b2*fd*r*s - 1512*D1*Dd*b2*fd*r + 2016*D1*Dd*b2*fd*s**2 - 1512*D1*Dd*b2*fd*s + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 1190*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 1190*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 + 216*D1*Dd*f**2*r*s - 162*D1*Dd*f**2*r + 108*D1*Dd*f**2*s**2 - 162*D1*Dd*f**2*s + 81*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 900*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 270*D1*Dd*f*fd - 4032*D1*Dd*fd*g2*r - 4032*D1*Dd*fd*g2*s + 3024*D1*Dd*fd*g2 + 720*D1*Ddd*K*f**2*r**2 + 1440*D1*Ddd*K*f**2*r*s - 1080*D1*Ddd*K*f**2*r + 720*D1*Ddd*K*f**2*s**2 - 1080*D1*Ddd*K*f**2*s + 540*D1*Ddd*K*f**2 + 1008*D1*Ddd*b2*f*r**2 + 2016*D1*Ddd*b2*f*r*s - 1512*D1*Ddd*b2*f*r + 1008*D1*Ddd*b2*f*s**2 - 1512*D1*Ddd*b2*f*s + 756*D1*Ddd*b2*f - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 210*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 210*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 3*D1*bd1*(D1*(9*f**2*(2*r + 2*s - 1) - 7*f*(4*K - 1)*(2*r + 2*s - 1) - 42*fd*(4*K - 1)*(r + s - 1) - 280*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 560*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(15*f**2 + f*(21 - 84*K) + 280*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 84*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 2160*Dd**2*K*f**2*r**2 + 4320*Dd**2*K*f**2*r*s - 3240*Dd**2*K*f**2*r + 2160*Dd**2*K*f**2*s**2 - 3240*Dd**2*K*f**2*s + 1080*Dd**2*K*f**2 + 3024*Dd**2*b2*f*r**2 + 6048*Dd**2*b2*f*r*s - 4536*Dd**2*b2*f*r + 3024*Dd**2*b2*f*s**2 - 4536*Dd**2*b2*f*s + 1512*Dd**2*b2*f - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 630*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 630*Dd**2*f**3*s - 210*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 270*Dd**2*f**2) - 36*b2*(7*D1**2*bdd1*f*(r + s - 1)**2 + D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(-3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) - D1**2*Pk1*Pkdd3*ct*k1*k2**5*st**6*(4*C - 3)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(126*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct*k1*k2**5*st**4*(396*C*D1**2*f**2*fd*r**2 + 792*C*D1**2*f**2*fd*r*s - 528*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 528*C*D1**2*f**2*fd*s + 264*C*D1**2*f**2*fd + 528*C*D1*Dd*f**3*r**2 + 1056*C*D1*Dd*f**3*r*s - 792*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 792*C*D1*Dd*f**3*s + 396*C*D1*Dd*f**3 + 66*D1**2*K*bdd1*f**2*r**2 + 132*D1**2*K*bdd1*f**2*r*s - 132*D1**2*K*bdd1*f**2*r + 66*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s + 66*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(-14*K + 25*f + 7)*(r + s - 1)**2 + 275*D1**2*bdd1*f**3*r**2 + 550*D1**2*bdd1*f**3*r*s - 550*D1**2*bdd1*f**3*r + 275*D1**2*bdd1*f**3*s**2 - 550*D1**2*bdd1*f**3*s + 275*D1**2*bdd1*f**3 - 33*D1**2*bdd1*f**2*r**2 - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r - 33*D1**2*bdd1*f**2*s**2 + 66*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 - 924*D1**2*bdd1*f*g2*r**2 - 1848*D1**2*bdd1*f*g2*r*s + 1848*D1**2*bdd1*f*g2*r - 924*D1**2*bdd1*f*g2*s**2 + 1848*D1**2*bdd1*f*g2*s - 924*D1**2*bdd1*f*g2 - 1516*D1**2*f**3*fd*r**2 - 3032*D1**2*f**3*fd*r*s + 2274*D1**2*f**3*fd*r - 1516*D1**2*f**3*fd*s**2 + 2274*D1**2*f**3*fd*s - 1137*D1**2*f**3*fd + 1000*D1**2*f**3*fdd*r**2 + 2000*D1**2*f**3*fdd*r*s - 1500*D1**2*f**3*fdd*r + 1000*D1**2*f**3*fdd*s**2 - 1500*D1**2*f**3*fdd*s + 750*D1**2*f**3*fdd + 3000*D1**2*f**2*fd**2*r**2 + 6000*D1**2*f**2*fd**2*r*s - 4500*D1**2*f**2*fd**2*r + 3000*D1**2*f**2*fd**2*s**2 - 4500*D1**2*f**2*fd**2*s + 1500*D1**2*f**2*fd**2 - 297*D1**2*f**2*fd*r**2 - 594*D1**2*f**2*fd*r*s + 396*D1**2*f**2*fd*r - 297*D1**2*f**2*fd*s**2 + 396*D1**2*f**2*fd*s - 198*D1**2*f**2*fd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 1516*D1*Dd*f**4*r**2 - 3032*D1*Dd*f**4*r*s + 2274*D1*Dd*f**4*r - 1516*D1*Dd*f**4*s**2 + 2274*D1*Dd*f**4*s - 1137*D1*Dd*f**4 + 8000*D1*Dd*f**3*fd*r**2 + 16000*D1*Dd*f**3*fd*r*s - 12000*D1*Dd*f**3*fd*r + 8000*D1*Dd*f**3*fd*s**2 - 12000*D1*Dd*f**3*fd*s + 4500*D1*Dd*f**3*fd - 396*D1*Dd*f**3*r**2 - 792*D1*Dd*f**3*r*s + 594*D1*Dd*f**3*r - 396*D1*Dd*f**3*s**2 + 594*D1*Dd*f**3*s - 297*D1*Dd*f**3 + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 1000*D1*Ddd*f**4*r**2 + 2000*D1*Ddd*f**4*r*s - 1500*D1*Ddd*f**4*r + 1000*D1*Ddd*f**4*s**2 - 1500*D1*Ddd*f**4*s + 750*D1*Ddd*f**4 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(23*f**3*(r + s - 1) + f**2*(-84*C*(r + s - 1) - 50*fd*(3*r + 3*s - 2) + (12*K + 57)*(r + s - 1)) - 6*f*(fd*(2*K - 1)*(2*r + 2*s - 1) + (28*g2 - 28*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 2*Dd*f*(25*f**2 + f*(6*K - 3) - 84*g2)*(4*r + 4*s - 3))*(r + s - 1) + 3000*Dd**2*f**4*r**2 + 6000*Dd**2*f**4*r*s - 4500*Dd**2*f**4*r + 3000*Dd**2*f**4*s**2 - 4500*Dd**2*f**4*s + 1500*Dd**2*f**4 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(25*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 25*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 25*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(168*C*D1**2*f*fd*r**2 + 336*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r + 168*C*D1**2*f*fd*s**2 - 168*C*D1**2*f*fd*s + 84*C*D1**2*f*fd + 336*C*D1*Dd*f**2*r**2 + 672*C*D1*Dd*f**2*r*s - 504*C*D1*Dd*f**2*r + 336*C*D1*Dd*f**2*s**2 - 504*C*D1*Dd*f**2*s + 252*C*D1*Dd*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 12*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 12*D1**2*K*f*fdd*s**2 - 12*D1**2*K*f*fdd*s + 6*D1**2*K*f*fdd + 12*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 12*D1**2*K*fd**2*s**2 - 12*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-14*K + 25*f + 7)*(r + s - 1)**2 - 69*D1**2*f**2*fd*r**2 - 138*D1**2*f**2*fd*r*s + 92*D1**2*f**2*fd*r - 69*D1**2*f**2*fd*s**2 + 92*D1**2*f**2*fd*s - 46*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 - 114*D1**2*f*fd*r**2 - 228*D1**2*f*fd*r*s + 114*D1**2*f*fd*r - 114*D1**2*f*fd*s**2 + 114*D1**2*f*fd*s - 57*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 3*D1**2*f*fdd + 168*D1**2*f*gd2*r**2 + 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r + 168*D1**2*f*gd2*s**2 - 336*D1**2*f*gd2*s + 168*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s + 168*D1**2*fd*g2*r**2 + 336*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 96*D1*Dd*K*f*fd*r**2 + 192*D1*Dd*K*f*fd*r*s - 120*D1*Dd*K*f*fd*r + 96*D1*Dd*K*f*fd*s**2 - 120*D1*Dd*K*f*fd*s + 36*D1*Dd*K*f*fd - 92*D1*Dd*f**3*r**2 - 184*D1*Dd*f**3*r*s + 138*D1*Dd*f**3*r - 92*D1*Dd*f**3*s**2 + 138*D1*Dd*f**3*s - 69*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 850*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 850*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd - 228*D1*Dd*f**2*r**2 - 456*D1*Dd*f**2*r*s + 342*D1*Dd*f**2*r - 228*D1*Dd*f**2*s**2 + 342*D1*Dd*f**2*s - 171*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 18*D1*Dd*f*fd + 672*D1*Dd*f*g2*r**2 + 1344*D1*Dd*f*g2*r*s - 1008*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 1008*D1*Dd*f*g2*s + 504*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s + 24*D1*Ddd*K*f**2*r**2 + 48*D1*Ddd*K*f**2*r*s - 36*D1*Ddd*K*f**2*r + 24*D1*Ddd*K*f**2*s**2 - 36*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 - 12*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 18*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 12*D1*bd1*(D1*(18*f**2*(r + s - 1) - 25*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 25*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 72*Dd**2*K*f**2*r**2 + 144*Dd**2*K*f**2*r*s - 108*Dd**2*K*f**2*r + 72*Dd**2*K*f**2*s**2 - 108*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 - 36*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 54*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 18*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(2310*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct*k1*k2**3*st**4*(-21*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(-88*C*D1**2*f*fd*r**2 - 176*C*D1**2*f*fd*r*s + 72*C*D1**2*f*fd*r - 88*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s - 36*C*D1**2*f*fd + 72*C*D1**2*f*fdd*r**2 + 144*C*D1**2*f*fdd*r*s - 64*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s**2 - 64*C*D1**2*f*fdd*s + 32*C*D1**2*f*fdd + 72*C*D1**2*fd**2*r**2 + 144*C*D1**2*fd**2*r*s - 64*C*D1**2*fd**2*r + 72*C*D1**2*fd**2*s**2 - 64*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 - 176*C*D1*Dd*f**2*r**2 - 352*C*D1*Dd*f**2*r*s + 264*C*D1*Dd*f**2*r - 176*C*D1*Dd*f**2*s**2 + 264*C*D1*Dd*f**2*s - 132*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 + 1152*C*D1*Dd*f*fd*r*s - 688*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 688*C*D1*Dd*f*fd*s + 192*C*D1*Dd*f*fd + 144*C*D1*Ddd*f**2*r**2 + 288*C*D1*Ddd*f**2*r*s - 216*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 216*C*D1*Ddd*f**2*s + 108*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r**2 + 864*C*Dd**2*f**2*r*s - 648*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 648*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 50*D1**2*f*fd*r**2 + 100*D1**2*f*fd*r*s - 38*D1**2*f*fd*r + 50*D1**2*f*fd*s**2 - 38*D1**2*f*fd*s + 19*D1**2*f*fd - 46*D1**2*f*fdd*r**2 - 92*D1**2*f*fdd*r*s + 40*D1**2*f*fdd*r - 46*D1**2*f*fdd*s**2 + 40*D1**2*f*fdd*s - 20*D1**2*f*fdd - 46*D1**2*fd**2*r**2 - 92*D1**2*fd**2*r*s + 40*D1**2*fd**2*r - 46*D1**2*fd**2*s**2 + 40*D1**2*fd**2*s + 6*D1**2*fd**2 + 100*D1*Dd*f**2*r**2 + 200*D1*Dd*f**2*r*s - 150*D1*Dd*f**2*r + 100*D1*Dd*f**2*s**2 - 150*D1*Dd*f**2*s + 75*D1*Dd*f**2 - 368*D1*Dd*f*fd*r**2 - 736*D1*Dd*f*fd*r*s + 436*D1*Dd*f*fd*r - 368*D1*Dd*f*fd*s**2 + 436*D1*Dd*f*fd*s - 120*D1*Dd*f*fd - 92*D1*Ddd*f**2*r**2 - 184*D1*Ddd*f**2*r*s + 138*D1*Ddd*f**2*r - 92*D1*Ddd*f**2*s**2 + 138*D1*Ddd*f**2*s - 69*D1*Ddd*f**2 + 14*D1*bd1*(4*C - 3)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 276*Dd**2*f**2*r**2 - 552*Dd**2*f**2*r*s + 414*Dd**2*f**2*r - 276*Dd**2*f**2*s**2 + 414*Dd**2*f**2*s - 138*Dd**2*f**2) + f*(204*C*D1**2*f*fd*r**2 + 408*C*D1**2*f*fd*r*s - 272*C*D1**2*f*fd*r + 204*C*D1**2*f*fd*s**2 - 272*C*D1**2*f*fd*s + 136*C*D1**2*f*fd - 120*C*D1**2*f*fdd*r**2 - 240*C*D1**2*f*fdd*r*s + 160*C*D1**2*f*fdd*r - 120*C*D1**2*f*fdd*s**2 + 160*C*D1**2*f*fdd*s - 80*C*D1**2*f*fdd - 240*C*D1**2*fd**2*r**2 - 480*C*D1**2*fd**2*r*s + 320*C*D1**2*fd**2*r - 240*C*D1**2*fd**2*s**2 + 320*C*D1**2*fd**2*s - 80*C*D1**2*fd**2 + 272*C*D1*Dd*f**2*r**2 + 544*C*D1*Dd*f**2*r*s - 408*C*D1*Dd*f**2*r + 272*C*D1*Dd*f**2*s**2 - 408*C*D1*Dd*f**2*s + 204*C*D1*Dd*f**2 - 960*C*D1*Dd*f*fd*r**2 - 1920*C*D1*Dd*f*fd*r*s + 1360*C*D1*Dd*f*fd*r - 960*C*D1*Dd*f*fd*s**2 + 1360*C*D1*Dd*f*fd*s - 480*C*D1*Dd*f*fd - 160*C*D1*Ddd*f**2*r**2 - 320*C*D1*Ddd*f**2*r*s + 240*C*D1*Ddd*f**2*r - 160*C*D1*Ddd*f**2*s**2 + 240*C*D1*Ddd*f**2*s - 120*C*D1*Ddd*f**2 - 480*C*Dd**2*f**2*r**2 - 960*C*Dd**2*f**2*r*s + 720*C*Dd**2*f**2*r - 480*C*Dd**2*f**2*s**2 + 720*C*Dd**2*f**2*s - 240*C*Dd**2*f**2 + 42*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 3*D1**2*bdd1*f*(4*C*(9*r**2 + 18*r*s - 20*r + 9*s**2 - 20*s + 10) - 23*r**2 - 46*r*s + 52*r - 23*s**2 + 52*s - 26) - 129*D1**2*f*fd*r**2 - 258*D1**2*f*fd*r*s + 172*D1**2*f*fd*r - 129*D1**2*f*fd*s**2 + 172*D1**2*f*fd*s - 86*D1**2*f*fd + 78*D1**2*f*fdd*r**2 + 156*D1**2*f*fdd*r*s - 104*D1**2*f*fdd*r + 78*D1**2*f*fdd*s**2 - 104*D1**2*f*fdd*s + 52*D1**2*f*fdd + 156*D1**2*fd**2*r**2 + 312*D1**2*fd**2*r*s - 208*D1**2*fd**2*r + 156*D1**2*fd**2*s**2 - 208*D1**2*fd**2*s + 52*D1**2*fd**2 - 172*D1*Dd*f**2*r**2 - 344*D1*Dd*f**2*r*s + 258*D1*Dd*f**2*r - 172*D1*Dd*f**2*s**2 + 258*D1*Dd*f**2*s - 129*D1*Dd*f**2 + 624*D1*Dd*f*fd*r**2 + 1248*D1*Dd*f*fd*r*s - 884*D1*Dd*f*fd*r + 624*D1*Dd*f*fd*s**2 - 884*D1*Dd*f*fd*s + 312*D1*Dd*f*fd + 104*D1*Ddd*f**2*r**2 + 208*D1*Ddd*f**2*r*s - 156*D1*Ddd*f**2*r + 104*D1*Ddd*f**2*s**2 - 156*D1*Ddd*f**2*s + 78*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(4*C*(11*r**2 + 22*r*s - 26*r + 11*s**2 - 26*s + 13) - 25*r**2 - 50*r*s + 62*r - 25*s**2 + 62*s - 31) - 4*fd*(r + s - 1)*(4*C*(9*r + 9*s - 5) - 23*r - 23*s + 13)) - 2*Dd*f*(4*r + 4*s - 3)*(4*C*(9*r + 9*s - 10) - 23*r - 23*s + 26)) + 312*Dd**2*f**2*r**2 + 624*Dd**2*f**2*r*s - 468*Dd**2*f**2*r + 312*Dd**2*f**2*s**2 - 468*Dd**2*f**2*s + 156*Dd**2*f**2))/(210*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct*k1*k2**3*st**2*(-56*C*D1**2*bd1*f**2*r**2 - 112*C*D1**2*bd1*f**2*r*s + 168*C*D1**2*bd1*f**2*r - 56*C*D1**2*bd1*f**2*s**2 + 168*C*D1**2*bd1*f**2*s - 84*C*D1**2*bd1*f**2 - 108*C*D1**2*f**2*fd*r**2 - 216*C*D1**2*f**2*fd*r*s + 144*C*D1**2*f**2*fd*r - 108*C*D1**2*f**2*fd*s**2 + 144*C*D1**2*f**2*fd*s - 72*C*D1**2*f**2*fd - 144*C*D1*Dd*f**3*r**2 - 288*C*D1*Dd*f**3*r*s + 216*C*D1*Dd*f**3*r - 144*C*D1*Dd*f**3*s**2 + 216*C*D1*Dd*f**3*s - 108*C*D1*Dd*f**3 - 140*D1**2*K*bd1**2*f*r**2 - 280*D1**2*K*bd1**2*f*r*s + 308*D1**2*K*bd1**2*f*r - 140*D1**2*K*bd1**2*f*s**2 + 308*D1**2*K*bd1**2*f*s - 168*D1**2*K*bd1**2*f + 58*D1**2*K*bd1*f**2*r**2 + 116*D1**2*K*bd1*f**2*r*s - 116*D1**2*K*bd1*f**2*r + 58*D1**2*K*bd1*f**2*s**2 - 116*D1**2*K*bd1*f**2*s + 58*D1**2*K*bd1*f**2 - 144*D1**2*K*bd1*f*fd*r**2 - 288*D1**2*K*bd1*f*fd*r*s + 216*D1**2*K*bd1*f*fd*r - 144*D1**2*K*bd1*f*fd*s**2 + 216*D1**2*K*bd1*f*fd*s - 72*D1**2*K*bd1*f*fd - 36*D1**2*K*bdd1*f**2*r**2 - 72*D1**2*K*bdd1*f**2*r*s + 72*D1**2*K*bdd1*f**2*r - 36*D1**2*K*bdd1*f**2*s**2 + 72*D1**2*K*bdd1*f**2*s - 36*D1**2*K*bdd1*f**2 + 108*D1**2*bd1**2*f**2*r**2 + 216*D1**2*bd1**2*f**2*r*s - 216*D1**2*bd1**2*f**2*r + 108*D1**2*bd1**2*f**2*s**2 - 216*D1**2*bd1**2*f**2*s + 108*D1**2*bd1**2*f**2 + 70*D1**2*bd1**2*f*r**2 + 140*D1**2*bd1**2*f*r*s - 154*D1**2*bd1**2*f*r + 70*D1**2*bd1**2*f*s**2 - 154*D1**2*bd1**2*f*s + 84*D1**2*bd1**2*f - 280*D1**2*bd1**2*g2*r**2 - 560*D1**2*bd1**2*g2*r*s + 280*D1**2*bd1**2*g2*r - 280*D1**2*bd1**2*g2*s**2 + 280*D1**2*bd1**2*g2*s - 168*D1**2*bd1*bd2*f*r**2 - 336*D1**2*bd1*bd2*f*r*s + 336*D1**2*bd1*bd2*f*r - 168*D1**2*bd1*bd2*f*s**2 + 336*D1**2*bd1*bd2*f*s - 168*D1**2*bd1*bd2*f - 54*D1**2*bd1*f**3*r**2 - 108*D1**2*bd1*f**3*r*s + 78*D1**2*bd1*f**3*r - 54*D1**2*bd1*f**3*s**2 + 78*D1**2*bd1*f**3*s - 39*D1**2*bd1*f**3 + 270*D1**2*bd1*f**2*fd*r**2 + 540*D1**2*bd1*f**2*fd*r*s - 390*D1**2*bd1*f**2*fd*r + 270*D1**2*bd1*f**2*fd*s**2 - 390*D1**2*bd1*f**2*fd*s + 120*D1**2*bd1*f**2*fd - D1**2*bd1*f**2*r**2 - 2*D1**2*bd1*f**2*r*s - 40*D1**2*bd1*f**2*r - D1**2*bd1*f**2*s**2 - 40*D1**2*bd1*f**2*s + 20*D1**2*bd1*f**2 + 72*D1**2*bd1*f*fd*r**2 + 144*D1**2*bd1*f*fd*r*s - 108*D1**2*bd1*f*fd*r + 72*D1**2*bd1*f*fd*s**2 - 108*D1**2*bd1*f*fd*s + 36*D1**2*bd1*f*fd - 140*D1**2*bd1*f*g2*r**2 - 280*D1**2*bd1*f*g2*r*s + 392*D1**2*bd1*f*g2*r - 140*D1**2*bd1*f*g2*s**2 + 392*D1**2*bd1*f*g2*s - 196*D1**2*bd1*f*g2 + 280*D1**2*bd1*f*gd2*r**2 + 560*D1**2*bd1*f*gd2*r*s - 616*D1**2*bd1*f*gd2*r + 280*D1**2*bd1*f*gd2*s**2 - 616*D1**2*bd1*f*gd2*s + 336*D1**2*bd1*f*gd2 + 280*D1**2*bd1*fd*g2*r**2 + 560*D1**2*bd1*fd*g2*r*s - 280*D1**2*bd1*fd*g2*r + 280*D1**2*bd1*fd*g2*s**2 - 280*D1**2*bd1*fd*g2*s + 58*D1**2*bd2*f**2*r**2 + 116*D1**2*bd2*f**2*r*s - 116*D1**2*bd2*f**2*r + 58*D1**2*bd2*f**2*s**2 - 116*D1**2*bd2*f**2*s + 58*D1**2*bd2*f**2 - 144*D1**2*bd2*f*fd*r**2 - 288*D1**2*bd2*f*fd*r*s + 216*D1**2*bd2*f*fd*r - 144*D1**2*bd2*f*fd*s**2 + 216*D1**2*bd2*f*fd*s - 72*D1**2*bd2*f*fd + 45*D1**2*bdd1*f**3*r**2 + 90*D1**2*bdd1*f**3*r*s - 60*D1**2*bdd1*f**3*r + 45*D1**2*bdd1*f**3*s**2 - 60*D1**2*bdd1*f**3*s + 30*D1**2*bdd1*f**3 + 18*D1**2*bdd1*f**2*r**2 + 36*D1**2*bdd1*f**2*r*s - 36*D1**2*bdd1*f**2*r + 18*D1**2*bdd1*f**2*s**2 - 36*D1**2*bdd1*f**2*s + 18*D1**2*bdd1*f**2 + 140*D1**2*bdd1*f*g2*r**2 + 280*D1**2*bdd1*f*g2*r*s - 336*D1**2*bdd1*f*g2*r + 140*D1**2*bdd1*f*g2*s**2 - 336*D1**2*bdd1*f*g2*s + 168*D1**2*bdd1*f*g2 - 36*D1**2*bdd2*f**2*r**2 - 72*D1**2*bdd2*f**2*r*s + 72*D1**2*bdd2*f**2*r - 36*D1**2*bdd2*f**2*s**2 + 72*D1**2*bdd2*f**2*s - 36*D1**2*bdd2*f**2 + 63*D1**2*f**2*fd*r**2 + 126*D1**2*f**2*fd*r*s - 84*D1**2*f**2*fd*r + 63*D1**2*f**2*fd*s**2 - 84*D1**2*f**2*fd*s + 42*D1**2*f**2*fd - 116*D1**2*f**2*gd2*r**2 - 232*D1**2*f**2*gd2*r*s + 232*D1**2*f**2*gd2*r - 116*D1**2*f**2*gd2*s**2 + 232*D1**2*f**2*gd2*s - 116*D1**2*f**2*gd2 + 72*D1**2*f**2*gdd2*r**2 + 144*D1**2*f**2*gdd2*r*s - 144*D1**2*f**2*gdd2*r + 72*D1**2*f**2*gdd2*s**2 - 144*D1**2*f**2*gdd2*s + 72*D1**2*f**2*gdd2 - 232*D1**2*f*fd*g2*r**2 - 464*D1**2*f*fd*g2*r*s + 232*D1**2*f*fd*g2*r - 232*D1**2*f*fd*g2*s**2 + 232*D1**2*f*fd*g2*s - 116*D1**2*f*fd*g2 + 288*D1**2*f*fd*gd2*r**2 + 576*D1**2*f*fd*gd2*r*s - 432*D1**2*f*fd*gd2*r + 288*D1**2*f*fd*gd2*s**2 - 432*D1**2*f*fd*gd2*s + 144*D1**2*f*fd*gd2 + 144*D1**2*f*fdd*g2*r**2 + 288*D1**2*f*fdd*g2*r*s - 144*D1**2*f*fdd*g2*r + 144*D1**2*f*fdd*g2*s**2 - 144*D1**2*f*fdd*g2*s + 72*D1**2*f*fdd*g2 + 144*D1**2*fd**2*g2*r**2 + 288*D1**2*fd**2*g2*r*s - 144*D1**2*fd**2*g2*r + 144*D1**2*fd**2*g2*s**2 - 144*D1**2*fd**2*g2*s - 288*D1*Dd*K*bd1*f**2*r**2 - 576*D1*Dd*K*bd1*f**2*r*s + 504*D1*Dd*K*bd1*f**2*r - 288*D1*Dd*K*bd1*f**2*s**2 + 504*D1*Dd*K*bd1*f**2*s - 216*D1*Dd*K*bd1*f**2 + 360*D1*Dd*bd1*f**3*r**2 + 720*D1*Dd*bd1*f**3*r*s - 510*D1*Dd*bd1*f**3*r + 360*D1*Dd*bd1*f**3*s**2 - 510*D1*Dd*bd1*f**3*s + 180*D1*Dd*bd1*f**3 + 144*D1*Dd*bd1*f**2*r**2 + 288*D1*Dd*bd1*f**2*r*s - 252*D1*Dd*bd1*f**2*r + 144*D1*Dd*bd1*f**2*s**2 - 252*D1*Dd*bd1*f**2*s + 108*D1*Dd*bd1*f**2 + 1120*D1*Dd*bd1*f*g2*r**2 + 2240*D1*Dd*bd1*f*g2*r*s - 2184*D1*Dd*bd1*f*g2*r + 1120*D1*Dd*bd1*f*g2*s**2 - 2184*D1*Dd*bd1*f*g2*s + 1008*D1*Dd*bd1*f*g2 - 288*D1*Dd*bd2*f**2*r**2 - 576*D1*Dd*bd2*f**2*r*s + 504*D1*Dd*bd2*f**2*r - 288*D1*Dd*bd2*f**2*s**2 + 504*D1*Dd*bd2*f**2*s - 216*D1*Dd*bd2*f**2 + 84*D1*Dd*f**3*r**2 + 168*D1*Dd*f**3*r*s - 126*D1*Dd*f**3*r + 84*D1*Dd*f**3*s**2 - 126*D1*Dd*f**3*s + 63*D1*Dd*f**3 - 464*D1*Dd*f**2*g2*r**2 - 928*D1*Dd*f**2*g2*r*s + 696*D1*Dd*f**2*g2*r - 464*D1*Dd*f**2*g2*s**2 + 696*D1*Dd*f**2*g2*s - 348*D1*Dd*f**2*g2 + 576*D1*Dd*f**2*gd2*r**2 + 1152*D1*Dd*f**2*gd2*r*s - 1008*D1*Dd*f**2*gd2*r + 576*D1*Dd*f**2*gd2*s**2 - 1008*D1*Dd*f**2*gd2*s + 432*D1*Dd*f**2*gd2 + 1152*D1*Dd*f*fd*g2*r**2 + 2304*D1*Dd*f*fd*g2*r*s - 1440*D1*Dd*f*fd*g2*r + 1152*D1*Dd*f*fd*g2*s**2 - 1440*D1*Dd*f*fd*g2*s + 432*D1*Dd*f*fd*g2 + 288*D1*Ddd*f**2*g2*r**2 + 576*D1*Ddd*f**2*g2*r*s - 432*D1*Ddd*f**2*g2*r + 288*D1*Ddd*f**2*g2*s**2 - 432*D1*Ddd*f**2*g2*s + 216*D1*Ddd*f**2*g2 + 864*Dd**2*f**2*g2*r**2 + 1728*Dd**2*f**2*g2*r*s - 1296*Dd**2*f**2*g2*r + 864*Dd**2*f**2*g2*s**2 - 1296*Dd**2*f**2*g2*s + 432*Dd**2*f**2*g2 + 7*b1**3*(D1**2*(8*fd - 9*fdd)*(r + s - 1)**2 + D1*(2*Dd*(4*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 9*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 9*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 9*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(140*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 140*C*D1**2*fd*s**2 - 280*C*D1**2*fd*s + 140*C*D1**2*fd + 560*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 840*C*D1*Dd*f*r + 560*C*D1*Dd*f*s**2 - 840*C*D1*Dd*f*s + 420*C*D1*Dd*f + 70*D1**2*K*fd*r**2 + 140*D1**2*K*fd*r*s + 56*D1**2*K*fd*r + 70*D1**2*K*fd*s**2 + 56*D1**2*K*fd*s - 28*D1**2*K*fd - 70*D1**2*K*fdd*r**2 - 140*D1**2*K*fdd*r*s - 28*D1**2*K*fdd*r - 70*D1**2*K*fdd*s**2 - 28*D1**2*K*fdd*s + 14*D1**2*K*fdd - 7*D1**2*bdd1*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 76*D1**2*f*fd*r**2 - 152*D1**2*f*fd*r*s + 34*D1**2*f*fd*r - 76*D1**2*f*fd*s**2 + 34*D1**2*f*fd*s - 17*D1**2*f*fd + 108*D1**2*f*fdd*r**2 + 216*D1**2*f*fdd*r*s - 108*D1**2*f*fdd*r + 108*D1**2*f*fdd*s**2 - 108*D1**2*f*fdd*s + 54*D1**2*f*fdd + 108*D1**2*fd**2*r**2 + 216*D1**2*fd**2*r*s - 108*D1**2*fd**2*r + 108*D1**2*fd**2*s**2 - 108*D1**2*fd**2*s - 140*D1**2*fd*r**2 - 280*D1**2*fd*r*s + 182*D1**2*fd*r - 140*D1**2*fd*s**2 + 182*D1**2*fd*s - 91*D1**2*fd + 35*D1**2*fdd*r**2 + 70*D1**2*fdd*r*s + 14*D1**2*fdd*r + 35*D1**2*fdd*s**2 + 14*D1**2*fdd*s - 7*D1**2*fdd + 280*D1**2*gd2*r**2 + 560*D1**2*gd2*r*s - 560*D1**2*gd2*r + 280*D1**2*gd2*s**2 - 560*D1**2*gd2*s + 280*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 + 280*D1*Dd*K*f*r**2 + 560*D1*Dd*K*f*r*s - 420*D1*Dd*K*f*r + 280*D1*Dd*K*f*s**2 - 420*D1*Dd*K*f*s + 210*D1*Dd*K*f - 560*D1*Dd*K*fd*r**2 - 1120*D1*Dd*K*fd*r*s + 308*D1*Dd*K*fd*r - 560*D1*Dd*K*fd*s**2 + 308*D1*Dd*K*fd*s + 84*D1*Dd*K*fd - 152*D1*Dd*f**2*r**2 - 304*D1*Dd*f**2*r*s + 228*D1*Dd*f**2*r - 152*D1*Dd*f**2*s**2 + 228*D1*Dd*f**2*s - 114*D1*Dd*f**2 + 864*D1*Dd*f*fd*r**2 + 1728*D1*Dd*f*fd*r*s - 1080*D1*Dd*f*fd*r + 864*D1*Dd*f*fd*s**2 - 1080*D1*Dd*f*fd*s + 324*D1*Dd*f*fd - 560*D1*Dd*f*r**2 - 1120*D1*Dd*f*r*s + 840*D1*Dd*f*r - 560*D1*Dd*f*s**2 + 840*D1*Dd*f*s - 420*D1*Dd*f + 280*D1*Dd*fd*r**2 + 560*D1*Dd*fd*r*s - 154*D1*Dd*fd*r + 280*D1*Dd*fd*s**2 - 154*D1*Dd*fd*s - 42*D1*Dd*fd + 1120*D1*Dd*g2*r**2 + 2240*D1*Dd*g2*r*s - 1680*D1*Dd*g2*r + 1120*D1*Dd*g2*s**2 - 1680*D1*Dd*g2*s + 840*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 - 280*D1*Ddd*K*f*r**2 - 560*D1*Ddd*K*f*r*s + 420*D1*Ddd*K*f*r - 280*D1*Ddd*K*f*s**2 + 420*D1*Ddd*K*f*s - 210*D1*Ddd*K*f + 216*D1*Ddd*f**2*r**2 + 432*D1*Ddd*f**2*r*s - 324*D1*Ddd*f**2*r + 216*D1*Ddd*f**2*s**2 - 324*D1*Ddd*f**2*s + 162*D1*Ddd*f**2 + 140*D1*Ddd*f*r**2 + 280*D1*Ddd*f*r*s - 210*D1*Ddd*f*r + 140*D1*Ddd*f*s**2 - 210*D1*Ddd*f*s + 105*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 + 14*D1*bd1*(D1*(4*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-10*K + 9*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 840*Dd**2*K*f*r**2 - 1680*Dd**2*K*f*r*s + 1260*Dd**2*K*f*r - 840*Dd**2*K*f*s**2 + 1260*Dd**2*K*f*s - 420*Dd**2*K*f + 648*Dd**2*f**2*r**2 + 1296*Dd**2*f**2*r*s - 972*Dd**2*f**2*r + 648*Dd**2*f**2*s**2 - 972*Dd**2*f**2*s + 324*Dd**2*f**2 + 420*Dd**2*f*r**2 + 840*Dd**2*f*r*s - 630*Dd**2*f*r + 420*Dd**2*f*s**2 - 630*Dd**2*f*s + 210*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) + b1*(-112*C*D1**2*f*fd*r**2 - 224*C*D1**2*f*fd*r*s + 56*C*D1**2*f*fd*r - 112*C*D1**2*f*fd*s**2 + 56*C*D1**2*f*fd*s - 28*C*D1**2*f*fd - 224*C*D1*Dd*f**2*r**2 - 448*C*D1*Dd*f**2*r*s + 336*C*D1*Dd*f**2*r - 224*C*D1*Dd*f**2*s**2 + 336*C*D1*Dd*f**2*s - 168*C*D1*Dd*f**2 - 140*D1**2*K*bdd1*f*r**2 - 280*D1**2*K*bdd1*f*r*s + 308*D1**2*K*bdd1*f*r - 140*D1**2*K*bdd1*f*s**2 + 308*D1**2*K*bdd1*f*s - 154*D1**2*K*bdd1*f + 116*D1**2*K*f*fd*r**2 + 232*D1**2*K*f*fd*r*s - 116*D1**2*K*f*fd*r + 116*D1**2*K*f*fd*s**2 - 116*D1**2*K*f*fd*s + 58*D1**2*K*f*fd - 72*D1**2*K*f*fdd*r**2 - 144*D1**2*K*f*fdd*r*s + 72*D1**2*K*f*fdd*r - 72*D1**2*K*f*fdd*s**2 + 72*D1**2*K*f*fdd*s - 36*D1**2*K*f*fdd - 72*D1**2*K*fd**2*r**2 - 144*D1**2*K*fd**2*r*s + 72*D1**2*K*fd**2*r - 72*D1**2*K*fd**2*s**2 + 72*D1**2*K*fd**2*s + 98*D1**2*b2*fd*r**2 + 196*D1**2*b2*fd*r*s + 98*D1**2*b2*fd*s**2 - 84*D1**2*b2*fdd*r**2 - 168*D1**2*b2*fdd*r*s - 84*D1**2*b2*fdd*s**2 - 14*D1**2*bd1**2*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 108*D1**2*bdd1*f**2*r**2 + 216*D1**2*bdd1*f**2*r*s - 216*D1**2*bdd1*f**2*r + 108*D1**2*bdd1*f**2*s**2 - 216*D1**2*bdd1*f**2*s + 108*D1**2*bdd1*f**2 + 70*D1**2*bdd1*f*r**2 + 140*D1**2*bdd1*f*r*s - 154*D1**2*bdd1*f*r + 70*D1**2*bdd1*f*s**2 - 154*D1**2*bdd1*f*s + 77*D1**2*bdd1*f - 280*D1**2*bdd1*g2*r**2 - 560*D1**2*bdd1*g2*r*s + 280*D1**2*bdd1*g2*r - 280*D1**2*bdd1*g2*s**2 + 280*D1**2*bdd1*g2*s - 140*D1**2*bdd1*g2 - 84*D1**2*bdd2*f*r**2 - 168*D1**2*bdd2*f*r*s + 168*D1**2*bdd2*f*r - 84*D1**2*bdd2*f*s**2 + 168*D1**2*bdd2*f*s - 84*D1**2*bdd2*f - 162*D1**2*f**2*fd*r**2 - 324*D1**2*f**2*fd*r*s + 246*D1**2*f**2*fd*r - 162*D1**2*f**2*fd*s**2 + 246*D1**2*f**2*fd*s - 123*D1**2*f**2*fd + 135*D1**2*f**2*fdd*r**2 + 270*D1**2*f**2*fdd*r*s - 210*D1**2*f**2*fdd*r + 135*D1**2*f**2*fdd*s**2 - 210*D1**2*f**2*fdd*s + 105*D1**2*f**2*fdd + 270*D1**2*f*fd**2*r**2 + 540*D1**2*f*fd**2*r*s - 420*D1**2*f*fd**2*r + 270*D1**2*f*fd**2*s**2 - 420*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 44*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 44*D1**2*f*fd*s - 22*D1**2*f*fd + 36*D1**2*f*fdd*r**2 + 72*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 18*D1**2*f*fdd - 140*D1**2*f*gd2*r**2 - 280*D1**2*f*gd2*r*s + 280*D1**2*f*gd2*r - 140*D1**2*f*gd2*s**2 + 280*D1**2*f*gd2*s - 140*D1**2*f*gd2 + 140*D1**2*f*gdd2*r**2 + 280*D1**2*f*gdd2*r*s - 280*D1**2*f*gdd2*r + 140*D1**2*f*gdd2*s**2 - 280*D1**2*f*gdd2*s + 140*D1**2*f*gdd2 + 36*D1**2*fd**2*r**2 + 72*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s - 140*D1**2*fd*g2*r**2 - 280*D1**2*fd*g2*r*s - 112*D1**2*fd*g2*r - 140*D1**2*fd*g2*s**2 - 112*D1**2*fd*g2*s + 56*D1**2*fd*g2 + 280*D1**2*fd*gd2*r**2 + 560*D1**2*fd*gd2*r*s - 224*D1**2*fd*gd2*r + 280*D1**2*fd*gd2*s**2 - 224*D1**2*fd*gd2*s - 56*D1**2*fd*gd2 + 140*D1**2*fdd*g2*r**2 + 280*D1**2*fdd*g2*r*s + 56*D1**2*fdd*g2*r + 140*D1**2*fdd*g2*s**2 + 56*D1**2*fdd*g2*s - 28*D1**2*fdd*g2 + 232*D1*Dd*K*f**2*r**2 + 464*D1*Dd*K*f**2*r*s - 348*D1*Dd*K*f**2*r + 232*D1*Dd*K*f**2*s**2 - 348*D1*Dd*K*f**2*s + 174*D1*Dd*K*f**2 - 576*D1*Dd*K*f*fd*r**2 - 1152*D1*Dd*K*f*fd*r*s + 720*D1*Dd*K*f*fd*r - 576*D1*Dd*K*f*fd*s**2 + 720*D1*Dd*K*f*fd*s - 216*D1*Dd*K*f*fd + 392*D1*Dd*b2*f*r**2 + 784*D1*Dd*b2*f*r*s - 588*D1*Dd*b2*f*r + 392*D1*Dd*b2*f*s**2 - 588*D1*Dd*b2*f*s + 294*D1*Dd*b2*f - 672*D1*Dd*b2*fd*r**2 - 1344*D1*Dd*b2*fd*r*s + 504*D1*Dd*b2*fd*r - 672*D1*Dd*b2*fd*s**2 + 504*D1*Dd*b2*fd*s - 216*D1*Dd*f**3*r**2 - 432*D1*Dd*f**3*r*s + 324*D1*Dd*f**3*r - 216*D1*Dd*f**3*s**2 + 324*D1*Dd*f**3*s - 162*D1*Dd*f**3 + 1080*D1*Dd*f**2*fd*r**2 + 2160*D1*Dd*f**2*fd*r*s - 1650*D1*Dd*f**2*fd*r + 1080*D1*Dd*f**2*fd*s**2 - 1650*D1*Dd*f**2*fd*s + 630*D1*Dd*f**2*fd - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 288*D1*Dd*f*fd*r**2 + 576*D1*Dd*f*fd*r*s - 360*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s**2 - 360*D1*Dd*f*fd*s + 108*D1*Dd*f*fd - 560*D1*Dd*f*g2*r**2 - 1120*D1*Dd*f*g2*r*s + 840*D1*Dd*f*g2*r - 560*D1*Dd*f*g2*s**2 + 840*D1*Dd*f*g2*s - 420*D1*Dd*f*g2 + 1120*D1*Dd*f*gd2*r**2 + 2240*D1*Dd*f*gd2*r*s - 1960*D1*Dd*f*gd2*r + 1120*D1*Dd*f*gd2*s**2 - 1960*D1*Dd*f*gd2*s + 840*D1*Dd*f*gd2 + 1120*D1*Dd*fd*g2*r**2 + 2240*D1*Dd*fd*g2*r*s - 616*D1*Dd*fd*g2*r + 1120*D1*Dd*fd*g2*s**2 - 616*D1*Dd*fd*g2*s - 168*D1*Dd*fd*g2 - 144*D1*Ddd*K*f**2*r**2 - 288*D1*Ddd*K*f**2*r*s + 216*D1*Ddd*K*f**2*r - 144*D1*Ddd*K*f**2*s**2 + 216*D1*Ddd*K*f**2*s - 108*D1*Ddd*K*f**2 - 336*D1*Ddd*b2*f*r**2 - 672*D1*Ddd*b2*f*r*s + 504*D1*Ddd*b2*f*r - 336*D1*Ddd*b2*f*s**2 + 504*D1*Ddd*b2*f*s - 252*D1*Ddd*b2*f + 180*D1*Ddd*f**3*r**2 + 360*D1*Ddd*f**3*r*s - 270*D1*Ddd*f**3*r + 180*D1*Ddd*f**3*s**2 - 270*D1*Ddd*f**3*s + 135*D1*Ddd*f**3 + 72*D1*Ddd*f**2*r**2 + 144*D1*Ddd*f**2*r*s - 108*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 108*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 560*D1*Ddd*f*g2*r**2 + 1120*D1*Ddd*f*g2*r*s - 840*D1*Ddd*f*g2*r + 560*D1*Ddd*f*g2*s**2 - 840*D1*Ddd*f*g2*s + 420*D1*Ddd*f*g2 + D1*bd1*(D1*(-f**2*(76*r**2 + 2*r*(76*s - 97) + 76*s**2 - 194*s + 97) + f*(140*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*K*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) + 216*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 280*r**2 - 560*r*s + 378*r - 280*s**2 + 378*s - 189) - 14*fd*(2*K - 1)*(10*r**2 + r*(20*s - 9) + 10*s**2 - 9*s - 1) + 280*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 280*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(4*r + 4*s - 3)*(108*f**2*(r + s - 1) - 7*f*(2*K - 1)*(10*r + 10*s - 11) - 140*g2*(2*r + 2*s - 1))) + 14*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 432*Dd**2*K*f**2*r**2 - 864*Dd**2*K*f**2*r*s + 648*Dd**2*K*f**2*r - 432*Dd**2*K*f**2*s**2 + 648*Dd**2*K*f**2*s - 216*Dd**2*K*f**2 - 1008*Dd**2*b2*f*r**2 - 2016*Dd**2*b2*f*r*s + 1512*Dd**2*b2*f*r - 1008*Dd**2*b2*f*s**2 + 1512*Dd**2*b2*f*s - 504*Dd**2*b2*f + 540*Dd**2*f**3*r**2 + 1080*Dd**2*f**3*r*s - 810*Dd**2*f**3*r + 540*Dd**2*f**3*s**2 - 810*Dd**2*f**3*s + 270*Dd**2*f**3 + 216*Dd**2*f**2*r**2 + 432*Dd**2*f**2*r*s - 324*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 324*Dd**2*f**2*s + 108*Dd**2*f**2 + 1680*Dd**2*f*g2*r**2 + 3360*Dd**2*f*g2*r*s - 2520*Dd**2*f*g2*r + 1680*Dd**2*f*g2*s**2 - 2520*Dd**2*f*g2*s + 840*Dd**2*f*g2) + 2*b2*(-42*D1**2*bdd1*f*(r + s - 1)**2 + 58*D1**2*f*fd*r**2 + 116*D1**2*f*fd*r*s - 58*D1**2*f*fd*r + 58*D1**2*f*fd*s**2 - 58*D1**2*f*fd*s + 29*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 116*D1*Dd*f**2*r**2 + 232*D1*Dd*f**2*r*s - 174*D1*Dd*f**2*r + 116*D1*Dd*f**2*s**2 - 174*D1*Dd*f**2*s + 87*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 + 7*D1*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2))/(210*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct*k1*k2*st**2*(-D1*f*(r + s)*(14*D1*bd1**2*(12*C - 7)*(r + s - 1) + 3*D1*bdd1*f*(12*C - 7)*(r + s) + bd1*(-D1*f*(44*C - 21)*(r + s) + D1*fd*(144*C - 84)*(r + s - 1) + Dd*f*(72*C - 42)*(4*r + 4*s - 3))) + 7*b1**2*(D1**2*(r + s - 1)**2*(4*C*fd + fd + fdd*(7 - 12*C)) + D1*(Dd*(f*(4*C + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(14 - 24*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(12*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(72*C - 42)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(88*C*D1**2*f*fd*r**2 + 176*C*D1**2*f*fd*r*s - 176*C*D1**2*f*fd*r + 88*C*D1**2*f*fd*s**2 - 176*C*D1**2*f*fd*s + 88*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r**2 - 144*C*D1**2*f*fdd*r*s + 144*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s**2 + 144*C*D1**2*f*fdd*s - 72*C*D1**2*f*fdd - 72*C*D1**2*fd**2*r**2 - 144*C*D1**2*fd**2*r*s + 144*C*D1**2*fd**2*r - 72*C*D1**2*fd**2*s**2 + 144*C*D1**2*fd**2*s - 72*C*D1**2*fd**2 + 176*C*D1*Dd*f**2*r**2 + 352*C*D1*Dd*f**2*r*s - 264*C*D1*Dd*f**2*r + 176*C*D1*Dd*f**2*s**2 - 264*C*D1*Dd*f**2*s + 132*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r**2 - 1152*C*D1*Dd*f*fd*r*s + 1008*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 1008*C*D1*Dd*f*fd*s - 432*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r**2 - 288*C*D1*Ddd*f**2*r*s + 216*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 216*C*D1*Ddd*f**2*s - 108*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r**2 - 864*C*Dd**2*f**2*r*s + 648*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 648*C*Dd**2*f**2*s - 216*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(12*C - 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 42*D1**2*f*fd*r**2 - 84*D1**2*f*fd*r*s + 84*D1**2*f*fd*r - 42*D1**2*f*fd*s**2 + 84*D1**2*f*fd*s - 42*D1**2*f*fd + 42*D1**2*f*fdd*r**2 + 84*D1**2*f*fdd*r*s - 84*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 84*D1**2*f*fdd*s + 42*D1**2*f*fdd + 42*D1**2*fd**2*r**2 + 84*D1**2*fd**2*r*s - 84*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 84*D1**2*fd**2*s + 42*D1**2*fd**2 - 84*D1*Dd*f**2*r**2 - 168*D1*Dd*f**2*r*s + 126*D1*Dd*f**2*r - 84*D1*Dd*f**2*s**2 + 126*D1*Dd*f**2*s - 63*D1*Dd*f**2 + 336*D1*Dd*f*fd*r**2 + 672*D1*Dd*f*fd*r*s - 588*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 588*D1*Dd*f*fd*s + 252*D1*Dd*f*fd + 84*D1*Ddd*f**2*r**2 + 168*D1*Ddd*f**2*r*s - 126*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 126*D1*Ddd*f**2*s + 63*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(4*C + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(14 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(14 - 24*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 252*Dd**2*f**2*r**2 + 504*Dd**2*f**2*r*s - 378*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 378*Dd**2*f**2*s + 126*Dd**2*f**2))/(210*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct*k1*k2*(-2*D1*(r + s)*(-D1*bd1**2*(15*f**2 + f*(21 - 42*K) + 140*g2)*(r + s - 1) - 42*D1*bdd1*f*g2*(r + s) + 7*b2*(10*D1*bd1**2*(r + s - 1) + 3*D1*bdd1*f*(r + s) + bd1*(-D1*f*(r + s) + 6*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3))) + 14*bd1*(3*D1*bd2*f*(r + s - 1) + D1*(f*g2*(r + s) - 6*f*gd2*(r + s - 1) - 6*fd*g2*(r + s - 1)) - 6*Dd*f*g2*(4*r + 4*s - 3))) - 7*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-210*D1**2*K*bdd1*r**2 - 420*D1**2*K*bdd1*r*s + 280*D1**2*K*bdd1*r - 210*D1**2*K*bdd1*s**2 + 280*D1**2*K*bdd1*s - 140*D1**2*K*bdd1 + 14*D1**2*K*fd*r**2 + 28*D1**2*K*fd*r*s - 28*D1**2*K*fd*r + 14*D1**2*K*fd*s**2 - 28*D1**2*K*fd*s + 14*D1**2*K*fd - 42*D1**2*K*fdd*r**2 - 84*D1**2*K*fdd*r*s + 84*D1**2*K*fdd*r - 42*D1**2*K*fdd*s**2 + 84*D1**2*K*fdd*s - 42*D1**2*K*fdd + 63*D1**2*bdd1*f*r**2 + 126*D1**2*bdd1*f*r*s - 84*D1**2*bdd1*f*r + 63*D1**2*bdd1*f*s**2 - 84*D1**2*bdd1*f*s + 42*D1**2*bdd1*f + 105*D1**2*bdd1*r**2 + 210*D1**2*bdd1*r*s - 140*D1**2*bdd1*r + 105*D1**2*bdd1*s**2 - 140*D1**2*bdd1*s + 70*D1**2*bdd1 - 70*D1**2*bdd2*r**2 - 140*D1**2*bdd2*r*s + 140*D1**2*bdd2*r - 70*D1**2*bdd2*s**2 + 140*D1**2*bdd2*s - 70*D1**2*bdd2 - 18*D1**2*f*fd*r**2 - 36*D1**2*f*fd*r*s + 36*D1**2*f*fd*r - 18*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 18*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s + 30*D1**2*f*fdd + 30*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 60*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s + 30*D1**2*fd**2 - 7*D1**2*fd*r**2 - 14*D1**2*fd*r*s + 14*D1**2*fd*r - 7*D1**2*fd*s**2 + 14*D1**2*fd*s - 7*D1**2*fd + 21*D1**2*fdd*r**2 + 42*D1**2*fdd*r*s - 42*D1**2*fdd*r + 21*D1**2*fdd*s**2 - 42*D1**2*fdd*s + 21*D1**2*fdd + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 + 140*D1**2*gdd2*r**2 + 280*D1**2*gdd2*r*s - 280*D1**2*gdd2*r + 140*D1**2*gdd2*s**2 - 280*D1**2*gdd2*s + 140*D1**2*gdd2 + 56*D1*Dd*K*f*r**2 + 112*D1*Dd*K*f*r*s - 84*D1*Dd*K*f*r + 56*D1*Dd*K*f*s**2 - 84*D1*Dd*K*f*s + 42*D1*Dd*K*f - 336*D1*Dd*K*fd*r**2 - 672*D1*Dd*K*fd*r*s + 588*D1*Dd*K*fd*r - 336*D1*Dd*K*fd*s**2 + 588*D1*Dd*K*fd*s - 252*D1*Dd*K*fd - 280*D1*Dd*b2*r**2 - 560*D1*Dd*b2*r*s + 420*D1*Dd*b2*r - 280*D1*Dd*b2*s**2 + 420*D1*Dd*b2*s - 210*D1*Dd*b2 - 36*D1*Dd*f**2*r**2 - 72*D1*Dd*f**2*r*s + 54*D1*Dd*f**2*r - 36*D1*Dd*f**2*s**2 + 54*D1*Dd*f**2*s - 27*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 420*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 420*D1*Dd*f*fd*s + 180*D1*Dd*f*fd - 28*D1*Dd*f*r**2 - 56*D1*Dd*f*r*s + 42*D1*Dd*f*r - 28*D1*Dd*f*s**2 + 42*D1*Dd*f*s - 21*D1*Dd*f + 168*D1*Dd*fd*r**2 + 336*D1*Dd*fd*r*s - 294*D1*Dd*fd*r + 168*D1*Dd*fd*s**2 - 294*D1*Dd*fd*s + 126*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 + 1120*D1*Dd*gd2*r**2 + 2240*D1*Dd*gd2*r*s - 1960*D1*Dd*gd2*r + 1120*D1*Dd*gd2*s**2 - 1960*D1*Dd*gd2*s + 840*D1*Dd*gd2 - 168*D1*Ddd*K*f*r**2 - 336*D1*Ddd*K*f*r*s + 252*D1*Ddd*K*f*r - 168*D1*Ddd*K*f*s**2 + 252*D1*Ddd*K*f*s - 126*D1*Ddd*K*f - 280*D1*Ddd*b2*r**2 - 560*D1*Ddd*b2*r*s + 420*D1*Ddd*b2*r - 280*D1*Ddd*b2*s**2 + 420*D1*Ddd*b2*s - 210*D1*Ddd*b2 + 60*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 90*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 90*D1*Ddd*f**2*s + 45*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 + 168*D1*Ddd*f*r*s - 126*D1*Ddd*f*r + 84*D1*Ddd*f*s**2 - 126*D1*Ddd*f*s + 63*D1*Ddd*f + 560*D1*Ddd*g2*r**2 + 1120*D1*Ddd*g2*r*s - 840*D1*Ddd*g2*r + 560*D1*Ddd*g2*s**2 - 840*D1*Ddd*g2*s + 420*D1*Ddd*g2 - 7*D1*bd1*(D1*(f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-10*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 70*D1*bd2*(D1*(r + s - 1) + 2*Dd*(4*r + 4*s - 3))*(r + s - 1) - 504*Dd**2*K*f*r**2 - 1008*Dd**2*K*f*r*s + 756*Dd**2*K*f*r - 504*Dd**2*K*f*s**2 + 756*Dd**2*K*f*s - 252*Dd**2*K*f - 840*Dd**2*b2*r**2 - 1680*Dd**2*b2*r*s + 1260*Dd**2*b2*r - 840*Dd**2*b2*s**2 + 1260*Dd**2*b2*s - 420*Dd**2*b2 + 180*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 270*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 270*Dd**2*f**2*s + 90*Dd**2*f**2 + 252*Dd**2*f*r**2 + 504*Dd**2*f*r*s - 378*Dd**2*f*r + 252*Dd**2*f*s**2 - 378*Dd**2*f*s + 126*Dd**2*f + 1680*Dd**2*g2*r**2 + 3360*Dd**2*g2*r*s - 2520*Dd**2*g2*r + 1680*Dd**2*g2*s**2 - 2520*Dd**2*g2*s + 840*Dd**2*g2) + b1*(-84*D1**2*K*bdd1*f*r**2 - 168*D1**2*K*bdd1*f*r*s + 84*D1**2*K*bdd1*f*r - 84*D1**2*K*bdd1*f*s**2 + 84*D1**2*K*bdd1*f*s - 42*D1**2*K*bdd1*f + 14*D1**2*bd1**2*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 14*D1**2*bd2*f*r**2 + 28*D1**2*bd2*f*r*s - 28*D1**2*bd2*f*r + 14*D1**2*bd2*f*s**2 - 28*D1**2*bd2*f*s + 14*D1**2*bd2*f - 84*D1**2*bd2*fd*r**2 - 168*D1**2*bd2*fd*r*s + 168*D1**2*bd2*fd*r - 84*D1**2*bd2*fd*s**2 + 168*D1**2*bd2*fd*s - 84*D1**2*bd2*fd + 30*D1**2*bdd1*f**2*r**2 + 60*D1**2*bdd1*f**2*r*s - 30*D1**2*bdd1*f**2*r + 30*D1**2*bdd1*f**2*s**2 - 30*D1**2*bdd1*f**2*s + 15*D1**2*bdd1*f**2 + 42*D1**2*bdd1*f*r**2 + 84*D1**2*bdd1*f*r*s - 42*D1**2*bdd1*f*r + 42*D1**2*bdd1*f*s**2 - 42*D1**2*bdd1*f*s + 21*D1**2*bdd1*f + 280*D1**2*bdd1*g2*r**2 + 560*D1**2*bdd1*g2*r*s - 280*D1**2*bdd1*g2*r + 280*D1**2*bdd1*g2*s**2 - 280*D1**2*bdd1*g2*s + 140*D1**2*bdd1*g2 - 42*D1**2*bdd2*f*r**2 - 84*D1**2*bdd2*f*r*s + 84*D1**2*bdd2*f*r - 42*D1**2*bdd2*f*s**2 + 84*D1**2*bdd2*f*s - 42*D1**2*bdd2*f - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 84*D1**2*f*gdd2*r**2 + 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*r + 84*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s + 84*D1**2*f*gdd2 - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 168*D1**2*fd*gd2*r**2 + 336*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 336*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 + 84*D1**2*fdd*g2*r**2 + 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r + 84*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 - 336*D1*Dd*bd2*f*r**2 - 672*D1*Dd*bd2*f*r*s + 588*D1*Dd*bd2*f*r - 336*D1*Dd*bd2*f*s**2 + 588*D1*Dd*bd2*f*s - 252*D1*Dd*bd2*f - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r**2 + 1344*D1*Dd*f*gd2*r*s - 1176*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 1176*D1*Dd*f*gd2*s + 504*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r**2 + 1344*D1*Dd*fd*g2*r*s - 1176*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 1176*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 + 336*D1*Ddd*f*g2*r**2 + 672*D1*Ddd*f*g2*r*s - 504*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 504*D1*Ddd*f*g2*s + 252*D1*Ddd*f*g2 + D1*bd1*(-140*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-9*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(60*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + (14*K - 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) - 42*fd*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 140*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 280*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(15*f**2 + f*(21 - 42*K) + 140*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 1008*Dd**2*f*g2*r**2 + 2016*Dd**2*f*g2*r*s - 1512*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1512*Dd**2*f*g2*s + 504*Dd**2*f*g2 - 14*b2*(5*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - D1**2*fd*r**2 - 2*D1**2*fd*r*s + 2*D1**2*fd*r - D1**2*fd*s**2 + 2*D1**2*fd*s - D1**2*fd + 3*D1**2*fdd*r**2 + 6*D1**2*fdd*r*s - 6*D1**2*fdd*r + 3*D1**2*fdd*s**2 - 6*D1**2*fdd*s + 3*D1**2*fdd - 4*D1*Dd*f*r**2 - 8*D1*Dd*f*r*s + 6*D1*Dd*f*r - 4*D1*Dd*f*s**2 + 6*D1*Dd*f*s - 3*D1*Dd*f + 24*D1*Dd*fd*r**2 + 48*D1*Dd*fd*r*s - 42*D1*Dd*fd*r + 24*D1*Dd*fd*s**2 - 42*D1*Dd*fd*s + 18*D1*Dd*fd + 12*D1*Ddd*f*r**2 + 24*D1*Ddd*f*r*s - 18*D1*Ddd*f*r + 12*D1*Ddd*f*s**2 - 18*D1*Ddd*f*s + 9*D1*Ddd*f + 5*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 36*Dd**2*f*r**2 + 72*Dd**2*f*r*s - 54*Dd**2*f*r + 36*Dd**2*f*s**2 - 54*Dd**2*f*s + 18*Dd**2*f)))/(210*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct*k2**5*st**6*(-36*D1**2*b1*f*fd*r**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(r + s - 1)**2 - 6*D1**2*f**2*fd*r**2 - 12*D1**2*f**2*fd*r*s + 8*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 8*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 6*D1**2*f**2*fdd*r*s - 4*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 4*D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 12*D1**2*f*fd**2*r*s - 8*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 8*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 - 72*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 108*D1*Dd*b1*f**2*s - 54*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 8*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 48*D1*Dd*f**2*fd*r*s - 34*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 34*D1*Dd*f**2*fd*s + 12*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 8*D1*Ddd*f**3*r*s - 6*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 6*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 - 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 24*Dd**2*f**3*r*s - 18*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 18*Dd**2*f**3*s + 6*Dd**2*f**3)/(126*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct*k2**5*st**4*(D1*f*(6*D1*bd1**2*(r + s - 1)*(5*f*(2*r + 2*s - 1) + 7*r + 7*s - 7) + bd1*(D1*(-10*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*f*(r + s - 1)*(4*fd*(3*r + 3*s - 1) + 3*r + 3*s - 3) + 6*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(4*r + 4*s - 3)*(5*f*(2*r + 2*s - 1) + 3*r + 3*s - 3)) + f*(5*D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*D1*bdd1*(r + s - 1)**2 + 3*D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 3*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) - 3*b1**2*(D1**2*(5*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 14*fd*(r + s)**2 - 7*fdd*(r + s)**2) + D1*(2*Dd*(10*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-5*fd*(4*r + 4*s - 3)**2 + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) - 7*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(10*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(10*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(3*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 14*(r + s - 1)**2) - 60*D1**2*f**2*fd*r**2 - 120*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 60*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r**2 + 60*D1**2*f**2*fdd*r*s - 50*D1**2*f**2*fdd*r + 30*D1**2*f**2*fdd*s**2 - 50*D1**2*f**2*fdd*s + 25*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 + 120*D1**2*f*fd**2*r*s - 100*D1**2*f*fd**2*r + 60*D1**2*f*fd**2*s**2 - 100*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 + 30*D1**2*f*fd*r**2 + 60*D1**2*f*fd*r*s - 30*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 30*D1**2*f*fd*s + 15*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 6*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 6*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 6*D1**2*fd**2*s - 80*D1*Dd*f**3*r**2 - 160*D1*Dd*f**3*r*s + 120*D1*Dd*f**3*r - 80*D1*Dd*f**3*s**2 + 120*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r**2 + 480*D1*Dd*f**2*fd*r*s - 380*D1*Dd*f**2*fd*r + 240*D1*Dd*f**2*fd*s**2 - 380*D1*Dd*f**2*fd*s + 150*D1*Dd*f**2*fd + 60*D1*Dd*f**2*r**2 + 120*D1*Dd*f**2*r*s - 90*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 90*D1*Dd*f**2*s + 45*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 60*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 40*D1*Ddd*f**3*r**2 + 80*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 40*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + 12*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 - 6*D1*bd1*(D1*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(r + s - 1)*(10*fd*(2*r + 2*s - 1) - 7*r - 7*s + 7) - 14*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 14*r + 14*s - 14)) + 120*Dd**2*f**3*r**2 + 240*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 120*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 60*Dd**2*f**3 + 36*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 18*Dd**2*f**2))/(210*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct*k2**3*st**4*(D1*f*(r + s)*(14*D1*bd1**2*(r + s - 1) + D1*bdd1*f*(r + s) + bd1*(-2*D1*f*(r + s) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3))) - 7*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(7*D1**2*bdd1*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 4*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 4*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 4*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 4*D1**2*f*fdd*s + 2*D1**2*f*fdd + 2*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 4*D1**2*fd**2*s + 2*D1**2*fd**2 - 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 32*D1*Dd*f*fd*r*s - 28*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 28*D1*Dd*f*fd*s + 12*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 - 14*D1*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 12*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 18*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s + 6*Dd**2*f**2))/(70*d**2*k1*k3**2) + D1**2*Pk1*Pkdd3*ct*k2**3*st**2*(D1**2*bd1*f*(r + s)*(2*bd1*(9*f + 7)*(r + s - 1) + 7*f*(r + s)) + D1*b1*(14*D1*bd1**2*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + bd1*(D1*(-18*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*f*(12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 14*r**2 + 28*r*s - 14*r + 14*s**2 - 14*s + 7) + 14*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(9*f + 7)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + f*(D1*bdd1*(9*f + 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*D1*fd*(r + s - 1)**2 + 7*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) - 7*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 20*r**2 + 40*r*s - 30*r + 20*s**2 - 30*s + 15) - Ddd*(3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(7*D1**2*bdd1*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 36*D1**2*f*fd*r**2 - 72*D1**2*f*fd*r*s + 72*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 72*D1**2*f*fd*s - 36*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 36*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 18*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 36*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s + 18*D1**2*fd**2 + 21*D1**2*fd*r**2 + 42*D1**2*fd*r*s - 42*D1**2*fd*r + 21*D1**2*fd*s**2 - 42*D1**2*fd*s + 21*D1**2*fd + 7*D1**2*fdd*r**2 + 14*D1**2*fdd*r*s - 14*D1**2*fdd*r + 7*D1**2*fdd*s**2 - 14*D1**2*fdd*s + 7*D1**2*fdd - 72*D1*Dd*f**2*r**2 - 144*D1*Dd*f**2*r*s + 108*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 108*D1*Dd*f**2*s - 54*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 288*D1*Dd*f*fd*r*s - 252*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 252*D1*Dd*f*fd*s + 108*D1*Dd*f*fd + 84*D1*Dd*f*r**2 + 168*D1*Dd*f*r*s - 126*D1*Dd*f*r + 84*D1*Dd*f*s**2 - 126*D1*Dd*f*s + 63*D1*Dd*f + 56*D1*Dd*fd*r**2 + 112*D1*Dd*fd*r*s - 98*D1*Dd*fd*r + 56*D1*Dd*fd*s**2 - 98*D1*Dd*fd*s + 42*D1*Dd*fd + 36*D1*Ddd*f**2*r**2 + 72*D1*Ddd*f**2*r*s - 54*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 54*D1*Ddd*f**2*s + 27*D1*Ddd*f**2 + 28*D1*Ddd*f*r**2 + 56*D1*Ddd*f*r*s - 42*D1*Ddd*f*r + 28*D1*Ddd*f*s**2 - 42*D1*Ddd*f*s + 21*D1*Ddd*f - 14*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 15*r**2 + 30*r*s - 20*r + 15*s**2 - 20*s + 10) - Dd*(3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 108*Dd**2*f**2*r**2 + 216*Dd**2*f**2*r*s - 162*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 162*Dd**2*f**2*s + 54*Dd**2*f**2 + 84*Dd**2*f*r**2 + 168*Dd**2*f*r*s - 126*Dd**2*f*r + 84*Dd**2*f*s**2 - 126*Dd**2*f*s + 42*Dd**2*f))/(210*d**2*k1*k3**2) + D1**2*Pk1*Pkdd3*k1**6*st**2*(2*C - 1)*(6*D1**2*b1*f*fd*r**2 + 12*D1**2*b1*f*fd*r*s - 6*D1**2*b1*f*fd*r + 6*D1**2*b1*f*fd*s**2 - 6*D1**2*b1*f*fd*s + 3*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + 9*D1**2*bdd1*f**2*(r + s - 1)**2 - 3*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s**2 + 4*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 + 12*D1*Dd*b1*f**2*r**2 + 24*D1*Dd*b1*f**2*r*s - 18*D1*Dd*b1*f**2*r + 12*D1*Dd*b1*f**2*s**2 - 18*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 6*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 170*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 170*D1*Dd*f**2*fd*s + 60*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 3*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + 6*D1*fd*(2*r + 2*s - 1) + 6*Dd*f*(4*r + 4*s - 3)) + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 30*Dd**2*f**3)/(630*d**2*k3**6) - D1**2*Pk1*Pkdd3*k1**6*(7*D1**2*K*b1**2*fd*r**2 + 14*D1**2*K*b1**2*fd*r*s + 7*D1**2*K*b1**2*fd*s**2 - 21*D1**2*K*b1**2*fdd*r**2 - 42*D1**2*K*b1**2*fdd*r*s - 21*D1**2*K*b1**2*fdd*s**2 + 18*D1**2*K*b1*f*fd*r**2 + 36*D1**2*K*b1*f*fd*r*s - 18*D1**2*K*b1*f*fd*r + 18*D1**2*K*b1*f*fd*s**2 - 18*D1**2*K*b1*f*fd*s + 9*D1**2*K*b1*f*fd - 30*D1**2*K*b1*f*fdd*r**2 - 60*D1**2*K*b1*f*fdd*r*s + 30*D1**2*K*b1*f*fdd*r - 30*D1**2*K*b1*f*fdd*s**2 + 30*D1**2*K*b1*f*fdd*s - 15*D1**2*K*b1*f*fdd - 30*D1**2*K*b1*fd**2*r**2 - 60*D1**2*K*b1*fd**2*r*s + 30*D1**2*K*b1*fd**2*r - 30*D1**2*K*b1*fd**2*s**2 + 30*D1**2*K*b1*fd**2*s - 42*D1**2*K*bd1**2*f*(r + s - 1)**2 - 14*D1**2*b1*f*gd2*r**2 - 28*D1**2*b1*f*gd2*r*s + 28*D1**2*b1*f*gd2*r - 14*D1**2*b1*f*gd2*s**2 + 28*D1**2*b1*f*gd2*s - 14*D1**2*b1*f*gd2 + 42*D1**2*b1*f*gdd2*r**2 + 84*D1**2*b1*f*gdd2*r*s - 84*D1**2*b1*f*gdd2*r + 42*D1**2*b1*f*gdd2*s**2 - 84*D1**2*b1*f*gdd2*s + 42*D1**2*b1*f*gdd2 - 14*D1**2*b1*fd*g2*r**2 - 28*D1**2*b1*fd*g2*r*s - 14*D1**2*b1*fd*g2*s**2 + 84*D1**2*b1*fd*gd2*r**2 + 168*D1**2*b1*fd*gd2*r*s - 84*D1**2*b1*fd*gd2*r + 84*D1**2*b1*fd*gd2*s**2 - 84*D1**2*b1*fd*gd2*s + 42*D1**2*b1*fdd*g2*r**2 + 84*D1**2*b1*fdd*g2*r*s + 42*D1**2*b1*fdd*g2*s**2 - 3*D1**2*bdd1*f*(r + s - 1)**2*(14*K*b1 + 5*K*f - 14*g2) - 18*D1**2*f**2*gd2*r**2 - 36*D1**2*f**2*gd2*r*s + 36*D1**2*f**2*gd2*r - 18*D1**2*f**2*gd2*s**2 + 36*D1**2*f**2*gd2*s - 18*D1**2*f**2*gd2 + 30*D1**2*f**2*gdd2*r**2 + 60*D1**2*f**2*gdd2*r*s - 60*D1**2*f**2*gdd2*r + 30*D1**2*f**2*gdd2*s**2 - 60*D1**2*f**2*gdd2*s + 30*D1**2*f**2*gdd2 - 36*D1**2*f*fd*g2*r**2 - 72*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r - 36*D1**2*f*fd*g2*s**2 + 36*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 + 120*D1**2*f*fd*gd2*r**2 + 240*D1**2*f*fd*gd2*r*s - 180*D1**2*f*fd*gd2*r + 120*D1**2*f*fd*gd2*s**2 - 180*D1**2*f*fd*gd2*s + 60*D1**2*f*fd*gd2 + 60*D1**2*f*fdd*g2*r**2 + 120*D1**2*f*fdd*g2*r*s - 60*D1**2*f*fdd*g2*r + 60*D1**2*f*fdd*g2*s**2 - 60*D1**2*f*fdd*g2*s + 30*D1**2*f*fdd*g2 + 60*D1**2*fd**2*g2*r**2 + 120*D1**2*fd**2*g2*r*s - 60*D1**2*fd**2*g2*r + 60*D1**2*fd**2*g2*s**2 - 60*D1**2*fd**2*g2*s + 28*D1*Dd*K*b1**2*f*r**2 + 56*D1*Dd*K*b1**2*f*r*s - 42*D1*Dd*K*b1**2*f*r + 28*D1*Dd*K*b1**2*f*s**2 - 42*D1*Dd*K*b1**2*f*s + 21*D1*Dd*K*b1**2*f - 168*D1*Dd*K*b1**2*fd*r**2 - 336*D1*Dd*K*b1**2*fd*r*s + 126*D1*Dd*K*b1**2*fd*r - 168*D1*Dd*K*b1**2*fd*s**2 + 126*D1*Dd*K*b1**2*fd*s + 36*D1*Dd*K*b1*f**2*r**2 + 72*D1*Dd*K*b1*f**2*r*s - 54*D1*Dd*K*b1*f**2*r + 36*D1*Dd*K*b1*f**2*s**2 - 54*D1*Dd*K*b1*f**2*s + 27*D1*Dd*K*b1*f**2 - 240*D1*Dd*K*b1*f*fd*r**2 - 480*D1*Dd*K*b1*f*fd*r*s + 300*D1*Dd*K*b1*f*fd*r - 240*D1*Dd*K*b1*f*fd*s**2 + 300*D1*Dd*K*b1*f*fd*s - 90*D1*Dd*K*b1*f*fd - 56*D1*Dd*b1*f*g2*r**2 - 112*D1*Dd*b1*f*g2*r*s + 84*D1*Dd*b1*f*g2*r - 56*D1*Dd*b1*f*g2*s**2 + 84*D1*Dd*b1*f*g2*s - 42*D1*Dd*b1*f*g2 + 336*D1*Dd*b1*f*gd2*r**2 + 672*D1*Dd*b1*f*gd2*r*s - 588*D1*Dd*b1*f*gd2*r + 336*D1*Dd*b1*f*gd2*s**2 - 588*D1*Dd*b1*f*gd2*s + 252*D1*Dd*b1*f*gd2 + 336*D1*Dd*b1*fd*g2*r**2 + 672*D1*Dd*b1*fd*g2*r*s - 252*D1*Dd*b1*fd*g2*r + 336*D1*Dd*b1*fd*g2*s**2 - 252*D1*Dd*b1*fd*g2*s - 72*D1*Dd*f**2*g2*r**2 - 144*D1*Dd*f**2*g2*r*s + 108*D1*Dd*f**2*g2*r - 72*D1*Dd*f**2*g2*s**2 + 108*D1*Dd*f**2*g2*s - 54*D1*Dd*f**2*g2 + 240*D1*Dd*f**2*gd2*r**2 + 480*D1*Dd*f**2*gd2*r*s - 420*D1*Dd*f**2*gd2*r + 240*D1*Dd*f**2*gd2*s**2 - 420*D1*Dd*f**2*gd2*s + 180*D1*Dd*f**2*gd2 + 480*D1*Dd*f*fd*g2*r**2 + 960*D1*Dd*f*fd*g2*r*s - 600*D1*Dd*f*fd*g2*r + 480*D1*Dd*f*fd*g2*s**2 - 600*D1*Dd*f*fd*g2*s + 180*D1*Dd*f*fd*g2 - 84*D1*Ddd*K*b1**2*f*r**2 - 168*D1*Ddd*K*b1**2*f*r*s + 126*D1*Ddd*K*b1**2*f*r - 84*D1*Ddd*K*b1**2*f*s**2 + 126*D1*Ddd*K*b1**2*f*s - 63*D1*Ddd*K*b1**2*f - 60*D1*Ddd*K*b1*f**2*r**2 - 120*D1*Ddd*K*b1*f**2*r*s + 90*D1*Ddd*K*b1*f**2*r - 60*D1*Ddd*K*b1*f**2*s**2 + 90*D1*Ddd*K*b1*f**2*s - 45*D1*Ddd*K*b1*f**2 + 168*D1*Ddd*b1*f*g2*r**2 + 336*D1*Ddd*b1*f*g2*r*s - 252*D1*Ddd*b1*f*g2*r + 168*D1*Ddd*b1*f*g2*s**2 - 252*D1*Ddd*b1*f*g2*s + 126*D1*Ddd*b1*f*g2 + 120*D1*Ddd*f**2*g2*r**2 + 240*D1*Ddd*f**2*g2*r*s - 180*D1*Ddd*f**2*g2*r + 120*D1*Ddd*f**2*g2*s**2 - 180*D1*Ddd*f**2*g2*s + 90*D1*Ddd*f**2*g2 + D1*bd1*(D1*(9*K*f**2*(r + s - 1) - 2*f*(-7*K*b1*(r + s - 1) + 15*K*fd*(2*r + 2*s - 1) + 7*g2*(r + s - 1) - 42*gd2*(r + s - 1)) + 84*fd*(r + s)*(-K*b1 + g2)) - 6*Dd*f*(4*r + 4*s - 3)*(14*K*b1 + 5*K*f - 14*g2))*(r + s - 1) - 252*Dd**2*K*b1**2*f*r**2 - 504*Dd**2*K*b1**2*f*r*s + 378*Dd**2*K*b1**2*f*r - 252*Dd**2*K*b1**2*f*s**2 + 378*Dd**2*K*b1**2*f*s - 126*Dd**2*K*b1**2*f - 180*Dd**2*K*b1*f**2*r**2 - 360*Dd**2*K*b1*f**2*r*s + 270*Dd**2*K*b1*f**2*r - 180*Dd**2*K*b1*f**2*s**2 + 270*Dd**2*K*b1*f**2*s - 90*Dd**2*K*b1*f**2 + 504*Dd**2*b1*f*g2*r**2 + 1008*Dd**2*b1*f*g2*r*s - 756*Dd**2*b1*f*g2*r + 504*Dd**2*b1*f*g2*s**2 - 756*Dd**2*b1*f*g2*s + 252*Dd**2*b1*f*g2 + 360*Dd**2*f**2*g2*r**2 + 720*Dd**2*f**2*g2*r*s - 540*Dd**2*f**2*g2*r + 360*Dd**2*f**2*g2*s**2 - 540*Dd**2*f**2*g2*s + 180*Dd**2*f**2*g2)/(210*d**2*k3**6) - D1**2*Pk1*Pkdd3*k1**4*k2**2*st**4*(2*C - 1)*(10*D1**2*b1*f*fd*r**2 + 20*D1**2*b1*f*fd*r*s - 10*D1**2*b1*f*fd*r + 10*D1**2*b1*f*fd*s**2 - 10*D1**2*b1*f*fd*s + 5*D1**2*b1*f*fd - 12*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 12*D1**2*b1*f*fdd*r - 12*D1**2*b1*f*fdd*s**2 + 12*D1**2*b1*f*fdd*s - 6*D1**2*b1*f*fdd - 12*D1**2*b1*fd**2*r**2 - 24*D1**2*b1*fd**2*r*s + 12*D1**2*b1*fd**2*r - 12*D1**2*b1*fd**2*s**2 + 12*D1**2*b1*fd**2*s - 6*D1**2*bdd1*f**2*(r + s - 1)**2 + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 6*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 8*D1**2*f**2*fdd*r - 6*D1**2*f**2*fdd*s**2 + 8*D1**2*f**2*fdd*s - 4*D1**2*f**2*fdd - 12*D1**2*f*fd**2*r**2 - 24*D1**2*f*fd**2*r*s + 16*D1**2*f*fd**2*r - 12*D1**2*f*fd**2*s**2 + 16*D1**2*f*fd**2*s - 4*D1**2*f*fd**2 + 20*D1*Dd*b1*f**2*r**2 + 40*D1*Dd*b1*f**2*r*s - 30*D1*Dd*b1*f**2*r + 20*D1*Dd*b1*f**2*s**2 - 30*D1*Dd*b1*f**2*s + 15*D1*Dd*b1*f**2 - 96*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 120*D1*Dd*b1*f*fd*r - 96*D1*Dd*b1*f*fd*s**2 + 120*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 - 48*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 68*D1*Dd*f**2*fd*r - 48*D1*Dd*f**2*fd*s**2 + 68*D1*Dd*f**2*fd*s - 24*D1*Dd*f**2*fd - 24*D1*Ddd*b1*f**2*r**2 - 48*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r - 24*D1*Ddd*b1*f**2*s**2 + 36*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 - 8*D1*Ddd*f**3*r**2 - 16*D1*Ddd*f**3*r*s + 12*D1*Ddd*f**3*r - 8*D1*Ddd*f**3*s**2 + 12*D1*Ddd*f**3*s - 6*D1*Ddd*f**3 + D1*bd1*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*b1*f**2*r**2 - 144*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r - 72*Dd**2*b1*f**2*s**2 + 108*Dd**2*b1*f**2*s - 36*Dd**2*b1*f**2 - 24*Dd**2*f**3*r**2 - 48*Dd**2*f**3*r*s + 36*Dd**2*f**3*r - 24*Dd**2*f**3*s**2 + 36*Dd**2*f**3*s - 12*Dd**2*f**3)/(70*d**2*k3**6) - D1**2*Pk1*Pkdd3*k1**4*k2**2*st**2*(-594*C*D1**2*f**2*fd*r**2 - 1188*C*D1**2*f**2*fd*r*s + 792*C*D1**2*f**2*fd*r - 594*C*D1**2*f**2*fd*s**2 + 792*C*D1**2*f**2*fd*s - 396*C*D1**2*f**2*fd - 792*C*D1*Dd*f**3*r**2 - 1584*C*D1*Dd*f**3*r*s + 1188*C*D1*Dd*f**3*r - 792*C*D1*Dd*f**3*s**2 + 1188*C*D1*Dd*f**3*s - 594*C*D1*Dd*f**3 - 594*D1**2*K*bdd1*f**2*r**2 - 1188*D1**2*K*bdd1*f**2*r*s + 1188*D1**2*K*bdd1*f**2*r - 594*D1**2*K*bdd1*f**2*s**2 + 1188*D1**2*K*bdd1*f**2*s - 594*D1**2*K*bdd1*f**2 + 198*D1**2*bd1**2*f*(-14*K + 5*f)*(r + s - 1)**2 + 220*D1**2*bdd1*f**3*r**2 + 440*D1**2*bdd1*f**3*r*s - 440*D1**2*bdd1*f**3*r + 220*D1**2*bdd1*f**3*s**2 - 440*D1**2*bdd1*f**3*s + 220*D1**2*bdd1*f**3 + 2772*D1**2*bdd1*f*g2*r**2 + 5544*D1**2*bdd1*f*g2*r*s - 5544*D1**2*bdd1*f*g2*r + 2772*D1**2*bdd1*f*g2*s**2 - 5544*D1**2*bdd1*f*g2*s + 2772*D1**2*bdd1*f*g2 + 60*D1**2*f**3*fd*r**2 + 120*D1**2*f**3*fd*r*s - 90*D1**2*f**3*fd*r + 60*D1**2*f**3*fd*s**2 - 90*D1**2*f**3*fd*s + 45*D1**2*f**3*fd - 140*D1**2*f**3*fdd*r**2 - 280*D1**2*f**3*fdd*r*s + 210*D1**2*f**3*fdd*r - 140*D1**2*f**3*fdd*s**2 + 210*D1**2*f**3*fdd*s - 105*D1**2*f**3*fdd - 420*D1**2*f**2*fd**2*r**2 - 840*D1**2*f**2*fd**2*r*s + 630*D1**2*f**2*fd**2*r - 420*D1**2*f**2*fd**2*s**2 + 630*D1**2*f**2*fd**2*s - 210*D1**2*f**2*fd**2 + 297*D1**2*f**2*fd*r**2 + 594*D1**2*f**2*fd*r*s - 396*D1**2*f**2*fd*r + 297*D1**2*f**2*fd*s**2 - 396*D1**2*f**2*fd*s + 198*D1**2*f**2*fd - 1914*D1**2*f**2*gd2*r**2 - 3828*D1**2*f**2*gd2*r*s + 3828*D1**2*f**2*gd2*r - 1914*D1**2*f**2*gd2*s**2 + 3828*D1**2*f**2*gd2*s - 1914*D1**2*f**2*gd2 + 1188*D1**2*f**2*gdd2*r**2 + 2376*D1**2*f**2*gdd2*r*s - 2376*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 2376*D1**2*f**2*gdd2*s + 1188*D1**2*f**2*gdd2 - 3828*D1**2*f*fd*g2*r**2 - 7656*D1**2*f*fd*g2*r*s + 3828*D1**2*f*fd*g2*r - 3828*D1**2*f*fd*g2*s**2 + 3828*D1**2*f*fd*g2*s - 1914*D1**2*f*fd*g2 + 4752*D1**2*f*fd*gd2*r**2 + 9504*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2376*D1**2*f*fd*gd2 + 2376*D1**2*f*fdd*g2*r**2 + 4752*D1**2*f*fdd*g2*r*s - 2376*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 2376*D1**2*fd**2*g2*r**2 + 4752*D1**2*fd**2*g2*r*s - 2376*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 60*D1*Dd*f**4*r**2 + 120*D1*Dd*f**4*r*s - 90*D1*Dd*f**4*r + 60*D1*Dd*f**4*s**2 - 90*D1*Dd*f**4*s + 45*D1*Dd*f**4 - 1120*D1*Dd*f**3*fd*r**2 - 2240*D1*Dd*f**3*fd*r*s + 1680*D1*Dd*f**3*fd*r - 1120*D1*Dd*f**3*fd*s**2 + 1680*D1*Dd*f**3*fd*s - 630*D1*Dd*f**3*fd + 396*D1*Dd*f**3*r**2 + 792*D1*Dd*f**3*r*s - 594*D1*Dd*f**3*r + 396*D1*Dd*f**3*s**2 - 594*D1*Dd*f**3*s + 297*D1*Dd*f**3 - 7656*D1*Dd*f**2*g2*r**2 - 15312*D1*Dd*f**2*g2*r*s + 11484*D1*Dd*f**2*g2*r - 7656*D1*Dd*f**2*g2*s**2 + 11484*D1*Dd*f**2*g2*s - 5742*D1*Dd*f**2*g2 + 9504*D1*Dd*f**2*gd2*r**2 + 19008*D1*Dd*f**2*gd2*r*s - 16632*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 19008*D1*Dd*f*fd*g2*r**2 + 38016*D1*Dd*f*fd*g2*r*s - 23760*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 23760*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**4*r**2 - 280*D1*Ddd*f**4*r*s + 210*D1*Ddd*f**4*r - 140*D1*Ddd*f**4*s**2 + 210*D1*Ddd*f**4*s - 105*D1*Ddd*f**4 + 4752*D1*Ddd*f**2*g2*r**2 + 9504*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(22*f**3*(r + s - 1) + f**2*(42*C*(r + s - 1) - 87*K*r - 87*K*s + 87*K + 54*b1*(r + s - 1) - 120*fd*r - 120*fd*s + 80*fd - 21*r - 21*s + 21) - 6*f*(49*K*b1*(r + s - 1) - 18*K*fd*(2*r + 2*s - 1) + 30*b1*fd*(2*r + 2*s - 1) - 49*g2*(r + s - 1) + 84*gd2*(r + s - 1)) - 504*fd*(r + s)*(-K*b1 + g2)) - 4*Dd*f*(4*r + 4*s - 3)*(-27*K*f + 9*b1*(-14*K + 5*f) + 10*f**2 + 126*g2))*(r + s - 1) - 420*Dd**2*f**4*r**2 - 840*Dd**2*f**4*r*s + 630*Dd**2*f**4*r - 420*Dd**2*f**4*s**2 + 630*Dd**2*f**4*s - 210*Dd**2*f**4 + 14256*Dd**2*f**2*g2*r**2 + 28512*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 7128*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(3*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(49*K*fd*(r + s) - 42*K*fdd*(r + s) + 30*fd**2*(r + s - 1))) + D1*(Dd*(84*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(49*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 30*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 3*Ddd*f*(-14*K + 5*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-14*K + 5*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(18*D1**2*bdd1*f*(-14*K + 5*f)*(r + s - 1)**2 + D1**2*(-2*f**2*(11*fd - 10*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-54*K*fdd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 3*fd*(14*C - 29*K - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 294*gd2*(r + s - 1)**2 + 252*gdd2*(r + s - 1)**2) + (-6*r - 6*s)*(18*K*fd**2*(r + s - 1) + 49*fd*g2*(r + s) - 84*fd*gd2*(r + s - 1) - 42*fdd*g2*(r + s))) + D1*(Dd*(-22*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-42*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 40*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + (87*K + 21)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 6*f*(49*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (-3*K*fd*(2*r + 2*s - 1) + 14*gd2*(r + s - 1))*(-24*r - 24*s + 18)) + 504*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 2*Ddd*f*(-27*K*f + 10*f**2 + 126*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f*(-27*K*f + 10*f**2 + 126*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(6930*d**2*k3**6) + D1**2*Pk1*Pkdd3*k1**4*st**2*(2*C - 1)*(3*D1*b1*(7*D1*bdd1*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 2*D1*f*fd*r - 2*D1*f*fd*s + D1*f*fd - 6*D1*f*fdd*r - 6*D1*f*fdd*s + 3*D1*f*fdd - 6*D1*fd**2*r - 6*D1*fd**2*s + 6*D1*fd**2 - 24*Dd*f*fd*r - 24*Dd*f*fd*s + 18*Dd*f*fd + 7*bd1*(D1*(3*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 21*b1**2*(D1**2*(3*fd + fdd)*(r + s - 1)**2 + D1*(Dd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(42*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 9*D1**2*bdd1*f*(2*r + 2*s - 1) + 3*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 3*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 15*D1**2*f*fdd*r**2 - 30*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*r - 15*D1**2*f*fdd*s**2 + 20*D1**2*f*fdd*s - 10*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 40*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 40*D1**2*fd**2*s - 10*D1**2*fd**2 + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 120*D1*Dd*f*fd*r**2 - 240*D1*Dd*f*fd*r*s + 170*D1*Dd*f*fd*r - 120*D1*Dd*f*fd*s**2 + 170*D1*Dd*f*fd*s - 60*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + 3*D1*bd1*(D1*f*(2*r + 2*s - 1) + 6*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2))/(630*d**2*k3**4) + D1**2*Pk1*Pkdd3*k1**4*(42*D1**2*K*bd1**2*f*r + 42*D1**2*K*bd1**2*f*s - 42*D1**2*K*bd1**2*f + 9*D1**2*K*bd1*f**2*r**2 + 18*D1**2*K*bd1*f**2*r*s - 18*D1**2*K*bd1*f**2*r + 9*D1**2*K*bd1*f**2*s**2 - 18*D1**2*K*bd1*f**2*s + 9*D1**2*K*bd1*f**2 - 60*D1**2*K*bd1*f*fd*r**2 - 120*D1**2*K*bd1*f*fd*r*s + 90*D1**2*K*bd1*f*fd*r - 60*D1**2*K*bd1*f*fd*s**2 + 90*D1**2*K*bd1*f*fd*s - 30*D1**2*K*bd1*f*fd - 15*D1**2*K*bdd1*f**2*r**2 - 30*D1**2*K*bdd1*f**2*r*s + 30*D1**2*K*bdd1*f**2*r - 15*D1**2*K*bdd1*f**2*s**2 + 30*D1**2*K*bdd1*f**2*s - 15*D1**2*K*bdd1*f**2 - 140*D1**2*bd1**2*g2*r**2 - 280*D1**2*bd1**2*g2*r*s + 140*D1**2*bd1**2*g2*r - 140*D1**2*bd1**2*g2*s**2 + 140*D1**2*bd1**2*g2*s - 42*D1**2*bd1*bd2*f*r**2 - 84*D1**2*bd1*bd2*f*r*s + 84*D1**2*bd1*bd2*f*r - 42*D1**2*bd1*bd2*f*s**2 + 84*D1**2*bd1*bd2*f*s - 42*D1**2*bd1*bd2*f + 28*D1**2*bd1*f*g2*r + 28*D1**2*bd1*f*g2*s - 14*D1**2*bd1*f*g2 - 84*D1**2*bd1*f*gd2*r - 84*D1**2*bd1*f*gd2*s + 84*D1**2*bd1*f*gd2 + 9*D1**2*bd2*f**2*r**2 + 18*D1**2*bd2*f**2*r*s - 18*D1**2*bd2*f**2*r + 9*D1**2*bd2*f**2*s**2 - 18*D1**2*bd2*f**2*s + 9*D1**2*bd2*f**2 - 60*D1**2*bd2*f*fd*r**2 - 120*D1**2*bd2*f*fd*r*s + 90*D1**2*bd2*f*fd*r - 60*D1**2*bd2*f*fd*s**2 + 90*D1**2*bd2*f*fd*s - 30*D1**2*bd2*f*fd - 84*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s + 42*D1**2*bdd1*f*g2 - 15*D1**2*bdd2*f**2*r**2 - 30*D1**2*bdd2*f**2*r*s + 30*D1**2*bdd2*f**2*r - 15*D1**2*bdd2*f**2*s**2 + 30*D1**2*bdd2*f**2*s - 15*D1**2*bdd2*f**2 - 18*D1**2*f**2*gd2*r**2 - 36*D1**2*f**2*gd2*r*s + 36*D1**2*f**2*gd2*r - 18*D1**2*f**2*gd2*s**2 + 36*D1**2*f**2*gd2*s - 18*D1**2*f**2*gd2 + 30*D1**2*f**2*gdd2*r**2 + 60*D1**2*f**2*gdd2*r*s - 60*D1**2*f**2*gdd2*r + 30*D1**2*f**2*gdd2*s**2 - 60*D1**2*f**2*gdd2*s + 30*D1**2*f**2*gdd2 - 36*D1**2*f*fd*g2*r**2 - 72*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r - 36*D1**2*f*fd*g2*s**2 + 36*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 + 120*D1**2*f*fd*gd2*r**2 + 240*D1**2*f*fd*gd2*r*s - 180*D1**2*f*fd*gd2*r + 120*D1**2*f*fd*gd2*s**2 - 180*D1**2*f*fd*gd2*s + 60*D1**2*f*fd*gd2 + 60*D1**2*f*fdd*g2*r**2 + 120*D1**2*f*fdd*g2*r*s - 60*D1**2*f*fdd*g2*r + 60*D1**2*f*fdd*g2*s**2 - 60*D1**2*f*fdd*g2*s + 30*D1**2*f*fdd*g2 + 60*D1**2*fd**2*g2*r**2 + 120*D1**2*fd**2*g2*r*s - 60*D1**2*fd**2*g2*r + 60*D1**2*fd**2*g2*s**2 - 60*D1**2*fd**2*g2*s - 120*D1*Dd*K*bd1*f**2*r**2 - 240*D1*Dd*K*bd1*f**2*r*s + 210*D1*Dd*K*bd1*f**2*r - 120*D1*Dd*K*bd1*f**2*s**2 + 210*D1*Dd*K*bd1*f**2*s - 90*D1*Dd*K*bd1*f**2 - 336*D1*Dd*bd1*f*g2*r - 336*D1*Dd*bd1*f*g2*s + 252*D1*Dd*bd1*f*g2 - 120*D1*Dd*bd2*f**2*r**2 - 240*D1*Dd*bd2*f**2*r*s + 210*D1*Dd*bd2*f**2*r - 120*D1*Dd*bd2*f**2*s**2 + 210*D1*Dd*bd2*f**2*s - 90*D1*Dd*bd2*f**2 - 72*D1*Dd*f**2*g2*r**2 - 144*D1*Dd*f**2*g2*r*s + 108*D1*Dd*f**2*g2*r - 72*D1*Dd*f**2*g2*s**2 + 108*D1*Dd*f**2*g2*s - 54*D1*Dd*f**2*g2 + 240*D1*Dd*f**2*gd2*r**2 + 480*D1*Dd*f**2*gd2*r*s - 420*D1*Dd*f**2*gd2*r + 240*D1*Dd*f**2*gd2*s**2 - 420*D1*Dd*f**2*gd2*s + 180*D1*Dd*f**2*gd2 + 480*D1*Dd*f*fd*g2*r**2 + 960*D1*Dd*f*fd*g2*r*s - 600*D1*Dd*f*fd*g2*r + 480*D1*Dd*f*fd*g2*s**2 - 600*D1*Dd*f*fd*g2*s + 180*D1*Dd*f*fd*g2 + 120*D1*Ddd*f**2*g2*r**2 + 240*D1*Ddd*f**2*g2*r*s - 180*D1*Ddd*f**2*g2*r + 120*D1*Ddd*f**2*g2*s**2 - 180*D1*Ddd*f**2*g2*s + 90*D1*Ddd*f**2*g2 + 360*Dd**2*f**2*g2*r**2 + 720*Dd**2*f**2*g2*r*s - 540*Dd**2*f**2*g2*r + 360*Dd**2*f**2*g2*s**2 - 540*Dd**2*f**2*g2*s + 180*Dd**2*f**2*g2 + 35*K*b1**3*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 7*b1**2*(D1**2*(-K*(5*bd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 5*bdd1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + (fd - 3*fdd)*(2*r + 2*s - 1)) + 10*gd2*(r + s - 1)**2 + 10*gdd2*(r + s - 1)**2) + 2*D1*(Dd*(5*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (4*r + 4*s - 3)*(-5*K*bd1*(3*r + 3*s - 2) + 3*K*fd + 10*gd2*(r + s - 1))) + 5*Ddd*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*Dd**2*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(210*D1**2*K*bd1**2*r**2 + 420*D1**2*K*bd1**2*r*s - 280*D1**2*K*bd1**2*r + 210*D1**2*K*bd1**2*s**2 - 280*D1**2*K*bd1**2*s + 70*D1**2*K*bd1**2 - 14*D1**2*K*bd1*f*r - 14*D1**2*K*bd1*f*s + 7*D1**2*K*bd1*f - 42*D1**2*K*bd1*fd*r - 42*D1**2*K*bd1*fd*s + 42*D1**2*K*bd1*fd + 42*D1**2*K*bdd1*f*r + 42*D1**2*K*bdd1*f*s - 21*D1**2*K*bdd1*f + 18*D1**2*K*f*fd*r**2 + 36*D1**2*K*f*fd*r*s - 18*D1**2*K*f*fd*r + 18*D1**2*K*f*fd*s**2 - 18*D1**2*K*f*fd*s + 9*D1**2*K*f*fd - 30*D1**2*K*f*fdd*r**2 - 60*D1**2*K*f*fdd*r*s + 30*D1**2*K*f*fdd*r - 30*D1**2*K*f*fdd*s**2 + 30*D1**2*K*f*fdd*s - 15*D1**2*K*f*fdd - 30*D1**2*K*fd**2*r**2 - 60*D1**2*K*fd**2*r*s + 30*D1**2*K*fd**2*r - 30*D1**2*K*fd**2*s**2 + 30*D1**2*K*fd**2*s - 140*D1**2*bd1*g2*r**2 - 280*D1**2*bd1*g2*r*s + 140*D1**2*bd1*g2*r - 140*D1**2*bd1*g2*s**2 + 140*D1**2*bd1*g2*s - 70*D1**2*bd1*g2 - 280*D1**2*bd1*gd2*r**2 - 560*D1**2*bd1*gd2*r*s + 420*D1**2*bd1*gd2*r - 280*D1**2*bd1*gd2*s**2 + 420*D1**2*bd1*gd2*s - 140*D1**2*bd1*gd2 - 140*D1**2*bdd1*g2*r**2 - 280*D1**2*bdd1*g2*r*s + 140*D1**2*bdd1*g2*r - 140*D1**2*bdd1*g2*s**2 + 140*D1**2*bdd1*g2*s - 70*D1**2*bdd1*g2 - 21*D1**2*bdd2*f*(r + s - 1)**2 - 28*D1**2*fd*g2*r - 28*D1**2*fd*g2*s + 14*D1**2*fd*g2 + 84*D1**2*fd*gd2*r + 84*D1**2*fd*gd2*s - 84*D1**2*fd*gd2 + 84*D1**2*fdd*g2*r + 84*D1**2*fdd*g2*s - 42*D1**2*fdd*g2 + 168*D1*Dd*K*bd1*f*r + 168*D1*Dd*K*bd1*f*s - 126*D1*Dd*K*bd1*f + 36*D1*Dd*K*f**2*r**2 + 72*D1*Dd*K*f**2*r*s - 54*D1*Dd*K*f**2*r + 36*D1*Dd*K*f**2*s**2 - 54*D1*Dd*K*f**2*s + 27*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*r**2 - 480*D1*Dd*K*f*fd*r*s + 300*D1*Dd*K*f*fd*r - 240*D1*Dd*K*f*fd*s**2 + 300*D1*Dd*K*f*fd*s - 90*D1*Dd*K*f*fd - 1120*D1*Dd*bd1*g2*r**2 - 2240*D1*Dd*bd1*g2*r*s + 1400*D1*Dd*bd1*g2*r - 1120*D1*Dd*bd1*g2*s**2 + 1400*D1*Dd*bd1*g2*s - 420*D1*Dd*bd1*g2 + 336*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s - 252*D1*Dd*fd*g2 - 60*D1*Ddd*K*f**2*r**2 - 120*D1*Ddd*K*f**2*r*s + 90*D1*Ddd*K*f**2*r - 60*D1*Ddd*K*f**2*s**2 + 90*D1*Ddd*K*f**2*s - 45*D1*Ddd*K*f**2 + 7*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 180*Dd**2*K*f**2*r**2 - 360*Dd**2*K*f**2*r*s + 270*Dd**2*K*f**2*r - 180*Dd**2*K*f**2*s**2 + 270*Dd**2*K*f**2*s - 90*Dd**2*K*f**2) + b2*(7*D1**2*b1*fd*r**2 + 14*D1**2*b1*fd*r*s + 7*D1**2*b1*fd*s**2 - 21*D1**2*b1*fdd*r**2 - 42*D1**2*b1*fdd*r*s - 21*D1**2*b1*fdd*s**2 - 21*D1**2*bdd1*f*(r + s - 1)**2 + 18*D1**2*f*fd*r**2 + 36*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 18*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 9*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 28*D1*Dd*b1*f*r**2 + 56*D1*Dd*b1*f*r*s - 42*D1*Dd*b1*f*r + 28*D1*Dd*b1*f*s**2 - 42*D1*Dd*b1*f*s + 21*D1*Dd*b1*f - 168*D1*Dd*b1*fd*r**2 - 336*D1*Dd*b1*fd*r*s + 126*D1*Dd*b1*fd*r - 168*D1*Dd*b1*fd*s**2 + 126*D1*Dd*b1*fd*s + 36*D1*Dd*f**2*r**2 + 72*D1*Dd*f**2*r*s - 54*D1*Dd*f**2*r + 36*D1*Dd*f**2*s**2 - 54*D1*Dd*f**2*s + 27*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd - 84*D1*Ddd*b1*f*r**2 - 168*D1*Ddd*b1*f*r*s + 126*D1*Ddd*b1*f*r - 84*D1*Ddd*b1*f*s**2 + 126*D1*Ddd*b1*f*s - 63*D1*Ddd*b1*f - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 + 7*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 252*Dd**2*b1*f*r**2 - 504*Dd**2*b1*f*r*s + 378*Dd**2*b1*f*r - 252*Dd**2*b1*f*s**2 + 378*Dd**2*b1*f*s - 126*Dd**2*b1*f - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2))/(210*d**2*k3**4) - D1**2*Pk1*Pkdd3*k1**2*k2**4*st**6*(2*C - 1)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(126*d**2*k3**6) - D1**2*Pk1*Pkdd3*k1**2*k2**4*st**4*(-198*C*D1**2*f**2*fd*r**2 - 396*C*D1**2*f**2*fd*r*s + 264*C*D1**2*f**2*fd*r - 198*C*D1**2*f**2*fd*s**2 + 264*C*D1**2*f**2*fd*s - 132*C*D1**2*f**2*fd - 264*C*D1*Dd*f**3*r**2 - 528*C*D1*Dd*f**3*r*s + 396*C*D1*Dd*f**3*r - 264*C*D1*Dd*f**3*s**2 + 396*C*D1*Dd*f**3*s - 198*C*D1*Dd*f**3 - 33*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*K*bdd1*f**2*r*s + 66*D1**2*K*bdd1*f**2*r - 33*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s - 33*D1**2*K*bdd1*f**2 + 66*D1**2*bd1**2*f*(-7*K + 10*f)*(r + s - 1)**2 + 462*D1**2*bdd1*f*g2*r**2 + 924*D1**2*bdd1*f*g2*r*s - 924*D1**2*bdd1*f*g2*r + 462*D1**2*bdd1*f*g2*s**2 - 924*D1**2*bdd1*f*g2*s + 462*D1**2*bdd1*f*g2 + 268*D1**2*f**3*fd*r**2 + 536*D1**2*f**3*fd*r*s - 402*D1**2*f**3*fd*r + 268*D1**2*f**3*fd*s**2 - 402*D1**2*f**3*fd*s + 201*D1**2*f**3*fd - 200*D1**2*f**3*fdd*r**2 - 400*D1**2*f**3*fdd*r*s + 300*D1**2*f**3*fdd*r - 200*D1**2*f**3*fdd*s**2 + 300*D1**2*f**3*fdd*s - 150*D1**2*f**3*fdd - 600*D1**2*f**2*fd**2*r**2 - 1200*D1**2*f**2*fd**2*r*s + 900*D1**2*f**2*fd**2*r - 600*D1**2*f**2*fd**2*s**2 + 900*D1**2*f**2*fd**2*s - 300*D1**2*f**2*fd**2 + 99*D1**2*f**2*fd*r**2 + 198*D1**2*f**2*fd*r*s - 132*D1**2*f**2*fd*r + 99*D1**2*f**2*fd*s**2 - 132*D1**2*f**2*fd*s + 66*D1**2*f**2*fd - 132*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*r - 132*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s - 132*D1**2*f**2*gd2 + 66*D1**2*f**2*gdd2*r**2 + 132*D1**2*f**2*gdd2*r*s - 132*D1**2*f**2*gdd2*r + 66*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 66*D1**2*f**2*gdd2 - 264*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 + 528*D1**2*f*fd*gd2*r*s - 396*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 396*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r**2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 268*D1*Dd*f**4*r**2 + 536*D1*Dd*f**4*r*s - 402*D1*Dd*f**4*r + 268*D1*Dd*f**4*s**2 - 402*D1*Dd*f**4*s + 201*D1*Dd*f**4 - 1600*D1*Dd*f**3*fd*r**2 - 3200*D1*Dd*f**3*fd*r*s + 2400*D1*Dd*f**3*fd*r - 1600*D1*Dd*f**3*fd*s**2 + 2400*D1*Dd*f**3*fd*s - 900*D1*Dd*f**3*fd + 132*D1*Dd*f**3*r**2 + 264*D1*Dd*f**3*r*s - 198*D1*Dd*f**3*r + 132*D1*Dd*f**3*s**2 - 198*D1*Dd*f**3*s + 99*D1*Dd*f**3 - 528*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s + 792*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 792*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 + 1056*D1*Dd*f**2*gd2*r*s - 924*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 924*D1*Dd*f**2*gd2*s + 396*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r**2 + 2112*D1*Dd*f*fd*g2*r*s - 1320*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1320*D1*Dd*f*fd*g2*s + 396*D1*Dd*f*fd*g2 - 200*D1*Ddd*f**4*r**2 - 400*D1*Ddd*f**4*r*s + 300*D1*Ddd*f**4*r - 200*D1*Ddd*f**4*s**2 + 300*D1*Ddd*f**4*s - 150*D1*Ddd*f**4 + 264*D1*Ddd*f**2*g2*r**2 + 528*D1*Ddd*f**2*g2*r*s - 396*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 396*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(2*f**3*(r + s - 1) + f**2*(r + s - 1)*(14*C - 2*K + 26*b1 - 7) - 2*f*(14*K*b1*(r + s - 1) - 2*K*fd*r - 2*K*fd*s + K*fd + 20*b1*fd*(2*r + 2*s - 1) - 14*g2*(r + s - 1) + 14*gd2*r + 14*gd2*s - 14*gd2) - 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(-14*K*b1 - K*f + 20*b1*f + 14*g2))*(r + s - 1) - 600*Dd**2*f**4*r**2 - 1200*Dd**2*f**4*r*s + 900*Dd**2*f**4*r - 600*Dd**2*f**4*s**2 + 900*Dd**2*f**4*s - 300*Dd**2*f**4 + 792*Dd**2*f**2*g2*r**2 + 1584*Dd**2*f**2*g2*r*s - 1188*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 1188*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(14*K*fd*(r + s) - 7*K*fdd*(r + s) + 20*fd**2*(r + s - 1))) + D1*(Dd*(14*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 13*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(7*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - Ddd*f*(-7*K + 10*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-7*K + 10*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(2*D1**2*bdd1*f*(-7*K + 10*f)*(r + s - 1)**2 - D1**2*(2*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(2*K*fdd*r**2 + 4*K*fdd*r*s - 2*K*fdd*r + 2*K*fdd*s**2 - 2*K*fdd*s + K*fdd + fd*(14*C - 2*K - 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*gd2*(r + s - 1)**2 - 14*gdd2*r**2 - 28*gdd2*r*s + 28*gdd2*r - 14*gdd2*s**2 + 28*gdd2*s - 14*gdd2) + (2*r + 2*s)*(K*fd**2*(r + s - 1) + 14*fd*g2*(r + s) - 14*fd*gd2*(r + s - 1) - 7*fdd*g2*(r + s))) + D1*(Dd*(-2*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(14*C - 2*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 28*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*f*(K*fd*(-2*r - 2*s + 1) + 14*gd2*(r + s - 1))*(4*r + 4*s - 3) + 28*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + Ddd*f*(-K*f + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(K*f - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(2310*d**2*k3**6) - D1**2*Pk1*Pkdd3*k1**2*k2**2*st**4*(2*C - 1)*(7*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-7*D1**2*bdd1*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 8*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s + 4*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 8*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 8*D1**2*fd**2*s - 2*D1**2*fd**2 - 12*D1*Dd*f**2*r**2 - 24*D1*Dd*f**2*r*s + 18*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 18*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 92*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 92*D1*Dd*f*fd*s + 24*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2) + f*(-14*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1**2*bdd1*f*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) - 9*D1**2*f*fd*r**2 - 18*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 9*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 6*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 8*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s + 4*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 16*D1**2*fd**2*r + 12*D1**2*fd**2*s**2 - 16*D1**2*fd**2*s + 4*D1**2*fd**2 - 12*D1*Dd*f**2*r**2 - 24*D1*Dd*f**2*r*s + 18*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 18*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 68*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 68*D1*Dd*f*fd*s + 24*D1*Dd*f*fd + 8*D1*Ddd*f**2*r**2 + 16*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 8*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + D1*bd1*(D1*(-f*(3*r**2 + 6*r*s - 10*r + 3*s**2 - 10*s + 5) + 4*fd*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 3)) + 2*Dd*f*(20*r**2 + r*(40*s - 39) + 20*s**2 - 39*s + 18)) + 24*Dd**2*f**2*r**2 + 48*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 24*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 12*Dd**2*f**2))/(70*d**2*k3**4) + D1**2*Pk1*Pkdd3*k1**2*k2**2*st**2*(84*C*D1**2*bd1*f**2*r + 84*C*D1**2*bd1*f**2*s - 42*C*D1**2*bd1*f**2 - 54*C*D1**2*f**2*fd*r**2 - 108*C*D1**2*f**2*fd*r*s + 72*C*D1**2*f**2*fd*r - 54*C*D1**2*f**2*fd*s**2 + 72*C*D1**2*f**2*fd*s - 36*C*D1**2*f**2*fd - 72*C*D1*Dd*f**3*r**2 - 144*C*D1*Dd*f**3*r*s + 108*C*D1*Dd*f**3*r - 72*C*D1*Dd*f**3*s**2 + 108*C*D1*Dd*f**3*s - 54*C*D1*Dd*f**3 - 210*D1**2*K*bd1**2*f*r**2 - 420*D1**2*K*bd1**2*f*r*s + 462*D1**2*K*bd1**2*f*r - 210*D1**2*K*bd1**2*f*s**2 + 462*D1**2*K*bd1**2*f*s - 252*D1**2*K*bd1**2*f + 87*D1**2*K*bd1*f**2*r**2 + 174*D1**2*K*bd1*f**2*r*s - 174*D1**2*K*bd1*f**2*r + 87*D1**2*K*bd1*f**2*s**2 - 174*D1**2*K*bd1*f**2*s + 87*D1**2*K*bd1*f**2 - 216*D1**2*K*bd1*f*fd*r**2 - 432*D1**2*K*bd1*f*fd*r*s + 324*D1**2*K*bd1*f*fd*r - 216*D1**2*K*bd1*f*fd*s**2 + 324*D1**2*K*bd1*f*fd*s - 108*D1**2*K*bd1*f*fd - 54*D1**2*K*bdd1*f**2*r**2 - 108*D1**2*K*bdd1*f**2*r*s + 108*D1**2*K*bdd1*f**2*r - 54*D1**2*K*bdd1*f**2*s**2 + 108*D1**2*K*bdd1*f**2*s - 54*D1**2*K*bdd1*f**2 + 36*D1**2*bd1**2*f**2*r**2 + 72*D1**2*bd1**2*f**2*r*s - 108*D1**2*bd1**2*f**2*r + 36*D1**2*bd1**2*f**2*s**2 - 108*D1**2*bd1**2*f**2*s + 72*D1**2*bd1**2*f**2 - 420*D1**2*bd1**2*g2*r**2 - 840*D1**2*bd1**2*g2*r*s + 420*D1**2*bd1**2*g2*r - 420*D1**2*bd1**2*g2*s**2 + 420*D1**2*bd1**2*g2*s - 252*D1**2*bd1*bd2*f*r**2 - 504*D1**2*bd1*bd2*f*r*s + 504*D1**2*bd1*bd2*f*r - 252*D1**2*bd1*bd2*f*s**2 + 504*D1**2*bd1*bd2*f*s - 252*D1**2*bd1*bd2*f - 23*D1**2*bd1*f**3*r**2 - 46*D1**2*bd1*f**3*r*s + 44*D1**2*bd1*f**3*r - 23*D1**2*bd1*f**3*s**2 + 44*D1**2*bd1*f**3*s - 22*D1**2*bd1*f**3 + 150*D1**2*bd1*f**2*fd*r**2 + 300*D1**2*bd1*f**2*fd*r*s - 230*D1**2*bd1*f**2*fd*r + 150*D1**2*bd1*f**2*fd*s**2 - 230*D1**2*bd1*f**2*fd*s + 80*D1**2*bd1*f**2*fd - 42*D1**2*bd1*f**2*r - 42*D1**2*bd1*f**2*s + 21*D1**2*bd1*f**2 - 210*D1**2*bd1*f*g2*r**2 - 420*D1**2*bd1*f*g2*r*s + 588*D1**2*bd1*f*g2*r - 210*D1**2*bd1*f*g2*s**2 + 588*D1**2*bd1*f*g2*s - 294*D1**2*bd1*f*g2 + 420*D1**2*bd1*f*gd2*r**2 + 840*D1**2*bd1*f*gd2*r*s - 924*D1**2*bd1*f*gd2*r + 420*D1**2*bd1*f*gd2*s**2 - 924*D1**2*bd1*f*gd2*s + 504*D1**2*bd1*f*gd2 + 420*D1**2*bd1*fd*g2*r**2 + 840*D1**2*bd1*fd*g2*r*s - 420*D1**2*bd1*fd*g2*r + 420*D1**2*bd1*fd*g2*s**2 - 420*D1**2*bd1*fd*g2*s + 87*D1**2*bd2*f**2*r**2 + 174*D1**2*bd2*f**2*r*s - 174*D1**2*bd2*f**2*r + 87*D1**2*bd2*f**2*s**2 - 174*D1**2*bd2*f**2*s + 87*D1**2*bd2*f**2 - 216*D1**2*bd2*f*fd*r**2 - 432*D1**2*bd2*f*fd*r*s + 324*D1**2*bd2*f*fd*r - 216*D1**2*bd2*f*fd*s**2 + 324*D1**2*bd2*f*fd*s - 108*D1**2*bd2*f*fd + 25*D1**2*bdd1*f**3*r**2 + 50*D1**2*bdd1*f**3*r*s - 40*D1**2*bdd1*f**3*r + 25*D1**2*bdd1*f**3*s**2 - 40*D1**2*bdd1*f**3*s + 20*D1**2*bdd1*f**3 + 210*D1**2*bdd1*f*g2*r**2 + 420*D1**2*bdd1*f*g2*r*s - 504*D1**2*bdd1*f*g2*r + 210*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 - 54*D1**2*bdd2*f**2*r**2 - 108*D1**2*bdd2*f**2*r*s + 108*D1**2*bdd2*f**2*r - 54*D1**2*bdd2*f**2*s**2 + 108*D1**2*bdd2*f**2*s - 54*D1**2*bdd2*f**2 + 27*D1**2*f**2*fd*r**2 + 54*D1**2*f**2*fd*r*s - 36*D1**2*f**2*fd*r + 27*D1**2*f**2*fd*s**2 - 36*D1**2*f**2*fd*s + 18*D1**2*f**2*fd - 174*D1**2*f**2*gd2*r**2 - 348*D1**2*f**2*gd2*r*s + 348*D1**2*f**2*gd2*r - 174*D1**2*f**2*gd2*s**2 + 348*D1**2*f**2*gd2*s - 174*D1**2*f**2*gd2 + 108*D1**2*f**2*gdd2*r**2 + 216*D1**2*f**2*gdd2*r*s - 216*D1**2*f**2*gdd2*r + 108*D1**2*f**2*gdd2*s**2 - 216*D1**2*f**2*gdd2*s + 108*D1**2*f**2*gdd2 - 348*D1**2*f*fd*g2*r**2 - 696*D1**2*f*fd*g2*r*s + 348*D1**2*f*fd*g2*r - 348*D1**2*f*fd*g2*s**2 + 348*D1**2*f*fd*g2*s - 174*D1**2*f*fd*g2 + 432*D1**2*f*fd*gd2*r**2 + 864*D1**2*f*fd*gd2*r*s - 648*D1**2*f*fd*gd2*r + 432*D1**2*f*fd*gd2*s**2 - 648*D1**2*f*fd*gd2*s + 216*D1**2*f*fd*gd2 + 216*D1**2*f*fdd*g2*r**2 + 432*D1**2*f*fdd*g2*r*s - 216*D1**2*f*fdd*g2*r + 216*D1**2*f*fdd*g2*s**2 - 216*D1**2*f*fdd*g2*s + 108*D1**2*f*fdd*g2 + 216*D1**2*fd**2*g2*r**2 + 432*D1**2*fd**2*g2*r*s - 216*D1**2*fd**2*g2*r + 216*D1**2*fd**2*g2*s**2 - 216*D1**2*fd**2*g2*s - 432*D1*Dd*K*bd1*f**2*r**2 - 864*D1*Dd*K*bd1*f**2*r*s + 756*D1*Dd*K*bd1*f**2*r - 432*D1*Dd*K*bd1*f**2*s**2 + 756*D1*Dd*K*bd1*f**2*s - 324*D1*Dd*K*bd1*f**2 + 200*D1*Dd*bd1*f**3*r**2 + 400*D1*Dd*bd1*f**3*r*s - 310*D1*Dd*bd1*f**3*r + 200*D1*Dd*bd1*f**3*s**2 - 310*D1*Dd*bd1*f**3*s + 120*D1*Dd*bd1*f**3 + 1680*D1*Dd*bd1*f*g2*r**2 + 3360*D1*Dd*bd1*f*g2*r*s - 3276*D1*Dd*bd1*f*g2*r + 1680*D1*Dd*bd1*f*g2*s**2 - 3276*D1*Dd*bd1*f*g2*s + 1512*D1*Dd*bd1*f*g2 - 432*D1*Dd*bd2*f**2*r**2 - 864*D1*Dd*bd2*f**2*r*s + 756*D1*Dd*bd2*f**2*r - 432*D1*Dd*bd2*f**2*s**2 + 756*D1*Dd*bd2*f**2*s - 324*D1*Dd*bd2*f**2 + 36*D1*Dd*f**3*r**2 + 72*D1*Dd*f**3*r*s - 54*D1*Dd*f**3*r + 36*D1*Dd*f**3*s**2 - 54*D1*Dd*f**3*s + 27*D1*Dd*f**3 - 696*D1*Dd*f**2*g2*r**2 - 1392*D1*Dd*f**2*g2*r*s + 1044*D1*Dd*f**2*g2*r - 696*D1*Dd*f**2*g2*s**2 + 1044*D1*Dd*f**2*g2*s - 522*D1*Dd*f**2*g2 + 864*D1*Dd*f**2*gd2*r**2 + 1728*D1*Dd*f**2*gd2*r*s - 1512*D1*Dd*f**2*gd2*r + 864*D1*Dd*f**2*gd2*s**2 - 1512*D1*Dd*f**2*gd2*s + 648*D1*Dd*f**2*gd2 + 1728*D1*Dd*f*fd*g2*r**2 + 3456*D1*Dd*f*fd*g2*r*s - 2160*D1*Dd*f*fd*g2*r + 1728*D1*Dd*f*fd*g2*s**2 - 2160*D1*Dd*f*fd*g2*s + 648*D1*Dd*f*fd*g2 + 432*D1*Ddd*f**2*g2*r**2 + 864*D1*Ddd*f**2*g2*r*s - 648*D1*Ddd*f**2*g2*r + 432*D1*Ddd*f**2*g2*s**2 - 648*D1*Ddd*f**2*g2*s + 324*D1*Ddd*f**2*g2 + 1296*Dd**2*f**2*g2*r**2 + 2592*Dd**2*f**2*g2*r*s - 1944*Dd**2*f**2*g2*r + 1296*Dd**2*f**2*g2*s**2 - 1944*Dd**2*f**2*g2*s + 648*Dd**2*f**2*g2 + 21*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(-10*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*(-5*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 3*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(70*C*D1**2*fd*r**2 + 140*C*D1**2*fd*r*s - 140*C*D1**2*fd*r + 70*C*D1**2*fd*s**2 - 140*C*D1**2*fd*s + 70*C*D1**2*fd + 280*C*D1*Dd*f*r**2 + 560*C*D1*Dd*f*r*s - 420*C*D1*Dd*f*r + 280*C*D1*Dd*f*s**2 - 420*C*D1*Dd*f*s + 210*C*D1*Dd*f + 35*D1**2*K*fd*r**2 + 70*D1**2*K*fd*r*s + 28*D1**2*K*fd*r + 35*D1**2*K*fd*s**2 + 28*D1**2*K*fd*s - 14*D1**2*K*fd - 35*D1**2*K*fdd*r**2 - 70*D1**2*K*fdd*r*s - 14*D1**2*K*fdd*r - 35*D1**2*K*fdd*s**2 - 14*D1**2*K*fdd*s + 7*D1**2*K*fdd - 7*D1**2*bdd1*(-5*K + 3*f)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 28*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 28*D1**2*f*fd*s + 14*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*s**2 + 12*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*s**2 - 12*D1**2*fd**2 - 35*D1**2*fd*r**2 - 70*D1**2*fd*r*s + 70*D1**2*fd*r - 35*D1**2*fd*s**2 + 70*D1**2*fd*s - 35*D1**2*fd + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 + 140*D1*Dd*K*f*r**2 + 280*D1*Dd*K*f*r*s - 210*D1*Dd*K*f*r + 140*D1*Dd*K*f*s**2 - 210*D1*Dd*K*f*s + 105*D1*Dd*K*f - 280*D1*Dd*K*fd*r**2 - 560*D1*Dd*K*fd*r*s + 154*D1*Dd*K*fd*r - 280*D1*Dd*K*fd*s**2 + 154*D1*Dd*K*fd*s + 42*D1*Dd*K*fd + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r + 96*D1*Dd*f*fd*s**2 - 72*D1*Dd*f*fd*s - 140*D1*Dd*f*r**2 - 280*D1*Dd*f*r*s + 210*D1*Dd*f*r - 140*D1*Dd*f*s**2 + 210*D1*Dd*f*s - 105*D1*Dd*f + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 - 140*D1*Ddd*K*f*r**2 - 280*D1*Ddd*K*f*r*s + 210*D1*Ddd*K*f*r - 140*D1*Ddd*K*f*s**2 + 210*D1*Ddd*K*f*s - 105*D1*Ddd*K*f + 24*D1*Ddd*f**2*r**2 + 48*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 7*D1*bd1*(D1*(-10*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - 2*Dd*(-5*K + 3*f)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 420*Dd**2*K*f*r**2 - 840*Dd**2*K*f*r*s + 630*Dd**2*K*f*r - 420*Dd**2*K*f*s**2 + 630*Dd**2*K*f*s - 210*Dd**2*K*f + 72*Dd**2*f**2*r**2 + 144*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 72*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 36*Dd**2*f**2 - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) + b1*(-84*C*D1**2*f*fd*r - 84*C*D1**2*f*fd*s + 42*C*D1**2*f*fd - 210*D1**2*K*bdd1*f*r**2 - 420*D1**2*K*bdd1*f*r*s + 462*D1**2*K*bdd1*f*r - 210*D1**2*K*bdd1*f*s**2 + 462*D1**2*K*bdd1*f*s - 231*D1**2*K*bdd1*f + 174*D1**2*K*f*fd*r**2 + 348*D1**2*K*f*fd*r*s - 174*D1**2*K*f*fd*r + 174*D1**2*K*f*fd*s**2 - 174*D1**2*K*f*fd*s + 87*D1**2*K*f*fd - 108*D1**2*K*f*fdd*r**2 - 216*D1**2*K*f*fdd*r*s + 108*D1**2*K*f*fdd*r - 108*D1**2*K*f*fdd*s**2 + 108*D1**2*K*f*fdd*s - 54*D1**2*K*f*fdd - 108*D1**2*K*fd**2*r**2 - 216*D1**2*K*fd**2*r*s + 108*D1**2*K*fd**2*r - 108*D1**2*K*fd**2*s**2 + 108*D1**2*K*fd**2*s + 147*D1**2*b2*fd*r**2 + 294*D1**2*b2*fd*r*s + 147*D1**2*b2*fd*s**2 - 126*D1**2*b2*fdd*r**2 - 252*D1**2*b2*fdd*r*s - 126*D1**2*b2*fdd*s**2 - 42*D1**2*bd1**2*(-5*K + 3*f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 36*D1**2*bdd1*f**2*r**2 + 72*D1**2*bdd1*f**2*r*s - 108*D1**2*bdd1*f**2*r + 36*D1**2*bdd1*f**2*s**2 - 108*D1**2*bdd1*f**2*s + 54*D1**2*bdd1*f**2 - 420*D1**2*bdd1*g2*r**2 - 840*D1**2*bdd1*g2*r*s + 420*D1**2*bdd1*g2*r - 420*D1**2*bdd1*g2*s**2 + 420*D1**2*bdd1*g2*s - 210*D1**2*bdd1*g2 - 126*D1**2*bdd2*f*r**2 - 252*D1**2*bdd2*f*r*s + 252*D1**2*bdd2*f*r - 126*D1**2*bdd2*f*s**2 + 252*D1**2*bdd2*f*s - 126*D1**2*bdd2*f - 69*D1**2*f**2*fd*r**2 - 138*D1**2*f**2*fd*r*s + 94*D1**2*f**2*fd*r - 69*D1**2*f**2*fd*s**2 + 94*D1**2*f**2*fd*s - 47*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 110*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 110*D1**2*f**2*fdd*s + 55*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 220*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 220*D1**2*f*fd**2*s + 70*D1**2*f*fd**2 + 42*D1**2*f*fd*r + 42*D1**2*f*fd*s - 21*D1**2*f*fd - 210*D1**2*f*gd2*r**2 - 420*D1**2*f*gd2*r*s + 420*D1**2*f*gd2*r - 210*D1**2*f*gd2*s**2 + 420*D1**2*f*gd2*s - 210*D1**2*f*gd2 + 210*D1**2*f*gdd2*r**2 + 420*D1**2*f*gdd2*r*s - 420*D1**2*f*gdd2*r + 210*D1**2*f*gdd2*s**2 - 420*D1**2*f*gdd2*s + 210*D1**2*f*gdd2 - 210*D1**2*fd*g2*r**2 - 420*D1**2*fd*g2*r*s - 168*D1**2*fd*g2*r - 210*D1**2*fd*g2*s**2 - 168*D1**2*fd*g2*s + 84*D1**2*fd*g2 + 420*D1**2*fd*gd2*r**2 + 840*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*r + 420*D1**2*fd*gd2*s**2 - 336*D1**2*fd*gd2*s - 84*D1**2*fd*gd2 + 210*D1**2*fdd*g2*r**2 + 420*D1**2*fdd*g2*r*s + 84*D1**2*fdd*g2*r + 210*D1**2*fdd*g2*s**2 + 84*D1**2*fdd*g2*s - 42*D1**2*fdd*g2 + 348*D1*Dd*K*f**2*r**2 + 696*D1*Dd*K*f**2*r*s - 522*D1*Dd*K*f**2*r + 348*D1*Dd*K*f**2*s**2 - 522*D1*Dd*K*f**2*s + 261*D1*Dd*K*f**2 - 864*D1*Dd*K*f*fd*r**2 - 1728*D1*Dd*K*f*fd*r*s + 1080*D1*Dd*K*f*fd*r - 864*D1*Dd*K*f*fd*s**2 + 1080*D1*Dd*K*f*fd*s - 324*D1*Dd*K*f*fd + 588*D1*Dd*b2*f*r**2 + 1176*D1*Dd*b2*f*r*s - 882*D1*Dd*b2*f*r + 588*D1*Dd*b2*f*s**2 - 882*D1*Dd*b2*f*s + 441*D1*Dd*b2*f - 1008*D1*Dd*b2*fd*r**2 - 2016*D1*Dd*b2*fd*r*s + 756*D1*Dd*b2*fd*r - 1008*D1*Dd*b2*fd*s**2 + 756*D1*Dd*b2*fd*s - 92*D1*Dd*f**3*r**2 - 184*D1*Dd*f**3*r*s + 138*D1*Dd*f**3*r - 92*D1*Dd*f**3*s**2 + 138*D1*Dd*f**3*s - 69*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 890*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 890*D1*Dd*f**2*fd*s + 330*D1*Dd*f**2*fd - 840*D1*Dd*f*g2*r**2 - 1680*D1*Dd*f*g2*r*s + 1260*D1*Dd*f*g2*r - 840*D1*Dd*f*g2*s**2 + 1260*D1*Dd*f*g2*s - 630*D1*Dd*f*g2 + 1680*D1*Dd*f*gd2*r**2 + 3360*D1*Dd*f*gd2*r*s - 2940*D1*Dd*f*gd2*r + 1680*D1*Dd*f*gd2*s**2 - 2940*D1*Dd*f*gd2*s + 1260*D1*Dd*f*gd2 + 1680*D1*Dd*fd*g2*r**2 + 3360*D1*Dd*fd*g2*r*s - 924*D1*Dd*fd*g2*r + 1680*D1*Dd*fd*g2*s**2 - 924*D1*Dd*fd*g2*s - 252*D1*Dd*fd*g2 - 216*D1*Ddd*K*f**2*r**2 - 432*D1*Ddd*K*f**2*r*s + 324*D1*Ddd*K*f**2*r - 216*D1*Ddd*K*f**2*s**2 + 324*D1*Ddd*K*f**2*s - 162*D1*Ddd*K*f**2 - 504*D1*Ddd*b2*f*r**2 - 1008*D1*Ddd*b2*f*r*s + 756*D1*Ddd*b2*f*r - 504*D1*Ddd*b2*f*s**2 + 756*D1*Ddd*b2*f*s - 378*D1*Ddd*b2*f + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 840*D1*Ddd*f*g2*r**2 + 1680*D1*Ddd*f*g2*r*s - 1260*D1*Ddd*f*g2*r + 840*D1*Ddd*f*g2*s**2 - 1260*D1*Ddd*f*g2*s + 630*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(4*f**2*(r**2 + 2*r*(s + 2) + s**2 + 4*s - 2) + f*(70*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*K*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) + 24*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 70*r**2 - 35*r*(4*s - 2) - 70*s**2 + 70*s - 35) + 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (K*fd*(10*r + 10*s + 1) + 10*gd2*(2*r + 2*s - 1))*(14*r + 14*s - 14)) + 2*Dd*(4*r + 4*s - 3)*(-7*K*f*(10*r + 10*s - 11) + 6*f**2*(2*r + 2*s - 3) - 70*g2*(2*r + 2*s - 1))) + 21*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 648*Dd**2*K*f**2*r**2 - 1296*Dd**2*K*f**2*r*s + 972*Dd**2*K*f**2*r - 648*Dd**2*K*f**2*s**2 + 972*Dd**2*K*f**2*s - 324*Dd**2*K*f**2 - 1512*Dd**2*b2*f*r**2 - 3024*Dd**2*b2*f*r*s + 2268*Dd**2*b2*f*r - 1512*Dd**2*b2*f*s**2 + 2268*Dd**2*b2*f*s - 756*Dd**2*b2*f + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 + 2520*Dd**2*f*g2*r**2 + 5040*Dd**2*f*g2*r*s - 3780*Dd**2*f*g2*r + 2520*Dd**2*f*g2*s**2 - 3780*Dd**2*f*g2*s + 1260*Dd**2*f*g2) + 3*b2*(-42*D1**2*bdd1*f*(r + s - 1)**2 + 58*D1**2*f*fd*r**2 + 116*D1**2*f*fd*r*s - 58*D1**2*f*fd*r + 58*D1**2*f*fd*s**2 - 58*D1**2*f*fd*s + 29*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 116*D1*Dd*f**2*r**2 + 232*D1*Dd*f**2*r*s - 174*D1*Dd*f**2*r + 116*D1*Dd*f**2*s**2 - 174*D1*Dd*f**2*s + 87*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 + 7*D1*bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2))/(630*d**2*k3**4) - D1**2*Pk1*Pkdd3*k1**2*st**2*(2*C - 1)*(D1*f*(r + s)*(14*D1*bd1**2*(r + s - 1) + 3*D1*bdd1*f*(r + s) + bd1*(D1*f*(r + s) + 12*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3))) + 7*b1**2*(D1**2*(3*fd + fdd)*(r + s - 1)**2 + D1*(Dd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(7*D1**2*bdd1*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 12*D1**2*f*fdd*s + 6*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 12*D1**2*fd**2*s + 6*D1**2*fd**2 + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s + 3*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 84*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 84*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 7*D1*bd1*(D1*(3*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 36*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 18*Dd**2*f**2))/(210*d**2*k3**2) - D1**2*Pk1*Pkdd3*k1**2*(D1*(r + s)*(-2*D1*bd1**2*(-3*K*f + 10*g2)*(r + s - 1) - 6*D1*bdd1*f*g2*(r + s) + b2*(10*D1*bd1**2*(r + s - 1) + 3*D1*bdd1*f*(r + s) + bd1*(-D1*f*(r + s) + 6*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3))) + 2*bd1*(3*D1*bd2*f*(r + s - 1) + D1*(f*g2*(r + s) - 6*f*gd2*(r + s - 1) - 6*fd*g2*(r + s - 1)) - 6*Dd*f*g2*(4*r + 4*s - 3))) + 5*K*b1**3*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(15*D1**2*K*bd1*r**2 + 30*D1**2*K*bd1*r*s - 20*D1**2*K*bd1*r + 15*D1**2*K*bd1*s**2 - 20*D1**2*K*bd1*s + 10*D1**2*K*bd1 + 15*D1**2*K*bdd1*r**2 + 30*D1**2*K*bdd1*r*s - 20*D1**2*K*bdd1*r + 15*D1**2*K*bdd1*s**2 - 20*D1**2*K*bdd1*s + 10*D1**2*K*bdd1 - D1**2*K*fd*r**2 - 2*D1**2*K*fd*r*s + 2*D1**2*K*fd*r - D1**2*K*fd*s**2 + 2*D1**2*K*fd*s - D1**2*K*fd + 3*D1**2*K*fdd*r**2 + 6*D1**2*K*fdd*r*s - 6*D1**2*K*fdd*r + 3*D1**2*K*fdd*s**2 - 6*D1**2*K*fdd*s + 3*D1**2*K*fdd + 5*D1**2*bdd2*(r + s - 1)**2 - 10*D1**2*gd2*r**2 - 20*D1**2*gd2*r*s + 20*D1**2*gd2*r - 10*D1**2*gd2*s**2 + 20*D1**2*gd2*s - 10*D1**2*gd2 - 10*D1**2*gdd2*r**2 - 20*D1**2*gdd2*r*s + 20*D1**2*gdd2*r - 10*D1**2*gdd2*s**2 + 20*D1**2*gdd2*s - 10*D1**2*gdd2 + 120*D1*Dd*K*bd1*r**2 + 240*D1*Dd*K*bd1*r*s - 170*D1*Dd*K*bd1*r + 120*D1*Dd*K*bd1*s**2 - 170*D1*Dd*K*bd1*s + 60*D1*Dd*K*bd1 - 4*D1*Dd*K*f*r**2 - 8*D1*Dd*K*f*r*s + 6*D1*Dd*K*f*r - 4*D1*Dd*K*f*s**2 + 6*D1*Dd*K*f*s - 3*D1*Dd*K*f + 24*D1*Dd*K*fd*r**2 + 48*D1*Dd*K*fd*r*s - 42*D1*Dd*K*fd*r + 24*D1*Dd*K*fd*s**2 - 42*D1*Dd*K*fd*s + 18*D1*Dd*K*fd + 20*D1*Dd*b2*r**2 + 40*D1*Dd*b2*r*s - 30*D1*Dd*b2*r + 20*D1*Dd*b2*s**2 - 30*D1*Dd*b2*s + 15*D1*Dd*b2 - 40*D1*Dd*g2*r**2 - 80*D1*Dd*g2*r*s + 60*D1*Dd*g2*r - 40*D1*Dd*g2*s**2 + 60*D1*Dd*g2*s - 30*D1*Dd*g2 - 80*D1*Dd*gd2*r**2 - 160*D1*Dd*gd2*r*s + 140*D1*Dd*gd2*r - 80*D1*Dd*gd2*s**2 + 140*D1*Dd*gd2*s - 60*D1*Dd*gd2 + 12*D1*Ddd*K*f*r**2 + 24*D1*Ddd*K*f*r*s - 18*D1*Ddd*K*f*r + 12*D1*Ddd*K*f*s**2 - 18*D1*Ddd*K*f*s + 9*D1*Ddd*K*f + 20*D1*Ddd*b2*r**2 + 40*D1*Ddd*b2*r*s - 30*D1*Ddd*b2*r + 20*D1*Ddd*b2*s**2 - 30*D1*Ddd*b2*s + 15*D1*Ddd*b2 - 40*D1*Ddd*g2*r**2 - 80*D1*Ddd*g2*r*s + 60*D1*Ddd*g2*r - 40*D1*Ddd*g2*s**2 + 60*D1*Ddd*g2*s - 30*D1*Ddd*g2 + 5*D1*bd2*(D1*(r + s - 1) + 2*Dd*(4*r + 4*s - 3))*(r + s - 1) + 36*Dd**2*K*f*r**2 + 72*Dd**2*K*f*r*s - 54*Dd**2*K*f*r + 36*Dd**2*K*f*s**2 - 54*Dd**2*K*f*s + 18*Dd**2*K*f + 60*Dd**2*b2*r**2 + 120*Dd**2*b2*r*s - 90*Dd**2*b2*r + 60*Dd**2*b2*s**2 - 90*Dd**2*b2*s + 30*Dd**2*b2 - 120*Dd**2*g2*r**2 - 240*Dd**2*g2*r*s + 180*Dd**2*g2*r - 120*Dd**2*g2*s**2 + 180*Dd**2*g2*s - 60*Dd**2*g2) + b1*(10*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 6*D1**2*K*bdd1*f*r**2 + 12*D1**2*K*bdd1*f*r*s - 6*D1**2*K*bdd1*f*r + 6*D1**2*K*bdd1*f*s**2 - 6*D1**2*K*bdd1*f*s + 3*D1**2*K*bdd1*f - D1**2*bd2*f*r**2 - 2*D1**2*bd2*f*r*s + 2*D1**2*bd2*f*r - D1**2*bd2*f*s**2 + 2*D1**2*bd2*f*s - D1**2*bd2*f + 6*D1**2*bd2*fd*r**2 + 12*D1**2*bd2*fd*r*s - 12*D1**2*bd2*fd*r + 6*D1**2*bd2*fd*s**2 - 12*D1**2*bd2*fd*s + 6*D1**2*bd2*fd - 20*D1**2*bdd1*g2*r**2 - 40*D1**2*bdd1*g2*r*s + 20*D1**2*bdd1*g2*r - 20*D1**2*bdd1*g2*s**2 + 20*D1**2*bdd1*g2*s - 10*D1**2*bdd1*g2 + 3*D1**2*bdd2*f*r**2 + 6*D1**2*bdd2*f*r*s - 6*D1**2*bdd2*f*r + 3*D1**2*bdd2*f*s**2 - 6*D1**2*bdd2*f*s + 3*D1**2*bdd2*f + 2*D1**2*f*gd2*r**2 + 4*D1**2*f*gd2*r*s - 4*D1**2*f*gd2*r + 2*D1**2*f*gd2*s**2 - 4*D1**2*f*gd2*s + 2*D1**2*f*gd2 - 6*D1**2*f*gdd2*r**2 - 12*D1**2*f*gdd2*r*s + 12*D1**2*f*gdd2*r - 6*D1**2*f*gdd2*s**2 + 12*D1**2*f*gdd2*s - 6*D1**2*f*gdd2 + 2*D1**2*fd*g2*r**2 + 4*D1**2*fd*g2*r*s - 4*D1**2*fd*g2*r + 2*D1**2*fd*g2*s**2 - 4*D1**2*fd*g2*s + 2*D1**2*fd*g2 - 12*D1**2*fd*gd2*r**2 - 24*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 12*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 12*D1**2*fd*gd2 - 6*D1**2*fdd*g2*r**2 - 12*D1**2*fdd*g2*r*s + 12*D1**2*fdd*g2*r - 6*D1**2*fdd*g2*s**2 + 12*D1**2*fdd*g2*s - 6*D1**2*fdd*g2 + 24*D1*Dd*bd2*f*r**2 + 48*D1*Dd*bd2*f*r*s - 42*D1*Dd*bd2*f*r + 24*D1*Dd*bd2*f*s**2 - 42*D1*Dd*bd2*f*s + 18*D1*Dd*bd2*f + 8*D1*Dd*f*g2*r**2 + 16*D1*Dd*f*g2*r*s - 12*D1*Dd*f*g2*r + 8*D1*Dd*f*g2*s**2 - 12*D1*Dd*f*g2*s + 6*D1*Dd*f*g2 - 48*D1*Dd*f*gd2*r**2 - 96*D1*Dd*f*gd2*r*s + 84*D1*Dd*f*gd2*r - 48*D1*Dd*f*gd2*s**2 + 84*D1*Dd*f*gd2*s - 36*D1*Dd*f*gd2 - 48*D1*Dd*fd*g2*r**2 - 96*D1*Dd*fd*g2*r*s + 84*D1*Dd*fd*g2*r - 48*D1*Dd*fd*g2*s**2 + 84*D1*Dd*fd*g2*s - 36*D1*Dd*fd*g2 - 24*D1*Ddd*f*g2*r**2 - 48*D1*Ddd*f*g2*r*s + 36*D1*Ddd*f*g2*r - 24*D1*Ddd*f*g2*s**2 + 36*D1*Ddd*f*g2*s - 18*D1*Ddd*f*g2 + D1*bd1*(10*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - D1*(K*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 10*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(-3*K*f + 10*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 72*Dd**2*f*g2*r**2 - 144*Dd**2*f*g2*r*s + 108*Dd**2*f*g2*r - 72*Dd**2*f*g2*s**2 + 108*Dd**2*f*g2*s - 36*Dd**2*f*g2 + b2*(5*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - D1**2*fd*r**2 - 2*D1**2*fd*r*s + 2*D1**2*fd*r - D1**2*fd*s**2 + 2*D1**2*fd*s - D1**2*fd + 3*D1**2*fdd*r**2 + 6*D1**2*fdd*r*s - 6*D1**2*fdd*r + 3*D1**2*fdd*s**2 - 6*D1**2*fdd*s + 3*D1**2*fdd - 4*D1*Dd*f*r**2 - 8*D1*Dd*f*r*s + 6*D1*Dd*f*r - 4*D1*Dd*f*s**2 + 6*D1*Dd*f*s - 3*D1*Dd*f + 24*D1*Dd*fd*r**2 + 48*D1*Dd*fd*r*s - 42*D1*Dd*fd*r + 24*D1*Dd*fd*s**2 - 42*D1*Dd*fd*s + 18*D1*Dd*fd + 12*D1*Ddd*f*r**2 + 24*D1*Ddd*f*r*s - 18*D1*Ddd*f*r + 12*D1*Ddd*f*s**2 - 18*D1*Ddd*f*s + 9*D1*Ddd*f + 5*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 36*Dd**2*f*r**2 + 72*Dd**2*f*r*s - 54*Dd**2*f*r + 36*Dd**2*f*s**2 - 54*Dd**2*f*s + 18*Dd**2*f)))/(30*d**2*k3**2) + D1**2*Pk1*Pkdd3*k2**6*st**6*(99*b1**2*(D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*f*(-9*D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 18*D1*bd1*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 2*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f**2*(-198*D1**2*bd1**2*(r + s - 1)**2 + 44*D1**2*bdd1*f*(r + s - 1)**2 - 15*D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 88*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 15*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(1386*d**2*k3**6) + D1**2*Pk1*Pkdd3*k2**4*st**6*(2*C - 1)*(36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - 9*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 18*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(126*d**2*k3**4) + D1**2*Pk1*Pkdd3*k2**4*st**4*(-42*C*D1**2*bd1*f**2*r**2 - 84*C*D1**2*bd1*f**2*r*s + 84*C*D1**2*bd1*f**2*r - 42*C*D1**2*bd1*f**2*s**2 + 84*C*D1**2*bd1*f**2*s - 42*C*D1**2*bd1*f**2 - 18*C*D1**2*f**2*fd*r**2 - 36*C*D1**2*f**2*fd*r*s + 24*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 12*C*D1**2*f**2*fd - 24*C*D1*Dd*f**3*r**2 - 48*C*D1*Dd*f**3*r*s + 36*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 36*C*D1*Dd*f**3*s - 18*C*D1*Dd*f**3 - 42*D1**2*K*bd1**2*f*r**2 - 84*D1**2*K*bd1**2*f*r*s + 84*D1**2*K*bd1**2*f*r - 42*D1**2*K*bd1**2*f*s**2 + 84*D1**2*K*bd1**2*f*s - 42*D1**2*K*bd1**2*f + 6*D1**2*K*bd1*f**2*r**2 + 12*D1**2*K*bd1*f**2*r*s - 12*D1**2*K*bd1*f**2*r + 6*D1**2*K*bd1*f**2*s**2 - 12*D1**2*K*bd1*f**2*s + 6*D1**2*K*bd1*f**2 - 12*D1**2*K*bd1*f*fd*r**2 - 24*D1**2*K*bd1*f*fd*r*s + 18*D1**2*K*bd1*f*fd*r - 12*D1**2*K*bd1*f*fd*s**2 + 18*D1**2*K*bd1*f*fd*s - 6*D1**2*K*bd1*f*fd - 3*D1**2*K*bdd1*f**2*r**2 - 6*D1**2*K*bdd1*f**2*r*s + 6*D1**2*K*bdd1*f**2*r - 3*D1**2*K*bdd1*f**2*s**2 + 6*D1**2*K*bdd1*f**2*s - 3*D1**2*K*bdd1*f**2 + 36*D1**2*bd1**2*f**2*r**2 + 72*D1**2*bd1**2*f**2*r*s - 60*D1**2*bd1**2*f**2*r + 36*D1**2*bd1**2*f**2*s**2 - 60*D1**2*bd1**2*f**2*s + 24*D1**2*bd1**2*f**2 - 42*D1**2*bd1*bd2*f*r**2 - 84*D1**2*bd1*bd2*f*r*s + 84*D1**2*bd1*bd2*f*r - 42*D1**2*bd1*bd2*f*s**2 + 84*D1**2*bd1*bd2*f*s - 42*D1**2*bd1*bd2*f - 14*D1**2*bd1*f**3*r**2 - 28*D1**2*bd1*f**3*r*s + 16*D1**2*bd1*f**3*r - 14*D1**2*bd1*f**3*s**2 + 16*D1**2*bd1*f**3*s - 8*D1**2*bd1*f**3 + 42*D1**2*bd1*f**2*fd*r**2 + 84*D1**2*bd1*f**2*fd*r*s - 58*D1**2*bd1*f**2*fd*r + 42*D1**2*bd1*f**2*fd*s**2 - 58*D1**2*bd1*f**2*fd*s + 16*D1**2*bd1*f**2*fd + 21*D1**2*bd1*f**2*r**2 + 42*D1**2*bd1*f**2*r*s - 42*D1**2*bd1*f**2*r + 21*D1**2*bd1*f**2*s**2 - 42*D1**2*bd1*f**2*s + 21*D1**2*bd1*f**2 - 84*D1**2*bd1*f*g2*r**2 - 168*D1**2*bd1*f*g2*r*s + 168*D1**2*bd1*f*g2*r - 84*D1**2*bd1*f*g2*s**2 + 168*D1**2*bd1*f*g2*s - 84*D1**2*bd1*f*g2 + 84*D1**2*bd1*f*gd2*r**2 + 168*D1**2*bd1*f*gd2*r*s - 168*D1**2*bd1*f*gd2*r + 84*D1**2*bd1*f*gd2*s**2 - 168*D1**2*bd1*f*gd2*s + 84*D1**2*bd1*f*gd2 + 84*D1**2*bd1*fd*g2*r**2 + 168*D1**2*bd1*fd*g2*r*s - 84*D1**2*bd1*fd*g2*r + 84*D1**2*bd1*fd*g2*s**2 - 84*D1**2*bd1*fd*g2*s + 6*D1**2*bd2*f**2*r**2 + 12*D1**2*bd2*f**2*r*s - 12*D1**2*bd2*f**2*r + 6*D1**2*bd2*f**2*s**2 - 12*D1**2*bd2*f**2*s + 6*D1**2*bd2*f**2 - 12*D1**2*bd2*f*fd*r**2 - 24*D1**2*bd2*f*fd*r*s + 18*D1**2*bd2*f*fd*r - 12*D1**2*bd2*f*fd*s**2 + 18*D1**2*bd2*f*fd*s - 6*D1**2*bd2*f*fd + 7*D1**2*bdd1*f**3*r**2 + 14*D1**2*bdd1*f**3*r*s - 8*D1**2*bdd1*f**3*r + 7*D1**2*bdd1*f**3*s**2 - 8*D1**2*bdd1*f**3*s + 4*D1**2*bdd1*f**3 + 42*D1**2*bdd1*f*g2*r**2 + 84*D1**2*bdd1*f*g2*r*s - 84*D1**2*bdd1*f*g2*r + 42*D1**2*bdd1*f*g2*s**2 - 84*D1**2*bdd1*f*g2*s + 42*D1**2*bdd1*f*g2 - 3*D1**2*bdd2*f**2*r**2 - 6*D1**2*bdd2*f**2*r*s + 6*D1**2*bdd2*f**2*r - 3*D1**2*bdd2*f**2*s**2 + 6*D1**2*bdd2*f**2*s - 3*D1**2*bdd2*f**2 + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 12*D1**2*f**2*gd2*r**2 - 24*D1**2*f**2*gd2*r*s + 24*D1**2*f**2*gd2*r - 12*D1**2*f**2*gd2*s**2 + 24*D1**2*f**2*gd2*s - 12*D1**2*f**2*gd2 + 6*D1**2*f**2*gdd2*r**2 + 12*D1**2*f**2*gdd2*r*s - 12*D1**2*f**2*gdd2*r + 6*D1**2*f**2*gdd2*s**2 - 12*D1**2*f**2*gdd2*s + 6*D1**2*f**2*gdd2 - 24*D1**2*f*fd*g2*r**2 - 48*D1**2*f*fd*g2*r*s + 24*D1**2*f*fd*g2*r - 24*D1**2*f*fd*g2*s**2 + 24*D1**2*f*fd*g2*s - 12*D1**2*f*fd*g2 + 24*D1**2*f*fd*gd2*r**2 + 48*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 24*D1**2*f*fd*gd2*s**2 - 36*D1**2*f*fd*gd2*s + 12*D1**2*f*fd*gd2 + 12*D1**2*f*fdd*g2*r**2 + 24*D1**2*f*fdd*g2*r*s - 12*D1**2*f*fdd*g2*r + 12*D1**2*f*fdd*g2*s**2 - 12*D1**2*f*fdd*g2*s + 6*D1**2*f*fdd*g2 + 12*D1**2*fd**2*g2*r**2 + 24*D1**2*fd**2*g2*r*s - 12*D1**2*fd**2*g2*r + 12*D1**2*fd**2*g2*s**2 - 12*D1**2*fd**2*g2*s - 24*D1*Dd*K*bd1*f**2*r**2 - 48*D1*Dd*K*bd1*f**2*r*s + 42*D1*Dd*K*bd1*f**2*r - 24*D1*Dd*K*bd1*f**2*s**2 + 42*D1*Dd*K*bd1*f**2*s - 18*D1*Dd*K*bd1*f**2 + 56*D1*Dd*bd1*f**3*r**2 + 112*D1*Dd*bd1*f**3*r*s - 74*D1*Dd*bd1*f**3*r + 56*D1*Dd*bd1*f**3*s**2 - 74*D1*Dd*bd1*f**3*s + 24*D1*Dd*bd1*f**3 + 336*D1*Dd*bd1*f*g2*r**2 + 672*D1*Dd*bd1*f*g2*r*s - 588*D1*Dd*bd1*f*g2*r + 336*D1*Dd*bd1*f*g2*s**2 - 588*D1*Dd*bd1*f*g2*s + 252*D1*Dd*bd1*f*g2 - 24*D1*Dd*bd2*f**2*r**2 - 48*D1*Dd*bd2*f**2*r*s + 42*D1*Dd*bd2*f**2*r - 24*D1*Dd*bd2*f**2*s**2 + 42*D1*Dd*bd2*f**2*s - 18*D1*Dd*bd2*f**2 + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 - 48*D1*Dd*f**2*g2*r**2 - 96*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 48*D1*Dd*f**2*g2*s**2 + 72*D1*Dd*f**2*g2*s - 36*D1*Dd*f**2*g2 + 48*D1*Dd*f**2*gd2*r**2 + 96*D1*Dd*f**2*gd2*r*s - 84*D1*Dd*f**2*gd2*r + 48*D1*Dd*f**2*gd2*s**2 - 84*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 96*D1*Dd*f*fd*g2*r**2 + 192*D1*Dd*f*fd*g2*r*s - 120*D1*Dd*f*fd*g2*r + 96*D1*Dd*f*fd*g2*s**2 - 120*D1*Dd*f*fd*g2*s + 36*D1*Dd*f*fd*g2 + 24*D1*Ddd*f**2*g2*r**2 + 48*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 24*D1*Ddd*f**2*g2*s**2 - 36*D1*Ddd*f**2*g2*s + 18*D1*Ddd*f**2*g2 + 72*Dd**2*f**2*g2*r**2 + 144*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 72*Dd**2*f**2*g2*s**2 - 108*Dd**2*f**2*g2*s + 36*Dd**2*f**2*g2 + 21*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(14*D1**2*K*fd*r**2 + 28*D1**2*K*fd*r*s + 14*D1**2*K*fd*s**2 - 7*D1**2*K*fdd*r**2 - 14*D1**2*K*fdd*r*s - 7*D1**2*K*fdd*s**2 - 7*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 24*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 32*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 32*D1**2*f*fd*s - 16*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s - 16*D1**2*f*fdd*r + 12*D1**2*f*fdd*s**2 - 16*D1**2*f*fdd*s + 8*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 16*D1**2*fd**2*r + 12*D1**2*fd**2*s**2 - 16*D1**2*fd**2*s + 4*D1**2*fd**2 + 56*D1*Dd*K*f*r**2 + 112*D1*Dd*K*f*r*s - 84*D1*Dd*K*f*r + 56*D1*Dd*K*f*s**2 - 84*D1*Dd*K*f*s + 42*D1*Dd*K*f - 56*D1*Dd*K*fd*r**2 - 112*D1*Dd*K*fd*r*s + 42*D1*Dd*K*fd*r - 56*D1*Dd*K*fd*s**2 + 42*D1*Dd*K*fd*s - 48*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 72*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s - 136*D1*Dd*f*fd*r + 96*D1*Dd*f*fd*s**2 - 136*D1*Dd*f*fd*s + 48*D1*Dd*f*fd - 28*D1*Ddd*K*f*r**2 - 56*D1*Ddd*K*f*r*s + 42*D1*Ddd*K*f*r - 28*D1*Ddd*K*f*s**2 + 42*D1*Ddd*K*f*s - 21*D1*Ddd*K*f + 24*D1*Ddd*f**2*r**2 + 48*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 84*Dd**2*K*f*r**2 - 168*Dd**2*K*f*r*s + 126*Dd**2*K*f*r - 84*Dd**2*K*f*s**2 + 126*Dd**2*K*f*s - 42*Dd**2*K*f + 72*Dd**2*f**2*r**2 + 144*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 72*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 36*Dd**2*f**2) + b1*(-84*C*D1**2*f*fd*r**2 - 168*C*D1**2*f*fd*r*s + 84*C*D1**2*f*fd*r - 84*C*D1**2*f*fd*s**2 + 84*C*D1**2*f*fd*s - 42*C*D1**2*f*fd - 168*C*D1*Dd*f**2*r**2 - 336*C*D1*Dd*f**2*r*s + 252*C*D1*Dd*f**2*r - 168*C*D1*Dd*f**2*s**2 + 252*C*D1*Dd*f**2*s - 126*C*D1*Dd*f**2 - 42*D1**2*K*bdd1*f*r**2 - 84*D1**2*K*bdd1*f*r*s + 84*D1**2*K*bdd1*f*r - 42*D1**2*K*bdd1*f*s**2 + 84*D1**2*K*bdd1*f*s - 42*D1**2*K*bdd1*f + 12*D1**2*K*f*fd*r**2 + 24*D1**2*K*f*fd*r*s - 12*D1**2*K*f*fd*r + 12*D1**2*K*f*fd*s**2 - 12*D1**2*K*f*fd*s + 6*D1**2*K*f*fd - 6*D1**2*K*f*fdd*r**2 - 12*D1**2*K*f*fdd*r*s + 6*D1**2*K*f*fdd*r - 6*D1**2*K*f*fdd*s**2 + 6*D1**2*K*f*fdd*s - 3*D1**2*K*f*fdd - 6*D1**2*K*fd**2*r**2 - 12*D1**2*K*fd**2*r*s + 6*D1**2*K*fd**2*r - 6*D1**2*K*fd**2*s**2 + 6*D1**2*K*fd**2*s + 42*D1**2*b2*fd*r**2 + 84*D1**2*b2*fd*r*s + 42*D1**2*b2*fd*s**2 - 21*D1**2*b2*fdd*r**2 - 42*D1**2*b2*fdd*r*s - 21*D1**2*b2*fdd*s**2 - 42*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 36*D1**2*bdd1*f**2*r**2 + 72*D1**2*bdd1*f**2*r*s - 60*D1**2*bdd1*f**2*r + 36*D1**2*bdd1*f**2*s**2 - 60*D1**2*bdd1*f**2*s + 30*D1**2*bdd1*f**2 - 21*D1**2*bdd2*f*r**2 - 42*D1**2*bdd2*f*r*s + 42*D1**2*bdd2*f*r - 21*D1**2*bdd2*f*s**2 + 42*D1**2*bdd2*f*s - 21*D1**2*bdd2*f - 42*D1**2*f**2*fd*r**2 - 84*D1**2*f**2*fd*r*s + 68*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 68*D1**2*f**2*fd*s - 34*D1**2*f**2*fd + 21*D1**2*f**2*fdd*r**2 + 42*D1**2*f**2*fdd*r*s - 34*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s**2 - 34*D1**2*f**2*fdd*s + 17*D1**2*f**2*fdd + 42*D1**2*f*fd**2*r**2 + 84*D1**2*f*fd**2*r*s - 68*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s**2 - 68*D1**2*f*fd**2*s + 26*D1**2*f*fd**2 + 42*D1**2*f*fd*r**2 + 84*D1**2*f*fd*r*s - 42*D1**2*f*fd*r + 42*D1**2*f*fd*s**2 - 42*D1**2*f*fd*s + 21*D1**2*f*fd - 84*D1**2*f*gd2*r**2 - 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*r - 84*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s - 84*D1**2*f*gd2 + 42*D1**2*f*gdd2*r**2 + 84*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*r + 42*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 42*D1**2*f*gdd2 - 84*D1**2*fd*g2*r**2 - 168*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*s**2 + 84*D1**2*fd*gd2*r**2 + 168*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*r + 84*D1**2*fd*gd2*s**2 - 84*D1**2*fd*gd2*s + 42*D1**2*fdd*g2*r**2 + 84*D1**2*fdd*g2*r*s + 42*D1**2*fdd*g2*s**2 + 24*D1*Dd*K*f**2*r**2 + 48*D1*Dd*K*f**2*r*s - 36*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s**2 - 36*D1*Dd*K*f**2*s + 18*D1*Dd*K*f**2 - 48*D1*Dd*K*f*fd*r**2 - 96*D1*Dd*K*f*fd*r*s + 60*D1*Dd*K*f*fd*r - 48*D1*Dd*K*f*fd*s**2 + 60*D1*Dd*K*f*fd*s - 18*D1*Dd*K*f*fd + 168*D1*Dd*b2*f*r**2 + 336*D1*Dd*b2*f*r*s - 252*D1*Dd*b2*f*r + 168*D1*Dd*b2*f*s**2 - 252*D1*Dd*b2*f*s + 126*D1*Dd*b2*f - 168*D1*Dd*b2*fd*r**2 - 336*D1*Dd*b2*fd*r*s + 126*D1*Dd*b2*fd*r - 168*D1*Dd*b2*fd*s**2 + 126*D1*Dd*b2*fd*s - 56*D1*Dd*f**3*r**2 - 112*D1*Dd*f**3*r*s + 84*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 84*D1*Dd*f**3*s - 42*D1*Dd*f**3 + 168*D1*Dd*f**2*fd*r**2 + 336*D1*Dd*f**2*fd*r*s - 262*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s**2 - 262*D1*Dd*f**2*fd*s + 102*D1*Dd*f**2*fd + 84*D1*Dd*f**2*r**2 + 168*D1*Dd*f**2*r*s - 126*D1*Dd*f**2*r + 84*D1*Dd*f**2*s**2 - 126*D1*Dd*f**2*s + 63*D1*Dd*f**2 - 336*D1*Dd*f*g2*r**2 - 672*D1*Dd*f*g2*r*s + 504*D1*Dd*f*g2*r - 336*D1*Dd*f*g2*s**2 + 504*D1*Dd*f*g2*s - 252*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 + 672*D1*Dd*f*gd2*r*s - 588*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s**2 - 588*D1*Dd*f*gd2*s + 252*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r**2 + 672*D1*Dd*fd*g2*r*s - 252*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s**2 - 252*D1*Dd*fd*g2*s - 12*D1*Ddd*K*f**2*r**2 - 24*D1*Ddd*K*f**2*r*s + 18*D1*Ddd*K*f**2*r - 12*D1*Ddd*K*f**2*s**2 + 18*D1*Ddd*K*f**2*s - 9*D1*Ddd*K*f**2 - 84*D1*Ddd*b2*f*r**2 - 168*D1*Ddd*b2*f*r*s + 126*D1*Ddd*b2*f*r - 84*D1*Ddd*b2*f*s**2 + 126*D1*Ddd*b2*f*s - 63*D1*Ddd*b2*f + 28*D1*Ddd*f**3*r**2 + 56*D1*Ddd*f**3*r*s - 42*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 42*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 + 168*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r*s - 252*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s**2 - 252*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 - 12*D1*bd1*(D1*(7*K*fd*(r**2 + r*(2*s - 1) + s*(s - 1)) + f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - f*(7*K*(r + s - 1) + 6*fd*(2*r + 2*s - 1))*(r + s - 1)) - Dd*f*(-7*K*(r + s - 1) + f*(6*r + 6*s - 5))*(4*r + 4*s - 3)) + 42*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 36*Dd**2*K*f**2*r**2 - 72*Dd**2*K*f**2*r*s + 54*Dd**2*K*f**2*r - 36*Dd**2*K*f**2*s**2 + 54*Dd**2*K*f**2*s - 18*Dd**2*K*f**2 - 252*Dd**2*b2*f*r**2 - 504*Dd**2*b2*f*r*s + 378*Dd**2*b2*f*r - 252*Dd**2*b2*f*s**2 + 378*Dd**2*b2*f*s - 126*Dd**2*b2*f + 84*Dd**2*f**3*r**2 + 168*Dd**2*f**3*r*s - 126*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 126*Dd**2*f**3*s + 42*Dd**2*f**3 + 504*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r*s - 756*Dd**2*f*g2*r + 504*Dd**2*f*g2*s**2 - 756*Dd**2*f*g2*s + 252*Dd**2*f*g2) + 3*b2*(-7*D1**2*bdd1*f*(r + s - 1)**2 + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd*s - 6*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 14*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2))/(210*d**2*k3**4) + D1**2*Pk1*Pkdd3*k2**2*st**4*(2*C - 1)*(-D1*f*(r + s)*(14*D1*bd1**2*(r + s - 1) + D1*bdd1*f*(r + s) + bd1*(-2*D1*f*(r + s) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3))) + 7*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-7*D1**2*bdd1*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 4*D1**2*f*fdd*s - 2*D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 4*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 4*D1**2*fd**2*s - 2*D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 28*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 28*D1*Dd*f*fd*s - 12*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2))/(70*d**2*k3**2) + D1**2*Pk1*Pkdd3*k2**2*st**2*(-D1*(r + s)*(-2*D1*bd1**2*(r + s - 1)*(-7*K*f + 6*f**2 + 70*g2) - 14*D1*bdd1*f*g2*(r + s) + 7*b2*(10*D1*bd1**2*(r + s - 1) + D1*bdd1*f*(r + s) + 2*bd1*(-D1*f*(r + s) + D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + 7*bd1*(2*D1*bd2*f*(r + s - 1) + D1*(-4*f*gd2*(r + s - 1) + f*(r + s)*(f*(2*C - 1) + 4*g2) - 4*fd*g2*(r + s - 1)) - 4*Dd*f*g2*(4*r + 4*s - 3))) - 7*b1**3*(2*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(-5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*(-5*K + 2*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-5*K + 2*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-70*C*D1**2*fd*r**2 - 140*C*D1**2*fd*r*s + 140*C*D1**2*fd*r - 70*C*D1**2*fd*s**2 + 140*C*D1**2*fd*s - 70*C*D1**2*fd - 280*C*D1*Dd*f*r**2 - 560*C*D1*Dd*f*r*s + 420*C*D1*Dd*f*r - 280*C*D1*Dd*f*s**2 + 420*C*D1*Dd*f*s - 210*C*D1*Dd*f + 210*D1**2*K*bd1*r**2 + 420*D1**2*K*bd1*r*s - 280*D1**2*K*bd1*r + 210*D1**2*K*bd1*s**2 - 280*D1**2*K*bd1*s + 140*D1**2*K*bd1 - 105*D1**2*K*bdd1*r**2 - 210*D1**2*K*bdd1*r*s + 140*D1**2*K*bdd1*r - 105*D1**2*K*bdd1*s**2 + 140*D1**2*K*bdd1*s - 70*D1**2*K*bdd1 + 14*D1**2*K*fd*r**2 + 28*D1**2*K*fd*r*s - 28*D1**2*K*fd*r + 14*D1**2*K*fd*s**2 - 28*D1**2*K*fd*s + 14*D1**2*K*fd - 7*D1**2*K*fdd*r**2 - 14*D1**2*K*fdd*r*s + 14*D1**2*K*fdd*r - 7*D1**2*K*fdd*s**2 + 14*D1**2*K*fdd*s - 7*D1**2*K*fdd - 84*D1**2*bd1*f*r**2 - 168*D1**2*bd1*f*r*s + 112*D1**2*bd1*f*r - 84*D1**2*bd1*f*s**2 + 112*D1**2*bd1*f*s - 56*D1**2*bd1*f + 84*D1**2*bd1*fd*r**2 + 168*D1**2*bd1*fd*r*s - 140*D1**2*bd1*fd*r + 84*D1**2*bd1*fd*s**2 - 140*D1**2*bd1*fd*s + 56*D1**2*bd1*fd + 42*D1**2*bdd1*f*r**2 + 84*D1**2*bdd1*f*r*s - 56*D1**2*bdd1*f*r + 42*D1**2*bdd1*f*s**2 - 56*D1**2*bdd1*f*s + 28*D1**2*bdd1*f - 35*D1**2*bdd2*(r + s - 1)**2 - 24*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 48*D1**2*f*fd*s - 24*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s - 24*D1**2*f*fdd*r + 12*D1**2*f*fdd*s**2 - 24*D1**2*f*fdd*s + 12*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 24*D1**2*fd**2*r + 12*D1**2*fd**2*s**2 - 24*D1**2*fd**2*s + 12*D1**2*fd**2 + 35*D1**2*fd*r**2 + 70*D1**2*fd*r*s - 70*D1**2*fd*r + 35*D1**2*fd*s**2 - 70*D1**2*fd*s + 35*D1**2*fd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 + 70*D1**2*gdd2*r**2 + 140*D1**2*gdd2*r*s - 140*D1**2*gdd2*r + 70*D1**2*gdd2*s**2 - 140*D1**2*gdd2*s + 70*D1**2*gdd2 - 840*D1*Dd*K*bd1*r**2 - 1680*D1*Dd*K*bd1*r*s + 1190*D1*Dd*K*bd1*r - 840*D1*Dd*K*bd1*s**2 + 1190*D1*Dd*K*bd1*s - 420*D1*Dd*K*bd1 + 56*D1*Dd*K*f*r**2 + 112*D1*Dd*K*f*r*s - 84*D1*Dd*K*f*r + 56*D1*Dd*K*f*s**2 - 84*D1*Dd*K*f*s + 42*D1*Dd*K*f - 56*D1*Dd*K*fd*r**2 - 112*D1*Dd*K*fd*r*s + 98*D1*Dd*K*fd*r - 56*D1*Dd*K*fd*s**2 + 98*D1*Dd*K*fd*s - 42*D1*Dd*K*fd + 280*D1*Dd*b2*r**2 + 560*D1*Dd*b2*r*s - 420*D1*Dd*b2*r + 280*D1*Dd*b2*s**2 - 420*D1*Dd*b2*s + 210*D1*Dd*b2 + 336*D1*Dd*bd1*f*r**2 + 672*D1*Dd*bd1*f*r*s - 476*D1*Dd*bd1*f*r + 336*D1*Dd*bd1*f*s**2 - 476*D1*Dd*bd1*f*s + 168*D1*Dd*bd1*f - 48*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 72*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s - 168*D1*Dd*f*fd*r + 96*D1*Dd*f*fd*s**2 - 168*D1*Dd*f*fd*s + 72*D1*Dd*f*fd + 140*D1*Dd*f*r**2 + 280*D1*Dd*f*r*s - 210*D1*Dd*f*r + 140*D1*Dd*f*s**2 - 210*D1*Dd*f*s + 105*D1*Dd*f - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 + 1120*D1*Dd*gd2*r*s - 980*D1*Dd*gd2*r + 560*D1*Dd*gd2*s**2 - 980*D1*Dd*gd2*s + 420*D1*Dd*gd2 - 28*D1*Ddd*K*f*r**2 - 56*D1*Ddd*K*f*r*s + 42*D1*Ddd*K*f*r - 28*D1*Ddd*K*f*s**2 + 42*D1*Ddd*K*f*s - 21*D1*Ddd*K*f - 140*D1*Ddd*b2*r**2 - 280*D1*Ddd*b2*r*s + 210*D1*Ddd*b2*r - 140*D1*Ddd*b2*s**2 + 210*D1*Ddd*b2*s - 105*D1*Ddd*b2 + 24*D1*Ddd*f**2*r**2 + 48*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + 280*D1*Ddd*g2*r**2 + 560*D1*Ddd*g2*r*s - 420*D1*Ddd*g2*r + 280*D1*Ddd*g2*s**2 - 420*D1*Ddd*g2*s + 210*D1*Ddd*g2 + 70*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 84*Dd**2*K*f*r**2 - 168*Dd**2*K*f*r*s + 126*Dd**2*K*f*r - 84*Dd**2*K*f*s**2 + 126*Dd**2*K*f*s - 42*Dd**2*K*f - 420*Dd**2*b2*r**2 - 840*Dd**2*b2*r*s + 630*Dd**2*b2*r - 420*Dd**2*b2*s**2 + 630*Dd**2*b2*s - 210*Dd**2*b2 + 72*Dd**2*f**2*r**2 + 144*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 72*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 36*Dd**2*f**2 + 840*Dd**2*g2*r**2 + 1680*Dd**2*g2*r*s - 1260*Dd**2*g2*r + 840*Dd**2*g2*s**2 - 1260*Dd**2*g2*s + 420*Dd**2*g2) + b1*(-28*C*D1**2*f*fd*r**2 - 56*C*D1**2*f*fd*r*s + 56*C*D1**2*f*fd*r - 28*C*D1**2*f*fd*s**2 + 56*C*D1**2*f*fd*s - 28*C*D1**2*f*fd - 56*C*D1*Dd*f**2*r**2 - 112*C*D1*Dd*f**2*r*s + 84*C*D1*Dd*f**2*r - 56*C*D1*Dd*f**2*s**2 + 84*C*D1*Dd*f**2*s - 42*C*D1*Dd*f**2 - 14*D1**2*K*bdd1*f*r**2 - 28*D1**2*K*bdd1*f*r*s + 14*D1**2*K*bdd1*f*r - 14*D1**2*K*bdd1*f*s**2 + 14*D1**2*K*bdd1*f*s - 7*D1**2*K*bdd1*f + 14*D1**2*bd1**2*(-5*K + 2*f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 14*D1**2*bd2*f*r**2 + 28*D1**2*bd2*f*r*s - 28*D1**2*bd2*f*r + 14*D1**2*bd2*f*s**2 - 28*D1**2*bd2*f*s + 14*D1**2*bd2*f - 14*D1**2*bd2*fd*r**2 - 28*D1**2*bd2*fd*r*s + 28*D1**2*bd2*fd*r - 14*D1**2*bd2*fd*s**2 + 28*D1**2*bd2*fd*s - 14*D1**2*bd2*fd + 12*D1**2*bdd1*f**2*r**2 + 24*D1**2*bdd1*f**2*r*s - 12*D1**2*bdd1*f**2*r + 12*D1**2*bdd1*f**2*s**2 - 12*D1**2*bdd1*f**2*s + 6*D1**2*bdd1*f**2 + 140*D1**2*bdd1*g2*r**2 + 280*D1**2*bdd1*g2*r*s - 140*D1**2*bdd1*g2*r + 140*D1**2*bdd1*g2*s**2 - 140*D1**2*bdd1*g2*s + 70*D1**2*bdd1*g2 - 7*D1**2*bdd2*f*r**2 - 14*D1**2*bdd2*f*r*s + 14*D1**2*bdd2*f*r - 7*D1**2*bdd2*f*s**2 + 14*D1**2*bdd2*f*s - 7*D1**2*bdd2*f + 14*D1**2*f*fd*r**2 + 28*D1**2*f*fd*r*s - 28*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 - 28*D1**2*f*fd*s + 14*D1**2*f*fd - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 14*D1**2*f*gdd2*r**2 + 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 28*D1**2*fd*gd2*r**2 + 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 56*D1**2*fd*gd2*s + 28*D1**2*fd*gd2 + 14*D1**2*fdd*g2*r**2 + 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 56*D1*Dd*bd2*f*r**2 - 112*D1*Dd*bd2*f*r*s + 98*D1*Dd*bd2*f*r - 56*D1*Dd*bd2*f*s**2 + 98*D1*Dd*bd2*f*s - 42*D1*Dd*bd2*f + 28*D1*Dd*f**2*r**2 + 56*D1*Dd*f**2*r*s - 42*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 - 42*D1*Dd*f**2*s + 21*D1*Dd*f**2 - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 + 224*D1*Dd*f*gd2*r*s - 196*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 196*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r**2 + 224*D1*Dd*fd*g2*r*s - 196*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 196*D1*Dd*fd*g2*s + 84*D1*Dd*fd*g2 + 56*D1*Ddd*f*g2*r**2 + 112*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 84*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + D1*bd1*(-70*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-12*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(-70*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 24*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + (14*K + 35)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) - 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-14*K*fd + 140*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(-7*K*f + 6*f**2 + 70*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 168*Dd**2*f*g2*r**2 + 336*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 252*Dd**2*f*g2*s + 84*Dd**2*f*g2 + 7*b2*(-5*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*D1**2*fd*r**2 + 4*D1**2*fd*r*s - 4*D1**2*fd*r + 2*D1**2*fd*s**2 - 4*D1**2*fd*s + 2*D1**2*fd - D1**2*fdd*r**2 - 2*D1**2*fdd*r*s + 2*D1**2*fdd*r - D1**2*fdd*s**2 + 2*D1**2*fdd*s - D1**2*fdd + 8*D1*Dd*f*r**2 + 16*D1*Dd*f*r*s - 12*D1*Dd*f*r + 8*D1*Dd*f*s**2 - 12*D1*Dd*f*s + 6*D1*Dd*f - 8*D1*Dd*fd*r**2 - 16*D1*Dd*fd*r*s + 14*D1*Dd*fd*r - 8*D1*Dd*fd*s**2 + 14*D1*Dd*fd*s - 6*D1*Dd*fd - 4*D1*Ddd*f*r**2 - 8*D1*Ddd*f*r*s + 6*D1*Ddd*f*r - 4*D1*Ddd*f*s**2 + 6*D1*Ddd*f*s - 3*D1*Ddd*f + 10*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 12*Dd**2*f*r**2 - 24*Dd**2*f*r*s + 18*Dd**2*f*r - 12*Dd**2*f*s**2 + 18*Dd**2*f*s - 6*Dd**2*f)))/(210*d**2*k3**2) + D1**2*Pk3*Pkd1*ct**7*k2**5*(8*C - 8)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**7*k2**3*(4*C - 4)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(5*f*(r*(2 - 4*s) + s) + 7*fd*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 2) - s)) + 7*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k3**4) + 4*D1**2*Pk3*Pkd1*ct**6*f*k2**6*(165*D1**2*b1*f*fd*r**2 + 165*D1**2*b1*f*fd*r*s - 110*D1**2*b1*f*fd*r - 231*D1**2*b1*f*fdd*r**2 - 231*D1**2*b1*f*fdd*r*s + 154*D1**2*b1*f*fdd*r - 462*D1**2*b1*fd**2*r**2 - 462*D1**2*b1*fd**2*r*s + 308*D1**2*b1*fd**2*r - 77*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 196*D1**2*f**2*fd*r**2 + 196*D1**2*f**2*fd*r*s - 196*D1**2*f**2*fd*r - 49*D1**2*f**2*fd*s + 49*D1**2*f**2*fd - 252*D1**2*f**2*fdd*r**2 - 252*D1**2*f**2*fdd*r*s + 252*D1**2*f**2*fdd*r + 63*D1**2*f**2*fdd*s - 63*D1**2*f**2*fdd - 756*D1**2*f*fd**2*r**2 - 756*D1**2*f*fd**2*r*s + 756*D1**2*f*fd**2*r + 189*D1**2*f*fd**2*s - 126*D1**2*f*fd**2 + 220*D1*Dd*b1*f**2*r**2 + 220*D1*Dd*b1*f**2*r*s - 220*D1*Dd*b1*f**2*r - 55*D1*Dd*b1*f**2*s + 55*D1*Dd*b1*f**2 - 1848*D1*Dd*b1*f*fd*r**2 - 1848*D1*Dd*b1*f*fd*r*s + 1540*D1*Dd*b1*f*fd*r + 231*D1*Dd*b1*f*fd*s - 154*D1*Dd*b1*f*fd + 196*D1*Dd*f**3*r**2 + 196*D1*Dd*f**3*r*s - 196*D1*Dd*f**3*r - 49*D1*Dd*f**3*s + 49*D1*Dd*f**3 - 2016*D1*Dd*f**2*fd*r**2 - 2016*D1*Dd*f**2*fd*r*s + 2016*D1*Dd*f**2*fd*r + 504*D1*Dd*f**2*fd*s - 378*D1*Dd*f**2*fd - 308*D1*Ddd*b1*f**2*r**2 - 308*D1*Ddd*b1*f**2*r*s + 308*D1*Ddd*b1*f**2*r + 77*D1*Ddd*b1*f**2*s - 77*D1*Ddd*b1*f**2 - 252*D1*Ddd*f**3*r**2 - 252*D1*Ddd*f**3*r*s + 252*D1*Ddd*f**3*r + 63*D1*Ddd*f**3*s - 63*D1*Ddd*f**3 + 11*D1*bd1*f*(D1*(5*f*(r - 1)*(r + s - 1) - 7*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 7*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 924*Dd**2*b1*f**2*r**2 - 924*Dd**2*b1*f**2*r*s + 924*Dd**2*b1*f**2*r + 231*Dd**2*b1*f**2*s - 154*Dd**2*b1*f**2 - 756*Dd**2*f**3*r**2 - 756*Dd**2*f**3*r*s + 756*Dd**2*f**3*r + 189*Dd**2*f**3*s - 126*Dd**2*f**3)/(693*d**2*k1*k3**6) + D1**2*Pk3*Pkd1*ct**6*k1*k2**4*(40*C - 36)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**6*k1*k2**2*(16*C - 14)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(5*f*(r*(2 - 4*s) + s) + 7*fd*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 2) - s)) + 7*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k3**4) + 2*D1**2*Pk3*Pkd1*ct**6*k2**4*(90*C*D1**2*b1*f*fd*r**2 + 18*C*D1**2*b1*f*fdd*r**2 + 18*C*D1**2*b1*fd**2*r**2 - 15*C*D1**2*f**2*fd*r**2 + 10*C*D1**2*f**2*fd*r - 5*C*D1**2*f**2*fd + 75*C*D1**2*f**2*fdd*r**2 - 50*C*D1**2*f**2*fdd*r + 25*C*D1**2*f**2*fdd + 150*C*D1**2*f*fd**2*r**2 - 100*C*D1**2*f*fd**2*r + 180*C*D1*Dd*b1*f**2*r**2 - 90*C*D1*Dd*b1*f**2*r + 45*C*D1*Dd*b1*f**2 + 144*C*D1*Dd*b1*f*fd*r**2 - 36*C*D1*Dd*b1*f*fd*r - 20*C*D1*Dd*f**3*r**2 + 10*C*D1*Dd*f**3*r - 5*C*D1*Dd*f**3 + 600*C*D1*Dd*f**2*fd*r**2 - 350*C*D1*Dd*f**2*fd*r + 50*C*D1*Dd*f**2*fd + 36*C*D1*Ddd*b1*f**2*r**2 - 18*C*D1*Ddd*b1*f**2*r + 9*C*D1*Ddd*b1*f**2 + 100*C*D1*Ddd*f**3*r**2 - 50*C*D1*Ddd*f**3*r + 25*C*D1*Ddd*f**3 + 108*C*Dd**2*b1*f**2*r**2 - 54*C*Dd**2*b1*f**2*r + 300*C*Dd**2*f**3*r**2 - 150*C*Dd**2*f**3*r - 36*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 108*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 108*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(r - 1)*(C*(r - 1) - 6*r - 5*s + 6) + 90*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 85*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 30*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 155*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 60*D1**2*f**2*fdd - 360*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 310*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 - 72*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 18*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s - 18*D1*Dd*b1*f**2 - 864*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 576*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 120*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 110*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 30*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 1190*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 225*D1*Dd*f**2*fd - 216*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 54*D1*Ddd*b1*f**2 - 240*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 190*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(f*(r - 1)*(5*C*(r - 1) - 2*r + 3*s + 2) + fd*(r**2*(4*C - 24) + r*(-4*C - 20*s + 29) + 10*s - 5)) + Dd*f*(2*C*(4*r**2 - 5*r + 1) - 48*r**2 - 40*r*s + 70*r + 25*s - 22)) - 648*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 720*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 570*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k1*k3**4) + 2*D1**2*Pk3*Pkd1*ct**6*k2**2*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(5*f*(r*(2 - 4*s) + s) + 7*fd*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 2) - s)) + 7*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k1*k3**2) + 2*D1**2*Pk3*Pkd1*ct**5*f*k2**5*(132*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*fd**2*r**2 - 22*D1**2*bdd1*f**2*(r - 1)**2 + 56*D1**2*f**2*fd*r**2 - 28*D1**2*f**2*fd*r + 14*D1**2*f**2*fd - 28*D1**2*f**2*fdd*r**2 + 14*D1**2*f**2*fdd*r - 7*D1**2*f**2*fdd - 84*D1**2*f*fd**2*r**2 + 42*D1**2*f*fd**2*r + 176*D1*Dd*b1*f**2*r**2 - 88*D1*Dd*b1*f**2*r + 44*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 56*D1*Dd*f**3*r**2 - 28*D1*Dd*f**3*r + 14*D1*Dd*f**3 - 224*D1*Dd*f**2*fd*r**2 + 112*D1*Dd*f**2*fd*r - 14*D1*Dd*f**2*fd - 88*D1*Ddd*b1*f**2*r**2 + 44*D1*Ddd*b1*f**2*r - 22*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 + 14*D1*Ddd*f**3*r - 7*D1*Ddd*f**3 + 44*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 264*Dd**2*b1*f**2*r**2 + 132*Dd**2*b1*f**2*r - 84*Dd**2*f**3*r**2 + 42*Dd**2*f**3*r)/(693*d**2*k1**2*k3**4) + D1**2*Pk3*Pkd1*ct**5*k1**2*k2**3*(80*C - 64)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**5*k1**2*k2*(8*C - 6)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(5*f*(r*(2 - 4*s) + s) + 7*fd*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 2) - s)) + 7*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**5*k2**5*st**2*(16*C - 16)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 69*D1**2*f**2*fd*r**2 + 69*D1**2*f**2*fd*r*s - 69*D1**2*f**2*fd*r - 23*D1**2*f**2*fd*s + 23*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 92*D1*Dd*f**3*r**2 + 92*D1*Dd*f**3*r*s - 92*D1*Dd*f**3*r - 23*D1*Dd*f**3*s + 23*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 600*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s - 125*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 300*Dd**2*f**3*r + 75*Dd**2*f**3*s - 50*Dd**2*f**3)/(315*d**2*k3**6) - 4*D1**2*Pk3*Pkd1*ct**5*k2**5*(495*D1**2*K*bdd1*f**2*r**2 + 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*r - 99*D1**2*bd1**2*f*(2*r - 1)*(-7*K + 5*f + 7)*(r + s - 1) + 1155*D1**2*bdd1*f**3*r**2 + 1155*D1**2*bdd1*f**3*r*s - 2695*D1**2*bdd1*f**3*r - 1540*D1**2*bdd1*f**3*s + 1540*D1**2*bdd1*f**3 - 495*D1**2*bdd1*f**2*r**2 - 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*r - 1386*D1**2*bdd1*f*g2*r**2 - 1386*D1**2*bdd1*f*g2*r*s + 2772*D1**2*bdd1*f*g2*r + 1386*D1**2*bdd1*f*g2*s - 1386*D1**2*bdd1*f*g2 - 3920*D1**2*f**3*fd*r**2 - 3920*D1**2*f**3*fd*r*s + 3920*D1**2*f**3*fd*r + 980*D1**2*f**3*fd*s - 980*D1**2*f**3*fd + 5040*D1**2*f**3*fdd*r**2 + 5040*D1**2*f**3*fdd*r*s - 5040*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s + 1260*D1**2*f**3*fdd + 15120*D1**2*f**2*fd**2*r**2 + 15120*D1**2*f**2*fd**2*r*s - 15120*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s + 2520*D1**2*f**2*fd**2 + 594*D1**2*f**2*gd2*r**2 + 594*D1**2*f**2*gd2*r*s - 594*D1**2*f**2*gd2*r - 990*D1**2*f**2*gdd2*r**2 - 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*r + 1188*D1**2*f*fd*g2*r**2 + 1188*D1**2*f*fd*g2*r*s - 1188*D1**2*f*fd*g2*r - 594*D1**2*f*fd*g2*s + 594*D1**2*f*fd*g2 - 3960*D1**2*f*fd*gd2*r**2 - 3960*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r + 990*D1**2*f*fd*gd2*s - 990*D1**2*f*fd*gd2 - 1980*D1**2*f*fdd*g2*r**2 - 1980*D1**2*f*fdd*g2*r*s + 1980*D1**2*f*fdd*g2*r + 990*D1**2*f*fdd*g2*s - 990*D1**2*f*fdd*g2 - 1980*D1**2*fd**2*g2*r**2 - 1980*D1**2*fd**2*g2*r*s + 1980*D1**2*fd**2*g2*r + 990*D1**2*fd**2*g2*s - 3920*D1*Dd*f**4*r**2 - 3920*D1*Dd*f**4*r*s + 3920*D1*Dd*f**4*r + 980*D1*Dd*f**4*s - 980*D1*Dd*f**4 + 40320*D1*Dd*f**3*fd*r**2 + 40320*D1*Dd*f**3*fd*r*s - 40320*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s + 7560*D1*Dd*f**3*fd + 2376*D1*Dd*f**2*g2*r**2 + 2376*D1*Dd*f**2*g2*r*s - 2376*D1*Dd*f**2*g2*r - 594*D1*Dd*f**2*g2*s + 594*D1*Dd*f**2*g2 - 7920*D1*Dd*f**2*gd2*r**2 - 7920*D1*Dd*f**2*gd2*r*s + 7920*D1*Dd*f**2*gd2*r + 990*D1*Dd*f**2*gd2*s - 990*D1*Dd*f**2*gd2 - 15840*D1*Dd*f*fd*g2*r**2 - 15840*D1*Dd*f*fd*g2*r*s + 15840*D1*Dd*f*fd*g2*r + 5940*D1*Dd*f*fd*g2*s - 3960*D1*Dd*f*fd*g2 + 5040*D1*Ddd*f**4*r**2 + 5040*D1*Ddd*f**4*r*s - 5040*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s + 1260*D1*Ddd*f**4 - 3960*D1*Ddd*f**2*g2*r**2 - 3960*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r + 990*D1*Ddd*f**2*g2*s - 990*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(25*f**3*(3*r - 4)*(r + s - 1) + f**2*(-35*fd*(18*r**2 + 2*r*(9*s - 13) - 11*s + 7) + r*(27*K - 27)*(r + s - 1)) - 3*f*(15*fd*(K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) + 126*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-35*f**2*(24*r**2 + 8*r*(3*s - 5) - 19*s + 15) - 45*f*(K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 15120*Dd**2*f**4*r**2 + 15120*Dd**2*f**4*r*s - 15120*Dd**2*f**4*r - 3780*Dd**2*f**4*s + 2520*Dd**2*f**4 - 11880*Dd**2*f**2*g2*r**2 - 11880*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r + 2970*Dd**2*f**2*g2*s - 1980*Dd**2*f**2*g2 + 33*b1**2*(D1**2*r*(3*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 15*fd**2*(2*r + 2*s - 1) - 7*fd*(K - 1)*(r + s) + 21*fdd*(K - 1)*(r + s)) + D1*(Dd*(9*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-15*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (7 - 7*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(K - 1)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-7*K + 5*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-7*K + 5*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-54*D1**2*K*f*fd*r**2 - 54*D1**2*K*f*fd*r*s + 54*D1**2*K*f*fd*r + 27*D1**2*K*f*fd*s - 27*D1**2*K*f*fd + 90*D1**2*K*f*fdd*r**2 + 90*D1**2*K*f*fdd*r*s - 90*D1**2*K*f*fdd*r - 45*D1**2*K*f*fdd*s + 45*D1**2*K*f*fdd + 90*D1**2*K*fd**2*r**2 + 90*D1**2*K*fd**2*r*s - 90*D1**2*K*fd**2*r - 45*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*r - 1)*(-7*K + 5*f + 7)*(r + s - 1) - 225*D1**2*f**2*fd*r**2 - 225*D1**2*f**2*fd*r*s + 125*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd + 315*D1**2*f**2*fdd*r**2 + 315*D1**2*f**2*fdd*r*s - 175*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd + 630*D1**2*f*fd**2*r**2 + 630*D1**2*f*fd**2*r*s - 350*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 54*D1**2*f*fd*r**2 + 54*D1**2*f*fd*r*s - 54*D1**2*f*fd*r - 27*D1**2*f*fd*s + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 90*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r + 45*D1**2*f*fdd*s - 45*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r - 126*D1**2*f*gdd2*r**2 - 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*r - 90*D1**2*fd**2*r**2 - 90*D1**2*fd**2*r*s + 90*D1**2*fd**2*r + 45*D1**2*fd**2*s + 42*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s - 252*D1**2*fd*gd2*r**2 - 252*D1**2*fd*gd2*r*s + 126*D1**2*fd*gd2*r - 126*D1**2*fdd*g2*r**2 - 126*D1**2*fdd*g2*r*s - 108*D1*Dd*K*f**2*r**2 - 108*D1*Dd*K*f**2*r*s + 108*D1*Dd*K*f**2*r + 27*D1*Dd*K*f**2*s - 27*D1*Dd*K*f**2 + 720*D1*Dd*K*f*fd*r**2 + 720*D1*Dd*K*f*fd*r*s - 720*D1*Dd*K*f*fd*r - 270*D1*Dd*K*f*fd*s + 180*D1*Dd*K*f*fd - 300*D1*Dd*f**3*r**2 - 300*D1*Dd*f**3*r*s + 300*D1*Dd*f**3*r + 75*D1*Dd*f**3*s - 75*D1*Dd*f**3 + 2520*D1*Dd*f**2*fd*r**2 + 2520*D1*Dd*f**2*fd*r*s - 1960*D1*Dd*f**2*fd*r - 175*D1*Dd*f**2*fd*s + 105*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 + 108*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r - 27*D1*Dd*f**2*s + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 720*D1*Dd*f*fd*r*s + 720*D1*Dd*f*fd*r + 270*D1*Dd*f*fd*s - 180*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 42*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r + 126*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r + 126*D1*Dd*fd*g2*s + 180*D1*Ddd*K*f**2*r**2 + 180*D1*Ddd*K*f**2*r*s - 180*D1*Ddd*K*f**2*r - 45*D1*Ddd*K*f**2*s + 45*D1*Ddd*K*f**2 + 420*D1*Ddd*f**3*r**2 + 420*D1*Ddd*f**3*r*s - 420*D1*Ddd*f**3*r - 105*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 180*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r + 45*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 504*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 126*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(9*f**2*(2*r - 1)*(r + s - 1) + f*(-15*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (7*K - 7)*(2*r - 1)*(r + s - 1)) + 21*fd*(K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-7*K + 5*f + 7)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 540*Dd**2*K*f**2*r**2 + 540*Dd**2*K*f**2*r*s - 540*Dd**2*K*f**2*r - 135*Dd**2*K*f**2*s + 90*Dd**2*K*f**2 + 1260*Dd**2*f**3*r**2 + 1260*Dd**2*f**3*r*s - 1260*Dd**2*f**3*r - 315*Dd**2*f**3*s + 210*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 540*Dd**2*f**2*r*s + 540*Dd**2*f**2*r + 135*Dd**2*f**2*s - 90*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 1512*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 378*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(3465*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**5*k2**3*st**2*(8*C - 8)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(23*f*(4*r*s - 2*r - s) - 25*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(23*f*fd*(r*(3*s - 1) - s) + 5*f*(-9*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(r*(2 - 4*s) + s)) - 25*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k3**4) + 2*D1**2*Pk3*Pkd1*ct**5*k2**3*(42*D1*b1*bd1*(C - 1)*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 42*b1**2*(C - 1)*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 9*b1*(14*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*D1**2*(f*(fd*(C*(34*r*s - 11*r + 3*s - 3) - 7*r**2 - 40*r*s + 14*r - 3*s + 3) + fdd*(C*(-28*r**2 - 38*r*s + 9*r - 5*s + 5) + 35*r**2 + 48*r*s - 14*r + 5*s - 5)) + fd**2*(C*(-28*r**2 - 38*r*s + 9*r - 5*s + 5) + 35*r**2 + 48*r*s - 14*r + 5*s - 5)) + D1*f*(Dd*(-f*(28*r**2 - 2*r*(34*C*(2*s - 1) - 80*s + 47) + s*(34*C - 40) + 7) + 2*fd*(C*(-224*r**2 - 8*r*(38*s - 21) + 18*s + 1) + 280*r**2 + 6*r*(64*s - 37) - 28*s + 4)) + Ddd*f*(-2*C*(56*r**2 + r*(76*s - 66) - 19*s + 14) + 140*r**2 + 2*r*(96*s - 83) - 48*s + 35)) + 2*Dd**2*f**2*(C*(-168*r**2 - 6*r*(38*s - 33) + 57*s - 38) + 210*r**2 + 3*r*(96*s - 83) - 72*s + 48)) + f*(-126*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 9*D1**2*bdd1*f*(C*(28*r**2 + 38*r*(s - 2) - 48*s + 38) - 35*r**2 + r*(90 - 48*s) + 58*s - 45) - 5*D1**2*(f*(fd*(14*C*(9*r**2 + 2*r*(6*s - 5) - 4*s + 3) - 147*r**2 - 198*r*s + 164*r + 66*s - 49) + 2*fdd*(C*(-99*r**2 - 96*r*s + 98*r + 32*s - 33) + 111*r**2 + 117*r*s - 113*r - 39*s + 37)) + 2*fd**2*(-2*C*(99*r**2 + 96*r*s - 98*r - 32*s + 16) + 222*r**2 + 234*r*s - 226*r - 78*s + 39)) - 9*D1*bd1*(D1*(f*(2*C*(17*r*s - 6*r - 20*s + 3) - 7*r**2 - 40*r*s + 26*r + 46*s - 13) - 2*fd*(C*(56*r**2 + 76*r*s - 85*r - 43*s + 24) - 70*r**2 - 96*r*s + 104*r + 53*s - 29)) + 2*Dd*f*(C*(-112*r**2 - 152*r*s + 218*r + 115*s - 86) + 140*r**2 + 192*r*s - 263*r - 140*s + 103)) - 5*D1*f*(Dd*(f*(14*C*(12*r**2 + 2*r*(8*s - 7) - 4*s + 3) - 196*r**2 - 264*r*s + 230*r + 66*s - 49) - 2*fd*(2*C*(396*r**2 + 384*r*s - 391*r - 112*s + 81) - 888*r**2 - 936*r*s + 908*r + 273*s - 191)) + 2*Ddd*f*(C*(-132*r**2 - 2*r*(64*s - 65) + 32*s - 33) + 148*r**2 + 4*r*(39*s - 38) - 39*s + 37)) - 10*Dd**2*f**2*(C*(-396*r**2 - 6*r*(64*s - 65) + 96*s - 64) + 444*r**2 + 12*r*(39*s - 38) - 117*s + 78)))/(315*d**2*k3**4) + 2*D1**2*Pk3*Pkd1*ct**5*k2*(42*D1*b1*bd1*(C - 1)*(D1*(f*s*(2*r - 1) + 3*fd*(-4*r*s + 2*r + s - 1)) - 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) - 42*b1**2*(C - 1)*(D1*Dd*(f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) - 5*fd*(2*s - 1)*(4*C - 8*r - 3)) + D1*(D1*(3*f*fd*(-2*r*s + r + s*(2*C - 2)) + f*(14*bdd1*s*(C - 1)*(2*r - 1) - 5*fdd*(-2*r*s + r + s*(2*C - 2))) - 5*fd**2*(2*C*(s - 1) - 2*r*s + r - 2*s + 2)) + 5*Ddd*f**2*(r*(4*s - 2) - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(-126*D1**2*bd1**2*s*(C - 1)*(2*r - 1) - 5*D1*Dd*f*(2*C - 3)*(5*f*(r*(4*s - 2) - s) - 7*fd*(2*r*(12*s - 5) - 7*s + 3)) + 9*D1*bd1*(D1*(3*f*s*(2*C + r - 3) - 5*fd*(2*C*(s - 1) + 4*r*s - r - 4*s + 3)) - 5*Dd*f*(C*(8*s - 4) + 8*r*s - 2*r - 13*s + 6)) - 5*D1*(D1*(f*fd*(10*C - 15)*(r*(3*s - 1) - s) + f*(9*bdd1*s*(2*C + r - 3) - fdd*(14*C - 21)*(3*r*s - r - s)) - fd**2*(14*C - 21)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(21 - 14*C)*(r*(4*s - 2) - s)) - 5*Dd**2*f**2*(21 - 14*C)*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k3**2) + 2*D1**2*Pk3*Pkd1*ct**5*k2**3*(72*D1**2*b1*f*fd*r**2 - 36*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*fd**2*r**2 - 18*D1**2*bdd1*f**2*(r - 1)**2 + 30*D1**2*f**2*fd*r**2 - 20*D1**2*f**2*fd*r + 10*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 + 10*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 + 20*D1**2*f*fd**2*r + 144*D1*Dd*b1*f**2*r**2 - 72*D1*Dd*b1*f**2*r + 36*D1*Dd*b1*f**2 - 288*D1*Dd*b1*f*fd*r**2 + 72*D1*Dd*b1*f*fd*r + 40*D1*Dd*f**3*r**2 - 20*D1*Dd*f**3*r + 10*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 + 70*D1*Dd*f**2*fd*r - 10*D1*Dd*f**2*fd - 72*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r - 18*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 + 10*D1*Ddd*f**3*r - 5*D1*Ddd*f**3 + 36*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 216*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r - 60*Dd**2*f**3*r**2 + 30*Dd**2*f**3*r)/(315*d**2*k1**2*k3**2) + 4*D1**2*Pk3*Pkd1*ct**4*f*k2**6*st**2*(396*D1**2*b1*f*fd*r**2 + 396*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r - 495*D1**2*b1*f*fdd*r**2 - 495*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 990*D1**2*b1*fd**2*r**2 - 990*D1**2*b1*fd**2*r*s + 660*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 400*D1**2*f**2*fd*r**2 + 400*D1**2*f**2*fd*r*s - 400*D1**2*f**2*fd*r - 100*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s - 105*D1**2*f**2*fdd - 1260*D1**2*f*fd**2*r**2 - 1260*D1**2*f*fd**2*r*s + 1260*D1**2*f*fd**2*r + 315*D1**2*f*fd**2*s - 210*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 3960*D1*Dd*b1*f*fd*r**2 - 3960*D1*Dd*b1*f*fd*r*s + 3300*D1*Dd*b1*f*fd*r + 495*D1*Dd*b1*f*fd*s - 330*D1*Dd*b1*f*fd + 400*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 400*D1*Dd*f**3*r - 100*D1*Dd*f**3*s + 100*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s - 630*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 420*D1*Ddd*f**3*r**2 - 420*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r + 105*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1260*Dd**2*f**3*r**2 - 1260*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r + 315*Dd**2*f**3*s - 210*Dd**2*f**3)/(693*d**2*k1*k3**6) + D1**2*Pk3*Pkd1*ct**4*k1**3*k2**2*(80*C - 56)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**4*k1**3*(16*C - 10)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(5*f*(r*(2 - 4*s) + s) + 7*fd*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 2) - s)) + 7*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k3**4) + 8*D1**2*Pk3*Pkd1*ct**4*k1*k2**4*st**2*(360*C*D1**2*b1*f*fd*r**2 + 360*C*D1**2*b1*f*fd*r*s - 180*C*D1**2*b1*f*fd*r - 684*C*D1**2*b1*f*fdd*r**2 - 684*C*D1**2*b1*f*fdd*r*s + 342*C*D1**2*b1*f*fdd*r - 684*C*D1**2*b1*fd**2*r**2 - 684*C*D1**2*b1*fd**2*r*s + 342*C*D1**2*b1*fd**2*r + 492*C*D1**2*f**2*fd*r**2 + 492*C*D1**2*f**2*fd*r*s - 492*C*D1**2*f**2*fd*r - 164*C*D1**2*f**2*fd*s + 164*C*D1**2*f**2*fd - 570*C*D1**2*f**2*fdd*r**2 - 570*C*D1**2*f**2*fdd*r*s + 570*C*D1**2*f**2*fdd*r + 190*C*D1**2*f**2*fdd*s - 190*C*D1**2*f**2*fdd - 1140*C*D1**2*f*fd**2*r**2 - 1140*C*D1**2*f*fd**2*r*s + 1140*C*D1**2*f*fd**2*r + 380*C*D1**2*f*fd**2*s - 190*C*D1**2*f*fd**2 + 720*C*D1*Dd*b1*f**2*r**2 + 720*C*D1*Dd*b1*f**2*r*s - 720*C*D1*Dd*b1*f**2*r - 180*C*D1*Dd*b1*f**2*s + 180*C*D1*Dd*b1*f**2 - 5472*C*D1*Dd*b1*f*fd*r**2 - 5472*C*D1*Dd*b1*f*fd*r*s + 4104*C*D1*Dd*b1*f*fd*r + 684*C*D1*Dd*b1*f*fd*s - 342*C*D1*Dd*b1*f*fd + 656*C*D1*Dd*f**3*r**2 + 656*C*D1*Dd*f**3*r*s - 656*C*D1*Dd*f**3*r - 164*C*D1*Dd*f**3*s + 164*C*D1*Dd*f**3 - 4560*C*D1*Dd*f**2*fd*r**2 - 4560*C*D1*Dd*f**2*fd*r*s + 4560*C*D1*Dd*f**2*fd*r + 1330*C*D1*Dd*f**2*fd*s - 950*C*D1*Dd*f**2*fd - 1368*C*D1*Ddd*b1*f**2*r**2 - 1368*C*D1*Ddd*b1*f**2*r*s + 1368*C*D1*Ddd*b1*f**2*r + 342*C*D1*Ddd*b1*f**2*s - 342*C*D1*Ddd*b1*f**2 - 760*C*D1*Ddd*f**3*r**2 - 760*C*D1*Ddd*f**3*r*s + 760*C*D1*Ddd*f**3*r + 190*C*D1*Ddd*f**3*s - 190*C*D1*Ddd*f**3 - 4104*C*Dd**2*b1*f**2*r**2 - 4104*C*Dd**2*b1*f**2*r*s + 4104*C*Dd**2*b1*f**2*r + 1026*C*Dd**2*b1*f**2*s - 684*C*Dd**2*b1*f**2 - 2280*C*Dd**2*f**3*r**2 - 2280*C*Dd**2*f**3*r*s + 2280*C*Dd**2*f**3*r + 570*C*Dd**2*f**3*s - 380*C*Dd**2*f**3 - 306*D1**2*b1*f*fd*r**2 - 306*D1**2*b1*f*fd*r*s + 153*D1**2*b1*f*fd*r + 594*D1**2*b1*f*fdd*r**2 + 594*D1**2*b1*f*fdd*r*s - 297*D1**2*b1*f*fdd*r + 594*D1**2*b1*fd**2*r**2 + 594*D1**2*b1*fd**2*r*s - 297*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(38*C - 33)*(r - 1)*(r + s - 1) - 423*D1**2*f**2*fd*r**2 - 423*D1**2*f**2*fd*r*s + 423*D1**2*f**2*fd*r + 141*D1**2*f**2*fd*s - 141*D1**2*f**2*fd + 495*D1**2*f**2*fdd*r**2 + 495*D1**2*f**2*fdd*r*s - 495*D1**2*f**2*fdd*r - 165*D1**2*f**2*fdd*s + 165*D1**2*f**2*fdd + 990*D1**2*f*fd**2*r**2 + 990*D1**2*f*fd**2*r*s - 990*D1**2*f*fd**2*r - 330*D1**2*f*fd**2*s + 165*D1**2*f*fd**2 - 612*D1*Dd*b1*f**2*r**2 - 612*D1*Dd*b1*f**2*r*s + 612*D1*Dd*b1*f**2*r + 153*D1*Dd*b1*f**2*s - 153*D1*Dd*b1*f**2 + 4752*D1*Dd*b1*f*fd*r**2 + 4752*D1*Dd*b1*f*fd*r*s - 3564*D1*Dd*b1*f*fd*r - 594*D1*Dd*b1*f*fd*s + 297*D1*Dd*b1*f*fd - 564*D1*Dd*f**3*r**2 - 564*D1*Dd*f**3*r*s + 564*D1*Dd*f**3*r + 141*D1*Dd*f**3*s - 141*D1*Dd*f**3 + 3960*D1*Dd*f**2*fd*r**2 + 3960*D1*Dd*f**2*fd*r*s - 3960*D1*Dd*f**2*fd*r - 1155*D1*Dd*f**2*fd*s + 825*D1*Dd*f**2*fd + 1188*D1*Ddd*b1*f**2*r**2 + 1188*D1*Ddd*b1*f**2*r*s - 1188*D1*Ddd*b1*f**2*r - 297*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 + 660*D1*Ddd*f**3*r**2 + 660*D1*Ddd*f**3*r*s - 660*D1*Ddd*f**3*r - 165*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(f*(20*C - 17)*(r - 1)*(r + s - 1) - fd*(38*C - 33)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(38*C - 33)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 3564*Dd**2*b1*f**2*r**2 + 3564*Dd**2*b1*f**2*r*s - 3564*Dd**2*b1*f**2*r - 891*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 + 1980*Dd**2*f**3*r**2 + 1980*Dd**2*f**3*r*s - 1980*Dd**2*f**3*r - 495*Dd**2*f**3*s + 330*Dd**2*f**3)/(315*d**2*k3**6) - 4*D1**2*Pk3*Pkd1*ct**4*k1*k2**4*(-99*D1**2*bd1**2*f*(2*r - 1)*(-35*K + 20*f + 28)*(r + s - 1) + 55*D1**2*bdd1*f*(r + s - 1)*(14*f**2*(r - 3) + 9*f*r*(5*K - 4) - 126*g2*(r - 1)) - 30*D1**2*(7*f**3*(7*fd - 9*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*f**2*(21*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + r*(33*gd2 - 55*gdd2)*(r + s - 1)) - 33*f*(fd*(g2*(6*r**2 + 6*r*(s - 1) - 3*s + 3) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 165*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) - 11*D1*bd1*(D1*(50*f**3*(r - 3)*(r + s - 1) + f**2*(-70*fd*(6*r**2 + 6*r*(s - 2) - 7*s + 4) + r*(135*K - 108)*(r + s - 1)) - 15*f*(3*fd*(5*K - 4)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) + 630*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(14*f**2*(8*r**2 + 4*r*(2*s - 5) - 13*s + 10) + 9*f*(5*K - 4)*(8*r**2 + 8*r*(s - 1) - s + 1) - 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 30*D1*f*(Dd*(49*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 126*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 33*f*(3*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 330*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 3*Ddd*f*(21*f**2 - 55*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 90*Dd**2*f**2*(21*f**2 - 55*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 33*b1**2*(D1**2*r*(12*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 60*fd**2*(2*r + 2*s - 1) - 7*fd*(5*K - 4)*(r + s) + 21*fdd*(5*K - 4)*(r + s)) + D1*(Dd*(36*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-60*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (28 - 35*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(5*K - 4)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-35*K + 20*f + 28)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-35*K + 20*f + 28)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-270*D1**2*K*f*fd*r**2 - 270*D1**2*K*f*fd*r*s + 270*D1**2*K*f*fd*r + 135*D1**2*K*f*fd*s - 135*D1**2*K*f*fd + 450*D1**2*K*f*fdd*r**2 + 450*D1**2*K*f*fdd*r*s - 450*D1**2*K*f*fdd*r - 225*D1**2*K*f*fdd*s + 225*D1**2*K*f*fdd + 450*D1**2*K*fd**2*r**2 + 450*D1**2*K*fd**2*r*s - 450*D1**2*K*fd**2*r - 225*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*r - 1)*(-35*K + 20*f + 28)*(r + s - 1) - 150*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*s + 100*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r**2 + 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r**2 + 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 216*D1**2*f*fd*r**2 + 216*D1**2*f*fd*r*s - 216*D1**2*f*fd*r - 108*D1**2*f*fd*s + 108*D1**2*f*fd - 360*D1**2*f*fdd*r**2 - 360*D1**2*f*fdd*r*s + 360*D1**2*f*fdd*r + 180*D1**2*f*fdd*s - 180*D1**2*f*fdd + 210*D1**2*f*gd2*r**2 + 210*D1**2*f*gd2*r*s - 210*D1**2*f*gd2*r - 630*D1**2*f*gdd2*r**2 - 630*D1**2*f*gdd2*r*s + 630*D1**2*f*gdd2*r - 360*D1**2*fd**2*r**2 - 360*D1**2*fd**2*r*s + 360*D1**2*fd**2*r + 180*D1**2*fd**2*s + 210*D1**2*fd*g2*r**2 + 210*D1**2*fd*g2*r*s - 1260*D1**2*fd*gd2*r**2 - 1260*D1**2*fd*gd2*r*s + 630*D1**2*fd*gd2*r - 630*D1**2*fdd*g2*r**2 - 630*D1**2*fdd*g2*r*s - 540*D1*Dd*K*f**2*r**2 - 540*D1*Dd*K*f**2*r*s + 540*D1*Dd*K*f**2*r + 135*D1*Dd*K*f**2*s - 135*D1*Dd*K*f**2 + 3600*D1*Dd*K*f*fd*r**2 + 3600*D1*Dd*K*f*fd*r*s - 3600*D1*Dd*K*f*fd*r - 1350*D1*Dd*K*f*fd*s + 900*D1*Dd*K*f*fd - 200*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 200*D1*Dd*f**3*r + 50*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r**2 + 1680*D1*Dd*f**2*fd*r*s - 840*D1*Dd*f**2*fd*r + 350*D1*Dd*f**2*fd*s - 280*D1*Dd*f**2*fd + 432*D1*Dd*f**2*r**2 + 432*D1*Dd*f**2*r*s - 432*D1*Dd*f**2*r - 108*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 2880*D1*Dd*f*fd*r**2 - 2880*D1*Dd*f*fd*r*s + 2880*D1*Dd*f*fd*r + 1080*D1*Dd*f*fd*s - 720*D1*Dd*f*fd + 840*D1*Dd*f*g2*r**2 + 840*D1*Dd*f*g2*r*s - 840*D1*Dd*f*g2*r - 210*D1*Dd*f*g2*s + 210*D1*Dd*f*g2 - 5040*D1*Dd*f*gd2*r**2 - 5040*D1*Dd*f*gd2*r*s + 5040*D1*Dd*f*gd2*r + 630*D1*Dd*f*gd2*s - 630*D1*Dd*f*gd2 - 5040*D1*Dd*fd*g2*r**2 - 5040*D1*Dd*fd*g2*r*s + 2520*D1*Dd*fd*g2*r + 630*D1*Dd*fd*g2*s + 900*D1*Ddd*K*f**2*r**2 + 900*D1*Ddd*K*f**2*r*s - 900*D1*Ddd*K*f**2*r - 225*D1*Ddd*K*f**2*s + 225*D1*Ddd*K*f**2 + 280*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r - 70*D1*Ddd*f**3*s + 70*D1*Ddd*f**3 - 720*D1*Ddd*f**2*r**2 - 720*D1*Ddd*f**2*r*s + 720*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 2520*D1*Ddd*f*g2*r**2 - 2520*D1*Ddd*f*g2*r*s + 2520*D1*Ddd*f*g2*r + 630*D1*Ddd*f*g2*s - 630*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(36*f**2*(2*r - 1)*(r + s - 1) + f*(-60*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (35*K - 28)*(2*r - 1)*(r + s - 1)) + 21*fd*(5*K - 4)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-35*K + 20*f + 28)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 2700*Dd**2*K*f**2*r**2 + 2700*Dd**2*K*f**2*r*s - 2700*Dd**2*K*f**2*r - 675*Dd**2*K*f**2*s + 450*Dd**2*K*f**2 + 840*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r*s - 840*Dd**2*f**3*r - 210*Dd**2*f**3*s + 140*Dd**2*f**3 - 2160*Dd**2*f**2*r**2 - 2160*Dd**2*f**2*r*s + 2160*Dd**2*f**2*r + 540*Dd**2*f**2*s - 360*Dd**2*f**2 - 7560*Dd**2*f*g2*r**2 - 7560*Dd**2*f*g2*r*s + 7560*Dd**2*f*g2*r + 1890*Dd**2*f*g2*s - 1260*Dd**2*f*g2))/(3465*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*ct**4*k1*k2**2*st**2*(9*D1*bd1*f*(D1*(f*s*(22*C - 19)*(r - 1) - fd*(32*C - 27)*(r*(4*s - 1) - 2*s + 1)) - Dd*f*(32*C - 27)*(r*(8*s - 2) - 5*s + 2)) - 9*b1*(D1*Dd*f*(-f*(22*C - 19)*(r*(4*s - 2) - s) + fd*(32*C - 27)*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(22*C - 19) + f*fdd*(27 - 32*C) + fd**2*(27 - 32*C)) + Ddd*f**2*(32*C - 27)*(r*(4*s - 2) - s)) + Dd**2*f**2*(32*C - 27)*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(f*(158*C - 135)*(r*(4*s - 2) - s) - fd*(160*C - 135)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(f*fd*(158*C - 135)*(r*(3*s - 1) - s) - f*(32*C - 27)*(9*bdd1*s*(r - 1) + 5*fdd*r*(3*s - 1) - 5*fdd*s) - fd**2*(160*C - 135)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(135 - 160*C)*(r*(4*s - 2) - s)) + Dd**2*f**2*(135 - 160*C)*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**4*k1*k2**2*(42*D1*b1*bd1*(6*C - 5)*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 42*b1**2*(6*C - 5)*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 9*b1*(14*D1**2*bdd1*f*(6*C - 5)*(2*r**2 + 2*r*(s - 1) - s + 1) + D1**2*(f*(fd*(4*C*(30*r**2 + 116*r*s - 40*r + 9*s - 9) - 110*r**2 - 414*r*s + 147*r - 30*s + 30) + fdd*(-4*C*(78*r**2 + 128*r*s - 34*r + 15*s - 15) + 258*r**2 + 466*r*s - 133*r + 50*s - 50)) + fd**2*(-4*C*(78*r**2 + 128*r*s - 34*r + 15*s - 15) + 258*r**2 + 466*r*s - 133*r + 50*s - 50)) + D1*f*(Dd*(f*(4*C*(60*r**2 + 2*r*(116*s - 73) - 58*s + 15) - 220*r**2 + r*(524 - 828*s) + 207*s - 55) + fd*(-16*C*(156*r**2 + r*(256*s - 137) - 17*s + 1) + 2064*r**2 + 4*r*(932*s - 495) - 266*s + 33)) + Ddd*f*(-4*C*(156*r**2 + r*(256*s - 206) - 64*s + 39) + 516*r**2 + r*(932*s - 724) - 233*s + 129)) + Dd**2*f**2*(-8*C*(234*r**2 + r*(384*s - 309) - 96*s + 64) + 1548*r**2 + 12*r*(233*s - 181) - 699*s + 466)) + f*(-126*D1**2*bd1**2*(6*C - 5)*(2*r**2 + 2*r*(s - 1) - s) + 9*D1**2*bdd1*f*(4*C*(39*r**2 + 4*r*(16*s - 27) - 79*s + 54) - 129*r**2 + r*(358 - 233*s) + 283*s - 179) - 5*D1**2*(f*(fd*(12*C*(60*r**2 + 93*r*s - 71*r - 31*s + 20) - 597*r**2 - 993*r*s + 729*r + 331*s - 199) + fdd*(-84*C*(12*r**2 + 15*r*s - 13*r - 5*s + 4) + 825*r**2 + 1131*r*s - 927*r - 377*s + 275)) + fd**2*(-84*C*(24*r**2 + r*(30*s - 26) - 10*s + 5) + 1650*r**2 + 6*r*(377*s - 309) - 754*s + 377)) - 9*D1*bd1*(D1*(f*(4*C*(15*r**2 + 58*r*s - 48*r - 67*s + 24) - 55*r**2 - 207*r*s + 170*r + 237*s - 85) + fd*(-4*C*(156*r**2 + 256*r*s - 250*r - 143*s + 79) + 516*r**2 + 932*r*s - 849*r - 516*s + 283)) + Dd*f*(-8*C*(156*r**2 + r*(256*s - 319) - 190*s + 133) + 1032*r**2 + 4*r*(466*s - 539) - 1365*s + 924)) - 5*D1*f*(Dd*(f*(12*C*(80*r**2 + 2*r*(62*s - 51) - 31*s + 20) - 796*r**2 - 1324*r*s + 1060*r + 331*s - 199) + fd*(-84*C*(96*r**2 + 2*r*(60*s - 53) - 35*s + 23) + 6600*r**2 + 9048*r*s - 7620*r - 2639*s + 1681)) + Ddd*f*(-84*C*(16*r**2 + 2*r*(10*s - 9) - 5*s + 4) + 1100*r**2 + 4*r*(377*s - 326) - 377*s + 275)) - 5*Dd**2*f**2*(-84*C*(48*r**2 + 6*r*(10*s - 9) - 15*s + 10) + 3300*r**2 + 12*r*(377*s - 326) - 1131*s + 754)))/(315*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**4*k1*(8*C - 6)*(3*D1*b1*(3*D1*(-3*f*fd*s + f*s*(bdd1*(7 - 14*r) + 5*fdd) + 5*fd**2*(s - 1)) + 30*Dd*f*fd*(2*s - 1) - 7*bd1*(D1*(f*s*(1 - 2*r) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1))) - 21*b1**2*(D1*Dd*(f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + f*(-63*D1**2*bd1**2*s*(2*r - 1) - 5*D1*Dd*f*(5*f*(4*r*s - 2*r - s) - 7*fd*(24*r*s - 10*r - 7*s + 3)) + 9*D1*bd1*(3*D1*f*s - 5*D1*fd*(s - 1) + 10*Dd*f*(1 - 2*s)) - 5*D1*(D1*(5*f*fd*(r*(3*s - 1) - s) + f*(9*bdd1*s + 7*fdd*(-3*r*s + r + s)) - 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(2 - 4*s) + s)) + 35*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k3**2) - 4*D1**2*Pk3*Pkd1*ct**4*k2**4*st**2*(90*C*D1**2*b1*f*fd*r**2 - 108*C*D1**2*b1*f*fdd*r**2 - 108*C*D1**2*b1*fd**2*r**2 + 219*C*D1**2*f**2*fd*r**2 - 146*C*D1**2*f**2*fd*r + 73*C*D1**2*f**2*fd - 150*C*D1**2*f**2*fdd*r**2 + 100*C*D1**2*f**2*fdd*r - 50*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*r**2 + 200*C*D1**2*f*fd**2*r + 180*C*D1*Dd*b1*f**2*r**2 - 90*C*D1*Dd*b1*f**2*r + 45*C*D1*Dd*b1*f**2 - 864*C*D1*Dd*b1*f*fd*r**2 + 216*C*D1*Dd*b1*f*fd*r + 292*C*D1*Dd*f**3*r**2 - 146*C*D1*Dd*f**3*r + 73*C*D1*Dd*f**3 - 1200*C*D1*Dd*f**2*fd*r**2 + 700*C*D1*Dd*f**2*fd*r - 100*C*D1*Dd*f**2*fd - 216*C*D1*Ddd*b1*f**2*r**2 + 108*C*D1*Ddd*b1*f**2*r - 54*C*D1*Ddd*b1*f**2 - 200*C*D1*Ddd*f**3*r**2 + 100*C*D1*Ddd*f**3*r - 50*C*D1*Ddd*f**3 - 648*C*Dd**2*b1*f**2*r**2 + 324*C*Dd**2*b1*f**2*r - 600*C*Dd**2*f**3*r**2 + 300*C*Dd**2*f**3*r - 144*D1**2*b1*f*fd*r**2 - 54*D1**2*b1*f*fd*r*s + 27*D1**2*b1*f*fd*r + 198*D1**2*b1*f*fdd*r**2 + 90*D1**2*b1*f*fdd*r*s - 45*D1**2*b1*f*fdd*r + 198*D1**2*b1*fd**2*r**2 + 90*D1**2*b1*fd**2*r*s - 45*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(r - 1)*(6*C*(r - 1) - 11*r - 5*s + 11) - 288*D1**2*f**2*fd*r**2 - 69*D1**2*f**2*fd*r*s + 215*D1**2*f**2*fd*r + 23*D1**2*f**2*fd*s - 96*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 75*D1**2*f**2*fdd*r*s - 175*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd*s + 75*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 150*D1**2*f*fd**2*r*s - 350*D1**2*f*fd**2*r - 50*D1**2*f*fd**2*s + 25*D1**2*f*fd**2 - 288*D1*Dd*b1*f**2*r**2 - 108*D1*Dd*b1*f**2*r*s + 198*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2*s - 72*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 720*D1*Dd*b1*f*fd*r*s - 756*D1*Dd*b1*f*fd*r - 90*D1*Dd*b1*f*fd*s + 45*D1*Dd*b1*f*fd - 384*D1*Dd*f**3*r**2 - 92*D1*Dd*f**3*r*s + 238*D1*Dd*f**3*r + 23*D1*Dd*f**3*s - 96*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 600*D1*Dd*f**2*fd*r*s - 1300*D1*Dd*f**2*fd*r - 175*D1*Dd*f**2*fd*s + 225*D1*Dd*f**2*fd + 396*D1*Ddd*b1*f**2*r**2 + 180*D1*Ddd*b1*f**2*r*s - 288*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2*s + 99*D1*Ddd*b1*f**2 + 300*D1*Ddd*f**3*r**2 + 100*D1*Ddd*f**3*r*s - 200*D1*Ddd*f**3*r - 25*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(f*(r - 1)*(5*C*(r - 1) - 8*r - 3*s + 8) + fd*(r**2*(44 - 24*C) + r*(24*C + 20*s - 49) - 10*s + 5)) + Dd*f*(-12*C*(4*r**2 - 5*r + 1) + 88*r**2 + 40*r*(s - 3) - 25*s + 32)) + 1188*Dd**2*b1*f**2*r**2 + 540*Dd**2*b1*f**2*r*s - 864*Dd**2*b1*f**2*r - 135*Dd**2*b1*f**2*s + 90*Dd**2*b1*f**2 + 900*Dd**2*f**3*r**2 + 300*Dd**2*f**3*r*s - 600*Dd**2*f**3*r - 75*Dd**2*f**3*s + 50*Dd**2*f**3)/(315*d**2*k1*k3**4) + D1**2*Pk3*Pkd1*ct**4*k2**4*(495*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*bd1**2*f*(3*f*(21*r**2 + r*(20*s - 26) - 10*s + 5) - 7*r**2*(K - 7) + 7*r*(K + 6*s - 10) - 21*s + 21) - 990*D1**2*bdd1*f**3*r**2 + 935*D1**2*bdd1*f**3*r*s - 880*D1**2*bdd1*f**3*r - 2475*D1**2*bdd1*f**3*s + 825*D1**2*bdd1*f**3 - 1485*D1**2*bdd1*f**2*r**2 - 990*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*r - 462*D1**2*bdd1*f*g2*r**2 + 924*D1**2*bdd1*f*g2*r - 462*D1**2*bdd1*f*g2 - 2940*D1**2*f**3*fd*r**2 - 7700*D1**2*f**3*fd*r*s + 5320*D1**2*f**3*fd*r + 1925*D1**2*f**3*fd*s - 735*D1**2*f**3*fd + 3780*D1**2*f**3*fdd*r**2 + 7700*D1**2*f**3*fdd*r*s - 5740*D1**2*f**3*fdd*r - 1925*D1**2*f**3*fdd*s + 945*D1**2*f**3*fdd + 11340*D1**2*f**2*fd**2*r**2 + 23100*D1**2*f**2*fd**2*r*s - 17220*D1**2*f**2*fd**2*r - 5775*D1**2*f**2*fd**2*s + 3850*D1**2*f**2*fd**2 + 594*D1**2*f**2*gd2*r**2 - 990*D1**2*f**2*gdd2*r**2 + 1188*D1**2*f*fd*g2*r**2 - 1188*D1**2*f*fd*g2*r + 594*D1**2*f*fd*g2 - 3960*D1**2*f*fd*gd2*r**2 + 1980*D1**2*f*fd*gd2*r - 1980*D1**2*f*fdd*g2*r**2 + 1980*D1**2*f*fdd*g2*r - 990*D1**2*f*fdd*g2 - 1980*D1**2*fd**2*g2*r**2 + 1980*D1**2*fd**2*g2*r - 2940*D1*Dd*f**4*r**2 - 7700*D1*Dd*f**4*r*s + 5320*D1*Dd*f**4*r + 1925*D1*Dd*f**4*s - 735*D1*Dd*f**4 + 30240*D1*Dd*f**3*fd*r**2 + 61600*D1*Dd*f**3*fd*r*s - 45920*D1*Dd*f**3*fd*r - 15400*D1*Dd*f**3*fd*s + 9590*D1*Dd*f**3*fd + 2376*D1*Dd*f**2*g2*r**2 - 1188*D1*Dd*f**2*g2*r + 594*D1*Dd*f**2*g2 - 7920*D1*Dd*f**2*gd2*r**2 + 1980*D1*Dd*f**2*gd2*r - 15840*D1*Dd*f*fd*g2*r**2 + 11880*D1*Dd*f*fd*g2*r - 1980*D1*Dd*f*fd*g2 + 3780*D1*Ddd*f**4*r**2 + 7700*D1*Ddd*f**4*r*s - 5740*D1*Ddd*f**4*r - 1925*D1*Ddd*f**4*s + 945*D1*Ddd*f**4 - 3960*D1*Ddd*f**2*g2*r**2 + 1980*D1*Ddd*f**2*g2*r - 990*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(5*f**3*(18*r**2 - r*(25*s + 4) + 45*s - 3) + f**2*(-5*fd*(108*r**2 - 6*r*(17*s - 5) + 107*s - 76) - 27*r*(r*(K - 3) - 2*s + 2)) + 6*f*(15*fd*(r**2*(2*K - 6) - r*(K + 4*s - 5) + s - 1) + (7 - 7*r)*(3*g2*(r - 1) + 2*gd2*r)) - 84*fd*g2*r*(r - 1)) - Dd*f*(5*f**2*(144*r**2 + r*(62 - 136*s) + 197*s - 106) - 90*f*(r**2*(4*K - 12) - r*(K + 8*s - 9) + s - 1) + 84*g2*(4*r**2 - 5*r + 1))) + 11340*Dd**2*f**4*r**2 + 23100*Dd**2*f**4*r*s - 17220*Dd**2*f**4*r - 5775*Dd**2*f**4*s + 3850*Dd**2*f**4 - 11880*Dd**2*f**2*g2*r**2 + 5940*Dd**2*f**2*g2*r + 33*b1**2*(D1**2*r*(6*f*(fd*(7*r + 12*s - 9) + fdd*(-21*r - 20*s + 15)) - 6*fd**2*(21*r + 20*s - 15) + 7*fd*(r*(3*K - 1) + 2*s) + 7*fdd*(r*(K - 7) - 6*s)) + D1*(Dd*(3*f**2*(28*r**2 + r*(48*s - 38) - 12*s + 7) - 6*f*fd*(168*r**2 + 2*r*(80*s - 71) - 20*s + 15) + 7*f*(3*K*(4*r**2 - 2*r + 1) - 4*r**2 + 8*r*s - 2*r - 2*s - 1) + 14*fd*(r**2*(4*K - 28) - r*(K + 24*s - 13) + 3*s)) + Ddd*f*(28*K*r**2 - 14*K*r + 7*K - 3*f*(84*r**2 + 80*r*s - 82*r - 20*s + 21) - 196*r**2 - 168*r*s + 182*r + 42*s - 49)) - 6*Dd**2*f*(f*(126*r**2 + 3*r*(40*s - 41) - 30*s + 20) - 7*r**2*(2*K - 14) + 7*r*(K + 12*s - 13) - 21*s + 14)) + 11*b1*(-54*D1**2*K*f*fd*r**2 + 54*D1**2*K*f*fd*r - 27*D1**2*K*f*fd + 90*D1**2*K*f*fdd*r**2 - 90*D1**2*K*f*fdd*r + 45*D1**2*K*f*fdd + 90*D1**2*K*fd**2*r**2 - 90*D1**2*K*fd**2*r - 3*D1**2*bdd1*f*(-14*K*r**2 + 14*K*r - 7*K + 3*f*(42*r**2 + 40*r*s - 52*r - 20*s + 21) + 98*r**2 + 84*r*s - 140*r - 42*s + 49) + 270*D1**2*f**2*fd*r**2 - 375*D1**2*f**2*fd*r*s + 90*D1**2*f**2*fd*r - 100*D1**2*f**2*fd*s + 105*D1**2*f**2*fd - 270*D1**2*f**2*fdd*r**2 + 255*D1**2*f**2*fdd*r*s + 90*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 165*D1**2*f**2*fdd - 540*D1**2*f*fd**2*r**2 + 510*D1**2*f*fd**2*r*s + 180*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 210*D1**2*f*fd**2 + 162*D1**2*f*fd*r**2 + 108*D1**2*f*fd*r*s - 162*D1**2*f*fd*r - 54*D1**2*f*fd*s + 81*D1**2*f*fd - 270*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 270*D1**2*f*fdd*r + 90*D1**2*f*fdd*s - 135*D1**2*f*fdd - 126*D1**2*f*gd2*r**2 - 42*D1**2*f*gdd2*r**2 - 270*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 270*D1**2*fd**2*r + 90*D1**2*fd**2*s - 126*D1**2*fd*g2*r**2 - 84*D1**2*fd*gd2*r**2 - 42*D1**2*fdd*g2*r**2 - 108*D1*Dd*K*f**2*r**2 + 54*D1*Dd*K*f**2*r - 27*D1*Dd*K*f**2 + 720*D1*Dd*K*f*fd*r**2 - 540*D1*Dd*K*f*fd*r + 90*D1*Dd*K*f*fd + 360*D1*Dd*f**3*r**2 - 500*D1*Dd*f**3*r*s + 70*D1*Dd*f**3*r + 125*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 2160*D1*Dd*f**2*fd*r**2 + 2040*D1*Dd*f**2*fd*r*s + 390*D1*Dd*f**2*fd*r + 305*D1*Dd*f**2*fd*s - 370*D1*Dd*f**2*fd + 324*D1*Dd*f**2*r**2 + 216*D1*Dd*f**2*r*s - 270*D1*Dd*f**2*r - 54*D1*Dd*f**2*s + 81*D1*Dd*f**2 - 2160*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 1980*D1*Dd*f*fd*r + 540*D1*Dd*f*fd*s - 450*D1*Dd*f*fd - 504*D1*Dd*f*g2*r**2 + 252*D1*Dd*f*g2*r - 126*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r**2 + 84*D1*Dd*f*gd2*r - 336*D1*Dd*fd*g2*r**2 + 84*D1*Dd*fd*g2*r + 180*D1*Ddd*K*f**2*r**2 - 90*D1*Ddd*K*f**2*r + 45*D1*Ddd*K*f**2 - 360*D1*Ddd*f**3*r**2 + 340*D1*Ddd*f**3*r*s + 10*D1*Ddd*f**3*r - 85*D1*Ddd*f**3*s - 90*D1*Ddd*f**3 - 540*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 450*D1*Ddd*f**2*r + 90*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r**2 + 84*D1*Ddd*f*g2*r - 42*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(3*f**2*(14*r**2 + 4*r*(6*s - 5) - 12*s + 7) - 6*f*fd*(84*r**2 + r*(80*s - 82) - 20*s + 15) + 7*f*(K*(6*r**2 - 6*r + 3) - 2*r**2 + 4*r*s - 2*s - 1) + 14*fd*(r**2*(2*K - 14) - r*(K + 12*s - 10) + 3*s)) - 2*Dd*f*(-56*K*r**2 + 42*K*r - 7*K + 6*f*(84*r**2 + 80*r*s - 93*r - 30*s + 23) + 392*r**2 + 336*r*s - 462*r - 126*s + 112)) + 540*Dd**2*K*f**2*r**2 - 270*Dd**2*K*f**2*r - 1080*Dd**2*f**3*r**2 + 1020*Dd**2*f**3*r*s + 30*Dd**2*f**3*r - 255*Dd**2*f**3*s + 170*Dd**2*f**3 - 1620*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 1350*Dd**2*f**2*r + 270*Dd**2*f**2*s - 180*Dd**2*f**2 - 504*Dd**2*f*g2*r**2 + 252*Dd**2*f*g2*r))/(3465*d**2*k1*k3**4) + 4*D1**2*Pk3*Pkd1*ct**4*k2**2*st**2*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(23*f*(4*r*s - 2*r - s) - 25*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(23*f*fd*(r*(3*s - 1) - s) + 5*f*(-9*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(r*(2 - 4*s) + s)) - 25*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k1*k3**2) + D1**2*Pk3*Pkd1*ct**4*k2**2*(42*b1**2*(C - 1)*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + 3*b1*(14*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 3*D1**2*(f*(fd*(2*C*(16*r**2 - 6*r + 3) - 26*r**2 + 62*r*s - 19*r - 6) + fdd*(-2*C*(8*r**2 - 10*r + 5) + 6*r**2 - 66*r*s + 13*r + 10)) + fd**2*r*(-4*C*(4*r - 5) + 6*r - 66*s + 13)) + 14*D1*bd1*(C - 1)*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) - 3*D1*f*(-8*C*Ddd*f*(4*r**2 - 2*r + 1) + Dd*f*(16*C*(4*r**2 - 2*r + 1) - 52*r**2 + 4*r*(31*s - 9) - 31*s - 13) + Dd*fd*(-4*C*(32*r**2 - 28*r + 5) + 48*r**2 + r*(172 - 528*s) + 66*s - 13) + 3*Ddd*f*(4*r**2 + r*(20 - 44*s) + 11*s + 1)) - 9*Dd**2*f**2*(-r**2*(32*C - 12) + 4*r*(4*C - 33*s + 15) + 33*s - 22)) + f*(84*D1**2*bd1**2*r*(C - 1)*(r - 1) + 9*D1**2*bdd1*f*(C*(8*r**2 + 4*r - 2) - 3*r**2 + r*(33*s - 14) - 33*s + 7) + 5*D1**2*(f*(fd*(C*(6*r**2 - 4*r + 2) - 33*r**2 - 123*r*s + 63*r + 41*s - 11) + fdd*(-10*C*(3*r**2 - 2*r + 1) + 57*r**2 + 129*r*s - 81*r - 43*s + 19)) + fd**2*(r**2*(114 - 60*C) + 2*r*(20*C + 129*s - 81) - 86*s + 43)) - 9*D1*bd1*(D1*(f*(2*C*(8*r**2 - 10*r + 5) - 13*r**2 + 31*r*s + 14*r - 31*s - 7) + fd*(-r**2*(32*C - 12) + r*(12*C - 132*s + 41) + 66*s - 33)) + Dd*f*(C*(4 - 64*r**2) + 24*r**2 - 264*r*s + 116*r + 165*s - 80)) + 5*D1*f*(Dd*(f*(C*(8*r**2 - 4*r + 2) - 44*r**2 - 4*r*(41*s - 26) + 41*s - 11) + fd*(-20*C*(12*r**2 - 7*r + 1) + 456*r**2 + 24*r*(43*s - 29) - 301*s + 167)) + Ddd*f*(-10*C*(4*r**2 - 2*r + 1) + 76*r**2 + 4*r*(43*s - 31) - 43*s + 19)) + 5*Dd**2*f**2*(r**2*(228 - 120*C) + 12*r*(5*C + 43*s - 31) - 129*s + 86)))/(315*d**2*k1*k3**2) + 2*D1**2*Pk3*Pkd1*ct**4*(3*D1*f*(7*D1*bd1**2*s*(1 - 2*r) + D1*bd1*(3*f*r*s + 5*fd*(-4*r*s + r + s)) - 5*D1*bdd1*f*r*s + 5*Dd*bd1*f*(r*(2 - 8*s) + s)) - 7*b1**2*(D1*Dd*(f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(-3*D1*Dd*f*(3*f*(r*(2 - 4*s) + s) + 5*fd*(8*r - 3)*(2*s - 1)) + 7*D1*bd1*(D1*(f*s*(2*r - 1) + 3*fd*(-4*r*s + 2*r + s - 1)) - 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) - 3*D1*(D1*(3*f*fd*(-2*r*s + r + s) + f*(7*bdd1*s*(2*r - 1) + 5*fdd*r*(2*s - 1) - 5*fdd*s) + 5*fd**2*(r*(2*s - 1) - s + 1)) + 5*Ddd*f**2*(r*(4*s - 2) - s)) - 15*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k1) - 2*D1**2*Pk3*Pkd1*ct**3*f*k2**5*st**2*(66*D1**2*b1*f*fd*r**2 - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 11*D1**2*bdd1*f**2*(r - 1)**2 + 280*D1**2*f**2*fd*r**2 - 140*D1**2*f**2*fd*r + 70*D1**2*f**2*fd - 140*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 + 210*D1**2*f*fd**2*r + 88*D1*Dd*b1*f**2*r**2 - 44*D1*Dd*b1*f**2*r + 22*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 + 66*D1*Dd*b1*f*fd*r + 280*D1*Dd*f**3*r**2 - 140*D1*Dd*f**3*r + 70*D1*Dd*f**3 - 1120*D1*Dd*f**2*fd*r**2 + 560*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 + 22*D1*Ddd*b1*f**2*r - 11*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 22*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 132*Dd**2*b1*f**2*r**2 + 66*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(693*d**2*k1**2*k3**4) + D1**2*Pk3*Pkd1*ct**3*k1**4*k2*(40*C - 24)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**3*k1**4*(4*C - 2)*(9*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 9*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(5*f*(r*(2 - 4*s) + s) + 7*fd*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(9*bdd1*s*(r - 1) + 7*fdd*r*(3*s - 1) - 7*fdd*s) + 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(4*s - 2) - s)) + 7*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k2*k3**4) + 8*D1**2*Pk3*Pkd1*ct**3*k1**2*k2**3*st**2*(426*C*D1**2*b1*f*fd*r**2 + 426*C*D1**2*b1*f*fd*r*s - 213*C*D1**2*b1*f*fd*r - 990*C*D1**2*b1*f*fdd*r**2 - 990*C*D1**2*b1*f*fdd*r*s + 495*C*D1**2*b1*f*fdd*r - 990*C*D1**2*b1*fd**2*r**2 - 990*C*D1**2*b1*fd**2*r*s + 495*C*D1**2*b1*fd**2*r + 651*C*D1**2*f**2*fd*r**2 + 651*C*D1**2*f**2*fd*r*s - 651*C*D1**2*f**2*fd*r - 217*C*D1**2*f**2*fd*s + 217*C*D1**2*f**2*fd - 825*C*D1**2*f**2*fdd*r**2 - 825*C*D1**2*f**2*fdd*r*s + 825*C*D1**2*f**2*fdd*r + 275*C*D1**2*f**2*fdd*s - 275*C*D1**2*f**2*fdd - 1650*C*D1**2*f*fd**2*r**2 - 1650*C*D1**2*f*fd**2*r*s + 1650*C*D1**2*f*fd**2*r + 550*C*D1**2*f*fd**2*s - 275*C*D1**2*f*fd**2 + 852*C*D1*Dd*b1*f**2*r**2 + 852*C*D1*Dd*b1*f**2*r*s - 852*C*D1*Dd*b1*f**2*r - 213*C*D1*Dd*b1*f**2*s + 213*C*D1*Dd*b1*f**2 - 7920*C*D1*Dd*b1*f*fd*r**2 - 7920*C*D1*Dd*b1*f*fd*r*s + 5940*C*D1*Dd*b1*f*fd*r + 990*C*D1*Dd*b1*f*fd*s - 495*C*D1*Dd*b1*f*fd + 868*C*D1*Dd*f**3*r**2 + 868*C*D1*Dd*f**3*r*s - 868*C*D1*Dd*f**3*r - 217*C*D1*Dd*f**3*s + 217*C*D1*Dd*f**3 - 6600*C*D1*Dd*f**2*fd*r**2 - 6600*C*D1*Dd*f**2*fd*r*s + 6600*C*D1*Dd*f**2*fd*r + 1925*C*D1*Dd*f**2*fd*s - 1375*C*D1*Dd*f**2*fd - 1980*C*D1*Ddd*b1*f**2*r**2 - 1980*C*D1*Ddd*b1*f**2*r*s + 1980*C*D1*Ddd*b1*f**2*r + 495*C*D1*Ddd*b1*f**2*s - 495*C*D1*Ddd*b1*f**2 - 1100*C*D1*Ddd*f**3*r**2 - 1100*C*D1*Ddd*f**3*r*s + 1100*C*D1*Ddd*f**3*r + 275*C*D1*Ddd*f**3*s - 275*C*D1*Ddd*f**3 - 5940*C*Dd**2*b1*f**2*r**2 - 5940*C*Dd**2*b1*f**2*r*s + 5940*C*Dd**2*b1*f**2*r + 1485*C*Dd**2*b1*f**2*s - 990*C*Dd**2*b1*f**2 - 3300*C*Dd**2*f**3*r**2 - 3300*C*Dd**2*f**3*r*s + 3300*C*Dd**2*f**3*r + 825*C*Dd**2*f**3*s - 550*C*Dd**2*f**3 - 300*D1**2*b1*f*fd*r**2 - 300*D1**2*b1*f*fd*r*s + 150*D1**2*b1*f*fd*r + 738*D1**2*b1*f*fdd*r**2 + 738*D1**2*b1*f*fdd*r*s - 369*D1**2*b1*f*fdd*r + 738*D1**2*b1*fd**2*r**2 + 738*D1**2*b1*fd**2*r*s - 369*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(55*C - 41)*(r - 1)*(r + s - 1) - 474*D1**2*f**2*fd*r**2 - 474*D1**2*f**2*fd*r*s + 474*D1**2*f**2*fd*r + 158*D1**2*f**2*fd*s - 158*D1**2*f**2*fd + 615*D1**2*f**2*fdd*r**2 + 615*D1**2*f**2*fdd*r*s - 615*D1**2*f**2*fdd*r - 205*D1**2*f**2*fdd*s + 205*D1**2*f**2*fdd + 1230*D1**2*f*fd**2*r**2 + 1230*D1**2*f*fd**2*r*s - 1230*D1**2*f*fd**2*r - 410*D1**2*f*fd**2*s + 205*D1**2*f*fd**2 - 600*D1*Dd*b1*f**2*r**2 - 600*D1*Dd*b1*f**2*r*s + 600*D1*Dd*b1*f**2*r + 150*D1*Dd*b1*f**2*s - 150*D1*Dd*b1*f**2 + 5904*D1*Dd*b1*f*fd*r**2 + 5904*D1*Dd*b1*f*fd*r*s - 4428*D1*Dd*b1*f*fd*r - 738*D1*Dd*b1*f*fd*s + 369*D1*Dd*b1*f*fd - 632*D1*Dd*f**3*r**2 - 632*D1*Dd*f**3*r*s + 632*D1*Dd*f**3*r + 158*D1*Dd*f**3*s - 158*D1*Dd*f**3 + 4920*D1*Dd*f**2*fd*r**2 + 4920*D1*Dd*f**2*fd*r*s - 4920*D1*Dd*f**2*fd*r - 1435*D1*Dd*f**2*fd*s + 1025*D1*Dd*f**2*fd + 1476*D1*Ddd*b1*f**2*r**2 + 1476*D1*Ddd*b1*f**2*r*s - 1476*D1*Ddd*b1*f**2*r - 369*D1*Ddd*b1*f**2*s + 369*D1*Ddd*b1*f**2 + 820*D1*Ddd*f**3*r**2 + 820*D1*Ddd*f**3*r*s - 820*D1*Ddd*f**3*r - 205*D1*Ddd*f**3*s + 205*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(71*C - 50)*(r - 1)*(r + s - 1) - fd*(165*C - 123)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(123 - 165*C)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 4428*Dd**2*b1*f**2*r**2 + 4428*Dd**2*b1*f**2*r*s - 4428*Dd**2*b1*f**2*r - 1107*Dd**2*b1*f**2*s + 738*Dd**2*b1*f**2 + 2460*Dd**2*f**3*r**2 + 2460*Dd**2*f**3*r*s - 2460*Dd**2*f**3*r - 615*Dd**2*f**3*s + 410*Dd**2*f**3)/(315*d**2*k3**6) - 8*D1**2*Pk3*Pkd1*ct**3*k1**2*k2**3*(-99*D1**2*bd1**2*f*(2*r - 1)*(-35*K + 15*f + 21)*(r + s - 1) - 55*D1**2*bdd1*f*(r + s - 1)*(7*f**2*(r + 2) - 9*f*r*(5*K - 3) + 126*g2*(r - 1)) - 10*D1**2*(7*f**3*(7*fd - 9*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 9*f**2*(7*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + r*(33*gd2 - 55*gdd2)*(r + s - 1)) - 99*f*(fd*(g2*(6*r**2 + 6*r*(s - 1) - 3*s + 3) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 495*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) + 11*D1*bd1*(D1*(25*f**3*(r + 2)*(r + s - 1) + f**2*(-35*fd*(6*r**2 + r*(6*s - 2) + 3*s - 1) + r*(81 - 135*K)*(r + s - 1)) + 15*f*(3*fd*(5*K - 3)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) - 630*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(7*f**2*(8*r**2 + 8*r*s + 7*s - 5) - 9*f*(5*K - 3)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 10*D1*f*(Dd*(49*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 126*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 99*f*(3*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 990*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 9*Ddd*f*(7*f**2 - 55*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 90*Dd**2*f**2*(7*f**2 - 55*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 33*b1**2*(D1**2*r*(9*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 45*fd**2*(2*r + 2*s - 1) - 7*fd*(5*K - 3)*(r + s) + 21*fdd*(5*K - 3)*(r + s)) + D1*(Dd*(27*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-45*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (21 - 35*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(5*K - 3)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-35*K + 15*f + 21)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-35*K + 15*f + 21)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-270*D1**2*K*f*fd*r**2 - 270*D1**2*K*f*fd*r*s + 270*D1**2*K*f*fd*r + 135*D1**2*K*f*fd*s - 135*D1**2*K*f*fd + 450*D1**2*K*f*fdd*r**2 + 450*D1**2*K*f*fdd*r*s - 450*D1**2*K*f*fdd*r - 225*D1**2*K*f*fdd*s + 225*D1**2*K*f*fdd + 450*D1**2*K*fd**2*r**2 + 450*D1**2*K*fd**2*r*s - 450*D1**2*K*fd**2*r - 225*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*r - 1)*(-35*K + 15*f + 21)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 125*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s + 75*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 175*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s - 105*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 350*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s - 105*D1**2*f*fd**2 + 162*D1**2*f*fd*r**2 + 162*D1**2*f*fd*r*s - 162*D1**2*f*fd*r - 81*D1**2*f*fd*s + 81*D1**2*f*fd - 270*D1**2*f*fdd*r**2 - 270*D1**2*f*fdd*r*s + 270*D1**2*f*fdd*r + 135*D1**2*f*fdd*s - 135*D1**2*f*fdd + 210*D1**2*f*gd2*r**2 + 210*D1**2*f*gd2*r*s - 210*D1**2*f*gd2*r - 630*D1**2*f*gdd2*r**2 - 630*D1**2*f*gdd2*r*s + 630*D1**2*f*gdd2*r - 270*D1**2*fd**2*r**2 - 270*D1**2*fd**2*r*s + 270*D1**2*fd**2*r + 135*D1**2*fd**2*s + 210*D1**2*fd*g2*r**2 + 210*D1**2*fd*g2*r*s - 1260*D1**2*fd*gd2*r**2 - 1260*D1**2*fd*gd2*r*s + 630*D1**2*fd*gd2*r - 630*D1**2*fdd*g2*r**2 - 630*D1**2*fdd*g2*r*s - 540*D1*Dd*K*f**2*r**2 - 540*D1*Dd*K*f**2*r*s + 540*D1*Dd*K*f**2*r + 135*D1*Dd*K*f**2*s - 135*D1*Dd*K*f**2 + 3600*D1*Dd*K*f*fd*r**2 + 3600*D1*Dd*K*f*fd*r*s - 3600*D1*Dd*K*f*fd*r - 1350*D1*Dd*K*f*fd*s + 900*D1*Dd*K*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 1120*D1*Dd*f**2*fd*r + 525*D1*Dd*f**2*fd*s - 385*D1*Dd*f**2*fd + 324*D1*Dd*f**2*r**2 + 324*D1*Dd*f**2*r*s - 324*D1*Dd*f**2*r - 81*D1*Dd*f**2*s + 81*D1*Dd*f**2 - 2160*D1*Dd*f*fd*r**2 - 2160*D1*Dd*f*fd*r*s + 2160*D1*Dd*f*fd*r + 810*D1*Dd*f*fd*s - 540*D1*Dd*f*fd + 840*D1*Dd*f*g2*r**2 + 840*D1*Dd*f*g2*r*s - 840*D1*Dd*f*g2*r - 210*D1*Dd*f*g2*s + 210*D1*Dd*f*g2 - 5040*D1*Dd*f*gd2*r**2 - 5040*D1*Dd*f*gd2*r*s + 5040*D1*Dd*f*gd2*r + 630*D1*Dd*f*gd2*s - 630*D1*Dd*f*gd2 - 5040*D1*Dd*fd*g2*r**2 - 5040*D1*Dd*fd*g2*r*s + 2520*D1*Dd*fd*g2*r + 630*D1*Dd*fd*g2*s + 900*D1*Ddd*K*f**2*r**2 + 900*D1*Ddd*K*f**2*r*s - 900*D1*Ddd*K*f**2*r - 225*D1*Ddd*K*f**2*s + 225*D1*Ddd*K*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 540*D1*Ddd*f**2*r**2 - 540*D1*Ddd*f**2*r*s + 540*D1*Ddd*f**2*r + 135*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 2520*D1*Ddd*f*g2*r**2 - 2520*D1*Ddd*f*g2*r*s + 2520*D1*Ddd*f*g2*r + 630*D1*Ddd*f*g2*s - 630*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(27*f**2*(2*r - 1)*(r + s - 1) + f*(-45*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (35*K - 21)*(2*r - 1)*(r + s - 1)) + 21*fd*(5*K - 3)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-35*K + 15*f + 21)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 2700*Dd**2*K*f**2*r**2 + 2700*Dd**2*K*f**2*r*s - 2700*Dd**2*K*f**2*r - 675*Dd**2*K*f**2*s + 450*Dd**2*K*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3 - 1620*Dd**2*f**2*r**2 - 1620*Dd**2*f**2*r*s + 1620*Dd**2*f**2*r + 405*Dd**2*f**2*s - 270*Dd**2*f**2 - 7560*Dd**2*f*g2*r**2 - 7560*Dd**2*f*g2*r*s + 7560*Dd**2*f*g2*r + 1890*Dd**2*f*g2*s - 1260*Dd**2*f*g2))/(3465*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*ct**3*k1**2*k2*st**2*(3*D1*bd1*f*(D1*(f*s*(89*C - 65)*(r - 1) - fd*(111*C - 78)*(r*(4*s - 1) - 2*s + 1)) + Dd*f*(78 - 111*C)*(r*(8*s - 2) - 5*s + 2)) - 3*b1*(D1*Dd*f*(-f*(89*C - 65)*(r*(4*s - 2) - s) + fd*(111*C - 78)*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(89*C - 65) + f*fdd*(78 - 111*C) + fd**2*(78 - 111*C)) + Ddd*f**2*(111*C - 78)*(r*(4*s - 2) - s)) + Dd**2*f**2*(111*C - 78)*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(f*(199*C - 143)*(r*(4*s - 2) - s) - fd*(185*C - 130)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(f*fd*(199*C - 143)*(r*(3*s - 1) - s) - f*(37*C - 26)*(9*bdd1*s*(r - 1) + 5*fdd*r*(3*s - 1) - 5*fdd*s) - fd**2*(185*C - 130)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(130 - 185*C)*(r*(4*s - 2) - s)) + Dd**2*f**2*(130 - 185*C)*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k3**4) + 2*D1**2*Pk3*Pkd1*ct**3*k1**2*k2*(42*b1**2*(3*C - 2)*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 6*b1*(-21*D1**2*bdd1*f*(3*C - 2)*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*D1**2*(f*(fd*(C*(40*r**2 + 144*r*s - 54*r + 9*s - 9) - 26*r**2 - 106*r*s + 41*r - 6*s + 6) + fdd*(C*(-76*r**2 - 156*r*s + 48*r - 15*s + 15) + 48*r**2 + 116*r*s - 38*r + 10*s - 10)) + fd**2*(C*(-76*r**2 - 156*r*s + 48*r - 15*s + 15) + 48*r**2 + 116*r*s - 38*r + 10*s - 10)) + 7*D1*bd1*(3*C - 2)*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 3*D1*f*(Dd*(f*(4*C*(20*r**2 + 72*r*s - 46*r - 18*s + 5) - 52*r**2 - 212*r*s + 132*r + 53*s - 13) + 2*fd*(C*(-304*r**2 - 624*r*s + 328*r + 48*s - 9) + 192*r**2 + 464*r*s - 240*r - 38*s + 9)) + 2*Ddd*f*(C*(-76*r**2 - 156*r*s + 116*r + 39*s - 19) + 48*r**2 + 116*r*s - 82*r - 29*s + 12)) - 6*Dd**2*f**2*(-3*C*(76*r**2 + 4*r*(39*s - 29) - 39*s + 26) + 144*r**2 + 6*r*(58*s - 41) - 87*s + 58)) + f*(-126*D1**2*bd1**2*(3*C - 2)*(2*r**2 + 2*r*(s - 1) - s) + 18*D1**2*bdd1*f*(C*(38*r**2 + 78*r*s - 106*r - 93*s + 53) - 24*r**2 - 58*r*s + 68*r + 68*s - 34) - 5*D1**2*(f*(2*fd*(C*(177*r**2 + 333*r*s - 229*r - 111*s + 59) - 114*r**2 - 243*r*s + 157*r + 81*s - 38) + fdd*(-2*C*(237*r**2 + 369*r*s - 281*r - 123*s + 79) + 303*r**2 + 540*r*s - 382*r - 180*s + 101)) - 2*fd**2*(C*(474*r**2 + 738*r*s - 562*r - 246*s + 123) - 303*r**2 - 540*r*s + 382*r + 180*s - 90)) - 18*D1*bd1*(D1*(f*(C*(20*r**2 + 72*r*s - 58*r - 81*s + 29) - 13*r**2 - 53*r*s + 38*r + 59*s - 19) + fd*(C*(-152*r**2 - 52*r*(6*s - 5) + 171*s - 93) + 96*r**2 + 58*r*(4*s - 3) - 126*s + 68)) + 2*Dd*f*(C*(-152*r**2 - 312*r*s + 328*r + 225*s - 146) + 96*r**2 + 232*r*s - 218*r - 165*s + 102)) - 5*D1*f*(2*Dd*(f*(C*(236*r**2 + 444*r*s - 340*r - 111*s + 59) - 152*r**2 - 324*r*s + 238*r + 81*s - 38) + fd*(C*(-1896*r**2 - 2952*r*s + 2336*r + 861*s - 527) + 1212*r**2 + 2160*r*s - 1607*r - 630*s + 371)) + Ddd*f*(-2*C*(316*r**2 + 492*r*s - 404*r - 123*s + 79) + 404*r**2 + 720*r*s - 562*r - 180*s + 101)) + 30*Dd**2*f**2*(C*(316*r**2 + 492*r*s - 404*r - 123*s + 82) - 202*r**2 - 360*r*s + 281*r + 90*s - 60)))/(315*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**3*k1**2*(4*C - 2)*(3*D1*b1*(3*D1*(-3*f*fd*s + f*s*(bdd1*(7 - 14*r) + 5*fdd) + 5*fd**2*(s - 1)) + 30*Dd*f*fd*(2*s - 1) - 7*bd1*(D1*(f*s*(1 - 2*r) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1))) - 21*b1**2*(D1*Dd*(f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + f*(-63*D1**2*bd1**2*s*(2*r - 1) - 5*D1*Dd*f*(5*f*(4*r*s - 2*r - s) - 7*fd*(24*r*s - 10*r - 7*s + 3)) + 9*D1*bd1*(3*D1*f*s - 5*D1*fd*(s - 1) + 10*Dd*f*(1 - 2*s)) - 5*D1*(D1*(5*f*fd*(r*(3*s - 1) - s) + f*(9*bdd1*s + 7*fdd*(-3*r*s + r + s)) - 7*fd**2*(r*(6*s - 2) - 2*s + 1)) + 7*Ddd*f**2*(r*(2 - 4*s) + s)) + 35*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k2*k3**2) + D1**2*Pk3*Pkd1*ct**3*k2**5*st**4*(8*C - 8)*(18*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fd*r*s - 9*D1**2*b1*f*fd*r - 30*D1**2*b1*f*fdd*r**2 - 30*D1**2*b1*f*fdd*r*s + 15*D1**2*b1*f*fdd*r - 30*D1**2*b1*fd**2*r**2 - 30*D1**2*b1*fd**2*r*s + 15*D1**2*b1*fd**2*r - 15*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 21*D1**2*f**2*fd*r**2 + 21*D1**2*f**2*fd*r*s - 21*D1**2*f**2*fd*r - 7*D1**2*f**2*fd*s + 7*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 15*D1**2*f**2*fdd*r*s + 15*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 - 30*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r + 10*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 + 36*D1*Dd*b1*f**2*r**2 + 36*D1*Dd*b1*f**2*r*s - 36*D1*Dd*b1*f**2*r - 9*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 - 240*D1*Dd*b1*f*fd*r**2 - 240*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r + 30*D1*Dd*b1*f*fd*s - 15*D1*Dd*b1*f*fd + 28*D1*Dd*f**3*r**2 + 28*D1*Dd*f**3*r*s - 28*D1*Dd*f**3*r - 7*D1*Dd*f**3*s + 7*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 120*D1*Dd*f**2*fd*r*s + 120*D1*Dd*f**2*fd*r + 35*D1*Dd*f**2*fd*s - 25*D1*Dd*f**2*fd - 60*D1*Ddd*b1*f**2*r**2 - 60*D1*Ddd*b1*f**2*r*s + 60*D1*Ddd*b1*f**2*r + 15*D1*Ddd*b1*f**2*s - 15*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r + 5*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 180*Dd**2*b1*f**2*r**2 - 180*Dd**2*b1*f**2*r*s + 180*Dd**2*b1*f**2*r + 45*Dd**2*b1*f**2*s - 30*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r*s + 60*Dd**2*f**3*r + 15*Dd**2*f**3*s - 10*Dd**2*f**3)/(105*d**2*k3**6) - 4*D1**2*Pk3*Pkd1*ct**3*k2**5*st**2*(297*D1**2*K*bdd1*f**2*r**2 + 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*r - 99*D1**2*bd1**2*f*(2*r - 1)*(-7*K + 10*f + 7)*(r + s - 1) + 1650*D1**2*bdd1*f**3*r**2 + 1650*D1**2*bdd1*f**3*r*s - 3850*D1**2*bdd1*f**3*r - 2200*D1**2*bdd1*f**3*s + 2200*D1**2*bdd1*f**3 - 297*D1**2*bdd1*f**2*r**2 - 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*r - 1386*D1**2*bdd1*f*g2*r**2 - 1386*D1**2*bdd1*f*g2*r*s + 2772*D1**2*bdd1*f*g2*r + 1386*D1**2*bdd1*f*g2*s - 1386*D1**2*bdd1*f*g2 - 5040*D1**2*f**3*fd*r**2 - 5040*D1**2*f**3*fd*r*s + 5040*D1**2*f**3*fd*r + 1260*D1**2*f**3*fd*s - 1260*D1**2*f**3*fd + 5600*D1**2*f**3*fdd*r**2 + 5600*D1**2*f**3*fdd*r*s - 5600*D1**2*f**3*fdd*r - 1400*D1**2*f**3*fdd*s + 1400*D1**2*f**3*fdd + 16800*D1**2*f**2*fd**2*r**2 + 16800*D1**2*f**2*fd**2*r*s - 16800*D1**2*f**2*fd**2*r - 4200*D1**2*f**2*fd**2*s + 2800*D1**2*f**2*fd**2 + 726*D1**2*f**2*gd2*r**2 + 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*r - 594*D1**2*f**2*gdd2*r**2 - 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*r + 1452*D1**2*f*fd*g2*r**2 + 1452*D1**2*f*fd*g2*r*s - 1452*D1**2*f*fd*g2*r - 726*D1**2*f*fd*g2*s + 726*D1**2*f*fd*g2 - 2376*D1**2*f*fd*gd2*r**2 - 2376*D1**2*f*fd*gd2*r*s + 2376*D1**2*f*fd*gd2*r + 594*D1**2*f*fd*gd2*s - 594*D1**2*f*fd*gd2 - 1188*D1**2*f*fdd*g2*r**2 - 1188*D1**2*f*fdd*g2*r*s + 1188*D1**2*f*fdd*g2*r + 594*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 1188*D1**2*fd**2*g2*r**2 - 1188*D1**2*fd**2*g2*r*s + 1188*D1**2*fd**2*g2*r + 594*D1**2*fd**2*g2*s - 5040*D1*Dd*f**4*r**2 - 5040*D1*Dd*f**4*r*s + 5040*D1*Dd*f**4*r + 1260*D1*Dd*f**4*s - 1260*D1*Dd*f**4 + 44800*D1*Dd*f**3*fd*r**2 + 44800*D1*Dd*f**3*fd*r*s - 44800*D1*Dd*f**3*fd*r - 11200*D1*Dd*f**3*fd*s + 8400*D1*Dd*f**3*fd + 2904*D1*Dd*f**2*g2*r**2 + 2904*D1*Dd*f**2*g2*r*s - 2904*D1*Dd*f**2*g2*r - 726*D1*Dd*f**2*g2*s + 726*D1*Dd*f**2*g2 - 4752*D1*Dd*f**2*gd2*r**2 - 4752*D1*Dd*f**2*gd2*r*s + 4752*D1*Dd*f**2*gd2*r + 594*D1*Dd*f**2*gd2*s - 594*D1*Dd*f**2*gd2 - 9504*D1*Dd*f*fd*g2*r**2 - 9504*D1*Dd*f*fd*g2*r*s + 9504*D1*Dd*f*fd*g2*r + 3564*D1*Dd*f*fd*g2*s - 2376*D1*Dd*f*fd*g2 + 5600*D1*Ddd*f**4*r**2 + 5600*D1*Ddd*f**4*r*s - 5600*D1*Ddd*f**4*r - 1400*D1*Ddd*f**4*s + 1400*D1*Ddd*f**4 - 2376*D1*Ddd*f**2*g2*r**2 - 2376*D1*Ddd*f**2*g2*r*s + 2376*D1*Ddd*f**2*g2*r + 594*D1*Ddd*f**2*g2*s - 594*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(2*f**3*(51*r - 74)*(r + s - 1) + f**2*(-50*fd*(18*r**2 + 2*r*(9*s - 13) - 11*s + 7) + r*(33*K - 33)*(r + s - 1)) - 3*f*(9*fd*(K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) + 126*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-50*f**2*(24*r**2 + 8*r*(3*s - 5) - 19*s + 15) - 27*f*(K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 16800*Dd**2*f**4*r**2 + 16800*Dd**2*f**4*r*s - 16800*Dd**2*f**4*r - 4200*Dd**2*f**4*s + 2800*Dd**2*f**4 - 7128*Dd**2*f**2*g2*r**2 - 7128*Dd**2*f**2*g2*r*s + 7128*Dd**2*f**2*g2*r + 1782*Dd**2*f**2*g2*s - 1188*Dd**2*f**2*g2 + 33*b1**2*(D1**2*r*(6*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 30*fd**2*(2*r + 2*s - 1) - 7*fd*(K - 1)*(r + s) + 21*fdd*(K - 1)*(r + s)) + D1*(Dd*(18*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-30*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (7 - 7*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(K - 1)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-7*K + 10*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-7*K + 10*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-66*D1**2*K*f*fd*r**2 - 66*D1**2*K*f*fd*r*s + 66*D1**2*K*f*fd*r + 33*D1**2*K*f*fd*s - 33*D1**2*K*f*fd + 54*D1**2*K*f*fdd*r**2 + 54*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r - 27*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 54*D1**2*K*fd**2*r**2 + 54*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r - 27*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*r - 1)*(-7*K + 10*f + 7)*(r + s - 1) - 306*D1**2*f**2*fd*r**2 - 306*D1**2*f**2*fd*r*s + 158*D1**2*f**2*fd*r - 46*D1**2*f**2*fd*s + 46*D1**2*f**2*fd + 450*D1**2*f**2*fdd*r**2 + 450*D1**2*f**2*fdd*r*s - 250*D1**2*f**2*fdd*r + 50*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd + 900*D1**2*f*fd**2*r**2 + 900*D1**2*f*fd**2*r*s - 500*D1**2*f*fd**2*r + 100*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 66*D1**2*f*fd*r**2 + 66*D1**2*f*fd*r*s - 66*D1**2*f*fd*r - 33*D1**2*f*fd*s + 33*D1**2*f*fd - 54*D1**2*f*fdd*r**2 - 54*D1**2*f*fdd*r*s + 54*D1**2*f*fdd*r + 27*D1**2*f*fdd*s - 27*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r - 126*D1**2*f*gdd2*r**2 - 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*r - 54*D1**2*fd**2*r**2 - 54*D1**2*fd**2*r*s + 54*D1**2*fd**2*r + 27*D1**2*fd**2*s + 42*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s - 252*D1**2*fd*gd2*r**2 - 252*D1**2*fd*gd2*r*s + 126*D1**2*fd*gd2*r - 126*D1**2*fdd*g2*r**2 - 126*D1**2*fdd*g2*r*s - 132*D1*Dd*K*f**2*r**2 - 132*D1*Dd*K*f**2*r*s + 132*D1*Dd*K*f**2*r + 33*D1*Dd*K*f**2*s - 33*D1*Dd*K*f**2 + 432*D1*Dd*K*f*fd*r**2 + 432*D1*Dd*K*f*fd*r*s - 432*D1*Dd*K*f*fd*r - 162*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd - 408*D1*Dd*f**3*r**2 - 408*D1*Dd*f**3*r*s + 408*D1*Dd*f**3*r + 102*D1*Dd*f**3*s - 102*D1*Dd*f**3 + 3600*D1*Dd*f**2*fd*r**2 + 3600*D1*Dd*f**2*fd*r*s - 2800*D1*Dd*f**2*fd*r - 250*D1*Dd*f**2*fd*s + 150*D1*Dd*f**2*fd + 132*D1*Dd*f**2*r**2 + 132*D1*Dd*f**2*r*s - 132*D1*Dd*f**2*r - 33*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 432*D1*Dd*f*fd*r**2 - 432*D1*Dd*f*fd*r*s + 432*D1*Dd*f*fd*r + 162*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 42*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r + 126*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r + 126*D1*Dd*fd*g2*s + 108*D1*Ddd*K*f**2*r**2 + 108*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r - 27*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 + 600*D1*Ddd*f**3*r**2 + 600*D1*Ddd*f**3*r*s - 600*D1*Ddd*f**3*r - 150*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 - 108*D1*Ddd*f**2*r**2 - 108*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r + 27*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 504*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 126*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(18*f**2*(2*r - 1)*(r + s - 1) + f*(-30*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (7*K - 7)*(2*r - 1)*(r + s - 1)) + 21*fd*(K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-7*K + 10*f + 7)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 324*Dd**2*K*f**2*r**2 + 324*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r - 81*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 + 1800*Dd**2*f**3*r**2 + 1800*Dd**2*f**3*r*s - 1800*Dd**2*f**3*r - 450*Dd**2*f**3*s + 300*Dd**2*f**3 - 324*Dd**2*f**2*r**2 - 324*Dd**2*f**2*r*s + 324*Dd**2*f**2*r + 81*Dd**2*f**2*s - 54*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 1512*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 378*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(3465*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**3*k2**3*st**4*(4*C - 4)*(3*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 3*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(7*f*(4*r*s - 2*r - s) - 5*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(7*f*fd*(r*(3*s - 1) - s) + 5*f*(-3*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k3**4) + 2*D1**2*Pk3*Pkd1*ct**3*k2**3*st**2*(42*b1**2*(C - 1)*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1*(-220*C*D1**2*f*fd*r**2 - 172*C*D1**2*f*fd*r*s + 42*C*D1**2*f*fd*r - 22*C*D1**2*f*fd*s + 22*C*D1**2*f*fd + 432*C*D1**2*f*fdd*r**2 + 324*C*D1**2*f*fdd*r*s - 126*C*D1**2*f*fdd*r + 18*C*D1**2*f*fdd*s - 18*C*D1**2*f*fdd + 432*C*D1**2*fd**2*r**2 + 324*C*D1**2*fd**2*r*s - 126*C*D1**2*fd**2*r + 18*C*D1**2*fd**2*s - 18*C*D1**2*fd**2 - 440*C*D1*Dd*f**2*r**2 - 344*C*D1*Dd*f**2*r*s + 392*C*D1*Dd*f**2*r + 86*C*D1*Dd*f**2*s - 110*C*D1*Dd*f**2 + 3456*C*D1*Dd*f*fd*r**2 + 2592*C*D1*Dd*f*fd*r*s - 2016*C*D1*Dd*f*fd*r - 252*C*D1*Dd*f*fd*s + 90*C*D1*Dd*f*fd + 864*C*D1*Ddd*f**2*r**2 + 648*C*D1*Ddd*f**2*r*s - 756*C*D1*Ddd*f**2*r - 162*C*D1*Ddd*f**2*s + 216*C*D1*Ddd*f**2 + 2592*C*Dd**2*f**2*r**2 + 1944*C*Dd**2*f**2*r*s - 2268*C*Dd**2*f**2*r - 486*C*Dd**2*f**2*s + 324*C*Dd**2*f**2 - 42*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 232*D1**2*f*fd*r**2 + 184*D1**2*f*fd*r*s - 48*D1**2*f*fd*r + 22*D1**2*f*fd*s - 22*D1**2*f*fd - 438*D1**2*f*fdd*r**2 - 372*D1**2*f*fdd*r*s + 150*D1**2*f*fdd*r - 18*D1**2*f*fdd*s + 18*D1**2*f*fdd - 438*D1**2*fd**2*r**2 - 372*D1**2*fd**2*r*s + 150*D1**2*fd**2*r - 18*D1**2*fd**2*s + 18*D1**2*fd**2 + 464*D1*Dd*f**2*r**2 + 368*D1*Dd*f**2*r*s - 416*D1*Dd*f**2*r - 92*D1*Dd*f**2*s + 116*D1*Dd*f**2 - 3504*D1*Dd*f*fd*r**2 - 2976*D1*Dd*f*fd*r*s + 2220*D1*Dd*f*fd*r + 300*D1*Dd*f*fd*s - 114*D1*Dd*f*fd - 876*D1*Ddd*f**2*r**2 - 744*D1*Ddd*f**2*r*s + 810*D1*Ddd*f**2*r + 186*D1*Ddd*f**2*s - 219*D1*Ddd*f**2 + 14*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 2628*Dd**2*f**2*r**2 - 2232*Dd**2*f**2*r*s + 2430*Dd**2*f**2*r + 558*Dd**2*f**2*s - 372*Dd**2*f**2) + f*(-1668*C*D1**2*f*fd*r**2 - 636*C*D1**2*f*fd*r*s + 1324*C*D1**2*f*fd*r + 212*C*D1**2*f*fd*s - 556*C*D1**2*f*fd + 1482*C*D1**2*f*fdd*r**2 + 804*C*D1**2*f*fdd*r*s - 1256*C*D1**2*f*fdd*r - 268*C*D1**2*f*fdd*s + 494*C*D1**2*f*fdd + 2964*C*D1**2*fd**2*r**2 + 1608*C*D1**2*fd**2*r*s - 2512*C*D1**2*fd**2*r - 536*C*D1**2*fd**2*s + 268*C*D1**2*fd**2 - 2224*C*D1*Dd*f**2*r**2 - 848*C*D1*Dd*f**2*r*s + 1536*C*D1*Dd*f**2*r + 212*C*D1*Dd*f**2*s - 556*C*D1*Dd*f**2 + 11856*C*D1*Dd*f*fd*r**2 + 6432*C*D1*Dd*f*fd*r*s - 9596*C*D1*Dd*f*fd*r - 1876*C*D1*Dd*f*fd*s + 1792*C*D1*Dd*f*fd + 1976*C*D1*Ddd*f**2*r**2 + 1072*C*D1*Ddd*f**2*r*s - 1524*C*D1*Ddd*f**2*r - 268*C*D1*Ddd*f**2*s + 494*C*D1*Ddd*f**2 + 5928*C*Dd**2*f**2*r**2 + 3216*C*Dd**2*f**2*r*s - 4572*C*Dd**2*f**2*r - 804*C*Dd**2*f**2*s + 536*C*Dd**2*f**2 - 126*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 9*D1**2*bdd1*f*(6*C*(12*r**2 + r*(9*s - 26) - 10*s + 13) - 73*r**2 + r*(158 - 62*s) + 68*s - 79) + 1578*D1**2*f*fd*r**2 + 714*D1**2*f*fd*r*s - 1290*D1**2*f*fd*r - 238*D1**2*f*fd*s + 526*D1**2*f*fd - 1437*D1**2*f*fdd*r**2 - 924*D1**2*f*fdd*r*s + 1266*D1**2*f*fdd*r + 308*D1**2*f*fdd*s - 479*D1**2*f*fdd - 2874*D1**2*fd**2*r**2 - 1848*D1**2*fd**2*r*s + 2532*D1**2*fd**2*r + 616*D1**2*fd**2*s - 308*D1**2*fd**2 + 2104*D1*Dd*f**2*r**2 + 952*D1*Dd*f**2*r*s - 1528*D1*Dd*f**2*r - 238*D1*Dd*f**2*s + 526*D1*Dd*f**2 - 11496*D1*Dd*f*fd*r**2 - 7392*D1*Dd*f*fd*r*s + 9786*D1*Dd*f*fd*r + 2156*D1*Dd*f*fd*s - 1882*D1*Dd*f*fd - 1916*D1*Ddd*f**2*r**2 - 1232*D1*Ddd*f**2*r*s + 1574*D1*Ddd*f**2*r + 308*D1*Ddd*f**2*s - 479*D1*Ddd*f**2 - 6*D1*bd1*(D1*(f*(C*(55*r**2 + r*(43*s - 132) - 54*s + 66) - 58*r**2 - 46*r*(s - 3) + 57*s - 69) + 3*fd*(-3*C*(48*r**2 + r*(36*s - 59) - 19*s + 10) + 146*r**2 + r*(124*s - 183) - 65*s + 34)) + 3*Dd*f*(-3*C*(96*r**2 + 2*r*(36*s - 73) - 49*s + 46) + 292*r**2 + r*(248*s - 451) - 167*s + 147)) - 5748*Dd**2*f**2*r**2 - 3696*Dd**2*f**2*r*s + 4722*Dd**2*f**2*r + 924*Dd**2*f**2*s - 616*Dd**2*f**2))/(315*d**2*k3**4) - 2*D1**2*Pk3*Pkd1*ct**3*k2**3*(-4620*D1**2*K*bd1**2*f*r**2 - 3696*D1**2*K*bd1**2*f*r*s + 7854*D1**2*K*bd1**2*f*r + 2541*D1**2*K*bd1**2*f*s - 2541*D1**2*K*bd1**2*f + 1881*D1**2*K*bd1*f**2*r**2 + 1287*D1**2*K*bd1*f**2*r*s - 1287*D1**2*K*bd1*f**2*r - 10692*D1**2*K*bd1*f*fd*r**2 - 6732*D1**2*K*bd1*f*fd*r*s + 8712*D1**2*K*bd1*f*fd*r + 1683*D1**2*K*bd1*f*fd*s - 1683*D1**2*K*bd1*f*fd - 2673*D1**2*K*bdd1*f**2*r**2 - 1683*D1**2*K*bdd1*f**2*r*s + 1683*D1**2*K*bdd1*f**2*r + 6336*D1**2*bd1**2*f**2*r**2 + 6732*D1**2*bd1**2*f**2*r*s - 9702*D1**2*bd1**2*f**2*r - 3861*D1**2*bd1**2*f**2*s + 2871*D1**2*bd1**2*f**2 + 6468*D1**2*bd1**2*f*r**2 + 6468*D1**2*bd1**2*f*r*s - 11088*D1**2*bd1**2*f*r - 3927*D1**2*bd1**2*f*s + 3927*D1**2*bd1**2*f - 4620*D1**2*bd1**2*g2*r**2 - 4620*D1**2*bd1**2*g2*r*s + 4620*D1**2*bd1**2*g2*r + 2310*D1**2*bd1**2*g2*s - 1386*D1**2*bd1*bd2*f*r**2 - 1386*D1**2*bd1*bd2*f*r*s + 2079*D1**2*bd1*bd2*f*r + 693*D1**2*bd1*bd2*f*s - 693*D1**2*bd1*bd2*f - 1375*D1**2*bd1*f**3*r**2 + 605*D1**2*bd1*f**3*r*s + 165*D1**2*bd1*f**3*r - 2970*D1**2*bd1*f**3*s + 825*D1**2*bd1*f**3 + 11550*D1**2*bd1*f**2*fd*r**2 - 330*D1**2*bd1*f**2*fd*r*s - 3410*D1**2*bd1*f**2*fd*r + 5995*D1**2*bd1*f**2*fd*s - 3795*D1**2*bd1*f**2*fd - 2178*D1**2*bd1*f**2*r**2 - 1881*D1**2*bd1*f**2*r*s + 1881*D1**2*bd1*f**2*r + 12672*D1**2*bd1*f*fd*r**2 + 10692*D1**2*bd1*f*fd*r*s - 11682*D1**2*bd1*f*fd*r - 2673*D1**2*bd1*f*fd*s + 2673*D1**2*bd1*f*fd - 2772*D1**2*bd1*f*g2*r*s + 924*D1**2*bd1*f*g2*r + 3234*D1**2*bd1*f*g2*s - 462*D1**2*bd1*f*g2 + 9240*D1**2*bd1*f*gd2*r**2 + 7392*D1**2*bd1*f*gd2*r*s - 15708*D1**2*bd1*f*gd2*r - 5082*D1**2*bd1*f*gd2*s + 5082*D1**2*bd1*f*gd2 + 9240*D1**2*bd1*fd*g2*r**2 + 7392*D1**2*bd1*fd*g2*r*s - 9240*D1**2*bd1*fd*g2*r - 3696*D1**2*bd1*fd*g2*s + 297*D1**2*bd2*f**2*r**2 + 297*D1**2*bd2*f**2*r*s - 297*D1**2*bd2*f**2*r - 1980*D1**2*bd2*f*fd*r**2 - 1980*D1**2*bd2*f*fd*r*s + 1980*D1**2*bd2*f*fd*r + 495*D1**2*bd2*f*fd*s - 495*D1**2*bd2*f*fd + 1925*D1**2*bdd1*f**3*r**2 - 55*D1**2*bdd1*f**3*r*s + 165*D1**2*bdd1*f**3*r + 2970*D1**2*bdd1*f**3*s - 1155*D1**2*bdd1*f**3 + 3168*D1**2*bdd1*f**2*r**2 + 2673*D1**2*bdd1*f**2*r*s - 2673*D1**2*bdd1*f**2*r + 4620*D1**2*bdd1*f*g2*r**2 + 3696*D1**2*bdd1*f*g2*r*s - 12012*D1**2*bdd1*f*g2*r - 5082*D1**2*bdd1*f*g2*s + 6006*D1**2*bdd1*f*g2 - 495*D1**2*bdd2*f**2*r**2 - 495*D1**2*bdd2*f**2*r*s + 495*D1**2*bdd2*f**2*r + 3780*D1**2*f**3*fd*r**2 + 9240*D1**2*f**3*fd*r*s - 6510*D1**2*f**3*fd*r - 2310*D1**2*f**3*fd*s + 945*D1**2*f**3*fd - 4200*D1**2*f**3*fdd*r**2 - 9240*D1**2*f**3*fdd*r*s + 6720*D1**2*f**3*fdd*r + 2310*D1**2*f**3*fdd*s - 1050*D1**2*f**3*fdd - 12600*D1**2*f**2*fd**2*r**2 - 27720*D1**2*f**2*fd**2*r*s + 20160*D1**2*f**2*fd**2*r + 6930*D1**2*f**2*fd**2*s - 4620*D1**2*f**2*fd**2 - 3762*D1**2*f**2*gd2*r**2 - 2574*D1**2*f**2*gd2*r*s + 2574*D1**2*f**2*gd2*r + 5346*D1**2*f**2*gdd2*r**2 + 3366*D1**2*f**2*gdd2*r*s - 3366*D1**2*f**2*gdd2*r - 7524*D1**2*f*fd*g2*r**2 - 5148*D1**2*f*fd*g2*r*s + 7524*D1**2*f*fd*g2*r + 2574*D1**2*f*fd*g2*s - 3762*D1**2*f*fd*g2 + 21384*D1**2*f*fd*gd2*r**2 + 13464*D1**2*f*fd*gd2*r*s - 17424*D1**2*f*fd*gd2*r - 3366*D1**2*f*fd*gd2*s + 3366*D1**2*f*fd*gd2 + 10692*D1**2*f*fdd*g2*r**2 + 6732*D1**2*f*fdd*g2*r*s - 10692*D1**2*f*fdd*g2*r - 3366*D1**2*f*fdd*g2*s + 5346*D1**2*f*fdd*g2 + 10692*D1**2*fd**2*g2*r**2 + 6732*D1**2*fd**2*g2*r*s - 10692*D1**2*fd**2*g2*r - 3366*D1**2*fd**2*g2*s - 21384*D1*Dd*K*bd1*f**2*r**2 - 13464*D1*Dd*K*bd1*f**2*r*s + 15444*D1*Dd*K*bd1*f**2*r + 1683*D1*Dd*K*bd1*f**2*s - 1683*D1*Dd*K*bd1*f**2 + 15400*D1*Dd*bd1*f**3*r**2 - 440*D1*Dd*bd1*f**3*r*s - 3080*D1*Dd*bd1*f**3*r + 11935*D1*Dd*bd1*f**3*s - 6105*D1*Dd*bd1*f**3 + 25344*D1*Dd*bd1*f**2*r**2 + 21384*D1*Dd*bd1*f**2*r*s - 22374*D1*Dd*bd1*f**2*r - 2673*D1*Dd*bd1*f**2*s + 2673*D1*Dd*bd1*f**2 + 36960*D1*Dd*bd1*f*g2*r**2 + 29568*D1*Dd*bd1*f*g2*r*s - 64680*D1*Dd*bd1*f*g2*r - 24024*D1*Dd*bd1*f*g2*s + 22176*D1*Dd*bd1*f*g2 - 3960*D1*Dd*bd2*f**2*r**2 - 3960*D1*Dd*bd2*f**2*r*s + 3960*D1*Dd*bd2*f**2*r + 495*D1*Dd*bd2*f**2*s - 495*D1*Dd*bd2*f**2 + 3780*D1*Dd*f**4*r**2 + 9240*D1*Dd*f**4*r*s - 6510*D1*Dd*f**4*r - 2310*D1*Dd*f**4*s + 945*D1*Dd*f**4 - 33600*D1*Dd*f**3*fd*r**2 - 73920*D1*Dd*f**3*fd*r*s + 53760*D1*Dd*f**3*fd*r + 18480*D1*Dd*f**3*fd*s - 11340*D1*Dd*f**3*fd - 15048*D1*Dd*f**2*g2*r**2 - 10296*D1*Dd*f**2*g2*r*s + 12672*D1*Dd*f**2*g2*r + 2574*D1*Dd*f**2*g2*s - 3762*D1*Dd*f**2*g2 + 42768*D1*Dd*f**2*gd2*r**2 + 26928*D1*Dd*f**2*gd2*r*s - 30888*D1*Dd*f**2*gd2*r - 3366*D1*Dd*f**2*gd2*s + 3366*D1*Dd*f**2*gd2 + 85536*D1*Dd*f*fd*g2*r**2 + 53856*D1*Dd*f*fd*g2*r*s - 77616*D1*Dd*f*fd*g2*r - 20196*D1*Dd*f*fd*g2*s + 17424*D1*Dd*f*fd*g2 - 4200*D1*Ddd*f**4*r**2 - 9240*D1*Ddd*f**4*r*s + 6720*D1*Ddd*f**4*r + 2310*D1*Ddd*f**4*s - 1050*D1*Ddd*f**4 + 21384*D1*Ddd*f**2*g2*r**2 + 13464*D1*Ddd*f**2*g2*r*s - 17424*D1*Ddd*f**2*g2*r - 3366*D1*Ddd*f**2*g2*s + 5346*D1*Ddd*f**2*g2 - 12600*Dd**2*f**4*r**2 - 27720*Dd**2*f**4*r*s + 20160*Dd**2*f**4*r + 6930*Dd**2*f**4*s - 4620*Dd**2*f**4 + 64152*Dd**2*f**2*g2*r**2 + 40392*Dd**2*f**2*g2*r*s - 52272*Dd**2*f**2*g2*r - 10098*Dd**2*f**2*g2*s + 6732*Dd**2*f**2*g2 + 231*b1**3*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + (5*K - 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-5*K + 3*f + 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-5*K + 3*f + 5)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1**2*(42*D1**2*K*fd*r*s + 14*D1**2*K*fd*r + 7*D1**2*K*fd*s - 7*D1**2*K*fd - 70*D1**2*K*fdd*r**2 - 56*D1**2*K*fdd*r*s - 42*D1**2*K*fdd*r - 21*D1**2*K*fdd*s + 21*D1**2*K*fdd - 7*D1**2*bdd1*(-5*K + 3*f + 5)*(3*r**2 + 3*r*(s - 1) - s + 1) - 90*D1**2*f*fd*r**2 - 156*D1**2*f*fd*r*s + 78*D1**2*f*fd*r - 9*D1**2*f*fd*s + 9*D1**2*f*fd + 192*D1**2*f*fdd*r**2 + 204*D1**2*f*fdd*r*s - 102*D1**2*f*fdd*r + 15*D1**2*f*fdd*s - 15*D1**2*f*fdd + 192*D1**2*fd**2*r**2 + 204*D1**2*fd**2*r*s - 102*D1**2*fd**2*r + 15*D1**2*fd**2*s - 15*D1**2*fd**2 - 21*D1**2*fd*r**2 - 56*D1**2*fd*r*s - 14*D1**2*fd*r - 7*D1**2*fd*s + 7*D1**2*fd + 98*D1**2*fdd*r**2 + 98*D1**2*fdd*r*s + 42*D1**2*fdd*r + 21*D1**2*fdd*s - 21*D1**2*fdd - 70*D1**2*gd2*r**2 - 70*D1**2*gd2*r*s + 70*D1**2*gd2*r - 70*D1**2*gdd2*r**2 - 70*D1**2*gdd2*r*s + 70*D1**2*gdd2*r + 168*D1*Dd*K*f*r*s - 84*D1*Dd*K*f*r - 42*D1*Dd*K*f*s - 560*D1*Dd*K*fd*r**2 - 448*D1*Dd*K*fd*r*s + 84*D1*Dd*K*fd*r - 28*D1*Dd*K*fd*s + 84*D1*Dd*K*fd - 180*D1*Dd*f**2*r**2 - 312*D1*Dd*f**2*r*s + 246*D1*Dd*f**2*r + 78*D1*Dd*f**2*s - 45*D1*Dd*f**2 + 1536*D1*Dd*f*fd*r**2 + 1632*D1*Dd*f*fd*r*s - 1200*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s + 72*D1*Dd*f*fd - 84*D1*Dd*f*r**2 - 224*D1*Dd*f*r*s + 154*D1*Dd*f*r + 56*D1*Dd*f*s - 21*D1*Dd*f + 784*D1*Dd*fd*r**2 + 784*D1*Dd*fd*r*s - 224*D1*Dd*fd*r - 14*D1*Dd*fd*s - 84*D1*Dd*fd - 280*D1*Dd*g2*r**2 - 280*D1*Dd*g2*r*s + 280*D1*Dd*g2*r + 70*D1*Dd*g2*s - 70*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 560*D1*Dd*gd2*r*s + 560*D1*Dd*gd2*r + 70*D1*Dd*gd2*s - 70*D1*Dd*gd2 - 280*D1*Ddd*K*f*r**2 - 224*D1*Ddd*K*f*r*s + 252*D1*Ddd*K*f*r + 56*D1*Ddd*K*f*s - 70*D1*Ddd*K*f + 384*D1*Ddd*f**2*r**2 + 408*D1*Ddd*f**2*r*s - 396*D1*Ddd*f**2*r - 102*D1*Ddd*f**2*s + 96*D1*Ddd*f**2 + 392*D1*Ddd*f*r**2 + 392*D1*Ddd*f*r*s - 392*D1*Ddd*f*r - 98*D1*Ddd*f*s + 98*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 280*D1*Ddd*g2*r*s + 280*D1*Ddd*g2*r + 70*D1*Ddd*g2*s - 70*D1*Ddd*g2 + 7*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + (5*K - 5)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-5*K + 3*f + 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 840*Dd**2*K*f*r**2 - 672*Dd**2*K*f*r*s + 756*Dd**2*K*f*r + 168*Dd**2*K*f*s - 112*Dd**2*K*f + 1152*Dd**2*f**2*r**2 + 1224*Dd**2*f**2*r*s - 1188*Dd**2*f**2*r - 306*Dd**2*f**2*s + 204*Dd**2*f**2 + 1176*Dd**2*f*r**2 + 1176*Dd**2*f*r*s - 1176*Dd**2*f*r - 294*Dd**2*f*s + 196*Dd**2*f - 840*Dd**2*g2*r**2 - 840*Dd**2*g2*r*s + 840*Dd**2*g2*r + 210*Dd**2*g2*s - 140*Dd**2*g2) - 11*b1*(-342*D1**2*K*f*fd*r**2 - 234*D1**2*K*f*fd*r*s + 342*D1**2*K*f*fd*r + 117*D1**2*K*f*fd*s - 171*D1**2*K*f*fd + 486*D1**2*K*f*fdd*r**2 + 306*D1**2*K*f*fdd*r*s - 486*D1**2*K*f*fdd*r - 153*D1**2*K*f*fdd*s + 243*D1**2*K*f*fdd + 486*D1**2*K*fd**2*r**2 + 306*D1**2*K*fd**2*r*s - 486*D1**2*K*fd**2*r - 153*D1**2*K*fd**2*s - 21*D1**2*b2*fd*r**2 - 21*D1**2*b2*fd*r*s + 63*D1**2*b2*fdd*r**2 + 63*D1**2*b2*fdd*r*s + 21*D1**2*bd1**2*(-5*K + 3*f + 5)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 21*D1**2*bd2*f*r**2 - 21*D1**2*bd2*f*r*s + 21*D1**2*bd2*f*r + 126*D1**2*bd2*fd*r**2 + 126*D1**2*bd2*fd*r*s - 63*D1**2*bd2*fd*r - 3*D1**2*bdd1*(3*f**2*(64*r**2 + r*(68*s - 98) - 39*s + 37) - 7*f*(K*(20*r**2 + 16*r*s - 34*r - 11*s + 13) - 28*r**2 - 28*r*s + 48*r + 17*s - 17) - 70*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 63*D1**2*bdd2*f*r**2 + 63*D1**2*bdd2*f*r*s - 63*D1**2*bdd2*f*r + 375*D1**2*f**2*fd*r**2 - 165*D1**2*f**2*fd*r*s - 125*D1**2*f**2*fd*r - 215*D1**2*f**2*fd*s + 200*D1**2*f**2*fd - 525*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s + 355*D1**2*f**2*fdd*r + 265*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 1050*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s + 710*D1**2*f*fd**2*r + 530*D1**2*f*fd**2*s - 335*D1**2*f*fd**2 + 396*D1**2*f*fd*r**2 + 342*D1**2*f*fd*r*s - 396*D1**2*f*fd*r - 171*D1**2*f*fd*s + 198*D1**2*f*fd - 576*D1**2*f*fdd*r**2 - 486*D1**2*f*fdd*r*s + 576*D1**2*f*fdd*r + 243*D1**2*f*fdd*s - 288*D1**2*f*fdd + 252*D1**2*f*gd2*r*s - 252*D1**2*f*gd2*r - 420*D1**2*f*gdd2*r**2 - 336*D1**2*f*gdd2*r*s + 336*D1**2*f*gdd2*r - 576*D1**2*fd**2*r**2 - 486*D1**2*fd**2*r*s + 576*D1**2*fd**2*r + 243*D1**2*fd**2*s + 252*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*r + 42*D1**2*fd*g2*s - 42*D1**2*fd*g2 - 840*D1**2*fd*gd2*r**2 - 672*D1**2*fd*gd2*r*s + 84*D1**2*fd*gd2*r - 126*D1**2*fd*gd2*s + 126*D1**2*fd*gd2 - 420*D1**2*fdd*g2*r**2 - 336*D1**2*fdd*g2*r*s - 252*D1**2*fdd*g2*r - 126*D1**2*fdd*g2*s + 126*D1**2*fdd*g2 - 684*D1*Dd*K*f**2*r**2 - 468*D1*Dd*K*f**2*r*s + 576*D1*Dd*K*f**2*r + 117*D1*Dd*K*f**2*s - 171*D1*Dd*K*f**2 + 3888*D1*Dd*K*f*fd*r**2 + 2448*D1*Dd*K*f*fd*r*s - 3528*D1*Dd*K*f*fd*r - 918*D1*Dd*K*f*fd*s + 792*D1*Dd*K*f*fd - 84*D1*Dd*b2*f*r**2 - 84*D1*Dd*b2*f*r*s + 84*D1*Dd*b2*f*r + 21*D1*Dd*b2*f*s - 21*D1*Dd*b2*f + 504*D1*Dd*b2*fd*r**2 + 504*D1*Dd*b2*fd*r*s - 252*D1*Dd*b2*fd*r - 63*D1*Dd*b2*fd*s + 504*D1*Dd*bd2*f*r**2 + 504*D1*Dd*bd2*f*r*s - 504*D1*Dd*bd2*f*r - 63*D1*Dd*bd2*f*s + 63*D1*Dd*bd2*f + 500*D1*Dd*f**3*r**2 - 220*D1*Dd*f**3*r*s - 140*D1*Dd*f**3*r + 55*D1*Dd*f**3*s + 125*D1*Dd*f**3 - 4200*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s + 2440*D1*Dd*f**2*fd*r + 1045*D1*Dd*f**2*fd*s - 885*D1*Dd*f**2*fd + 792*D1*Dd*f**2*r**2 + 684*D1*Dd*f**2*r*s - 738*D1*Dd*f**2*r - 171*D1*Dd*f**2*s + 198*D1*Dd*f**2 - 4608*D1*Dd*f*fd*r**2 - 3888*D1*Dd*f*fd*r*s + 4428*D1*Dd*f*fd*r + 1458*D1*Dd*f*fd*s - 1062*D1*Dd*f*fd + 1008*D1*Dd*f*g2*r*s - 504*D1*Dd*f*g2*r - 252*D1*Dd*f*g2*s - 3360*D1*Dd*f*gd2*r**2 - 2688*D1*Dd*f*gd2*r*s + 2856*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s - 336*D1*Dd*f*gd2 - 3360*D1*Dd*fd*g2*r**2 - 2688*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 168*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 + 972*D1*Ddd*K*f**2*r**2 + 612*D1*Ddd*K*f**2*r*s - 792*D1*Ddd*K*f**2*r - 153*D1*Ddd*K*f**2*s + 243*D1*Ddd*K*f**2 + 252*D1*Ddd*b2*f*r**2 + 252*D1*Ddd*b2*f*r*s - 252*D1*Ddd*b2*f*r - 63*D1*Ddd*b2*f*s + 63*D1*Ddd*b2*f - 700*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s + 340*D1*Ddd*f**3*r - 5*D1*Ddd*f**3*s - 175*D1*Ddd*f**3 - 1152*D1*Ddd*f**2*r**2 - 972*D1*Ddd*f**2*r*s + 1062*D1*Ddd*f**2*r + 243*D1*Ddd*f**2*s - 288*D1*Ddd*f**2 - 1680*D1*Ddd*f*g2*r**2 - 1344*D1*Ddd*f*g2*r*s + 1512*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s - 420*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(3*f**2*(30*r**2 + r*(52*s - 56) - 29*s + 18) + f*(7*K*(r*(8 - 12*s) + 7*s - 1) - 12*fd*(64*r**2 + r*(68*s - 66) - 17*s + 11) + 42*r**2 + 112*r*(s - 1) - 63*s + 28) + 7*fd*(K*(40*r**2 + r*(32*s - 22) - 5*s - 3) - 56*r**2 + r*(36 - 56*s) + 11*s + 3) + 70*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 70*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 2*Dd*(24*f**2*(32*r**2 + r*(34*s - 41) - 14*s + 11) - 7*f*(2*K*(40*r**2 + 32*r*s - 52*r - 15*s + 14) - 112*r**2 - 112*r*s + 152*r + 48*s - 41) - 70*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + 2916*Dd**2*K*f**2*r**2 + 1836*Dd**2*K*f**2*r*s - 2376*Dd**2*K*f**2*r - 459*Dd**2*K*f**2*s + 306*Dd**2*K*f**2 + 756*Dd**2*b2*f*r**2 + 756*Dd**2*b2*f*r*s - 756*Dd**2*b2*f*r - 189*Dd**2*b2*f*s + 126*Dd**2*b2*f - 2100*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s + 1020*Dd**2*f**3*r - 15*Dd**2*f**3*s + 10*Dd**2*f**3 - 3456*Dd**2*f**2*r**2 - 2916*Dd**2*f**2*r*s + 3186*Dd**2*f**2*r + 729*Dd**2*f**2*s - 486*Dd**2*f**2 - 5040*Dd**2*f*g2*r**2 - 4032*Dd**2*f*g2*r*s + 4536*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s - 672*Dd**2*f*g2) + 33*b2*(-21*D1**2*bdd1*f*(r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 10*fd*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(3465*d**2*k3**4) + 4*D1**2*Pk3*Pkd1*ct**3*k2*st**2*(-21*b1**2*(C - 1)*(D1*Dd*(f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 3*b1*(D1*Dd*f*(-f*(7*C - 13)*(r*(4*s - 2) - s) + 3*fd*(2*s - 1)*(C*(56*r - 1) - 64*r + 2)) - 7*D1*bd1*(C - 1)*(D1*(f*s*(1 - 2*r) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(f*fd*(-r*(7*C - 13)*(2*s - 1) + s*(11 - 11*C)) + 3*f*(-7*bdd1*s*(C - 1)*(2*r - 1) + fdd*r*(7*C - 8)*(2*s - 1) + fdd*s*(3*C - 3)) + 3*fd**2*(C*(14*r*s - 7*r + 3*s - 3) - 16*r*s + 8*r - 3*s + 3)) + Ddd*f**2*(21*C - 24)*(r*(4*s - 2) - s)) + Dd**2*f**2*(21*C - 24)*(6*r*(2*s - 1) - 3*s + 2)) + f*(-63*D1**2*bd1**2*s*(C - 1)*(2*r - 1) + D1*Dd*f*(f*(56 - 46*C)*(r*(4*s - 2) - s) + fd*(50*C - 55)*(2*r*(12*s - 5) - 7*s + 3)) - 3*D1*bd1*(D1*(f*s*(C*(7*r - 18) - 13*r + 24) - 3*fd*(C*(28*r*s - 7*r - 17*s + 10) - 32*r*s + 8*r + 19*s - 11)) - 3*Dd*f*(C*(56*r*s - 14*r - 47*s + 20) - 64*r*s + 16*r + 52*s - 22)) + D1*(D1*(f*fd*(56 - 46*C)*(r*(3*s - 1) - s) + f*(9*bdd1*s*(7*C*r - 10*C - 8*r + 11) + fdd*(50*C - 55)*(3*r*s - r - s)) + fd**2*(50*C - 55)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(50*C - 55)*(r*(4*s - 2) - s)) + Dd**2*f**2*(50*C - 55)*(6*r*(2*s - 1) - 3*s + 2)))/(315*d**2*k3**2) + 2*D1**2*Pk3*Pkd1*ct**3*k2*(21*b1**2*(D1**2*r*(fd*(4*C*(r - 3*s + 3) - 3*r + 12*s - 12) + 2*fdd*(4*C*(r + 2*s - 2) - 3*r - 8*s + 8)) + D1*(Dd*(f*(4*C*(4*r**2 - 12*r*s + 4*r + 3*s + 1) - 12*r**2 + 48*r*s - 18*r - 12*s - 3) + 4*fd*(4*C*(4*r**2 + 8*r*s - 7*r - s + 1) - 12*r**2 - 32*r*s + 27*r + 4*s - 4)) + 2*Ddd*f*(4*C*(4*r**2 + 8*r*s - 6*r - 2*s + 1) - 12*r**2 - 32*r*s + 22*r + 8*s - 3)) + 4*Dd**2*f*(4*C*(6*r**2 + 12*r*s - 9*r - 3*s + 2) - 18*r**2 - 48*r*s + 33*r + 12*s - 8)) + 3*b1*(14*D1**2*bdd1*f*(4*C*(2*r**2 + r*(4*s - 2) - 2*s + 1) - 6*r**2 + r*(6 - 16*s) + 8*s - 3) - 3*D1**2*(f*(fd*(4*C*(4*r**2 - 4*r*(s + 1) - 5*s + 3) - 8*r**2 + 36*r*s + 20*s - 9) + fdd*(-4*C*(2*r**2 - r*(2*s + 9) - 6*s + 5) + 4*r**2 - 2*r*(16*s + 7) - 24*s + 15)) + 2*fd**2*(-2*C*(2*r**2 - r*(2*s + 9) - 6*s + 6) + 2*r**2 - 16*r*s - 7*r - 12*s + 12)) + 7*D1*bd1*(D1*(f*(4*C*(2*r**2 - 6*r*s - 2*r + 3*s + 1) - 6*r**2 + 24*r*s + 6*r - 12*s - 3) + 4*fd*(4*C*(2*r**2 + 4*r*s - 3*r - s + 1) - 6*r**2 - 16*r*s + 11*r + 4*s - 4)) + 4*Dd*f*(4*C*(8*r**2 + 2*r*(8*s - 5) - 6*s + 3) - 24*r**2 - 64*r*s + 34*r + 24*s - 11)) - 6*D1*f*(Dd*(f*(4*C*(4*r**2 - 4*r*s + s + 1) - 8*r**2 + 36*r*s - 14*r - 9*s - 2) + fd*(C*(-32*r**2 + 8*r*(4*s + 9) + 44*s - 42) + 16*r**2 - 128*r*s - 32*s + 31)) + Ddd*f*(-2*C*(4*r**2 - 4*r*s + s + 1) + 4*r**2 - 32*r*s + 14*r + 8*s + 1)) - 12*Dd**2*f**2*(C*(-12*r**2 + 12*r*s - 3*s + 2) + 6*r**2 + r*(21 - 48*s) + 12*s - 8)) + f*(84*D1**2*bd1**2*(r**2*(4*C - 3) + r*(C*(8*s - 4) - 8*s + 3) - s*(4*C - 4)) + 9*D1**2*bdd1*f*(4*C*(r**2 - r*(s - 8) + 7*s - 4) - 2*r**2 + 2*r*(8*s - 13) - 40*s + 13) + 5*D1**2*(f*(fd*(4*C*(15*r**2 + 27*r*s - 19*r - 9*s + 5) - 51*r**2 - 150*r*s + 84*r + 50*s - 17) + 2*fdd*(-2*C*(21*r**2 + 27*r*s - 23*r - 9*s + 7) + 33*r**2 + 78*r*s - 48*r - 26*s + 11)) - 4*fd**2*(C*(42*r**2 + 54*r*s - 46*r - 18*s + 9) - 33*r**2 - 78*r*s + 48*r + 26*s - 13)) - 9*D1*bd1*(D1*(f*(4*C*(2*r**2 - 2*r*(s - 1) + 7*s - 1) - 4*r**2 + 2*r*(9*s - 5) - 38*s + 5) + 2*fd*(-2*C*(4*r**2 + r*(7 - 4*s) + 8*s - 7) + 4*r**2 - 32*r*s + 19*r + 28*s - 20)) - 2*Dd*f*(2*C*(8*r**2 - 8*r*(s - 4) + 29*s - 22) - 8*r**2 + r*(64*s - 66) - 88*s + 53)) + 5*D1*f*(Dd*(f*(4*C*(20*r**2 + 4*r*(9*s - 7) - 9*s + 5) - 68*r**2 - 200*r*s + 134*r + 50*s - 17) - 4*fd*(C*(168*r**2 + 4*r*(54*s - 47) - 63*s + 41) - 132*r**2 - 312*r*s + 207*r + 91*s - 50)) - 2*Ddd*f*(2*C*(28*r**2 + 4*r*(9*s - 8) - 9*s + 7) - 44*r**2 - 104*r*s + 74*r + 26*s - 11)) - 20*Dd**2*f**2*(3*C*(28*r**2 + 4*r*(9*s - 8) - 9*s + 6) - 66*r**2 - 156*r*s + 111*r + 39*s - 26)))/(315*d**2*k3**2) - D1**2*Pk3*Pkd1*ct**3*(4*C - 2)*(3*D1*f*(7*D1*bd1**2*s*(1 - 2*r) + D1*bd1*(3*f*r*s + 5*fd*(-4*r*s + r + s)) - 5*D1*bdd1*f*r*s + 5*Dd*bd1*f*(r*(2 - 8*s) + s)) - 7*b1**2*(D1*Dd*(f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(-3*D1*Dd*f*(3*f*(r*(2 - 4*s) + s) + 5*fd*(8*r - 3)*(2*s - 1)) + 7*D1*bd1*(D1*(f*s*(2*r - 1) + 3*fd*(-4*r*s + 2*r + s - 1)) - 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) - 3*D1*(D1*(3*f*fd*(-2*r*s + r + s) + f*(7*bdd1*s*(2*r - 1) + 5*fdd*r*(2*s - 1) - 5*fdd*s) + 5*fd**2*(r*(2*s - 1) - s + 1)) + 5*Ddd*f**2*(r*(4*s - 2) - s)) - 15*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k2) - 2*D1**2*Pk3*Pkd1*ct**3*k2**3*st**2*(36*D1**2*b1*f*fd*r**2 - 18*D1**2*b1*f*fdd*r**2 - 18*D1**2*b1*fd**2*r**2 - 9*D1**2*bdd1*f**2*(r - 1)**2 + 150*D1**2*f**2*fd*r**2 - 100*D1**2*f**2*fd*r + 50*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 72*D1*Dd*b1*f**2*r**2 - 36*D1*Dd*b1*f**2*r + 18*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 + 36*D1*Dd*b1*f*fd*r + 200*D1*Dd*f**3*r**2 - 100*D1*Dd*f**3*r + 50*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 + 18*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 18*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 108*Dd**2*b1*f**2*r**2 + 54*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(315*d**2*k1**2*k3**2) + 2*D1**2*Pk3*Pkd1*ct**3*k2**3*(-2*D1**2*bd1**2*f*r*(6*f + 7)*(r - 1) + D1*b1*(2*D1*bd1*(6*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(14 - 24*fd) + r*(12*fd - 14) + 7) + 7*fd*r*(1 - 2*r)) - D1*bdd1*f*(6*f + 7)*(2*r**2 - 2*r + 1) - 2*Dd*bd1*f*(6*f + 7)*(8*r**2 - 6*r + 1)) + b1**2*(D1**2*r**2*(-12*fd**2 + fd*(24*f + 14) - fdd*(12*f + 7)) + D1*(2*Dd*(6*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(28 - 48*fd) + r*(12*fd - 14) + 7) + 7*fd*r*(1 - 4*r)) - Ddd*f*(6*f + 7)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(6*f + 7)*(2*r - 1)))/(105*d**2*k1**2*k3**2) - 2*D1**2*Pk3*Pkd1*ct**3*k2*(2*D1**2*bd1**2*f*r*(r - 1) + D1*b1*(D1*bdd1*f*(2*r**2 - 2*r + 1) - 2*bd1*(D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(1 - 2*r) + Dd*f*(-8*r**2 + 6*r - 1))) + b1**2*(D1**2*r**2*(-2*fd + fdd) - 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*r*(1 - 4*r)) + D1*Ddd*f*(4*r**2 - 2*r + 1) + 6*Dd**2*f*r*(2*r - 1)))/(15*d**2*k1**2) + 4*D1**2*Pk3*Pkd1*ct**2*f*k2**6*st**4*(99*D1**2*b1*f*fd*r**2 + 99*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r - 99*D1**2*b1*f*fdd*r**2 - 99*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 198*D1**2*b1*fd**2*r**2 - 198*D1**2*b1*fd**2*r*s + 132*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 76*D1**2*f**2*fd*r**2 + 76*D1**2*f**2*fd*r*s - 76*D1**2*f**2*fd*r - 19*D1**2*f**2*fd*s + 19*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 60*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s - 15*D1**2*f**2*fdd - 180*D1**2*f*fd**2*r**2 - 180*D1**2*f*fd**2*r*s + 180*D1**2*f*fd**2*r + 45*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 132*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r - 33*D1*Dd*b1*f**2*s + 33*D1*Dd*b1*f**2 - 792*D1*Dd*b1*f*fd*r**2 - 792*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r + 99*D1*Dd*b1*f*fd*s - 66*D1*Dd*b1*f*fd + 76*D1*Dd*f**3*r**2 + 76*D1*Dd*f**3*r*s - 76*D1*Dd*f**3*r - 19*D1*Dd*f**3*s + 19*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 480*D1*Dd*f**2*fd*r*s + 480*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s - 90*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 60*D1*Ddd*f**3*r**2 - 60*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r + 15*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r + 99*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 180*Dd**2*f**3*r**2 - 180*Dd**2*f**3*r*s + 180*Dd**2*f**3*r + 45*Dd**2*f**3*s - 30*Dd**2*f**3)/(231*d**2*k1*k3**6) + D1**2*Pk3*Pkd1*ct**2*k1**5*(8*C - 4)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*ct**2*k1**3*k2**2*st**2*(396*C*D1**2*b1*f*fd*r**2 + 396*C*D1**2*b1*f*fd*r*s - 198*C*D1**2*b1*f*fd*r - 1332*C*D1**2*b1*f*fdd*r**2 - 1332*C*D1**2*b1*f*fdd*r*s + 666*C*D1**2*b1*f*fdd*r - 1332*C*D1**2*b1*fd**2*r**2 - 1332*C*D1**2*b1*fd**2*r*s + 666*C*D1**2*b1*fd**2*r + 762*C*D1**2*f**2*fd*r**2 + 762*C*D1**2*f**2*fd*r*s - 762*C*D1**2*f**2*fd*r - 254*C*D1**2*f**2*fd*s + 254*C*D1**2*f**2*fd - 1110*C*D1**2*f**2*fdd*r**2 - 1110*C*D1**2*f**2*fdd*r*s + 1110*C*D1**2*f**2*fdd*r + 370*C*D1**2*f**2*fdd*s - 370*C*D1**2*f**2*fdd - 2220*C*D1**2*f*fd**2*r**2 - 2220*C*D1**2*f*fd**2*r*s + 2220*C*D1**2*f*fd**2*r + 740*C*D1**2*f*fd**2*s - 370*C*D1**2*f*fd**2 + 792*C*D1*Dd*b1*f**2*r**2 + 792*C*D1*Dd*b1*f**2*r*s - 792*C*D1*Dd*b1*f**2*r - 198*C*D1*Dd*b1*f**2*s + 198*C*D1*Dd*b1*f**2 - 10656*C*D1*Dd*b1*f*fd*r**2 - 10656*C*D1*Dd*b1*f*fd*r*s + 7992*C*D1*Dd*b1*f*fd*r + 1332*C*D1*Dd*b1*f*fd*s - 666*C*D1*Dd*b1*f*fd + 1016*C*D1*Dd*f**3*r**2 + 1016*C*D1*Dd*f**3*r*s - 1016*C*D1*Dd*f**3*r - 254*C*D1*Dd*f**3*s + 254*C*D1*Dd*f**3 - 8880*C*D1*Dd*f**2*fd*r**2 - 8880*C*D1*Dd*f**2*fd*r*s + 8880*C*D1*Dd*f**2*fd*r + 2590*C*D1*Dd*f**2*fd*s - 1850*C*D1*Dd*f**2*fd - 2664*C*D1*Ddd*b1*f**2*r**2 - 2664*C*D1*Ddd*b1*f**2*r*s + 2664*C*D1*Ddd*b1*f**2*r + 666*C*D1*Ddd*b1*f**2*s - 666*C*D1*Ddd*b1*f**2 - 1480*C*D1*Ddd*f**3*r**2 - 1480*C*D1*Ddd*f**3*r*s + 1480*C*D1*Ddd*f**3*r + 370*C*D1*Ddd*f**3*s - 370*C*D1*Ddd*f**3 - 7992*C*Dd**2*b1*f**2*r**2 - 7992*C*Dd**2*b1*f**2*r*s + 7992*C*Dd**2*b1*f**2*r + 1998*C*Dd**2*b1*f**2*s - 1332*C*Dd**2*b1*f**2 - 4440*C*Dd**2*f**3*r**2 - 4440*C*Dd**2*f**3*r*s + 4440*C*Dd**2*f**3*r + 1110*C*Dd**2*f**3*s - 740*C*Dd**2*f**3 - 222*D1**2*b1*f*fd*r**2 - 222*D1**2*b1*f*fd*r*s + 111*D1**2*b1*f*fd*r + 846*D1**2*b1*f*fdd*r**2 + 846*D1**2*b1*f*fdd*r*s - 423*D1**2*b1*f*fdd*r + 846*D1**2*b1*fd**2*r**2 + 846*D1**2*b1*fd**2*r*s - 423*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(74*C - 47)*(r - 1)*(r + s - 1) - 465*D1**2*f**2*fd*r**2 - 465*D1**2*f**2*fd*r*s + 465*D1**2*f**2*fd*r + 155*D1**2*f**2*fd*s - 155*D1**2*f**2*fd + 705*D1**2*f**2*fdd*r**2 + 705*D1**2*f**2*fdd*r*s - 705*D1**2*f**2*fdd*r - 235*D1**2*f**2*fdd*s + 235*D1**2*f**2*fdd + 1410*D1**2*f*fd**2*r**2 + 1410*D1**2*f*fd**2*r*s - 1410*D1**2*f*fd**2*r - 470*D1**2*f*fd**2*s + 235*D1**2*f*fd**2 - 444*D1*Dd*b1*f**2*r**2 - 444*D1*Dd*b1*f**2*r*s + 444*D1*Dd*b1*f**2*r + 111*D1*Dd*b1*f**2*s - 111*D1*Dd*b1*f**2 + 6768*D1*Dd*b1*f*fd*r**2 + 6768*D1*Dd*b1*f*fd*r*s - 5076*D1*Dd*b1*f*fd*r - 846*D1*Dd*b1*f*fd*s + 423*D1*Dd*b1*f*fd - 620*D1*Dd*f**3*r**2 - 620*D1*Dd*f**3*r*s + 620*D1*Dd*f**3*r + 155*D1*Dd*f**3*s - 155*D1*Dd*f**3 + 5640*D1*Dd*f**2*fd*r**2 + 5640*D1*Dd*f**2*fd*r*s - 5640*D1*Dd*f**2*fd*r - 1645*D1*Dd*f**2*fd*s + 1175*D1*Dd*f**2*fd + 1692*D1*Ddd*b1*f**2*r**2 + 1692*D1*Ddd*b1*f**2*r*s - 1692*D1*Ddd*b1*f**2*r - 423*D1*Ddd*b1*f**2*s + 423*D1*Ddd*b1*f**2 + 940*D1*Ddd*f**3*r**2 + 940*D1*Ddd*f**3*r*s - 940*D1*Ddd*f**3*r - 235*D1*Ddd*f**3*s + 235*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(66*C - 37)*(r - 1)*(r + s - 1) - fd*(222*C - 141)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(141 - 222*C)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 5076*Dd**2*b1*f**2*r**2 + 5076*Dd**2*b1*f**2*r*s - 5076*Dd**2*b1*f**2*r - 1269*Dd**2*b1*f**2*s + 846*Dd**2*b1*f**2 + 2820*Dd**2*f**3*r**2 + 2820*Dd**2*f**3*r*s - 2820*Dd**2*f**3*r - 705*Dd**2*f**3*s + 470*Dd**2*f**3)/(315*d**2*k3**6) - 4*D1**2*Pk3*Pkd1*ct**2*k1**3*k2**2*(-198*D1**2*bd1**2*f*(2*r - 1)*(-35*K + 10*f + 14)*(r + s - 1) - 55*D1**2*bdd1*f*(r + s - 1)*(7*f**2*(3*r + 1) + 18*f*r*(2 - 5*K) + 252*g2*(r - 1)) - 5*D1**2*(7*f**3*(7*fd - 9*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 9*f**2*(7*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + r*(132*gd2 - 220*gdd2)*(r + s - 1)) - 396*f*(fd*(g2*(6*r**2 + 6*r*(s - 1) - 3*s + 3) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 1980*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) + 11*D1*bd1*(D1*(25*f**3*(3*r + 1)*(r + s - 1) + f**2*(-35*fd*(18*r**2 + 2*r*(9*s - 8) - s + 2) + r*(108 - 270*K)*(r + s - 1)) + 30*f*(3*fd*(5*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) - 1260*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(7*f**2*(24*r**2 + 4*r*(6*s - 5) + s) - 18*f*(5*K - 2)*(8*r**2 + 8*r*(s - 1) - s + 1) + 252*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 5*D1*f*(Dd*(49*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 126*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 396*f*(3*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 3960*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 9*Ddd*f*(7*f**2 - 220*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 45*Dd**2*f**2*(7*f**2 - 220*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 66*b1**2*(D1**2*r*(6*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 30*fd**2*(2*r + 2*s - 1) - 7*fd*(5*K - 2)*(r + s) + 21*fdd*(5*K - 2)*(r + s)) + D1*(Dd*(18*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-30*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (14 - 35*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(5*K - 2)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-35*K + 10*f + 14)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-35*K + 10*f + 14)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-540*D1**2*K*f*fd*r**2 - 540*D1**2*K*f*fd*r*s + 540*D1**2*K*f*fd*r + 270*D1**2*K*f*fd*s - 270*D1**2*K*f*fd + 900*D1**2*K*f*fdd*r**2 + 900*D1**2*K*f*fdd*r*s - 900*D1**2*K*f*fdd*r - 450*D1**2*K*f*fdd*s + 450*D1**2*K*f*fdd + 900*D1**2*K*fd**2*r**2 + 900*D1**2*K*fd**2*r*s - 900*D1**2*K*fd**2*r - 450*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(2*r - 1)*(-35*K + 10*f + 14)*(r + s - 1) + 225*D1**2*f**2*fd*r**2 + 225*D1**2*f**2*fd*r*s - 250*D1**2*f**2*fd*r - 100*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 315*D1**2*f**2*fdd*r**2 - 315*D1**2*f**2*fdd*r*s + 350*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 630*D1**2*f*fd**2*r**2 - 630*D1**2*f*fd**2*r*s + 700*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 216*D1**2*f*fd*r**2 + 216*D1**2*f*fd*r*s - 216*D1**2*f*fd*r - 108*D1**2*f*fd*s + 108*D1**2*f*fd - 360*D1**2*f*fdd*r**2 - 360*D1**2*f*fdd*r*s + 360*D1**2*f*fdd*r + 180*D1**2*f*fdd*s - 180*D1**2*f*fdd + 420*D1**2*f*gd2*r**2 + 420*D1**2*f*gd2*r*s - 420*D1**2*f*gd2*r - 1260*D1**2*f*gdd2*r**2 - 1260*D1**2*f*gdd2*r*s + 1260*D1**2*f*gdd2*r - 360*D1**2*fd**2*r**2 - 360*D1**2*fd**2*r*s + 360*D1**2*fd**2*r + 180*D1**2*fd**2*s + 420*D1**2*fd*g2*r**2 + 420*D1**2*fd*g2*r*s - 2520*D1**2*fd*gd2*r**2 - 2520*D1**2*fd*gd2*r*s + 1260*D1**2*fd*gd2*r - 1260*D1**2*fdd*g2*r**2 - 1260*D1**2*fdd*g2*r*s - 1080*D1*Dd*K*f**2*r**2 - 1080*D1*Dd*K*f**2*r*s + 1080*D1*Dd*K*f**2*r + 270*D1*Dd*K*f**2*s - 270*D1*Dd*K*f**2 + 7200*D1*Dd*K*f*fd*r**2 + 7200*D1*Dd*K*f*fd*r*s - 7200*D1*Dd*K*f*fd*r - 2700*D1*Dd*K*f*fd*s + 1800*D1*Dd*K*f*fd + 300*D1*Dd*f**3*r**2 + 300*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r - 75*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 2520*D1*Dd*f**2*fd*r**2 - 2520*D1*Dd*f**2*fd*r*s + 2660*D1*Dd*f**2*fd*r + 875*D1*Dd*f**2*fd*s - 630*D1*Dd*f**2*fd + 432*D1*Dd*f**2*r**2 + 432*D1*Dd*f**2*r*s - 432*D1*Dd*f**2*r - 108*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 2880*D1*Dd*f*fd*r**2 - 2880*D1*Dd*f*fd*r*s + 2880*D1*Dd*f*fd*r + 1080*D1*Dd*f*fd*s - 720*D1*Dd*f*fd + 1680*D1*Dd*f*g2*r**2 + 1680*D1*Dd*f*g2*r*s - 1680*D1*Dd*f*g2*r - 420*D1*Dd*f*g2*s + 420*D1*Dd*f*g2 - 10080*D1*Dd*f*gd2*r**2 - 10080*D1*Dd*f*gd2*r*s + 10080*D1*Dd*f*gd2*r + 1260*D1*Dd*f*gd2*s - 1260*D1*Dd*f*gd2 - 10080*D1*Dd*fd*g2*r**2 - 10080*D1*Dd*fd*g2*r*s + 5040*D1*Dd*fd*g2*r + 1260*D1*Dd*fd*g2*s + 1800*D1*Ddd*K*f**2*r**2 + 1800*D1*Ddd*K*f**2*r*s - 1800*D1*Ddd*K*f**2*r - 450*D1*Ddd*K*f**2*s + 450*D1*Ddd*K*f**2 - 420*D1*Ddd*f**3*r**2 - 420*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r + 105*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 - 720*D1*Ddd*f**2*r**2 - 720*D1*Ddd*f**2*r*s + 720*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 5040*D1*Ddd*f*g2*r**2 - 5040*D1*Ddd*f*g2*r*s + 5040*D1*Ddd*f*g2*r + 1260*D1*Ddd*f*g2*s - 1260*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(18*f**2*(2*r - 1)*(r + s - 1) + f*(-30*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (35*K - 14)*(2*r - 1)*(r + s - 1)) + 21*fd*(5*K - 2)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-35*K + 10*f + 14)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 5400*Dd**2*K*f**2*r**2 + 5400*Dd**2*K*f**2*r*s - 5400*Dd**2*K*f**2*r - 1350*Dd**2*K*f**2*s + 900*Dd**2*K*f**2 - 1260*Dd**2*f**3*r**2 - 1260*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r + 315*Dd**2*f**3*s - 210*Dd**2*f**3 - 2160*Dd**2*f**2*r**2 - 2160*Dd**2*f**2*r*s + 2160*Dd**2*f**2*r + 540*Dd**2*f**2*s - 360*Dd**2*f**2 - 15120*Dd**2*f*g2*r**2 - 15120*Dd**2*f*g2*r*s + 15120*Dd**2*f*g2*r + 3780*Dd**2*f*g2*s - 2520*Dd**2*f*g2))/(3465*d**2*k3**6) + 2*D1**2*Pk3*Pkd1*ct**2*k1**3*st**2*(D1*bd1*f*(D1*(f*s*(104*C - 63)*(r - 1) - fd*(108*C - 63)*(r*(4*s - 1) - 2*s + 1)) + Dd*f*(63 - 108*C)*(r*(8*s - 2) - 5*s + 2)) + b1*(D1*Dd*f*(f*(104*C - 63)*(r*(4*s - 2) - s) + fd*(63 - 108*C)*(8*r - 1)*(2*s - 1)) + D1*(D1*r*(2*s - 1)*(f*fd*(104*C - 63) + f*fdd*(63 - 108*C) + fd**2*(63 - 108*C)) - Ddd*f**2*(108*C - 63)*(r*(4*s - 2) - s)) + Dd**2*f**2*(63 - 108*C)*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(f*(72*C - 43)*(r*(4*s - 2) - s) - fd*(60*C - 35)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(f*fd*(72*C - 43)*(r*(3*s - 1) - s) - f*(12*C - 7)*(9*bdd1*s*(r - 1) + 5*fdd*r*(3*s - 1) - 5*fdd*s) - fd**2*(60*C - 35)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(35 - 60*C)*(r*(4*s - 2) - s)) + Dd**2*f**2*(35 - 60*C)*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**2*k1**3*(42*D1*b1*bd1*(2*C - 1)*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 42*b1**2*(2*C - 1)*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 9*b1*(14*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + D1**2*(f*(fd*(4*C*(15*r**2 + 76*r*s - 32*r + 3*s - 3) - 30*r**2 - 186*r*s + 81*r - 6*s + 6) + fdd*(-20*C*(5*r**2 + 16*r*s - 6*r + s - 1) + 50*r**2 + 198*r*s - 79*r + 10*s - 10)) + fd**2*(-20*C*(5*r**2 + 16*r*s - 6*r + s - 1) + 50*r**2 + 198*r*s - 79*r + 10*s - 10)) + D1*f*(Dd*(f*(2*C*(60*r**2 + 304*r*s - 182*r - 76*s + 15) - 60*r**2 - 372*r*s + 216*r + 93*s - 15) + fd*(-40*C*(20*r**2 + 64*r*s - 33*r - 6*s + 2) + 400*r**2 + 1584*r*s - 812*r - 158*s + 59)) + Ddd*f*(-10*C*(20*r**2 + r*(64*s - 42) - 16*s + 5) + 100*r**2 + 4*r*(99*s - 62) - 99*s + 25)) + Dd**2*f**2*(-20*C*(30*r**2 + r*(96*s - 63) - 24*s + 16) + 300*r**2 + 12*r*(99*s - 62) - 297*s + 198)) + f*(-126*D1**2*bd1**2*(2*C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 9*D1**2*bdd1*f*(10*C*(5*r**2 + 2*r*(8*s - 7) - 18*s + 7) - 25*r**2 + r*(70 - 99*s) + 109*s - 35) - 5*D1**2*(f*(fd*(C*(234*r**2 + 660*r*s - 376*r - 220*s + 78) - 117*r**2 - 399*r*s + 211*r + 133*s - 39) + fdd*(-2*C*(153*r**2 + 354*r*s - 220*r - 118*s + 51) + 153*r**2 + 429*r*s - 245*r - 143*s + 51)) + fd**2*(-4*C*(153*r**2 + 354*r*s - 220*r - 118*s + 59) + 306*r**2 + 858*r*s - 490*r - 286*s + 143)) - 9*D1*bd1*(D1*(f*(2*C*(15*r**2 + 76*r*s - 42*r - 82*s + 21) - 15*r**2 - 93*r*s + 42*r + 99*s - 21) + fd*(-20*C*(10*r**2 + 4*r*(8*s - 5) - 17*s + 9) + 100*r**2 + 396*r*s - 219*r - 208*s + 109)) + Dd*f*(-20*C*(20*r**2 + r*(64*s - 49) - 44*s + 25) + 200*r**2 + 264*r*(3*s - 2) - 535*s + 288)) - 5*D1*f*(Dd*(f*(C*(312*r**2 + r*(880*s - 596) - 220*s + 78) - 156*r**2 + r*(344 - 532*s) + 133*s - 39) + fd*(-4*C*(612*r**2 + r*(1416*s - 947) - 413*s + 228) + 1224*r**2 + 8*r*(429*s - 268) - 1001*s + 531)) + Ddd*f*(-2*C*(204*r**2 + r*(472*s - 338) - 118*s + 51) + 204*r**2 + 4*r*(143*s - 97) - 143*s + 51)) - 5*Dd**2*f**2*(-4*C*(306*r**2 + r*(708*s - 507) - 177*s + 118) + 612*r**2 + 12*r*(143*s - 97) - 429*s + 286)))/(315*d**2*k3**4) + 4*D1**2*Pk3*Pkd1*ct**2*k1*k2**4*st**4*(60*C*D1**2*b1*f*fd*r**2 + 60*C*D1**2*b1*f*fd*r*s - 30*C*D1**2*b1*f*fd*r - 156*C*D1**2*b1*f*fdd*r**2 - 156*C*D1**2*b1*f*fdd*r*s + 78*C*D1**2*b1*f*fdd*r - 156*C*D1**2*b1*fd**2*r**2 - 156*C*D1**2*b1*fd**2*r*s + 78*C*D1**2*b1*fd**2*r + 102*C*D1**2*f**2*fd*r**2 + 102*C*D1**2*f**2*fd*r*s - 102*C*D1**2*f**2*fd*r - 34*C*D1**2*f**2*fd*s + 34*C*D1**2*f**2*fd - 78*C*D1**2*f**2*fdd*r**2 - 78*C*D1**2*f**2*fdd*r*s + 78*C*D1**2*f**2*fdd*r + 26*C*D1**2*f**2*fdd*s - 26*C*D1**2*f**2*fdd - 156*C*D1**2*f*fd**2*r**2 - 156*C*D1**2*f*fd**2*r*s + 156*C*D1**2*f*fd**2*r + 52*C*D1**2*f*fd**2*s - 26*C*D1**2*f*fd**2 + 120*C*D1*Dd*b1*f**2*r**2 + 120*C*D1*Dd*b1*f**2*r*s - 120*C*D1*Dd*b1*f**2*r - 30*C*D1*Dd*b1*f**2*s + 30*C*D1*Dd*b1*f**2 - 1248*C*D1*Dd*b1*f*fd*r**2 - 1248*C*D1*Dd*b1*f*fd*r*s + 936*C*D1*Dd*b1*f*fd*r + 156*C*D1*Dd*b1*f*fd*s - 78*C*D1*Dd*b1*f*fd + 136*C*D1*Dd*f**3*r**2 + 136*C*D1*Dd*f**3*r*s - 136*C*D1*Dd*f**3*r - 34*C*D1*Dd*f**3*s + 34*C*D1*Dd*f**3 - 624*C*D1*Dd*f**2*fd*r**2 - 624*C*D1*Dd*f**2*fd*r*s + 624*C*D1*Dd*f**2*fd*r + 182*C*D1*Dd*f**2*fd*s - 130*C*D1*Dd*f**2*fd - 312*C*D1*Ddd*b1*f**2*r**2 - 312*C*D1*Ddd*b1*f**2*r*s + 312*C*D1*Ddd*b1*f**2*r + 78*C*D1*Ddd*b1*f**2*s - 78*C*D1*Ddd*b1*f**2 - 104*C*D1*Ddd*f**3*r**2 - 104*C*D1*Ddd*f**3*r*s + 104*C*D1*Ddd*f**3*r + 26*C*D1*Ddd*f**3*s - 26*C*D1*Ddd*f**3 - 936*C*Dd**2*b1*f**2*r**2 - 936*C*Dd**2*b1*f**2*r*s + 936*C*Dd**2*b1*f**2*r + 234*C*Dd**2*b1*f**2*s - 156*C*Dd**2*b1*f**2 - 312*C*Dd**2*f**3*r**2 - 312*C*Dd**2*f**3*r*s + 312*C*Dd**2*f**3*r + 78*C*Dd**2*f**3*s - 52*C*Dd**2*f**3 - 42*D1**2*b1*f*fd*r**2 - 42*D1**2*b1*f*fd*r*s + 21*D1**2*b1*f*fd*r + 126*D1**2*b1*f*fdd*r**2 + 126*D1**2*b1*f*fdd*r*s - 63*D1**2*b1*f*fdd*r + 126*D1**2*b1*fd**2*r**2 + 126*D1**2*b1*fd**2*r*s - 63*D1**2*b1*fd**2*r - 3*D1**2*bdd1*f**2*(26*C - 21)*(r - 1)*(r + s - 1) - 81*D1**2*f**2*fd*r**2 - 81*D1**2*f**2*fd*r*s + 81*D1**2*f**2*fd*r + 27*D1**2*f**2*fd*s - 27*D1**2*f**2*fd + 63*D1**2*f**2*fdd*r**2 + 63*D1**2*f**2*fdd*r*s - 63*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd + 126*D1**2*f*fd**2*r**2 + 126*D1**2*f*fd**2*r*s - 126*D1**2*f*fd**2*r - 42*D1**2*f*fd**2*s + 21*D1**2*f*fd**2 - 84*D1*Dd*b1*f**2*r**2 - 84*D1*Dd*b1*f**2*r*s + 84*D1*Dd*b1*f**2*r + 21*D1*Dd*b1*f**2*s - 21*D1*Dd*b1*f**2 + 1008*D1*Dd*b1*f*fd*r**2 + 1008*D1*Dd*b1*f*fd*r*s - 756*D1*Dd*b1*f*fd*r - 126*D1*Dd*b1*f*fd*s + 63*D1*Dd*b1*f*fd - 108*D1*Dd*f**3*r**2 - 108*D1*Dd*f**3*r*s + 108*D1*Dd*f**3*r + 27*D1*Dd*f**3*s - 27*D1*Dd*f**3 + 504*D1*Dd*f**2*fd*r**2 + 504*D1*Dd*f**2*fd*r*s - 504*D1*Dd*f**2*fd*r - 147*D1*Dd*f**2*fd*s + 105*D1*Dd*f**2*fd + 252*D1*Ddd*b1*f**2*r**2 + 252*D1*Ddd*b1*f**2*r*s - 252*D1*Ddd*b1*f**2*r - 63*D1*Ddd*b1*f**2*s + 63*D1*Ddd*b1*f**2 + 84*D1*Ddd*f**3*r**2 + 84*D1*Ddd*f**3*r*s - 84*D1*Ddd*f**3*r - 21*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(10*C - 7)*(r - 1)*(r + s - 1) - fd*(26*C - 21)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(26*C - 21)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 756*Dd**2*b1*f**2*r**2 + 756*Dd**2*b1*f**2*r*s - 756*Dd**2*b1*f**2*r - 189*Dd**2*b1*f**2*s + 126*Dd**2*b1*f**2 + 252*Dd**2*f**3*r**2 + 252*Dd**2*f**3*r*s - 252*Dd**2*f**3*r - 63*Dd**2*f**3*s + 42*Dd**2*f**3)/(105*d**2*k3**6) - 4*D1**2*Pk3*Pkd1*ct**2*k1*k2**4*st**2*(297*D1**2*K*bdd1*f**2*r**2 + 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*r - 33*D1**2*bd1**2*f*(2*r - 1)*(-21*K + 24*f + 14)*(r + s - 1) + 220*D1**2*bdd1*f**3*r**2 + 220*D1**2*bdd1*f**3*r*s - 880*D1**2*bdd1*f**3*r - 660*D1**2*bdd1*f**3*s + 660*D1**2*bdd1*f**3 - 198*D1**2*bdd1*f**2*r**2 - 198*D1**2*bdd1*f**2*r*s + 198*D1**2*bdd1*f**2*r - 1386*D1**2*bdd1*f*g2*r**2 - 1386*D1**2*bdd1*f*g2*r*s + 2772*D1**2*bdd1*f*g2*r + 1386*D1**2*bdd1*f*g2*s - 1386*D1**2*bdd1*f*g2 - 1380*D1**2*f**3*fd*r**2 - 1380*D1**2*f**3*fd*r*s + 1380*D1**2*f**3*fd*r + 345*D1**2*f**3*fd*s - 345*D1**2*f**3*fd + 1680*D1**2*f**3*fdd*r**2 + 1680*D1**2*f**3*fdd*r*s - 1680*D1**2*f**3*fdd*r - 420*D1**2*f**3*fdd*s + 420*D1**2*f**3*fdd + 5040*D1**2*f**2*fd**2*r**2 + 5040*D1**2*f**2*fd**2*r*s - 5040*D1**2*f**2*fd**2*r - 1260*D1**2*f**2*fd**2*s + 840*D1**2*f**2*fd**2 + 726*D1**2*f**2*gd2*r**2 + 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*r - 594*D1**2*f**2*gdd2*r**2 - 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*r + 1452*D1**2*f*fd*g2*r**2 + 1452*D1**2*f*fd*g2*r*s - 1452*D1**2*f*fd*g2*r - 726*D1**2*f*fd*g2*s + 726*D1**2*f*fd*g2 - 2376*D1**2*f*fd*gd2*r**2 - 2376*D1**2*f*fd*gd2*r*s + 2376*D1**2*f*fd*gd2*r + 594*D1**2*f*fd*gd2*s - 594*D1**2*f*fd*gd2 - 1188*D1**2*f*fdd*g2*r**2 - 1188*D1**2*f*fdd*g2*r*s + 1188*D1**2*f*fdd*g2*r + 594*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 1188*D1**2*fd**2*g2*r**2 - 1188*D1**2*fd**2*g2*r*s + 1188*D1**2*fd**2*g2*r + 594*D1**2*fd**2*g2*s - 1380*D1*Dd*f**4*r**2 - 1380*D1*Dd*f**4*r*s + 1380*D1*Dd*f**4*r + 345*D1*Dd*f**4*s - 345*D1*Dd*f**4 + 13440*D1*Dd*f**3*fd*r**2 + 13440*D1*Dd*f**3*fd*r*s - 13440*D1*Dd*f**3*fd*r - 3360*D1*Dd*f**3*fd*s + 2520*D1*Dd*f**3*fd + 2904*D1*Dd*f**2*g2*r**2 + 2904*D1*Dd*f**2*g2*r*s - 2904*D1*Dd*f**2*g2*r - 726*D1*Dd*f**2*g2*s + 726*D1*Dd*f**2*g2 - 4752*D1*Dd*f**2*gd2*r**2 - 4752*D1*Dd*f**2*gd2*r*s + 4752*D1*Dd*f**2*gd2*r + 594*D1*Dd*f**2*gd2*s - 594*D1*Dd*f**2*gd2 - 9504*D1*Dd*f*fd*g2*r**2 - 9504*D1*Dd*f*fd*g2*r*s + 9504*D1*Dd*f*fd*g2*r + 3564*D1*Dd*f*fd*g2*s - 2376*D1*Dd*f*fd*g2 + 1680*D1*Ddd*f**4*r**2 + 1680*D1*Ddd*f**4*r*s - 1680*D1*Ddd*f**4*r - 420*D1*Ddd*f**4*s + 420*D1*Ddd*f**4 - 2376*D1*Ddd*f**2*g2*r**2 - 2376*D1*Ddd*f**2*g2*r*s + 2376*D1*Ddd*f**2*g2*r + 594*D1*Ddd*f**2*g2*s - 594*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(f**3*(4*r - 39)*(r + s - 1) + f**2*(-20*fd*(6*r**2 + 6*r*(s - 2) - 7*s + 4) + r*(33*K - 22)*(r + s - 1)) - 3*f*(3*fd*(3*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) + 126*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-20*f**2*(8*r**2 + 4*r*(2*s - 5) - 13*s + 10) - 9*f*(3*K - 2)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 5040*Dd**2*f**4*r**2 + 5040*Dd**2*f**4*r*s - 5040*Dd**2*f**4*r - 1260*Dd**2*f**4*s + 840*Dd**2*f**4 - 7128*Dd**2*f**2*g2*r**2 - 7128*Dd**2*f**2*g2*r*s + 7128*Dd**2*f**2*g2*r + 1782*Dd**2*f**2*g2*s - 1188*Dd**2*f**2*g2 + 11*b1**2*(D1**2*r*(3*f*(13*fd - 24*fdd)*(2*r + 2*s - 1) - 72*fd**2*(2*r + 2*s - 1) - 7*fd*(3*K - 2)*(r + s) + 21*fdd*(3*K - 2)*(r + s)) + D1*(Dd*(39*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-72*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (14 - 21*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(3*K - 2)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-21*K + 24*f + 14)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-21*K + 24*f + 14)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-66*D1**2*K*f*fd*r**2 - 66*D1**2*K*f*fd*r*s + 66*D1**2*K*f*fd*r + 33*D1**2*K*f*fd*s - 33*D1**2*K*f*fd + 54*D1**2*K*f*fdd*r**2 + 54*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r - 27*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 54*D1**2*K*fd**2*r**2 + 54*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r - 27*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(2*r - 1)*(-21*K + 24*f + 14)*(r + s - 1) - 12*D1**2*f**2*fd*r**2 - 12*D1**2*f**2*fd*r*s - 27*D1**2*f**2*fd*r - 35*D1**2*f**2*fd*s + 35*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 60*D1**2*f**2*fdd*r*s + 40*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 120*D1**2*f*fd**2*r*s + 80*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 44*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 44*D1**2*f*fd*r - 22*D1**2*f*fd*s + 22*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r + 18*D1**2*f*fdd*s - 18*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r - 126*D1**2*f*gdd2*r**2 - 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*r - 36*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 36*D1**2*fd**2*r + 18*D1**2*fd**2*s + 42*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s - 252*D1**2*fd*gd2*r**2 - 252*D1**2*fd*gd2*r*s + 126*D1**2*fd*gd2*r - 126*D1**2*fdd*g2*r**2 - 126*D1**2*fdd*g2*r*s - 132*D1*Dd*K*f**2*r**2 - 132*D1*Dd*K*f**2*r*s + 132*D1*Dd*K*f**2*r + 33*D1*Dd*K*f**2*s - 33*D1*Dd*K*f**2 + 432*D1*Dd*K*f*fd*r**2 + 432*D1*Dd*K*f*fd*r*s - 432*D1*Dd*K*f*fd*r - 162*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd - 16*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r*s + 16*D1*Dd*f**3*r + 4*D1*Dd*f**3*s - 4*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 480*D1*Dd*f**2*fd*r*s - 240*D1*Dd*f**2*fd*r + 100*D1*Dd*f**2*fd*s - 80*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 88*D1*Dd*f**2*r - 22*D1*Dd*f**2*s + 22*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 288*D1*Dd*f*fd*r + 108*D1*Dd*f*fd*s - 72*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 42*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r + 126*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r + 126*D1*Dd*fd*g2*s + 108*D1*Ddd*K*f**2*r**2 + 108*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r - 27*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r**2 + 80*D1*Ddd*f**3*r*s - 80*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s + 20*D1*Ddd*f**3 - 72*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 72*D1*Ddd*f**2*r + 18*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 504*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 126*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + D1*bd1*(D1*(39*f**2*(2*r - 1)*(r + s - 1) + f*(-72*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (21*K - 14)*(2*r - 1)*(r + s - 1)) + 21*fd*(3*K - 2)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-21*K + 24*f + 14)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 324*Dd**2*K*f**2*r**2 + 324*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r - 81*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 + 240*Dd**2*f**3*r**2 + 240*Dd**2*f**3*r*s - 240*Dd**2*f**3*r - 60*Dd**2*f**3*s + 40*Dd**2*f**3 - 216*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 216*Dd**2*f**2*r + 54*Dd**2*f**2*s - 36*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 1512*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 378*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(1155*d**2*k3**6) + 2*D1**2*Pk3*Pkd1*ct**2*k1*k2**2*st**4*(3*D1*bd1*f*(D1*(f*s*(20*C - 17)*(r - 1) - fd*(24*C - 19)*(r*(4*s - 1) - 2*s + 1)) - Dd*f*(24*C - 19)*(r*(8*s - 2) - 5*s + 2)) - 3*b1*(D1*Dd*f*(-f*(20*C - 17)*(r*(4*s - 2) - s) + fd*(24*C - 19)*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(20*C - 17) + f*fdd*(19 - 24*C) + fd**2*(19 - 24*C)) + Ddd*f**2*(24*C - 19)*(r*(4*s - 2) - s)) + Dd**2*f**2*(24*C - 19)*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(f*(36*C - 29)*(r*(4*s - 2) - s) - fd*(24*C - 19)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(f*fd*(36*C - 29)*(r*(3*s - 1) - s) - f*(24*C - 19)*(3*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) - fd**2*(24*C - 19)*(r*(6*s - 2) - 2*s + 1)) - Ddd*f**2*(24*C - 19)*(r*(4*s - 2) - s)) - Dd**2*f**2*(24*C - 19)*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k3**4) - 2*D1**2*Pk3*Pkd1*ct**2*k1*k2**2*st**2*(7*b1**2*(D1**2*r*(fd*(2*C - 3) + fdd*(14*C - 11))*(r + s - 1) + D1*(Dd*(f*(2*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(14*C - 11)*(8*r**2 + 8*r*(s - 1) - s + 1)) + Ddd*f*(14*C - 11)*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd**2*f*(14*C - 11)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(238*C*D1**2*f*fd*r**2 + 384*C*D1**2*f*fd*r*s - 108*C*D1**2*f*fd*r + 42*C*D1**2*f*fd*s - 42*C*D1**2*f*fd - 644*C*D1**2*f*fdd*r**2 - 696*C*D1**2*f*fdd*r*s + 264*C*D1**2*f*fdd*r - 42*C*D1**2*f*fdd*s + 42*C*D1**2*f*fdd - 644*C*D1**2*fd**2*r**2 - 696*C*D1**2*fd**2*r*s + 264*C*D1**2*fd**2*r - 42*C*D1**2*fd**2*s + 42*C*D1**2*fd**2 + 476*C*D1*Dd*f**2*r**2 + 768*C*D1*Dd*f**2*r*s - 622*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s + 119*C*D1*Dd*f**2 - 5152*C*D1*Dd*f*fd*r**2 - 5568*C*D1*Dd*f*fd*r*s + 3736*C*D1*Dd*f*fd*r + 528*C*D1*Dd*f*fd*s - 180*C*D1*Dd*f*fd - 1288*C*D1*Ddd*f**2*r**2 - 1392*C*D1*Ddd*f**2*r*s + 1340*C*D1*Ddd*f**2*r + 348*C*D1*Ddd*f**2*s - 322*C*D1*Ddd*f**2 - 3864*C*Dd**2*f**2*r**2 - 4176*C*Dd**2*f**2*r*s + 4020*C*Dd**2*f**2*r + 1044*C*Dd**2*f**2*s - 696*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(14*C - 11)*(2*r**2 + 2*r*(s - 1) - s + 1) - 198*D1**2*f*fd*r**2 - 290*D1**2*f*fd*r*s + 83*D1**2*f*fd*r - 31*D1**2*f*fd*s + 31*D1**2*f*fd + 470*D1**2*f*fdd*r**2 + 558*D1**2*f*fdd*r*s - 213*D1**2*f*fdd*r + 33*D1**2*f*fdd*s - 33*D1**2*f*fdd + 470*D1**2*fd**2*r**2 + 558*D1**2*fd**2*r*s - 213*D1**2*fd**2*r + 33*D1**2*fd**2*s - 33*D1**2*fd**2 - 396*D1*Dd*f**2*r**2 - 580*D1*Dd*f**2*r*s + 488*D1*Dd*f**2*r + 145*D1*Dd*f**2*s - 99*D1*Dd*f**2 + 3760*D1*Dd*f*fd*r**2 + 4464*D1*Dd*f*fd*r*s - 2908*D1*Dd*f*fd*r - 426*D1*Dd*f*fd*s + 147*D1*Dd*f*fd + 940*D1*Ddd*f**2*r**2 + 1116*D1*Ddd*f**2*r*s - 1028*D1*Ddd*f**2*r - 279*D1*Ddd*f**2*s + 235*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(2*C - 3)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd*(14*C - 11)*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*f*(28*C - 22)*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 2820*Dd**2*f**2*r**2 + 3348*Dd**2*f**2*r*s - 3084*Dd**2*f**2*r - 837*Dd**2*f**2*s + 558*Dd**2*f**2) + f*(663*C*D1**2*f*fd*r**2 + 438*C*D1**2*f*fd*r*s - 588*C*D1**2*f*fd*r - 146*C*D1**2*f*fd*s + 221*C*D1**2*f*fd - 696*C*D1**2*f*fdd*r**2 - 570*C*D1**2*f*fdd*r*s + 654*C*D1**2*f*fdd*r + 190*C*D1**2*f*fdd*s - 232*C*D1**2*f*fdd - 1392*C*D1**2*fd**2*r**2 - 1140*C*D1**2*fd**2*r*s + 1308*C*D1**2*fd**2*r + 380*C*D1**2*fd**2*s - 190*C*D1**2*fd**2 + 884*C*D1*Dd*f**2*r**2 + 584*C*D1*Dd*f**2*r*s - 734*C*D1*Dd*f**2*r - 146*C*D1*Dd*f**2*s + 221*C*D1*Dd*f**2 - 5568*C*D1*Dd*f*fd*r**2 - 4560*C*D1*Dd*f*fd*r*s + 5148*C*D1*Dd*f*fd*r + 1330*C*D1*Dd*f*fd*s - 1034*C*D1*Dd*f*fd - 928*C*D1*Ddd*f**2*r**2 - 760*C*D1*Ddd*f**2*r*s + 844*C*D1*Ddd*f**2*r + 190*C*D1*Ddd*f**2*s - 232*C*D1*Ddd*f**2 - 2784*C*Dd**2*f**2*r**2 - 2280*C*Dd**2*f**2*r*s + 2532*C*Dd**2*f**2*r + 570*C*Dd**2*f**2*s - 380*C*Dd**2*f**2 + 7*D1**2*bd1**2*(14*C - 11)*(2*r**2 + 2*r*(s - 1) - s) + D1**2*bdd1*f*(C*(-322*r**2 + r*(728 - 348*s) + 390*s - 364) + 235*r**2 + r*(279*s - 536) - 312*s + 268) - 486*D1**2*f*fd*r**2 - 336*D1**2*f*fd*r*s + 436*D1**2*f*fd*r + 112*D1**2*f*fd*s - 162*D1**2*f*fd + 504*D1**2*f*fdd*r**2 + 456*D1**2*f*fdd*r*s - 488*D1**2*f*fdd*r - 152*D1**2*f*fdd*s + 168*D1**2*f*fdd + 1008*D1**2*fd**2*r**2 + 912*D1**2*fd**2*r*s - 976*D1**2*fd**2*r - 304*D1**2*fd**2*s + 152*D1**2*fd**2 - 648*D1*Dd*f**2*r**2 - 448*D1*Dd*f**2*r*s + 548*D1*Dd*f**2*r + 112*D1*Dd*f**2*s - 162*D1*Dd*f**2 + 4032*D1*Dd*f*fd*r**2 + 3648*D1*Dd*f*fd*r*s - 3872*D1*Dd*f*fd*r - 1064*D1*Dd*f*fd*s + 792*D1*Dd*f*fd + 672*D1*Ddd*f**2*r**2 + 608*D1*Ddd*f**2*r*s - 640*D1*Ddd*f**2*r - 152*D1*Ddd*f**2*s + 168*D1*Ddd*f**2 + D1*bd1*(D1*(f*(C*(119*r**2 + 192*r*s - 322*r - 234*s + 161) - 99*r**2 - 145*r*s + 260*r + 176*s - 130) + fd*(-2*C*(644*r**2 + 696*r*s - 860*r - 369*s + 195) + 940*r**2 + 1116*r*s - 1285*r - 591*s + 312)) + Dd*f*(-4*C*(644*r**2 + r*(696*s - 1063) - 477*s + 377) + 1880*r**2 + 4*r*(558*s - 793) - 1527*s + 1160)) + 2016*Dd**2*f**2*r**2 + 1824*Dd**2*f**2*r*s - 1920*Dd**2*f**2*r - 456*Dd**2*f**2*s + 304*Dd**2*f**2))/(105*d**2*k3**4) - D1**2*Pk3*Pkd1*ct**2*k1*k2**2*(-24948*D1**2*K*bd1**2*f*r**2 - 22176*D1**2*K*bd1**2*f*r*s + 44352*D1**2*K*bd1**2*f*r + 15246*D1**2*K*bd1**2*f*s - 15246*D1**2*K*bd1**2*f + 9504*D1**2*K*bd1*f**2*r**2 + 7722*D1**2*K*bd1*f**2*r*s - 7722*D1**2*K*bd1*f**2*r - 52272*D1**2*K*bd1*f*fd*r**2 - 40392*D1**2*K*bd1*f*fd*r*s + 46332*D1**2*K*bd1*f*fd*r + 10098*D1**2*K*bd1*f*fd*s - 10098*D1**2*K*bd1*f*fd - 13068*D1**2*K*bdd1*f**2*r**2 - 10098*D1**2*K*bdd1*f**2*r*s + 10098*D1**2*K*bdd1*f**2*r + 12870*D1**2*bd1**2*f**2*r**2 + 16434*D1**2*bd1**2*f**2*r*s - 24057*D1**2*bd1**2*f**2*r - 10197*D1**2*bd1**2*f**2*s + 9207*D1**2*bd1**2*f**2 + 16170*D1**2*bd1**2*f*r**2 + 18942*D1**2*bd1**2*f*r*s - 31185*D1**2*bd1**2*f*r - 12243*D1**2*bd1**2*f*s + 12243*D1**2*bd1**2*f - 27720*D1**2*bd1**2*g2*r**2 - 27720*D1**2*bd1**2*g2*r*s + 27720*D1**2*bd1**2*g2*r + 13860*D1**2*bd1**2*g2*s - 8316*D1**2*bd1*bd2*f*r**2 - 8316*D1**2*bd1*bd2*f*r*s + 12474*D1**2*bd1*bd2*f*r + 4158*D1**2*bd1*bd2*f*s - 4158*D1**2*bd1*bd2*f - 4290*D1**2*bd1*f**3*r**2 - 2200*D1**2*bd1*f**3*r*s + 4015*D1**2*bd1*f**3*r - 4455*D1**2*bd1*f**3*s + 1045*D1**2*bd1*f**3 + 33660*D1**2*bd1*f**2*fd*r**2 + 18480*D1**2*bd1*f**2*fd*r*s - 25850*D1**2*bd1*f**2*fd*r + 5830*D1**2*bd1*f**2*fd*s - 2145*D1**2*bd1*f**2*fd - 6039*D1**2*bd1*f**2*r**2 - 6039*D1**2*bd1*f**2*r*s + 6039*D1**2*bd1*f**2*r + 32868*D1**2*bd1*f*fd*r**2 + 32868*D1**2*bd1*f*fd*r*s - 32868*D1**2*bd1*f*fd*r - 8217*D1**2*bd1*f*fd*s + 8217*D1**2*bd1*f*fd - 8316*D1**2*bd1*f*g2*r**2 - 16632*D1**2*bd1*f*g2*r*s + 22176*D1**2*bd1*f*g2*r + 19404*D1**2*bd1*f*g2*s - 11088*D1**2*bd1*f*g2 + 49896*D1**2*bd1*f*gd2*r**2 + 44352*D1**2*bd1*f*gd2*r*s - 88704*D1**2*bd1*f*gd2*r - 30492*D1**2*bd1*f*gd2*s + 30492*D1**2*bd1*f*gd2 + 49896*D1**2*bd1*fd*g2*r**2 + 44352*D1**2*bd1*fd*g2*r*s - 49896*D1**2*bd1*fd*g2*r - 22176*D1**2*bd1*fd*g2*s + 1782*D1**2*bd2*f**2*r**2 + 1782*D1**2*bd2*f**2*r*s - 1782*D1**2*bd2*f**2*r - 11880*D1**2*bd2*f*fd*r**2 - 11880*D1**2*bd2*f*fd*r*s + 11880*D1**2*bd2*f*fd*r + 2970*D1**2*bd2*f*fd*s - 2970*D1**2*bd2*f*fd + 5610*D1**2*bdd1*f**3*r**2 + 3080*D1**2*bdd1*f**3*r*s - 4235*D1**2*bdd1*f**3*r + 4455*D1**2*bdd1*f**3*s - 1265*D1**2*bdd1*f**3 + 8217*D1**2*bdd1*f**2*r**2 + 8217*D1**2*bdd1*f**2*r*s - 8217*D1**2*bdd1*f**2*r + 24948*D1**2*bdd1*f*g2*r**2 + 22176*D1**2*bdd1*f*g2*r*s - 66528*D1**2*bdd1*f*g2*r - 30492*D1**2*bdd1*f*g2*s + 33264*D1**2*bdd1*f*g2 - 2970*D1**2*bdd2*f**2*r**2 - 2970*D1**2*bdd2*f**2*r*s + 2970*D1**2*bdd2*f**2*r + 4060*D1**2*f**3*fd*r**2 + 13860*D1**2*f**3*fd*r*s - 8960*D1**2*f**3*fd*r - 3465*D1**2*f**3*fd*s + 1015*D1**2*f**3*fd - 4340*D1**2*f**3*fdd*r**2 - 13860*D1**2*f**3*fdd*r*s + 9100*D1**2*f**3*fdd*r + 3465*D1**2*f**3*fdd*s - 1085*D1**2*f**3*fdd - 13020*D1**2*f**2*fd**2*r**2 - 41580*D1**2*f**2*fd**2*r*s + 27300*D1**2*f**2*fd**2*r + 10395*D1**2*f**2*fd**2*s - 6930*D1**2*f**2*fd**2 - 19008*D1**2*f**2*gd2*r**2 - 15444*D1**2*f**2*gd2*r*s + 15444*D1**2*f**2*gd2*r + 26136*D1**2*f**2*gdd2*r**2 + 20196*D1**2*f**2*gdd2*r*s - 20196*D1**2*f**2*gdd2*r - 38016*D1**2*f*fd*g2*r**2 - 30888*D1**2*f*fd*g2*r*s + 38016*D1**2*f*fd*g2*r + 15444*D1**2*f*fd*g2*s - 19008*D1**2*f*fd*g2 + 104544*D1**2*f*fd*gd2*r**2 + 80784*D1**2*f*fd*gd2*r*s - 92664*D1**2*f*fd*gd2*r - 20196*D1**2*f*fd*gd2*s + 20196*D1**2*f*fd*gd2 + 52272*D1**2*f*fdd*g2*r**2 + 40392*D1**2*f*fdd*g2*r*s - 52272*D1**2*f*fdd*g2*r - 20196*D1**2*f*fdd*g2*s + 26136*D1**2*f*fdd*g2 + 52272*D1**2*fd**2*g2*r**2 + 40392*D1**2*fd**2*g2*r*s - 52272*D1**2*fd**2*g2*r - 20196*D1**2*fd**2*g2*s - 104544*D1*Dd*K*bd1*f**2*r**2 - 80784*D1*Dd*K*bd1*f**2*r*s + 86724*D1*Dd*K*bd1*f**2*r + 10098*D1*Dd*K*bd1*f**2*s - 10098*D1*Dd*K*bd1*f**2 + 44880*D1*Dd*bd1*f**3*r**2 + 24640*D1*Dd*bd1*f**3*r*s - 34320*D1*Dd*bd1*f**3*r + 14740*D1*Dd*bd1*f**3*s - 4675*D1*Dd*bd1*f**3 + 65736*D1*Dd*bd1*f**2*r**2 + 65736*D1*Dd*bd1*f**2*r*s - 65736*D1*Dd*bd1*f**2*r - 8217*D1*Dd*bd1*f**2*s + 8217*D1*Dd*bd1*f**2 + 199584*D1*Dd*bd1*f*g2*r**2 + 177408*D1*Dd*bd1*f*g2*r*s - 360360*D1*Dd*bd1*f*g2*r - 144144*D1*Dd*bd1*f*g2*s + 127512*D1*Dd*bd1*f*g2 - 23760*D1*Dd*bd2*f**2*r**2 - 23760*D1*Dd*bd2*f**2*r*s + 23760*D1*Dd*bd2*f**2*r + 2970*D1*Dd*bd2*f**2*s - 2970*D1*Dd*bd2*f**2 + 4060*D1*Dd*f**4*r**2 + 13860*D1*Dd*f**4*r*s - 8960*D1*Dd*f**4*r - 3465*D1*Dd*f**4*s + 1015*D1*Dd*f**4 - 34720*D1*Dd*f**3*fd*r**2 - 110880*D1*Dd*f**3*fd*r*s + 72800*D1*Dd*f**3*fd*r + 27720*D1*Dd*f**3*fd*s - 16030*D1*Dd*f**3*fd - 76032*D1*Dd*f**2*g2*r**2 - 61776*D1*Dd*f**2*g2*r*s + 68904*D1*Dd*f**2*g2*r + 15444*D1*Dd*f**2*g2*s - 19008*D1*Dd*f**2*g2 + 209088*D1*Dd*f**2*gd2*r**2 + 161568*D1*Dd*f**2*gd2*r*s - 173448*D1*Dd*f**2*gd2*r - 20196*D1*Dd*f**2*gd2*s + 20196*D1*Dd*f**2*gd2 + 418176*D1*Dd*f*fd*g2*r**2 + 323136*D1*Dd*f*fd*g2*r*s - 394416*D1*Dd*f*fd*g2*r - 121176*D1*Dd*f*fd*g2*s + 92664*D1*Dd*f*fd*g2 - 4340*D1*Ddd*f**4*r**2 - 13860*D1*Ddd*f**4*r*s + 9100*D1*Ddd*f**4*r + 3465*D1*Ddd*f**4*s - 1085*D1*Ddd*f**4 + 104544*D1*Ddd*f**2*g2*r**2 + 80784*D1*Ddd*f**2*g2*r*s - 92664*D1*Ddd*f**2*g2*r - 20196*D1*Ddd*f**2*g2*s + 26136*D1*Ddd*f**2*g2 - 13020*Dd**2*f**4*r**2 - 41580*Dd**2*f**4*r*s + 27300*Dd**2*f**4*r + 10395*Dd**2*f**4*s - 6930*Dd**2*f**4 + 313632*Dd**2*f**2*g2*r**2 + 242352*Dd**2*f**2*g2*r*s - 277992*Dd**2*f**2*g2*r - 60588*Dd**2*f**2*g2*s + 40392*Dd**2*f**2*g2 + 462*b1**3*(2*D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + (15*K - 10)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-15*K + 6*f + 10)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-15*K + 6*f + 10)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1**2*(126*D1**2*K*fd*r**2 + 252*D1**2*K*fd*r*s + 84*D1**2*K*fd*r + 42*D1**2*K*fd*s - 42*D1**2*K*fd - 378*D1**2*K*fdd*r**2 - 336*D1**2*K*fdd*r*s - 252*D1**2*K*fdd*r - 126*D1**2*K*fdd*s + 126*D1**2*K*fdd - 14*D1**2*bdd1*(-15*K + 6*f + 10)*(3*r**2 + 3*r*(s - 1) - s + 1) - 234*D1**2*f*fd*r**2 - 450*D1**2*f*fd*r*s + 171*D1**2*f*fd*r - 36*D1**2*f*fd*s + 36*D1**2*f*fd + 390*D1**2*f*fdd*r**2 + 498*D1**2*f*fdd*r*s - 159*D1**2*f*fdd*r + 60*D1**2*f*fdd*s - 60*D1**2*f*fdd + 390*D1**2*fd**2*r**2 + 498*D1**2*fd**2*r*s - 159*D1**2*fd**2*r + 60*D1**2*fd**2*s - 60*D1**2*fd**2 - 105*D1**2*fd*r**2 - 189*D1**2*fd*r*s - 56*D1**2*fd*r - 28*D1**2*fd*s + 28*D1**2*fd + 245*D1**2*fdd*r**2 + 287*D1**2*fdd*r*s + 168*D1**2*fdd*r + 84*D1**2*fdd*s - 84*D1**2*fdd - 420*D1**2*gd2*r**2 - 420*D1**2*gd2*r*s + 420*D1**2*gd2*r - 420*D1**2*gdd2*r**2 - 420*D1**2*gdd2*r*s + 420*D1**2*gdd2*r + 504*D1*Dd*K*f*r**2 + 1008*D1*Dd*K*f*r*s - 756*D1*Dd*K*f*r - 252*D1*Dd*K*f*s + 126*D1*Dd*K*f - 3024*D1*Dd*K*fd*r**2 - 2688*D1*Dd*K*fd*r*s + 420*D1*Dd*K*fd*r - 168*D1*Dd*K*fd*s + 504*D1*Dd*K*fd - 468*D1*Dd*f**2*r**2 - 900*D1*Dd*f**2*r*s + 684*D1*Dd*f**2*r + 225*D1*Dd*f**2*s - 117*D1*Dd*f**2 + 3120*D1*Dd*f*fd*r**2 + 3984*D1*Dd*f*fd*r*s - 2412*D1*Dd*f*fd*r - 258*D1*Dd*f*fd*s + 39*D1*Dd*f*fd - 420*D1*Dd*f*r**2 - 756*D1*Dd*f*r*s + 588*D1*Dd*f*r + 189*D1*Dd*f*s - 105*D1*Dd*f + 1960*D1*Dd*fd*r**2 + 2296*D1*Dd*fd*r*s - 392*D1*Dd*fd*r + 49*D1*Dd*fd*s - 336*D1*Dd*fd - 1680*D1*Dd*g2*r**2 - 1680*D1*Dd*g2*r*s + 1680*D1*Dd*g2*r + 420*D1*Dd*g2*s - 420*D1*Dd*g2 - 3360*D1*Dd*gd2*r**2 - 3360*D1*Dd*gd2*r*s + 3360*D1*Dd*gd2*r + 420*D1*Dd*gd2*s - 420*D1*Dd*gd2 - 1512*D1*Ddd*K*f*r**2 - 1344*D1*Ddd*K*f*r*s + 1428*D1*Ddd*K*f*r + 336*D1*Ddd*K*f*s - 378*D1*Ddd*K*f + 780*D1*Ddd*f**2*r**2 + 996*D1*Ddd*f**2*r*s - 888*D1*Ddd*f**2*r - 249*D1*Ddd*f**2*s + 195*D1*Ddd*f**2 + 980*D1*Ddd*f*r**2 + 1148*D1*Ddd*f*r*s - 1064*D1*Ddd*f*r - 287*D1*Ddd*f*s + 245*D1*Ddd*f - 1680*D1*Ddd*g2*r**2 - 1680*D1*Ddd*g2*r*s + 1680*D1*Ddd*g2*r + 420*D1*Ddd*g2*s - 420*D1*Ddd*g2 + 14*D1*bd1*(D1*(f*(6*r**2 + 6*r*(s - 1) - 2*s + 2) - 6*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + (15*K - 10)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-15*K + 6*f + 10)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 4536*Dd**2*K*f*r**2 - 4032*Dd**2*K*f*r*s + 4284*Dd**2*K*f*r + 1008*Dd**2*K*f*s - 672*Dd**2*K*f + 2340*Dd**2*f**2*r**2 + 2988*Dd**2*f**2*r*s - 2664*Dd**2*f**2*r - 747*Dd**2*f**2*s + 498*Dd**2*f**2 + 2940*Dd**2*f*r**2 + 3444*Dd**2*f*r*s - 3192*Dd**2*f*r - 861*Dd**2*f*s + 574*Dd**2*f - 5040*Dd**2*g2*r**2 - 5040*Dd**2*g2*r*s + 5040*Dd**2*g2*r + 1260*Dd**2*g2*s - 840*Dd**2*g2) - 11*b1*(-1728*D1**2*K*f*fd*r**2 - 1404*D1**2*K*f*fd*r*s + 1728*D1**2*K*f*fd*r + 702*D1**2*K*f*fd*s - 864*D1**2*K*f*fd + 2376*D1**2*K*f*fdd*r**2 + 1836*D1**2*K*f*fdd*r*s - 2376*D1**2*K*f*fdd*r - 918*D1**2*K*f*fdd*s + 1188*D1**2*K*f*fdd + 2376*D1**2*K*fd**2*r**2 + 1836*D1**2*K*fd**2*r*s - 2376*D1**2*K*fd**2*r - 918*D1**2*K*fd**2*s - 126*D1**2*b2*fd*r**2 - 126*D1**2*b2*fd*r*s + 378*D1**2*b2*fdd*r**2 + 378*D1**2*b2*fdd*r*s + 42*D1**2*bd1**2*(-15*K + 6*f + 10)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 126*D1**2*bd2*f*r**2 - 126*D1**2*bd2*f*r*s + 126*D1**2*bd2*f*r + 756*D1**2*bd2*fd*r**2 + 756*D1**2*bd2*fd*r*s - 378*D1**2*bd2*fd*r - 3*D1**2*bdd1*(3*f**2*(130*r**2 + r*(166*s - 243) - 103*s + 85) - 7*f*(6*K*(18*r**2 + 16*r*(s - 2) - 11*s + 12) - 70*r**2 - 82*r*s + 135*r + 53*s - 47) - 420*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 378*D1**2*bdd2*f*r**2 + 378*D1**2*bdd2*f*r*s - 378*D1**2*bdd2*f*r + 1170*D1**2*f**2*fd*r**2 + 600*D1**2*f**2*fd*r*s - 815*D1**2*f**2*fd*r - 605*D1**2*f**2*fd*s + 485*D1**2*f**2*fd - 1530*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 1195*D1**2*f**2*fdd*r + 685*D1**2*f**2*fdd*s - 625*D1**2*f**2*fdd - 3060*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 2390*D1**2*f*fd**2*r + 1370*D1**2*f*fd**2*s - 755*D1**2*f*fd**2 + 1098*D1**2*f*fd*r**2 + 1098*D1**2*f*fd*r*s - 1098*D1**2*f*fd*r - 549*D1**2*f*fd*s + 549*D1**2*f*fd - 1494*D1**2*f*fdd*r**2 - 1494*D1**2*f*fdd*r*s + 1494*D1**2*f*fdd*r + 747*D1**2*f*fdd*s - 747*D1**2*f*fdd + 756*D1**2*f*gd2*r**2 + 1512*D1**2*f*gd2*r*s - 1512*D1**2*f*gd2*r - 2268*D1**2*f*gdd2*r**2 - 2016*D1**2*f*gdd2*r*s + 2016*D1**2*f*gdd2*r - 1494*D1**2*fd**2*r**2 - 1494*D1**2*fd**2*r*s + 1494*D1**2*fd**2*r + 747*D1**2*fd**2*s + 756*D1**2*fd*g2*r**2 + 1512*D1**2*fd*g2*r*s + 504*D1**2*fd*g2*r + 252*D1**2*fd*g2*s - 252*D1**2*fd*g2 - 4536*D1**2*fd*gd2*r**2 - 4032*D1**2*fd*gd2*r*s + 504*D1**2*fd*gd2*r - 756*D1**2*fd*gd2*s + 756*D1**2*fd*gd2 - 2268*D1**2*fdd*g2*r**2 - 2016*D1**2*fdd*g2*r*s - 1512*D1**2*fdd*g2*r - 756*D1**2*fdd*g2*s + 756*D1**2*fdd*g2 - 3456*D1*Dd*K*f**2*r**2 - 2808*D1*Dd*K*f**2*r*s + 3132*D1*Dd*K*f**2*r + 702*D1*Dd*K*f**2*s - 864*D1*Dd*K*f**2 + 19008*D1*Dd*K*f*fd*r**2 + 14688*D1*Dd*K*f*fd*r*s - 17928*D1*Dd*K*f*fd*r - 5508*D1*Dd*K*f*fd*s + 4212*D1*Dd*K*f*fd - 504*D1*Dd*b2*f*r**2 - 504*D1*Dd*b2*f*r*s + 504*D1*Dd*b2*f*r + 126*D1*Dd*b2*f*s - 126*D1*Dd*b2*f + 3024*D1*Dd*b2*fd*r**2 + 3024*D1*Dd*b2*fd*r*s - 1512*D1*Dd*b2*fd*r - 378*D1*Dd*b2*fd*s + 3024*D1*Dd*bd2*f*r**2 + 3024*D1*Dd*bd2*f*r*s - 3024*D1*Dd*bd2*f*r - 378*D1*Dd*bd2*f*s + 378*D1*Dd*bd2*f + 1560*D1*Dd*f**3*r**2 + 800*D1*Dd*f**3*r*s - 1180*D1*Dd*f**3*r - 200*D1*Dd*f**3*s + 390*D1*Dd*f**3 - 12240*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 9520*D1*Dd*f**2*fd*r + 3580*D1*Dd*f**2*fd*s - 2565*D1*Dd*f**2*fd + 2196*D1*Dd*f**2*r**2 + 2196*D1*Dd*f**2*r*s - 2196*D1*Dd*f**2*r - 549*D1*Dd*f**2*s + 549*D1*Dd*f**2 - 11952*D1*Dd*f*fd*r**2 - 11952*D1*Dd*f*fd*r*s + 11952*D1*Dd*f*fd*r + 4482*D1*Dd*f*fd*s - 2988*D1*Dd*f*fd + 3024*D1*Dd*f*g2*r**2 + 6048*D1*Dd*f*g2*r*s - 4536*D1*Dd*f*g2*r - 1512*D1*Dd*f*g2*s + 756*D1*Dd*f*g2 - 18144*D1*Dd*f*gd2*r**2 - 16128*D1*Dd*f*gd2*r*s + 16632*D1*Dd*f*gd2*r + 2016*D1*Dd*f*gd2*s - 2016*D1*Dd*f*gd2 - 18144*D1*Dd*fd*g2*r**2 - 16128*D1*Dd*fd*g2*r*s + 2520*D1*Dd*fd*g2*r - 1008*D1*Dd*fd*g2*s + 3024*D1*Dd*fd*g2 + 4752*D1*Ddd*K*f**2*r**2 + 3672*D1*Ddd*K*f**2*r*s - 4212*D1*Ddd*K*f**2*r - 918*D1*Ddd*K*f**2*s + 1188*D1*Ddd*K*f**2 + 1512*D1*Ddd*b2*f*r**2 + 1512*D1*Ddd*b2*f*r*s - 1512*D1*Ddd*b2*f*r - 378*D1*Ddd*b2*f*s + 378*D1*Ddd*b2*f - 2040*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 1580*D1*Ddd*f**3*r + 280*D1*Ddd*f**3*s - 510*D1*Ddd*f**3 - 2988*D1*Ddd*f**2*r**2 - 2988*D1*Ddd*f**2*r*s + 2988*D1*Ddd*f**2*r + 747*D1*Ddd*f**2*s - 747*D1*Ddd*f**2 - 9072*D1*Ddd*f*g2*r**2 - 8064*D1*Ddd*f*g2*r*s + 8568*D1*Ddd*f*g2*r + 2016*D1*Ddd*f*g2*s - 2268*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(9*f**2*(26*r**2 + r*(50*s - 57) - 29*s + 17) + f*(-42*K*(6*r**2 + 2*r*(6*s - 7) - 7*s + 4) - 3*fd*(520*r**2 + 8*r*(83*s - 74) - 166*s + 93) + 210*r**2 + 378*r*s - 455*r - 217*s + 133) + 7*fd*(6*K*(36*r**2 + 4*r*(8*s - 5) - 5*s - 3) - 140*r**2 - 164*r*s + 87*r + 29*s + 12) + 420*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 420*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*(-3*f**2*(1040*r**2 + 4*r*(332*s - 391) - 578*s + 449) + 7*f*(12*K*(72*r**2 + 64*r*s - 98*r - 30*s + 27) - 560*r**2 - 656*r*s + 844*r + 294*s - 241) + 840*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + 14256*Dd**2*K*f**2*r**2 + 11016*Dd**2*K*f**2*r*s - 12636*Dd**2*K*f**2*r - 2754*Dd**2*K*f**2*s + 1836*Dd**2*K*f**2 + 4536*Dd**2*b2*f*r**2 + 4536*Dd**2*b2*f*r*s - 4536*Dd**2*b2*f*r - 1134*Dd**2*b2*f*s + 756*Dd**2*b2*f - 6120*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 4740*Dd**2*f**3*r + 840*Dd**2*f**3*s - 560*Dd**2*f**3 - 8964*Dd**2*f**2*r**2 - 8964*Dd**2*f**2*r*s + 8964*Dd**2*f**2*r + 2241*Dd**2*f**2*s - 1494*Dd**2*f**2 - 27216*Dd**2*f*g2*r**2 - 24192*Dd**2*f*g2*r*s + 25704*Dd**2*f*g2*r + 6048*Dd**2*f*g2*s - 4032*Dd**2*f*g2) + 198*b2*(-21*D1**2*bdd1*f*(r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 10*fd*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(3465*d**2*k3**4) + 2*D1**2*Pk3*Pkd1*ct**2*k1*st**2*(-7*b1**2*(4*C - 3)*(D1*Dd*(f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(-4*D1*Dd*f*(f*(4*C - 2)*(r*(4*s - 2) - s) - 9*fd*(2*s - 1)*(8*C*r + C - 4*r - 1)) - 7*D1*bd1*(4*C - 3)*(D1*(f*s*(1 - 2*r) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(f*fd*(-r*(16*C - 8)*(2*s - 1) + s*(33 - 44*C)) + 3*f*(-7*bdd1*s*(4*C - 3)*(2*r - 1) + fdd*r*(12*C - 6)*(2*s - 1) + fdd*s*(12*C - 9)) + 9*fd**2*(4*C*(2*r*s - r + s - 1) - 4*r*s + 2*r - 3*s + 3)) + Ddd*f**2*(36*C - 18)*(r*(4*s - 2) - s)) + Dd**2*f**2*(36*C - 18)*(6*r*(2*s - 1) - 3*s + 2)) + f*(-21*D1**2*bd1**2*s*(4*C - 3)*(2*r - 1) + D1*Dd*f*(-f*(44*C - 29)*(r*(4*s - 2) - s) + fd*(40*C - 25)*(2*r*(12*s - 5) - 7*s + 3)) + D1*bd1*(D1*(f*s*(C*(60 - 16*r) + 8*r - 41) + 9*fd*(4*C*(4*r*s - r - 3*s + 2) - 8*r*s + 2*r + 7*s - 5)) + 18*Dd*f*(2*C*(8*r*s - 2*r - 9*s + 4) - 8*r*s + 2*r + 11*s - 5)) + D1*(D1*(-f*fd*(44*C - 29)*(r*(3*s - 1) - s) + f*(9*bdd1*s*(4*C*(r - 2) - 2*r + 5) + fdd*(40*C - 25)*(r*(3*s - 1) - s)) + fd**2*(40*C - 25)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(40*C - 25)*(r*(4*s - 2) - s)) + Dd**2*f**2*(40*C - 25)*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k3**2) + D1**2*Pk3*Pkd1*ct**2*k1*(21*b1**2*(D1**2*r*(fd*(2*C*(r - 22*s + 22) - r + 33*s - 33) + fdd*(14*C*r + 52*C*(s - 1) - 7*r - 39*s + 39)) + D1*(Dd*(f*(2*C*(4*r**2 - 88*r*s + 42*r + 22*s + 1) - 4*r**2 + 132*r*s - 64*r - 33*s - 1) + fd*(4*C*(28*r**2 + 104*r*s - 85*r - 13*s + 13) - 56*r**2 - 312*r*s + 248*r + 39*s - 39)) + Ddd*f*(2*C*(28*r**2 + 104*r*s - 66*r - 26*s + 7) - 28*r**2 - 156*r*s + 92*r + 39*s - 7)) + Dd**2*f*(4*C*(42*r**2 + 3*r*(52*s - 33) - 39*s + 26) - 84*r**2 - 12*r*(39*s - 23) + 117*s - 78)) + 3*b1*(7*D1**2*bdd1*f*(2*C*(14*r**2 + 2*r*(26*s - 7) - 26*s + 7) - 14*r**2 + r*(14 - 78*s) + 39*s - 7) + 12*D1*Dd*f*(f*(4*C - 2)*(r*(4*s - 2) - s) + fd*(-C*(32*r*s + 44*r + 72*s - 51) + 16*r*s + 22*r + 55*s - 35)) + 7*D1*bd1*(D1*(f*(C*(4*r**2 - 88*r*s - 4*r + 44*s + 2) - 2*r**2 + 66*r*s + 2*r - 33*s - 1) + fd*(4*C*(14*r**2 + 52*r*s - 33*r - 13*s + 13) - 28*r**2 - 156*r*s + 92*r + 39*s - 39)) + 2*Dd*f*(2*C*(56*r**2 + 208*r*s - 94*r - 78*s + 33) - 56*r**2 - 312*r*s + 120*r + 117*s - 46)) + 3*D1*(D1*(f*(fd*(2*C*(2*r*(8*s + 5) + 34*s - 9) - 2*r*(8*s + 5) - 51*s + 9) + fdd*(-2*C*(r*(8*s + 26) + 38*s - 15) + r*(8*s + 26) + 57*s - 15)) + fd**2*(-4*C*(r*(4*s + 13) + 19*s - 19) + r*(8*s + 26) + 57*s - 57)) + Ddd*f**2*(4 - 8*C)*(r*(4*s - 2) - s)) + 3*Dd**2*f**2*(4 - 8*C)*(6*r*(2*s - 1) - 3*s + 2)) + f*(21*D1**2*bd1**2*(r**2*(28*C - 14) + 2*r*(2*C*(26*s - 7) - 39*s + 7) + s*(39 - 52*C)) - 9*D1**2*bdd1*f*(C*(r*(8*s - 60) - 84*s + 30) + r*(30 - 4*s) + 61*s - 15) + 5*D1**2*(f*(fd*(2*C*(57*r**2 + 162*r*s - 92*r - 54*s + 19) - 57*r**2 - 231*r*s + 115*r + 77*s - 19) + fdd*(-2*C*(69*r**2 + 2*r*(81*s - 50) - 54*s + 23) + 69*r**2 + 237*r*s - 125*r - 79*s + 23)) + fd**2*(-4*C*(69*r**2 + 2*r*(81*s - 50) - 54*s + 27) + 138*r**2 + 474*r*s - 250*r - 158*s + 79)) + 9*D1*bd1*(D1*(f*(2*C*(8*r*s - 18*r - 42*s + 9) - 8*r*s + 18*r + 59*s - 9) + fd*(C*(-32*r*s + 68*r + 92*s - 84) + 16*r*s - 34*r - 65*s + 61)) - 4*Dd*f*(C*(16*r*(s - 4) - 86*s + 57) - 8*r*(s - 4) + 62*s - 38)) + 5*D1*f*(Dd*(f*(2*C*(76*r**2 + 2*r*(108*s - 73) - 54*s + 19) - 76*r**2 - 4*r*(77*s - 48) + 77*s - 19) + fd*(-4*C*(276*r**2 + r*(648*s - 431) - 189*s + 104) + 552*r**2 + 8*r*(237*s - 139) - 553*s + 283)) + Ddd*f*(-2*C*(92*r**2 + 2*r*(108*s - 77) - 54*s + 23) + 92*r**2 + 4*r*(79*s - 51) - 79*s + 23)) + 5*Dd**2*f**2*(-12*C*(46*r**2 + r*(108*s - 77) - 27*s + 18) + 276*r**2 + 12*r*(79*s - 51) - 237*s + 158)))/(315*d**2*k3**2) - 2*D1**2*Pk3*Pkd1*ct**2*k2**4*st**4*(90*C*D1**2*b1*f*fd*r**2 - 66*C*D1**2*b1*f*fdd*r**2 - 66*C*D1**2*b1*fd**2*r**2 + 69*C*D1**2*f**2*fd*r**2 - 46*C*D1**2*f**2*fd*r + 23*C*D1**2*f**2*fd - 39*C*D1**2*f**2*fdd*r**2 + 26*C*D1**2*f**2*fdd*r - 13*C*D1**2*f**2*fdd - 78*C*D1**2*f*fd**2*r**2 + 52*C*D1**2*f*fd**2*r + 180*C*D1*Dd*b1*f**2*r**2 - 90*C*D1*Dd*b1*f**2*r + 45*C*D1*Dd*b1*f**2 - 528*C*D1*Dd*b1*f*fd*r**2 + 132*C*D1*Dd*b1*f*fd*r + 92*C*D1*Dd*f**3*r**2 - 46*C*D1*Dd*f**3*r + 23*C*D1*Dd*f**3 - 312*C*D1*Dd*f**2*fd*r**2 + 182*C*D1*Dd*f**2*fd*r - 26*C*D1*Dd*f**2*fd - 132*C*D1*Ddd*b1*f**2*r**2 + 66*C*D1*Ddd*b1*f**2*r - 33*C*D1*Ddd*b1*f**2 - 52*C*D1*Ddd*f**3*r**2 + 26*C*D1*Ddd*f**3*r - 13*C*D1*Ddd*f**3 - 396*C*Dd**2*b1*f**2*r**2 + 198*C*Dd**2*b1*f**2*r - 156*C*Dd**2*f**3*r**2 + 78*C*Dd**2*f**3*r - 108*D1**2*b1*f*fd*r**2 - 18*D1**2*b1*f*fd*r*s + 9*D1**2*b1*f*fd*r + 96*D1**2*b1*f*fdd*r**2 + 30*D1**2*b1*f*fdd*r*s - 15*D1**2*b1*f*fdd*r + 96*D1**2*b1*fd**2*r**2 + 30*D1**2*b1*fd**2*r*s - 15*D1**2*b1*fd**2*r - 3*D1**2*bdd1*f**2*(r - 1)*(11*C*(r - 1) - 16*r - 5*s + 16) - 90*D1**2*f**2*fd*r**2 - 21*D1**2*f**2*fd*r*s + 67*D1**2*f**2*fd*r + 7*D1**2*f**2*fd*s - 30*D1**2*f**2*fd + 54*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 41*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd*s + 18*D1**2*f**2*fdd + 108*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 82*D1**2*f*fd**2*r - 10*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 - 216*D1*Dd*b1*f**2*r**2 - 36*D1*Dd*b1*f**2*r*s + 126*D1*Dd*b1*f**2*r + 9*D1*Dd*b1*f**2*s - 54*D1*Dd*b1*f**2 + 768*D1*Dd*b1*f*fd*r**2 + 240*D1*Dd*b1*f*fd*r*s - 312*D1*Dd*b1*f*fd*r - 30*D1*Dd*b1*f*fd*s + 15*D1*Dd*b1*f*fd - 120*D1*Dd*f**3*r**2 - 28*D1*Dd*f**3*r*s + 74*D1*Dd*f**3*r + 7*D1*Dd*f**3*s - 30*D1*Dd*f**3 + 432*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 302*D1*Dd*f**2*fd*r - 35*D1*Dd*f**2*fd*s + 51*D1*Dd*f**2*fd + 192*D1*Ddd*b1*f**2*r**2 + 60*D1*Ddd*b1*f**2*r*s - 126*D1*Ddd*b1*f**2*r - 15*D1*Ddd*b1*f**2*s + 48*D1*Ddd*b1*f**2 + 72*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 46*D1*Ddd*f**3*r - 5*D1*Ddd*f**3*s + 18*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(3*f*(r - 1)*(5*C*(r - 1) - 6*r - s + 6) + fd*(r**2*(64 - 44*C) + r*(44*C + 20*s - 69) - 10*s + 5)) + Dd*f*(-22*C*(4*r**2 - 5*r + 1) + 128*r**2 + 40*r*s - 170*r - 25*s + 42)) + 576*Dd**2*b1*f**2*r**2 + 180*Dd**2*b1*f**2*r*s - 378*Dd**2*b1*f**2*r - 45*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 216*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 138*Dd**2*f**3*r - 15*Dd**2*f**3*s + 10*Dd**2*f**3)/(105*d**2*k1*k3**4) + D1**2*Pk3*Pkd1*ct**2*k2**4*st**2*(-66*D1**2*bd1**2*f*(2*f*(14*r**2 + r*(12*s - 17) - 6*s + 3) - 7*r**2*(2*K - 4) - 7*r*(-2*K - 2*s + 5) - 7*s + 7) + 22*D1**2*bdd1*f*(5*f**2*(5*r*(s - 2) - 9*s + 6) + f*r*(r*(11*K - 20) - 9*s + 9) - 42*g2*(r - 1)**2) + 2*D1**2*(-5*f**3*(5*fd*(60*r**2 + 44*r*s - 52*r - 11*s + 15) + fdd*(-216*r**2 - 220*r*s + 218*r + 55*s - 54)) + f**2*(5*fd**2*(648*r**2 + 660*r*s - 654*r - 165*s + 110) + r**2*(407*gd2 - 242*gdd2)) + 11*f*(37*fd*g2*(2*r**2 - 2*r + 1) + 44*fd*gd2*r*(1 - 2*r) - 22*fdd*g2*(2*r**2 - 2*r + 1)) - 484*fd**2*g2*r*(r - 1)) - 11*D1*bd1*(D1*(2*f**3*(r*(23*s - 55) - 45*s + 33) + f**2*(-10*fd*(30*r*(s - 1) - 23*s + 16) + r*(37*K*r - 59*r - 22*s + 22)) - 2*f*(fd*(r**2*(44*K - 80) + r*(-22*K - 36*s + 58) + 9*s - 9) + (7*r - 7)*(7*g2*(r - 1) - 12*gd2*r)) + 168*fd*g2*r*(r - 1)) - 2*Dd*f*(5*f**2*(10*r*(4*s - 5) - 41*s + 28) + f*(r**2*(88*K - 160) + r*(-22*K - 72*s + 94) + 9*s - 9) - 84*g2*(4*r**2 - 5*r + 1))) + 2*D1*f*(Dd*(-25*f**3*(60*r**2 + r*(44*s - 52) - 11*s + 15) + 40*f**2*fd*(4*r - 1)*(54*r + 55*s - 41) + 11*f*(37*g2*(4*r**2 - 2*r + 1) + 44*gd2*r*(1 - 4*r)) - 484*fd*g2*(8*r**2 - 6*r + 1)) + Ddd*f*(5*f**2*(216*r**2 + 220*r*s - 218*r - 55*s + 54) - 242*g2*(4*r**2 - 2*r + 1))) + 2*Dd**2*f**2*(5*f**2*(648*r**2 + 660*r*s - 654*r - 165*s + 110) + 1452*g2*r*(1 - 2*r)) + 11*b1**2*(D1**2*r*(6*f*(fd*(14*r + 20*s - 15) - 2*fdd*(14*r + 12*s - 9)) - 12*fd**2*(14*r + 12*s - 9) - 7*fd*r*(7*K - 9) + 14*fd*s + 42*fdd*r*(K - 2) - 42*fdd*s) + D1*(Dd*(6*f**2*(28*r**2 + r*(40*s - 34) - 10*s + 7) + f*(-49*K*(4*r**2 - 2*r + 1) - 12*fd*(112*r**2 + r*(96*s - 88) - 12*s + 9) + 252*r**2 + 56*r*s - 154*r - 14*s + 63) + 42*fd*(r**2*(8*K - 16) - 2*r*(K + 4*s - 3) + s)) - 6*Ddd*f*(-28*K*r**2 + 14*K*r - 7*K + 2*f*(28*r**2 + 24*r*s - 26*r - 6*s + 7) + 56*r**2 + 28*r*s - 42*r - 7*s + 14)) - 6*Dd**2*f*(12*f*(14*r**2 + r*(12*s - 13) - 3*s + 2) - 7*r**2*(12*K - 24) + 42*r*(K + 2*s - 3) - 21*s + 14)) + 11*b1*(-74*D1**2*K*f*fd*r**2 + 74*D1**2*K*f*fd*r - 37*D1**2*K*f*fd + 44*D1**2*K*f*fdd*r**2 - 44*D1**2*K*f*fdd*r + 22*D1**2*K*f*fdd + 44*D1**2*K*fd**2*r**2 - 44*D1**2*K*fd**2*r - 6*D1**2*bdd1*f*(-14*K*r**2 + 14*K*r - 7*K + 2*f*(14*r**2 + r*(12*s - 17) - 6*s + 7) + 28*r**2 + 14*r*s - 35*r - 7*s + 14) - 138*D1**2*f**2*fd*r*s - 18*D1**2*f**2*fd*r - 44*D1**2*f**2*fd*s + 66*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r*s + 40*D1**2*f**2*fdd*s - 60*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r*s + 80*D1**2*f*fd**2*s - 60*D1**2*f*fd**2 + 118*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 118*D1**2*f*fd*r - 22*D1**2*f*fd*s + 59*D1**2*f*fd - 80*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 80*D1**2*f*fdd*r + 18*D1**2*f*fdd*s - 40*D1**2*f*fdd + 98*D1**2*f*gd2*r**2 - 84*D1**2*f*gdd2*r**2 - 80*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 80*D1**2*fd**2*r + 18*D1**2*fd**2*s + 98*D1**2*fd*g2*r**2 - 168*D1**2*fd*gd2*r**2 - 84*D1**2*fdd*g2*r**2 - 148*D1*Dd*K*f**2*r**2 + 74*D1*Dd*K*f**2*r - 37*D1*Dd*K*f**2 + 352*D1*Dd*K*f*fd*r**2 - 264*D1*Dd*K*f*fd*r + 44*D1*Dd*K*f*fd - 184*D1*Dd*f**3*r*s + 92*D1*Dd*f**3*r + 46*D1*Dd*f**3*s + 1200*D1*Dd*f**2*fd*r*s - 300*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd*s - 80*D1*Dd*f**2*fd + 236*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 162*D1*Dd*f**2*r - 22*D1*Dd*f**2*s + 59*D1*Dd*f**2 - 640*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 552*D1*Dd*f*fd*r + 108*D1*Dd*f*fd*s - 116*D1*Dd*f*fd + 392*D1*Dd*f*g2*r**2 - 196*D1*Dd*f*g2*r + 98*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 + 168*D1*Dd*f*gd2*r - 672*D1*Dd*fd*g2*r**2 + 168*D1*Dd*fd*g2*r + 88*D1*Ddd*K*f**2*r**2 - 44*D1*Ddd*K*f**2*r + 22*D1*Ddd*K*f**2 + 200*D1*Ddd*f**3*r*s - 100*D1*Ddd*f**3*r - 50*D1*Ddd*f**3*s - 160*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 116*D1*Ddd*f**2*r + 18*D1*Ddd*f**2*s - 40*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 + 168*D1*Ddd*f*g2*r - 84*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(14*r**2 + r*(20*s - 19) - 10*s + 7) + f*(-49*K*(2*r**2 - 2*r + 1) - 12*fd*(56*r**2 + r*(48*s - 52) - 12*s + 9) + 126*r**2 + 28*r*(s - 5) - 14*s + 63) + 42*fd*(r**2*(4*K - 8) + r*(-2*K - 4*s + 5) + s)) - 6*Dd*f*(-14*K*(8*r**2 - 6*r + 1) + 2*f*(112*r**2 + 24*r*(4*s - 5) - 36*s + 29) + 224*r**2 + 112*r*(s - 2) - 42*s + 49)) + 264*Dd**2*K*f**2*r**2 - 132*Dd**2*K*f**2*r + 600*Dd**2*f**3*r*s - 300*Dd**2*f**3*r - 150*Dd**2*f**3*s + 100*Dd**2*f**3 - 480*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 348*Dd**2*f**2*r + 54*Dd**2*f**2*s - 36*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 + 504*Dd**2*f*g2*r))/(1155*d**2*k1*k3**4) + 2*D1**2*Pk3*Pkd1*ct**2*k2**2*st**4*(3*D1*bd1*f*(D1*(3*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 3*b1*(D1*Dd*f*(3*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(7*f*(4*r*s - 2*r - s) - 5*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(7*f*fd*(r*(3*s - 1) - s) + 5*f*(-3*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k1*k3**2) - 2*D1**2*Pk3*Pkd1*ct**2*k2**2*st**2*(7*b1**2*(C - 1)*(D1**2*r**2*(7*fd - 6*fdd) + D1*(7*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + b1*(110*C*D1**2*f*fd*r**2 - 74*C*D1**2*f*fd*r + 37*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 + 44*C*D1**2*f*fdd*r - 22*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 + 44*C*D1**2*fd**2*r + 220*C*D1*Dd*f**2*r**2 - 110*C*D1*Dd*f**2*r + 55*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 + 216*C*D1*Dd*f*fd*r - 44*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 + 20*C*D1*Ddd*f**2*r - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 + 60*C*Dd**2*f**2*r - 42*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 26*D1**2*f*fd*r**2 + 78*D1**2*f*fd*r*s + 35*D1**2*f*fd*r - 37*D1**2*f*fd - 22*D1**2*f*fdd*r**2 - 102*D1**2*f*fdd*r*s + 7*D1**2*f*fdd*r + 22*D1**2*f*fdd - 22*D1**2*fd**2*r**2 - 102*D1**2*fd**2*r*s + 7*D1**2*fd**2*r - 52*D1*Dd*f**2*r**2 + 156*D1*Dd*f**2*r*s - 52*D1*Dd*f**2*r - 39*D1*Dd*f**2*s - 13*D1*Dd*f**2 - 176*D1*Dd*f*fd*r**2 - 816*D1*Dd*f*fd*r*s + 276*D1*Dd*f*fd*r + 102*D1*Dd*f*fd*s - 7*D1*Dd*f*fd - 44*D1*Ddd*f**2*r**2 - 204*D1*Ddd*f**2*r*s + 124*D1*Ddd*f**2*r + 51*D1*Ddd*f**2*s - 11*D1*Ddd*f**2 + 7*D1*bd1*(C - 1)*(7*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) - 132*Dd**2*f**2*r**2 - 612*Dd**2*f**2*r*s + 372*Dd**2*f**2*r + 153*Dd**2*f**2*s - 102*Dd**2*f**2) - f*(66*C*D1**2*f*fd*r**2 - 44*C*D1**2*f*fd*r + 22*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r**2 + 40*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd - 120*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r + 88*C*D1*Dd*f**2*r**2 - 44*C*D1*Dd*f**2*r + 22*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r**2 + 280*C*D1*Dd*f*fd*r - 40*C*D1*Dd*f*fd - 80*C*D1*Ddd*f**2*r**2 + 40*C*D1*Ddd*f**2*r - 20*C*D1*Ddd*f**2 - 240*C*Dd**2*f**2*r**2 + 120*C*Dd**2*f**2*r + 84*D1**2*bd1**2*r*(C - 1)*(r - 1) + D1**2*bdd1*f*(2*C*(5*r**2 + 12*r - 6) + 11*r**2 + 51*r*s - 66*r - 51*s + 33) - 120*D1**2*f*fd*r**2 - 57*D1**2*f*fd*r*s + 99*D1**2*f*fd*r + 19*D1**2*f*fd*s - 40*D1**2*f*fd + 87*D1**2*f*fdd*r**2 + 69*D1**2*f*fdd*r*s - 81*D1**2*f*fdd*r - 23*D1**2*f*fdd*s + 29*D1**2*f*fdd + 174*D1**2*fd**2*r**2 + 138*D1**2*fd**2*r*s - 162*D1**2*fd**2*r - 46*D1**2*fd**2*s + 23*D1**2*fd**2 - 160*D1*Dd*f**2*r**2 - 76*D1*Dd*f**2*r*s + 118*D1*Dd*f**2*r + 19*D1*Dd*f**2*s - 40*D1*Dd*f**2 + 696*D1*Dd*f*fd*r**2 + 552*D1*Dd*f*fd*r*s - 636*D1*Dd*f*fd*r - 161*D1*Dd*f*fd*s + 127*D1*Dd*f*fd + 116*D1*Ddd*f**2*r**2 + 92*D1*Ddd*f**2*r*s - 104*D1*Ddd*f**2*r - 23*D1*Ddd*f**2*s + 29*D1*Ddd*f**2 + D1*bd1*(D1*(f*(C*(-55*r**2 + 36*r - 18) + 13*r**2 - 39*r*s + 48*r + 39*s - 24) + fd*(r**2*(40*C + 44) + r*(4*C + 204*s - 139) - 102*s + 51)) + Dd*f*(4*C*(20*r**2 + 19*r - 6) + 88*r**2 + 408*r*s - 388*r - 255*s + 168)) + 348*Dd**2*f**2*r**2 + 276*Dd**2*f**2*r*s - 312*Dd**2*f**2*r - 69*Dd**2*f**2*s + 46*Dd**2*f**2))/(105*d**2*k1*k3**2) + D1**2*Pk3*Pkd1*ct**2*k2**2*(56*D1**2*K*bd1**2*f*r**2 + 14*D1**2*K*bd1**2*f*r + 9*D1**2*K*bd1*f**2*r**2 - 60*D1**2*K*bd1*f*fd*r**2 + 30*D1**2*K*bd1*f*fd*r - 15*D1**2*K*bdd1*f**2*r**2 + 60*D1**2*bd1**2*f**2*r**2 + 252*D1**2*bd1**2*f**2*r*s - 153*D1**2*bd1**2*f**2*r - 126*D1**2*bd1**2*f**2*s + 63*D1**2*bd1**2*f**2 + 14*D1**2*bd1**2*f*r**2 + 182*D1**2*bd1**2*f*r*s - 175*D1**2*bd1**2*f*r - 91*D1**2*bd1**2*f*s + 91*D1**2*bd1**2*f - 140*D1**2*bd1**2*g2*r**2 + 140*D1**2*bd1**2*g2*r - 14*D1**2*bd1*bd2*f*r**2 + 14*D1**2*bd1*bd2*f*r - 45*D1**2*bd1*f**3*r**2 - 90*D1**2*bd1*f**3*r*s + 45*D1**2*bd1*f**3*r + 270*D1**2*bd1*f**2*fd*r**2 + 540*D1**2*bd1*f**2*fd*r*s - 360*D1**2*bd1*f**2*fd*r - 90*D1**2*bd1*f**2*fd*s + 45*D1**2*bd1*f**2*fd - 42*D1**2*bd1*f**2*r**2 - 51*D1**2*bd1*f**2*r*s + 51*D1**2*bd1*f**2*r + 168*D1**2*bd1*f*fd*r**2 + 228*D1**2*bd1*f*fd*r*s - 198*D1**2*bd1*f*fd*r - 57*D1**2*bd1*f*fd*s + 57*D1**2*bd1*f*fd + 112*D1**2*bd1*f*g2*r**2 - 84*D1**2*bd1*f*g2*r + 42*D1**2*bd1*f*g2 - 112*D1**2*bd1*f*gd2*r**2 - 28*D1**2*bd1*f*gd2*r - 112*D1**2*bd1*fd*g2*r**2 + 112*D1**2*bd1*fd*g2*r + 9*D1**2*bd2*f**2*r**2 - 60*D1**2*bd2*f*fd*r**2 + 30*D1**2*bd2*f*fd*r + 45*D1**2*bdd1*f**3*r**2 + 90*D1**2*bdd1*f**3*r*s - 45*D1**2*bdd1*f**3*r + 42*D1**2*bdd1*f**2*r**2 + 57*D1**2*bdd1*f**2*r*s - 57*D1**2*bdd1*f**2*r - 56*D1**2*bdd1*f*g2*r**2 - 28*D1**2*bdd1*f*g2*r + 14*D1**2*bdd1*f*g2 - 15*D1**2*bdd2*f**2*r**2 - 18*D1**2*f**2*gd2*r**2 + 30*D1**2*f**2*gdd2*r**2 - 36*D1**2*f*fd*g2*r**2 + 36*D1**2*f*fd*g2*r - 18*D1**2*f*fd*g2 + 120*D1**2*f*fd*gd2*r**2 - 60*D1**2*f*fd*gd2*r + 60*D1**2*f*fdd*g2*r**2 - 60*D1**2*f*fdd*g2*r + 30*D1**2*f*fdd*g2 + 60*D1**2*fd**2*g2*r**2 - 60*D1**2*fd**2*g2*r - 120*D1*Dd*K*bd1*f**2*r**2 + 30*D1*Dd*K*bd1*f**2*r + 360*D1*Dd*bd1*f**3*r**2 + 720*D1*Dd*bd1*f**3*r*s - 450*D1*Dd*bd1*f**3*r - 90*D1*Dd*bd1*f**3*s + 45*D1*Dd*bd1*f**3 + 336*D1*Dd*bd1*f**2*r**2 + 456*D1*Dd*bd1*f**2*r*s - 426*D1*Dd*bd1*f**2*r - 57*D1*Dd*bd1*f**2*s + 57*D1*Dd*bd1*f**2 - 448*D1*Dd*bd1*f*g2*r**2 + 28*D1*Dd*bd1*f*g2 - 120*D1*Dd*bd2*f**2*r**2 + 30*D1*Dd*bd2*f**2*r - 72*D1*Dd*f**2*g2*r**2 + 36*D1*Dd*f**2*g2*r - 18*D1*Dd*f**2*g2 + 240*D1*Dd*f**2*gd2*r**2 - 60*D1*Dd*f**2*gd2*r + 480*D1*Dd*f*fd*g2*r**2 - 360*D1*Dd*f*fd*g2*r + 60*D1*Dd*f*fd*g2 + 120*D1*Ddd*f**2*g2*r**2 - 60*D1*Ddd*f**2*g2*r + 30*D1*Ddd*f**2*g2 + 360*Dd**2*f**2*g2*r**2 - 180*Dd**2*f**2*g2*r - 7*b1**3*(D1**2*r**2*(3*fd + fdd) + D1*Dd*(-5*K*(4*r**2 - 2*r + 1) + 3*f*(4*r**2 - 2*r + 1) + 8*fd*r**2 - 2*fd*r + 20*r**2 - 10*r + 5) + D1*Ddd*(-5*K + f + 5)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(2*r - 1)*(-5*K + f + 5)) + b1**2*(-56*D1**2*K*fd*r**2 + 70*D1**2*K*fd*r - 35*D1**2*K*fd + 28*D1**2*K*fdd*r**2 - 70*D1**2*K*fdd*r + 35*D1**2*K*fdd - 7*D1**2*bdd1*(-5*K + f + 5)*(3*r**2 - 2*r + 1) - 36*D1**2*f*fd*r**2 - 252*D1**2*f*fd*r*s + 171*D1**2*f*fd*r + 9*D1**2*f*fd + 60*D1**2*f*fdd*r**2 + 252*D1**2*f*fdd*r*s - 159*D1**2*f*fdd*r - 15*D1**2*f*fdd + 60*D1**2*fd**2*r**2 + 252*D1**2*fd**2*r*s - 159*D1**2*fd**2*r + 21*D1**2*fd*r**2 - 77*D1**2*fd*r*s - 70*D1**2*fd*r + 35*D1**2*fd + 7*D1**2*fdd*r**2 + 91*D1**2*fdd*r*s + 70*D1**2*fdd*r - 35*D1**2*fdd - 70*D1**2*gd2*r**2 - 70*D1**2*gdd2*r**2 - 224*D1*Dd*K*f*r**2 + 112*D1*Dd*K*f*r - 56*D1*Dd*K*f + 224*D1*Dd*K*fd*r**2 - 336*D1*Dd*K*fd*r + 70*D1*Dd*K*fd - 72*D1*Dd*f**2*r**2 - 504*D1*Dd*f**2*r*s + 288*D1*Dd*f**2*r + 126*D1*Dd*f**2*s - 18*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 + 2016*D1*Dd*f*fd*r*s - 1260*D1*Dd*f*fd*r - 252*D1*Dd*f*fd*s + 159*D1*Dd*f*fd + 84*D1*Dd*f*r**2 - 308*D1*Dd*f*r*s + 112*D1*Dd*f*r + 77*D1*Dd*f*s + 21*D1*Dd*f + 56*D1*Dd*fd*r**2 + 728*D1*Dd*fd*r*s + 84*D1*Dd*fd*r - 91*D1*Dd*fd*s - 70*D1*Dd*fd - 280*D1*Dd*g2*r**2 + 140*D1*Dd*g2*r - 70*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 + 140*D1*Dd*gd2*r + 112*D1*Ddd*K*f*r**2 - 56*D1*Ddd*K*f*r + 28*D1*Ddd*K*f + 120*D1*Ddd*f**2*r**2 + 504*D1*Ddd*f**2*r*s - 312*D1*Ddd*f**2*r - 126*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + 28*D1*Ddd*f*r**2 + 364*D1*Ddd*f*r*s - 196*D1*Ddd*f*r - 91*D1*Ddd*f*s + 7*D1*Ddd*f - 280*D1*Ddd*g2*r**2 + 140*D1*Ddd*g2*r - 70*D1*Ddd*g2 - 7*D1*bd1*(D1*(-5*K*(3*r**2 - 2*r + 1) + f*(9*r**2 - 6*r + 3) + 6*fd*r**2 - 2*fd*r + 15*r**2 - 10*r + 5) + 2*Dd*(-5*K + f + 5)*(12*r**2 - 7*r + 1)) + 336*Dd**2*K*f*r**2 - 168*Dd**2*K*f*r + 360*Dd**2*f**2*r**2 + 1512*Dd**2*f**2*r*s - 936*Dd**2*f**2*r - 378*Dd**2*f**2*s + 252*Dd**2*f**2 + 84*Dd**2*f*r**2 + 1092*Dd**2*f*r*s - 588*Dd**2*f*r - 273*Dd**2*f*s + 182*Dd**2*f - 840*Dd**2*g2*r**2 + 420*Dd**2*g2*r) - b1*(-18*D1**2*K*f*fd*r**2 + 18*D1**2*K*f*fd*r - 9*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 - 30*D1**2*K*f*fdd*r + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 - 30*D1**2*K*fd**2*r + 21*D1**2*b2*fd*r**2 + 7*D1**2*b2*fdd*r**2 + 14*D1**2*bd1**2*r*(3*r - 2)*(-5*K + f + 5) + 21*D1**2*bd2*f*r**2 + 14*D1**2*bd2*fd*r**2 - D1**2*bdd1*(3*f**2*(20*r**2 + r*(84*s - 51) - 42*s + 15) + 7*f*(K*(8*r**2 + 2*r - 1) + 2*r**2 + 26*r*s - 25*r - 13*s + 6) - 70*g2*(2*r**2 - 2*r + 1)) + 7*D1**2*bdd2*f*r**2 + 135*D1**2*f**2*fd*r**2 + 270*D1**2*f**2*fd*r*s - 225*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s + 45*D1**2*f**2*fd - 135*D1**2*f**2*fdd*r**2 - 270*D1**2*f**2*fdd*r*s + 225*D1**2*f**2*fdd*r + 90*D1**2*f**2*fdd*s - 45*D1**2*f**2*fdd - 270*D1**2*f*fd**2*r**2 - 540*D1**2*f*fd**2*r*s + 450*D1**2*f*fd**2*r + 180*D1**2*f*fd**2*s - 135*D1**2*f*fd**2 + 84*D1**2*f*fd*r**2 + 102*D1**2*f*fd*r*s - 84*D1**2*f*fd*r - 51*D1**2*f*fd*s + 42*D1**2*f*fd - 84*D1**2*f*fdd*r**2 - 114*D1**2*f*fdd*r*s + 84*D1**2*f*fdd*r + 57*D1**2*f*fdd*s - 42*D1**2*f*fdd - 112*D1**2*f*gd2*r**2 + 56*D1**2*f*gdd2*r**2 - 84*D1**2*fd**2*r**2 - 114*D1**2*fd**2*r*s + 84*D1**2*fd**2*r + 57*D1**2*fd**2*s - 112*D1**2*fd*g2*r**2 + 140*D1**2*fd*g2*r - 70*D1**2*fd*g2 + 112*D1**2*fd*gd2*r**2 - 140*D1**2*fd*gd2*r + 56*D1**2*fdd*g2*r**2 - 140*D1**2*fdd*g2*r + 70*D1**2*fdd*g2 - 36*D1*Dd*K*f**2*r**2 + 18*D1*Dd*K*f**2*r - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 - 180*D1*Dd*K*f*fd*r + 30*D1*Dd*K*f*fd + 84*D1*Dd*b2*f*r**2 - 42*D1*Dd*b2*f*r + 21*D1*Dd*b2*f + 56*D1*Dd*b2*fd*r**2 - 14*D1*Dd*b2*fd*r + 56*D1*Dd*bd2*f*r**2 - 14*D1*Dd*bd2*f*r + 180*D1*Dd*f**3*r**2 + 360*D1*Dd*f**3*r*s - 270*D1*Dd*f**3*r - 90*D1*Dd*f**3*s + 45*D1*Dd*f**3 - 1080*D1*Dd*f**2*fd*r**2 - 2160*D1*Dd*f**2*fd*r*s + 1710*D1*Dd*f**2*fd*r + 630*D1*Dd*f**2*fd*s - 405*D1*Dd*f**2*fd + 168*D1*Dd*f**2*r**2 + 204*D1*Dd*f**2*r*s - 186*D1*Dd*f**2*r - 51*D1*Dd*f**2*s + 42*D1*Dd*f**2 - 672*D1*Dd*f*fd*r**2 - 912*D1*Dd*f*fd*r*s + 732*D1*Dd*f*fd*r + 342*D1*Dd*f*fd*s - 198*D1*Dd*f*fd - 448*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r - 112*D1*Dd*f*g2 + 448*D1*Dd*f*gd2*r**2 - 112*D1*Dd*f*gd2*r + 448*D1*Dd*fd*g2*r**2 - 672*D1*Dd*fd*g2*r + 140*D1*Dd*fd*g2 + 60*D1*Ddd*K*f**2*r**2 - 30*D1*Ddd*K*f**2*r + 15*D1*Ddd*K*f**2 + 28*D1*Ddd*b2*f*r**2 - 14*D1*Ddd*b2*f*r + 7*D1*Ddd*b2*f - 180*D1*Ddd*f**3*r**2 - 360*D1*Ddd*f**3*r*s + 270*D1*Ddd*f**3*r + 90*D1*Ddd*f**3*s - 45*D1*Ddd*f**3 - 168*D1*Ddd*f**2*r**2 - 228*D1*Ddd*f**2*r*s + 198*D1*Ddd*f**2*r + 57*D1*Ddd*f**2*s - 42*D1*Ddd*f**2 + 224*D1*Ddd*f*g2*r**2 - 112*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2 + D1*bd1*(D1*(9*f**2*(4*r**2 + r*(28*s - 13) - 14*s + 3) + f*(7*K*(16*r**2 - 6*r + 3) - 3*fd*(80*r**2 + 16*r*(21*s - 13) - 84*s + 63) - 42*r**2 + 154*r*s - 105*r - 77*s + 14) + 7*fd*(r**2*(-16*K - 4) + r*(18*K - 52*s + 5) + 13*s) + 70*g2*(2*r**2 - 2*r + 1) + 140*gd2*r*(2*r - 1)) + Dd*(-3*f**2*(160*r**2 + r*(672*s - 412) - 252*s + 135) - 7*f*(K*(64*r**2 - 8*r - 2) + 16*r**2 + 52*r*(4*s - 3) - 78*s + 51) + 140*g2*(8*r**2 - 6*r + 1))) + 180*Dd**2*K*f**2*r**2 - 90*Dd**2*K*f**2*r + 84*Dd**2*b2*f*r**2 - 42*Dd**2*b2*f*r - 540*Dd**2*f**3*r**2 - 1080*Dd**2*f**3*r*s + 810*Dd**2*f**3*r + 270*Dd**2*f**3*s - 180*Dd**2*f**3 - 504*Dd**2*f**2*r**2 - 684*Dd**2*f**2*r*s + 594*Dd**2*f**2*r + 171*Dd**2*f**2*s - 114*Dd**2*f**2 + 672*Dd**2*f*g2*r**2 - 336*Dd**2*f*g2*r) - b2*(7*D1**2*bdd1*f*(r - 1)**2 - 3*D1**2*(f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) - 10*fd**2*r*(r - 1)) + 7*D1*bd1*(r - 1)*(3*D1*f*(r - 1) + 2*D1*fd*r + 2*Dd*f*(4*r - 1)) - 3*D1*f*(3*Dd*f*(4*r**2 - 2*r + 1) - 10*Dd*fd*(8*r**2 - 6*r + 1) - 5*Ddd*f*(4*r**2 - 2*r + 1)) - 90*Dd**2*f**2*r*(1 - 2*r)))/(105*d**2*k1*k3**2) + 2*D1**2*Pk3*Pkd1*ct**2*st**2*(D1*f*(21*D1*bd1**2*s*(1 - 2*r) + D1*bd1*(11*f*r*s + 9*fd*(-4*r*s + r + s)) - 9*D1*bdd1*f*r*s + 9*Dd*bd1*f*(r*(2 - 8*s) + s)) - 7*b1**2*(D1*Dd*(f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(D1*Dd*f*(11*f*(4*r*s - 2*r - s) - 9*fd*(8*r - 3)*(2*s - 1)) + 7*D1*bd1*(D1*(f*s*(2*r - 1) + 3*fd*(-4*r*s + 2*r + s - 1)) - 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(11*f*fd*(r*(2*s - 1) - s) + 3*f*(7*bdd1*s*(1 - 2*r) + 3*fdd*(-2*r*s + r + s)) + 9*fd**2*(-2*r*s + r + s - 1)) + 9*Ddd*f**2*(r*(2 - 4*s) + s)) - 9*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k1) + D1**2*Pk3*Pkd1*ct**2*(D1*f*(-7*D1*bd1**2*(r**2*(4*C - 2) + r*(-4*C - 26*s + 2) + 13*s) + 3*D1*bdd1*f*r*(r*(5 - 10*C) + 19*s) - 3*bd1*(D1*(f*r*(r*(3 - 6*C) + 17*s) + fd*(r**2*(40*C - 20) + r*(-20*C - 76*s + 29) + 19*s)) + Dd*f*(r**2*(80*C - 40) - 4*r*(5*C + 38*s - 12) + 19*s))) - 7*b1**2*(D1**2*r*(fd*r*(6*C - 3) + 11*fd*(s - 1) + fdd*(2*C*r - r - 13*s + 13)) + D1*(Dd*(f*(6*C*(4*r**2 - 2*r + 1) - 12*r**2 + 44*r*s - 16*r - 11*s - 3) + fd*(r**2*(16*C - 8) - 4*r*(C + 26*s - 20) + 13*s - 13)) + Ddd*f*(C*(8*r**2 - 4*r + 2) - 4*r**2 - 52*r*s + 28*r + 13*s - 1)) + Dd**2*f*(r**2*(24*C - 12) - 12*r*(C + 13*s - 7) + 39*s - 26)) + b1*(-7*D1**2*bdd1*f*(C*(4*r**2 - 4*r + 2) - 2*r**2 + r*(2 - 26*s) + 13*s - 1) + 3*D1**2*(f*(fd*(6*C*(2*r**2 - 2*r + 1) - 6*r**2 - 34*r*s + 23*r + 17*s - 3) + fdd*(-10*C*(2*r**2 - 2*r + 1) + 10*r**2 + 38*r*s - 29*r - 19*s + 5)) + fd**2*(r**2*(10 - 20*C) + r*(20*C + 38*s - 29) - 19*s + 19)) - 7*D1*bd1*(D1*(f*(6*C*(2*r**2 - 2*r + 1) - 6*r**2 + 22*r*s + 6*r - 11*s - 3) + fd*(r**2*(8*C - 4) - 4*r*(C + 13*s - 7) + 13*s - 13)) + 2*Dd*f*(2*C*(8*r**2 - 6*r + 1) - 8*r**2 - 104*r*s + 32*r + 39*s - 14)) + 3*D1*f*(Dd*(f*(6*C*(4*r**2 - 2*r + 1) - 12*r**2 + r*(40 - 68*s) + 17*s - 3) + fd*(-20*C*(8*r**2 - 6*r + 1) + 80*r**2 + 4*r*(76*s - 53) - 114*s + 67)) + Ddd*f*(-10*C*(4*r**2 - 2*r + 1) + 20*r**2 + r*(76*s - 48) - 19*s + 5)) + 3*Dd**2*f**2*(-r**2*(120*C - 60) + 12*r*(5*C + 19*s - 12) - 57*s + 38)))/(105*d**2*k1) - 2*D1**2*Pk3*Pkd1*ct*f*k2**5*st**4*(66*D1**2*b1*f*fd*r**2 - 33*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 11*D1**2*bdd1*f**2*(r - 1)**2 + 64*D1**2*f**2*fd*r**2 - 32*D1**2*f**2*fd*r + 16*D1**2*f**2*fd - 32*D1**2*f**2*fdd*r**2 + 16*D1**2*f**2*fdd*r - 8*D1**2*f**2*fdd - 96*D1**2*f*fd**2*r**2 + 48*D1**2*f*fd**2*r + 88*D1*Dd*b1*f**2*r**2 - 44*D1*Dd*b1*f**2*r + 22*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 + 66*D1*Dd*b1*f*fd*r + 64*D1*Dd*f**3*r**2 - 32*D1*Dd*f**3*r + 16*D1*Dd*f**3 - 256*D1*Dd*f**2*fd*r**2 + 128*D1*Dd*f**2*fd*r - 16*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 + 22*D1*Ddd*b1*f**2*r - 11*D1*Ddd*b1*f**2 - 32*D1*Ddd*f**3*r**2 + 16*D1*Ddd*f**3*r - 8*D1*Ddd*f**3 + 22*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 132*Dd**2*b1*f**2*r**2 + 66*Dd**2*b1*f**2*r - 96*Dd**2*f**3*r**2 + 48*Dd**2*f**3*r)/(231*d**2*k1**2*k3**4) + 8*D1**2*Pk3*Pkd1*ct*k1**4*k2*st**2*(18*C*D1**2*b1*f*fd*r**2 + 18*C*D1**2*b1*f*fd*r*s - 9*C*D1**2*b1*f*fd*r - 198*C*D1**2*b1*f*fdd*r**2 - 198*C*D1**2*b1*f*fdd*r*s + 99*C*D1**2*b1*f*fdd*r - 198*C*D1**2*b1*fd**2*r**2 - 198*C*D1**2*b1*fd**2*r*s + 99*C*D1**2*b1*fd**2*r + 87*C*D1**2*f**2*fd*r**2 + 87*C*D1**2*f**2*fd*r*s - 87*C*D1**2*f**2*fd*r - 29*C*D1**2*f**2*fd*s + 29*C*D1**2*f**2*fd - 165*C*D1**2*f**2*fdd*r**2 - 165*C*D1**2*f**2*fdd*r*s + 165*C*D1**2*f**2*fdd*r + 55*C*D1**2*f**2*fdd*s - 55*C*D1**2*f**2*fdd - 330*C*D1**2*f*fd**2*r**2 - 330*C*D1**2*f*fd**2*r*s + 330*C*D1**2*f*fd**2*r + 110*C*D1**2*f*fd**2*s - 55*C*D1**2*f*fd**2 + 36*C*D1*Dd*b1*f**2*r**2 + 36*C*D1*Dd*b1*f**2*r*s - 36*C*D1*Dd*b1*f**2*r - 9*C*D1*Dd*b1*f**2*s + 9*C*D1*Dd*b1*f**2 - 1584*C*D1*Dd*b1*f*fd*r**2 - 1584*C*D1*Dd*b1*f*fd*r*s + 1188*C*D1*Dd*b1*f*fd*r + 198*C*D1*Dd*b1*f*fd*s - 99*C*D1*Dd*b1*f*fd + 116*C*D1*Dd*f**3*r**2 + 116*C*D1*Dd*f**3*r*s - 116*C*D1*Dd*f**3*r - 29*C*D1*Dd*f**3*s + 29*C*D1*Dd*f**3 - 1320*C*D1*Dd*f**2*fd*r**2 - 1320*C*D1*Dd*f**2*fd*r*s + 1320*C*D1*Dd*f**2*fd*r + 385*C*D1*Dd*f**2*fd*s - 275*C*D1*Dd*f**2*fd - 396*C*D1*Ddd*b1*f**2*r**2 - 396*C*D1*Ddd*b1*f**2*r*s + 396*C*D1*Ddd*b1*f**2*r + 99*C*D1*Ddd*b1*f**2*s - 99*C*D1*Ddd*b1*f**2 - 220*C*D1*Ddd*f**3*r**2 - 220*C*D1*Ddd*f**3*r*s + 220*C*D1*Ddd*f**3*r + 55*C*D1*Ddd*f**3*s - 55*C*D1*Ddd*f**3 - 1188*C*Dd**2*b1*f**2*r**2 - 1188*C*Dd**2*b1*f**2*r*s + 1188*C*Dd**2*b1*f**2*r + 297*C*Dd**2*b1*f**2*s - 198*C*Dd**2*b1*f**2 - 660*C*Dd**2*f**3*r**2 - 660*C*Dd**2*f**3*r*s + 660*C*Dd**2*f**3*r + 165*C*Dd**2*f**3*s - 110*C*Dd**2*f**3 - 6*D1**2*b1*f*fd*r**2 - 6*D1**2*b1*f*fd*r*s + 3*D1**2*b1*f*fd*r + 108*D1**2*b1*f*fdd*r**2 + 108*D1**2*b1*f*fdd*r*s - 54*D1**2*b1*f*fdd*r + 108*D1**2*b1*fd**2*r**2 + 108*D1**2*b1*fd**2*r*s - 54*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(11*C - 6)*(r - 1)*(r + s - 1) - 45*D1**2*f**2*fd*r**2 - 45*D1**2*f**2*fd*r*s + 45*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r**2 + 90*D1**2*f**2*fdd*r*s - 90*D1**2*f**2*fdd*r - 30*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r**2 + 180*D1**2*f*fd**2*r*s - 180*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 - 12*D1*Dd*b1*f**2*r**2 - 12*D1*Dd*b1*f**2*r*s + 12*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2*s - 3*D1*Dd*b1*f**2 + 864*D1*Dd*b1*f*fd*r**2 + 864*D1*Dd*b1*f*fd*r*s - 648*D1*Dd*b1*f*fd*r - 108*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 60*D1*Dd*f**3*r**2 - 60*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r + 15*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r**2 + 720*D1*Dd*f**2*fd*r*s - 720*D1*Dd*f**2*fd*r - 210*D1*Dd*f**2*fd*s + 150*D1*Dd*f**2*fd + 216*D1*Ddd*b1*f**2*r**2 + 216*D1*Ddd*b1*f**2*r*s - 216*D1*Ddd*b1*f**2*r - 54*D1*Ddd*b1*f**2*s + 54*D1*Ddd*b1*f**2 + 120*D1*Ddd*f**3*r**2 + 120*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r - 30*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(3*C - 1)*(r - 1)*(r + s - 1) - fd*(33*C - 18)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(18 - 33*C)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 648*Dd**2*b1*f**2*r**2 + 648*Dd**2*b1*f**2*r*s - 648*Dd**2*b1*f**2*r - 162*Dd**2*b1*f**2*s + 108*Dd**2*b1*f**2 + 360*Dd**2*f**3*r**2 + 360*Dd**2*f**3*r*s - 360*Dd**2*f**3*r - 90*Dd**2*f**3*s + 60*Dd**2*f**3)/(315*d**2*k3**6) - 4*D1**2*Pk3*Pkd1*ct*k1**4*k2*(-9*D1**2*bd1**2*f*(2*r - 1)*(-35*K + 5*f + 7)*(r + s - 1) - 5*D1**2*bdd1*f*(f*r*(-45*K + 7*f + 9) + 126*g2*(r - 1))*(r + s - 1) + 90*D1**2*(f**2*r*(3*gd2 - 5*gdd2)*(r + s - 1) + f*(fd*(g2*(6*r**2 + 6*r*(s - 1) - 3*s + 3) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 5*fd**2*g2*(-2*r**2 - 2*r*(s - 1) + s)) + D1*bd1*(D1*(25*f**3*r*(r + s - 1) + f**2*(-35*fd*(6*r**2 + 6*r*(s - 1) - s + 1) - r*(135*K - 27)*(r + s - 1)) + 15*f*(3*fd*(5*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) - 630*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(7*f**2*(8*r**2 + 8*r*(s - 1) - s + 1) - 9*f*(5*K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 90*D1*f*(Dd*(f*(3*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) - 10*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 5*Ddd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 450*Dd**2*f**2*g2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 3*b1**2*(D1**2*r*(3*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 15*fd**2*(2*r + 2*s - 1) - 7*fd*(5*K - 1)*(r + s) + 21*fdd*(5*K - 1)*(r + s)) + D1*(Dd*(9*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-15*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (7 - 35*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(5*K - 1)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-35*K + 5*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-35*K + 5*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-270*D1**2*K*f*fd*r**2 - 270*D1**2*K*f*fd*r*s + 270*D1**2*K*f*fd*r + 135*D1**2*K*f*fd*s - 135*D1**2*K*f*fd + 450*D1**2*K*f*fdd*r**2 + 450*D1**2*K*f*fdd*r*s - 450*D1**2*K*f*fdd*r - 225*D1**2*K*f*fdd*s + 225*D1**2*K*f*fdd + 450*D1**2*K*fd**2*r**2 + 450*D1**2*K*fd**2*r*s - 450*D1**2*K*fd**2*r - 225*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*r - 1)*(-35*K + 5*f + 7)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 54*D1**2*f*fd*r**2 + 54*D1**2*f*fd*r*s - 54*D1**2*f*fd*r - 27*D1**2*f*fd*s + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 90*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r + 45*D1**2*f*fdd*s - 45*D1**2*f*fdd + 210*D1**2*f*gd2*r**2 + 210*D1**2*f*gd2*r*s - 210*D1**2*f*gd2*r - 630*D1**2*f*gdd2*r**2 - 630*D1**2*f*gdd2*r*s + 630*D1**2*f*gdd2*r - 90*D1**2*fd**2*r**2 - 90*D1**2*fd**2*r*s + 90*D1**2*fd**2*r + 45*D1**2*fd**2*s + 210*D1**2*fd*g2*r**2 + 210*D1**2*fd*g2*r*s - 1260*D1**2*fd*gd2*r**2 - 1260*D1**2*fd*gd2*r*s + 630*D1**2*fd*gd2*r - 630*D1**2*fdd*g2*r**2 - 630*D1**2*fdd*g2*r*s - 540*D1*Dd*K*f**2*r**2 - 540*D1*Dd*K*f**2*r*s + 540*D1*Dd*K*f**2*r + 135*D1*Dd*K*f**2*s - 135*D1*Dd*K*f**2 + 3600*D1*Dd*K*f*fd*r**2 + 3600*D1*Dd*K*f*fd*r*s - 3600*D1*Dd*K*f*fd*r - 1350*D1*Dd*K*f*fd*s + 900*D1*Dd*K*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 + 108*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r - 27*D1*Dd*f**2*s + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 720*D1*Dd*f*fd*r*s + 720*D1*Dd*f*fd*r + 270*D1*Dd*f*fd*s - 180*D1*Dd*f*fd + 840*D1*Dd*f*g2*r**2 + 840*D1*Dd*f*g2*r*s - 840*D1*Dd*f*g2*r - 210*D1*Dd*f*g2*s + 210*D1*Dd*f*g2 - 5040*D1*Dd*f*gd2*r**2 - 5040*D1*Dd*f*gd2*r*s + 5040*D1*Dd*f*gd2*r + 630*D1*Dd*f*gd2*s - 630*D1*Dd*f*gd2 - 5040*D1*Dd*fd*g2*r**2 - 5040*D1*Dd*fd*g2*r*s + 2520*D1*Dd*fd*g2*r + 630*D1*Dd*fd*g2*s + 900*D1*Ddd*K*f**2*r**2 + 900*D1*Ddd*K*f**2*r*s - 900*D1*Ddd*K*f**2*r - 225*D1*Ddd*K*f**2*s + 225*D1*Ddd*K*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 180*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r + 45*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 2520*D1*Ddd*f*g2*r**2 - 2520*D1*Ddd*f*g2*r*s + 2520*D1*Ddd*f*g2*r + 630*D1*Ddd*f*g2*s - 630*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(9*f**2*(2*r - 1)*(r + s - 1) + f*(-15*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (35*K - 7)*(2*r - 1)*(r + s - 1)) + 21*fd*(5*K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-35*K + 5*f + 7)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 2700*Dd**2*K*f**2*r**2 + 2700*Dd**2*K*f**2*r*s - 2700*Dd**2*K*f**2*r - 675*Dd**2*K*f**2*s + 450*Dd**2*K*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 540*Dd**2*f**2*r*s + 540*Dd**2*f**2*r + 135*Dd**2*f**2*s - 90*Dd**2*f**2 - 7560*Dd**2*f*g2*r**2 - 7560*Dd**2*f*g2*r*s + 7560*Dd**2*f*g2*r + 1890*Dd**2*f*g2*s - 1260*Dd**2*f*g2))/(315*d**2*k3**6) + D1**2*Pk3*Pkd1*ct*k1**4*st**2*(4*C - 2)*(D1*bd1*f*(D1*(11*f*s*(r - 1) - 9*fd*(4*r*s - r - 2*s + 1)) - 9*Dd*f*(r*(8*s - 2) - 5*s + 2)) + b1*(D1*Dd*f*(11*f*(4*r*s - 2*r - s) - 9*fd*(8*r - 1)*(2*s - 1)) + D1*(D1*r*(2*s - 1)*(11*f*fd - 9*f*fdd - 9*fd**2) + 9*Ddd*f**2*(-4*r*s + 2*r + s)) - 9*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(7*f*(4*r*s - 2*r - s) - 5*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(7*f*fd*(r*(3*s - 1) - s) + f*(-9*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k2*k3**4) - D1**2*Pk3*Pkd1*ct*k1**4*(4*C - 2)*(7*D1*bd1*f*(D1*(f*s*(r - 1) + fd*(-4*r*s + r + 2*s - 1)) + Dd*f*(r*(2 - 8*s) + 5*s - 2)) - 7*b1*(D1*Dd*f*(f*(-4*r*s + 2*r + s) + fd*(8*r - 1)*(2*s - 1)) + D1*(D1*r*(2*s - 1)*(f*(-fd + fdd) + fd**2) - Ddd*f**2*(r*(2 - 4*s) + s)) + Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(5*D1*Dd*f*(f*(4*r*s - 2*r - s) + fd*(-24*r*s + 10*r + 7*s - 3)) + D1*(D1*(5*f*fd*(r*(3*s - 1) - s) + f*(-7*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(35*d**2*k2*k3**4) + 8*D1**2*Pk3*Pkd1*ct*k1**2*k2**3*st**4*(6*C*D1**2*b1*f*fd*r**2 + 6*C*D1**2*b1*f*fd*r*s - 3*C*D1**2*b1*f*fd*r - 66*C*D1**2*b1*f*fdd*r**2 - 66*C*D1**2*b1*f*fdd*r*s + 33*C*D1**2*b1*f*fdd*r - 66*C*D1**2*b1*fd**2*r**2 - 66*C*D1**2*b1*fd**2*r*s + 33*C*D1**2*b1*fd**2*r + 39*C*D1**2*f**2*fd*r**2 + 39*C*D1**2*f**2*fd*r*s - 39*C*D1**2*f**2*fd*r - 13*C*D1**2*f**2*fd*s + 13*C*D1**2*f**2*fd - 33*C*D1**2*f**2*fdd*r**2 - 33*C*D1**2*f**2*fdd*r*s + 33*C*D1**2*f**2*fdd*r + 11*C*D1**2*f**2*fdd*s - 11*C*D1**2*f**2*fdd - 66*C*D1**2*f*fd**2*r**2 - 66*C*D1**2*f*fd**2*r*s + 66*C*D1**2*f*fd**2*r + 22*C*D1**2*f*fd**2*s - 11*C*D1**2*f*fd**2 + 12*C*D1*Dd*b1*f**2*r**2 + 12*C*D1*Dd*b1*f**2*r*s - 12*C*D1*Dd*b1*f**2*r - 3*C*D1*Dd*b1*f**2*s + 3*C*D1*Dd*b1*f**2 - 528*C*D1*Dd*b1*f*fd*r**2 - 528*C*D1*Dd*b1*f*fd*r*s + 396*C*D1*Dd*b1*f*fd*r + 66*C*D1*Dd*b1*f*fd*s - 33*C*D1*Dd*b1*f*fd + 52*C*D1*Dd*f**3*r**2 + 52*C*D1*Dd*f**3*r*s - 52*C*D1*Dd*f**3*r - 13*C*D1*Dd*f**3*s + 13*C*D1*Dd*f**3 - 264*C*D1*Dd*f**2*fd*r**2 - 264*C*D1*Dd*f**2*fd*r*s + 264*C*D1*Dd*f**2*fd*r + 77*C*D1*Dd*f**2*fd*s - 55*C*D1*Dd*f**2*fd - 132*C*D1*Ddd*b1*f**2*r**2 - 132*C*D1*Ddd*b1*f**2*r*s + 132*C*D1*Ddd*b1*f**2*r + 33*C*D1*Ddd*b1*f**2*s - 33*C*D1*Ddd*b1*f**2 - 44*C*D1*Ddd*f**3*r**2 - 44*C*D1*Ddd*f**3*r*s + 44*C*D1*Ddd*f**3*r + 11*C*D1*Ddd*f**3*s - 11*C*D1*Ddd*f**3 - 396*C*Dd**2*b1*f**2*r**2 - 396*C*Dd**2*b1*f**2*r*s + 396*C*Dd**2*b1*f**2*r + 99*C*Dd**2*b1*f**2*s - 66*C*Dd**2*b1*f**2 - 132*C*Dd**2*f**3*r**2 - 132*C*Dd**2*f**3*r*s + 132*C*Dd**2*f**3*r + 33*C*Dd**2*f**3*s - 22*C*Dd**2*f**3 + 42*D1**2*b1*f*fdd*r**2 + 42*D1**2*b1*f*fdd*r*s - 21*D1**2*b1*f*fdd*r + 42*D1**2*b1*fd**2*r**2 + 42*D1**2*b1*fd**2*r*s - 21*D1**2*b1*fd**2*r - 3*D1**2*bdd1*f**2*(11*C - 7)*(r - 1)*(r + s - 1) - 24*D1**2*f**2*fd*r**2 - 24*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r + 8*D1**2*f**2*fd*s - 8*D1**2*f**2*fd + 21*D1**2*f**2*fdd*r**2 + 21*D1**2*f**2*fdd*r*s - 21*D1**2*f**2*fdd*r - 7*D1**2*f**2*fdd*s + 7*D1**2*f**2*fdd + 42*D1**2*f*fd**2*r**2 + 42*D1**2*f*fd**2*r*s - 42*D1**2*f*fd**2*r - 14*D1**2*f*fd**2*s + 7*D1**2*f*fd**2 + 336*D1*Dd*b1*f*fd*r**2 + 336*D1*Dd*b1*f*fd*r*s - 252*D1*Dd*b1*f*fd*r - 42*D1*Dd*b1*f*fd*s + 21*D1*Dd*b1*f*fd - 32*D1*Dd*f**3*r**2 - 32*D1*Dd*f**3*r*s + 32*D1*Dd*f**3*r + 8*D1*Dd*f**3*s - 8*D1*Dd*f**3 + 168*D1*Dd*f**2*fd*r**2 + 168*D1*Dd*f**2*fd*r*s - 168*D1*Dd*f**2*fd*r - 49*D1*Dd*f**2*fd*s + 35*D1*Dd*f**2*fd + 84*D1*Ddd*b1*f**2*r**2 + 84*D1*Ddd*b1*f**2*r*s - 84*D1*Ddd*b1*f**2*r - 21*D1*Ddd*b1*f**2*s + 21*D1*Ddd*b1*f**2 + 28*D1*Ddd*f**3*r**2 + 28*D1*Ddd*f**3*r*s - 28*D1*Ddd*f**3*r - 7*D1*Ddd*f**3*s + 7*D1*Ddd*f**3 + 3*D1*bd1*f*(C*D1*(f*(r - 1)*(r + s - 1) - 11*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 11*C*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4) + 7*D1*fd*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 7*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 252*Dd**2*b1*f**2*r**2 + 252*Dd**2*b1*f**2*r*s - 252*Dd**2*b1*f**2*r - 63*Dd**2*b1*f**2*s + 42*Dd**2*b1*f**2 + 84*Dd**2*f**3*r**2 + 84*Dd**2*f**3*r*s - 84*Dd**2*f**3*r - 21*Dd**2*f**3*s + 14*Dd**2*f**3)/(105*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*ct*k1**2*k2**3*st**2*(-891*D1**2*K*bdd1*f**2*r**2 - 891*D1**2*K*bdd1*f**2*r*s + 891*D1**2*K*bdd1*f**2*r + 99*D1**2*bd1**2*f*(2*r - 1)*(-21*K + 18*f + 7)*(r + s - 1) + 330*D1**2*bdd1*f**3*r**2 + 330*D1**2*bdd1*f**3*r*s + 330*D1**2*bdd1*f**3*r + 660*D1**2*bdd1*f**3*s - 660*D1**2*bdd1*f**3 + 297*D1**2*bdd1*f**2*r**2 + 297*D1**2*bdd1*f**2*r*s - 297*D1**2*bdd1*f**2*r + 4158*D1**2*bdd1*f*g2*r**2 + 4158*D1**2*bdd1*f*g2*r*s - 8316*D1**2*bdd1*f*g2*r - 4158*D1**2*bdd1*f*g2*s + 4158*D1**2*bdd1*f*g2 + 1160*D1**2*f**3*fd*r**2 + 1160*D1**2*f**3*fd*r*s - 1160*D1**2*f**3*fd*r - 290*D1**2*f**3*fd*s + 290*D1**2*f**3*fd - 1680*D1**2*f**3*fdd*r**2 - 1680*D1**2*f**3*fdd*r*s + 1680*D1**2*f**3*fdd*r + 420*D1**2*f**3*fdd*s - 420*D1**2*f**3*fdd - 5040*D1**2*f**2*fd**2*r**2 - 5040*D1**2*f**2*fd**2*r*s + 5040*D1**2*f**2*fd**2*r + 1260*D1**2*f**2*fd**2*s - 840*D1**2*f**2*fd**2 - 2178*D1**2*f**2*gd2*r**2 - 2178*D1**2*f**2*gd2*r*s + 2178*D1**2*f**2*gd2*r + 1782*D1**2*f**2*gdd2*r**2 + 1782*D1**2*f**2*gdd2*r*s - 1782*D1**2*f**2*gdd2*r - 4356*D1**2*f*fd*g2*r**2 - 4356*D1**2*f*fd*g2*r*s + 4356*D1**2*f*fd*g2*r + 2178*D1**2*f*fd*g2*s - 2178*D1**2*f*fd*g2 + 7128*D1**2*f*fd*gd2*r**2 + 7128*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r - 1782*D1**2*f*fd*gd2*s + 1782*D1**2*f*fd*gd2 + 3564*D1**2*f*fdd*g2*r**2 + 3564*D1**2*f*fdd*g2*r*s - 3564*D1**2*f*fdd*g2*r - 1782*D1**2*f*fdd*g2*s + 1782*D1**2*f*fdd*g2 + 3564*D1**2*fd**2*g2*r**2 + 3564*D1**2*fd**2*g2*r*s - 3564*D1**2*fd**2*g2*r - 1782*D1**2*fd**2*g2*s + 1160*D1*Dd*f**4*r**2 + 1160*D1*Dd*f**4*r*s - 1160*D1*Dd*f**4*r - 290*D1*Dd*f**4*s + 290*D1*Dd*f**4 - 13440*D1*Dd*f**3*fd*r**2 - 13440*D1*Dd*f**3*fd*r*s + 13440*D1*Dd*f**3*fd*r + 3360*D1*Dd*f**3*fd*s - 2520*D1*Dd*f**3*fd - 8712*D1*Dd*f**2*g2*r**2 - 8712*D1*Dd*f**2*g2*r*s + 8712*D1*Dd*f**2*g2*r + 2178*D1*Dd*f**2*g2*s - 2178*D1*Dd*f**2*g2 + 14256*D1*Dd*f**2*gd2*r**2 + 14256*D1*Dd*f**2*gd2*r*s - 14256*D1*Dd*f**2*gd2*r - 1782*D1*Dd*f**2*gd2*s + 1782*D1*Dd*f**2*gd2 + 28512*D1*Dd*f*fd*g2*r**2 + 28512*D1*Dd*f*fd*g2*r*s - 28512*D1*Dd*f*fd*g2*r - 10692*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 1680*D1*Ddd*f**4*r**2 - 1680*D1*Ddd*f**4*r*s + 1680*D1*Ddd*f**4*r + 420*D1*Ddd*f**4*s - 420*D1*Ddd*f**4 + 7128*D1*Ddd*f**2*g2*r**2 + 7128*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r - 1782*D1*Ddd*f**2*g2*s + 1782*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(2*f**3*(7*r + 5)*(r + s - 1) + f**2*(-10*fd*(6*r**2 + r*(6*s - 2) + 3*s - 1) + r*(11 - 33*K)*(r + s - 1)) + 9*f*fd*(3*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + 42*f*(g2*(r - 1) + gd2*(3 - 6*r))*(r + s - 1) - 126*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - Dd*f*(10*f**2*(8*r**2 + 8*r*s + 7*s - 5) - 9*f*(3*K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 5040*Dd**2*f**4*r**2 - 5040*Dd**2*f**4*r*s + 5040*Dd**2*f**4*r + 1260*Dd**2*f**4*s - 840*Dd**2*f**4 + 21384*Dd**2*f**2*g2*r**2 + 21384*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r - 5346*Dd**2*f**2*g2*s + 3564*Dd**2*f**2*g2 - 33*b1**2*(D1**2*r*(6*f*(4*fd - 9*fdd)*(2*r + 2*s - 1) - 54*fd**2*(2*r + 2*s - 1) - 7*fd*(3*K - 1)*(r + s) + 21*fdd*(3*K - 1)*(r + s)) + D1*(Dd*(24*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-54*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (7 - 21*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(3*K - 1)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-21*K + 18*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-21*K + 18*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 33*b1*(-66*D1**2*K*f*fd*r**2 - 66*D1**2*K*f*fd*r*s + 66*D1**2*K*f*fd*r + 33*D1**2*K*f*fd*s - 33*D1**2*K*f*fd + 54*D1**2*K*f*fdd*r**2 + 54*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r - 27*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 54*D1**2*K*fd**2*r**2 + 54*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r - 27*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(2*r - 1)*(-21*K + 18*f + 7)*(r + s - 1) + 42*D1**2*f**2*fd*r**2 + 42*D1**2*f**2*fd*r*s - 52*D1**2*f**2*fd*r - 24*D1**2*f**2*fd*s + 24*D1**2*f**2*fd - 30*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 50*D1**2*f**2*fdd*r + 30*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd - 60*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 100*D1**2*f*fd**2*r + 60*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 22*D1**2*f*fd*r**2 + 22*D1**2*f*fd*r*s - 22*D1**2*f*fd*r - 11*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 18*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 9*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r - 126*D1**2*f*gdd2*r**2 - 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*r - 18*D1**2*fd**2*r**2 - 18*D1**2*fd**2*r*s + 18*D1**2*fd**2*r + 9*D1**2*fd**2*s + 42*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s - 252*D1**2*fd*gd2*r**2 - 252*D1**2*fd*gd2*r*s + 126*D1**2*fd*gd2*r - 126*D1**2*fdd*g2*r**2 - 126*D1**2*fdd*g2*r*s - 132*D1*Dd*K*f**2*r**2 - 132*D1*Dd*K*f**2*r*s + 132*D1*Dd*K*f**2*r + 33*D1*Dd*K*f**2*s - 33*D1*Dd*K*f**2 + 432*D1*Dd*K*f*fd*r**2 + 432*D1*Dd*K*f*fd*r*s - 432*D1*Dd*K*f*fd*r - 162*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd + 56*D1*Dd*f**3*r**2 + 56*D1*Dd*f**3*r*s - 56*D1*Dd*f**3*r - 14*D1*Dd*f**3*s + 14*D1*Dd*f**3 - 240*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 320*D1*Dd*f**2*fd*r + 150*D1*Dd*f**2*fd*s - 110*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 + 44*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r - 11*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 144*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r + 54*D1*Dd*f*fd*s - 36*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 42*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r + 126*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r + 126*D1*Dd*fd*g2*s + 108*D1*Ddd*K*f**2*r**2 + 108*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r - 27*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 - 40*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 40*D1*Ddd*f**3*r + 10*D1*Ddd*f**3*s - 10*D1*Ddd*f**3 - 36*D1*Ddd*f**2*r**2 - 36*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r + 9*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 504*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 126*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + D1*bd1*(D1*(24*f**2*(2*r - 1)*(r + s - 1) + f*(-54*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (21*K - 7)*(2*r - 1)*(r + s - 1)) + 21*fd*(3*K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-21*K + 18*f + 7)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 324*Dd**2*K*f**2*r**2 + 324*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r - 81*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 - 120*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 120*Dd**2*f**3*r + 30*Dd**2*f**3*s - 20*Dd**2*f**3 - 108*Dd**2*f**2*r**2 - 108*Dd**2*f**2*r*s + 108*Dd**2*f**2*r + 27*Dd**2*f**2*s - 18*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 1512*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 378*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(3465*d**2*k3**6) + 2*D1**2*Pk3*Pkd1*ct*k1**2*k2*st**4*(3*D1*bd1*f*(D1*(f*s*(22*C - 15)*(r - 1) - fd*(18*C - 11)*(4*r*s - r - 2*s + 1)) - Dd*f*(18*C - 11)*(r*(8*s - 2) - 5*s + 2)) - 3*b1*(D1*Dd*f*(-f*(22*C - 15)*(r*(4*s - 2) - s) + fd*(18*C - 11)*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(22*C - 15) + f*fdd*(11 - 18*C) + fd**2*(11 - 18*C)) + Ddd*f**2*(18*C - 11)*(r*(4*s - 2) - s)) + Dd**2*f**2*(18*C - 11)*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(f*(30*C - 19)*(r*(4*s - 2) - s) - fd*(18*C - 11)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(f*fd*(30*C - 19)*(r*(3*s - 1) - s) - f*(18*C - 11)*(3*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) - fd**2*(18*C - 11)*(r*(6*s - 2) - 2*s + 1)) - Ddd*f**2*(18*C - 11)*(r*(4*s - 2) - s)) - Dd**2*f**2*(18*C - 11)*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k3**4) - D1**2*Pk3*Pkd1*ct*k1**2*k2*st**2*(84*b1**2*(D1**2*r*(fd*(5*C - 4) + fdd*(5*C - 3))*(r + s - 1) + D1*(Dd*(f*(5*C - 4)*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(5*C - 3)*(8*r**2 + 8*r*(s - 1) - s + 1)) + Ddd*f*(5*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd**2*f*(5*C - 3)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1*(192*C*D1**2*f*fd*r**2 + 584*C*D1**2*f*fd*r*s - 220*C*D1**2*f*fd*r + 36*C*D1**2*f*fd*s - 36*C*D1**2*f*fd - 656*C*D1**2*f*fdd*r**2 - 936*C*D1**2*f*fdd*r*s + 348*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd - 656*C*D1**2*fd**2*r**2 - 936*C*D1**2*fd**2*r*s + 348*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s + 60*C*D1**2*fd**2 + 384*C*D1*Dd*f**2*r**2 + 1168*C*D1*Dd*f**2*r*s - 776*C*D1*Dd*f**2*r - 292*C*D1*Dd*f**2*s + 96*C*D1*Dd*f**2 - 5248*C*D1*Dd*f*fd*r**2 - 7488*C*D1*Dd*f*fd*r*s + 4576*C*D1*Dd*f*fd*r + 696*C*D1*Dd*f*fd*s - 228*C*D1*Dd*f*fd - 1312*C*D1*Ddd*f**2*r**2 - 1872*C*D1*Ddd*f**2*r*s + 1592*C*D1*Ddd*f**2*r + 468*C*D1*Ddd*f**2*s - 328*C*D1*Ddd*f**2 - 3936*C*Dd**2*f**2*r**2 - 5616*C*Dd**2*f**2*r*s + 4776*C*Dd**2*f**2*r + 1404*C*Dd**2*f**2*s - 936*C*Dd**2*f**2 + 28*D1**2*bdd1*f*(5*C - 3)*(2*r**2 + 2*r*(s - 1) - s + 1) - 140*D1**2*f*fd*r**2 - 360*D1**2*f*fd*r*s + 148*D1**2*f*fd*r - 16*D1**2*f*fd*s + 16*D1**2*f*fd + 378*D1**2*f*fdd*r**2 + 600*D1**2*f*fdd*r*s - 228*D1**2*f*fdd*r + 36*D1**2*f*fdd*s - 36*D1**2*f*fdd + 378*D1**2*fd**2*r**2 + 600*D1**2*fd**2*r*s - 228*D1**2*fd**2*r + 36*D1**2*fd**2*s - 36*D1**2*fd**2 - 280*D1*Dd*f**2*r**2 - 720*D1*Dd*f**2*r*s + 500*D1*Dd*f**2*r + 180*D1*Dd*f**2*s - 70*D1*Dd*f**2 + 3024*D1*Dd*f*fd*r**2 + 4800*D1*Dd*f*fd*r*s - 2868*D1*Dd*f*fd*r - 456*D1*Dd*f*fd*s + 156*D1*Dd*f*fd + 756*D1*Ddd*f**2*r**2 + 1200*D1*Ddd*f**2*r*s - 978*D1*Ddd*f**2*r - 300*D1*Ddd*f**2*s + 189*D1*Ddd*f**2 + 28*D1*bd1*(D1*(f*(5*C - 4)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd*(5*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*f*(10*C - 6)*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 2268*Dd**2*f**2*r**2 + 3600*Dd**2*f**2*r*s - 2934*Dd**2*f**2*r - 900*Dd**2*f**2*s + 600*Dd**2*f**2) + f*(1716*C*D1**2*f*fd*r**2 + 1704*C*D1**2*f*fd*r*s - 1712*C*D1**2*f*fd*r - 568*C*D1**2*f*fd*s + 572*C*D1**2*f*fd - 2100*C*D1**2*f*fdd*r**2 - 2256*C*D1**2*f*fdd*r*s + 2152*C*D1**2*f*fdd*r + 752*C*D1**2*f*fdd*s - 700*C*D1**2*f*fdd - 4200*C*D1**2*fd**2*r**2 - 4512*C*D1**2*fd**2*r*s + 4304*C*D1**2*fd**2*r + 1504*C*D1**2*fd**2*s - 752*C*D1**2*fd**2 + 2288*C*D1*Dd*f**2*r**2 + 2272*C*D1*Dd*f**2*r*s - 2280*C*D1*Dd*f**2*r - 568*C*D1*Dd*f**2*s + 572*C*D1*Dd*f**2 - 16800*C*D1*Dd*f*fd*r**2 - 18048*C*D1*Dd*f*fd*r*s + 17320*C*D1*Dd*f*fd*r + 5264*C*D1*Dd*f*fd*s - 3656*C*D1*Dd*f*fd - 2800*C*D1*Ddd*f**2*r**2 - 3008*C*D1*Ddd*f**2*r*s + 2904*C*D1*Ddd*f**2*r + 752*C*D1*Ddd*f**2*s - 700*C*D1*Ddd*f**2 - 8400*C*Dd**2*f**2*r**2 - 9024*C*Dd**2*f**2*r*s + 8712*C*Dd**2*f**2*r + 2256*C*Dd**2*f**2*s - 1504*C*Dd**2*f**2 + 84*D1**2*bd1**2*(5*C - 3)*(2*r**2 + 2*r*(s - 1) - s) - 3*D1**2*bdd1*f*(4*C*(82*r**2 + r*(117*s - 194) - 132*s + 97) - 189*r**2 - 150*r*(2*s - 3) + 336*s - 225) - 1014*D1**2*f*fd*r**2 - 1044*D1**2*f*fd*r*s + 1024*D1**2*f*fd*r + 348*D1**2*f*fd*s - 338*D1**2*f*fd + 1209*D1**2*f*fdd*r**2 + 1440*D1**2*f*fdd*r*s - 1286*D1**2*f*fdd*r - 480*D1**2*f*fdd*s + 403*D1**2*f*fdd + 2418*D1**2*fd**2*r**2 + 2880*D1**2*fd**2*r*s - 2572*D1**2*fd**2*r - 960*D1**2*fd**2*s + 480*D1**2*fd**2 - 1352*D1*Dd*f**2*r**2 - 1392*D1*Dd*f**2*r*s + 1372*D1*Dd*f**2*r + 348*D1*Dd*f**2*s - 338*D1*Dd*f**2 + 9672*D1*Dd*f*fd*r**2 + 11520*D1*Dd*f*fd*r*s - 10442*D1*Dd*f*fd*r - 3360*D1*Dd*f*fd*s + 2246*D1*Dd*f*fd + 1612*D1*Ddd*f**2*r**2 + 1920*D1*Ddd*f**2*r*s - 1766*D1*Ddd*f**2*r - 480*D1*Ddd*f**2*s + 403*D1*Ddd*f**2 + 6*D1*bd1*(D1*(f*(2*C*(24*r**2 + r*(73*s - 66) - 82*s + 33) - 35*r**2 + r*(86 - 90*s) + 98*s - 43) + 2*fd*(C*(-328*r**2 - 468*r*s + 475*r + 249*s - 132) + 189*r**2 + 6*r*(50*s - 47) - 159*s + 84)) + Dd*f*(-2*C*(656*r**2 + 2*r*(468*s - 587) - 645*s + 458) + 756*r**2 + 3*r*(400*s - 463) - 822*s + 561)) + 4836*Dd**2*f**2*r**2 + 5760*Dd**2*f**2*r*s - 5298*Dd**2*f**2*r - 1440*Dd**2*f**2*s + 960*Dd**2*f**2))/(315*d**2*k3**4) - 2*D1**2*Pk3*Pkd1*ct*k1**2*k2*(-1092*D1**2*K*bd1**2*f*r**2 - 1008*D1**2*K*bd1**2*f*r*s + 1974*D1**2*K*bd1**2*f*r + 693*D1**2*K*bd1**2*f*s - 693*D1**2*K*bd1**2*f + 405*D1**2*K*bd1*f**2*r**2 + 351*D1**2*K*bd1*f**2*r*s - 351*D1**2*K*bd1*f**2*r - 2196*D1**2*K*bd1*f*fd*r**2 - 1836*D1**2*K*bd1*f*fd*r*s + 2016*D1**2*K*bd1*f*fd*r + 459*D1**2*K*bd1*f*fd*s - 459*D1**2*K*bd1*f*fd - 549*D1**2*K*bdd1*f**2*r**2 - 459*D1**2*K*bdd1*f**2*r*s + 459*D1**2*K*bdd1*f**2*r + 198*D1**2*bd1**2*f**2*r**2 + 378*D1**2*bd1**2*f**2*r*s - 477*D1**2*bd1**2*f**2*r - 234*D1**2*bd1**2*f**2*s + 234*D1**2*bd1**2*f**2 + 294*D1**2*bd1**2*f*r**2 + 462*D1**2*bd1**2*f*r*s - 651*D1**2*bd1**2*f*r - 294*D1**2*bd1**2*f*s + 294*D1**2*bd1**2*f - 1260*D1**2*bd1**2*g2*r**2 - 1260*D1**2*bd1**2*g2*r*s + 1260*D1**2*bd1**2*g2*r + 630*D1**2*bd1**2*g2*s - 378*D1**2*bd1*bd2*f*r**2 - 378*D1**2*bd1*bd2*f*r*s + 567*D1**2*bd1*bd2*f*r + 189*D1**2*bd1*bd2*f*s - 189*D1**2*bd1*bd2*f - 95*D1**2*bd1*f**3*r**2 - 115*D1**2*bd1*f**3*r*s + 160*D1**2*bd1*f**3*r - 45*D1**2*bd1*f**3*s + 690*D1**2*bd1*f**2*fd*r**2 + 750*D1**2*bd1*f**2*fd*r*s - 820*D1**2*bd1*f**2*fd*r - 35*D1**2*bd1*f**2*fd*s + 80*D1**2*bd1*f**2*fd - 117*D1**2*bd1*f**2*r**2 - 144*D1**2*bd1*f**2*r*s + 144*D1**2*bd1*f**2*r + 612*D1**2*bd1*f*fd*r**2 + 792*D1**2*bd1*f*fd*r*s - 702*D1**2*bd1*f*fd*r - 198*D1**2*bd1*f*fd*s + 198*D1**2*bd1*f*fd - 504*D1**2*bd1*f*g2*r**2 - 756*D1**2*bd1*f*g2*r*s + 1260*D1**2*bd1*f*g2*r + 882*D1**2*bd1*f*g2*s - 630*D1**2*bd1*f*g2 + 2184*D1**2*bd1*f*gd2*r**2 + 2016*D1**2*bd1*f*gd2*r*s - 3948*D1**2*bd1*f*gd2*r - 1386*D1**2*bd1*f*gd2*s + 1386*D1**2*bd1*f*gd2 + 2184*D1**2*bd1*fd*g2*r**2 + 2016*D1**2*bd1*fd*g2*r*s - 2184*D1**2*bd1*fd*g2*r - 1008*D1**2*bd1*fd*g2*s + 81*D1**2*bd2*f**2*r**2 + 81*D1**2*bd2*f**2*r*s - 81*D1**2*bd2*f**2*r - 540*D1**2*bd2*f*fd*r**2 - 540*D1**2*bd2*f*fd*r*s + 540*D1**2*bd2*f*fd*r + 135*D1**2*bd2*f*fd*s - 135*D1**2*bd2*f*fd + 115*D1**2*bdd1*f**3*r**2 + 125*D1**2*bdd1*f**3*r*s - 170*D1**2*bdd1*f**3*r + 45*D1**2*bdd1*f**3*s + 153*D1**2*bdd1*f**2*r**2 + 198*D1**2*bdd1*f**2*r*s - 198*D1**2*bdd1*f**2*r + 1092*D1**2*bdd1*f*g2*r**2 + 1008*D1**2*bdd1*f*g2*r*s - 2940*D1**2*bdd1*f*g2*r - 1386*D1**2*bdd1*f*g2*s + 1470*D1**2*bdd1*f*g2 - 135*D1**2*bdd2*f**2*r**2 - 135*D1**2*bdd2*f**2*r*s + 135*D1**2*bdd2*f**2*r + 140*D1**2*f**3*fd*r*s - 70*D1**2*f**3*fd*r - 35*D1**2*f**3*fd*s - 140*D1**2*f**3*fdd*r*s + 70*D1**2*f**3*fdd*r + 35*D1**2*f**3*fdd*s - 420*D1**2*f**2*fd**2*r*s + 210*D1**2*f**2*fd**2*r + 105*D1**2*f**2*fd**2*s - 70*D1**2*f**2*fd**2 - 810*D1**2*f**2*gd2*r**2 - 702*D1**2*f**2*gd2*r*s + 702*D1**2*f**2*gd2*r + 1098*D1**2*f**2*gdd2*r**2 + 918*D1**2*f**2*gdd2*r*s - 918*D1**2*f**2*gdd2*r - 1620*D1**2*f*fd*g2*r**2 - 1404*D1**2*f*fd*g2*r*s + 1620*D1**2*f*fd*g2*r + 702*D1**2*f*fd*g2*s - 810*D1**2*f*fd*g2 + 4392*D1**2*f*fd*gd2*r**2 + 3672*D1**2*f*fd*gd2*r*s - 4032*D1**2*f*fd*gd2*r - 918*D1**2*f*fd*gd2*s + 918*D1**2*f*fd*gd2 + 2196*D1**2*f*fdd*g2*r**2 + 1836*D1**2*f*fdd*g2*r*s - 2196*D1**2*f*fdd*g2*r - 918*D1**2*f*fdd*g2*s + 1098*D1**2*f*fdd*g2 + 2196*D1**2*fd**2*g2*r**2 + 1836*D1**2*fd**2*g2*r*s - 2196*D1**2*fd**2*g2*r - 918*D1**2*fd**2*g2*s - 4392*D1*Dd*K*bd1*f**2*r**2 - 3672*D1*Dd*K*bd1*f**2*r*s + 3852*D1*Dd*K*bd1*f**2*r + 459*D1*Dd*K*bd1*f**2*s - 459*D1*Dd*K*bd1*f**2 + 920*D1*Dd*bd1*f**3*r**2 + 1000*D1*Dd*bd1*f**3*r*s - 1160*D1*Dd*bd1*f**3*r + 55*D1*Dd*bd1*f**3*s + 80*D1*Dd*bd1*f**3 + 1224*D1*Dd*bd1*f**2*r**2 + 1584*D1*Dd*bd1*f**2*r*s - 1494*D1*Dd*bd1*f**2*r - 198*D1*Dd*bd1*f**2*s + 198*D1*Dd*bd1*f**2 + 8736*D1*Dd*bd1*f*g2*r**2 + 8064*D1*Dd*bd1*f*g2*r*s - 15960*D1*Dd*bd1*f*g2*r - 6552*D1*Dd*bd1*f*g2*s + 5712*D1*Dd*bd1*f*g2 - 1080*D1*Dd*bd2*f**2*r**2 - 1080*D1*Dd*bd2*f**2*r*s + 1080*D1*Dd*bd2*f**2*r + 135*D1*Dd*bd2*f**2*s - 135*D1*Dd*bd2*f**2 + 140*D1*Dd*f**4*r*s - 70*D1*Dd*f**4*r - 35*D1*Dd*f**4*s - 1120*D1*Dd*f**3*fd*r*s + 560*D1*Dd*f**3*fd*r + 280*D1*Dd*f**3*fd*s - 140*D1*Dd*f**3*fd - 3240*D1*Dd*f**2*g2*r**2 - 2808*D1*Dd*f**2*g2*r*s + 3024*D1*Dd*f**2*g2*r + 702*D1*Dd*f**2*g2*s - 810*D1*Dd*f**2*g2 + 8784*D1*Dd*f**2*gd2*r**2 + 7344*D1*Dd*f**2*gd2*r*s - 7704*D1*Dd*f**2*gd2*r - 918*D1*Dd*f**2*gd2*s + 918*D1*Dd*f**2*gd2 + 17568*D1*Dd*f*fd*g2*r**2 + 14688*D1*Dd*f*fd*g2*r*s - 16848*D1*Dd*f*fd*g2*r - 5508*D1*Dd*f*fd*g2*s + 4032*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**4*r*s + 70*D1*Ddd*f**4*r + 35*D1*Ddd*f**4*s + 4392*D1*Ddd*f**2*g2*r**2 + 3672*D1*Ddd*f**2*g2*r*s - 4032*D1*Ddd*f**2*g2*r - 918*D1*Ddd*f**2*g2*s + 1098*D1*Ddd*f**2*g2 - 420*Dd**2*f**4*r*s + 210*Dd**2*f**4*r + 105*Dd**2*f**4*s - 70*Dd**2*f**4 + 13176*Dd**2*f**2*g2*r**2 + 11016*Dd**2*f**2*g2*r*s - 12096*Dd**2*f**2*g2*r - 2754*Dd**2*f**2*g2*s + 1836*Dd**2*f**2*g2 + 21*b1**3*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + (15*K - 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-15*K + 3*f + 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-15*K + 3*f + 5)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1**2*(84*D1**2*K*fd*r**2 + 126*D1**2*K*fd*r*s + 42*D1**2*K*fd*r + 21*D1**2*K*fd*s - 21*D1**2*K*fd - 182*D1**2*K*fdd*r**2 - 168*D1**2*K*fdd*r*s - 126*D1**2*K*fdd*r - 63*D1**2*K*fdd*s + 63*D1**2*K*fdd - 7*D1**2*bdd1*(-15*K + 3*f + 5)*(3*r**2 + 3*r*(s - 1) - s + 1) - 48*D1**2*f*fd*r**2 - 126*D1**2*f*fd*r*s + 45*D1**2*f*fd*r - 9*D1**2*f*fd*s + 9*D1**2*f*fd + 66*D1**2*f*fdd*r**2 + 126*D1**2*f*fdd*r*s - 33*D1**2*f*fdd*r + 15*D1**2*f*fdd*s - 15*D1**2*f*fdd + 66*D1**2*fd**2*r**2 + 126*D1**2*fd**2*r*s - 33*D1**2*fd**2*r + 15*D1**2*fd**2*s - 15*D1**2*fd**2 - 28*D1**2*fd*r**2 - 49*D1**2*fd*r*s - 14*D1**2*fd*r - 7*D1**2*fd*s + 7*D1**2*fd + 49*D1**2*fdd*r**2 + 77*D1**2*fdd*r*s + 42*D1**2*fdd*r + 21*D1**2*fdd*s - 21*D1**2*fdd - 210*D1**2*gd2*r**2 - 210*D1**2*gd2*r*s + 210*D1**2*gd2*r - 210*D1**2*gdd2*r**2 - 210*D1**2*gdd2*r*s + 210*D1**2*gdd2*r + 336*D1*Dd*K*f*r**2 + 504*D1*Dd*K*f*r*s - 420*D1*Dd*K*f*r - 126*D1*Dd*K*f*s + 84*D1*Dd*K*f - 1456*D1*Dd*K*fd*r**2 - 1344*D1*Dd*K*fd*r*s + 196*D1*Dd*K*fd*r - 84*D1*Dd*K*fd*s + 252*D1*Dd*K*fd - 96*D1*Dd*f**2*r**2 - 252*D1*Dd*f**2*r*s + 174*D1*Dd*f**2*r + 63*D1*Dd*f**2*s - 24*D1*Dd*f**2 + 528*D1*Dd*f*fd*r**2 + 1008*D1*Dd*f*fd*r*s - 516*D1*Dd*f*fd*r - 66*D1*Dd*f*fd*s + 3*D1*Dd*f*fd - 112*D1*Dd*f*r**2 - 196*D1*Dd*f*r*s + 154*D1*Dd*f*r + 49*D1*Dd*f*s - 28*D1*Dd*f + 392*D1*Dd*fd*r**2 + 616*D1*Dd*fd*r*s - 84*D1*Dd*fd*r + 7*D1*Dd*fd*s - 84*D1*Dd*fd - 840*D1*Dd*g2*r**2 - 840*D1*Dd*g2*r*s + 840*D1*Dd*g2*r + 210*D1*Dd*g2*s - 210*D1*Dd*g2 - 1680*D1*Dd*gd2*r**2 - 1680*D1*Dd*gd2*r*s + 1680*D1*Dd*gd2*r + 210*D1*Dd*gd2*s - 210*D1*Dd*gd2 - 728*D1*Ddd*K*f*r**2 - 672*D1*Ddd*K*f*r*s + 700*D1*Ddd*K*f*r + 168*D1*Ddd*K*f*s - 182*D1*Ddd*K*f + 132*D1*Ddd*f**2*r**2 + 252*D1*Ddd*f**2*r*s - 192*D1*Ddd*f**2*r - 63*D1*Ddd*f**2*s + 33*D1*Ddd*f**2 + 196*D1*Ddd*f*r**2 + 308*D1*Ddd*f*r*s - 252*D1*Ddd*f*r - 77*D1*Ddd*f*s + 49*D1*Ddd*f - 840*D1*Ddd*g2*r**2 - 840*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r + 210*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 7*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + (15*K - 5)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-15*K + 3*f + 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 2184*Dd**2*K*f*r**2 - 2016*Dd**2*K*f*r*s + 2100*Dd**2*K*f*r + 504*Dd**2*K*f*s - 336*Dd**2*K*f + 396*Dd**2*f**2*r**2 + 756*Dd**2*f**2*r*s - 576*Dd**2*f**2*r - 189*Dd**2*f**2*s + 126*Dd**2*f**2 + 588*Dd**2*f*r**2 + 924*Dd**2*f*r*s - 756*Dd**2*f*r - 231*Dd**2*f*s + 154*Dd**2*f - 2520*Dd**2*g2*r**2 - 2520*Dd**2*g2*r*s + 2520*Dd**2*g2*r + 630*Dd**2*g2*s - 420*Dd**2*g2) + b1*(810*D1**2*K*f*fd*r**2 + 702*D1**2*K*f*fd*r*s - 810*D1**2*K*f*fd*r - 351*D1**2*K*f*fd*s + 405*D1**2*K*f*fd - 1098*D1**2*K*f*fdd*r**2 - 918*D1**2*K*f*fdd*r*s + 1098*D1**2*K*f*fdd*r + 459*D1**2*K*f*fdd*s - 549*D1**2*K*f*fdd - 1098*D1**2*K*fd**2*r**2 - 918*D1**2*K*fd**2*r*s + 1098*D1**2*K*fd**2*r + 459*D1**2*K*fd**2*s + 63*D1**2*b2*fd*r**2 + 63*D1**2*b2*fd*r*s - 189*D1**2*b2*fdd*r**2 - 189*D1**2*b2*fdd*r*s - 21*D1**2*bd1**2*(-15*K + 3*f + 5)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 63*D1**2*bd2*f*r**2 + 63*D1**2*bd2*f*r*s - 63*D1**2*bd2*f*r - 378*D1**2*bd2*fd*r**2 - 378*D1**2*bd2*fd*r*s + 189*D1**2*bd2*fd*r + 3*D1**2*bdd1*(3*f**2*(22*r**2 + r*(42*s - 53) - 26*s + 16) - 7*f*(K*(52*r**2 + 48*r*s - 94*r - 33*s + 35) - 14*r**2 - 22*r*s + 31*r + 14*s - 10) - 210*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 189*D1**2*bdd2*f*r**2 - 189*D1**2*bdd2*f*r*s + 189*D1**2*bdd2*f*r - 285*D1**2*f**2*fd*r**2 - 345*D1**2*f**2*fd*r*s + 260*D1**2*f**2*fd*r + 160*D1**2*f**2*fd*s - 95*D1**2*f**2*fd + 345*D1**2*f**2*fdd*r**2 + 375*D1**2*f**2*fdd*r*s - 310*D1**2*f**2*fdd*r - 170*D1**2*f**2*fdd*s + 115*D1**2*f**2*fdd + 690*D1**2*f*fd**2*r**2 + 750*D1**2*f*fd**2*r*s - 620*D1**2*f*fd**2*r - 340*D1**2*f*fd**2*s + 170*D1**2*f*fd**2 - 234*D1**2*f*fd*r**2 - 288*D1**2*f*fd*r*s + 234*D1**2*f*fd*r + 144*D1**2*f*fd*s - 117*D1**2*f*fd + 306*D1**2*f*fdd*r**2 + 396*D1**2*f*fdd*r*s - 306*D1**2*f*fdd*r - 198*D1**2*f*fdd*s + 153*D1**2*f*fdd - 504*D1**2*f*gd2*r**2 - 756*D1**2*f*gd2*r*s + 756*D1**2*f*gd2*r + 1092*D1**2*f*gdd2*r**2 + 1008*D1**2*f*gdd2*r*s - 1008*D1**2*f*gdd2*r + 306*D1**2*fd**2*r**2 + 396*D1**2*fd**2*r*s - 306*D1**2*fd**2*r - 198*D1**2*fd**2*s - 504*D1**2*fd*g2*r**2 - 756*D1**2*fd*g2*r*s - 252*D1**2*fd*g2*r - 126*D1**2*fd*g2*s + 126*D1**2*fd*g2 + 2184*D1**2*fd*gd2*r**2 + 2016*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*r + 378*D1**2*fd*gd2*s - 378*D1**2*fd*gd2 + 1092*D1**2*fdd*g2*r**2 + 1008*D1**2*fdd*g2*r*s + 756*D1**2*fdd*g2*r + 378*D1**2*fdd*g2*s - 378*D1**2*fdd*g2 + 1620*D1*Dd*K*f**2*r**2 + 1404*D1*Dd*K*f**2*r*s - 1512*D1*Dd*K*f**2*r - 351*D1*Dd*K*f**2*s + 405*D1*Dd*K*f**2 - 8784*D1*Dd*K*f*fd*r**2 - 7344*D1*Dd*K*f*fd*r*s + 8424*D1*Dd*K*f*fd*r + 2754*D1*Dd*K*f*fd*s - 2016*D1*Dd*K*f*fd + 252*D1*Dd*b2*f*r**2 + 252*D1*Dd*b2*f*r*s - 252*D1*Dd*b2*f*r - 63*D1*Dd*b2*f*s + 63*D1*Dd*b2*f - 1512*D1*Dd*b2*fd*r**2 - 1512*D1*Dd*b2*fd*r*s + 756*D1*Dd*b2*fd*r + 189*D1*Dd*b2*fd*s - 1512*D1*Dd*bd2*f*r**2 - 1512*D1*Dd*bd2*f*r*s + 1512*D1*Dd*bd2*f*r + 189*D1*Dd*bd2*f*s - 189*D1*Dd*bd2*f - 380*D1*Dd*f**3*r**2 - 460*D1*Dd*f**3*r*s + 420*D1*Dd*f**3*r + 115*D1*Dd*f**3*s - 95*D1*Dd*f**3 + 2760*D1*Dd*f**2*fd*r**2 + 3000*D1*Dd*f**2*fd*r*s - 2680*D1*Dd*f**2*fd*r - 1055*D1*Dd*f**2*fd*s + 650*D1*Dd*f**2*fd - 468*D1*Dd*f**2*r**2 - 576*D1*Dd*f**2*r*s + 522*D1*Dd*f**2*r + 144*D1*Dd*f**2*s - 117*D1*Dd*f**2 + 2448*D1*Dd*f*fd*r**2 + 3168*D1*Dd*f*fd*r*s - 2628*D1*Dd*f*fd*r - 1188*D1*Dd*f*fd*s + 702*D1*Dd*f*fd - 2016*D1*Dd*f*g2*r**2 - 3024*D1*Dd*f*g2*r*s + 2520*D1*Dd*f*g2*r + 756*D1*Dd*f*g2*s - 504*D1*Dd*f*g2 + 8736*D1*Dd*f*gd2*r**2 + 8064*D1*Dd*f*gd2*r*s - 8232*D1*Dd*f*gd2*r - 1008*D1*Dd*f*gd2*s + 1008*D1*Dd*f*gd2 + 8736*D1*Dd*fd*g2*r**2 + 8064*D1*Dd*fd*g2*r*s - 1176*D1*Dd*fd*g2*r + 504*D1*Dd*fd*g2*s - 1512*D1*Dd*fd*g2 - 2196*D1*Ddd*K*f**2*r**2 - 1836*D1*Ddd*K*f**2*r*s + 2016*D1*Ddd*K*f**2*r + 459*D1*Ddd*K*f**2*s - 549*D1*Ddd*K*f**2 - 756*D1*Ddd*b2*f*r**2 - 756*D1*Ddd*b2*f*r*s + 756*D1*Ddd*b2*f*r + 189*D1*Ddd*b2*f*s - 189*D1*Ddd*b2*f + 460*D1*Ddd*f**3*r**2 + 500*D1*Ddd*f**3*r*s - 480*D1*Ddd*f**3*r - 125*D1*Ddd*f**3*s + 115*D1*Ddd*f**3 + 612*D1*Ddd*f**2*r**2 + 792*D1*Ddd*f**2*r*s - 702*D1*Ddd*f**2*r - 198*D1*Ddd*f**2*s + 153*D1*Ddd*f**2 + 4368*D1*Ddd*f*g2*r**2 + 4032*D1*Ddd*f*g2*r*s - 4200*D1*Ddd*f*g2*r - 1008*D1*Ddd*f*g2*s + 1092*D1*Ddd*f*g2 - 3*D1*bd1*(D1*(3*f**2*(16*r**2 + r*(42*s - 43) - 24*s + 11) + f*(-21*K*(8*r**2 + 4*r*(3*s - 4) - 7*s + 5) - 3*fd*(88*r**2 + 8*r*(21*s - 16) - 42*s + 21) + 56*r**2 + 98*r*s - 119*r - 56*s + 35) + 7*fd*(K*(104*r**2 + 96*r*s - 58*r - 15*s - 9) - 28*r**2 - 44*r*s + 19*r + 8*s + 3) + 210*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 210*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*(-3*f**2*(176*r**2 + 4*r*(84*s - 85) - 146*s + 105) + 7*f*(4*K*(104*r**2 + 48*r*(2*s - 3) - 45*s + 40) - 112*r**2 - 176*r*s + 196*r + 78*s - 59) + 420*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 6588*Dd**2*K*f**2*r**2 - 5508*Dd**2*K*f**2*r*s + 6048*Dd**2*K*f**2*r + 1377*Dd**2*K*f**2*s - 918*Dd**2*K*f**2 - 2268*Dd**2*b2*f*r**2 - 2268*Dd**2*b2*f*r*s + 2268*Dd**2*b2*f*r + 567*Dd**2*b2*f*s - 378*Dd**2*b2*f + 1380*Dd**2*f**3*r**2 + 1500*Dd**2*f**3*r*s - 1440*Dd**2*f**3*r - 375*Dd**2*f**3*s + 250*Dd**2*f**3 + 1836*Dd**2*f**2*r**2 + 2376*Dd**2*f**2*r*s - 2106*Dd**2*f**2*r - 594*Dd**2*f**2*s + 396*Dd**2*f**2 + 13104*Dd**2*f*g2*r**2 + 12096*Dd**2*f*g2*r*s - 12600*Dd**2*f*g2*r - 3024*Dd**2*f*g2*s + 2016*Dd**2*f*g2) + 9*b2*(-21*D1**2*bdd1*f*(r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 10*fd*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(315*d**2*k3**4) + D1**2*Pk3*Pkd1*ct*k1**2*st**2*(4*C - 2)*(D1*b1*(D1*(-11*f*fd*s + 3*f*s*(-14*bdd1*r + 7*bdd1 + 3*fdd) + 9*fd**2*(s - 1)) + 18*Dd*f*fd*(2*s - 1) - 7*bd1*(D1*(f*s*(1 - 2*r) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1))) - 7*b1**2*(D1*Dd*(f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + f*(21*D1**2*bd1**2*s*(1 - 2*r) + D1*Dd*f*(7*f*(r*(2 - 4*s) + s) + 5*fd*(2*r*(12*s - 5) - 7*s + 3)) + D1*bd1*(11*D1*f*s - 9*D1*fd*(s - 1) + 18*Dd*f*(1 - 2*s)) + D1*(D1*(7*f*fd*(-3*r*s + r + s) - f*(9*bdd1*s + 5*fdd*(-3*r*s + r + s)) + 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(4*s - 2) - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k2*k3**2) - D1**2*Pk3*Pkd1*ct*k1**2*(4*C - 2)*(7*D1*b1*(D1*(-3*f*fd*s + f*s*(bdd1*(5 - 10*r) + 3*fdd) + 3*fd**2*(s - 1)) + 6*Dd*f*fd*(2*s - 1) - 5*bd1*(D1*(f*s*(1 - 2*r) + fd*r*(4*s - 2) - fd*s + fd) + 2*Dd*f*(r*(8*s - 2) - 3*s + 1))) - 35*b1**2*(D1*Dd*(f*r*(2 - 4*s) + f*s + fd*r*(8*s - 6) - fd*s + fd) - D1*(D1*r*(fd - fdd)*(s - 1) + Ddd*f*(r*(2 - 4*s) + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + f*(35*D1**2*bd1**2*s*(1 - 2*r) - 15*D1*Dd*f*(f*(4*r*s - 2*r - s) + fd*(-24*r*s + 10*r + 7*s - 3)) + 21*D1*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s)) - 3*D1*(D1*(5*f*fd*(r*(3*s - 1) - s) + f*(7*bdd1*s + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) + 15*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k2*k3**2) - 4*D1**2*Pk3*Pkd1*ct*k2**5*st**4*(33*b1**2*(D1**2*r*(2*r + 2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + D1*f*(Dd*(3*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1)) - 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*f*(-15*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 27*D1**2*f*fd*r**2 - 27*D1**2*f*fd*r*s + 11*D1**2*f*fd*r - 7*D1**2*f*fd*s + 7*D1**2*f*fd + 45*D1**2*f*fdd*r**2 + 45*D1**2*f*fdd*r*s - 25*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 90*D1**2*fd**2*r*s - 50*D1**2*fd**2*r + 10*D1**2*fd**2*s - 5*D1**2*fd**2 - 36*D1*Dd*f**2*r**2 - 36*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r + 9*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 360*D1*Dd*f*fd*r**2 + 360*D1*Dd*f*fd*r*s - 280*D1*Dd*f*fd*r - 25*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 60*D1*Ddd*f**2*r**2 + 60*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r - 15*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 3*D1*bd1*(D1*(3*f*(2*r - 1)*(r + s - 1) - 5*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1)) - 5*Dd*f*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 180*Dd**2*f**2*r**2 + 180*Dd**2*f**2*r*s - 180*Dd**2*f**2*r - 45*Dd**2*f**2*s + 30*Dd**2*f**2) + f**2*(-165*D1**2*bd1**2*(2*r - 1)*(r + s - 1) + 55*D1**2*bdd1*f*(3*r - 4)*(r + s - 1) - 4*D1**2*(f*(28*fd - 25*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 25*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 11*D1*bd1*(D1*(f*(9*r - 16)*(r + s - 1) - 5*fd*(18*r**2 + 18*r*s - 26*r - 11*s + 7)) - 5*Dd*f*(24*r**2 + 8*r*(3*s - 5) - 19*s + 15)) - 4*D1*f*(28*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 50*Dd*fd*(4*r - 1)*(4*r + 4*s - 3) - 25*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 100*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(1155*d**2*k3**6) - 2*D1**2*Pk3*Pkd1*ct*k2**3*st**4*(108*C*D1**2*b1*f*fd*r**2 - 24*C*D1**2*b1*f*fd*r*s + 12*C*D1**2*b1*f*fd*r - 180*C*D1**2*b1*f*fdd*r**2 - 72*C*D1**2*b1*f*fdd*r*s + 36*C*D1**2*b1*f*fdd*r - 180*C*D1**2*b1*fd**2*r**2 - 72*C*D1**2*b1*fd**2*r*s + 36*C*D1**2*b1*fd**2*r + 150*C*D1**2*f**2*fd*r**2 + 36*C*D1**2*f**2*fd*r*s - 112*C*D1**2*f**2*fd*r - 12*C*D1**2*f**2*fd*s + 50*C*D1**2*f**2*fd - 102*C*D1**2*f**2*fdd*r**2 - 36*C*D1**2*f**2*fdd*r*s + 80*C*D1**2*f**2*fdd*r + 12*C*D1**2*f**2*fdd*s - 34*C*D1**2*f**2*fdd - 204*C*D1**2*f*fd**2*r**2 - 72*C*D1**2*f*fd**2*r*s + 160*C*D1**2*f*fd**2*r + 24*C*D1**2*f*fd**2*s - 12*C*D1**2*f*fd**2 + 216*C*D1*Dd*b1*f**2*r**2 - 48*C*D1*Dd*b1*f**2*r*s - 84*C*D1*Dd*b1*f**2*r + 12*C*D1*Dd*b1*f**2*s + 54*C*D1*Dd*b1*f**2 - 1440*C*D1*Dd*b1*f*fd*r**2 - 576*C*D1*Dd*b1*f*fd*r*s + 648*C*D1*Dd*b1*f*fd*r + 72*C*D1*Dd*b1*f*fd*s - 36*C*D1*Dd*b1*f*fd + 200*C*D1*Dd*f**3*r**2 + 48*C*D1*Dd*f**3*r*s - 124*C*D1*Dd*f**3*r - 12*C*D1*Dd*f**3*s + 50*C*D1*Dd*f**3 - 816*C*D1*Dd*f**2*fd*r**2 - 288*C*D1*Dd*f**2*fd*r*s + 596*C*D1*Dd*f**2*fd*r + 84*C*D1*Dd*f**2*fd*s - 104*C*D1*Dd*f**2*fd - 360*C*D1*Ddd*b1*f**2*r**2 - 144*C*D1*Ddd*b1*f**2*r*s + 252*C*D1*Ddd*b1*f**2*r + 36*C*D1*Ddd*b1*f**2*s - 90*C*D1*Ddd*b1*f**2 - 136*C*D1*Ddd*f**3*r**2 - 48*C*D1*Ddd*f**3*r*s + 92*C*D1*Ddd*f**3*r + 12*C*D1*Ddd*f**3*s - 34*C*D1*Ddd*f**3 - 1080*C*Dd**2*b1*f**2*r**2 - 432*C*Dd**2*b1*f**2*r*s + 756*C*Dd**2*b1*f**2*r + 108*C*Dd**2*b1*f**2*s - 72*C*Dd**2*b1*f**2 - 408*C*Dd**2*f**3*r**2 - 144*C*Dd**2*f**3*r*s + 276*C*Dd**2*f**3*r + 36*C*Dd**2*f**3*s - 24*C*Dd**2*f**3 - 78*D1**2*b1*f*fd*r**2 + 48*D1**2*b1*f*fd*r*s - 24*D1**2*b1*f*fd*r + 144*D1**2*b1*f*fdd*r**2 + 60*D1**2*b1*f*fdd*r*s - 30*D1**2*b1*f*fdd*r + 144*D1**2*b1*fd**2*r**2 + 60*D1**2*b1*fd**2*r*s - 30*D1**2*b1*fd**2*r - 6*D1**2*bdd1*f**2*(r - 1)*(3*C*(5*r + 2*s - 5) - 12*r - 5*s + 12) - 117*D1**2*f**2*fd*r**2 - 24*D1**2*f**2*fd*r*s + 86*D1**2*f**2*fd*r + 8*D1**2*f**2*fd*s - 39*D1**2*f**2*fd + 81*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 64*D1**2*f**2*fdd*r - 10*D1**2*f**2*fdd*s + 27*D1**2*f**2*fdd + 162*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 128*D1**2*f*fd**2*r - 20*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 - 156*D1*Dd*b1*f**2*r**2 + 96*D1*Dd*b1*f**2*r*s + 30*D1*Dd*b1*f**2*r - 24*D1*Dd*b1*f**2*s - 39*D1*Dd*b1*f**2 + 1152*D1*Dd*b1*f*fd*r**2 + 480*D1*Dd*b1*f*fd*r*s - 528*D1*Dd*b1*f*fd*r - 60*D1*Dd*b1*f*fd*s + 30*D1*Dd*b1*f*fd - 156*D1*Dd*f**3*r**2 - 32*D1*Dd*f**3*r*s + 94*D1*Dd*f**3*r + 8*D1*Dd*f**3*s - 39*D1*Dd*f**3 + 648*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 478*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd*s + 84*D1*Dd*f**2*fd + 288*D1*Ddd*b1*f**2*r**2 + 120*D1*Ddd*b1*f**2*r*s - 204*D1*Ddd*b1*f**2*r - 30*D1*Ddd*b1*f**2*s + 72*D1*Ddd*b1*f**2 + 108*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 74*D1*Ddd*f**3*r - 10*D1*Ddd*f**3*s + 27*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(r - 1)*(2*C*(9*r - 2*s - 9) - 13*r + 8*s + 13) - 2*fd*(6*C*(10*r**2 + 4*r*s - 11*r - 2*s + 1) - 48*r**2 - 20*r*s + 53*r + 10*s - 5)) + 2*Dd*f*(-6*C*(20*r**2 + 8*r*s - 27*r - 5*s + 7) + 96*r**2 + 40*r*s - 130*r - 25*s + 34)) + 864*Dd**2*b1*f**2*r**2 + 360*Dd**2*b1*f**2*r*s - 612*Dd**2*b1*f**2*r - 90*Dd**2*b1*f**2*s + 60*Dd**2*b1*f**2 + 324*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 222*Dd**2*f**3*r - 30*Dd**2*f**3*s + 20*Dd**2*f**3)/(105*d**2*k3**4) - D1**2*Pk3*Pkd1*ct*k2**3*st**2*(-3080*D1**2*K*bd1**2*f*r**2 - 1232*D1**2*K*bd1**2*f*r*s + 3696*D1**2*K*bd1**2*f*r + 616*D1**2*K*bd1**2*f*s - 616*D1**2*K*bd1**2*f + 1034*D1**2*K*bd1*f**2*r**2 + 220*D1**2*K*bd1*f**2*r*s - 220*D1**2*K*bd1*f**2*r - 2992*D1**2*K*bd1*f*fd*r**2 - 1056*D1**2*K*bd1*f*fd*r*s + 2024*D1**2*K*bd1*f*fd*r + 264*D1**2*K*bd1*f*fd*s - 264*D1**2*K*bd1*f*fd - 748*D1**2*K*bdd1*f**2*r**2 - 264*D1**2*K*bdd1*f**2*r*s + 264*D1**2*K*bdd1*f**2*r + 3366*D1**2*bd1**2*f**2*r**2 + 3432*D1**2*bd1**2*f**2*r*s - 5082*D1**2*bd1**2*f**2*r - 1914*D1**2*bd1**2*f**2*s + 1518*D1**2*bd1**2*f**2 + 2310*D1**2*bd1**2*f*r**2 + 1232*D1**2*bd1**2*f*r*s - 2926*D1**2*bd1**2*f*r - 616*D1**2*bd1**2*f*s + 616*D1**2*bd1**2*f - 924*D1**2*bd1*bd2*f*r**2 - 924*D1**2*bd1*bd2*f*r*s + 1386*D1**2*bd1*bd2*f*r + 462*D1**2*bd1*bd2*f*s - 462*D1**2*bd1*bd2*f - 506*D1**2*bd1*f**3*r**2 + 286*D1**2*bd1*f**3*r*s - 594*D1**2*bd1*f**3*r - 1188*D1**2*bd1*f**3*s + 660*D1**2*bd1*f**3 + 3300*D1**2*bd1*f**2*fd*r**2 - 1452*D1**2*bd1*f**2*fd*r*s + 440*D1**2*bd1*f**2*fd*r + 2618*D1**2*bd1*f**2*fd*s - 1650*D1**2*bd1*f**2*fd - 770*D1**2*bd1*f**2*r**2 - 220*D1**2*bd1*f**2*r*s + 220*D1**2*bd1*f**2*r + 2156*D1**2*bd1*f*fd*r**2 + 1056*D1**2*bd1*f*fd*r*s - 1606*D1**2*bd1*f*fd*r - 264*D1**2*bd1*f*fd*s + 264*D1**2*bd1*f*fd - 1540*D1**2*bd1*f*g2*r**2 + 616*D1**2*bd1*f*g2*r*s + 3080*D1**2*bd1*f*g2*r - 616*D1**2*bd1*f*g2*s - 1540*D1**2*bd1*f*g2 + 6160*D1**2*bd1*f*gd2*r**2 + 2464*D1**2*bd1*f*gd2*r*s - 7392*D1**2*bd1*f*gd2*r - 1232*D1**2*bd1*f*gd2*s + 1232*D1**2*bd1*f*gd2 + 6160*D1**2*bd1*fd*g2*r**2 + 2464*D1**2*bd1*fd*g2*r*s - 6160*D1**2*bd1*fd*g2*r - 1232*D1**2*bd1*fd*g2*s + 242*D1**2*bd2*f**2*r**2 + 242*D1**2*bd2*f**2*r*s - 242*D1**2*bd2*f**2*r - 792*D1**2*bd2*f*fd*r**2 - 792*D1**2*bd2*f*fd*r*s + 792*D1**2*bd2*f*fd*r + 198*D1**2*bd2*f*fd*s - 198*D1**2*bd2*f*fd + 550*D1**2*bdd1*f**3*r**2 - 242*D1**2*bdd1*f**3*r*s + 528*D1**2*bdd1*f**3*r + 1188*D1**2*bdd1*f**3*s - 627*D1**2*bdd1*f**3 + 539*D1**2*bdd1*f**2*r**2 + 264*D1**2*bdd1*f**2*r*s - 264*D1**2*bdd1*f**2*r + 3080*D1**2*bdd1*f*g2*r**2 + 1232*D1**2*bdd1*f*g2*r*s - 6160*D1**2*bdd1*f*g2*r - 1232*D1**2*bdd1*f*g2*s + 3080*D1**2*bdd1*f*g2 - 198*D1**2*bdd2*f**2*r**2 - 198*D1**2*bdd2*f**2*r*s + 198*D1**2*bdd2*f**2*r + 2160*D1**2*f**3*fd*r**2 + 2640*D1**2*f**3*fd*r*s - 2400*D1**2*f**3*fd*r - 660*D1**2*f**3*fd*s + 540*D1**2*f**3*fd - 1740*D1**2*f**3*fdd*r**2 - 2640*D1**2*f**3*fdd*r*s + 2190*D1**2*f**3*fdd*r + 660*D1**2*f**3*fdd*s - 435*D1**2*f**3*fdd - 5220*D1**2*f**2*fd**2*r**2 - 7920*D1**2*f**2*fd**2*r*s + 6570*D1**2*f**2*fd**2*r + 1980*D1**2*f**2*fd**2*s - 1320*D1**2*f**2*fd**2 - 2068*D1**2*f**2*gd2*r**2 - 440*D1**2*f**2*gd2*r*s + 440*D1**2*f**2*gd2*r + 1496*D1**2*f**2*gdd2*r**2 + 528*D1**2*f**2*gdd2*r*s - 528*D1**2*f**2*gdd2*r - 4136*D1**2*f*fd*g2*r**2 - 880*D1**2*f*fd*g2*r*s + 4136*D1**2*f*fd*g2*r + 440*D1**2*f*fd*g2*s - 2068*D1**2*f*fd*g2 + 5984*D1**2*f*fd*gd2*r**2 + 2112*D1**2*f*fd*gd2*r*s - 4048*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s + 528*D1**2*f*fd*gd2 + 2992*D1**2*f*fdd*g2*r**2 + 1056*D1**2*f*fdd*g2*r*s - 2992*D1**2*f*fdd*g2*r - 528*D1**2*f*fdd*g2*s + 1496*D1**2*f*fdd*g2 + 2992*D1**2*fd**2*g2*r**2 + 1056*D1**2*fd**2*g2*r*s - 2992*D1**2*fd**2*g2*r - 528*D1**2*fd**2*g2*s - 5984*D1*Dd*K*bd1*f**2*r**2 - 2112*D1*Dd*K*bd1*f**2*r*s + 3080*D1*Dd*K*bd1*f**2*r + 264*D1*Dd*K*bd1*f**2*s - 264*D1*Dd*K*bd1*f**2 + 4400*D1*Dd*bd1*f**3*r**2 - 1936*D1*Dd*bd1*f**3*r*s + 1496*D1*Dd*bd1*f**3*r + 4994*D1*Dd*bd1*f**3*s - 2904*D1*Dd*bd1*f**3 + 4312*D1*Dd*bd1*f**2*r**2 + 2112*D1*Dd*bd1*f**2*r*s - 2662*D1*Dd*bd1*f**2*r - 264*D1*Dd*bd1*f**2*s + 264*D1*Dd*bd1*f**2 + 24640*D1*Dd*bd1*f*g2*r**2 + 9856*D1*Dd*bd1*f*g2*r*s - 33264*D1*Dd*bd1*f*g2*r - 6160*D1*Dd*bd1*f*g2*s + 8624*D1*Dd*bd1*f*g2 - 1584*D1*Dd*bd2*f**2*r**2 - 1584*D1*Dd*bd2*f**2*r*s + 1584*D1*Dd*bd2*f**2*r + 198*D1*Dd*bd2*f**2*s - 198*D1*Dd*bd2*f**2 + 2160*D1*Dd*f**4*r**2 + 2640*D1*Dd*f**4*r*s - 2400*D1*Dd*f**4*r - 660*D1*Dd*f**4*s + 540*D1*Dd*f**4 - 13920*D1*Dd*f**3*fd*r**2 - 21120*D1*Dd*f**3*fd*r*s + 17520*D1*Dd*f**3*fd*r + 5280*D1*Dd*f**3*fd*s - 3510*D1*Dd*f**3*fd - 8272*D1*Dd*f**2*g2*r**2 - 1760*D1*Dd*f**2*g2*r*s + 5016*D1*Dd*f**2*g2*r + 440*D1*Dd*f**2*g2*s - 2068*D1*Dd*f**2*g2 + 11968*D1*Dd*f**2*gd2*r**2 + 4224*D1*Dd*f**2*gd2*r*s - 6160*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s + 528*D1*Dd*f**2*gd2 + 23936*D1*Dd*f*fd*g2*r**2 + 8448*D1*Dd*f*fd*g2*r*s - 20064*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s + 4048*D1*Dd*f*fd*g2 - 1740*D1*Ddd*f**4*r**2 - 2640*D1*Ddd*f**4*r*s + 2190*D1*Ddd*f**4*r + 660*D1*Ddd*f**4*s - 435*D1*Ddd*f**4 + 5984*D1*Ddd*f**2*g2*r**2 + 2112*D1*Ddd*f**2*g2*r*s - 4048*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s + 1496*D1*Ddd*f**2*g2 - 5220*Dd**2*f**4*r**2 - 7920*Dd**2*f**4*r*s + 6570*Dd**2*f**4*r + 1980*Dd**2*f**4*s - 1320*Dd**2*f**4 + 17952*Dd**2*f**2*g2*r**2 + 6336*Dd**2*f**2*g2*r*s - 12144*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s + 1056*Dd**2*f**2*g2 + 154*b1**3*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1**2*(70*D1**2*K*fd*r**2 - 28*D1**2*K*fd*r*s - 140*D1**2*K*fdd*r**2 - 56*D1**2*K*fdd*r*s - 42*D1**2*bdd1*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 136*D1**2*f*fd*r**2 - 232*D1**2*f*fd*r*s + 88*D1**2*f*fd*r - 22*D1**2*f*fd*s + 22*D1**2*f*fd + 306*D1**2*f*fdd*r**2 + 312*D1**2*f*fdd*r*s - 156*D1**2*f*fdd*r + 18*D1**2*f*fdd*s - 18*D1**2*f*fdd + 306*D1**2*fd**2*r**2 + 312*D1**2*fd**2*r*s - 156*D1**2*fd**2*r + 18*D1**2*fd**2*s - 18*D1**2*fd**2 - 70*D1**2*fd*r**2 + 28*D1**2*fd*r*s + 105*D1**2*fdd*r**2 + 56*D1**2*fdd*r*s + 280*D1*Dd*K*f*r**2 - 112*D1*Dd*K*f*r*s - 84*D1*Dd*K*f*r + 28*D1*Dd*K*f*s + 70*D1*Dd*K*f - 1120*D1*Dd*K*fd*r**2 - 448*D1*Dd*K*fd*r*s + 392*D1*Dd*K*fd*r + 56*D1*Dd*K*fd*s - 272*D1*Dd*f**2*r**2 - 464*D1*Dd*f**2*r*s + 368*D1*Dd*f**2*r + 116*D1*Dd*f**2*s - 68*D1*Dd*f**2 + 2448*D1*Dd*f*fd*r**2 + 2496*D1*Dd*f*fd*r*s - 1860*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s + 120*D1*Dd*f*fd - 280*D1*Dd*f*r**2 + 112*D1*Dd*f*r*s + 84*D1*Dd*f*r - 28*D1*Dd*f*s - 70*D1*Dd*f + 840*D1*Dd*fd*r**2 + 448*D1*Dd*fd*r*s - 322*D1*Dd*fd*r - 56*D1*Dd*fd*s - 560*D1*Ddd*K*f*r**2 - 224*D1*Ddd*K*f*r*s + 392*D1*Ddd*K*f*r + 56*D1*Ddd*K*f*s - 140*D1*Ddd*K*f + 612*D1*Ddd*f**2*r**2 + 624*D1*Ddd*f**2*r*s - 618*D1*Ddd*f**2*r - 156*D1*Ddd*f**2*s + 153*D1*Ddd*f**2 + 420*D1*Ddd*f*r**2 + 224*D1*Ddd*f*r*s - 322*D1*Ddd*f*r - 56*D1*Ddd*f*s + 105*D1*Ddd*f + 14*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1)) - 3*Dd*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 1680*Dd**2*K*f*r**2 - 672*Dd**2*K*f*r*s + 1176*Dd**2*K*f*r + 168*Dd**2*K*f*s - 112*Dd**2*K*f + 1836*Dd**2*f**2*r**2 + 1872*Dd**2*f**2*r*s - 1854*Dd**2*f**2*r - 468*Dd**2*f**2*s + 312*Dd**2*f**2 + 1260*Dd**2*f*r**2 + 672*Dd**2*f*r*s - 966*Dd**2*f*r - 168*Dd**2*f*s + 112*Dd**2*f) - 11*b1*(-188*D1**2*K*f*fd*r**2 - 40*D1**2*K*f*fd*r*s + 188*D1**2*K*f*fd*r + 20*D1**2*K*f*fd*s - 94*D1**2*K*f*fd + 136*D1**2*K*f*fdd*r**2 + 48*D1**2*K*f*fdd*r*s - 136*D1**2*K*f*fdd*r - 24*D1**2*K*f*fdd*s + 68*D1**2*K*f*fdd + 136*D1**2*K*fd**2*r**2 + 48*D1**2*K*fd**2*r*s - 136*D1**2*K*fd**2*r - 24*D1**2*K*fd**2*s - 14*D1**2*b2*fd*r**2 - 14*D1**2*b2*fd*r*s + 42*D1**2*b2*fdd*r**2 + 42*D1**2*b2*fdd*r*s + 42*D1**2*bd1**2*f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 14*D1**2*bd2*f*r**2 - 14*D1**2*bd2*f*r*s + 14*D1**2*bd2*f*r + 84*D1**2*bd2*fd*r**2 + 84*D1**2*bd2*fd*r*s - 42*D1**2*bd2*fd*r + D1**2*bdd1*f*(28*K*(10*r**2 + 4*r*(s - 3) - 2*s + 5) - 3*f*(102*r**2 + 2*r*(52*s - 77) - 58*s + 57) - 210*r**2 - 112*r*s + 266*r + 56*s - 105) + 42*D1**2*bdd2*f*r**2 + 42*D1**2*bdd2*f*r*s - 42*D1**2*bdd2*f*r + 138*D1**2*f**2*fd*r**2 - 78*D1**2*f**2*fd*r*s - 94*D1**2*f**2*fd*r - 82*D1**2*f**2*fd*s + 106*D1**2*f**2*fd - 150*D1**2*f**2*fdd*r**2 + 66*D1**2*f**2*fdd*r*s + 104*D1**2*f**2*fdd*r + 86*D1**2*f**2*fdd*s - 107*D1**2*f**2*fdd - 300*D1**2*f*fd**2*r**2 + 132*D1**2*f*fd**2*r*s + 208*D1**2*f*fd**2*r + 172*D1**2*f*fd**2*s - 106*D1**2*f*fd**2 + 140*D1**2*f*fd*r**2 + 40*D1**2*f*fd*r*s - 140*D1**2*f*fd*r - 20*D1**2*f*fd*s + 70*D1**2*f*fd - 98*D1**2*f*fdd*r**2 - 48*D1**2*f*fdd*r*s + 98*D1**2*f*fdd*r + 24*D1**2*f*fdd*s - 49*D1**2*f*fdd + 140*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 280*D1**2*f*gdd2*r**2 - 112*D1**2*f*gdd2*r*s + 112*D1**2*f*gdd2*r - 98*D1**2*fd**2*r**2 - 48*D1**2*fd**2*r*s + 98*D1**2*fd**2*r + 24*D1**2*fd**2*s + 140*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s - 560*D1**2*fd*gd2*r**2 - 224*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 280*D1**2*fdd*g2*r**2 - 112*D1**2*fdd*g2*r*s - 376*D1*Dd*K*f**2*r**2 - 80*D1*Dd*K*f**2*r*s + 228*D1*Dd*K*f**2*r + 20*D1*Dd*K*f**2*s - 94*D1*Dd*K*f**2 + 1088*D1*Dd*K*f*fd*r**2 + 384*D1*Dd*K*f*fd*r*s - 912*D1*Dd*K*f*fd*r - 144*D1*Dd*K*f*fd*s + 184*D1*Dd*K*f*fd - 56*D1*Dd*b2*f*r**2 - 56*D1*Dd*b2*f*r*s + 56*D1*Dd*b2*f*r + 14*D1*Dd*b2*f*s - 14*D1*Dd*b2*f + 336*D1*Dd*b2*fd*r**2 + 336*D1*Dd*b2*fd*r*s - 168*D1*Dd*b2*fd*r - 42*D1*Dd*b2*fd*s + 336*D1*Dd*bd2*f*r**2 + 336*D1*Dd*bd2*f*r*s - 336*D1*Dd*bd2*f*r - 42*D1*Dd*bd2*f*s + 42*D1*Dd*bd2*f + 184*D1*Dd*f**3*r**2 - 104*D1*Dd*f**3*r*s - 40*D1*Dd*f**3*r + 26*D1*Dd*f**3*s + 46*D1*Dd*f**3 - 1200*D1*Dd*f**2*fd*r**2 + 528*D1*Dd*f**2*fd*r*s + 584*D1*Dd*f**2*fd*r + 278*D1*Dd*f**2*fd*s - 276*D1*Dd*f**2*fd + 280*D1*Dd*f**2*r**2 + 80*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r - 20*D1*Dd*f**2*s + 70*D1*Dd*f**2 - 784*D1*Dd*f*fd*r**2 - 384*D1*Dd*f*fd*r*s + 684*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s - 146*D1*Dd*f*fd + 560*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s + 140*D1*Dd*f*g2 - 2240*D1*Dd*f*gd2*r**2 - 896*D1*Dd*f*gd2*r*s + 1232*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s - 112*D1*Dd*f*gd2 - 2240*D1*Dd*fd*g2*r**2 - 896*D1*Dd*fd*g2*r*s + 784*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s + 272*D1*Ddd*K*f**2*r**2 + 96*D1*Ddd*K*f**2*r*s - 184*D1*Ddd*K*f**2*r - 24*D1*Ddd*K*f**2*s + 68*D1*Ddd*K*f**2 + 168*D1*Ddd*b2*f*r**2 + 168*D1*Ddd*b2*f*r*s - 168*D1*Ddd*b2*f*r - 42*D1*Ddd*b2*f*s + 42*D1*Ddd*b2*f - 200*D1*Ddd*f**3*r**2 + 88*D1*Ddd*f**3*r*s + 56*D1*Ddd*f**3*r - 22*D1*Ddd*f**3*s - 50*D1*Ddd*f**3 - 196*D1*Ddd*f**2*r**2 - 96*D1*Ddd*f**2*r*s + 146*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s - 49*D1*Ddd*f**2 - 1120*D1*Ddd*f*g2*r**2 - 448*D1*Ddd*f*g2*r*s + 784*D1*Ddd*f*g2*r + 112*D1*Ddd*f*g2*s - 280*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*(68*r**2 + 4*r*(29*s - 35) - 69*s + 45) + f*(-6*fd*(102*r**2 + r*(104*s - 103) - 26*s + 16) + (7 - 7*K)*(10*r**2 - 4*r*(s + 2) + 2*s + 5)) + 7*fd*(r**2*(40*K - 30) + r*(8*K*(2*s - 3) - 16*s + 19) - s*(4*K - 4))) + Dd*f*(56*K*(20*r**2 + 8*r*s - 19*r - 3*s + 4) - 3*f*(408*r**2 + r*(416*s - 514) - 168*s + 135) - 840*r**2 - 448*r*s + 854*r + 168*s - 189)) + 816*Dd**2*K*f**2*r**2 + 288*Dd**2*K*f**2*r*s - 552*Dd**2*K*f**2*r - 72*Dd**2*K*f**2*s + 48*Dd**2*K*f**2 + 504*Dd**2*b2*f*r**2 + 504*Dd**2*b2*f*r*s - 504*Dd**2*b2*f*r - 126*Dd**2*b2*f*s + 84*Dd**2*b2*f - 600*Dd**2*f**3*r**2 + 264*Dd**2*f**3*r*s + 168*Dd**2*f**3*r - 66*Dd**2*f**3*s + 44*Dd**2*f**3 - 588*Dd**2*f**2*r**2 - 288*Dd**2*f**2*r*s + 438*Dd**2*f**2*r + 72*Dd**2*f**2*s - 48*Dd**2*f**2 - 3360*Dd**2*f*g2*r**2 - 1344*Dd**2*f*g2*r*s + 2352*Dd**2*f*g2*r + 336*Dd**2*f*g2*s - 224*Dd**2*f*g2) + 22*b2*(-21*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 22*D1**2*f*fd*r**2 + 22*D1**2*f*fd*r*s - 22*D1**2*f*fd*r - 11*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 18*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 9*D1**2*f*fdd - 18*D1**2*fd**2*r**2 - 18*D1**2*fd**2*r*s + 18*D1**2*fd**2*r + 9*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 44*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r - 11*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 144*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r + 54*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 36*D1*Ddd*f**2*r**2 - 36*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r + 9*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 108*Dd**2*f**2*r**2 - 108*Dd**2*f**2*r*s + 108*Dd**2*f**2*r + 27*Dd**2*f**2*s - 18*Dd**2*f**2))/(1155*d**2*k3**4) - 2*D1**2*Pk3*Pkd1*ct*k2*st**4*(3*D1*bd1*f*(D1*(f*s*(6*C - 7)*(r - 1) - fd*(10*C - 7)*(r*(4*s - 1) - 2*s + 1)) - Dd*f*(10*C - 7)*(r*(8*s - 2) - 5*s + 2)) - 3*b1*(D1*Dd*f*(-f*(6*C - 7)*(r*(4*s - 2) - s) + fd*(10*C - 7)*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(6*C - 7) + f*fdd*(7 - 10*C) + fd**2*(7 - 10*C)) + Ddd*f**2*(10*C - 7)*(r*(4*s - 2) - s)) + Dd**2*f**2*(10*C - 7)*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(f*(14*C - 11)*(r*(4*s - 2) - s) - fd*(10*C - 7)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(f*fd*(14*C - 11)*(r*(3*s - 1) - s) - f*(10*C - 7)*(3*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) - fd**2*(10*C - 7)*(r*(6*s - 2) - 2*s + 1)) - Ddd*f**2*(10*C - 7)*(r*(4*s - 2) - s)) - Dd**2*f**2*(10*C - 7)*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k3**2) + D1**2*Pk3*Pkd1*ct*k2*st**2*(7*b1**2*(2*D1*Dd*(f*(6*C - 6)*(r*(4*s - 2) - s) + fd*(2*C*(40*r**2 + 8*r*(s - 2) - s + 1) - 60*r**2 - 16*r*s + 27*r + 2*s - 2)) + D1*(D1*r*(fd*(12*C - 12)*(s - 1) + fdd*(4*C*(5*r + s - 1) - 15*r - 4*s + 4)) + Ddd*f*(4*C*(20*r**2 + 4*r*(s - 3) - s + 5) - 60*r**2 - 16*r*s + 38*r + 4*s - 15)) + 2*Dd**2*f*(2*C*(60*r**2 + 12*r*(s - 3) - 3*s + 2) - 90*r**2 - 24*r*s + 57*r + 6*s - 4)) + b1*(-96*C*D1**2*f*fd*r**2 + 344*C*D1**2*f*fd*r*s + 20*C*D1**2*f*fd*r - 4*C*D1**2*f*fd*s - 96*C*D1**2*f*fd - 64*C*D1**2*f*fdd*r**2 - 312*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s + 76*C*D1**2*f*fdd - 64*C*D1**2*fd**2*r**2 - 312*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 - 192*C*D1*Dd*f**2*r**2 + 688*C*D1*Dd*f**2*r*s - 248*C*D1*Dd*f**2*r - 172*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 - 512*C*D1*Dd*f*fd*r**2 - 2496*C*D1*Dd*f*fd*r*s + 768*C*D1*Dd*f*fd*r + 264*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd - 128*C*D1*Ddd*f**2*r**2 - 624*C*D1*Ddd*f**2*r*s + 376*C*D1*Ddd*f**2*r + 156*C*D1*Ddd*f**2*s - 32*C*D1*Ddd*f**2 - 384*C*Dd**2*f**2*r**2 - 1872*C*Dd**2*f**2*r*s + 1128*C*Dd**2*f**2*r + 468*C*Dd**2*f**2*s - 312*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(4*C*(10*r**2 + 2*r*(s - 5) - s + 5) - 30*r**2 - 8*r*s + 30*r + 4*s - 15) + 48*D1**2*f*fd*r**2 - 248*D1**2*f*fd*r*s - 20*D1**2*f*fd*r + 4*D1**2*f*fd*s + 72*D1**2*f*fd + 32*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r + 12*D1**2*f*fdd*s - 57*D1**2*f*fdd + 32*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 18*D1**2*fd**2*r + 12*D1**2*fd**2*s - 12*D1**2*fd**2 + 96*D1*Dd*f**2*r**2 - 496*D1*Dd*f**2*r*s + 200*D1*Dd*f**2*r + 124*D1*Dd*f**2*s + 24*D1*Dd*f**2 + 256*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 664*D1*Dd*f*fd*r - 216*D1*Dd*f*fd*s - 6*D1*Dd*f*fd + 64*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 296*D1*Ddd*f**2*r - 132*D1*Ddd*f**2*s + 16*D1*Ddd*f**2 + 14*D1*bd1*(D1*(f*s*(6*C - 6)*(2*r - 1) + fd*(C*(40*r**2 + 8*r*(s - 3) - 2*s + 2) - 30*r**2 - 8*r*s + 19*r + 2*s - 2)) + Dd*f*(4*C*(40*r**2 + 8*r*(s - 4) - 3*s + 6) - 120*r**2 - 32*r*s + 98*r + 12*s - 19)) + 192*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 888*Dd**2*f**2*r - 396*Dd**2*f**2*s + 264*Dd**2*f**2) + f*(240*C*D1**2*f*fd*r**2 + 216*C*D1**2*f*fd*r*s - 232*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s + 80*C*D1**2*f*fd - 228*C*D1**2*f*fdd*r**2 - 216*C*D1**2*f*fdd*r*s + 224*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s - 76*C*D1**2*f*fdd - 456*C*D1**2*fd**2*r**2 - 432*C*D1**2*fd**2*r*s + 448*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s - 72*C*D1**2*fd**2 + 320*C*D1*Dd*f**2*r**2 + 288*C*D1*Dd*f**2*r*s - 304*C*D1*Dd*f**2*r - 72*C*D1*Dd*f**2*s + 80*C*D1*Dd*f**2 - 1824*C*D1*Dd*f*fd*r**2 - 1728*C*D1*Dd*f*fd*r*s + 1784*C*D1*Dd*f*fd*r + 504*C*D1*Dd*f*fd*s - 368*C*D1*Dd*f*fd - 304*C*D1*Ddd*f**2*r**2 - 288*C*D1*Ddd*f**2*r*s + 296*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s - 76*C*D1*Ddd*f**2 - 912*C*Dd**2*f**2*r**2 - 864*C*Dd**2*f**2*r*s + 888*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s - 144*C*Dd**2*f**2 + 14*D1**2*bd1**2*(r**2*(20*C - 15) + r*(4*C*(s - 5) - 4*s + 15) - s*(2*C - 2)) + D1**2*bdd1*f*(-4*C*(8*r**2 + r*(39*s - 54) - 42*s + 27) + 16*r**2 + 2*r*(66*s - 73) - 144*s + 73) - 168*D1**2*f*fd*r**2 - 168*D1**2*f*fd*r*s + 168*D1**2*f*fd*r + 56*D1**2*f*fd*s - 56*D1**2*f*fd + 147*D1**2*f*fdd*r**2 + 192*D1**2*f*fdd*r*s - 162*D1**2*f*fdd*r - 64*D1**2*f*fdd*s + 49*D1**2*f*fdd + 294*D1**2*fd**2*r**2 + 384*D1**2*fd**2*r*s - 324*D1**2*fd**2*r - 128*D1**2*fd**2*s + 64*D1**2*fd**2 - 224*D1*Dd*f**2*r**2 - 224*D1*Dd*f**2*r*s + 224*D1*Dd*f**2*r + 56*D1*Dd*f**2*s - 56*D1*Dd*f**2 + 1176*D1*Dd*f*fd*r**2 + 1536*D1*Dd*f*fd*r*s - 1326*D1*Dd*f*fd*r - 448*D1*Dd*f*fd*s + 290*D1*Dd*f*fd + 196*D1*Ddd*f**2*r**2 + 256*D1*Ddd*f**2*r*s - 226*D1*Ddd*f**2*r - 64*D1*Ddd*f**2*s + 49*D1*Ddd*f**2 - 2*D1*bd1*(D1*(2*f*(C*(12*r**2 - 43*r*s + 24*r + 42*s - 12) - 6*r**2 + 31*r*s - 24*r - 30*s + 12) + fd*(2*C*(32*r**2 + 156*r*s - 109*r - 81*s + 42) - 32*r**2 - 264*r*s + 155*r + 138*s - 72)) + Dd*f*(2*C*(64*r**2 + r*(312*s - 310) - 207*s + 138) - 64*r**2 - 88*r*(6*s - 5) + 354*s - 217)) + 588*Dd**2*f**2*r**2 + 768*Dd**2*f**2*r*s - 678*Dd**2*f**2*r - 192*Dd**2*f**2*s + 128*Dd**2*f**2))/(105*d**2*k3**2) + 2*D1**2*Pk3*Pkd1*ct*k2*(28*D1**2*K*bd1**2*f*r**2 - 28*D1**2*K*bd1**2*f*r*s + 98*D1**2*K*bd1**2*f*r + 35*D1**2*K*bd1**2*f*s - 35*D1**2*K*bd1**2*f + 30*D1**2*K*bd1*f**2*r**2 + 21*D1**2*K*bd1*f**2*r*s - 21*D1**2*K*bd1*f**2*r - 144*D1**2*K*bd1*f*fd*r**2 - 84*D1**2*K*bd1*f*fd*r*s + 114*D1**2*K*bd1*f*fd*r + 21*D1**2*K*bd1*f*fd*s - 21*D1**2*K*bd1*f*fd - 36*D1**2*K*bdd1*f**2*r**2 - 21*D1**2*K*bdd1*f**2*r*s + 21*D1**2*K*bdd1*f**2*r + 84*D1**2*bd1**2*f**2*r*s - 57*D1**2*bd1**2*f**2*r - 63*D1**2*bd1**2*f**2*s + 42*D1**2*bd1**2*f**2 + 70*D1**2*bd1**2*f*r*s - 91*D1**2*bd1**2*f*r - 56*D1**2*bd1**2*f*s + 56*D1**2*bd1**2*f - 280*D1**2*bd1**2*g2*r**2 - 140*D1**2*bd1**2*g2*r*s + 280*D1**2*bd1**2*g2*r + 70*D1**2*bd1**2*g2*s - 84*D1**2*bd1*bd2*f*r**2 - 70*D1**2*bd1*bd2*f*r*s + 119*D1**2*bd1*bd2*f*r + 35*D1**2*bd1*bd2*f*s - 35*D1**2*bd1*bd2*f - 15*D1**2*bd1*f**3*r**2 - 45*D1**2*bd1*f**3*r*s + 30*D1**2*bd1*f**3*r + 90*D1**2*bd1*f**2*fd*r**2 + 270*D1**2*bd1*f**2*fd*r*s - 180*D1**2*bd1*f**2*fd*r - 45*D1**2*bd1*f**2*fd*s + 30*D1**2*bd1*f**2*fd - 21*D1**2*bd1*f**2*r**2 - 30*D1**2*bd1*f**2*r*s + 30*D1**2*bd1*f**2*r + 84*D1**2*bd1*f*fd*r**2 + 144*D1**2*bd1*f*fd*r*s - 114*D1**2*bd1*f*fd*r - 36*D1**2*bd1*f*fd*s + 36*D1**2*bd1*f*fd + 56*D1**2*bd1*f*g2*r**2 - 56*D1**2*bd1*f*g2*r*s + 56*D1**2*bd1*f*g2*r + 70*D1**2*bd1*f*g2*s - 28*D1**2*bd1*f*g2 - 56*D1**2*bd1*f*gd2*r**2 + 56*D1**2*bd1*f*gd2*r*s - 196*D1**2*bd1*f*gd2*r - 70*D1**2*bd1*f*gd2*s + 70*D1**2*bd1*f*gd2 - 56*D1**2*bd1*fd*g2*r**2 + 56*D1**2*bd1*fd*g2*r*s + 56*D1**2*bd1*fd*g2*r - 28*D1**2*bd1*fd*g2*s + 30*D1**2*bd2*f**2*r**2 + 21*D1**2*bd2*f**2*r*s - 21*D1**2*bd2*f**2*r - 144*D1**2*bd2*f*fd*r**2 - 84*D1**2*bd2*f*fd*r*s + 114*D1**2*bd2*f*fd*r + 21*D1**2*bd2*f*fd*s - 21*D1**2*bd2*f*fd + 15*D1**2*bdd1*f**3*r**2 + 45*D1**2*bdd1*f**3*r*s - 30*D1**2*bdd1*f**3*r + 21*D1**2*bdd1*f**2*r**2 + 36*D1**2*bdd1*f**2*r*s - 36*D1**2*bdd1*f**2*r - 28*D1**2*bdd1*f*g2*r**2 + 28*D1**2*bdd1*f*g2*r*s - 168*D1**2*bdd1*f*g2*r - 70*D1**2*bdd1*f*g2*s + 84*D1**2*bdd1*f*g2 - 36*D1**2*bdd2*f**2*r**2 - 21*D1**2*bdd2*f**2*r*s + 21*D1**2*bdd2*f**2*r - 60*D1**2*f**2*gd2*r**2 - 42*D1**2*f**2*gd2*r*s + 42*D1**2*f**2*gd2*r + 72*D1**2*f**2*gdd2*r**2 + 42*D1**2*f**2*gdd2*r*s - 42*D1**2*f**2*gdd2*r - 120*D1**2*f*fd*g2*r**2 - 84*D1**2*f*fd*g2*r*s + 120*D1**2*f*fd*g2*r + 42*D1**2*f*fd*g2*s - 60*D1**2*f*fd*g2 + 288*D1**2*f*fd*gd2*r**2 + 168*D1**2*f*fd*gd2*r*s - 228*D1**2*f*fd*gd2*r - 42*D1**2*f*fd*gd2*s + 42*D1**2*f*fd*gd2 + 144*D1**2*f*fdd*g2*r**2 + 84*D1**2*f*fdd*g2*r*s - 144*D1**2*f*fdd*g2*r - 42*D1**2*f*fdd*g2*s + 72*D1**2*f*fdd*g2 + 144*D1**2*fd**2*g2*r**2 + 84*D1**2*fd**2*g2*r*s - 144*D1**2*fd**2*g2*r - 42*D1**2*fd**2*g2*s - 288*D1*Dd*K*bd1*f**2*r**2 - 168*D1*Dd*K*bd1*f**2*r*s + 198*D1*Dd*K*bd1*f**2*r + 21*D1*Dd*K*bd1*f**2*s - 21*D1*Dd*K*bd1*f**2 + 120*D1*Dd*bd1*f**3*r**2 + 360*D1*Dd*bd1*f**3*r*s - 240*D1*Dd*bd1*f**3*r - 45*D1*Dd*bd1*f**3*s + 30*D1*Dd*bd1*f**3 + 168*D1*Dd*bd1*f**2*r**2 + 288*D1*Dd*bd1*f**2*r*s - 258*D1*Dd*bd1*f**2*r - 36*D1*Dd*bd1*f**2*s + 36*D1*Dd*bd1*f**2 - 224*D1*Dd*bd1*f*g2*r**2 + 224*D1*Dd*bd1*f*g2*r*s - 672*D1*Dd*bd1*f*g2*r - 308*D1*Dd*bd1*f*g2*s + 308*D1*Dd*bd1*f*g2 - 288*D1*Dd*bd2*f**2*r**2 - 168*D1*Dd*bd2*f**2*r*s + 198*D1*Dd*bd2*f**2*r + 21*D1*Dd*bd2*f**2*s - 21*D1*Dd*bd2*f**2 - 240*D1*Dd*f**2*g2*r**2 - 168*D1*Dd*f**2*g2*r*s + 204*D1*Dd*f**2*g2*r + 42*D1*Dd*f**2*g2*s - 60*D1*Dd*f**2*g2 + 576*D1*Dd*f**2*gd2*r**2 + 336*D1*Dd*f**2*gd2*r*s - 396*D1*Dd*f**2*gd2*r - 42*D1*Dd*f**2*gd2*s + 42*D1*Dd*f**2*gd2 + 1152*D1*Dd*f*fd*g2*r**2 + 672*D1*Dd*f*fd*g2*r*s - 1032*D1*Dd*f*fd*g2*r - 252*D1*Dd*f*fd*g2*s + 228*D1*Dd*f*fd*g2 + 288*D1*Ddd*f**2*g2*r**2 + 168*D1*Ddd*f**2*g2*r*s - 228*D1*Ddd*f**2*g2*r - 42*D1*Ddd*f**2*g2*s + 72*D1*Ddd*f**2*g2 + 864*Dd**2*f**2*g2*r**2 + 504*Dd**2*f**2*g2*r*s - 684*Dd**2*f**2*g2*r - 126*Dd**2*f**2*g2*s + 84*Dd**2*f**2*g2 + 7*b1**3*(D1**2*r*(fd*(r + 5*s - 5) + fdd*(-3*r - 5*s + 5)) + D1*(Dd*f*(4*r**2 + 4*r*(5*s - 3) - 5*s + 1) + Dd*fd*(-24*r**2 - 40*r*s + 36*r + 5*s - 5) + 5*Dd*(K*(8*r**2 + r*(4*s - 6) - s + 2) - 4*r**2 - 4*r*(s - 1) + s - 1) + Ddd*f*(-12*r**2 - 4*r*(5*s - 4) + 5*s - 3) + 5*Ddd*(K*(8*r**2 + r*(4*s - 6) - s + 2) - 4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*(5*K*(24*r**2 + 6*r*(2*s - 3) - 3*s + 2) + f*(-36*r**2 - 60*r*s + 48*r + 15*s - 10) - 60*r**2 - 60*r*(s - 1) + 15*s - 10)) + b1**2*(-28*D1**2*K*fd*r**2 + 28*D1**2*K*fd*r*s + 84*D1**2*K*fd*r + 7*D1**2*K*fd*s - 42*D1**2*K*fd + 14*D1**2*K*fdd*r**2 - 14*D1**2*K*fdd*r*s - 112*D1**2*K*fdd*r - 21*D1**2*K*fdd*s + 56*D1**2*K*fdd - 7*D1**2*bdd1*(-5*K*(6*r**2 + 3*r*s - 5*r - s + 2) + f*(9*r**2 + r*(15*s - 11) - 5*s + 3) + 15*r**2 + 15*r*s - 15*r - 5*s + 5) - 84*D1**2*f*fd*r*s + 33*D1**2*f*fd*r - 21*D1**2*f*fd*s + 15*D1**2*f*fd + 84*D1**2*f*fdd*r*s - 27*D1**2*f*fdd*r + 21*D1**2*f*fdd*s - 18*D1**2*f*fdd + 84*D1**2*fd**2*r*s - 27*D1**2*fd**2*r + 21*D1**2*fd**2*s - 21*D1**2*fd**2 - 35*D1**2*fd*r*s - 42*D1**2*fd*r - 7*D1**2*fd*s + 21*D1**2*fd + 35*D1**2*fdd*r*s + 56*D1**2*fdd*r + 21*D1**2*fdd*s - 28*D1**2*fdd - 140*D1**2*gd2*r**2 - 70*D1**2*gd2*r*s + 70*D1**2*gd2*r - 140*D1**2*gdd2*r**2 - 70*D1**2*gdd2*r*s + 70*D1**2*gdd2*r - 112*D1*Dd*K*f*r**2 + 112*D1*Dd*K*f*r*s - 28*D1*Dd*K*f*s - 28*D1*Dd*K*f + 112*D1*Dd*K*fd*r**2 - 112*D1*Dd*K*fd*r*s - 448*D1*Dd*K*fd*r - 70*D1*Dd*K*fd*s + 154*D1*Dd*K*fd - 168*D1*Dd*f**2*r*s + 84*D1*Dd*f**2*r + 42*D1*Dd*f**2*s + 672*D1*Dd*f*fd*r*s - 276*D1*Dd*f*fd*r - 15*D1*Dd*f*fd - 140*D1*Dd*f*r*s + 70*D1*Dd*f*r + 35*D1*Dd*f*s + 280*D1*Dd*fd*r*s + 154*D1*Dd*fd*r + 49*D1*Dd*fd*s - 98*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 280*D1*Dd*g2*r*s + 420*D1*Dd*g2*r + 70*D1*Dd*g2*s - 140*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 560*D1*Dd*gd2*r*s + 700*D1*Dd*gd2*r + 70*D1*Dd*gd2*s - 70*D1*Dd*gd2 + 56*D1*Ddd*K*f*r**2 - 56*D1*Ddd*K*f*r*s + 14*D1*Ddd*K*f*s + 14*D1*Ddd*K*f + 168*D1*Ddd*f**2*r*s - 84*D1*Ddd*f**2*r - 42*D1*Ddd*f**2*s + 140*D1*Ddd*f*r*s - 70*D1*Ddd*f*r - 35*D1*Ddd*f*s - 560*D1*Ddd*g2*r**2 - 280*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r + 70*D1*Ddd*g2*s - 140*D1*Ddd*g2 + 7*D1*bd1*(D1*f*(3*r**2 + r*(15*s - 7) - 5*s + 1) + D1*fd*(-18*r**2 - 30*r*s + 26*r + 5*s - 5) + 5*D1*(K*(6*r**2 + r*(3*s - 5) - s + 2) - 3*r**2 - 3*r*(s - 1) + s - 1) + Dd*f*(-72*r**2 - 120*r*s + 92*r + 35*s - 21) + 5*Dd*(K*(24*r - 7)*(2*r + s - 1) - 24*r**2 - 24*r*(s - 1) + 7*s - 5)) + 168*Dd**2*K*f*r**2 - 168*Dd**2*K*f*r*s + 42*Dd**2*K*f*s - 28*Dd**2*K*f + 504*Dd**2*f**2*r*s - 252*Dd**2*f**2*r - 126*Dd**2*f**2*s + 84*Dd**2*f**2 + 420*Dd**2*f*r*s - 210*Dd**2*f*r - 105*Dd**2*f*s + 70*Dd**2*f - 1680*Dd**2*g2*r**2 - 840*Dd**2*g2*r*s + 1260*Dd**2*g2*r + 210*Dd**2*g2*s - 140*Dd**2*g2) - b1*(-60*D1**2*K*f*fd*r**2 - 42*D1**2*K*f*fd*r*s + 60*D1**2*K*f*fd*r + 21*D1**2*K*f*fd*s - 30*D1**2*K*f*fd + 72*D1**2*K*f*fdd*r**2 + 42*D1**2*K*f*fdd*r*s - 72*D1**2*K*f*fdd*r - 21*D1**2*K*f*fdd*s + 36*D1**2*K*f*fdd + 72*D1**2*K*fd**2*r**2 + 42*D1**2*K*fd**2*r*s - 72*D1**2*K*fd**2*r - 21*D1**2*K*fd**2*s - 14*D1**2*b2*fd*r**2 - 35*D1**2*b2*fd*r*s + 42*D1**2*b2*fdd*r**2 + 35*D1**2*b2*fdd*r*s + 7*D1**2*bd1**2*(-5*K*(12*r**2 + 6*r*s - 10*r - 2*s + 1) + f*(18*r**2 + r*(30*s - 22) - 10*s + 5) + 30*r**2 + 30*r*s - 30*r - 10*s + 5) - 14*D1**2*bd2*f*r**2 - 35*D1**2*bd2*f*r*s + 35*D1**2*bd2*f*r + 84*D1**2*bd2*fd*r**2 + 70*D1**2*bd2*fd*r*s - 35*D1**2*bd2*fd*r + D1**2*bdd1*(f**2*(-84*r*s + 57*r + 63*s - 18) - 7*f*(K*(4*r**2 - 4*r*s + 14*r + 5*s - 6) + 10*r*s - 13*r - 8*s + 4) + 70*g2*(4*r**2 + 2*r*(s - 2) - s + 2)) + 42*D1**2*bdd2*f*r**2 + 35*D1**2*bdd2*f*r*s - 35*D1**2*bdd2*f*r + 45*D1**2*f**2*fd*r**2 + 135*D1**2*f**2*fd*r*s - 90*D1**2*f**2*fd*r - 45*D1**2*f**2*fd*s + 15*D1**2*f**2*fd - 45*D1**2*f**2*fdd*r**2 - 135*D1**2*f**2*fdd*r*s + 90*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s - 15*D1**2*f**2*fdd - 90*D1**2*f*fd**2*r**2 - 270*D1**2*f*fd**2*r*s + 180*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s - 60*D1**2*f*fd**2 + 42*D1**2*f*fd*r**2 + 60*D1**2*f*fd*r*s - 42*D1**2*f*fd*r - 30*D1**2*f*fd*s + 21*D1**2*f*fd - 42*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 42*D1**2*f*fdd*r + 36*D1**2*f*fdd*s - 21*D1**2*f*fdd - 56*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r + 28*D1**2*f*gdd2*r**2 - 28*D1**2*f*gdd2*r*s + 28*D1**2*f*gdd2*r - 42*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 42*D1**2*fd**2*r + 36*D1**2*fd**2*s - 56*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*r + 14*D1**2*fd*g2*s - 84*D1**2*fd*g2 + 56*D1**2*fd*gd2*r**2 - 56*D1**2*fd*gd2*r*s - 196*D1**2*fd*gd2*r - 42*D1**2*fd*gd2*s + 42*D1**2*fd*gd2 + 28*D1**2*fdd*g2*r**2 - 28*D1**2*fdd*g2*r*s - 224*D1**2*fdd*g2*r - 42*D1**2*fdd*g2*s + 112*D1**2*fdd*g2 - 120*D1*Dd*K*f**2*r**2 - 84*D1*Dd*K*f**2*r*s + 102*D1*Dd*K*f**2*r + 21*D1*Dd*K*f**2*s - 30*D1*Dd*K*f**2 + 576*D1*Dd*K*f*fd*r**2 + 336*D1*Dd*K*f*fd*r*s - 516*D1*Dd*K*f*fd*r - 126*D1*Dd*K*f*fd*s + 114*D1*Dd*K*f*fd - 56*D1*Dd*b2*f*r**2 - 140*D1*Dd*b2*f*r*s + 98*D1*Dd*b2*f*r + 35*D1*Dd*b2*f*s - 14*D1*Dd*b2*f + 336*D1*Dd*b2*fd*r**2 + 280*D1*Dd*b2*fd*r*s - 154*D1*Dd*b2*fd*r - 35*D1*Dd*b2*fd*s + 336*D1*Dd*bd2*f*r**2 + 280*D1*Dd*bd2*f*r*s - 294*D1*Dd*bd2*f*r - 35*D1*Dd*bd2*f*s + 35*D1*Dd*bd2*f + 60*D1*Dd*f**3*r**2 + 180*D1*Dd*f**3*r*s - 120*D1*Dd*f**3*r - 45*D1*Dd*f**3*s + 15*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r**2 - 1080*D1*Dd*f**2*fd*r*s + 720*D1*Dd*f**2*fd*r + 315*D1*Dd*f**2*fd*s - 180*D1*Dd*f**2*fd + 84*D1*Dd*f**2*r**2 + 120*D1*Dd*f**2*r*s - 102*D1*Dd*f**2*r - 30*D1*Dd*f**2*s + 21*D1*Dd*f**2 - 336*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 396*D1*Dd*f*fd*r + 216*D1*Dd*f*fd*s - 114*D1*Dd*f*fd - 224*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*s - 56*D1*Dd*f*g2 + 224*D1*Dd*f*gd2*r**2 - 224*D1*Dd*f*gd2*r*s + 112*D1*Dd*f*gd2*r + 28*D1*Dd*f*gd2*s - 28*D1*Dd*f*gd2 + 224*D1*Dd*fd*g2*r**2 - 224*D1*Dd*fd*g2*r*s - 896*D1*Dd*fd*g2*r - 140*D1*Dd*fd*g2*s + 308*D1*Dd*fd*g2 + 144*D1*Ddd*K*f**2*r**2 + 84*D1*Ddd*K*f**2*r*s - 114*D1*Ddd*K*f**2*r - 21*D1*Ddd*K*f**2*s + 36*D1*Ddd*K*f**2 + 168*D1*Ddd*b2*f*r**2 + 140*D1*Ddd*b2*f*r*s - 154*D1*Ddd*b2*f*r - 35*D1*Ddd*b2*f*s + 42*D1*Ddd*b2*f - 60*D1*Ddd*f**3*r**2 - 180*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r + 45*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 - 84*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 114*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s - 21*D1*Ddd*f**2 + 112*D1*Ddd*f*g2*r**2 - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*s + 28*D1*Ddd*f*g2 + D1*bd1*(D1*(3*f**2*(r*(28*s - 17) - 21*s + 5) - 7*f*(K*(-8*r**2 + 8*r*(s - 1) - 5*s + 2) + 3*fd*(8*r*(2*s - 1) - 4*s + 3) - 10*r*s + 11*r + 6*s - 3) - 7*fd*(K*(8*r**2 - 2*r*(4*s + 9) - s + 3) + r*(20*s + 3) - 2*s - 3) + 70*g2*(4*r**2 + 2*r*(s - 2) - s + 2) + 70*gd2*(4*r - 1)*(2*r + s - 1)) + Dd*(f**2*(r*(396 - 672*s) + 336*s - 183) - 7*f*(8*K*(4*r**2 - 4*r*s + 7*r + 3*s - 3) + 80*r*s - 72*r - 42*s + 29) + 140*g2*(8*r - 3)*(2*r + s - 1))) + 432*Dd**2*K*f**2*r**2 + 252*Dd**2*K*f**2*r*s - 342*Dd**2*K*f**2*r - 63*Dd**2*K*f**2*s + 42*Dd**2*K*f**2 + 504*Dd**2*b2*f*r**2 + 420*Dd**2*b2*f*r*s - 462*Dd**2*b2*f*r - 105*Dd**2*b2*f*s + 70*Dd**2*b2*f - 180*Dd**2*f**3*r**2 - 540*Dd**2*f**3*r*s + 360*Dd**2*f**3*r + 135*Dd**2*f**3*s - 90*Dd**2*f**3 - 252*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 342*Dd**2*f**2*r + 108*Dd**2*f**2*s - 72*Dd**2*f**2 + 336*Dd**2*f*g2*r**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*s - 56*Dd**2*f*g2) + b2*(-7*D1**2*bdd1*f*(r - 1)*(6*r + 5*s - 6) + 3*D1**2*(f*(fd*(20*r**2 + 14*r*s - 20*r - 7*s + 10) + fdd*(-24*r**2 - 14*r*s + 24*r + 7*s - 12)) + fd**2*(-24*r**2 + r*(24 - 14*s) + 7*s)) + 7*D1*bd1*(D1*(f*(r - 1)*(2*r + 5*s - 2) + fd*(-12*r**2 - 10*r*s + 12*r + 5*s)) + Dd*f*(-48*r**2 + r*(70 - 40*s) + 25*s - 22)) + 3*D1*f*(Dd*(f*(40*r**2 + 28*r*s - 34*r - 7*s + 10) - 2*fd*(96*r**2 + 56*r*s - 86*r - 21*s + 19)) + Ddd*f*(-48*r**2 + r*(38 - 28*s) + 7*s - 12)) + 3*Dd**2*f**2*(-144*r**2 - 84*r*s + 114*r + 21*s - 14)))/(105*d**2*k3**2) - D1**2*Pk3*Pkd1*ct*st**2*(4*C - 2)*(D1*f*(21*D1*bd1**2*s*(1 - 2*r) + D1*bd1*(11*f*r*s + 9*fd*(-4*r*s + r + s)) - 9*D1*bdd1*f*r*s + 9*Dd*bd1*f*(r*(2 - 8*s) + s)) - 7*b1**2*(D1*Dd*(f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(D1*Dd*f*(11*f*(4*r*s - 2*r - s) - 9*fd*(8*r - 3)*(2*s - 1)) + 7*D1*bd1*(D1*(f*s*(2*r - 1) + 3*fd*(-4*r*s + 2*r + s - 1)) - 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(11*f*fd*(r*(2*s - 1) - s) + 3*f*(7*bdd1*s*(1 - 2*r) + 3*fdd*(-2*r*s + r + s)) + 9*fd**2*(-2*r*s + r + s - 1)) + 9*Ddd*f**2*(r*(2 - 4*s) + s)) - 9*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(105*d**2*k2) + D1**2*Pk3*Pkd1*ct*(4*C - 2)*(D1*f*(5*D1*bd1**2*s*(1 - 2*r) - 3*D1*bdd1*f*r*s + 3*bd1*(D1*(f*r*s + fd*(-4*r*s + r + s)) + Dd*f*(r*(2 - 8*s) + s))) - 5*b1**2*(D1*Dd*(f*r*(2 - 4*s) + f*s + fd*r*(8*s - 6) - fd*s + fd) - D1*(D1*r*(fd - fdd)*(s - 1) + Ddd*f*(r*(2 - 4*s) + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(3*D1*Dd*f*(f*r*(4*s - 2) - f*s - fd*(8*r - 3)*(2*s - 1)) + 5*D1*bd1*(D1*(f*s*(2*r - 1) + fd*(-4*r*s + 2*r + s - 1)) - 2*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(5*bdd1*f*s*(1 - 2*r) + 3*f*fd*r*(2*s - 1) - 3*f*fd*s + 3*f*fdd*(-2*r*s + r + s) + 3*fd**2*(-2*r*s + r + s - 1)) + 3*Ddd*f**2*(r*(2 - 4*s) + s)) + 3*Dd**2*f**2*(r*(6 - 12*s) + 3*s - 2)))/(15*d**2*k2) - 2*D1**2*Pk3*Pkd1*ct*k2**3*st**4*(36*D1**2*b1*f*fd*r**2 - 18*D1**2*b1*f*fdd*r**2 - 18*D1**2*b1*fd**2*r**2 - 9*D1**2*bdd1*f**2*(r - 1)**2 + 24*D1**2*f**2*fd*r**2 - 16*D1**2*f**2*fd*r + 8*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 + 8*D1**2*f**2*fdd*r - 4*D1**2*f**2*fdd - 24*D1**2*f*fd**2*r**2 + 16*D1**2*f*fd**2*r + 72*D1*Dd*b1*f**2*r**2 - 36*D1*Dd*b1*f**2*r + 18*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 + 36*D1*Dd*b1*f*fd*r + 32*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r + 8*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 + 56*D1*Dd*f**2*fd*r - 8*D1*Dd*f**2*fd - 36*D1*Ddd*b1*f**2*r**2 + 18*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2 - 16*D1*Ddd*f**3*r**2 + 8*D1*Ddd*f**3*r - 4*D1*Ddd*f**3 + 18*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 108*Dd**2*b1*f**2*r**2 + 54*Dd**2*b1*f**2*r - 48*Dd**2*f**3*r**2 + 24*Dd**2*f**3*r)/(105*d**2*k1**2*k3**2) + D1**2*Pk3*Pkd1*ct*k2**3*st**2*(D1*f*r*(6*D1*bd1**2*(6*f + 7)*(r - 1) + D1*bdd1*f*r*(18*f + 13) + 2*bd1*(-D1*f*r*(18*f + 13) + D1*fd*(18*f*(3*r - 1) + 26*r - 13) + Dd*f*(18*f + 13)*(4*r - 1))) - 3*b1**2*(D1**2*r**2*(-12*fd**2 + fd*(24*f + 14) - fdd*(12*f + 7)) + D1*(2*Dd*(6*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(28 - 48*fd) + r*(12*fd - 14) + 7) + 7*fd*r*(1 - 4*r)) - Ddd*f*(6*f + 7)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(6*f + 7)*(2*r - 1)) + b1*(3*D1**2*bdd1*f*(6*f + 7)*(2*r**2 - 2*r + 1) - 108*D1**2*f**2*fd*r**2 + 72*D1**2*f**2*fd*r - 36*D1**2*f**2*fd + 54*D1**2*f**2*fdd*r**2 - 36*D1**2*f**2*fdd*r + 18*D1**2*f**2*fdd + 108*D1**2*f*fd**2*r**2 - 72*D1**2*f*fd**2*r - 52*D1**2*f*fd*r**2 + 52*D1**2*f*fd*r - 26*D1**2*f*fd + 26*D1**2*f*fdd*r**2 - 26*D1**2*f*fdd*r + 13*D1**2*f*fdd + 26*D1**2*fd**2*r**2 - 26*D1**2*fd**2*r - 144*D1*Dd*f**3*r**2 + 72*D1*Dd*f**3*r - 36*D1*Dd*f**3 + 432*D1*Dd*f**2*fd*r**2 - 252*D1*Dd*f**2*fd*r + 36*D1*Dd*f**2*fd - 104*D1*Dd*f**2*r**2 + 52*D1*Dd*f**2*r - 26*D1*Dd*f**2 + 208*D1*Dd*f*fd*r**2 - 156*D1*Dd*f*fd*r + 26*D1*Dd*f*fd + 72*D1*Ddd*f**3*r**2 - 36*D1*Ddd*f**3*r + 18*D1*Ddd*f**3 + 52*D1*Ddd*f**2*r**2 - 26*D1*Ddd*f**2*r + 13*D1*Ddd*f**2 - 6*D1*bd1*(D1*(6*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(14 - 24*fd) + r*(12*fd - 14) + 7) + 7*fd*r*(1 - 2*r)) - Dd*f*(6*f + 7)*(8*r**2 - 6*r + 1)) + 216*Dd**2*f**3*r**2 - 108*Dd**2*f**3*r + 156*Dd**2*f**2*r**2 - 78*Dd**2*f**2*r))/(105*d**2*k1**2*k3**2) + D1**2*Pk3*Pkd1*ct*k2*st**2*(D1*f*r*(42*D1*bd1**2*(r - 1) + 13*D1*bdd1*f*r + 26*bd1*(-D1*(f*r - 2*fd*r + fd) + Dd*f*(4*r - 1))) - 21*b1**2*(D1**2*r**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*r*(1 - 4*r)) + D1*Ddd*f*(-4*r**2 + 2*r - 1) + 6*Dd**2*f*r*(1 - 2*r)) + b1*(21*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 13*D1**2*(f*(2*fd - fdd)*(2*r**2 - 2*r + 1) - 2*fd**2*r*(r - 1)) - 42*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(1 - 2*r) + Dd*f*(-8*r**2 + 6*r - 1)) - 13*D1*f*(2*Dd*(4*f*r**2 - 2*f*r + f - 8*fd*r**2 + 6*fd*r - fd) + Ddd*f*(-4*r**2 + 2*r - 1)) - 78*Dd**2*f**2*r*(1 - 2*r)))/(105*d**2*k1**2) - 2*D1**2*Pk3*Pkd1*ct*k2*(-2*D1**2*bd1**2*f*r**2*(3*f + 7) + 2*D1*b1*r*(-D1*bdd1*f*r*(3*f + 7) - 2*bd1*(-D1*f*r*(3*f + 7) + D1*fd*(6*f*r - 3*f + 7*r - 7) + Dd*f*(3*f + 7)*(4*r - 1))) + b1**2*(D1**2*(-6*fd**2*r*(r - 1) + 2*fd*(f*(6*r**2 - 6*r + 3) + 7*(r - 1)**2) - fdd*(f*(6*r**2 - 6*r + 3) + 7*(r - 1)**2)) + D1*(2*Dd*(3*f**2*(4*r**2 - 2*r + 1) - 3*f*fd*(8*r**2 - 6*r + 1) + 7*f*(4*r**2 - 2*r + 1) - 7*fd*(4*r**2 - 5*r + 1)) - Ddd*f*(3*f + 7)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(3*f + 7)*(2*r - 1)))/(105*d**2*k1**2) + 4*D1**2*Pk3*Pkd1*f*k2**6*st**6*(66*D1**2*b1*f*fd*r**2 + 66*D1**2*b1*f*fd*r*s - 44*D1**2*b1*f*fd*r - 33*D1**2*b1*f*fdd*r**2 - 33*D1**2*b1*f*fdd*r*s + 22*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 44*D1**2*b1*fd**2*r - 11*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 24*D1**2*f**2*fd*r**2 + 24*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s - 3*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 36*D1**2*f*fd**2*r + 9*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 88*D1*Dd*b1*f**2*r*s - 88*D1*Dd*b1*f**2*r - 22*D1*Dd*b1*f**2*s + 22*D1*Dd*b1*f**2 - 264*D1*Dd*b1*f*fd*r**2 - 264*D1*Dd*b1*f*fd*r*s + 220*D1*Dd*b1*f*fd*r + 33*D1*Dd*b1*f*fd*s - 22*D1*Dd*b1*f*fd + 24*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 24*D1*Dd*f**3*r - 6*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 96*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s - 18*D1*Dd*f**2*fd - 44*D1*Ddd*b1*f**2*r**2 - 44*D1*Ddd*b1*f**2*r*s + 44*D1*Ddd*b1*f**2*r + 11*D1*Ddd*b1*f**2*s - 11*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 12*D1*Ddd*f**3*r*s + 12*D1*Ddd*f**3*r + 3*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 11*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 132*Dd**2*b1*f**2*r**2 - 132*Dd**2*b1*f**2*r*s + 132*Dd**2*b1*f**2*r + 33*Dd**2*b1*f**2*s - 22*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 36*Dd**2*f**3*r*s + 36*Dd**2*f**3*r + 9*Dd**2*f**3*s - 6*Dd**2*f**3)/(693*d**2*k1*k3**6) - D1**2*Pk3*Pkd1*k1**5*st**2*(8*C - 4)*(6*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fd*r*s - 3*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 18*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 3*D1**2*f**2*fd*r**2 - 3*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r + D1**2*f**2*fd*s - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r - 10*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 + 12*D1*Dd*b1*f**2*r**2 + 12*D1*Dd*b1*f**2*r*s - 12*D1*Dd*b1*f**2*r - 3*D1*Dd*b1*f**2*s + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 108*D1*Dd*b1*f*fd*r - 18*D1*Dd*b1*f*fd*s + 9*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 4*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r + D1*Dd*f**3*s - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 120*D1*Dd*f**2*fd*r - 35*D1*Dd*f**2*fd*s + 25*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r - 5*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 108*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r - 27*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 60*Dd**2*f**3*r - 15*Dd**2*f**3*s + 10*Dd**2*f**3)/(315*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*k1**5*(7*D1**2*K*b1**2*fd*r**2 + 7*D1**2*K*b1**2*fd*r*s - 21*D1**2*K*b1**2*fdd*r**2 - 21*D1**2*K*b1**2*fdd*r*s + 18*D1**2*K*b1*f*fd*r**2 + 18*D1**2*K*b1*f*fd*r*s - 18*D1**2*K*b1*f*fd*r - 9*D1**2*K*b1*f*fd*s + 9*D1**2*K*b1*f*fd - 30*D1**2*K*b1*f*fdd*r**2 - 30*D1**2*K*b1*f*fdd*r*s + 30*D1**2*K*b1*f*fdd*r + 15*D1**2*K*b1*f*fdd*s - 15*D1**2*K*b1*f*fdd - 30*D1**2*K*b1*fd**2*r**2 - 30*D1**2*K*b1*fd**2*r*s + 30*D1**2*K*b1*fd**2*r + 15*D1**2*K*b1*fd**2*s - 21*D1**2*K*bd1**2*f*(2*r - 1)*(r + s - 1) - 14*D1**2*b1*f*gd2*r**2 - 14*D1**2*b1*f*gd2*r*s + 14*D1**2*b1*f*gd2*r + 42*D1**2*b1*f*gdd2*r**2 + 42*D1**2*b1*f*gdd2*r*s - 42*D1**2*b1*f*gdd2*r - 14*D1**2*b1*fd*g2*r**2 - 14*D1**2*b1*fd*g2*r*s + 84*D1**2*b1*fd*gd2*r**2 + 84*D1**2*b1*fd*gd2*r*s - 42*D1**2*b1*fd*gd2*r + 42*D1**2*b1*fdd*g2*r**2 + 42*D1**2*b1*fdd*g2*r*s - 3*D1**2*bdd1*f*(r + s - 1)*(7*K*b1*(2*r - 1) + 5*K*f*r - 14*g2*(r - 1)) - 18*D1**2*f**2*gd2*r**2 - 18*D1**2*f**2*gd2*r*s + 18*D1**2*f**2*gd2*r + 30*D1**2*f**2*gdd2*r**2 + 30*D1**2*f**2*gdd2*r*s - 30*D1**2*f**2*gdd2*r - 36*D1**2*f*fd*g2*r**2 - 36*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r + 18*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 + 120*D1**2*f*fd*gd2*r**2 + 120*D1**2*f*fd*gd2*r*s - 120*D1**2*f*fd*gd2*r - 30*D1**2*f*fd*gd2*s + 30*D1**2*f*fd*gd2 + 60*D1**2*f*fdd*g2*r**2 + 60*D1**2*f*fdd*g2*r*s - 60*D1**2*f*fdd*g2*r - 30*D1**2*f*fdd*g2*s + 30*D1**2*f*fdd*g2 + 60*D1**2*fd**2*g2*r**2 + 60*D1**2*fd**2*g2*r*s - 60*D1**2*fd**2*g2*r - 30*D1**2*fd**2*g2*s + 28*D1*Dd*K*b1**2*f*r**2 + 28*D1*Dd*K*b1**2*f*r*s - 28*D1*Dd*K*b1**2*f*r - 7*D1*Dd*K*b1**2*f*s + 7*D1*Dd*K*b1**2*f - 168*D1*Dd*K*b1**2*fd*r**2 - 168*D1*Dd*K*b1**2*fd*r*s + 84*D1*Dd*K*b1**2*fd*r + 21*D1*Dd*K*b1**2*fd*s + 36*D1*Dd*K*b1*f**2*r**2 + 36*D1*Dd*K*b1*f**2*r*s - 36*D1*Dd*K*b1*f**2*r - 9*D1*Dd*K*b1*f**2*s + 9*D1*Dd*K*b1*f**2 - 240*D1*Dd*K*b1*f*fd*r**2 - 240*D1*Dd*K*b1*f*fd*r*s + 240*D1*Dd*K*b1*f*fd*r + 90*D1*Dd*K*b1*f*fd*s - 60*D1*Dd*K*b1*f*fd - 56*D1*Dd*b1*f*g2*r**2 - 56*D1*Dd*b1*f*g2*r*s + 56*D1*Dd*b1*f*g2*r + 14*D1*Dd*b1*f*g2*s - 14*D1*Dd*b1*f*g2 + 336*D1*Dd*b1*f*gd2*r**2 + 336*D1*Dd*b1*f*gd2*r*s - 336*D1*Dd*b1*f*gd2*r - 42*D1*Dd*b1*f*gd2*s + 42*D1*Dd*b1*f*gd2 + 336*D1*Dd*b1*fd*g2*r**2 + 336*D1*Dd*b1*fd*g2*r*s - 168*D1*Dd*b1*fd*g2*r - 42*D1*Dd*b1*fd*g2*s - 72*D1*Dd*f**2*g2*r**2 - 72*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r + 18*D1*Dd*f**2*g2*s - 18*D1*Dd*f**2*g2 + 240*D1*Dd*f**2*gd2*r**2 + 240*D1*Dd*f**2*gd2*r*s - 240*D1*Dd*f**2*gd2*r - 30*D1*Dd*f**2*gd2*s + 30*D1*Dd*f**2*gd2 + 480*D1*Dd*f*fd*g2*r**2 + 480*D1*Dd*f*fd*g2*r*s - 480*D1*Dd*f*fd*g2*r - 180*D1*Dd*f*fd*g2*s + 120*D1*Dd*f*fd*g2 - 84*D1*Ddd*K*b1**2*f*r**2 - 84*D1*Ddd*K*b1**2*f*r*s + 84*D1*Ddd*K*b1**2*f*r + 21*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f - 60*D1*Ddd*K*b1*f**2*r**2 - 60*D1*Ddd*K*b1*f**2*r*s + 60*D1*Ddd*K*b1*f**2*r + 15*D1*Ddd*K*b1*f**2*s - 15*D1*Ddd*K*b1*f**2 + 168*D1*Ddd*b1*f*g2*r**2 + 168*D1*Ddd*b1*f*g2*r*s - 168*D1*Ddd*b1*f*g2*r - 42*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + 120*D1*Ddd*f**2*g2*r**2 + 120*D1*Ddd*f**2*g2*r*s - 120*D1*Ddd*f**2*g2*r - 30*D1*Ddd*f**2*g2*s + 30*D1*Ddd*f**2*g2 + D1*bd1*(9*D1*K*f**2*r*(r + s - 1) + D1*f*(7*K*b1*(2*r - 1)*(r + s - 1) - 15*K*fd*(4*r**2 + 4*r*(s - 1) - s + 1) - 14*g2*(r - 1)*(r + s - 1) + 42*gd2*(2*r - 1)*(r + s - 1)) + 21*D1*fd*(K*b1*(-4*r**2 + r*(3 - 4*s) + s) + g2*(4*r**2 + 4*r*(s - 1) - 2*s)) - 3*Dd*K*f*(7*b1*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 5*f*(8*r**2 + 8*r*(s - 1) - s + 1)) + 42*Dd*f*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 252*Dd**2*K*b1**2*f*r**2 - 252*Dd**2*K*b1**2*f*r*s + 252*Dd**2*K*b1**2*f*r + 63*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f - 180*Dd**2*K*b1*f**2*r**2 - 180*Dd**2*K*b1*f**2*r*s + 180*Dd**2*K*b1*f**2*r + 45*Dd**2*K*b1*f**2*s - 30*Dd**2*K*b1*f**2 + 504*Dd**2*b1*f*g2*r**2 + 504*Dd**2*b1*f*g2*r*s - 504*Dd**2*b1*f*g2*r - 126*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2 + 360*Dd**2*f**2*g2*r**2 + 360*Dd**2*f**2*g2*r*s - 360*Dd**2*f**2*g2*r - 90*Dd**2*f**2*g2*s + 60*Dd**2*f**2*g2)/(105*d**2*k3**6) - D1**2*Pk3*Pkd1*k1**3*k2**2*st**4*(8*C - 4)*(2*D1**2*b1*f*fd*r**2 + 2*D1**2*b1*f*fd*r*s - D1**2*b1*f*fd*r + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*f*fdd*r*s - 3*D1**2*b1*f*fdd*r + 6*D1**2*b1*fd**2*r**2 + 6*D1**2*b1*fd**2*r*s - 3*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 3*D1**2*f**2*fd*r**2 - 3*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r + D1**2*f**2*fd*s - D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 + 4*D1*Dd*b1*f**2*r**2 + 4*D1*Dd*b1*f**2*r*s - 4*D1*Dd*b1*f**2*r - D1*Dd*b1*f**2*s + D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 48*D1*Dd*b1*f*fd*r*s - 36*D1*Dd*b1*f*fd*r - 6*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 4*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r + D1*Dd*f**3*s - D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 24*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 5*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 + 12*D1*Ddd*b1*f**2*r*s - 12*D1*Ddd*b1*f**2*r - 3*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 4*D1*Ddd*f**3*r - D1*Ddd*f**3*s + D1*Ddd*f**3 + D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 36*Dd**2*b1*f**2*r**2 + 36*Dd**2*b1*f**2*r*s - 36*Dd**2*b1*f**2*r - 9*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 12*Dd**2*f**3*r - 3*Dd**2*f**3*s + 2*Dd**2*f**3)/(35*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*k1**3*k2**2*st**2*(-297*D1**2*K*bdd1*f**2*r**2 - 297*D1**2*K*bdd1*f**2*r*s + 297*D1**2*K*bdd1*f**2*r + 99*D1**2*bd1**2*f*(-7*K + 4*f)*(2*r - 1)*(r + s - 1) + 165*D1**2*bdd1*f**3*r**2 + 165*D1**2*bdd1*f**3*r*s - 110*D1**2*bdd1*f**3*r + 55*D1**2*bdd1*f**3*s - 55*D1**2*bdd1*f**3 + 1386*D1**2*bdd1*f*g2*r**2 + 1386*D1**2*bdd1*f*g2*r*s - 2772*D1**2*bdd1*f*g2*r - 1386*D1**2*bdd1*f*g2*s + 1386*D1**2*bdd1*f*g2 + 60*D1**2*f**3*fd*r**2 + 60*D1**2*f**3*fd*r*s - 60*D1**2*f**3*fd*r - 15*D1**2*f**3*fd*s + 15*D1**2*f**3*fd - 140*D1**2*f**3*fdd*r**2 - 140*D1**2*f**3*fdd*r*s + 140*D1**2*f**3*fdd*r + 35*D1**2*f**3*fdd*s - 35*D1**2*f**3*fdd - 420*D1**2*f**2*fd**2*r**2 - 420*D1**2*f**2*fd**2*r*s + 420*D1**2*f**2*fd**2*r + 105*D1**2*f**2*fd**2*s - 70*D1**2*f**2*fd**2 - 726*D1**2*f**2*gd2*r**2 - 726*D1**2*f**2*gd2*r*s + 726*D1**2*f**2*gd2*r + 594*D1**2*f**2*gdd2*r**2 + 594*D1**2*f**2*gdd2*r*s - 594*D1**2*f**2*gdd2*r - 1452*D1**2*f*fd*g2*r**2 - 1452*D1**2*f*fd*g2*r*s + 1452*D1**2*f*fd*g2*r + 726*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r**2 + 2376*D1**2*f*fd*gd2*r*s - 2376*D1**2*f*fd*gd2*r - 594*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r**2 + 1188*D1**2*f*fdd*g2*r*s - 1188*D1**2*f*fdd*g2*r - 594*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r**2 + 1188*D1**2*fd**2*g2*r*s - 1188*D1**2*fd**2*g2*r - 594*D1**2*fd**2*g2*s + 60*D1*Dd*f**4*r**2 + 60*D1*Dd*f**4*r*s - 60*D1*Dd*f**4*r - 15*D1*Dd*f**4*s + 15*D1*Dd*f**4 - 1120*D1*Dd*f**3*fd*r**2 - 1120*D1*Dd*f**3*fd*r*s + 1120*D1*Dd*f**3*fd*r + 280*D1*Dd*f**3*fd*s - 210*D1*Dd*f**3*fd - 2904*D1*Dd*f**2*g2*r**2 - 2904*D1*Dd*f**2*g2*r*s + 2904*D1*Dd*f**2*g2*r + 726*D1*Dd*f**2*g2*s - 726*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r**2 + 4752*D1*Dd*f**2*gd2*r*s - 4752*D1*Dd*f**2*gd2*r - 594*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r**2 + 9504*D1*Dd*f*fd*g2*r*s - 9504*D1*Dd*f*fd*g2*r - 3564*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**4*r**2 - 140*D1*Ddd*f**4*r*s + 140*D1*Ddd*f**4*r + 35*D1*Ddd*f**4*s - 35*D1*Ddd*f**4 + 2376*D1*Ddd*f**2*g2*r**2 + 2376*D1*Ddd*f**2*g2*r*s - 2376*D1*Ddd*f**2*g2*r - 594*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(f**3*(12*r + 1)*(r + s - 1) - f**2*(33*K*r*(r + s - 1) + 5*fd*(18*r**2 + 2*r*(9*s - 8) - s + 2)) + 3*f*(9*K*fd*(4*r**2 + 4*r*(s - 1) - s + 1) + 14*g2*(r - 1)*(r + s - 1) - 42*gd2*(2*r - 1)*(r + s - 1)) - 126*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - Dd*f*(f*(-27*K*(8*r**2 + 8*r*(s - 1) - s + 1) + 5*f*(24*r**2 + 4*r*(6*s - 5) + s)) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 420*Dd**2*f**4*r**2 - 420*Dd**2*f**4*r*s + 420*Dd**2*f**4*r + 105*Dd**2*f**4*s - 70*Dd**2*f**4 + 7128*Dd**2*f**2*g2*r**2 + 7128*Dd**2*f**2*g2*r*s - 7128*Dd**2*f**2*g2*r - 1782*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 - 33*b1**2*(D1**2*r*(-7*K*fd*(r + s) + 21*K*fdd*(r + s) + 3*f*(fd - 4*fdd)*(2*r + 2*s - 1) - 12*fd**2*(2*r + 2*s - 1)) + D1*(Dd*(21*K*fd*(8*r**2 + r*(8*s - 4) - s) + 3*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - f*(7*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 12*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1))) - 3*Ddd*f*(-7*K + 4*f)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-7*K + 4*f)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 11*b1*(-66*D1**2*K*f*fd*r**2 - 66*D1**2*K*f*fd*r*s + 66*D1**2*K*f*fd*r + 33*D1**2*K*f*fd*s - 33*D1**2*K*f*fd + 54*D1**2*K*f*fdd*r**2 + 54*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r - 27*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 54*D1**2*K*fd**2*r**2 + 54*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r - 27*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(-7*K + 4*f)*(2*r - 1)*(r + s - 1) + 36*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 37*D1**2*f**2*fd*r - 13*D1**2*f**2*fd*s + 13*D1**2*f**2*fd - 45*D1**2*f**2*fdd*r**2 - 45*D1**2*f**2*fdd*r*s + 50*D1**2*f**2*fdd*r + 20*D1**2*f**2*fdd*s - 20*D1**2*f**2*fdd - 90*D1**2*f*fd**2*r**2 - 90*D1**2*f*fd**2*r*s + 100*D1**2*f*fd**2*r + 40*D1**2*f*fd**2*s - 20*D1**2*f*fd**2 + 42*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r - 126*D1**2*f*gdd2*r**2 - 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*r + 42*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s - 252*D1**2*fd*gd2*r**2 - 252*D1**2*fd*gd2*r*s + 126*D1**2*fd*gd2*r - 126*D1**2*fdd*g2*r**2 - 126*D1**2*fdd*g2*r*s - 132*D1*Dd*K*f**2*r**2 - 132*D1*Dd*K*f**2*r*s + 132*D1*Dd*K*f**2*r + 33*D1*Dd*K*f**2*s - 33*D1*Dd*K*f**2 + 432*D1*Dd*K*f*fd*r**2 + 432*D1*Dd*K*f*fd*r*s - 432*D1*Dd*K*f*fd*r - 162*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd + 48*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 48*D1*Dd*f**3*r - 12*D1*Dd*f**3*s + 12*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r**2 - 360*D1*Dd*f**2*fd*r*s + 380*D1*Dd*f**2*fd*r + 125*D1*Dd*f**2*fd*s - 90*D1*Dd*f**2*fd + 168*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 42*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r + 126*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r + 126*D1*Dd*fd*g2*s + 108*D1*Ddd*K*f**2*r**2 + 108*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r - 27*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 - 60*D1*Ddd*f**3*r**2 - 60*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r + 15*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 - 504*D1*Ddd*f*g2*r**2 - 504*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 126*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(21*K*fd*(4*r**2 + r*(4*s - 3) - s) + 3*f**2*(2*r - 1)*(r + s - 1) - f*(7*K*(2*r - 1)*(r + s - 1) + 12*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1))) - 3*Dd*f*(-7*K + 4*f)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 324*Dd**2*K*f**2*r**2 + 324*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r - 81*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 - 180*Dd**2*f**3*r**2 - 180*Dd**2*f**3*r*s + 180*Dd**2*f**3*r + 45*Dd**2*f**3*s - 30*Dd**2*f**3 - 1512*Dd**2*f*g2*r**2 - 1512*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 378*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(3465*d**2*k3**6) + D1**2*Pk3*Pkd1*k1**3*st**4*(8*C - 4)*(3*D1*bd1*f*(D1*(2*f*s*(r - 1) + fd*(-4*r*s + r + 2*s - 1)) + Dd*f*(r*(2 - 8*s) + 5*s - 2)) - 3*b1*(D1*Dd*f*(2*f*(-4*r*s + 2*r + s) + fd*(8*r - 1)*(2*s - 1)) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + 2*r + s)) + Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(2*f*(4*r*s - 2*r - s) + fd*(-24*r*s + 10*r + 7*s - 3)) + D1*(D1*(2*f*fd*(r*(3*s - 1) - s) + f*(-3*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) + fd**2*(r*(2 - 6*s) + 2*s - 1)) + Ddd*f**2*(r*(2 - 4*s) + s)) + Dd**2*f**2*(r*(6 - 12*s) + 3*s - 2)))/(105*d**2*k3**4) - D1**2*Pk3*Pkd1*k1**3*st**2*(42*b1**2*(2*C - 1)*(D1**2*r*(3*fd + fdd)*(r + s - 1) + D1*(Dd*(3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1*(36*C*D1**2*f*fd*r**2 + 160*C*D1**2*f*fd*r*s - 88*C*D1**2*f*fd*r - 4*C*D1**2*f*fd*s + 4*C*D1**2*f*fd - 88*C*D1**2*f*fdd*r**2 - 192*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd - 88*C*D1**2*fd**2*r**2 - 192*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 + 72*C*D1*Dd*f**2*r**2 + 320*C*D1*Dd*f**2*r*s - 196*C*D1*Dd*f**2*r - 80*C*D1*Dd*f**2*s + 18*C*D1*Dd*f**2 - 704*C*D1*Dd*f*fd*r**2 - 1536*C*D1*Dd*f*fd*r*s + 848*C*D1*Dd*f*fd*r + 144*C*D1*Dd*f*fd*s - 48*C*D1*Dd*f*fd - 176*C*D1*Ddd*f**2*r**2 - 384*C*D1*Ddd*f**2*r*s + 280*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s - 44*C*D1*Ddd*f**2 - 528*C*Dd**2*f**2*r**2 - 1152*C*Dd**2*f**2*r*s + 840*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s - 192*C*Dd**2*f**2 + 14*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) - 18*D1**2*f*fd*r**2 - 78*D1**2*f*fd*r*s + 43*D1**2*f*fd*r + 2*D1**2*f*fd*s - 2*D1**2*f*fd + 44*D1**2*f*fdd*r**2 + 102*D1**2*f*fdd*r*s - 39*D1**2*f*fdd*r + 6*D1**2*f*fdd*s - 6*D1**2*f*fdd + 44*D1**2*fd**2*r**2 + 102*D1**2*fd**2*r*s - 39*D1**2*fd**2*r + 6*D1**2*fd**2*s - 6*D1**2*fd**2 - 36*D1*Dd*f**2*r**2 - 156*D1*Dd*f**2*r*s + 96*D1*Dd*f**2*r + 39*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 352*D1*Dd*f*fd*r**2 + 816*D1*Dd*f*fd*r*s - 448*D1*Dd*f*fd*r - 78*D1*Dd*f*fd*s + 27*D1*Dd*f*fd + 88*D1*Ddd*f**2*r**2 + 204*D1*Ddd*f**2*r*s - 146*D1*Ddd*f**2*r - 51*D1*Ddd*f**2*s + 22*D1*Ddd*f**2 + 14*D1*bd1*(2*C - 1)*(D1*(f*(6*r**2 + 6*r*(s - 1) - 3*s + 3) + fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 264*Dd**2*f**2*r**2 + 612*Dd**2*f**2*r*s - 438*Dd**2*f**2*r - 153*Dd**2*f**2*s + 102*Dd**2*f**2) + f*(198*C*D1**2*f*fd*r**2 + 348*C*D1**2*f*fd*r*s - 248*C*D1**2*f*fd*r - 116*C*D1**2*f*fd*s + 66*C*D1**2*f*fd - 288*C*D1**2*f*fdd*r**2 - 444*C*D1**2*f*fdd*r*s + 340*C*D1**2*f*fdd*r + 148*C*D1**2*f*fdd*s - 96*C*D1**2*f*fdd - 576*C*D1**2*fd**2*r**2 - 888*C*D1**2*fd**2*r*s + 680*C*D1**2*fd**2*r + 296*C*D1**2*fd**2*s - 148*C*D1**2*fd**2 + 264*C*D1*Dd*f**2*r**2 + 464*C*D1*Dd*f**2*r*s - 364*C*D1*Dd*f**2*r - 116*C*D1*Dd*f**2*s + 66*C*D1*Dd*f**2 - 2304*C*D1*Dd*f*fd*r**2 - 3552*C*D1*Dd*f*fd*r*s + 2824*C*D1*Dd*f*fd*r + 1036*C*D1*Dd*f*fd*s - 636*C*D1*Dd*f*fd - 384*C*D1*Ddd*f**2*r**2 - 592*C*D1*Ddd*f**2*r*s + 488*C*D1*Ddd*f**2*r + 148*C*D1*Ddd*f**2*s - 96*C*D1*Ddd*f**2 - 1152*C*Dd**2*f**2*r**2 - 1776*C*Dd**2*f**2*r*s + 1464*C*Dd**2*f**2*r + 444*C*Dd**2*f**2*s - 296*C*Dd**2*f**2 + 42*D1**2*bd1**2*(2*C - 1)*(2*r**2 + 2*r*(s - 1) - s) - 3*D1**2*bdd1*f*(4*C*(11*r**2 + 4*r*(6*s - 7) - 27*s + 14) - 22*r**2 - 51*r*s + 56*r + 57*s - 28) - 99*D1**2*f*fd*r**2 - 177*D1**2*f*fd*r*s + 125*D1**2*f*fd*r + 59*D1**2*f*fd*s - 33*D1**2*f*fd + 144*D1**2*f*fdd*r**2 + 237*D1**2*f*fdd*r*s - 175*D1**2*f*fdd*r - 79*D1**2*f*fdd*s + 48*D1**2*f*fdd + 288*D1**2*fd**2*r**2 + 474*D1**2*fd**2*r*s - 350*D1**2*fd**2*r - 158*D1**2*fd**2*s + 79*D1**2*fd**2 - 132*D1*Dd*f**2*r**2 - 236*D1*Dd*f**2*r*s + 184*D1*Dd*f**2*r + 59*D1*Dd*f**2*s - 33*D1*Dd*f**2 + 1152*D1*Dd*f*fd*r**2 + 1896*D1*Dd*f*fd*r*s - 1462*D1*Dd*f*fd*r - 553*D1*Dd*f*fd*s + 333*D1*Dd*f*fd + 192*D1*Ddd*f**2*r**2 + 316*D1*Ddd*f**2*r*s - 254*D1*Ddd*f**2*r - 79*D1*Ddd*f**2*s + 48*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(2*C*(9*r**2 + 40*r*s - 14*r - 38*s + 7) - 9*r**2 - 39*r*s + 14*r + 37*s - 7) + fd*(-4*C*(44*r**2 + 96*r*s - 74*r - 51*s + 27) + 88*r**2 + 204*r*s - 151*r - 108*s + 57)) + Dd*f*(-8*C*(44*r**2 + 96*r*s - 91*r - 66*s + 41) + 176*r**2 + 408*r*s - 370*r - 279*s + 170)) + 576*Dd**2*f**2*r**2 + 948*Dd**2*f**2*r*s - 762*Dd**2*f**2*r - 237*Dd**2*f**2*s + 158*Dd**2*f**2))/(315*d**2*k3**4) + D1**2*Pk3*Pkd1*k1**3*(-210*D1**2*K*b1**2*bdd1*r**2 - 210*D1**2*K*b1**2*bdd1*r*s + 210*D1**2*K*b1**2*bdd1*r + 70*D1**2*K*b1**2*bdd1*s - 70*D1**2*K*b1**2*bdd1 - 63*D1**2*K*b1**2*fd*r**2 - 84*D1**2*K*b1**2*fd*r*s - 28*D1**2*K*b1**2*fd*r - 14*D1**2*K*b1**2*fd*s + 14*D1**2*K*b1**2*fd + 119*D1**2*K*b1**2*fdd*r**2 + 112*D1**2*K*b1**2*fdd*r*s + 84*D1**2*K*b1**2*fdd*r + 42*D1**2*K*b1**2*fdd*s - 42*D1**2*K*b1**2*fdd + 238*D1**2*K*b1*bdd1*f*r**2 + 224*D1**2*K*b1*bdd1*f*r*s - 434*D1**2*K*b1*bdd1*f*r - 154*D1**2*K*b1*bdd1*f*s + 161*D1**2*K*b1*bdd1*f - 174*D1**2*K*b1*f*fd*r**2 - 156*D1**2*K*b1*f*fd*r*s + 174*D1**2*K*b1*f*fd*r + 78*D1**2*K*b1*f*fd*s - 87*D1**2*K*b1*f*fd + 234*D1**2*K*b1*f*fdd*r**2 + 204*D1**2*K*b1*f*fdd*r*s - 234*D1**2*K*b1*f*fdd*r - 102*D1**2*K*b1*f*fdd*s + 117*D1**2*K*b1*f*fdd + 234*D1**2*K*b1*fd**2*r**2 + 204*D1**2*K*b1*fd**2*r*s - 234*D1**2*K*b1*fd**2*r - 102*D1**2*K*b1*fd**2*s + 117*D1**2*K*bdd1*f**2*r**2 + 102*D1**2*K*bdd1*f**2*r*s - 102*D1**2*K*bdd1*f**2*r + 42*D1**2*b1**2*f*fd*r*s - 21*D1**2*b1**2*f*fd*r - 42*D1**2*b1**2*f*fdd*r*s + 21*D1**2*b1**2*f*fdd*r - 42*D1**2*b1**2*fd**2*r*s + 21*D1**2*b1**2*fd**2*r + 7*D1**2*b1**2*fd*r*s - 21*D1**2*b1**2*fdd*r*s + 140*D1**2*b1**2*gd2*r**2 + 140*D1**2*b1**2*gd2*r*s - 140*D1**2*b1**2*gd2*r + 140*D1**2*b1**2*gdd2*r**2 + 140*D1**2*b1**2*gdd2*r*s - 140*D1**2*b1**2*gdd2*r - 14*D1**2*b1*bd2*f*r**2 - 14*D1**2*b1*bd2*f*r*s + 14*D1**2*b1*bd2*f*r + 84*D1**2*b1*bd2*fd*r**2 + 84*D1**2*b1*bd2*fd*r*s - 42*D1**2*b1*bd2*fd*r - 42*D1**2*b1*bdd1*f**2*r*s + 21*D1**2*b1*bdd1*f**2*r + 21*D1**2*b1*bdd1*f**2*s - 42*D1**2*b1*bdd1*f*r*s + 21*D1**2*b1*bdd1*f*r + 21*D1**2*b1*bdd1*f*s + 280*D1**2*b1*bdd1*g2*r**2 + 280*D1**2*b1*bdd1*g2*r*s - 280*D1**2*b1*bdd1*g2*r - 140*D1**2*b1*bdd1*g2*s + 140*D1**2*b1*bdd1*g2 + 42*D1**2*b1*bdd2*f*r**2 + 42*D1**2*b1*bdd2*f*r*s - 42*D1**2*b1*bdd2*f*r + 45*D1**2*b1*f**2*fd*r*s - 15*D1**2*b1*f**2*fd*r - 15*D1**2*b1*f**2*fd*s - 45*D1**2*b1*f**2*fdd*r*s + 15*D1**2*b1*f**2*fdd*r + 15*D1**2*b1*f**2*fdd*s - 90*D1**2*b1*f*fd**2*r*s + 30*D1**2*b1*f*fd**2*r + 30*D1**2*b1*f*fd**2*s - 15*D1**2*b1*f*fd**2 + 18*D1**2*b1*f*fd*r*s - 9*D1**2*b1*f*fd*s - 30*D1**2*b1*f*fdd*r*s + 15*D1**2*b1*f*fdd*s + 126*D1**2*b1*f*gd2*r**2 + 168*D1**2*b1*f*gd2*r*s - 168*D1**2*b1*f*gd2*r - 238*D1**2*b1*f*gdd2*r**2 - 224*D1**2*b1*f*gdd2*r*s + 224*D1**2*b1*f*gdd2*r - 30*D1**2*b1*fd**2*r*s + 15*D1**2*b1*fd**2*s + 126*D1**2*b1*fd*g2*r**2 + 168*D1**2*b1*fd*g2*r*s + 56*D1**2*b1*fd*g2*r + 28*D1**2*b1*fd*g2*s - 28*D1**2*b1*fd*g2 - 476*D1**2*b1*fd*gd2*r**2 - 448*D1**2*b1*fd*gd2*r*s + 56*D1**2*b1*fd*gd2*r - 84*D1**2*b1*fd*gd2*s + 84*D1**2*b1*fd*gd2 - 238*D1**2*b1*fdd*g2*r**2 - 224*D1**2*b1*fdd*g2*r*s - 168*D1**2*b1*fdd*g2*r - 84*D1**2*b1*fdd*g2*s + 84*D1**2*b1*fdd*g2 - 7*D1**2*bd1**2*(10*K*b1*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + f**2*(r*(6*s - 3) - 3*s + 3) + f*(K*(-34*r**2 - 32*r*s + 62*r + 22*s - 22) + 6*r*s - 3*r - 3*s + 3) + 20*g2*(-2*r**2 - 2*r*(s - 1) + s)) - 18*D1**2*bd2*f**2*r**2 - 18*D1**2*bd2*f**2*r*s + 18*D1**2*bd2*f**2*r + 120*D1**2*bd2*f*fd*r**2 + 120*D1**2*bd2*f*fd*r*s - 120*D1**2*bd2*f*fd*r - 30*D1**2*bd2*f*fd*s + 30*D1**2*bd2*f*fd - 15*D1**2*bdd1*f**3*r*s + 15*D1**2*bdd1*f**3*r - 15*D1**2*bdd1*f**2*r*s + 15*D1**2*bdd1*f**2*r - 238*D1**2*bdd1*f*g2*r**2 - 224*D1**2*bdd1*f*g2*r*s + 644*D1**2*bdd1*f*g2*r + 308*D1**2*bdd1*f*g2*s - 322*D1**2*bdd1*f*g2 + 30*D1**2*bdd2*f**2*r**2 + 30*D1**2*bdd2*f**2*r*s - 30*D1**2*bdd2*f**2*r + 174*D1**2*f**2*gd2*r**2 + 156*D1**2*f**2*gd2*r*s - 156*D1**2*f**2*gd2*r - 234*D1**2*f**2*gdd2*r**2 - 204*D1**2*f**2*gdd2*r*s + 204*D1**2*f**2*gdd2*r + 348*D1**2*f*fd*g2*r**2 + 312*D1**2*f*fd*g2*r*s - 348*D1**2*f*fd*g2*r - 156*D1**2*f*fd*g2*s + 174*D1**2*f*fd*g2 - 936*D1**2*f*fd*gd2*r**2 - 816*D1**2*f*fd*gd2*r*s + 876*D1**2*f*fd*gd2*r + 204*D1**2*f*fd*gd2*s - 204*D1**2*f*fd*gd2 - 468*D1**2*f*fdd*g2*r**2 - 408*D1**2*f*fdd*g2*r*s + 468*D1**2*f*fdd*g2*r + 204*D1**2*f*fdd*g2*s - 234*D1**2*f*fdd*g2 - 468*D1**2*fd**2*g2*r**2 - 408*D1**2*fd**2*g2*r*s + 468*D1**2*fd**2*g2*r + 204*D1**2*fd**2*g2*s - 280*D1*Dd*K*b1**3*r**2 - 280*D1*Dd*K*b1**3*r*s + 280*D1*Dd*K*b1**3*r + 70*D1*Dd*K*b1**3*s - 70*D1*Dd*K*b1**3 - 252*D1*Dd*K*b1**2*f*r**2 - 336*D1*Dd*K*b1**2*f*r*s + 294*D1*Dd*K*b1**2*f*r + 84*D1*Dd*K*b1**2*f*s - 63*D1*Dd*K*b1**2*f + 952*D1*Dd*K*b1**2*fd*r**2 + 896*D1*Dd*K*b1**2*fd*r*s - 126*D1*Dd*K*b1**2*fd*r + 56*D1*Dd*K*b1**2*fd*s - 168*D1*Dd*K*b1**2*fd - 348*D1*Dd*K*b1*f**2*r**2 - 312*D1*Dd*K*b1*f**2*r*s + 330*D1*Dd*K*b1*f**2*r + 78*D1*Dd*K*b1*f**2*s - 87*D1*Dd*K*b1*f**2 + 1872*D1*Dd*K*b1*f*fd*r**2 + 1632*D1*Dd*K*b1*f*fd*r*s - 1812*D1*Dd*K*b1*f*fd*r - 612*D1*Dd*K*b1*f*fd*s + 438*D1*Dd*K*b1*f*fd + 84*D1*Dd*b1**2*f**2*r*s - 42*D1*Dd*b1**2*f**2*r - 21*D1*Dd*b1**2*f**2*s - 336*D1*Dd*b1**2*f*fd*r*s + 168*D1*Dd*b1**2*f*fd*r + 42*D1*Dd*b1**2*f*fd*s - 21*D1*Dd*b1**2*f*fd + 28*D1*Dd*b1**2*f*r*s - 14*D1*Dd*b1**2*f*r - 7*D1*Dd*b1**2*f*s - 168*D1*Dd*b1**2*fd*r*s + 42*D1*Dd*b1**2*fd*r + 21*D1*Dd*b1**2*fd*s + 560*D1*Dd*b1**2*g2*r**2 + 560*D1*Dd*b1**2*g2*r*s - 560*D1*Dd*b1**2*g2*r - 140*D1*Dd*b1**2*g2*s + 140*D1*Dd*b1**2*g2 + 1120*D1*Dd*b1**2*gd2*r**2 + 1120*D1*Dd*b1**2*gd2*r*s - 1120*D1*Dd*b1**2*gd2*r - 140*D1*Dd*b1**2*gd2*s + 140*D1*Dd*b1**2*gd2 + 336*D1*Dd*b1*bd2*f*r**2 + 336*D1*Dd*b1*bd2*f*r*s - 336*D1*Dd*b1*bd2*f*r - 42*D1*Dd*b1*bd2*f*s + 42*D1*Dd*b1*bd2*f + 60*D1*Dd*b1*f**3*r*s - 30*D1*Dd*b1*f**3*r - 15*D1*Dd*b1*f**3*s - 360*D1*Dd*b1*f**2*fd*r*s + 150*D1*Dd*b1*f**2*fd*r + 105*D1*Dd*b1*f**2*fd*s - 45*D1*Dd*b1*f**2*fd + 36*D1*Dd*b1*f**2*r*s - 18*D1*Dd*b1*f**2*r - 9*D1*Dd*b1*f**2*s - 240*D1*Dd*b1*f*fd*r*s + 60*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 30*D1*Dd*b1*f*fd + 504*D1*Dd*b1*f*g2*r**2 + 672*D1*Dd*b1*f*g2*r*s - 588*D1*Dd*b1*f*g2*r - 168*D1*Dd*b1*f*g2*s + 126*D1*Dd*b1*f*g2 - 1904*D1*Dd*b1*f*gd2*r**2 - 1792*D1*Dd*b1*f*gd2*r*s + 1820*D1*Dd*b1*f*gd2*r + 224*D1*Dd*b1*f*gd2*s - 224*D1*Dd*b1*f*gd2 - 1904*D1*Dd*b1*fd*g2*r**2 - 1792*D1*Dd*b1*fd*g2*r*s + 252*D1*Dd*b1*fd*g2*r - 112*D1*Dd*b1*fd*g2*s + 336*D1*Dd*b1*fd*g2 + 240*D1*Dd*bd2*f**2*r**2 + 240*D1*Dd*bd2*f**2*r*s - 240*D1*Dd*bd2*f**2*r - 30*D1*Dd*bd2*f**2*s + 30*D1*Dd*bd2*f**2 + 696*D1*Dd*f**2*g2*r**2 + 624*D1*Dd*f**2*g2*r*s - 660*D1*Dd*f**2*g2*r - 156*D1*Dd*f**2*g2*s + 174*D1*Dd*f**2*g2 - 1872*D1*Dd*f**2*gd2*r**2 - 1632*D1*Dd*f**2*gd2*r*s + 1692*D1*Dd*f**2*gd2*r + 204*D1*Dd*f**2*gd2*s - 204*D1*Dd*f**2*gd2 - 3744*D1*Dd*f*fd*g2*r**2 - 3264*D1*Dd*f*fd*g2*r*s + 3624*D1*Dd*f*fd*g2*r + 1224*D1*Dd*f*fd*g2*s - 876*D1*Dd*f*fd*g2 - 280*D1*Ddd*K*b1**3*r**2 - 280*D1*Ddd*K*b1**3*r*s + 280*D1*Ddd*K*b1**3*r + 70*D1*Ddd*K*b1**3*s - 70*D1*Ddd*K*b1**3 + 476*D1*Ddd*K*b1**2*f*r**2 + 448*D1*Ddd*K*b1**2*f*r*s - 462*D1*Ddd*K*b1**2*f*r - 112*D1*Ddd*K*b1**2*f*s + 119*D1*Ddd*K*b1**2*f + 468*D1*Ddd*K*b1*f**2*r**2 + 408*D1*Ddd*K*b1*f**2*r*s - 438*D1*Ddd*K*b1*f**2*r - 102*D1*Ddd*K*b1*f**2*s + 117*D1*Ddd*K*b1*f**2 - 84*D1*Ddd*b1**2*f**2*r*s + 42*D1*Ddd*b1**2*f**2*r + 21*D1*Ddd*b1**2*f**2*s - 84*D1*Ddd*b1**2*f*r*s + 42*D1*Ddd*b1**2*f*r + 21*D1*Ddd*b1**2*f*s + 560*D1*Ddd*b1**2*g2*r**2 + 560*D1*Ddd*b1**2*g2*r*s - 560*D1*Ddd*b1**2*g2*r - 140*D1*Ddd*b1**2*g2*s + 140*D1*Ddd*b1**2*g2 - 60*D1*Ddd*b1*f**3*r*s + 30*D1*Ddd*b1*f**3*r + 15*D1*Ddd*b1*f**3*s - 60*D1*Ddd*b1*f**2*r*s + 30*D1*Ddd*b1*f**2*r + 15*D1*Ddd*b1*f**2*s - 952*D1*Ddd*b1*f*g2*r**2 - 896*D1*Ddd*b1*f*g2*r*s + 924*D1*Ddd*b1*f*g2*r + 224*D1*Ddd*b1*f*g2*s - 238*D1*Ddd*b1*f*g2 - 936*D1*Ddd*f**2*g2*r**2 - 816*D1*Ddd*f**2*g2*r*s + 876*D1*Ddd*f**2*g2*r + 204*D1*Ddd*f**2*g2*s - 234*D1*Ddd*f**2*g2 + D1*bd1*(-87*D1*K*f**2*r**2 - 78*D1*K*f**2*r*s + 78*D1*K*f**2*r + 468*D1*K*f*fd*r**2 + 408*D1*K*f*fd*r*s - 438*D1*K*f*fd*r - 102*D1*K*f*fd*s + 102*D1*K*f*fd + 42*D1*bd2*f*(2*r - 1)*(r + s - 1) + 15*D1*f**3*r*s - 15*D1*f**3*r - 90*D1*f**2*fd*r*s + 60*D1*f**2*fd*r + 15*D1*f**2*fd*s - 15*D1*f**2*fd + 9*D1*f**2*r*s - 9*D1*f**2*r - 60*D1*f*fd*r*s + 30*D1*f*fd*r + 15*D1*f*fd*s - 15*D1*f*fd + 126*D1*f*g2*r**2 + 168*D1*f*g2*r*s - 308*D1*f*g2*r - 196*D1*f*g2*s + 154*D1*f*g2 - 476*D1*f*gd2*r**2 - 448*D1*f*gd2*r*s + 868*D1*f*gd2*r + 308*D1*f*gd2*s - 308*D1*f*gd2 - 476*D1*fd*g2*r**2 - 448*D1*fd*g2*r*s + 476*D1*fd*g2*r + 224*D1*fd*g2*s + 936*Dd*K*f**2*r**2 + 816*Dd*K*f**2*r*s - 846*Dd*K*f**2*r - 102*Dd*K*f**2*s + 102*Dd*K*f**2 - 120*Dd*f**3*r*s + 90*Dd*f**3*r + 15*Dd*f**3*s - 15*Dd*f**3 - 120*Dd*f**2*r*s + 90*Dd*f**2*r + 15*Dd*f**2*s - 15*Dd*f**2 - 1904*Dd*f*g2*r**2 - 1792*Dd*f*g2*r*s + 3500*Dd*f*g2*r + 1456*Dd*f*g2*s - 1260*Dd*f*g2 - 70*K*b1**2*(D1*(3*r**2 + 3*r*(s - 1) - s + 1) + Dd*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 7*b1*(D1*(-68*K*fd*r**2 - 64*K*fd*r*s + 38*K*fd*r + 10*K*fd*s + 6*K*fd + 3*f**2*(-2*r*s + r + s) + f*(K*(18*r**2 + 24*r*s - 34*r - 14*s + 11) + 3*fd*(4*r - 1)*(2*s - 1) - 2*r*s + r + s) + 12*fd*r*s - 3*fd*r - 3*fd*s - 20*g2*(2*r**2 + 2*r*(s - 1) - s + 1) - 80*gd2*r**2 - 80*gd2*r*s + 80*gd2*r + 20*gd2*s - 20*gd2) + Dd*(3*f**2*(8*r - 3)*(2*s - 1) + f*(-2*K*(136*r**2 + 2*r*(64*s - 95) - 60*s + 53) + (24*r - 9)*(2*s - 1)) - 40*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)))) - 840*Dd**2*K*b1**3*r**2 - 840*Dd**2*K*b1**3*r*s + 840*Dd**2*K*b1**3*r + 210*Dd**2*K*b1**3*s - 140*Dd**2*K*b1**3 + 1428*Dd**2*K*b1**2*f*r**2 + 1344*Dd**2*K*b1**2*f*r*s - 1386*Dd**2*K*b1**2*f*r - 336*Dd**2*K*b1**2*f*s + 224*Dd**2*K*b1**2*f + 1404*Dd**2*K*b1*f**2*r**2 + 1224*Dd**2*K*b1*f**2*r*s - 1314*Dd**2*K*b1*f**2*r - 306*Dd**2*K*b1*f**2*s + 204*Dd**2*K*b1*f**2 - 252*Dd**2*b1**2*f**2*r*s + 126*Dd**2*b1**2*f**2*r + 63*Dd**2*b1**2*f**2*s - 42*Dd**2*b1**2*f**2 - 252*Dd**2*b1**2*f*r*s + 126*Dd**2*b1**2*f*r + 63*Dd**2*b1**2*f*s - 42*Dd**2*b1**2*f + 1680*Dd**2*b1**2*g2*r**2 + 1680*Dd**2*b1**2*g2*r*s - 1680*Dd**2*b1**2*g2*r - 420*Dd**2*b1**2*g2*s + 280*Dd**2*b1**2*g2 - 180*Dd**2*b1*f**3*r*s + 90*Dd**2*b1*f**3*r + 45*Dd**2*b1*f**3*s - 30*Dd**2*b1*f**3 - 180*Dd**2*b1*f**2*r*s + 90*Dd**2*b1*f**2*r + 45*Dd**2*b1*f**2*s - 30*Dd**2*b1*f**2 - 2856*Dd**2*b1*f*g2*r**2 - 2688*Dd**2*b1*f*g2*r*s + 2772*Dd**2*b1*f*g2*r + 672*Dd**2*b1*f*g2*s - 448*Dd**2*b1*f*g2 - 2808*Dd**2*f**2*g2*r**2 - 2448*Dd**2*f**2*g2*r*s + 2628*Dd**2*f**2*g2*r + 612*Dd**2*f**2*g2*s - 408*Dd**2*f**2*g2 - 2*b2*(7*D1**2*b1*fd*r**2 + 7*D1**2*b1*fd*r*s - 21*D1**2*b1*fdd*r**2 - 21*D1**2*b1*fdd*r*s - 21*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 18*D1**2*f*fd*r**2 + 18*D1**2*f*fd*r*s - 18*D1**2*f*fd*r - 9*D1**2*f*fd*s + 9*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 30*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r + 15*D1**2*f*fdd*s - 15*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 30*D1**2*fd**2*r*s + 30*D1**2*fd**2*r + 15*D1**2*fd**2*s + 28*D1*Dd*b1*f*r**2 + 28*D1*Dd*b1*f*r*s - 28*D1*Dd*b1*f*r - 7*D1*Dd*b1*f*s + 7*D1*Dd*b1*f - 168*D1*Dd*b1*fd*r**2 - 168*D1*Dd*b1*fd*r*s + 84*D1*Dd*b1*fd*r + 21*D1*Dd*b1*fd*s + 36*D1*Dd*f**2*r**2 + 36*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r - 9*D1*Dd*f**2*s + 9*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 240*D1*Dd*f*fd*r*s + 240*D1*Dd*f*fd*r + 90*D1*Dd*f*fd*s - 60*D1*Dd*f*fd - 84*D1*Ddd*b1*f*r**2 - 84*D1*Ddd*b1*f*r*s + 84*D1*Ddd*b1*f*r + 21*D1*Ddd*b1*f*s - 21*D1*Ddd*b1*f - 60*D1*Ddd*f**2*r**2 - 60*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r + 15*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 252*Dd**2*b1*f*r**2 - 252*Dd**2*b1*f*r*s + 252*Dd**2*b1*f*r + 63*Dd**2*b1*f*s - 42*Dd**2*b1*f - 180*Dd**2*f**2*r**2 - 180*Dd**2*f**2*r*s + 180*Dd**2*f**2*r + 45*Dd**2*f**2*s - 30*Dd**2*f**2))/(105*d**2*k3**4) - 4*D1**2*Pk3*Pkd1*k1*k2**4*st**4*(33*b1**2*(D1**2*r*(f*(fd - 4*fdd) - 4*fd**2)*(2*r + 2*s - 1) + D1*f*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 4*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1)) - 4*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 4*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*f*(-12*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) + 6*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s - 9*D1**2*f*fd*r - 5*D1**2*f*fd*s + 5*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*s - 4*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s + 8*D1**2*fd**2*s - 4*D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 2*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 10*D1*Dd*f*fd*s - 8*D1*Dd*f*fd + 8*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 8*D1*Ddd*f**2*r - 2*D1*Ddd*f**2*s + 2*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) - 4*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1)) - 4*Dd*f*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 24*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 24*Dd**2*f**2*r - 6*Dd**2*f**2*s + 4*Dd**2*f**2) + f**2*(-132*D1**2*bd1**2*(2*r - 1)*(r + s - 1) + 22*D1**2*bdd1*f*(r - 3)*(r + s - 1) - 3*D1**2*(f*(9*fd - 10*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 10*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*D1*bd1*(D1*(f*(2*r + 3)*(r + s - 1) + 2*fd*(6*r**2 + 6*r*(s - 2) - 7*s + 4)) + 2*Dd*f*(8*r**2 + 4*r*(2*s - 5) - 13*s + 10)) - 3*D1*f*(Dd*(9*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 20*fd*(4*r - 1)*(4*r + 4*s - 3)) - 10*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 30*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(1155*d**2*k3**6) + D1**2*Pk3*Pkd1*k1*k2**2*st**4*(60*C*D1**2*b1*f*fd*r**2 + 144*C*D1**2*b1*f*fd*r*s - 72*C*D1**2*b1*f*fd*r + 180*C*D1**2*b1*f*fdd*r**2 + 96*C*D1**2*b1*f*fdd*r*s - 48*C*D1**2*b1*f*fdd*r + 180*C*D1**2*b1*fd**2*r**2 + 96*C*D1**2*b1*fd**2*r*s - 48*C*D1**2*b1*fd**2*r - 114*C*D1**2*f**2*fd*r**2 - 24*C*D1**2*f**2*fd*r*s + 84*C*D1**2*f**2*fd*r + 8*C*D1**2*f**2*fd*s - 38*C*D1**2*f**2*fd + 102*C*D1**2*f**2*fdd*r**2 + 48*C*D1**2*f**2*fdd*r*s - 84*C*D1**2*f**2*fdd*r - 16*C*D1**2*f**2*fdd*s + 34*C*D1**2*f**2*fdd + 204*C*D1**2*f*fd**2*r**2 + 96*C*D1**2*f*fd**2*r*s - 168*C*D1**2*f*fd**2*r - 32*C*D1**2*f*fd**2*s + 16*C*D1**2*f*fd**2 + 120*C*D1*Dd*b1*f**2*r**2 + 288*C*D1*Dd*b1*f**2*r*s - 204*C*D1*Dd*b1*f**2*r - 72*C*D1*Dd*b1*f**2*s + 30*C*D1*Dd*b1*f**2 + 1440*C*D1*Dd*b1*f*fd*r**2 + 768*C*D1*Dd*b1*f*fd*r*s - 744*C*D1*Dd*b1*f*fd*r - 96*C*D1*Dd*b1*f*fd*s + 48*C*D1*Dd*b1*f*fd - 152*C*D1*Dd*f**3*r**2 - 32*C*D1*Dd*f**3*r*s + 92*C*D1*Dd*f**3*r + 8*C*D1*Dd*f**3*s - 38*C*D1*Dd*f**3 + 816*C*D1*Dd*f**2*fd*r**2 + 384*C*D1*Dd*f**2*fd*r*s - 636*C*D1*Dd*f**2*fd*r - 112*C*D1*Dd*f**2*fd*s + 116*C*D1*Dd*f**2*fd + 360*C*D1*Ddd*b1*f**2*r**2 + 192*C*D1*Ddd*b1*f**2*r*s - 276*C*D1*Ddd*b1*f**2*r - 48*C*D1*Ddd*b1*f**2*s + 90*C*D1*Ddd*b1*f**2 + 136*C*D1*Ddd*f**3*r**2 + 64*C*D1*Ddd*f**3*r*s - 100*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s + 34*C*D1*Ddd*f**3 + 1080*C*Dd**2*b1*f**2*r**2 + 576*C*Dd**2*b1*f**2*r*s - 828*C*Dd**2*b1*f**2*r - 144*C*Dd**2*b1*f**2*s + 96*C*Dd**2*b1*f**2 + 408*C*Dd**2*f**3*r**2 + 192*C*Dd**2*f**3*r*s - 300*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s + 32*C*Dd**2*f**3 - 6*D1**2*b1*f*fd*r**2 - 102*D1**2*b1*f*fd*r*s + 51*D1**2*b1*f*fd*r - 102*D1**2*b1*f*fdd*r**2 - 54*D1**2*b1*f*fdd*r*s + 27*D1**2*b1*f*fdd*r - 102*D1**2*b1*fd**2*r**2 - 54*D1**2*b1*fd**2*r*s + 27*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(r - 1)*(2*C*(15*r + 8*s - 15) - 17*r - 9*s + 17) + 69*D1**2*f**2*fd*r**2 + 9*D1**2*f**2*fd*r*s - 49*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s + 23*D1**2*f**2*fd - 57*D1**2*f**2*fdd*r**2 - 27*D1**2*f**2*fdd*r*s + 47*D1**2*f**2*fdd*r + 9*D1**2*f**2*fdd*s - 19*D1**2*f**2*fdd - 114*D1**2*f*fd**2*r**2 - 54*D1**2*f*fd**2*r*s + 94*D1**2*f*fd**2*r + 18*D1**2*f*fd**2*s - 9*D1**2*f*fd**2 - 12*D1*Dd*b1*f**2*r**2 - 204*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r + 51*D1*Dd*b1*f**2*s - 3*D1*Dd*b1*f**2 - 816*D1*Dd*b1*f*fd*r**2 - 432*D1*Dd*b1*f*fd*r*s + 420*D1*Dd*b1*f*fd*r + 54*D1*Dd*b1*f*fd*s - 27*D1*Dd*b1*f*fd + 92*D1*Dd*f**3*r**2 + 12*D1*Dd*f**3*r*s - 52*D1*Dd*f**3*r - 3*D1*Dd*f**3*s + 23*D1*Dd*f**3 - 456*D1*Dd*f**2*fd*r**2 - 216*D1*Dd*f**2*fd*r*s + 356*D1*Dd*f**2*fd*r + 63*D1*Dd*f**2*fd*s - 65*D1*Dd*f**2*fd - 204*D1*Ddd*b1*f**2*r**2 - 108*D1*Ddd*b1*f**2*r*s + 156*D1*Ddd*b1*f**2*r + 27*D1*Ddd*b1*f**2*s - 51*D1*Ddd*b1*f**2 - 76*D1*Ddd*f**3*r**2 - 36*D1*Ddd*f**3*r*s + 56*D1*Ddd*f**3*r + 9*D1*Ddd*f**3*s - 19*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(r - 1)*(2*C*(5*r + 12*s - 5) - r - 17*s + 1) + fd*(8*C*(15*r**2 + 8*r*s - 17*r - 4*s + 2) - 68*r**2 - 36*r*s + 77*r + 18*s - 9)) + Dd*f*(4*C*(60*r**2 + 32*r*s - 83*r - 20*s + 23) - 136*r**2 - 72*r*s + 188*r + 45*s - 52)) - 612*Dd**2*b1*f**2*r**2 - 324*Dd**2*b1*f**2*r*s + 468*Dd**2*b1*f**2*r + 81*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 228*Dd**2*f**3*r**2 - 108*Dd**2*f**3*r*s + 168*Dd**2*f**3*r + 27*Dd**2*f**3*s - 18*Dd**2*f**3)/(105*d**2*k3**4) + D1**2*Pk3*Pkd1*k1*k2**2*st**2*(6468*D1**2*K*bd1**2*f*r**2 + 3696*D1**2*K*bd1**2*f*r*s - 8316*D1**2*K*bd1**2*f*r - 1848*D1**2*K*bd1**2*f*s + 1848*D1**2*K*bd1**2*f - 1881*D1**2*K*bd1*f**2*r**2 - 660*D1**2*K*bd1*f**2*r*s + 660*D1**2*K*bd1*f**2*r + 6072*D1**2*K*bd1*f*fd*r**2 + 3168*D1**2*K*bd1*f*fd*r*s - 4620*D1**2*K*bd1*f*fd*r - 792*D1**2*K*bd1*f*fd*s + 792*D1**2*K*bd1*f*fd + 1518*D1**2*K*bdd1*f**2*r**2 + 792*D1**2*K*bdd1*f**2*r*s - 792*D1**2*K*bdd1*f**2*r - 3960*D1**2*bd1**2*f**2*r**2 - 4950*D1**2*bd1**2*f**2*r*s + 7029*D1**2*bd1**2*f**2*r + 2871*D1**2*bd1**2*f**2*s - 2673*D1**2*bd1**2*f**2 - 924*D1**2*bd1**2*f*r**2 - 462*D1**2*bd1**2*f*r*s + 1155*D1**2*bd1**2*f*r + 231*D1**2*bd1**2*f*s - 231*D1**2*bd1**2*f + 2772*D1**2*bd1*bd2*f*r**2 + 2772*D1**2*bd1*bd2*f*r*s - 4158*D1**2*bd1*bd2*f*r - 1386*D1**2*bd1*bd2*f*s + 1386*D1**2*bd1*bd2*f + 924*D1**2*bd1*f**3*r**2 + 286*D1**2*bd1*f**3*r*s - 517*D1**2*bd1*f**3*r + 891*D1**2*bd1*f**3*s - 319*D1**2*bd1*f**3 - 6336*D1**2*bd1*f**2*fd*r**2 - 2640*D1**2*bd1*f**2*fd*r*s + 4202*D1**2*bd1*f**2*fd*r - 1342*D1**2*bd1*f**2*fd*s + 561*D1**2*bd1*f**2*fd + 396*D1**2*bd1*f**2*r**2 - 33*D1**2*bd1*f**2*r*s + 33*D1**2*bd1*f**2*r - 792*D1**2*bd1*f*fd*r**2 - 396*D1**2*bd1*f*fd*r*s + 594*D1**2*bd1*f*fd*r + 99*D1**2*bd1*f*fd*s - 99*D1**2*bd1*f*fd + 1386*D1**2*bd1*f*g2*r**2 - 1848*D1**2*bd1*f*g2*r*s - 2772*D1**2*bd1*f*g2*r + 1848*D1**2*bd1*f*g2*s + 1386*D1**2*bd1*f*g2 - 12936*D1**2*bd1*f*gd2*r**2 - 7392*D1**2*bd1*f*gd2*r*s + 16632*D1**2*bd1*f*gd2*r + 3696*D1**2*bd1*f*gd2*s - 3696*D1**2*bd1*f*gd2 - 12936*D1**2*bd1*fd*g2*r**2 - 7392*D1**2*bd1*fd*g2*r*s + 12936*D1**2*bd1*fd*g2*r + 3696*D1**2*bd1*fd*g2*s - 726*D1**2*bd2*f**2*r**2 - 726*D1**2*bd2*f**2*r*s + 726*D1**2*bd2*f**2*r + 2376*D1**2*bd2*f*fd*r**2 + 2376*D1**2*bd2*f*fd*r*s - 2376*D1**2*bd2*f*fd*r - 594*D1**2*bd2*f*fd*s + 594*D1**2*bd2*f*fd - 1056*D1**2*bdd1*f**3*r**2 - 440*D1**2*bdd1*f**3*r*s + 605*D1**2*bdd1*f**3*r - 891*D1**2*bdd1*f**3*s + 308*D1**2*bdd1*f**3 - 198*D1**2*bdd1*f**2*r**2 - 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*r - 6468*D1**2*bdd1*f*g2*r**2 - 3696*D1**2*bdd1*f*g2*r*s + 12936*D1**2*bdd1*f*g2*r + 3696*D1**2*bdd1*f*g2*s - 6468*D1**2*bdd1*f*g2 + 594*D1**2*bdd2*f**2*r**2 + 594*D1**2*bdd2*f**2*r*s - 594*D1**2*bdd2*f**2*r - 940*D1**2*f**3*fd*r**2 - 1980*D1**2*f**3*fd*r*s + 1460*D1**2*f**3*fd*r + 495*D1**2*f**3*fd*s - 235*D1**2*f**3*fd + 800*D1**2*f**3*fdd*r**2 + 1980*D1**2*f**3*fdd*r*s - 1390*D1**2*f**3*fdd*r - 495*D1**2*f**3*fdd*s + 200*D1**2*f**3*fdd + 2400*D1**2*f**2*fd**2*r**2 + 5940*D1**2*f**2*fd**2*r*s - 4170*D1**2*f**2*fd**2*r - 1485*D1**2*f**2*fd**2*s + 990*D1**2*f**2*fd**2 + 3762*D1**2*f**2*gd2*r**2 + 1320*D1**2*f**2*gd2*r*s - 1320*D1**2*f**2*gd2*r - 3036*D1**2*f**2*gdd2*r**2 - 1584*D1**2*f**2*gdd2*r*s + 1584*D1**2*f**2*gdd2*r + 7524*D1**2*f*fd*g2*r**2 + 2640*D1**2*f*fd*g2*r*s - 7524*D1**2*f*fd*g2*r - 1320*D1**2*f*fd*g2*s + 3762*D1**2*f*fd*g2 - 12144*D1**2*f*fd*gd2*r**2 - 6336*D1**2*f*fd*gd2*r*s + 9240*D1**2*f*fd*gd2*r + 1584*D1**2*f*fd*gd2*s - 1584*D1**2*f*fd*gd2 - 6072*D1**2*f*fdd*g2*r**2 - 3168*D1**2*f*fdd*g2*r*s + 6072*D1**2*f*fdd*g2*r + 1584*D1**2*f*fdd*g2*s - 3036*D1**2*f*fdd*g2 - 6072*D1**2*fd**2*g2*r**2 - 3168*D1**2*fd**2*g2*r*s + 6072*D1**2*fd**2*g2*r + 1584*D1**2*fd**2*g2*s + 12144*D1*Dd*K*bd1*f**2*r**2 + 6336*D1*Dd*K*bd1*f**2*r*s - 7788*D1*Dd*K*bd1*f**2*r - 792*D1*Dd*K*bd1*f**2*s + 792*D1*Dd*K*bd1*f**2 - 8448*D1*Dd*bd1*f**3*r**2 - 3520*D1*Dd*bd1*f**3*r*s + 5412*D1*Dd*bd1*f**3*r - 3124*D1*Dd*bd1*f**3*s + 1177*D1*Dd*bd1*f**3 - 1584*D1*Dd*bd1*f**2*r**2 - 792*D1*Dd*bd1*f**2*r*s + 990*D1*Dd*bd1*f**2*r + 99*D1*Dd*bd1*f**2*s - 99*D1*Dd*bd1*f**2 - 51744*D1*Dd*bd1*f*g2*r**2 - 29568*D1*Dd*bd1*f*g2*r*s + 72072*D1*Dd*bd1*f*g2*r + 18480*D1*Dd*bd1*f*g2*s - 20328*D1*Dd*bd1*f*g2 + 4752*D1*Dd*bd2*f**2*r**2 + 4752*D1*Dd*bd2*f**2*r*s - 4752*D1*Dd*bd2*f**2*r - 594*D1*Dd*bd2*f**2*s + 594*D1*Dd*bd2*f**2 - 940*D1*Dd*f**4*r**2 - 1980*D1*Dd*f**4*r*s + 1460*D1*Dd*f**4*r + 495*D1*Dd*f**4*s - 235*D1*Dd*f**4 + 6400*D1*Dd*f**3*fd*r**2 + 15840*D1*Dd*f**3*fd*r*s - 11120*D1*Dd*f**3*fd*r - 3960*D1*Dd*f**3*fd*s + 2380*D1*Dd*f**3*fd + 15048*D1*Dd*f**2*g2*r**2 + 5280*D1*Dd*f**2*g2*r*s - 10164*D1*Dd*f**2*g2*r - 1320*D1*Dd*f**2*g2*s + 3762*D1*Dd*f**2*g2 - 24288*D1*Dd*f**2*gd2*r**2 - 12672*D1*Dd*f**2*gd2*r*s + 15576*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s - 1584*D1*Dd*f**2*gd2 - 48576*D1*Dd*f*fd*g2*r**2 - 25344*D1*Dd*f*fd*g2*r*s + 42768*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s - 9240*D1*Dd*f*fd*g2 + 800*D1*Ddd*f**4*r**2 + 1980*D1*Ddd*f**4*r*s - 1390*D1*Ddd*f**4*r - 495*D1*Ddd*f**4*s + 200*D1*Ddd*f**4 - 12144*D1*Ddd*f**2*g2*r**2 - 6336*D1*Ddd*f**2*g2*r*s + 9240*D1*Ddd*f**2*g2*r + 1584*D1*Ddd*f**2*g2*s - 3036*D1*Ddd*f**2*g2 + 2400*Dd**2*f**4*r**2 + 5940*Dd**2*f**4*r*s - 4170*Dd**2*f**4*r - 1485*Dd**2*f**4*s + 990*Dd**2*f**4 - 36432*Dd**2*f**2*g2*r**2 - 19008*Dd**2*f**2*g2*r*s + 27720*Dd**2*f**2*g2*r + 4752*Dd**2*f**2*g2*s - 3168*Dd**2*f**2*g2 + 462*b1**3*(D1**2*r*(fd + 2*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) + 2*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + 2*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 2*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1**2*(-21*D1**2*K*fd*r**2 + 28*D1**2*K*fd*r*s + 98*D1**2*K*fdd*r**2 + 56*D1**2*K*fdd*r*s + 28*D1**2*bdd1*f*(3*r**2 + 3*r*(s - 1) - s + 1) + 58*D1**2*f*fd*r**2 + 118*D1**2*f*fd*r*s - 37*D1**2*f*fd*r + 10*D1**2*f*fd*s - 10*D1**2*f*fd - 120*D1**2*f*fdd*r**2 - 150*D1**2*f*fdd*r*s + 57*D1**2*f*fdd*r - 12*D1**2*f*fdd*s + 12*D1**2*f*fdd - 120*D1**2*fd**2*r**2 - 150*D1**2*fd**2*r*s + 57*D1**2*fd**2*r - 12*D1**2*fd**2*s + 12*D1**2*fd**2 + 28*D1**2*fd*r**2 - 21*D1**2*fd*r*s - 14*D1**2*fdd*r**2 - 7*D1**2*fdd*r*s - 84*D1*Dd*K*f*r**2 + 112*D1*Dd*K*f*r*s - 14*D1*Dd*K*f*r - 28*D1*Dd*K*f*s - 21*D1*Dd*K*f + 784*D1*Dd*K*fd*r**2 + 448*D1*Dd*K*fd*r*s - 308*D1*Dd*K*fd*r - 56*D1*Dd*K*fd*s + 116*D1*Dd*f**2*r**2 + 236*D1*Dd*f**2*r*s - 176*D1*Dd*f**2*r - 59*D1*Dd*f**2*s + 29*D1*Dd*f**2 - 960*D1*Dd*f*fd*r**2 - 1200*D1*Dd*f*fd*r*s + 768*D1*Dd*f*fd*r + 102*D1*Dd*f*fd*s - 33*D1*Dd*f*fd + 112*D1*Dd*f*r**2 - 84*D1*Dd*f*r*s - 14*D1*Dd*f*r + 21*D1*Dd*f*s + 28*D1*Dd*f - 112*D1*Dd*fd*r**2 - 56*D1*Dd*fd*r*s + 42*D1*Dd*fd*r + 7*D1*Dd*fd*s + 392*D1*Ddd*K*f*r**2 + 224*D1*Ddd*K*f*r*s - 308*D1*Ddd*K*f*r - 56*D1*Ddd*K*f*s + 98*D1*Ddd*K*f - 240*D1*Ddd*f**2*r**2 - 300*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r + 75*D1*Ddd*f**2*s - 60*D1*Ddd*f**2 - 56*D1*Ddd*f*r**2 - 28*D1*Ddd*f*r*s + 42*D1*Ddd*f*r + 7*D1*Ddd*f*s - 14*D1*Ddd*f + 14*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) + 2*fd*(6*r**2 + 6*r*(s - 1) - s + 1)) + 2*Dd*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 1176*Dd**2*K*f*r**2 + 672*Dd**2*K*f*r*s - 924*Dd**2*K*f*r - 168*Dd**2*K*f*s + 112*Dd**2*K*f - 720*Dd**2*f**2*r**2 - 900*Dd**2*f**2*r*s + 810*Dd**2*f**2*r + 225*Dd**2*f**2*s - 150*Dd**2*f**2 - 168*Dd**2*f*r**2 - 84*Dd**2*f*r*s + 126*Dd**2*f*r + 21*Dd**2*f*s - 14*Dd**2*f) + 11*b1*(-342*D1**2*K*f*fd*r**2 - 120*D1**2*K*f*fd*r*s + 342*D1**2*K*f*fd*r + 60*D1**2*K*f*fd*s - 171*D1**2*K*f*fd + 276*D1**2*K*f*fdd*r**2 + 144*D1**2*K*f*fdd*r*s - 276*D1**2*K*f*fdd*r - 72*D1**2*K*f*fdd*s + 138*D1**2*K*f*fdd + 276*D1**2*K*fd**2*r**2 + 144*D1**2*K*fd**2*r*s - 276*D1**2*K*fd**2*r - 72*D1**2*K*fd**2*s - 42*D1**2*b2*fd*r**2 - 42*D1**2*b2*fd*r*s + 126*D1**2*b2*fdd*r**2 + 126*D1**2*b2*fdd*r*s + 84*D1**2*bd1**2*f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 42*D1**2*bd2*f*r**2 - 42*D1**2*bd2*f*r*s + 42*D1**2*bd2*f*r + 252*D1**2*bd2*fd*r**2 + 252*D1**2*bd2*fd*r*s - 126*D1**2*bd2*fd*r - 3*D1**2*bdd1*f*(-14*K*(14*r**2 + 8*r*s - 18*r - 4*s + 7) + 3*f*(40*r**2 + r*(50*s - 71) - 29*s + 24) + 28*r**2 + 14*r*s - 35*r - 7*s + 14) + 126*D1**2*bdd2*f*r**2 + 126*D1**2*bdd2*f*r*s - 126*D1**2*bdd2*f*r + 252*D1**2*f**2*fd*r**2 + 78*D1**2*f**2*fd*r*s - 173*D1**2*f**2*fd*r - 107*D1**2*f**2*fd*s + 113*D1**2*f**2*fd - 288*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 217*D1**2*f**2*fdd*r + 121*D1**2*f**2*fdd*s - 124*D1**2*f**2*fdd - 576*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 434*D1**2*f*fd**2*r + 242*D1**2*f*fd**2*s - 131*D1**2*f*fd**2 + 72*D1**2*f*fd*r**2 - 6*D1**2*f*fd*r*s - 72*D1**2*f*fd*r + 3*D1**2*f*fd*s + 36*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 18*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 18*D1**2*f*fdd + 126*D1**2*f*gd2*r**2 - 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*r - 588*D1**2*f*gdd2*r**2 - 336*D1**2*f*gdd2*r*s + 336*D1**2*f*gdd2*r - 36*D1**2*fd**2*r**2 - 18*D1**2*fd**2*r*s + 36*D1**2*fd**2*r + 9*D1**2*fd**2*s + 126*D1**2*fd*g2*r**2 - 168*D1**2*fd*g2*r*s - 1176*D1**2*fd*gd2*r**2 - 672*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r - 588*D1**2*fdd*g2*r**2 - 336*D1**2*fdd*g2*r*s - 684*D1*Dd*K*f**2*r**2 - 240*D1*Dd*K*f**2*r*s + 462*D1*Dd*K*f**2*r + 60*D1*Dd*K*f**2*s - 171*D1*Dd*K*f**2 + 2208*D1*Dd*K*f*fd*r**2 + 1152*D1*Dd*K*f*fd*r*s - 1944*D1*Dd*K*f*fd*r - 432*D1*Dd*K*f*fd*s + 420*D1*Dd*K*f*fd - 168*D1*Dd*b2*f*r**2 - 168*D1*Dd*b2*f*r*s + 168*D1*Dd*b2*f*r + 42*D1*Dd*b2*f*s - 42*D1*Dd*b2*f + 1008*D1*Dd*b2*fd*r**2 + 1008*D1*Dd*b2*fd*r*s - 504*D1*Dd*b2*fd*r - 126*D1*Dd*b2*fd*s + 1008*D1*Dd*bd2*f*r**2 + 1008*D1*Dd*bd2*f*r*s - 1008*D1*Dd*bd2*f*r - 126*D1*Dd*bd2*f*s + 126*D1*Dd*bd2*f + 336*D1*Dd*f**3*r**2 + 104*D1*Dd*f**3*r*s - 220*D1*Dd*f**3*r - 26*D1*Dd*f**3*s + 84*D1*Dd*f**3 - 2304*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 1684*D1*Dd*f**2*fd*r + 604*D1*Dd*f**2*fd*s - 459*D1*Dd*f**2*fd + 144*D1*Dd*f**2*r**2 - 12*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 3*D1*Dd*f**2*s + 36*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 144*D1*Dd*f*fd*r*s + 252*D1*Dd*f*fd*r + 54*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 504*D1*Dd*f*g2*r**2 - 672*D1*Dd*f*g2*r*s + 84*D1*Dd*f*g2*r + 168*D1*Dd*f*g2*s + 126*D1*Dd*f*g2 - 4704*D1*Dd*f*gd2*r**2 - 2688*D1*Dd*f*gd2*r*s + 3192*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s - 336*D1*Dd*f*gd2 - 4704*D1*Dd*fd*g2*r**2 - 2688*D1*Dd*fd*g2*r*s + 1848*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s + 552*D1*Ddd*K*f**2*r**2 + 288*D1*Ddd*K*f**2*r*s - 420*D1*Ddd*K*f**2*r - 72*D1*Ddd*K*f**2*s + 138*D1*Ddd*K*f**2 + 504*D1*Ddd*b2*f*r**2 + 504*D1*Ddd*b2*f*r*s - 504*D1*Ddd*b2*f*r - 126*D1*Ddd*b2*f*s + 126*D1*Ddd*b2*f - 384*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 272*D1*Ddd*f**3*r + 40*D1*Ddd*f**3*s - 96*D1*Ddd*f**3 - 72*D1*Ddd*f**2*r**2 - 36*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r + 9*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 - 2352*D1*Ddd*f*g2*r**2 - 1344*D1*Ddd*f*g2*r*s + 1848*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s - 588*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(f**2*(58*r**2 + r*(118*s - 139) - 69*s + 39) + f*(-7*K*(6*r**2 - 8*r*s - 2*r + 4*s + 3) - 3*fd*(160*r**2 + 20*r*(10*s - 9) - 50*s + 27) + 56*r**2 - 42*r*s - 35*r + 21*s + 28) + 7*fd*(-8*K*s + r**2*(56*K - 8) + r*(4*K*(8*s - 9) - 4*s + 5) + s)) + Dd*f*(28*K*(56*r**2 + r*(32*s - 58) - 12*s + 13) - 3*f*(320*r**2 + 16*r*(25*s - 29) - 166*s + 129) - 224*r**2 - 112*r*(s - 2) + 42*s - 49)) + 1656*Dd**2*K*f**2*r**2 + 864*Dd**2*K*f**2*r*s - 1260*Dd**2*K*f**2*r - 216*Dd**2*K*f**2*s + 144*Dd**2*K*f**2 + 1512*Dd**2*b2*f*r**2 + 1512*Dd**2*b2*f*r*s - 1512*Dd**2*b2*f*r - 378*Dd**2*b2*f*s + 252*Dd**2*b2*f - 1152*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 816*Dd**2*f**3*r + 120*Dd**2*f**3*s - 80*Dd**2*f**3 - 216*Dd**2*f**2*r**2 - 108*Dd**2*f**2*r*s + 162*Dd**2*f**2*r + 27*Dd**2*f**2*s - 18*Dd**2*f**2 - 7056*Dd**2*f*g2*r**2 - 4032*Dd**2*f*g2*r*s + 5544*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s - 672*Dd**2*f*g2) - 66*b2*(-21*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 22*D1**2*f*fd*r**2 + 22*D1**2*f*fd*r*s - 22*D1**2*f*fd*r - 11*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 18*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 9*D1**2*f*fdd - 18*D1**2*fd**2*r**2 - 18*D1**2*fd**2*r*s + 18*D1**2*fd**2*r + 9*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 44*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r - 11*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 144*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r + 54*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 36*D1*Ddd*f**2*r**2 - 36*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r + 9*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 108*Dd**2*f**2*r**2 - 108*Dd**2*f**2*r*s + 108*Dd**2*f**2*r + 27*Dd**2*f**2*s - 18*Dd**2*f**2))/(3465*d**2*k3**4) - D1**2*Pk3*Pkd1*k1*st**4*(8*C - 4)*(3*D1*bd1*f*(D1*(2*f*s*(r - 1) + fd*(-4*r*s + r + 2*s - 1)) + Dd*f*(r*(2 - 8*s) + 5*s - 2)) - 3*b1*(D1*Dd*f*(2*f*(-4*r*s + 2*r + s) + fd*(8*r - 1)*(2*s - 1)) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + 2*r + s)) + Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(2*f*(4*r*s - 2*r - s) + fd*(-24*r*s + 10*r + 7*s - 3)) + D1*(D1*(2*f*fd*(r*(3*s - 1) - s) + f*(-3*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) + fd**2*(r*(2 - 6*s) + 2*s - 1)) + Ddd*f**2*(r*(2 - 4*s) + s)) + Dd**2*f**2*(r*(6 - 12*s) + 3*s - 2)))/(105*d**2*k3**2) + D1**2*Pk3*Pkd1*k1*st**2*(21*b1**2*(D1**2*r*(fd*(2*C*(7*r + 6*s - 6) - 7*r - 9*s + 9) + fdd*(4*C*(2*r + s - 1) - 4*r - 3*s + 3)) + D1*(Dd*(f*(2*C*(28*r**2 + 24*r*s - 26*r - 6*s + 7) - 28*r**2 - 36*r*s + 32*r + 9*s - 7) + fd*(4*C*(8*r - 1)*(2*r + s - 1) - 32*r**2 - 24*r*s + 26*r + 3*s - 3)) + Ddd*f*(4*C*(8*r**2 + 4*r*s - 6*r - s + 2) - 16*r**2 - 12*r*s + 14*r + 3*s - 4)) + Dd**2*f*(4*C*(24*r**2 + 6*r*(2*s - 3) - 3*s + 2) - 48*r**2 - 36*r*s + 42*r + 9*s - 6)) + 3*b1*(176*C*D1**2*f*fd*r*s - 44*C*D1**2*f*fd*r - 4*C*D1**2*f*fd*s - 22*C*D1**2*f*fd - 144*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s + 32*C*D1**2*f*fdd - 144*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 + 352*C*D1*Dd*f**2*r*s - 176*C*D1*Dd*f**2*r - 88*C*D1*Dd*f**2*s - 1152*C*D1*Dd*f*fd*r*s + 320*C*D1*Dd*f*fd*r + 96*C*D1*Dd*f*fd*s + 16*C*D1*Dd*f*fd - 288*C*D1*Ddd*f**2*r*s + 144*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s - 864*C*Dd**2*f**2*r*s + 432*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s - 144*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(4*C*(4*r**2 + 2*r*(s - 2) - s + 2) - 8*r**2 - 6*r*s + 8*r + 3*s - 4) - 88*D1**2*f*fd*r*s + 22*D1**2*f*fd*r + 3*D1**2*f*fd*s + 11*D1**2*f*fd + 72*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 16*D1**2*f*fdd + 72*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 9*D1**2*fd**2*s - 9*D1**2*fd**2 - 176*D1*Dd*f**2*r*s + 88*D1*Dd*f**2*r + 44*D1*Dd*f**2*s + 576*D1*Dd*f*fd*r*s - 160*D1*Dd*f*fd*r - 36*D1*Dd*f*fd*s - 14*D1*Dd*f*fd + 144*D1*Ddd*f**2*r*s - 72*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s + 7*D1*bd1*(D1*(f*(2*C*(14*r**2 + 2*r*(6*s - 7) - 6*s + 7) - 14*r**2 - 18*r*s + 14*r + 9*s - 7) + fd*(4*C*(4*r - 1)*(2*r + s - 1) - 16*r**2 - 12*r*s + 14*r + 3*s - 3)) + 2*Dd*f*(4*C*(8*r - 3)*(2*r + s - 1) - 32*r**2 - 24*r*s + 30*r + 9*s - 7)) + 432*Dd**2*f**2*r*s - 216*Dd**2*f**2*r - 108*Dd**2*f**2*s + 72*Dd**2*f**2) + f*(174*C*D1**2*f*fd*r**2 + 324*C*D1**2*f*fd*r*s - 224*C*D1**2*f*fd*r - 108*C*D1**2*f*fd*s + 58*C*D1**2*f*fd - 168*C*D1**2*f*fdd*r**2 - 324*C*D1**2*f*fdd*r*s + 220*C*D1**2*f*fdd*r + 108*C*D1**2*f*fdd*s - 56*C*D1**2*f*fdd - 336*C*D1**2*fd**2*r**2 - 648*C*D1**2*fd**2*r*s + 440*C*D1**2*fd**2*r + 216*C*D1**2*fd**2*s - 108*C*D1**2*fd**2 + 232*C*D1*Dd*f**2*r**2 + 432*C*D1*Dd*f**2*r*s - 332*C*D1*Dd*f**2*r - 108*C*D1*Dd*f**2*s + 58*C*D1*Dd*f**2 - 1344*C*D1*Dd*f*fd*r**2 - 2592*C*D1*Dd*f*fd*r*s + 1864*C*D1*Dd*f*fd*r + 756*C*D1*Dd*f*fd*s - 436*C*D1*Dd*f*fd - 224*C*D1*Ddd*f**2*r**2 - 432*C*D1*Ddd*f**2*r*s + 328*C*D1*Ddd*f**2*r + 108*C*D1*Ddd*f**2*s - 56*C*D1*Ddd*f**2 - 672*C*Dd**2*f**2*r**2 - 1296*C*Dd**2*f**2*r*s + 984*C*Dd**2*f**2*r + 324*C*Dd**2*f**2*s - 216*C*Dd**2*f**2 + 21*D1**2*bd1**2*(r**2*(16*C - 8) + 2*r*(4*C*(s - 2) - 3*s + 4) + s*(3 - 4*C)) - 3*D1**2*bdd1*f*(4*C*(2*r*(9*s - 8) - 21*s + 8) - 4*r*(9*s - 8) + 45*s - 16) - 87*D1**2*f*fd*r**2 - 165*D1**2*f*fd*r*s + 113*D1**2*f*fd*r + 55*D1**2*f*fd*s - 29*D1**2*f*fd + 84*D1**2*f*fdd*r**2 + 177*D1**2*f*fdd*r*s - 115*D1**2*f*fdd*r - 59*D1**2*f*fdd*s + 28*D1**2*f*fdd + 168*D1**2*fd**2*r**2 + 354*D1**2*fd**2*r*s - 230*D1**2*fd**2*r - 118*D1**2*fd**2*s + 59*D1**2*fd**2 - 116*D1*Dd*f**2*r**2 - 220*D1*Dd*f**2*r*s + 168*D1*Dd*f**2*r + 55*D1*Dd*f**2*s - 29*D1*Dd*f**2 + 672*D1*Dd*f*fd*r**2 + 1416*D1*Dd*f*fd*r*s - 982*D1*Dd*f*fd*r - 413*D1*Dd*f*fd*s + 233*D1*Dd*f*fd + 112*D1*Ddd*f**2*r**2 + 236*D1*Ddd*f**2*r*s - 174*D1*Ddd*f**2*r - 59*D1*Ddd*f**2*s + 28*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(C*(88*r*s - 44*r - 84*s + 22) - 44*r*s + 22*r + 41*s - 11) + fd*(-4*C*(72*r*s - 34*r - 39*s + 21) + 144*r*s - 68*r - 81*s + 45)) + 2*Dd*f*(-4*C*(r*(72*s - 50) - 51*s + 29) + 4*r*(36*s - 25) - 108*s + 61)) + 336*Dd**2*f**2*r**2 + 708*Dd**2*f**2*r*s - 522*Dd**2*f**2*r - 177*Dd**2*f**2*s + 118*Dd**2*f**2))/(315*d**2*k3**2) - D1**2*Pk3*Pkd1*k1*(56*D1**2*K*bd1**2*f*r*s - 182*D1**2*K*bd1**2*f*r - 70*D1**2*K*bd1**2*f*s + 70*D1**2*K*bd1**2*f - 51*D1**2*K*bd1*f**2*r**2 - 42*D1**2*K*bd1*f**2*r*s + 42*D1**2*K*bd1*f**2*r + 228*D1**2*K*bd1*f*fd*r**2 + 168*D1**2*K*bd1*f*fd*r*s - 198*D1**2*K*bd1*f*fd*r - 42*D1**2*K*bd1*f*fd*s + 42*D1**2*K*bd1*f*fd + 57*D1**2*K*bdd1*f**2*r**2 + 42*D1**2*K*bdd1*f**2*r*s - 42*D1**2*K*bdd1*f**2*r + 21*D1**2*bd1**2*f**2*s - 21*D1**2*bd1**2*f**2 + 21*D1**2*bd1**2*f*s - 21*D1**2*bd1**2*f + 420*D1**2*bd1**2*g2*r**2 + 280*D1**2*bd1**2*g2*r*s - 420*D1**2*bd1**2*g2*r - 140*D1**2*bd1**2*g2*s + 154*D1**2*bd1*bd2*f*r**2 + 140*D1**2*bd1*bd2*f*r*s - 224*D1**2*bd1*bd2*f*r - 70*D1**2*bd1*bd2*f*s + 70*D1**2*bd1*bd2*f + 15*D1**2*bd1*f**3*r*s - 15*D1**2*bd1*f**3*r - 90*D1**2*bd1*f**2*fd*r*s + 60*D1**2*bd1*f**2*fd*r + 15*D1**2*bd1*f**2*fd*s - 15*D1**2*bd1*f**2*fd + 9*D1**2*bd1*f**2*r*s - 9*D1**2*bd1*f**2*r - 60*D1**2*bd1*f*fd*r*s + 30*D1**2*bd1*f*fd*r + 15*D1**2*bd1*f*fd*s - 15*D1**2*bd1*f*fd + 112*D1**2*bd1*f*g2*r*s - 196*D1**2*bd1*f*g2*r - 140*D1**2*bd1*f*g2*s + 98*D1**2*bd1*f*g2 - 112*D1**2*bd1*f*gd2*r*s + 364*D1**2*bd1*f*gd2*r + 140*D1**2*bd1*f*gd2*s - 140*D1**2*bd1*f*gd2 - 112*D1**2*bd1*fd*g2*r*s + 56*D1**2*bd1*fd*g2*s - 51*D1**2*bd2*f**2*r**2 - 42*D1**2*bd2*f**2*r*s + 42*D1**2*bd2*f**2*r + 228*D1**2*bd2*f*fd*r**2 + 168*D1**2*bd2*f*fd*r*s - 198*D1**2*bd2*f*fd*r - 42*D1**2*bd2*f*fd*s + 42*D1**2*bd2*f*fd - 15*D1**2*bdd1*f**3*r*s + 15*D1**2*bdd1*f**3*r - 15*D1**2*bdd1*f**2*r*s + 15*D1**2*bdd1*f**2*r - 56*D1**2*bdd1*f*g2*r*s + 308*D1**2*bdd1*f*g2*r + 140*D1**2*bdd1*f*g2*s - 154*D1**2*bdd1*f*g2 + 57*D1**2*bdd2*f**2*r**2 + 42*D1**2*bdd2*f**2*r*s - 42*D1**2*bdd2*f**2*r + 102*D1**2*f**2*gd2*r**2 + 84*D1**2*f**2*gd2*r*s - 84*D1**2*f**2*gd2*r - 114*D1**2*f**2*gdd2*r**2 - 84*D1**2*f**2*gdd2*r*s + 84*D1**2*f**2*gdd2*r + 204*D1**2*f*fd*g2*r**2 + 168*D1**2*f*fd*g2*r*s - 204*D1**2*f*fd*g2*r - 84*D1**2*f*fd*g2*s + 102*D1**2*f*fd*g2 - 456*D1**2*f*fd*gd2*r**2 - 336*D1**2*f*fd*gd2*r*s + 396*D1**2*f*fd*gd2*r + 84*D1**2*f*fd*gd2*s - 84*D1**2*f*fd*gd2 - 228*D1**2*f*fdd*g2*r**2 - 168*D1**2*f*fdd*g2*r*s + 228*D1**2*f*fdd*g2*r + 84*D1**2*f*fdd*g2*s - 114*D1**2*f*fdd*g2 - 228*D1**2*fd**2*g2*r**2 - 168*D1**2*fd**2*g2*r*s + 228*D1**2*fd**2*g2*r + 84*D1**2*fd**2*g2*s + 456*D1*Dd*K*bd1*f**2*r**2 + 336*D1*Dd*K*bd1*f**2*r*s - 366*D1*Dd*K*bd1*f**2*r - 42*D1*Dd*K*bd1*f**2*s + 42*D1*Dd*K*bd1*f**2 - 120*D1*Dd*bd1*f**3*r*s + 90*D1*Dd*bd1*f**3*r + 15*D1*Dd*bd1*f**3*s - 15*D1*Dd*bd1*f**3 - 120*D1*Dd*bd1*f**2*r*s + 90*D1*Dd*bd1*f**2*r + 15*D1*Dd*bd1*f**2*s - 15*D1*Dd*bd1*f**2 - 448*D1*Dd*bd1*f*g2*r*s + 1344*D1*Dd*bd1*f*g2*r + 616*D1*Dd*bd1*f*g2*s - 588*D1*Dd*bd1*f*g2 + 456*D1*Dd*bd2*f**2*r**2 + 336*D1*Dd*bd2*f**2*r*s - 366*D1*Dd*bd2*f**2*r - 42*D1*Dd*bd2*f**2*s + 42*D1*Dd*bd2*f**2 + 408*D1*Dd*f**2*g2*r**2 + 336*D1*Dd*f**2*g2*r*s - 372*D1*Dd*f**2*g2*r - 84*D1*Dd*f**2*g2*s + 102*D1*Dd*f**2*g2 - 912*D1*Dd*f**2*gd2*r**2 - 672*D1*Dd*f**2*gd2*r*s + 732*D1*Dd*f**2*gd2*r + 84*D1*Dd*f**2*gd2*s - 84*D1*Dd*f**2*gd2 - 1824*D1*Dd*f*fd*g2*r**2 - 1344*D1*Dd*f*fd*g2*r*s + 1704*D1*Dd*f*fd*g2*r + 504*D1*Dd*f*fd*g2*s - 396*D1*Dd*f*fd*g2 - 456*D1*Ddd*f**2*g2*r**2 - 336*D1*Ddd*f**2*g2*r*s + 396*D1*Ddd*f**2*g2*r + 84*D1*Ddd*f**2*g2*s - 114*D1*Ddd*f**2*g2 - 1368*Dd**2*f**2*g2*r**2 - 1008*Dd**2*f**2*g2*r*s + 1188*Dd**2*f**2*g2*r + 252*Dd**2*f**2*g2*s - 168*Dd**2*f**2*g2 + 35*b1**3*(D1*Dd*(K*(-12*r**2 + r*(10 - 8*s) + 2*s - 3) + fd*r*(8*s - 6) - fd*s + fd - (f - 1)*(r*(4*s - 2) - s)) - D1*(D1*r*(fd - fdd)*(s - 1) + Ddd*K*(12*r**2 + 2*r*(4*s - 5) - 2*s + 3) - Ddd*(f + 1)*(r*(4*s - 2) - s)) + Dd**2*(K*(-36*r**2 - 24*r*s + 30*r + 6*s - 4) + f*(6*r*(2*s - 1) - 3*s + 2) + 12*r*s - 6*r - 3*s + 2)) - 7*b1**2*(D1**2*(5*K*bdd1*(9*r**2 + r*(6*s - 8) - 2*s + 3) - 4*K*fdd*r*s - 22*K*fdd*r - 6*K*fdd*s + 11*K*fdd - 5*bdd1*(f + 1)*(r*(3*s - 1) - s) + 3*f*fdd*s + 3*fd**2*(s - 1) + fd*(K*(8*r*s + 14*r + 2*s - 7) - s*(3*f + 1)) + 3*fdd*s - 30*gd2*r**2 - 20*gd2*r*s + 20*gd2*r - 30*gdd2*r**2 - 20*gdd2*r*s + 20*gdd2*r) + 5*D1*bd1*(D1*(K*(9*r**2 + 6*r*s - 8*r - 2*s + 3) + fd*(r*(4 - 6*s) + s - 1) + (f - 1)*(3*r*s - r - s)) + Dd*(2*K*(36*r**2 + 24*r*s - 31*r - 7*s + 6) + f*(r*(10 - 24*s) + 7*s - 3) - 24*r*s + 10*r + 7*s - 3)) + 2*D1*(-Dd*fd*(K*(8*r*(2*s + 5) + 10*s - 17) + f*(3 - 6*s) - 6*s + 3) - 5*Dd*g2*(12*r**2 + 2*r*(4*s - 5) - 2*s + 3) - 2*Dd*(2*K*f*(r*(2 - 4*s) + s) + 5*gd2*(12*r**2 + r*(8*s - 9) - s + 1)) + 2*Ddd*K*f*(r*(2 - 4*s) + s) - 5*Ddd*g2*(12*r**2 + 2*r*(4*s - 5) - 2*s + 3)) - 4*Dd**2*(K*f*(6*r*(2*s - 1) - 3*s + 2) + 5*g2*(18*r**2 + 3*r*(4*s - 5) - 3*s + 2))) + b1*(56*D1**2*K*bdd1*f*r*s - 182*D1**2*K*bdd1*f*r - 70*D1**2*K*bdd1*f*s + 77*D1**2*K*bdd1*f - 102*D1**2*K*f*fd*r**2 - 84*D1**2*K*f*fd*r*s + 102*D1**2*K*f*fd*r + 42*D1**2*K*f*fd*s - 51*D1**2*K*f*fd + 114*D1**2*K*f*fdd*r**2 + 84*D1**2*K*f*fdd*r*s - 114*D1**2*K*f*fdd*r - 42*D1**2*K*f*fdd*s + 57*D1**2*K*f*fdd + 114*D1**2*K*fd**2*r**2 + 84*D1**2*K*fd**2*r*s - 114*D1**2*K*fd**2*r - 42*D1**2*K*fd**2*s + 35*D1**2*bd1**2*(-2*K*(9*r**2 + r*(6*s - 8) - 2*s + 1) + f*r*(6*s - 2) - 2*f*s + f + 6*r*s - 2*r - 2*s + 1) - 49*D1**2*bd2*f*r**2 - 70*D1**2*bd2*f*r*s + 70*D1**2*bd2*f*r + 154*D1**2*bd2*fd*r**2 + 140*D1**2*bd2*fd*r*s - 70*D1**2*bd2*fd*r + 21*D1**2*bdd1*f**2*s + 21*D1**2*bdd1*f*s + 420*D1**2*bdd1*g2*r**2 + 280*D1**2*bdd1*g2*r*s - 420*D1**2*bdd1*g2*r - 140*D1**2*bdd1*g2*s + 210*D1**2*bdd1*g2 + 77*D1**2*bdd2*f*r**2 + 70*D1**2*bdd2*f*r*s - 70*D1**2*bdd2*f*r + 45*D1**2*f**2*fd*r*s - 15*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s - 45*D1**2*f**2*fdd*r*s + 15*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s - 90*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s - 15*D1**2*f*fd**2 + 18*D1**2*f*fd*r*s - 9*D1**2*f*fd*s - 30*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*s + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 30*D1**2*fd**2*r*s + 15*D1**2*fd**2*s + 112*D1**2*fd*g2*r*s + 196*D1**2*fd*g2*r + 28*D1**2*fd*g2*s - 98*D1**2*fd*g2 - 112*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*r - 84*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r*s - 308*D1**2*fdd*g2*r - 84*D1**2*fdd*g2*s + 154*D1**2*fdd*g2 - 204*D1*Dd*K*f**2*r**2 - 168*D1*Dd*K*f**2*r*s + 186*D1*Dd*K*f**2*r + 42*D1*Dd*K*f**2*s - 51*D1*Dd*K*f**2 + 912*D1*Dd*K*f*fd*r**2 + 672*D1*Dd*K*f*fd*r*s - 852*D1*Dd*K*f*fd*r - 252*D1*Dd*K*f*fd*s + 198*D1*Dd*K*f*fd + 616*D1*Dd*bd2*f*r**2 + 560*D1*Dd*bd2*f*r*s - 574*D1*Dd*bd2*f*r - 70*D1*Dd*bd2*f*s + 70*D1*Dd*bd2*f + 60*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r - 15*D1*Dd*f**3*s - 360*D1*Dd*f**2*fd*r*s + 150*D1*Dd*f**2*fd*r + 105*D1*Dd*f**2*fd*s - 45*D1*Dd*f**2*fd + 36*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r - 9*D1*Dd*f**2*s - 240*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r + 90*D1*Dd*f*fd*s - 30*D1*Dd*f*fd + 448*D1*Dd*f*g2*r*s - 224*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s - 448*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r + 56*D1*Dd*f*gd2*s - 56*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r*s - 1120*D1*Dd*fd*g2*r - 280*D1*Dd*fd*g2*s + 476*D1*Dd*fd*g2 + 228*D1*Ddd*K*f**2*r**2 + 168*D1*Ddd*K*f**2*r*s - 198*D1*Ddd*K*f**2*r - 42*D1*Ddd*K*f**2*s + 57*D1*Ddd*K*f**2 - 60*D1*Ddd*f**3*r*s + 30*D1*Ddd*f**3*r + 15*D1*Ddd*f**3*s - 60*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r + 15*D1*Ddd*f**2*s - 224*D1*Ddd*f*g2*r*s + 112*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s - 7*D1*bd1*(D1*(16*K*f*r*s - 22*K*f*r - 10*K*f*s + 7*K*f + 3*f**2*s + f*s - fd*(2*K*(8*r*s + 9*r + s - 3) - 3*s + 3) - 10*g2*(6*r**2 + 4*r*s - 6*r - 2*s + 3) - 120*gd2*r**2 - 80*gd2*r*s + 100*gd2*r + 20*gd2*s - 20*gd2) - 2*Dd*(f**2*(6*s - 3) + f*(K*(32*r*s - 60*r - 24*s + 23) + 6*s - 3) + 10*g2*(24*r**2 + 2*r*(8*s - 11) - 6*s + 5))) + 684*Dd**2*K*f**2*r**2 + 504*Dd**2*K*f**2*r*s - 594*Dd**2*K*f**2*r - 126*Dd**2*K*f**2*s + 84*Dd**2*K*f**2 - 180*Dd**2*f**3*r*s + 90*Dd**2*f**3*r + 45*Dd**2*f**3*s - 30*Dd**2*f**3 - 180*Dd**2*f**2*r*s + 90*Dd**2*f**2*r + 45*Dd**2*f**2*s - 30*Dd**2*f**2 - 672*Dd**2*f*g2*r*s + 336*Dd**2*f*g2*r + 168*Dd**2*f*g2*s - 112*Dd**2*f*g2 - 7*b2*(D1**2*r*(7*fd*r + 10*fd*s - 11*fdd*r - 10*fdd*s) + D1*(Dd*(f*(28*r**2 + 40*r*s - 34*r - 10*s + 7) + 2*fd*(-44*r**2 - 40*r*s + 21*r + 5*s)) + Ddd*f*(-44*r**2 + r*(42 - 40*s) + 10*s - 11)) - 2*Dd**2*f*(66*r**2 + r*(60*s - 63) - 15*s + 10))) + b2*(7*D1**2*bdd1*f*(r - 1)*(11*r + 10*s - 11) - 3*D1**2*(f*(fd*(34*r**2 + 28*r*s - 34*r - 14*s + 17) + fdd*(-38*r**2 - 28*r*s + 38*r + 14*s - 19)) + 2*fd**2*(-19*r**2 + r*(19 - 14*s) + 7*s)) - 7*D1*bd1*(D1*(f*(r - 1)*(7*r + 10*s - 7) + 2*fd*(-11*r**2 - 10*r*s + 11*r + 5*s)) - 2*Dd*f*(44*r**2 + 5*r*(8*s - 13) - 25*s + 21)) - 3*D1*f*(Dd*(f*(68*r**2 + r*(56*s - 62) - 14*s + 17) - 2*fd*(152*r**2 + 2*r*(56*s - 71) - 42*s + 33)) + Ddd*f*(-76*r**2 + r*(66 - 56*s) + 14*s - 19)) + 6*Dd**2*f**2*(114*r**2 + r*(84*s - 99) - 21*s + 14)))/(105*d**2*k3**2) + D1**2*Pk3*Pkd1*k2**4*st**4*(33*b1**2*(2*D1**2*r*(f*fd*(7*r + 8*s - 6) + f*fdd*(-7*r - 4*s + 3) + fd**2*(-7*r - 4*s + 3)) + D1*f*(Dd*(f*(28*r**2 + 32*r*s - 30*r - 8*s + 7) - 2*fd*(56*r**2 + 32*r*s - 34*r - 4*s + 3)) + Ddd*f*(-28*r**2 + r*(22 - 16*s) + 4*s - 7)) - 2*Dd**2*f**2*(42*r**2 + 3*r*(8*s - 11) - 6*s + 4)) - 11*b1*f*(3*D1**2*bdd1*f*(14*r**2 + 8*r*(s - 2) - 4*s + 7) + 18*D1**2*f*fd*r**2 + 21*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 8*D1**2*f*fd*s - 15*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 33*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 4*D1**2*f*fdd*s + 9*D1**2*f*fdd - 36*D1**2*fd**2*r**2 - 66*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 8*D1**2*fd**2*s + 6*D1**2*fd**2 + 24*D1*Dd*f**2*r**2 + 28*D1*Dd*f**2*r*s - 26*D1*Dd*f**2*r - 7*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 264*D1*Dd*f*fd*r*s + 126*D1*Dd*f*fd*r + 17*D1*Dd*f*fd*s + 2*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 - 44*D1*Ddd*f**2*r*s + 34*D1*Ddd*f**2*r + 11*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(14*r**2 + 2*r*(8*s - 9) - 8*s + 7) - 2*fd*(28*r**2 + 2*r*(8*s - 11) - 4*s + 3)) - 4*Dd*f*(28*r**2 + r*(16*s - 27) - 6*s + 6)) - 72*Dd**2*f**2*r**2 - 132*Dd**2*f**2*r*s + 102*Dd**2*f**2*r + 33*Dd**2*f**2*s - 22*Dd**2*f**2) + f**2*(-66*D1**2*bd1**2*(7*r**2 + 4*r*(s - 2) - 2*s + 1) + 11*D1**2*bdd1*f*(6*r**2 + 11*r*s - 28*r - 15*s + 15) - 516*D1**2*f*fd*r**2 - 220*D1**2*f*fd*r*s + 368*D1**2*f*fd*r + 55*D1**2*f*fd*s - 129*D1**2*f*fd + 324*D1**2*f*fdd*r**2 + 220*D1**2*f*fdd*r*s - 272*D1**2*f*fdd*r - 55*D1**2*f*fdd*s + 81*D1**2*f*fdd + 972*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s - 816*D1**2*fd**2*r - 165*D1**2*fd**2*s + 110*D1**2*fd**2 - 516*D1*Dd*f**2*r**2 - 220*D1*Dd*f**2*r*s + 368*D1*Dd*f**2*r + 55*D1*Dd*f**2*s - 129*D1*Dd*f**2 + 2592*D1*Dd*f*fd*r**2 + 1760*D1*Dd*f*fd*r*s - 2176*D1*Dd*f*fd*r - 440*D1*Dd*f*fd*s + 382*D1*Dd*f*fd + 324*D1*Ddd*f**2*r**2 + 220*D1*Ddd*f**2*r*s - 272*D1*Ddd*f**2*r - 55*D1*Ddd*f**2*s + 81*D1*Ddd*f**2 - 11*D1*bd1*(D1*(f*(6*r**2 + 7*r*s - 38*r - 15*s + 21) + fd*(-36*r**2 - 66*r*s + 90*r + 41*s - 28)) + Dd*f*(-48*r**2 + r*(146 - 88*s) + 71*s - 58)) + 972*Dd**2*f**2*r**2 + 660*Dd**2*f**2*r*s - 816*Dd**2*f**2*r - 165*Dd**2*f**2*s + 110*Dd**2*f**2))/(1155*d**2*k1*k3**4) - D1**2*Pk3*Pkd1*k2**2*st**4*(12*C*D1**2*b1*f*fd*r**2 + 36*C*D1**2*b1*f*fdd*r**2 + 36*C*D1**2*b1*fd**2*r**2 - 42*C*D1**2*f**2*fd*r**2 + 28*C*D1**2*f**2*fd*r - 14*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r**2 - 20*C*D1**2*f**2*fdd*r + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r**2 - 40*C*D1**2*f*fd**2*r + 24*C*D1*Dd*b1*f**2*r**2 - 12*C*D1*Dd*b1*f**2*r + 6*C*D1*Dd*b1*f**2 + 288*C*D1*Dd*b1*f*fd*r**2 - 72*C*D1*Dd*b1*f*fd*r - 56*C*D1*Dd*f**3*r**2 + 28*C*D1*Dd*f**3*r - 14*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r**2 - 140*C*D1*Dd*f**2*fd*r + 20*C*D1*Dd*f**2*fd + 72*C*D1*Ddd*b1*f**2*r**2 - 36*C*D1*Ddd*b1*f**2*r + 18*C*D1*Ddd*b1*f**2 + 40*C*D1*Ddd*f**3*r**2 - 20*C*D1*Ddd*f**3*r + 10*C*D1*Ddd*f**3 + 216*C*Dd**2*b1*f**2*r**2 - 108*C*Dd**2*b1*f**2*r + 120*C*Dd**2*f**3*r**2 - 60*C*Dd**2*f**3*r + 18*D1**2*b1*f*fd*r**2 - 30*D1**2*b1*f*fd*r*s + 15*D1**2*b1*f*fd*r - 30*D1**2*b1*f*fdd*r**2 - 6*D1**2*b1*f*fdd*r*s + 3*D1**2*b1*f*fdd*r - 30*D1**2*b1*fd**2*r**2 - 6*D1**2*b1*fd**2*r*s + 3*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(r - 1)*(6*C*(r - 1) - 5*r - s + 5) + 33*D1**2*f**2*fd*r**2 - 3*D1**2*f**2*fd*r*s - 21*D1**2*f**2*fd*r + D1**2*f**2*fd*s + 11*D1**2*f**2*fd - 21*D1**2*f**2*fdd*r**2 - 3*D1**2*f**2*fdd*r*s + 15*D1**2*f**2*fdd*r + D1**2*f**2*fdd*s - 7*D1**2*f**2*fdd - 42*D1**2*f*fd**2*r**2 - 6*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r + 2*D1**2*f*fd**2*s - D1**2*f*fd**2 + 36*D1*Dd*b1*f**2*r**2 - 60*D1*Dd*b1*f**2*r*s + 12*D1*Dd*b1*f**2*r + 15*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 - 240*D1*Dd*b1*f*fd*r**2 - 48*D1*Dd*b1*f*fd*r*s + 84*D1*Dd*b1*f*fd*r + 6*D1*Dd*b1*f*fd*s - 3*D1*Dd*b1*f*fd + 44*D1*Dd*f**3*r**2 - 4*D1*Dd*f**3*r*s - 20*D1*Dd*f**3*r + D1*Dd*f**3*s + 11*D1*Dd*f**3 - 168*D1*Dd*f**2*fd*r**2 - 24*D1*Dd*f**2*fd*r*s + 108*D1*Dd*f**2*fd*r + 7*D1*Dd*f**2*fd*s - 17*D1*Dd*f**2*fd - 60*D1*Ddd*b1*f**2*r**2 - 12*D1*Ddd*b1*f**2*r*s + 36*D1*Ddd*b1*f**2*r + 3*D1*Ddd*b1*f**2*s - 15*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 - 4*D1*Ddd*f**3*r*s + 16*D1*Ddd*f**3*r + D1*Ddd*f**3*s - 7*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(r - 1)*(2*C*(r - 1) + 3*r - 5*s - 3) + fd*(r**2*(24*C - 20) + r*(-24*C - 4*s + 21) + 2*s - 1)) + Dd*f*(12*C*(4*r**2 - 5*r + 1) - 40*r**2 - 8*r*s + 52*r + 5*s - 12)) - 180*Dd**2*b1*f**2*r**2 - 36*Dd**2*b1*f**2*r*s + 108*Dd**2*b1*f**2*r + 9*Dd**2*b1*f**2*s - 6*Dd**2*b1*f**2 - 84*Dd**2*f**3*r**2 - 12*Dd**2*f**3*r*s + 48*Dd**2*f**3*r + 3*Dd**2*f**3*s - 2*Dd**2*f**3)/(105*d**2*k1*k3**2) + D1**2*Pk3*Pkd1*k2**2*st**2*(-28*D1**2*K*bd1**2*f*r**2 + 28*D1**2*K*bd1**2*f*r + 13*D1**2*K*bd1*f**2*r**2 - 40*D1**2*K*bd1*f*fd*r**2 + 20*D1**2*K*bd1*f*fd*r - 10*D1**2*K*bdd1*f**2*r**2 + 40*D1**2*bd1**2*f**2*r**2 + 84*D1**2*bd1**2*f**2*r*s - 81*D1**2*bd1**2*f**2*r - 42*D1**2*bd1**2*f**2*s + 21*D1**2*bd1**2*f**2 + 28*D1**2*bd1**2*f*r**2 + 14*D1**2*bd1**2*f*r*s - 35*D1**2*bd1**2*f*r - 7*D1**2*bd1**2*f*s + 7*D1**2*bd1**2*f - 28*D1**2*bd1*bd2*f*r**2 + 28*D1**2*bd1*bd2*f*r - 27*D1**2*bd1*f**3*r**2 - 18*D1**2*bd1*f**3*r*s + 9*D1**2*bd1*f**3*r + 108*D1**2*bd1*f**2*fd*r**2 + 108*D1**2*bd1*f**2*fd*r*s - 90*D1**2*bd1*f**2*fd*r - 18*D1**2*bd1*f**2*fd*s + 9*D1**2*bd1*f**2*fd - 12*D1**2*bd1*f**2*r**2 + D1**2*bd1*f**2*r*s - D1**2*bd1*f**2*r + 24*D1**2*bd1*f*fd*r**2 + 12*D1**2*bd1*f*fd*r*s - 18*D1**2*bd1*f*fd*r - 3*D1**2*bd1*f*fd*s + 3*D1**2*bd1*f*fd + 14*D1**2*bd1*f*g2*r**2 - 28*D1**2*bd1*f*g2*r + 14*D1**2*bd1*f*g2 + 56*D1**2*bd1*f*gd2*r**2 - 56*D1**2*bd1*f*gd2*r + 56*D1**2*bd1*fd*g2*r**2 - 56*D1**2*bd1*fd*g2*r + 13*D1**2*bd2*f**2*r**2 - 40*D1**2*bd2*f*fd*r**2 + 20*D1**2*bd2*f*fd*r + 18*D1**2*bdd1*f**3*r**2 + 18*D1**2*bdd1*f**3*r*s - 9*D1**2*bdd1*f**3*r + 6*D1**2*bdd1*f**2*r**2 + 3*D1**2*bdd1*f**2*r*s - 3*D1**2*bdd1*f**2*r + 28*D1**2*bdd1*f*g2*r**2 - 56*D1**2*bdd1*f*g2*r + 28*D1**2*bdd1*f*g2 - 10*D1**2*bdd2*f**2*r**2 - 26*D1**2*f**2*gd2*r**2 + 20*D1**2*f**2*gdd2*r**2 - 52*D1**2*f*fd*g2*r**2 + 52*D1**2*f*fd*g2*r - 26*D1**2*f*fd*g2 + 80*D1**2*f*fd*gd2*r**2 - 40*D1**2*f*fd*gd2*r + 40*D1**2*f*fdd*g2*r**2 - 40*D1**2*f*fdd*g2*r + 20*D1**2*f*fdd*g2 + 40*D1**2*fd**2*g2*r**2 - 40*D1**2*fd**2*g2*r - 80*D1*Dd*K*bd1*f**2*r**2 + 20*D1*Dd*K*bd1*f**2*r + 144*D1*Dd*bd1*f**3*r**2 + 144*D1*Dd*bd1*f**3*r*s - 108*D1*Dd*bd1*f**3*r - 18*D1*Dd*bd1*f**3*s + 9*D1*Dd*bd1*f**3 + 48*D1*Dd*bd1*f**2*r**2 + 24*D1*Dd*bd1*f**2*r*s - 30*D1*Dd*bd1*f**2*r - 3*D1*Dd*bd1*f**2*s + 3*D1*Dd*bd1*f**2 + 224*D1*Dd*bd1*f*g2*r**2 - 280*D1*Dd*bd1*f*g2*r + 56*D1*Dd*bd1*f*g2 - 80*D1*Dd*bd2*f**2*r**2 + 20*D1*Dd*bd2*f**2*r - 104*D1*Dd*f**2*g2*r**2 + 52*D1*Dd*f**2*g2*r - 26*D1*Dd*f**2*g2 + 160*D1*Dd*f**2*gd2*r**2 - 40*D1*Dd*f**2*gd2*r + 320*D1*Dd*f*fd*g2*r**2 - 240*D1*Dd*f*fd*g2*r + 40*D1*Dd*f*fd*g2 + 80*D1*Ddd*f**2*g2*r**2 - 40*D1*Ddd*f**2*g2*r + 20*D1*Ddd*f**2*g2 + 240*Dd**2*f**2*g2*r**2 - 120*Dd**2*f**2*g2*r - 7*b1**3*(D1**2*r**2*(fd + 2*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 4*Dd*fd*r*(4*r - 1) + 2*Ddd*f*(4*r**2 - 2*r + 1)) + 12*Dd**2*f*r*(2*r - 1)) + b1**2*(-7*D1**2*K*fd*r**2 - 14*D1**2*K*fdd*r**2 - 14*D1**2*bdd1*f*(3*r**2 - 2*r + 1) - 52*D1**2*f*fd*r**2 - 84*D1**2*f*fd*r*s + 37*D1**2*f*fd*r + 13*D1**2*f*fd + 40*D1**2*f*fdd*r**2 + 84*D1**2*f*fdd*r*s - 43*D1**2*f*fdd*r - 10*D1**2*f*fdd + 40*D1**2*fd**2*r**2 + 84*D1**2*fd**2*r*s - 43*D1**2*fd**2*r - 28*D1**2*fd*r**2 + 21*D1**2*fd*r*s + 14*D1**2*fdd*r**2 + 7*D1**2*fdd*r*s - 28*D1*Dd*K*f*r**2 + 14*D1*Dd*K*f*r - 7*D1*Dd*K*f - 112*D1*Dd*K*fd*r**2 + 28*D1*Dd*K*fd*r - 104*D1*Dd*f**2*r**2 - 168*D1*Dd*f**2*r*s + 136*D1*Dd*f**2*r + 42*D1*Dd*f**2*s - 26*D1*Dd*f**2 + 320*D1*Dd*f*fd*r**2 + 672*D1*Dd*f*fd*r*s - 420*D1*Dd*f*fd*r - 84*D1*Dd*f*fd*s + 43*D1*Dd*f*fd - 112*D1*Dd*f*r**2 + 84*D1*Dd*f*r*s + 14*D1*Dd*f*r - 21*D1*Dd*f*s - 28*D1*Dd*f + 112*D1*Dd*fd*r**2 + 56*D1*Dd*fd*r*s - 42*D1*Dd*fd*r - 7*D1*Dd*fd*s - 56*D1*Ddd*K*f*r**2 + 28*D1*Ddd*K*f*r - 14*D1*Ddd*K*f + 80*D1*Ddd*f**2*r**2 + 168*D1*Ddd*f**2*r*s - 124*D1*Ddd*f**2*r - 42*D1*Ddd*f**2*s + 20*D1*Ddd*f**2 + 56*D1*Ddd*f*r**2 + 28*D1*Ddd*f*r*s - 42*D1*Ddd*f*r - 7*D1*Ddd*f*s + 14*D1*Ddd*f - 7*D1*bd1*(D1*f*(3*r**2 - 2*r + 1) + 4*D1*fd*r*(3*r - 1) + 4*Dd*f*(12*r**2 - 7*r + 1)) - 168*Dd**2*K*f*r**2 + 84*Dd**2*K*f*r + 240*Dd**2*f**2*r**2 + 504*Dd**2*f**2*r*s - 372*Dd**2*f**2*r - 126*Dd**2*f**2*s + 84*Dd**2*f**2 + 168*Dd**2*f*r**2 + 84*Dd**2*f*r*s - 126*Dd**2*f*r - 21*Dd**2*f*s + 14*Dd**2*f) + b1*(26*D1**2*K*f*fd*r**2 - 26*D1**2*K*f*fd*r + 13*D1**2*K*f*fd - 20*D1**2*K*f*fdd*r**2 + 20*D1**2*K*f*fdd*r - 10*D1**2*K*f*fdd - 20*D1**2*K*fd**2*r**2 + 20*D1**2*K*fd**2*r - 7*D1**2*b2*fd*r**2 - 14*D1**2*b2*fdd*r**2 + 28*D1**2*bd1**2*f*r*(2 - 3*r) - 7*D1**2*bd2*f*r**2 - 28*D1**2*bd2*fd*r**2 + D1**2*bdd1*f*(-7*K*(4*r**2 - 4*r + 2) + f*(40*r**2 + r*(84*s - 81) - 42*s + 30) + 28*r**2 + 14*r*s - 35*r - 7*s + 14) - 14*D1**2*bdd2*f*r**2 - 81*D1**2*f**2*fd*r**2 - 54*D1**2*f**2*fd*r*s + 81*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s - 27*D1**2*f**2*fd + 54*D1**2*f**2*fdd*r**2 + 54*D1**2*f**2*fdd*r*s - 63*D1**2*f**2*fdd*r - 18*D1**2*f**2*fdd*s + 18*D1**2*f**2*fdd + 108*D1**2*f*fd**2*r**2 + 108*D1**2*f*fd**2*r*s - 126*D1**2*f*fd**2*r - 36*D1**2*f*fd**2*s + 27*D1**2*f*fd**2 - 24*D1**2*f*fd*r**2 + 2*D1**2*f*fd*r*s + 24*D1**2*f*fd*r - D1**2*f*fd*s - 12*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 6*D1**2*f*fdd + 14*D1**2*f*gd2*r**2 + 28*D1**2*f*gdd2*r**2 + 12*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s - 12*D1**2*fd**2*r - 3*D1**2*fd**2*s + 14*D1**2*fd*g2*r**2 + 56*D1**2*fd*gd2*r**2 + 28*D1**2*fdd*g2*r**2 + 52*D1*Dd*K*f**2*r**2 - 26*D1*Dd*K*f**2*r + 13*D1*Dd*K*f**2 - 160*D1*Dd*K*f*fd*r**2 + 120*D1*Dd*K*f*fd*r - 20*D1*Dd*K*f*fd - 28*D1*Dd*b2*f*r**2 + 14*D1*Dd*b2*f*r - 7*D1*Dd*b2*f - 112*D1*Dd*b2*fd*r**2 + 28*D1*Dd*b2*fd*r - 112*D1*Dd*bd2*f*r**2 + 28*D1*Dd*bd2*f*r - 108*D1*Dd*f**3*r**2 - 72*D1*Dd*f**3*r*s + 90*D1*Dd*f**3*r + 18*D1*Dd*f**3*s - 27*D1*Dd*f**3 + 432*D1*Dd*f**2*fd*r**2 + 432*D1*Dd*f**2*fd*r*s - 468*D1*Dd*f**2*fd*r - 126*D1*Dd*f**2*fd*s + 99*D1*Dd*f**2*fd - 48*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r*s + 22*D1*Dd*f**2*r - D1*Dd*f**2*s - 12*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 84*D1*Dd*f*fd*r - 18*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 56*D1*Dd*f*g2*r**2 - 28*D1*Dd*f*g2*r + 14*D1*Dd*f*g2 + 224*D1*Dd*f*gd2*r**2 - 56*D1*Dd*f*gd2*r + 224*D1*Dd*fd*g2*r**2 - 56*D1*Dd*fd*g2*r - 40*D1*Ddd*K*f**2*r**2 + 20*D1*Ddd*K*f**2*r - 10*D1*Ddd*K*f**2 - 56*D1*Ddd*b2*f*r**2 + 28*D1*Ddd*b2*f*r - 14*D1*Ddd*b2*f + 72*D1*Ddd*f**3*r**2 + 72*D1*Ddd*f**3*r*s - 72*D1*Ddd*f**3*r - 18*D1*Ddd*f**3*s + 18*D1*Ddd*f**3 + 24*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r - 3*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 112*D1*Ddd*f*g2*r**2 - 56*D1*Ddd*f*g2*r + 28*D1*Ddd*f*g2 + D1*bd1*(-D1*(f**2*(52*r**2 + r*(84*s - 99) - 42*s + 39) + f*(14*K*r**2 - 14*K*r + 7*K + fd*(-160*r**2 - 336*r*s + 248*r + 84*s - 63) + 56*r**2 - 42*r*s - 35*r + 21*s + 28) + 7*fd*(r**2*(8*K - 8) + r*(-4*K - 4*s + 5) + s)) + Dd*f*(-28*K*(8*r**2 - 6*r + 1) + f*(320*r**2 + r*(672*s - 572) - 252*s + 165) + 224*r**2 + 112*r*(s - 2) - 42*s + 49)) - 120*Dd**2*K*f**2*r**2 + 60*Dd**2*K*f**2*r - 168*Dd**2*b2*f*r**2 + 84*Dd**2*b2*f*r + 216*Dd**2*f**3*r**2 + 216*Dd**2*f**3*r*s - 216*Dd**2*f**3*r - 54*Dd**2*f**3*s + 36*Dd**2*f**3 + 72*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s - 54*Dd**2*f**2*r - 9*Dd**2*f**2*s + 6*Dd**2*f**2 + 336*Dd**2*f*g2*r**2 - 168*Dd**2*f*g2*r) - b2*(14*D1**2*bdd1*f*(r - 1)**2 - 26*D1**2*f*fd*r**2 + 26*D1**2*f*fd*r - 13*D1**2*f*fd + 20*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r + 10*D1**2*f*fdd + 20*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r - 52*D1*Dd*f**2*r**2 + 26*D1*Dd*f**2*r - 13*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 - 120*D1*Dd*f*fd*r + 20*D1*Dd*f*fd + 40*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r + 10*D1*Ddd*f**2 + 7*D1*bd1*(r - 1)*(D1*f*(r - 1) + 4*D1*fd*r + 4*Dd*f*(4*r - 1)) + 120*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r))/(105*d**2*k1*k3**2) + D1**2*Pk3*Pkd1*st**2*(D1*f*(-7*D1*bd1**2*(r**2*(8*C - 4) - 2*r*(4*C + s - 2) + s) + D1*bdd1*f*r*(r*(10 - 20*C) + 3*s) + bd1*(D1*(f*r*(r*(26*C - 13) + s) + fd*(r**2*(40 - 80*C) + r*(40*C + 12*s - 23) - 3*s)) + Dd*f*(r**2*(80 - 160*C) + r*(40*C + 24*s - 26) - 3*s))) - 7*b1**2*(D1**2*r*(fd*(2*C*r - r - 3*s + 3) + fdd*(4*C*r - 2*r - s + 1)) + D1*(Dd*(f*(C*(8*r**2 - 4*r + 2) - 4*r**2 - 12*r*s + 8*r + 3*s - 1) + fd*(r**2*(32*C - 16) - 2*r*(4*C + 4*s - 5) + s - 1)) + Ddd*f*(4*C*(4*r**2 - 2*r + 1) - 8*r**2 - 4*r*s + 6*r + s - 2)) + Dd**2*f*(r**2*(48*C - 24) - 6*r*(4*C + 2*s - 3) + 3*s - 2)) + b1*(52*C*D1**2*f*fd*r**2 - 52*C*D1**2*f*fd*r + 26*C*D1**2*f*fd - 40*C*D1**2*f*fdd*r**2 + 40*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd - 40*C*D1**2*fd**2*r**2 + 40*C*D1**2*fd**2*r + 104*C*D1*Dd*f**2*r**2 - 52*C*D1*Dd*f**2*r + 26*C*D1*Dd*f**2 - 320*C*D1*Dd*f*fd*r**2 + 240*C*D1*Dd*f*fd*r - 40*C*D1*Dd*f*fd - 80*C*D1*Ddd*f**2*r**2 + 40*C*D1*Ddd*f**2*r - 20*C*D1*Ddd*f**2 - 240*C*Dd**2*f**2*r**2 + 120*C*Dd**2*f**2*r - 7*D1**2*bdd1*f*(C*(8*r**2 - 8*r + 4) - 4*r**2 - 2*r*s + 4*r + s - 2) - 26*D1**2*f*fd*r**2 + 2*D1**2*f*fd*r*s + 25*D1**2*f*fd*r - D1**2*f*fd*s - 13*D1**2*f*fd + 20*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 23*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 10*D1**2*f*fdd + 20*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s - 23*D1**2*fd**2*r - 3*D1**2*fd**2*s + 3*D1**2*fd**2 - 52*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - D1*Dd*f**2*s - 13*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r - 18*D1*Dd*f*fd*s + 29*D1*Dd*f*fd + 40*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s - 26*D1*Ddd*f**2*r - 3*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 - 7*D1*bd1*(8*C*Dd*f*(8*r**2 - 6*r + 1) + D1*f*(C*(4*r**2 - 4*r + 2) - 2*r**2 - 6*r*s + 2*r + 3*s - 1) + D1*fd*(r**2*(16*C - 8) + r*(-8*C - 4*s + 6) + s - 1) - 2*Dd*f*(8*r - 3)*(2*r + s - 1)) + 120*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s - 78*Dd**2*f**2*r - 9*Dd**2*f**2*s + 6*Dd**2*f**2))/(105*d**2*k1) - D1**2*Pk3*Pkd1*(D1*r*(D1*bd1**2*(f**2*(3 - 6*s) + f*(10*K*r - 6*s + 3) - 20*g2*(r - 1)) - 10*D1*bdd1*f*g2*r + 5*b2*(2*D1*bd1**2*(r - 1) + D1*bdd1*f*r + bd1*(-D1*f*r + 2*D1*fd*(r - 1) + 2*Dd*f*(4*r - 1))) - 10*bd1*(-D1*f*r*(bd2 + g2 - 2*gd2) + 2*D1*fd*g2*(r - 1) + 2*Dd*f*g2*(4*r - 1))) - 5*b1**3*(-D1*Dd*(K*(4*r**2 - 2*r + 1) + fd*(r*(6 - 8*s) + s - 1) + (f - 1)*(4*r*s - 2*r - s)) - D1*(D1*r*(fd - fdd)*(s - 1) + Ddd*K*(4*r**2 - 2*r + 1) - Ddd*(f + 1)*(r*(4*s - 2) - s)) + Dd**2*(-12*K*r**2 + f*(6*r*(2*s - 1) - 3*s + 2) + 6*r*(K + 2*s - 1) - 3*s + 2)) + b1**2*(15*D1**2*K*bdd1*r**2 - 10*D1**2*K*bdd1*r + 5*D1**2*K*bdd1 - 5*D1**2*K*fd*r**2 + 10*D1**2*K*fd*r - 5*D1**2*K*fd + 5*D1**2*K*fdd*r**2 - 10*D1**2*K*fdd*r + 5*D1**2*K*fdd + 5*D1**2*bd2*r**2 - 15*D1**2*bdd1*f*r*s + 5*D1**2*bdd1*f*r + 5*D1**2*bdd1*f*s - 15*D1**2*bdd1*r*s + 5*D1**2*bdd1*r + 5*D1**2*bdd1*s + 5*D1**2*bdd2*r**2 + 6*D1**2*f*fd*r*s - 3*D1**2*f*fd*r - 3*D1**2*f*fd*s - 6*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + 3*D1**2*f*fdd*s - 6*D1**2*fd**2*r*s + 3*D1**2*fd**2*r + 3*D1**2*fd**2*s - 3*D1**2*fd**2 + D1**2*fd*r*s - D1**2*fd*s - 3*D1**2*fdd*r*s + 3*D1**2*fdd*s - 10*D1**2*gd2*r**2 - 10*D1**2*gdd2*r**2 - 20*D1*Dd*K*f*r**2 + 10*D1*Dd*K*f*r - 5*D1*Dd*K*f + 40*D1*Dd*K*fd*r**2 - 50*D1*Dd*K*fd*r + 10*D1*Dd*K*fd + 40*D1*Dd*bd2*r**2 - 10*D1*Dd*bd2*r + 12*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r - 3*D1*Dd*f**2*s - 48*D1*Dd*f*fd*r*s + 24*D1*Dd*f*fd*r + 18*D1*Dd*f*fd*s - 9*D1*Dd*f*fd + 4*D1*Dd*f*r*s - 2*D1*Dd*f*r - D1*Dd*f*s - 24*D1*Dd*fd*r*s + 6*D1*Dd*fd*r + 15*D1*Dd*fd*s - 6*D1*Dd*fd - 40*D1*Dd*g2*r**2 + 20*D1*Dd*g2*r - 10*D1*Dd*g2 - 80*D1*Dd*gd2*r**2 + 20*D1*Dd*gd2*r + 20*D1*Ddd*K*f*r**2 - 10*D1*Ddd*K*f*r + 5*D1*Ddd*K*f - 12*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2*s - 12*D1*Ddd*f*r*s + 6*D1*Ddd*f*r + 3*D1*Ddd*f*s - 40*D1*Ddd*g2*r**2 + 20*D1*Ddd*g2*r - 10*D1*Ddd*g2 + 5*D1*bd1*(D1*(K*(3*r**2 - 2*r + 1) + fd*(r*(4 - 6*s) + s - 1) + (f - 1)*(3*r*s - r - s)) + Dd*(2*K*(12*r**2 - 7*r + 1) + f*(r*(10 - 24*s) + 7*s - 3) - 24*r*s + 10*r + 7*s - 3)) + 60*Dd**2*K*f*r**2 - 30*Dd**2*K*f*r - 36*Dd**2*f**2*r*s + 18*Dd**2*f**2*r + 9*Dd**2*f**2*s - 6*Dd**2*f**2 - 36*Dd**2*f*r*s + 18*Dd**2*f*r + 9*Dd**2*f*s - 6*Dd**2*f - 120*Dd**2*g2*r**2 + 60*Dd**2*g2*r + 5*b2*(D1*(Dd + Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(2*r - 1))) + b1*(10*D1**2*K*bdd1*f*r**2 - 5*D1**2*bd1**2*(-6*K*r**2 + f*r*(6*s - 2) - 2*f*s + f + r*(4*K + 6*s - 2) - 2*s + 1) - 5*D1**2*bd2*f*r**2 + 10*D1**2*bd2*fd*r**2 - 10*D1**2*bd2*fd*r - 6*D1**2*bdd1*f**2*r*s + 3*D1**2*bdd1*f**2*r - 6*D1**2*bdd1*f*r*s + 3*D1**2*bdd1*f*r - 20*D1**2*bdd1*g2*r**2 + 20*D1**2*bdd1*g2*r - 10*D1**2*bdd1*g2 + 5*D1**2*bdd2*f*r**2 + 10*D1**2*f*gd2*r**2 - 10*D1**2*f*gdd2*r**2 + 10*D1**2*fd*g2*r**2 - 20*D1**2*fd*g2*r + 10*D1**2*fd*g2 - 20*D1**2*fd*gd2*r**2 + 20*D1**2*fd*gd2*r - 10*D1**2*fdd*g2*r**2 + 20*D1**2*fdd*g2*r - 10*D1**2*fdd*g2 + 40*D1*Dd*bd2*f*r**2 - 10*D1*Dd*bd2*f*r + 40*D1*Dd*f*g2*r**2 - 20*D1*Dd*f*g2*r + 10*D1*Dd*f*g2 - 80*D1*Dd*f*gd2*r**2 + 20*D1*Dd*f*gd2*r - 80*D1*Dd*fd*g2*r**2 + 100*D1*Dd*fd*g2*r - 20*D1*Dd*fd*g2 - 40*D1*Ddd*f*g2*r**2 + 20*D1*Ddd*f*g2*r - 10*D1*Ddd*f*g2 + D1*bd1*(-D1*(fd*(-20*K*r**2 + 3*f*(4*r - 1)*(2*s - 1) + r*(20*K + 12*s - 3) - 6*s + 3) + 10*g2*(2*r**2 - 2*r + 1) + r*(bd2*(10 - 20*r) + f**2*(3 - 6*s) + f*(10*K*r - 2*s + 1) + 20*gd2*(2*r - 1))) + Dd*(-3*f**2*(8*r - 1)*(2*s - 1) + f*(80*K*r**2 - 4*r*(5*K + 12*s - 6) + 6*s - 3) - 20*g2*(8*r**2 - 6*r + 1))) - 120*Dd**2*f*g2*r**2 + 60*Dd**2*f*g2*r + 5*b2*(D1**2*bdd1*(2*r**2 - 2*r + 1) - D1**2*fd*r**2 + 2*D1**2*fd*r - D1**2*fd + D1**2*fdd*r**2 - 2*D1**2*fdd*r + D1**2*fdd - 4*D1*Dd*f*r**2 + 2*D1*Dd*f*r - D1*Dd*f + 8*D1*Dd*fd*r**2 - 10*D1*Dd*fd*r + 2*D1*Dd*fd + 4*D1*Ddd*f*r**2 - 2*D1*Ddd*f*r + D1*Ddd*f + D1*bd1*(D1*(2*r**2 - 2*r + 1) + 2*Dd*(8*r**2 - 6*r + 1)) + 12*Dd**2*f*r**2 - 6*Dd**2*f*r)))/(15*d**2*k1) - D1**2*Pk3*Pkdd1*ct**6*k2**4*(C - 1)*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(315*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**5*f*k2**5*(-165*D1**2*b1*f*fd*r**2 + 231*D1**2*b1*f*fdd*r**2 + 462*D1**2*b1*fd**2*r**2 + 77*D1**2*bdd1*f**2*(r - 1)**2 - 196*D1**2*f**2*fd*r**2 + 98*D1**2*f**2*fd*r - 49*D1**2*f**2*fd + 252*D1**2*f**2*fdd*r**2 - 126*D1**2*f**2*fdd*r + 63*D1**2*f**2*fdd + 756*D1**2*f*fd**2*r**2 - 378*D1**2*f*fd**2*r - 220*D1*Dd*b1*f**2*r**2 + 110*D1*Dd*b1*f**2*r - 55*D1*Dd*b1*f**2 + 1848*D1*Dd*b1*f*fd*r**2 - 462*D1*Dd*b1*f*fd*r - 196*D1*Dd*f**3*r**2 + 98*D1*Dd*f**3*r - 49*D1*Dd*f**3 + 2016*D1*Dd*f**2*fd*r**2 - 1008*D1*Dd*f**2*fd*r + 126*D1*Dd*f**2*fd + 308*D1*Ddd*b1*f**2*r**2 - 154*D1*Ddd*b1*f**2*r + 77*D1*Ddd*b1*f**2 + 252*D1*Ddd*f**3*r**2 - 126*D1*Ddd*f**3*r + 63*D1*Ddd*f**3 - 11*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) - 42*D1*fd*r + 14*Dd*f*(1 - 4*r)) + 924*Dd**2*b1*f**2*r**2 - 462*Dd**2*b1*f**2*r + 756*Dd**2*f**3*r**2 - 378*Dd**2*f**3*r)/(1386*d**2*k1*k3**4) - D1**2*Pk3*Pkdd1*ct**5*k1*k2**3*(8*C - 7)*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(630*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**5*k2**3*(-54*D1**2*b1*f*fd*r**2 + 90*D1**2*b1*f*fdd*r**2 + 90*D1**2*b1*fd**2*r**2 + 45*D1**2*bdd1*f**2*(r - 1)**2 - 75*D1**2*f**2*fd*r**2 + 50*D1**2*f**2*fd*r - 25*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 - 70*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 - 140*D1**2*f*fd**2*r - 108*D1*Dd*b1*f**2*r**2 + 54*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2 + 720*D1*Dd*b1*f*fd*r**2 - 180*D1*Dd*b1*f*fd*r - 100*D1*Dd*f**3*r**2 + 50*D1*Dd*f**3*r - 25*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 - 490*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd + 180*D1*Ddd*b1*f**2*r**2 - 90*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2 + 140*D1*Ddd*f**3*r**2 - 70*D1*Ddd*f**3*r + 35*D1*Ddd*f**3 - 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) + 540*Dd**2*b1*f**2*r**2 - 270*Dd**2*b1*f**2*r + 420*Dd**2*f**3*r**2 - 210*Dd**2*f**3*r)/(630*d**2*k1*k3**2) - D1**2*Pk3*Pkdd1*ct**4*k1**2*k2**2*(4*C - 3)*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(210*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**4*k2**4*st**2*(2*C - 2)*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(105*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**4*k2**4*(495*D1**2*K*bdd1*f**2*r**2 - 198*D1**2*bd1**2*f*r*(r - 1)*(-7*K + 5*f + 7) + 770*D1**2*bdd1*f**3*r**2 - 2310*D1**2*bdd1*f**3*r + 1155*D1**2*bdd1*f**3 - 495*D1**2*bdd1*f**2*r**2 - 1386*D1**2*bdd1*f*g2*r**2 + 2772*D1**2*bdd1*f*g2*r - 1386*D1**2*bdd1*f*g2 - 2940*D1**2*f**3*fd*r**2 + 1470*D1**2*f**3*fd*r - 735*D1**2*f**3*fd + 3780*D1**2*f**3*fdd*r**2 - 1890*D1**2*f**3*fdd*r + 945*D1**2*f**3*fdd + 11340*D1**2*f**2*fd**2*r**2 - 5670*D1**2*f**2*fd**2*r + 594*D1**2*f**2*gd2*r**2 - 990*D1**2*f**2*gdd2*r**2 + 1188*D1**2*f*fd*g2*r**2 - 1188*D1**2*f*fd*g2*r + 594*D1**2*f*fd*g2 - 3960*D1**2*f*fd*gd2*r**2 + 1980*D1**2*f*fd*gd2*r - 1980*D1**2*f*fdd*g2*r**2 + 1980*D1**2*f*fdd*g2*r - 990*D1**2*f*fdd*g2 - 1980*D1**2*fd**2*g2*r**2 + 1980*D1**2*fd**2*g2*r - 2940*D1*Dd*f**4*r**2 + 1470*D1*Dd*f**4*r - 735*D1*Dd*f**4 + 30240*D1*Dd*f**3*fd*r**2 - 15120*D1*Dd*f**3*fd*r + 1890*D1*Dd*f**3*fd + 2376*D1*Dd*f**2*g2*r**2 - 1188*D1*Dd*f**2*g2*r + 594*D1*Dd*f**2*g2 - 7920*D1*Dd*f**2*gd2*r**2 + 1980*D1*Dd*f**2*gd2*r - 15840*D1*Dd*f*fd*g2*r**2 + 11880*D1*Dd*f*fd*g2*r - 1980*D1*Dd*f*fd*g2 + 3780*D1*Ddd*f**4*r**2 - 1890*D1*Ddd*f**4*r + 945*D1*Ddd*f**4 - 3960*D1*Ddd*f**2*g2*r**2 + 1980*D1*Ddd*f**2*g2*r - 990*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(25*f**3*(2*r**2 - 6*r + 3) + f**2*r*(-140*fd*(3*r - 4) + r*(27*K - 27)) - 6*f*(15*fd*r*(K - 1)*(2*r - 1) + 7*g2*(r - 1)**2 - 42*gd2*r*(r - 1)) + 252*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(35*f**2*(2*r - 3) + 45*f*r*(K - 1) - 126*g2*(r - 1))) + 11340*Dd**2*f**4*r**2 - 5670*Dd**2*f**4*r - 11880*Dd**2*f**2*g2*r**2 + 5940*Dd**2*f**2*g2*r + 33*b1**2*(D1**2*r**2*(-30*fd**2 + fd*(-7*K + 18*f + 7) - 3*fdd*(-7*K + 10*f + 7)) + D1*(Dd*(9*f**2*(4*r**2 - 2*r + 1) + f*(-7*K*(4*r**2 - 2*r + 1) - r**2*(240*fd - 28) + r*(60*fd - 14) + 7) + 42*fd*r*(K - 1)*(4*r - 1)) - 3*Ddd*f*(-7*K + 5*f + 7)*(4*r**2 - 2*r + 1)) - 18*Dd**2*f*r*(2*r - 1)*(-7*K + 5*f + 7)) + 11*b1*(-54*D1**2*K*f*fd*r**2 + 54*D1**2*K*f*fd*r - 27*D1**2*K*f*fd + 90*D1**2*K*f*fdd*r**2 - 90*D1**2*K*f*fdd*r + 45*D1**2*K*f*fdd + 90*D1**2*K*fd**2*r**2 - 90*D1**2*K*fd**2*r - 9*D1**2*bdd1*f*(-7*K + 5*f + 7)*(2*r**2 - 2*r + 1) - 150*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 54*D1**2*f*fd*r**2 - 54*D1**2*f*fd*r + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 + 90*D1**2*f*fdd*r - 45*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 - 126*D1**2*f*gdd2*r**2 - 90*D1**2*fd**2*r**2 + 90*D1**2*fd**2*r + 42*D1**2*fd*g2*r**2 - 252*D1**2*fd*gd2*r**2 - 126*D1**2*fdd*g2*r**2 - 108*D1*Dd*K*f**2*r**2 + 54*D1*Dd*K*f**2*r - 27*D1*Dd*K*f**2 + 720*D1*Dd*K*f*fd*r**2 - 540*D1*Dd*K*f*fd*r + 90*D1*Dd*K*f*fd - 200*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r - 50*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r**2 - 140*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 - 54*D1*Dd*f**2*r + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 + 540*D1*Dd*f*fd*r - 90*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 - 84*D1*Dd*f*g2*r + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 + 252*D1*Dd*f*gd2*r - 1008*D1*Dd*fd*g2*r**2 + 252*D1*Dd*fd*g2*r + 180*D1*Ddd*K*f**2*r**2 - 90*D1*Ddd*K*f**2*r + 45*D1*Ddd*K*f**2 + 280*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r + 70*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 + 90*D1*Ddd*f**2*r - 45*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 + 252*D1*Ddd*f*g2*r - 126*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(9*f**2*(2*r**2 - 2*r + 1) + f*(-7*K*(2*r**2 - 2*r + 1) - r**2*(120*fd - 14) + r*(60*fd - 14) + 7) + 42*fd*r*(K - 1)*(2*r - 1)) - 6*Dd*f*(-7*K + 5*f + 7)*(8*r**2 - 6*r + 1)) + 540*Dd**2*K*f**2*r**2 - 270*Dd**2*K*f**2*r + 840*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r - 540*Dd**2*f**2*r**2 + 270*Dd**2*f**2*r - 1512*Dd**2*f*g2*r**2 + 756*Dd**2*f*g2*r))/(6930*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**4*k2**2*(-42*D1*b1*bd1*(C - 1)*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) - 42*b1**2*(C - 1)*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + 9*b1*(14*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) + 2*D1**2*(-f*(3*fd - 5*fdd)*(-2*C*r + C + r**2 + 2*r - 1) + 5*fd**2*r*(-2*C + r + 2)) + D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) - 20*Dd*fd*(4*r - 1)*(C - r - 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) + 30*Dd**2*f**2*r*(2*r - 1)) + f*(252*D1**2*bd1**2*r*(C - 1)*(r - 1) + 45*D1**2*bdd1*f*(C*(4*r - 2) + r**2 - 6*r + 3) - 9*D1*bd1*(3*D1*f*(C*(4*r - 2) + r**2 - 6*r + 3) - 20*D1*fd*r*(C + r - 2) - 10*Dd*f*(4*r - 1)*(2*C + r - 3)) + 5*(2*C - 3)*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 - 2*r + 1) + 14*fd**2*r*(2 - 3*r)) + D1*f*(5*Dd*f*(4*r**2 - 2*r + 1) - 14*Dd*fd*(12*r**2 - 7*r + 1) - 7*Ddd*f*(4*r**2 - 2*r + 1)) + 42*Dd**2*f**2*r*(1 - 2*r))))/(630*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct**3*f*k2**5*st**2*(-33*D1**2*b1*f*fd*r**2 + 165*D1**2*b1*f*fdd*r**2 + 330*D1**2*b1*fd**2*r**2 + 55*D1**2*bdd1*f**2*(r - 1)**2 - 60*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r - 15*D1**2*f**2*fd + 140*D1**2*f**2*fdd*r**2 - 70*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r - 44*D1*Dd*b1*f**2*r**2 + 22*D1*Dd*b1*f**2*r - 11*D1*Dd*b1*f**2 + 1320*D1*Dd*b1*f*fd*r**2 - 330*D1*Dd*b1*f*fd*r - 60*D1*Dd*f**3*r**2 + 30*D1*Dd*f**3*r - 15*D1*Dd*f**3 + 1120*D1*Dd*f**2*fd*r**2 - 560*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd + 220*D1*Ddd*b1*f**2*r**2 - 110*D1*Ddd*b1*f**2*r + 55*D1*Ddd*b1*f**2 + 140*D1*Ddd*f**3*r**2 - 70*D1*Ddd*f**3*r + 35*D1*Ddd*f**3 - 11*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 30*D1*fd*r + 10*Dd*f*(1 - 4*r)) + 660*Dd**2*b1*f**2*r**2 - 330*Dd**2*b1*f**2*r + 420*Dd**2*f**3*r**2 - 210*Dd**2*f**3*r)/(693*d**2*k1*k3**4) - D1**2*Pk3*Pkdd1*ct**3*k1**3*k2*(8*C - 5)*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(630*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**3*k1*k2**3*st**2*(6*C - 5)*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(105*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**3*k1*k2**3*(660*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*bd1**2*f*r*(r - 1)*(-28*K + 15*f + 21) - 770*D1**2*bdd1*f**3*r + 385*D1**2*bdd1*f**3 - 495*D1**2*bdd1*f**2*r**2 - 1848*D1**2*bdd1*f*g2*r**2 + 3696*D1**2*bdd1*f*g2*r - 1848*D1**2*bdd1*f*g2 - 980*D1**2*f**3*fd*r**2 + 490*D1**2*f**3*fd*r - 245*D1**2*f**3*fd + 1260*D1**2*f**3*fdd*r**2 - 630*D1**2*f**3*fdd*r + 315*D1**2*f**3*fdd + 3780*D1**2*f**2*fd**2*r**2 - 1890*D1**2*f**2*fd**2*r + 792*D1**2*f**2*gd2*r**2 - 1320*D1**2*f**2*gdd2*r**2 + 1584*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r + 792*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r**2 + 2640*D1**2*f*fd*gd2*r - 2640*D1**2*f*fdd*g2*r**2 + 2640*D1**2*f*fdd*g2*r - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r**2 + 2640*D1**2*fd**2*g2*r - 980*D1*Dd*f**4*r**2 + 490*D1*Dd*f**4*r - 245*D1*Dd*f**4 + 10080*D1*Dd*f**3*fd*r**2 - 5040*D1*Dd*f**3*fd*r + 630*D1*Dd*f**3*fd + 3168*D1*Dd*f**2*g2*r**2 - 1584*D1*Dd*f**2*g2*r + 792*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r**2 + 2640*D1*Dd*f**2*gd2*r - 21120*D1*Dd*f*fd*g2*r**2 + 15840*D1*Dd*f*fd*g2*r - 2640*D1*Dd*f*fd*g2 + 1260*D1*Ddd*f**4*r**2 - 630*D1*Ddd*f**4*r + 315*D1*Ddd*f**4 - 5280*D1*Ddd*f**2*g2*r**2 + 2640*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(25*f**3*(2*r - 1) + f**2*r*(-140*fd + r*(27 - 36*K)) + 56*f*g2*(r - 1)**2 + 6*f*r*(5*fd*(4*K - 3)*(2*r - 1) - 56*gd2*(r - 1)) - 336*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(35*f**2 + 15*f*r*(3 - 4*K) + 168*g2*(r - 1))) + 3780*Dd**2*f**4*r**2 - 1890*Dd**2*f**4*r - 15840*Dd**2*f**2*g2*r**2 + 7920*Dd**2*f**2*g2*r + 11*b1**2*(D1**2*r**2*(-90*fd**2 + fd*(-28*K + 54*f + 21) - 3*fdd*(-28*K + 30*f + 21)) + D1*(Dd*(27*f**2*(4*r**2 - 2*r + 1) + f*(-28*K*(4*r**2 - 2*r + 1) + r**2*(84 - 720*fd) + r*(180*fd - 42) + 21) + 42*fd*r*(4*K - 3)*(4*r - 1)) - 3*Ddd*f*(-28*K + 15*f + 21)*(4*r**2 - 2*r + 1)) - 18*Dd**2*f*r*(2*r - 1)*(-28*K + 15*f + 21)) + 11*b1*(-72*D1**2*K*f*fd*r**2 + 72*D1**2*K*f*fd*r - 36*D1**2*K*f*fd + 120*D1**2*K*f*fdd*r**2 - 120*D1**2*K*f*fdd*r + 60*D1**2*K*f*fdd + 120*D1**2*K*fd**2*r**2 - 120*D1**2*K*fd**2*r - 3*D1**2*bdd1*f*(-28*K + 15*f + 21)*(2*r**2 - 2*r + 1) - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd + 140*D1**2*f*fd**2*r + 54*D1**2*f*fd*r**2 - 54*D1**2*f*fd*r + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 + 90*D1**2*f*fdd*r - 45*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 - 168*D1**2*f*gdd2*r**2 - 90*D1**2*fd**2*r**2 + 90*D1**2*fd**2*r + 56*D1**2*fd*g2*r**2 - 336*D1**2*fd*gd2*r**2 - 168*D1**2*fdd*g2*r**2 - 144*D1*Dd*K*f**2*r**2 + 72*D1*Dd*K*f**2*r - 36*D1*Dd*K*f**2 + 960*D1*Dd*K*f*fd*r**2 - 720*D1*Dd*K*f*fd*r + 120*D1*Dd*K*f*fd + 280*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 - 54*D1*Dd*f**2*r + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 + 540*D1*Dd*f*fd*r - 90*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 - 112*D1*Dd*f*g2*r + 56*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r**2 + 336*D1*Dd*f*gd2*r - 1344*D1*Dd*fd*g2*r**2 + 336*D1*Dd*fd*g2*r + 240*D1*Ddd*K*f**2*r**2 - 120*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2 - 180*D1*Ddd*f**2*r**2 + 90*D1*Ddd*f**2*r - 45*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2 + D1*bd1*(D1*(27*f**2*(2*r**2 - 2*r + 1) + f*(-28*K*(2*r**2 - 2*r + 1) - r**2*(360*fd - 42) + r*(180*fd - 42) + 21) + 42*fd*r*(4*K - 3)*(2*r - 1)) - 6*Dd*f*(-28*K + 15*f + 21)*(8*r**2 - 6*r + 1)) + 720*Dd**2*K*f**2*r**2 - 360*Dd**2*K*f**2*r - 540*Dd**2*f**2*r**2 + 270*Dd**2*f**2*r - 2016*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r))/(2310*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct**3*k1*k2*(4*C - 3)*(3*D1*b1*(-21*D1*bdd1*f*(2*r**2 - 2*r + 1) - 3*D1*f*(3*fd - 5*fdd)*(2*r - 1) + 30*D1*fd**2*r - 30*Dd*f*fd*(1 - 4*r) + 7*bd1*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1))) + 21*b1**2*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + f*(-126*D1**2*bd1**2*r*(r - 1) - 45*D1**2*bdd1*f*(2*r - 1) - 5*D1**2*(f*(5*fd - 7*fdd)*(3*r**2 - 2*r + 1) + 14*fd**2*r*(2 - 3*r)) + 9*D1*bd1*(D1*f*(6*r - 3) - 10*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 5*D1*f*(5*Dd*f*(4*r**2 - 2*r + 1) - 14*Dd*fd*(12*r**2 - 7*r + 1) - 7*Ddd*f*(4*r**2 - 2*r + 1)) - 210*Dd**2*f**2*r*(1 - 2*r)))/(630*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct**3*k2**3*st**2*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(105*d**2*k1*k3**2) + D1**2*Pk3*Pkdd1*ct**3*k2**3*(D1*f*r*(18*D1*bd1**2*(10*f + 7)*(r - 1) + 5*D1*bdd1*f*r*(14*f + 9) + bd1*(-D1*f*r*(50*f + 27) + 10*D1*fd*(14*f*(3*r - 1) + 18*r - 9) + 10*Dd*f*(14*f + 9)*(4*r - 1))) - 3*b1**2*(D1**2*r**2*(-60*fd**2 + fd*(36*f + 7) - fdd*(60*f + 21)) + D1*(Dd*(18*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(28 - 480*fd) + r*(120*fd - 14) + 7) + 42*fd*r*(1 - 4*r)) - 3*Ddd*f*(10*f + 7)*(4*r**2 - 2*r + 1)) - 18*Dd**2*f*r*(10*f + 7)*(2*r - 1)) + b1*(9*D1**2*bdd1*f*(10*f + 7)*(2*r**2 - 2*r + 1) - 150*D1**2*f**2*fd*r**2 + 100*D1**2*f**2*fd*r - 50*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r**2 - 140*D1**2*f**2*fdd*r + 70*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r**2 - 280*D1**2*f*fd**2*r - 54*D1**2*f*fd*r**2 + 54*D1**2*f*fd*r - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 - 90*D1**2*f*fdd*r + 45*D1**2*f*fdd + 90*D1**2*fd**2*r**2 - 90*D1**2*fd**2*r - 200*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r - 50*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r**2 - 980*D1*Dd*f**2*fd*r + 140*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 + 54*D1*Dd*f**2*r - 27*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 - 540*D1*Dd*f*fd*r + 90*D1*Dd*f*fd + 280*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r + 70*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 - 90*D1*Ddd*f**2*r + 45*D1*Ddd*f**2 - 3*D1*bd1*(D1*(18*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(14 - 240*fd) + r*(120*fd - 14) + 7) + 42*fd*r*(1 - 2*r)) - 6*Dd*f*(10*f + 7)*(8*r**2 - 6*r + 1)) + 840*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r + 540*Dd**2*f**2*r**2 - 270*Dd**2*f**2*r))/(630*d**2*k1*k3**2) + D1**2*Pk3*Pkdd1*ct**3*k2*(3*D1*f*r*(14*D1*bd1**2*(r - 1) + D1*bd1*(-3*f*r + 10*fd*(2*r - 1)) + 5*D1*bdd1*f*r + 10*Dd*bd1*f*(4*r - 1)) - 7*b1**2*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + b1*(21*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) + 10*fd**2*r*(r - 1)) - 7*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) + 3*D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(8*r**2 - 6*r + 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) + 90*Dd**2*f**2*r*(2*r - 1)))/(210*d**2*k1) - D1**2*Pk3*Pkdd1*ct**2*k1**4*(2*C - 1)*(54*D1**2*b1*f*fd*r**2 - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*fd**2*r**2 - 45*D1**2*bdd1*f**2*(r - 1)**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 108*D1*Dd*b1*f**2*r**2 - 54*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 + 180*D1*Dd*b1*f*fd*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 + 90*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(r - 1)*(3*D1*f*(r - 1) - 20*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 540*Dd**2*b1*f**2*r**2 + 270*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(630*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**2*k1**2*k2**2*st**2*(19*C - 13)*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(315*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**2*k1**2*k2**2*(2970*D1**2*K*bdd1*f**2*r**2 - 594*D1**2*bd1**2*f*r*(r - 1)*(-14*K + 5*f + 7) - 770*D1**2*bdd1*f**3*r**2 - 770*D1**2*bdd1*f**3*r + 385*D1**2*bdd1*f**3 - 1485*D1**2*bdd1*f**2*r**2 - 8316*D1**2*bdd1*f*g2*r**2 + 16632*D1**2*bdd1*f*g2*r - 8316*D1**2*bdd1*f*g2 - 980*D1**2*f**3*fd*r**2 + 490*D1**2*f**3*fd*r - 245*D1**2*f**3*fd + 1260*D1**2*f**3*fdd*r**2 - 630*D1**2*f**3*fdd*r + 315*D1**2*f**3*fdd + 3780*D1**2*f**2*fd**2*r**2 - 1890*D1**2*f**2*fd**2*r + 3564*D1**2*f**2*gd2*r**2 - 5940*D1**2*f**2*gdd2*r**2 + 7128*D1**2*f*fd*g2*r**2 - 7128*D1**2*f*fd*g2*r + 3564*D1**2*f*fd*g2 - 23760*D1**2*f*fd*gd2*r**2 + 11880*D1**2*f*fd*gd2*r - 11880*D1**2*f*fdd*g2*r**2 + 11880*D1**2*f*fdd*g2*r - 5940*D1**2*f*fdd*g2 - 11880*D1**2*fd**2*g2*r**2 + 11880*D1**2*fd**2*g2*r - 980*D1*Dd*f**4*r**2 + 490*D1*Dd*f**4*r - 245*D1*Dd*f**4 + 10080*D1*Dd*f**3*fd*r**2 - 5040*D1*Dd*f**3*fd*r + 630*D1*Dd*f**3*fd + 14256*D1*Dd*f**2*g2*r**2 - 7128*D1*Dd*f**2*g2*r + 3564*D1*Dd*f**2*g2 - 47520*D1*Dd*f**2*gd2*r**2 + 11880*D1*Dd*f**2*gd2*r - 95040*D1*Dd*f*fd*g2*r**2 + 71280*D1*Dd*f*fd*g2*r - 11880*D1*Dd*f*fd*g2 + 1260*D1*Ddd*f**4*r**2 - 630*D1*Ddd*f**4*r + 315*D1*Ddd*f**4 - 23760*D1*Ddd*f**2*g2*r**2 + 11880*D1*Ddd*f**2*g2*r - 5940*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(25*f**3*(2*r**2 + 2*r - 1) - 3*f**2*r**2*(54*K + 140*fd - 27) + 18*f*(15*fd*r*(2*K - 1)*(2*r - 1) + 14*g2*(r - 1)**2 - 84*gd2*r*(r - 1)) - 1512*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(35*f**2*(2*r + 1) - 135*f*r*(2*K - 1) + 756*g2*(r - 1))) + 3780*Dd**2*f**4*r**2 - 1890*Dd**2*f**4*r - 71280*Dd**2*f**2*g2*r**2 + 35640*Dd**2*f**2*g2*r + 99*b1**2*(D1**2*r**2*(-30*fd**2 + fd*(-14*K + 18*f + 7) - 3*fdd*(-14*K + 10*f + 7)) + D1*(Dd*(9*f**2*(4*r**2 - 2*r + 1) + f*(-14*K*(4*r**2 - 2*r + 1) - r**2*(240*fd - 28) + r*(60*fd - 14) + 7) + 42*fd*r*(2*K - 1)*(4*r - 1)) - 3*Ddd*f*(-14*K + 5*f + 7)*(4*r**2 - 2*r + 1)) - 18*Dd**2*f*r*(2*r - 1)*(-14*K + 5*f + 7)) + 11*b1*(-324*D1**2*K*f*fd*r**2 + 324*D1**2*K*f*fd*r - 162*D1**2*K*f*fd + 540*D1**2*K*f*fdd*r**2 - 540*D1**2*K*f*fdd*r + 270*D1**2*K*f*fdd + 540*D1**2*K*fd**2*r**2 - 540*D1**2*K*fd**2*r - 27*D1**2*bdd1*f*(-14*K + 5*f + 7)*(2*r**2 - 2*r + 1) + 150*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r + 75*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 + 210*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 + 420*D1**2*f*fd**2*r + 162*D1**2*f*fd*r**2 - 162*D1**2*f*fd*r + 81*D1**2*f*fd - 270*D1**2*f*fdd*r**2 + 270*D1**2*f*fdd*r - 135*D1**2*f*fdd + 252*D1**2*f*gd2*r**2 - 756*D1**2*f*gdd2*r**2 - 270*D1**2*fd**2*r**2 + 270*D1**2*fd**2*r + 252*D1**2*fd*g2*r**2 - 1512*D1**2*fd*gd2*r**2 - 756*D1**2*fdd*g2*r**2 - 648*D1*Dd*K*f**2*r**2 + 324*D1*Dd*K*f**2*r - 162*D1*Dd*K*f**2 + 4320*D1*Dd*K*f*fd*r**2 - 3240*D1*Dd*K*f*fd*r + 540*D1*Dd*K*f*fd + 200*D1*Dd*f**3*r**2 - 100*D1*Dd*f**3*r + 50*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 + 1260*D1*Dd*f**2*fd*r - 210*D1*Dd*f**2*fd + 324*D1*Dd*f**2*r**2 - 162*D1*Dd*f**2*r + 81*D1*Dd*f**2 - 2160*D1*Dd*f*fd*r**2 + 1620*D1*Dd*f*fd*r - 270*D1*Dd*f*fd + 1008*D1*Dd*f*g2*r**2 - 504*D1*Dd*f*g2*r + 252*D1*Dd*f*g2 - 6048*D1*Dd*f*gd2*r**2 + 1512*D1*Dd*f*gd2*r - 6048*D1*Dd*fd*g2*r**2 + 1512*D1*Dd*fd*g2*r + 1080*D1*Ddd*K*f**2*r**2 - 540*D1*Ddd*K*f**2*r + 270*D1*Ddd*K*f**2 - 280*D1*Ddd*f**3*r**2 + 140*D1*Ddd*f**3*r - 70*D1*Ddd*f**3 - 540*D1*Ddd*f**2*r**2 + 270*D1*Ddd*f**2*r - 135*D1*Ddd*f**2 - 3024*D1*Ddd*f*g2*r**2 + 1512*D1*Ddd*f*g2*r - 756*D1*Ddd*f*g2 + 9*D1*bd1*(D1*(9*f**2*(2*r**2 - 2*r + 1) + f*(-14*K*(2*r**2 - 2*r + 1) - r**2*(120*fd - 14) + r*(60*fd - 14) + 7) + 42*fd*r*(2*K - 1)*(2*r - 1)) - 6*Dd*f*(-14*K + 5*f + 7)*(8*r**2 - 6*r + 1)) + 3240*Dd**2*K*f**2*r**2 - 1620*Dd**2*K*f**2*r - 840*Dd**2*f**3*r**2 + 420*Dd**2*f**3*r - 1620*Dd**2*f**2*r**2 + 810*Dd**2*f**2*r - 9072*Dd**2*f*g2*r**2 + 4536*Dd**2*f*g2*r))/(6930*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct**2*k1**2*(2*C - 1)*(3*D1*b1*(-21*D1*bdd1*f*(2*r**2 - 2*r + 1) - 3*D1*f*(3*fd - 5*fdd)*(2*r - 1) + 30*D1*fd**2*r - 30*Dd*f*fd*(1 - 4*r) + 7*bd1*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1))) + 21*b1**2*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + f*(-126*D1**2*bd1**2*r*(r - 1) - 45*D1**2*bdd1*f*(2*r - 1) - 5*D1**2*(f*(5*fd - 7*fdd)*(3*r**2 - 2*r + 1) + 14*fd**2*r*(2 - 3*r)) + 9*D1*bd1*(D1*f*(6*r - 3) - 10*D1*fd*r + 10*Dd*f*(1 - 4*r)) - 5*D1*f*(5*Dd*f*(4*r**2 - 2*r + 1) - 14*Dd*fd*(12*r**2 - 7*r + 1) - 7*Ddd*f*(4*r**2 - 2*r + 1)) - 210*Dd**2*f**2*r*(1 - 2*r)))/(630*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct**2*k2**4*st**4*(C - 1)*(30*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*fd**2*r**2 + 3*D1**2*bdd1*f**2*(r - 1)**2 + 3*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 60*D1*Dd*b1*f**2*r**2 - 30*D1*Dd*b1*f**2*r + 15*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 - 12*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 - 6*D1*Ddd*b1*f**2*r + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) + 4*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*b1*f**2*r**2 - 18*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(105*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct**2*k2**4*st**2*(-33*D1**2*K*bdd1*f**2*r**2 + 22*D1**2*bd1**2*f*r*(r - 1)*(-7*K + 18*f + 7) - 220*D1**2*bdd1*f**3*r**2 + 660*D1**2*bdd1*f**3*r - 330*D1**2*bdd1*f**3 + 33*D1**2*bdd1*f**2*r**2 + 154*D1**2*bdd1*f*g2*r**2 - 308*D1**2*bdd1*f*g2*r + 154*D1**2*bdd1*f*g2 + 360*D1**2*f**3*fd*r**2 - 180*D1**2*f**3*fd*r + 90*D1**2*f**3*fd - 840*D1**2*f**3*fdd*r**2 + 420*D1**2*f**3*fdd*r - 210*D1**2*f**3*fdd - 2520*D1**2*f**2*fd**2*r**2 + 1260*D1**2*f**2*fd**2*r + 22*D1**2*f**2*gd2*r**2 + 66*D1**2*f**2*gdd2*r**2 + 44*D1**2*f*fd*g2*r**2 - 44*D1**2*f*fd*g2*r + 22*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 - 132*D1**2*f*fd*gd2*r + 132*D1**2*f*fdd*g2*r**2 - 132*D1**2*f*fdd*g2*r + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 - 132*D1**2*fd**2*g2*r + 360*D1*Dd*f**4*r**2 - 180*D1*Dd*f**4*r + 90*D1*Dd*f**4 - 6720*D1*Dd*f**3*fd*r**2 + 3360*D1*Dd*f**3*fd*r - 420*D1*Dd*f**3*fd + 88*D1*Dd*f**2*g2*r**2 - 44*D1*Dd*f**2*g2*r + 22*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f*fd*g2*r**2 - 792*D1*Dd*f*fd*g2*r + 132*D1*Dd*f*fd*g2 - 840*D1*Ddd*f**4*r**2 + 420*D1*Ddd*f**4*r - 210*D1*Ddd*f**4 + 264*D1*Ddd*f**2*g2*r**2 - 132*D1*Ddd*f**2*g2*r + 66*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(2*f**3*(2*r**2 - 6*r + 3) + f**2*r*(-K*r - 40*fd*(3*r - 4) + r) + 2*f*(-3*fd*r*(K - 1)*(2*r - 1) + 21*g2*(r - 1)**2 + 14*gd2*r*(r - 1)) + 28*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(10*f**2*(2*r - 3) + 3*f*r*(K - 1) - 14*g2*(r - 1))) - 2520*Dd**2*f**4*r**2 + 1260*Dd**2*f**4*r + 792*Dd**2*f**2*g2*r**2 - 396*Dd**2*f**2*g2*r + 11*b1**2*(D1**2*r**2*(36*fd**2 + 3*fd*(-7*K + 4*f + 7) + fdd*(-7*K + 36*f + 7)) + D1*(Dd*(6*f**2*(4*r**2 - 2*r + 1) - 3*f*(7*K*(4*r**2 - 2*r + 1) - r**2*(96*fd + 28) + r*(24*fd + 14) - 7) - 14*fd*r*(K - 1)*(4*r - 1)) + Ddd*f*(-7*K + 18*f + 7)*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)*(-7*K + 18*f + 7)) + 11*b1*(-2*D1**2*K*f*fd*r**2 + 2*D1**2*K*f*fd*r - D1**2*K*f*fd - 6*D1**2*K*f*fdd*r**2 + 6*D1**2*K*f*fdd*r - 3*D1**2*K*f*fdd - 6*D1**2*K*fd**2*r**2 + 6*D1**2*K*fd**2*r + D1**2*bdd1*f*(-7*K + 18*f + 7)*(2*r**2 - 2*r + 1) + 12*D1**2*f**2*fd*r**2 + 4*D1**2*f**2*fd*r - 2*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 20*D1**2*f**2*fdd*r + 10*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r**2 - 40*D1**2*f*fd**2*r + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 14*D1**2*f*gdd2*r**2 + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 42*D1**2*fd*g2*r**2 + 28*D1**2*fd*gd2*r**2 + 14*D1**2*fdd*g2*r**2 - 4*D1*Dd*K*f**2*r**2 + 2*D1*Dd*K*f**2*r - D1*Dd*K*f**2 - 48*D1*Dd*K*f*fd*r**2 + 36*D1*Dd*K*f*fd*r - 6*D1*Dd*K*f*fd + 16*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r + 4*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 + 40*D1*Dd*f**2*fd*r + 20*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 - 84*D1*Dd*f*g2*r + 42*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 - 28*D1*Dd*f*gd2*r + 112*D1*Dd*fd*g2*r**2 - 28*D1*Dd*fd*g2*r - 12*D1*Ddd*K*f**2*r**2 + 6*D1*Ddd*K*f**2*r - 3*D1*Ddd*K*f**2 - 80*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r - 20*D1*Ddd*f**3 + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 - 28*D1*Ddd*f*g2*r + 14*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(2*r**2 - 2*r + 1) - 3*f*(7*K*(2*r**2 - 2*r + 1) - r**2*(48*fd + 14) + r*(24*fd + 14) - 7) - 14*fd*r*(K - 1)*(2*r - 1)) + 2*Dd*f*(-7*K + 18*f + 7)*(8*r**2 - 6*r + 1)) - 36*Dd**2*K*f**2*r**2 + 18*Dd**2*K*f**2*r - 240*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r + 168*Dd**2*f*g2*r**2 - 84*Dd**2*f*g2*r))/(2310*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**2*k2**2*st**2*(C - 1)*(7*b1**2*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + b1*(7*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 10*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r - 20*D1*Dd*f**2*r**2 + 10*D1*Dd*f**2*r - 5*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 + 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd - 60*D1*Ddd*f**2*r**2 + 30*D1*Ddd*f**2*r - 15*D1*Ddd*f**2 + 7*D1*bd1*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) - 180*Dd**2*f**2*r**2 + 90*Dd**2*f**2*r) + f*(14*D1**2*bd1**2*r*(r - 1) - 3*D1**2*bdd1*f*(5*r**2 - 12*r + 6) + 2*D1**2*(f*(fd - 5*fdd)*(3*r**2 - 2*r + 1) + 10*fd**2*r*(2 - 3*r)) - D1*bd1*(D1*f*(5*r**2 - 12*r + 6) + 6*D1*fd*r*(10*r - 11) + 6*Dd*f*(20*r**2 - 29*r + 6)) + 2*D1*f*(Dd*f*(4*r**2 - 2*r + 1) - 10*Dd*fd*(12*r**2 - 7*r + 1) - 5*Ddd*f*(4*r**2 - 2*r + 1)) + 60*Dd**2*f**2*r*(1 - 2*r)))/(105*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct**2*k2**2*(42*D1**2*K*bd1**2*f*r + 9*D1**2*K*bd1*f**2*r**2 - 60*D1**2*K*bd1*f*fd*r**2 + 30*D1**2*K*bd1*f*fd*r - 15*D1**2*K*bdd1*f**2*r**2 + 60*D1**2*bd1**2*f**2*r**2 - 90*D1**2*bd1**2*f**2*r + 42*D1**2*bd1**2*f*r**2 - 84*D1**2*bd1**2*f*r - 140*D1**2*bd1**2*g2*r**2 + 140*D1**2*bd1**2*g2*r - 42*D1**2*bd1*bd2*f*r**2 + 42*D1**2*bd1*bd2*f*r - 25*D1**2*bd1*f**3*r**2 + 210*D1**2*bd1*f**2*fd*r**2 - 70*D1**2*bd1*f**2*fd*r - 18*D1**2*bd1*f**2*r**2 + 120*D1**2*bd1*f*fd*r**2 - 60*D1**2*bd1*f*fd*r + 28*D1**2*bd1*f*g2*r - 14*D1**2*bd1*f*g2 - 84*D1**2*bd1*f*gd2*r + 9*D1**2*bd2*f**2*r**2 - 60*D1**2*bd2*f*fd*r**2 + 30*D1**2*bd2*f*fd*r + 35*D1**2*bdd1*f**3*r**2 + 30*D1**2*bdd1*f**2*r**2 - 84*D1**2*bdd1*f*g2*r + 42*D1**2*bdd1*f*g2 - 15*D1**2*bdd2*f**2*r**2 - 18*D1**2*f**2*gd2*r**2 + 30*D1**2*f**2*gdd2*r**2 - 36*D1**2*f*fd*g2*r**2 + 36*D1**2*f*fd*g2*r - 18*D1**2*f*fd*g2 + 120*D1**2*f*fd*gd2*r**2 - 60*D1**2*f*fd*gd2*r + 60*D1**2*f*fdd*g2*r**2 - 60*D1**2*f*fdd*g2*r + 30*D1**2*f*fdd*g2 + 60*D1**2*fd**2*g2*r**2 - 60*D1**2*fd**2*g2*r - 120*D1*Dd*K*bd1*f**2*r**2 + 30*D1*Dd*K*bd1*f**2*r + 280*D1*Dd*bd1*f**3*r**2 - 70*D1*Dd*bd1*f**3*r + 240*D1*Dd*bd1*f**2*r**2 - 60*D1*Dd*bd1*f**2*r - 336*D1*Dd*bd1*f*g2*r + 84*D1*Dd*bd1*f*g2 - 120*D1*Dd*bd2*f**2*r**2 + 30*D1*Dd*bd2*f**2*r - 72*D1*Dd*f**2*g2*r**2 + 36*D1*Dd*f**2*g2*r - 18*D1*Dd*f**2*g2 + 240*D1*Dd*f**2*gd2*r**2 - 60*D1*Dd*f**2*gd2*r + 480*D1*Dd*f*fd*g2*r**2 - 360*D1*Dd*f*fd*g2*r + 60*D1*Dd*f*fd*g2 + 120*D1*Ddd*f**2*g2*r**2 - 60*D1*Ddd*f**2*g2*r + 30*D1*Ddd*f**2*g2 + 7*D1*b2*bd1*(r - 1)*(D1*f*(r - 1) - 6*D1*fd*r + 6*Dd*f*(1 - 4*r)) + 360*Dd**2*f**2*g2*r**2 - 180*Dd**2*f**2*g2*r + 7*b1**3*(D1**2*r**2*(fd - 3*fdd) + D1*Dd*(5*K*(4*r**2 - 2*r + 1) + f*(4*r**2 - 2*r + 1) - 24*fd*r**2 + 6*fd*r - 20*r**2 + 10*r - 5) - D1*Ddd*(-5*K + 3*f + 5)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(2*r - 1)*(-5*K + 3*f + 5)) + b1**2*(14*D1**2*K*fd*r - 7*D1**2*K*fd - 42*D1**2*K*fdd*r + 21*D1**2*K*fdd - 7*D1**2*bdd1*(-5*K + 3*f + 5)*(3*r**2 - 2*r + 1) - 36*D1**2*f*fd*r**2 - 18*D1**2*f*fd*r + 9*D1**2*f*fd + 60*D1**2*f*fdd*r**2 + 30*D1**2*f*fdd*r - 15*D1**2*f*fdd + 60*D1**2*fd**2*r**2 + 30*D1**2*fd**2*r - 7*D1**2*fd*r**2 - 14*D1**2*fd*r + 7*D1**2*fd + 21*D1**2*fdd*r**2 + 42*D1**2*fdd*r - 21*D1**2*fdd - 70*D1**2*gd2*r**2 - 70*D1**2*gdd2*r**2 - 168*D1*Dd*K*fd*r + 42*D1*Dd*K*fd - 72*D1*Dd*f**2*r**2 + 36*D1*Dd*f**2*r - 18*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 - 30*D1*Dd*f*fd - 28*D1*Dd*f*r**2 + 14*D1*Dd*f*r - 7*D1*Dd*f + 168*D1*Dd*fd*r**2 + 126*D1*Dd*fd*r - 42*D1*Dd*fd - 280*D1*Dd*g2*r**2 + 140*D1*Dd*g2*r - 70*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 + 140*D1*Dd*gd2*r + 120*D1*Ddd*f**2*r**2 - 60*D1*Ddd*f**2*r + 30*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 - 42*D1*Ddd*f*r + 21*D1*Ddd*f - 280*D1*Ddd*g2*r**2 + 140*D1*Ddd*g2*r - 70*D1*Ddd*g2 + 7*D1*bd1*(D1*(5*K*(3*r**2 - 2*r + 1) + f*(3*r**2 - 2*r + 1) - 18*fd*r**2 + 6*fd*r - 15*r**2 + 10*r - 5) - 2*Dd*(-5*K + 3*f + 5)*(12*r**2 - 7*r + 1)) + 360*Dd**2*f**2*r**2 - 180*Dd**2*f**2*r + 252*Dd**2*f*r**2 - 126*Dd**2*f*r - 840*Dd**2*g2*r**2 + 420*Dd**2*g2*r) + b1*(18*D1**2*K*f*fd*r**2 - 18*D1**2*K*f*fd*r + 9*D1**2*K*f*fd - 30*D1**2*K*f*fdd*r**2 + 30*D1**2*K*f*fdd*r - 15*D1**2*K*f*fdd - 30*D1**2*K*fd**2*r**2 + 30*D1**2*K*fd**2*r + 7*D1**2*b2*fd*r**2 - 21*D1**2*b2*fdd*r**2 - 14*D1**2*bd1**2*r*(3*r - 2)*(-5*K + 3*f + 5) + 7*D1**2*bd2*f*r**2 - 42*D1**2*bd2*fd*r**2 + D1**2*bdd1*(15*f**2*(4*r**2 - 6*r + 3) + 21*f*(K*(2*r - 1) + 2*(r - 1)**2) - 70*g2*(2*r**2 - 2*r + 1)) - 21*D1**2*bdd2*f*r**2 - 75*D1**2*f**2*fd*r**2 + 50*D1**2*f**2*fd*r - 25*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 - 70*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 - 140*D1**2*f*fd**2*r - 36*D1**2*f*fd*r**2 + 36*D1**2*f*fd*r - 18*D1**2*f*fd + 60*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r + 30*D1**2*f*fdd + 60*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r - 28*D1**2*fd*g2*r + 14*D1**2*fd*g2 + 84*D1**2*fd*gd2*r + 84*D1**2*fdd*g2*r - 42*D1**2*fdd*g2 + 36*D1*Dd*K*f**2*r**2 - 18*D1*Dd*K*f**2*r + 9*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*r**2 + 180*D1*Dd*K*f*fd*r - 30*D1*Dd*K*f*fd + 28*D1*Dd*b2*f*r**2 - 14*D1*Dd*b2*f*r + 7*D1*Dd*b2*f - 168*D1*Dd*b2*fd*r**2 + 42*D1*Dd*b2*fd*r - 168*D1*Dd*bd2*f*r**2 + 42*D1*Dd*bd2*f*r - 100*D1*Dd*f**3*r**2 + 50*D1*Dd*f**3*r - 25*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 - 490*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd - 72*D1*Dd*f**2*r**2 + 36*D1*Dd*f**2*r - 18*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 - 360*D1*Dd*f*fd*r + 60*D1*Dd*f*fd + 336*D1*Dd*fd*g2*r - 84*D1*Dd*fd*g2 - 60*D1*Ddd*K*f**2*r**2 + 30*D1*Ddd*K*f**2*r - 15*D1*Ddd*K*f**2 - 84*D1*Ddd*b2*f*r**2 + 42*D1*Ddd*b2*f*r - 21*D1*Ddd*b2*f + 140*D1*Ddd*f**3*r**2 - 70*D1*Ddd*f**3*r + 35*D1*Ddd*f**3 + 120*D1*Ddd*f**2*r**2 - 60*D1*Ddd*f**2*r + 30*D1*Ddd*f**2 - D1*bd1*(D1*(7*K*f*(2*r - 1) + 9*f**2*(4*r**2 - 6*r + 3) + 2*f*(r**2*(7 - 120*fd) + r*(60*fd - 14) + 7) + 70*g2*(2*r**2 - 2*r + 1) + 14*r*(3*fd*(K - 2*r) + 10*gd2*(2*r - 1))) - 2*Dd*(4*r - 1)*(15*f**2*(4*r - 3) + 21*f*(K + 2*r - 2) + 70*g2*(1 - 2*r))) - 180*Dd**2*K*f**2*r**2 + 90*Dd**2*K*f**2*r - 252*Dd**2*b2*f*r**2 + 126*Dd**2*b2*f*r + 420*Dd**2*f**3*r**2 - 210*Dd**2*f**3*r + 360*Dd**2*f**2*r**2 - 180*Dd**2*f**2*r) - 3*b2*(7*D1**2*bdd1*f*(r - 1)**2 + D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) + 10*fd**2*r*(r - 1)) + D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(8*r**2 - 6*r + 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) + 30*Dd**2*f**2*r*(2*r - 1)))/(210*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct**2*(2*C - 1)*(3*D1*f*r*(-14*D1*bd1**2*(r - 1) + D1*bd1*(3*f*r + fd*(10 - 20*r)) - 5*D1*bdd1*f*r + 10*Dd*bd1*f*(1 - 4*r)) + 7*b1**2*(D1**2*r**2*(fd - 3*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 6*Dd*fd*r*(1 - 4*r) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f*r*(1 - 2*r)) + b1*(-21*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) + 10*fd**2*r*(r - 1)) + 7*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + 6*D1*fd*r*(1 - 2*r) - 6*Dd*f*(8*r**2 - 6*r + 1)) - 3*D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(8*r**2 - 6*r + 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) - 90*Dd**2*f**2*r*(2*r - 1)))/(210*d**2) + D1**2*Pk3*Pkdd1*ct*f*k2**5*st**4*(33*D1**2*b1*f*fd*r**2 + 33*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*fd**2*r**2 + 11*D1**2*bdd1*f**2*(r - 1)**2 + 4*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 20*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 - 30*D1**2*f*fd**2*r + 44*D1*Dd*b1*f**2*r**2 - 22*D1*Dd*b1*f**2*r + 11*D1*Dd*b1*f**2 + 264*D1*Dd*b1*f*fd*r**2 - 66*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 160*D1*Dd*f**2*fd*r**2 - 80*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 44*D1*Ddd*b1*f**2*r**2 - 22*D1*Ddd*b1*f**2*r + 11*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 11*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 6*D1*fd*r + 2*Dd*f*(4*r - 1)) + 132*Dd**2*b1*f**2*r**2 - 66*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(462*d**2*k1*k3**4) + D1**2*Pk3*Pkdd1*ct*k1**3*k2*st**2*(16*C - 9)*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(630*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct*k1**3*k2*(-180*D1**2*K*bdd1*f**2*r**2 + 18*D1**2*bd1**2*f*r*(r - 1)*(-28*K + 5*f + 7) + 35*D1**2*bdd1*f**3*r**2 + 45*D1**2*bdd1*f**2*r**2 + 504*D1**2*bdd1*f*g2*r**2 - 1008*D1**2*bdd1*f*g2*r + 504*D1**2*bdd1*f*g2 - 216*D1**2*f**2*gd2*r**2 + 360*D1**2*f**2*gdd2*r**2 - 432*D1**2*f*fd*g2*r**2 + 432*D1**2*f*fd*g2*r - 216*D1**2*f*fd*g2 + 1440*D1**2*f*fd*gd2*r**2 - 720*D1**2*f*fd*gd2*r + 720*D1**2*f*fdd*g2*r**2 - 720*D1**2*f*fdd*g2*r + 360*D1**2*f*fdd*g2 + 720*D1**2*fd**2*g2*r**2 - 720*D1**2*fd**2*g2*r - 864*D1*Dd*f**2*g2*r**2 + 432*D1*Dd*f**2*g2*r - 216*D1*Dd*f**2*g2 + 2880*D1*Dd*f**2*gd2*r**2 - 720*D1*Dd*f**2*gd2*r + 5760*D1*Dd*f*fd*g2*r**2 - 4320*D1*Dd*f*fd*g2*r + 720*D1*Dd*f*fd*g2 + 1440*D1*Ddd*f**2*g2*r**2 - 720*D1*Ddd*f**2*g2*r + 360*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(25*f**3*r**2 + f**2*r*(-70*fd*(3*r - 1) + r*(27 - 108*K)) + 6*f*(28*g2*(r - 1)**2 + 3*r*(5*fd*(4*K - 1)*(2*r - 1) - 56*gd2*(r - 1))) - 1008*fd*g2*r*(r - 1)) + 2*Dd*f*(4*r - 1)*(5*f*r*(-36*K + 7*f + 9) + 504*g2*(r - 1))) + 4320*Dd**2*f**2*g2*r**2 - 2160*Dd**2*f**2*g2*r - 3*b1**2*(D1**2*r**2*(-30*fd**2 + fd*(-28*K + 18*f + 7) - 3*fdd*(-28*K + 10*f + 7)) + D1*(Dd*(9*f**2*(4*r**2 - 2*r + 1) + f*(-28*K*(4*r**2 - 2*r + 1) - r**2*(240*fd - 28) + r*(60*fd - 14) + 7) + 42*fd*r*(4*K - 1)*(4*r - 1)) - 3*Ddd*f*(-28*K + 5*f + 7)*(4*r**2 - 2*r + 1)) - 18*Dd**2*f*r*(2*r - 1)*(-28*K + 5*f + 7)) + b1*(216*D1**2*K*f*fd*r**2 - 216*D1**2*K*f*fd*r + 108*D1**2*K*f*fd - 360*D1**2*K*f*fdd*r**2 + 360*D1**2*K*f*fdd*r - 180*D1**2*K*f*fdd - 360*D1**2*K*fd**2*r**2 + 360*D1**2*K*fd**2*r + 9*D1**2*bdd1*f*(-28*K + 5*f + 7)*(2*r**2 - 2*r + 1) - 75*D1**2*f**2*fd*r**2 + 50*D1**2*f**2*fd*r - 25*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 - 70*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 - 140*D1**2*f*fd**2*r - 54*D1**2*f*fd*r**2 + 54*D1**2*f*fd*r - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 - 90*D1**2*f*fdd*r + 45*D1**2*f*fdd - 168*D1**2*f*gd2*r**2 + 504*D1**2*f*gdd2*r**2 + 90*D1**2*fd**2*r**2 - 90*D1**2*fd**2*r - 168*D1**2*fd*g2*r**2 + 1008*D1**2*fd*gd2*r**2 + 504*D1**2*fdd*g2*r**2 + 432*D1*Dd*K*f**2*r**2 - 216*D1*Dd*K*f**2*r + 108*D1*Dd*K*f**2 - 2880*D1*Dd*K*f*fd*r**2 + 2160*D1*Dd*K*f*fd*r - 360*D1*Dd*K*f*fd - 100*D1*Dd*f**3*r**2 + 50*D1*Dd*f**3*r - 25*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 - 490*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 + 54*D1*Dd*f**2*r - 27*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 - 540*D1*Dd*f*fd*r + 90*D1*Dd*f*fd - 672*D1*Dd*f*g2*r**2 + 336*D1*Dd*f*g2*r - 168*D1*Dd*f*g2 + 4032*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r + 4032*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r - 720*D1*Ddd*K*f**2*r**2 + 360*D1*Ddd*K*f**2*r - 180*D1*Ddd*K*f**2 + 140*D1*Ddd*f**3*r**2 - 70*D1*Ddd*f**3*r + 35*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 - 90*D1*Ddd*f**2*r + 45*D1*Ddd*f**2 + 2016*D1*Ddd*f*g2*r**2 - 1008*D1*Ddd*f*g2*r + 504*D1*Ddd*f*g2 - 3*D1*bd1*(D1*(9*f**2*(2*r**2 - 2*r + 1) + f*(-28*K*(2*r**2 - 2*r + 1) - r**2*(120*fd - 14) + r*(60*fd - 14) + 7) + 42*fd*r*(4*K - 1)*(2*r - 1)) - 6*Dd*f*(-28*K + 5*f + 7)*(8*r**2 - 6*r + 1)) - 2160*Dd**2*K*f**2*r**2 + 1080*Dd**2*K*f**2*r + 420*Dd**2*f**3*r**2 - 210*Dd**2*f**3*r + 540*Dd**2*f**2*r**2 - 270*Dd**2*f**2*r + 6048*Dd**2*f*g2*r**2 - 3024*Dd**2*f*g2*r))/(630*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct*k1*k2**3*st**4*(4*C - 3)*(30*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*fd**2*r**2 + 3*D1**2*bdd1*f**2*(r - 1)**2 + 3*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 60*D1*Dd*b1*f**2*r**2 - 30*D1*Dd*b1*f**2*r + 15*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 - 12*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 - 6*D1*Ddd*b1*f**2*r + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) + 4*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*b1*f**2*r**2 - 18*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(210*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct*k1*k2**3*st**2*(-66*D1**2*K*bdd1*f**2*r**2 + 22*D1**2*bd1**2*f*r*(r - 1)*(-14*K + 27*f + 7) + 330*D1**2*bdd1*f**3*r - 165*D1**2*bdd1*f**3 + 33*D1**2*bdd1*f**2*r**2 + 308*D1**2*bdd1*f*g2*r**2 - 616*D1**2*bdd1*f*g2*r + 308*D1**2*bdd1*f*g2 + 180*D1**2*f**3*fd*r**2 - 90*D1**2*f**3*fd*r + 45*D1**2*f**3*fd - 420*D1**2*f**3*fdd*r**2 + 210*D1**2*f**3*fdd*r - 105*D1**2*f**3*fdd - 1260*D1**2*f**2*fd**2*r**2 + 630*D1**2*f**2*fd**2*r + 44*D1**2*f**2*gd2*r**2 + 132*D1**2*f**2*gdd2*r**2 + 88*D1**2*f*fd*g2*r**2 - 88*D1**2*f*fd*g2*r + 44*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r**2 - 264*D1**2*f*fd*gd2*r + 264*D1**2*f*fdd*g2*r**2 - 264*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r**2 - 264*D1**2*fd**2*g2*r + 180*D1*Dd*f**4*r**2 - 90*D1*Dd*f**4*r + 45*D1*Dd*f**4 - 3360*D1*Dd*f**3*fd*r**2 + 1680*D1*Dd*f**3*fd*r - 210*D1*Dd*f**3*fd + 176*D1*Dd*f**2*g2*r**2 - 88*D1*Dd*f**2*g2*r + 44*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r**2 - 264*D1*Dd*f**2*gd2*r + 2112*D1*Dd*f*fd*g2*r**2 - 1584*D1*Dd*f*fd*g2*r + 264*D1*Dd*f*fd*g2 - 420*D1*Ddd*f**4*r**2 + 210*D1*Ddd*f**4*r - 105*D1*Ddd*f**4 + 528*D1*Ddd*f**2*g2*r**2 - 264*D1*Ddd*f**2*g2*r + 132*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(f**3*(6*r - 3) - f**2*r*(-2*K*r + 60*fd + r) + 6*f*fd*r*(2*K - 1)*(2*r - 1) - 84*f*g2*(r - 1)**2 - 56*f*gd2*r*(r - 1) - 56*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(15*f**2 + f*r*(3 - 6*K) + 28*g2*(r - 1))) - 1260*Dd**2*f**4*r**2 + 630*Dd**2*f**4*r + 1584*Dd**2*f**2*g2*r**2 - 792*Dd**2*f**2*g2*r + 11*b1**2*(D1**2*r**2*(54*fd**2 + 3*fd*(-14*K + 6*f + 7) + fdd*(-14*K + 54*f + 7)) + D1*(Dd*(9*f**2*(4*r**2 - 2*r + 1) - 3*f*(14*K*(4*r**2 - 2*r + 1) - r**2*(144*fd + 28) + r*(36*fd + 14) - 7) - 14*fd*r*(2*K - 1)*(4*r - 1)) + Ddd*f*(-14*K + 27*f + 7)*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)*(-14*K + 27*f + 7)) + 11*b1*(-4*D1**2*K*f*fd*r**2 + 4*D1**2*K*f*fd*r - 2*D1**2*K*f*fd - 12*D1**2*K*f*fdd*r**2 + 12*D1**2*K*f*fdd*r - 6*D1**2*K*f*fdd - 12*D1**2*K*fd**2*r**2 + 12*D1**2*K*fd**2*r + D1**2*bdd1*f*(-14*K + 27*f + 7)*(2*r**2 - 2*r + 1) + 6*D1**2*f**2*fd*r - 3*D1**2*f**2*fd - 30*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd - 60*D1**2*f*fd**2*r + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 84*D1**2*f*gd2*r**2 + 28*D1**2*f*gdd2*r**2 + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 84*D1**2*fd*g2*r**2 + 56*D1**2*fd*gd2*r**2 + 28*D1**2*fdd*g2*r**2 - 8*D1*Dd*K*f**2*r**2 + 4*D1*Dd*K*f**2*r - 2*D1*Dd*K*f**2 - 96*D1*Dd*K*f*fd*r**2 + 72*D1*Dd*K*f*fd*r - 12*D1*Dd*K*f*fd - 120*D1*Dd*f**2*fd*r + 30*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 336*D1*Dd*f*g2*r**2 - 168*D1*Dd*f*g2*r + 84*D1*Dd*f*g2 + 224*D1*Dd*f*gd2*r**2 - 56*D1*Dd*f*gd2*r + 224*D1*Dd*fd*g2*r**2 - 56*D1*Dd*fd*g2*r - 24*D1*Ddd*K*f**2*r**2 + 12*D1*Ddd*K*f**2*r - 6*D1*Ddd*K*f**2 + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 112*D1*Ddd*f*g2*r**2 - 56*D1*Ddd*f*g2*r + 28*D1*Ddd*f*g2 + D1*bd1*(D1*(9*f**2*(2*r**2 - 2*r + 1) - 3*f*(14*K*(2*r**2 - 2*r + 1) - r**2*(72*fd + 14) + r*(36*fd + 14) - 7) - 14*fd*r*(2*K - 1)*(2*r - 1)) + 2*Dd*f*(-14*K + 27*f + 7)*(8*r**2 - 6*r + 1)) - 72*Dd**2*K*f**2*r**2 + 36*Dd**2*K*f**2*r + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r + 336*Dd**2*f*g2*r**2 - 168*Dd**2*f*g2*r))/(2310*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct*k1*k2*st**2*(21*b1**2*(4*C - 3)*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + 3*b1*(-16*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd - 48*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r + 12*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r - 32*C*D1*Dd*f**2*r**2 + 16*C*D1*Dd*f**2*r - 8*C*D1*Dd*f**2 - 384*C*D1*Dd*f*fd*r**2 + 24*C*D1*Dd*f*fd - 96*C*D1*Ddd*f**2*r**2 + 48*C*D1*Ddd*f**2*r - 24*C*D1*Ddd*f**2 - 288*C*Dd**2*f**2*r**2 + 144*C*Dd**2*f**2*r + 7*D1**2*bdd1*f*(4*C - 3)*(2*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r - 3*D1**2*f*fd + 24*D1**2*f*fdd*r**2 + 18*D1**2*f*fdd*r - 9*D1**2*f*fdd + 24*D1**2*fd**2*r**2 + 18*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 + 192*D1*Dd*f*fd*r**2 + 24*D1*Dd*f*fd*r - 18*D1*Dd*f*fd + 48*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r + 12*D1*Ddd*f**2 + 7*D1*bd1*(4*C - 3)*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) + 144*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r) + f*(42*D1**2*bd1**2*r*(4*C - 3)*(r - 1) - 9*D1**2*bdd1*f*(4*C*(2*r**2 - 6*r + 3) - 4*r**2 + 14*r - 7) - 3*D1*bd1*(D1*(f*(4*C*(2*r**2 - 6*r + 3) - 4*r**2 + 14*r - 7) + 6*fd*r*(4*C*(4*r - 5) - 8*r + 11)) + 6*Dd*f*(4*r - 1)*(4*C*(2*r - 3) - 4*r + 7)) + (12*C - 7)*(D1**2*(f*(fd - 5*fdd)*(3*r**2 - 2*r + 1) + 10*fd**2*r*(2 - 3*r)) + D1*f*(Dd*f*(4*r**2 - 2*r + 1) - 10*Dd*fd*(12*r**2 - 7*r + 1) - 5*Ddd*f*(4*r**2 - 2*r + 1)) + 30*Dd**2*f**2*r*(1 - 2*r))))/(630*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct*k1*k2*(252*D1**2*K*bd1**2*f*r + 54*D1**2*K*bd1*f**2*r**2 - 360*D1**2*K*bd1*f*fd*r**2 + 180*D1**2*K*bd1*f*fd*r - 90*D1**2*K*bdd1*f**2*r**2 - 90*D1**2*bd1**2*f**2*r - 126*D1**2*bd1**2*f*r - 840*D1**2*bd1**2*g2*r**2 + 840*D1**2*bd1**2*g2*r - 252*D1**2*bd1*bd2*f*r**2 + 252*D1**2*bd1*bd2*f*r - 25*D1**2*bd1*f**3*r**2 + 210*D1**2*bd1*f**2*fd*r**2 - 70*D1**2*bd1*f**2*fd*r - 27*D1**2*bd1*f**2*r**2 + 180*D1**2*bd1*f*fd*r**2 - 90*D1**2*bd1*f*fd*r + 168*D1**2*bd1*f*g2*r - 84*D1**2*bd1*f*g2 - 504*D1**2*bd1*f*gd2*r + 54*D1**2*bd2*f**2*r**2 - 360*D1**2*bd2*f*fd*r**2 + 180*D1**2*bd2*f*fd*r + 35*D1**2*bdd1*f**3*r**2 + 45*D1**2*bdd1*f**2*r**2 - 504*D1**2*bdd1*f*g2*r + 252*D1**2*bdd1*f*g2 - 90*D1**2*bdd2*f**2*r**2 - 108*D1**2*f**2*gd2*r**2 + 180*D1**2*f**2*gdd2*r**2 - 216*D1**2*f*fd*g2*r**2 + 216*D1**2*f*fd*g2*r - 108*D1**2*f*fd*g2 + 720*D1**2*f*fd*gd2*r**2 - 360*D1**2*f*fd*gd2*r + 360*D1**2*f*fdd*g2*r**2 - 360*D1**2*f*fdd*g2*r + 180*D1**2*f*fdd*g2 + 360*D1**2*fd**2*g2*r**2 - 360*D1**2*fd**2*g2*r - 720*D1*Dd*K*bd1*f**2*r**2 + 180*D1*Dd*K*bd1*f**2*r + 280*D1*Dd*bd1*f**3*r**2 - 70*D1*Dd*bd1*f**3*r + 360*D1*Dd*bd1*f**2*r**2 - 90*D1*Dd*bd1*f**2*r - 2016*D1*Dd*bd1*f*g2*r + 504*D1*Dd*bd1*f*g2 - 720*D1*Dd*bd2*f**2*r**2 + 180*D1*Dd*bd2*f**2*r - 432*D1*Dd*f**2*g2*r**2 + 216*D1*Dd*f**2*g2*r - 108*D1*Dd*f**2*g2 + 1440*D1*Dd*f**2*gd2*r**2 - 360*D1*Dd*f**2*gd2*r + 2880*D1*Dd*f*fd*g2*r**2 - 2160*D1*Dd*f*fd*g2*r + 360*D1*Dd*f*fd*g2 + 720*D1*Ddd*f**2*g2*r**2 - 360*D1*Ddd*f**2*g2*r + 180*D1*Ddd*f**2*g2 + 2160*Dd**2*f**2*g2*r**2 - 1080*Dd**2*f**2*g2*r + 21*b1**3*(D1**2*r**2*(fd - 3*fdd) + D1*Dd*(10*K*(4*r**2 - 2*r + 1) + f*(4*r**2 - 2*r + 1) - 24*fd*r**2 + 6*fd*r - 20*r**2 + 10*r - 5) - D1*Ddd*(-10*K + 3*f + 5)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(2*r - 1)*(-10*K + 3*f + 5)) + 3*b1**2*(28*D1**2*K*fd*r - 14*D1**2*K*fd - 84*D1**2*K*fdd*r + 42*D1**2*K*fdd - 7*D1**2*bdd1*(-10*K + 3*f + 5)*(3*r**2 - 2*r + 1) - 18*D1**2*f*fd*r + 9*D1**2*f*fd + 30*D1**2*f*fdd*r - 15*D1**2*f*fdd + 30*D1**2*fd**2*r - 14*D1**2*fd*r + 7*D1**2*fd + 42*D1**2*fdd*r - 21*D1**2*fdd - 140*D1**2*gd2*r**2 - 140*D1**2*gdd2*r**2 - 336*D1*Dd*K*fd*r + 84*D1*Dd*K*fd + 120*D1*Dd*f*fd*r - 30*D1*Dd*f*fd + 168*D1*Dd*fd*r - 42*D1*Dd*fd - 560*D1*Dd*g2*r**2 + 280*D1*Dd*g2*r - 140*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 + 280*D1*Dd*gd2*r - 560*D1*Ddd*g2*r**2 + 280*D1*Ddd*g2*r - 140*D1*Ddd*g2 + 7*D1*bd1*(D1*(10*K*(3*r**2 - 2*r + 1) + f*(3*r**2 - 2*r + 1) - 18*fd*r**2 + 6*fd*r - 15*r**2 + 10*r - 5) - 2*Dd*(-10*K + 3*f + 5)*(12*r**2 - 7*r + 1)) - 1680*Dd**2*g2*r**2 + 840*Dd**2*g2*r) - b1*(-108*D1**2*K*f*fd*r**2 + 108*D1**2*K*f*fd*r - 54*D1**2*K*f*fd + 180*D1**2*K*f*fdd*r**2 - 180*D1**2*K*f*fdd*r + 90*D1**2*K*f*fdd + 180*D1**2*K*fd**2*r**2 - 180*D1**2*K*fd**2*r - 42*D1**2*b2*fd*r**2 + 126*D1**2*b2*fdd*r**2 + 42*D1**2*bd1**2*r*(3*r - 2)*(-10*K + 3*f + 5) - 42*D1**2*bd2*f*r**2 + 252*D1**2*bd2*fd*r**2 + 3*D1**2*bdd1*(15*f**2*(2*r - 1) - 21*f*(2*K - 1)*(2*r - 1) + 140*g2*(2*r**2 - 2*r + 1)) + 126*D1**2*bdd2*f*r**2 + 75*D1**2*f**2*fd*r**2 - 50*D1**2*f**2*fd*r + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 + 140*D1**2*f*fd**2*r + 54*D1**2*f*fd*r**2 - 54*D1**2*f*fd*r + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 + 90*D1**2*f*fdd*r - 45*D1**2*f*fdd - 90*D1**2*fd**2*r**2 + 90*D1**2*fd**2*r + 168*D1**2*fd*g2*r - 84*D1**2*fd*g2 - 504*D1**2*fd*gd2*r - 504*D1**2*fdd*g2*r + 252*D1**2*fdd*g2 - 216*D1*Dd*K*f**2*r**2 + 108*D1*Dd*K*f**2*r - 54*D1*Dd*K*f**2 + 1440*D1*Dd*K*f*fd*r**2 - 1080*D1*Dd*K*f*fd*r + 180*D1*Dd*K*f*fd - 168*D1*Dd*b2*f*r**2 + 84*D1*Dd*b2*f*r - 42*D1*Dd*b2*f + 1008*D1*Dd*b2*fd*r**2 - 252*D1*Dd*b2*fd*r + 1008*D1*Dd*bd2*f*r**2 - 252*D1*Dd*bd2*f*r + 100*D1*Dd*f**3*r**2 - 50*D1*Dd*f**3*r + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 + 490*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 - 54*D1*Dd*f**2*r + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 + 540*D1*Dd*f*fd*r - 90*D1*Dd*f*fd - 2016*D1*Dd*fd*g2*r + 504*D1*Dd*fd*g2 + 360*D1*Ddd*K*f**2*r**2 - 180*D1*Ddd*K*f**2*r + 90*D1*Ddd*K*f**2 + 504*D1*Ddd*b2*f*r**2 - 252*D1*Ddd*b2*f*r + 126*D1*Ddd*b2*f - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 + 90*D1*Ddd*f**2*r - 45*D1*Ddd*f**2 - 3*D1*bd1*(D1*(9*f**2*(2*r - 1) - 7*f*(2*K - 1)*(2*r - 1) - 14*fd*r*(6*K - 3) - 140*g2*(2*r**2 - 2*r + 1) - 280*gd2*r*(2*r - 1)) - 2*Dd*(4*r - 1)*(15*f**2 + f*(21 - 42*K) + 140*g2*(2*r - 1))) + 1080*Dd**2*K*f**2*r**2 - 540*Dd**2*K*f**2*r + 1512*Dd**2*b2*f*r**2 - 756*Dd**2*b2*f*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r - 540*Dd**2*f**2*r**2 + 270*Dd**2*f**2*r) + 6*b2*(-21*D1**2*bdd1*f*(r - 1)**2 - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 - 2*r + 1) + 10*fd**2*r*(r - 1)) + 7*D1*bd1*(r - 1)*(D1*f*(r - 1) - 6*D1*fd*r + 6*Dd*f*(1 - 4*r)) - 3*D1*f*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(8*r**2 - 6*r + 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) - 90*Dd**2*f**2*r*(2*r - 1)))/(630*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct*k2**3*st**4*(30*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*fd**2*r**2 + 3*D1**2*bdd1*f**2*(r - 1)**2 + 3*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 60*D1*Dd*b1*f**2*r**2 - 30*D1*Dd*b1*f**2*r + 15*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 - 12*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 - 6*D1*Ddd*b1*f**2*r + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) + 4*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*b1*f**2*r**2 - 18*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(210*d**2*k1*k3**2) + D1**2*Pk3*Pkdd1*ct*k2**3*st**2*(D1*f*r*(2*D1*bd1**2*(18*f + 7)*(r - 1) + D1*bdd1*f*r*(10*f + 3) + bd1*(D1*f*r*(1 - 2*f) + 2*D1*fd*(10*f*(3*r - 1) + 6*r - 3) + 2*Dd*f*(10*f + 3)*(4*r - 1))) + b1**2*(D1**2*r**2*(36*fd**2 + fd*(12*f + 21) + fdd*(36*f + 7)) + D1*(Dd*(6*f**2*(4*r**2 - 2*r + 1) + 3*f*(r**2*(96*fd + 28) - r*(24*fd + 14) + 7) + 14*fd*r*(4*r - 1)) + Ddd*f*(18*f + 7)*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(18*f + 7)*(2*r - 1)) + b1*(D1**2*bdd1*f*(18*f + 7)*(2*r**2 - 2*r + 1) - 6*D1**2*f**2*fd*r**2 + 4*D1**2*f**2*fd*r - 2*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r**2 - 20*D1**2*f**2*fdd*r + 10*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 - 40*D1**2*f*fd**2*r + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r - 8*D1*Dd*f**3*r**2 + 4*D1*Dd*f**3*r - 2*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r**2 - 140*D1*Dd*f**2*fd*r + 20*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 40*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r + 10*D1*Ddd*f**3 + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + D1*bd1*(D1*(6*f**2*(2*r**2 - 2*r + 1) + 3*f*(r**2*(48*fd + 14) - r*(24*fd + 14) + 7) + 14*fd*r*(2*r - 1)) + 2*Dd*f*(18*f + 7)*(8*r**2 - 6*r + 1)) + 120*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r))/(210*d**2*k1*k3**2) + D1**2*Pk3*Pkdd1*ct*k2*st**2*(D1*f*r*(14*D1*bd1**2*(r - 1) + D1*bd1*(f*r + 6*fd*(2*r - 1)) + 3*D1*bdd1*f*r + 6*Dd*bd1*f*(4*r - 1)) + 7*b1**2*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + b1*(7*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 7*D1*bd1*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r))/(210*d**2*k1) + D1**2*Pk3*Pkdd1*ct*k2*(6*D1**2*bd1**2*f*r**2*(5*f + 7) + 2*D1*b1*r*(7*D1*bd1**2*(3*f + 5)*(3*r - 2) + 3*D1*bdd1*f*r*(5*f + 7) + bd1*(-D1*f*r*(9*f + 7) + 6*D1*fd*(10*f*r - 5*f + 7*r - 7) + 6*Dd*f*(5*f + 7)*(4*r - 1))) - 7*b1**3*(D1**2*r**2*(fd - 3*fdd) + D1*Dd*(f*(4*r**2 - 2*r + 1) - r**2*(24*fd + 20) + r*(6*fd + 10) - 5) - D1*Ddd*(3*f + 5)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(3*f + 5)*(2*r - 1)) + b1**2*(7*D1**2*bdd1*(3*f + 5)*(3*r**2 - 2*r + 1) - 18*D1**2*f*fd*r**2 + 18*D1**2*f*fd*r - 9*D1**2*f*fd + 30*D1**2*f*fdd*r**2 - 30*D1**2*f*fdd*r + 15*D1**2*f*fdd + 30*D1**2*fd**2*r**2 - 30*D1**2*fd**2*r - 7*D1**2*fd*r**2 + 14*D1**2*fd*r - 7*D1**2*fd + 21*D1**2*fdd*r**2 - 42*D1**2*fdd*r + 21*D1**2*fdd - 36*D1*Dd*f**2*r**2 + 18*D1*Dd*f**2*r - 9*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 - 180*D1*Dd*f*fd*r + 30*D1*Dd*f*fd - 28*D1*Dd*f*r**2 + 14*D1*Dd*f*r - 7*D1*Dd*f + 168*D1*Dd*fd*r**2 - 210*D1*Dd*fd*r + 42*D1*Dd*fd + 60*D1*Ddd*f**2*r**2 - 30*D1*Ddd*f**2*r + 15*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 - 42*D1*Ddd*f*r + 21*D1*Ddd*f - 7*D1*bd1*(D1*(f*(3*r**2 - 2*r + 1) - r**2*(18*fd + 15) + r*(6*fd + 10) - 5) - 2*Dd*(3*f + 5)*(12*r**2 - 7*r + 1)) + 180*Dd**2*f**2*r**2 - 90*Dd**2*f**2*r + 252*Dd**2*f*r**2 - 126*Dd**2*f*r))/(210*d**2*k1) + D1**2*Pk3*Pkdd1*k1**4*st**2*(2*C - 1)*(6*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*fd**2*r**2 + 9*D1**2*bdd1*f**2*(r - 1)**2 - 3*D1**2*f**2*fd*r**2 + 2*D1**2*f**2*fd*r - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 - 10*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 - 20*D1**2*f*fd**2*r + 12*D1*Dd*b1*f**2*r**2 - 6*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 - 36*D1*Dd*b1*f*fd*r - 4*D1*Dd*f**3*r**2 + 2*D1*Dd*f**3*r - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 - 70*D1*Dd*f**2*fd*r + 10*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 - 18*D1*Ddd*b1*f**2*r + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 - 10*D1*Ddd*f**3*r + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 12*D1*fd*r + 6*Dd*f*(4*r - 1)) + 108*Dd**2*b1*f**2*r**2 - 54*Dd**2*b1*f**2*r + 60*Dd**2*f**3*r**2 - 30*Dd**2*f**3*r)/(630*d**2*k3**4) + D1**2*Pk3*Pkdd1*k1**4*(-7*D1**2*K*b1**2*fd*r**2 + 21*D1**2*K*b1**2*fdd*r**2 - 18*D1**2*K*b1*f*fd*r**2 + 18*D1**2*K*b1*f*fd*r - 9*D1**2*K*b1*f*fd + 30*D1**2*K*b1*f*fdd*r**2 - 30*D1**2*K*b1*f*fdd*r + 15*D1**2*K*b1*f*fdd + 30*D1**2*K*b1*fd**2*r**2 - 30*D1**2*K*b1*fd**2*r + 42*D1**2*K*bd1**2*f*r*(r - 1) + 14*D1**2*b1*f*gd2*r**2 - 42*D1**2*b1*f*gdd2*r**2 + 14*D1**2*b1*fd*g2*r**2 - 84*D1**2*b1*fd*gd2*r**2 - 42*D1**2*b1*fdd*g2*r**2 + 3*D1**2*bdd1*f*(7*K*b1*(2*r**2 - 2*r + 1) + 5*K*f*r**2 - 14*g2*(r - 1)**2) + 18*D1**2*f**2*gd2*r**2 - 30*D1**2*f**2*gdd2*r**2 + 36*D1**2*f*fd*g2*r**2 - 36*D1**2*f*fd*g2*r + 18*D1**2*f*fd*g2 - 120*D1**2*f*fd*gd2*r**2 + 60*D1**2*f*fd*gd2*r - 60*D1**2*f*fdd*g2*r**2 + 60*D1**2*f*fdd*g2*r - 30*D1**2*f*fdd*g2 - 60*D1**2*fd**2*g2*r**2 + 60*D1**2*fd**2*g2*r - 28*D1*Dd*K*b1**2*f*r**2 + 14*D1*Dd*K*b1**2*f*r - 7*D1*Dd*K*b1**2*f + 168*D1*Dd*K*b1**2*fd*r**2 - 42*D1*Dd*K*b1**2*fd*r - 36*D1*Dd*K*b1*f**2*r**2 + 18*D1*Dd*K*b1*f**2*r - 9*D1*Dd*K*b1*f**2 + 240*D1*Dd*K*b1*f*fd*r**2 - 180*D1*Dd*K*b1*f*fd*r + 30*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f*g2*r**2 - 28*D1*Dd*b1*f*g2*r + 14*D1*Dd*b1*f*g2 - 336*D1*Dd*b1*f*gd2*r**2 + 84*D1*Dd*b1*f*gd2*r - 336*D1*Dd*b1*fd*g2*r**2 + 84*D1*Dd*b1*fd*g2*r + 72*D1*Dd*f**2*g2*r**2 - 36*D1*Dd*f**2*g2*r + 18*D1*Dd*f**2*g2 - 240*D1*Dd*f**2*gd2*r**2 + 60*D1*Dd*f**2*gd2*r - 480*D1*Dd*f*fd*g2*r**2 + 360*D1*Dd*f*fd*g2*r - 60*D1*Dd*f*fd*g2 + 84*D1*Ddd*K*b1**2*f*r**2 - 42*D1*Ddd*K*b1**2*f*r + 21*D1*Ddd*K*b1**2*f + 60*D1*Ddd*K*b1*f**2*r**2 - 30*D1*Ddd*K*b1*f**2*r + 15*D1*Ddd*K*b1*f**2 - 168*D1*Ddd*b1*f*g2*r**2 + 84*D1*Ddd*b1*f*g2*r - 42*D1*Ddd*b1*f*g2 - 120*D1*Ddd*f**2*g2*r**2 + 60*D1*Ddd*f**2*g2*r - 30*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-9*K*f**2*r**2 + f*(-7*K*b1*(2*r**2 - 2*r + 1) + 30*K*fd*r*(2*r - 1) + 14*g2*(r - 1)**2 - 84*gd2*r*(r - 1)) - 42*fd*r*(K*b1*(1 - 2*r) + 2*g2*(r - 1))) + 6*Dd*f*(4*r - 1)*(7*K*b1*(2*r - 1) + 5*K*f*r - 14*g2*(r - 1))) + 252*Dd**2*K*b1**2*f*r**2 - 126*Dd**2*K*b1**2*f*r + 180*Dd**2*K*b1*f**2*r**2 - 90*Dd**2*K*b1*f**2*r - 504*Dd**2*b1*f*g2*r**2 + 252*Dd**2*b1*f*g2*r - 360*Dd**2*f**2*g2*r**2 + 180*Dd**2*f**2*g2*r)/(210*d**2*k3**4) + D1**2*Pk3*Pkdd1*k1**2*k2**2*st**4*(2*C - 1)*(30*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*fd**2*r**2 + 3*D1**2*bdd1*f**2*(r - 1)**2 + 3*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 60*D1*Dd*b1*f**2*r**2 - 30*D1*Dd*b1*f**2*r + 15*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 - 12*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 - 6*D1*Ddd*b1*f**2*r + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) + 4*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*b1*f**2*r**2 - 18*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(210*d**2*k3**4) - D1**2*Pk3*Pkdd1*k1**2*k2**2*st**2*(-99*D1**2*K*bdd1*f**2*r**2 + 66*D1**2*bd1**2*f*r*(-7*K + 9*f)*(r - 1) + 110*D1**2*bdd1*f**3*r**2 + 110*D1**2*bdd1*f**3*r - 55*D1**2*bdd1*f**3 + 462*D1**2*bdd1*f*g2*r**2 - 924*D1**2*bdd1*f*g2*r + 462*D1**2*bdd1*f*g2 + 60*D1**2*f**3*fd*r**2 - 30*D1**2*f**3*fd*r + 15*D1**2*f**3*fd - 140*D1**2*f**3*fdd*r**2 + 70*D1**2*f**3*fdd*r - 35*D1**2*f**3*fdd - 420*D1**2*f**2*fd**2*r**2 + 210*D1**2*f**2*fd**2*r + 66*D1**2*f**2*gd2*r**2 + 198*D1**2*f**2*gdd2*r**2 + 132*D1**2*f*fd*g2*r**2 - 132*D1**2*f*fd*g2*r + 66*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 - 396*D1**2*f*fd*gd2*r + 396*D1**2*f*fdd*g2*r**2 - 396*D1**2*f*fdd*g2*r + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 - 396*D1**2*fd**2*g2*r + 60*D1*Dd*f**4*r**2 - 30*D1*Dd*f**4*r + 15*D1*Dd*f**4 - 1120*D1*Dd*f**3*fd*r**2 + 560*D1*Dd*f**3*fd*r - 70*D1*Dd*f**3*fd + 264*D1*Dd*f**2*g2*r**2 - 132*D1*Dd*f**2*g2*r + 66*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 - 396*D1*Dd*f**2*gd2*r + 3168*D1*Dd*f*fd*g2*r**2 - 2376*D1*Dd*f*fd*g2*r + 396*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**4*r**2 + 70*D1*Ddd*f**4*r - 35*D1*Ddd*f**4 + 792*D1*Ddd*f**2*g2*r**2 - 396*D1*Ddd*f**2*g2*r + 198*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(f**3*(2*r**2 + 2*r - 1) + 3*f**2*r**2*(K - 20*fd) - 6*f*(3*K*fd*r*(1 - 2*r) + 21*g2*(r - 1)**2 + 14*gd2*r*(r - 1)) - 84*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(-9*K*f*r + 5*f**2*(2*r + 1) + 42*g2*(r - 1))) - 420*Dd**2*f**4*r**2 + 210*Dd**2*f**4*r + 2376*Dd**2*f**2*g2*r**2 - 1188*Dd**2*f**2*g2*r + 33*b1**2*(D1**2*r**2*(-21*K*fd - 7*K*fdd + 6*f*(fd + 3*fdd) + 18*fd**2) + D1*(Dd*(14*K*fd*r*(1 - 4*r) + 3*f**2*(4*r**2 - 2*r + 1) - 3*f*(7*K*(4*r**2 - 2*r + 1) + 12*fd*r*(1 - 4*r))) + Ddd*f*(-7*K + 9*f)*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(-7*K + 9*f)*(2*r - 1)) + 11*b1*(-6*D1**2*K*f*fd*r**2 + 6*D1**2*K*f*fd*r - 3*D1**2*K*f*fd - 18*D1**2*K*f*fdd*r**2 + 18*D1**2*K*f*fdd*r - 9*D1**2*K*f*fdd - 18*D1**2*K*fd**2*r**2 + 18*D1**2*K*fd**2*r + 3*D1**2*bdd1*f*(-7*K + 9*f)*(2*r**2 - 2*r + 1) - 6*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r - 3*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r + 126*D1**2*f*gd2*r**2 + 42*D1**2*f*gdd2*r**2 + 126*D1**2*fd*g2*r**2 + 84*D1**2*fd*gd2*r**2 + 42*D1**2*fdd*g2*r**2 - 12*D1*Dd*K*f**2*r**2 + 6*D1*Dd*K*f**2*r - 3*D1*Dd*K*f**2 - 144*D1*Dd*K*f*fd*r**2 + 108*D1*Dd*K*f*fd*r - 18*D1*Dd*K*f*fd - 8*D1*Dd*f**3*r**2 + 4*D1*Dd*f**3*r - 2*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r**2 - 180*D1*Dd*f**2*fd*r + 30*D1*Dd*f**2*fd + 504*D1*Dd*f*g2*r**2 - 252*D1*Dd*f*g2*r + 126*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 - 84*D1*Dd*f*gd2*r + 336*D1*Dd*fd*g2*r**2 - 84*D1*Dd*fd*g2*r - 36*D1*Ddd*K*f**2*r**2 + 18*D1*Ddd*K*f**2*r - 9*D1*Ddd*K*f**2 + 40*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r + 10*D1*Ddd*f**3 + 168*D1*Ddd*f*g2*r**2 - 84*D1*Ddd*f*g2*r + 42*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(14*K*fd*r*(1 - 2*r) + f**2*(6*r**2 - 6*r + 3) - 3*f*(7*K*(2*r**2 - 2*r + 1) + 12*fd*r*(1 - 2*r))) + 2*Dd*f*(-7*K + 9*f)*(8*r**2 - 6*r + 1)) - 108*Dd**2*K*f**2*r**2 + 54*Dd**2*K*f**2*r + 120*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r + 504*Dd**2*f*g2*r**2 - 252*Dd**2*f*g2*r))/(6930*d**2*k3**4) + D1**2*Pk3*Pkdd1*k1**2*st**2*(2*C - 1)*(3*D1*b1*(7*D1*bdd1*f*(2*r**2 - 2*r + 1) - 2*D1*f*fd*r + D1*f*fd - 6*D1*f*fdd*r + 3*D1*f*fdd - 6*D1*fd**2*r - 24*Dd*f*fd*r + 6*Dd*f*fd + 7*bd1*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1))) + 21*b1**2*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + f*(42*D1**2*bd1**2*r*(r - 1) + 9*D1**2*bdd1*f*(2*r - 1) + 3*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 15*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 30*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 - 120*D1*Dd*f*fd*r**2 + 70*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + 3*D1*bd1*(D1*f*(2*r - 1) + 6*D1*fd*r + 6*Dd*f*(4*r - 1)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(630*d**2*k3**2) + D1**2*Pk3*Pkdd1*k1**2*(42*D1**2*K*bd1**2*f*r + 9*D1**2*K*bd1*f**2*r**2 - 60*D1**2*K*bd1*f*fd*r**2 + 30*D1**2*K*bd1*f*fd*r - 15*D1**2*K*bdd1*f**2*r**2 - 140*D1**2*bd1**2*g2*r**2 + 140*D1**2*bd1**2*g2*r - 42*D1**2*bd1*bd2*f*r**2 + 42*D1**2*bd1*bd2*f*r + 28*D1**2*bd1*f*g2*r - 14*D1**2*bd1*f*g2 - 84*D1**2*bd1*f*gd2*r + 9*D1**2*bd2*f**2*r**2 - 60*D1**2*bd2*f*fd*r**2 + 30*D1**2*bd2*f*fd*r - 84*D1**2*bdd1*f*g2*r + 42*D1**2*bdd1*f*g2 - 15*D1**2*bdd2*f**2*r**2 - 18*D1**2*f**2*gd2*r**2 + 30*D1**2*f**2*gdd2*r**2 - 36*D1**2*f*fd*g2*r**2 + 36*D1**2*f*fd*g2*r - 18*D1**2*f*fd*g2 + 120*D1**2*f*fd*gd2*r**2 - 60*D1**2*f*fd*gd2*r + 60*D1**2*f*fdd*g2*r**2 - 60*D1**2*f*fdd*g2*r + 30*D1**2*f*fdd*g2 + 60*D1**2*fd**2*g2*r**2 - 60*D1**2*fd**2*g2*r - 120*D1*Dd*K*bd1*f**2*r**2 + 30*D1*Dd*K*bd1*f**2*r - 336*D1*Dd*bd1*f*g2*r + 84*D1*Dd*bd1*f*g2 - 120*D1*Dd*bd2*f**2*r**2 + 30*D1*Dd*bd2*f**2*r - 72*D1*Dd*f**2*g2*r**2 + 36*D1*Dd*f**2*g2*r - 18*D1*Dd*f**2*g2 + 240*D1*Dd*f**2*gd2*r**2 - 60*D1*Dd*f**2*gd2*r + 480*D1*Dd*f*fd*g2*r**2 - 360*D1*Dd*f*fd*g2*r + 60*D1*Dd*f*fd*g2 + 120*D1*Ddd*f**2*g2*r**2 - 60*D1*Ddd*f**2*g2*r + 30*D1*Ddd*f**2*g2 + 360*Dd**2*f**2*g2*r**2 - 180*Dd**2*f**2*g2*r + 35*K*b1**3*(D1*(Dd + Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(2*r - 1)) + 7*b1**2*(D1**2*(5*K*bd1*(3*r**2 - 2*r + 1) + 5*K*bdd1*(3*r**2 - 2*r + 1) + 2*K*fd*r - K*fd - 6*K*fdd*r + 3*K*fdd - 10*gd2*r**2 - 10*gdd2*r**2) - 2*D1*(5*Dd*g2*(4*r**2 - 2*r + 1) - Dd*(4*r - 1)*(5*K*bd1*(3*r - 1) - 3*K*fd - 10*gd2*r) + 5*Ddd*g2*(4*r**2 - 2*r + 1)) + 60*Dd**2*g2*r*(1 - 2*r)) + b1*(70*D1**2*K*bd1**2*r*(3*r - 2) + 18*D1**2*K*f*fd*r**2 - 18*D1**2*K*f*fd*r + 9*D1**2*K*f*fd - 30*D1**2*K*f*fdd*r**2 + 30*D1**2*K*f*fdd*r - 15*D1**2*K*f*fdd - 30*D1**2*K*fd**2*r**2 + 30*D1**2*K*fd**2*r + 7*D1**2*bd2*f*r**2 - 42*D1**2*bd2*fd*r**2 - 7*D1**2*bdd1*(3*K*f*(1 - 2*r) + 10*g2*(2*r**2 - 2*r + 1)) - 21*D1**2*bdd2*f*r**2 - 28*D1**2*fd*g2*r + 14*D1**2*fd*g2 + 84*D1**2*fd*gd2*r + 84*D1**2*fdd*g2*r - 42*D1**2*fdd*g2 + 36*D1*Dd*K*f**2*r**2 - 18*D1*Dd*K*f**2*r + 9*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*r**2 + 180*D1*Dd*K*f*fd*r - 30*D1*Dd*K*f*fd - 168*D1*Dd*bd2*f*r**2 + 42*D1*Dd*bd2*f*r + 336*D1*Dd*fd*g2*r - 84*D1*Dd*fd*g2 - 60*D1*Ddd*K*f**2*r**2 + 30*D1*Ddd*K*f**2*r - 15*D1*Ddd*K*f**2 - 7*D1*bd1*(D1*(K*f*(2*r - 1) + 6*K*fd*r + 10*g2*(2*r**2 - 2*r + 1) + 20*gd2*r*(2*r - 1)) + 2*Dd*(4*r - 1)*(-3*K*f + 10*g2*(2*r - 1))) - 180*Dd**2*K*f**2*r**2 + 90*Dd**2*K*f**2*r) + b2*(7*D1**2*b1*fd*r**2 - 21*D1**2*b1*fdd*r**2 - 21*D1**2*bdd1*f*(r - 1)**2 + 18*D1**2*f*fd*r**2 - 18*D1**2*f*fd*r + 9*D1**2*f*fd - 30*D1**2*f*fdd*r**2 + 30*D1**2*f*fdd*r - 15*D1**2*f*fdd - 30*D1**2*fd**2*r**2 + 30*D1**2*fd**2*r + 28*D1*Dd*b1*f*r**2 - 14*D1*Dd*b1*f*r + 7*D1*Dd*b1*f - 168*D1*Dd*b1*fd*r**2 + 42*D1*Dd*b1*fd*r + 36*D1*Dd*f**2*r**2 - 18*D1*Dd*f**2*r + 9*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 + 180*D1*Dd*f*fd*r - 30*D1*Dd*f*fd - 84*D1*Ddd*b1*f*r**2 + 42*D1*Ddd*b1*f*r - 21*D1*Ddd*b1*f - 60*D1*Ddd*f**2*r**2 + 30*D1*Ddd*f**2*r - 15*D1*Ddd*f**2 + 7*D1*bd1*(r - 1)*(D1*f*(r - 1) - 6*D1*fd*r + 6*Dd*f*(1 - 4*r)) - 252*Dd**2*b1*f*r**2 + 126*Dd**2*b1*f*r - 180*Dd**2*f**2*r**2 + 90*Dd**2*f**2*r))/(210*d**2*k3**2) + D1**2*Pk3*Pkdd1*k2**4*st**4*(-33*b1**2*(2*D1**2*r**2*(f*(5*fd + fdd) + fd**2) + D1*f*(5*Dd*f*(4*r**2 - 2*r + 1) + 4*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f**2*r*(2*r - 1)) - 11*b1*f*(3*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 6*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r + D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r - 8*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r - 2*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 + 4*D1*Dd*f*fd*r + 2*D1*Dd*f*fd - 8*D1*Ddd*f**2*r**2 + 4*D1*Ddd*f**2*r - 2*D1*Ddd*f**2 + 3*D1*bd1*(5*D1*f*(2*r**2 - 2*r + 1) + 4*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) - 24*Dd**2*f**2*r**2 + 12*Dd**2*f**2*r) + f**2*(-66*D1**2*bd1**2*r*(r - 1) + 11*D1**2*bdd1*f*(2*r**2 - 6*r + 3) + 3*D1**2*(f*(fd + 5*fdd)*(4*r**2 - 2*r + 1) + 30*fd**2*r*(2*r - 1)) + 11*D1*bd1*(D1*f*(2*r**2 - 6*r + 3) + 4*D1*fd*r*(3*r - 4) + 2*Dd*f*(8*r**2 - 14*r + 3)) + 3*D1*f*(Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*(1 - 4*r)**2 + 5*Ddd*f*(4*r**2 - 2*r + 1)) + 90*Dd**2*f**2*r*(2*r - 1)))/(2310*d**2*k3**4) - D1**2*Pk3*Pkdd1*k2**2*st**4*(2*C - 1)*(30*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*fd**2*r**2 + 3*D1**2*bdd1*f**2*(r - 1)**2 + 3*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 60*D1*Dd*b1*f**2*r**2 - 30*D1*Dd*b1*f**2*r + 15*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 - 12*D1*Dd*b1*f*fd*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 - 6*D1*Ddd*b1*f**2*r + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 3*D1*bd1*f*(r - 1)*(5*D1*f*(r - 1) + 4*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*b1*f**2*r**2 - 18*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(210*d**2*k3**2) - D1**2*Pk3*Pkdd1*k2**2*st**2*(14*D1**2*K*bd1**2*f*r**2 - 14*D1**2*K*bd1**2*f*r + D1**2*K*bd1*f**2*r**2 + 12*D1**2*K*bd1*f*fd*r**2 - 6*D1**2*K*bd1*f*fd*r + 3*D1**2*K*bdd1*f**2*r**2 - 12*D1**2*bd1**2*f**2*r**2 + 18*D1**2*bd1**2*f**2*r + 14*D1**2*bd1*bd2*f*r**2 - 14*D1**2*bd1*bd2*f*r + D1**2*bd1*f**3*r**2 - 30*D1**2*bd1*f**2*fd*r**2 + 10*D1**2*bd1*f**2*fd*r - 42*D1**2*bd1*f*g2*r**2 + 84*D1**2*bd1*f*g2*r - 42*D1**2*bd1*f*g2 - 28*D1**2*bd1*f*gd2*r**2 + 28*D1**2*bd1*f*gd2*r - 28*D1**2*bd1*fd*g2*r**2 + 28*D1**2*bd1*fd*g2*r + D1**2*bd2*f**2*r**2 + 12*D1**2*bd2*f*fd*r**2 - 6*D1**2*bd2*f*fd*r - 5*D1**2*bdd1*f**3*r**2 - 14*D1**2*bdd1*f*g2*r**2 + 28*D1**2*bdd1*f*g2*r - 14*D1**2*bdd1*f*g2 + 3*D1**2*bdd2*f**2*r**2 - 2*D1**2*f**2*gd2*r**2 - 6*D1**2*f**2*gdd2*r**2 - 4*D1**2*f*fd*g2*r**2 + 4*D1**2*f*fd*g2*r - 2*D1**2*f*fd*g2 - 24*D1**2*f*fd*gd2*r**2 + 12*D1**2*f*fd*gd2*r - 12*D1**2*f*fdd*g2*r**2 + 12*D1**2*f*fdd*g2*r - 6*D1**2*f*fdd*g2 - 12*D1**2*fd**2*g2*r**2 + 12*D1**2*fd**2*g2*r + 24*D1*Dd*K*bd1*f**2*r**2 - 6*D1*Dd*K*bd1*f**2*r - 40*D1*Dd*bd1*f**3*r**2 + 10*D1*Dd*bd1*f**3*r - 112*D1*Dd*bd1*f*g2*r**2 + 140*D1*Dd*bd1*f*g2*r - 28*D1*Dd*bd1*f*g2 + 24*D1*Dd*bd2*f**2*r**2 - 6*D1*Dd*bd2*f**2*r - 8*D1*Dd*f**2*g2*r**2 + 4*D1*Dd*f**2*g2*r - 2*D1*Dd*f**2*g2 - 48*D1*Dd*f**2*gd2*r**2 + 12*D1*Dd*f**2*gd2*r - 96*D1*Dd*f*fd*g2*r**2 + 72*D1*Dd*f*fd*g2*r - 12*D1*Dd*f*fd*g2 - 24*D1*Ddd*f**2*g2*r**2 + 12*D1*Ddd*f**2*g2*r - 6*D1*Ddd*f**2*g2 - 72*Dd**2*f**2*g2*r**2 + 36*Dd**2*f**2*g2*r + 7*b1**3*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + b1**2*(21*D1**2*K*fd*r**2 + 7*D1**2*K*fdd*r**2 + 7*D1**2*bdd1*f*(3*r**2 - 2*r + 1) - 4*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 84*D1*Dd*K*f*r**2 - 42*D1*Dd*K*f*r + 21*D1*Dd*K*f + 56*D1*Dd*K*fd*r**2 - 14*D1*Dd*K*fd*r - 8*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r - 2*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 + 6*D1*Dd*f*fd + 28*D1*Ddd*K*f*r**2 - 14*D1*Ddd*K*f*r + 7*D1*Ddd*K*f - 24*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r - 6*D1*Ddd*f**2 + 7*D1*bd1*(D1*f*(9*r**2 - 6*r + 3) + 2*D1*fd*r*(3*r - 1) + 2*Dd*f*(12*r**2 - 7*r + 1)) + 84*Dd**2*K*f*r**2 - 42*Dd**2*K*f*r - 72*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r) + b1*(14*D1**2*K*bdd1*f*r**2 - 14*D1**2*K*bdd1*f*r + 7*D1**2*K*bdd1*f + 2*D1**2*K*f*fd*r**2 - 2*D1**2*K*f*fd*r + D1**2*K*f*fd + 6*D1**2*K*f*fdd*r**2 - 6*D1**2*K*f*fdd*r + 3*D1**2*K*f*fdd + 6*D1**2*K*fd**2*r**2 - 6*D1**2*K*fd**2*r + 14*D1**2*bd1**2*f*r*(3*r - 2) + 21*D1**2*bd2*f*r**2 + 14*D1**2*bd2*fd*r**2 - 12*D1**2*bdd1*f**2*r**2 + 18*D1**2*bdd1*f**2*r - 9*D1**2*bdd1*f**2 + 7*D1**2*bdd2*f*r**2 + 3*D1**2*f**2*fd*r**2 - 2*D1**2*f**2*fd*r + D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 + 10*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 + 20*D1**2*f*fd**2*r - 42*D1**2*f*gd2*r**2 - 14*D1**2*f*gdd2*r**2 - 42*D1**2*fd*g2*r**2 - 28*D1**2*fd*gd2*r**2 - 14*D1**2*fdd*g2*r**2 + 4*D1*Dd*K*f**2*r**2 - 2*D1*Dd*K*f**2*r + D1*Dd*K*f**2 + 48*D1*Dd*K*f*fd*r**2 - 36*D1*Dd*K*f*fd*r + 6*D1*Dd*K*f*fd + 56*D1*Dd*bd2*f*r**2 - 14*D1*Dd*bd2*f*r + 4*D1*Dd*f**3*r**2 - 2*D1*Dd*f**3*r + D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 + 70*D1*Dd*f**2*fd*r - 10*D1*Dd*f**2*fd - 168*D1*Dd*f*g2*r**2 + 84*D1*Dd*f*g2*r - 42*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*r**2 + 28*D1*Dd*f*gd2*r - 112*D1*Dd*fd*g2*r**2 + 28*D1*Dd*fd*g2*r + 12*D1*Ddd*K*f**2*r**2 - 6*D1*Ddd*K*f**2*r + 3*D1*Ddd*K*f**2 - 20*D1*Ddd*f**3*r**2 + 10*D1*Ddd*f**3*r - 5*D1*Ddd*f**3 - 56*D1*Ddd*f*g2*r**2 + 28*D1*Ddd*f*g2*r - 14*D1*Ddd*f*g2 + D1*bd1*(D1*(14*K*fd*r*(2*r - 1) + f**2*(-4*r**2 + 6*r - 3) + 3*f*(7*K*(2*r**2 - 2*r + 1) + 8*fd*r*(1 - 2*r))) + 2*Dd*f*(4*r - 1)*(7*K*(2*r - 1) + f*(9 - 12*r))) + 36*Dd**2*K*f**2*r**2 - 18*Dd**2*K*f**2*r - 60*Dd**2*f**3*r**2 + 30*Dd**2*f**3*r - 168*Dd**2*f*g2*r**2 + 84*Dd**2*f*g2*r + 7*b2*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1))) + b2*(7*D1**2*bdd1*f*(r - 1)**2 + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 7*D1*bd1*(r - 1)*(3*D1*f*(r - 1) + 2*D1*fd*r + 2*Dd*f*(4*r - 1)) + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r))/(210*d**2*k3**2) - D1**2*Pk3*Pkdd1*st**2*(2*C - 1)*(D1*f*r*(14*D1*bd1**2*(r - 1) + D1*bd1*(f*r + 6*fd*(2*r - 1)) + 3*D1*bdd1*f*r + 6*Dd*bd1*f*(4*r - 1)) + 7*b1**2*(D1**2*r**2*(3*fd + fdd) + D1*(3*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + b1*(7*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 7*D1*bd1*(D1*f*(6*r**2 - 6*r + 3) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r))/(210*d**2) + D1**2*Pk3*Pkdd1*(D1*r*(-2*D1*bd1**2*(3*K*f*r - 10*g2*(r - 1)) + 6*D1*bdd1*f*g2*r + b2*(-10*D1*bd1**2*(r - 1) + D1*bd1*(f*r - 6*fd*(r - 1)) - 3*D1*bdd1*f*r + 6*Dd*bd1*f*(1 - 4*r)) - 2*bd1*(D1*f*r*(3*bd2 + g2 - 6*gd2) - 6*D1*fd*g2*(r - 1) + 6*Dd*f*g2*(1 - 4*r))) - 5*K*b1**3*(D1*(Dd + Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(2*r - 1)) + b1**2*(D1**2*(-5*K*bd1*(3*r**2 - 2*r + 1) - 5*K*bdd1*(3*r**2 - 2*r + 1) + K*fd*r**2 - 2*K*fd*r + K*fd - 3*K*fdd*r**2 + 6*K*fdd*r - 3*K*fdd - 5*bd2*r**2 - 5*bdd2*r**2 + 10*gd2*r**2 + 10*gdd2*r**2) + D1*(Dd*(-10*K*bd1*(12*r**2 - 7*r + 1) + 4*K*f*r**2 - 2*K*f*r + K*f - 24*K*fd*r**2 + 30*K*fd*r - 6*K*fd - 40*bd2*r**2 + 10*bd2*r + 10*g2*(4*r**2 - 2*r + 1) + 80*gd2*r**2 - 20*gd2*r) + Ddd*(-3*K*f + 10*g2)*(4*r**2 - 2*r + 1)) + 6*Dd**2*r*(2*r - 1)*(-3*K*f + 10*g2) - 5*b2*(D1*(Dd + Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(2*r - 1))) + b1*(10*D1**2*K*bd1**2*r*(2 - 3*r) - 6*D1**2*K*bdd1*f*r**2 + D1**2*bd2*f*r**2 - 6*D1**2*bd2*fd*r**2 + 6*D1**2*bd2*fd*r + 20*D1**2*bdd1*g2*r**2 - 20*D1**2*bdd1*g2*r + 10*D1**2*bdd1*g2 - 3*D1**2*bdd2*f*r**2 - 2*D1**2*f*gd2*r**2 + 6*D1**2*f*gdd2*r**2 - 2*D1**2*fd*g2*r**2 + 4*D1**2*fd*g2*r - 2*D1**2*fd*g2 + 12*D1**2*fd*gd2*r**2 - 12*D1**2*fd*gd2*r + 6*D1**2*fdd*g2*r**2 - 12*D1**2*fdd*g2*r + 6*D1**2*fdd*g2 - 24*D1*Dd*bd2*f*r**2 + 6*D1*Dd*bd2*f*r - 8*D1*Dd*f*g2*r**2 + 4*D1*Dd*f*g2*r - 2*D1*Dd*f*g2 + 48*D1*Dd*f*gd2*r**2 - 12*D1*Dd*f*gd2*r + 48*D1*Dd*fd*g2*r**2 - 60*D1*Dd*fd*g2*r + 12*D1*Dd*fd*g2 + 24*D1*Ddd*f*g2*r**2 - 12*D1*Ddd*f*g2*r + 6*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*g2*(2*r**2 - 2*r + 1) + r*(K*f*r - 6*K*fd*r + 6*K*fd - 10*bd2*r + 5*bd2 + 20*gd2*r - 10*gd2)) + 2*Dd*(4*r - 1)*(-3*K*f*r + 5*g2*(2*r - 1))) + 72*Dd**2*f*g2*r**2 - 36*Dd**2*f*g2*r + b2*(-5*D1**2*bdd1*(2*r**2 - 2*r + 1) + D1**2*fd*r**2 - 2*D1**2*fd*r + D1**2*fd - 3*D1**2*fdd*r**2 + 6*D1**2*fdd*r - 3*D1**2*fdd + 4*D1*Dd*f*r**2 - 2*D1*Dd*f*r + D1*Dd*f - 24*D1*Dd*fd*r**2 + 30*D1*Dd*fd*r - 6*D1*Dd*fd - 12*D1*Ddd*f*r**2 + 6*D1*Ddd*f*r - 3*D1*Ddd*f - 5*D1*bd1*(D1*(2*r**2 - 2*r + 1) + 2*Dd*(8*r**2 - 6*r + 1)) - 36*Dd**2*f*r**2 + 18*Dd**2*f*r)))/(30*d**2) - D1**2*Pkd1*Pkd3*ct**7*k2**5*(2*C - 2)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**6*f*k2**6*(-165*D1**2*b1*f*fd*r**2 - 165*D1**2*b1*f*fd*r*s + 110*D1**2*b1*f*fd*r + 231*D1**2*b1*f*fdd*r**2 + 231*D1**2*b1*f*fdd*r*s - 154*D1**2*b1*f*fdd*r + 462*D1**2*b1*fd**2*r**2 + 462*D1**2*b1*fd**2*r*s - 308*D1**2*b1*fd**2*r + 77*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 196*D1**2*f**2*fd*r**2 - 196*D1**2*f**2*fd*r*s + 196*D1**2*f**2*fd*r + 49*D1**2*f**2*fd*s - 49*D1**2*f**2*fd + 252*D1**2*f**2*fdd*r**2 + 252*D1**2*f**2*fdd*r*s - 252*D1**2*f**2*fdd*r - 63*D1**2*f**2*fdd*s + 63*D1**2*f**2*fdd + 756*D1**2*f*fd**2*r**2 + 756*D1**2*f*fd**2*r*s - 756*D1**2*f*fd**2*r - 189*D1**2*f*fd**2*s + 126*D1**2*f*fd**2 - 220*D1*Dd*b1*f**2*r**2 - 220*D1*Dd*b1*f**2*r*s + 220*D1*Dd*b1*f**2*r + 55*D1*Dd*b1*f**2*s - 55*D1*Dd*b1*f**2 + 1848*D1*Dd*b1*f*fd*r**2 + 1848*D1*Dd*b1*f*fd*r*s - 1540*D1*Dd*b1*f*fd*r - 231*D1*Dd*b1*f*fd*s + 154*D1*Dd*b1*f*fd - 196*D1*Dd*f**3*r**2 - 196*D1*Dd*f**3*r*s + 196*D1*Dd*f**3*r + 49*D1*Dd*f**3*s - 49*D1*Dd*f**3 + 2016*D1*Dd*f**2*fd*r**2 + 2016*D1*Dd*f**2*fd*r*s - 2016*D1*Dd*f**2*fd*r - 504*D1*Dd*f**2*fd*s + 378*D1*Dd*f**2*fd + 308*D1*Ddd*b1*f**2*r**2 + 308*D1*Ddd*b1*f**2*r*s - 308*D1*Ddd*b1*f**2*r - 77*D1*Ddd*b1*f**2*s + 77*D1*Ddd*b1*f**2 + 252*D1*Ddd*f**3*r**2 + 252*D1*Ddd*f**3*r*s - 252*D1*Ddd*f**3*r - 63*D1*Ddd*f**3*s + 63*D1*Ddd*f**3 - 11*D1*bd1*f*(D1*(5*f*(r - 1)*(r + s - 1) - 7*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 7*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 924*Dd**2*b1*f**2*r**2 + 924*Dd**2*b1*f**2*r*s - 924*Dd**2*b1*f**2*r - 231*Dd**2*b1*f**2*s + 154*Dd**2*b1*f**2 + 756*Dd**2*f**3*r**2 + 756*Dd**2*f**3*r*s - 756*Dd**2*f**3*r - 189*Dd**2*f**3*s + 126*Dd**2*f**3)/(693*d**2*k1*k3**5) - D1**2*Pkd1*Pkd3*ct**6*k1*k2**4*(10*C - 9)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**6*k2**4*(-54*D1**2*b1*f*fd*r**2 - 54*D1**2*b1*f*fd*r*s + 27*D1**2*b1*f*fd*r + 90*D1**2*b1*f*fdd*r**2 + 90*D1**2*b1*f*fdd*r*s - 45*D1**2*b1*f*fdd*r + 90*D1**2*b1*fd**2*r**2 + 90*D1**2*b1*fd**2*r*s - 45*D1**2*b1*fd**2*r + 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 75*D1**2*f**2*fd*r**2 - 75*D1**2*f**2*fd*r*s + 75*D1**2*f**2*fd*r + 25*D1**2*f**2*fd*s - 25*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 + 105*D1**2*f**2*fdd*r*s - 105*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd*s + 35*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 + 210*D1**2*f*fd**2*r*s - 210*D1**2*f*fd**2*r - 70*D1**2*f*fd**2*s + 35*D1**2*f*fd**2 - 108*D1*Dd*b1*f**2*r**2 - 108*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r + 27*D1*Dd*b1*f**2*s - 27*D1*Dd*b1*f**2 + 720*D1*Dd*b1*f*fd*r**2 + 720*D1*Dd*b1*f*fd*r*s - 540*D1*Dd*b1*f*fd*r - 90*D1*Dd*b1*f*fd*s + 45*D1*Dd*b1*f*fd - 100*D1*Dd*f**3*r**2 - 100*D1*Dd*f**3*r*s + 100*D1*Dd*f**3*r + 25*D1*Dd*f**3*s - 25*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 + 840*D1*Dd*f**2*fd*r*s - 840*D1*Dd*f**2*fd*r - 245*D1*Dd*f**2*fd*s + 175*D1*Dd*f**2*fd + 180*D1*Ddd*b1*f**2*r**2 + 180*D1*Ddd*b1*f**2*r*s - 180*D1*Ddd*b1*f**2*r - 45*D1*Ddd*b1*f**2*s + 45*D1*Ddd*b1*f**2 + 140*D1*Ddd*f**3*r**2 + 140*D1*Ddd*f**3*r*s - 140*D1*Ddd*f**3*r - 35*D1*Ddd*f**3*s + 35*D1*Ddd*f**3 - 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 540*Dd**2*b1*f**2*r**2 + 540*Dd**2*b1*f**2*r*s - 540*Dd**2*b1*f**2*r - 135*Dd**2*b1*f**2*s + 90*Dd**2*b1*f**2 + 420*Dd**2*f**3*r**2 + 420*Dd**2*f**3*r*s - 420*Dd**2*f**3*r - 105*Dd**2*f**3*s + 70*Dd**2*f**3)/(315*d**2*k1*k3**3) - D1**2*Pkd1*Pkd3*ct**5*k1**2*k2**3*(20*C - 16)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**5) - D1**2*Pkd1*Pkd3*ct**5*k2**5*st**2*(4*C - 4)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 69*D1**2*f**2*fd*r**2 + 69*D1**2*f**2*fd*r*s - 69*D1**2*f**2*fd*r - 23*D1**2*f**2*fd*s + 23*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 92*D1*Dd*f**3*r**2 + 92*D1*Dd*f**3*r*s - 92*D1*Dd*f**3*r - 23*D1*Dd*f**3*s + 23*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 600*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s - 125*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 300*Dd**2*f**3*r + 75*Dd**2*f**3*s - 50*Dd**2*f**3)/(315*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**5*k2**5*(495*D1**2*K*bdd1*f**2*r**2 + 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*r - 99*D1**2*bd1**2*f*(2*r - 1)*(-7*K + 5*f + 7)*(r + s - 1) + 1155*D1**2*bdd1*f**3*r**2 + 1155*D1**2*bdd1*f**3*r*s - 2695*D1**2*bdd1*f**3*r - 1540*D1**2*bdd1*f**3*s + 1540*D1**2*bdd1*f**3 - 495*D1**2*bdd1*f**2*r**2 - 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*r - 1386*D1**2*bdd1*f*g2*r**2 - 1386*D1**2*bdd1*f*g2*r*s + 2772*D1**2*bdd1*f*g2*r + 1386*D1**2*bdd1*f*g2*s - 1386*D1**2*bdd1*f*g2 - 3920*D1**2*f**3*fd*r**2 - 3920*D1**2*f**3*fd*r*s + 3920*D1**2*f**3*fd*r + 980*D1**2*f**3*fd*s - 980*D1**2*f**3*fd + 5040*D1**2*f**3*fdd*r**2 + 5040*D1**2*f**3*fdd*r*s - 5040*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s + 1260*D1**2*f**3*fdd + 15120*D1**2*f**2*fd**2*r**2 + 15120*D1**2*f**2*fd**2*r*s - 15120*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s + 2520*D1**2*f**2*fd**2 + 594*D1**2*f**2*gd2*r**2 + 594*D1**2*f**2*gd2*r*s - 594*D1**2*f**2*gd2*r - 990*D1**2*f**2*gdd2*r**2 - 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*r + 1188*D1**2*f*fd*g2*r**2 + 1188*D1**2*f*fd*g2*r*s - 1188*D1**2*f*fd*g2*r - 594*D1**2*f*fd*g2*s + 594*D1**2*f*fd*g2 - 3960*D1**2*f*fd*gd2*r**2 - 3960*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r + 990*D1**2*f*fd*gd2*s - 990*D1**2*f*fd*gd2 - 1980*D1**2*f*fdd*g2*r**2 - 1980*D1**2*f*fdd*g2*r*s + 1980*D1**2*f*fdd*g2*r + 990*D1**2*f*fdd*g2*s - 990*D1**2*f*fdd*g2 - 1980*D1**2*fd**2*g2*r**2 - 1980*D1**2*fd**2*g2*r*s + 1980*D1**2*fd**2*g2*r + 990*D1**2*fd**2*g2*s - 3920*D1*Dd*f**4*r**2 - 3920*D1*Dd*f**4*r*s + 3920*D1*Dd*f**4*r + 980*D1*Dd*f**4*s - 980*D1*Dd*f**4 + 40320*D1*Dd*f**3*fd*r**2 + 40320*D1*Dd*f**3*fd*r*s - 40320*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s + 7560*D1*Dd*f**3*fd + 2376*D1*Dd*f**2*g2*r**2 + 2376*D1*Dd*f**2*g2*r*s - 2376*D1*Dd*f**2*g2*r - 594*D1*Dd*f**2*g2*s + 594*D1*Dd*f**2*g2 - 7920*D1*Dd*f**2*gd2*r**2 - 7920*D1*Dd*f**2*gd2*r*s + 7920*D1*Dd*f**2*gd2*r + 990*D1*Dd*f**2*gd2*s - 990*D1*Dd*f**2*gd2 - 15840*D1*Dd*f*fd*g2*r**2 - 15840*D1*Dd*f*fd*g2*r*s + 15840*D1*Dd*f*fd*g2*r + 5940*D1*Dd*f*fd*g2*s - 3960*D1*Dd*f*fd*g2 + 5040*D1*Ddd*f**4*r**2 + 5040*D1*Ddd*f**4*r*s - 5040*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s + 1260*D1*Ddd*f**4 - 3960*D1*Ddd*f**2*g2*r**2 - 3960*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r + 990*D1*Ddd*f**2*g2*s - 990*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(25*f**3*(3*r - 4)*(r + s - 1) + f**2*(-35*fd*(18*r**2 + 2*r*(9*s - 13) - 11*s + 7) + r*(27*K - 27)*(r + s - 1)) - 3*f*(15*fd*(K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) + 126*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-35*f**2*(24*r**2 + 8*r*(3*s - 5) - 19*s + 15) - 45*f*(K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 15120*Dd**2*f**4*r**2 + 15120*Dd**2*f**4*r*s - 15120*Dd**2*f**4*r - 3780*Dd**2*f**4*s + 2520*Dd**2*f**4 - 11880*Dd**2*f**2*g2*r**2 - 11880*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r + 2970*Dd**2*f**2*g2*s - 1980*Dd**2*f**2*g2 + 33*b1**2*(D1**2*r*(3*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 15*fd**2*(2*r + 2*s - 1) - 7*fd*(K - 1)*(r + s) + 21*fdd*(K - 1)*(r + s)) + D1*(Dd*(9*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-15*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (7 - 7*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(K - 1)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-7*K + 5*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-7*K + 5*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-54*D1**2*K*f*fd*r**2 - 54*D1**2*K*f*fd*r*s + 54*D1**2*K*f*fd*r + 27*D1**2*K*f*fd*s - 27*D1**2*K*f*fd + 90*D1**2*K*f*fdd*r**2 + 90*D1**2*K*f*fdd*r*s - 90*D1**2*K*f*fdd*r - 45*D1**2*K*f*fdd*s + 45*D1**2*K*f*fdd + 90*D1**2*K*fd**2*r**2 + 90*D1**2*K*fd**2*r*s - 90*D1**2*K*fd**2*r - 45*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*r - 1)*(-7*K + 5*f + 7)*(r + s - 1) - 225*D1**2*f**2*fd*r**2 - 225*D1**2*f**2*fd*r*s + 125*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd + 315*D1**2*f**2*fdd*r**2 + 315*D1**2*f**2*fdd*r*s - 175*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd + 630*D1**2*f*fd**2*r**2 + 630*D1**2*f*fd**2*r*s - 350*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 54*D1**2*f*fd*r**2 + 54*D1**2*f*fd*r*s - 54*D1**2*f*fd*r - 27*D1**2*f*fd*s + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 90*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r + 45*D1**2*f*fdd*s - 45*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r - 126*D1**2*f*gdd2*r**2 - 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*r - 90*D1**2*fd**2*r**2 - 90*D1**2*fd**2*r*s + 90*D1**2*fd**2*r + 45*D1**2*fd**2*s + 42*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s - 252*D1**2*fd*gd2*r**2 - 252*D1**2*fd*gd2*r*s + 126*D1**2*fd*gd2*r - 126*D1**2*fdd*g2*r**2 - 126*D1**2*fdd*g2*r*s - 108*D1*Dd*K*f**2*r**2 - 108*D1*Dd*K*f**2*r*s + 108*D1*Dd*K*f**2*r + 27*D1*Dd*K*f**2*s - 27*D1*Dd*K*f**2 + 720*D1*Dd*K*f*fd*r**2 + 720*D1*Dd*K*f*fd*r*s - 720*D1*Dd*K*f*fd*r - 270*D1*Dd*K*f*fd*s + 180*D1*Dd*K*f*fd - 300*D1*Dd*f**3*r**2 - 300*D1*Dd*f**3*r*s + 300*D1*Dd*f**3*r + 75*D1*Dd*f**3*s - 75*D1*Dd*f**3 + 2520*D1*Dd*f**2*fd*r**2 + 2520*D1*Dd*f**2*fd*r*s - 1960*D1*Dd*f**2*fd*r - 175*D1*Dd*f**2*fd*s + 105*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 + 108*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r - 27*D1*Dd*f**2*s + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 720*D1*Dd*f*fd*r*s + 720*D1*Dd*f*fd*r + 270*D1*Dd*f*fd*s - 180*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 42*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r + 126*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r + 126*D1*Dd*fd*g2*s + 180*D1*Ddd*K*f**2*r**2 + 180*D1*Ddd*K*f**2*r*s - 180*D1*Ddd*K*f**2*r - 45*D1*Ddd*K*f**2*s + 45*D1*Ddd*K*f**2 + 420*D1*Ddd*f**3*r**2 + 420*D1*Ddd*f**3*r*s - 420*D1*Ddd*f**3*r - 105*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 180*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r + 45*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 504*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 126*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(9*f**2*(2*r - 1)*(r + s - 1) + f*(-15*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (7*K - 7)*(2*r - 1)*(r + s - 1)) + 21*fd*(K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-7*K + 5*f + 7)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 540*Dd**2*K*f**2*r**2 + 540*Dd**2*K*f**2*r*s - 540*Dd**2*K*f**2*r - 135*Dd**2*K*f**2*s + 90*Dd**2*K*f**2 + 1260*Dd**2*f**3*r**2 + 1260*Dd**2*f**3*r*s - 1260*Dd**2*f**3*r - 315*Dd**2*f**3*s + 210*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 540*Dd**2*f**2*r*s + 540*Dd**2*f**2*r + 135*Dd**2*f**2*s - 90*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 1512*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 378*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(3465*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct**5*k2**3*(21*b1**2*(C - 1)*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1*(-21*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*D1**2*(3*f*fd - 5*f*fdd - 5*fd**2)*(-C*(2*r + s - 1) + 2*r**2 + 2*r*s + r + s - 1) + 7*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*fd*(4*C*(2*r + s - 1) - 16*r**2 - 16*r*s + 4*r - 2*s + 3)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - f*(63*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 45*D1**2*bdd1*f*(C*(2*r + s - 1) + r**2 + r*(s - 4) - 2*s + 2) - 9*D1*bd1*(D1*(3*f*(C*(2*r + s - 1) + r**2 + r*(s - 4) - 2*s + 2) - 5*fd*(C*(2*r + s - 1) + 4*r**2 + r*(4*s - 7) - 3*s + 2)) - 5*Dd*f*(4*C*(2*r + s - 1) + 8*r**2 + 4*r*(2*s - 5) - 9*s + 8)) + 5*(C - 2)*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 7*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 7*fd*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 7*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 7*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2))))/(315*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct**4*f*k2**6*st**2*(-396*D1**2*b1*f*fd*r**2 - 396*D1**2*b1*f*fd*r*s + 264*D1**2*b1*f*fd*r + 495*D1**2*b1*f*fdd*r**2 + 495*D1**2*b1*f*fdd*r*s - 330*D1**2*b1*f*fdd*r + 990*D1**2*b1*fd**2*r**2 + 990*D1**2*b1*fd**2*r*s - 660*D1**2*b1*fd**2*r + 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 400*D1**2*f**2*fd*r**2 - 400*D1**2*f**2*fd*r*s + 400*D1**2*f**2*fd*r + 100*D1**2*f**2*fd*s - 100*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 420*D1**2*f**2*fdd*r*s - 420*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s + 105*D1**2*f**2*fdd + 1260*D1**2*f*fd**2*r**2 + 1260*D1**2*f*fd**2*r*s - 1260*D1**2*f*fd**2*r - 315*D1**2*f*fd**2*s + 210*D1**2*f*fd**2 - 528*D1*Dd*b1*f**2*r**2 - 528*D1*Dd*b1*f**2*r*s + 528*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2*s - 132*D1*Dd*b1*f**2 + 3960*D1*Dd*b1*f*fd*r**2 + 3960*D1*Dd*b1*f*fd*r*s - 3300*D1*Dd*b1*f*fd*r - 495*D1*Dd*b1*f*fd*s + 330*D1*Dd*b1*f*fd - 400*D1*Dd*f**3*r**2 - 400*D1*Dd*f**3*r*s + 400*D1*Dd*f**3*r + 100*D1*Dd*f**3*s - 100*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 3360*D1*Dd*f**2*fd*r*s - 3360*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s + 630*D1*Dd*f**2*fd + 660*D1*Ddd*b1*f**2*r**2 + 660*D1*Ddd*b1*f**2*r*s - 660*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2*s + 165*D1*Ddd*b1*f**2 + 420*D1*Ddd*f**3*r**2 + 420*D1*Ddd*f**3*r*s - 420*D1*Ddd*f**3*r - 105*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 - 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 1980*Dd**2*b1*f**2*r**2 + 1980*Dd**2*b1*f**2*r*s - 1980*Dd**2*b1*f**2*r - 495*Dd**2*b1*f**2*s + 330*Dd**2*b1*f**2 + 1260*Dd**2*f**3*r**2 + 1260*Dd**2*f**3*r*s - 1260*Dd**2*f**3*r - 315*Dd**2*f**3*s + 210*Dd**2*f**3)/(693*d**2*k1*k3**5) - D1**2*Pkd1*Pkd3*ct**4*k1**3*k2**2*(20*C - 14)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct**4*k1*k2**4*st**2*(360*C*D1**2*b1*f*fd*r**2 + 360*C*D1**2*b1*f*fd*r*s - 180*C*D1**2*b1*f*fd*r - 684*C*D1**2*b1*f*fdd*r**2 - 684*C*D1**2*b1*f*fdd*r*s + 342*C*D1**2*b1*f*fdd*r - 684*C*D1**2*b1*fd**2*r**2 - 684*C*D1**2*b1*fd**2*r*s + 342*C*D1**2*b1*fd**2*r + 492*C*D1**2*f**2*fd*r**2 + 492*C*D1**2*f**2*fd*r*s - 492*C*D1**2*f**2*fd*r - 164*C*D1**2*f**2*fd*s + 164*C*D1**2*f**2*fd - 570*C*D1**2*f**2*fdd*r**2 - 570*C*D1**2*f**2*fdd*r*s + 570*C*D1**2*f**2*fdd*r + 190*C*D1**2*f**2*fdd*s - 190*C*D1**2*f**2*fdd - 1140*C*D1**2*f*fd**2*r**2 - 1140*C*D1**2*f*fd**2*r*s + 1140*C*D1**2*f*fd**2*r + 380*C*D1**2*f*fd**2*s - 190*C*D1**2*f*fd**2 + 720*C*D1*Dd*b1*f**2*r**2 + 720*C*D1*Dd*b1*f**2*r*s - 720*C*D1*Dd*b1*f**2*r - 180*C*D1*Dd*b1*f**2*s + 180*C*D1*Dd*b1*f**2 - 5472*C*D1*Dd*b1*f*fd*r**2 - 5472*C*D1*Dd*b1*f*fd*r*s + 4104*C*D1*Dd*b1*f*fd*r + 684*C*D1*Dd*b1*f*fd*s - 342*C*D1*Dd*b1*f*fd + 656*C*D1*Dd*f**3*r**2 + 656*C*D1*Dd*f**3*r*s - 656*C*D1*Dd*f**3*r - 164*C*D1*Dd*f**3*s + 164*C*D1*Dd*f**3 - 4560*C*D1*Dd*f**2*fd*r**2 - 4560*C*D1*Dd*f**2*fd*r*s + 4560*C*D1*Dd*f**2*fd*r + 1330*C*D1*Dd*f**2*fd*s - 950*C*D1*Dd*f**2*fd - 1368*C*D1*Ddd*b1*f**2*r**2 - 1368*C*D1*Ddd*b1*f**2*r*s + 1368*C*D1*Ddd*b1*f**2*r + 342*C*D1*Ddd*b1*f**2*s - 342*C*D1*Ddd*b1*f**2 - 760*C*D1*Ddd*f**3*r**2 - 760*C*D1*Ddd*f**3*r*s + 760*C*D1*Ddd*f**3*r + 190*C*D1*Ddd*f**3*s - 190*C*D1*Ddd*f**3 - 4104*C*Dd**2*b1*f**2*r**2 - 4104*C*Dd**2*b1*f**2*r*s + 4104*C*Dd**2*b1*f**2*r + 1026*C*Dd**2*b1*f**2*s - 684*C*Dd**2*b1*f**2 - 2280*C*Dd**2*f**3*r**2 - 2280*C*Dd**2*f**3*r*s + 2280*C*Dd**2*f**3*r + 570*C*Dd**2*f**3*s - 380*C*Dd**2*f**3 - 306*D1**2*b1*f*fd*r**2 - 306*D1**2*b1*f*fd*r*s + 153*D1**2*b1*f*fd*r + 594*D1**2*b1*f*fdd*r**2 + 594*D1**2*b1*f*fdd*r*s - 297*D1**2*b1*f*fdd*r + 594*D1**2*b1*fd**2*r**2 + 594*D1**2*b1*fd**2*r*s - 297*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(38*C - 33)*(r - 1)*(r + s - 1) - 423*D1**2*f**2*fd*r**2 - 423*D1**2*f**2*fd*r*s + 423*D1**2*f**2*fd*r + 141*D1**2*f**2*fd*s - 141*D1**2*f**2*fd + 495*D1**2*f**2*fdd*r**2 + 495*D1**2*f**2*fdd*r*s - 495*D1**2*f**2*fdd*r - 165*D1**2*f**2*fdd*s + 165*D1**2*f**2*fdd + 990*D1**2*f*fd**2*r**2 + 990*D1**2*f*fd**2*r*s - 990*D1**2*f*fd**2*r - 330*D1**2*f*fd**2*s + 165*D1**2*f*fd**2 - 612*D1*Dd*b1*f**2*r**2 - 612*D1*Dd*b1*f**2*r*s + 612*D1*Dd*b1*f**2*r + 153*D1*Dd*b1*f**2*s - 153*D1*Dd*b1*f**2 + 4752*D1*Dd*b1*f*fd*r**2 + 4752*D1*Dd*b1*f*fd*r*s - 3564*D1*Dd*b1*f*fd*r - 594*D1*Dd*b1*f*fd*s + 297*D1*Dd*b1*f*fd - 564*D1*Dd*f**3*r**2 - 564*D1*Dd*f**3*r*s + 564*D1*Dd*f**3*r + 141*D1*Dd*f**3*s - 141*D1*Dd*f**3 + 3960*D1*Dd*f**2*fd*r**2 + 3960*D1*Dd*f**2*fd*r*s - 3960*D1*Dd*f**2*fd*r - 1155*D1*Dd*f**2*fd*s + 825*D1*Dd*f**2*fd + 1188*D1*Ddd*b1*f**2*r**2 + 1188*D1*Ddd*b1*f**2*r*s - 1188*D1*Ddd*b1*f**2*r - 297*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 + 660*D1*Ddd*f**3*r**2 + 660*D1*Ddd*f**3*r*s - 660*D1*Ddd*f**3*r - 165*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(f*(20*C - 17)*(r - 1)*(r + s - 1) - fd*(38*C - 33)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(38*C - 33)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 3564*Dd**2*b1*f**2*r**2 + 3564*Dd**2*b1*f**2*r*s - 3564*Dd**2*b1*f**2*r - 891*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 + 1980*Dd**2*f**3*r**2 + 1980*Dd**2*f**3*r*s - 1980*Dd**2*f**3*r - 495*Dd**2*f**3*s + 330*Dd**2*f**3)/(315*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**4*k1*k2**4*(-99*D1**2*bd1**2*f*(2*r - 1)*(-35*K + 20*f + 28)*(r + s - 1) + 55*D1**2*bdd1*f*(r + s - 1)*(14*f**2*(r - 3) + 9*f*r*(5*K - 4) - 126*g2*(r - 1)) - 30*D1**2*(7*f**3*(7*fd - 9*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*f**2*(21*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + r*(33*gd2 - 55*gdd2)*(r + s - 1)) - 33*f*(fd*(g2*(6*r**2 + 6*r*(s - 1) - 3*s + 3) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 165*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) - 11*D1*bd1*(D1*(50*f**3*(r - 3)*(r + s - 1) + f**2*(-70*fd*(6*r**2 + 6*r*(s - 2) - 7*s + 4) + r*(135*K - 108)*(r + s - 1)) - 15*f*(3*fd*(5*K - 4)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) + 630*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(14*f**2*(8*r**2 + 4*r*(2*s - 5) - 13*s + 10) + 9*f*(5*K - 4)*(8*r**2 + 8*r*(s - 1) - s + 1) - 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 30*D1*f*(Dd*(49*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 126*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 33*f*(3*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 330*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 3*Ddd*f*(21*f**2 - 55*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 90*Dd**2*f**2*(21*f**2 - 55*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 33*b1**2*(D1**2*r*(12*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 60*fd**2*(2*r + 2*s - 1) - 7*fd*(5*K - 4)*(r + s) + 21*fdd*(5*K - 4)*(r + s)) + D1*(Dd*(36*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-60*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (28 - 35*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(5*K - 4)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-35*K + 20*f + 28)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-35*K + 20*f + 28)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-270*D1**2*K*f*fd*r**2 - 270*D1**2*K*f*fd*r*s + 270*D1**2*K*f*fd*r + 135*D1**2*K*f*fd*s - 135*D1**2*K*f*fd + 450*D1**2*K*f*fdd*r**2 + 450*D1**2*K*f*fdd*r*s - 450*D1**2*K*f*fdd*r - 225*D1**2*K*f*fdd*s + 225*D1**2*K*f*fdd + 450*D1**2*K*fd**2*r**2 + 450*D1**2*K*fd**2*r*s - 450*D1**2*K*fd**2*r - 225*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*r - 1)*(-35*K + 20*f + 28)*(r + s - 1) - 150*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*s + 100*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r**2 + 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r**2 + 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 216*D1**2*f*fd*r**2 + 216*D1**2*f*fd*r*s - 216*D1**2*f*fd*r - 108*D1**2*f*fd*s + 108*D1**2*f*fd - 360*D1**2*f*fdd*r**2 - 360*D1**2*f*fdd*r*s + 360*D1**2*f*fdd*r + 180*D1**2*f*fdd*s - 180*D1**2*f*fdd + 210*D1**2*f*gd2*r**2 + 210*D1**2*f*gd2*r*s - 210*D1**2*f*gd2*r - 630*D1**2*f*gdd2*r**2 - 630*D1**2*f*gdd2*r*s + 630*D1**2*f*gdd2*r - 360*D1**2*fd**2*r**2 - 360*D1**2*fd**2*r*s + 360*D1**2*fd**2*r + 180*D1**2*fd**2*s + 210*D1**2*fd*g2*r**2 + 210*D1**2*fd*g2*r*s - 1260*D1**2*fd*gd2*r**2 - 1260*D1**2*fd*gd2*r*s + 630*D1**2*fd*gd2*r - 630*D1**2*fdd*g2*r**2 - 630*D1**2*fdd*g2*r*s - 540*D1*Dd*K*f**2*r**2 - 540*D1*Dd*K*f**2*r*s + 540*D1*Dd*K*f**2*r + 135*D1*Dd*K*f**2*s - 135*D1*Dd*K*f**2 + 3600*D1*Dd*K*f*fd*r**2 + 3600*D1*Dd*K*f*fd*r*s - 3600*D1*Dd*K*f*fd*r - 1350*D1*Dd*K*f*fd*s + 900*D1*Dd*K*f*fd - 200*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 200*D1*Dd*f**3*r + 50*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r**2 + 1680*D1*Dd*f**2*fd*r*s - 840*D1*Dd*f**2*fd*r + 350*D1*Dd*f**2*fd*s - 280*D1*Dd*f**2*fd + 432*D1*Dd*f**2*r**2 + 432*D1*Dd*f**2*r*s - 432*D1*Dd*f**2*r - 108*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 2880*D1*Dd*f*fd*r**2 - 2880*D1*Dd*f*fd*r*s + 2880*D1*Dd*f*fd*r + 1080*D1*Dd*f*fd*s - 720*D1*Dd*f*fd + 840*D1*Dd*f*g2*r**2 + 840*D1*Dd*f*g2*r*s - 840*D1*Dd*f*g2*r - 210*D1*Dd*f*g2*s + 210*D1*Dd*f*g2 - 5040*D1*Dd*f*gd2*r**2 - 5040*D1*Dd*f*gd2*r*s + 5040*D1*Dd*f*gd2*r + 630*D1*Dd*f*gd2*s - 630*D1*Dd*f*gd2 - 5040*D1*Dd*fd*g2*r**2 - 5040*D1*Dd*fd*g2*r*s + 2520*D1*Dd*fd*g2*r + 630*D1*Dd*fd*g2*s + 900*D1*Ddd*K*f**2*r**2 + 900*D1*Ddd*K*f**2*r*s - 900*D1*Ddd*K*f**2*r - 225*D1*Ddd*K*f**2*s + 225*D1*Ddd*K*f**2 + 280*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r - 70*D1*Ddd*f**3*s + 70*D1*Ddd*f**3 - 720*D1*Ddd*f**2*r**2 - 720*D1*Ddd*f**2*r*s + 720*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 2520*D1*Ddd*f*g2*r**2 - 2520*D1*Ddd*f*g2*r*s + 2520*D1*Ddd*f*g2*r + 630*D1*Ddd*f*g2*s - 630*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(36*f**2*(2*r - 1)*(r + s - 1) + f*(-60*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (35*K - 28)*(2*r - 1)*(r + s - 1)) + 21*fd*(5*K - 4)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-35*K + 20*f + 28)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 2700*Dd**2*K*f**2*r**2 + 2700*Dd**2*K*f**2*r*s - 2700*Dd**2*K*f**2*r - 675*Dd**2*K*f**2*s + 450*Dd**2*K*f**2 + 840*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r*s - 840*Dd**2*f**3*r - 210*Dd**2*f**3*s + 140*Dd**2*f**3 - 2160*Dd**2*f**2*r**2 - 2160*Dd**2*f**2*r*s + 2160*Dd**2*f**2*r + 540*Dd**2*f**2*s - 360*Dd**2*f**2 - 7560*Dd**2*f*g2*r**2 - 7560*Dd**2*f*g2*r*s + 7560*Dd**2*f*g2*r + 1890*Dd**2*f*g2*s - 1260*Dd**2*f*g2))/(3465*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**4*k1*k2**2*(-7*b1**2*(6*C - 5)*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(21*D1**2*bdd1*f*(6*C - 5)*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*D1**2*(3*f*fd - 5*f*fdd - 5*fd**2)*(6*C*(2*r + s - 1) - 2*r**2 - r*(2*s + 9) - 5*s + 5) - 7*D1*bd1*(6*C - 5)*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 5*fd*(-24*C*(2*r + s - 1) + 16*r**2 + 4*r*(4*s + 7) + 18*s - 19)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + f*(21*D1**2*bd1**2*(6*C - 5)*(2*r**2 + 2*r*(s - 1) - s) + 15*D1**2*bdd1*f*(6*C*(2*r + s - 1) + r**2 + r*(s - 12) - 6*s + 6) - 3*D1*bd1*(D1*(3*f*(6*C*(2*r + s - 1) + r**2 + r*(s - 12) - 6*s + 6) - 5*fd*(6*C*(2*r + s - 1) + 4*r**2 + r*(4*s - 15) - 7*s + 6)) - 5*Dd*f*(24*C*(2*r + s - 1) + 8*r**2 + r*(8*s - 52) - 25*s + 24)) + 5*(2*C - 2)*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 7*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 7*fd*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 7*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 7*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2))))/(105*d**2*k3**3) - 2*D1**2*Pkd1*Pkd3*ct**4*k2**4*st**2*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 69*D1**2*f**2*fd*r**2 + 69*D1**2*f**2*fd*r*s - 69*D1**2*f**2*fd*r - 23*D1**2*f**2*fd*s + 23*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 92*D1*Dd*f**3*r**2 + 92*D1*Dd*f**3*r*s - 92*D1*Dd*f**3*r - 23*D1*Dd*f**3*s + 23*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 600*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s - 125*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 300*Dd**2*f**3*r + 75*Dd**2*f**3*s - 50*Dd**2*f**3)/(315*d**2*k1*k3**3) + D1**2*Pkd1*Pkd3*ct**4*k2**4*(D1*f*(9*D1*bd1**2*(5*f*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + (14*r - 7)*(r + s - 1)) + 5*D1*bdd1*f*r*(7*f*(2*r + 2*s - 1) + 9*r + 9*s - 9) + bd1*(D1*(-f*r*(25*f*(2*r + 2*s - 1) + 27*r + 27*s - 27) + 5*fd*(7*f*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1) + 36*r**2 + 36*r*(s - 1) - 9*s + 9)) + 5*Dd*f*(7*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 72*r**2 + 72*r*(s - 1) - 9*s + 9))) - 3*b1**2*(D1**2*r*(3*f*(3*fd - 5*fdd)*(4*r + 4*s - 3) - 15*fd**2*(4*r + 4*s - 3) + 7*fd*(r + s) - 21*fdd*(r + s)) + D1*(Dd*(18*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-15*fd*(8*r - 1)*(4*r + 4*s - 3) + 28*r**2 + 28*r*(s - 1) - 7*s + 7) - 21*fd*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(10*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(10*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(9*D1**2*bdd1*f*(5*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + (14*r - 7)*(r + s - 1)) - 150*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s + 175*D1**2*f**2*fd*r + 50*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r**2 + 210*D1**2*f**2*fdd*r*s - 245*D1**2*f**2*fdd*r - 70*D1**2*f**2*fdd*s + 70*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r**2 + 420*D1**2*f*fd**2*r*s - 490*D1**2*f*fd**2*r - 140*D1**2*f*fd**2*s + 105*D1**2*f*fd**2 - 54*D1**2*f*fd*r**2 - 54*D1**2*f*fd*r*s + 54*D1**2*f*fd*r + 27*D1**2*f*fd*s - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 90*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r - 45*D1**2*f*fdd*s + 45*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 90*D1**2*fd**2*r*s - 90*D1**2*fd**2*r - 45*D1**2*fd**2*s - 200*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 200*D1*Dd*f**3*r + 50*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r**2 + 1680*D1*Dd*f**2*fd*r*s - 1820*D1*Dd*f**2*fd*r - 490*D1*Dd*f**2*fd*s + 385*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 - 108*D1*Dd*f**2*r*s + 108*D1*Dd*f**2*r + 27*D1*Dd*f**2*s - 27*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 720*D1*Dd*f*fd*r*s - 720*D1*Dd*f*fd*r - 270*D1*Dd*f*fd*s + 180*D1*Dd*f*fd + 280*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r - 70*D1*Ddd*f**3*s + 70*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 + 180*D1*Ddd*f**2*r*s - 180*D1*Ddd*f**2*r - 45*D1*Ddd*f**2*s + 45*D1*Ddd*f**2 - 3*D1*bd1*(D1*(9*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(-15*fd*(4*r - 1)*(4*r + 4*s - 3) + (14*r - 7)*(r + s - 1)) + 21*fd*(-4*r**2 + r*(3 - 4*s) + s)) - 3*Dd*f*(5*f*(8*r - 3)*(4*r + 4*s - 3) + 112*r**2 + 28*r*(4*s - 5) - 42*s + 35)) + 840*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r*s - 840*Dd**2*f**3*r - 210*Dd**2*f**3*s + 140*Dd**2*f**3 + 540*Dd**2*f**2*r**2 + 540*Dd**2*f**2*r*s - 540*Dd**2*f**2*r - 135*Dd**2*f**2*s + 90*Dd**2*f**2))/(315*d**2*k1*k3**3) + D1**2*Pkd1*Pkd3*ct**4*k2**2*(3*D1*f*(7*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + 5*D1*bdd1*f*r*(r + s) + bd1*(D1*(-3*f*r*(r + s) + 5*fd*(4*r**2 + 4*r*s - 3*r - s)) + 5*Dd*f*(8*r**2 + r*(8*s - 4) - s))) - 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(21*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*D1**2*(2*r - 1)*(r + s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) - 7*D1*bd1*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 5*fd*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(105*d**2*k1*k3) - D1**2*Pkd1*Pkd3*ct**3*k1**4*k2*(10*C - 6)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct**3*k1**2*k2**3*st**2*(426*C*D1**2*b1*f*fd*r**2 + 426*C*D1**2*b1*f*fd*r*s - 213*C*D1**2*b1*f*fd*r - 990*C*D1**2*b1*f*fdd*r**2 - 990*C*D1**2*b1*f*fdd*r*s + 495*C*D1**2*b1*f*fdd*r - 990*C*D1**2*b1*fd**2*r**2 - 990*C*D1**2*b1*fd**2*r*s + 495*C*D1**2*b1*fd**2*r + 651*C*D1**2*f**2*fd*r**2 + 651*C*D1**2*f**2*fd*r*s - 651*C*D1**2*f**2*fd*r - 217*C*D1**2*f**2*fd*s + 217*C*D1**2*f**2*fd - 825*C*D1**2*f**2*fdd*r**2 - 825*C*D1**2*f**2*fdd*r*s + 825*C*D1**2*f**2*fdd*r + 275*C*D1**2*f**2*fdd*s - 275*C*D1**2*f**2*fdd - 1650*C*D1**2*f*fd**2*r**2 - 1650*C*D1**2*f*fd**2*r*s + 1650*C*D1**2*f*fd**2*r + 550*C*D1**2*f*fd**2*s - 275*C*D1**2*f*fd**2 + 852*C*D1*Dd*b1*f**2*r**2 + 852*C*D1*Dd*b1*f**2*r*s - 852*C*D1*Dd*b1*f**2*r - 213*C*D1*Dd*b1*f**2*s + 213*C*D1*Dd*b1*f**2 - 7920*C*D1*Dd*b1*f*fd*r**2 - 7920*C*D1*Dd*b1*f*fd*r*s + 5940*C*D1*Dd*b1*f*fd*r + 990*C*D1*Dd*b1*f*fd*s - 495*C*D1*Dd*b1*f*fd + 868*C*D1*Dd*f**3*r**2 + 868*C*D1*Dd*f**3*r*s - 868*C*D1*Dd*f**3*r - 217*C*D1*Dd*f**3*s + 217*C*D1*Dd*f**3 - 6600*C*D1*Dd*f**2*fd*r**2 - 6600*C*D1*Dd*f**2*fd*r*s + 6600*C*D1*Dd*f**2*fd*r + 1925*C*D1*Dd*f**2*fd*s - 1375*C*D1*Dd*f**2*fd - 1980*C*D1*Ddd*b1*f**2*r**2 - 1980*C*D1*Ddd*b1*f**2*r*s + 1980*C*D1*Ddd*b1*f**2*r + 495*C*D1*Ddd*b1*f**2*s - 495*C*D1*Ddd*b1*f**2 - 1100*C*D1*Ddd*f**3*r**2 - 1100*C*D1*Ddd*f**3*r*s + 1100*C*D1*Ddd*f**3*r + 275*C*D1*Ddd*f**3*s - 275*C*D1*Ddd*f**3 - 5940*C*Dd**2*b1*f**2*r**2 - 5940*C*Dd**2*b1*f**2*r*s + 5940*C*Dd**2*b1*f**2*r + 1485*C*Dd**2*b1*f**2*s - 990*C*Dd**2*b1*f**2 - 3300*C*Dd**2*f**3*r**2 - 3300*C*Dd**2*f**3*r*s + 3300*C*Dd**2*f**3*r + 825*C*Dd**2*f**3*s - 550*C*Dd**2*f**3 - 300*D1**2*b1*f*fd*r**2 - 300*D1**2*b1*f*fd*r*s + 150*D1**2*b1*f*fd*r + 738*D1**2*b1*f*fdd*r**2 + 738*D1**2*b1*f*fdd*r*s - 369*D1**2*b1*f*fdd*r + 738*D1**2*b1*fd**2*r**2 + 738*D1**2*b1*fd**2*r*s - 369*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(55*C - 41)*(r - 1)*(r + s - 1) - 474*D1**2*f**2*fd*r**2 - 474*D1**2*f**2*fd*r*s + 474*D1**2*f**2*fd*r + 158*D1**2*f**2*fd*s - 158*D1**2*f**2*fd + 615*D1**2*f**2*fdd*r**2 + 615*D1**2*f**2*fdd*r*s - 615*D1**2*f**2*fdd*r - 205*D1**2*f**2*fdd*s + 205*D1**2*f**2*fdd + 1230*D1**2*f*fd**2*r**2 + 1230*D1**2*f*fd**2*r*s - 1230*D1**2*f*fd**2*r - 410*D1**2*f*fd**2*s + 205*D1**2*f*fd**2 - 600*D1*Dd*b1*f**2*r**2 - 600*D1*Dd*b1*f**2*r*s + 600*D1*Dd*b1*f**2*r + 150*D1*Dd*b1*f**2*s - 150*D1*Dd*b1*f**2 + 5904*D1*Dd*b1*f*fd*r**2 + 5904*D1*Dd*b1*f*fd*r*s - 4428*D1*Dd*b1*f*fd*r - 738*D1*Dd*b1*f*fd*s + 369*D1*Dd*b1*f*fd - 632*D1*Dd*f**3*r**2 - 632*D1*Dd*f**3*r*s + 632*D1*Dd*f**3*r + 158*D1*Dd*f**3*s - 158*D1*Dd*f**3 + 4920*D1*Dd*f**2*fd*r**2 + 4920*D1*Dd*f**2*fd*r*s - 4920*D1*Dd*f**2*fd*r - 1435*D1*Dd*f**2*fd*s + 1025*D1*Dd*f**2*fd + 1476*D1*Ddd*b1*f**2*r**2 + 1476*D1*Ddd*b1*f**2*r*s - 1476*D1*Ddd*b1*f**2*r - 369*D1*Ddd*b1*f**2*s + 369*D1*Ddd*b1*f**2 + 820*D1*Ddd*f**3*r**2 + 820*D1*Ddd*f**3*r*s - 820*D1*Ddd*f**3*r - 205*D1*Ddd*f**3*s + 205*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(71*C - 50)*(r - 1)*(r + s - 1) - fd*(165*C - 123)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(123 - 165*C)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 4428*Dd**2*b1*f**2*r**2 + 4428*Dd**2*b1*f**2*r*s - 4428*Dd**2*b1*f**2*r - 1107*Dd**2*b1*f**2*s + 738*Dd**2*b1*f**2 + 2460*Dd**2*f**3*r**2 + 2460*Dd**2*f**3*r*s - 2460*Dd**2*f**3*r - 615*Dd**2*f**3*s + 410*Dd**2*f**3)/(315*d**2*k3**5) + 2*D1**2*Pkd1*Pkd3*ct**3*k1**2*k2**3*(-99*D1**2*bd1**2*f*(2*r - 1)*(-35*K + 15*f + 21)*(r + s - 1) - 55*D1**2*bdd1*f*(r + s - 1)*(7*f**2*(r + 2) - 9*f*r*(5*K - 3) + 126*g2*(r - 1)) - 10*D1**2*(7*f**3*(7*fd - 9*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 9*f**2*(7*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + r*(33*gd2 - 55*gdd2)*(r + s - 1)) - 99*f*(fd*(g2*(6*r**2 + 6*r*(s - 1) - 3*s + 3) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 495*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) + 11*D1*bd1*(D1*(25*f**3*(r + 2)*(r + s - 1) + f**2*(-35*fd*(6*r**2 + r*(6*s - 2) + 3*s - 1) + r*(81 - 135*K)*(r + s - 1)) + 15*f*(3*fd*(5*K - 3)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) - 630*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(7*f**2*(8*r**2 + 8*r*s + 7*s - 5) - 9*f*(5*K - 3)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 10*D1*f*(Dd*(49*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 126*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 99*f*(3*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 990*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 9*Ddd*f*(7*f**2 - 55*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 90*Dd**2*f**2*(7*f**2 - 55*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 33*b1**2*(D1**2*r*(9*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 45*fd**2*(2*r + 2*s - 1) - 7*fd*(5*K - 3)*(r + s) + 21*fdd*(5*K - 3)*(r + s)) + D1*(Dd*(27*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-45*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (21 - 35*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(5*K - 3)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-35*K + 15*f + 21)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-35*K + 15*f + 21)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-270*D1**2*K*f*fd*r**2 - 270*D1**2*K*f*fd*r*s + 270*D1**2*K*f*fd*r + 135*D1**2*K*f*fd*s - 135*D1**2*K*f*fd + 450*D1**2*K*f*fdd*r**2 + 450*D1**2*K*f*fdd*r*s - 450*D1**2*K*f*fdd*r - 225*D1**2*K*f*fdd*s + 225*D1**2*K*f*fdd + 450*D1**2*K*fd**2*r**2 + 450*D1**2*K*fd**2*r*s - 450*D1**2*K*fd**2*r - 225*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*r - 1)*(-35*K + 15*f + 21)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 125*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s + 75*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 175*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s - 105*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 350*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s - 105*D1**2*f*fd**2 + 162*D1**2*f*fd*r**2 + 162*D1**2*f*fd*r*s - 162*D1**2*f*fd*r - 81*D1**2*f*fd*s + 81*D1**2*f*fd - 270*D1**2*f*fdd*r**2 - 270*D1**2*f*fdd*r*s + 270*D1**2*f*fdd*r + 135*D1**2*f*fdd*s - 135*D1**2*f*fdd + 210*D1**2*f*gd2*r**2 + 210*D1**2*f*gd2*r*s - 210*D1**2*f*gd2*r - 630*D1**2*f*gdd2*r**2 - 630*D1**2*f*gdd2*r*s + 630*D1**2*f*gdd2*r - 270*D1**2*fd**2*r**2 - 270*D1**2*fd**2*r*s + 270*D1**2*fd**2*r + 135*D1**2*fd**2*s + 210*D1**2*fd*g2*r**2 + 210*D1**2*fd*g2*r*s - 1260*D1**2*fd*gd2*r**2 - 1260*D1**2*fd*gd2*r*s + 630*D1**2*fd*gd2*r - 630*D1**2*fdd*g2*r**2 - 630*D1**2*fdd*g2*r*s - 540*D1*Dd*K*f**2*r**2 - 540*D1*Dd*K*f**2*r*s + 540*D1*Dd*K*f**2*r + 135*D1*Dd*K*f**2*s - 135*D1*Dd*K*f**2 + 3600*D1*Dd*K*f*fd*r**2 + 3600*D1*Dd*K*f*fd*r*s - 3600*D1*Dd*K*f*fd*r - 1350*D1*Dd*K*f*fd*s + 900*D1*Dd*K*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 1120*D1*Dd*f**2*fd*r + 525*D1*Dd*f**2*fd*s - 385*D1*Dd*f**2*fd + 324*D1*Dd*f**2*r**2 + 324*D1*Dd*f**2*r*s - 324*D1*Dd*f**2*r - 81*D1*Dd*f**2*s + 81*D1*Dd*f**2 - 2160*D1*Dd*f*fd*r**2 - 2160*D1*Dd*f*fd*r*s + 2160*D1*Dd*f*fd*r + 810*D1*Dd*f*fd*s - 540*D1*Dd*f*fd + 840*D1*Dd*f*g2*r**2 + 840*D1*Dd*f*g2*r*s - 840*D1*Dd*f*g2*r - 210*D1*Dd*f*g2*s + 210*D1*Dd*f*g2 - 5040*D1*Dd*f*gd2*r**2 - 5040*D1*Dd*f*gd2*r*s + 5040*D1*Dd*f*gd2*r + 630*D1*Dd*f*gd2*s - 630*D1*Dd*f*gd2 - 5040*D1*Dd*fd*g2*r**2 - 5040*D1*Dd*fd*g2*r*s + 2520*D1*Dd*fd*g2*r + 630*D1*Dd*fd*g2*s + 900*D1*Ddd*K*f**2*r**2 + 900*D1*Ddd*K*f**2*r*s - 900*D1*Ddd*K*f**2*r - 225*D1*Ddd*K*f**2*s + 225*D1*Ddd*K*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 540*D1*Ddd*f**2*r**2 - 540*D1*Ddd*f**2*r*s + 540*D1*Ddd*f**2*r + 135*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 2520*D1*Ddd*f*g2*r**2 - 2520*D1*Ddd*f*g2*r*s + 2520*D1*Ddd*f*g2*r + 630*D1*Ddd*f*g2*s - 630*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(27*f**2*(2*r - 1)*(r + s - 1) + f*(-45*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (35*K - 21)*(2*r - 1)*(r + s - 1)) + 21*fd*(5*K - 3)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-35*K + 15*f + 21)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 2700*Dd**2*K*f**2*r**2 + 2700*Dd**2*K*f**2*r*s - 2700*Dd**2*K*f**2*r - 675*Dd**2*K*f**2*s + 450*Dd**2*K*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3 - 1620*Dd**2*f**2*r**2 - 1620*Dd**2*f**2*r*s + 1620*Dd**2*f**2*r + 405*Dd**2*f**2*s - 270*Dd**2*f**2 - 7560*Dd**2*f*g2*r**2 - 7560*Dd**2*f*g2*r*s + 7560*Dd**2*f*g2*r + 1890*Dd**2*f*g2*s - 1260*Dd**2*f*g2))/(3465*d**2*k3**5) - D1**2*Pkd1*Pkd3*ct**3*k1**2*k2*(6*C - 4)*(3*D1*b1*(-21*D1*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 7*bd1*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + (3*D1*(-3*f*fd + 5*f*fdd + 5*fd**2) + 60*Dd*f*fd)*(2*r + s - 1)) + 21*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + f*(-63*D1**2*bd1**2*(2*r**2 + 2*r*(s - 1) - s) - 45*D1**2*bdd1*f*(2*r + s - 1) - 5*D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 7*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + 9*D1*bd1*(2*r + s - 1)*(3*D1*f - 5*D1*fd - 20*Dd*f) - 5*D1*f*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 7*fd*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 7*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 35*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(315*d**2*k3**3) - D1**2*Pkd1*Pkd3*ct**3*k2**5*st**4*(2*C - 2)*(18*D1**2*b1*f*fd*r**2 + 18*D1**2*b1*f*fd*r*s - 9*D1**2*b1*f*fd*r - 30*D1**2*b1*f*fdd*r**2 - 30*D1**2*b1*f*fdd*r*s + 15*D1**2*b1*f*fdd*r - 30*D1**2*b1*fd**2*r**2 - 30*D1**2*b1*fd**2*r*s + 15*D1**2*b1*fd**2*r - 15*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 21*D1**2*f**2*fd*r**2 + 21*D1**2*f**2*fd*r*s - 21*D1**2*f**2*fd*r - 7*D1**2*f**2*fd*s + 7*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 15*D1**2*f**2*fdd*r*s + 15*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd - 30*D1**2*f*fd**2*r**2 - 30*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r + 10*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 + 36*D1*Dd*b1*f**2*r**2 + 36*D1*Dd*b1*f**2*r*s - 36*D1*Dd*b1*f**2*r - 9*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 - 240*D1*Dd*b1*f*fd*r**2 - 240*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r + 30*D1*Dd*b1*f*fd*s - 15*D1*Dd*b1*f*fd + 28*D1*Dd*f**3*r**2 + 28*D1*Dd*f**3*r*s - 28*D1*Dd*f**3*r - 7*D1*Dd*f**3*s + 7*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 120*D1*Dd*f**2*fd*r*s + 120*D1*Dd*f**2*fd*r + 35*D1*Dd*f**2*fd*s - 25*D1*Dd*f**2*fd - 60*D1*Ddd*b1*f**2*r**2 - 60*D1*Ddd*b1*f**2*r*s + 60*D1*Ddd*b1*f**2*r + 15*D1*Ddd*b1*f**2*s - 15*D1*Ddd*b1*f**2 - 20*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r + 5*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 180*Dd**2*b1*f**2*r**2 - 180*Dd**2*b1*f**2*r*s + 180*Dd**2*b1*f**2*r + 45*Dd**2*b1*f**2*s - 30*Dd**2*b1*f**2 - 60*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r*s + 60*Dd**2*f**3*r + 15*Dd**2*f**3*s - 10*Dd**2*f**3)/(105*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**3*k2**5*st**2*(297*D1**2*K*bdd1*f**2*r**2 + 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*r - 99*D1**2*bd1**2*f*(2*r - 1)*(-7*K + 10*f + 7)*(r + s - 1) + 1650*D1**2*bdd1*f**3*r**2 + 1650*D1**2*bdd1*f**3*r*s - 3850*D1**2*bdd1*f**3*r - 2200*D1**2*bdd1*f**3*s + 2200*D1**2*bdd1*f**3 - 297*D1**2*bdd1*f**2*r**2 - 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*r - 1386*D1**2*bdd1*f*g2*r**2 - 1386*D1**2*bdd1*f*g2*r*s + 2772*D1**2*bdd1*f*g2*r + 1386*D1**2*bdd1*f*g2*s - 1386*D1**2*bdd1*f*g2 - 5040*D1**2*f**3*fd*r**2 - 5040*D1**2*f**3*fd*r*s + 5040*D1**2*f**3*fd*r + 1260*D1**2*f**3*fd*s - 1260*D1**2*f**3*fd + 5600*D1**2*f**3*fdd*r**2 + 5600*D1**2*f**3*fdd*r*s - 5600*D1**2*f**3*fdd*r - 1400*D1**2*f**3*fdd*s + 1400*D1**2*f**3*fdd + 16800*D1**2*f**2*fd**2*r**2 + 16800*D1**2*f**2*fd**2*r*s - 16800*D1**2*f**2*fd**2*r - 4200*D1**2*f**2*fd**2*s + 2800*D1**2*f**2*fd**2 + 726*D1**2*f**2*gd2*r**2 + 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*r - 594*D1**2*f**2*gdd2*r**2 - 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*r + 1452*D1**2*f*fd*g2*r**2 + 1452*D1**2*f*fd*g2*r*s - 1452*D1**2*f*fd*g2*r - 726*D1**2*f*fd*g2*s + 726*D1**2*f*fd*g2 - 2376*D1**2*f*fd*gd2*r**2 - 2376*D1**2*f*fd*gd2*r*s + 2376*D1**2*f*fd*gd2*r + 594*D1**2*f*fd*gd2*s - 594*D1**2*f*fd*gd2 - 1188*D1**2*f*fdd*g2*r**2 - 1188*D1**2*f*fdd*g2*r*s + 1188*D1**2*f*fdd*g2*r + 594*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 1188*D1**2*fd**2*g2*r**2 - 1188*D1**2*fd**2*g2*r*s + 1188*D1**2*fd**2*g2*r + 594*D1**2*fd**2*g2*s - 5040*D1*Dd*f**4*r**2 - 5040*D1*Dd*f**4*r*s + 5040*D1*Dd*f**4*r + 1260*D1*Dd*f**4*s - 1260*D1*Dd*f**4 + 44800*D1*Dd*f**3*fd*r**2 + 44800*D1*Dd*f**3*fd*r*s - 44800*D1*Dd*f**3*fd*r - 11200*D1*Dd*f**3*fd*s + 8400*D1*Dd*f**3*fd + 2904*D1*Dd*f**2*g2*r**2 + 2904*D1*Dd*f**2*g2*r*s - 2904*D1*Dd*f**2*g2*r - 726*D1*Dd*f**2*g2*s + 726*D1*Dd*f**2*g2 - 4752*D1*Dd*f**2*gd2*r**2 - 4752*D1*Dd*f**2*gd2*r*s + 4752*D1*Dd*f**2*gd2*r + 594*D1*Dd*f**2*gd2*s - 594*D1*Dd*f**2*gd2 - 9504*D1*Dd*f*fd*g2*r**2 - 9504*D1*Dd*f*fd*g2*r*s + 9504*D1*Dd*f*fd*g2*r + 3564*D1*Dd*f*fd*g2*s - 2376*D1*Dd*f*fd*g2 + 5600*D1*Ddd*f**4*r**2 + 5600*D1*Ddd*f**4*r*s - 5600*D1*Ddd*f**4*r - 1400*D1*Ddd*f**4*s + 1400*D1*Ddd*f**4 - 2376*D1*Ddd*f**2*g2*r**2 - 2376*D1*Ddd*f**2*g2*r*s + 2376*D1*Ddd*f**2*g2*r + 594*D1*Ddd*f**2*g2*s - 594*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(2*f**3*(51*r - 74)*(r + s - 1) + f**2*(-50*fd*(18*r**2 + 2*r*(9*s - 13) - 11*s + 7) + r*(33*K - 33)*(r + s - 1)) - 3*f*(9*fd*(K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) + 126*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-50*f**2*(24*r**2 + 8*r*(3*s - 5) - 19*s + 15) - 27*f*(K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 16800*Dd**2*f**4*r**2 + 16800*Dd**2*f**4*r*s - 16800*Dd**2*f**4*r - 4200*Dd**2*f**4*s + 2800*Dd**2*f**4 - 7128*Dd**2*f**2*g2*r**2 - 7128*Dd**2*f**2*g2*r*s + 7128*Dd**2*f**2*g2*r + 1782*Dd**2*f**2*g2*s - 1188*Dd**2*f**2*g2 + 33*b1**2*(D1**2*r*(6*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 30*fd**2*(2*r + 2*s - 1) - 7*fd*(K - 1)*(r + s) + 21*fdd*(K - 1)*(r + s)) + D1*(Dd*(18*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-30*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (7 - 7*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(K - 1)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-7*K + 10*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-7*K + 10*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-66*D1**2*K*f*fd*r**2 - 66*D1**2*K*f*fd*r*s + 66*D1**2*K*f*fd*r + 33*D1**2*K*f*fd*s - 33*D1**2*K*f*fd + 54*D1**2*K*f*fdd*r**2 + 54*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r - 27*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 54*D1**2*K*fd**2*r**2 + 54*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r - 27*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*r - 1)*(-7*K + 10*f + 7)*(r + s - 1) - 306*D1**2*f**2*fd*r**2 - 306*D1**2*f**2*fd*r*s + 158*D1**2*f**2*fd*r - 46*D1**2*f**2*fd*s + 46*D1**2*f**2*fd + 450*D1**2*f**2*fdd*r**2 + 450*D1**2*f**2*fdd*r*s - 250*D1**2*f**2*fdd*r + 50*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd + 900*D1**2*f*fd**2*r**2 + 900*D1**2*f*fd**2*r*s - 500*D1**2*f*fd**2*r + 100*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 66*D1**2*f*fd*r**2 + 66*D1**2*f*fd*r*s - 66*D1**2*f*fd*r - 33*D1**2*f*fd*s + 33*D1**2*f*fd - 54*D1**2*f*fdd*r**2 - 54*D1**2*f*fdd*r*s + 54*D1**2*f*fdd*r + 27*D1**2*f*fdd*s - 27*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r - 126*D1**2*f*gdd2*r**2 - 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*r - 54*D1**2*fd**2*r**2 - 54*D1**2*fd**2*r*s + 54*D1**2*fd**2*r + 27*D1**2*fd**2*s + 42*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s - 252*D1**2*fd*gd2*r**2 - 252*D1**2*fd*gd2*r*s + 126*D1**2*fd*gd2*r - 126*D1**2*fdd*g2*r**2 - 126*D1**2*fdd*g2*r*s - 132*D1*Dd*K*f**2*r**2 - 132*D1*Dd*K*f**2*r*s + 132*D1*Dd*K*f**2*r + 33*D1*Dd*K*f**2*s - 33*D1*Dd*K*f**2 + 432*D1*Dd*K*f*fd*r**2 + 432*D1*Dd*K*f*fd*r*s - 432*D1*Dd*K*f*fd*r - 162*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd - 408*D1*Dd*f**3*r**2 - 408*D1*Dd*f**3*r*s + 408*D1*Dd*f**3*r + 102*D1*Dd*f**3*s - 102*D1*Dd*f**3 + 3600*D1*Dd*f**2*fd*r**2 + 3600*D1*Dd*f**2*fd*r*s - 2800*D1*Dd*f**2*fd*r - 250*D1*Dd*f**2*fd*s + 150*D1*Dd*f**2*fd + 132*D1*Dd*f**2*r**2 + 132*D1*Dd*f**2*r*s - 132*D1*Dd*f**2*r - 33*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 432*D1*Dd*f*fd*r**2 - 432*D1*Dd*f*fd*r*s + 432*D1*Dd*f*fd*r + 162*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 42*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r + 126*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r + 126*D1*Dd*fd*g2*s + 108*D1*Ddd*K*f**2*r**2 + 108*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r - 27*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 + 600*D1*Ddd*f**3*r**2 + 600*D1*Ddd*f**3*r*s - 600*D1*Ddd*f**3*r - 150*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 - 108*D1*Ddd*f**2*r**2 - 108*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r + 27*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 504*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 126*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(18*f**2*(2*r - 1)*(r + s - 1) + f*(-30*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (7*K - 7)*(2*r - 1)*(r + s - 1)) + 21*fd*(K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-7*K + 10*f + 7)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 324*Dd**2*K*f**2*r**2 + 324*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r - 81*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 + 1800*Dd**2*f**3*r**2 + 1800*Dd**2*f**3*r*s - 1800*Dd**2*f**3*r - 450*Dd**2*f**3*s + 300*Dd**2*f**3 - 324*Dd**2*f**2*r**2 - 324*Dd**2*f**2*r*s + 324*Dd**2*f**2*r + 81*Dd**2*f**2*s - 54*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 1512*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 378*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(3465*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct**3*k2**3*st**2*(21*b1**2*(C - 1)*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1*(-14*C*D1**2*f*fd*r**2 - 14*C*D1**2*f*fd*r*s - 15*C*D1**2*f*fd*r - 11*C*D1**2*f*fd*s + 11*C*D1**2*f*fd + 42*C*D1**2*f*fdd*r**2 + 42*C*D1**2*f*fdd*r*s - 3*C*D1**2*f*fdd*r + 9*C*D1**2*f*fdd*s - 9*C*D1**2*f*fdd + 42*C*D1**2*fd**2*r**2 + 42*C*D1**2*fd**2*r*s - 3*C*D1**2*fd**2*r + 9*C*D1**2*fd**2*s - 9*C*D1**2*fd**2 - 28*C*D1*Dd*f**2*r**2 - 28*C*D1*Dd*f**2*r*s + 28*C*D1*Dd*f**2*r + 7*C*D1*Dd*f**2*s - 7*C*D1*Dd*f**2 + 336*C*D1*Dd*f*fd*r**2 + 336*C*D1*Dd*f*fd*r*s - 180*C*D1*Dd*f*fd*r - 6*C*D1*Dd*f*fd*s - 15*C*D1*Dd*f*fd + 84*C*D1*Ddd*f**2*r**2 + 84*C*D1*Ddd*f**2*r*s - 84*C*D1*Ddd*f**2*r - 21*C*D1*Ddd*f**2*s + 21*C*D1*Ddd*f**2 + 252*C*Dd**2*f**2*r**2 + 252*C*Dd**2*f**2*r*s - 252*C*Dd**2*f**2*r - 63*C*Dd**2*f**2*s + 42*C*Dd**2*f**2 - 21*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 20*D1**2*f*fd*r**2 + 20*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 11*D1**2*f*fd*s - 11*D1**2*f*fd - 66*D1**2*f*fdd*r**2 - 66*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd - 66*D1**2*fd**2*r**2 - 66*D1**2*fd**2*r*s + 15*D1**2*fd**2*r - 9*D1**2*fd**2*s + 9*D1**2*fd**2 + 40*D1*Dd*f**2*r**2 + 40*D1*Dd*f**2*r*s - 40*D1*Dd*f**2*r - 10*D1*Dd*f**2*s + 10*D1*Dd*f**2 - 528*D1*Dd*f*fd*r**2 - 528*D1*Dd*f*fd*r*s + 324*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s + 3*D1*Dd*f*fd - 132*D1*Ddd*f**2*r**2 - 132*D1*Ddd*f**2*r*s + 132*D1*Ddd*f**2*r + 33*D1*Ddd*f**2*s - 33*D1*Ddd*f**2 + 7*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 396*Dd**2*f**2*r**2 - 396*Dd**2*f**2*r*s + 396*Dd**2*f**2*r + 99*Dd**2*f**2*s - 66*Dd**2*f**2) + f*(-138*C*D1**2*f*fd*r**2 - 138*C*D1**2*f*fd*r*s + 138*C*D1**2*f*fd*r + 46*C*D1**2*f*fd*s - 46*C*D1**2*f*fd + 150*C*D1**2*f*fdd*r**2 + 150*C*D1**2*f*fdd*r*s - 150*C*D1**2*f*fdd*r - 50*C*D1**2*f*fdd*s + 50*C*D1**2*f*fdd + 300*C*D1**2*fd**2*r**2 + 300*C*D1**2*fd**2*r*s - 300*C*D1**2*fd**2*r - 100*C*D1**2*fd**2*s + 50*C*D1**2*fd**2 - 184*C*D1*Dd*f**2*r**2 - 184*C*D1*Dd*f**2*r*s + 184*C*D1*Dd*f**2*r + 46*C*D1*Dd*f**2*s - 46*C*D1*Dd*f**2 + 1200*C*D1*Dd*f*fd*r**2 + 1200*C*D1*Dd*f*fd*r*s - 1200*C*D1*Dd*f*fd*r - 350*C*D1*Dd*f*fd*s + 250*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*r**2 + 200*C*D1*Ddd*f**2*r*s - 200*C*D1*Ddd*f**2*r - 50*C*D1*Ddd*f**2*s + 50*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*r**2 + 600*C*Dd**2*f**2*r*s - 600*C*Dd**2*f**2*r - 150*C*Dd**2*f**2*s + 100*C*Dd**2*f**2 - 63*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 9*D1**2*bdd1*f*(C*(7*r**2 + 7*r*s - 20*r - 10*s + 10) - 11*r**2 - 11*r*s + 28*r + 14*s - 14) + 177*D1**2*f*fd*r**2 + 177*D1**2*f*fd*r*s - 177*D1**2*f*fd*r - 59*D1**2*f*fd*s + 59*D1**2*f*fd - 210*D1**2*f*fdd*r**2 - 210*D1**2*f*fdd*r*s + 210*D1**2*f*fdd*r + 70*D1**2*f*fdd*s - 70*D1**2*f*fdd - 420*D1**2*fd**2*r**2 - 420*D1**2*fd**2*r*s + 420*D1**2*fd**2*r + 140*D1**2*fd**2*s - 70*D1**2*fd**2 + 236*D1*Dd*f**2*r**2 + 236*D1*Dd*f**2*r*s - 236*D1*Dd*f**2*r - 59*D1*Dd*f**2*s + 59*D1*Dd*f**2 - 1680*D1*Dd*f*fd*r**2 - 1680*D1*Dd*f*fd*r*s + 1680*D1*Dd*f*fd*r + 490*D1*Dd*f*fd*s - 350*D1*Dd*f*fd - 280*D1*Ddd*f**2*r**2 - 280*D1*Ddd*f**2*r*s + 280*D1*Ddd*f**2*r + 70*D1*Ddd*f**2*s - 70*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(C*(7*r**2 + 7*r*s - 36*r - 18*s + 18) - 10*r**2 - 10*r*s + 42*r + 21*s - 21) - 3*fd*(C*(28*r**2 + 28*r*s - 41*r - 17*s + 10) - 44*r**2 - 44*r*s + 61*r + 25*s - 14)) - 3*Dd*f*(C*(56*r**2 + 56*r*s - 108*r - 47*s + 40) - 88*r**2 - 88*r*s + 156*r + 67*s - 56)) - 840*Dd**2*f**2*r**2 - 840*Dd**2*f**2*r*s + 840*Dd**2*f**2*r + 210*Dd**2*f**2*s - 140*Dd**2*f**2))/(315*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct**3*k2**3*(126*D1**2*K*bd1**2*f*r + 63*D1**2*K*bd1**2*f*s - 63*D1**2*K*bd1**2*f + 27*D1**2*K*bd1*f**2*r**2 + 27*D1**2*K*bd1*f**2*r*s - 27*D1**2*K*bd1*f**2*r - 180*D1**2*K*bd1*f*fd*r**2 - 180*D1**2*K*bd1*f*fd*r*s + 180*D1**2*K*bd1*f*fd*r + 45*D1**2*K*bd1*f*fd*s - 45*D1**2*K*bd1*f*fd - 45*D1**2*K*bdd1*f**2*r**2 - 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*r + 360*D1**2*bd1**2*f**2*r**2 + 360*D1**2*bd1**2*f**2*r*s - 540*D1**2*bd1**2*f**2*r - 225*D1**2*bd1**2*f**2*s + 135*D1**2*bd1**2*f**2 + 252*D1**2*bd1**2*f*r**2 + 252*D1**2*bd1**2*f*r*s - 504*D1**2*bd1**2*f*r - 189*D1**2*bd1**2*f*s + 189*D1**2*bd1**2*f - 420*D1**2*bd1**2*g2*r**2 - 420*D1**2*bd1**2*g2*r*s + 420*D1**2*bd1**2*g2*r + 210*D1**2*bd1**2*g2*s - 126*D1**2*bd1*bd2*f*r**2 - 126*D1**2*bd1*bd2*f*r*s + 189*D1**2*bd1*bd2*f*r + 63*D1**2*bd1*bd2*f*s - 63*D1**2*bd1*bd2*f - 125*D1**2*bd1*f**3*r**2 - 125*D1**2*bd1*f**3*r*s + 75*D1**2*bd1*f**3*r + 1050*D1**2*bd1*f**2*fd*r**2 + 1050*D1**2*bd1*f**2*fd*r*s - 910*D1**2*bd1*f**2*fd*r - 175*D1**2*bd1*f**2*fd*s + 105*D1**2*bd1*f**2*fd - 81*D1**2*bd1*f**2*r**2 - 81*D1**2*bd1*f**2*r*s + 81*D1**2*bd1*f**2*r + 540*D1**2*bd1*f*fd*r**2 + 540*D1**2*bd1*f*fd*r*s - 540*D1**2*bd1*f*fd*r - 135*D1**2*bd1*f*fd*s + 135*D1**2*bd1*f*fd + 84*D1**2*bd1*f*g2*r + 42*D1**2*bd1*f*g2*s - 42*D1**2*bd1*f*g2 - 252*D1**2*bd1*f*gd2*r - 126*D1**2*bd1*f*gd2*s + 126*D1**2*bd1*f*gd2 + 27*D1**2*bd2*f**2*r**2 + 27*D1**2*bd2*f**2*r*s - 27*D1**2*bd2*f**2*r - 180*D1**2*bd2*f*fd*r**2 - 180*D1**2*bd2*f*fd*r*s + 180*D1**2*bd2*f*fd*r + 45*D1**2*bd2*f*fd*s - 45*D1**2*bd2*f*fd + 175*D1**2*bdd1*f**3*r**2 + 175*D1**2*bdd1*f**3*r*s - 105*D1**2*bdd1*f**3*r + 135*D1**2*bdd1*f**2*r**2 + 135*D1**2*bdd1*f**2*r*s - 135*D1**2*bdd1*f**2*r - 252*D1**2*bdd1*f*g2*r - 126*D1**2*bdd1*f*g2*s + 126*D1**2*bdd1*f*g2 - 45*D1**2*bdd2*f**2*r**2 - 45*D1**2*bdd2*f**2*r*s + 45*D1**2*bdd2*f**2*r - 54*D1**2*f**2*gd2*r**2 - 54*D1**2*f**2*gd2*r*s + 54*D1**2*f**2*gd2*r + 90*D1**2*f**2*gdd2*r**2 + 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*r - 108*D1**2*f*fd*g2*r**2 - 108*D1**2*f*fd*g2*r*s + 108*D1**2*f*fd*g2*r + 54*D1**2*f*fd*g2*s - 54*D1**2*f*fd*g2 + 360*D1**2*f*fd*gd2*r**2 + 360*D1**2*f*fd*gd2*r*s - 360*D1**2*f*fd*gd2*r - 90*D1**2*f*fd*gd2*s + 90*D1**2*f*fd*gd2 + 180*D1**2*f*fdd*g2*r**2 + 180*D1**2*f*fdd*g2*r*s - 180*D1**2*f*fdd*g2*r - 90*D1**2*f*fdd*g2*s + 90*D1**2*f*fdd*g2 + 180*D1**2*fd**2*g2*r**2 + 180*D1**2*fd**2*g2*r*s - 180*D1**2*fd**2*g2*r - 90*D1**2*fd**2*g2*s - 360*D1*Dd*K*bd1*f**2*r**2 - 360*D1*Dd*K*bd1*f**2*r*s + 360*D1*Dd*K*bd1*f**2*r + 45*D1*Dd*K*bd1*f**2*s - 45*D1*Dd*K*bd1*f**2 + 1400*D1*Dd*bd1*f**3*r**2 + 1400*D1*Dd*bd1*f**3*r*s - 1120*D1*Dd*bd1*f**3*r - 175*D1*Dd*bd1*f**3*s + 105*D1*Dd*bd1*f**3 + 1080*D1*Dd*bd1*f**2*r**2 + 1080*D1*Dd*bd1*f**2*r*s - 1080*D1*Dd*bd1*f**2*r - 135*D1*Dd*bd1*f**2*s + 135*D1*Dd*bd1*f**2 - 1008*D1*Dd*bd1*f*g2*r - 504*D1*Dd*bd1*f*g2*s + 504*D1*Dd*bd1*f*g2 - 360*D1*Dd*bd2*f**2*r**2 - 360*D1*Dd*bd2*f**2*r*s + 360*D1*Dd*bd2*f**2*r + 45*D1*Dd*bd2*f**2*s - 45*D1*Dd*bd2*f**2 - 216*D1*Dd*f**2*g2*r**2 - 216*D1*Dd*f**2*g2*r*s + 216*D1*Dd*f**2*g2*r + 54*D1*Dd*f**2*g2*s - 54*D1*Dd*f**2*g2 + 720*D1*Dd*f**2*gd2*r**2 + 720*D1*Dd*f**2*gd2*r*s - 720*D1*Dd*f**2*gd2*r - 90*D1*Dd*f**2*gd2*s + 90*D1*Dd*f**2*gd2 + 1440*D1*Dd*f*fd*g2*r**2 + 1440*D1*Dd*f*fd*g2*r*s - 1440*D1*Dd*f*fd*g2*r - 540*D1*Dd*f*fd*g2*s + 360*D1*Dd*f*fd*g2 + 360*D1*Ddd*f**2*g2*r**2 + 360*D1*Ddd*f**2*g2*r*s - 360*D1*Ddd*f**2*g2*r - 90*D1*Ddd*f**2*g2*s + 90*D1*Ddd*f**2*g2 + 21*D1*b2*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 1080*Dd**2*f**2*g2*r**2 + 1080*Dd**2*f**2*g2*r*s - 1080*Dd**2*f**2*g2*r - 270*Dd**2*f**2*g2*s + 180*Dd**2*f**2*g2 + 21*b1**3*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + (5*K - 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-5*K + 3*f + 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-5*K + 3*f + 5)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1**2*(14*D1**2*K*fd*r + 7*D1**2*K*fd*s - 7*D1**2*K*fd - 42*D1**2*K*fdd*r - 21*D1**2*K*fdd*s + 21*D1**2*K*fdd - 7*D1**2*bdd1*(-5*K + 3*f + 5)*(3*r**2 + 3*r*(s - 1) - s + 1) - 72*D1**2*f*fd*r**2 - 72*D1**2*f*fd*r*s + 36*D1**2*f*fd*r - 9*D1**2*f*fd*s + 9*D1**2*f*fd + 120*D1**2*f*fdd*r**2 + 120*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*r + 15*D1**2*f*fdd*s - 15*D1**2*f*fdd + 120*D1**2*fd**2*r**2 + 120*D1**2*fd**2*r*s - 60*D1**2*fd**2*r + 15*D1**2*fd**2*s - 15*D1**2*fd**2 - 14*D1**2*fd*r**2 - 14*D1**2*fd*r*s - 14*D1**2*fd*r - 7*D1**2*fd*s + 7*D1**2*fd + 42*D1**2*fdd*r**2 + 42*D1**2*fdd*r*s + 42*D1**2*fdd*r + 21*D1**2*fdd*s - 21*D1**2*fdd - 70*D1**2*gd2*r**2 - 70*D1**2*gd2*r*s + 70*D1**2*gd2*r - 70*D1**2*gdd2*r**2 - 70*D1**2*gdd2*r*s + 70*D1**2*gdd2*r - 168*D1*Dd*K*fd*r - 84*D1*Dd*K*fd*s + 84*D1*Dd*K*fd - 144*D1*Dd*f**2*r**2 - 144*D1*Dd*f**2*r*s + 144*D1*Dd*f**2*r + 36*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 960*D1*Dd*f*fd*r**2 + 960*D1*Dd*f*fd*r*s - 720*D1*Dd*f*fd*r - 60*D1*Dd*f*fd*s + 30*D1*Dd*f*fd - 56*D1*Dd*f*r**2 - 56*D1*Dd*f*r*s + 56*D1*Dd*f*r + 14*D1*Dd*f*s - 14*D1*Dd*f + 336*D1*Dd*fd*r**2 + 336*D1*Dd*fd*r*s + 42*D1*Dd*fd*s - 84*D1*Dd*fd - 280*D1*Dd*g2*r**2 - 280*D1*Dd*g2*r*s + 280*D1*Dd*g2*r + 70*D1*Dd*g2*s - 70*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 560*D1*Dd*gd2*r*s + 560*D1*Dd*gd2*r + 70*D1*Dd*gd2*s - 70*D1*Dd*gd2 + 240*D1*Ddd*f**2*r**2 + 240*D1*Ddd*f**2*r*s - 240*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s + 60*D1*Ddd*f**2 + 168*D1*Ddd*f*r**2 + 168*D1*Ddd*f*r*s - 168*D1*Ddd*f*r - 42*D1*Ddd*f*s + 42*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 280*D1*Ddd*g2*r*s + 280*D1*Ddd*g2*r + 70*D1*Ddd*g2*s - 70*D1*Ddd*g2 + 7*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + (5*K - 5)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-5*K + 3*f + 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 720*Dd**2*f**2*r**2 + 720*Dd**2*f**2*r*s - 720*Dd**2*f**2*r - 180*Dd**2*f**2*s + 120*Dd**2*f**2 + 504*Dd**2*f*r**2 + 504*Dd**2*f*r*s - 504*Dd**2*f*r - 126*Dd**2*f*s + 84*Dd**2*f - 840*Dd**2*g2*r**2 - 840*Dd**2*g2*r*s + 840*Dd**2*g2*r + 210*Dd**2*g2*s - 140*Dd**2*g2) + b1*(54*D1**2*K*f*fd*r**2 + 54*D1**2*K*f*fd*r*s - 54*D1**2*K*f*fd*r - 27*D1**2*K*f*fd*s + 27*D1**2*K*f*fd - 90*D1**2*K*f*fdd*r**2 - 90*D1**2*K*f*fdd*r*s + 90*D1**2*K*f*fdd*r + 45*D1**2*K*f*fdd*s - 45*D1**2*K*f*fdd - 90*D1**2*K*fd**2*r**2 - 90*D1**2*K*fd**2*r*s + 90*D1**2*K*fd**2*r + 45*D1**2*K*fd**2*s + 21*D1**2*b2*fd*r**2 + 21*D1**2*b2*fd*r*s - 63*D1**2*b2*fdd*r**2 - 63*D1**2*b2*fdd*r*s - 21*D1**2*bd1**2*(-5*K + 3*f + 5)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 21*D1**2*bd2*f*r**2 + 21*D1**2*bd2*f*r*s - 21*D1**2*bd2*f*r - 126*D1**2*bd2*fd*r**2 - 126*D1**2*bd2*fd*r*s + 63*D1**2*bd2*fd*r + 3*D1**2*bdd1*(15*f**2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 5) + 21*f*(K*(2*r + s - 1) + 4*r**2 + 4*r*(s - 2) - 3*s + 3) - 70*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 63*D1**2*bdd2*f*r**2 - 63*D1**2*bdd2*f*r*s + 63*D1**2*bdd2*f*r - 375*D1**2*f**2*fd*r**2 - 375*D1**2*f**2*fd*r*s + 425*D1**2*f**2*fd*r + 125*D1**2*f**2*fd*s - 125*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 525*D1**2*f**2*fdd*r*s - 595*D1**2*f**2*fdd*r - 175*D1**2*f**2*fdd*s + 175*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 1050*D1**2*f*fd**2*r*s - 1190*D1**2*f*fd**2*r - 350*D1**2*f*fd**2*s + 245*D1**2*f*fd**2 - 162*D1**2*f*fd*r**2 - 162*D1**2*f*fd*r*s + 162*D1**2*f*fd*r + 81*D1**2*f*fd*s - 81*D1**2*f*fd + 270*D1**2*f*fdd*r**2 + 270*D1**2*f*fdd*r*s - 270*D1**2*f*fdd*r - 135*D1**2*f*fdd*s + 135*D1**2*f*fdd + 270*D1**2*fd**2*r**2 + 270*D1**2*fd**2*r*s - 270*D1**2*fd**2*r - 135*D1**2*fd**2*s - 84*D1**2*fd*g2*r - 42*D1**2*fd*g2*s + 42*D1**2*fd*g2 + 252*D1**2*fd*gd2*r + 126*D1**2*fd*gd2*s - 126*D1**2*fd*gd2 + 252*D1**2*fdd*g2*r + 126*D1**2*fdd*g2*s - 126*D1**2*fdd*g2 + 108*D1*Dd*K*f**2*r**2 + 108*D1*Dd*K*f**2*r*s - 108*D1*Dd*K*f**2*r - 27*D1*Dd*K*f**2*s + 27*D1*Dd*K*f**2 - 720*D1*Dd*K*f*fd*r**2 - 720*D1*Dd*K*f*fd*r*s + 720*D1*Dd*K*f*fd*r + 270*D1*Dd*K*f*fd*s - 180*D1*Dd*K*f*fd + 84*D1*Dd*b2*f*r**2 + 84*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r - 21*D1*Dd*b2*f*s + 21*D1*Dd*b2*f - 504*D1*Dd*b2*fd*r**2 - 504*D1*Dd*b2*fd*r*s + 252*D1*Dd*b2*fd*r + 63*D1*Dd*b2*fd*s - 504*D1*Dd*bd2*f*r**2 - 504*D1*Dd*bd2*f*r*s + 504*D1*Dd*bd2*f*r + 63*D1*Dd*bd2*f*s - 63*D1*Dd*bd2*f - 500*D1*Dd*f**3*r**2 - 500*D1*Dd*f**3*r*s + 500*D1*Dd*f**3*r + 125*D1*Dd*f**3*s - 125*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 4200*D1*Dd*f**2*fd*r*s - 4480*D1*Dd*f**2*fd*r - 1225*D1*Dd*f**2*fd*s + 945*D1*Dd*f**2*fd - 324*D1*Dd*f**2*r**2 - 324*D1*Dd*f**2*r*s + 324*D1*Dd*f**2*r + 81*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 2160*D1*Dd*f*fd*r**2 + 2160*D1*Dd*f*fd*r*s - 2160*D1*Dd*f*fd*r - 810*D1*Dd*f*fd*s + 540*D1*Dd*f*fd + 1008*D1*Dd*fd*g2*r + 504*D1*Dd*fd*g2*s - 504*D1*Dd*fd*g2 - 180*D1*Ddd*K*f**2*r**2 - 180*D1*Ddd*K*f**2*r*s + 180*D1*Ddd*K*f**2*r + 45*D1*Ddd*K*f**2*s - 45*D1*Ddd*K*f**2 - 252*D1*Ddd*b2*f*r**2 - 252*D1*Ddd*b2*f*r*s + 252*D1*Ddd*b2*f*r + 63*D1*Ddd*b2*f*s - 63*D1*Ddd*b2*f + 700*D1*Ddd*f**3*r**2 + 700*D1*Ddd*f**3*r*s - 700*D1*Ddd*f**3*r - 175*D1*Ddd*f**3*s + 175*D1*Ddd*f**3 + 540*D1*Ddd*f**2*r**2 + 540*D1*Ddd*f**2*r*s - 540*D1*Ddd*f**2*r - 135*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 - 3*D1*bd1*(D1*(9*f**2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 5) + f*(7*K*(2*r + s - 1) - 30*fd*(4*r - 1)*(4*r + 4*s - 3) + 28*r**2 + 28*r*(s - 2) - 21*s + 21) + 21*fd*(K*(2*r + s - 1) - 8*r**2 + r*(4 - 8*s) + s + 1) + 70*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 70*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 2*Dd*(15*f**2*(32*r**2 + 8*r*(4*s - 5) - 14*s + 11) + 21*f*(2*K*(2*r + s - 1) + 16*r**2 + 8*r*(2*s - 3) - 8*s + 7) - 70*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 540*Dd**2*K*f**2*r**2 - 540*Dd**2*K*f**2*r*s + 540*Dd**2*K*f**2*r + 135*Dd**2*K*f**2*s - 90*Dd**2*K*f**2 - 756*Dd**2*b2*f*r**2 - 756*Dd**2*b2*f*r*s + 756*Dd**2*b2*f*r + 189*Dd**2*b2*f*s - 126*Dd**2*b2*f + 2100*Dd**2*f**3*r**2 + 2100*Dd**2*f**3*r*s - 2100*Dd**2*f**3*r - 525*Dd**2*f**3*s + 350*Dd**2*f**3 + 1620*Dd**2*f**2*r**2 + 1620*Dd**2*f**2*r*s - 1620*Dd**2*f**2*r - 405*Dd**2*f**2*s + 270*Dd**2*f**2) - 9*b2*(7*D1**2*bdd1*f*(r - 1)*(r + s - 1) + D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 10*fd*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(315*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct**3*k2*(2*C - 2)*(-3*D1*f*(7*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + 5*D1*bdd1*f*r*(r + s) + bd1*(D1*(-3*f*r*(r + s) + 5*fd*(4*r**2 + 4*r*s - 3*r - s)) + 5*Dd*f*(8*r**2 + r*(8*s - 4) - s))) + 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-21*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*D1**2*(2*r - 1)*(r + s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 7*D1*bd1*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 5*fd*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(105*d**2*k3) + D1**2*Pkd1*Pkd3*ct**2*f*k2**6*st**4*(-99*D1**2*b1*f*fd*r**2 - 99*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r + 99*D1**2*b1*f*fdd*r**2 + 99*D1**2*b1*f*fdd*r*s - 66*D1**2*b1*f*fdd*r + 198*D1**2*b1*fd**2*r**2 + 198*D1**2*b1*fd**2*r*s - 132*D1**2*b1*fd**2*r + 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 76*D1**2*f**2*fd*r**2 - 76*D1**2*f**2*fd*r*s + 76*D1**2*f**2*fd*r + 19*D1**2*f**2*fd*s - 19*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 60*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s + 15*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r**2 + 180*D1**2*f*fd**2*r*s - 180*D1**2*f*fd**2*r - 45*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 - 132*D1*Dd*b1*f**2*r**2 - 132*D1*Dd*b1*f**2*r*s + 132*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2*s - 33*D1*Dd*b1*f**2 + 792*D1*Dd*b1*f*fd*r**2 + 792*D1*Dd*b1*f*fd*r*s - 660*D1*Dd*b1*f*fd*r - 99*D1*Dd*b1*f*fd*s + 66*D1*Dd*b1*f*fd - 76*D1*Dd*f**3*r**2 - 76*D1*Dd*f**3*r*s + 76*D1*Dd*f**3*r + 19*D1*Dd*f**3*s - 19*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 480*D1*Dd*f**2*fd*r*s - 480*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s + 90*D1*Dd*f**2*fd + 132*D1*Ddd*b1*f**2*r**2 + 132*D1*Ddd*b1*f**2*r*s - 132*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 + 60*D1*Ddd*f**3*r**2 + 60*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r - 15*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 - 33*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) + 396*Dd**2*b1*f**2*r**2 + 396*Dd**2*b1*f**2*r*s - 396*Dd**2*b1*f**2*r - 99*Dd**2*b1*f**2*s + 66*Dd**2*b1*f**2 + 180*Dd**2*f**3*r**2 + 180*Dd**2*f**3*r*s - 180*Dd**2*f**3*r - 45*Dd**2*f**3*s + 30*Dd**2*f**3)/(231*d**2*k1*k3**5) - D1**2*Pkd1*Pkd3*ct**2*k1**5*(2*C - 1)*(54*D1**2*b1*f*fd*r**2 + 54*D1**2*b1*f*fd*r*s - 27*D1**2*b1*f*fd*r - 90*D1**2*b1*f*fdd*r**2 - 90*D1**2*b1*f*fdd*r*s + 45*D1**2*b1*f*fdd*r - 90*D1**2*b1*fd**2*r**2 - 90*D1**2*b1*fd**2*r*s + 45*D1**2*b1*fd**2*r - 45*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1*Dd*b1*f**2*r**2 + 108*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r - 27*D1*Dd*b1*f**2*s + 27*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 720*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 90*D1*Dd*b1*f*fd*s - 45*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 180*D1*Ddd*b1*f**2*r**2 - 180*D1*Ddd*b1*f**2*r*s + 180*D1*Ddd*b1*f**2*r + 45*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 9*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 540*Dd**2*b1*f**2*r**2 - 540*Dd**2*b1*f**2*r*s + 540*Dd**2*b1*f**2*r + 135*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(315*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**2*k1**3*k2**2*st**2*(-396*C*D1**2*b1*f*fd*r**2 - 396*C*D1**2*b1*f*fd*r*s + 198*C*D1**2*b1*f*fd*r + 1332*C*D1**2*b1*f*fdd*r**2 + 1332*C*D1**2*b1*f*fdd*r*s - 666*C*D1**2*b1*f*fdd*r + 1332*C*D1**2*b1*fd**2*r**2 + 1332*C*D1**2*b1*fd**2*r*s - 666*C*D1**2*b1*fd**2*r - 762*C*D1**2*f**2*fd*r**2 - 762*C*D1**2*f**2*fd*r*s + 762*C*D1**2*f**2*fd*r + 254*C*D1**2*f**2*fd*s - 254*C*D1**2*f**2*fd + 1110*C*D1**2*f**2*fdd*r**2 + 1110*C*D1**2*f**2*fdd*r*s - 1110*C*D1**2*f**2*fdd*r - 370*C*D1**2*f**2*fdd*s + 370*C*D1**2*f**2*fdd + 2220*C*D1**2*f*fd**2*r**2 + 2220*C*D1**2*f*fd**2*r*s - 2220*C*D1**2*f*fd**2*r - 740*C*D1**2*f*fd**2*s + 370*C*D1**2*f*fd**2 - 792*C*D1*Dd*b1*f**2*r**2 - 792*C*D1*Dd*b1*f**2*r*s + 792*C*D1*Dd*b1*f**2*r + 198*C*D1*Dd*b1*f**2*s - 198*C*D1*Dd*b1*f**2 + 10656*C*D1*Dd*b1*f*fd*r**2 + 10656*C*D1*Dd*b1*f*fd*r*s - 7992*C*D1*Dd*b1*f*fd*r - 1332*C*D1*Dd*b1*f*fd*s + 666*C*D1*Dd*b1*f*fd - 1016*C*D1*Dd*f**3*r**2 - 1016*C*D1*Dd*f**3*r*s + 1016*C*D1*Dd*f**3*r + 254*C*D1*Dd*f**3*s - 254*C*D1*Dd*f**3 + 8880*C*D1*Dd*f**2*fd*r**2 + 8880*C*D1*Dd*f**2*fd*r*s - 8880*C*D1*Dd*f**2*fd*r - 2590*C*D1*Dd*f**2*fd*s + 1850*C*D1*Dd*f**2*fd + 2664*C*D1*Ddd*b1*f**2*r**2 + 2664*C*D1*Ddd*b1*f**2*r*s - 2664*C*D1*Ddd*b1*f**2*r - 666*C*D1*Ddd*b1*f**2*s + 666*C*D1*Ddd*b1*f**2 + 1480*C*D1*Ddd*f**3*r**2 + 1480*C*D1*Ddd*f**3*r*s - 1480*C*D1*Ddd*f**3*r - 370*C*D1*Ddd*f**3*s + 370*C*D1*Ddd*f**3 + 7992*C*Dd**2*b1*f**2*r**2 + 7992*C*Dd**2*b1*f**2*r*s - 7992*C*Dd**2*b1*f**2*r - 1998*C*Dd**2*b1*f**2*s + 1332*C*Dd**2*b1*f**2 + 4440*C*Dd**2*f**3*r**2 + 4440*C*Dd**2*f**3*r*s - 4440*C*Dd**2*f**3*r - 1110*C*Dd**2*f**3*s + 740*C*Dd**2*f**3 + 222*D1**2*b1*f*fd*r**2 + 222*D1**2*b1*f*fd*r*s - 111*D1**2*b1*f*fd*r - 846*D1**2*b1*f*fdd*r**2 - 846*D1**2*b1*f*fdd*r*s + 423*D1**2*b1*f*fdd*r - 846*D1**2*b1*fd**2*r**2 - 846*D1**2*b1*fd**2*r*s + 423*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(74*C - 47)*(r - 1)*(r + s - 1) + 465*D1**2*f**2*fd*r**2 + 465*D1**2*f**2*fd*r*s - 465*D1**2*f**2*fd*r - 155*D1**2*f**2*fd*s + 155*D1**2*f**2*fd - 705*D1**2*f**2*fdd*r**2 - 705*D1**2*f**2*fdd*r*s + 705*D1**2*f**2*fdd*r + 235*D1**2*f**2*fdd*s - 235*D1**2*f**2*fdd - 1410*D1**2*f*fd**2*r**2 - 1410*D1**2*f*fd**2*r*s + 1410*D1**2*f*fd**2*r + 470*D1**2*f*fd**2*s - 235*D1**2*f*fd**2 + 444*D1*Dd*b1*f**2*r**2 + 444*D1*Dd*b1*f**2*r*s - 444*D1*Dd*b1*f**2*r - 111*D1*Dd*b1*f**2*s + 111*D1*Dd*b1*f**2 - 6768*D1*Dd*b1*f*fd*r**2 - 6768*D1*Dd*b1*f*fd*r*s + 5076*D1*Dd*b1*f*fd*r + 846*D1*Dd*b1*f*fd*s - 423*D1*Dd*b1*f*fd + 620*D1*Dd*f**3*r**2 + 620*D1*Dd*f**3*r*s - 620*D1*Dd*f**3*r - 155*D1*Dd*f**3*s + 155*D1*Dd*f**3 - 5640*D1*Dd*f**2*fd*r**2 - 5640*D1*Dd*f**2*fd*r*s + 5640*D1*Dd*f**2*fd*r + 1645*D1*Dd*f**2*fd*s - 1175*D1*Dd*f**2*fd - 1692*D1*Ddd*b1*f**2*r**2 - 1692*D1*Ddd*b1*f**2*r*s + 1692*D1*Ddd*b1*f**2*r + 423*D1*Ddd*b1*f**2*s - 423*D1*Ddd*b1*f**2 - 940*D1*Ddd*f**3*r**2 - 940*D1*Ddd*f**3*r*s + 940*D1*Ddd*f**3*r + 235*D1*Ddd*f**3*s - 235*D1*Ddd*f**3 - 3*D1*bd1*f*(D1*(f*(66*C - 37)*(r - 1)*(r + s - 1) - fd*(222*C - 141)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(141 - 222*C)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 5076*Dd**2*b1*f**2*r**2 - 5076*Dd**2*b1*f**2*r*s + 5076*Dd**2*b1*f**2*r + 1269*Dd**2*b1*f**2*s - 846*Dd**2*b1*f**2 - 2820*Dd**2*f**3*r**2 - 2820*Dd**2*f**3*r*s + 2820*Dd**2*f**3*r + 705*Dd**2*f**3*s - 470*Dd**2*f**3)/(315*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**2*k1**3*k2**2*(-198*D1**2*bd1**2*f*(2*r - 1)*(-35*K + 10*f + 14)*(r + s - 1) - 55*D1**2*bdd1*f*(r + s - 1)*(7*f**2*(3*r + 1) + 18*f*r*(2 - 5*K) + 252*g2*(r - 1)) - 5*D1**2*(7*f**3*(7*fd - 9*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 9*f**2*(7*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + r*(132*gd2 - 220*gdd2)*(r + s - 1)) - 396*f*(fd*(g2*(6*r**2 + 6*r*(s - 1) - 3*s + 3) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 1980*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) + 11*D1*bd1*(D1*(25*f**3*(3*r + 1)*(r + s - 1) + f**2*(-35*fd*(18*r**2 + 2*r*(9*s - 8) - s + 2) + r*(108 - 270*K)*(r + s - 1)) + 30*f*(3*fd*(5*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) - 1260*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(7*f**2*(24*r**2 + 4*r*(6*s - 5) + s) - 18*f*(5*K - 2)*(8*r**2 + 8*r*(s - 1) - s + 1) + 252*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 5*D1*f*(Dd*(49*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 126*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 396*f*(3*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 3960*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 9*Ddd*f*(7*f**2 - 220*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 45*Dd**2*f**2*(7*f**2 - 220*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 66*b1**2*(D1**2*r*(6*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 30*fd**2*(2*r + 2*s - 1) - 7*fd*(5*K - 2)*(r + s) + 21*fdd*(5*K - 2)*(r + s)) + D1*(Dd*(18*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-30*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (14 - 35*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(5*K - 2)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-35*K + 10*f + 14)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-35*K + 10*f + 14)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-540*D1**2*K*f*fd*r**2 - 540*D1**2*K*f*fd*r*s + 540*D1**2*K*f*fd*r + 270*D1**2*K*f*fd*s - 270*D1**2*K*f*fd + 900*D1**2*K*f*fdd*r**2 + 900*D1**2*K*f*fdd*r*s - 900*D1**2*K*f*fdd*r - 450*D1**2*K*f*fdd*s + 450*D1**2*K*f*fdd + 900*D1**2*K*fd**2*r**2 + 900*D1**2*K*fd**2*r*s - 900*D1**2*K*fd**2*r - 450*D1**2*K*fd**2*s - 18*D1**2*bdd1*f*(2*r - 1)*(-35*K + 10*f + 14)*(r + s - 1) + 225*D1**2*f**2*fd*r**2 + 225*D1**2*f**2*fd*r*s - 250*D1**2*f**2*fd*r - 100*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 315*D1**2*f**2*fdd*r**2 - 315*D1**2*f**2*fdd*r*s + 350*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 630*D1**2*f*fd**2*r**2 - 630*D1**2*f*fd**2*r*s + 700*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 216*D1**2*f*fd*r**2 + 216*D1**2*f*fd*r*s - 216*D1**2*f*fd*r - 108*D1**2*f*fd*s + 108*D1**2*f*fd - 360*D1**2*f*fdd*r**2 - 360*D1**2*f*fdd*r*s + 360*D1**2*f*fdd*r + 180*D1**2*f*fdd*s - 180*D1**2*f*fdd + 420*D1**2*f*gd2*r**2 + 420*D1**2*f*gd2*r*s - 420*D1**2*f*gd2*r - 1260*D1**2*f*gdd2*r**2 - 1260*D1**2*f*gdd2*r*s + 1260*D1**2*f*gdd2*r - 360*D1**2*fd**2*r**2 - 360*D1**2*fd**2*r*s + 360*D1**2*fd**2*r + 180*D1**2*fd**2*s + 420*D1**2*fd*g2*r**2 + 420*D1**2*fd*g2*r*s - 2520*D1**2*fd*gd2*r**2 - 2520*D1**2*fd*gd2*r*s + 1260*D1**2*fd*gd2*r - 1260*D1**2*fdd*g2*r**2 - 1260*D1**2*fdd*g2*r*s - 1080*D1*Dd*K*f**2*r**2 - 1080*D1*Dd*K*f**2*r*s + 1080*D1*Dd*K*f**2*r + 270*D1*Dd*K*f**2*s - 270*D1*Dd*K*f**2 + 7200*D1*Dd*K*f*fd*r**2 + 7200*D1*Dd*K*f*fd*r*s - 7200*D1*Dd*K*f*fd*r - 2700*D1*Dd*K*f*fd*s + 1800*D1*Dd*K*f*fd + 300*D1*Dd*f**3*r**2 + 300*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r - 75*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 2520*D1*Dd*f**2*fd*r**2 - 2520*D1*Dd*f**2*fd*r*s + 2660*D1*Dd*f**2*fd*r + 875*D1*Dd*f**2*fd*s - 630*D1*Dd*f**2*fd + 432*D1*Dd*f**2*r**2 + 432*D1*Dd*f**2*r*s - 432*D1*Dd*f**2*r - 108*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 2880*D1*Dd*f*fd*r**2 - 2880*D1*Dd*f*fd*r*s + 2880*D1*Dd*f*fd*r + 1080*D1*Dd*f*fd*s - 720*D1*Dd*f*fd + 1680*D1*Dd*f*g2*r**2 + 1680*D1*Dd*f*g2*r*s - 1680*D1*Dd*f*g2*r - 420*D1*Dd*f*g2*s + 420*D1*Dd*f*g2 - 10080*D1*Dd*f*gd2*r**2 - 10080*D1*Dd*f*gd2*r*s + 10080*D1*Dd*f*gd2*r + 1260*D1*Dd*f*gd2*s - 1260*D1*Dd*f*gd2 - 10080*D1*Dd*fd*g2*r**2 - 10080*D1*Dd*fd*g2*r*s + 5040*D1*Dd*fd*g2*r + 1260*D1*Dd*fd*g2*s + 1800*D1*Ddd*K*f**2*r**2 + 1800*D1*Ddd*K*f**2*r*s - 1800*D1*Ddd*K*f**2*r - 450*D1*Ddd*K*f**2*s + 450*D1*Ddd*K*f**2 - 420*D1*Ddd*f**3*r**2 - 420*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r + 105*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 - 720*D1*Ddd*f**2*r**2 - 720*D1*Ddd*f**2*r*s + 720*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 5040*D1*Ddd*f*g2*r**2 - 5040*D1*Ddd*f*g2*r*s + 5040*D1*Ddd*f*g2*r + 1260*D1*Ddd*f*g2*s - 1260*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(18*f**2*(2*r - 1)*(r + s - 1) + f*(-30*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (35*K - 14)*(2*r - 1)*(r + s - 1)) + 21*fd*(5*K - 2)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-35*K + 10*f + 14)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 5400*Dd**2*K*f**2*r**2 + 5400*Dd**2*K*f**2*r*s - 5400*Dd**2*K*f**2*r - 1350*Dd**2*K*f**2*s + 900*Dd**2*K*f**2 - 1260*Dd**2*f**3*r**2 - 1260*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r + 315*Dd**2*f**3*s - 210*Dd**2*f**3 - 2160*Dd**2*f**2*r**2 - 2160*Dd**2*f**2*r*s + 2160*Dd**2*f**2*r + 540*Dd**2*f**2*s - 360*Dd**2*f**2 - 15120*Dd**2*f*g2*r**2 - 15120*Dd**2*f*g2*r*s + 15120*Dd**2*f*g2*r + 3780*Dd**2*f*g2*s - 2520*Dd**2*f*g2))/(3465*d**2*k3**5) - D1**2*Pkd1*Pkd3*ct**2*k1**3*(2*C - 1)*(3*D1*b1*(-21*D1*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 7*bd1*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + (3*D1*(-3*f*fd + 5*f*fdd + 5*fd**2) + 60*Dd*f*fd)*(2*r + s - 1)) + 21*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + f*(-63*D1**2*bd1**2*(2*r**2 + 2*r*(s - 1) - s) - 45*D1**2*bdd1*f*(2*r + s - 1) - 5*D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 7*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + 9*D1*bd1*(2*r + s - 1)*(3*D1*f - 5*D1*fd - 20*Dd*f) - 5*D1*f*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 7*fd*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 7*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 35*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(315*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct**2*k1*k2**4*st**4*(-60*C*D1**2*b1*f*fd*r**2 - 60*C*D1**2*b1*f*fd*r*s + 30*C*D1**2*b1*f*fd*r + 156*C*D1**2*b1*f*fdd*r**2 + 156*C*D1**2*b1*f*fdd*r*s - 78*C*D1**2*b1*f*fdd*r + 156*C*D1**2*b1*fd**2*r**2 + 156*C*D1**2*b1*fd**2*r*s - 78*C*D1**2*b1*fd**2*r - 102*C*D1**2*f**2*fd*r**2 - 102*C*D1**2*f**2*fd*r*s + 102*C*D1**2*f**2*fd*r + 34*C*D1**2*f**2*fd*s - 34*C*D1**2*f**2*fd + 78*C*D1**2*f**2*fdd*r**2 + 78*C*D1**2*f**2*fdd*r*s - 78*C*D1**2*f**2*fdd*r - 26*C*D1**2*f**2*fdd*s + 26*C*D1**2*f**2*fdd + 156*C*D1**2*f*fd**2*r**2 + 156*C*D1**2*f*fd**2*r*s - 156*C*D1**2*f*fd**2*r - 52*C*D1**2*f*fd**2*s + 26*C*D1**2*f*fd**2 - 120*C*D1*Dd*b1*f**2*r**2 - 120*C*D1*Dd*b1*f**2*r*s + 120*C*D1*Dd*b1*f**2*r + 30*C*D1*Dd*b1*f**2*s - 30*C*D1*Dd*b1*f**2 + 1248*C*D1*Dd*b1*f*fd*r**2 + 1248*C*D1*Dd*b1*f*fd*r*s - 936*C*D1*Dd*b1*f*fd*r - 156*C*D1*Dd*b1*f*fd*s + 78*C*D1*Dd*b1*f*fd - 136*C*D1*Dd*f**3*r**2 - 136*C*D1*Dd*f**3*r*s + 136*C*D1*Dd*f**3*r + 34*C*D1*Dd*f**3*s - 34*C*D1*Dd*f**3 + 624*C*D1*Dd*f**2*fd*r**2 + 624*C*D1*Dd*f**2*fd*r*s - 624*C*D1*Dd*f**2*fd*r - 182*C*D1*Dd*f**2*fd*s + 130*C*D1*Dd*f**2*fd + 312*C*D1*Ddd*b1*f**2*r**2 + 312*C*D1*Ddd*b1*f**2*r*s - 312*C*D1*Ddd*b1*f**2*r - 78*C*D1*Ddd*b1*f**2*s + 78*C*D1*Ddd*b1*f**2 + 104*C*D1*Ddd*f**3*r**2 + 104*C*D1*Ddd*f**3*r*s - 104*C*D1*Ddd*f**3*r - 26*C*D1*Ddd*f**3*s + 26*C*D1*Ddd*f**3 + 936*C*Dd**2*b1*f**2*r**2 + 936*C*Dd**2*b1*f**2*r*s - 936*C*Dd**2*b1*f**2*r - 234*C*Dd**2*b1*f**2*s + 156*C*Dd**2*b1*f**2 + 312*C*Dd**2*f**3*r**2 + 312*C*Dd**2*f**3*r*s - 312*C*Dd**2*f**3*r - 78*C*Dd**2*f**3*s + 52*C*Dd**2*f**3 + 42*D1**2*b1*f*fd*r**2 + 42*D1**2*b1*f*fd*r*s - 21*D1**2*b1*f*fd*r - 126*D1**2*b1*f*fdd*r**2 - 126*D1**2*b1*f*fdd*r*s + 63*D1**2*b1*f*fdd*r - 126*D1**2*b1*fd**2*r**2 - 126*D1**2*b1*fd**2*r*s + 63*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(26*C - 21)*(r - 1)*(r + s - 1) + 81*D1**2*f**2*fd*r**2 + 81*D1**2*f**2*fd*r*s - 81*D1**2*f**2*fd*r - 27*D1**2*f**2*fd*s + 27*D1**2*f**2*fd - 63*D1**2*f**2*fdd*r**2 - 63*D1**2*f**2*fdd*r*s + 63*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s - 21*D1**2*f**2*fdd - 126*D1**2*f*fd**2*r**2 - 126*D1**2*f*fd**2*r*s + 126*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s - 21*D1**2*f*fd**2 + 84*D1*Dd*b1*f**2*r**2 + 84*D1*Dd*b1*f**2*r*s - 84*D1*Dd*b1*f**2*r - 21*D1*Dd*b1*f**2*s + 21*D1*Dd*b1*f**2 - 1008*D1*Dd*b1*f*fd*r**2 - 1008*D1*Dd*b1*f*fd*r*s + 756*D1*Dd*b1*f*fd*r + 126*D1*Dd*b1*f*fd*s - 63*D1*Dd*b1*f*fd + 108*D1*Dd*f**3*r**2 + 108*D1*Dd*f**3*r*s - 108*D1*Dd*f**3*r - 27*D1*Dd*f**3*s + 27*D1*Dd*f**3 - 504*D1*Dd*f**2*fd*r**2 - 504*D1*Dd*f**2*fd*r*s + 504*D1*Dd*f**2*fd*r + 147*D1*Dd*f**2*fd*s - 105*D1*Dd*f**2*fd - 252*D1*Ddd*b1*f**2*r**2 - 252*D1*Ddd*b1*f**2*r*s + 252*D1*Ddd*b1*f**2*r + 63*D1*Ddd*b1*f**2*s - 63*D1*Ddd*b1*f**2 - 84*D1*Ddd*f**3*r**2 - 84*D1*Ddd*f**3*r*s + 84*D1*Ddd*f**3*r + 21*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 - 3*D1*bd1*f*(D1*(f*(10*C - 7)*(r - 1)*(r + s - 1) - fd*(26*C - 21)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(26*C - 21)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 756*Dd**2*b1*f**2*r**2 - 756*Dd**2*b1*f**2*r*s + 756*Dd**2*b1*f**2*r + 189*Dd**2*b1*f**2*s - 126*Dd**2*b1*f**2 - 252*Dd**2*f**3*r**2 - 252*Dd**2*f**3*r*s + 252*Dd**2*f**3*r + 63*Dd**2*f**3*s - 42*Dd**2*f**3)/(105*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**2*k1*k2**4*st**2*(297*D1**2*K*bdd1*f**2*r**2 + 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*r - 33*D1**2*bd1**2*f*(2*r - 1)*(-21*K + 24*f + 14)*(r + s - 1) + 220*D1**2*bdd1*f**3*r**2 + 220*D1**2*bdd1*f**3*r*s - 880*D1**2*bdd1*f**3*r - 660*D1**2*bdd1*f**3*s + 660*D1**2*bdd1*f**3 - 198*D1**2*bdd1*f**2*r**2 - 198*D1**2*bdd1*f**2*r*s + 198*D1**2*bdd1*f**2*r - 1386*D1**2*bdd1*f*g2*r**2 - 1386*D1**2*bdd1*f*g2*r*s + 2772*D1**2*bdd1*f*g2*r + 1386*D1**2*bdd1*f*g2*s - 1386*D1**2*bdd1*f*g2 - 1380*D1**2*f**3*fd*r**2 - 1380*D1**2*f**3*fd*r*s + 1380*D1**2*f**3*fd*r + 345*D1**2*f**3*fd*s - 345*D1**2*f**3*fd + 1680*D1**2*f**3*fdd*r**2 + 1680*D1**2*f**3*fdd*r*s - 1680*D1**2*f**3*fdd*r - 420*D1**2*f**3*fdd*s + 420*D1**2*f**3*fdd + 5040*D1**2*f**2*fd**2*r**2 + 5040*D1**2*f**2*fd**2*r*s - 5040*D1**2*f**2*fd**2*r - 1260*D1**2*f**2*fd**2*s + 840*D1**2*f**2*fd**2 + 726*D1**2*f**2*gd2*r**2 + 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*r - 594*D1**2*f**2*gdd2*r**2 - 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*r + 1452*D1**2*f*fd*g2*r**2 + 1452*D1**2*f*fd*g2*r*s - 1452*D1**2*f*fd*g2*r - 726*D1**2*f*fd*g2*s + 726*D1**2*f*fd*g2 - 2376*D1**2*f*fd*gd2*r**2 - 2376*D1**2*f*fd*gd2*r*s + 2376*D1**2*f*fd*gd2*r + 594*D1**2*f*fd*gd2*s - 594*D1**2*f*fd*gd2 - 1188*D1**2*f*fdd*g2*r**2 - 1188*D1**2*f*fdd*g2*r*s + 1188*D1**2*f*fdd*g2*r + 594*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 1188*D1**2*fd**2*g2*r**2 - 1188*D1**2*fd**2*g2*r*s + 1188*D1**2*fd**2*g2*r + 594*D1**2*fd**2*g2*s - 1380*D1*Dd*f**4*r**2 - 1380*D1*Dd*f**4*r*s + 1380*D1*Dd*f**4*r + 345*D1*Dd*f**4*s - 345*D1*Dd*f**4 + 13440*D1*Dd*f**3*fd*r**2 + 13440*D1*Dd*f**3*fd*r*s - 13440*D1*Dd*f**3*fd*r - 3360*D1*Dd*f**3*fd*s + 2520*D1*Dd*f**3*fd + 2904*D1*Dd*f**2*g2*r**2 + 2904*D1*Dd*f**2*g2*r*s - 2904*D1*Dd*f**2*g2*r - 726*D1*Dd*f**2*g2*s + 726*D1*Dd*f**2*g2 - 4752*D1*Dd*f**2*gd2*r**2 - 4752*D1*Dd*f**2*gd2*r*s + 4752*D1*Dd*f**2*gd2*r + 594*D1*Dd*f**2*gd2*s - 594*D1*Dd*f**2*gd2 - 9504*D1*Dd*f*fd*g2*r**2 - 9504*D1*Dd*f*fd*g2*r*s + 9504*D1*Dd*f*fd*g2*r + 3564*D1*Dd*f*fd*g2*s - 2376*D1*Dd*f*fd*g2 + 1680*D1*Ddd*f**4*r**2 + 1680*D1*Ddd*f**4*r*s - 1680*D1*Ddd*f**4*r - 420*D1*Ddd*f**4*s + 420*D1*Ddd*f**4 - 2376*D1*Ddd*f**2*g2*r**2 - 2376*D1*Ddd*f**2*g2*r*s + 2376*D1*Ddd*f**2*g2*r + 594*D1*Ddd*f**2*g2*s - 594*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(f**3*(4*r - 39)*(r + s - 1) + f**2*(-20*fd*(6*r**2 + 6*r*(s - 2) - 7*s + 4) + r*(33*K - 22)*(r + s - 1)) - 3*f*(3*fd*(3*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) + 126*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-20*f**2*(8*r**2 + 4*r*(2*s - 5) - 13*s + 10) - 9*f*(3*K - 2)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 5040*Dd**2*f**4*r**2 + 5040*Dd**2*f**4*r*s - 5040*Dd**2*f**4*r - 1260*Dd**2*f**4*s + 840*Dd**2*f**4 - 7128*Dd**2*f**2*g2*r**2 - 7128*Dd**2*f**2*g2*r*s + 7128*Dd**2*f**2*g2*r + 1782*Dd**2*f**2*g2*s - 1188*Dd**2*f**2*g2 + 11*b1**2*(D1**2*r*(3*f*(13*fd - 24*fdd)*(2*r + 2*s - 1) - 72*fd**2*(2*r + 2*s - 1) - 7*fd*(3*K - 2)*(r + s) + 21*fdd*(3*K - 2)*(r + s)) + D1*(Dd*(39*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-72*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (14 - 21*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(3*K - 2)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-21*K + 24*f + 14)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-21*K + 24*f + 14)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-66*D1**2*K*f*fd*r**2 - 66*D1**2*K*f*fd*r*s + 66*D1**2*K*f*fd*r + 33*D1**2*K*f*fd*s - 33*D1**2*K*f*fd + 54*D1**2*K*f*fdd*r**2 + 54*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r - 27*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 54*D1**2*K*fd**2*r**2 + 54*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r - 27*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(2*r - 1)*(-21*K + 24*f + 14)*(r + s - 1) - 12*D1**2*f**2*fd*r**2 - 12*D1**2*f**2*fd*r*s - 27*D1**2*f**2*fd*r - 35*D1**2*f**2*fd*s + 35*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 60*D1**2*f**2*fdd*r*s + 40*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 120*D1**2*f*fd**2*r*s + 80*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 44*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 44*D1**2*f*fd*r - 22*D1**2*f*fd*s + 22*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r + 18*D1**2*f*fdd*s - 18*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r - 126*D1**2*f*gdd2*r**2 - 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*r - 36*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 36*D1**2*fd**2*r + 18*D1**2*fd**2*s + 42*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s - 252*D1**2*fd*gd2*r**2 - 252*D1**2*fd*gd2*r*s + 126*D1**2*fd*gd2*r - 126*D1**2*fdd*g2*r**2 - 126*D1**2*fdd*g2*r*s - 132*D1*Dd*K*f**2*r**2 - 132*D1*Dd*K*f**2*r*s + 132*D1*Dd*K*f**2*r + 33*D1*Dd*K*f**2*s - 33*D1*Dd*K*f**2 + 432*D1*Dd*K*f*fd*r**2 + 432*D1*Dd*K*f*fd*r*s - 432*D1*Dd*K*f*fd*r - 162*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd - 16*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r*s + 16*D1*Dd*f**3*r + 4*D1*Dd*f**3*s - 4*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 480*D1*Dd*f**2*fd*r*s - 240*D1*Dd*f**2*fd*r + 100*D1*Dd*f**2*fd*s - 80*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 88*D1*Dd*f**2*r - 22*D1*Dd*f**2*s + 22*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 288*D1*Dd*f*fd*r + 108*D1*Dd*f*fd*s - 72*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 42*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r + 126*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r + 126*D1*Dd*fd*g2*s + 108*D1*Ddd*K*f**2*r**2 + 108*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r - 27*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r**2 + 80*D1*Ddd*f**3*r*s - 80*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s + 20*D1*Ddd*f**3 - 72*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 72*D1*Ddd*f**2*r + 18*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 504*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 126*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + D1*bd1*(D1*(39*f**2*(2*r - 1)*(r + s - 1) + f*(-72*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (21*K - 14)*(2*r - 1)*(r + s - 1)) + 21*fd*(3*K - 2)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-21*K + 24*f + 14)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 324*Dd**2*K*f**2*r**2 + 324*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r - 81*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 + 240*Dd**2*f**3*r**2 + 240*Dd**2*f**3*r*s - 240*Dd**2*f**3*r - 60*Dd**2*f**3*s + 40*Dd**2*f**3 - 216*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 216*Dd**2*f**2*r + 54*Dd**2*f**2*s - 36*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 1512*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 378*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(1155*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**2*k1*k2**2*st**2*(7*b1**2*(D1**2*r*(fd*(2*C - 3) + fdd*(14*C - 11))*(r + s - 1) + D1*(Dd*(f*(2*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(14*C - 11)*(8*r**2 + 8*r*(s - 1) - s + 1)) + Ddd*f*(14*C - 11)*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd**2*f*(14*C - 11)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(12*C*D1**2*f*fd*r**2 + 12*C*D1**2*f*fd*r*s + 78*C*D1**2*f*fd*r + 42*C*D1**2*f*fd*s - 42*C*D1**2*f*fd - 132*C*D1**2*f*fdd*r**2 - 132*C*D1**2*f*fdd*r*s - 18*C*D1**2*f*fdd*r - 42*C*D1**2*f*fdd*s + 42*C*D1**2*f*fdd - 132*C*D1**2*fd**2*r**2 - 132*C*D1**2*fd**2*r*s - 18*C*D1**2*fd**2*r - 42*C*D1**2*fd**2*s + 42*C*D1**2*fd**2 + 24*C*D1*Dd*f**2*r**2 + 24*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r - 6*C*D1*Dd*f**2*s + 6*C*D1*Dd*f**2 - 1056*C*D1*Dd*f*fd*r**2 - 1056*C*D1*Dd*f*fd*r*s + 456*C*D1*Dd*f*fd*r - 36*C*D1*Dd*f*fd*s + 102*C*D1*Dd*f*fd - 264*C*D1*Ddd*f**2*r**2 - 264*C*D1*Ddd*f**2*r*s + 264*C*D1*Ddd*f**2*r + 66*C*D1*Ddd*f**2*s - 66*C*D1*Ddd*f**2 - 792*C*Dd**2*f**2*r**2 - 792*C*Dd**2*f**2*r*s + 792*C*Dd**2*f**2*r + 198*C*Dd**2*f**2*s - 132*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(14*C - 11)*(2*r**2 + 2*r*(s - 1) - s + 1) + 4*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 64*D1**2*f*fd*r - 31*D1**2*f*fd*s + 31*D1**2*f*fd + 96*D1**2*f*fdd*r**2 + 96*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r + 33*D1**2*f*fdd*s - 33*D1**2*f*fdd + 96*D1**2*fd**2*r**2 + 96*D1**2*fd**2*r*s + 18*D1**2*fd**2*r + 33*D1**2*fd**2*s - 33*D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 2*D1*Dd*f**2 + 768*D1*Dd*f*fd*r**2 + 768*D1*Dd*f*fd*r*s - 312*D1*Dd*f*fd*r + 36*D1*Dd*f*fd*s - 84*D1*Dd*f*fd + 192*D1*Ddd*f**2*r**2 + 192*D1*Ddd*f**2*r*s - 192*D1*Ddd*f**2*r - 48*D1*Ddd*f**2*s + 48*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(2*C - 3)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd*(14*C - 11)*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*f*(28*C - 22)*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 576*Dd**2*f**2*r**2 + 576*Dd**2*f**2*r*s - 576*Dd**2*f**2*r - 144*Dd**2*f**2*s + 96*Dd**2*f**2) + f*(7*D1**2*bd1**2*(14*C - 11)*(2*r**2 + 2*r*(s - 1) - s) - 3*D1**2*bdd1*f*(C*(22*r**2 + 22*r*s - 72*r - 36*s + 36) - 16*r**2 + r*(54 - 16*s) + 27*s - 27) - 3*D1**2*(-f*(fd*(16*C - 11) + fdd*(15 - 20*C))*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(20*C - 15)*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*bd1*(D1*(f*(6*C*(r**2 + r*(s - 16) - 8*s + 8) + 2*r**2 + 2*r*(s + 29) + 29*s - 29) - 3*fd*(2*C*(44*r**2 + r*(44*s - 69) - 29*s + 18) - 64*r**2 + r*(102 - 64*s) + 43*s - 27)) - 6*Dd*f*(C*(88*r**2 + 4*r*(22*s - 47) - 83*s + 72) - 64*r**2 + r*(140 - 64*s) + 62*s - 54)) - 3*D1*f*(Dd*(-f*(16*C - 11)*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(20*C - 15)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + Ddd*f*(20*C - 15)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f**2*(20*C - 15)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(105*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct**2*k1*k2**2*(378*D1**2*K*bd1**2*f*r + 189*D1**2*K*bd1**2*f*s - 189*D1**2*K*bd1**2*f + 81*D1**2*K*bd1*f**2*r**2 + 81*D1**2*K*bd1*f**2*r*s - 81*D1**2*K*bd1*f**2*r - 540*D1**2*K*bd1*f*fd*r**2 - 540*D1**2*K*bd1*f*fd*r*s + 540*D1**2*K*bd1*f*fd*r + 135*D1**2*K*bd1*f*fd*s - 135*D1**2*K*bd1*f*fd - 135*D1**2*K*bdd1*f**2*r**2 - 135*D1**2*K*bdd1*f**2*r*s + 135*D1**2*K*bdd1*f**2*r + 180*D1**2*bd1**2*f**2*r**2 + 180*D1**2*bd1**2*f**2*r*s - 405*D1**2*bd1**2*f**2*r - 180*D1**2*bd1**2*f**2*s + 135*D1**2*bd1**2*f**2 + 126*D1**2*bd1**2*f*r**2 + 126*D1**2*bd1**2*f*r*s - 441*D1**2*bd1**2*f*r - 189*D1**2*bd1**2*f*s + 189*D1**2*bd1**2*f - 1260*D1**2*bd1**2*g2*r**2 - 1260*D1**2*bd1**2*g2*r*s + 1260*D1**2*bd1**2*g2*r + 630*D1**2*bd1**2*g2*s - 378*D1**2*bd1*bd2*f*r**2 - 378*D1**2*bd1*bd2*f*r*s + 567*D1**2*bd1*bd2*f*r + 189*D1**2*bd1*bd2*f*s - 189*D1**2*bd1*bd2*f - 100*D1**2*bd1*f**3*r**2 - 100*D1**2*bd1*f**3*r*s + 75*D1**2*bd1*f**3*r + 840*D1**2*bd1*f**2*fd*r**2 + 840*D1**2*bd1*f**2*fd*r*s - 770*D1**2*bd1*f**2*fd*r - 140*D1**2*bd1*f**2*fd*s + 105*D1**2*bd1*f**2*fd - 81*D1**2*bd1*f**2*r**2 - 81*D1**2*bd1*f**2*r*s + 81*D1**2*bd1*f**2*r + 540*D1**2*bd1*f*fd*r**2 + 540*D1**2*bd1*f*fd*r*s - 540*D1**2*bd1*f*fd*r - 135*D1**2*bd1*f*fd*s + 135*D1**2*bd1*f*fd + 252*D1**2*bd1*f*g2*r + 126*D1**2*bd1*f*g2*s - 126*D1**2*bd1*f*g2 - 756*D1**2*bd1*f*gd2*r - 378*D1**2*bd1*f*gd2*s + 378*D1**2*bd1*f*gd2 + 81*D1**2*bd2*f**2*r**2 + 81*D1**2*bd2*f**2*r*s - 81*D1**2*bd2*f**2*r - 540*D1**2*bd2*f*fd*r**2 - 540*D1**2*bd2*f*fd*r*s + 540*D1**2*bd2*f*fd*r + 135*D1**2*bd2*f*fd*s - 135*D1**2*bd2*f*fd + 140*D1**2*bdd1*f**3*r**2 + 140*D1**2*bdd1*f**3*r*s - 105*D1**2*bdd1*f**3*r + 135*D1**2*bdd1*f**2*r**2 + 135*D1**2*bdd1*f**2*r*s - 135*D1**2*bdd1*f**2*r - 756*D1**2*bdd1*f*g2*r - 378*D1**2*bdd1*f*g2*s + 378*D1**2*bdd1*f*g2 - 135*D1**2*bdd2*f**2*r**2 - 135*D1**2*bdd2*f**2*r*s + 135*D1**2*bdd2*f**2*r - 162*D1**2*f**2*gd2*r**2 - 162*D1**2*f**2*gd2*r*s + 162*D1**2*f**2*gd2*r + 270*D1**2*f**2*gdd2*r**2 + 270*D1**2*f**2*gdd2*r*s - 270*D1**2*f**2*gdd2*r - 324*D1**2*f*fd*g2*r**2 - 324*D1**2*f*fd*g2*r*s + 324*D1**2*f*fd*g2*r + 162*D1**2*f*fd*g2*s - 162*D1**2*f*fd*g2 + 1080*D1**2*f*fd*gd2*r**2 + 1080*D1**2*f*fd*gd2*r*s - 1080*D1**2*f*fd*gd2*r - 270*D1**2*f*fd*gd2*s + 270*D1**2*f*fd*gd2 + 540*D1**2*f*fdd*g2*r**2 + 540*D1**2*f*fdd*g2*r*s - 540*D1**2*f*fdd*g2*r - 270*D1**2*f*fdd*g2*s + 270*D1**2*f*fdd*g2 + 540*D1**2*fd**2*g2*r**2 + 540*D1**2*fd**2*g2*r*s - 540*D1**2*fd**2*g2*r - 270*D1**2*fd**2*g2*s - 1080*D1*Dd*K*bd1*f**2*r**2 - 1080*D1*Dd*K*bd1*f**2*r*s + 1080*D1*Dd*K*bd1*f**2*r + 135*D1*Dd*K*bd1*f**2*s - 135*D1*Dd*K*bd1*f**2 + 1120*D1*Dd*bd1*f**3*r**2 + 1120*D1*Dd*bd1*f**3*r*s - 980*D1*Dd*bd1*f**3*r - 140*D1*Dd*bd1*f**3*s + 105*D1*Dd*bd1*f**3 + 1080*D1*Dd*bd1*f**2*r**2 + 1080*D1*Dd*bd1*f**2*r*s - 1080*D1*Dd*bd1*f**2*r - 135*D1*Dd*bd1*f**2*s + 135*D1*Dd*bd1*f**2 - 3024*D1*Dd*bd1*f*g2*r - 1512*D1*Dd*bd1*f*g2*s + 1512*D1*Dd*bd1*f*g2 - 1080*D1*Dd*bd2*f**2*r**2 - 1080*D1*Dd*bd2*f**2*r*s + 1080*D1*Dd*bd2*f**2*r + 135*D1*Dd*bd2*f**2*s - 135*D1*Dd*bd2*f**2 - 648*D1*Dd*f**2*g2*r**2 - 648*D1*Dd*f**2*g2*r*s + 648*D1*Dd*f**2*g2*r + 162*D1*Dd*f**2*g2*s - 162*D1*Dd*f**2*g2 + 2160*D1*Dd*f**2*gd2*r**2 + 2160*D1*Dd*f**2*gd2*r*s - 2160*D1*Dd*f**2*gd2*r - 270*D1*Dd*f**2*gd2*s + 270*D1*Dd*f**2*gd2 + 4320*D1*Dd*f*fd*g2*r**2 + 4320*D1*Dd*f*fd*g2*r*s - 4320*D1*Dd*f*fd*g2*r - 1620*D1*Dd*f*fd*g2*s + 1080*D1*Dd*f*fd*g2 + 1080*D1*Ddd*f**2*g2*r**2 + 1080*D1*Ddd*f**2*g2*r*s - 1080*D1*Ddd*f**2*g2*r - 270*D1*Ddd*f**2*g2*s + 270*D1*Ddd*f**2*g2 + 3240*Dd**2*f**2*g2*r**2 + 3240*Dd**2*f**2*g2*r*s - 3240*Dd**2*f**2*g2*r - 810*Dd**2*f**2*g2*s + 540*Dd**2*f**2*g2 + 21*b1**3*(2*D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + (15*K - 10)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-15*K + 6*f + 10)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-15*K + 6*f + 10)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1**2*(42*D1**2*K*fd*r + 21*D1**2*K*fd*s - 21*D1**2*K*fd - 126*D1**2*K*fdd*r - 63*D1**2*K*fdd*s + 63*D1**2*K*fdd - 7*D1**2*bdd1*(-15*K + 6*f + 10)*(3*r**2 + 3*r*(s - 1) - s + 1) - 36*D1**2*f*fd*r**2 - 36*D1**2*f*fd*r*s - 9*D1**2*f*fd*r - 18*D1**2*f*fd*s + 18*D1**2*f*fd + 60*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 30*D1**2*f*fdd*s - 30*D1**2*f*fdd + 60*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s + 15*D1**2*fd**2*r + 30*D1**2*fd**2*s - 30*D1**2*fd**2 - 7*D1**2*fd*r**2 - 7*D1**2*fd*r*s - 28*D1**2*fd*r - 14*D1**2*fd*s + 14*D1**2*fd + 21*D1**2*fdd*r**2 + 21*D1**2*fdd*r*s + 84*D1**2*fdd*r + 42*D1**2*fdd*s - 42*D1**2*fdd - 210*D1**2*gd2*r**2 - 210*D1**2*gd2*r*s + 210*D1**2*gd2*r - 210*D1**2*gdd2*r**2 - 210*D1**2*gdd2*r*s + 210*D1**2*gdd2*r - 504*D1*Dd*K*fd*r - 252*D1*Dd*K*fd*s + 252*D1*Dd*K*fd - 72*D1*Dd*f**2*r**2 - 72*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r + 18*D1*Dd*f**2*s - 18*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 180*D1*Dd*f*fd*r + 60*D1*Dd*f*fd*s - 75*D1*Dd*f*fd - 28*D1*Dd*f*r**2 - 28*D1*Dd*f*r*s + 28*D1*Dd*f*r + 7*D1*Dd*f*s - 7*D1*Dd*f + 168*D1*Dd*fd*r**2 + 168*D1*Dd*fd*r*s + 252*D1*Dd*fd*r + 147*D1*Dd*fd*s - 168*D1*Dd*fd - 840*D1*Dd*g2*r**2 - 840*D1*Dd*g2*r*s + 840*D1*Dd*g2*r + 210*D1*Dd*g2*s - 210*D1*Dd*g2 - 1680*D1*Dd*gd2*r**2 - 1680*D1*Dd*gd2*r*s + 1680*D1*Dd*gd2*r + 210*D1*Dd*gd2*s - 210*D1*Dd*gd2 + 120*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r - 30*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 + 84*D1*Ddd*f*r*s - 84*D1*Ddd*f*r - 21*D1*Ddd*f*s + 21*D1*Ddd*f - 840*D1*Ddd*g2*r**2 - 840*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r + 210*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 7*D1*bd1*(D1*(f*(6*r**2 + 6*r*(s - 1) - 2*s + 2) - 6*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + (15*K - 10)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-15*K + 6*f + 10)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 360*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 360*Dd**2*f**2*r - 90*Dd**2*f**2*s + 60*Dd**2*f**2 + 252*Dd**2*f*r**2 + 252*Dd**2*f*r*s - 252*Dd**2*f*r - 63*Dd**2*f*s + 42*Dd**2*f - 2520*Dd**2*g2*r**2 - 2520*Dd**2*g2*r*s + 2520*Dd**2*g2*r + 630*Dd**2*g2*s - 420*Dd**2*g2) + b1*(162*D1**2*K*f*fd*r**2 + 162*D1**2*K*f*fd*r*s - 162*D1**2*K*f*fd*r - 81*D1**2*K*f*fd*s + 81*D1**2*K*f*fd - 270*D1**2*K*f*fdd*r**2 - 270*D1**2*K*f*fdd*r*s + 270*D1**2*K*f*fdd*r + 135*D1**2*K*f*fdd*s - 135*D1**2*K*f*fdd - 270*D1**2*K*fd**2*r**2 - 270*D1**2*K*fd**2*r*s + 270*D1**2*K*fd**2*r + 135*D1**2*K*fd**2*s + 63*D1**2*b2*fd*r**2 + 63*D1**2*b2*fd*r*s - 189*D1**2*b2*fdd*r**2 - 189*D1**2*b2*fdd*r*s - 21*D1**2*bd1**2*(-15*K + 6*f + 10)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 63*D1**2*bd2*f*r**2 + 63*D1**2*bd2*f*r*s - 63*D1**2*bd2*f*r - 378*D1**2*bd2*fd*r**2 - 378*D1**2*bd2*fd*r*s + 189*D1**2*bd2*fd*r + 9*D1**2*bdd1*(5*f**2*(4*r**2 + r*(4*s - 9) - 4*s + 4) + 7*f*(3*K*(2*r + s - 1) + 2*r**2 + 2*r*s - 7*r - 3*s + 3) - 70*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 189*D1**2*bdd2*f*r**2 - 189*D1**2*bdd2*f*r*s + 189*D1**2*bdd2*f*r - 300*D1**2*f**2*fd*r**2 - 300*D1**2*f**2*fd*r*s + 325*D1**2*f**2*fd*r + 100*D1**2*f**2*fd*s - 100*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 420*D1**2*f**2*fdd*r*s - 455*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd*s + 140*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 840*D1**2*f*fd**2*r*s - 910*D1**2*f*fd**2*r - 280*D1**2*f*fd**2*s + 175*D1**2*f*fd**2 - 162*D1**2*f*fd*r**2 - 162*D1**2*f*fd*r*s + 162*D1**2*f*fd*r + 81*D1**2*f*fd*s - 81*D1**2*f*fd + 270*D1**2*f*fdd*r**2 + 270*D1**2*f*fdd*r*s - 270*D1**2*f*fdd*r - 135*D1**2*f*fdd*s + 135*D1**2*f*fdd + 270*D1**2*fd**2*r**2 + 270*D1**2*fd**2*r*s - 270*D1**2*fd**2*r - 135*D1**2*fd**2*s - 252*D1**2*fd*g2*r - 126*D1**2*fd*g2*s + 126*D1**2*fd*g2 + 756*D1**2*fd*gd2*r + 378*D1**2*fd*gd2*s - 378*D1**2*fd*gd2 + 756*D1**2*fdd*g2*r + 378*D1**2*fdd*g2*s - 378*D1**2*fdd*g2 + 324*D1*Dd*K*f**2*r**2 + 324*D1*Dd*K*f**2*r*s - 324*D1*Dd*K*f**2*r - 81*D1*Dd*K*f**2*s + 81*D1*Dd*K*f**2 - 2160*D1*Dd*K*f*fd*r**2 - 2160*D1*Dd*K*f*fd*r*s + 2160*D1*Dd*K*f*fd*r + 810*D1*Dd*K*f*fd*s - 540*D1*Dd*K*f*fd + 252*D1*Dd*b2*f*r**2 + 252*D1*Dd*b2*f*r*s - 252*D1*Dd*b2*f*r - 63*D1*Dd*b2*f*s + 63*D1*Dd*b2*f - 1512*D1*Dd*b2*fd*r**2 - 1512*D1*Dd*b2*fd*r*s + 756*D1*Dd*b2*fd*r + 189*D1*Dd*b2*fd*s - 1512*D1*Dd*bd2*f*r**2 - 1512*D1*Dd*bd2*f*r*s + 1512*D1*Dd*bd2*f*r + 189*D1*Dd*bd2*f*s - 189*D1*Dd*bd2*f - 400*D1*Dd*f**3*r**2 - 400*D1*Dd*f**3*r*s + 400*D1*Dd*f**3*r + 100*D1*Dd*f**3*s - 100*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 3360*D1*Dd*f**2*fd*r*s - 3500*D1*Dd*f**2*fd*r - 980*D1*Dd*f**2*fd*s + 735*D1*Dd*f**2*fd - 324*D1*Dd*f**2*r**2 - 324*D1*Dd*f**2*r*s + 324*D1*Dd*f**2*r + 81*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 2160*D1*Dd*f*fd*r**2 + 2160*D1*Dd*f*fd*r*s - 2160*D1*Dd*f*fd*r - 810*D1*Dd*f*fd*s + 540*D1*Dd*f*fd + 3024*D1*Dd*fd*g2*r + 1512*D1*Dd*fd*g2*s - 1512*D1*Dd*fd*g2 - 540*D1*Ddd*K*f**2*r**2 - 540*D1*Ddd*K*f**2*r*s + 540*D1*Ddd*K*f**2*r + 135*D1*Ddd*K*f**2*s - 135*D1*Ddd*K*f**2 - 756*D1*Ddd*b2*f*r**2 - 756*D1*Ddd*b2*f*r*s + 756*D1*Ddd*b2*f*r + 189*D1*Ddd*b2*f*s - 189*D1*Ddd*b2*f + 560*D1*Ddd*f**3*r**2 + 560*D1*Ddd*f**3*r*s - 560*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s + 140*D1*Ddd*f**3 + 540*D1*Ddd*f**2*r**2 + 540*D1*Ddd*f**2*r*s - 540*D1*Ddd*f**2*r - 135*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 - 3*D1*bd1*(D1*(9*f**2*(4*r**2 + r*(4*s - 9) - 4*s + 4) + f*(21*K*(2*r + s - 1) - 15*fd*(4*r - 1)*(4*r + 4*s - 3) + 14*r**2 + 14*r*s - 49*r - 21*s + 21) - 21*fd*(-3*K*(2*r + s - 1) + 4*r**2 + 4*r*s + r + s - 2) + 210*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 210*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd*(5*f**2*(32*r**2 + 4*r*(8*s - 13) - 20*s + 17) + 7*f*(12*K*(2*r + s - 1) + 16*r**2 + 4*r*(4*s - 9) - 14*s + 13) - 140*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 1620*Dd**2*K*f**2*r**2 - 1620*Dd**2*K*f**2*r*s + 1620*Dd**2*K*f**2*r + 405*Dd**2*K*f**2*s - 270*Dd**2*K*f**2 - 2268*Dd**2*b2*f*r**2 - 2268*Dd**2*b2*f*r*s + 2268*Dd**2*b2*f*r + 567*Dd**2*b2*f*s - 378*Dd**2*b2*f + 1680*Dd**2*f**3*r**2 + 1680*Dd**2*f**3*r*s - 1680*Dd**2*f**3*r - 420*Dd**2*f**3*s + 280*Dd**2*f**3 + 1620*Dd**2*f**2*r**2 + 1620*Dd**2*f**2*r*s - 1620*Dd**2*f**2*r - 405*Dd**2*f**2*s + 270*Dd**2*f**2) + 9*b2*(-21*D1**2*bdd1*f*(r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 10*fd*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(315*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct**2*k1*(2*C - 1)*(-3*D1*f*(7*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + 5*D1*bdd1*f*r*(r + s) + bd1*(D1*(-3*f*r*(r + s) + 5*fd*(4*r**2 + 4*r*s - 3*r - s)) + 5*Dd*f*(8*r**2 + r*(8*s - 4) - s))) + 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-21*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*D1**2*(2*r - 1)*(r + s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + 7*D1*bd1*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 5*fd*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(105*d**2*k3) + D1**2*Pkd1*Pkd3*ct**2*k2**4*st**4*(-18*D1**2*b1*f*fd*r**2 - 18*D1**2*b1*f*fd*r*s + 9*D1**2*b1*f*fd*r + 30*D1**2*b1*f*fdd*r**2 + 30*D1**2*b1*f*fdd*r*s - 15*D1**2*b1*f*fdd*r + 30*D1**2*b1*fd**2*r**2 + 30*D1**2*b1*fd**2*r*s - 15*D1**2*b1*fd**2*r + 15*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 21*D1**2*f**2*fd*r**2 - 21*D1**2*f**2*fd*r*s + 21*D1**2*f**2*fd*r + 7*D1**2*f**2*fd*s - 7*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r - 10*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 - 36*D1*Dd*b1*f**2*r**2 - 36*D1*Dd*b1*f**2*r*s + 36*D1*Dd*b1*f**2*r + 9*D1*Dd*b1*f**2*s - 9*D1*Dd*b1*f**2 + 240*D1*Dd*b1*f*fd*r**2 + 240*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r - 30*D1*Dd*b1*f*fd*s + 15*D1*Dd*b1*f*fd - 28*D1*Dd*f**3*r**2 - 28*D1*Dd*f**3*r*s + 28*D1*Dd*f**3*r + 7*D1*Dd*f**3*s - 7*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 120*D1*Dd*f**2*fd*r - 35*D1*Dd*f**2*fd*s + 25*D1*Dd*f**2*fd + 60*D1*Ddd*b1*f**2*r**2 + 60*D1*Ddd*b1*f**2*r*s - 60*D1*Ddd*b1*f**2*r - 15*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r - 5*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 - 3*D1*bd1*f*(D1*(3*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 180*Dd**2*b1*f**2*r**2 + 180*Dd**2*b1*f**2*r*s - 180*Dd**2*b1*f**2*r - 45*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 60*Dd**2*f**3*r - 15*Dd**2*f**3*s + 10*Dd**2*f**3)/(105*d**2*k1*k3**3) + D1**2*Pkd1*Pkd3*ct**2*k2**4*st**2*(D1*f*(3*D1*bd1**2*(6*f*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + (14*r - 7)*(r + s - 1)) + D1*bdd1*f*r*(10*f*(2*r + 2*s - 1) + 9*r + 9*s - 9) + bd1*(D1*(-11*f*r*(f*(2*r + 2*s - 1) + r + s - 1) + fd*(10*f*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1) + 36*r**2 + 36*r*(s - 1) - 9*s + 9)) + Dd*f*(10*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 72*r**2 + 72*r*(s - 1) - 9*s + 9))) + b1**2*(D1**2*r*(-3*f*(5*fd - 6*fdd)*(4*r + 4*s - 3) + 18*fd**2*(4*r + 4*s - 3) - 7*fd*(r + s) + 21*fdd*(r + s)) + D1*(Dd*(-30*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(18*fd*(8*r - 1)*(4*r + 4*s - 3) - 28*r**2 - 28*r*(s - 1) + 7*s - 7) + 21*fd*(8*r**2 + r*(8*s - 4) - s)) + 3*Ddd*f*(12*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*Dd**2*f*(12*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(3*D1**2*bdd1*f*(6*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + (14*r - 7)*(r + s - 1)) - 66*D1**2*f**2*fd*r**2 - 66*D1**2*f**2*fd*r*s + 77*D1**2*f**2*fd*r + 22*D1**2*f**2*fd*s - 22*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 60*D1**2*f**2*fdd*r*s - 70*D1**2*f**2*fdd*r - 20*D1**2*f**2*fdd*s + 20*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 120*D1**2*f*fd**2*r*s - 140*D1**2*f*fd**2*r - 40*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 - 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r*s + 22*D1**2*f*fd*r + 11*D1**2*f*fd*s - 11*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*r - 9*D1**2*fd**2*s - 88*D1*Dd*f**3*r**2 - 88*D1*Dd*f**3*r*s + 88*D1*Dd*f**3*r + 22*D1*Dd*f**3*s - 22*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 480*D1*Dd*f**2*fd*r*s - 520*D1*Dd*f**2*fd*r - 140*D1*Dd*f**2*fd*s + 110*D1*Dd*f**2*fd - 44*D1*Dd*f**2*r**2 - 44*D1*Dd*f**2*r*s + 44*D1*Dd*f**2*r + 11*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 144*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r - 54*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 80*D1*Ddd*f**3*r**2 + 80*D1*Ddd*f**3*r*s - 80*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s + 20*D1*Ddd*f**3 + 36*D1*Ddd*f**2*r**2 + 36*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r - 9*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + D1*bd1*(D1*(-15*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(18*fd*(4*r - 1)*(4*r + 4*s - 3) + (7 - 14*r)*(r + s - 1)) + 21*fd*(4*r**2 + r*(4*s - 3) - s)) + 3*Dd*f*(6*f*(8*r - 3)*(4*r + 4*s - 3) + 112*r**2 + 28*r*(4*s - 5) - 42*s + 35)) + 240*Dd**2*f**3*r**2 + 240*Dd**2*f**3*r*s - 240*Dd**2*f**3*r - 60*Dd**2*f**3*s + 40*Dd**2*f**3 + 108*Dd**2*f**2*r**2 + 108*Dd**2*f**2*r*s - 108*Dd**2*f**2*r - 27*Dd**2*f**2*s + 18*Dd**2*f**2))/(105*d**2*k1*k3**3) + D1**2*Pkd1*Pkd3*ct**2*k2**2*st**2*(D1*f*(21*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + 9*D1*bdd1*f*r*(r + s) + bd1*(D1*(-11*f*r*(r + s) + 9*fd*(4*r**2 + 4*r*s - 3*r - s)) + 9*Dd*f*(8*r**2 + r*(8*s - 4) - s))) - 7*b1**2*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(21*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r*s + 33*D1**2*f*fd*r + 11*D1**2*f*fd*s - 11*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 18*D1**2*f*fdd*r*s - 27*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 18*D1**2*fd**2*r*s - 27*D1**2*fd**2*r - 9*D1**2*fd**2*s + 9*D1**2*fd**2 - 44*D1*Dd*f**2*r**2 - 44*D1*Dd*f**2*r*s + 44*D1*Dd*f**2*r + 11*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 144*D1*Dd*f*fd*r*s - 180*D1*Dd*f*fd*r - 54*D1*Dd*f*fd*s + 45*D1*Dd*f*fd + 36*D1*Ddd*f**2*r**2 + 36*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r - 9*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 - 7*D1*bd1*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 108*Dd**2*f**2*r**2 + 108*Dd**2*f**2*r*s - 108*Dd**2*f**2*r - 27*Dd**2*f**2*s + 18*Dd**2*f**2))/(105*d**2*k1*k3) + D1**2*Pkd1*Pkd3*ct**2*k2**2*(3*D1**2*bd1**2*f*r*(5*f + 7)*(2*r + 2*s - 1) + D1*b1*(7*D1*bd1**2*(3*f + 5)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 3*D1*bdd1*f*r*(5*f + 7)*(2*r + 2*s - 1) + bd1*(D1*(-f*r*(9*f + 7)*(2*r + 2*s - 1) + 3*fd*(5*f*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + 28*r**2 + 7*r*(4*s - 5) - 14*s + 7)) + 3*Dd*f*(5*f + 7)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1))) - 7*b1**3*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1) - 20*r**2 - 20*r*(s - 1) + 5*s - 5) - Ddd*(3*f + 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(3*f + 5)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(7*D1**2*bdd1*(3*f + 5)*(3*r**2 + 3*r*(s - 1) - s + 1) - 18*D1**2*f*fd*r**2 - 18*D1**2*f*fd*r*s + 27*D1**2*f*fd*r + 9*D1**2*f*fd*s - 9*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 30*D1**2*f*fdd*r*s - 45*D1**2*f*fdd*r - 15*D1**2*f*fdd*s + 15*D1**2*f*fdd + 30*D1**2*fd**2*r**2 + 30*D1**2*fd**2*r*s - 45*D1**2*fd**2*r - 15*D1**2*fd**2*s + 15*D1**2*fd**2 - 7*D1**2*fd*r**2 - 7*D1**2*fd*r*s + 14*D1**2*fd*r + 7*D1**2*fd*s - 7*D1**2*fd + 21*D1**2*fdd*r**2 + 21*D1**2*fdd*r*s - 42*D1**2*fdd*r - 21*D1**2*fdd*s + 21*D1**2*fdd - 36*D1*Dd*f**2*r**2 - 36*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r + 9*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 240*D1*Dd*f*fd*r*s - 300*D1*Dd*f*fd*r - 90*D1*Dd*f*fd*s + 75*D1*Dd*f*fd - 28*D1*Dd*f*r**2 - 28*D1*Dd*f*r*s + 28*D1*Dd*f*r + 7*D1*Dd*f*s - 7*D1*Dd*f + 168*D1*Dd*fd*r**2 + 168*D1*Dd*fd*r*s - 252*D1*Dd*fd*r - 105*D1*Dd*fd*s + 84*D1*Dd*fd + 60*D1*Ddd*f**2*r**2 + 60*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r - 15*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 + 84*D1*Ddd*f*r*s - 84*D1*Ddd*f*r - 21*D1*Ddd*f*s + 21*D1*Ddd*f - 7*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1) - 15*r**2 - 15*r*(s - 1) + 5*s - 5) - Dd*(3*f + 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 180*Dd**2*f**2*r**2 + 180*Dd**2*f**2*r*s - 180*Dd**2*f**2*r - 45*Dd**2*f**2*s + 30*Dd**2*f**2 + 252*Dd**2*f*r**2 + 252*Dd**2*f*r*s - 252*Dd**2*f*r - 63*Dd**2*f*s + 42*Dd**2*f))/(105*d**2*k1*k3) - 2*D1**2*Pkd1*Pkd3*ct*k1**4*k2*st**2*(18*C*D1**2*b1*f*fd*r**2 + 18*C*D1**2*b1*f*fd*r*s - 9*C*D1**2*b1*f*fd*r - 198*C*D1**2*b1*f*fdd*r**2 - 198*C*D1**2*b1*f*fdd*r*s + 99*C*D1**2*b1*f*fdd*r - 198*C*D1**2*b1*fd**2*r**2 - 198*C*D1**2*b1*fd**2*r*s + 99*C*D1**2*b1*fd**2*r + 87*C*D1**2*f**2*fd*r**2 + 87*C*D1**2*f**2*fd*r*s - 87*C*D1**2*f**2*fd*r - 29*C*D1**2*f**2*fd*s + 29*C*D1**2*f**2*fd - 165*C*D1**2*f**2*fdd*r**2 - 165*C*D1**2*f**2*fdd*r*s + 165*C*D1**2*f**2*fdd*r + 55*C*D1**2*f**2*fdd*s - 55*C*D1**2*f**2*fdd - 330*C*D1**2*f*fd**2*r**2 - 330*C*D1**2*f*fd**2*r*s + 330*C*D1**2*f*fd**2*r + 110*C*D1**2*f*fd**2*s - 55*C*D1**2*f*fd**2 + 36*C*D1*Dd*b1*f**2*r**2 + 36*C*D1*Dd*b1*f**2*r*s - 36*C*D1*Dd*b1*f**2*r - 9*C*D1*Dd*b1*f**2*s + 9*C*D1*Dd*b1*f**2 - 1584*C*D1*Dd*b1*f*fd*r**2 - 1584*C*D1*Dd*b1*f*fd*r*s + 1188*C*D1*Dd*b1*f*fd*r + 198*C*D1*Dd*b1*f*fd*s - 99*C*D1*Dd*b1*f*fd + 116*C*D1*Dd*f**3*r**2 + 116*C*D1*Dd*f**3*r*s - 116*C*D1*Dd*f**3*r - 29*C*D1*Dd*f**3*s + 29*C*D1*Dd*f**3 - 1320*C*D1*Dd*f**2*fd*r**2 - 1320*C*D1*Dd*f**2*fd*r*s + 1320*C*D1*Dd*f**2*fd*r + 385*C*D1*Dd*f**2*fd*s - 275*C*D1*Dd*f**2*fd - 396*C*D1*Ddd*b1*f**2*r**2 - 396*C*D1*Ddd*b1*f**2*r*s + 396*C*D1*Ddd*b1*f**2*r + 99*C*D1*Ddd*b1*f**2*s - 99*C*D1*Ddd*b1*f**2 - 220*C*D1*Ddd*f**3*r**2 - 220*C*D1*Ddd*f**3*r*s + 220*C*D1*Ddd*f**3*r + 55*C*D1*Ddd*f**3*s - 55*C*D1*Ddd*f**3 - 1188*C*Dd**2*b1*f**2*r**2 - 1188*C*Dd**2*b1*f**2*r*s + 1188*C*Dd**2*b1*f**2*r + 297*C*Dd**2*b1*f**2*s - 198*C*Dd**2*b1*f**2 - 660*C*Dd**2*f**3*r**2 - 660*C*Dd**2*f**3*r*s + 660*C*Dd**2*f**3*r + 165*C*Dd**2*f**3*s - 110*C*Dd**2*f**3 - 6*D1**2*b1*f*fd*r**2 - 6*D1**2*b1*f*fd*r*s + 3*D1**2*b1*f*fd*r + 108*D1**2*b1*f*fdd*r**2 + 108*D1**2*b1*f*fdd*r*s - 54*D1**2*b1*f*fdd*r + 108*D1**2*b1*fd**2*r**2 + 108*D1**2*b1*fd**2*r*s - 54*D1**2*b1*fd**2*r - 9*D1**2*bdd1*f**2*(11*C - 6)*(r - 1)*(r + s - 1) - 45*D1**2*f**2*fd*r**2 - 45*D1**2*f**2*fd*r*s + 45*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r**2 + 90*D1**2*f**2*fdd*r*s - 90*D1**2*f**2*fdd*r - 30*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r**2 + 180*D1**2*f*fd**2*r*s - 180*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 - 12*D1*Dd*b1*f**2*r**2 - 12*D1*Dd*b1*f**2*r*s + 12*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2*s - 3*D1*Dd*b1*f**2 + 864*D1*Dd*b1*f*fd*r**2 + 864*D1*Dd*b1*f*fd*r*s - 648*D1*Dd*b1*f*fd*r - 108*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 60*D1*Dd*f**3*r**2 - 60*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r + 15*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r**2 + 720*D1*Dd*f**2*fd*r*s - 720*D1*Dd*f**2*fd*r - 210*D1*Dd*f**2*fd*s + 150*D1*Dd*f**2*fd + 216*D1*Ddd*b1*f**2*r**2 + 216*D1*Ddd*b1*f**2*r*s - 216*D1*Ddd*b1*f**2*r - 54*D1*Ddd*b1*f**2*s + 54*D1*Ddd*b1*f**2 + 120*D1*Ddd*f**3*r**2 + 120*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r - 30*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(3*C - 1)*(r - 1)*(r + s - 1) - fd*(33*C - 18)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(18 - 33*C)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 648*Dd**2*b1*f**2*r**2 + 648*Dd**2*b1*f**2*r*s - 648*Dd**2*b1*f**2*r - 162*Dd**2*b1*f**2*s + 108*Dd**2*b1*f**2 + 360*Dd**2*f**3*r**2 + 360*Dd**2*f**3*r*s - 360*Dd**2*f**3*r - 90*Dd**2*f**3*s + 60*Dd**2*f**3)/(315*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct*k1**4*k2*(-9*D1**2*bd1**2*f*(2*r - 1)*(-35*K + 5*f + 7)*(r + s - 1) - 5*D1**2*bdd1*f*(f*r*(-45*K + 7*f + 9) + 126*g2*(r - 1))*(r + s - 1) + 90*D1**2*(f**2*r*(3*gd2 - 5*gdd2)*(r + s - 1) + f*(fd*(g2*(6*r**2 + 6*r*(s - 1) - 3*s + 3) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 5*fd**2*g2*(-2*r**2 - 2*r*(s - 1) + s)) + D1*bd1*(D1*(25*f**3*r*(r + s - 1) + f**2*(-35*fd*(6*r**2 + 6*r*(s - 1) - s + 1) - r*(135*K - 27)*(r + s - 1)) + 15*f*(3*fd*(5*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (14*g2*(r - 1) + 14*gd2*(3 - 6*r))*(r + s - 1)) - 630*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(7*f**2*(8*r**2 + 8*r*(s - 1) - s + 1) - 9*f*(5*K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 90*D1*f*(Dd*(f*(3*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) - 10*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 5*Ddd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 450*Dd**2*f**2*g2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 3*b1**2*(D1**2*r*(3*f*(3*fd - 5*fdd)*(2*r + 2*s - 1) - 15*fd**2*(2*r + 2*s - 1) - 7*fd*(5*K - 1)*(r + s) + 21*fdd*(5*K - 1)*(r + s)) + D1*(Dd*(9*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-15*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (7 - 35*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(5*K - 1)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-35*K + 5*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-35*K + 5*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-270*D1**2*K*f*fd*r**2 - 270*D1**2*K*f*fd*r*s + 270*D1**2*K*f*fd*r + 135*D1**2*K*f*fd*s - 135*D1**2*K*f*fd + 450*D1**2*K*f*fdd*r**2 + 450*D1**2*K*f*fdd*r*s - 450*D1**2*K*f*fdd*r - 225*D1**2*K*f*fdd*s + 225*D1**2*K*f*fdd + 450*D1**2*K*fd**2*r**2 + 450*D1**2*K*fd**2*r*s - 450*D1**2*K*fd**2*r - 225*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*r - 1)*(-35*K + 5*f + 7)*(r + s - 1) + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 54*D1**2*f*fd*r**2 + 54*D1**2*f*fd*r*s - 54*D1**2*f*fd*r - 27*D1**2*f*fd*s + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 90*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r + 45*D1**2*f*fdd*s - 45*D1**2*f*fdd + 210*D1**2*f*gd2*r**2 + 210*D1**2*f*gd2*r*s - 210*D1**2*f*gd2*r - 630*D1**2*f*gdd2*r**2 - 630*D1**2*f*gdd2*r*s + 630*D1**2*f*gdd2*r - 90*D1**2*fd**2*r**2 - 90*D1**2*fd**2*r*s + 90*D1**2*fd**2*r + 45*D1**2*fd**2*s + 210*D1**2*fd*g2*r**2 + 210*D1**2*fd*g2*r*s - 1260*D1**2*fd*gd2*r**2 - 1260*D1**2*fd*gd2*r*s + 630*D1**2*fd*gd2*r - 630*D1**2*fdd*g2*r**2 - 630*D1**2*fdd*g2*r*s - 540*D1*Dd*K*f**2*r**2 - 540*D1*Dd*K*f**2*r*s + 540*D1*Dd*K*f**2*r + 135*D1*Dd*K*f**2*s - 135*D1*Dd*K*f**2 + 3600*D1*Dd*K*f*fd*r**2 + 3600*D1*Dd*K*f*fd*r*s - 3600*D1*Dd*K*f*fd*r - 1350*D1*Dd*K*f*fd*s + 900*D1*Dd*K*f*fd + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 + 108*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r - 27*D1*Dd*f**2*s + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 720*D1*Dd*f*fd*r*s + 720*D1*Dd*f*fd*r + 270*D1*Dd*f*fd*s - 180*D1*Dd*f*fd + 840*D1*Dd*f*g2*r**2 + 840*D1*Dd*f*g2*r*s - 840*D1*Dd*f*g2*r - 210*D1*Dd*f*g2*s + 210*D1*Dd*f*g2 - 5040*D1*Dd*f*gd2*r**2 - 5040*D1*Dd*f*gd2*r*s + 5040*D1*Dd*f*gd2*r + 630*D1*Dd*f*gd2*s - 630*D1*Dd*f*gd2 - 5040*D1*Dd*fd*g2*r**2 - 5040*D1*Dd*fd*g2*r*s + 2520*D1*Dd*fd*g2*r + 630*D1*Dd*fd*g2*s + 900*D1*Ddd*K*f**2*r**2 + 900*D1*Ddd*K*f**2*r*s - 900*D1*Ddd*K*f**2*r - 225*D1*Ddd*K*f**2*s + 225*D1*Ddd*K*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 180*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r + 45*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 2520*D1*Ddd*f*g2*r**2 - 2520*D1*Ddd*f*g2*r*s + 2520*D1*Ddd*f*g2*r + 630*D1*Ddd*f*g2*s - 630*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(9*f**2*(2*r - 1)*(r + s - 1) + f*(-15*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (35*K - 7)*(2*r - 1)*(r + s - 1)) + 21*fd*(5*K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-35*K + 5*f + 7)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 2700*Dd**2*K*f**2*r**2 + 2700*Dd**2*K*f**2*r*s - 2700*Dd**2*K*f**2*r - 675*Dd**2*K*f**2*s + 450*Dd**2*K*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 540*Dd**2*f**2*r*s + 540*Dd**2*f**2*r + 135*Dd**2*f**2*s - 90*Dd**2*f**2 - 7560*Dd**2*f*g2*r**2 - 7560*Dd**2*f*g2*r*s + 7560*Dd**2*f*g2*r + 1890*Dd**2*f*g2*s - 1260*Dd**2*f*g2))/(315*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct*k1**2*k2**3*st**4*(6*C*D1**2*b1*f*fd*r**2 + 6*C*D1**2*b1*f*fd*r*s - 3*C*D1**2*b1*f*fd*r - 66*C*D1**2*b1*f*fdd*r**2 - 66*C*D1**2*b1*f*fdd*r*s + 33*C*D1**2*b1*f*fdd*r - 66*C*D1**2*b1*fd**2*r**2 - 66*C*D1**2*b1*fd**2*r*s + 33*C*D1**2*b1*fd**2*r + 39*C*D1**2*f**2*fd*r**2 + 39*C*D1**2*f**2*fd*r*s - 39*C*D1**2*f**2*fd*r - 13*C*D1**2*f**2*fd*s + 13*C*D1**2*f**2*fd - 33*C*D1**2*f**2*fdd*r**2 - 33*C*D1**2*f**2*fdd*r*s + 33*C*D1**2*f**2*fdd*r + 11*C*D1**2*f**2*fdd*s - 11*C*D1**2*f**2*fdd - 66*C*D1**2*f*fd**2*r**2 - 66*C*D1**2*f*fd**2*r*s + 66*C*D1**2*f*fd**2*r + 22*C*D1**2*f*fd**2*s - 11*C*D1**2*f*fd**2 + 12*C*D1*Dd*b1*f**2*r**2 + 12*C*D1*Dd*b1*f**2*r*s - 12*C*D1*Dd*b1*f**2*r - 3*C*D1*Dd*b1*f**2*s + 3*C*D1*Dd*b1*f**2 - 528*C*D1*Dd*b1*f*fd*r**2 - 528*C*D1*Dd*b1*f*fd*r*s + 396*C*D1*Dd*b1*f*fd*r + 66*C*D1*Dd*b1*f*fd*s - 33*C*D1*Dd*b1*f*fd + 52*C*D1*Dd*f**3*r**2 + 52*C*D1*Dd*f**3*r*s - 52*C*D1*Dd*f**3*r - 13*C*D1*Dd*f**3*s + 13*C*D1*Dd*f**3 - 264*C*D1*Dd*f**2*fd*r**2 - 264*C*D1*Dd*f**2*fd*r*s + 264*C*D1*Dd*f**2*fd*r + 77*C*D1*Dd*f**2*fd*s - 55*C*D1*Dd*f**2*fd - 132*C*D1*Ddd*b1*f**2*r**2 - 132*C*D1*Ddd*b1*f**2*r*s + 132*C*D1*Ddd*b1*f**2*r + 33*C*D1*Ddd*b1*f**2*s - 33*C*D1*Ddd*b1*f**2 - 44*C*D1*Ddd*f**3*r**2 - 44*C*D1*Ddd*f**3*r*s + 44*C*D1*Ddd*f**3*r + 11*C*D1*Ddd*f**3*s - 11*C*D1*Ddd*f**3 - 396*C*Dd**2*b1*f**2*r**2 - 396*C*Dd**2*b1*f**2*r*s + 396*C*Dd**2*b1*f**2*r + 99*C*Dd**2*b1*f**2*s - 66*C*Dd**2*b1*f**2 - 132*C*Dd**2*f**3*r**2 - 132*C*Dd**2*f**3*r*s + 132*C*Dd**2*f**3*r + 33*C*Dd**2*f**3*s - 22*C*Dd**2*f**3 + 42*D1**2*b1*f*fdd*r**2 + 42*D1**2*b1*f*fdd*r*s - 21*D1**2*b1*f*fdd*r + 42*D1**2*b1*fd**2*r**2 + 42*D1**2*b1*fd**2*r*s - 21*D1**2*b1*fd**2*r - 3*D1**2*bdd1*f**2*(11*C - 7)*(r - 1)*(r + s - 1) - 24*D1**2*f**2*fd*r**2 - 24*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r + 8*D1**2*f**2*fd*s - 8*D1**2*f**2*fd + 21*D1**2*f**2*fdd*r**2 + 21*D1**2*f**2*fdd*r*s - 21*D1**2*f**2*fdd*r - 7*D1**2*f**2*fdd*s + 7*D1**2*f**2*fdd + 42*D1**2*f*fd**2*r**2 + 42*D1**2*f*fd**2*r*s - 42*D1**2*f*fd**2*r - 14*D1**2*f*fd**2*s + 7*D1**2*f*fd**2 + 336*D1*Dd*b1*f*fd*r**2 + 336*D1*Dd*b1*f*fd*r*s - 252*D1*Dd*b1*f*fd*r - 42*D1*Dd*b1*f*fd*s + 21*D1*Dd*b1*f*fd - 32*D1*Dd*f**3*r**2 - 32*D1*Dd*f**3*r*s + 32*D1*Dd*f**3*r + 8*D1*Dd*f**3*s - 8*D1*Dd*f**3 + 168*D1*Dd*f**2*fd*r**2 + 168*D1*Dd*f**2*fd*r*s - 168*D1*Dd*f**2*fd*r - 49*D1*Dd*f**2*fd*s + 35*D1*Dd*f**2*fd + 84*D1*Ddd*b1*f**2*r**2 + 84*D1*Ddd*b1*f**2*r*s - 84*D1*Ddd*b1*f**2*r - 21*D1*Ddd*b1*f**2*s + 21*D1*Ddd*b1*f**2 + 28*D1*Ddd*f**3*r**2 + 28*D1*Ddd*f**3*r*s - 28*D1*Ddd*f**3*r - 7*D1*Ddd*f**3*s + 7*D1*Ddd*f**3 + 3*D1*bd1*f*(C*D1*(f*(r - 1)*(r + s - 1) - 11*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 11*C*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4) + 7*D1*fd*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 7*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 252*Dd**2*b1*f**2*r**2 + 252*Dd**2*b1*f**2*r*s - 252*Dd**2*b1*f**2*r - 63*Dd**2*b1*f**2*s + 42*Dd**2*b1*f**2 + 84*Dd**2*f**3*r**2 + 84*Dd**2*f**3*r*s - 84*Dd**2*f**3*r - 21*Dd**2*f**3*s + 14*Dd**2*f**3)/(105*d**2*k3**5) - D1**2*Pkd1*Pkd3*ct*k1**2*k2**3*st**2*(-891*D1**2*K*bdd1*f**2*r**2 - 891*D1**2*K*bdd1*f**2*r*s + 891*D1**2*K*bdd1*f**2*r + 99*D1**2*bd1**2*f*(2*r - 1)*(-21*K + 18*f + 7)*(r + s - 1) + 330*D1**2*bdd1*f**3*r**2 + 330*D1**2*bdd1*f**3*r*s + 330*D1**2*bdd1*f**3*r + 660*D1**2*bdd1*f**3*s - 660*D1**2*bdd1*f**3 + 297*D1**2*bdd1*f**2*r**2 + 297*D1**2*bdd1*f**2*r*s - 297*D1**2*bdd1*f**2*r + 4158*D1**2*bdd1*f*g2*r**2 + 4158*D1**2*bdd1*f*g2*r*s - 8316*D1**2*bdd1*f*g2*r - 4158*D1**2*bdd1*f*g2*s + 4158*D1**2*bdd1*f*g2 + 1160*D1**2*f**3*fd*r**2 + 1160*D1**2*f**3*fd*r*s - 1160*D1**2*f**3*fd*r - 290*D1**2*f**3*fd*s + 290*D1**2*f**3*fd - 1680*D1**2*f**3*fdd*r**2 - 1680*D1**2*f**3*fdd*r*s + 1680*D1**2*f**3*fdd*r + 420*D1**2*f**3*fdd*s - 420*D1**2*f**3*fdd - 5040*D1**2*f**2*fd**2*r**2 - 5040*D1**2*f**2*fd**2*r*s + 5040*D1**2*f**2*fd**2*r + 1260*D1**2*f**2*fd**2*s - 840*D1**2*f**2*fd**2 - 2178*D1**2*f**2*gd2*r**2 - 2178*D1**2*f**2*gd2*r*s + 2178*D1**2*f**2*gd2*r + 1782*D1**2*f**2*gdd2*r**2 + 1782*D1**2*f**2*gdd2*r*s - 1782*D1**2*f**2*gdd2*r - 4356*D1**2*f*fd*g2*r**2 - 4356*D1**2*f*fd*g2*r*s + 4356*D1**2*f*fd*g2*r + 2178*D1**2*f*fd*g2*s - 2178*D1**2*f*fd*g2 + 7128*D1**2*f*fd*gd2*r**2 + 7128*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r - 1782*D1**2*f*fd*gd2*s + 1782*D1**2*f*fd*gd2 + 3564*D1**2*f*fdd*g2*r**2 + 3564*D1**2*f*fdd*g2*r*s - 3564*D1**2*f*fdd*g2*r - 1782*D1**2*f*fdd*g2*s + 1782*D1**2*f*fdd*g2 + 3564*D1**2*fd**2*g2*r**2 + 3564*D1**2*fd**2*g2*r*s - 3564*D1**2*fd**2*g2*r - 1782*D1**2*fd**2*g2*s + 1160*D1*Dd*f**4*r**2 + 1160*D1*Dd*f**4*r*s - 1160*D1*Dd*f**4*r - 290*D1*Dd*f**4*s + 290*D1*Dd*f**4 - 13440*D1*Dd*f**3*fd*r**2 - 13440*D1*Dd*f**3*fd*r*s + 13440*D1*Dd*f**3*fd*r + 3360*D1*Dd*f**3*fd*s - 2520*D1*Dd*f**3*fd - 8712*D1*Dd*f**2*g2*r**2 - 8712*D1*Dd*f**2*g2*r*s + 8712*D1*Dd*f**2*g2*r + 2178*D1*Dd*f**2*g2*s - 2178*D1*Dd*f**2*g2 + 14256*D1*Dd*f**2*gd2*r**2 + 14256*D1*Dd*f**2*gd2*r*s - 14256*D1*Dd*f**2*gd2*r - 1782*D1*Dd*f**2*gd2*s + 1782*D1*Dd*f**2*gd2 + 28512*D1*Dd*f*fd*g2*r**2 + 28512*D1*Dd*f*fd*g2*r*s - 28512*D1*Dd*f*fd*g2*r - 10692*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 1680*D1*Ddd*f**4*r**2 - 1680*D1*Ddd*f**4*r*s + 1680*D1*Ddd*f**4*r + 420*D1*Ddd*f**4*s - 420*D1*Ddd*f**4 + 7128*D1*Ddd*f**2*g2*r**2 + 7128*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r - 1782*D1*Ddd*f**2*g2*s + 1782*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(2*f**3*(7*r + 5)*(r + s - 1) + f**2*(-10*fd*(6*r**2 + r*(6*s - 2) + 3*s - 1) + r*(11 - 33*K)*(r + s - 1)) + 9*f*fd*(3*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + 42*f*(g2*(r - 1) + gd2*(3 - 6*r))*(r + s - 1) - 126*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - Dd*f*(10*f**2*(8*r**2 + 8*r*s + 7*s - 5) - 9*f*(3*K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 5040*Dd**2*f**4*r**2 - 5040*Dd**2*f**4*r*s + 5040*Dd**2*f**4*r + 1260*Dd**2*f**4*s - 840*Dd**2*f**4 + 21384*Dd**2*f**2*g2*r**2 + 21384*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r - 5346*Dd**2*f**2*g2*s + 3564*Dd**2*f**2*g2 - 33*b1**2*(D1**2*r*(6*f*(4*fd - 9*fdd)*(2*r + 2*s - 1) - 54*fd**2*(2*r + 2*s - 1) - 7*fd*(3*K - 1)*(r + s) + 21*fdd*(3*K - 1)*(r + s)) + D1*(Dd*(24*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-54*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (7 - 21*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 21*fd*(3*K - 1)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-21*K + 18*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-21*K + 18*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 33*b1*(-66*D1**2*K*f*fd*r**2 - 66*D1**2*K*f*fd*r*s + 66*D1**2*K*f*fd*r + 33*D1**2*K*f*fd*s - 33*D1**2*K*f*fd + 54*D1**2*K*f*fdd*r**2 + 54*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r - 27*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 54*D1**2*K*fd**2*r**2 + 54*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r - 27*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(2*r - 1)*(-21*K + 18*f + 7)*(r + s - 1) + 42*D1**2*f**2*fd*r**2 + 42*D1**2*f**2*fd*r*s - 52*D1**2*f**2*fd*r - 24*D1**2*f**2*fd*s + 24*D1**2*f**2*fd - 30*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 50*D1**2*f**2*fdd*r + 30*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd - 60*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 100*D1**2*f*fd**2*r + 60*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 22*D1**2*f*fd*r**2 + 22*D1**2*f*fd*r*s - 22*D1**2*f*fd*r - 11*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 18*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 9*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r - 126*D1**2*f*gdd2*r**2 - 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*r - 18*D1**2*fd**2*r**2 - 18*D1**2*fd**2*r*s + 18*D1**2*fd**2*r + 9*D1**2*fd**2*s + 42*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s - 252*D1**2*fd*gd2*r**2 - 252*D1**2*fd*gd2*r*s + 126*D1**2*fd*gd2*r - 126*D1**2*fdd*g2*r**2 - 126*D1**2*fdd*g2*r*s - 132*D1*Dd*K*f**2*r**2 - 132*D1*Dd*K*f**2*r*s + 132*D1*Dd*K*f**2*r + 33*D1*Dd*K*f**2*s - 33*D1*Dd*K*f**2 + 432*D1*Dd*K*f*fd*r**2 + 432*D1*Dd*K*f*fd*r*s - 432*D1*Dd*K*f*fd*r - 162*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd + 56*D1*Dd*f**3*r**2 + 56*D1*Dd*f**3*r*s - 56*D1*Dd*f**3*r - 14*D1*Dd*f**3*s + 14*D1*Dd*f**3 - 240*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 320*D1*Dd*f**2*fd*r + 150*D1*Dd*f**2*fd*s - 110*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 + 44*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r - 11*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 144*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r + 54*D1*Dd*f*fd*s - 36*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 42*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r + 126*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r + 126*D1*Dd*fd*g2*s + 108*D1*Ddd*K*f**2*r**2 + 108*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r - 27*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 - 40*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 40*D1*Ddd*f**3*r + 10*D1*Ddd*f**3*s - 10*D1*Ddd*f**3 - 36*D1*Ddd*f**2*r**2 - 36*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r + 9*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 504*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 126*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + D1*bd1*(D1*(24*f**2*(2*r - 1)*(r + s - 1) + f*(-54*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (21*K - 7)*(2*r - 1)*(r + s - 1)) + 21*fd*(3*K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-21*K + 18*f + 7)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 324*Dd**2*K*f**2*r**2 + 324*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r - 81*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 - 120*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 120*Dd**2*f**3*r + 30*Dd**2*f**3*s - 20*Dd**2*f**3 - 108*Dd**2*f**2*r**2 - 108*Dd**2*f**2*r*s + 108*Dd**2*f**2*r + 27*Dd**2*f**2*s - 18*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 1512*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 378*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(3465*d**2*k3**5) + 2*D1**2*Pkd1*Pkd3*ct*k1**2*k2*st**2*(21*b1**2*(D1**2*r*(fd*(5*C - 4) + fdd*(5*C - 3))*(r + s - 1) + D1*(Dd*(f*(5*C - 4)*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(5*C - 3)*(8*r**2 + 8*r*(s - 1) - s + 1)) + Ddd*f*(5*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd**2*f*(5*C - 3)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1*(-8*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r*s + 22*C*D1**2*f*fd*r + 9*C*D1**2*f*fd*s - 9*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r*s - 18*C*D1**2*f*fdd*r - 15*C*D1**2*f*fdd*s + 15*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r*s - 18*C*D1**2*fd**2*r - 15*C*D1**2*fd**2*s + 15*C*D1**2*fd**2 - 16*C*D1*Dd*f**2*r**2 - 16*C*D1*Dd*f**2*r*s + 16*C*D1*Dd*f**2*r + 4*C*D1*Dd*f**2*s - 4*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 - 192*C*D1*Dd*f*fd*r*s + 24*C*D1*Dd*f*fd*r - 36*C*D1*Dd*f*fd*s + 48*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r**2 - 48*C*D1*Ddd*f**2*r*s + 48*C*D1*Ddd*f**2*r + 12*C*D1*Ddd*f**2*s - 12*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r**2 - 144*C*Dd**2*f**2*r*s + 144*C*Dd**2*f**2*r + 36*C*Dd**2*f**2*s - 24*C*Dd**2*f**2 + 7*D1**2*bdd1*f*(5*C - 3)*(2*r**2 + 2*r*(s - 1) - s + 1) + 4*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 10*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 9*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s + 12*D1**2*fd**2*r + 9*D1**2*fd**2*s - 9*D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 2*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s + 24*D1*Dd*f*fd*s - 30*D1*Dd*f*fd + 24*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 24*D1*Ddd*f**2*r - 6*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(5*C - 4)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd*(5*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*f*(10*C - 6)*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 72*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 72*Dd**2*f**2*r - 18*Dd**2*f**2*s + 12*Dd**2*f**2) + f*(81*C*D1**2*f*fd*r**2 + 81*C*D1**2*f*fd*r*s - 81*C*D1**2*f*fd*r - 27*C*D1**2*f*fd*s + 27*C*D1**2*f*fd - 135*C*D1**2*f*fdd*r**2 - 135*C*D1**2*f*fdd*r*s + 135*C*D1**2*f*fdd*r + 45*C*D1**2*f*fdd*s - 45*C*D1**2*f*fdd - 270*C*D1**2*fd**2*r**2 - 270*C*D1**2*fd**2*r*s + 270*C*D1**2*fd**2*r + 90*C*D1**2*fd**2*s - 45*C*D1**2*fd**2 + 108*C*D1*Dd*f**2*r**2 + 108*C*D1*Dd*f**2*r*s - 108*C*D1*Dd*f**2*r - 27*C*D1*Dd*f**2*s + 27*C*D1*Dd*f**2 - 1080*C*D1*Dd*f*fd*r**2 - 1080*C*D1*Dd*f*fd*r*s + 1080*C*D1*Dd*f*fd*r + 315*C*D1*Dd*f*fd*s - 225*C*D1*Dd*f*fd - 180*C*D1*Ddd*f**2*r**2 - 180*C*D1*Ddd*f**2*r*s + 180*C*D1*Ddd*f**2*r + 45*C*D1*Ddd*f**2*s - 45*C*D1*Ddd*f**2 - 540*C*Dd**2*f**2*r**2 - 540*C*Dd**2*f**2*r*s + 540*C*Dd**2*f**2*r + 135*C*Dd**2*f**2*s - 90*C*Dd**2*f**2 + 21*D1**2*bd1**2*(5*C - 3)*(2*r**2 + 2*r*(s - 1) - s) - 9*D1**2*bdd1*f*(C*(4*r**2 + 2*r*(2*s - 9) - 9*s + 9) - 2*r**2 - 2*r*(s - 5) + 5*s - 5) - 42*D1**2*f*fd*r**2 - 42*D1**2*f*fd*r*s + 42*D1**2*f*fd*r + 14*D1**2*f*fd*s - 14*D1**2*f*fd + 75*D1**2*f*fdd*r**2 + 75*D1**2*f*fdd*r*s - 75*D1**2*f*fdd*r - 25*D1**2*f*fdd*s + 25*D1**2*f*fdd + 150*D1**2*fd**2*r**2 + 150*D1**2*fd**2*r*s - 150*D1**2*fd**2*r - 50*D1**2*fd**2*s + 25*D1**2*fd**2 - 56*D1*Dd*f**2*r**2 - 56*D1*Dd*f**2*r*s + 56*D1*Dd*f**2*r + 14*D1*Dd*f**2*s - 14*D1*Dd*f**2 + 600*D1*Dd*f*fd*r**2 + 600*D1*Dd*f*fd*r*s - 600*D1*Dd*f*fd*r - 175*D1*Dd*f*fd*s + 125*D1*Dd*f*fd + 100*D1*Ddd*f**2*r**2 + 100*D1*Ddd*f**2*r*s - 100*D1*Ddd*f**2*r - 25*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 - 3*D1*bd1*(D1*(f*(C*(4*r**2 + 4*r*s + 10*r + 5*s - 5) - 2*r**2 - 2*r*(s + 2) - 2*s + 2) + 3*fd*(C*(16*r**2 + 2*r*(8*s - 15) - 13*s + 9) - 8*r**2 - 8*r*(s - 2) + 7*s - 5)) + 6*Dd*f*(2*C*(8*r**2 + r*(8*s - 22) - 10*s + 9) - 8*r**2 - 8*r*(s - 3) + 11*s - 10)) + 300*Dd**2*f**2*r**2 + 300*Dd**2*f**2*r*s - 300*Dd**2*f**2*r - 75*Dd**2*f**2*s + 50*Dd**2*f**2))/(315*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct*k1**2*k2*(378*D1**2*K*bd1**2*f*r + 189*D1**2*K*bd1**2*f*s - 189*D1**2*K*bd1**2*f + 81*D1**2*K*bd1*f**2*r**2 + 81*D1**2*K*bd1*f**2*r*s - 81*D1**2*K*bd1*f**2*r - 540*D1**2*K*bd1*f*fd*r**2 - 540*D1**2*K*bd1*f*fd*r*s + 540*D1**2*K*bd1*f*fd*r + 135*D1**2*K*bd1*f*fd*s - 135*D1**2*K*bd1*f*fd - 135*D1**2*K*bdd1*f**2*r**2 - 135*D1**2*K*bdd1*f**2*r*s + 135*D1**2*K*bdd1*f**2*r - 90*D1**2*bd1**2*f**2*r - 45*D1**2*bd1**2*f**2*s + 45*D1**2*bd1**2*f**2 - 126*D1**2*bd1**2*f*r - 63*D1**2*bd1**2*f*s + 63*D1**2*bd1**2*f - 1260*D1**2*bd1**2*g2*r**2 - 1260*D1**2*bd1**2*g2*r*s + 1260*D1**2*bd1**2*g2*r + 630*D1**2*bd1**2*g2*s - 378*D1**2*bd1*bd2*f*r**2 - 378*D1**2*bd1*bd2*f*r*s + 567*D1**2*bd1*bd2*f*r + 189*D1**2*bd1*bd2*f*s - 189*D1**2*bd1*bd2*f - 25*D1**2*bd1*f**3*r**2 - 25*D1**2*bd1*f**3*r*s + 25*D1**2*bd1*f**3*r + 210*D1**2*bd1*f**2*fd*r**2 + 210*D1**2*bd1*f**2*fd*r*s - 210*D1**2*bd1*f**2*fd*r - 35*D1**2*bd1*f**2*fd*s + 35*D1**2*bd1*f**2*fd - 27*D1**2*bd1*f**2*r**2 - 27*D1**2*bd1*f**2*r*s + 27*D1**2*bd1*f**2*r + 180*D1**2*bd1*f*fd*r**2 + 180*D1**2*bd1*f*fd*r*s - 180*D1**2*bd1*f*fd*r - 45*D1**2*bd1*f*fd*s + 45*D1**2*bd1*f*fd + 252*D1**2*bd1*f*g2*r + 126*D1**2*bd1*f*g2*s - 126*D1**2*bd1*f*g2 - 756*D1**2*bd1*f*gd2*r - 378*D1**2*bd1*f*gd2*s + 378*D1**2*bd1*f*gd2 + 81*D1**2*bd2*f**2*r**2 + 81*D1**2*bd2*f**2*r*s - 81*D1**2*bd2*f**2*r - 540*D1**2*bd2*f*fd*r**2 - 540*D1**2*bd2*f*fd*r*s + 540*D1**2*bd2*f*fd*r + 135*D1**2*bd2*f*fd*s - 135*D1**2*bd2*f*fd + 35*D1**2*bdd1*f**3*r**2 + 35*D1**2*bdd1*f**3*r*s - 35*D1**2*bdd1*f**3*r + 45*D1**2*bdd1*f**2*r**2 + 45*D1**2*bdd1*f**2*r*s - 45*D1**2*bdd1*f**2*r - 756*D1**2*bdd1*f*g2*r - 378*D1**2*bdd1*f*g2*s + 378*D1**2*bdd1*f*g2 - 135*D1**2*bdd2*f**2*r**2 - 135*D1**2*bdd2*f**2*r*s + 135*D1**2*bdd2*f**2*r - 162*D1**2*f**2*gd2*r**2 - 162*D1**2*f**2*gd2*r*s + 162*D1**2*f**2*gd2*r + 270*D1**2*f**2*gdd2*r**2 + 270*D1**2*f**2*gdd2*r*s - 270*D1**2*f**2*gdd2*r - 324*D1**2*f*fd*g2*r**2 - 324*D1**2*f*fd*g2*r*s + 324*D1**2*f*fd*g2*r + 162*D1**2*f*fd*g2*s - 162*D1**2*f*fd*g2 + 1080*D1**2*f*fd*gd2*r**2 + 1080*D1**2*f*fd*gd2*r*s - 1080*D1**2*f*fd*gd2*r - 270*D1**2*f*fd*gd2*s + 270*D1**2*f*fd*gd2 + 540*D1**2*f*fdd*g2*r**2 + 540*D1**2*f*fdd*g2*r*s - 540*D1**2*f*fdd*g2*r - 270*D1**2*f*fdd*g2*s + 270*D1**2*f*fdd*g2 + 540*D1**2*fd**2*g2*r**2 + 540*D1**2*fd**2*g2*r*s - 540*D1**2*fd**2*g2*r - 270*D1**2*fd**2*g2*s - 1080*D1*Dd*K*bd1*f**2*r**2 - 1080*D1*Dd*K*bd1*f**2*r*s + 1080*D1*Dd*K*bd1*f**2*r + 135*D1*Dd*K*bd1*f**2*s - 135*D1*Dd*K*bd1*f**2 + 280*D1*Dd*bd1*f**3*r**2 + 280*D1*Dd*bd1*f**3*r*s - 280*D1*Dd*bd1*f**3*r - 35*D1*Dd*bd1*f**3*s + 35*D1*Dd*bd1*f**3 + 360*D1*Dd*bd1*f**2*r**2 + 360*D1*Dd*bd1*f**2*r*s - 360*D1*Dd*bd1*f**2*r - 45*D1*Dd*bd1*f**2*s + 45*D1*Dd*bd1*f**2 - 3024*D1*Dd*bd1*f*g2*r - 1512*D1*Dd*bd1*f*g2*s + 1512*D1*Dd*bd1*f*g2 - 1080*D1*Dd*bd2*f**2*r**2 - 1080*D1*Dd*bd2*f**2*r*s + 1080*D1*Dd*bd2*f**2*r + 135*D1*Dd*bd2*f**2*s - 135*D1*Dd*bd2*f**2 - 648*D1*Dd*f**2*g2*r**2 - 648*D1*Dd*f**2*g2*r*s + 648*D1*Dd*f**2*g2*r + 162*D1*Dd*f**2*g2*s - 162*D1*Dd*f**2*g2 + 2160*D1*Dd*f**2*gd2*r**2 + 2160*D1*Dd*f**2*gd2*r*s - 2160*D1*Dd*f**2*gd2*r - 270*D1*Dd*f**2*gd2*s + 270*D1*Dd*f**2*gd2 + 4320*D1*Dd*f*fd*g2*r**2 + 4320*D1*Dd*f*fd*g2*r*s - 4320*D1*Dd*f*fd*g2*r - 1620*D1*Dd*f*fd*g2*s + 1080*D1*Dd*f*fd*g2 + 1080*D1*Ddd*f**2*g2*r**2 + 1080*D1*Ddd*f**2*g2*r*s - 1080*D1*Ddd*f**2*g2*r - 270*D1*Ddd*f**2*g2*s + 270*D1*Ddd*f**2*g2 + 3240*Dd**2*f**2*g2*r**2 + 3240*Dd**2*f**2*g2*r*s - 3240*Dd**2*f**2*g2*r - 810*Dd**2*f**2*g2*s + 540*Dd**2*f**2*g2 + 21*b1**3*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + (15*K - 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-15*K + 3*f + 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-15*K + 3*f + 5)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 3*b1**2*(42*D1**2*K*fd*r + 21*D1**2*K*fd*s - 21*D1**2*K*fd - 126*D1**2*K*fdd*r - 63*D1**2*K*fdd*s + 63*D1**2*K*fdd - 7*D1**2*bdd1*(-15*K + 3*f + 5)*(3*r**2 + 3*r*(s - 1) - s + 1) - 18*D1**2*f*fd*r - 9*D1**2*f*fd*s + 9*D1**2*f*fd + 30*D1**2*f*fdd*r + 15*D1**2*f*fdd*s - 15*D1**2*f*fdd + 30*D1**2*fd**2*r + 15*D1**2*fd**2*s - 15*D1**2*fd**2 - 14*D1**2*fd*r - 7*D1**2*fd*s + 7*D1**2*fd + 42*D1**2*fdd*r + 21*D1**2*fdd*s - 21*D1**2*fdd - 210*D1**2*gd2*r**2 - 210*D1**2*gd2*r*s + 210*D1**2*gd2*r - 210*D1**2*gdd2*r**2 - 210*D1**2*gdd2*r*s + 210*D1**2*gdd2*r - 504*D1*Dd*K*fd*r - 252*D1*Dd*K*fd*s + 252*D1*Dd*K*fd + 120*D1*Dd*f*fd*r + 60*D1*Dd*f*fd*s - 60*D1*Dd*f*fd + 168*D1*Dd*fd*r + 84*D1*Dd*fd*s - 84*D1*Dd*fd - 840*D1*Dd*g2*r**2 - 840*D1*Dd*g2*r*s + 840*D1*Dd*g2*r + 210*D1*Dd*g2*s - 210*D1*Dd*g2 - 1680*D1*Dd*gd2*r**2 - 1680*D1*Dd*gd2*r*s + 1680*D1*Dd*gd2*r + 210*D1*Dd*gd2*s - 210*D1*Dd*gd2 - 840*D1*Ddd*g2*r**2 - 840*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r + 210*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 7*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + (15*K - 5)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-15*K + 3*f + 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 2520*Dd**2*g2*r**2 - 2520*Dd**2*g2*r*s + 2520*Dd**2*g2*r + 630*Dd**2*g2*s - 420*Dd**2*g2) - b1*(-162*D1**2*K*f*fd*r**2 - 162*D1**2*K*f*fd*r*s + 162*D1**2*K*f*fd*r + 81*D1**2*K*f*fd*s - 81*D1**2*K*f*fd + 270*D1**2*K*f*fdd*r**2 + 270*D1**2*K*f*fdd*r*s - 270*D1**2*K*f*fdd*r - 135*D1**2*K*f*fdd*s + 135*D1**2*K*f*fdd + 270*D1**2*K*fd**2*r**2 + 270*D1**2*K*fd**2*r*s - 270*D1**2*K*fd**2*r - 135*D1**2*K*fd**2*s - 63*D1**2*b2*fd*r**2 - 63*D1**2*b2*fd*r*s + 189*D1**2*b2*fdd*r**2 + 189*D1**2*b2*fdd*r*s + 21*D1**2*bd1**2*(-15*K + 3*f + 5)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 63*D1**2*bd2*f*r**2 - 63*D1**2*bd2*f*r*s + 63*D1**2*bd2*f*r + 378*D1**2*bd2*fd*r**2 + 378*D1**2*bd2*fd*r*s - 189*D1**2*bd2*fd*r + 9*D1**2*bdd1*(5*f**2*(2*r + s - 1) - 7*f*(3*K - 1)*(2*r + s - 1) + 70*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 189*D1**2*bdd2*f*r**2 + 189*D1**2*bdd2*f*r*s - 189*D1**2*bdd2*f*r + 75*D1**2*f**2*fd*r**2 + 75*D1**2*f**2*fd*r*s - 75*D1**2*f**2*fd*r - 25*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 54*D1**2*f*fd*r**2 + 54*D1**2*f*fd*r*s - 54*D1**2*f*fd*r - 27*D1**2*f*fd*s + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 90*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r + 45*D1**2*f*fdd*s - 45*D1**2*f*fdd - 90*D1**2*fd**2*r**2 - 90*D1**2*fd**2*r*s + 90*D1**2*fd**2*r + 45*D1**2*fd**2*s + 252*D1**2*fd*g2*r + 126*D1**2*fd*g2*s - 126*D1**2*fd*g2 - 756*D1**2*fd*gd2*r - 378*D1**2*fd*gd2*s + 378*D1**2*fd*gd2 - 756*D1**2*fdd*g2*r - 378*D1**2*fdd*g2*s + 378*D1**2*fdd*g2 - 324*D1*Dd*K*f**2*r**2 - 324*D1*Dd*K*f**2*r*s + 324*D1*Dd*K*f**2*r + 81*D1*Dd*K*f**2*s - 81*D1*Dd*K*f**2 + 2160*D1*Dd*K*f*fd*r**2 + 2160*D1*Dd*K*f*fd*r*s - 2160*D1*Dd*K*f*fd*r - 810*D1*Dd*K*f*fd*s + 540*D1*Dd*K*f*fd - 252*D1*Dd*b2*f*r**2 - 252*D1*Dd*b2*f*r*s + 252*D1*Dd*b2*f*r + 63*D1*Dd*b2*f*s - 63*D1*Dd*b2*f + 1512*D1*Dd*b2*fd*r**2 + 1512*D1*Dd*b2*fd*r*s - 756*D1*Dd*b2*fd*r - 189*D1*Dd*b2*fd*s + 1512*D1*Dd*bd2*f*r**2 + 1512*D1*Dd*bd2*f*r*s - 1512*D1*Dd*bd2*f*r - 189*D1*Dd*bd2*f*s + 189*D1*Dd*bd2*f + 100*D1*Dd*f**3*r**2 + 100*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r - 25*D1*Dd*f**3*s + 25*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 + 108*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r - 27*D1*Dd*f**2*s + 27*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 720*D1*Dd*f*fd*r*s + 720*D1*Dd*f*fd*r + 270*D1*Dd*f*fd*s - 180*D1*Dd*f*fd - 3024*D1*Dd*fd*g2*r - 1512*D1*Dd*fd*g2*s + 1512*D1*Dd*fd*g2 + 540*D1*Ddd*K*f**2*r**2 + 540*D1*Ddd*K*f**2*r*s - 540*D1*Ddd*K*f**2*r - 135*D1*Ddd*K*f**2*s + 135*D1*Ddd*K*f**2 + 756*D1*Ddd*b2*f*r**2 + 756*D1*Ddd*b2*f*r*s - 756*D1*Ddd*b2*f*r - 189*D1*Ddd*b2*f*s + 189*D1*Ddd*b2*f - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 180*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r + 45*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 3*D1*bd1*(D1*(9*f**2*(2*r + s - 1) - 7*f*(3*K - 1)*(2*r + s - 1) - 21*fd*(3*K - 1)*(2*r + s - 1) - 210*g2*(2*r**2 + 2*r*(s - 1) - s + 1) - 210*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*(5*f**2*(2*r + s - 1) - 7*f*(3*K - 1)*(2*r + s - 1) + 35*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + 1620*Dd**2*K*f**2*r**2 + 1620*Dd**2*K*f**2*r*s - 1620*Dd**2*K*f**2*r - 405*Dd**2*K*f**2*s + 270*Dd**2*K*f**2 + 2268*Dd**2*b2*f*r**2 + 2268*Dd**2*b2*f*r*s - 2268*Dd**2*b2*f*r - 567*Dd**2*b2*f*s + 378*Dd**2*b2*f - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 540*Dd**2*f**2*r*s + 540*Dd**2*f**2*r + 135*Dd**2*f**2*s - 90*Dd**2*f**2) + 9*b2*(-21*D1**2*bdd1*f*(r - 1)*(r + s - 1) - 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*fd**2*(2*r**2 + 2*r*(s - 1) - s)) + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 3*D1*f*(Dd*(-3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 10*fd*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(315*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct*k2**5*st**4*(33*b1**2*(D1**2*r*(2*r + 2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + D1*f*(Dd*(3*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1)) - 5*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*f*(-15*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 27*D1**2*f*fd*r**2 - 27*D1**2*f*fd*r*s + 11*D1**2*f*fd*r - 7*D1**2*f*fd*s + 7*D1**2*f*fd + 45*D1**2*f*fdd*r**2 + 45*D1**2*f*fdd*r*s - 25*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 90*D1**2*fd**2*r*s - 50*D1**2*fd**2*r + 10*D1**2*fd**2*s - 5*D1**2*fd**2 - 36*D1*Dd*f**2*r**2 - 36*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r + 9*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 360*D1*Dd*f*fd*r**2 + 360*D1*Dd*f*fd*r*s - 280*D1*Dd*f*fd*r - 25*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 60*D1*Ddd*f**2*r**2 + 60*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r - 15*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 3*D1*bd1*(D1*(3*f*(2*r - 1)*(r + s - 1) - 5*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1)) - 5*Dd*f*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 180*Dd**2*f**2*r**2 + 180*Dd**2*f**2*r*s - 180*Dd**2*f**2*r - 45*Dd**2*f**2*s + 30*Dd**2*f**2) + f**2*(-165*D1**2*bd1**2*(2*r - 1)*(r + s - 1) + 55*D1**2*bdd1*f*(3*r - 4)*(r + s - 1) - 4*D1**2*(f*(28*fd - 25*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 25*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 11*D1*bd1*(D1*(f*(9*r - 16)*(r + s - 1) - 5*fd*(18*r**2 + 18*r*s - 26*r - 11*s + 7)) - 5*Dd*f*(24*r**2 + 8*r*(3*s - 5) - 19*s + 15)) - 4*D1*f*(28*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 50*Dd*fd*(4*r - 1)*(4*r + 4*s - 3) - 25*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 100*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(1155*d**2*k3**5) + 2*D1**2*Pkd1*Pkd3*ct*k2**3*st**4*(18*C*D1**2*b1*f*fd*r**2 + 18*C*D1**2*b1*f*fd*r*s - 9*C*D1**2*b1*f*fd*r - 30*C*D1**2*b1*f*fdd*r**2 - 30*C*D1**2*b1*f*fdd*r*s + 15*C*D1**2*b1*f*fdd*r - 30*C*D1**2*b1*fd**2*r**2 - 30*C*D1**2*b1*fd**2*r*s + 15*C*D1**2*b1*fd**2*r + 21*C*D1**2*f**2*fd*r**2 + 21*C*D1**2*f**2*fd*r*s - 21*C*D1**2*f**2*fd*r - 7*C*D1**2*f**2*fd*s + 7*C*D1**2*f**2*fd - 15*C*D1**2*f**2*fdd*r**2 - 15*C*D1**2*f**2*fdd*r*s + 15*C*D1**2*f**2*fdd*r + 5*C*D1**2*f**2*fdd*s - 5*C*D1**2*f**2*fdd - 30*C*D1**2*f*fd**2*r**2 - 30*C*D1**2*f*fd**2*r*s + 30*C*D1**2*f*fd**2*r + 10*C*D1**2*f*fd**2*s - 5*C*D1**2*f*fd**2 + 36*C*D1*Dd*b1*f**2*r**2 + 36*C*D1*Dd*b1*f**2*r*s - 36*C*D1*Dd*b1*f**2*r - 9*C*D1*Dd*b1*f**2*s + 9*C*D1*Dd*b1*f**2 - 240*C*D1*Dd*b1*f*fd*r**2 - 240*C*D1*Dd*b1*f*fd*r*s + 180*C*D1*Dd*b1*f*fd*r + 30*C*D1*Dd*b1*f*fd*s - 15*C*D1*Dd*b1*f*fd + 28*C*D1*Dd*f**3*r**2 + 28*C*D1*Dd*f**3*r*s - 28*C*D1*Dd*f**3*r - 7*C*D1*Dd*f**3*s + 7*C*D1*Dd*f**3 - 120*C*D1*Dd*f**2*fd*r**2 - 120*C*D1*Dd*f**2*fd*r*s + 120*C*D1*Dd*f**2*fd*r + 35*C*D1*Dd*f**2*fd*s - 25*C*D1*Dd*f**2*fd - 60*C*D1*Ddd*b1*f**2*r**2 - 60*C*D1*Ddd*b1*f**2*r*s + 60*C*D1*Ddd*b1*f**2*r + 15*C*D1*Ddd*b1*f**2*s - 15*C*D1*Ddd*b1*f**2 - 20*C*D1*Ddd*f**3*r**2 - 20*C*D1*Ddd*f**3*r*s + 20*C*D1*Ddd*f**3*r + 5*C*D1*Ddd*f**3*s - 5*C*D1*Ddd*f**3 - 180*C*Dd**2*b1*f**2*r**2 - 180*C*Dd**2*b1*f**2*r*s + 180*C*Dd**2*b1*f**2*r + 45*C*Dd**2*b1*f**2*s - 30*C*Dd**2*b1*f**2 - 60*C*Dd**2*f**3*r**2 - 60*C*Dd**2*f**3*r*s + 60*C*Dd**2*f**3*r + 15*C*Dd**2*f**3*s - 10*C*Dd**2*f**3 - 6*D1**2*b1*f*fd*r**2 - 6*D1**2*b1*f*fd*r*s + 3*D1**2*b1*f*fd*r + 24*D1**2*b1*f*fdd*r**2 + 24*D1**2*b1*f*fdd*r*s - 12*D1**2*b1*f*fdd*r + 24*D1**2*b1*fd**2*r**2 + 24*D1**2*b1*fd**2*r*s - 12*D1**2*b1*fd**2*r - 3*D1**2*bdd1*f**2*(5*C - 4)*(r - 1)*(r + s - 1) - 15*D1**2*f**2*fd*r**2 - 15*D1**2*f**2*fd*r*s + 15*D1**2*f**2*fd*r + 5*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r*s - 12*D1**2*f**2*fdd*r - 4*D1**2*f**2*fdd*s + 4*D1**2*f**2*fdd + 24*D1**2*f*fd**2*r**2 + 24*D1**2*f*fd**2*r*s - 24*D1**2*f*fd**2*r - 8*D1**2*f*fd**2*s + 4*D1**2*f*fd**2 - 12*D1*Dd*b1*f**2*r**2 - 12*D1*Dd*b1*f**2*r*s + 12*D1*Dd*b1*f**2*r + 3*D1*Dd*b1*f**2*s - 3*D1*Dd*b1*f**2 + 192*D1*Dd*b1*f*fd*r**2 + 192*D1*Dd*b1*f*fd*r*s - 144*D1*Dd*b1*f*fd*r - 24*D1*Dd*b1*f*fd*s + 12*D1*Dd*b1*f*fd - 20*D1*Dd*f**3*r**2 - 20*D1*Dd*f**3*r*s + 20*D1*Dd*f**3*r + 5*D1*Dd*f**3*s - 5*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 96*D1*Dd*f**2*fd*r*s - 96*D1*Dd*f**2*fd*r - 28*D1*Dd*f**2*fd*s + 20*D1*Dd*f**2*fd + 48*D1*Ddd*b1*f**2*r**2 + 48*D1*Ddd*b1*f**2*r*s - 48*D1*Ddd*b1*f**2*r - 12*D1*Ddd*b1*f**2*s + 12*D1*Ddd*b1*f**2 + 16*D1*Ddd*f**3*r**2 + 16*D1*Ddd*f**3*r*s - 16*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s + 4*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(3*C - 1)*(r - 1)*(r + s - 1) - fd*(5*C - 4)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(5*C - 4)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 144*Dd**2*b1*f**2*r**2 + 144*Dd**2*b1*f**2*r*s - 144*Dd**2*b1*f**2*r - 36*Dd**2*b1*f**2*s + 24*Dd**2*b1*f**2 + 48*Dd**2*f**3*r**2 + 48*Dd**2*f**3*r*s - 48*Dd**2*f**3*r - 12*Dd**2*f**3*s + 8*Dd**2*f**3)/(105*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct*k2**3*st**2*(-42*D1**2*K*bd1**2*f*r**2 - 42*D1**2*K*bd1**2*f*r*s + 63*D1**2*K*bd1**2*f*r + 21*D1**2*K*bd1**2*f*s - 21*D1**2*K*bd1**2*f + 11*D1**2*K*bd1*f**2*r**2 + 11*D1**2*K*bd1*f**2*r*s - 11*D1**2*K*bd1*f**2*r - 36*D1**2*K*bd1*f*fd*r**2 - 36*D1**2*K*bd1*f*fd*r*s + 36*D1**2*K*bd1*f*fd*r + 9*D1**2*K*bd1*f*fd*s - 9*D1**2*K*bd1*f*fd - 9*D1**2*K*bdd1*f**2*r**2 - 9*D1**2*K*bdd1*f**2*r*s + 9*D1**2*K*bdd1*f**2*r + 72*D1**2*bd1**2*f**2*r**2 + 72*D1**2*bd1**2*f**2*r*s - 108*D1**2*bd1**2*f**2*r - 45*D1**2*bd1**2*f**2*s + 27*D1**2*bd1**2*f**2 + 42*D1**2*bd1**2*f*r**2 + 42*D1**2*bd1**2*f*r*s - 63*D1**2*bd1**2*f*r - 21*D1**2*bd1**2*f*s + 21*D1**2*bd1**2*f - 42*D1**2*bd1*bd2*f*r**2 - 42*D1**2*bd1*bd2*f*r*s + 63*D1**2*bd1*bd2*f*r + 21*D1**2*bd1*bd2*f*s - 21*D1**2*bd1*bd2*f - 23*D1**2*bd1*f**3*r**2 - 23*D1**2*bd1*f**3*r*s + 15*D1**2*bd1*f**3*r + 150*D1**2*bd1*f**2*fd*r**2 + 150*D1**2*bd1*f**2*fd*r*s - 130*D1**2*bd1*f**2*fd*r - 25*D1**2*bd1*f**2*fd*s + 15*D1**2*bd1*f**2*fd - 11*D1**2*bd1*f**2*r**2 - 11*D1**2*bd1*f**2*r*s + 11*D1**2*bd1*f**2*r + 36*D1**2*bd1*f*fd*r**2 + 36*D1**2*bd1*f*fd*r*s - 36*D1**2*bd1*f*fd*r - 9*D1**2*bd1*f*fd*s + 9*D1**2*bd1*f*fd - 14*D1**2*bd1*f*g2*r**2 - 14*D1**2*bd1*f*g2*r*s + 28*D1**2*bd1*f*g2*r + 14*D1**2*bd1*f*g2*s - 14*D1**2*bd1*f*g2 + 84*D1**2*bd1*f*gd2*r**2 + 84*D1**2*bd1*f*gd2*r*s - 126*D1**2*bd1*f*gd2*r - 42*D1**2*bd1*f*gd2*s + 42*D1**2*bd1*f*gd2 + 84*D1**2*bd1*fd*g2*r**2 + 84*D1**2*bd1*fd*g2*r*s - 84*D1**2*bd1*fd*g2*r - 42*D1**2*bd1*fd*g2*s + 11*D1**2*bd2*f**2*r**2 + 11*D1**2*bd2*f**2*r*s - 11*D1**2*bd2*f**2*r - 36*D1**2*bd2*f*fd*r**2 - 36*D1**2*bd2*f*fd*r*s + 36*D1**2*bd2*f*fd*r + 9*D1**2*bd2*f*fd*s - 9*D1**2*bd2*f*fd + 25*D1**2*bdd1*f**3*r**2 + 25*D1**2*bdd1*f**3*r*s - 15*D1**2*bdd1*f**3*r + 9*D1**2*bdd1*f**2*r**2 + 9*D1**2*bdd1*f**2*r*s - 9*D1**2*bdd1*f**2*r + 42*D1**2*bdd1*f*g2*r**2 + 42*D1**2*bdd1*f*g2*r*s - 84*D1**2*bdd1*f*g2*r - 42*D1**2*bdd1*f*g2*s + 42*D1**2*bdd1*f*g2 - 9*D1**2*bdd2*f**2*r**2 - 9*D1**2*bdd2*f**2*r*s + 9*D1**2*bdd2*f**2*r - 22*D1**2*f**2*gd2*r**2 - 22*D1**2*f**2*gd2*r*s + 22*D1**2*f**2*gd2*r + 18*D1**2*f**2*gdd2*r**2 + 18*D1**2*f**2*gdd2*r*s - 18*D1**2*f**2*gdd2*r - 44*D1**2*f*fd*g2*r**2 - 44*D1**2*f*fd*g2*r*s + 44*D1**2*f*fd*g2*r + 22*D1**2*f*fd*g2*s - 22*D1**2*f*fd*g2 + 72*D1**2*f*fd*gd2*r**2 + 72*D1**2*f*fd*gd2*r*s - 72*D1**2*f*fd*gd2*r - 18*D1**2*f*fd*gd2*s + 18*D1**2*f*fd*gd2 + 36*D1**2*f*fdd*g2*r**2 + 36*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r - 18*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 36*D1**2*fd**2*g2*r**2 + 36*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r - 18*D1**2*fd**2*g2*s - 72*D1*Dd*K*bd1*f**2*r**2 - 72*D1*Dd*K*bd1*f**2*r*s + 72*D1*Dd*K*bd1*f**2*r + 9*D1*Dd*K*bd1*f**2*s - 9*D1*Dd*K*bd1*f**2 + 200*D1*Dd*bd1*f**3*r**2 + 200*D1*Dd*bd1*f**3*r*s - 160*D1*Dd*bd1*f**3*r - 25*D1*Dd*bd1*f**3*s + 15*D1*Dd*bd1*f**3 + 72*D1*Dd*bd1*f**2*r**2 + 72*D1*Dd*bd1*f**2*r*s - 72*D1*Dd*bd1*f**2*r - 9*D1*Dd*bd1*f**2*s + 9*D1*Dd*bd1*f**2 + 336*D1*Dd*bd1*f*g2*r**2 + 336*D1*Dd*bd1*f*g2*r*s - 504*D1*Dd*bd1*f*g2*r - 210*D1*Dd*bd1*f*g2*s + 168*D1*Dd*bd1*f*g2 - 72*D1*Dd*bd2*f**2*r**2 - 72*D1*Dd*bd2*f**2*r*s + 72*D1*Dd*bd2*f**2*r + 9*D1*Dd*bd2*f**2*s - 9*D1*Dd*bd2*f**2 - 88*D1*Dd*f**2*g2*r**2 - 88*D1*Dd*f**2*g2*r*s + 88*D1*Dd*f**2*g2*r + 22*D1*Dd*f**2*g2*s - 22*D1*Dd*f**2*g2 + 144*D1*Dd*f**2*gd2*r**2 + 144*D1*Dd*f**2*gd2*r*s - 144*D1*Dd*f**2*gd2*r - 18*D1*Dd*f**2*gd2*s + 18*D1*Dd*f**2*gd2 + 288*D1*Dd*f*fd*g2*r**2 + 288*D1*Dd*f*fd*g2*r*s - 288*D1*Dd*f*fd*g2*r - 108*D1*Dd*f*fd*g2*s + 72*D1*Dd*f*fd*g2 + 72*D1*Ddd*f**2*g2*r**2 + 72*D1*Ddd*f**2*g2*r*s - 72*D1*Ddd*f**2*g2*r - 18*D1*Ddd*f**2*g2*s + 18*D1*Ddd*f**2*g2 + 216*Dd**2*f**2*g2*r**2 + 216*Dd**2*f**2*g2*r*s - 216*Dd**2*f**2*g2*r - 54*Dd**2*f**2*g2*s + 36*Dd**2*f**2*g2 + 7*b1**3*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(7*D1**2*K*fd*r**2 + 7*D1**2*K*fd*r*s - 21*D1**2*K*fdd*r**2 - 21*D1**2*K*fdd*r*s - 21*D1**2*bdd1*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 32*D1**2*f*fd*r**2 - 32*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 11*D1**2*f*fd*s + 11*D1**2*f*fd + 72*D1**2*f*fdd*r**2 + 72*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 9*D1**2*f*fdd + 72*D1**2*fd**2*r**2 + 72*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 9*D1**2*fd**2*s - 9*D1**2*fd**2 - 7*D1**2*fd*r**2 - 7*D1**2*fd*r*s + 21*D1**2*fdd*r**2 + 21*D1**2*fdd*r*s + 28*D1*Dd*K*f*r**2 + 28*D1*Dd*K*f*r*s - 28*D1*Dd*K*f*r - 7*D1*Dd*K*f*s + 7*D1*Dd*K*f - 168*D1*Dd*K*fd*r**2 - 168*D1*Dd*K*fd*r*s + 84*D1*Dd*K*fd*r + 21*D1*Dd*K*fd*s - 64*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 64*D1*Dd*f**2*r + 16*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 576*D1*Dd*f*fd*r**2 + 576*D1*Dd*f*fd*r*s - 432*D1*Dd*f*fd*r - 36*D1*Dd*f*fd*s + 18*D1*Dd*f*fd - 28*D1*Dd*f*r**2 - 28*D1*Dd*f*r*s + 28*D1*Dd*f*r + 7*D1*Dd*f*s - 7*D1*Dd*f + 168*D1*Dd*fd*r**2 + 168*D1*Dd*fd*r*s - 84*D1*Dd*fd*r - 21*D1*Dd*fd*s - 84*D1*Ddd*K*f*r**2 - 84*D1*Ddd*K*f*r*s + 84*D1*Ddd*K*f*r + 21*D1*Ddd*K*f*s - 21*D1*Ddd*K*f + 144*D1*Ddd*f**2*r**2 + 144*D1*Ddd*f**2*r*s - 144*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s + 36*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 + 84*D1*Ddd*f*r*s - 84*D1*Ddd*f*r - 21*D1*Ddd*f*s + 21*D1*Ddd*f + 7*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1)) - 3*Dd*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 252*Dd**2*K*f*r**2 - 252*Dd**2*K*f*r*s + 252*Dd**2*K*f*r + 63*Dd**2*K*f*s - 42*Dd**2*K*f + 432*Dd**2*f**2*r**2 + 432*Dd**2*f**2*r*s - 432*Dd**2*f**2*r - 108*Dd**2*f**2*s + 72*Dd**2*f**2 + 252*Dd**2*f*r**2 + 252*Dd**2*f*r*s - 252*Dd**2*f*r - 63*Dd**2*f*s + 42*Dd**2*f) + b1*(22*D1**2*K*f*fd*r**2 + 22*D1**2*K*f*fd*r*s - 22*D1**2*K*f*fd*r - 11*D1**2*K*f*fd*s + 11*D1**2*K*f*fd - 18*D1**2*K*f*fdd*r**2 - 18*D1**2*K*f*fdd*r*s + 18*D1**2*K*f*fdd*r + 9*D1**2*K*f*fdd*s - 9*D1**2*K*f*fdd - 18*D1**2*K*fd**2*r**2 - 18*D1**2*K*fd**2*r*s + 18*D1**2*K*fd**2*r + 9*D1**2*K*fd**2*s + 7*D1**2*b2*fd*r**2 + 7*D1**2*b2*fd*r*s - 21*D1**2*b2*fdd*r**2 - 21*D1**2*b2*fdd*r*s - 21*D1**2*bd1**2*f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 7*D1**2*bd2*f*r**2 + 7*D1**2*bd2*f*r*s - 7*D1**2*bd2*f*r - 42*D1**2*bd2*fd*r**2 - 42*D1**2*bd2*fd*r*s + 21*D1**2*bd2*fd*r + 3*D1**2*bdd1*f*(3*f*(8*r**2 + 8*r*s - 12*r - 5*s + 5) + (7 - 7*K)*(2*r - 1)*(r + s - 1)) - 21*D1**2*bdd2*f*r**2 - 21*D1**2*bdd2*f*r*s + 21*D1**2*bdd2*f*r - 69*D1**2*f**2*fd*r**2 - 69*D1**2*f**2*fd*r*s + 77*D1**2*f**2*fd*r + 23*D1**2*f**2*fd*s - 23*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 75*D1**2*f**2*fdd*r*s - 85*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd*s + 25*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 150*D1**2*f*fd**2*r*s - 170*D1**2*f*fd**2*r - 50*D1**2*f*fd**2*s + 35*D1**2*f*fd**2 - 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r*s + 22*D1**2*f*fd*r + 11*D1**2*f*fd*s - 11*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd - 14*D1**2*f*gd2*r**2 - 14*D1**2*f*gd2*r*s + 14*D1**2*f*gd2*r + 42*D1**2*f*gdd2*r**2 + 42*D1**2*f*gdd2*r*s - 42*D1**2*f*gdd2*r + 18*D1**2*fd**2*r**2 + 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*r - 9*D1**2*fd**2*s - 14*D1**2*fd*g2*r**2 - 14*D1**2*fd*g2*r*s + 84*D1**2*fd*gd2*r**2 + 84*D1**2*fd*gd2*r*s - 42*D1**2*fd*gd2*r + 42*D1**2*fdd*g2*r**2 + 42*D1**2*fdd*g2*r*s + 44*D1*Dd*K*f**2*r**2 + 44*D1*Dd*K*f**2*r*s - 44*D1*Dd*K*f**2*r - 11*D1*Dd*K*f**2*s + 11*D1*Dd*K*f**2 - 144*D1*Dd*K*f*fd*r**2 - 144*D1*Dd*K*f*fd*r*s + 144*D1*Dd*K*f*fd*r + 54*D1*Dd*K*f*fd*s - 36*D1*Dd*K*f*fd + 28*D1*Dd*b2*f*r**2 + 28*D1*Dd*b2*f*r*s - 28*D1*Dd*b2*f*r - 7*D1*Dd*b2*f*s + 7*D1*Dd*b2*f - 168*D1*Dd*b2*fd*r**2 - 168*D1*Dd*b2*fd*r*s + 84*D1*Dd*b2*fd*r + 21*D1*Dd*b2*fd*s - 168*D1*Dd*bd2*f*r**2 - 168*D1*Dd*bd2*f*r*s + 168*D1*Dd*bd2*f*r + 21*D1*Dd*bd2*f*s - 21*D1*Dd*bd2*f - 92*D1*Dd*f**3*r**2 - 92*D1*Dd*f**3*r*s + 92*D1*Dd*f**3*r + 23*D1*Dd*f**3*s - 23*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 600*D1*Dd*f**2*fd*r*s - 640*D1*Dd*f**2*fd*r - 175*D1*Dd*f**2*fd*s + 135*D1*Dd*f**2*fd - 44*D1*Dd*f**2*r**2 - 44*D1*Dd*f**2*r*s + 44*D1*Dd*f**2*r + 11*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 144*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r - 54*D1*Dd*f*fd*s + 36*D1*Dd*f*fd - 56*D1*Dd*f*g2*r**2 - 56*D1*Dd*f*g2*r*s + 56*D1*Dd*f*g2*r + 14*D1*Dd*f*g2*s - 14*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 + 336*D1*Dd*f*gd2*r*s - 336*D1*Dd*f*gd2*r - 42*D1*Dd*f*gd2*s + 42*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r**2 + 336*D1*Dd*fd*g2*r*s - 168*D1*Dd*fd*g2*r - 42*D1*Dd*fd*g2*s - 36*D1*Ddd*K*f**2*r**2 - 36*D1*Ddd*K*f**2*r*s + 36*D1*Ddd*K*f**2*r + 9*D1*Ddd*K*f**2*s - 9*D1*Ddd*K*f**2 - 84*D1*Ddd*b2*f*r**2 - 84*D1*Ddd*b2*f*r*s + 84*D1*Ddd*b2*f*r + 21*D1*Ddd*b2*f*s - 21*D1*Ddd*b2*f + 100*D1*Ddd*f**3*r**2 + 100*D1*Ddd*f**3*r*s - 100*D1*Ddd*f**3*r - 25*D1*Ddd*f**3*s + 25*D1*Ddd*f**3 + 36*D1*Ddd*f**2*r**2 + 36*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r - 9*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*r**2 + 168*D1*Ddd*f*g2*r*s - 168*D1*Ddd*f*g2*r - 42*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(-32*r**2 + r*(62 - 32*s) + 27*s - 27) + f*(18*fd*(4*r - 1)*(4*r + 4*s - 3) + (7*K - 7)*(2*r - 1)*(r + s - 1)) - 21*fd*(K - 1)*(4*r**2 + r*(4*s - 3) - s)) + 3*Dd*f*(6*f*(32*r**2 + 8*r*(4*s - 5) - 14*s + 11) + (7 - 7*K)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5))) - 108*Dd**2*K*f**2*r**2 - 108*Dd**2*K*f**2*r*s + 108*Dd**2*K*f**2*r + 27*Dd**2*K*f**2*s - 18*Dd**2*K*f**2 - 252*Dd**2*b2*f*r**2 - 252*Dd**2*b2*f*r*s + 252*Dd**2*b2*f*r + 63*Dd**2*b2*f*s - 42*Dd**2*b2*f + 300*Dd**2*f**3*r**2 + 300*Dd**2*f**3*r*s - 300*Dd**2*f**3*r - 75*Dd**2*f**3*s + 50*Dd**2*f**3 + 108*Dd**2*f**2*r**2 + 108*Dd**2*f**2*r*s - 108*Dd**2*f**2*r - 27*Dd**2*f**2*s + 18*Dd**2*f**2 + 504*Dd**2*f*g2*r**2 + 504*Dd**2*f*g2*r*s - 504*Dd**2*f*g2*r - 126*Dd**2*f*g2*s + 84*Dd**2*f*g2) + b2*(-21*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 22*D1**2*f*fd*r**2 + 22*D1**2*f*fd*r*s - 22*D1**2*f*fd*r - 11*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 18*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 9*D1**2*f*fdd - 18*D1**2*fd**2*r**2 - 18*D1**2*fd**2*r*s + 18*D1**2*fd**2*r + 9*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 44*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r - 11*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 144*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r + 54*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 36*D1*Ddd*f**2*r**2 - 36*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r + 9*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 108*Dd**2*f**2*r**2 - 108*Dd**2*f**2*r*s + 108*Dd**2*f**2*r + 27*Dd**2*f**2*s - 18*Dd**2*f**2))/(105*d**2*k3**3) + 2*D1**2*Pkd1*Pkd3*ct*k2*st**2*(D1*f*(-7*D1*bd1**2*(3*C - 2)*(2*r**2 + 2*r*(s - 1) - s) - 3*D1*bdd1*f*r*(3*C - 2)*(r + s) + bd1*(D1*(f*r*(11*C - 5)*(r + s) - fd*(9*C - 6)*(4*r**2 + r*(4*s - 3) - s)) + Dd*f*(6 - 9*C)*(8*r**2 + r*(8*s - 4) - s))) + 7*b1**2*(D1**2*r*(r + s - 1)*(C*fd - 3*C*fdd + fd + 2*fdd) + D1*(Dd*(f*(C + 1)*(4*r**2 + 4*r*(s - 1) - s + 1) - fd*(3*C - 2)*(8*r**2 + 8*r*(s - 1) - s + 1)) - Ddd*f*(3*C - 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(3*C - 2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(22*C*D1**2*f*fd*r**2 + 22*C*D1**2*f*fd*r*s - 33*C*D1**2*f*fd*r - 11*C*D1**2*f*fd*s + 11*C*D1**2*f*fd - 18*C*D1**2*f*fdd*r**2 - 18*C*D1**2*f*fdd*r*s + 27*C*D1**2*f*fdd*r + 9*C*D1**2*f*fdd*s - 9*C*D1**2*f*fdd - 18*C*D1**2*fd**2*r**2 - 18*C*D1**2*fd**2*r*s + 27*C*D1**2*fd**2*r + 9*C*D1**2*fd**2*s - 9*C*D1**2*fd**2 + 44*C*D1*Dd*f**2*r**2 + 44*C*D1*Dd*f**2*r*s - 44*C*D1*Dd*f**2*r - 11*C*D1*Dd*f**2*s + 11*C*D1*Dd*f**2 - 144*C*D1*Dd*f*fd*r**2 - 144*C*D1*Dd*f*fd*r*s + 180*C*D1*Dd*f*fd*r + 54*C*D1*Dd*f*fd*s - 45*C*D1*Dd*f*fd - 36*C*D1*Ddd*f**2*r**2 - 36*C*D1*Ddd*f**2*r*s + 36*C*D1*Ddd*f**2*r + 9*C*D1*Ddd*f**2*s - 9*C*D1*Ddd*f**2 - 108*C*Dd**2*f**2*r**2 - 108*C*Dd**2*f**2*r*s + 108*C*Dd**2*f**2*r + 27*C*Dd**2*f**2*s - 18*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(3*C - 2)*(2*r**2 + 2*r*(s - 1) - s + 1) - 10*D1**2*f*fd*r**2 - 10*D1**2*f*fd*r*s + 15*D1**2*f*fd*r + 5*D1**2*f*fd*s - 5*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r - 6*D1**2*f*fdd*s + 6*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 18*D1**2*fd**2*r - 6*D1**2*fd**2*s + 6*D1**2*fd**2 - 20*D1*Dd*f**2*r**2 - 20*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r + 5*D1*Dd*f**2*s - 5*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r - 36*D1*Dd*f*fd*s + 30*D1*Dd*f*fd + 24*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 24*D1*Ddd*f**2*r - 6*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(C + 1)*(2*r**2 + 2*r*(s - 1) - s + 1) - fd*(3*C - 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd*f*(6*C - 4)*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 72*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 72*Dd**2*f**2*r - 18*Dd**2*f**2*s + 12*Dd**2*f**2))/(105*d**2*k3) + D1**2*Pkd1*Pkd3*ct*k2*(D1*(D1*bd1**2*(15*f**2*r*(2*r + 2*s - 1) - 21*f*r*(K - 1)*(2*r + 2*s - 1) + 70*g2*(2*r**2 + 2*r*(s - 1) - s)) + 42*D1*bdd1*f*g2*r*(r + s) - 7*b2*(5*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + 3*D1*bdd1*f*r*(r + s) + bd1*(D1*(-f*r*(r + s) + fd*(6*r**2 + 6*r*(s - 1) - 3*s)) + 3*Dd*f*(8*r**2 + r*(8*s - 4) - s))) - 7*bd1*(3*D1*bd2*f*r*(2*r + 2*s - 1) + 2*D1*(f*r*(g2*(r + s) + gd2*(-6*r - 6*s + 3)) + 3*fd*g2*(-2*r**2 - 2*r*(s - 1) + s)) - 6*Dd*f*g2*(8*r**2 + r*(8*s - 4) - s))) - 7*b1**3*(D1**2*r*(fd - 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + (5*K - 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-5*K + 3*f + 5)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-5*K + 3*f + 5)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(7*D1**2*K*fd*r**2 + 7*D1**2*K*fd*r*s - 14*D1**2*K*fd*r - 7*D1**2*K*fd*s + 7*D1**2*K*fd - 21*D1**2*K*fdd*r**2 - 21*D1**2*K*fdd*r*s + 42*D1**2*K*fdd*r + 21*D1**2*K*fdd*s - 21*D1**2*K*fdd - 35*D1**2*bd2*r**2 - 35*D1**2*bd2*r*s + 35*D1**2*bd2*r + 7*D1**2*bdd1*(-5*K + 3*f + 5)*(3*r**2 + 3*r*(s - 1) - s + 1) - 35*D1**2*bdd2*r**2 - 35*D1**2*bdd2*r*s + 35*D1**2*bdd2*r - 18*D1**2*f*fd*r**2 - 18*D1**2*f*fd*r*s + 27*D1**2*f*fd*r + 9*D1**2*f*fd*s - 9*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 30*D1**2*f*fdd*r*s - 45*D1**2*f*fdd*r - 15*D1**2*f*fdd*s + 15*D1**2*f*fdd + 30*D1**2*fd**2*r**2 + 30*D1**2*fd**2*r*s - 45*D1**2*fd**2*r - 15*D1**2*fd**2*s + 15*D1**2*fd**2 - 7*D1**2*fd*r**2 - 7*D1**2*fd*r*s + 14*D1**2*fd*r + 7*D1**2*fd*s - 7*D1**2*fd + 21*D1**2*fdd*r**2 + 21*D1**2*fdd*r*s - 42*D1**2*fdd*r - 21*D1**2*fdd*s + 21*D1**2*fdd + 70*D1**2*gd2*r**2 + 70*D1**2*gd2*r*s - 70*D1**2*gd2*r + 70*D1**2*gdd2*r**2 + 70*D1**2*gdd2*r*s - 70*D1**2*gdd2*r + 28*D1*Dd*K*f*r**2 + 28*D1*Dd*K*f*r*s - 28*D1*Dd*K*f*r - 7*D1*Dd*K*f*s + 7*D1*Dd*K*f - 168*D1*Dd*K*fd*r**2 - 168*D1*Dd*K*fd*r*s + 252*D1*Dd*K*fd*r + 105*D1*Dd*K*fd*s - 84*D1*Dd*K*fd - 140*D1*Dd*b2*r**2 - 140*D1*Dd*b2*r*s + 140*D1*Dd*b2*r + 35*D1*Dd*b2*s - 35*D1*Dd*b2 - 280*D1*Dd*bd2*r**2 - 280*D1*Dd*bd2*r*s + 280*D1*Dd*bd2*r + 35*D1*Dd*bd2*s - 35*D1*Dd*bd2 - 36*D1*Dd*f**2*r**2 - 36*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r + 9*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 240*D1*Dd*f*fd*r*s - 300*D1*Dd*f*fd*r - 90*D1*Dd*f*fd*s + 75*D1*Dd*f*fd - 28*D1*Dd*f*r**2 - 28*D1*Dd*f*r*s + 28*D1*Dd*f*r + 7*D1*Dd*f*s - 7*D1*Dd*f + 168*D1*Dd*fd*r**2 + 168*D1*Dd*fd*r*s - 252*D1*Dd*fd*r - 105*D1*Dd*fd*s + 84*D1*Dd*fd + 280*D1*Dd*g2*r**2 + 280*D1*Dd*g2*r*s - 280*D1*Dd*g2*r - 70*D1*Dd*g2*s + 70*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 + 560*D1*Dd*gd2*r*s - 560*D1*Dd*gd2*r - 70*D1*Dd*gd2*s + 70*D1*Dd*gd2 - 84*D1*Ddd*K*f*r**2 - 84*D1*Ddd*K*f*r*s + 84*D1*Ddd*K*f*r + 21*D1*Ddd*K*f*s - 21*D1*Ddd*K*f - 140*D1*Ddd*b2*r**2 - 140*D1*Ddd*b2*r*s + 140*D1*Ddd*b2*r + 35*D1*Ddd*b2*s - 35*D1*Ddd*b2 + 60*D1*Ddd*f**2*r**2 + 60*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r - 15*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 + 84*D1*Ddd*f*r*s - 84*D1*Ddd*f*r - 21*D1*Ddd*f*s + 21*D1*Ddd*f + 280*D1*Ddd*g2*r**2 + 280*D1*Ddd*g2*r*s - 280*D1*Ddd*g2*r - 70*D1*Ddd*g2*s + 70*D1*Ddd*g2 - 7*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + (5*K - 5)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-5*K + 3*f + 5)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 252*Dd**2*K*f*r**2 - 252*Dd**2*K*f*r*s + 252*Dd**2*K*f*r + 63*Dd**2*K*f*s - 42*Dd**2*K*f - 420*Dd**2*b2*r**2 - 420*Dd**2*b2*r*s + 420*Dd**2*b2*r + 105*Dd**2*b2*s - 70*Dd**2*b2 + 180*Dd**2*f**2*r**2 + 180*Dd**2*f**2*r*s - 180*Dd**2*f**2*r - 45*Dd**2*f**2*s + 30*Dd**2*f**2 + 252*Dd**2*f*r**2 + 252*Dd**2*f*r*s - 252*Dd**2*f*r - 63*Dd**2*f*s + 42*Dd**2*f + 840*Dd**2*g2*r**2 + 840*Dd**2*g2*r*s - 840*Dd**2*g2*r - 210*Dd**2*g2*s + 140*Dd**2*g2) + b1*(-42*D1**2*K*bdd1*f*r**2 - 42*D1**2*K*bdd1*f*r*s + 21*D1**2*K*bdd1*f*r + 7*D1**2*bd1**2*(-5*K + 3*f + 5)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 7*D1**2*bd2*f*r**2 + 7*D1**2*bd2*f*r*s - 7*D1**2*bd2*f*r - 42*D1**2*bd2*fd*r**2 - 42*D1**2*bd2*fd*r*s + 63*D1**2*bd2*fd*r + 21*D1**2*bd2*fd*s - 21*D1**2*bd2*fd + 30*D1**2*bdd1*f**2*r**2 + 30*D1**2*bdd1*f**2*r*s - 15*D1**2*bdd1*f**2*r + 42*D1**2*bdd1*f*r**2 + 42*D1**2*bdd1*f*r*s - 21*D1**2*bdd1*f*r + 140*D1**2*bdd1*g2*r**2 + 140*D1**2*bdd1*g2*r*s - 140*D1**2*bdd1*g2*r - 70*D1**2*bdd1*g2*s + 70*D1**2*bdd1*g2 - 21*D1**2*bdd2*f*r**2 - 21*D1**2*bdd2*f*r*s + 21*D1**2*bdd2*f*r - 14*D1**2*f*gd2*r**2 - 14*D1**2*f*gd2*r*s + 14*D1**2*f*gd2*r + 42*D1**2*f*gdd2*r**2 + 42*D1**2*f*gdd2*r*s - 42*D1**2*f*gdd2*r - 14*D1**2*fd*g2*r**2 - 14*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*r + 14*D1**2*fd*g2*s - 14*D1**2*fd*g2 + 84*D1**2*fd*gd2*r**2 + 84*D1**2*fd*gd2*r*s - 126*D1**2*fd*gd2*r - 42*D1**2*fd*gd2*s + 42*D1**2*fd*gd2 + 42*D1**2*fdd*g2*r**2 + 42*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r - 42*D1**2*fdd*g2*s + 42*D1**2*fdd*g2 - 168*D1*Dd*bd2*f*r**2 - 168*D1*Dd*bd2*f*r*s + 168*D1*Dd*bd2*f*r + 21*D1*Dd*bd2*f*s - 21*D1*Dd*bd2*f - 56*D1*Dd*f*g2*r**2 - 56*D1*Dd*f*g2*r*s + 56*D1*Dd*f*g2*r + 14*D1*Dd*f*g2*s - 14*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 + 336*D1*Dd*f*gd2*r*s - 336*D1*Dd*f*gd2*r - 42*D1*Dd*f*gd2*s + 42*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r**2 + 336*D1*Dd*fd*g2*r*s - 504*D1*Dd*fd*g2*r - 210*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 + 168*D1*Ddd*f*g2*r**2 + 168*D1*Ddd*f*g2*r*s - 168*D1*Ddd*f*g2*r - 42*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + D1*bd1*(-35*D1*bd2*(4*r**2 + 4*r*(s - 1) - s + 1) + D1*(14*K*f*r**2 + 14*K*f*r*s - 7*K*f*r - 18*f**2*r**2 - 18*f**2*r*s + 9*f**2*r - 14*f*r**2 - 14*f*r*s + 7*f*r + 3*fd*(5*f*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (7*K - 7)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + 70*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 280*gd2*r**2 + 280*gd2*r*s - 280*gd2*r - 70*gd2*s + 70*gd2) + Dd*(15*f**2*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) - 21*f*(K - 1)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 140*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + 504*Dd**2*f*g2*r**2 + 504*Dd**2*f*g2*r*s - 504*Dd**2*f*g2*r - 126*Dd**2*f*g2*s + 84*Dd**2*f*g2 - 7*b2*(5*D1**2*bdd1*(2*r**2 + 2*r*(s - 1) - s + 1) - D1**2*fd*r**2 - D1**2*fd*r*s + 2*D1**2*fd*r + D1**2*fd*s - D1**2*fd + 3*D1**2*fdd*r**2 + 3*D1**2*fdd*r*s - 6*D1**2*fdd*r - 3*D1**2*fdd*s + 3*D1**2*fdd - 4*D1*Dd*f*r**2 - 4*D1*Dd*f*r*s + 4*D1*Dd*f*r + D1*Dd*f*s - D1*Dd*f + 24*D1*Dd*fd*r**2 + 24*D1*Dd*fd*r*s - 36*D1*Dd*fd*r - 15*D1*Dd*fd*s + 12*D1*Dd*fd + 12*D1*Ddd*f*r**2 + 12*D1*Ddd*f*r*s - 12*D1*Ddd*f*r - 3*D1*Ddd*f*s + 3*D1*Ddd*f + 5*D1*bd1*(D1*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*Dd*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 36*Dd**2*f*r**2 + 36*Dd**2*f*r*s - 36*Dd**2*f*r - 9*Dd**2*f*s + 6*Dd**2*f)))/(105*d**2*k3) + D1**2*Pkd1*Pkd3*f*k2**6*st**6*(-66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fd*r*s + 44*D1**2*b1*f*fd*r + 33*D1**2*b1*f*fdd*r**2 + 33*D1**2*b1*f*fdd*r*s - 22*D1**2*b1*f*fdd*r + 66*D1**2*b1*fd**2*r**2 + 66*D1**2*b1*fd**2*r*s - 44*D1**2*b1*fd**2*r + 11*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 24*D1**2*f**2*fd*r**2 - 24*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r*s - 12*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s + 3*D1**2*f**2*fdd + 36*D1**2*f*fd**2*r**2 + 36*D1**2*f*fd**2*r*s - 36*D1**2*f*fd**2*r - 9*D1**2*f*fd**2*s + 6*D1**2*f*fd**2 - 88*D1*Dd*b1*f**2*r**2 - 88*D1*Dd*b1*f**2*r*s + 88*D1*Dd*b1*f**2*r + 22*D1*Dd*b1*f**2*s - 22*D1*Dd*b1*f**2 + 264*D1*Dd*b1*f*fd*r**2 + 264*D1*Dd*b1*f*fd*r*s - 220*D1*Dd*b1*f*fd*r - 33*D1*Dd*b1*f*fd*s + 22*D1*Dd*b1*f*fd - 24*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r*s + 24*D1*Dd*f**3*r + 6*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 96*D1*Dd*f**2*fd*r*s - 96*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s + 18*D1*Dd*f**2*fd + 44*D1*Ddd*b1*f**2*r**2 + 44*D1*Ddd*b1*f**2*r*s - 44*D1*Ddd*b1*f**2*r - 11*D1*Ddd*b1*f**2*s + 11*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*r**2 + 12*D1*Ddd*f**3*r*s - 12*D1*Ddd*f**3*r - 3*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 - 11*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) + 132*Dd**2*b1*f**2*r**2 + 132*Dd**2*b1*f**2*r*s - 132*Dd**2*b1*f**2*r - 33*Dd**2*b1*f**2*s + 22*Dd**2*b1*f**2 + 36*Dd**2*f**3*r**2 + 36*Dd**2*f**3*r*s - 36*Dd**2*f**3*r - 9*Dd**2*f**3*s + 6*Dd**2*f**3)/(693*d**2*k1*k3**5) + D1**2*Pkd1*Pkd3*k1**5*st**2*(2*C - 1)*(6*D1**2*b1*f*fd*r**2 + 6*D1**2*b1*f*fd*r*s - 3*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 18*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r + 9*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 3*D1**2*f**2*fd*r**2 - 3*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r + D1**2*f**2*fd*s - D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r - 10*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 + 12*D1*Dd*b1*f**2*r**2 + 12*D1*Dd*b1*f**2*r*s - 12*D1*Dd*b1*f**2*r - 3*D1*Dd*b1*f**2*s + 3*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 108*D1*Dd*b1*f*fd*r - 18*D1*Dd*b1*f*fd*s + 9*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 4*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r + D1*Dd*f**3*s - D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 120*D1*Dd*f**2*fd*r - 35*D1*Dd*f**2*fd*s + 25*D1*Dd*f**2*fd + 36*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r - 9*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r - 5*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 3*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 108*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r - 27*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 60*Dd**2*f**3*r - 15*Dd**2*f**3*s + 10*Dd**2*f**3)/(315*d**2*k3**5) + D1**2*Pkd1*Pkd3*k1**5*(-7*D1**2*K*b1**2*fd*r**2 - 7*D1**2*K*b1**2*fd*r*s + 21*D1**2*K*b1**2*fdd*r**2 + 21*D1**2*K*b1**2*fdd*r*s - 18*D1**2*K*b1*f*fd*r**2 - 18*D1**2*K*b1*f*fd*r*s + 18*D1**2*K*b1*f*fd*r + 9*D1**2*K*b1*f*fd*s - 9*D1**2*K*b1*f*fd + 30*D1**2*K*b1*f*fdd*r**2 + 30*D1**2*K*b1*f*fdd*r*s - 30*D1**2*K*b1*f*fdd*r - 15*D1**2*K*b1*f*fdd*s + 15*D1**2*K*b1*f*fdd + 30*D1**2*K*b1*fd**2*r**2 + 30*D1**2*K*b1*fd**2*r*s - 30*D1**2*K*b1*fd**2*r - 15*D1**2*K*b1*fd**2*s + 21*D1**2*K*bd1**2*f*(2*r - 1)*(r + s - 1) + 14*D1**2*b1*f*gd2*r**2 + 14*D1**2*b1*f*gd2*r*s - 14*D1**2*b1*f*gd2*r - 42*D1**2*b1*f*gdd2*r**2 - 42*D1**2*b1*f*gdd2*r*s + 42*D1**2*b1*f*gdd2*r + 14*D1**2*b1*fd*g2*r**2 + 14*D1**2*b1*fd*g2*r*s - 84*D1**2*b1*fd*gd2*r**2 - 84*D1**2*b1*fd*gd2*r*s + 42*D1**2*b1*fd*gd2*r - 42*D1**2*b1*fdd*g2*r**2 - 42*D1**2*b1*fdd*g2*r*s + 3*D1**2*bdd1*f*(r + s - 1)*(7*K*b1*(2*r - 1) + 5*K*f*r - 14*g2*(r - 1)) + 18*D1**2*f**2*gd2*r**2 + 18*D1**2*f**2*gd2*r*s - 18*D1**2*f**2*gd2*r - 30*D1**2*f**2*gdd2*r**2 - 30*D1**2*f**2*gdd2*r*s + 30*D1**2*f**2*gdd2*r + 36*D1**2*f*fd*g2*r**2 + 36*D1**2*f*fd*g2*r*s - 36*D1**2*f*fd*g2*r - 18*D1**2*f*fd*g2*s + 18*D1**2*f*fd*g2 - 120*D1**2*f*fd*gd2*r**2 - 120*D1**2*f*fd*gd2*r*s + 120*D1**2*f*fd*gd2*r + 30*D1**2*f*fd*gd2*s - 30*D1**2*f*fd*gd2 - 60*D1**2*f*fdd*g2*r**2 - 60*D1**2*f*fdd*g2*r*s + 60*D1**2*f*fdd*g2*r + 30*D1**2*f*fdd*g2*s - 30*D1**2*f*fdd*g2 - 60*D1**2*fd**2*g2*r**2 - 60*D1**2*fd**2*g2*r*s + 60*D1**2*fd**2*g2*r + 30*D1**2*fd**2*g2*s - 28*D1*Dd*K*b1**2*f*r**2 - 28*D1*Dd*K*b1**2*f*r*s + 28*D1*Dd*K*b1**2*f*r + 7*D1*Dd*K*b1**2*f*s - 7*D1*Dd*K*b1**2*f + 168*D1*Dd*K*b1**2*fd*r**2 + 168*D1*Dd*K*b1**2*fd*r*s - 84*D1*Dd*K*b1**2*fd*r - 21*D1*Dd*K*b1**2*fd*s - 36*D1*Dd*K*b1*f**2*r**2 - 36*D1*Dd*K*b1*f**2*r*s + 36*D1*Dd*K*b1*f**2*r + 9*D1*Dd*K*b1*f**2*s - 9*D1*Dd*K*b1*f**2 + 240*D1*Dd*K*b1*f*fd*r**2 + 240*D1*Dd*K*b1*f*fd*r*s - 240*D1*Dd*K*b1*f*fd*r - 90*D1*Dd*K*b1*f*fd*s + 60*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f*g2*r**2 + 56*D1*Dd*b1*f*g2*r*s - 56*D1*Dd*b1*f*g2*r - 14*D1*Dd*b1*f*g2*s + 14*D1*Dd*b1*f*g2 - 336*D1*Dd*b1*f*gd2*r**2 - 336*D1*Dd*b1*f*gd2*r*s + 336*D1*Dd*b1*f*gd2*r + 42*D1*Dd*b1*f*gd2*s - 42*D1*Dd*b1*f*gd2 - 336*D1*Dd*b1*fd*g2*r**2 - 336*D1*Dd*b1*fd*g2*r*s + 168*D1*Dd*b1*fd*g2*r + 42*D1*Dd*b1*fd*g2*s + 72*D1*Dd*f**2*g2*r**2 + 72*D1*Dd*f**2*g2*r*s - 72*D1*Dd*f**2*g2*r - 18*D1*Dd*f**2*g2*s + 18*D1*Dd*f**2*g2 - 240*D1*Dd*f**2*gd2*r**2 - 240*D1*Dd*f**2*gd2*r*s + 240*D1*Dd*f**2*gd2*r + 30*D1*Dd*f**2*gd2*s - 30*D1*Dd*f**2*gd2 - 480*D1*Dd*f*fd*g2*r**2 - 480*D1*Dd*f*fd*g2*r*s + 480*D1*Dd*f*fd*g2*r + 180*D1*Dd*f*fd*g2*s - 120*D1*Dd*f*fd*g2 + 84*D1*Ddd*K*b1**2*f*r**2 + 84*D1*Ddd*K*b1**2*f*r*s - 84*D1*Ddd*K*b1**2*f*r - 21*D1*Ddd*K*b1**2*f*s + 21*D1*Ddd*K*b1**2*f + 60*D1*Ddd*K*b1*f**2*r**2 + 60*D1*Ddd*K*b1*f**2*r*s - 60*D1*Ddd*K*b1*f**2*r - 15*D1*Ddd*K*b1*f**2*s + 15*D1*Ddd*K*b1*f**2 - 168*D1*Ddd*b1*f*g2*r**2 - 168*D1*Ddd*b1*f*g2*r*s + 168*D1*Ddd*b1*f*g2*r + 42*D1*Ddd*b1*f*g2*s - 42*D1*Ddd*b1*f*g2 - 120*D1*Ddd*f**2*g2*r**2 - 120*D1*Ddd*f**2*g2*r*s + 120*D1*Ddd*f**2*g2*r + 30*D1*Ddd*f**2*g2*s - 30*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-9*K*f**2*r*(r + s - 1) + f*(-7*K*b1*(2*r - 1)*(r + s - 1) + 15*K*fd*(4*r**2 + 4*r*(s - 1) - s + 1) + 14*g2*(r - 1)*(r + s - 1) - 42*gd2*(2*r - 1)*(r + s - 1)) - 21*fd*(K*b1*(-4*r**2 + r*(3 - 4*s) + s) + g2*(4*r**2 + 4*r*(s - 1) - 2*s))) + 3*Dd*f*(K*(7*b1*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 5*f*(8*r**2 + 8*r*(s - 1) - s + 1)) - 14*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 252*Dd**2*K*b1**2*f*r**2 + 252*Dd**2*K*b1**2*f*r*s - 252*Dd**2*K*b1**2*f*r - 63*Dd**2*K*b1**2*f*s + 42*Dd**2*K*b1**2*f + 180*Dd**2*K*b1*f**2*r**2 + 180*Dd**2*K*b1*f**2*r*s - 180*Dd**2*K*b1*f**2*r - 45*Dd**2*K*b1*f**2*s + 30*Dd**2*K*b1*f**2 - 504*Dd**2*b1*f*g2*r**2 - 504*Dd**2*b1*f*g2*r*s + 504*Dd**2*b1*f*g2*r + 126*Dd**2*b1*f*g2*s - 84*Dd**2*b1*f*g2 - 360*Dd**2*f**2*g2*r**2 - 360*Dd**2*f**2*g2*r*s + 360*Dd**2*f**2*g2*r + 90*Dd**2*f**2*g2*s - 60*Dd**2*f**2*g2)/(105*d**2*k3**5) + D1**2*Pkd1*Pkd3*k1**3*k2**2*st**4*(2*C - 1)*(2*D1**2*b1*f*fd*r**2 + 2*D1**2*b1*f*fd*r*s - D1**2*b1*f*fd*r + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*f*fdd*r*s - 3*D1**2*b1*f*fdd*r + 6*D1**2*b1*fd**2*r**2 + 6*D1**2*b1*fd**2*r*s - 3*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 3*D1**2*f**2*fd*r**2 - 3*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r + D1**2*f**2*fd*s - D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 + 4*D1*Dd*b1*f**2*r**2 + 4*D1*Dd*b1*f**2*r*s - 4*D1*Dd*b1*f**2*r - D1*Dd*b1*f**2*s + D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 48*D1*Dd*b1*f*fd*r*s - 36*D1*Dd*b1*f*fd*r - 6*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 4*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r + D1*Dd*f**3*s - D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 24*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 5*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 + 12*D1*Ddd*b1*f**2*r*s - 12*D1*Ddd*b1*f**2*r - 3*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 4*D1*Ddd*f**3*r - D1*Ddd*f**3*s + D1*Ddd*f**3 + D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 36*Dd**2*b1*f**2*r**2 + 36*Dd**2*b1*f**2*r*s - 36*Dd**2*b1*f**2*r - 9*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 12*Dd**2*f**3*r - 3*Dd**2*f**3*s + 2*Dd**2*f**3)/(35*d**2*k3**5) + D1**2*Pkd1*Pkd3*k1**3*k2**2*st**2*(297*D1**2*K*bdd1*f**2*r**2 + 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*r - 99*D1**2*bd1**2*f*(-7*K + 4*f)*(2*r - 1)*(r + s - 1) - 165*D1**2*bdd1*f**3*r**2 - 165*D1**2*bdd1*f**3*r*s + 110*D1**2*bdd1*f**3*r - 55*D1**2*bdd1*f**3*s + 55*D1**2*bdd1*f**3 - 1386*D1**2*bdd1*f*g2*r**2 - 1386*D1**2*bdd1*f*g2*r*s + 2772*D1**2*bdd1*f*g2*r + 1386*D1**2*bdd1*f*g2*s - 1386*D1**2*bdd1*f*g2 - 60*D1**2*f**3*fd*r**2 - 60*D1**2*f**3*fd*r*s + 60*D1**2*f**3*fd*r + 15*D1**2*f**3*fd*s - 15*D1**2*f**3*fd + 140*D1**2*f**3*fdd*r**2 + 140*D1**2*f**3*fdd*r*s - 140*D1**2*f**3*fdd*r - 35*D1**2*f**3*fdd*s + 35*D1**2*f**3*fdd + 420*D1**2*f**2*fd**2*r**2 + 420*D1**2*f**2*fd**2*r*s - 420*D1**2*f**2*fd**2*r - 105*D1**2*f**2*fd**2*s + 70*D1**2*f**2*fd**2 + 726*D1**2*f**2*gd2*r**2 + 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*r - 594*D1**2*f**2*gdd2*r**2 - 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*r + 1452*D1**2*f*fd*g2*r**2 + 1452*D1**2*f*fd*g2*r*s - 1452*D1**2*f*fd*g2*r - 726*D1**2*f*fd*g2*s + 726*D1**2*f*fd*g2 - 2376*D1**2*f*fd*gd2*r**2 - 2376*D1**2*f*fd*gd2*r*s + 2376*D1**2*f*fd*gd2*r + 594*D1**2*f*fd*gd2*s - 594*D1**2*f*fd*gd2 - 1188*D1**2*f*fdd*g2*r**2 - 1188*D1**2*f*fdd*g2*r*s + 1188*D1**2*f*fdd*g2*r + 594*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 1188*D1**2*fd**2*g2*r**2 - 1188*D1**2*fd**2*g2*r*s + 1188*D1**2*fd**2*g2*r + 594*D1**2*fd**2*g2*s - 60*D1*Dd*f**4*r**2 - 60*D1*Dd*f**4*r*s + 60*D1*Dd*f**4*r + 15*D1*Dd*f**4*s - 15*D1*Dd*f**4 + 1120*D1*Dd*f**3*fd*r**2 + 1120*D1*Dd*f**3*fd*r*s - 1120*D1*Dd*f**3*fd*r - 280*D1*Dd*f**3*fd*s + 210*D1*Dd*f**3*fd + 2904*D1*Dd*f**2*g2*r**2 + 2904*D1*Dd*f**2*g2*r*s - 2904*D1*Dd*f**2*g2*r - 726*D1*Dd*f**2*g2*s + 726*D1*Dd*f**2*g2 - 4752*D1*Dd*f**2*gd2*r**2 - 4752*D1*Dd*f**2*gd2*r*s + 4752*D1*Dd*f**2*gd2*r + 594*D1*Dd*f**2*gd2*s - 594*D1*Dd*f**2*gd2 - 9504*D1*Dd*f*fd*g2*r**2 - 9504*D1*Dd*f*fd*g2*r*s + 9504*D1*Dd*f*fd*g2*r + 3564*D1*Dd*f*fd*g2*s - 2376*D1*Dd*f*fd*g2 + 140*D1*Ddd*f**4*r**2 + 140*D1*Ddd*f**4*r*s - 140*D1*Ddd*f**4*r - 35*D1*Ddd*f**4*s + 35*D1*Ddd*f**4 - 2376*D1*Ddd*f**2*g2*r**2 - 2376*D1*Ddd*f**2*g2*r*s + 2376*D1*Ddd*f**2*g2*r + 594*D1*Ddd*f**2*g2*s - 594*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(f**3*(12*r + 1)*(r + s - 1) - f**2*(33*K*r*(r + s - 1) + 5*fd*(18*r**2 + 2*r*(9*s - 8) - s + 2)) + 3*f*(9*K*fd*(4*r**2 + 4*r*(s - 1) - s + 1) + 14*g2*(r - 1)*(r + s - 1) - 42*gd2*(2*r - 1)*(r + s - 1)) - 126*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - Dd*f*(f*(-27*K*(8*r**2 + 8*r*(s - 1) - s + 1) + 5*f*(24*r**2 + 4*r*(6*s - 5) + s)) + 126*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 420*Dd**2*f**4*r**2 + 420*Dd**2*f**4*r*s - 420*Dd**2*f**4*r - 105*Dd**2*f**4*s + 70*Dd**2*f**4 - 7128*Dd**2*f**2*g2*r**2 - 7128*Dd**2*f**2*g2*r*s + 7128*Dd**2*f**2*g2*r + 1782*Dd**2*f**2*g2*s - 1188*Dd**2*f**2*g2 + 33*b1**2*(D1**2*r*(-7*K*fd*(r + s) + 21*K*fdd*(r + s) + 3*f*(fd - 4*fdd)*(2*r + 2*s - 1) - 12*fd**2*(2*r + 2*s - 1)) + D1*(Dd*(21*K*fd*(8*r**2 + r*(8*s - 4) - s) + 3*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - f*(7*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 12*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1))) - 3*Ddd*f*(-7*K + 4*f)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-7*K + 4*f)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-66*D1**2*K*f*fd*r**2 - 66*D1**2*K*f*fd*r*s + 66*D1**2*K*f*fd*r + 33*D1**2*K*f*fd*s - 33*D1**2*K*f*fd + 54*D1**2*K*f*fdd*r**2 + 54*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r - 27*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 54*D1**2*K*fd**2*r**2 + 54*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r - 27*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(-7*K + 4*f)*(2*r - 1)*(r + s - 1) + 36*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 37*D1**2*f**2*fd*r - 13*D1**2*f**2*fd*s + 13*D1**2*f**2*fd - 45*D1**2*f**2*fdd*r**2 - 45*D1**2*f**2*fdd*r*s + 50*D1**2*f**2*fdd*r + 20*D1**2*f**2*fdd*s - 20*D1**2*f**2*fdd - 90*D1**2*f*fd**2*r**2 - 90*D1**2*f*fd**2*r*s + 100*D1**2*f*fd**2*r + 40*D1**2*f*fd**2*s - 20*D1**2*f*fd**2 + 42*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r - 126*D1**2*f*gdd2*r**2 - 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*r + 42*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s - 252*D1**2*fd*gd2*r**2 - 252*D1**2*fd*gd2*r*s + 126*D1**2*fd*gd2*r - 126*D1**2*fdd*g2*r**2 - 126*D1**2*fdd*g2*r*s - 132*D1*Dd*K*f**2*r**2 - 132*D1*Dd*K*f**2*r*s + 132*D1*Dd*K*f**2*r + 33*D1*Dd*K*f**2*s - 33*D1*Dd*K*f**2 + 432*D1*Dd*K*f*fd*r**2 + 432*D1*Dd*K*f*fd*r*s - 432*D1*Dd*K*f*fd*r - 162*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd + 48*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 48*D1*Dd*f**3*r - 12*D1*Dd*f**3*s + 12*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r**2 - 360*D1*Dd*f**2*fd*r*s + 380*D1*Dd*f**2*fd*r + 125*D1*Dd*f**2*fd*s - 90*D1*Dd*f**2*fd + 168*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r - 42*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 1008*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r + 126*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 1008*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r + 126*D1*Dd*fd*g2*s + 108*D1*Ddd*K*f**2*r**2 + 108*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r - 27*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 - 60*D1*Ddd*f**3*r**2 - 60*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r + 15*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 - 504*D1*Ddd*f*g2*r**2 - 504*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 126*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(21*K*fd*(4*r**2 + r*(4*s - 3) - s) + 3*f**2*(2*r - 1)*(r + s - 1) - f*(7*K*(2*r - 1)*(r + s - 1) + 12*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1))) - 3*Dd*f*(-7*K + 4*f)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 324*Dd**2*K*f**2*r**2 + 324*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r - 81*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 - 180*Dd**2*f**3*r**2 - 180*Dd**2*f**3*r*s + 180*Dd**2*f**3*r + 45*Dd**2*f**3*s - 30*Dd**2*f**3 - 1512*Dd**2*f*g2*r**2 - 1512*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 378*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(3465*d**2*k3**5) + D1**2*Pkd1*Pkd3*k1**3*st**2*(2*C - 1)*(3*D1*b1*(7*D1*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 7*bd1*(D1*(f*(6*r**2 + 6*r*(s - 1) - 3*s + 3) + fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - (2*r + s - 1)*(D1*f*(fd + 3*fdd) + 3*D1*fd**2 + 12*Dd*f*fd)) + 21*b1**2*(D1**2*r*(3*fd + fdd)*(r + s - 1) + D1*(Dd*(3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + f*(21*D1**2*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + 9*D1**2*bdd1*f*(2*r + s - 1) + 3*D1**2*f*fd*r**2 + 3*D1**2*f*fd*r*s - 3*D1**2*f*fd*r - D1**2*f*fd*s + D1**2*f*fd - 15*D1**2*f*fdd*r**2 - 15*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 30*D1**2*fd**2*r*s + 30*D1**2*fd**2*r + 10*D1**2*fd**2*s - 5*D1**2*fd**2 + 4*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r - D1*Dd*f**2*s + D1*Dd*f**2 - 120*D1*Dd*f*fd*r**2 - 120*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r + 35*D1*Dd*f*fd*s - 25*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f + 3*fd) + 12*Dd*f)*(2*r + s - 1) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(315*d**2*k3**3) + D1**2*Pkd1*Pkd3*k1**3*(105*D1**2*K*b1**2*bdd1*r**2 + 105*D1**2*K*b1**2*bdd1*r*s - 105*D1**2*K*b1**2*bdd1*r - 35*D1**2*K*b1**2*bdd1*s + 35*D1**2*K*b1**2*bdd1 + 14*D1**2*K*b1**2*fd*r + 7*D1**2*K*b1**2*fd*s - 7*D1**2*K*b1**2*fd - 42*D1**2*K*b1**2*fdd*r - 21*D1**2*K*b1**2*fdd*s + 21*D1**2*K*b1**2*fdd + 42*D1**2*K*b1*bdd1*f*r + 21*D1**2*K*b1*bdd1*f*s - 21*D1**2*K*b1*bdd1*f + 18*D1**2*K*b1*f*fd*r**2 + 18*D1**2*K*b1*f*fd*r*s - 18*D1**2*K*b1*f*fd*r - 9*D1**2*K*b1*f*fd*s + 9*D1**2*K*b1*f*fd - 30*D1**2*K*b1*f*fdd*r**2 - 30*D1**2*K*b1*f*fdd*r*s + 30*D1**2*K*b1*f*fdd*r + 15*D1**2*K*b1*f*fdd*s - 15*D1**2*K*b1*f*fdd - 30*D1**2*K*b1*fd**2*r**2 - 30*D1**2*K*b1*fd**2*r*s + 30*D1**2*K*b1*fd**2*r + 15*D1**2*K*b1*fd**2*s - 15*D1**2*K*bdd1*f**2*r**2 - 15*D1**2*K*bdd1*f**2*r*s + 15*D1**2*K*bdd1*f**2*r - 70*D1**2*b1**2*gd2*r**2 - 70*D1**2*b1**2*gd2*r*s + 70*D1**2*b1**2*gd2*r - 70*D1**2*b1**2*gdd2*r**2 - 70*D1**2*b1**2*gdd2*r*s + 70*D1**2*b1**2*gdd2*r + 7*D1**2*b1*bd2*f*r**2 + 7*D1**2*b1*bd2*f*r*s - 7*D1**2*b1*bd2*f*r - 42*D1**2*b1*bd2*fd*r**2 - 42*D1**2*b1*bd2*fd*r*s + 21*D1**2*b1*bd2*fd*r - 140*D1**2*b1*bdd1*g2*r**2 - 140*D1**2*b1*bdd1*g2*r*s + 140*D1**2*b1*bdd1*g2*r + 70*D1**2*b1*bdd1*g2*s - 70*D1**2*b1*bdd1*g2 - 21*D1**2*b1*bdd2*f*r**2 - 21*D1**2*b1*bdd2*f*r*s + 21*D1**2*b1*bdd2*f*r - 28*D1**2*b1*fd*g2*r - 14*D1**2*b1*fd*g2*s + 14*D1**2*b1*fd*g2 + 84*D1**2*b1*fd*gd2*r + 42*D1**2*b1*fd*gd2*s - 42*D1**2*b1*fd*gd2 + 84*D1**2*b1*fdd*g2*r + 42*D1**2*b1*fdd*g2*s - 42*D1**2*b1*fdd*g2 + 7*D1**2*bd1**2*(5*K*b1*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 3*K*f*(2*r + s - 1) + 10*g2*(-2*r**2 - 2*r*s + 2*r + s)) + 9*D1**2*bd2*f**2*r**2 + 9*D1**2*bd2*f**2*r*s - 9*D1**2*bd2*f**2*r - 60*D1**2*bd2*f*fd*r**2 - 60*D1**2*bd2*f*fd*r*s + 60*D1**2*bd2*f*fd*r + 15*D1**2*bd2*f*fd*s - 15*D1**2*bd2*f*fd - 84*D1**2*bdd1*f*g2*r - 42*D1**2*bdd1*f*g2*s + 42*D1**2*bdd1*f*g2 - 15*D1**2*bdd2*f**2*r**2 - 15*D1**2*bdd2*f**2*r*s + 15*D1**2*bdd2*f**2*r - 18*D1**2*f**2*gd2*r**2 - 18*D1**2*f**2*gd2*r*s + 18*D1**2*f**2*gd2*r + 30*D1**2*f**2*gdd2*r**2 + 30*D1**2*f**2*gdd2*r*s - 30*D1**2*f**2*gdd2*r - 36*D1**2*f*fd*g2*r**2 - 36*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r + 18*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 + 120*D1**2*f*fd*gd2*r**2 + 120*D1**2*f*fd*gd2*r*s - 120*D1**2*f*fd*gd2*r - 30*D1**2*f*fd*gd2*s + 30*D1**2*f*fd*gd2 + 60*D1**2*f*fdd*g2*r**2 + 60*D1**2*f*fdd*g2*r*s - 60*D1**2*f*fdd*g2*r - 30*D1**2*f*fdd*g2*s + 30*D1**2*f*fdd*g2 + 60*D1**2*fd**2*g2*r**2 + 60*D1**2*fd**2*g2*r*s - 60*D1**2*fd**2*g2*r - 30*D1**2*fd**2*g2*s + 140*D1*Dd*K*b1**3*r**2 + 140*D1*Dd*K*b1**3*r*s - 140*D1*Dd*K*b1**3*r - 35*D1*Dd*K*b1**3*s + 35*D1*Dd*K*b1**3 - 168*D1*Dd*K*b1**2*fd*r - 84*D1*Dd*K*b1**2*fd*s + 84*D1*Dd*K*b1**2*fd + 36*D1*Dd*K*b1*f**2*r**2 + 36*D1*Dd*K*b1*f**2*r*s - 36*D1*Dd*K*b1*f**2*r - 9*D1*Dd*K*b1*f**2*s + 9*D1*Dd*K*b1*f**2 - 240*D1*Dd*K*b1*f*fd*r**2 - 240*D1*Dd*K*b1*f*fd*r*s + 240*D1*Dd*K*b1*f*fd*r + 90*D1*Dd*K*b1*f*fd*s - 60*D1*Dd*K*b1*f*fd - 280*D1*Dd*b1**2*g2*r**2 - 280*D1*Dd*b1**2*g2*r*s + 280*D1*Dd*b1**2*g2*r + 70*D1*Dd*b1**2*g2*s - 70*D1*Dd*b1**2*g2 - 560*D1*Dd*b1**2*gd2*r**2 - 560*D1*Dd*b1**2*gd2*r*s + 560*D1*Dd*b1**2*gd2*r + 70*D1*Dd*b1**2*gd2*s - 70*D1*Dd*b1**2*gd2 - 168*D1*Dd*b1*bd2*f*r**2 - 168*D1*Dd*b1*bd2*f*r*s + 168*D1*Dd*b1*bd2*f*r + 21*D1*Dd*b1*bd2*f*s - 21*D1*Dd*b1*bd2*f + 336*D1*Dd*b1*fd*g2*r + 168*D1*Dd*b1*fd*g2*s - 168*D1*Dd*b1*fd*g2 - 120*D1*Dd*bd2*f**2*r**2 - 120*D1*Dd*bd2*f**2*r*s + 120*D1*Dd*bd2*f**2*r + 15*D1*Dd*bd2*f**2*s - 15*D1*Dd*bd2*f**2 - 72*D1*Dd*f**2*g2*r**2 - 72*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r + 18*D1*Dd*f**2*g2*s - 18*D1*Dd*f**2*g2 + 240*D1*Dd*f**2*gd2*r**2 + 240*D1*Dd*f**2*gd2*r*s - 240*D1*Dd*f**2*gd2*r - 30*D1*Dd*f**2*gd2*s + 30*D1*Dd*f**2*gd2 + 480*D1*Dd*f*fd*g2*r**2 + 480*D1*Dd*f*fd*g2*r*s - 480*D1*Dd*f*fd*g2*r - 180*D1*Dd*f*fd*g2*s + 120*D1*Dd*f*fd*g2 + 140*D1*Ddd*K*b1**3*r**2 + 140*D1*Ddd*K*b1**3*r*s - 140*D1*Ddd*K*b1**3*r - 35*D1*Ddd*K*b1**3*s + 35*D1*Ddd*K*b1**3 - 60*D1*Ddd*K*b1*f**2*r**2 - 60*D1*Ddd*K*b1*f**2*r*s + 60*D1*Ddd*K*b1*f**2*r + 15*D1*Ddd*K*b1*f**2*s - 15*D1*Ddd*K*b1*f**2 - 280*D1*Ddd*b1**2*g2*r**2 - 280*D1*Ddd*b1**2*g2*r*s + 280*D1*Ddd*b1**2*g2*r + 70*D1*Ddd*b1**2*g2*s - 70*D1*Ddd*b1**2*g2 + 120*D1*Ddd*f**2*g2*r**2 + 120*D1*Ddd*f**2*g2*r*s - 120*D1*Ddd*f**2*g2*r - 30*D1*Ddd*f**2*g2*s + 30*D1*Ddd*f**2*g2 - D1*bd1*(21*D1*bd2*f*(2*r - 1)*(r + s - 1) - 35*K*b1**2*(D1*(3*r**2 + 3*r*(s - 1) - s + 1) + Dd*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 7*b1*(D1*(K*(f + 3*fd)*(2*r + s - 1) + 10*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 10*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) + 4*Dd*(-3*K*f*(2*r + s - 1) + 5*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + f*(D1*(-9*K*f*r*(r + s - 1) + 15*K*fd*(4*r**2 + 4*r*(s - 1) - s + 1) - 14*g2*(2*r + s - 1) + 42*gd2*(2*r + s - 1)) + 3*Dd*(5*K*f*(8*r**2 + 8*r*(s - 1) - s + 1) + 56*g2*(2*r + s - 1)))) + 420*Dd**2*K*b1**3*r**2 + 420*Dd**2*K*b1**3*r*s - 420*Dd**2*K*b1**3*r - 105*Dd**2*K*b1**3*s + 70*Dd**2*K*b1**3 - 180*Dd**2*K*b1*f**2*r**2 - 180*Dd**2*K*b1*f**2*r*s + 180*Dd**2*K*b1*f**2*r + 45*Dd**2*K*b1*f**2*s - 30*Dd**2*K*b1*f**2 - 840*Dd**2*b1**2*g2*r**2 - 840*Dd**2*b1**2*g2*r*s + 840*Dd**2*b1**2*g2*r + 210*Dd**2*b1**2*g2*s - 140*Dd**2*b1**2*g2 + 360*Dd**2*f**2*g2*r**2 + 360*Dd**2*f**2*g2*r*s - 360*Dd**2*f**2*g2*r - 90*Dd**2*f**2*g2*s + 60*Dd**2*f**2*g2 + b2*(7*D1**2*b1*fd*r**2 + 7*D1**2*b1*fd*r*s - 21*D1**2*b1*fdd*r**2 - 21*D1**2*b1*fdd*r*s - 21*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 18*D1**2*f*fd*r**2 + 18*D1**2*f*fd*r*s - 18*D1**2*f*fd*r - 9*D1**2*f*fd*s + 9*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 30*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r + 15*D1**2*f*fdd*s - 15*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 30*D1**2*fd**2*r*s + 30*D1**2*fd**2*r + 15*D1**2*fd**2*s + 28*D1*Dd*b1*f*r**2 + 28*D1*Dd*b1*f*r*s - 28*D1*Dd*b1*f*r - 7*D1*Dd*b1*f*s + 7*D1*Dd*b1*f - 168*D1*Dd*b1*fd*r**2 - 168*D1*Dd*b1*fd*r*s + 84*D1*Dd*b1*fd*r + 21*D1*Dd*b1*fd*s + 36*D1*Dd*f**2*r**2 + 36*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r - 9*D1*Dd*f**2*s + 9*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 240*D1*Dd*f*fd*r*s + 240*D1*Dd*f*fd*r + 90*D1*Dd*f*fd*s - 60*D1*Dd*f*fd - 84*D1*Ddd*b1*f*r**2 - 84*D1*Ddd*b1*f*r*s + 84*D1*Ddd*b1*f*r + 21*D1*Ddd*b1*f*s - 21*D1*Ddd*b1*f - 60*D1*Ddd*f**2*r**2 - 60*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r + 15*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 252*Dd**2*b1*f*r**2 - 252*Dd**2*b1*f*r*s + 252*Dd**2*b1*f*r + 63*Dd**2*b1*f*s - 42*Dd**2*b1*f - 180*Dd**2*f**2*r**2 - 180*Dd**2*f**2*r*s + 180*Dd**2*f**2*r + 45*Dd**2*f**2*s - 30*Dd**2*f**2))/(105*d**2*k3**3) + D1**2*Pkd1*Pkd3*k1*k2**4*st**4*(33*b1**2*(D1**2*r*(f*(fd - 4*fdd) - 4*fd**2)*(2*r + 2*s - 1) + D1*f*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) - 4*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1)) - 4*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 4*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*f*(-12*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) + 6*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s - 9*D1**2*f*fd*r - 5*D1**2*f*fd*s + 5*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*s - 4*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s + 8*D1**2*fd**2*s - 4*D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 2*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 10*D1*Dd*f*fd*s - 8*D1*Dd*f*fd + 8*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 8*D1*Ddd*f**2*r - 2*D1*Ddd*f**2*s + 2*D1*Ddd*f**2 + 3*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) - 4*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1)) - 4*Dd*f*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 24*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 24*Dd**2*f**2*r - 6*Dd**2*f**2*s + 4*Dd**2*f**2) + f**2*(-132*D1**2*bd1**2*(2*r - 1)*(r + s - 1) + 22*D1**2*bdd1*f*(r - 3)*(r + s - 1) - 3*D1**2*(f*(9*fd - 10*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 10*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*D1*bd1*(D1*(f*(2*r + 3)*(r + s - 1) + 2*fd*(6*r**2 + 6*r*(s - 2) - 7*s + 4)) + 2*Dd*f*(8*r**2 + 4*r*(2*s - 5) - 13*s + 10)) - 3*D1*f*(Dd*(9*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 20*fd*(4*r - 1)*(4*r + 4*s - 3)) - 10*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 30*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(1155*d**2*k3**5) - D1**2*Pkd1*Pkd3*k1*k2**2*st**4*(2*C - 1)*(2*D1**2*b1*f*fd*r**2 + 2*D1**2*b1*f*fd*r*s - D1**2*b1*f*fd*r + 6*D1**2*b1*f*fdd*r**2 + 6*D1**2*b1*f*fdd*r*s - 3*D1**2*b1*f*fdd*r + 6*D1**2*b1*fd**2*r**2 + 6*D1**2*b1*fd**2*r*s - 3*D1**2*b1*fd**2*r + 3*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 3*D1**2*f**2*fd*r**2 - 3*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r + D1**2*f**2*fd*s - D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 + 4*D1*Dd*b1*f**2*r**2 + 4*D1*Dd*b1*f**2*r*s - 4*D1*Dd*b1*f**2*r - D1*Dd*b1*f**2*s + D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 48*D1*Dd*b1*f*fd*r*s - 36*D1*Dd*b1*f*fd*r - 6*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 4*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r + D1*Dd*f**3*s - D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 24*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 5*D1*Dd*f**2*fd + 12*D1*Ddd*b1*f**2*r**2 + 12*D1*Ddd*b1*f**2*r*s - 12*D1*Ddd*b1*f**2*r - 3*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 4*D1*Ddd*f**3*r - D1*Ddd*f**3*s + D1*Ddd*f**3 + D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 36*Dd**2*b1*f**2*r**2 + 36*Dd**2*b1*f**2*r*s - 36*Dd**2*b1*f**2*r - 9*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 12*Dd**2*f**3*r - 3*Dd**2*f**3*s + 2*Dd**2*f**3)/(35*d**2*k3**3) + D1**2*Pkd1*Pkd3*k1*k2**2*st**2*(-126*D1**2*K*bd1**2*f*r**2 - 126*D1**2*K*bd1**2*f*r*s + 189*D1**2*K*bd1**2*f*r + 63*D1**2*K*bd1**2*f*s - 63*D1**2*K*bd1**2*f + 33*D1**2*K*bd1*f**2*r**2 + 33*D1**2*K*bd1*f**2*r*s - 33*D1**2*K*bd1*f**2*r - 108*D1**2*K*bd1*f*fd*r**2 - 108*D1**2*K*bd1*f*fd*r*s + 108*D1**2*K*bd1*f*fd*r + 27*D1**2*K*bd1*f*fd*s - 27*D1**2*K*bd1*f*fd - 27*D1**2*K*bdd1*f**2*r**2 - 27*D1**2*K*bdd1*f**2*r*s + 27*D1**2*K*bdd1*f**2*r + 36*D1**2*bd1**2*f**2*r**2 + 36*D1**2*bd1**2*f**2*r*s - 81*D1**2*bd1**2*f**2*r - 36*D1**2*bd1**2*f**2*s + 27*D1**2*bd1**2*f**2 - 126*D1**2*bd1*bd2*f*r**2 - 126*D1**2*bd1*bd2*f*r*s + 189*D1**2*bd1*bd2*f*r + 63*D1**2*bd1*bd2*f*s - 63*D1**2*bd1*bd2*f - 13*D1**2*bd1*f**3*r**2 - 13*D1**2*bd1*f**3*r*s + 12*D1**2*bd1*f**3*r + 120*D1**2*bd1*f**2*fd*r**2 + 120*D1**2*bd1*f**2*fd*r*s - 110*D1**2*bd1*f**2*fd*r - 20*D1**2*bd1*f**2*fd*s + 15*D1**2*bd1*f**2*fd - 42*D1**2*bd1*f*g2*r**2 - 42*D1**2*bd1*f*g2*r*s + 84*D1**2*bd1*f*g2*r + 42*D1**2*bd1*f*g2*s - 42*D1**2*bd1*f*g2 + 252*D1**2*bd1*f*gd2*r**2 + 252*D1**2*bd1*f*gd2*r*s - 378*D1**2*bd1*f*gd2*r - 126*D1**2*bd1*f*gd2*s + 126*D1**2*bd1*f*gd2 + 252*D1**2*bd1*fd*g2*r**2 + 252*D1**2*bd1*fd*g2*r*s - 252*D1**2*bd1*fd*g2*r - 126*D1**2*bd1*fd*g2*s + 33*D1**2*bd2*f**2*r**2 + 33*D1**2*bd2*f**2*r*s - 33*D1**2*bd2*f**2*r - 108*D1**2*bd2*f*fd*r**2 - 108*D1**2*bd2*f*fd*r*s + 108*D1**2*bd2*f*fd*r + 27*D1**2*bd2*f*fd*s - 27*D1**2*bd2*f*fd + 20*D1**2*bdd1*f**3*r**2 + 20*D1**2*bdd1*f**3*r*s - 15*D1**2*bdd1*f**3*r + 126*D1**2*bdd1*f*g2*r**2 + 126*D1**2*bdd1*f*g2*r*s - 252*D1**2*bdd1*f*g2*r - 126*D1**2*bdd1*f*g2*s + 126*D1**2*bdd1*f*g2 - 27*D1**2*bdd2*f**2*r**2 - 27*D1**2*bdd2*f**2*r*s + 27*D1**2*bdd2*f**2*r - 66*D1**2*f**2*gd2*r**2 - 66*D1**2*f**2*gd2*r*s + 66*D1**2*f**2*gd2*r + 54*D1**2*f**2*gdd2*r**2 + 54*D1**2*f**2*gdd2*r*s - 54*D1**2*f**2*gdd2*r - 132*D1**2*f*fd*g2*r**2 - 132*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r + 66*D1**2*f*fd*g2*s - 66*D1**2*f*fd*g2 + 216*D1**2*f*fd*gd2*r**2 + 216*D1**2*f*fd*gd2*r*s - 216*D1**2*f*fd*gd2*r - 54*D1**2*f*fd*gd2*s + 54*D1**2*f*fd*gd2 + 108*D1**2*f*fdd*g2*r**2 + 108*D1**2*f*fdd*g2*r*s - 108*D1**2*f*fdd*g2*r - 54*D1**2*f*fdd*g2*s + 54*D1**2*f*fdd*g2 + 108*D1**2*fd**2*g2*r**2 + 108*D1**2*fd**2*g2*r*s - 108*D1**2*fd**2*g2*r - 54*D1**2*fd**2*g2*s - 216*D1*Dd*K*bd1*f**2*r**2 - 216*D1*Dd*K*bd1*f**2*r*s + 216*D1*Dd*K*bd1*f**2*r + 27*D1*Dd*K*bd1*f**2*s - 27*D1*Dd*K*bd1*f**2 + 160*D1*Dd*bd1*f**3*r**2 + 160*D1*Dd*bd1*f**3*r*s - 140*D1*Dd*bd1*f**3*r - 20*D1*Dd*bd1*f**3*s + 15*D1*Dd*bd1*f**3 + 1008*D1*Dd*bd1*f*g2*r**2 + 1008*D1*Dd*bd1*f*g2*r*s - 1512*D1*Dd*bd1*f*g2*r - 630*D1*Dd*bd1*f*g2*s + 504*D1*Dd*bd1*f*g2 - 216*D1*Dd*bd2*f**2*r**2 - 216*D1*Dd*bd2*f**2*r*s + 216*D1*Dd*bd2*f**2*r + 27*D1*Dd*bd2*f**2*s - 27*D1*Dd*bd2*f**2 - 264*D1*Dd*f**2*g2*r**2 - 264*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r + 66*D1*Dd*f**2*g2*s - 66*D1*Dd*f**2*g2 + 432*D1*Dd*f**2*gd2*r**2 + 432*D1*Dd*f**2*gd2*r*s - 432*D1*Dd*f**2*gd2*r - 54*D1*Dd*f**2*gd2*s + 54*D1*Dd*f**2*gd2 + 864*D1*Dd*f*fd*g2*r**2 + 864*D1*Dd*f*fd*g2*r*s - 864*D1*Dd*f*fd*g2*r - 324*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 + 216*D1*Ddd*f**2*g2*r**2 + 216*D1*Ddd*f**2*g2*r*s - 216*D1*Ddd*f**2*g2*r - 54*D1*Ddd*f**2*g2*s + 54*D1*Ddd*f**2*g2 + 648*Dd**2*f**2*g2*r**2 + 648*Dd**2*f**2*g2*r*s - 648*Dd**2*f**2*g2*r - 162*Dd**2*f**2*g2*s + 108*Dd**2*f**2*g2 - 21*b1**3*(D1**2*r*(fd + 2*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) + 2*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + 2*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 2*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 3*b1**2*(-7*D1**2*K*fd*r**2 - 7*D1**2*K*fd*r*s + 21*D1**2*K*fdd*r**2 + 21*D1**2*K*fdd*r*s + 14*D1**2*bdd1*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 13*D1**2*f*fd*r + 5*D1**2*f*fd*s - 5*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r - 6*D1**2*f*fdd*s + 6*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s - 3*D1**2*fd**2*r - 6*D1**2*fd**2*s + 6*D1**2*fd**2 - 28*D1*Dd*K*f*r**2 - 28*D1*Dd*K*f*r*s + 28*D1*Dd*K*f*r + 7*D1*Dd*K*f*s - 7*D1*Dd*K*f + 168*D1*Dd*K*fd*r**2 + 168*D1*Dd*K*fd*r*s - 84*D1*Dd*K*fd*r - 21*D1*Dd*K*fd*s - 8*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r + 2*D1*Dd*f**2*s - 2*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 36*D1*Dd*f*fd*r - 12*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 84*D1*Ddd*K*f*r**2 + 84*D1*Ddd*K*f*r*s - 84*D1*Ddd*K*f*r - 21*D1*Ddd*K*f*s + 21*D1*Ddd*K*f - 24*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r + 6*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) + 2*fd*(6*r**2 + 6*r*(s - 1) - s + 1)) + 2*Dd*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 252*Dd**2*K*f*r**2 + 252*Dd**2*K*f*r*s - 252*Dd**2*K*f*r - 63*Dd**2*K*f*s + 42*Dd**2*K*f - 72*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 72*Dd**2*f**2*r + 18*Dd**2*f**2*s - 12*Dd**2*f**2) + b1*(-126*D1**2*K*bdd1*f*r**2 - 126*D1**2*K*bdd1*f*r*s + 189*D1**2*K*bdd1*f*r + 63*D1**2*K*bdd1*f*s - 63*D1**2*K*bdd1*f + 66*D1**2*K*f*fd*r**2 + 66*D1**2*K*f*fd*r*s - 66*D1**2*K*f*fd*r - 33*D1**2*K*f*fd*s + 33*D1**2*K*f*fd - 54*D1**2*K*f*fdd*r**2 - 54*D1**2*K*f*fdd*r*s + 54*D1**2*K*f*fdd*r + 27*D1**2*K*f*fdd*s - 27*D1**2*K*f*fdd - 54*D1**2*K*fd**2*r**2 - 54*D1**2*K*fd**2*r*s + 54*D1**2*K*fd**2*r + 27*D1**2*K*fd**2*s - 42*D1**2*bd1**2*f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 21*D1**2*bd2*f*r**2 + 21*D1**2*bd2*f*r*s - 21*D1**2*bd2*f*r - 126*D1**2*bd2*fd*r**2 - 126*D1**2*bd2*fd*r*s + 63*D1**2*bd2*fd*r + 36*D1**2*bdd1*f**2*r**2 + 36*D1**2*bdd1*f**2*r*s - 81*D1**2*bdd1*f**2*r - 36*D1**2*bdd1*f**2*s + 36*D1**2*bdd1*f**2 - 63*D1**2*bdd2*f*r**2 - 63*D1**2*bdd2*f*r*s + 63*D1**2*bdd2*f*r - 39*D1**2*f**2*fd*r**2 - 39*D1**2*f**2*fd*r*s + 40*D1**2*f**2*fd*r + 13*D1**2*f**2*fd*s - 13*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 60*D1**2*f**2*fdd*r*s - 65*D1**2*f**2*fdd*r - 20*D1**2*f**2*fdd*s + 20*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 120*D1**2*f*fd**2*r*s - 130*D1**2*f*fd**2*r - 40*D1**2*f*fd**2*s + 25*D1**2*f*fd**2 - 42*D1**2*f*gd2*r**2 - 42*D1**2*f*gd2*r*s + 42*D1**2*f*gd2*r + 126*D1**2*f*gdd2*r**2 + 126*D1**2*f*gdd2*r*s - 126*D1**2*f*gdd2*r - 42*D1**2*fd*g2*r**2 - 42*D1**2*fd*g2*r*s + 252*D1**2*fd*gd2*r**2 + 252*D1**2*fd*gd2*r*s - 126*D1**2*fd*gd2*r + 126*D1**2*fdd*g2*r**2 + 126*D1**2*fdd*g2*r*s + 132*D1*Dd*K*f**2*r**2 + 132*D1*Dd*K*f**2*r*s - 132*D1*Dd*K*f**2*r - 33*D1*Dd*K*f**2*s + 33*D1*Dd*K*f**2 - 432*D1*Dd*K*f*fd*r**2 - 432*D1*Dd*K*f*fd*r*s + 432*D1*Dd*K*f*fd*r + 162*D1*Dd*K*f*fd*s - 108*D1*Dd*K*f*fd - 504*D1*Dd*bd2*f*r**2 - 504*D1*Dd*bd2*f*r*s + 504*D1*Dd*bd2*f*r + 63*D1*Dd*bd2*f*s - 63*D1*Dd*bd2*f - 52*D1*Dd*f**3*r**2 - 52*D1*Dd*f**3*r*s + 52*D1*Dd*f**3*r + 13*D1*Dd*f**3*s - 13*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 480*D1*Dd*f**2*fd*r*s - 500*D1*Dd*f**2*fd*r - 140*D1*Dd*f**2*fd*s + 105*D1*Dd*f**2*fd - 168*D1*Dd*f*g2*r**2 - 168*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r + 42*D1*Dd*f*g2*s - 42*D1*Dd*f*g2 + 1008*D1*Dd*f*gd2*r**2 + 1008*D1*Dd*f*gd2*r*s - 1008*D1*Dd*f*gd2*r - 126*D1*Dd*f*gd2*s + 126*D1*Dd*f*gd2 + 1008*D1*Dd*fd*g2*r**2 + 1008*D1*Dd*fd*g2*r*s - 504*D1*Dd*fd*g2*r - 126*D1*Dd*fd*g2*s - 108*D1*Ddd*K*f**2*r**2 - 108*D1*Ddd*K*f**2*r*s + 108*D1*Ddd*K*f**2*r + 27*D1*Ddd*K*f**2*s - 27*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r**2 + 80*D1*Ddd*f**3*r*s - 80*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s + 20*D1*Ddd*f**3 + 504*D1*Ddd*f*g2*r**2 + 504*D1*Ddd*f*g2*r*s - 504*D1*Ddd*f*g2*r - 126*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(21*K*fd*(-4*r**2 + r*(3 - 4*s) + s) + f**2*(4*r**2 + 4*r*s + 5*r + 3*s - 3) + f*(7*K*(2*r - 1)*(r + s - 1) + 3*fd*(4*r - 1)*(4*r + 4*s - 3))) + 3*Dd*f*(-7*K*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + f*(32*r**2 + 4*r*(8*s - 13) - 20*s + 17))) - 324*Dd**2*K*f**2*r**2 - 324*Dd**2*K*f**2*r*s + 324*Dd**2*K*f**2*r + 81*Dd**2*K*f**2*s - 54*Dd**2*K*f**2 + 240*Dd**2*f**3*r**2 + 240*Dd**2*f**3*r*s - 240*Dd**2*f**3*r - 60*Dd**2*f**3*s + 40*Dd**2*f**3 + 1512*Dd**2*f*g2*r**2 + 1512*Dd**2*f*g2*r*s - 1512*Dd**2*f*g2*r - 378*Dd**2*f*g2*s + 252*Dd**2*f*g2 + 21*b2*(D1**2*r*(fd - 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) + 3*fd*(-8*r**2 + r*(4 - 8*s) + s)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2))) + 3*b2*(-21*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 22*D1**2*f*fd*r**2 + 22*D1**2*f*fd*r*s - 22*D1**2*f*fd*r - 11*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 18*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r + 9*D1**2*f*fdd*s - 9*D1**2*f*fdd - 18*D1**2*fd**2*r**2 - 18*D1**2*fd**2*r*s + 18*D1**2*fd**2*r + 9*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 44*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r - 11*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 144*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r + 54*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 36*D1*Ddd*f**2*r**2 - 36*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r + 9*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 108*Dd**2*f**2*r**2 - 108*Dd**2*f**2*r*s + 108*Dd**2*f**2*r + 27*Dd**2*f**2*s - 18*Dd**2*f**2))/(315*d**2*k3**3) - D1**2*Pkd1*Pkd3*k1*st**2*(2*C - 1)*(D1*f*(7*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + 3*D1*bdd1*f*r*(r + s) + bd1*(D1*(f*r*(r + s) + 3*fd*(4*r**2 + 4*r*s - 3*r - s)) + 3*Dd*f*(8*r**2 + r*(8*s - 4) - s))) + 7*b1**2*(D1**2*r*(3*fd + fdd)*(r + s - 1) + D1*(Dd*(3*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(7*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*D1**2*f*fd*r**2 + 2*D1**2*f*fd*r*s - 3*D1**2*f*fd*r - D1**2*f*fd*s + D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 9*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s - 9*D1**2*fd**2*r - 3*D1**2*fd**2*s + 3*D1**2*fd**2 + 4*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r - D1*Dd*f**2*s + D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 60*D1*Dd*f*fd*r - 18*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r - 3*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 7*D1*bd1*(D1*(f*(6*r**2 + 6*r*(s - 1) - 3*s + 3) + fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 36*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s - 36*Dd**2*f**2*r - 9*Dd**2*f**2*s + 6*Dd**2*f**2))/(105*d**2*k3) - D1**2*Pkd1*Pkd3*k1*(D1*(D1*bd1**2*(3*K*f*r*(2*r + 2*s - 1) - 10*g2*(2*r**2 + 2*r*(s - 1) - s)) - 6*D1*bdd1*f*g2*r*(r + s) + b2*(5*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + 3*D1*bdd1*f*r*(r + s) + bd1*(D1*(-f*r*(r + s) + fd*(6*r**2 + 6*r*(s - 1) - 3*s)) + 3*Dd*f*(8*r**2 + r*(8*s - 4) - s))) + bd1*(3*D1*bd2*f*r*(2*r + 2*s - 1) + 2*D1*(f*r*(g2*(r + s) + gd2*(-6*r - 6*s + 3)) + 3*fd*g2*(-2*r**2 - 2*r*(s - 1) + s)) - 6*Dd*f*g2*(8*r**2 + r*(8*s - 4) - s))) + 5*K*b1**3*(D1*(Dd + Ddd)*(4*r**2 + 4*r*(s - 1) - s + 1) + Dd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(15*D1**2*K*bd1*r**2 + 15*D1**2*K*bd1*r*s - 15*D1**2*K*bd1*r - 5*D1**2*K*bd1*s + 5*D1**2*K*bd1 + 15*D1**2*K*bdd1*r**2 + 15*D1**2*K*bdd1*r*s - 15*D1**2*K*bdd1*r - 5*D1**2*K*bdd1*s + 5*D1**2*K*bdd1 - D1**2*K*fd*r**2 - D1**2*K*fd*r*s + 2*D1**2*K*fd*r + D1**2*K*fd*s - D1**2*K*fd + 3*D1**2*K*fdd*r**2 + 3*D1**2*K*fdd*r*s - 6*D1**2*K*fdd*r - 3*D1**2*K*fdd*s + 3*D1**2*K*fdd + 5*D1**2*bdd2*r**2 + 5*D1**2*bdd2*r*s - 5*D1**2*bdd2*r - 10*D1**2*gd2*r**2 - 10*D1**2*gd2*r*s + 10*D1**2*gd2*r - 10*D1**2*gdd2*r**2 - 10*D1**2*gdd2*r*s + 10*D1**2*gdd2*r + 120*D1*Dd*K*bd1*r**2 + 120*D1*Dd*K*bd1*r*s - 120*D1*Dd*K*bd1*r - 35*D1*Dd*K*bd1*s + 25*D1*Dd*K*bd1 - 4*D1*Dd*K*f*r**2 - 4*D1*Dd*K*f*r*s + 4*D1*Dd*K*f*r + D1*Dd*K*f*s - D1*Dd*K*f + 24*D1*Dd*K*fd*r**2 + 24*D1*Dd*K*fd*r*s - 36*D1*Dd*K*fd*r - 15*D1*Dd*K*fd*s + 12*D1*Dd*K*fd - 40*D1*Dd*g2*r**2 - 40*D1*Dd*g2*r*s + 40*D1*Dd*g2*r + 10*D1*Dd*g2*s - 10*D1*Dd*g2 - 80*D1*Dd*gd2*r**2 - 80*D1*Dd*gd2*r*s + 80*D1*Dd*gd2*r + 10*D1*Dd*gd2*s - 10*D1*Dd*gd2 + 12*D1*Ddd*K*f*r**2 + 12*D1*Ddd*K*f*r*s - 12*D1*Ddd*K*f*r - 3*D1*Ddd*K*f*s + 3*D1*Ddd*K*f - 40*D1*Ddd*g2*r**2 - 40*D1*Ddd*g2*r*s + 40*D1*Ddd*g2*r + 10*D1*Ddd*g2*s - 10*D1*Ddd*g2 + 5*D1*bd2*(D1*r*(r + s - 1) + Dd*(8*r**2 + 8*r*(s - 1) - s + 1)) + 36*Dd**2*K*f*r**2 + 36*Dd**2*K*f*r*s - 36*Dd**2*K*f*r - 9*Dd**2*K*f*s + 6*Dd**2*K*f - 120*Dd**2*g2*r**2 - 120*Dd**2*g2*r*s + 120*Dd**2*g2*r + 30*Dd**2*g2*s - 20*Dd**2*g2 + 5*b2*(D1*(Dd + Ddd)*(4*r**2 + 4*r*(s - 1) - s + 1) + Dd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2))) + b1*(5*D1**2*K*bd1**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*D1**2*K*bdd1*f*r**2 + 6*D1**2*K*bdd1*f*r*s - 3*D1**2*K*bdd1*f*r - D1**2*bd2*f*r**2 - D1**2*bd2*f*r*s + D1**2*bd2*f*r + 6*D1**2*bd2*fd*r**2 + 6*D1**2*bd2*fd*r*s - 9*D1**2*bd2*fd*r - 3*D1**2*bd2*fd*s + 3*D1**2*bd2*fd - 20*D1**2*bdd1*g2*r**2 - 20*D1**2*bdd1*g2*r*s + 20*D1**2*bdd1*g2*r + 10*D1**2*bdd1*g2*s - 10*D1**2*bdd1*g2 + 3*D1**2*bdd2*f*r**2 + 3*D1**2*bdd2*f*r*s - 3*D1**2*bdd2*f*r + 2*D1**2*f*gd2*r**2 + 2*D1**2*f*gd2*r*s - 2*D1**2*f*gd2*r - 6*D1**2*f*gdd2*r**2 - 6*D1**2*f*gdd2*r*s + 6*D1**2*f*gdd2*r + 2*D1**2*fd*g2*r**2 + 2*D1**2*fd*g2*r*s - 4*D1**2*fd*g2*r - 2*D1**2*fd*g2*s + 2*D1**2*fd*g2 - 12*D1**2*fd*gd2*r**2 - 12*D1**2*fd*gd2*r*s + 18*D1**2*fd*gd2*r + 6*D1**2*fd*gd2*s - 6*D1**2*fd*gd2 - 6*D1**2*fdd*g2*r**2 - 6*D1**2*fdd*g2*r*s + 12*D1**2*fdd*g2*r + 6*D1**2*fdd*g2*s - 6*D1**2*fdd*g2 + 24*D1*Dd*bd2*f*r**2 + 24*D1*Dd*bd2*f*r*s - 24*D1*Dd*bd2*f*r - 3*D1*Dd*bd2*f*s + 3*D1*Dd*bd2*f + 8*D1*Dd*f*g2*r**2 + 8*D1*Dd*f*g2*r*s - 8*D1*Dd*f*g2*r - 2*D1*Dd*f*g2*s + 2*D1*Dd*f*g2 - 48*D1*Dd*f*gd2*r**2 - 48*D1*Dd*f*gd2*r*s + 48*D1*Dd*f*gd2*r + 6*D1*Dd*f*gd2*s - 6*D1*Dd*f*gd2 - 48*D1*Dd*fd*g2*r**2 - 48*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r + 30*D1*Dd*fd*g2*s - 24*D1*Dd*fd*g2 - 24*D1*Ddd*f*g2*r**2 - 24*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r + 6*D1*Ddd*f*g2*s - 6*D1*Ddd*f*g2 + D1*bd1*(5*D1*bd2*(4*r**2 + 4*r*(s - 1) - s + 1) + D1*(K*(f*r*(-2*r - 2*s + 1) + 3*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 10*g2*(2*r**2 + 2*r*(s - 1) - s + 1) - 10*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*(3*K*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) - 20*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 72*Dd**2*f*g2*r**2 - 72*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r + 18*Dd**2*f*g2*s - 12*Dd**2*f*g2 + b2*(5*D1**2*bdd1*(2*r**2 + 2*r*(s - 1) - s + 1) - D1**2*fd*r**2 - D1**2*fd*r*s + 2*D1**2*fd*r + D1**2*fd*s - D1**2*fd + 3*D1**2*fdd*r**2 + 3*D1**2*fdd*r*s - 6*D1**2*fdd*r - 3*D1**2*fdd*s + 3*D1**2*fdd - 4*D1*Dd*f*r**2 - 4*D1*Dd*f*r*s + 4*D1*Dd*f*r + D1*Dd*f*s - D1*Dd*f + 24*D1*Dd*fd*r**2 + 24*D1*Dd*fd*r*s - 36*D1*Dd*fd*r - 15*D1*Dd*fd*s + 12*D1*Dd*fd + 12*D1*Ddd*f*r**2 + 12*D1*Ddd*f*r*s - 12*D1*Ddd*f*r - 3*D1*Ddd*f*s + 3*D1*Ddd*f + 5*D1*bd1*(D1*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*Dd*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 36*Dd**2*f*r**2 + 36*Dd**2*f*r*s - 36*Dd**2*f*r - 9*Dd**2*f*s + 6*Dd**2*f)))/(15*d**2*k3) + D1**2*Pkd1*Pkd3*k2**4*st**4*(D1*f**2*(3*D1*bd1**2*(4*r**2 + r*(4*s - 5) - 2*s + 1) + D1*bdd1*f*r*(2*r + 2*s - 1) + bd1*(D1*(-2*f*r*(2*r + 2*s - 1) + fd*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1)) + Dd*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1))) - 3*b1**2*(D1**2*r*(4*r + 4*s - 3)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*(4*f*(4*r**2 + 4*r*(s - 1) - s + 1) - fd*(8*r - 1)*(4*r + 4*s - 3)) + 2*Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*f*(3*D1**2*bdd1*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) - 12*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s + 14*D1**2*f*fd*r + 4*D1**2*f*fd*s - 4*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 7*D1**2*f*fdd*r - 2*D1**2*f*fdd*s + 2*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 14*D1**2*fd**2*r - 4*D1**2*fd**2*s + 3*D1**2*fd**2 - 16*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 16*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 52*D1*Dd*f*fd*r - 14*D1*Dd*f*fd*s + 11*D1*Dd*f*fd + 8*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 8*D1*Ddd*f**2*r - 2*D1*Ddd*f**2*s + 2*D1*Ddd*f**2 - 3*D1*bd1*(2*D1*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - D1*fd*(4*r - 1)*(4*r + 4*s - 3) - Dd*f*(8*r - 3)*(4*r + 4*s - 3)) + 24*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 24*Dd**2*f**2*r - 6*Dd**2*f**2*s + 4*Dd**2*f**2))/(105*d**2*k1*k3**3) + D1**2*Pkd1*Pkd3*k2**2*st**2*(3*D1**2*bd1**2*f**2*r*(2*r + 2*s - 1) + D1*b1*f*(7*D1*bd1**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 3*D1*bdd1*f*r*(2*r + 2*s - 1) + 3*bd1*(D1*(-2*f*r*(2*r + 2*s - 1) + fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1)) + Dd*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1))) - 7*b1**3*(D1**2*r*(2*fd - fdd)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-8*r**2 - 8*r*(s - 1) + s - 1)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + b1**2*(7*D1**2*bdd1*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*D1**2*(2*r - 1)*(r + s - 1)*(2*f*fd - f*fdd - fd**2) - 7*D1*bd1*(D1*(f*(6*r**2 + 6*r*(s - 1) - 2*s + 2) + fd*(-6*r**2 - 6*r*(s - 1) + s - 1)) + Dd*f*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) - 3*D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-16*r**2 - 4*r*(4*s - 5) + 6*s - 5)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 3*Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)))/(105*d**2*k1*k3)
        perm23 = 4*D1**3*Pk2*Pk3*b1*k2**4*(D1*bd1*(3*K*b1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + b1*(D1*(fd*(2*C - 1) - 6*gd2)*(r + s - 1)**2 + Dd*(3*K*b1 + f*(2*C - 1) - 6*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(3*d**2*k3**6) + 4*D1**3*Pk2*Pk3*ct**2*k2**6*(D1*b1*(f*fd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(6*C*f + 10*K*b1 - 3*f - 10*g2) + Dd*b1*f*(6*C*f + 5*K*b1 - 3*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(5*d**2*k3**8) + 8*D1**3*Pk2*Pk3*ct*k1*k2**5*(D1*b1*(f*fd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(6*C*f + 10*K*b1 - 3*f - 10*g2) + Dd*b1*f*(6*C*f + 5*K*b1 - 3*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(5*d**2*k3**8) - 12*D1**3*Pk2*Pk3*f**2*k1**4*k2**2*st**4*(2*D1*bd1*f*(r + s - 1)**2 + 2*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(35*d**2*k3**8) + 4*D1**3*Pk2*Pk3*k1**2*k2**4*(D1*b1*(f*fd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(6*C*f + 10*K*b1 - 3*f - 10*g2) + Dd*b1*f*(6*C*f + 5*K*b1 - 3*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(5*d**2*k3**8) + 4*D1**3*Pk2*Pk3*k2**6*st**2*(D1*b1*(f*fd*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(2*C*f + 10*K*b1 - f - 10*g2) + Dd*b1*f*(2*C*f + 5*K*b1 - f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(5*d**2*k3**8) - 5*D1**3*Pk2*Pkd3*b1*k2**4*(D1*bd1*(3*K*b1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + b1*(D1*(fd*(2*C - 1) - 6*gd2)*(r + s - 1)**2 + Dd*(3*K*b1 + f*(2*C - 1) - 6*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(6*d**2*k3**5) + D1**3*Pk2*Pkd3*ct**3*k2**3*(8*C - 4)*(D1*b1*(2*f*fd*r - f*fdd*r - fd**2*(r - 1)) + D1*bdd1*f**2*r + 2*Dd*b1*f*fd*(1 - 2*r) + bd1*f*(-2*D1*f*r + D1*fd*(r - 1) + 2*Dd*f*(2*r - 1)))/(35*d**2*k1*k3**3) - 3*D1**3*Pk2*Pkd3*ct**2*k2**6*(D1*b1*(f*fd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(6*C*f + 10*K*b1 - 3*f - 10*g2) + Dd*b1*f*(6*C*f + 5*K*b1 - 3*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(10*d**2*k3**7) - 3*D1**3*Pk2*Pkd3*ct*k1*k2**5*(D1*b1*(f*fd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(6*C*f + 10*K*b1 - 3*f - 10*g2) + Dd*b1*f*(6*C*f + 5*K*b1 - 3*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(5*d**2*k3**7) + D1**3*Pk2*Pkd3*ct*k2**3*st**2*(8*C - 4)*(D1*b1*(5*f*fd*r - 6*f*fdd*r - 6*fd**2*(r - 1)) + 6*D1*bdd1*f**2*r + 12*Dd*b1*f*fd*(1 - 2*r) + bd1*f*(-5*D1*f*r + 6*D1*fd*(r - 1) + 12*Dd*f*(2*r - 1)))/(105*d**2*k1*k3**3) + 9*D1**3*Pk2*Pkd3*f**2*k1**4*k2**2*st**4*(2*D1*bd1*f*(r + s - 1)**2 + 2*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(70*d**2*k3**7) - 3*D1**3*Pk2*Pkd3*k1**2*k2**4*(D1*b1*(f*fd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(6*C*f + 10*K*b1 - 3*f - 10*g2) + Dd*b1*f*(6*C*f + 5*K*b1 - 3*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(10*d**2*k3**7) - 3*D1**3*Pk2*Pkd3*k2**6*st**2*(D1*b1*(f*fd*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(2*C*f + 10*K*b1 - f - 10*g2) + Dd*b1*f*(2*C*f + 5*K*b1 - f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(10*d**2*k3**7) + D1**3*Pk2*Pkdd3*b1*k2**4*(D1*bd1*(3*K*b1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + b1*(D1*(fd*(2*C - 1) - 6*gd2)*(r + s - 1)**2 + Dd*(3*K*b1 + f*(2*C - 1) - 6*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(6*d**2*k3**4) + D1**3*Pk2*Pkdd3*b1*k2**2*(-D1*bd1*(f*(2*C - 1) - 6*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 3*Dd*K*b1**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + b1*(-3*D1*bd2*(r + s - 1)**2 + D1*(-3*K*bd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fd*(2*C - 1)*(r + s - 1)**2 + 6*gd2*(r + s - 1)**2) - Dd*(f*(2*C - 1) - 6*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 3*b2*(D1*bd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*b1*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(6*d**2*k3**2) + D1**3*Pk2*Pkdd3*ct**2*k2**6*(D1*b1*(f*fd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(6*C*f + 10*K*b1 - 3*f - 10*g2) + Dd*b1*f*(6*C*f + 5*K*b1 - 3*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(30*d**2*k3**6) + D1**3*Pk2*Pkdd3*ct*k1*k2**5*(D1*b1*(f*fd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(6*C*f + 10*K*b1 - 3*f - 10*g2) + Dd*b1*f*(6*C*f + 5*K*b1 - 3*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(15*d**2*k3**6) - D1**3*Pk2*Pkdd3*f**2*k1**4*k2**2*st**4*(2*D1*bd1*f*(r + s - 1)**2 + 2*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(70*d**2*k3**6) + D1**3*Pk2*Pkdd3*k1**2*k2**4*(D1*b1*(f*fd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(6*C*f + 10*K*b1 - 3*f - 10*g2) + Dd*b1*f*(6*C*f + 5*K*b1 - 3*f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(30*d**2*k3**6) + D1**3*Pk2*Pkdd3*k2**6*st**2*(D1*b1*(f*fd*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*gd2*(r + s - 1)**2 - 5*fd*(r + s)**2*(-K*b1 + 2*g2)) + D1*bd1*f*(r + s - 1)**2*(2*C*f + 10*K*b1 - f - 10*g2) + Dd*b1*f*(2*C*f + 5*K*b1 - f - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(30*d**2*k3**6) + 4*D1**3*Pk3*Pkd2*b1*f*k1**4*k2*(D1*b1*fd*s*(2*r + 2*s - 1) + D1*bd1*f*(2*s - 1)*(r + s - 1) + Dd*b1*f*(r*(4*s - 1) + (1 - 2*s)**2))/(5*d**2*k3**6) - 2*D1**3*Pk3*Pkd2*b1*k2**3*(D1*b1*s*(fd*(2*C - 1) - 6*gd2)*(r + s - 1) + D1*bd1*f*(2*C - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*D1*bd1*(K*b1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + g2*(r*(2 - 4*s) - 4*s**2 + 4*s - 2)) + Dd*b1*(r*(4*s - 1) + (1 - 2*s)**2)*(3*K*b1 + f*(2*C - 1) - 6*g2))/(3*d**2*k3**4) + D1**3*Pk3*Pkd2*ct**3*k2**2*(8*C - 4)*(D1*b1*(2*f*fd*r - f*fdd*r - fd**2*(r - 1)) + D1*bdd1*f**2*r + 2*Dd*b1*f*fd*(1 - 2*r) + bd1*f*(-2*D1*f*r + D1*fd*(r - 1) + 2*Dd*f*(2*r - 1)))/(35*d**2*k1*k3**2) - 4*D1**3*Pk3*Pkd2*ct**2*k2**5*(D1*bd1*f*(r + s - 1)*(5*K*b1*(2*s - 1) + f*(6*C - 3)*(s - 1) - 10*g2*(s - 1)) + b1*(D1*s*(f*fd*(6*C - 3)*(2*r + 2*s - 1) - 10*f*gd2*(r + s - 1) - 5*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(6*C*f + 5*K*b1 - 3*f - 10*g2)))/(15*d**2*k3**6) - 8*D1**3*Pk3*Pkd2*ct*k1*k2**4*(D1*bd1*f*(r + s - 1)*(5*K*b1*(2*s - 1) + f*(6*C - 3)*(s - 1) - 10*g2*(s - 1)) + b1*(D1*s*(f*fd*(6*C - 3)*(2*r + 2*s - 1) - 10*f*gd2*(r + s - 1) - 5*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(6*C*f + 5*K*b1 - 3*f - 10*g2)))/(15*d**2*k3**6) + D1**3*Pk3*Pkd2*ct*k2**2*st**2*(8*C - 4)*(D1*b1*(5*f*fd*r - 6*f*fdd*r - 6*fd**2*(r - 1)) + 6*D1*bdd1*f**2*r + 12*Dd*b1*f*fd*(1 - 2*r) + bd1*f*(-5*D1*f*r + 6*D1*fd*(r - 1) + 12*Dd*f*(2*r - 1)))/(105*d**2*k1*k3**2) - 4*D1**3*Pk3*Pkd2*k1**2*k2**3*(D1*bd1*f*(r + s - 1)*(5*K*b1*(2*s - 1) + f*(6*C - 3)*(s - 1) - 10*g2*(s - 1)) + b1*(D1*s*(f*fd*(6*C - 3)*(2*r + 2*s - 1) - 10*f*gd2*(r + s - 1) - 5*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(6*C*f + 5*K*b1 - 3*f - 10*g2)))/(15*d**2*k3**6) - 4*D1**3*Pk3*Pkd2*k2**5*st**2*(D1*bd1*f*(r + s - 1)*(5*K*b1*(2*s - 1) + f*(2*C - 1)*(s - 1) - 10*g2*(s - 1)) + b1*(D1*s*(f*fd*(2*C - 1)*(2*r + 2*s - 1) - 10*f*gd2*(r + s - 1) - 5*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(2*C*f + 5*K*b1 - f - 10*g2)))/(15*d**2*k3**6) - D1**3*Pkd2*Pkd3*b1*f*k1**4*k2*(D1*b1*fd*s*(2*r + 2*s - 1) + D1*bd1*f*(2*s - 1)*(r + s - 1) + Dd*b1*f*(r*(4*s - 1) + (1 - 2*s)**2))/(5*d**2*k3**5) + D1**3*Pkd2*Pkd3*b1*k2**3*(D1*b1*s*(fd*(2*C - 1) - 6*gd2)*(r + s - 1) + D1*bd1*f*(2*C - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*D1*bd1*(K*b1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + g2*(r*(2 - 4*s) - 4*s**2 + 4*s - 2)) + Dd*b1*(r*(4*s - 1) + (1 - 2*s)**2)*(3*K*b1 + f*(2*C - 1) - 6*g2))/(3*d**2*k3**3) + D1**3*Pkd2*Pkd3*b1*k2*(-D1*b1*s*(3*bd2 + fd*(2*C - 1) - 6*gd2)*(r + s - 1) - D1*bd1*f*(2*C - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*D1*bd1*(K*b1*(-3*r*s + r - 3*s**2 + 3*s - 1) + g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2)) - Dd*b1*(r*(4*s - 1) + (1 - 2*s)**2)*(3*K*b1 + f*(2*C - 1) - 6*g2) - 3*b2*(D1*bd1*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*b1*(r*(4*s - 1) + (1 - 2*s)**2)))/(3*d**2*k3) + D1**3*Pkd2*Pkd3*ct**2*k2**5*(D1*bd1*f*(r + s - 1)*(5*K*b1*(2*s - 1) + f*(6*C - 3)*(s - 1) - 10*g2*(s - 1)) + b1*(D1*s*(f*fd*(6*C - 3)*(2*r + 2*s - 1) - 10*f*gd2*(r + s - 1) - 5*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(6*C*f + 5*K*b1 - 3*f - 10*g2)))/(15*d**2*k3**5) + 2*D1**3*Pkd2*Pkd3*ct*k1*k2**4*(D1*bd1*f*(r + s - 1)*(5*K*b1*(2*s - 1) + f*(6*C - 3)*(s - 1) - 10*g2*(s - 1)) + b1*(D1*s*(f*fd*(6*C - 3)*(2*r + 2*s - 1) - 10*f*gd2*(r + s - 1) - 5*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(6*C*f + 5*K*b1 - 3*f - 10*g2)))/(15*d**2*k3**5) + D1**3*Pkd2*Pkd3*k1**2*k2**3*(D1*bd1*f*(r + s - 1)*(5*K*b1*(2*s - 1) + f*(6*C - 3)*(s - 1) - 10*g2*(s - 1)) + b1*(D1*s*(f*fd*(6*C - 3)*(2*r + 2*s - 1) - 10*f*gd2*(r + s - 1) - 5*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(6*C*f + 5*K*b1 - 3*f - 10*g2)))/(15*d**2*k3**5) - D1**3*Pkd2*Pkd3*k1**2*k2*(D1*bd1*f*(s - 1)*(5*b2 + f*(6*C - 3) - 10*g2)*(r + s - 1) + 5*b1**3*(D1*fd*s*(r + s - 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 5*b1**2*(D1*bd1*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + K*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + b1*(D1*(5*K*bd1*f*(2*s - 1)*(r + s - 1) + s*(5*bd2*f*(r + s - 1) + f*fd*(6*C - 3)*(2*r + 2*s - 1) - 10*f*gd2*(r + s - 1) - 10*fd*g2*(r + s))) + Dd*f*(f*(6*C - 3) - 10*g2)*(r*(4*s - 1) + (1 - 2*s)**2) + 5*b2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))))/(15*d**2*k3**3) + D1**3*Pkd2*Pkd3*k2**5*st**2*(D1*bd1*f*(r + s - 1)*(5*K*b1*(2*s - 1) + f*(2*C - 1)*(s - 1) - 10*g2*(s - 1)) + b1*(D1*s*(f*fd*(2*C - 1)*(2*r + 2*s - 1) - 10*f*gd2*(r + s - 1) - 5*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(2*C*f + 5*K*b1 - f - 10*g2)))/(15*d**2*k3**5) - 4*D1**2*Pk2*Pk3*ct**8*k1**2*k2**4*(924*C*D1**2*f**2*fd*r**2 + 1848*C*D1**2*f**2*fd*r*s - 1232*C*D1**2*f**2*fd*r + 924*C*D1**2*f**2*fd*s**2 - 1232*C*D1**2*f**2*fd*s + 616*C*D1**2*f**2*fd - 462*C*D1**2*f**2*fdd*r**2 - 924*C*D1**2*f**2*fdd*r*s + 616*C*D1**2*f**2*fdd*r - 462*C*D1**2*f**2*fdd*s**2 + 616*C*D1**2*f**2*fdd*s - 308*C*D1**2*f**2*fdd - 924*C*D1**2*f*fd**2*r**2 - 1848*C*D1**2*f*fd**2*r*s + 1232*C*D1**2*f*fd**2*r - 924*C*D1**2*f*fd**2*s**2 + 1232*C*D1**2*f*fd**2*s - 308*C*D1**2*f*fd**2 + 1232*C*D1*Dd*f**3*r**2 + 2464*C*D1*Dd*f**3*r*s - 1848*C*D1*Dd*f**3*r + 1232*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 924*C*D1*Dd*f**3 - 3696*C*D1*Dd*f**2*fd*r**2 - 7392*C*D1*Dd*f**2*fd*r*s + 5236*C*D1*Dd*f**2*fd*r - 3696*C*D1*Dd*f**2*fd*s**2 + 5236*C*D1*Dd*f**2*fd*s - 1848*C*D1*Dd*f**2*fd - 616*C*D1*Ddd*f**3*r**2 - 1232*C*D1*Ddd*f**3*r*s + 924*C*D1*Ddd*f**3*r - 616*C*D1*Ddd*f**3*s**2 + 924*C*D1*Ddd*f**3*s - 462*C*D1*Ddd*f**3 - 1848*C*Dd**2*f**3*r**2 - 3696*C*Dd**2*f**3*r*s + 2772*C*Dd**2*f**3*r - 1848*C*Dd**2*f**3*s**2 + 2772*C*Dd**2*f**3*s - 924*C*Dd**2*f**3 + 396*D1**2*K*b1*f*fd*r**2 + 792*D1**2*K*b1*f*fd*r*s - 396*D1**2*K*b1*f*fd*r + 396*D1**2*K*b1*f*fd*s**2 - 396*D1**2*K*b1*f*fd*s + 198*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 396*D1**2*K*b1*f*fdd*r*s + 198*D1**2*K*b1*f*fdd*r - 198*D1**2*K*b1*f*fdd*s**2 + 198*D1**2*K*b1*f*fdd*s - 99*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 396*D1**2*K*b1*fd**2*r*s + 198*D1**2*K*b1*fd**2*r - 198*D1**2*K*b1*fd**2*s**2 + 198*D1**2*K*b1*fd**2*s - 396*D1**2*b1*f*fd*r**2 - 792*D1**2*b1*f*fd*r*s + 396*D1**2*b1*f*fd*r - 396*D1**2*b1*f*fd*s**2 + 396*D1**2*b1*f*fd*s - 198*D1**2*b1*f*fd + 198*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 198*D1**2*b1*f*fdd*s**2 - 198*D1**2*b1*f*fdd*s + 99*D1**2*b1*f*fdd + 198*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 198*D1**2*b1*fd**2*s**2 - 198*D1**2*b1*fd**2*s - 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 504*D1**2*f**3*fd*r**2 + 1008*D1**2*f**3*fd*r*s - 756*D1**2*f**3*fd*r + 504*D1**2*f**3*fd*s**2 - 756*D1**2*f**3*fd*s + 378*D1**2*f**3*fd - 252*D1**2*f**3*fdd*r**2 - 504*D1**2*f**3*fdd*r*s + 378*D1**2*f**3*fdd*r - 252*D1**2*f**3*fdd*s**2 + 378*D1**2*f**3*fdd*s - 189*D1**2*f**3*fdd - 756*D1**2*f**2*fd**2*r**2 - 1512*D1**2*f**2*fd**2*r*s + 1134*D1**2*f**2*fd**2*r - 756*D1**2*f**2*fd**2*s**2 + 1134*D1**2*f**2*fd**2*s - 378*D1**2*f**2*fd**2 - 924*D1**2*f**2*fd*r**2 - 1848*D1**2*f**2*fd*r*s + 1232*D1**2*f**2*fd*r - 924*D1**2*f**2*fd*s**2 + 1232*D1**2*f**2*fd*s - 616*D1**2*f**2*fd + 462*D1**2*f**2*fdd*r**2 + 924*D1**2*f**2*fdd*r*s - 616*D1**2*f**2*fdd*r + 462*D1**2*f**2*fdd*s**2 - 616*D1**2*f**2*fdd*s + 308*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 396*D1**2*f**2*gd2*s**2 + 792*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 396*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 924*D1**2*f*fd**2*r**2 + 1848*D1**2*f*fd**2*r*s - 1232*D1**2*f*fd**2*r + 924*D1**2*f*fd**2*s**2 - 1232*D1**2*f*fd**2*s + 308*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 792*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1584*D1**2*f*fd*gd2*r*s - 1188*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1188*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 792*D1*Dd*K*b1*f**2*r**2 + 1584*D1*Dd*K*b1*f**2*r*s - 1188*D1*Dd*K*b1*f**2*r + 792*D1*Dd*K*b1*f**2*s**2 - 1188*D1*Dd*K*b1*f**2*s + 594*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 3168*D1*Dd*K*b1*f*fd*r*s + 1980*D1*Dd*K*b1*f*fd*r - 1584*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 594*D1*Dd*K*b1*f*fd - 792*D1*Dd*b1*f**2*r**2 - 1584*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 792*D1*Dd*b1*f**2*s**2 + 1188*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r + 1584*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s + 594*D1*Dd*b1*f*fd + 504*D1*Dd*f**4*r**2 + 1008*D1*Dd*f**4*r*s - 756*D1*Dd*f**4*r + 504*D1*Dd*f**4*s**2 - 756*D1*Dd*f**4*s + 378*D1*Dd*f**4 - 2016*D1*Dd*f**3*fd*r**2 - 4032*D1*Dd*f**3*fd*r*s + 3024*D1*Dd*f**3*fd*r - 2016*D1*Dd*f**3*fd*s**2 + 3024*D1*Dd*f**3*fd*s - 1134*D1*Dd*f**3*fd - 1232*D1*Dd*f**3*r**2 - 2464*D1*Dd*f**3*r*s + 1848*D1*Dd*f**3*r - 1232*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 924*D1*Dd*f**3 + 3696*D1*Dd*f**2*fd*r**2 + 7392*D1*Dd*f**2*fd*r*s - 5236*D1*Dd*f**2*fd*r + 3696*D1*Dd*f**2*fd*s**2 - 5236*D1*Dd*f**2*fd*s + 1848*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 2376*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 3168*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 1188*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 6336*D1*Dd*f*fd*g2*r*s - 3960*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 1188*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 792*D1*Ddd*K*b1*f**2*r*s + 594*D1*Ddd*K*b1*f**2*r - 396*D1*Ddd*K*b1*f**2*s**2 + 594*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 396*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 396*D1*Ddd*b1*f**2*s**2 - 594*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 - 252*D1*Ddd*f**4*r**2 - 504*D1*Ddd*f**4*r*s + 378*D1*Ddd*f**4*r - 252*D1*Ddd*f**4*s**2 + 378*D1*Ddd*f**4*s - 189*D1*Ddd*f**4 + 616*D1*Ddd*f**3*r**2 + 1232*D1*Ddd*f**3*r*s - 924*D1*Ddd*f**3*r + 616*D1*Ddd*f**3*s**2 - 924*D1*Ddd*f**3*s + 462*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1584*D1*Ddd*f**2*g2*r*s - 1188*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1188*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1188*Dd**2*K*b1*f**2*r**2 - 2376*Dd**2*K*b1*f**2*r*s + 1782*Dd**2*K*b1*f**2*r - 1188*Dd**2*K*b1*f**2*s**2 + 1782*Dd**2*K*b1*f**2*s - 594*Dd**2*K*b1*f**2 + 1188*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 1188*Dd**2*b1*f**2*s**2 - 1782*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 - 756*Dd**2*f**4*r**2 - 1512*Dd**2*f**4*r*s + 1134*Dd**2*f**4*r - 756*Dd**2*f**4*s**2 + 1134*Dd**2*f**4*s - 378*Dd**2*f**4 + 1848*Dd**2*f**3*r**2 + 3696*Dd**2*f**3*r*s - 2772*Dd**2*f**3*r + 1848*Dd**2*f**3*s**2 - 2772*Dd**2*f**3*s + 924*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 4752*Dd**2*f**2*g2*r*s - 3564*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3564*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2)/(231*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**8*k1**2*k2**2*(924*C*D1**2*f**2*fd*r*s - 308*C*D1**2*f**2*fd*r + 924*C*D1**2*f**2*fd*s**2 - 924*C*D1**2*f**2*fd*s + 308*C*D1**2*f**2*fd - 462*C*D1**2*f**2*fdd*r*s + 154*C*D1**2*f**2*fdd*r - 462*C*D1**2*f**2*fdd*s**2 + 462*C*D1**2*f**2*fdd*s - 154*C*D1**2*f**2*fdd - 924*C*D1**2*f*fd**2*r*s + 308*C*D1**2*f*fd**2*r - 924*C*D1**2*f*fd**2*s**2 + 924*C*D1**2*f*fd**2*s - 154*C*D1**2*f*fd**2 + 1232*C*D1*Dd*f**3*r*s - 308*C*D1*Dd*f**3*r + 1232*C*D1*Dd*f**3*s**2 - 1232*C*D1*Dd*f**3*s + 308*C*D1*Dd*f**3 - 3696*C*D1*Dd*f**2*fd*r*s + 1078*C*D1*Dd*f**2*fd*r - 3696*C*D1*Dd*f**2*fd*s**2 + 3696*C*D1*Dd*f**2*fd*s - 770*C*D1*Dd*f**2*fd - 616*C*D1*Ddd*f**3*r*s + 154*C*D1*Ddd*f**3*r - 616*C*D1*Ddd*f**3*s**2 + 616*C*D1*Ddd*f**3*s - 154*C*D1*Ddd*f**3 - 1848*C*Dd**2*f**3*r*s + 462*C*Dd**2*f**3*r - 1848*C*Dd**2*f**3*s**2 + 1848*C*Dd**2*f**3*s - 308*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 504*D1**2*f**3*fd*r*s - 126*D1**2*f**3*fd*r + 504*D1**2*f**3*fd*s**2 - 504*D1**2*f**3*fd*s + 126*D1**2*f**3*fd - 252*D1**2*f**3*fdd*r*s + 63*D1**2*f**3*fdd*r - 252*D1**2*f**3*fdd*s**2 + 252*D1**2*f**3*fdd*s - 63*D1**2*f**3*fdd - 756*D1**2*f**2*fd**2*r*s + 189*D1**2*f**2*fd**2*r - 756*D1**2*f**2*fd**2*s**2 + 756*D1**2*f**2*fd**2*s - 126*D1**2*f**2*fd**2 - 924*D1**2*f**2*fd*r*s + 308*D1**2*f**2*fd*r - 924*D1**2*f**2*fd*s**2 + 924*D1**2*f**2*fd*s - 308*D1**2*f**2*fd + 462*D1**2*f**2*fdd*r*s - 154*D1**2*f**2*fdd*r + 462*D1**2*f**2*fdd*s**2 - 462*D1**2*f**2*fdd*s + 154*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 924*D1**2*f*fd**2*r*s - 308*D1**2*f*fd**2*r + 924*D1**2*f*fd**2*s**2 - 924*D1**2*f*fd**2*s + 154*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 504*D1*Dd*f**4*r*s - 126*D1*Dd*f**4*r + 504*D1*Dd*f**4*s**2 - 504*D1*Dd*f**4*s + 126*D1*Dd*f**4 - 2016*D1*Dd*f**3*fd*r*s + 504*D1*Dd*f**3*fd*r - 2016*D1*Dd*f**3*fd*s**2 + 2016*D1*Dd*f**3*fd*s - 378*D1*Dd*f**3*fd - 1232*D1*Dd*f**3*r*s + 308*D1*Dd*f**3*r - 1232*D1*Dd*f**3*s**2 + 1232*D1*Dd*f**3*s - 308*D1*Dd*f**3 + 3696*D1*Dd*f**2*fd*r*s - 1078*D1*Dd*f**2*fd*r + 3696*D1*Dd*f**2*fd*s**2 - 3696*D1*Dd*f**2*fd*s + 770*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 252*D1*Ddd*f**4*r*s + 63*D1*Ddd*f**4*r - 252*D1*Ddd*f**4*s**2 + 252*D1*Ddd*f**4*s - 63*D1*Ddd*f**4 + 616*D1*Ddd*f**3*r*s - 154*D1*Ddd*f**3*r + 616*D1*Ddd*f**3*s**2 - 616*D1*Ddd*f**3*s + 154*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 756*Dd**2*f**4*r*s + 189*Dd**2*f**4*r - 756*Dd**2*f**4*s**2 + 756*Dd**2*f**4*s - 126*Dd**2*f**4 + 1848*Dd**2*f**3*r*s - 462*Dd**2*f**3*r + 1848*Dd**2*f**3*s**2 - 1848*Dd**2*f**3*s + 308*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**8*k1**2*(D1**2*(63*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-378*fd**2*s*(2*s - 1) + fd*(308*C - 308)*(3*s**2 - 2*s + 1) - fdd*(154*C - 154)*(3*s**2 - 2*s + 1) + s**2*(-99*K*bdd1 + 198*bd1*(K - 1) + 99*bdd1 - 396*gd2 + 198*gdd2)) - 22*f*(fd**2*s*(14*C - 14)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 396*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(63*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(22*C*(4*s**2 - 2*s + 1) - 9*fd*(1 - 4*s)**2 - 88*s**2 + 44*s - 22) - 11*f*(fd*(14*C - 14)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(63*f**2 + f*(154*C - 154) - 198*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(63*f**2 + f*(154*C - 154) - 198*g2) + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k3**4) - 4*D1**2*Pk2*Pk3*ct**7*k1**3*k2**3*(12540*C*D1**2*f**2*fd*r**2 + 25080*C*D1**2*f**2*fd*r*s - 16720*C*D1**2*f**2*fd*r + 12540*C*D1**2*f**2*fd*s**2 - 16720*C*D1**2*f**2*fd*s + 8360*C*D1**2*f**2*fd - 9240*C*D1**2*f**2*fdd*r**2 - 18480*C*D1**2*f**2*fdd*r*s + 12320*C*D1**2*f**2*fdd*r - 9240*C*D1**2*f**2*fdd*s**2 + 12320*C*D1**2*f**2*fdd*s - 6160*C*D1**2*f**2*fdd - 18480*C*D1**2*f*fd**2*r**2 - 36960*C*D1**2*f*fd**2*r*s + 24640*C*D1**2*f*fd**2*r - 18480*C*D1**2*f*fd**2*s**2 + 24640*C*D1**2*f*fd**2*s - 6160*C*D1**2*f*fd**2 + 16720*C*D1*Dd*f**3*r**2 + 33440*C*D1*Dd*f**3*r*s - 25080*C*D1*Dd*f**3*r + 16720*C*D1*Dd*f**3*s**2 - 25080*C*D1*Dd*f**3*s + 12540*C*D1*Dd*f**3 - 73920*C*D1*Dd*f**2*fd*r**2 - 147840*C*D1*Dd*f**2*fd*r*s + 104720*C*D1*Dd*f**2*fd*r - 73920*C*D1*Dd*f**2*fd*s**2 + 104720*C*D1*Dd*f**2*fd*s - 36960*C*D1*Dd*f**2*fd - 12320*C*D1*Ddd*f**3*r**2 - 24640*C*D1*Ddd*f**3*r*s + 18480*C*D1*Ddd*f**3*r - 12320*C*D1*Ddd*f**3*s**2 + 18480*C*D1*Ddd*f**3*s - 9240*C*D1*Ddd*f**3 - 36960*C*Dd**2*f**3*r**2 - 73920*C*Dd**2*f**3*r*s + 55440*C*Dd**2*f**3*r - 36960*C*Dd**2*f**3*s**2 + 55440*C*Dd**2*f**3*s - 18480*C*Dd**2*f**3 + 5148*D1**2*K*b1*f*fd*r**2 + 10296*D1**2*K*b1*f*fd*r*s - 5148*D1**2*K*b1*f*fd*r + 5148*D1**2*K*b1*f*fd*s**2 - 5148*D1**2*K*b1*f*fd*s + 2574*D1**2*K*b1*f*fd - 3960*D1**2*K*b1*f*fdd*r**2 - 7920*D1**2*K*b1*f*fdd*r*s + 3960*D1**2*K*b1*f*fdd*r - 3960*D1**2*K*b1*f*fdd*s**2 + 3960*D1**2*K*b1*f*fdd*s - 1980*D1**2*K*b1*f*fdd - 3960*D1**2*K*b1*fd**2*r**2 - 7920*D1**2*K*b1*fd**2*r*s + 3960*D1**2*K*b1*fd**2*r - 3960*D1**2*K*b1*fd**2*s**2 + 3960*D1**2*K*b1*fd**2*s - 5148*D1**2*b1*f*fd*r**2 - 10296*D1**2*b1*f*fd*r*s + 5148*D1**2*b1*f*fd*r - 5148*D1**2*b1*f*fd*s**2 + 5148*D1**2*b1*f*fd*s - 2574*D1**2*b1*f*fd + 3960*D1**2*b1*f*fdd*r**2 + 7920*D1**2*b1*f*fdd*r*s - 3960*D1**2*b1*f*fdd*r + 3960*D1**2*b1*f*fdd*s**2 - 3960*D1**2*b1*f*fdd*s + 1980*D1**2*b1*f*fdd + 3960*D1**2*b1*fd**2*r**2 + 7920*D1**2*b1*fd**2*r*s - 3960*D1**2*b1*fd**2*r + 3960*D1**2*b1*fd**2*s**2 - 3960*D1**2*b1*fd**2*s - 1980*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 9520*D1**2*f**3*fd*r**2 + 19040*D1**2*f**3*fd*r*s - 14280*D1**2*f**3*fd*r + 9520*D1**2*f**3*fd*s**2 - 14280*D1**2*f**3*fd*s + 7140*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 12540*D1**2*f**2*fd*r**2 - 25080*D1**2*f**2*fd*r*s + 16720*D1**2*f**2*fd*r - 12540*D1**2*f**2*fd*s**2 + 16720*D1**2*f**2*fd*s - 8360*D1**2*f**2*fd + 9240*D1**2*f**2*fdd*r**2 + 18480*D1**2*f**2*fdd*r*s - 12320*D1**2*f**2*fdd*r + 9240*D1**2*f**2*fdd*s**2 - 12320*D1**2*f**2*fdd*s + 6160*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r**2 - 10296*D1**2*f**2*gd2*r*s + 10296*D1**2*f**2*gd2*r - 5148*D1**2*f**2*gd2*s**2 + 10296*D1**2*f**2*gd2*s - 5148*D1**2*f**2*gd2 + 3960*D1**2*f**2*gdd2*r**2 + 7920*D1**2*f**2*gdd2*r*s - 7920*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 7920*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 + 18480*D1**2*f*fd**2*r**2 + 36960*D1**2*f*fd**2*r*s - 24640*D1**2*f*fd**2*r + 18480*D1**2*f*fd**2*s**2 - 24640*D1**2*f*fd**2*s + 6160*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r**2 - 20592*D1**2*f*fd*g2*r*s + 10296*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 15840*D1**2*f*fd*gd2*r**2 + 31680*D1**2*f*fd*gd2*r*s - 23760*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 23760*D1**2*f*fd*gd2*s + 7920*D1**2*f*fd*gd2 + 7920*D1**2*f*fdd*g2*r**2 + 15840*D1**2*f*fdd*g2*r*s - 7920*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 7920*D1**2*f*fdd*g2*s + 3960*D1**2*f*fdd*g2 + 7920*D1**2*fd**2*g2*r**2 + 15840*D1**2*fd**2*g2*r*s - 7920*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 7920*D1**2*fd**2*g2*s + 10296*D1*Dd*K*b1*f**2*r**2 + 20592*D1*Dd*K*b1*f**2*r*s - 15444*D1*Dd*K*b1*f**2*r + 10296*D1*Dd*K*b1*f**2*s**2 - 15444*D1*Dd*K*b1*f**2*s + 7722*D1*Dd*K*b1*f**2 - 31680*D1*Dd*K*b1*f*fd*r**2 - 63360*D1*Dd*K*b1*f*fd*r*s + 39600*D1*Dd*K*b1*f*fd*r - 31680*D1*Dd*K*b1*f*fd*s**2 + 39600*D1*Dd*K*b1*f*fd*s - 11880*D1*Dd*K*b1*f*fd - 10296*D1*Dd*b1*f**2*r**2 - 20592*D1*Dd*b1*f**2*r*s + 15444*D1*Dd*b1*f**2*r - 10296*D1*Dd*b1*f**2*s**2 + 15444*D1*Dd*b1*f**2*s - 7722*D1*Dd*b1*f**2 + 31680*D1*Dd*b1*f*fd*r**2 + 63360*D1*Dd*b1*f*fd*r*s - 39600*D1*Dd*b1*f*fd*r + 31680*D1*Dd*b1*f*fd*s**2 - 39600*D1*Dd*b1*f*fd*s + 11880*D1*Dd*b1*f*fd + 9520*D1*Dd*f**4*r**2 + 19040*D1*Dd*f**4*r*s - 14280*D1*Dd*f**4*r + 9520*D1*Dd*f**4*s**2 - 14280*D1*Dd*f**4*s + 7140*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 16720*D1*Dd*f**3*r**2 - 33440*D1*Dd*f**3*r*s + 25080*D1*Dd*f**3*r - 16720*D1*Dd*f**3*s**2 + 25080*D1*Dd*f**3*s - 12540*D1*Dd*f**3 + 73920*D1*Dd*f**2*fd*r**2 + 147840*D1*Dd*f**2*fd*r*s - 104720*D1*Dd*f**2*fd*r + 73920*D1*Dd*f**2*fd*s**2 - 104720*D1*Dd*f**2*fd*s + 36960*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r**2 - 41184*D1*Dd*f**2*g2*r*s + 30888*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 30888*D1*Dd*f**2*g2*s - 15444*D1*Dd*f**2*g2 + 31680*D1*Dd*f**2*gd2*r**2 + 63360*D1*Dd*f**2*gd2*r*s - 55440*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 55440*D1*Dd*f**2*gd2*s + 23760*D1*Dd*f**2*gd2 + 63360*D1*Dd*f*fd*g2*r**2 + 126720*D1*Dd*f*fd*g2*r*s - 79200*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 79200*D1*Dd*f*fd*g2*s + 23760*D1*Dd*f*fd*g2 - 7920*D1*Ddd*K*b1*f**2*r**2 - 15840*D1*Ddd*K*b1*f**2*r*s + 11880*D1*Ddd*K*b1*f**2*r - 7920*D1*Ddd*K*b1*f**2*s**2 + 11880*D1*Ddd*K*b1*f**2*s - 5940*D1*Ddd*K*b1*f**2 + 7920*D1*Ddd*b1*f**2*r**2 + 15840*D1*Ddd*b1*f**2*r*s - 11880*D1*Ddd*b1*f**2*r + 7920*D1*Ddd*b1*f**2*s**2 - 11880*D1*Ddd*b1*f**2*s + 5940*D1*Ddd*b1*f**2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 12320*D1*Ddd*f**3*r**2 + 24640*D1*Ddd*f**3*r*s - 18480*D1*Ddd*f**3*r + 12320*D1*Ddd*f**3*s**2 - 18480*D1*Ddd*f**3*s + 9240*D1*Ddd*f**3 + 15840*D1*Ddd*f**2*g2*r**2 + 31680*D1*Ddd*f**2*g2*r*s - 23760*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 23760*D1*Ddd*f**2*g2*s + 11880*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 23760*Dd**2*K*b1*f**2*r**2 - 47520*Dd**2*K*b1*f**2*r*s + 35640*Dd**2*K*b1*f**2*r - 23760*Dd**2*K*b1*f**2*s**2 + 35640*Dd**2*K*b1*f**2*s - 11880*Dd**2*K*b1*f**2 + 23760*Dd**2*b1*f**2*r**2 + 47520*Dd**2*b1*f**2*r*s - 35640*Dd**2*b1*f**2*r + 23760*Dd**2*b1*f**2*s**2 - 35640*Dd**2*b1*f**2*s + 11880*Dd**2*b1*f**2 - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 36960*Dd**2*f**3*r**2 + 73920*Dd**2*f**3*r*s - 55440*Dd**2*f**3*r + 36960*Dd**2*f**3*s**2 - 55440*Dd**2*f**3*s + 18480*Dd**2*f**3 + 47520*Dd**2*f**2*g2*r**2 + 95040*Dd**2*f**2*g2*r*s - 71280*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 71280*Dd**2*f**2*g2*s + 23760*Dd**2*f**2*g2)/(1155*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**7*k1**3*k2*(10890*C*D1**2*f**2*fd*r*s - 3630*C*D1**2*f**2*fd*r + 10890*C*D1**2*f**2*fd*s**2 - 10890*C*D1**2*f**2*fd*s + 3630*C*D1**2*f**2*fd - 6930*C*D1**2*f**2*fdd*r*s + 2310*C*D1**2*f**2*fdd*r - 6930*C*D1**2*f**2*fdd*s**2 + 6930*C*D1**2*f**2*fdd*s - 2310*C*D1**2*f**2*fdd - 13860*C*D1**2*f*fd**2*r*s + 4620*C*D1**2*f*fd**2*r - 13860*C*D1**2*f*fd**2*s**2 + 13860*C*D1**2*f*fd**2*s - 2310*C*D1**2*f*fd**2 + 14520*C*D1*Dd*f**3*r*s - 3630*C*D1*Dd*f**3*r + 14520*C*D1*Dd*f**3*s**2 - 14520*C*D1*Dd*f**3*s + 3630*C*D1*Dd*f**3 - 55440*C*D1*Dd*f**2*fd*r*s + 16170*C*D1*Dd*f**2*fd*r - 55440*C*D1*Dd*f**2*fd*s**2 + 55440*C*D1*Dd*f**2*fd*s - 11550*C*D1*Dd*f**2*fd - 9240*C*D1*Ddd*f**3*r*s + 2310*C*D1*Ddd*f**3*r - 9240*C*D1*Ddd*f**3*s**2 + 9240*C*D1*Ddd*f**3*s - 2310*C*D1*Ddd*f**3 - 27720*C*Dd**2*f**3*r*s + 6930*C*Dd**2*f**3*r - 27720*C*Dd**2*f**3*s**2 + 27720*C*Dd**2*f**3*s - 4620*C*Dd**2*f**3 - 1485*D1**2*K*bdd1*f**2*r*s - 1485*D1**2*K*bdd1*f**2*s**2 + 1485*D1**2*K*bdd1*f**2*s + 1485*D1**2*bdd1*f**2*r*s + 1485*D1**2*bdd1*f**2*s**2 - 1485*D1**2*bdd1*f**2*s + 8540*D1**2*f**3*fd*r*s - 2135*D1**2*f**3*fd*r + 8540*D1**2*f**3*fd*s**2 - 8540*D1**2*f**3*fd*s + 2135*D1**2*f**3*fd - 5040*D1**2*f**3*fdd*r*s + 1260*D1**2*f**3*fdd*r - 5040*D1**2*f**3*fdd*s**2 + 5040*D1**2*f**3*fdd*s - 1260*D1**2*f**3*fdd - 15120*D1**2*f**2*fd**2*r*s + 3780*D1**2*f**2*fd**2*r - 15120*D1**2*f**2*fd**2*s**2 + 15120*D1**2*f**2*fd**2*s - 2520*D1**2*f**2*fd**2 - 10890*D1**2*f**2*fd*r*s + 3630*D1**2*f**2*fd*r - 10890*D1**2*f**2*fd*s**2 + 10890*D1**2*f**2*fd*s - 3630*D1**2*f**2*fd + 6930*D1**2*f**2*fdd*r*s - 2310*D1**2*f**2*fdd*r + 6930*D1**2*f**2*fdd*s**2 - 6930*D1**2*f**2*fdd*s + 2310*D1**2*f**2*fdd - 4554*D1**2*f**2*gd2*r*s - 4554*D1**2*f**2*gd2*s**2 + 4554*D1**2*f**2*gd2*s + 2970*D1**2*f**2*gdd2*r*s + 2970*D1**2*f**2*gdd2*s**2 - 2970*D1**2*f**2*gdd2*s + 13860*D1**2*f*fd**2*r*s - 4620*D1**2*f*fd**2*r + 13860*D1**2*f*fd**2*s**2 - 13860*D1**2*f*fd**2*s + 2310*D1**2*f*fd**2 - 9108*D1**2*f*fd*g2*r*s + 4554*D1**2*f*fd*g2*r - 9108*D1**2*f*fd*g2*s**2 + 9108*D1**2*f*fd*g2*s - 4554*D1**2*f*fd*g2 + 11880*D1**2*f*fd*gd2*r*s - 2970*D1**2*f*fd*gd2*r + 11880*D1**2*f*fd*gd2*s**2 - 11880*D1**2*f*fd*gd2*s + 2970*D1**2*f*fd*gd2 + 5940*D1**2*f*fdd*g2*r*s - 2970*D1**2*f*fdd*g2*r + 5940*D1**2*f*fdd*g2*s**2 - 5940*D1**2*f*fdd*g2*s + 2970*D1**2*f*fdd*g2 + 5940*D1**2*fd**2*g2*r*s - 2970*D1**2*fd**2*g2*r + 5940*D1**2*fd**2*g2*s**2 - 5940*D1**2*fd**2*g2*s + 8540*D1*Dd*f**4*r*s - 2135*D1*Dd*f**4*r + 8540*D1*Dd*f**4*s**2 - 8540*D1*Dd*f**4*s + 2135*D1*Dd*f**4 - 40320*D1*Dd*f**3*fd*r*s + 10080*D1*Dd*f**3*fd*r - 40320*D1*Dd*f**3*fd*s**2 + 40320*D1*Dd*f**3*fd*s - 7560*D1*Dd*f**3*fd - 14520*D1*Dd*f**3*r*s + 3630*D1*Dd*f**3*r - 14520*D1*Dd*f**3*s**2 + 14520*D1*Dd*f**3*s - 3630*D1*Dd*f**3 + 55440*D1*Dd*f**2*fd*r*s - 16170*D1*Dd*f**2*fd*r + 55440*D1*Dd*f**2*fd*s**2 - 55440*D1*Dd*f**2*fd*s + 11550*D1*Dd*f**2*fd - 18216*D1*Dd*f**2*g2*r*s + 4554*D1*Dd*f**2*g2*r - 18216*D1*Dd*f**2*g2*s**2 + 18216*D1*Dd*f**2*g2*s - 4554*D1*Dd*f**2*g2 + 23760*D1*Dd*f**2*gd2*r*s - 2970*D1*Dd*f**2*gd2*r + 23760*D1*Dd*f**2*gd2*s**2 - 23760*D1*Dd*f**2*gd2*s + 2970*D1*Dd*f**2*gd2 + 47520*D1*Dd*f*fd*g2*r*s - 17820*D1*Dd*f*fd*g2*r + 47520*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 11880*D1*Dd*f*fd*g2 - 5040*D1*Ddd*f**4*r*s + 1260*D1*Ddd*f**4*r - 5040*D1*Ddd*f**4*s**2 + 5040*D1*Ddd*f**4*s - 1260*D1*Ddd*f**4 + 9240*D1*Ddd*f**3*r*s - 2310*D1*Ddd*f**3*r + 9240*D1*Ddd*f**3*s**2 - 9240*D1*Ddd*f**3*s + 2310*D1*Ddd*f**3 + 11880*D1*Ddd*f**2*g2*r*s - 2970*D1*Ddd*f**2*g2*r + 11880*D1*Ddd*f**2*g2*s**2 - 11880*D1*Ddd*f**2*g2*s + 2970*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 15120*Dd**2*f**4*r*s + 3780*Dd**2*f**4*r - 15120*Dd**2*f**4*s**2 + 15120*Dd**2*f**4*s - 2520*Dd**2*f**4 + 27720*Dd**2*f**3*r*s - 6930*Dd**2*f**3*r + 27720*Dd**2*f**3*s**2 - 27720*Dd**2*f**3*s + 4620*Dd**2*f**3 + 35640*Dd**2*f**2*g2*r*s - 8910*Dd**2*f**2*g2*r + 35640*Dd**2*f**2*g2*s**2 - 35640*Dd**2*f**2*g2*s + 5940*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**7*k1**3*(D1**2*(189*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(567*fd**2*s*(2*s - 1) - fd*(308*C - 308)*(3*s**2 - 2*s + 1) + fdd*(154*C - 154)*(3*s**2 - 2*s + 1) + s**2*(99*K*bdd1 - 198*bd1*(K - 1) - 99*bdd1 + 396*gd2 - 198*gdd2)) - 44*f*(fd**2*s*(14*C - 14)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 792*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(189*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(44*C*(4*s**2 - 2*s + 1) - 27*fd*(1 - 4*s)**2 - 176*s**2 + 88*s - 44) - 22*f*(fd*(14*C - 14)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 396*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(189*f**2 + f*(308*C - 308) - 396*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(189*f**2 + f*(308*C - 308) - 396*g2) + 198*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2*k3**4) + 4*D1**2*Pk2*Pk3*ct**7*k1*k2**5*(-168*C*D1**2*f**2*fd*r**2 - 336*C*D1**2*f**2*fd*r*s + 224*C*D1**2*f**2*fd*r - 168*C*D1**2*f**2*fd*s**2 + 224*C*D1**2*f**2*fd*s - 112*C*D1**2*f**2*fd + 84*C*D1**2*f**2*fdd*r**2 + 168*C*D1**2*f**2*fdd*r*s - 112*C*D1**2*f**2*fdd*r + 84*C*D1**2*f**2*fdd*s**2 - 112*C*D1**2*f**2*fdd*s + 56*C*D1**2*f**2*fdd + 168*C*D1**2*f*fd**2*r**2 + 336*C*D1**2*f*fd**2*r*s - 224*C*D1**2*f*fd**2*r + 168*C*D1**2*f*fd**2*s**2 - 224*C*D1**2*f*fd**2*s + 56*C*D1**2*f*fd**2 - 224*C*D1*Dd*f**3*r**2 - 448*C*D1*Dd*f**3*r*s + 336*C*D1*Dd*f**3*r - 224*C*D1*Dd*f**3*s**2 + 336*C*D1*Dd*f**3*s - 168*C*D1*Dd*f**3 + 672*C*D1*Dd*f**2*fd*r**2 + 1344*C*D1*Dd*f**2*fd*r*s - 952*C*D1*Dd*f**2*fd*r + 672*C*D1*Dd*f**2*fd*s**2 - 952*C*D1*Dd*f**2*fd*s + 336*C*D1*Dd*f**2*fd + 112*C*D1*Ddd*f**3*r**2 + 224*C*D1*Ddd*f**3*r*s - 168*C*D1*Ddd*f**3*r + 112*C*D1*Ddd*f**3*s**2 - 168*C*D1*Ddd*f**3*s + 84*C*D1*Ddd*f**3 + 336*C*Dd**2*f**3*r**2 + 672*C*Dd**2*f**3*r*s - 504*C*Dd**2*f**3*r + 336*C*Dd**2*f**3*s**2 - 504*C*Dd**2*f**3*s + 168*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 - 144*D1**2*K*b1*f*fd*r*s + 72*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 + 126*D1**2*f**2*fd*r**2 + 252*D1**2*f**2*fd*r*s - 168*D1**2*f**2*fd*r + 126*D1**2*f**2*fd*s**2 - 168*D1**2*f**2*fd*s + 84*D1**2*f**2*fd - 63*D1**2*f**2*fdd*r**2 - 126*D1**2*f**2*fdd*r*s + 84*D1**2*f**2*fdd*r - 63*D1**2*f**2*fdd*s**2 + 84*D1**2*f**2*fdd*s - 42*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r - 36*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 126*D1**2*f*fd**2*r**2 - 252*D1**2*f*fd**2*r*s + 168*D1**2*f*fd**2*r - 126*D1**2*f*fd**2*s**2 + 168*D1**2*f*fd**2*s - 42*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 - 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 216*D1*Dd*K*b1*f**2*s - 108*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r**2 + 576*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 360*D1*Dd*K*b1*f*fd*s + 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 168*D1*Dd*f**3*r**2 + 336*D1*Dd*f**3*r*s - 252*D1*Dd*f**3*r + 168*D1*Dd*f**3*s**2 - 252*D1*Dd*f**3*s + 126*D1*Dd*f**3 - 504*D1*Dd*f**2*fd*r**2 - 1008*D1*Dd*f**2*fd*r*s + 714*D1*Dd*f**2*fd*r - 504*D1*Dd*f**2*fd*s**2 + 714*D1*Dd*f**2*fd*s - 252*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 504*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 720*D1*Dd*f*fd*g2*s - 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 + 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 108*D1*Ddd*K*b1*f**2*s + 54*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 84*D1*Ddd*f**3*r**2 - 168*D1*Ddd*f**3*r*s + 126*D1*Ddd*f**3*r - 84*D1*Ddd*f**3*s**2 + 126*D1*Ddd*f**3*s - 63*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 216*D1*Ddd*f**2*g2*s - 108*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*b1*f**2*r**2 + 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 324*Dd**2*K*b1*f**2*s + 108*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 252*Dd**2*f**3*r**2 - 504*Dd**2*f**3*r*s + 378*Dd**2*f**3*r - 252*Dd**2*f**3*s**2 + 378*Dd**2*f**3*s - 126*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 648*Dd**2*f**2*g2*s - 216*Dd**2*f**2*g2)/(21*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**7*k1*k2**3*(-216*C*D1**2*f**2*fd*r**2 + 120*C*D1**2*f**2*fd*r*s + 104*C*D1**2*f**2*fd*r + 336*C*D1**2*f**2*fd*s**2 - 264*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd + 108*C*D1**2*f**2*fdd*r**2 - 60*C*D1**2*f**2*fdd*r*s - 52*C*D1**2*f**2*fdd*r - 168*C*D1**2*f**2*fdd*s**2 + 132*C*D1**2*f**2*fdd*s - 20*C*D1**2*f**2*fdd + 216*C*D1**2*f*fd**2*r**2 - 120*C*D1**2*f*fd**2*r*s - 104*C*D1**2*f*fd**2*r - 336*C*D1**2*f*fd**2*s**2 + 264*C*D1**2*f*fd**2*s - 20*C*D1**2*f*fd**2 - 288*C*D1*Dd*f**3*r**2 + 160*C*D1*Dd*f**3*r*s + 248*C*D1*Dd*f**3*r + 448*C*D1*Dd*f**3*s**2 - 304*C*D1*Dd*f**3*s - 32*C*D1*Dd*f**3 + 864*C*D1*Dd*f**2*fd*r**2 - 480*C*D1*Dd*f**2*fd*r*s - 580*C*D1*Dd*f**2*fd*r - 1344*C*D1*Dd*f**2*fd*s**2 + 984*C*D1*Dd*f**2*fd*s - 28*C*D1*Dd*f**2*fd + 144*C*D1*Ddd*f**3*r**2 - 80*C*D1*Ddd*f**3*r*s - 124*C*D1*Ddd*f**3*r - 224*C*D1*Ddd*f**3*s**2 + 152*C*D1*Ddd*f**3*s + 16*C*D1*Ddd*f**3 + 432*C*Dd**2*f**3*r**2 - 240*C*Dd**2*f**3*r*s - 372*C*Dd**2*f**3*r - 672*C*Dd**2*f**3*s**2 + 456*C*Dd**2*f**3*s + 32*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 + 72*D1**2*K*b1*f*fd*r*s - 36*D1**2*K*b1*f*fd*r + 144*D1**2*K*b1*f*fd*s**2 - 144*D1**2*K*b1*f*fd*s + 72*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 - 36*D1**2*K*b1*f*fdd*r*s + 18*D1**2*K*b1*f*fdd*r - 72*D1**2*K*b1*f*fdd*s**2 + 72*D1**2*K*b1*f*fdd*s - 36*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 - 36*D1**2*K*b1*fd**2*r*s + 18*D1**2*K*b1*fd**2*r - 72*D1**2*K*b1*fd**2*s**2 + 72*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 - 28*D1**2*b1*f**2*fd*r - 42*D1**2*b1*f**2*fd*s**2 + 28*D1**2*b1*f**2*fd*s - 21*D1**2*b1*f**2*fdd*r**2 + 14*D1**2*b1*f**2*fdd*r + 21*D1**2*b1*f**2*fdd*s**2 - 14*D1**2*b1*f**2*fdd*s - 42*D1**2*b1*f*fd**2*r**2 + 28*D1**2*b1*f*fd**2*r + 42*D1**2*b1*f*fd**2*s**2 - 28*D1**2*b1*f*fd**2*s + 108*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd - 54*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd - 54*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(r + s - 1)*(-18*K*(r - 2*s - 1) + 7*f*(r - s - 1) + 27*r - 9*s - 27) - 56*D1**2*f**3*fd*r**2 - 56*D1**2*f**3*fd*r*s + 70*D1**2*f**3*fd*r + 28*D1**2*f**3*fd*s - 28*D1**2*f**3*fd + 56*D1**2*f**3*fdd*r**2 + 56*D1**2*f**3*fdd*r*s - 70*D1**2*f**3*fdd*r - 28*D1**2*f**3*fdd*s + 28*D1**2*f**3*fdd + 168*D1**2*f**2*fd**2*r**2 + 168*D1**2*f**2*fd**2*r*s - 210*D1**2*f**2*fd**2*r - 84*D1**2*f**2*fd**2*s + 56*D1**2*f**2*fd**2 + 258*D1**2*f**2*fd*r**2 + 48*D1**2*f**2*fd*r*s - 188*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 124*D1**2*f**2*fd*s + 16*D1**2*f**2*fd - 129*D1**2*f**2*fdd*r**2 - 24*D1**2*f**2*fdd*r*s + 94*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 62*D1**2*f**2*fdd*s - 8*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 - 72*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r - 144*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 + 36*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r + 72*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 258*D1**2*f*fd**2*r**2 - 48*D1**2*f*fd**2*r*s + 188*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 124*D1**2*f*fd**2*s - 8*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 288*D1**2*f*fd*g2*s**2 + 288*D1**2*f*fd*g2*s - 144*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 + 144*D1**2*f*fd*gd2*r*s + 108*D1**2*f*fd*gd2*r + 288*D1**2*f*fd*gd2*s**2 - 216*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 144*D1**2*f*fdd*g2*s**2 - 144*D1**2*f*fdd*g2*s + 72*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 144*D1**2*fd**2*g2*s**2 - 144*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 + 144*D1*Dd*K*b1*f**2*r*s + 108*D1*Dd*K*b1*f**2*r + 288*D1*Dd*K*b1*f**2*s**2 - 216*D1*Dd*K*b1*f**2*s + 288*D1*Dd*K*b1*f*fd*r**2 - 288*D1*Dd*K*b1*f*fd*r*s - 36*D1*Dd*K*b1*f*fd*r - 576*D1*Dd*K*b1*f*fd*s**2 + 504*D1*Dd*K*b1*f*fd*s - 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 - 56*D1*Dd*b1*f**3*r - 56*D1*Dd*b1*f**3*s**2 + 28*D1*Dd*b1*f**3*s + 14*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 + 140*D1*Dd*b1*f**2*fd*r + 168*D1*Dd*b1*f**2*fd*s**2 - 98*D1*Dd*b1*f**2*fd*s - 14*D1*Dd*b1*f**2*fd + 216*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 252*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 - 36*D1*Dd*b1*f**2*s + 90*D1*Dd*b1*f**2 - 432*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 324*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 36*D1*Dd*b1*f*fd*s - 18*D1*Dd*b1*f*fd - 56*D1*Dd*f**4*r**2 - 56*D1*Dd*f**4*r*s + 70*D1*Dd*f**4*r + 28*D1*Dd*f**4*s - 28*D1*Dd*f**4 + 448*D1*Dd*f**3*fd*r**2 + 448*D1*Dd*f**3*fd*r*s - 560*D1*Dd*f**3*fd*r - 224*D1*Dd*f**3*fd*s + 168*D1*Dd*f**3*fd + 344*D1*Dd*f**3*r**2 + 64*D1*Dd*f**3*r*s - 360*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 108*D1*Dd*f**3*s + 102*D1*Dd*f**3 - 1032*D1*Dd*f**2*fd*r**2 - 192*D1*Dd*f**2*fd*r*s + 916*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 410*D1*Dd*f**2*fd*s - 126*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 - 288*D1*Dd*f**2*g2*r*s - 216*D1*Dd*f**2*g2*r - 576*D1*Dd*f**2*g2*s**2 + 432*D1*Dd*f**2*g2*s - 288*D1*Dd*f**2*gd2*r**2 + 288*D1*Dd*f**2*gd2*r*s + 396*D1*Dd*f**2*gd2*r + 576*D1*Dd*f**2*gd2*s**2 - 360*D1*Dd*f**2*gd2*s - 108*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 + 576*D1*Dd*f*fd*g2*r*s + 72*D1*Dd*f*fd*g2*r + 1152*D1*Dd*f*fd*g2*s**2 - 1008*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 - 72*D1*Ddd*K*b1*f**2*r*s - 54*D1*Ddd*K*b1*f**2*r - 144*D1*Ddd*K*b1*f**2*s**2 + 108*D1*Ddd*K*b1*f**2*s - 28*D1*Ddd*b1*f**3*r**2 + 28*D1*Ddd*b1*f**3*r + 28*D1*Ddd*b1*f**3*s**2 - 14*D1*Ddd*b1*f**3*s - 7*D1*Ddd*b1*f**3 - 108*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 126*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 + 18*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 + 56*D1*Ddd*f**4*r**2 + 56*D1*Ddd*f**4*r*s - 70*D1*Ddd*f**4*r - 28*D1*Ddd*f**4*s + 28*D1*Ddd*f**4 - 172*D1*Ddd*f**3*r**2 - 32*D1*Ddd*f**3*r*s + 180*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 54*D1*Ddd*f**3*s - 51*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 + 144*D1*Ddd*f**2*g2*r*s + 108*D1*Ddd*f**2*g2*r + 288*D1*Ddd*f**2*g2*s**2 - 216*D1*Ddd*f**2*g2*s + 2*D1*bd1*f*(D1*(7*f**2*(r**2 - 2*r - s**2 + 1) + f*(-7*fd*(3*r**2 - 4*r - 3*s**2 + s + 1) + (-9*r - 9*s + 9)*(2*K*(r - 2*s - 1) - 3*r + s + 3)) + 9*fd*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1)) + Dd*f*(9*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 7*f*(4*r**2 - 6*r - 4*s**2 + s + 2) - 108*r**2 - 72*r*s + 171*r + 36*s**2 + 45*s - 63)) + 216*Dd**2*K*b1*f**2*r**2 - 216*Dd**2*K*b1*f**2*r*s - 162*Dd**2*K*b1*f**2*r - 432*Dd**2*K*b1*f**2*s**2 + 324*Dd**2*K*b1*f**2*s - 84*Dd**2*b1*f**3*r**2 + 84*Dd**2*b1*f**3*r + 84*Dd**2*b1*f**3*s**2 - 42*Dd**2*b1*f**3*s - 14*Dd**2*b1*f**3 - 324*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 378*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 + 54*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 + 168*Dd**2*f**4*r**2 + 168*Dd**2*f**4*r*s - 210*Dd**2*f**4*r - 84*Dd**2*f**4*s + 56*Dd**2*f**4 - 516*Dd**2*f**3*r**2 - 96*Dd**2*f**3*r*s + 540*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 162*Dd**2*f**3*s - 102*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 + 432*Dd**2*f**2*g2*r*s + 324*Dd**2*f**2*g2*r + 864*Dd**2*f**2*g2*s**2 - 648*Dd**2*f**2*g2*s)/(63*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**7*k1*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 18*fd*(2*s**2 - 2*s + 1) - 9*fdd*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) + f*(-14*fd*(s**2*(3*bd1 - 3) - s*(bd1 - 2) - 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(-2*Dd*(7*f*(s**2*(4*bd1 - 4) - s*(bd1 - 2) - 1) + (4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1))) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2*k3**2) - 4*D1**2*Pk2*Pk3*ct**6*k1**4*k2**2*(2574*C*D1**2*f**2*fd*r**2 + 5148*C*D1**2*f**2*fd*r*s - 3432*C*D1**2*f**2*fd*r + 2574*C*D1**2*f**2*fd*s**2 - 3432*C*D1**2*f**2*fd*s + 1716*C*D1**2*f**2*fd - 2772*C*D1**2*f**2*fdd*r**2 - 5544*C*D1**2*f**2*fdd*r*s + 3696*C*D1**2*f**2*fdd*r - 2772*C*D1**2*f**2*fdd*s**2 + 3696*C*D1**2*f**2*fdd*s - 1848*C*D1**2*f**2*fdd - 5544*C*D1**2*f*fd**2*r**2 - 11088*C*D1**2*f*fd**2*r*s + 7392*C*D1**2*f*fd**2*r - 5544*C*D1**2*f*fd**2*s**2 + 7392*C*D1**2*f*fd**2*s - 1848*C*D1**2*f*fd**2 + 3432*C*D1*Dd*f**3*r**2 + 6864*C*D1*Dd*f**3*r*s - 5148*C*D1*Dd*f**3*r + 3432*C*D1*Dd*f**3*s**2 - 5148*C*D1*Dd*f**3*s + 2574*C*D1*Dd*f**3 - 22176*C*D1*Dd*f**2*fd*r**2 - 44352*C*D1*Dd*f**2*fd*r*s + 31416*C*D1*Dd*f**2*fd*r - 22176*C*D1*Dd*f**2*fd*s**2 + 31416*C*D1*Dd*f**2*fd*s - 11088*C*D1*Dd*f**2*fd - 3696*C*D1*Ddd*f**3*r**2 - 7392*C*D1*Ddd*f**3*r*s + 5544*C*D1*Ddd*f**3*r - 3696*C*D1*Ddd*f**3*s**2 + 5544*C*D1*Ddd*f**3*s - 2772*C*D1*Ddd*f**3 - 11088*C*Dd**2*f**3*r**2 - 22176*C*Dd**2*f**3*r*s + 16632*C*Dd**2*f**3*r - 11088*C*Dd**2*f**3*s**2 + 16632*C*Dd**2*f**3*s - 5544*C*Dd**2*f**3 + 990*D1**2*K*b1*f*fd*r**2 + 1980*D1**2*K*b1*f*fd*r*s - 990*D1**2*K*b1*f*fd*r + 990*D1**2*K*b1*f*fd*s**2 - 990*D1**2*K*b1*f*fd*s + 495*D1**2*K*b1*f*fd - 1188*D1**2*K*b1*f*fdd*r**2 - 2376*D1**2*K*b1*f*fdd*r*s + 1188*D1**2*K*b1*f*fdd*r - 1188*D1**2*K*b1*f*fdd*s**2 + 1188*D1**2*K*b1*f*fdd*s - 594*D1**2*K*b1*f*fdd - 1188*D1**2*K*b1*fd**2*r**2 - 2376*D1**2*K*b1*fd**2*r*s + 1188*D1**2*K*b1*fd**2*r - 1188*D1**2*K*b1*fd**2*s**2 + 1188*D1**2*K*b1*fd**2*s - 990*D1**2*b1*f*fd*r**2 - 1980*D1**2*b1*f*fd*r*s + 990*D1**2*b1*f*fd*r - 990*D1**2*b1*f*fd*s**2 + 990*D1**2*b1*f*fd*s - 495*D1**2*b1*f*fd + 1188*D1**2*b1*f*fdd*r**2 + 2376*D1**2*b1*f*fdd*r*s - 1188*D1**2*b1*f*fdd*r + 1188*D1**2*b1*f*fdd*s**2 - 1188*D1**2*b1*f*fdd*s + 594*D1**2*b1*f*fdd + 1188*D1**2*b1*fd**2*r**2 + 2376*D1**2*b1*fd**2*r*s - 1188*D1**2*b1*fd**2*r + 1188*D1**2*b1*fd**2*s**2 - 1188*D1**2*b1*fd**2*s - 594*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 2884*D1**2*f**3*fd*r**2 + 5768*D1**2*f**3*fd*r*s - 4326*D1**2*f**3*fd*r + 2884*D1**2*f**3*fd*s**2 - 4326*D1**2*f**3*fd*s + 2163*D1**2*f**3*fd - 2520*D1**2*f**3*fdd*r**2 - 5040*D1**2*f**3*fdd*r*s + 3780*D1**2*f**3*fdd*r - 2520*D1**2*f**3*fdd*s**2 + 3780*D1**2*f**3*fdd*s - 1890*D1**2*f**3*fdd - 7560*D1**2*f**2*fd**2*r**2 - 15120*D1**2*f**2*fd**2*r*s + 11340*D1**2*f**2*fd**2*r - 7560*D1**2*f**2*fd**2*s**2 + 11340*D1**2*f**2*fd**2*s - 3780*D1**2*f**2*fd**2 - 2574*D1**2*f**2*fd*r**2 - 5148*D1**2*f**2*fd*r*s + 3432*D1**2*f**2*fd*r - 2574*D1**2*f**2*fd*s**2 + 3432*D1**2*f**2*fd*s - 1716*D1**2*f**2*fd + 2772*D1**2*f**2*fdd*r**2 + 5544*D1**2*f**2*fdd*r*s - 3696*D1**2*f**2*fdd*r + 2772*D1**2*f**2*fdd*s**2 - 3696*D1**2*f**2*fdd*s + 1848*D1**2*f**2*fdd - 990*D1**2*f**2*gd2*r**2 - 1980*D1**2*f**2*gd2*r*s + 1980*D1**2*f**2*gd2*r - 990*D1**2*f**2*gd2*s**2 + 1980*D1**2*f**2*gd2*s - 990*D1**2*f**2*gd2 + 1188*D1**2*f**2*gdd2*r**2 + 2376*D1**2*f**2*gdd2*r*s - 2376*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 2376*D1**2*f**2*gdd2*s + 1188*D1**2*f**2*gdd2 + 5544*D1**2*f*fd**2*r**2 + 11088*D1**2*f*fd**2*r*s - 7392*D1**2*f*fd**2*r + 5544*D1**2*f*fd**2*s**2 - 7392*D1**2*f*fd**2*s + 1848*D1**2*f*fd**2 - 1980*D1**2*f*fd*g2*r**2 - 3960*D1**2*f*fd*g2*r*s + 1980*D1**2*f*fd*g2*r - 1980*D1**2*f*fd*g2*s**2 + 1980*D1**2*f*fd*g2*s - 990*D1**2*f*fd*g2 + 4752*D1**2*f*fd*gd2*r**2 + 9504*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2376*D1**2*f*fd*gd2 + 2376*D1**2*f*fdd*g2*r**2 + 4752*D1**2*f*fdd*g2*r*s - 2376*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 2376*D1**2*fd**2*g2*r**2 + 4752*D1**2*fd**2*g2*r*s - 2376*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 1980*D1*Dd*K*b1*f**2*r**2 + 3960*D1*Dd*K*b1*f**2*r*s - 2970*D1*Dd*K*b1*f**2*r + 1980*D1*Dd*K*b1*f**2*s**2 - 2970*D1*Dd*K*b1*f**2*s + 1485*D1*Dd*K*b1*f**2 - 9504*D1*Dd*K*b1*f*fd*r**2 - 19008*D1*Dd*K*b1*f*fd*r*s + 11880*D1*Dd*K*b1*f*fd*r - 9504*D1*Dd*K*b1*f*fd*s**2 + 11880*D1*Dd*K*b1*f*fd*s - 3564*D1*Dd*K*b1*f*fd - 1980*D1*Dd*b1*f**2*r**2 - 3960*D1*Dd*b1*f**2*r*s + 2970*D1*Dd*b1*f**2*r - 1980*D1*Dd*b1*f**2*s**2 + 2970*D1*Dd*b1*f**2*s - 1485*D1*Dd*b1*f**2 + 9504*D1*Dd*b1*f*fd*r**2 + 19008*D1*Dd*b1*f*fd*r*s - 11880*D1*Dd*b1*f*fd*r + 9504*D1*Dd*b1*f*fd*s**2 - 11880*D1*Dd*b1*f*fd*s + 3564*D1*Dd*b1*f*fd + 2884*D1*Dd*f**4*r**2 + 5768*D1*Dd*f**4*r*s - 4326*D1*Dd*f**4*r + 2884*D1*Dd*f**4*s**2 - 4326*D1*Dd*f**4*s + 2163*D1*Dd*f**4 - 20160*D1*Dd*f**3*fd*r**2 - 40320*D1*Dd*f**3*fd*r*s + 30240*D1*Dd*f**3*fd*r - 20160*D1*Dd*f**3*fd*s**2 + 30240*D1*Dd*f**3*fd*s - 11340*D1*Dd*f**3*fd - 3432*D1*Dd*f**3*r**2 - 6864*D1*Dd*f**3*r*s + 5148*D1*Dd*f**3*r - 3432*D1*Dd*f**3*s**2 + 5148*D1*Dd*f**3*s - 2574*D1*Dd*f**3 + 22176*D1*Dd*f**2*fd*r**2 + 44352*D1*Dd*f**2*fd*r*s - 31416*D1*Dd*f**2*fd*r + 22176*D1*Dd*f**2*fd*s**2 - 31416*D1*Dd*f**2*fd*s + 11088*D1*Dd*f**2*fd - 3960*D1*Dd*f**2*g2*r**2 - 7920*D1*Dd*f**2*g2*r*s + 5940*D1*Dd*f**2*g2*r - 3960*D1*Dd*f**2*g2*s**2 + 5940*D1*Dd*f**2*g2*s - 2970*D1*Dd*f**2*g2 + 9504*D1*Dd*f**2*gd2*r**2 + 19008*D1*Dd*f**2*gd2*r*s - 16632*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 19008*D1*Dd*f*fd*g2*r**2 + 38016*D1*Dd*f*fd*g2*r*s - 23760*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 23760*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 2376*D1*Ddd*K*b1*f**2*r**2 - 4752*D1*Ddd*K*b1*f**2*r*s + 3564*D1*Ddd*K*b1*f**2*r - 2376*D1*Ddd*K*b1*f**2*s**2 + 3564*D1*Ddd*K*b1*f**2*s - 1782*D1*Ddd*K*b1*f**2 + 2376*D1*Ddd*b1*f**2*r**2 + 4752*D1*Ddd*b1*f**2*r*s - 3564*D1*Ddd*b1*f**2*r + 2376*D1*Ddd*b1*f**2*s**2 - 3564*D1*Ddd*b1*f**2*s + 1782*D1*Ddd*b1*f**2 - 2520*D1*Ddd*f**4*r**2 - 5040*D1*Ddd*f**4*r*s + 3780*D1*Ddd*f**4*r - 2520*D1*Ddd*f**4*s**2 + 3780*D1*Ddd*f**4*s - 1890*D1*Ddd*f**4 + 3696*D1*Ddd*f**3*r**2 + 7392*D1*Ddd*f**3*r*s - 5544*D1*Ddd*f**3*r + 3696*D1*Ddd*f**3*s**2 - 5544*D1*Ddd*f**3*s + 2772*D1*Ddd*f**3 + 4752*D1*Ddd*f**2*g2*r**2 + 9504*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 7128*Dd**2*K*b1*f**2*r**2 - 14256*Dd**2*K*b1*f**2*r*s + 10692*Dd**2*K*b1*f**2*r - 7128*Dd**2*K*b1*f**2*s**2 + 10692*Dd**2*K*b1*f**2*s - 3564*Dd**2*K*b1*f**2 + 7128*Dd**2*b1*f**2*r**2 + 14256*Dd**2*b1*f**2*r*s - 10692*Dd**2*b1*f**2*r + 7128*Dd**2*b1*f**2*s**2 - 10692*Dd**2*b1*f**2*s + 3564*Dd**2*b1*f**2 - 7560*Dd**2*f**4*r**2 - 15120*Dd**2*f**4*r*s + 11340*Dd**2*f**4*r - 7560*Dd**2*f**4*s**2 + 11340*Dd**2*f**4*s - 3780*Dd**2*f**4 + 11088*Dd**2*f**3*r**2 + 22176*Dd**2*f**3*r*s - 16632*Dd**2*f**3*r + 11088*Dd**2*f**3*s**2 - 16632*Dd**2*f**3*s + 5544*Dd**2*f**3 + 14256*Dd**2*f**2*g2*r**2 + 28512*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 7128*Dd**2*f**2*g2)/(231*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**6*k1**4*(2640*C*D1**2*f**2*fd*r*s - 880*C*D1**2*f**2*fd*r + 2640*C*D1**2*f**2*fd*s**2 - 2640*C*D1**2*f**2*fd*s + 880*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r*s + 770*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 2310*C*D1**2*f**2*fdd*s - 770*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r*s + 1540*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 4620*C*D1**2*f*fd**2*s - 770*C*D1**2*f*fd**2 + 3520*C*D1*Dd*f**3*r*s - 880*C*D1*Dd*f**3*r + 3520*C*D1*Dd*f**3*s**2 - 3520*C*D1*Dd*f**3*s + 880*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r*s + 5390*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 18480*C*D1*Dd*f**2*fd*s - 3850*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r*s + 770*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 3080*C*D1*Ddd*f**3*s - 770*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r*s + 2310*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 9240*C*Dd**2*f**3*s - 1540*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 3500*D1**2*f**3*fd*r*s - 875*D1**2*f**3*fd*r + 3500*D1**2*f**3*fd*s**2 - 3500*D1**2*f**3*fd*s + 875*D1**2*f**3*fd - 2520*D1**2*f**3*fdd*r*s + 630*D1**2*f**3*fdd*r - 2520*D1**2*f**3*fdd*s**2 + 2520*D1**2*f**3*fdd*s - 630*D1**2*f**3*fdd - 7560*D1**2*f**2*fd**2*r*s + 1890*D1**2*f**2*fd**2*r - 7560*D1**2*f**2*fd**2*s**2 + 7560*D1**2*f**2*fd**2*s - 1260*D1**2*f**2*fd**2 - 2640*D1**2*f**2*fd*r*s + 880*D1**2*f**2*fd*r - 2640*D1**2*f**2*fd*s**2 + 2640*D1**2*f**2*fd*s - 880*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r*s - 770*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2310*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd - 1056*D1**2*f**2*gd2*r*s - 1056*D1**2*f**2*gd2*s**2 + 1056*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 4620*D1**2*f*fd**2*r*s - 1540*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 4620*D1**2*f*fd**2*s + 770*D1**2*f*fd**2 - 2112*D1**2*f*fd*g2*r*s + 1056*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s**2 + 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 3500*D1*Dd*f**4*r*s - 875*D1*Dd*f**4*r + 3500*D1*Dd*f**4*s**2 - 3500*D1*Dd*f**4*s + 875*D1*Dd*f**4 - 20160*D1*Dd*f**3*fd*r*s + 5040*D1*Dd*f**3*fd*r - 20160*D1*Dd*f**3*fd*s**2 + 20160*D1*Dd*f**3*fd*s - 3780*D1*Dd*f**3*fd - 3520*D1*Dd*f**3*r*s + 880*D1*Dd*f**3*r - 3520*D1*Dd*f**3*s**2 + 3520*D1*Dd*f**3*s - 880*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r*s - 5390*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 18480*D1*Dd*f**2*fd*s + 3850*D1*Dd*f**2*fd - 4224*D1*Dd*f**2*g2*r*s + 1056*D1*Dd*f**2*g2*r - 4224*D1*Dd*f**2*g2*s**2 + 4224*D1*Dd*f**2*g2*s - 1056*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 2520*D1*Ddd*f**4*r*s + 630*D1*Ddd*f**4*r - 2520*D1*Ddd*f**4*s**2 + 2520*D1*Ddd*f**4*s - 630*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r*s - 770*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 3080*D1*Ddd*f**3*s + 770*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(16*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 7560*Dd**2*f**4*r*s + 1890*Dd**2*f**4*r - 7560*Dd**2*f**4*s**2 + 7560*Dd**2*f**4*s - 1260*Dd**2*f**4 + 9240*Dd**2*f**3*r*s - 2310*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 9240*Dd**2*f**3*s + 1540*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(16*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - 15*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**6*k1**4*(D1**2*(189*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-1134*fd**2*s*(2*s - 1) + fd*(308*C - 308)*(3*s**2 - 2*s + 1) - fdd*(154*C - 154)*(3*s**2 - 2*s + 1) + s**2*(-99*K*bdd1 + 198*bd1*(K - 1) + 99*bdd1 - 396*gd2 + 198*gdd2)) - 22*f*(fd**2*s*(14*C - 14)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 396*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(189*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(22*C*(4*s**2 - 2*s + 1) - 27*fd*(1 - 4*s)**2 - 88*s**2 + 44*s - 22) - 11*f*(fd*(14*C - 14)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(189*f**2 + f*(154*C - 154) - 198*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(189*f**2 + f*(154*C - 154) - 198*g2) + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2**2*k3**4) - 4*D1**2*Pk2*Pk3*ct**6*k1**2*k2**4*st**2*(1980*C*D1**2*f**2*fd*r**2 + 3960*C*D1**2*f**2*fd*r*s - 2640*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd*s**2 - 2640*C*D1**2*f**2*fd*s + 1320*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r**2 - 1980*C*D1**2*f**2*fdd*r*s + 1320*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 1320*C*D1**2*f**2*fdd*s - 660*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r**2 - 3960*C*D1**2*f*fd**2*r*s + 2640*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 2640*C*D1**2*f*fd**2*s - 660*C*D1**2*f*fd**2 + 2640*C*D1*Dd*f**3*r**2 + 5280*C*D1*Dd*f**3*r*s - 3960*C*D1*Dd*f**3*r + 2640*C*D1*Dd*f**3*s**2 - 3960*C*D1*Dd*f**3*s + 1980*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r**2 - 15840*C*D1*Dd*f**2*fd*r*s + 11220*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 11220*C*D1*Dd*f**2*fd*s - 3960*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r**2 - 2640*C*D1*Ddd*f**3*r*s + 1980*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1980*C*D1*Ddd*f**3*s - 990*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r**2 - 7920*C*Dd**2*f**3*r*s + 5940*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 5940*C*Dd**2*f**3*s - 1980*C*Dd**2*f**3 + 1188*D1**2*K*b1*f*fd*r**2 + 2376*D1**2*K*b1*f*fd*r*s - 1188*D1**2*K*b1*f*fd*r + 1188*D1**2*K*b1*f*fd*s**2 - 1188*D1**2*K*b1*f*fd*s + 594*D1**2*K*b1*f*fd - 594*D1**2*K*b1*f*fdd*r**2 - 1188*D1**2*K*b1*f*fdd*r*s + 594*D1**2*K*b1*f*fdd*r - 594*D1**2*K*b1*f*fdd*s**2 + 594*D1**2*K*b1*f*fdd*s - 297*D1**2*K*b1*f*fdd - 594*D1**2*K*b1*fd**2*r**2 - 1188*D1**2*K*b1*fd**2*r*s + 594*D1**2*K*b1*fd**2*r - 594*D1**2*K*b1*fd**2*s**2 + 594*D1**2*K*b1*fd**2*s - 1188*D1**2*b1*f*fd*r**2 - 2376*D1**2*b1*f*fd*r*s + 1188*D1**2*b1*f*fd*r - 1188*D1**2*b1*f*fd*s**2 + 1188*D1**2*b1*f*fd*s - 594*D1**2*b1*f*fd + 594*D1**2*b1*f*fdd*r**2 + 1188*D1**2*b1*f*fdd*r*s - 594*D1**2*b1*f*fdd*r + 594*D1**2*b1*f*fdd*s**2 - 594*D1**2*b1*f*fdd*s + 297*D1**2*b1*f*fdd + 594*D1**2*b1*fd**2*r**2 + 1188*D1**2*b1*fd**2*r*s - 594*D1**2*b1*fd**2*r + 594*D1**2*b1*fd**2*s**2 - 594*D1**2*b1*fd**2*s - 297*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 1568*D1**2*f**3*fd*r**2 + 3136*D1**2*f**3*fd*r*s - 2352*D1**2*f**3*fd*r + 1568*D1**2*f**3*fd*s**2 - 2352*D1**2*f**3*fd*s + 1176*D1**2*f**3*fd - 784*D1**2*f**3*fdd*r**2 - 1568*D1**2*f**3*fdd*r*s + 1176*D1**2*f**3*fdd*r - 784*D1**2*f**3*fdd*s**2 + 1176*D1**2*f**3*fdd*s - 588*D1**2*f**3*fdd - 2352*D1**2*f**2*fd**2*r**2 - 4704*D1**2*f**2*fd**2*r*s + 3528*D1**2*f**2*fd**2*r - 2352*D1**2*f**2*fd**2*s**2 + 3528*D1**2*f**2*fd**2*s - 1176*D1**2*f**2*fd**2 - 1980*D1**2*f**2*fd*r**2 - 3960*D1**2*f**2*fd*r*s + 2640*D1**2*f**2*fd*r - 1980*D1**2*f**2*fd*s**2 + 2640*D1**2*f**2*fd*s - 1320*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r**2 + 1980*D1**2*f**2*fdd*r*s - 1320*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 1320*D1**2*f**2*fdd*s + 660*D1**2*f**2*fdd - 1188*D1**2*f**2*gd2*r**2 - 2376*D1**2*f**2*gd2*r*s + 2376*D1**2*f**2*gd2*r - 1188*D1**2*f**2*gd2*s**2 + 2376*D1**2*f**2*gd2*s - 1188*D1**2*f**2*gd2 + 594*D1**2*f**2*gdd2*r**2 + 1188*D1**2*f**2*gdd2*r*s - 1188*D1**2*f**2*gdd2*r + 594*D1**2*f**2*gdd2*s**2 - 1188*D1**2*f**2*gdd2*s + 594*D1**2*f**2*gdd2 + 1980*D1**2*f*fd**2*r**2 + 3960*D1**2*f*fd**2*r*s - 2640*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 2640*D1**2*f*fd**2*s + 660*D1**2*f*fd**2 - 2376*D1**2*f*fd*g2*r**2 - 4752*D1**2*f*fd*g2*r*s + 2376*D1**2*f*fd*g2*r - 2376*D1**2*f*fd*g2*s**2 + 2376*D1**2*f*fd*g2*s - 1188*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r**2 + 4752*D1**2*f*fd*gd2*r*s - 3564*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 3564*D1**2*f*fd*gd2*s + 1188*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r**2 + 2376*D1**2*f*fdd*g2*r*s - 1188*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r**2 + 2376*D1**2*fd**2*g2*r*s - 1188*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 2376*D1*Dd*K*b1*f**2*r**2 + 4752*D1*Dd*K*b1*f**2*r*s - 3564*D1*Dd*K*b1*f**2*r + 2376*D1*Dd*K*b1*f**2*s**2 - 3564*D1*Dd*K*b1*f**2*s + 1782*D1*Dd*K*b1*f**2 - 4752*D1*Dd*K*b1*f*fd*r**2 - 9504*D1*Dd*K*b1*f*fd*r*s + 5940*D1*Dd*K*b1*f*fd*r - 4752*D1*Dd*K*b1*f*fd*s**2 + 5940*D1*Dd*K*b1*f*fd*s - 1782*D1*Dd*K*b1*f*fd - 2376*D1*Dd*b1*f**2*r**2 - 4752*D1*Dd*b1*f**2*r*s + 3564*D1*Dd*b1*f**2*r - 2376*D1*Dd*b1*f**2*s**2 + 3564*D1*Dd*b1*f**2*s - 1782*D1*Dd*b1*f**2 + 4752*D1*Dd*b1*f*fd*r**2 + 9504*D1*Dd*b1*f*fd*r*s - 5940*D1*Dd*b1*f*fd*r + 4752*D1*Dd*b1*f*fd*s**2 - 5940*D1*Dd*b1*f*fd*s + 1782*D1*Dd*b1*f*fd + 1568*D1*Dd*f**4*r**2 + 3136*D1*Dd*f**4*r*s - 2352*D1*Dd*f**4*r + 1568*D1*Dd*f**4*s**2 - 2352*D1*Dd*f**4*s + 1176*D1*Dd*f**4 - 6272*D1*Dd*f**3*fd*r**2 - 12544*D1*Dd*f**3*fd*r*s + 9408*D1*Dd*f**3*fd*r - 6272*D1*Dd*f**3*fd*s**2 + 9408*D1*Dd*f**3*fd*s - 3528*D1*Dd*f**3*fd - 2640*D1*Dd*f**3*r**2 - 5280*D1*Dd*f**3*r*s + 3960*D1*Dd*f**3*r - 2640*D1*Dd*f**3*s**2 + 3960*D1*Dd*f**3*s - 1980*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r**2 + 15840*D1*Dd*f**2*fd*r*s - 11220*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 11220*D1*Dd*f**2*fd*s + 3960*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*g2*r**2 - 9504*D1*Dd*f**2*g2*r*s + 7128*D1*Dd*f**2*g2*r - 4752*D1*Dd*f**2*g2*s**2 + 7128*D1*Dd*f**2*g2*s - 3564*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r**2 + 9504*D1*Dd*f**2*gd2*r*s - 8316*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 8316*D1*Dd*f**2*gd2*s + 3564*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r**2 + 19008*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 11880*D1*Dd*f*fd*g2*s + 3564*D1*Dd*f*fd*g2 - 1188*D1*Ddd*K*b1*f**2*r**2 - 2376*D1*Ddd*K*b1*f**2*r*s + 1782*D1*Ddd*K*b1*f**2*r - 1188*D1*Ddd*K*b1*f**2*s**2 + 1782*D1*Ddd*K*b1*f**2*s - 891*D1*Ddd*K*b1*f**2 + 1188*D1*Ddd*b1*f**2*r**2 + 2376*D1*Ddd*b1*f**2*r*s - 1782*D1*Ddd*b1*f**2*r + 1188*D1*Ddd*b1*f**2*s**2 - 1782*D1*Ddd*b1*f**2*s + 891*D1*Ddd*b1*f**2 - 784*D1*Ddd*f**4*r**2 - 1568*D1*Ddd*f**4*r*s + 1176*D1*Ddd*f**4*r - 784*D1*Ddd*f**4*s**2 + 1176*D1*Ddd*f**4*s - 588*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r**2 + 2640*D1*Ddd*f**3*r*s - 1980*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1980*D1*Ddd*f**3*s + 990*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r**2 + 4752*D1*Ddd*f**2*g2*r*s - 3564*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 3564*D1*Ddd*f**2*g2*s + 1782*D1*Ddd*f**2*g2 + 594*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 3564*Dd**2*K*b1*f**2*r**2 - 7128*Dd**2*K*b1*f**2*r*s + 5346*Dd**2*K*b1*f**2*r - 3564*Dd**2*K*b1*f**2*s**2 + 5346*Dd**2*K*b1*f**2*s - 1782*Dd**2*K*b1*f**2 + 3564*Dd**2*b1*f**2*r**2 + 7128*Dd**2*b1*f**2*r*s - 5346*Dd**2*b1*f**2*r + 3564*Dd**2*b1*f**2*s**2 - 5346*Dd**2*b1*f**2*s + 1782*Dd**2*b1*f**2 - 2352*Dd**2*f**4*r**2 - 4704*Dd**2*f**4*r*s + 3528*Dd**2*f**4*r - 2352*Dd**2*f**4*s**2 + 3528*Dd**2*f**4*s - 1176*Dd**2*f**4 + 3960*Dd**2*f**3*r**2 + 7920*Dd**2*f**3*r*s - 5940*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 5940*Dd**2*f**3*s + 1980*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r**2 + 14256*Dd**2*f**2*g2*r*s - 10692*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 10692*Dd**2*f**2*g2*s + 3564*Dd**2*f**2*g2)/(231*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**6*k1**2*k2**4*(-90*C*D1**2*bdd1*f**2*r**2 - 180*C*D1**2*bdd1*f**2*r*s + 180*C*D1**2*bdd1*f**2*r - 90*C*D1**2*bdd1*f**2*s**2 + 180*C*D1**2*bdd1*f**2*s - 90*C*D1**2*bdd1*f**2 + 2010*C*D1**2*f**2*fd*r**2 + 4020*C*D1**2*f**2*fd*r*s - 2680*C*D1**2*f**2*fd*r + 2010*C*D1**2*f**2*fd*s**2 - 2680*C*D1**2*f**2*fd*s + 1340*C*D1**2*f**2*fd - 1680*C*D1**2*f**2*fdd*r**2 - 3360*C*D1**2*f**2*fdd*r*s + 2240*C*D1**2*f**2*fdd*r - 1680*C*D1**2*f**2*fdd*s**2 + 2240*C*D1**2*f**2*fdd*s - 1120*C*D1**2*f**2*fdd - 3360*C*D1**2*f*fd**2*r**2 - 6720*C*D1**2*f*fd**2*r*s + 4480*C*D1**2*f*fd**2*r - 3360*C*D1**2*f*fd**2*s**2 + 4480*C*D1**2*f*fd**2*s - 1120*C*D1**2*f*fd**2 + 2680*C*D1*Dd*f**3*r**2 + 5360*C*D1*Dd*f**3*r*s - 4020*C*D1*Dd*f**3*r + 2680*C*D1*Dd*f**3*s**2 - 4020*C*D1*Dd*f**3*s + 2010*C*D1*Dd*f**3 - 13440*C*D1*Dd*f**2*fd*r**2 - 26880*C*D1*Dd*f**2*fd*r*s + 19040*C*D1*Dd*f**2*fd*r - 13440*C*D1*Dd*f**2*fd*s**2 + 19040*C*D1*Dd*f**2*fd*s - 6720*C*D1*Dd*f**2*fd - 2240*C*D1*Ddd*f**3*r**2 - 4480*C*D1*Ddd*f**3*r*s + 3360*C*D1*Ddd*f**3*r - 2240*C*D1*Ddd*f**3*s**2 + 3360*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 6720*C*Dd**2*f**3*r**2 - 13440*C*Dd**2*f**3*r*s + 10080*C*Dd**2*f**3*r - 6720*C*Dd**2*f**3*s**2 + 10080*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 360*D1**2*K*bdd1*f**2*r**2 - 720*D1**2*K*bdd1*f**2*r*s + 720*D1**2*K*bdd1*f**2*r - 360*D1**2*K*bdd1*f**2*s**2 + 720*D1**2*K*bdd1*f**2*s - 360*D1**2*K*bdd1*f**2 - 126*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 140*D1**2*bdd1*f**3*r**2 + 280*D1**2*bdd1*f**3*r*s - 280*D1**2*bdd1*f**3*r + 140*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 140*D1**2*bdd1*f**3 + 270*D1**2*bdd1*f**2*r**2 + 540*D1**2*bdd1*f**2*r*s - 540*D1**2*bdd1*f**2*r + 270*D1**2*bdd1*f**2*s**2 - 540*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 + 126*D1**2*bdd1*f*g2*r**2 + 252*D1**2*bdd1*f*g2*r*s - 252*D1**2*bdd1*f*g2*r + 126*D1**2*bdd1*f*g2*s**2 - 252*D1**2*bdd1*f*g2*s + 126*D1**2*bdd1*f*g2 - 140*D1**2*f**3*fd*r**2 - 280*D1**2*f**3*fd*r*s + 210*D1**2*f**3*fd*r - 140*D1**2*f**3*fd*s**2 + 210*D1**2*f**3*fd*s - 105*D1**2*f**3*fd - 1440*D1**2*f**2*fd*r**2 - 2880*D1**2*f**2*fd*r*s + 1920*D1**2*f**2*fd*r - 1440*D1**2*f**2*fd*s**2 + 1920*D1**2*f**2*fd*s - 960*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 2520*D1**2*f**2*fdd*r*s - 1680*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1680*D1**2*f**2*fdd*s + 840*D1**2*f**2*fdd - 810*D1**2*f**2*gd2*r**2 - 1620*D1**2*f**2*gd2*r*s + 1620*D1**2*f**2*gd2*r - 810*D1**2*f**2*gd2*s**2 + 1620*D1**2*f**2*gd2*s - 810*D1**2*f**2*gd2 + 720*D1**2*f**2*gdd2*r**2 + 1440*D1**2*f**2*gdd2*r*s - 1440*D1**2*f**2*gdd2*r + 720*D1**2*f**2*gdd2*s**2 - 1440*D1**2*f**2*gdd2*s + 720*D1**2*f**2*gdd2 + 2520*D1**2*f*fd**2*r**2 + 5040*D1**2*f*fd**2*r*s - 3360*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 3360*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 1620*D1**2*f*fd*g2*r**2 - 3240*D1**2*f*fd*g2*r*s + 1620*D1**2*f*fd*g2*r - 1620*D1**2*f*fd*g2*s**2 + 1620*D1**2*f*fd*g2*s - 810*D1**2*f*fd*g2 + 2880*D1**2*f*fd*gd2*r**2 + 5760*D1**2*f*fd*gd2*r*s - 4320*D1**2*f*fd*gd2*r + 2880*D1**2*f*fd*gd2*s**2 - 4320*D1**2*f*fd*gd2*s + 1440*D1**2*f*fd*gd2 + 1440*D1**2*f*fdd*g2*r**2 + 2880*D1**2*f*fdd*g2*r*s - 1440*D1**2*f*fdd*g2*r + 1440*D1**2*f*fdd*g2*s**2 - 1440*D1**2*f*fdd*g2*s + 720*D1**2*f*fdd*g2 + 1440*D1**2*fd**2*g2*r**2 + 2880*D1**2*fd**2*g2*r*s - 1440*D1**2*fd**2*g2*r + 1440*D1**2*fd**2*g2*s**2 - 1440*D1**2*fd**2*g2*s - 140*D1*Dd*f**4*r**2 - 280*D1*Dd*f**4*r*s + 210*D1*Dd*f**4*r - 140*D1*Dd*f**4*s**2 + 210*D1*Dd*f**4*s - 105*D1*Dd*f**4 - 1920*D1*Dd*f**3*r**2 - 3840*D1*Dd*f**3*r*s + 2880*D1*Dd*f**3*r - 1920*D1*Dd*f**3*s**2 + 2880*D1*Dd*f**3*s - 1440*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 20160*D1*Dd*f**2*fd*r*s - 14280*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 14280*D1*Dd*f**2*fd*s + 5040*D1*Dd*f**2*fd - 3240*D1*Dd*f**2*g2*r**2 - 6480*D1*Dd*f**2*g2*r*s + 4860*D1*Dd*f**2*g2*r - 3240*D1*Dd*f**2*g2*s**2 + 4860*D1*Dd*f**2*g2*s - 2430*D1*Dd*f**2*g2 + 5760*D1*Dd*f**2*gd2*r**2 + 11520*D1*Dd*f**2*gd2*r*s - 10080*D1*Dd*f**2*gd2*r + 5760*D1*Dd*f**2*gd2*s**2 - 10080*D1*Dd*f**2*gd2*s + 4320*D1*Dd*f**2*gd2 + 11520*D1*Dd*f*fd*g2*r**2 + 23040*D1*Dd*f*fd*g2*r*s - 14400*D1*Dd*f*fd*g2*r + 11520*D1*Dd*f*fd*g2*s**2 - 14400*D1*Dd*f*fd*g2*s + 4320*D1*Dd*f*fd*g2 + 1680*D1*Ddd*f**3*r**2 + 3360*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 2520*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 2880*D1*Ddd*f**2*g2*r**2 + 5760*D1*Ddd*f**2*g2*r*s - 4320*D1*Ddd*f**2*g2*r + 2880*D1*Ddd*f**2*g2*s**2 - 4320*D1*Ddd*f**2*g2*s + 2160*D1*Ddd*f**2*g2 - D1*bd1*(D1*(190*f**3*(r + s - 1) - f**2*(180*C*(r + s - 1) + 280*fd*(3*r + 3*s - 2) + (405*K - 351)*(r + s - 1)) + 36*f*(5*fd*(C + 4*K - 3)*(2*r + 2*s - 1) + (7*g2 - 7*gd2)*(r + s - 1)) - 252*fd*g2*(r + s)) - 4*Dd*f*(70*f**2 - 45*f*(C + 4*K - 3) + 63*g2)*(4*r + 4*s - 3))*(r + s - 1) + 5040*Dd**2*f**3*r**2 + 10080*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 7560*Dd**2*f**3*s + 2520*Dd**2*f**3 + 8640*Dd**2*f**2*g2*r**2 + 17280*Dd**2*f**2*g2*r*s - 12960*Dd**2*f**2*g2*r + 8640*Dd**2*f**2*g2*s**2 - 12960*Dd**2*f**2*g2*s + 4320*Dd**2*f**2*g2 + 63*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(360*C*D1**2*f*fd*r**2 + 720*C*D1**2*f*fd*r*s - 360*C*D1**2*f*fd*r + 360*C*D1**2*f*fd*s**2 - 360*C*D1**2*f*fd*s + 180*C*D1**2*f*fd - 180*C*D1**2*f*fdd*r**2 - 360*C*D1**2*f*fdd*r*s + 180*C*D1**2*f*fdd*r - 180*C*D1**2*f*fdd*s**2 + 180*C*D1**2*f*fdd*s - 90*C*D1**2*f*fdd - 180*C*D1**2*fd**2*r**2 - 360*C*D1**2*fd**2*r*s + 180*C*D1**2*fd**2*r - 180*C*D1**2*fd**2*s**2 + 180*C*D1**2*fd**2*s + 720*C*D1*Dd*f**2*r**2 + 1440*C*D1*Dd*f**2*r*s - 1080*C*D1*Dd*f**2*r + 720*C*D1*Dd*f**2*s**2 - 1080*C*D1*Dd*f**2*s + 540*C*D1*Dd*f**2 - 1440*C*D1*Dd*f*fd*r**2 - 2880*C*D1*Dd*f*fd*r*s + 1800*C*D1*Dd*f*fd*r - 1440*C*D1*Dd*f*fd*s**2 + 1800*C*D1*Dd*f*fd*s - 540*C*D1*Dd*f*fd - 360*C*D1*Ddd*f**2*r**2 - 720*C*D1*Ddd*f**2*r*s + 540*C*D1*Ddd*f**2*r - 360*C*D1*Ddd*f**2*s**2 + 540*C*D1*Ddd*f**2*s - 270*C*D1*Ddd*f**2 - 1080*C*Dd**2*f**2*r**2 - 2160*C*Dd**2*f**2*r*s + 1620*C*Dd**2*f**2*r - 1080*C*Dd**2*f**2*s**2 + 1620*C*Dd**2*f**2*s - 540*C*Dd**2*f**2 + 810*D1**2*K*f*fd*r**2 + 1620*D1**2*K*f*fd*r*s - 810*D1**2*K*f*fd*r + 810*D1**2*K*f*fd*s**2 - 810*D1**2*K*f*fd*s + 405*D1**2*K*f*fd - 720*D1**2*K*f*fdd*r**2 - 1440*D1**2*K*f*fdd*r*s + 720*D1**2*K*f*fdd*r - 720*D1**2*K*f*fdd*s**2 + 720*D1**2*K*f*fdd*s - 360*D1**2*K*f*fdd - 720*D1**2*K*fd**2*r**2 - 1440*D1**2*K*fd**2*r*s + 720*D1**2*K*fd**2*r - 720*D1**2*K*fd**2*s**2 + 720*D1**2*K*fd**2*s - 126*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 570*D1**2*f**2*fd*r**2 - 1140*D1**2*f**2*fd*r*s + 760*D1**2*f**2*fd*r - 570*D1**2*f**2*fd*s**2 + 760*D1**2*f**2*fd*s - 380*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 702*D1**2*f*fd*r**2 - 1404*D1**2*f*fd*r*s + 702*D1**2*f*fd*r - 702*D1**2*f*fd*s**2 + 702*D1**2*f*fd*s - 351*D1**2*f*fd + 540*D1**2*f*fdd*r**2 + 1080*D1**2*f*fdd*r*s - 540*D1**2*f*fdd*r + 540*D1**2*f*fdd*s**2 - 540*D1**2*f*fdd*s + 270*D1**2*f*fdd - 252*D1**2*f*gd2*r**2 - 504*D1**2*f*gd2*r*s + 504*D1**2*f*gd2*r - 252*D1**2*f*gd2*s**2 + 504*D1**2*f*gd2*s - 252*D1**2*f*gd2 + 126*D1**2*f*gdd2*r**2 + 252*D1**2*f*gdd2*r*s - 252*D1**2*f*gdd2*r + 126*D1**2*f*gdd2*s**2 - 252*D1**2*f*gdd2*s + 126*D1**2*f*gdd2 + 540*D1**2*fd**2*r**2 + 1080*D1**2*fd**2*r*s - 540*D1**2*fd**2*r + 540*D1**2*fd**2*s**2 - 540*D1**2*fd**2*s - 252*D1**2*fd*g2*r**2 - 504*D1**2*fd*g2*r*s - 252*D1**2*fd*g2*s**2 + 252*D1**2*fd*gd2*r**2 + 504*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*r + 252*D1**2*fd*gd2*s**2 - 252*D1**2*fd*gd2*s + 126*D1**2*fdd*g2*r**2 + 252*D1**2*fdd*g2*r*s + 126*D1**2*fdd*g2*s**2 + 1620*D1*Dd*K*f**2*r**2 + 3240*D1*Dd*K*f**2*r*s - 2430*D1*Dd*K*f**2*r + 1620*D1*Dd*K*f**2*s**2 - 2430*D1*Dd*K*f**2*s + 1215*D1*Dd*K*f**2 - 5760*D1*Dd*K*f*fd*r**2 - 11520*D1*Dd*K*f*fd*r*s + 7200*D1*Dd*K*f*fd*r - 5760*D1*Dd*K*f*fd*s**2 + 7200*D1*Dd*K*f*fd*s - 2160*D1*Dd*K*f*fd - 760*D1*Dd*f**3*r**2 - 1520*D1*Dd*f**3*r*s + 1140*D1*Dd*f**3*r - 760*D1*Dd*f**3*s**2 + 1140*D1*Dd*f**3*s - 570*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 1404*D1*Dd*f**2*r**2 - 2808*D1*Dd*f**2*r*s + 2106*D1*Dd*f**2*r - 1404*D1*Dd*f**2*s**2 + 2106*D1*Dd*f**2*s - 1053*D1*Dd*f**2 + 4320*D1*Dd*f*fd*r**2 + 8640*D1*Dd*f*fd*r*s - 5400*D1*Dd*f*fd*r + 4320*D1*Dd*f*fd*s**2 - 5400*D1*Dd*f*fd*s + 1620*D1*Dd*f*fd - 1008*D1*Dd*f*g2*r**2 - 2016*D1*Dd*f*g2*r*s + 1512*D1*Dd*f*g2*r - 1008*D1*Dd*f*g2*s**2 + 1512*D1*Dd*f*g2*s - 756*D1*Dd*f*g2 + 1008*D1*Dd*f*gd2*r**2 + 2016*D1*Dd*f*gd2*r*s - 1764*D1*Dd*f*gd2*r + 1008*D1*Dd*f*gd2*s**2 - 1764*D1*Dd*f*gd2*s + 756*D1*Dd*f*gd2 + 1008*D1*Dd*fd*g2*r**2 + 2016*D1*Dd*fd*g2*r*s - 756*D1*Dd*fd*g2*r + 1008*D1*Dd*fd*g2*s**2 - 756*D1*Dd*fd*g2*s - 1440*D1*Ddd*K*f**2*r**2 - 2880*D1*Ddd*K*f**2*r*s + 2160*D1*Ddd*K*f**2*r - 1440*D1*Ddd*K*f**2*s**2 + 2160*D1*Ddd*K*f**2*s - 1080*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 1080*D1*Ddd*f**2*r**2 + 2160*D1*Ddd*f**2*r*s - 1620*D1*Ddd*f**2*r + 1080*D1*Ddd*f**2*s**2 - 1620*D1*Ddd*f**2*s + 810*D1*Ddd*f**2 + 504*D1*Ddd*f*g2*r**2 + 1008*D1*Ddd*f*g2*r*s - 756*D1*Ddd*f*g2*r + 504*D1*Ddd*f*g2*s**2 - 756*D1*Ddd*f*g2*s + 378*D1*Ddd*f*g2 + 252*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 4320*Dd**2*K*f**2*r**2 - 8640*Dd**2*K*f**2*r*s + 6480*Dd**2*K*f**2*r - 4320*Dd**2*K*f**2*s**2 + 6480*Dd**2*K*f**2*s - 2160*Dd**2*K*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 3240*Dd**2*f**2*r**2 + 6480*Dd**2*f**2*r*s - 4860*Dd**2*f**2*r + 3240*Dd**2*f**2*s**2 - 4860*Dd**2*f**2*s + 1620*Dd**2*f**2 + 1512*Dd**2*f*g2*r**2 + 3024*Dd**2*f*g2*r*s - 2268*Dd**2*f*g2*r + 1512*Dd**2*f*g2*s**2 - 2268*Dd**2*f*g2*s + 756*Dd**2*f*g2))/(105*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**6*k1**2*k2**2*st**2*(1980*C*D1**2*f**2*fd*r*s - 660*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd*s**2 - 1980*C*D1**2*f**2*fd*s + 660*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 2640*C*D1*Dd*f**3*r*s - 660*C*D1*Dd*f**3*r + 2640*C*D1*Dd*f**3*s**2 - 2640*C*D1*Dd*f**3*s + 660*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 1568*D1**2*f**3*fd*r*s - 392*D1**2*f**3*fd*r + 1568*D1**2*f**3*fd*s**2 - 1568*D1**2*f**3*fd*s + 392*D1**2*f**3*fd - 784*D1**2*f**3*fdd*r*s + 196*D1**2*f**3*fdd*r - 784*D1**2*f**3*fdd*s**2 + 784*D1**2*f**3*fdd*s - 196*D1**2*f**3*fdd - 2352*D1**2*f**2*fd**2*r*s + 588*D1**2*f**2*fd**2*r - 2352*D1**2*f**2*fd**2*s**2 + 2352*D1**2*f**2*fd**2*s - 392*D1**2*f**2*fd**2 - 1980*D1**2*f**2*fd*r*s + 660*D1**2*f**2*fd*r - 1980*D1**2*f**2*fd*s**2 + 1980*D1**2*f**2*fd*s - 660*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 1188*D1**2*f**2*gd2*r*s - 1188*D1**2*f**2*gd2*s**2 + 1188*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 2376*D1**2*f*fd*g2*r*s + 1188*D1**2*f*fd*g2*r - 2376*D1**2*f*fd*g2*s**2 + 2376*D1**2*f*fd*g2*s - 1188*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 1568*D1*Dd*f**4*r*s - 392*D1*Dd*f**4*r + 1568*D1*Dd*f**4*s**2 - 1568*D1*Dd*f**4*s + 392*D1*Dd*f**4 - 6272*D1*Dd*f**3*fd*r*s + 1568*D1*Dd*f**3*fd*r - 6272*D1*Dd*f**3*fd*s**2 + 6272*D1*Dd*f**3*fd*s - 1176*D1*Dd*f**3*fd - 2640*D1*Dd*f**3*r*s + 660*D1*Dd*f**3*r - 2640*D1*Dd*f**3*s**2 + 2640*D1*Dd*f**3*s - 660*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*g2*r*s + 1188*D1*Dd*f**2*g2*r - 4752*D1*Dd*f**2*g2*s**2 + 4752*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 784*D1*Ddd*f**4*r*s + 196*D1*Ddd*f**4*r - 784*D1*Ddd*f**4*s**2 + 784*D1*Ddd*f**4*s - 196*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 297*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 2352*Dd**2*f**4*r*s + 588*Dd**2*f**4*r - 2352*Dd**2*f**4*s**2 + 2352*Dd**2*f**4*s - 392*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 297*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**6*k1**2*k2**2*(180*C*D1**2*bdd1*f**2*r**2 + 720*C*D1**2*bdd1*f**2*r*s - 360*C*D1**2*bdd1*f**2*r + 540*C*D1**2*bdd1*f**2*s**2 - 720*C*D1**2*bdd1*f**2*s + 360*C*D1**2*bdd1*f**2 + 6210*C*D1**2*f**2*fd*r**2 + 2940*C*D1**2*f**2*fd*r*s - 5120*C*D1**2*f**2*fd*r - 3270*C*D1**2*f**2*fd*s**2 + 1200*C*D1**2*f**2*fd*s + 980*C*D1**2*f**2*fd - 4590*C*D1**2*f**2*fdd*r**2 - 2820*C*D1**2*f**2*fdd*r*s + 4000*C*D1**2*f**2*fdd*r + 1770*C*D1**2*f**2*fdd*s**2 - 240*C*D1**2*f**2*fdd*s - 940*C*D1**2*f**2*fdd - 9180*C*D1**2*f*fd**2*r**2 - 5640*C*D1**2*f*fd**2*r*s + 8000*C*D1**2*f*fd**2*r + 3540*C*D1**2*f*fd**2*s**2 - 480*C*D1**2*f*fd**2*s - 940*C*D1**2*f*fd**2 + 8280*C*D1*Dd*f**3*r**2 + 3920*C*D1*Dd*f**3*r*s - 9260*C*D1*Dd*f**3*r - 4360*C*D1*Dd*f**3*s**2 + 220*C*D1*Dd*f**3*s + 3050*C*D1*Dd*f**3 - 36720*C*D1*Dd*f**2*fd*r**2 - 22560*C*D1*Dd*f**2*fd*r*s + 37180*C*D1*Dd*f**2*fd*r + 14160*C*D1*Dd*f**2*fd*s**2 + 1140*C*D1*Dd*f**2*fd*s - 7760*C*D1*Dd*f**2*fd - 6120*C*D1*Ddd*f**3*r**2 - 3760*C*D1*Ddd*f**3*r*s + 7060*C*D1*Ddd*f**3*r + 2360*C*D1*Ddd*f**3*s**2 + 700*C*D1*Ddd*f**3*s - 2470*C*D1*Ddd*f**3 - 18360*C*Dd**2*f**3*r**2 - 11280*C*Dd**2*f**3*r*s + 21180*C*Dd**2*f**3*r + 7080*C*Dd**2*f**3*s**2 + 2100*C*Dd**2*f**3*s - 4940*C*Dd**2*f**3 - 855*D1**2*K*bdd1*f**2*r**2 - 522*D1**2*K*bdd1*f**2*r*s + 1710*D1**2*K*bdd1*f**2*r + 333*D1**2*K*bdd1*f**2*s**2 + 522*D1**2*K*bdd1*f**2*s - 855*D1**2*K*bdd1*f**2 + 252*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1) + 350*D1**2*bdd1*f**3*r**2 + 280*D1**2*bdd1*f**3*r*s - 700*D1**2*bdd1*f**3*r - 70*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 420*D1**2*bdd1*f**3 + 1035*D1**2*bdd1*f**2*r**2 + 1062*D1**2*bdd1*f**2*r*s - 2070*D1**2*bdd1*f**2*r + 27*D1**2*bdd1*f**2*s**2 - 1062*D1**2*bdd1*f**2*s + 855*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r**2 - 1008*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 756*D1**2*bdd1*f*g2*s**2 + 1008*D1**2*bdd1*f*g2*s - 504*D1**2*bdd1*f*g2 + 2940*D1**2*f**3*fd*r**2 + 5600*D1**2*f**3*fd*r*s - 4340*D1**2*f**3*fd*r + 2660*D1**2*f**3*fd*s**2 - 4130*D1**2*f**3*fd*s + 2135*D1**2*f**3*fd - 3220*D1**2*f**3*fdd*r**2 - 5040*D1**2*f**3*fdd*r*s + 4480*D1**2*f**3*fdd*r - 1820*D1**2*f**3*fdd*s**2 + 3430*D1**2*f**3*fdd*s - 2065*D1**2*f**3*fdd - 9660*D1**2*f**2*fd**2*r**2 - 15120*D1**2*f**2*fd**2*r*s + 13440*D1**2*f**2*fd**2*r - 5460*D1**2*f**2*fd**2*s**2 + 10290*D1**2*f**2*fd**2*s - 4130*D1**2*f**2*fd**2 - 7350*D1**2*f**2*fd*r**2 - 7200*D1**2*f**2*fd*r*s + 7300*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 + 2300*D1**2*f**2*fd*s - 2400*D1**2*f**2*fd + 5430*D1**2*f**2*fdd*r**2 + 5760*D1**2*f**2*fdd*r*s - 5540*D1**2*f**2*fdd*r + 330*D1**2*f**2*fdd*s**2 - 2140*D1**2*f**2*fdd*s + 1920*D1**2*f**2*fdd - 2034*D1**2*f**2*gd2*r**2 - 828*D1**2*f**2*gd2*r*s + 4068*D1**2*f**2*gd2*r + 1206*D1**2*f**2*gd2*s**2 + 828*D1**2*f**2*gd2*s - 2034*D1**2*f**2*gd2 + 1710*D1**2*f**2*gdd2*r**2 + 1044*D1**2*f**2*gdd2*r*s - 3420*D1**2*f**2*gdd2*r - 666*D1**2*f**2*gdd2*s**2 - 1044*D1**2*f**2*gdd2*s + 1710*D1**2*f**2*gdd2 + 10860*D1**2*f*fd**2*r**2 + 11520*D1**2*f*fd**2*r*s - 11080*D1**2*f*fd**2*r + 660*D1**2*f*fd**2*s**2 - 4280*D1**2*f*fd**2*s + 1920*D1**2*f*fd**2 - 4068*D1**2*f*fd*g2*r**2 - 1656*D1**2*f*fd*g2*r*s + 828*D1**2*f*fd*g2*r + 2412*D1**2*f*fd*g2*s**2 - 2412*D1**2*f*fd*g2*s + 1206*D1**2*f*fd*g2 + 6840*D1**2*f*fd*gd2*r**2 + 4176*D1**2*f*fd*gd2*r*s - 7884*D1**2*f*fd*gd2*r - 2664*D1**2*f*fd*gd2*s**2 - 756*D1**2*f*fd*gd2*s + 1044*D1**2*f*fd*gd2 + 3420*D1**2*f*fdd*g2*r**2 + 2088*D1**2*f*fdd*g2*r*s - 1044*D1**2*f*fdd*g2*r - 1332*D1**2*f*fdd*g2*s**2 + 1332*D1**2*f*fdd*g2*s - 666*D1**2*f*fdd*g2 + 3420*D1**2*fd**2*g2*r**2 + 2088*D1**2*fd**2*g2*r*s - 1044*D1**2*fd**2*g2*r - 1332*D1**2*fd**2*g2*s**2 + 1332*D1**2*fd**2*g2*s + 2940*D1*Dd*f**4*r**2 + 5600*D1*Dd*f**4*r*s - 4340*D1*Dd*f**4*r + 2660*D1*Dd*f**4*s**2 - 4130*D1*Dd*f**4*s + 2135*D1*Dd*f**4 - 25760*D1*Dd*f**3*fd*r**2 - 40320*D1*Dd*f**3*fd*r*s + 35840*D1*Dd*f**3*fd*r - 14560*D1*Dd*f**3*fd*s**2 + 27440*D1*Dd*f**3*fd*s - 12390*D1*Dd*f**3*fd - 9800*D1*Dd*f**3*r**2 - 9600*D1*Dd*f**3*r*s + 12200*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 + 4700*D1*Dd*f**3*s - 4850*D1*Dd*f**3 + 43440*D1*Dd*f**2*fd*r**2 + 46080*D1*Dd*f**2*fd*r*s - 49640*D1*Dd*f**2*fd*r + 2640*D1*Dd*f**2*fd*s**2 - 20740*D1*Dd*f**2*fd*s + 13220*D1*Dd*f**2*fd - 8136*D1*Dd*f**2*g2*r**2 - 3312*D1*Dd*f**2*g2*r*s + 8964*D1*Dd*f**2*g2*r + 4824*D1*Dd*f**2*g2*s**2 - 756*D1*Dd*f**2*g2*s - 2862*D1*Dd*f**2*g2 + 13680*D1*Dd*f**2*gd2*r**2 + 8352*D1*Dd*f**2*gd2*r*s - 21564*D1*Dd*f**2*gd2*r - 5328*D1*Dd*f**2*gd2*s**2 - 4932*D1*Dd*f**2*gd2*s + 7884*D1*Dd*f**2*gd2 + 27360*D1*Dd*f*fd*g2*r**2 + 16704*D1*Dd*f*fd*g2*r*s - 19944*D1*Dd*f*fd*g2*r - 10656*D1*Dd*f*fd*g2*s**2 + 3816*D1*Dd*f*fd*g2*s + 756*D1*Dd*f*fd*g2 - 3220*D1*Ddd*f**4*r**2 - 5040*D1*Ddd*f**4*r*s + 4480*D1*Ddd*f**4*r - 1820*D1*Ddd*f**4*s**2 + 3430*D1*Ddd*f**4*s - 2065*D1*Ddd*f**4 + 7240*D1*Ddd*f**3*r**2 + 7680*D1*Ddd*f**3*r*s - 9160*D1*Ddd*f**3*r + 440*D1*Ddd*f**3*s**2 - 4060*D1*Ddd*f**3*s + 3730*D1*Ddd*f**3 + 6840*D1*Ddd*f**2*g2*r**2 + 4176*D1*Ddd*f**2*g2*r*s - 7884*D1*Ddd*f**2*g2*r - 2664*D1*Ddd*f**2*g2*s**2 - 756*D1*Ddd*f**2*g2*s + 2754*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-20*f**3*(26*r**2 + r*(19*s - 52) - 7*s**2 - 19*s + 33) - f**2*(360*C*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 2) - 9*K*(113*r**2 + 46*r*s - 226*r - 67*s**2 - 46*s + 113) - 140*fd*(15*r**2 + 2*r*(6*s - 11) - 3*s**2 - 7*s + 6) + 1125*r**2 + 738*r*s - 2250*r - 387*s**2 - 738*s + 765) + 18*f*(fd*(20*C*(2*r**2 + r*(8*s - 4) + 6*s**2 - 7*s + 1) + K*(-190*r**2 - 116*r*s + 219*r + 74*s**2 + 21*s - 29) + 230*r**2 + 236*r*s - 289*r + 6*s**2 - 121*s + 79) + 28*g2*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 2) - 28*gd2*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1)) - 504*fd*g2*(r**2 + r*(4*s - 2) + s*(3*s - 3))) + 2*Dd*f*(70*f**2*(20*r**2 + 16*r*(s - 2) - 4*s**2 - 11*s + 12) + 9*f*(20*C*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4) + K*(-380*r**2 - 232*r*s + 599*r + 148*s**2 + 137*s - 219) + 460*r**2 + 472*r*s - 749*r + 12*s**2 - 357*s + 289) - 252*g2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4))) - 9660*Dd**2*f**4*r**2 - 15120*Dd**2*f**4*r*s + 13440*Dd**2*f**4*r - 5460*Dd**2*f**4*s**2 + 10290*Dd**2*f**4*s - 4130*Dd**2*f**4 + 21720*Dd**2*f**3*r**2 + 23040*Dd**2*f**3*r*s - 27480*Dd**2*f**3*r + 1320*Dd**2*f**3*s**2 - 12180*Dd**2*f**3*s + 7460*Dd**2*f**3 + 20520*Dd**2*f**2*g2*r**2 + 12528*Dd**2*f**2*g2*r*s - 23652*Dd**2*f**2*g2*r - 7992*Dd**2*f**2*g2*s**2 - 2268*Dd**2*f**2*g2*s + 5508*Dd**2*f**2*g2 - 126*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + D1*(2*Dd*(f*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 14*s + 5) - fd*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3)) - Ddd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 14*s + 5)) - 2*Dd**2*f*(6*r**2 + 12*r*(2*s - 1) + 18*s**2 - 21*s + 5)) + b1*(-720*C*D1**2*f*fd*r**2 - 2880*C*D1**2*f*fd*r*s + 1440*C*D1**2*f*fd*r - 2160*C*D1**2*f*fd*s**2 + 2160*C*D1**2*f*fd*s - 720*C*D1**2*f*fd + 360*C*D1**2*f*fdd*r**2 + 1440*C*D1**2*f*fdd*r*s - 720*C*D1**2*f*fdd*r + 1080*C*D1**2*f*fdd*s**2 - 1080*C*D1**2*f*fdd*s + 360*C*D1**2*f*fdd + 360*C*D1**2*fd**2*r**2 + 1440*C*D1**2*fd**2*r*s - 720*C*D1**2*fd**2*r + 1080*C*D1**2*fd**2*s**2 - 1080*C*D1**2*fd**2*s + 360*C*D1**2*fd**2 - 1440*C*D1*Dd*f**2*r**2 - 5760*C*D1*Dd*f**2*r*s + 2880*C*D1*Dd*f**2*r - 4320*C*D1*Dd*f**2*s**2 + 5040*C*D1*Dd*f**2*s - 1800*C*D1*Dd*f**2 + 2880*C*D1*Dd*f*fd*r**2 + 11520*C*D1*Dd*f*fd*r*s - 5760*C*D1*Dd*f*fd*r + 8640*C*D1*Dd*f*fd*s**2 - 9360*C*D1*Dd*f*fd*s + 2520*C*D1*Dd*f*fd + 720*C*D1*Ddd*f**2*r**2 + 2880*C*D1*Ddd*f**2*r*s - 1440*C*D1*Ddd*f**2*r + 2160*C*D1*Ddd*f**2*s**2 - 2520*C*D1*Ddd*f**2*s + 900*C*D1*Ddd*f**2 + 2160*C*Dd**2*f**2*r**2 + 8640*C*Dd**2*f**2*r*s - 4320*C*Dd**2*f**2*r + 6480*C*Dd**2*f**2*s**2 - 7560*C*Dd**2*f**2*s + 1800*C*Dd**2*f**2 + 2034*D1**2*K*f*fd*r**2 + 828*D1**2*K*f*fd*r*s - 414*D1**2*K*f*fd*r - 1206*D1**2*K*f*fd*s**2 + 1206*D1**2*K*f*fd*s - 603*D1**2*K*f*fd - 1710*D1**2*K*f*fdd*r**2 - 1044*D1**2*K*f*fdd*r*s + 522*D1**2*K*f*fdd*r + 666*D1**2*K*f*fdd*s**2 - 666*D1**2*K*f*fdd*s + 333*D1**2*K*f*fdd - 1710*D1**2*K*fd**2*r**2 - 1044*D1**2*K*fd**2*r*s + 522*D1**2*K*fd**2*r + 666*D1**2*K*fd**2*s**2 - 666*D1**2*K*fd**2*s + 126*D1**2*bdd1*f*(K - 1)*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) - 1560*D1**2*f**2*fd*r**2 - 1140*D1**2*f**2*fd*r*s + 1420*D1**2*f**2*fd*r + 420*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 240*D1**2*f**2*fd + 1050*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 980*D1**2*f**2*fdd*r - 210*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 210*D1**2*f**2*fdd + 2100*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1960*D1**2*f*fd**2*r - 420*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s + 420*D1**2*f*fd**2 - 2250*D1**2*f*fd*r**2 - 1476*D1**2*f*fd*r*s + 738*D1**2*f*fd*r + 774*D1**2*f*fd*s**2 - 774*D1**2*f*fd*s + 27*D1**2*f*fd + 2070*D1**2*f*fdd*r**2 + 2124*D1**2*f*fdd*r*s - 1062*D1**2*f*fdd*r + 54*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 207*D1**2*f*fdd + 504*D1**2*f*gd2*r**2 + 2016*D1**2*f*gd2*r*s - 1008*D1**2*f*gd2*r + 1512*D1**2*f*gd2*s**2 - 2016*D1**2*f*gd2*s + 504*D1**2*f*gd2 - 252*D1**2*f*gdd2*r**2 - 1008*D1**2*f*gdd2*r*s + 504*D1**2*f*gdd2*r - 756*D1**2*f*gdd2*s**2 + 1008*D1**2*f*gdd2*s - 252*D1**2*f*gdd2 + 2070*D1**2*fd**2*r**2 + 2124*D1**2*fd**2*r*s - 1062*D1**2*fd**2*r + 54*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s - 360*D1**2*fd**2 + 504*D1**2*fd*g2*r**2 + 2016*D1**2*fd*g2*r*s - 1008*D1**2*fd*g2*r + 1512*D1**2*fd*g2*s**2 - 1008*D1**2*fd*g2*s + 504*D1**2*fd*g2 - 504*D1**2*fd*gd2*r**2 - 2016*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 1512*D1**2*fd*gd2*s**2 + 1512*D1**2*fd*gd2*s - 504*D1**2*fd*gd2 - 252*D1**2*fdd*g2*r**2 - 1008*D1**2*fdd*g2*r*s + 504*D1**2*fdd*g2*r - 756*D1**2*fdd*g2*s**2 + 504*D1**2*fdd*g2*s - 252*D1**2*fdd*g2 + 4068*D1*Dd*K*f**2*r**2 + 1656*D1*Dd*K*f**2*r*s - 4482*D1*Dd*K*f**2*r - 2412*D1*Dd*K*f**2*s**2 + 378*D1*Dd*K*f**2*s + 1431*D1*Dd*K*f**2 - 13680*D1*Dd*K*f*fd*r**2 - 8352*D1*Dd*K*f*fd*r*s + 9972*D1*Dd*K*f*fd*r + 5328*D1*Dd*K*f*fd*s**2 - 1908*D1*Dd*K*f*fd*s - 378*D1*Dd*K*f*fd - 2080*D1*Dd*f**3*r**2 - 1520*D1*Dd*f**3*r*s + 2460*D1*Dd*f**3*r + 560*D1*Dd*f**3*s**2 + 480*D1*Dd*f**3*s - 900*D1*Dd*f**3 + 8400*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 8960*D1*Dd*f**2*fd*r - 1680*D1*Dd*f**2*fd*s**2 - 1820*D1*Dd*f**2*fd*s + 2100*D1*Dd*f**2*fd - 4500*D1*Dd*f**2*r**2 - 2952*D1*Dd*f**2*r*s + 5238*D1*Dd*f**2*r + 1548*D1*Dd*f**2*s**2 + 702*D1*Dd*f**2*s - 1863*D1*Dd*f**2 + 16560*D1*Dd*f*fd*r**2 + 16992*D1*Dd*f*fd*r*s - 14652*D1*Dd*f*fd*r + 432*D1*Dd*f*fd*s**2 - 4572*D1*Dd*f*fd*s + 2178*D1*Dd*f*fd + 2016*D1*Dd*f*g2*r**2 + 8064*D1*Dd*f*g2*r*s - 4032*D1*Dd*f*g2*r + 6048*D1*Dd*f*g2*s**2 - 7056*D1*Dd*f*g2*s + 2520*D1*Dd*f*g2 - 2016*D1*Dd*f*gd2*r**2 - 8064*D1*Dd*f*gd2*r*s + 4032*D1*Dd*f*gd2*r - 6048*D1*Dd*f*gd2*s**2 + 7560*D1*Dd*f*gd2*s - 2016*D1*Dd*f*gd2 - 2016*D1*Dd*fd*g2*r**2 - 8064*D1*Dd*fd*g2*r*s + 4032*D1*Dd*fd*g2*r - 6048*D1*Dd*fd*g2*s**2 + 5544*D1*Dd*fd*g2*s - 1512*D1*Dd*fd*g2 - 3420*D1*Ddd*K*f**2*r**2 - 2088*D1*Ddd*K*f**2*r*s + 3942*D1*Ddd*K*f**2*r + 1332*D1*Ddd*K*f**2*s**2 + 378*D1*Ddd*K*f**2*s - 1377*D1*Ddd*K*f**2 + 1400*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 1680*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s**2 - 420*D1*Ddd*f**3*s + 630*D1*Ddd*f**3 + 4140*D1*Ddd*f**2*r**2 + 4248*D1*Ddd*f**2*r*s - 5202*D1*Ddd*f**2*r + 108*D1*Ddd*f**2*s**2 - 2178*D1*Ddd*f**2*s + 2097*D1*Ddd*f**2 - 1008*D1*Ddd*f*g2*r**2 - 4032*D1*Ddd*f*g2*r*s + 2016*D1*Ddd*f*g2*r - 3024*D1*Ddd*f*g2*s**2 + 3528*D1*Ddd*f*g2*s - 1260*D1*Ddd*f*g2 - 252*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) - fd*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 6*s + 1)) - 2*Dd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4)) - 10260*Dd**2*K*f**2*r**2 - 6264*Dd**2*K*f**2*r*s + 11826*Dd**2*K*f**2*r + 3996*Dd**2*K*f**2*s**2 + 1134*Dd**2*K*f**2*s - 2754*Dd**2*K*f**2 + 4200*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 5040*Dd**2*f**3*r - 840*Dd**2*f**3*s**2 - 1260*Dd**2*f**3*s + 1260*Dd**2*f**3 + 12420*Dd**2*f**2*r**2 + 12744*Dd**2*f**2*r*s - 15606*Dd**2*f**2*r + 324*Dd**2*f**2*s**2 - 6534*Dd**2*f**2*s + 4194*Dd**2*f**2 - 3024*Dd**2*f*g2*r**2 - 12096*Dd**2*f*g2*r*s + 6048*Dd**2*f*g2*r - 9072*Dd**2*f*g2*s**2 + 10584*Dd**2*f*g2*s - 2520*Dd**2*f*g2))/(315*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**6*k1**2*st**2*(D1**2*(196*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 3*f**2*(392*fd**2*s*(2*s - 1) - fd*(220*C - 220)*(3*s**2 - 2*s + 1) + fdd*(110*C - 110)*(3*s**2 - 2*s + 1) + s**2*(99*K*bdd1 - 198*bd1*(K - 1) - 99*bdd1 + 396*gd2 - 198*gdd2)) - 66*f*(fd**2*s*(10*C - 10)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 1188*fd**2*g2*s*(s - 1)) + 2*D1*f*(Dd*(196*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(165*C*(4*s**2 - 2*s + 1) - 98*fd*(1 - 4*s)**2 - 660*s**2 + 330*s - 165) - 33*f*(fd*(10*C - 10)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 594*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(98*f**2 + f*(165*C - 165) - 297*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(2*s - 1)*(98*f**2 + f*(165*C - 165) - 297*g2) + 297*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k3**4) - 4*D1**2*Pk2*Pk3*ct**6*k1**2*(D1**2*(252*bd1*fd*g2*s*(s - 1) + f**3*s**2*(210*bd1 - 105*bdd1) - 10*f**2*(C*s**2*(-18*bd1 + 9*bdd1) + 7*fd*(s**2*(9*bd1 - 6) + s*(4 - 3*bd1) - 2) + 7*fdd*(3*s**2 - 2*s + 1)) - 2*f*s*(63*bd1**2*s*(K - 1) + 18*bd1*(5*C*fd*(2*s - 1) + s*(7*g2 - 7*gd2)) - 63*bdd1*g2*s - 7*fd**2*(20 - 30*s))) - 2*D1*f*(Dd*(126*bd1*g2*s*(1 - 4*s) + 35*f**2*(s**2*(12*bd1 - 8) + s*(4 - 3*bd1) - 2) + 10*f*(4*s - 1)*(9*C*bd1*s + 7*fd*(3*s - 1))) + 35*Ddd*f**2*(4*s**2 - 2*s + 1)) + 420*Dd**2*f**3*s*(1 - 2*s) + 63*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(30*C*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + 7*D1**2*(5*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) - 2*f*s*(5*fd**2*(3*s - 2) + s*(3*K*bdd1 - 6*bd1*(K - 1) - 3*bdd1 + 6*gd2 - 3*gdd2)) + (6 - 6*s)*(2*fd*g2*(s - 1) - 2*fd*s*(-K*bd1 + bd1 + gd2) - fdd*g2*(s - 1))) + 7*D1*(2*Dd*(5*f**3*(4*s**2 - 2*s + 1) - 5*f**2*fd*(12*s**2 - 7*s + 1) - 6*f*g2*(4*s**2 - 2*s + 1) + 6*f*s*(4*s - 1)*(-K*bd1 + bd1 + gd2) + 6*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f**2 - 6*g2)*(4*s**2 - 2*s + 1)) - 42*Dd**2*f*s*(5*f**2 - 6*g2)*(2*s - 1)))/(105*d**2*k2**2*k3**2) - 4*D1**2*Pk2*Pk3*ct**6*k2**6*(D1**2*(f**2*(fd*(28*C - 14)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(14*C - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-9*K*(-2*bd1 + bdd1) - 36*gd2 + 18*gdd2)) + f*(-fd**2*(28*C - 14)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 18*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 18*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(14*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(7 - 14*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 18*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 18*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 9*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(14*C*f + 9*K*b1 - 7*f - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(14*C*f + 9*K*b1 - 7*f - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(21*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**6*k2**4*(348*C*D1**2*f**2*fd*r**2 + 432*C*D1**2*f**2*fd*r*s - 376*C*D1**2*f**2*fd*r + 84*C*D1**2*f**2*fd*s**2 - 200*C*D1**2*f**2*fd*s + 144*C*D1**2*f**2*fd - 174*C*D1**2*f**2*fdd*r**2 - 216*C*D1**2*f**2*fdd*r*s + 188*C*D1**2*f**2*fdd*r - 42*C*D1**2*f**2*fdd*s**2 + 100*C*D1**2*f**2*fdd*s - 72*C*D1**2*f**2*fdd - 348*C*D1**2*f*fd**2*r**2 - 432*C*D1**2*f*fd**2*r*s + 376*C*D1**2*f*fd**2*r - 84*C*D1**2*f*fd**2*s**2 + 200*C*D1**2*f*fd**2*s - 72*C*D1**2*f*fd**2 + 464*C*D1*Dd*f**3*r**2 + 576*C*D1*Dd*f**3*r*s - 608*C*D1*Dd*f**3*r + 112*C*D1*Dd*f**3*s**2 - 344*C*D1*Dd*f**3*s + 260*C*D1*Dd*f**3 - 1392*C*D1*Dd*f**2*fd*r**2 - 1728*C*D1*Dd*f**2*fd*r*s + 1664*C*D1*Dd*f**2*fd*r - 336*C*D1*Dd*f**2*fd*s**2 + 916*C*D1*Dd*f**2*fd*s - 476*C*D1*Dd*f**2*fd - 232*C*D1*Ddd*f**3*r**2 - 288*C*D1*Ddd*f**3*r*s + 304*C*D1*Ddd*f**3*r - 56*C*D1*Ddd*f**3*s**2 + 172*C*D1*Ddd*f**3*s - 130*C*D1*Ddd*f**3 - 696*C*Dd**2*f**3*r**2 - 864*C*Dd**2*f**3*r*s + 912*C*Dd**2*f**3*r - 168*C*Dd**2*f**3*s**2 + 516*C*Dd**2*f**3*s - 260*C*Dd**2*f**3 + 108*D1**2*K*b1*f*fd*r**2 + 144*D1**2*K*b1*f*fd*r*s - 72*D1**2*K*b1*f*fd*r + 36*D1**2*K*b1*f*fd*s**2 - 36*D1**2*K*b1*f*fd*s + 18*D1**2*K*b1*f*fd - 54*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*r*s + 36*D1**2*K*b1*f*fdd*r - 18*D1**2*K*b1*f*fdd*s**2 + 18*D1**2*K*b1*f*fdd*s - 9*D1**2*K*b1*f*fdd - 54*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*r*s + 36*D1**2*K*b1*fd**2*r - 18*D1**2*K*b1*fd**2*s**2 + 18*D1**2*K*b1*fd**2*s - 27*D1**2*K*bdd1*f**2*r**2 - 36*D1**2*K*bdd1*f**2*r*s + 54*D1**2*K*bdd1*f**2*r - 9*D1**2*K*bdd1*f**2*s**2 + 36*D1**2*K*bdd1*f**2*s - 27*D1**2*K*bdd1*f**2 - 27*D1**2*b1*f**2*fd*r**2 - 27*D1**2*b1*f**2*fd*r*s + 27*D1**2*b1*f**2*fd*r + 9*D1**2*b1*f**2*fd*s - 9*D1**2*b1*f**2*fd + 27*D1**2*b1*f**2*fdd*r**2 + 27*D1**2*b1*f**2*fdd*r*s - 27*D1**2*b1*f**2*fdd*r - 9*D1**2*b1*f**2*fdd*s + 9*D1**2*b1*f**2*fdd + 54*D1**2*b1*f*fd**2*r**2 + 54*D1**2*b1*f*fd**2*r*s - 54*D1**2*b1*f*fd**2*r - 18*D1**2*b1*f*fd**2*s + 9*D1**2*b1*f*fd**2 - 36*D1**2*b1*f*fd*r**2 - 36*D1**2*b1*f*fd*r*s + 18*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 18*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r + 36*D1**2*b2*f*fd*r**2 + 72*D1**2*b2*f*fd*r*s - 36*D1**2*b2*f*fd*r + 36*D1**2*b2*f*fd*s**2 - 36*D1**2*b2*f*fd*s + 18*D1**2*b2*f*fd - 18*D1**2*b2*f*fdd*r**2 - 36*D1**2*b2*f*fdd*r*s + 18*D1**2*b2*f*fdd*r - 18*D1**2*b2*f*fdd*s**2 + 18*D1**2*b2*f*fdd*s - 9*D1**2*b2*f*fdd - 18*D1**2*b2*fd**2*r**2 - 36*D1**2*b2*fd**2*r*s + 18*D1**2*b2*fd**2*r - 18*D1**2*b2*fd**2*s**2 + 18*D1**2*b2*fd**2*s + 9*D1**2*bdd1*f**3*r**2 + 9*D1**2*bdd1*f**3*r*s - 18*D1**2*bdd1*f**3*r - 9*D1**2*bdd1*f**3*s + 9*D1**2*bdd1*f**3 + 9*D1**2*bdd1*f**2*r**2 + 9*D1**2*bdd1*f**2*r*s - 18*D1**2*bdd1*f**2*r - 9*D1**2*bdd1*f**2*s + 9*D1**2*bdd1*f**2 - 9*D1**2*bdd2*f**2*r**2 - 18*D1**2*bdd2*f**2*r*s + 18*D1**2*bdd2*f**2*r - 9*D1**2*bdd2*f**2*s**2 + 18*D1**2*bdd2*f**2*s - 9*D1**2*bdd2*f**2 - 240*D1**2*f**2*fd*r**2 - 282*D1**2*f**2*fd*r*s + 254*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 122*D1**2*f**2*fd*s - 94*D1**2*f**2*fd + 120*D1**2*f**2*fdd*r**2 + 141*D1**2*f**2*fdd*r*s - 127*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s**2 - 61*D1**2*f**2*fdd*s + 47*D1**2*f**2*fdd - 108*D1**2*f**2*gd2*r**2 - 144*D1**2*f**2*gd2*r*s + 216*D1**2*f**2*gd2*r - 36*D1**2*f**2*gd2*s**2 + 144*D1**2*f**2*gd2*s - 108*D1**2*f**2*gd2 + 54*D1**2*f**2*gdd2*r**2 + 72*D1**2*f**2*gdd2*r*s - 108*D1**2*f**2*gdd2*r + 18*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2*s + 54*D1**2*f**2*gdd2 + 240*D1**2*f*fd**2*r**2 + 282*D1**2*f*fd**2*r*s - 254*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s**2 - 122*D1**2*f*fd**2*s + 47*D1**2*f*fd**2 - 216*D1**2*f*fd*g2*r**2 - 288*D1**2*f*fd*g2*r*s + 144*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 72*D1**2*f*fd*g2*s - 36*D1**2*f*fd*g2 + 216*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r*s - 288*D1**2*f*fd*gd2*r + 72*D1**2*f*fd*gd2*s**2 - 180*D1**2*f*fd*gd2*s + 72*D1**2*f*fd*gd2 + 108*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*r*s - 72*D1**2*f*fdd*g2*r + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 108*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*r*s - 72*D1**2*fd**2*g2*r + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 216*D1*Dd*K*b1*f**2*r**2 + 288*D1*Dd*K*b1*f**2*r*s - 288*D1*Dd*K*b1*f**2*r + 72*D1*Dd*K*b1*f**2*s**2 - 180*D1*Dd*K*b1*f**2*s + 126*D1*Dd*K*b1*f**2 - 432*D1*Dd*K*b1*f*fd*r**2 - 576*D1*Dd*K*b1*f*fd*r*s + 432*D1*Dd*K*b1*f*fd*r - 144*D1*Dd*K*b1*f*fd*s**2 + 252*D1*Dd*K*b1*f*fd*s - 90*D1*Dd*K*b1*f*fd - 36*D1*Dd*b1*f**3*r**2 - 36*D1*Dd*b1*f**3*r*s + 45*D1*Dd*b1*f**3*r + 18*D1*Dd*b1*f**3*s - 18*D1*Dd*b1*f**3 + 216*D1*Dd*b1*f**2*fd*r**2 + 216*D1*Dd*b1*f**2*fd*r*s - 243*D1*Dd*b1*f**2*fd*r - 90*D1*Dd*b1*f**2*fd*s + 63*D1*Dd*b1*f**2*fd - 72*D1*Dd*b1*f**2*r**2 - 72*D1*Dd*b1*f**2*r*s + 90*D1*Dd*b1*f**2*r + 36*D1*Dd*b1*f**2*s - 36*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 126*D1*Dd*b1*f*fd*r - 36*D1*Dd*b1*f*fd*s + 18*D1*Dd*b1*f*fd + 72*D1*Dd*b2*f**2*r**2 + 144*D1*Dd*b2*f**2*r*s - 108*D1*Dd*b2*f**2*r + 72*D1*Dd*b2*f**2*s**2 - 108*D1*Dd*b2*f**2*s + 54*D1*Dd*b2*f**2 - 144*D1*Dd*b2*f*fd*r**2 - 288*D1*Dd*b2*f*fd*r*s + 180*D1*Dd*b2*f*fd*r - 144*D1*Dd*b2*f*fd*s**2 + 180*D1*Dd*b2*f*fd*s - 54*D1*Dd*b2*f*fd - 320*D1*Dd*f**3*r**2 - 376*D1*Dd*f**3*r*s + 414*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 216*D1*Dd*f**3*s - 174*D1*Dd*f**3 + 960*D1*Dd*f**2*fd*r**2 + 1128*D1*Dd*f**2*fd*r*s - 1129*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s**2 - 568*D1*Dd*f**2*fd*s + 315*D1*Dd*f**2*fd - 432*D1*Dd*f**2*g2*r**2 - 576*D1*Dd*f**2*g2*r*s + 576*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 360*D1*Dd*f**2*g2*s - 252*D1*Dd*f**2*g2 + 432*D1*Dd*f**2*gd2*r**2 + 576*D1*Dd*f**2*gd2*r*s - 720*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s**2 - 468*D1*Dd*f**2*gd2*s + 288*D1*Dd*f**2*gd2 + 864*D1*Dd*f*fd*g2*r**2 + 1152*D1*Dd*f*fd*g2*r*s - 864*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s**2 - 504*D1*Dd*f*fd*g2*s + 180*D1*Dd*f*fd*g2 - 108*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r*s + 144*D1*Ddd*K*b1*f**2*r - 36*D1*Ddd*K*b1*f**2*s**2 + 90*D1*Ddd*K*b1*f**2*s - 63*D1*Ddd*K*b1*f**2 + 36*D1*Ddd*b1*f**3*r**2 + 36*D1*Ddd*b1*f**3*r*s - 45*D1*Ddd*b1*f**3*r - 18*D1*Ddd*b1*f**3*s + 18*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 45*D1*Ddd*b1*f**2*r - 18*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 - 36*D1*Ddd*b2*f**2*r**2 - 72*D1*Ddd*b2*f**2*r*s + 54*D1*Ddd*b2*f**2*r - 36*D1*Ddd*b2*f**2*s**2 + 54*D1*Ddd*b2*f**2*s - 27*D1*Ddd*b2*f**2 + 160*D1*Ddd*f**3*r**2 + 188*D1*Ddd*f**3*r*s - 207*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 108*D1*Ddd*f**3*s + 87*D1*Ddd*f**3 + 216*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r*s - 288*D1*Ddd*f**2*g2*r + 72*D1*Ddd*f**2*g2*s**2 - 180*D1*Ddd*f**2*g2*s + 126*D1*Ddd*f**2*g2 - 9*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (2*r + 2*s - 2)*(K*(3*r + s - 3) - r + 1)) + fd*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(2*K*(12*r**2 + 4*r*(4*s - 5) + 4*s**2 - 13*s + 8) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) + 18*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 324*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r*s + 432*Dd**2*K*b1*f**2*r - 108*Dd**2*K*b1*f**2*s**2 + 270*Dd**2*K*b1*f**2*s - 126*Dd**2*K*b1*f**2 + 108*Dd**2*b1*f**3*r**2 + 108*Dd**2*b1*f**3*r*s - 135*Dd**2*b1*f**3*r - 54*Dd**2*b1*f**3*s + 36*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 135*Dd**2*b1*f**2*r - 54*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 - 108*Dd**2*b2*f**2*r**2 - 216*Dd**2*b2*f**2*r*s + 162*Dd**2*b2*f**2*r - 108*Dd**2*b2*f**2*s**2 + 162*Dd**2*b2*f**2*s - 54*Dd**2*b2*f**2 + 480*Dd**2*f**3*r**2 + 564*Dd**2*f**3*r*s - 621*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 324*Dd**2*f**3*s + 174*Dd**2*f**3 + 648*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r*s - 864*Dd**2*f**2*g2*r + 216*Dd**2*f**2*g2*s**2 - 540*Dd**2*f**2*g2*s + 252*Dd**2*f**2*g2)/(63*d**2*k3**6) - 12*D1**2*Pk2*Pk3*ct**5*f**2*k1**5*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(11*d**2*k2**3*k3**4) + D1**2*Pk2*Pk3*ct**5*f*k2**5*(32*C - 16)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4))/(63*d**2*k1*k3**6) - 4*D1**2*Pk2*Pk3*ct**5*k1**5*k2*(6600*C*D1**2*f**2*fd*r**2 + 13200*C*D1**2*f**2*fd*r*s - 8800*C*D1**2*f**2*fd*r + 6600*C*D1**2*f**2*fd*s**2 - 8800*C*D1**2*f**2*fd*s + 4400*C*D1**2*f**2*fd - 9240*C*D1**2*f**2*fdd*r**2 - 18480*C*D1**2*f**2*fdd*r*s + 12320*C*D1**2*f**2*fdd*r - 9240*C*D1**2*f**2*fdd*s**2 + 12320*C*D1**2*f**2*fdd*s - 6160*C*D1**2*f**2*fdd - 18480*C*D1**2*f*fd**2*r**2 - 36960*C*D1**2*f*fd**2*r*s + 24640*C*D1**2*f*fd**2*r - 18480*C*D1**2*f*fd**2*s**2 + 24640*C*D1**2*f*fd**2*s - 6160*C*D1**2*f*fd**2 + 8800*C*D1*Dd*f**3*r**2 + 17600*C*D1*Dd*f**3*r*s - 13200*C*D1*Dd*f**3*r + 8800*C*D1*Dd*f**3*s**2 - 13200*C*D1*Dd*f**3*s + 6600*C*D1*Dd*f**3 - 73920*C*D1*Dd*f**2*fd*r**2 - 147840*C*D1*Dd*f**2*fd*r*s + 104720*C*D1*Dd*f**2*fd*r - 73920*C*D1*Dd*f**2*fd*s**2 + 104720*C*D1*Dd*f**2*fd*s - 36960*C*D1*Dd*f**2*fd - 12320*C*D1*Ddd*f**3*r**2 - 24640*C*D1*Ddd*f**3*r*s + 18480*C*D1*Ddd*f**3*r - 12320*C*D1*Ddd*f**3*s**2 + 18480*C*D1*Ddd*f**3*s - 9240*C*D1*Ddd*f**3 - 36960*C*Dd**2*f**3*r**2 - 73920*C*Dd**2*f**3*r*s + 55440*C*Dd**2*f**3*r - 36960*C*Dd**2*f**3*s**2 + 55440*C*Dd**2*f**3*s - 18480*C*Dd**2*f**3 + 2376*D1**2*K*b1*f*fd*r**2 + 4752*D1**2*K*b1*f*fd*r*s - 2376*D1**2*K*b1*f*fd*r + 2376*D1**2*K*b1*f*fd*s**2 - 2376*D1**2*K*b1*f*fd*s + 1188*D1**2*K*b1*f*fd - 3960*D1**2*K*b1*f*fdd*r**2 - 7920*D1**2*K*b1*f*fdd*r*s + 3960*D1**2*K*b1*f*fdd*r - 3960*D1**2*K*b1*f*fdd*s**2 + 3960*D1**2*K*b1*f*fdd*s - 1980*D1**2*K*b1*f*fdd - 3960*D1**2*K*b1*fd**2*r**2 - 7920*D1**2*K*b1*fd**2*r*s + 3960*D1**2*K*b1*fd**2*r - 3960*D1**2*K*b1*fd**2*s**2 + 3960*D1**2*K*b1*fd**2*s - 2376*D1**2*b1*f*fd*r**2 - 4752*D1**2*b1*f*fd*r*s + 2376*D1**2*b1*f*fd*r - 2376*D1**2*b1*f*fd*s**2 + 2376*D1**2*b1*f*fd*s - 1188*D1**2*b1*f*fd + 3960*D1**2*b1*f*fdd*r**2 + 7920*D1**2*b1*f*fdd*r*s - 3960*D1**2*b1*f*fdd*r + 3960*D1**2*b1*f*fdd*s**2 - 3960*D1**2*b1*f*fdd*s + 1980*D1**2*b1*f*fdd + 3960*D1**2*b1*fd**2*r**2 + 7920*D1**2*b1*fd**2*r*s - 3960*D1**2*b1*fd**2*r + 3960*D1**2*b1*fd**2*s**2 - 3960*D1**2*b1*fd**2*s - 1980*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 11340*D1**2*f**3*fd*r**2 + 22680*D1**2*f**3*fd*r*s - 17010*D1**2*f**3*fd*r + 11340*D1**2*f**3*fd*s**2 - 17010*D1**2*f**3*fd*s + 8505*D1**2*f**3*fd - 12600*D1**2*f**3*fdd*r**2 - 25200*D1**2*f**3*fdd*r*s + 18900*D1**2*f**3*fdd*r - 12600*D1**2*f**3*fdd*s**2 + 18900*D1**2*f**3*fdd*s - 9450*D1**2*f**3*fdd - 37800*D1**2*f**2*fd**2*r**2 - 75600*D1**2*f**2*fd**2*r*s + 56700*D1**2*f**2*fd**2*r - 37800*D1**2*f**2*fd**2*s**2 + 56700*D1**2*f**2*fd**2*s - 18900*D1**2*f**2*fd**2 - 6600*D1**2*f**2*fd*r**2 - 13200*D1**2*f**2*fd*r*s + 8800*D1**2*f**2*fd*r - 6600*D1**2*f**2*fd*s**2 + 8800*D1**2*f**2*fd*s - 4400*D1**2*f**2*fd + 9240*D1**2*f**2*fdd*r**2 + 18480*D1**2*f**2*fdd*r*s - 12320*D1**2*f**2*fdd*r + 9240*D1**2*f**2*fdd*s**2 - 12320*D1**2*f**2*fdd*s + 6160*D1**2*f**2*fdd - 2376*D1**2*f**2*gd2*r**2 - 4752*D1**2*f**2*gd2*r*s + 4752*D1**2*f**2*gd2*r - 2376*D1**2*f**2*gd2*s**2 + 4752*D1**2*f**2*gd2*s - 2376*D1**2*f**2*gd2 + 3960*D1**2*f**2*gdd2*r**2 + 7920*D1**2*f**2*gdd2*r*s - 7920*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 7920*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 + 18480*D1**2*f*fd**2*r**2 + 36960*D1**2*f*fd**2*r*s - 24640*D1**2*f*fd**2*r + 18480*D1**2*f*fd**2*s**2 - 24640*D1**2*f*fd**2*s + 6160*D1**2*f*fd**2 - 4752*D1**2*f*fd*g2*r**2 - 9504*D1**2*f*fd*g2*r*s + 4752*D1**2*f*fd*g2*r - 4752*D1**2*f*fd*g2*s**2 + 4752*D1**2*f*fd*g2*s - 2376*D1**2*f*fd*g2 + 15840*D1**2*f*fd*gd2*r**2 + 31680*D1**2*f*fd*gd2*r*s - 23760*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 23760*D1**2*f*fd*gd2*s + 7920*D1**2*f*fd*gd2 + 7920*D1**2*f*fdd*g2*r**2 + 15840*D1**2*f*fdd*g2*r*s - 7920*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 7920*D1**2*f*fdd*g2*s + 3960*D1**2*f*fdd*g2 + 7920*D1**2*fd**2*g2*r**2 + 15840*D1**2*fd**2*g2*r*s - 7920*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 7920*D1**2*fd**2*g2*s + 4752*D1*Dd*K*b1*f**2*r**2 + 9504*D1*Dd*K*b1*f**2*r*s - 7128*D1*Dd*K*b1*f**2*r + 4752*D1*Dd*K*b1*f**2*s**2 - 7128*D1*Dd*K*b1*f**2*s + 3564*D1*Dd*K*b1*f**2 - 31680*D1*Dd*K*b1*f*fd*r**2 - 63360*D1*Dd*K*b1*f*fd*r*s + 39600*D1*Dd*K*b1*f*fd*r - 31680*D1*Dd*K*b1*f*fd*s**2 + 39600*D1*Dd*K*b1*f*fd*s - 11880*D1*Dd*K*b1*f*fd - 4752*D1*Dd*b1*f**2*r**2 - 9504*D1*Dd*b1*f**2*r*s + 7128*D1*Dd*b1*f**2*r - 4752*D1*Dd*b1*f**2*s**2 + 7128*D1*Dd*b1*f**2*s - 3564*D1*Dd*b1*f**2 + 31680*D1*Dd*b1*f*fd*r**2 + 63360*D1*Dd*b1*f*fd*r*s - 39600*D1*Dd*b1*f*fd*r + 31680*D1*Dd*b1*f*fd*s**2 - 39600*D1*Dd*b1*f*fd*s + 11880*D1*Dd*b1*f*fd + 11340*D1*Dd*f**4*r**2 + 22680*D1*Dd*f**4*r*s - 17010*D1*Dd*f**4*r + 11340*D1*Dd*f**4*s**2 - 17010*D1*Dd*f**4*s + 8505*D1*Dd*f**4 - 100800*D1*Dd*f**3*fd*r**2 - 201600*D1*Dd*f**3*fd*r*s + 151200*D1*Dd*f**3*fd*r - 100800*D1*Dd*f**3*fd*s**2 + 151200*D1*Dd*f**3*fd*s - 56700*D1*Dd*f**3*fd - 8800*D1*Dd*f**3*r**2 - 17600*D1*Dd*f**3*r*s + 13200*D1*Dd*f**3*r - 8800*D1*Dd*f**3*s**2 + 13200*D1*Dd*f**3*s - 6600*D1*Dd*f**3 + 73920*D1*Dd*f**2*fd*r**2 + 147840*D1*Dd*f**2*fd*r*s - 104720*D1*Dd*f**2*fd*r + 73920*D1*Dd*f**2*fd*s**2 - 104720*D1*Dd*f**2*fd*s + 36960*D1*Dd*f**2*fd - 9504*D1*Dd*f**2*g2*r**2 - 19008*D1*Dd*f**2*g2*r*s + 14256*D1*Dd*f**2*g2*r - 9504*D1*Dd*f**2*g2*s**2 + 14256*D1*Dd*f**2*g2*s - 7128*D1*Dd*f**2*g2 + 31680*D1*Dd*f**2*gd2*r**2 + 63360*D1*Dd*f**2*gd2*r*s - 55440*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 55440*D1*Dd*f**2*gd2*s + 23760*D1*Dd*f**2*gd2 + 63360*D1*Dd*f*fd*g2*r**2 + 126720*D1*Dd*f*fd*g2*r*s - 79200*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 79200*D1*Dd*f*fd*g2*s + 23760*D1*Dd*f*fd*g2 - 7920*D1*Ddd*K*b1*f**2*r**2 - 15840*D1*Ddd*K*b1*f**2*r*s + 11880*D1*Ddd*K*b1*f**2*r - 7920*D1*Ddd*K*b1*f**2*s**2 + 11880*D1*Ddd*K*b1*f**2*s - 5940*D1*Ddd*K*b1*f**2 + 7920*D1*Ddd*b1*f**2*r**2 + 15840*D1*Ddd*b1*f**2*r*s - 11880*D1*Ddd*b1*f**2*r + 7920*D1*Ddd*b1*f**2*s**2 - 11880*D1*Ddd*b1*f**2*s + 5940*D1*Ddd*b1*f**2 - 12600*D1*Ddd*f**4*r**2 - 25200*D1*Ddd*f**4*r*s + 18900*D1*Ddd*f**4*r - 12600*D1*Ddd*f**4*s**2 + 18900*D1*Ddd*f**4*s - 9450*D1*Ddd*f**4 + 12320*D1*Ddd*f**3*r**2 + 24640*D1*Ddd*f**3*r*s - 18480*D1*Ddd*f**3*r + 12320*D1*Ddd*f**3*s**2 - 18480*D1*Ddd*f**3*s + 9240*D1*Ddd*f**3 + 15840*D1*Ddd*f**2*g2*r**2 + 31680*D1*Ddd*f**2*g2*r*s - 23760*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 23760*D1*Ddd*f**2*g2*s + 11880*D1*Ddd*f**2*g2 + 396*D1*bd1*f*(K - 1)*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 23760*Dd**2*K*b1*f**2*r**2 - 47520*Dd**2*K*b1*f**2*r*s + 35640*Dd**2*K*b1*f**2*r - 23760*Dd**2*K*b1*f**2*s**2 + 35640*Dd**2*K*b1*f**2*s - 11880*Dd**2*K*b1*f**2 + 23760*Dd**2*b1*f**2*r**2 + 47520*Dd**2*b1*f**2*r*s - 35640*Dd**2*b1*f**2*r + 23760*Dd**2*b1*f**2*s**2 - 35640*Dd**2*b1*f**2*s + 11880*Dd**2*b1*f**2 - 37800*Dd**2*f**4*r**2 - 75600*Dd**2*f**4*r*s + 56700*Dd**2*f**4*r - 37800*Dd**2*f**4*s**2 + 56700*Dd**2*f**4*s - 18900*Dd**2*f**4 + 36960*Dd**2*f**3*r**2 + 73920*Dd**2*f**3*r*s - 55440*Dd**2*f**3*r + 36960*Dd**2*f**3*s**2 - 55440*Dd**2*f**3*s + 18480*Dd**2*f**3 + 47520*Dd**2*f**2*g2*r**2 + 95040*Dd**2*f**2*g2*r*s - 71280*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 71280*Dd**2*f**2*g2*s + 23760*Dd**2*f**2*g2)/(1155*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**5*k1**5*(1650*C*D1**2*f**2*fd*r*s - 550*C*D1**2*f**2*fd*r + 1650*C*D1**2*f**2*fd*s**2 - 1650*C*D1**2*f**2*fd*s + 550*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r*s + 770*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 2310*C*D1**2*f**2*fdd*s - 770*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r*s + 1540*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 4620*C*D1**2*f*fd**2*s - 770*C*D1**2*f*fd**2 + 2200*C*D1*Dd*f**3*r*s - 550*C*D1*Dd*f**3*r + 2200*C*D1*Dd*f**3*s**2 - 2200*C*D1*Dd*f**3*s + 550*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r*s + 5390*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 18480*C*D1*Dd*f**2*fd*s - 3850*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r*s + 770*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 3080*C*D1*Ddd*f**3*s - 770*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r*s + 2310*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 9240*C*Dd**2*f**3*s - 1540*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 5460*D1**2*f**3*fd*r*s - 1365*D1**2*f**3*fd*r + 5460*D1**2*f**3*fd*s**2 - 5460*D1**2*f**3*fd*s + 1365*D1**2*f**3*fd - 5040*D1**2*f**3*fdd*r*s + 1260*D1**2*f**3*fdd*r - 5040*D1**2*f**3*fdd*s**2 + 5040*D1**2*f**3*fdd*s - 1260*D1**2*f**3*fdd - 15120*D1**2*f**2*fd**2*r*s + 3780*D1**2*f**2*fd**2*r - 15120*D1**2*f**2*fd**2*s**2 + 15120*D1**2*f**2*fd**2*s - 2520*D1**2*f**2*fd**2 - 1650*D1**2*f**2*fd*r*s + 550*D1**2*f**2*fd*r - 1650*D1**2*f**2*fd*s**2 + 1650*D1**2*f**2*fd*s - 550*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r*s - 770*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2310*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd - 594*D1**2*f**2*gd2*r*s - 594*D1**2*f**2*gd2*s**2 + 594*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 4620*D1**2*f*fd**2*r*s - 1540*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 4620*D1**2*f*fd**2*s + 770*D1**2*f*fd**2 - 1188*D1**2*f*fd*g2*r*s + 594*D1**2*f*fd*g2*r - 1188*D1**2*f*fd*g2*s**2 + 1188*D1**2*f*fd*g2*s - 594*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 5460*D1*Dd*f**4*r*s - 1365*D1*Dd*f**4*r + 5460*D1*Dd*f**4*s**2 - 5460*D1*Dd*f**4*s + 1365*D1*Dd*f**4 - 40320*D1*Dd*f**3*fd*r*s + 10080*D1*Dd*f**3*fd*r - 40320*D1*Dd*f**3*fd*s**2 + 40320*D1*Dd*f**3*fd*s - 7560*D1*Dd*f**3*fd - 2200*D1*Dd*f**3*r*s + 550*D1*Dd*f**3*r - 2200*D1*Dd*f**3*s**2 + 2200*D1*Dd*f**3*s - 550*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r*s - 5390*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 18480*D1*Dd*f**2*fd*s + 3850*D1*Dd*f**2*fd - 2376*D1*Dd*f**2*g2*r*s + 594*D1*Dd*f**2*g2*r - 2376*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 594*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 5040*D1*Ddd*f**4*r*s + 1260*D1*Ddd*f**4*r - 5040*D1*Ddd*f**4*s**2 + 5040*D1*Ddd*f**4*s - 1260*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r*s - 770*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 3080*D1*Ddd*f**3*s + 770*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(3*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 15120*Dd**2*f**4*r*s + 3780*Dd**2*f**4*r - 15120*Dd**2*f**4*s**2 + 15120*Dd**2*f**4*s - 2520*Dd**2*f**4 + 9240*Dd**2*f**3*r*s - 2310*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 9240*Dd**2*f**3*s + 1540*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(3*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(3*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k2*k3**6) - 4*D1**2*Pk2*Pk3*ct**5*k1**3*k2**3*st**2*(19272*C*D1**2*f**2*fd*r**2 + 38544*C*D1**2*f**2*fd*r*s - 25696*C*D1**2*f**2*fd*r + 19272*C*D1**2*f**2*fd*s**2 - 25696*C*D1**2*f**2*fd*s + 12848*C*D1**2*f**2*fd - 13200*C*D1**2*f**2*fdd*r**2 - 26400*C*D1**2*f**2*fdd*r*s + 17600*C*D1**2*f**2*fdd*r - 13200*C*D1**2*f**2*fdd*s**2 + 17600*C*D1**2*f**2*fdd*s - 8800*C*D1**2*f**2*fdd - 26400*C*D1**2*f*fd**2*r**2 - 52800*C*D1**2*f*fd**2*r*s + 35200*C*D1**2*f*fd**2*r - 26400*C*D1**2*f*fd**2*s**2 + 35200*C*D1**2*f*fd**2*s - 8800*C*D1**2*f*fd**2 + 25696*C*D1*Dd*f**3*r**2 + 51392*C*D1*Dd*f**3*r*s - 38544*C*D1*Dd*f**3*r + 25696*C*D1*Dd*f**3*s**2 - 38544*C*D1*Dd*f**3*s + 19272*C*D1*Dd*f**3 - 105600*C*D1*Dd*f**2*fd*r**2 - 211200*C*D1*Dd*f**2*fd*r*s + 149600*C*D1*Dd*f**2*fd*r - 105600*C*D1*Dd*f**2*fd*s**2 + 149600*C*D1*Dd*f**2*fd*s - 52800*C*D1*Dd*f**2*fd - 17600*C*D1*Ddd*f**3*r**2 - 35200*C*D1*Ddd*f**3*r*s + 26400*C*D1*Ddd*f**3*r - 17600*C*D1*Ddd*f**3*s**2 + 26400*C*D1*Ddd*f**3*s - 13200*C*D1*Ddd*f**3 - 52800*C*Dd**2*f**3*r**2 - 105600*C*Dd**2*f**3*r*s + 79200*C*Dd**2*f**3*r - 52800*C*Dd**2*f**3*s**2 + 79200*C*Dd**2*f**3*s - 26400*C*Dd**2*f**3 + 10296*D1**2*K*b1*f*fd*r**2 + 20592*D1**2*K*b1*f*fd*r*s - 10296*D1**2*K*b1*f*fd*r + 10296*D1**2*K*b1*f*fd*s**2 - 10296*D1**2*K*b1*f*fd*s + 5148*D1**2*K*b1*f*fd - 7920*D1**2*K*b1*f*fdd*r**2 - 15840*D1**2*K*b1*f*fdd*r*s + 7920*D1**2*K*b1*f*fdd*r - 7920*D1**2*K*b1*f*fdd*s**2 + 7920*D1**2*K*b1*f*fdd*s - 3960*D1**2*K*b1*f*fdd - 7920*D1**2*K*b1*fd**2*r**2 - 15840*D1**2*K*b1*fd**2*r*s + 7920*D1**2*K*b1*fd**2*r - 7920*D1**2*K*b1*fd**2*s**2 + 7920*D1**2*K*b1*fd**2*s - 10296*D1**2*b1*f*fd*r**2 - 20592*D1**2*b1*f*fd*r*s + 10296*D1**2*b1*f*fd*r - 10296*D1**2*b1*f*fd*s**2 + 10296*D1**2*b1*f*fd*s - 5148*D1**2*b1*f*fd + 7920*D1**2*b1*f*fdd*r**2 + 15840*D1**2*b1*f*fdd*r*s - 7920*D1**2*b1*f*fdd*r + 7920*D1**2*b1*f*fdd*s**2 - 7920*D1**2*b1*f*fdd*s + 3960*D1**2*b1*f*fdd + 7920*D1**2*b1*fd**2*r**2 + 15840*D1**2*b1*fd**2*r*s - 7920*D1**2*b1*fd**2*r + 7920*D1**2*b1*fd**2*s**2 - 7920*D1**2*b1*fd**2*s - 3960*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 22800*D1**2*f**3*fd*r**2 + 45600*D1**2*f**3*fd*r*s - 34200*D1**2*f**3*fd*r + 22800*D1**2*f**3*fd*s**2 - 34200*D1**2*f**3*fd*s + 17100*D1**2*f**3*fd - 14700*D1**2*f**3*fdd*r**2 - 29400*D1**2*f**3*fdd*r*s + 22050*D1**2*f**3*fdd*r - 14700*D1**2*f**3*fdd*s**2 + 22050*D1**2*f**3*fdd*s - 11025*D1**2*f**3*fdd - 44100*D1**2*f**2*fd**2*r**2 - 88200*D1**2*f**2*fd**2*r*s + 66150*D1**2*f**2*fd**2*r - 44100*D1**2*f**2*fd**2*s**2 + 66150*D1**2*f**2*fd**2*s - 22050*D1**2*f**2*fd**2 - 19272*D1**2*f**2*fd*r**2 - 38544*D1**2*f**2*fd*r*s + 25696*D1**2*f**2*fd*r - 19272*D1**2*f**2*fd*s**2 + 25696*D1**2*f**2*fd*s - 12848*D1**2*f**2*fd + 13200*D1**2*f**2*fdd*r**2 + 26400*D1**2*f**2*fdd*r*s - 17600*D1**2*f**2*fdd*r + 13200*D1**2*f**2*fdd*s**2 - 17600*D1**2*f**2*fdd*s + 8800*D1**2*f**2*fdd - 10296*D1**2*f**2*gd2*r**2 - 20592*D1**2*f**2*gd2*r*s + 20592*D1**2*f**2*gd2*r - 10296*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s - 10296*D1**2*f**2*gd2 + 7920*D1**2*f**2*gdd2*r**2 + 15840*D1**2*f**2*gdd2*r*s - 15840*D1**2*f**2*gdd2*r + 7920*D1**2*f**2*gdd2*s**2 - 15840*D1**2*f**2*gdd2*s + 7920*D1**2*f**2*gdd2 + 26400*D1**2*f*fd**2*r**2 + 52800*D1**2*f*fd**2*r*s - 35200*D1**2*f*fd**2*r + 26400*D1**2*f*fd**2*s**2 - 35200*D1**2*f*fd**2*s + 8800*D1**2*f*fd**2 - 20592*D1**2*f*fd*g2*r**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 20592*D1**2*f*fd*g2*s**2 + 20592*D1**2*f*fd*g2*s - 10296*D1**2*f*fd*g2 + 31680*D1**2*f*fd*gd2*r**2 + 63360*D1**2*f*fd*gd2*r*s - 47520*D1**2*f*fd*gd2*r + 31680*D1**2*f*fd*gd2*s**2 - 47520*D1**2*f*fd*gd2*s + 15840*D1**2*f*fd*gd2 + 15840*D1**2*f*fdd*g2*r**2 + 31680*D1**2*f*fdd*g2*r*s - 15840*D1**2*f*fdd*g2*r + 15840*D1**2*f*fdd*g2*s**2 - 15840*D1**2*f*fdd*g2*s + 7920*D1**2*f*fdd*g2 + 15840*D1**2*fd**2*g2*r**2 + 31680*D1**2*fd**2*g2*r*s - 15840*D1**2*fd**2*g2*r + 15840*D1**2*fd**2*g2*s**2 - 15840*D1**2*fd**2*g2*s + 20592*D1*Dd*K*b1*f**2*r**2 + 41184*D1*Dd*K*b1*f**2*r*s - 30888*D1*Dd*K*b1*f**2*r + 20592*D1*Dd*K*b1*f**2*s**2 - 30888*D1*Dd*K*b1*f**2*s + 15444*D1*Dd*K*b1*f**2 - 63360*D1*Dd*K*b1*f*fd*r**2 - 126720*D1*Dd*K*b1*f*fd*r*s + 79200*D1*Dd*K*b1*f*fd*r - 63360*D1*Dd*K*b1*f*fd*s**2 + 79200*D1*Dd*K*b1*f*fd*s - 23760*D1*Dd*K*b1*f*fd - 20592*D1*Dd*b1*f**2*r**2 - 41184*D1*Dd*b1*f**2*r*s + 30888*D1*Dd*b1*f**2*r - 20592*D1*Dd*b1*f**2*s**2 + 30888*D1*Dd*b1*f**2*s - 15444*D1*Dd*b1*f**2 + 63360*D1*Dd*b1*f*fd*r**2 + 126720*D1*Dd*b1*f*fd*r*s - 79200*D1*Dd*b1*f*fd*r + 63360*D1*Dd*b1*f*fd*s**2 - 79200*D1*Dd*b1*f*fd*s + 23760*D1*Dd*b1*f*fd + 22800*D1*Dd*f**4*r**2 + 45600*D1*Dd*f**4*r*s - 34200*D1*Dd*f**4*r + 22800*D1*Dd*f**4*s**2 - 34200*D1*Dd*f**4*s + 17100*D1*Dd*f**4 - 117600*D1*Dd*f**3*fd*r**2 - 235200*D1*Dd*f**3*fd*r*s + 176400*D1*Dd*f**3*fd*r - 117600*D1*Dd*f**3*fd*s**2 + 176400*D1*Dd*f**3*fd*s - 66150*D1*Dd*f**3*fd - 25696*D1*Dd*f**3*r**2 - 51392*D1*Dd*f**3*r*s + 38544*D1*Dd*f**3*r - 25696*D1*Dd*f**3*s**2 + 38544*D1*Dd*f**3*s - 19272*D1*Dd*f**3 + 105600*D1*Dd*f**2*fd*r**2 + 211200*D1*Dd*f**2*fd*r*s - 149600*D1*Dd*f**2*fd*r + 105600*D1*Dd*f**2*fd*s**2 - 149600*D1*Dd*f**2*fd*s + 52800*D1*Dd*f**2*fd - 41184*D1*Dd*f**2*g2*r**2 - 82368*D1*Dd*f**2*g2*r*s + 61776*D1*Dd*f**2*g2*r - 41184*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 30888*D1*Dd*f**2*g2 + 63360*D1*Dd*f**2*gd2*r**2 + 126720*D1*Dd*f**2*gd2*r*s - 110880*D1*Dd*f**2*gd2*r + 63360*D1*Dd*f**2*gd2*s**2 - 110880*D1*Dd*f**2*gd2*s + 47520*D1*Dd*f**2*gd2 + 126720*D1*Dd*f*fd*g2*r**2 + 253440*D1*Dd*f*fd*g2*r*s - 158400*D1*Dd*f*fd*g2*r + 126720*D1*Dd*f*fd*g2*s**2 - 158400*D1*Dd*f*fd*g2*s + 47520*D1*Dd*f*fd*g2 - 15840*D1*Ddd*K*b1*f**2*r**2 - 31680*D1*Ddd*K*b1*f**2*r*s + 23760*D1*Ddd*K*b1*f**2*r - 15840*D1*Ddd*K*b1*f**2*s**2 + 23760*D1*Ddd*K*b1*f**2*s - 11880*D1*Ddd*K*b1*f**2 + 15840*D1*Ddd*b1*f**2*r**2 + 31680*D1*Ddd*b1*f**2*r*s - 23760*D1*Ddd*b1*f**2*r + 15840*D1*Ddd*b1*f**2*s**2 - 23760*D1*Ddd*b1*f**2*s + 11880*D1*Ddd*b1*f**2 - 14700*D1*Ddd*f**4*r**2 - 29400*D1*Ddd*f**4*r*s + 22050*D1*Ddd*f**4*r - 14700*D1*Ddd*f**4*s**2 + 22050*D1*Ddd*f**4*s - 11025*D1*Ddd*f**4 + 17600*D1*Ddd*f**3*r**2 + 35200*D1*Ddd*f**3*r*s - 26400*D1*Ddd*f**3*r + 17600*D1*Ddd*f**3*s**2 - 26400*D1*Ddd*f**3*s + 13200*D1*Ddd*f**3 + 31680*D1*Ddd*f**2*g2*r**2 + 63360*D1*Ddd*f**2*g2*r*s - 47520*D1*Ddd*f**2*g2*r + 31680*D1*Ddd*f**2*g2*s**2 - 47520*D1*Ddd*f**2*g2*s + 23760*D1*Ddd*f**2*g2 + 396*D1*bd1*f*(K - 1)*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 47520*Dd**2*K*b1*f**2*r**2 - 95040*Dd**2*K*b1*f**2*r*s + 71280*Dd**2*K*b1*f**2*r - 47520*Dd**2*K*b1*f**2*s**2 + 71280*Dd**2*K*b1*f**2*s - 23760*Dd**2*K*b1*f**2 + 47520*Dd**2*b1*f**2*r**2 + 95040*Dd**2*b1*f**2*r*s - 71280*Dd**2*b1*f**2*r + 47520*Dd**2*b1*f**2*s**2 - 71280*Dd**2*b1*f**2*s + 23760*Dd**2*b1*f**2 - 44100*Dd**2*f**4*r**2 - 88200*Dd**2*f**4*r*s + 66150*Dd**2*f**4*r - 44100*Dd**2*f**4*s**2 + 66150*Dd**2*f**4*s - 22050*Dd**2*f**4 + 52800*Dd**2*f**3*r**2 + 105600*Dd**2*f**3*r*s - 79200*Dd**2*f**3*r + 52800*Dd**2*f**3*s**2 - 79200*Dd**2*f**3*s + 26400*Dd**2*f**3 + 95040*Dd**2*f**2*g2*r**2 + 190080*Dd**2*f**2*g2*r*s - 142560*Dd**2*f**2*g2*r + 95040*Dd**2*f**2*g2*s**2 - 142560*Dd**2*f**2*g2*s + 47520*Dd**2*f**2*g2)/(1155*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**5*k1**3*k2**3*(-360*C*D1**2*bdd1*f**2*r**2 - 720*C*D1**2*bdd1*f**2*r*s + 720*C*D1**2*bdd1*f**2*r - 360*C*D1**2*bdd1*f**2*s**2 + 720*C*D1**2*bdd1*f**2*s - 360*C*D1**2*bdd1*f**2 + 1800*C*D1**2*f**2*fd*r**2 + 3600*C*D1**2*f**2*fd*r*s - 2400*C*D1**2*f**2*fd*r + 1800*C*D1**2*f**2*fd*s**2 - 2400*C*D1**2*f**2*fd*s + 1200*C*D1**2*f**2*fd - 2520*C*D1**2*f**2*fdd*r**2 - 5040*C*D1**2*f**2*fdd*r*s + 3360*C*D1**2*f**2*fdd*r - 2520*C*D1**2*f**2*fdd*s**2 + 3360*C*D1**2*f**2*fdd*s - 1680*C*D1**2*f**2*fdd - 5040*C*D1**2*f*fd**2*r**2 - 10080*C*D1**2*f*fd**2*r*s + 6720*C*D1**2*f*fd**2*r - 5040*C*D1**2*f*fd**2*s**2 + 6720*C*D1**2*f*fd**2*s - 1680*C*D1**2*f*fd**2 + 2400*C*D1*Dd*f**3*r**2 + 4800*C*D1*Dd*f**3*r*s - 3600*C*D1*Dd*f**3*r + 2400*C*D1*Dd*f**3*s**2 - 3600*C*D1*Dd*f**3*s + 1800*C*D1*Dd*f**3 - 20160*C*D1*Dd*f**2*fd*r**2 - 40320*C*D1*Dd*f**2*fd*r*s + 28560*C*D1*Dd*f**2*fd*r - 20160*C*D1*Dd*f**2*fd*s**2 + 28560*C*D1*Dd*f**2*fd*s - 10080*C*D1*Dd*f**2*fd - 3360*C*D1*Ddd*f**3*r**2 - 6720*C*D1*Ddd*f**3*r*s + 5040*C*D1*Ddd*f**3*r - 3360*C*D1*Ddd*f**3*s**2 + 5040*C*D1*Ddd*f**3*s - 2520*C*D1*Ddd*f**3 - 10080*C*Dd**2*f**3*r**2 - 20160*C*Dd**2*f**3*r*s + 15120*C*Dd**2*f**3*r - 10080*C*Dd**2*f**3*s**2 + 15120*C*Dd**2*f**3*s - 5040*C*Dd**2*f**3 - 540*D1**2*K*bdd1*f**2*r**2 - 1080*D1**2*K*bdd1*f**2*r*s + 1080*D1**2*K*bdd1*f**2*r - 540*D1**2*K*bdd1*f**2*s**2 + 1080*D1**2*K*bdd1*f**2*s - 540*D1**2*K*bdd1*f**2 - 504*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 175*D1**2*bdd1*f**3*r**2 + 350*D1**2*bdd1*f**3*r*s - 350*D1**2*bdd1*f**3*r + 175*D1**2*bdd1*f**3*s**2 - 350*D1**2*bdd1*f**3*s + 175*D1**2*bdd1*f**3 + 630*D1**2*bdd1*f**2*r**2 + 1260*D1**2*bdd1*f**2*r*s - 1260*D1**2*bdd1*f**2*r + 630*D1**2*bdd1*f**2*s**2 - 1260*D1**2*bdd1*f**2*s + 630*D1**2*bdd1*f**2 + 504*D1**2*bdd1*f*g2*r**2 + 1008*D1**2*bdd1*f*g2*r*s - 1008*D1**2*bdd1*f*g2*r + 504*D1**2*bdd1*f*g2*s**2 - 1008*D1**2*bdd1*f*g2*s + 504*D1**2*bdd1*f*g2 - 420*D1**2*f**3*fd*r**2 - 840*D1**2*f**3*fd*r*s + 630*D1**2*f**3*fd*r - 420*D1**2*f**3*fd*s**2 + 630*D1**2*f**3*fd*s - 315*D1**2*f**3*fd - 1215*D1**2*f**2*fd*r**2 - 2430*D1**2*f**2*fd*r*s + 1620*D1**2*f**2*fd*r - 1215*D1**2*f**2*fd*s**2 + 1620*D1**2*f**2*fd*s - 810*D1**2*f**2*fd + 1890*D1**2*f**2*fdd*r**2 + 3780*D1**2*f**2*fdd*r*s - 2520*D1**2*f**2*fdd*r + 1890*D1**2*f**2*fdd*s**2 - 2520*D1**2*f**2*fdd*s + 1260*D1**2*f**2*fdd - 648*D1**2*f**2*gd2*r**2 - 1296*D1**2*f**2*gd2*r*s + 1296*D1**2*f**2*gd2*r - 648*D1**2*f**2*gd2*s**2 + 1296*D1**2*f**2*gd2*s - 648*D1**2*f**2*gd2 + 1080*D1**2*f**2*gdd2*r**2 + 2160*D1**2*f**2*gdd2*r*s - 2160*D1**2*f**2*gdd2*r + 1080*D1**2*f**2*gdd2*s**2 - 2160*D1**2*f**2*gdd2*s + 1080*D1**2*f**2*gdd2 + 3780*D1**2*f*fd**2*r**2 + 7560*D1**2*f*fd**2*r*s - 5040*D1**2*f*fd**2*r + 3780*D1**2*f*fd**2*s**2 - 5040*D1**2*f*fd**2*s + 1260*D1**2*f*fd**2 - 1296*D1**2*f*fd*g2*r**2 - 2592*D1**2*f*fd*g2*r*s + 1296*D1**2*f*fd*g2*r - 1296*D1**2*f*fd*g2*s**2 + 1296*D1**2*f*fd*g2*s - 648*D1**2*f*fd*g2 + 4320*D1**2*f*fd*gd2*r**2 + 8640*D1**2*f*fd*gd2*r*s - 6480*D1**2*f*fd*gd2*r + 4320*D1**2*f*fd*gd2*s**2 - 6480*D1**2*f*fd*gd2*s + 2160*D1**2*f*fd*gd2 + 2160*D1**2*f*fdd*g2*r**2 + 4320*D1**2*f*fdd*g2*r*s - 2160*D1**2*f*fdd*g2*r + 2160*D1**2*f*fdd*g2*s**2 - 2160*D1**2*f*fdd*g2*s + 1080*D1**2*f*fdd*g2 + 2160*D1**2*fd**2*g2*r**2 + 4320*D1**2*fd**2*g2*r*s - 2160*D1**2*fd**2*g2*r + 2160*D1**2*fd**2*g2*s**2 - 2160*D1**2*fd**2*g2*s - 420*D1*Dd*f**4*r**2 - 840*D1*Dd*f**4*r*s + 630*D1*Dd*f**4*r - 420*D1*Dd*f**4*s**2 + 630*D1*Dd*f**4*s - 315*D1*Dd*f**4 - 1620*D1*Dd*f**3*r**2 - 3240*D1*Dd*f**3*r*s + 2430*D1*Dd*f**3*r - 1620*D1*Dd*f**3*s**2 + 2430*D1*Dd*f**3*s - 1215*D1*Dd*f**3 + 15120*D1*Dd*f**2*fd*r**2 + 30240*D1*Dd*f**2*fd*r*s - 21420*D1*Dd*f**2*fd*r + 15120*D1*Dd*f**2*fd*s**2 - 21420*D1*Dd*f**2*fd*s + 7560*D1*Dd*f**2*fd - 2592*D1*Dd*f**2*g2*r**2 - 5184*D1*Dd*f**2*g2*r*s + 3888*D1*Dd*f**2*g2*r - 2592*D1*Dd*f**2*g2*s**2 + 3888*D1*Dd*f**2*g2*s - 1944*D1*Dd*f**2*g2 + 8640*D1*Dd*f**2*gd2*r**2 + 17280*D1*Dd*f**2*gd2*r*s - 15120*D1*Dd*f**2*gd2*r + 8640*D1*Dd*f**2*gd2*s**2 - 15120*D1*Dd*f**2*gd2*s + 6480*D1*Dd*f**2*gd2 + 17280*D1*Dd*f*fd*g2*r**2 + 34560*D1*Dd*f*fd*g2*r*s - 21600*D1*Dd*f*fd*g2*r + 17280*D1*Dd*f*fd*g2*s**2 - 21600*D1*Dd*f*fd*g2*s + 6480*D1*Dd*f*fd*g2 + 2520*D1*Ddd*f**3*r**2 + 5040*D1*Ddd*f**3*r*s - 3780*D1*Ddd*f**3*r + 2520*D1*Ddd*f**3*s**2 - 3780*D1*Ddd*f**3*s + 1890*D1*Ddd*f**3 + 4320*D1*Ddd*f**2*g2*r**2 + 8640*D1*Ddd*f**2*g2*r*s - 6480*D1*Ddd*f**2*g2*r + 4320*D1*Ddd*f**2*g2*s**2 - 6480*D1*Ddd*f**2*g2*s + 3240*D1*Ddd*f**2*g2 - D1*bd1*(D1*(125*f**3*(r + s - 1) - f**2*(468*C*(r + s - 1) + 350*fd*(3*r + 3*s - 2) + (324*K - 567)*(r + s - 1)) + 12*f*(15*fd*(4*C + 6*K - 7)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) - 1008*fd*g2*(r + s)) - 2*Dd*f*(175*f**2 - 90*f*(4*C + 6*K - 7) + 504*g2)*(4*r + 4*s - 3))*(r + s - 1) + 7560*Dd**2*f**3*r**2 + 15120*Dd**2*f**3*r*s - 11340*Dd**2*f**3*r + 7560*Dd**2*f**3*s**2 - 11340*Dd**2*f**3*s + 3780*Dd**2*f**3 + 12960*Dd**2*f**2*g2*r**2 + 25920*Dd**2*f**2*g2*r*s - 19440*Dd**2*f**2*g2*r + 12960*Dd**2*f**2*g2*s**2 - 19440*Dd**2*f**2*g2*s + 6480*Dd**2*f**2*g2 + 42*b1**2*(K - 1)*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(936*C*D1**2*f*fd*r**2 + 1872*C*D1**2*f*fd*r*s - 936*C*D1**2*f*fd*r + 936*C*D1**2*f*fd*s**2 - 936*C*D1**2*f*fd*s + 468*C*D1**2*f*fd - 720*C*D1**2*f*fdd*r**2 - 1440*C*D1**2*f*fdd*r*s + 720*C*D1**2*f*fdd*r - 720*C*D1**2*f*fdd*s**2 + 720*C*D1**2*f*fdd*s - 360*C*D1**2*f*fdd - 720*C*D1**2*fd**2*r**2 - 1440*C*D1**2*fd**2*r*s + 720*C*D1**2*fd**2*r - 720*C*D1**2*fd**2*s**2 + 720*C*D1**2*fd**2*s + 1872*C*D1*Dd*f**2*r**2 + 3744*C*D1*Dd*f**2*r*s - 2808*C*D1*Dd*f**2*r + 1872*C*D1*Dd*f**2*s**2 - 2808*C*D1*Dd*f**2*s + 1404*C*D1*Dd*f**2 - 5760*C*D1*Dd*f*fd*r**2 - 11520*C*D1*Dd*f*fd*r*s + 7200*C*D1*Dd*f*fd*r - 5760*C*D1*Dd*f*fd*s**2 + 7200*C*D1*Dd*f*fd*s - 2160*C*D1*Dd*f*fd - 1440*C*D1*Ddd*f**2*r**2 - 2880*C*D1*Ddd*f**2*r*s + 2160*C*D1*Ddd*f**2*r - 1440*C*D1*Ddd*f**2*s**2 + 2160*C*D1*Ddd*f**2*s - 1080*C*D1*Ddd*f**2 - 4320*C*Dd**2*f**2*r**2 - 8640*C*Dd**2*f**2*r*s + 6480*C*Dd**2*f**2*r - 4320*C*Dd**2*f**2*s**2 + 6480*C*Dd**2*f**2*s - 2160*C*Dd**2*f**2 + 648*D1**2*K*f*fd*r**2 + 1296*D1**2*K*f*fd*r*s - 648*D1**2*K*f*fd*r + 648*D1**2*K*f*fd*s**2 - 648*D1**2*K*f*fd*s + 324*D1**2*K*f*fd - 1080*D1**2*K*f*fdd*r**2 - 2160*D1**2*K*f*fdd*r*s + 1080*D1**2*K*f*fdd*r - 1080*D1**2*K*f*fdd*s**2 + 1080*D1**2*K*f*fdd*s - 540*D1**2*K*f*fdd - 1080*D1**2*K*fd**2*r**2 - 2160*D1**2*K*fd**2*r*s + 1080*D1**2*K*fd**2*r - 1080*D1**2*K*fd**2*s**2 + 1080*D1**2*K*fd**2*s - 504*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 375*D1**2*f**2*fd*r**2 - 750*D1**2*f**2*fd*r*s + 500*D1**2*f**2*fd*r - 375*D1**2*f**2*fd*s**2 + 500*D1**2*f**2*fd*s - 250*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 700*D1**2*f**2*fdd*s + 350*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1400*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 - 1134*D1**2*f*fd*r**2 - 2268*D1**2*f*fd*r*s + 1134*D1**2*f*fd*r - 1134*D1**2*f*fd*s**2 + 1134*D1**2*f*fd*s - 567*D1**2*f*fd + 1260*D1**2*f*fdd*r**2 + 2520*D1**2*f*fdd*r*s - 1260*D1**2*f*fdd*r + 1260*D1**2*f*fdd*s**2 - 1260*D1**2*f*fdd*s + 630*D1**2*f*fdd - 588*D1**2*f*gd2*r**2 - 1176*D1**2*f*gd2*r*s + 1176*D1**2*f*gd2*r - 588*D1**2*f*gd2*s**2 + 1176*D1**2*f*gd2*s - 588*D1**2*f*gd2 + 504*D1**2*f*gdd2*r**2 + 1008*D1**2*f*gdd2*r*s - 1008*D1**2*f*gdd2*r + 504*D1**2*f*gdd2*s**2 - 1008*D1**2*f*gdd2*s + 504*D1**2*f*gdd2 + 1260*D1**2*fd**2*r**2 + 2520*D1**2*fd**2*r*s - 1260*D1**2*fd**2*r + 1260*D1**2*fd**2*s**2 - 1260*D1**2*fd**2*s - 588*D1**2*fd*g2*r**2 - 1176*D1**2*fd*g2*r*s - 588*D1**2*fd*g2*s**2 + 1008*D1**2*fd*gd2*r**2 + 2016*D1**2*fd*gd2*r*s - 1008*D1**2*fd*gd2*r + 1008*D1**2*fd*gd2*s**2 - 1008*D1**2*fd*gd2*s + 504*D1**2*fdd*g2*r**2 + 1008*D1**2*fdd*g2*r*s + 504*D1**2*fdd*g2*s**2 + 1296*D1*Dd*K*f**2*r**2 + 2592*D1*Dd*K*f**2*r*s - 1944*D1*Dd*K*f**2*r + 1296*D1*Dd*K*f**2*s**2 - 1944*D1*Dd*K*f**2*s + 972*D1*Dd*K*f**2 - 8640*D1*Dd*K*f*fd*r**2 - 17280*D1*Dd*K*f*fd*r*s + 10800*D1*Dd*K*f*fd*r - 8640*D1*Dd*K*f*fd*s**2 + 10800*D1*Dd*K*f*fd*s - 3240*D1*Dd*K*f*fd - 500*D1*Dd*f**3*r**2 - 1000*D1*Dd*f**3*r*s + 750*D1*Dd*f**3*r - 500*D1*Dd*f**3*s**2 + 750*D1*Dd*f**3*s - 375*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 5950*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 5950*D1*Dd*f**2*fd*s + 2100*D1*Dd*f**2*fd - 2268*D1*Dd*f**2*r**2 - 4536*D1*Dd*f**2*r*s + 3402*D1*Dd*f**2*r - 2268*D1*Dd*f**2*s**2 + 3402*D1*Dd*f**2*s - 1701*D1*Dd*f**2 + 10080*D1*Dd*f*fd*r**2 + 20160*D1*Dd*f*fd*r*s - 12600*D1*Dd*f*fd*r + 10080*D1*Dd*f*fd*s**2 - 12600*D1*Dd*f*fd*s + 3780*D1*Dd*f*fd - 2352*D1*Dd*f*g2*r**2 - 4704*D1*Dd*f*g2*r*s + 3528*D1*Dd*f*g2*r - 2352*D1*Dd*f*g2*s**2 + 3528*D1*Dd*f*g2*s - 1764*D1*Dd*f*g2 + 4032*D1*Dd*f*gd2*r**2 + 8064*D1*Dd*f*gd2*r*s - 7056*D1*Dd*f*gd2*r + 4032*D1*Dd*f*gd2*s**2 - 7056*D1*Dd*f*gd2*s + 3024*D1*Dd*f*gd2 + 4032*D1*Dd*fd*g2*r**2 + 8064*D1*Dd*fd*g2*r*s - 3024*D1*Dd*fd*g2*r + 4032*D1*Dd*fd*g2*s**2 - 3024*D1*Dd*fd*g2*s - 2160*D1*Ddd*K*f**2*r**2 - 4320*D1*Ddd*K*f**2*r*s + 3240*D1*Ddd*K*f**2*r - 2160*D1*Ddd*K*f**2*s**2 + 3240*D1*Ddd*K*f**2*s - 1620*D1*Ddd*K*f**2 + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 1050*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 525*D1*Ddd*f**3 + 2520*D1*Ddd*f**2*r**2 + 5040*D1*Ddd*f**2*r*s - 3780*D1*Ddd*f**2*r + 2520*D1*Ddd*f**2*s**2 - 3780*D1*Ddd*f**2*s + 1890*D1*Ddd*f**2 + 2016*D1*Ddd*f*g2*r**2 + 4032*D1*Ddd*f*g2*r*s - 3024*D1*Ddd*f*g2*r + 2016*D1*Ddd*f*g2*s**2 - 3024*D1*Ddd*f*g2*s + 1512*D1*Ddd*f*g2 + 84*D1*bd1*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 6480*Dd**2*K*f**2*r**2 - 12960*Dd**2*K*f**2*r*s + 9720*Dd**2*K*f**2*r - 6480*Dd**2*K*f**2*s**2 + 9720*Dd**2*K*f**2*s - 3240*Dd**2*K*f**2 + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 3150*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 1050*Dd**2*f**3 + 7560*Dd**2*f**2*r**2 + 15120*Dd**2*f**2*r*s - 11340*Dd**2*f**2*r + 7560*Dd**2*f**2*s**2 - 11340*Dd**2*f**2*s + 3780*Dd**2*f**2 + 6048*Dd**2*f*g2*r**2 + 12096*Dd**2*f*g2*r*s - 9072*Dd**2*f*g2*r + 6048*Dd**2*f*g2*s**2 - 9072*Dd**2*f*g2*s + 3024*Dd**2*f*g2))/(105*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**5*k1**3*k2*st**2*(5412*C*D1**2*f**2*fd*r*s - 1804*C*D1**2*f**2*fd*r + 5412*C*D1**2*f**2*fd*s**2 - 5412*C*D1**2*f**2*fd*s + 1804*C*D1**2*f**2*fd - 3300*C*D1**2*f**2*fdd*r*s + 1100*C*D1**2*f**2*fdd*r - 3300*C*D1**2*f**2*fdd*s**2 + 3300*C*D1**2*f**2*fdd*s - 1100*C*D1**2*f**2*fdd - 6600*C*D1**2*f*fd**2*r*s + 2200*C*D1**2*f*fd**2*r - 6600*C*D1**2*f*fd**2*s**2 + 6600*C*D1**2*f*fd**2*s - 1100*C*D1**2*f*fd**2 + 7216*C*D1*Dd*f**3*r*s - 1804*C*D1*Dd*f**3*r + 7216*C*D1*Dd*f**3*s**2 - 7216*C*D1*Dd*f**3*s + 1804*C*D1*Dd*f**3 - 26400*C*D1*Dd*f**2*fd*r*s + 7700*C*D1*Dd*f**2*fd*r - 26400*C*D1*Dd*f**2*fd*s**2 + 26400*C*D1*Dd*f**2*fd*s - 5500*C*D1*Dd*f**2*fd - 4400*C*D1*Ddd*f**3*r*s + 1100*C*D1*Ddd*f**3*r - 4400*C*D1*Ddd*f**3*s**2 + 4400*C*D1*Ddd*f**3*s - 1100*C*D1*Ddd*f**3 - 13200*C*Dd**2*f**3*r*s + 3300*C*Dd**2*f**3*r - 13200*C*Dd**2*f**3*s**2 + 13200*C*Dd**2*f**3*s - 2200*C*Dd**2*f**3 - 990*D1**2*K*bdd1*f**2*r*s - 990*D1**2*K*bdd1*f**2*s**2 + 990*D1**2*K*bdd1*f**2*s + 990*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*s**2 - 990*D1**2*bdd1*f**2*s + 6740*D1**2*f**3*fd*r*s - 1685*D1**2*f**3*fd*r + 6740*D1**2*f**3*fd*s**2 - 6740*D1**2*f**3*fd*s + 1685*D1**2*f**3*fd - 3920*D1**2*f**3*fdd*r*s + 980*D1**2*f**3*fdd*r - 3920*D1**2*f**3*fdd*s**2 + 3920*D1**2*f**3*fdd*s - 980*D1**2*f**3*fdd - 11760*D1**2*f**2*fd**2*r*s + 2940*D1**2*f**2*fd**2*r - 11760*D1**2*f**2*fd**2*s**2 + 11760*D1**2*f**2*fd**2*s - 1960*D1**2*f**2*fd**2 - 5412*D1**2*f**2*fd*r*s + 1804*D1**2*f**2*fd*r - 5412*D1**2*f**2*fd*s**2 + 5412*D1**2*f**2*fd*s - 1804*D1**2*f**2*fd + 3300*D1**2*f**2*fdd*r*s - 1100*D1**2*f**2*fdd*r + 3300*D1**2*f**2*fdd*s**2 - 3300*D1**2*f**2*fdd*s + 1100*D1**2*f**2*fdd - 3036*D1**2*f**2*gd2*r*s - 3036*D1**2*f**2*gd2*s**2 + 3036*D1**2*f**2*gd2*s + 1980*D1**2*f**2*gdd2*r*s + 1980*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 6600*D1**2*f*fd**2*r*s - 2200*D1**2*f*fd**2*r + 6600*D1**2*f*fd**2*s**2 - 6600*D1**2*f*fd**2*s + 1100*D1**2*f*fd**2 - 6072*D1**2*f*fd*g2*r*s + 3036*D1**2*f*fd*g2*r - 6072*D1**2*f*fd*g2*s**2 + 6072*D1**2*f*fd*g2*s - 3036*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s + 6740*D1*Dd*f**4*r*s - 1685*D1*Dd*f**4*r + 6740*D1*Dd*f**4*s**2 - 6740*D1*Dd*f**4*s + 1685*D1*Dd*f**4 - 31360*D1*Dd*f**3*fd*r*s + 7840*D1*Dd*f**3*fd*r - 31360*D1*Dd*f**3*fd*s**2 + 31360*D1*Dd*f**3*fd*s - 5880*D1*Dd*f**3*fd - 7216*D1*Dd*f**3*r*s + 1804*D1*Dd*f**3*r - 7216*D1*Dd*f**3*s**2 + 7216*D1*Dd*f**3*s - 1804*D1*Dd*f**3 + 26400*D1*Dd*f**2*fd*r*s - 7700*D1*Dd*f**2*fd*r + 26400*D1*Dd*f**2*fd*s**2 - 26400*D1*Dd*f**2*fd*s + 5500*D1*Dd*f**2*fd - 12144*D1*Dd*f**2*g2*r*s + 3036*D1*Dd*f**2*g2*r - 12144*D1*Dd*f**2*g2*s**2 + 12144*D1*Dd*f**2*g2*s - 3036*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r*s - 1980*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 15840*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 31680*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 - 3920*D1*Ddd*f**4*r*s + 980*D1*Ddd*f**4*r - 3920*D1*Ddd*f**4*s**2 + 3920*D1*Ddd*f**4*s - 980*D1*Ddd*f**4 + 4400*D1*Ddd*f**3*r*s - 1100*D1*Ddd*f**3*r + 4400*D1*Ddd*f**3*s**2 - 4400*D1*Ddd*f**3*s + 1100*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 1980*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 11760*Dd**2*f**4*r*s + 2940*Dd**2*f**4*r - 11760*Dd**2*f**4*s**2 + 11760*Dd**2*f**4*s - 1960*Dd**2*f**4 + 13200*Dd**2*f**3*r*s - 3300*Dd**2*f**3*r + 13200*Dd**2*f**3*s**2 - 13200*Dd**2*f**3*s + 2200*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 3960*Dd**2*f**2*g2 + 66*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**5*k1**3*k2*(360*C*D1**2*bdd1*f**2*r**2 + 1800*C*D1**2*bdd1*f**2*r*s - 1080*C*D1**2*bdd1*f**2*r + 1440*C*D1**2*bdd1*f**2*s**2 - 2160*C*D1**2*bdd1*f**2*s + 1080*C*D1**2*bdd1*f**2 + 5940*C*D1**2*f**2*fd*r**2 + 11160*C*D1**2*f**2*fd*r*s - 7680*C*D1**2*f**2*fd*r + 5220*C*D1**2*f**2*fd*s**2 - 7200*C*D1**2*f**2*fd*s + 3720*C*D1**2*f**2*fd - 5940*C*D1**2*f**2*fdd*r**2 - 9360*C*D1**2*f**2*fdd*r*s + 7080*C*D1**2*f**2*fdd*r - 3420*C*D1**2*f**2*fdd*s**2 + 5400*C*D1**2*f**2*fdd*s - 3120*C*D1**2*f**2*fdd - 11880*C*D1**2*f*fd**2*r**2 - 18720*C*D1**2*f*fd**2*r*s + 14160*C*D1**2*f*fd**2*r - 6840*C*D1**2*f*fd**2*s**2 + 10800*C*D1**2*f*fd**2*s - 3120*C*D1**2*f*fd**2 + 7920*C*D1*Dd*f**3*r**2 + 14880*C*D1*Dd*f**3*r*s - 11640*C*D1*Dd*f**3*r + 6960*C*D1*Dd*f**3*s**2 - 10920*C*D1*Dd*f**3*s + 5700*C*D1*Dd*f**3 - 47520*C*D1*Dd*f**2*fd*r**2 - 74880*C*D1*Dd*f**2*fd*r*s + 61440*C*D1*Dd*f**2*fd*r - 27360*C*D1*Dd*f**2*fd*s**2 + 47160*C*D1*Dd*f**2*fd*s - 19560*C*D1*Dd*f**2*fd - 7920*C*D1*Ddd*f**3*r**2 - 12480*C*D1*Ddd*f**3*r*s + 11040*C*D1*Ddd*f**3*r - 4560*C*D1*Ddd*f**3*s**2 + 8520*C*D1*Ddd*f**3*s - 5100*C*D1*Ddd*f**3 - 23760*C*Dd**2*f**3*r**2 - 37440*C*Dd**2*f**3*r*s + 33120*C*Dd**2*f**3*r - 13680*C*Dd**2*f**3*s**2 + 25560*C*Dd**2*f**3*s - 10200*C*Dd**2*f**3 - 1170*D1**2*K*bdd1*f**2*r**2 - 2016*D1**2*K*bdd1*f**2*r*s + 2340*D1**2*K*bdd1*f**2*r - 846*D1**2*K*bdd1*f**2*s**2 + 2016*D1**2*K*bdd1*f**2*s - 1170*D1**2*K*bdd1*f**2 + 252*D1**2*bd1**2*f*(K - 1)*(2*r**2 + 5*r*(2*s - 1) + 8*s**2 - 11*s + 3) + 630*D1**2*bdd1*f**3*r**2 + 980*D1**2*bdd1*f**3*r*s - 1400*D1**2*bdd1*f**3*r + 350*D1**2*bdd1*f**3*s**2 - 1120*D1**2*bdd1*f**3*s + 980*D1**2*bdd1*f**3 + 1350*D1**2*bdd1*f**2*r**2 + 1836*D1**2*bdd1*f**2*r*s - 2340*D1**2*bdd1*f**2*r + 486*D1**2*bdd1*f**2*s**2 - 1476*D1**2*bdd1*f**2*s + 630*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r**2 - 2520*D1**2*bdd1*f*g2*r*s + 1512*D1**2*bdd1*f*g2*r - 2016*D1**2*bdd1*f*g2*s**2 + 3024*D1**2*bdd1*f*g2*s - 1512*D1**2*bdd1*f*g2 + 5460*D1**2*f**3*fd*r**2 + 14280*D1**2*f**3*fd*r*s - 9030*D1**2*f**3*fd*r + 8820*D1**2*f**3*fd*s**2 - 11550*D1**2*f**3*fd*s + 4935*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 7110*D1**2*f**2*fd*r**2 - 14940*D1**2*f**2*fd*r*s + 9720*D1**2*f**2*fd*r - 7830*D1**2*f**2*fd*s**2 + 10200*D1**2*f**2*fd*s - 4980*D1**2*f**2*fd + 7200*D1**2*f**2*fdd*r**2 + 13140*D1**2*f**2*fdd*r*s - 9180*D1**2*f**2*fdd*r + 5940*D1**2*f**2*fdd*s**2 - 8340*D1**2*f**2*fdd*s + 4380*D1**2*f**2*fdd - 1908*D1**2*f**2*gd2*r**2 - 4536*D1**2*f**2*gd2*r*s + 3816*D1**2*f**2*gd2*r - 2628*D1**2*f**2*gd2*s**2 + 4536*D1**2*f**2*gd2*s - 1908*D1**2*f**2*gd2 + 2340*D1**2*f**2*gdd2*r**2 + 4032*D1**2*f**2*gdd2*r*s - 4680*D1**2*f**2*gdd2*r + 1692*D1**2*f**2*gdd2*s**2 - 4032*D1**2*f**2*gdd2*s + 2340*D1**2*f**2*gdd2 + 14400*D1**2*f*fd**2*r**2 + 26280*D1**2*f*fd**2*r*s - 18360*D1**2*f*fd**2*r + 11880*D1**2*f*fd**2*s**2 - 16680*D1**2*f*fd**2*s + 4380*D1**2*f*fd**2 - 3816*D1**2*f*fd*g2*r**2 - 9072*D1**2*f*fd*g2*r*s + 4536*D1**2*f*fd*g2*r - 5256*D1**2*f*fd*g2*s**2 + 5256*D1**2*f*fd*g2*s - 2628*D1**2*f*fd*g2 + 9360*D1**2*f*fd*gd2*r**2 + 16128*D1**2*f*fd*gd2*r*s - 13392*D1**2*f*fd*gd2*r + 6768*D1**2*f*fd*gd2*s**2 - 11448*D1**2*f*fd*gd2*s + 4032*D1**2*f*fd*gd2 + 4680*D1**2*f*fdd*g2*r**2 + 8064*D1**2*f*fdd*g2*r*s - 4032*D1**2*f*fdd*g2*r + 3384*D1**2*f*fdd*g2*s**2 - 3384*D1**2*f*fdd*g2*s + 1692*D1**2*f*fdd*g2 + 4680*D1**2*fd**2*g2*r**2 + 8064*D1**2*fd**2*g2*r*s - 4032*D1**2*fd**2*g2*r + 3384*D1**2*fd**2*g2*s**2 - 3384*D1**2*fd**2*g2*s + 5460*D1*Dd*f**4*r**2 + 14280*D1*Dd*f**4*r*s - 9030*D1*Dd*f**4*r + 8820*D1*Dd*f**4*s**2 - 11550*D1*Dd*f**4*s + 4935*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 9480*D1*Dd*f**3*r**2 - 19920*D1*Dd*f**3*r*s + 14460*D1*Dd*f**3*r - 10440*D1*Dd*f**3*s**2 + 15180*D1*Dd*f**3*s - 7350*D1*Dd*f**3 + 57600*D1*Dd*f**2*fd*r**2 + 105120*D1*Dd*f**2*fd*r*s - 78660*D1*Dd*f**2*fd*r + 47520*D1*Dd*f**2*fd*s**2 - 71520*D1*Dd*f**2*fd*s + 26700*D1*Dd*f**2*fd - 7632*D1*Dd*f**2*g2*r**2 - 18144*D1*Dd*f**2*g2*r*s + 12168*D1*Dd*f**2*g2*r - 10512*D1*Dd*f**2*g2*s**2 + 14328*D1*Dd*f**2*g2*s - 6444*D1*Dd*f**2*g2 + 18720*D1*Dd*f**2*gd2*r**2 + 32256*D1*Dd*f**2*gd2*r*s - 32112*D1*Dd*f**2*gd2*r + 13536*D1*Dd*f**2*gd2*s**2 - 27576*D1*Dd*f**2*gd2*s + 13392*D1*Dd*f**2*gd2 + 37440*D1*Dd*f*fd*g2*r**2 + 64512*D1*Dd*f*fd*g2*r*s - 42912*D1*Dd*f*fd*g2*r + 27072*D1*Dd*f*fd*g2*s**2 - 36432*D1*Dd*f*fd*g2*s + 11448*D1*Dd*f*fd*g2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 9600*D1*Ddd*f**3*r**2 + 17520*D1*Ddd*f**3*r*s - 13980*D1*Ddd*f**3*r + 7920*D1*Ddd*f**3*s**2 - 12720*D1*Ddd*f**3*s + 6780*D1*Ddd*f**3 + 9360*D1*Ddd*f**2*g2*r**2 + 16128*D1*Ddd*f**2*g2*r*s - 13392*D1*Ddd*f**2*g2*r + 6768*D1*Ddd*f**2*g2*s**2 - 11448*D1*Ddd*f**2*g2*s + 6372*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(5*f**3*(63*r**2 + 2*r*(53*s - 86) + 43*s**2 - 152*s + 133) + f**2*(36*C*(3*r**2 + r*(29*s - 23) + 26*s**2 - 46*s + 23) - 9*K*(53*r**2 + 2*r*(63*s - 53) + 73*s**2 - 126*s + 53) - 70*fd*(27*r**2 + r*(42*s - 45) + 15*s**2 - 35*s + 14) + 594*r**2 + 828*r*s - 576*r + 234*s**2 - 216*s - 126) - 6*f*(3*fd*(10*C*(4*r**2 + 10*r*(2*s - 1) + 16*s**2 - 19*s + 3) - K*(130*r**2 + 224*r*s - 186*r + 94*s**2 - 159*s + 56) + 150*r**2 + 204*r*s - 191*r + 54*s**2 - 119*s + 71) + 14*g2*(r**2 + r*(15*s - 13) + 14*s**2 - 26*s + 13) - 42*gd2*(2*r**2 + 5*r*(2*s - 1) + 8*s**2 - 11*s + 3)) + 252*fd*g2*(2*r**2 + 5*r*(2*s - 1) + s*(8*s - 8))) - 2*Dd*f*(35*f**2*(36*r**2 + r*(56*s - 65) + 20*s**2 - 51*s + 28) + 9*f*(10*C*(8*r**2 + r*(40*s - 21) + 32*s**2 - 42*s + 12) - K*(260*r**2 + 448*r*s - 446*r + 188*s**2 - 383*s + 186) + 300*r**2 + 408*r*s - 461*r + 108*s**2 - 293*s + 171) - 126*g2*(8*r**2 + r*(40*s - 21) + 32*s**2 - 42*s + 12))) - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 28800*Dd**2*f**3*r**2 + 52560*Dd**2*f**3*r*s - 41940*Dd**2*f**3*r + 23760*Dd**2*f**3*s**2 - 38160*Dd**2*f**3*s + 13560*Dd**2*f**3 + 28080*Dd**2*f**2*g2*r**2 + 48384*Dd**2*f**2*g2*r*s - 40176*Dd**2*f**2*g2*r + 20304*Dd**2*f**2*g2*s**2 - 34344*Dd**2*f**2*g2*s + 12744*Dd**2*f**2*g2 - 84*b1**2*(K - 1)*(D1**2*(fd*(r**2 + 15*r*s - 2*r + 14*s**2 - 2*s + 1) - 3*fdd*(r**2 + 5*r*s - 2*r + 4*s**2 - 2*s + 1)) + D1*(Dd*f*(4*r**2 + r*(60*s - 19) + 56*s**2 - 58*s + 16) - 3*Dd*fd*(8*r**2 + r*(40*s - 17) + 32*s**2 - 26*s + 6) - 3*Ddd*f*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 18*s + 6)) - 9*Dd**2*f*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 18*s + 4)) - 2*b1*(216*C*D1**2*f*fd*r**2 + 2088*C*D1**2*f*fd*r*s - 432*C*D1**2*f*fd*r + 1872*C*D1**2*f*fd*s**2 - 1260*C*D1**2*f*fd*s + 216*C*D1**2*f*fd - 360*C*D1**2*f*fdd*r**2 - 1800*C*D1**2*f*fdd*r*s + 720*C*D1**2*f*fdd*r - 1440*C*D1**2*f*fdd*s**2 + 1260*C*D1**2*f*fdd*s - 360*C*D1**2*f*fdd - 360*C*D1**2*fd**2*r**2 - 1800*C*D1**2*fd**2*r*s + 720*C*D1**2*fd**2*r - 1440*C*D1**2*fd**2*s**2 + 1260*C*D1**2*fd**2*s - 360*C*D1**2*fd**2 + 432*C*D1*Dd*f**2*r**2 + 4176*C*D1*Dd*f**2*r*s - 1476*C*D1*Dd*f**2*r + 3744*C*D1*Dd*f**2*s**2 - 3960*C*D1*Dd*f**2*s + 1152*C*D1*Dd*f**2 - 2880*C*D1*Dd*f*fd*r**2 - 14400*C*D1*Dd*f*fd*r*s + 6120*C*D1*Dd*f*fd*r - 11520*C*D1*Dd*f*fd*s**2 + 11520*C*D1*Dd*f*fd*s - 2700*C*D1*Dd*f*fd - 720*C*D1*Ddd*f**2*r**2 - 3600*C*D1*Ddd*f**2*r*s + 1620*C*D1*Ddd*f**2*r - 2880*C*D1*Ddd*f**2*s**2 + 3240*C*D1*Ddd*f**2*s - 1080*C*D1*Ddd*f**2 - 2160*C*Dd**2*f**2*r**2 - 10800*C*Dd**2*f**2*r*s + 4860*C*Dd**2*f**2*r - 8640*C*Dd**2*f**2*s**2 + 9720*C*Dd**2*f**2*s - 2160*C*Dd**2*f**2 - 954*D1**2*K*f*fd*r**2 - 2268*D1**2*K*f*fd*r*s + 1134*D1**2*K*f*fd*r - 1314*D1**2*K*f*fd*s**2 + 1314*D1**2*K*f*fd*s - 657*D1**2*K*f*fd + 1170*D1**2*K*f*fdd*r**2 + 2016*D1**2*K*f*fdd*r*s - 1008*D1**2*K*f*fdd*r + 846*D1**2*K*f*fdd*s**2 - 846*D1**2*K*f*fdd*s + 423*D1**2*K*f*fdd + 1170*D1**2*K*fd**2*r**2 + 2016*D1**2*K*fd**2*r*s - 1008*D1**2*K*fd**2*r + 846*D1**2*K*fd**2*s**2 - 846*D1**2*K*fd**2*s - 126*D1**2*bdd1*f*(K - 1)*(2*r**2 + 10*r*s - 5*r + 8*s**2 - 11*s + 4) + 945*D1**2*f**2*fd*r**2 + 1590*D1**2*f**2*fd*r*s - 930*D1**2*f**2*fd*r + 645*D1**2*f**2*fd*s**2 - 730*D1**2*f**2*fd*s + 180*D1**2*f**2*fd - 945*D1**2*f**2*fdd*r**2 - 1470*D1**2*f**2*fdd*r*s + 1050*D1**2*f**2*fdd*r - 525*D1**2*f**2*fdd*s**2 + 770*D1**2*f**2*fdd*s - 315*D1**2*f**2*fdd - 1890*D1**2*f*fd**2*r**2 - 2940*D1**2*f*fd**2*r*s + 2100*D1**2*f*fd**2*r - 1050*D1**2*f*fd**2*s**2 + 1540*D1**2*f*fd**2*s - 630*D1**2*f*fd**2 + 1188*D1**2*f*fd*r**2 + 1656*D1**2*f*fd*r*s - 1440*D1**2*f*fd*r + 468*D1**2*f*fd*s**2 - 1080*D1**2*f*fd*s + 954*D1**2*f*fd - 1350*D1**2*f*fdd*r**2 - 1836*D1**2*f*fdd*r*s + 1098*D1**2*f*fdd*r - 486*D1**2*f*fdd*s**2 + 666*D1**2*f*fdd*s - 603*D1**2*f*fdd - 84*D1**2*f*gd2*r**2 - 1260*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*r - 1176*D1**2*f*gd2*s**2 + 1260*D1**2*f*gd2*s - 84*D1**2*f*gd2 + 252*D1**2*f*gdd2*r**2 + 1260*D1**2*f*gdd2*r*s - 504*D1**2*f*gdd2*r + 1008*D1**2*f*gdd2*s**2 - 1260*D1**2*f*gdd2*s + 252*D1**2*f*gdd2 - 1350*D1**2*fd**2*r**2 - 1836*D1**2*fd**2*r*s + 1098*D1**2*fd**2*r - 486*D1**2*fd**2*s**2 + 666*D1**2*fd**2*s + 360*D1**2*fd**2 - 84*D1**2*fd*g2*r**2 - 1260*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*r - 1176*D1**2*fd*g2*s**2 + 168*D1**2*fd*g2*s - 84*D1**2*fd*g2 + 504*D1**2*fd*gd2*r**2 + 2520*D1**2*fd*gd2*r*s - 1008*D1**2*fd*gd2*r + 2016*D1**2*fd*gd2*s**2 - 1764*D1**2*fd*gd2*s + 504*D1**2*fd*gd2 + 252*D1**2*fdd*g2*r**2 + 1260*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*r + 1008*D1**2*fdd*g2*s**2 - 504*D1**2*fdd*g2*s + 252*D1**2*fdd*g2 - 1908*D1*Dd*K*f**2*r**2 - 4536*D1*Dd*K*f**2*r*s + 3042*D1*Dd*K*f**2*r - 2628*D1*Dd*K*f**2*s**2 + 3582*D1*Dd*K*f**2*s - 1611*D1*Dd*K*f**2 + 9360*D1*Dd*K*f*fd*r**2 + 16128*D1*Dd*K*f*fd*r*s - 10728*D1*Dd*K*f*fd*r + 6768*D1*Dd*K*f*fd*s**2 - 9108*D1*Dd*K*f*fd*s + 2862*D1*Dd*K*f*fd + 1260*D1*Dd*f**3*r**2 + 2120*D1*Dd*f**3*r*s - 1790*D1*Dd*f**3*r + 860*D1*Dd*f**3*s**2 - 1490*D1*Dd*f**3*s + 845*D1*Dd*f**3 - 7560*D1*Dd*f**2*fd*r**2 - 11760*D1*Dd*f**2*fd*r*s + 9450*D1*Dd*f**2*fd*r - 4200*D1*Dd*f**2*fd*s**2 + 7070*D1*Dd*f**2*fd*s - 2870*D1*Dd*f**2*fd + 2376*D1*Dd*f**2*r**2 + 3312*D1*Dd*f**2*r*s - 3204*D1*Dd*f**2*r + 936*D1*Dd*f**2*s**2 - 2124*D1*Dd*f**2*s + 1422*D1*Dd*f**2 - 10800*D1*Dd*f*fd*r**2 - 14688*D1*Dd*f*fd*r*s + 11628*D1*Dd*f*fd*r - 3888*D1*Dd*f*fd*s**2 + 7308*D1*Dd*f*fd*s - 2862*D1*Dd*f*fd - 336*D1*Dd*f*g2*r**2 - 5040*D1*Dd*f*g2*r*s + 1596*D1*Dd*f*g2*r - 4704*D1*Dd*f*g2*s**2 + 4872*D1*Dd*f*g2*s - 1344*D1*Dd*f*g2 + 2016*D1*Dd*f*gd2*r**2 + 10080*D1*Dd*f*gd2*r*s - 4284*D1*Dd*f*gd2*r + 8064*D1*Dd*f*gd2*s**2 - 9576*D1*Dd*f*gd2*s + 2268*D1*Dd*f*gd2 + 2016*D1*Dd*fd*g2*r**2 + 10080*D1*Dd*fd*g2*r*s - 4284*D1*Dd*fd*g2*r + 8064*D1*Dd*fd*g2*s**2 - 6552*D1*Dd*fd*g2*s + 1512*D1*Dd*fd*g2 + 2340*D1*Ddd*K*f**2*r**2 + 4032*D1*Ddd*K*f**2*r*s - 3348*D1*Ddd*K*f**2*r + 1692*D1*Ddd*K*f**2*s**2 - 2862*D1*Ddd*K*f**2*s + 1593*D1*Ddd*K*f**2 - 1260*D1*Ddd*f**3*r**2 - 1960*D1*Ddd*f**3*r*s + 1750*D1*Ddd*f**3*r - 700*D1*Ddd*f**3*s**2 + 1330*D1*Ddd*f**3*s - 805*D1*Ddd*f**3 - 2700*D1*Ddd*f**2*r**2 - 3672*D1*Ddd*f**2*r*s + 3618*D1*Ddd*f**2*r - 972*D1*Ddd*f**2*s**2 + 2322*D1*Ddd*f**2*s - 1593*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r**2 + 5040*D1*Ddd*f*g2*r*s - 2268*D1*Ddd*f*g2*r + 4032*D1*Ddd*f*g2*s**2 - 4536*D1*Ddd*f*g2*s + 1512*D1*Ddd*f*g2 + 42*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 30*r*s - 15*r + 28*s**2 - 41*s + 14) - 3*fd*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 15*s + 2)) - 3*Dd*f*(16*r**2 + r*(80*s - 38) + 64*s**2 - 80*s + 21)) + 7020*Dd**2*K*f**2*r**2 + 12096*Dd**2*K*f**2*r*s - 10044*Dd**2*K*f**2*r + 5076*Dd**2*K*f**2*s**2 - 8586*Dd**2*K*f**2*s + 3186*Dd**2*K*f**2 - 3780*Dd**2*f**3*r**2 - 5880*Dd**2*f**3*r*s + 5250*Dd**2*f**3*r - 2100*Dd**2*f**3*s**2 + 3990*Dd**2*f**3*s - 1610*Dd**2*f**3 - 8100*Dd**2*f**2*r**2 - 11016*Dd**2*f**2*r*s + 10854*Dd**2*f**2*r - 2916*Dd**2*f**2*s**2 + 6966*Dd**2*f**2*s - 3186*Dd**2*f**2 + 3024*Dd**2*f*g2*r**2 + 15120*Dd**2*f*g2*r*s - 6804*Dd**2*f*g2*r + 12096*Dd**2*f*g2*s**2 - 13608*Dd**2*f*g2*s + 3024*Dd**2*f*g2))/(315*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**5*k1**3*st**2*(D1**2*(441*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(1323*fd**2*s*(2*s - 1) - fd*(440*C - 440)*(3*s**2 - 2*s + 1) + fdd*(220*C - 220)*(3*s**2 - 2*s + 1) + s**2*(198*K*bdd1 - 396*bd1*(K - 1) - 198*bdd1 + 792*gd2 - 396*gdd2)) - 88*f*(fd**2*s*(10*C - 10)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 1584*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(441*f**3*(4*s**2 - 2*s + 1) + f**2*(440*C*(4*s**2 - 2*s + 1) - 441*fd*(1 - 4*s)**2 - 1760*s**2 + 880*s - 440) - 44*f*(fd*(10*C - 10)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 792*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(441*f**2 + f*(440*C - 440) - 792*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(441*f**2 + f*(440*C - 440) - 792*g2) + 396*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2*k3**4) - 4*D1**2*Pk2*Pk3*ct**5*k1**3*(b1*(D1**2*(14*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(28*fd**2*s*(2 - 3*s) + 18*fd*(2*s**2 - 2*s + 1) - 9*fdd*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)) + D1*f*(2*Dd*(14*f**2*(4*s**2 - 2*s + 1) - 14*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(14*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(14*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(28*bd1 - 14*bdd1) + f*(-14*fd*(s**2*(6*bd1 - 3) - s*(2*bd1 - 2) - 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(-2*Dd*(7*f*(s**2*(8*bd1 - 4) - s*(2*bd1 - 2) - 1) + (4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1))) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2**3*k3**2) + 4*D1**2*Pk2*Pk3*ct**5*k1*k2**5*st**2*(-120*C*D1**2*f**2*fd*r**2 - 240*C*D1**2*f**2*fd*r*s + 160*C*D1**2*f**2*fd*r - 120*C*D1**2*f**2*fd*s**2 + 160*C*D1**2*f**2*fd*s - 80*C*D1**2*f**2*fd + 60*C*D1**2*f**2*fdd*r**2 + 120*C*D1**2*f**2*fdd*r*s - 80*C*D1**2*f**2*fdd*r + 60*C*D1**2*f**2*fdd*s**2 - 80*C*D1**2*f**2*fdd*s + 40*C*D1**2*f**2*fdd + 120*C*D1**2*f*fd**2*r**2 + 240*C*D1**2*f*fd**2*r*s - 160*C*D1**2*f*fd**2*r + 120*C*D1**2*f*fd**2*s**2 - 160*C*D1**2*f*fd**2*s + 40*C*D1**2*f*fd**2 - 160*C*D1*Dd*f**3*r**2 - 320*C*D1*Dd*f**3*r*s + 240*C*D1*Dd*f**3*r - 160*C*D1*Dd*f**3*s**2 + 240*C*D1*Dd*f**3*s - 120*C*D1*Dd*f**3 + 480*C*D1*Dd*f**2*fd*r**2 + 960*C*D1*Dd*f**2*fd*r*s - 680*C*D1*Dd*f**2*fd*r + 480*C*D1*Dd*f**2*fd*s**2 - 680*C*D1*Dd*f**2*fd*s + 240*C*D1*Dd*f**2*fd + 80*C*D1*Ddd*f**3*r**2 + 160*C*D1*Ddd*f**3*r*s - 120*C*D1*Ddd*f**3*r + 80*C*D1*Ddd*f**3*s**2 - 120*C*D1*Ddd*f**3*s + 60*C*D1*Ddd*f**3 + 240*C*Dd**2*f**3*r**2 + 480*C*Dd**2*f**3*r*s - 360*C*Dd**2*f**3*r + 240*C*Dd**2*f**3*s**2 - 360*C*Dd**2*f**3*s + 120*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 - 144*D1**2*K*b1*f*fd*r*s + 72*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 + 90*D1**2*f**2*fd*r**2 + 180*D1**2*f**2*fd*r*s - 120*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 45*D1**2*f**2*fdd*r**2 - 90*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 45*D1**2*f**2*fdd*s**2 + 60*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r - 36*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 90*D1**2*f*fd**2*r**2 - 180*D1**2*f*fd**2*r*s + 120*D1**2*f*fd**2*r - 90*D1**2*f*fd**2*s**2 + 120*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 - 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 216*D1*Dd*K*b1*f**2*s - 108*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r**2 + 576*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 360*D1*Dd*K*b1*f*fd*s + 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 120*D1*Dd*f**3*r**2 + 240*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r + 120*D1*Dd*f**3*s**2 - 180*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r**2 - 720*D1*Dd*f**2*fd*r*s + 510*D1*Dd*f**2*fd*r - 360*D1*Dd*f**2*fd*s**2 + 510*D1*Dd*f**2*fd*s - 180*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 504*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 720*D1*Dd*f*fd*g2*s - 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 + 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 108*D1*Ddd*K*b1*f**2*s + 54*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 60*D1*Ddd*f**3*r**2 - 120*D1*Ddd*f**3*r*s + 90*D1*Ddd*f**3*r - 60*D1*Ddd*f**3*s**2 + 90*D1*Ddd*f**3*s - 45*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 216*D1*Ddd*f**2*g2*s - 108*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*b1*f**2*r**2 + 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 324*Dd**2*K*b1*f**2*s + 108*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 180*Dd**2*f**3*r**2 - 360*Dd**2*f**3*r*s + 270*Dd**2*f**3*r - 180*Dd**2*f**3*s**2 + 270*Dd**2*f**3*s - 90*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 648*Dd**2*f**2*g2*s - 216*Dd**2*f**2*g2)/(7*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**5*k1*k2**5*(180*C*D1**2*bdd1*f**2*r**2 + 360*C*D1**2*bdd1*f**2*r*s - 360*C*D1**2*bdd1*f**2*r + 180*C*D1**2*bdd1*f**2*s**2 - 360*C*D1**2*bdd1*f**2*s + 180*C*D1**2*bdd1*f**2 - 600*C*D1**2*f**2*fd*r**2 - 1200*C*D1**2*f**2*fd*r*s + 800*C*D1**2*f**2*fd*r - 600*C*D1**2*f**2*fd*s**2 + 800*C*D1**2*f**2*fd*s - 400*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r**2 + 1680*C*D1**2*f**2*fdd*r*s - 1120*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 1120*C*D1**2*f**2*fdd*s + 560*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r**2 + 3360*C*D1**2*f*fd**2*r*s - 2240*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 2240*C*D1**2*f*fd**2*s + 560*C*D1**2*f*fd**2 - 800*C*D1*Dd*f**3*r**2 - 1600*C*D1*Dd*f**3*r*s + 1200*C*D1*Dd*f**3*r - 800*C*D1*Dd*f**3*s**2 + 1200*C*D1*Dd*f**3*s - 600*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r**2 + 13440*C*D1*Dd*f**2*fd*r*s - 9520*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 9520*C*D1*Dd*f**2*fd*s + 3360*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r**2 + 2240*C*D1*Ddd*f**3*r*s - 1680*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1680*C*D1*Ddd*f**3*s + 840*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r**2 + 6720*C*Dd**2*f**3*r*s - 5040*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 5040*C*Dd**2*f**3*s + 1680*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r**2 + 360*D1**2*K*bdd1*f**2*r*s - 360*D1**2*K*bdd1*f**2*r + 180*D1**2*K*bdd1*f**2*s**2 - 360*D1**2*K*bdd1*f**2*s + 180*D1**2*K*bdd1*f**2 - 18*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 135*D1**2*bdd1*f**2*r**2 - 270*D1**2*bdd1*f**2*r*s + 270*D1**2*bdd1*f**2*r - 135*D1**2*bdd1*f**2*s**2 + 270*D1**2*bdd1*f**2*s - 135*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r**2 - 504*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 252*D1**2*bdd1*f*g2*s**2 + 504*D1**2*bdd1*f*g2*s - 252*D1**2*bdd1*f*g2 + 165*D1**2*f**2*fd*r**2 + 330*D1**2*f**2*fd*r*s - 220*D1**2*f**2*fd*r + 165*D1**2*f**2*fd*s**2 - 220*D1**2*f**2*fd*s + 110*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd + 216*D1**2*f**2*gd2*r**2 + 432*D1**2*f**2*gd2*r*s - 432*D1**2*f**2*gd2*r + 216*D1**2*f**2*gd2*s**2 - 432*D1**2*f**2*gd2*s + 216*D1**2*f**2*gd2 - 360*D1**2*f**2*gdd2*r**2 - 720*D1**2*f**2*gdd2*r*s + 720*D1**2*f**2*gdd2*r - 360*D1**2*f**2*gdd2*s**2 + 720*D1**2*f**2*gdd2*s - 360*D1**2*f**2*gdd2 - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 432*D1**2*f*fd*g2*r**2 + 864*D1**2*f*fd*g2*r*s - 432*D1**2*f*fd*g2*r + 432*D1**2*f*fd*g2*s**2 - 432*D1**2*f*fd*g2*s + 216*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r**2 - 2880*D1**2*f*fd*gd2*r*s + 2160*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 2160*D1**2*f*fd*gd2*s - 720*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r**2 - 1440*D1**2*f*fdd*g2*r*s + 720*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r**2 - 1440*D1**2*fd**2*g2*r*s + 720*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s + 220*D1*Dd*f**3*r**2 + 440*D1*Dd*f**3*r*s - 330*D1*Dd*f**3*r + 220*D1*Dd*f**3*s**2 - 330*D1*Dd*f**3*s + 165*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd + 864*D1*Dd*f**2*g2*r**2 + 1728*D1*Dd*f**2*g2*r*s - 1296*D1*Dd*f**2*g2*r + 864*D1*Dd*f**2*g2*s**2 - 1296*D1*Dd*f**2*g2*s + 648*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r**2 - 5760*D1*Dd*f**2*gd2*r*s + 5040*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 5040*D1*Dd*f**2*gd2*s - 2160*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r**2 - 11520*D1*Dd*f*fd*g2*r*s + 7200*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 7200*D1*Dd*f*fd*g2*s - 2160*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r**2 - 2880*D1*Ddd*f**2*g2*r*s + 2160*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 2160*D1*Ddd*f**2*g2*s - 1080*D1*Ddd*f**2*g2 - 9*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(40*C + 12*K - 23)*(r + s - 1) - 10*f*fd*(4*C + 4*K - 3)*(2*r + 2*s - 1) - 56*f*(g2 - gd2)*(r + s - 1) + 56*fd*g2*(r + s)) - 2*Dd*f*(5*f*(4*C + 4*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r**2 - 8640*Dd**2*f**2*g2*r*s + 6480*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 6480*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 + 9*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(-80*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s + 80*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 80*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 240*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 240*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 400*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 46*D1**2*f*fd*r**2 + 92*D1**2*f*fd*r*s - 46*D1**2*f*fd*r + 46*D1**2*f*fd*s**2 - 46*D1**2*f*fd*s + 23*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 92*D1*Dd*f**2*r**2 + 184*D1*Dd*f**2*r*s - 138*D1*Dd*f**2*r + 92*D1*Dd*f**2*s**2 - 138*D1*Dd*f**2*s + 69*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(105*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**5*k1*k2**3*st**2*(-2328*C*D1**2*f**2*fd*r**2 + 1272*C*D1**2*f**2*fd*r*s + 1128*C*D1**2*f**2*fd*r + 3600*C*D1**2*f**2*fd*s**2 - 2824*C*D1**2*f**2*fd*s + 424*C*D1**2*f**2*fd + 1380*C*D1**2*f**2*fdd*r**2 - 420*C*D1**2*f**2*fdd*r*s - 780*C*D1**2*f**2*fdd*r - 1800*C*D1**2*f**2*fdd*s**2 + 1340*C*D1**2*f**2*fdd*s - 140*C*D1**2*f**2*fdd + 2760*C*D1**2*f*fd**2*r**2 - 840*C*D1**2*f*fd**2*r*s - 1560*C*D1**2*f*fd**2*r - 3600*C*D1**2*f*fd**2*s**2 + 2680*C*D1**2*f*fd**2*s - 140*C*D1**2*f*fd**2 - 3104*C*D1*Dd*f**3*r**2 + 1696*C*D1*Dd*f**3*r*s + 2680*C*D1*Dd*f**3*r + 4800*C*D1*Dd*f**3*s**2 - 3248*C*D1*Dd*f**3*s - 352*C*D1*Dd*f**3 + 11040*C*D1*Dd*f**2*fd*r**2 - 3360*C*D1*Dd*f**2*fd*r*s - 8220*C*D1*Dd*f**2*fd*r - 14400*C*D1*Dd*f**2*fd*s**2 + 9800*C*D1*Dd*f**2*fd*s + 220*C*D1*Dd*f**2*fd + 1840*C*D1*Ddd*f**3*r**2 - 560*C*D1*Ddd*f**3*r*s - 1700*C*D1*Ddd*f**3*r - 2400*C*D1*Ddd*f**3*s**2 + 1480*C*D1*Ddd*f**3*s + 320*C*D1*Ddd*f**3 + 5520*C*Dd**2*f**3*r**2 - 1680*C*Dd**2*f**3*r*s - 5100*C*Dd**2*f**3*r - 7200*C*Dd**2*f**3*s**2 + 4440*C*Dd**2*f**3*s + 640*C*Dd**2*f**3 - 1080*D1**2*K*b1*f*fd*r**2 + 1080*D1**2*K*b1*f*fd*r*s - 540*D1**2*K*b1*f*fd*r + 2160*D1**2*K*b1*f*fd*s**2 - 2160*D1**2*K*b1*f*fd*s + 1080*D1**2*K*b1*f*fd + 540*D1**2*K*b1*f*fdd*r**2 - 540*D1**2*K*b1*f*fdd*r*s + 270*D1**2*K*b1*f*fdd*r - 1080*D1**2*K*b1*f*fdd*s**2 + 1080*D1**2*K*b1*f*fdd*s - 540*D1**2*K*b1*f*fdd + 540*D1**2*K*b1*fd**2*r**2 - 540*D1**2*K*b1*fd**2*r*s + 270*D1**2*K*b1*fd**2*r - 1080*D1**2*K*b1*fd**2*s**2 + 1080*D1**2*K*b1*fd**2*s + 630*D1**2*b1*f**2*fd*r**2 - 420*D1**2*b1*f**2*fd*r - 630*D1**2*b1*f**2*fd*s**2 + 420*D1**2*b1*f**2*fd*s - 315*D1**2*b1*f**2*fdd*r**2 + 210*D1**2*b1*f**2*fdd*r + 315*D1**2*b1*f**2*fdd*s**2 - 210*D1**2*b1*f**2*fdd*s - 630*D1**2*b1*f*fd**2*r**2 + 420*D1**2*b1*f*fd**2*r + 630*D1**2*b1*f*fd**2*s**2 - 420*D1**2*b1*f*fd**2*s + 1620*D1**2*b1*f*fd*r**2 + 1080*D1**2*b1*f*fd*r*s - 540*D1**2*b1*f*fd*r - 540*D1**2*b1*f*fd*s**2 + 540*D1**2*b1*f*fd*s - 270*D1**2*b1*f*fd - 810*D1**2*b1*f*fdd*r**2 - 540*D1**2*b1*f*fdd*r*s + 270*D1**2*b1*f*fdd*r + 270*D1**2*b1*f*fdd*s**2 - 270*D1**2*b1*f*fdd*s + 135*D1**2*b1*f*fdd - 810*D1**2*b1*fd**2*r**2 - 540*D1**2*b1*fd**2*r*s + 270*D1**2*b1*fd**2*r + 270*D1**2*b1*fd**2*s**2 - 270*D1**2*b1*fd**2*s - 15*D1**2*bdd1*f**2*(r + s - 1)*(-18*K*(r - 2*s - 1) + 7*f*(r - s - 1) + 27*r - 9*s - 27) - 840*D1**2*f**3*fd*r**2 - 840*D1**2*f**3*fd*r*s + 1050*D1**2*f**3*fd*r + 420*D1**2*f**3*fd*s - 420*D1**2*f**3*fd + 840*D1**2*f**3*fdd*r**2 + 840*D1**2*f**3*fdd*r*s - 1050*D1**2*f**3*fdd*r - 420*D1**2*f**3*fdd*s + 420*D1**2*f**3*fdd + 2520*D1**2*f**2*fd**2*r**2 + 2520*D1**2*f**2*fd**2*r*s - 3150*D1**2*f**2*fd**2*r - 1260*D1**2*f**2*fd**2*s + 840*D1**2*f**2*fd**2 + 2778*D1**2*f**2*fd*r**2 + 528*D1**2*f**2*fd*r*s - 2028*D1**2*f**2*fd*r - 2250*D1**2*f**2*fd*s**2 + 1324*D1**2*f**2*fd*s + 176*D1**2*f**2*fd - 1605*D1**2*f**2*fdd*r**2 - 480*D1**2*f**2*fdd*r*s + 1230*D1**2*f**2*fdd*r + 1125*D1**2*f**2*fdd*s**2 - 590*D1**2*f**2*fdd*s - 160*D1**2*f**2*fdd + 1080*D1**2*f**2*gd2*r**2 - 1080*D1**2*f**2*gd2*r*s - 2160*D1**2*f**2*gd2*r - 2160*D1**2*f**2*gd2*s**2 + 1080*D1**2*f**2*gd2*s + 1080*D1**2*f**2*gd2 - 540*D1**2*f**2*gdd2*r**2 + 540*D1**2*f**2*gdd2*r*s + 1080*D1**2*f**2*gdd2*r + 1080*D1**2*f**2*gdd2*s**2 - 540*D1**2*f**2*gdd2*s - 540*D1**2*f**2*gdd2 - 3210*D1**2*f*fd**2*r**2 - 960*D1**2*f*fd**2*r*s + 2460*D1**2*f*fd**2*r + 2250*D1**2*f*fd**2*s**2 - 1180*D1**2*f*fd**2*s - 160*D1**2*f*fd**2 + 2160*D1**2*f*fd*g2*r**2 - 2160*D1**2*f*fd*g2*r*s + 1080*D1**2*f*fd*g2*r - 4320*D1**2*f*fd*g2*s**2 + 4320*D1**2*f*fd*g2*s - 2160*D1**2*f*fd*g2 - 2160*D1**2*f*fd*gd2*r**2 + 2160*D1**2*f*fd*gd2*r*s + 1620*D1**2*f*fd*gd2*r + 4320*D1**2*f*fd*gd2*s**2 - 3240*D1**2*f*fd*gd2*s + 540*D1**2*f*fd*gd2 - 1080*D1**2*f*fdd*g2*r**2 + 1080*D1**2*f*fdd*g2*r*s - 540*D1**2*f*fdd*g2*r + 2160*D1**2*f*fdd*g2*s**2 - 2160*D1**2*f*fdd*g2*s + 1080*D1**2*f*fdd*g2 - 1080*D1**2*fd**2*g2*r**2 + 1080*D1**2*fd**2*g2*r*s - 540*D1**2*fd**2*g2*r + 2160*D1**2*fd**2*g2*s**2 - 2160*D1**2*fd**2*g2*s - 2160*D1*Dd*K*b1*f**2*r**2 + 2160*D1*Dd*K*b1*f**2*r*s + 1620*D1*Dd*K*b1*f**2*r + 4320*D1*Dd*K*b1*f**2*s**2 - 3240*D1*Dd*K*b1*f**2*s + 4320*D1*Dd*K*b1*f*fd*r**2 - 4320*D1*Dd*K*b1*f*fd*r*s - 540*D1*Dd*K*b1*f*fd*r - 8640*D1*Dd*K*b1*f*fd*s**2 + 7560*D1*Dd*K*b1*f*fd*s - 1620*D1*Dd*K*b1*f*fd + 840*D1*Dd*b1*f**3*r**2 - 840*D1*Dd*b1*f**3*r - 840*D1*Dd*b1*f**3*s**2 + 420*D1*Dd*b1*f**3*s + 210*D1*Dd*b1*f**3 - 2520*D1*Dd*b1*f**2*fd*r**2 + 2100*D1*Dd*b1*f**2*fd*r + 2520*D1*Dd*b1*f**2*fd*s**2 - 1470*D1*Dd*b1*f**2*fd*s - 210*D1*Dd*b1*f**2*fd + 3240*D1*Dd*b1*f**2*r**2 + 2160*D1*Dd*b1*f**2*r*s - 3780*D1*Dd*b1*f**2*r - 1080*D1*Dd*b1*f**2*s**2 - 540*D1*Dd*b1*f**2*s + 1350*D1*Dd*b1*f**2 - 6480*D1*Dd*b1*f*fd*r**2 - 4320*D1*Dd*b1*f*fd*r*s + 4860*D1*Dd*b1*f*fd*r + 2160*D1*Dd*b1*f*fd*s**2 - 540*D1*Dd*b1*f*fd*s - 270*D1*Dd*b1*f*fd - 840*D1*Dd*f**4*r**2 - 840*D1*Dd*f**4*r*s + 1050*D1*Dd*f**4*r + 420*D1*Dd*f**4*s - 420*D1*Dd*f**4 + 6720*D1*Dd*f**3*fd*r**2 + 6720*D1*Dd*f**3*fd*r*s - 8400*D1*Dd*f**3*fd*r - 3360*D1*Dd*f**3*fd*s + 2520*D1*Dd*f**3*fd + 3704*D1*Dd*f**3*r**2 + 704*D1*Dd*f**3*r*s - 3880*D1*Dd*f**3*r - 3000*D1*Dd*f**3*s**2 + 1148*D1*Dd*f**3*s + 1102*D1*Dd*f**3 - 12840*D1*Dd*f**2*fd*r**2 - 3840*D1*Dd*f**2*fd*r*s + 11820*D1*Dd*f**2*fd*r + 9000*D1*Dd*f**2*fd*s**2 - 3650*D1*Dd*f**2*fd*s - 1870*D1*Dd*f**2*fd + 4320*D1*Dd*f**2*g2*r**2 - 4320*D1*Dd*f**2*g2*r*s - 3240*D1*Dd*f**2*g2*r - 8640*D1*Dd*f**2*g2*s**2 + 6480*D1*Dd*f**2*g2*s - 4320*D1*Dd*f**2*gd2*r**2 + 4320*D1*Dd*f**2*gd2*r*s + 5940*D1*Dd*f**2*gd2*r + 8640*D1*Dd*f**2*gd2*s**2 - 5400*D1*Dd*f**2*gd2*s - 1620*D1*Dd*f**2*gd2 - 8640*D1*Dd*f*fd*g2*r**2 + 8640*D1*Dd*f*fd*g2*r*s + 1080*D1*Dd*f*fd*g2*r + 17280*D1*Dd*f*fd*g2*s**2 - 15120*D1*Dd*f*fd*g2*s + 3240*D1*Dd*f*fd*g2 + 1080*D1*Ddd*K*b1*f**2*r**2 - 1080*D1*Ddd*K*b1*f**2*r*s - 810*D1*Ddd*K*b1*f**2*r - 2160*D1*Ddd*K*b1*f**2*s**2 + 1620*D1*Ddd*K*b1*f**2*s - 420*D1*Ddd*b1*f**3*r**2 + 420*D1*Ddd*b1*f**3*r + 420*D1*Ddd*b1*f**3*s**2 - 210*D1*Ddd*b1*f**3*s - 105*D1*Ddd*b1*f**3 - 1620*D1*Ddd*b1*f**2*r**2 - 1080*D1*Ddd*b1*f**2*r*s + 1890*D1*Ddd*b1*f**2*r + 540*D1*Ddd*b1*f**2*s**2 + 270*D1*Ddd*b1*f**2*s - 675*D1*Ddd*b1*f**2 + 840*D1*Ddd*f**4*r**2 + 840*D1*Ddd*f**4*r*s - 1050*D1*Ddd*f**4*r - 420*D1*Ddd*f**4*s + 420*D1*Ddd*f**4 - 2140*D1*Ddd*f**3*r**2 - 640*D1*Ddd*f**3*r*s + 2300*D1*Ddd*f**3*r + 1500*D1*Ddd*f**3*s**2 - 430*D1*Ddd*f**3*s - 695*D1*Ddd*f**3 - 2160*D1*Ddd*f**2*g2*r**2 + 2160*D1*Ddd*f**2*g2*r*s + 1620*D1*Ddd*f**2*g2*r + 4320*D1*Ddd*f**2*g2*s**2 - 3240*D1*Ddd*f**2*g2*s + 30*D1*bd1*f*(D1*(7*f**2*(r**2 - 2*r - s**2 + 1) + f*(-7*fd*(3*r**2 - 4*r - 3*s**2 + s + 1) + (-9*r - 9*s + 9)*(2*K*(r - 2*s - 1) - 3*r + s + 3)) + 9*fd*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1)) + Dd*f*(9*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 7*f*(4*r**2 - 6*r - 4*s**2 + s + 2) - 108*r**2 - 72*r*s + 171*r + 36*s**2 + 45*s - 63)) + 3240*Dd**2*K*b1*f**2*r**2 - 3240*Dd**2*K*b1*f**2*r*s - 2430*Dd**2*K*b1*f**2*r - 6480*Dd**2*K*b1*f**2*s**2 + 4860*Dd**2*K*b1*f**2*s - 1260*Dd**2*b1*f**3*r**2 + 1260*Dd**2*b1*f**3*r + 1260*Dd**2*b1*f**3*s**2 - 630*Dd**2*b1*f**3*s - 210*Dd**2*b1*f**3 - 4860*Dd**2*b1*f**2*r**2 - 3240*Dd**2*b1*f**2*r*s + 5670*Dd**2*b1*f**2*r + 1620*Dd**2*b1*f**2*s**2 + 810*Dd**2*b1*f**2*s - 1350*Dd**2*b1*f**2 + 2520*Dd**2*f**4*r**2 + 2520*Dd**2*f**4*r*s - 3150*Dd**2*f**4*r - 1260*Dd**2*f**4*s + 840*Dd**2*f**4 - 6420*Dd**2*f**3*r**2 - 1920*Dd**2*f**3*r*s + 6900*Dd**2*f**3*r + 4500*Dd**2*f**3*s**2 - 1290*Dd**2*f**3*s - 1390*Dd**2*f**3 - 6480*Dd**2*f**2*g2*r**2 + 6480*Dd**2*f**2*g2*r*s + 4860*Dd**2*f**2*g2*r + 12960*Dd**2*f**2*g2*s**2 - 9720*Dd**2*f**2*g2*s)/(315*d**2*k3**6) - 2*D1**2*Pk2*Pk3*ct**5*k1*k2**3*(144*C*D1**2*bdd1*f**2*r**2 - 216*C*D1**2*bdd1*f**2*r*s - 504*C*D1**2*bdd1*f**2*r - 360*C*D1**2*bdd1*f**2*s**2 - 9660*C*D1**2*f**2*fd*r**2 - 18480*C*D1**2*f**2*fd*r*s + 12600*C*D1**2*f**2*fd*r - 8820*C*D1**2*f**2*fd*s**2 + 12040*C*D1**2*f**2*fd*s - 6160*C*D1**2*f**2*fd + 8340*C*D1**2*f**2*fdd*r**2 + 15720*C*D1**2*f**2*fdd*r*s - 10800*C*D1**2*f**2*fdd*r + 7380*C*D1**2*f**2*fdd*s**2 - 10160*C*D1**2*f**2*fdd*s + 5240*C*D1**2*f**2*fdd + 16680*C*D1**2*f*fd**2*r**2 + 31440*C*D1**2*f*fd**2*r*s - 21600*C*D1**2*f*fd**2*r + 14760*C*D1**2*f*fd**2*s**2 - 20320*C*D1**2*f*fd**2*s + 5240*C*D1**2*f*fd**2 - 12880*C*D1*Dd*f**3*r**2 - 24640*C*D1*Dd*f**3*r*s + 19040*C*D1*Dd*f**3*r - 11760*C*D1*Dd*f**3*s**2 + 18200*C*D1*Dd*f**3*s - 9380*C*D1*Dd*f**3 + 66720*C*D1*Dd*f**2*fd*r**2 + 125760*C*D1*Dd*f**2*fd*r*s - 92280*C*D1*Dd*f**2*fd*r + 59040*C*D1*Dd*f**2*fd*s**2 - 86840*C*D1*Dd*f**2*fd*s + 31760*C*D1*Dd*f**2*fd + 11120*C*D1*Ddd*f**3*r**2 + 20960*C*D1*Ddd*f**3*r*s - 16360*C*D1*Ddd*f**3*r + 9840*C*D1*Ddd*f**3*s**2 - 15400*C*D1*Ddd*f**3*s + 8020*C*D1*Ddd*f**3 + 33360*C*Dd**2*f**3*r**2 + 62880*C*Dd**2*f**3*r*s - 49080*C*Dd**2*f**3*r + 29520*C*Dd**2*f**3*s**2 - 46200*C*Dd**2*f**3*s + 16040*C*Dd**2*f**3 + 1530*D1**2*K*bdd1*f**2*r**2 + 3204*D1**2*K*bdd1*f**2*r*s - 3060*D1**2*K*bdd1*f**2*r + 1674*D1**2*K*bdd1*f**2*s**2 - 3204*D1**2*K*bdd1*f**2*s + 1530*D1**2*K*bdd1*f**2 - 936*D1**2*b2*f*fd*r**2 - 1872*D1**2*b2*f*fd*r*s + 936*D1**2*b2*f*fd*r - 936*D1**2*b2*f*fd*s**2 + 936*D1**2*b2*f*fd*s - 468*D1**2*b2*f*fd + 720*D1**2*b2*f*fdd*r**2 + 1440*D1**2*b2*f*fdd*r*s - 720*D1**2*b2*f*fdd*r + 720*D1**2*b2*f*fdd*s**2 - 720*D1**2*b2*f*fdd*s + 360*D1**2*b2*f*fdd + 720*D1**2*b2*fd**2*r**2 + 1440*D1**2*b2*fd**2*r*s - 720*D1**2*b2*fd**2*r + 720*D1**2*b2*fd**2*s**2 - 720*D1**2*b2*fd**2*s + 36*D1**2*bd1**2*f*(r + s - 1)*(-14*K*s - 7*K + 5*f - 14*r + 14) - 468*D1**2*bd2*f**2*r**2 - 936*D1**2*bd2*f**2*r*s + 936*D1**2*bd2*f**2*r - 468*D1**2*bd2*f**2*s**2 + 936*D1**2*bd2*f**2*s - 468*D1**2*bd2*f**2 + 1440*D1**2*bd2*f*fd*r**2 + 2880*D1**2*bd2*f*fd*r*s - 2160*D1**2*bd2*f*fd*r + 1440*D1**2*bd2*f*fd*s**2 - 2160*D1**2*bd2*f*fd*s + 720*D1**2*bd2*f*fd - 495*D1**2*bdd1*f**3*r**2 - 990*D1**2*bdd1*f**3*r*s + 1170*D1**2*bdd1*f**3*r - 495*D1**2*bdd1*f**3*s**2 + 1170*D1**2*bdd1*f**3*s - 675*D1**2*bdd1*f**3 - 909*D1**2*bdd1*f**2*r**2 - 1386*D1**2*bdd1*f**2*r*s + 1854*D1**2*bdd1*f**2*r - 477*D1**2*bdd1*f**2*s**2 + 1422*D1**2*bdd1*f**2*s - 675*D1**2*bdd1*f**2 + 504*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r + 504*D1**2*bdd1*f*g2*s**2 + 360*D1**2*bdd2*f**2*r**2 + 720*D1**2*bdd2*f**2*r*s - 720*D1**2*bdd2*f**2*r + 360*D1**2*bdd2*f**2*s**2 - 720*D1**2*bdd2*f**2*s + 360*D1**2*bdd2*f**2 + 6135*D1**2*f**2*fd*r**2 + 11910*D1**2*f**2*fd*r*s - 8060*D1**2*f**2*fd*r + 5775*D1**2*f**2*fd*s**2 - 7820*D1**2*f**2*fd*s + 3970*D1**2*f**2*fd - 5835*D1**2*f**2*fdd*r**2 - 10950*D1**2*f**2*fdd*r*s + 7540*D1**2*f**2*fdd*r - 5115*D1**2*f**2*fdd*s**2 + 7060*D1**2*f**2*fdd*s - 3650*D1**2*f**2*fdd + 2844*D1**2*f**2*gd2*r**2 + 6768*D1**2*f**2*gd2*r*s - 5688*D1**2*f**2*gd2*r + 3924*D1**2*f**2*gd2*s**2 - 6768*D1**2*f**2*gd2*s + 2844*D1**2*f**2*gd2 - 3060*D1**2*f**2*gdd2*r**2 - 6408*D1**2*f**2*gdd2*r*s + 6120*D1**2*f**2*gdd2*r - 3348*D1**2*f**2*gdd2*s**2 + 6408*D1**2*f**2*gdd2*s - 3060*D1**2*f**2*gdd2 - 11670*D1**2*f*fd**2*r**2 - 21900*D1**2*f*fd**2*r*s + 15080*D1**2*f*fd**2*r - 10230*D1**2*f*fd**2*s**2 + 14120*D1**2*f*fd**2*s - 3650*D1**2*f*fd**2 + 5688*D1**2*f*fd*g2*r**2 + 13536*D1**2*f*fd*g2*r*s - 6768*D1**2*f*fd*g2*r + 7848*D1**2*f*fd*g2*s**2 - 7848*D1**2*f*fd*g2*s + 3924*D1**2*f*fd*g2 - 12240*D1**2*f*fd*gd2*r**2 - 25632*D1**2*f*fd*gd2*r*s + 18648*D1**2*f*fd*gd2*r - 13392*D1**2*f*fd*gd2*s**2 + 19512*D1**2*f*fd*gd2*s - 6408*D1**2*f*fd*gd2 - 6120*D1**2*f*fdd*g2*r**2 - 12816*D1**2*f*fdd*g2*r*s + 6408*D1**2*f*fdd*g2*r - 6696*D1**2*f*fdd*g2*s**2 + 6696*D1**2*f*fdd*g2*s - 3348*D1**2*f*fdd*g2 - 6120*D1**2*fd**2*g2*r**2 - 12816*D1**2*fd**2*g2*r*s + 6408*D1**2*fd**2*g2*r - 6696*D1**2*fd**2*g2*s**2 + 6696*D1**2*fd**2*g2*s - 1872*D1*Dd*b2*f**2*r**2 - 3744*D1*Dd*b2*f**2*r*s + 2808*D1*Dd*b2*f**2*r - 1872*D1*Dd*b2*f**2*s**2 + 2808*D1*Dd*b2*f**2*s - 1404*D1*Dd*b2*f**2 + 5760*D1*Dd*b2*f*fd*r**2 + 11520*D1*Dd*b2*f*fd*r*s - 7200*D1*Dd*b2*f*fd*r + 5760*D1*Dd*b2*f*fd*s**2 - 7200*D1*Dd*b2*f*fd*s + 2160*D1*Dd*b2*f*fd + 2880*D1*Dd*bd2*f**2*r**2 + 5760*D1*Dd*bd2*f**2*r*s - 5040*D1*Dd*bd2*f**2*r + 2880*D1*Dd*bd2*f**2*s**2 - 5040*D1*Dd*bd2*f**2*s + 2160*D1*Dd*bd2*f**2 + 8180*D1*Dd*f**3*r**2 + 15880*D1*Dd*f**3*r*s - 12150*D1*Dd*f**3*r + 7700*D1*Dd*f**3*s**2 - 11790*D1*Dd*f**3*s + 6015*D1*Dd*f**3 - 46680*D1*Dd*f**2*fd*r**2 - 87600*D1*Dd*f**2*fd*r*s + 64450*D1*Dd*f**2*fd*r - 40920*D1*Dd*f**2*fd*s**2 + 60370*D1*Dd*f**2*fd*s - 22140*D1*Dd*f**2*fd + 11376*D1*Dd*f**2*g2*r**2 + 27072*D1*Dd*f**2*g2*r*s - 18144*D1*Dd*f**2*g2*r + 15696*D1*Dd*f**2*g2*s**2 - 21384*D1*Dd*f**2*g2*s + 9612*D1*Dd*f**2*g2 - 24480*D1*Dd*f**2*gd2*r**2 - 51264*D1*Dd*f**2*gd2*r*s + 43128*D1*Dd*f**2*gd2*r - 26784*D1*Dd*f**2*gd2*s**2 + 45144*D1*Dd*f**2*gd2*s - 18648*D1*Dd*f**2*gd2 - 48960*D1*Dd*f*fd*g2*r**2 - 102528*D1*Dd*f*fd*g2*r*s + 62928*D1*Dd*f*fd*g2*r - 53568*D1*Dd*f*fd*g2*s**2 + 65808*D1*Dd*f*fd*g2*s - 19512*D1*Dd*f*fd*g2 + 1440*D1*Ddd*b2*f**2*r**2 + 2880*D1*Ddd*b2*f**2*r*s - 2160*D1*Ddd*b2*f**2*r + 1440*D1*Ddd*b2*f**2*s**2 - 2160*D1*Ddd*b2*f**2*s + 1080*D1*Ddd*b2*f**2 - 7780*D1*Ddd*f**3*r**2 - 14600*D1*Ddd*f**3*r*s + 11430*D1*Ddd*f**3*r - 6820*D1*Ddd*f**3*s**2 + 10710*D1*Ddd*f**3*s - 5595*D1*Ddd*f**3 - 12240*D1*Ddd*f**2*g2*r**2 - 25632*D1*Ddd*f**2*g2*r*s + 18648*D1*Ddd*f**2*g2*r - 13392*D1*Ddd*f**2*g2*s**2 + 19512*D1*Ddd*f**2*g2*s - 9468*D1*Ddd*f**2*g2 + 9*D1*bd1*(D1*(5*f**3*(7*r**2 + 18*r*(s - 1) + 11*(s - 1)**2) + f**2*(-32*C*r**2 + 48*C*r*s + 112*C*r + 80*C*s**2 - 2*K*(79*r**2 + 2*r*(94*s - 79) + 109*s**2 - 188*s + 79) - 10*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) + 97*r**2 + 126*r*s - 202*r + 29*s**2 - 134*s + 45) + 2*f*(fd*(4*C*(8*r**2 - 4*r*(3*s + 2) - 20*s**2 + 13*s + 7) + 2*K*(170*r**2 + 356*r*s - 259*r + 186*s**2 - 271*s + 89) - 202*r**2 - 308*r*s + 281*r - 106*s**2 + 209*s - 107) - 56*g2*(r*s + r + s**2) + 28*gd2*(2*s + 1)*(r + s - 1)) + 56*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + f*(-4*C*(16*r**2 - 3*r*(8*s + 11) - 40*s**2 + 16*s + 14) - 2*K*(340*r**2 + 712*r*s - 599*r + 372*s**2 - 627*s + 259) + 404*r**2 + 616*r*s - 691*r + 212*s**2 - 523*s + 285) - 28*g2*(r*(8*s + 3) + 8*s**2 - 4*s - 2))) + 4320*Dd**2*b2*f**2*r**2 + 8640*Dd**2*b2*f**2*r*s - 6480*Dd**2*b2*f**2*r + 4320*Dd**2*b2*f**2*s**2 - 6480*Dd**2*b2*f**2*s + 2160*Dd**2*b2*f**2 - 23340*Dd**2*f**3*r**2 - 43800*Dd**2*f**3*r*s + 34290*Dd**2*f**3*r - 20460*Dd**2*f**3*s**2 + 32130*Dd**2*f**3*s - 11190*Dd**2*f**3 - 36720*Dd**2*f**2*g2*r**2 - 76896*Dd**2*f**2*g2*r*s + 55944*Dd**2*f**2*g2*r - 40176*Dd**2*f**2*g2*s**2 + 58536*Dd**2*f**2*g2*s - 18936*Dd**2*f**2*g2 + 18*b1**2*(D1**2*(10*f*fd*(2*r + 2*s - 1) - 5*f*fdd*(2*r + 2*s - 1) - 10*fd**2*(r + s - 1) + 14*fd*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1) - 7*fdd*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1)) - 2*D1*(Dd*(f*(-14*K*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(4*r + 4*s - 3) - 56*r**2 - 56*r*s + 70*r + 28*s - 28) + 7*fd*(K*(8*r*s - 9*r + 8*s**2 - 12*s + 6) + 8*r**2 + 8*r*s - r + 2*s - 3)) + 7*Ddd*f*(K*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - 14*Dd**2*f*(K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) - 9*b1*(64*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r - 160*C*D1**2*f*fd*s**2 + 208*C*D1**2*f*fd*s - 48*C*D1**2*f*fd - 32*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 - 104*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd - 32*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 - 104*C*D1**2*fd**2*s + 80*C*D1**2*fd**2 + 128*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s - 80*C*D1*Dd*f**2*r - 320*C*D1*Dd*f**2*s**2 + 256*C*D1*Dd*f**2*s - 16*C*D1*Dd*f**2 - 256*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 112*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 672*C*D1*Dd*f*fd*s + 200*C*D1*Dd*f*fd - 64*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s + 40*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 128*C*D1*Ddd*f**2*s + 8*C*D1*Ddd*f**2 - 192*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s + 120*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 384*C*Dd**2*f**2*s + 16*C*Dd**2*f**2 + 316*D1**2*K*f*fd*r**2 + 752*D1**2*K*f*fd*r*s - 376*D1**2*K*f*fd*r + 436*D1**2*K*f*fd*s**2 - 436*D1**2*K*f*fd*s + 218*D1**2*K*f*fd - 340*D1**2*K*f*fdd*r**2 - 712*D1**2*K*f*fdd*r*s + 356*D1**2*K*f*fdd*r - 372*D1**2*K*f*fdd*s**2 + 372*D1**2*K*f*fdd*s - 186*D1**2*K*f*fdd - 340*D1**2*K*fd**2*r**2 - 712*D1**2*K*fd**2*r*s + 356*D1**2*K*fd**2*r - 372*D1**2*K*fd**2*s**2 + 372*D1**2*K*fd**2*s + 2*D1**2*bdd1*f*(28*K*s**2 - 5*f*(2*r + 2*s - 1) + 28*r**2 + 14*r*(2*K*s + K + 2*s - 4) - 7*s*(2*K + 4) + 21) - 105*D1**2*f**2*fd*r**2 - 270*D1**2*f**2*fd*r*s + 140*D1**2*f**2*fd*r - 165*D1**2*f**2*fd*s**2 + 180*D1**2*f**2*fd*s - 70*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 194*D1**2*f*fd*r**2 - 252*D1**2*f*fd*r*s + 118*D1**2*f*fd*r - 58*D1**2*f*fd*s**2 + 50*D1**2*f*fd*s - 81*D1**2*f*fd + 202*D1**2*f*fdd*r**2 + 308*D1**2*f*fdd*r*s - 150*D1**2*f*fdd*r + 106*D1**2*f*fdd*s**2 - 102*D1**2*f*fdd*s + 79*D1**2*f*fdd + 112*D1**2*f*gd2*r*s + 112*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s - 56*D1**2*f*gdd2*r*s - 56*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s + 202*D1**2*fd**2*r**2 + 308*D1**2*fd**2*r*s - 150*D1**2*fd**2*r + 106*D1**2*fd**2*s**2 - 102*D1**2*fd**2*s - 60*D1**2*fd**2 + 112*D1**2*fd*g2*r*s - 224*D1**2*fd*g2*r + 112*D1**2*fd*g2*s**2 - 224*D1**2*fd*g2*s + 112*D1**2*fd*g2 - 112*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 112*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 112*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r*s + 112*D1**2*fdd*g2*r - 56*D1**2*fdd*g2*s**2 + 112*D1**2*fdd*g2*s - 56*D1**2*fdd*g2 + 632*D1*Dd*K*f**2*r**2 + 1504*D1*Dd*K*f**2*r*s - 1008*D1*Dd*K*f**2*r + 872*D1*Dd*K*f**2*s**2 - 1188*D1*Dd*K*f**2*s + 534*D1*Dd*K*f**2 - 2720*D1*Dd*K*f*fd*r**2 - 5696*D1*Dd*K*f*fd*r*s + 3496*D1*Dd*K*f*fd*r - 2976*D1*Dd*K*f*fd*s**2 + 3656*D1*Dd*K*f*fd*s - 1084*D1*Dd*K*f*fd - 140*D1*Dd*f**3*r**2 - 360*D1*Dd*f**3*r*s + 230*D1*Dd*f**3*r - 220*D1*Dd*f**3*s**2 + 290*D1*Dd*f**3*s - 125*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1790*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 388*D1*Dd*f**2*r**2 - 504*D1*Dd*f**2*r*s + 514*D1*Dd*f**2*r - 116*D1*Dd*f**2*s**2 + 310*D1*Dd*f**2*s - 223*D1*Dd*f**2 + 1616*D1*Dd*f*fd*r**2 + 2464*D1*Dd*f*fd*r*s - 1716*D1*Dd*f*fd*r + 848*D1*Dd*f*fd*s**2 - 1236*D1*Dd*f*fd*s + 402*D1*Dd*f*fd + 448*D1*Dd*f*g2*r*s - 112*D1*Dd*f*g2*r + 448*D1*Dd*f*g2*s**2 - 448*D1*Dd*f*g2*s + 112*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r*s + 56*D1*Dd*f*gd2*r - 448*D1*Dd*f*gd2*s**2 + 448*D1*Dd*f*gd2*s - 56*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 448*D1*Dd*fd*g2*s**2 + 672*D1*Dd*fd*g2*s - 336*D1*Dd*fd*g2 - 680*D1*Ddd*K*f**2*r**2 - 1424*D1*Ddd*K*f**2*r*s + 1036*D1*Ddd*K*f**2*r - 744*D1*Ddd*K*f**2*s**2 + 1084*D1*Ddd*K*f**2*s - 526*D1*Ddd*K*f**2 + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 404*D1*Ddd*f**2*r**2 + 616*D1*Ddd*f**2*r*s - 558*D1*Ddd*f**2*r + 212*D1*Ddd*f**2*s**2 - 414*D1*Ddd*f**2*s + 255*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r*s + 56*D1*Ddd*f*g2*r - 224*D1*Ddd*f*g2*s**2 + 224*D1*Ddd*f*g2*s - 56*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(2*r + 2*s - 1) - 7*f*(4*K*s**2 + 4*r**2 + 2*r*(2*K*s + K + 2*s - 4) - s*(2*K + 4) + 3) + 7*fd*(K*(r*(4*s - 3) + 4*s**2 - 5*s + 2) + 4*r**2 + r*(4*s - 2) - 1)) + Dd*f*(7*K*(2*r*(8*s + 1) + 16*s**2 - 12*s - 1) - 5*f*(4*r + 4*s - 3) + 112*r**2 + 14*r*(8*s - 13) - 84*s + 70)) - 2040*Dd**2*K*f**2*r**2 - 4272*Dd**2*K*f**2*r*s + 3108*Dd**2*K*f**2*r - 2232*Dd**2*K*f**2*s**2 + 3252*Dd**2*K*f**2*s - 1052*Dd**2*K*f**2 + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 330*Dd**2*f**3 + 1212*Dd**2*f**2*r**2 + 1848*Dd**2*f**2*r*s - 1674*Dd**2*f**2*r + 636*Dd**2*f**2*s**2 - 1242*Dd**2*f**2*s + 510*Dd**2*f**2 - 672*Dd**2*f*g2*r*s + 168*Dd**2*f*g2*r - 672*Dd**2*f*g2*s**2 + 672*Dd**2*f*g2*s - 112*Dd**2*f*g2))/(315*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**5*k1*st**2*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 18*fd*(2*s**2 - 2*s + 1) - 9*fdd*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) + f*(fd*(-s**2*(42*bd1 - 30) + s*(14*bd1 - 20) + 10) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(-2*Dd*(f*(s**2*(28*bd1 - 20) + s*(10 - 7*bd1) - 5) + (4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1))) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k2*k3**2) - 12*D1**2*Pk2*Pk3*ct**5*k1*(-D1*f*s*(2*D1*bd1**2*s*(5*f + 7) + 5*D1*bdd1*f*s + 10*bd1*(-D1*(f*s - 2*fd*s + fd) + Dd*f*(4*s - 1))) + b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) + f*(-10*fd*(s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(28*bd1 - 14*bdd1)) - 2*fd*s*(14*bd1 + 5*fd)*(s - 1)) + D1*f*(-2*Dd*(5*f*(s**2*(8*bd1 - 4) - s*(2*bd1 - 2) - 1) + (4*s - 1)*(14*bd1*s + 5*fd*(2*s - 1))) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2**3) - 16*D1**2*Pk2*Pk3*ct**4*f**2*k1**6*(D1**2*(f*(7*fd - 9*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 9*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(7*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(4*s - 1)*(4*r + 4*s - 3)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(99*d**2*k2**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**4*k1**6*(1650*C*D1**2*f**2*fd*r**2 + 3300*C*D1**2*f**2*fd*r*s - 2200*C*D1**2*f**2*fd*r + 1650*C*D1**2*f**2*fd*s**2 - 2200*C*D1**2*f**2*fd*s + 1100*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r**2 - 4620*C*D1**2*f**2*fdd*r*s + 3080*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 3080*C*D1**2*f**2*fdd*s - 1540*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r**2 - 9240*C*D1**2*f*fd**2*r*s + 6160*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 6160*C*D1**2*f*fd**2*s - 1540*C*D1**2*f*fd**2 + 2200*C*D1*Dd*f**3*r**2 + 4400*C*D1*Dd*f**3*r*s - 3300*C*D1*Dd*f**3*r + 2200*C*D1*Dd*f**3*s**2 - 3300*C*D1*Dd*f**3*s + 1650*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r**2 - 36960*C*D1*Dd*f**2*fd*r*s + 26180*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 26180*C*D1*Dd*f**2*fd*s - 9240*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r**2 - 6160*C*D1*Ddd*f**3*r*s + 4620*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 4620*C*D1*Ddd*f**3*s - 2310*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r**2 - 18480*C*Dd**2*f**3*r*s + 13860*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 13860*C*Dd**2*f**3*s - 4620*C*Dd**2*f**3 + 594*D1**2*K*b1*f*fd*r**2 + 1188*D1**2*K*b1*f*fd*r*s - 594*D1**2*K*b1*f*fd*r + 594*D1**2*K*b1*f*fd*s**2 - 594*D1**2*K*b1*f*fd*s + 297*D1**2*K*b1*f*fd - 990*D1**2*K*b1*f*fdd*r**2 - 1980*D1**2*K*b1*f*fdd*r*s + 990*D1**2*K*b1*f*fdd*r - 990*D1**2*K*b1*f*fdd*s**2 + 990*D1**2*K*b1*f*fdd*s - 495*D1**2*K*b1*f*fdd - 990*D1**2*K*b1*fd**2*r**2 - 1980*D1**2*K*b1*fd**2*r*s + 990*D1**2*K*b1*fd**2*r - 990*D1**2*K*b1*fd**2*s**2 + 990*D1**2*K*b1*fd**2*s - 594*D1**2*b1*f*fd*r**2 - 1188*D1**2*b1*f*fd*r*s + 594*D1**2*b1*f*fd*r - 594*D1**2*b1*f*fd*s**2 + 594*D1**2*b1*f*fd*s - 297*D1**2*b1*f*fd + 990*D1**2*b1*f*fdd*r**2 + 1980*D1**2*b1*f*fdd*r*s - 990*D1**2*b1*f*fdd*r + 990*D1**2*b1*f*fdd*s**2 - 990*D1**2*b1*f*fdd*s + 495*D1**2*b1*f*fdd + 990*D1**2*b1*fd**2*r**2 + 1980*D1**2*b1*fd**2*r*s - 990*D1**2*b1*fd**2*r + 990*D1**2*b1*fd**2*s**2 - 990*D1**2*b1*fd**2*s - 495*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 4900*D1**2*f**3*fd*r**2 + 9800*D1**2*f**3*fd*r*s - 7350*D1**2*f**3*fd*r + 4900*D1**2*f**3*fd*s**2 - 7350*D1**2*f**3*fd*s + 3675*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 1650*D1**2*f**2*fd*r**2 - 3300*D1**2*f**2*fd*r*s + 2200*D1**2*f**2*fd*r - 1650*D1**2*f**2*fd*s**2 + 2200*D1**2*f**2*fd*s - 1100*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r**2 + 4620*D1**2*f**2*fdd*r*s - 3080*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 3080*D1**2*f**2*fdd*s + 1540*D1**2*f**2*fdd - 594*D1**2*f**2*gd2*r**2 - 1188*D1**2*f**2*gd2*r*s + 1188*D1**2*f**2*gd2*r - 594*D1**2*f**2*gd2*s**2 + 1188*D1**2*f**2*gd2*s - 594*D1**2*f**2*gd2 + 990*D1**2*f**2*gdd2*r**2 + 1980*D1**2*f**2*gdd2*r*s - 1980*D1**2*f**2*gdd2*r + 990*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 990*D1**2*f**2*gdd2 + 4620*D1**2*f*fd**2*r**2 + 9240*D1**2*f*fd**2*r*s - 6160*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 6160*D1**2*f*fd**2*s + 1540*D1**2*f*fd**2 - 1188*D1**2*f*fd*g2*r**2 - 2376*D1**2*f*fd*g2*r*s + 1188*D1**2*f*fd*g2*r - 1188*D1**2*f*fd*g2*s**2 + 1188*D1**2*f*fd*g2*s - 594*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r**2 + 7920*D1**2*f*fd*gd2*r*s - 5940*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 5940*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r**2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r**2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 1188*D1*Dd*K*b1*f**2*r**2 + 2376*D1*Dd*K*b1*f**2*r*s - 1782*D1*Dd*K*b1*f**2*r + 1188*D1*Dd*K*b1*f**2*s**2 - 1782*D1*Dd*K*b1*f**2*s + 891*D1*Dd*K*b1*f**2 - 7920*D1*Dd*K*b1*f*fd*r**2 - 15840*D1*Dd*K*b1*f*fd*r*s + 9900*D1*Dd*K*b1*f*fd*r - 7920*D1*Dd*K*b1*f*fd*s**2 + 9900*D1*Dd*K*b1*f*fd*s - 2970*D1*Dd*K*b1*f*fd - 1188*D1*Dd*b1*f**2*r**2 - 2376*D1*Dd*b1*f**2*r*s + 1782*D1*Dd*b1*f**2*r - 1188*D1*Dd*b1*f**2*s**2 + 1782*D1*Dd*b1*f**2*s - 891*D1*Dd*b1*f**2 + 7920*D1*Dd*b1*f*fd*r**2 + 15840*D1*Dd*b1*f*fd*r*s - 9900*D1*Dd*b1*f*fd*r + 7920*D1*Dd*b1*f*fd*s**2 - 9900*D1*Dd*b1*f*fd*s + 2970*D1*Dd*b1*f*fd + 4900*D1*Dd*f**4*r**2 + 9800*D1*Dd*f**4*r*s - 7350*D1*Dd*f**4*r + 4900*D1*Dd*f**4*s**2 - 7350*D1*Dd*f**4*s + 3675*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 2200*D1*Dd*f**3*r**2 - 4400*D1*Dd*f**3*r*s + 3300*D1*Dd*f**3*r - 2200*D1*Dd*f**3*s**2 + 3300*D1*Dd*f**3*s - 1650*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r**2 + 36960*D1*Dd*f**2*fd*r*s - 26180*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 26180*D1*Dd*f**2*fd*s + 9240*D1*Dd*f**2*fd - 2376*D1*Dd*f**2*g2*r**2 - 4752*D1*Dd*f**2*g2*r*s + 3564*D1*Dd*f**2*g2*r - 2376*D1*Dd*f**2*g2*s**2 + 3564*D1*Dd*f**2*g2*s - 1782*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r**2 + 15840*D1*Dd*f**2*gd2*r*s - 13860*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 13860*D1*Dd*f**2*gd2*s + 5940*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r**2 + 31680*D1*Dd*f*fd*g2*r*s - 19800*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 19800*D1*Dd*f*fd*g2*s + 5940*D1*Dd*f*fd*g2 - 1980*D1*Ddd*K*b1*f**2*r**2 - 3960*D1*Ddd*K*b1*f**2*r*s + 2970*D1*Ddd*K*b1*f**2*r - 1980*D1*Ddd*K*b1*f**2*s**2 + 2970*D1*Ddd*K*b1*f**2*s - 1485*D1*Ddd*K*b1*f**2 + 1980*D1*Ddd*b1*f**2*r**2 + 3960*D1*Ddd*b1*f**2*r*s - 2970*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s**2 - 2970*D1*Ddd*b1*f**2*s + 1485*D1*Ddd*b1*f**2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r**2 + 6160*D1*Ddd*f**3*r*s - 4620*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 4620*D1*Ddd*f**3*s + 2310*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r**2 + 7920*D1*Ddd*f**2*g2*r*s - 5940*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 5940*D1*Ddd*f**2*g2*s + 2970*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 5940*Dd**2*K*b1*f**2*r**2 - 11880*Dd**2*K*b1*f**2*r*s + 8910*Dd**2*K*b1*f**2*r - 5940*Dd**2*K*b1*f**2*s**2 + 8910*Dd**2*K*b1*f**2*s - 2970*Dd**2*K*b1*f**2 + 5940*Dd**2*b1*f**2*r**2 + 11880*Dd**2*b1*f**2*r*s - 8910*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s**2 - 8910*Dd**2*b1*f**2*s + 2970*Dd**2*b1*f**2 - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 9240*Dd**2*f**3*r**2 + 18480*Dd**2*f**3*r*s - 13860*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 13860*Dd**2*f**3*s + 4620*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r**2 + 23760*Dd**2*f**2*g2*r*s - 17820*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 17820*Dd**2*f**2*g2*s + 5940*Dd**2*f**2*g2)/(1155*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**4*k1**4*k2**2*st**2*(4356*C*D1**2*f**2*fd*r**2 + 8712*C*D1**2*f**2*fd*r*s - 5808*C*D1**2*f**2*fd*r + 4356*C*D1**2*f**2*fd*s**2 - 5808*C*D1**2*f**2*fd*s + 2904*C*D1**2*f**2*fd - 3960*C*D1**2*f**2*fdd*r**2 - 7920*C*D1**2*f**2*fdd*r*s + 5280*C*D1**2*f**2*fdd*r - 3960*C*D1**2*f**2*fdd*s**2 + 5280*C*D1**2*f**2*fdd*s - 2640*C*D1**2*f**2*fdd - 7920*C*D1**2*f*fd**2*r**2 - 15840*C*D1**2*f*fd**2*r*s + 10560*C*D1**2*f*fd**2*r - 7920*C*D1**2*f*fd**2*s**2 + 10560*C*D1**2*f*fd**2*s - 2640*C*D1**2*f*fd**2 + 5808*C*D1*Dd*f**3*r**2 + 11616*C*D1*Dd*f**3*r*s - 8712*C*D1*Dd*f**3*r + 5808*C*D1*Dd*f**3*s**2 - 8712*C*D1*Dd*f**3*s + 4356*C*D1*Dd*f**3 - 31680*C*D1*Dd*f**2*fd*r**2 - 63360*C*D1*Dd*f**2*fd*r*s + 44880*C*D1*Dd*f**2*fd*r - 31680*C*D1*Dd*f**2*fd*s**2 + 44880*C*D1*Dd*f**2*fd*s - 15840*C*D1*Dd*f**2*fd - 5280*C*D1*Ddd*f**3*r**2 - 10560*C*D1*Ddd*f**3*r*s + 7920*C*D1*Ddd*f**3*r - 5280*C*D1*Ddd*f**3*s**2 + 7920*C*D1*Ddd*f**3*s - 3960*C*D1*Ddd*f**3 - 15840*C*Dd**2*f**3*r**2 - 31680*C*Dd**2*f**3*r*s + 23760*C*Dd**2*f**3*r - 15840*C*Dd**2*f**3*s**2 + 23760*C*Dd**2*f**3*s - 7920*C*Dd**2*f**3 + 1980*D1**2*K*b1*f*fd*r**2 + 3960*D1**2*K*b1*f*fd*r*s - 1980*D1**2*K*b1*f*fd*r + 1980*D1**2*K*b1*f*fd*s**2 - 1980*D1**2*K*b1*f*fd*s + 990*D1**2*K*b1*f*fd - 2376*D1**2*K*b1*f*fdd*r**2 - 4752*D1**2*K*b1*f*fdd*r*s + 2376*D1**2*K*b1*f*fdd*r - 2376*D1**2*K*b1*f*fdd*s**2 + 2376*D1**2*K*b1*f*fdd*s - 1188*D1**2*K*b1*f*fdd - 2376*D1**2*K*b1*fd**2*r**2 - 4752*D1**2*K*b1*fd**2*r*s + 2376*D1**2*K*b1*fd**2*r - 2376*D1**2*K*b1*fd**2*s**2 + 2376*D1**2*K*b1*fd**2*s - 1980*D1**2*b1*f*fd*r**2 - 3960*D1**2*b1*f*fd*r*s + 1980*D1**2*b1*f*fd*r - 1980*D1**2*b1*f*fd*s**2 + 1980*D1**2*b1*f*fd*s - 990*D1**2*b1*f*fd + 2376*D1**2*b1*f*fdd*r**2 + 4752*D1**2*b1*f*fdd*r*s - 2376*D1**2*b1*f*fdd*r + 2376*D1**2*b1*f*fdd*s**2 - 2376*D1**2*b1*f*fdd*s + 1188*D1**2*b1*f*fdd + 2376*D1**2*b1*fd**2*r**2 + 4752*D1**2*b1*fd**2*r*s - 2376*D1**2*b1*fd**2*r + 2376*D1**2*b1*fd**2*s**2 - 2376*D1**2*b1*fd**2*s - 1188*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 8500*D1**2*f**3*fd*r**2 + 17000*D1**2*f**3*fd*r*s - 12750*D1**2*f**3*fd*r + 8500*D1**2*f**3*fd*s**2 - 12750*D1**2*f**3*fd*s + 6375*D1**2*f**3*fd - 7000*D1**2*f**3*fdd*r**2 - 14000*D1**2*f**3*fdd*r*s + 10500*D1**2*f**3*fdd*r - 7000*D1**2*f**3*fdd*s**2 + 10500*D1**2*f**3*fdd*s - 5250*D1**2*f**3*fdd - 21000*D1**2*f**2*fd**2*r**2 - 42000*D1**2*f**2*fd**2*r*s + 31500*D1**2*f**2*fd**2*r - 21000*D1**2*f**2*fd**2*s**2 + 31500*D1**2*f**2*fd**2*s - 10500*D1**2*f**2*fd**2 - 4356*D1**2*f**2*fd*r**2 - 8712*D1**2*f**2*fd*r*s + 5808*D1**2*f**2*fd*r - 4356*D1**2*f**2*fd*s**2 + 5808*D1**2*f**2*fd*s - 2904*D1**2*f**2*fd + 3960*D1**2*f**2*fdd*r**2 + 7920*D1**2*f**2*fdd*r*s - 5280*D1**2*f**2*fdd*r + 3960*D1**2*f**2*fdd*s**2 - 5280*D1**2*f**2*fdd*s + 2640*D1**2*f**2*fdd - 1980*D1**2*f**2*gd2*r**2 - 3960*D1**2*f**2*gd2*r*s + 3960*D1**2*f**2*gd2*r - 1980*D1**2*f**2*gd2*s**2 + 3960*D1**2*f**2*gd2*s - 1980*D1**2*f**2*gd2 + 2376*D1**2*f**2*gdd2*r**2 + 4752*D1**2*f**2*gdd2*r*s - 4752*D1**2*f**2*gdd2*r + 2376*D1**2*f**2*gdd2*s**2 - 4752*D1**2*f**2*gdd2*s + 2376*D1**2*f**2*gdd2 + 7920*D1**2*f*fd**2*r**2 + 15840*D1**2*f*fd**2*r*s - 10560*D1**2*f*fd**2*r + 7920*D1**2*f*fd**2*s**2 - 10560*D1**2*f*fd**2*s + 2640*D1**2*f*fd**2 - 3960*D1**2*f*fd*g2*r**2 - 7920*D1**2*f*fd*g2*r*s + 3960*D1**2*f*fd*g2*r - 3960*D1**2*f*fd*g2*s**2 + 3960*D1**2*f*fd*g2*s - 1980*D1**2*f*fd*g2 + 9504*D1**2*f*fd*gd2*r**2 + 19008*D1**2*f*fd*gd2*r*s - 14256*D1**2*f*fd*gd2*r + 9504*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4752*D1**2*f*fd*gd2 + 4752*D1**2*f*fdd*g2*r**2 + 9504*D1**2*f*fdd*g2*r*s - 4752*D1**2*f*fdd*g2*r + 4752*D1**2*f*fdd*g2*s**2 - 4752*D1**2*f*fdd*g2*s + 2376*D1**2*f*fdd*g2 + 4752*D1**2*fd**2*g2*r**2 + 9504*D1**2*fd**2*g2*r*s - 4752*D1**2*fd**2*g2*r + 4752*D1**2*fd**2*g2*s**2 - 4752*D1**2*fd**2*g2*s + 3960*D1*Dd*K*b1*f**2*r**2 + 7920*D1*Dd*K*b1*f**2*r*s - 5940*D1*Dd*K*b1*f**2*r + 3960*D1*Dd*K*b1*f**2*s**2 - 5940*D1*Dd*K*b1*f**2*s + 2970*D1*Dd*K*b1*f**2 - 19008*D1*Dd*K*b1*f*fd*r**2 - 38016*D1*Dd*K*b1*f*fd*r*s + 23760*D1*Dd*K*b1*f*fd*r - 19008*D1*Dd*K*b1*f*fd*s**2 + 23760*D1*Dd*K*b1*f*fd*s - 7128*D1*Dd*K*b1*f*fd - 3960*D1*Dd*b1*f**2*r**2 - 7920*D1*Dd*b1*f**2*r*s + 5940*D1*Dd*b1*f**2*r - 3960*D1*Dd*b1*f**2*s**2 + 5940*D1*Dd*b1*f**2*s - 2970*D1*Dd*b1*f**2 + 19008*D1*Dd*b1*f*fd*r**2 + 38016*D1*Dd*b1*f*fd*r*s - 23760*D1*Dd*b1*f*fd*r + 19008*D1*Dd*b1*f*fd*s**2 - 23760*D1*Dd*b1*f*fd*s + 7128*D1*Dd*b1*f*fd + 8500*D1*Dd*f**4*r**2 + 17000*D1*Dd*f**4*r*s - 12750*D1*Dd*f**4*r + 8500*D1*Dd*f**4*s**2 - 12750*D1*Dd*f**4*s + 6375*D1*Dd*f**4 - 56000*D1*Dd*f**3*fd*r**2 - 112000*D1*Dd*f**3*fd*r*s + 84000*D1*Dd*f**3*fd*r - 56000*D1*Dd*f**3*fd*s**2 + 84000*D1*Dd*f**3*fd*s - 31500*D1*Dd*f**3*fd - 5808*D1*Dd*f**3*r**2 - 11616*D1*Dd*f**3*r*s + 8712*D1*Dd*f**3*r - 5808*D1*Dd*f**3*s**2 + 8712*D1*Dd*f**3*s - 4356*D1*Dd*f**3 + 31680*D1*Dd*f**2*fd*r**2 + 63360*D1*Dd*f**2*fd*r*s - 44880*D1*Dd*f**2*fd*r + 31680*D1*Dd*f**2*fd*s**2 - 44880*D1*Dd*f**2*fd*s + 15840*D1*Dd*f**2*fd - 7920*D1*Dd*f**2*g2*r**2 - 15840*D1*Dd*f**2*g2*r*s + 11880*D1*Dd*f**2*g2*r - 7920*D1*Dd*f**2*g2*s**2 + 11880*D1*Dd*f**2*g2*s - 5940*D1*Dd*f**2*g2 + 19008*D1*Dd*f**2*gd2*r**2 + 38016*D1*Dd*f**2*gd2*r*s - 33264*D1*Dd*f**2*gd2*r + 19008*D1*Dd*f**2*gd2*s**2 - 33264*D1*Dd*f**2*gd2*s + 14256*D1*Dd*f**2*gd2 + 38016*D1*Dd*f*fd*g2*r**2 + 76032*D1*Dd*f*fd*g2*r*s - 47520*D1*Dd*f*fd*g2*r + 38016*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 - 4752*D1*Ddd*K*b1*f**2*r**2 - 9504*D1*Ddd*K*b1*f**2*r*s + 7128*D1*Ddd*K*b1*f**2*r - 4752*D1*Ddd*K*b1*f**2*s**2 + 7128*D1*Ddd*K*b1*f**2*s - 3564*D1*Ddd*K*b1*f**2 + 4752*D1*Ddd*b1*f**2*r**2 + 9504*D1*Ddd*b1*f**2*r*s - 7128*D1*Ddd*b1*f**2*r + 4752*D1*Ddd*b1*f**2*s**2 - 7128*D1*Ddd*b1*f**2*s + 3564*D1*Ddd*b1*f**2 - 7000*D1*Ddd*f**4*r**2 - 14000*D1*Ddd*f**4*r*s + 10500*D1*Ddd*f**4*r - 7000*D1*Ddd*f**4*s**2 + 10500*D1*Ddd*f**4*s - 5250*D1*Ddd*f**4 + 5280*D1*Ddd*f**3*r**2 + 10560*D1*Ddd*f**3*r*s - 7920*D1*Ddd*f**3*r + 5280*D1*Ddd*f**3*s**2 - 7920*D1*Ddd*f**3*s + 3960*D1*Ddd*f**3 + 9504*D1*Ddd*f**2*g2*r**2 + 19008*D1*Ddd*f**2*g2*r*s - 14256*D1*Ddd*f**2*g2*r + 9504*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 7128*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 14256*Dd**2*K*b1*f**2*r**2 - 28512*Dd**2*K*b1*f**2*r*s + 21384*Dd**2*K*b1*f**2*r - 14256*Dd**2*K*b1*f**2*s**2 + 21384*Dd**2*K*b1*f**2*s - 7128*Dd**2*K*b1*f**2 + 14256*Dd**2*b1*f**2*r**2 + 28512*Dd**2*b1*f**2*r*s - 21384*Dd**2*b1*f**2*r + 14256*Dd**2*b1*f**2*s**2 - 21384*Dd**2*b1*f**2*s + 7128*Dd**2*b1*f**2 - 21000*Dd**2*f**4*r**2 - 42000*Dd**2*f**4*r*s + 31500*Dd**2*f**4*r - 21000*Dd**2*f**4*s**2 + 31500*Dd**2*f**4*s - 10500*Dd**2*f**4 + 15840*Dd**2*f**3*r**2 + 31680*Dd**2*f**3*r*s - 23760*Dd**2*f**3*r + 15840*Dd**2*f**3*s**2 - 23760*Dd**2*f**3*s + 7920*Dd**2*f**3 + 28512*Dd**2*f**2*g2*r**2 + 57024*Dd**2*f**2*g2*r*s - 42768*Dd**2*f**2*g2*r + 28512*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 14256*Dd**2*f**2*g2)/(385*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**4*k1**4*k2**2*(-540*C*D1**2*bdd1*f**2*r**2 - 1080*C*D1**2*bdd1*f**2*r*s + 1080*C*D1**2*bdd1*f**2*r - 540*C*D1**2*bdd1*f**2*s**2 + 1080*C*D1**2*bdd1*f**2*s - 540*C*D1**2*bdd1*f**2 + 930*C*D1**2*f**2*fd*r**2 + 1860*C*D1**2*f**2*fd*r*s - 1240*C*D1**2*f**2*fd*r + 930*C*D1**2*f**2*fd*s**2 - 1240*C*D1**2*f**2*fd*s + 620*C*D1**2*f**2*fd - 1680*C*D1**2*f**2*fdd*r**2 - 3360*C*D1**2*f**2*fdd*r*s + 2240*C*D1**2*f**2*fdd*r - 1680*C*D1**2*f**2*fdd*s**2 + 2240*C*D1**2*f**2*fdd*s - 1120*C*D1**2*f**2*fdd - 3360*C*D1**2*f*fd**2*r**2 - 6720*C*D1**2*f*fd**2*r*s + 4480*C*D1**2*f*fd**2*r - 3360*C*D1**2*f*fd**2*s**2 + 4480*C*D1**2*f*fd**2*s - 1120*C*D1**2*f*fd**2 + 1240*C*D1*Dd*f**3*r**2 + 2480*C*D1*Dd*f**3*r*s - 1860*C*D1*Dd*f**3*r + 1240*C*D1*Dd*f**3*s**2 - 1860*C*D1*Dd*f**3*s + 930*C*D1*Dd*f**3 - 13440*C*D1*Dd*f**2*fd*r**2 - 26880*C*D1*Dd*f**2*fd*r*s + 19040*C*D1*Dd*f**2*fd*r - 13440*C*D1*Dd*f**2*fd*s**2 + 19040*C*D1*Dd*f**2*fd*s - 6720*C*D1*Dd*f**2*fd - 2240*C*D1*Ddd*f**3*r**2 - 4480*C*D1*Ddd*f**3*r*s + 3360*C*D1*Ddd*f**3*r - 2240*C*D1*Ddd*f**3*s**2 + 3360*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 6720*C*Dd**2*f**3*r**2 - 13440*C*Dd**2*f**3*r*s + 10080*C*Dd**2*f**3*r - 6720*C*Dd**2*f**3*s**2 + 10080*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 360*D1**2*K*bdd1*f**2*r**2 - 720*D1**2*K*bdd1*f**2*r*s + 720*D1**2*K*bdd1*f**2*r - 360*D1**2*K*bdd1*f**2*s**2 + 720*D1**2*K*bdd1*f**2*s - 360*D1**2*K*bdd1*f**2 - 756*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 720*D1**2*bdd1*f**2*r**2 + 1440*D1**2*bdd1*f**2*r*s - 1440*D1**2*bdd1*f**2*r + 720*D1**2*bdd1*f**2*s**2 - 1440*D1**2*bdd1*f**2*s + 720*D1**2*bdd1*f**2 + 756*D1**2*bdd1*f*g2*r**2 + 1512*D1**2*bdd1*f*g2*r*s - 1512*D1**2*bdd1*f*g2*r + 756*D1**2*bdd1*f*g2*s**2 - 1512*D1**2*bdd1*f*g2*s + 756*D1**2*bdd1*f*g2 - 420*D1**2*f**3*fd*r**2 - 840*D1**2*f**3*fd*r*s + 630*D1**2*f**3*fd*r - 420*D1**2*f**3*fd*s**2 + 630*D1**2*f**3*fd*s - 315*D1**2*f**3*fd - 630*D1**2*f**2*fd*r**2 - 1260*D1**2*f**2*fd*r*s + 840*D1**2*f**2*fd*r - 630*D1**2*f**2*fd*s**2 + 840*D1**2*f**2*fd*s - 420*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 2520*D1**2*f**2*fdd*r*s - 1680*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1680*D1**2*f**2*fdd*s + 840*D1**2*f**2*fdd - 306*D1**2*f**2*gd2*r**2 - 612*D1**2*f**2*gd2*r*s + 612*D1**2*f**2*gd2*r - 306*D1**2*f**2*gd2*s**2 + 612*D1**2*f**2*gd2*s - 306*D1**2*f**2*gd2 + 720*D1**2*f**2*gdd2*r**2 + 1440*D1**2*f**2*gdd2*r*s - 1440*D1**2*f**2*gdd2*r + 720*D1**2*f**2*gdd2*s**2 - 1440*D1**2*f**2*gdd2*s + 720*D1**2*f**2*gdd2 + 2520*D1**2*f*fd**2*r**2 + 5040*D1**2*f*fd**2*r*s - 3360*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 3360*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 612*D1**2*f*fd*g2*r**2 - 1224*D1**2*f*fd*g2*r*s + 612*D1**2*f*fd*g2*r - 612*D1**2*f*fd*g2*s**2 + 612*D1**2*f*fd*g2*s - 306*D1**2*f*fd*g2 + 2880*D1**2*f*fd*gd2*r**2 + 5760*D1**2*f*fd*gd2*r*s - 4320*D1**2*f*fd*gd2*r + 2880*D1**2*f*fd*gd2*s**2 - 4320*D1**2*f*fd*gd2*s + 1440*D1**2*f*fd*gd2 + 1440*D1**2*f*fdd*g2*r**2 + 2880*D1**2*f*fdd*g2*r*s - 1440*D1**2*f*fdd*g2*r + 1440*D1**2*f*fdd*g2*s**2 - 1440*D1**2*f*fdd*g2*s + 720*D1**2*f*fdd*g2 + 1440*D1**2*fd**2*g2*r**2 + 2880*D1**2*fd**2*g2*r*s - 1440*D1**2*fd**2*g2*r + 1440*D1**2*fd**2*g2*s**2 - 1440*D1**2*fd**2*g2*s - 420*D1*Dd*f**4*r**2 - 840*D1*Dd*f**4*r*s + 630*D1*Dd*f**4*r - 420*D1*Dd*f**4*s**2 + 630*D1*Dd*f**4*s - 315*D1*Dd*f**4 - 840*D1*Dd*f**3*r**2 - 1680*D1*Dd*f**3*r*s + 1260*D1*Dd*f**3*r - 840*D1*Dd*f**3*s**2 + 1260*D1*Dd*f**3*s - 630*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 20160*D1*Dd*f**2*fd*r*s - 14280*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 14280*D1*Dd*f**2*fd*s + 5040*D1*Dd*f**2*fd - 1224*D1*Dd*f**2*g2*r**2 - 2448*D1*Dd*f**2*g2*r*s + 1836*D1*Dd*f**2*g2*r - 1224*D1*Dd*f**2*g2*s**2 + 1836*D1*Dd*f**2*g2*s - 918*D1*Dd*f**2*g2 + 5760*D1*Dd*f**2*gd2*r**2 + 11520*D1*Dd*f**2*gd2*r*s - 10080*D1*Dd*f**2*gd2*r + 5760*D1*Dd*f**2*gd2*s**2 - 10080*D1*Dd*f**2*gd2*s + 4320*D1*Dd*f**2*gd2 + 11520*D1*Dd*f*fd*g2*r**2 + 23040*D1*Dd*f*fd*g2*r*s - 14400*D1*Dd*f*fd*g2*r + 11520*D1*Dd*f*fd*g2*s**2 - 14400*D1*Dd*f*fd*g2*s + 4320*D1*Dd*f*fd*g2 + 1680*D1*Ddd*f**3*r**2 + 3360*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 2520*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 2880*D1*Ddd*f**2*g2*r**2 + 5760*D1*Ddd*f**2*g2*r*s - 4320*D1*Ddd*f**2*g2*r + 2880*D1*Ddd*f**2*g2*s**2 - 4320*D1*Ddd*f**2*g2*s + 2160*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(30*f**3*(r + s - 1) + 3*f**2*(50*C + 17*K - 55)*(r + s - 1) - 2*f*(60*fd*(3*C + 2*K - 4)*(2*r + 2*s - 1) + (77*g2 - 252*gd2)*(r + s - 1)) + 504*fd*g2*(r + s)) - 24*Dd*f*(5*f*(3*C + 2*K - 4) - 21*g2)*(4*r + 4*s - 3))*(r + s - 1) + 5040*Dd**2*f**3*r**2 + 10080*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 7560*Dd**2*f**3*s + 2520*Dd**2*f**3 + 8640*Dd**2*f**2*g2*r**2 + 17280*Dd**2*f**2*g2*r*s - 12960*Dd**2*f**2*g2*r + 8640*Dd**2*f**2*g2*s**2 - 12960*Dd**2*f**2*g2*s + 4320*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(11*fd - 18*fdd)*(r + s)**2 + D1*(Dd*(11*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 36*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 18*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(300*C*D1**2*f*fd*r**2 + 600*C*D1**2*f*fd*r*s - 300*C*D1**2*f*fd*r + 300*C*D1**2*f*fd*s**2 - 300*C*D1**2*f*fd*s + 150*C*D1**2*f*fd - 360*C*D1**2*f*fdd*r**2 - 720*C*D1**2*f*fdd*r*s + 360*C*D1**2*f*fdd*r - 360*C*D1**2*f*fdd*s**2 + 360*C*D1**2*f*fdd*s - 180*C*D1**2*f*fdd - 360*C*D1**2*fd**2*r**2 - 720*C*D1**2*fd**2*r*s + 360*C*D1**2*fd**2*r - 360*C*D1**2*fd**2*s**2 + 360*C*D1**2*fd**2*s + 600*C*D1*Dd*f**2*r**2 + 1200*C*D1*Dd*f**2*r*s - 900*C*D1*Dd*f**2*r + 600*C*D1*Dd*f**2*s**2 - 900*C*D1*Dd*f**2*s + 450*C*D1*Dd*f**2 - 2880*C*D1*Dd*f*fd*r**2 - 5760*C*D1*Dd*f*fd*r*s + 3600*C*D1*Dd*f*fd*r - 2880*C*D1*Dd*f*fd*s**2 + 3600*C*D1*Dd*f*fd*s - 1080*C*D1*Dd*f*fd - 720*C*D1*Ddd*f**2*r**2 - 1440*C*D1*Ddd*f**2*r*s + 1080*C*D1*Ddd*f**2*r - 720*C*D1*Ddd*f**2*s**2 + 1080*C*D1*Ddd*f**2*s - 540*C*D1*Ddd*f**2 - 2160*C*Dd**2*f**2*r**2 - 4320*C*Dd**2*f**2*r*s + 3240*C*Dd**2*f**2*r - 2160*C*Dd**2*f**2*s**2 + 3240*C*Dd**2*f**2*s - 1080*C*Dd**2*f**2 + 102*D1**2*K*f*fd*r**2 + 204*D1**2*K*f*fd*r*s - 102*D1**2*K*f*fd*r + 102*D1**2*K*f*fd*s**2 - 102*D1**2*K*f*fd*s + 51*D1**2*K*f*fd - 240*D1**2*K*f*fdd*r**2 - 480*D1**2*K*f*fdd*r*s + 240*D1**2*K*f*fdd*r - 240*D1**2*K*f*fdd*s**2 + 240*D1**2*K*f*fdd*s - 120*D1**2*K*f*fdd - 240*D1**2*K*fd**2*r**2 - 480*D1**2*K*fd**2*r*s + 240*D1**2*K*fd**2*r - 240*D1**2*K*fd**2*s**2 + 240*D1**2*K*fd**2*s - 252*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 90*D1**2*f**2*fd*r**2 + 180*D1**2*f**2*fd*r*s - 120*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 330*D1**2*f*fd*r**2 - 660*D1**2*f*fd*r*s + 330*D1**2*f*fd*r - 330*D1**2*f*fd*s**2 + 330*D1**2*f*fd*s - 165*D1**2*f*fd + 480*D1**2*f*fdd*r**2 + 960*D1**2*f*fdd*r*s - 480*D1**2*f*fdd*r + 480*D1**2*f*fdd*s**2 - 480*D1**2*f*fdd*s + 240*D1**2*f*fdd - 154*D1**2*f*gd2*r**2 - 308*D1**2*f*gd2*r*s + 308*D1**2*f*gd2*r - 154*D1**2*f*gd2*s**2 + 308*D1**2*f*gd2*s - 154*D1**2*f*gd2 + 252*D1**2*f*gdd2*r**2 + 504*D1**2*f*gdd2*r*s - 504*D1**2*f*gdd2*r + 252*D1**2*f*gdd2*s**2 - 504*D1**2*f*gdd2*s + 252*D1**2*f*gdd2 + 480*D1**2*fd**2*r**2 + 960*D1**2*fd**2*r*s - 480*D1**2*fd**2*r + 480*D1**2*fd**2*s**2 - 480*D1**2*fd**2*s - 154*D1**2*fd*g2*r**2 - 308*D1**2*fd*g2*r*s - 154*D1**2*fd*g2*s**2 + 504*D1**2*fd*gd2*r**2 + 1008*D1**2*fd*gd2*r*s - 504*D1**2*fd*gd2*r + 504*D1**2*fd*gd2*s**2 - 504*D1**2*fd*gd2*s + 252*D1**2*fdd*g2*r**2 + 504*D1**2*fdd*g2*r*s + 252*D1**2*fdd*g2*s**2 + 204*D1*Dd*K*f**2*r**2 + 408*D1*Dd*K*f**2*r*s - 306*D1*Dd*K*f**2*r + 204*D1*Dd*K*f**2*s**2 - 306*D1*Dd*K*f**2*s + 153*D1*Dd*K*f**2 - 1920*D1*Dd*K*f*fd*r**2 - 3840*D1*Dd*K*f*fd*r*s + 2400*D1*Dd*K*f*fd*r - 1920*D1*Dd*K*f*fd*s**2 + 2400*D1*Dd*K*f*fd*s - 720*D1*Dd*K*f*fd + 120*D1*Dd*f**3*r**2 + 240*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r + 120*D1*Dd*f**3*s**2 - 180*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 660*D1*Dd*f**2*r**2 - 1320*D1*Dd*f**2*r*s + 990*D1*Dd*f**2*r - 660*D1*Dd*f**2*s**2 + 990*D1*Dd*f**2*s - 495*D1*Dd*f**2 + 3840*D1*Dd*f*fd*r**2 + 7680*D1*Dd*f*fd*r*s - 4800*D1*Dd*f*fd*r + 3840*D1*Dd*f*fd*s**2 - 4800*D1*Dd*f*fd*s + 1440*D1*Dd*f*fd - 616*D1*Dd*f*g2*r**2 - 1232*D1*Dd*f*g2*r*s + 924*D1*Dd*f*g2*r - 616*D1*Dd*f*g2*s**2 + 924*D1*Dd*f*g2*s - 462*D1*Dd*f*g2 + 2016*D1*Dd*f*gd2*r**2 + 4032*D1*Dd*f*gd2*r*s - 3528*D1*Dd*f*gd2*r + 2016*D1*Dd*f*gd2*s**2 - 3528*D1*Dd*f*gd2*s + 1512*D1*Dd*f*gd2 + 2016*D1*Dd*fd*g2*r**2 + 4032*D1*Dd*fd*g2*r*s - 1512*D1*Dd*fd*g2*r + 2016*D1*Dd*fd*g2*s**2 - 1512*D1*Dd*fd*g2*s - 480*D1*Ddd*K*f**2*r**2 - 960*D1*Ddd*K*f**2*r*s + 720*D1*Ddd*K*f**2*r - 480*D1*Ddd*K*f**2*s**2 + 720*D1*Ddd*K*f**2*s - 360*D1*Ddd*K*f**2 + 960*D1*Ddd*f**2*r**2 + 1920*D1*Ddd*f**2*r*s - 1440*D1*Ddd*f**2*r + 960*D1*Ddd*f**2*s**2 - 1440*D1*Ddd*f**2*s + 720*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r**2 + 2016*D1*Ddd*f*g2*r*s - 1512*D1*Ddd*f*g2*r + 1008*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 756*D1*Ddd*f*g2 + 14*D1*bd1*(K - 1)*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) - 1440*Dd**2*K*f**2*r**2 - 2880*Dd**2*K*f**2*r*s + 2160*Dd**2*K*f**2*r - 1440*Dd**2*K*f**2*s**2 + 2160*Dd**2*K*f**2*s - 720*Dd**2*K*f**2 + 2880*Dd**2*f**2*r**2 + 5760*Dd**2*f**2*r*s - 4320*Dd**2*f**2*r + 2880*Dd**2*f**2*s**2 - 4320*Dd**2*f**2*s + 1440*Dd**2*f**2 + 3024*Dd**2*f*g2*r**2 + 6048*Dd**2*f*g2*r*s - 4536*Dd**2*f*g2*r + 3024*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 1512*Dd**2*f*g2))/(105*d**2*k3**8) - 32*D1**2*Pk2*Pk3*ct**4*k1**4*st**2*(1386*C*D1**2*f**2*fd*r*s - 462*C*D1**2*f**2*fd*r + 1386*C*D1**2*f**2*fd*s**2 - 1386*C*D1**2*f**2*fd*s + 462*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 1848*C*D1*Dd*f**3*r*s - 462*C*D1*Dd*f**3*r + 1848*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 462*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 3100*D1**2*f**3*fd*r*s - 775*D1**2*f**3*fd*r + 3100*D1**2*f**3*fd*s**2 - 3100*D1**2*f**3*fd*s + 775*D1**2*f**3*fd - 2100*D1**2*f**3*fdd*r*s + 525*D1**2*f**3*fdd*r - 2100*D1**2*f**3*fdd*s**2 + 2100*D1**2*f**3*fdd*s - 525*D1**2*f**3*fdd - 6300*D1**2*f**2*fd**2*r*s + 1575*D1**2*f**2*fd**2*r - 6300*D1**2*f**2*fd**2*s**2 + 6300*D1**2*f**2*fd**2*s - 1050*D1**2*f**2*fd**2 - 1386*D1**2*f**2*fd*r*s + 462*D1**2*f**2*fd*r - 1386*D1**2*f**2*fd*s**2 + 1386*D1**2*f**2*fd*s - 462*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*s**2 + 726*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 1452*D1**2*f*fd*g2*r*s + 726*D1**2*f*fd*g2*r - 1452*D1**2*f*fd*g2*s**2 + 1452*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 3100*D1*Dd*f**4*r*s - 775*D1*Dd*f**4*r + 3100*D1*Dd*f**4*s**2 - 3100*D1*Dd*f**4*s + 775*D1*Dd*f**4 - 16800*D1*Dd*f**3*fd*r*s + 4200*D1*Dd*f**3*fd*r - 16800*D1*Dd*f**3*fd*s**2 + 16800*D1*Dd*f**3*fd*s - 3150*D1*Dd*f**3*fd - 1848*D1*Dd*f**3*r*s + 462*D1*Dd*f**3*r - 1848*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 462*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 2904*D1*Dd*f**2*g2*r*s + 726*D1*Dd*f**2*g2*r - 2904*D1*Dd*f**2*g2*s**2 + 2904*D1*Dd*f**2*g2*s - 726*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 2100*D1*Ddd*f**4*r*s + 525*D1*Ddd*f**4*r - 2100*D1*Ddd*f**4*s**2 + 2100*D1*Ddd*f**4*s - 525*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 6300*Dd**2*f**4*r*s + 1575*Dd**2*f**4*r - 6300*Dd**2*f**4*s**2 + 6300*Dd**2*f**4*s - 1050*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**4*k1**4*(180*C*D1**2*bdd1*f**2*r**2 + 1440*C*D1**2*bdd1*f**2*r*s - 1080*C*D1**2*bdd1*f**2*r + 1260*C*D1**2*bdd1*f**2*s**2 - 2160*C*D1**2*bdd1*f**2*s + 1080*C*D1**2*bdd1*f**2 + 1890*C*D1**2*f**2*fd*r**2 + 8700*C*D1**2*f**2*fd*r*s - 4160*C*D1**2*f**2*fd*r + 6810*C*D1**2*f**2*fd*s**2 - 7440*C*D1**2*f**2*fd*s + 2900*C*D1**2*f**2*fd - 2430*C*D1**2*f**2*fdd*r**2 - 7860*C*D1**2*f**2*fdd*r*s + 4240*C*D1**2*f**2*fdd*r - 5430*C*D1**2*f**2*fdd*s**2 + 6240*C*D1**2*f**2*fdd*s - 2620*C*D1**2*f**2*fdd - 4860*C*D1**2*f*fd**2*r**2 - 15720*C*D1**2*f*fd**2*r*s + 8480*C*D1**2*f*fd**2*r - 10860*C*D1**2*f*fd**2*s**2 + 12480*C*D1**2*f*fd**2*s - 2620*C*D1**2*f*fd**2 + 2520*C*D1*Dd*f**3*r**2 + 11600*C*D1*Dd*f**3*r*s - 5420*C*D1*Dd*f**3*r + 9080*C*D1*Dd*f**3*s**2 - 10340*C*D1*Dd*f**3*s + 3530*C*D1*Dd*f**3 - 19440*C*D1*Dd*f**2*fd*r**2 - 62880*C*D1*Dd*f**2*fd*r*s + 34540*C*D1*Dd*f**2*fd*r - 43440*C*D1*Dd*f**2*fd*s**2 + 51540*C*D1*Dd*f**2*fd*s - 14720*C*D1*Dd*f**2*fd - 3240*C*D1*Ddd*f**3*r**2 - 10480*C*D1*Ddd*f**3*r*s + 5860*C*D1*Ddd*f**3*r - 7240*C*D1*Ddd*f**3*s**2 + 8860*C*D1*Ddd*f**3*s - 3430*C*D1*Ddd*f**3 - 9720*C*Dd**2*f**3*r**2 - 31440*C*Dd**2*f**3*r*s + 17580*C*Dd**2*f**3*r - 21720*C*Dd**2*f**3*s**2 + 26580*C*Dd**2*f**3*s - 6860*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r**2 - 1746*D1**2*K*bdd1*f**2*r*s + 990*D1**2*K*bdd1*f**2*r - 1251*D1**2*K*bdd1*f**2*s**2 + 1746*D1**2*K*bdd1*f**2*s - 495*D1**2*K*bdd1*f**2 + 252*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(8*s - 4) + 7*s**2 - 10*s + 3) + 490*D1**2*bdd1*f**3*r**2 + 1260*D1**2*bdd1*f**3*r*s - 1400*D1**2*bdd1*f**3*r + 770*D1**2*bdd1*f**3*s**2 - 1680*D1**2*bdd1*f**3*s + 1120*D1**2*bdd1*f**3 + 675*D1**2*bdd1*f**2*r**2 + 1206*D1**2*bdd1*f**2*r*s - 630*D1**2*bdd1*f**2*r + 531*D1**2*bdd1*f**2*s**2 - 486*D1**2*bdd1*f**2*s - 225*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r**2 - 2016*D1**2*bdd1*f*g2*r*s + 1512*D1**2*bdd1*f*g2*r - 1764*D1**2*bdd1*f*g2*s**2 + 3024*D1**2*bdd1*f*g2*s - 1512*D1**2*bdd1*f*g2 + 4340*D1**2*f**3*fd*r**2 + 14840*D1**2*f**3*fd*r*s - 8050*D1**2*f**3*fd*r + 10500*D1**2*f**3*fd*s**2 - 12670*D1**2*f**3*fd*s + 4795*D1**2*f**3*fd - 5180*D1**2*f**3*fdd*r**2 - 13160*D1**2*f**3*fdd*r*s + 8470*D1**2*f**3*fdd*r - 7980*D1**2*f**3*fdd*s**2 + 10570*D1**2*f**3*fdd*s - 4585*D1**2*f**3*fdd - 15540*D1**2*f**2*fd**2*r**2 - 39480*D1**2*f**2*fd**2*r*s + 25410*D1**2*f**2*fd**2*r - 23940*D1**2*f**2*fd**2*s**2 + 31710*D1**2*f**2*fd**2*s - 9170*D1**2*f**2*fd**2 - 2490*D1**2*f**2*fd*r**2 - 10200*D1**2*f**2*fd*r*s + 5060*D1**2*f**2*fd*r - 7710*D1**2*f**2*fd*s**2 + 8540*D1**2*f**2*fd*s - 3400*D1**2*f**2*fd + 3270*D1**2*f**2*fdd*r**2 + 9960*D1**2*f**2*fdd*r*s - 5500*D1**2*f**2*fdd*r + 6690*D1**2*f**2*fdd*s**2 - 7780*D1**2*f**2*fdd*s + 3320*D1**2*f**2*fdd - 594*D1**2*f**2*gd2*r**2 - 3708*D1**2*f**2*gd2*r*s + 1188*D1**2*f**2*gd2*r - 3114*D1**2*f**2*gd2*s**2 + 3708*D1**2*f**2*gd2*s - 594*D1**2*f**2*gd2 + 990*D1**2*f**2*gdd2*r**2 + 3492*D1**2*f**2*gdd2*r*s - 1980*D1**2*f**2*gdd2*r + 2502*D1**2*f**2*gdd2*s**2 - 3492*D1**2*f**2*gdd2*s + 990*D1**2*f**2*gdd2 + 6540*D1**2*f*fd**2*r**2 + 19920*D1**2*f*fd**2*r*s - 11000*D1**2*f*fd**2*r + 13380*D1**2*f*fd**2*s**2 - 15560*D1**2*f*fd**2*s + 3320*D1**2*f*fd**2 - 1188*D1**2*f*fd*g2*r**2 - 7416*D1**2*f*fd*g2*r*s + 3708*D1**2*f*fd*g2*r - 6228*D1**2*f*fd*g2*s**2 + 6228*D1**2*f*fd*g2*s - 3114*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r**2 + 13968*D1**2*f*fd*gd2*r*s - 7452*D1**2*f*fd*gd2*r + 10008*D1**2*f*fd*gd2*s**2 - 11988*D1**2*f*fd*gd2*s + 3492*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r**2 + 6984*D1**2*f*fdd*g2*r*s - 3492*D1**2*f*fdd*g2*r + 5004*D1**2*f*fdd*g2*s**2 - 5004*D1**2*f*fdd*g2*s + 2502*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r**2 + 6984*D1**2*fd**2*g2*r*s - 3492*D1**2*fd**2*g2*r + 5004*D1**2*fd**2*g2*s**2 - 5004*D1**2*fd**2*g2*s + 4340*D1*Dd*f**4*r**2 + 14840*D1*Dd*f**4*r*s - 8050*D1*Dd*f**4*r + 10500*D1*Dd*f**4*s**2 - 12670*D1*Dd*f**4*s + 4795*D1*Dd*f**4 - 41440*D1*Dd*f**3*fd*r**2 - 105280*D1*Dd*f**3*fd*r*s + 67760*D1*Dd*f**3*fd*r - 63840*D1*Dd*f**3*fd*s**2 + 84560*D1*Dd*f**3*fd*s - 27510*D1*Dd*f**3*fd - 3320*D1*Dd*f**3*r**2 - 13600*D1*Dd*f**3*r*s + 6720*D1*Dd*f**3*r - 10280*D1*Dd*f**3*s**2 + 11940*D1*Dd*f**3*s - 4230*D1*Dd*f**3 + 26160*D1*Dd*f**2*fd*r**2 + 79680*D1*Dd*f**2*fd*r*s - 45040*D1*Dd*f**2*fd*r + 53520*D1*Dd*f**2*fd*s**2 - 64420*D1*Dd*f**2*fd*s + 18780*D1*Dd*f**2*fd - 2376*D1*Dd*f**2*g2*r**2 - 14832*D1*Dd*f**2*g2*r*s + 6084*D1*Dd*f**2*g2*r - 12456*D1*Dd*f**2*g2*s**2 + 13644*D1*Dd*f**2*g2*s - 4302*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r**2 + 27936*D1*Dd*f**2*gd2*r*s - 15372*D1*Dd*f**2*gd2*r + 20016*D1*Dd*f**2*gd2*s**2 - 25956*D1*Dd*f**2*gd2*s + 7452*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r**2 + 55872*D1*Dd*f*fd*g2*r*s - 28872*D1*Dd*f*fd*g2*r + 40032*D1*Dd*f*fd*g2*s**2 - 43992*D1*Dd*f*fd*g2*s + 11988*D1*Dd*f*fd*g2 - 5180*D1*Ddd*f**4*r**2 - 13160*D1*Ddd*f**4*r*s + 8470*D1*Ddd*f**4*r - 7980*D1*Ddd*f**4*s**2 + 10570*D1*Ddd*f**4*s - 4585*D1*Ddd*f**4 + 4360*D1*Ddd*f**3*r**2 + 13280*D1*Ddd*f**3*r*s - 7680*D1*Ddd*f**3*r + 8920*D1*Ddd*f**3*s**2 - 11100*D1*Ddd*f**3*s + 4410*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r**2 + 13968*D1*Ddd*f**2*g2*r*s - 7452*D1*Ddd*f**2*g2*r + 10008*D1*Ddd*f**2*g2*s**2 - 11988*D1*Ddd*f**2*g2*s + 4482*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-10*f**3*(35*r**2 + 14*r*(9*s - 11) + 91*s**2 - 210*s + 134) + f**2*(-36*C*(3*r**2 + r*(38*s - 32) + 35*s**2 - 64*s + 32) + 9*K*(33*r**2 + r*(206*s - 66) + 173*s**2 - 206*s + 33) + 140*fd*(21*r**2 + r*(54*s - 43) + 33*s**2 - 53*s + 16) - 405*r**2 - 18*r*(57*s + 7) - 621*s**2 + 90*s + 639) + 6*f*(3*fd*(20*C*(2*r**2 + 8*r*(2*s - 1) + 14*s**2 - 17*s + 3) - K*(110*r**2 + 388*r*s - 207*r + 278*s**2 - 333*s + 97) + 150*r**2 + 268*r*s - 177*r + 118*s**2 - 153*s + 87) + 14*g2*(r**2 + 2*r*(9*s - 8) + 17*s**2 - 32*s + 16) - 84*gd2*(r**2 + r*(8*s - 4) + 7*s**2 - 10*s + 3)) - 504*fd*g2*(r**2 + r*(8*s - 4) + s*(7*s - 7))) + 2*Dd*f*(70*f**2*(28*r**2 + 9*r*(8*s - 7) + 44*s**2 - 77*s + 32) + 9*f*(20*C*(4*r**2 + 2*r*(16*s - 9) + 28*s**2 - 39*s + 12) - K*(220*r**2 + 776*r*s - 427*r + 556*s**2 - 721*s + 207) + 300*r**2 + 536*r*s - 357*r + 236*s**2 - 301*s + 97) - 252*g2*(4*r**2 + 2*r*(16*s - 9) + 28*s**2 - 39*s + 12))) - 15540*Dd**2*f**4*r**2 - 39480*Dd**2*f**4*r*s + 25410*Dd**2*f**4*r - 23940*Dd**2*f**4*s**2 + 31710*Dd**2*f**4*s - 9170*Dd**2*f**4 + 13080*Dd**2*f**3*r**2 + 39840*Dd**2*f**3*r*s - 23040*Dd**2*f**3*r + 26760*Dd**2*f**3*s**2 - 33300*Dd**2*f**3*s + 8820*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r**2 + 41904*Dd**2*f**2*g2*r*s - 22356*Dd**2*f**2*g2*r + 30024*Dd**2*f**2*g2*s**2 - 35964*Dd**2*f**2*g2*s + 8964*Dd**2*f**2*g2 - 42*b1**2*(K - 1)*(D1**2*(fd*(r**2 + 18*r*s - 2*r + 17*s**2 - 2*s + 1) - 3*fdd*(r**2 + 8*r*s - 2*r + 7*s**2 - 2*s + 1)) + D1*(Dd*(f*(4*r**2 + 72*r*s - 22*r + 68*s**2 - 70*s + 19) - 6*fd*(4*r**2 + 32*r*s - 10*r + 28*s**2 - 19*s + 3)) - 3*Ddd*f*(4*r**2 + 4*r*(8*s - 3) + 28*s**2 - 30*s + 9)) - 18*Dd**2*f*(2*r**2 + 2*r*(8*s - 3) + 14*s**2 - 15*s + 3)) + b1*(-216*C*D1**2*f*fd*r**2 - 2736*C*D1**2*f*fd*r*s + 432*C*D1**2*f*fd*r - 2520*C*D1**2*f*fd*s**2 + 1584*C*D1**2*f*fd*s - 216*C*D1**2*f*fd + 360*C*D1**2*f*fdd*r**2 + 2880*C*D1**2*f*fdd*r*s - 720*C*D1**2*f*fdd*r + 2520*C*D1**2*f*fdd*s**2 - 1800*C*D1**2*f*fdd*s + 360*C*D1**2*f*fdd + 360*C*D1**2*fd**2*r**2 + 2880*C*D1**2*fd**2*r*s - 720*C*D1**2*fd**2*r + 2520*C*D1**2*fd**2*s**2 - 1800*C*D1**2*fd**2*s + 360*C*D1**2*fd**2 - 432*C*D1*Dd*f**2*r**2 - 5472*C*D1*Dd*f**2*r*s + 1800*C*D1*Dd*f**2*r - 5040*C*D1*Dd*f**2*s**2 + 5256*C*D1*Dd*f**2*s - 1476*C*D1*Dd*f**2 + 2880*C*D1*Dd*f*fd*r**2 + 23040*C*D1*Dd*f*fd*r*s - 7200*C*D1*Dd*f*fd*r + 20160*C*D1*Dd*f*fd*s**2 - 18000*C*D1*Dd*f*fd*s + 3240*C*D1*Dd*f*fd + 720*C*D1*Ddd*f**2*r**2 + 5760*C*D1*Ddd*f**2*r*s - 2160*C*D1*Ddd*f**2*r + 5040*C*D1*Ddd*f**2*s**2 - 5400*C*D1*Ddd*f**2*s + 1620*C*D1*Ddd*f**2 + 2160*C*Dd**2*f**2*r**2 + 17280*C*Dd**2*f**2*r*s - 6480*C*Dd**2*f**2*r + 15120*C*Dd**2*f**2*s**2 - 16200*C*Dd**2*f**2*s + 3240*C*Dd**2*f**2 + 594*D1**2*K*f*fd*r**2 + 3708*D1**2*K*f*fd*r*s - 1854*D1**2*K*f*fd*r + 3114*D1**2*K*f*fd*s**2 - 3114*D1**2*K*f*fd*s + 1557*D1**2*K*f*fd - 990*D1**2*K*f*fdd*r**2 - 3492*D1**2*K*f*fdd*r*s + 1746*D1**2*K*f*fdd*r - 2502*D1**2*K*f*fdd*s**2 + 2502*D1**2*K*f*fdd*s - 1251*D1**2*K*f*fdd - 990*D1**2*K*fd**2*r**2 - 3492*D1**2*K*fd**2*r*s + 1746*D1**2*K*fd**2*r - 2502*D1**2*K*fd**2*s**2 + 2502*D1**2*K*fd**2*s + 126*D1**2*bdd1*f*(K - 1)*(2*r**2 + 16*r*s - 8*r + 14*s**2 - 20*s + 7) - 1050*D1**2*f**2*fd*r**2 - 3780*D1**2*f**2*fd*r*s + 1120*D1**2*f**2*fd*r - 2730*D1**2*f**2*fd*s**2 + 2240*D1**2*f**2*fd*s - 270*D1**2*f**2*fd + 1470*D1**2*f**2*fdd*r**2 + 3780*D1**2*f**2*fdd*r*s - 1820*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2380*D1**2*f**2*fdd*s + 630*D1**2*f**2*fdd + 2940*D1**2*f*fd**2*r**2 + 7560*D1**2*f*fd**2*r*s - 3640*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 4760*D1**2*f*fd**2*s + 1260*D1**2*f*fd**2 - 810*D1**2*f*fd*r**2 - 2052*D1**2*f*fd*r*s + 1962*D1**2*f*fd*r - 1242*D1**2*f*fd*s**2 + 2178*D1**2*f*fd*s - 1665*D1**2*f*fd + 1350*D1**2*f*fdd*r**2 + 2412*D1**2*f*fdd*r*s - 1926*D1**2*f*fdd*r + 1062*D1**2*f*fdd*s**2 - 1782*D1**2*f*fdd*s + 1431*D1**2*f*fdd + 84*D1**2*f*gd2*r**2 + 1512*D1**2*f*gd2*r*s - 168*D1**2*f*gd2*r + 1428*D1**2*f*gd2*s**2 - 1512*D1**2*f*gd2*s + 84*D1**2*f*gd2 - 252*D1**2*f*gdd2*r**2 - 2016*D1**2*f*gdd2*r*s + 504*D1**2*f*gdd2*r - 1764*D1**2*f*gdd2*s**2 + 2016*D1**2*f*gdd2*s - 252*D1**2*f*gdd2 + 1350*D1**2*fd**2*r**2 + 2412*D1**2*fd**2*r*s - 1926*D1**2*fd**2*r + 1062*D1**2*fd**2*s**2 - 1782*D1**2*fd**2*s - 360*D1**2*fd**2 + 84*D1**2*fd*g2*r**2 + 1512*D1**2*fd*g2*r*s - 168*D1**2*fd*g2*r + 1428*D1**2*fd*g2*s**2 - 168*D1**2*fd*g2*s + 84*D1**2*fd*g2 - 504*D1**2*fd*gd2*r**2 - 4032*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 3528*D1**2*fd*gd2*s**2 + 2520*D1**2*fd*gd2*s - 504*D1**2*fd*gd2 - 252*D1**2*fdd*g2*r**2 - 2016*D1**2*fdd*g2*r*s + 504*D1**2*fdd*g2*r - 1764*D1**2*fdd*g2*s**2 + 504*D1**2*fdd*g2*s - 252*D1**2*fdd*g2 + 1188*D1*Dd*K*f**2*r**2 + 7416*D1*Dd*K*f**2*r*s - 3042*D1*Dd*K*f**2*r + 6228*D1*Dd*K*f**2*s**2 - 6822*D1*Dd*K*f**2*s + 2151*D1*Dd*K*f**2 - 7920*D1*Dd*K*f*fd*r**2 - 27936*D1*Dd*K*f*fd*r*s + 14436*D1*Dd*K*f*fd*r - 20016*D1*Dd*K*f*fd*s**2 + 21996*D1*Dd*K*f*fd*s - 5994*D1*Dd*K*f*fd - 1400*D1*Dd*f**3*r**2 - 5040*D1*Dd*f**3*r*s + 2660*D1*Dd*f**3*r - 3640*D1*Dd*f**3*s**2 + 4340*D1*Dd*f**3*s - 1610*D1*Dd*f**3 + 11760*D1*Dd*f**2*fd*r**2 + 30240*D1*Dd*f**2*fd*r*s - 16940*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 21700*D1*Dd*f**2*fd*s + 6020*D1*Dd*f**2*fd - 1620*D1*Dd*f**2*r**2 - 4104*D1*Dd*f**2*r*s + 2646*D1*Dd*f**2*r - 2484*D1*Dd*f**2*s**2 + 3294*D1*Dd*f**2*s - 1431*D1*Dd*f**2 + 10800*D1*Dd*f*fd*r**2 + 19296*D1*Dd*f*fd*r*s - 15516*D1*Dd*f*fd*r + 8496*D1*Dd*f*fd*s**2 - 14076*D1*Dd*f*fd*s + 5634*D1*Dd*f*fd + 336*D1*Dd*f*g2*r**2 + 6048*D1*Dd*f*g2*r*s - 1848*D1*Dd*f*g2*r + 5712*D1*Dd*f*g2*s**2 - 5880*D1*Dd*f*g2*s + 1596*D1*Dd*f*g2 - 2016*D1*Dd*f*gd2*r**2 - 16128*D1*Dd*f*gd2*r*s + 5040*D1*Dd*f*gd2*r - 14112*D1*Dd*f*gd2*s**2 + 15624*D1*Dd*f*gd2*s - 3024*D1*Dd*f*gd2 - 2016*D1*Dd*fd*g2*r**2 - 16128*D1*Dd*fd*g2*r*s + 5040*D1*Dd*fd*g2*r - 14112*D1*Dd*fd*g2*s**2 + 9576*D1*Dd*fd*g2*s - 1512*D1*Dd*fd*g2 - 1980*D1*Ddd*K*f**2*r**2 - 6984*D1*Ddd*K*f**2*r*s + 3726*D1*Ddd*K*f**2*r - 5004*D1*Ddd*K*f**2*s**2 + 5994*D1*Ddd*K*f**2*s - 2241*D1*Ddd*K*f**2 + 1960*D1*Ddd*f**3*r**2 + 5040*D1*Ddd*f**3*r*s - 3220*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 4060*D1*Ddd*f**3*s + 1750*D1*Ddd*f**3 + 2700*D1*Ddd*f**2*r**2 + 4824*D1*Ddd*f**2*r*s - 3906*D1*Ddd*f**2*r + 2124*D1*Ddd*f**2*s**2 - 3474*D1*Ddd*f**2*s + 1881*D1*Ddd*f**2 - 1008*D1*Ddd*f*g2*r**2 - 8064*D1*Ddd*f*g2*r*s + 3024*D1*Ddd*f*g2*r - 7056*D1*Ddd*f*g2*s**2 + 7560*D1*Ddd*f*g2*s - 2268*D1*Ddd*f*g2 - 42*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 36*r*s - 18*r + 34*s**2 - 50*s + 17) - 6*fd*(2*r**2 + 16*r*s - 6*r + 14*s**2 - 12*s + 1)) - 12*Dd*f*(4*r**2 + 2*r*(16*s - 7) + 28*s**2 - 35*s + 9)) - 5940*Dd**2*K*f**2*r**2 - 20952*Dd**2*K*f**2*r*s + 11178*Dd**2*K*f**2*r - 15012*Dd**2*K*f**2*s**2 + 17982*Dd**2*K*f**2*s - 4482*Dd**2*K*f**2 + 5880*Dd**2*f**3*r**2 + 15120*Dd**2*f**3*r*s - 9660*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 12180*Dd**2*f**3*s + 3500*Dd**2*f**3 + 8100*Dd**2*f**2*r**2 + 14472*Dd**2*f**2*r*s - 11718*Dd**2*f**2*r + 6372*Dd**2*f**2*s**2 - 10422*Dd**2*f**2*s + 3762*Dd**2*f**2 - 3024*Dd**2*f*g2*r**2 - 24192*Dd**2*f*g2*r*s + 9072*Dd**2*f*g2*r - 21168*Dd**2*f*g2*s**2 + 22680*Dd**2*f*g2*s - 4536*Dd**2*f*g2))/(315*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**4*k1**4*st**2*(D1**2*(525*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(1575*fd**2*s*(2*s - 1) - fd*(220*C - 220)*(3*s**2 - 2*s + 1) + fdd*(110*C - 110)*(3*s**2 - 2*s + 1) + s**2*(99*K*bdd1 - 198*bd1*(K - 1) - 99*bdd1 + 396*gd2 - 198*gdd2)) - 44*f*(fd**2*s*(10*C - 10)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 792*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(525*f**3*(4*s**2 - 2*s + 1) + 5*f**2*(44*C*(4*s**2 - 2*s + 1) - 105*fd*(1 - 4*s)**2 - 176*s**2 + 88*s - 44) - 22*f*(fd*(10*C - 10)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 396*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(525*f**2 + f*(220*C - 220) - 396*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(525*f**2 + f*(220*C - 220) - 396*g2) + 198*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(385*d**2*k2**2*k3**4) + 2*D1**2*Pk2*Pk3*ct**4*k1**4*(180*C*D1**2*bdd1*f**2*s**2 - 360*C*D1**2*bdd1*f**2*s + 180*C*D1**2*bdd1*f**2 + 3030*C*D1**2*f**2*fd*s**2 - 2020*C*D1**2*f**2*fd*s + 1010*C*D1**2*f**2*fd - 2190*C*D1**2*f**2*fdd*s**2 + 1460*C*D1**2*f**2*fdd*s - 730*C*D1**2*f**2*fdd - 4380*C*D1**2*f*fd**2*s**2 + 2920*C*D1**2*f*fd**2*s + 4040*C*D1*Dd*f**3*s**2 - 2020*C*D1*Dd*f**3*s + 1010*C*D1*Dd*f**3 - 17520*C*D1*Dd*f**2*fd*s**2 + 10220*C*D1*Dd*f**2*fd*s - 1460*C*D1*Dd*f**2*fd - 2920*C*D1*Ddd*f**3*s**2 + 1460*C*D1*Ddd*f**3*s - 730*C*D1*Ddd*f**3 - 8760*C*Dd**2*f**3*s**2 + 4380*C*Dd**2*f**3*s - 495*D1**2*K*bdd1*f**2*s**2 + 252*D1**2*bd1**2*f*s*(K - 1)*(s - 1) + 280*D1**2*bdd1*f**3*r*s + 420*D1**2*bdd1*f**3*s**2 - 560*D1**2*bdd1*f**3*s + 210*D1**2*bdd1*f**3 + 180*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 + 180*D1**2*bdd1*f**2*s - 180*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*s**2 + 504*D1**2*bdd1*f*g2*s - 252*D1**2*bdd1*f*g2 + 1400*D1**2*f**3*fd*r*s - 350*D1**2*f**3*fd*r + 5460*D1**2*f**3*fd*s**2 - 3430*D1**2*f**3*fd*s + 1365*D1**2*f**3*fd - 1400*D1**2*f**3*fdd*r*s + 350*D1**2*f**3*fdd*r - 3780*D1**2*f**3*fdd*s**2 + 2590*D1**2*f**3*fdd*s - 945*D1**2*f**3*fdd - 4200*D1**2*f**2*fd**2*r*s + 1050*D1**2*f**2*fd**2*r - 11340*D1**2*f**2*fd**2*s**2 + 7770*D1**2*f**2*fd**2*s - 700*D1**2*f**2*fd**2 - 300*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 3330*D1**2*f**2*fd*s**2 + 2320*D1**2*f**2*fd*s - 1110*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r + 2610*D1**2*f**2*fdd*s**2 - 1880*D1**2*f**2*fdd*s + 870*D1**2*f**2*fdd - 1350*D1**2*f**2*gd2*s**2 + 990*D1**2*f**2*gdd2*s**2 + 840*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r + 5220*D1**2*f*fd**2*s**2 - 3760*D1**2*f*fd**2*s + 140*D1**2*f*fd**2 - 2700*D1**2*f*fd*g2*s**2 + 2700*D1**2*f*fd*g2*s - 1350*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*s**2 - 1980*D1**2*f*fd*gd2*s + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 1400*D1*Dd*f**4*r*s - 350*D1*Dd*f**4*r + 5460*D1*Dd*f**4*s**2 - 3430*D1*Dd*f**4*s + 1365*D1*Dd*f**4 - 11200*D1*Dd*f**3*fd*r*s + 2800*D1*Dd*f**3*fd*r - 30240*D1*Dd*f**3*fd*s**2 + 20720*D1*Dd*f**3*fd*s - 3290*D1*Dd*f**3*fd - 400*D1*Dd*f**3*r*s + 100*D1*Dd*f**3*r - 4440*D1*Dd*f**3*s**2 + 2420*D1*Dd*f**3*s - 1110*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r*s - 980*D1*Dd*f**2*fd*r + 20880*D1*Dd*f**2*fd*s**2 - 13580*D1*Dd*f**2*fd*s + 2160*D1*Dd*f**2*fd - 5400*D1*Dd*f**2*g2*s**2 + 2700*D1*Dd*f**2*g2*s - 1350*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*s**2 - 1980*D1*Dd*f**2*gd2*s + 15840*D1*Dd*f*fd*g2*s**2 - 11880*D1*Dd*f*fd*g2*s + 1980*D1*Dd*f*fd*g2 - 1400*D1*Ddd*f**4*r*s + 350*D1*Ddd*f**4*r - 3780*D1*Ddd*f**4*s**2 + 2590*D1*Ddd*f**4*s - 945*D1*Ddd*f**4 + 560*D1*Ddd*f**3*r*s - 140*D1*Ddd*f**3*r + 3480*D1*Ddd*f**3*s**2 - 2020*D1*Ddd*f**3*s + 870*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*s**2 - 1980*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-20*f**3*(24*s**2 + s*(10*r - 47) + 21) + f**2*(-360*C*(s - 1)**2 + 140*fd*(2*r*(6*s - 1) + 18*s**2 - 18*s + 1) + 9*s**2*(75*K - 47) - 9*s*(12*r + 68) + 360) + 18*f*(5*fd*(r*(8*s - 2) + s**2*(8*C - 22*K + 22) + s*(-8*C + 11*K - 11) + 2) + (28*s - 28)*(g2*(s - 1) - gd2*s)) - 504*fd*g2*s*(s - 1)) + 2*Dd*f*(140*f**2*(r*(8*s - 1) + 12*s**2 - 13*s + 2) + 45*f*(4*C*(4*s**2 - 5*s + 1) - 44*K*s**2 + 11*K*s + 16*r*s - 2*r + 44*s**2 - 7*s - 2) - 252*g2*(4*s**2 - 5*s + 1))) - 4200*Dd**2*f**4*r*s + 1050*Dd**2*f**4*r - 11340*Dd**2*f**4*s**2 + 7770*Dd**2*f**4*s - 700*Dd**2*f**4 + 1680*Dd**2*f**3*r*s - 420*Dd**2*f**3*r + 10440*Dd**2*f**3*s**2 - 6060*Dd**2*f**3*s + 280*Dd**2*f**3 + 11880*Dd**2*f**2*g2*s**2 - 5940*Dd**2*f**2*g2*s - 126*b1**2*(K - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-720*C*D1**2*f*fd*s**2 + 360*C*D1**2*f*fdd*s**2 + 360*C*D1**2*fd**2*s**2 - 1440*C*D1*Dd*f**2*s**2 + 720*C*D1*Dd*f**2*s - 360*C*D1*Dd*f**2 + 2880*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 720*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 2160*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 1350*D1**2*K*f*fd*s**2 - 1350*D1**2*K*f*fd*s + 675*D1**2*K*f*fd - 990*D1**2*K*f*fdd*s**2 + 990*D1**2*K*f*fdd*s - 495*D1**2*K*f*fdd - 990*D1**2*K*fd**2*s**2 + 990*D1**2*K*fd**2*s + 126*D1**2*bdd1*f*(K - 1)*(2*s**2 - 2*s + 1) - 600*D1**2*f**2*fd*r*s + 200*D1**2*f**2*fd*r - 1440*D1**2*f**2*fd*s**2 + 420*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r*s - 280*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 840*D1**2*f**2*fdd*s + 210*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r*s - 560*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 1680*D1**2*f*fd**2*s + 420*D1**2*f*fd**2 - 216*D1**2*f*fd*r*s + 108*D1**2*f*fd*r - 846*D1**2*f*fd*s**2 + 1566*D1**2*f*fd*s - 783*D1**2*f*fd + 360*D1**2*f*fdd*r*s - 180*D1**2*f*fdd*r + 990*D1**2*f*fdd*s**2 - 1350*D1**2*f*fdd*s + 675*D1**2*f*fdd + 504*D1**2*f*gd2*s**2 - 252*D1**2*f*gdd2*s**2 + 360*D1**2*fd**2*r*s - 180*D1**2*fd**2*r + 990*D1**2*fd**2*s**2 - 1350*D1**2*fd**2*s + 504*D1**2*fd*g2*s**2 - 504*D1**2*fd*gd2*s**2 - 252*D1**2*fdd*g2*s**2 + 2700*D1*Dd*K*f**2*s**2 - 1350*D1*Dd*K*f**2*s + 675*D1*Dd*K*f**2 - 7920*D1*Dd*K*f*fd*s**2 + 5940*D1*Dd*K*f*fd*s - 990*D1*Dd*K*f*fd - 800*D1*Dd*f**3*r*s + 200*D1*Dd*f**3*r - 1920*D1*Dd*f**3*s**2 + 1360*D1*Dd*f**3*s - 480*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r*s - 1960*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 7560*D1*Dd*f**2*fd*s + 1400*D1*Dd*f**2*fd - 432*D1*Dd*f**2*r*s + 108*D1*Dd*f**2*r - 1692*D1*Dd*f**2*s**2 + 1062*D1*Dd*f**2*s - 423*D1*Dd*f**2 + 2880*D1*Dd*f*fd*r*s - 1080*D1*Dd*f*fd*r + 7920*D1*Dd*f*fd*s**2 - 8100*D1*Dd*f*fd*s + 1710*D1*Dd*f*fd + 2016*D1*Dd*f*g2*s**2 - 1008*D1*Dd*f*g2*s + 504*D1*Dd*f*g2 - 2016*D1*Dd*f*gd2*s**2 + 504*D1*Dd*f*gd2*s - 2016*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s - 1980*D1*Ddd*K*f**2*s**2 + 990*D1*Ddd*K*f**2*s - 495*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 1400*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 720*D1*Ddd*f**2*r*s - 180*D1*Ddd*f**2*r + 1980*D1*Ddd*f**2*s**2 - 1350*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 - 1008*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 - 252*D1*bd1*(K - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 5940*Dd**2*K*f**2*s**2 + 2970*Dd**2*K*f**2*s + 3360*Dd**2*f**3*r*s - 840*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 4200*Dd**2*f**3*s + 560*Dd**2*f**3 + 2160*Dd**2*f**2*r*s - 540*Dd**2*f**2*r + 5940*Dd**2*f**2*s**2 - 4050*Dd**2*f**2*s + 360*Dd**2*f**2 - 3024*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s))/(315*d**2*k2**2*k3**4) - 4*D1**2*Pk2*Pk3*ct**4*k1**2*k2**4*st**4*(396*C*D1**2*f**2*fd*r**2 + 792*C*D1**2*f**2*fd*r*s - 528*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 528*C*D1**2*f**2*fd*s + 264*C*D1**2*f**2*fd - 198*C*D1**2*f**2*fdd*r**2 - 396*C*D1**2*f**2*fdd*r*s + 264*C*D1**2*f**2*fdd*r - 198*C*D1**2*f**2*fdd*s**2 + 264*C*D1**2*f**2*fdd*s - 132*C*D1**2*f**2*fdd - 396*C*D1**2*f*fd**2*r**2 - 792*C*D1**2*f*fd**2*r*s + 528*C*D1**2*f*fd**2*r - 396*C*D1**2*f*fd**2*s**2 + 528*C*D1**2*f*fd**2*s - 132*C*D1**2*f*fd**2 + 528*C*D1*Dd*f**3*r**2 + 1056*C*D1*Dd*f**3*r*s - 792*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 792*C*D1*Dd*f**3*s + 396*C*D1*Dd*f**3 - 1584*C*D1*Dd*f**2*fd*r**2 - 3168*C*D1*Dd*f**2*fd*r*s + 2244*C*D1*Dd*f**2*fd*r - 1584*C*D1*Dd*f**2*fd*s**2 + 2244*C*D1*Dd*f**2*fd*s - 792*C*D1*Dd*f**2*fd - 264*C*D1*Ddd*f**3*r**2 - 528*C*D1*Ddd*f**3*r*s + 396*C*D1*Ddd*f**3*r - 264*C*D1*Ddd*f**3*s**2 + 396*C*D1*Ddd*f**3*s - 198*C*D1*Ddd*f**3 - 792*C*Dd**2*f**3*r**2 - 1584*C*Dd**2*f**3*r*s + 1188*C*Dd**2*f**3*r - 792*C*Dd**2*f**3*s**2 + 1188*C*Dd**2*f**3*s - 396*C*Dd**2*f**3 + 396*D1**2*K*b1*f*fd*r**2 + 792*D1**2*K*b1*f*fd*r*s - 396*D1**2*K*b1*f*fd*r + 396*D1**2*K*b1*f*fd*s**2 - 396*D1**2*K*b1*f*fd*s + 198*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 396*D1**2*K*b1*f*fdd*r*s + 198*D1**2*K*b1*f*fdd*r - 198*D1**2*K*b1*f*fdd*s**2 + 198*D1**2*K*b1*f*fdd*s - 99*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 396*D1**2*K*b1*fd**2*r*s + 198*D1**2*K*b1*fd**2*r - 198*D1**2*K*b1*fd**2*s**2 + 198*D1**2*K*b1*fd**2*s - 396*D1**2*b1*f*fd*r**2 - 792*D1**2*b1*f*fd*r*s + 396*D1**2*b1*f*fd*r - 396*D1**2*b1*f*fd*s**2 + 396*D1**2*b1*f*fd*s - 198*D1**2*b1*f*fd + 198*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 198*D1**2*b1*f*fdd*s**2 - 198*D1**2*b1*f*fdd*s + 99*D1**2*b1*f*fdd + 198*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 198*D1**2*b1*fd**2*s**2 - 198*D1**2*b1*fd**2*s - 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 560*D1**2*f**3*fd*r**2 + 1120*D1**2*f**3*fd*r*s - 840*D1**2*f**3*fd*r + 560*D1**2*f**3*fd*s**2 - 840*D1**2*f**3*fd*s + 420*D1**2*f**3*fd - 280*D1**2*f**3*fdd*r**2 - 560*D1**2*f**3*fdd*r*s + 420*D1**2*f**3*fdd*r - 280*D1**2*f**3*fdd*s**2 + 420*D1**2*f**3*fdd*s - 210*D1**2*f**3*fdd - 840*D1**2*f**2*fd**2*r**2 - 1680*D1**2*f**2*fd**2*r*s + 1260*D1**2*f**2*fd**2*r - 840*D1**2*f**2*fd**2*s**2 + 1260*D1**2*f**2*fd**2*s - 420*D1**2*f**2*fd**2 - 396*D1**2*f**2*fd*r**2 - 792*D1**2*f**2*fd*r*s + 528*D1**2*f**2*fd*r - 396*D1**2*f**2*fd*s**2 + 528*D1**2*f**2*fd*s - 264*D1**2*f**2*fd + 198*D1**2*f**2*fdd*r**2 + 396*D1**2*f**2*fdd*r*s - 264*D1**2*f**2*fdd*r + 198*D1**2*f**2*fdd*s**2 - 264*D1**2*f**2*fdd*s + 132*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 396*D1**2*f**2*gd2*s**2 + 792*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 396*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 396*D1**2*f*fd**2*r**2 + 792*D1**2*f*fd**2*r*s - 528*D1**2*f*fd**2*r + 396*D1**2*f*fd**2*s**2 - 528*D1**2*f*fd**2*s + 132*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 792*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1584*D1**2*f*fd*gd2*r*s - 1188*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1188*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 792*D1*Dd*K*b1*f**2*r**2 + 1584*D1*Dd*K*b1*f**2*r*s - 1188*D1*Dd*K*b1*f**2*r + 792*D1*Dd*K*b1*f**2*s**2 - 1188*D1*Dd*K*b1*f**2*s + 594*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 3168*D1*Dd*K*b1*f*fd*r*s + 1980*D1*Dd*K*b1*f*fd*r - 1584*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 594*D1*Dd*K*b1*f*fd - 792*D1*Dd*b1*f**2*r**2 - 1584*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 792*D1*Dd*b1*f**2*s**2 + 1188*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r + 1584*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s + 594*D1*Dd*b1*f*fd + 560*D1*Dd*f**4*r**2 + 1120*D1*Dd*f**4*r*s - 840*D1*Dd*f**4*r + 560*D1*Dd*f**4*s**2 - 840*D1*Dd*f**4*s + 420*D1*Dd*f**4 - 2240*D1*Dd*f**3*fd*r**2 - 4480*D1*Dd*f**3*fd*r*s + 3360*D1*Dd*f**3*fd*r - 2240*D1*Dd*f**3*fd*s**2 + 3360*D1*Dd*f**3*fd*s - 1260*D1*Dd*f**3*fd - 528*D1*Dd*f**3*r**2 - 1056*D1*Dd*f**3*r*s + 792*D1*Dd*f**3*r - 528*D1*Dd*f**3*s**2 + 792*D1*Dd*f**3*s - 396*D1*Dd*f**3 + 1584*D1*Dd*f**2*fd*r**2 + 3168*D1*Dd*f**2*fd*r*s - 2244*D1*Dd*f**2*fd*r + 1584*D1*Dd*f**2*fd*s**2 - 2244*D1*Dd*f**2*fd*s + 792*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 2376*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 3168*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 1188*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 6336*D1*Dd*f*fd*g2*r*s - 3960*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 1188*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 792*D1*Ddd*K*b1*f**2*r*s + 594*D1*Ddd*K*b1*f**2*r - 396*D1*Ddd*K*b1*f**2*s**2 + 594*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 396*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 396*D1*Ddd*b1*f**2*s**2 - 594*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 - 280*D1*Ddd*f**4*r**2 - 560*D1*Ddd*f**4*r*s + 420*D1*Ddd*f**4*r - 280*D1*Ddd*f**4*s**2 + 420*D1*Ddd*f**4*s - 210*D1*Ddd*f**4 + 264*D1*Ddd*f**3*r**2 + 528*D1*Ddd*f**3*r*s - 396*D1*Ddd*f**3*r + 264*D1*Ddd*f**3*s**2 - 396*D1*Ddd*f**3*s + 198*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1584*D1*Ddd*f**2*g2*r*s - 1188*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1188*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1188*Dd**2*K*b1*f**2*r**2 - 2376*Dd**2*K*b1*f**2*r*s + 1782*Dd**2*K*b1*f**2*r - 1188*Dd**2*K*b1*f**2*s**2 + 1782*Dd**2*K*b1*f**2*s - 594*Dd**2*K*b1*f**2 + 1188*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 1188*Dd**2*b1*f**2*s**2 - 1782*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 - 840*Dd**2*f**4*r**2 - 1680*Dd**2*f**4*r*s + 1260*Dd**2*f**4*r - 840*Dd**2*f**4*s**2 + 1260*Dd**2*f**4*s - 420*Dd**2*f**4 + 792*Dd**2*f**3*r**2 + 1584*Dd**2*f**3*r*s - 1188*Dd**2*f**3*r + 792*Dd**2*f**3*s**2 - 1188*Dd**2*f**3*s + 396*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 4752*Dd**2*f**2*g2*r*s - 3564*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3564*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2)/(77*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**4*k1**2*k2**4*st**2*(-108*C*D1**2*bdd1*f**2*r**2 - 216*C*D1**2*bdd1*f**2*r*s + 216*C*D1**2*bdd1*f**2*r - 108*C*D1**2*bdd1*f**2*s**2 + 216*C*D1**2*bdd1*f**2*s - 108*C*D1**2*bdd1*f**2 + 3180*C*D1**2*f**2*fd*r**2 + 6360*C*D1**2*f**2*fd*r*s - 4240*C*D1**2*f**2*fd*r + 3180*C*D1**2*f**2*fd*s**2 - 4240*C*D1**2*f**2*fd*s + 2120*C*D1**2*f**2*fd - 2400*C*D1**2*f**2*fdd*r**2 - 4800*C*D1**2*f**2*fdd*r*s + 3200*C*D1**2*f**2*fdd*r - 2400*C*D1**2*f**2*fdd*s**2 + 3200*C*D1**2*f**2*fdd*s - 1600*C*D1**2*f**2*fdd - 4800*C*D1**2*f*fd**2*r**2 - 9600*C*D1**2*f*fd**2*r*s + 6400*C*D1**2*f*fd**2*r - 4800*C*D1**2*f*fd**2*s**2 + 6400*C*D1**2*f*fd**2*s - 1600*C*D1**2*f*fd**2 + 4240*C*D1*Dd*f**3*r**2 + 8480*C*D1*Dd*f**3*r*s - 6360*C*D1*Dd*f**3*r + 4240*C*D1*Dd*f**3*s**2 - 6360*C*D1*Dd*f**3*s + 3180*C*D1*Dd*f**3 - 19200*C*D1*Dd*f**2*fd*r**2 - 38400*C*D1*Dd*f**2*fd*r*s + 27200*C*D1*Dd*f**2*fd*r - 19200*C*D1*Dd*f**2*fd*s**2 + 27200*C*D1*Dd*f**2*fd*s - 9600*C*D1*Dd*f**2*fd - 3200*C*D1*Ddd*f**3*r**2 - 6400*C*D1*Ddd*f**3*r*s + 4800*C*D1*Ddd*f**3*r - 3200*C*D1*Ddd*f**3*s**2 + 4800*C*D1*Ddd*f**3*s - 2400*C*D1*Ddd*f**3 - 9600*C*Dd**2*f**3*r**2 - 19200*C*Dd**2*f**3*r*s + 14400*C*Dd**2*f**3*r - 9600*C*Dd**2*f**3*s**2 + 14400*C*Dd**2*f**3*s - 4800*C*Dd**2*f**3 - 720*D1**2*K*bdd1*f**2*r**2 - 1440*D1**2*K*bdd1*f**2*r*s + 1440*D1**2*K*bdd1*f**2*r - 720*D1**2*K*bdd1*f**2*s**2 + 1440*D1**2*K*bdd1*f**2*s - 720*D1**2*K*bdd1*f**2 - 252*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 300*D1**2*bdd1*f**3*r**2 + 600*D1**2*bdd1*f**3*r*s - 600*D1**2*bdd1*f**3*r + 300*D1**2*bdd1*f**3*s**2 - 600*D1**2*bdd1*f**3*s + 300*D1**2*bdd1*f**3 + 468*D1**2*bdd1*f**2*r**2 + 936*D1**2*bdd1*f**2*r*s - 936*D1**2*bdd1*f**2*r + 468*D1**2*bdd1*f**2*s**2 - 936*D1**2*bdd1*f**2*s + 468*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s - 504*D1**2*bdd1*f*g2*r + 252*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 - 300*D1**2*f**3*fd*r**2 - 600*D1**2*f**3*fd*r*s + 450*D1**2*f**3*fd*r - 300*D1**2*f**3*fd*s**2 + 450*D1**2*f**3*fd*s - 225*D1**2*f**3*fd - 2304*D1**2*f**2*fd*r**2 - 4608*D1**2*f**2*fd*r*s + 3072*D1**2*f**2*fd*r - 2304*D1**2*f**2*fd*s**2 + 3072*D1**2*f**2*fd*s - 1536*D1**2*f**2*fd + 1800*D1**2*f**2*fdd*r**2 + 3600*D1**2*f**2*fdd*r*s - 2400*D1**2*f**2*fdd*r + 1800*D1**2*f**2*fdd*s**2 - 2400*D1**2*f**2*fdd*s + 1200*D1**2*f**2*fdd - 1620*D1**2*f**2*gd2*r**2 - 3240*D1**2*f**2*gd2*r*s + 3240*D1**2*f**2*gd2*r - 1620*D1**2*f**2*gd2*s**2 + 3240*D1**2*f**2*gd2*s - 1620*D1**2*f**2*gd2 + 1440*D1**2*f**2*gdd2*r**2 + 2880*D1**2*f**2*gdd2*r*s - 2880*D1**2*f**2*gdd2*r + 1440*D1**2*f**2*gdd2*s**2 - 2880*D1**2*f**2*gdd2*s + 1440*D1**2*f**2*gdd2 + 3600*D1**2*f*fd**2*r**2 + 7200*D1**2*f*fd**2*r*s - 4800*D1**2*f*fd**2*r + 3600*D1**2*f*fd**2*s**2 - 4800*D1**2*f*fd**2*s + 1200*D1**2*f*fd**2 - 3240*D1**2*f*fd*g2*r**2 - 6480*D1**2*f*fd*g2*r*s + 3240*D1**2*f*fd*g2*r - 3240*D1**2*f*fd*g2*s**2 + 3240*D1**2*f*fd*g2*s - 1620*D1**2*f*fd*g2 + 5760*D1**2*f*fd*gd2*r**2 + 11520*D1**2*f*fd*gd2*r*s - 8640*D1**2*f*fd*gd2*r + 5760*D1**2*f*fd*gd2*s**2 - 8640*D1**2*f*fd*gd2*s + 2880*D1**2*f*fd*gd2 + 2880*D1**2*f*fdd*g2*r**2 + 5760*D1**2*f*fdd*g2*r*s - 2880*D1**2*f*fdd*g2*r + 2880*D1**2*f*fdd*g2*s**2 - 2880*D1**2*f*fdd*g2*s + 1440*D1**2*f*fdd*g2 + 2880*D1**2*fd**2*g2*r**2 + 5760*D1**2*fd**2*g2*r*s - 2880*D1**2*fd**2*g2*r + 2880*D1**2*fd**2*g2*s**2 - 2880*D1**2*fd**2*g2*s - 300*D1*Dd*f**4*r**2 - 600*D1*Dd*f**4*r*s + 450*D1*Dd*f**4*r - 300*D1*Dd*f**4*s**2 + 450*D1*Dd*f**4*s - 225*D1*Dd*f**4 - 3072*D1*Dd*f**3*r**2 - 6144*D1*Dd*f**3*r*s + 4608*D1*Dd*f**3*r - 3072*D1*Dd*f**3*s**2 + 4608*D1*Dd*f**3*s - 2304*D1*Dd*f**3 + 14400*D1*Dd*f**2*fd*r**2 + 28800*D1*Dd*f**2*fd*r*s - 20400*D1*Dd*f**2*fd*r + 14400*D1*Dd*f**2*fd*s**2 - 20400*D1*Dd*f**2*fd*s + 7200*D1*Dd*f**2*fd - 6480*D1*Dd*f**2*g2*r**2 - 12960*D1*Dd*f**2*g2*r*s + 9720*D1*Dd*f**2*g2*r - 6480*D1*Dd*f**2*g2*s**2 + 9720*D1*Dd*f**2*g2*s - 4860*D1*Dd*f**2*g2 + 11520*D1*Dd*f**2*gd2*r**2 + 23040*D1*Dd*f**2*gd2*r*s - 20160*D1*Dd*f**2*gd2*r + 11520*D1*Dd*f**2*gd2*s**2 - 20160*D1*Dd*f**2*gd2*s + 8640*D1*Dd*f**2*gd2 + 23040*D1*Dd*f*fd*g2*r**2 + 46080*D1*Dd*f*fd*g2*r*s - 28800*D1*Dd*f*fd*g2*r + 23040*D1*Dd*f*fd*g2*s**2 - 28800*D1*Dd*f*fd*g2*s + 8640*D1*Dd*f*fd*g2 + 2400*D1*Ddd*f**3*r**2 + 4800*D1*Ddd*f**3*r*s - 3600*D1*Ddd*f**3*r + 2400*D1*Ddd*f**3*s**2 - 3600*D1*Ddd*f**3*s + 1800*D1*Ddd*f**3 + 5760*D1*Ddd*f**2*g2*r**2 + 11520*D1*Ddd*f**2*g2*r*s - 8640*D1*Ddd*f**2*g2*r + 5760*D1*Ddd*f**2*g2*s**2 - 8640*D1*Ddd*f**2*g2*s + 4320*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(70*f**3*(r + s - 1) - f**2*(36*C*(r + s - 1) + 100*fd*(3*r + 3*s - 2) + (135*K - 93)*(r + s - 1)) + 12*f*(fd*(3*C + 20*K - 13)*(2*r + 2*s - 1) + (7*g2 - 7*gd2)*(r + s - 1)) - 84*fd*g2*(r + s)) - 4*Dd*f*(25*f**2 + f*(-9*C - 60*K + 39) + 21*g2)*(4*r + 4*s - 3))*(r + s - 1) + 7200*Dd**2*f**3*r**2 + 14400*Dd**2*f**3*r*s - 10800*Dd**2*f**3*r + 7200*Dd**2*f**3*s**2 - 10800*Dd**2*f**3*s + 3600*Dd**2*f**3 + 17280*Dd**2*f**2*g2*r**2 + 34560*Dd**2*f**2*g2*r*s - 25920*Dd**2*f**2*g2*r + 17280*Dd**2*f**2*g2*s**2 - 25920*Dd**2*f**2*g2*s + 8640*Dd**2*f**2*g2 + 126*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*b1*(72*C*D1**2*f*fd*r**2 + 144*C*D1**2*f*fd*r*s - 72*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s**2 - 72*C*D1**2*f*fd*s + 36*C*D1**2*f*fd - 36*C*D1**2*f*fdd*r**2 - 72*C*D1**2*f*fdd*r*s + 36*C*D1**2*f*fdd*r - 36*C*D1**2*f*fdd*s**2 + 36*C*D1**2*f*fdd*s - 18*C*D1**2*f*fdd - 36*C*D1**2*fd**2*r**2 - 72*C*D1**2*fd**2*r*s + 36*C*D1**2*fd**2*r - 36*C*D1**2*fd**2*s**2 + 36*C*D1**2*fd**2*s + 144*C*D1*Dd*f**2*r**2 + 288*C*D1*Dd*f**2*r*s - 216*C*D1*Dd*f**2*r + 144*C*D1*Dd*f**2*s**2 - 216*C*D1*Dd*f**2*s + 108*C*D1*Dd*f**2 - 288*C*D1*Dd*f*fd*r**2 - 576*C*D1*Dd*f*fd*r*s + 360*C*D1*Dd*f*fd*r - 288*C*D1*Dd*f*fd*s**2 + 360*C*D1*Dd*f*fd*s - 108*C*D1*Dd*f*fd - 72*C*D1*Ddd*f**2*r**2 - 144*C*D1*Ddd*f**2*r*s + 108*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 108*C*D1*Ddd*f**2*s - 54*C*D1*Ddd*f**2 - 216*C*Dd**2*f**2*r**2 - 432*C*Dd**2*f**2*r*s + 324*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 324*C*Dd**2*f**2*s - 108*C*Dd**2*f**2 + 270*D1**2*K*f*fd*r**2 + 540*D1**2*K*f*fd*r*s - 270*D1**2*K*f*fd*r + 270*D1**2*K*f*fd*s**2 - 270*D1**2*K*f*fd*s + 135*D1**2*K*f*fd - 240*D1**2*K*f*fdd*r**2 - 480*D1**2*K*f*fdd*r*s + 240*D1**2*K*f*fdd*r - 240*D1**2*K*f*fdd*s**2 + 240*D1**2*K*f*fdd*s - 120*D1**2*K*f*fdd - 240*D1**2*K*fd**2*r**2 - 480*D1**2*K*fd**2*r*s + 240*D1**2*K*fd**2*r - 240*D1**2*K*fd**2*s**2 + 240*D1**2*K*fd**2*s - 42*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 210*D1**2*f**2*fd*r**2 - 420*D1**2*f**2*fd*r*s + 280*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 280*D1**2*f**2*fd*s - 140*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 186*D1**2*f*fd*r**2 - 372*D1**2*f*fd*r*s + 186*D1**2*f*fd*r - 186*D1**2*f*fd*s**2 + 186*D1**2*f*fd*s - 93*D1**2*f*fd + 156*D1**2*f*fdd*r**2 + 312*D1**2*f*fdd*r*s - 156*D1**2*f*fdd*r + 156*D1**2*f*fdd*s**2 - 156*D1**2*f*fdd*s + 78*D1**2*f*fdd - 84*D1**2*f*gd2*r**2 - 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*r - 84*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s - 84*D1**2*f*gd2 + 42*D1**2*f*gdd2*r**2 + 84*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*r + 42*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 42*D1**2*f*gdd2 + 156*D1**2*fd**2*r**2 + 312*D1**2*fd**2*r*s - 156*D1**2*fd**2*r + 156*D1**2*fd**2*s**2 - 156*D1**2*fd**2*s - 84*D1**2*fd*g2*r**2 - 168*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*s**2 + 84*D1**2*fd*gd2*r**2 + 168*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*r + 84*D1**2*fd*gd2*s**2 - 84*D1**2*fd*gd2*s + 42*D1**2*fdd*g2*r**2 + 84*D1**2*fdd*g2*r*s + 42*D1**2*fdd*g2*s**2 + 540*D1*Dd*K*f**2*r**2 + 1080*D1*Dd*K*f**2*r*s - 810*D1*Dd*K*f**2*r + 540*D1*Dd*K*f**2*s**2 - 810*D1*Dd*K*f**2*s + 405*D1*Dd*K*f**2 - 1920*D1*Dd*K*f*fd*r**2 - 3840*D1*Dd*K*f*fd*r*s + 2400*D1*Dd*K*f*fd*r - 1920*D1*Dd*K*f*fd*s**2 + 2400*D1*Dd*K*f*fd*s - 720*D1*Dd*K*f*fd - 280*D1*Dd*f**3*r**2 - 560*D1*Dd*f**3*r*s + 420*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 420*D1*Dd*f**3*s - 210*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 1700*D1*Dd*f**2*fd*r + 1200*D1*Dd*f**2*fd*s**2 - 1700*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 372*D1*Dd*f**2*r**2 - 744*D1*Dd*f**2*r*s + 558*D1*Dd*f**2*r - 372*D1*Dd*f**2*s**2 + 558*D1*Dd*f**2*s - 279*D1*Dd*f**2 + 1248*D1*Dd*f*fd*r**2 + 2496*D1*Dd*f*fd*r*s - 1560*D1*Dd*f*fd*r + 1248*D1*Dd*f*fd*s**2 - 1560*D1*Dd*f*fd*s + 468*D1*Dd*f*fd - 336*D1*Dd*f*g2*r**2 - 672*D1*Dd*f*g2*r*s + 504*D1*Dd*f*g2*r - 336*D1*Dd*f*g2*s**2 + 504*D1*Dd*f*g2*s - 252*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 + 672*D1*Dd*f*gd2*r*s - 588*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s**2 - 588*D1*Dd*f*gd2*s + 252*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r**2 + 672*D1*Dd*fd*g2*r*s - 252*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s**2 - 252*D1*Dd*fd*g2*s - 480*D1*Ddd*K*f**2*r**2 - 960*D1*Ddd*K*f**2*r*s + 720*D1*Ddd*K*f**2*r - 480*D1*Ddd*K*f**2*s**2 + 720*D1*Ddd*K*f**2*s - 360*D1*Ddd*K*f**2 + 200*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 300*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 + 312*D1*Ddd*f**2*r**2 + 624*D1*Ddd*f**2*r*s - 468*D1*Ddd*f**2*r + 312*D1*Ddd*f**2*s**2 - 468*D1*Ddd*f**2*s + 234*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r*s - 252*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s**2 - 252*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 + 84*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 1440*Dd**2*K*f**2*r**2 - 2880*Dd**2*K*f**2*r*s + 2160*Dd**2*K*f**2*r - 1440*Dd**2*K*f**2*s**2 + 2160*Dd**2*K*f**2*s - 720*Dd**2*K*f**2 + 600*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 900*Dd**2*f**3*r + 600*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 300*Dd**2*f**3 + 936*Dd**2*f**2*r**2 + 1872*Dd**2*f**2*r*s - 1404*Dd**2*f**2*r + 936*Dd**2*f**2*s**2 - 1404*Dd**2*f**2*s + 468*Dd**2*f**2 + 504*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r*s - 756*Dd**2*f*g2*r + 504*Dd**2*f*g2*s**2 - 756*Dd**2*f*g2*s + 252*Dd**2*f*g2))/(105*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**4*k1**2*k2**4*(240*C*D1**2*bdd1*f**2*r**2 + 480*C*D1**2*bdd1*f**2*r*s - 480*C*D1**2*bdd1*f**2*r + 240*C*D1**2*bdd1*f**2*s**2 - 480*C*D1**2*bdd1*f**2*s + 240*C*D1**2*bdd1*f**2 - 30*C*D1**2*f**2*fd*r**2 - 60*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 420*C*D1**2*f**2*fdd*r**2 + 840*C*D1**2*f**2*fdd*r*s - 560*C*D1**2*f**2*fdd*r + 420*C*D1**2*f**2*fdd*s**2 - 560*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 840*C*D1**2*f*fd**2*r**2 + 1680*C*D1**2*f*fd**2*r*s - 1120*C*D1**2*f*fd**2*r + 840*C*D1**2*f*fd**2*s**2 - 1120*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 40*C*D1*Dd*f**3*r**2 - 80*C*D1*Dd*f**3*r*s + 60*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 60*C*D1*Dd*f**3*s - 30*C*D1*Dd*f**3 + 3360*C*D1*Dd*f**2*fd*r**2 + 6720*C*D1*Dd*f**2*fd*r*s - 4760*C*D1*Dd*f**2*fd*r + 3360*C*D1*Dd*f**2*fd*s**2 - 4760*C*D1*Dd*f**2*fd*s + 1680*C*D1*Dd*f**2*fd + 560*C*D1*Ddd*f**3*r**2 + 1120*C*D1*Ddd*f**3*r*s - 840*C*D1*Ddd*f**3*r + 560*C*D1*Ddd*f**3*s**2 - 840*C*D1*Ddd*f**3*s + 420*C*D1*Ddd*f**3 + 1680*C*Dd**2*f**3*r**2 + 3360*C*Dd**2*f**3*r*s - 2520*C*Dd**2*f**3*r + 1680*C*Dd**2*f**3*s**2 - 2520*C*Dd**2*f**3*s + 840*C*Dd**2*f**3 + 90*D1**2*K*bdd1*f**2*r**2 + 180*D1**2*K*bdd1*f**2*r*s - 180*D1**2*K*bdd1*f**2*r + 90*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s + 90*D1**2*K*bdd1*f**2 - 6*D1**2*bd1**2*f*(-56*K + 25*f + 28)*(r + s - 1)**2 - 180*D1**2*bdd1*f**2*r**2 - 360*D1**2*bdd1*f**2*r*s + 360*D1**2*bdd1*f**2*r - 180*D1**2*bdd1*f**2*s**2 + 360*D1**2*bdd1*f**2*s - 180*D1**2*bdd1*f**2 - 336*D1**2*bdd1*f*g2*r**2 - 672*D1**2*bdd1*f*g2*r*s + 672*D1**2*bdd1*f*g2*r - 336*D1**2*bdd1*f*g2*s**2 + 672*D1**2*bdd1*f*g2*s - 336*D1**2*bdd1*f*g2 - 75*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 280*D1**2*f**2*fdd*r - 210*D1**2*f**2*fdd*s**2 + 280*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 18*D1**2*f**2*gd2*r**2 - 36*D1**2*f**2*gd2*r*s + 36*D1**2*f**2*gd2*r - 18*D1**2*f**2*gd2*s**2 + 36*D1**2*f**2*gd2*s - 18*D1**2*f**2*gd2 - 180*D1**2*f**2*gdd2*r**2 - 360*D1**2*f**2*gdd2*r*s + 360*D1**2*f**2*gdd2*r - 180*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s - 180*D1**2*f**2*gdd2 - 420*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 560*D1**2*f*fd**2*r - 420*D1**2*f*fd**2*s**2 + 560*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 36*D1**2*f*fd*g2*r**2 - 72*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r - 36*D1**2*f*fd*g2*s**2 + 36*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*r**2 - 1440*D1**2*f*fd*gd2*r*s + 1080*D1**2*f*fd*gd2*r - 720*D1**2*f*fd*gd2*s**2 + 1080*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 360*D1**2*f*fdd*g2*r**2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r - 360*D1**2*f*fdd*g2*s**2 + 360*D1**2*f*fdd*g2*s - 180*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*r**2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r - 360*D1**2*fd**2*g2*s**2 + 360*D1**2*fd**2*g2*s - 100*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 75*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2380*D1*Dd*f**2*fd*r - 1680*D1*Dd*f**2*fd*s**2 + 2380*D1*Dd*f**2*fd*s - 840*D1*Dd*f**2*fd - 72*D1*Dd*f**2*g2*r**2 - 144*D1*Dd*f**2*g2*r*s + 108*D1*Dd*f**2*g2*r - 72*D1*Dd*f**2*g2*s**2 + 108*D1*Dd*f**2*g2*s - 54*D1*Dd*f**2*g2 - 1440*D1*Dd*f**2*gd2*r**2 - 2880*D1*Dd*f**2*gd2*r*s + 2520*D1*Dd*f**2*gd2*r - 1440*D1*Dd*f**2*gd2*s**2 + 2520*D1*Dd*f**2*gd2*s - 1080*D1*Dd*f**2*gd2 - 2880*D1*Dd*f*fd*g2*r**2 - 5760*D1*Dd*f*fd*g2*r*s + 3600*D1*Dd*f*fd*g2*r - 2880*D1*Dd*f*fd*g2*s**2 + 3600*D1*Dd*f*fd*g2*s - 1080*D1*Dd*f*fd*g2 - 280*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s**2 + 420*D1*Ddd*f**3*s - 210*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*r**2 - 1440*D1*Ddd*f**2*g2*r*s + 1080*D1*Ddd*f**2*g2*r - 720*D1*Ddd*f**2*g2*s**2 + 1080*D1*Ddd*f**2*g2*s - 540*D1*Ddd*f**2*g2 - D1*bd1*(D1*(30*f**3*(r + s - 1) + 3*f**2*(90*C - 3*K - 50)*(r + s - 1) - 2*f*(30*fd*(8*C + 3*K - 6)*(2*r + 2*s - 1) + (161*g2 - 336*gd2)*(r + s - 1)) + 672*fd*g2*(r + s)) - 12*Dd*f*(5*f*(8*C + 3*K - 6) - 56*g2)*(4*r + 4*s - 3))*(r + s - 1) - 840*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 840*Dd**2*f**3*s**2 + 1260*Dd**2*f**3*s - 420*Dd**2*f**3 - 2160*Dd**2*f**2*g2*r**2 - 4320*Dd**2*f**2*g2*r*s + 3240*Dd**2*f**2*g2*r - 2160*Dd**2*f**2*g2*s**2 + 3240*Dd**2*f**2*g2*s - 1080*Dd**2*f**2*g2 + b1**2*(D1**2*(3*f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 7*fd*(23*K - 9)*(r + s) - 84*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(108*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(150*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (161*K - 63)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 168*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-56*K + 25*f + 28)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-56*K + 25*f + 28)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-540*C*D1**2*f*fd*r**2 - 1080*C*D1**2*f*fd*r*s + 540*C*D1**2*f*fd*r - 540*C*D1**2*f*fd*s**2 + 540*C*D1**2*f*fd*s - 270*C*D1**2*f*fd + 480*C*D1**2*f*fdd*r**2 + 960*C*D1**2*f*fdd*r*s - 480*C*D1**2*f*fdd*r + 480*C*D1**2*f*fdd*s**2 - 480*C*D1**2*f*fdd*s + 240*C*D1**2*f*fdd + 480*C*D1**2*fd**2*r**2 + 960*C*D1**2*fd**2*r*s - 480*C*D1**2*fd**2*r + 480*C*D1**2*fd**2*s**2 - 480*C*D1**2*fd**2*s - 1080*C*D1*Dd*f**2*r**2 - 2160*C*D1*Dd*f**2*r*s + 1620*C*D1*Dd*f**2*r - 1080*C*D1*Dd*f**2*s**2 + 1620*C*D1*Dd*f**2*s - 810*C*D1*Dd*f**2 + 3840*C*D1*Dd*f*fd*r**2 + 7680*C*D1*Dd*f*fd*r*s - 4800*C*D1*Dd*f*fd*r + 3840*C*D1*Dd*f*fd*s**2 - 4800*C*D1*Dd*f*fd*s + 1440*C*D1*Dd*f*fd + 960*C*D1*Ddd*f**2*r**2 + 1920*C*D1*Ddd*f**2*r*s - 1440*C*D1*Ddd*f**2*r + 960*C*D1*Ddd*f**2*s**2 - 1440*C*D1*Ddd*f**2*s + 720*C*D1*Ddd*f**2 + 2880*C*Dd**2*f**2*r**2 + 5760*C*Dd**2*f**2*r*s - 4320*C*Dd**2*f**2*r + 2880*C*Dd**2*f**2*s**2 - 4320*C*Dd**2*f**2*s + 1440*C*Dd**2*f**2 + 18*D1**2*K*f*fd*r**2 + 36*D1**2*K*f*fd*r*s - 18*D1**2*K*f*fd*r + 18*D1**2*K*f*fd*s**2 - 18*D1**2*K*f*fd*s + 9*D1**2*K*f*fd + 180*D1**2*K*f*fdd*r**2 + 360*D1**2*K*f*fdd*r*s - 180*D1**2*K*f*fdd*r + 180*D1**2*K*f*fdd*s**2 - 180*D1**2*K*f*fdd*s + 90*D1**2*K*f*fdd + 180*D1**2*K*fd**2*r**2 + 360*D1**2*K*fd**2*r*s - 180*D1**2*K*fd**2*r + 180*D1**2*K*fd**2*s**2 - 180*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-56*K + 25*f + 28)*(r + s - 1)**2 - 90*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 300*D1**2*f*fd*r**2 + 600*D1**2*f*fd*r*s - 300*D1**2*f*fd*r + 300*D1**2*f*fd*s**2 - 300*D1**2*f*fd*s + 150*D1**2*f*fd - 360*D1**2*f*fdd*r**2 - 720*D1**2*f*fdd*r*s + 360*D1**2*f*fdd*r - 360*D1**2*f*fdd*s**2 + 360*D1**2*f*fdd*s - 180*D1**2*f*fdd + 322*D1**2*f*gd2*r**2 + 644*D1**2*f*gd2*r*s - 644*D1**2*f*gd2*r + 322*D1**2*f*gd2*s**2 - 644*D1**2*f*gd2*s + 322*D1**2*f*gd2 - 336*D1**2*f*gdd2*r**2 - 672*D1**2*f*gdd2*r*s + 672*D1**2*f*gdd2*r - 336*D1**2*f*gdd2*s**2 + 672*D1**2*f*gdd2*s - 336*D1**2*f*gdd2 - 360*D1**2*fd**2*r**2 - 720*D1**2*fd**2*r*s + 360*D1**2*fd**2*r - 360*D1**2*fd**2*s**2 + 360*D1**2*fd**2*s + 322*D1**2*fd*g2*r**2 + 644*D1**2*fd*g2*r*s + 322*D1**2*fd*g2*s**2 - 672*D1**2*fd*gd2*r**2 - 1344*D1**2*fd*gd2*r*s + 672*D1**2*fd*gd2*r - 672*D1**2*fd*gd2*s**2 + 672*D1**2*fd*gd2*s - 336*D1**2*fdd*g2*r**2 - 672*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*s**2 + 36*D1*Dd*K*f**2*r**2 + 72*D1*Dd*K*f**2*r*s - 54*D1*Dd*K*f**2*r + 36*D1*Dd*K*f**2*s**2 - 54*D1*Dd*K*f**2*s + 27*D1*Dd*K*f**2 + 1440*D1*Dd*K*f*fd*r**2 + 2880*D1*Dd*K*f*fd*r*s - 1800*D1*Dd*K*f*fd*r + 1440*D1*Dd*K*f*fd*s**2 - 1800*D1*Dd*K*f*fd*s + 540*D1*Dd*K*f*fd - 120*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 180*D1*Dd*f**3*s - 90*D1*Dd*f**3 + 600*D1*Dd*f**2*r**2 + 1200*D1*Dd*f**2*r*s - 900*D1*Dd*f**2*r + 600*D1*Dd*f**2*s**2 - 900*D1*Dd*f**2*s + 450*D1*Dd*f**2 - 2880*D1*Dd*f*fd*r**2 - 5760*D1*Dd*f*fd*r*s + 3600*D1*Dd*f*fd*r - 2880*D1*Dd*f*fd*s**2 + 3600*D1*Dd*f*fd*s - 1080*D1*Dd*f*fd + 1288*D1*Dd*f*g2*r**2 + 2576*D1*Dd*f*g2*r*s - 1932*D1*Dd*f*g2*r + 1288*D1*Dd*f*g2*s**2 - 1932*D1*Dd*f*g2*s + 966*D1*Dd*f*g2 - 2688*D1*Dd*f*gd2*r**2 - 5376*D1*Dd*f*gd2*r*s + 4704*D1*Dd*f*gd2*r - 2688*D1*Dd*f*gd2*s**2 + 4704*D1*Dd*f*gd2*s - 2016*D1*Dd*f*gd2 - 2688*D1*Dd*fd*g2*r**2 - 5376*D1*Dd*fd*g2*r*s + 2016*D1*Dd*fd*g2*r - 2688*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s + 360*D1*Ddd*K*f**2*r**2 + 720*D1*Ddd*K*f**2*r*s - 540*D1*Ddd*K*f**2*r + 360*D1*Ddd*K*f**2*s**2 - 540*D1*Ddd*K*f**2*s + 270*D1*Ddd*K*f**2 - 720*D1*Ddd*f**2*r**2 - 1440*D1*Ddd*f**2*r*s + 1080*D1*Ddd*f**2*r - 720*D1*Ddd*f**2*s**2 + 1080*D1*Ddd*f**2*s - 540*D1*Ddd*f**2 - 1344*D1*Ddd*f*g2*r**2 - 2688*D1*Ddd*f*g2*r*s + 2016*D1*Ddd*f*g2*r - 1344*D1*Ddd*f*g2*s**2 + 2016*D1*Ddd*f*g2*s - 1008*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(108*f**2*(r + s - 1) - 150*f*fd*(2*r + 2*s - 1) - 7*f*(23*K - 9)*(r + s - 1) + 168*fd*(2*K - 1)*(r + s)) - 6*Dd*f*(-56*K + 25*f + 28)*(4*r + 4*s - 3))*(r + s - 1) + 1080*Dd**2*K*f**2*r**2 + 2160*Dd**2*K*f**2*r*s - 1620*Dd**2*K*f**2*r + 1080*Dd**2*K*f**2*s**2 - 1620*Dd**2*K*f**2*s + 540*Dd**2*K*f**2 - 2160*Dd**2*f**2*r**2 - 4320*Dd**2*f**2*r*s + 3240*Dd**2*f**2*r - 2160*Dd**2*f**2*s**2 + 3240*Dd**2*f**2*s - 1080*Dd**2*f**2 - 4032*Dd**2*f*g2*r**2 - 8064*Dd**2*f*g2*r*s + 6048*Dd**2*f*g2*r - 4032*Dd**2*f*g2*s**2 + 6048*Dd**2*f*g2*s - 2016*Dd**2*f*g2))/(35*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**4*k1**2*k2**2*st**4*(396*C*D1**2*f**2*fd*r*s - 132*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 396*C*D1**2*f**2*fd*s + 132*C*D1**2*f**2*fd - 198*C*D1**2*f**2*fdd*r*s + 66*C*D1**2*f**2*fdd*r - 198*C*D1**2*f**2*fdd*s**2 + 198*C*D1**2*f**2*fdd*s - 66*C*D1**2*f**2*fdd - 396*C*D1**2*f*fd**2*r*s + 132*C*D1**2*f*fd**2*r - 396*C*D1**2*f*fd**2*s**2 + 396*C*D1**2*f*fd**2*s - 66*C*D1**2*f*fd**2 + 528*C*D1*Dd*f**3*r*s - 132*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 528*C*D1*Dd*f**3*s + 132*C*D1*Dd*f**3 - 1584*C*D1*Dd*f**2*fd*r*s + 462*C*D1*Dd*f**2*fd*r - 1584*C*D1*Dd*f**2*fd*s**2 + 1584*C*D1*Dd*f**2*fd*s - 330*C*D1*Dd*f**2*fd - 264*C*D1*Ddd*f**3*r*s + 66*C*D1*Ddd*f**3*r - 264*C*D1*Ddd*f**3*s**2 + 264*C*D1*Ddd*f**3*s - 66*C*D1*Ddd*f**3 - 792*C*Dd**2*f**3*r*s + 198*C*Dd**2*f**3*r - 792*C*Dd**2*f**3*s**2 + 792*C*Dd**2*f**3*s - 132*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 560*D1**2*f**3*fd*r*s - 140*D1**2*f**3*fd*r + 560*D1**2*f**3*fd*s**2 - 560*D1**2*f**3*fd*s + 140*D1**2*f**3*fd - 280*D1**2*f**3*fdd*r*s + 70*D1**2*f**3*fdd*r - 280*D1**2*f**3*fdd*s**2 + 280*D1**2*f**3*fdd*s - 70*D1**2*f**3*fdd - 840*D1**2*f**2*fd**2*r*s + 210*D1**2*f**2*fd**2*r - 840*D1**2*f**2*fd**2*s**2 + 840*D1**2*f**2*fd**2*s - 140*D1**2*f**2*fd**2 - 396*D1**2*f**2*fd*r*s + 132*D1**2*f**2*fd*r - 396*D1**2*f**2*fd*s**2 + 396*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 198*D1**2*f**2*fdd*r*s - 66*D1**2*f**2*fdd*r + 198*D1**2*f**2*fdd*s**2 - 198*D1**2*f**2*fdd*s + 66*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 396*D1**2*f*fd**2*r*s - 132*D1**2*f*fd**2*r + 396*D1**2*f*fd**2*s**2 - 396*D1**2*f*fd**2*s + 66*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 560*D1*Dd*f**4*r*s - 140*D1*Dd*f**4*r + 560*D1*Dd*f**4*s**2 - 560*D1*Dd*f**4*s + 140*D1*Dd*f**4 - 2240*D1*Dd*f**3*fd*r*s + 560*D1*Dd*f**3*fd*r - 2240*D1*Dd*f**3*fd*s**2 + 2240*D1*Dd*f**3*fd*s - 420*D1*Dd*f**3*fd - 528*D1*Dd*f**3*r*s + 132*D1*Dd*f**3*r - 528*D1*Dd*f**3*s**2 + 528*D1*Dd*f**3*s - 132*D1*Dd*f**3 + 1584*D1*Dd*f**2*fd*r*s - 462*D1*Dd*f**2*fd*r + 1584*D1*Dd*f**2*fd*s**2 - 1584*D1*Dd*f**2*fd*s + 330*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 280*D1*Ddd*f**4*r*s + 70*D1*Ddd*f**4*r - 280*D1*Ddd*f**4*s**2 + 280*D1*Ddd*f**4*s - 70*D1*Ddd*f**4 + 264*D1*Ddd*f**3*r*s - 66*D1*Ddd*f**3*r + 264*D1*Ddd*f**3*s**2 - 264*D1*Ddd*f**3*s + 66*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 840*Dd**2*f**4*r*s + 210*Dd**2*f**4*r - 840*Dd**2*f**4*s**2 + 840*Dd**2*f**4*s - 140*Dd**2*f**4 + 792*Dd**2*f**3*r*s - 198*Dd**2*f**3*r + 792*Dd**2*f**3*s**2 - 792*Dd**2*f**3*s + 132*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(231*d**2*k3**6) - 2*D1**2*Pk2*Pk3*ct**4*k1**2*k2**2*st**2*(-216*C*D1**2*bdd1*f**2*r**2 - 864*C*D1**2*bdd1*f**2*r*s + 432*C*D1**2*bdd1*f**2*r - 648*C*D1**2*bdd1*f**2*s**2 + 864*C*D1**2*bdd1*f**2*s - 432*C*D1**2*bdd1*f**2 - 9036*C*D1**2*f**2*fd*r**2 - 3192*C*D1**2*f**2*fd*r*s + 7088*C*D1**2*f**2*fd*r + 5844*C*D1**2*f**2*fd*s**2 - 2832*C*D1**2*f**2*fd*s - 1064*C*D1**2*f**2*fd + 6948*C*D1**2*f**2*fdd*r**2 + 3864*C*D1**2*f**2*fdd*r*s - 5920*C*D1**2*f**2*fdd*r - 3084*C*D1**2*f**2*fdd*s**2 + 768*C*D1**2*f**2*fdd*s + 1288*C*D1**2*f**2*fdd + 13896*C*D1**2*f*fd**2*r**2 + 7728*C*D1**2*f*fd**2*r*s - 11840*C*D1**2*f*fd**2*r - 6168*C*D1**2*f*fd**2*s**2 + 1536*C*D1**2*f*fd**2*s + 1288*C*D1**2*f*fd**2 - 12048*C*D1*Dd*f**3*r**2 - 4256*C*D1*Dd*f**3*r*s + 13112*C*D1*Dd*f**3*r + 7792*C*D1*Dd*f**3*s**2 - 1768*C*D1*Dd*f**3*s - 4076*C*D1*Dd*f**3 + 55584*C*D1*Dd*f**2*fd*r**2 + 30912*C*D1*Dd*f**2*fd*r*s - 55336*C*D1*Dd*f**2*fd*r - 24672*C*D1*Dd*f**2*fd*s**2 + 1512*C*D1*Dd*f**2*fd*s + 11072*C*D1*Dd*f**2*fd + 9264*C*D1*Ddd*f**3*r**2 + 5152*C*D1*Ddd*f**3*r*s - 10552*C*D1*Ddd*f**3*r - 4112*C*D1*Ddd*f**3*s**2 - 520*C*D1*Ddd*f**3*s + 3604*C*D1*Ddd*f**3 + 27792*C*Dd**2*f**3*r**2 + 15456*C*Dd**2*f**3*r*s - 31656*C*Dd**2*f**3*r - 12336*C*Dd**2*f**3*s**2 - 1560*C*Dd**2*f**3*s + 7208*C*Dd**2*f**3 + 1710*D1**2*K*bdd1*f**2*r**2 + 1044*D1**2*K*bdd1*f**2*r*s - 3420*D1**2*K*bdd1*f**2*r - 666*D1**2*K*bdd1*f**2*s**2 - 1044*D1**2*K*bdd1*f**2*s + 1710*D1**2*K*bdd1*f**2 - 504*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1) - 750*D1**2*bdd1*f**3*r**2 - 600*D1**2*bdd1*f**3*r*s + 1500*D1**2*bdd1*f**3*r + 150*D1**2*bdd1*f**3*s**2 + 600*D1**2*bdd1*f**3*s - 900*D1**2*bdd1*f**3 - 2214*D1**2*bdd1*f**2*r**2 - 2700*D1**2*bdd1*f**2*r*s + 4428*D1**2*bdd1*f**2*r - 486*D1**2*bdd1*f**2*s**2 + 2700*D1**2*bdd1*f**2*s - 1998*D1**2*bdd1*f**2 + 504*D1**2*bdd1*f*g2*r**2 + 2016*D1**2*bdd1*f*g2*r*s - 1008*D1**2*bdd1*f*g2*r + 1512*D1**2*bdd1*f*g2*s**2 - 2016*D1**2*bdd1*f*g2*s + 1008*D1**2*bdd1*f*g2 - 6300*D1**2*f**3*fd*r**2 - 12000*D1**2*f**3*fd*r*s + 9300*D1**2*f**3*fd*r - 5700*D1**2*f**3*fd*s**2 + 8850*D1**2*f**3*fd*s - 4575*D1**2*f**3*fd + 6900*D1**2*f**3*fdd*r**2 + 10800*D1**2*f**3*fdd*r*s - 9600*D1**2*f**3*fdd*r + 3900*D1**2*f**3*fdd*s**2 - 7350*D1**2*f**3*fdd*s + 4425*D1**2*f**3*fdd + 20700*D1**2*f**2*fd**2*r**2 + 32400*D1**2*f**2*fd**2*r*s - 28800*D1**2*f**2*fd**2*r + 11700*D1**2*f**2*fd**2*s**2 - 22050*D1**2*f**2*fd**2*s + 8850*D1**2*f**2*fd**2 + 10788*D1**2*f**2*fd*r**2 + 9648*D1**2*f**2*fd*r*s - 10408*D1**2*f**2*fd*r - 1140*D1**2*f**2*fd*s**2 - 2456*D1**2*f**2*fd*s + 3216*D1**2*f**2*fd - 8148*D1**2*f**2*fdd*r**2 - 8064*D1**2*f**2*fdd*r*s + 8120*D1**2*f**2*fdd*r + 84*D1**2*f**2*fdd*s**2 + 2632*D1**2*f**2*fdd*s - 2688*D1**2*f**2*fdd + 4068*D1**2*f**2*gd2*r**2 + 1656*D1**2*f**2*gd2*r*s - 8136*D1**2*f**2*gd2*r - 2412*D1**2*f**2*gd2*s**2 - 1656*D1**2*f**2*gd2*s + 4068*D1**2*f**2*gd2 - 3420*D1**2*f**2*gdd2*r**2 - 2088*D1**2*f**2*gdd2*r*s + 6840*D1**2*f**2*gdd2*r + 1332*D1**2*f**2*gdd2*s**2 + 2088*D1**2*f**2*gdd2*s - 3420*D1**2*f**2*gdd2 - 16296*D1**2*f*fd**2*r**2 - 16128*D1**2*f*fd**2*r*s + 16240*D1**2*f*fd**2*r + 168*D1**2*f*fd**2*s**2 + 5264*D1**2*f*fd**2*s - 2688*D1**2*f*fd**2 + 8136*D1**2*f*fd*g2*r**2 + 3312*D1**2*f*fd*g2*r*s - 1656*D1**2*f*fd*g2*r - 4824*D1**2*f*fd*g2*s**2 + 4824*D1**2*f*fd*g2*s - 2412*D1**2*f*fd*g2 - 13680*D1**2*f*fd*gd2*r**2 - 8352*D1**2*f*fd*gd2*r*s + 15768*D1**2*f*fd*gd2*r + 5328*D1**2*f*fd*gd2*s**2 + 1512*D1**2*f*fd*gd2*s - 2088*D1**2*f*fd*gd2 - 6840*D1**2*f*fdd*g2*r**2 - 4176*D1**2*f*fdd*g2*r*s + 2088*D1**2*f*fdd*g2*r + 2664*D1**2*f*fdd*g2*s**2 - 2664*D1**2*f*fdd*g2*s + 1332*D1**2*f*fdd*g2 - 6840*D1**2*fd**2*g2*r**2 - 4176*D1**2*fd**2*g2*r*s + 2088*D1**2*fd**2*g2*r + 2664*D1**2*fd**2*g2*s**2 - 2664*D1**2*fd**2*g2*s - 6300*D1*Dd*f**4*r**2 - 12000*D1*Dd*f**4*r*s + 9300*D1*Dd*f**4*r - 5700*D1*Dd*f**4*s**2 + 8850*D1*Dd*f**4*s - 4575*D1*Dd*f**4 + 55200*D1*Dd*f**3*fd*r**2 + 86400*D1*Dd*f**3*fd*r*s - 76800*D1*Dd*f**3*fd*r + 31200*D1*Dd*f**3*fd*s**2 - 58800*D1*Dd*f**3*fd*s + 26550*D1*Dd*f**3*fd + 14384*D1*Dd*f**3*r**2 + 12864*D1*Dd*f**3*r*s - 17600*D1*Dd*f**3*r - 1520*D1*Dd*f**3*s**2 - 5672*D1*Dd*f**3*s + 6812*D1*Dd*f**3 - 65184*D1*Dd*f**2*fd*r**2 - 64512*D1*Dd*f**2*fd*r*s + 73136*D1*Dd*f**2*fd*r + 672*D1*Dd*f**2*fd*s**2 + 26488*D1*Dd*f**2*fd*s - 18872*D1*Dd*f**2*fd + 16272*D1*Dd*f**2*g2*r**2 + 6624*D1*Dd*f**2*g2*r*s - 17928*D1*Dd*f**2*g2*r - 9648*D1*Dd*f**2*g2*s**2 + 1512*D1*Dd*f**2*g2*s + 5724*D1*Dd*f**2*g2 - 27360*D1*Dd*f**2*gd2*r**2 - 16704*D1*Dd*f**2*gd2*r*s + 43128*D1*Dd*f**2*gd2*r + 10656*D1*Dd*f**2*gd2*s**2 + 9864*D1*Dd*f**2*gd2*s - 15768*D1*Dd*f**2*gd2 - 54720*D1*Dd*f*fd*g2*r**2 - 33408*D1*Dd*f*fd*g2*r*s + 39888*D1*Dd*f*fd*g2*r + 21312*D1*Dd*f*fd*g2*s**2 - 7632*D1*Dd*f*fd*g2*s - 1512*D1*Dd*f*fd*g2 + 6900*D1*Ddd*f**4*r**2 + 10800*D1*Ddd*f**4*r*s - 9600*D1*Ddd*f**4*r + 3900*D1*Ddd*f**4*s**2 - 7350*D1*Ddd*f**4*s + 4425*D1*Ddd*f**4 - 10864*D1*Ddd*f**3*r**2 - 10752*D1*Ddd*f**3*r*s + 13552*D1*Ddd*f**3*r + 112*D1*Ddd*f**3*s**2 + 5320*D1*Ddd*f**3*s - 5404*D1*Ddd*f**3 - 13680*D1*Ddd*f**2*g2*r**2 - 8352*D1*Ddd*f**2*g2*r*s + 15768*D1*Ddd*f**2*g2*r + 5328*D1*Ddd*f**2*g2*s**2 + 1512*D1*Ddd*f**2*g2*s - 5508*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(10*f**3*(19*r**2 + 2*r*(7*s - 19) - 5*s**2 - 14*s + 24) + f**2*(72*C*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 2) + 3*K*(-113*r**2 - 46*r*s + 226*r + 67*s**2 + 46*s - 113) - 50*fd*(15*r**2 + 2*r*(6*s - 11) - 3*s**2 - 7*s + 6) + 423*r**2 + 438*r*s - 846*r + 15*s**2 - 438*s + 351) - 6*f*(12*C*fd*(2*r**2 + r*(8*s - 4) + 6*s**2 - 7*s + 1) + K*fd*(-190*r**2 + r*(219 - 116*s) + 74*s**2 + 21*s - 29) + 3*fd*(82*r**2 + r*(100*s - 107) + 18*s**2 - 59*s + 29) + 28*g2*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 2) - 28*gd2*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1)) + 168*fd*g2*(r**2 + r*(4*s - 2) + s*(3*s - 3))) - 2*Dd*f*(25*f**2*(20*r**2 + 16*r*(s - 2) - 4*s**2 - 11*s + 12) + 3*f*(12*C*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4) + K*(-380*r**2 - 232*r*s + 599*r + 148*s**2 + 137*s - 219) + 492*r**2 + 600*r*s - 813*r + 108*s**2 - 477*s + 321) - 84*g2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4))) + 20700*Dd**2*f**4*r**2 + 32400*Dd**2*f**4*r*s - 28800*Dd**2*f**4*r + 11700*Dd**2*f**4*s**2 - 22050*Dd**2*f**4*s + 8850*Dd**2*f**4 - 32592*Dd**2*f**3*r**2 - 32256*Dd**2*f**3*r*s + 40656*Dd**2*f**3*r + 336*Dd**2*f**3*s**2 + 15960*Dd**2*f**3*s - 10808*Dd**2*f**3 - 41040*Dd**2*f**2*g2*r**2 - 25056*Dd**2*f**2*g2*r*s + 47304*Dd**2*f**2*g2*r + 15984*Dd**2*f**2*g2*s**2 + 4536*Dd**2*f**2*g2*s - 11016*Dd**2*f**2*g2 + 252*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + D1*(2*Dd*(f*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 14*s + 5) - fd*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3)) - Ddd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 14*s + 5)) - 2*Dd**2*f*(6*r**2 + 12*r*(2*s - 1) + 18*s**2 - 21*s + 5)) + 6*b1*(144*C*D1**2*f*fd*r**2 + 576*C*D1**2*f*fd*r*s - 288*C*D1**2*f*fd*r + 432*C*D1**2*f*fd*s**2 - 432*C*D1**2*f*fd*s + 144*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r**2 - 288*C*D1**2*f*fdd*r*s + 144*C*D1**2*f*fdd*r - 216*C*D1**2*f*fdd*s**2 + 216*C*D1**2*f*fdd*s - 72*C*D1**2*f*fdd - 72*C*D1**2*fd**2*r**2 - 288*C*D1**2*fd**2*r*s + 144*C*D1**2*fd**2*r - 216*C*D1**2*fd**2*s**2 + 216*C*D1**2*fd**2*s - 72*C*D1**2*fd**2 + 288*C*D1*Dd*f**2*r**2 + 1152*C*D1*Dd*f**2*r*s - 576*C*D1*Dd*f**2*r + 864*C*D1*Dd*f**2*s**2 - 1008*C*D1*Dd*f**2*s + 360*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r**2 - 2304*C*D1*Dd*f*fd*r*s + 1152*C*D1*Dd*f*fd*r - 1728*C*D1*Dd*f*fd*s**2 + 1872*C*D1*Dd*f*fd*s - 504*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r**2 - 576*C*D1*Ddd*f**2*r*s + 288*C*D1*Ddd*f**2*r - 432*C*D1*Ddd*f**2*s**2 + 504*C*D1*Ddd*f**2*s - 180*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r**2 - 1728*C*Dd**2*f**2*r*s + 864*C*Dd**2*f**2*r - 1296*C*Dd**2*f**2*s**2 + 1512*C*Dd**2*f**2*s - 360*C*Dd**2*f**2 - 678*D1**2*K*f*fd*r**2 - 276*D1**2*K*f*fd*r*s + 138*D1**2*K*f*fd*r + 402*D1**2*K*f*fd*s**2 - 402*D1**2*K*f*fd*s + 201*D1**2*K*f*fd + 570*D1**2*K*f*fdd*r**2 + 348*D1**2*K*f*fdd*r*s - 174*D1**2*K*f*fdd*r - 222*D1**2*K*f*fdd*s**2 + 222*D1**2*K*f*fdd*s - 111*D1**2*K*f*fdd + 570*D1**2*K*fd**2*r**2 + 348*D1**2*K*fd**2*r*s - 174*D1**2*K*fd**2*r - 222*D1**2*K*fd**2*s**2 + 222*D1**2*K*fd**2*s - 42*D1**2*bdd1*f*(K - 1)*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) + 570*D1**2*f**2*fd*r**2 + 420*D1**2*f**2*fd*r*s - 520*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 300*D1**2*f**2*fdd*r*s + 350*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 + 50*D1**2*f**2*fdd*s - 75*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 600*D1**2*f*fd**2*r*s + 700*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 + 100*D1**2*f*fd**2*s - 150*D1**2*f*fd**2 + 846*D1**2*f*fd*r**2 + 876*D1**2*f*fd*r*s - 438*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 30*D1**2*f*fd*s + 87*D1**2*f*fd - 738*D1**2*f*fdd*r**2 - 900*D1**2*f*fdd*r*s + 450*D1**2*f*fdd*r - 162*D1**2*f*fdd*s**2 + 162*D1**2*f*fdd*s - 117*D1**2*f*fdd - 168*D1**2*f*gd2*r**2 - 672*D1**2*f*gd2*r*s + 336*D1**2*f*gd2*r - 504*D1**2*f*gd2*s**2 + 672*D1**2*f*gd2*s - 168*D1**2*f*gd2 + 84*D1**2*f*gdd2*r**2 + 336*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*r + 252*D1**2*f*gdd2*s**2 - 336*D1**2*f*gdd2*s + 84*D1**2*f*gdd2 - 738*D1**2*fd**2*r**2 - 900*D1**2*fd**2*r*s + 450*D1**2*fd**2*r - 162*D1**2*fd**2*s**2 + 162*D1**2*fd**2*s + 72*D1**2*fd**2 - 168*D1**2*fd*g2*r**2 - 672*D1**2*fd*g2*r*s + 336*D1**2*fd*g2*r - 504*D1**2*fd*g2*s**2 + 336*D1**2*fd*g2*s - 168*D1**2*fd*g2 + 168*D1**2*fd*gd2*r**2 + 672*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*r + 504*D1**2*fd*gd2*s**2 - 504*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 + 84*D1**2*fdd*g2*r**2 + 336*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r + 252*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 - 1356*D1*Dd*K*f**2*r**2 - 552*D1*Dd*K*f**2*r*s + 1494*D1*Dd*K*f**2*r + 804*D1*Dd*K*f**2*s**2 - 126*D1*Dd*K*f**2*s - 477*D1*Dd*K*f**2 + 4560*D1*Dd*K*f*fd*r**2 + 2784*D1*Dd*K*f*fd*r*s - 3324*D1*Dd*K*f*fd*r - 1776*D1*Dd*K*f*fd*s**2 + 636*D1*Dd*K*f*fd*s + 126*D1*Dd*K*f*fd + 760*D1*Dd*f**3*r**2 + 560*D1*Dd*f**3*r*s - 900*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 - 180*D1*Dd*f**3*s + 330*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 2400*D1*Dd*f**2*fd*r*s + 3200*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 + 650*D1*Dd*f**2*fd*s - 750*D1*Dd*f**2*fd + 1692*D1*Dd*f**2*r**2 + 1752*D1*Dd*f**2*r*s - 2130*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 906*D1*Dd*f**2*s + 861*D1*Dd*f**2 - 5904*D1*Dd*f*fd*r**2 - 7200*D1*Dd*f*fd*r*s + 5652*D1*Dd*f*fd*r - 1296*D1*Dd*f*fd*s**2 + 2772*D1*Dd*f*fd*s - 1062*D1*Dd*f*fd - 672*D1*Dd*f*g2*r**2 - 2688*D1*Dd*f*g2*r*s + 1344*D1*Dd*f*g2*r - 2016*D1*Dd*f*g2*s**2 + 2352*D1*Dd*f*g2*s - 840*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r**2 + 2688*D1*Dd*f*gd2*r*s - 1344*D1*Dd*f*gd2*r + 2016*D1*Dd*f*gd2*s**2 - 2520*D1*Dd*f*gd2*s + 672*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r**2 + 2688*D1*Dd*fd*g2*r*s - 1344*D1*Dd*fd*g2*r + 2016*D1*Dd*fd*g2*s**2 - 1848*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 + 1140*D1*Ddd*K*f**2*r**2 + 696*D1*Ddd*K*f**2*r*s - 1314*D1*Ddd*K*f**2*r - 444*D1*Ddd*K*f**2*s**2 - 126*D1*Ddd*K*f**2*s + 459*D1*Ddd*K*f**2 - 500*D1*Ddd*f**3*r**2 - 400*D1*Ddd*f**3*r*s + 600*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 225*D1*Ddd*f**3 - 1476*D1*Ddd*f**2*r**2 - 1800*D1*Ddd*f**2*r*s + 1926*D1*Ddd*f**2*r - 324*D1*Ddd*f**2*s**2 + 1062*D1*Ddd*f**2*s - 819*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r**2 + 1344*D1*Ddd*f*g2*r*s - 672*D1*Ddd*f*g2*r + 1008*D1*Ddd*f*g2*s**2 - 1176*D1*Ddd*f*g2*s + 420*D1*Ddd*f*g2 + 84*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) - fd*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 6*s + 1)) - 2*Dd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 3420*Dd**2*K*f**2*r**2 + 2088*Dd**2*K*f**2*r*s - 3942*Dd**2*K*f**2*r - 1332*Dd**2*K*f**2*s**2 - 378*Dd**2*K*f**2*s + 918*Dd**2*K*f**2 - 1500*Dd**2*f**3*r**2 - 1200*Dd**2*f**3*r*s + 1800*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 450*Dd**2*f**3 - 4428*Dd**2*f**2*r**2 - 5400*Dd**2*f**2*r*s + 5778*Dd**2*f**2*r - 972*Dd**2*f**2*s**2 + 3186*Dd**2*f**2*s - 1638*Dd**2*f**2 + 1008*Dd**2*f*g2*r**2 + 4032*Dd**2*f*g2*r*s - 2016*Dd**2*f*g2*r + 3024*Dd**2*f*g2*s**2 - 3528*Dd**2*f*g2*s + 840*Dd**2*f*g2))/(315*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**4*k1**2*k2**2*(-474*C*D1**2*bdd1*f**2*r**2 - 564*C*D1**2*bdd1*f**2*r*s + 1044*C*D1**2*bdd1*f**2*r - 90*C*D1**2*bdd1*f**2*s**2 + 660*C*D1**2*bdd1*f**2*s - 330*C*D1**2*bdd1*f**2 + 3060*C*D1**2*f**2*fd*r**2 + 9120*C*D1**2*f**2*fd*r*s - 5080*C*D1**2*f**2*fd*r + 6060*C*D1**2*f**2*fd*s**2 - 7080*C*D1**2*f**2*fd*s + 3040*C*D1**2*f**2*fd - 3960*C*D1**2*f**2*fdd*r**2 - 9600*C*D1**2*f**2*fdd*r*s + 5840*C*D1**2*f**2*fdd*r - 5640*C*D1**2*f**2*fdd*s**2 + 6960*C*D1**2*f**2*fdd*s - 3200*C*D1**2*f**2*fdd - 7920*C*D1**2*f*fd**2*r**2 - 19200*C*D1**2*f*fd**2*r*s + 11680*C*D1**2*f*fd**2*r - 11280*C*D1**2*f*fd**2*s**2 + 13920*C*D1**2*f*fd**2*s - 3200*C*D1**2*f*fd**2 + 4080*C*D1*Dd*f**3*r**2 + 12160*C*D1*Dd*f**3*r*s - 7120*C*D1*Dd*f**3*r + 8080*C*D1*Dd*f**3*s**2 - 10120*C*D1*Dd*f**3*s + 4060*C*D1*Dd*f**3 - 31680*C*D1*Dd*f**2*fd*r**2 - 76800*C*D1*Dd*f**2*fd*r*s + 48800*C*D1*Dd*f**2*fd*r - 45120*C*D1*Dd*f**2*fd*s**2 + 58320*C*D1*Dd*f**2*fd*s - 18640*C*D1*Dd*f**2*fd - 5280*C*D1*Ddd*f**3*r**2 - 12800*C*D1*Ddd*f**3*r*s + 8480*C*D1*Ddd*f**3*r - 7520*C*D1*Ddd*f**3*s**2 + 10160*C*D1*Ddd*f**3*s - 4520*C*D1*Ddd*f**3 - 15840*C*Dd**2*f**3*r**2 - 38400*C*Dd**2*f**3*r*s + 25440*C*Dd**2*f**3*r - 22560*C*Dd**2*f**3*s**2 + 30480*C*Dd**2*f**3*s - 9040*C*Dd**2*f**3 - 780*D1**2*K*bdd1*f**2*r**2 - 2064*D1**2*K*bdd1*f**2*r*s + 1560*D1**2*K*bdd1*f**2*r - 1284*D1**2*K*bdd1*f**2*s**2 + 2064*D1**2*K*bdd1*f**2*s - 780*D1**2*K*bdd1*f**2 + 300*D1**2*b2*f*fd*r**2 + 600*D1**2*b2*f*fd*r*s - 300*D1**2*b2*f*fd*r + 300*D1**2*b2*f*fd*s**2 - 300*D1**2*b2*f*fd*s + 150*D1**2*b2*f*fd - 360*D1**2*b2*f*fdd*r**2 - 720*D1**2*b2*f*fdd*r*s + 360*D1**2*b2*f*fdd*r - 360*D1**2*b2*f*fdd*s**2 + 360*D1**2*b2*f*fdd*s - 180*D1**2*b2*f*fdd - 360*D1**2*b2*fd**2*r**2 - 720*D1**2*b2*fd**2*r*s + 360*D1**2*b2*fd**2*r - 360*D1**2*b2*fd**2*s**2 + 360*D1**2*b2*fd**2*s + 2*D1**2*bd1**2*(r + s - 1)*(60*f**2*(r + s - 2) + 7*f*(12*C*r + 12*C*s + K*(-37*r - 13*s + 49) + 61*r + 37*s - 73) - 140*g2*(r + s)) + 150*D1**2*bdd1*f**3*r**2 + 570*D1**2*bdd1*f**3*r*s - 510*D1**2*bdd1*f**3*r + 420*D1**2*bdd1*f**3*s**2 - 780*D1**2*bdd1*f**3*s + 360*D1**2*bdd1*f**3 + 954*D1**2*bdd1*f**2*r**2 + 1776*D1**2*bdd1*f**2*r*s - 1884*D1**2*bdd1*f**2*r + 822*D1**2*bdd1*f**2*s**2 - 1752*D1**2*bdd1*f**2*s + 750*D1**2*bdd1*f**2 + 518*D1**2*bdd1*f*g2*r**2 + 700*D1**2*bdd1*f*g2*r*s - 1372*D1**2*bdd1*f*g2*r + 182*D1**2*bdd1*f*g2*s**2 - 1036*D1**2*bdd1*f*g2*s + 518*D1**2*bdd1*f*g2 - 180*D1**2*bdd2*f**2*r**2 - 360*D1**2*bdd2*f**2*r*s + 360*D1**2*bdd2*f**2*r - 180*D1**2*bdd2*f**2*s**2 + 360*D1**2*bdd2*f**2*s - 180*D1**2*bdd2*f**2 - 1740*D1**2*f**2*fd*r**2 - 5910*D1**2*f**2*fd*r*s + 3130*D1**2*f**2*fd*r - 4170*D1**2*f**2*fd*s**2 + 4750*D1**2*f**2*fd*s - 1970*D1**2*f**2*fd + 2760*D1**2*f**2*fdd*r**2 + 6780*D1**2*f**2*fdd*r*s - 4100*D1**2*f**2*fdd*r + 4020*D1**2*f**2*fdd*s**2 - 4940*D1**2*f**2*fdd*s + 2260*D1**2*f**2*fdd - 852*D1**2*f**2*gd2*r**2 - 3552*D1**2*f**2*gd2*r*s + 1704*D1**2*f**2*gd2*r - 2700*D1**2*f**2*gd2*s**2 + 3552*D1**2*f**2*gd2*s - 852*D1**2*f**2*gd2 + 1560*D1**2*f**2*gdd2*r**2 + 4128*D1**2*f**2*gdd2*r*s - 3120*D1**2*f**2*gdd2*r + 2568*D1**2*f**2*gdd2*s**2 - 4128*D1**2*f**2*gdd2*s + 1560*D1**2*f**2*gdd2 + 5520*D1**2*f*fd**2*r**2 + 13560*D1**2*f*fd**2*r*s - 8200*D1**2*f*fd**2*r + 8040*D1**2*f*fd**2*s**2 - 9880*D1**2*f*fd**2*s + 2260*D1**2*f*fd**2 - 1704*D1**2*f*fd*g2*r**2 - 7104*D1**2*f*fd*g2*r*s + 3552*D1**2*f*fd*g2*r - 5400*D1**2*f*fd*g2*s**2 + 5400*D1**2*f*fd*g2*s - 2700*D1**2*f*fd*g2 + 6240*D1**2*f*fd*gd2*r**2 + 16512*D1**2*f*fd*gd2*r*s - 10368*D1**2*f*fd*gd2*r + 10272*D1**2*f*fd*gd2*s**2 - 13392*D1**2*f*fd*gd2*s + 4128*D1**2*f*fd*gd2 + 3120*D1**2*f*fdd*g2*r**2 + 8256*D1**2*f*fdd*g2*r*s - 4128*D1**2*f*fdd*g2*r + 5136*D1**2*f*fdd*g2*s**2 - 5136*D1**2*f*fdd*g2*s + 2568*D1**2*f*fdd*g2 + 3120*D1**2*fd**2*g2*r**2 + 8256*D1**2*fd**2*g2*r*s - 4128*D1**2*fd**2*g2*r + 5136*D1**2*fd**2*g2*s**2 - 5136*D1**2*fd**2*g2*s + 600*D1*Dd*b2*f**2*r**2 + 1200*D1*Dd*b2*f**2*r*s - 900*D1*Dd*b2*f**2*r + 600*D1*Dd*b2*f**2*s**2 - 900*D1*Dd*b2*f**2*s + 450*D1*Dd*b2*f**2 - 2880*D1*Dd*b2*f*fd*r**2 - 5760*D1*Dd*b2*f*fd*r*s + 3600*D1*Dd*b2*f*fd*r - 2880*D1*Dd*b2*f*fd*s**2 + 3600*D1*Dd*b2*f*fd*s - 1080*D1*Dd*b2*f*fd - 2320*D1*Dd*f**3*r**2 - 7880*D1*Dd*f**3*r*s + 4290*D1*Dd*f**3*r - 5560*D1*Dd*f**3*s**2 + 6720*D1*Dd*f**3*s - 2550*D1*Dd*f**3 + 22080*D1*Dd*f**2*fd*r**2 + 54240*D1*Dd*f**2*fd*r*s - 34220*D1*Dd*f**2*fd*r + 32160*D1*Dd*f**2*fd*s**2 - 41360*D1*Dd*f**2*fd*s + 13140*D1*Dd*f**2*fd - 3408*D1*Dd*f**2*g2*r**2 - 14208*D1*Dd*f**2*g2*r*s + 6960*D1*Dd*f**2*g2*r - 10800*D1*Dd*f**2*g2*s**2 + 12504*D1*Dd*f**2*g2*s - 4404*D1*Dd*f**2*g2 + 12480*D1*Dd*f**2*gd2*r**2 + 33024*D1*Dd*f**2*gd2*r*s - 22848*D1*Dd*f**2*gd2*r + 20544*D1*Dd*f**2*gd2*s**2 - 29904*D1*Dd*f**2*gd2*s + 10368*D1*Dd*f**2*gd2 + 24960*D1*Dd*f*fd*g2*r**2 + 66048*D1*Dd*f*fd*g2*r*s - 37248*D1*Dd*f*fd*g2*r + 41088*D1*Dd*f*fd*g2*s**2 - 47328*D1*Dd*f*fd*g2*s + 13392*D1*Dd*f*fd*g2 - 720*D1*Ddd*b2*f**2*r**2 - 1440*D1*Ddd*b2*f**2*r*s + 1080*D1*Ddd*b2*f**2*r - 720*D1*Ddd*b2*f**2*s**2 + 1080*D1*Ddd*b2*f**2*s - 540*D1*Ddd*b2*f**2 + 3680*D1*Ddd*f**3*r**2 + 9040*D1*Ddd*f**3*r*s - 5940*D1*Ddd*f**3*r + 5360*D1*Ddd*f**3*s**2 - 7200*D1*Ddd*f**3*s + 3180*D1*Ddd*f**3 + 6240*D1*Ddd*f**2*g2*r**2 + 16512*D1*Ddd*f**2*g2*r*s - 10368*D1*Ddd*f**2*g2*r + 10272*D1*Ddd*f**2*g2*s**2 - 13392*D1*Ddd*f**2*g2*s + 5688*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(-15*f**3*(r*(13*s - 7) + 13*s**2 - 20*s + 6) + 3*f**2*(C*(151*r**2 + r*(202*s - 222) + 51*s**2 - 122*s + 61) + 71*K*r**2 + 296*K*r*s - 142*K*r + 225*K*s**2 - 296*K*s + 71*K + 5*fd*(30*r**2 + 114*r*s - 73*r + 84*s**2 - 118*s + 36) - 178*r**2 - 347*r*s + 264*r - 169*s**2 + 255*s - 82) - f*(6*fd*(C*(158*r**2 + r*(188*s - 213) + 30*s**2 - 117*s + 87) + 2*K*(130*r**2 + 8*r*(43*s - 27) + 214*s**2 - 279*s + 86) - 318*r**2 - 592*r*s + 464*r - 274*s**2 + 431*s - 178) + 7*g2*(69*r**2 + 2*r*(55*s - 53) + 41*s**2 - 78*s + 39) - 14*gd2*(37*r**2 + r*(50*s - 86) + 13*s**2 - 62*s + 49)) + 14*fd*g2*(37*r**2 + 25*r*(2*s - 1) + s*(13*s - 13))) + Dd*f*(15*f**2*(40*r**2 + 152*r*s - 107*r + 112*s**2 - 170*s + 60) - 6*f*(C*(316*r**2 + r*(376*s - 553) + 60*s**2 - 329*s + 229) + 2*K*(260*r**2 + 688*r*s - 476*r + 428*s**2 - 623*s + 216) - 636*r**2 - 1184*r*s + 1094*r - 548*s**2 + 1017*s - 460) + 14*g2*(148*r**2 + 5*r*(40*s - 59) + 52*s**2 - 211*s + 135))) + 30*D1*bd2*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 2160*Dd**2*b2*f**2*r**2 - 4320*Dd**2*b2*f**2*r*s + 3240*Dd**2*b2*f**2*r - 2160*Dd**2*b2*f**2*s**2 + 3240*Dd**2*b2*f**2*s - 1080*Dd**2*b2*f**2 + 11040*Dd**2*f**3*r**2 + 27120*Dd**2*f**3*r*s - 17820*Dd**2*f**3*r + 16080*Dd**2*f**3*s**2 - 21600*Dd**2*f**3*s + 6360*Dd**2*f**3 + 18720*Dd**2*f**2*g2*r**2 + 49536*Dd**2*f**2*g2*r*s - 31104*Dd**2*f**2*g2*r + 30816*Dd**2*f**2*g2*s**2 - 40176*Dd**2*f**2*g2*s + 11376*Dd**2*f**2*g2 - 70*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-168*C*D1**2*fd*r**2 - 336*C*D1**2*fd*r*s + 336*C*D1**2*fd*r - 168*C*D1**2*fd*s**2 + 336*C*D1**2*fd*s - 168*C*D1**2*fd + 84*C*D1**2*fdd*r**2 + 168*C*D1**2*fdd*r*s - 168*C*D1**2*fdd*r + 84*C*D1**2*fdd*s**2 - 168*C*D1**2*fdd*s + 84*C*D1**2*fdd - 672*C*D1*Dd*f*r**2 - 1344*C*D1*Dd*f*r*s + 1008*C*D1*Dd*f*r - 672*C*D1*Dd*f*s**2 + 1008*C*D1*Dd*f*s - 504*C*D1*Dd*f + 672*C*D1*Dd*fd*r**2 + 1344*C*D1*Dd*fd*r*s - 1176*C*D1*Dd*fd*r + 672*C*D1*Dd*fd*s**2 - 1176*C*D1*Dd*fd*s + 504*C*D1*Dd*fd + 336*C*D1*Ddd*f*r**2 + 672*C*D1*Ddd*f*r*s - 504*C*D1*Ddd*f*r + 336*C*D1*Ddd*f*s**2 - 504*C*D1*Ddd*f*s + 252*C*D1*Ddd*f + 1008*C*Dd**2*f*r**2 + 2016*C*Dd**2*f*r*s - 1512*C*Dd**2*f*r + 1008*C*Dd**2*f*s**2 - 1512*C*Dd**2*f*s + 504*C*Dd**2*f + 483*D1**2*K*fd*r**2 + 770*D1**2*K*fd*r*s - 28*D1**2*K*fd*r + 287*D1**2*K*fd*s**2 - 28*D1**2*K*fd*s + 14*D1**2*K*fd - 259*D1**2*K*fdd*r**2 - 350*D1**2*K*fdd*r*s - 336*D1**2*K*fdd*r - 91*D1**2*K*fdd*s**2 - 336*D1**2*K*fdd*s + 168*D1**2*K*fdd + 70*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 240*D1**2*f*fd*r**2 - 480*D1**2*f*fd*r*s + 168*D1**2*f*fd*r - 240*D1**2*f*fd*s**2 + 168*D1**2*f*fd*s - 84*D1**2*f*fd + 120*D1**2*f*fdd*r**2 + 240*D1**2*f*fdd*r*s + 120*D1**2*f*fdd*s**2 + 120*D1**2*fd**2*r**2 + 240*D1**2*fd**2*r*s + 120*D1**2*fd**2*s**2 - 120*D1**2*fd**2 - 539*D1**2*fd*r**2 - 882*D1**2*fd*r*s - 252*D1**2*fd*r - 343*D1**2*fd*s**2 - 252*D1**2*fd*s + 126*D1**2*fd + 427*D1**2*fdd*r**2 + 686*D1**2*fdd*r*s + 336*D1**2*fdd*r + 259*D1**2*fdd*s**2 + 336*D1**2*fdd*s - 168*D1**2*fdd + 280*D1**2*gd2*r**2 + 560*D1**2*gd2*r*s - 560*D1**2*gd2*r + 280*D1**2*gd2*s**2 - 560*D1**2*gd2*s + 280*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 + 1932*D1*Dd*K*f*r**2 + 3080*D1*Dd*K*f*r*s - 2702*D1*Dd*K*f*r + 1148*D1*Dd*K*f*s**2 - 2114*D1*Dd*K*f*s + 1253*D1*Dd*K*f - 2072*D1*Dd*K*fd*r**2 - 2800*D1*Dd*K*fd*r*s + 42*D1*Dd*K*fd*r - 728*D1*Dd*K*fd*s**2 - 462*D1*Dd*K*fd*s + 1008*D1*Dd*K*fd - 480*D1*Dd*f**2*r**2 - 960*D1*Dd*f**2*r*s + 720*D1*Dd*f**2*r - 480*D1*Dd*f**2*s**2 + 720*D1*Dd*f**2*s - 360*D1*Dd*f**2 + 960*D1*Dd*f*fd*r**2 + 1920*D1*Dd*f*fd*r*s - 720*D1*Dd*f*fd*r + 960*D1*Dd*f*fd*s**2 - 720*D1*Dd*f*fd*s - 2156*D1*Dd*f*r**2 - 3528*D1*Dd*f*r*s + 3038*D1*Dd*f*r - 1372*D1*Dd*f*s**2 + 2450*D1*Dd*f*s - 1421*D1*Dd*f + 3416*D1*Dd*fd*r**2 + 5488*D1*Dd*fd*r*s - 1050*D1*Dd*fd*r + 2072*D1*Dd*fd*s**2 - 546*D1*Dd*fd*s - 1008*D1*Dd*fd + 1120*D1*Dd*g2*r**2 + 2240*D1*Dd*g2*r*s - 1680*D1*Dd*g2*r + 1120*D1*Dd*g2*s**2 - 1680*D1*Dd*g2*s + 840*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 - 1036*D1*Ddd*K*f*r**2 - 1400*D1*Ddd*K*f*r*s + 1386*D1*Ddd*K*f*r - 364*D1*Ddd*K*f*s**2 + 882*D1*Ddd*K*f*s - 609*D1*Ddd*K*f + 240*D1*Ddd*f**2*r**2 + 480*D1*Ddd*f**2*r*s - 360*D1*Ddd*f**2*r + 240*D1*Ddd*f**2*s**2 - 360*D1*Ddd*f**2*s + 180*D1*Ddd*f**2 + 1708*D1*Ddd*f*r**2 + 2744*D1*Ddd*f*r*s - 2394*D1*Ddd*f*r + 1036*D1*Ddd*f*s**2 - 1890*D1*Ddd*f*s + 1113*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 - 140*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 3108*Dd**2*K*f*r**2 - 4200*Dd**2*K*f*r*s + 4158*Dd**2*K*f*r - 1092*Dd**2*K*f*s**2 + 2646*Dd**2*K*f*s - 1218*Dd**2*K*f + 720*Dd**2*f**2*r**2 + 1440*Dd**2*f**2*r*s - 1080*Dd**2*f**2*r + 720*Dd**2*f**2*s**2 - 1080*Dd**2*f**2*s + 360*Dd**2*f**2 + 5124*Dd**2*f*r**2 + 8232*Dd**2*f*r*s - 7182*Dd**2*f*r + 3108*Dd**2*f*s**2 - 5670*Dd**2*f*s + 2226*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) + 2*b1*(906*C*D1**2*f*fd*r**2 + 1212*C*D1**2*f*fd*r*s - 846*C*D1**2*f*fd*r + 306*C*D1**2*f*fd*s**2 - 546*C*D1**2*f*fd*s + 423*C*D1**2*f*fd - 474*C*D1**2*f*fdd*r**2 - 564*C*D1**2*f*fdd*r*s + 234*C*D1**2*f*fdd*r - 90*C*D1**2*f*fdd*s**2 + 42*C*D1**2*f*fdd*s - 117*C*D1**2*f*fdd - 474*C*D1**2*fd**2*r**2 - 564*C*D1**2*fd**2*r*s + 234*C*D1**2*fd**2*r - 90*C*D1**2*fd**2*s**2 + 42*C*D1**2*fd**2*s + 240*C*D1**2*fd**2 + 1812*C*D1*Dd*f**2*r**2 + 2424*C*D1*Dd*f**2*r*s - 2418*C*D1*Dd*f**2*r + 612*C*D1*Dd*f**2*s**2 - 1518*C*D1*Dd*f**2*s + 1059*C*D1*Dd*f**2 - 3792*C*D1*Dd*f*fd*r**2 - 4512*C*D1*Dd*f*fd*r*s + 3396*C*D1*Dd*f*fd*r - 720*C*D1*Dd*f*fd*s**2 + 1476*C*D1*Dd*f*fd*s - 510*C*D1*Dd*f*fd - 948*C*D1*Ddd*f**2*r**2 - 1128*C*D1*Ddd*f**2*r*s + 1230*C*D1*Ddd*f**2*r - 180*C*D1*Ddd*f**2*s**2 + 654*C*D1*Ddd*f**2*s - 519*C*D1*Ddd*f**2 - 2844*C*Dd**2*f**2*r**2 - 3384*C*Dd**2*f**2*r*s + 3690*C*Dd**2*f**2*r - 540*C*Dd**2*f**2*s**2 + 1962*C*Dd**2*f**2*s - 1038*C*Dd**2*f**2 + 426*D1**2*K*f*fd*r**2 + 1776*D1**2*K*f*fd*r*s - 888*D1**2*K*f*fd*r + 1350*D1**2*K*f*fd*s**2 - 1350*D1**2*K*f*fd*s + 675*D1**2*K*f*fd - 780*D1**2*K*f*fdd*r**2 - 2064*D1**2*K*f*fdd*r*s + 1032*D1**2*K*f*fdd*r - 1284*D1**2*K*f*fdd*s**2 + 1284*D1**2*K*f*fdd*s - 642*D1**2*K*f*fdd - 780*D1**2*K*fd**2*r**2 - 2064*D1**2*K*fd**2*r*s + 1032*D1**2*K*fd**2*r - 1284*D1**2*K*fd**2*s**2 + 1284*D1**2*K*fd**2*s + 70*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1**2*bdd1*(30*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + 7*f*(6*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - K*(37*r**2 + 50*r*s - 86*r + 13*s**2 - 62*s + 37) + 61*r**2 + 98*r*s - 134*r + 37*s**2 - 110*s + 61) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 585*D1**2*f**2*fd*r*s + 90*D1**2*f**2*fd*r - 585*D1**2*f**2*fd*s**2 + 480*D1**2*f**2*fd*s - 105*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 855*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 630*D1**2*f**2*fdd*s**2 - 600*D1**2*f**2*fdd*s + 180*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 1710*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1260*D1**2*f*fd**2*s**2 - 1200*D1**2*f*fd**2*s + 180*D1**2*f*fd**2 - 1068*D1**2*f*fd*r**2 - 2082*D1**2*f*fd*r*s + 1317*D1**2*f*fd*r - 1014*D1**2*f*fd*s**2 + 1290*D1**2*f*fd*s - 795*D1**2*f*fd + 954*D1**2*f*fdd*r**2 + 1776*D1**2*f*fdd*r*s - 900*D1**2*f*fdd*r + 822*D1**2*f*fdd*s**2 - 834*D1**2*f*fdd*s + 513*D1**2*f*fdd - 483*D1**2*f*gd2*r**2 - 770*D1**2*f*gd2*r*s + 966*D1**2*f*gd2*r - 287*D1**2*f*gd2*s**2 + 770*D1**2*f*gd2*s - 483*D1**2*f*gd2 + 259*D1**2*f*gdd2*r**2 + 350*D1**2*f*gdd2*r*s - 518*D1**2*f*gdd2*r + 91*D1**2*f*gdd2*s**2 - 350*D1**2*f*gdd2*s + 259*D1**2*f*gdd2 + 954*D1**2*fd**2*r**2 + 1776*D1**2*fd**2*r*s - 900*D1**2*fd**2*r + 822*D1**2*fd**2*s**2 - 834*D1**2*fd**2*s - 180*D1**2*fd**2 - 483*D1**2*fd*g2*r**2 - 770*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*r - 287*D1**2*fd*g2*s**2 + 28*D1**2*fd*g2*s - 14*D1**2*fd*g2 + 518*D1**2*fd*gd2*r**2 + 700*D1**2*fd*gd2*r*s - 182*D1**2*fd*gd2*r + 182*D1**2*fd*gd2*s**2 - 14*D1**2*fd*gd2*s - 336*D1**2*fd*gd2 + 259*D1**2*fdd*g2*r**2 + 350*D1**2*fdd*g2*r*s + 336*D1**2*fdd*g2*r + 91*D1**2*fdd*g2*s**2 + 336*D1**2*fdd*g2*s - 168*D1**2*fdd*g2 + 852*D1*Dd*K*f**2*r**2 + 3552*D1*Dd*K*f**2*r*s - 1740*D1*Dd*K*f**2*r + 2700*D1*Dd*K*f**2*s**2 - 3126*D1*Dd*K*f**2*s + 1101*D1*Dd*K*f**2 - 6240*D1*Dd*K*f*fd*r**2 - 16512*D1*Dd*K*f*fd*r*s + 9312*D1*Dd*K*f*fd*r - 10272*D1*Dd*K*f*fd*s**2 + 11832*D1*Dd*K*f*fd*s - 3348*D1*Dd*K*f*fd - 780*D1*Dd*f**3*r*s + 195*D1*Dd*f**3*r - 780*D1*Dd*f**3*s**2 + 780*D1*Dd*f**3*s - 195*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 6840*D1*Dd*f**2*fd*r*s - 3075*D1*Dd*f**2*fd*r + 5040*D1*Dd*f**2*fd*s**2 - 5370*D1*Dd*f**2*fd*s + 1260*D1*Dd*f**2*fd - 2136*D1*Dd*f**2*r**2 - 4164*D1*Dd*f**2*r*s + 3177*D1*Dd*f**2*r - 2028*D1*Dd*f**2*s**2 + 3096*D1*Dd*f**2*s - 1575*D1*Dd*f**2 + 7632*D1*Dd*f*fd*r**2 + 14208*D1*Dd*f*fd*r*s - 9192*D1*Dd*f*fd*r + 6576*D1*Dd*f*fd*s**2 - 8532*D1*Dd*f*fd*s + 2634*D1*Dd*f*fd - 1932*D1*Dd*f*g2*r**2 - 3080*D1*Dd*f*g2*r*s + 2702*D1*Dd*f*g2*r - 1148*D1*Dd*f*g2*s**2 + 2114*D1*Dd*f*g2*s - 1253*D1*Dd*f*g2 + 2072*D1*Dd*f*gd2*r**2 + 2800*D1*Dd*f*gd2*r*s - 3458*D1*Dd*f*gd2*r + 728*D1*Dd*f*gd2*s**2 - 2282*D1*Dd*f*gd2*s + 1386*D1*Dd*f*gd2 + 2072*D1*Dd*fd*g2*r**2 + 2800*D1*Dd*fd*g2*r*s - 42*D1*Dd*fd*g2*r + 728*D1*Dd*fd*g2*s**2 + 462*D1*Dd*fd*g2*s - 1008*D1*Dd*fd*g2 - 1560*D1*Ddd*K*f**2*r**2 - 4128*D1*Ddd*K*f**2*r*s + 2592*D1*Ddd*K*f**2*r - 2568*D1*Ddd*K*f**2*s**2 + 3348*D1*Ddd*K*f**2*s - 1422*D1*Ddd*K*f**2 + 300*D1*Ddd*f**3*r**2 + 1140*D1*Ddd*f**3*r*s - 585*D1*Ddd*f**3*r + 840*D1*Ddd*f**3*s**2 - 990*D1*Ddd*f**3*s + 360*D1*Ddd*f**3 + 1908*D1*Ddd*f**2*r**2 + 3552*D1*Ddd*f**2*r*s - 2796*D1*Ddd*f**2*r + 1644*D1*Ddd*f**2*s**2 - 2598*D1*Ddd*f**2*s + 1365*D1*Ddd*f**2 + 1036*D1*Ddd*f*g2*r**2 + 1400*D1*Ddd*f*g2*r*s - 1386*D1*Ddd*f*g2*r + 364*D1*Ddd*f*g2*s**2 - 882*D1*Ddd*f*g2*s + 609*D1*Ddd*f*g2 + D1*bd1*(D1*(-6*f**2*(20*r**2 + r*(40*s - 46) + 20*s**2 - 46*s + 23) + f*(-84*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(69*r**2 + 2*r*(55*s - 61) + 41*s**2 - 94*s + 54) + 120*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 539*r**2 - 882*r*s + 1106*r - 343*s**2 + 910*s - 504) + 14*fd*(6*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-37*r**2 - 50*r*s + 19*r - 13*s**2 + 7*s + 12) + 61*r**2 + 98*r*s - 43*r + 37*s**2 - 31*s - 12) + 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(30*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + 7*f*(6*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(148*r**2 + 200*r*s - 271*r + 52*s**2 - 187*s + 117) + 244*r**2 + 392*r*s - 439*r + 148*s**2 - 355*s + 189) - 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 4680*Dd**2*K*f**2*r**2 - 12384*Dd**2*K*f**2*r*s + 7776*Dd**2*K*f**2*r - 7704*Dd**2*K*f**2*s**2 + 10044*Dd**2*K*f**2*s - 2844*Dd**2*K*f**2 + 900*Dd**2*f**3*r**2 + 3420*Dd**2*f**3*r*s - 1755*Dd**2*f**3*r + 2520*Dd**2*f**3*s**2 - 2970*Dd**2*f**3*s + 720*Dd**2*f**3 + 5724*Dd**2*f**2*r**2 + 10656*Dd**2*f**2*r*s - 8388*Dd**2*f**2*r + 4932*Dd**2*f**2*s**2 - 7794*Dd**2*f**2*s + 2730*Dd**2*f**2 + 3108*Dd**2*f*g2*r**2 + 4200*Dd**2*f*g2*r*s - 4158*Dd**2*f*g2*r + 1092*Dd**2*f*g2*s**2 - 2646*Dd**2*f*g2*s + 1218*Dd**2*f*g2))/(105*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**4*k1**2*st**4*(D1**2*(70*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 3*f**2*(140*fd**2*s*(2*s - 1) - fd*(44*C - 44)*(3*s**2 - 2*s + 1) + fdd*(22*C - 22)*(3*s**2 - 2*s + 1) + s**2*(33*K*bdd1 - 66*bd1*(K - 1) - 33*bdd1 + 132*gd2 - 66*gdd2)) - 66*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 3*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 3*fdd*g2*(2*s**2 - 2*s + 1)) + 396*fd**2*g2*s*(s - 1)) + 2*D1*f*(Dd*(70*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(33*C*(4*s**2 - 2*s + 1) - 35*fd*(1 - 4*s)**2 - 132*s**2 + 66*s - 33) - 33*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 6*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(3*K*bd1 - 3*bd1 - 6*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(35*f**2 + f*(33*C - 33) - 99*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(2*s - 1)*(35*f**2 + f*(33*C - 33) - 99*g2) + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k3**4) - 4*D1**2*Pk2*Pk3*ct**4*k1**2*st**2*(D1**2*(504*bd1*fd*g2*s*(s - 1) + f**3*s**2*(450*bd1 - 225*bdd1) - 2*f**2*(25*fd*(s**2*(27*bd1 - 12) + s*(8 - 9*bd1) - 4) + 50*fdd*(3*s**2 - 2*s + 1) + s**2*(3*C + 2)*(-36*bd1 + 18*bdd1)) - 4*f*s*(63*bd1**2*s*(K - 1) + 18*bd1*(fd*(3*C + 2)*(2*s - 1) + s*(7*g2 - 7*gd2)) - 63*bdd1*g2*s + 50*fd**2*(3*s - 2))) - 2*D1*f*(Dd*(252*bd1*g2*s*(1 - 4*s) + 25*f**2*(s**2*(36*bd1 - 16) + s*(8 - 9*bd1) - 4) + 4*f*(4*s - 1)*(9*bd1*s*(3*C + 2) + 25*fd*(3*s - 1))) + 50*Ddd*f**2*(4*s**2 - 2*s + 1)) + 600*Dd**2*f**3*s*(1 - 2*s) + 126*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 9*b1*(D1**2*(25*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) - 2*f*(25*fd**2*s*(3*s - 2) - fd*(12*C + 8)*(2*s**2 - 2*s + 1) + fdd*(6*C + 4)*(2*s**2 - 2*s + 1) + s**2*(14*K*bdd1 - 28*bd1*(K - 1) - 14*bdd1 + 28*gd2 - 14*gdd2)) - (4*s - 4)*(fd**2*s*(6*C + 4) + 14*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(25*f**3*(4*s**2 - 2*s + 1) + f**2*(12*C*(4*s**2 - 2*s + 1) - 25*fd*(12*s**2 - 7*s + 1) + 32*s**2 - 16*s + 8) - 4*f*(fd*(3*C + 2)*(8*s**2 - 6*s + 1) + 7*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(7*K*bd1 - 7*bd1 - 7*gd2)) + 28*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(25*f**2 + f*(12*C + 8) - 28*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(25*f**2 + f*(12*C + 8) - 28*g2)))/(105*d**2*k2**2*k3**2) - 2*D1**2*Pk2*Pk3*ct**4*k1**2*(990*C*D1**2*bdd1*f**2*s**2 - 840*C*D1**2*f**2*fd*s**2 + 560*C*D1**2*f**2*fd*s - 280*C*D1**2*f**2*fd + 420*C*D1**2*f**2*fdd*s**2 - 280*C*D1**2*f**2*fdd*s + 140*C*D1**2*f**2*fdd + 840*C*D1**2*f*fd**2*s**2 - 560*C*D1**2*f*fd**2*s - 1120*C*D1*Dd*f**3*s**2 + 560*C*D1*Dd*f**3*s - 280*C*D1*Dd*f**3 + 3360*C*D1*Dd*f**2*fd*s**2 - 1960*C*D1*Dd*f**2*fd*s + 280*C*D1*Dd*f**2*fd + 560*C*D1*Ddd*f**3*s**2 - 280*C*D1*Ddd*f**3*s + 140*C*D1*Ddd*f**3 + 1680*C*Dd**2*f**3*s**2 - 840*C*Dd**2*f**3*s + 90*D1**2*K*bdd1*f**2*s**2 - 360*D1**2*b2*f*fd*s**2 + 360*D1**2*b2*f*fd*s - 180*D1**2*b2*f*fd + 180*D1**2*b2*f*fdd*s**2 - 180*D1**2*b2*f*fdd*s + 90*D1**2*b2*f*fdd + 180*D1**2*b2*fd**2*s**2 - 180*D1**2*b2*fd**2*s - 6*D1**2*bd1**2*s*(84*C*f*(s - 1) + 30*f**2*(2*s - 3) - 259*f*s*(K - 1) - 140*g2*(s - 1)) - 180*D1**2*bd2*f**2*s**2 + 360*D1**2*bd2*f*fd*s**2 - 180*D1**2*bd2*f*fd*s + 540*D1**2*bdd1*f**3*r*s + 1215*D1**2*bdd1*f**3*s**2 - 270*D1**2*bdd1*f**3*s + 342*D1**2*bdd1*f**2*r*s - 108*D1**2*bdd1*f**2*s**2 + 18*D1**2*bdd1*f**2*s - 180*D1**2*bdd1*f**2 - 1554*D1**2*bdd1*f*g2*s**2 + 90*D1**2*bdd2*f**2*s**2 - 1200*D1**2*f**2*fd*r*s + 400*D1**2*f**2*fd*r - 2850*D1**2*f**2*fd*s**2 + 2300*D1**2*f**2*fd*s - 950*D1**2*f**2*fd + 870*D1**2*f**2*fdd*r*s - 290*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 1690*D1**2*f**2*fdd*s + 700*D1**2*f**2*fdd + 360*D1**2*f**2*gd2*s**2 - 180*D1**2*f**2*gdd2*s**2 + 1740*D1**2*f*fd**2*r*s - 580*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 3380*D1**2*f*fd**2*s + 290*D1**2*f*fd**2 + 720*D1**2*f*fd*g2*s**2 - 720*D1**2*f*fd*g2*s + 360*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 360*D1**2*f*fdd*g2*s**2 + 360*D1**2*f*fdd*g2*s - 180*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*s**2 + 360*D1**2*fd**2*g2*s - 720*D1*Dd*b2*f**2*s**2 + 360*D1*Dd*b2*f**2*s - 180*D1*Dd*b2*f**2 + 1440*D1*Dd*b2*f*fd*s**2 - 1080*D1*Dd*b2*f*fd*s + 180*D1*Dd*b2*f*fd + 720*D1*Dd*bd2*f**2*s**2 - 180*D1*Dd*bd2*f**2*s - 1600*D1*Dd*f**3*r*s + 400*D1*Dd*f**3*r - 3800*D1*Dd*f**3*s**2 + 2700*D1*Dd*f**3*s - 950*D1*Dd*f**3 + 6960*D1*Dd*f**2*fd*r*s - 2030*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 12700*D1*Dd*f**2*fd*s + 2270*D1*Dd*f**2*fd + 1440*D1*Dd*f**2*g2*s**2 - 720*D1*Dd*f**2*g2*s + 360*D1*Dd*f**2*g2 - 1440*D1*Dd*f**2*gd2*s**2 + 360*D1*Dd*f**2*gd2*s - 2880*D1*Dd*f*fd*g2*s**2 + 2160*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 + 360*D1*Ddd*b2*f**2*s**2 - 180*D1*Ddd*b2*f**2*s + 90*D1*Ddd*b2*f**2 + 1160*D1*Ddd*f**3*r*s - 290*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 1980*D1*Ddd*f**3*s + 700*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 180*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(45*f**3*s*(4*r + 13*s - 2) - 6*f**2*(15*fd*(2*r*(6*s - 1) + 27*s**2 - 15*s + 1) + s**2*(-75*C - 10*K + 12) - s*(24*r + 16) + 20) - 2*f*(3*fd*(19*r*(4*s - 1) + s**2*(220*C + 20*K - 24) - s*(110*C + 10*K + 6) + 19) + s**2*(343*g2 - 518*gd2)) + 1036*fd*g2*s*(s - 1)) - 2*Dd*f*(45*f**2*(2*r*(8*s - 1) + 36*s**2 - 17*s + 1) + 3*f*(19*r*(8*s - 1) + s**2*(440*C + 40*K - 48) - s*(110*C + 10*K + 22) - 1) + 518*g2*s*(1 - 4*s))) + 1080*Dd**2*b2*f**2*s**2 - 540*Dd**2*b2*f**2*s + 3480*Dd**2*f**3*r*s - 870*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 5940*Dd**2*f**3*s + 580*Dd**2*f**3 - 2160*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s + 210*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 3*b1**2*(168*C*D1**2*fd*s**2 - 84*C*D1**2*fdd*s**2 + 672*C*D1*Dd*f*s**2 - 336*C*D1*Dd*f*s + 168*C*D1*Dd*f - 672*C*D1*Dd*fd*s**2 + 168*C*D1*Dd*fd*s - 336*C*D1*Ddd*f*s**2 + 168*C*D1*Ddd*f*s - 84*C*D1*Ddd*f - 1008*C*Dd**2*f*s**2 + 504*C*Dd**2*f*s - 343*D1**2*K*fd*s**2 + 686*D1**2*K*fd*s - 343*D1**2*K*fd + 259*D1**2*K*fdd*s**2 - 518*D1**2*K*fdd*s + 259*D1**2*K*fdd - 70*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) + 240*D1**2*f*fd*s**2 + 120*D1**2*f*fd*s - 60*D1**2*f*fd - 120*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s + 30*D1**2*f*fdd - 120*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s + 343*D1**2*fd*s**2 - 686*D1**2*fd*s + 343*D1**2*fd - 259*D1**2*fdd*s**2 + 518*D1**2*fdd*s - 259*D1**2*fdd - 280*D1**2*gd2*s**2 + 140*D1**2*gdd2*s**2 - 1372*D1*Dd*K*f*s**2 + 686*D1*Dd*K*f*s - 343*D1*Dd*K*f + 2072*D1*Dd*K*fd*s**2 - 2590*D1*Dd*K*fd*s + 518*D1*Dd*K*fd + 480*D1*Dd*f**2*s**2 - 240*D1*Dd*f**2*s + 120*D1*Dd*f**2 - 960*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd + 1372*D1*Dd*f*s**2 - 686*D1*Dd*f*s + 343*D1*Dd*f - 2072*D1*Dd*fd*s**2 + 2590*D1*Dd*fd*s - 518*D1*Dd*fd - 1120*D1*Dd*g2*s**2 + 560*D1*Dd*g2*s - 280*D1*Dd*g2 + 1120*D1*Dd*gd2*s**2 - 280*D1*Dd*gd2*s + 1036*D1*Ddd*K*f*s**2 - 518*D1*Ddd*K*f*s + 259*D1*Ddd*K*f - 240*D1*Ddd*f**2*s**2 + 120*D1*Ddd*f**2*s - 60*D1*Ddd*f**2 - 1036*D1*Ddd*f*s**2 + 518*D1*Ddd*f*s - 259*D1*Ddd*f + 560*D1*Ddd*g2*s**2 - 280*D1*Ddd*g2*s + 140*D1*Ddd*g2 + 140*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) + 3108*Dd**2*K*f*s**2 - 1554*Dd**2*K*f*s - 720*Dd**2*f**2*s**2 + 360*Dd**2*f**2*s - 3108*Dd**2*f*s**2 + 1554*Dd**2*f*s + 1680*Dd**2*g2*s**2 - 840*Dd**2*g2*s) - 3*b1*(168*C*D1**2*bdd1*f*s**2 - 168*C*D1**2*bdd1*f*s + 84*C*D1**2*bdd1*f + 900*C*D1**2*f*fd*s**2 - 900*C*D1**2*f*fd*s + 450*C*D1**2*f*fd - 660*C*D1**2*f*fdd*s**2 + 660*C*D1**2*f*fdd*s - 330*C*D1**2*f*fdd - 660*C*D1**2*fd**2*s**2 + 660*C*D1**2*fd**2*s + 1800*C*D1*Dd*f**2*s**2 - 900*C*D1*Dd*f**2*s + 450*C*D1*Dd*f**2 - 5280*C*D1*Dd*f*fd*s**2 + 3960*C*D1*Dd*f*fd*s - 660*C*D1*Dd*f*fd - 1320*C*D1*Ddd*f**2*s**2 + 660*C*D1*Ddd*f**2*s - 330*C*D1*Ddd*f**2 - 3960*C*Dd**2*f**2*s**2 + 1980*C*Dd**2*f**2*s - 518*D1**2*K*bdd1*f*s**2 + 120*D1**2*K*f*fd*s**2 - 120*D1**2*K*f*fd*s + 60*D1**2*K*f*fd - 60*D1**2*K*f*fdd*s**2 + 60*D1**2*K*f*fdd*s - 30*D1**2*K*f*fdd - 60*D1**2*K*fd**2*s**2 + 60*D1**2*K*fd**2*s + 140*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + 120*D1**2*bdd1*f**2*s**2 - 180*D1**2*bdd1*f**2*s + 90*D1**2*bdd1*f**2 + 518*D1**2*bdd1*f*s**2 - 280*D1**2*bdd1*g2*s**2 + 280*D1**2*bdd1*g2*s - 140*D1**2*bdd1*g2 + 540*D1**2*f**2*fd*r*s - 180*D1**2*f**2*fd*r + 1755*D1**2*f**2*fd*s**2 - 1440*D1**2*f**2*fd*s + 585*D1**2*f**2*fd - 540*D1**2*f**2*fdd*r*s + 180*D1**2*f**2*fdd*r - 1215*D1**2*f**2*fdd*s**2 + 1080*D1**2*f**2*fdd*s - 405*D1**2*f**2*fdd - 1080*D1**2*f*fd**2*r*s + 360*D1**2*f*fd**2*r - 2430*D1**2*f*fd**2*s**2 + 2160*D1**2*f*fd**2*s - 270*D1**2*f*fd**2 + 288*D1**2*f*fd*r*s - 144*D1**2*f*fd*r - 144*D1**2*f*fd*s**2 - 96*D1**2*f*fd*s + 48*D1**2*f*fd - 228*D1**2*f*fdd*r*s + 114*D1**2*f*fdd*r + 72*D1**2*f*fdd*s**2 + 48*D1**2*f*fdd*s - 24*D1**2*f*fdd - 686*D1**2*f*gd2*s**2 + 518*D1**2*f*gdd2*s**2 - 228*D1**2*fd**2*r*s + 114*D1**2*fd**2*r + 72*D1**2*fd**2*s**2 + 48*D1**2*fd**2*s - 686*D1**2*fd*g2*s**2 + 1372*D1**2*fd*g2*s - 686*D1**2*fd*g2 + 1036*D1**2*fd*gd2*s**2 - 1036*D1**2*fd*gd2*s + 518*D1**2*fdd*g2*s**2 - 1036*D1**2*fdd*g2*s + 518*D1**2*fdd*g2 + 240*D1*Dd*K*f**2*s**2 - 120*D1*Dd*K*f**2*s + 60*D1*Dd*K*f**2 - 480*D1*Dd*K*f*fd*s**2 + 360*D1*Dd*K*f*fd*s - 60*D1*Dd*K*f*fd + 720*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r + 2340*D1*Dd*f**3*s**2 - 1530*D1*Dd*f**3*s + 585*D1*Dd*f**3 - 4320*D1*Dd*f**2*fd*r*s + 1260*D1*Dd*f**2*fd*r - 9720*D1*Dd*f**2*fd*s**2 + 7830*D1*Dd*f**2*fd*s - 1440*D1*Dd*f**2*fd + 576*D1*Dd*f**2*r*s - 144*D1*Dd*f**2*r - 288*D1*Dd*f**2*s**2 - 144*D1*Dd*f**2*s - 72*D1*Dd*f**2 - 1824*D1*Dd*f*fd*r*s + 684*D1*Dd*f*fd*r + 576*D1*Dd*f*fd*s**2 + 504*D1*Dd*f*fd*s - 276*D1*Dd*f*fd - 2744*D1*Dd*f*g2*s**2 + 1372*D1*Dd*f*g2*s - 686*D1*Dd*f*g2 + 4144*D1*Dd*f*gd2*s**2 - 1036*D1*Dd*f*gd2*s + 4144*D1*Dd*fd*g2*s**2 - 5180*D1*Dd*fd*g2*s + 1036*D1*Dd*fd*g2 - 120*D1*Ddd*K*f**2*s**2 + 60*D1*Ddd*K*f**2*s - 30*D1*Ddd*K*f**2 - 720*D1*Ddd*f**3*r*s + 180*D1*Ddd*f**3*r - 1620*D1*Ddd*f**3*s**2 + 1170*D1*Ddd*f**3*s - 405*D1*Ddd*f**3 - 456*D1*Ddd*f**2*r*s + 114*D1*Ddd*f**2*r + 144*D1*Ddd*f**2*s**2 + 156*D1*Ddd*f**2*s + 36*D1*Ddd*f**2 + 2072*D1*Ddd*f*g2*s**2 - 1036*D1*Ddd*f*g2*s + 518*D1*Ddd*f*g2 - 2*D1*bd1*(84*C*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + D1*(30*f**2*(4*s**2 - 6*s + 3) + f*s*(-120*fd*(2*s - 1) + s*(343 - 343*K)) + 518*fd*s*(K - 1)*(s - 1) - 140*g2*(2*s**2 - 2*s + 1) + 140*gd2*s*(2*s - 1)) - 2*Dd*(4*s - 1)*(15*f**2*(4*s - 3) - 259*f*s*(K - 1) + 70*g2*(1 - 2*s))) - 360*Dd**2*K*f**2*s**2 + 180*Dd**2*K*f**2*s - 2160*Dd**2*f**3*r*s + 540*Dd**2*f**3*r - 4860*Dd**2*f**3*s**2 + 3510*Dd**2*f**3*s - 360*Dd**2*f**3 - 1368*Dd**2*f**2*r*s + 342*Dd**2*f**2*r + 432*Dd**2*f**2*s**2 + 468*Dd**2*f**2*s - 228*Dd**2*f**2 + 6216*Dd**2*f*g2*s**2 - 3108*Dd**2*f*g2*s))/(315*d**2*k2**2*k3**2) - 4*D1**2*Pk2*Pk3*ct**4*k2**6*st**2*(D1**2*(f**2*(fd*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-9*K*(-2*bd1 + bdd1) - 36*gd2 + 18*gdd2)) + f*(-fd**2*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 18*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 18*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(10*C - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(5 - 10*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 18*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 18*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 9*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(10*C*f + 9*K*b1 - 5*f - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(10*C*f + 9*K*b1 - 5*f - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(7*d**2*k3**8) - 12*D1**2*Pk2*Pk3*ct**4*k2**6*(40*C*D1**2*b1*f*fd*r**2 + 80*C*D1**2*b1*f*fd*r*s - 40*C*D1**2*b1*f*fd*r + 40*C*D1**2*b1*f*fd*s**2 - 40*C*D1**2*b1*f*fd*s + 20*C*D1**2*b1*f*fd - 20*C*D1**2*b1*f*fdd*r**2 - 40*C*D1**2*b1*f*fdd*r*s + 20*C*D1**2*b1*f*fdd*r - 20*C*D1**2*b1*f*fdd*s**2 + 20*C*D1**2*b1*f*fdd*s - 10*C*D1**2*b1*f*fdd - 20*C*D1**2*b1*fd**2*r**2 - 40*C*D1**2*b1*fd**2*r*s + 20*C*D1**2*b1*fd**2*r - 20*C*D1**2*b1*fd**2*s**2 + 20*C*D1**2*b1*fd**2*s - 30*C*D1**2*f**2*fd*r**2 - 60*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 80*C*D1*Dd*b1*f**2*r**2 + 160*C*D1*Dd*b1*f**2*r*s - 120*C*D1*Dd*b1*f**2*r + 80*C*D1*Dd*b1*f**2*s**2 - 120*C*D1*Dd*b1*f**2*s + 60*C*D1*Dd*b1*f**2 - 160*C*D1*Dd*b1*f*fd*r**2 - 320*C*D1*Dd*b1*f*fd*r*s + 200*C*D1*Dd*b1*f*fd*r - 160*C*D1*Dd*b1*f*fd*s**2 + 200*C*D1*Dd*b1*f*fd*s - 60*C*D1*Dd*b1*f*fd - 40*C*D1*Dd*f**3*r**2 - 80*C*D1*Dd*f**3*r*s + 60*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 60*C*D1*Dd*f**3*s - 30*C*D1*Dd*f**3 - 40*C*D1*Ddd*b1*f**2*r**2 - 80*C*D1*Ddd*b1*f**2*r*s + 60*C*D1*Ddd*b1*f**2*r - 40*C*D1*Ddd*b1*f**2*s**2 + 60*C*D1*Ddd*b1*f**2*s - 30*C*D1*Ddd*b1*f**2 - 120*C*Dd**2*b1*f**2*r**2 - 240*C*Dd**2*b1*f**2*r*s + 180*C*Dd**2*b1*f**2*r - 120*C*Dd**2*b1*f**2*s**2 + 180*C*Dd**2*b1*f**2*s - 60*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r**2 + 28*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r**2 - 14*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 14*D1**2*K*bd1**2*f*(r + s - 1)**2 - 20*D1**2*b1*f*fd*r**2 - 40*D1**2*b1*f*fd*r*s + 20*D1**2*b1*f*fd*r - 20*D1**2*b1*f*fd*s**2 + 20*D1**2*b1*f*fd*s - 10*D1**2*b1*f*fd + 10*D1**2*b1*f*fdd*r**2 + 20*D1**2*b1*f*fdd*r*s - 10*D1**2*b1*f*fdd*r + 10*D1**2*b1*f*fdd*s**2 - 10*D1**2*b1*f*fdd*s + 5*D1**2*b1*f*fdd - 28*D1**2*b1*f*gd2*r**2 - 56*D1**2*b1*f*gd2*r*s + 56*D1**2*b1*f*gd2*r - 28*D1**2*b1*f*gd2*s**2 + 56*D1**2*b1*f*gd2*s - 28*D1**2*b1*f*gd2 + 14*D1**2*b1*f*gdd2*r**2 + 28*D1**2*b1*f*gdd2*r*s - 28*D1**2*b1*f*gdd2*r + 14*D1**2*b1*f*gdd2*s**2 - 28*D1**2*b1*f*gdd2*s + 14*D1**2*b1*f*gdd2 + 10*D1**2*b1*fd**2*r**2 + 20*D1**2*b1*fd**2*r*s - 10*D1**2*b1*fd**2*r + 10*D1**2*b1*fd**2*s**2 - 10*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r**2 - 56*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r**2 + 56*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*r + 28*D1**2*b1*fd*gd2*s**2 - 28*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r**2 + 28*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 14*K*b1 - 5*f - 14*g2) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r**2 + 112*D1*Dd*K*b1**2*f*r*s - 84*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 84*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r**2 - 112*D1*Dd*K*b1**2*fd*r*s + 42*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 42*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 - 40*D1*Dd*b1*f**2*r**2 - 80*D1*Dd*b1*f**2*r*s + 60*D1*Dd*b1*f**2*r - 40*D1*Dd*b1*f**2*s**2 + 60*D1*Dd*b1*f**2*s - 30*D1*Dd*b1*f**2 + 80*D1*Dd*b1*f*fd*r**2 + 160*D1*Dd*b1*f*fd*r*s - 100*D1*Dd*b1*f*fd*r + 80*D1*Dd*b1*f*fd*s**2 - 100*D1*Dd*b1*f*fd*s + 30*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r**2 - 224*D1*Dd*b1*f*g2*r*s + 168*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 168*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r**2 + 224*D1*Dd*b1*f*gd2*r*s - 196*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 196*D1*Dd*b1*f*gd2*s + 84*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r**2 + 224*D1*Dd*b1*fd*g2*r*s - 84*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 84*D1*Dd*b1*fd*g2*s + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r**2 - 56*D1*Ddd*K*b1**2*f*r*s + 42*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 42*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 20*D1*Ddd*b1*f**2*r**2 + 40*D1*Ddd*b1*f**2*r*s - 30*D1*Ddd*b1*f**2*r + 20*D1*Ddd*b1*f**2*s**2 - 30*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r**2 + 112*D1*Ddd*b1*f*g2*r*s - 84*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 84*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(20*C - 7*K - 10)*(r + s - 1) - f*fd*(20*C - 10)*(2*r + 2*s - 1) - 28*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(10*C*f + 14*K*b1 - 5*f - 14*g2))*(r + s - 1) - 84*Dd**2*K*b1**2*f*r**2 - 168*Dd**2*K*b1**2*f*r*s + 126*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 126*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 60*Dd**2*b1*f**2*r**2 + 120*Dd**2*b1*f**2*r*s - 90*Dd**2*b1*f**2*r + 60*Dd**2*b1*f**2*s**2 - 90*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r**2 + 336*Dd**2*b1*f*g2*r*s - 252*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 252*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(35*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**4*k2**4*st**2*(3756*C*D1**2*f**2*fd*r**2 + 4656*C*D1**2*f**2*fd*r*s - 4056*C*D1**2*f**2*fd*r + 900*C*D1**2*f**2*fd*s**2 - 2152*C*D1**2*f**2*fd*s + 1552*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r**2 - 2760*C*D1**2*f**2*fdd*r*s + 2460*C*D1**2*f**2*fdd*r - 450*C*D1**2*f**2*fdd*s**2 + 1220*C*D1**2*f**2*fdd*s - 920*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r**2 - 5520*C*D1**2*f*fd**2*r*s + 4920*C*D1**2*f*fd**2*r - 900*C*D1**2*f*fd**2*s**2 + 2440*C*D1**2*f*fd**2*s - 920*C*D1**2*f*fd**2 + 5008*C*D1*Dd*f**3*r**2 + 6208*C*D1*Dd*f**3*r*s - 6560*C*D1*Dd*f**3*r + 1200*C*D1*Dd*f**3*s**2 - 3704*C*D1*Dd*f**3*s + 2804*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r**2 - 22080*C*D1*Dd*f**2*fd*r*s + 21840*C*D1*Dd*f**2*fd*r - 3600*C*D1*Dd*f**2*fd*s**2 + 11300*C*D1*Dd*f**2*fd*s - 6140*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r**2 - 3680*C*D1*Ddd*f**3*r*s + 4000*C*D1*Ddd*f**3*r - 600*C*D1*Ddd*f**3*s**2 + 2140*C*D1*Ddd*f**3*s - 1690*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r**2 - 11040*C*Dd**2*f**3*r*s + 12000*C*Dd**2*f**3*r - 1800*C*Dd**2*f**3*s**2 + 6420*C*Dd**2*f**3*s - 3380*C*Dd**2*f**3 + 1620*D1**2*K*b1*f*fd*r**2 + 2160*D1**2*K*b1*f*fd*r*s - 1080*D1**2*K*b1*f*fd*r + 540*D1**2*K*b1*f*fd*s**2 - 540*D1**2*K*b1*f*fd*s + 270*D1**2*K*b1*f*fd - 810*D1**2*K*b1*f*fdd*r**2 - 1080*D1**2*K*b1*f*fdd*r*s + 540*D1**2*K*b1*f*fdd*r - 270*D1**2*K*b1*f*fdd*s**2 + 270*D1**2*K*b1*f*fdd*s - 135*D1**2*K*b1*f*fdd - 810*D1**2*K*b1*fd**2*r**2 - 1080*D1**2*K*b1*fd**2*r*s + 540*D1**2*K*b1*fd**2*r - 270*D1**2*K*b1*fd**2*s**2 + 270*D1**2*K*b1*fd**2*s - 405*D1**2*K*bdd1*f**2*r**2 - 540*D1**2*K*bdd1*f**2*r*s + 810*D1**2*K*bdd1*f**2*r - 135*D1**2*K*bdd1*f**2*s**2 + 540*D1**2*K*bdd1*f**2*s - 405*D1**2*K*bdd1*f**2 - 405*D1**2*b1*f**2*fd*r**2 - 405*D1**2*b1*f**2*fd*r*s + 405*D1**2*b1*f**2*fd*r + 135*D1**2*b1*f**2*fd*s - 135*D1**2*b1*f**2*fd + 405*D1**2*b1*f**2*fdd*r**2 + 405*D1**2*b1*f**2*fdd*r*s - 405*D1**2*b1*f**2*fdd*r - 135*D1**2*b1*f**2*fdd*s + 135*D1**2*b1*f**2*fdd + 810*D1**2*b1*f*fd**2*r**2 + 810*D1**2*b1*f*fd**2*r*s - 810*D1**2*b1*f*fd**2*r - 270*D1**2*b1*f*fd**2*s + 135*D1**2*b1*f*fd**2 - 540*D1**2*b1*f*fd*r**2 - 540*D1**2*b1*f*fd*r*s + 270*D1**2*b1*f*fd*r + 270*D1**2*b1*f*fdd*r**2 + 270*D1**2*b1*f*fdd*r*s - 135*D1**2*b1*f*fdd*r + 270*D1**2*b1*fd**2*r**2 + 270*D1**2*b1*fd**2*r*s - 135*D1**2*b1*fd**2*r + 540*D1**2*b2*f*fd*r**2 + 1080*D1**2*b2*f*fd*r*s - 540*D1**2*b2*f*fd*r + 540*D1**2*b2*f*fd*s**2 - 540*D1**2*b2*f*fd*s + 270*D1**2*b2*f*fd - 270*D1**2*b2*f*fdd*r**2 - 540*D1**2*b2*f*fdd*r*s + 270*D1**2*b2*f*fdd*r - 270*D1**2*b2*f*fdd*s**2 + 270*D1**2*b2*f*fdd*s - 135*D1**2*b2*f*fdd - 270*D1**2*b2*fd**2*r**2 - 540*D1**2*b2*fd**2*r*s + 270*D1**2*b2*fd**2*r - 270*D1**2*b2*fd**2*s**2 + 270*D1**2*b2*fd**2*s + 135*D1**2*bdd1*f**3*r**2 + 135*D1**2*bdd1*f**3*r*s - 270*D1**2*bdd1*f**3*r - 135*D1**2*bdd1*f**3*s + 135*D1**2*bdd1*f**3 + 135*D1**2*bdd1*f**2*r**2 + 135*D1**2*bdd1*f**2*r*s - 270*D1**2*bdd1*f**2*r - 135*D1**2*bdd1*f**2*s + 135*D1**2*bdd1*f**2 - 135*D1**2*bdd2*f**2*r**2 - 270*D1**2*bdd2*f**2*r*s + 270*D1**2*bdd2*f**2*r - 135*D1**2*bdd2*f**2*s**2 + 270*D1**2*bdd2*f**2*s - 135*D1**2*bdd2*f**2 - 2592*D1**2*f**2*fd*r**2 - 3042*D1**2*f**2*fd*r*s + 2742*D1**2*f**2*fd*r - 450*D1**2*f**2*fd*s**2 + 1314*D1**2*f**2*fd*s - 1014*D1**2*f**2*fd + 1620*D1**2*f**2*fdd*r**2 + 1845*D1**2*f**2*fdd*r*s - 1695*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 765*D1**2*f**2*fdd*s + 615*D1**2*f**2*fdd - 1620*D1**2*f**2*gd2*r**2 - 2160*D1**2*f**2*gd2*r*s + 3240*D1**2*f**2*gd2*r - 540*D1**2*f**2*gd2*s**2 + 2160*D1**2*f**2*gd2*s - 1620*D1**2*f**2*gd2 + 810*D1**2*f**2*gdd2*r**2 + 1080*D1**2*f**2*gdd2*r*s - 1620*D1**2*f**2*gdd2*r + 270*D1**2*f**2*gdd2*s**2 - 1080*D1**2*f**2*gdd2*s + 810*D1**2*f**2*gdd2 + 3240*D1**2*f*fd**2*r**2 + 3690*D1**2*f*fd**2*r*s - 3390*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 1530*D1**2*f*fd**2*s + 615*D1**2*f*fd**2 - 3240*D1**2*f*fd*g2*r**2 - 4320*D1**2*f*fd*g2*r*s + 2160*D1**2*f*fd*g2*r - 1080*D1**2*f*fd*g2*s**2 + 1080*D1**2*f*fd*g2*s - 540*D1**2*f*fd*g2 + 3240*D1**2*f*fd*gd2*r**2 + 4320*D1**2*f*fd*gd2*r*s - 4320*D1**2*f*fd*gd2*r + 1080*D1**2*f*fd*gd2*s**2 - 2700*D1**2*f*fd*gd2*s + 1080*D1**2*f*fd*gd2 + 1620*D1**2*f*fdd*g2*r**2 + 2160*D1**2*f*fdd*g2*r*s - 1080*D1**2*f*fdd*g2*r + 540*D1**2*f*fdd*g2*s**2 - 540*D1**2*f*fdd*g2*s + 270*D1**2*f*fdd*g2 + 1620*D1**2*fd**2*g2*r**2 + 2160*D1**2*fd**2*g2*r*s - 1080*D1**2*fd**2*g2*r + 540*D1**2*fd**2*g2*s**2 - 540*D1**2*fd**2*g2*s + 3240*D1*Dd*K*b1*f**2*r**2 + 4320*D1*Dd*K*b1*f**2*r*s - 4320*D1*Dd*K*b1*f**2*r + 1080*D1*Dd*K*b1*f**2*s**2 - 2700*D1*Dd*K*b1*f**2*s + 1890*D1*Dd*K*b1*f**2 - 6480*D1*Dd*K*b1*f*fd*r**2 - 8640*D1*Dd*K*b1*f*fd*r*s + 6480*D1*Dd*K*b1*f*fd*r - 2160*D1*Dd*K*b1*f*fd*s**2 + 3780*D1*Dd*K*b1*f*fd*s - 1350*D1*Dd*K*b1*f*fd - 540*D1*Dd*b1*f**3*r**2 - 540*D1*Dd*b1*f**3*r*s + 675*D1*Dd*b1*f**3*r + 270*D1*Dd*b1*f**3*s - 270*D1*Dd*b1*f**3 + 3240*D1*Dd*b1*f**2*fd*r**2 + 3240*D1*Dd*b1*f**2*fd*r*s - 3645*D1*Dd*b1*f**2*fd*r - 1350*D1*Dd*b1*f**2*fd*s + 945*D1*Dd*b1*f**2*fd - 1080*D1*Dd*b1*f**2*r**2 - 1080*D1*Dd*b1*f**2*r*s + 1350*D1*Dd*b1*f**2*r + 540*D1*Dd*b1*f**2*s - 540*D1*Dd*b1*f**2 + 2160*D1*Dd*b1*f*fd*r**2 + 2160*D1*Dd*b1*f*fd*r*s - 1890*D1*Dd*b1*f*fd*r - 540*D1*Dd*b1*f*fd*s + 270*D1*Dd*b1*f*fd + 1080*D1*Dd*b2*f**2*r**2 + 2160*D1*Dd*b2*f**2*r*s - 1620*D1*Dd*b2*f**2*r + 1080*D1*Dd*b2*f**2*s**2 - 1620*D1*Dd*b2*f**2*s + 810*D1*Dd*b2*f**2 - 2160*D1*Dd*b2*f*fd*r**2 - 4320*D1*Dd*b2*f*fd*r*s + 2700*D1*Dd*b2*f*fd*r - 2160*D1*Dd*b2*f*fd*s**2 + 2700*D1*Dd*b2*f*fd*s - 810*D1*Dd*b2*f*fd - 3456*D1*Dd*f**3*r**2 - 4056*D1*Dd*f**3*r*s + 4470*D1*Dd*f**3*r - 600*D1*Dd*f**3*s**2 + 2328*D1*Dd*f**3*s - 1878*D1*Dd*f**3 + 12960*D1*Dd*f**2*fd*r**2 + 14760*D1*Dd*f**2*fd*r*s - 15105*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 7200*D1*Dd*f**2*fd*s + 4155*D1*Dd*f**2*fd - 6480*D1*Dd*f**2*g2*r**2 - 8640*D1*Dd*f**2*g2*r*s + 8640*D1*Dd*f**2*g2*r - 2160*D1*Dd*f**2*g2*s**2 + 5400*D1*Dd*f**2*g2*s - 3780*D1*Dd*f**2*g2 + 6480*D1*Dd*f**2*gd2*r**2 + 8640*D1*Dd*f**2*gd2*r*s - 10800*D1*Dd*f**2*gd2*r + 2160*D1*Dd*f**2*gd2*s**2 - 7020*D1*Dd*f**2*gd2*s + 4320*D1*Dd*f**2*gd2 + 12960*D1*Dd*f*fd*g2*r**2 + 17280*D1*Dd*f*fd*g2*r*s - 12960*D1*Dd*f*fd*g2*r + 4320*D1*Dd*f*fd*g2*s**2 - 7560*D1*Dd*f*fd*g2*s + 2700*D1*Dd*f*fd*g2 - 1620*D1*Ddd*K*b1*f**2*r**2 - 2160*D1*Ddd*K*b1*f**2*r*s + 2160*D1*Ddd*K*b1*f**2*r - 540*D1*Ddd*K*b1*f**2*s**2 + 1350*D1*Ddd*K*b1*f**2*s - 945*D1*Ddd*K*b1*f**2 + 540*D1*Ddd*b1*f**3*r**2 + 540*D1*Ddd*b1*f**3*r*s - 675*D1*Ddd*b1*f**3*r - 270*D1*Ddd*b1*f**3*s + 270*D1*Ddd*b1*f**3 + 540*D1*Ddd*b1*f**2*r**2 + 540*D1*Ddd*b1*f**2*r*s - 675*D1*Ddd*b1*f**2*r - 270*D1*Ddd*b1*f**2*s + 270*D1*Ddd*b1*f**2 - 540*D1*Ddd*b2*f**2*r**2 - 1080*D1*Ddd*b2*f**2*r*s + 810*D1*Ddd*b2*f**2*r - 540*D1*Ddd*b2*f**2*s**2 + 810*D1*Ddd*b2*f**2*s - 405*D1*Ddd*b2*f**2 + 2160*D1*Ddd*f**3*r**2 + 2460*D1*Ddd*f**3*r*s - 2775*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 1380*D1*Ddd*f**3*s + 1155*D1*Ddd*f**3 + 3240*D1*Ddd*f**2*g2*r**2 + 4320*D1*Ddd*f**2*g2*r*s - 4320*D1*Ddd*f**2*g2*r + 1080*D1*Ddd*f**2*g2*s**2 - 2700*D1*Ddd*f**2*g2*s + 1890*D1*Ddd*f**2*g2 - 135*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (2*r + 2*s - 2)*(K*(3*r + s - 3) - r + 1)) + fd*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(2*K*(12*r**2 + 4*r*(4*s - 5) + 4*s**2 - 13*s + 8) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) + 270*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 4860*Dd**2*K*b1*f**2*r**2 - 6480*Dd**2*K*b1*f**2*r*s + 6480*Dd**2*K*b1*f**2*r - 1620*Dd**2*K*b1*f**2*s**2 + 4050*Dd**2*K*b1*f**2*s - 1890*Dd**2*K*b1*f**2 + 1620*Dd**2*b1*f**3*r**2 + 1620*Dd**2*b1*f**3*r*s - 2025*Dd**2*b1*f**3*r - 810*Dd**2*b1*f**3*s + 540*Dd**2*b1*f**3 + 1620*Dd**2*b1*f**2*r**2 + 1620*Dd**2*b1*f**2*r*s - 2025*Dd**2*b1*f**2*r - 810*Dd**2*b1*f**2*s + 540*Dd**2*b1*f**2 - 1620*Dd**2*b2*f**2*r**2 - 3240*Dd**2*b2*f**2*r*s + 2430*Dd**2*b2*f**2*r - 1620*Dd**2*b2*f**2*s**2 + 2430*Dd**2*b2*f**2*s - 810*Dd**2*b2*f**2 + 6480*Dd**2*f**3*r**2 + 7380*Dd**2*f**3*r*s - 8325*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 4140*Dd**2*f**3*s + 2310*Dd**2*f**3 + 9720*Dd**2*f**2*g2*r**2 + 12960*Dd**2*f**2*g2*r*s - 12960*Dd**2*f**2*g2*r + 3240*Dd**2*f**2*g2*s**2 - 8100*Dd**2*f**2*g2*s + 3780*Dd**2*f**2*g2)/(315*d**2*k3**6) - 2*D1**2*Pk2*Pk3*ct**4*k2**4*(-432*C*D1**2*bd1*f**2*r**2 - 672*C*D1**2*bd1*f**2*r*s + 912*C*D1**2*bd1*f**2*r - 240*C*D1**2*bd1*f**2*s**2 + 720*C*D1**2*bd1*f**2*s - 360*C*D1**2*bd1*f**2 + 864*C*D1**2*bd1*f*fd*r**2 + 1344*C*D1**2*bd1*f*fd*r*s - 1224*C*D1**2*bd1*f*fd*r + 480*C*D1**2*bd1*f*fd*s**2 - 936*C*D1**2*bd1*f*fd*s + 456*C*D1**2*bd1*f*fd + 216*C*D1**2*bdd1*f**2*r**2 + 336*C*D1**2*bdd1*f**2*r*s - 456*C*D1**2*bdd1*f**2*r + 120*C*D1**2*bdd1*f**2*s**2 - 360*C*D1**2*bdd1*f**2*s + 180*C*D1**2*bdd1*f**2 - 210*C*D1**2*f**2*fd*r**2 - 660*C*D1**2*f**2*fd*r*s + 360*C*D1**2*f**2*fd*r - 450*C*D1**2*f**2*fd*s**2 + 520*C*D1**2*f**2*fd*s - 220*C*D1**2*f**2*fd + 690*C*D1**2*f**2*fdd*r**2 + 1500*C*D1**2*f**2*fdd*r*s - 960*C*D1**2*f**2*fdd*r + 810*C*D1**2*f**2*fdd*s**2 - 1040*C*D1**2*f**2*fdd*s + 500*C*D1**2*f**2*fdd + 1380*C*D1**2*f*fd**2*r**2 + 3000*C*D1**2*f*fd**2*r*s - 1920*C*D1**2*f*fd**2*r + 1620*C*D1**2*f*fd**2*s**2 - 2080*C*D1**2*f*fd**2*s + 500*C*D1**2*f*fd**2 + 1728*C*D1*Dd*bd1*f**2*r**2 + 2688*C*D1*Dd*bd1*f**2*r*s - 3024*C*D1*Dd*bd1*f**2*r + 960*C*D1*Dd*bd1*f**2*s**2 - 2352*C*D1*Dd*bd1*f**2*s + 1272*C*D1*Dd*bd1*f**2 - 280*C*D1*Dd*f**3*r**2 - 880*C*D1*Dd*f**3*r*s + 500*C*D1*Dd*f**3*r - 600*C*D1*Dd*f**3*s**2 + 740*C*D1*Dd*f**3*s - 290*C*D1*Dd*f**3 + 5520*C*D1*Dd*f**2*fd*r**2 + 12000*C*D1*Dd*f**2*fd*r*s - 8100*C*D1*Dd*f**2*fd*r + 6480*C*D1*Dd*f**2*fd*s**2 - 8780*C*D1*Dd*f**2*fd*s + 2960*C*D1*Dd*f**2*fd + 920*C*D1*Ddd*f**3*r**2 + 2000*C*D1*Ddd*f**3*r*s - 1420*C*D1*Ddd*f**3*r + 1080*C*D1*Ddd*f**3*s**2 - 1540*C*D1*Ddd*f**3*s + 730*C*D1*Ddd*f**3 + 2760*C*Dd**2*f**3*r**2 + 6000*C*Dd**2*f**3*r*s - 4260*C*Dd**2*f**3*r + 3240*C*Dd**2*f**3*s**2 - 4620*C*Dd**2*f**3*s + 1460*C*Dd**2*f**3 + 168*D1**2*K*bd1**2*f*r**2 + 336*D1**2*K*bd1**2*f*r*s - 420*D1**2*K*bd1**2*f*r + 168*D1**2*K*bd1**2*f*s**2 - 420*D1**2*K*bd1**2*f*s + 252*D1**2*K*bd1**2*f + 63*D1**2*K*bd1*f**2*r**2 - 42*D1**2*K*bd1*f**2*r*s - 126*D1**2*K*bd1*f**2*r - 105*D1**2*K*bd1*f**2*s**2 + 42*D1**2*K*bd1*f**2*s + 63*D1**2*K*bd1*f**2 + 420*D1**2*K*bd1*f*fd*r**2 + 1176*D1**2*K*bd1*f*fd*r*s - 714*D1**2*K*bd1*f*fd*r + 756*D1**2*K*bd1*f*fd*s**2 - 966*D1**2*K*bd1*f*fd*s + 294*D1**2*K*bd1*f*fd + 105*D1**2*K*bdd1*f**2*r**2 + 294*D1**2*K*bdd1*f**2*r*s - 210*D1**2*K*bdd1*f**2*r + 189*D1**2*K*bdd1*f**2*s**2 - 294*D1**2*K*bdd1*f**2*s + 105*D1**2*K*bdd1*f**2 - 84*D1**2*bd1**2*f**2*r**2 - 84*D1**2*bd1**2*f**2*r*s + 126*D1**2*bd1**2*f**2*r + 42*D1**2*bd1**2*f**2*s - 42*D1**2*bd1**2*f**2 - 84*D1**2*bd1**2*f*r**2 - 84*D1**2*bd1**2*f*r*s + 126*D1**2*bd1**2*f*r + 42*D1**2*bd1**2*f*s - 42*D1**2*bd1**2*f + 84*D1**2*bd1*bd2*f*r**2 + 168*D1**2*bd1*bd2*f*r*s - 168*D1**2*bd1*bd2*f*r + 84*D1**2*bd1*bd2*f*s**2 - 168*D1**2*bd1*bd2*f*s + 84*D1**2*bd1*bd2*f + 282*D1**2*bd1*f**2*r**2 + 402*D1**2*bd1*f**2*r*s - 480*D1**2*bd1*f**2*r + 120*D1**2*bd1*f**2*s**2 - 318*D1**2*bd1*f**2*s + 138*D1**2*bd1*f**2 - 648*D1**2*bd1*f*fd*r**2 - 888*D1**2*bd1*f*fd*r*s + 828*D1**2*bd1*f*fd*r - 240*D1**2*bd1*f*fd*s**2 + 522*D1**2*bd1*f*fd*s - 282*D1**2*bd1*f*fd + 336*D1**2*bd1*f*g2*r**2 + 672*D1**2*bd1*f*g2*r*s - 1008*D1**2*bd1*f*g2*r + 336*D1**2*bd1*f*g2*s**2 - 1008*D1**2*bd1*f*g2*s + 504*D1**2*bd1*f*g2 - 336*D1**2*bd1*f*gd2*r**2 - 672*D1**2*bd1*f*gd2*r*s + 840*D1**2*bd1*f*gd2*r - 336*D1**2*bd1*f*gd2*s**2 + 840*D1**2*bd1*f*gd2*s - 504*D1**2*bd1*f*gd2 - 336*D1**2*bd1*fd*g2*r**2 - 672*D1**2*bd1*fd*g2*r*s + 336*D1**2*bd1*fd*g2*r - 336*D1**2*bd1*fd*g2*s**2 + 336*D1**2*bd1*fd*g2*s + 42*D1**2*bd2*f**2*r**2 + 84*D1**2*bd2*f**2*r*s - 84*D1**2*bd2*f**2*r + 42*D1**2*bd2*f**2*s**2 - 84*D1**2*bd2*f**2*s + 42*D1**2*bd2*f**2 - 162*D1**2*bdd1*f**2*r**2 - 222*D1**2*bdd1*f**2*r*s + 282*D1**2*bdd1*f**2*r - 60*D1**2*bdd1*f**2*s**2 + 180*D1**2*bdd1*f**2*s - 90*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r**2 - 336*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 168*D1**2*bdd1*f*g2*s**2 + 504*D1**2*bdd1*f*g2*s - 252*D1**2*bdd1*f*g2 + 15*D1**2*f**2*fd*r**2 + 240*D1**2*f**2*fd*r*s - 90*D1**2*f**2*fd*r + 225*D1**2*f**2*fd*s**2 - 230*D1**2*f**2*fd*s + 80*D1**2*f**2*fd - 345*D1**2*f**2*fdd*r**2 - 750*D1**2*f**2*fdd*r*s + 480*D1**2*f**2*fdd*r - 405*D1**2*f**2*fdd*s**2 + 520*D1**2*f**2*fdd*s - 250*D1**2*f**2*fdd - 126*D1**2*f**2*gd2*r**2 + 84*D1**2*f**2*gd2*r*s + 252*D1**2*f**2*gd2*r + 210*D1**2*f**2*gd2*s**2 - 84*D1**2*f**2*gd2*s - 126*D1**2*f**2*gd2 - 210*D1**2*f**2*gdd2*r**2 - 588*D1**2*f**2*gdd2*r*s + 420*D1**2*f**2*gdd2*r - 378*D1**2*f**2*gdd2*s**2 + 588*D1**2*f**2*gdd2*s - 210*D1**2*f**2*gdd2 - 690*D1**2*f*fd**2*r**2 - 1500*D1**2*f*fd**2*r*s + 960*D1**2*f*fd**2*r - 810*D1**2*f*fd**2*s**2 + 1040*D1**2*f*fd**2*s - 250*D1**2*f*fd**2 - 252*D1**2*f*fd*g2*r**2 + 168*D1**2*f*fd*g2*r*s - 84*D1**2*f*fd*g2*r + 420*D1**2*f*fd*g2*s**2 - 420*D1**2*f*fd*g2*s + 210*D1**2*f*fd*g2 - 840*D1**2*f*fd*gd2*r**2 - 2352*D1**2*f*fd*gd2*r*s + 1428*D1**2*f*fd*gd2*r - 1512*D1**2*f*fd*gd2*s**2 + 1932*D1**2*f*fd*gd2*s - 588*D1**2*f*fd*gd2 - 420*D1**2*f*fdd*g2*r**2 - 1176*D1**2*f*fdd*g2*r*s + 588*D1**2*f*fdd*g2*r - 756*D1**2*f*fdd*g2*s**2 + 756*D1**2*f*fdd*g2*s - 378*D1**2*f*fdd*g2 - 420*D1**2*fd**2*g2*r**2 - 1176*D1**2*fd**2*g2*r*s + 588*D1**2*fd**2*g2*r - 756*D1**2*fd**2*g2*s**2 + 756*D1**2*fd**2*g2*s + 840*D1*Dd*K*bd1*f**2*r**2 + 2352*D1*Dd*K*bd1*f**2*r*s - 1554*D1*Dd*K*bd1*f**2*r + 1512*D1*Dd*K*bd1*f**2*s**2 - 2142*D1*Dd*K*bd1*f**2*s + 714*D1*Dd*K*bd1*f**2 - 1296*D1*Dd*bd1*f**2*r**2 - 1776*D1*Dd*bd1*f**2*r*s + 1998*D1*Dd*bd1*f**2*r - 480*D1*Dd*bd1*f**2*s**2 + 1284*D1*Dd*bd1*f**2*s - 744*D1*Dd*bd1*f**2 - 1344*D1*Dd*bd1*f*g2*r**2 - 2688*D1*Dd*bd1*f*g2*r*s + 3024*D1*Dd*bd1*f*g2*r - 1344*D1*Dd*bd1*f*g2*s**2 + 3024*D1*Dd*bd1*f*g2*s - 1512*D1*Dd*bd1*f*g2 + 20*D1*Dd*f**3*r**2 + 320*D1*Dd*f**3*r*s - 100*D1*Dd*f**3*r + 300*D1*Dd*f**3*s**2 - 310*D1*Dd*f**3*s + 85*D1*Dd*f**3 - 2760*D1*Dd*f**2*fd*r**2 - 6000*D1*Dd*f**2*fd*r*s + 4050*D1*Dd*f**2*fd*r - 3240*D1*Dd*f**2*fd*s**2 + 4390*D1*Dd*f**2*fd*s - 1480*D1*Dd*f**2*fd - 504*D1*Dd*f**2*g2*r**2 + 336*D1*Dd*f**2*g2*r*s + 420*D1*Dd*f**2*g2*r + 840*D1*Dd*f**2*g2*s**2 - 588*D1*Dd*f**2*g2*s - 42*D1*Dd*f**2*g2 - 1680*D1*Dd*f**2*gd2*r**2 - 4704*D1*Dd*f**2*gd2*r*s + 3108*D1*Dd*f**2*gd2*r - 3024*D1*Dd*f**2*gd2*s**2 + 4284*D1*Dd*f**2*gd2*s - 1428*D1*Dd*f**2*gd2 - 3360*D1*Dd*f*fd*g2*r**2 - 9408*D1*Dd*f*fd*g2*r*s + 5208*D1*Dd*f*fd*g2*r - 6048*D1*Dd*f*fd*g2*s**2 + 6888*D1*Dd*f*fd*g2*s - 1932*D1*Dd*f*fd*g2 - 460*D1*Ddd*f**3*r**2 - 1000*D1*Ddd*f**3*r*s + 710*D1*Ddd*f**3*r - 540*D1*Ddd*f**3*s**2 + 770*D1*Ddd*f**3*s - 365*D1*Ddd*f**3 - 840*D1*Ddd*f**2*g2*r**2 - 2352*D1*Ddd*f**2*g2*r*s + 1428*D1*Ddd*f**2*g2*r - 1512*D1*Ddd*f**2*g2*s**2 + 1932*D1*Ddd*f**2*g2*s - 798*D1*Ddd*f**2*g2 - 84*D1*b2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 42*D1*b2*f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 1380*Dd**2*f**3*r**2 - 3000*Dd**2*f**3*r*s + 2130*Dd**2*f**3*r - 1620*Dd**2*f**3*s**2 + 2310*Dd**2*f**3*s - 730*Dd**2*f**3 - 2520*Dd**2*f**2*g2*r**2 - 7056*Dd**2*f**2*g2*r*s + 4284*Dd**2*f**2*g2*r - 4536*Dd**2*f**2*g2*s**2 + 5796*Dd**2*f**2*g2*s - 1596*Dd**2*f**2*g2 + 42*b1**2*(D1**2*(-2*K*fd*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-2*r**2 - 2*r*(s - 1) + s) + 2*fd*r*(r + s) + fdd*(K*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) - r*(r + s))) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(2*K*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 3*b1*(-288*C*D1**2*f*fd*r**2 - 448*C*D1**2*f*fd*r*s + 208*C*D1**2*f*fd*r - 160*C*D1**2*f*fd*s**2 + 144*C*D1**2*f*fd*s - 104*C*D1**2*f*fd + 144*C*D1**2*f*fdd*r**2 + 224*C*D1**2*f*fdd*r*s - 104*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 52*C*D1**2*f*fdd + 144*C*D1**2*fd**2*r**2 + 224*C*D1**2*fd**2*r*s - 104*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s - 40*C*D1**2*fd**2 - 576*C*D1*Dd*f**2*r**2 - 896*C*D1*Dd*f**2*r*s + 800*C*D1*Dd*f**2*r - 320*C*D1*Dd*f**2*s**2 + 608*C*D1*Dd*f**2*s - 368*C*D1*Dd*f**2 + 1152*C*D1*Dd*f*fd*r**2 + 1792*C*D1*Dd*f*fd*r*s - 1216*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 896*C*D1*Dd*f*fd*s + 280*C*D1*Dd*f*fd + 288*C*D1*Ddd*f**2*r**2 + 448*C*D1*Ddd*f**2*r*s - 400*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 304*C*D1*Ddd*f**2*s + 184*C*D1*Ddd*f**2 + 864*C*Dd**2*f**2*r**2 + 1344*C*Dd**2*f**2*r*s - 1200*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 912*C*Dd**2*f**2*s + 368*C*Dd**2*f**2 + 56*D1**2*K*bdd1*f*r**2 + 112*D1**2*K*bdd1*f*r*s - 140*D1**2*K*bdd1*f*r + 56*D1**2*K*bdd1*f*s**2 - 140*D1**2*K*bdd1*f*s + 70*D1**2*K*bdd1*f + 42*D1**2*K*f*fd*r**2 - 28*D1**2*K*f*fd*r*s + 14*D1**2*K*f*fd*r - 70*D1**2*K*f*fd*s**2 + 70*D1**2*K*f*fd*s - 35*D1**2*K*f*fd + 70*D1**2*K*f*fdd*r**2 + 196*D1**2*K*f*fdd*r*s - 98*D1**2*K*f*fdd*r + 126*D1**2*K*f*fdd*s**2 - 126*D1**2*K*f*fdd*s + 63*D1**2*K*f*fdd + 70*D1**2*K*fd**2*r**2 + 196*D1**2*K*fd**2*r*s - 98*D1**2*K*fd**2*r + 126*D1**2*K*fd**2*s**2 - 126*D1**2*K*fd**2*s - 28*D1**2*b2*fd*r**2 - 56*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*s**2 + 14*D1**2*b2*fdd*r**2 + 28*D1**2*b2*fdd*r*s + 14*D1**2*b2*fdd*s**2 - 28*D1**2*bdd1*f**2*r**2 - 28*D1**2*bdd1*f**2*r*s + 42*D1**2*bdd1*f**2*r + 14*D1**2*bdd1*f**2*s - 14*D1**2*bdd1*f**2 - 28*D1**2*bdd1*f*r**2 - 28*D1**2*bdd1*f*r*s + 42*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s - 14*D1**2*bdd1*f + 14*D1**2*bdd2*f*r**2 + 28*D1**2*bdd2*f*r*s - 28*D1**2*bdd2*f*r + 14*D1**2*bdd2*f*s**2 - 28*D1**2*bdd2*f*s + 14*D1**2*bdd2*f + 188*D1**2*f*fd*r**2 + 268*D1**2*f*fd*r*s - 162*D1**2*f*fd*r + 80*D1**2*f*fd*s**2 - 108*D1**2*f*fd*s + 88*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 148*D1**2*f*fdd*r*s + 88*D1**2*f*fdd*r - 40*D1**2*f*fdd*s**2 + 54*D1**2*f*fdd*s - 44*D1**2*f*fdd + 112*D1**2*f*gd2*r**2 + 224*D1**2*f*gd2*r*s - 224*D1**2*f*gd2*r + 112*D1**2*f*gd2*s**2 - 224*D1**2*f*gd2*s + 112*D1**2*f*gd2 - 56*D1**2*f*gdd2*r**2 - 112*D1**2*f*gdd2*r*s + 112*D1**2*f*gdd2*r - 56*D1**2*f*gdd2*s**2 + 112*D1**2*f*gdd2*s - 56*D1**2*f*gdd2 - 108*D1**2*fd**2*r**2 - 148*D1**2*fd**2*r*s + 88*D1**2*fd**2*r - 40*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s + 20*D1**2*fd**2 + 112*D1**2*fd*g2*r**2 + 224*D1**2*fd*g2*r*s + 112*D1**2*fd*g2*r + 112*D1**2*fd*g2*s**2 + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 - 112*D1**2*fd*gd2*r**2 - 224*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 112*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r**2 - 112*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r - 56*D1**2*fdd*g2*s**2 - 56*D1**2*fdd*g2*s + 28*D1**2*fdd*g2 + 84*D1*Dd*K*f**2*r**2 - 56*D1*Dd*K*f**2*r*s - 70*D1*Dd*K*f**2*r - 140*D1*Dd*K*f**2*s**2 + 98*D1*Dd*K*f**2*s + 7*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*r**2 + 1568*D1*Dd*K*f*fd*r*s - 868*D1*Dd*K*f*fd*r + 1008*D1*Dd*K*f*fd*s**2 - 1148*D1*Dd*K*f*fd*s + 322*D1*Dd*K*f*fd - 112*D1*Dd*b2*f*r**2 - 224*D1*Dd*b2*f*r*s + 168*D1*Dd*b2*f*r - 112*D1*Dd*b2*f*s**2 + 168*D1*Dd*b2*f*s - 84*D1*Dd*b2*f + 112*D1*Dd*b2*fd*r**2 + 224*D1*Dd*b2*fd*r*s - 84*D1*Dd*b2*fd*r + 112*D1*Dd*b2*fd*s**2 - 84*D1*Dd*b2*fd*s + 376*D1*Dd*f**2*r**2 + 536*D1*Dd*f**2*r*s - 510*D1*Dd*f**2*r + 160*D1*Dd*f**2*s**2 - 348*D1*Dd*f**2*s + 228*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 1184*D1*Dd*f*fd*r*s + 932*D1*Dd*f*fd*r - 320*D1*Dd*f*fd*s**2 + 592*D1*Dd*f*fd*s - 230*D1*Dd*f*fd + 448*D1*Dd*f*g2*r**2 + 896*D1*Dd*f*g2*r*s - 672*D1*Dd*f*g2*r + 448*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 336*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r**2 - 896*D1*Dd*f*gd2*r*s + 784*D1*Dd*f*gd2*r - 448*D1*Dd*f*gd2*s**2 + 784*D1*Dd*f*gd2*s - 336*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r**2 - 896*D1*Dd*fd*g2*r*s + 112*D1*Dd*fd*g2*r - 448*D1*Dd*fd*g2*s**2 + 112*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*r**2 + 392*D1*Ddd*K*f**2*r*s - 238*D1*Ddd*K*f**2*r + 252*D1*Ddd*K*f**2*s**2 - 322*D1*Ddd*K*f**2*s + 133*D1*Ddd*K*f**2 + 56*D1*Ddd*b2*f*r**2 + 112*D1*Ddd*b2*f*r*s - 84*D1*Ddd*b2*f*r + 56*D1*Ddd*b2*f*s**2 - 84*D1*Ddd*b2*f*s + 42*D1*Ddd*b2*f - 216*D1*Ddd*f**2*r**2 - 296*D1*Ddd*f**2*r*s + 290*D1*Ddd*f**2*r - 80*D1*Ddd*f**2*s**2 + 188*D1*Ddd*f**2*s - 128*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r**2 - 448*D1*Ddd*f*g2*r*s + 336*D1*Ddd*f*g2*r - 224*D1*Ddd*f*g2*s**2 + 336*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(2*K*(4*r**2 + 2*r*(4*s - 5) + 4*s**2 - 10*s + 5) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(2*K*(4*r**2 + 8*r*s - 3*r + 4*s**2 - 3*s - 1) - 4*r**2 - 4*r*s + 3*r + s)) + Dd*f*(K*(32*r**2 + 64*r*(s - 1) + 32*s**2 - 64*s + 30) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 28*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 420*Dd**2*K*f**2*r**2 + 1176*Dd**2*K*f**2*r*s - 714*Dd**2*K*f**2*r + 756*Dd**2*K*f**2*s**2 - 966*Dd**2*K*f**2*s + 266*Dd**2*K*f**2 + 168*Dd**2*b2*f*r**2 + 336*Dd**2*b2*f*r*s - 252*Dd**2*b2*f*r + 168*Dd**2*b2*f*s**2 - 252*Dd**2*b2*f*s + 84*Dd**2*b2*f - 648*Dd**2*f**2*r**2 - 888*Dd**2*f**2*r*s + 870*Dd**2*f**2*r - 240*Dd**2*f**2*s**2 + 564*Dd**2*f**2*s - 256*Dd**2*f**2 - 672*Dd**2*f*g2*r**2 - 1344*Dd**2*f*g2*r*s + 1008*Dd**2*f*g2*r - 672*Dd**2*f*g2*s**2 + 1008*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(105*d**2*k3**6) + 4*D1**2*Pk2*Pk3*ct**4*(D1*(-7*D1*bd1**2*f*s*(2*K*s + f*(2*r - 1) + 2*r - 1) + D1*bdd1*f*s*(-9*f*r + f*s*(5 - 10*C) - s*(7*b2 - 14*g2)) + bd1*(D1*(2*f**2*s*(9*r + s*(10*C - 5)) + f*(-fd*(9*r*(4*s - 1) + s*(40*C*s - 20*C - 20*s + 1)) + s**2*(14*b2 - 14*bd2 - 28*g2 + 28*gd2)) - 14*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(f*r*(9 - 72*s) + 4*f*s*(C*(5 - 20*s) + 10*s + 2) - s*(14*b2 - 28*g2)*(4*s - 1)))) - 7*b1**2*(D1*Dd*(f*(K*(-8*s**2 + 4*s - 2) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(2*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(2*s - 1) - s + 1) + fd*(-2*K*(s - 1)**2 + f*s + r*(-2*f*s + f - 2*s + 2)) + fdd*(K*(s - 1)**2 - f*s + r*(2*f*s - f + s - 1))) + Ddd*f*(K*(4*s**2 - 2*s + 1) + (f + 1)*(r*(4*s - 1) - 2*s))) + Dd**2*f*(12*K*s**2 - 6*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(40*C*D1**2*f*fd*s**2 - 40*C*D1**2*f*fd*s + 20*C*D1**2*f*fd - 20*C*D1**2*f*fdd*s**2 + 20*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd - 20*C*D1**2*fd**2*s**2 + 20*C*D1**2*fd**2*s + 80*C*D1*Dd*f**2*s**2 - 40*C*D1*Dd*f**2*s + 20*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*s**2 + 120*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*s**2 + 20*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*s**2 + 60*C*Dd**2*f**2*s - 14*D1**2*K*bdd1*f*s**2 + 14*D1**2*bd2*f*s**2 - 14*D1**2*bd2*fd*s**2 + 14*D1**2*bd2*fd*s - 14*D1**2*bdd1*f**2*r*s + 7*D1**2*bdd1*f**2*s - 14*D1**2*bdd1*f*r*s + 7*D1**2*bdd1*f*s - 7*D1**2*bdd2*f*s**2 + 36*D1**2*f*fd*r*s - 18*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - 10*D1**2*f*fd - 18*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - D1**2*f*fdd*s + 5*D1**2*f*fdd - 28*D1**2*f*gd2*s**2 + 14*D1**2*f*gdd2*s**2 - 18*D1**2*fd**2*r*s + 9*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - D1**2*fd**2*s - 9*D1**2*fd**2 - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 28*D1**2*fd*gd2*s**2 - 28*D1**2*fd*gd2*s + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 56*D1*Dd*bd2*f*s**2 + 14*D1*Dd*bd2*f*s + 72*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s - 10*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 54*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 + 12*D1*Dd*f*fd*s - 17*D1*Dd*f*fd - 112*D1*Dd*f*g2*s**2 + 56*D1*Dd*f*g2*s - 28*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*s**2 - 28*D1*Dd*f*gd2*s + 112*D1*Dd*fd*g2*s**2 - 140*D1*Dd*fd*g2*s + 28*D1*Dd*fd*g2 - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 + 8*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*s**2 - 28*D1*Ddd*f*g2*s + 14*D1*Ddd*f*g2 + 7*D1*bd1*(-D1*(f*s*(-4*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(4*K*s - 1))) - Dd*f*(16*K*s**2 - 4*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 + 24*Dd**2*f**2*s - 18*Dd**2*f**2 + 168*Dd**2*f*g2*s**2 - 84*Dd**2*f*g2*s + 7*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(35*d**2*k2**2) - 4*D1**2*Pk2*Pk3*ct**3*f**2*k1**7*(D1**2*(f*(7*fd - 9*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 54*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(7*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 18*fd*(4*r + 4*s - 3)**2) - 9*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 54*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(33*d**2*k2*k3**8) - 40*D1**2*Pk2*Pk3*ct**3*f**2*k1**5*st**2*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(33*d**2*k2**3*k3**4) + 2*D1**2*Pk2*Pk3*ct**3*f*k1**5*(-12*D1**2*b1*f*fd*s**2 + 6*D1**2*b1*f*fdd*s**2 + 12*D1**2*b1*fd**2*s**2 + 2*D1**2*bdd1*f**2*(s - 1)**2 + 44*D1**2*f**2*fd*s**2 - 22*D1**2*f**2*fd*s + 11*D1**2*f**2*fd - 28*D1**2*f**2*fdd*s**2 + 14*D1**2*f**2*fdd*s - 7*D1**2*f**2*fdd - 84*D1**2*f*fd**2*s**2 + 42*D1**2*f*fd**2*s - 16*D1*Dd*b1*f**2*s**2 + 8*D1*Dd*b1*f**2*s - 4*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*s**2 - 12*D1*Dd*b1*f*fd*s + 44*D1*Dd*f**3*s**2 - 22*D1*Dd*f**3*s + 11*D1*Dd*f**3 - 224*D1*Dd*f**2*fd*s**2 + 112*D1*Dd*f**2*fd*s - 14*D1*Dd*f**2*fd + 8*D1*Ddd*b1*f**2*s**2 - 4*D1*Ddd*b1*f**2*s + 2*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*s**2 + 14*D1*Ddd*f**3*s - 7*D1*Ddd*f**3 - 4*D1*bd1*f*(s - 1)*(D1*f*(s - 1) - 3*D1*fd*s + Dd*f*(1 - 4*s)) + 24*Dd**2*b1*f**2*s**2 - 12*Dd**2*b1*f**2*s - 84*Dd**2*f**3*s**2 + 42*Dd**2*f**3*s)/(9*d**2*k2**3*k3**4) + D1**2*Pk2*Pk3*ct**3*f*k2**5*st**2*(64*C - 32)*(D1**2*(f*(11*fd - 10*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 10*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(11*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 10*fd*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) - 10*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 10*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4))/(315*d**2*k1*k3**6) - 8*D1**2*Pk2*Pk3*ct**3*k1**5*k2*st**2*(1584*C*D1**2*f**2*fd*r**2 + 3168*C*D1**2*f**2*fd*r*s - 2112*C*D1**2*f**2*fd*r + 1584*C*D1**2*f**2*fd*s**2 - 2112*C*D1**2*f**2*fd*s + 1056*C*D1**2*f**2*fd - 1980*C*D1**2*f**2*fdd*r**2 - 3960*C*D1**2*f**2*fdd*r*s + 2640*C*D1**2*f**2*fdd*r - 1980*C*D1**2*f**2*fdd*s**2 + 2640*C*D1**2*f**2*fdd*s - 1320*C*D1**2*f**2*fdd - 3960*C*D1**2*f*fd**2*r**2 - 7920*C*D1**2*f*fd**2*r*s + 5280*C*D1**2*f*fd**2*r - 3960*C*D1**2*f*fd**2*s**2 + 5280*C*D1**2*f*fd**2*s - 1320*C*D1**2*f*fd**2 + 2112*C*D1*Dd*f**3*r**2 + 4224*C*D1*Dd*f**3*r*s - 3168*C*D1*Dd*f**3*r + 2112*C*D1*Dd*f**3*s**2 - 3168*C*D1*Dd*f**3*s + 1584*C*D1*Dd*f**3 - 15840*C*D1*Dd*f**2*fd*r**2 - 31680*C*D1*Dd*f**2*fd*r*s + 22440*C*D1*Dd*f**2*fd*r - 15840*C*D1*Dd*f**2*fd*s**2 + 22440*C*D1*Dd*f**2*fd*s - 7920*C*D1*Dd*f**2*fd - 2640*C*D1*Ddd*f**3*r**2 - 5280*C*D1*Ddd*f**3*r*s + 3960*C*D1*Ddd*f**3*r - 2640*C*D1*Ddd*f**3*s**2 + 3960*C*D1*Ddd*f**3*s - 1980*C*D1*Ddd*f**3 - 7920*C*Dd**2*f**3*r**2 - 15840*C*Dd**2*f**3*r*s + 11880*C*Dd**2*f**3*r - 7920*C*Dd**2*f**3*s**2 + 11880*C*Dd**2*f**3*s - 3960*C*Dd**2*f**3 + 528*D1**2*K*b1*f*fd*r**2 + 1056*D1**2*K*b1*f*fd*r*s - 528*D1**2*K*b1*f*fd*r + 528*D1**2*K*b1*f*fd*s**2 - 528*D1**2*K*b1*f*fd*s + 264*D1**2*K*b1*f*fd - 1188*D1**2*K*b1*f*fdd*r**2 - 2376*D1**2*K*b1*f*fdd*r*s + 1188*D1**2*K*b1*f*fdd*r - 1188*D1**2*K*b1*f*fdd*s**2 + 1188*D1**2*K*b1*f*fdd*s - 594*D1**2*K*b1*f*fdd - 1188*D1**2*K*b1*fd**2*r**2 - 2376*D1**2*K*b1*fd**2*r*s + 1188*D1**2*K*b1*fd**2*r - 1188*D1**2*K*b1*fd**2*s**2 + 1188*D1**2*K*b1*fd**2*s - 528*D1**2*b1*f*fd*r**2 - 1056*D1**2*b1*f*fd*r*s + 528*D1**2*b1*f*fd*r - 528*D1**2*b1*f*fd*s**2 + 528*D1**2*b1*f*fd*s - 264*D1**2*b1*f*fd + 1188*D1**2*b1*f*fdd*r**2 + 2376*D1**2*b1*f*fdd*r*s - 1188*D1**2*b1*f*fdd*r + 1188*D1**2*b1*f*fdd*s**2 - 1188*D1**2*b1*f*fdd*s + 594*D1**2*b1*f*fdd + 1188*D1**2*b1*fd**2*r**2 + 2376*D1**2*b1*fd**2*r*s - 1188*D1**2*b1*fd**2*r + 1188*D1**2*b1*fd**2*s**2 - 1188*D1**2*b1*fd**2*s - 594*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 6740*D1**2*f**3*fd*r**2 + 13480*D1**2*f**3*fd*r*s - 10110*D1**2*f**3*fd*r + 6740*D1**2*f**3*fd*s**2 - 10110*D1**2*f**3*fd*s + 5055*D1**2*f**3*fd - 7000*D1**2*f**3*fdd*r**2 - 14000*D1**2*f**3*fdd*r*s + 10500*D1**2*f**3*fdd*r - 7000*D1**2*f**3*fdd*s**2 + 10500*D1**2*f**3*fdd*s - 5250*D1**2*f**3*fdd - 21000*D1**2*f**2*fd**2*r**2 - 42000*D1**2*f**2*fd**2*r*s + 31500*D1**2*f**2*fd**2*r - 21000*D1**2*f**2*fd**2*s**2 + 31500*D1**2*f**2*fd**2*s - 10500*D1**2*f**2*fd**2 - 1584*D1**2*f**2*fd*r**2 - 3168*D1**2*f**2*fd*r*s + 2112*D1**2*f**2*fd*r - 1584*D1**2*f**2*fd*s**2 + 2112*D1**2*f**2*fd*s - 1056*D1**2*f**2*fd + 1980*D1**2*f**2*fdd*r**2 + 3960*D1**2*f**2*fdd*r*s - 2640*D1**2*f**2*fdd*r + 1980*D1**2*f**2*fdd*s**2 - 2640*D1**2*f**2*fdd*s + 1320*D1**2*f**2*fdd - 528*D1**2*f**2*gd2*r**2 - 1056*D1**2*f**2*gd2*r*s + 1056*D1**2*f**2*gd2*r - 528*D1**2*f**2*gd2*s**2 + 1056*D1**2*f**2*gd2*s - 528*D1**2*f**2*gd2 + 1188*D1**2*f**2*gdd2*r**2 + 2376*D1**2*f**2*gdd2*r*s - 2376*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 2376*D1**2*f**2*gdd2*s + 1188*D1**2*f**2*gdd2 + 3960*D1**2*f*fd**2*r**2 + 7920*D1**2*f*fd**2*r*s - 5280*D1**2*f*fd**2*r + 3960*D1**2*f*fd**2*s**2 - 5280*D1**2*f*fd**2*s + 1320*D1**2*f*fd**2 - 1056*D1**2*f*fd*g2*r**2 - 2112*D1**2*f*fd*g2*r*s + 1056*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 + 4752*D1**2*f*fd*gd2*r**2 + 9504*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2376*D1**2*f*fd*gd2 + 2376*D1**2*f*fdd*g2*r**2 + 4752*D1**2*f*fdd*g2*r*s - 2376*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 2376*D1**2*fd**2*g2*r**2 + 4752*D1**2*fd**2*g2*r*s - 2376*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 1056*D1*Dd*K*b1*f**2*r**2 + 2112*D1*Dd*K*b1*f**2*r*s - 1584*D1*Dd*K*b1*f**2*r + 1056*D1*Dd*K*b1*f**2*s**2 - 1584*D1*Dd*K*b1*f**2*s + 792*D1*Dd*K*b1*f**2 - 9504*D1*Dd*K*b1*f*fd*r**2 - 19008*D1*Dd*K*b1*f*fd*r*s + 11880*D1*Dd*K*b1*f*fd*r - 9504*D1*Dd*K*b1*f*fd*s**2 + 11880*D1*Dd*K*b1*f*fd*s - 3564*D1*Dd*K*b1*f*fd - 1056*D1*Dd*b1*f**2*r**2 - 2112*D1*Dd*b1*f**2*r*s + 1584*D1*Dd*b1*f**2*r - 1056*D1*Dd*b1*f**2*s**2 + 1584*D1*Dd*b1*f**2*s - 792*D1*Dd*b1*f**2 + 9504*D1*Dd*b1*f*fd*r**2 + 19008*D1*Dd*b1*f*fd*r*s - 11880*D1*Dd*b1*f*fd*r + 9504*D1*Dd*b1*f*fd*s**2 - 11880*D1*Dd*b1*f*fd*s + 3564*D1*Dd*b1*f*fd + 6740*D1*Dd*f**4*r**2 + 13480*D1*Dd*f**4*r*s - 10110*D1*Dd*f**4*r + 6740*D1*Dd*f**4*s**2 - 10110*D1*Dd*f**4*s + 5055*D1*Dd*f**4 - 56000*D1*Dd*f**3*fd*r**2 - 112000*D1*Dd*f**3*fd*r*s + 84000*D1*Dd*f**3*fd*r - 56000*D1*Dd*f**3*fd*s**2 + 84000*D1*Dd*f**3*fd*s - 31500*D1*Dd*f**3*fd - 2112*D1*Dd*f**3*r**2 - 4224*D1*Dd*f**3*r*s + 3168*D1*Dd*f**3*r - 2112*D1*Dd*f**3*s**2 + 3168*D1*Dd*f**3*s - 1584*D1*Dd*f**3 + 15840*D1*Dd*f**2*fd*r**2 + 31680*D1*Dd*f**2*fd*r*s - 22440*D1*Dd*f**2*fd*r + 15840*D1*Dd*f**2*fd*s**2 - 22440*D1*Dd*f**2*fd*s + 7920*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*g2*r**2 - 4224*D1*Dd*f**2*g2*r*s + 3168*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s**2 + 3168*D1*Dd*f**2*g2*s - 1584*D1*Dd*f**2*g2 + 9504*D1*Dd*f**2*gd2*r**2 + 19008*D1*Dd*f**2*gd2*r*s - 16632*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 19008*D1*Dd*f*fd*g2*r**2 + 38016*D1*Dd*f*fd*g2*r*s - 23760*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 23760*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 2376*D1*Ddd*K*b1*f**2*r**2 - 4752*D1*Ddd*K*b1*f**2*r*s + 3564*D1*Ddd*K*b1*f**2*r - 2376*D1*Ddd*K*b1*f**2*s**2 + 3564*D1*Ddd*K*b1*f**2*s - 1782*D1*Ddd*K*b1*f**2 + 2376*D1*Ddd*b1*f**2*r**2 + 4752*D1*Ddd*b1*f**2*r*s - 3564*D1*Ddd*b1*f**2*r + 2376*D1*Ddd*b1*f**2*s**2 - 3564*D1*Ddd*b1*f**2*s + 1782*D1*Ddd*b1*f**2 - 7000*D1*Ddd*f**4*r**2 - 14000*D1*Ddd*f**4*r*s + 10500*D1*Ddd*f**4*r - 7000*D1*Ddd*f**4*s**2 + 10500*D1*Ddd*f**4*s - 5250*D1*Ddd*f**4 + 2640*D1*Ddd*f**3*r**2 + 5280*D1*Ddd*f**3*r*s - 3960*D1*Ddd*f**3*r + 2640*D1*Ddd*f**3*s**2 - 3960*D1*Ddd*f**3*s + 1980*D1*Ddd*f**3 + 4752*D1*Ddd*f**2*g2*r**2 + 9504*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 + 132*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 9*D1*fd*(2*r + 2*s - 1) - 9*Dd*f*(4*r + 4*s - 3)) - 7128*Dd**2*K*b1*f**2*r**2 - 14256*Dd**2*K*b1*f**2*r*s + 10692*Dd**2*K*b1*f**2*r - 7128*Dd**2*K*b1*f**2*s**2 + 10692*Dd**2*K*b1*f**2*s - 3564*Dd**2*K*b1*f**2 + 7128*Dd**2*b1*f**2*r**2 + 14256*Dd**2*b1*f**2*r*s - 10692*Dd**2*b1*f**2*r + 7128*Dd**2*b1*f**2*s**2 - 10692*Dd**2*b1*f**2*s + 3564*Dd**2*b1*f**2 - 21000*Dd**2*f**4*r**2 - 42000*Dd**2*f**4*r*s + 31500*Dd**2*f**4*r - 21000*Dd**2*f**4*s**2 + 31500*Dd**2*f**4*s - 10500*Dd**2*f**4 + 7920*Dd**2*f**3*r**2 + 15840*Dd**2*f**3*r*s - 11880*Dd**2*f**3*r + 7920*Dd**2*f**3*s**2 - 11880*Dd**2*f**3*s + 3960*Dd**2*f**3 + 14256*Dd**2*f**2*g2*r**2 + 28512*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 7128*Dd**2*f**2*g2)/(1155*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**3*k1**5*k2*(360*C*D1**2*bdd1*f**2*r**2 + 720*C*D1**2*bdd1*f**2*r*s - 720*C*D1**2*bdd1*f**2*r + 360*C*D1**2*bdd1*f**2*s**2 - 720*C*D1**2*bdd1*f**2*s + 360*C*D1**2*bdd1*f**2 - 300*C*D1**2*f**2*fd*r**2 - 600*C*D1**2*f**2*fd*r*s + 400*C*D1**2*f**2*fd*r - 300*C*D1**2*f**2*fd*s**2 + 400*C*D1**2*f**2*fd*s - 200*C*D1**2*f**2*fd + 420*C*D1**2*f**2*fdd*r**2 + 840*C*D1**2*f**2*fdd*r*s - 560*C*D1**2*f**2*fdd*r + 420*C*D1**2*f**2*fdd*s**2 - 560*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 840*C*D1**2*f*fd**2*r**2 + 1680*C*D1**2*f*fd**2*r*s - 1120*C*D1**2*f*fd**2*r + 840*C*D1**2*f*fd**2*s**2 - 1120*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 400*C*D1*Dd*f**3*r**2 - 800*C*D1*Dd*f**3*r*s + 600*C*D1*Dd*f**3*r - 400*C*D1*Dd*f**3*s**2 + 600*C*D1*Dd*f**3*s - 300*C*D1*Dd*f**3 + 3360*C*D1*Dd*f**2*fd*r**2 + 6720*C*D1*Dd*f**2*fd*r*s - 4760*C*D1*Dd*f**2*fd*r + 3360*C*D1*Dd*f**2*fd*s**2 - 4760*C*D1*Dd*f**2*fd*s + 1680*C*D1*Dd*f**2*fd + 560*C*D1*Ddd*f**3*r**2 + 1120*C*D1*Ddd*f**3*r*s - 840*C*D1*Ddd*f**3*r + 560*C*D1*Ddd*f**3*s**2 - 840*C*D1*Ddd*f**3*s + 420*C*D1*Ddd*f**3 + 1680*C*Dd**2*f**3*r**2 + 3360*C*Dd**2*f**3*r*s - 2520*C*Dd**2*f**3*r + 1680*C*Dd**2*f**3*s**2 - 2520*C*Dd**2*f**3*s + 840*C*Dd**2*f**3 + 90*D1**2*K*bdd1*f**2*r**2 + 180*D1**2*K*bdd1*f**2*r*s - 180*D1**2*K*bdd1*f**2*r + 90*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s + 90*D1**2*K*bdd1*f**2 + 504*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 175*D1**2*bdd1*f**3*r**2 + 350*D1**2*bdd1*f**3*r*s - 350*D1**2*bdd1*f**3*r + 175*D1**2*bdd1*f**3*s**2 - 350*D1**2*bdd1*f**3*s + 175*D1**2*bdd1*f**3 - 405*D1**2*bdd1*f**2*r**2 - 810*D1**2*bdd1*f**2*r*s + 810*D1**2*bdd1*f**2*r - 405*D1**2*bdd1*f**2*s**2 + 810*D1**2*bdd1*f**2*s - 405*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r**2 - 1008*D1**2*bdd1*f*g2*r*s + 1008*D1**2*bdd1*f*g2*r - 504*D1**2*bdd1*f*g2*s**2 + 1008*D1**2*bdd1*f*g2*s - 504*D1**2*bdd1*f*g2 + 140*D1**2*f**3*fd*r**2 + 280*D1**2*f**3*fd*r*s - 210*D1**2*f**3*fd*r + 140*D1**2*f**3*fd*s**2 - 210*D1**2*f**3*fd*s + 105*D1**2*f**3*fd + 225*D1**2*f**2*fd*r**2 + 450*D1**2*f**2*fd*r*s - 300*D1**2*f**2*fd*r + 225*D1**2*f**2*fd*s**2 - 300*D1**2*f**2*fd*s + 150*D1**2*f**2*fd - 315*D1**2*f**2*fdd*r**2 - 630*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r - 315*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 210*D1**2*f**2*fdd + 108*D1**2*f**2*gd2*r**2 + 216*D1**2*f**2*gd2*r*s - 216*D1**2*f**2*gd2*r + 108*D1**2*f**2*gd2*s**2 - 216*D1**2*f**2*gd2*s + 108*D1**2*f**2*gd2 - 180*D1**2*f**2*gdd2*r**2 - 360*D1**2*f**2*gdd2*r*s + 360*D1**2*f**2*gdd2*r - 180*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s - 180*D1**2*f**2*gdd2 - 630*D1**2*f*fd**2*r**2 - 1260*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r - 630*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 210*D1**2*f*fd**2 + 216*D1**2*f*fd*g2*r**2 + 432*D1**2*f*fd*g2*r*s - 216*D1**2*f*fd*g2*r + 216*D1**2*f*fd*g2*s**2 - 216*D1**2*f*fd*g2*s + 108*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*r**2 - 1440*D1**2*f*fd*gd2*r*s + 1080*D1**2*f*fd*gd2*r - 720*D1**2*f*fd*gd2*s**2 + 1080*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 360*D1**2*f*fdd*g2*r**2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r - 360*D1**2*f*fdd*g2*s**2 + 360*D1**2*f*fdd*g2*s - 180*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*r**2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r - 360*D1**2*fd**2*g2*s**2 + 360*D1**2*fd**2*g2*s + 140*D1*Dd*f**4*r**2 + 280*D1*Dd*f**4*r*s - 210*D1*Dd*f**4*r + 140*D1*Dd*f**4*s**2 - 210*D1*Dd*f**4*s + 105*D1*Dd*f**4 + 300*D1*Dd*f**3*r**2 + 600*D1*Dd*f**3*r*s - 450*D1*Dd*f**3*r + 300*D1*Dd*f**3*s**2 - 450*D1*Dd*f**3*s + 225*D1*Dd*f**3 - 2520*D1*Dd*f**2*fd*r**2 - 5040*D1*Dd*f**2*fd*r*s + 3570*D1*Dd*f**2*fd*r - 2520*D1*Dd*f**2*fd*s**2 + 3570*D1*Dd*f**2*fd*s - 1260*D1*Dd*f**2*fd + 432*D1*Dd*f**2*g2*r**2 + 864*D1*Dd*f**2*g2*r*s - 648*D1*Dd*f**2*g2*r + 432*D1*Dd*f**2*g2*s**2 - 648*D1*Dd*f**2*g2*s + 324*D1*Dd*f**2*g2 - 1440*D1*Dd*f**2*gd2*r**2 - 2880*D1*Dd*f**2*gd2*r*s + 2520*D1*Dd*f**2*gd2*r - 1440*D1*Dd*f**2*gd2*s**2 + 2520*D1*Dd*f**2*gd2*s - 1080*D1*Dd*f**2*gd2 - 2880*D1*Dd*f*fd*g2*r**2 - 5760*D1*Dd*f*fd*g2*r*s + 3600*D1*Dd*f*fd*g2*r - 2880*D1*Dd*f*fd*g2*s**2 + 3600*D1*Dd*f*fd*g2*s - 1080*D1*Dd*f*fd*g2 - 420*D1*Ddd*f**3*r**2 - 840*D1*Ddd*f**3*r*s + 630*D1*Ddd*f**3*r - 420*D1*Ddd*f**3*s**2 + 630*D1*Ddd*f**3*s - 315*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*r**2 - 1440*D1*Ddd*f**2*g2*r*s + 1080*D1*Ddd*f**2*g2*r - 720*D1*Ddd*f**2*g2*s**2 + 1080*D1*Ddd*f**2*g2*s - 540*D1*Ddd*f**2*g2 - D1*bd1*(D1*(170*f**3*(r + s - 1) + f**2*(216*C*(r + s - 1) - 350*fd*(3*r + 3*s - 2) + (54*K - 243)*(r + s - 1)) - 6*f*(15*fd*(8*C + 2*K - 9)*(2*r + 2*s - 1) + (28*g2 - 168*gd2)*(r + s - 1)) + 1008*fd*g2*(r + s)) - 2*Dd*f*(175*f**2 + 45*f*(8*C + 2*K - 9) - 504*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1260*Dd**2*f**3*r**2 - 2520*Dd**2*f**3*r*s + 1890*Dd**2*f**3*r - 1260*Dd**2*f**3*s**2 + 1890*Dd**2*f**3*s - 630*Dd**2*f**3 - 2160*Dd**2*f**2*g2*r**2 - 4320*Dd**2*f**2*g2*r*s + 3240*Dd**2*f**2*g2*r - 2160*Dd**2*f**2*g2*s**2 + 3240*Dd**2*f**2*g2*s - 1080*Dd**2*f**2*g2 - 84*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(r + s)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-432*C*D1**2*f*fd*r**2 - 864*C*D1**2*f*fd*r*s + 432*C*D1**2*f*fd*r - 432*C*D1**2*f*fd*s**2 + 432*C*D1**2*f*fd*s - 216*C*D1**2*f*fd + 720*C*D1**2*f*fdd*r**2 + 1440*C*D1**2*f*fdd*r*s - 720*C*D1**2*f*fdd*r + 720*C*D1**2*f*fdd*s**2 - 720*C*D1**2*f*fdd*s + 360*C*D1**2*f*fdd + 720*C*D1**2*fd**2*r**2 + 1440*C*D1**2*fd**2*r*s - 720*C*D1**2*fd**2*r + 720*C*D1**2*fd**2*s**2 - 720*C*D1**2*fd**2*s - 864*C*D1*Dd*f**2*r**2 - 1728*C*D1*Dd*f**2*r*s + 1296*C*D1*Dd*f**2*r - 864*C*D1*Dd*f**2*s**2 + 1296*C*D1*Dd*f**2*s - 648*C*D1*Dd*f**2 + 5760*C*D1*Dd*f*fd*r**2 + 11520*C*D1*Dd*f*fd*r*s - 7200*C*D1*Dd*f*fd*r + 5760*C*D1*Dd*f*fd*s**2 - 7200*C*D1*Dd*f*fd*s + 2160*C*D1*Dd*f*fd + 1440*C*D1*Ddd*f**2*r**2 + 2880*C*D1*Ddd*f**2*r*s - 2160*C*D1*Ddd*f**2*r + 1440*C*D1*Ddd*f**2*s**2 - 2160*C*D1*Ddd*f**2*s + 1080*C*D1*Ddd*f**2 + 4320*C*Dd**2*f**2*r**2 + 8640*C*Dd**2*f**2*r*s - 6480*C*Dd**2*f**2*r + 4320*C*Dd**2*f**2*s**2 - 6480*C*Dd**2*f**2*s + 2160*C*Dd**2*f**2 - 108*D1**2*K*f*fd*r**2 - 216*D1**2*K*f*fd*r*s + 108*D1**2*K*f*fd*r - 108*D1**2*K*f*fd*s**2 + 108*D1**2*K*f*fd*s - 54*D1**2*K*f*fd + 180*D1**2*K*f*fdd*r**2 + 360*D1**2*K*f*fdd*r*s - 180*D1**2*K*f*fdd*r + 180*D1**2*K*f*fdd*s**2 - 180*D1**2*K*f*fdd*s + 90*D1**2*K*f*fdd + 180*D1**2*K*fd**2*r**2 + 360*D1**2*K*fd**2*r*s - 180*D1**2*K*fd**2*r + 180*D1**2*K*fd**2*s**2 - 180*D1**2*K*fd**2*s + 504*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 510*D1**2*f**2*fd*r**2 - 1020*D1**2*f**2*fd*r*s + 680*D1**2*f**2*fd*r - 510*D1**2*f**2*fd*s**2 + 680*D1**2*f**2*fd*s - 340*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 700*D1**2*f**2*fdd*s + 350*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1400*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 + 486*D1**2*f*fd*r**2 + 972*D1**2*f*fd*r*s - 486*D1**2*f*fd*r + 486*D1**2*f*fd*s**2 - 486*D1**2*f*fd*s + 243*D1**2*f*fd - 810*D1**2*f*fdd*r**2 - 1620*D1**2*f*fdd*r*s + 810*D1**2*f*fdd*r - 810*D1**2*f*fdd*s**2 + 810*D1**2*f*fdd*s - 405*D1**2*f*fdd + 168*D1**2*f*gd2*r**2 + 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r + 168*D1**2*f*gd2*s**2 - 336*D1**2*f*gd2*s + 168*D1**2*f*gd2 - 504*D1**2*f*gdd2*r**2 - 1008*D1**2*f*gdd2*r*s + 1008*D1**2*f*gdd2*r - 504*D1**2*f*gdd2*s**2 + 1008*D1**2*f*gdd2*s - 504*D1**2*f*gdd2 - 810*D1**2*fd**2*r**2 - 1620*D1**2*fd**2*r*s + 810*D1**2*fd**2*r - 810*D1**2*fd**2*s**2 + 810*D1**2*fd**2*s + 168*D1**2*fd*g2*r**2 + 336*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*s**2 - 1008*D1**2*fd*gd2*r**2 - 2016*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 1008*D1**2*fd*gd2*s**2 + 1008*D1**2*fd*gd2*s - 504*D1**2*fdd*g2*r**2 - 1008*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*s**2 - 216*D1*Dd*K*f**2*r**2 - 432*D1*Dd*K*f**2*r*s + 324*D1*Dd*K*f**2*r - 216*D1*Dd*K*f**2*s**2 + 324*D1*Dd*K*f**2*s - 162*D1*Dd*K*f**2 + 1440*D1*Dd*K*f*fd*r**2 + 2880*D1*Dd*K*f*fd*r*s - 1800*D1*Dd*K*f*fd*r + 1440*D1*Dd*K*f*fd*s**2 - 1800*D1*Dd*K*f*fd*s + 540*D1*Dd*K*f*fd - 680*D1*Dd*f**3*r**2 - 1360*D1*Dd*f**3*r*s + 1020*D1*Dd*f**3*r - 680*D1*Dd*f**3*s**2 + 1020*D1*Dd*f**3*s - 510*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 5950*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 5950*D1*Dd*f**2*fd*s + 2100*D1*Dd*f**2*fd + 972*D1*Dd*f**2*r**2 + 1944*D1*Dd*f**2*r*s - 1458*D1*Dd*f**2*r + 972*D1*Dd*f**2*s**2 - 1458*D1*Dd*f**2*s + 729*D1*Dd*f**2 - 6480*D1*Dd*f*fd*r**2 - 12960*D1*Dd*f*fd*r*s + 8100*D1*Dd*f*fd*r - 6480*D1*Dd*f*fd*s**2 + 8100*D1*Dd*f*fd*s - 2430*D1*Dd*f*fd + 672*D1*Dd*f*g2*r**2 + 1344*D1*Dd*f*g2*r*s - 1008*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 1008*D1*Dd*f*g2*s + 504*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r**2 - 8064*D1*Dd*f*gd2*r*s + 7056*D1*Dd*f*gd2*r - 4032*D1*Dd*f*gd2*s**2 + 7056*D1*Dd*f*gd2*s - 3024*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r**2 - 8064*D1*Dd*fd*g2*r*s + 3024*D1*Dd*fd*g2*r - 4032*D1*Dd*fd*g2*s**2 + 3024*D1*Dd*fd*g2*s + 360*D1*Ddd*K*f**2*r**2 + 720*D1*Ddd*K*f**2*r*s - 540*D1*Ddd*K*f**2*r + 360*D1*Ddd*K*f**2*s**2 - 540*D1*Ddd*K*f**2*s + 270*D1*Ddd*K*f**2 + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 1050*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 525*D1*Ddd*f**3 - 1620*D1*Ddd*f**2*r**2 - 3240*D1*Ddd*f**2*r*s + 2430*D1*Ddd*f**2*r - 1620*D1*Ddd*f**2*s**2 + 2430*D1*Ddd*f**2*s - 1215*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r**2 - 4032*D1*Ddd*f*g2*r*s + 3024*D1*Ddd*f*g2*r - 2016*D1*Ddd*f*g2*s**2 + 3024*D1*Ddd*f*g2*s - 1512*D1*Ddd*f*g2 - 168*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 1080*Dd**2*K*f**2*r**2 + 2160*Dd**2*K*f**2*r*s - 1620*Dd**2*K*f**2*r + 1080*Dd**2*K*f**2*s**2 - 1620*Dd**2*K*f**2*s + 540*Dd**2*K*f**2 + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 3150*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 1050*Dd**2*f**3 - 4860*Dd**2*f**2*r**2 - 9720*Dd**2*f**2*r*s + 7290*Dd**2*f**2*r - 4860*Dd**2*f**2*s**2 + 7290*Dd**2*f**2*s - 2430*Dd**2*f**2 - 6048*Dd**2*f*g2*r**2 - 12096*Dd**2*f*g2*r*s + 9072*Dd**2*f*g2*r - 6048*Dd**2*f*g2*s**2 + 9072*Dd**2*f*g2*s - 3024*Dd**2*f*g2))/(105*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**3*k1**5*st**2*(1386*C*D1**2*f**2*fd*r*s - 462*C*D1**2*f**2*fd*r + 1386*C*D1**2*f**2*fd*s**2 - 1386*C*D1**2*f**2*fd*s + 462*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 1848*C*D1*Dd*f**3*r*s - 462*C*D1*Dd*f**3*r + 1848*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 462*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 7240*D1**2*f**3*fd*r*s - 1810*D1**2*f**3*fd*r + 7240*D1**2*f**3*fd*s**2 - 7240*D1**2*f**3*fd*s + 1810*D1**2*f**3*fd - 5600*D1**2*f**3*fdd*r*s + 1400*D1**2*f**3*fdd*r - 5600*D1**2*f**3*fdd*s**2 + 5600*D1**2*f**3*fdd*s - 1400*D1**2*f**3*fdd - 16800*D1**2*f**2*fd**2*r*s + 4200*D1**2*f**2*fd**2*r - 16800*D1**2*f**2*fd**2*s**2 + 16800*D1**2*f**2*fd**2*s - 2800*D1**2*f**2*fd**2 - 1386*D1**2*f**2*fd*r*s + 462*D1**2*f**2*fd*r - 1386*D1**2*f**2*fd*s**2 + 1386*D1**2*f**2*fd*s - 462*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*s**2 + 726*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 1452*D1**2*f*fd*g2*r*s + 726*D1**2*f*fd*g2*r - 1452*D1**2*f*fd*g2*s**2 + 1452*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 7240*D1*Dd*f**4*r*s - 1810*D1*Dd*f**4*r + 7240*D1*Dd*f**4*s**2 - 7240*D1*Dd*f**4*s + 1810*D1*Dd*f**4 - 44800*D1*Dd*f**3*fd*r*s + 11200*D1*Dd*f**3*fd*r - 44800*D1*Dd*f**3*fd*s**2 + 44800*D1*Dd*f**3*fd*s - 8400*D1*Dd*f**3*fd - 1848*D1*Dd*f**3*r*s + 462*D1*Dd*f**3*r - 1848*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 462*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 2904*D1*Dd*f**2*g2*r*s + 726*D1*Dd*f**2*g2*r - 2904*D1*Dd*f**2*g2*s**2 + 2904*D1*Dd*f**2*g2*s - 726*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 5600*D1*Ddd*f**4*r*s + 1400*D1*Ddd*f**4*r - 5600*D1*Ddd*f**4*s**2 + 5600*D1*Ddd*f**4*s - 1400*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 16800*Dd**2*f**4*r*s + 4200*Dd**2*f**4*r - 16800*Dd**2*f**4*s**2 + 16800*Dd**2*f**4*s - 2800*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k2*k3**6) + 2*D1**2*Pk2*Pk3*ct**3*k1**5*(360*C*D1**2*bdd1*f**2*r*s - 360*C*D1**2*bdd1*f**2*r + 360*C*D1**2*bdd1*f**2*s**2 - 720*C*D1**2*bdd1*f**2*s + 360*C*D1**2*bdd1*f**2 + 1680*C*D1**2*f**2*fd*r*s - 560*C*D1**2*f**2*fd*r + 1680*C*D1**2*f**2*fd*s**2 - 1680*C*D1**2*f**2*fd*s + 560*C*D1**2*f**2*fd - 1920*C*D1**2*f**2*fdd*r*s + 640*C*D1**2*f**2*fdd*r - 1920*C*D1**2*f**2*fdd*s**2 + 1920*C*D1**2*f**2*fdd*s - 640*C*D1**2*f**2*fdd - 3840*C*D1**2*f*fd**2*r*s + 1280*C*D1**2*f*fd**2*r - 3840*C*D1**2*f*fd**2*s**2 + 3840*C*D1**2*f*fd**2*s - 640*C*D1**2*f*fd**2 + 2240*C*D1*Dd*f**3*r*s - 560*C*D1*Dd*f**3*r + 2240*C*D1*Dd*f**3*s**2 - 2240*C*D1*Dd*f**3*s + 560*C*D1*Dd*f**3 - 15360*C*D1*Dd*f**2*fd*r*s + 4480*C*D1*Dd*f**2*fd*r - 15360*C*D1*Dd*f**2*fd*s**2 + 15360*C*D1*Dd*f**2*fd*s - 3200*C*D1*Dd*f**2*fd - 2560*C*D1*Ddd*f**3*r*s + 640*C*D1*Ddd*f**3*r - 2560*C*D1*Ddd*f**3*s**2 + 2560*C*D1*Ddd*f**3*s - 640*C*D1*Ddd*f**3 - 7680*C*Dd**2*f**3*r*s + 1920*C*Dd**2*f**3*r - 7680*C*Dd**2*f**3*s**2 + 7680*C*Dd**2*f**3*s - 1280*C*Dd**2*f**3 - 432*D1**2*K*bdd1*f**2*r*s - 432*D1**2*K*bdd1*f**2*s**2 + 432*D1**2*K*bdd1*f**2*s + 252*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 140*D1**2*bdd1*f**3*r**2 + 700*D1**2*bdd1*f**3*r*s - 700*D1**2*bdd1*f**3*r + 560*D1**2*bdd1*f**3*s**2 - 1120*D1**2*bdd1*f**3*s + 630*D1**2*bdd1*f**3 + 90*D1**2*bdd1*f**2*r**2 + 252*D1**2*bdd1*f**2*r*s + 180*D1**2*bdd1*f**2*r + 162*D1**2*bdd1*f**2*s**2 + 108*D1**2*bdd1*f**2*s - 270*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 504*D1**2*bdd1*f*g2*s**2 + 1008*D1**2*bdd1*f*g2*s - 504*D1**2*bdd1*f*g2 + 1260*D1**2*f**3*fd*r**2 + 6440*D1**2*f**3*fd*r*s - 2870*D1**2*f**3*fd*r + 5180*D1**2*f**3*fd*s**2 - 5810*D1**2*f**3*fd*s + 1925*D1**2*f**3*fd - 1540*D1**2*f**3*fdd*r**2 - 5880*D1**2*f**3*fdd*r*s + 3010*D1**2*f**3*fdd*r - 4340*D1**2*f**3*fdd*s**2 + 5110*D1**2*f**3*fdd*s - 1855*D1**2*f**3*fdd - 4620*D1**2*f**2*fd**2*r**2 - 17640*D1**2*f**2*fd**2*r*s + 9030*D1**2*f**2*fd**2*r - 13020*D1**2*f**2*fd**2*s**2 + 15330*D1**2*f**2*fd**2*s - 3710*D1**2*f**2*fd**2 - 150*D1**2*f**2*fd*r**2 - 1980*D1**2*f**2*fd*r*s + 760*D1**2*f**2*fd*r - 1830*D1**2*f**2*fd*s**2 + 1880*D1**2*f**2*fd*s - 660*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r**2 + 2340*D1**2*f**2*fdd*r*s - 920*D1**2*f**2*fdd*r + 2130*D1**2*f**2*fdd*s**2 - 2200*D1**2*f**2*fdd*s + 780*D1**2*f**2*fdd - 720*D1**2*f**2*gd2*r*s - 720*D1**2*f**2*gd2*s**2 + 720*D1**2*f**2*gd2*s + 864*D1**2*f**2*gdd2*r*s + 864*D1**2*f**2*gdd2*s**2 - 864*D1**2*f**2*gdd2*s + 420*D1**2*f*fd**2*r**2 + 4680*D1**2*f*fd**2*r*s - 1840*D1**2*f*fd**2*r + 4260*D1**2*f*fd**2*s**2 - 4400*D1**2*f*fd**2*s + 780*D1**2*f*fd**2 - 1440*D1**2*f*fd*g2*r*s + 720*D1**2*f*fd*g2*r - 1440*D1**2*f*fd*g2*s**2 + 1440*D1**2*f*fd*g2*s - 720*D1**2*f*fd*g2 + 3456*D1**2*f*fd*gd2*r*s - 864*D1**2*f*fd*gd2*r + 3456*D1**2*f*fd*gd2*s**2 - 3456*D1**2*f*fd*gd2*s + 864*D1**2*f*fd*gd2 + 1728*D1**2*f*fdd*g2*r*s - 864*D1**2*f*fdd*g2*r + 1728*D1**2*f*fdd*g2*s**2 - 1728*D1**2*f*fdd*g2*s + 864*D1**2*f*fdd*g2 + 1728*D1**2*fd**2*g2*r*s - 864*D1**2*fd**2*g2*r + 1728*D1**2*fd**2*g2*s**2 - 1728*D1**2*fd**2*g2*s + 1260*D1*Dd*f**4*r**2 + 6440*D1*Dd*f**4*r*s - 2870*D1*Dd*f**4*r + 5180*D1*Dd*f**4*s**2 - 5810*D1*Dd*f**4*s + 1925*D1*Dd*f**4 - 12320*D1*Dd*f**3*fd*r**2 - 47040*D1*Dd*f**3*fd*r*s + 24080*D1*Dd*f**3*fd*r - 34720*D1*Dd*f**3*fd*s**2 + 40880*D1*Dd*f**3*fd*s - 11130*D1*Dd*f**3*fd - 200*D1*Dd*f**3*r**2 - 2640*D1*Dd*f**3*r*s + 860*D1*Dd*f**3*r - 2440*D1*Dd*f**3*s**2 + 2540*D1*Dd*f**3*s - 710*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r**2 + 18720*D1*Dd*f**2*fd*r*s - 6860*D1*Dd*f**2*fd*r + 17040*D1*Dd*f**2*fd*s**2 - 17740*D1*Dd*f**2*fd*s + 4040*D1*Dd*f**2*fd - 2880*D1*Dd*f**2*g2*r*s + 720*D1*Dd*f**2*g2*r - 2880*D1*Dd*f**2*g2*s**2 + 2880*D1*Dd*f**2*g2*s - 720*D1*Dd*f**2*g2 + 6912*D1*Dd*f**2*gd2*r*s - 864*D1*Dd*f**2*gd2*r + 6912*D1*Dd*f**2*gd2*s**2 - 6912*D1*Dd*f**2*gd2*s + 864*D1*Dd*f**2*gd2 + 13824*D1*Dd*f*fd*g2*r*s - 5184*D1*Dd*f*fd*g2*r + 13824*D1*Dd*f*fd*g2*s**2 - 13824*D1*Dd*f*fd*g2*s + 3456*D1*Dd*f*fd*g2 - 1540*D1*Ddd*f**4*r**2 - 5880*D1*Ddd*f**4*r*s + 3010*D1*Ddd*f**4*r - 4340*D1*Ddd*f**4*s**2 + 5110*D1*Ddd*f**4*s - 1855*D1*Ddd*f**4 + 280*D1*Ddd*f**3*r**2 + 3120*D1*Ddd*f**3*r*s - 1060*D1*Ddd*f**3*r + 2840*D1*Ddd*f**3*s**2 - 2980*D1*Ddd*f**3*s + 850*D1*Ddd*f**3 + 3456*D1*Ddd*f**2*g2*r*s - 864*D1*Ddd*f**2*g2*r + 3456*D1*Ddd*f**2*g2*s**2 - 3456*D1*Ddd*f**2*g2*s + 864*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(5*f**3*(10*r**2 + 68*r*(s - 1) + 58*s**2 - 116*s + 63) + f**2*(108*C*(s - 1)*(r + s - 1) - 70*fd*(6*r**2 + 30*r*s - 19*r + 24*s**2 - 34*s + 9) + (9*r + 9*s - 9)*(-20*K*s + 3*r + 11*s + 9)) - 6*f*(3*fd*(10*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 12*K*(r*(4*s - 1) + (1 - 2*s)**2) + 10*r**2 + 28*r*s - 7*r + 18*s**2 - 13*s + 7) + (14*g2*(s - 1) + 14*gd2*(3 - 6*s))*(r + s - 1)) + 252*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*Dd*f*(35*f**2*(8*r**2 + r*(40*s - 29) + 32*s**2 - 50*s + 18) + 9*f*(10*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 12*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 20*r**2 + 56*r*s + 3*r + 36*s**2 - 11*s - 13) - 126*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 4620*Dd**2*f**4*r**2 - 17640*Dd**2*f**4*r*s + 9030*Dd**2*f**4*r - 13020*Dd**2*f**4*s**2 + 15330*Dd**2*f**4*s - 3710*Dd**2*f**4 + 840*Dd**2*f**3*r**2 + 9360*Dd**2*f**3*r*s - 3180*Dd**2*f**3*r + 8520*Dd**2*f**3*s**2 - 8940*Dd**2*f**3*s + 1700*Dd**2*f**3 + 10368*Dd**2*f**2*g2*r*s - 2592*Dd**2*f**2*g2*r + 10368*Dd**2*f**2*g2*s**2 - 10368*Dd**2*f**2*g2*s + 1728*Dd**2*f**2*g2 - 84*b1**2*(K - 1)*(D1**2*s*(fd - 3*fdd)*(r + s) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*fd*(-8*r*s + r + s*(4 - 8*s))) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 2*b1*(216*C*D1**2*f*fd*r*s + 216*C*D1**2*f*fd*s**2 - 108*C*D1**2*f*fd*s - 360*C*D1**2*f*fdd*r*s - 360*C*D1**2*f*fdd*s**2 + 180*C*D1**2*f*fdd*s - 360*C*D1**2*fd**2*r*s - 360*C*D1**2*fd**2*s**2 + 180*C*D1**2*fd**2*s + 432*C*D1*Dd*f**2*r*s - 108*C*D1*Dd*f**2*r + 432*C*D1*Dd*f**2*s**2 - 432*C*D1*Dd*f**2*s + 108*C*D1*Dd*f**2 - 2880*C*D1*Dd*f*fd*r*s + 360*C*D1*Dd*f*fd*r - 2880*C*D1*Dd*f*fd*s**2 + 2160*C*D1*Dd*f*fd*s - 180*C*D1*Dd*f*fd - 720*C*D1*Ddd*f**2*r*s + 180*C*D1*Ddd*f**2*r - 720*C*D1*Ddd*f**2*s**2 + 720*C*D1*Ddd*f**2*s - 180*C*D1*Ddd*f**2 - 2160*C*Dd**2*f**2*r*s + 540*C*Dd**2*f**2*r - 2160*C*Dd**2*f**2*s**2 + 2160*C*Dd**2*f**2*s - 360*C*Dd**2*f**2 - 360*D1**2*K*f*fd*r*s + 180*D1**2*K*f*fd*r - 360*D1**2*K*f*fd*s**2 + 360*D1**2*K*f*fd*s - 180*D1**2*K*f*fd + 432*D1**2*K*f*fdd*r*s - 216*D1**2*K*f*fdd*r + 432*D1**2*K*f*fdd*s**2 - 432*D1**2*K*f*fdd*s + 216*D1**2*K*f*fdd + 432*D1**2*K*fd**2*r*s - 216*D1**2*K*fd**2*r + 432*D1**2*K*fd**2*s**2 - 432*D1**2*K*fd**2*s - 126*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 150*D1**2*f**2*fd*r**2 + 1020*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 870*D1**2*f**2*fd*s**2 - 680*D1**2*f**2*fd*s + 75*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 1050*D1**2*f**2*fdd*r*s + 280*D1**2*f**2*fdd*r - 840*D1**2*f**2*fdd*s**2 + 700*D1**2*f**2*fdd*s - 105*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 - 2100*D1**2*f*fd**2*r*s + 560*D1**2*f*fd**2*r - 1680*D1**2*f*fd**2*s**2 + 1400*D1**2*f*fd**2*s - 210*D1**2*f*fd**2 + 54*D1**2*f*fd*r**2 + 252*D1**2*f*fd*r*s - 234*D1**2*f*fd*r + 198*D1**2*f*fd*s**2 - 306*D1**2*f*fd*s + 207*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 252*D1**2*f*fdd*r*s + 306*D1**2*f*fdd*r - 162*D1**2*f*fdd*s**2 + 342*D1**2*f*fdd*s - 261*D1**2*f*fdd - 84*D1**2*f*gd2*r*s - 84*D1**2*f*gd2*s**2 + 84*D1**2*f*gd2*s + 252*D1**2*f*gdd2*r*s + 252*D1**2*f*gdd2*s**2 - 252*D1**2*f*gdd2*s - 90*D1**2*fd**2*r**2 - 252*D1**2*fd**2*r*s + 306*D1**2*fd**2*r - 162*D1**2*fd**2*s**2 + 342*D1**2*fd**2*s - 84*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*s**2 + 504*D1**2*fd*gd2*r*s + 504*D1**2*fd*gd2*s**2 - 252*D1**2*fd*gd2*s + 252*D1**2*fdd*g2*r*s + 252*D1**2*fdd*g2*s**2 - 720*D1*Dd*K*f**2*r*s + 180*D1*Dd*K*f**2*r - 720*D1*Dd*K*f**2*s**2 + 720*D1*Dd*K*f**2*s - 180*D1*Dd*K*f**2 + 3456*D1*Dd*K*f*fd*r*s - 1296*D1*Dd*K*f*fd*r + 3456*D1*Dd*K*f*fd*s**2 - 3456*D1*Dd*K*f*fd*s + 864*D1*Dd*K*f*fd + 200*D1*Dd*f**3*r**2 + 1360*D1*Dd*f**3*r*s - 540*D1*Dd*f**3*r + 1160*D1*Dd*f**3*s**2 - 1260*D1*Dd*f**3*s + 390*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 8400*D1*Dd*f**2*fd*r*s + 3010*D1*Dd*f**2*fd*r - 6720*D1*Dd*f**2*fd*s**2 + 6580*D1*Dd*f**2*fd*s - 1260*D1*Dd*f**2*fd + 108*D1*Dd*f**2*r**2 + 504*D1*Dd*f**2*r*s - 234*D1*Dd*f**2*r + 396*D1*Dd*f**2*s**2 - 450*D1*Dd*f**2*s + 153*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 2016*D1*Dd*f*fd*r*s + 1836*D1*Dd*f*fd*r - 1296*D1*Dd*f*fd*s**2 + 2196*D1*Dd*f*fd*s - 954*D1*Dd*f*fd - 336*D1*Dd*f*g2*r*s + 84*D1*Dd*f*g2*r - 336*D1*Dd*f*g2*s**2 + 336*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 2016*D1*Dd*f*gd2*r*s - 252*D1*Dd*f*gd2*r + 2016*D1*Dd*f*gd2*s**2 - 2016*D1*Dd*f*gd2*s + 252*D1*Dd*f*gd2 + 2016*D1*Dd*fd*g2*r*s - 252*D1*Dd*fd*g2*r + 2016*D1*Dd*fd*g2*s**2 - 1008*D1*Dd*fd*g2*s + 864*D1*Ddd*K*f**2*r*s - 216*D1*Ddd*K*f**2*r + 864*D1*Ddd*K*f**2*s**2 - 864*D1*Ddd*K*f**2*s + 216*D1*Ddd*K*f**2 - 280*D1*Ddd*f**3*r**2 - 1400*D1*Ddd*f**3*r*s + 630*D1*Ddd*f**3*r - 1120*D1*Ddd*f**3*s**2 + 1260*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 180*D1*Ddd*f**2*r**2 - 504*D1*Ddd*f**2*r*s + 306*D1*Ddd*f**2*r - 324*D1*Ddd*f**2*s**2 + 414*D1*Ddd*f**2*s - 171*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r*s - 252*D1*Ddd*f*g2*r + 1008*D1*Ddd*f*g2*s**2 - 1008*D1*Ddd*f*g2*s + 252*D1*Ddd*f*g2 + 42*D1*bd1*(K - 1)*(D1*(f*(2*s - 1)*(r + s - 1) + 3*fd*(-4*r*s + r + s*(3 - 4*s))) - 3*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 2592*Dd**2*K*f**2*r*s - 648*Dd**2*K*f**2*r + 2592*Dd**2*K*f**2*s**2 - 2592*Dd**2*K*f**2*s + 432*Dd**2*K*f**2 - 840*Dd**2*f**3*r**2 - 4200*Dd**2*f**3*r*s + 1890*Dd**2*f**3*r - 3360*Dd**2*f**3*s**2 + 3780*Dd**2*f**3*s - 840*Dd**2*f**3 - 540*Dd**2*f**2*r**2 - 1512*Dd**2*f**2*r*s + 918*Dd**2*f**2*r - 972*Dd**2*f**2*s**2 + 1242*Dd**2*f**2*s - 342*Dd**2*f**2 + 3024*Dd**2*f*g2*r*s - 756*Dd**2*f*g2*r + 3024*Dd**2*f*g2*s**2 - 3024*Dd**2*f*g2*s + 504*Dd**2*f*g2))/(315*d**2*k2*k3**6) - 4*D1**2*Pk2*Pk3*ct**3*k1**3*k2**3*st**4*(2244*C*D1**2*f**2*fd*r**2 + 4488*C*D1**2*f**2*fd*r*s - 2992*C*D1**2*f**2*fd*r + 2244*C*D1**2*f**2*fd*s**2 - 2992*C*D1**2*f**2*fd*s + 1496*C*D1**2*f**2*fd - 1320*C*D1**2*f**2*fdd*r**2 - 2640*C*D1**2*f**2*fdd*r*s + 1760*C*D1**2*f**2*fdd*r - 1320*C*D1**2*f**2*fdd*s**2 + 1760*C*D1**2*f**2*fdd*s - 880*C*D1**2*f**2*fdd - 2640*C*D1**2*f*fd**2*r**2 - 5280*C*D1**2*f*fd**2*r*s + 3520*C*D1**2*f*fd**2*r - 2640*C*D1**2*f*fd**2*s**2 + 3520*C*D1**2*f*fd**2*s - 880*C*D1**2*f*fd**2 + 2992*C*D1*Dd*f**3*r**2 + 5984*C*D1*Dd*f**3*r*s - 4488*C*D1*Dd*f**3*r + 2992*C*D1*Dd*f**3*s**2 - 4488*C*D1*Dd*f**3*s + 2244*C*D1*Dd*f**3 - 10560*C*D1*Dd*f**2*fd*r**2 - 21120*C*D1*Dd*f**2*fd*r*s + 14960*C*D1*Dd*f**2*fd*r - 10560*C*D1*Dd*f**2*fd*s**2 + 14960*C*D1*Dd*f**2*fd*s - 5280*C*D1*Dd*f**2*fd - 1760*C*D1*Ddd*f**3*r**2 - 3520*C*D1*Ddd*f**3*r*s + 2640*C*D1*Ddd*f**3*r - 1760*C*D1*Ddd*f**3*s**2 + 2640*C*D1*Ddd*f**3*s - 1320*C*D1*Ddd*f**3 - 5280*C*Dd**2*f**3*r**2 - 10560*C*Dd**2*f**3*r*s + 7920*C*Dd**2*f**3*r - 5280*C*Dd**2*f**3*s**2 + 7920*C*Dd**2*f**3*s - 2640*C*Dd**2*f**3 + 1716*D1**2*K*b1*f*fd*r**2 + 3432*D1**2*K*b1*f*fd*r*s - 1716*D1**2*K*b1*f*fd*r + 1716*D1**2*K*b1*f*fd*s**2 - 1716*D1**2*K*b1*f*fd*s + 858*D1**2*K*b1*f*fd - 1320*D1**2*K*b1*f*fdd*r**2 - 2640*D1**2*K*b1*f*fdd*r*s + 1320*D1**2*K*b1*f*fdd*r - 1320*D1**2*K*b1*f*fdd*s**2 + 1320*D1**2*K*b1*f*fdd*s - 660*D1**2*K*b1*f*fdd - 1320*D1**2*K*b1*fd**2*r**2 - 2640*D1**2*K*b1*fd**2*r*s + 1320*D1**2*K*b1*fd**2*r - 1320*D1**2*K*b1*fd**2*s**2 + 1320*D1**2*K*b1*fd**2*s - 1716*D1**2*b1*f*fd*r**2 - 3432*D1**2*b1*f*fd*r*s + 1716*D1**2*b1*f*fd*r - 1716*D1**2*b1*f*fd*s**2 + 1716*D1**2*b1*f*fd*s - 858*D1**2*b1*f*fd + 1320*D1**2*b1*f*fdd*r**2 + 2640*D1**2*b1*f*fdd*r*s - 1320*D1**2*b1*f*fdd*r + 1320*D1**2*b1*f*fdd*s**2 - 1320*D1**2*b1*f*fdd*s + 660*D1**2*b1*f*fdd + 1320*D1**2*b1*fd**2*r**2 + 2640*D1**2*b1*fd**2*r*s - 1320*D1**2*b1*fd**2*r + 1320*D1**2*b1*fd**2*s**2 - 1320*D1**2*b1*fd**2*s - 660*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 5680*D1**2*f**3*fd*r**2 + 11360*D1**2*f**3*fd*r*s - 8520*D1**2*f**3*fd*r + 5680*D1**2*f**3*fd*s**2 - 8520*D1**2*f**3*fd*s + 4260*D1**2*f**3*fd - 3500*D1**2*f**3*fdd*r**2 - 7000*D1**2*f**3*fdd*r*s + 5250*D1**2*f**3*fdd*r - 3500*D1**2*f**3*fdd*s**2 + 5250*D1**2*f**3*fdd*s - 2625*D1**2*f**3*fdd - 10500*D1**2*f**2*fd**2*r**2 - 21000*D1**2*f**2*fd**2*r*s + 15750*D1**2*f**2*fd**2*r - 10500*D1**2*f**2*fd**2*s**2 + 15750*D1**2*f**2*fd**2*s - 5250*D1**2*f**2*fd**2 - 2244*D1**2*f**2*fd*r**2 - 4488*D1**2*f**2*fd*r*s + 2992*D1**2*f**2*fd*r - 2244*D1**2*f**2*fd*s**2 + 2992*D1**2*f**2*fd*s - 1496*D1**2*f**2*fd + 1320*D1**2*f**2*fdd*r**2 + 2640*D1**2*f**2*fdd*r*s - 1760*D1**2*f**2*fdd*r + 1320*D1**2*f**2*fdd*s**2 - 1760*D1**2*f**2*fdd*s + 880*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 2640*D1**2*f*fd**2*r**2 + 5280*D1**2*f*fd**2*r*s - 3520*D1**2*f*fd**2*r + 2640*D1**2*f*fd**2*s**2 - 3520*D1**2*f*fd**2*s + 880*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s + 3432*D1*Dd*K*b1*f**2*r**2 + 6864*D1*Dd*K*b1*f**2*r*s - 5148*D1*Dd*K*b1*f**2*r + 3432*D1*Dd*K*b1*f**2*s**2 - 5148*D1*Dd*K*b1*f**2*s + 2574*D1*Dd*K*b1*f**2 - 10560*D1*Dd*K*b1*f*fd*r**2 - 21120*D1*Dd*K*b1*f*fd*r*s + 13200*D1*Dd*K*b1*f*fd*r - 10560*D1*Dd*K*b1*f*fd*s**2 + 13200*D1*Dd*K*b1*f*fd*s - 3960*D1*Dd*K*b1*f*fd - 3432*D1*Dd*b1*f**2*r**2 - 6864*D1*Dd*b1*f**2*r*s + 5148*D1*Dd*b1*f**2*r - 3432*D1*Dd*b1*f**2*s**2 + 5148*D1*Dd*b1*f**2*s - 2574*D1*Dd*b1*f**2 + 10560*D1*Dd*b1*f*fd*r**2 + 21120*D1*Dd*b1*f*fd*r*s - 13200*D1*Dd*b1*f*fd*r + 10560*D1*Dd*b1*f*fd*s**2 - 13200*D1*Dd*b1*f*fd*s + 3960*D1*Dd*b1*f*fd + 5680*D1*Dd*f**4*r**2 + 11360*D1*Dd*f**4*r*s - 8520*D1*Dd*f**4*r + 5680*D1*Dd*f**4*s**2 - 8520*D1*Dd*f**4*s + 4260*D1*Dd*f**4 - 28000*D1*Dd*f**3*fd*r**2 - 56000*D1*Dd*f**3*fd*r*s + 42000*D1*Dd*f**3*fd*r - 28000*D1*Dd*f**3*fd*s**2 + 42000*D1*Dd*f**3*fd*s - 15750*D1*Dd*f**3*fd - 2992*D1*Dd*f**3*r**2 - 5984*D1*Dd*f**3*r*s + 4488*D1*Dd*f**3*r - 2992*D1*Dd*f**3*s**2 + 4488*D1*Dd*f**3*s - 2244*D1*Dd*f**3 + 10560*D1*Dd*f**2*fd*r**2 + 21120*D1*Dd*f**2*fd*r*s - 14960*D1*Dd*f**2*fd*r + 10560*D1*Dd*f**2*fd*s**2 - 14960*D1*Dd*f**2*fd*s + 5280*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 - 2640*D1*Ddd*K*b1*f**2*r**2 - 5280*D1*Ddd*K*b1*f**2*r*s + 3960*D1*Ddd*K*b1*f**2*r - 2640*D1*Ddd*K*b1*f**2*s**2 + 3960*D1*Ddd*K*b1*f**2*s - 1980*D1*Ddd*K*b1*f**2 + 2640*D1*Ddd*b1*f**2*r**2 + 5280*D1*Ddd*b1*f**2*r*s - 3960*D1*Ddd*b1*f**2*r + 2640*D1*Ddd*b1*f**2*s**2 - 3960*D1*Ddd*b1*f**2*s + 1980*D1*Ddd*b1*f**2 - 3500*D1*Ddd*f**4*r**2 - 7000*D1*Ddd*f**4*r*s + 5250*D1*Ddd*f**4*r - 3500*D1*Ddd*f**4*s**2 + 5250*D1*Ddd*f**4*s - 2625*D1*Ddd*f**4 + 1760*D1*Ddd*f**3*r**2 + 3520*D1*Ddd*f**3*r*s - 2640*D1*Ddd*f**3*r + 1760*D1*Ddd*f**3*s**2 - 2640*D1*Ddd*f**3*s + 1320*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(K - 1)*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 7920*Dd**2*K*b1*f**2*r**2 - 15840*Dd**2*K*b1*f**2*r*s + 11880*Dd**2*K*b1*f**2*r - 7920*Dd**2*K*b1*f**2*s**2 + 11880*Dd**2*K*b1*f**2*s - 3960*Dd**2*K*b1*f**2 + 7920*Dd**2*b1*f**2*r**2 + 15840*Dd**2*b1*f**2*r*s - 11880*Dd**2*b1*f**2*r + 7920*Dd**2*b1*f**2*s**2 - 11880*Dd**2*b1*f**2*s + 3960*Dd**2*b1*f**2 - 10500*Dd**2*f**4*r**2 - 21000*Dd**2*f**4*r*s + 15750*Dd**2*f**4*r - 10500*Dd**2*f**4*s**2 + 15750*Dd**2*f**4*s - 5250*Dd**2*f**4 + 5280*Dd**2*f**3*r**2 + 10560*Dd**2*f**3*r*s - 7920*Dd**2*f**3*r + 5280*Dd**2*f**3*s**2 - 7920*Dd**2*f**3*s + 2640*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2)/(385*d**2*k3**8) - 8*D1**2*Pk2*Pk3*ct**3*k1**3*k2**3*st**2*(-108*C*D1**2*bdd1*f**2*r**2 - 216*C*D1**2*bdd1*f**2*r*s + 216*C*D1**2*bdd1*f**2*r - 108*C*D1**2*bdd1*f**2*s**2 + 216*C*D1**2*bdd1*f**2*s - 108*C*D1**2*bdd1*f**2 + 1026*C*D1**2*f**2*fd*r**2 + 2052*C*D1**2*f**2*fd*r*s - 1368*C*D1**2*f**2*fd*r + 1026*C*D1**2*f**2*fd*s**2 - 1368*C*D1**2*f**2*fd*s + 684*C*D1**2*f**2*fd - 1080*C*D1**2*f**2*fdd*r**2 - 2160*C*D1**2*f**2*fdd*r*s + 1440*C*D1**2*f**2*fdd*r - 1080*C*D1**2*f**2*fdd*s**2 + 1440*C*D1**2*f**2*fdd*s - 720*C*D1**2*f**2*fdd - 2160*C*D1**2*f*fd**2*r**2 - 4320*C*D1**2*f*fd**2*r*s + 2880*C*D1**2*f*fd**2*r - 2160*C*D1**2*f*fd**2*s**2 + 2880*C*D1**2*f*fd**2*s - 720*C*D1**2*f*fd**2 + 1368*C*D1*Dd*f**3*r**2 + 2736*C*D1*Dd*f**3*r*s - 2052*C*D1*Dd*f**3*r + 1368*C*D1*Dd*f**3*s**2 - 2052*C*D1*Dd*f**3*s + 1026*C*D1*Dd*f**3 - 8640*C*D1*Dd*f**2*fd*r**2 - 17280*C*D1*Dd*f**2*fd*r*s + 12240*C*D1*Dd*f**2*fd*r - 8640*C*D1*Dd*f**2*fd*s**2 + 12240*C*D1*Dd*f**2*fd*s - 4320*C*D1*Dd*f**2*fd - 1440*C*D1*Ddd*f**3*r**2 - 2880*C*D1*Ddd*f**3*r*s + 2160*C*D1*Ddd*f**3*r - 1440*C*D1*Ddd*f**3*s**2 + 2160*C*D1*Ddd*f**3*s - 1080*C*D1*Ddd*f**3 - 4320*C*Dd**2*f**3*r**2 - 8640*C*Dd**2*f**3*r*s + 6480*C*Dd**2*f**3*r - 4320*C*Dd**2*f**3*s**2 + 6480*C*Dd**2*f**3*s - 2160*C*Dd**2*f**3 - 324*D1**2*K*bdd1*f**2*r**2 - 648*D1**2*K*bdd1*f**2*r*s + 648*D1**2*K*bdd1*f**2*r - 324*D1**2*K*bdd1*f**2*s**2 + 648*D1**2*K*bdd1*f**2*s - 324*D1**2*K*bdd1*f**2 - 252*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 125*D1**2*bdd1*f**3*r**2 + 250*D1**2*bdd1*f**3*r*s - 250*D1**2*bdd1*f**3*r + 125*D1**2*bdd1*f**3*s**2 - 250*D1**2*bdd1*f**3*s + 125*D1**2*bdd1*f**3 + 270*D1**2*bdd1*f**2*r**2 + 540*D1**2*bdd1*f**2*r*s - 540*D1**2*bdd1*f**2*r + 270*D1**2*bdd1*f**2*s**2 - 540*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s - 504*D1**2*bdd1*f*g2*r + 252*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 - 300*D1**2*f**3*fd*r**2 - 600*D1**2*f**3*fd*r*s + 450*D1**2*f**3*fd*r - 300*D1**2*f**3*fd*s**2 + 450*D1**2*f**3*fd*s - 225*D1**2*f**3*fd - 729*D1**2*f**2*fd*r**2 - 1458*D1**2*f**2*fd*r*s + 972*D1**2*f**2*fd*r - 729*D1**2*f**2*fd*s**2 + 972*D1**2*f**2*fd*s - 486*D1**2*f**2*fd + 810*D1**2*f**2*fdd*r**2 + 1620*D1**2*f**2*fdd*r*s - 1080*D1**2*f**2*fdd*r + 810*D1**2*f**2*fdd*s**2 - 1080*D1**2*f**2*fdd*s + 540*D1**2*f**2*fdd - 414*D1**2*f**2*gd2*r**2 - 828*D1**2*f**2*gd2*r*s + 828*D1**2*f**2*gd2*r - 414*D1**2*f**2*gd2*s**2 + 828*D1**2*f**2*gd2*s - 414*D1**2*f**2*gd2 + 648*D1**2*f**2*gdd2*r**2 + 1296*D1**2*f**2*gdd2*r*s - 1296*D1**2*f**2*gdd2*r + 648*D1**2*f**2*gdd2*s**2 - 1296*D1**2*f**2*gdd2*s + 648*D1**2*f**2*gdd2 + 1620*D1**2*f*fd**2*r**2 + 3240*D1**2*f*fd**2*r*s - 2160*D1**2*f*fd**2*r + 1620*D1**2*f*fd**2*s**2 - 2160*D1**2*f*fd**2*s + 540*D1**2*f*fd**2 - 828*D1**2*f*fd*g2*r**2 - 1656*D1**2*f*fd*g2*r*s + 828*D1**2*f*fd*g2*r - 828*D1**2*f*fd*g2*s**2 + 828*D1**2*f*fd*g2*s - 414*D1**2*f*fd*g2 + 2592*D1**2*f*fd*gd2*r**2 + 5184*D1**2*f*fd*gd2*r*s - 3888*D1**2*f*fd*gd2*r + 2592*D1**2*f*fd*gd2*s**2 - 3888*D1**2*f*fd*gd2*s + 1296*D1**2*f*fd*gd2 + 1296*D1**2*f*fdd*g2*r**2 + 2592*D1**2*f*fdd*g2*r*s - 1296*D1**2*f*fdd*g2*r + 1296*D1**2*f*fdd*g2*s**2 - 1296*D1**2*f*fdd*g2*s + 648*D1**2*f*fdd*g2 + 1296*D1**2*fd**2*g2*r**2 + 2592*D1**2*fd**2*g2*r*s - 1296*D1**2*fd**2*g2*r + 1296*D1**2*fd**2*g2*s**2 - 1296*D1**2*fd**2*g2*s - 300*D1*Dd*f**4*r**2 - 600*D1*Dd*f**4*r*s + 450*D1*Dd*f**4*r - 300*D1*Dd*f**4*s**2 + 450*D1*Dd*f**4*s - 225*D1*Dd*f**4 - 972*D1*Dd*f**3*r**2 - 1944*D1*Dd*f**3*r*s + 1458*D1*Dd*f**3*r - 972*D1*Dd*f**3*s**2 + 1458*D1*Dd*f**3*s - 729*D1*Dd*f**3 + 6480*D1*Dd*f**2*fd*r**2 + 12960*D1*Dd*f**2*fd*r*s - 9180*D1*Dd*f**2*fd*r + 6480*D1*Dd*f**2*fd*s**2 - 9180*D1*Dd*f**2*fd*s + 3240*D1*Dd*f**2*fd - 1656*D1*Dd*f**2*g2*r**2 - 3312*D1*Dd*f**2*g2*r*s + 2484*D1*Dd*f**2*g2*r - 1656*D1*Dd*f**2*g2*s**2 + 2484*D1*Dd*f**2*g2*s - 1242*D1*Dd*f**2*g2 + 5184*D1*Dd*f**2*gd2*r**2 + 10368*D1*Dd*f**2*gd2*r*s - 9072*D1*Dd*f**2*gd2*r + 5184*D1*Dd*f**2*gd2*s**2 - 9072*D1*Dd*f**2*gd2*s + 3888*D1*Dd*f**2*gd2 + 10368*D1*Dd*f*fd*g2*r**2 + 20736*D1*Dd*f*fd*g2*r*s - 12960*D1*Dd*f*fd*g2*r + 10368*D1*Dd*f*fd*g2*s**2 - 12960*D1*Dd*f*fd*g2*s + 3888*D1*Dd*f*fd*g2 + 1080*D1*Ddd*f**3*r**2 + 2160*D1*Ddd*f**3*r*s - 1620*D1*Ddd*f**3*r + 1080*D1*Ddd*f**3*s**2 - 1620*D1*Ddd*f**3*s + 810*D1*Ddd*f**3 + 2592*D1*Ddd*f**2*g2*r**2 + 5184*D1*Ddd*f**2*g2*r*s - 3888*D1*Ddd*f**2*g2*r + 2592*D1*Ddd*f**2*g2*s**2 - 3888*D1*Ddd*f**2*g2*s + 1944*D1*Ddd*f**2*g2 - D1*bd1*(D1*(97*f**3*(r + s - 1) - f**2*(174*C*(r + s - 1) + 250*fd*(3*r + 3*s - 2) + (207*K - 246)*(r + s - 1)) + 6*f*(18*fd*(2*C + 6*K - 5)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) - 504*fd*g2*(r + s)) - 2*Dd*f*(125*f**2 - 54*f*(2*C + 6*K - 5) + 252*g2)*(4*r + 4*s - 3))*(r + s - 1) + 3240*Dd**2*f**3*r**2 + 6480*Dd**2*f**3*r*s - 4860*Dd**2*f**3*r + 3240*Dd**2*f**3*s**2 - 4860*Dd**2*f**3*s + 1620*Dd**2*f**3 + 7776*Dd**2*f**2*g2*r**2 + 15552*Dd**2*f**2*g2*r*s - 11664*Dd**2*f**2*g2*r + 7776*Dd**2*f**2*g2*s**2 - 11664*Dd**2*f**2*g2*s + 3888*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(348*C*D1**2*f*fd*r**2 + 696*C*D1**2*f*fd*r*s - 348*C*D1**2*f*fd*r + 348*C*D1**2*f*fd*s**2 - 348*C*D1**2*f*fd*s + 174*C*D1**2*f*fd - 216*C*D1**2*f*fdd*r**2 - 432*C*D1**2*f*fdd*r*s + 216*C*D1**2*f*fdd*r - 216*C*D1**2*f*fdd*s**2 + 216*C*D1**2*f*fdd*s - 108*C*D1**2*f*fdd - 216*C*D1**2*fd**2*r**2 - 432*C*D1**2*fd**2*r*s + 216*C*D1**2*fd**2*r - 216*C*D1**2*fd**2*s**2 + 216*C*D1**2*fd**2*s + 696*C*D1*Dd*f**2*r**2 + 1392*C*D1*Dd*f**2*r*s - 1044*C*D1*Dd*f**2*r + 696*C*D1*Dd*f**2*s**2 - 1044*C*D1*Dd*f**2*s + 522*C*D1*Dd*f**2 - 1728*C*D1*Dd*f*fd*r**2 - 3456*C*D1*Dd*f*fd*r*s + 2160*C*D1*Dd*f*fd*r - 1728*C*D1*Dd*f*fd*s**2 + 2160*C*D1*Dd*f*fd*s - 648*C*D1*Dd*f*fd - 432*C*D1*Ddd*f**2*r**2 - 864*C*D1*Ddd*f**2*r*s + 648*C*D1*Ddd*f**2*r - 432*C*D1*Ddd*f**2*s**2 + 648*C*D1*Ddd*f**2*s - 324*C*D1*Ddd*f**2 - 1296*C*Dd**2*f**2*r**2 - 2592*C*Dd**2*f**2*r*s + 1944*C*Dd**2*f**2*r - 1296*C*Dd**2*f**2*s**2 + 1944*C*Dd**2*f**2*s - 648*C*Dd**2*f**2 + 414*D1**2*K*f*fd*r**2 + 828*D1**2*K*f*fd*r*s - 414*D1**2*K*f*fd*r + 414*D1**2*K*f*fd*s**2 - 414*D1**2*K*f*fd*s + 207*D1**2*K*f*fd - 648*D1**2*K*f*fdd*r**2 - 1296*D1**2*K*f*fdd*r*s + 648*D1**2*K*f*fdd*r - 648*D1**2*K*f*fdd*s**2 + 648*D1**2*K*f*fdd*s - 324*D1**2*K*f*fdd - 648*D1**2*K*fd**2*r**2 - 1296*D1**2*K*fd**2*r*s + 648*D1**2*K*fd**2*r - 648*D1**2*K*fd**2*s**2 + 648*D1**2*K*fd**2*s - 252*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 291*D1**2*f**2*fd*r**2 - 582*D1**2*f**2*fd*r*s + 388*D1**2*f**2*fd*r - 291*D1**2*f**2*fd*s**2 + 388*D1**2*f**2*fd*s - 194*D1**2*f**2*fd + 375*D1**2*f**2*fdd*r**2 + 750*D1**2*f**2*fdd*r*s - 500*D1**2*f**2*fdd*r + 375*D1**2*f**2*fdd*s**2 - 500*D1**2*f**2*fdd*s + 250*D1**2*f**2*fdd + 750*D1**2*f*fd**2*r**2 + 1500*D1**2*f*fd**2*r*s - 1000*D1**2*f*fd**2*r + 750*D1**2*f*fd**2*s**2 - 1000*D1**2*f*fd**2*s + 250*D1**2*f*fd**2 - 492*D1**2*f*fd*r**2 - 984*D1**2*f*fd*r*s + 492*D1**2*f*fd*r - 492*D1**2*f*fd*s**2 + 492*D1**2*f*fd*s - 246*D1**2*f*fd + 540*D1**2*f*fdd*r**2 + 1080*D1**2*f*fdd*r*s - 540*D1**2*f*fdd*r + 540*D1**2*f*fdd*s**2 - 540*D1**2*f*fdd*s + 270*D1**2*f*fdd - 294*D1**2*f*gd2*r**2 - 588*D1**2*f*gd2*r*s + 588*D1**2*f*gd2*r - 294*D1**2*f*gd2*s**2 + 588*D1**2*f*gd2*s - 294*D1**2*f*gd2 + 252*D1**2*f*gdd2*r**2 + 504*D1**2*f*gdd2*r*s - 504*D1**2*f*gdd2*r + 252*D1**2*f*gdd2*s**2 - 504*D1**2*f*gdd2*s + 252*D1**2*f*gdd2 + 540*D1**2*fd**2*r**2 + 1080*D1**2*fd**2*r*s - 540*D1**2*fd**2*r + 540*D1**2*fd**2*s**2 - 540*D1**2*fd**2*s - 294*D1**2*fd*g2*r**2 - 588*D1**2*fd*g2*r*s - 294*D1**2*fd*g2*s**2 + 504*D1**2*fd*gd2*r**2 + 1008*D1**2*fd*gd2*r*s - 504*D1**2*fd*gd2*r + 504*D1**2*fd*gd2*s**2 - 504*D1**2*fd*gd2*s + 252*D1**2*fdd*g2*r**2 + 504*D1**2*fdd*g2*r*s + 252*D1**2*fdd*g2*s**2 + 828*D1*Dd*K*f**2*r**2 + 1656*D1*Dd*K*f**2*r*s - 1242*D1*Dd*K*f**2*r + 828*D1*Dd*K*f**2*s**2 - 1242*D1*Dd*K*f**2*s + 621*D1*Dd*K*f**2 - 5184*D1*Dd*K*f*fd*r**2 - 10368*D1*Dd*K*f*fd*r*s + 6480*D1*Dd*K*f*fd*r - 5184*D1*Dd*K*f*fd*s**2 + 6480*D1*Dd*K*f*fd*s - 1944*D1*Dd*K*f*fd - 388*D1*Dd*f**3*r**2 - 776*D1*Dd*f**3*r*s + 582*D1*Dd*f**3*r - 388*D1*Dd*f**3*s**2 + 582*D1*Dd*f**3*s - 291*D1*Dd*f**3 + 3000*D1*Dd*f**2*fd*r**2 + 6000*D1*Dd*f**2*fd*r*s - 4250*D1*Dd*f**2*fd*r + 3000*D1*Dd*f**2*fd*s**2 - 4250*D1*Dd*f**2*fd*s + 1500*D1*Dd*f**2*fd - 984*D1*Dd*f**2*r**2 - 1968*D1*Dd*f**2*r*s + 1476*D1*Dd*f**2*r - 984*D1*Dd*f**2*s**2 + 1476*D1*Dd*f**2*s - 738*D1*Dd*f**2 + 4320*D1*Dd*f*fd*r**2 + 8640*D1*Dd*f*fd*r*s - 5400*D1*Dd*f*fd*r + 4320*D1*Dd*f*fd*s**2 - 5400*D1*Dd*f*fd*s + 1620*D1*Dd*f*fd - 1176*D1*Dd*f*g2*r**2 - 2352*D1*Dd*f*g2*r*s + 1764*D1*Dd*f*g2*r - 1176*D1*Dd*f*g2*s**2 + 1764*D1*Dd*f*g2*s - 882*D1*Dd*f*g2 + 2016*D1*Dd*f*gd2*r**2 + 4032*D1*Dd*f*gd2*r*s - 3528*D1*Dd*f*gd2*r + 2016*D1*Dd*f*gd2*s**2 - 3528*D1*Dd*f*gd2*s + 1512*D1*Dd*f*gd2 + 2016*D1*Dd*fd*g2*r**2 + 4032*D1*Dd*fd*g2*r*s - 1512*D1*Dd*fd*g2*r + 2016*D1*Dd*fd*g2*s**2 - 1512*D1*Dd*fd*g2*s - 1296*D1*Ddd*K*f**2*r**2 - 2592*D1*Ddd*K*f**2*r*s + 1944*D1*Ddd*K*f**2*r - 1296*D1*Ddd*K*f**2*s**2 + 1944*D1*Ddd*K*f**2*s - 972*D1*Ddd*K*f**2 + 500*D1*Ddd*f**3*r**2 + 1000*D1*Ddd*f**3*r*s - 750*D1*Ddd*f**3*r + 500*D1*Ddd*f**3*s**2 - 750*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 + 1080*D1*Ddd*f**2*r**2 + 2160*D1*Ddd*f**2*r*s - 1620*D1*Ddd*f**2*r + 1080*D1*Ddd*f**2*s**2 - 1620*D1*Ddd*f**2*s + 810*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r**2 + 2016*D1*Ddd*f*g2*r*s - 1512*D1*Ddd*f*g2*r + 1008*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 756*D1*Ddd*f*g2 + 42*D1*bd1*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3888*Dd**2*K*f**2*r**2 - 7776*Dd**2*K*f**2*r*s + 5832*Dd**2*K*f**2*r - 3888*Dd**2*K*f**2*s**2 + 5832*Dd**2*K*f**2*s - 1944*Dd**2*K*f**2 + 1500*Dd**2*f**3*r**2 + 3000*Dd**2*f**3*r*s - 2250*Dd**2*f**3*r + 1500*Dd**2*f**3*s**2 - 2250*Dd**2*f**3*s + 750*Dd**2*f**3 + 3240*Dd**2*f**2*r**2 + 6480*Dd**2*f**2*r*s - 4860*Dd**2*f**2*r + 3240*Dd**2*f**2*s**2 - 4860*Dd**2*f**2*s + 1620*Dd**2*f**2 + 3024*Dd**2*f*g2*r**2 + 6048*Dd**2*f*g2*r*s - 4536*Dd**2*f*g2*r + 3024*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 1512*Dd**2*f*g2))/(105*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**3*k1**3*k2**3*(1080*C*D1**2*bdd1*f**2*r**2 + 2160*C*D1**2*bdd1*f**2*r*s - 2160*C*D1**2*bdd1*f**2*r + 1080*C*D1**2*bdd1*f**2*s**2 - 2160*C*D1**2*bdd1*f**2*s + 1080*C*D1**2*bdd1*f**2 - 60*C*D1**2*f**2*fd*r**2 - 120*C*D1**2*f**2*fd*r*s + 80*C*D1**2*f**2*fd*r - 60*C*D1**2*f**2*fd*s**2 + 80*C*D1**2*f**2*fd*s - 40*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r**2 + 1680*C*D1**2*f**2*fdd*r*s - 1120*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 1120*C*D1**2*f**2*fdd*s + 560*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r**2 + 3360*C*D1**2*f*fd**2*r*s - 2240*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 2240*C*D1**2*f*fd**2*s + 560*C*D1**2*f*fd**2 - 80*C*D1*Dd*f**3*r**2 - 160*C*D1*Dd*f**3*r*s + 120*C*D1*Dd*f**3*r - 80*C*D1*Dd*f**3*s**2 + 120*C*D1*Dd*f**3*s - 60*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r**2 + 13440*C*D1*Dd*f**2*fd*r*s - 9520*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 9520*C*D1*Dd*f**2*fd*s + 3360*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r**2 + 2240*C*D1*Ddd*f**3*r*s - 1680*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1680*C*D1*Ddd*f**3*s + 840*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r**2 + 6720*C*Dd**2*f**3*r*s - 5040*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 5040*C*Dd**2*f**3*s + 1680*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r**2 + 360*D1**2*K*bdd1*f**2*r*s - 360*D1**2*K*bdd1*f**2*r + 180*D1**2*K*bdd1*f**2*s**2 - 360*D1**2*K*bdd1*f**2*s + 180*D1**2*K*bdd1*f**2 - 36*D1**2*bd1**2*f*(-42*K + 25*f + 21)*(r + s - 1)**2 - 810*D1**2*bdd1*f**2*r**2 - 1620*D1**2*bdd1*f**2*r*s + 1620*D1**2*bdd1*f**2*r - 810*D1**2*bdd1*f**2*s**2 + 1620*D1**2*bdd1*f**2*s - 810*D1**2*bdd1*f**2 - 1512*D1**2*bdd1*f*g2*r**2 - 3024*D1**2*bdd1*f*g2*r*s + 3024*D1**2*bdd1*f*g2*r - 1512*D1**2*bdd1*f*g2*s**2 + 3024*D1**2*bdd1*f*g2*s - 1512*D1**2*bdd1*f*g2 - 105*D1**2*f**2*fd*r**2 - 210*D1**2*f**2*fd*r*s + 140*D1**2*f**2*fd*r - 105*D1**2*f**2*fd*s**2 + 140*D1**2*f**2*fd*s - 70*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 36*D1**2*f**2*gd2*r**2 - 72*D1**2*f**2*gd2*r*s + 72*D1**2*f**2*gd2*r - 36*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s - 36*D1**2*f**2*gd2 - 360*D1**2*f**2*gdd2*r**2 - 720*D1**2*f**2*gdd2*r*s + 720*D1**2*f**2*gdd2*r - 360*D1**2*f**2*gdd2*s**2 + 720*D1**2*f**2*gdd2*s - 360*D1**2*f**2*gdd2 - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 - 72*D1**2*f*fd*g2*r**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 72*D1**2*f*fd*g2*s - 36*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r**2 - 2880*D1**2*f*fd*gd2*r*s + 2160*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 2160*D1**2*f*fd*gd2*s - 720*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r**2 - 1440*D1**2*f*fdd*g2*r*s + 720*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r**2 - 1440*D1**2*fd**2*g2*r*s + 720*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s - 140*D1*Dd*f**3*r**2 - 280*D1*Dd*f**3*r*s + 210*D1*Dd*f**3*r - 140*D1*Dd*f**3*s**2 + 210*D1*Dd*f**3*s - 105*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd - 144*D1*Dd*f**2*g2*r**2 - 288*D1*Dd*f**2*g2*r*s + 216*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 216*D1*Dd*f**2*g2*s - 108*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r**2 - 5760*D1*Dd*f**2*gd2*r*s + 5040*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 5040*D1*Dd*f**2*gd2*s - 2160*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r**2 - 11520*D1*Dd*f*fd*g2*r*s + 7200*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 7200*D1*Dd*f*fd*g2*s - 2160*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r**2 - 2880*D1*Ddd*f**2*g2*r*s + 2160*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 2160*D1*Ddd*f**2*g2*s - 1080*D1*Ddd*f**2*g2 - 18*D1*bd1*(D1*(f**2*(36*C - K - 20)*(r + s - 1) - 2*f*(5*fd*(12*C + 2*K - 9)*(2*r + 2*s - 1) + (14*g2 - 84*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 2*Dd*f*(5*f*(12*C + 2*K - 9) - 84*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r**2 - 8640*Dd**2*f**2*g2*r*s + 6480*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 6480*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 + 3*b1**2*(D1**2*(3*f*(51*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(300*fd**2*(r + s - 1) + 7*fd*(12*K - 1)*(r + s) - 126*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(153*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(300*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (84*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 252*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-42*K + 25*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-42*K + 25*f + 21)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*b1*(-6*D1**2*bdd1*f*(-42*K + 25*f + 21)*(r + s - 1)**2 - 3*D1**2*(f*(fd*(36*C - K - 20)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*fdd*(12*C + 2*K - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-28*gd2 + 84*gdd2)*(r + s - 1)**2) + (-2*r - 2*s)*(5*fd**2*(12*C + 2*K - 9)*(r + s - 1) + 14*fd*(g2*(r + s) - 6*gd2*(r + s - 1)) - 42*fdd*g2*(r + s))) + D1*bd1*(D1*(153*f**2*(r + s - 1) - 300*f*fd*(2*r + 2*s - 1) - 7*f*(12*K - 1)*(r + s - 1) + 252*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-42*K + 25*f + 21)*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(f**2*(36*C - K - 20)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(5*fd*(12*C + 2*K - 9)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 14*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 84*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 168*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(5*f*(12*C + 2*K - 9) - 84*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f*(5*f*(12*C + 2*K - 9) - 84*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(105*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**3*k1**3*k2*st**4*(1782*C*D1**2*f**2*fd*r*s - 594*C*D1**2*f**2*fd*r + 1782*C*D1**2*f**2*fd*s**2 - 1782*C*D1**2*f**2*fd*s + 594*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 2376*C*D1*Dd*f**3*r*s - 594*C*D1*Dd*f**3*r + 2376*C*D1*Dd*f**3*s**2 - 2376*C*D1*Dd*f**3*s + 594*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 4940*D1**2*f**3*fd*r*s - 1235*D1**2*f**3*fd*r + 4940*D1**2*f**3*fd*s**2 - 4940*D1**2*f**3*fd*s + 1235*D1**2*f**3*fd - 2800*D1**2*f**3*fdd*r*s + 700*D1**2*f**3*fdd*r - 2800*D1**2*f**3*fdd*s**2 + 2800*D1**2*f**3*fdd*s - 700*D1**2*f**3*fdd - 8400*D1**2*f**2*fd**2*r*s + 2100*D1**2*f**2*fd**2*r - 8400*D1**2*f**2*fd**2*s**2 + 8400*D1**2*f**2*fd**2*s - 1400*D1**2*f**2*fd**2 - 1782*D1**2*f**2*fd*r*s + 594*D1**2*f**2*fd*r - 1782*D1**2*f**2*fd*s**2 + 1782*D1**2*f**2*fd*s - 594*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 1518*D1**2*f**2*gd2*r*s - 1518*D1**2*f**2*gd2*s**2 + 1518*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 3036*D1**2*f*fd*g2*r*s + 1518*D1**2*f*fd*g2*r - 3036*D1**2*f*fd*g2*s**2 + 3036*D1**2*f*fd*g2*s - 1518*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 4940*D1*Dd*f**4*r*s - 1235*D1*Dd*f**4*r + 4940*D1*Dd*f**4*s**2 - 4940*D1*Dd*f**4*s + 1235*D1*Dd*f**4 - 22400*D1*Dd*f**3*fd*r*s + 5600*D1*Dd*f**3*fd*r - 22400*D1*Dd*f**3*fd*s**2 + 22400*D1*Dd*f**3*fd*s - 4200*D1*Dd*f**3*fd - 2376*D1*Dd*f**3*r*s + 594*D1*Dd*f**3*r - 2376*D1*Dd*f**3*s**2 + 2376*D1*Dd*f**3*s - 594*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 6072*D1*Dd*f**2*g2*r*s + 1518*D1*Dd*f**2*g2*r - 6072*D1*Dd*f**2*g2*s**2 + 6072*D1*Dd*f**2*g2*s - 1518*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 2800*D1*Ddd*f**4*r*s + 700*D1*Ddd*f**4*r - 2800*D1*Ddd*f**4*s**2 + 2800*D1*Ddd*f**4*s - 700*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 8400*Dd**2*f**4*r*s + 2100*Dd**2*f**4*r - 8400*Dd**2*f**4*s**2 + 8400*Dd**2*f**4*s - 1400*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**6) + 4*D1**2*Pk2*Pk3*ct**3*k1**3*k2*st**2*(108*C*D1**2*bdd1*f**2*r**2 + 540*C*D1**2*bdd1*f**2*r*s - 324*C*D1**2*bdd1*f**2*r + 432*C*D1**2*bdd1*f**2*s**2 - 648*C*D1**2*bdd1*f**2*s + 324*C*D1**2*bdd1*f**2 + 2646*C*D1**2*f**2*fd*r**2 + 3240*C*D1**2*f**2*fd*r*s - 2844*C*D1**2*f**2*fd*r + 594*C*D1**2*f**2*fd*s**2 - 1476*C*D1**2*f**2*fd*s + 1080*C*D1**2*f**2*fd - 2322*C*D1**2*f**2*fdd*r**2 - 3024*C*D1**2*f**2*fdd*r*s + 2556*C*D1**2*f**2*fdd*r - 702*C*D1**2*f**2*fdd*s**2 + 1476*C*D1**2*f**2*fdd*s - 1008*C*D1**2*f**2*fdd - 4644*C*D1**2*f*fd**2*r**2 - 6048*C*D1**2*f*fd**2*r*s + 5112*C*D1**2*f*fd**2*r - 1404*C*D1**2*f*fd**2*s**2 + 2952*C*D1**2*f*fd**2*s - 1008*C*D1**2*f*fd**2 + 3528*C*D1*Dd*f**3*r**2 + 4320*C*D1*Dd*f**3*r*s - 4608*C*D1*Dd*f**3*r + 792*C*D1*Dd*f**3*s**2 - 2556*C*D1*Dd*f**3*s + 1962*C*D1*Dd*f**3 - 18576*C*D1*Dd*f**2*fd*r**2 - 24192*C*D1*Dd*f**2*fd*r*s + 22536*C*D1*Dd*f**2*fd*r - 5616*C*D1*Dd*f**2*fd*s**2 + 13356*C*D1*Dd*f**2*fd*s - 6588*C*D1*Dd*f**2*fd - 3096*C*D1*Ddd*f**3*r**2 - 4032*C*D1*Ddd*f**3*r*s + 4104*C*D1*Ddd*f**3*r - 936*C*D1*Ddd*f**3*s**2 + 2484*C*D1*Ddd*f**3*s - 1782*C*D1*Ddd*f**3 - 9288*C*Dd**2*f**3*r**2 - 12096*C*Dd**2*f**3*r*s + 12312*C*Dd**2*f**3*r - 2808*C*Dd**2*f**3*s**2 + 7452*C*Dd**2*f**3*s - 3564*C*Dd**2*f**3 - 639*D1**2*K*bdd1*f**2*r**2 - 1008*D1**2*K*bdd1*f**2*r*s + 1278*D1**2*K*bdd1*f**2*r - 369*D1**2*K*bdd1*f**2*s**2 + 1008*D1**2*K*bdd1*f**2*s - 639*D1**2*K*bdd1*f**2 + 126*D1**2*bd1**2*f*(K - 1)*(2*r**2 + 5*r*(2*s - 1) + 8*s**2 - 11*s + 3) + 450*D1**2*bdd1*f**3*r**2 + 700*D1**2*bdd1*f**3*r*s - 1000*D1**2*bdd1*f**3*r + 250*D1**2*bdd1*f**3*s**2 - 800*D1**2*bdd1*f**3*s + 700*D1**2*bdd1*f**3 + 855*D1**2*bdd1*f**2*r**2 + 1440*D1**2*bdd1*f**2*r*s - 1602*D1**2*bdd1*f**2*r + 585*D1**2*bdd1*f**2*s**2 - 1332*D1**2*bdd1*f**2*s + 639*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r**2 - 1260*D1**2*bdd1*f*g2*r*s + 756*D1**2*bdd1*f*g2*r - 1008*D1**2*bdd1*f*g2*s**2 + 1512*D1**2*bdd1*f*g2*s - 756*D1**2*bdd1*f*g2 + 3900*D1**2*f**3*fd*r**2 + 10200*D1**2*f**3*fd*r*s - 6450*D1**2*f**3*fd*r + 6300*D1**2*f**3*fd*s**2 - 8250*D1**2*f**3*fd*s + 3525*D1**2*f**3*fd - 4500*D1**2*f**3*fdd*r**2 - 9000*D1**2*f**3*fdd*r*s + 6750*D1**2*f**3*fdd*r - 4500*D1**2*f**3*fdd*s**2 + 6750*D1**2*f**3*fdd*s - 3375*D1**2*f**3*fdd - 13500*D1**2*f**2*fd**2*r**2 - 27000*D1**2*f**2*fd**2*r*s + 20250*D1**2*f**2*fd**2*r - 13500*D1**2*f**2*fd**2*s**2 + 20250*D1**2*f**2*fd**2*s - 6750*D1**2*f**2*fd**2 - 3240*D1**2*f**2*fd*r**2 - 5184*D1**2*f**2*fd*r*s + 3888*D1**2*f**2*fd*r - 1944*D1**2*f**2*fd*s**2 + 3024*D1**2*f**2*fd*s - 1728*D1**2*f**2*fd + 2862*D1**2*f**2*fdd*r**2 + 4644*D1**2*f**2*fdd*r*s - 3456*D1**2*f**2*fdd*r + 1782*D1**2*f**2*fdd*s**2 - 2736*D1**2*f**2*fdd*s + 1548*D1**2*f**2*fdd - 1170*D1**2*f**2*gd2*r**2 - 2016*D1**2*f**2*gd2*r*s + 2340*D1**2*f**2*gd2*r - 846*D1**2*f**2*gd2*s**2 + 2016*D1**2*f**2*gd2*s - 1170*D1**2*f**2*gd2 + 1278*D1**2*f**2*gdd2*r**2 + 2016*D1**2*f**2*gdd2*r*s - 2556*D1**2*f**2*gdd2*r + 738*D1**2*f**2*gdd2*s**2 - 2016*D1**2*f**2*gdd2*s + 1278*D1**2*f**2*gdd2 + 5724*D1**2*f*fd**2*r**2 + 9288*D1**2*f*fd**2*r*s - 6912*D1**2*f*fd**2*r + 3564*D1**2*f*fd**2*s**2 - 5472*D1**2*f*fd**2*s + 1548*D1**2*f*fd**2 - 2340*D1**2*f*fd*g2*r**2 - 4032*D1**2*f*fd*g2*r*s + 2016*D1**2*f*fd*g2*r - 1692*D1**2*f*fd*g2*s**2 + 1692*D1**2*f*fd*g2*s - 846*D1**2*f*fd*g2 + 5112*D1**2*f*fd*gd2*r**2 + 8064*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 2952*D1**2*f*fd*gd2*s**2 - 5508*D1**2*f*fd*gd2*s + 2016*D1**2*f*fd*gd2 + 2556*D1**2*f*fdd*g2*r**2 + 4032*D1**2*f*fdd*g2*r*s - 2016*D1**2*f*fdd*g2*r + 1476*D1**2*f*fdd*g2*s**2 - 1476*D1**2*f*fdd*g2*s + 738*D1**2*f*fdd*g2 + 2556*D1**2*fd**2*g2*r**2 + 4032*D1**2*fd**2*g2*r*s - 2016*D1**2*fd**2*g2*r + 1476*D1**2*fd**2*g2*s**2 - 1476*D1**2*fd**2*g2*s + 3900*D1*Dd*f**4*r**2 + 10200*D1*Dd*f**4*r*s - 6450*D1*Dd*f**4*r + 6300*D1*Dd*f**4*s**2 - 8250*D1*Dd*f**4*s + 3525*D1*Dd*f**4 - 36000*D1*Dd*f**3*fd*r**2 - 72000*D1*Dd*f**3*fd*r*s + 54000*D1*Dd*f**3*fd*r - 36000*D1*Dd*f**3*fd*s**2 + 54000*D1*Dd*f**3*fd*s - 20250*D1*Dd*f**3*fd - 4320*D1*Dd*f**3*r**2 - 6912*D1*Dd*f**3*r*s + 6048*D1*Dd*f**3*r - 2592*D1*Dd*f**3*s**2 + 4752*D1*Dd*f**3*s - 2808*D1*Dd*f**3 + 22896*D1*Dd*f**2*fd*r**2 + 37152*D1*Dd*f**2*fd*r*s - 29916*D1*Dd*f**2*fd*r + 14256*D1*Dd*f**2*fd*s**2 - 23796*D1*Dd*f**2*fd*s + 9648*D1*Dd*f**2*fd - 4680*D1*Dd*f**2*g2*r**2 - 8064*D1*Dd*f**2*g2*r*s + 6696*D1*Dd*f**2*g2*r - 3384*D1*Dd*f**2*g2*s**2 + 5724*D1*Dd*f**2*g2*s - 3186*D1*Dd*f**2*g2 + 10224*D1*Dd*f**2*gd2*r**2 + 16128*D1*Dd*f**2*gd2*r*s - 17352*D1*Dd*f**2*gd2*r + 5904*D1*Dd*f**2*gd2*s**2 - 13572*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 20448*D1*Dd*f*fd*g2*r**2 + 32256*D1*Dd*f*fd*g2*r*s - 22320*D1*Dd*f*fd*g2*r + 11808*D1*Dd*f*fd*g2*s**2 - 16920*D1*Dd*f*fd*g2*s + 5508*D1*Dd*f*fd*g2 - 4500*D1*Ddd*f**4*r**2 - 9000*D1*Ddd*f**4*r*s + 6750*D1*Ddd*f**4*r - 4500*D1*Ddd*f**4*s**2 + 6750*D1*Ddd*f**4*s - 3375*D1*Ddd*f**4 + 3816*D1*Ddd*f**3*r**2 + 6192*D1*Ddd*f**3*r*s - 5364*D1*Ddd*f**3*r + 2376*D1*Ddd*f**3*s**2 - 4284*D1*Ddd*f**3*s + 2502*D1*Ddd*f**3 + 5112*D1*Ddd*f**2*g2*r**2 + 8064*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 2952*D1*Ddd*f**2*g2*s**2 - 5508*D1*Ddd*f**2*g2*s + 3294*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-2*f**3*(243*r**2 + r*(394*s - 640) + 151*s**2 - 548*s + 493) + f**2*(-12*C*(11*r**2 + r*(69*s - 47) + 58*s**2 - 94*s + 47) + 9*K*(65*r**2 + 2*r*(56*s - 65) + 47*s**2 - 112*s + 65) + 100*fd*(27*r**2 + r*(42*s - 45) + 15*s**2 - 35*s + 14) - 723*r**2 - 1116*r*s + 1146*r - 393*s**2 + 816*s - 291) + 6*f*(3*fd*(6*C*(4*r**2 + 10*r*(2*s - 1) + 16*s**2 - 19*s + 3) - K*(142*r**2 + 224*r*s - 198*r + 82*s**2 - 153*s + 56) + 190*r**2 + 320*r*s - 264*r + 130*s**2 - 219*s + 92) + 14*g2*(r**2 + r*(15*s - 13) + 14*s**2 - 26*s + 13) - 42*gd2*(2*r**2 + 5*r*(2*s - 1) + 8*s**2 - 11*s + 3)) - 252*fd*g2*(2*r**2 + 5*r*(2*s - 1) + s*(8*s - 8))) + 2*Dd*f*(50*f**2*(36*r**2 + r*(56*s - 65) + 20*s**2 - 51*s + 28) + 9*f*(6*C*(8*r**2 + r*(40*s - 21) + 32*s**2 - 42*s + 12) - K*(284*r**2 + 448*r*s - 482*r + 164*s**2 - 377*s + 198) + 380*r**2 + 640*r*s - 626*r + 260*s**2 - 521*s + 252) - 126*g2*(8*r**2 + r*(40*s - 21) + 32*s**2 - 42*s + 12))) - 13500*Dd**2*f**4*r**2 - 27000*Dd**2*f**4*r*s + 20250*Dd**2*f**4*r - 13500*Dd**2*f**4*s**2 + 20250*Dd**2*f**4*s - 6750*Dd**2*f**4 + 11448*Dd**2*f**3*r**2 + 18576*Dd**2*f**3*r*s - 16092*Dd**2*f**3*r + 7128*Dd**2*f**3*s**2 - 12852*Dd**2*f**3*s + 5004*Dd**2*f**3 + 15336*Dd**2*f**2*g2*r**2 + 24192*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 8856*Dd**2*f**2*g2*s**2 - 16524*Dd**2*f**2*g2*s + 6588*Dd**2*f**2*g2 - 42*b1**2*(K - 1)*(D1**2*(fd*(r**2 + 15*r*s - 2*r + 14*s**2 - 2*s + 1) - 3*fdd*(r**2 + 5*r*s - 2*r + 4*s**2 - 2*s + 1)) + D1*(Dd*f*(4*r**2 + r*(60*s - 19) + 56*s**2 - 58*s + 16) - 3*Dd*fd*(8*r**2 + r*(40*s - 17) + 32*s**2 - 26*s + 6) - 3*Ddd*f*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 18*s + 6)) - 9*Dd**2*f*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 18*s + 4)) + b1*(-264*C*D1**2*f*fd*r**2 - 1656*C*D1**2*f*fd*r*s + 528*C*D1**2*f*fd*r - 1392*C*D1**2*f*fd*s**2 + 1092*C*D1**2*f*fd*s - 264*C*D1**2*f*fd + 216*C*D1**2*f*fdd*r**2 + 1080*C*D1**2*f*fdd*r*s - 432*C*D1**2*f*fdd*r + 864*C*D1**2*f*fdd*s**2 - 756*C*D1**2*f*fdd*s + 216*C*D1**2*f*fdd + 216*C*D1**2*fd**2*r**2 + 1080*C*D1**2*fd**2*r*s - 432*C*D1**2*fd**2*r + 864*C*D1**2*fd**2*s**2 - 756*C*D1**2*fd**2*s + 216*C*D1**2*fd**2 - 528*C*D1*Dd*f**2*r**2 - 3312*C*D1*Dd*f**2*r*s + 1356*C*D1*Dd*f**2*r - 2784*C*D1*Dd*f**2*s**2 + 3048*C*D1*Dd*f**2*s - 960*C*D1*Dd*f**2 + 1728*C*D1*Dd*f*fd*r**2 + 8640*C*D1*Dd*f*fd*r*s - 3672*C*D1*Dd*f*fd*r + 6912*C*D1*Dd*f*fd*s**2 - 6912*C*D1*Dd*f*fd*s + 1620*C*D1*Dd*f*fd + 432*C*D1*Ddd*f**2*r**2 + 2160*C*D1*Ddd*f**2*r*s - 972*C*D1*Ddd*f**2*r + 1728*C*D1*Ddd*f**2*s**2 - 1944*C*D1*Ddd*f**2*s + 648*C*D1*Ddd*f**2 + 1296*C*Dd**2*f**2*r**2 + 6480*C*Dd**2*f**2*r*s - 2916*C*Dd**2*f**2*r + 5184*C*Dd**2*f**2*s**2 - 5832*C*Dd**2*f**2*s + 1296*C*Dd**2*f**2 + 1170*D1**2*K*f*fd*r**2 + 2016*D1**2*K*f*fd*r*s - 1008*D1**2*K*f*fd*r + 846*D1**2*K*f*fd*s**2 - 846*D1**2*K*f*fd*s + 423*D1**2*K*f*fd - 1278*D1**2*K*f*fdd*r**2 - 2016*D1**2*K*f*fdd*r*s + 1008*D1**2*K*f*fdd*r - 738*D1**2*K*f*fdd*s**2 + 738*D1**2*K*f*fdd*s - 369*D1**2*K*f*fdd - 1278*D1**2*K*fd**2*r**2 - 2016*D1**2*K*fd**2*r*s + 1008*D1**2*K*fd**2*r - 738*D1**2*K*fd**2*s**2 + 738*D1**2*K*fd**2*s + 126*D1**2*bdd1*f*(K - 1)*(2*r**2 + 10*r*s - 5*r + 8*s**2 - 11*s + 4) - 1458*D1**2*f**2*fd*r**2 - 2364*D1**2*f**2*fd*r*s + 1452*D1**2*f**2*fd*r - 906*D1**2*f**2*fd*s**2 + 1084*D1**2*f**2*fd*s - 288*D1**2*f**2*fd + 1350*D1**2*f**2*fdd*r**2 + 2100*D1**2*f**2*fdd*r*s - 1500*D1**2*f**2*fdd*r + 750*D1**2*f**2*fdd*s**2 - 1100*D1**2*f**2*fdd*s + 450*D1**2*f**2*fdd + 2700*D1**2*f*fd**2*r**2 + 4200*D1**2*f*fd**2*r*s - 3000*D1**2*f*fd**2*r + 1500*D1**2*f*fd**2*s**2 - 2200*D1**2*f*fd**2*s + 900*D1**2*f*fd**2 - 1446*D1**2*f*fd*r**2 - 2232*D1**2*f*fd*r*s + 1416*D1**2*f*fd*r - 786*D1**2*f*fd*s**2 + 1086*D1**2*f*fd*s - 825*D1**2*f*fd + 1710*D1**2*f*fdd*r**2 + 2880*D1**2*f*fdd*r*s - 1548*D1**2*f*fdd*r + 1170*D1**2*f*fdd*s**2 - 1278*D1**2*f*fdd*s + 801*D1**2*f*fdd + 84*D1**2*f*gd2*r**2 + 1260*D1**2*f*gd2*r*s - 168*D1**2*f*gd2*r + 1176*D1**2*f*gd2*s**2 - 1260*D1**2*f*gd2*s + 84*D1**2*f*gd2 - 252*D1**2*f*gdd2*r**2 - 1260*D1**2*f*gdd2*r*s + 504*D1**2*f*gdd2*r - 1008*D1**2*f*gdd2*s**2 + 1260*D1**2*f*gdd2*s - 252*D1**2*f*gdd2 + 1710*D1**2*fd**2*r**2 + 2880*D1**2*fd**2*r*s - 1548*D1**2*fd**2*r + 1170*D1**2*fd**2*s**2 - 1278*D1**2*fd**2*s - 216*D1**2*fd**2 + 84*D1**2*fd*g2*r**2 + 1260*D1**2*fd*g2*r*s - 168*D1**2*fd*g2*r + 1176*D1**2*fd*g2*s**2 - 168*D1**2*fd*g2*s + 84*D1**2*fd*g2 - 504*D1**2*fd*gd2*r**2 - 2520*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 2016*D1**2*fd*gd2*s**2 + 1764*D1**2*fd*gd2*s - 504*D1**2*fd*gd2 - 252*D1**2*fdd*g2*r**2 - 1260*D1**2*fdd*g2*r*s + 504*D1**2*fdd*g2*r - 1008*D1**2*fdd*g2*s**2 + 504*D1**2*fdd*g2*s - 252*D1**2*fdd*g2 + 2340*D1*Dd*K*f**2*r**2 + 4032*D1*Dd*K*f**2*r*s - 3348*D1*Dd*K*f**2*r + 1692*D1*Dd*K*f**2*s**2 - 2862*D1*Dd*K*f**2*s + 1593*D1*Dd*K*f**2 - 10224*D1*Dd*K*f*fd*r**2 - 16128*D1*Dd*K*f*fd*r*s + 11160*D1*Dd*K*f*fd*r - 5904*D1*Dd*K*f*fd*s**2 + 8460*D1*Dd*K*f*fd*s - 2754*D1*Dd*K*f*fd - 1944*D1*Dd*f**3*r**2 - 3152*D1*Dd*f**3*r*s + 2732*D1*Dd*f**3*r - 1208*D1*Dd*f**3*s**2 + 2180*D1*Dd*f**3*s - 1274*D1*Dd*f**3 + 10800*D1*Dd*f**2*fd*r**2 + 16800*D1*Dd*f**2*fd*r*s - 13500*D1*Dd*f**2*fd*r + 6000*D1*Dd*f**2*fd*s**2 - 10100*D1*Dd*f**2*fd*s + 4100*D1*Dd*f**2*fd - 2892*D1*Dd*f**2*r**2 - 4464*D1*Dd*f**2*r*s + 4008*D1*Dd*f**2*r - 1572*D1*Dd*f**2*s**2 + 3018*D1*Dd*f**2*s - 1839*D1*Dd*f**2 + 13680*D1*Dd*f*fd*r**2 + 23040*D1*Dd*f*fd*r*s - 15912*D1*Dd*f*fd*r + 9360*D1*Dd*f*fd*s**2 - 13212*D1*Dd*f*fd*s + 4374*D1*Dd*f*fd + 336*D1*Dd*f*g2*r**2 + 5040*D1*Dd*f*g2*r*s - 1596*D1*Dd*f*g2*r + 4704*D1*Dd*f*g2*s**2 - 4872*D1*Dd*f*g2*s + 1344*D1*Dd*f*g2 - 2016*D1*Dd*f*gd2*r**2 - 10080*D1*Dd*f*gd2*r*s + 4284*D1*Dd*f*gd2*r - 8064*D1*Dd*f*gd2*s**2 + 9576*D1*Dd*f*gd2*s - 2268*D1*Dd*f*gd2 - 2016*D1*Dd*fd*g2*r**2 - 10080*D1*Dd*fd*g2*r*s + 4284*D1*Dd*fd*g2*r - 8064*D1*Dd*fd*g2*s**2 + 6552*D1*Dd*fd*g2*s - 1512*D1*Dd*fd*g2 - 2556*D1*Ddd*K*f**2*r**2 - 4032*D1*Ddd*K*f**2*r*s + 3564*D1*Ddd*K*f**2*r - 1476*D1*Ddd*K*f**2*s**2 + 2754*D1*Ddd*K*f**2*s - 1647*D1*Ddd*K*f**2 + 1800*D1*Ddd*f**3*r**2 + 2800*D1*Ddd*f**3*r*s - 2500*D1*Ddd*f**3*r + 1000*D1*Ddd*f**3*s**2 - 1900*D1*Ddd*f**3*s + 1150*D1*Ddd*f**3 + 3420*D1*Ddd*f**2*r**2 + 5760*D1*Ddd*f**2*r*s - 4860*D1*Ddd*f**2*r + 2340*D1*Ddd*f**2*s**2 - 4050*D1*Ddd*f**2*s + 2295*D1*Ddd*f**2 - 1008*D1*Ddd*f*g2*r**2 - 5040*D1*Ddd*f*g2*r*s + 2268*D1*Ddd*f*g2*r - 4032*D1*Ddd*f*g2*s**2 + 4536*D1*Ddd*f*g2*s - 1512*D1*Ddd*f*g2 - 42*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 30*r*s - 15*r + 28*s**2 - 41*s + 14) - 3*fd*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 15*s + 2)) - 3*Dd*f*(16*r**2 + r*(80*s - 38) + 64*s**2 - 80*s + 21)) - 7668*Dd**2*K*f**2*r**2 - 12096*Dd**2*K*f**2*r*s + 10692*Dd**2*K*f**2*r - 4428*Dd**2*K*f**2*s**2 + 8262*Dd**2*K*f**2*s - 3294*Dd**2*K*f**2 + 5400*Dd**2*f**3*r**2 + 8400*Dd**2*f**3*r*s - 7500*Dd**2*f**3*r + 3000*Dd**2*f**3*s**2 - 5700*Dd**2*f**3*s + 2300*Dd**2*f**3 + 10260*Dd**2*f**2*r**2 + 17280*Dd**2*f**2*r*s - 14580*Dd**2*f**2*r + 7020*Dd**2*f**2*s**2 - 12150*Dd**2*f**2*s + 4590*Dd**2*f**2 - 3024*Dd**2*f*g2*r**2 - 15120*Dd**2*f*g2*r*s + 6804*Dd**2*f*g2*r - 12096*Dd**2*f*g2*s**2 + 13608*Dd**2*f*g2*s - 3024*Dd**2*f*g2))/(315*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**3*k1**3*k2*(-2412*C*D1**2*bdd1*f**2*r**2 - 4392*C*D1**2*bdd1*f**2*r*s + 5112*C*D1**2*bdd1*f**2*r - 1980*C*D1**2*bdd1*f**2*s**2 + 4680*C*D1**2*bdd1*f**2*s - 2340*C*D1**2*bdd1*f**2 + 3300*C*D1**2*f**2*fd*r**2 + 16560*C*D1**2*f**2*fd*r*s - 7720*C*D1**2*f**2*fd*r + 13260*C*D1**2*f**2*fd*s**2 - 14360*C*D1**2*f**2*fd*s + 5520*C*D1**2*f**2*fd - 5700*C*D1**2*f**2*fdd*r**2 - 19080*C*D1**2*f**2*fdd*r*s + 10160*C*D1**2*f**2*fdd*r - 13380*C*D1**2*f**2*fdd*s**2 + 15280*C*D1**2*f**2*fdd*s - 6360*C*D1**2*f**2*fdd - 11400*C*D1**2*f*fd**2*r**2 - 38160*C*D1**2*f*fd**2*r*s + 20320*C*D1**2*f*fd**2*r - 26760*C*D1**2*f*fd**2*s**2 + 30560*C*D1**2*f*fd**2*s - 6360*C*D1**2*f*fd**2 + 4400*C*D1*Dd*f**3*r**2 + 22080*C*D1*Dd*f**3*r*s - 9920*C*D1*Dd*f**3*r + 17680*C*D1*Dd*f**3*s**2 - 19880*C*D1*Dd*f**3*s + 6620*C*D1*Dd*f**3 - 45600*C*D1*Dd*f**2*fd*r**2 - 152640*C*D1*Dd*f**2*fd*r*s + 82520*C*D1*Dd*f**2*fd*r - 107040*C*D1*Dd*f**2*fd*s**2 + 126040*C*D1*Dd*f**2*fd*s - 35600*C*D1*Dd*f**2*fd - 7600*C*D1*Ddd*f**3*r**2 - 25440*C*D1*Ddd*f**3*r*s + 13960*C*D1*Ddd*f**3*r - 17840*C*D1*Ddd*f**3*s**2 + 21640*C*D1*Ddd*f**3*s - 8260*C*D1*Ddd*f**3 - 22800*C*Dd**2*f**3*r**2 - 76320*C*Dd**2*f**3*r*s + 41880*C*Dd**2*f**3*r - 53520*C*Dd**2*f**3*s**2 + 64920*C*Dd**2*f**3*s - 16520*C*Dd**2*f**3 - 1170*D1**2*K*bdd1*f**2*r**2 - 4212*D1**2*K*bdd1*f**2*r*s + 2340*D1**2*K*bdd1*f**2*r - 3042*D1**2*K*bdd1*f**2*s**2 + 4212*D1**2*K*bdd1*f**2*s - 1170*D1**2*K*bdd1*f**2 + 432*D1**2*b2*f*fd*r**2 + 864*D1**2*b2*f*fd*r*s - 432*D1**2*b2*f*fd*r + 432*D1**2*b2*f*fd*s**2 - 432*D1**2*b2*f*fd*s + 216*D1**2*b2*f*fd - 720*D1**2*b2*f*fdd*r**2 - 1440*D1**2*b2*f*fdd*r*s + 720*D1**2*b2*f*fdd*r - 720*D1**2*b2*f*fdd*s**2 + 720*D1**2*b2*f*fdd*s - 360*D1**2*b2*f*fdd - 720*D1**2*b2*fd**2*r**2 - 1440*D1**2*b2*fd**2*r*s + 720*D1**2*b2*fd**2*r - 720*D1**2*b2*fd**2*s**2 + 720*D1**2*b2*fd**2*s + 12*D1**2*bd1**2*(r + s - 1)*(90*f**2*(r + s - 1) + 7*f*(12*C*r + 12*C*s + K*(-37*r - 37*s + 43) + 46*r + 46*s - 61) - 140*g2*(r + s)) + 216*D1**2*bd2*f**2*r**2 + 432*D1**2*bd2*f**2*r*s - 432*D1**2*bd2*f**2*r + 216*D1**2*bd2*f**2*s**2 - 432*D1**2*bd2*f**2*s + 216*D1**2*bd2*f**2 - 1440*D1**2*bd2*f*fd*r**2 - 2880*D1**2*bd2*f*fd*r*s + 2160*D1**2*bd2*f*fd*r - 1440*D1**2*bd2*f*fd*s**2 + 2160*D1**2*bd2*f*fd*s - 720*D1**2*bd2*f*fd - 720*D1**2*bdd1*f**3*r**2 + 720*D1**2*bdd1*f**3*r + 720*D1**2*bdd1*f**3*s**2 - 720*D1**2*bdd1*f**3*s + 3447*D1**2*bdd1*f**2*r**2 + 7398*D1**2*bdd1*f**2*r*s - 7002*D1**2*bdd1*f**2*r + 3951*D1**2*bdd1*f**2*s**2 - 7506*D1**2*bdd1*f**2*s + 3285*D1**2*bdd1*f**2 + 3108*D1**2*bdd1*f*g2*r**2 + 6216*D1**2*bdd1*f*g2*r*s - 7224*D1**2*bdd1*f*g2*r + 3108*D1**2*bdd1*f*g2*s**2 - 7224*D1**2*bdd1*f*g2*s + 3612*D1**2*bdd1*f*g2 - 360*D1**2*bdd2*f**2*r**2 - 720*D1**2*bdd2*f**2*r*s + 720*D1**2*bdd2*f**2*r - 360*D1**2*bdd2*f**2*s**2 + 720*D1**2*bdd2*f**2*s - 360*D1**2*bdd2*f**2 - 1635*D1**2*f**2*fd*r**2 - 11010*D1**2*f**2*fd*r*s + 4760*D1**2*f**2*fd*r - 9375*D1**2*f**2*fd*s**2 + 9920*D1**2*f**2*fd*s - 3670*D1**2*f**2*fd + 3855*D1**2*f**2*fdd*r**2 + 13470*D1**2*f**2*fdd*r*s - 7060*D1**2*f**2*fdd*r + 9615*D1**2*f**2*fdd*s**2 - 10900*D1**2*f**2*fdd*s + 4490*D1**2*f**2*fdd - 900*D1**2*f**2*gd2*r**2 - 6768*D1**2*f**2*gd2*r*s + 1800*D1**2*f**2*gd2*r - 5868*D1**2*f**2*gd2*s**2 + 6768*D1**2*f**2*gd2*s - 900*D1**2*f**2*gd2 + 2340*D1**2*f**2*gdd2*r**2 + 8424*D1**2*f**2*gdd2*r*s - 4680*D1**2*f**2*gdd2*r + 6084*D1**2*f**2*gdd2*s**2 - 8424*D1**2*f**2*gdd2*s + 2340*D1**2*f**2*gdd2 + 7710*D1**2*f*fd**2*r**2 + 26940*D1**2*f*fd**2*r*s - 14120*D1**2*f*fd**2*r + 19230*D1**2*f*fd**2*s**2 - 21800*D1**2*f*fd**2*s + 4490*D1**2*f*fd**2 - 1800*D1**2*f*fd*g2*r**2 - 13536*D1**2*f*fd*g2*r*s + 6768*D1**2*f*fd*g2*r - 11736*D1**2*f*fd*g2*s**2 + 11736*D1**2*f*fd*g2*s - 5868*D1**2*f*fd*g2 + 9360*D1**2*f*fd*gd2*r**2 + 33696*D1**2*f*fd*gd2*r*s - 17784*D1**2*f*fd*gd2*r + 24336*D1**2*f*fd*gd2*s**2 - 29016*D1**2*f*fd*gd2*s + 8424*D1**2*f*fd*gd2 + 4680*D1**2*f*fdd*g2*r**2 + 16848*D1**2*f*fdd*g2*r*s - 8424*D1**2*f*fdd*g2*r + 12168*D1**2*f*fdd*g2*s**2 - 12168*D1**2*f*fdd*g2*s + 6084*D1**2*f*fdd*g2 + 4680*D1**2*fd**2*g2*r**2 + 16848*D1**2*fd**2*g2*r*s - 8424*D1**2*fd**2*g2*r + 12168*D1**2*fd**2*g2*s**2 - 12168*D1**2*fd**2*g2*s + 864*D1*Dd*b2*f**2*r**2 + 1728*D1*Dd*b2*f**2*r*s - 1296*D1*Dd*b2*f**2*r + 864*D1*Dd*b2*f**2*s**2 - 1296*D1*Dd*b2*f**2*s + 648*D1*Dd*b2*f**2 - 5760*D1*Dd*b2*f*fd*r**2 - 11520*D1*Dd*b2*f*fd*r*s + 7200*D1*Dd*b2*f*fd*r - 5760*D1*Dd*b2*f*fd*s**2 + 7200*D1*Dd*b2*f*fd*s - 2160*D1*Dd*b2*f*fd - 2880*D1*Dd*bd2*f**2*r**2 - 5760*D1*Dd*bd2*f**2*r*s + 5040*D1*Dd*bd2*f**2*r - 2880*D1*Dd*bd2*f**2*s**2 + 5040*D1*Dd*bd2*f**2*s - 2160*D1*Dd*bd2*f**2 - 2180*D1*Dd*f**3*r**2 - 14680*D1*Dd*f**3*r*s + 5850*D1*Dd*f**3*r - 12500*D1*Dd*f**3*s**2 + 13590*D1*Dd*f**3*s - 4215*D1*Dd*f**3 + 30840*D1*Dd*f**2*fd*r**2 + 107760*D1*Dd*f**2*fd*r*s - 57130*D1*Dd*f**2*fd*r + 76920*D1*Dd*f**2*fd*s**2 - 89770*D1*Dd*f**2*fd*s + 25020*D1*Dd*f**2*fd - 3600*D1*Dd*f**2*g2*r**2 - 27072*D1*Dd*f**2*g2*r*s + 10368*D1*Dd*f**2*g2*r - 23472*D1*Dd*f**2*g2*s**2 + 25272*D1*Dd*f**2*g2*s - 7668*D1*Dd*f**2*g2 + 18720*D1*Dd*f**2*gd2*r**2 + 67392*D1*Dd*f**2*gd2*r*s - 36504*D1*Dd*f**2*gd2*r + 48672*D1*Dd*f**2*gd2*s**2 - 62712*D1*Dd*f**2*gd2*s + 17784*D1*Dd*f**2*gd2 + 37440*D1*Dd*f*fd*g2*r**2 + 134784*D1*Dd*f*fd*g2*r*s - 69264*D1*Dd*f*fd*g2*r + 97344*D1*Dd*f*fd*g2*s**2 - 106704*D1*Dd*f*fd*g2*s + 29016*D1*Dd*f*fd*g2 - 1440*D1*Ddd*b2*f**2*r**2 - 2880*D1*Ddd*b2*f**2*r*s + 2160*D1*Ddd*b2*f**2*r - 1440*D1*Ddd*b2*f**2*s**2 + 2160*D1*Ddd*b2*f**2*s - 1080*D1*Ddd*b2*f**2 + 5140*D1*Ddd*f**3*r**2 + 17960*D1*Ddd*f**3*r*s - 9630*D1*Ddd*f**3*r + 12820*D1*Ddd*f**3*s**2 - 15390*D1*Ddd*f**3*s + 5775*D1*Ddd*f**3 + 9360*D1*Ddd*f**2*g2*r**2 + 33696*D1*Ddd*f**2*g2*r*s - 17784*D1*Ddd*f**2*g2*r + 24336*D1*Ddd*f**2*g2*s**2 - 29016*D1*Ddd*f**2*g2*s + 10764*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(30*f**3*(10*r**2 + 4*r*(s - 4) - 6*s**2 + 7) + 3*f**2*(4*C*(71*r**2 + 12*r*(11*s - 12) + 61*s**2 - 134*s + 67) + 50*K*r**2 + 376*K*r*s - 100*K*r + 326*K*s**2 - 376*K*s + 50*K - 80*fd*(6*r**2 - 6*r - 6*s**2 + 4*s + 1) - 325*r**2 - 762*r*s + 646*r - 437*s**2 + 758*s - 303) - 2*f*(3*fd*(4*C*(134*r**2 + r*(244*s - 199) + 110*s**2 - 181*s + 71) + 26*K*(10*r**2 + 36*r*s - 19*r + 26*s**2 - 31*s + 9) - 766*r**2 - 1644*r*s + 1183*r - 878*s**2 + 1267*s - 441) + 14*g2*(29*r**2 + r*(68*s - 72) + 39*s**2 - 82*s + 41) - 28*gd2*(37*r**2 + r*(74*s - 80) + 37*s**2 - 80*s + 43)) + 2072*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(120*f**2*(8*r**2 - 8*r - 8*s**2 + 6*s + 1) + 3*f*(4*C*(268*r**2 + r*(488*s - 479) + 220*s**2 - 437*s + 207) + 26*K*(20*r**2 + 72*r*s - 39*r + 52*s**2 - 67*s + 19) - 1532*r**2 - 3288*r*s + 2733*r - 1756*s**2 + 2929*s - 1195) - 28*g2*(148*r**2 + r*(296*s - 283) + 148*s**2 - 283*s + 129))) - 4320*Dd**2*b2*f**2*r**2 - 8640*Dd**2*b2*f**2*r*s + 6480*Dd**2*b2*f**2*r - 4320*Dd**2*b2*f**2*s**2 + 6480*Dd**2*b2*f**2*s - 2160*Dd**2*b2*f**2 + 15420*Dd**2*f**3*r**2 + 53880*Dd**2*f**3*r*s - 28890*Dd**2*f**3*r + 38460*Dd**2*f**3*s**2 - 46170*Dd**2*f**3*s + 11550*Dd**2*f**3 + 28080*Dd**2*f**2*g2*r**2 + 101088*Dd**2*f**2*g2*r*s - 53352*Dd**2*f**2*g2*r + 73008*Dd**2*f**2*g2*s**2 - 87048*Dd**2*f**2*g2*s + 21528*Dd**2*f**2*g2 + 420*b1**3*(K - 1)*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*b1**2*(-28*C*D1**2*fd*r**2 - 56*C*D1**2*fd*r*s + 56*C*D1**2*fd*r - 28*C*D1**2*fd*s**2 + 56*C*D1**2*fd*s - 28*C*D1**2*fd + 84*C*D1**2*fdd*r**2 + 168*C*D1**2*fdd*r*s - 168*C*D1**2*fdd*r + 84*C*D1**2*fdd*s**2 - 168*C*D1**2*fdd*s + 84*C*D1**2*fdd - 112*C*D1*Dd*f*r**2 - 224*C*D1*Dd*f*r*s + 168*C*D1*Dd*f*r - 112*C*D1*Dd*f*s**2 + 168*C*D1*Dd*f*s - 84*C*D1*Dd*f + 672*C*D1*Dd*fd*r**2 + 1344*C*D1*Dd*fd*r*s - 1176*C*D1*Dd*fd*r + 672*C*D1*Dd*fd*s**2 - 1176*C*D1*Dd*fd*s + 504*C*D1*Dd*fd + 336*C*D1*Ddd*f*r**2 + 672*C*D1*Ddd*f*r*s - 504*C*D1*Ddd*f*r + 336*C*D1*Ddd*f*s**2 - 504*C*D1*Ddd*f*s + 252*C*D1*Ddd*f + 1008*C*Dd**2*f*r**2 + 2016*C*Dd**2*f*r*s - 1512*C*Dd**2*f*r + 1008*C*Dd**2*f*s**2 - 1512*C*Dd**2*f*s + 504*C*Dd**2*f + 203*D1**2*K*fd*r**2 + 476*D1**2*K*fd*r*s + 28*D1**2*K*fd*r + 273*D1**2*K*fd*s**2 + 28*D1**2*K*fd*s - 14*D1**2*K*fd - 259*D1**2*K*fdd*r**2 - 518*D1**2*K*fdd*r*s - 84*D1**2*K*fdd*r - 259*D1**2*K*fdd*s**2 - 84*D1**2*K*fdd*s + 42*D1**2*K*fdd + 70*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 192*D1**2*f*fd*r**2 - 384*D1**2*f*fd*r*s + 234*D1**2*f*fd*r - 192*D1**2*f*fd*s**2 + 234*D1**2*f*fd*s - 117*D1**2*f*fd + 180*D1**2*f*fdd*r**2 + 360*D1**2*f*fdd*r*s - 180*D1**2*f*fdd*r + 180*D1**2*f*fdd*s**2 - 180*D1**2*f*fdd*s + 90*D1**2*f*fdd + 180*D1**2*fd**2*r**2 + 360*D1**2*fd**2*r*s - 180*D1**2*fd**2*r + 180*D1**2*fd**2*s**2 - 180*D1**2*fd**2*s - 259*D1**2*fd*r**2 - 588*D1**2*fd*r*s - 70*D1**2*fd*r - 329*D1**2*fd*s**2 - 70*D1**2*fd*s + 35*D1**2*fd + 322*D1**2*fdd*r**2 + 644*D1**2*fdd*r*s + 210*D1**2*fdd*r + 322*D1**2*fdd*s**2 + 210*D1**2*fdd*s - 105*D1**2*fdd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 + 812*D1*Dd*K*f*r**2 + 1904*D1*Dd*K*f*r*s - 1288*D1*Dd*K*f*r + 1092*D1*Dd*K*f*s**2 - 1498*D1*Dd*K*f*s + 679*D1*Dd*K*f - 2072*D1*Dd*K*fd*r**2 - 4144*D1*Dd*K*fd*r*s + 1218*D1*Dd*K*fd*r - 2072*D1*Dd*K*fd*s**2 + 1218*D1*Dd*K*fd*s + 252*D1*Dd*K*fd - 384*D1*Dd*f**2*r**2 - 768*D1*Dd*f**2*r*s + 576*D1*Dd*f**2*r - 384*D1*Dd*f**2*s**2 + 576*D1*Dd*f**2*s - 288*D1*Dd*f**2 + 1440*D1*Dd*f*fd*r**2 + 2880*D1*Dd*f*fd*r*s - 1800*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 1800*D1*Dd*f*fd*s + 540*D1*Dd*f*fd - 1036*D1*Dd*f*r**2 - 2352*D1*Dd*f*r*s + 1624*D1*Dd*f*r - 1316*D1*Dd*f*s**2 + 1834*D1*Dd*f*s - 847*D1*Dd*f + 2576*D1*Dd*fd*r**2 + 5152*D1*Dd*fd*r*s - 1092*D1*Dd*fd*r + 2576*D1*Dd*fd*s**2 - 1092*D1*Dd*fd*s - 630*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 - 1036*D1*Ddd*K*f*r**2 - 2072*D1*Ddd*K*f*r*s + 1554*D1*Ddd*K*f*r - 1036*D1*Ddd*K*f*s**2 + 1554*D1*Ddd*K*f*s - 777*D1*Ddd*K*f + 360*D1*Ddd*f**2*r**2 + 720*D1*Ddd*f**2*r*s - 540*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 540*D1*Ddd*f**2*s + 270*D1*Ddd*f**2 + 1288*D1*Ddd*f*r**2 + 2576*D1*Ddd*f*r*s - 1932*D1*Ddd*f*r + 1288*D1*Ddd*f*s**2 - 1932*D1*Ddd*f*s + 966*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 + 70*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 3108*Dd**2*K*f*r**2 - 6216*Dd**2*K*f*r*s + 4662*Dd**2*K*f*r - 3108*Dd**2*K*f*s**2 + 4662*Dd**2*K*f*s - 1554*Dd**2*K*f + 1080*Dd**2*f**2*r**2 + 2160*Dd**2*f**2*r*s - 1620*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1620*Dd**2*f**2*s + 540*Dd**2*f**2 + 3864*Dd**2*f*r**2 + 7728*Dd**2*f*r*s - 5796*Dd**2*f*r + 3864*Dd**2*f*s**2 - 5796*Dd**2*f*s + 1932*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) + 3*b1*(1704*C*D1**2*f*fd*r**2 + 3168*C*D1**2*f*fd*r*s - 1560*C*D1**2*f*fd*r + 1464*C*D1**2*f*fd*s**2 - 1440*C*D1**2*f*fd*s + 780*C*D1**2*f*fd - 1608*C*D1**2*f*fdd*r**2 - 2928*C*D1**2*f*fdd*r*s + 1368*C*D1**2*f*fdd*r - 1320*C*D1**2*f*fdd*s**2 + 1224*C*D1**2*f*fdd*s - 684*C*D1**2*f*fdd - 1608*C*D1**2*fd**2*r**2 - 2928*C*D1**2*fd**2*r*s + 1368*C*D1**2*fd**2*r - 1320*C*D1**2*fd**2*s**2 + 1224*C*D1**2*fd**2*s + 240*C*D1**2*fd**2 + 3408*C*D1*Dd*f**2*r**2 + 6336*C*D1*Dd*f**2*r*s - 4992*C*D1*Dd*f**2*r + 2928*C*D1*Dd*f**2*s**2 - 4632*C*D1*Dd*f**2*s + 2436*C*D1*Dd*f**2 - 12864*C*D1*Dd*f*fd*r**2 - 23424*C*D1*Dd*f*fd*r*s + 14832*C*D1*Dd*f*fd*r - 10560*C*D1*Dd*f*fd*s**2 + 13392*C*D1*Dd*f*fd*s - 3960*C*D1*Dd*f*fd - 3216*C*D1*Ddd*f**2*r**2 - 5856*C*D1*Ddd*f**2*r*s + 4680*C*D1*Ddd*f**2*r - 2640*C*D1*Ddd*f**2*s**2 + 4248*C*D1*Ddd*f**2*s - 2268*C*D1*Ddd*f**2 - 9648*C*Dd**2*f**2*r**2 - 17568*C*Dd**2*f**2*r*s + 14040*C*Dd**2*f**2*r - 7920*C*Dd**2*f**2*s**2 + 12744*C*Dd**2*f**2*s - 4536*C*Dd**2*f**2 + 300*D1**2*K*f*fd*r**2 + 2256*D1**2*K*f*fd*r*s - 1128*D1**2*K*f*fd*r + 1956*D1**2*K*f*fd*s**2 - 1956*D1**2*K*f*fd*s + 978*D1**2*K*f*fd - 780*D1**2*K*f*fdd*r**2 - 2808*D1**2*K*f*fdd*r*s + 1404*D1**2*K*f*fdd*r - 2028*D1**2*K*f*fdd*s**2 + 2028*D1**2*K*f*fdd*s - 1014*D1**2*K*f*fdd - 780*D1**2*K*fd**2*r**2 - 2808*D1**2*K*fd**2*r*s + 1404*D1**2*K*fd**2*r - 2028*D1**2*K*fd**2*s**2 + 2028*D1**2*K*fd**2*s + 280*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(180*f**2*(r + s - 1)**2 + 7*f*(12*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*K*(37*r**2 + 74*r*s - 80*r + 37*s**2 - 80*s + 40) + 92*r**2 + 184*r*s - 214*r + 92*s**2 - 214*s + 107) - 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 900*D1**2*f**2*fd*r**2 + 360*D1**2*f**2*fd*r*s - 840*D1**2*f**2*fd*r - 540*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s + 210*D1**2*f**2*fd - 720*D1**2*f**2*fdd*r**2 + 720*D1**2*f**2*fdd*r + 720*D1**2*f**2*fdd*s**2 - 240*D1**2*f**2*fdd*s - 240*D1**2*f**2*fdd - 1440*D1**2*f*fd**2*r**2 + 1440*D1**2*f*fd**2*r + 1440*D1**2*f*fd**2*s**2 - 480*D1**2*f*fd**2*s - 240*D1**2*f*fd**2 - 1950*D1**2*f*fd*r**2 - 4572*D1**2*f*fd*r*s + 2298*D1**2*f*fd*r - 2622*D1**2*f*fd*s**2 + 2634*D1**2*f*fd*s - 1377*D1**2*f*fd + 2298*D1**2*f*fdd*r**2 + 4932*D1**2*f*fdd*r*s - 2430*D1**2*f*fdd*r + 2634*D1**2*f*fdd*s**2 - 2598*D1**2*f*fdd*s + 1371*D1**2*f*fdd - 812*D1**2*f*gd2*r**2 - 1904*D1**2*f*gd2*r*s + 1624*D1**2*f*gd2*r - 1092*D1**2*f*gd2*s**2 + 1904*D1**2*f*gd2*s - 812*D1**2*f*gd2 + 1036*D1**2*f*gdd2*r**2 + 2072*D1**2*f*gdd2*r*s - 2072*D1**2*f*gdd2*r + 1036*D1**2*f*gdd2*s**2 - 2072*D1**2*f*gdd2*s + 1036*D1**2*f*gdd2 + 2298*D1**2*fd**2*r**2 + 4932*D1**2*fd**2*r*s - 2430*D1**2*fd**2*r + 2634*D1**2*fd**2*s**2 - 2598*D1**2*fd**2*s - 180*D1**2*fd**2 - 812*D1**2*fd*g2*r**2 - 1904*D1**2*fd*g2*r*s - 112*D1**2*fd*g2*r - 1092*D1**2*fd*g2*s**2 - 112*D1**2*fd*g2*s + 56*D1**2*fd*g2 + 2072*D1**2*fd*gd2*r**2 + 4144*D1**2*fd*gd2*r*s - 1736*D1**2*fd*gd2*r + 2072*D1**2*fd*gd2*s**2 - 1736*D1**2*fd*gd2*s - 336*D1**2*fd*gd2 + 1036*D1**2*fdd*g2*r**2 + 2072*D1**2*fdd*g2*r*s + 336*D1**2*fdd*g2*r + 1036*D1**2*fdd*g2*s**2 + 336*D1**2*fdd*g2*s - 168*D1**2*fdd*g2 + 600*D1*Dd*K*f**2*r**2 + 4512*D1*Dd*K*f**2*r*s - 1728*D1*Dd*K*f**2*r + 3912*D1*Dd*K*f**2*s**2 - 4212*D1*Dd*K*f**2*s + 1278*D1*Dd*K*f**2 - 6240*D1*Dd*K*f*fd*r**2 - 22464*D1*Dd*K*f*fd*r*s + 11544*D1*Dd*K*f*fd*r - 16224*D1*Dd*K*f*fd*s**2 + 17784*D1*Dd*K*f*fd*s - 4836*D1*Dd*K*f*fd + 1200*D1*Dd*f**3*r**2 + 480*D1*Dd*f**3*r*s - 1320*D1*Dd*f**3*r - 720*D1*Dd*f**3*s**2 + 120*D1*Dd*f**3*s + 420*D1*Dd*f**3 - 5760*D1*Dd*f**2*fd*r**2 + 5760*D1*Dd*f**2*fd*r + 5760*D1*Dd*f**2*fd*s**2 - 2400*D1*Dd*f**2*fd*s - 1200*D1*Dd*f**2*fd - 3900*D1*Dd*f**2*r**2 - 9144*D1*Dd*f**2*r*s + 6186*D1*Dd*f**2*r - 5244*D1*Dd*f**2*s**2 + 7194*D1*Dd*f**2*s - 3261*D1*Dd*f**2 + 18384*D1*Dd*f*fd*r**2 + 39456*D1*Dd*f*fd*r*s - 23844*D1*Dd*f*fd*r + 21072*D1*Dd*f*fd*s**2 - 25524*D1*Dd*f*fd*s + 7458*D1*Dd*f*fd - 3248*D1*Dd*f*g2*r**2 - 7616*D1*Dd*f*g2*r*s + 5152*D1*Dd*f*g2*r - 4368*D1*Dd*f*g2*s**2 + 5992*D1*Dd*f*g2*s - 2716*D1*Dd*f*g2 + 8288*D1*Dd*f*gd2*r**2 + 16576*D1*Dd*f*gd2*r*s - 14504*D1*Dd*f*gd2*r + 8288*D1*Dd*f*gd2*s**2 - 14504*D1*Dd*f*gd2*s + 6216*D1*Dd*f*gd2 + 8288*D1*Dd*fd*g2*r**2 + 16576*D1*Dd*fd*g2*r*s - 4872*D1*Dd*fd*g2*r + 8288*D1*Dd*fd*g2*s**2 - 4872*D1*Dd*fd*g2*s - 1008*D1*Dd*fd*g2 - 1560*D1*Ddd*K*f**2*r**2 - 5616*D1*Ddd*K*f**2*r*s + 2964*D1*Ddd*K*f**2*r - 4056*D1*Ddd*K*f**2*s**2 + 4836*D1*Ddd*K*f**2*s - 1794*D1*Ddd*K*f**2 - 960*D1*Ddd*f**3*r**2 + 960*D1*Ddd*f**3*r + 960*D1*Ddd*f**3*s**2 - 480*D1*Ddd*f**3*s - 240*D1*Ddd*f**3 + 4596*D1*Ddd*f**2*r**2 + 9864*D1*Ddd*f**2*r*s - 7062*D1*Ddd*f**2*r + 5268*D1*Ddd*f**2*s**2 - 7566*D1*Ddd*f**2*s + 3615*D1*Ddd*f**2 + 4144*D1*Ddd*f*g2*r**2 + 8288*D1*Ddd*f*g2*r*s - 6216*D1*Ddd*f*g2*r + 4144*D1*Ddd*f*g2*s**2 - 6216*D1*Ddd*f*g2*s + 3108*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(3*f**2*(64*r**2 + 2*r*(64*s - 57) + 64*s**2 - 114*s + 57) + f*(28*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*K*(29*r**2 + r*(68*s - 65) + 39*s**2 - 75*s + 35) - 360*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 518*r**2 + 1176*r*(s - 1) + 658*s**2 - 1316*s + 623) - 14*fd*(r + s - 1)*(12*C*(2*r + 2*s - 1) - 2*K*(37*r + 37*s + 3) + 92*r + 92*s + 15) + 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 280*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(4*r + 4*s - 3)*(180*f**2*(r + s - 1) + 7*f*(12*C*(2*r + 2*s - 1) + K*(-74*r - 74*s + 80) + 92*r + 92*s - 107) - 140*g2*(2*r + 2*s - 1))) - 4680*Dd**2*K*f**2*r**2 - 16848*Dd**2*K*f**2*r*s + 8892*Dd**2*K*f**2*r - 12168*Dd**2*K*f**2*s**2 + 14508*Dd**2*K*f**2*s - 3588*Dd**2*K*f**2 - 2880*Dd**2*f**3*r**2 + 2880*Dd**2*f**3*r + 2880*Dd**2*f**3*s**2 - 1440*Dd**2*f**3*s - 480*Dd**2*f**3 + 13788*Dd**2*f**2*r**2 + 29592*Dd**2*f**2*r*s - 21186*Dd**2*f**2*r + 15804*Dd**2*f**2*s**2 - 22698*Dd**2*f**2*s + 7230*Dd**2*f**2 + 12432*Dd**2*f*g2*r**2 + 24864*Dd**2*f*g2*r*s - 18648*Dd**2*f*g2*r + 12432*Dd**2*f*g2*s**2 - 18648*Dd**2*f*g2*s + 6216*Dd**2*f*g2))/(315*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**3*k1**3*st**4*(D1**2*(105*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(315*fd**2*s*(2*s - 1) - fd*(44*C - 44)*(3*s**2 - 2*s + 1) + fdd*(22*C - 22)*(3*s**2 - 2*s + 1) + s**2*(33*K*bdd1 - 66*bd1*(K - 1) - 33*bdd1 + 132*gd2 - 66*gdd2)) - 44*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 3*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 3*fdd*g2*(2*s**2 - 2*s + 1)) + 264*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(105*f**3*(4*s**2 - 2*s + 1) + f**2*(44*C*(4*s**2 - 2*s + 1) - 105*fd*(1 - 4*s)**2 - 176*s**2 + 88*s - 44) - 22*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 6*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(3*K*bd1 - 3*bd1 - 6*gd2)) + 132*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(105*f**2 + f*(44*C - 44) - 132*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(105*f**2 + f*(44*C - 44) - 132*g2) + 66*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2*k3**4) - 8*D1**2*Pk2*Pk3*ct**3*k1**3*st**2*(b1*(D1**2*(50*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-100*fd**2*s*(3*s - 2) + 54*fd*(2*s**2 - 2*s + 1) - 27*fdd*(2*s**2 - 2*s + 1)) - 54*fd**2*s*(s - 1)) + D1*f*(2*Dd*(50*f**2*(4*s**2 - 2*s + 1) - 50*f*fd*(12*s**2 - 7*s + 1) + 27*f*(4*s**2 - 2*s + 1) - 27*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(50*f + 27)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(50*f + 27)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(100*bd1 - 50*bdd1) + f*(-10*fd*(s**2*(30*bd1 - 9) + s*(6 - 10*bd1) - 3) - 15*fdd*(3*s**2 - 2*s + 1) - 3*s**2*(-18*bd1 + 9*bdd1)) + 6*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(-2*Dd*(5*f*(s**2*(40*bd1 - 12) + s*(6 - 10*bd1) - 3) + (12*s - 3)*(9*bd1*s + 5*fd*(3*s - 1))) - 15*Ddd*f*(4*s**2 - 2*s + 1)) + 90*Dd**2*f**2*s*(1 - 2*s)))/(105*d**2*k2**3*k3**2) - 2*D1**2*Pk2*Pk3*ct**3*k1**3*(18*b1**2*(D1**2*s**2*(-20*fd**2 + fd*(40*f + 14) - fdd*(20*f + 7)) + D1*(2*Dd*(10*f**2*(4*s**2 - 2*s + 1) + f*(s**2*(28 - 80*fd) + s*(20*fd - 14) + 7) + 7*fd*s*(1 - 4*s)) - Ddd*f*(10*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(10*f + 7)*(2*s - 1)) + 9*b1*(-2*D1**2*bdd1*f*(10*f + 7)*(2*s**2 - 2*s + 1) - 330*D1**2*f**2*fd*s**2 + 220*D1**2*f**2*fd*s - 110*D1**2*f**2*fd + 210*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 70*D1**2*f**2*fdd + 420*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s - 98*D1**2*f*fd*s**2 + 138*D1**2*f*fd*s - 69*D1**2*f*fd + 70*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 45*D1**2*f*fdd + 70*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 440*D1*Dd*f**3*s**2 + 220*D1*Dd*f**3*s - 110*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*s**2 - 980*D1*Dd*f**2*fd*s + 140*D1*Dd*f**2*fd - 196*D1*Dd*f**2*s**2 + 98*D1*Dd*f**2*s - 49*D1*Dd*f**2 + 560*D1*Dd*f*fd*s**2 - 500*D1*Dd*f*fd*s + 90*D1*Dd*f*fd + 280*D1*Ddd*f**3*s**2 - 140*D1*Ddd*f**3*s + 70*D1*Ddd*f**3 + 140*D1*Ddd*f**2*s**2 - 70*D1*Ddd*f**2*s + 35*D1*Ddd*f**2 + 4*D1*bd1*(D1*(10*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(14 - 40*fd) + s*(20*fd - 14) + 7) + 7*fd*s*(1 - 2*s)) - Dd*f*(10*f + 7)*(8*s**2 - 6*s + 1)) + 840*Dd**2*f**3*s**2 - 420*Dd**2*f**3*s + 420*Dd**2*f**2*s**2 - 210*Dd**2*f**2*s) + f*(-36*D1**2*bd1**2*s*(10*f + 7)*(s - 1) + 45*D1**2*bdd1*f*(s**2*(14*f + 7) + 4*s - 2) + 5*D1**2*(-f*(91*fd - 59*fdd)*(3*s**2 - 2*s + 1) + 118*fd**2*s*(3*s - 2)) - 9*D1*bd1*(D1*(110*f**2*s**2 + f*(-s**2*(420*fd - 49) + s*(140*fd + 40) - 20) + 10*fd*s*(5 - 14*s)) - 10*Dd*f*(4*s - 1)*(s*(14*f + 7) + 2)) + 5*D1*f*(-91*Dd*f*(4*s**2 - 2*s + 1) + 118*Dd*fd*(12*s**2 - 7*s + 1) + 59*Ddd*f*(4*s**2 - 2*s + 1)) + 1770*Dd**2*f**2*s*(2*s - 1)))/(315*d**2*k2**3*k3**2) + 4*D1**2*Pk2*Pk3*ct**3*k1*k2**5*st**4*(-72*C*D1**2*f**2*fd*r**2 - 144*C*D1**2*f**2*fd*r*s + 96*C*D1**2*f**2*fd*r - 72*C*D1**2*f**2*fd*s**2 + 96*C*D1**2*f**2*fd*s - 48*C*D1**2*f**2*fd + 36*C*D1**2*f**2*fdd*r**2 + 72*C*D1**2*f**2*fdd*r*s - 48*C*D1**2*f**2*fdd*r + 36*C*D1**2*f**2*fdd*s**2 - 48*C*D1**2*f**2*fdd*s + 24*C*D1**2*f**2*fdd + 72*C*D1**2*f*fd**2*r**2 + 144*C*D1**2*f*fd**2*r*s - 96*C*D1**2*f*fd**2*r + 72*C*D1**2*f*fd**2*s**2 - 96*C*D1**2*f*fd**2*s + 24*C*D1**2*f*fd**2 - 96*C*D1*Dd*f**3*r**2 - 192*C*D1*Dd*f**3*r*s + 144*C*D1*Dd*f**3*r - 96*C*D1*Dd*f**3*s**2 + 144*C*D1*Dd*f**3*s - 72*C*D1*Dd*f**3 + 288*C*D1*Dd*f**2*fd*r**2 + 576*C*D1*Dd*f**2*fd*r*s - 408*C*D1*Dd*f**2*fd*r + 288*C*D1*Dd*f**2*fd*s**2 - 408*C*D1*Dd*f**2*fd*s + 144*C*D1*Dd*f**2*fd + 48*C*D1*Ddd*f**3*r**2 + 96*C*D1*Ddd*f**3*r*s - 72*C*D1*Ddd*f**3*r + 48*C*D1*Ddd*f**3*s**2 - 72*C*D1*Ddd*f**3*s + 36*C*D1*Ddd*f**3 + 144*C*Dd**2*f**3*r**2 + 288*C*Dd**2*f**3*r*s - 216*C*Dd**2*f**3*r + 144*C*Dd**2*f**3*s**2 - 216*C*Dd**2*f**3*s + 72*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 - 144*D1**2*K*b1*f*fd*r*s + 72*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 + 54*D1**2*f**2*fd*r**2 + 108*D1**2*f**2*fd*r*s - 72*D1**2*f**2*fd*r + 54*D1**2*f**2*fd*s**2 - 72*D1**2*f**2*fd*s + 36*D1**2*f**2*fd - 27*D1**2*f**2*fdd*r**2 - 54*D1**2*f**2*fdd*r*s + 36*D1**2*f**2*fdd*r - 27*D1**2*f**2*fdd*s**2 + 36*D1**2*f**2*fdd*s - 18*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r - 36*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 54*D1**2*f*fd**2*r**2 - 108*D1**2*f*fd**2*r*s + 72*D1**2*f*fd**2*r - 54*D1**2*f*fd**2*s**2 + 72*D1**2*f*fd**2*s - 18*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 - 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 216*D1*Dd*K*b1*f**2*s - 108*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r**2 + 576*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 360*D1*Dd*K*b1*f*fd*s + 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 72*D1*Dd*f**3*r**2 + 144*D1*Dd*f**3*r*s - 108*D1*Dd*f**3*r + 72*D1*Dd*f**3*s**2 - 108*D1*Dd*f**3*s + 54*D1*Dd*f**3 - 216*D1*Dd*f**2*fd*r**2 - 432*D1*Dd*f**2*fd*r*s + 306*D1*Dd*f**2*fd*r - 216*D1*Dd*f**2*fd*s**2 + 306*D1*Dd*f**2*fd*s - 108*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 504*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 720*D1*Dd*f*fd*g2*s - 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 + 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 108*D1*Ddd*K*b1*f**2*s + 54*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 36*D1*Ddd*f**3*r**2 - 72*D1*Ddd*f**3*r*s + 54*D1*Ddd*f**3*r - 36*D1*Ddd*f**3*s**2 + 54*D1*Ddd*f**3*s - 27*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 216*D1*Ddd*f**2*g2*s - 108*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*b1*f**2*r**2 + 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 324*Dd**2*K*b1*f**2*s + 108*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 108*Dd**2*f**3*r**2 - 216*Dd**2*f**3*r*s + 162*Dd**2*f**3*r - 108*Dd**2*f**3*s**2 + 162*Dd**2*f**3*s - 54*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 648*Dd**2*f**2*g2*s - 216*Dd**2*f**2*g2)/(7*d**2*k3**8) + 8*D1**2*Pk2*Pk3*ct**3*k1*k2**5*st**2*(108*C*D1**2*bdd1*f**2*r**2 + 216*C*D1**2*bdd1*f**2*r*s - 216*C*D1**2*bdd1*f**2*r + 108*C*D1**2*bdd1*f**2*s**2 - 216*C*D1**2*bdd1*f**2*s + 108*C*D1**2*bdd1*f**2 - 552*C*D1**2*f**2*fd*r**2 - 1104*C*D1**2*f**2*fd*r*s + 736*C*D1**2*f**2*fd*r - 552*C*D1**2*f**2*fd*s**2 + 736*C*D1**2*f**2*fd*s - 368*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r**2 + 1200*C*D1**2*f**2*fdd*r*s - 800*C*D1**2*f**2*fdd*r + 600*C*D1**2*f**2*fdd*s**2 - 800*C*D1**2*f**2*fdd*s + 400*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r**2 + 2400*C*D1**2*f*fd**2*r*s - 1600*C*D1**2*f*fd**2*r + 1200*C*D1**2*f*fd**2*s**2 - 1600*C*D1**2*f*fd**2*s + 400*C*D1**2*f*fd**2 - 736*C*D1*Dd*f**3*r**2 - 1472*C*D1*Dd*f**3*r*s + 1104*C*D1*Dd*f**3*r - 736*C*D1*Dd*f**3*s**2 + 1104*C*D1*Dd*f**3*s - 552*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r**2 + 9600*C*D1*Dd*f**2*fd*r*s - 6800*C*D1*Dd*f**2*fd*r + 4800*C*D1*Dd*f**2*fd*s**2 - 6800*C*D1*Dd*f**2*fd*s + 2400*C*D1*Dd*f**2*fd + 800*C*D1*Ddd*f**3*r**2 + 1600*C*D1*Ddd*f**3*r*s - 1200*C*D1*Ddd*f**3*r + 800*C*D1*Ddd*f**3*s**2 - 1200*C*D1*Ddd*f**3*s + 600*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r**2 + 4800*C*Dd**2*f**3*r*s - 3600*C*Dd**2*f**3*r + 2400*C*Dd**2*f**3*s**2 - 3600*C*Dd**2*f**3*s + 1200*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r**2 + 360*D1**2*K*bdd1*f**2*r*s - 360*D1**2*K*bdd1*f**2*r + 180*D1**2*K*bdd1*f**2*s**2 - 360*D1**2*K*bdd1*f**2*s + 180*D1**2*K*bdd1*f**2 - 18*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 81*D1**2*bdd1*f**2*r**2 - 162*D1**2*bdd1*f**2*r*s + 162*D1**2*bdd1*f**2*r - 81*D1**2*bdd1*f**2*s**2 + 162*D1**2*bdd1*f**2*s - 81*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r**2 - 504*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 252*D1**2*bdd1*f*g2*s**2 + 504*D1**2*bdd1*f*g2*s - 252*D1**2*bdd1*f*g2 + 195*D1**2*f**2*fd*r**2 + 390*D1**2*f**2*fd*r*s - 260*D1**2*f**2*fd*r + 195*D1**2*f**2*fd*s**2 - 260*D1**2*f**2*fd*s + 130*D1**2*f**2*fd - 300*D1**2*f**2*fdd*r**2 - 600*D1**2*f**2*fdd*r*s + 400*D1**2*f**2*fdd*r - 300*D1**2*f**2*fdd*s**2 + 400*D1**2*f**2*fdd*s - 200*D1**2*f**2*fdd + 216*D1**2*f**2*gd2*r**2 + 432*D1**2*f**2*gd2*r*s - 432*D1**2*f**2*gd2*r + 216*D1**2*f**2*gd2*s**2 - 432*D1**2*f**2*gd2*s + 216*D1**2*f**2*gd2 - 360*D1**2*f**2*gdd2*r**2 - 720*D1**2*f**2*gdd2*r*s + 720*D1**2*f**2*gdd2*r - 360*D1**2*f**2*gdd2*s**2 + 720*D1**2*f**2*gdd2*s - 360*D1**2*f**2*gdd2 - 600*D1**2*f*fd**2*r**2 - 1200*D1**2*f*fd**2*r*s + 800*D1**2*f*fd**2*r - 600*D1**2*f*fd**2*s**2 + 800*D1**2*f*fd**2*s - 200*D1**2*f*fd**2 + 432*D1**2*f*fd*g2*r**2 + 864*D1**2*f*fd*g2*r*s - 432*D1**2*f*fd*g2*r + 432*D1**2*f*fd*g2*s**2 - 432*D1**2*f*fd*g2*s + 216*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r**2 - 2880*D1**2*f*fd*gd2*r*s + 2160*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 2160*D1**2*f*fd*gd2*s - 720*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r**2 - 1440*D1**2*f*fdd*g2*r*s + 720*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r**2 - 1440*D1**2*fd**2*g2*r*s + 720*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s + 260*D1*Dd*f**3*r**2 + 520*D1*Dd*f**3*r*s - 390*D1*Dd*f**3*r + 260*D1*Dd*f**3*s**2 - 390*D1*Dd*f**3*s + 195*D1*Dd*f**3 - 2400*D1*Dd*f**2*fd*r**2 - 4800*D1*Dd*f**2*fd*r*s + 3400*D1*Dd*f**2*fd*r - 2400*D1*Dd*f**2*fd*s**2 + 3400*D1*Dd*f**2*fd*s - 1200*D1*Dd*f**2*fd + 864*D1*Dd*f**2*g2*r**2 + 1728*D1*Dd*f**2*g2*r*s - 1296*D1*Dd*f**2*g2*r + 864*D1*Dd*f**2*g2*s**2 - 1296*D1*Dd*f**2*g2*s + 648*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r**2 - 5760*D1*Dd*f**2*gd2*r*s + 5040*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 5040*D1*Dd*f**2*gd2*s - 2160*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r**2 - 11520*D1*Dd*f*fd*g2*r*s + 7200*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 7200*D1*Dd*f*fd*g2*s - 2160*D1*Dd*f*fd*g2 - 400*D1*Ddd*f**3*r**2 - 800*D1*Ddd*f**3*r*s + 600*D1*Ddd*f**3*r - 400*D1*Ddd*f**3*s**2 + 600*D1*Ddd*f**3*s - 300*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r**2 - 2880*D1*Ddd*f**2*g2*r*s + 2160*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 2160*D1*Ddd*f**2*g2*s - 1080*D1*Ddd*f**2*g2 - 9*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(24*C + 12*K - 11)*(r + s - 1) - 2*f*(fd*(12*C + 20*K - 9)*(2*r + 2*s - 1) + (28*g2 - 28*gd2)*(r + s - 1)) + 56*fd*g2*(r + s)) - 2*Dd*f*(f*(12*C + 20*K - 9) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1200*Dd**2*f**3*r**2 - 2400*Dd**2*f**3*r*s + 1800*Dd**2*f**3*r - 1200*Dd**2*f**3*s**2 + 1800*Dd**2*f**3*s - 600*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r**2 - 8640*Dd**2*f**2*g2*r*s + 6480*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 6480*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 + 9*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(-48*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 144*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(105*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**3*k1*k2**5*(D1*(-168*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(3*f**2*(24*C - 14*K - 5)*(r + s - 1) - 8*f*(fd*(30*C - 15)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 336*fd*g2*(r + s)) - 24*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6*f*(2*D1*bdd1*(f*(10*C - 5) - 14*g2)*(r + s - 1)**2 + D1*(f*(fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*gd2*(r + s - 1)**2) - 14*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + 7*b1**2*(D1**2*(3*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-12*K*fdd + fd*(4*K + 5))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*K + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*(f*(3*fd*(24*C - 14*K - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(120*C - 60)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s - 1)**2*(-168*K*bdd1 - 56*gd2 + 168*gdd2)) + (-8*r - 8*s)*(fd**2*(30*C - 15)*(r + s - 1) + 7*fd*(g2*(r + s) - 6*gd2*(r + s - 1)) - 21*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-24*K*fd*(r + s) + 3*f**2*(r + s - 1) + f*(4*K + 5)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(3*f**2*(24*C - 14*K - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*f*(fd*(30*C - 15)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 42*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 336*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(10*C - 5) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(35*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**3*k1*k2**3*st**4*(-456*C*D1**2*f**2*fd*r**2 + 264*C*D1**2*f**2*fd*r*s + 216*C*D1**2*f**2*fd*r + 720*C*D1**2*f**2*fd*s**2 - 568*C*D1**2*f**2*fd*s + 88*C*D1**2*f**2*fd + 300*C*D1**2*f**2*fdd*r**2 - 60*C*D1**2*f**2*fdd*r*s - 180*C*D1**2*f**2*fdd*r - 360*C*D1**2*f**2*fdd*s**2 + 260*C*D1**2*f**2*fdd*s - 20*C*D1**2*f**2*fdd + 600*C*D1**2*f*fd**2*r**2 - 120*C*D1**2*f*fd**2*r*s - 360*C*D1**2*f*fd**2*r - 720*C*D1**2*f*fd**2*s**2 + 520*C*D1**2*f*fd**2*s - 20*C*D1**2*f*fd**2 - 608*C*D1*Dd*f**3*r**2 + 352*C*D1*Dd*f**3*r*s + 520*C*D1*Dd*f**3*r + 960*C*D1*Dd*f**3*s**2 - 656*C*D1*Dd*f**3*s - 64*C*D1*Dd*f**3 + 2400*C*D1*Dd*f**2*fd*r**2 - 480*C*D1*Dd*f**2*fd*r*s - 1860*C*D1*Dd*f**2*fd*r - 2880*C*D1*Dd*f**2*fd*s**2 + 1880*C*D1*Dd*f**2*fd*s + 100*C*D1*Dd*f**2*fd + 400*C*D1*Ddd*f**3*r**2 - 80*C*D1*Ddd*f**3*r*s - 380*C*D1*Ddd*f**3*r - 480*C*D1*Ddd*f**3*s**2 + 280*C*D1*Ddd*f**3*s + 80*C*D1*Ddd*f**3 + 1200*C*Dd**2*f**3*r**2 - 240*C*Dd**2*f**3*r*s - 1140*C*Dd**2*f**3*r - 1440*C*Dd**2*f**3*s**2 + 840*C*Dd**2*f**3*s + 160*C*Dd**2*f**3 - 360*D1**2*K*b1*f*fd*r**2 + 360*D1**2*K*b1*f*fd*r*s - 180*D1**2*K*b1*f*fd*r + 720*D1**2*K*b1*f*fd*s**2 - 720*D1**2*K*b1*f*fd*s + 360*D1**2*K*b1*f*fd + 180*D1**2*K*b1*f*fdd*r**2 - 180*D1**2*K*b1*f*fdd*r*s + 90*D1**2*K*b1*f*fdd*r - 360*D1**2*K*b1*f*fdd*s**2 + 360*D1**2*K*b1*f*fdd*s - 180*D1**2*K*b1*f*fdd + 180*D1**2*K*b1*fd**2*r**2 - 180*D1**2*K*b1*fd**2*r*s + 90*D1**2*K*b1*fd**2*r - 360*D1**2*K*b1*fd**2*s**2 + 360*D1**2*K*b1*fd**2*s + 210*D1**2*b1*f**2*fd*r**2 - 140*D1**2*b1*f**2*fd*r - 210*D1**2*b1*f**2*fd*s**2 + 140*D1**2*b1*f**2*fd*s - 105*D1**2*b1*f**2*fdd*r**2 + 70*D1**2*b1*f**2*fdd*r + 105*D1**2*b1*f**2*fdd*s**2 - 70*D1**2*b1*f**2*fdd*s - 210*D1**2*b1*f*fd**2*r**2 + 140*D1**2*b1*f*fd**2*r + 210*D1**2*b1*f*fd**2*s**2 - 140*D1**2*b1*f*fd**2*s + 540*D1**2*b1*f*fd*r**2 + 360*D1**2*b1*f*fd*r*s - 180*D1**2*b1*f*fd*r - 180*D1**2*b1*f*fd*s**2 + 180*D1**2*b1*f*fd*s - 90*D1**2*b1*f*fd - 270*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r + 90*D1**2*b1*f*fdd*s**2 - 90*D1**2*b1*f*fdd*s + 45*D1**2*b1*f*fdd - 270*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r + 90*D1**2*b1*fd**2*s**2 - 90*D1**2*b1*fd**2*s - 5*D1**2*bdd1*f**2*(r + s - 1)*(-18*K*(r - 2*s - 1) + 7*f*(r - s - 1) + 27*r - 9*s - 27) - 280*D1**2*f**3*fd*r**2 - 280*D1**2*f**3*fd*r*s + 350*D1**2*f**3*fd*r + 140*D1**2*f**3*fd*s - 140*D1**2*f**3*fd + 280*D1**2*f**3*fdd*r**2 + 280*D1**2*f**3*fdd*r*s - 350*D1**2*f**3*fdd*r - 140*D1**2*f**3*fdd*s + 140*D1**2*f**3*fdd + 840*D1**2*f**2*fd**2*r**2 + 840*D1**2*f**2*fd**2*r*s - 1050*D1**2*f**2*fd**2*r - 420*D1**2*f**2*fd**2*s + 280*D1**2*f**2*fd**2 + 546*D1**2*f**2*fd*r**2 + 96*D1**2*f**2*fd*r*s - 396*D1**2*f**2*fd*r - 450*D1**2*f**2*fd*s**2 + 268*D1**2*f**2*fd*s + 32*D1**2*f**2*fd - 345*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 270*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 110*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd + 360*D1**2*f**2*gd2*r**2 - 360*D1**2*f**2*gd2*r*s - 720*D1**2*f**2*gd2*r - 720*D1**2*f**2*gd2*s**2 + 360*D1**2*f**2*gd2*s + 360*D1**2*f**2*gd2 - 180*D1**2*f**2*gdd2*r**2 + 180*D1**2*f**2*gdd2*r*s + 360*D1**2*f**2*gdd2*r + 360*D1**2*f**2*gdd2*s**2 - 180*D1**2*f**2*gdd2*s - 180*D1**2*f**2*gdd2 - 690*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 540*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 220*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 720*D1**2*f*fd*g2*r**2 - 720*D1**2*f*fd*g2*r*s + 360*D1**2*f*fd*g2*r - 1440*D1**2*f*fd*g2*s**2 + 1440*D1**2*f*fd*g2*s - 720*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*r**2 + 720*D1**2*f*fd*gd2*r*s + 540*D1**2*f*fd*gd2*r + 1440*D1**2*f*fd*gd2*s**2 - 1080*D1**2*f*fd*gd2*s + 180*D1**2*f*fd*gd2 - 360*D1**2*f*fdd*g2*r**2 + 360*D1**2*f*fdd*g2*r*s - 180*D1**2*f*fdd*g2*r + 720*D1**2*f*fdd*g2*s**2 - 720*D1**2*f*fdd*g2*s + 360*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*r**2 + 360*D1**2*fd**2*g2*r*s - 180*D1**2*fd**2*g2*r + 720*D1**2*fd**2*g2*s**2 - 720*D1**2*fd**2*g2*s - 720*D1*Dd*K*b1*f**2*r**2 + 720*D1*Dd*K*b1*f**2*r*s + 540*D1*Dd*K*b1*f**2*r + 1440*D1*Dd*K*b1*f**2*s**2 - 1080*D1*Dd*K*b1*f**2*s + 1440*D1*Dd*K*b1*f*fd*r**2 - 1440*D1*Dd*K*b1*f*fd*r*s - 180*D1*Dd*K*b1*f*fd*r - 2880*D1*Dd*K*b1*f*fd*s**2 + 2520*D1*Dd*K*b1*f*fd*s - 540*D1*Dd*K*b1*f*fd + 280*D1*Dd*b1*f**3*r**2 - 280*D1*Dd*b1*f**3*r - 280*D1*Dd*b1*f**3*s**2 + 140*D1*Dd*b1*f**3*s + 70*D1*Dd*b1*f**3 - 840*D1*Dd*b1*f**2*fd*r**2 + 700*D1*Dd*b1*f**2*fd*r + 840*D1*Dd*b1*f**2*fd*s**2 - 490*D1*Dd*b1*f**2*fd*s - 70*D1*Dd*b1*f**2*fd + 1080*D1*Dd*b1*f**2*r**2 + 720*D1*Dd*b1*f**2*r*s - 1260*D1*Dd*b1*f**2*r - 360*D1*Dd*b1*f**2*s**2 - 180*D1*Dd*b1*f**2*s + 450*D1*Dd*b1*f**2 - 2160*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 1620*D1*Dd*b1*f*fd*r + 720*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s - 90*D1*Dd*b1*f*fd - 280*D1*Dd*f**4*r**2 - 280*D1*Dd*f**4*r*s + 350*D1*Dd*f**4*r + 140*D1*Dd*f**4*s - 140*D1*Dd*f**4 + 2240*D1*Dd*f**3*fd*r**2 + 2240*D1*Dd*f**3*fd*r*s - 2800*D1*Dd*f**3*fd*r - 1120*D1*Dd*f**3*fd*s + 840*D1*Dd*f**3*fd + 728*D1*Dd*f**3*r**2 + 128*D1*Dd*f**3*r*s - 760*D1*Dd*f**3*r - 600*D1*Dd*f**3*s**2 + 236*D1*Dd*f**3*s + 214*D1*Dd*f**3 - 2760*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 2580*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 650*D1*Dd*f**2*fd*s - 430*D1*Dd*f**2*fd + 1440*D1*Dd*f**2*g2*r**2 - 1440*D1*Dd*f**2*g2*r*s - 1080*D1*Dd*f**2*g2*r - 2880*D1*Dd*f**2*g2*s**2 + 2160*D1*Dd*f**2*g2*s - 1440*D1*Dd*f**2*gd2*r**2 + 1440*D1*Dd*f**2*gd2*r*s + 1980*D1*Dd*f**2*gd2*r + 2880*D1*Dd*f**2*gd2*s**2 - 1800*D1*Dd*f**2*gd2*s - 540*D1*Dd*f**2*gd2 - 2880*D1*Dd*f*fd*g2*r**2 + 2880*D1*Dd*f*fd*g2*r*s + 360*D1*Dd*f*fd*g2*r + 5760*D1*Dd*f*fd*g2*s**2 - 5040*D1*Dd*f*fd*g2*s + 1080*D1*Dd*f*fd*g2 + 360*D1*Ddd*K*b1*f**2*r**2 - 360*D1*Ddd*K*b1*f**2*r*s - 270*D1*Ddd*K*b1*f**2*r - 720*D1*Ddd*K*b1*f**2*s**2 + 540*D1*Ddd*K*b1*f**2*s - 140*D1*Ddd*b1*f**3*r**2 + 140*D1*Ddd*b1*f**3*r + 140*D1*Ddd*b1*f**3*s**2 - 70*D1*Ddd*b1*f**3*s - 35*D1*Ddd*b1*f**3 - 540*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 630*D1*Ddd*b1*f**2*r + 180*D1*Ddd*b1*f**2*s**2 + 90*D1*Ddd*b1*f**2*s - 225*D1*Ddd*b1*f**2 + 280*D1*Ddd*f**4*r**2 + 280*D1*Ddd*f**4*r*s - 350*D1*Ddd*f**4*r - 140*D1*Ddd*f**4*s + 140*D1*Ddd*f**4 - 460*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 500*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 70*D1*Ddd*f**3*s - 155*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*r**2 + 720*D1*Ddd*f**2*g2*r*s + 540*D1*Ddd*f**2*g2*r + 1440*D1*Ddd*f**2*g2*s**2 - 1080*D1*Ddd*f**2*g2*s + 10*D1*bd1*f*(D1*(7*f**2*(r**2 - 2*r - s**2 + 1) + f*(-7*fd*(3*r**2 - 4*r - 3*s**2 + s + 1) + (-9*r - 9*s + 9)*(2*K*(r - 2*s - 1) - 3*r + s + 3)) + 9*fd*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1)) + Dd*f*(9*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 7*f*(4*r**2 - 6*r - 4*s**2 + s + 2) - 108*r**2 - 72*r*s + 171*r + 36*s**2 + 45*s - 63)) + 1080*Dd**2*K*b1*f**2*r**2 - 1080*Dd**2*K*b1*f**2*r*s - 810*Dd**2*K*b1*f**2*r - 2160*Dd**2*K*b1*f**2*s**2 + 1620*Dd**2*K*b1*f**2*s - 420*Dd**2*b1*f**3*r**2 + 420*Dd**2*b1*f**3*r + 420*Dd**2*b1*f**3*s**2 - 210*Dd**2*b1*f**3*s - 70*Dd**2*b1*f**3 - 1620*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 1890*Dd**2*b1*f**2*r + 540*Dd**2*b1*f**2*s**2 + 270*Dd**2*b1*f**2*s - 450*Dd**2*b1*f**2 + 840*Dd**2*f**4*r**2 + 840*Dd**2*f**4*r*s - 1050*Dd**2*f**4*r - 420*Dd**2*f**4*s + 280*Dd**2*f**4 - 1380*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 1500*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 210*Dd**2*f**3*s - 310*Dd**2*f**3 - 2160*Dd**2*f**2*g2*r**2 + 2160*Dd**2*f**2*g2*r*s + 1620*Dd**2*f**2*g2*r + 4320*Dd**2*f**2*g2*s**2 - 3240*Dd**2*f**2*g2*s)/(105*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**3*k1*k2**3*st**2*(144*C*D1**2*bdd1*f**2*r**2 - 72*C*D1**2*bdd1*f**2*r*s - 360*C*D1**2*bdd1*f**2*r - 216*C*D1**2*bdd1*f**2*s**2 - 7188*C*D1**2*f**2*fd*r**2 - 13056*C*D1**2*f**2*fd*r*s + 9144*C*D1**2*f**2*fd*r - 5868*C*D1**2*f**2*fd*s**2 + 8264*C*D1**2*f**2*fd*s - 4352*C*D1**2*f**2*fd + 6348*C*D1**2*f**2*fdd*r**2 + 11064*C*D1**2*f**2*fdd*r*s - 7920*C*D1**2*f**2*fdd*r + 4716*C*D1**2*f**2*fdd*s**2 - 6832*C*D1**2*f**2*fdd*s + 3688*C*D1**2*f**2*fdd + 12696*C*D1**2*f*fd**2*r**2 + 22128*C*D1**2*f*fd**2*r*s - 15840*C*D1**2*f*fd**2*r + 9432*C*D1**2*f*fd**2*s**2 - 13664*C*D1**2*f*fd**2*s + 3688*C*D1**2*f*fd**2 - 9584*C*D1*Dd*f**3*r**2 - 17408*C*D1*Dd*f**3*r*s + 13936*C*D1*Dd*f**3*r - 7824*C*D1*Dd*f**3*s**2 + 12616*C*D1*Dd*f**3*s - 6748*C*D1*Dd*f**3 + 50784*C*D1*Dd*f**2*fd*r**2 + 88512*C*D1*Dd*f**2*fd*r*s - 68136*C*D1*Dd*f**2*fd*r + 37728*C*D1*Dd*f**2*fd*s**2 - 58888*C*D1*Dd*f**2*fd*s + 22672*C*D1*Dd*f**2*fd + 8464*C*D1*Ddd*f**3*r**2 + 14752*C*D1*Ddd*f**3*r*s - 12152*C*D1*Ddd*f**3*r + 6288*C*D1*Ddd*f**3*s**2 - 10520*C*D1*Ddd*f**3*s + 5804*C*D1*Ddd*f**3 + 25392*C*Dd**2*f**3*r**2 + 44256*C*Dd**2*f**3*r*s - 36456*C*Dd**2*f**3*r + 18864*C*Dd**2*f**3*s**2 - 31560*C*Dd**2*f**3*s + 11608*C*Dd**2*f**3 + 1530*D1**2*K*bdd1*f**2*r**2 + 3204*D1**2*K*bdd1*f**2*r*s - 3060*D1**2*K*bdd1*f**2*r + 1674*D1**2*K*bdd1*f**2*s**2 - 3204*D1**2*K*bdd1*f**2*s + 1530*D1**2*K*bdd1*f**2 - 936*D1**2*b2*f*fd*r**2 - 1872*D1**2*b2*f*fd*r*s + 936*D1**2*b2*f*fd*r - 936*D1**2*b2*f*fd*s**2 + 936*D1**2*b2*f*fd*s - 468*D1**2*b2*f*fd + 720*D1**2*b2*f*fdd*r**2 + 1440*D1**2*b2*f*fdd*r*s - 720*D1**2*b2*f*fdd*r + 720*D1**2*b2*f*fdd*s**2 - 720*D1**2*b2*f*fdd*s + 360*D1**2*b2*f*fdd + 720*D1**2*b2*fd**2*r**2 + 1440*D1**2*b2*fd**2*r*s - 720*D1**2*b2*fd**2*r + 720*D1**2*b2*fd**2*s**2 - 720*D1**2*b2*fd**2*s + 36*D1**2*bd1**2*f*(r + s - 1)*(-14*K*s - 7*K + 5*f - 14*r + 14) - 468*D1**2*bd2*f**2*r**2 - 936*D1**2*bd2*f**2*r*s + 936*D1**2*bd2*f**2*r - 468*D1**2*bd2*f**2*s**2 + 936*D1**2*bd2*f**2*s - 468*D1**2*bd2*f**2 + 1440*D1**2*bd2*f*fd*r**2 + 2880*D1**2*bd2*f*fd*r*s - 2160*D1**2*bd2*f*fd*r + 1440*D1**2*bd2*f*fd*s**2 - 2160*D1**2*bd2*f*fd*s + 720*D1**2*bd2*f*fd - 495*D1**2*bdd1*f**3*r**2 - 990*D1**2*bdd1*f**3*r*s + 1170*D1**2*bdd1*f**3*r - 495*D1**2*bdd1*f**3*s**2 + 1170*D1**2*bdd1*f**3*s - 675*D1**2*bdd1*f**3 - 837*D1**2*bdd1*f**2*r**2 - 1386*D1**2*bdd1*f**2*r*s + 1638*D1**2*bdd1*f**2*r - 549*D1**2*bdd1*f**2*s**2 + 1350*D1**2*bdd1*f**2*s - 639*D1**2*bdd1*f**2 + 504*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r + 504*D1**2*bdd1*f*g2*s**2 + 360*D1**2*bdd2*f**2*r**2 + 720*D1**2*bdd2*f**2*r*s - 720*D1**2*bdd2*f**2*r + 360*D1**2*bdd2*f**2*s**2 - 720*D1**2*bdd2*f**2*s + 360*D1**2*bdd2*f**2 + 4629*D1**2*f**2*fd*r**2 + 8430*D1**2*f**2*fd*r*s - 5896*D1**2*f**2*fd*r + 3801*D1**2*f**2*fd*s**2 - 5344*D1**2*f**2*fd*s + 2810*D1**2*f**2*fd - 4461*D1**2*f**2*fdd*r**2 - 7698*D1**2*f**2*fdd*r*s + 5540*D1**2*f**2*fdd*r - 3237*D1**2*f**2*fdd*s**2 + 4724*D1**2*f**2*fdd*s - 2566*D1**2*f**2*fdd + 2844*D1**2*f**2*gd2*r**2 + 6768*D1**2*f**2*gd2*r*s - 5688*D1**2*f**2*gd2*r + 3924*D1**2*f**2*gd2*s**2 - 6768*D1**2*f**2*gd2*s + 2844*D1**2*f**2*gd2 - 3060*D1**2*f**2*gdd2*r**2 - 6408*D1**2*f**2*gdd2*r*s + 6120*D1**2*f**2*gdd2*r - 3348*D1**2*f**2*gdd2*s**2 + 6408*D1**2*f**2*gdd2*s - 3060*D1**2*f**2*gdd2 - 8922*D1**2*f*fd**2*r**2 - 15396*D1**2*f*fd**2*r*s + 11080*D1**2*f*fd**2*r - 6474*D1**2*f*fd**2*s**2 + 9448*D1**2*f*fd**2*s - 2566*D1**2*f*fd**2 + 5688*D1**2*f*fd*g2*r**2 + 13536*D1**2*f*fd*g2*r*s - 6768*D1**2*f*fd*g2*r + 7848*D1**2*f*fd*g2*s**2 - 7848*D1**2*f*fd*g2*s + 3924*D1**2*f*fd*g2 - 12240*D1**2*f*fd*gd2*r**2 - 25632*D1**2*f*fd*gd2*r*s + 18648*D1**2*f*fd*gd2*r - 13392*D1**2*f*fd*gd2*s**2 + 19512*D1**2*f*fd*gd2*s - 6408*D1**2*f*fd*gd2 - 6120*D1**2*f*fdd*g2*r**2 - 12816*D1**2*f*fdd*g2*r*s + 6408*D1**2*f*fdd*g2*r - 6696*D1**2*f*fdd*g2*s**2 + 6696*D1**2*f*fdd*g2*s - 3348*D1**2*f*fdd*g2 - 6120*D1**2*fd**2*g2*r**2 - 12816*D1**2*fd**2*g2*r*s + 6408*D1**2*fd**2*g2*r - 6696*D1**2*fd**2*g2*s**2 + 6696*D1**2*fd**2*g2*s - 1872*D1*Dd*b2*f**2*r**2 - 3744*D1*Dd*b2*f**2*r*s + 2808*D1*Dd*b2*f**2*r - 1872*D1*Dd*b2*f**2*s**2 + 2808*D1*Dd*b2*f**2*s - 1404*D1*Dd*b2*f**2 + 5760*D1*Dd*b2*f*fd*r**2 + 11520*D1*Dd*b2*f*fd*r*s - 7200*D1*Dd*b2*f*fd*r + 5760*D1*Dd*b2*f*fd*s**2 - 7200*D1*Dd*b2*f*fd*s + 2160*D1*Dd*b2*f*fd + 2880*D1*Dd*bd2*f**2*r**2 + 5760*D1*Dd*bd2*f**2*r*s - 5040*D1*Dd*bd2*f**2*r + 2880*D1*Dd*bd2*f**2*s**2 - 5040*D1*Dd*bd2*f**2*s + 2160*D1*Dd*bd2*f**2 + 6172*D1*Dd*f**3*r**2 + 11240*D1*Dd*f**3*r*s - 8982*D1*Dd*f**3*r + 5068*D1*Dd*f**3*s**2 - 8154*D1*Dd*f**3*s + 4353*D1*Dd*f**3 - 35688*D1*Dd*f**2*fd*r**2 - 61584*D1*Dd*f**2*fd*r*s + 47702*D1*Dd*f**2*fd*r - 25896*D1*Dd*f**2*fd*s**2 + 40766*D1*Dd*f**2*fd*s - 15804*D1*Dd*f**2*fd + 11376*D1*Dd*f**2*g2*r**2 + 27072*D1*Dd*f**2*g2*r*s - 18144*D1*Dd*f**2*g2*r + 15696*D1*Dd*f**2*g2*s**2 - 21384*D1*Dd*f**2*g2*s + 9612*D1*Dd*f**2*g2 - 24480*D1*Dd*f**2*gd2*r**2 - 51264*D1*Dd*f**2*gd2*r*s + 43128*D1*Dd*f**2*gd2*r - 26784*D1*Dd*f**2*gd2*s**2 + 45144*D1*Dd*f**2*gd2*s - 18648*D1*Dd*f**2*gd2 - 48960*D1*Dd*f*fd*g2*r**2 - 102528*D1*Dd*f*fd*g2*r*s + 62928*D1*Dd*f*fd*g2*r - 53568*D1*Dd*f*fd*g2*s**2 + 65808*D1*Dd*f*fd*g2*s - 19512*D1*Dd*f*fd*g2 + 1440*D1*Ddd*b2*f**2*r**2 + 2880*D1*Ddd*b2*f**2*r*s - 2160*D1*Ddd*b2*f**2*r + 1440*D1*Ddd*b2*f**2*s**2 - 2160*D1*Ddd*b2*f**2*s + 1080*D1*Ddd*b2*f**2 - 5948*D1*Ddd*f**3*r**2 - 10264*D1*Ddd*f**3*r*s + 8514*D1*Ddd*f**3*r - 4316*D1*Ddd*f**3*s**2 + 7290*D1*Ddd*f**3*s - 4053*D1*Ddd*f**3 - 12240*D1*Ddd*f**2*g2*r**2 - 25632*D1*Ddd*f**2*g2*r*s + 18648*D1*Ddd*f**2*g2*r - 13392*D1*Ddd*f**2*g2*s**2 + 19512*D1*Ddd*f**2*g2*s - 9468*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(15*f**3*(7*r**2 + 18*r*(s - 1) + 11*(s - 1)**2) + f**2*(-40*C*r**2 + 104*C*r*s + 184*C*r + 144*C*s**2 - 6*K*(79*r**2 + 2*r*(94*s - 79) + 109*s**2 - 188*s + 79) - 30*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) + 187*r**2 + 322*r*s - 406*r + 135*s**2 - 354*s + 111) + 6*f*(fd*(4*C*(8*r**2 - 4*r*(s + 2) - 12*s**2 + 7*s + 5) + 2*K*(170*r**2 + 356*r*s - 259*r + 186*s**2 - 271*s + 89) - 186*r**2 - 308*r*s + 261*r - 122*s**2 + 213*s - 95) - 56*g2*(r*s + r + s**2) + 28*gd2*(2*s + 1)*(r + s - 1)) + 168*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 6*Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + f*(-4*C*(16*r**2 - r*(8*s + 27) - 24*s**2 + 8*s + 10) - 2*K*(340*r**2 + 712*r*s - 599*r + 372*s**2 - 627*s + 259) + 372*r**2 + 616*r*s - 627*r + 244*s**2 - 515*s + 257) - 28*g2*(r*(8*s + 3) + 8*s**2 - 4*s - 2))) + 4320*Dd**2*b2*f**2*r**2 + 8640*Dd**2*b2*f**2*r*s - 6480*Dd**2*b2*f**2*r + 4320*Dd**2*b2*f**2*s**2 - 6480*Dd**2*b2*f**2*s + 2160*Dd**2*b2*f**2 - 17844*Dd**2*f**3*r**2 - 30792*Dd**2*f**3*r*s + 25542*Dd**2*f**3*r - 12948*Dd**2*f**3*s**2 + 21870*Dd**2*f**3*s - 8106*Dd**2*f**3 - 36720*Dd**2*f**2*g2*r**2 - 76896*Dd**2*f**2*g2*r*s + 55944*Dd**2*f**2*g2*r - 40176*Dd**2*f**2*g2*s**2 + 58536*Dd**2*f**2*g2*s - 18936*Dd**2*f**2*g2 + 18*b1**2*(D1**2*(10*f*fd*(2*r + 2*s - 1) - 5*f*fdd*(2*r + 2*s - 1) - 10*fd**2*(r + s - 1) + 14*fd*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1) - 7*fdd*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1)) - 2*D1*(Dd*(f*(-14*K*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(4*r + 4*s - 3) - 56*r**2 - 56*r*s + 70*r + 28*s - 28) + 7*fd*(K*(8*r*s - 9*r + 8*s**2 - 12*s + 6) + 8*r**2 + 8*r*s - r + 2*s - 3)) + 7*Ddd*f*(K*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - 14*Dd**2*f*(K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) - 3*b1*(80*C*D1**2*f*fd*r**2 - 208*C*D1**2*f*fd*r*s + 208*C*D1**2*f*fd*r - 288*C*D1**2*f*fd*s**2 + 392*C*D1**2*f*fd*s - 104*C*D1**2*f*fd - 96*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 144*C*D1**2*f*fdd*s**2 - 168*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd - 96*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 168*C*D1**2*fd**2*s + 144*C*D1**2*fd**2 + 160*C*D1*Dd*f**2*r**2 - 416*C*D1*Dd*f**2*r*s - 56*C*D1*Dd*f**2*r - 576*C*D1*Dd*f**2*s**2 + 496*C*D1*Dd*f**2*s - 64*C*D1*Dd*f**2 - 768*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s + 144*C*D1*Dd*f*fd*r + 1152*C*D1*Dd*f*fd*s**2 - 1056*C*D1*Dd*f*fd*s + 264*C*D1*Dd*f*fd - 192*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s + 168*C*D1*Ddd*f**2*r + 288*C*D1*Ddd*f**2*s**2 - 192*C*D1*Ddd*f**2*s - 24*C*D1*Ddd*f**2 - 576*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s + 504*C*Dd**2*f**2*r + 864*C*Dd**2*f**2*s**2 - 576*C*Dd**2*f**2*s - 48*C*Dd**2*f**2 + 948*D1**2*K*f*fd*r**2 + 2256*D1**2*K*f*fd*r*s - 1128*D1**2*K*f*fd*r + 1308*D1**2*K*f*fd*s**2 - 1308*D1**2*K*f*fd*s + 654*D1**2*K*f*fd - 1020*D1**2*K*f*fdd*r**2 - 2136*D1**2*K*f*fdd*r*s + 1068*D1**2*K*f*fdd*r - 1116*D1**2*K*f*fdd*s**2 + 1116*D1**2*K*f*fdd*s - 558*D1**2*K*f*fdd - 1020*D1**2*K*fd**2*r**2 - 2136*D1**2*K*fd**2*r*s + 1068*D1**2*K*fd**2*r - 1116*D1**2*K*fd**2*s**2 + 1116*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-28*K*s**2 + 5*f*(2*r + 2*s - 1) - 28*r**2 - 14*r*(2*K*s + K + 2*s - 4) + 7*s*(2*K + 4) - 21) - 315*D1**2*f**2*fd*r**2 - 810*D1**2*f**2*fd*r*s + 420*D1**2*f**2*fd*r - 495*D1**2*f**2*fd*s**2 + 540*D1**2*f**2*fd*s - 210*D1**2*f**2*fd + 495*D1**2*f**2*fdd*r**2 + 990*D1**2*f**2*fdd*r*s - 600*D1**2*f**2*fdd*r + 495*D1**2*f**2*fdd*s**2 - 600*D1**2*f**2*fdd*s + 270*D1**2*f**2*fdd + 990*D1**2*f*fd**2*r**2 + 1980*D1**2*f*fd**2*r*s - 1200*D1**2*f*fd**2*r + 990*D1**2*f*fd**2*s**2 - 1200*D1**2*f*fd**2*s + 270*D1**2*f*fd**2 - 374*D1**2*f*fd*r**2 - 644*D1**2*f*fd*r*s + 290*D1**2*f*fd*r - 270*D1**2*f*fd*s**2 + 238*D1**2*f*fd*s - 211*D1**2*f*fd + 558*D1**2*f*fdd*r**2 + 924*D1**2*f*fdd*r*s - 474*D1**2*f*fdd*r + 366*D1**2*f*fdd*s**2 - 378*D1**2*f*fdd*s + 249*D1**2*f*fdd + 336*D1**2*f*gd2*r*s + 336*D1**2*f*gd2*s**2 - 336*D1**2*f*gd2*s - 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s + 558*D1**2*fd**2*r**2 + 924*D1**2*fd**2*r*s - 474*D1**2*fd**2*r + 366*D1**2*fd**2*s**2 - 378*D1**2*fd**2*s - 108*D1**2*fd**2 + 336*D1**2*fd*g2*r*s - 672*D1**2*fd*g2*r + 336*D1**2*fd*g2*s**2 - 672*D1**2*fd*g2*s + 336*D1**2*fd*g2 - 336*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s**2 + 504*D1**2*fd*gd2*s - 336*D1**2*fd*gd2 - 168*D1**2*fdd*g2*r*s + 336*D1**2*fdd*g2*r - 168*D1**2*fdd*g2*s**2 + 336*D1**2*fdd*g2*s - 168*D1**2*fdd*g2 + 1896*D1*Dd*K*f**2*r**2 + 4512*D1*Dd*K*f**2*r*s - 3024*D1*Dd*K*f**2*r + 2616*D1*Dd*K*f**2*s**2 - 3564*D1*Dd*K*f**2*s + 1602*D1*Dd*K*f**2 - 8160*D1*Dd*K*f*fd*r**2 - 17088*D1*Dd*K*f*fd*r*s + 10488*D1*Dd*K*f*fd*r - 8928*D1*Dd*K*f*fd*s**2 + 10968*D1*Dd*K*f*fd*s - 3252*D1*Dd*K*f*fd - 420*D1*Dd*f**3*r**2 - 1080*D1*Dd*f**3*r*s + 690*D1*Dd*f**3*r - 660*D1*Dd*f**3*s**2 + 870*D1*Dd*f**3*s - 375*D1*Dd*f**3 + 3960*D1*Dd*f**2*fd*r**2 + 7920*D1*Dd*f**2*fd*r*s - 5370*D1*Dd*f**2*fd*r + 3960*D1*Dd*f**2*fd*s**2 - 5370*D1*Dd*f**2*fd*s + 1800*D1*Dd*f**2*fd - 748*D1*Dd*f**2*r**2 - 1288*D1*Dd*f**2*r*s + 1070*D1*Dd*f**2*r - 540*D1*Dd*f**2*s**2 + 914*D1*Dd*f**2*s - 509*D1*Dd*f**2 + 4464*D1*Dd*f*fd*r**2 + 7392*D1*Dd*f*fd*r*s - 5052*D1*Dd*f*fd*r + 2928*D1*Dd*f*fd*s**2 - 4092*D1*Dd*f*fd*s + 1326*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 1344*D1*Dd*f*g2*s**2 - 1344*D1*Dd*f*g2*s + 336*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 1344*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r*s + 1512*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s - 1008*D1*Dd*fd*g2 - 2040*D1*Ddd*K*f**2*r**2 - 4272*D1*Ddd*K*f**2*r*s + 3108*D1*Ddd*K*f**2*r - 2232*D1*Ddd*K*f**2*s**2 + 3252*D1*Ddd*K*f**2*s - 1578*D1*Ddd*K*f**2 + 660*D1*Ddd*f**3*r**2 + 1320*D1*Ddd*f**3*r*s - 990*D1*Ddd*f**3*r + 660*D1*Ddd*f**3*s**2 - 990*D1*Ddd*f**3*s + 495*D1*Ddd*f**3 + 1116*D1*Ddd*f**2*r**2 + 1848*D1*Ddd*f**2*r*s - 1578*D1*Ddd*f**2*r + 732*D1*Ddd*f**2*s**2 - 1290*D1*Ddd*f**2*s + 741*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 672*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 + 12*D1*bd1*(D1*(5*f**2*(2*r + 2*s - 1) - 7*f*(4*K*s**2 + 4*r**2 + 2*r*(2*K*s + K + 2*s - 4) - s*(2*K + 4) + 3) + 7*fd*(K*(r*(4*s - 3) + 4*s**2 - 5*s + 2) + 4*r**2 + r*(4*s - 2) - 1)) + Dd*f*(7*K*(2*r*(8*s + 1) + 16*s**2 - 12*s - 1) - 5*f*(4*r + 4*s - 3) + 112*r**2 + 14*r*(8*s - 13) - 84*s + 70)) - 6120*Dd**2*K*f**2*r**2 - 12816*Dd**2*K*f**2*r*s + 9324*Dd**2*K*f**2*r - 6696*Dd**2*K*f**2*s**2 + 9756*Dd**2*K*f**2*s - 3156*Dd**2*K*f**2 + 1980*Dd**2*f**3*r**2 + 3960*Dd**2*f**3*r*s - 2970*Dd**2*f**3*r + 1980*Dd**2*f**3*s**2 - 2970*Dd**2*f**3*s + 990*Dd**2*f**3 + 3348*Dd**2*f**2*r**2 + 5544*Dd**2*f**2*r*s - 4734*Dd**2*f**2*r + 2196*Dd**2*f**2*s**2 - 3870*Dd**2*f**2*s + 1482*Dd**2*f**2 - 2016*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 2016*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(315*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**3*k1*k2**3*(336*C*D1**2*bd1**2*f*r**2 + 672*C*D1**2*bd1**2*f*r*s - 336*C*D1**2*bd1**2*f*r + 336*C*D1**2*bd1**2*f*s**2 - 336*C*D1**2*bd1**2*f*s + 1620*C*D1**2*bd1*f**2*r**2 + 2904*C*D1**2*bd1*f**2*r*s - 2712*C*D1**2*bd1*f**2*r + 1284*C*D1**2*bd1*f**2*s**2 - 2376*C*D1**2*bd1*f**2*s + 1188*C*D1**2*bd1*f**2 - 4752*C*D1**2*bd1*f*fd*r**2 - 8832*C*D1**2*bd1*f*fd*r*s + 7032*C*D1**2*bd1*f*fd*r - 4080*C*D1**2*bd1*f*fd*s**2 + 6528*C*D1**2*bd1*f*fd*s - 2448*C*D1**2*bd1*f*fd - 1188*C*D1**2*bdd1*f**2*r**2 - 2208*C*D1**2*bdd1*f**2*r*s + 2448*C*D1**2*bdd1*f**2*r - 1020*C*D1**2*bdd1*f**2*s**2 + 2280*C*D1**2*bdd1*f**2*s - 1140*C*D1**2*bdd1*f**2 - 60*C*D1**2*f**2*fd*r**2 + 1200*C*D1**2*f**2*fd*r*s - 360*C*D1**2*f**2*fd*r + 1260*C*D1**2*f**2*fd*s**2 - 1240*C*D1**2*f**2*fd*s + 400*C*D1**2*f**2*fd - 1140*C*D1**2*f**2*fdd*r**2 - 3120*C*D1**2*f**2*fdd*r*s + 1800*C*D1**2*f**2*fdd*r - 1980*C*D1**2*f**2*fdd*s**2 + 2360*C*D1**2*f**2*fdd*s - 1040*C*D1**2*f**2*fdd - 2280*C*D1**2*f*fd**2*r**2 - 6240*C*D1**2*f*fd**2*r*s + 3600*C*D1**2*f*fd**2*r - 3960*C*D1**2*f*fd**2*s**2 + 4720*C*D1**2*f*fd**2*s - 1040*C*D1**2*f*fd**2 - 9504*C*D1*Dd*bd1*f**2*r**2 - 17664*C*D1*Dd*bd1*f**2*r*s + 16752*C*D1*Dd*bd1*f**2*r - 8160*C*D1*Dd*bd1*f**2*s**2 + 15576*C*D1*Dd*bd1*f**2*s - 7176*C*D1*Dd*bd1*f**2 - 80*C*D1*Dd*f**3*r**2 + 1600*C*D1*Dd*f**3*r*s - 320*C*D1*Dd*f**3*r + 1680*C*D1*Dd*f**3*s**2 - 1640*C*D1*Dd*f**3*s + 380*C*D1*Dd*f**3 - 9120*C*D1*Dd*f**2*fd*r**2 - 24960*C*D1*Dd*f**2*fd*r*s + 14880*C*D1*Dd*f**2*fd*r - 15840*C*D1*Dd*f**2*fd*s**2 + 19640*C*D1*Dd*f**2*fd*s - 5960*C*D1*Dd*f**2*fd - 1520*C*D1*Ddd*f**3*r**2 - 4160*C*D1*Ddd*f**3*r*s + 2560*C*D1*Ddd*f**3*r - 2640*C*D1*Ddd*f**3*s**2 + 3400*C*D1*Ddd*f**3*s - 1420*C*D1*Ddd*f**3 - 4560*C*Dd**2*f**3*r**2 - 12480*C*Dd**2*f**3*r*s + 7680*C*Dd**2*f**3*r - 7920*C*Dd**2*f**3*s**2 + 10200*C*Dd**2*f**3*s - 2840*C*Dd**2*f**3 - 1372*D1**2*K*bd1**2*f*r**2 - 2912*D1**2*K*bd1**2*f*r*s + 2996*D1**2*K*bd1**2*f*r - 1540*D1**2*K*bd1**2*f*s**2 + 3164*D1**2*K*bd1**2*f*s - 1624*D1**2*K*bd1**2*f - 126*D1**2*K*bd1*f**2*r**2 + 168*D1**2*K*bd1*f**2*r*s + 252*D1**2*K*bd1*f**2*r + 294*D1**2*K*bd1*f**2*s**2 - 168*D1**2*K*bd1*f**2*s - 126*D1**2*K*bd1*f**2 - 840*D1**2*K*bd1*f*fd*r**2 - 2688*D1**2*K*bd1*f*fd*r*s + 1512*D1**2*K*bd1*f*fd*r - 1848*D1**2*K*bd1*f*fd*s**2 + 2268*D1**2*K*bd1*f*fd*s - 672*D1**2*K*bd1*f*fd - 210*D1**2*K*bdd1*f**2*r**2 - 672*D1**2*K*bdd1*f**2*r*s + 420*D1**2*K*bdd1*f**2*r - 462*D1**2*K*bdd1*f**2*s**2 + 672*D1**2*K*bdd1*f**2*s - 210*D1**2*K*bdd1*f**2 + 630*D1**2*bd1**2*f**2*r**2 + 924*D1**2*bd1**2*f**2*r*s - 1092*D1**2*bd1**2*f**2*r + 294*D1**2*bd1**2*f**2*s**2 - 756*D1**2*bd1**2*f**2*s + 462*D1**2*bd1**2*f**2 + 350*D1**2*bd1**2*f*r**2 + 532*D1**2*bd1**2*f*r*s - 868*D1**2*bd1**2*f*r + 182*D1**2*bd1**2*f*s**2 - 700*D1**2*bd1**2*f*s + 518*D1**2*bd1**2*f - 560*D1**2*bd1**2*g2*r**2 - 1120*D1**2*bd1**2*g2*r*s + 560*D1**2*bd1**2*g2*r - 560*D1**2*bd1**2*g2*s**2 + 560*D1**2*bd1**2*g2*s - 336*D1**2*bd1*bd2*f*r**2 - 672*D1**2*bd1*bd2*f*r*s + 672*D1**2*bd1*bd2*f*r - 336*D1**2*bd1*bd2*f*s**2 + 672*D1**2*bd1*bd2*f*s - 336*D1**2*bd1*bd2*f - 987*D1**2*bd1*f**2*r**2 - 1710*D1**2*bd1*f**2*r*s + 1446*D1**2*bd1*f**2*r - 723*D1**2*bd1*f**2*s**2 + 1182*D1**2*bd1*f**2*s - 549*D1**2*bd1*f**2 + 3444*D1**2*bd1*f*fd*r**2 + 6024*D1**2*bd1*f*fd*r*s - 4854*D1**2*bd1*f*fd*r + 2580*D1**2*bd1*f*fd*s**2 - 4206*D1**2*bd1*f*fd*s + 1626*D1**2*bd1*f*fd - 1484*D1**2*bd1*f*g2*r**2 - 3304*D1**2*bd1*f*g2*r*s + 2856*D1**2*bd1*f*g2*r - 1820*D1**2*bd1*f*g2*s**2 + 3192*D1**2*bd1*f*g2*s - 1596*D1**2*bd1*f*g2 + 2744*D1**2*bd1*f*gd2*r**2 + 5824*D1**2*bd1*f*gd2*r*s - 5992*D1**2*bd1*f*gd2*r + 3080*D1**2*bd1*f*gd2*s**2 - 6328*D1**2*bd1*f*gd2*s + 3248*D1**2*bd1*f*gd2 + 2744*D1**2*bd1*fd*g2*r**2 + 5824*D1**2*bd1*fd*g2*r*s - 2912*D1**2*bd1*fd*g2*r + 3080*D1**2*bd1*fd*g2*s**2 - 3080*D1**2*bd1*fd*g2*s - 84*D1**2*bd2*f**2*r**2 - 168*D1**2*bd2*f**2*r*s + 168*D1**2*bd2*f**2*r - 84*D1**2*bd2*f**2*s**2 + 168*D1**2*bd2*f**2*s - 84*D1**2*bd2*f**2 + 861*D1**2*bdd1*f**2*r**2 + 1506*D1**2*bdd1*f**2*r*s - 1626*D1**2*bdd1*f**2*r + 645*D1**2*bdd1*f**2*s**2 - 1410*D1**2*bdd1*f**2*s + 705*D1**2*bdd1*f**2 + 1372*D1**2*bdd1*f*g2*r**2 + 2912*D1**2*bdd1*f*g2*r*s - 3248*D1**2*bdd1*f*g2*r + 1540*D1**2*bdd1*f*g2*s**2 - 3416*D1**2*bdd1*f*g2*s + 1708*D1**2*bdd1*f*g2 + 210*D1**2*f**2*fd*r**2 - 420*D1**2*f**2*fd*r*s - 630*D1**2*f**2*fd*s**2 + 560*D1**2*f**2*fd*s - 140*D1**2*f**2*fd + 570*D1**2*f**2*fdd*r**2 + 1560*D1**2*f**2*fdd*r*s - 900*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 1180*D1**2*f**2*fdd*s + 520*D1**2*f**2*fdd + 252*D1**2*f**2*gd2*r**2 - 336*D1**2*f**2*gd2*r*s - 504*D1**2*f**2*gd2*r - 588*D1**2*f**2*gd2*s**2 + 336*D1**2*f**2*gd2*s + 252*D1**2*f**2*gd2 + 420*D1**2*f**2*gdd2*r**2 + 1344*D1**2*f**2*gdd2*r*s - 840*D1**2*f**2*gdd2*r + 924*D1**2*f**2*gdd2*s**2 - 1344*D1**2*f**2*gdd2*s + 420*D1**2*f**2*gdd2 + 1140*D1**2*f*fd**2*r**2 + 3120*D1**2*f*fd**2*r*s - 1800*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 2360*D1**2*f*fd**2*s + 520*D1**2*f*fd**2 + 504*D1**2*f*fd*g2*r**2 - 672*D1**2*f*fd*g2*r*s + 336*D1**2*f*fd*g2*r - 1176*D1**2*f*fd*g2*s**2 + 1176*D1**2*f*fd*g2*s - 588*D1**2*f*fd*g2 + 1680*D1**2*f*fd*gd2*r**2 + 5376*D1**2*f*fd*gd2*r*s - 3024*D1**2*f*fd*gd2*r + 3696*D1**2*f*fd*gd2*s**2 - 4536*D1**2*f*fd*gd2*s + 1344*D1**2*f*fd*gd2 + 840*D1**2*f*fdd*g2*r**2 + 2688*D1**2*f*fdd*g2*r*s - 1344*D1**2*f*fdd*g2*r + 1848*D1**2*f*fdd*g2*s**2 - 1848*D1**2*f*fdd*g2*s + 924*D1**2*f*fdd*g2 + 840*D1**2*fd**2*g2*r**2 + 2688*D1**2*fd**2*g2*r*s - 1344*D1**2*fd**2*g2*r + 1848*D1**2*fd**2*g2*s**2 - 1848*D1**2*fd**2*g2*s - 1680*D1*Dd*K*bd1*f**2*r**2 - 5376*D1*Dd*K*bd1*f**2*r*s + 3192*D1*Dd*K*bd1*f**2*r - 3696*D1*Dd*K*bd1*f**2*s**2 + 4956*D1*Dd*K*bd1*f**2*s - 1512*D1*Dd*K*bd1*f**2 + 6888*D1*Dd*bd1*f**2*r**2 + 12048*D1*Dd*bd1*f**2*r*s - 11454*D1*Dd*bd1*f**2*r + 5160*D1*Dd*bd1*f**2*s**2 - 9942*D1*Dd*bd1*f**2*s + 4662*D1*Dd*bd1*f**2 + 10976*D1*Dd*bd1*f*g2*r**2 + 23296*D1*Dd*bd1*f*g2*r*s - 21392*D1*Dd*bd1*f*g2*r + 12320*D1*Dd*bd1*f*g2*s**2 - 22568*D1*Dd*bd1*f*g2*s + 9912*D1*Dd*bd1*f*g2 + 280*D1*Dd*f**3*r**2 - 560*D1*Dd*f**3*r*s - 140*D1*Dd*f**3*r - 840*D1*Dd*f**3*s**2 + 700*D1*Dd*f**3*s - 70*D1*Dd*f**3 + 4560*D1*Dd*f**2*fd*r**2 + 12480*D1*Dd*f**2*fd*r*s - 7440*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 9820*D1*Dd*f**2*fd*s + 2980*D1*Dd*f**2*fd + 1008*D1*Dd*f**2*g2*r**2 - 1344*D1*Dd*f**2*g2*r*s - 672*D1*Dd*f**2*g2*r - 2352*D1*Dd*f**2*g2*s**2 + 1848*D1*Dd*f**2*g2*s - 84*D1*Dd*f**2*g2 + 3360*D1*Dd*f**2*gd2*r**2 + 10752*D1*Dd*f**2*gd2*r*s - 6384*D1*Dd*f**2*gd2*r + 7392*D1*Dd*f**2*gd2*s**2 - 9912*D1*Dd*f**2*gd2*s + 3024*D1*Dd*f**2*gd2 + 6720*D1*Dd*f*fd*g2*r**2 + 21504*D1*Dd*f*fd*g2*r*s - 11424*D1*Dd*f*fd*g2*r + 14784*D1*Dd*f*fd*g2*s**2 - 16464*D1*Dd*f*fd*g2*s + 4536*D1*Dd*f*fd*g2 + 760*D1*Ddd*f**3*r**2 + 2080*D1*Ddd*f**3*r*s - 1280*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1700*D1*Ddd*f**3*s + 710*D1*Ddd*f**3 + 1680*D1*Ddd*f**2*g2*r**2 + 5376*D1*Ddd*f**2*g2*r*s - 3024*D1*Ddd*f**2*g2*r + 3696*D1*Ddd*f**2*g2*s**2 - 4536*D1*Ddd*f**2*g2*s + 1764*D1*Ddd*f**2*g2 + 28*D1*b2*(bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 2280*Dd**2*f**3*r**2 + 6240*Dd**2*f**3*r*s - 3840*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 5100*Dd**2*f**3*s + 1420*Dd**2*f**3 + 5040*Dd**2*f**2*g2*r**2 + 16128*Dd**2*f**2*g2*r*s - 9072*Dd**2*f**2*g2*r + 11088*Dd**2*f**2*g2*s**2 - 13608*Dd**2*f**2*g2*s + 3528*Dd**2*f**2*g2 + 14*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-48*C*D1**2*fd*r**2 - 96*C*D1**2*fd*r*s + 96*C*D1**2*fd*r - 48*C*D1**2*fd*s**2 + 96*C*D1**2*fd*s - 48*C*D1**2*fd + 24*C*D1**2*fdd*r**2 + 48*C*D1**2*fdd*r*s - 48*C*D1**2*fdd*r + 24*C*D1**2*fdd*s**2 - 48*C*D1**2*fdd*s + 24*C*D1**2*fdd - 192*C*D1*Dd*f*r**2 - 384*C*D1*Dd*f*r*s + 288*C*D1*Dd*f*r - 192*C*D1*Dd*f*s**2 + 288*C*D1*Dd*f*s - 144*C*D1*Dd*f + 192*C*D1*Dd*fd*r**2 + 384*C*D1*Dd*fd*r*s - 336*C*D1*Dd*fd*r + 192*C*D1*Dd*fd*s**2 - 336*C*D1*Dd*fd*s + 144*C*D1*Dd*fd + 96*C*D1*Ddd*f*r**2 + 192*C*D1*Ddd*f*r*s - 144*C*D1*Ddd*f*r + 96*C*D1*Ddd*f*s**2 - 144*C*D1*Ddd*f*s + 72*C*D1*Ddd*f + 288*C*Dd**2*f*r**2 + 576*C*Dd**2*f*r*s - 432*C*Dd**2*f*r + 288*C*Dd**2*f*s**2 - 432*C*Dd**2*f*s + 144*C*Dd**2*f + 106*D1**2*K*fd*r**2 + 236*D1**2*K*fd*r*s - 32*D1**2*K*fd*r + 130*D1**2*K*fd*s**2 - 32*D1**2*K*fd*s + 16*D1**2*K*fd - 98*D1**2*K*fdd*r**2 - 208*D1**2*K*fdd*r*s - 24*D1**2*K*fdd*r - 110*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 2*D1**2*bdd1*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 78*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 90*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 45*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 132*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 45*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 132*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s + 15*D1**2*fd*r**2 + 34*D1**2*fd*r*s - 52*D1**2*fd*r + 19*D1**2*fd*s**2 - 52*D1**2*fd*s + 26*D1**2*fd + 25*D1**2*fdd*r**2 + 38*D1**2*fdd*r*s + 36*D1**2*fdd*r + 13*D1**2*fdd*s**2 + 36*D1**2*fdd*s - 18*D1**2*fdd + 80*D1**2*gd2*r**2 + 160*D1**2*gd2*r*s - 160*D1**2*gd2*r + 80*D1**2*gd2*s**2 - 160*D1**2*gd2*s + 80*D1**2*gd2 - 40*D1**2*gdd2*r**2 - 80*D1**2*gdd2*r*s + 80*D1**2*gdd2*r - 40*D1**2*gdd2*s**2 + 80*D1**2*gdd2*s - 40*D1**2*gdd2 + 424*D1*Dd*K*f*r**2 + 944*D1*Dd*K*f*r*s - 660*D1*Dd*K*f*r + 520*D1*Dd*K*f*s**2 - 732*D1*Dd*K*f*s + 342*D1*Dd*K*f - 784*D1*Dd*K*fd*r**2 - 1664*D1*Dd*K*fd*r*s + 504*D1*Dd*K*fd*r - 880*D1*Dd*K*fd*s**2 + 540*D1*Dd*K*fd*s + 72*D1*Dd*K*fd - 156*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 93*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1056*D1*Dd*f*fd*r*s - 852*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 612*D1*Dd*f*fd*s + 246*D1*Dd*f*fd + 60*D1*Dd*f*r**2 + 136*D1*Dd*f*r*s - 94*D1*Dd*f*r + 76*D1*Dd*f*s**2 - 106*D1*Dd*f*s + 49*D1*Dd*f + 200*D1*Dd*fd*r**2 + 304*D1*Dd*fd*r*s + 6*D1*Dd*fd*r + 104*D1*Dd*fd*s**2 + 42*D1*Dd*fd*s - 108*D1*Dd*fd + 320*D1*Dd*g2*r**2 + 640*D1*Dd*g2*r*s - 480*D1*Dd*g2*r + 320*D1*Dd*g2*s**2 - 480*D1*Dd*g2*s + 240*D1*Dd*g2 - 320*D1*Dd*gd2*r**2 - 640*D1*Dd*gd2*r*s + 560*D1*Dd*gd2*r - 320*D1*Dd*gd2*s**2 + 560*D1*Dd*gd2*s - 240*D1*Dd*gd2 - 392*D1*Ddd*K*f*r**2 - 832*D1*Ddd*K*f*r*s + 600*D1*Ddd*K*f*r - 440*D1*Ddd*K*f*s**2 + 636*D1*Ddd*K*f*s - 306*D1*Ddd*K*f + 180*D1*Ddd*f**2*r**2 + 264*D1*Ddd*f**2*r*s - 246*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 174*D1*Ddd*f**2*s + 111*D1*Ddd*f**2 + 100*D1*Ddd*f*r**2 + 152*D1*Ddd*f*r*s - 138*D1*Ddd*f*r + 52*D1*Ddd*f*s**2 - 102*D1*Ddd*f*s + 63*D1*Ddd*f - 160*D1*Ddd*g2*r**2 - 320*D1*Ddd*g2*r*s + 240*D1*Ddd*g2*r - 160*D1*Ddd*g2*s**2 + 240*D1*Ddd*g2*s - 120*D1*Ddd*g2 + 4*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-10*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 1176*Dd**2*K*f*r**2 - 2496*Dd**2*K*f*r*s + 1800*Dd**2*K*f*r - 1320*Dd**2*K*f*s**2 + 1908*Dd**2*K*f*s - 612*Dd**2*K*f + 540*Dd**2*f**2*r**2 + 792*Dd**2*f**2*r*s - 738*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 522*Dd**2*f**2*s + 222*Dd**2*f**2 + 300*Dd**2*f*r**2 + 456*Dd**2*f*r*s - 414*Dd**2*f*r + 156*Dd**2*f*s**2 - 306*Dd**2*f*s + 126*Dd**2*f - 480*Dd**2*g2*r**2 - 960*Dd**2*g2*r*s + 720*Dd**2*g2*r - 480*Dd**2*g2*s**2 + 720*Dd**2*g2*s - 240*Dd**2*g2) + b1*(336*C*D1**2*bdd1*f*r**2 + 672*C*D1**2*bdd1*f*r*s - 336*C*D1**2*bdd1*f*r + 336*C*D1**2*bdd1*f*s**2 - 336*C*D1**2*bdd1*f*s + 168*C*D1**2*bdd1*f + 3240*C*D1**2*f*fd*r**2 + 5808*C*D1**2*f*fd*r*s - 3432*C*D1**2*f*fd*r + 2568*C*D1**2*f*fd*s**2 - 3096*C*D1**2*f*fd*s + 1716*C*D1**2*f*fd - 2376*C*D1**2*f*fdd*r**2 - 4416*C*D1**2*f*fdd*r*s + 2136*C*D1**2*f*fdd*r - 2040*C*D1**2*f*fdd*s**2 + 1968*C*D1**2*f*fdd*s - 1068*C*D1**2*f*fdd - 2376*C*D1**2*fd**2*r**2 - 4416*C*D1**2*fd**2*r*s + 2136*C*D1**2*fd**2*r - 2040*C*D1**2*fd**2*s**2 + 1968*C*D1**2*fd**2*s + 240*C*D1**2*fd**2 + 6480*C*D1*Dd*f**2*r**2 + 11616*C*D1*Dd*f**2*r*s - 9384*C*D1*Dd*f**2*r + 5136*C*D1*Dd*f**2*s**2 - 8376*C*D1*Dd*f**2*s + 4524*C*D1*Dd*f**2 - 19008*C*D1*Dd*f*fd*r**2 - 35328*C*D1*Dd*f*fd*r*s + 22464*C*D1*Dd*f*fd*r - 16320*C*D1*Dd*f*fd*s**2 + 20784*C*D1*Dd*f*fd*s - 6240*C*D1*Dd*f*fd - 4752*C*D1*Ddd*f**2*r**2 - 8832*C*D1*Ddd*f**2*r*s + 6960*C*D1*Ddd*f**2*r - 4080*C*D1*Ddd*f**2*s**2 + 6456*C*D1*Ddd*f**2*s - 3396*C*D1*Ddd*f**2 - 14256*C*Dd**2*f**2*r**2 - 26496*C*Dd**2*f**2*r*s + 20880*C*Dd**2*f**2*r - 12240*C*Dd**2*f**2*s**2 + 19368*C*Dd**2*f**2*s - 6792*C*Dd**2*f**2 - 1372*D1**2*K*bdd1*f*r**2 - 2912*D1**2*K*bdd1*f*r*s + 2996*D1**2*K*bdd1*f*r - 1540*D1**2*K*bdd1*f*s**2 + 3164*D1**2*K*bdd1*f*s - 1540*D1**2*K*bdd1*f - 252*D1**2*K*f*fd*r**2 + 336*D1**2*K*f*fd*r*s - 168*D1**2*K*f*fd*r + 588*D1**2*K*f*fd*s**2 - 588*D1**2*K*f*fd*s + 294*D1**2*K*f*fd - 420*D1**2*K*f*fdd*r**2 - 1344*D1**2*K*f*fdd*r*s + 672*D1**2*K*f*fdd*r - 924*D1**2*K*f*fdd*s**2 + 924*D1**2*K*f*fdd*s - 462*D1**2*K*f*fdd - 420*D1**2*K*fd**2*r**2 - 1344*D1**2*K*fd**2*r*s + 672*D1**2*K*fd**2*r - 924*D1**2*K*fd**2*s**2 + 924*D1**2*K*fd**2*s + 196*D1**2*b2*fd*r**2 + 392*D1**2*b2*fd*r*s + 196*D1**2*b2*fd*s**2 - 168*D1**2*b2*fdd*r**2 - 336*D1**2*b2*fdd*r*s - 168*D1**2*b2*fdd*s**2 - 28*D1**2*bd1**2*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 630*D1**2*bdd1*f**2*r**2 + 924*D1**2*bdd1*f**2*r*s - 1092*D1**2*bdd1*f**2*r + 294*D1**2*bdd1*f**2*s**2 - 756*D1**2*bdd1*f**2*s + 462*D1**2*bdd1*f**2 + 350*D1**2*bdd1*f*r**2 + 532*D1**2*bdd1*f*r*s - 868*D1**2*bdd1*f*r + 182*D1**2*bdd1*f*s**2 - 700*D1**2*bdd1*f*s + 392*D1**2*bdd1*f - 560*D1**2*bdd1*g2*r**2 - 1120*D1**2*bdd1*g2*r*s + 560*D1**2*bdd1*g2*r - 560*D1**2*bdd1*g2*s**2 + 560*D1**2*bdd1*g2*s - 280*D1**2*bdd1*g2 - 168*D1**2*bdd2*f*r**2 - 336*D1**2*bdd2*f*r*s + 336*D1**2*bdd2*f*r - 168*D1**2*bdd2*f*s**2 + 336*D1**2*bdd2*f*s - 168*D1**2*bdd2*f - 1974*D1**2*f*fd*r**2 - 3420*D1**2*f*fd*r*s + 2238*D1**2*f*fd*r - 1446*D1**2*f*fd*s**2 + 1974*D1**2*f*fd*s - 1161*D1**2*f*fd + 1722*D1**2*f*fdd*r**2 + 3012*D1**2*f*fdd*r*s - 1602*D1**2*f*fdd*r + 1290*D1**2*f*fdd*s**2 - 1386*D1**2*f*fdd*s + 801*D1**2*f*fdd - 1484*D1**2*f*gd2*r**2 - 3304*D1**2*f*gd2*r*s + 2968*D1**2*f*gd2*r - 1820*D1**2*f*gd2*s**2 + 3304*D1**2*f*gd2*s - 1484*D1**2*f*gd2 + 1372*D1**2*f*gdd2*r**2 + 2912*D1**2*f*gdd2*r*s - 2744*D1**2*f*gdd2*r + 1540*D1**2*f*gdd2*s**2 - 2912*D1**2*f*gdd2*s + 1372*D1**2*f*gdd2 + 1722*D1**2*fd**2*r**2 + 3012*D1**2*fd**2*r*s - 1602*D1**2*fd**2*r + 1290*D1**2*fd**2*s**2 - 1386*D1**2*fd**2*s - 120*D1**2*fd**2 - 1484*D1**2*fd*g2*r**2 - 3304*D1**2*fd*g2*r*s + 448*D1**2*fd*g2*r - 1820*D1**2*fd*g2*s**2 + 448*D1**2*fd*g2*s - 224*D1**2*fd*g2 + 2744*D1**2*fd*gd2*r**2 + 5824*D1**2*fd*gd2*r*s - 2408*D1**2*fd*gd2*r + 3080*D1**2*fd*gd2*s**2 - 2576*D1**2*fd*gd2*s - 336*D1**2*fd*gd2 + 1372*D1**2*fdd*g2*r**2 + 2912*D1**2*fdd*g2*r*s + 336*D1**2*fdd*g2*r + 1540*D1**2*fdd*g2*s**2 + 336*D1**2*fdd*g2*s - 168*D1**2*fdd*g2 - 504*D1*Dd*K*f**2*r**2 + 672*D1*Dd*K*f**2*r*s + 336*D1*Dd*K*f**2*r + 1176*D1*Dd*K*f**2*s**2 - 924*D1*Dd*K*f**2*s + 42*D1*Dd*K*f**2 - 3360*D1*Dd*K*f*fd*r**2 - 10752*D1*Dd*K*f*fd*r*s + 5712*D1*Dd*K*f*fd*r - 7392*D1*Dd*K*f*fd*s**2 + 8232*D1*Dd*K*f*fd*s - 2268*D1*Dd*K*f*fd + 784*D1*Dd*b2*f*r**2 + 1568*D1*Dd*b2*f*r*s - 1176*D1*Dd*b2*f*r + 784*D1*Dd*b2*f*s**2 - 1176*D1*Dd*b2*f*s + 588*D1*Dd*b2*f - 1344*D1*Dd*b2*fd*r**2 - 2688*D1*Dd*b2*fd*r*s + 1008*D1*Dd*b2*fd*r - 1344*D1*Dd*b2*fd*s**2 + 1008*D1*Dd*b2*fd*s - 3948*D1*Dd*f**2*r**2 - 6840*D1*Dd*f**2*r*s + 5658*D1*Dd*f**2*r - 2892*D1*Dd*f**2*s**2 + 4866*D1*Dd*f**2*s - 2697*D1*Dd*f**2 + 13776*D1*Dd*f*fd*r**2 + 24096*D1*Dd*f*fd*r*s - 16308*D1*Dd*f*fd*r + 10320*D1*Dd*f*fd*s**2 - 14148*D1*Dd*f*fd*s + 4590*D1*Dd*f*fd - 5936*D1*Dd*f*g2*r**2 - 13216*D1*Dd*f*g2*r*s + 9240*D1*Dd*f*g2*r - 7280*D1*Dd*f*g2*s**2 + 10248*D1*Dd*f*g2*s - 4788*D1*Dd*f*g2 + 10976*D1*Dd*f*gd2*r**2 + 23296*D1*Dd*f*gd2*r*s - 19376*D1*Dd*f*gd2*r + 12320*D1*Dd*f*gd2*s**2 - 20552*D1*Dd*f*gd2*s + 8400*D1*Dd*f*gd2 + 10976*D1*Dd*fd*g2*r**2 + 23296*D1*Dd*fd*g2*r*s - 7056*D1*Dd*fd*g2*r + 12320*D1*Dd*fd*g2*s**2 - 7560*D1*Dd*fd*g2*s - 1008*D1*Dd*fd*g2 - 840*D1*Ddd*K*f**2*r**2 - 2688*D1*Ddd*K*f**2*r*s + 1512*D1*Ddd*K*f**2*r - 1848*D1*Ddd*K*f**2*s**2 + 2268*D1*Ddd*K*f**2*s - 882*D1*Ddd*K*f**2 - 672*D1*Ddd*b2*f*r**2 - 1344*D1*Ddd*b2*f*r*s + 1008*D1*Ddd*b2*f*r - 672*D1*Ddd*b2*f*s**2 + 1008*D1*Ddd*b2*f*s - 504*D1*Ddd*b2*f + 3444*D1*Ddd*f**2*r**2 + 6024*D1*Ddd*f**2*r*s - 4950*D1*Ddd*f**2*r + 2580*D1*Ddd*f**2*s**2 - 4302*D1*Ddd*f**2*s + 2367*D1*Ddd*f**2 + 5488*D1*Ddd*f*g2*r**2 + 11648*D1*Ddd*f*g2*r*s - 8400*D1*Ddd*f*g2*r + 6160*D1*Ddd*f*g2*s**2 - 8904*D1*Ddd*f*g2*s + 4284*D1*Ddd*f*g2 - 14*D1*bd1*(D1*(3*f**2*(13*r**2 + 2*r*(9*s - 10) + 5*s**2 - 12*s + 8) + f*(24*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 106*K*r**2 - 236*K*r*s + 208*K*r - 130*K*s**2 + 232*K*s - 110*K - 6*fd*(30*r**2 + 44*r*s - 41*r + 14*s**2 - 29*s + 13) - 15*r**2 - 34*r*s + 6*r - 19*s**2 + 10*s - 4) - 2*fd*(12*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-98*r**2 - 208*r*s + 95*r - 110*s**2 + 101*s + 6) + 25*r**2 + 38*r*s - 13*r + 13*s**2 - 7*s - 9) - 40*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(3*f**2*(60*r**2 + r*(88*s - 93) + 28*s**2 - 65*s + 35) + f*(12*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(392*r**2 + 104*r*(8*s - 7) + 440*s**2 - 770*s + 327) + 100*r**2 + 152*r*s - 193*r + 52*s**2 - 151*s + 87) - 20*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 28*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 2520*Dd**2*K*f**2*r**2 - 8064*Dd**2*K*f**2*r*s + 4536*Dd**2*K*f**2*r - 5544*Dd**2*K*f**2*s**2 + 6804*Dd**2*K*f**2*s - 1764*Dd**2*K*f**2 - 2016*Dd**2*b2*f*r**2 - 4032*Dd**2*b2*f*r*s + 3024*Dd**2*b2*f*r - 2016*Dd**2*b2*f*s**2 + 3024*Dd**2*b2*f*s - 1008*Dd**2*b2*f + 10332*Dd**2*f**2*r**2 + 18072*Dd**2*f**2*r*s - 14850*Dd**2*f**2*r + 7740*Dd**2*f**2*s**2 - 12906*Dd**2*f**2*s + 4734*Dd**2*f**2 + 16464*Dd**2*f*g2*r**2 + 34944*Dd**2*f*g2*r*s - 25200*Dd**2*f*g2*r + 18480*Dd**2*f*g2*s**2 - 26712*Dd**2*f*g2*s + 8568*Dd**2*f*g2))/(105*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**3*k1*st**4*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 18*fd*(2*s**2 - 2*s + 1) - 9*fdd*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) + f*(-2*fd*(s**2*(21*bd1 - 9) + s*(6 - 7*bd1) - 3) - 3*fdd*(3*s**2 - 2*s + 1) - 3*s**2*(-6*bd1 + 3*bdd1)) - 6*fd*s*(bd1*(6*s - 3) + fd*(3*s - 2))) + D1*f*(-2*Dd*(f*(s**2*(28*bd1 - 12) + s*(6 - 7*bd1) - 3) + (12*s - 3)*(3*bd1*s + fd*(3*s - 1))) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k2*k3**2) - 24*D1**2*Pk2*Pk3*ct**3*k1*st**2*(-D1*f*s*(2*D1*bd1**2*s*(5*f + 7) - 6*D1*bd1*(f*s - 2*fd*s + fd) + 3*D1*bdd1*f*s + 6*Dd*bd1*f*(4*s - 1)) + b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) + f*(fd*(s**2*(12 - 40*bd1) + s*(20*bd1 - 12) + 6) + fdd*(-6*s**2 + 6*s - 3) + s**2*(28*bd1 - 14*bdd1)) - 2*fd*s*(14*bd1 + 3*fd)*(s - 1)) + D1*f*(-2*Dd*(f*(s**2*(40*bd1 - 12) + s*(6 - 10*bd1) - 3) + (4*s - 1)*(14*bd1*s + fd*(6*s - 3))) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2**3) - 2*D1**2*Pk2*Pk3*ct**3*k1*(D1*f*s*(14*D1*bd1**2*(s*(21*f + 25) + 6) + 135*D1*bdd1*f*s + 9*bd1*(-23*D1*f*s + 30*D1*fd*(2*s - 1) + 30*Dd*f*(4*s - 1))) + 14*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + 7*b1**2*(-2*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 66*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 33*D1**2*f*fd + 42*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd + 42*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s - 35*D1**2*fd*s**2 + 94*D1**2*fd*s - 47*D1**2*fd + 25*D1**2*fdd*s**2 - 62*D1**2*fdd*s + 31*D1**2*fdd - 132*D1*Dd*f**2*s**2 + 66*D1*Dd*f**2*s - 33*D1*Dd*f**2 + 336*D1*Dd*f*fd*s**2 - 252*D1*Dd*f*fd*s + 42*D1*Dd*f*fd - 140*D1*Dd*f*s**2 + 70*D1*Dd*f*s - 35*D1*Dd*f + 200*D1*Dd*fd*s**2 - 298*D1*Dd*fd*s + 62*D1*Dd*fd + 84*D1*Ddd*f**2*s**2 - 42*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 + 100*D1*Ddd*f*s**2 - 50*D1*Ddd*f*s + 25*D1*Ddd*f + 4*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) + 252*Dd**2*f**2*s**2 - 126*Dd**2*f**2*s + 300*Dd**2*f*s**2 - 150*Dd**2*f*s) + b1*(-28*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) + 14*D1**2*bdd1*f*(s**2*(21*f + 25) + 6*s - 3) - 9*D1**2*(f*(23*fd - 15*fdd)*(2*s**2 - 2*s + 1) - 30*fd**2*s*(s - 1)) - 14*D1*bd1*(D1*(33*f**2*s**2 + f*(s**2*(35 - 84*fd) + s*(42*fd + 12) - 6) + 2*fd*s*(28 - 25*s)) - 2*Dd*f*(4*s - 1)*(s*(21*f + 25) + 3)) - 9*D1*f*(23*Dd*f*(4*s**2 - 2*s + 1) - 30*Dd*fd*(8*s**2 - 6*s + 1) - 15*Ddd*f*(4*s**2 - 2*s + 1)) - 810*Dd**2*f**2*s*(1 - 2*s)))/(105*d**2*k2**3) + D1**2*Pk2*Pk3*ct**3*k2**5*(32*C - 16)*(D1*f*(-D1*bdd1*f*r*(r + s - 1) + bd1*(2*D1*f*r*(r + s - 1) + D1*fd*(-4*r**2 - 4*r*(s - 1) + s - 1) + Dd*f*(-8*r**2 - 8*r*s + 9*r + 2*s - 2))) + b1*(D1**2*(f*(2*fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-2*r**2 - 2*r*(s - 1) + s)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - Dd*fd*(2*r - 1)*(8*r + 8*s - 5) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)))/(35*d**2*k1*k3**6) - 16*D1**2*Pk2*Pk3*ct**2*f**2*k1**6*st**2*(D1**2*(f*(17*fd - 14*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 14*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(17*f*(r*(4*s - 1) + (1 - 2*s)**2) - 28*fd*(4*s - 1)*(4*r + 4*s - 3)) - 14*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 14*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k2**2*k3**6) + 4*D1**2*Pk2*Pk3*ct**2*f*k1**6*(-30*D1**2*b1*f*fd*r*s - 30*D1**2*b1*f*fd*s**2 + 20*D1**2*b1*f*fd*s + 42*D1**2*b1*f*fdd*r*s + 42*D1**2*b1*f*fdd*s**2 - 28*D1**2*b1*f*fdd*s + 84*D1**2*b1*fd**2*r*s + 84*D1**2*b1*fd**2*s**2 - 56*D1**2*b1*fd**2*s + 14*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + 84*D1**2*f**2*fd*r*s - 21*D1**2*f**2*fd*r + 84*D1**2*f**2*fd*s**2 - 84*D1**2*f**2*fd*s + 21*D1**2*f**2*fd - 84*D1**2*f**2*fdd*r*s + 21*D1**2*f**2*fdd*r - 84*D1**2*f**2*fdd*s**2 + 84*D1**2*f**2*fdd*s - 21*D1**2*f**2*fdd - 252*D1**2*f*fd**2*r*s + 63*D1**2*f*fd**2*r - 252*D1**2*f*fd**2*s**2 + 252*D1**2*f*fd**2*s - 42*D1**2*f*fd**2 - 40*D1*Dd*b1*f**2*r*s + 10*D1*Dd*b1*f**2*r - 40*D1*Dd*b1*f**2*s**2 + 40*D1*Dd*b1*f**2*s - 10*D1*Dd*b1*f**2 + 336*D1*Dd*b1*f*fd*r*s - 42*D1*Dd*b1*f*fd*r + 336*D1*Dd*b1*f*fd*s**2 - 280*D1*Dd*b1*f*fd*s + 28*D1*Dd*b1*f*fd + 84*D1*Dd*f**3*r*s - 21*D1*Dd*f**3*r + 84*D1*Dd*f**3*s**2 - 84*D1*Dd*f**3*s + 21*D1*Dd*f**3 - 672*D1*Dd*f**2*fd*r*s + 168*D1*Dd*f**2*fd*r - 672*D1*Dd*f**2*fd*s**2 + 672*D1*Dd*f**2*fd*s - 126*D1*Dd*f**2*fd + 56*D1*Ddd*b1*f**2*r*s - 14*D1*Ddd*b1*f**2*r + 56*D1*Ddd*b1*f**2*s**2 - 56*D1*Ddd*b1*f**2*s + 14*D1*Ddd*b1*f**2 - 84*D1*Ddd*f**3*r*s + 21*D1*Ddd*f**3*r - 84*D1*Ddd*f**3*s**2 + 84*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(5*f*(s - 1)*(r + s - 1) - 7*fd*(6*r*s - 3*r + 6*s**2 - 8*s + 2)) - 7*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 168*Dd**2*b1*f**2*r*s - 42*Dd**2*b1*f**2*r + 168*Dd**2*b1*f**2*s**2 - 168*Dd**2*b1*f**2*s + 28*Dd**2*b1*f**2 - 252*Dd**2*f**3*r*s + 63*Dd**2*f**3*r - 252*Dd**2*f**3*s**2 + 252*Dd**2*f**3*s - 42*Dd**2*f**3)/(63*d**2*k2**2*k3**6) + 4*D1**2*Pk2*Pk3*ct**2*k1**6*st**2*(-66*C*D1**2*f**2*fd*r**2 - 132*C*D1**2*f**2*fd*r*s + 88*C*D1**2*f**2*fd*r - 66*C*D1**2*f**2*fd*s**2 + 88*C*D1**2*f**2*fd*s - 44*C*D1**2*f**2*fd + 330*C*D1**2*f**2*fdd*r**2 + 660*C*D1**2*f**2*fdd*r*s - 440*C*D1**2*f**2*fdd*r + 330*C*D1**2*f**2*fdd*s**2 - 440*C*D1**2*f**2*fdd*s + 220*C*D1**2*f**2*fdd + 660*C*D1**2*f*fd**2*r**2 + 1320*C*D1**2*f*fd**2*r*s - 880*C*D1**2*f*fd**2*r + 660*C*D1**2*f*fd**2*s**2 - 880*C*D1**2*f*fd**2*s + 220*C*D1**2*f*fd**2 - 88*C*D1*Dd*f**3*r**2 - 176*C*D1*Dd*f**3*r*s + 132*C*D1*Dd*f**3*r - 88*C*D1*Dd*f**3*s**2 + 132*C*D1*Dd*f**3*s - 66*C*D1*Dd*f**3 + 2640*C*D1*Dd*f**2*fd*r**2 + 5280*C*D1*Dd*f**2*fd*r*s - 3740*C*D1*Dd*f**2*fd*r + 2640*C*D1*Dd*f**2*fd*s**2 - 3740*C*D1*Dd*f**2*fd*s + 1320*C*D1*Dd*f**2*fd + 440*C*D1*Ddd*f**3*r**2 + 880*C*D1*Ddd*f**3*r*s - 660*C*D1*Ddd*f**3*r + 440*C*D1*Ddd*f**3*s**2 - 660*C*D1*Ddd*f**3*s + 330*C*D1*Ddd*f**3 + 1320*C*Dd**2*f**3*r**2 + 2640*C*Dd**2*f**3*r*s - 1980*C*Dd**2*f**3*r + 1320*C*Dd**2*f**3*s**2 - 1980*C*Dd**2*f**3*s + 660*C*Dd**2*f**3 + 66*D1**2*K*b1*f*fd*r**2 + 132*D1**2*K*b1*f*fd*r*s - 66*D1**2*K*b1*f*fd*r + 66*D1**2*K*b1*f*fd*s**2 - 66*D1**2*K*b1*f*fd*s + 33*D1**2*K*b1*f*fd + 198*D1**2*K*b1*f*fdd*r**2 + 396*D1**2*K*b1*f*fdd*r*s - 198*D1**2*K*b1*f*fdd*r + 198*D1**2*K*b1*f*fdd*s**2 - 198*D1**2*K*b1*f*fdd*s + 99*D1**2*K*b1*f*fdd + 198*D1**2*K*b1*fd**2*r**2 + 396*D1**2*K*b1*fd**2*r*s - 198*D1**2*K*b1*fd**2*r + 198*D1**2*K*b1*fd**2*s**2 - 198*D1**2*K*b1*fd**2*s - 66*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fd*s**2 + 66*D1**2*b1*f*fd*s - 33*D1**2*b1*f*fd - 198*D1**2*b1*f*fdd*r**2 - 396*D1**2*b1*f*fdd*r*s + 198*D1**2*b1*f*fdd*r - 198*D1**2*b1*f*fdd*s**2 + 198*D1**2*b1*f*fdd*s - 99*D1**2*b1*f*fdd - 198*D1**2*b1*fd**2*r**2 - 396*D1**2*b1*fd**2*r*s + 198*D1**2*b1*fd**2*r - 198*D1**2*b1*fd**2*s**2 + 198*D1**2*b1*fd**2*s + 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 - 3120*D1**2*f**3*fd*r**2 - 6240*D1**2*f**3*fd*r*s + 4680*D1**2*f**3*fd*r - 3120*D1**2*f**3*fd*s**2 + 4680*D1**2*f**3*fd*s - 2340*D1**2*f**3*fd + 4200*D1**2*f**3*fdd*r**2 + 8400*D1**2*f**3*fdd*r*s - 6300*D1**2*f**3*fdd*r + 4200*D1**2*f**3*fdd*s**2 - 6300*D1**2*f**3*fdd*s + 3150*D1**2*f**3*fdd + 12600*D1**2*f**2*fd**2*r**2 + 25200*D1**2*f**2*fd**2*r*s - 18900*D1**2*f**2*fd**2*r + 12600*D1**2*f**2*fd**2*s**2 - 18900*D1**2*f**2*fd**2*s + 6300*D1**2*f**2*fd**2 + 66*D1**2*f**2*fd*r**2 + 132*D1**2*f**2*fd*r*s - 88*D1**2*f**2*fd*r + 66*D1**2*f**2*fd*s**2 - 88*D1**2*f**2*fd*s + 44*D1**2*f**2*fd - 330*D1**2*f**2*fdd*r**2 - 660*D1**2*f**2*fdd*r*s + 440*D1**2*f**2*fdd*r - 330*D1**2*f**2*fdd*s**2 + 440*D1**2*f**2*fdd*s - 220*D1**2*f**2*fdd - 66*D1**2*f**2*gd2*r**2 - 132*D1**2*f**2*gd2*r*s + 132*D1**2*f**2*gd2*r - 66*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s - 66*D1**2*f**2*gd2 - 198*D1**2*f**2*gdd2*r**2 - 396*D1**2*f**2*gdd2*r*s + 396*D1**2*f**2*gdd2*r - 198*D1**2*f**2*gdd2*s**2 + 396*D1**2*f**2*gdd2*s - 198*D1**2*f**2*gdd2 - 660*D1**2*f*fd**2*r**2 - 1320*D1**2*f*fd**2*r*s + 880*D1**2*f*fd**2*r - 660*D1**2*f*fd**2*s**2 + 880*D1**2*f*fd**2*s - 220*D1**2*f*fd**2 - 132*D1**2*f*fd*g2*r**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 132*D1**2*f*fd*g2*s**2 + 132*D1**2*f*fd*g2*s - 66*D1**2*f*fd*g2 - 792*D1**2*f*fd*gd2*r**2 - 1584*D1**2*f*fd*gd2*r*s + 1188*D1**2*f*fd*gd2*r - 792*D1**2*f*fd*gd2*s**2 + 1188*D1**2*f*fd*gd2*s - 396*D1**2*f*fd*gd2 - 396*D1**2*f*fdd*g2*r**2 - 792*D1**2*f*fdd*g2*r*s + 396*D1**2*f*fdd*g2*r - 396*D1**2*f*fdd*g2*s**2 + 396*D1**2*f*fdd*g2*s - 198*D1**2*f*fdd*g2 - 396*D1**2*fd**2*g2*r**2 - 792*D1**2*fd**2*g2*r*s + 396*D1**2*fd**2*g2*r - 396*D1**2*fd**2*g2*s**2 + 396*D1**2*fd**2*g2*s + 132*D1*Dd*K*b1*f**2*r**2 + 264*D1*Dd*K*b1*f**2*r*s - 198*D1*Dd*K*b1*f**2*r + 132*D1*Dd*K*b1*f**2*s**2 - 198*D1*Dd*K*b1*f**2*s + 99*D1*Dd*K*b1*f**2 + 1584*D1*Dd*K*b1*f*fd*r**2 + 3168*D1*Dd*K*b1*f*fd*r*s - 1980*D1*Dd*K*b1*f*fd*r + 1584*D1*Dd*K*b1*f*fd*s**2 - 1980*D1*Dd*K*b1*f*fd*s + 594*D1*Dd*K*b1*f*fd - 132*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 198*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s**2 + 198*D1*Dd*b1*f**2*s - 99*D1*Dd*b1*f**2 - 1584*D1*Dd*b1*f*fd*r**2 - 3168*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r - 1584*D1*Dd*b1*f*fd*s**2 + 1980*D1*Dd*b1*f*fd*s - 594*D1*Dd*b1*f*fd - 3120*D1*Dd*f**4*r**2 - 6240*D1*Dd*f**4*r*s + 4680*D1*Dd*f**4*r - 3120*D1*Dd*f**4*s**2 + 4680*D1*Dd*f**4*s - 2340*D1*Dd*f**4 + 33600*D1*Dd*f**3*fd*r**2 + 67200*D1*Dd*f**3*fd*r*s - 50400*D1*Dd*f**3*fd*r + 33600*D1*Dd*f**3*fd*s**2 - 50400*D1*Dd*f**3*fd*s + 18900*D1*Dd*f**3*fd + 88*D1*Dd*f**3*r**2 + 176*D1*Dd*f**3*r*s - 132*D1*Dd*f**3*r + 88*D1*Dd*f**3*s**2 - 132*D1*Dd*f**3*s + 66*D1*Dd*f**3 - 2640*D1*Dd*f**2*fd*r**2 - 5280*D1*Dd*f**2*fd*r*s + 3740*D1*Dd*f**2*fd*r - 2640*D1*Dd*f**2*fd*s**2 + 3740*D1*Dd*f**2*fd*s - 1320*D1*Dd*f**2*fd - 264*D1*Dd*f**2*g2*r**2 - 528*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 264*D1*Dd*f**2*g2*s**2 + 396*D1*Dd*f**2*g2*s - 198*D1*Dd*f**2*g2 - 1584*D1*Dd*f**2*gd2*r**2 - 3168*D1*Dd*f**2*gd2*r*s + 2772*D1*Dd*f**2*gd2*r - 1584*D1*Dd*f**2*gd2*s**2 + 2772*D1*Dd*f**2*gd2*s - 1188*D1*Dd*f**2*gd2 - 3168*D1*Dd*f*fd*g2*r**2 - 6336*D1*Dd*f*fd*g2*r*s + 3960*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s**2 + 3960*D1*Dd*f*fd*g2*s - 1188*D1*Dd*f*fd*g2 + 396*D1*Ddd*K*b1*f**2*r**2 + 792*D1*Ddd*K*b1*f**2*r*s - 594*D1*Ddd*K*b1*f**2*r + 396*D1*Ddd*K*b1*f**2*s**2 - 594*D1*Ddd*K*b1*f**2*s + 297*D1*Ddd*K*b1*f**2 - 396*D1*Ddd*b1*f**2*r**2 - 792*D1*Ddd*b1*f**2*r*s + 594*D1*Ddd*b1*f**2*r - 396*D1*Ddd*b1*f**2*s**2 + 594*D1*Ddd*b1*f**2*s - 297*D1*Ddd*b1*f**2 + 4200*D1*Ddd*f**4*r**2 + 8400*D1*Ddd*f**4*r*s - 6300*D1*Ddd*f**4*r + 4200*D1*Ddd*f**4*s**2 - 6300*D1*Ddd*f**4*s + 3150*D1*Ddd*f**4 - 440*D1*Ddd*f**3*r**2 - 880*D1*Ddd*f**3*r*s + 660*D1*Ddd*f**3*r - 440*D1*Ddd*f**3*s**2 + 660*D1*Ddd*f**3*s - 330*D1*Ddd*f**3 - 792*D1*Ddd*f**2*g2*r**2 - 1584*D1*Ddd*f**2*g2*r*s + 1188*D1*Ddd*f**2*g2*r - 792*D1*Ddd*f**2*g2*s**2 + 1188*D1*Ddd*f**2*g2*s - 594*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) + 6*D1*fd*(2*r + 2*s - 1) + 6*Dd*f*(4*r + 4*s - 3)) + 1188*Dd**2*K*b1*f**2*r**2 + 2376*Dd**2*K*b1*f**2*r*s - 1782*Dd**2*K*b1*f**2*r + 1188*Dd**2*K*b1*f**2*s**2 - 1782*Dd**2*K*b1*f**2*s + 594*Dd**2*K*b1*f**2 - 1188*Dd**2*b1*f**2*r**2 - 2376*Dd**2*b1*f**2*r*s + 1782*Dd**2*b1*f**2*r - 1188*Dd**2*b1*f**2*s**2 + 1782*Dd**2*b1*f**2*s - 594*Dd**2*b1*f**2 + 12600*Dd**2*f**4*r**2 + 25200*Dd**2*f**4*r*s - 18900*Dd**2*f**4*r + 12600*Dd**2*f**4*s**2 - 18900*Dd**2*f**4*s + 6300*Dd**2*f**4 - 1320*Dd**2*f**3*r**2 - 2640*Dd**2*f**3*r*s + 1980*Dd**2*f**3*r - 1320*Dd**2*f**3*s**2 + 1980*Dd**2*f**3*s - 660*Dd**2*f**3 - 2376*Dd**2*f**2*g2*r**2 - 4752*Dd**2*f**2*g2*r*s + 3564*Dd**2*f**2*g2*r - 2376*Dd**2*f**2*g2*s**2 + 3564*Dd**2*f**2*g2*s - 1188*Dd**2*f**2*g2)/(1155*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**2*k1**6*(-2*D1*(r + s - 1)*(63*D1*bd1**2*f*(K - 1)*(r + s - 1) - D1*bd1*(50*f**3*(r + s - 1) + f**2*(27*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) - 27*r - 27*s + 27) - 3*f*(fd*(30*C - 30)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 126*fd*g2*(r + s)) + D1*bdd1*f*(70*f**2 + f*(45*C - 45) - 63*g2)*(r + s - 1) + 2*Dd*bd1*f*(70*f**2 + f*(45*C - 45) - 63*g2)*(4*r + 4*s - 3)) + 21*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(r + s)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(54*C*D1**2*f*fd*r**2 + 108*C*D1**2*f*fd*r*s - 54*C*D1**2*f*fd*r + 54*C*D1**2*f*fd*s**2 - 54*C*D1**2*f*fd*s + 27*C*D1**2*f*fd - 90*C*D1**2*f*fdd*r**2 - 180*C*D1**2*f*fdd*r*s + 90*C*D1**2*f*fdd*r - 90*C*D1**2*f*fdd*s**2 + 90*C*D1**2*f*fdd*s - 45*C*D1**2*f*fdd - 90*C*D1**2*fd**2*r**2 - 180*C*D1**2*fd**2*r*s + 90*C*D1**2*fd**2*r - 90*C*D1**2*fd**2*s**2 + 90*C*D1**2*fd**2*s + 108*C*D1*Dd*f**2*r**2 + 216*C*D1*Dd*f**2*r*s - 162*C*D1*Dd*f**2*r + 108*C*D1*Dd*f**2*s**2 - 162*C*D1*Dd*f**2*s + 81*C*D1*Dd*f**2 - 720*C*D1*Dd*f*fd*r**2 - 1440*C*D1*Dd*f*fd*r*s + 900*C*D1*Dd*f*fd*r - 720*C*D1*Dd*f*fd*s**2 + 900*C*D1*Dd*f*fd*s - 270*C*D1*Dd*f*fd - 180*C*D1*Ddd*f**2*r**2 - 360*C*D1*Ddd*f**2*r*s + 270*C*D1*Ddd*f**2*r - 180*C*D1*Ddd*f**2*s**2 + 270*C*D1*Ddd*f**2*s - 135*C*D1*Ddd*f**2 - 540*C*Dd**2*f**2*r**2 - 1080*C*Dd**2*f**2*r*s + 810*C*Dd**2*f**2*r - 540*C*Dd**2*f**2*s**2 + 810*C*Dd**2*f**2*s - 270*C*Dd**2*f**2 - 63*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 150*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 - 200*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 280*D1**2*f**2*fdd*r - 210*D1**2*f**2*fdd*s**2 + 280*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 560*D1**2*f*fd**2*r - 420*D1**2*f*fd**2*s**2 + 560*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 54*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 54*D1**2*f*fd*r - 54*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 180*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 90*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 45*D1**2*f*fdd - 21*D1**2*f*gd2*r**2 - 42*D1**2*f*gd2*r*s + 42*D1**2*f*gd2*r - 21*D1**2*f*gd2*s**2 + 42*D1**2*f*gd2*s - 21*D1**2*f*gd2 + 63*D1**2*f*gdd2*r**2 + 126*D1**2*f*gdd2*r*s - 126*D1**2*f*gdd2*r + 63*D1**2*f*gdd2*s**2 - 126*D1**2*f*gdd2*s + 63*D1**2*f*gdd2 + 90*D1**2*fd**2*r**2 + 180*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 90*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 21*D1**2*fd*g2*r**2 - 42*D1**2*fd*g2*r*s - 21*D1**2*fd*g2*s**2 + 126*D1**2*fd*gd2*r**2 + 252*D1**2*fd*gd2*r*s - 126*D1**2*fd*gd2*r + 126*D1**2*fd*gd2*s**2 - 126*D1**2*fd*gd2*s + 63*D1**2*fdd*g2*r**2 + 126*D1**2*fdd*g2*r*s + 63*D1**2*fdd*g2*s**2 + 200*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 150*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2380*D1*Dd*f**2*fd*r - 1680*D1*Dd*f**2*fd*s**2 + 2380*D1*Dd*f**2*fd*s - 840*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 162*D1*Dd*f**2*r - 108*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1440*D1*Dd*f*fd*r*s - 900*D1*Dd*f*fd*r + 720*D1*Dd*f*fd*s**2 - 900*D1*Dd*f*fd*s + 270*D1*Dd*f*fd - 84*D1*Dd*f*g2*r**2 - 168*D1*Dd*f*g2*r*s + 126*D1*Dd*f*g2*r - 84*D1*Dd*f*g2*s**2 + 126*D1*Dd*f*g2*s - 63*D1*Dd*f*g2 + 504*D1*Dd*f*gd2*r**2 + 1008*D1*Dd*f*gd2*r*s - 882*D1*Dd*f*gd2*r + 504*D1*Dd*f*gd2*s**2 - 882*D1*Dd*f*gd2*s + 378*D1*Dd*f*gd2 + 504*D1*Dd*fd*g2*r**2 + 1008*D1*Dd*fd*g2*r*s - 378*D1*Dd*fd*g2*r + 504*D1*Dd*fd*g2*s**2 - 378*D1*Dd*fd*g2*s - 280*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s**2 + 420*D1*Ddd*f**3*s - 210*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 + 360*D1*Ddd*f**2*r*s - 270*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s**2 - 270*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 + 252*D1*Ddd*f*g2*r**2 + 504*D1*Ddd*f*g2*r*s - 378*D1*Ddd*f*g2*r + 252*D1*Ddd*f*g2*s**2 - 378*D1*Ddd*f*g2*s + 189*D1*Ddd*f*g2 + 21*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 840*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 840*Dd**2*f**3*s**2 + 1260*Dd**2*f**3*s - 420*Dd**2*f**3 + 540*Dd**2*f**2*r**2 + 1080*Dd**2*f**2*r*s - 810*Dd**2*f**2*r + 540*Dd**2*f**2*s**2 - 810*Dd**2*f**2*s + 270*Dd**2*f**2 + 756*Dd**2*f*g2*r**2 + 1512*Dd**2*f*g2*r*s - 1134*Dd**2*f*g2*r + 756*Dd**2*f*g2*s**2 - 1134*Dd**2*f*g2*s + 378*Dd**2*f*g2))/(105*d**2*k3**8) - 12*D1**2*Pk2*Pk3*ct**2*k1**4*k2**2*st**4*(198*C*D1**2*f**2*fd*r**2 + 396*C*D1**2*f**2*fd*r*s - 264*C*D1**2*f**2*fd*r + 198*C*D1**2*f**2*fd*s**2 - 264*C*D1**2*f**2*fd*s + 132*C*D1**2*f**2*fd - 132*C*D1**2*f**2*fdd*r**2 - 264*C*D1**2*f**2*fdd*r*s + 176*C*D1**2*f**2*fdd*r - 132*C*D1**2*f**2*fdd*s**2 + 176*C*D1**2*f**2*fdd*s - 88*C*D1**2*f**2*fdd - 264*C*D1**2*f*fd**2*r**2 - 528*C*D1**2*f*fd**2*r*s + 352*C*D1**2*f*fd**2*r - 264*C*D1**2*f*fd**2*s**2 + 352*C*D1**2*f*fd**2*s - 88*C*D1**2*f*fd**2 + 264*C*D1*Dd*f**3*r**2 + 528*C*D1*Dd*f**3*r*s - 396*C*D1*Dd*f**3*r + 264*C*D1*Dd*f**3*s**2 - 396*C*D1*Dd*f**3*s + 198*C*D1*Dd*f**3 - 1056*C*D1*Dd*f**2*fd*r**2 - 2112*C*D1*Dd*f**2*fd*r*s + 1496*C*D1*Dd*f**2*fd*r - 1056*C*D1*Dd*f**2*fd*s**2 + 1496*C*D1*Dd*f**2*fd*s - 528*C*D1*Dd*f**2*fd - 176*C*D1*Ddd*f**3*r**2 - 352*C*D1*Ddd*f**3*r*s + 264*C*D1*Ddd*f**3*r - 176*C*D1*Ddd*f**3*s**2 + 264*C*D1*Ddd*f**3*s - 132*C*D1*Ddd*f**3 - 528*C*Dd**2*f**3*r**2 - 1056*C*Dd**2*f**3*r*s + 792*C*Dd**2*f**3*r - 528*C*Dd**2*f**3*s**2 + 792*C*Dd**2*f**3*s - 264*C*Dd**2*f**3 + 110*D1**2*K*b1*f*fd*r**2 + 220*D1**2*K*b1*f*fd*r*s - 110*D1**2*K*b1*f*fd*r + 110*D1**2*K*b1*f*fd*s**2 - 110*D1**2*K*b1*f*fd*s + 55*D1**2*K*b1*f*fd - 132*D1**2*K*b1*f*fdd*r**2 - 264*D1**2*K*b1*f*fdd*r*s + 132*D1**2*K*b1*f*fdd*r - 132*D1**2*K*b1*f*fdd*s**2 + 132*D1**2*K*b1*f*fdd*s - 66*D1**2*K*b1*f*fdd - 132*D1**2*K*b1*fd**2*r**2 - 264*D1**2*K*b1*fd**2*r*s + 132*D1**2*K*b1*fd**2*r - 132*D1**2*K*b1*fd**2*s**2 + 132*D1**2*K*b1*fd**2*s - 110*D1**2*b1*f*fd*r**2 - 220*D1**2*b1*f*fd*r*s + 110*D1**2*b1*f*fd*r - 110*D1**2*b1*f*fd*s**2 + 110*D1**2*b1*f*fd*s - 55*D1**2*b1*f*fd + 132*D1**2*b1*f*fdd*r**2 + 264*D1**2*b1*f*fdd*r*s - 132*D1**2*b1*f*fdd*r + 132*D1**2*b1*f*fdd*s**2 - 132*D1**2*b1*f*fdd*s + 66*D1**2*b1*f*fdd + 132*D1**2*b1*fd**2*r**2 + 264*D1**2*b1*fd**2*r*s - 132*D1**2*b1*fd**2*r + 132*D1**2*b1*fd**2*s**2 - 132*D1**2*b1*fd**2*s - 66*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 1340*D1**2*f**3*fd*r**2 + 2680*D1**2*f**3*fd*r*s - 2010*D1**2*f**3*fd*r + 1340*D1**2*f**3*fd*s**2 - 2010*D1**2*f**3*fd*s + 1005*D1**2*f**3*fd - 1000*D1**2*f**3*fdd*r**2 - 2000*D1**2*f**3*fdd*r*s + 1500*D1**2*f**3*fdd*r - 1000*D1**2*f**3*fdd*s**2 + 1500*D1**2*f**3*fdd*s - 750*D1**2*f**3*fdd - 3000*D1**2*f**2*fd**2*r**2 - 6000*D1**2*f**2*fd**2*r*s + 4500*D1**2*f**2*fd**2*r - 3000*D1**2*f**2*fd**2*s**2 + 4500*D1**2*f**2*fd**2*s - 1500*D1**2*f**2*fd**2 - 198*D1**2*f**2*fd*r**2 - 396*D1**2*f**2*fd*r*s + 264*D1**2*f**2*fd*r - 198*D1**2*f**2*fd*s**2 + 264*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 132*D1**2*f**2*fdd*r**2 + 264*D1**2*f**2*fdd*r*s - 176*D1**2*f**2*fdd*r + 132*D1**2*f**2*fdd*s**2 - 176*D1**2*f**2*fdd*s + 88*D1**2*f**2*fdd - 110*D1**2*f**2*gd2*r**2 - 220*D1**2*f**2*gd2*r*s + 220*D1**2*f**2*gd2*r - 110*D1**2*f**2*gd2*s**2 + 220*D1**2*f**2*gd2*s - 110*D1**2*f**2*gd2 + 132*D1**2*f**2*gdd2*r**2 + 264*D1**2*f**2*gdd2*r*s - 264*D1**2*f**2*gdd2*r + 132*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 132*D1**2*f**2*gdd2 + 264*D1**2*f*fd**2*r**2 + 528*D1**2*f*fd**2*r*s - 352*D1**2*f*fd**2*r + 264*D1**2*f*fd**2*s**2 - 352*D1**2*f*fd**2*s + 88*D1**2*f*fd**2 - 220*D1**2*f*fd*g2*r**2 - 440*D1**2*f*fd*g2*r*s + 220*D1**2*f*fd*g2*r - 220*D1**2*f*fd*g2*s**2 + 220*D1**2*f*fd*g2*s - 110*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r**2 + 1056*D1**2*f*fd*gd2*r*s - 792*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r**2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r**2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s + 220*D1*Dd*K*b1*f**2*r**2 + 440*D1*Dd*K*b1*f**2*r*s - 330*D1*Dd*K*b1*f**2*r + 220*D1*Dd*K*b1*f**2*s**2 - 330*D1*Dd*K*b1*f**2*s + 165*D1*Dd*K*b1*f**2 - 1056*D1*Dd*K*b1*f*fd*r**2 - 2112*D1*Dd*K*b1*f*fd*r*s + 1320*D1*Dd*K*b1*f*fd*r - 1056*D1*Dd*K*b1*f*fd*s**2 + 1320*D1*Dd*K*b1*f*fd*s - 396*D1*Dd*K*b1*f*fd - 220*D1*Dd*b1*f**2*r**2 - 440*D1*Dd*b1*f**2*r*s + 330*D1*Dd*b1*f**2*r - 220*D1*Dd*b1*f**2*s**2 + 330*D1*Dd*b1*f**2*s - 165*D1*Dd*b1*f**2 + 1056*D1*Dd*b1*f*fd*r**2 + 2112*D1*Dd*b1*f*fd*r*s - 1320*D1*Dd*b1*f*fd*r + 1056*D1*Dd*b1*f*fd*s**2 - 1320*D1*Dd*b1*f*fd*s + 396*D1*Dd*b1*f*fd + 1340*D1*Dd*f**4*r**2 + 2680*D1*Dd*f**4*r*s - 2010*D1*Dd*f**4*r + 1340*D1*Dd*f**4*s**2 - 2010*D1*Dd*f**4*s + 1005*D1*Dd*f**4 - 8000*D1*Dd*f**3*fd*r**2 - 16000*D1*Dd*f**3*fd*r*s + 12000*D1*Dd*f**3*fd*r - 8000*D1*Dd*f**3*fd*s**2 + 12000*D1*Dd*f**3*fd*s - 4500*D1*Dd*f**3*fd - 264*D1*Dd*f**3*r**2 - 528*D1*Dd*f**3*r*s + 396*D1*Dd*f**3*r - 264*D1*Dd*f**3*s**2 + 396*D1*Dd*f**3*s - 198*D1*Dd*f**3 + 1056*D1*Dd*f**2*fd*r**2 + 2112*D1*Dd*f**2*fd*r*s - 1496*D1*Dd*f**2*fd*r + 1056*D1*Dd*f**2*fd*s**2 - 1496*D1*Dd*f**2*fd*s + 528*D1*Dd*f**2*fd - 440*D1*Dd*f**2*g2*r**2 - 880*D1*Dd*f**2*g2*r*s + 660*D1*Dd*f**2*g2*r - 440*D1*Dd*f**2*g2*s**2 + 660*D1*Dd*f**2*g2*s - 330*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r**2 + 2112*D1*Dd*f**2*gd2*r*s - 1848*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1848*D1*Dd*f**2*gd2*s + 792*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r**2 + 4224*D1*Dd*f*fd*g2*r*s - 2640*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2640*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 264*D1*Ddd*K*b1*f**2*r**2 - 528*D1*Ddd*K*b1*f**2*r*s + 396*D1*Ddd*K*b1*f**2*r - 264*D1*Ddd*K*b1*f**2*s**2 + 396*D1*Ddd*K*b1*f**2*s - 198*D1*Ddd*K*b1*f**2 + 264*D1*Ddd*b1*f**2*r**2 + 528*D1*Ddd*b1*f**2*r*s - 396*D1*Ddd*b1*f**2*r + 264*D1*Ddd*b1*f**2*s**2 - 396*D1*Ddd*b1*f**2*s + 198*D1*Ddd*b1*f**2 - 1000*D1*Ddd*f**4*r**2 - 2000*D1*Ddd*f**4*r*s + 1500*D1*Ddd*f**4*r - 1000*D1*Ddd*f**4*s**2 + 1500*D1*Ddd*f**4*s - 750*D1*Ddd*f**4 + 176*D1*Ddd*f**3*r**2 + 352*D1*Ddd*f**3*r*s - 264*D1*Ddd*f**3*r + 176*D1*Ddd*f**3*s**2 - 264*D1*Ddd*f**3*s + 132*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r**2 + 1056*D1*Ddd*f**2*g2*r*s - 792*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 396*D1*Ddd*f**2*g2 + 11*D1*bd1*f*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 792*Dd**2*K*b1*f**2*r**2 - 1584*Dd**2*K*b1*f**2*r*s + 1188*Dd**2*K*b1*f**2*r - 792*Dd**2*K*b1*f**2*s**2 + 1188*Dd**2*K*b1*f**2*s - 396*Dd**2*K*b1*f**2 + 792*Dd**2*b1*f**2*r**2 + 1584*Dd**2*b1*f**2*r*s - 1188*Dd**2*b1*f**2*r + 792*Dd**2*b1*f**2*s**2 - 1188*Dd**2*b1*f**2*s + 396*Dd**2*b1*f**2 - 3000*Dd**2*f**4*r**2 - 6000*Dd**2*f**4*r*s + 4500*Dd**2*f**4*r - 3000*Dd**2*f**4*s**2 + 4500*Dd**2*f**4*s - 1500*Dd**2*f**4 + 528*Dd**2*f**3*r**2 + 1056*Dd**2*f**3*r*s - 792*Dd**2*f**3*r + 528*Dd**2*f**3*s**2 - 792*Dd**2*f**3*s + 264*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r**2 + 3168*Dd**2*f**2*g2*r*s - 2376*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 792*Dd**2*f**2*g2)/(385*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**2*k1**4*k2**2*st**2*(-84*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 12*D1**2*bdd1*f*(3*f*(C + 2*K - 2) - 7*g2)*(r + s - 1)**2 - 2*D1**2*(15*f**3*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-fd*(29*C - 21)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(40*C - 30)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (25*gd2 - 72*gdd2)*(r + s - 1)**2) + f*(fd**2*(80*C - 60)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + fd*(25*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 144*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 72*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 144*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bd1*(D1*(36*f**3*(r + s - 1) + f**2*(58*C + 25*K - 67)*(r + s - 1) - 2*f*(36*fd*(C + 2*K - 2)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 24*Dd*f*(3*f*(C + 2*K - 2) - 7*g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(15*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(29*C - 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(fd*(80*C - 60)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 25*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 144*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 144*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2*Ddd*f*(f*(20*C - 15) - 36*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Dd**2*f**2*(f*(20*C - 15) - 36*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*b1**2*(K - 1)*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(116*C*D1**2*f*fd*r**2 + 232*C*D1**2*f*fd*r*s - 116*C*D1**2*f*fd*r + 116*C*D1**2*f*fd*s**2 - 116*C*D1**2*f*fd*s + 58*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r**2 - 144*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s**2 + 72*C*D1**2*f*fdd*s - 36*C*D1**2*f*fdd - 72*C*D1**2*fd**2*r**2 - 144*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*r - 72*C*D1**2*fd**2*s**2 + 72*C*D1**2*fd**2*s + 232*C*D1*Dd*f**2*r**2 + 464*C*D1*Dd*f**2*r*s - 348*C*D1*Dd*f**2*r + 232*C*D1*Dd*f**2*s**2 - 348*C*D1*Dd*f**2*s + 174*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r**2 - 1152*C*D1*Dd*f*fd*r*s + 720*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 720*C*D1*Dd*f*fd*s - 216*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r**2 - 288*C*D1*Ddd*f**2*r*s + 216*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 216*C*D1*Ddd*f**2*s - 108*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r**2 - 864*C*Dd**2*f**2*r*s + 648*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 648*C*Dd**2*f**2*s - 216*C*Dd**2*f**2 + 50*D1**2*K*f*fd*r**2 + 100*D1**2*K*f*fd*r*s - 50*D1**2*K*f*fd*r + 50*D1**2*K*f*fd*s**2 - 50*D1**2*K*f*fd*s + 25*D1**2*K*f*fd - 144*D1**2*K*f*fdd*r**2 - 288*D1**2*K*f*fdd*r*s + 144*D1**2*K*f*fdd*r - 144*D1**2*K*f*fdd*s**2 + 144*D1**2*K*f*fdd*s - 72*D1**2*K*f*fdd - 144*D1**2*K*fd**2*r**2 - 288*D1**2*K*fd**2*r*s + 144*D1**2*K*fd**2*r - 144*D1**2*K*fd**2*s**2 + 144*D1**2*K*fd**2*s - 84*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 108*D1**2*f**2*fd*r**2 + 216*D1**2*f**2*fd*r*s - 144*D1**2*f**2*fd*r + 108*D1**2*f**2*fd*s**2 - 144*D1**2*f**2*fd*s + 72*D1**2*f**2*fd - 134*D1**2*f*fd*r**2 - 268*D1**2*f*fd*r*s + 134*D1**2*f*fd*r - 134*D1**2*f*fd*s**2 + 134*D1**2*f*fd*s - 67*D1**2*f*fd + 144*D1**2*f*fdd*r**2 + 288*D1**2*f*fdd*r*s - 144*D1**2*f*fdd*r + 144*D1**2*f*fdd*s**2 - 144*D1**2*f*fdd*s + 72*D1**2*f*fdd - 98*D1**2*f*gd2*r**2 - 196*D1**2*f*gd2*r*s + 196*D1**2*f*gd2*r - 98*D1**2*f*gd2*s**2 + 196*D1**2*f*gd2*s - 98*D1**2*f*gd2 + 84*D1**2*f*gdd2*r**2 + 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*r + 84*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s + 84*D1**2*f*gdd2 + 144*D1**2*fd**2*r**2 + 288*D1**2*fd**2*r*s - 144*D1**2*fd**2*r + 144*D1**2*fd**2*s**2 - 144*D1**2*fd**2*s - 98*D1**2*fd*g2*r**2 - 196*D1**2*fd*g2*r*s - 98*D1**2*fd*g2*s**2 + 168*D1**2*fd*gd2*r**2 + 336*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 84*D1**2*fdd*g2*r**2 + 168*D1**2*fdd*g2*r*s + 84*D1**2*fdd*g2*s**2 + 100*D1*Dd*K*f**2*r**2 + 200*D1*Dd*K*f**2*r*s - 150*D1*Dd*K*f**2*r + 100*D1*Dd*K*f**2*s**2 - 150*D1*Dd*K*f**2*s + 75*D1*Dd*K*f**2 - 1152*D1*Dd*K*f*fd*r**2 - 2304*D1*Dd*K*f*fd*r*s + 1440*D1*Dd*K*f*fd*r - 1152*D1*Dd*K*f*fd*s**2 + 1440*D1*Dd*K*f*fd*s - 432*D1*Dd*K*f*fd + 144*D1*Dd*f**3*r**2 + 288*D1*Dd*f**3*r*s - 216*D1*Dd*f**3*r + 144*D1*Dd*f**3*s**2 - 216*D1*Dd*f**3*s + 108*D1*Dd*f**3 - 268*D1*Dd*f**2*r**2 - 536*D1*Dd*f**2*r*s + 402*D1*Dd*f**2*r - 268*D1*Dd*f**2*s**2 + 402*D1*Dd*f**2*s - 201*D1*Dd*f**2 + 1152*D1*Dd*f*fd*r**2 + 2304*D1*Dd*f*fd*r*s - 1440*D1*Dd*f*fd*r + 1152*D1*Dd*f*fd*s**2 - 1440*D1*Dd*f*fd*s + 432*D1*Dd*f*fd - 392*D1*Dd*f*g2*r**2 - 784*D1*Dd*f*g2*r*s + 588*D1*Dd*f*g2*r - 392*D1*Dd*f*g2*s**2 + 588*D1*Dd*f*g2*s - 294*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r**2 + 1344*D1*Dd*f*gd2*r*s - 1176*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 1176*D1*Dd*f*gd2*s + 504*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r**2 + 1344*D1*Dd*fd*g2*r*s - 504*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 504*D1*Dd*fd*g2*s - 288*D1*Ddd*K*f**2*r**2 - 576*D1*Ddd*K*f**2*r*s + 432*D1*Ddd*K*f**2*r - 288*D1*Ddd*K*f**2*s**2 + 432*D1*Ddd*K*f**2*s - 216*D1*Ddd*K*f**2 + 288*D1*Ddd*f**2*r**2 + 576*D1*Ddd*f**2*r*s - 432*D1*Ddd*f**2*r + 288*D1*Ddd*f**2*s**2 - 432*D1*Ddd*f**2*s + 216*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r**2 + 672*D1*Ddd*f*g2*r*s - 504*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 504*D1*Ddd*f*g2*s + 252*D1*Ddd*f*g2 + 14*D1*bd1*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 864*Dd**2*K*f**2*r**2 - 1728*Dd**2*K*f**2*r*s + 1296*Dd**2*K*f**2*r - 864*Dd**2*K*f**2*s**2 + 1296*Dd**2*K*f**2*s - 432*Dd**2*K*f**2 + 864*Dd**2*f**2*r**2 + 1728*Dd**2*f**2*r*s - 1296*Dd**2*f**2*r + 864*Dd**2*f**2*s**2 - 1296*Dd**2*f**2*s + 432*Dd**2*f**2 + 1008*Dd**2*f*g2*r**2 + 2016*Dd**2*f*g2*r*s - 1512*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1512*Dd**2*f*g2*s + 504*Dd**2*f*g2))/(35*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**2*k1**4*k2**2*(720*C*D1**2*bdd1*f**2*r**2 + 1440*C*D1**2*bdd1*f**2*r*s - 1440*C*D1**2*bdd1*f**2*r + 720*C*D1**2*bdd1*f**2*s**2 - 1440*C*D1**2*bdd1*f**2*s + 720*C*D1**2*bdd1*f**2 - 150*C*D1**2*f**2*fd*r**2 - 300*C*D1**2*f**2*fd*r*s + 200*C*D1**2*f**2*fd*r - 150*C*D1**2*f**2*fd*s**2 + 200*C*D1**2*f**2*fd*s - 100*C*D1**2*f**2*fd + 210*C*D1**2*f**2*fdd*r**2 + 420*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 210*C*D1**2*f**2*fdd*s**2 - 280*C*D1**2*f**2*fdd*s + 140*C*D1**2*f**2*fdd + 420*C*D1**2*f*fd**2*r**2 + 840*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 420*C*D1**2*f*fd**2*s**2 - 560*C*D1**2*f*fd**2*s + 140*C*D1**2*f*fd**2 - 200*C*D1*Dd*f**3*r**2 - 400*C*D1*Dd*f**3*r*s + 300*C*D1*Dd*f**3*r - 200*C*D1*Dd*f**3*s**2 + 300*C*D1*Dd*f**3*s - 150*C*D1*Dd*f**3 + 1680*C*D1*Dd*f**2*fd*r**2 + 3360*C*D1*Dd*f**2*fd*r*s - 2380*C*D1*Dd*f**2*fd*r + 1680*C*D1*Dd*f**2*fd*s**2 - 2380*C*D1*Dd*f**2*fd*s + 840*C*D1*Dd*f**2*fd + 280*C*D1*Ddd*f**3*r**2 + 560*C*D1*Ddd*f**3*r*s - 420*C*D1*Ddd*f**3*r + 280*C*D1*Ddd*f**3*s**2 - 420*C*D1*Ddd*f**3*s + 210*C*D1*Ddd*f**3 + 840*C*Dd**2*f**3*r**2 + 1680*C*Dd**2*f**3*r*s - 1260*C*Dd**2*f**3*r + 840*C*Dd**2*f**3*s**2 - 1260*C*Dd**2*f**3*s + 420*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r**2 + 90*D1**2*K*bdd1*f**2*r*s - 90*D1**2*K*bdd1*f**2*r + 45*D1**2*K*bdd1*f**2*s**2 - 90*D1**2*K*bdd1*f**2*s + 45*D1**2*K*bdd1*f**2 - 36*D1**2*bd1**2*f*(-28*K + 25*f + 14)*(r + s - 1)**2 - 540*D1**2*bdd1*f**2*r**2 - 1080*D1**2*bdd1*f**2*r*s + 1080*D1**2*bdd1*f**2*r - 540*D1**2*bdd1*f**2*s**2 + 1080*D1**2*bdd1*f**2*s - 540*D1**2*bdd1*f**2 - 1008*D1**2*bdd1*f*g2*r**2 - 2016*D1**2*bdd1*f*g2*r*s + 2016*D1**2*bdd1*f*g2*r - 1008*D1**2*bdd1*f*g2*s**2 + 2016*D1**2*bdd1*f*g2*s - 1008*D1**2*bdd1*f*g2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd + 54*D1**2*f**2*gd2*r**2 + 108*D1**2*f**2*gd2*r*s - 108*D1**2*f**2*gd2*r + 54*D1**2*f**2*gd2*s**2 - 108*D1**2*f**2*gd2*s + 54*D1**2*f**2*gd2 - 90*D1**2*f**2*gdd2*r**2 - 180*D1**2*f**2*gdd2*r*s + 180*D1**2*f**2*gdd2*r - 90*D1**2*f**2*gdd2*s**2 + 180*D1**2*f**2*gdd2*s - 90*D1**2*f**2*gdd2 - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 108*D1**2*f*fd*g2*r**2 + 216*D1**2*f*fd*g2*r*s - 108*D1**2*f*fd*g2*r + 108*D1**2*f*fd*g2*s**2 - 108*D1**2*f*fd*g2*s + 54*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r**2 - 720*D1**2*f*fd*gd2*r*s + 540*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 540*D1**2*f*fd*gd2*s - 180*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r**2 - 360*D1**2*f*fdd*g2*r*s + 180*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r**2 - 360*D1**2*fd**2*g2*r*s + 180*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 1190*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 1190*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd + 216*D1*Dd*f**2*g2*r**2 + 432*D1*Dd*f**2*g2*r*s - 324*D1*Dd*f**2*g2*r + 216*D1*Dd*f**2*g2*s**2 - 324*D1*Dd*f**2*g2*s + 162*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r**2 - 1440*D1*Dd*f**2*gd2*r*s + 1260*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 1260*D1*Dd*f**2*gd2*s - 540*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r**2 - 2880*D1*Dd*f*fd*g2*r*s + 1800*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1800*D1*Dd*f*fd*g2*s - 540*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 210*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 210*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r**2 - 720*D1*Ddd*f**2*g2*r*s + 540*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 540*D1*Ddd*f**2*g2*s - 270*D1*Ddd*f**2*g2 + 6*D1*b1*bd1*(D1*(111*f**2*(r + s - 1) - 300*f*fd*(2*r + 2*s - 1) - 7*f*(3*K + 1)*(r + s - 1) + 168*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-28*K + 25*f + 14)*(4*r + 4*s - 3))*(r + s - 1) + 9*D1*bd1*(D1*(10*f**3*(r + s - 1) - f**2*(34*C + 3*K - 22)*(r + s - 1) + 2*f*(5*fd*(16*C + K - 12)*(2*r + 2*s - 1) + (7*g2 - 112*gd2)*(r + s - 1)) - 224*fd*g2*(r + s)) + 2*Dd*f*(5*f*(16*C + K - 12) - 112*g2)*(4*r + 4*s - 3))*(r + s - 1) - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 630*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 630*Dd**2*f**3*s - 210*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r**2 - 2160*Dd**2*f**2*g2*r*s + 1620*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1620*Dd**2*f**2*g2*s - 540*Dd**2*f**2*g2 + 3*b1**2*(D1**2*(3*f*(37*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(300*fd**2*(r + s - 1) + 7*fd*(3*K + 1)*(r + s) - 84*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(111*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(300*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (21*K + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 168*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-28*K + 25*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-28*K + 25*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(4*D1**2*bdd1*f*(-28*K + 25*f + 14)*(r + s - 1)**2 - D1**2*(10*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-fd*(34*C + 3*K - 22)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*fdd*(16*C + K - 12)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (14*gd2 - 112*gdd2)*(r + s - 1)**2) + (2*r + 2*s)*(5*fd**2*(16*C + K - 12)*(r + s - 1) + 7*fd*(g2*(r + s) - 16*gd2*(r + s - 1)) - 56*fdd*g2*(r + s))) + D1*(Dd*(-10*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(34*C + 3*K - 22)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(5*fd*(16*C + K - 12)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 7*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 112*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 224*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(5*f*(16*C + K - 12) - 112*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(5*f*(16*C + K - 12) - 112*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(105*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**2*k1**4*st**4*(132*C*D1**2*f**2*fd*r*s - 44*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 132*C*D1**2*f**2*fd*s + 44*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r*s + 22*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 66*C*D1**2*f**2*fdd*s - 22*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r*s + 44*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 132*C*D1**2*f*fd**2*s - 22*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r*s - 44*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 176*C*D1*Dd*f**3*s + 44*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r*s + 154*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 528*C*D1*Dd*f**2*fd*s - 110*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r*s + 22*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 88*C*D1*Ddd*f**3*s - 22*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r*s + 66*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 264*C*Dd**2*f**3*s - 44*C*Dd**2*f**3 - 33*D1**2*K*bdd1*f**2*r*s - 33*D1**2*K*bdd1*f**2*s**2 + 33*D1**2*K*bdd1*f**2*s + 33*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s + 980*D1**2*f**3*fd*r*s - 245*D1**2*f**3*fd*r + 980*D1**2*f**3*fd*s**2 - 980*D1**2*f**3*fd*s + 245*D1**2*f**3*fd - 600*D1**2*f**3*fdd*r*s + 150*D1**2*f**3*fdd*r - 600*D1**2*f**3*fdd*s**2 + 600*D1**2*f**3*fdd*s - 150*D1**2*f**3*fdd - 1800*D1**2*f**2*fd**2*r*s + 450*D1**2*f**2*fd**2*r - 1800*D1**2*f**2*fd**2*s**2 + 1800*D1**2*f**2*fd**2*s - 300*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r*s + 44*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 132*D1**2*f**2*fd*s - 44*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r*s - 22*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 66*D1**2*f**2*fdd*s + 22*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s + 66*D1**2*f**2*gdd2*r*s + 66*D1**2*f**2*gdd2*s**2 - 66*D1**2*f**2*gdd2*s + 132*D1**2*f*fd**2*r*s - 44*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 132*D1**2*f*fd**2*s + 22*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r*s - 66*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 264*D1**2*f*fd*gd2*s + 66*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r*s - 66*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r*s - 66*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 980*D1*Dd*f**4*r*s - 245*D1*Dd*f**4*r + 980*D1*Dd*f**4*s**2 - 980*D1*Dd*f**4*s + 245*D1*Dd*f**4 - 4800*D1*Dd*f**3*fd*r*s + 1200*D1*Dd*f**3*fd*r - 4800*D1*Dd*f**3*fd*s**2 + 4800*D1*Dd*f**3*fd*s - 900*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 176*D1*Dd*f**3*s - 44*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r*s - 154*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 528*D1*Dd*f**2*fd*s + 110*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r*s + 132*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r*s - 66*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 528*D1*Dd*f**2*gd2*s + 66*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r*s - 396*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1056*D1*Dd*f*fd*g2*s + 264*D1*Dd*f*fd*g2 - 600*D1*Ddd*f**4*r*s + 150*D1*Ddd*f**4*r - 600*D1*Ddd*f**4*s**2 + 600*D1*Ddd*f**4*s - 150*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 88*D1*Ddd*f**3*s + 22*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r*s - 66*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 264*D1*Ddd*f**2*g2*s + 66*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 1800*Dd**2*f**4*r*s + 450*Dd**2*f**4*r - 1800*Dd**2*f**4*s**2 + 1800*Dd**2*f**4*s - 300*Dd**2*f**4 + 264*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 264*Dd**2*f**3*s + 44*Dd**2*f**3 + 792*Dd**2*f**2*g2*r*s - 198*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 792*Dd**2*f**2*g2*s + 132*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(385*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**2*k1**4*st**2*(36*C*D1**2*bdd1*f**2*r**2 + 288*C*D1**2*bdd1*f**2*r*s - 216*C*D1**2*bdd1*f**2*r + 252*C*D1**2*bdd1*f**2*s**2 - 432*C*D1**2*bdd1*f**2*s + 216*C*D1**2*bdd1*f**2 + 858*C*D1**2*f**2*fd*r**2 + 1740*C*D1**2*f**2*fd*r*s - 1152*C*D1**2*f**2*fd*r + 882*C*D1**2*f**2*fd*s**2 - 1168*C*D1**2*f**2*fd*s + 580*C*D1**2*f**2*fd - 726*C*D1**2*f**2*fdd*r**2 - 2004*C*D1**2*f**2*fdd*r*s + 1152*C*D1**2*f**2*fdd*r - 1278*C*D1**2*f**2*fdd*s**2 + 1520*C*D1**2*f**2*fdd*s - 668*C*D1**2*f**2*fdd - 1452*C*D1**2*f*fd**2*r**2 - 4008*C*D1**2*f*fd**2*r*s + 2304*C*D1**2*f*fd**2*r - 2556*C*D1**2*f*fd**2*s**2 + 3040*C*D1**2*f*fd**2*s - 668*C*D1**2*f*fd**2 + 1144*C*D1*Dd*f**3*r**2 + 2320*C*D1*Dd*f**3*r*s - 1724*C*D1*Dd*f**3*r + 1176*C*D1*Dd*f**3*s**2 - 1748*C*D1*Dd*f**3*s + 866*C*D1*Dd*f**3 - 5808*C*D1*Dd*f**2*fd*r**2 - 16032*C*D1*Dd*f**2*fd*r*s + 9516*C*D1*Dd*f**2*fd*r - 10224*C*D1*Dd*f**2*fd*s**2 + 12644*C*D1*Dd*f**2*fd*s - 3824*C*D1*Dd*f**2*fd - 968*C*D1*Ddd*f**3*r**2 - 2672*C*D1*Ddd*f**3*r*s + 1636*C*D1*Ddd*f**3*r - 1704*C*D1*Ddd*f**3*s**2 + 2188*C*D1*Ddd*f**3*s - 910*C*D1*Ddd*f**3 - 2904*C*Dd**2*f**3*r**2 - 8016*C*Dd**2*f**3*r*s + 4908*C*Dd**2*f**3*r - 5112*C*Dd**2*f**3*s**2 + 6564*C*Dd**2*f**3*s - 1820*C*Dd**2*f**3 - 213*D1**2*K*bdd1*f**2*r**2 - 678*D1**2*K*bdd1*f**2*r*s + 426*D1**2*K*bdd1*f**2*r - 465*D1**2*K*bdd1*f**2*s**2 + 678*D1**2*K*bdd1*f**2*s - 213*D1**2*K*bdd1*f**2 + 84*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(8*s - 4) + 7*s**2 - 10*s + 3) + 420*D1**2*bdd1*f**3*r**2 + 1080*D1**2*bdd1*f**3*r*s - 1200*D1**2*bdd1*f**3*r + 660*D1**2*bdd1*f**3*s**2 - 1440*D1**2*bdd1*f**3*s + 960*D1**2*bdd1*f**3 + 393*D1**2*bdd1*f**2*r**2 + 930*D1**2*bdd1*f**2*r*s - 642*D1**2*bdd1*f**2*r + 537*D1**2*bdd1*f**2*s**2 - 786*D1**2*bdd1*f**2*s + 213*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r**2 - 672*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 588*D1**2*bdd1*f*g2*s**2 + 1008*D1**2*bdd1*f*g2*s - 504*D1**2*bdd1*f*g2 + 3720*D1**2*f**3*fd*r**2 + 12720*D1**2*f**3*fd*r*s - 6900*D1**2*f**3*fd*r + 9000*D1**2*f**3*fd*s**2 - 10860*D1**2*f**3*fd*s + 4110*D1**2*f**3*fd - 4440*D1**2*f**3*fdd*r**2 - 11280*D1**2*f**3*fdd*r*s + 7260*D1**2*f**3*fdd*r - 6840*D1**2*f**3*fdd*s**2 + 9060*D1**2*f**3*fdd*s - 3930*D1**2*f**3*fdd - 13320*D1**2*f**2*fd**2*r**2 - 33840*D1**2*f**2*fd**2*r*s + 21780*D1**2*f**2*fd**2*r - 20520*D1**2*f**2*fd**2*s**2 + 27180*D1**2*f**2*fd**2*s - 7860*D1**2*f**2*fd**2 - 1146*D1**2*f**2*fd*r**2 - 2568*D1**2*f**2*fd*r*s + 1620*D1**2*f**2*fd*r - 1422*D1**2*f**2*fd*s**2 + 1804*D1**2*f**2*fd*s - 856*D1**2*f**2*fd + 1086*D1**2*f**2*fdd*r**2 + 2904*D1**2*f**2*fdd*r*s - 1692*D1**2*f**2*fdd*r + 1818*D1**2*f**2*fdd*s**2 - 2180*D1**2*f**2*fdd*s + 968*D1**2*f**2*fdd - 390*D1**2*f**2*gd2*r**2 - 948*D1**2*f**2*gd2*r*s + 780*D1**2*f**2*gd2*r - 558*D1**2*f**2*gd2*s**2 + 948*D1**2*f**2*gd2*s - 390*D1**2*f**2*gd2 + 426*D1**2*f**2*gdd2*r**2 + 1356*D1**2*f**2*gdd2*r*s - 852*D1**2*f**2*gdd2*r + 930*D1**2*f**2*gdd2*s**2 - 1356*D1**2*f**2*gdd2*s + 426*D1**2*f**2*gdd2 + 2172*D1**2*f*fd**2*r**2 + 5808*D1**2*f*fd**2*r*s - 3384*D1**2*f*fd**2*r + 3636*D1**2*f*fd**2*s**2 - 4360*D1**2*f*fd**2*s + 968*D1**2*f*fd**2 - 780*D1**2*f*fd*g2*r**2 - 1896*D1**2*f*fd*g2*r*s + 948*D1**2*f*fd*g2*r - 1116*D1**2*f*fd*g2*s**2 + 1116*D1**2*f*fd*g2*s - 558*D1**2*f*fd*g2 + 1704*D1**2*f*fd*gd2*r**2 + 5424*D1**2*f*fd*gd2*r*s - 3060*D1**2*f*fd*gd2*r + 3720*D1**2*f*fd*gd2*s**2 - 4572*D1**2*f*fd*gd2*s + 1356*D1**2*f*fd*gd2 + 852*D1**2*f*fdd*g2*r**2 + 2712*D1**2*f*fdd*g2*r*s - 1356*D1**2*f*fdd*g2*r + 1860*D1**2*f*fdd*g2*s**2 - 1860*D1**2*f*fdd*g2*s + 930*D1**2*f*fdd*g2 + 852*D1**2*fd**2*g2*r**2 + 2712*D1**2*fd**2*g2*r*s - 1356*D1**2*fd**2*g2*r + 1860*D1**2*fd**2*g2*s**2 - 1860*D1**2*fd**2*g2*s + 3720*D1*Dd*f**4*r**2 + 12720*D1*Dd*f**4*r*s - 6900*D1*Dd*f**4*r + 9000*D1*Dd*f**4*s**2 - 10860*D1*Dd*f**4*s + 4110*D1*Dd*f**4 - 35520*D1*Dd*f**3*fd*r**2 - 90240*D1*Dd*f**3*fd*r*s + 58080*D1*Dd*f**3*fd*r - 54720*D1*Dd*f**3*fd*s**2 + 72480*D1*Dd*f**3*fd*s - 23580*D1*Dd*f**3*fd - 1528*D1*Dd*f**3*r**2 - 3424*D1*Dd*f**3*r*s + 2384*D1*Dd*f**3*r - 1896*D1*Dd*f**3*s**2 + 2660*D1*Dd*f**3*s - 1238*D1*Dd*f**3 + 8688*D1*Dd*f**2*fd*r**2 + 23232*D1*Dd*f**2*fd*r*s - 14016*D1*Dd*f**2*fd*r + 14544*D1*Dd*f**2*fd*s**2 - 18164*D1*Dd*f**2*fd*s + 5564*D1*Dd*f**2*fd - 1560*D1*Dd*f**2*g2*r**2 - 3792*D1*Dd*f**2*g2*r*s + 2508*D1*Dd*f**2*g2*r - 2232*D1*Dd*f**2*g2*s**2 + 3012*D1*Dd*f**2*g2*s - 1338*D1*Dd*f**2*g2 + 3408*D1*Dd*f**2*gd2*r**2 + 10848*D1*Dd*f**2*gd2*r*s - 6468*D1*Dd*f**2*gd2*r + 7440*D1*Dd*f**2*gd2*s**2 - 9996*D1*Dd*f**2*gd2*s + 3060*D1*Dd*f**2*gd2 + 6816*D1*Dd*f*fd*g2*r**2 + 21696*D1*Dd*f*fd*g2*r*s - 11544*D1*Dd*f*fd*g2*r + 14880*D1*Dd*f*fd*g2*s**2 - 16584*D1*Dd*f*fd*g2*s + 4572*D1*Dd*f*fd*g2 - 4440*D1*Ddd*f**4*r**2 - 11280*D1*Ddd*f**4*r*s + 7260*D1*Ddd*f**4*r - 6840*D1*Ddd*f**4*s**2 + 9060*D1*Ddd*f**4*s - 3930*D1*Ddd*f**4 + 1448*D1*Ddd*f**3*r**2 + 3872*D1*Ddd*f**3*r*s - 2416*D1*Ddd*f**3*r + 2424*D1*Ddd*f**3*s**2 - 3148*D1*Ddd*f**3*s + 1330*D1*Ddd*f**3 + 1704*D1*Ddd*f**2*g2*r**2 + 5424*D1*Ddd*f**2*g2*r*s - 3060*D1*Ddd*f**2*g2*r + 3720*D1*Ddd*f**2*g2*s**2 - 4572*D1*Ddd*f**2*g2*s + 1782*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(4*f**3*(25*r**2 + r*(90*s - 119) + 65*s**2 - 159*s + 106) - f**2*(4*C*(r**2 + r*(36 - 34*s) - 35*s**2 + 72*s - 36) + 65*K*r**2 + 158*K*r*s - 130*K*r + 93*K*s**2 - 158*K*s + 65*K + 40*fd*(21*r**2 + 54*r*s - 43*r + 33*s**2 - 53*s + 16) - 101*r**2 - 130*r*s + 50*r - 29*s**2 - 22*s + 47) - 2*f*fd*(12*C*(2*r**2 + 8*r*(2*s - 1) + 14*s**2 - 17*s + 3) - K*(142*r**2 + 452*r*s - 255*r + 310*s**2 - 381*s + 113) + 262*r**2 + 620*r*s - 393*r + 358*s**2 - 465*s + 167) + 28*f*(3*g2*(r**2 - 2*r*(s - 2) - 3*s**2 + 8*s - 4) + 2*gd2*(r**2 + r*(8*s - 4) + 7*s**2 - 10*s + 3)) + 56*fd*g2*(r**2 + r*(8*s - 4) + s*(7*s - 7))) - 2*Dd*f*(20*f**2*(28*r**2 + 9*r*(8*s - 7) + 44*s**2 - 77*s + 32) + f*(12*C*(4*r**2 + 2*r*(16*s - 9) + 28*s**2 - 39*s + 12) - K*(284*r**2 + 904*r*s - 539*r + 620*s**2 - 833*s + 255) + 524*r**2 + 1240*r*s - 845*r + 716*s**2 - 1013*s + 345) - 28*g2*(4*r**2 + 2*r*(16*s - 9) + 28*s**2 - 39*s + 12))) - 13320*Dd**2*f**4*r**2 - 33840*Dd**2*f**4*r*s + 21780*Dd**2*f**4*r - 20520*Dd**2*f**4*s**2 + 27180*Dd**2*f**4*s - 7860*Dd**2*f**4 + 4344*Dd**2*f**3*r**2 + 11616*Dd**2*f**3*r*s - 7248*Dd**2*f**3*r + 7272*Dd**2*f**3*s**2 - 9444*Dd**2*f**3*s + 2660*Dd**2*f**3 + 5112*Dd**2*f**2*g2*r**2 + 16272*Dd**2*f**2*g2*r*s - 9180*Dd**2*f**2*g2*r + 11160*Dd**2*f**2*g2*s**2 - 13716*Dd**2*f**2*g2*s + 3564*Dd**2*f**2*g2 + 42*b1**2*(K - 1)*(D1**2*(3*fd*(r**2 - 2*r*(s + 1) - 3*s**2 - 2*s + 1) + fdd*(r**2 + r*(8*s - 2) + 7*s**2 - 2*s + 1)) + D1*(Dd*(3*f*(4*r**2 - 8*r*s - 2*r - 12*s**2 + 10*s - 1) + 2*fd*(4*r**2 + 32*r*s - 10*r + 28*s**2 - 19*s + 3)) + Ddd*f*(4*r**2 + 4*r*(8*s - 3) + 28*s**2 - 30*s + 9)) + 6*Dd**2*f*(2*r**2 + 2*r*(8*s - 3) + 14*s**2 - 15*s + 3)) + 3*b1*(8*C*D1**2*f*fd*r**2 - 272*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r - 280*C*D1**2*f*fd*s**2 + 128*C*D1**2*f*fd*s + 8*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 192*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 168*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 192*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 168*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s + 24*C*D1**2*fd**2 + 16*C*D1*Dd*f**2*r**2 - 544*C*D1*Dd*f**2*r*s + 120*C*D1*Dd*f**2*r - 560*C*D1*Dd*f**2*s**2 + 552*C*D1*Dd*f**2*s - 132*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 1536*C*D1*Dd*f*fd*r*s - 480*C*D1*Dd*f*fd*r + 1344*C*D1*Dd*f*fd*s**2 - 1200*C*D1*Dd*f*fd*s + 216*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 384*C*D1*Ddd*f**2*r*s - 144*C*D1*Ddd*f**2*r + 336*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 108*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 1152*C*Dd**2*f**2*r*s - 432*C*Dd**2*f**2*r + 1008*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 + 130*D1**2*K*f*fd*r**2 + 316*D1**2*K*f*fd*r*s - 158*D1**2*K*f*fd*r + 186*D1**2*K*f*fd*s**2 - 186*D1**2*K*f*fd*s + 93*D1**2*K*f*fd - 142*D1**2*K*f*fdd*r**2 - 452*D1**2*K*f*fdd*r*s + 226*D1**2*K*f*fdd*r - 310*D1**2*K*f*fdd*s**2 + 310*D1**2*K*f*fdd*s - 155*D1**2*K*f*fdd - 142*D1**2*K*fd**2*r**2 - 452*D1**2*K*fd**2*r*s + 226*D1**2*K*fd**2*r - 310*D1**2*K*fd**2*s**2 + 310*D1**2*K*fd**2*s + 14*D1**2*bdd1*f*(K - 1)*(2*r**2 + 16*r*s - 8*r + 14*s**2 - 20*s + 7) - 300*D1**2*f**2*fd*r**2 - 1080*D1**2*f**2*fd*r*s + 284*D1**2*f**2*fd*r - 780*D1**2*f**2*fd*s**2 + 604*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 1080*D1**2*f**2*fdd*r*s - 520*D1**2*f**2*fdd*r + 660*D1**2*f**2*fdd*s**2 - 680*D1**2*f**2*fdd*s + 180*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 2160*D1**2*f*fd**2*r*s - 1040*D1**2*f*fd**2*r + 1320*D1**2*f*fd**2*s**2 - 1360*D1**2*f*fd**2*s + 360*D1**2*f*fd**2 - 202*D1**2*f*fd*r**2 - 260*D1**2*f*fd*r*s + 282*D1**2*f*fd*r - 58*D1**2*f*fd*s**2 + 210*D1**2*f*fd*s - 177*D1**2*f*fd + 262*D1**2*f*fdd*r**2 + 620*D1**2*f*fdd*r*s - 358*D1**2*f*fdd*r + 358*D1**2*f*fdd*s**2 - 406*D1**2*f*fdd*s + 239*D1**2*f*fdd - 84*D1**2*f*gd2*r**2 + 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*r + 252*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s - 84*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 224*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 196*D1**2*f*gdd2*s**2 + 224*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 + 262*D1**2*fd**2*r**2 + 620*D1**2*fd**2*r*s - 358*D1**2*fd**2*r + 358*D1**2*fd**2*s**2 - 406*D1**2*fd**2*s - 24*D1**2*fd**2 - 84*D1**2*fd*g2*r**2 + 168*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*r + 252*D1**2*fd*g2*s**2 + 168*D1**2*fd*g2*s - 84*D1**2*fd*g2 - 56*D1**2*fd*gd2*r**2 - 448*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 392*D1**2*fd*gd2*s**2 + 280*D1**2*fd*gd2*s - 56*D1**2*fd*gd2 - 28*D1**2*fdd*g2*r**2 - 224*D1**2*fdd*g2*r*s + 56*D1**2*fdd*g2*r - 196*D1**2*fdd*g2*s**2 + 56*D1**2*fdd*g2*s - 28*D1**2*fdd*g2 + 260*D1*Dd*K*f**2*r**2 + 632*D1*Dd*K*f**2*r*s - 418*D1*Dd*K*f**2*r + 372*D1*Dd*K*f**2*s**2 - 502*D1*Dd*K*f**2*s + 223*D1*Dd*K*f**2 - 1136*D1*Dd*K*f*fd*r**2 - 3616*D1*Dd*K*f*fd*r*s + 1924*D1*Dd*K*f*fd*r - 2480*D1*Dd*K*f*fd*s**2 + 2764*D1*Dd*K*f*fd*s - 762*D1*Dd*K*f*fd - 400*D1*Dd*f**3*r**2 - 1440*D1*Dd*f**3*r*s + 760*D1*Dd*f**3*r - 1040*D1*Dd*f**3*s**2 + 1240*D1*Dd*f**3*s - 460*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 8640*D1*Dd*f**2*fd*r*s - 4840*D1*Dd*f**2*fd*r + 5280*D1*Dd*f**2*fd*s**2 - 6200*D1*Dd*f**2*fd*s + 1720*D1*Dd*f**2*fd - 404*D1*Dd*f**2*r**2 - 520*D1*Dd*f**2*r*s + 534*D1*Dd*f**2*r - 116*D1*Dd*f**2*s**2 + 318*D1*Dd*f**2*s - 231*D1*Dd*f**2 + 2096*D1*Dd*f*fd*r**2 + 4960*D1*Dd*f*fd*r*s - 3100*D1*Dd*f*fd*r + 2864*D1*Dd*f*fd*s**2 - 3580*D1*Dd*f*fd*s + 1122*D1*Dd*f*fd - 336*D1*Dd*f*g2*r**2 + 672*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r + 1008*D1*Dd*f*g2*s**2 - 840*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 1792*D1*Dd*f*gd2*r*s + 560*D1*Dd*f*gd2*r - 1568*D1*Dd*f*gd2*s**2 + 1736*D1*Dd*f*gd2*s - 336*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 1792*D1*Dd*fd*g2*r*s + 560*D1*Dd*fd*g2*r - 1568*D1*Dd*fd*g2*s**2 + 1064*D1*Dd*fd*g2*s - 168*D1*Dd*fd*g2 - 284*D1*Ddd*K*f**2*r**2 - 904*D1*Ddd*K*f**2*r*s + 510*D1*Ddd*K*f**2*r - 620*D1*Ddd*K*f**2*s**2 + 762*D1*Ddd*K*f**2*s - 297*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 + 1440*D1*Ddd*f**3*r*s - 920*D1*Ddd*f**3*r + 880*D1*Ddd*f**3*s**2 - 1160*D1*Ddd*f**3*s + 500*D1*Ddd*f**3 + 524*D1*Ddd*f**2*r**2 + 1240*D1*Ddd*f**2*r*s - 834*D1*Ddd*f**2*r + 716*D1*Ddd*f**2*s**2 - 978*D1*Ddd*f**2*s + 441*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 896*D1*Ddd*f*g2*r*s + 336*D1*Ddd*f*g2*r - 784*D1*Ddd*f*g2*s**2 + 840*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 14*D1*bd1*(K - 1)*(D1*(3*f*(2*r**2 - 4*r*s + 2*r - 6*s**2 + 10*s - 3) + 2*fd*(2*r**2 + 16*r*s - 6*r + 14*s**2 - 12*s + 1)) + 4*Dd*f*(4*r**2 + 2*r*(16*s - 7) + 28*s**2 - 35*s + 9)) - 852*Dd**2*K*f**2*r**2 - 2712*Dd**2*K*f**2*r*s + 1530*Dd**2*K*f**2*r - 1860*Dd**2*K*f**2*s**2 + 2286*Dd**2*K*f**2*s - 594*Dd**2*K*f**2 + 1680*Dd**2*f**3*r**2 + 4320*Dd**2*f**3*r*s - 2760*Dd**2*f**3*r + 2640*Dd**2*f**3*s**2 - 3480*Dd**2*f**3*s + 1000*Dd**2*f**3 + 1572*Dd**2*f**2*r**2 + 3720*Dd**2*f**2*r*s - 2502*Dd**2*f**2*r + 2148*Dd**2*f**2*s**2 - 2934*Dd**2*f**2*s + 882*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 2688*Dd**2*f*g2*r*s + 1008*Dd**2*f*g2*r - 2352*Dd**2*f*g2*s**2 + 2520*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(315*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**2*k1**4*(-1134*C*D1**2*bdd1*f**2*r**2 - 2844*C*D1**2*bdd1*f**2*r*s + 2844*C*D1**2*bdd1*f**2*r - 1710*C*D1**2*bdd1*f**2*s**2 + 3420*C*D1**2*bdd1*f**2*s - 1710*C*D1**2*bdd1*f**2 + 300*C*D1**2*f**2*fd*r**2 + 3360*C*D1**2*f**2*fd*r*s - 1320*C*D1**2*f**2*fd*r + 3060*C*D1**2*f**2*fd*s**2 - 3160*C*D1**2*f**2*fd*s + 1120*C*D1**2*f**2*fd - 420*C*D1**2*f**2*fdd*r**2 - 3840*C*D1**2*f**2*fdd*r*s + 1560*C*D1**2*f**2*fdd*r - 3420*C*D1**2*f**2*fdd*s**2 + 3560*C*D1**2*f**2*fdd*s - 1280*C*D1**2*f**2*fdd - 840*C*D1**2*f*fd**2*r**2 - 7680*C*D1**2*f*fd**2*r*s + 3120*C*D1**2*f*fd**2*r - 6840*C*D1**2*f*fd**2*s**2 + 7120*C*D1**2*f*fd**2*s - 1280*C*D1**2*f*fd**2 + 400*C*D1*Dd*f**3*r**2 + 4480*C*D1*Dd*f**3*r*s - 1520*C*D1*Dd*f**3*r + 4080*C*D1*Dd*f**3*s**2 - 4280*C*D1*Dd*f**3*s + 1220*C*D1*Dd*f**3 - 3360*C*D1*Dd*f**2*fd*r**2 - 30720*C*D1*Dd*f**2*fd*r*s + 11760*C*D1*Dd*f**2*fd*r - 27360*C*D1*Dd*f**2*fd*s**2 + 28760*C*D1*Dd*f**2*fd*s - 6680*C*D1*Dd*f**2*fd - 560*C*D1*Ddd*f**3*r**2 - 5120*C*D1*Ddd*f**3*r*s + 1840*C*D1*Ddd*f**3*r - 4560*C*D1*Ddd*f**3*s**2 + 4840*C*D1*Ddd*f**3*s - 1420*C*D1*Ddd*f**3 - 1680*C*Dd**2*f**3*r**2 - 15360*C*Dd**2*f**3*r*s + 5520*C*Dd**2*f**3*r - 13680*C*Dd**2*f**3*s**2 + 14520*C*Dd**2*f**3*s - 2840*C*Dd**2*f**3 - 90*D1**2*K*bdd1*f**2*r**2 - 864*D1**2*K*bdd1*f**2*r*s + 180*D1**2*K*bdd1*f**2*r - 774*D1**2*K*bdd1*f**2*s**2 + 864*D1**2*K*bdd1*f**2*s - 90*D1**2*K*bdd1*f**2 + 108*D1**2*b2*f*fd*r**2 + 216*D1**2*b2*f*fd*r*s - 108*D1**2*b2*f*fd*r + 108*D1**2*b2*f*fd*s**2 - 108*D1**2*b2*f*fd*s + 54*D1**2*b2*f*fd - 180*D1**2*b2*f*fdd*r**2 - 360*D1**2*b2*f*fdd*r*s + 180*D1**2*b2*f*fdd*r - 180*D1**2*b2*f*fdd*s**2 + 180*D1**2*b2*f*fdd*s - 90*D1**2*b2*f*fdd - 180*D1**2*b2*fd**2*r**2 - 360*D1**2*b2*fd**2*r*s + 180*D1**2*b2*fd**2*r - 180*D1**2*b2*fd**2*s**2 + 180*D1**2*b2*fd**2*s + 6*D1**2*bd1**2*(r + s - 1)*(60*f**2*(3*r + 3*s - 2) + 7*f*(12*C*r + 12*C*s + K*(-37*r - 61*s + 49) + 49*r + 73*s - 73) - 140*g2*(r + s)) - 1260*D1**2*bdd1*f**3*r**2 - 1710*D1**2*bdd1*f**3*r*s + 2340*D1**2*bdd1*f**3*r - 450*D1**2*bdd1*f**3*s**2 + 1530*D1**2*bdd1*f**3*s - 1080*D1**2*bdd1*f**3 + 1494*D1**2*bdd1*f**2*r**2 + 3906*D1**2*bdd1*f**2*r*s - 3564*D1**2*bdd1*f**2*r + 2412*D1**2*bdd1*f**2*s**2 - 4482*D1**2*bdd1*f**2*s + 2070*D1**2*bdd1*f**2 + 1554*D1**2*bdd1*f*g2*r**2 + 4116*D1**2*bdd1*f*g2*r*s - 4116*D1**2*bdd1*f*g2*r + 2562*D1**2*bdd1*f*g2*s**2 - 5124*D1**2*bdd1*f*g2*s + 2562*D1**2*bdd1*f*g2 - 90*D1**2*bdd2*f**2*r**2 - 180*D1**2*bdd2*f**2*r*s + 180*D1**2*bdd2*f**2*r - 90*D1**2*bdd2*f**2*s**2 + 180*D1**2*bdd2*f**2*s - 90*D1**2*bdd2*f**2 - 150*D1**2*f**2*fd*r**2 - 2370*D1**2*f**2*fd*r*s + 890*D1**2*f**2*fd*r - 2220*D1**2*f**2*fd*s**2 + 2270*D1**2*f**2*fd*s - 790*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r**2 + 2670*D1**2*f**2*fdd*r*s - 1030*D1**2*f**2*fdd*r + 2460*D1**2*f**2*fdd*s**2 - 2530*D1**2*f**2*fdd*s + 890*D1**2*f**2*fdd - 108*D1**2*f**2*gd2*r**2 - 1440*D1**2*f**2*gd2*r*s + 216*D1**2*f**2*gd2*r - 1332*D1**2*f**2*gd2*s**2 + 1440*D1**2*f**2*gd2*s - 108*D1**2*f**2*gd2 + 180*D1**2*f**2*gdd2*r**2 + 1728*D1**2*f**2*gdd2*r*s - 360*D1**2*f**2*gdd2*r + 1548*D1**2*f**2*gdd2*s**2 - 1728*D1**2*f**2*gdd2*s + 180*D1**2*f**2*gdd2 + 420*D1**2*f*fd**2*r**2 + 5340*D1**2*f*fd**2*r*s - 2060*D1**2*f*fd**2*r + 4920*D1**2*f*fd**2*s**2 - 5060*D1**2*f*fd**2*s + 890*D1**2*f*fd**2 - 216*D1**2*f*fd*g2*r**2 - 2880*D1**2*f*fd*g2*r*s + 1440*D1**2*f*fd*g2*r - 2664*D1**2*f*fd*g2*s**2 + 2664*D1**2*f*fd*g2*s - 1332*D1**2*f*fd*g2 + 720*D1**2*f*fd*gd2*r**2 + 6912*D1**2*f*fd*gd2*r*s - 2448*D1**2*f*fd*gd2*r + 6192*D1**2*f*fd*gd2*s**2 - 6552*D1**2*f*fd*gd2*s + 1728*D1**2*f*fd*gd2 + 360*D1**2*f*fdd*g2*r**2 + 3456*D1**2*f*fdd*g2*r*s - 1728*D1**2*f*fdd*g2*r + 3096*D1**2*f*fdd*g2*s**2 - 3096*D1**2*f*fdd*g2*s + 1548*D1**2*f*fdd*g2 + 360*D1**2*fd**2*g2*r**2 + 3456*D1**2*fd**2*g2*r*s - 1728*D1**2*fd**2*g2*r + 3096*D1**2*fd**2*g2*s**2 - 3096*D1**2*fd**2*g2*s + 216*D1*Dd*b2*f**2*r**2 + 432*D1*Dd*b2*f**2*r*s - 324*D1*Dd*b2*f**2*r + 216*D1*Dd*b2*f**2*s**2 - 324*D1*Dd*b2*f**2*s + 162*D1*Dd*b2*f**2 - 1440*D1*Dd*b2*f*fd*r**2 - 2880*D1*Dd*b2*f*fd*r*s + 1800*D1*Dd*b2*f*fd*r - 1440*D1*Dd*b2*f*fd*s**2 + 1800*D1*Dd*b2*f*fd*s - 540*D1*Dd*b2*f*fd - 200*D1*Dd*f**3*r**2 - 3160*D1*Dd*f**3*r*s + 990*D1*Dd*f**3*r - 2960*D1*Dd*f**3*s**2 + 3060*D1*Dd*f**3*s - 840*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r**2 + 21360*D1*Dd*f**2*fd*r*s - 7630*D1*Dd*f**2*fd*r + 19680*D1*Dd*f**2*fd*s**2 - 20380*D1*Dd*f**2*fd*s + 4590*D1*Dd*f**2*fd - 432*D1*Dd*f**2*g2*r**2 - 5760*D1*Dd*f**2*g2*r*s + 1872*D1*Dd*f**2*g2*r - 5328*D1*Dd*f**2*g2*s**2 + 5544*D1*Dd*f**2*g2*s - 1548*D1*Dd*f**2*g2 + 1440*D1*Dd*f**2*gd2*r**2 + 13824*D1*Dd*f**2*gd2*r*s - 3888*D1*Dd*f**2*gd2*r + 12384*D1*Dd*f**2*gd2*s**2 - 13464*D1*Dd*f**2*gd2*s + 2448*D1*Dd*f**2*gd2 + 2880*D1*Dd*f*fd*g2*r**2 + 27648*D1*Dd*f*fd*g2*r*s - 11808*D1*Dd*f*fd*g2*r + 24768*D1*Dd*f*fd*g2*s**2 - 25488*D1*Dd*f*fd*g2*s + 6552*D1*Dd*f*fd*g2 - 360*D1*Ddd*b2*f**2*r**2 - 720*D1*Ddd*b2*f**2*r*s + 540*D1*Ddd*b2*f**2*r - 360*D1*Ddd*b2*f**2*s**2 + 540*D1*Ddd*b2*f**2*s - 270*D1*Ddd*b2*f**2 + 280*D1*Ddd*f**3*r**2 + 3560*D1*Ddd*f**3*r*s - 1170*D1*Ddd*f**3*r + 3280*D1*Ddd*f**3*s**2 - 3420*D1*Ddd*f**3*s + 960*D1*Ddd*f**3 + 720*D1*Ddd*f**2*g2*r**2 + 6912*D1*Ddd*f**2*g2*r*s - 2448*D1*Ddd*f**2*g2*r + 6192*D1*Ddd*f**2*g2*s**2 - 6552*D1*Ddd*f**2*g2*s + 1908*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(15*f**3*(12*r**2 + r*(19*s - 28) + 7*s**2 - 23*s + 16) + 3*f**2*(C*(49*r**2 + 134*r*(s - 1) + 85*(s - 1)**2) - 5*fd*(84*r**2 + r*(114*s - 127) + 30*s**2 - 82*s + 45) + (r + s - 1)*(K*(3*r + 37*s - 3) - 61*r - 114*s + 97)) - f*(3*fd*(2*C*(126*r**2 + r*(316*s - 221) + 190*s**2 - 269*s + 79) + 2*K*(10*r**2 + 96*r*s - 34*r + 86*s**2 - 91*s + 24) - 332*r**2 - 868*r*s + 581*r - 536*s**2 + 734*s - 217) + (7*r + 7*s - 7)*(19*g2*r + 47*g2*(s - 1) - 2*gd2*(37*r + 61*s - 49))) + 14*fd*g2*(37*r**2 + 49*r*(2*s - 1) + s*(61*s - 61))) - Dd*f*(15*f**2*(112*r**2 + r*(152*s - 179) + 40*s**2 - 116*s + 69) + 3*f*(2*C*(252*r**2 + r*(632*s - 521) + 380*s**2 - 633*s + 253) + 2*K*(20*r**2 + 6*r*(32*s - 9) + 172*s**2 - 187*s + 34) - 664*r**2 - 1736*r*s + 1341*r - 1072*s**2 + 1698*s - 645) - 14*g2*(148*r**2 + r*(392*s - 319) + 244*s**2 - 403*s + 159))) + 18*D1*bd2*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 1080*Dd**2*b2*f**2*r**2 - 2160*Dd**2*b2*f**2*r*s + 1620*Dd**2*b2*f**2*r - 1080*Dd**2*b2*f**2*s**2 + 1620*Dd**2*b2*f**2*s - 540*Dd**2*b2*f**2 + 840*Dd**2*f**3*r**2 + 10680*Dd**2*f**3*r*s - 3510*Dd**2*f**3*r + 9840*Dd**2*f**3*s**2 - 10260*Dd**2*f**3*s + 1920*Dd**2*f**3 + 2160*Dd**2*f**2*g2*r**2 + 20736*Dd**2*f**2*g2*r*s - 7344*Dd**2*f**2*g2*r + 18576*Dd**2*f**2*g2*s**2 - 19656*Dd**2*f**2*g2*s + 3816*Dd**2*f**2*g2 + 210*b1**3*(K - 1)*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(-28*C*D1**2*fd*r**2 - 56*C*D1**2*fd*r*s + 56*C*D1**2*fd*r - 28*C*D1**2*fd*s**2 + 56*C*D1**2*fd*s - 28*C*D1**2*fd + 84*C*D1**2*fdd*r**2 + 168*C*D1**2*fdd*r*s - 168*C*D1**2*fdd*r + 84*C*D1**2*fdd*s**2 - 168*C*D1**2*fdd*s + 84*C*D1**2*fdd - 112*C*D1*Dd*f*r**2 - 224*C*D1*Dd*f*r*s + 168*C*D1*Dd*f*r - 112*C*D1*Dd*f*s**2 + 168*C*D1*Dd*f*s - 84*C*D1*Dd*f + 672*C*D1*Dd*fd*r**2 + 1344*C*D1*Dd*fd*r*s - 1176*C*D1*Dd*fd*r + 672*C*D1*Dd*fd*s**2 - 1176*C*D1*Dd*fd*s + 504*C*D1*Dd*fd + 336*C*D1*Ddd*f*r**2 + 672*C*D1*Ddd*f*r*s - 504*C*D1*Ddd*f*r + 336*C*D1*Ddd*f*s**2 - 504*C*D1*Ddd*f*s + 252*C*D1*Ddd*f + 1008*C*Dd**2*f*r**2 + 2016*C*Dd**2*f*r*s - 1512*C*Dd**2*f*r + 1008*C*Dd**2*f*s**2 - 1512*C*Dd**2*f*s + 504*C*Dd**2*f + 133*D1**2*K*fd*r**2 + 462*D1**2*K*fd*r*s + 329*D1**2*K*fd*s**2 - 259*D1**2*K*fdd*r**2 - 686*D1**2*K*fdd*r*s - 427*D1**2*K*fdd*s**2 + 70*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 216*D1**2*f*fd*r**2 - 432*D1**2*f*fd*r*s + 288*D1**2*f*fd*r - 216*D1**2*f*fd*s**2 + 288*D1**2*f*fd*s - 144*D1**2*f*fd + 360*D1**2*f*fdd*r**2 + 720*D1**2*f*fdd*r*s - 480*D1**2*f*fdd*r + 360*D1**2*f*fdd*s**2 - 480*D1**2*f*fdd*s + 240*D1**2*f*fdd + 360*D1**2*fd**2*r**2 + 720*D1**2*fd**2*r*s - 480*D1**2*fd**2*r + 360*D1**2*fd**2*s**2 - 480*D1**2*fd**2*s + 120*D1**2*fd**2 - 161*D1**2*fd*r**2 - 518*D1**2*fd*r*s - 56*D1**2*fd*r - 357*D1**2*fd*s**2 - 56*D1**2*fd*s + 28*D1**2*fd + 343*D1**2*fdd*r**2 + 854*D1**2*fdd*r*s + 168*D1**2*fdd*r + 511*D1**2*fdd*s**2 + 168*D1**2*fdd*s - 84*D1**2*fdd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 + 532*D1*Dd*K*f*r**2 + 1848*D1*Dd*K*f*r*s - 994*D1*Dd*K*f*r + 1316*D1*Dd*K*f*s**2 - 1582*D1*Dd*K*f*s + 595*D1*Dd*K*f - 2072*D1*Dd*K*fd*r**2 - 5488*D1*Dd*K*fd*r*s + 1722*D1*Dd*K*fd*r - 3416*D1*Dd*K*fd*s**2 + 2226*D1*Dd*K*fd*s - 432*D1*Dd*f**2*r**2 - 864*D1*Dd*f**2*r*s + 648*D1*Dd*f**2*r - 432*D1*Dd*f**2*s**2 + 648*D1*Dd*f**2*s - 324*D1*Dd*f**2 + 2880*D1*Dd*f*fd*r**2 + 5760*D1*Dd*f*fd*r*s - 4080*D1*Dd*f*fd*r + 2880*D1*Dd*f*fd*s**2 - 4080*D1*Dd*f*fd*s + 1440*D1*Dd*f*fd - 644*D1*Dd*f*r**2 - 2072*D1*Dd*f*r*s + 1162*D1*Dd*f*r - 1428*D1*Dd*f*s**2 + 1750*D1*Dd*f*s - 679*D1*Dd*f + 2744*D1*Dd*fd*r**2 + 6832*D1*Dd*fd*r*s - 1554*D1*Dd*fd*r + 4088*D1*Dd*fd*s**2 - 2058*D1*Dd*fd*s - 504*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 - 1036*D1*Ddd*K*f*r**2 - 2744*D1*Ddd*K*f*r*s + 1722*D1*Ddd*K*f*r - 1708*D1*Ddd*K*f*s**2 + 2226*D1*Ddd*K*f*s - 945*D1*Ddd*K*f + 720*D1*Ddd*f**2*r**2 + 1440*D1*Ddd*f**2*r*s - 1080*D1*Ddd*f**2*r + 720*D1*Ddd*f**2*s**2 - 1080*D1*Ddd*f**2*s + 540*D1*Ddd*f**2 + 1372*D1*Ddd*f*r**2 + 3416*D1*Ddd*f*r*s - 2226*D1*Ddd*f*r + 2044*D1*Ddd*f*s**2 - 2730*D1*Ddd*f*s + 1197*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 + 70*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 3108*Dd**2*K*f*r**2 - 8232*Dd**2*K*f*r*s + 5166*Dd**2*K*f*r - 5124*Dd**2*K*f*s**2 + 6678*Dd**2*K*f*s - 1890*Dd**2*K*f + 2160*Dd**2*f**2*r**2 + 4320*Dd**2*f**2*r*s - 3240*Dd**2*f**2*r + 2160*Dd**2*f**2*s**2 - 3240*Dd**2*f**2*s + 1080*Dd**2*f**2 + 4116*Dd**2*f*r**2 + 10248*Dd**2*f*r*s - 6678*Dd**2*f*r + 6132*Dd**2*f*s**2 - 8190*Dd**2*f*s + 2394*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) + 6*b1*(294*C*D1**2*f*fd*r**2 + 804*C*D1**2*f*fd*r*s - 294*C*D1**2*f*fd*r + 510*C*D1**2*f*fd*s**2 - 402*C*D1**2*f*fd*s + 147*C*D1**2*f*fd - 378*C*D1**2*f*fdd*r**2 - 948*C*D1**2*f*fdd*r*s + 378*C*D1**2*f*fdd*r - 570*C*D1**2*f*fdd*s**2 + 474*C*D1**2*f*fdd*s - 189*C*D1**2*f*fdd - 378*C*D1**2*fd**2*r**2 - 948*C*D1**2*fd**2*r*s + 378*C*D1**2*fd**2*r - 570*C*D1**2*fd**2*s**2 + 474*C*D1**2*fd**2*s + 588*C*D1*Dd*f**2*r**2 + 1608*C*D1*Dd*f**2*r*s - 990*C*D1*Dd*f**2*r + 1020*C*D1*Dd*f**2*s**2 - 1314*C*D1*Dd*f**2*s + 549*C*D1*Dd*f**2 - 3024*C*D1*Dd*f*fd*r**2 - 7584*C*D1*Dd*f*fd*r*s + 3972*C*D1*Dd*f*fd*r - 4560*C*D1*Dd*f*fd*s**2 + 4932*C*D1*Dd*f*fd*s - 1230*C*D1*Dd*f*fd - 756*C*D1*Ddd*f**2*r**2 - 1896*C*D1*Ddd*f**2*r*s + 1230*C*D1*Ddd*f**2*r - 1140*C*D1*Ddd*f**2*s**2 + 1518*C*D1*Ddd*f**2*s - 663*C*D1*Ddd*f**2 - 2268*C*Dd**2*f**2*r**2 - 5688*C*Dd**2*f**2*r*s + 3690*C*Dd**2*f**2*r - 3420*C*Dd**2*f**2*s**2 + 4554*C*Dd**2*f**2*s - 1326*C*Dd**2*f**2 + 18*D1**2*K*f*fd*r**2 + 240*D1**2*K*f*fd*r*s - 120*D1**2*K*f*fd*r + 222*D1**2*K*f*fd*s**2 - 222*D1**2*K*f*fd*s + 111*D1**2*K*f*fd - 30*D1**2*K*f*fdd*r**2 - 288*D1**2*K*f*fdd*r*s + 144*D1**2*K*f*fdd*r - 258*D1**2*K*f*fdd*s**2 + 258*D1**2*K*f*fdd*s - 129*D1**2*K*f*fdd - 30*D1**2*K*fd**2*r**2 - 288*D1**2*K*fd**2*r*s + 144*D1**2*K*fd**2*r - 258*D1**2*K*fd**2*s**2 + 258*D1**2*K*fd**2*s + 70*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1**2*bdd1*(30*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 7*f*(6*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - K*(37*r**2 + 98*r*s - 86*r + 61*s**2 - 110*s + 49) + 49*r**2 + 122*r*s - 122*r + 73*s**2 - 146*s + 67) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 540*D1**2*f**2*fd*r**2 + 855*D1**2*f**2*fd*r*s - 585*D1**2*f**2*fd*r + 315*D1**2*f**2*fd*s**2 - 435*D1**2*f**2*fd*s + 225*D1**2*f**2*fd - 630*D1**2*f**2*fdd*r**2 - 855*D1**2*f**2*fdd*r*s + 735*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 465*D1**2*f**2*fdd*s - 315*D1**2*f**2*fdd - 1260*D1**2*f*fd**2*r**2 - 1710*D1**2*f*fd**2*r*s + 1470*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 930*D1**2*f*fd**2*s - 315*D1**2*f*fd**2 - 366*D1**2*f*fd*r**2 - 1050*D1**2*f*fd*r*s + 417*D1**2*f*fd*r - 684*D1**2*f*fd*s**2 + 576*D1**2*f*fd*s - 234*D1**2*f*fd + 498*D1**2*f*fdd*r**2 + 1302*D1**2*f*fdd*r*s - 555*D1**2*f*fdd*r + 804*D1**2*f*fdd*s**2 - 708*D1**2*f*fdd*s + 306*D1**2*f*fdd - 133*D1**2*f*gd2*r**2 - 462*D1**2*f*gd2*r*s + 266*D1**2*f*gd2*r - 329*D1**2*f*gd2*s**2 + 462*D1**2*f*gd2*s - 133*D1**2*f*gd2 + 259*D1**2*f*gdd2*r**2 + 686*D1**2*f*gdd2*r*s - 518*D1**2*f*gdd2*r + 427*D1**2*f*gdd2*s**2 - 686*D1**2*f*gdd2*s + 259*D1**2*f*gdd2 + 498*D1**2*fd**2*r**2 + 1302*D1**2*fd**2*r*s - 555*D1**2*fd**2*r + 804*D1**2*fd**2*s**2 - 708*D1**2*fd**2*s - 133*D1**2*fd*g2*r**2 - 462*D1**2*fd*g2*r*s - 329*D1**2*fd*g2*s**2 + 518*D1**2*fd*gd2*r**2 + 1372*D1**2*fd*gd2*r*s - 518*D1**2*fd*gd2*r + 854*D1**2*fd*gd2*s**2 - 686*D1**2*fd*gd2*s + 259*D1**2*fdd*g2*r**2 + 686*D1**2*fdd*g2*r*s + 427*D1**2*fdd*g2*s**2 + 36*D1*Dd*K*f**2*r**2 + 480*D1*Dd*K*f**2*r*s - 156*D1*Dd*K*f**2*r + 444*D1*Dd*K*f**2*s**2 - 462*D1*Dd*K*f**2*s + 129*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*r**2 - 2304*D1*Dd*K*f*fd*r*s + 984*D1*Dd*K*f*fd*r - 2064*D1*Dd*K*f*fd*s**2 + 2124*D1*Dd*K*f*fd*s - 546*D1*Dd*K*f*fd + 720*D1*Dd*f**3*r**2 + 1140*D1*Dd*f**3*r*s - 1005*D1*Dd*f**3*r + 420*D1*Dd*f**3*s**2 - 780*D1*Dd*f**3*s + 465*D1*Dd*f**3 - 5040*D1*Dd*f**2*fd*r**2 - 6840*D1*Dd*f**2*fd*r*s + 6315*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 4020*D1*Dd*f**2*fd*s - 1935*D1*Dd*f**2*fd - 732*D1*Dd*f**2*r**2 - 2100*D1*Dd*f**2*r*s + 1257*D1*Dd*f**2*r - 1368*D1*Dd*f**2*s**2 + 1734*D1*Dd*f**2*s - 708*D1*Dd*f**2 + 3984*D1*Dd*f*fd*r**2 + 10416*D1*Dd*f*fd*r*s - 5514*D1*Dd*f*fd*r + 6432*D1*Dd*f*fd*s**2 - 7044*D1*Dd*f*fd*s + 1818*D1*Dd*f*fd - 532*D1*Dd*f*g2*r**2 - 1848*D1*Dd*f*g2*r*s + 994*D1*Dd*f*g2*r - 1316*D1*Dd*f*g2*s**2 + 1582*D1*Dd*f*g2*s - 595*D1*Dd*f*g2 + 2072*D1*Dd*f*gd2*r**2 + 5488*D1*Dd*f*gd2*r*s - 3794*D1*Dd*f*gd2*r + 3416*D1*Dd*f*gd2*s**2 - 4970*D1*Dd*f*gd2*s + 1722*D1*Dd*f*gd2 + 2072*D1*Dd*fd*g2*r**2 + 5488*D1*Dd*fd*g2*r*s - 1722*D1*Dd*fd*g2*r + 3416*D1*Dd*fd*g2*s**2 - 2226*D1*Dd*fd*g2*s - 60*D1*Ddd*K*f**2*r**2 - 576*D1*Ddd*K*f**2*r*s + 204*D1*Ddd*K*f**2*r - 516*D1*Ddd*K*f**2*s**2 + 546*D1*Ddd*K*f**2*s - 159*D1*Ddd*K*f**2 - 840*D1*Ddd*f**3*r**2 - 1140*D1*Ddd*f**3*r*s + 1125*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 720*D1*Ddd*f**3*s - 495*D1*Ddd*f**3 + 996*D1*Ddd*f**2*r**2 + 2604*D1*Ddd*f**2*r*s - 1647*D1*Ddd*f**2*r + 1608*D1*Ddd*f**2*s**2 - 2106*D1*Ddd*f**2*s + 900*D1*Ddd*f**2 + 1036*D1*Ddd*f*g2*r**2 + 2744*D1*Ddd*f*g2*r*s - 1722*D1*Ddd*f*g2*r + 1708*D1*Ddd*f*g2*s**2 - 2226*D1*Ddd*f*g2*s + 945*D1*Ddd*f*g2 - D1*bd1*(D1*(18*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + f*(14*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*K*(19*r**2 + 66*r*s - 52*r + 47*s**2 - 80*s + 33) - 360*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 161*r**2 + 518*r*s - 448*r + 357*s**2 - 644*s + 273) - 14*fd*(6*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 61*K*s**2 + 55*K*s + r**2*(49 - 37*K) + r*(-98*K*s + 43*K + 122*s - 49) + 73*s**2 - 61*s - 6) + 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(30*f**2*(24*r**2 + r*(48*s - 38) + 24*s**2 - 38*s + 15) + 7*f*(6*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(148*r**2 + 392*r*s - 295*r + 244*s**2 - 379*s + 141) + 196*r**2 + 488*r*s - 403*r + 292*s**2 - 487*s + 195) - 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 180*Dd**2*K*f**2*r**2 - 1728*Dd**2*K*f**2*r*s + 612*Dd**2*K*f**2*r - 1548*Dd**2*K*f**2*s**2 + 1638*Dd**2*K*f**2*s - 318*Dd**2*K*f**2 - 2520*Dd**2*f**3*r**2 - 3420*Dd**2*f**3*r*s + 3375*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 2160*Dd**2*f**3*s - 990*Dd**2*f**3 + 2988*Dd**2*f**2*r**2 + 7812*Dd**2*f**2*r*s - 4941*Dd**2*f**2*r + 4824*Dd**2*f**2*s**2 - 6318*Dd**2*f**2*s + 1800*Dd**2*f**2 + 3108*Dd**2*f*g2*r**2 + 8232*Dd**2*f*g2*r*s - 5166*Dd**2*f*g2*r + 5124*Dd**2*f*g2*s**2 - 6678*Dd**2*f*g2*s + 1890*Dd**2*f*g2))/(315*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**2*k1**4*st**4*(D1**2*(225*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-1350*fd**2*s*(2*s - 1) + fd*(44*C - 44)*(3*s**2 - 2*s + 1) - fdd*(22*C - 22)*(3*s**2 - 2*s + 1) + s**2*(-33*K*bdd1 + 66*bd1*(K - 1) + 33*bdd1 - 132*gd2 + 66*gdd2)) - 22*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 3*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 3*fdd*g2*(2*s**2 - 2*s + 1)) + 132*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(225*f**3*(4*s**2 - 2*s + 1) + f**2*(22*C*(4*s**2 - 2*s + 1) - 225*fd*(1 - 4*s)**2 - 88*s**2 + 44*s - 22) - 11*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 6*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(3*K*bd1 - 3*bd1 - 6*gd2)) + 66*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(225*f**2 + f*(22*C - 22) - 66*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(225*f**2 + f*(22*C - 22) - 66*g2) + 33*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(385*d**2*k2**2*k3**4) + 2*D1**2*Pk2*Pk3*ct**2*k1**4*st**2*(12*C*D1**2*bdd1*f**2*s**2 - 24*C*D1**2*bdd1*f**2*s + 12*C*D1**2*bdd1*f**2 + 330*C*D1**2*f**2*fd*s**2 - 220*C*D1**2*f**2*fd*s + 110*C*D1**2*f**2*fd - 210*C*D1**2*f**2*fdd*s**2 + 140*C*D1**2*f**2*fdd*s - 70*C*D1**2*f**2*fdd - 420*C*D1**2*f*fd**2*s**2 + 280*C*D1**2*f*fd**2*s + 440*C*D1*Dd*f**3*s**2 - 220*C*D1*Dd*f**3*s + 110*C*D1*Dd*f**3 - 1680*C*D1*Dd*f**2*fd*s**2 + 980*C*D1*Dd*f**2*fd*s - 140*C*D1*Dd*f**2*fd - 280*C*D1*Ddd*f**3*s**2 + 140*C*D1*Ddd*f**3*s - 70*C*D1*Ddd*f**3 - 840*C*Dd**2*f**3*s**2 + 420*C*Dd**2*f**3*s - 71*D1**2*K*bdd1*f**2*s**2 + 28*D1**2*bd1**2*f*s*(K - 1)*(s - 1) + 80*D1**2*bdd1*f**3*r*s + 120*D1**2*bdd1*f**3*s**2 - 160*D1**2*bdd1*f**3*s + 60*D1**2*bdd1*f**3 + 36*D1**2*bdd1*f**2*r*s + 95*D1**2*bdd1*f**2*s**2 - 12*D1**2*bdd1*f**2*s - 12*D1**2*bdd1*f**2 - 28*D1**2*bdd1*f*g2*s**2 + 56*D1**2*bdd1*f*g2*s - 28*D1**2*bdd1*f*g2 + 400*D1**2*f**3*fd*r*s - 100*D1**2*f**3*fd*r + 1560*D1**2*f**3*fd*s**2 - 980*D1**2*f**3*fd*s + 390*D1**2*f**3*fd - 400*D1**2*f**3*fdd*r*s + 100*D1**2*f**3*fdd*r - 1080*D1**2*f**3*fdd*s**2 + 740*D1**2*f**3*fdd*s - 270*D1**2*f**3*fdd - 1200*D1**2*f**2*fd**2*r*s + 300*D1**2*f**2*fd**2*r - 3240*D1**2*f**2*fd**2*s**2 + 2220*D1**2*f**2*fd**2*s - 200*D1**2*f**2*fd**2 - 84*D1**2*f**2*fd*r*s + 28*D1**2*f**2*fd*r - 414*D1**2*f**2*fd*s**2 + 304*D1**2*f**2*fd*s - 138*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 270*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd - 214*D1**2*f**2*gd2*s**2 + 142*D1**2*f**2*gdd2*s**2 + 120*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 540*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 - 428*D1**2*f*fd*g2*s**2 + 428*D1**2*f*fd*g2*s - 214*D1**2*f*fd*g2 + 568*D1**2*f*fd*gd2*s**2 - 284*D1**2*f*fd*gd2*s + 284*D1**2*f*fdd*g2*s**2 - 284*D1**2*f*fdd*g2*s + 142*D1**2*f*fdd*g2 + 284*D1**2*fd**2*g2*s**2 - 284*D1**2*fd**2*g2*s + 400*D1*Dd*f**4*r*s - 100*D1*Dd*f**4*r + 1560*D1*Dd*f**4*s**2 - 980*D1*Dd*f**4*s + 390*D1*Dd*f**4 - 3200*D1*Dd*f**3*fd*r*s + 800*D1*Dd*f**3*fd*r - 8640*D1*Dd*f**3*fd*s**2 + 5920*D1*Dd*f**3*fd*s - 940*D1*Dd*f**3*fd - 112*D1*Dd*f**3*r*s + 28*D1*Dd*f**3*r - 552*D1*Dd*f**3*s**2 + 332*D1*Dd*f**3*s - 138*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r*s - 140*D1*Dd*f**2*fd*r + 2160*D1*Dd*f**2*fd*s**2 - 1460*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd - 856*D1*Dd*f**2*g2*s**2 + 428*D1*Dd*f**2*g2*s - 214*D1*Dd*f**2*g2 + 1136*D1*Dd*f**2*gd2*s**2 - 284*D1*Dd*f**2*gd2*s + 2272*D1*Dd*f*fd*g2*s**2 - 1704*D1*Dd*f*fd*g2*s + 284*D1*Dd*f*fd*g2 - 400*D1*Ddd*f**4*r*s + 100*D1*Ddd*f**4*r - 1080*D1*Ddd*f**4*s**2 + 740*D1*Ddd*f**4*s - 270*D1*Ddd*f**4 + 80*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r + 360*D1*Ddd*f**3*s**2 - 220*D1*Ddd*f**3*s + 90*D1*Ddd*f**3 + 568*D1*Ddd*f**2*g2*s**2 - 284*D1*Ddd*f**2*g2*s + 142*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-4*f**3*(42*s**2 + s*(22*r - 71) + 30) + f**2*(-24*C*(s - 1)**2 + 107*K*s**2 + 40*fd*(12*r*s - 2*r + 18*s**2 - 18*s + 1) - 44*r*s - 127*s**2 - 4*s + 24) + 2*f*(fd*(18*r*(4*s - 1) + s**2*(24*C - 142*K + 190) + s*(-24*C + 71*K - 119) + 18) + (28*s - 28)*(g2*(s - 1) - gd2*s)) - 56*fd*g2*s*(s - 1)) + 2*Dd*f*(40*f**2*(r*(8*s - 1) + 12*s**2 - 13*s + 2) + f*(12*C*(4*s**2 - 5*s + 1) - 284*K*s**2 + 71*K*s + 18*r*(8*s - 1) + 380*s**2 - 155*s + 6) - 28*g2*(4*s**2 - 5*s + 1))) - 1200*Dd**2*f**4*r*s + 300*Dd**2*f**4*r - 3240*Dd**2*f**4*s**2 + 2220*Dd**2*f**4*s - 200*Dd**2*f**4 + 240*Dd**2*f**3*r*s - 60*Dd**2*f**3*r + 1080*Dd**2*f**3*s**2 - 660*Dd**2*f**3*s + 40*Dd**2*f**3 + 1704*Dd**2*f**2*g2*s**2 - 852*Dd**2*f**2*g2*s - 14*b1**2*(K - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-48*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fdd*s**2 + 24*C*D1**2*fd**2*s**2 - 96*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*s**2 - 48*C*D1*Dd*f*fd*s + 48*C*D1*Ddd*f**2*s**2 - 24*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*s**2 - 72*C*Dd**2*f**2*s + 214*D1**2*K*f*fd*s**2 - 214*D1**2*K*f*fd*s + 107*D1**2*K*f*fd - 142*D1**2*K*f*fdd*s**2 + 142*D1**2*K*f*fdd*s - 71*D1**2*K*f*fdd - 142*D1**2*K*fd**2*s**2 + 142*D1**2*K*fd**2*s + 14*D1**2*bdd1*f*(K - 1)*(2*s**2 - 2*s + 1) - 264*D1**2*f**2*fd*r*s + 88*D1**2*f**2*fd*r - 504*D1**2*f**2*fd*s**2 + 228*D1**2*f**2*fd*s - 48*D1**2*f**2*fd + 240*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 360*D1**2*f**2*fdd*s**2 - 240*D1**2*f**2*fdd*s + 60*D1**2*f**2*fdd + 480*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 720*D1**2*f*fd**2*s**2 - 480*D1**2*f*fd**2*s + 120*D1**2*f*fd**2 - 88*D1**2*f*fd*r*s + 44*D1**2*f*fd*r - 254*D1**2*f*fd*s**2 + 302*D1**2*f*fd*s - 151*D1**2*f*fd + 72*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 190*D1**2*f*fdd*s**2 - 214*D1**2*f*fdd*s + 107*D1**2*f*fdd + 56*D1**2*f*gd2*s**2 - 28*D1**2*f*gdd2*s**2 + 72*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 190*D1**2*fd**2*s**2 - 214*D1**2*fd**2*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*s**2 - 28*D1**2*fdd*g2*s**2 + 428*D1*Dd*K*f**2*s**2 - 214*D1*Dd*K*f**2*s + 107*D1*Dd*K*f**2 - 1136*D1*Dd*K*f*fd*s**2 + 852*D1*Dd*K*f*fd*s - 142*D1*Dd*K*f*fd - 352*D1*Dd*f**3*r*s + 88*D1*Dd*f**3*r - 672*D1*Dd*f**3*s**2 + 512*D1*Dd*f**3*s - 168*D1*Dd*f**3 + 1920*D1*Dd*f**2*fd*r*s - 560*D1*Dd*f**2*fd*r + 2880*D1*Dd*f**2*fd*s**2 - 2160*D1*Dd*f**2*fd*s + 400*D1*Dd*f**2*fd - 176*D1*Dd*f**2*r*s + 44*D1*Dd*f**2*r - 508*D1*Dd*f**2*s**2 + 342*D1*Dd*f**2*s - 127*D1*Dd*f**2 + 576*D1*Dd*f*fd*r*s - 216*D1*Dd*f*fd*r + 1520*D1*Dd*f*fd*s**2 - 1380*D1*Dd*f*fd*s + 286*D1*Dd*f*fd + 224*D1*Dd*f*g2*s**2 - 112*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*s**2 + 56*D1*Dd*f*gd2*s - 224*D1*Dd*fd*g2*s**2 + 56*D1*Dd*fd*g2*s - 284*D1*Ddd*K*f**2*s**2 + 142*D1*Ddd*K*f**2*s - 71*D1*Ddd*K*f**2 + 320*D1*Ddd*f**3*r*s - 80*D1*Ddd*f**3*r + 480*D1*Ddd*f**3*s**2 - 400*D1*Ddd*f**3*s + 120*D1*Ddd*f**3 + 144*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 380*D1*Ddd*f**2*s**2 - 262*D1*Ddd*f**2*s + 95*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*s**2 + 56*D1*Ddd*f*g2*s - 28*D1*Ddd*f*g2 - 28*D1*bd1*(K - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 852*Dd**2*K*f**2*s**2 + 426*Dd**2*K*f**2*s + 960*Dd**2*f**3*r*s - 240*Dd**2*f**3*r + 1440*Dd**2*f**3*s**2 - 1200*Dd**2*f**3*s + 160*Dd**2*f**3 + 432*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 1140*Dd**2*f**2*s**2 - 786*Dd**2*f**2*s + 72*Dd**2*f**2 - 336*Dd**2*f*g2*s**2 + 168*Dd**2*f*g2*s))/(105*d**2*k2**2*k3**4) - D1**2*Pk2*Pk3*ct**2*k1**4*(486*C*D1**2*bdd1*f**2*s**2 - 972*C*D1**2*bdd1*f**2*s + 486*C*D1**2*bdd1*f**2 + 1608*C*D1**2*f**2*fd*s**2 - 1072*C*D1**2*f**2*fd*s + 536*C*D1**2*f**2*fd - 1668*C*D1**2*f**2*fdd*s**2 + 1112*C*D1**2*f**2*fdd*s - 556*C*D1**2*f**2*fdd - 3336*C*D1**2*f*fd**2*s**2 + 2224*C*D1**2*f*fd**2*s + 2144*C*D1*Dd*f**3*s**2 - 1072*C*D1*Dd*f**3*s + 536*C*D1*Dd*f**3 - 13344*C*D1*Dd*f**2*fd*s**2 + 7784*C*D1*Dd*f**2*fd*s - 1112*C*D1*Dd*f**2*fd - 2224*C*D1*Ddd*f**3*s**2 + 1112*C*D1*Ddd*f**3*s - 556*C*D1*Ddd*f**3 - 6672*C*Dd**2*f**3*s**2 + 3336*C*Dd**2*f**3*s - 402*D1**2*K*bdd1*f**2*s**2 - 6*D1**2*bd1**2*f*(30*f*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 42*r*(2*s - 1) - (7*s - 7)*(s*(17*K - 29) + 6)) + 990*D1**2*bdd1*f**3*r*s - 450*D1**2*bdd1*f**3*r + 990*D1**2*bdd1*f**3*s**2 - 1620*D1**2*bdd1*f**3*s + 675*D1**2*bdd1*f**3 + 162*D1**2*bdd1*f**2*r*s + 180*D1**2*bdd1*f**2*r + 78*D1**2*bdd1*f**2*s**2 + 990*D1**2*bdd1*f**2*s - 666*D1**2*bdd1*f**2 - 714*D1**2*bdd1*f*g2*s**2 + 1428*D1**2*bdd1*f*g2*s - 714*D1**2*bdd1*f*g2 + 2700*D1**2*f**3*fd*r*s - 675*D1**2*f**3*fd*r + 3240*D1**2*f**3*fd*s**2 - 2970*D1**2*f**3*fd*s + 810*D1**2*f**3*fd - 2700*D1**2*f**3*fdd*r*s + 675*D1**2*f**3*fdd*r - 3240*D1**2*f**3*fdd*s**2 + 2970*D1**2*f**3*fdd*s - 810*D1**2*f**3*fdd - 8100*D1**2*f**2*fd**2*r*s + 2025*D1**2*f**2*fd**2*r - 9720*D1**2*f**2*fd**2*s**2 + 8910*D1**2*f**2*fd**2*s - 1350*D1**2*f**2*fd**2 - 690*D1**2*f**2*fd*r*s + 230*D1**2*f**2*fd*r - 2298*D1**2*f**2*fd*s**2 + 1762*D1**2*f**2*fd*s - 766*D1**2*f**2*fd + 750*D1**2*f**2*fdd*r*s - 250*D1**2*f**2*fdd*r + 2418*D1**2*f**2*fdd*s**2 - 1862*D1**2*f**2*fdd*s + 806*D1**2*f**2*fdd - 768*D1**2*f**2*gd2*s**2 + 804*D1**2*f**2*gdd2*s**2 + 1500*D1**2*f*fd**2*r*s - 500*D1**2*f*fd**2*r + 4836*D1**2*f*fd**2*s**2 - 3724*D1**2*f*fd**2*s + 250*D1**2*f*fd**2 - 1536*D1**2*f*fd*g2*s**2 + 1536*D1**2*f*fd*g2*s - 768*D1**2*f*fd*g2 + 3216*D1**2*f*fd*gd2*s**2 - 1608*D1**2*f*fd*gd2*s + 1608*D1**2*f*fdd*g2*s**2 - 1608*D1**2*f*fdd*g2*s + 804*D1**2*f*fdd*g2 + 1608*D1**2*fd**2*g2*s**2 - 1608*D1**2*fd**2*g2*s + 2700*D1*Dd*f**4*r*s - 675*D1*Dd*f**4*r + 3240*D1*Dd*f**4*s**2 - 2970*D1*Dd*f**4*s + 810*D1*Dd*f**4 - 21600*D1*Dd*f**3*fd*r*s + 5400*D1*Dd*f**3*fd*r - 25920*D1*Dd*f**3*fd*s**2 + 23760*D1*Dd*f**3*fd*s - 4320*D1*Dd*f**3*fd - 920*D1*Dd*f**3*r*s + 230*D1*Dd*f**3*r - 3064*D1*Dd*f**3*s**2 + 1992*D1*Dd*f**3*s - 766*D1*Dd*f**3 + 6000*D1*Dd*f**2*fd*r*s - 1750*D1*Dd*f**2*fd*r + 19344*D1*Dd*f**2*fd*s**2 - 13784*D1*Dd*f**2*fd*s + 2362*D1*Dd*f**2*fd - 3072*D1*Dd*f**2*g2*s**2 + 1536*D1*Dd*f**2*g2*s - 768*D1*Dd*f**2*g2 + 6432*D1*Dd*f**2*gd2*s**2 - 1608*D1*Dd*f**2*gd2*s + 12864*D1*Dd*f*fd*g2*s**2 - 9648*D1*Dd*f*fd*g2*s + 1608*D1*Dd*f*fd*g2 - 2700*D1*Ddd*f**4*r*s + 675*D1*Ddd*f**4*r - 3240*D1*Ddd*f**4*s**2 + 2970*D1*Ddd*f**4*s - 810*D1*Ddd*f**4 + 1000*D1*Ddd*f**3*r*s - 250*D1*Ddd*f**3*r + 3224*D1*Ddd*f**3*s**2 - 2112*D1*Ddd*f**3*s + 806*D1*Ddd*f**3 + 3216*D1*Ddd*f**2*g2*s**2 - 1608*D1*Ddd*f**2*g2*s + 804*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(15*f**3*(2*r*(11*s - 5) + 26*s**2 - 48*s + 21) + 2*f**2*(99*C*(s - 1)**2 - 64*K*s**2 - 15*fd*(66*r*s - 21*r + 66*s**2 - 80*s + 13) + 33*r*s + 18*r - 2*s**2 + 183*s - 117) - 2*f*(fd*(3*r*(36*s + 1) + s**2*(324*C - 268*K + 52) + s*(-324*C + 134*K + 112) + 27) + (7*s - 7)*(19*g2*(s - 1) - 34*gd2*s)) + 476*fd*g2*s*(s - 1)) - 2*Dd*f*(15*f**2*(88*r*s - 31*r + 88*s**2 - 116*s + 28) + f*(162*C*(4*s**2 - 5*s + 1) - 536*K*s**2 + 134*K*s + 216*r*s + 93*r + 104*s**2 + 580*s - 225) - 238*g2*(4*s**2 - 5*s + 1))) - 8100*Dd**2*f**4*r*s + 2025*Dd**2*f**4*r - 9720*Dd**2*f**4*s**2 + 8910*Dd**2*f**4*s - 1350*Dd**2*f**4 + 3000*Dd**2*f**3*r*s - 750*Dd**2*f**3*r + 9672*Dd**2*f**3*s**2 - 6336*Dd**2*f**3*s + 500*Dd**2*f**3 + 9648*Dd**2*f**2*g2*s**2 - 4824*Dd**2*f**2*g2*s + 3*b1**2*(D1**2*s*(12*f*(3*fd - 5*fdd)*(4*r + 4*s - 3) - 60*fd**2*(4*r + 4*s - 3) + 7*fd*(-19*K*s + 4*r + 23*s) - 7*fdd*(-17*K*s + 12*r + 29*s)) + D1*(Dd*(72*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-133*K*(4*s**2 - 2*s + 1) - 60*fd*(8*s - 1)*(4*r + 4*s - 3) + 112*r*s - 28*r + 644*s**2 - 378*s + 161) + 14*fd*(r*(6 - 48*s) + s*(68*K*s - 17*K - 116*s + 41))) + Ddd*f*(119*K*(4*s**2 - 2*s + 1) - 120*f*(r*(4*s - 1) + (1 - 2*s)**2) - 336*r*s + 84*r - 812*s**2 + 574*s - 203)) - 6*Dd**2*f*(20*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 42*r*(4*s - 1) + 7*s**2*(58 - 34*K) + 7*s*(17*K - 41) + 28)) + 3*b1*(-396*C*D1**2*f*fd*s**2 + 324*C*D1**2*f*fdd*s**2 + 324*C*D1**2*fd**2*s**2 - 792*C*D1*Dd*f**2*s**2 + 396*C*D1*Dd*f**2*s - 198*C*D1*Dd*f**2 + 2592*C*D1*Dd*f*fd*s**2 - 648*C*D1*Dd*f*fd*s + 648*C*D1*Ddd*f**2*s**2 - 324*C*D1*Ddd*f**2*s + 162*C*D1*Ddd*f**2 + 1944*C*Dd**2*f**2*s**2 - 972*C*Dd**2*f**2*s + 256*D1**2*K*f*fd*s**2 - 256*D1**2*K*f*fd*s + 128*D1**2*K*f*fd - 268*D1**2*K*f*fdd*s**2 + 268*D1**2*K*f*fdd*s - 134*D1**2*K*f*fdd - 268*D1**2*K*fd**2*s**2 + 268*D1**2*K*fd**2*s + D1**2*bdd1*f*(119*K*(2*s**2 - 2*s + 1) - 60*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 168*r*s + 84*r - 406*s**2 + 490*s - 203) - 990*D1**2*f**2*fd*r*s + 180*D1**2*f**2*fd*r - 1170*D1**2*f**2*fd*s**2 + 720*D1**2*f**2*fd*s - 75*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 180*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 780*D1**2*f**2*fdd*s + 105*D1**2*f**2*fdd + 1980*D1**2*f*fd**2*r*s - 360*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1560*D1**2*f*fd**2*s + 270*D1**2*f*fd**2 - 132*D1**2*f*fd*r*s + 102*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 + 424*D1**2*f*fd*s - 230*D1**2*f*fd + 108*D1**2*f*fdd*r*s - 114*D1**2*f*fdd*r + 52*D1**2*f*fdd*s**2 - 436*D1**2*f*fdd*s + 248*D1**2*f*fdd + 266*D1**2*f*gd2*s**2 - 238*D1**2*f*gdd2*s**2 + 108*D1**2*fd**2*r*s - 114*D1**2*fd**2*r + 52*D1**2*fd**2*s**2 - 436*D1**2*fd**2*s + 266*D1**2*fd*g2*s**2 - 476*D1**2*fd*gd2*s**2 - 238*D1**2*fdd*g2*s**2 + 512*D1*Dd*K*f**2*s**2 - 256*D1*Dd*K*f**2*s + 128*D1*Dd*K*f**2 - 2144*D1*Dd*K*f*fd*s**2 + 1608*D1*Dd*K*f*fd*s - 268*D1*Dd*K*f*fd - 1320*D1*Dd*f**3*r*s + 330*D1*Dd*f**3*r - 1560*D1*Dd*f**3*s**2 + 1440*D1*Dd*f**3*s - 390*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 1710*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7080*D1*Dd*f**2*fd*s + 1140*D1*Dd*f**2*fd - 264*D1*Dd*f**2*r*s + 66*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 + 124*D1*Dd*f**2*s + 4*D1*Dd*f**2 + 864*D1*Dd*f*fd*r*s - 564*D1*Dd*f*fd*r + 416*D1*Dd*f*fd*s**2 - 2064*D1*Dd*f*fd*s + 664*D1*Dd*f*fd + 1064*D1*Dd*f*g2*s**2 - 532*D1*Dd*f*g2*s + 266*D1*Dd*f*g2 - 1904*D1*Dd*f*gd2*s**2 + 476*D1*Dd*f*gd2*s - 1904*D1*Dd*fd*g2*s**2 + 476*D1*Dd*fd*g2*s - 536*D1*Ddd*K*f**2*s**2 + 268*D1*Ddd*K*f**2*s - 134*D1*Ddd*K*f**2 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 216*D1*Ddd*f**2*r*s - 54*D1*Ddd*f**2*r + 104*D1*Ddd*f**2*s**2 - 160*D1*Ddd*f**2*s + 26*D1*Ddd*f**2 - 952*D1*Ddd*f*g2*s**2 + 476*D1*Ddd*f*g2*s - 238*D1*Ddd*f*g2 + D1*bd1*(D1*(36*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(-133*K*(2*s**2 - 2*s + 1) - 60*fd*(4*s - 1)*(4*r + 4*s - 3) + 56*r*s - 28*r + 322*s**2 - 350*s + 161) + 14*fd*(r*(6 - 24*s) + s*(34*K*s - 17*K - 58*s + 35))) - 2*Dd*f*(-119*K*(8*s**2 - 6*s + 1) + 30*f*(8*s - 3)*(4*r + 4*s - 3) + 672*r*s - 252*r + 1624*s**2 - 1554*s + 329)) - 1608*Dd**2*K*f**2*s**2 + 804*Dd**2*K*f**2*s + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 648*Dd**2*f**2*r*s - 162*Dd**2*f**2*r + 312*Dd**2*f**2*s**2 - 480*Dd**2*f**2*s + 108*Dd**2*f**2 - 2856*Dd**2*f*g2*s**2 + 1428*Dd**2*f*g2*s))/(315*d**2*k2**2*k3**4) - 4*D1**2*Pk2*Pk3*ct**2*k1**2*k2**4*st**6*(132*C*D1**2*f**2*fd*r**2 + 264*C*D1**2*f**2*fd*r*s - 176*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 176*C*D1**2*f**2*fd*s + 88*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r**2 - 132*C*D1**2*f**2*fdd*r*s + 88*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 88*C*D1**2*f**2*fdd*s - 44*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r**2 - 264*C*D1**2*f*fd**2*r*s + 176*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 176*C*D1**2*f*fd**2*s - 44*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r**2 + 352*C*D1*Dd*f**3*r*s - 264*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 264*C*D1*Dd*f**3*s + 132*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r**2 - 1056*C*D1*Dd*f**2*fd*r*s + 748*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 748*C*D1*Dd*f**2*fd*s - 264*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r**2 - 176*C*D1*Ddd*f**3*r*s + 132*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 132*C*D1*Ddd*f**3*s - 66*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r**2 - 528*C*Dd**2*f**3*r*s + 396*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 396*C*Dd**2*f**3*s - 132*C*Dd**2*f**3 + 396*D1**2*K*b1*f*fd*r**2 + 792*D1**2*K*b1*f*fd*r*s - 396*D1**2*K*b1*f*fd*r + 396*D1**2*K*b1*f*fd*s**2 - 396*D1**2*K*b1*f*fd*s + 198*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 396*D1**2*K*b1*f*fdd*r*s + 198*D1**2*K*b1*f*fdd*r - 198*D1**2*K*b1*f*fdd*s**2 + 198*D1**2*K*b1*f*fdd*s - 99*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 396*D1**2*K*b1*fd**2*r*s + 198*D1**2*K*b1*fd**2*r - 198*D1**2*K*b1*fd**2*s**2 + 198*D1**2*K*b1*fd**2*s - 396*D1**2*b1*f*fd*r**2 - 792*D1**2*b1*f*fd*r*s + 396*D1**2*b1*f*fd*r - 396*D1**2*b1*f*fd*s**2 + 396*D1**2*b1*f*fd*s - 198*D1**2*b1*f*fd + 198*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 198*D1**2*b1*f*fdd*s**2 - 198*D1**2*b1*f*fdd*s + 99*D1**2*b1*f*fdd + 198*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 198*D1**2*b1*fd**2*s**2 - 198*D1**2*b1*fd**2*s - 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 672*D1**2*f**3*fd*r**2 + 1344*D1**2*f**3*fd*r*s - 1008*D1**2*f**3*fd*r + 672*D1**2*f**3*fd*s**2 - 1008*D1**2*f**3*fd*s + 504*D1**2*f**3*fd - 336*D1**2*f**3*fdd*r**2 - 672*D1**2*f**3*fdd*r*s + 504*D1**2*f**3*fdd*r - 336*D1**2*f**3*fdd*s**2 + 504*D1**2*f**3*fdd*s - 252*D1**2*f**3*fdd - 1008*D1**2*f**2*fd**2*r**2 - 2016*D1**2*f**2*fd**2*r*s + 1512*D1**2*f**2*fd**2*r - 1008*D1**2*f**2*fd**2*s**2 + 1512*D1**2*f**2*fd**2*s - 504*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r**2 - 264*D1**2*f**2*fd*r*s + 176*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 176*D1**2*f**2*fd*s - 88*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r**2 + 132*D1**2*f**2*fdd*r*s - 88*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 88*D1**2*f**2*fdd*s + 44*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 396*D1**2*f**2*gd2*s**2 + 792*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 396*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 132*D1**2*f*fd**2*r**2 + 264*D1**2*f*fd**2*r*s - 176*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 176*D1**2*f*fd**2*s + 44*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 792*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1584*D1**2*f*fd*gd2*r*s - 1188*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1188*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 792*D1*Dd*K*b1*f**2*r**2 + 1584*D1*Dd*K*b1*f**2*r*s - 1188*D1*Dd*K*b1*f**2*r + 792*D1*Dd*K*b1*f**2*s**2 - 1188*D1*Dd*K*b1*f**2*s + 594*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 3168*D1*Dd*K*b1*f*fd*r*s + 1980*D1*Dd*K*b1*f*fd*r - 1584*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 594*D1*Dd*K*b1*f*fd - 792*D1*Dd*b1*f**2*r**2 - 1584*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 792*D1*Dd*b1*f**2*s**2 + 1188*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r + 1584*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s + 594*D1*Dd*b1*f*fd + 672*D1*Dd*f**4*r**2 + 1344*D1*Dd*f**4*r*s - 1008*D1*Dd*f**4*r + 672*D1*Dd*f**4*s**2 - 1008*D1*Dd*f**4*s + 504*D1*Dd*f**4 - 2688*D1*Dd*f**3*fd*r**2 - 5376*D1*Dd*f**3*fd*r*s + 4032*D1*Dd*f**3*fd*r - 2688*D1*Dd*f**3*fd*s**2 + 4032*D1*Dd*f**3*fd*s - 1512*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r**2 - 352*D1*Dd*f**3*r*s + 264*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 264*D1*Dd*f**3*s - 132*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r**2 + 1056*D1*Dd*f**2*fd*r*s - 748*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 748*D1*Dd*f**2*fd*s + 264*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 2376*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 3168*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 1188*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 6336*D1*Dd*f*fd*g2*r*s - 3960*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 1188*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 792*D1*Ddd*K*b1*f**2*r*s + 594*D1*Ddd*K*b1*f**2*r - 396*D1*Ddd*K*b1*f**2*s**2 + 594*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 396*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 396*D1*Ddd*b1*f**2*s**2 - 594*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 - 336*D1*Ddd*f**4*r**2 - 672*D1*Ddd*f**4*r*s + 504*D1*Ddd*f**4*r - 336*D1*Ddd*f**4*s**2 + 504*D1*Ddd*f**4*s - 252*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r**2 + 176*D1*Ddd*f**3*r*s - 132*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 132*D1*Ddd*f**3*s + 66*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1584*D1*Ddd*f**2*g2*r*s - 1188*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1188*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1188*Dd**2*K*b1*f**2*r**2 - 2376*Dd**2*K*b1*f**2*r*s + 1782*Dd**2*K*b1*f**2*r - 1188*Dd**2*K*b1*f**2*s**2 + 1782*Dd**2*K*b1*f**2*s - 594*Dd**2*K*b1*f**2 + 1188*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 1188*Dd**2*b1*f**2*s**2 - 1782*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 - 1008*Dd**2*f**4*r**2 - 2016*Dd**2*f**4*r*s + 1512*Dd**2*f**4*r - 1008*Dd**2*f**4*s**2 + 1512*Dd**2*f**4*s - 504*Dd**2*f**4 + 264*Dd**2*f**3*r**2 + 528*Dd**2*f**3*r*s - 396*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 396*Dd**2*f**3*s + 132*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 4752*Dd**2*f**2*g2*r*s - 3564*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3564*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2)/(231*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**2*k1**2*k2**4*st**4*(-6*C*D1**2*bdd1*f**2*r**2 - 12*C*D1**2*bdd1*f**2*r*s + 12*C*D1**2*bdd1*f**2*r - 6*C*D1**2*bdd1*f**2*s**2 + 12*C*D1**2*bdd1*f**2*s - 6*C*D1**2*bdd1*f**2 + 390*C*D1**2*f**2*fd*r**2 + 780*C*D1**2*f**2*fd*r*s - 520*C*D1**2*f**2*fd*r + 390*C*D1**2*f**2*fd*s**2 - 520*C*D1**2*f**2*fd*s + 260*C*D1**2*f**2*fd - 240*C*D1**2*f**2*fdd*r**2 - 480*C*D1**2*f**2*fdd*r*s + 320*C*D1**2*f**2*fdd*r - 240*C*D1**2*f**2*fdd*s**2 + 320*C*D1**2*f**2*fdd*s - 160*C*D1**2*f**2*fdd - 480*C*D1**2*f*fd**2*r**2 - 960*C*D1**2*f*fd**2*r*s + 640*C*D1**2*f*fd**2*r - 480*C*D1**2*f*fd**2*s**2 + 640*C*D1**2*f*fd**2*s - 160*C*D1**2*f*fd**2 + 520*C*D1*Dd*f**3*r**2 + 1040*C*D1*Dd*f**3*r*s - 780*C*D1*Dd*f**3*r + 520*C*D1*Dd*f**3*s**2 - 780*C*D1*Dd*f**3*s + 390*C*D1*Dd*f**3 - 1920*C*D1*Dd*f**2*fd*r**2 - 3840*C*D1*Dd*f**2*fd*r*s + 2720*C*D1*Dd*f**2*fd*r - 1920*C*D1*Dd*f**2*fd*s**2 + 2720*C*D1*Dd*f**2*fd*s - 960*C*D1*Dd*f**2*fd - 320*C*D1*Ddd*f**3*r**2 - 640*C*D1*Ddd*f**3*r*s + 480*C*D1*Ddd*f**3*r - 320*C*D1*Ddd*f**3*s**2 + 480*C*D1*Ddd*f**3*s - 240*C*D1*Ddd*f**3 - 960*C*Dd**2*f**3*r**2 - 1920*C*Dd**2*f**3*r*s + 1440*C*Dd**2*f**3*r - 960*C*Dd**2*f**3*s**2 + 1440*C*Dd**2*f**3*s - 480*C*Dd**2*f**3 - 120*D1**2*K*bdd1*f**2*r**2 - 240*D1**2*K*bdd1*f**2*r*s + 240*D1**2*K*bdd1*f**2*r - 120*D1**2*K*bdd1*f**2*s**2 + 240*D1**2*K*bdd1*f**2*s - 120*D1**2*K*bdd1*f**2 - 42*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 60*D1**2*bdd1*f**3*r**2 + 120*D1**2*bdd1*f**3*r*s - 120*D1**2*bdd1*f**3*r + 60*D1**2*bdd1*f**3*s**2 - 120*D1**2*bdd1*f**3*s + 60*D1**2*bdd1*f**3 + 66*D1**2*bdd1*f**2*r**2 + 132*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*r + 66*D1**2*bdd1*f**2*s**2 - 132*D1**2*bdd1*f**2*s + 66*D1**2*bdd1*f**2 + 42*D1**2*bdd1*f*g2*r**2 + 84*D1**2*bdd1*f*g2*r*s - 84*D1**2*bdd1*f*g2*r + 42*D1**2*bdd1*f*g2*s**2 - 84*D1**2*bdd1*f*g2*s + 42*D1**2*bdd1*f*g2 - 60*D1**2*f**3*fd*r**2 - 120*D1**2*f**3*fd*r*s + 90*D1**2*f**3*fd*r - 60*D1**2*f**3*fd*s**2 + 90*D1**2*f**3*fd*s - 45*D1**2*f**3*fd - 288*D1**2*f**2*fd*r**2 - 576*D1**2*f**2*fd*r*s + 384*D1**2*f**2*fd*r - 288*D1**2*f**2*fd*s**2 + 384*D1**2*f**2*fd*s - 192*D1**2*f**2*fd + 180*D1**2*f**2*fdd*r**2 + 360*D1**2*f**2*fdd*r*s - 240*D1**2*f**2*fdd*r + 180*D1**2*f**2*fdd*s**2 - 240*D1**2*f**2*fdd*s + 120*D1**2*f**2*fdd - 270*D1**2*f**2*gd2*r**2 - 540*D1**2*f**2*gd2*r*s + 540*D1**2*f**2*gd2*r - 270*D1**2*f**2*gd2*s**2 + 540*D1**2*f**2*gd2*s - 270*D1**2*f**2*gd2 + 240*D1**2*f**2*gdd2*r**2 + 480*D1**2*f**2*gdd2*r*s - 480*D1**2*f**2*gdd2*r + 240*D1**2*f**2*gdd2*s**2 - 480*D1**2*f**2*gdd2*s + 240*D1**2*f**2*gdd2 + 360*D1**2*f*fd**2*r**2 + 720*D1**2*f*fd**2*r*s - 480*D1**2*f*fd**2*r + 360*D1**2*f*fd**2*s**2 - 480*D1**2*f*fd**2*s + 120*D1**2*f*fd**2 - 540*D1**2*f*fd*g2*r**2 - 1080*D1**2*f*fd*g2*r*s + 540*D1**2*f*fd*g2*r - 540*D1**2*f*fd*g2*s**2 + 540*D1**2*f*fd*g2*s - 270*D1**2*f*fd*g2 + 960*D1**2*f*fd*gd2*r**2 + 1920*D1**2*f*fd*gd2*r*s - 1440*D1**2*f*fd*gd2*r + 960*D1**2*f*fd*gd2*s**2 - 1440*D1**2*f*fd*gd2*s + 480*D1**2*f*fd*gd2 + 480*D1**2*f*fdd*g2*r**2 + 960*D1**2*f*fdd*g2*r*s - 480*D1**2*f*fdd*g2*r + 480*D1**2*f*fdd*g2*s**2 - 480*D1**2*f*fdd*g2*s + 240*D1**2*f*fdd*g2 + 480*D1**2*fd**2*g2*r**2 + 960*D1**2*fd**2*g2*r*s - 480*D1**2*fd**2*g2*r + 480*D1**2*fd**2*g2*s**2 - 480*D1**2*fd**2*g2*s - 60*D1*Dd*f**4*r**2 - 120*D1*Dd*f**4*r*s + 90*D1*Dd*f**4*r - 60*D1*Dd*f**4*s**2 + 90*D1*Dd*f**4*s - 45*D1*Dd*f**4 - 384*D1*Dd*f**3*r**2 - 768*D1*Dd*f**3*r*s + 576*D1*Dd*f**3*r - 384*D1*Dd*f**3*s**2 + 576*D1*Dd*f**3*s - 288*D1*Dd*f**3 + 1440*D1*Dd*f**2*fd*r**2 + 2880*D1*Dd*f**2*fd*r*s - 2040*D1*Dd*f**2*fd*r + 1440*D1*Dd*f**2*fd*s**2 - 2040*D1*Dd*f**2*fd*s + 720*D1*Dd*f**2*fd - 1080*D1*Dd*f**2*g2*r**2 - 2160*D1*Dd*f**2*g2*r*s + 1620*D1*Dd*f**2*g2*r - 1080*D1*Dd*f**2*g2*s**2 + 1620*D1*Dd*f**2*g2*s - 810*D1*Dd*f**2*g2 + 1920*D1*Dd*f**2*gd2*r**2 + 3840*D1*Dd*f**2*gd2*r*s - 3360*D1*Dd*f**2*gd2*r + 1920*D1*Dd*f**2*gd2*s**2 - 3360*D1*Dd*f**2*gd2*s + 1440*D1*Dd*f**2*gd2 + 3840*D1*Dd*f*fd*g2*r**2 + 7680*D1*Dd*f*fd*g2*r*s - 4800*D1*Dd*f*fd*g2*r + 3840*D1*Dd*f*fd*g2*s**2 - 4800*D1*Dd*f*fd*g2*s + 1440*D1*Dd*f*fd*g2 + 240*D1*Ddd*f**3*r**2 + 480*D1*Ddd*f**3*r*s - 360*D1*Ddd*f**3*r + 240*D1*Ddd*f**3*s**2 - 360*D1*Ddd*f**3*s + 180*D1*Ddd*f**3 + 960*D1*Ddd*f**2*g2*r**2 + 1920*D1*Ddd*f**2*g2*r*s - 1440*D1*Ddd*f**2*g2*r + 960*D1*Ddd*f**2*g2*s**2 - 1440*D1*Ddd*f**2*g2*s + 720*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(30*f**3*(r + s - 1) - f**2*(4*C*(r + s - 1) + 40*fd*(3*r + 3*s - 2) + (45*K - 23)*(r + s - 1)) + 4*f*(fd*(C + 20*K - 11)*(2*r + 2*s - 1) + (7*g2 - 7*gd2)*(r + s - 1)) - 28*fd*g2*(r + s)) - 4*Dd*f*(10*f**2 - f*(C + 20*K - 11) + 7*g2)*(4*r + 4*s - 3))*(r + s - 1) + 720*Dd**2*f**3*r**2 + 1440*Dd**2*f**3*r*s - 1080*Dd**2*f**3*r + 720*Dd**2*f**3*s**2 - 1080*Dd**2*f**3*s + 360*Dd**2*f**3 + 2880*Dd**2*f**2*g2*r**2 + 5760*Dd**2*f**2*g2*r*s - 4320*Dd**2*f**2*g2*r + 2880*Dd**2*f**2*g2*s**2 - 4320*Dd**2*f**2*g2*s + 1440*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(8*C*D1**2*f*fd*r**2 + 16*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd*s + 4*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 - 8*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 4*C*D1**2*f*fdd*s - 2*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 - 8*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 4*C*D1**2*fd**2*s + 16*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 24*C*D1*Dd*f**2*s + 12*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 - 64*C*D1*Dd*f*fd*r*s + 40*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 40*C*D1*Dd*f*fd*s - 12*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 - 16*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 12*C*D1*Ddd*f**2*s - 6*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 - 48*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 36*C*Dd**2*f**2*s - 12*C*Dd**2*f**2 + 90*D1**2*K*f*fd*r**2 + 180*D1**2*K*f*fd*r*s - 90*D1**2*K*f*fd*r + 90*D1**2*K*f*fd*s**2 - 90*D1**2*K*f*fd*s + 45*D1**2*K*f*fd - 80*D1**2*K*f*fdd*r**2 - 160*D1**2*K*f*fdd*r*s + 80*D1**2*K*f*fdd*r - 80*D1**2*K*f*fdd*s**2 + 80*D1**2*K*f*fdd*s - 40*D1**2*K*f*fdd - 80*D1**2*K*fd**2*r**2 - 160*D1**2*K*fd**2*r*s + 80*D1**2*K*fd**2*r - 80*D1**2*K*fd**2*s**2 + 80*D1**2*K*fd**2*s - 14*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 90*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 120*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 80*D1**2*f**2*fdd*s + 40*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 240*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 160*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 46*D1**2*f*fd*r**2 - 92*D1**2*f*fd*r*s + 46*D1**2*f*fd*r - 46*D1**2*f*fd*s**2 + 46*D1**2*f*fd*s - 23*D1**2*f*fd + 44*D1**2*f*fdd*r**2 + 88*D1**2*f*fdd*r*s - 44*D1**2*f*fdd*r + 44*D1**2*f*fdd*s**2 - 44*D1**2*f*fdd*s + 22*D1**2*f*fdd - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 14*D1**2*f*gdd2*r**2 + 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 + 44*D1**2*fd**2*r**2 + 88*D1**2*fd**2*r*s - 44*D1**2*fd**2*r + 44*D1**2*fd**2*s**2 - 44*D1**2*fd**2*s - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s - 28*D1**2*fd*g2*s**2 + 28*D1**2*fd*gd2*r**2 + 56*D1**2*fd*gd2*r*s - 28*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 28*D1**2*fd*gd2*s + 14*D1**2*fdd*g2*r**2 + 28*D1**2*fdd*g2*r*s + 14*D1**2*fdd*g2*s**2 + 180*D1*Dd*K*f**2*r**2 + 360*D1*Dd*K*f**2*r*s - 270*D1*Dd*K*f**2*r + 180*D1*Dd*K*f**2*s**2 - 270*D1*Dd*K*f**2*s + 135*D1*Dd*K*f**2 - 640*D1*Dd*K*f*fd*r**2 - 1280*D1*Dd*K*f*fd*r*s + 800*D1*Dd*K*f*fd*r - 640*D1*Dd*K*f*fd*s**2 + 800*D1*Dd*K*f*fd*s - 240*D1*Dd*K*f*fd - 120*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 180*D1*Dd*f**3*s - 90*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 960*D1*Dd*f**2*fd*r*s - 680*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 680*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd - 92*D1*Dd*f**2*r**2 - 184*D1*Dd*f**2*r*s + 138*D1*Dd*f**2*r - 92*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 69*D1*Dd*f**2 + 352*D1*Dd*f*fd*r**2 + 704*D1*Dd*f*fd*r*s - 440*D1*Dd*f*fd*r + 352*D1*Dd*f*fd*s**2 - 440*D1*Dd*f*fd*s + 132*D1*Dd*f*fd - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 + 224*D1*Dd*f*gd2*r*s - 196*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 196*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r**2 + 224*D1*Dd*fd*g2*r*s - 84*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 84*D1*Dd*fd*g2*s - 160*D1*Ddd*K*f**2*r**2 - 320*D1*Ddd*K*f**2*r*s + 240*D1*Ddd*K*f**2*r - 160*D1*Ddd*K*f**2*s**2 + 240*D1*Ddd*K*f**2*s - 120*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r**2 + 160*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 120*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 88*D1*Ddd*f**2*r**2 + 176*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 88*D1*Ddd*f**2*s**2 - 132*D1*Ddd*f**2*s + 66*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 + 112*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 84*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 28*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 480*Dd**2*K*f**2*r**2 - 960*Dd**2*K*f**2*r*s + 720*Dd**2*K*f**2*r - 480*Dd**2*K*f**2*s**2 + 720*Dd**2*K*f**2*s - 240*Dd**2*K*f**2 + 240*Dd**2*f**3*r**2 + 480*Dd**2*f**3*r*s - 360*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 360*Dd**2*f**3*s + 120*Dd**2*f**3 + 264*Dd**2*f**2*r**2 + 528*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 264*Dd**2*f**2*s**2 - 396*Dd**2*f**2*s + 132*Dd**2*f**2 + 168*Dd**2*f*g2*r**2 + 336*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 252*Dd**2*f*g2*s + 84*Dd**2*f*g2))/(35*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**2*k1**2*k2**4*st**2*(-12*D1**2*bd1**2*f*(-28*K + 15*f + 14)*(r + s - 1)**2 + 12*D1**2*bdd1*f*(3*f*(4*C + 3*K - 3) - 28*g2)*(r + s - 1)**2 + 12*D1**2*(f**2*(-fd*(5*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (gd2 - 18*gdd2)*(r + s - 1)**2) + f*(fd**2*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + fd*(g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 36*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 18*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 36*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*D1*bd1*(D1*(18*f**3*(r + s - 1) + f**2*(109*C + 3*K - 59)*(r + s - 1) - 36*f*fd*(4*C + 3*K - 3)*(2*r + 2*s - 1) - 7*f*(23*g2 - 48*gd2)*(r + s - 1) + 336*fd*g2*(r + s)) - 12*Dd*f*(3*f*(4*C + 3*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 12*D1*f*(Dd*(f**2*(5*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-fd*(20*C - 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 36*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 36*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(f*(10*C - 5) - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 72*Dd**2*f**2*(f*(10*C - 5) - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + b1**2*(D1**2*(6*f*(23*fd - 15*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(180*fd**2*(r + s - 1) + 7*fd*(23*K - 9)*(r + s) - 84*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(138*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(180*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (161*K - 63)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 168*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-28*K + 15*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-28*K + 15*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(-218*C*D1**2*f*fd*r**2 - 436*C*D1**2*f*fd*r*s + 218*C*D1**2*f*fd*r - 218*C*D1**2*f*fd*s**2 + 218*C*D1**2*f*fd*s - 109*C*D1**2*f*fd + 144*C*D1**2*f*fdd*r**2 + 288*C*D1**2*f*fdd*r*s - 144*C*D1**2*f*fdd*r + 144*C*D1**2*f*fdd*s**2 - 144*C*D1**2*f*fdd*s + 72*C*D1**2*f*fdd + 144*C*D1**2*fd**2*r**2 + 288*C*D1**2*fd**2*r*s - 144*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 144*C*D1**2*fd**2*s - 436*C*D1*Dd*f**2*r**2 - 872*C*D1*Dd*f**2*r*s + 654*C*D1*Dd*f**2*r - 436*C*D1*Dd*f**2*s**2 + 654*C*D1*Dd*f**2*s - 327*C*D1*Dd*f**2 + 1152*C*D1*Dd*f*fd*r**2 + 2304*C*D1*Dd*f*fd*r*s - 1440*C*D1*Dd*f*fd*r + 1152*C*D1*Dd*f*fd*s**2 - 1440*C*D1*Dd*f*fd*s + 432*C*D1*Dd*f*fd + 288*C*D1*Ddd*f**2*r**2 + 576*C*D1*Ddd*f**2*r*s - 432*C*D1*Ddd*f**2*r + 288*C*D1*Ddd*f**2*s**2 - 432*C*D1*Ddd*f**2*s + 216*C*D1*Ddd*f**2 + 864*C*Dd**2*f**2*r**2 + 1728*C*Dd**2*f**2*r*s - 1296*C*Dd**2*f**2*r + 864*C*Dd**2*f**2*s**2 - 1296*C*Dd**2*f**2*s + 432*C*Dd**2*f**2 - 6*D1**2*K*f*fd*r**2 - 12*D1**2*K*f*fd*r*s + 6*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd + 108*D1**2*K*f*fdd*r**2 + 216*D1**2*K*f*fdd*r*s - 108*D1**2*K*f*fdd*r + 108*D1**2*K*f*fdd*s**2 - 108*D1**2*K*f*fdd*s + 54*D1**2*K*f*fdd + 108*D1**2*K*fd**2*r**2 + 216*D1**2*K*fd**2*r*s - 108*D1**2*K*fd**2*r + 108*D1**2*K*fd**2*s**2 - 108*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-28*K + 15*f + 14)*(r + s - 1)**2 - 54*D1**2*f**2*fd*r**2 - 108*D1**2*f**2*fd*r*s + 72*D1**2*f**2*fd*r - 54*D1**2*f**2*fd*s**2 + 72*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 118*D1**2*f*fd*r**2 + 236*D1**2*f*fd*r*s - 118*D1**2*f*fd*r + 118*D1**2*f*fd*s**2 - 118*D1**2*f*fd*s + 59*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 216*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*r - 108*D1**2*f*fdd*s**2 + 108*D1**2*f*fdd*s - 54*D1**2*f*fdd + 161*D1**2*f*gd2*r**2 + 322*D1**2*f*gd2*r*s - 322*D1**2*f*gd2*r + 161*D1**2*f*gd2*s**2 - 322*D1**2*f*gd2*s + 161*D1**2*f*gd2 - 168*D1**2*f*gdd2*r**2 - 336*D1**2*f*gdd2*r*s + 336*D1**2*f*gdd2*r - 168*D1**2*f*gdd2*s**2 + 336*D1**2*f*gdd2*s - 168*D1**2*f*gdd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 108*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 108*D1**2*fd**2*s + 161*D1**2*fd*g2*r**2 + 322*D1**2*fd*g2*r*s + 161*D1**2*fd*g2*s**2 - 336*D1**2*fd*gd2*r**2 - 672*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s**2 + 336*D1**2*fd*gd2*s - 168*D1**2*fdd*g2*r**2 - 336*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*s**2 - 12*D1*Dd*K*f**2*r**2 - 24*D1*Dd*K*f**2*r*s + 18*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 18*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 864*D1*Dd*K*f*fd*r**2 + 1728*D1*Dd*K*f*fd*r*s - 1080*D1*Dd*K*f*fd*r + 864*D1*Dd*K*f*fd*s**2 - 1080*D1*Dd*K*f*fd*s + 324*D1*Dd*K*f*fd - 72*D1*Dd*f**3*r**2 - 144*D1*Dd*f**3*r*s + 108*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 108*D1*Dd*f**3*s - 54*D1*Dd*f**3 + 236*D1*Dd*f**2*r**2 + 472*D1*Dd*f**2*r*s - 354*D1*Dd*f**2*r + 236*D1*Dd*f**2*s**2 - 354*D1*Dd*f**2*s + 177*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 1728*D1*Dd*f*fd*r*s + 1080*D1*Dd*f*fd*r - 864*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 324*D1*Dd*f*fd + 644*D1*Dd*f*g2*r**2 + 1288*D1*Dd*f*g2*r*s - 966*D1*Dd*f*g2*r + 644*D1*Dd*f*g2*s**2 - 966*D1*Dd*f*g2*s + 483*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r**2 - 2688*D1*Dd*f*gd2*r*s + 2352*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 2352*D1*Dd*f*gd2*s - 1008*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r**2 - 2688*D1*Dd*fd*g2*r*s + 1008*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 + 1008*D1*Dd*fd*g2*s + 216*D1*Ddd*K*f**2*r**2 + 432*D1*Ddd*K*f**2*r*s - 324*D1*Ddd*K*f**2*r + 216*D1*Ddd*K*f**2*s**2 - 324*D1*Ddd*K*f**2*s + 162*D1*Ddd*K*f**2 - 216*D1*Ddd*f**2*r**2 - 432*D1*Ddd*f**2*r*s + 324*D1*Ddd*f**2*r - 216*D1*Ddd*f**2*s**2 + 324*D1*Ddd*f**2*s - 162*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 - 1344*D1*Ddd*f*g2*r*s + 1008*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 1008*D1*Ddd*f*g2*s - 504*D1*Ddd*f*g2 + D1*bd1*(D1*(138*f**2*(r + s - 1) - 180*f*fd*(2*r + 2*s - 1) - 7*f*(23*K - 9)*(r + s - 1) + 168*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-28*K + 15*f + 14)*(4*r + 4*s - 3))*(r + s - 1) + 648*Dd**2*K*f**2*r**2 + 1296*Dd**2*K*f**2*r*s - 972*Dd**2*K*f**2*r + 648*Dd**2*K*f**2*s**2 - 972*Dd**2*K*f**2*s + 324*Dd**2*K*f**2 - 648*Dd**2*f**2*r**2 - 1296*Dd**2*f**2*r*s + 972*Dd**2*f**2*r - 648*Dd**2*f**2*s**2 + 972*Dd**2*f**2*s - 324*Dd**2*f**2 - 2016*Dd**2*f*g2*r**2 - 4032*Dd**2*f*g2*r*s + 3024*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 3024*Dd**2*f*g2*s - 1008*Dd**2*f*g2))/(35*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**2*k1**2*k2**4*(-3*D1*(84*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(f**2*(6*C + 7*K - 17)*(r + s - 1) + f*fd*(120*C - 60)*(2*r + 2*s - 1) - 42*f*(g2 + 4*gd2)*(r + s - 1) - 168*fd*g2*(r + s)) + 12*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) + f*(6*D1*bdd1*(f*(10*C - 5) - 14*g2)*(r + s - 1)**2 + D1*(f*(fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*gd2*(r + s - 1)**2) - 14*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + 7*b1**2*(D1**2*(9*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)**2*(18*K*fdd + fd*(9*K - 10))) + D1*(Dd*(-36*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(9*K - 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-3*D1**2*(f*(fd*(6*C + 7*K - 17)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*(r + s - 1)**2*(14*K*bdd1 - 7*gd2 - 14*gdd2)) + (6*r + 6*s)*(fd**2*(20*C - 10)*(r + s - 1) - 7*fd*(g2*(r + s) + 4*gd2*(r + s - 1)) - 14*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-36*K*fd*(r + s) + 9*f**2*(r + s - 1) - f*(9*K - 10)*(r + s - 1)) - 36*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(f**2*(6*C + 7*K - 17)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*f*(fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 28*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 168*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 6*Ddd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*f*(f*(10*C - 5) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(35*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**2*k1**2*k2**2*st**6*(132*C*D1**2*f**2*fd*r*s - 44*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 132*C*D1**2*f**2*fd*s + 44*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r*s + 22*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 66*C*D1**2*f**2*fdd*s - 22*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r*s + 44*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 132*C*D1**2*f*fd**2*s - 22*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r*s - 44*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 176*C*D1*Dd*f**3*s + 44*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r*s + 154*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 528*C*D1*Dd*f**2*fd*s - 110*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r*s + 22*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 88*C*D1*Ddd*f**3*s - 22*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r*s + 66*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 264*C*Dd**2*f**3*s - 44*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 672*D1**2*f**3*fd*r*s - 168*D1**2*f**3*fd*r + 672*D1**2*f**3*fd*s**2 - 672*D1**2*f**3*fd*s + 168*D1**2*f**3*fd - 336*D1**2*f**3*fdd*r*s + 84*D1**2*f**3*fdd*r - 336*D1**2*f**3*fdd*s**2 + 336*D1**2*f**3*fdd*s - 84*D1**2*f**3*fdd - 1008*D1**2*f**2*fd**2*r*s + 252*D1**2*f**2*fd**2*r - 1008*D1**2*f**2*fd**2*s**2 + 1008*D1**2*f**2*fd**2*s - 168*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r*s + 44*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 132*D1**2*f**2*fd*s - 44*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r*s - 22*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 66*D1**2*f**2*fdd*s + 22*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 132*D1**2*f*fd**2*r*s - 44*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 132*D1**2*f*fd**2*s + 22*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 672*D1*Dd*f**4*r*s - 168*D1*Dd*f**4*r + 672*D1*Dd*f**4*s**2 - 672*D1*Dd*f**4*s + 168*D1*Dd*f**4 - 2688*D1*Dd*f**3*fd*r*s + 672*D1*Dd*f**3*fd*r - 2688*D1*Dd*f**3*fd*s**2 + 2688*D1*Dd*f**3*fd*s - 504*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 176*D1*Dd*f**3*s - 44*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r*s - 154*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 528*D1*Dd*f**2*fd*s + 110*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 336*D1*Ddd*f**4*r*s + 84*D1*Ddd*f**4*r - 336*D1*Ddd*f**4*s**2 + 336*D1*Ddd*f**4*s - 84*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 88*D1*Ddd*f**3*s + 22*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 1008*Dd**2*f**4*r*s + 252*Dd**2*f**4*r - 1008*Dd**2*f**4*s**2 + 1008*Dd**2*f**4*s - 168*Dd**2*f**4 + 264*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 264*Dd**2*f**3*s + 44*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**6) - 2*D1**2*Pk2*Pk3*ct**2*k1**2*k2**2*st**4*(-12*C*D1**2*bdd1*f**2*r**2 - 48*C*D1**2*bdd1*f**2*r*s + 24*C*D1**2*bdd1*f**2*r - 36*C*D1**2*bdd1*f**2*s**2 + 48*C*D1**2*bdd1*f**2*s - 24*C*D1**2*bdd1*f**2 - 846*C*D1**2*f**2*fd*r**2 + 12*C*D1**2*f**2*fd*r*s + 560*C*D1**2*f**2*fd*r + 858*C*D1**2*f**2*fd*s**2 - 576*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd + 594*C*D1**2*f**2*fdd*r**2 + 156*C*D1**2*f**2*fdd*r*s - 448*C*D1**2*f**2*fdd*r - 438*C*D1**2*f**2*fdd*s**2 + 240*C*D1**2*f**2*fdd*s + 52*C*D1**2*f**2*fdd + 1188*C*D1**2*f*fd**2*r**2 + 312*C*D1**2*f*fd**2*r*s - 896*C*D1**2*f*fd**2*r - 876*C*D1**2*f*fd**2*s**2 + 480*C*D1**2*f*fd**2*s + 52*C*D1**2*f*fd**2 - 1128*C*D1*Dd*f**3*r**2 + 16*C*D1*Dd*f**3*r*s + 1124*C*D1*Dd*f**3*r + 1144*C*D1*Dd*f**3*s**2 - 580*C*D1*Dd*f**3*s - 278*C*D1*Dd*f**3 + 4752*C*D1*Dd*f**2*fd*r**2 + 1248*C*D1*Dd*f**2*fd*r*s - 4324*C*D1*Dd*f**2*fd*r - 3504*C*D1*Dd*f**2*fd*s**2 + 1524*C*D1*Dd*f**2*fd*s + 656*C*D1*Dd*f**2*fd + 792*C*D1*Ddd*f**3*r**2 + 208*C*D1*Ddd*f**3*r*s - 844*C*D1*Ddd*f**3*r - 584*C*D1*Ddd*f**3*s**2 + 188*C*D1*Ddd*f**3*s + 250*C*D1*Ddd*f**3 + 2376*C*Dd**2*f**3*r**2 + 624*C*Dd**2*f**3*r*s - 2532*C*Dd**2*f**3*r - 1752*C*Dd**2*f**3*s**2 + 564*C*Dd**2*f**3*s + 500*C*Dd**2*f**3 + 285*D1**2*K*bdd1*f**2*r**2 + 174*D1**2*K*bdd1*f**2*r*s - 570*D1**2*K*bdd1*f**2*r - 111*D1**2*K*bdd1*f**2*s**2 - 174*D1**2*K*bdd1*f**2*s + 285*D1**2*K*bdd1*f**2 - 84*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1) - 150*D1**2*bdd1*f**3*r**2 - 120*D1**2*bdd1*f**3*r*s + 300*D1**2*bdd1*f**3*r + 30*D1**2*bdd1*f**3*s**2 + 120*D1**2*bdd1*f**3*s - 180*D1**2*bdd1*f**3 - 393*D1**2*bdd1*f**2*r**2 - 546*D1**2*bdd1*f**2*r*s + 786*D1**2*bdd1*f**2*r - 153*D1**2*bdd1*f**2*s**2 + 546*D1**2*bdd1*f**2*s - 381*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*g2*r**2 + 336*D1**2*bdd1*f*g2*r*s - 168*D1**2*bdd1*f*g2*r + 252*D1**2*bdd1*f*g2*s**2 - 336*D1**2*bdd1*f*g2*s + 168*D1**2*bdd1*f*g2 - 1260*D1**2*f**3*fd*r**2 - 2400*D1**2*f**3*fd*r*s + 1860*D1**2*f**3*fd*r - 1140*D1**2*f**3*fd*s**2 + 1770*D1**2*f**3*fd*s - 915*D1**2*f**3*fd + 1380*D1**2*f**3*fdd*r**2 + 2160*D1**2*f**3*fdd*r*s - 1920*D1**2*f**3*fdd*r + 780*D1**2*f**3*fdd*s**2 - 1470*D1**2*f**3*fdd*s + 885*D1**2*f**3*fdd + 4140*D1**2*f**2*fd**2*r**2 + 6480*D1**2*f**2*fd**2*r*s - 5760*D1**2*f**2*fd**2*r + 2340*D1**2*f**2*fd**2*s**2 - 4410*D1**2*f**2*fd**2*s + 1770*D1**2*f**2*fd**2 + 1050*D1**2*f**2*fd*r**2 + 720*D1**2*f**2*fd*r*s - 940*D1**2*f**2*fd*r - 330*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 240*D1**2*f**2*fd - 714*D1**2*f**2*fdd*r**2 - 576*D1**2*f**2*fdd*r*s + 668*D1**2*f**2*fdd*r + 138*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 192*D1**2*f**2*fdd + 678*D1**2*f**2*gd2*r**2 + 276*D1**2*f**2*gd2*r*s - 1356*D1**2*f**2*gd2*r - 402*D1**2*f**2*gd2*s**2 - 276*D1**2*f**2*gd2*s + 678*D1**2*f**2*gd2 - 570*D1**2*f**2*gdd2*r**2 - 348*D1**2*f**2*gdd2*r*s + 1140*D1**2*f**2*gdd2*r + 222*D1**2*f**2*gdd2*s**2 + 348*D1**2*f**2*gdd2*s - 570*D1**2*f**2*gdd2 - 1428*D1**2*f*fd**2*r**2 - 1152*D1**2*f*fd**2*r*s + 1336*D1**2*f*fd**2*r + 276*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 192*D1**2*f*fd**2 + 1356*D1**2*f*fd*g2*r**2 + 552*D1**2*f*fd*g2*r*s - 276*D1**2*f*fd*g2*r - 804*D1**2*f*fd*g2*s**2 + 804*D1**2*f*fd*g2*s - 402*D1**2*f*fd*g2 - 2280*D1**2*f*fd*gd2*r**2 - 1392*D1**2*f*fd*gd2*r*s + 2628*D1**2*f*fd*gd2*r + 888*D1**2*f*fd*gd2*s**2 + 252*D1**2*f*fd*gd2*s - 348*D1**2*f*fd*gd2 - 1140*D1**2*f*fdd*g2*r**2 - 696*D1**2*f*fdd*g2*r*s + 348*D1**2*f*fdd*g2*r + 444*D1**2*f*fdd*g2*s**2 - 444*D1**2*f*fdd*g2*s + 222*D1**2*f*fdd*g2 - 1140*D1**2*fd**2*g2*r**2 - 696*D1**2*fd**2*g2*r*s + 348*D1**2*fd**2*g2*r + 444*D1**2*fd**2*g2*s**2 - 444*D1**2*fd**2*g2*s - 1260*D1*Dd*f**4*r**2 - 2400*D1*Dd*f**4*r*s + 1860*D1*Dd*f**4*r - 1140*D1*Dd*f**4*s**2 + 1770*D1*Dd*f**4*s - 915*D1*Dd*f**4 + 11040*D1*Dd*f**3*fd*r**2 + 17280*D1*Dd*f**3*fd*r*s - 15360*D1*Dd*f**3*fd*r + 6240*D1*Dd*f**3*fd*s**2 - 11760*D1*Dd*f**3*fd*s + 5310*D1*Dd*f**3*fd + 1400*D1*Dd*f**3*r**2 + 960*D1*Dd*f**3*r*s - 1640*D1*Dd*f**3*r - 440*D1*Dd*f**3*s**2 - 260*D1*Dd*f**3*s + 590*D1*Dd*f**3 - 5712*D1*Dd*f**2*fd*r**2 - 4608*D1*Dd*f**2*fd*r*s + 6104*D1*Dd*f**2*fd*r + 1104*D1*Dd*f**2*fd*s**2 + 1276*D1*Dd*f**2*fd*s - 1436*D1*Dd*f**2*fd + 2712*D1*Dd*f**2*g2*r**2 + 1104*D1*Dd*f**2*g2*r*s - 2988*D1*Dd*f**2*g2*r - 1608*D1*Dd*f**2*g2*s**2 + 252*D1*Dd*f**2*g2*s + 954*D1*Dd*f**2*g2 - 4560*D1*Dd*f**2*gd2*r**2 - 2784*D1*Dd*f**2*gd2*r*s + 7188*D1*Dd*f**2*gd2*r + 1776*D1*Dd*f**2*gd2*s**2 + 1644*D1*Dd*f**2*gd2*s - 2628*D1*Dd*f**2*gd2 - 9120*D1*Dd*f*fd*g2*r**2 - 5568*D1*Dd*f*fd*g2*r*s + 6648*D1*Dd*f*fd*g2*r + 3552*D1*Dd*f*fd*g2*s**2 - 1272*D1*Dd*f*fd*g2*s - 252*D1*Dd*f*fd*g2 + 1380*D1*Ddd*f**4*r**2 + 2160*D1*Ddd*f**4*r*s - 1920*D1*Ddd*f**4*r + 780*D1*Ddd*f**4*s**2 - 1470*D1*Ddd*f**4*s + 885*D1*Ddd*f**4 - 952*D1*Ddd*f**3*r**2 - 768*D1*Ddd*f**3*r*s + 1144*D1*Ddd*f**3*r + 184*D1*Ddd*f**3*s**2 + 292*D1*Ddd*f**3*s - 430*D1*Ddd*f**3 - 2280*D1*Ddd*f**2*g2*r**2 - 1392*D1*Ddd*f**2*g2*r*s + 2628*D1*Ddd*f**2*g2*r + 888*D1*Ddd*f**2*g2*s**2 + 252*D1*Ddd*f**2*g2*s - 918*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(20*f**3*(4*r**2 + r*(3*s - 8) - s**2 - 3*s + 5) + f**2*(8*C*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 2) - 113*K*r**2 - 46*K*r*s + 226*K*r + 67*K*s**2 + 46*K*s - 113*K - 20*fd*(15*r**2 + 12*r*s - 22*r - 3*s**2 - 7*s + 6) + 157*r**2 + 210*r*s - 314*r + 53*s**2 - 210*s + 149) - 2*f*(fd*(4*C*(2*r**2 + r*(8*s - 4) + 6*s**2 - 7*s + 1) + K*(-190*r**2 - 116*r*s + 219*r + 74*s**2 + 21*s - 29) + 262*r**2 + 364*r*s - 353*r + 102*s**2 - 233*s + 95) + 28*g2*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 2) - 28*gd2*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1)) + 56*fd*g2*(r**2 + r*(4*s - 2) + s*(3*s - 3))) - 2*Dd*f*(10*f**2*(20*r**2 + 16*r*(s - 2) - 4*s**2 - 11*s + 12) + f*(4*C*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4) + K*(-380*r**2 - 232*r*s + 599*r + 148*s**2 + 137*s - 219) + 524*r**2 + 728*r*s - 877*r + 204*s**2 - 597*s + 353) - 28*g2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4))) + 4140*Dd**2*f**4*r**2 + 6480*Dd**2*f**4*r*s - 5760*Dd**2*f**4*r + 2340*Dd**2*f**4*s**2 - 4410*Dd**2*f**4*s + 1770*Dd**2*f**4 - 2856*Dd**2*f**3*r**2 - 2304*Dd**2*f**3*r*s + 3432*Dd**2*f**3*r + 552*Dd**2*f**3*s**2 + 876*Dd**2*f**3*s - 860*Dd**2*f**3 - 6840*Dd**2*f**2*g2*r**2 - 4176*Dd**2*f**2*g2*r*s + 7884*Dd**2*f**2*g2*r + 2664*Dd**2*f**2*g2*s**2 + 756*Dd**2*f**2*g2*s - 1836*Dd**2*f**2*g2 + 42*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + D1*(2*Dd*(f*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 14*s + 5) - fd*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3)) - Ddd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 14*s + 5)) - 2*Dd**2*f*(6*r**2 + 12*r*(2*s - 1) + 18*s**2 - 21*s + 5)) + 3*b1*(16*C*D1**2*f*fd*r**2 + 64*C*D1**2*f*fd*r*s - 32*C*D1**2*f*fd*r + 48*C*D1**2*f*fd*s**2 - 48*C*D1**2*f*fd*s + 16*C*D1**2*f*fd - 8*C*D1**2*f*fdd*r**2 - 32*C*D1**2*f*fdd*r*s + 16*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 + 24*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd - 8*C*D1**2*fd**2*r**2 - 32*C*D1**2*fd**2*r*s + 16*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 + 24*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r**2 + 128*C*D1*Dd*f**2*r*s - 64*C*D1*Dd*f**2*r + 96*C*D1*Dd*f**2*s**2 - 112*C*D1*Dd*f**2*s + 40*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r**2 - 256*C*D1*Dd*f*fd*r*s + 128*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 208*C*D1*Dd*f*fd*s - 56*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 - 64*C*D1*Ddd*f**2*r*s + 32*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 56*C*D1*Ddd*f**2*s - 20*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 - 192*C*Dd**2*f**2*r*s + 96*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 168*C*Dd**2*f**2*s - 40*C*Dd**2*f**2 - 226*D1**2*K*f*fd*r**2 - 92*D1**2*K*f*fd*r*s + 46*D1**2*K*f*fd*r + 134*D1**2*K*f*fd*s**2 - 134*D1**2*K*f*fd*s + 67*D1**2*K*f*fd + 190*D1**2*K*f*fdd*r**2 + 116*D1**2*K*f*fdd*r*s - 58*D1**2*K*f*fdd*r - 74*D1**2*K*f*fdd*s**2 + 74*D1**2*K*f*fdd*s - 37*D1**2*K*f*fdd + 190*D1**2*K*fd**2*r**2 + 116*D1**2*K*fd**2*r*s - 58*D1**2*K*fd**2*r - 74*D1**2*K*fd**2*s**2 + 74*D1**2*K*fd**2*s - 14*D1**2*bdd1*f*(K - 1)*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) + 240*D1**2*f**2*fd*r**2 + 180*D1**2*f**2*fd*r*s - 220*D1**2*f**2*fd*r - 60*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 40*D1**2*f**2*fd - 150*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r + 30*D1**2*f**2*fdd*s**2 + 20*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd - 300*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r + 60*D1**2*f*fd**2*s**2 + 40*D1**2*f*fd**2*s - 60*D1**2*f*fd**2 + 314*D1**2*f*fd*r**2 + 420*D1**2*f*fd*r*s - 210*D1**2*f*fd*r + 106*D1**2*f*fd*s**2 - 106*D1**2*f*fd*s + 61*D1**2*f*fd - 262*D1**2*f*fdd*r**2 - 364*D1**2*f*fdd*r*s + 182*D1**2*f*fdd*r - 102*D1**2*f*fdd*s**2 + 102*D1**2*f*fdd*s - 55*D1**2*f*fdd - 56*D1**2*f*gd2*r**2 - 224*D1**2*f*gd2*r*s + 112*D1**2*f*gd2*r - 168*D1**2*f*gd2*s**2 + 224*D1**2*f*gd2*s - 56*D1**2*f*gd2 + 28*D1**2*f*gdd2*r**2 + 112*D1**2*f*gdd2*r*s - 56*D1**2*f*gdd2*r + 84*D1**2*f*gdd2*s**2 - 112*D1**2*f*gdd2*s + 28*D1**2*f*gdd2 - 262*D1**2*fd**2*r**2 - 364*D1**2*fd**2*r*s + 182*D1**2*fd**2*r - 102*D1**2*fd**2*s**2 + 102*D1**2*fd**2*s + 8*D1**2*fd**2 - 56*D1**2*fd*g2*r**2 - 224*D1**2*fd*g2*r*s + 112*D1**2*fd*g2*r - 168*D1**2*fd*g2*s**2 + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 + 56*D1**2*fd*gd2*r**2 + 224*D1**2*fd*gd2*r*s - 112*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 + 28*D1**2*fdd*g2*r**2 + 112*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r + 84*D1**2*fdd*g2*s**2 - 56*D1**2*fdd*g2*s + 28*D1**2*fdd*g2 - 452*D1*Dd*K*f**2*r**2 - 184*D1*Dd*K*f**2*r*s + 498*D1*Dd*K*f**2*r + 268*D1*Dd*K*f**2*s**2 - 42*D1*Dd*K*f**2*s - 159*D1*Dd*K*f**2 + 1520*D1*Dd*K*f*fd*r**2 + 928*D1*Dd*K*f*fd*r*s - 1108*D1*Dd*K*f*fd*r - 592*D1*Dd*K*f*fd*s**2 + 212*D1*Dd*K*f*fd*s + 42*D1*Dd*K*f*fd + 320*D1*Dd*f**3*r**2 + 240*D1*Dd*f**3*r*s - 380*D1*Dd*f**3*r - 80*D1*Dd*f**3*s**2 - 80*D1*Dd*f**3*s + 140*D1*Dd*f**3 - 1200*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 1280*D1*Dd*f**2*fd*r + 240*D1*Dd*f**2*fd*s**2 + 260*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd + 628*D1*Dd*f**2*r**2 + 840*D1*Dd*f**2*r*s - 838*D1*Dd*f**2*r + 212*D1*Dd*f**2*s**2 - 526*D1*Dd*f**2*s + 367*D1*Dd*f**2 - 2096*D1*Dd*f*fd*r**2 - 2912*D1*Dd*f*fd*r*s + 2140*D1*Dd*f*fd*r - 816*D1*Dd*f*fd*s**2 + 1340*D1*Dd*f*fd*s - 466*D1*Dd*f*fd - 224*D1*Dd*f*g2*r**2 - 896*D1*Dd*f*g2*r*s + 448*D1*Dd*f*g2*r - 672*D1*Dd*f*g2*s**2 + 784*D1*Dd*f*g2*s - 280*D1*Dd*f*g2 + 224*D1*Dd*f*gd2*r**2 + 896*D1*Dd*f*gd2*r*s - 448*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 840*D1*Dd*f*gd2*s + 224*D1*Dd*f*gd2 + 224*D1*Dd*fd*g2*r**2 + 896*D1*Dd*fd*g2*r*s - 448*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 616*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 + 380*D1*Ddd*K*f**2*r**2 + 232*D1*Ddd*K*f**2*r*s - 438*D1*Ddd*K*f**2*r - 148*D1*Ddd*K*f**2*s**2 - 42*D1*Ddd*K*f**2*s + 153*D1*Ddd*K*f**2 - 200*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 240*D1*Ddd*f**3*r + 40*D1*Ddd*f**3*s**2 + 60*D1*Ddd*f**3*s - 90*D1*Ddd*f**3 - 524*D1*Ddd*f**2*r**2 - 728*D1*Ddd*f**2*r*s + 706*D1*Ddd*f**2*r - 204*D1*Ddd*f**2*s**2 + 466*D1*Ddd*f**2*s - 313*D1*Ddd*f**2 + 112*D1*Ddd*f*g2*r**2 + 448*D1*Ddd*f*g2*r*s - 224*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 392*D1*Ddd*f*g2*s + 140*D1*Ddd*f*g2 + 28*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) - fd*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 6*s + 1)) - 2*Dd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 1140*Dd**2*K*f**2*r**2 + 696*Dd**2*K*f**2*r*s - 1314*Dd**2*K*f**2*r - 444*Dd**2*K*f**2*s**2 - 126*Dd**2*K*f**2*s + 306*Dd**2*K*f**2 - 600*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 720*Dd**2*f**3*r + 120*Dd**2*f**3*s**2 + 180*Dd**2*f**3*s - 180*Dd**2*f**3 - 1572*Dd**2*f**2*r**2 - 2184*Dd**2*f**2*r*s + 2118*Dd**2*f**2*r - 612*Dd**2*f**2*s**2 + 1398*Dd**2*f**2*s - 626*Dd**2*f**2 + 336*Dd**2*f*g2*r**2 + 1344*Dd**2*f*g2*r*s - 672*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1176*Dd**2*f*g2*s + 280*Dd**2*f*g2))/(105*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**2*k1**2*k2**2*st**2*(-238*C*D1**2*bdd1*f**2*r**2 - 236*C*D1**2*bdd1*f**2*r*s + 524*C*D1**2*bdd1*f**2*r + 2*C*D1**2*bdd1*f**2*s**2 + 284*C*D1**2*bdd1*f**2*s - 142*C*D1**2*bdd1*f**2 + 2880*C*D1**2*f**2*fd*r**2 + 7056*C*D1**2*f**2*fd*r*s - 4272*C*D1**2*f**2*fd*r + 4176*C*D1**2*f**2*fd*s**2 - 5136*C*D1**2*f**2*fd*s + 2352*C*D1**2*f**2*fd - 3096*C*D1**2*f**2*fdd*r**2 - 6912*C*D1**2*f**2*fdd*r*s + 4368*C*D1**2*f**2*fdd*r - 3816*C*D1**2*f**2*fdd*s**2 + 4848*C*D1**2*f**2*fdd*s - 2304*C*D1**2*f**2*fdd - 6192*C*D1**2*f*fd**2*r**2 - 13824*C*D1**2*f*fd**2*r*s + 8736*C*D1**2*f*fd**2*r - 7632*C*D1**2*f*fd**2*s**2 + 9696*C*D1**2*f*fd**2*s - 2304*C*D1**2*f*fd**2 + 3840*C*D1*Dd*f**3*r**2 + 9408*C*D1*Dd*f**3*r*s - 6192*C*D1*Dd*f**3*r + 5568*C*D1*Dd*f**3*s**2 - 7488*C*D1*Dd*f**3*s + 3312*C*D1*Dd*f**3 - 24768*C*D1*Dd*f**2*fd*r**2 - 55296*C*D1*Dd*f**2*fd*r*s + 36768*C*D1*Dd*f**2*fd*r - 30528*C*D1*Dd*f**2*fd*s**2 + 40848*C*D1*Dd*f**2*fd*s - 13584*C*D1*Dd*f**2*fd - 4128*C*D1*Ddd*f**3*r**2 - 9216*C*D1*Ddd*f**3*r*s + 6432*C*D1*Ddd*f**3*r - 5088*C*D1*Ddd*f**3*s**2 + 7152*C*D1*Ddd*f**3*s - 3336*C*D1*Ddd*f**3 - 12384*C*Dd**2*f**3*r**2 - 27648*C*Dd**2*f**3*r*s + 19296*C*Dd**2*f**3*r - 15264*C*Dd**2*f**3*s**2 + 21456*C*Dd**2*f**3*s - 6672*C*Dd**2*f**3 - 852*D1**2*K*bdd1*f**2*r**2 - 2208*D1**2*K*bdd1*f**2*r*s + 1704*D1**2*K*bdd1*f**2*r - 1356*D1**2*K*bdd1*f**2*s**2 + 2208*D1**2*K*bdd1*f**2*s - 852*D1**2*K*bdd1*f**2 + 360*D1**2*b2*f*fd*r**2 + 720*D1**2*b2*f*fd*r*s - 360*D1**2*b2*f*fd*r + 360*D1**2*b2*f*fd*s**2 - 360*D1**2*b2*f*fd*s + 180*D1**2*b2*f*fd - 432*D1**2*b2*f*fdd*r**2 - 864*D1**2*b2*f*fdd*r*s + 432*D1**2*b2*f*fdd*r - 432*D1**2*b2*f*fdd*s**2 + 432*D1**2*b2*f*fdd*s - 216*D1**2*b2*f*fdd - 432*D1**2*b2*fd**2*r**2 - 864*D1**2*b2*fd**2*r*s + 432*D1**2*b2*fd**2*r - 432*D1**2*b2*fd**2*s**2 + 432*D1**2*b2*fd**2*s + 2*D1**2*bd1**2*(r + s - 1)*(72*f**2*(r + s - 2) + 7*f*(4*C*r + 4*C*s + K*(-37*r - 13*s + 49) + 69*r + 45*s - 73) - 140*g2*(r + s)) + 180*D1**2*bdd1*f**3*r**2 + 684*D1**2*bdd1*f**3*r*s - 612*D1**2*bdd1*f**3*r + 504*D1**2*bdd1*f**3*s**2 - 936*D1**2*bdd1*f**3*s + 432*D1**2*bdd1*f**3 + 664*D1**2*bdd1*f**2*r**2 + 1340*D1**2*bdd1*f**2*r*s - 1304*D1**2*bdd1*f**2*r + 676*D1**2*bdd1*f**2*s**2 - 1316*D1**2*bdd1*f**2*s + 532*D1**2*bdd1*f**2 + 518*D1**2*bdd1*f*g2*r**2 + 700*D1**2*bdd1*f*g2*r*s - 1372*D1**2*bdd1*f*g2*r + 182*D1**2*bdd1*f*g2*s**2 - 1036*D1**2*bdd1*f*g2*s + 518*D1**2*bdd1*f*g2 - 216*D1**2*bdd2*f**2*r**2 - 432*D1**2*bdd2*f**2*r*s + 432*D1**2*bdd2*f**2*r - 216*D1**2*bdd2*f**2*s**2 + 432*D1**2*bdd2*f**2*s - 216*D1**2*bdd2*f**2 - 1746*D1**2*f**2*fd*r**2 - 4572*D1**2*f**2*fd*r*s + 2688*D1**2*f**2*fd*r - 2826*D1**2*f**2*fd*s**2 + 3408*D1**2*f**2*fd*s - 1524*D1**2*f**2*fd + 2142*D1**2*f**2*fdd*r**2 + 4824*D1**2*f**2*fdd*r*s - 3036*D1**2*f**2*fdd*r + 2682*D1**2*f**2*fdd*s**2 - 3396*D1**2*f**2*fdd*s + 1608*D1**2*f**2*fdd - 1056*D1**2*f**2*gd2*r**2 - 3792*D1**2*f**2*gd2*r*s + 2112*D1**2*f**2*gd2*r - 2736*D1**2*f**2*gd2*s**2 + 3792*D1**2*f**2*gd2*s - 1056*D1**2*f**2*gd2 + 1704*D1**2*f**2*gdd2*r**2 + 4416*D1**2*f**2*gdd2*r*s - 3408*D1**2*f**2*gdd2*r + 2712*D1**2*f**2*gdd2*s**2 - 4416*D1**2*f**2*gdd2*s + 1704*D1**2*f**2*gdd2 + 4284*D1**2*f*fd**2*r**2 + 9648*D1**2*f*fd**2*r*s - 6072*D1**2*f*fd**2*r + 5364*D1**2*f*fd**2*s**2 - 6792*D1**2*f*fd**2*s + 1608*D1**2*f*fd**2 - 2112*D1**2*f*fd*g2*r**2 - 7584*D1**2*f*fd*g2*r*s + 3792*D1**2*f*fd*g2*r - 5472*D1**2*f*fd*g2*s**2 + 5472*D1**2*f*fd*g2*s - 2736*D1**2*f*fd*g2 + 6816*D1**2*f*fd*gd2*r**2 + 17664*D1**2*f*fd*gd2*r*s - 11232*D1**2*f*fd*gd2*r + 10848*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4416*D1**2*f*fd*gd2 + 3408*D1**2*f*fdd*g2*r**2 + 8832*D1**2*f*fdd*g2*r*s - 4416*D1**2*f*fdd*g2*r + 5424*D1**2*f*fdd*g2*s**2 - 5424*D1**2*f*fdd*g2*s + 2712*D1**2*f*fdd*g2 + 3408*D1**2*fd**2*g2*r**2 + 8832*D1**2*fd**2*g2*r*s - 4416*D1**2*fd**2*g2*r + 5424*D1**2*fd**2*g2*s**2 - 5424*D1**2*fd**2*g2*s + 720*D1*Dd*b2*f**2*r**2 + 1440*D1*Dd*b2*f**2*r*s - 1080*D1*Dd*b2*f**2*r + 720*D1*Dd*b2*f**2*s**2 - 1080*D1*Dd*b2*f**2*s + 540*D1*Dd*b2*f**2 - 3456*D1*Dd*b2*f*fd*r**2 - 6912*D1*Dd*b2*f*fd*r*s + 4320*D1*Dd*b2*f*fd*r - 3456*D1*Dd*b2*f*fd*s**2 + 4320*D1*Dd*b2*f*fd*s - 1296*D1*Dd*b2*f*fd - 2328*D1*Dd*f**3*r**2 - 6096*D1*Dd*f**3*r*s + 3852*D1*Dd*f**3*r - 3768*D1*Dd*f**3*s**2 + 4932*D1*Dd*f**3*s - 2106*D1*Dd*f**3 + 17136*D1*Dd*f**2*fd*r**2 + 38592*D1*Dd*f**2*fd*r*s - 25536*D1*Dd*f**2*fd*r + 21456*D1*Dd*f**2*fd*s**2 - 28596*D1*Dd*f**2*fd*s + 9468*D1*Dd*f**2*fd - 4224*D1*Dd*f**2*g2*r**2 - 15168*D1*Dd*f**2*g2*r*s + 8016*D1*Dd*f**2*g2*r - 10944*D1*Dd*f**2*g2*s**2 + 13056*D1*Dd*f**2*g2*s - 4848*D1*Dd*f**2*g2 + 13632*D1*Dd*f**2*gd2*r**2 + 35328*D1*Dd*f**2*gd2*r*s - 24864*D1*Dd*f**2*gd2*r + 21696*D1*Dd*f**2*gd2*s**2 - 31920*D1*Dd*f**2*gd2*s + 11232*D1*Dd*f**2*gd2 + 27264*D1*Dd*f*fd*g2*r**2 + 70656*D1*Dd*f*fd*g2*r*s - 40128*D1*Dd*f*fd*g2*r + 43392*D1*Dd*f*fd*g2*s**2 - 50208*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 - 864*D1*Ddd*b2*f**2*r**2 - 1728*D1*Ddd*b2*f**2*r*s + 1296*D1*Ddd*b2*f**2*r - 864*D1*Ddd*b2*f**2*s**2 + 1296*D1*Ddd*b2*f**2*s - 648*D1*Ddd*b2*f**2 + 2856*D1*Ddd*f**3*r**2 + 6432*D1*Ddd*f**3*r*s - 4464*D1*Ddd*f**3*r + 3576*D1*Ddd*f**3*s**2 - 5004*D1*Ddd*f**3*s + 2322*D1*Ddd*f**3 + 6816*D1*Ddd*f**2*g2*r**2 + 17664*D1*Ddd*f**2*g2*r*s - 11232*D1*Ddd*f**2*g2*r + 10848*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 6120*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(-18*f**3*(r*(13*s - 7) + 13*s**2 - 20*s + 6) + f**2*(C*(175*r**2 + 2*r*(97*s - 171) + 19*s**2 - 186*s + 93) + 12*K*(22*r**2 + 79*r*s - 44*r + 57*s**2 - 79*s + 22) + 18*fd*(30*r**2 + r*(114*s - 73) + 84*s**2 - 118*s + 36) - 258*r**2 - 612*r*s + 464*r - 354*s**2 + 560*s - 154) + f*(-2*fd*(C*(238*r**2 + r*(236*s - 309) - 2*s**2 - 129*s + 131) + 6*K*(142*r**2 + 368*r*s - 234*r + 226*s**2 - 297*s + 92) - 664*r**2 - 1340*r*s + 993*r - 676*s**2 + 1002*s - 389) - 7*g2*(69*r**2 + 2*r*(55*s - 53) + 41*s**2 - 78*s + 39) + 14*gd2*(37*r**2 + r*(50*s - 86) + 13*s**2 - 62*s + 49)) + 14*fd*g2*(37*r**2 + 25*r*(2*s - 1) + s*(13*s - 13))) + 2*Dd*f*(9*f**2*(40*r**2 + 152*r*s - 107*r + 112*s**2 - 170*s + 60) + f*(C*(-476*r**2 + r*(821 - 472*s) + 4*s**2 + 401*s - 333) - 6*K*(284*r**2 + 736*r*s - 518*r + 452*s**2 - 665*s + 234) + 1328*r**2 + 2680*r*s - 2303*r + 1352*s**2 - 2324*s + 981) + 7*g2*(148*r**2 + 5*r*(40*s - 59) + 52*s**2 - 211*s + 135))) + 36*D1*bd2*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 2592*Dd**2*b2*f**2*r**2 - 5184*Dd**2*b2*f**2*r*s + 3888*Dd**2*b2*f**2*r - 2592*Dd**2*b2*f**2*s**2 + 3888*Dd**2*b2*f**2*s - 1296*Dd**2*b2*f**2 + 8568*Dd**2*f**3*r**2 + 19296*Dd**2*f**3*r*s - 13392*Dd**2*f**3*r + 10728*Dd**2*f**3*s**2 - 15012*Dd**2*f**3*s + 4644*Dd**2*f**3 + 20448*Dd**2*f**2*g2*r**2 + 52992*Dd**2*f**2*g2*r*s - 33696*Dd**2*f**2*g2*r + 32544*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 12240*Dd**2*f**2*g2 - 70*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-56*C*D1**2*fd*r**2 - 112*C*D1**2*fd*r*s + 112*C*D1**2*fd*r - 56*C*D1**2*fd*s**2 + 112*C*D1**2*fd*s - 56*C*D1**2*fd + 28*C*D1**2*fdd*r**2 + 56*C*D1**2*fdd*r*s - 56*C*D1**2*fdd*r + 28*C*D1**2*fdd*s**2 - 56*C*D1**2*fdd*s + 28*C*D1**2*fdd - 224*C*D1*Dd*f*r**2 - 448*C*D1*Dd*f*r*s + 336*C*D1*Dd*f*r - 224*C*D1*Dd*f*s**2 + 336*C*D1*Dd*f*s - 168*C*D1*Dd*f + 224*C*D1*Dd*fd*r**2 + 448*C*D1*Dd*fd*r*s - 392*C*D1*Dd*fd*r + 224*C*D1*Dd*fd*s**2 - 392*C*D1*Dd*fd*s + 168*C*D1*Dd*fd + 112*C*D1*Ddd*f*r**2 + 224*C*D1*Ddd*f*r*s - 168*C*D1*Ddd*f*r + 112*C*D1*Ddd*f*s**2 - 168*C*D1*Ddd*f*s + 84*C*D1*Ddd*f + 336*C*Dd**2*f*r**2 + 672*C*Dd**2*f*r*s - 504*C*Dd**2*f*r + 336*C*Dd**2*f*s**2 - 504*C*Dd**2*f*s + 168*C*Dd**2*f + 483*D1**2*K*fd*r**2 + 770*D1**2*K*fd*r*s - 28*D1**2*K*fd*r + 287*D1**2*K*fd*s**2 - 28*D1**2*K*fd*s + 14*D1**2*K*fd - 259*D1**2*K*fdd*r**2 - 350*D1**2*K*fdd*r*s - 336*D1**2*K*fdd*r - 91*D1**2*K*fdd*s**2 - 336*D1**2*K*fdd*s + 168*D1**2*K*fdd + 70*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 288*D1**2*f*fd*r**2 - 576*D1**2*f*fd*r*s + 168*D1**2*f*fd*r - 288*D1**2*f*fd*s**2 + 168*D1**2*f*fd*s - 84*D1**2*f*fd + 144*D1**2*f*fdd*r**2 + 288*D1**2*f*fdd*r*s + 144*D1**2*f*fdd*s**2 + 144*D1**2*fd**2*r**2 + 288*D1**2*fd**2*r*s + 144*D1**2*fd**2*s**2 - 144*D1**2*fd**2 - 651*D1**2*fd*r**2 - 1106*D1**2*fd*r*s - 28*D1**2*fd*r - 455*D1**2*fd*s**2 - 28*D1**2*fd*s + 14*D1**2*fd + 483*D1**2*fdd*r**2 + 798*D1**2*fdd*r*s + 224*D1**2*fdd*r + 315*D1**2*fdd*s**2 + 224*D1**2*fdd*s - 112*D1**2*fdd + 280*D1**2*gd2*r**2 + 560*D1**2*gd2*r*s - 560*D1**2*gd2*r + 280*D1**2*gd2*s**2 - 560*D1**2*gd2*s + 280*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 + 1932*D1*Dd*K*f*r**2 + 3080*D1*Dd*K*f*r*s - 2702*D1*Dd*K*f*r + 1148*D1*Dd*K*f*s**2 - 2114*D1*Dd*K*f*s + 1253*D1*Dd*K*f - 2072*D1*Dd*K*fd*r**2 - 2800*D1*Dd*K*fd*r*s + 42*D1*Dd*K*fd*r - 728*D1*Dd*K*fd*s**2 - 462*D1*Dd*K*fd*s + 1008*D1*Dd*K*fd - 576*D1*Dd*f**2*r**2 - 1152*D1*Dd*f**2*r*s + 864*D1*Dd*f**2*r - 576*D1*Dd*f**2*s**2 + 864*D1*Dd*f**2*s - 432*D1*Dd*f**2 + 1152*D1*Dd*f*fd*r**2 + 2304*D1*Dd*f*fd*r*s - 864*D1*Dd*f*fd*r + 1152*D1*Dd*f*fd*s**2 - 864*D1*Dd*f*fd*s - 2604*D1*Dd*f*r**2 - 4424*D1*Dd*f*r*s + 3710*D1*Dd*f*r - 1820*D1*Dd*f*s**2 + 3122*D1*Dd*f*s - 1757*D1*Dd*f + 3864*D1*Dd*fd*r**2 + 6384*D1*Dd*fd*r*s - 1834*D1*Dd*fd*r + 2520*D1*Dd*fd*s**2 - 1330*D1*Dd*fd*s - 672*D1*Dd*fd + 1120*D1*Dd*g2*r**2 + 2240*D1*Dd*g2*r*s - 1680*D1*Dd*g2*r + 1120*D1*Dd*g2*s**2 - 1680*D1*Dd*g2*s + 840*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 - 1036*D1*Ddd*K*f*r**2 - 1400*D1*Ddd*K*f*r*s + 1386*D1*Ddd*K*f*r - 364*D1*Ddd*K*f*s**2 + 882*D1*Ddd*K*f*s - 609*D1*Ddd*K*f + 288*D1*Ddd*f**2*r**2 + 576*D1*Ddd*f**2*r*s - 432*D1*Ddd*f**2*r + 288*D1*Ddd*f**2*s**2 - 432*D1*Ddd*f**2*s + 216*D1*Ddd*f**2 + 1932*D1*Ddd*f*r**2 + 3192*D1*Ddd*f*r*s - 2730*D1*Ddd*f*r + 1260*D1*Ddd*f*s**2 - 2226*D1*Ddd*f*s + 1281*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 - 140*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 3108*Dd**2*K*f*r**2 - 4200*Dd**2*K*f*r*s + 4158*Dd**2*K*f*r - 1092*Dd**2*K*f*s**2 + 2646*Dd**2*K*f*s - 1218*Dd**2*K*f + 864*Dd**2*f**2*r**2 + 1728*Dd**2*f**2*r*s - 1296*Dd**2*f**2*r + 864*Dd**2*f**2*s**2 - 1296*Dd**2*f**2*s + 432*Dd**2*f**2 + 5796*Dd**2*f*r**2 + 9576*Dd**2*f*r*s - 8190*Dd**2*f*r + 3780*Dd**2*f*s**2 - 6678*Dd**2*f*s + 2562*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) + 2*b1*(350*C*D1**2*f*fd*r**2 + 388*C*D1**2*f*fd*r*s - 202*C*D1**2*f*fd*r + 38*C*D1**2*f*fd*s**2 - 46*C*D1**2*f*fd*s + 101*C*D1**2*f*fd - 238*C*D1**2*f*fdd*r**2 - 236*C*D1**2*f*fdd*r*s + 94*C*D1**2*f*fdd*r + 2*C*D1**2*f*fdd*s**2 - 26*C*D1**2*f*fdd*s - 47*C*D1**2*f*fdd - 238*C*D1**2*fd**2*r**2 - 236*C*D1**2*fd**2*r*s + 94*C*D1**2*fd**2*r + 2*C*D1**2*fd**2*s**2 - 26*C*D1**2*fd**2*s + 144*C*D1**2*fd**2 + 700*C*D1*Dd*f**2*r**2 + 776*C*D1*Dd*f**2*r*s - 894*C*D1*Dd*f**2*r + 76*C*D1*Dd*f**2*s**2 - 426*C*D1*Dd*f**2*s + 369*C*D1*Dd*f**2 - 1904*C*D1*Dd*f*fd*r**2 - 1888*C*D1*Dd*f*fd*r*s + 1564*C*D1*Dd*f*fd*r + 16*C*D1*Dd*f*fd*s**2 + 364*C*D1*Dd*f*fd*s - 162*C*D1*Dd*f*fd - 476*C*D1*Ddd*f**2*r**2 - 472*C*D1*Ddd*f**2*r*s + 594*C*D1*Ddd*f**2*r + 4*C*D1*Ddd*f**2*s**2 + 234*C*D1*Ddd*f**2*s - 237*C*D1*Ddd*f**2 - 1428*C*Dd**2*f**2*r**2 - 1416*C*Dd**2*f**2*r*s + 1782*C*Dd**2*f**2*r + 12*C*Dd**2*f**2*s**2 + 702*C*Dd**2*f**2*s - 474*C*Dd**2*f**2 + 528*D1**2*K*f*fd*r**2 + 1896*D1**2*K*f*fd*r*s - 948*D1**2*K*f*fd*r + 1368*D1**2*K*f*fd*s**2 - 1368*D1**2*K*f*fd*s + 684*D1**2*K*f*fd - 852*D1**2*K*f*fdd*r**2 - 2208*D1**2*K*f*fdd*r*s + 1104*D1**2*K*f*fdd*r - 1356*D1**2*K*f*fdd*s**2 + 1356*D1**2*K*f*fdd*s - 678*D1**2*K*f*fdd - 852*D1**2*K*fd**2*r**2 - 2208*D1**2*K*fd**2*r*s + 1104*D1**2*K*fd**2*r - 1356*D1**2*K*fd**2*s**2 + 1356*D1**2*K*fd**2*s + 70*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1**2*bdd1*(36*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + 7*f*(C*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - K*(37*r**2 + 50*r*s - 86*r + 13*s**2 - 62*s + 37) + 69*r**2 + 114*r*s - 142*r + 45*s**2 - 118*s + 65) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 702*D1**2*f**2*fd*r*s + 108*D1**2*f**2*fd*r - 702*D1**2*f**2*fd*s**2 + 576*D1**2*f**2*fd*s - 126*D1**2*f**2*fd + 270*D1**2*f**2*fdd*r**2 + 1026*D1**2*f**2*fdd*r*s - 396*D1**2*f**2*fdd*r + 756*D1**2*f**2*fdd*s**2 - 720*D1**2*f**2*fdd*s + 216*D1**2*f**2*fdd + 540*D1**2*f*fd**2*r**2 + 2052*D1**2*f*fd**2*r*s - 792*D1**2*f*fd**2*r + 1512*D1**2*f*fd**2*s**2 - 1440*D1**2*f*fd**2*s + 216*D1**2*f*fd**2 - 516*D1**2*f*fd*r**2 - 1224*D1**2*f*fd*r*s + 664*D1**2*f*fd*r - 708*D1**2*f*fd*s**2 + 760*D1**2*f*fd*s - 458*D1**2*f*fd + 664*D1**2*f*fdd*r**2 + 1340*D1**2*f*fdd*r*s - 682*D1**2*f*fdd*r + 676*D1**2*f*fdd*s**2 - 688*D1**2*f*fdd*s + 404*D1**2*f*fdd - 483*D1**2*f*gd2*r**2 - 770*D1**2*f*gd2*r*s + 966*D1**2*f*gd2*r - 287*D1**2*f*gd2*s**2 + 770*D1**2*f*gd2*s - 483*D1**2*f*gd2 + 259*D1**2*f*gdd2*r**2 + 350*D1**2*f*gdd2*r*s - 518*D1**2*f*gdd2*r + 91*D1**2*f*gdd2*s**2 - 350*D1**2*f*gdd2*s + 259*D1**2*f*gdd2 + 664*D1**2*fd**2*r**2 + 1340*D1**2*fd**2*r*s - 682*D1**2*fd**2*r + 676*D1**2*fd**2*s**2 - 688*D1**2*fd**2*s - 108*D1**2*fd**2 - 483*D1**2*fd*g2*r**2 - 770*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*r - 287*D1**2*fd*g2*s**2 + 28*D1**2*fd*g2*s - 14*D1**2*fd*g2 + 518*D1**2*fd*gd2*r**2 + 700*D1**2*fd*gd2*r*s - 182*D1**2*fd*gd2*r + 182*D1**2*fd*gd2*s**2 - 14*D1**2*fd*gd2*s - 336*D1**2*fd*gd2 + 259*D1**2*fdd*g2*r**2 + 350*D1**2*fdd*g2*r*s + 336*D1**2*fdd*g2*r + 91*D1**2*fdd*g2*s**2 + 336*D1**2*fdd*g2*s - 168*D1**2*fdd*g2 + 1056*D1*Dd*K*f**2*r**2 + 3792*D1*Dd*K*f**2*r*s - 2004*D1*Dd*K*f**2*r + 2736*D1*Dd*K*f**2*s**2 - 3264*D1*Dd*K*f**2*s + 1212*D1*Dd*K*f**2 - 6816*D1*Dd*K*f*fd*r**2 - 17664*D1*Dd*K*f*fd*r*s + 10032*D1*Dd*K*f*fd*r - 10848*D1*Dd*K*f*fd*s**2 + 12552*D1*Dd*K*f*fd*s - 3564*D1*Dd*K*f*fd - 936*D1*Dd*f**3*r*s + 234*D1*Dd*f**3*r - 936*D1*Dd*f**3*s**2 + 936*D1*Dd*f**3*s - 234*D1*Dd*f**3 + 2160*D1*Dd*f**2*fd*r**2 + 8208*D1*Dd*f**2*fd*r*s - 3690*D1*Dd*f**2*fd*r + 6048*D1*Dd*f**2*fd*s**2 - 6444*D1*Dd*f**2*fd*s + 1512*D1*Dd*f**2*fd - 1032*D1*Dd*f**2*r**2 - 2448*D1*Dd*f**2*r*s + 1644*D1*Dd*f**2*r - 1416*D1*Dd*f**2*s**2 + 1932*D1*Dd*f**2*s - 870*D1*Dd*f**2 + 5312*D1*Dd*f*fd*r**2 + 10720*D1*Dd*f*fd*r*s - 6724*D1*Dd*f*fd*r + 5408*D1*Dd*f*fd*s**2 - 6784*D1*Dd*f*fd*s + 2052*D1*Dd*f*fd - 1932*D1*Dd*f*g2*r**2 - 3080*D1*Dd*f*g2*r*s + 2702*D1*Dd*f*g2*r - 1148*D1*Dd*f*g2*s**2 + 2114*D1*Dd*f*g2*s - 1253*D1*Dd*f*g2 + 2072*D1*Dd*f*gd2*r**2 + 2800*D1*Dd*f*gd2*r*s - 3458*D1*Dd*f*gd2*r + 728*D1*Dd*f*gd2*s**2 - 2282*D1*Dd*f*gd2*s + 1386*D1*Dd*f*gd2 + 2072*D1*Dd*fd*g2*r**2 + 2800*D1*Dd*fd*g2*r*s - 42*D1*Dd*fd*g2*r + 728*D1*Dd*fd*g2*s**2 + 462*D1*Dd*fd*g2*s - 1008*D1*Dd*fd*g2 - 1704*D1*Ddd*K*f**2*r**2 - 4416*D1*Ddd*K*f**2*r*s + 2808*D1*Ddd*K*f**2*r - 2712*D1*Ddd*K*f**2*s**2 + 3564*D1*Ddd*K*f**2*s - 1530*D1*Ddd*K*f**2 + 360*D1*Ddd*f**3*r**2 + 1368*D1*Ddd*f**3*r*s - 702*D1*Ddd*f**3*r + 1008*D1*Ddd*f**3*s**2 - 1188*D1*Ddd*f**3*s + 432*D1*Ddd*f**3 + 1328*D1*Ddd*f**2*r**2 + 2680*D1*Ddd*f**2*r*s - 1998*D1*Ddd*f**2*r + 1352*D1*Ddd*f**2*s**2 - 2016*D1*Ddd*f**2*s + 1002*D1*Ddd*f**2 + 1036*D1*Ddd*f*g2*r**2 + 1400*D1*Ddd*f*g2*r*s - 1386*D1*Ddd*f*g2*r + 364*D1*Ddd*f*g2*s**2 - 882*D1*Ddd*f*g2*s + 609*D1*Ddd*f*g2 + D1*bd1*(D1*(-6*f**2*(24*r**2 + r*(48*s - 58) + 24*s**2 - 58*s + 29) + f*(-28*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(69*r**2 + 2*r*(55*s - 61) + 41*s**2 - 94*s + 54) + 144*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 651*r**2 - 1106*r*s + 1218*r - 455*s**2 + 1022*s - 560) + 14*fd*(C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) + K*(-37*r**2 - 50*r*s + 19*r - 13*s**2 + 7*s + 12) + 69*r**2 + 114*r*s - 55*r + 45*s**2 - 43*s - 8) + 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(36*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + 7*f*(2*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(148*r**2 + 200*r*s - 271*r + 52*s**2 - 187*s + 117) + 276*r**2 + 456*r*s - 479*r + 180*s**2 - 395*s + 201) - 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 5112*Dd**2*K*f**2*r**2 - 13248*Dd**2*K*f**2*r*s + 8424*Dd**2*K*f**2*r - 8136*Dd**2*K*f**2*s**2 + 10692*Dd**2*K*f**2*s - 3060*Dd**2*K*f**2 + 1080*Dd**2*f**3*r**2 + 4104*Dd**2*f**3*r*s - 2106*Dd**2*f**3*r + 3024*Dd**2*f**3*s**2 - 3564*Dd**2*f**3*s + 864*Dd**2*f**3 + 3984*Dd**2*f**2*r**2 + 8040*Dd**2*f**2*r*s - 5994*Dd**2*f**2*r + 4056*Dd**2*f**2*s**2 - 6048*Dd**2*f**2*s + 2004*Dd**2*f**2 + 3108*Dd**2*f*g2*r**2 + 4200*Dd**2*f*g2*r*s - 4158*Dd**2*f*g2*r + 1092*Dd**2*f*g2*s**2 - 2646*Dd**2*f*g2*s + 1218*Dd**2*f*g2))/(105*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**2*k1**2*k2**2*(2016*C*D1**2*bd1**2*f*r**2 + 4032*C*D1**2*bd1**2*f*r*s - 2016*C*D1**2*bd1**2*f*r + 2016*C*D1**2*bd1**2*f*s**2 - 2016*C*D1**2*bd1**2*f*s + 4176*C*D1**2*bd1*f**2*r**2 + 8280*C*D1**2*bd1*f**2*r*s - 8496*C*D1**2*bd1*f**2*r + 4104*C*D1**2*bd1*f**2*s**2 - 8424*C*D1**2*bd1*f**2*s + 4212*C*D1**2*bd1*f**2 - 21456*C*D1**2*bd1*f*fd*r**2 - 43776*C*D1**2*bd1*f*fd*r*s + 32976*C*D1**2*bd1*f*fd*r - 22320*C*D1**2*bd1*f*fd*s**2 + 33624*C*D1**2*bd1*f*fd*s - 11304*C*D1**2*bd1*f*fd - 5364*C*D1**2*bdd1*f**2*r**2 - 10944*C*D1**2*bdd1*f**2*r*s + 11304*C*D1**2*bdd1*f**2*r - 5580*C*D1**2*bdd1*f**2*s**2 + 11520*C*D1**2*bdd1*f**2*s - 5760*C*D1**2*bdd1*f**2 - 330*C*D1**2*f**2*fd*r**2 + 3180*C*D1**2*f**2*fd*r*s - 840*C*D1**2*f**2*fd*r + 3510*C*D1**2*f**2*fd*s**2 - 3400*C*D1**2*f**2*fd*s + 1060*C*D1**2*f**2*fd - 1590*C*D1**2*f**2*fdd*r**2 - 6180*C*D1**2*f**2*fdd*r*s + 3120*C*D1**2*f**2*fdd*r - 4590*C*D1**2*f**2*fdd*s**2 + 5120*C*D1**2*f**2*fdd*s - 2060*C*D1**2*f**2*fdd - 3180*C*D1**2*f*fd**2*r**2 - 12360*C*D1**2*f*fd**2*r*s + 6240*C*D1**2*f*fd**2*r - 9180*C*D1**2*f*fd**2*s**2 + 10240*C*D1**2*f*fd**2*s - 2060*C*D1**2*f*fd**2 - 42912*C*D1*Dd*bd1*f**2*r**2 - 87552*C*D1*Dd*bd1*f**2*r*s + 77616*C*D1*Dd*bd1*f**2*r - 44640*C*D1*Dd*bd1*f**2*s**2 + 79128*C*D1*Dd*bd1*f**2*s - 34128*C*D1*Dd*bd1*f**2 - 440*C*D1*Dd*f**3*r**2 + 4240*C*D1*Dd*f**3*r*s - 620*C*D1*Dd*f**3*r + 4680*C*D1*Dd*f**3*s**2 - 4460*C*D1*Dd*f**3*s + 950*C*D1*Dd*f**3 - 12720*C*D1*Dd*f**2*fd*r**2 - 49440*C*D1*Dd*f**2*fd*r*s + 25020*C*D1*Dd*f**2*fd*r - 36720*C*D1*Dd*f**2*fd*s**2 + 42020*C*D1*Dd*f**2*fd*s - 11360*C*D1*Dd*f**2*fd - 2120*C*D1*Ddd*f**3*r**2 - 8240*C*D1*Ddd*f**3*r*s + 4180*C*D1*Ddd*f**3*r - 6120*C*D1*Ddd*f**3*s**2 + 7180*C*D1*Ddd*f**3*s - 2590*C*D1*Ddd*f**3 - 6360*C*Dd**2*f**3*r**2 - 24720*C*Dd**2*f**3*r*s + 12540*C*Dd**2*f**3*r - 18360*C*Dd**2*f**3*s**2 + 21540*C*Dd**2*f**3*s - 5180*C*Dd**2*f**3 - 6972*D1**2*K*bd1**2*f*r**2 - 15456*D1**2*K*bd1**2*f*r*s + 14952*D1**2*K*bd1**2*f*r - 8484*D1**2*K*bd1**2*f*s**2 + 16464*D1**2*K*bd1**2*f*s - 7980*D1**2*K*bd1**2*f - 189*D1**2*K*bd1*f**2*r**2 + 630*D1**2*K*bd1*f**2*r*s + 378*D1**2*K*bd1*f**2*r + 819*D1**2*K*bd1*f**2*s**2 - 630*D1**2*K*bd1*f**2*s - 189*D1**2*K*bd1*f**2 - 1260*D1**2*K*bd1*f*fd*r**2 - 5544*D1**2*K*bd1*f*fd*r*s + 2646*D1**2*K*bd1*f*fd*r - 4284*D1**2*K*bd1*f*fd*s**2 + 4914*D1**2*K*bd1*f*fd*s - 1386*D1**2*K*bd1*f*fd - 315*D1**2*K*bdd1*f**2*r**2 - 1386*D1**2*K*bdd1*f**2*r*s + 630*D1**2*K*bdd1*f**2*r - 1071*D1**2*K*bdd1*f**2*s**2 + 1386*D1**2*K*bdd1*f**2*s - 315*D1**2*K*bdd1*f**2 + 4158*D1**2*bd1**2*f**2*r**2 + 6804*D1**2*bd1**2*f**2*r*s - 7560*D1**2*bd1**2*f**2*r + 2646*D1**2*bd1**2*f**2*s**2 - 6048*D1**2*bd1**2*f**2*s + 3402*D1**2*bd1**2*f**2 + 1344*D1**2*bd1**2*f*r**2 + 2688*D1**2*bd1**2*f*r*s - 4200*D1**2*bd1**2*f*r + 1344*D1**2*bd1**2*f*s**2 - 4200*D1**2*bd1**2*f*s + 2856*D1**2*bd1**2*f - 3360*D1**2*bd1**2*g2*r**2 - 6720*D1**2*bd1**2*g2*r*s + 3360*D1**2*bd1**2*g2*r - 3360*D1**2*bd1**2*g2*s**2 + 3360*D1**2*bd1**2*g2*s - 1512*D1**2*bd1*bd2*f*r**2 - 3024*D1**2*bd1*bd2*f*r*s + 3024*D1**2*bd1*bd2*f*r - 1512*D1**2*bd1*bd2*f*s**2 + 3024*D1**2*bd1*bd2*f*s - 1512*D1**2*bd1*bd2*f - 2304*D1**2*bd1*f**2*r**2 - 4644*D1**2*bd1*f**2*r*s + 4626*D1**2*bd1*f**2*r - 2340*D1**2*bd1*f**2*s**2 + 4662*D1**2*bd1*f**2*s - 2268*D1**2*bd1*f**2 + 15192*D1**2*bd1*f*fd*r**2 + 29952*D1**2*bd1*f*fd*r*s - 22752*D1**2*bd1*f*fd*r + 14760*D1**2*bd1*f*fd*s**2 - 22428*D1**2*bd1*f*fd*s + 7668*D1**2*bd1*f*fd - 3024*D1**2*bd1*f*g2*r**2 - 8232*D1**2*bd1*f*g2*r*s + 8400*D1**2*bd1*f*g2*r - 5208*D1**2*bd1*f*g2*s**2 + 10584*D1**2*bd1*f*g2*s - 5292*D1**2*bd1*f*g2 + 13944*D1**2*bd1*f*gd2*r**2 + 30912*D1**2*bd1*f*gd2*r*s - 29904*D1**2*bd1*f*gd2*r + 16968*D1**2*bd1*f*gd2*s**2 - 32928*D1**2*bd1*f*gd2*s + 15960*D1**2*bd1*f*gd2 + 13944*D1**2*bd1*fd*g2*r**2 + 30912*D1**2*bd1*fd*g2*r*s - 15456*D1**2*bd1*fd*g2*r + 16968*D1**2*bd1*fd*g2*s**2 - 16968*D1**2*bd1*fd*g2*s - 126*D1**2*bd2*f**2*r**2 - 252*D1**2*bd2*f**2*r*s + 252*D1**2*bd2*f**2*r - 126*D1**2*bd2*f**2*s**2 + 252*D1**2*bd2*f**2*s - 126*D1**2*bd2*f**2 + 3798*D1**2*bdd1*f**2*r**2 + 7488*D1**2*bdd1*f**2*r*s - 7668*D1**2*bdd1*f**2*r + 3690*D1**2*bdd1*f**2*s**2 - 7560*D1**2*bdd1*f**2*s + 3780*D1**2*bdd1*f**2 + 6972*D1**2*bdd1*f*g2*r**2 + 15456*D1**2*bdd1*f*g2*r*s - 15960*D1**2*bdd1*f*g2*r + 8484*D1**2*bdd1*f*g2*s**2 - 17472*D1**2*bdd1*f*g2*s + 8736*D1**2*bdd1*f*g2 + 435*D1**2*f**2*fd*r**2 - 1320*D1**2*f**2*fd*r*s + 150*D1**2*f**2*fd*r - 1755*D1**2*f**2*fd*s**2 + 1610*D1**2*f**2*fd*s - 440*D1**2*f**2*fd + 795*D1**2*f**2*fdd*r**2 + 3090*D1**2*f**2*fdd*r*s - 1560*D1**2*f**2*fdd*r + 2295*D1**2*f**2*fdd*s**2 - 2560*D1**2*f**2*fdd*s + 1030*D1**2*f**2*fdd + 378*D1**2*f**2*gd2*r**2 - 1260*D1**2*f**2*gd2*r*s - 756*D1**2*f**2*gd2*r - 1638*D1**2*f**2*gd2*s**2 + 1260*D1**2*f**2*gd2*s + 378*D1**2*f**2*gd2 + 630*D1**2*f**2*gdd2*r**2 + 2772*D1**2*f**2*gdd2*r*s - 1260*D1**2*f**2*gdd2*r + 2142*D1**2*f**2*gdd2*s**2 - 2772*D1**2*f**2*gdd2*s + 630*D1**2*f**2*gdd2 + 1590*D1**2*f*fd**2*r**2 + 6180*D1**2*f*fd**2*r*s - 3120*D1**2*f*fd**2*r + 4590*D1**2*f*fd**2*s**2 - 5120*D1**2*f*fd**2*s + 1030*D1**2*f*fd**2 + 756*D1**2*f*fd*g2*r**2 - 2520*D1**2*f*fd*g2*r*s + 1260*D1**2*f*fd*g2*r - 3276*D1**2*f*fd*g2*s**2 + 3276*D1**2*f*fd*g2*s - 1638*D1**2*f*fd*g2 + 2520*D1**2*f*fd*gd2*r**2 + 11088*D1**2*f*fd*gd2*r*s - 5292*D1**2*f*fd*gd2*r + 8568*D1**2*f*fd*gd2*s**2 - 9828*D1**2*f*fd*gd2*s + 2772*D1**2*f*fd*gd2 + 1260*D1**2*f*fdd*g2*r**2 + 5544*D1**2*f*fdd*g2*r*s - 2772*D1**2*f*fdd*g2*r + 4284*D1**2*f*fdd*g2*s**2 - 4284*D1**2*f*fdd*g2*s + 2142*D1**2*f*fdd*g2 + 1260*D1**2*fd**2*g2*r**2 + 5544*D1**2*fd**2*g2*r*s - 2772*D1**2*fd**2*g2*r + 4284*D1**2*fd**2*g2*s**2 - 4284*D1**2*fd**2*g2*s - 2520*D1*Dd*K*bd1*f**2*r**2 - 11088*D1*Dd*K*bd1*f**2*r*s + 5166*D1*Dd*K*bd1*f**2*r - 8568*D1*Dd*K*bd1*f**2*s**2 + 10458*D1*Dd*K*bd1*f**2*s - 2646*D1*Dd*K*bd1*f**2 + 30384*D1*Dd*bd1*f**2*r**2 + 59904*D1*Dd*bd1*f**2*r*s - 53352*D1*Dd*bd1*f**2*r + 29520*D1*Dd*bd1*f**2*s**2 - 52596*D1*Dd*bd1*f**2*s + 22896*D1*Dd*bd1*f**2 + 55776*D1*Dd*bd1*f*g2*r**2 + 123648*D1*Dd*bd1*f*g2*r*s - 107184*D1*Dd*bd1*f*g2*r + 67872*D1*Dd*bd1*f*g2*s**2 - 117768*D1*Dd*bd1*f*g2*s + 49392*D1*Dd*bd1*f*g2 + 580*D1*Dd*f**3*r**2 - 1760*D1*Dd*f**3*r*s - 140*D1*Dd*f**3*r - 2340*D1*Dd*f**3*s**2 + 2050*D1*Dd*f**3*s - 295*D1*Dd*f**3 + 6360*D1*Dd*f**2*fd*r**2 + 24720*D1*Dd*f**2*fd*r*s - 12510*D1*Dd*f**2*fd*r + 18360*D1*Dd*f**2*fd*s**2 - 21010*D1*Dd*f**2*fd*s + 5680*D1*Dd*f**2*fd + 1512*D1*Dd*f**2*g2*r**2 - 5040*D1*Dd*f**2*g2*r*s - 252*D1*Dd*f**2*g2*r - 6552*D1*Dd*f**2*g2*s**2 + 5796*D1*Dd*f**2*g2*s - 882*D1*Dd*f**2*g2 + 5040*D1*Dd*f**2*gd2*r**2 + 22176*D1*Dd*f**2*gd2*r*s - 10332*D1*Dd*f**2*gd2*r + 17136*D1*Dd*f**2*gd2*s**2 - 20916*D1*Dd*f**2*gd2*s + 5292*D1*Dd*f**2*gd2 + 10080*D1*Dd*f*fd*g2*r**2 + 44352*D1*Dd*f*fd*g2*r*s - 21672*D1*Dd*f*fd*g2*r + 34272*D1*Dd*f*fd*g2*s**2 - 36792*D1*Dd*f*fd*g2*s + 9828*D1*Dd*f*fd*g2 + 1060*D1*Ddd*f**3*r**2 + 4120*D1*Ddd*f**3*r*s - 2090*D1*Ddd*f**3*r + 3060*D1*Ddd*f**3*s**2 - 3590*D1*Ddd*f**3*s + 1295*D1*Ddd*f**3 + 2520*D1*Ddd*f**2*g2*r**2 + 11088*D1*Ddd*f**2*g2*r*s - 5292*D1*Ddd*f**2*g2*r + 8568*D1*Ddd*f**2*g2*s**2 - 9828*D1*Ddd*f**2*g2*s + 3402*D1*Ddd*f**2*g2 + 42*D1*b2*(bd1*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) - 3*f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 3180*Dd**2*f**3*r**2 + 12360*Dd**2*f**3*r*s - 6270*Dd**2*f**3*r + 9180*Dd**2*f**3*s**2 - 10770*Dd**2*f**3*s + 2590*Dd**2*f**3 + 7560*Dd**2*f**2*g2*r**2 + 33264*Dd**2*f**2*g2*r*s - 15876*Dd**2*f**2*g2*r + 25704*Dd**2*f**2*g2*s**2 - 29484*Dd**2*f**2*g2*s + 6804*Dd**2*f**2*g2 + 42*b1**3*(D1**2*(8*fd - 9*fdd)*(r + s - 1)**2 + D1*(Dd*(8*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (35*K - 25)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-20*K + 9*f + 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-20*K + 9*f + 10)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 21*b1**2*(4*C*D1**2*fd*r**2 + 8*C*D1**2*fd*r*s - 8*C*D1**2*fd*r + 4*C*D1**2*fd*s**2 - 8*C*D1**2*fd*s + 4*C*D1**2*fd + 48*C*D1**2*fdd*r**2 + 96*C*D1**2*fdd*r*s - 96*C*D1**2*fdd*r + 48*C*D1**2*fdd*s**2 - 96*C*D1**2*fdd*s + 48*C*D1**2*fdd + 16*C*D1*Dd*f*r**2 + 32*C*D1*Dd*f*r*s - 24*C*D1*Dd*f*r + 16*C*D1*Dd*f*s**2 - 24*C*D1*Dd*f*s + 12*C*D1*Dd*f + 384*C*D1*Dd*fd*r**2 + 768*C*D1*Dd*fd*r*s - 672*C*D1*Dd*fd*r + 384*C*D1*Dd*fd*s**2 - 672*C*D1*Dd*fd*s + 288*C*D1*Dd*fd + 192*C*D1*Ddd*f*r**2 + 384*C*D1*Ddd*f*r*s - 288*C*D1*Ddd*f*r + 192*C*D1*Ddd*f*s**2 - 288*C*D1*Ddd*f*s + 144*C*D1*Ddd*f + 576*C*Dd**2*f*r**2 + 1152*C*Dd**2*f*r*s - 864*C*Dd**2*f*r + 576*C*Dd**2*f*s**2 - 864*C*Dd**2*f*s + 288*C*Dd**2*f + 72*D1**2*K*fd*r**2 + 196*D1**2*K*fd*r*s + 4*D1**2*K*fd*r + 124*D1**2*K*fd*s**2 + 4*D1**2*K*fd*s - 2*D1**2*K*fd - 166*D1**2*K*fdd*r**2 - 368*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r - 202*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - 2*D1**2*bdd1*(-20*K + 9*f + 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 138*D1**2*f*fd*r**2 - 204*D1**2*f*fd*r*s + 138*D1**2*f*fd*r - 66*D1**2*f*fd*s**2 + 102*D1**2*f*fd*s - 69*D1**2*f*fd + 198*D1**2*f*fdd*r**2 + 324*D1**2*f*fdd*r*s - 198*D1**2*f*fdd*r + 126*D1**2*f*fdd*s**2 - 162*D1**2*f*fdd*s + 99*D1**2*f*fdd + 198*D1**2*fd**2*r**2 + 324*D1**2*fd**2*r*s - 198*D1**2*fd**2*r + 126*D1**2*fd**2*s**2 - 162*D1**2*fd**2*s + 6*D1**2*fd*r**2 - 18*D1**2*fd*r*s + 16*D1**2*fd*r - 24*D1**2*fd*s**2 + 16*D1**2*fd*s - 8*D1**2*fd + 32*D1**2*fdd*r**2 + 64*D1**2*fdd*r*s + 72*D1**2*fdd*r + 32*D1**2*fdd*s**2 + 72*D1**2*fdd*s - 36*D1**2*fdd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 - 80*D1**2*gdd2*r**2 - 160*D1**2*gdd2*r*s + 160*D1**2*gdd2*r - 80*D1**2*gdd2*s**2 + 160*D1**2*gdd2*s - 80*D1**2*gdd2 + 288*D1*Dd*K*f*r**2 + 784*D1*Dd*K*f*r*s - 484*D1*Dd*K*f*r + 496*D1*Dd*K*f*s**2 - 640*D1*Dd*K*f*s + 268*D1*Dd*K*f - 1328*D1*Dd*K*fd*r**2 - 2944*D1*Dd*K*fd*r*s + 984*D1*Dd*K*fd*r - 1616*D1*Dd*K*fd*s**2 + 1092*D1*Dd*K*fd*s + 36*D1*Dd*K*fd - 276*D1*Dd*f**2*r**2 - 408*D1*Dd*f**2*r*s + 378*D1*Dd*f**2*r - 132*D1*Dd*f**2*s**2 + 270*D1*Dd*f**2*s - 171*D1*Dd*f**2 + 1584*D1*Dd*f*fd*r**2 + 2592*D1*Dd*f*fd*r*s - 1908*D1*Dd*f*fd*r + 1008*D1*Dd*f*fd*s**2 - 1548*D1*Dd*f*fd*s + 558*D1*Dd*f*fd + 24*D1*Dd*f*r**2 - 72*D1*Dd*f*r*s - 6*D1*Dd*f*r - 96*D1*Dd*f*s**2 + 84*D1*Dd*f*s - 12*D1*Dd*f + 256*D1*Dd*fd*r**2 + 512*D1*Dd*fd*r*s + 96*D1*Dd*fd*r + 256*D1*Dd*fd*s**2 + 96*D1*Dd*fd*s - 216*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 - 640*D1*Dd*gd2*r**2 - 1280*D1*Dd*gd2*r*s + 1120*D1*Dd*gd2*r - 640*D1*Dd*gd2*s**2 + 1120*D1*Dd*gd2*s - 480*D1*Dd*gd2 - 664*D1*Ddd*K*f*r**2 - 1472*D1*Ddd*K*f*r*s + 1032*D1*Ddd*K*f*r - 808*D1*Ddd*K*f*s**2 + 1140*D1*Ddd*K*f*s - 534*D1*Ddd*K*f + 396*D1*Ddd*f**2*r**2 + 648*D1*Ddd*f**2*r*s - 558*D1*Ddd*f**2*r + 252*D1*Ddd*f**2*s**2 - 450*D1*Ddd*f**2*s + 261*D1*Ddd*f**2 + 128*D1*Ddd*f*r**2 + 256*D1*Ddd*f*r*s - 192*D1*Ddd*f*r + 128*D1*Ddd*f*s**2 - 192*D1*Ddd*f*s + 96*D1*Ddd*f - 320*D1*Ddd*g2*r**2 - 640*D1*Ddd*g2*r*s + 480*D1*Ddd*g2*r - 320*D1*Ddd*g2*s**2 + 480*D1*Ddd*g2*s - 240*D1*Ddd*g2 + 2*D1*bd1*(D1*(8*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (35*K - 25)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-20*K + 9*f + 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 1992*Dd**2*K*f*r**2 - 4416*Dd**2*K*f*r*s + 3096*Dd**2*K*f*r - 2424*Dd**2*K*f*s**2 + 3420*Dd**2*K*f*s - 1068*Dd**2*K*f + 1188*Dd**2*f**2*r**2 + 1944*Dd**2*f**2*r*s - 1674*Dd**2*f**2*r + 756*Dd**2*f**2*s**2 - 1350*Dd**2*f**2*s + 522*Dd**2*f**2 + 384*Dd**2*f*r**2 + 768*Dd**2*f*r*s - 576*Dd**2*f*r + 384*Dd**2*f*s**2 - 576*Dd**2*f*s + 192*Dd**2*f - 960*Dd**2*g2*r**2 - 1920*Dd**2*g2*r*s + 1440*Dd**2*g2*r - 960*Dd**2*g2*s**2 + 1440*Dd**2*g2*s - 480*Dd**2*g2) - 3*b1*(-672*C*D1**2*bdd1*f*r**2 - 1344*C*D1**2*bdd1*f*r*s + 672*C*D1**2*bdd1*f*r - 672*C*D1**2*bdd1*f*s**2 + 672*C*D1**2*bdd1*f*s - 336*C*D1**2*bdd1*f - 2784*C*D1**2*f*fd*r**2 - 5520*C*D1**2*f*fd*r*s + 2712*C*D1**2*f*fd*r - 2736*C*D1**2*f*fd*s**2 + 2688*C*D1**2*f*fd*s - 1356*C*D1**2*f*fd + 3576*C*D1**2*f*fdd*r**2 + 7296*C*D1**2*f*fdd*r*s - 3456*C*D1**2*f*fdd*r + 3720*C*D1**2*f*fdd*s**2 - 3528*C*D1**2*f*fdd*s + 1728*C*D1**2*f*fdd + 3576*C*D1**2*fd**2*r**2 + 7296*C*D1**2*fd**2*r*s - 3456*C*D1**2*fd**2*r + 3720*C*D1**2*fd**2*s**2 - 3528*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 - 5568*C*D1*Dd*f**2*r**2 - 11040*C*D1*Dd*f**2*r*s + 8328*C*D1*Dd*f**2*r - 5472*C*D1*Dd*f**2*s**2 + 8256*C*D1*Dd*f**2*s - 4152*C*D1*Dd*f**2 + 28608*C*D1*Dd*f*fd*r**2 + 58368*C*D1*Dd*f*fd*r*s - 35424*C*D1*Dd*f*fd*r + 29760*C*D1*Dd*f*fd*s**2 - 36144*C*D1*Dd*f*fd*s + 10440*C*D1*Dd*f*fd + 7152*C*D1*Ddd*f**2*r**2 + 14592*C*D1*Ddd*f**2*r*s - 10800*C*D1*Ddd*f**2*r + 7440*C*D1*Ddd*f**2*s**2 - 11016*C*D1*Ddd*f**2*s + 5436*C*D1*Ddd*f**2 + 21456*C*Dd**2*f**2*r**2 + 43776*C*Dd**2*f**2*r*s - 32400*C*Dd**2*f**2*r + 22320*C*Dd**2*f**2*s**2 - 33048*C*Dd**2*f**2*s + 10872*C*Dd**2*f**2 + 2324*D1**2*K*bdd1*f*r**2 + 5152*D1**2*K*bdd1*f*r*s - 4984*D1**2*K*bdd1*f*r + 2828*D1**2*K*bdd1*f*s**2 - 5488*D1**2*K*bdd1*f*s + 2618*D1**2*K*bdd1*f + 126*D1**2*K*f*fd*r**2 - 420*D1**2*K*f*fd*r*s + 210*D1**2*K*f*fd*r - 546*D1**2*K*f*fd*s**2 + 546*D1**2*K*f*fd*s - 273*D1**2*K*f*fd + 210*D1**2*K*f*fdd*r**2 + 924*D1**2*K*f*fdd*r*s - 462*D1**2*K*f*fdd*r + 714*D1**2*K*f*fdd*s**2 - 714*D1**2*K*f*fdd*s + 357*D1**2*K*f*fdd + 210*D1**2*K*fd**2*r**2 + 924*D1**2*K*fd**2*r*s - 462*D1**2*K*fd**2*r + 714*D1**2*K*fd**2*s**2 - 714*D1**2*K*fd**2*s - 154*D1**2*b2*fd*r**2 - 308*D1**2*b2*fd*r*s - 154*D1**2*b2*fd*s**2 + 252*D1**2*b2*fdd*r**2 + 504*D1**2*b2*fdd*r*s + 252*D1**2*b2*fdd*s**2 + 28*D1**2*bd1**2*(-20*K + 9*f + 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 1386*D1**2*bdd1*f**2*r**2 - 2268*D1**2*bdd1*f**2*r*s + 2520*D1**2*bdd1*f**2*r - 882*D1**2*bdd1*f**2*s**2 + 2016*D1**2*bdd1*f**2*s - 1134*D1**2*bdd1*f**2 - 448*D1**2*bdd1*f*r**2 - 896*D1**2*bdd1*f*r*s + 1400*D1**2*bdd1*f*r - 448*D1**2*bdd1*f*s**2 + 1400*D1**2*bdd1*f*s - 700*D1**2*bdd1*f + 1120*D1**2*bdd1*g2*r**2 + 2240*D1**2*bdd1*g2*r*s - 1120*D1**2*bdd1*g2*r + 1120*D1**2*bdd1*g2*s**2 - 1120*D1**2*bdd1*g2*s + 560*D1**2*bdd1*g2 + 252*D1**2*bdd2*f*r**2 + 504*D1**2*bdd2*f*r*s - 504*D1**2*bdd2*f*r + 252*D1**2*bdd2*f*s**2 - 504*D1**2*bdd2*f*s + 252*D1**2*bdd2*f + 1536*D1**2*f*fd*r**2 + 3096*D1**2*f*fd*r*s - 1542*D1**2*f*fd*r + 1560*D1**2*f*fd*s**2 - 1554*D1**2*f*fd*s + 792*D1**2*f*fd - 2532*D1**2*f*fdd*r**2 - 4992*D1**2*f*fdd*r*s + 2472*D1**2*f*fdd*r - 2460*D1**2*f*fdd*s**2 + 2436*D1**2*f*fdd*s - 1236*D1**2*f*fdd + 1008*D1**2*f*gd2*r**2 + 2744*D1**2*f*gd2*r*s - 2016*D1**2*f*gd2*r + 1736*D1**2*f*gd2*s**2 - 2744*D1**2*f*gd2*s + 1008*D1**2*f*gd2 - 2324*D1**2*f*gdd2*r**2 - 5152*D1**2*f*gdd2*r*s + 4648*D1**2*f*gdd2*r - 2828*D1**2*f*gdd2*s**2 + 5152*D1**2*f*gdd2*s - 2324*D1**2*f*gdd2 - 2532*D1**2*fd**2*r**2 - 4992*D1**2*fd**2*r*s + 2472*D1**2*fd**2*r - 2460*D1**2*fd**2*s**2 + 2436*D1**2*fd**2*s + 60*D1**2*fd**2 + 1008*D1**2*fd*g2*r**2 + 2744*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r + 1736*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 - 4648*D1**2*fd*gd2*r**2 - 10304*D1**2*fd*gd2*r*s + 4480*D1**2*fd*gd2*r - 5656*D1**2*fd*gd2*s**2 + 4984*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 - 2324*D1**2*fdd*g2*r**2 - 5152*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r - 2828*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 + 252*D1*Dd*K*f**2*r**2 - 840*D1*Dd*K*f**2*r*s - 42*D1*Dd*K*f**2*r - 1092*D1*Dd*K*f**2*s**2 + 966*D1*Dd*K*f**2*s - 147*D1*Dd*K*f**2 + 1680*D1*Dd*K*f*fd*r**2 + 7392*D1*Dd*K*f*fd*r*s - 3612*D1*Dd*K*f*fd*r + 5712*D1*Dd*K*f*fd*s**2 - 6132*D1*Dd*K*f*fd*s + 1638*D1*Dd*K*f*fd - 616*D1*Dd*b2*f*r**2 - 1232*D1*Dd*b2*f*r*s + 924*D1*Dd*b2*f*r - 616*D1*Dd*b2*f*s**2 + 924*D1*Dd*b2*f*s - 462*D1*Dd*b2*f + 2016*D1*Dd*b2*fd*r**2 + 4032*D1*Dd*b2*fd*r*s - 1512*D1*Dd*b2*fd*r + 2016*D1*Dd*b2*fd*s**2 - 1512*D1*Dd*b2*fd*s + 3072*D1*Dd*f**2*r**2 + 6192*D1*Dd*f**2*r*s - 4620*D1*Dd*f**2*r + 3120*D1*Dd*f**2*s**2 - 4656*D1*Dd*f**2*s + 2316*D1*Dd*f**2 - 20256*D1*Dd*f*fd*r**2 - 39936*D1*Dd*f*fd*r*s + 25008*D1*Dd*f*fd*r - 19680*D1*Dd*f*fd*s**2 + 24648*D1*Dd*f*fd*s - 7380*D1*Dd*f*fd + 4032*D1*Dd*f*g2*r**2 + 10976*D1*Dd*f*g2*r*s - 6776*D1*Dd*f*g2*r + 6944*D1*Dd*f*g2*s**2 - 8960*D1*Dd*f*g2*s + 3752*D1*Dd*f*g2 - 18592*D1*Dd*f*gd2*r**2 - 41216*D1*Dd*f*gd2*r*s + 33040*D1*Dd*f*gd2*r - 22624*D1*Dd*f*gd2*s**2 + 36568*D1*Dd*f*gd2*s - 14448*D1*Dd*f*gd2 - 18592*D1*Dd*fd*g2*r**2 - 41216*D1*Dd*fd*g2*r*s + 13776*D1*Dd*fd*g2*r - 22624*D1*Dd*fd*g2*s**2 + 15288*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 + 420*D1*Ddd*K*f**2*r**2 + 1848*D1*Ddd*K*f**2*r*s - 882*D1*Ddd*K*f**2*r + 1428*D1*Ddd*K*f**2*s**2 - 1638*D1*Ddd*K*f**2*s + 567*D1*Ddd*K*f**2 + 1008*D1*Ddd*b2*f*r**2 + 2016*D1*Ddd*b2*f*r*s - 1512*D1*Ddd*b2*f*r + 1008*D1*Ddd*b2*f*s**2 - 1512*D1*Ddd*b2*f*s + 756*D1*Ddd*b2*f - 5064*D1*Ddd*f**2*r**2 - 9984*D1*Ddd*f**2*r*s + 7560*D1*Ddd*f**2*r - 4920*D1*Ddd*f**2*s**2 + 7452*D1*Ddd*f**2*s - 3762*D1*Ddd*f**2 - 9296*D1*Ddd*f*g2*r**2 - 20608*D1*Ddd*f*g2*r*s + 14448*D1*Ddd*f*g2*r - 11312*D1*Ddd*f*g2*s**2 + 15960*D1*Ddd*f*g2*s - 7476*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(3*f**2*(23*r**2 + r*(34*s - 40) + 11*s**2 - 28*s + 17) - f*(C*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) + 72*K*r**2 + 196*K*r*s - 172*K*r + 124*K*s**2 - 224*K*s + 99*K + 18*fd*(22*r**2 + 36*r*s - 31*r + 14*s**2 - 25*s + 10) + 6*r**2 - 18*r*s - 5*r - 24*s**2 + 25*s - 5) - 2*fd*(24*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-166*r**2 - 368*r*s + 172*r - 202*s**2 + 190*s + 3) + 32*r**2 + 64*r*s - 14*r + 32*s**2 - 14*s - 18) + 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 80*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(9*f**2*(44*r**2 + r*(72*s - 71) + 28*s**2 - 57*s + 28) + 2*f*(12*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(332*r**2 + 736*r*s - 614*r + 404*s**2 - 677*s + 276) + 64*r**2 + 128*r*s - 148*r + 64*s**2 - 148*s + 75) - 40*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 14*D1*bd2*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) + 1260*Dd**2*K*f**2*r**2 + 5544*Dd**2*K*f**2*r*s - 2646*Dd**2*K*f**2*r + 4284*Dd**2*K*f**2*s**2 - 4914*Dd**2*K*f**2*s + 1134*Dd**2*K*f**2 + 3024*Dd**2*b2*f*r**2 + 6048*Dd**2*b2*f*r*s - 4536*Dd**2*b2*f*r + 3024*Dd**2*b2*f*s**2 - 4536*Dd**2*b2*f*s + 1512*Dd**2*b2*f - 15192*Dd**2*f**2*r**2 - 29952*Dd**2*f**2*r*s + 22680*Dd**2*f**2*r - 14760*Dd**2*f**2*s**2 + 22356*Dd**2*f**2*s - 7524*Dd**2*f**2 - 27888*Dd**2*f*g2*r**2 - 61824*Dd**2*f*g2*r*s + 43344*Dd**2*f*g2*r - 33936*Dd**2*f*g2*s**2 + 47880*Dd**2*f*g2*s - 14952*Dd**2*f*g2))/(315*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**2*k1**2*st**6*(D1**2*(84*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-504*fd**2*s*(2*s - 1) + fd*(44*C - 44)*(3*s**2 - 2*s + 1) - fdd*(22*C - 22)*(3*s**2 - 2*s + 1) + s**2*(-99*K*bdd1 + 198*bd1*(K - 1) + 99*bdd1 - 396*gd2 + 198*gdd2)) - 22*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 396*fd**2*g2*s*(s - 1)) + 2*D1*f*(Dd*(84*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(11*C*(4*s**2 - 2*s + 1) - 42*fd*(1 - 4*s)**2 - 44*s**2 + 22*s - 11) - 11*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(42*f**2 + f*(11*C - 11) - 99*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(2*s - 1)*(42*f**2 + f*(11*C - 11) - 99*g2) + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k3**4) - 4*D1**2*Pk2*Pk3*ct**2*k1**2*st**4*(D1**2*(84*bd1*fd*g2*s*(s - 1) + f**3*s**2*(90*bd1 - 45*bdd1) - 2*f**2*(5*fd*(s**2*(27*bd1 - 6) + s*(4 - 9*bd1) - 2) + 5*fdd*(3*s**2 - 2*s + 1) + s**2*(C + 4)*(-6*bd1 + 3*bdd1)) + 2*f*s*(-21*bd1**2*s*(K - 1) - 6*bd1*(fd*(C + 4)*(2*s - 1) + s*(7*g2 - 7*gd2)) + 21*bdd1*g2*s + fd**2*(20 - 30*s))) - 2*D1*f*(Dd*(42*bd1*g2*s*(1 - 4*s) + 5*f**2*(s**2*(36*bd1 - 8) + s*(4 - 9*bd1) - 2) + 2*f*(4*s - 1)*(3*bd1*s*(C + 4) + 5*fd*(3*s - 1))) + 5*Ddd*f**2*(4*s**2 - 2*s + 1)) + 60*Dd**2*f**3*s*(1 - 2*s) + 21*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(D1**2*(15*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) - 2*f*(15*fd**2*s*(3*s - 2) - fd*(2*C + 8)*(2*s**2 - 2*s + 1) + fdd*(C + 4)*(2*s**2 - 2*s + 1) + s**2*(7*K*bdd1 - 14*bd1*(K - 1) - 7*bdd1 + 14*gd2 - 7*gdd2)) - (2*s - 2)*(fd**2*s*(2*C + 8) + 14*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(15*f**3*(4*s**2 - 2*s + 1) + f**2*(C*(8*s**2 - 4*s + 2) - 15*fd*(12*s**2 - 7*s + 1) + 32*s**2 - 16*s + 8) - 2*f*(fd*(C + 4)*(8*s**2 - 6*s + 1) + 7*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(7*K*bd1 - 7*bd1 - 7*gd2)) + 14*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(15*f**2 + f*(2*C + 8) - 14*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(15*f**2 + f*(2*C + 8) - 14*g2)))/(35*d**2*k2**2*k3**2) - 2*D1**2*Pk2*Pk3*ct**2*k1**2*st**2*(-240*C*D1**2*f**2*fd*s**2 + 160*C*D1**2*f**2*fd*s - 80*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*s**2 - 80*C*D1**2*f**2*fdd*s + 40*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*s**2 - 160*C*D1**2*f*fd**2*s - 320*C*D1*Dd*f**3*s**2 + 160*C*D1*Dd*f**3*s - 80*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*s**2 - 560*C*D1*Dd*f**2*fd*s + 80*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*s**2 - 80*C*D1*Ddd*f**3*s + 40*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*s**2 - 240*C*Dd**2*f**3*s - 144*D1**2*b2*f*fd*s**2 + 144*D1**2*b2*f*fd*s - 72*D1**2*b2*f*fd + 72*D1**2*b2*f*fdd*s**2 - 72*D1**2*b2*f*fdd*s + 36*D1**2*b2*f*fdd + 72*D1**2*b2*fd**2*s**2 - 72*D1**2*b2*fd**2*s - 2*D1**2*bd1**2*s*(36*f**2*(2*s - 3) + 7*f*(4*C*(s - 1) - 37*K*s + 45*s - 8) - 140*g2*(s - 1)) - 72*D1**2*bd2*f**2*s**2 + 144*D1**2*bd2*f*fd*s**2 - 72*D1**2*bd2*f*fd*s + 2*D1**2*bdd1*f*(27*f**2*s*(4*r + 9*s - 2) + f*(s**2*(71*C + 18*K + 94) + s*(60*r - 24) - 18) - 259*g2*s**2) + 36*D1**2*bdd2*f**2*s**2 - 252*D1**2*f**2*fd*r*s + 84*D1**2*f**2*fd*r - 606*D1**2*f**2*fd*s**2 + 488*D1**2*f**2*fd*s - 202*D1**2*f**2*fd + 216*D1**2*f**2*fdd*r*s - 72*D1**2*f**2*fdd*r + 438*D1**2*f**2*fdd*s**2 - 364*D1**2*f**2*fdd*s + 146*D1**2*f**2*fdd + 144*D1**2*f**2*gd2*s**2 - 72*D1**2*f**2*gdd2*s**2 + 432*D1**2*f*fd**2*r*s - 144*D1**2*f*fd**2*r + 876*D1**2*f*fd**2*s**2 - 728*D1**2*f*fd**2*s + 72*D1**2*f*fd**2 + 288*D1**2*f*fd*g2*s**2 - 288*D1**2*f*fd*g2*s + 144*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*s**2 + 144*D1**2*f*fd*gd2*s - 144*D1**2*f*fdd*g2*s**2 + 144*D1**2*f*fdd*g2*s - 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*s**2 + 144*D1**2*fd**2*g2*s - 288*D1*Dd*b2*f**2*s**2 + 144*D1*Dd*b2*f**2*s - 72*D1*Dd*b2*f**2 + 576*D1*Dd*b2*f*fd*s**2 - 432*D1*Dd*b2*f*fd*s + 72*D1*Dd*b2*f*fd + 288*D1*Dd*bd2*f**2*s**2 - 72*D1*Dd*bd2*f**2*s - 336*D1*Dd*f**3*r*s + 84*D1*Dd*f**3*r - 808*D1*Dd*f**3*s**2 + 572*D1*Dd*f**3*s - 202*D1*Dd*f**3 + 1728*D1*Dd*f**2*fd*r*s - 504*D1*Dd*f**2*fd*r + 3504*D1*Dd*f**2*fd*s**2 - 2764*D1*Dd*f**2*fd*s + 508*D1*Dd*f**2*fd + 576*D1*Dd*f**2*g2*s**2 - 288*D1*Dd*f**2*g2*s + 144*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*s**2 + 144*D1*Dd*f**2*gd2*s - 1152*D1*Dd*f*fd*g2*s**2 + 864*D1*Dd*f*fd*g2*s - 144*D1*Dd*f*fd*g2 + 144*D1*Ddd*b2*f**2*s**2 - 72*D1*Ddd*b2*f**2*s + 36*D1*Ddd*b2*f**2 + 288*D1*Ddd*f**3*r*s - 72*D1*Ddd*f**3*r + 584*D1*Ddd*f**3*s**2 - 436*D1*Ddd*f**3*s + 146*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*s**2 + 144*D1*Ddd*f**2*g2*s - 72*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(27*f**3*s*(4*r + 13*s - 2) + f**2*(-54*fd*(2*r*(6*s - 1) + 27*s**2 - 15*s + 1) + s**2*(107*C + 36*K + 118) + s*(78*r - 6) - 36) + f*(-2*fd*(30*r*(4*s - 1) + s**2*(142*C + 36*K + 188) - s*(71*C + 18*K + 136) + 30) + s**2*(-343*g2 + 518*gd2)) + 518*fd*g2*s*(s - 1)) - 2*Dd*f*(27*f**2*(2*r*(8*s - 1) + 36*s**2 - 17*s + 1) + f*(30*r*(8*s - 1) + s**2*(284*C + 72*K + 376) - s*(71*C + 18*K + 202) + 12) + 259*g2*s*(1 - 4*s))) + 432*Dd**2*b2*f**2*s**2 - 216*Dd**2*b2*f**2*s + 864*Dd**2*f**3*r*s - 216*Dd**2*f**3*r + 1752*Dd**2*f**3*s**2 - 1308*Dd**2*f**3*s + 144*Dd**2*f**3 - 864*Dd**2*f**2*g2*s**2 + 432*Dd**2*f**2*g2*s + 70*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + b1**2*(56*C*D1**2*fd*s**2 - 28*C*D1**2*fdd*s**2 + 224*C*D1*Dd*f*s**2 - 112*C*D1*Dd*f*s + 56*C*D1*Dd*f - 224*C*D1*Dd*fd*s**2 + 56*C*D1*Dd*fd*s - 112*C*D1*Ddd*f*s**2 + 56*C*D1*Ddd*f*s - 28*C*D1*Ddd*f - 336*C*Dd**2*f*s**2 + 168*C*Dd**2*f*s - 343*D1**2*K*fd*s**2 + 686*D1**2*K*fd*s - 343*D1**2*K*fd + 259*D1**2*K*fdd*s**2 - 518*D1**2*K*fdd*s + 259*D1**2*K*fdd - 70*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) + 288*D1**2*f*fd*s**2 + 144*D1**2*f*fd*s - 72*D1**2*f*fd - 144*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 36*D1**2*f*fdd - 144*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s + 455*D1**2*fd*s**2 - 686*D1**2*fd*s + 343*D1**2*fd - 315*D1**2*fdd*s**2 + 518*D1**2*fdd*s - 259*D1**2*fdd - 280*D1**2*gd2*s**2 + 140*D1**2*gdd2*s**2 - 1372*D1*Dd*K*f*s**2 + 686*D1*Dd*K*f*s - 343*D1*Dd*K*f + 2072*D1*Dd*K*fd*s**2 - 2590*D1*Dd*K*fd*s + 518*D1*Dd*K*fd + 576*D1*Dd*f**2*s**2 - 288*D1*Dd*f**2*s + 144*D1*Dd*f**2 - 1152*D1*Dd*f*fd*s**2 + 72*D1*Dd*f*fd + 1820*D1*Dd*f*s**2 - 910*D1*Dd*f*s + 455*D1*Dd*f - 2520*D1*Dd*fd*s**2 + 2702*D1*Dd*fd*s - 518*D1*Dd*fd - 1120*D1*Dd*g2*s**2 + 560*D1*Dd*g2*s - 280*D1*Dd*g2 + 1120*D1*Dd*gd2*s**2 - 280*D1*Dd*gd2*s + 1036*D1*Ddd*K*f*s**2 - 518*D1*Ddd*K*f*s + 259*D1*Ddd*K*f - 288*D1*Ddd*f**2*s**2 + 144*D1*Ddd*f**2*s - 72*D1*Ddd*f**2 - 1260*D1*Ddd*f*s**2 + 630*D1*Ddd*f*s - 315*D1*Ddd*f + 560*D1*Ddd*g2*s**2 - 280*D1*Ddd*g2*s + 140*D1*Ddd*g2 + 140*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) + 3108*Dd**2*K*f*s**2 - 1554*Dd**2*K*f*s - 864*Dd**2*f**2*s**2 + 432*Dd**2*f**2*s - 3780*Dd**2*f*s**2 + 1890*Dd**2*f*s + 1680*Dd**2*g2*s**2 - 840*Dd**2*g2*s) - 2*b1*(214*C*D1**2*f*fd*s**2 - 214*C*D1**2*f*fd*s + 107*C*D1**2*f*fd - 142*C*D1**2*f*fdd*s**2 + 142*C*D1**2*f*fdd*s - 71*C*D1**2*f*fdd - 142*C*D1**2*fd**2*s**2 + 142*C*D1**2*fd**2*s + 428*C*D1*Dd*f**2*s**2 - 214*C*D1*Dd*f**2*s + 107*C*D1*Dd*f**2 - 1136*C*D1*Dd*f*fd*s**2 + 852*C*D1*Dd*f*fd*s - 142*C*D1*Dd*f*fd - 284*C*D1*Ddd*f**2*s**2 + 142*C*D1*Ddd*f**2*s - 71*C*D1*Ddd*f**2 - 852*C*Dd**2*f**2*s**2 + 426*C*Dd**2*f**2*s + 72*D1**2*K*f*fd*s**2 - 72*D1**2*K*f*fd*s + 36*D1**2*K*f*fd - 36*D1**2*K*f*fdd*s**2 + 36*D1**2*K*f*fdd*s - 18*D1**2*K*f*fdd - 36*D1**2*K*fd**2*s**2 + 36*D1**2*K*fd**2*s + 70*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + D1**2*bdd1*(18*f**2*(4*s**2 - 6*s + 3) + 7*f*(C*(4*s**2 - 4*s + 2) + s**2*(45 - 37*K) - 8*s + 4) - 70*g2*(2*s**2 - 2*s + 1)) + 324*D1**2*f**2*fd*r*s - 108*D1**2*f**2*fd*r + 1053*D1**2*f**2*fd*s**2 - 864*D1**2*f**2*fd*s + 351*D1**2*f**2*fd - 324*D1**2*f**2*fdd*r*s + 108*D1**2*f**2*fdd*r - 729*D1**2*f**2*fdd*s**2 + 648*D1**2*f**2*fdd*s - 243*D1**2*f**2*fdd - 648*D1**2*f*fd**2*r*s + 216*D1**2*f*fd**2*r - 1458*D1**2*f*fd**2*s**2 + 1296*D1**2*f*fd**2*s - 162*D1**2*f*fd**2 + 156*D1**2*f*fd*r*s - 78*D1**2*f*fd*r + 236*D1**2*f*fd*s**2 - 308*D1**2*f*fd*s + 154*D1**2*f*fd - 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 188*D1**2*f*fdd*s**2 + 224*D1**2*f*fdd*s - 112*D1**2*f*fdd - 343*D1**2*f*gd2*s**2 + 259*D1**2*f*gdd2*s**2 - 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 188*D1**2*fd**2*s**2 + 224*D1**2*fd**2*s - 343*D1**2*fd*g2*s**2 + 686*D1**2*fd*g2*s - 343*D1**2*fd*g2 + 518*D1**2*fd*gd2*s**2 - 518*D1**2*fd*gd2*s + 259*D1**2*fdd*g2*s**2 - 518*D1**2*fdd*g2*s + 259*D1**2*fdd*g2 + 144*D1*Dd*K*f**2*s**2 - 72*D1*Dd*K*f**2*s + 36*D1*Dd*K*f**2 - 288*D1*Dd*K*f*fd*s**2 + 216*D1*Dd*K*f*fd*s - 36*D1*Dd*K*f*fd + 432*D1*Dd*f**3*r*s - 108*D1*Dd*f**3*r + 1404*D1*Dd*f**3*s**2 - 918*D1*Dd*f**3*s + 351*D1*Dd*f**3 - 2592*D1*Dd*f**2*fd*r*s + 756*D1*Dd*f**2*fd*r - 5832*D1*Dd*f**2*fd*s**2 + 4698*D1*Dd*f**2*fd*s - 864*D1*Dd*f**2*fd + 312*D1*Dd*f**2*r*s - 78*D1*Dd*f**2*r + 472*D1*Dd*f**2*s**2 - 392*D1*Dd*f**2*s + 118*D1*Dd*f**2 - 960*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 1504*D1*Dd*f*fd*s**2 + 1512*D1*Dd*f*fd*s - 344*D1*Dd*f*fd - 1372*D1*Dd*f*g2*s**2 + 686*D1*Dd*f*g2*s - 343*D1*Dd*f*g2 + 2072*D1*Dd*f*gd2*s**2 - 518*D1*Dd*f*gd2*s + 2072*D1*Dd*fd*g2*s**2 - 2590*D1*Dd*fd*g2*s + 518*D1*Dd*fd*g2 - 72*D1*Ddd*K*f**2*s**2 + 36*D1*Ddd*K*f**2*s - 18*D1*Ddd*K*f**2 - 432*D1*Ddd*f**3*r*s + 108*D1*Ddd*f**3*r - 972*D1*Ddd*f**3*s**2 + 702*D1*Ddd*f**3*s - 243*D1*Ddd*f**3 - 240*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 376*D1*Ddd*f**2*s**2 + 308*D1*Ddd*f**2*s - 94*D1*Ddd*f**2 + 1036*D1*Ddd*f*g2*s**2 - 518*D1*Ddd*f*g2*s + 259*D1*Ddd*f*g2 + D1*bd1*(D1*(-36*f**2*(4*s**2 - 6*s + 3) + f*(-28*C*(2*s**2 - 2*s + 1) + s**2*(343*K + 288*fd - 455) - s*(144*fd - 112) - 56) + 14*fd*s*(C*(4*s - 2) - 37*K*(s - 1) + 45*s - 41) + 140*g2*(2*s**2 - 2*s + 1) + 140*gd2*s*(1 - 2*s)) + 2*Dd*(4*s - 1)*(18*f**2*(4*s - 3) + 7*f*(C*(4*s - 2) - 37*K*s + 45*s - 4) + 70*g2*(1 - 2*s))) - 216*Dd**2*K*f**2*s**2 + 108*Dd**2*K*f**2*s - 1296*Dd**2*f**3*r*s + 324*Dd**2*f**3*r - 2916*Dd**2*f**3*s**2 + 2106*Dd**2*f**3*s - 216*Dd**2*f**3 - 720*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 1128*Dd**2*f**2*s**2 + 924*Dd**2*f**2*s - 120*Dd**2*f**2 + 3108*Dd**2*f*g2*s**2 - 1554*Dd**2*f*g2*s))/(105*d**2*k2**2*k3**2) + D1**2*Pk2*Pk3*ct**2*k1**2*(804*C*D1**2*bdd1*f**2*s**2 - 1890*C*D1**2*f**2*fd*s**2 + 1260*C*D1**2*f**2*fd*s - 630*C*D1**2*f**2*fd + 1350*C*D1**2*f**2*fdd*s**2 - 900*C*D1**2*f**2*fdd*s + 450*C*D1**2*f**2*fdd + 2700*C*D1**2*f*fd**2*s**2 - 1800*C*D1**2*f*fd**2*s - 2520*C*D1*Dd*f**3*s**2 + 1260*C*D1*Dd*f**3*s - 630*C*D1*Dd*f**3 + 10800*C*D1*Dd*f**2*fd*s**2 - 6300*C*D1*Dd*f**2*fd*s + 900*C*D1*Dd*f**2*fd + 1800*C*D1*Ddd*f**3*s**2 - 900*C*D1*Ddd*f**3*s + 450*C*D1*Ddd*f**3 + 5400*C*Dd**2*f**3*s**2 - 2700*C*Dd**2*f**3*s + 315*D1**2*K*bdd1*f**2*s**2 - 882*D1**2*b2*f*fd*s**2 + 882*D1**2*b2*f*fd*s - 441*D1**2*b2*f*fd + 630*D1**2*b2*f*fdd*s**2 - 630*D1**2*b2*f*fdd*s + 315*D1**2*b2*f*fdd + 630*D1**2*b2*fd**2*s**2 - 630*D1**2*b2*fd**2*s - 42*D1**2*bd1**2*(3*f**2*(6*r*(2*s - 1) + 10*s**2 - 18*s + 3) + f*(13*r*(2*s - 1) + s**2*(34*C - 38*K + 46) - s*(34*C + 21) + 13) - 70*g2*s*(s - 1)) - 441*D1**2*bd2*f**2*s**2 + 1260*D1**2*bd2*f*fd*s**2 - 630*D1**2*bd2*f*fd*s + 1134*D1**2*bdd1*f**3*r*s + 1134*D1**2*bdd1*f**3*s**2 - 567*D1**2*bdd1*f**3*s + 321*D1**2*bdd1*f**2*r*s + 414*D1**2*bdd1*f**2*r - 354*D1**2*bdd1*f**2*s**2 + 381*D1**2*bdd1*f**2*s - 558*D1**2*bdd1*f**2 - 1596*D1**2*bdd1*f*g2*s**2 + 315*D1**2*bdd2*f**2*s**2 - 2037*D1**2*f**2*fd*r*s + 679*D1**2*f**2*fd*r - 999*D1**2*f**2*fd*s**2 + 1345*D1**2*f**2*fd*s - 333*D1**2*f**2*fd + 1707*D1**2*f**2*fdd*r*s - 569*D1**2*f**2*fdd*r + 1269*D1**2*f**2*fdd*s**2 - 1415*D1**2*f**2*fdd*s + 423*D1**2*f**2*fdd + 882*D1**2*f**2*gd2*s**2 - 630*D1**2*f**2*gdd2*s**2 + 3414*D1**2*f*fd**2*r*s - 1138*D1**2*f*fd**2*r + 2538*D1**2*f*fd**2*s**2 - 2830*D1**2*f*fd**2*s + 569*D1**2*f*fd**2 + 1764*D1**2*f*fd*g2*s**2 - 1764*D1**2*f*fd*g2*s + 882*D1**2*f*fd*g2 - 2520*D1**2*f*fd*gd2*s**2 + 1260*D1**2*f*fd*gd2*s - 1260*D1**2*f*fdd*g2*s**2 + 1260*D1**2*f*fdd*g2*s - 630*D1**2*f*fdd*g2 - 1260*D1**2*fd**2*g2*s**2 + 1260*D1**2*fd**2*g2*s - 1764*D1*Dd*b2*f**2*s**2 + 882*D1*Dd*b2*f**2*s - 441*D1*Dd*b2*f**2 + 5040*D1*Dd*b2*f*fd*s**2 - 3780*D1*Dd*b2*f*fd*s + 630*D1*Dd*b2*f*fd + 2520*D1*Dd*bd2*f**2*s**2 - 630*D1*Dd*bd2*f**2*s - 2716*D1*Dd*f**3*r*s + 679*D1*Dd*f**3*r - 1332*D1*Dd*f**3*s**2 + 2024*D1*Dd*f**3*s - 333*D1*Dd*f**3 + 13656*D1*Dd*f**2*fd*r*s - 3983*D1*Dd*f**2*fd*r + 10152*D1*Dd*f**2*fd*s**2 - 11612*D1*Dd*f**2*fd*s + 2553*D1*Dd*f**2*fd + 3528*D1*Dd*f**2*g2*s**2 - 1764*D1*Dd*f**2*g2*s + 882*D1*Dd*f**2*g2 - 5040*D1*Dd*f**2*gd2*s**2 + 1260*D1*Dd*f**2*gd2*s - 10080*D1*Dd*f*fd*g2*s**2 + 7560*D1*Dd*f*fd*g2*s - 1260*D1*Dd*f*fd*g2 + 1260*D1*Ddd*b2*f**2*s**2 - 630*D1*Ddd*b2*f**2*s + 315*D1*Ddd*b2*f**2 + 2276*D1*Ddd*f**3*r*s - 569*D1*Ddd*f**3*r + 1692*D1*Ddd*f**3*s**2 - 1984*D1*Ddd*f**3*s + 423*D1*Ddd*f**3 - 2520*D1*Ddd*f**2*g2*s**2 + 1260*D1*Ddd*f**2*g2*s - 630*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(189*f**3*s*(2*r + 2*s - 1) + f**2*(256*C*s**2 + 147*K*s**2 - 189*fd*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + r*(95*s + 192) - 166*s**2 + 205*s - 246) - f*(fd*(r*(428*s + 31) + s**2*(1072*C + 420*K - 472) + s*(-536*C - 210*K + 256) + 107) + s**2*(504*g2 - 1064*gd2)) + 1064*fd*g2*s*(s - 1)) - Dd*f*(189*f**2*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + f*(r*(856*s + 445) + s**2*(2144*C + 840*K - 944) + s*(-536*C - 210*K + 530) - 403) + 1064*g2*s*(1 - 4*s))) + 3780*Dd**2*b2*f**2*s**2 - 1890*Dd**2*b2*f**2*s + 6828*Dd**2*f**3*r*s - 1707*Dd**2*f**3*r + 5076*Dd**2*f**3*s**2 - 5952*Dd**2*f**3*s + 1138*Dd**2*f**3 - 7560*Dd**2*f**2*g2*s**2 + 3780*Dd**2*f**2*g2*s + 105*b1**3*(K - 1)*(D1*(5*Dd - 7*Ddd)*(4*s**2 - 2*s + 1) + 42*Dd**2*s*(1 - 2*s)) + 21*b1**2*(38*C*D1**2*fd*s**2 - 34*C*D1**2*fdd*s**2 + 152*C*D1*Dd*f*s**2 - 76*C*D1*Dd*f*s + 38*C*D1*Dd*f - 272*C*D1*Dd*fd*s**2 + 68*C*D1*Dd*fd*s - 136*C*D1*Ddd*f*s**2 + 68*C*D1*Ddd*f*s - 34*C*D1*Ddd*f - 408*C*Dd**2*f*s**2 + 204*C*Dd**2*f*s - 36*D1**2*K*fd*s**2 + 72*D1**2*K*fd*s - 36*D1**2*K*fd + 38*D1**2*K*fdd*s**2 - 76*D1**2*K*fdd*s + 38*D1**2*K*fdd - 35*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) + 72*D1**2*f*fd*r*s + 84*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s - 21*D1**2*f*fd - 72*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s + 15*D1**2*f*fdd - 72*D1**2*fd**2*r*s - 60*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s + 32*D1**2*fd*r*s + 52*D1**2*fd*s**2 - 72*D1**2*fd*s + 36*D1**2*fd - 26*D1**2*fdd*r*s - 46*D1**2*fdd*s**2 + 76*D1**2*fdd*s - 38*D1**2*fdd - 50*D1**2*gd2*s**2 + 70*D1**2*gdd2*s**2 - 144*D1*Dd*K*f*s**2 + 72*D1*Dd*K*f*s - 36*D1*Dd*K*f + 304*D1*Dd*K*fd*s**2 - 380*D1*Dd*K*fd*s + 76*D1*Dd*K*fd + 144*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r + 168*D1*Dd*f**2*s**2 - 156*D1*Dd*f**2*s + 42*D1*Dd*f**2 - 576*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 24*D1*Dd*f*fd + 128*D1*Dd*f*r*s - 32*D1*Dd*f*r + 208*D1*Dd*f*s**2 - 168*D1*Dd*f*s + 52*D1*Dd*f - 208*D1*Dd*fd*r*s + 26*D1*Dd*fd*r - 368*D1*Dd*fd*s**2 + 448*D1*Dd*fd*s - 76*D1*Dd*fd - 200*D1*Dd*g2*s**2 + 100*D1*Dd*g2*s - 50*D1*Dd*g2 + 560*D1*Dd*gd2*s**2 - 140*D1*Dd*gd2*s + 152*D1*Ddd*K*f*s**2 - 76*D1*Ddd*K*f*s + 38*D1*Ddd*K*f - 144*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 132*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 - 104*D1*Ddd*f*r*s + 26*D1*Ddd*f*r - 184*D1*Ddd*f*s**2 + 144*D1*Ddd*f*s - 46*D1*Ddd*f + 280*D1*Ddd*g2*s**2 - 140*D1*Ddd*g2*s + 70*D1*Ddd*g2 + 5*D1*bd1*(K - 1)*(5*D1*(3*s**2 - 2*s + 1) - 14*Dd*(12*s**2 - 7*s + 1)) + 456*Dd**2*K*f*s**2 - 228*Dd**2*K*f*s - 432*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 396*Dd**2*f**2*s - 72*Dd**2*f**2 - 312*Dd**2*f*r*s + 78*Dd**2*f*r - 552*Dd**2*f*s**2 + 432*Dd**2*f*s - 52*Dd**2*f + 840*Dd**2*g2*s**2 - 420*Dd**2*g2*s) - 3*b1*(512*C*D1**2*f*fd*s**2 - 512*C*D1**2*f*fd*s + 256*C*D1**2*f*fd - 536*C*D1**2*f*fdd*s**2 + 536*C*D1**2*f*fdd*s - 268*C*D1**2*f*fdd - 536*C*D1**2*fd**2*s**2 + 536*C*D1**2*fd**2*s + 1024*C*D1*Dd*f**2*s**2 - 512*C*D1*Dd*f**2*s + 256*C*D1*Dd*f**2 - 4288*C*D1*Dd*f*fd*s**2 + 3216*C*D1*Dd*f*fd*s - 536*C*D1*Dd*f*fd - 1072*C*D1*Ddd*f**2*s**2 + 536*C*D1*Ddd*f**2*s - 268*C*D1*Ddd*f**2 - 3216*C*Dd**2*f**2*s**2 + 1608*C*Dd**2*f**2*s + 294*D1**2*K*f*fd*s**2 - 294*D1**2*K*f*fd*s + 147*D1**2*K*f*fd - 210*D1**2*K*f*fdd*s**2 + 210*D1**2*K*f*fdd*s - 105*D1**2*K*f*fdd - 210*D1**2*K*fd**2*s**2 + 210*D1**2*K*fd**2*s + 490*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + 7*D1**2*bdd1*(3*f**2*(12*r*(2*s - 1) + 20*s**2 - 36*s + 15) + f*(34*C*(2*s**2 - 2*s + 1) - 76*K*s**2 + 52*r*s - 26*r + 92*s**2 - 42*s + 8) - 70*g2*(2*s**2 - 2*s + 1)) + 1134*D1**2*f**2*fd*r*s - 378*D1**2*f**2*fd*r + 1134*D1**2*f**2*fd*s**2 - 1323*D1**2*f**2*fd*s + 378*D1**2*f**2*fd - 1134*D1**2*f**2*fdd*r*s + 378*D1**2*f**2*fdd*r - 1134*D1**2*f**2*fdd*s**2 + 1323*D1**2*f**2*fdd*s - 378*D1**2*f**2*fdd - 2268*D1**2*f*fd**2*r*s + 756*D1**2*f*fd**2*r - 2268*D1**2*f*fd**2*s**2 + 2646*D1**2*f*fd**2*s - 567*D1**2*f*fd**2 + 190*D1**2*f*fd*r*s - 287*D1**2*f*fd*r - 332*D1**2*f*fd*s**2 + 32*D1**2*f*fd*s + 80*D1**2*f*fd - 214*D1**2*f*fdd*r*s + 245*D1**2*f*fdd*r + 236*D1**2*f*fdd*s**2 - 2*D1**2*f*fdd*s - 68*D1**2*f*fdd - 504*D1**2*f*gd2*s**2 + 532*D1**2*f*gdd2*s**2 - 214*D1**2*fd**2*r*s + 245*D1**2*fd**2*r + 236*D1**2*fd**2*s**2 - 2*D1**2*fd**2*s - 504*D1**2*fd*g2*s**2 + 1008*D1**2*fd*g2*s - 504*D1**2*fd*g2 + 1064*D1**2*fd*gd2*s**2 - 1064*D1**2*fd*gd2*s + 532*D1**2*fdd*g2*s**2 - 1064*D1**2*fdd*g2*s + 532*D1**2*fdd*g2 + 588*D1*Dd*K*f**2*s**2 - 294*D1*Dd*K*f**2*s + 147*D1*Dd*K*f**2 - 1680*D1*Dd*K*f*fd*s**2 + 1260*D1*Dd*K*f*fd*s - 210*D1*Dd*K*f*fd + 1512*D1*Dd*f**3*r*s - 378*D1*Dd*f**3*r + 1512*D1*Dd*f**3*s**2 - 1512*D1*Dd*f**3*s + 378*D1*Dd*f**3 - 9072*D1*Dd*f**2*fd*r*s + 2646*D1*Dd*f**2*fd*r - 9072*D1*Dd*f**2*fd*s**2 + 9828*D1*Dd*f**2*fd*s - 2079*D1*Dd*f**2*fd + 380*D1*Dd*f**2*r*s - 95*D1*Dd*f**2*r - 664*D1*Dd*f**2*s**2 + 142*D1*Dd*f**2*s - 166*D1*Dd*f**2 - 1712*D1*Dd*f*fd*r*s + 1194*D1*Dd*f*fd*r + 1888*D1*Dd*f*fd*s**2 - 52*D1*Dd*f*fd*s - 488*D1*Dd*f*fd - 2016*D1*Dd*f*g2*s**2 + 1008*D1*Dd*f*g2*s - 504*D1*Dd*f*g2 + 4256*D1*Dd*f*gd2*s**2 - 1064*D1*Dd*f*gd2*s + 4256*D1*Dd*fd*g2*s**2 - 5320*D1*Dd*fd*g2*s + 1064*D1*Dd*fd*g2 - 420*D1*Ddd*K*f**2*s**2 + 210*D1*Ddd*K*f**2*s - 105*D1*Ddd*K*f**2 - 1512*D1*Ddd*f**3*r*s + 378*D1*Ddd*f**3*r - 1512*D1*Ddd*f**3*s**2 + 1512*D1*Ddd*f**3*s - 378*D1*Ddd*f**3 - 428*D1*Ddd*f**2*r*s + 107*D1*Ddd*f**2*r + 472*D1*Ddd*f**2*s**2 - 22*D1*Ddd*f**2*s + 118*D1*Ddd*f**2 + 2128*D1*Ddd*f*g2*s**2 - 1064*D1*Ddd*f*g2*s + 532*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(3*f**2*(12*r*(2*s - 1) + 28*s**2 - 48*s + 21) + 2*f*(19*C*(2*s**2 - 2*s + 1) - 3*fd*(12*r*(4*s - 1) + 40*s**2 - 44*s + 9) + 4*r*(8*s - 4) + 4*s**2*(13 - 9*K) - 32*s + 8) - 26*fd*r*(4*s - 1) - 2*fd*s*(34*C*(2*s - 1) - 76*K*(s - 1) + 92*s - 97) - 50*g2*(2*s**2 - 2*s + 1) - 140*gd2*s*(1 - 2*s)) - 2*Dd*(6*f**2*(6*r*(8*s - 3) + 40*s**2 - 58*s + 15) + f*(34*C*(8*s**2 - 6*s + 1) - 304*K*s**2 + 76*K*s + 26*r*(8*s - 3) + 368*s**2 - 228*s + 47) - 70*g2*(8*s**2 - 6*s + 1))) - 1260*Dd**2*K*f**2*s**2 + 630*Dd**2*K*f**2*s - 4536*Dd**2*f**3*r*s + 1134*Dd**2*f**3*r - 4536*Dd**2*f**3*s**2 + 4536*Dd**2*f**3*s - 756*Dd**2*f**3 - 1284*Dd**2*f**2*r*s + 321*Dd**2*f**2*r + 1416*Dd**2*f**2*s**2 - 66*Dd**2*f**2*s - 214*Dd**2*f**2 + 6384*Dd**2*f*g2*s**2 - 3192*Dd**2*f*g2*s))/(315*d**2*k2**2*k3**2) - 12*D1**2*Pk2*Pk3*ct**2*k2**6*st**4*(D1**2*(f**2*(fd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-3*K*(-2*bd1 + bdd1) - 12*gd2 + 6*gdd2)) + f*(-fd**2*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 6*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 6*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(3*K*(b1*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - fd*(2*C - 1)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 6*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(3*K*b1 + f*(2*C - 1) - 6*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(3*K*b1 + f*(2*C - 1) - 6*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(7*d**2*k3**8) - 24*D1**2*Pk2*Pk3*ct**2*k2**6*st**2*(24*C*D1**2*b1*f*fd*r**2 + 48*C*D1**2*b1*f*fd*r*s - 24*C*D1**2*b1*f*fd*r + 24*C*D1**2*b1*f*fd*s**2 - 24*C*D1**2*b1*f*fd*s + 12*C*D1**2*b1*f*fd - 12*C*D1**2*b1*f*fdd*r**2 - 24*C*D1**2*b1*f*fdd*r*s + 12*C*D1**2*b1*f*fdd*r - 12*C*D1**2*b1*f*fdd*s**2 + 12*C*D1**2*b1*f*fdd*s - 6*C*D1**2*b1*f*fdd - 12*C*D1**2*b1*fd**2*r**2 - 24*C*D1**2*b1*fd**2*r*s + 12*C*D1**2*b1*fd**2*r - 12*C*D1**2*b1*fd**2*s**2 + 12*C*D1**2*b1*fd**2*s - 18*C*D1**2*f**2*fd*r**2 - 36*C*D1**2*f**2*fd*r*s + 24*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 12*C*D1**2*f**2*fd + 48*C*D1*Dd*b1*f**2*r**2 + 96*C*D1*Dd*b1*f**2*r*s - 72*C*D1*Dd*b1*f**2*r + 48*C*D1*Dd*b1*f**2*s**2 - 72*C*D1*Dd*b1*f**2*s + 36*C*D1*Dd*b1*f**2 - 96*C*D1*Dd*b1*f*fd*r**2 - 192*C*D1*Dd*b1*f*fd*r*s + 120*C*D1*Dd*b1*f*fd*r - 96*C*D1*Dd*b1*f*fd*s**2 + 120*C*D1*Dd*b1*f*fd*s - 36*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r**2 - 48*C*D1*Dd*f**3*r*s + 36*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 36*C*D1*Dd*f**3*s - 18*C*D1*Dd*f**3 - 24*C*D1*Ddd*b1*f**2*r**2 - 48*C*D1*Ddd*b1*f**2*r*s + 36*C*D1*Ddd*b1*f**2*r - 24*C*D1*Ddd*b1*f**2*s**2 + 36*C*D1*Ddd*b1*f**2*s - 18*C*D1*Ddd*b1*f**2 - 72*C*Dd**2*b1*f**2*r**2 - 144*C*Dd**2*b1*f**2*r*s + 108*C*Dd**2*b1*f**2*r - 72*C*Dd**2*b1*f**2*s**2 + 108*C*Dd**2*b1*f**2*s - 36*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r**2 + 28*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r**2 - 14*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 14*D1**2*K*bd1**2*f*(r + s - 1)**2 - 12*D1**2*b1*f*fd*r**2 - 24*D1**2*b1*f*fd*r*s + 12*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s**2 + 12*D1**2*b1*f*fd*s - 6*D1**2*b1*f*fd + 6*D1**2*b1*f*fdd*r**2 + 12*D1**2*b1*f*fdd*r*s - 6*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 - 6*D1**2*b1*f*fdd*s + 3*D1**2*b1*f*fdd - 28*D1**2*b1*f*gd2*r**2 - 56*D1**2*b1*f*gd2*r*s + 56*D1**2*b1*f*gd2*r - 28*D1**2*b1*f*gd2*s**2 + 56*D1**2*b1*f*gd2*s - 28*D1**2*b1*f*gd2 + 14*D1**2*b1*f*gdd2*r**2 + 28*D1**2*b1*f*gdd2*r*s - 28*D1**2*b1*f*gdd2*r + 14*D1**2*b1*f*gdd2*s**2 - 28*D1**2*b1*f*gdd2*s + 14*D1**2*b1*f*gdd2 + 6*D1**2*b1*fd**2*r**2 + 12*D1**2*b1*fd**2*r*s - 6*D1**2*b1*fd**2*r + 6*D1**2*b1*fd**2*s**2 - 6*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r**2 - 56*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r**2 + 56*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*r + 28*D1**2*b1*fd*gd2*s**2 - 28*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r**2 + 28*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(6*C*f + 14*K*b1 - 3*f - 14*g2) + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r**2 + 112*D1*Dd*K*b1**2*f*r*s - 84*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 84*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r**2 - 112*D1*Dd*K*b1**2*fd*r*s + 42*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 42*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 - 24*D1*Dd*b1*f**2*r**2 - 48*D1*Dd*b1*f**2*r*s + 36*D1*Dd*b1*f**2*r - 24*D1*Dd*b1*f**2*s**2 + 36*D1*Dd*b1*f**2*s - 18*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 96*D1*Dd*b1*f*fd*r*s - 60*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 60*D1*Dd*b1*f*fd*s + 18*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r**2 - 224*D1*Dd*b1*f*g2*r*s + 168*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 168*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r**2 + 224*D1*Dd*b1*f*gd2*r*s - 196*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 196*D1*Dd*b1*f*gd2*s + 84*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r**2 + 224*D1*Dd*b1*fd*g2*r*s - 84*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 84*D1*Dd*b1*fd*g2*s + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r**2 - 56*D1*Ddd*K*b1**2*f*r*s + 42*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 42*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 12*D1*Ddd*b1*f**2*r**2 + 24*D1*Ddd*b1*f**2*r*s - 18*D1*Ddd*b1*f**2*r + 12*D1*Ddd*b1*f**2*s**2 - 18*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r**2 + 112*D1*Ddd*b1*f*g2*r*s - 84*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 84*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(12*C - 7*K - 6)*(r + s - 1) - f*fd*(12*C - 6)*(2*r + 2*s - 1) - 28*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(6*C*f + 14*K*b1 - 3*f - 14*g2))*(r + s - 1) - 84*Dd**2*K*b1**2*f*r**2 - 168*Dd**2*K*b1**2*f*r*s + 126*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 126*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 36*Dd**2*b1*f**2*r**2 + 72*Dd**2*b1*f**2*r*s - 54*Dd**2*b1*f**2*r + 36*Dd**2*b1*f**2*s**2 - 54*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r**2 + 336*Dd**2*b1*f*g2*r*s - 252*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 252*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(35*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**2*k2**4*st**4*(732*C*D1**2*f**2*fd*r**2 + 912*C*D1**2*f**2*fd*r*s - 792*C*D1**2*f**2*fd*r + 180*C*D1**2*f**2*fd*s**2 - 424*C*D1**2*f**2*fd*s + 304*C*D1**2*f**2*fd - 510*C*D1**2*f**2*fdd*r**2 - 600*C*D1**2*f**2*fdd*r*s + 540*C*D1**2*f**2*fdd*r - 90*C*D1**2*f**2*fdd*s**2 + 260*C*D1**2*f**2*fdd*s - 200*C*D1**2*f**2*fdd - 1020*C*D1**2*f*fd**2*r**2 - 1200*C*D1**2*f*fd**2*r*s + 1080*C*D1**2*f*fd**2*r - 180*C*D1**2*f*fd**2*s**2 + 520*C*D1**2*f*fd**2*s - 200*C*D1**2*f*fd**2 + 976*C*D1*Dd*f**3*r**2 + 1216*C*D1*Dd*f**3*r*s - 1280*C*D1*Dd*f**3*r + 240*C*D1*Dd*f**3*s**2 - 728*C*D1*Dd*f**3*s + 548*C*D1*Dd*f**3 - 4080*C*D1*Dd*f**2*fd*r**2 - 4800*C*D1*Dd*f**2*fd*r*s + 4800*C*D1*Dd*f**2*fd*r - 720*C*D1*Dd*f**2*fd*s**2 + 2420*C*D1*Dd*f**2*fd*s - 1340*C*D1*Dd*f**2*fd - 680*C*D1*Ddd*f**3*r**2 - 800*C*D1*Ddd*f**3*r*s + 880*C*D1*Ddd*f**3*r - 120*C*D1*Ddd*f**3*s**2 + 460*C*D1*Ddd*f**3*s - 370*C*D1*Ddd*f**3 - 2040*C*Dd**2*f**3*r**2 - 2400*C*Dd**2*f**3*r*s + 2640*C*Dd**2*f**3*r - 360*C*Dd**2*f**3*s**2 + 1380*C*Dd**2*f**3*s - 740*C*Dd**2*f**3 + 540*D1**2*K*b1*f*fd*r**2 + 720*D1**2*K*b1*f*fd*r*s - 360*D1**2*K*b1*f*fd*r + 180*D1**2*K*b1*f*fd*s**2 - 180*D1**2*K*b1*f*fd*s + 90*D1**2*K*b1*f*fd - 270*D1**2*K*b1*f*fdd*r**2 - 360*D1**2*K*b1*f*fdd*r*s + 180*D1**2*K*b1*f*fdd*r - 90*D1**2*K*b1*f*fdd*s**2 + 90*D1**2*K*b1*f*fdd*s - 45*D1**2*K*b1*f*fdd - 270*D1**2*K*b1*fd**2*r**2 - 360*D1**2*K*b1*fd**2*r*s + 180*D1**2*K*b1*fd**2*r - 90*D1**2*K*b1*fd**2*s**2 + 90*D1**2*K*b1*fd**2*s - 135*D1**2*K*bdd1*f**2*r**2 - 180*D1**2*K*bdd1*f**2*r*s + 270*D1**2*K*bdd1*f**2*r - 45*D1**2*K*bdd1*f**2*s**2 + 180*D1**2*K*bdd1*f**2*s - 135*D1**2*K*bdd1*f**2 - 135*D1**2*b1*f**2*fd*r**2 - 135*D1**2*b1*f**2*fd*r*s + 135*D1**2*b1*f**2*fd*r + 45*D1**2*b1*f**2*fd*s - 45*D1**2*b1*f**2*fd + 135*D1**2*b1*f**2*fdd*r**2 + 135*D1**2*b1*f**2*fdd*r*s - 135*D1**2*b1*f**2*fdd*r - 45*D1**2*b1*f**2*fdd*s + 45*D1**2*b1*f**2*fdd + 270*D1**2*b1*f*fd**2*r**2 + 270*D1**2*b1*f*fd**2*r*s - 270*D1**2*b1*f*fd**2*r - 90*D1**2*b1*f*fd**2*s + 45*D1**2*b1*f*fd**2 - 180*D1**2*b1*f*fd*r**2 - 180*D1**2*b1*f*fd*r*s + 90*D1**2*b1*f*fd*r + 90*D1**2*b1*f*fdd*r**2 + 90*D1**2*b1*f*fdd*r*s - 45*D1**2*b1*f*fdd*r + 90*D1**2*b1*fd**2*r**2 + 90*D1**2*b1*fd**2*r*s - 45*D1**2*b1*fd**2*r + 180*D1**2*b2*f*fd*r**2 + 360*D1**2*b2*f*fd*r*s - 180*D1**2*b2*f*fd*r + 180*D1**2*b2*f*fd*s**2 - 180*D1**2*b2*f*fd*s + 90*D1**2*b2*f*fd - 90*D1**2*b2*f*fdd*r**2 - 180*D1**2*b2*f*fdd*r*s + 90*D1**2*b2*f*fdd*r - 90*D1**2*b2*f*fdd*s**2 + 90*D1**2*b2*f*fdd*s - 45*D1**2*b2*f*fdd - 90*D1**2*b2*fd**2*r**2 - 180*D1**2*b2*fd**2*r*s + 90*D1**2*b2*fd**2*r - 90*D1**2*b2*fd**2*s**2 + 90*D1**2*b2*fd**2*s + 45*D1**2*bdd1*f**3*r**2 + 45*D1**2*bdd1*f**3*r*s - 90*D1**2*bdd1*f**3*r - 45*D1**2*bdd1*f**3*s + 45*D1**2*bdd1*f**3 + 45*D1**2*bdd1*f**2*r**2 + 45*D1**2*bdd1*f**2*r*s - 90*D1**2*bdd1*f**2*r - 45*D1**2*bdd1*f**2*s + 45*D1**2*bdd1*f**2 - 45*D1**2*bdd2*f**2*r**2 - 90*D1**2*bdd2*f**2*r*s + 90*D1**2*bdd2*f**2*r - 45*D1**2*bdd2*f**2*s**2 + 90*D1**2*bdd2*f**2*s - 45*D1**2*bdd2*f**2 - 504*D1**2*f**2*fd*r**2 - 594*D1**2*f**2*fd*r*s + 534*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 258*D1**2*f**2*fd*s - 198*D1**2*f**2*fd + 360*D1**2*f**2*fdd*r**2 + 405*D1**2*f**2*fdd*r*s - 375*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 165*D1**2*f**2*fdd*s + 135*D1**2*f**2*fdd - 540*D1**2*f**2*gd2*r**2 - 720*D1**2*f**2*gd2*r*s + 1080*D1**2*f**2*gd2*r - 180*D1**2*f**2*gd2*s**2 + 720*D1**2*f**2*gd2*s - 540*D1**2*f**2*gd2 + 270*D1**2*f**2*gdd2*r**2 + 360*D1**2*f**2*gdd2*r*s - 540*D1**2*f**2*gdd2*r + 90*D1**2*f**2*gdd2*s**2 - 360*D1**2*f**2*gdd2*s + 270*D1**2*f**2*gdd2 + 720*D1**2*f*fd**2*r**2 + 810*D1**2*f*fd**2*r*s - 750*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 330*D1**2*f*fd**2*s + 135*D1**2*f*fd**2 - 1080*D1**2*f*fd*g2*r**2 - 1440*D1**2*f*fd*g2*r*s + 720*D1**2*f*fd*g2*r - 360*D1**2*f*fd*g2*s**2 + 360*D1**2*f*fd*g2*s - 180*D1**2*f*fd*g2 + 1080*D1**2*f*fd*gd2*r**2 + 1440*D1**2*f*fd*gd2*r*s - 1440*D1**2*f*fd*gd2*r + 360*D1**2*f*fd*gd2*s**2 - 900*D1**2*f*fd*gd2*s + 360*D1**2*f*fd*gd2 + 540*D1**2*f*fdd*g2*r**2 + 720*D1**2*f*fdd*g2*r*s - 360*D1**2*f*fdd*g2*r + 180*D1**2*f*fdd*g2*s**2 - 180*D1**2*f*fdd*g2*s + 90*D1**2*f*fdd*g2 + 540*D1**2*fd**2*g2*r**2 + 720*D1**2*fd**2*g2*r*s - 360*D1**2*fd**2*g2*r + 180*D1**2*fd**2*g2*s**2 - 180*D1**2*fd**2*g2*s + 1080*D1*Dd*K*b1*f**2*r**2 + 1440*D1*Dd*K*b1*f**2*r*s - 1440*D1*Dd*K*b1*f**2*r + 360*D1*Dd*K*b1*f**2*s**2 - 900*D1*Dd*K*b1*f**2*s + 630*D1*Dd*K*b1*f**2 - 2160*D1*Dd*K*b1*f*fd*r**2 - 2880*D1*Dd*K*b1*f*fd*r*s + 2160*D1*Dd*K*b1*f*fd*r - 720*D1*Dd*K*b1*f*fd*s**2 + 1260*D1*Dd*K*b1*f*fd*s - 450*D1*Dd*K*b1*f*fd - 180*D1*Dd*b1*f**3*r**2 - 180*D1*Dd*b1*f**3*r*s + 225*D1*Dd*b1*f**3*r + 90*D1*Dd*b1*f**3*s - 90*D1*Dd*b1*f**3 + 1080*D1*Dd*b1*f**2*fd*r**2 + 1080*D1*Dd*b1*f**2*fd*r*s - 1215*D1*Dd*b1*f**2*fd*r - 450*D1*Dd*b1*f**2*fd*s + 315*D1*Dd*b1*f**2*fd - 360*D1*Dd*b1*f**2*r**2 - 360*D1*Dd*b1*f**2*r*s + 450*D1*Dd*b1*f**2*r + 180*D1*Dd*b1*f**2*s - 180*D1*Dd*b1*f**2 + 720*D1*Dd*b1*f*fd*r**2 + 720*D1*Dd*b1*f*fd*r*s - 630*D1*Dd*b1*f*fd*r - 180*D1*Dd*b1*f*fd*s + 90*D1*Dd*b1*f*fd + 360*D1*Dd*b2*f**2*r**2 + 720*D1*Dd*b2*f**2*r*s - 540*D1*Dd*b2*f**2*r + 360*D1*Dd*b2*f**2*s**2 - 540*D1*Dd*b2*f**2*s + 270*D1*Dd*b2*f**2 - 720*D1*Dd*b2*f*fd*r**2 - 1440*D1*Dd*b2*f*fd*r*s + 900*D1*Dd*b2*f*fd*r - 720*D1*Dd*b2*f*fd*s**2 + 900*D1*Dd*b2*f*fd*s - 270*D1*Dd*b2*f*fd - 672*D1*Dd*f**3*r**2 - 792*D1*Dd*f**3*r*s + 870*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 456*D1*Dd*f**3*s - 366*D1*Dd*f**3 + 2880*D1*Dd*f**2*fd*r**2 + 3240*D1*Dd*f**2*fd*r*s - 3345*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 1560*D1*Dd*f**2*fd*s + 915*D1*Dd*f**2*fd - 2160*D1*Dd*f**2*g2*r**2 - 2880*D1*Dd*f**2*g2*r*s + 2880*D1*Dd*f**2*g2*r - 720*D1*Dd*f**2*g2*s**2 + 1800*D1*Dd*f**2*g2*s - 1260*D1*Dd*f**2*g2 + 2160*D1*Dd*f**2*gd2*r**2 + 2880*D1*Dd*f**2*gd2*r*s - 3600*D1*Dd*f**2*gd2*r + 720*D1*Dd*f**2*gd2*s**2 - 2340*D1*Dd*f**2*gd2*s + 1440*D1*Dd*f**2*gd2 + 4320*D1*Dd*f*fd*g2*r**2 + 5760*D1*Dd*f*fd*g2*r*s - 4320*D1*Dd*f*fd*g2*r + 1440*D1*Dd*f*fd*g2*s**2 - 2520*D1*Dd*f*fd*g2*s + 900*D1*Dd*f*fd*g2 - 540*D1*Ddd*K*b1*f**2*r**2 - 720*D1*Ddd*K*b1*f**2*r*s + 720*D1*Ddd*K*b1*f**2*r - 180*D1*Ddd*K*b1*f**2*s**2 + 450*D1*Ddd*K*b1*f**2*s - 315*D1*Ddd*K*b1*f**2 + 180*D1*Ddd*b1*f**3*r**2 + 180*D1*Ddd*b1*f**3*r*s - 225*D1*Ddd*b1*f**3*r - 90*D1*Ddd*b1*f**3*s + 90*D1*Ddd*b1*f**3 + 180*D1*Ddd*b1*f**2*r**2 + 180*D1*Ddd*b1*f**2*r*s - 225*D1*Ddd*b1*f**2*r - 90*D1*Ddd*b1*f**2*s + 90*D1*Ddd*b1*f**2 - 180*D1*Ddd*b2*f**2*r**2 - 360*D1*Ddd*b2*f**2*r*s + 270*D1*Ddd*b2*f**2*r - 180*D1*Ddd*b2*f**2*s**2 + 270*D1*Ddd*b2*f**2*s - 135*D1*Ddd*b2*f**2 + 480*D1*Ddd*f**3*r**2 + 540*D1*Ddd*f**3*r*s - 615*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 255*D1*Ddd*f**3 + 1080*D1*Ddd*f**2*g2*r**2 + 1440*D1*Ddd*f**2*g2*r*s - 1440*D1*Ddd*f**2*g2*r + 360*D1*Ddd*f**2*g2*s**2 - 900*D1*Ddd*f**2*g2*s + 630*D1*Ddd*f**2*g2 - 45*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (2*r + 2*s - 2)*(K*(3*r + s - 3) - r + 1)) + fd*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(2*K*(12*r**2 + 4*r*(4*s - 5) + 4*s**2 - 13*s + 8) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) + 90*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1620*Dd**2*K*b1*f**2*r**2 - 2160*Dd**2*K*b1*f**2*r*s + 2160*Dd**2*K*b1*f**2*r - 540*Dd**2*K*b1*f**2*s**2 + 1350*Dd**2*K*b1*f**2*s - 630*Dd**2*K*b1*f**2 + 540*Dd**2*b1*f**3*r**2 + 540*Dd**2*b1*f**3*r*s - 675*Dd**2*b1*f**3*r - 270*Dd**2*b1*f**3*s + 180*Dd**2*b1*f**3 + 540*Dd**2*b1*f**2*r**2 + 540*Dd**2*b1*f**2*r*s - 675*Dd**2*b1*f**2*r - 270*Dd**2*b1*f**2*s + 180*Dd**2*b1*f**2 - 540*Dd**2*b2*f**2*r**2 - 1080*Dd**2*b2*f**2*r*s + 810*Dd**2*b2*f**2*r - 540*Dd**2*b2*f**2*s**2 + 810*Dd**2*b2*f**2*s - 270*Dd**2*b2*f**2 + 1440*Dd**2*f**3*r**2 + 1620*Dd**2*f**3*r*s - 1845*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 510*Dd**2*f**3 + 3240*Dd**2*f**2*g2*r**2 + 4320*Dd**2*f**2*g2*r*s - 4320*Dd**2*f**2*g2*r + 1080*Dd**2*f**2*g2*s**2 - 2700*Dd**2*f**2*g2*s + 1260*Dd**2*f**2*g2)/(105*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**2*k2**4*st**2*(-224*C*D1**2*bd1*f**2*r**2 - 368*C*D1**2*bd1*f**2*r*s + 512*C*D1**2*bd1*f**2*r - 144*C*D1**2*bd1*f**2*s**2 + 432*C*D1**2*bd1*f**2*s - 216*C*D1**2*bd1*f**2 + 672*C*D1**2*bd1*f*fd*r**2 + 960*C*D1**2*bd1*f*fd*r*s - 888*C*D1**2*bd1*f*fd*r + 288*C*D1**2*bd1*f*fd*s**2 - 600*C*D1**2*bd1*f*fd*s + 312*C*D1**2*bd1*f*fd + 168*C*D1**2*bdd1*f**2*r**2 + 240*C*D1**2*bdd1*f**2*r*s - 312*C*D1**2*bdd1*f**2*r + 72*C*D1**2*bdd1*f**2*s**2 - 216*C*D1**2*bdd1*f**2*s + 108*C*D1**2*bdd1*f**2 - 198*C*D1**2*f**2*fd*r**2 - 468*C*D1**2*f**2*fd*r*s + 288*C*D1**2*f**2*fd*r - 270*C*D1**2*f**2*fd*s**2 + 336*C*D1**2*f**2*fd*s - 156*C*D1**2*f**2*fd + 558*C*D1**2*f**2*fdd*r**2 + 1044*C*D1**2*f**2*fdd*r*s - 720*C*D1**2*f**2*fdd*r + 486*C*D1**2*f**2*fdd*s**2 - 672*C*D1**2*f**2*fdd*s + 348*C*D1**2*f**2*fdd + 1116*C*D1**2*f*fd**2*r**2 + 2088*C*D1**2*f*fd**2*r*s - 1440*C*D1**2*f*fd**2*r + 972*C*D1**2*f*fd**2*s**2 - 1344*C*D1**2*f*fd**2*s + 348*C*D1**2*f*fd**2 + 1344*C*D1*Dd*bd1*f**2*r**2 + 1920*C*D1*Dd*bd1*f**2*r*s - 2160*C*D1*Dd*bd1*f**2*r + 576*C*D1*Dd*bd1*f**2*s**2 - 1488*C*D1*Dd*bd1*f**2*s + 840*C*D1*Dd*bd1*f**2 - 264*C*D1*Dd*f**3*r**2 - 624*C*D1*Dd*f**3*r*s + 420*C*D1*Dd*f**3*r - 360*C*D1*Dd*f**3*s**2 + 492*C*D1*Dd*f**3*s - 222*C*D1*Dd*f**3 + 4464*C*D1*Dd*f**2*fd*r**2 + 8352*C*D1*Dd*f**2*fd*r*s - 6156*C*D1*Dd*f**2*fd*r + 3888*C*D1*Dd*f**2*fd*s**2 - 5748*C*D1*Dd*f**2*fd*s + 2112*C*D1*Dd*f**2*fd + 744*C*D1*Ddd*f**3*r**2 + 1392*C*D1*Ddd*f**3*r*s - 1092*C*D1*Ddd*f**3*r + 648*C*D1*Ddd*f**3*s**2 - 1020*C*D1*Ddd*f**3*s + 534*C*D1*Ddd*f**3 + 2232*C*Dd**2*f**3*r**2 + 4176*C*Dd**2*f**3*r*s - 3276*C*Dd**2*f**3*r + 1944*C*Dd**2*f**3*s**2 - 3060*C*Dd**2*f**3*s + 1068*C*Dd**2*f**3 + 168*D1**2*K*bd1**2*f*r**2 + 336*D1**2*K*bd1**2*f*r*s - 420*D1**2*K*bd1**2*f*r + 168*D1**2*K*bd1**2*f*s**2 - 420*D1**2*K*bd1**2*f*s + 252*D1**2*K*bd1**2*f + 63*D1**2*K*bd1*f**2*r**2 - 42*D1**2*K*bd1*f**2*r*s - 126*D1**2*K*bd1*f**2*r - 105*D1**2*K*bd1*f**2*s**2 + 42*D1**2*K*bd1*f**2*s + 63*D1**2*K*bd1*f**2 + 420*D1**2*K*bd1*f*fd*r**2 + 1176*D1**2*K*bd1*f*fd*r*s - 714*D1**2*K*bd1*f*fd*r + 756*D1**2*K*bd1*f*fd*s**2 - 966*D1**2*K*bd1*f*fd*s + 294*D1**2*K*bd1*f*fd + 105*D1**2*K*bdd1*f**2*r**2 + 294*D1**2*K*bdd1*f**2*r*s - 210*D1**2*K*bdd1*f**2*r + 189*D1**2*K*bdd1*f**2*s**2 - 294*D1**2*K*bdd1*f**2*s + 105*D1**2*K*bdd1*f**2 - 84*D1**2*bd1**2*f**2*r**2 - 84*D1**2*bd1**2*f**2*r*s + 126*D1**2*bd1**2*f**2*r + 42*D1**2*bd1**2*f**2*s - 42*D1**2*bd1**2*f**2 - 84*D1**2*bd1**2*f*r**2 - 84*D1**2*bd1**2*f*r*s + 126*D1**2*bd1**2*f*r + 42*D1**2*bd1**2*f*s - 42*D1**2*bd1**2*f + 84*D1**2*bd1*bd2*f*r**2 + 168*D1**2*bd1*bd2*f*r*s - 168*D1**2*bd1*bd2*f*r + 84*D1**2*bd1*bd2*f*s**2 - 168*D1**2*bd1*bd2*f*s + 84*D1**2*bd1*bd2*f + 126*D1**2*bd1*f**2*r**2 + 198*D1**2*bd1*f**2*r*s - 228*D1**2*bd1*f**2*r + 72*D1**2*bd1*f**2*s**2 - 174*D1**2*bd1*f**2*s + 66*D1**2*bd1*f**2 - 504*D1**2*bd1*f*fd*r**2 - 648*D1**2*bd1*f*fd*r*s + 612*D1**2*bd1*f*fd*r - 144*D1**2*bd1*f*fd*s**2 + 342*D1**2*bd1*f*fd*s - 198*D1**2*bd1*f*fd + 336*D1**2*bd1*f*g2*r**2 + 672*D1**2*bd1*f*g2*r*s - 1008*D1**2*bd1*f*g2*r + 336*D1**2*bd1*f*g2*s**2 - 1008*D1**2*bd1*f*g2*s + 504*D1**2*bd1*f*g2 - 336*D1**2*bd1*f*gd2*r**2 - 672*D1**2*bd1*f*gd2*r*s + 840*D1**2*bd1*f*gd2*r - 336*D1**2*bd1*f*gd2*s**2 + 840*D1**2*bd1*f*gd2*s - 504*D1**2*bd1*f*gd2 - 336*D1**2*bd1*fd*g2*r**2 - 672*D1**2*bd1*fd*g2*r*s + 336*D1**2*bd1*fd*g2*r - 336*D1**2*bd1*fd*g2*s**2 + 336*D1**2*bd1*fd*g2*s + 42*D1**2*bd2*f**2*r**2 + 84*D1**2*bd2*f**2*r*s - 84*D1**2*bd2*f**2*r + 42*D1**2*bd2*f**2*s**2 - 84*D1**2*bd2*f**2*s + 42*D1**2*bd2*f**2 - 126*D1**2*bdd1*f**2*r**2 - 162*D1**2*bdd1*f**2*r*s + 198*D1**2*bdd1*f**2*r - 36*D1**2*bdd1*f**2*s**2 + 108*D1**2*bdd1*f**2*s - 54*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r**2 - 336*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 168*D1**2*bdd1*f*g2*s**2 + 504*D1**2*bdd1*f*g2*s - 252*D1**2*bdd1*f*g2 + 45*D1**2*f**2*fd*r**2 + 180*D1**2*f**2*fd*r*s - 90*D1**2*f**2*fd*r + 135*D1**2*f**2*fd*s**2 - 150*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 279*D1**2*f**2*fdd*r**2 - 522*D1**2*f**2*fdd*r*s + 360*D1**2*f**2*fdd*r - 243*D1**2*f**2*fdd*s**2 + 336*D1**2*f**2*fdd*s - 174*D1**2*f**2*fdd - 126*D1**2*f**2*gd2*r**2 + 84*D1**2*f**2*gd2*r*s + 252*D1**2*f**2*gd2*r + 210*D1**2*f**2*gd2*s**2 - 84*D1**2*f**2*gd2*s - 126*D1**2*f**2*gd2 - 210*D1**2*f**2*gdd2*r**2 - 588*D1**2*f**2*gdd2*r*s + 420*D1**2*f**2*gdd2*r - 378*D1**2*f**2*gdd2*s**2 + 588*D1**2*f**2*gdd2*s - 210*D1**2*f**2*gdd2 - 558*D1**2*f*fd**2*r**2 - 1044*D1**2*f*fd**2*r*s + 720*D1**2*f*fd**2*r - 486*D1**2*f*fd**2*s**2 + 672*D1**2*f*fd**2*s - 174*D1**2*f*fd**2 - 252*D1**2*f*fd*g2*r**2 + 168*D1**2*f*fd*g2*r*s - 84*D1**2*f*fd*g2*r + 420*D1**2*f*fd*g2*s**2 - 420*D1**2*f*fd*g2*s + 210*D1**2*f*fd*g2 - 840*D1**2*f*fd*gd2*r**2 - 2352*D1**2*f*fd*gd2*r*s + 1428*D1**2*f*fd*gd2*r - 1512*D1**2*f*fd*gd2*s**2 + 1932*D1**2*f*fd*gd2*s - 588*D1**2*f*fd*gd2 - 420*D1**2*f*fdd*g2*r**2 - 1176*D1**2*f*fdd*g2*r*s + 588*D1**2*f*fdd*g2*r - 756*D1**2*f*fdd*g2*s**2 + 756*D1**2*f*fdd*g2*s - 378*D1**2*f*fdd*g2 - 420*D1**2*fd**2*g2*r**2 - 1176*D1**2*fd**2*g2*r*s + 588*D1**2*fd**2*g2*r - 756*D1**2*fd**2*g2*s**2 + 756*D1**2*fd**2*g2*s + 840*D1*Dd*K*bd1*f**2*r**2 + 2352*D1*Dd*K*bd1*f**2*r*s - 1554*D1*Dd*K*bd1*f**2*r + 1512*D1*Dd*K*bd1*f**2*s**2 - 2142*D1*Dd*K*bd1*f**2*s + 714*D1*Dd*K*bd1*f**2 - 1008*D1*Dd*bd1*f**2*r**2 - 1296*D1*Dd*bd1*f**2*r*s + 1458*D1*Dd*bd1*f**2*r - 288*D1*Dd*bd1*f**2*s**2 + 828*D1*Dd*bd1*f**2*s - 504*D1*Dd*bd1*f**2 - 1344*D1*Dd*bd1*f*g2*r**2 - 2688*D1*Dd*bd1*f*g2*r*s + 3024*D1*Dd*bd1*f*g2*r - 1344*D1*Dd*bd1*f*g2*s**2 + 3024*D1*Dd*bd1*f*g2*s - 1512*D1*Dd*bd1*f*g2 + 60*D1*Dd*f**3*r**2 + 240*D1*Dd*f**3*r*s - 120*D1*Dd*f**3*r + 180*D1*Dd*f**3*s**2 - 210*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 2232*D1*Dd*f**2*fd*r**2 - 4176*D1*Dd*f**2*fd*r*s + 3078*D1*Dd*f**2*fd*r - 1944*D1*Dd*f**2*fd*s**2 + 2874*D1*Dd*f**2*fd*s - 1056*D1*Dd*f**2*fd - 504*D1*Dd*f**2*g2*r**2 + 336*D1*Dd*f**2*g2*r*s + 420*D1*Dd*f**2*g2*r + 840*D1*Dd*f**2*g2*s**2 - 588*D1*Dd*f**2*g2*s - 42*D1*Dd*f**2*g2 - 1680*D1*Dd*f**2*gd2*r**2 - 4704*D1*Dd*f**2*gd2*r*s + 3108*D1*Dd*f**2*gd2*r - 3024*D1*Dd*f**2*gd2*s**2 + 4284*D1*Dd*f**2*gd2*s - 1428*D1*Dd*f**2*gd2 - 3360*D1*Dd*f*fd*g2*r**2 - 9408*D1*Dd*f*fd*g2*r*s + 5208*D1*Dd*f*fd*g2*r - 6048*D1*Dd*f*fd*g2*s**2 + 6888*D1*Dd*f*fd*g2*s - 1932*D1*Dd*f*fd*g2 - 372*D1*Ddd*f**3*r**2 - 696*D1*Ddd*f**3*r*s + 546*D1*Ddd*f**3*r - 324*D1*Ddd*f**3*s**2 + 510*D1*Ddd*f**3*s - 267*D1*Ddd*f**3 - 840*D1*Ddd*f**2*g2*r**2 - 2352*D1*Ddd*f**2*g2*r*s + 1428*D1*Ddd*f**2*g2*r - 1512*D1*Ddd*f**2*g2*s**2 + 1932*D1*Ddd*f**2*g2*s - 798*D1*Ddd*f**2*g2 - 84*D1*b2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 42*D1*b2*f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 1116*Dd**2*f**3*r**2 - 2088*Dd**2*f**3*r*s + 1638*Dd**2*f**3*r - 972*Dd**2*f**3*s**2 + 1530*Dd**2*f**3*s - 534*Dd**2*f**3 - 2520*Dd**2*f**2*g2*r**2 - 7056*Dd**2*f**2*g2*r*s + 4284*Dd**2*f**2*g2*r - 4536*Dd**2*f**2*g2*s**2 + 5796*Dd**2*f**2*g2*s - 1596*Dd**2*f**2*g2 + 42*b1**2*(D1**2*(-2*K*fd*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-2*r**2 - 2*r*(s - 1) + s) + 2*fd*r*(r + s) + fdd*(K*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) - r*(r + s))) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(2*K*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + b1*(-448*C*D1**2*f*fd*r**2 - 736*C*D1**2*f*fd*r*s + 304*C*D1**2*f*fd*r - 288*C*D1**2*f*fd*s**2 + 224*C*D1**2*f*fd*s - 152*C*D1**2*f*fd + 336*C*D1**2*f*fdd*r**2 + 480*C*D1**2*f*fdd*r*s - 264*C*D1**2*f*fdd*r + 144*C*D1**2*f*fdd*s**2 - 168*C*D1**2*f*fdd*s + 132*C*D1**2*f*fdd + 336*C*D1**2*fd**2*r**2 + 480*C*D1**2*fd**2*r*s - 264*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 168*C*D1**2*fd**2*s - 72*C*D1**2*fd**2 - 896*C*D1*Dd*f**2*r**2 - 1472*C*D1*Dd*f**2*r*s + 1264*C*D1*Dd*f**2*r - 576*C*D1*Dd*f**2*s**2 + 1024*C*D1*Dd*f**2*s - 592*C*D1*Dd*f**2 + 2688*C*D1*Dd*f*fd*r**2 + 3840*C*D1*Dd*f*fd*r*s - 2880*C*D1*Dd*f*fd*r + 1152*C*D1*Dd*f*fd*s**2 - 1920*C*D1*Dd*f*fd*s + 696*C*D1*Dd*f*fd + 672*C*D1*Ddd*f**2*r**2 + 960*C*D1*Ddd*f**2*r*s - 912*C*D1*Ddd*f**2*r + 288*C*D1*Ddd*f**2*s**2 - 624*C*D1*Ddd*f**2*s + 408*C*D1*Ddd*f**2 + 2016*C*Dd**2*f**2*r**2 + 2880*C*Dd**2*f**2*r*s - 2736*C*Dd**2*f**2*r + 864*C*Dd**2*f**2*s**2 - 1872*C*Dd**2*f**2*s + 816*C*Dd**2*f**2 + 168*D1**2*K*bdd1*f*r**2 + 336*D1**2*K*bdd1*f*r*s - 420*D1**2*K*bdd1*f*r + 168*D1**2*K*bdd1*f*s**2 - 420*D1**2*K*bdd1*f*s + 210*D1**2*K*bdd1*f + 126*D1**2*K*f*fd*r**2 - 84*D1**2*K*f*fd*r*s + 42*D1**2*K*f*fd*r - 210*D1**2*K*f*fd*s**2 + 210*D1**2*K*f*fd*s - 105*D1**2*K*f*fd + 210*D1**2*K*f*fdd*r**2 + 588*D1**2*K*f*fdd*r*s - 294*D1**2*K*f*fdd*r + 378*D1**2*K*f*fdd*s**2 - 378*D1**2*K*f*fdd*s + 189*D1**2*K*f*fdd + 210*D1**2*K*fd**2*r**2 + 588*D1**2*K*fd**2*r*s - 294*D1**2*K*fd**2*r + 378*D1**2*K*fd**2*s**2 - 378*D1**2*K*fd**2*s - 84*D1**2*b2*fd*r**2 - 168*D1**2*b2*fd*r*s - 84*D1**2*b2*fd*s**2 + 42*D1**2*b2*fdd*r**2 + 84*D1**2*b2*fdd*r*s + 42*D1**2*b2*fdd*s**2 - 84*D1**2*bdd1*f**2*r**2 - 84*D1**2*bdd1*f**2*r*s + 126*D1**2*bdd1*f**2*r + 42*D1**2*bdd1*f**2*s - 42*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*r**2 - 84*D1**2*bdd1*f*r*s + 126*D1**2*bdd1*f*r + 42*D1**2*bdd1*f*s - 42*D1**2*bdd1*f + 42*D1**2*bdd2*f*r**2 + 84*D1**2*bdd2*f*r*s - 84*D1**2*bdd2*f*r + 42*D1**2*bdd2*f*s**2 - 84*D1**2*bdd2*f*s + 42*D1**2*bdd2*f + 252*D1**2*f*fd*r**2 + 396*D1**2*f*fd*r*s - 222*D1**2*f*fd*r + 144*D1**2*f*fd*s**2 - 168*D1**2*f*fd*s + 132*D1**2*f*fd - 252*D1**2*f*fdd*r**2 - 324*D1**2*f*fdd*r*s + 216*D1**2*f*fdd*r - 72*D1**2*f*fdd*s**2 + 126*D1**2*f*fdd*s - 108*D1**2*f*fdd + 336*D1**2*f*gd2*r**2 + 672*D1**2*f*gd2*r*s - 672*D1**2*f*gd2*r + 336*D1**2*f*gd2*s**2 - 672*D1**2*f*gd2*s + 336*D1**2*f*gd2 - 168*D1**2*f*gdd2*r**2 - 336*D1**2*f*gdd2*r*s + 336*D1**2*f*gdd2*r - 168*D1**2*f*gdd2*s**2 + 336*D1**2*f*gdd2*s - 168*D1**2*f*gdd2 - 252*D1**2*fd**2*r**2 - 324*D1**2*fd**2*r*s + 216*D1**2*fd**2*r - 72*D1**2*fd**2*s**2 + 126*D1**2*fd**2*s + 36*D1**2*fd**2 + 336*D1**2*fd*g2*r**2 + 672*D1**2*fd*g2*r*s + 336*D1**2*fd*g2*r + 336*D1**2*fd*g2*s**2 + 336*D1**2*fd*g2*s - 168*D1**2*fd*g2 - 336*D1**2*fd*gd2*r**2 - 672*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 - 168*D1**2*fdd*g2*r**2 - 336*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r - 168*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 + 252*D1*Dd*K*f**2*r**2 - 168*D1*Dd*K*f**2*r*s - 210*D1*Dd*K*f**2*r - 420*D1*Dd*K*f**2*s**2 + 294*D1*Dd*K*f**2*s + 21*D1*Dd*K*f**2 + 1680*D1*Dd*K*f*fd*r**2 + 4704*D1*Dd*K*f*fd*r*s - 2604*D1*Dd*K*f*fd*r + 3024*D1*Dd*K*f*fd*s**2 - 3444*D1*Dd*K*f*fd*s + 966*D1*Dd*K*f*fd - 336*D1*Dd*b2*f*r**2 - 672*D1*Dd*b2*f*r*s + 504*D1*Dd*b2*f*r - 336*D1*Dd*b2*f*s**2 + 504*D1*Dd*b2*f*s - 252*D1*Dd*b2*f + 336*D1*Dd*b2*fd*r**2 + 672*D1*Dd*b2*fd*r*s - 252*D1*Dd*b2*fd*r + 336*D1*Dd*b2*fd*s**2 - 252*D1*Dd*b2*fd*s + 504*D1*Dd*f**2*r**2 + 792*D1*Dd*f**2*r*s - 702*D1*Dd*f**2*r + 288*D1*Dd*f**2*s**2 - 540*D1*Dd*f**2*s + 324*D1*Dd*f**2 - 2016*D1*Dd*f*fd*r**2 - 2592*D1*Dd*f*fd*r*s + 2196*D1*Dd*f*fd*r - 576*D1*Dd*f*fd*s**2 + 1296*D1*Dd*f*fd*s - 558*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r**2 + 2688*D1*Dd*f*g2*r*s - 2016*D1*Dd*f*g2*r + 1344*D1*Dd*f*g2*s**2 - 2016*D1*Dd*f*g2*s + 1008*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r**2 - 2688*D1*Dd*f*gd2*r*s + 2352*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 2352*D1*Dd*f*gd2*s - 1008*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r**2 - 2688*D1*Dd*fd*g2*r*s + 336*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 + 336*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 + 420*D1*Ddd*K*f**2*r**2 + 1176*D1*Ddd*K*f**2*r*s - 714*D1*Ddd*K*f**2*r + 756*D1*Ddd*K*f**2*s**2 - 966*D1*Ddd*K*f**2*s + 399*D1*Ddd*K*f**2 + 168*D1*Ddd*b2*f*r**2 + 336*D1*Ddd*b2*f*r*s - 252*D1*Ddd*b2*f*r + 168*D1*Ddd*b2*f*s**2 - 252*D1*Ddd*b2*f*s + 126*D1*Ddd*b2*f - 504*D1*Ddd*f**2*r**2 - 648*D1*Ddd*f**2*r*s + 666*D1*Ddd*f**2*r - 144*D1*Ddd*f**2*s**2 + 396*D1*Ddd*f**2*s - 288*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 - 1344*D1*Ddd*f*g2*r*s + 1008*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 1008*D1*Ddd*f*g2*s - 504*D1*Ddd*f*g2 + 42*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(2*K*(4*r**2 + 2*r*(4*s - 5) + 4*s**2 - 10*s + 5) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(2*K*(4*r**2 + 8*r*s - 3*r + 4*s**2 - 3*s - 1) - 4*r**2 - 4*r*s + 3*r + s)) + Dd*f*(K*(32*r**2 + 64*r*(s - 1) + 32*s**2 - 64*s + 30) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 84*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 1260*Dd**2*K*f**2*r**2 + 3528*Dd**2*K*f**2*r*s - 2142*Dd**2*K*f**2*r + 2268*Dd**2*K*f**2*s**2 - 2898*Dd**2*K*f**2*s + 798*Dd**2*K*f**2 + 504*Dd**2*b2*f*r**2 + 1008*Dd**2*b2*f*r*s - 756*Dd**2*b2*f*r + 504*Dd**2*b2*f*s**2 - 756*Dd**2*b2*f*s + 252*Dd**2*b2*f - 1512*Dd**2*f**2*r**2 - 1944*Dd**2*f**2*r*s + 1998*Dd**2*f**2*r - 432*Dd**2*f**2*s**2 + 1188*Dd**2*f**2*s - 576*Dd**2*f**2 - 2016*Dd**2*f*g2*r**2 - 4032*Dd**2*f*g2*r*s + 3024*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 3024*Dd**2*f*g2*s - 1008*Dd**2*f*g2))/(105*d**2*k3**6) - 2*D1**2*Pk2*Pk3*ct**2*k2**4*(D1*(70*D1*b2*bd1*f*(r + s - 1)**2 + 14*D1*bd1**2*(r + s - 1)*(25*K*f*(r + s - 1) - f*(12*C - 6)*(r + s) + 20*g2*(r + s)) + D1*bdd1*f*(f*(6*C - 3)*(59*r + 35*s - 35) - 350*g2*(r + s - 1))*(r + s - 1) - bd1*(D1*(3*f**2*(2*C*(41*r**2 + r*(34*s - 6) - 7*s**2 + 42*s - 21) - 27*r**2 - 4*r*(5*s + 2) + 7*s**2 - 42*s + 21) - f*fd*(12*C - 6)*(118*r**2 + r*(188*s - 153) + 70*s**2 - 117*s + 47) + 70*f*(g2*(r**2 + 2*r*(s - 3) + s**2 - 6*s + 3) + 10*gd2*(r + s - 1)**2) + 700*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(-f*(6*C - 3)*(236*r**2 + r*(376*s - 353) + 140*s**2 - 269*s + 129) + 350*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 70*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(D1**2*(10*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(24*C*(r + s - 1)**2 + 5*K*(r**2 + 2*r*(s + 2) + s**2 + 4*s - 2) - 22*r**2 - 2*r*(17*s - 12) - 12*(s - 1)**2) + fdd*(-12*C*(r + s - 1)**2 + 25*K*s**2 + r**2*(25*K + 6) + 2*r*(25*K*s + 6*s - 6) + 6*s**2 - 12*s + 6) - 40*gd2*(r + s - 1)**2 + 20*gdd2*(r + s - 1)**2) + D1*(Dd*(f*(24*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 88*r**2 - 136*r*s + 122*r - 48*s**2 + 92*s - 56) - 2*fd*(4*r + 4*s - 3)*(12*C*(r + s - 1) - 25*K*s - r*(25*K + 6) - 6*s + 6) - 40*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(80*r + 80*s - 60)) + Ddd*(f*(-12*C + 25*K + 6) + 20*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(-12*C + 25*K + 6) + 20*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - b1*(168*C*D1**2*bdd1*f*r**2 + 336*C*D1**2*bdd1*f*r*s - 168*C*D1**2*bdd1*f*r + 168*C*D1**2*bdd1*f*s**2 - 168*C*D1**2*bdd1*f*s + 84*C*D1**2*bdd1*f + 492*C*D1**2*f*fd*r**2 + 408*C*D1**2*f*fd*r*s - 660*C*D1**2*f*fd*r - 84*C*D1**2*f*fd*s**2 - 372*C*D1**2*f*fd*s + 330*C*D1**2*f*fd - 708*C*D1**2*f*fdd*r**2 - 1128*C*D1**2*f*fdd*r*s + 708*C*D1**2*f*fdd*r - 420*C*D1**2*f*fdd*s**2 + 564*C*D1**2*f*fdd*s - 354*C*D1**2*f*fdd - 708*C*D1**2*fd**2*r**2 - 1128*C*D1**2*fd**2*r*s + 708*C*D1**2*fd**2*r - 420*C*D1**2*fd**2*s**2 + 564*C*D1**2*fd**2*s + 984*C*D1*Dd*f**2*r**2 + 816*C*D1*Dd*f**2*r*s - 1188*C*D1*Dd*f**2*r - 168*C*D1*Dd*f**2*s**2 - 324*C*D1*Dd*f**2*s + 450*C*D1*Dd*f**2 - 5664*C*D1*Dd*f*fd*r**2 - 9024*C*D1*Dd*f*fd*r*s + 6792*C*D1*Dd*f*fd*r - 3360*C*D1*Dd*f*fd*s**2 + 5352*C*D1*Dd*f*fd*s - 1980*C*D1*Dd*f*fd - 1416*C*D1*Ddd*f**2*r**2 - 2256*C*D1*Ddd*f**2*r*s + 1980*C*D1*Ddd*f**2*r - 840*C*D1*Ddd*f**2*s**2 + 1548*C*D1*Ddd*f**2*s - 918*C*D1*Ddd*f**2 - 4248*C*Dd**2*f**2*r**2 - 6768*C*Dd**2*f**2*r*s + 5940*C*Dd**2*f**2*r - 2520*C*Dd**2*f**2*s**2 + 4644*C*Dd**2*f**2*s - 1836*C*Dd**2*f**2 + 140*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 350*D1**2*K*bdd1*f*r**2 - 700*D1**2*K*bdd1*f*r*s + 700*D1**2*K*bdd1*f*r - 350*D1**2*K*bdd1*f*s**2 + 700*D1**2*K*bdd1*f*s - 350*D1**2*K*bdd1*f - 70*D1**2*b2*fd*r**2 - 140*D1**2*b2*fd*r*s - 70*D1**2*b2*fd*s**2 - 70*D1**2*bd2*f*(r + s - 1)**2 - 84*D1**2*bdd1*f*r**2 - 168*D1**2*bdd1*f*r*s + 84*D1**2*bdd1*f*r - 84*D1**2*bdd1*f*s**2 + 84*D1**2*bdd1*f*s - 42*D1**2*bdd1*f - 280*D1**2*bdd1*g2*r**2 - 560*D1**2*bdd1*g2*r*s + 280*D1**2*bdd1*g2*r - 280*D1**2*bdd1*g2*s**2 + 280*D1**2*bdd1*g2*s - 140*D1**2*bdd1*g2 - 162*D1**2*f*fd*r**2 - 120*D1**2*f*fd*r*s + 246*D1**2*f*fd*r + 42*D1**2*f*fd*s**2 + 144*D1**2*f*fd*s - 123*D1**2*f*fd + 354*D1**2*f*fdd*r**2 + 564*D1**2*f*fdd*r*s - 354*D1**2*f*fdd*r + 210*D1**2*f*fdd*s**2 - 282*D1**2*f*fdd*s + 177*D1**2*f*fdd + 70*D1**2*f*gd2*r**2 + 140*D1**2*f*gd2*r*s - 140*D1**2*f*gd2*r + 70*D1**2*f*gd2*s**2 - 140*D1**2*f*gd2*s + 70*D1**2*f*gd2 + 350*D1**2*f*gdd2*r**2 + 700*D1**2*f*gdd2*r*s - 700*D1**2*f*gdd2*r + 350*D1**2*f*gdd2*s**2 - 700*D1**2*f*gdd2*s + 350*D1**2*f*gdd2 + 354*D1**2*fd**2*r**2 + 564*D1**2*fd**2*r*s - 354*D1**2*fd**2*r + 210*D1**2*fd**2*s**2 - 282*D1**2*fd**2*s + 70*D1**2*fd*g2*r**2 + 140*D1**2*fd*g2*r*s + 280*D1**2*fd*g2*r + 70*D1**2*fd*g2*s**2 + 280*D1**2*fd*g2*s - 140*D1**2*fd*g2 + 700*D1**2*fd*gd2*r**2 + 1400*D1**2*fd*gd2*r*s - 700*D1**2*fd*gd2*r + 700*D1**2*fd*gd2*s**2 - 700*D1**2*fd*gd2*s + 350*D1**2*fdd*g2*r**2 + 700*D1**2*fdd*g2*r*s + 350*D1**2*fdd*g2*s**2 - 280*D1*Dd*b2*f*r**2 - 560*D1*Dd*b2*f*r*s + 420*D1*Dd*b2*f*r - 280*D1*Dd*b2*f*s**2 + 420*D1*Dd*b2*f*s - 210*D1*Dd*b2*f - 324*D1*Dd*f**2*r**2 - 240*D1*Dd*f**2*r*s + 384*D1*Dd*f**2*r + 84*D1*Dd*f**2*s**2 + 78*D1*Dd*f**2*s - 141*D1*Dd*f**2 + 2832*D1*Dd*f*fd*r**2 + 4512*D1*Dd*f*fd*r*s - 3396*D1*Dd*f*fd*r + 1680*D1*Dd*f*fd*s**2 - 2676*D1*Dd*f*fd*s + 990*D1*Dd*f*fd + 280*D1*Dd*f*g2*r**2 + 560*D1*Dd*f*g2*r*s - 420*D1*Dd*f*g2*r + 280*D1*Dd*f*g2*s**2 - 420*D1*Dd*f*g2*s + 210*D1*Dd*f*g2 + 2800*D1*Dd*f*gd2*r**2 + 5600*D1*Dd*f*gd2*r*s - 4900*D1*Dd*f*gd2*r + 2800*D1*Dd*f*gd2*s**2 - 4900*D1*Dd*f*gd2*s + 2100*D1*Dd*f*gd2 + 2800*D1*Dd*fd*g2*r**2 + 5600*D1*Dd*fd*g2*r*s - 2100*D1*Dd*fd*g2*r + 2800*D1*Dd*fd*g2*s**2 - 2100*D1*Dd*fd*g2*s + 708*D1*Ddd*f**2*r**2 + 1128*D1*Ddd*f**2*r*s - 990*D1*Ddd*f**2*r + 420*D1*Ddd*f**2*s**2 - 774*D1*Ddd*f**2*s + 459*D1*Ddd*f**2 + 1400*D1*Ddd*f*g2*r**2 + 2800*D1*Ddd*f*g2*r*s - 2100*D1*Ddd*f*g2*r + 1400*D1*Ddd*f*g2*s**2 - 2100*D1*Ddd*f*g2*s + 1050*D1*Ddd*f*g2 - 14*D1*bd1*(D1*(f*(12*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*K*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) - 22*r**2 - 34*r*s + 27*r - 12*s**2 + 17*s - 11) - 2*fd*(r + s - 1)*(6*C*(2*r + 2*s - 1) - 25*K*r - 25*K*s - 6*r - 6*s + 3) - 20*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(6*C*(2*r + 2*s - 1) - 25*K*(r + s - 1) - 6*r - 6*s + 3) - 10*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 2124*Dd**2*f**2*r**2 + 3384*Dd**2*f**2*r*s - 2970*Dd**2*f**2*r + 1260*Dd**2*f**2*s**2 - 2322*Dd**2*f**2*s + 918*Dd**2*f**2 + 4200*Dd**2*f*g2*r**2 + 8400*Dd**2*f*g2*r*s - 6300*Dd**2*f*g2*r + 4200*Dd**2*f*g2*s**2 - 6300*Dd**2*f*g2*s + 2100*Dd**2*f*g2))/(105*d**2*k3**6) + 8*D1**2*Pk2*Pk3*ct**2*st**2*(D1*(-21*D1*bd1**2*f*s*(2*K*s + f*(2*r - 1) + 2*r - 1) - 3*D1*bdd1*f*s*(f*(6*C*s + 7*r - 3*s) + s*(7*b2 - 14*g2)) + bd1*(D1*(2*f**2*s*(14*r + s*(18*C - 9)) + 3*f*(fd*r*(7 - 28*s) + fd*s*(C*(12 - 24*s) + 12*s + 1) + s**2*(14*b2 - 14*bd2 - 28*g2 + 28*gd2)) - 42*fd*s*(b2 - 2*g2)*(s - 1)) - 3*Dd*f*(7*f*r*(8*s - 1) + 4*f*s*(3*C*(4*s - 1) - 6*s - 2) + s*(14*b2 - 28*g2)*(4*s - 1)))) - 21*b1**2*(D1*Dd*(f*(K*(-8*s**2 + 4*s - 2) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(2*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(2*s - 1) - s + 1) + fd*(-2*K*(s - 1)**2 + f*s + r*(-2*f*s + f - 2*s + 2)) + fdd*(K*(s - 1)**2 - f*s + r*(2*f*s - f + s - 1))) + Ddd*f*(K*(4*s**2 - 2*s + 1) + (f + 1)*(r*(4*s - 1) - 2*s))) + Dd**2*f*(12*K*s**2 - 6*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(72*C*D1**2*f*fd*s**2 - 72*C*D1**2*f*fd*s + 36*C*D1**2*f*fd - 36*C*D1**2*f*fdd*s**2 + 36*C*D1**2*f*fdd*s - 18*C*D1**2*f*fdd - 36*C*D1**2*fd**2*s**2 + 36*C*D1**2*fd**2*s + 144*C*D1*Dd*f**2*s**2 - 72*C*D1*Dd*f**2*s + 36*C*D1*Dd*f**2 - 288*C*D1*Dd*f*fd*s**2 + 216*C*D1*Dd*f*fd*s - 36*C*D1*Dd*f*fd - 72*C*D1*Ddd*f**2*s**2 + 36*C*D1*Ddd*f**2*s - 18*C*D1*Ddd*f**2 - 216*C*Dd**2*f**2*s**2 + 108*C*Dd**2*f**2*s - 42*D1**2*K*bdd1*f*s**2 + 42*D1**2*bd2*f*s**2 - 42*D1**2*bd2*fd*s**2 + 42*D1**2*bd2*fd*s - 42*D1**2*bdd1*f**2*r*s + 21*D1**2*bdd1*f**2*s - 42*D1**2*bdd1*f*r*s + 21*D1**2*bdd1*f*s - 21*D1**2*bdd2*f*s**2 + 56*D1**2*f*fd*r*s - 28*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 18*D1**2*f*fd - 42*D1**2*f*fdd*r*s + 21*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s + 9*D1**2*f*fdd - 84*D1**2*f*gd2*s**2 + 42*D1**2*f*gdd2*s**2 - 42*D1**2*fd**2*r*s + 21*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s - 21*D1**2*fd**2 - 84*D1**2*fd*g2*s**2 + 168*D1**2*fd*g2*s - 84*D1**2*fd*g2 + 84*D1**2*fd*gd2*s**2 - 84*D1**2*fd*gd2*s + 42*D1**2*fdd*g2*s**2 - 84*D1**2*fdd*g2*s + 42*D1**2*fdd*g2 - 168*D1*Dd*bd2*f*s**2 + 42*D1*Dd*bd2*f*s + 112*D1*Dd*f**2*r*s - 28*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 - 20*D1*Dd*f**2*s - 18*D1*Dd*f**2 - 336*D1*Dd*f*fd*r*s + 126*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 45*D1*Dd*f*fd - 336*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*s**2 - 84*D1*Dd*f*gd2*s + 336*D1*Dd*fd*g2*s**2 - 420*D1*Dd*fd*g2*s + 84*D1*Dd*fd*g2 - 84*D1*Ddd*f**2*r*s + 21*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 + 24*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*s**2 - 84*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 21*D1*bd1*(-D1*(f*s*(-4*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(4*K*s - 1))) - Dd*f*(16*K*s**2 - 4*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) - 252*Dd**2*f**2*r*s + 63*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 + 72*Dd**2*f**2*s - 42*Dd**2*f**2 + 504*Dd**2*f*g2*s**2 - 252*Dd**2*f*g2*s + 21*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(105*d**2*k2**2) + D1**2*Pk2*Pk3*ct**2*(D1*(7*D1*bd1**2*f*(2*r*(15*f*s + s + 7) + 5*s*(10*K*s - 3*f - 3)) + D1*bdd1*f*s*(131*f*r + f*s*(210*C - 105) + s*(175*b2 - 350*g2)) + bd1*(D1*(f**2*s*(-185*r + s*(147 - 294*C)) + f*(131*fd*r*(4*s - 1) + fd*s*(420*C*(2*s - 1) - 420*s + 79) + s**2*(-245*b2 + 350*bd2 + 490*g2 - 700*gd2)) + 350*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(131*f*r*(8*s - 1) + 4*f*s*(105*C*(4*s - 1) - 210*s - 13) + s*(350*b2 - 700*g2)*(4*s - 1)))) - 70*b1**3*(D1*Dd*(fd*(8*r*s - r - 6*s + 1) - (f + 2)*(4*r*s - r - 2*s)) + D1*(-D1*s*(fd - fdd)*(r - 1) + Ddd*(f + 1)*(4*r*s - r - 2*s)) + Dd**2*(f + 1)*(3*r*(4*s - 1) - 6*s + 2)) + 7*b1**2*(D1*Dd*(f*(-35*K*(4*s**2 - 2*s + 1) - (15*f - 3)*(r*(4*s - 1) - 2*s)) + fd*(50*K*(4*s**2 - 5*s + 1) + 15*f*(2*r - 1)*(8*s - 3) + 8*r*s - 61*r + 54*s + 16)) + 10*D1*bd1*(-D1*fd*(r*(6*s - 1) - 4*s + 1) + D1*(f + 2)*(r*(3*s - 1) - s) - Dd*(f + 1)*(r*(24*s - 7) - 10*s + 3)) + D1*(D1*(-10*bdd1*(f + 1)*(r*(3*s - 1) - s) + 15*fd**2*(r*(2*s - 1) - s + 1) + fd*(-35*K*(s - 1)**2 + r*(-30*f*s + 15*f + 3*s + 25) + s*(15*f - 28)) + fdd*(25*K*(s - 1)**2 + r*(30*f*s - 15*f + s - 15) + s*(14 - 15*f))) + Ddd*f*(25*K*(4*s**2 - 2*s + 1) + (15*f + 1)*(r*(4*s - 1) - 2*s))) + Dd**2*f*(300*K*s**2 - 150*K*s + 15*f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(-588*C*D1**2*f*fd*s**2 + 588*C*D1**2*f*fd*s - 294*C*D1**2*f*fd + 420*C*D1**2*f*fdd*s**2 - 420*C*D1**2*f*fdd*s + 210*C*D1**2*f*fdd + 420*C*D1**2*fd**2*s**2 - 420*C*D1**2*fd**2*s - 1176*C*D1*Dd*f**2*s**2 + 588*C*D1*Dd*f**2*s - 294*C*D1*Dd*f**2 + 3360*C*D1*Dd*f*fd*s**2 - 2520*C*D1*Dd*f*fd*s + 420*C*D1*Dd*f*fd + 840*C*D1*Ddd*f**2*s**2 - 420*C*D1*Ddd*f**2*s + 210*C*D1*Ddd*f**2 + 2520*C*Dd**2*f**2*s**2 - 1260*C*Dd**2*f**2*s + 350*D1**2*K*bdd1*f*s**2 - 70*D1**2*bd1**2*(f + 1)*(r*(6*s - 2) - 2*s + 1) - 245*D1**2*bd2*f*s**2 + 350*D1**2*bd2*fd*s**2 - 350*D1**2*bd2*fd*s + 210*D1**2*bdd1*f**2*r*s - 105*D1**2*bdd1*f**2*s + 14*D1**2*bdd1*f*r*s + 98*D1**2*bdd1*f*r - 105*D1**2*bdd1*f*s + 175*D1**2*bdd2*f*s**2 - 370*D1**2*f*fd*r*s + 185*D1**2*f*fd*r + 294*D1**2*f*fd*s**2 - 109*D1**2*f*fd*s + 147*D1**2*f*fd + 262*D1**2*f*fdd*r*s - 131*D1**2*f*fdd*r - 210*D1**2*f*fdd*s**2 + 79*D1**2*f*fdd*s - 105*D1**2*f*fdd + 490*D1**2*f*gd2*s**2 - 350*D1**2*f*gdd2*s**2 + 262*D1**2*fd**2*r*s - 131*D1**2*fd**2*r - 210*D1**2*fd**2*s**2 + 79*D1**2*fd**2*s + 131*D1**2*fd**2 + 490*D1**2*fd*g2*s**2 - 980*D1**2*fd*g2*s + 490*D1**2*fd*g2 - 700*D1**2*fd*gd2*s**2 + 700*D1**2*fd*gd2*s - 350*D1**2*fdd*g2*s**2 + 700*D1**2*fdd*g2*s - 350*D1**2*fdd*g2 + 1400*D1*Dd*bd2*f*s**2 - 350*D1*Dd*bd2*f*s - 740*D1*Dd*f**2*r*s + 185*D1*Dd*f**2*r + 588*D1*Dd*f**2*s**2 + 76*D1*Dd*f**2*s + 147*D1*Dd*f**2 + 2096*D1*Dd*f*fd*r*s - 786*D1*Dd*f*fd*r - 1680*D1*Dd*f*fd*s**2 + 212*D1*Dd*f*fd*s + 183*D1*Dd*f*fd + 1960*D1*Dd*f*g2*s**2 - 980*D1*Dd*f*g2*s + 490*D1*Dd*f*g2 - 2800*D1*Dd*f*gd2*s**2 + 700*D1*Dd*f*gd2*s - 2800*D1*Dd*fd*g2*s**2 + 3500*D1*Dd*fd*g2*s - 700*D1*Dd*fd*g2 + 524*D1*Ddd*f**2*r*s - 131*D1*Ddd*f**2*r - 420*D1*Ddd*f**2*s**2 - 52*D1*Ddd*f**2*s - 105*D1*Ddd*f**2 - 1400*D1*Ddd*f*g2*s**2 + 700*D1*Ddd*f*g2*s - 350*D1*Ddd*f*g2 - 7*D1*bd1*(-D1*(f*(r*(s*(6 - 30*f) - 28) + 5*s*(-14*K*s + 3*f + 5)) + fd*(100*K*s**2 - 100*K*s + 15*f*(2*r - 1)*(4*s - 1) + 4*r*(s - 4) + 13*s + 1)) + Dd*f*(-400*K*s**2 + 100*K*s - 15*f*(2*r - 1)*(8*s - 1) - 2*r*(8*s + 27) + 64*s + 13)) + 1572*Dd**2*f**2*r*s - 393*Dd**2*f**2*r - 1260*Dd**2*f**2*s**2 - 156*Dd**2*f**2*s + 262*Dd**2*f**2 - 4200*Dd**2*f*g2*s**2 + 2100*Dd**2*f*g2*s - 35*b2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + D1*(7*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(4*s**2 - 5*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f*s*(1 - 2*s))))/(105*d**2*k2**2) - 4*D1**2*Pk2*Pk3*ct*f**2*k1**7*st**2*(D1**2*(f*(3*fd - 7*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 42*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 14*fd*(4*r + 4*s - 3)**2) - 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 42*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k2*k3**8) - 4*D1**2*Pk2*Pk3*ct*f**2*k1**5*k2*st**4*(D1**2*(f*(269*fd - 250*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 1500*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(269*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 500*fd*(4*r + 4*s - 3)**2) - 250*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 1500*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(385*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct*f**2*k1**5*st**4*(D1**2*(f*(167*fd - 100*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 100*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(167*f*(r*(4*s - 1) + (1 - 2*s)**2) - 200*fd*(4*s - 1)*(4*r + 4*s - 3)) - 100*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 100*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1155*d**2*k2*k3**6) - 20*D1**2*Pk2*Pk3*ct*f**2*k1**5*st**4*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k2**3*k3**4) - 4*D1**2*Pk2*Pk3*ct*f**2*k1**3*k2**3*st**6*(D1**2*(f*(188*fd - 105*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 630*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(2*Dd*(94*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 105*fd*(4*r + 4*s - 3)**2) - 105*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 630*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(231*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct*f**2*k1**3*k2*st**6*(D1**2*(f*(157*fd - 84*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 84*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(157*f*(r*(4*s - 1) + (1 - 2*s)**2) - 168*fd*(4*s - 1)*(4*r + 4*s - 3)) - 84*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 84*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(693*d**2*k3**6) - 12*D1**2*Pk2*Pk3*ct*f**2*k1**3*st**6*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(11*d**2*k2*k3**4) - 4*D1**2*Pk2*Pk3*ct*f*k1**7*(-7*D1**2*bdd1*f**2*(r + s - 1)**2 + D1*bd1*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 14*D1*fd*(3*r + 3*s - 2) - 14*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 14*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 42*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k2*k3**8) + 2*D1**2*Pk2*Pk3*ct*f*k1**5*st**2*(-12*D1**2*b1*f*fd*s**2 + 6*D1**2*b1*f*fdd*s**2 + 12*D1**2*b1*fd**2*s**2 + 2*D1**2*bdd1*f**2*(s - 1)**2 + 44*D1**2*f**2*fd*s**2 - 22*D1**2*f**2*fd*s + 11*D1**2*f**2*fd - 28*D1**2*f**2*fdd*s**2 + 14*D1**2*f**2*fdd*s - 7*D1**2*f**2*fdd - 84*D1**2*f*fd**2*s**2 + 42*D1**2*f*fd**2*s - 16*D1*Dd*b1*f**2*s**2 + 8*D1*Dd*b1*f**2*s - 4*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*s**2 - 12*D1*Dd*b1*f*fd*s + 44*D1*Dd*f**3*s**2 - 22*D1*Dd*f**3*s + 11*D1*Dd*f**3 - 224*D1*Dd*f**2*fd*s**2 + 112*D1*Dd*f**2*fd*s - 14*D1*Dd*f**2*fd + 8*D1*Ddd*b1*f**2*s**2 - 4*D1*Ddd*b1*f**2*s + 2*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*s**2 + 14*D1*Ddd*f**3*s - 7*D1*Ddd*f**3 - 4*D1*bd1*f*(s - 1)*(D1*f*(s - 1) - 3*D1*fd*s + Dd*f*(1 - 4*s)) + 24*Dd**2*b1*f**2*s**2 - 12*Dd**2*b1*f**2*s - 84*Dd**2*f**3*s**2 + 42*Dd**2*f**3*s)/(21*d**2*k2**3*k3**4) + D1**2*Pk2*Pk3*ct*f*k1**5*(15*D1**2*b1*f*fd*s**2 - 9*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*fd**2*s**2 - 3*D1**2*bdd1*f**2*(s - 1)**2 - 12*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 3*D1**2*f**2*fd + 12*D1**2*f**2*fdd*s**2 - 6*D1**2*f**2*fdd*s + 3*D1**2*f**2*fdd + 36*D1**2*f*fd**2*s**2 - 18*D1**2*f*fd**2*s + 20*D1*Dd*b1*f**2*s**2 - 10*D1*Dd*b1*f**2*s + 5*D1*Dd*b1*f**2 - 72*D1*Dd*b1*f*fd*s**2 + 18*D1*Dd*b1*f*fd*s - 12*D1*Dd*f**3*s**2 + 6*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*s**2 - 48*D1*Dd*f**2*fd*s + 6*D1*Dd*f**2*fd - 12*D1*Ddd*b1*f**2*s**2 + 6*D1*Ddd*b1*f**2*s - 3*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*s**2 - 6*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + D1*bd1*f*(s - 1)*(5*D1*f*(s - 1) - 18*D1*fd*s + 6*Dd*f*(1 - 4*s)) - 36*Dd**2*b1*f**2*s**2 + 18*Dd**2*b1*f**2*s + 36*Dd**2*f**3*s**2 - 18*Dd**2*f**3*s)/(7*d**2*k2**3*k3**4) + D1**2*Pk2*Pk3*ct*f*k2**5*st**4*(32*C - 16)*(D1**2*(f*(4*fd - 5*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 5*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(4*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 5*fd*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) - 5*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 5*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4))/(105*d**2*k1*k3**6) - 4*D1**2*Pk2*Pk3*ct*k1**5*k2*st**2*(12*C*D1**2*f**2*fd*r**2 + 24*C*D1**2*f**2*fd*r*s - 16*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 16*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 60*C*D1**2*f**2*fdd*r**2 - 120*C*D1**2*f**2*fdd*r*s + 80*C*D1**2*f**2*fdd*r - 60*C*D1**2*f**2*fdd*s**2 + 80*C*D1**2*f**2*fdd*s - 40*C*D1**2*f**2*fdd - 120*C*D1**2*f*fd**2*r**2 - 240*C*D1**2*f*fd**2*r*s + 160*C*D1**2*f*fd**2*r - 120*C*D1**2*f*fd**2*s**2 + 160*C*D1**2*f*fd**2*s - 40*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r**2 + 32*C*D1*Dd*f**3*r*s - 24*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 12*C*D1*Dd*f**3 - 480*C*D1*Dd*f**2*fd*r**2 - 960*C*D1*Dd*f**2*fd*r*s + 680*C*D1*Dd*f**2*fd*r - 480*C*D1*Dd*f**2*fd*s**2 + 680*C*D1*Dd*f**2*fd*s - 240*C*D1*Dd*f**2*fd - 80*C*D1*Ddd*f**3*r**2 - 160*C*D1*Ddd*f**3*r*s + 120*C*D1*Ddd*f**3*r - 80*C*D1*Ddd*f**3*s**2 + 120*C*D1*Ddd*f**3*s - 60*C*D1*Ddd*f**3 - 240*C*Dd**2*f**3*r**2 - 480*C*Dd**2*f**3*r*s + 360*C*Dd**2*f**3*r - 240*C*Dd**2*f**3*s**2 + 360*C*Dd**2*f**3*s - 120*C*Dd**2*f**3 - 12*D1**2*K*b1*f*fd*r**2 - 24*D1**2*K*b1*f*fd*r*s + 12*D1**2*K*b1*f*fd*r - 12*D1**2*K*b1*f*fd*s**2 + 12*D1**2*K*b1*f*fd*s - 6*D1**2*K*b1*f*fd - 36*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*r*s + 36*D1**2*K*b1*f*fdd*r - 36*D1**2*K*b1*f*fdd*s**2 + 36*D1**2*K*b1*f*fdd*s - 18*D1**2*K*b1*f*fdd - 36*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*r*s + 36*D1**2*K*b1*fd**2*r - 36*D1**2*K*b1*fd**2*s**2 + 36*D1**2*K*b1*fd**2*s + 342*D1**2*b1*f**2*fd*r**2 + 684*D1**2*b1*f**2*fd*r*s - 456*D1**2*b1*f**2*fd*r + 342*D1**2*b1*f**2*fd*s**2 - 456*D1**2*b1*f**2*fd*s + 228*D1**2*b1*f**2*fd - 225*D1**2*b1*f**2*fdd*r**2 - 450*D1**2*b1*f**2*fdd*r*s + 300*D1**2*b1*f**2*fdd*r - 225*D1**2*b1*f**2*fdd*s**2 + 300*D1**2*b1*f**2*fdd*s - 150*D1**2*b1*f**2*fdd - 450*D1**2*b1*f*fd**2*r**2 - 900*D1**2*b1*f*fd**2*r*s + 600*D1**2*b1*f*fd**2*r - 450*D1**2*b1*f*fd**2*s**2 + 600*D1**2*b1*f*fd**2*s - 150*D1**2*b1*f*fd**2 + 6*D1**2*b1*f*fd*r**2 + 12*D1**2*b1*f*fd*r*s - 6*D1**2*b1*f*fd*r + 6*D1**2*b1*f*fd*s**2 - 6*D1**2*b1*f*fd*s + 3*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(6*K + 25*f - 3)*(r + s - 1)**2 - 60*D1**2*f**3*fd*r**2 - 120*D1**2*f**3*fd*r*s + 90*D1**2*f**3*fd*r - 60*D1**2*f**3*fd*s**2 + 90*D1**2*f**3*fd*s - 45*D1**2*f**3*fd - 9*D1**2*f**2*fd*r**2 - 18*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 9*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 45*D1**2*f**2*fdd*r**2 + 90*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 60*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 12*D1**2*f**2*gd2*r**2 + 24*D1**2*f**2*gd2*r*s - 24*D1**2*f**2*gd2*r + 12*D1**2*f**2*gd2*s**2 - 24*D1**2*f**2*gd2*s + 12*D1**2*f**2*gd2 + 36*D1**2*f**2*gdd2*r**2 + 72*D1**2*f**2*gdd2*r*s - 72*D1**2*f**2*gdd2*r + 36*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2*s + 36*D1**2*f**2*gdd2 + 90*D1**2*f*fd**2*r**2 + 180*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 120*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 + 24*D1**2*f*fd*g2*r**2 + 48*D1**2*f*fd*g2*r*s - 24*D1**2*f*fd*g2*r + 24*D1**2*f*fd*g2*s**2 - 24*D1**2*f*fd*g2*s + 12*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r*s - 216*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 216*D1**2*f*fd*gd2*s + 72*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*r*s - 72*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*r*s - 72*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 24*D1*Dd*K*b1*f**2*r**2 - 48*D1*Dd*K*b1*f**2*r*s + 36*D1*Dd*K*b1*f**2*r - 24*D1*Dd*K*b1*f**2*s**2 + 36*D1*Dd*K*b1*f**2*s - 18*D1*Dd*K*b1*f**2 - 288*D1*Dd*K*b1*f*fd*r**2 - 576*D1*Dd*K*b1*f*fd*r*s + 360*D1*Dd*K*b1*f*fd*r - 288*D1*Dd*K*b1*f*fd*s**2 + 360*D1*Dd*K*b1*f*fd*s - 108*D1*Dd*K*b1*f*fd + 456*D1*Dd*b1*f**3*r**2 + 912*D1*Dd*b1*f**3*r*s - 684*D1*Dd*b1*f**3*r + 456*D1*Dd*b1*f**3*s**2 - 684*D1*Dd*b1*f**3*s + 342*D1*Dd*b1*f**3 - 1800*D1*Dd*b1*f**2*fd*r**2 - 3600*D1*Dd*b1*f**2*fd*r*s + 2550*D1*Dd*b1*f**2*fd*r - 1800*D1*Dd*b1*f**2*fd*s**2 + 2550*D1*Dd*b1*f**2*fd*s - 900*D1*Dd*b1*f**2*fd + 12*D1*Dd*b1*f**2*r**2 + 24*D1*Dd*b1*f**2*r*s - 18*D1*Dd*b1*f**2*r + 12*D1*Dd*b1*f**2*s**2 - 18*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 60*D1*Dd*f**4*r**2 - 120*D1*Dd*f**4*r*s + 90*D1*Dd*f**4*r - 60*D1*Dd*f**4*s**2 + 90*D1*Dd*f**4*s - 45*D1*Dd*f**4 - 12*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 + 18*D1*Dd*f**3*s - 9*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*r**2 + 720*D1*Dd*f**2*fd*r*s - 510*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 510*D1*Dd*f**2*fd*s + 180*D1*Dd*f**2*fd + 48*D1*Dd*f**2*g2*r**2 + 96*D1*Dd*f**2*g2*r*s - 72*D1*Dd*f**2*g2*r + 48*D1*Dd*f**2*g2*s**2 - 72*D1*Dd*f**2*g2*s + 36*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r**2 + 576*D1*Dd*f**2*gd2*r*s - 504*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 504*D1*Dd*f**2*gd2*s + 216*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r**2 + 1152*D1*Dd*f*fd*g2*r*s - 720*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 720*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 - 72*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r*s + 108*D1*Ddd*K*b1*f**2*r - 72*D1*Ddd*K*b1*f**2*s**2 + 108*D1*Ddd*K*b1*f**2*s - 54*D1*Ddd*K*b1*f**2 - 300*D1*Ddd*b1*f**3*r**2 - 600*D1*Ddd*b1*f**3*r*s + 450*D1*Ddd*b1*f**3*r - 300*D1*Ddd*b1*f**3*s**2 + 450*D1*Ddd*b1*f**3*s - 225*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 60*D1*Ddd*f**3*r**2 + 120*D1*Ddd*f**3*r*s - 90*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 90*D1*Ddd*f**3*s + 45*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r*s - 216*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 216*D1*Ddd*f**2*g2*s + 108*D1*Ddd*f**2*g2 + 3*D1*bd1*f*(D1*(38*f**2*(r + s - 1) - 50*f*fd*(3*r + 3*s - 2) - f*(2*K - 1)*(r + s - 1) - 6*fd*(2*K - 1)*(2*r + 2*s - 1)) - 2*Dd*f*(6*K + 25*f - 3)*(4*r + 4*s - 3))*(r + s - 1) - 216*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r*s + 324*Dd**2*K*b1*f**2*r - 216*Dd**2*K*b1*f**2*s**2 + 324*Dd**2*K*b1*f**2*s - 108*Dd**2*K*b1*f**2 - 900*Dd**2*b1*f**3*r**2 - 1800*Dd**2*b1*f**3*r*s + 1350*Dd**2*b1*f**3*r - 900*Dd**2*b1*f**3*s**2 + 1350*Dd**2*b1*f**3*s - 450*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 180*Dd**2*f**3*r**2 + 360*Dd**2*f**3*r*s - 270*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 270*Dd**2*f**3*s + 90*Dd**2*f**3 + 432*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r*s - 648*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 648*Dd**2*f**2*g2*s + 216*Dd**2*f**2*g2)/(105*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct*k1**5*k2*(-D1*(r + s - 1)*(6*D1*bd1**2*f*(-14*K + 25*f + 7)*(r + s - 1) - 3*D1*bdd1*f*(f*(20*C - 15) - 28*g2)*(r + s - 1) + bd1*(D1*(-15*f**3*(r + s - 1) + f**2*(36*C - 27)*(r + s - 1) - f*fd*(120*C - 90)*(2*r + 2*s - 1) - 28*f*(g2 - 6*gd2)*(r + s - 1) + 168*fd*g2*(r + s)) - 6*Dd*f*(f*(20*C - 15) - 28*g2)*(4*r + 4*s - 3))) + b1**2*(D1**2*(15*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 7*fd*(2*K - 1)*(r + s) - 21*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(45*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(150*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-14*K + 25*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-14*K + 25*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-72*C*D1**2*f*fd*r**2 - 144*C*D1**2*f*fd*r*s + 72*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s - 36*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 144*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 216*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 216*C*D1*Dd*f**2*s - 108*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 1200*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1200*C*D1*Dd*f*fd*s + 360*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 360*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(-14*K + 25*f + 7)*(r + s - 1)**2 + 45*D1**2*f**2*fd*r**2 + 90*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s**2 - 60*D1**2*f**2*fd*s + 30*D1**2*f**2*fd + 54*D1**2*f*fd*r**2 + 108*D1**2*f*fd*r*s - 54*D1**2*f*fd*r + 54*D1**2*f*fd*s**2 - 54*D1**2*f*fd*s + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 45*D1**2*f*fdd + 28*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r + 28*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s + 28*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 28*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 + 60*D1*Dd*f**3*r**2 + 120*D1*Dd*f**3*r*s - 90*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 90*D1*Dd*f**3*s + 45*D1*Dd*f**3 + 108*D1*Dd*f**2*r**2 + 216*D1*Dd*f**2*r*s - 162*D1*Dd*f**2*r + 108*D1*Dd*f**2*s**2 - 162*D1*Dd*f**2*s + 81*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 900*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 270*D1*Dd*f*fd + 112*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 112*D1*Dd*f*g2*s**2 - 168*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s - 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(45*f**2*(r + s - 1) - 150*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 42*fd*(2*K - 1)*(r + s)) - 6*Dd*f*(-14*K + 25*f + 7)*(4*r + 4*s - 3))*(r + s - 1) - 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 270*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(35*d**2*k3**8) - 2*D1**2*Pk2*Pk3*ct*k1**5*st**2*(-24*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 24*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 8*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r*s - 40*C*D1**2*f**2*fdd*r + 120*C*D1**2*f**2*fdd*s**2 - 120*C*D1**2*f**2*fdd*s + 40*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r*s - 80*C*D1**2*f*fd**2*r + 240*C*D1**2*f*fd**2*s**2 - 240*C*D1**2*f*fd**2*s + 40*C*D1**2*f*fd**2 - 32*C*D1*Dd*f**3*r*s + 8*C*D1*Dd*f**3*r - 32*C*D1*Dd*f**3*s**2 + 32*C*D1*Dd*f**3*s - 8*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r*s - 280*C*D1*Dd*f**2*fd*r + 960*C*D1*Dd*f**2*fd*s**2 - 960*C*D1*Dd*f**2*fd*s + 200*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r*s - 40*C*D1*Ddd*f**3*r + 160*C*D1*Ddd*f**3*s**2 - 160*C*D1*Ddd*f**3*s + 40*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r*s - 120*C*Dd**2*f**3*r + 480*C*Dd**2*f**3*s**2 - 480*C*Dd**2*f**3*s + 80*C*Dd**2*f**3 + 24*D1**2*K*b1*f*fd*r*s - 12*D1**2*K*b1*f*fd*r + 24*D1**2*K*b1*f*fd*s**2 - 24*D1**2*K*b1*f*fd*s + 12*D1**2*K*b1*f*fd + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 72*D1**2*K*b1*f*fdd*s**2 - 72*D1**2*K*b1*f*fdd*s + 36*D1**2*K*b1*f*fdd + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 72*D1**2*K*b1*fd**2*s**2 - 72*D1**2*K*b1*fd**2*s + 36*D1**2*b1*f**2*fd*r**2 + 936*D1**2*b1*f**2*fd*r*s + 24*D1**2*b1*f**2*fd*r + 900*D1**2*b1*f**2*fd*s**2 - 552*D1**2*b1*f**2*fd*s - 54*D1**2*b1*f**2*fd - 180*D1**2*b1*f**2*fdd*r**2 - 900*D1**2*b1*f**2*fdd*r*s + 240*D1**2*b1*f**2*fdd*r - 720*D1**2*b1*f**2*fdd*s**2 + 600*D1**2*b1*f**2*fdd*s - 90*D1**2*b1*f**2*fdd - 360*D1**2*b1*f*fd**2*r**2 - 1800*D1**2*b1*f*fd**2*r*s + 480*D1**2*b1*f*fd**2*r - 1440*D1**2*b1*f*fd**2*s**2 + 1200*D1**2*b1*f*fd**2*s - 180*D1**2*b1*f*fd**2 - 12*D1**2*b1*f*fd*r**2 - 48*D1**2*b1*f*fd*r*s + 24*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd - 36*D1**2*b1*f*fdd*r**2 - 144*D1**2*b1*f*fdd*r*s + 72*D1**2*b1*f*fdd*r - 108*D1**2*b1*f*fdd*s**2 + 108*D1**2*b1*f*fdd*s - 54*D1**2*b1*f*fdd - 36*D1**2*b1*fd**2*r**2 - 144*D1**2*b1*fd**2*r*s + 72*D1**2*b1*fd**2*r - 108*D1**2*b1*fd**2*s**2 + 108*D1**2*b1*fd**2*s - 6*D1**2*bdd1*f**2*(5*f*(2*r**2 + 10*r*(s - 1) + 8*s**2 - 16*s + 9) + (3*r + 3*s - 3)*(-2*K*s + r + 3*s - 1)) - 540*D1**2*f**3*fd*r**2 - 2760*D1**2*f**3*fd*r*s + 1230*D1**2*f**3*fd*r - 2220*D1**2*f**3*fd*s**2 + 2490*D1**2*f**3*fd*s - 825*D1**2*f**3*fd + 660*D1**2*f**3*fdd*r**2 + 2520*D1**2*f**3*fdd*r*s - 1290*D1**2*f**3*fdd*r + 1860*D1**2*f**3*fdd*s**2 - 2190*D1**2*f**3*fdd*s + 795*D1**2*f**3*fdd + 1980*D1**2*f**2*fd**2*r**2 + 7560*D1**2*f**2*fd**2*r*s - 3870*D1**2*f**2*fd**2*r + 5580*D1**2*f**2*fd**2*s**2 - 6570*D1**2*f**2*fd**2*s + 1590*D1**2*f**2*fd**2 + 6*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 16*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 32*D1**2*f**2*fd*s + 12*D1**2*f**2*fd - 30*D1**2*f**2*fdd*r**2 - 180*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 150*D1**2*f**2*fdd*s**2 + 160*D1**2*f**2*fdd*s - 60*D1**2*f**2*fdd - 24*D1**2*f**2*gd2*r*s - 24*D1**2*f**2*gd2*s**2 + 24*D1**2*f**2*gd2*s - 72*D1**2*f**2*gdd2*r*s - 72*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 60*D1**2*f*fd**2*r**2 - 360*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 300*D1**2*f*fd**2*s**2 + 320*D1**2*f*fd**2*s - 60*D1**2*f*fd**2 - 48*D1**2*f*fd*g2*r*s + 24*D1**2*f*fd*g2*r - 48*D1**2*f*fd*g2*s**2 + 48*D1**2*f*fd*g2*s - 24*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r*s + 72*D1**2*f*fd*gd2*r - 288*D1**2*f*fd*gd2*s**2 + 288*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 144*D1**2*f*fdd*g2*s**2 + 144*D1**2*f*fdd*g2*s - 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 144*D1**2*fd**2*g2*s**2 + 144*D1**2*fd**2*g2*s + 48*D1*Dd*K*b1*f**2*r*s - 12*D1*Dd*K*b1*f**2*r + 48*D1*Dd*K*b1*f**2*s**2 - 48*D1*Dd*K*b1*f**2*s + 12*D1*Dd*K*b1*f**2 + 576*D1*Dd*K*b1*f*fd*r*s - 216*D1*Dd*K*b1*f*fd*r + 576*D1*Dd*K*b1*f*fd*s**2 - 576*D1*Dd*K*b1*f*fd*s + 144*D1*Dd*K*b1*f*fd + 48*D1*Dd*b1*f**3*r**2 + 1248*D1*Dd*b1*f**3*r*s - 360*D1*Dd*b1*f**3*r + 1200*D1*Dd*b1*f**3*s**2 - 1224*D1*Dd*b1*f**3*s + 324*D1*Dd*b1*f**3 - 1440*D1*Dd*b1*f**2*fd*r**2 - 7200*D1*Dd*b1*f**2*fd*r*s + 2580*D1*Dd*b1*f**2*fd*r - 5760*D1*Dd*b1*f**2*fd*s**2 + 5640*D1*Dd*b1*f**2*fd*s - 1080*D1*Dd*b1*f**2*fd - 24*D1*Dd*b1*f**2*r**2 - 96*D1*Dd*b1*f**2*r*s + 48*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 84*D1*Dd*b1*f**2*s - 30*D1*Dd*b1*f**2 - 288*D1*Dd*b1*f*fd*r**2 - 1152*D1*Dd*b1*f*fd*r*s + 576*D1*Dd*b1*f*fd*r - 864*D1*Dd*b1*f*fd*s**2 + 936*D1*Dd*b1*f*fd*s - 252*D1*Dd*b1*f*fd - 540*D1*Dd*f**4*r**2 - 2760*D1*Dd*f**4*r*s + 1230*D1*Dd*f**4*r - 2220*D1*Dd*f**4*s**2 + 2490*D1*Dd*f**4*s - 825*D1*Dd*f**4 + 5280*D1*Dd*f**3*fd*r**2 + 20160*D1*Dd*f**3*fd*r*s - 10320*D1*Dd*f**3*fd*r + 14880*D1*Dd*f**3*fd*s**2 - 17520*D1*Dd*f**3*fd*s + 4770*D1*Dd*f**3*fd + 8*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 20*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 44*D1*Dd*f**3*s + 14*D1*Dd*f**3 - 240*D1*Dd*f**2*fd*r**2 - 1440*D1*Dd*f**2*fd*r*s + 620*D1*Dd*f**2*fd*r - 1200*D1*Dd*f**2*fd*s**2 + 1300*D1*Dd*f**2*fd*s - 320*D1*Dd*f**2*fd - 96*D1*Dd*f**2*g2*r*s + 24*D1*Dd*f**2*g2*r - 96*D1*Dd*f**2*g2*s**2 + 96*D1*Dd*f**2*g2*s - 24*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r*s + 72*D1*Dd*f**2*gd2*r - 576*D1*Dd*f**2*gd2*s**2 + 576*D1*Dd*f**2*gd2*s - 72*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r*s + 432*D1*Dd*f*fd*g2*r - 1152*D1*Dd*f*fd*g2*s**2 + 1152*D1*Dd*f*fd*g2*s - 288*D1*Dd*f*fd*g2 + 144*D1*Ddd*K*b1*f**2*r*s - 36*D1*Ddd*K*b1*f**2*r + 144*D1*Ddd*K*b1*f**2*s**2 - 144*D1*Ddd*K*b1*f**2*s + 36*D1*Ddd*K*b1*f**2 - 240*D1*Ddd*b1*f**3*r**2 - 1200*D1*Ddd*b1*f**3*r*s + 540*D1*Ddd*b1*f**3*r - 960*D1*Ddd*b1*f**3*s**2 + 1080*D1*Ddd*b1*f**3*s - 360*D1*Ddd*b1*f**3 - 72*D1*Ddd*b1*f**2*r**2 - 288*D1*Ddd*b1*f**2*r*s + 144*D1*Ddd*b1*f**2*r - 216*D1*Ddd*b1*f**2*s**2 + 252*D1*Ddd*b1*f**2*s - 90*D1*Ddd*b1*f**2 + 660*D1*Ddd*f**4*r**2 + 2520*D1*Ddd*f**4*r*s - 1290*D1*Ddd*f**4*r + 1860*D1*Ddd*f**4*s**2 - 2190*D1*Ddd*f**4*s + 795*D1*Ddd*f**4 - 40*D1*Ddd*f**3*r**2 - 240*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r - 200*D1*Ddd*f**3*s**2 + 220*D1*Ddd*f**3*s - 70*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r*s + 72*D1*Ddd*f**2*g2*r - 288*D1*Ddd*f**2*g2*s**2 + 288*D1*Ddd*f**2*g2*s - 72*D1*Ddd*f**2*g2 + 6*D1*bd1*f*(D1*(f**2*(2*r**2 + r*(52*s - 64) + 50*s**2 - 112*s + 63) - f*(10*fd*(6*r**2 + 30*r*s - 19*r + 24*s**2 - 34*s + 9) + (r + s - 1)*(-2*K*s + r + 3*s - 1)) + 6*fd*(K*(r*(4*s - 1) + (1 - 2*s)**2) - 2*r**2 - 8*r*s + 4*r - 6*s**2 + 7*s - 2)) - 2*Dd*f*(3*K*(-8*r*s + r - 8*s**2 + 8*s - 1) + 5*f*(8*r**2 + r*(40*s - 29) + 32*s**2 - 50*s + 18) + 12*r**2 + 48*r*s - 24*r + 36*s**2 - 45*s + 12)) + 432*Dd**2*K*b1*f**2*r*s - 108*Dd**2*K*b1*f**2*r + 432*Dd**2*K*b1*f**2*s**2 - 432*Dd**2*K*b1*f**2*s + 72*Dd**2*K*b1*f**2 - 720*Dd**2*b1*f**3*r**2 - 3600*Dd**2*b1*f**3*r*s + 1620*Dd**2*b1*f**3*r - 2880*Dd**2*b1*f**3*s**2 + 3240*Dd**2*b1*f**3*s - 720*Dd**2*b1*f**3 - 216*Dd**2*b1*f**2*r**2 - 864*Dd**2*b1*f**2*r*s + 432*Dd**2*b1*f**2*r - 648*Dd**2*b1*f**2*s**2 + 756*Dd**2*b1*f**2*s - 180*Dd**2*b1*f**2 + 1980*Dd**2*f**4*r**2 + 7560*Dd**2*f**4*r*s - 3870*Dd**2*f**4*r + 5580*Dd**2*f**4*s**2 - 6570*Dd**2*f**4*s + 1590*Dd**2*f**4 - 120*Dd**2*f**3*r**2 - 720*Dd**2*f**3*r*s + 300*Dd**2*f**3*r - 600*Dd**2*f**3*s**2 + 660*Dd**2*f**3*s - 140*Dd**2*f**3 - 864*Dd**2*f**2*g2*r*s + 216*Dd**2*f**2*g2*r - 864*Dd**2*f**2*g2*s**2 + 864*Dd**2*f**2*g2*s - 144*Dd**2*f**2*g2)/(315*d**2*k2*k3**6) - 2*D1**2*Pk2*Pk3*ct*k1**5*(-D1*(12*D1*bd1**2*f*(r + s - 1)*(-14*K*s + 7*K + 5*f*(2*r + 2*s - 1) + 7*r + 21*s - 14) - 3*D1*bdd1*f*(r + s - 1)*(f**2*(55*r + 55*s - 75) - 10*f*(-4*C*(s - 1) + r + 5*s - 5) - 56*g2*(s - 1)) + bd1*(D1*(15*f**3*(9*r**2 + r*(22*s - 26) + 13*s**2 - 30*s + 17) + 6*f**2*(12*C*(s - 1)*(r + s - 1) - 5*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) - 3*r**2 - 18*r*(s - 1) - 15*(s - 1)**2) - 4*f*(15*fd*(2*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 2*r**2 - 12*r*s + 7*r - 10*s**2 + 13*s - 3) + (14*r + 14*s - 14)*(g2*(s - 1) - 6*gd2*s + 3*gd2)) + 168*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 6*Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + 10*f*(2*C*(8*r*s - 5*r + 8*s**2 - 12*s + 4) - 4*r**2 - 24*r*s + 17*r - 20*s**2 + 31*s - 11) - 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)))) + 2*b1**2*(D1**2*(3*f*(3*fd - 5*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 30*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*fd*(r + s)*(r + s*(3 - 2*K)) - 21*fdd*(r + s)*(r + s*(3 - 2*K))) + D1*(Dd*(18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-7*K*r*(8*s - 2) - 14*K*(1 - 2*s)**2 - 30*fd*(4*r + 4*s - 3)**2 + 28*r**2 - 7*r*(8 - 16*s) + 84*s**2 - 98*s + 35) - 42*fd*(4*r**2 + r*(-8*K*s + K + 16*s - 4) + s*(K*(4 - 8*s) + 12*s - 7))) - 3*Ddd*f*(-7*K*r*(8*s - 2) - 14*K*(1 - 2*s)**2 + 10*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 28*r**2 - 7*r*(8 - 16*s) + 84*s**2 - 98*s + 35)) - 6*Dd**2*f*(-7*K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 30*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 42*r**2 + 168*r*s - 84*r + 126*s**2 - 147*s + 35)) + b1*(-144*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s + 240*C*D1**2*f*fdd*r*s + 240*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 240*C*D1**2*fd**2*r*s + 240*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 288*C*D1*Dd*f**2*r*s + 72*C*D1*Dd*f**2*r - 288*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 1920*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 1920*C*D1*Dd*f*fd*s**2 - 1440*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 480*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 480*C*D1*Ddd*f**2*s**2 - 480*C*D1*Ddd*f**2*s + 120*C*D1*Ddd*f**2 + 1440*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 1440*C*Dd**2*f**2*s**2 - 1440*C*Dd**2*f**2*s + 240*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (14*r + 14*s - 14)*(-2*K*s + K + r + 3*s - 2)) - 405*D1**2*f**2*fd*r**2 - 990*D1**2*f**2*fd*r*s + 480*D1**2*f**2*fd*r - 585*D1**2*f**2*fd*s**2 + 600*D1**2*f**2*fd*s - 210*D1**2*f**2*fd + 495*D1**2*f**2*fdd*r**2 + 990*D1**2*f**2*fdd*r*s - 600*D1**2*f**2*fdd*r + 495*D1**2*f**2*fdd*s**2 - 600*D1**2*f**2*fdd*s + 270*D1**2*f**2*fdd + 990*D1**2*f*fd**2*r**2 + 1980*D1**2*f*fd**2*r*s - 1200*D1**2*f*fd**2*r + 990*D1**2*f*fd**2*s**2 - 1200*D1**2*f*fd**2*s + 270*D1**2*f*fd**2 + 36*D1**2*f*fd*r**2 + 216*D1**2*f*fd*r*s - 36*D1**2*f*fd*r + 180*D1**2*f*fd*s**2 - 108*D1**2*f*fd*s + 18*D1**2*f*fd - 60*D1**2*f*fdd*r**2 - 360*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 300*D1**2*f*fdd*s**2 + 180*D1**2*f*fdd*s - 30*D1**2*f*fdd + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 60*D1**2*fd**2*r**2 - 360*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 300*D1**2*fd**2*s**2 + 180*D1**2*fd**2*s + 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 336*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*s**2 - 540*D1*Dd*f**3*r**2 - 1320*D1*Dd*f**3*r*s + 870*D1*Dd*f**3*r - 780*D1*Dd*f**3*s**2 + 1050*D1*Dd*f**3*s - 465*D1*Dd*f**3 + 3960*D1*Dd*f**2*fd*r**2 + 7920*D1*Dd*f**2*fd*r*s - 5370*D1*Dd*f**2*fd*r + 3960*D1*Dd*f**2*fd*s**2 - 5370*D1*Dd*f**2*fd*s + 1800*D1*Dd*f**2*fd + 72*D1*Dd*f**2*r**2 + 432*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r + 360*D1*Dd*f**2*s**2 - 396*D1*Dd*f**2*s + 126*D1*Dd*f**2 - 480*D1*Dd*f*fd*r**2 - 2880*D1*Dd*f*fd*r*s + 840*D1*Dd*f*fd*r - 2400*D1*Dd*f*fd*s**2 + 2040*D1*Dd*f*fd*s - 300*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 1344*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 + 672*D1*Dd*fd*g2*s + 660*D1*Ddd*f**3*r**2 + 1320*D1*Ddd*f**3*r*s - 990*D1*Ddd*f**3*r + 660*D1*Ddd*f**3*s**2 - 990*D1*Ddd*f**3*s + 495*D1*Ddd*f**3 - 120*D1*Ddd*f**2*r**2 - 720*D1*Ddd*f**2*r*s + 300*D1*Ddd*f**2*r - 600*D1*Ddd*f**2*s**2 + 660*D1*Ddd*f**2*s - 210*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 672*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(r + s - 1)*(14*K*s - 7*K + 60*fd*(2*r + 2*s - 1) - 7*r - 21*s + 14) - 42*fd*(2*r**2 + r*(-4*K*s + K + 8*s - 3) + s*(-4*K*s + 3*K + 6*s - 5))) - 6*Dd*f*(-7*K*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + 5*f*(4*r + 4*s - 3)**2 + 56*r**2 + 224*r*s - 140*r + 168*s**2 - 238*s + 77)) + 1980*Dd**2*f**3*r**2 + 3960*Dd**2*f**3*r*s - 2970*Dd**2*f**3*r + 1980*Dd**2*f**3*s**2 - 2970*Dd**2*f**3*s + 990*Dd**2*f**3 - 360*Dd**2*f**2*r**2 - 2160*Dd**2*f**2*r*s + 900*Dd**2*f**2*r - 1800*Dd**2*f**2*s**2 + 1980*Dd**2*f**2*s - 420*Dd**2*f**2 - 2016*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 2016*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(105*d**2*k2*k3**6) + 4*D1**2*Pk2*Pk3*ct*k1**3*k2**3*st**4*(-108*C*D1**2*f**2*fd*r**2 - 216*C*D1**2*f**2*fd*r*s + 144*C*D1**2*f**2*fd*r - 108*C*D1**2*f**2*fd*s**2 + 144*C*D1**2*f**2*fd*s - 72*C*D1**2*f**2*fd + 72*C*D1**2*f**2*fdd*r**2 + 144*C*D1**2*f**2*fdd*r*s - 96*C*D1**2*f**2*fdd*r + 72*C*D1**2*f**2*fdd*s**2 - 96*C*D1**2*f**2*fdd*s + 48*C*D1**2*f**2*fdd + 144*C*D1**2*f*fd**2*r**2 + 288*C*D1**2*f*fd**2*r*s - 192*C*D1**2*f*fd**2*r + 144*C*D1**2*f*fd**2*s**2 - 192*C*D1**2*f*fd**2*s + 48*C*D1**2*f*fd**2 - 144*C*D1*Dd*f**3*r**2 - 288*C*D1*Dd*f**3*r*s + 216*C*D1*Dd*f**3*r - 144*C*D1*Dd*f**3*s**2 + 216*C*D1*Dd*f**3*s - 108*C*D1*Dd*f**3 + 576*C*D1*Dd*f**2*fd*r**2 + 1152*C*D1*Dd*f**2*fd*r*s - 816*C*D1*Dd*f**2*fd*r + 576*C*D1*Dd*f**2*fd*s**2 - 816*C*D1*Dd*f**2*fd*s + 288*C*D1*Dd*f**2*fd + 96*C*D1*Ddd*f**3*r**2 + 192*C*D1*Ddd*f**3*r*s - 144*C*D1*Ddd*f**3*r + 96*C*D1*Ddd*f**3*s**2 - 144*C*D1*Ddd*f**3*s + 72*C*D1*Ddd*f**3 + 288*C*Dd**2*f**3*r**2 + 576*C*Dd**2*f**3*r*s - 432*C*Dd**2*f**3*r + 288*C*Dd**2*f**3*s**2 - 432*C*Dd**2*f**3*s + 144*C*Dd**2*f**3 - 60*D1**2*K*b1*f*fd*r**2 - 120*D1**2*K*b1*f*fd*r*s + 60*D1**2*K*b1*f*fd*r - 60*D1**2*K*b1*f*fd*s**2 + 60*D1**2*K*b1*f*fd*s - 30*D1**2*K*b1*f*fd + 72*D1**2*K*b1*f*fdd*r**2 + 144*D1**2*K*b1*f*fdd*r*s - 72*D1**2*K*b1*f*fdd*r + 72*D1**2*K*b1*f*fdd*s**2 - 72*D1**2*K*b1*f*fdd*s + 36*D1**2*K*b1*f*fdd + 72*D1**2*K*b1*fd**2*r**2 + 144*D1**2*K*b1*fd**2*r*s - 72*D1**2*K*b1*fd**2*r + 72*D1**2*K*b1*fd**2*s**2 - 72*D1**2*K*b1*fd**2*s + 69*D1**2*b1*f**2*fd*r**2 + 138*D1**2*b1*f**2*fd*r*s - 92*D1**2*b1*f**2*fd*r + 69*D1**2*b1*f**2*fd*s**2 - 92*D1**2*b1*f**2*fd*s + 46*D1**2*b1*f**2*fd - 75*D1**2*b1*f**2*fdd*r**2 - 150*D1**2*b1*f**2*fdd*r*s + 100*D1**2*b1*f**2*fdd*r - 75*D1**2*b1*f**2*fdd*s**2 + 100*D1**2*b1*f**2*fdd*s - 50*D1**2*b1*f**2*fdd - 150*D1**2*b1*f*fd**2*r**2 - 300*D1**2*b1*f*fd**2*r*s + 200*D1**2*b1*f*fd**2*r - 150*D1**2*b1*f*fd**2*s**2 + 200*D1**2*b1*f*fd**2*s - 50*D1**2*b1*f*fd**2 + 30*D1**2*b1*f*fd*r**2 + 60*D1**2*b1*f*fd*r*s - 30*D1**2*b1*f*fd*r + 30*D1**2*b1*f*fd*s**2 - 30*D1**2*b1*f*fd*s + 15*D1**2*b1*f*fd - 36*D1**2*b1*f*fdd*r**2 - 72*D1**2*b1*f*fdd*r*s + 36*D1**2*b1*f*fdd*r - 36*D1**2*b1*f*fdd*s**2 + 36*D1**2*b1*f*fdd*s - 18*D1**2*b1*f*fdd - 36*D1**2*b1*fd**2*r**2 - 72*D1**2*b1*fd**2*r*s + 36*D1**2*b1*fd**2*r - 36*D1**2*b1*fd**2*s**2 + 36*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-36*K + 25*f + 18)*(r + s - 1)**2 + 60*D1**2*f**3*fd*r**2 + 120*D1**2*f**3*fd*r*s - 90*D1**2*f**3*fd*r + 60*D1**2*f**3*fd*s**2 - 90*D1**2*f**3*fd*s + 45*D1**2*f**3*fd + 81*D1**2*f**2*fd*r**2 + 162*D1**2*f**2*fd*r*s - 108*D1**2*f**2*fd*r + 81*D1**2*f**2*fd*s**2 - 108*D1**2*f**2*fd*s + 54*D1**2*f**2*fd - 54*D1**2*f**2*fdd*r**2 - 108*D1**2*f**2*fdd*r*s + 72*D1**2*f**2*fdd*r - 54*D1**2*f**2*fdd*s**2 + 72*D1**2*f**2*fdd*s - 36*D1**2*f**2*fdd + 60*D1**2*f**2*gd2*r**2 + 120*D1**2*f**2*gd2*r*s - 120*D1**2*f**2*gd2*r + 60*D1**2*f**2*gd2*s**2 - 120*D1**2*f**2*gd2*s + 60*D1**2*f**2*gd2 - 72*D1**2*f**2*gdd2*r**2 - 144*D1**2*f**2*gdd2*r*s + 144*D1**2*f**2*gdd2*r - 72*D1**2*f**2*gdd2*s**2 + 144*D1**2*f**2*gdd2*s - 72*D1**2*f**2*gdd2 - 108*D1**2*f*fd**2*r**2 - 216*D1**2*f*fd**2*r*s + 144*D1**2*f*fd**2*r - 108*D1**2*f*fd**2*s**2 + 144*D1**2*f*fd**2*s - 36*D1**2*f*fd**2 + 120*D1**2*f*fd*g2*r**2 + 240*D1**2*f*fd*g2*r*s - 120*D1**2*f*fd*g2*r + 120*D1**2*f*fd*g2*s**2 - 120*D1**2*f*fd*g2*s + 60*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r**2 - 576*D1**2*f*fd*gd2*r*s + 432*D1**2*f*fd*gd2*r - 288*D1**2*f*fd*gd2*s**2 + 432*D1**2*f*fd*gd2*s - 144*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r**2 - 288*D1**2*f*fdd*g2*r*s + 144*D1**2*f*fdd*g2*r - 144*D1**2*f*fdd*g2*s**2 + 144*D1**2*f*fdd*g2*s - 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r**2 - 288*D1**2*fd**2*g2*r*s + 144*D1**2*fd**2*g2*r - 144*D1**2*fd**2*g2*s**2 + 144*D1**2*fd**2*g2*s - 120*D1*Dd*K*b1*f**2*r**2 - 240*D1*Dd*K*b1*f**2*r*s + 180*D1*Dd*K*b1*f**2*r - 120*D1*Dd*K*b1*f**2*s**2 + 180*D1*Dd*K*b1*f**2*s - 90*D1*Dd*K*b1*f**2 + 576*D1*Dd*K*b1*f*fd*r**2 + 1152*D1*Dd*K*b1*f*fd*r*s - 720*D1*Dd*K*b1*f*fd*r + 576*D1*Dd*K*b1*f*fd*s**2 - 720*D1*Dd*K*b1*f*fd*s + 216*D1*Dd*K*b1*f*fd + 92*D1*Dd*b1*f**3*r**2 + 184*D1*Dd*b1*f**3*r*s - 138*D1*Dd*b1*f**3*r + 92*D1*Dd*b1*f**3*s**2 - 138*D1*Dd*b1*f**3*s + 69*D1*Dd*b1*f**3 - 600*D1*Dd*b1*f**2*fd*r**2 - 1200*D1*Dd*b1*f**2*fd*r*s + 850*D1*Dd*b1*f**2*fd*r - 600*D1*Dd*b1*f**2*fd*s**2 + 850*D1*Dd*b1*f**2*fd*s - 300*D1*Dd*b1*f**2*fd + 60*D1*Dd*b1*f**2*r**2 + 120*D1*Dd*b1*f**2*r*s - 90*D1*Dd*b1*f**2*r + 60*D1*Dd*b1*f**2*s**2 - 90*D1*Dd*b1*f**2*s + 45*D1*Dd*b1*f**2 - 288*D1*Dd*b1*f*fd*r**2 - 576*D1*Dd*b1*f*fd*r*s + 360*D1*Dd*b1*f*fd*r - 288*D1*Dd*b1*f*fd*s**2 + 360*D1*Dd*b1*f*fd*s - 108*D1*Dd*b1*f*fd + 60*D1*Dd*f**4*r**2 + 120*D1*Dd*f**4*r*s - 90*D1*Dd*f**4*r + 60*D1*Dd*f**4*s**2 - 90*D1*Dd*f**4*s + 45*D1*Dd*f**4 + 108*D1*Dd*f**3*r**2 + 216*D1*Dd*f**3*r*s - 162*D1*Dd*f**3*r + 108*D1*Dd*f**3*s**2 - 162*D1*Dd*f**3*s + 81*D1*Dd*f**3 - 432*D1*Dd*f**2*fd*r**2 - 864*D1*Dd*f**2*fd*r*s + 612*D1*Dd*f**2*fd*r - 432*D1*Dd*f**2*fd*s**2 + 612*D1*Dd*f**2*fd*s - 216*D1*Dd*f**2*fd + 240*D1*Dd*f**2*g2*r**2 + 480*D1*Dd*f**2*g2*r*s - 360*D1*Dd*f**2*g2*r + 240*D1*Dd*f**2*g2*s**2 - 360*D1*Dd*f**2*g2*s + 180*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r**2 - 1152*D1*Dd*f**2*gd2*r*s + 1008*D1*Dd*f**2*gd2*r - 576*D1*Dd*f**2*gd2*s**2 + 1008*D1*Dd*f**2*gd2*s - 432*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r**2 - 2304*D1*Dd*f*fd*g2*r*s + 1440*D1*Dd*f*fd*g2*r - 1152*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 432*D1*Dd*f*fd*g2 + 144*D1*Ddd*K*b1*f**2*r**2 + 288*D1*Ddd*K*b1*f**2*r*s - 216*D1*Ddd*K*b1*f**2*r + 144*D1*Ddd*K*b1*f**2*s**2 - 216*D1*Ddd*K*b1*f**2*s + 108*D1*Ddd*K*b1*f**2 - 100*D1*Ddd*b1*f**3*r**2 - 200*D1*Ddd*b1*f**3*r*s + 150*D1*Ddd*b1*f**3*r - 100*D1*Ddd*b1*f**3*s**2 + 150*D1*Ddd*b1*f**3*s - 75*D1*Ddd*b1*f**3 - 72*D1*Ddd*b1*f**2*r**2 - 144*D1*Ddd*b1*f**2*r*s + 108*D1*Ddd*b1*f**2*r - 72*D1*Ddd*b1*f**2*s**2 + 108*D1*Ddd*b1*f**2*s - 54*D1*Ddd*b1*f**2 - 72*D1*Ddd*f**3*r**2 - 144*D1*Ddd*f**3*r*s + 108*D1*Ddd*f**3*r - 72*D1*Ddd*f**3*s**2 + 108*D1*Ddd*f**3*s - 54*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r**2 - 576*D1*Ddd*f**2*g2*r*s + 432*D1*Ddd*f**2*g2*r - 288*D1*Ddd*f**2*g2*s**2 + 432*D1*Ddd*f**2*g2*s - 216*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(23*f**2*(r + s - 1) - 5*f*(10*fd*(3*r + 3*s - 2) + (6*K - 3)*(r + s - 1)) + 36*fd*(2*K - 1)*(2*r + 2*s - 1)) - 2*Dd*f*(-36*K + 25*f + 18)*(4*r + 4*s - 3))*(r + s - 1) + 432*Dd**2*K*b1*f**2*r**2 + 864*Dd**2*K*b1*f**2*r*s - 648*Dd**2*K*b1*f**2*r + 432*Dd**2*K*b1*f**2*s**2 - 648*Dd**2*K*b1*f**2*s + 216*Dd**2*K*b1*f**2 - 300*Dd**2*b1*f**3*r**2 - 600*Dd**2*b1*f**3*r*s + 450*Dd**2*b1*f**3*r - 300*Dd**2*b1*f**3*s**2 + 450*Dd**2*b1*f**3*s - 150*Dd**2*b1*f**3 - 216*Dd**2*b1*f**2*r**2 - 432*Dd**2*b1*f**2*r*s + 324*Dd**2*b1*f**2*r - 216*Dd**2*b1*f**2*s**2 + 324*Dd**2*b1*f**2*s - 108*Dd**2*b1*f**2 - 216*Dd**2*f**3*r**2 - 432*Dd**2*f**3*r*s + 324*Dd**2*f**3*r - 216*Dd**2*f**3*s**2 + 324*Dd**2*f**3*s - 108*Dd**2*f**3 - 864*Dd**2*f**2*g2*r**2 - 1728*Dd**2*f**2*g2*r*s + 1296*Dd**2*f**2*g2*r - 864*Dd**2*f**2*g2*s**2 + 1296*Dd**2*f**2*g2*s - 432*Dd**2*f**2*g2)/(35*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct*k1**3*k2**3*st**2*(72*C*D1**2*bdd1*f**2*r**2 + 144*C*D1**2*bdd1*f**2*r*s - 144*C*D1**2*bdd1*f**2*r + 72*C*D1**2*bdd1*f**2*s**2 - 144*C*D1**2*bdd1*f**2*s + 72*C*D1**2*bdd1*f**2 - 60*C*D1**2*f**2*fd*r**2 - 120*C*D1**2*f**2*fd*r*s + 80*C*D1**2*f**2*fd*r - 60*C*D1**2*f**2*fd*s**2 + 80*C*D1**2*f**2*fd*s - 40*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r**2 + 240*C*D1**2*f**2*fdd*r*s - 160*C*D1**2*f**2*fdd*r + 120*C*D1**2*f**2*fdd*s**2 - 160*C*D1**2*f**2*fdd*s + 80*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r**2 + 480*C*D1**2*f*fd**2*r*s - 320*C*D1**2*f*fd**2*r + 240*C*D1**2*f*fd**2*s**2 - 320*C*D1**2*f*fd**2*s + 80*C*D1**2*f*fd**2 - 80*C*D1*Dd*f**3*r**2 - 160*C*D1*Dd*f**3*r*s + 120*C*D1*Dd*f**3*r - 80*C*D1*Dd*f**3*s**2 + 120*C*D1*Dd*f**3*s - 60*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r**2 + 1920*C*D1*Dd*f**2*fd*r*s - 1360*C*D1*Dd*f**2*fd*r + 960*C*D1*Dd*f**2*fd*s**2 - 1360*C*D1*Dd*f**2*fd*s + 480*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r**2 + 320*C*D1*Ddd*f**3*r*s - 240*C*D1*Ddd*f**3*r + 160*C*D1*Ddd*f**3*s**2 - 240*C*D1*Ddd*f**3*s + 120*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r**2 + 960*C*Dd**2*f**3*r*s - 720*C*Dd**2*f**3*r + 480*C*Dd**2*f**3*s**2 - 720*C*Dd**2*f**3*s + 240*C*Dd**2*f**3 + 36*D1**2*K*bdd1*f**2*r**2 + 72*D1**2*K*bdd1*f**2*r*s - 72*D1**2*K*bdd1*f**2*r + 36*D1**2*K*bdd1*f**2*s**2 - 72*D1**2*K*bdd1*f**2*s + 36*D1**2*K*bdd1*f**2 - 12*D1**2*bd1**2*f*(-14*K + 15*f + 7)*(r + s - 1)**2 - 54*D1**2*bdd1*f**2*r**2 - 108*D1**2*bdd1*f**2*r*s + 108*D1**2*bdd1*f**2*r - 54*D1**2*bdd1*f**2*s**2 + 108*D1**2*bdd1*f**2*s - 54*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r**2 - 336*D1**2*bdd1*f*g2*r*s + 336*D1**2*bdd1*f*g2*r - 168*D1**2*bdd1*f*g2*s**2 + 336*D1**2*bdd1*f*g2*s - 168*D1**2*bdd1*f*g2 + 21*D1**2*f**2*fd*r**2 + 42*D1**2*f**2*fd*r*s - 28*D1**2*f**2*fd*r + 21*D1**2*f**2*fd*s**2 - 28*D1**2*f**2*fd*s + 14*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd + 4*D1**2*f**2*gd2*r**2 + 8*D1**2*f**2*gd2*r*s - 8*D1**2*f**2*gd2*r + 4*D1**2*f**2*gd2*s**2 - 8*D1**2*f**2*gd2*s + 4*D1**2*f**2*gd2 - 72*D1**2*f**2*gdd2*r**2 - 144*D1**2*f**2*gdd2*r*s + 144*D1**2*f**2*gdd2*r - 72*D1**2*f**2*gdd2*s**2 + 144*D1**2*f**2*gdd2*s - 72*D1**2*f**2*gdd2 - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 8*D1**2*f*fd*g2*r**2 + 16*D1**2*f*fd*g2*r*s - 8*D1**2*f*fd*g2*r + 8*D1**2*f*fd*g2*s**2 - 8*D1**2*f*fd*g2*s + 4*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r**2 - 576*D1**2*f*fd*gd2*r*s + 432*D1**2*f*fd*gd2*r - 288*D1**2*f*fd*gd2*s**2 + 432*D1**2*f*fd*gd2*s - 144*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r**2 - 288*D1**2*f*fdd*g2*r*s + 144*D1**2*f*fdd*g2*r - 144*D1**2*f*fdd*g2*s**2 + 144*D1**2*f*fdd*g2*s - 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r**2 - 288*D1**2*fd**2*g2*r*s + 144*D1**2*fd**2*g2*r - 144*D1**2*fd**2*g2*s**2 + 144*D1**2*fd**2*g2*s + 28*D1*Dd*f**3*r**2 + 56*D1*Dd*f**3*r*s - 42*D1*Dd*f**3*r + 28*D1*Dd*f**3*s**2 - 42*D1*Dd*f**3*s + 21*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 680*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 680*D1*Dd*f**2*fd*s - 240*D1*Dd*f**2*fd + 16*D1*Dd*f**2*g2*r**2 + 32*D1*Dd*f**2*g2*r*s - 24*D1*Dd*f**2*g2*r + 16*D1*Dd*f**2*g2*s**2 - 24*D1*Dd*f**2*g2*s + 12*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r**2 - 1152*D1*Dd*f**2*gd2*r*s + 1008*D1*Dd*f**2*gd2*r - 576*D1*Dd*f**2*gd2*s**2 + 1008*D1*Dd*f**2*gd2*s - 432*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r**2 - 2304*D1*Dd*f*fd*g2*r*s + 1440*D1*Dd*f*fd*g2*r - 1152*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 432*D1*Dd*f*fd*g2 - 80*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 120*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r**2 - 576*D1*Ddd*f**2*g2*r*s + 432*D1*Ddd*f**2*g2*r - 288*D1*Ddd*f**2*g2*s**2 + 432*D1*Ddd*f**2*g2*s - 216*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(f**2*(58*C + K - 40)*(r + s - 1) - 2*f*(9*fd*(4*C + 2*K - 3)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 6*Dd*f*(3*f*(4*C + 2*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 240*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 360*Dd**2*f**3*s - 120*Dd**2*f**3 - 864*Dd**2*f**2*g2*r**2 - 1728*Dd**2*f**2*g2*r*s + 1296*Dd**2*f**2*g2*r - 864*Dd**2*f**2*g2*s**2 + 1296*Dd**2*f**2*g2*s - 432*Dd**2*f**2*g2 + b1**2*(D1**2*(9*f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(180*fd**2*(r + s - 1) + 49*fd*(2*K - 1)*(r + s) - 42*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(117*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(180*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (98*K - 49)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 84*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-14*K + 15*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-14*K + 15*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(-116*C*D1**2*f*fd*r**2 - 232*C*D1**2*f*fd*r*s + 116*C*D1**2*f*fd*r - 116*C*D1**2*f*fd*s**2 + 116*C*D1**2*f*fd*s - 58*C*D1**2*f*fd + 72*C*D1**2*f*fdd*r**2 + 144*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 36*C*D1**2*f*fdd + 72*C*D1**2*fd**2*r**2 + 144*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*r + 72*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s - 232*C*D1*Dd*f**2*r**2 - 464*C*D1*Dd*f**2*r*s + 348*C*D1*Dd*f**2*r - 232*C*D1*Dd*f**2*s**2 + 348*C*D1*Dd*f**2*s - 174*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 + 1152*C*D1*Dd*f*fd*r*s - 720*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 216*C*D1*Dd*f*fd + 144*C*D1*Ddd*f**2*r**2 + 288*C*D1*Ddd*f**2*r*s - 216*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 216*C*D1*Ddd*f**2*s + 108*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r**2 + 864*C*Dd**2*f**2*r*s - 648*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 648*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 - 2*D1**2*K*f*fd*r**2 - 4*D1**2*K*f*fd*r*s + 2*D1**2*K*f*fd*r - 2*D1**2*K*f*fd*s**2 + 2*D1**2*K*f*fd*s - D1**2*K*f*fd + 36*D1**2*K*f*fdd*r**2 + 72*D1**2*K*f*fdd*r*s - 36*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r**2 + 72*D1**2*K*fd**2*r*s - 36*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-14*K + 15*f + 7)*(r + s - 1)**2 + 80*D1**2*f*fd*r**2 + 160*D1**2*f*fd*r*s - 80*D1**2*f*fd*r + 80*D1**2*f*fd*s**2 - 80*D1**2*f*fd*s + 40*D1**2*f*fd - 54*D1**2*f*fdd*r**2 - 108*D1**2*f*fdd*r*s + 54*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 54*D1**2*f*fdd*s - 27*D1**2*f*fdd + 98*D1**2*f*gd2*r**2 + 196*D1**2*f*gd2*r*s - 196*D1**2*f*gd2*r + 98*D1**2*f*gd2*s**2 - 196*D1**2*f*gd2*s + 98*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 54*D1**2*fd**2*r**2 - 108*D1**2*fd**2*r*s + 54*D1**2*fd**2*r - 54*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s + 98*D1**2*fd*g2*r**2 + 196*D1**2*fd*g2*r*s + 98*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 - 4*D1*Dd*K*f**2*r**2 - 8*D1*Dd*K*f**2*r*s + 6*D1*Dd*K*f**2*r - 4*D1*Dd*K*f**2*s**2 + 6*D1*Dd*K*f**2*s - 3*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r**2 + 576*D1*Dd*K*f*fd*r*s - 360*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 360*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd + 160*D1*Dd*f**2*r**2 + 320*D1*Dd*f**2*r*s - 240*D1*Dd*f**2*r + 160*D1*Dd*f**2*s**2 - 240*D1*Dd*f**2*s + 120*D1*Dd*f**2 - 432*D1*Dd*f*fd*r**2 - 864*D1*Dd*f*fd*r*s + 540*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 540*D1*Dd*f*fd*s - 162*D1*Dd*f*fd + 392*D1*Dd*f*g2*r**2 + 784*D1*Dd*f*g2*r*s - 588*D1*Dd*f*g2*r + 392*D1*Dd*f*g2*s**2 - 588*D1*Dd*f*g2*s + 294*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s + 72*D1*Ddd*K*f**2*r**2 + 144*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 108*D1*Ddd*K*f**2*s + 54*D1*Ddd*K*f**2 - 108*D1*Ddd*f**2*r**2 - 216*D1*Ddd*f**2*r*s + 162*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 162*D1*Ddd*f**2*s - 81*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + D1*bd1*(D1*(117*f**2*(r + s - 1) - 180*f*fd*(2*r + 2*s - 1) - 49*f*(2*K - 1)*(r + s - 1) + 84*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-14*K + 15*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*f**2*r**2 + 432*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 324*Dd**2*K*f**2*s + 108*Dd**2*K*f**2 - 324*Dd**2*f**2*r**2 - 648*Dd**2*f**2*r*s + 486*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 486*Dd**2*f**2*s - 162*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(35*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct*k1**3*k2**3*(-3*D1*(r + s - 1)*(56*D1*K*bd1**2*f*(r + s - 1) + 4*D1*bdd1*f*(f*(10*C - 5) - 14*g2)*(r + s - 1) + bd1*(D1*(f**2*(4*C - 9)*(r + s - 1) + f*fd*(80*C - 40)*(2*r + 2*s - 1) - 28*f*(g2 + 4*gd2)*(r + s - 1) - 112*fd*g2*(r + s)) + 8*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))) + 7*b1**2*(D1**2*(9*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)**2*(12*K*fdd + fd*(6*K - 5))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(6*K - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-3*D1**2*(f*(fd*(4*C - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*(r + s - 1)**2*(14*K*bdd1 - 7*gd2 - 14*gdd2)) + (4*r + 4*s)*(fd**2*(20*C - 10)*(r + s - 1) - 7*fd*(g2*(r + s) + 4*gd2*(r + s - 1)) - 14*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-24*K*fd*(r + s) + 9*f**2*(r + s - 1) - f*(6*K - 5)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(f**2*(4*C - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4*f*(fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 28*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 112*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 4*Ddd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(10*C - 5) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(35*d**2*k3**8) - 2*D1**2*Pk2*Pk3*ct*k1**3*k2*st**4*(-144*C*D1**2*f**2*fd*r**2 + 72*C*D1**2*f**2*fd*r*s + 72*C*D1**2*f**2*fd*r + 216*C*D1**2*f**2*fd*s**2 - 168*C*D1**2*f**2*fd*s + 24*C*D1**2*f**2*fd + 72*C*D1**2*f**2*fdd*r**2 - 48*C*D1**2*f**2*fdd*r - 72*C*D1**2*f**2*fdd*s**2 + 48*C*D1**2*f**2*fdd*s + 144*C*D1**2*f*fd**2*r**2 - 96*C*D1**2*f*fd**2*r - 144*C*D1**2*f*fd**2*s**2 + 96*C*D1**2*f*fd**2*s - 192*C*D1*Dd*f**3*r**2 + 96*C*D1*Dd*f**3*r*s + 168*C*D1*Dd*f**3*r + 288*C*D1*Dd*f**3*s**2 - 192*C*D1*Dd*f**3*s - 24*C*D1*Dd*f**3 + 576*C*D1*Dd*f**2*fd*r**2 - 480*C*D1*Dd*f**2*fd*r - 576*C*D1*Dd*f**2*fd*s**2 + 336*C*D1*Dd*f**2*fd*s + 48*C*D1*Dd*f**2*fd + 96*C*D1*Ddd*f**3*r**2 - 96*C*D1*Ddd*f**3*r - 96*C*D1*Ddd*f**3*s**2 + 48*C*D1*Ddd*f**3*s + 24*C*D1*Ddd*f**3 + 288*C*Dd**2*f**3*r**2 - 288*C*Dd**2*f**3*r - 288*C*Dd**2*f**3*s**2 + 144*C*Dd**2*f**3*s + 48*C*Dd**2*f**3 - 144*D1**2*K*b1*f*fd*r**2 + 168*D1**2*K*b1*f*fd*r*s - 84*D1**2*K*b1*f*fd*r + 312*D1**2*K*b1*f*fd*s**2 - 312*D1**2*K*b1*f*fd*s + 156*D1**2*K*b1*f*fd + 72*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*s**2 + 72*D1**2*K*b1*f*fdd*s - 36*D1**2*K*b1*f*fdd + 72*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*s**2 + 72*D1**2*K*b1*fd**2*s + 342*D1**2*b1*f**2*fd*r**2 + 516*D1**2*b1*f**2*fd*r*s - 348*D1**2*b1*f**2*fd*r + 174*D1**2*b1*f**2*fd*s**2 - 236*D1**2*b1*f**2*fd*s + 72*D1**2*b1*f**2*fd - 270*D1**2*b1*f**2*fdd*r**2 - 420*D1**2*b1*f**2*fdd*r*s + 300*D1**2*b1*f**2*fdd*r - 150*D1**2*b1*f**2*fdd*s**2 + 220*D1**2*b1*f**2*fdd*s - 90*D1**2*b1*f**2*fdd - 540*D1**2*b1*f*fd**2*r**2 - 840*D1**2*b1*f*fd**2*r*s + 600*D1**2*b1*f*fd**2*r - 300*D1**2*b1*f*fd**2*s**2 + 440*D1**2*b1*f*fd**2*s - 180*D1**2*b1*f*fd**2 + 204*D1**2*b1*f*fd*r**2 + 96*D1**2*b1*f*fd*r*s - 48*D1**2*b1*f*fd*r - 108*D1**2*b1*f*fd*s**2 + 108*D1**2*b1*f*fd*s - 54*D1**2*b1*f*fd - 144*D1**2*b1*f*fdd*r**2 - 216*D1**2*b1*f*fdd*r*s + 108*D1**2*b1*f*fdd*r - 72*D1**2*b1*f*fdd*s**2 + 72*D1**2*b1*f*fdd*s - 36*D1**2*b1*f*fdd - 144*D1**2*b1*fd**2*r**2 - 216*D1**2*b1*fd**2*r*s + 108*D1**2*b1*fd**2*r - 72*D1**2*b1*fd**2*s**2 + 72*D1**2*b1*fd**2*s - 2*D1**2*bdd1*f**2*(5*f*(9*r**2 + 2*r*(7*s - 10) + 5*s**2 - 16*s + 14) + (r + s - 1)*(-18*K*(r - s - 1) + 36*r + 18*s - 36)) - 780*D1**2*f**3*fd*r**2 - 2040*D1**2*f**3*fd*r*s + 1290*D1**2*f**3*fd*r - 1260*D1**2*f**3*fd*s**2 + 1650*D1**2*f**3*fd*s - 705*D1**2*f**3*fd + 900*D1**2*f**3*fdd*r**2 + 1800*D1**2*f**3*fdd*r*s - 1350*D1**2*f**3*fdd*r + 900*D1**2*f**3*fdd*s**2 - 1350*D1**2*f**3*fdd*s + 675*D1**2*f**3*fdd + 2700*D1**2*f**2*fd**2*r**2 + 5400*D1**2*f**2*fd**2*r*s - 4050*D1**2*f**2*fd**2*r + 2700*D1**2*f**2*fd**2*s**2 - 4050*D1**2*f**2*fd**2*s + 1350*D1**2*f**2*fd**2 + 198*D1**2*f**2*fd*r**2 + 108*D1**2*f**2*fd*r*s - 168*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 24*D1**2*f**2*fd*s + 36*D1**2*f**2*fd - 108*D1**2*f**2*fdd*r**2 - 108*D1**2*f**2*fdd*r*s + 108*D1**2*f**2*fdd*r + 36*D1**2*f**2*fdd*s - 36*D1**2*f**2*fdd + 144*D1**2*f**2*gd2*r**2 - 168*D1**2*f**2*gd2*r*s - 288*D1**2*f**2*gd2*r - 312*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s + 144*D1**2*f**2*gd2 - 72*D1**2*f**2*gdd2*r**2 + 144*D1**2*f**2*gdd2*r + 72*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2 - 216*D1**2*f*fd**2*r**2 - 216*D1**2*f*fd**2*r*s + 216*D1**2*f*fd**2*r + 72*D1**2*f*fd**2*s - 36*D1**2*f*fd**2 + 288*D1**2*f*fd*g2*r**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r - 624*D1**2*f*fd*g2*s**2 + 624*D1**2*f*fd*g2*s - 312*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r + 288*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s - 144*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*s**2 - 144*D1**2*f*fdd*g2*s + 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*s**2 - 144*D1**2*fd**2*g2*s - 288*D1*Dd*K*b1*f**2*r**2 + 336*D1*Dd*K*b1*f**2*r*s + 204*D1*Dd*K*b1*f**2*r + 624*D1*Dd*K*b1*f**2*s**2 - 480*D1*Dd*K*b1*f**2*s + 12*D1*Dd*K*b1*f**2 + 576*D1*Dd*K*b1*f*fd*r**2 - 288*D1*Dd*K*b1*f*fd*r - 576*D1*Dd*K*b1*f*fd*s**2 + 432*D1*Dd*K*b1*f*fd*s - 72*D1*Dd*K*b1*f*fd + 456*D1*Dd*b1*f**3*r**2 + 688*D1*Dd*b1*f**3*r*s - 628*D1*Dd*b1*f**3*r + 232*D1*Dd*b1*f**3*s**2 - 460*D1*Dd*b1*f**3*s + 286*D1*Dd*b1*f**3 - 2160*D1*Dd*b1*f**2*fd*r**2 - 3360*D1*Dd*b1*f**2*fd*r*s + 2700*D1*Dd*b1*f**2*fd*r - 1200*D1*Dd*b1*f**2*fd*s**2 + 2020*D1*Dd*b1*f**2*fd*s - 820*D1*Dd*b1*f**2*fd + 408*D1*Dd*b1*f**2*r**2 + 192*D1*Dd*b1*f**2*r*s - 456*D1*Dd*b1*f**2*r - 216*D1*Dd*b1*f**2*s**2 + 12*D1*Dd*b1*f**2*s + 150*D1*Dd*b1*f**2 - 1152*D1*Dd*b1*f*fd*r**2 - 1728*D1*Dd*b1*f*fd*r*s + 1224*D1*Dd*b1*f*fd*r - 576*D1*Dd*b1*f*fd*s**2 + 864*D1*Dd*b1*f*fd*s - 288*D1*Dd*b1*f*fd - 780*D1*Dd*f**4*r**2 - 2040*D1*Dd*f**4*r*s + 1290*D1*Dd*f**4*r - 1260*D1*Dd*f**4*s**2 + 1650*D1*Dd*f**4*s - 705*D1*Dd*f**4 + 7200*D1*Dd*f**3*fd*r**2 + 14400*D1*Dd*f**3*fd*r*s - 10800*D1*Dd*f**3*fd*r + 7200*D1*Dd*f**3*fd*s**2 - 10800*D1*Dd*f**3*fd*s + 4050*D1*Dd*f**3*fd + 264*D1*Dd*f**3*r**2 + 144*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 102*D1*Dd*f**3 - 864*D1*Dd*f**2*fd*r**2 - 864*D1*Dd*f**2*fd*r*s + 972*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s - 252*D1*Dd*f**2*fd + 576*D1*Dd*f**2*g2*r**2 - 672*D1*Dd*f**2*g2*r*s - 408*D1*Dd*f**2*g2*r - 1248*D1*Dd*f**2*g2*s**2 + 960*D1*Dd*f**2*g2*s - 24*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r**2 + 864*D1*Dd*f**2*gd2*r + 576*D1*Dd*f**2*gd2*s**2 - 144*D1*Dd*f**2*gd2*s - 288*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r**2 + 576*D1*Dd*f*fd*g2*r + 1152*D1*Dd*f*fd*g2*s**2 - 864*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 144*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r - 144*D1*Ddd*K*b1*f**2*s**2 + 72*D1*Ddd*K*b1*f**2*s + 36*D1*Ddd*K*b1*f**2 - 360*D1*Ddd*b1*f**3*r**2 - 560*D1*Ddd*b1*f**3*r*s + 500*D1*Ddd*b1*f**3*r - 200*D1*Ddd*b1*f**3*s**2 + 380*D1*Ddd*b1*f**3*s - 230*D1*Ddd*b1*f**3 - 288*D1*Ddd*b1*f**2*r**2 - 432*D1*Ddd*b1*f**2*r*s + 396*D1*Ddd*b1*f**2*r - 144*D1*Ddd*b1*f**2*s**2 + 288*D1*Ddd*b1*f**2*s - 180*D1*Ddd*b1*f**2 + 900*D1*Ddd*f**4*r**2 + 1800*D1*Ddd*f**4*r*s - 1350*D1*Ddd*f**4*r + 900*D1*Ddd*f**4*s**2 - 1350*D1*Ddd*f**4*s + 675*D1*Ddd*f**4 - 144*D1*Ddd*f**3*r**2 - 144*D1*Ddd*f**3*r*s + 180*D1*Ddd*f**3*r + 72*D1*Ddd*f**3*s - 72*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r + 288*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s - 72*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(f**2*(57*r**2 + 2*r*(43*s - 70) + 29*s**2 - 112*s + 107) - f*(10*fd*(27*r**2 + r*(42*s - 45) + 15*s**2 - 35*s + 14) + (3*r + 3*s - 3)*(2*K*(6*r - 13*s - 6) - 17*r + 9*s + 17)) + 18*fd*(r**2*(4*K - 8) + r*(-4*K - 12*s + 11) - (2*s - 1)*(s*(2*K + 2) - 3))) - 2*Dd*f*(-18*K*(4*r**2 - 6*r - 4*s**2 + s + 2) + 5*f*(36*r**2 + r*(56*s - 65) + 20*s**2 - 51*s + 28) + 144*r**2 + 216*r*s - 243*r + 72*s**2 - 180*s + 99)) + 432*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r - 432*Dd**2*K*b1*f**2*s**2 + 216*Dd**2*K*b1*f**2*s + 72*Dd**2*K*b1*f**2 - 1080*Dd**2*b1*f**3*r**2 - 1680*Dd**2*b1*f**3*r*s + 1500*Dd**2*b1*f**3*r - 600*Dd**2*b1*f**3*s**2 + 1140*Dd**2*b1*f**3*s - 460*Dd**2*b1*f**3 - 864*Dd**2*b1*f**2*r**2 - 1296*Dd**2*b1*f**2*r*s + 1188*Dd**2*b1*f**2*r - 432*Dd**2*b1*f**2*s**2 + 864*Dd**2*b1*f**2*s - 360*Dd**2*b1*f**2 + 2700*Dd**2*f**4*r**2 + 5400*Dd**2*f**4*r*s - 4050*Dd**2*f**4*r + 2700*Dd**2*f**4*s**2 - 4050*Dd**2*f**4*s + 1350*Dd**2*f**4 - 432*Dd**2*f**3*r**2 - 432*Dd**2*f**3*r*s + 540*Dd**2*f**3*r + 216*Dd**2*f**3*s - 144*Dd**2*f**3 - 864*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r + 864*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s - 144*Dd**2*f**2*g2)/(105*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct*k1**3*k2*st**2*(-144*C*D1**2*bdd1*f**2*r**2 - 288*C*D1**2*bdd1*f**2*r*s + 432*C*D1**2*bdd1*f**2*r - 144*C*D1**2*bdd1*f**2*s**2 + 432*C*D1**2*bdd1*f**2*s - 216*C*D1**2*bdd1*f**2 + 1572*C*D1**2*f**2*fd*r**2 + 4848*C*D1**2*f**2*fd*r*s - 2664*C*D1**2*f**2*fd*r + 3276*C*D1**2*f**2*fd*s**2 - 3800*C*D1**2*f**2*fd*s + 1616*C*D1**2*f**2*fd - 1812*C*D1**2*f**2*fdd*r**2 - 5448*C*D1**2*f**2*fdd*r*s + 3024*C*D1**2*f**2*fdd*r - 3636*C*D1**2*f**2*fdd*s**2 + 4240*C*D1**2*f**2*fdd*s - 1816*C*D1**2*f**2*fdd - 3624*C*D1**2*f*fd**2*r**2 - 10896*C*D1**2*f*fd**2*r*s + 6048*C*D1**2*f*fd**2*r - 7272*C*D1**2*f*fd**2*s**2 + 8480*C*D1**2*f*fd**2*s - 1816*C*D1**2*f*fd**2 + 2096*C*D1*Dd*f**3*r**2 + 6464*C*D1*Dd*f**3*r*s - 3712*C*D1*Dd*f**3*r + 4368*C*D1*Dd*f**3*s**2 - 5416*C*D1*Dd*f**3*s + 2140*C*D1*Dd*f**3 - 14496*C*D1*Dd*f**2*fd*r**2 - 43584*C*D1*Dd*f**2*fd*r*s + 24792*C*D1*Dd*f**2*fd*r - 29088*C*D1*Dd*f**2*fd*s**2 + 35128*C*D1*Dd*f**2*fd*s - 10288*C*D1*Dd*f**2*fd - 2416*C*D1*Ddd*f**3*r**2 - 7264*C*D1*Ddd*f**3*r*s + 4232*C*D1*Ddd*f**3*r - 4848*C*D1*Ddd*f**3*s**2 + 6056*C*D1*Ddd*f**3*s - 2420*C*D1*Ddd*f**3 - 7248*C*Dd**2*f**3*r**2 - 21792*C*Dd**2*f**3*r*s + 12696*C*Dd**2*f**3*r - 14544*C*Dd**2*f**3*s**2 + 18168*C*Dd**2*f**3*s - 4840*C*Dd**2*f**3 - 534*D1**2*K*bdd1*f**2*r**2 - 1788*D1**2*K*bdd1*f**2*r*s + 1068*D1**2*K*bdd1*f**2*r - 1254*D1**2*K*bdd1*f**2*s**2 + 1788*D1**2*K*bdd1*f**2*s - 534*D1**2*K*bdd1*f**2 + 192*D1**2*b2*f*fd*r**2 + 384*D1**2*b2*f*fd*r*s - 192*D1**2*b2*f*fd*r + 192*D1**2*b2*f*fd*s**2 - 192*D1**2*b2*f*fd*s + 96*D1**2*b2*f*fd - 432*D1**2*b2*f*fdd*r**2 - 864*D1**2*b2*f*fdd*r*s + 432*D1**2*b2*f*fdd*r - 432*D1**2*b2*f*fdd*s**2 + 432*D1**2*b2*f*fdd*s - 216*D1**2*b2*f*fdd - 432*D1**2*b2*fd**2*r**2 - 864*D1**2*b2*fd**2*r*s + 432*D1**2*b2*fd**2*r - 432*D1**2*b2*fd**2*s**2 + 432*D1**2*b2*fd**2*s + 12*D1**2*bd1**2*f*(r + s - 1)*(7*K*(-4*r - 4*s + 6) + 54*f*(r + s - 1) + 77*r + 77*s - 84) + 96*D1**2*bd2*f**2*r**2 + 192*D1**2*bd2*f**2*r*s - 192*D1**2*bd2*f**2*r + 96*D1**2*bd2*f**2*s**2 - 192*D1**2*bd2*f**2*s + 96*D1**2*bd2*f**2 - 864*D1**2*bd2*f*fd*r**2 - 1728*D1**2*bd2*f*fd*r*s + 1296*D1**2*bd2*f*fd*r - 864*D1**2*bd2*f*fd*s**2 + 1296*D1**2*bd2*f*fd*s - 432*D1**2*bd2*f*fd - 432*D1**2*bdd1*f**3*r**2 + 432*D1**2*bdd1*f**3*r + 432*D1**2*bdd1*f**3*s**2 - 432*D1**2*bdd1*f**3*s + 429*D1**2*bdd1*f**2*r**2 + 1218*D1**2*bdd1*f**2*r*s - 966*D1**2*bdd1*f**2*r + 789*D1**2*bdd1*f**2*s**2 - 1326*D1**2*bdd1*f**2*s + 483*D1**2*bdd1*f**2 + 336*D1**2*bdd1*f*g2*r**2 + 672*D1**2*bdd1*f*g2*r*s - 1008*D1**2*bdd1*f*g2*r + 336*D1**2*bdd1*f*g2*s**2 - 1008*D1**2*bdd1*f*g2*s + 504*D1**2*bdd1*f*g2 - 216*D1**2*bdd2*f**2*r**2 - 432*D1**2*bdd2*f**2*r*s + 432*D1**2*bdd2*f**2*r - 216*D1**2*bdd2*f**2*s**2 + 432*D1**2*bdd2*f**2*s - 216*D1**2*bdd2*f**2 - 927*D1**2*f**2*fd*r**2 - 3186*D1**2*f**2*fd*r*s + 1680*D1**2*f**2*fd*r - 2259*D1**2*f**2*fd*s**2 + 2568*D1**2*f**2*fd*s - 1062*D1**2*f**2*fd + 1179*D1**2*f**2*fdd*r**2 + 3726*D1**2*f**2*fdd*r*s - 2028*D1**2*f**2*fdd*r + 2547*D1**2*f**2*fdd*s**2 - 2940*D1**2*f**2*fdd*s + 1242*D1**2*f**2*fdd - 540*D1**2*f**2*gd2*r**2 - 2448*D1**2*f**2*gd2*r*s + 1080*D1**2*f**2*gd2*r - 1908*D1**2*f**2*gd2*s**2 + 2448*D1**2*f**2*gd2*s - 540*D1**2*f**2*gd2 + 1068*D1**2*f**2*gdd2*r**2 + 3576*D1**2*f**2*gdd2*r*s - 2136*D1**2*f**2*gdd2*r + 2508*D1**2*f**2*gdd2*s**2 - 3576*D1**2*f**2*gdd2*s + 1068*D1**2*f**2*gdd2 + 2358*D1**2*f*fd**2*r**2 + 7452*D1**2*f*fd**2*r*s - 4056*D1**2*f*fd**2*r + 5094*D1**2*f*fd**2*s**2 - 5880*D1**2*f*fd**2*s + 1242*D1**2*f*fd**2 - 1080*D1**2*f*fd*g2*r**2 - 4896*D1**2*f*fd*g2*r*s + 2448*D1**2*f*fd*g2*r - 3816*D1**2*f*fd*g2*s**2 + 3816*D1**2*f*fd*g2*s - 1908*D1**2*f*fd*g2 + 4272*D1**2*f*fd*gd2*r**2 + 14304*D1**2*f*fd*gd2*r*s - 7848*D1**2*f*fd*gd2*r + 10032*D1**2*f*fd*gd2*s**2 - 12168*D1**2*f*fd*gd2*s + 3576*D1**2*f*fd*gd2 + 2136*D1**2*f*fdd*g2*r**2 + 7152*D1**2*f*fdd*g2*r*s - 3576*D1**2*f*fdd*g2*r + 5016*D1**2*f*fdd*g2*s**2 - 5016*D1**2*f*fdd*g2*s + 2508*D1**2*f*fdd*g2 + 2136*D1**2*fd**2*g2*r**2 + 7152*D1**2*fd**2*g2*r*s - 3576*D1**2*fd**2*g2*r + 5016*D1**2*fd**2*g2*s**2 - 5016*D1**2*fd**2*g2*s + 384*D1*Dd*b2*f**2*r**2 + 768*D1*Dd*b2*f**2*r*s - 576*D1*Dd*b2*f**2*r + 384*D1*Dd*b2*f**2*s**2 - 576*D1*Dd*b2*f**2*s + 288*D1*Dd*b2*f**2 - 3456*D1*Dd*b2*f*fd*r**2 - 6912*D1*Dd*b2*f*fd*r*s + 4320*D1*Dd*b2*f*fd*r - 3456*D1*Dd*b2*f*fd*s**2 + 4320*D1*Dd*b2*f*fd*s - 1296*D1*Dd*b2*f*fd - 1728*D1*Dd*bd2*f**2*r**2 - 3456*D1*Dd*bd2*f**2*r*s + 3024*D1*Dd*bd2*f**2*r - 1728*D1*Dd*bd2*f**2*s**2 + 3024*D1*Dd*bd2*f**2*s - 1296*D1*Dd*bd2*f**2 - 1236*D1*Dd*f**3*r**2 - 4248*D1*Dd*f**3*r*s + 2298*D1*Dd*f**3*r - 3012*D1*Dd*f**3*s**2 + 3630*D1*Dd*f**3*s - 1371*D1*Dd*f**3 + 9432*D1*Dd*f**2*fd*r**2 + 29808*D1*Dd*f**2*fd*r*s - 16554*D1*Dd*f**2*fd*r + 20376*D1*Dd*f**2*fd*s**2 - 24306*D1*Dd*f**2*fd*s + 6996*D1*Dd*f**2*fd - 2160*D1*Dd*f**2*g2*r**2 - 9792*D1*Dd*f**2*g2*r*s + 4608*D1*Dd*f**2*g2*r - 7632*D1*Dd*f**2*g2*s**2 + 8712*D1*Dd*f**2*g2*s - 2988*D1*Dd*f**2*g2 + 8544*D1*Dd*f**2*gd2*r**2 + 28608*D1*Dd*f**2*gd2*r*s - 16392*D1*Dd*f**2*gd2*r + 20064*D1*Dd*f**2*gd2*s**2 - 26472*D1*Dd*f**2*gd2*s + 7848*D1*Dd*f**2*gd2 + 17088*D1*Dd*f*fd*g2*r**2 + 57216*D1*Dd*f*fd*g2*r*s - 30000*D1*Dd*f*fd*g2*r + 40128*D1*Dd*f*fd*g2*s**2 - 44400*D1*Dd*f*fd*g2*s + 12168*D1*Dd*f*fd*g2 - 864*D1*Ddd*b2*f**2*r**2 - 1728*D1*Ddd*b2*f**2*r*s + 1296*D1*Ddd*b2*f**2*r - 864*D1*Ddd*b2*f**2*s**2 + 1296*D1*Ddd*b2*f**2*s - 648*D1*Ddd*b2*f**2 + 1572*D1*Ddd*f**3*r**2 + 4968*D1*Ddd*f**3*r*s - 2814*D1*Ddd*f**3*r + 3396*D1*Ddd*f**3*s**2 - 4182*D1*Ddd*f**3*s + 1635*D1*Ddd*f**3 + 4272*D1*Ddd*f**2*g2*r**2 + 14304*D1*Ddd*f**2*g2*r*s - 7848*D1*Ddd*f**2*g2*r + 10032*D1*Ddd*f**2*g2*s**2 - 12168*D1*Ddd*f**2*g2*s + 4644*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(18*f**3*(10*r**2 + 4*r*(s - 4) - 6*s**2 + 7) + f**2*(8*C*(19*r**2 + r*(31*s - 29) + 12*s**2 - 22*s + 11) + 90*K*r**2 + 408*K*r*s - 180*K*r + 318*K*s**2 - 408*K*s + 90*K - 144*fd*(6*r**2 - 6*r - 6*s**2 + 4*s + 1) - 209*r**2 - 490*r*s + 350*r - 281*s**2 + 422*s - 147) - 2*f*(fd*(24*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*K*(178*r**2 + 596*r*s - 327*r + 418*s**2 - 507*s + 149) - 286*r**2 - 812*r*s + 507*r - 526*s**2 + 687*s - 221) + 28*g2*(9*r**2 + r*(13*s - 7) + 4*s**2 - 2*s + 1) - 56*gd2*(2*r**2 + r*(4*s - 5) + 2*s**2 - 5*s + 3)) + 224*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(72*f**2*(8*r**2 - 8*r - 8*s**2 + 6*s + 1) + f*(24*C*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + 2*K*(356*r**2 + 1192*r*s - 683*r + 836*s**2 - 1103*s + 327) - 572*r**2 - 1624*r*s + 1133*r - 1052*s**2 + 1553*s - 543) - 56*g2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9))) - 2592*Dd**2*b2*f**2*r**2 - 5184*Dd**2*b2*f**2*r*s + 3888*Dd**2*b2*f**2*r - 2592*Dd**2*b2*f**2*s**2 + 3888*Dd**2*b2*f**2*s - 1296*Dd**2*b2*f**2 + 4716*Dd**2*f**3*r**2 + 14904*Dd**2*f**3*r*s - 8442*Dd**2*f**3*r + 10188*Dd**2*f**3*s**2 - 12546*Dd**2*f**3*s + 3270*Dd**2*f**3 + 12816*Dd**2*f**2*g2*r**2 + 42912*Dd**2*f**2*g2*r*s - 23544*Dd**2*f**2*g2*r + 30096*Dd**2*f**2*g2*s**2 - 36504*Dd**2*f**2*g2*s + 9288*Dd**2*f**2*g2 - 6*b1**2*(D1**2*(-108*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(-14*K*(9*r**2 + 13*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(160*r**2 + r*(320*s - 202) + 160*s**2 - 202*s + 101) + 154*r**2 + 238*r*s - 42*r + 84*s**2 - 42*s + 21) - fdd*(-14*K*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) + 54*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 77*r**2 + 154*r*s + 14*r + 77*s**2 + 14*s - 7)) + D1*(2*Dd*(40*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(7*K*(36*r**2 + 52*r*s - 49*r + 16*s**2 - 34*s + 22) + 54*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 308*r**2 - 476*r*s + 427*r - 168*s**2 + 322*s - 196) + 7*fd*(4*r + 4*s - 3)*(K*(4*r + 4*s + 2) - 11*r - 11*s - 1)) - Ddd*f*(-28*K + 54*f + 77)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-28*K + 54*f + 77)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(-304*C*D1**2*f*fd*r**2 - 496*C*D1**2*f*fd*r*s + 320*C*D1**2*f*fd*r - 192*C*D1**2*f*fd*s**2 + 264*C*D1**2*f*fd*s - 160*C*D1**2*f*fd + 96*C*D1**2*f*fdd*r**2 + 192*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 96*C*D1**2*f*fdd*s**2 - 48*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 96*C*D1**2*fd**2*r**2 + 192*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 96*C*D1**2*fd**2*s**2 - 48*C*D1**2*fd**2*s - 48*C*D1**2*fd**2 - 608*C*D1*Dd*f**2*r**2 - 992*C*D1*Dd*f**2*r*s + 856*C*D1*Dd*f**2*r - 384*C*D1*Dd*f**2*s**2 + 688*C*D1*Dd*f**2*s - 400*C*D1*Dd*f**2 + 768*C*D1*Dd*f*fd*r**2 + 1536*C*D1*Dd*f*fd*r*s - 768*C*D1*Dd*f*fd*r + 768*C*D1*Dd*f*fd*s**2 - 768*C*D1*Dd*f*fd*s + 144*C*D1*Dd*f*fd + 192*C*D1*Ddd*f**2*r**2 + 384*C*D1*Ddd*f**2*r*s - 288*C*D1*Ddd*f**2*r + 192*C*D1*Ddd*f**2*s**2 - 288*C*D1*Ddd*f**2*s + 144*C*D1*Ddd*f**2 + 576*C*Dd**2*f**2*r**2 + 1152*C*Dd**2*f**2*r*s - 864*C*Dd**2*f**2*r + 576*C*Dd**2*f**2*s**2 - 864*C*Dd**2*f**2*s + 288*C*Dd**2*f**2 - 180*D1**2*K*f*fd*r**2 - 816*D1**2*K*f*fd*r*s + 408*D1**2*K*f*fd*r - 636*D1**2*K*f*fd*s**2 + 636*D1**2*K*f*fd*s - 318*D1**2*K*f*fd + 356*D1**2*K*f*fdd*r**2 + 1192*D1**2*K*f*fdd*r*s - 596*D1**2*K*f*fdd*r + 836*D1**2*K*f*fdd*s**2 - 836*D1**2*K*f*fdd*s + 418*D1**2*K*f*fdd + 356*D1**2*K*fd**2*r**2 + 1192*D1**2*K*fd**2*r*s - 596*D1**2*K*fd**2*r + 836*D1**2*K*fd**2*s**2 - 836*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-14*K*(4*r**2 + 8*r*s - 10*r + 4*s**2 - 10*s + 5) + 108*f*(r + s - 1)**2 + 154*r**2 + 308*r*s - 322*r + 154*s**2 - 322*s + 161) - 540*D1**2*f**2*fd*r**2 - 216*D1**2*f**2*fd*r*s + 504*D1**2*f**2*fd*r + 324*D1**2*f**2*fd*s**2 - 72*D1**2*f**2*fd*s - 126*D1**2*f**2*fd + 432*D1**2*f**2*fdd*r**2 - 432*D1**2*f**2*fdd*r - 432*D1**2*f**2*fdd*s**2 + 144*D1**2*f**2*fdd*s + 144*D1**2*f**2*fdd + 864*D1**2*f*fd**2*r**2 - 864*D1**2*f*fd**2*r - 864*D1**2*f*fd**2*s**2 + 288*D1**2*f*fd**2*s + 144*D1**2*f*fd**2 + 418*D1**2*f*fd*r**2 + 980*D1**2*f*fd*r*s - 558*D1**2*f*fd*r + 562*D1**2*f*fd*s**2 - 630*D1**2*f*fd*s + 343*D1**2*f*fd - 286*D1**2*f*fdd*r**2 - 812*D1**2*f*fdd*r*s + 370*D1**2*f*fdd*r - 526*D1**2*f*fdd*s**2 + 490*D1**2*f*fdd*s - 245*D1**2*f*fdd + 504*D1**2*f*gd2*r**2 + 728*D1**2*f*gd2*r*s - 1008*D1**2*f*gd2*r + 224*D1**2*f*gd2*s**2 - 728*D1**2*f*gd2*s + 504*D1**2*f*gd2 - 112*D1**2*f*gdd2*r**2 - 224*D1**2*f*gdd2*r*s + 224*D1**2*f*gdd2*r - 112*D1**2*f*gdd2*s**2 + 224*D1**2*f*gdd2*s - 112*D1**2*f*gdd2 - 286*D1**2*fd**2*r**2 - 812*D1**2*fd**2*r*s + 370*D1**2*fd**2*r - 526*D1**2*fd**2*s**2 + 490*D1**2*fd**2*s + 36*D1**2*fd**2 + 504*D1**2*fd*g2*r**2 + 728*D1**2*fd*g2*r*s - 336*D1**2*fd*g2*r + 224*D1**2*fd*g2*s**2 - 336*D1**2*fd*g2*s + 168*D1**2*fd*g2 - 224*D1**2*fd*gd2*r**2 - 448*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 224*D1**2*fd*gd2*s**2 + 112*D1**2*fd*gd2*s + 112*D1**2*fd*gd2 - 112*D1**2*fdd*g2*r**2 - 224*D1**2*fdd*g2*r*s - 112*D1**2*fdd*g2*r - 112*D1**2*fdd*g2*s**2 - 112*D1**2*fdd*g2*s + 56*D1**2*fdd*g2 - 360*D1*Dd*K*f**2*r**2 - 1632*D1*Dd*K*f**2*r*s + 768*D1*Dd*K*f**2*r - 1272*D1*Dd*K*f**2*s**2 + 1452*D1*Dd*K*f**2*s - 498*D1*Dd*K*f**2 + 2848*D1*Dd*K*f*fd*r**2 + 9536*D1*Dd*K*f*fd*r*s - 5000*D1*Dd*K*f*fd*r + 6688*D1*Dd*K*f*fd*s**2 - 7400*D1*Dd*K*f*fd*s + 2028*D1*Dd*K*f*fd - 720*D1*Dd*f**3*r**2 - 288*D1*Dd*f**3*r*s + 792*D1*Dd*f**3*r + 432*D1*Dd*f**3*s**2 - 72*D1*Dd*f**3*s - 252*D1*Dd*f**3 + 3456*D1*Dd*f**2*fd*r**2 - 3456*D1*Dd*f**2*fd*r - 3456*D1*Dd*f**2*fd*s**2 + 1440*D1*Dd*f**2*fd*s + 720*D1*Dd*f**2*fd + 836*D1*Dd*f**2*r**2 + 1960*D1*Dd*f**2*r*s - 1326*D1*Dd*f**2*r + 1124*D1*Dd*f**2*s**2 - 1542*D1*Dd*f**2*s + 699*D1*Dd*f**2 - 2288*D1*Dd*f*fd*r**2 - 6496*D1*Dd*f*fd*r*s + 3436*D1*Dd*f*fd*r - 4208*D1*Dd*f*fd*s**2 + 4636*D1*Dd*f*fd*s - 1230*D1*Dd*f*fd + 2016*D1*Dd*f*g2*r**2 + 2912*D1*Dd*f*g2*r*s - 2744*D1*Dd*f*g2*r + 896*D1*Dd*f*g2*s**2 - 1904*D1*Dd*f*g2*s + 1232*D1*Dd*f*g2 - 896*D1*Dd*f*gd2*r**2 - 1792*D1*Dd*f*gd2*r*s + 1568*D1*Dd*f*gd2*r - 896*D1*Dd*f*gd2*s**2 + 1568*D1*Dd*f*gd2*s - 672*D1*Dd*f*gd2 - 896*D1*Dd*fd*g2*r**2 - 1792*D1*Dd*fd*g2*r*s + 224*D1*Dd*fd*g2*r - 896*D1*Dd*fd*g2*s**2 + 224*D1*Dd*fd*g2*s + 336*D1*Dd*fd*g2 + 712*D1*Ddd*K*f**2*r**2 + 2384*D1*Ddd*K*f**2*r*s - 1308*D1*Ddd*K*f**2*r + 1672*D1*Ddd*K*f**2*s**2 - 2028*D1*Ddd*K*f**2*s + 774*D1*Ddd*K*f**2 + 576*D1*Ddd*f**3*r**2 - 576*D1*Ddd*f**3*r - 576*D1*Ddd*f**3*s**2 + 288*D1*Ddd*f**3*s + 144*D1*Ddd*f**3 - 572*D1*Ddd*f**2*r**2 - 1624*D1*Ddd*f**2*r*s + 978*D1*Ddd*f**2*r - 1052*D1*Ddd*f**2*s**2 + 1338*D1*Ddd*f**2*s - 549*D1*Ddd*f**2 - 448*D1*Ddd*f*g2*r**2 - 896*D1*Ddd*f*g2*r*s + 672*D1*Ddd*f*g2*r - 448*D1*Ddd*f*g2*s**2 + 672*D1*Ddd*f*g2*s - 336*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*(160*r**2 + r*(320*s - 278) + 160*s**2 - 278*s + 139) - f*(14*K*(18*r**2 + 26*r*s - 25*r + 8*s**2 - 15*s + 10) + 216*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 308*r**2 - 476*r*s + 504*r - 168*s**2 + 364*s - 217) + 14*fd*(r + s - 1)*(K*(8*r + 8*s + 2) - 22*r - 22*s - 1)) - 2*Dd*f*(4*r + 4*s - 3)*(-14*K*(4*r + 4*s - 5) + 108*f*(r + s - 1) + 154*r + 154*s - 161)) + 2136*Dd**2*K*f**2*r**2 + 7152*Dd**2*K*f**2*r*s - 3924*Dd**2*K*f**2*r + 5016*Dd**2*K*f**2*s**2 - 6084*Dd**2*K*f**2*s + 1548*Dd**2*K*f**2 + 1728*Dd**2*f**3*r**2 - 1728*Dd**2*f**3*r - 1728*Dd**2*f**3*s**2 + 864*Dd**2*f**3*s + 288*Dd**2*f**3 - 1716*Dd**2*f**2*r**2 - 4872*Dd**2*f**2*r*s + 2934*Dd**2*f**2*r - 3156*Dd**2*f**2*s**2 + 4014*Dd**2*f**2*s - 1098*Dd**2*f**2 - 1344*Dd**2*f*g2*r**2 - 2688*Dd**2*f*g2*r*s + 2016*Dd**2*f*g2*r - 1344*Dd**2*f*g2*s**2 + 2016*Dd**2*f*g2*s - 672*Dd**2*f*g2))/(315*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct*k1**3*k2*(336*C*D1**2*bd1**2*f*r**2 + 672*C*D1**2*bd1**2*f*r*s - 336*C*D1**2*bd1**2*f*r + 336*C*D1**2*bd1**2*f*s**2 - 336*C*D1**2*bd1**2*f*s + 492*C*D1**2*bd1*f**2*r**2 + 1176*C*D1**2*bd1*f**2*r*s - 1176*C*D1**2*bd1*f**2*r + 684*C*D1**2*bd1*f**2*s**2 - 1368*C*D1**2*bd1*f**2*s + 684*C*D1**2*bd1*f**2 - 3504*C*D1**2*bd1*f*fd*r**2 - 8064*C*D1**2*bd1*f*fd*r*s + 5784*C*D1**2*bd1*f*fd*r - 4560*C*D1**2*bd1*f*fd*s**2 + 6576*C*D1**2*bd1*f*fd*s - 2016*C*D1**2*bd1*f*fd - 876*C*D1**2*bdd1*f**2*r**2 - 2016*C*D1**2*bdd1*f**2*r*s + 2016*C*D1**2*bdd1*f**2*r - 1140*C*D1**2*bdd1*f**2*s**2 + 2280*C*D1**2*bdd1*f**2*s - 1140*C*D1**2*bdd1*f**2 + 360*C*D1**2*f**2*fd*r*s - 120*C*D1**2*f**2*fd*r + 360*C*D1**2*f**2*fd*s**2 - 360*C*D1**2*f**2*fd*s + 120*C*D1**2*f**2*fd - 360*C*D1**2*f**2*fdd*r*s + 120*C*D1**2*f**2*fdd*r - 360*C*D1**2*f**2*fdd*s**2 + 360*C*D1**2*f**2*fdd*s - 120*C*D1**2*f**2*fdd - 720*C*D1**2*f*fd**2*r*s + 240*C*D1**2*f*fd**2*r - 720*C*D1**2*f*fd**2*s**2 + 720*C*D1**2*f*fd**2*s - 120*C*D1**2*f*fd**2 - 7008*C*D1*Dd*bd1*f**2*r**2 - 16128*C*D1*Dd*bd1*f**2*r*s + 13584*C*D1*Dd*bd1*f**2*r - 9120*C*D1*Dd*bd1*f**2*s**2 + 15432*C*D1*Dd*bd1*f**2*s - 6312*C*D1*Dd*bd1*f**2 + 480*C*D1*Dd*f**3*r*s - 120*C*D1*Dd*f**3*r + 480*C*D1*Dd*f**3*s**2 - 480*C*D1*Dd*f**3*s + 120*C*D1*Dd*f**3 - 2880*C*D1*Dd*f**2*fd*r*s + 840*C*D1*Dd*f**2*fd*r - 2880*C*D1*Dd*f**2*fd*s**2 + 2880*C*D1*Dd*f**2*fd*s - 600*C*D1*Dd*f**2*fd - 480*C*D1*Ddd*f**3*r*s + 120*C*D1*Ddd*f**3*r - 480*C*D1*Ddd*f**3*s**2 + 480*C*D1*Ddd*f**3*s - 120*C*D1*Ddd*f**3 - 1440*C*Dd**2*f**3*r*s + 360*C*Dd**2*f**3*r - 1440*C*Dd**2*f**3*s**2 + 1440*C*Dd**2*f**3*s - 240*C*Dd**2*f**3 - 1204*D1**2*K*bd1**2*f*r**2 - 2912*D1**2*K*bd1**2*f*r*s + 2660*D1**2*K*bd1**2*f*r - 1708*D1**2*K*bd1**2*f*s**2 + 3164*D1**2*K*bd1**2*f*s - 1456*D1**2*K*bd1**2*f + 84*D1**2*K*bd1*f**2*r*s + 84*D1**2*K*bd1*f**2*s**2 - 84*D1**2*K*bd1*f**2*s - 336*D1**2*K*bd1*f*fd*r*s + 84*D1**2*K*bd1*f*fd*r - 336*D1**2*K*bd1*f*fd*s**2 + 336*D1**2*K*bd1*f*fd*s - 84*D1**2*K*bd1*f*fd - 84*D1**2*K*bdd1*f**2*r*s - 84*D1**2*K*bdd1*f**2*s**2 + 84*D1**2*K*bdd1*f**2*s + 1218*D1**2*bd1**2*f**2*r**2 + 2100*D1**2*bd1**2*f**2*r*s - 2268*D1**2*bd1**2*f**2*r + 882*D1**2*bd1**2*f**2*s**2 - 1932*D1**2*bd1**2*f**2*s + 1050*D1**2*bd1**2*f**2 + 182*D1**2*bd1**2*f*r**2 + 532*D1**2*bd1**2*f*r*s - 700*D1**2*bd1**2*f*r + 350*D1**2*bd1**2*f*s**2 - 868*D1**2*bd1**2*f*s + 518*D1**2*bd1**2*f - 560*D1**2*bd1**2*g2*r**2 - 1120*D1**2*bd1**2*g2*r*s + 560*D1**2*bd1**2*g2*r - 560*D1**2*bd1**2*g2*s**2 + 560*D1**2*bd1**2*g2*s - 336*D1**2*bd1*bd2*f*r**2 - 672*D1**2*bd1*bd2*f*r*s + 672*D1**2*bd1*bd2*f*r - 336*D1**2*bd1*bd2*f*s**2 + 672*D1**2*bd1*bd2*f*s - 336*D1**2*bd1*bd2*f - 249*D1**2*bd1*f**2*r**2 - 666*D1**2*bd1*f**2*r*s + 666*D1**2*bd1*f**2*r - 417*D1**2*bd1*f**2*s**2 + 834*D1**2*bd1*f**2*s - 417*D1**2*bd1*f**2 + 2388*D1**2*bd1*f*fd*r**2 + 5448*D1**2*bd1*f*fd*r*s - 3918*D1**2*bd1*f*fd*r + 3060*D1**2*bd1*f*fd*s**2 - 4422*D1**2*bd1*f*fd*s + 1362*D1**2*bd1*f*fd - 308*D1**2*bd1*f*g2*r**2 - 1064*D1**2*bd1*f*g2*r*s + 1064*D1**2*bd1*f*g2*r - 756*D1**2*bd1*f*g2*s**2 + 1512*D1**2*bd1*f*g2*s - 756*D1**2*bd1*f*g2 + 2408*D1**2*bd1*f*gd2*r**2 + 5824*D1**2*bd1*f*gd2*r*s - 5320*D1**2*bd1*f*gd2*r + 3416*D1**2*bd1*f*gd2*s**2 - 6328*D1**2*bd1*f*gd2*s + 2912*D1**2*bd1*f*gd2 + 2408*D1**2*bd1*fd*g2*r**2 + 5824*D1**2*bd1*fd*g2*r*s - 2912*D1**2*bd1*fd*g2*r + 3416*D1**2*bd1*fd*g2*s**2 - 3416*D1**2*bd1*fd*g2*s + 597*D1**2*bdd1*f**2*r**2 + 1362*D1**2*bdd1*f**2*r*s - 1362*D1**2*bdd1*f**2*r + 765*D1**2*bdd1*f**2*s**2 - 1530*D1**2*bdd1*f**2*s + 765*D1**2*bdd1*f**2 + 1204*D1**2*bdd1*f*g2*r**2 + 2912*D1**2*bdd1*f*g2*r*s - 2912*D1**2*bdd1*f*g2*r + 1708*D1**2*bdd1*f*g2*s**2 - 3416*D1**2*bdd1*f*g2*s + 1708*D1**2*bdd1*f*g2 - 180*D1**2*f**2*fd*r*s + 60*D1**2*f**2*fd*r - 180*D1**2*f**2*fd*s**2 + 180*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 180*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 180*D1**2*f**2*fdd*s**2 - 180*D1**2*f**2*fdd*s + 60*D1**2*f**2*fdd - 168*D1**2*f**2*gd2*r*s - 168*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s + 168*D1**2*f**2*gdd2*r*s + 168*D1**2*f**2*gdd2*s**2 - 168*D1**2*f**2*gdd2*s + 360*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 360*D1**2*f*fd**2*s**2 - 360*D1**2*f*fd**2*s + 60*D1**2*f*fd**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r - 336*D1**2*f*fd*g2*s**2 + 336*D1**2*f*fd*g2*s - 168*D1**2*f*fd*g2 + 672*D1**2*f*fd*gd2*r*s - 168*D1**2*f*fd*gd2*r + 672*D1**2*f*fd*gd2*s**2 - 672*D1**2*f*fd*gd2*s + 168*D1**2*f*fd*gd2 + 336*D1**2*f*fdd*g2*r*s - 168*D1**2*f*fdd*g2*r + 336*D1**2*f*fdd*g2*s**2 - 336*D1**2*f*fdd*g2*s + 168*D1**2*f*fdd*g2 + 336*D1**2*fd**2*g2*r*s - 168*D1**2*fd**2*g2*r + 336*D1**2*fd**2*g2*s**2 - 336*D1**2*fd**2*g2*s - 672*D1*Dd*K*bd1*f**2*r*s + 84*D1*Dd*K*bd1*f**2*r - 672*D1*Dd*K*bd1*f**2*s**2 + 672*D1*Dd*K*bd1*f**2*s - 84*D1*Dd*K*bd1*f**2 + 4776*D1*Dd*bd1*f**2*r**2 + 10896*D1*Dd*bd1*f**2*r*s - 9198*D1*Dd*bd1*f**2*r + 6120*D1*Dd*bd1*f**2*s**2 - 10374*D1*Dd*bd1*f**2*s + 4254*D1*Dd*bd1*f**2 + 9632*D1*Dd*bd1*f*g2*r**2 + 23296*D1*Dd*bd1*f*g2*r*s - 19376*D1*Dd*bd1*f*g2*r + 13664*D1*Dd*bd1*f*g2*s**2 - 22904*D1*Dd*bd1*f*g2*s + 9240*D1*Dd*bd1*f*g2 - 240*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 240*D1*Dd*f**3*s**2 + 240*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 1440*D1*Dd*f**2*fd*r*s - 420*D1*Dd*f**2*fd*r + 1440*D1*Dd*f**2*fd*s**2 - 1440*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd - 672*D1*Dd*f**2*g2*r*s + 168*D1*Dd*f**2*g2*r - 672*D1*Dd*f**2*g2*s**2 + 672*D1*Dd*f**2*g2*s - 168*D1*Dd*f**2*g2 + 1344*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 1344*D1*Dd*f**2*gd2*s**2 - 1344*D1*Dd*f**2*gd2*s + 168*D1*Dd*f**2*gd2 + 2688*D1*Dd*f*fd*g2*r*s - 1008*D1*Dd*f*fd*g2*r + 2688*D1*Dd*f*fd*g2*s**2 - 2688*D1*Dd*f*fd*g2*s + 672*D1*Dd*f*fd*g2 + 240*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 240*D1*Ddd*f**3*s**2 - 240*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 672*D1*Ddd*f**2*g2*r*s - 168*D1*Ddd*f**2*g2*r + 672*D1*Ddd*f**2*g2*s**2 - 672*D1*Ddd*f**2*g2*s + 168*D1*Ddd*f**2*g2 + 56*D1*b2*(-3*D1*bdd1*f*(r + s - 1) + bd1*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + 720*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 720*Dd**2*f**3*s**2 - 720*Dd**2*f**3*s + 120*Dd**2*f**3 + 2016*Dd**2*f**2*g2*r*s - 504*Dd**2*f**2*g2*r + 2016*Dd**2*f**2*g2*s**2 - 2016*Dd**2*f**2*g2*s + 336*Dd**2*f**2*g2 + 14*b1**3*(3*D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 9*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 9*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-8*C*D1**2*fd*r**2 - 16*C*D1**2*fd*r*s + 16*C*D1**2*fd*r - 8*C*D1**2*fd*s**2 + 16*C*D1**2*fd*s - 8*C*D1**2*fd + 24*C*D1**2*fdd*r**2 + 48*C*D1**2*fdd*r*s - 48*C*D1**2*fdd*r + 24*C*D1**2*fdd*s**2 - 48*C*D1**2*fdd*s + 24*C*D1**2*fdd - 32*C*D1*Dd*f*r**2 - 64*C*D1*Dd*f*r*s + 48*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 + 48*C*D1*Dd*f*s - 24*C*D1*Dd*f + 192*C*D1*Dd*fd*r**2 + 384*C*D1*Dd*fd*r*s - 336*C*D1*Dd*fd*r + 192*C*D1*Dd*fd*s**2 - 336*C*D1*Dd*fd*s + 144*C*D1*Dd*fd + 96*C*D1*Ddd*f*r**2 + 192*C*D1*Ddd*f*r*s - 144*C*D1*Ddd*f*r + 96*C*D1*Ddd*f*s**2 - 144*C*D1*Ddd*f*s + 72*C*D1*Ddd*f + 288*C*Dd**2*f*r**2 + 576*C*Dd**2*f*r*s - 432*C*Dd**2*f*r + 288*C*Dd**2*f*s**2 - 432*C*Dd**2*f*s + 144*C*Dd**2*f + 22*D1**2*K*fd*r**2 + 76*D1**2*K*fd*r*s + 54*D1**2*K*fd*s**2 - 86*D1**2*K*fdd*r**2 - 208*D1**2*K*fdd*r*s - 122*D1**2*K*fdd*s**2 - 2*D1**2*bdd1*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 114*D1**2*f*fd*r**2 - 180*D1**2*f*fd*r*s + 102*D1**2*f*fd*r - 66*D1**2*f*fd*s**2 + 78*D1**2*f*fd*s - 51*D1**2*f*fd + 174*D1**2*f*fdd*r**2 + 300*D1**2*f*fdd*r*s - 174*D1**2*f*fdd*r + 126*D1**2*f*fdd*s**2 - 150*D1**2*f*fdd*s + 87*D1**2*f*fdd + 174*D1**2*fd**2*r**2 + 300*D1**2*fd**2*r*s - 174*D1**2*fd**2*r + 126*D1**2*fd**2*s**2 - 150*D1**2*fd**2*s + 19*D1**2*fd*r**2 + 14*D1**2*fd*r*s - 12*D1**2*fd*r - 5*D1**2*fd*s**2 - 12*D1**2*fd*s + 6*D1**2*fd + 13*D1**2*fdd*r**2 + 38*D1**2*fdd*r*s + 36*D1**2*fdd*r + 25*D1**2*fdd*s**2 + 36*D1**2*fdd*s - 18*D1**2*fdd - 40*D1**2*gd2*r**2 - 80*D1**2*gd2*r*s + 80*D1**2*gd2*r - 40*D1**2*gd2*s**2 + 80*D1**2*gd2*s - 40*D1**2*gd2 - 40*D1**2*gdd2*r**2 - 80*D1**2*gdd2*r*s + 80*D1**2*gdd2*r - 40*D1**2*gdd2*s**2 + 80*D1**2*gdd2*s - 40*D1**2*gdd2 + 88*D1*Dd*K*f*r**2 + 304*D1*Dd*K*f*r*s - 164*D1*Dd*K*f*r + 216*D1*Dd*K*f*s**2 - 260*D1*Dd*K*f*s + 98*D1*Dd*K*f - 688*D1*Dd*K*fd*r**2 - 1664*D1*Dd*K*fd*r*s + 552*D1*Dd*K*fd*r - 976*D1*Dd*K*fd*s**2 + 660*D1*Dd*K*fd*s - 228*D1*Dd*f**2*r**2 - 360*D1*Dd*f**2*r*s + 318*D1*Dd*f**2*r - 132*D1*Dd*f**2*s**2 + 246*D1*Dd*f**2*s - 147*D1*Dd*f**2 + 1392*D1*Dd*f*fd*r**2 + 2400*D1*Dd*f*fd*r*s - 1692*D1*Dd*f*fd*r + 1008*D1*Dd*f*fd*s**2 - 1452*D1*Dd*f*fd*s + 498*D1*Dd*f*fd + 76*D1*Dd*f*r**2 + 56*D1*Dd*f*r*s - 90*D1*Dd*f*r - 20*D1*Dd*f*s**2 - 18*D1*Dd*f*s + 33*D1*Dd*f + 104*D1*Dd*fd*r**2 + 304*D1*Dd*fd*r*s + 54*D1*Dd*fd*r + 200*D1*Dd*fd*s**2 + 18*D1*Dd*fd*s - 108*D1*Dd*fd - 160*D1*Dd*g2*r**2 - 320*D1*Dd*g2*r*s + 240*D1*Dd*g2*r - 160*D1*Dd*g2*s**2 + 240*D1*Dd*g2*s - 120*D1*Dd*g2 - 320*D1*Dd*gd2*r**2 - 640*D1*Dd*gd2*r*s + 560*D1*Dd*gd2*r - 320*D1*Dd*gd2*s**2 + 560*D1*Dd*gd2*s - 240*D1*Dd*gd2 - 344*D1*Ddd*K*f*r**2 - 832*D1*Ddd*K*f*r*s + 552*D1*Ddd*K*f*r - 488*D1*Ddd*K*f*s**2 + 660*D1*Ddd*K*f*s - 294*D1*Ddd*K*f + 348*D1*Ddd*f**2*r**2 + 600*D1*Ddd*f**2*r*s - 498*D1*Ddd*f**2*r + 252*D1*Ddd*f**2*s**2 - 426*D1*Ddd*f**2*s + 237*D1*Ddd*f**2 + 52*D1*Ddd*f*r**2 + 152*D1*Ddd*f*r*s - 90*D1*Ddd*f*r + 100*D1*Ddd*f*s**2 - 126*D1*Ddd*f*s + 51*D1*Ddd*f - 160*D1*Ddd*g2*r**2 - 320*D1*Ddd*g2*r*s + 240*D1*Ddd*g2*r - 160*D1*Ddd*g2*s**2 + 240*D1*Ddd*g2*s - 120*D1*Ddd*g2 + 2*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-10*K + 9*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 1032*Dd**2*K*f*r**2 - 2496*Dd**2*K*f*r*s + 1656*Dd**2*K*f*r - 1464*Dd**2*K*f*s**2 + 1980*Dd**2*K*f*s - 588*Dd**2*K*f + 1044*Dd**2*f**2*r**2 + 1800*Dd**2*f**2*r*s - 1494*Dd**2*f**2*r + 756*Dd**2*f**2*s**2 - 1278*Dd**2*f**2*s + 474*Dd**2*f**2 + 156*Dd**2*f*r**2 + 456*Dd**2*f*r*s - 270*Dd**2*f*r + 300*Dd**2*f*s**2 - 378*Dd**2*f*s + 102*Dd**2*f - 480*Dd**2*g2*r**2 - 960*Dd**2*g2*r*s + 720*Dd**2*g2*r - 480*Dd**2*g2*s**2 + 720*Dd**2*g2*s - 240*Dd**2*g2) + b1*(336*C*D1**2*bdd1*f*r**2 + 672*C*D1**2*bdd1*f*r*s - 336*C*D1**2*bdd1*f*r + 336*C*D1**2*bdd1*f*s**2 - 336*C*D1**2*bdd1*f*s + 168*C*D1**2*bdd1*f + 984*C*D1**2*f*fd*r**2 + 2352*C*D1**2*f*fd*r*s - 984*C*D1**2*f*fd*r + 1368*C*D1**2*f*fd*s**2 - 1176*C*D1**2*f*fd*s + 492*C*D1**2*f*fd - 1752*C*D1**2*f*fdd*r**2 - 4032*C*D1**2*f*fdd*r*s + 1752*C*D1**2*f*fdd*r - 2280*C*D1**2*f*fdd*s**2 + 2016*C*D1**2*f*fdd*s - 876*C*D1**2*f*fdd - 1752*C*D1**2*fd**2*r**2 - 4032*C*D1**2*fd**2*r*s + 1752*C*D1**2*fd**2*r - 2280*C*D1**2*fd**2*s**2 + 2016*C*D1**2*fd**2*s + 1968*C*D1*Dd*f**2*r**2 + 4704*C*D1*Dd*f**2*r*s - 3144*C*D1*Dd*f**2*r + 2736*C*D1*Dd*f**2*s**2 - 3720*C*D1*Dd*f**2*s + 1668*C*D1*Dd*f**2 - 14016*C*D1*Dd*f*fd*r**2 - 32256*C*D1*Dd*f*fd*r*s + 18048*C*D1*Dd*f*fd*r - 18240*C*D1*Dd*f*fd*s**2 + 20688*C*D1*Dd*f*fd*s - 5520*C*D1*Dd*f*fd - 3504*C*D1*Ddd*f**2*r**2 - 8064*C*D1*Ddd*f**2*r*s + 5520*C*D1*Ddd*f**2*r - 4560*C*D1*Ddd*f**2*s**2 + 6312*C*D1*Ddd*f**2*s - 2892*C*D1*Ddd*f**2 - 10512*C*Dd**2*f**2*r**2 - 24192*C*Dd**2*f**2*r*s + 16560*C*Dd**2*f**2*r - 13680*C*Dd**2*f**2*s**2 + 18936*C*Dd**2*f**2*s - 5784*C*Dd**2*f**2 - 1204*D1**2*K*bdd1*f*r**2 - 2912*D1**2*K*bdd1*f*r*s + 2660*D1**2*K*bdd1*f*r - 1708*D1**2*K*bdd1*f*s**2 + 3164*D1**2*K*bdd1*f*s - 1456*D1**2*K*bdd1*f + 168*D1**2*K*f*fd*r*s - 84*D1**2*K*f*fd*r + 168*D1**2*K*f*fd*s**2 - 168*D1**2*K*f*fd*s + 84*D1**2*K*f*fd - 168*D1**2*K*f*fdd*r*s + 84*D1**2*K*f*fdd*r - 168*D1**2*K*f*fdd*s**2 + 168*D1**2*K*f*fdd*s - 84*D1**2*K*f*fdd - 168*D1**2*K*fd**2*r*s + 84*D1**2*K*fd**2*r - 168*D1**2*K*fd**2*s**2 + 168*D1**2*K*fd**2*s + 56*D1**2*b2*fd*r**2 + 112*D1**2*b2*fd*r*s + 56*D1**2*b2*fd*s**2 - 168*D1**2*b2*fdd*r**2 - 336*D1**2*b2*fdd*r*s - 168*D1**2*b2*fdd*s**2 - 28*D1**2*bd1**2*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 1218*D1**2*bdd1*f**2*r**2 + 2100*D1**2*bdd1*f**2*r*s - 2268*D1**2*bdd1*f**2*r + 882*D1**2*bdd1*f**2*s**2 - 1932*D1**2*bdd1*f**2*s + 1050*D1**2*bdd1*f**2 + 182*D1**2*bdd1*f*r**2 + 532*D1**2*bdd1*f*r*s - 700*D1**2*bdd1*f*r + 350*D1**2*bdd1*f*s**2 - 868*D1**2*bdd1*f*s + 392*D1**2*bdd1*f - 560*D1**2*bdd1*g2*r**2 - 1120*D1**2*bdd1*g2*r*s + 560*D1**2*bdd1*g2*r - 560*D1**2*bdd1*g2*s**2 + 560*D1**2*bdd1*g2*s - 280*D1**2*bdd1*g2 - 168*D1**2*bdd2*f*r**2 - 336*D1**2*bdd2*f*r*s + 336*D1**2*bdd2*f*r - 168*D1**2*bdd2*f*s**2 + 336*D1**2*bdd2*f*s - 168*D1**2*bdd2*f - 498*D1**2*f*fd*r**2 - 1332*D1**2*f*fd*r*s + 498*D1**2*f*fd*r - 834*D1**2*f*fd*s**2 + 666*D1**2*f*fd*s - 249*D1**2*f*fd + 1194*D1**2*f*fdd*r**2 + 2724*D1**2*f*fdd*r*s - 1194*D1**2*f*fdd*r + 1530*D1**2*f*fdd*s**2 - 1362*D1**2*f*fdd*s + 597*D1**2*f*fdd - 308*D1**2*f*gd2*r**2 - 1064*D1**2*f*gd2*r*s + 616*D1**2*f*gd2*r - 756*D1**2*f*gd2*s**2 + 1064*D1**2*f*gd2*s - 308*D1**2*f*gd2 + 1204*D1**2*f*gdd2*r**2 + 2912*D1**2*f*gdd2*r*s - 2408*D1**2*f*gdd2*r + 1708*D1**2*f*gdd2*s**2 - 2912*D1**2*f*gdd2*s + 1204*D1**2*f*gdd2 + 1194*D1**2*fd**2*r**2 + 2724*D1**2*fd**2*r*s - 1194*D1**2*fd**2*r + 1530*D1**2*fd**2*s**2 - 1362*D1**2*fd**2*s - 308*D1**2*fd*g2*r**2 - 1064*D1**2*fd*g2*r*s - 756*D1**2*fd*g2*s**2 + 2408*D1**2*fd*gd2*r**2 + 5824*D1**2*fd*gd2*r*s - 2408*D1**2*fd*gd2*r + 3416*D1**2*fd*gd2*s**2 - 2912*D1**2*fd*gd2*s + 1204*D1**2*fdd*g2*r**2 + 2912*D1**2*fdd*g2*r*s + 1708*D1**2*fdd*g2*s**2 + 336*D1*Dd*K*f**2*r*s - 84*D1*Dd*K*f**2*r + 336*D1*Dd*K*f**2*s**2 - 336*D1*Dd*K*f**2*s + 84*D1*Dd*K*f**2 - 1344*D1*Dd*K*f*fd*r*s + 504*D1*Dd*K*f*fd*r - 1344*D1*Dd*K*f*fd*s**2 + 1344*D1*Dd*K*f*fd*s - 336*D1*Dd*K*f*fd + 224*D1*Dd*b2*f*r**2 + 448*D1*Dd*b2*f*r*s - 336*D1*Dd*b2*f*r + 224*D1*Dd*b2*f*s**2 - 336*D1*Dd*b2*f*s + 168*D1*Dd*b2*f - 1344*D1*Dd*b2*fd*r**2 - 2688*D1*Dd*b2*fd*r*s + 1008*D1*Dd*b2*fd*r - 1344*D1*Dd*b2*fd*s**2 + 1008*D1*Dd*b2*fd*s - 996*D1*Dd*f**2*r**2 - 2664*D1*Dd*f**2*r*s + 1662*D1*Dd*f**2*r - 1668*D1*Dd*f**2*s**2 + 2166*D1*Dd*f**2*s - 915*D1*Dd*f**2 + 9552*D1*Dd*f*fd*r**2 + 21792*D1*Dd*f*fd*r*s - 12276*D1*Dd*f*fd*r + 12240*D1*Dd*f*fd*s**2 - 13956*D1*Dd*f*fd*s + 3750*D1*Dd*f*fd - 1232*D1*Dd*f*g2*r**2 - 4256*D1*Dd*f*g2*r*s + 2296*D1*Dd*f*g2*r - 3024*D1*Dd*f*g2*s**2 + 3640*D1*Dd*f*g2*s - 1372*D1*Dd*f*g2 + 9632*D1*Dd*f*gd2*r**2 + 23296*D1*Dd*f*gd2*r*s - 17360*D1*Dd*f*gd2*r + 13664*D1*Dd*f*gd2*s**2 - 20888*D1*Dd*f*gd2*s + 7728*D1*Dd*f*gd2 + 9632*D1*Dd*fd*g2*r**2 + 23296*D1*Dd*fd*g2*r*s - 7728*D1*Dd*fd*g2*r + 13664*D1*Dd*fd*g2*s**2 - 9240*D1*Dd*fd*g2*s - 336*D1*Ddd*K*f**2*r*s + 84*D1*Ddd*K*f**2*r - 336*D1*Ddd*K*f**2*s**2 + 336*D1*Ddd*K*f**2*s - 84*D1*Ddd*K*f**2 - 672*D1*Ddd*b2*f*r**2 - 1344*D1*Ddd*b2*f*r*s + 1008*D1*Ddd*b2*f*r - 672*D1*Ddd*b2*f*s**2 + 1008*D1*Ddd*b2*f*s - 504*D1*Ddd*b2*f + 2388*D1*Ddd*f**2*r**2 + 5448*D1*Ddd*f**2*r*s - 3750*D1*Ddd*f**2*r + 3060*D1*Ddd*f**2*s**2 - 4254*D1*Ddd*f**2*s + 1959*D1*Ddd*f**2 + 4816*D1*Ddd*f*g2*r**2 + 11648*D1*Ddd*f*g2*r*s - 7728*D1*Ddd*f*g2*r + 6832*D1*Ddd*f*g2*s**2 - 9240*D1*Ddd*f*g2*s + 4116*D1*Ddd*f*g2 - 14*D1*bd1*(D1*(3*f**2*(19*r**2 + 6*r*(5*s - 6) + 11*s**2 - 28*s + 16) + f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 22*K*r**2 - 76*K*r*s + 60*K*r - 54*K*s**2 + 92*K*s - 38*K - 6*fd*(58*r**2 + 100*r*s - 83*r + 42*s**2 - 71*s + 27) - 19*r**2 - 14*r*s + 20*r + 5*s**2 - 4*s - 4) - 2*fd*(12*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 122*K*s**2 + 113*K*s + r**2*(13 - 86*K) + r*(-208*K*s + 95*K + 38*s - 7) + 25*s**2 - 13*s - 9) + 20*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(3*f**2*(116*r**2 + r*(200*s - 191) + 84*s**2 - 163*s + 77) + f*(12*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(344*r**2 + 832*r*s - 656*r + 488*s**2 - 782*s + 303) + 52*r**2 + 152*r*s - 145*r + 100*s**2 - 187*s + 81) - 20*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 56*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 1008*Dd**2*K*f**2*r*s + 252*Dd**2*K*f**2*r - 1008*Dd**2*K*f**2*s**2 + 1008*Dd**2*K*f**2*s - 168*Dd**2*K*f**2 - 2016*Dd**2*b2*f*r**2 - 4032*Dd**2*b2*f*r*s + 3024*Dd**2*b2*f*r - 2016*Dd**2*b2*f*s**2 + 3024*Dd**2*b2*f*s - 1008*Dd**2*b2*f + 7164*Dd**2*f**2*r**2 + 16344*Dd**2*f**2*r*s - 11250*Dd**2*f**2*r + 9180*Dd**2*f**2*s**2 - 12762*Dd**2*f**2*s + 3918*Dd**2*f**2 + 14448*Dd**2*f*g2*r**2 + 34944*Dd**2*f*g2*r*s - 23184*Dd**2*f*g2*r + 20496*Dd**2*f*g2*s**2 - 27720*Dd**2*f*g2*s + 8232*Dd**2*f*g2))/(105*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct*k1**3*st**4*(b1*(D1**2*(10*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(20*fd**2*s*(2 - 3*s) + 6*fd*(2*s**2 - 2*s + 1) - 3*fdd*(2*s**2 - 2*s + 1)) - 6*fd**2*s*(s - 1)) + D1*f*(2*Dd*(10*f**2*(4*s**2 - 2*s + 1) + f*(-10*fd*(12*s**2 - 7*s + 1) + 12*s**2 - 6*s + 3) - 3*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(10*f + 3)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(10*f + 3)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) - f*(fd*(s**2*(60*bd1 - 6) + s*(4 - 20*bd1) - 2) + fdd*(3*s**2 - 2*s + 1) + s**2*(-6*bd1 + 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) - D1*f*(2*Dd*(f*(s**2*(40*bd1 - 4) + s*(2 - 10*bd1) - 1) + (4*s - 1)*(3*bd1*s + fd*(3*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2**3*k3**2) - 2*D1**2*Pk2*Pk3*ct*k1**3*st**2*(2*b1**2*(D1**2*s**2*(-36*fd**2 + fd*(72*f + 14) - fdd*(36*f + 7)) + D1*(2*Dd*(18*f**2*(4*s**2 - 2*s + 1) + f*(-s**2*(144*fd - 28) + s*(36*fd - 14) + 7) + 7*fd*s*(1 - 4*s)) - Ddd*f*(18*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(18*f + 7)*(2*s - 1)) + b1*(-2*D1**2*bdd1*f*(18*f + 7)*(2*s**2 - 2*s + 1) - 594*D1**2*f**2*fd*s**2 + 396*D1**2*f**2*fd*s - 198*D1**2*f**2*fd + 378*D1**2*f**2*fdd*s**2 - 252*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd + 756*D1**2*f*fd**2*s**2 - 504*D1**2*f*fd**2*s - 146*D1**2*f*fd*s**2 + 170*D1**2*f*fd*s - 85*D1**2*f*fd + 94*D1**2*f*fdd*s**2 - 106*D1**2*f*fdd*s + 53*D1**2*f*fdd + 94*D1**2*fd**2*s**2 - 106*D1**2*fd**2*s - 792*D1*Dd*f**3*s**2 + 396*D1*Dd*f**3*s - 198*D1*Dd*f**3 + 3024*D1*Dd*f**2*fd*s**2 - 1764*D1*Dd*f**2*fd*s + 252*D1*Dd*f**2*fd - 292*D1*Dd*f**2*s**2 + 146*D1*Dd*f**2*s - 73*D1*Dd*f**2 + 752*D1*Dd*f*fd*s**2 - 612*D1*Dd*f*fd*s + 106*D1*Dd*f*fd + 504*D1*Ddd*f**3*s**2 - 252*D1*Ddd*f**3*s + 126*D1*Ddd*f**3 + 188*D1*Ddd*f**2*s**2 - 94*D1*Ddd*f**2*s + 47*D1*Ddd*f**2 + 4*D1*bd1*(D1*(18*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(14 - 72*fd) + s*(36*fd - 14) + 7) + 7*fd*s*(1 - 2*s)) - Dd*f*(18*f + 7)*(8*s**2 - 6*s + 1)) + 1512*Dd**2*f**3*s**2 - 756*Dd**2*f**3*s + 564*Dd**2*f**2*s**2 - 282*Dd**2*f**2*s) + f*(-4*D1**2*bd1**2*s*(18*f + 7)*(s - 1) + D1**2*bdd1*f*(s**2*(126*f + 47) + 12*s - 6) - 123*D1**2*f*fd*s**2 + 82*D1**2*f*fd*s - 41*D1**2*f*fd + 75*D1**2*f*fdd*s**2 - 50*D1**2*f*fdd*s + 25*D1**2*f*fdd + 150*D1**2*fd**2*s**2 - 100*D1**2*fd**2*s - 164*D1*Dd*f**2*s**2 + 82*D1*Dd*f**2*s - 41*D1*Dd*f**2 + 600*D1*Dd*f*fd*s**2 - 350*D1*Dd*f*fd*s + 50*D1*Dd*f*fd + 100*D1*Ddd*f**2*s**2 - 50*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 - D1*bd1*(D1*(198*f**2*s**2 + f*(s**2*(73 - 756*fd) + s*(252*fd + 24) - 12) + 2*fd*s*(41 - 94*s)) - 2*Dd*f*(4*s - 1)*(s*(126*f + 47) + 6)) + 300*Dd**2*f**2*s**2 - 150*Dd**2*f**2*s))/(105*d**2*k2**3*k3**2) + D1**2*Pk2*Pk3*ct*k1**3*(7*b1**2*(D1**2*s**2*(-36*fd**2 + fd*(60*f + 17) - fdd*(36*f + 11)) + D1*(Dd*(30*f**2*(4*s**2 - 2*s + 1) + f*(s**2*(68 - 288*fd) + s*(72*fd - 34) + 17) + 22*fd*s*(1 - 4*s)) - Ddd*f*(18*f + 11)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(18*f + 11)*(2*s - 1)) + b1*(-7*D1**2*bdd1*f*(18*f + 11)*(2*s**2 - 2*s + 1) - 378*D1**2*f**2*fd*s**2 + 252*D1**2*f**2*fd*s - 126*D1**2*f**2*fd + 378*D1**2*f**2*fdd*s**2 - 252*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd + 756*D1**2*f*fd**2*s**2 - 504*D1**2*f*fd**2*s + 8*D1**2*f*fd*s**2 + 154*D1**2*f*fd*s - 77*D1**2*f*fd + 52*D1**2*f*fdd*s**2 - 154*D1**2*f*fdd*s + 77*D1**2*f*fdd + 52*D1**2*fd**2*s**2 - 154*D1**2*fd**2*s - 504*D1*Dd*f**3*s**2 + 252*D1*Dd*f**3*s - 126*D1*Dd*f**3 + 3024*D1*Dd*f**2*fd*s**2 - 1764*D1*Dd*f**2*fd*s + 252*D1*Dd*f**2*fd + 16*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 4*D1*Dd*f**2 + 416*D1*Dd*f*fd*s**2 - 720*D1*Dd*f*fd*s + 154*D1*Dd*f*fd + 504*D1*Ddd*f**3*s**2 - 252*D1*Ddd*f**3*s + 126*D1*Ddd*f**3 + 104*D1*Ddd*f**2*s**2 - 52*D1*Ddd*f**2*s + 26*D1*Ddd*f**2 + 7*D1*bd1*(D1*(30*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(34 - 144*fd) + s*(72*fd - 34) + 17) + 22*fd*s*(1 - 2*s)) - 2*Dd*f*(18*f + 11)*(8*s**2 - 6*s + 1)) + 1512*Dd**2*f**3*s**2 - 756*Dd**2*f**3*s + 312*Dd**2*f**2*s**2 - 156*Dd**2*f**2*s) + f*(-14*D1**2*bd1**2*s*(18*f + 11)*(s - 1) + D1**2*bdd1*f*(s**2*(126*f + 26) + 102*s - 51) - 51*D1**2*(f*(fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*bd1*(D1*(-126*f**2*s**2 + f*(s**2*(756*fd + 4) - s*(252*fd + 162) + 81) + 2*fd*s*(52*s + 25)) + 2*Dd*f*(4*s - 1)*(s*(126*f + 26) + 51)) - 51*D1*f*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(12*s**2 - 7*s + 1) + Ddd*f*(-4*s**2 + 2*s - 1)) - 306*Dd**2*f**2*s*(1 - 2*s)))/(105*d**2*k2**3*k3**2) + 4*D1**2*Pk2*Pk3*ct*k1*k2**5*st**6*(-24*C*D1**2*f**2*fd*r**2 - 48*C*D1**2*f**2*fd*r*s + 32*C*D1**2*f**2*fd*r - 24*C*D1**2*f**2*fd*s**2 + 32*C*D1**2*f**2*fd*s - 16*C*D1**2*f**2*fd + 12*C*D1**2*f**2*fdd*r**2 + 24*C*D1**2*f**2*fdd*r*s - 16*C*D1**2*f**2*fdd*r + 12*C*D1**2*f**2*fdd*s**2 - 16*C*D1**2*f**2*fdd*s + 8*C*D1**2*f**2*fdd + 24*C*D1**2*f*fd**2*r**2 + 48*C*D1**2*f*fd**2*r*s - 32*C*D1**2*f*fd**2*r + 24*C*D1**2*f*fd**2*s**2 - 32*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 32*C*D1*Dd*f**3*r**2 - 64*C*D1*Dd*f**3*r*s + 48*C*D1*Dd*f**3*r - 32*C*D1*Dd*f**3*s**2 + 48*C*D1*Dd*f**3*s - 24*C*D1*Dd*f**3 + 96*C*D1*Dd*f**2*fd*r**2 + 192*C*D1*Dd*f**2*fd*r*s - 136*C*D1*Dd*f**2*fd*r + 96*C*D1*Dd*f**2*fd*s**2 - 136*C*D1*Dd*f**2*fd*s + 48*C*D1*Dd*f**2*fd + 16*C*D1*Ddd*f**3*r**2 + 32*C*D1*Ddd*f**3*r*s - 24*C*D1*Ddd*f**3*r + 16*C*D1*Ddd*f**3*s**2 - 24*C*D1*Ddd*f**3*s + 12*C*D1*Ddd*f**3 + 48*C*Dd**2*f**3*r**2 + 96*C*Dd**2*f**3*r*s - 72*C*Dd**2*f**3*r + 48*C*Dd**2*f**3*s**2 - 72*C*Dd**2*f**3*s + 24*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 - 144*D1**2*K*b1*f*fd*r*s + 72*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 + 18*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 24*D1**2*f**2*fd*s + 12*D1**2*f**2*fd - 9*D1**2*f**2*fdd*r**2 - 18*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r - 9*D1**2*f**2*fdd*s**2 + 12*D1**2*f**2*fdd*s - 6*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r - 36*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 18*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 24*D1**2*f*fd**2*r - 18*D1**2*f*fd**2*s**2 + 24*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 - 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 216*D1*Dd*K*b1*f**2*s - 108*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r**2 + 576*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 360*D1*Dd*K*b1*f*fd*s + 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 72*D1*Dd*f**2*fd*r**2 - 144*D1*Dd*f**2*fd*r*s + 102*D1*Dd*f**2*fd*r - 72*D1*Dd*f**2*fd*s**2 + 102*D1*Dd*f**2*fd*s - 36*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 504*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 720*D1*Dd*f*fd*g2*s - 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 + 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 108*D1*Ddd*K*b1*f**2*s + 54*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 24*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 18*D1*Ddd*f**3*s - 9*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 216*D1*Ddd*f**2*g2*s - 108*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*b1*f**2*r**2 + 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 324*Dd**2*K*b1*f**2*s + 108*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 72*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 54*Dd**2*f**3*s - 18*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 648*Dd**2*f**2*g2*s - 216*Dd**2*f**2*g2)/(21*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct*k1*k2**5*st**4*(12*C*D1**2*bdd1*f**2*r**2 + 24*C*D1**2*bdd1*f**2*r*s - 24*C*D1**2*bdd1*f**2*r + 12*C*D1**2*bdd1*f**2*s**2 - 24*C*D1**2*bdd1*f**2*s + 12*C*D1**2*bdd1*f**2 - 168*C*D1**2*f**2*fd*r**2 - 336*C*D1**2*f**2*fd*r*s + 224*C*D1**2*f**2*fd*r - 168*C*D1**2*f**2*fd*s**2 + 224*C*D1**2*f**2*fd*s - 112*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r**2 + 240*C*D1**2*f**2*fdd*r*s - 160*C*D1**2*f**2*fdd*r + 120*C*D1**2*f**2*fdd*s**2 - 160*C*D1**2*f**2*fdd*s + 80*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r**2 + 480*C*D1**2*f*fd**2*r*s - 320*C*D1**2*f*fd**2*r + 240*C*D1**2*f*fd**2*s**2 - 320*C*D1**2*f*fd**2*s + 80*C*D1**2*f*fd**2 - 224*C*D1*Dd*f**3*r**2 - 448*C*D1*Dd*f**3*r*s + 336*C*D1*Dd*f**3*r - 224*C*D1*Dd*f**3*s**2 + 336*C*D1*Dd*f**3*s - 168*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r**2 + 1920*C*D1*Dd*f**2*fd*r*s - 1360*C*D1*Dd*f**2*fd*r + 960*C*D1*Dd*f**2*fd*s**2 - 1360*C*D1*Dd*f**2*fd*s + 480*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r**2 + 320*C*D1*Ddd*f**3*r*s - 240*C*D1*Ddd*f**3*r + 160*C*D1*Ddd*f**3*s**2 - 240*C*D1*Ddd*f**3*s + 120*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r**2 + 960*C*Dd**2*f**3*r*s - 720*C*Dd**2*f**3*r + 480*C*Dd**2*f**3*s**2 - 720*C*Dd**2*f**3*s + 240*C*Dd**2*f**3 + 60*D1**2*K*bdd1*f**2*r**2 + 120*D1**2*K*bdd1*f**2*r*s - 120*D1**2*K*bdd1*f**2*r + 60*D1**2*K*bdd1*f**2*s**2 - 120*D1**2*K*bdd1*f**2*s + 60*D1**2*K*bdd1*f**2 - 6*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 9*D1**2*bdd1*f**2*r**2 - 18*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*r - 9*D1**2*bdd1*f**2*s**2 + 18*D1**2*bdd1*f**2*s - 9*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r**2 - 168*D1**2*bdd1*f*g2*r*s + 168*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 120*D1**2*f**2*gdd2*r**2 - 240*D1**2*f**2*gdd2*r*s + 240*D1**2*f**2*gdd2*r - 120*D1**2*f**2*gdd2*s**2 + 240*D1**2*f**2*gdd2*s - 120*D1**2*f**2*gdd2 - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 480*D1**2*f*fd*gd2*r**2 - 960*D1**2*f*fd*gd2*r*s + 720*D1**2*f*fd*gd2*r - 480*D1**2*f*fd*gd2*s**2 + 720*D1**2*f*fd*gd2*s - 240*D1**2*f*fd*gd2 - 240*D1**2*f*fdd*g2*r**2 - 480*D1**2*f*fdd*g2*r*s + 240*D1**2*f*fdd*g2*r - 240*D1**2*f*fdd*g2*s**2 + 240*D1**2*f*fdd*g2*s - 120*D1**2*f*fdd*g2 - 240*D1**2*fd**2*g2*r**2 - 480*D1**2*fd**2*g2*r*s + 240*D1**2*fd**2*g2*r - 240*D1**2*fd**2*g2*s**2 + 240*D1**2*fd**2*g2*s + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 680*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 680*D1*Dd*f**2*fd*s - 240*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 960*D1*Dd*f**2*gd2*r**2 - 1920*D1*Dd*f**2*gd2*r*s + 1680*D1*Dd*f**2*gd2*r - 960*D1*Dd*f**2*gd2*s**2 + 1680*D1*Dd*f**2*gd2*s - 720*D1*Dd*f**2*gd2 - 1920*D1*Dd*f*fd*g2*r**2 - 3840*D1*Dd*f*fd*g2*r*s + 2400*D1*Dd*f*fd*g2*r - 1920*D1*Dd*f*fd*g2*s**2 + 2400*D1*Dd*f*fd*g2*s - 720*D1*Dd*f*fd*g2 - 80*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 120*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 - 480*D1*Ddd*f**2*g2*r**2 - 960*D1*Ddd*f**2*g2*r*s + 720*D1*Ddd*f**2*g2*r - 480*D1*Ddd*f**2*g2*s**2 + 720*D1*Ddd*f**2*g2*s - 360*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(8*C + 12*K + 1)*(r + s - 1) - 2*f*(fd*(4*C + 20*K - 3)*(2*r + 2*s - 1) + (28*g2 - 28*gd2)*(r + s - 1)) + 56*fd*g2*(r + s)) - 2*Dd*f*(f*(4*C + 20*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 240*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 360*Dd**2*f**3*s - 120*Dd**2*f**3 - 1440*Dd**2*f**2*g2*r**2 - 2880*Dd**2*f**2*g2*r*s + 2160*Dd**2*f**2*g2*r - 1440*Dd**2*f**2*g2*s**2 + 2160*Dd**2*f**2*g2*s - 720*Dd**2*f**2*g2 + 3*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-16*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 16*C*D1**2*f*fd*s - 8*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r**2 + 16*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r + 8*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s + 4*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r**2 + 16*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s - 32*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r**2 + 128*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r + 64*C*D1*Dd*f*fd*s**2 - 80*C*D1*Dd*f*fd*s + 24*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r**2 + 32*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s**2 - 24*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r**2 + 96*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s**2 - 72*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 3*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 18*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 12*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 18*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 36*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 54*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 18*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(35*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct*k1*k2**5*st**2*(D1*(-168*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(f**2*(88*C - 42*K - 37)*(r + s - 1) - 8*f*(fd*(18*C - 9)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 336*fd*g2*(r + s)) - 24*Dd*f*(f*(6*C - 3) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6*f*(2*D1*bdd1*(f*(6*C - 3) - 14*g2)*(r + s - 1)**2 + D1*(f*(fd*(6*C - 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*gd2*(r + s - 1)**2) - 14*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(6*C - 3) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + 7*b1**2*(D1**2*(3*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-12*K*fdd + fd*(4*K + 5))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*K + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*(f*(fd*(88*C - 42*K - 37)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*fdd*(18*C - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*(r + s - 1)**2*(42*K*bdd1 + 14*gd2 - 42*gdd2)) + (-8*r - 8*s)*(fd**2*(18*C - 9)*(r + s - 1) + 7*fd*(g2*(r + s) - 6*gd2*(r + s - 1)) - 21*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-24*K*fd*(r + s) + 3*f**2*(r + s - 1) + f*(4*K + 5)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(88*C - 42*K - 37)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*f*(fd*(18*C - 9)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 42*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 336*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(f*(6*C - 3) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(6*C - 3) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(35*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct*k1*k2**3*st**6*(-24*C*D1**2*f**2*fd*r**2 + 24*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r + 48*C*D1**2*f**2*fd*s**2 - 40*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd + 12*C*D1**2*f**2*fdd*r**2 - 12*C*D1**2*f**2*fdd*r*s - 4*C*D1**2*f**2*fdd*r - 24*C*D1**2*f**2*fdd*s**2 + 20*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd + 24*C*D1**2*f*fd**2*r**2 - 24*C*D1**2*f*fd**2*r*s - 8*C*D1**2*f*fd**2*r - 48*C*D1**2*f*fd**2*s**2 + 40*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 - 32*C*D1*Dd*f**3*r**2 + 32*C*D1*Dd*f**3*r*s + 24*C*D1*Dd*f**3*r + 64*C*D1*Dd*f**3*s**2 - 48*C*D1*Dd*f**3*s + 96*C*D1*Dd*f**2*fd*r**2 - 96*C*D1*Dd*f**2*fd*r*s - 52*C*D1*Dd*f**2*fd*r - 192*C*D1*Dd*f**2*fd*s**2 + 152*C*D1*Dd*f**2*fd*s - 12*C*D1*Dd*f**2*fd + 16*C*D1*Ddd*f**3*r**2 - 16*C*D1*Ddd*f**3*r*s - 12*C*D1*Ddd*f**3*r - 32*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s + 48*C*Dd**2*f**3*r**2 - 48*C*Dd**2*f**3*r*s - 36*C*Dd**2*f**3*r - 96*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s - 72*D1**2*K*b1*f*fd*r**2 + 72*D1**2*K*b1*f*fd*r*s - 36*D1**2*K*b1*f*fd*r + 144*D1**2*K*b1*f*fd*s**2 - 144*D1**2*K*b1*f*fd*s + 72*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 - 36*D1**2*K*b1*f*fdd*r*s + 18*D1**2*K*b1*f*fdd*r - 72*D1**2*K*b1*f*fdd*s**2 + 72*D1**2*K*b1*f*fdd*s - 36*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 - 36*D1**2*K*b1*fd**2*r*s + 18*D1**2*K*b1*fd**2*r - 72*D1**2*K*b1*fd**2*s**2 + 72*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 - 28*D1**2*b1*f**2*fd*r - 42*D1**2*b1*f**2*fd*s**2 + 28*D1**2*b1*f**2*fd*s - 21*D1**2*b1*f**2*fdd*r**2 + 14*D1**2*b1*f**2*fdd*r + 21*D1**2*b1*f**2*fdd*s**2 - 14*D1**2*b1*f**2*fdd*s - 42*D1**2*b1*f*fd**2*r**2 + 28*D1**2*b1*f*fd**2*r + 42*D1**2*b1*f*fd**2*s**2 - 28*D1**2*b1*f*fd**2*s + 108*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd - 54*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd - 54*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(r + s - 1)*(-18*K*(r - 2*s - 1) + 7*f*(r - s - 1) + 27*r - 9*s - 27) - 56*D1**2*f**3*fd*r**2 - 56*D1**2*f**3*fd*r*s + 70*D1**2*f**3*fd*r + 28*D1**2*f**3*fd*s - 28*D1**2*f**3*fd + 56*D1**2*f**3*fdd*r**2 + 56*D1**2*f**3*fdd*r*s - 70*D1**2*f**3*fdd*r - 28*D1**2*f**3*fdd*s + 28*D1**2*f**3*fdd + 168*D1**2*f**2*fd**2*r**2 + 168*D1**2*f**2*fd**2*r*s - 210*D1**2*f**2*fd**2*r - 84*D1**2*f**2*fd**2*s + 56*D1**2*f**2*fd**2 + 30*D1**2*f**2*fd*r**2 - 20*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 15*D1**2*f**2*fdd*r**2 + 10*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 10*D1**2*f**2*fdd*s + 72*D1**2*f**2*gd2*r**2 - 72*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r - 144*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 + 36*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r + 72*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 30*D1**2*f*fd**2*r**2 + 20*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 20*D1**2*f*fd**2*s + 144*D1**2*f*fd*g2*r**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 288*D1**2*f*fd*g2*s**2 + 288*D1**2*f*fd*g2*s - 144*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 + 144*D1**2*f*fd*gd2*r*s + 108*D1**2*f*fd*gd2*r + 288*D1**2*f*fd*gd2*s**2 - 216*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 144*D1**2*f*fdd*g2*s**2 - 144*D1**2*f*fdd*g2*s + 72*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 144*D1**2*fd**2*g2*s**2 - 144*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 + 144*D1*Dd*K*b1*f**2*r*s + 108*D1*Dd*K*b1*f**2*r + 288*D1*Dd*K*b1*f**2*s**2 - 216*D1*Dd*K*b1*f**2*s + 288*D1*Dd*K*b1*f*fd*r**2 - 288*D1*Dd*K*b1*f*fd*r*s - 36*D1*Dd*K*b1*f*fd*r - 576*D1*Dd*K*b1*f*fd*s**2 + 504*D1*Dd*K*b1*f*fd*s - 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 - 56*D1*Dd*b1*f**3*r - 56*D1*Dd*b1*f**3*s**2 + 28*D1*Dd*b1*f**3*s + 14*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 + 140*D1*Dd*b1*f**2*fd*r + 168*D1*Dd*b1*f**2*fd*s**2 - 98*D1*Dd*b1*f**2*fd*s - 14*D1*Dd*b1*f**2*fd + 216*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 252*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 - 36*D1*Dd*b1*f**2*s + 90*D1*Dd*b1*f**2 - 432*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 324*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 36*D1*Dd*b1*f*fd*s - 18*D1*Dd*b1*f*fd - 56*D1*Dd*f**4*r**2 - 56*D1*Dd*f**4*r*s + 70*D1*Dd*f**4*r + 28*D1*Dd*f**4*s - 28*D1*Dd*f**4 + 448*D1*Dd*f**3*fd*r**2 + 448*D1*Dd*f**3*fd*r*s - 560*D1*Dd*f**3*fd*r - 224*D1*Dd*f**3*fd*s + 168*D1*Dd*f**3*fd + 40*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s + 10*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 + 100*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 70*D1*Dd*f**2*fd*s - 10*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 - 288*D1*Dd*f**2*g2*r*s - 216*D1*Dd*f**2*g2*r - 576*D1*Dd*f**2*g2*s**2 + 432*D1*Dd*f**2*g2*s - 288*D1*Dd*f**2*gd2*r**2 + 288*D1*Dd*f**2*gd2*r*s + 396*D1*Dd*f**2*gd2*r + 576*D1*Dd*f**2*gd2*s**2 - 360*D1*Dd*f**2*gd2*s - 108*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 + 576*D1*Dd*f*fd*g2*r*s + 72*D1*Dd*f*fd*g2*r + 1152*D1*Dd*f*fd*g2*s**2 - 1008*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 - 72*D1*Ddd*K*b1*f**2*r*s - 54*D1*Ddd*K*b1*f**2*r - 144*D1*Ddd*K*b1*f**2*s**2 + 108*D1*Ddd*K*b1*f**2*s - 28*D1*Ddd*b1*f**3*r**2 + 28*D1*Ddd*b1*f**3*r + 28*D1*Ddd*b1*f**3*s**2 - 14*D1*Ddd*b1*f**3*s - 7*D1*Ddd*b1*f**3 - 108*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 126*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 + 18*D1*Ddd*b1*f**2*s - 45*D1*Ddd*b1*f**2 + 56*D1*Ddd*f**4*r**2 + 56*D1*Ddd*f**4*r*s - 70*D1*Ddd*f**4*r - 28*D1*Ddd*f**4*s + 28*D1*Ddd*f**4 - 20*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 10*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 + 144*D1*Ddd*f**2*g2*r*s + 108*D1*Ddd*f**2*g2*r + 288*D1*Ddd*f**2*g2*s**2 - 216*D1*Ddd*f**2*g2*s + 2*D1*bd1*f*(D1*(7*f**2*(r**2 - 2*r - s**2 + 1) + f*(-7*fd*(3*r**2 - 4*r - 3*s**2 + s + 1) + (-9*r - 9*s + 9)*(2*K*(r - 2*s - 1) - 3*r + s + 3)) + 9*fd*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1)) + Dd*f*(9*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 7*f*(4*r**2 - 6*r - 4*s**2 + s + 2) - 108*r**2 - 72*r*s + 171*r + 36*s**2 + 45*s - 63)) + 216*Dd**2*K*b1*f**2*r**2 - 216*Dd**2*K*b1*f**2*r*s - 162*Dd**2*K*b1*f**2*r - 432*Dd**2*K*b1*f**2*s**2 + 324*Dd**2*K*b1*f**2*s - 84*Dd**2*b1*f**3*r**2 + 84*Dd**2*b1*f**3*r + 84*Dd**2*b1*f**3*s**2 - 42*Dd**2*b1*f**3*s - 14*Dd**2*b1*f**3 - 324*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 378*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 + 54*Dd**2*b1*f**2*s - 90*Dd**2*b1*f**2 + 168*Dd**2*f**4*r**2 + 168*Dd**2*f**4*r*s - 210*Dd**2*f**4*r - 84*Dd**2*f**4*s + 56*Dd**2*f**4 - 60*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 30*Dd**2*f**3*s - 10*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 + 432*Dd**2*f**2*g2*r*s + 324*Dd**2*f**2*g2*r + 864*Dd**2*f**2*g2*s**2 - 648*Dd**2*f**2*g2*s)/(63*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct*k1*k2**3*st**4*(24*C*D1**2*bdd1*f**2*r*s + 24*C*D1**2*bdd1*f**2*r + 24*C*D1**2*bdd1*f**2*s**2 + 1380*C*D1**2*f**2*fd*r**2 + 2352*C*D1**2*f**2*fd*r*s - 1704*C*D1**2*f**2*fd*r + 972*C*D1**2*f**2*fd*s**2 - 1432*C*D1**2*f**2*fd*s + 784*C*D1**2*f**2*fd - 1068*C*D1**2*f**2*fdd*r**2 - 1752*C*D1**2*f**2*fdd*r*s + 1296*C*D1**2*f**2*fdd*r - 684*C*D1**2*f**2*fdd*s**2 + 1040*C*D1**2*f**2*fdd*s - 584*C*D1**2*f**2*fdd - 2136*C*D1**2*f*fd**2*r**2 - 3504*C*D1**2*f*fd**2*r*s + 2592*C*D1**2*f*fd**2*r - 1368*C*D1**2*f*fd**2*s**2 + 2080*C*D1**2*f*fd**2*s - 584*C*D1**2*f*fd**2 + 1840*C*D1*Dd*f**3*r**2 + 3136*C*D1*Dd*f**3*r*s - 2624*C*D1*Dd*f**3*r + 1296*C*D1*Dd*f**3*s**2 - 2216*C*D1*Dd*f**3*s + 1244*C*D1*Dd*f**3 - 8544*C*D1*Dd*f**2*fd*r**2 - 14016*C*D1*Dd*f**2*fd*r*s + 11208*C*D1*Dd*f**2*fd*r - 5472*C*D1*Dd*f**2*fd*s**2 + 9032*C*D1*Dd*f**2*fd*s - 3632*C*D1*Dd*f**2*fd - 1424*C*D1*Ddd*f**3*r**2 - 2336*C*D1*Ddd*f**3*r*s + 2008*C*D1*Ddd*f**3*r - 912*C*D1*Ddd*f**3*s**2 + 1624*C*D1*Ddd*f**3*s - 940*C*D1*Ddd*f**3 - 4272*C*Dd**2*f**3*r**2 - 7008*C*Dd**2*f**3*r*s + 6024*C*Dd**2*f**3*r - 2736*C*Dd**2*f**3*s**2 + 4872*C*Dd**2*f**3*s - 1880*C*Dd**2*f**3 - 510*D1**2*K*bdd1*f**2*r**2 - 1068*D1**2*K*bdd1*f**2*r*s + 1020*D1**2*K*bdd1*f**2*r - 558*D1**2*K*bdd1*f**2*s**2 + 1068*D1**2*K*bdd1*f**2*s - 510*D1**2*K*bdd1*f**2 + 312*D1**2*b2*f*fd*r**2 + 624*D1**2*b2*f*fd*r*s - 312*D1**2*b2*f*fd*r + 312*D1**2*b2*f*fd*s**2 - 312*D1**2*b2*f*fd*s + 156*D1**2*b2*f*fd - 240*D1**2*b2*f*fdd*r**2 - 480*D1**2*b2*f*fdd*r*s + 240*D1**2*b2*f*fdd*r - 240*D1**2*b2*f*fdd*s**2 + 240*D1**2*b2*f*fdd*s - 120*D1**2*b2*f*fdd - 240*D1**2*b2*fd**2*r**2 - 480*D1**2*b2*fd**2*r*s + 240*D1**2*b2*fd**2*r - 240*D1**2*b2*fd**2*s**2 + 240*D1**2*b2*fd**2*s - 12*D1**2*bd1**2*f*(r + s - 1)*(-14*K*s - 7*K + 5*f - 14*r + 14) + 156*D1**2*bd2*f**2*r**2 + 312*D1**2*bd2*f**2*r*s - 312*D1**2*bd2*f**2*r + 156*D1**2*bd2*f**2*s**2 - 312*D1**2*bd2*f**2*s + 156*D1**2*bd2*f**2 - 480*D1**2*bd2*f*fd*r**2 - 960*D1**2*bd2*f*fd*r*s + 720*D1**2*bd2*f*fd*r - 480*D1**2*bd2*f*fd*s**2 + 720*D1**2*bd2*f*fd*s - 240*D1**2*bd2*f*fd + 165*D1**2*bdd1*f**3*r**2 + 330*D1**2*bdd1*f**3*r*s - 390*D1**2*bdd1*f**3*r + 165*D1**2*bdd1*f**3*s**2 - 390*D1**2*bdd1*f**3*s + 225*D1**2*bdd1*f**3 + 207*D1**2*bdd1*f**2*r**2 + 414*D1**2*bdd1*f**2*r*s - 426*D1**2*bdd1*f**2*r + 207*D1**2*bdd1*f**2*s**2 - 426*D1**2*bdd1*f**2*s + 201*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r*s - 168*D1**2*bdd1*f*g2*r - 168*D1**2*bdd1*f*g2*s**2 - 120*D1**2*bdd2*f**2*r**2 - 240*D1**2*bdd2*f**2*r*s + 240*D1**2*bdd2*f**2*r - 120*D1**2*bdd2*f**2*s**2 + 240*D1**2*bdd2*f**2*s - 120*D1**2*bdd2*f**2 - 897*D1**2*f**2*fd*r**2 - 1506*D1**2*f**2*fd*r*s + 1100*D1**2*f**2*fd*r - 609*D1**2*f**2*fd*s**2 + 908*D1**2*f**2*fd*s - 502*D1**2*f**2*fd + 741*D1**2*f**2*fdd*r**2 + 1194*D1**2*f**2*fdd*r*s - 892*D1**2*f**2*fdd*r + 453*D1**2*f**2*fdd*s**2 - 700*D1**2*f**2*fdd*s + 398*D1**2*f**2*fdd - 948*D1**2*f**2*gd2*r**2 - 2256*D1**2*f**2*gd2*r*s + 1896*D1**2*f**2*gd2*r - 1308*D1**2*f**2*gd2*s**2 + 2256*D1**2*f**2*gd2*s - 948*D1**2*f**2*gd2 + 1020*D1**2*f**2*gdd2*r**2 + 2136*D1**2*f**2*gdd2*r*s - 2040*D1**2*f**2*gdd2*r + 1116*D1**2*f**2*gdd2*s**2 - 2136*D1**2*f**2*gdd2*s + 1020*D1**2*f**2*gdd2 + 1482*D1**2*f*fd**2*r**2 + 2388*D1**2*f*fd**2*r*s - 1784*D1**2*f*fd**2*r + 906*D1**2*f*fd**2*s**2 - 1400*D1**2*f*fd**2*s + 398*D1**2*f*fd**2 - 1896*D1**2*f*fd*g2*r**2 - 4512*D1**2*f*fd*g2*r*s + 2256*D1**2*f*fd*g2*r - 2616*D1**2*f*fd*g2*s**2 + 2616*D1**2*f*fd*g2*s - 1308*D1**2*f*fd*g2 + 4080*D1**2*f*fd*gd2*r**2 + 8544*D1**2*f*fd*gd2*r*s - 6216*D1**2*f*fd*gd2*r + 4464*D1**2*f*fd*gd2*s**2 - 6504*D1**2*f*fd*gd2*s + 2136*D1**2*f*fd*gd2 + 2040*D1**2*f*fdd*g2*r**2 + 4272*D1**2*f*fdd*g2*r*s - 2136*D1**2*f*fdd*g2*r + 2232*D1**2*f*fdd*g2*s**2 - 2232*D1**2*f*fdd*g2*s + 1116*D1**2*f*fdd*g2 + 2040*D1**2*fd**2*g2*r**2 + 4272*D1**2*fd**2*g2*r*s - 2136*D1**2*fd**2*g2*r + 2232*D1**2*fd**2*g2*s**2 - 2232*D1**2*fd**2*g2*s + 624*D1*Dd*b2*f**2*r**2 + 1248*D1*Dd*b2*f**2*r*s - 936*D1*Dd*b2*f**2*r + 624*D1*Dd*b2*f**2*s**2 - 936*D1*Dd*b2*f**2*s + 468*D1*Dd*b2*f**2 - 1920*D1*Dd*b2*f*fd*r**2 - 3840*D1*Dd*b2*f*fd*r*s + 2400*D1*Dd*b2*f*fd*r - 1920*D1*Dd*b2*f*fd*s**2 + 2400*D1*Dd*b2*f*fd*s - 720*D1*Dd*b2*f*fd - 960*D1*Dd*bd2*f**2*r**2 - 1920*D1*Dd*bd2*f**2*r*s + 1680*D1*Dd*bd2*f**2*r - 960*D1*Dd*bd2*f**2*s**2 + 1680*D1*Dd*bd2*f**2*s - 720*D1*Dd*bd2*f**2 - 1196*D1*Dd*f**3*r**2 - 2008*D1*Dd*f**3*r*s + 1698*D1*Dd*f**3*r - 812*D1*Dd*f**3*s**2 + 1410*D1*Dd*f**3*s - 801*D1*Dd*f**3 + 5928*D1*Dd*f**2*fd*r**2 + 9552*D1*Dd*f**2*fd*r*s - 7726*D1*Dd*f**2*fd*r + 3624*D1*Dd*f**2*fd*s**2 - 6094*D1*Dd*f**2*fd*s + 2484*D1*Dd*f**2*fd - 3792*D1*Dd*f**2*g2*r**2 - 9024*D1*Dd*f**2*g2*r*s + 6048*D1*Dd*f**2*g2*r - 5232*D1*Dd*f**2*g2*s**2 + 7128*D1*Dd*f**2*g2*s - 3204*D1*Dd*f**2*g2 + 8160*D1*Dd*f**2*gd2*r**2 + 17088*D1*Dd*f**2*gd2*r*s - 14376*D1*Dd*f**2*gd2*r + 8928*D1*Dd*f**2*gd2*s**2 - 15048*D1*Dd*f**2*gd2*s + 6216*D1*Dd*f**2*gd2 + 16320*D1*Dd*f*fd*g2*r**2 + 34176*D1*Dd*f*fd*g2*r*s - 20976*D1*Dd*f*fd*g2*r + 17856*D1*Dd*f*fd*g2*s**2 - 21936*D1*Dd*f*fd*g2*s + 6504*D1*Dd*f*fd*g2 - 480*D1*Ddd*b2*f**2*r**2 - 960*D1*Ddd*b2*f**2*r*s + 720*D1*Ddd*b2*f**2*r - 480*D1*Ddd*b2*f**2*s**2 + 720*D1*Ddd*b2*f**2*s - 360*D1*Ddd*b2*f**2 + 988*D1*Ddd*f**3*r**2 + 1592*D1*Ddd*f**3*r*s - 1386*D1*Ddd*f**3*r + 604*D1*Ddd*f**3*s**2 - 1098*D1*Ddd*f**3*s + 645*D1*Ddd*f**3 + 4080*D1*Ddd*f**2*g2*r**2 + 8544*D1*Ddd*f**2*g2*r*s - 6216*D1*Ddd*f**2*g2*r + 4464*D1*Ddd*f**2*g2*s**2 - 6504*D1*Ddd*f**2*g2*s + 3156*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*(7*r**2 + 18*r*(s - 1) + 11*(s - 1)**2) + f**2*(16*C*r*s + 16*C*r + 16*C*s**2 - 2*K*(79*r**2 + 2*r*(94*s - 79) + 109*s**2 - 188*s + 79) - 10*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) + 33*r**2 + 94*r*s - 74*r + 61*s**2 - 102*s + 29) - 2*f*(fd*(4*C*(4*s**2 + s*(4*r - 3) - 1) - 2*K*(170*r**2 + 356*r*s - 259*r + 186*s**2 - 271*s + 89) + 138*r**2 + 276*r*s - 209*r + 138*s**2 - 209*s + 75) + 56*g2*(r*s + r + s**2) - 28*gd2*(2*s + 1)*(r + s - 1)) + 56*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + f*(4*C*(r*(8*s + 3) + 8*s**2 - 4*s - 2) - 2*K*(340*r**2 + 712*r*s - 599*r + 372*s**2 - 627*s + 259) + 276*r**2 + 552*r*s - 491*r + 276*s**2 - 491*s + 213) - 28*g2*(r*(8*s + 3) + 8*s**2 - 4*s - 2))) - 1440*Dd**2*b2*f**2*r**2 - 2880*Dd**2*b2*f**2*r*s + 2160*Dd**2*b2*f**2*r - 1440*Dd**2*b2*f**2*s**2 + 2160*Dd**2*b2*f**2*s - 720*Dd**2*b2*f**2 + 2964*Dd**2*f**3*r**2 + 4776*Dd**2*f**3*r*s - 4158*Dd**2*f**3*r + 1812*Dd**2*f**3*s**2 - 3294*Dd**2*f**3*s + 1290*Dd**2*f**3 + 12240*Dd**2*f**2*g2*r**2 + 25632*Dd**2*f**2*g2*r*s - 18648*Dd**2*f**2*g2*r + 13392*Dd**2*f**2*g2*s**2 - 19512*Dd**2*f**2*g2*s + 6312*Dd**2*f**2*g2 - 6*b1**2*(D1**2*(10*f*fd*(2*r + 2*s - 1) - 5*f*fdd*(2*r + 2*s - 1) - 10*fd**2*(r + s - 1) + 14*fd*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1) - 7*fdd*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1)) - 2*D1*(Dd*(f*(-14*K*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(4*r + 4*s - 3) - 56*r**2 - 56*r*s + 70*r + 28*s - 28) + 7*fd*(K*(8*r*s - 9*r + 8*s**2 - 12*s + 6) + 8*r**2 + 8*r*s - r + 2*s - 3)) + 7*Ddd*f*(K*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - 14*Dd**2*f*(K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) + 3*b1*(-32*C*D1**2*f*fd*r*s + 32*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 16*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r*s - 16*C*D1**2*f*fdd*r + 16*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 8*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r*s - 16*C*D1**2*fd**2*r + 16*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s + 16*C*D1**2*fd**2 - 64*C*D1*Dd*f**2*r*s + 16*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s**2 + 64*C*D1*Dd*f**2*s - 16*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r + 128*C*D1*Dd*f*fd*s**2 - 160*C*D1*Dd*f*fd*s + 56*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r*s - 8*C*D1*Ddd*f**2*r + 32*C*D1*Ddd*f**2*s**2 - 32*C*D1*Ddd*f**2*s + 8*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r*s - 24*C*Dd**2*f**2*r + 96*C*Dd**2*f**2*s**2 - 96*C*Dd**2*f**2*s + 16*C*Dd**2*f**2 + 316*D1**2*K*f*fd*r**2 + 752*D1**2*K*f*fd*r*s - 376*D1**2*K*f*fd*r + 436*D1**2*K*f*fd*s**2 - 436*D1**2*K*f*fd*s + 218*D1**2*K*f*fd - 340*D1**2*K*f*fdd*r**2 - 712*D1**2*K*f*fdd*r*s + 356*D1**2*K*f*fdd*r - 372*D1**2*K*f*fdd*s**2 + 372*D1**2*K*f*fdd*s - 186*D1**2*K*f*fdd - 340*D1**2*K*fd**2*r**2 - 712*D1**2*K*fd**2*r*s + 356*D1**2*K*fd**2*r - 372*D1**2*K*fd**2*s**2 + 372*D1**2*K*fd**2*s + 2*D1**2*bdd1*f*(28*K*s**2 - 5*f*(2*r + 2*s - 1) + 28*r**2 + 14*r*(2*K*s + K + 2*s - 4) - 7*s*(2*K + 4) + 21) - 105*D1**2*f**2*fd*r**2 - 270*D1**2*f**2*fd*r*s + 140*D1**2*f**2*fd*r - 165*D1**2*f**2*fd*s**2 + 180*D1**2*f**2*fd*s - 70*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 66*D1**2*f*fd*r**2 - 188*D1**2*f*fd*r*s + 86*D1**2*f*fd*r - 122*D1**2*f*fd*s**2 + 114*D1**2*f*fd*s - 65*D1**2*f*fd + 138*D1**2*f*fdd*r**2 + 276*D1**2*f*fdd*r*s - 134*D1**2*f*fdd*r + 138*D1**2*f*fdd*s**2 - 134*D1**2*f*fdd*s + 71*D1**2*f*fdd + 112*D1**2*f*gd2*r*s + 112*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s - 56*D1**2*f*gdd2*r*s - 56*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s + 138*D1**2*fd**2*r**2 + 276*D1**2*fd**2*r*s - 134*D1**2*fd**2*r + 138*D1**2*fd**2*s**2 - 134*D1**2*fd**2*s - 12*D1**2*fd**2 + 112*D1**2*fd*g2*r*s - 224*D1**2*fd*g2*r + 112*D1**2*fd*g2*s**2 - 224*D1**2*fd*g2*s + 112*D1**2*fd*g2 - 112*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 112*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 112*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r*s + 112*D1**2*fdd*g2*r - 56*D1**2*fdd*g2*s**2 + 112*D1**2*fdd*g2*s - 56*D1**2*fdd*g2 + 632*D1*Dd*K*f**2*r**2 + 1504*D1*Dd*K*f**2*r*s - 1008*D1*Dd*K*f**2*r + 872*D1*Dd*K*f**2*s**2 - 1188*D1*Dd*K*f**2*s + 534*D1*Dd*K*f**2 - 2720*D1*Dd*K*f*fd*r**2 - 5696*D1*Dd*K*f*fd*r*s + 3496*D1*Dd*K*f*fd*r - 2976*D1*Dd*K*f*fd*s**2 + 3656*D1*Dd*K*f*fd*s - 1084*D1*Dd*K*f*fd - 140*D1*Dd*f**3*r**2 - 360*D1*Dd*f**3*r*s + 230*D1*Dd*f**3*r - 220*D1*Dd*f**3*s**2 + 290*D1*Dd*f**3*s - 125*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1790*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 132*D1*Dd*f**2*r**2 - 376*D1*Dd*f**2*r*s + 226*D1*Dd*f**2*r - 244*D1*Dd*f**2*s**2 + 310*D1*Dd*f**2*s - 127*D1*Dd*f**2 + 1104*D1*Dd*f*fd*r**2 + 2208*D1*Dd*f*fd*r*s - 1364*D1*Dd*f*fd*r + 1104*D1*Dd*f*fd*s**2 - 1364*D1*Dd*f*fd*s + 402*D1*Dd*f*fd + 448*D1*Dd*f*g2*r*s - 112*D1*Dd*f*g2*r + 448*D1*Dd*f*g2*s**2 - 448*D1*Dd*f*g2*s + 112*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r*s + 56*D1*Dd*f*gd2*r - 448*D1*Dd*f*gd2*s**2 + 448*D1*Dd*f*gd2*s - 56*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 448*D1*Dd*fd*g2*s**2 + 672*D1*Dd*fd*g2*s - 336*D1*Dd*fd*g2 - 680*D1*Ddd*K*f**2*r**2 - 1424*D1*Ddd*K*f**2*r*s + 1036*D1*Ddd*K*f**2*r - 744*D1*Ddd*K*f**2*s**2 + 1084*D1*Ddd*K*f**2*s - 526*D1*Ddd*K*f**2 + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 276*D1*Ddd*f**2*r**2 + 552*D1*Ddd*f**2*r*s - 414*D1*Ddd*f**2*r + 276*D1*Ddd*f**2*s**2 - 414*D1*Ddd*f**2*s + 207*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r*s + 56*D1*Ddd*f*g2*r - 224*D1*Ddd*f*g2*s**2 + 224*D1*Ddd*f*g2*s - 56*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(2*r + 2*s - 1) - 7*f*(4*K*s**2 + 4*r**2 + 2*r*(2*K*s + K + 2*s - 4) - s*(2*K + 4) + 3) + 7*fd*(K*(r*(4*s - 3) + 4*s**2 - 5*s + 2) + 4*r**2 + r*(4*s - 2) - 1)) + Dd*f*(7*K*(2*r*(8*s + 1) + 16*s**2 - 12*s - 1) - 5*f*(4*r + 4*s - 3) + 112*r**2 + 14*r*(8*s - 13) - 84*s + 70)) - 2040*Dd**2*K*f**2*r**2 - 4272*Dd**2*K*f**2*r*s + 3108*Dd**2*K*f**2*r - 2232*Dd**2*K*f**2*s**2 + 3252*Dd**2*K*f**2*s - 1052*Dd**2*K*f**2 + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 330*Dd**2*f**3 + 828*Dd**2*f**2*r**2 + 1656*Dd**2*f**2*r*s - 1242*Dd**2*f**2*r + 828*Dd**2*f**2*s**2 - 1242*Dd**2*f**2*s + 414*Dd**2*f**2 - 672*Dd**2*f*g2*r*s + 168*Dd**2*f*g2*r - 672*Dd**2*f*g2*s**2 + 672*Dd**2*f*g2*s - 112*Dd**2*f*g2))/(105*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct*k1*k2**3*st**2*(112*C*D1**2*bd1**2*f*r**2 + 224*C*D1**2*bd1**2*f*r*s - 112*C*D1**2*bd1**2*f*r + 112*C*D1**2*bd1**2*f*s**2 - 112*C*D1**2*bd1**2*f*s + 764*C*D1**2*bd1*f**2*r**2 + 1512*C*D1**2*bd1*f**2*r*s - 1576*C*D1**2*bd1*f**2*r + 748*C*D1**2*bd1*f**2*s**2 - 1560*C*D1**2*bd1*f**2*s + 780*C*D1**2*bd1*f**2 - 2480*C*D1**2*bd1*f*fd*r**2 - 4480*C*D1**2*bd1*f*fd*r*s + 3624*C*D1**2*bd1*f*fd*r - 2000*C*D1**2*bd1*f*fd*s**2 + 3264*C*D1**2*bd1*f*fd*s - 1264*C*D1**2*bd1*f*fd - 620*C*D1**2*bdd1*f**2*r**2 - 1120*C*D1**2*bdd1*f**2*r*s + 1264*C*D1**2*bdd1*f**2*r - 500*C*D1**2*bdd1*f**2*s**2 + 1144*C*D1**2*bdd1*f**2*s - 572*C*D1**2*bdd1*f**2 + 108*C*D1**2*f**2*fd*r**2 + 864*C*D1**2*f**2*fd*r*s - 360*C*D1**2*f**2*fd*r + 756*C*D1**2*f**2*fd*s**2 - 792*C*D1**2*f**2*fd*s + 288*C*D1**2*f**2*fd - 828*C*D1**2*f**2*fdd*r**2 - 2016*C*D1**2*f**2*fdd*r*s + 1224*C*D1**2*f**2*fdd*r - 1188*C*D1**2*f**2*fdd*s**2 + 1464*C*D1**2*f**2*fdd*s - 672*C*D1**2*f**2*fdd - 1656*C*D1**2*f*fd**2*r**2 - 4032*C*D1**2*f*fd**2*r*s + 2448*C*D1**2*f*fd**2*r - 2376*C*D1**2*f*fd**2*s**2 + 2928*C*D1**2*f*fd**2*s - 672*C*D1**2*f*fd**2 - 4960*C*D1*Dd*bd1*f**2*r**2 - 8960*C*D1*Dd*bd1*f**2*r*s + 8656*C*D1*Dd*bd1*f**2*r - 4000*C*D1*Dd*bd1*f**2*s**2 + 7816*C*D1*Dd*bd1*f**2*s - 3672*C*D1*Dd*bd1*f**2 + 144*C*D1*Dd*f**3*r**2 + 1152*C*D1*Dd*f**3*r*s - 432*C*D1*Dd*f**3*r + 1008*C*D1*Dd*f**3*s**2 - 1080*C*D1*Dd*f**3*s + 324*C*D1*Dd*f**3 - 6624*C*D1*Dd*f**2*fd*r**2 - 16128*C*D1*Dd*f**2*fd*r*s + 10224*C*D1*Dd*f**2*fd*r - 9504*C*D1*Dd*f**2*fd*s**2 + 12264*C*D1*Dd*f**2*fd*s - 3912*C*D1*Dd*f**2*fd - 1104*C*D1*Ddd*f**3*r**2 - 2688*C*D1*Ddd*f**3*r*s + 1776*C*D1*Ddd*f**3*r - 1584*C*D1*Ddd*f**3*s**2 + 2136*C*D1*Ddd*f**3*s - 948*C*D1*Ddd*f**3 - 3312*C*Dd**2*f**3*r**2 - 8064*C*Dd**2*f**3*r*s + 5328*C*Dd**2*f**3*r - 4752*C*Dd**2*f**3*s**2 + 6408*C*Dd**2*f**3*s - 1896*C*Dd**2*f**3 - 1372*D1**2*K*bd1**2*f*r**2 - 2912*D1**2*K*bd1**2*f*r*s + 2996*D1**2*K*bd1**2*f*r - 1540*D1**2*K*bd1**2*f*s**2 + 3164*D1**2*K*bd1**2*f*s - 1624*D1**2*K*bd1**2*f - 126*D1**2*K*bd1*f**2*r**2 + 168*D1**2*K*bd1*f**2*r*s + 252*D1**2*K*bd1*f**2*r + 294*D1**2*K*bd1*f**2*s**2 - 168*D1**2*K*bd1*f**2*s - 126*D1**2*K*bd1*f**2 - 840*D1**2*K*bd1*f*fd*r**2 - 2688*D1**2*K*bd1*f*fd*r*s + 1512*D1**2*K*bd1*f*fd*r - 1848*D1**2*K*bd1*f*fd*s**2 + 2268*D1**2*K*bd1*f*fd*s - 672*D1**2*K*bd1*f*fd - 210*D1**2*K*bdd1*f**2*r**2 - 672*D1**2*K*bdd1*f**2*r*s + 420*D1**2*K*bdd1*f**2*r - 462*D1**2*K*bdd1*f**2*s**2 + 672*D1**2*K*bdd1*f**2*s - 210*D1**2*K*bdd1*f**2 + 630*D1**2*bd1**2*f**2*r**2 + 924*D1**2*bd1**2*f**2*r*s - 1092*D1**2*bd1**2*f**2*r + 294*D1**2*bd1**2*f**2*s**2 - 756*D1**2*bd1**2*f**2*s + 462*D1**2*bd1**2*f**2 + 518*D1**2*bd1**2*f*r**2 + 868*D1**2*bd1**2*f*r*s - 1036*D1**2*bd1**2*f*r + 350*D1**2*bd1**2*f*s**2 - 868*D1**2*bd1**2*f*s + 518*D1**2*bd1**2*f - 560*D1**2*bd1**2*g2*r**2 - 1120*D1**2*bd1**2*g2*r*s + 560*D1**2*bd1**2*g2*r - 560*D1**2*bd1**2*g2*s**2 + 560*D1**2*bd1**2*g2*s - 336*D1**2*bd1*bd2*f*r**2 - 672*D1**2*bd1*bd2*f*r*s + 672*D1**2*bd1*bd2*f*r - 336*D1**2*bd1*bd2*f*s**2 + 672*D1**2*bd1*bd2*f*s - 336*D1**2*bd1*bd2*f - 425*D1**2*bd1*f**2*r**2 - 842*D1**2*bd1*f**2*r*s + 762*D1**2*bd1*f**2*r - 417*D1**2*bd1*f**2*s**2 + 754*D1**2*bd1*f**2*s - 335*D1**2*bd1*f**2 + 1788*D1**2*bd1*f*fd*r**2 + 3000*D1**2*bd1*f*fd*r*s - 2466*D1**2*bd1*f*fd*r + 1212*D1**2*bd1*f*fd*s**2 - 2034*D1**2*bd1*f*fd*s + 822*D1**2*bd1*f*fd - 1484*D1**2*bd1*f*g2*r**2 - 3304*D1**2*bd1*f*g2*r*s + 2856*D1**2*bd1*f*g2*r - 1820*D1**2*bd1*f*g2*s**2 + 3192*D1**2*bd1*f*g2*s - 1596*D1**2*bd1*f*g2 + 2744*D1**2*bd1*f*gd2*r**2 + 5824*D1**2*bd1*f*gd2*r*s - 5992*D1**2*bd1*f*gd2*r + 3080*D1**2*bd1*f*gd2*s**2 - 6328*D1**2*bd1*f*gd2*s + 3248*D1**2*bd1*f*gd2 + 2744*D1**2*bd1*fd*g2*r**2 + 5824*D1**2*bd1*fd*g2*r*s - 2912*D1**2*bd1*fd*g2*r + 3080*D1**2*bd1*fd*g2*s**2 - 3080*D1**2*bd1*fd*g2*s - 84*D1**2*bd2*f**2*r**2 - 168*D1**2*bd2*f**2*r*s + 168*D1**2*bd2*f**2*r - 84*D1**2*bd2*f**2*s**2 + 168*D1**2*bd2*f**2*s - 84*D1**2*bd2*f**2 + 447*D1**2*bdd1*f**2*r**2 + 750*D1**2*bdd1*f**2*r*s - 822*D1**2*bdd1*f**2*r + 303*D1**2*bdd1*f**2*s**2 - 678*D1**2*bdd1*f**2*s + 339*D1**2*bdd1*f**2 + 1372*D1**2*bdd1*f*g2*r**2 + 2912*D1**2*bdd1*f*g2*r*s - 3248*D1**2*bdd1*f*g2*r + 1540*D1**2*bdd1*f*g2*s**2 - 3416*D1**2*bdd1*f*g2*s + 1708*D1**2*bdd1*f*g2 + 54*D1**2*f**2*fd*r**2 - 324*D1**2*f**2*fd*r*s + 72*D1**2*f**2*fd*r - 378*D1**2*f**2*fd*s**2 + 360*D1**2*f**2*fd*s - 108*D1**2*f**2*fd + 414*D1**2*f**2*fdd*r**2 + 1008*D1**2*f**2*fdd*r*s - 612*D1**2*f**2*fdd*r + 594*D1**2*f**2*fdd*s**2 - 732*D1**2*f**2*fdd*s + 336*D1**2*f**2*fdd + 252*D1**2*f**2*gd2*r**2 - 336*D1**2*f**2*gd2*r*s - 504*D1**2*f**2*gd2*r - 588*D1**2*f**2*gd2*s**2 + 336*D1**2*f**2*gd2*s + 252*D1**2*f**2*gd2 + 420*D1**2*f**2*gdd2*r**2 + 1344*D1**2*f**2*gdd2*r*s - 840*D1**2*f**2*gdd2*r + 924*D1**2*f**2*gdd2*s**2 - 1344*D1**2*f**2*gdd2*s + 420*D1**2*f**2*gdd2 + 828*D1**2*f*fd**2*r**2 + 2016*D1**2*f*fd**2*r*s - 1224*D1**2*f*fd**2*r + 1188*D1**2*f*fd**2*s**2 - 1464*D1**2*f*fd**2*s + 336*D1**2*f*fd**2 + 504*D1**2*f*fd*g2*r**2 - 672*D1**2*f*fd*g2*r*s + 336*D1**2*f*fd*g2*r - 1176*D1**2*f*fd*g2*s**2 + 1176*D1**2*f*fd*g2*s - 588*D1**2*f*fd*g2 + 1680*D1**2*f*fd*gd2*r**2 + 5376*D1**2*f*fd*gd2*r*s - 3024*D1**2*f*fd*gd2*r + 3696*D1**2*f*fd*gd2*s**2 - 4536*D1**2*f*fd*gd2*s + 1344*D1**2*f*fd*gd2 + 840*D1**2*f*fdd*g2*r**2 + 2688*D1**2*f*fdd*g2*r*s - 1344*D1**2*f*fdd*g2*r + 1848*D1**2*f*fdd*g2*s**2 - 1848*D1**2*f*fdd*g2*s + 924*D1**2*f*fdd*g2 + 840*D1**2*fd**2*g2*r**2 + 2688*D1**2*fd**2*g2*r*s - 1344*D1**2*fd**2*g2*r + 1848*D1**2*fd**2*g2*s**2 - 1848*D1**2*fd**2*g2*s - 1680*D1*Dd*K*bd1*f**2*r**2 - 5376*D1*Dd*K*bd1*f**2*r*s + 3192*D1*Dd*K*bd1*f**2*r - 3696*D1*Dd*K*bd1*f**2*s**2 + 4956*D1*Dd*K*bd1*f**2*s - 1512*D1*Dd*K*bd1*f**2 + 3576*D1*Dd*bd1*f**2*r**2 + 6000*D1*Dd*bd1*f**2*r*s - 5826*D1*Dd*bd1*f**2*r + 2424*D1*Dd*bd1*f**2*s**2 - 4818*D1*Dd*bd1*f**2*s + 2322*D1*Dd*bd1*f**2 + 10976*D1*Dd*bd1*f*g2*r**2 + 23296*D1*Dd*bd1*f*g2*r*s - 21392*D1*Dd*bd1*f*g2*r + 12320*D1*Dd*bd1*f*g2*s**2 - 22568*D1*Dd*bd1*f*g2*s + 9912*D1*Dd*bd1*f*g2 + 72*D1*Dd*f**3*r**2 - 432*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 504*D1*Dd*f**3*s**2 + 468*D1*Dd*f**3*s - 90*D1*Dd*f**3 + 3312*D1*Dd*f**2*fd*r**2 + 8064*D1*Dd*f**2*fd*r*s - 5112*D1*Dd*f**2*fd*r + 4752*D1*Dd*f**2*fd*s**2 - 6132*D1*Dd*f**2*fd*s + 1956*D1*Dd*f**2*fd + 1008*D1*Dd*f**2*g2*r**2 - 1344*D1*Dd*f**2*g2*r*s - 672*D1*Dd*f**2*g2*r - 2352*D1*Dd*f**2*g2*s**2 + 1848*D1*Dd*f**2*g2*s - 84*D1*Dd*f**2*g2 + 3360*D1*Dd*f**2*gd2*r**2 + 10752*D1*Dd*f**2*gd2*r*s - 6384*D1*Dd*f**2*gd2*r + 7392*D1*Dd*f**2*gd2*s**2 - 9912*D1*Dd*f**2*gd2*s + 3024*D1*Dd*f**2*gd2 + 6720*D1*Dd*f*fd*g2*r**2 + 21504*D1*Dd*f*fd*g2*r*s - 11424*D1*Dd*f*fd*g2*r + 14784*D1*Dd*f*fd*g2*s**2 - 16464*D1*Dd*f*fd*g2*s + 4536*D1*Dd*f*fd*g2 + 552*D1*Ddd*f**3*r**2 + 1344*D1*Ddd*f**3*r*s - 888*D1*Ddd*f**3*r + 792*D1*Ddd*f**3*s**2 - 1068*D1*Ddd*f**3*s + 474*D1*Ddd*f**3 + 1680*D1*Ddd*f**2*g2*r**2 + 5376*D1*Ddd*f**2*g2*r*s - 3024*D1*Ddd*f**2*g2*r + 3696*D1*Ddd*f**2*g2*s**2 - 4536*D1*Ddd*f**2*g2*s + 1764*D1*Ddd*f**2*g2 + 28*D1*b2*(bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 1656*Dd**2*f**3*r**2 + 4032*Dd**2*f**3*r*s - 2664*Dd**2*f**3*r + 2376*Dd**2*f**3*s**2 - 3204*Dd**2*f**3*s + 948*Dd**2*f**3 + 5040*Dd**2*f**2*g2*r**2 + 16128*Dd**2*f**2*g2*r*s - 9072*Dd**2*f**2*g2*r + 11088*Dd**2*f**2*g2*s**2 - 13608*Dd**2*f**2*g2*s + 3528*Dd**2*f**2*g2 + 14*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-16*C*D1**2*fd*r**2 - 32*C*D1**2*fd*r*s + 32*C*D1**2*fd*r - 16*C*D1**2*fd*s**2 + 32*C*D1**2*fd*s - 16*C*D1**2*fd + 8*C*D1**2*fdd*r**2 + 16*C*D1**2*fdd*r*s - 16*C*D1**2*fdd*r + 8*C*D1**2*fdd*s**2 - 16*C*D1**2*fdd*s + 8*C*D1**2*fdd - 64*C*D1*Dd*f*r**2 - 128*C*D1*Dd*f*r*s + 96*C*D1*Dd*f*r - 64*C*D1*Dd*f*s**2 + 96*C*D1*Dd*f*s - 48*C*D1*Dd*f + 64*C*D1*Dd*fd*r**2 + 128*C*D1*Dd*fd*r*s - 112*C*D1*Dd*fd*r + 64*C*D1*Dd*fd*s**2 - 112*C*D1*Dd*fd*s + 48*C*D1*Dd*fd + 32*C*D1*Ddd*f*r**2 + 64*C*D1*Ddd*f*r*s - 48*C*D1*Ddd*f*r + 32*C*D1*Ddd*f*s**2 - 48*C*D1*Ddd*f*s + 24*C*D1*Ddd*f + 96*C*Dd**2*f*r**2 + 192*C*Dd**2*f*r*s - 144*C*Dd**2*f*r + 96*C*Dd**2*f*s**2 - 144*C*Dd**2*f*s + 48*C*Dd**2*f + 106*D1**2*K*fd*r**2 + 236*D1**2*K*fd*r*s - 32*D1**2*K*fd*r + 130*D1**2*K*fd*s**2 - 32*D1**2*K*fd*s + 16*D1**2*K*fd - 98*D1**2*K*fdd*r**2 - 208*D1**2*K*fdd*r*s - 24*D1**2*K*fdd*r - 110*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 2*D1**2*bdd1*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 78*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 90*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 45*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 132*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 45*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 132*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s - 9*D1**2*fd*r**2 - 14*D1**2*fd*r*s - 4*D1**2*fd*r - 5*D1**2*fd*s**2 - 4*D1**2*fd*s + 2*D1**2*fd + 37*D1**2*fdd*r**2 + 62*D1**2*fdd*r*s + 12*D1**2*fdd*r + 25*D1**2*fdd*s**2 + 12*D1**2*fdd*s - 6*D1**2*fdd + 80*D1**2*gd2*r**2 + 160*D1**2*gd2*r*s - 160*D1**2*gd2*r + 80*D1**2*gd2*s**2 - 160*D1**2*gd2*s + 80*D1**2*gd2 - 40*D1**2*gdd2*r**2 - 80*D1**2*gdd2*r*s + 80*D1**2*gdd2*r - 40*D1**2*gdd2*s**2 + 80*D1**2*gdd2*s - 40*D1**2*gdd2 + 424*D1*Dd*K*f*r**2 + 944*D1*Dd*K*f*r*s - 660*D1*Dd*K*f*r + 520*D1*Dd*K*f*s**2 - 732*D1*Dd*K*f*s + 342*D1*Dd*K*f - 784*D1*Dd*K*fd*r**2 - 1664*D1*Dd*K*fd*r*s + 504*D1*Dd*K*fd*r - 880*D1*Dd*K*fd*s**2 + 540*D1*Dd*K*fd*s + 72*D1*Dd*K*fd - 156*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 93*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1056*D1*Dd*f*fd*r*s - 852*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 612*D1*Dd*f*fd*s + 246*D1*Dd*f*fd - 36*D1*Dd*f*r**2 - 56*D1*Dd*f*r*s + 50*D1*Dd*f*r - 20*D1*Dd*f*s**2 + 38*D1*Dd*f*s - 23*D1*Dd*f + 296*D1*Dd*fd*r**2 + 496*D1*Dd*fd*r*s - 162*D1*Dd*fd*r + 200*D1*Dd*fd*s**2 - 126*D1*Dd*fd*s - 36*D1*Dd*fd + 320*D1*Dd*g2*r**2 + 640*D1*Dd*g2*r*s - 480*D1*Dd*g2*r + 320*D1*Dd*g2*s**2 - 480*D1*Dd*g2*s + 240*D1*Dd*g2 - 320*D1*Dd*gd2*r**2 - 640*D1*Dd*gd2*r*s + 560*D1*Dd*gd2*r - 320*D1*Dd*gd2*s**2 + 560*D1*Dd*gd2*s - 240*D1*Dd*gd2 - 392*D1*Ddd*K*f*r**2 - 832*D1*Ddd*K*f*r*s + 600*D1*Ddd*K*f*r - 440*D1*Ddd*K*f*s**2 + 636*D1*Ddd*K*f*s - 306*D1*Ddd*K*f + 180*D1*Ddd*f**2*r**2 + 264*D1*Ddd*f**2*r*s - 246*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 174*D1*Ddd*f**2*s + 111*D1*Ddd*f**2 + 148*D1*Ddd*f*r**2 + 248*D1*Ddd*f*r*s - 210*D1*Ddd*f*r + 100*D1*Ddd*f*s**2 - 174*D1*Ddd*f*s + 99*D1*Ddd*f - 160*D1*Ddd*g2*r**2 - 320*D1*Ddd*g2*r*s + 240*D1*Ddd*g2*r - 160*D1*Ddd*g2*s**2 + 240*D1*Ddd*g2*s - 120*D1*Ddd*g2 + 4*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-10*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 1176*Dd**2*K*f*r**2 - 2496*Dd**2*K*f*r*s + 1800*Dd**2*K*f*r - 1320*Dd**2*K*f*s**2 + 1908*Dd**2*K*f*s - 612*Dd**2*K*f + 540*Dd**2*f**2*r**2 + 792*Dd**2*f**2*r*s - 738*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 522*Dd**2*f**2*s + 222*Dd**2*f**2 + 444*Dd**2*f*r**2 + 744*Dd**2*f*r*s - 630*Dd**2*f*r + 300*Dd**2*f*s**2 - 522*Dd**2*f*s + 198*Dd**2*f - 480*Dd**2*g2*r**2 - 960*Dd**2*g2*r*s + 720*Dd**2*g2*r - 480*Dd**2*g2*s**2 + 720*Dd**2*g2*s - 240*Dd**2*g2) - b1*(-112*C*D1**2*bdd1*f*r**2 - 224*C*D1**2*bdd1*f*r*s + 112*C*D1**2*bdd1*f*r - 112*C*D1**2*bdd1*f*s**2 + 112*C*D1**2*bdd1*f*s - 56*C*D1**2*bdd1*f - 1528*C*D1**2*f*fd*r**2 - 3024*C*D1**2*f*fd*r*s + 1464*C*D1**2*f*fd*r - 1496*C*D1**2*f*fd*s**2 + 1448*C*D1**2*f*fd*s - 732*C*D1**2*f*fd + 1240*C*D1**2*f*fdd*r**2 + 2240*C*D1**2*f*fdd*r*s - 1096*C*D1**2*f*fdd*r + 1000*C*D1**2*f*fdd*s**2 - 976*C*D1**2*f*fdd*s + 548*C*D1**2*f*fdd + 1240*C*D1**2*fd**2*r**2 + 2240*C*D1**2*fd**2*r*s - 1096*C*D1**2*fd**2*r + 1000*C*D1**2*fd**2*s**2 - 976*C*D1**2*fd**2*s - 144*C*D1**2*fd**2 - 3056*C*D1*Dd*f**2*r**2 - 6048*C*D1*Dd*f**2*r*s + 4568*C*D1*Dd*f**2*r - 2992*C*D1*Dd*f**2*s**2 + 4520*C*D1*Dd*f**2*s - 2276*C*D1*Dd*f**2 + 9920*C*D1*Dd*f*fd*r**2 + 17920*C*D1*Dd*f*fd*r*s - 11584*C*D1*Dd*f*fd*r + 8000*C*D1*Dd*f*fd*s**2 - 10384*C*D1*Dd*f*fd*s + 3168*C*D1*Dd*f*fd + 2480*C*D1*Ddd*f**2*r**2 + 4480*C*D1*Ddd*f**2*r*s - 3600*C*D1*Ddd*f**2*r + 2000*C*D1*Ddd*f**2*s**2 - 3240*C*D1*Ddd*f**2*s + 1740*C*D1*Ddd*f**2 + 7440*C*Dd**2*f**2*r**2 + 13440*C*Dd**2*f**2*r*s - 10800*C*Dd**2*f**2*r + 6000*C*Dd**2*f**2*s**2 - 9720*C*Dd**2*f**2*s + 3480*C*Dd**2*f**2 + 1372*D1**2*K*bdd1*f*r**2 + 2912*D1**2*K*bdd1*f*r*s - 2996*D1**2*K*bdd1*f*r + 1540*D1**2*K*bdd1*f*s**2 - 3164*D1**2*K*bdd1*f*s + 1540*D1**2*K*bdd1*f + 252*D1**2*K*f*fd*r**2 - 336*D1**2*K*f*fd*r*s + 168*D1**2*K*f*fd*r - 588*D1**2*K*f*fd*s**2 + 588*D1**2*K*f*fd*s - 294*D1**2*K*f*fd + 420*D1**2*K*f*fdd*r**2 + 1344*D1**2*K*f*fdd*r*s - 672*D1**2*K*f*fdd*r + 924*D1**2*K*f*fdd*s**2 - 924*D1**2*K*f*fdd*s + 462*D1**2*K*f*fdd + 420*D1**2*K*fd**2*r**2 + 1344*D1**2*K*fd**2*r*s - 672*D1**2*K*fd**2*r + 924*D1**2*K*fd**2*s**2 - 924*D1**2*K*fd**2*s - 196*D1**2*b2*fd*r**2 - 392*D1**2*b2*fd*r*s - 196*D1**2*b2*fd*s**2 + 168*D1**2*b2*fdd*r**2 + 336*D1**2*b2*fdd*r*s + 168*D1**2*b2*fdd*s**2 + 28*D1**2*bd1**2*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 630*D1**2*bdd1*f**2*r**2 - 924*D1**2*bdd1*f**2*r*s + 1092*D1**2*bdd1*f**2*r - 294*D1**2*bdd1*f**2*s**2 + 756*D1**2*bdd1*f**2*s - 462*D1**2*bdd1*f**2 - 518*D1**2*bdd1*f*r**2 - 868*D1**2*bdd1*f*r*s + 1036*D1**2*bdd1*f*r - 350*D1**2*bdd1*f*s**2 + 868*D1**2*bdd1*f*s - 476*D1**2*bdd1*f + 560*D1**2*bdd1*g2*r**2 + 1120*D1**2*bdd1*g2*r*s - 560*D1**2*bdd1*g2*r + 560*D1**2*bdd1*g2*s**2 - 560*D1**2*bdd1*g2*s + 280*D1**2*bdd1*g2 + 168*D1**2*bdd2*f*r**2 + 336*D1**2*bdd2*f*r*s - 336*D1**2*bdd2*f*r + 168*D1**2*bdd2*f*s**2 - 336*D1**2*bdd2*f*s + 168*D1**2*bdd2*f + 850*D1**2*f*fd*r**2 + 1684*D1**2*f*fd*r*s - 930*D1**2*f*fd*r + 834*D1**2*f*fd*s**2 - 922*D1**2*f*fd*s + 507*D1**2*f*fd - 894*D1**2*f*fdd*r**2 - 1500*D1**2*f*fdd*r*s + 822*D1**2*f*fdd*r - 606*D1**2*f*fdd*s**2 + 678*D1**2*f*fdd*s - 411*D1**2*f*fdd + 1484*D1**2*f*gd2*r**2 + 3304*D1**2*f*gd2*r*s - 2968*D1**2*f*gd2*r + 1820*D1**2*f*gd2*s**2 - 3304*D1**2*f*gd2*s + 1484*D1**2*f*gd2 - 1372*D1**2*f*gdd2*r**2 - 2912*D1**2*f*gdd2*r*s + 2744*D1**2*f*gdd2*r - 1540*D1**2*f*gdd2*s**2 + 2912*D1**2*f*gdd2*s - 1372*D1**2*f*gdd2 - 894*D1**2*fd**2*r**2 - 1500*D1**2*fd**2*r*s + 822*D1**2*fd**2*r - 606*D1**2*fd**2*s**2 + 678*D1**2*fd**2*s + 72*D1**2*fd**2 + 1484*D1**2*fd*g2*r**2 + 3304*D1**2*fd*g2*r*s - 448*D1**2*fd*g2*r + 1820*D1**2*fd*g2*s**2 - 448*D1**2*fd*g2*s + 224*D1**2*fd*g2 - 2744*D1**2*fd*gd2*r**2 - 5824*D1**2*fd*gd2*r*s + 2408*D1**2*fd*gd2*r - 3080*D1**2*fd*gd2*s**2 + 2576*D1**2*fd*gd2*s + 336*D1**2*fd*gd2 - 1372*D1**2*fdd*g2*r**2 - 2912*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*r - 1540*D1**2*fdd*g2*s**2 - 336*D1**2*fdd*g2*s + 168*D1**2*fdd*g2 + 504*D1*Dd*K*f**2*r**2 - 672*D1*Dd*K*f**2*r*s - 336*D1*Dd*K*f**2*r - 1176*D1*Dd*K*f**2*s**2 + 924*D1*Dd*K*f**2*s - 42*D1*Dd*K*f**2 + 3360*D1*Dd*K*f*fd*r**2 + 10752*D1*Dd*K*f*fd*r*s - 5712*D1*Dd*K*f*fd*r + 7392*D1*Dd*K*f*fd*s**2 - 8232*D1*Dd*K*f*fd*s + 2268*D1*Dd*K*f*fd - 784*D1*Dd*b2*f*r**2 - 1568*D1*Dd*b2*f*r*s + 1176*D1*Dd*b2*f*r - 784*D1*Dd*b2*f*s**2 + 1176*D1*Dd*b2*f*s - 588*D1*Dd*b2*f + 1344*D1*Dd*b2*fd*r**2 + 2688*D1*Dd*b2*fd*r*s - 1008*D1*Dd*b2*fd*r + 1344*D1*Dd*b2*fd*s**2 - 1008*D1*Dd*b2*fd*s + 1700*D1*Dd*f**2*r**2 + 3368*D1*Dd*f**2*r*s - 2542*D1*Dd*f**2*r + 1668*D1*Dd*f**2*s**2 - 2518*D1*Dd*f**2*s + 1267*D1*Dd*f**2 - 7152*D1*Dd*f*fd*r**2 - 12000*D1*Dd*f*fd*r*s + 8364*D1*Dd*f*fd*r - 4848*D1*Dd*f*fd*s**2 + 6924*D1*Dd*f*fd*s - 2322*D1*Dd*f*fd + 5936*D1*Dd*f*g2*r**2 + 13216*D1*Dd*f*g2*r*s - 9240*D1*Dd*f*g2*r + 7280*D1*Dd*f*g2*s**2 - 10248*D1*Dd*f*g2*s + 4788*D1*Dd*f*g2 - 10976*D1*Dd*f*gd2*r**2 - 23296*D1*Dd*f*gd2*r*s + 19376*D1*Dd*f*gd2*r - 12320*D1*Dd*f*gd2*s**2 + 20552*D1*Dd*f*gd2*s - 8400*D1*Dd*f*gd2 - 10976*D1*Dd*fd*g2*r**2 - 23296*D1*Dd*fd*g2*r*s + 7056*D1*Dd*fd*g2*r - 12320*D1*Dd*fd*g2*s**2 + 7560*D1*Dd*fd*g2*s + 1008*D1*Dd*fd*g2 + 840*D1*Ddd*K*f**2*r**2 + 2688*D1*Ddd*K*f**2*r*s - 1512*D1*Ddd*K*f**2*r + 1848*D1*Ddd*K*f**2*s**2 - 2268*D1*Ddd*K*f**2*s + 882*D1*Ddd*K*f**2 + 672*D1*Ddd*b2*f*r**2 + 1344*D1*Ddd*b2*f*r*s - 1008*D1*Ddd*b2*f*r + 672*D1*Ddd*b2*f*s**2 - 1008*D1*Ddd*b2*f*s + 504*D1*Ddd*b2*f - 1788*D1*Ddd*f**2*r**2 - 3000*D1*Ddd*f**2*r*s + 2538*D1*Ddd*f**2*r - 1212*D1*Ddd*f**2*s**2 + 2106*D1*Ddd*f**2*s - 1197*D1*Ddd*f**2 - 5488*D1*Ddd*f*g2*r**2 - 11648*D1*Ddd*f*g2*r*s + 8400*D1*Ddd*f*g2*r - 6160*D1*Ddd*f*g2*s**2 + 8904*D1*Ddd*f*g2*s - 4284*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(3*f**2*(13*r**2 + 2*r*(9*s - 10) + 5*s**2 - 12*s + 8) + f*(8*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 106*K*r**2 - 236*K*r*s + 208*K*r - 130*K*s**2 + 232*K*s - 110*K - 6*fd*(30*r**2 + 44*r*s - 41*r + 14*s**2 - 29*s + 13) + 9*r**2 + 14*r*s - 18*r + 5*s**2 - 14*s + 8) - 2*fd*(4*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-98*r**2 - 208*r*s + 95*r - 110*s**2 + 101*s + 6) + 37*r**2 + 62*r*s - 31*r + 25*s**2 - 25*s - 3) - 40*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(3*f**2*(60*r**2 + r*(88*s - 93) + 28*s**2 - 65*s + 35) + f*(4*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(392*r**2 + 104*r*(8*s - 7) + 440*s**2 - 770*s + 327) + 148*r**2 + 248*r*s - 253*r + 100*s**2 - 211*s + 105) - 20*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 28*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 2520*Dd**2*K*f**2*r**2 + 8064*Dd**2*K*f**2*r*s - 4536*Dd**2*K*f**2*r + 5544*Dd**2*K*f**2*s**2 - 6804*Dd**2*K*f**2*s + 1764*Dd**2*K*f**2 + 2016*Dd**2*b2*f*r**2 + 4032*Dd**2*b2*f*r*s - 3024*Dd**2*b2*f*r + 2016*Dd**2*b2*f*s**2 - 3024*Dd**2*b2*f*s + 1008*Dd**2*b2*f - 5364*Dd**2*f**2*r**2 - 9000*Dd**2*f**2*r*s + 7614*Dd**2*f**2*r - 3636*Dd**2*f**2*s**2 + 6318*Dd**2*f**2*s - 2394*Dd**2*f**2 - 16464*Dd**2*f*g2*r**2 - 34944*Dd**2*f*g2*r*s + 25200*Dd**2*f*g2*r - 18480*Dd**2*f*g2*s**2 + 26712*Dd**2*f*g2*s - 8568*Dd**2*f*g2))/(105*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct*k1*k2**3*(D1*(70*D1*b2*bd1*f*(r + s - 1)**2 + 14*D1*bd1**2*(r + s - 1)*(25*K*f*(r + s - 1) - f*(12*C - 6)*(r + s) + 20*g2*(r + s)) - D1*bd1*(3*f**2*(r + s - 1)*(6*C*(r - 7*s + 7) + 11*r + 21*s - 21) - f*fd*(12*C - 6)*(94*r**2 + r*(164*s - 129) + 70*s**2 - 111*s + 41) + 70*f*(3*g2 + 10*gd2)*(r + s - 1)**2 + 700*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bdd1*f*(f*(6*C - 3)*(47*r + 35*s - 35) - 350*g2*(r + s - 1))*(r + s - 1) + 2*Dd*bd1*f*(f*(6*C - 3)*(188*r**2 + r*(328*s - 299) + 140*s**2 - 257*s + 117) - 350*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + 35*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(-8*K + f + 3) - 2*Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(D1**2*(-10*K*bdd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(-16*C*(r + s - 1)**2 + 15*K*s**2 + r**2*(15*K + 3) + 2*r*(15*K*s + 8*s - 13) + 13*s**2 - 26*s + 13) + fdd*(-12*C*(r + s - 1)**2 + 25*K*s**2 + r**2*(25*K + 6) + 2*r*(25*K*s + 6*s - 6) + 6*s**2 - 12*s + 6) + 80*gd2*(r + s - 1)**2 + 20*gdd2*(r + s - 1)**2) + 5*D1*bd1*(D1*(-8*K + f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 4*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(f*(-16*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 15*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 12*r**2 + 64*r*s - 28*r + 52*s**2 - 58*s + 19) - 2*fd*(4*r + 4*s - 3)*(12*C*(r + s - 1) - 25*K*s - r*(25*K + 6) - 6*s + 6) + 80*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 40*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*(f*(-12*C + 25*K + 6) + 20*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(-12*C + 25*K + 6) + 20*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - b1*(168*C*D1**2*bdd1*f*r**2 + 336*C*D1**2*bdd1*f*r*s - 168*C*D1**2*bdd1*f*r + 168*C*D1**2*bdd1*f*s**2 - 168*C*D1**2*bdd1*f*s + 84*C*D1**2*bdd1*f + 36*C*D1**2*f*fd*r**2 - 216*C*D1**2*f*fd*r*s - 36*C*D1**2*f*fd*r - 252*C*D1**2*f*fd*s**2 + 108*C*D1**2*f*fd*s + 18*C*D1**2*f*fd - 564*C*D1**2*f*fdd*r**2 - 984*C*D1**2*f*fdd*r*s + 564*C*D1**2*f*fdd*r - 420*C*D1**2*f*fdd*s**2 + 492*C*D1**2*f*fdd*s - 282*C*D1**2*f*fdd - 564*C*D1**2*fd**2*r**2 - 984*C*D1**2*fd**2*r*s + 564*C*D1**2*fd**2*r - 420*C*D1**2*fd**2*s**2 + 492*C*D1**2*fd**2*s + 72*C*D1*Dd*f**2*r**2 - 432*C*D1*Dd*f**2*r*s + 36*C*D1*Dd*f**2*r - 504*C*D1*Dd*f**2*s**2 + 468*C*D1*Dd*f**2*s - 90*C*D1*Dd*f**2 - 4512*C*D1*Dd*f*fd*r**2 - 7872*C*D1*Dd*f*fd*r*s + 5496*C*D1*Dd*f*fd*r - 3360*C*D1*Dd*f*fd*s**2 + 4776*C*D1*Dd*f*fd*s - 1620*C*D1*Dd*f*fd - 1128*C*D1*Ddd*f**2*r**2 - 1968*C*D1*Ddd*f**2*r*s + 1620*C*D1*Ddd*f**2*r - 840*C*D1*Ddd*f**2*s**2 + 1404*C*D1*Ddd*f**2*s - 774*C*D1*Ddd*f**2 - 3384*C*Dd**2*f**2*r**2 - 5904*C*Dd**2*f**2*r*s + 4860*C*Dd**2*f**2*r - 2520*C*Dd**2*f**2*s**2 + 4212*C*Dd**2*f**2*s - 1548*C*Dd**2*f**2 + 140*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 350*D1**2*K*bdd1*f*r**2 - 700*D1**2*K*bdd1*f*r*s + 700*D1**2*K*bdd1*f*r - 350*D1**2*K*bdd1*f*s**2 + 700*D1**2*K*bdd1*f*s - 350*D1**2*K*bdd1*f - 70*D1**2*b2*fd*r**2 - 140*D1**2*b2*fd*r*s - 70*D1**2*b2*fd*s**2 - 70*D1**2*bd2*f*(r + s - 1)**2 - 84*D1**2*bdd1*f*r**2 - 168*D1**2*bdd1*f*r*s + 84*D1**2*bdd1*f*r - 84*D1**2*bdd1*f*s**2 + 84*D1**2*bdd1*f*s - 42*D1**2*bdd1*f - 280*D1**2*bdd1*g2*r**2 - 560*D1**2*bdd1*g2*r*s + 280*D1**2*bdd1*g2*r - 280*D1**2*bdd1*g2*s**2 + 280*D1**2*bdd1*g2*s - 140*D1**2*bdd1*g2 + 66*D1**2*f*fd*r**2 + 192*D1**2*f*fd*r*s - 66*D1**2*f*fd*r + 126*D1**2*f*fd*s**2 - 96*D1**2*f*fd*s + 33*D1**2*f*fd + 282*D1**2*f*fdd*r**2 + 492*D1**2*f*fdd*r*s - 282*D1**2*f*fdd*r + 210*D1**2*f*fdd*s**2 - 246*D1**2*f*fdd*s + 141*D1**2*f*fdd + 210*D1**2*f*gd2*r**2 + 420*D1**2*f*gd2*r*s - 420*D1**2*f*gd2*r + 210*D1**2*f*gd2*s**2 - 420*D1**2*f*gd2*s + 210*D1**2*f*gd2 + 350*D1**2*f*gdd2*r**2 + 700*D1**2*f*gdd2*r*s - 700*D1**2*f*gdd2*r + 350*D1**2*f*gdd2*s**2 - 700*D1**2*f*gdd2*s + 350*D1**2*f*gdd2 + 282*D1**2*fd**2*r**2 + 492*D1**2*fd**2*r*s - 282*D1**2*fd**2*r + 210*D1**2*fd**2*s**2 - 246*D1**2*fd**2*s + 210*D1**2*fd*g2*r**2 + 420*D1**2*fd*g2*r*s + 210*D1**2*fd*g2*s**2 + 700*D1**2*fd*gd2*r**2 + 1400*D1**2*fd*gd2*r*s - 700*D1**2*fd*gd2*r + 700*D1**2*fd*gd2*s**2 - 700*D1**2*fd*gd2*s + 350*D1**2*fdd*g2*r**2 + 700*D1**2*fdd*g2*r*s + 350*D1**2*fdd*g2*s**2 - 280*D1*Dd*b2*f*r**2 - 560*D1*Dd*b2*f*r*s + 420*D1*Dd*b2*f*r - 280*D1*Dd*b2*f*s**2 + 420*D1*Dd*b2*f*s - 210*D1*Dd*b2*f + 132*D1*Dd*f**2*r**2 + 384*D1*Dd*f**2*r*s - 228*D1*Dd*f**2*r + 252*D1*Dd*f**2*s**2 - 318*D1*Dd*f**2*s + 129*D1*Dd*f**2 + 2256*D1*Dd*f*fd*r**2 + 3936*D1*Dd*f*fd*r*s - 2748*D1*Dd*f*fd*r + 1680*D1*Dd*f*fd*s**2 - 2388*D1*Dd*f*fd*s + 810*D1*Dd*f*fd + 840*D1*Dd*f*g2*r**2 + 1680*D1*Dd*f*g2*r*s - 1260*D1*Dd*f*g2*r + 840*D1*Dd*f*g2*s**2 - 1260*D1*Dd*f*g2*s + 630*D1*Dd*f*g2 + 2800*D1*Dd*f*gd2*r**2 + 5600*D1*Dd*f*gd2*r*s - 4900*D1*Dd*f*gd2*r + 2800*D1*Dd*f*gd2*s**2 - 4900*D1*Dd*f*gd2*s + 2100*D1*Dd*f*gd2 + 2800*D1*Dd*fd*g2*r**2 + 5600*D1*Dd*fd*g2*r*s - 2100*D1*Dd*fd*g2*r + 2800*D1*Dd*fd*g2*s**2 - 2100*D1*Dd*fd*g2*s + 564*D1*Ddd*f**2*r**2 + 984*D1*Ddd*f**2*r*s - 810*D1*Ddd*f**2*r + 420*D1*Ddd*f**2*s**2 - 702*D1*Ddd*f**2*s + 387*D1*Ddd*f**2 + 1400*D1*Ddd*f*g2*r**2 + 2800*D1*Ddd*f*g2*r*s - 2100*D1*Ddd*f*g2*r + 1400*D1*Ddd*f*g2*s**2 - 2100*D1*Ddd*f*g2*s + 1050*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(f*(16*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 30*K*(r + s - 1)**2 - 6*r**2 - 32*r*s - 4*r - 26*s**2 + 16*s - 3) + 4*fd*(r + s - 1)*(6*C*(2*r + 2*s - 1) - 25*K*s - r*(25*K + 6) - 6*s + 3) - 40*g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 40*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(f*(6*C*(2*r + 2*s - 1) - 25*K*(r + s - 1) - 6*r - 6*s + 3) - 10*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 1692*Dd**2*f**2*r**2 + 2952*Dd**2*f**2*r*s - 2430*Dd**2*f**2*r + 1260*Dd**2*f**2*s**2 - 2106*Dd**2*f**2*s + 774*Dd**2*f**2 + 4200*Dd**2*f*g2*r**2 + 8400*Dd**2*f*g2*r*s - 6300*Dd**2*f*g2*r + 4200*Dd**2*f*g2*s**2 - 6300*Dd**2*f*g2*s + 2100*Dd**2*f*g2))/(105*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct*k1*st**6*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 18*fd*(2*s**2 - 2*s + 1) - 9*fdd*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) - f*(2*fd*(s**2*(21*bd1 - 3) + s*(2 - 7*bd1) - 1) + fdd*(3*s**2 - 2*s + 1) + s**2*(-18*bd1 + 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) - D1*f*(2*Dd*(f*(s**2*(28*bd1 - 4) + s*(2 - 7*bd1) - 1) + (4*s - 1)*(9*bd1*s + fd*(3*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2*k3**2) - 12*D1**2*Pk2*Pk3*ct*k1*st**4*(-D1*f*s*(2*D1*bd1**2*s*(5*f + 7) + D1*bdd1*f*s - 2*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*(-4*f*s + f))) + b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) - f*(fd*(s**2*(40*bd1 - 4) + s*(4 - 20*bd1) - 2) + fdd*(2*s**2 - 2*s + 1) + s**2*(-28*bd1 + 14*bdd1)) - 2*fd*s*(14*bd1 + fd)*(s - 1)) - D1*f*(2*Dd*(f*(s**2*(40*bd1 - 4) + s*(2 - 10*bd1) - 1) + (4*s - 1)*(14*bd1*s + fd*(2*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2**3) - 2*D1**2*Pk2*Pk3*ct*k1*st**2*(D1*f*s*(14*D1*bd1**2*(s*(21*f + 29) + 2) + 53*D1*bdd1*f*s + bd1*(-85*D1*f*s + 106*D1*fd*(2*s - 1) + 106*Dd*f*(4*s - 1))) + 14*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + 7*b1**2*(-2*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 66*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 33*D1**2*f*fd + 42*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd + 42*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s - 43*D1**2*fd*s**2 + 94*D1**2*fd*s - 47*D1**2*fd + 29*D1**2*fdd*s**2 - 62*D1**2*fdd*s + 31*D1**2*fdd - 132*D1*Dd*f**2*s**2 + 66*D1*Dd*f**2*s - 33*D1*Dd*f**2 + 336*D1*Dd*f*fd*s**2 - 252*D1*Dd*f*fd*s + 42*D1*Dd*f*fd - 172*D1*Dd*f*s**2 + 86*D1*Dd*f*s - 43*D1*Dd*f + 232*D1*Dd*fd*s**2 - 306*D1*Dd*fd*s + 62*D1*Dd*fd + 84*D1*Ddd*f**2*s**2 - 42*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 + 116*D1*Ddd*f*s**2 - 58*D1*Ddd*f*s + 29*D1*Ddd*f + 4*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) + 252*Dd**2*f**2*s**2 - 126*Dd**2*f**2*s + 348*Dd**2*f*s**2 - 174*Dd**2*f*s) + b1*(-28*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) + 14*D1**2*bdd1*f*(s**2*(21*f + 29) + 2*s - 1) - 170*D1**2*f*fd*s**2 + 170*D1**2*f*fd*s - 85*D1**2*f*fd + 106*D1**2*f*fdd*s**2 - 106*D1**2*f*fdd*s + 53*D1**2*f*fdd + 106*D1**2*fd**2*s**2 - 106*D1**2*fd**2*s - 340*D1*Dd*f**2*s**2 + 170*D1*Dd*f**2*s - 85*D1*Dd*f**2 + 848*D1*Dd*f*fd*s**2 - 636*D1*Dd*f*fd*s + 106*D1*Dd*f*fd + 212*D1*Ddd*f**2*s**2 - 106*D1*Ddd*f**2*s + 53*D1*Ddd*f**2 - 14*D1*bd1*(D1*(33*f**2*s**2 + f*(s**2*(43 - 84*fd) + s*(42*fd + 4) - 2) + 2*fd*s*(30 - 29*s)) - 2*Dd*f*(4*s - 1)*(s*(21*f + 29) + 1)) + 636*Dd**2*f**2*s**2 - 318*Dd**2*f**2*s))/(105*d**2*k2**3) + D1**2*Pk2*Pk3*ct*k1*(D1*f*s*(2*D1*bd1**2*(s*(15*f + 14) + 11) + 11*D1*bdd1*f*s - 11*bd1*(D1*f*s + D1*fd*(2 - 4*s) + Dd*f*(2 - 8*s))) + 5*b1**3*(D1**2*s**2*(5*fd - 3*fdd) + D1*Dd*(5*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 28) + s*(6*fd - 14) + 7) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + b1**2*(-5*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 30*D1**2*f*fd*s**2 + 30*D1**2*f*fd*s - 15*D1**2*f*fd + 30*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s + 15*D1**2*f*fdd + 30*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s - 8*D1**2*fd*s**2 + 50*D1**2*fd*s - 25*D1**2*fd + 14*D1**2*fdd*s**2 - 50*D1**2*fdd*s + 25*D1**2*fdd - 60*D1*Dd*f**2*s**2 + 30*D1*Dd*f**2*s - 15*D1*Dd*f**2 + 240*D1*Dd*f*fd*s**2 - 180*D1*Dd*f*fd*s + 30*D1*Dd*f*fd - 32*D1*Dd*f*s**2 + 16*D1*Dd*f*s - 8*D1*Dd*f + 112*D1*Dd*fd*s**2 - 228*D1*Dd*fd*s + 50*D1*Dd*fd + 60*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 56*D1*Ddd*f*s**2 - 28*D1*Ddd*f*s + 14*D1*Ddd*f + 5*D1*bd1*(D1*(5*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 21) + s*(6*fd - 14) + 7) - 2*Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) + 180*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 168*Dd**2*f*s**2 - 84*Dd**2*f*s) + b1*(-10*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) + D1**2*bdd1*f*(s**2*(30*f + 28) + 22*s - 11) - 11*D1**2*(f*(fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*bd1*(-D1*(30*f**2*s**2 + f*(-s**2*(120*fd - 16) + s*(60*fd + 34) - 17) + 2*fd*s*(39 - 28*s)) + 2*Dd*f*(4*s - 1)*(s*(30*f + 28) + 11)) - 11*D1*f*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(8*s**2 - 6*s + 1) + Ddd*f*(-4*s**2 + 2*s - 1)) - 66*Dd**2*f**2*s*(1 - 2*s)))/(15*d**2*k2**3) + D1**2*Pk2*Pk3*ct*k2**5*st**2*(32*C - 16)*(D1*f*(D1*bd1*(5*f*r*(r + s - 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*D1*bdd1*f*r*(r + s - 1) - 6*Dd*bd1*f*(8*r**2 + r*(8*s - 9) - 2*s + 2)) + b1*(D1**2*(f*(5*fd - 6*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 6*fd**2*(-2*r**2 - 2*r*(s - 1) + s)) + D1*f*(Dd*(5*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) - 6*fd*(2*r - 1)*(8*r + 8*s - 5)) - 6*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 6*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4)))/(105*d**2*k1*k3**6) - 4*D1**2*Pk2*Pk3*f**2*k1**6*st**4*(D1**2*(f*(17*fd - 25*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 150*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(17*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 50*fd*(4*r + 4*s - 3)**2) - 25*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 150*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(385*d**2*k3**8) - 16*D1**2*Pk2*Pk3*f**2*k1**6*st**4*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(231*d**2*k2**2*k3**6) - 4*D1**2*Pk2*Pk3*f**2*k1**4*k2**2*st**6*(D1**2*(f*(49*fd - 30*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 180*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(49*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 60*fd*(4*r + 4*s - 3)**2) - 30*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(231*d**2*k3**8) - 32*D1**2*Pk2*Pk3*f**2*k1**4*st**6*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(77*d**2*k3**6) - 12*D1**2*Pk2*Pk3*f**2*k1**4*st**6*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k2**2*k3**4) - 4*D1**2*Pk2*Pk3*f**2*k1**2*k2**4*st**8*(D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(33*d**2*k3**8) - 16*D1**2*Pk2*Pk3*f**2*k1**2*k2**2*st**8*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(99*d**2*k3**6) - 4*D1**2*Pk2*Pk3*f**2*k1**2*st**8*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(33*d**2*k3**4) - 8*D1**2*Pk2*Pk3*f*k1**6*st**2*(-10*D1**2*bdd1*f**2*(r + s - 1)**2 + D1*bd1*f*(r + s - 1)*(11*D1*f*(r + s - 1) - 20*D1*fd*(3*r + 3*s - 2) - 20*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(f*(11*fd - 10*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 20*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(11*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 20*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(105*d**2*k3**8) + 4*D1**2*Pk2*Pk3*f*k1**6*st**2*(-12*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*s**2 + 8*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*s**2 - 4*D1**2*b1*f*fdd*s + 12*D1**2*b1*fd**2*r*s + 12*D1**2*b1*fd**2*s**2 - 8*D1**2*b1*fd**2*s + 2*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + 12*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 12*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 3*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r*s + 3*D1**2*f**2*fdd*r - 12*D1**2*f**2*fdd*s**2 + 12*D1**2*f**2*fdd*s - 3*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r*s + 9*D1**2*f*fd**2*r - 36*D1**2*f*fd**2*s**2 + 36*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 - 16*D1*Dd*b1*f**2*r*s + 4*D1*Dd*b1*f**2*r - 16*D1*Dd*b1*f**2*s**2 + 16*D1*Dd*b1*f**2*s - 4*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r*s - 6*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 40*D1*Dd*b1*f*fd*s + 4*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r*s + 24*D1*Dd*f**2*fd*r - 96*D1*Dd*f**2*fd*s**2 + 96*D1*Dd*f**2*fd*s - 18*D1*Dd*f**2*fd + 8*D1*Ddd*b1*f**2*r*s - 2*D1*Ddd*b1*f**2*r + 8*D1*Ddd*b1*f**2*s**2 - 8*D1*Ddd*b1*f**2*s + 2*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r*s + 3*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 12*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) + 24*Dd**2*b1*f**2*r*s - 6*Dd**2*b1*f**2*r + 24*Dd**2*b1*f**2*s**2 - 24*Dd**2*b1*f**2*s + 4*Dd**2*b1*f**2 - 36*Dd**2*f**3*r*s + 9*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 36*Dd**2*f**3*s - 6*Dd**2*f**3)/(63*d**2*k2**2*k3**6) + 4*D1**2*Pk2*Pk3*f*k1**6*(-D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) + b1*(D1**2*s*(f*(fd - fdd) - 2*fd**2)*(3*r + 3*s - 2) + D1*f*(Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) + Dd*fd*(r*(3 - 24*s) - 24*s**2 + 20*s - 2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(7*d**2*k2**2*k3**6) + 2*D1**2*Pk2*Pk3*f*k1**4*st**4*(-30*D1**2*b1*f*fd*r**2 - 108*D1**2*b1*f*fd*r*s + 20*D1**2*b1*f*fd*r - 78*D1**2*b1*f*fd*s**2 + 52*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fd + 42*D1**2*b1*f*fdd*r**2 + 108*D1**2*b1*f*fdd*r*s - 52*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s**2 - 68*D1**2*b1*f*fdd*s + 18*D1**2*b1*f*fdd + 84*D1**2*b1*fd**2*r**2 + 216*D1**2*b1*fd**2*r*s - 104*D1**2*b1*fd**2*r + 132*D1**2*b1*fd**2*s**2 - 136*D1**2*b1*fd**2*s + 36*D1**2*b1*fd**2 + 2*D1**2*bdd1*f**2*(7*r**2 + 18*r*s - 20*r + 11*s**2 - 24*s + 16) + 124*D1**2*f**2*fd*r**2 + 424*D1**2*f**2*fd*r*s - 230*D1**2*f**2*fd*r + 300*D1**2*f**2*fd*s**2 - 362*D1**2*f**2*fd*s + 137*D1**2*f**2*fd - 148*D1**2*f**2*fdd*r**2 - 376*D1**2*f**2*fdd*r*s + 242*D1**2*f**2*fdd*r - 228*D1**2*f**2*fdd*s**2 + 302*D1**2*f**2*fdd*s - 131*D1**2*f**2*fdd - 444*D1**2*f*fd**2*r**2 - 1128*D1**2*f*fd**2*r*s + 726*D1**2*f*fd**2*r - 684*D1**2*f*fd**2*s**2 + 906*D1**2*f*fd**2*s - 262*D1**2*f*fd**2 - 40*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 76*D1*Dd*b1*f**2*r - 104*D1*Dd*b1*f**2*s**2 + 124*D1*Dd*b1*f**2*s - 46*D1*Dd*b1*f**2 + 336*D1*Dd*b1*f*fd*r**2 + 864*D1*Dd*b1*f*fd*r*s - 484*D1*Dd*b1*f*fd*r + 528*D1*Dd*b1*f*fd*s**2 - 620*D1*Dd*b1*f*fd*s + 172*D1*Dd*b1*f*fd + 124*D1*Dd*f**3*r**2 + 424*D1*Dd*f**3*r*s - 230*D1*Dd*f**3*r + 300*D1*Dd*f**3*s**2 - 362*D1*Dd*f**3*s + 137*D1*Dd*f**3 - 1184*D1*Dd*f**2*fd*r**2 - 3008*D1*Dd*f**2*fd*r*s + 1936*D1*Dd*f**2*fd*r - 1824*D1*Dd*f**2*fd*s**2 + 2416*D1*Dd*f**2*fd*s - 786*D1*Dd*f**2*fd + 56*D1*Ddd*b1*f**2*r**2 + 144*D1*Ddd*b1*f**2*r*s - 92*D1*Ddd*b1*f**2*r + 88*D1*Ddd*b1*f**2*s**2 - 116*D1*Ddd*b1*f**2*s + 50*D1*Ddd*b1*f**2 - 148*D1*Ddd*f**3*r**2 - 376*D1*Ddd*f**3*r*s + 242*D1*Ddd*f**3*r - 228*D1*Ddd*f**3*s**2 + 302*D1*Ddd*f**3*s - 131*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(f*(5*r**2 + 18*r*s - 28*r + 13*s**2 - 36*s + 26) - 2*fd*(21*r**2 + 54*r*s - 43*r + 33*s**2 - 53*s + 16)) - 2*Dd*f*(28*r**2 + 9*r*(8*s - 7) + 44*s**2 - 77*s + 32)) + 168*Dd**2*b1*f**2*r**2 + 432*Dd**2*b1*f**2*r*s - 276*Dd**2*b1*f**2*r + 264*Dd**2*b1*f**2*s**2 - 348*Dd**2*b1*f**2*s + 100*Dd**2*b1*f**2 - 444*Dd**2*f**3*r**2 - 1128*Dd**2*f**3*r*s + 726*Dd**2*f**3*r - 684*Dd**2*f**3*s**2 + 906*Dd**2*f**3*s - 262*Dd**2*f**3)/(105*d**2*k3**6) + 2*D1**2*Pk2*Pk3*f*k1**4*st**4*(-48*D1**2*b1*f*fd*r*s + 16*D1**2*b1*f*fd*r - 72*D1**2*b1*f*fd*s**2 + 48*D1**2*b1*f*fd*s - 12*D1**2*b1*f*fd + 24*D1**2*b1*f*fdd*r*s - 8*D1**2*b1*f*fdd*r + 36*D1**2*b1*f*fdd*s**2 - 24*D1**2*b1*f*fdd*s + 6*D1**2*b1*f*fdd + 48*D1**2*b1*fd**2*r*s - 16*D1**2*b1*fd**2*r + 72*D1**2*b1*fd**2*s**2 - 48*D1**2*b1*fd**2*s + 12*D1**2*b1*fd**2 + 2*D1**2*bdd1*f**2*(6*s**2 + s*(4*r - 8) + 3) + 40*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r + 156*D1**2*f**2*fd*s**2 - 98*D1**2*f**2*fd*s + 39*D1**2*f**2*fd - 40*D1**2*f**2*fdd*r*s + 10*D1**2*f**2*fdd*r - 108*D1**2*f**2*fdd*s**2 + 74*D1**2*f**2*fdd*s - 27*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r - 324*D1**2*f*fd**2*s**2 + 222*D1**2*f*fd**2*s - 20*D1**2*f*fd**2 - 64*D1*Dd*b1*f**2*r*s + 16*D1*Dd*b1*f**2*r - 96*D1*Dd*b1*f**2*s**2 + 80*D1*Dd*b1*f**2*s - 24*D1*Dd*b1*f**2 + 192*D1*Dd*b1*f*fd*r*s - 56*D1*Dd*b1*f*fd*r + 288*D1*Dd*b1*f*fd*s**2 - 216*D1*Dd*b1*f*fd*s + 40*D1*Dd*b1*f*fd + 40*D1*Dd*f**3*r*s - 10*D1*Dd*f**3*r + 156*D1*Dd*f**3*s**2 - 98*D1*Dd*f**3*s + 39*D1*Dd*f**3 - 320*D1*Dd*f**2*fd*r*s + 80*D1*Dd*f**2*fd*r - 864*D1*Dd*f**2*fd*s**2 + 592*D1*Dd*f**2*fd*s - 94*D1*Dd*f**2*fd + 32*D1*Ddd*b1*f**2*r*s - 8*D1*Ddd*b1*f**2*r + 48*D1*Ddd*b1*f**2*s**2 - 40*D1*Ddd*b1*f**2*s + 12*D1*Ddd*b1*f**2 - 40*D1*Ddd*f**3*r*s + 10*D1*Ddd*f**3*r - 108*D1*Ddd*f**3*s**2 + 74*D1*Ddd*f**3*s - 27*D1*Ddd*f**3 - 4*D1*bd1*f*(D1*f*(6*s**2 + s*(4*r - 8) + 3) + D1*fd*(r*(2 - 12*s) - 18*s**2 + 18*s - 1) + 2*Dd*f*(-8*r*s + r - 12*s**2 + 13*s - 2)) + 96*Dd**2*b1*f**2*r*s - 24*Dd**2*b1*f**2*r + 144*Dd**2*b1*f**2*s**2 - 120*Dd**2*b1*f**2*s + 16*Dd**2*b1*f**2 - 120*Dd**2*f**3*r*s + 30*Dd**2*f**3*r - 324*Dd**2*f**3*s**2 + 222*Dd**2*f**3*s - 20*Dd**2*f**3)/(105*d**2*k2**2*k3**4) + 4*D1**2*Pk2*Pk3*f*k1**2*k2**4*st**6*(24*D1**2*b1*f*fd*r**2 + 48*D1**2*b1*f*fd*r*s - 32*D1**2*b1*f*fd*r + 24*D1**2*b1*f*fd*s**2 - 32*D1**2*b1*f*fd*s + 16*D1**2*b1*f*fd - 12*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 16*D1**2*b1*f*fdd*r - 12*D1**2*b1*f*fdd*s**2 + 16*D1**2*b1*f*fdd*s - 8*D1**2*b1*f*fdd - 24*D1**2*b1*fd**2*r**2 - 48*D1**2*b1*fd**2*r*s + 32*D1**2*b1*fd**2*r - 24*D1**2*b1*fd**2*s**2 + 32*D1**2*b1*fd**2*s - 8*D1**2*b1*fd**2 - 4*D1**2*bdd1*f**2*(r + s - 1)**2 + 4*D1**2*f**2*fd*r**2 + 8*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r + 4*D1**2*f**2*fd*s**2 - 6*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 32*D1*Dd*b1*f**2*r**2 + 64*D1*Dd*b1*f**2*r*s - 48*D1*Dd*b1*f**2*r + 32*D1*Dd*b1*f**2*s**2 - 48*D1*Dd*b1*f**2*s + 24*D1*Dd*b1*f**2 - 96*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 136*D1*Dd*b1*f*fd*r - 96*D1*Dd*b1*f*fd*s**2 + 136*D1*Dd*b1*f*fd*s - 48*D1*Dd*b1*f*fd + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 16*D1*Ddd*b1*f**2*r**2 - 32*D1*Ddd*b1*f**2*r*s + 24*D1*Ddd*b1*f**2*r - 16*D1*Ddd*b1*f**2*s**2 + 24*D1*Ddd*b1*f**2*s - 12*D1*Ddd*b1*f**2 + 8*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 48*Dd**2*b1*f**2*r**2 - 96*Dd**2*b1*f**2*r*s + 72*Dd**2*b1*f**2*r - 48*Dd**2*b1*f**2*s**2 + 72*Dd**2*b1*f**2*s - 24*Dd**2*b1*f**2)/(21*d**2*k3**8) - 2*D1**2*Pk2*Pk3*f*k1**2*k2**2*st**6*(60*D1**2*b1*f*fd*r**2 + 48*D1**2*b1*f*fd*r*s - 56*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s**2 - 8*D1**2*b1*f*fd*s + 12*D1**2*b1*f*fd - 30*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 28*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 + 4*D1**2*b1*f*fdd*s - 6*D1**2*b1*f*fdd - 60*D1**2*b1*fd**2*r**2 - 48*D1**2*b1*fd**2*r*s + 56*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 + 8*D1**2*b1*fd**2*s - 12*D1**2*b1*fd**2 - 2*D1**2*bdd1*f**2*(5*r**2 + 4*r*s - 10*r - s**2 - 4*s + 6) - 84*D1**2*f**2*fd*r**2 - 160*D1**2*f**2*fd*r*s + 124*D1**2*f**2*fd*r - 76*D1**2*f**2*fd*s**2 + 118*D1**2*f**2*fd*s - 61*D1**2*f**2*fd + 92*D1**2*f**2*fdd*r**2 + 144*D1**2*f**2*fdd*r*s - 128*D1**2*f**2*fdd*r + 52*D1**2*f**2*fdd*s**2 - 98*D1**2*f**2*fdd*s + 59*D1**2*f**2*fdd + 276*D1**2*f*fd**2*r**2 + 432*D1**2*f*fd**2*r*s - 384*D1**2*f*fd**2*r + 156*D1**2*f*fd**2*s**2 - 294*D1**2*f*fd**2*s + 118*D1**2*f*fd**2 + 80*D1*Dd*b1*f**2*r**2 + 64*D1*Dd*b1*f**2*r*s - 96*D1*Dd*b1*f**2*r - 16*D1*Dd*b1*f**2*s**2 - 24*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 240*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 256*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 + 52*D1*Dd*b1*f*fd*s - 60*D1*Dd*b1*f*fd - 84*D1*Dd*f**3*r**2 - 160*D1*Dd*f**3*r*s + 124*D1*Dd*f**3*r - 76*D1*Dd*f**3*s**2 + 118*D1*Dd*f**3*s - 61*D1*Dd*f**3 + 736*D1*Dd*f**2*fd*r**2 + 1152*D1*Dd*f**2*fd*r*s - 1024*D1*Dd*f**2*fd*r + 416*D1*Dd*f**2*fd*s**2 - 784*D1*Dd*f**2*fd*s + 354*D1*Dd*f**2*fd - 40*D1*Ddd*b1*f**2*r**2 - 32*D1*Ddd*b1*f**2*r*s + 48*D1*Ddd*b1*f**2*r + 8*D1*Ddd*b1*f**2*s**2 + 12*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 + 92*D1*Ddd*f**3*r**2 + 144*D1*Ddd*f**3*r*s - 128*D1*Ddd*f**3*r + 52*D1*Ddd*f**3*s**2 - 98*D1*Ddd*f**3*s + 59*D1*Ddd*f**3 + 4*D1*bd1*f*(D1*(f*(5*r**2 + 4*r*s - 10*r - s**2 - 4*s + 6) + fd*(-15*r**2 - 12*r*s + 22*r + 3*s**2 + 7*s - 6)) + Dd*f*(-20*r**2 - 16*r*(s - 2) + 4*s**2 + 11*s - 12)) - 120*Dd**2*b1*f**2*r**2 - 96*Dd**2*b1*f**2*r*s + 144*Dd**2*b1*f**2*r + 24*Dd**2*b1*f**2*s**2 + 36*Dd**2*b1*f**2*s - 36*Dd**2*b1*f**2 + 276*Dd**2*f**3*r**2 + 432*Dd**2*f**3*r*s - 384*Dd**2*f**3*r + 156*Dd**2*f**3*s**2 - 294*Dd**2*f**3*s + 118*Dd**2*f**3)/(63*d**2*k3**6) + 4*D1**2*Pk2*Pk3*f*k1**2*st**6*(D1*f*s*(D1*bdd1*f*s - 2*bd1*(D1*(f*s - 3*fd*s + fd) + Dd*(-4*f*s + f))) + b1*(D1**2*(-f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(3*s - 2)) + D1*f*(2*Dd*(f*(-4*s**2 + 2*s - 1) + fd*(12*s**2 - 7*s + 1)) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)))/(7*d**2*k2**2*k3**2) + 12*D1**2*Pk2*Pk3*k1**6*(-10*D1**2*bd1**2*f**2*(r + s - 1)**2 + 2*D1*b1*f*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + b1**2*(D1**2*(f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(35*d**2*k3**8) + 4*D1**2*Pk2*Pk3*k1**4*k2**2*st**2*(-6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r**2 + 60*C*D1**2*f**2*fdd*r*s - 40*C*D1**2*f**2*fdd*r + 30*C*D1**2*f**2*fdd*s**2 - 40*C*D1**2*f**2*fdd*s + 20*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r**2 + 120*C*D1**2*f*fd**2*r*s - 80*C*D1**2*f*fd**2*r + 60*C*D1**2*f*fd**2*s**2 - 80*C*D1**2*f*fd**2*s + 20*C*D1**2*f*fd**2 - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r**2 + 480*C*D1*Dd*f**2*fd*r*s - 340*C*D1*Dd*f**2*fd*r + 240*C*D1*Dd*f**2*fd*s**2 - 340*C*D1*Dd*f**2*fd*s + 120*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*r**2 + 80*C*D1*Ddd*f**3*r*s - 60*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s**2 - 60*C*D1*Ddd*f**3*s + 30*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*r**2 + 240*C*Dd**2*f**3*r*s - 180*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s**2 - 180*C*Dd**2*f**3*s + 60*C*Dd**2*f**3 + 9*D1**2*K*bdd1*f**2*r**2 + 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*r + 9*D1**2*K*bdd1*f**2*s**2 - 18*D1**2*K*bdd1*f**2*s + 9*D1**2*K*bdd1*f**2 - 180*D1**2*bd1**2*f**2*(r + s - 1)**2 + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 20*D1**2*f**2*fdd*s - 10*D1**2*f**2*fdd - 6*D1**2*f**2*gd2*r**2 - 12*D1**2*f**2*gd2*r*s + 12*D1**2*f**2*gd2*r - 6*D1**2*f**2*gd2*s**2 + 12*D1**2*f**2*gd2*s - 6*D1**2*f**2*gd2 - 18*D1**2*f**2*gdd2*r**2 - 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*r - 18*D1**2*f**2*gdd2*s**2 + 36*D1**2*f**2*gdd2*s - 18*D1**2*f**2*gdd2 - 30*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 40*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 - 12*D1**2*f*fd*g2*r**2 - 24*D1**2*f*fd*g2*r*s + 12*D1**2*f*fd*g2*r - 12*D1**2*f*fd*g2*s**2 + 12*D1**2*f*fd*g2*s - 6*D1**2*f*fd*g2 - 72*D1**2*f*fd*gd2*r**2 - 144*D1**2*f*fd*gd2*r*s + 108*D1**2*f*fd*gd2*r - 72*D1**2*f*fd*gd2*s**2 + 108*D1**2*f*fd*gd2*s - 36*D1**2*f*fd*gd2 - 36*D1**2*f*fdd*g2*r**2 - 72*D1**2*f*fdd*g2*r*s + 36*D1**2*f*fdd*g2*r - 36*D1**2*f*fdd*g2*s**2 + 36*D1**2*f*fdd*g2*s - 18*D1**2*f*fdd*g2 - 36*D1**2*fd**2*g2*r**2 - 72*D1**2*fd**2*g2*r*s + 36*D1**2*fd**2*g2*r - 36*D1**2*fd**2*g2*s**2 + 36*D1**2*fd**2*g2*s + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 170*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 170*D1*Dd*f**2*fd*s - 60*D1*Dd*f**2*fd - 24*D1*Dd*f**2*g2*r**2 - 48*D1*Dd*f**2*g2*r*s + 36*D1*Dd*f**2*g2*r - 24*D1*Dd*f**2*g2*s**2 + 36*D1*Dd*f**2*g2*s - 18*D1*Dd*f**2*g2 - 144*D1*Dd*f**2*gd2*r**2 - 288*D1*Dd*f**2*gd2*r*s + 252*D1*Dd*f**2*gd2*r - 144*D1*Dd*f**2*gd2*s**2 + 252*D1*Dd*f**2*gd2*s - 108*D1*Dd*f**2*gd2 - 288*D1*Dd*f*fd*g2*r**2 - 576*D1*Dd*f*fd*g2*r*s + 360*D1*Dd*f*fd*g2*r - 288*D1*Dd*f*fd*g2*s**2 + 360*D1*Dd*f*fd*g2*s - 108*D1*Dd*f*fd*g2 - 20*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 30*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 30*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 - 72*D1*Ddd*f**2*g2*r**2 - 144*D1*Ddd*f**2*g2*r*s + 108*D1*Ddd*f**2*g2*r - 72*D1*Ddd*f**2*g2*s**2 + 108*D1*Ddd*f**2*g2*s - 54*D1*Ddd*f**2*g2 + 3*D1*bd1*f*(D1*(K*f*(r + s - 1) + 6*K*fd*(2*r + 2*s - 1) + 6*f**2*(r + s - 1)) + 6*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) - 60*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 90*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 90*Dd**2*f**3*s - 30*Dd**2*f**3 - 216*Dd**2*f**2*g2*r**2 - 432*Dd**2*f**2*g2*r*s + 324*Dd**2*f**2*g2*r - 216*Dd**2*f**2*g2*s**2 + 324*Dd**2*f**2*g2*s - 108*Dd**2*f**2*g2 + 9*b1**2*(D1**2*(f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 20*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(13*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 20*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(2*D1**2*K*f*fd*r**2 + 4*D1**2*K*f*fd*r*s - 2*D1**2*K*f*fd*r + 2*D1**2*K*f*fd*s**2 - 2*D1**2*K*f*fd*s + D1**2*K*f*fd + 6*D1**2*K*f*fdd*r**2 + 12*D1**2*K*f*fdd*r*s - 6*D1**2*K*f*fdd*r + 6*D1**2*K*f*fdd*s**2 - 6*D1**2*K*f*fdd*s + 3*D1**2*K*f*fdd + 6*D1**2*K*fd**2*r**2 + 12*D1**2*K*fd**2*r*s - 6*D1**2*K*fd**2*r + 6*D1**2*K*fd**2*s**2 - 6*D1**2*K*fd**2*s - 60*D1**2*bdd1*f**2*(r + s - 1)**2 + 18*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 24*D1**2*f**2*fd*s + 12*D1**2*f**2*fd + 4*D1*Dd*K*f**2*r**2 + 8*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r + 4*D1*Dd*K*f**2*s**2 - 6*D1*Dd*K*f**2*s + 3*D1*Dd*K*f**2 + 48*D1*Dd*K*f*fd*r**2 + 96*D1*Dd*K*f*fd*r*s - 60*D1*Dd*K*f*fd*r + 48*D1*Dd*K*f*fd*s**2 - 60*D1*Dd*K*f*fd*s + 18*D1*Dd*K*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 + 12*D1*Ddd*K*f**2*r**2 + 24*D1*Ddd*K*f**2*r*s - 18*D1*Ddd*K*f**2*r + 12*D1*Ddd*K*f**2*s**2 - 18*D1*Ddd*K*f**2*s + 9*D1*Ddd*K*f**2 + 6*D1*bd1*f*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) + 36*Dd**2*K*f**2*r**2 + 72*Dd**2*K*f**2*r*s - 54*Dd**2*K*f**2*r + 36*Dd**2*K*f**2*s**2 - 54*Dd**2*K*f**2*s + 18*Dd**2*K*f**2))/(105*d**2*k3**8) - 4*D1**2*Pk2*Pk3*k1**4*k2**2*(-42*D1**2*K*bd1**2*f*(r + s - 1)**2 - 3*D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 14*K*b1 - 5*f - 14*g2) + D1*bd1*(D1*(f**2*(18*C + 42*b1 - 9)*(r + s - 1) - 2*f*(fd*(30*C - 15)*(2*r + 2*s - 1) + (r + s - 1)*(-7*K*b1 + 7*g2 - 42*gd2)) + 84*fd*(r + s)*(-K*b1 + g2)) - 6*Dd*f*(4*r + 4*s - 3)*(10*C*f + 14*K*b1 - 5*f - 14*g2))*(r + s - 1) + b1*(D1**2*(f*(fd*(18*C + 21*b1 - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(30*C - 15)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-14*gd2 + 42*gdd2)*(r + s - 1)**2) - (r + s)*(fd**2*(60*C - 30)*(r + s - 1) - 84*fd*gd2*(r + s - 1) + 7*fd*(r + s)*(-K*b1 + 2*g2) - 21*fdd*(r + s)*(-K*b1 + 2*g2))) + D1*(Dd*(f**2*(18*C + 21*b1 - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(7*K*b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + fd*(30 - 60*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 14*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 84*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 42*fd*(-K*b1 + 2*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(10*C*f + 7*K*b1 - 5*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(10*C*f + 7*K*b1 - 5*f - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(35*d**2*k3**8) - 4*D1**2*Pk2*Pk3*k1**4*st**2*(-6*C*D1**2*f**2*fd*r**2 - 24*C*D1**2*f**2*fd*r*s + 12*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 20*C*D1**2*f**2*fd*s - 8*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r**2 + 120*C*D1**2*f**2*fdd*r*s - 60*C*D1**2*f**2*fdd*r + 90*C*D1**2*f**2*fdd*s**2 - 100*C*D1**2*f**2*fdd*s + 40*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r**2 + 240*C*D1**2*f*fd**2*r*s - 120*C*D1**2*f*fd**2*r + 180*C*D1**2*f*fd**2*s**2 - 200*C*D1**2*f*fd**2*s + 40*C*D1**2*f*fd**2 - 8*C*D1*Dd*f**3*r**2 - 32*C*D1*Dd*f**3*r*s + 16*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 28*C*D1*Dd*f**3*s - 10*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r**2 + 960*C*D1*Dd*f**2*fd*r*s - 480*C*D1*Dd*f**2*fd*r + 720*C*D1*Dd*f**2*fd*s**2 - 820*C*D1*Dd*f**2*fd*s + 220*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*r**2 + 160*C*D1*Ddd*f**3*r*s - 80*C*D1*Ddd*f**3*r + 120*C*D1*Ddd*f**3*s**2 - 140*C*D1*Ddd*f**3*s + 50*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*r**2 + 480*C*Dd**2*f**3*r*s - 240*C*Dd**2*f**3*r + 360*C*Dd**2*f**3*s**2 - 420*C*Dd**2*f**3*s + 100*C*Dd**2*f**3 + 9*D1**2*K*bdd1*f**2*r**2 + 36*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*r + 27*D1**2*K*bdd1*f**2*s**2 - 36*D1**2*K*bdd1*f**2*s + 9*D1**2*K*bdd1*f**2 + 6*D1**2*b2*f*fd*r**2 + 12*D1**2*b2*f*fd*r*s - 6*D1**2*b2*f*fd*r + 6*D1**2*b2*f*fd*s**2 - 6*D1**2*b2*f*fd*s + 3*D1**2*b2*f*fd + 18*D1**2*b2*f*fdd*r**2 + 36*D1**2*b2*f*fdd*r*s - 18*D1**2*b2*f*fdd*r + 18*D1**2*b2*f*fdd*s**2 - 18*D1**2*b2*f*fdd*s + 9*D1**2*b2*f*fdd + 18*D1**2*b2*fd**2*r**2 + 36*D1**2*b2*fd**2*r*s - 18*D1**2*b2*fd**2*r + 18*D1**2*b2*fd**2*s**2 - 18*D1**2*b2*fd**2*s - 36*D1**2*bd1**2*f**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 3*D1**2*bd2*f**2*r**2 + 6*D1**2*bd2*f**2*r*s - 6*D1**2*bd2*f**2*r + 3*D1**2*bd2*f**2*s**2 - 6*D1**2*bd2*f**2*s + 3*D1**2*bd2*f**2 + 36*D1**2*bd2*f*fd*r**2 + 72*D1**2*bd2*f*fd*r*s - 54*D1**2*bd2*f*fd*r + 36*D1**2*bd2*f*fd*s**2 - 54*D1**2*bd2*f*fd*s + 18*D1**2*bd2*f*fd + 126*D1**2*bdd1*f**3*r**2 + 171*D1**2*bdd1*f**3*r*s - 234*D1**2*bdd1*f**3*r + 45*D1**2*bdd1*f**3*s**2 - 153*D1**2*bdd1*f**3*s + 108*D1**2*bdd1*f**3 - 9*D1**2*bdd1*f**2*r*s - 9*D1**2*bdd1*f**2*s**2 + 9*D1**2*bdd1*f**2*s + 9*D1**2*bdd2*f**2*r**2 + 18*D1**2*bdd2*f**2*r*s - 18*D1**2*bdd2*f**2*r + 9*D1**2*bdd2*f**2*s**2 - 18*D1**2*bdd2*f**2*s + 9*D1**2*bdd2*f**2 + 3*D1**2*f**2*fd*r**2 + 15*D1**2*f**2*fd*r*s - 7*D1**2*f**2*fd*r + 12*D1**2*f**2*fd*s**2 - 13*D1**2*f**2*fd*s + 5*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 35*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 65*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 6*D1**2*f**2*gd2*r**2 - 24*D1**2*f**2*gd2*r*s + 12*D1**2*f**2*gd2*r - 18*D1**2*f**2*gd2*s**2 + 24*D1**2*f**2*gd2*s - 6*D1**2*f**2*gd2 - 18*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*r - 54*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 18*D1**2*f**2*gdd2 - 30*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 70*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 130*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 - 12*D1**2*f*fd*g2*r**2 - 48*D1**2*f*fd*g2*r*s + 24*D1**2*f*fd*g2*r - 36*D1**2*f*fd*g2*s**2 + 36*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 - 72*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 144*D1**2*f*fd*gd2*r - 216*D1**2*f*fd*gd2*s**2 + 252*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 36*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 108*D1**2*f*fdd*g2*s**2 + 108*D1**2*f*fdd*g2*s - 54*D1**2*f*fdd*g2 - 36*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 108*D1**2*fd**2*g2*s**2 + 108*D1**2*fd**2*g2*s + 12*D1*Dd*b2*f**2*r**2 + 24*D1*Dd*b2*f**2*r*s - 18*D1*Dd*b2*f**2*r + 12*D1*Dd*b2*f**2*s**2 - 18*D1*Dd*b2*f**2*s + 9*D1*Dd*b2*f**2 + 144*D1*Dd*b2*f*fd*r**2 + 288*D1*Dd*b2*f*fd*r*s - 180*D1*Dd*b2*f*fd*r + 144*D1*Dd*b2*f*fd*s**2 - 180*D1*Dd*b2*f*fd*s + 54*D1*Dd*b2*f*fd + 72*D1*Dd*bd2*f**2*r**2 + 144*D1*Dd*bd2*f**2*r*s - 126*D1*Dd*bd2*f**2*r + 72*D1*Dd*bd2*f**2*s**2 - 126*D1*Dd*bd2*f**2*s + 54*D1*Dd*bd2*f**2 + 4*D1*Dd*f**3*r**2 + 20*D1*Dd*f**3*r*s - 9*D1*Dd*f**3*r + 16*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 275*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 530*D1*Dd*f**2*fd*s - 135*D1*Dd*f**2*fd - 24*D1*Dd*f**2*g2*r**2 - 96*D1*Dd*f**2*g2*r*s + 48*D1*Dd*f**2*g2*r - 72*D1*Dd*f**2*g2*s**2 + 84*D1*Dd*f**2*g2*s - 30*D1*Dd*f**2*g2 - 144*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 288*D1*Dd*f**2*gd2*r - 432*D1*Dd*f**2*gd2*s**2 + 540*D1*Dd*f**2*gd2*s - 144*D1*Dd*f**2*gd2 - 288*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 576*D1*Dd*f*fd*g2*r - 864*D1*Dd*f*fd*g2*s**2 + 936*D1*Dd*f*fd*g2*s - 252*D1*Dd*f*fd*g2 + 36*D1*Ddd*b2*f**2*r**2 + 72*D1*Ddd*b2*f**2*r*s - 54*D1*Ddd*b2*f**2*r + 36*D1*Ddd*b2*f**2*s**2 - 54*D1*Ddd*b2*f**2*s + 27*D1*Ddd*b2*f**2 - 20*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 45*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 90*D1*Ddd*f**3*s - 30*D1*Ddd*f**3 - 72*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 144*D1*Ddd*f**2*g2*r - 216*D1*Ddd*f**2*g2*s**2 + 252*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 3*D1*bd1*f*(D1*(3*f**2*(12*r**2 + r*(19*s - 28) + 7*s**2 - 23*s + 16) - f*(3*fd*(84*r**2 + r*(114*s - 127) + 30*s**2 - 82*s + 45) + (K*(r + 3*s - 1) - s)*(r + s - 1)) - 3*fd*(2*K*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 7*s + 2) - 4*r*s + r - 4*s**2 + 4*s - 1)) - 3*Dd*f*(2*K*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 15*s + 4) + f*(112*r**2 + r*(152*s - 179) + 40*s**2 - 116*s + 69) - 8*r*s + r - 8*s**2 + 8*s - 1)) + 108*Dd**2*b2*f**2*r**2 + 216*Dd**2*b2*f**2*r*s - 162*Dd**2*b2*f**2*r + 108*Dd**2*b2*f**2*s**2 - 162*Dd**2*b2*f**2*s + 54*Dd**2*b2*f**2 - 60*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 135*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 270*Dd**2*f**3*s - 60*Dd**2*f**3 - 216*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 432*Dd**2*f**2*g2*r - 648*Dd**2*f**2*g2*s**2 + 756*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 + 6*b1**2*(D1**2*(f*(fd*(22*r**2 + 44*r*s - 34*r + 22*s**2 - 34*s + 17) - 6*fdd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 6*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(11*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 9*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 54*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(2*D1**2*K*f*fd*r**2 + 8*D1**2*K*f*fd*r*s - 4*D1**2*K*f*fd*r + 6*D1**2*K*f*fd*s**2 - 6*D1**2*K*f*fd*s + 3*D1**2*K*f*fd + 6*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 18*D1**2*K*f*fdd*s**2 - 18*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 6*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 18*D1**2*K*fd**2*s**2 - 18*D1**2*K*fd**2*s - 6*D1**2*bdd1*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - 108*D1**2*f**2*fd*r**2 - 171*D1**2*f**2*fd*r*s + 117*D1**2*f**2*fd*r - 63*D1**2*f**2*fd*s**2 + 87*D1**2*f**2*fd*s - 45*D1**2*f**2*fd + 126*D1**2*f**2*fdd*r**2 + 171*D1**2*f**2*fdd*r*s - 147*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 93*D1**2*f**2*fdd*s + 63*D1**2*f**2*fdd + 252*D1**2*f*fd**2*r**2 + 342*D1**2*f*fd**2*r*s - 294*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 186*D1**2*f*fd**2*s + 63*D1**2*f*fd**2 - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd - 6*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 3*D1**2*f*fdd - 6*D1**2*fd**2*r*s + 3*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s + 4*D1*Dd*K*f**2*r**2 + 16*D1*Dd*K*f**2*r*s - 8*D1*Dd*K*f**2*r + 12*D1*Dd*K*f**2*s**2 - 14*D1*Dd*K*f**2*s + 5*D1*Dd*K*f**2 + 48*D1*Dd*K*f*fd*r**2 + 192*D1*Dd*K*f*fd*r*s - 96*D1*Dd*K*f*fd*r + 144*D1*Dd*K*f*fd*s**2 - 156*D1*Dd*K*f*fd*s + 42*D1*Dd*K*f*fd - 144*D1*Dd*f**3*r**2 - 228*D1*Dd*f**3*r*s + 201*D1*Dd*f**3*r - 84*D1*Dd*f**3*s**2 + 156*D1*Dd*f**3*s - 93*D1*Dd*f**3 + 1008*D1*Dd*f**2*fd*r**2 + 1368*D1*Dd*f**2*fd*r*s - 1263*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 804*D1*Dd*f**2*fd*s + 387*D1*Dd*f**2*fd - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 48*D1*Dd*f*fd*s - 12*D1*Dd*f*fd + 12*D1*Ddd*K*f**2*r**2 + 48*D1*Ddd*K*f**2*r*s - 24*D1*Ddd*K*f**2*r + 36*D1*Ddd*K*f**2*s**2 - 42*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 + 168*D1*Ddd*f**3*r**2 + 228*D1*Ddd*f**3*r*s - 225*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 144*D1*Ddd*f**3*s + 99*D1*Ddd*f**3 - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 4*D1*bd1*f*(D1*(f*(11*r**2 + 22*r*s - 16*r + 11*s**2 - 16*s + 8) - 18*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 3*Dd*f*(24*r**2 + r*(48*s - 38) + 24*s**2 - 38*s + 15)) + 36*Dd**2*K*f**2*r**2 + 144*Dd**2*K*f**2*r*s - 72*Dd**2*K*f**2*r + 108*Dd**2*K*f**2*s**2 - 126*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 + 504*Dd**2*f**3*r**2 + 684*Dd**2*f**3*r*s - 675*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 432*Dd**2*f**3*s + 198*Dd**2*f**3 - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s - 6*Dd**2*f**2))/(315*d**2*k3**6) + 2*D1**2*Pk2*Pk3*k1**4*(2*D1*(21*D1*bd1**2*f*(r + s - 1)*(-2*K*(r + 3*s - 2) + f*(9*r + 7*s - 8) + 2*s - 1) - 3*D1*bdd1*f*(5*f*(2*C*(r + 3*s - 3) - r - 4*s + 4) - 14*g2*(r + 3*s - 3))*(r + s - 1) + 7*b2*(-3*D1*bdd1*f*(r + s - 1) + bd1*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + bd1*(-42*D1*bd2*f*(r + s - 1)**2 + D1*(9*f**2*(r + s - 1)*(2*C*(r + 3*s - 3) - r - 4*s + 4) + f*(-15*fd*(4*C*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 8*s + 2) - 4*r**2 - 20*r*s + 12*r - 16*s**2 + 21*s - 5) + (g2*(r + 3*s - 3) - 6*gd2*(r + 3*s - 2))*(-14*r - 14*s + 14)) + 84*fd*g2*(r**2 + r*(4*s - 2) + s*(3*s - 3))) - 3*Dd*f*(5*f*(4*C*(4*r**2 + 4*r*(4*s - 3) + 12*s**2 - 19*s + 7) - 8*r**2 - 40*r*s + 29*r - 32*s**2 + 50*s - 18) - 28*g2*(4*r**2 + 4*r*(4*s - 3) + 12*s**2 - 19*s + 7)))) + 14*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(2*D1**2*K*fd*r**2 + 8*D1**2*K*fd*r*s + 6*D1**2*K*fd*s**2 - 6*D1**2*K*fdd*r**2 - 24*D1**2*K*fdd*r*s - 18*D1**2*K*fdd*s**2 - 6*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 42*D1**2*f*fd*r**2 - 72*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 21*D1**2*f*fd + 54*D1**2*f*fdd*r**2 + 96*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 27*D1**2*f*fdd + 54*D1**2*fd**2*r**2 + 96*D1**2*fd**2*r*s - 54*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 48*D1**2*fd**2*s - 2*D1**2*fd*r*s - 2*D1**2*fd*s**2 + 6*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 + 8*D1*Dd*K*f*r**2 + 32*D1*Dd*K*f*r*s - 16*D1*Dd*K*f*r + 24*D1*Dd*K*f*s**2 - 28*D1*Dd*K*f*s + 10*D1*Dd*K*f - 48*D1*Dd*K*fd*r**2 - 192*D1*Dd*K*fd*r*s + 48*D1*Dd*K*fd*r - 144*D1*Dd*K*fd*s**2 + 84*D1*Dd*K*fd*s - 84*D1*Dd*f**2*r**2 - 144*D1*Dd*f**2*r*s + 120*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 102*D1*Dd*f**2*s - 57*D1*Dd*f**2 + 432*D1*Dd*f*fd*r**2 + 768*D1*Dd*f*fd*r*s - 528*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 468*D1*Dd*f*fd*s + 156*D1*Dd*f*fd - 8*D1*Dd*f*r*s + 2*D1*Dd*f*r - 8*D1*Dd*f*s**2 + 8*D1*Dd*f*s - 2*D1*Dd*f + 48*D1*Dd*fd*r*s - 6*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 24*D1*Dd*fd*s - 24*D1*Ddd*K*f*r**2 - 96*D1*Ddd*K*f*r*s + 48*D1*Ddd*K*f*r - 72*D1*Ddd*K*f*s**2 + 84*D1*Ddd*K*f*s - 30*D1*Ddd*K*f + 108*D1*Ddd*f**2*r**2 + 192*D1*Ddd*f**2*r*s - 156*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 138*D1*Ddd*f**2*s + 75*D1*Ddd*f**2 + 24*D1*Ddd*f*r*s - 6*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 24*D1*Ddd*f*s + 6*D1*Ddd*f + 2*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - 6*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 72*Dd**2*K*f*r**2 - 288*Dd**2*K*f*r*s + 144*Dd**2*K*f*r - 216*Dd**2*K*f*s**2 + 252*Dd**2*K*f*s - 60*Dd**2*K*f + 324*Dd**2*f**2*r**2 + 576*Dd**2*f**2*r*s - 468*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 414*Dd**2*f**2*s + 150*Dd**2*f**2 + 72*Dd**2*f*r*s - 18*Dd**2*f*r + 72*Dd**2*f*s**2 - 72*Dd**2*f*s + 12*Dd**2*f) - 2*b1*(-36*C*D1**2*f*fd*r**2 - 144*C*D1**2*f*fd*r*s + 36*C*D1**2*f*fd*r - 108*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s - 18*C*D1**2*f*fd + 60*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 60*C*D1**2*f*fdd*r + 180*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 30*C*D1**2*f*fdd + 60*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s - 60*C*D1**2*fd**2*r + 180*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 72*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 144*C*D1*Dd*f**2*r - 216*C*D1*Dd*f**2*s**2 + 252*C*D1*Dd*f**2*s - 90*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 720*C*D1*Dd*f*fd*r + 1440*C*D1*Dd*f*fd*s**2 - 1320*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 240*C*D1*Ddd*f**2*r + 360*C*D1*Ddd*f**2*s**2 - 420*C*D1*Ddd*f**2*s + 150*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 720*C*Dd**2*f**2*r + 1080*C*Dd**2*f**2*s**2 - 1260*C*Dd**2*f**2*s + 300*C*Dd**2*f**2 + 42*D1**2*K*bdd1*f*r**2 + 168*D1**2*K*bdd1*f*r*s - 126*D1**2*K*bdd1*f*r + 126*D1**2*K*bdd1*f*s**2 - 210*D1**2*K*bdd1*f*s + 84*D1**2*K*bdd1*f - 7*D1**2*b2*fd*r**2 - 14*D1**2*b2*fd*r*s - 7*D1**2*b2*fd*s**2 + 21*D1**2*b2*fdd*r**2 + 42*D1**2*b2*fdd*r*s + 21*D1**2*b2*fdd*s**2 + 42*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 189*D1**2*bdd1*f**2*r**2 - 336*D1**2*bdd1*f**2*r*s + 357*D1**2*bdd1*f**2*r - 147*D1**2*bdd1*f**2*s**2 + 315*D1**2*bdd1*f**2*s - 168*D1**2*bdd1*f**2 - 42*D1**2*bdd1*f*r*s + 21*D1**2*bdd1*f*r - 42*D1**2*bdd1*f*s**2 + 63*D1**2*bdd1*f*s - 21*D1**2*bdd1*f + 21*D1**2*bdd2*f*r**2 + 42*D1**2*bdd2*f*r*s - 42*D1**2*bdd2*f*r + 21*D1**2*bdd2*f*s**2 - 42*D1**2*bdd2*f*s + 21*D1**2*bdd2*f + 18*D1**2*f*fd*r**2 + 90*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 72*D1**2*f*fd*s**2 - 45*D1**2*f*fd*s + 9*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 150*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 120*D1**2*f*fdd*s**2 + 75*D1**2*f*fdd*s - 15*D1**2*f*fdd + 14*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*r + 42*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s + 14*D1**2*f*gd2 - 42*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*r - 126*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 42*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 150*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 120*D1**2*fd**2*s**2 + 75*D1**2*fd**2*s + 14*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s + 42*D1**2*fd*g2*s**2 - 84*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 84*D1**2*fd*gd2*r - 252*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 42*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 126*D1**2*fdd*g2*s**2 - 28*D1*Dd*b2*f*r**2 - 56*D1*Dd*b2*f*r*s + 42*D1*Dd*b2*f*r - 28*D1*Dd*b2*f*s**2 + 42*D1*Dd*b2*f*s - 21*D1*Dd*b2*f + 168*D1*Dd*b2*fd*r**2 + 336*D1*Dd*b2*fd*r*s - 126*D1*Dd*b2*fd*r + 168*D1*Dd*b2*fd*s**2 - 126*D1*Dd*b2*fd*s + 36*D1*Dd*f**2*r**2 + 180*D1*Dd*f**2*r*s - 81*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 162*D1*Dd*f**2*s + 54*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 1200*D1*Dd*f*fd*r*s + 390*D1*Dd*f*fd*r - 960*D1*Dd*f*fd*s**2 + 840*D1*Dd*f*fd*s - 135*D1*Dd*f*fd + 56*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 112*D1*Dd*f*g2*r + 168*D1*Dd*f*g2*s**2 - 196*D1*Dd*f*g2*s + 70*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 672*D1*Dd*f*gd2*r - 1008*D1*Dd*f*gd2*s**2 + 1260*D1*Dd*f*gd2*s - 336*D1*Dd*f*gd2 - 336*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 336*D1*Dd*fd*g2*r - 1008*D1*Dd*fd*g2*s**2 + 588*D1*Dd*fd*g2*s + 84*D1*Ddd*b2*f*r**2 + 168*D1*Ddd*b2*f*r*s - 126*D1*Ddd*b2*f*r + 84*D1*Ddd*b2*f*s**2 - 126*D1*Ddd*b2*f*s + 63*D1*Ddd*b2*f - 60*D1*Ddd*f**2*r**2 - 300*D1*Ddd*f**2*r*s + 135*D1*Ddd*f**2*r - 240*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 90*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 336*D1*Ddd*f*g2*r - 504*D1*Ddd*f*g2*s**2 + 588*D1*Ddd*f*g2*s - 210*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(3*f**2*(7*r**2 + r*(12*s - 13) + 5*s**2 - 11*s + 6) - f*(3*fd*(36*r**2 + r*(64*s - 52) + 28*s**2 - 46*s + 17) + (r + s - 1)*(2*K*(r + 3*s - 2) - 2*s + 1)) + 3*fd*(4*K*r**2 + r*(2*K*(8*s - 3) - 4*s + 1) + s*(2*K*(6*s - 5) - 4*s + 3))) - 3*Dd*f*(-2*K*(8*r**2 + 4*r*(8*s - 5) + 24*s**2 - 34*s + 11) + f*(72*r**2 + 8*r*(16*s - 15) + 56*s**2 - 106*s + 49) + 16*r*s - 6*r + 16*s**2 - 20*s + 5)) - 7*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 252*Dd**2*b2*f*r**2 + 504*Dd**2*b2*f*r*s - 378*Dd**2*b2*f*r + 252*Dd**2*b2*f*s**2 - 378*Dd**2*b2*f*s + 126*Dd**2*b2*f - 180*Dd**2*f**2*r**2 - 900*Dd**2*f**2*r*s + 405*Dd**2*f**2*r - 720*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 180*Dd**2*f**2 - 504*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1008*Dd**2*f*g2*r - 1512*Dd**2*f*g2*s**2 + 1764*Dd**2*f*g2*s - 420*Dd**2*f*g2))/(105*d**2*k3**6) - D1**2*Pk2*Pk3*k1**4*st**2*(6*C*D1**2*f**2*fd*s**2 - 4*C*D1**2*f**2*fd*s + 2*C*D1**2*f**2*fd - 30*C*D1**2*f**2*fdd*s**2 + 20*C*D1**2*f**2*fdd*s - 10*C*D1**2*f**2*fdd - 60*C*D1**2*f*fd**2*s**2 + 40*C*D1**2*f*fd**2*s + 8*C*D1*Dd*f**3*s**2 - 4*C*D1*Dd*f**3*s + 2*C*D1*Dd*f**3 - 240*C*D1*Dd*f**2*fd*s**2 + 140*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 40*C*D1*Ddd*f**3*s**2 + 20*C*D1*Ddd*f**3*s - 10*C*D1*Ddd*f**3 - 120*C*Dd**2*f**3*s**2 + 60*C*Dd**2*f**3*s - 9*D1**2*K*bdd1*f**2*s**2 - 36*D1**2*bd1**2*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 198*D1**2*bdd1*f**3*r*s - 90*D1**2*bdd1*f**3*r + 198*D1**2*bdd1*f**3*s**2 - 324*D1**2*bdd1*f**3*s + 135*D1**2*bdd1*f**3 + 18*D1**2*bdd1*f**2*r*s + 27*D1**2*bdd1*f**2*s**2 - 18*D1**2*bdd1*f**2*s + 540*D1**2*f**3*fd*r*s - 135*D1**2*f**3*fd*r + 648*D1**2*f**3*fd*s**2 - 594*D1**2*f**3*fd*s + 162*D1**2*f**3*fd - 540*D1**2*f**3*fdd*r*s + 135*D1**2*f**3*fdd*r - 648*D1**2*f**3*fdd*s**2 + 594*D1**2*f**3*fdd*s - 162*D1**2*f**3*fdd - 1620*D1**2*f**2*fd**2*r*s + 405*D1**2*f**2*fd**2*r - 1944*D1**2*f**2*fd**2*s**2 + 1782*D1**2*f**2*fd**2*s - 270*D1**2*f**2*fd**2 - 6*D1**2*f**2*fd*r*s + 2*D1**2*f**2*fd*r - 12*D1**2*f**2*fd*s**2 + 10*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r*s - 10*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 50*D1**2*f**2*fdd*s + 20*D1**2*f**2*fdd + 6*D1**2*f**2*gd2*s**2 + 18*D1**2*f**2*gdd2*s**2 + 60*D1**2*f*fd**2*r*s - 20*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 100*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 + 12*D1**2*f*fd*g2*s**2 - 12*D1**2*f*fd*g2*s + 6*D1**2*f*fd*g2 + 72*D1**2*f*fd*gd2*s**2 - 36*D1**2*f*fd*gd2*s + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 540*D1*Dd*f**4*r*s - 135*D1*Dd*f**4*r + 648*D1*Dd*f**4*s**2 - 594*D1*Dd*f**4*s + 162*D1*Dd*f**4 - 4320*D1*Dd*f**3*fd*r*s + 1080*D1*Dd*f**3*fd*r - 5184*D1*Dd*f**3*fd*s**2 + 4752*D1*Dd*f**3*fd*s - 864*D1*Dd*f**3*fd - 8*D1*Dd*f**3*r*s + 2*D1*Dd*f**3*r - 16*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 4*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r*s - 70*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 380*D1*Dd*f**2*fd*s + 70*D1*Dd*f**2*fd + 24*D1*Dd*f**2*g2*s**2 - 12*D1*Dd*f**2*g2*s + 6*D1*Dd*f**2*g2 + 144*D1*Dd*f**2*gd2*s**2 - 36*D1*Dd*f**2*gd2*s + 288*D1*Dd*f*fd*g2*s**2 - 216*D1*Dd*f*fd*g2*s + 36*D1*Dd*f*fd*g2 - 540*D1*Ddd*f**4*r*s + 135*D1*Ddd*f**4*r - 648*D1*Ddd*f**4*s**2 + 594*D1*Ddd*f**4*s - 162*D1*Ddd*f**4 + 40*D1*Ddd*f**3*r*s - 10*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 20*D1*Ddd*f**3 + 72*D1*Ddd*f**2*g2*s**2 - 36*D1*Ddd*f**2*g2*s + 18*D1*Ddd*f**2*g2 - 3*D1*bd1*f*(D1*(3*f**2*(2*r*(11*s - 5) + 26*s**2 - 48*s + 21) + f*(-6*fd*(3*r*(22*s - 7) + 66*s**2 - 80*s + 13) + s*(-2*r + s*(K - 3) + 2)) + 6*fd*(-4*r*s + r + (2*s - 1)*(s*(K - 3) + 1))) - 6*Dd*f*(-4*K*s**2 + K*s + f*(88*r*s - 31*r + 88*s**2 - 116*s + 28) + r*(8*s - 1) + 12*s**2 - 9*s + 1)) - 1620*Dd**2*f**4*r*s + 405*Dd**2*f**4*r - 1944*Dd**2*f**4*s**2 + 1782*Dd**2*f**4*s - 270*Dd**2*f**4 + 120*Dd**2*f**3*r*s - 30*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 20*Dd**2*f**3 + 216*Dd**2*f**2*g2*s**2 - 108*Dd**2*f**2*g2*s + 36*b1**2*(D1**2*s*(4*r + 4*s - 3)*(2*f*fd - f*fdd - fd**2) + D1*f*(4*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - Dd*fd*(8*s - 1)*(4*r + 4*s - 3) + 2*Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 3*b1*(-2*D1**2*K*f*fd*s**2 + 2*D1**2*K*f*fd*s - D1**2*K*f*fd - 6*D1**2*K*f*fdd*s**2 + 6*D1**2*K*f*fdd*s - 3*D1**2*K*f*fdd - 6*D1**2*K*fd**2*s**2 + 6*D1**2*K*fd**2*s - 12*D1**2*bdd1*f**2*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 198*D1**2*f**2*fd*r*s + 36*D1**2*f**2*fd*r - 234*D1**2*f**2*fd*s**2 + 144*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 198*D1**2*f**2*fdd*r*s - 36*D1**2*f**2*fdd*r + 198*D1**2*f**2*fdd*s**2 - 156*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd + 396*D1**2*f*fd**2*r*s - 72*D1**2*f*fd**2*r + 396*D1**2*f*fd**2*s**2 - 312*D1**2*f*fd**2*s + 54*D1**2*f*fd**2 + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 6*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s + 3*D1**2*f*fd + 12*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 12*D1**2*fd**2*r*s - 6*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 4*D1*Dd*K*f**2*s**2 + 2*D1*Dd*K*f**2*s - D1*Dd*K*f**2 - 48*D1*Dd*K*f*fd*s**2 + 36*D1*Dd*K*f*fd*s - 6*D1*Dd*K*f*fd - 264*D1*Dd*f**3*r*s + 66*D1*Dd*f**3*r - 312*D1*Dd*f**3*s**2 + 288*D1*Dd*f**3*s - 78*D1*Dd*f**3 + 1584*D1*Dd*f**2*fd*r*s - 342*D1*Dd*f**2*fd*r + 1584*D1*Dd*f**2*fd*s**2 - 1416*D1*Dd*f**2*fd*s + 228*D1*Dd*f**2*fd + 8*D1*Dd*f**2*r*s - 2*D1*Dd*f**2*r + 12*D1*Dd*f**2*s**2 - 10*D1*Dd*f**2*s + 3*D1*Dd*f**2 + 96*D1*Dd*f*fd*r*s - 36*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 132*D1*Dd*f*fd*s + 30*D1*Dd*f*fd - 12*D1*Ddd*K*f**2*s**2 + 6*D1*Ddd*K*f**2*s - 3*D1*Ddd*K*f**2 + 264*D1*Ddd*f**3*r*s - 66*D1*Ddd*f**3*r + 264*D1*Ddd*f**3*s**2 - 264*D1*Ddd*f**3*s + 66*D1*Ddd*f**3 + 24*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 12*D1*bd1*f*(2*D1*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - D1*fd*(4*s - 1)*(4*r + 4*s - 3) - Dd*f*(8*s - 3)*(4*r + 4*s - 3)) - 36*Dd**2*K*f**2*s**2 + 18*Dd**2*K*f**2*s + 792*Dd**2*f**3*r*s - 198*Dd**2*f**3*r + 792*Dd**2*f**3*s**2 - 792*Dd**2*f**3*s + 132*Dd**2*f**3 + 72*Dd**2*f**2*r*s - 18*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 12*Dd**2*f**2))/(315*d**2*k2**2*k3**4) + D1**2*Pk2*Pk3*k1**4*(-D1*(42*D1*bd1**2*f*(f*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + r*(2*s - 1) - (s - 1)*(s*(K - 3) + 1)) - 3*D1*bdd1*f*(7*f**2*(5*r*(s - 1) + 2*s**2 - 6*s + 3) - 10*f*(s - 1)*(-C*s + C + r + 2*s - 2) - 14*g2*(s - 1)**2) + bd1*(D1*(21*f**3*(5*r*(s - 1) + 2*s**2 - 6*s + 3) + 3*f**2*(6*C*(s - 1)**2 - 7*fd*(2*s - 1)*(15*r + 6*s - 10) - (6*s - 6)*(r + 2*s - 2)) + 2*f*(15*fd*(r*(4*s - 2) - (s - 1)*(s*(4*C - 8) + 1)) + (7 - 7*s)*(g2*(s - 1) - 6*gd2*s)) + 84*fd*g2*s*(s - 1)) - 3*Dd*f*(7*f**2*(5*r*(8*s - 5) + 16*s**2 - 38*s + 16) + 10*f*(2*C*(4*s**2 - 5*s + 1) - 8*r*s + 5*r - 16*s**2 + 22*s - 6) - 28*g2*(4*s**2 - 5*s + 1)))) + 7*b1**2*(D1**2*s*(6*f*(fd - fdd)*(4*r + 4*s - 3) - 6*fd**2*(4*r + 4*s - 3) + 2*fd*r - fd*s*(K - 3) - 6*fdd*r + 3*fdd*s*(K - 3)) + D1*(Dd*(12*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(4*K*s**2 - 2*K*s + K + 6*fd*(8*s - 1)*(4*r + 4*s - 3) - 8*r*s + 2*r - 12*s**2 + 10*s - 3) + 6*fd*(-8*r*s + r + s*(4*K*s - K - 12*s + 5))) - 3*Ddd*f*(K*(-4*s**2 + 2*s - 1) + 4*f*(r*(4*s - 1) + (1 - 2*s)**2) + 8*r*s - 2*r + 12*s**2 - 10*s + 3)) - 6*Dd**2*f*(-6*K*s**2 + 3*K*s + f*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + 3*r*(4*s - 1) + 18*s**2 - 15*s + 2)) + b1*(-36*C*D1**2*f*fd*s**2 + 60*C*D1**2*f*fdd*s**2 + 60*C*D1**2*fd**2*s**2 - 72*C*D1*Dd*f**2*s**2 + 36*C*D1*Dd*f**2*s - 18*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*s**2 - 120*C*D1*Dd*f*fd*s + 120*C*D1*Ddd*f**2*s**2 - 60*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*s**2 - 180*C*Dd**2*f**2*s - 21*D1**2*bdd1*f*(K*(-2*s**2 + 2*s - 1) + 2*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + 4*r*s - 2*r + 6*s**2 - 8*s + 3) - 315*D1**2*f**2*fd*r*s - 126*D1**2*f**2*fd*s**2 + 168*D1**2*f**2*fd*s + 21*D1**2*f**2*fd + 315*D1**2*f**2*fdd*r*s + 126*D1**2*f**2*fdd*s**2 - 168*D1**2*f**2*fdd*s - 21*D1**2*f**2*fdd + 630*D1**2*f*fd**2*r*s + 252*D1**2*f*fd**2*s**2 - 336*D1**2*f*fd**2*s + 36*D1**2*f*fd*r*s + 72*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s - 60*D1**2*f*fdd*r*s - 120*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s + 14*D1**2*f*gd2*s**2 - 42*D1**2*f*gdd2*s**2 - 60*D1**2*fd**2*r*s - 120*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 14*D1**2*fd*g2*s**2 - 84*D1**2*fd*gd2*s**2 - 42*D1**2*fdd*g2*s**2 - 420*D1*Dd*f**3*r*s + 105*D1*Dd*f**3*r - 168*D1*Dd*f**3*s**2 + 294*D1*Dd*f**3*s - 42*D1*Dd*f**3 + 2520*D1*Dd*f**2*fd*r*s - 315*D1*Dd*f**2*fd*r + 1008*D1*Dd*f**2*fd*s**2 - 1554*D1*Dd*f**2*fd*s + 168*D1*Dd*f**2*fd + 72*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 108*D1*Dd*f**2*s + 36*D1*Dd*f**2 - 480*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r - 960*D1*Dd*f*fd*s**2 + 480*D1*Dd*f*fd*s - 30*D1*Dd*f*fd + 56*D1*Dd*f*g2*s**2 - 28*D1*Dd*f*g2*s + 14*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*s**2 + 84*D1*Dd*f*gd2*s - 336*D1*Dd*fd*g2*s**2 + 84*D1*Dd*fd*g2*s + 420*D1*Ddd*f**3*r*s - 105*D1*Ddd*f**3*r + 168*D1*Ddd*f**3*s**2 - 294*D1*Ddd*f**3*s + 42*D1*Ddd*f**3 - 120*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 240*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 60*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*s**2 + 84*D1*Ddd*f*g2*s - 42*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(6*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - f*(2*K*s**2 - 2*K*s + K + 6*fd*(4*s - 1)*(4*r + 4*s - 3) - 4*r*s + 2*r - 6*s**2 + 8*s - 3) + 6*fd*(-4*r*s + r + s*(2*K*s - K - 6*s + 4))) - 6*Dd*f*(K*(-8*s**2 + 6*s - 1) + f*(8*s - 3)*(4*r + 4*s - 3) + 16*r*s - 6*r + 24*s**2 - 26*s + 6)) + 1260*Dd**2*f**3*r*s - 315*Dd**2*f**3*r + 504*Dd**2*f**3*s**2 - 882*Dd**2*f**3*s + 210*Dd**2*f**3 - 360*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 720*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 60*Dd**2*f**2 - 504*Dd**2*f*g2*s**2 + 252*Dd**2*f*g2*s))/(105*d**2*k2**2*k3**4) - 12*D1**2*Pk2*Pk3*k1**2*k2**4*st**4*(18*C*D1**2*f**2*fd*r**2 + 36*C*D1**2*f**2*fd*r*s - 24*C*D1**2*f**2*fd*r + 18*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 12*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 16*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 16*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 32*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 32*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 24*C*D1*Dd*f**3*r**2 + 48*C*D1*Dd*f**3*r*s - 36*C*D1*Dd*f**3*r + 24*C*D1*Dd*f**3*s**2 - 36*C*D1*Dd*f**3*s + 18*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 136*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 136*C*D1*Dd*f**2*fd*s - 48*C*D1*Dd*f**2*fd - 16*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 24*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 48*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 72*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s - 24*C*Dd**2*f**3 - 6*D1**2*K*bdd1*f**2*r**2 - 12*D1**2*K*bdd1*f**2*r*s + 12*D1**2*K*bdd1*f**2*r - 6*D1**2*K*bdd1*f**2*s**2 + 12*D1**2*K*bdd1*f**2*s - 6*D1**2*K*bdd1*f**2 + 10*D1**2*bd1**2*f**2*(r + s - 1)**2 - 9*D1**2*f**2*fd*r**2 - 18*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 9*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r*s - 8*D1**2*f**2*fdd*r + 6*D1**2*f**2*fdd*s**2 - 8*D1**2*f**2*fdd*s + 4*D1**2*f**2*fdd - 10*D1**2*f**2*gd2*r**2 - 20*D1**2*f**2*gd2*r*s + 20*D1**2*f**2*gd2*r - 10*D1**2*f**2*gd2*s**2 + 20*D1**2*f**2*gd2*s - 10*D1**2*f**2*gd2 + 12*D1**2*f**2*gdd2*r**2 + 24*D1**2*f**2*gdd2*r*s - 24*D1**2*f**2*gdd2*r + 12*D1**2*f**2*gdd2*s**2 - 24*D1**2*f**2*gdd2*s + 12*D1**2*f**2*gdd2 + 12*D1**2*f*fd**2*r**2 + 24*D1**2*f*fd**2*r*s - 16*D1**2*f*fd**2*r + 12*D1**2*f*fd**2*s**2 - 16*D1**2*f*fd**2*s + 4*D1**2*f*fd**2 - 20*D1**2*f*fd*g2*r**2 - 40*D1**2*f*fd*g2*r*s + 20*D1**2*f*fd*g2*r - 20*D1**2*f*fd*g2*s**2 + 20*D1**2*f*fd*g2*s - 10*D1**2*f*fd*g2 + 48*D1**2*f*fd*gd2*r**2 + 96*D1**2*f*fd*gd2*r*s - 72*D1**2*f*fd*gd2*r + 48*D1**2*f*fd*gd2*s**2 - 72*D1**2*f*fd*gd2*s + 24*D1**2*f*fd*gd2 + 24*D1**2*f*fdd*g2*r**2 + 48*D1**2*f*fdd*g2*r*s - 24*D1**2*f*fdd*g2*r + 24*D1**2*f*fdd*g2*s**2 - 24*D1**2*f*fdd*g2*s + 12*D1**2*f*fdd*g2 + 24*D1**2*fd**2*g2*r**2 + 48*D1**2*fd**2*g2*r*s - 24*D1**2*fd**2*g2*r + 24*D1**2*fd**2*g2*s**2 - 24*D1**2*fd**2*g2*s - 12*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 + 18*D1*Dd*f**3*s - 9*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 96*D1*Dd*f**2*fd*r*s - 68*D1*Dd*f**2*fd*r + 48*D1*Dd*f**2*fd*s**2 - 68*D1*Dd*f**2*fd*s + 24*D1*Dd*f**2*fd - 40*D1*Dd*f**2*g2*r**2 - 80*D1*Dd*f**2*g2*r*s + 60*D1*Dd*f**2*g2*r - 40*D1*Dd*f**2*g2*s**2 + 60*D1*Dd*f**2*g2*s - 30*D1*Dd*f**2*g2 + 96*D1*Dd*f**2*gd2*r**2 + 192*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 96*D1*Dd*f**2*gd2*s**2 - 168*D1*Dd*f**2*gd2*s + 72*D1*Dd*f**2*gd2 + 192*D1*Dd*f*fd*g2*r**2 + 384*D1*Dd*f*fd*g2*r*s - 240*D1*Dd*f*fd*g2*r + 192*D1*Dd*f*fd*g2*s**2 - 240*D1*Dd*f*fd*g2*s + 72*D1*Dd*f*fd*g2 + 8*D1*Ddd*f**3*r**2 + 16*D1*Ddd*f**3*r*s - 12*D1*Ddd*f**3*r + 8*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 6*D1*Ddd*f**3 + 48*D1*Ddd*f**2*g2*r**2 + 96*D1*Ddd*f**2*g2*r*s - 72*D1*Ddd*f**2*g2*r + 48*D1*Ddd*f**2*g2*s**2 - 72*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(5*K*f*(r + s - 1) - 12*K*fd*(2*r + 2*s - 1) + 2*f**2*(r + s - 1)) - 12*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + 24*Dd**2*f**3*r**2 + 48*Dd**2*f**3*r*s - 36*Dd**2*f**3*r + 24*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 12*Dd**2*f**3 + 144*Dd**2*f**2*g2*r**2 + 288*Dd**2*f**2*g2*r*s - 216*Dd**2*f**2*g2*r + 144*Dd**2*f**2*g2*s**2 - 216*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 - 5*b1**2*(D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(10*D1**2*K*f*fd*r**2 + 20*D1**2*K*f*fd*r*s - 10*D1**2*K*f*fd*r + 10*D1**2*K*f*fd*s**2 - 10*D1**2*K*f*fd*s + 5*D1**2*K*f*fd - 12*D1**2*K*f*fdd*r**2 - 24*D1**2*K*f*fdd*r*s + 12*D1**2*K*f*fdd*r - 12*D1**2*K*f*fdd*s**2 + 12*D1**2*K*f*fdd*s - 6*D1**2*K*f*fdd - 12*D1**2*K*fd**2*r**2 - 24*D1**2*K*fd**2*r*s + 12*D1**2*K*fd**2*r - 12*D1**2*K*fd**2*s**2 + 12*D1**2*K*fd**2*s + 10*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd + 20*D1*Dd*K*f**2*r**2 + 40*D1*Dd*K*f**2*r*s - 30*D1*Dd*K*f**2*r + 20*D1*Dd*K*f**2*s**2 - 30*D1*Dd*K*f**2*s + 15*D1*Dd*K*f**2 - 96*D1*Dd*K*f*fd*r**2 - 192*D1*Dd*K*f*fd*r*s + 120*D1*Dd*K*f*fd*r - 96*D1*Dd*K*f*fd*s**2 + 120*D1*Dd*K*f*fd*s - 36*D1*Dd*K*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Ddd*K*f**2*r**2 - 48*D1*Ddd*K*f**2*r*s + 36*D1*Ddd*K*f**2*r - 24*D1*Ddd*K*f**2*s**2 + 36*D1*Ddd*K*f**2*s - 18*D1*Ddd*K*f**2 - 20*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 72*Dd**2*K*f**2*r**2 - 144*Dd**2*K*f**2*r*s + 108*Dd**2*K*f**2*r - 72*Dd**2*K*f**2*s**2 + 108*Dd**2*K*f**2*s - 36*Dd**2*K*f**2))/(35*d**2*k3**8) - 4*D1**2*Pk2*Pk3*k1**2*k2**4*st**2*(116*C*D1**2*b1*f*fd*r**2 + 232*C*D1**2*b1*f*fd*r*s - 116*C*D1**2*b1*f*fd*r + 116*C*D1**2*b1*f*fd*s**2 - 116*C*D1**2*b1*f*fd*s + 58*C*D1**2*b1*f*fd - 72*C*D1**2*b1*f*fdd*r**2 - 144*C*D1**2*b1*f*fdd*r*s + 72*C*D1**2*b1*f*fdd*r - 72*C*D1**2*b1*f*fdd*s**2 + 72*C*D1**2*b1*f*fdd*s - 36*C*D1**2*b1*f*fdd - 72*C*D1**2*b1*fd**2*r**2 - 144*C*D1**2*b1*fd**2*r*s + 72*C*D1**2*b1*fd**2*r - 72*C*D1**2*b1*fd**2*s**2 + 72*C*D1**2*b1*fd**2*s - 18*C*D1**2*f**2*fd*r**2 - 36*C*D1**2*f**2*fd*r*s + 24*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 12*C*D1**2*f**2*fd + 232*C*D1*Dd*b1*f**2*r**2 + 464*C*D1*Dd*b1*f**2*r*s - 348*C*D1*Dd*b1*f**2*r + 232*C*D1*Dd*b1*f**2*s**2 - 348*C*D1*Dd*b1*f**2*s + 174*C*D1*Dd*b1*f**2 - 576*C*D1*Dd*b1*f*fd*r**2 - 1152*C*D1*Dd*b1*f*fd*r*s + 720*C*D1*Dd*b1*f*fd*r - 576*C*D1*Dd*b1*f*fd*s**2 + 720*C*D1*Dd*b1*f*fd*s - 216*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r**2 - 48*C*D1*Dd*f**3*r*s + 36*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 36*C*D1*Dd*f**3*s - 18*C*D1*Dd*f**3 - 144*C*D1*Ddd*b1*f**2*r**2 - 288*C*D1*Ddd*b1*f**2*r*s + 216*C*D1*Ddd*b1*f**2*r - 144*C*D1*Ddd*b1*f**2*s**2 + 216*C*D1*Ddd*b1*f**2*s - 108*C*D1*Ddd*b1*f**2 - 432*C*Dd**2*b1*f**2*r**2 - 864*C*Dd**2*b1*f**2*r*s + 648*C*Dd**2*b1*f**2*r - 432*C*Dd**2*b1*f**2*s**2 + 648*C*Dd**2*b1*f**2*s - 216*C*Dd**2*b1*f**2 + 49*D1**2*K*b1**2*fd*r**2 + 98*D1**2*K*b1**2*fd*r*s + 49*D1**2*K*b1**2*fd*s**2 - 42*D1**2*K*b1**2*fdd*r**2 - 84*D1**2*K*b1**2*fdd*r*s - 42*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 84*D1**2*K*bd1**2*f*(r + s - 1)**2 + 42*D1**2*b1**2*f*fd*r**2 + 84*D1**2*b1**2*f*fd*r*s - 42*D1**2*b1**2*f*fd*r + 42*D1**2*b1**2*f*fd*s**2 - 42*D1**2*b1**2*f*fd*s + 21*D1**2*b1**2*f*fd - 58*D1**2*b1*f*fd*r**2 - 116*D1**2*b1*f*fd*r*s + 58*D1**2*b1*f*fd*r - 58*D1**2*b1*f*fd*s**2 + 58*D1**2*b1*f*fd*s - 29*D1**2*b1*f*fd + 36*D1**2*b1*f*fdd*r**2 + 72*D1**2*b1*f*fdd*r*s - 36*D1**2*b1*f*fdd*r + 36*D1**2*b1*f*fdd*s**2 - 36*D1**2*b1*f*fdd*s + 18*D1**2*b1*f*fdd - 98*D1**2*b1*f*gd2*r**2 - 196*D1**2*b1*f*gd2*r*s + 196*D1**2*b1*f*gd2*r - 98*D1**2*b1*f*gd2*s**2 + 196*D1**2*b1*f*gd2*s - 98*D1**2*b1*f*gd2 + 84*D1**2*b1*f*gdd2*r**2 + 168*D1**2*b1*f*gdd2*r*s - 168*D1**2*b1*f*gdd2*r + 84*D1**2*b1*f*gdd2*s**2 - 168*D1**2*b1*f*gdd2*s + 84*D1**2*b1*f*gdd2 + 36*D1**2*b1*fd**2*r**2 + 72*D1**2*b1*fd**2*r*s - 36*D1**2*b1*fd**2*r + 36*D1**2*b1*fd**2*s**2 - 36*D1**2*b1*fd**2*s - 98*D1**2*b1*fd*g2*r**2 - 196*D1**2*b1*fd*g2*r*s - 98*D1**2*b1*fd*g2*s**2 + 168*D1**2*b1*fd*gd2*r**2 + 336*D1**2*b1*fd*gd2*r*s - 168*D1**2*b1*fd*gd2*r + 168*D1**2*b1*fd*gd2*s**2 - 168*D1**2*b1*fd*gd2*s + 84*D1**2*b1*fdd*g2*r**2 + 168*D1**2*b1*fdd*g2*r*s + 84*D1**2*b1*fdd*g2*s**2 - 6*D1**2*bdd1*f*(r + s - 1)**2*(6*C*f + 14*K*b1 - 3*f - 14*g2) + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 196*D1*Dd*K*b1**2*f*r**2 + 392*D1*Dd*K*b1**2*f*r*s - 294*D1*Dd*K*b1**2*f*r + 196*D1*Dd*K*b1**2*f*s**2 - 294*D1*Dd*K*b1**2*f*s + 147*D1*Dd*K*b1**2*f - 336*D1*Dd*K*b1**2*fd*r**2 - 672*D1*Dd*K*b1**2*fd*r*s + 252*D1*Dd*K*b1**2*fd*r - 336*D1*Dd*K*b1**2*fd*s**2 + 252*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 + 84*D1*Dd*b1**2*f**2*r**2 + 168*D1*Dd*b1**2*f**2*r*s - 126*D1*Dd*b1**2*f**2*r + 84*D1*Dd*b1**2*f**2*s**2 - 126*D1*Dd*b1**2*f**2*s + 63*D1*Dd*b1**2*f**2 - 116*D1*Dd*b1*f**2*r**2 - 232*D1*Dd*b1*f**2*r*s + 174*D1*Dd*b1*f**2*r - 116*D1*Dd*b1*f**2*s**2 + 174*D1*Dd*b1*f**2*s - 87*D1*Dd*b1*f**2 + 288*D1*Dd*b1*f*fd*r**2 + 576*D1*Dd*b1*f*fd*r*s - 360*D1*Dd*b1*f*fd*r + 288*D1*Dd*b1*f*fd*s**2 - 360*D1*Dd*b1*f*fd*s + 108*D1*Dd*b1*f*fd - 392*D1*Dd*b1*f*g2*r**2 - 784*D1*Dd*b1*f*g2*r*s + 588*D1*Dd*b1*f*g2*r - 392*D1*Dd*b1*f*g2*s**2 + 588*D1*Dd*b1*f*g2*s - 294*D1*Dd*b1*f*g2 + 672*D1*Dd*b1*f*gd2*r**2 + 1344*D1*Dd*b1*f*gd2*r*s - 1176*D1*Dd*b1*f*gd2*r + 672*D1*Dd*b1*f*gd2*s**2 - 1176*D1*Dd*b1*f*gd2*s + 504*D1*Dd*b1*f*gd2 + 672*D1*Dd*b1*fd*g2*r**2 + 1344*D1*Dd*b1*fd*g2*r*s - 504*D1*Dd*b1*fd*g2*r + 672*D1*Dd*b1*fd*g2*s**2 - 504*D1*Dd*b1*fd*g2*s + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 168*D1*Ddd*K*b1**2*f*r**2 - 336*D1*Ddd*K*b1**2*f*r*s + 252*D1*Ddd*K*b1**2*f*r - 168*D1*Ddd*K*b1**2*f*s**2 + 252*D1*Ddd*K*b1**2*f*s - 126*D1*Ddd*K*b1**2*f + 72*D1*Ddd*b1*f**2*r**2 + 144*D1*Ddd*b1*f**2*r*s - 108*D1*Ddd*b1*f**2*r + 72*D1*Ddd*b1*f**2*s**2 - 108*D1*Ddd*b1*f**2*s + 54*D1*Ddd*b1*f**2 + 336*D1*Ddd*b1*f*g2*r**2 + 672*D1*Ddd*b1*f*g2*r*s - 504*D1*Ddd*b1*f*g2*r + 336*D1*Ddd*b1*f*g2*s**2 - 504*D1*Ddd*b1*f*g2*s + 252*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(58*C - 7*K + 42*b1 - 29) - 2*f*(fd*(36*C - 18)*(2*r + 2*s - 1) + (r + s - 1)*(-49*K*b1 + 49*g2 - 84*gd2)) + 168*fd*(r + s)*(-K*b1 + g2)) - 12*Dd*f*(4*r + 4*s - 3)*(6*C*f + 14*K*b1 - 3*f - 14*g2))*(r + s - 1) - 504*Dd**2*K*b1**2*f*r**2 - 1008*Dd**2*K*b1**2*f*r*s + 756*Dd**2*K*b1**2*f*r - 504*Dd**2*K*b1**2*f*s**2 + 756*Dd**2*K*b1**2*f*s - 252*Dd**2*K*b1**2*f + 216*Dd**2*b1*f**2*r**2 + 432*Dd**2*b1*f**2*r*s - 324*Dd**2*b1*f**2*r + 216*Dd**2*b1*f**2*s**2 - 324*Dd**2*b1*f**2*s + 108*Dd**2*b1*f**2 + 1008*Dd**2*b1*f*g2*r**2 + 2016*Dd**2*b1*f*g2*r*s - 1512*Dd**2*b1*f*g2*r + 1008*Dd**2*b1*f*g2*s**2 - 1512*Dd**2*b1*f*g2*s + 504*Dd**2*b1*f*g2)/(35*d**2*k3**8) + 4*D1**2*Pk2*Pk3*k1**2*k2**2*st**4*(42*C*D1**2*f**2*fd*r**2 + 72*C*D1**2*f**2*fd*r*s - 52*C*D1**2*f**2*fd*r + 30*C*D1**2*f**2*fd*s**2 - 44*C*D1**2*f**2*fd*s + 24*C*D1**2*f**2*fd - 24*C*D1**2*f**2*fdd*r**2 - 48*C*D1**2*f**2*fdd*r*s + 32*C*D1**2*f**2*fdd*r - 24*C*D1**2*f**2*fdd*s**2 + 32*C*D1**2*f**2*fdd*s - 16*C*D1**2*f**2*fdd - 48*C*D1**2*f*fd**2*r**2 - 96*C*D1**2*f*fd**2*r*s + 64*C*D1**2*f*fd**2*r - 48*C*D1**2*f*fd**2*s**2 + 64*C*D1**2*f*fd**2*s - 16*C*D1**2*f*fd**2 + 56*C*D1*Dd*f**3*r**2 + 96*C*D1*Dd*f**3*r*s - 80*C*D1*Dd*f**3*r + 40*C*D1*Dd*f**3*s**2 - 68*C*D1*Dd*f**3*s + 38*C*D1*Dd*f**3 - 192*C*D1*Dd*f**2*fd*r**2 - 384*C*D1*Dd*f**2*fd*r*s + 272*C*D1*Dd*f**2*fd*r - 192*C*D1*Dd*f**2*fd*s**2 + 272*C*D1*Dd*f**2*fd*s - 96*C*D1*Dd*f**2*fd - 32*C*D1*Ddd*f**3*r**2 - 64*C*D1*Ddd*f**3*r*s + 48*C*D1*Ddd*f**3*r - 32*C*D1*Ddd*f**3*s**2 + 48*C*D1*Ddd*f**3*s - 24*C*D1*Ddd*f**3 - 96*C*Dd**2*f**3*r**2 - 192*C*Dd**2*f**3*r*s + 144*C*Dd**2*f**3*r - 96*C*Dd**2*f**3*s**2 + 144*C*Dd**2*f**3*s - 48*C*Dd**2*f**3 + 34*D1**2*K*b1*f*fd*r**2 + 40*D1**2*K*b1*f*fd*r*s - 20*D1**2*K*b1*f*fd*r + 6*D1**2*K*b1*f*fd*s**2 - 6*D1**2*K*b1*f*fd*s + 3*D1**2*K*b1*f*fd - 24*D1**2*K*b1*f*fdd*r**2 - 48*D1**2*K*b1*f*fdd*r*s + 24*D1**2*K*b1*f*fdd*r - 24*D1**2*K*b1*f*fdd*s**2 + 24*D1**2*K*b1*f*fdd*s - 12*D1**2*K*b1*f*fdd - 24*D1**2*K*b1*fd**2*r**2 - 48*D1**2*K*b1*fd**2*r*s + 24*D1**2*K*b1*fd**2*r - 24*D1**2*K*b1*fd**2*s**2 + 24*D1**2*K*b1*fd**2*s - 12*D1**2*K*bdd1*f**2*r**2 - 24*D1**2*K*bdd1*f**2*r*s + 24*D1**2*K*bdd1*f**2*r - 12*D1**2*K*bdd1*f**2*s**2 + 24*D1**2*K*bdd1*f**2*s - 12*D1**2*K*bdd1*f**2 - 8*D1**2*b1**2*f*fd*r**2 - 16*D1**2*b1**2*f*fd*r*s - 8*D1**2*b1**2*f*fd*s**2 + 4*D1**2*b1**2*f*fdd*r**2 + 8*D1**2*b1**2*f*fdd*r*s + 4*D1**2*b1**2*f*fdd*s**2 + 4*D1**2*b1**2*fd**2*r**2 + 8*D1**2*b1**2*fd**2*r*s + 4*D1**2*b1**2*fd**2*s**2 - 4*D1**2*b1**2*fd**2 + 4*D1**2*b1*bdd1*f**2*r**2 + 8*D1**2*b1*bdd1*f**2*r*s - 12*D1**2*b1*bdd1*f**2*r + 4*D1**2*b1*bdd1*f**2*s**2 - 12*D1**2*b1*bdd1*f**2*s + 6*D1**2*b1*bdd1*f**2 - 39*D1**2*b1*f**2*fd*r*s + 6*D1**2*b1*f**2*fd*r - 39*D1**2*b1*f**2*fd*s**2 + 32*D1**2*b1*f**2*fd*s - 7*D1**2*b1*f**2*fd + 15*D1**2*b1*f**2*fdd*r**2 + 57*D1**2*b1*f**2*fdd*r*s - 22*D1**2*b1*f**2*fdd*r + 42*D1**2*b1*f**2*fdd*s**2 - 40*D1**2*b1*f**2*fdd*s + 12*D1**2*b1*f**2*fdd + 30*D1**2*b1*f*fd**2*r**2 + 114*D1**2*b1*f*fd**2*r*s - 44*D1**2*b1*f*fd**2*r + 84*D1**2*b1*f*fd**2*s**2 - 80*D1**2*b1*f*fd**2*s + 12*D1**2*b1*f*fd**2 - 12*D1**2*b1*f*fd*r**2 - 10*D1**2*b1*f*fd*r*s + 5*D1**2*b1*f*fd*r + 2*D1**2*b1*f*fd*s**2 - 2*D1**2*b1*f*fd*s + D1**2*b1*f*fd + 6*D1**2*b1*f*fdd*r**2 + 12*D1**2*b1*f*fdd*r*s - 6*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 - 6*D1**2*b1*f*fdd*s + 3*D1**2*b1*f*fdd + 6*D1**2*b1*fd**2*r**2 + 12*D1**2*b1*fd**2*r*s - 6*D1**2*b1*fd**2*r + 6*D1**2*b1*fd**2*s**2 - 6*D1**2*b1*fd**2*s + 10*D1**2*b2*f*fd*r**2 + 20*D1**2*b2*f*fd*r*s - 10*D1**2*b2*f*fd*r + 10*D1**2*b2*f*fd*s**2 - 10*D1**2*b2*f*fd*s + 5*D1**2*b2*f*fd - 12*D1**2*b2*f*fdd*r**2 - 24*D1**2*b2*f*fdd*r*s + 12*D1**2*b2*f*fdd*r - 12*D1**2*b2*f*fdd*s**2 + 12*D1**2*b2*f*fdd*s - 6*D1**2*b2*f*fdd - 12*D1**2*b2*fd**2*r**2 - 24*D1**2*b2*fd**2*r*s + 12*D1**2*b2*fd**2*r - 12*D1**2*b2*fd**2*s**2 + 12*D1**2*b2*fd**2*s + 4*D1**2*bd1**2*f**2*(r**2 + r*(2*s - 3) + s**2 - 3*s + 2) + 5*D1**2*bdd1*f**3*r**2 + 19*D1**2*bdd1*f**3*r*s - 17*D1**2*bdd1*f**3*r + 14*D1**2*bdd1*f**3*s**2 - 26*D1**2*bdd1*f**3*s + 12*D1**2*bdd1*f**3 + 3*D1**2*bdd1*f**2*r**2 + 6*D1**2*bdd1*f**2*r*s - 6*D1**2*bdd1*f**2*r + 3*D1**2*bdd1*f**2*s**2 - 6*D1**2*bdd1*f**2*s + 3*D1**2*bdd1*f**2 - 6*D1**2*bdd2*f**2*r**2 - 12*D1**2*bdd2*f**2*r*s + 12*D1**2*bdd2*f**2*r - 6*D1**2*bdd2*f**2*s**2 + 12*D1**2*bdd2*f**2*s - 6*D1**2*bdd2*f**2 - 27*D1**2*f**2*fd*r**2 - 45*D1**2*f**2*fd*r*s + 33*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 27*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd - 34*D1**2*f**2*gd2*r**2 - 40*D1**2*f**2*gd2*r*s + 68*D1**2*f**2*gd2*r - 6*D1**2*f**2*gd2*s**2 + 40*D1**2*f**2*gd2*s - 34*D1**2*f**2*gd2 + 24*D1**2*f**2*gdd2*r**2 + 48*D1**2*f**2*gdd2*r*s - 48*D1**2*f**2*gdd2*r + 24*D1**2*f**2*gdd2*s**2 - 48*D1**2*f**2*gdd2*s + 24*D1**2*f**2*gdd2 + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 - 68*D1**2*f*fd*g2*r**2 - 80*D1**2*f*fd*g2*r*s + 40*D1**2*f*fd*g2*r - 12*D1**2*f*fd*g2*s**2 + 12*D1**2*f*fd*g2*s - 6*D1**2*f*fd*g2 + 96*D1**2*f*fd*gd2*r**2 + 192*D1**2*f*fd*gd2*r*s - 144*D1**2*f*fd*gd2*r + 96*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 48*D1**2*f*fd*gd2 + 48*D1**2*f*fdd*g2*r**2 + 96*D1**2*f*fdd*g2*r*s - 48*D1**2*f*fdd*g2*r + 48*D1**2*f*fdd*g2*s**2 - 48*D1**2*f*fdd*g2*s + 24*D1**2*f*fdd*g2 + 48*D1**2*fd**2*g2*r**2 + 96*D1**2*fd**2*g2*r*s - 48*D1**2*fd**2*g2*r + 48*D1**2*fd**2*g2*s**2 - 48*D1**2*fd**2*g2*s + 68*D1*Dd*K*b1*f**2*r**2 + 80*D1*Dd*K*b1*f**2*r*s - 88*D1*Dd*K*b1*f**2*r + 12*D1*Dd*K*b1*f**2*s**2 - 46*D1*Dd*K*b1*f**2*s + 37*D1*Dd*K*b1*f**2 - 192*D1*Dd*K*b1*f*fd*r**2 - 384*D1*Dd*K*b1*f*fd*r*s + 240*D1*Dd*K*b1*f*fd*r - 192*D1*Dd*K*b1*f*fd*s**2 + 240*D1*Dd*K*b1*f*fd*s - 72*D1*Dd*K*b1*f*fd - 16*D1*Dd*b1**2*f**2*r**2 - 32*D1*Dd*b1**2*f**2*r*s + 24*D1*Dd*b1**2*f**2*r - 16*D1*Dd*b1**2*f**2*s**2 + 24*D1*Dd*b1**2*f**2*s - 12*D1*Dd*b1**2*f**2 + 32*D1*Dd*b1**2*f*fd*r**2 + 64*D1*Dd*b1**2*f*fd*r*s - 24*D1*Dd*b1**2*f*fd*r + 32*D1*Dd*b1**2*f*fd*s**2 - 24*D1*Dd*b1**2*f*fd*s - 52*D1*Dd*b1*f**3*r*s + 13*D1*Dd*b1*f**3*r - 52*D1*Dd*b1*f**3*s**2 + 52*D1*Dd*b1*f**3*s - 13*D1*Dd*b1*f**3 + 120*D1*Dd*b1*f**2*fd*r**2 + 456*D1*Dd*b1*f**2*fd*r*s - 205*D1*Dd*b1*f**2*fd*r + 336*D1*Dd*b1*f**2*fd*s**2 - 358*D1*Dd*b1*f**2*fd*s + 84*D1*Dd*b1*f**2*fd - 24*D1*Dd*b1*f**2*r**2 - 20*D1*Dd*b1*f**2*r*s + 29*D1*Dd*b1*f**2*r + 4*D1*Dd*b1*f**2*s**2 + 8*D1*Dd*b1*f**2*s - 11*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 96*D1*Dd*b1*f*fd*r*s - 60*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 60*D1*Dd*b1*f*fd*s + 18*D1*Dd*b1*f*fd + 20*D1*Dd*b2*f**2*r**2 + 40*D1*Dd*b2*f**2*r*s - 30*D1*Dd*b2*f**2*r + 20*D1*Dd*b2*f**2*s**2 - 30*D1*Dd*b2*f**2*s + 15*D1*Dd*b2*f**2 - 96*D1*Dd*b2*f*fd*r**2 - 192*D1*Dd*b2*f*fd*r*s + 120*D1*Dd*b2*f*fd*r - 96*D1*Dd*b2*f*fd*s**2 + 120*D1*Dd*b2*f*fd*s - 36*D1*Dd*b2*f*fd - 36*D1*Dd*f**3*r**2 - 60*D1*Dd*f**3*r*s + 51*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 42*D1*Dd*f**3*s - 24*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 170*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 170*D1*Dd*f**2*fd*s + 60*D1*Dd*f**2*fd - 136*D1*Dd*f**2*g2*r**2 - 160*D1*Dd*f**2*g2*r*s + 176*D1*Dd*f**2*g2*r - 24*D1*Dd*f**2*g2*s**2 + 92*D1*Dd*f**2*g2*s - 74*D1*Dd*f**2*g2 + 192*D1*Dd*f**2*gd2*r**2 + 384*D1*Dd*f**2*gd2*r*s - 336*D1*Dd*f**2*gd2*r + 192*D1*Dd*f**2*gd2*s**2 - 336*D1*Dd*f**2*gd2*s + 144*D1*Dd*f**2*gd2 + 384*D1*Dd*f*fd*g2*r**2 + 768*D1*Dd*f*fd*g2*r*s - 480*D1*Dd*f*fd*g2*r + 384*D1*Dd*f*fd*g2*s**2 - 480*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 - 48*D1*Ddd*K*b1*f**2*r**2 - 96*D1*Ddd*K*b1*f**2*r*s + 72*D1*Ddd*K*b1*f**2*r - 48*D1*Ddd*K*b1*f**2*s**2 + 72*D1*Ddd*K*b1*f**2*s - 36*D1*Ddd*K*b1*f**2 + 8*D1*Ddd*b1**2*f**2*r**2 + 16*D1*Ddd*b1**2*f**2*r*s - 12*D1*Ddd*b1**2*f**2*r + 8*D1*Ddd*b1**2*f**2*s**2 - 12*D1*Ddd*b1**2*f**2*s + 6*D1*Ddd*b1**2*f**2 + 20*D1*Ddd*b1*f**3*r**2 + 76*D1*Ddd*b1*f**3*r*s - 39*D1*Ddd*b1*f**3*r + 56*D1*Ddd*b1*f**3*s**2 - 66*D1*Ddd*b1*f**3*s + 24*D1*Ddd*b1*f**3 + 12*D1*Ddd*b1*f**2*r**2 + 24*D1*Ddd*b1*f**2*r*s - 18*D1*Ddd*b1*f**2*r + 12*D1*Ddd*b1*f**2*s**2 - 18*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 - 24*D1*Ddd*b2*f**2*r**2 - 48*D1*Ddd*b2*f**2*r*s + 36*D1*Ddd*b2*f**2*r - 24*D1*Ddd*b2*f**2*s**2 + 36*D1*Ddd*b2*f**2*s - 18*D1*Ddd*b2*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 96*D1*Ddd*f**2*g2*r**2 + 192*D1*Ddd*f**2*g2*r*s - 144*D1*Ddd*f**2*g2*r + 96*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 72*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(f**2*(r*(7 - 13*s) - 13*s**2 + 20*s - 6) + f*(-4*b1*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + fd*(30*r**2 + r*(114*s - 73) + 84*s**2 - 118*s + 36) + (r + s - 1)*(K*(17*r + 3*s - 17) - 6*r + s + 6)) + 2*fd*(-12*K + 4*b1 + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(4*b1*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + f*(40*r**2 + 152*r*s - 107*r + 112*s**2 - 170*s + 60) + (6 - 24*K)*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3))) + D1*bd2*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 144*Dd**2*K*b1*f**2*r**2 - 288*Dd**2*K*b1*f**2*r*s + 216*Dd**2*K*b1*f**2*r - 144*Dd**2*K*b1*f**2*s**2 + 216*Dd**2*K*b1*f**2*s - 72*Dd**2*K*b1*f**2 + 24*Dd**2*b1**2*f**2*r**2 + 48*Dd**2*b1**2*f**2*r*s - 36*Dd**2*b1**2*f**2*r + 24*Dd**2*b1**2*f**2*s**2 - 36*Dd**2*b1**2*f**2*s + 12*Dd**2*b1**2*f**2 + 60*Dd**2*b1*f**3*r**2 + 228*Dd**2*b1*f**3*r*s - 117*Dd**2*b1*f**3*r + 168*Dd**2*b1*f**3*s**2 - 198*Dd**2*b1*f**3*s + 48*Dd**2*b1*f**3 + 36*Dd**2*b1*f**2*r**2 + 72*Dd**2*b1*f**2*r*s - 54*Dd**2*b1*f**2*r + 36*Dd**2*b1*f**2*s**2 - 54*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 - 72*Dd**2*b2*f**2*r**2 - 144*Dd**2*b2*f**2*r*s + 108*Dd**2*b2*f**2*r - 72*Dd**2*b2*f**2*s**2 + 108*Dd**2*b2*f**2*s - 36*Dd**2*b2*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 30*Dd**2*f**3 + 288*Dd**2*f**2*g2*r**2 + 576*Dd**2*f**2*g2*r*s - 432*Dd**2*f**2*g2*r + 288*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 144*Dd**2*f**2*g2)/(35*d**2*k3**6) + 2*D1**2*Pk2*Pk3*k1**2*k2**2*st**2*(792*C*D1**2*bd1*f**2*r**2 + 1848*C*D1**2*bd1*f**2*r*s - 1824*C*D1**2*bd1*f**2*r + 1056*C*D1**2*bd1*f**2*s**2 - 2088*C*D1**2*bd1*f**2*s + 1044*C*D1**2*bd1*f**2 - 1584*C*D1**2*bd1*f*fd*r**2 - 4032*C*D1**2*bd1*f*fd*r*s + 2880*C*D1**2*bd1*f*fd*r - 2448*C*D1**2*bd1*f*fd*s**2 + 3528*C*D1**2*bd1*f*fd*s - 1080*C*D1**2*bd1*f*fd - 396*C*D1**2*bdd1*f**2*r**2 - 1008*C*D1**2*bdd1*f**2*r*s + 1080*C*D1**2*bdd1*f**2*r - 612*C*D1**2*bdd1*f**2*s**2 + 1296*C*D1**2*bdd1*f**2*s - 648*C*D1**2*bdd1*f**2 + 30*C*D1**2*f**2*fd*r**2 + 732*C*D1**2*f**2*fd*r*s - 264*C*D1**2*f**2*fd*r + 702*C*D1**2*f**2*fd*s**2 - 712*C*D1**2*f**2*fd*s + 244*C*D1**2*f**2*fd - 366*C*D1**2*f**2*fdd*r**2 - 1284*C*D1**2*f**2*fdd*r*s + 672*C*D1**2*f**2*fdd*r - 918*C*D1**2*f**2*fdd*s**2 + 1040*C*D1**2*f**2*fdd*s - 428*C*D1**2*f**2*fdd - 732*C*D1**2*f*fd**2*r**2 - 2568*C*D1**2*f*fd**2*r*s + 1344*C*D1**2*f*fd**2*r - 1836*C*D1**2*f*fd**2*s**2 + 2080*C*D1**2*f*fd**2*s - 428*C*D1**2*f*fd**2 - 3168*C*D1*Dd*bd1*f**2*r**2 - 8064*C*D1*Dd*bd1*f**2*r*s + 6912*C*D1*Dd*bd1*f**2*r - 4896*C*D1*Dd*bd1*f**2*s**2 + 8424*C*D1*Dd*bd1*f**2*s - 3456*C*D1*Dd*bd1*f**2 + 40*C*D1*Dd*f**3*r**2 + 976*C*D1*Dd*f**3*r*s - 284*C*D1*Dd*f**3*r + 936*C*D1*Dd*f**3*s**2 - 956*C*D1*Dd*f**3*s + 254*C*D1*Dd*f**3 - 2928*C*D1*Dd*f**2*fd*r**2 - 10272*C*D1*Dd*f**2*fd*r*s + 5436*C*D1*Dd*f**2*fd*r - 7344*C*D1*Dd*f**2*fd*s**2 + 8564*C*D1*Dd*f**2*fd*s - 2384*C*D1*Dd*f**2*fd - 488*C*D1*Ddd*f**3*r**2 - 1712*C*D1*Ddd*f**3*r*s + 916*C*D1*Ddd*f**3*r - 1224*C*D1*Ddd*f**3*s**2 + 1468*C*D1*Ddd*f**3*s - 550*C*D1*Ddd*f**3 - 1464*C*Dd**2*f**3*r**2 - 5136*C*Dd**2*f**3*r*s + 2748*C*Dd**2*f**3*r - 3672*C*Dd**2*f**3*s**2 + 4404*C*Dd**2*f**3*s - 1100*C*Dd**2*f**3 - 924*D1**2*K*bd1**2*f*r**2 - 2352*D1**2*K*bd1**2*f*r*s + 2184*D1**2*K*bd1**2*f*r - 1428*D1**2*K*bd1**2*f*s**2 + 2688*D1**2*K*bd1**2*f*s - 1260*D1**2*K*bd1**2*f - 63*D1**2*K*bd1*f**2*r**2 + 210*D1**2*K*bd1*f**2*r*s + 126*D1**2*K*bd1*f**2*r + 273*D1**2*K*bd1*f**2*s**2 - 210*D1**2*K*bd1*f**2*s - 63*D1**2*K*bd1*f**2 - 420*D1**2*K*bd1*f*fd*r**2 - 1848*D1**2*K*bd1*f*fd*r*s + 882*D1**2*K*bd1*f*fd*r - 1428*D1**2*K*bd1*f*fd*s**2 + 1638*D1**2*K*bd1*f*fd*s - 462*D1**2*K*bd1*f*fd - 105*D1**2*K*bdd1*f**2*r**2 - 462*D1**2*K*bdd1*f**2*r*s + 210*D1**2*K*bdd1*f**2*r - 357*D1**2*K*bdd1*f**2*s**2 + 462*D1**2*K*bdd1*f**2*s - 105*D1**2*K*bdd1*f**2 + 1386*D1**2*bd1**2*f**2*r**2 + 2268*D1**2*bd1**2*f**2*r*s - 2520*D1**2*bd1**2*f**2*r + 882*D1**2*bd1**2*f**2*s**2 - 2016*D1**2*bd1**2*f**2*s + 1134*D1**2*bd1**2*f**2 + 252*D1**2*bd1**2*f*r**2 + 504*D1**2*bd1**2*f*r*s - 504*D1**2*bd1**2*f*r + 252*D1**2*bd1**2*f*s**2 - 504*D1**2*bd1**2*f*s + 252*D1**2*bd1**2*f - 504*D1**2*bd1*bd2*f*r**2 - 1008*D1**2*bd1*bd2*f*r*s + 1008*D1**2*bd1*bd2*f*r - 504*D1**2*bd1*bd2*f*s**2 + 1008*D1**2*bd1*bd2*f*s - 504*D1**2*bd1*bd2*f - 462*D1**2*bd1*f**2*r**2 - 1056*D1**2*bd1*f**2*r*s + 1002*D1**2*bd1*f**2*r - 594*D1**2*bd1*f**2*s**2 + 1134*D1**2*bd1*f**2*s - 546*D1**2*bd1*f**2 + 1008*D1**2*bd1*f*fd*r**2 + 2448*D1**2*bd1*f*fd*r*s - 1764*D1**2*bd1*f*fd*r + 1440*D1**2*bd1*f*fd*s**2 - 2088*D1**2*bd1*f*fd*s + 648*D1**2*bd1*f*fd - 1848*D1**2*bd1*f*g2*r**2 - 3864*D1**2*bd1*f*g2*r*s + 3360*D1**2*bd1*f*g2*r - 2016*D1**2*bd1*f*g2*s**2 + 3528*D1**2*bd1*f*g2*s - 1764*D1**2*bd1*f*g2 + 1848*D1**2*bd1*f*gd2*r**2 + 4704*D1**2*bd1*f*gd2*r*s - 4368*D1**2*bd1*f*gd2*r + 2856*D1**2*bd1*f*gd2*s**2 - 5376*D1**2*bd1*f*gd2*s + 2520*D1**2*bd1*f*gd2 + 1848*D1**2*bd1*fd*g2*r**2 + 4704*D1**2*bd1*fd*g2*r*s - 2352*D1**2*bd1*fd*g2*r + 2856*D1**2*bd1*fd*g2*s**2 - 2856*D1**2*bd1*fd*g2*s - 42*D1**2*bd2*f**2*r**2 - 84*D1**2*bd2*f**2*r*s + 84*D1**2*bd2*f**2*r - 42*D1**2*bd2*f**2*s**2 + 84*D1**2*bd2*f**2*s - 42*D1**2*bd2*f**2 + 252*D1**2*bdd1*f**2*r**2 + 612*D1**2*bdd1*f**2*r*s - 648*D1**2*bdd1*f**2*r + 360*D1**2*bdd1*f**2*s**2 - 756*D1**2*bdd1*f**2*s + 378*D1**2*bdd1*f**2 + 924*D1**2*bdd1*f*g2*r**2 + 2352*D1**2*bdd1*f*g2*r*s - 2520*D1**2*bdd1*f*g2*r + 1428*D1**2*bdd1*f*g2*s**2 - 3024*D1**2*bdd1*f*g2*s + 1512*D1**2*bdd1*f*g2 + 39*D1**2*f**2*fd*r**2 - 312*D1**2*f**2*fd*r*s + 78*D1**2*f**2*fd*r - 351*D1**2*f**2*fd*s**2 + 338*D1**2*f**2*fd*s - 104*D1**2*f**2*fd + 183*D1**2*f**2*fdd*r**2 + 642*D1**2*f**2*fdd*r*s - 336*D1**2*f**2*fdd*r + 459*D1**2*f**2*fdd*s**2 - 520*D1**2*f**2*fdd*s + 214*D1**2*f**2*fdd + 126*D1**2*f**2*gd2*r**2 - 420*D1**2*f**2*gd2*r*s - 252*D1**2*f**2*gd2*r - 546*D1**2*f**2*gd2*s**2 + 420*D1**2*f**2*gd2*s + 126*D1**2*f**2*gd2 + 210*D1**2*f**2*gdd2*r**2 + 924*D1**2*f**2*gdd2*r*s - 420*D1**2*f**2*gdd2*r + 714*D1**2*f**2*gdd2*s**2 - 924*D1**2*f**2*gdd2*s + 210*D1**2*f**2*gdd2 + 366*D1**2*f*fd**2*r**2 + 1284*D1**2*f*fd**2*r*s - 672*D1**2*f*fd**2*r + 918*D1**2*f*fd**2*s**2 - 1040*D1**2*f*fd**2*s + 214*D1**2*f*fd**2 + 252*D1**2*f*fd*g2*r**2 - 840*D1**2*f*fd*g2*r*s + 420*D1**2*f*fd*g2*r - 1092*D1**2*f*fd*g2*s**2 + 1092*D1**2*f*fd*g2*s - 546*D1**2*f*fd*g2 + 840*D1**2*f*fd*gd2*r**2 + 3696*D1**2*f*fd*gd2*r*s - 1764*D1**2*f*fd*gd2*r + 2856*D1**2*f*fd*gd2*s**2 - 3276*D1**2*f*fd*gd2*s + 924*D1**2*f*fd*gd2 + 420*D1**2*f*fdd*g2*r**2 + 1848*D1**2*f*fdd*g2*r*s - 924*D1**2*f*fdd*g2*r + 1428*D1**2*f*fdd*g2*s**2 - 1428*D1**2*f*fdd*g2*s + 714*D1**2*f*fdd*g2 + 420*D1**2*fd**2*g2*r**2 + 1848*D1**2*fd**2*g2*r*s - 924*D1**2*fd**2*g2*r + 1428*D1**2*fd**2*g2*s**2 - 1428*D1**2*fd**2*g2*s - 840*D1*Dd*K*bd1*f**2*r**2 - 3696*D1*Dd*K*bd1*f**2*r*s + 1722*D1*Dd*K*bd1*f**2*r - 2856*D1*Dd*K*bd1*f**2*s**2 + 3486*D1*Dd*K*bd1*f**2*s - 882*D1*Dd*K*bd1*f**2 + 2016*D1*Dd*bd1*f**2*r**2 + 4896*D1*Dd*bd1*f**2*r*s - 4212*D1*Dd*bd1*f**2*r + 2880*D1*Dd*bd1*f**2*s**2 - 4968*D1*Dd*bd1*f**2*s + 2052*D1*Dd*bd1*f**2 + 7392*D1*Dd*bd1*f*g2*r**2 + 18816*D1*Dd*bd1*f*g2*r*s - 16128*D1*Dd*bd1*f*g2*r + 11424*D1*Dd*bd1*f*g2*s**2 - 19656*D1*Dd*bd1*f*g2*s + 8064*D1*Dd*bd1*f*g2 + 52*D1*Dd*f**3*r**2 - 416*D1*Dd*f**3*r*s + 52*D1*Dd*f**3*r - 468*D1*Dd*f**3*s**2 + 442*D1*Dd*f**3*s - 91*D1*Dd*f**3 + 1464*D1*Dd*f**2*fd*r**2 + 5136*D1*Dd*f**2*fd*r*s - 2718*D1*Dd*f**2*fd*r + 3672*D1*Dd*f**2*fd*s**2 - 4282*D1*Dd*f**2*fd*s + 1192*D1*Dd*f**2*fd + 504*D1*Dd*f**2*g2*r**2 - 1680*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r - 2184*D1*Dd*f**2*g2*s**2 + 1932*D1*Dd*f**2*g2*s - 294*D1*Dd*f**2*g2 + 1680*D1*Dd*f**2*gd2*r**2 + 7392*D1*Dd*f**2*gd2*r*s - 3444*D1*Dd*f**2*gd2*r + 5712*D1*Dd*f**2*gd2*s**2 - 6972*D1*Dd*f**2*gd2*s + 1764*D1*Dd*f**2*gd2 + 3360*D1*Dd*f*fd*g2*r**2 + 14784*D1*Dd*f*fd*g2*r*s - 7224*D1*Dd*f*fd*g2*r + 11424*D1*Dd*f*fd*g2*s**2 - 12264*D1*Dd*f*fd*g2*s + 3276*D1*Dd*f*fd*g2 + 244*D1*Ddd*f**3*r**2 + 856*D1*Ddd*f**3*r*s - 458*D1*Ddd*f**3*r + 612*D1*Ddd*f**3*s**2 - 734*D1*Ddd*f**3*s + 275*D1*Ddd*f**3 + 840*D1*Ddd*f**2*g2*r**2 + 3696*D1*Ddd*f**2*g2*r*s - 1764*D1*Ddd*f**2*g2*r + 2856*D1*Ddd*f**2*g2*s**2 - 3276*D1*Ddd*f**2*g2*s + 1134*D1*Ddd*f**2*g2 + 42*D1*b2*(bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 732*Dd**2*f**3*r**2 + 2568*Dd**2*f**3*r*s - 1374*Dd**2*f**3*r + 1836*Dd**2*f**3*s**2 - 2202*Dd**2*f**3*s + 550*Dd**2*f**3 + 2520*Dd**2*f**2*g2*r**2 + 11088*Dd**2*f**2*g2*r*s - 5292*Dd**2*f**2*g2*r + 8568*Dd**2*f**2*g2*s**2 - 9828*Dd**2*f**2*g2*s + 2268*Dd**2*f**2*g2 + 126*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 21*b1**2*(44*D1**2*K*fd*r**2 + 92*D1**2*K*fd*r*s - 12*D1**2*K*fd*r + 48*D1**2*K*fd*s**2 - 12*D1**2*K*fd*s + 6*D1**2*K*fd - 22*D1**2*K*fdd*r**2 - 56*D1**2*K*fdd*r*s - 4*D1**2*K*fdd*r - 34*D1**2*K*fdd*s**2 - 4*D1**2*K*fdd*s + 2*D1**2*K*fdd - 6*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 46*D1**2*f*fd*r**2 - 68*D1**2*f*fd*r*s + 46*D1**2*f*fd*r - 22*D1**2*f*fd*s**2 + 34*D1**2*f*fd*s - 23*D1**2*f*fd + 66*D1**2*f*fdd*r**2 + 108*D1**2*f*fdd*r*s - 66*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 33*D1**2*f*fdd + 66*D1**2*fd**2*r**2 + 108*D1**2*fd**2*r*s - 66*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s - 12*D1**2*fd*r**2 - 14*D1**2*fd*r*s - 2*D1**2*fd*s**2 + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 + 176*D1*Dd*K*f*r**2 + 368*D1*Dd*K*f*r*s - 268*D1*Dd*K*f*r + 192*D1*Dd*K*f*s**2 - 280*D1*Dd*K*f*s + 136*D1*Dd*K*f - 176*D1*Dd*K*fd*r**2 - 448*D1*Dd*K*fd*r*s + 128*D1*Dd*K*fd*r - 272*D1*Dd*K*fd*s**2 + 164*D1*Dd*K*fd*s + 12*D1*Dd*K*fd - 92*D1*Dd*f**2*r**2 - 136*D1*Dd*f**2*r*s + 126*D1*Dd*f**2*r - 44*D1*Dd*f**2*s**2 + 90*D1*Dd*f**2*s - 57*D1*Dd*f**2 + 528*D1*Dd*f*fd*r**2 + 864*D1*Dd*f*fd*r*s - 636*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 516*D1*Dd*f*fd*s + 186*D1*Dd*f*fd - 48*D1*Dd*f*r**2 - 56*D1*Dd*f*r*s + 62*D1*Dd*f*r - 8*D1*Dd*f*s**2 + 32*D1*Dd*f*s - 26*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 36*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 36*D1*Dd*fd*s - 88*D1*Ddd*K*f*r**2 - 224*D1*Ddd*K*f*r*s + 144*D1*Ddd*K*f*r - 136*D1*Ddd*K*f*s**2 + 180*D1*Ddd*K*f*s - 78*D1*Ddd*K*f + 132*D1*Ddd*f**2*r**2 + 216*D1*Ddd*f**2*r*s - 186*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 87*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f + 12*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 264*Dd**2*K*f*r**2 - 672*Dd**2*K*f*r*s + 432*Dd**2*K*f*r - 408*Dd**2*K*f*s**2 + 540*Dd**2*K*f*s - 156*Dd**2*K*f + 396*Dd**2*f**2*r**2 + 648*Dd**2*f**2*r*s - 558*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 174*Dd**2*f**2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f) - 3*b1*(-528*C*D1**2*f*fd*r**2 - 1232*C*D1**2*f*fd*r*s + 536*C*D1**2*f*fd*r - 704*C*D1**2*f*fd*s**2 + 624*C*D1**2*f*fd*s - 268*C*D1**2*f*fd + 264*C*D1**2*f*fdd*r**2 + 672*C*D1**2*f*fdd*r*s - 240*C*D1**2*f*fdd*r + 408*C*D1**2*f*fdd*s**2 - 312*C*D1**2*f*fdd*s + 120*C*D1**2*f*fdd + 264*C*D1**2*fd**2*r**2 + 672*C*D1**2*fd**2*r*s - 240*C*D1**2*fd**2*r + 408*C*D1**2*fd**2*s**2 - 312*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 1056*C*D1*Dd*f**2*r**2 - 2464*C*D1*Dd*f**2*r*s + 1672*C*D1*Dd*f**2*r - 1408*C*D1*Dd*f**2*s**2 + 1936*C*D1*Dd*f**2*s - 880*C*D1*Dd*f**2 + 2112*C*D1*Dd*f*fd*r**2 + 5376*C*D1*Dd*f*fd*r*s - 2688*C*D1*Dd*f*fd*r + 3264*C*D1*Dd*f*fd*s**2 - 3408*C*D1*Dd*f*fd*s + 792*C*D1*Dd*f*fd + 528*C*D1*Ddd*f**2*r**2 + 1344*C*D1*Ddd*f**2*r*s - 864*C*D1*Ddd*f**2*r + 816*C*D1*Ddd*f**2*s**2 - 1080*C*D1*Ddd*f**2*s + 468*C*D1*Ddd*f**2 + 1584*C*Dd**2*f**2*r**2 + 4032*C*Dd**2*f**2*r*s - 2592*C*Dd**2*f**2*r + 2448*C*Dd**2*f**2*s**2 - 3240*C*Dd**2*f**2*s + 936*C*Dd**2*f**2 + 308*D1**2*K*bdd1*f*r**2 + 784*D1**2*K*bdd1*f*r*s - 728*D1**2*K*bdd1*f*r + 476*D1**2*K*bdd1*f*s**2 - 896*D1**2*K*bdd1*f*s + 406*D1**2*K*bdd1*f + 42*D1**2*K*f*fd*r**2 - 140*D1**2*K*f*fd*r*s + 70*D1**2*K*f*fd*r - 182*D1**2*K*f*fd*s**2 + 182*D1**2*K*f*fd*s - 91*D1**2*K*f*fd + 70*D1**2*K*f*fdd*r**2 + 308*D1**2*K*f*fdd*r*s - 154*D1**2*K*f*fdd*r + 238*D1**2*K*f*fdd*s**2 - 238*D1**2*K*f*fdd*s + 119*D1**2*K*f*fdd + 70*D1**2*K*fd**2*r**2 + 308*D1**2*K*fd**2*r*s - 154*D1**2*K*fd**2*r + 238*D1**2*K*fd**2*s**2 - 238*D1**2*K*fd**2*s - 98*D1**2*b2*fd*r**2 - 196*D1**2*b2*fd*r*s - 98*D1**2*b2*fd*s**2 + 84*D1**2*b2*fdd*r**2 + 168*D1**2*b2*fdd*r*s + 84*D1**2*b2*fdd*s**2 + 84*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 462*D1**2*bdd1*f**2*r**2 - 756*D1**2*bdd1*f**2*r*s + 840*D1**2*bdd1*f**2*r - 294*D1**2*bdd1*f**2*s**2 + 672*D1**2*bdd1*f**2*s - 378*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*r**2 - 168*D1**2*bdd1*f*r*s + 168*D1**2*bdd1*f*r - 84*D1**2*bdd1*f*s**2 + 168*D1**2*bdd1*f*s - 84*D1**2*bdd1*f + 84*D1**2*bdd2*f*r**2 + 168*D1**2*bdd2*f*r*s - 168*D1**2*bdd2*f*r + 84*D1**2*bdd2*f*s**2 - 168*D1**2*bdd2*f*s + 84*D1**2*bdd2*f + 308*D1**2*f*fd*r**2 + 704*D1**2*f*fd*r*s - 326*D1**2*f*fd*r + 396*D1**2*f*fd*s**2 - 370*D1**2*f*fd*s + 170*D1**2*f*fd - 168*D1**2*f*fdd*r**2 - 408*D1**2*f*fdd*r*s + 156*D1**2*f*fdd*r - 240*D1**2*f*fdd*s**2 + 192*D1**2*f*fdd*s - 78*D1**2*f*fdd + 616*D1**2*f*gd2*r**2 + 1288*D1**2*f*gd2*r*s - 1232*D1**2*f*gd2*r + 672*D1**2*f*gd2*s**2 - 1288*D1**2*f*gd2*s + 616*D1**2*f*gd2 - 308*D1**2*f*gdd2*r**2 - 784*D1**2*f*gdd2*r*s + 616*D1**2*f*gdd2*r - 476*D1**2*f*gdd2*s**2 + 784*D1**2*f*gdd2*s - 308*D1**2*f*gdd2 - 168*D1**2*fd**2*r**2 - 408*D1**2*fd**2*r*s + 156*D1**2*fd**2*r - 240*D1**2*fd**2*s**2 + 192*D1**2*fd**2*s + 12*D1**2*fd**2 + 616*D1**2*fd*g2*r**2 + 1288*D1**2*fd*g2*r*s - 168*D1**2*fd*g2*r + 672*D1**2*fd*g2*s**2 - 168*D1**2*fd*g2*s + 84*D1**2*fd*g2 - 616*D1**2*fd*gd2*r**2 - 1568*D1**2*fd*gd2*r*s + 560*D1**2*fd*gd2*r - 952*D1**2*fd*gd2*s**2 + 728*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 - 308*D1**2*fdd*g2*r**2 - 784*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r - 476*D1**2*fdd*g2*s**2 - 56*D1**2*fdd*g2*s + 28*D1**2*fdd*g2 + 84*D1*Dd*K*f**2*r**2 - 280*D1*Dd*K*f**2*r*s - 14*D1*Dd*K*f**2*r - 364*D1*Dd*K*f**2*s**2 + 322*D1*Dd*K*f**2*s - 49*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*r**2 + 2464*D1*Dd*K*f*fd*r*s - 1204*D1*Dd*K*f*fd*r + 1904*D1*Dd*K*f*fd*s**2 - 2044*D1*Dd*K*f*fd*s + 546*D1*Dd*K*f*fd - 392*D1*Dd*b2*f*r**2 - 784*D1*Dd*b2*f*r*s + 588*D1*Dd*b2*f*r - 392*D1*Dd*b2*f*s**2 + 588*D1*Dd*b2*f*s - 294*D1*Dd*b2*f + 672*D1*Dd*b2*fd*r**2 + 1344*D1*Dd*b2*fd*r*s - 504*D1*Dd*b2*fd*r + 672*D1*Dd*b2*fd*s**2 - 504*D1*Dd*b2*fd*s + 616*D1*Dd*f**2*r**2 + 1408*D1*Dd*f**2*r*s - 968*D1*Dd*f**2*r + 792*D1*Dd*f**2*s**2 - 1100*D1*Dd*f**2*s + 506*D1*Dd*f**2 - 1344*D1*Dd*f*fd*r**2 - 3264*D1*Dd*f*fd*r*s + 1704*D1*Dd*f*fd*r - 1920*D1*Dd*f*fd*s**2 + 2064*D1*Dd*f*fd*s - 504*D1*Dd*f*fd + 2464*D1*Dd*f*g2*r**2 + 5152*D1*Dd*f*g2*r*s - 3752*D1*Dd*f*g2*r + 2688*D1*Dd*f*g2*s**2 - 3920*D1*Dd*f*g2*s + 1904*D1*Dd*f*g2 - 2464*D1*Dd*f*gd2*r**2 - 6272*D1*Dd*f*gd2*r*s + 4480*D1*Dd*f*gd2*r - 3808*D1*Dd*f*gd2*s**2 + 5656*D1*Dd*f*gd2*s - 2016*D1*Dd*f*gd2 - 2464*D1*Dd*fd*g2*r**2 - 6272*D1*Dd*fd*g2*r*s + 1792*D1*Dd*fd*g2*r - 3808*D1*Dd*fd*g2*s**2 + 2296*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*r**2 + 616*D1*Ddd*K*f**2*r*s - 294*D1*Ddd*K*f**2*r + 476*D1*Ddd*K*f**2*s**2 - 546*D1*Ddd*K*f**2*s + 189*D1*Ddd*K*f**2 + 336*D1*Ddd*b2*f*r**2 + 672*D1*Ddd*b2*f*r*s - 504*D1*Ddd*b2*f*r + 336*D1*Ddd*b2*f*s**2 - 504*D1*Ddd*b2*f*s + 252*D1*Ddd*b2*f - 336*D1*Ddd*f**2*r**2 - 816*D1*Ddd*f**2*r*s + 540*D1*Ddd*f**2*r - 480*D1*Ddd*f**2*s**2 + 648*D1*Ddd*f**2*s - 288*D1*Ddd*f**2 - 1232*D1*Ddd*f*g2*r**2 - 3136*D1*Ddd*f*g2*r*s + 2016*D1*Ddd*f*g2*r - 1904*D1*Ddd*f*g2*s**2 + 2520*D1*Ddd*f*g2*s - 1092*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(f**2*(23*r**2 + r*(34*s - 40) + 11*s**2 - 28*s + 17) - f*(K*(44*r**2 + 92*r*s - 84*r + 48*s**2 - 88*s + 43) + 6*fd*(22*r**2 + r*(36*s - 31) + 14*s**2 - 25*s + 10) - 12*r**2 - 14*r*s + 19*r - 2*s**2 + 9*s - 7) + 2*fd*(K*(22*r**2 + 8*r*(7*s - 3) + 34*s**2 - 30*s - 1) - 6*r**2 - 6*r*(2*s - 1) - 6*s*(s - 1))) - 2*Dd*f*(-2*K*(44*r**2 + 112*r*s - 88*r + 68*s**2 - 109*s + 42) + 3*f*(44*r**2 + r*(72*s - 71) + 28*s**2 - 57*s + 28) + 24*r**2 + 48*r*s - 42*r + 24*s**2 - 42*s + 18)) - 14*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 420*Dd**2*K*f**2*r**2 + 1848*Dd**2*K*f**2*r*s - 882*Dd**2*K*f**2*r + 1428*Dd**2*K*f**2*s**2 - 1638*Dd**2*K*f**2*s + 378*Dd**2*K*f**2 + 1008*Dd**2*b2*f*r**2 + 2016*Dd**2*b2*f*r*s - 1512*Dd**2*b2*f*r + 1008*Dd**2*b2*f*s**2 - 1512*Dd**2*b2*f*s + 504*Dd**2*b2*f - 1008*Dd**2*f**2*r**2 - 2448*Dd**2*f**2*r*s + 1620*Dd**2*f**2*r - 1440*Dd**2*f**2*s**2 + 1944*Dd**2*f**2*s - 576*Dd**2*f**2 - 3696*Dd**2*f*g2*r**2 - 9408*Dd**2*f*g2*r*s + 6048*Dd**2*f*g2*r - 5712*Dd**2*f*g2*s**2 + 7560*Dd**2*f*g2*s - 2184*Dd**2*f*g2))/(315*d**2*k3**6) - 2*D1**2*Pk2*Pk3*k1**2*k2**2*(D1*(70*D1*b2*bd1*f*(r + s - 1)**2 + 14*D1*bd1**2*(r + s - 1)*(25*K*f*(r + s - 1) - f*(12*C - 6)*(r + s) + 20*g2*(r + s)) + D1*bdd1*f*(f*(6*C - 3)*(43*r + 35*s - 35) - 350*g2*(r + s - 1))*(r + s - 1) + bd1*(D1*(3*f**2*(r + s - 1)*(10*C*r + 42*C*(s - 1) - 19*r - 21*s + 21) + f*fd*(12*C - 6)*(86*r**2 + r*(156*s - 121) + 70*s**2 - 109*s + 39) - 70*f*(3*g2 + 10*gd2)*(r + s - 1)**2 - 700*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(f*(6*C - 3)*(172*r**2 + r*(312*s - 281) + 140*s**2 - 253*s + 113) - 350*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 70*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(-K + f) - Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(D1**2*(-10*K*bdd1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + fd*(4*C*(r + s - 1)**2 + 15*K*s**2 + r**2*(15*K - 12) + 2*r*(15*K*s - 7*s + 2) - 2*s**2 + 4*s - 2) + fdd*(-12*C*(r + s - 1)**2 + 25*K*s**2 + r**2*(25*K + 6) + 2*r*(25*K*s + 6*s - 6) + 6*s**2 - 12*s + 6) + 20*gd2*(r + s - 1)**2 + 20*gdd2*(r + s - 1)**2) + 10*D1*bd1*(D1*(-K + f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(f*(4*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 15*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 48*r**2 - 56*r*s + 62*r - 8*s**2 + 32*s - 26) - 2*fd*(4*r + 4*s - 3)*(12*C*(r + s - 1) - 25*K*s - r*(25*K + 6) - 6*s + 6) + 20*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 40*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*(f*(-12*C + 25*K + 6) + 20*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(-12*C + 25*K + 6) + 20*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-168*C*D1**2*bdd1*f*r**2 - 336*C*D1**2*bdd1*f*r*s + 168*C*D1**2*bdd1*f*r - 168*C*D1**2*bdd1*f*s**2 + 168*C*D1**2*bdd1*f*s - 84*C*D1**2*bdd1*f + 60*C*D1**2*f*fd*r**2 + 312*C*D1**2*f*fd*r*s - 60*C*D1**2*f*fd*r + 252*C*D1**2*f*fd*s**2 - 156*C*D1**2*f*fd*s + 30*C*D1**2*f*fd + 516*C*D1**2*f*fdd*r**2 + 936*C*D1**2*f*fdd*r*s - 516*C*D1**2*f*fdd*r + 420*C*D1**2*f*fdd*s**2 - 468*C*D1**2*f*fdd*s + 258*C*D1**2*f*fdd + 516*C*D1**2*fd**2*r**2 + 936*C*D1**2*fd**2*r*s - 516*C*D1**2*fd**2*r + 420*C*D1**2*fd**2*s**2 - 468*C*D1**2*fd**2*s + 120*C*D1*Dd*f**2*r**2 + 624*C*D1*Dd*f**2*r*s - 276*C*D1*Dd*f**2*r + 504*C*D1*Dd*f**2*s**2 - 564*C*D1*Dd*f**2*s + 186*C*D1*Dd*f**2 + 4128*C*D1*Dd*f*fd*r**2 + 7488*C*D1*Dd*f*fd*r*s - 5064*C*D1*Dd*f*fd*r + 3360*C*D1*Dd*f*fd*s**2 - 4584*C*D1*Dd*f*fd*s + 1500*C*D1*Dd*f*fd + 1032*C*D1*Ddd*f**2*r**2 + 1872*C*D1*Ddd*f**2*r*s - 1500*C*D1*Ddd*f**2*r + 840*C*D1*Ddd*f**2*s**2 - 1356*C*D1*Ddd*f**2*s + 726*C*D1*Ddd*f**2 + 3096*C*Dd**2*f**2*r**2 + 5616*C*Dd**2*f**2*r*s - 4500*C*Dd**2*f**2*r + 2520*C*Dd**2*f**2*s**2 - 4068*C*Dd**2*f**2*s + 1452*C*Dd**2*f**2 - 140*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 350*D1**2*K*bdd1*f*r**2 + 700*D1**2*K*bdd1*f*r*s - 700*D1**2*K*bdd1*f*r + 350*D1**2*K*bdd1*f*s**2 - 700*D1**2*K*bdd1*f*s + 350*D1**2*K*bdd1*f + 70*D1**2*b2*fd*r**2 + 140*D1**2*b2*fd*r*s + 70*D1**2*b2*fd*s**2 + 70*D1**2*bd2*f*(r + s - 1)**2 + 84*D1**2*bdd1*f*r**2 + 168*D1**2*bdd1*f*r*s - 84*D1**2*bdd1*f*r + 84*D1**2*bdd1*f*s**2 - 84*D1**2*bdd1*f*s + 42*D1**2*bdd1*f + 280*D1**2*bdd1*g2*r**2 + 560*D1**2*bdd1*g2*r*s - 280*D1**2*bdd1*g2*r + 280*D1**2*bdd1*g2*s**2 - 280*D1**2*bdd1*g2*s + 140*D1**2*bdd1*g2 - 114*D1**2*f*fd*r**2 - 240*D1**2*f*fd*r*s + 114*D1**2*f*fd*r - 126*D1**2*f*fd*s**2 + 120*D1**2*f*fd*s - 57*D1**2*f*fd - 258*D1**2*f*fdd*r**2 - 468*D1**2*f*fdd*r*s + 258*D1**2*f*fdd*r - 210*D1**2*f*fdd*s**2 + 234*D1**2*f*fdd*s - 129*D1**2*f*fdd - 210*D1**2*f*gd2*r**2 - 420*D1**2*f*gd2*r*s + 420*D1**2*f*gd2*r - 210*D1**2*f*gd2*s**2 + 420*D1**2*f*gd2*s - 210*D1**2*f*gd2 - 350*D1**2*f*gdd2*r**2 - 700*D1**2*f*gdd2*r*s + 700*D1**2*f*gdd2*r - 350*D1**2*f*gdd2*s**2 + 700*D1**2*f*gdd2*s - 350*D1**2*f*gdd2 - 258*D1**2*fd**2*r**2 - 468*D1**2*fd**2*r*s + 258*D1**2*fd**2*r - 210*D1**2*fd**2*s**2 + 234*D1**2*fd**2*s - 210*D1**2*fd*g2*r**2 - 420*D1**2*fd*g2*r*s - 210*D1**2*fd*g2*s**2 - 700*D1**2*fd*gd2*r**2 - 1400*D1**2*fd*gd2*r*s + 700*D1**2*fd*gd2*r - 700*D1**2*fd*gd2*s**2 + 700*D1**2*fd*gd2*s - 350*D1**2*fdd*g2*r**2 - 700*D1**2*fdd*g2*r*s - 350*D1**2*fdd*g2*s**2 + 280*D1*Dd*b2*f*r**2 + 560*D1*Dd*b2*f*r*s - 420*D1*Dd*b2*f*r + 280*D1*Dd*b2*f*s**2 - 420*D1*Dd*b2*f*s + 210*D1*Dd*b2*f - 228*D1*Dd*f**2*r**2 - 480*D1*Dd*f**2*r*s + 348*D1*Dd*f**2*r - 252*D1*Dd*f**2*s**2 + 366*D1*Dd*f**2*s - 177*D1*Dd*f**2 - 2064*D1*Dd*f*fd*r**2 - 3744*D1*Dd*f*fd*r*s + 2532*D1*Dd*f*fd*r - 1680*D1*Dd*f*fd*s**2 + 2292*D1*Dd*f*fd*s - 750*D1*Dd*f*fd - 840*D1*Dd*f*g2*r**2 - 1680*D1*Dd*f*g2*r*s + 1260*D1*Dd*f*g2*r - 840*D1*Dd*f*g2*s**2 + 1260*D1*Dd*f*g2*s - 630*D1*Dd*f*g2 - 2800*D1*Dd*f*gd2*r**2 - 5600*D1*Dd*f*gd2*r*s + 4900*D1*Dd*f*gd2*r - 2800*D1*Dd*f*gd2*s**2 + 4900*D1*Dd*f*gd2*s - 2100*D1*Dd*f*gd2 - 2800*D1*Dd*fd*g2*r**2 - 5600*D1*Dd*fd*g2*r*s + 2100*D1*Dd*fd*g2*r - 2800*D1*Dd*fd*g2*s**2 + 2100*D1*Dd*fd*g2*s - 516*D1*Ddd*f**2*r**2 - 936*D1*Ddd*f**2*r*s + 750*D1*Ddd*f**2*r - 420*D1*Ddd*f**2*s**2 + 678*D1*Ddd*f**2*s - 363*D1*Ddd*f**2 - 1400*D1*Ddd*f*g2*r**2 - 2800*D1*Ddd*f*g2*r*s + 2100*D1*Ddd*f*g2*r - 1400*D1*Ddd*f*g2*s**2 + 2100*D1*Ddd*f*g2*s - 1050*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(f*(C*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) + 15*K*(r + s - 1)**2 - 12*r**2 - 14*r*s + 17*r - 2*s**2 + 7*s - 6) + 2*fd*(r + s - 1)*(-6*C*(2*r + 2*s - 1) + 25*K*r + 25*K*s + 6*r + 6*s - 3) + 10*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(6*C*(2*r + 2*s - 1) - 25*K*(r + s - 1) - 6*r - 6*s + 3) - 10*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 1548*Dd**2*f**2*r**2 - 2808*Dd**2*f**2*r*s + 2250*Dd**2*f**2*r - 1260*Dd**2*f**2*s**2 + 2034*Dd**2*f**2*s - 726*Dd**2*f**2 - 4200*Dd**2*f*g2*r**2 - 8400*Dd**2*f*g2*r*s + 6300*Dd**2*f*g2*r - 4200*Dd**2*f*g2*s**2 + 6300*Dd**2*f*g2*s - 2100*Dd**2*f*g2))/(105*d**2*k3**6) - 2*D1**2*Pk2*Pk3*k1**2*st**4*(-24*C*D1**2*f**2*fd*s**2 + 16*C*D1**2*f**2*fd*s - 8*C*D1**2*f**2*fd + 12*C*D1**2*f**2*fdd*s**2 - 8*C*D1**2*f**2*fdd*s + 4*C*D1**2*f**2*fdd + 24*C*D1**2*f*fd**2*s**2 - 16*C*D1**2*f*fd**2*s - 32*C*D1*Dd*f**3*s**2 + 16*C*D1*Dd*f**3*s - 8*C*D1*Dd*f**3 + 96*C*D1*Dd*f**2*fd*s**2 - 56*C*D1*Dd*f**2*fd*s + 8*C*D1*Dd*f**2*fd + 16*C*D1*Ddd*f**3*s**2 - 8*C*D1*Ddd*f**3*s + 4*C*D1*Ddd*f**3 + 48*C*Dd**2*f**3*s**2 - 24*C*Dd**2*f**3*s - 12*D1**2*K*bd1*f**2*s**2 + 24*D1**2*K*bd1*f*fd*s**2 - 12*D1**2*K*bd1*f*fd*s + 6*D1**2*K*bdd1*f**2*s**2 - 24*D1**2*bd1**2*f**2*s**2 + 36*D1**2*bd1**2*f**2*s - 36*D1**2*bd1*f**3*r*s - 117*D1**2*bd1*f**3*s**2 + 18*D1**2*bd1*f**3*s + 216*D1**2*bd1*f**2*fd*r*s - 36*D1**2*bd1*f**2*fd*r + 486*D1**2*bd1*f**2*fd*s**2 - 270*D1**2*bd1*f**2*fd*s + 18*D1**2*bd1*f**2*fd - 12*D1**2*bd1*f**2*r*s - 24*D1**2*bd1*f**2*s**2 + 12*D1**2*bd1*f**2*s + 24*D1**2*bd1*f*fd*r*s - 6*D1**2*bd1*f*fd*r + 48*D1**2*bd1*f*fd*s**2 - 36*D1**2*bd1*f*fd*s + 6*D1**2*bd1*f*fd - 12*D1**2*bd2*f**2*s**2 + 24*D1**2*bd2*f*fd*s**2 - 12*D1**2*bd2*f*fd*s + 36*D1**2*bdd1*f**3*r*s + 81*D1**2*bdd1*f**3*s**2 - 18*D1**2*bdd1*f**3*s + 6*D1**2*bdd1*f**2*r*s + 12*D1**2*bdd1*f**2*s**2 - 6*D1**2*bdd1*f**2*s + 6*D1**2*bdd2*f**2*s**2 - 12*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r - 12*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r*s - 2*D1**2*f**2*fdd*r + 6*D1**2*f**2*fdd*s**2 - 6*D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd + 24*D1**2*f**2*gd2*s**2 - 12*D1**2*f**2*gdd2*s**2 + 12*D1**2*f*fd**2*r*s - 4*D1**2*f*fd**2*r + 12*D1**2*f*fd**2*s**2 - 12*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 + 48*D1**2*f*fd*g2*s**2 - 48*D1**2*f*fd*g2*s + 24*D1**2*f*fd*g2 - 48*D1**2*f*fd*gd2*s**2 + 24*D1**2*f*fd*gd2*s - 24*D1**2*f*fdd*g2*s**2 + 24*D1**2*f*fdd*g2*s - 12*D1**2*f*fdd*g2 - 24*D1**2*fd**2*g2*s**2 + 24*D1**2*fd**2*g2*s + 48*D1*Dd*K*bd1*f**2*s**2 - 12*D1*Dd*K*bd1*f**2*s + 288*D1*Dd*bd1*f**3*r*s - 36*D1*Dd*bd1*f**3*r + 648*D1*Dd*bd1*f**3*s**2 - 306*D1*Dd*bd1*f**3*s + 18*D1*Dd*bd1*f**3 + 48*D1*Dd*bd1*f**2*r*s - 6*D1*Dd*bd1*f**2*r + 96*D1*Dd*bd1*f**2*s**2 - 60*D1*Dd*bd1*f**2*s + 6*D1*Dd*bd1*f**2 + 48*D1*Dd*bd2*f**2*s**2 - 12*D1*Dd*bd2*f**2*s - 16*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r - 16*D1*Dd*f**3*s**2 + 16*D1*Dd*f**3*s - 4*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r*s - 14*D1*Dd*f**2*fd*r + 48*D1*Dd*f**2*fd*s**2 - 48*D1*Dd*f**2*fd*s + 10*D1*Dd*f**2*fd + 96*D1*Dd*f**2*g2*s**2 - 48*D1*Dd*f**2*g2*s + 24*D1*Dd*f**2*g2 - 96*D1*Dd*f**2*gd2*s**2 + 24*D1*Dd*f**2*gd2*s - 192*D1*Dd*f*fd*g2*s**2 + 144*D1*Dd*f*fd*g2*s - 24*D1*Dd*f*fd*g2 + 8*D1*Ddd*f**3*r*s - 2*D1*Ddd*f**3*r + 8*D1*Ddd*f**3*s**2 - 8*D1*Ddd*f**3*s + 2*D1*Ddd*f**3 - 48*D1*Ddd*f**2*g2*s**2 + 24*D1*Ddd*f**2*g2*s - 12*D1*Ddd*f**2*g2 + 24*Dd**2*f**3*r*s - 6*Dd**2*f**3*r + 24*Dd**2*f**3*s**2 - 24*Dd**2*f**3*s + 4*Dd**2*f**3 - 144*Dd**2*f**2*g2*s**2 + 72*Dd**2*f**2*g2*s + 6*b1**2*(D1**2*(f*(2*fd - fdd)*(4*s**2 + 2*s - 1) - 2*fd**2*s*(2*s + 1)) + 2*D1*f*(Dd*(f*(8*s**2 - 4*s + 2) - 16*fd*s**2 + fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 12*Dd**2*f**2*s*(1 - 2*s)) + 3*b1*(-8*D1**2*K*f*fd*s**2 + 8*D1**2*K*f*fd*s - 4*D1**2*K*f*fd + 4*D1**2*K*f*fdd*s**2 - 4*D1**2*K*f*fdd*s + 2*D1**2*K*f*fdd + 4*D1**2*K*fd**2*s**2 - 4*D1**2*K*fd**2*s - 2*D1**2*bdd1*f**2*(4*s**2 - 6*s + 3) - 36*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 117*D1**2*f**2*fd*s**2 + 96*D1**2*f**2*fd*s - 39*D1**2*f**2*fd + 36*D1**2*f**2*fdd*r*s - 12*D1**2*f**2*fdd*r + 81*D1**2*f**2*fdd*s**2 - 72*D1**2*f**2*fdd*s + 27*D1**2*f**2*fdd + 72*D1**2*f*fd**2*r*s - 24*D1**2*f*fd**2*r + 162*D1**2*f*fd**2*s**2 - 144*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 16*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r + 8*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s + 4*D1**2*f*fdd + 4*D1**2*fd**2*r*s - 2*D1**2*fd**2*r + 8*D1**2*fd**2*s**2 - 8*D1**2*fd**2*s - 16*D1*Dd*K*f**2*s**2 + 8*D1*Dd*K*f**2*s - 4*D1*Dd*K*f**2 + 32*D1*Dd*K*f*fd*s**2 - 24*D1*Dd*K*f*fd*s + 4*D1*Dd*K*f*fd - 48*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r - 156*D1*Dd*f**3*s**2 + 102*D1*Dd*f**3*s - 39*D1*Dd*f**3 + 288*D1*Dd*f**2*fd*r*s - 84*D1*Dd*f**2*fd*r + 648*D1*Dd*f**2*fd*s**2 - 522*D1*Dd*f**2*fd*s + 96*D1*Dd*f**2*fd - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 32*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 64*D1*Dd*f*fd*s**2 - 56*D1*Dd*f*fd*s + 12*D1*Dd*f*fd + 8*D1*Ddd*K*f**2*s**2 - 4*D1*Ddd*K*f**2*s + 2*D1*Ddd*K*f**2 + 48*D1*Ddd*f**3*r*s - 12*D1*Ddd*f**3*r + 108*D1*Ddd*f**3*s**2 - 78*D1*Ddd*f**3*s + 27*D1*Ddd*f**3 + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 16*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 4*D1*Ddd*f**2 + 4*D1*bd1*f*(D1*f*(4*s**2 - 6*s + 3) + 4*D1*fd*s*(1 - 2*s) + Dd*f*(-16*s**2 + 16*s - 3)) + 24*Dd**2*K*f**2*s**2 - 12*Dd**2*K*f**2*s + 144*Dd**2*f**3*r*s - 36*Dd**2*f**3*r + 324*Dd**2*f**3*s**2 - 234*Dd**2*f**3*s + 24*Dd**2*f**3 + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 48*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 4*Dd**2*f**2) - 6*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(105*d**2*k2**2*k3**2) + D1**2*Pk2*Pk3*k1**2*st**2*(18*C*D1**2*bdd1*f**2*s**2 - 378*C*D1**2*f**2*fd*s**2 + 252*C*D1**2*f**2*fd*s - 126*C*D1**2*f**2*fd + 270*C*D1**2*f**2*fdd*s**2 - 180*C*D1**2*f**2*fdd*s + 90*C*D1**2*f**2*fdd + 540*C*D1**2*f*fd**2*s**2 - 360*C*D1**2*f*fd**2*s - 504*C*D1*Dd*f**3*s**2 + 252*C*D1*Dd*f**3*s - 126*C*D1*Dd*f**3 + 2160*C*D1*Dd*f**2*fd*s**2 - 1260*C*D1*Dd*f**2*fd*s + 180*C*D1*Dd*f**2*fd + 360*C*D1*Ddd*f**3*s**2 - 180*C*D1*Ddd*f**3*s + 90*C*D1*Ddd*f**3 + 1080*C*Dd**2*f**3*s**2 - 540*C*Dd**2*f**3*s + 105*D1**2*K*bdd1*f**2*s**2 - 294*D1**2*b2*f*fd*s**2 + 294*D1**2*b2*f*fd*s - 147*D1**2*b2*f*fd + 210*D1**2*b2*f*fdd*s**2 - 210*D1**2*b2*f*fdd*s + 105*D1**2*b2*f*fdd + 210*D1**2*b2*fd**2*s**2 - 210*D1**2*b2*fd**2*s - 42*D1**2*bd1**2*f*(-K*s**2 + f*(6*r*(2*s - 1) + 10*s**2 - 18*s + 3) + r*(2*s - 1) + 5*s**2 - 5*s + 1) - 147*D1**2*bd2*f**2*s**2 + 420*D1**2*bd2*f*fd*s**2 - 210*D1**2*bd2*f*fd*s + 378*D1**2*bdd1*f**3*r*s + 378*D1**2*bdd1*f**3*s**2 - 189*D1**2*bdd1*f**3*s + 87*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*r + 72*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s - 36*D1**2*bdd1*f**2 - 42*D1**2*bdd1*f*g2*s**2 + 105*D1**2*bdd2*f**2*s**2 - 237*D1**2*f**2*fd*r*s + 79*D1**2*f**2*fd*r + 27*D1**2*f**2*fd*s**2 + 61*D1**2*f**2*fd*s + 9*D1**2*f**2*fd + 159*D1**2*f**2*fdd*r*s - 53*D1**2*f**2*fdd*r + 27*D1**2*f**2*fdd*s**2 - 71*D1**2*f**2*fdd*s + 9*D1**2*f**2*fdd + 294*D1**2*f**2*gd2*s**2 - 210*D1**2*f**2*gdd2*s**2 + 318*D1**2*f*fd**2*r*s - 106*D1**2*f*fd**2*r + 54*D1**2*f*fd**2*s**2 - 142*D1**2*f*fd**2*s + 53*D1**2*f*fd**2 + 588*D1**2*f*fd*g2*s**2 - 588*D1**2*f*fd*g2*s + 294*D1**2*f*fd*g2 - 840*D1**2*f*fd*gd2*s**2 + 420*D1**2*f*fd*gd2*s - 420*D1**2*f*fdd*g2*s**2 + 420*D1**2*f*fdd*g2*s - 210*D1**2*f*fdd*g2 - 420*D1**2*fd**2*g2*s**2 + 420*D1**2*fd**2*g2*s - 588*D1*Dd*b2*f**2*s**2 + 294*D1*Dd*b2*f**2*s - 147*D1*Dd*b2*f**2 + 1680*D1*Dd*b2*f*fd*s**2 - 1260*D1*Dd*b2*f*fd*s + 210*D1*Dd*b2*f*fd + 840*D1*Dd*bd2*f**2*s**2 - 210*D1*Dd*bd2*f**2*s - 316*D1*Dd*f**3*r*s + 79*D1*Dd*f**3*r + 36*D1*Dd*f**3*s**2 + 140*D1*Dd*f**3*s + 9*D1*Dd*f**3 + 1272*D1*Dd*f**2*fd*r*s - 371*D1*Dd*f**2*fd*r + 216*D1*Dd*f**2*fd*s**2 - 656*D1*Dd*f**2*fd*s + 177*D1*Dd*f**2*fd + 1176*D1*Dd*f**2*g2*s**2 - 588*D1*Dd*f**2*g2*s + 294*D1*Dd*f**2*g2 - 1680*D1*Dd*f**2*gd2*s**2 + 420*D1*Dd*f**2*gd2*s - 3360*D1*Dd*f*fd*g2*s**2 + 2520*D1*Dd*f*fd*g2*s - 420*D1*Dd*f*fd*g2 + 420*D1*Ddd*b2*f**2*s**2 - 210*D1*Ddd*b2*f**2*s + 105*D1*Ddd*b2*f**2 + 212*D1*Ddd*f**3*r*s - 53*D1*Ddd*f**3*r + 36*D1*Ddd*f**3*s**2 - 124*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 - 840*D1*Ddd*f**2*g2*s**2 + 420*D1*Ddd*f**2*g2*s - 210*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(63*f**3*s*(2*r + 2*s - 1) - f**2*(2*C*s**2 - 49*K*s**2 + 63*fd*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) - r*(37*s + 12) - 20*s**2 + s + 24) + f*(fd*(r*(23 - 116*s) - s**2*(24*C + 140*K + 96) + s*(12*C + 70*K + 88) - 29) + s**2*(42*g2 + 28*gd2)) + 28*fd*g2*s*(s - 1)) + Dd*f*(-63*f**2*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + f*(r*(5 - 232*s) - s**2*(48*C + 280*K + 192) + s*(12*C + 70*K + 150) + 1) + 28*g2*s*(4*s - 1))) + 1260*Dd**2*b2*f**2*s**2 - 630*Dd**2*b2*f**2*s + 636*Dd**2*f**3*r*s - 159*Dd**2*f**3*r + 108*Dd**2*f**3*s**2 - 372*Dd**2*f**3*s + 106*Dd**2*f**3 - 2520*Dd**2*f**2*g2*s**2 + 1260*Dd**2*f**2*g2*s + 21*b1**2*(D1**2*(-4*fd**2*s*(6*r + 5*s - 2) + fd*(3*K*(s - 1)**2 + f*(28*s**2 + s*(24*r - 4) - 7) + 4*r*s + 5*s**2 + 6*s - 3) + fdd*(K*(s - 1)**2 + f*(-20*s**2 + s*(8 - 24*r) + 5) - 2*r*s - 5*s**2 + 2*s - 1)) + D1*(Dd*(2*f**2*(6*r*(4*s - 1) + 28*s**2 - 26*s + 7) + f*(3*K*(4*s**2 - 2*s + 1) - 8*fd*(3*r*(8*s - 1) + 20*s**2 - 15*s + 1) + 16*r*s - 4*r + 20*s**2 - 18*s + 5) + 2*fd*(4*K*s**2 - 5*K*s + K - 8*r*s + r - 20*s**2 + 11*s - 1)) + Ddd*f*(4*K*s**2 - 2*K*s + K - 2*f*(6*r*(4*s - 1) + 20*s**2 - 22*s + 5) - 8*r*s + 2*r - 20*s**2 + 14*s - 5)) - 2*Dd**2*f*(-6*K*s**2 + 3*K*s + 6*f*(3*r*(4*s - 1) + 10*s**2 - 11*s + 2) + 3*r*(4*s - 1) + 30*s**2 - 21*s + 2)) + 3*b1*(4*C*D1**2*f*fd*s**2 - 4*C*D1**2*f*fd*s + 2*C*D1**2*f*fd + 12*C*D1**2*f*fdd*s**2 - 12*C*D1**2*f*fdd*s + 6*C*D1**2*f*fdd + 12*C*D1**2*fd**2*s**2 - 12*C*D1**2*fd**2*s + 8*C*D1*Dd*f**2*s**2 - 4*C*D1*Dd*f**2*s + 2*C*D1*Dd*f**2 + 96*C*D1*Dd*f*fd*s**2 - 72*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd + 24*C*D1*Ddd*f**2*s**2 - 12*C*D1*Ddd*f**2*s + 6*C*D1*Ddd*f**2 + 72*C*Dd**2*f**2*s**2 - 36*C*Dd**2*f**2*s - 98*D1**2*K*f*fd*s**2 + 98*D1**2*K*f*fd*s - 49*D1**2*K*f*fd + 70*D1**2*K*f*fdd*s**2 - 70*D1**2*K*f*fdd*s + 35*D1**2*K*f*fdd + 70*D1**2*K*fd**2*s**2 - 70*D1**2*K*fd**2*s - 7*D1**2*bdd1*f*(f*(12*r*(2*s - 1) + 20*s**2 - 36*s + 15) + 4*r*s - 2*r - 2*s**2*(K - 5) - 10*s + 4) - 378*D1**2*f**2*fd*r*s + 126*D1**2*f**2*fd*r - 378*D1**2*f**2*fd*s**2 + 441*D1**2*f**2*fd*s - 126*D1**2*f**2*fd + 378*D1**2*f**2*fdd*r*s - 126*D1**2*f**2*fdd*r + 378*D1**2*f**2*fdd*s**2 - 441*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd + 756*D1**2*f*fd**2*r*s - 252*D1**2*f*fd**2*r + 756*D1**2*f*fd**2*s**2 - 882*D1**2*f*fd**2*s + 189*D1**2*f*fd**2 - 74*D1**2*f*fd*r*s + 49*D1**2*f*fd*r - 40*D1**2*f*fd*s**2 + 76*D1**2*f*fd*s - 44*D1**2*f*fd + 58*D1**2*f*fdd*r*s - 35*D1**2*f*fdd*r + 48*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 36*D1**2*f*fdd - 42*D1**2*f*gd2*s**2 - 14*D1**2*f*gdd2*s**2 + 58*D1**2*fd**2*r*s - 35*D1**2*fd**2*r + 48*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s - 42*D1**2*fd*g2*s**2 + 84*D1**2*fd*g2*s - 42*D1**2*fd*g2 - 28*D1**2*fd*gd2*s**2 + 28*D1**2*fd*gd2*s - 14*D1**2*fdd*g2*s**2 + 28*D1**2*fdd*g2*s - 14*D1**2*fdd*g2 - 196*D1*Dd*K*f**2*s**2 + 98*D1*Dd*K*f**2*s - 49*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*s**2 - 420*D1*Dd*K*f*fd*s + 70*D1*Dd*K*f*fd - 504*D1*Dd*f**3*r*s + 126*D1*Dd*f**3*r - 504*D1*Dd*f**3*s**2 + 504*D1*Dd*f**3*s - 126*D1*Dd*f**3 + 3024*D1*Dd*f**2*fd*r*s - 882*D1*Dd*f**2*fd*r + 3024*D1*Dd*f**2*fd*s**2 - 3276*D1*Dd*f**2*fd*s + 693*D1*Dd*f**2*fd - 148*D1*Dd*f**2*r*s + 37*D1*Dd*f**2*r - 80*D1*Dd*f**2*s**2 + 114*D1*Dd*f**2*s - 20*D1*Dd*f**2 + 464*D1*Dd*f*fd*r*s - 198*D1*Dd*f*fd*r + 384*D1*Dd*f*fd*s**2 - 476*D1*Dd*f*fd*s + 136*D1*Dd*f*fd - 168*D1*Dd*f*g2*s**2 + 84*D1*Dd*f*g2*s - 42*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*s**2 + 28*D1*Dd*f*gd2*s - 112*D1*Dd*fd*g2*s**2 + 140*D1*Dd*fd*g2*s - 28*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*s**2 - 70*D1*Ddd*K*f**2*s + 35*D1*Ddd*K*f**2 + 504*D1*Ddd*f**3*r*s - 126*D1*Ddd*f**3*r + 504*D1*Ddd*f**3*s**2 - 504*D1*Ddd*f**3*s + 126*D1*Ddd*f**3 + 116*D1*Ddd*f**2*r*s - 29*D1*Ddd*f**2*r + 96*D1*Ddd*f**2*s**2 - 106*D1*Ddd*f**2*s + 24*D1*Ddd*f**2 - 56*D1*Ddd*f*g2*s**2 + 28*D1*Ddd*f*g2*s - 14*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(f**2*(12*r*(2*s - 1) + 28*s**2 - 48*s + 21) + f*(6*K*s**2 - 2*fd*(48*r*s - 12*r + 40*s**2 - 44*s + 9) + 8*r*s - 4*r + 10*s**2 - 20*s + 8) + 2*fd*(-4*r*s + r + s*(2*K*(s - 1) - 10*s + 7))) - 2*Dd*f*(-8*K*s**2 + 2*K*s + 2*f*(6*r*(8*s - 3) + 40*s**2 - 58*s + 15) + 16*r*s - 6*r + 40*s**2 - 34*s + 7)) + 420*Dd**2*K*f**2*s**2 - 210*Dd**2*K*f**2*s + 1512*Dd**2*f**3*r*s - 378*Dd**2*f**3*r + 1512*Dd**2*f**3*s**2 - 1512*Dd**2*f**3*s + 252*Dd**2*f**3 + 348*Dd**2*f**2*r*s - 87*Dd**2*f**2*r + 288*Dd**2*f**2*s**2 - 318*Dd**2*f**2*s + 58*Dd**2*f**2 - 168*Dd**2*f*g2*s**2 + 84*Dd**2*f*g2*s))/(315*d**2*k2**2*k3**2) + D1**2*Pk2*Pk3*k1**2*(126*C*D1**2*f**2*fd*s**2 - 84*C*D1**2*f**2*fd*s + 42*C*D1**2*f**2*fd - 126*C*D1**2*f**2*fdd*s**2 + 84*C*D1**2*f**2*fdd*s - 42*C*D1**2*f**2*fdd - 252*C*D1**2*f*fd**2*s**2 + 168*C*D1**2*f*fd**2*s + 168*C*D1*Dd*f**3*s**2 - 84*C*D1*Dd*f**3*s + 42*C*D1*Dd*f**3 - 1008*C*D1*Dd*f**2*fd*s**2 + 588*C*D1*Dd*f**2*fd*s - 84*C*D1*Dd*f**2*fd - 168*C*D1*Ddd*f**3*s**2 + 84*C*D1*Ddd*f**3*s - 42*C*D1*Ddd*f**3 - 504*C*Dd**2*f**3*s**2 + 252*C*Dd**2*f**3*s - 35*D1**2*K*bdd1*f**2*s**2 + 70*D1**2*b2*f*fd*s**2 - 70*D1**2*b2*f*fd*s + 35*D1**2*b2*f*fd - 70*D1**2*b2*f*fdd*s**2 + 70*D1**2*b2*f*fdd*s - 35*D1**2*b2*f*fdd - 70*D1**2*b2*fd**2*s**2 + 70*D1**2*b2*fd**2*s + 7*D1**2*bd1**2*(5*f**2*(6*r*(2*s - 1) + 4*s**2 - 9*s + 3) + f*(15*r*(2*s - 1) + (s - 1)*(12*C*s + 8*s - 15)) - 20*g2*s*(s - 1)) + 35*D1**2*bd2*f**2*s**2 - 140*D1**2*bd2*f*fd*s**2 + 70*D1**2*bd2*f*fd*s + 75*D1**2*bdd1*f**2*r*s - 75*D1**2*bdd1*f**2*r + 42*D1**2*bdd1*f**2*s**2 - 84*D1**2*bdd1*f**2*s + 42*D1**2*bdd1*f**2 - 35*D1**2*bdd2*f**2*s**2 - 63*D1**2*f**2*fd*s**2 + 42*D1**2*f**2*fd*s - 21*D1**2*f**2*fd + 63*D1**2*f**2*fdd*s**2 - 42*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd - 70*D1**2*f**2*gd2*s**2 + 70*D1**2*f**2*gdd2*s**2 + 126*D1**2*f*fd**2*s**2 - 84*D1**2*f*fd**2*s - 140*D1**2*f*fd*g2*s**2 + 140*D1**2*f*fd*g2*s - 70*D1**2*f*fd*g2 + 280*D1**2*f*fd*gd2*s**2 - 140*D1**2*f*fd*gd2*s + 140*D1**2*f*fdd*g2*s**2 - 140*D1**2*f*fdd*g2*s + 70*D1**2*f*fdd*g2 + 140*D1**2*fd**2*g2*s**2 - 140*D1**2*fd**2*g2*s + 140*D1*Dd*b2*f**2*s**2 - 70*D1*Dd*b2*f**2*s + 35*D1*Dd*b2*f**2 - 560*D1*Dd*b2*f*fd*s**2 + 420*D1*Dd*b2*f*fd*s - 70*D1*Dd*b2*f*fd - 280*D1*Dd*bd2*f**2*s**2 + 70*D1*Dd*bd2*f**2*s - 84*D1*Dd*f**3*s**2 + 42*D1*Dd*f**3*s - 21*D1*Dd*f**3 + 504*D1*Dd*f**2*fd*s**2 - 294*D1*Dd*f**2*fd*s + 42*D1*Dd*f**2*fd - 280*D1*Dd*f**2*g2*s**2 + 140*D1*Dd*f**2*g2*s - 70*D1*Dd*f**2*g2 + 560*D1*Dd*f**2*gd2*s**2 - 140*D1*Dd*f**2*gd2*s + 1120*D1*Dd*f*fd*g2*s**2 - 840*D1*Dd*f*fd*g2*s + 140*D1*Dd*f*fd*g2 - 140*D1*Ddd*b2*f**2*s**2 + 70*D1*Ddd*b2*f**2*s - 35*D1*Ddd*b2*f**2 + 84*D1*Ddd*f**3*s**2 - 42*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 + 280*D1*Ddd*f**2*g2*s**2 - 140*D1*Ddd*f**2*g2*s + 70*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(f*(-87*r*(s - 1) + s**2*(35*K - 42) + 84*s - 42) + fd*(150*r*(2*s - 1) - s**2*(140*K - 168) + s*(70*K - 243) + 75)) + Dd*f*(75*r*(8*s - 5) - s**2*(280*K - 336) + s*(70*K - 570) + 234)) - 420*Dd**2*b2*f**2*s**2 + 210*Dd**2*b2*f**2*s + 252*Dd**2*f**3*s**2 - 126*Dd**2*f**3*s + 840*Dd**2*f**2*g2*s**2 - 420*Dd**2*f**2*g2*s + 35*b1**3*(K - 1)*(D1*(Dd + Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(2*s - 1)) + 7*b1**2*(-2*C*D1**2*fd*s**2 + 6*C*D1**2*fdd*s**2 - 8*C*D1*Dd*f*s**2 + 4*C*D1*Dd*f*s - 2*C*D1*Dd*f + 48*C*D1*Dd*fd*s**2 - 12*C*D1*Dd*fd*s + 24*C*D1*Ddd*f*s**2 - 12*C*D1*Ddd*f*s + 6*C*D1*Ddd*f + 72*C*Dd**2*f*s**2 - 36*C*Dd**2*f*s + 5*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) - 60*D1**2*f*fd*r*s - 20*D1**2*f*fd*s**2 + 35*D1**2*f*fd*s + 5*D1**2*f*fd + 60*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*s**2 - 35*D1**2*f*fdd*s - 5*D1**2*f*fdd + 60*D1**2*fd**2*r*s + 20*D1**2*fd**2*s**2 - 35*D1**2*fd**2*s - 15*D1**2*fd*r*s - 8*D1**2*fd*s**2 + 15*D1**2*fdd*r*s + 4*D1**2*fdd*s**2 - 10*D1**2*gd2*s**2 - 10*D1**2*gdd2*s**2 - 120*D1*Dd*f**2*r*s + 30*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 80*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 480*D1*Dd*f*fd*r*s - 60*D1*Dd*f*fd*r + 160*D1*Dd*f*fd*s**2 - 300*D1*Dd*f*fd*s + 35*D1*Dd*f*fd - 60*D1*Dd*f*r*s + 15*D1*Dd*f*r - 32*D1*Dd*f*s**2 + 46*D1*Dd*f*s - 8*D1*Dd*f + 120*D1*Dd*fd*r*s - 15*D1*Dd*fd*r + 32*D1*Dd*fd*s**2 - 38*D1*Dd*fd*s - 40*D1*Dd*g2*s**2 + 20*D1*Dd*g2*s - 10*D1*Dd*g2 - 80*D1*Dd*gd2*s**2 + 20*D1*Dd*gd2*s + 120*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 80*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 + 60*D1*Ddd*f*r*s - 15*D1*Ddd*f*r + 16*D1*Ddd*f*s**2 - 38*D1*Ddd*f*s + 4*D1*Ddd*f - 40*D1*Ddd*g2*s**2 + 20*D1*Ddd*g2*s - 10*D1*Ddd*g2 + 5*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + 2*Dd*(12*s**2 - 7*s + 1)) + 360*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 240*Dd**2*f**2*s + 60*Dd**2*f**2 + 180*Dd**2*f*r*s - 45*Dd**2*f*r + 48*Dd**2*f*s**2 - 114*Dd**2*f*s + 30*Dd**2*f - 120*Dd**2*g2*s**2 + 60*Dd**2*g2*s) + b1*(70*D1**2*K*f*fd*s**2 - 70*D1**2*K*f*fd*s + 35*D1**2*K*f*fd - 70*D1**2*K*f*fdd*s**2 + 70*D1**2*K*f*fdd*s - 35*D1**2*K*f*fdd - 70*D1**2*K*fd**2*s**2 + 70*D1**2*K*fd**2*s + 70*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + 7*D1**2*bdd1*(5*f**2*(6*r*(2*s - 1) + 4*s**2 - 9*s + 3) + f*(6*C*(2*s**2 - 2*s + 1) + 30*r*s - 15*r + 8*s**2 - 23*s + 4) - 10*g2*(2*s**2 - 2*s + 1)) - 174*D1**2*f*fd*r*s - 84*D1**2*f*fd*s**2 + 87*D1**2*f*fd*s + 150*D1**2*f*fdd*r*s + 84*D1**2*f*fdd*s**2 - 75*D1**2*f*fdd*s + 150*D1**2*fd**2*r*s + 84*D1**2*fd**2*s**2 - 75*D1**2*fd**2*s + 140*D1*Dd*K*f**2*s**2 - 70*D1*Dd*K*f**2*s + 35*D1*Dd*K*f**2 - 560*D1*Dd*K*f*fd*s**2 + 420*D1*Dd*K*f*fd*s - 70*D1*Dd*K*f*fd - 348*D1*Dd*f**2*r*s + 87*D1*Dd*f**2*r - 168*D1*Dd*f**2*s**2 + 258*D1*Dd*f**2*s - 42*D1*Dd*f**2 + 1200*D1*Dd*f*fd*r*s - 150*D1*Dd*f*fd*r + 672*D1*Dd*f*fd*s**2 - 768*D1*Dd*f*fd*s + 75*D1*Dd*f*fd - 140*D1*Ddd*K*f**2*s**2 + 70*D1*Ddd*K*f**2*s - 35*D1*Ddd*K*f**2 + 300*D1*Ddd*f**2*r*s - 75*D1*Ddd*f**2*r + 168*D1*Ddd*f**2*s**2 - 234*D1*Ddd*f**2*s + 42*D1*Ddd*f**2 - 7*D1*bd1*(D1*(-24*C*fd*s**2 + 12*C*fd*s + 5*f**2*(6*r*(2*s - 1) + 4*s**2 - 9*s + 3) + f*(C*(4*s**2 - 4*s + 2) - 5*fd*(48*r*s - 12*r + 16*s**2 - 32*s + 9) + 30*r*s - 15*r + 16*s**2 - 31*s + 8) - 60*fd*r*s + 15*fd*r - 16*fd*s**2 + 23*fd*s + 20*g2*s**2 - 20*g2*s + 10*g2 + 40*gd2*s**2 - 20*gd2*s) - Dd*(5*f**2*(8*s - 3)*(12*r + 4*s - 7) + f*(12*C*(8*s**2 - 6*s + 1) + 30*r*(8*s - 3) + 64*s**2 - 168*s + 53) - 20*g2*(8*s**2 - 6*s + 1))) - 420*Dd**2*K*f**2*s**2 + 210*Dd**2*K*f**2*s + 900*Dd**2*f**2*r*s - 225*Dd**2*f**2*r + 504*Dd**2*f**2*s**2 - 702*Dd**2*f**2*s + 150*Dd**2*f**2))/(105*d**2*k2**2*k3**2) - 4*D1**2*Pk2*Pk3*k2**6*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-9*K*(-2*bd1 + bdd1) - 36*gd2 + 18*gdd2)) + f*(-fd**2*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 18*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 18*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - fd*(2*C - 1)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 18*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 18*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 9*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(2*C*f + 9*K*b1 - f - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*C*f + 9*K*b1 - f - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(21*d**2*k3**8) - 12*D1**2*Pk2*Pk3*k2**6*st**4*(8*C*D1**2*b1*f*fd*r**2 + 16*C*D1**2*b1*f*fd*r*s - 8*C*D1**2*b1*f*fd*r + 8*C*D1**2*b1*f*fd*s**2 - 8*C*D1**2*b1*f*fd*s + 4*C*D1**2*b1*f*fd - 4*C*D1**2*b1*f*fdd*r**2 - 8*C*D1**2*b1*f*fdd*r*s + 4*C*D1**2*b1*f*fdd*r - 4*C*D1**2*b1*f*fdd*s**2 + 4*C*D1**2*b1*f*fdd*s - 2*C*D1**2*b1*f*fdd - 4*C*D1**2*b1*fd**2*r**2 - 8*C*D1**2*b1*fd**2*r*s + 4*C*D1**2*b1*fd**2*r - 4*C*D1**2*b1*fd**2*s**2 + 4*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 16*C*D1*Dd*b1*f**2*r**2 + 32*C*D1*Dd*b1*f**2*r*s - 24*C*D1*Dd*b1*f**2*r + 16*C*D1*Dd*b1*f**2*s**2 - 24*C*D1*Dd*b1*f**2*s + 12*C*D1*Dd*b1*f**2 - 32*C*D1*Dd*b1*f*fd*r**2 - 64*C*D1*Dd*b1*f*fd*r*s + 40*C*D1*Dd*b1*f*fd*r - 32*C*D1*Dd*b1*f*fd*s**2 + 40*C*D1*Dd*b1*f*fd*s - 12*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 8*C*D1*Ddd*b1*f**2*r**2 - 16*C*D1*Ddd*b1*f**2*r*s + 12*C*D1*Ddd*b1*f**2*r - 8*C*D1*Ddd*b1*f**2*s**2 + 12*C*D1*Ddd*b1*f**2*s - 6*C*D1*Ddd*b1*f**2 - 24*C*Dd**2*b1*f**2*r**2 - 48*C*Dd**2*b1*f**2*r*s + 36*C*Dd**2*b1*f**2*r - 24*C*Dd**2*b1*f**2*s**2 + 36*C*Dd**2*b1*f**2*s - 12*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r**2 + 28*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r**2 - 14*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 14*D1**2*K*bd1**2*f*(r + s - 1)**2 - 4*D1**2*b1*f*fd*r**2 - 8*D1**2*b1*f*fd*r*s + 4*D1**2*b1*f*fd*r - 4*D1**2*b1*f*fd*s**2 + 4*D1**2*b1*f*fd*s - 2*D1**2*b1*f*fd + 2*D1**2*b1*f*fdd*r**2 + 4*D1**2*b1*f*fdd*r*s - 2*D1**2*b1*f*fdd*r + 2*D1**2*b1*f*fdd*s**2 - 2*D1**2*b1*f*fdd*s + D1**2*b1*f*fdd - 28*D1**2*b1*f*gd2*r**2 - 56*D1**2*b1*f*gd2*r*s + 56*D1**2*b1*f*gd2*r - 28*D1**2*b1*f*gd2*s**2 + 56*D1**2*b1*f*gd2*s - 28*D1**2*b1*f*gd2 + 14*D1**2*b1*f*gdd2*r**2 + 28*D1**2*b1*f*gdd2*r*s - 28*D1**2*b1*f*gdd2*r + 14*D1**2*b1*f*gdd2*s**2 - 28*D1**2*b1*f*gdd2*s + 14*D1**2*b1*f*gdd2 + 2*D1**2*b1*fd**2*r**2 + 4*D1**2*b1*fd**2*r*s - 2*D1**2*b1*fd**2*r + 2*D1**2*b1*fd**2*s**2 - 2*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r**2 - 56*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r**2 + 56*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*r + 28*D1**2*b1*fd*gd2*s**2 - 28*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r**2 + 28*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(2*C*f + 14*K*b1 - f - 14*g2) + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r**2 + 112*D1*Dd*K*b1**2*f*r*s - 84*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 84*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r**2 - 112*D1*Dd*K*b1**2*fd*r*s + 42*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 42*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 - 8*D1*Dd*b1*f**2*r**2 - 16*D1*Dd*b1*f**2*r*s + 12*D1*Dd*b1*f**2*r - 8*D1*Dd*b1*f**2*s**2 + 12*D1*Dd*b1*f**2*s - 6*D1*Dd*b1*f**2 + 16*D1*Dd*b1*f*fd*r**2 + 32*D1*Dd*b1*f*fd*r*s - 20*D1*Dd*b1*f*fd*r + 16*D1*Dd*b1*f*fd*s**2 - 20*D1*Dd*b1*f*fd*s + 6*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r**2 - 224*D1*Dd*b1*f*g2*r*s + 168*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 168*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r**2 + 224*D1*Dd*b1*f*gd2*r*s - 196*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 196*D1*Dd*b1*f*gd2*s + 84*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r**2 + 224*D1*Dd*b1*fd*g2*r*s - 84*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 84*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r**2 - 56*D1*Ddd*K*b1**2*f*r*s + 42*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 42*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 4*D1*Ddd*b1*f**2*r**2 + 8*D1*Ddd*b1*f**2*r*s - 6*D1*Ddd*b1*f**2*r + 4*D1*Ddd*b1*f**2*s**2 - 6*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r**2 + 112*D1*Ddd*b1*f*g2*r*s - 84*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 84*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(4*C - 7*K - 2)*(r + s - 1) - f*fd*(4*C - 2)*(2*r + 2*s - 1) - 28*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(2*C*f + 14*K*b1 - f - 14*g2))*(r + s - 1) - 84*Dd**2*K*b1**2*f*r**2 - 168*Dd**2*K*b1**2*f*r*s + 126*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 126*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 12*Dd**2*b1*f**2*r**2 + 24*Dd**2*b1*f**2*r*s - 18*Dd**2*b1*f**2*r + 12*Dd**2*b1*f**2*s**2 - 18*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r**2 + 336*Dd**2*b1*f*g2*r*s - 252*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 252*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(35*d**2*k3**8) + 4*D1**2*Pk2*Pk3*k2**4*st**6*(36*C*D1**2*f**2*fd*r**2 + 48*C*D1**2*f**2*fd*r*s - 40*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 16*C*D1**2*f**2*fd - 18*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 20*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 36*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 40*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 48*C*D1*Dd*f**3*r**2 + 64*C*D1*Dd*f**3*r*s - 64*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 40*C*D1*Dd*f**3*s + 28*C*D1*Dd*f**3 - 144*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 176*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 108*C*D1*Dd*f**2*fd*s - 52*C*D1*Dd*f**2*fd - 24*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 32*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 20*C*D1*Ddd*f**3*s - 14*C*D1*Ddd*f**3 - 72*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 96*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 60*C*Dd**2*f**3*s - 28*C*Dd**2*f**3 + 108*D1**2*K*b1*f*fd*r**2 + 144*D1**2*K*b1*f*fd*r*s - 72*D1**2*K*b1*f*fd*r + 36*D1**2*K*b1*f*fd*s**2 - 36*D1**2*K*b1*f*fd*s + 18*D1**2*K*b1*f*fd - 54*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*r*s + 36*D1**2*K*b1*f*fdd*r - 18*D1**2*K*b1*f*fdd*s**2 + 18*D1**2*K*b1*f*fdd*s - 9*D1**2*K*b1*f*fdd - 54*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*r*s + 36*D1**2*K*b1*fd**2*r - 18*D1**2*K*b1*fd**2*s**2 + 18*D1**2*K*b1*fd**2*s - 27*D1**2*K*bdd1*f**2*r**2 - 36*D1**2*K*bdd1*f**2*r*s + 54*D1**2*K*bdd1*f**2*r - 9*D1**2*K*bdd1*f**2*s**2 + 36*D1**2*K*bdd1*f**2*s - 27*D1**2*K*bdd1*f**2 - 27*D1**2*b1*f**2*fd*r**2 - 27*D1**2*b1*f**2*fd*r*s + 27*D1**2*b1*f**2*fd*r + 9*D1**2*b1*f**2*fd*s - 9*D1**2*b1*f**2*fd + 27*D1**2*b1*f**2*fdd*r**2 + 27*D1**2*b1*f**2*fdd*r*s - 27*D1**2*b1*f**2*fdd*r - 9*D1**2*b1*f**2*fdd*s + 9*D1**2*b1*f**2*fdd + 54*D1**2*b1*f*fd**2*r**2 + 54*D1**2*b1*f*fd**2*r*s - 54*D1**2*b1*f*fd**2*r - 18*D1**2*b1*f*fd**2*s + 9*D1**2*b1*f*fd**2 - 36*D1**2*b1*f*fd*r**2 - 36*D1**2*b1*f*fd*r*s + 18*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 18*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r + 36*D1**2*b2*f*fd*r**2 + 72*D1**2*b2*f*fd*r*s - 36*D1**2*b2*f*fd*r + 36*D1**2*b2*f*fd*s**2 - 36*D1**2*b2*f*fd*s + 18*D1**2*b2*f*fd - 18*D1**2*b2*f*fdd*r**2 - 36*D1**2*b2*f*fdd*r*s + 18*D1**2*b2*f*fdd*r - 18*D1**2*b2*f*fdd*s**2 + 18*D1**2*b2*f*fdd*s - 9*D1**2*b2*f*fdd - 18*D1**2*b2*fd**2*r**2 - 36*D1**2*b2*fd**2*r*s + 18*D1**2*b2*fd**2*r - 18*D1**2*b2*fd**2*s**2 + 18*D1**2*b2*fd**2*s + 9*D1**2*bdd1*f**3*r**2 + 9*D1**2*bdd1*f**3*r*s - 18*D1**2*bdd1*f**3*r - 9*D1**2*bdd1*f**3*s + 9*D1**2*bdd1*f**3 + 9*D1**2*bdd1*f**2*r**2 + 9*D1**2*bdd1*f**2*r*s - 18*D1**2*bdd1*f**2*r - 9*D1**2*bdd1*f**2*s + 9*D1**2*bdd1*f**2 - 9*D1**2*bdd2*f**2*r**2 - 18*D1**2*bdd2*f**2*r*s + 18*D1**2*bdd2*f**2*r - 9*D1**2*bdd2*f**2*s**2 + 18*D1**2*bdd2*f**2*s - 9*D1**2*bdd2*f**2 - 24*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 26*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 14*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 13*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 7*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd - 108*D1**2*f**2*gd2*r**2 - 144*D1**2*f**2*gd2*r*s + 216*D1**2*f**2*gd2*r - 36*D1**2*f**2*gd2*s**2 + 144*D1**2*f**2*gd2*s - 108*D1**2*f**2*gd2 + 54*D1**2*f**2*gdd2*r**2 + 72*D1**2*f**2*gdd2*r*s - 108*D1**2*f**2*gdd2*r + 18*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2*s + 54*D1**2*f**2*gdd2 + 24*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 26*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 14*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 - 216*D1**2*f*fd*g2*r**2 - 288*D1**2*f*fd*g2*r*s + 144*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 72*D1**2*f*fd*g2*s - 36*D1**2*f*fd*g2 + 216*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r*s - 288*D1**2*f*fd*gd2*r + 72*D1**2*f*fd*gd2*s**2 - 180*D1**2*f*fd*gd2*s + 72*D1**2*f*fd*gd2 + 108*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*r*s - 72*D1**2*f*fdd*g2*r + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 108*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*r*s - 72*D1**2*fd**2*g2*r + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 216*D1*Dd*K*b1*f**2*r**2 + 288*D1*Dd*K*b1*f**2*r*s - 288*D1*Dd*K*b1*f**2*r + 72*D1*Dd*K*b1*f**2*s**2 - 180*D1*Dd*K*b1*f**2*s + 126*D1*Dd*K*b1*f**2 - 432*D1*Dd*K*b1*f*fd*r**2 - 576*D1*Dd*K*b1*f*fd*r*s + 432*D1*Dd*K*b1*f*fd*r - 144*D1*Dd*K*b1*f*fd*s**2 + 252*D1*Dd*K*b1*f*fd*s - 90*D1*Dd*K*b1*f*fd - 36*D1*Dd*b1*f**3*r**2 - 36*D1*Dd*b1*f**3*r*s + 45*D1*Dd*b1*f**3*r + 18*D1*Dd*b1*f**3*s - 18*D1*Dd*b1*f**3 + 216*D1*Dd*b1*f**2*fd*r**2 + 216*D1*Dd*b1*f**2*fd*r*s - 243*D1*Dd*b1*f**2*fd*r - 90*D1*Dd*b1*f**2*fd*s + 63*D1*Dd*b1*f**2*fd - 72*D1*Dd*b1*f**2*r**2 - 72*D1*Dd*b1*f**2*r*s + 90*D1*Dd*b1*f**2*r + 36*D1*Dd*b1*f**2*s - 36*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 126*D1*Dd*b1*f*fd*r - 36*D1*Dd*b1*f*fd*s + 18*D1*Dd*b1*f*fd + 72*D1*Dd*b2*f**2*r**2 + 144*D1*Dd*b2*f**2*r*s - 108*D1*Dd*b2*f**2*r + 72*D1*Dd*b2*f**2*s**2 - 108*D1*Dd*b2*f**2*s + 54*D1*Dd*b2*f**2 - 144*D1*Dd*b2*f*fd*r**2 - 288*D1*Dd*b2*f*fd*r*s + 180*D1*Dd*b2*f*fd*r - 144*D1*Dd*b2*f*fd*s**2 + 180*D1*Dd*b2*f*fd*s - 54*D1*Dd*b2*f*fd - 32*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 42*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 24*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 115*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 64*D1*Dd*f**2*fd*s + 33*D1*Dd*f**2*fd - 432*D1*Dd*f**2*g2*r**2 - 576*D1*Dd*f**2*g2*r*s + 576*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 360*D1*Dd*f**2*g2*s - 252*D1*Dd*f**2*g2 + 432*D1*Dd*f**2*gd2*r**2 + 576*D1*Dd*f**2*gd2*r*s - 720*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s**2 - 468*D1*Dd*f**2*gd2*s + 288*D1*Dd*f**2*gd2 + 864*D1*Dd*f*fd*g2*r**2 + 1152*D1*Dd*f*fd*g2*r*s - 864*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s**2 - 504*D1*Dd*f*fd*g2*s + 180*D1*Dd*f*fd*g2 - 108*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r*s + 144*D1*Ddd*K*b1*f**2*r - 36*D1*Ddd*K*b1*f**2*s**2 + 90*D1*Ddd*K*b1*f**2*s - 63*D1*Ddd*K*b1*f**2 + 36*D1*Ddd*b1*f**3*r**2 + 36*D1*Ddd*b1*f**3*r*s - 45*D1*Ddd*b1*f**3*r - 18*D1*Ddd*b1*f**3*s + 18*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 45*D1*Ddd*b1*f**2*r - 18*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 - 36*D1*Ddd*b2*f**2*r**2 - 72*D1*Ddd*b2*f**2*r*s + 54*D1*Ddd*b2*f**2*r - 36*D1*Ddd*b2*f**2*s**2 + 54*D1*Ddd*b2*f**2*s - 27*D1*Ddd*b2*f**2 + 16*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 21*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 + 216*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r*s - 288*D1*Ddd*f**2*g2*r + 72*D1*Ddd*f**2*g2*s**2 - 180*D1*Ddd*f**2*g2*s + 126*D1*Ddd*f**2*g2 - 9*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (2*r + 2*s - 2)*(K*(3*r + s - 3) - r + 1)) + fd*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(2*K*(12*r**2 + 4*r*(4*s - 5) + 4*s**2 - 13*s + 8) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) + 18*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 324*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r*s + 432*Dd**2*K*b1*f**2*r - 108*Dd**2*K*b1*f**2*s**2 + 270*Dd**2*K*b1*f**2*s - 126*Dd**2*K*b1*f**2 + 108*Dd**2*b1*f**3*r**2 + 108*Dd**2*b1*f**3*r*s - 135*Dd**2*b1*f**3*r - 54*Dd**2*b1*f**3*s + 36*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 135*Dd**2*b1*f**2*r - 54*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 - 108*Dd**2*b2*f**2*r**2 - 216*Dd**2*b2*f**2*r*s + 162*Dd**2*b2*f**2*r - 108*Dd**2*b2*f**2*s**2 + 162*Dd**2*b2*f**2*s - 54*Dd**2*b2*f**2 + 48*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 63*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 18*Dd**2*f**3 + 648*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r*s - 864*Dd**2*f**2*g2*r + 216*Dd**2*f**2*g2*s**2 - 540*Dd**2*f**2*g2*s + 252*Dd**2*f**2*g2)/(63*d**2*k3**6) - 2*D1**2*Pk2*Pk3*k2**4*st**4*(-16*C*D1**2*bd1*f**2*r**2 - 32*C*D1**2*bd1*f**2*r*s + 48*C*D1**2*bd1*f**2*r - 16*C*D1**2*bd1*f**2*s**2 + 48*C*D1**2*bd1*f**2*s - 24*C*D1**2*bd1*f**2 + 32*C*D1**2*bd1*f*fd*r**2 + 64*C*D1**2*bd1*f*fd*r*s - 56*C*D1**2*bd1*f*fd*r + 32*C*D1**2*bd1*f*fd*s**2 - 56*C*D1**2*bd1*f*fd*s + 24*C*D1**2*bd1*f*fd + 8*C*D1**2*bdd1*f**2*r**2 + 16*C*D1**2*bdd1*f**2*r*s - 24*C*D1**2*bdd1*f**2*r + 8*C*D1**2*bdd1*f**2*s**2 - 24*C*D1**2*bdd1*f**2*s + 12*C*D1**2*bdd1*f**2 - 30*C*D1**2*f**2*fd*r**2 - 60*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 78*C*D1**2*f**2*fdd*r**2 + 132*C*D1**2*f**2*fdd*r*s - 96*C*D1**2*f**2*fdd*r + 54*C*D1**2*f**2*fdd*s**2 - 80*C*D1**2*f**2*fdd*s + 44*C*D1**2*f**2*fdd + 156*C*D1**2*f*fd**2*r**2 + 264*C*D1**2*f*fd**2*r*s - 192*C*D1**2*f*fd**2*r + 108*C*D1**2*f*fd**2*s**2 - 160*C*D1**2*f*fd**2*s + 44*C*D1**2*f*fd**2 + 64*C*D1*Dd*bd1*f**2*r**2 + 128*C*D1*Dd*bd1*f**2*r*s - 144*C*D1*Dd*bd1*f**2*r + 64*C*D1*Dd*bd1*f**2*s**2 - 144*C*D1*Dd*bd1*f**2*s + 72*C*D1*Dd*bd1*f**2 - 40*C*D1*Dd*f**3*r**2 - 80*C*D1*Dd*f**3*r*s + 60*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 60*C*D1*Dd*f**3*s - 30*C*D1*Dd*f**3 + 624*C*D1*Dd*f**2*fd*r**2 + 1056*C*D1*Dd*f**2*fd*r*s - 828*C*D1*Dd*f**2*fd*r + 432*C*D1*Dd*f**2*fd*s**2 - 692*C*D1*Dd*f**2*fd*s + 272*C*D1*Dd*f**2*fd + 104*C*D1*Ddd*f**3*r**2 + 176*C*D1*Ddd*f**3*r*s - 148*C*D1*Ddd*f**3*r + 72*C*D1*Ddd*f**3*s**2 - 124*C*D1*Ddd*f**3*s + 70*C*D1*Ddd*f**3 + 312*C*Dd**2*f**3*r**2 + 528*C*Dd**2*f**3*r*s - 444*C*Dd**2*f**3*r + 216*C*Dd**2*f**3*s**2 - 372*C*Dd**2*f**3*s + 140*C*Dd**2*f**3 + 56*D1**2*K*bd1**2*f*r**2 + 112*D1**2*K*bd1**2*f*r*s - 140*D1**2*K*bd1**2*f*r + 56*D1**2*K*bd1**2*f*s**2 - 140*D1**2*K*bd1**2*f*s + 84*D1**2*K*bd1**2*f + 21*D1**2*K*bd1*f**2*r**2 - 14*D1**2*K*bd1*f**2*r*s - 42*D1**2*K*bd1*f**2*r - 35*D1**2*K*bd1*f**2*s**2 + 14*D1**2*K*bd1*f**2*s + 21*D1**2*K*bd1*f**2 + 140*D1**2*K*bd1*f*fd*r**2 + 392*D1**2*K*bd1*f*fd*r*s - 238*D1**2*K*bd1*f*fd*r + 252*D1**2*K*bd1*f*fd*s**2 - 322*D1**2*K*bd1*f*fd*s + 98*D1**2*K*bd1*f*fd + 35*D1**2*K*bdd1*f**2*r**2 + 98*D1**2*K*bdd1*f**2*r*s - 70*D1**2*K*bdd1*f**2*r + 63*D1**2*K*bdd1*f**2*s**2 - 98*D1**2*K*bdd1*f**2*s + 35*D1**2*K*bdd1*f**2 - 28*D1**2*bd1**2*f**2*r**2 - 28*D1**2*bd1**2*f**2*r*s + 42*D1**2*bd1**2*f**2*r + 14*D1**2*bd1**2*f**2*s - 14*D1**2*bd1**2*f**2 - 28*D1**2*bd1**2*f*r**2 - 28*D1**2*bd1**2*f*r*s + 42*D1**2*bd1**2*f*r + 14*D1**2*bd1**2*f*s - 14*D1**2*bd1**2*f + 28*D1**2*bd1*bd2*f*r**2 + 56*D1**2*bd1*bd2*f*r*s - 56*D1**2*bd1*bd2*f*r + 28*D1**2*bd1*bd2*f*s**2 - 56*D1**2*bd1*bd2*f*s + 28*D1**2*bd1*bd2*f - 2*D1**2*bd1*f**2*r**2 + 6*D1**2*bd1*f**2*r*s + 8*D1**2*bd1*f**2*s**2 - 10*D1**2*bd1*f**2*s - 2*D1**2*bd1*f**2 - 24*D1**2*bd1*f*fd*r**2 - 40*D1**2*bd1*f*fd*r*s + 36*D1**2*bd1*f*fd*r - 16*D1**2*bd1*f*fd*s**2 + 30*D1**2*bd1*f*fd*s - 14*D1**2*bd1*f*fd + 112*D1**2*bd1*f*g2*r**2 + 224*D1**2*bd1*f*g2*r*s - 336*D1**2*bd1*f*g2*r + 112*D1**2*bd1*f*g2*s**2 - 336*D1**2*bd1*f*g2*s + 168*D1**2*bd1*f*g2 - 112*D1**2*bd1*f*gd2*r**2 - 224*D1**2*bd1*f*gd2*r*s + 280*D1**2*bd1*f*gd2*r - 112*D1**2*bd1*f*gd2*s**2 + 280*D1**2*bd1*f*gd2*s - 168*D1**2*bd1*f*gd2 - 112*D1**2*bd1*fd*g2*r**2 - 224*D1**2*bd1*fd*g2*r*s + 112*D1**2*bd1*fd*g2*r - 112*D1**2*bd1*fd*g2*s**2 + 112*D1**2*bd1*fd*g2*s + 14*D1**2*bd2*f**2*r**2 + 28*D1**2*bd2*f**2*r*s - 28*D1**2*bd2*f**2*r + 14*D1**2*bd2*f**2*s**2 - 28*D1**2*bd2*f**2*s + 14*D1**2*bd2*f**2 - 6*D1**2*bdd1*f**2*r**2 - 10*D1**2*bdd1*f**2*r*s + 14*D1**2*bdd1*f**2*r - 4*D1**2*bdd1*f**2*s**2 + 12*D1**2*bdd1*f**2*s - 6*D1**2*bdd1*f**2 - 56*D1**2*bdd1*f*g2*r**2 - 112*D1**2*bdd1*f*g2*r*s + 168*D1**2*bdd1*f*g2*r - 56*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 + 9*D1**2*f**2*fd*r**2 + 24*D1**2*f**2*fd*r*s - 14*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 18*D1**2*f**2*fd*s + 8*D1**2*f**2*fd - 39*D1**2*f**2*fdd*r**2 - 66*D1**2*f**2*fdd*r*s + 48*D1**2*f**2*fdd*r - 27*D1**2*f**2*fdd*s**2 + 40*D1**2*f**2*fdd*s - 22*D1**2*f**2*fdd - 42*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s + 84*D1**2*f**2*gd2*r + 70*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s - 42*D1**2*f**2*gd2 - 70*D1**2*f**2*gdd2*r**2 - 196*D1**2*f**2*gdd2*r*s + 140*D1**2*f**2*gdd2*r - 126*D1**2*f**2*gdd2*s**2 + 196*D1**2*f**2*gdd2*s - 70*D1**2*f**2*gdd2 - 78*D1**2*f*fd**2*r**2 - 132*D1**2*f*fd**2*r*s + 96*D1**2*f*fd**2*r - 54*D1**2*f*fd**2*s**2 + 80*D1**2*f*fd**2*s - 22*D1**2*f*fd**2 - 84*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 140*D1**2*f*fd*g2*s**2 - 140*D1**2*f*fd*g2*s + 70*D1**2*f*fd*g2 - 280*D1**2*f*fd*gd2*r**2 - 784*D1**2*f*fd*gd2*r*s + 476*D1**2*f*fd*gd2*r - 504*D1**2*f*fd*gd2*s**2 + 644*D1**2*f*fd*gd2*s - 196*D1**2*f*fd*gd2 - 140*D1**2*f*fdd*g2*r**2 - 392*D1**2*f*fdd*g2*r*s + 196*D1**2*f*fdd*g2*r - 252*D1**2*f*fdd*g2*s**2 + 252*D1**2*f*fdd*g2*s - 126*D1**2*f*fdd*g2 - 140*D1**2*fd**2*g2*r**2 - 392*D1**2*fd**2*g2*r*s + 196*D1**2*fd**2*g2*r - 252*D1**2*fd**2*g2*s**2 + 252*D1**2*fd**2*g2*s + 280*D1*Dd*K*bd1*f**2*r**2 + 784*D1*Dd*K*bd1*f**2*r*s - 518*D1*Dd*K*bd1*f**2*r + 504*D1*Dd*K*bd1*f**2*s**2 - 714*D1*Dd*K*bd1*f**2*s + 238*D1*Dd*K*bd1*f**2 - 48*D1*Dd*bd1*f**2*r**2 - 80*D1*Dd*bd1*f**2*r*s + 90*D1*Dd*bd1*f**2*r - 32*D1*Dd*bd1*f**2*s**2 + 76*D1*Dd*bd1*f**2*s - 40*D1*Dd*bd1*f**2 - 448*D1*Dd*bd1*f*g2*r**2 - 896*D1*Dd*bd1*f*g2*r*s + 1008*D1*Dd*bd1*f*g2*r - 448*D1*Dd*bd1*f*g2*s**2 + 1008*D1*Dd*bd1*f*g2*s - 504*D1*Dd*bd1*f*g2 + 12*D1*Dd*f**3*r**2 + 32*D1*Dd*f**3*r*s - 20*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 26*D1*Dd*f**3*s + 11*D1*Dd*f**3 - 312*D1*Dd*f**2*fd*r**2 - 528*D1*Dd*f**2*fd*r*s + 414*D1*Dd*f**2*fd*r - 216*D1*Dd*f**2*fd*s**2 + 346*D1*Dd*f**2*fd*s - 136*D1*Dd*f**2*fd - 168*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s + 140*D1*Dd*f**2*g2*r + 280*D1*Dd*f**2*g2*s**2 - 196*D1*Dd*f**2*g2*s - 14*D1*Dd*f**2*g2 - 560*D1*Dd*f**2*gd2*r**2 - 1568*D1*Dd*f**2*gd2*r*s + 1036*D1*Dd*f**2*gd2*r - 1008*D1*Dd*f**2*gd2*s**2 + 1428*D1*Dd*f**2*gd2*s - 476*D1*Dd*f**2*gd2 - 1120*D1*Dd*f*fd*g2*r**2 - 3136*D1*Dd*f*fd*g2*r*s + 1736*D1*Dd*f*fd*g2*r - 2016*D1*Dd*f*fd*g2*s**2 + 2296*D1*Dd*f*fd*g2*s - 644*D1*Dd*f*fd*g2 - 52*D1*Ddd*f**3*r**2 - 88*D1*Ddd*f**3*r*s + 74*D1*Ddd*f**3*r - 36*D1*Ddd*f**3*s**2 + 62*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 280*D1*Ddd*f**2*g2*r**2 - 784*D1*Ddd*f**2*g2*r*s + 476*D1*Ddd*f**2*g2*r - 504*D1*Ddd*f**2*g2*s**2 + 644*D1*Ddd*f**2*g2*s - 266*D1*Ddd*f**2*g2 - 28*D1*b2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 14*D1*b2*f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 156*Dd**2*f**3*r**2 - 264*Dd**2*f**3*r*s + 222*Dd**2*f**3*r - 108*Dd**2*f**3*s**2 + 186*Dd**2*f**3*s - 70*Dd**2*f**3 - 840*Dd**2*f**2*g2*r**2 - 2352*Dd**2*f**2*g2*r*s + 1428*Dd**2*f**2*g2*r - 1512*Dd**2*f**2*g2*s**2 + 1932*Dd**2*f**2*g2*s - 532*Dd**2*f**2*g2 + 14*b1**2*(D1**2*(-2*K*fd*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-2*r**2 - 2*r*(s - 1) + s) + 2*fd*r*(r + s) + fdd*(K*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) - r*(r + s))) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(2*K*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + b1*(-32*C*D1**2*f*fd*r**2 - 64*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s**2 + 16*C*D1**2*f*fd*s - 8*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r**2 + 32*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r + 16*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s + 4*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r**2 + 32*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r + 16*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 - 64*C*D1*Dd*f**2*r**2 - 128*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r**2 + 256*C*D1*Dd*f*fd*r*s - 128*C*D1*Dd*f*fd*r + 128*C*D1*Dd*f*fd*s**2 - 128*C*D1*Dd*f*fd*s + 24*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r**2 + 64*C*D1*Ddd*f**2*r*s - 48*C*D1*Ddd*f**2*r + 32*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 24*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r**2 + 192*C*Dd**2*f**2*r*s - 144*C*Dd**2*f**2*r + 96*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 + 56*D1**2*K*bdd1*f*r**2 + 112*D1**2*K*bdd1*f*r*s - 140*D1**2*K*bdd1*f*r + 56*D1**2*K*bdd1*f*s**2 - 140*D1**2*K*bdd1*f*s + 70*D1**2*K*bdd1*f + 42*D1**2*K*f*fd*r**2 - 28*D1**2*K*f*fd*r*s + 14*D1**2*K*f*fd*r - 70*D1**2*K*f*fd*s**2 + 70*D1**2*K*f*fd*s - 35*D1**2*K*f*fd + 70*D1**2*K*f*fdd*r**2 + 196*D1**2*K*f*fdd*r*s - 98*D1**2*K*f*fdd*r + 126*D1**2*K*f*fdd*s**2 - 126*D1**2*K*f*fdd*s + 63*D1**2*K*f*fdd + 70*D1**2*K*fd**2*r**2 + 196*D1**2*K*fd**2*r*s - 98*D1**2*K*fd**2*r + 126*D1**2*K*fd**2*s**2 - 126*D1**2*K*fd**2*s - 28*D1**2*b2*fd*r**2 - 56*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*s**2 + 14*D1**2*b2*fdd*r**2 + 28*D1**2*b2*fdd*r*s + 14*D1**2*b2*fdd*s**2 - 28*D1**2*bdd1*f**2*r**2 - 28*D1**2*bdd1*f**2*r*s + 42*D1**2*bdd1*f**2*r + 14*D1**2*bdd1*f**2*s - 14*D1**2*bdd1*f**2 - 28*D1**2*bdd1*f*r**2 - 28*D1**2*bdd1*f*r*s + 42*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s - 14*D1**2*bdd1*f + 14*D1**2*bdd2*f*r**2 + 28*D1**2*bdd2*f*r*s - 28*D1**2*bdd2*f*r + 14*D1**2*bdd2*f*s**2 - 28*D1**2*bdd2*f*s + 14*D1**2*bdd2*f - 4*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 16*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s + 8*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 8*D1**2*f*fdd*r - 8*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 4*D1**2*f*fdd + 112*D1**2*f*gd2*r**2 + 224*D1**2*f*gd2*r*s - 224*D1**2*f*gd2*r + 112*D1**2*f*gd2*s**2 - 224*D1**2*f*gd2*s + 112*D1**2*f*gd2 - 56*D1**2*f*gdd2*r**2 - 112*D1**2*f*gdd2*r*s + 112*D1**2*f*gdd2*r - 56*D1**2*f*gdd2*s**2 + 112*D1**2*f*gdd2*s - 56*D1**2*f*gdd2 - 12*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 8*D1**2*fd**2*r - 8*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s + 4*D1**2*fd**2 + 112*D1**2*fd*g2*r**2 + 224*D1**2*fd*g2*r*s + 112*D1**2*fd*g2*r + 112*D1**2*fd*g2*s**2 + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 - 112*D1**2*fd*gd2*r**2 - 224*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 112*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r**2 - 112*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r - 56*D1**2*fdd*g2*s**2 - 56*D1**2*fdd*g2*s + 28*D1**2*fdd*g2 + 84*D1*Dd*K*f**2*r**2 - 56*D1*Dd*K*f**2*r*s - 70*D1*Dd*K*f**2*r - 140*D1*Dd*K*f**2*s**2 + 98*D1*Dd*K*f**2*s + 7*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*r**2 + 1568*D1*Dd*K*f*fd*r*s - 868*D1*Dd*K*f*fd*r + 1008*D1*Dd*K*f*fd*s**2 - 1148*D1*Dd*K*f*fd*s + 322*D1*Dd*K*f*fd - 112*D1*Dd*b2*f*r**2 - 224*D1*Dd*b2*f*r*s + 168*D1*Dd*b2*f*r - 112*D1*Dd*b2*f*s**2 + 168*D1*Dd*b2*f*s - 84*D1*Dd*b2*f + 112*D1*Dd*b2*fd*r**2 + 224*D1*Dd*b2*fd*r*s - 84*D1*Dd*b2*fd*r + 112*D1*Dd*b2*fd*s**2 - 84*D1*Dd*b2*fd*s - 8*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r + 32*D1*Dd*f**2*s**2 - 28*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r - 64*D1*Dd*f*fd*s**2 + 80*D1*Dd*f*fd*s - 22*D1*Dd*f*fd + 448*D1*Dd*f*g2*r**2 + 896*D1*Dd*f*g2*r*s - 672*D1*Dd*f*g2*r + 448*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 336*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r**2 - 896*D1*Dd*f*gd2*r*s + 784*D1*Dd*f*gd2*r - 448*D1*Dd*f*gd2*s**2 + 784*D1*Dd*f*gd2*s - 336*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r**2 - 896*D1*Dd*fd*g2*r*s + 112*D1*Dd*fd*g2*r - 448*D1*Dd*fd*g2*s**2 + 112*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*r**2 + 392*D1*Ddd*K*f**2*r*s - 238*D1*Ddd*K*f**2*r + 252*D1*Ddd*K*f**2*s**2 - 322*D1*Ddd*K*f**2*s + 133*D1*Ddd*K*f**2 + 56*D1*Ddd*b2*f*r**2 + 112*D1*Ddd*b2*f*r*s - 84*D1*Ddd*b2*f*r + 56*D1*Ddd*b2*f*s**2 - 84*D1*Ddd*b2*f*s + 42*D1*Ddd*b2*f - 24*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 34*D1*Ddd*f**2*r - 16*D1*Ddd*f**2*s**2 + 28*D1*Ddd*f**2*s - 16*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r**2 - 448*D1*Ddd*f*g2*r*s + 336*D1*Ddd*f*g2*r - 224*D1*Ddd*f*g2*s**2 + 336*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(2*K*(4*r**2 + 2*r*(4*s - 5) + 4*s**2 - 10*s + 5) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(2*K*(4*r**2 + 8*r*s - 3*r + 4*s**2 - 3*s - 1) - 4*r**2 - 4*r*s + 3*r + s)) + Dd*f*(K*(32*r**2 + 64*r*(s - 1) + 32*s**2 - 64*s + 30) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 28*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 420*Dd**2*K*f**2*r**2 + 1176*Dd**2*K*f**2*r*s - 714*Dd**2*K*f**2*r + 756*Dd**2*K*f**2*s**2 - 966*Dd**2*K*f**2*s + 266*Dd**2*K*f**2 + 168*Dd**2*b2*f*r**2 + 336*Dd**2*b2*f*r*s - 252*Dd**2*b2*f*r + 168*Dd**2*b2*f*s**2 - 252*Dd**2*b2*f*s + 84*Dd**2*b2*f - 72*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 102*Dd**2*f**2*r - 48*Dd**2*f**2*s**2 + 84*Dd**2*f**2*s - 32*Dd**2*f**2 - 672*Dd**2*f*g2*r**2 - 1344*Dd**2*f*g2*r*s + 1008*Dd**2*f*g2*r - 672*Dd**2*f*g2*s**2 + 1008*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(35*d**2*k3**6) - 2*D1**2*Pk2*Pk3*k2**4*st**2*(D1*(70*D1*b2*bd1*f*(r + s - 1)**2 + 14*D1*bd1**2*(r + s - 1)*(25*K*f*(r + s - 1) - f*(4*C - 2)*(r + s) + 20*g2*(r + s)) + D1*bdd1*f*(f*(2*C - 1)*(83*r + 35*s - 35) - 350*g2*(r + s - 1))*(r + s - 1) - bd1*(D1*(f**2*(2*C*(33*r**2 + r*(26*s + 2) - 7*s**2 + 42*s - 21) - 19*r**2 - 4*r*(3*s + 4) + 7*s**2 - 42*s + 21) - f*fd*(4*C - 2)*(166*r**2 + r*(236*s - 201) + 70*s**2 - 129*s + 59) + 70*f*(g2*(r**2 + 2*r*(s - 3) + s**2 - 6*s + 3) + 10*gd2*(r + s - 1)**2) + 700*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(-f*(2*C - 1)*(332*r**2 + r*(472*s - 461) + 140*s**2 - 293*s + 153) + 350*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 70*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(D1**2*(10*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(8*C*(r + s - 1)**2 + 5*K*(r**2 + 2*r*(s + 2) + s**2 + 4*s - 2) - 14*r**2 - 2*r*(9*s - 4) - 4*(s - 1)**2) + fdd*(-4*C*(r + s - 1)**2 + 25*K*s**2 + r**2*(25*K + 2) + r*(50*K*s + 4*s - 4) + 2*s**2 - 4*s + 2) - 40*gd2*(r + s - 1)**2 + 20*gdd2*(r + s - 1)**2) + D1*(Dd*(f*(8*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 56*r**2 - 72*r*s + 74*r - 16*s**2 + 44*s - 32) - 2*fd*(4*r + 4*s - 3)*(4*C*(r + s - 1) - 25*K*s - r*(25*K + 2) - 2*s + 2) - 40*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(80*r + 80*s - 60)) + Ddd*(f*(-4*C + 25*K + 2) + 20*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(-4*C + 25*K + 2) + 20*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - b1*(56*C*D1**2*bdd1*f*r**2 + 112*C*D1**2*bdd1*f*r*s - 56*C*D1**2*bdd1*f*r + 56*C*D1**2*bdd1*f*s**2 - 56*C*D1**2*bdd1*f*s + 28*C*D1**2*bdd1*f + 132*C*D1**2*f*fd*r**2 + 104*C*D1**2*f*fd*r*s - 188*C*D1**2*f*fd*r - 28*C*D1**2*f*fd*s**2 - 108*C*D1**2*f*fd*s + 94*C*D1**2*f*fd - 332*C*D1**2*f*fdd*r**2 - 472*C*D1**2*f*fdd*r*s + 332*C*D1**2*f*fdd*r - 140*C*D1**2*f*fdd*s**2 + 236*C*D1**2*f*fdd*s - 166*C*D1**2*f*fdd - 332*C*D1**2*fd**2*r**2 - 472*C*D1**2*fd**2*r*s + 332*C*D1**2*fd**2*r - 140*C*D1**2*fd**2*s**2 + 236*C*D1**2*fd**2*s + 264*C*D1*Dd*f**2*r**2 + 208*C*D1*Dd*f**2*r*s - 316*C*D1*Dd*f**2*r - 56*C*D1*Dd*f**2*s**2 - 76*C*D1*Dd*f**2*s + 118*C*D1*Dd*f**2 - 2656*C*D1*Dd*f*fd*r**2 - 3776*C*D1*Dd*f*fd*r*s + 3128*C*D1*Dd*f*fd*r - 1120*C*D1*Dd*f*fd*s**2 + 2168*C*D1*Dd*f*fd*s - 900*C*D1*Dd*f*fd - 664*C*D1*Ddd*f**2*r**2 - 944*C*D1*Ddd*f**2*r*s + 900*C*D1*Ddd*f**2*r - 280*C*D1*Ddd*f**2*s**2 + 612*C*D1*Ddd*f**2*s - 402*C*D1*Ddd*f**2 - 1992*C*Dd**2*f**2*r**2 - 2832*C*Dd**2*f**2*r*s + 2700*C*Dd**2*f**2*r - 840*C*Dd**2*f**2*s**2 + 1836*C*Dd**2*f**2*s - 804*C*Dd**2*f**2 + 140*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 350*D1**2*K*bdd1*f*r**2 - 700*D1**2*K*bdd1*f*r*s + 700*D1**2*K*bdd1*f*r - 350*D1**2*K*bdd1*f*s**2 + 700*D1**2*K*bdd1*f*s - 350*D1**2*K*bdd1*f - 70*D1**2*b2*fd*r**2 - 140*D1**2*b2*fd*r*s - 70*D1**2*b2*fd*s**2 - 70*D1**2*bd2*f*(r + s - 1)**2 - 28*D1**2*bdd1*f*r**2 - 56*D1**2*bdd1*f*r*s + 28*D1**2*bdd1*f*r - 28*D1**2*bdd1*f*s**2 + 28*D1**2*bdd1*f*s - 14*D1**2*bdd1*f - 280*D1**2*bdd1*g2*r**2 - 560*D1**2*bdd1*g2*r*s + 280*D1**2*bdd1*g2*r - 280*D1**2*bdd1*g2*s**2 + 280*D1**2*bdd1*g2*s - 140*D1**2*bdd1*g2 - 38*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 66*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 + 40*D1**2*f*fd*s - 33*D1**2*f*fd + 166*D1**2*f*fdd*r**2 + 236*D1**2*f*fdd*r*s - 166*D1**2*f*fdd*r + 70*D1**2*f*fdd*s**2 - 118*D1**2*f*fdd*s + 83*D1**2*f*fdd + 70*D1**2*f*gd2*r**2 + 140*D1**2*f*gd2*r*s - 140*D1**2*f*gd2*r + 70*D1**2*f*gd2*s**2 - 140*D1**2*f*gd2*s + 70*D1**2*f*gd2 + 350*D1**2*f*gdd2*r**2 + 700*D1**2*f*gdd2*r*s - 700*D1**2*f*gdd2*r + 350*D1**2*f*gdd2*s**2 - 700*D1**2*f*gdd2*s + 350*D1**2*f*gdd2 + 166*D1**2*fd**2*r**2 + 236*D1**2*fd**2*r*s - 166*D1**2*fd**2*r + 70*D1**2*fd**2*s**2 - 118*D1**2*fd**2*s + 70*D1**2*fd*g2*r**2 + 140*D1**2*fd*g2*r*s + 280*D1**2*fd*g2*r + 70*D1**2*fd*g2*s**2 + 280*D1**2*fd*g2*s - 140*D1**2*fd*g2 + 700*D1**2*fd*gd2*r**2 + 1400*D1**2*fd*gd2*r*s - 700*D1**2*fd*gd2*r + 700*D1**2*fd*gd2*s**2 - 700*D1**2*fd*gd2*s + 350*D1**2*fdd*g2*r**2 + 700*D1**2*fdd*g2*r*s + 350*D1**2*fdd*g2*s**2 - 280*D1*Dd*b2*f*r**2 - 560*D1*Dd*b2*f*r*s + 420*D1*Dd*b2*f*r - 280*D1*Dd*b2*f*s**2 + 420*D1*Dd*b2*f*s - 210*D1*Dd*b2*f - 76*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 88*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 + 10*D1*Dd*f**2*s - 31*D1*Dd*f**2 + 1328*D1*Dd*f*fd*r**2 + 1888*D1*Dd*f*fd*r*s - 1564*D1*Dd*f*fd*r + 560*D1*Dd*f*fd*s**2 - 1084*D1*Dd*f*fd*s + 450*D1*Dd*f*fd + 280*D1*Dd*f*g2*r**2 + 560*D1*Dd*f*g2*r*s - 420*D1*Dd*f*g2*r + 280*D1*Dd*f*g2*s**2 - 420*D1*Dd*f*g2*s + 210*D1*Dd*f*g2 + 2800*D1*Dd*f*gd2*r**2 + 5600*D1*Dd*f*gd2*r*s - 4900*D1*Dd*f*gd2*r + 2800*D1*Dd*f*gd2*s**2 - 4900*D1*Dd*f*gd2*s + 2100*D1*Dd*f*gd2 + 2800*D1*Dd*fd*g2*r**2 + 5600*D1*Dd*fd*g2*r*s - 2100*D1*Dd*fd*g2*r + 2800*D1*Dd*fd*g2*s**2 - 2100*D1*Dd*fd*g2*s + 332*D1*Ddd*f**2*r**2 + 472*D1*Ddd*f**2*r*s - 450*D1*Ddd*f**2*r + 140*D1*Ddd*f**2*s**2 - 306*D1*Ddd*f**2*s + 201*D1*Ddd*f**2 + 1400*D1*Ddd*f*g2*r**2 + 2800*D1*Ddd*f*g2*r*s - 2100*D1*Ddd*f*g2*r + 1400*D1*Ddd*f*g2*s**2 - 2100*D1*Ddd*f*g2*s + 1050*D1*Ddd*f*g2 - 14*D1*bd1*(D1*(f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*K*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) - 14*r**2 - 18*r*s + 19*r - 4*s**2 + 9*s - 7) + 2*fd*(r + s - 1)*(C*(-4*r - 4*s + 2) + 25*K*s + r*(25*K + 2) + 2*s - 1) - 20*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(C*(4*r + 4*s - 2) - 25*K*(r + s - 1) - 2*r - 2*s + 1) - 10*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 996*Dd**2*f**2*r**2 + 1416*Dd**2*f**2*r*s - 1350*Dd**2*f**2*r + 420*Dd**2*f**2*s**2 - 918*Dd**2*f**2*s + 402*Dd**2*f**2 + 4200*Dd**2*f*g2*r**2 + 8400*Dd**2*f*g2*r*s - 6300*Dd**2*f*g2*r + 4200*Dd**2*f*g2*s**2 - 6300*Dd**2*f*g2*s + 2100*Dd**2*f*g2))/(105*d**2*k3**6) + 4*D1**2*Pk2*Pk3*st**4*(D1*(-7*D1*bd1**2*f*s*(2*K*s + f*(2*r - 1) + 2*r - 1) + D1*bdd1*f*s*(f*(-2*C*s - r + s) + s*(-7*b2 + 14*g2)) + bd1*(D1*(2*f**2*s*(r + s*(2*C - 1)) + f*(fd*(-4*r*s + r + s*(-8*C*s + 4*C + 4*s - 1)) + s**2*(14*b2 - 14*bd2 - 28*g2 + 28*gd2)) - 14*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(f*(-8*r*s + r + 4*s*(-4*C*s + C + 2*s)) + s*(-14*b2 + 28*g2)*(4*s - 1)))) - 7*b1**2*(D1*Dd*(f*(K*(-8*s**2 + 4*s - 2) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(2*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(2*s - 1) - s + 1) + fd*(-2*K*(s - 1)**2 + f*s + r*(-2*f*s + f - 2*s + 2)) + fdd*(K*(s - 1)**2 - f*s + r*(2*f*s - f + s - 1))) + Ddd*f*(K*(4*s**2 - 2*s + 1) + (f + 1)*(r*(4*s - 1) - 2*s))) + Dd**2*f*(12*K*s**2 - 6*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(8*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd*s + 4*C*D1**2*f*fd - 4*C*D1**2*f*fdd*s**2 + 4*C*D1**2*f*fdd*s - 2*C*D1**2*f*fdd - 4*C*D1**2*fd**2*s**2 + 4*C*D1**2*fd**2*s + 16*C*D1*Dd*f**2*s**2 - 8*C*D1*Dd*f**2*s + 4*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*s**2 + 24*C*D1*Dd*f*fd*s - 4*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*s**2 + 4*C*D1*Ddd*f**2*s - 2*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*s**2 + 12*C*Dd**2*f**2*s - 14*D1**2*K*bdd1*f*s**2 + 14*D1**2*bd2*f*s**2 - 14*D1**2*bd2*fd*s**2 + 14*D1**2*bd2*fd*s - 14*D1**2*bdd1*f**2*r*s + 7*D1**2*bdd1*f**2*s - 14*D1**2*bdd1*f*r*s + 7*D1**2*bdd1*f*s - 7*D1**2*bdd2*f*s**2 + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - 2*D1**2*f*fd - 2*D1**2*f*fdd*r*s + D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - D1**2*f*fdd*s + D1**2*f*fdd - 28*D1**2*f*gd2*s**2 + 14*D1**2*f*gdd2*s**2 - 2*D1**2*fd**2*r*s + D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - D1**2*fd**2*s - D1**2*fd**2 - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 28*D1**2*fd*gd2*s**2 - 28*D1**2*fd*gd2*s + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 56*D1*Dd*bd2*f*s**2 + 14*D1*Dd*bd2*f*s + 8*D1*Dd*f**2*r*s - 2*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 - 2*D1*Dd*f**2 - 16*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 4*D1*Dd*f*fd*s - D1*Dd*f*fd - 112*D1*Dd*f*g2*s**2 + 56*D1*Dd*f*g2*s - 28*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*s**2 - 28*D1*Dd*f*gd2*s + 112*D1*Dd*fd*g2*s**2 - 140*D1*Dd*fd*g2*s + 28*D1*Dd*fd*g2 - 4*D1*Ddd*f**2*r*s + D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 + D1*Ddd*f**2 + 56*D1*Ddd*f*g2*s**2 - 28*D1*Ddd*f*g2*s + 14*D1*Ddd*f*g2 + 7*D1*bd1*(-D1*(f*s*(-4*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(4*K*s - 1))) - Dd*f*(16*K*s**2 - 4*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) - 12*Dd**2*f**2*r*s + 3*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 2*Dd**2*f**2 + 168*Dd**2*f*g2*s**2 - 84*Dd**2*f*g2*s + 7*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(35*d**2*k2**2) + D1**2*Pk2*Pk3*st**2*(D1*(7*D1*bd1**2*f*(r*(s*(30*f + 26) + 2) + 5*s*(10*K*s - 3*f - 3)) + D1*bdd1*f*s*(29*f*r + f*s*(70*C - 35) + s*(175*b2 - 350*g2)) + bd1*(D1*(f**2*s*(-51*r + s*(49 - 98*C)) + f*(29*fd*r*(4*s - 1) + fd*s*(140*C*(2*s - 1) - 140*s + 41) + s**2*(-245*b2 + 350*bd2 + 490*g2 - 700*gd2)) + 350*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(29*f*r*(8*s - 1) + 4*f*s*(35*C*(4*s - 1) - 70*s + 3) + s*(350*b2 - 700*g2)*(4*s - 1)))) - 70*b1**3*(D1*Dd*(fd*(8*r*s - r - 6*s + 1) - (f + 2)*(4*r*s - r - 2*s)) + D1*(-D1*s*(fd - fdd)*(r - 1) + Ddd*(f + 1)*(4*r*s - r - 2*s)) + Dd**2*(f + 1)*(3*r*(4*s - 1) - 6*s + 2)) + 7*b1**2*(D1*Dd*(f*(-35*K*(4*s**2 - 2*s + 1) - (15*f + 21)*(r*(4*s - 1) - 2*s)) + fd*(50*K*(4*s**2 - 5*s + 1) + 15*f*(2*r - 1)*(8*s - 3) + 104*r*s - 73*r - 18*s + 28)) + 10*D1*bd1*(-D1*fd*(r*(6*s - 1) - 4*s + 1) + D1*(f + 2)*(r*(3*s - 1) - s) - Dd*(f + 1)*(r*(24*s - 7) - 10*s + 3)) + D1*(D1*(-10*bdd1*(f + 1)*(r*(3*s - 1) - s) + 15*fd**2*(r*(2*s - 1) - s + 1) + fd*(-35*K*(s - 1)**2 + r*(-30*f*s + 15*f - 21*s + 25) + s*(15*f - 4)) + fdd*(25*K*(s - 1)**2 + r*(30*f*s - 15*f + 13*s - 15) + s*(2 - 15*f))) + Ddd*f*(25*K*(4*s**2 - 2*s + 1) + (15*f + 13)*(r*(4*s - 1) - 2*s))) + Dd**2*f*(300*K*s**2 - 150*K*s + 15*f*(3*r*(4*s - 1) - 6*s + 2) + 39*r*(4*s - 1) - 78*s + 26)) + b1*(-196*C*D1**2*f*fd*s**2 + 196*C*D1**2*f*fd*s - 98*C*D1**2*f*fd + 140*C*D1**2*f*fdd*s**2 - 140*C*D1**2*f*fdd*s + 70*C*D1**2*f*fdd + 140*C*D1**2*fd**2*s**2 - 140*C*D1**2*fd**2*s - 392*C*D1*Dd*f**2*s**2 + 196*C*D1*Dd*f**2*s - 98*C*D1*Dd*f**2 + 1120*C*D1*Dd*f*fd*s**2 - 840*C*D1*Dd*f*fd*s + 140*C*D1*Dd*f*fd + 280*C*D1*Ddd*f**2*s**2 - 140*C*D1*Ddd*f**2*s + 70*C*D1*Ddd*f**2 + 840*C*Dd**2*f**2*s**2 - 420*C*Dd**2*f**2*s + 350*D1**2*K*bdd1*f*s**2 - 70*D1**2*bd1**2*(f + 1)*(r*(6*s - 2) - 2*s + 1) - 245*D1**2*bd2*f*s**2 + 350*D1**2*bd2*fd*s**2 - 350*D1**2*bd2*fd*s + 210*D1**2*bdd1*f**2*r*s - 105*D1**2*bdd1*f**2*s + 182*D1**2*bdd1*f*r*s + 14*D1**2*bdd1*f*r - 105*D1**2*bdd1*f*s + 175*D1**2*bdd2*f*s**2 - 102*D1**2*f*fd*r*s + 51*D1**2*f*fd*r + 98*D1**2*f*fd*s**2 - 47*D1**2*f*fd*s + 49*D1**2*f*fd + 58*D1**2*f*fdd*r*s - 29*D1**2*f*fdd*r - 70*D1**2*f*fdd*s**2 + 41*D1**2*f*fdd*s - 35*D1**2*f*fdd + 490*D1**2*f*gd2*s**2 - 350*D1**2*f*gdd2*s**2 + 58*D1**2*fd**2*r*s - 29*D1**2*fd**2*r - 70*D1**2*fd**2*s**2 + 41*D1**2*fd**2*s + 29*D1**2*fd**2 + 490*D1**2*fd*g2*s**2 - 980*D1**2*fd*g2*s + 490*D1**2*fd*g2 - 700*D1**2*fd*gd2*s**2 + 700*D1**2*fd*gd2*s - 350*D1**2*fdd*g2*s**2 + 700*D1**2*fdd*g2*s - 350*D1**2*fdd*g2 + 1400*D1*Dd*bd2*f*s**2 - 350*D1*Dd*bd2*f*s - 204*D1*Dd*f**2*r*s + 51*D1*Dd*f**2*r + 196*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s + 49*D1*Dd*f**2 + 464*D1*Dd*f*fd*r*s - 174*D1*Dd*f*fd*r - 560*D1*Dd*f*fd*s**2 + 188*D1*Dd*f*fd*s + 17*D1*Dd*f*fd + 1960*D1*Dd*f*g2*s**2 - 980*D1*Dd*f*g2*s + 490*D1*Dd*f*g2 - 2800*D1*Dd*f*gd2*s**2 + 700*D1*Dd*f*gd2*s - 2800*D1*Dd*fd*g2*s**2 + 3500*D1*Dd*fd*g2*s - 700*D1*Dd*fd*g2 + 116*D1*Ddd*f**2*r*s - 29*D1*Ddd*f**2*r - 140*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 35*D1*Ddd*f**2 - 1400*D1*Ddd*f*g2*s**2 + 700*D1*Ddd*f*g2*s - 350*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(f*(r*(s*(30*f + 42) + 4) + 5*s*(14*K*s - 3*f - 5)) + fd*(-100*K*s**2 + 100*K*s - 15*f*(2*r - 1)*(4*s - 1) - 52*r*s + 28*r + 11*s - 13)) + Dd*f*(-400*K*s**2 + 100*K*s - 15*f*(2*r - 1)*(8*s - 1) - 208*r*s + 18*r + 112*s - 11)) + 348*Dd**2*f**2*r*s - 87*Dd**2*f**2*r - 420*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s + 58*Dd**2*f**2 - 4200*Dd**2*f*g2*s**2 + 2100*Dd**2*f*g2*s - 35*b2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + D1*(7*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(4*s**2 - 5*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f*s*(1 - 2*s))))/(105*d**2*k2**2) - D1**2*Pk2*Pk3*(D1*(3*D1*bd1**2*f*(10*K*s**2 + r*(3 - 6*s)) + 5*D1*bdd1*f*s**2*(3*b2 + f*(2*C - 1) - 6*g2) + 5*bd1*s*(D1*(f**2*(-2*C*s + s) + f*fd*(4*C - 2)*(2*s - 1) + 6*f*s*(bd2 + g2 - 2*gd2) - 12*fd*g2*(s - 1)) + 2*Dd*f*(4*s - 1)*(f*(2*C - 1) - 6*g2) + 3*b2*(-D1*f*s + 2*D1*fd*(s - 1) + 2*Dd*f*(4*s - 1)))) - 15*b1**3*(D1*Dd*(fd*(8*r*s - r - 6*s + 1) - (f + 1)*(4*r*s - r - 2*s)) + D1*(-D1*s*(fd - fdd)*(r - 1) + Ddd*(f + 1)*(4*r*s - r - 2*s)) + Dd**2*(f + 1)*(3*r*(4*s - 1) - 6*s + 2)) + b1**2*(D1*Dd*(-15*K*f*(4*s**2 - 2*s + 1) + 30*K*fd*(4*s**2 - 5*s + 1) - 13*f*(-4*r*s + r + 2*s) + 9*fd*(-8*r*s + r + 6*s - 1)) + 15*D1*bd1*(-D1*fd*(r*(6*s - 1) - 4*s + 1) + D1*(f + 1)*(r*(3*s - 1) - s) - Dd*(f + 1)*(r*(24*s - 7) - 10*s + 3)) + D1*(D1*(-15*K*fd*(s - 1)**2 - 15*bdd1*(f + 1)*(r*(3*s - 1) - s) + 13*fd*s*(r - 1) + 3*fdd*(5*K*(s - 1)**2 - s*(3*r - 3))) + 3*Ddd*f*(5*K*(4*s**2 - 2*s + 1) - 12*r*s + 3*r + 6*s)) + 9*Dd**2*f*(20*K*s**2 - 10*K*s + r*(3 - 12*s) + 6*s - 2)) + b1*(-20*C*D1**2*f*fd*s**2 + 20*C*D1**2*f*fd*s - 10*C*D1**2*f*fd + 20*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd + 20*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 40*C*D1*Dd*f**2*s**2 + 20*C*D1*Dd*f**2*s - 10*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*s**2 - 120*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*s**2 - 20*C*D1*Ddd*f**2*s + 10*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*s**2 - 60*C*Dd**2*f**2*s + 30*D1**2*K*bdd1*f*s**2 - 15*D1**2*bd1**2*(f + 1)*(r*(6*s - 2) - 2*s + 1) - 15*D1**2*bd2*f*s**2 + 30*D1**2*bd2*fd*s**2 - 30*D1**2*bd2*fd*s - 18*D1**2*bdd1*f*r*s + 9*D1**2*bdd1*f*r + 15*D1**2*bdd2*f*s**2 + 10*D1**2*f*fd*s**2 - 10*D1**2*f*fd*s + 5*D1**2*f*fd - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd + 30*D1**2*f*gd2*s**2 - 30*D1**2*f*gdd2*s**2 - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 30*D1**2*fd*g2*s**2 - 60*D1**2*fd*g2*s + 30*D1**2*fd*g2 - 60*D1**2*fd*gd2*s**2 + 60*D1**2*fd*gd2*s - 30*D1**2*fdd*g2*s**2 + 60*D1**2*fdd*g2*s - 30*D1**2*fdd*g2 + 120*D1*Dd*bd2*f*s**2 - 30*D1*Dd*bd2*f*s + 20*D1*Dd*f**2*s**2 - 10*D1*Dd*f**2*s + 5*D1*Dd*f**2 - 80*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 10*D1*Dd*f*fd + 120*D1*Dd*f*g2*s**2 - 60*D1*Dd*f*g2*s + 30*D1*Dd*f*g2 - 240*D1*Dd*f*gd2*s**2 + 60*D1*Dd*f*gd2*s - 240*D1*Dd*fd*g2*s**2 + 300*D1*Dd*fd*g2*s - 60*D1*Dd*fd*g2 - 20*D1*Ddd*f**2*s**2 + 10*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 - 120*D1*Ddd*f*g2*s**2 + 60*D1*Ddd*f*g2*s - 30*D1*Ddd*f*g2 + D1*bd1*(D1*(f*(-30*K*s**2 + 26*r*s - 13*r) + fd*(60*K*s**2 - 60*K*s - 36*r*s + 9*r + 18*s - 9)) + 6*Dd*f*(40*K*s**2 - 10*K*s + r*(9 - 24*s) + 6*s - 3)) - 60*Dd**2*f**2*s**2 + 30*Dd**2*f**2*s - 360*Dd**2*f*g2*s**2 + 180*Dd**2*f*g2*s - 15*b2*(D1**2*(fd - fdd)*(s - 1)**2 + D1*Dd*(f*(4*s**2 - 2*s + 1) - 2*fd*(4*s**2 - 5*s + 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(15*d**2*k2**2) + D1**2*Pk2*Pkd3*ct**8*k1**2*k2**4*(924*C*D1**2*f**2*fd*r**2 + 1848*C*D1**2*f**2*fd*r*s - 1232*C*D1**2*f**2*fd*r + 924*C*D1**2*f**2*fd*s**2 - 1232*C*D1**2*f**2*fd*s + 616*C*D1**2*f**2*fd - 462*C*D1**2*f**2*fdd*r**2 - 924*C*D1**2*f**2*fdd*r*s + 616*C*D1**2*f**2*fdd*r - 462*C*D1**2*f**2*fdd*s**2 + 616*C*D1**2*f**2*fdd*s - 308*C*D1**2*f**2*fdd - 924*C*D1**2*f*fd**2*r**2 - 1848*C*D1**2*f*fd**2*r*s + 1232*C*D1**2*f*fd**2*r - 924*C*D1**2*f*fd**2*s**2 + 1232*C*D1**2*f*fd**2*s - 308*C*D1**2*f*fd**2 + 1232*C*D1*Dd*f**3*r**2 + 2464*C*D1*Dd*f**3*r*s - 1848*C*D1*Dd*f**3*r + 1232*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 924*C*D1*Dd*f**3 - 3696*C*D1*Dd*f**2*fd*r**2 - 7392*C*D1*Dd*f**2*fd*r*s + 5236*C*D1*Dd*f**2*fd*r - 3696*C*D1*Dd*f**2*fd*s**2 + 5236*C*D1*Dd*f**2*fd*s - 1848*C*D1*Dd*f**2*fd - 616*C*D1*Ddd*f**3*r**2 - 1232*C*D1*Ddd*f**3*r*s + 924*C*D1*Ddd*f**3*r - 616*C*D1*Ddd*f**3*s**2 + 924*C*D1*Ddd*f**3*s - 462*C*D1*Ddd*f**3 - 1848*C*Dd**2*f**3*r**2 - 3696*C*Dd**2*f**3*r*s + 2772*C*Dd**2*f**3*r - 1848*C*Dd**2*f**3*s**2 + 2772*C*Dd**2*f**3*s - 924*C*Dd**2*f**3 + 396*D1**2*K*b1*f*fd*r**2 + 792*D1**2*K*b1*f*fd*r*s - 396*D1**2*K*b1*f*fd*r + 396*D1**2*K*b1*f*fd*s**2 - 396*D1**2*K*b1*f*fd*s + 198*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 396*D1**2*K*b1*f*fdd*r*s + 198*D1**2*K*b1*f*fdd*r - 198*D1**2*K*b1*f*fdd*s**2 + 198*D1**2*K*b1*f*fdd*s - 99*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 396*D1**2*K*b1*fd**2*r*s + 198*D1**2*K*b1*fd**2*r - 198*D1**2*K*b1*fd**2*s**2 + 198*D1**2*K*b1*fd**2*s - 396*D1**2*b1*f*fd*r**2 - 792*D1**2*b1*f*fd*r*s + 396*D1**2*b1*f*fd*r - 396*D1**2*b1*f*fd*s**2 + 396*D1**2*b1*f*fd*s - 198*D1**2*b1*f*fd + 198*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 198*D1**2*b1*f*fdd*s**2 - 198*D1**2*b1*f*fdd*s + 99*D1**2*b1*f*fdd + 198*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 198*D1**2*b1*fd**2*s**2 - 198*D1**2*b1*fd**2*s - 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 504*D1**2*f**3*fd*r**2 + 1008*D1**2*f**3*fd*r*s - 756*D1**2*f**3*fd*r + 504*D1**2*f**3*fd*s**2 - 756*D1**2*f**3*fd*s + 378*D1**2*f**3*fd - 252*D1**2*f**3*fdd*r**2 - 504*D1**2*f**3*fdd*r*s + 378*D1**2*f**3*fdd*r - 252*D1**2*f**3*fdd*s**2 + 378*D1**2*f**3*fdd*s - 189*D1**2*f**3*fdd - 756*D1**2*f**2*fd**2*r**2 - 1512*D1**2*f**2*fd**2*r*s + 1134*D1**2*f**2*fd**2*r - 756*D1**2*f**2*fd**2*s**2 + 1134*D1**2*f**2*fd**2*s - 378*D1**2*f**2*fd**2 - 924*D1**2*f**2*fd*r**2 - 1848*D1**2*f**2*fd*r*s + 1232*D1**2*f**2*fd*r - 924*D1**2*f**2*fd*s**2 + 1232*D1**2*f**2*fd*s - 616*D1**2*f**2*fd + 462*D1**2*f**2*fdd*r**2 + 924*D1**2*f**2*fdd*r*s - 616*D1**2*f**2*fdd*r + 462*D1**2*f**2*fdd*s**2 - 616*D1**2*f**2*fdd*s + 308*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 396*D1**2*f**2*gd2*s**2 + 792*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 396*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 924*D1**2*f*fd**2*r**2 + 1848*D1**2*f*fd**2*r*s - 1232*D1**2*f*fd**2*r + 924*D1**2*f*fd**2*s**2 - 1232*D1**2*f*fd**2*s + 308*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 792*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1584*D1**2*f*fd*gd2*r*s - 1188*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1188*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 792*D1*Dd*K*b1*f**2*r**2 + 1584*D1*Dd*K*b1*f**2*r*s - 1188*D1*Dd*K*b1*f**2*r + 792*D1*Dd*K*b1*f**2*s**2 - 1188*D1*Dd*K*b1*f**2*s + 594*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 3168*D1*Dd*K*b1*f*fd*r*s + 1980*D1*Dd*K*b1*f*fd*r - 1584*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 594*D1*Dd*K*b1*f*fd - 792*D1*Dd*b1*f**2*r**2 - 1584*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 792*D1*Dd*b1*f**2*s**2 + 1188*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r + 1584*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s + 594*D1*Dd*b1*f*fd + 504*D1*Dd*f**4*r**2 + 1008*D1*Dd*f**4*r*s - 756*D1*Dd*f**4*r + 504*D1*Dd*f**4*s**2 - 756*D1*Dd*f**4*s + 378*D1*Dd*f**4 - 2016*D1*Dd*f**3*fd*r**2 - 4032*D1*Dd*f**3*fd*r*s + 3024*D1*Dd*f**3*fd*r - 2016*D1*Dd*f**3*fd*s**2 + 3024*D1*Dd*f**3*fd*s - 1134*D1*Dd*f**3*fd - 1232*D1*Dd*f**3*r**2 - 2464*D1*Dd*f**3*r*s + 1848*D1*Dd*f**3*r - 1232*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 924*D1*Dd*f**3 + 3696*D1*Dd*f**2*fd*r**2 + 7392*D1*Dd*f**2*fd*r*s - 5236*D1*Dd*f**2*fd*r + 3696*D1*Dd*f**2*fd*s**2 - 5236*D1*Dd*f**2*fd*s + 1848*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 2376*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 3168*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 1188*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 6336*D1*Dd*f*fd*g2*r*s - 3960*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 1188*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 792*D1*Ddd*K*b1*f**2*r*s + 594*D1*Ddd*K*b1*f**2*r - 396*D1*Ddd*K*b1*f**2*s**2 + 594*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 396*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 396*D1*Ddd*b1*f**2*s**2 - 594*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 - 252*D1*Ddd*f**4*r**2 - 504*D1*Ddd*f**4*r*s + 378*D1*Ddd*f**4*r - 252*D1*Ddd*f**4*s**2 + 378*D1*Ddd*f**4*s - 189*D1*Ddd*f**4 + 616*D1*Ddd*f**3*r**2 + 1232*D1*Ddd*f**3*r*s - 924*D1*Ddd*f**3*r + 616*D1*Ddd*f**3*s**2 - 924*D1*Ddd*f**3*s + 462*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1584*D1*Ddd*f**2*g2*r*s - 1188*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1188*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1188*Dd**2*K*b1*f**2*r**2 - 2376*Dd**2*K*b1*f**2*r*s + 1782*Dd**2*K*b1*f**2*r - 1188*Dd**2*K*b1*f**2*s**2 + 1782*Dd**2*K*b1*f**2*s - 594*Dd**2*K*b1*f**2 + 1188*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 1188*Dd**2*b1*f**2*s**2 - 1782*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 - 756*Dd**2*f**4*r**2 - 1512*Dd**2*f**4*r*s + 1134*Dd**2*f**4*r - 756*Dd**2*f**4*s**2 + 1134*Dd**2*f**4*s - 378*Dd**2*f**4 + 1848*Dd**2*f**3*r**2 + 3696*Dd**2*f**3*r*s - 2772*Dd**2*f**3*r + 1848*Dd**2*f**3*s**2 - 2772*Dd**2*f**3*s + 924*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 4752*Dd**2*f**2*g2*r*s - 3564*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3564*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2)/(154*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**8*k1**2*k2**2*(924*C*D1**2*f**2*fd*r*s - 308*C*D1**2*f**2*fd*r + 924*C*D1**2*f**2*fd*s**2 - 924*C*D1**2*f**2*fd*s + 308*C*D1**2*f**2*fd - 462*C*D1**2*f**2*fdd*r*s + 154*C*D1**2*f**2*fdd*r - 462*C*D1**2*f**2*fdd*s**2 + 462*C*D1**2*f**2*fdd*s - 154*C*D1**2*f**2*fdd - 924*C*D1**2*f*fd**2*r*s + 308*C*D1**2*f*fd**2*r - 924*C*D1**2*f*fd**2*s**2 + 924*C*D1**2*f*fd**2*s - 154*C*D1**2*f*fd**2 + 1232*C*D1*Dd*f**3*r*s - 308*C*D1*Dd*f**3*r + 1232*C*D1*Dd*f**3*s**2 - 1232*C*D1*Dd*f**3*s + 308*C*D1*Dd*f**3 - 3696*C*D1*Dd*f**2*fd*r*s + 1078*C*D1*Dd*f**2*fd*r - 3696*C*D1*Dd*f**2*fd*s**2 + 3696*C*D1*Dd*f**2*fd*s - 770*C*D1*Dd*f**2*fd - 616*C*D1*Ddd*f**3*r*s + 154*C*D1*Ddd*f**3*r - 616*C*D1*Ddd*f**3*s**2 + 616*C*D1*Ddd*f**3*s - 154*C*D1*Ddd*f**3 - 1848*C*Dd**2*f**3*r*s + 462*C*Dd**2*f**3*r - 1848*C*Dd**2*f**3*s**2 + 1848*C*Dd**2*f**3*s - 308*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 504*D1**2*f**3*fd*r*s - 126*D1**2*f**3*fd*r + 504*D1**2*f**3*fd*s**2 - 504*D1**2*f**3*fd*s + 126*D1**2*f**3*fd - 252*D1**2*f**3*fdd*r*s + 63*D1**2*f**3*fdd*r - 252*D1**2*f**3*fdd*s**2 + 252*D1**2*f**3*fdd*s - 63*D1**2*f**3*fdd - 756*D1**2*f**2*fd**2*r*s + 189*D1**2*f**2*fd**2*r - 756*D1**2*f**2*fd**2*s**2 + 756*D1**2*f**2*fd**2*s - 126*D1**2*f**2*fd**2 - 924*D1**2*f**2*fd*r*s + 308*D1**2*f**2*fd*r - 924*D1**2*f**2*fd*s**2 + 924*D1**2*f**2*fd*s - 308*D1**2*f**2*fd + 462*D1**2*f**2*fdd*r*s - 154*D1**2*f**2*fdd*r + 462*D1**2*f**2*fdd*s**2 - 462*D1**2*f**2*fdd*s + 154*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 924*D1**2*f*fd**2*r*s - 308*D1**2*f*fd**2*r + 924*D1**2*f*fd**2*s**2 - 924*D1**2*f*fd**2*s + 154*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 504*D1*Dd*f**4*r*s - 126*D1*Dd*f**4*r + 504*D1*Dd*f**4*s**2 - 504*D1*Dd*f**4*s + 126*D1*Dd*f**4 - 2016*D1*Dd*f**3*fd*r*s + 504*D1*Dd*f**3*fd*r - 2016*D1*Dd*f**3*fd*s**2 + 2016*D1*Dd*f**3*fd*s - 378*D1*Dd*f**3*fd - 1232*D1*Dd*f**3*r*s + 308*D1*Dd*f**3*r - 1232*D1*Dd*f**3*s**2 + 1232*D1*Dd*f**3*s - 308*D1*Dd*f**3 + 3696*D1*Dd*f**2*fd*r*s - 1078*D1*Dd*f**2*fd*r + 3696*D1*Dd*f**2*fd*s**2 - 3696*D1*Dd*f**2*fd*s + 770*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 252*D1*Ddd*f**4*r*s + 63*D1*Ddd*f**4*r - 252*D1*Ddd*f**4*s**2 + 252*D1*Ddd*f**4*s - 63*D1*Ddd*f**4 + 616*D1*Ddd*f**3*r*s - 154*D1*Ddd*f**3*r + 616*D1*Ddd*f**3*s**2 - 616*D1*Ddd*f**3*s + 154*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 756*Dd**2*f**4*r*s + 189*Dd**2*f**4*r - 756*Dd**2*f**4*s**2 + 756*Dd**2*f**4*s - 126*Dd**2*f**4 + 1848*Dd**2*f**3*r*s - 462*Dd**2*f**3*r + 1848*Dd**2*f**3*s**2 - 1848*Dd**2*f**3*s + 308*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**7*k1**3*k2**3*(12540*C*D1**2*f**2*fd*r**2 + 25080*C*D1**2*f**2*fd*r*s - 16720*C*D1**2*f**2*fd*r + 12540*C*D1**2*f**2*fd*s**2 - 16720*C*D1**2*f**2*fd*s + 8360*C*D1**2*f**2*fd - 9240*C*D1**2*f**2*fdd*r**2 - 18480*C*D1**2*f**2*fdd*r*s + 12320*C*D1**2*f**2*fdd*r - 9240*C*D1**2*f**2*fdd*s**2 + 12320*C*D1**2*f**2*fdd*s - 6160*C*D1**2*f**2*fdd - 18480*C*D1**2*f*fd**2*r**2 - 36960*C*D1**2*f*fd**2*r*s + 24640*C*D1**2*f*fd**2*r - 18480*C*D1**2*f*fd**2*s**2 + 24640*C*D1**2*f*fd**2*s - 6160*C*D1**2*f*fd**2 + 16720*C*D1*Dd*f**3*r**2 + 33440*C*D1*Dd*f**3*r*s - 25080*C*D1*Dd*f**3*r + 16720*C*D1*Dd*f**3*s**2 - 25080*C*D1*Dd*f**3*s + 12540*C*D1*Dd*f**3 - 73920*C*D1*Dd*f**2*fd*r**2 - 147840*C*D1*Dd*f**2*fd*r*s + 104720*C*D1*Dd*f**2*fd*r - 73920*C*D1*Dd*f**2*fd*s**2 + 104720*C*D1*Dd*f**2*fd*s - 36960*C*D1*Dd*f**2*fd - 12320*C*D1*Ddd*f**3*r**2 - 24640*C*D1*Ddd*f**3*r*s + 18480*C*D1*Ddd*f**3*r - 12320*C*D1*Ddd*f**3*s**2 + 18480*C*D1*Ddd*f**3*s - 9240*C*D1*Ddd*f**3 - 36960*C*Dd**2*f**3*r**2 - 73920*C*Dd**2*f**3*r*s + 55440*C*Dd**2*f**3*r - 36960*C*Dd**2*f**3*s**2 + 55440*C*Dd**2*f**3*s - 18480*C*Dd**2*f**3 + 5148*D1**2*K*b1*f*fd*r**2 + 10296*D1**2*K*b1*f*fd*r*s - 5148*D1**2*K*b1*f*fd*r + 5148*D1**2*K*b1*f*fd*s**2 - 5148*D1**2*K*b1*f*fd*s + 2574*D1**2*K*b1*f*fd - 3960*D1**2*K*b1*f*fdd*r**2 - 7920*D1**2*K*b1*f*fdd*r*s + 3960*D1**2*K*b1*f*fdd*r - 3960*D1**2*K*b1*f*fdd*s**2 + 3960*D1**2*K*b1*f*fdd*s - 1980*D1**2*K*b1*f*fdd - 3960*D1**2*K*b1*fd**2*r**2 - 7920*D1**2*K*b1*fd**2*r*s + 3960*D1**2*K*b1*fd**2*r - 3960*D1**2*K*b1*fd**2*s**2 + 3960*D1**2*K*b1*fd**2*s - 5148*D1**2*b1*f*fd*r**2 - 10296*D1**2*b1*f*fd*r*s + 5148*D1**2*b1*f*fd*r - 5148*D1**2*b1*f*fd*s**2 + 5148*D1**2*b1*f*fd*s - 2574*D1**2*b1*f*fd + 3960*D1**2*b1*f*fdd*r**2 + 7920*D1**2*b1*f*fdd*r*s - 3960*D1**2*b1*f*fdd*r + 3960*D1**2*b1*f*fdd*s**2 - 3960*D1**2*b1*f*fdd*s + 1980*D1**2*b1*f*fdd + 3960*D1**2*b1*fd**2*r**2 + 7920*D1**2*b1*fd**2*r*s - 3960*D1**2*b1*fd**2*r + 3960*D1**2*b1*fd**2*s**2 - 3960*D1**2*b1*fd**2*s - 1980*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 9520*D1**2*f**3*fd*r**2 + 19040*D1**2*f**3*fd*r*s - 14280*D1**2*f**3*fd*r + 9520*D1**2*f**3*fd*s**2 - 14280*D1**2*f**3*fd*s + 7140*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 12540*D1**2*f**2*fd*r**2 - 25080*D1**2*f**2*fd*r*s + 16720*D1**2*f**2*fd*r - 12540*D1**2*f**2*fd*s**2 + 16720*D1**2*f**2*fd*s - 8360*D1**2*f**2*fd + 9240*D1**2*f**2*fdd*r**2 + 18480*D1**2*f**2*fdd*r*s - 12320*D1**2*f**2*fdd*r + 9240*D1**2*f**2*fdd*s**2 - 12320*D1**2*f**2*fdd*s + 6160*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r**2 - 10296*D1**2*f**2*gd2*r*s + 10296*D1**2*f**2*gd2*r - 5148*D1**2*f**2*gd2*s**2 + 10296*D1**2*f**2*gd2*s - 5148*D1**2*f**2*gd2 + 3960*D1**2*f**2*gdd2*r**2 + 7920*D1**2*f**2*gdd2*r*s - 7920*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 7920*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 + 18480*D1**2*f*fd**2*r**2 + 36960*D1**2*f*fd**2*r*s - 24640*D1**2*f*fd**2*r + 18480*D1**2*f*fd**2*s**2 - 24640*D1**2*f*fd**2*s + 6160*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r**2 - 20592*D1**2*f*fd*g2*r*s + 10296*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 15840*D1**2*f*fd*gd2*r**2 + 31680*D1**2*f*fd*gd2*r*s - 23760*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 23760*D1**2*f*fd*gd2*s + 7920*D1**2*f*fd*gd2 + 7920*D1**2*f*fdd*g2*r**2 + 15840*D1**2*f*fdd*g2*r*s - 7920*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 7920*D1**2*f*fdd*g2*s + 3960*D1**2*f*fdd*g2 + 7920*D1**2*fd**2*g2*r**2 + 15840*D1**2*fd**2*g2*r*s - 7920*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 7920*D1**2*fd**2*g2*s + 10296*D1*Dd*K*b1*f**2*r**2 + 20592*D1*Dd*K*b1*f**2*r*s - 15444*D1*Dd*K*b1*f**2*r + 10296*D1*Dd*K*b1*f**2*s**2 - 15444*D1*Dd*K*b1*f**2*s + 7722*D1*Dd*K*b1*f**2 - 31680*D1*Dd*K*b1*f*fd*r**2 - 63360*D1*Dd*K*b1*f*fd*r*s + 39600*D1*Dd*K*b1*f*fd*r - 31680*D1*Dd*K*b1*f*fd*s**2 + 39600*D1*Dd*K*b1*f*fd*s - 11880*D1*Dd*K*b1*f*fd - 10296*D1*Dd*b1*f**2*r**2 - 20592*D1*Dd*b1*f**2*r*s + 15444*D1*Dd*b1*f**2*r - 10296*D1*Dd*b1*f**2*s**2 + 15444*D1*Dd*b1*f**2*s - 7722*D1*Dd*b1*f**2 + 31680*D1*Dd*b1*f*fd*r**2 + 63360*D1*Dd*b1*f*fd*r*s - 39600*D1*Dd*b1*f*fd*r + 31680*D1*Dd*b1*f*fd*s**2 - 39600*D1*Dd*b1*f*fd*s + 11880*D1*Dd*b1*f*fd + 9520*D1*Dd*f**4*r**2 + 19040*D1*Dd*f**4*r*s - 14280*D1*Dd*f**4*r + 9520*D1*Dd*f**4*s**2 - 14280*D1*Dd*f**4*s + 7140*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 16720*D1*Dd*f**3*r**2 - 33440*D1*Dd*f**3*r*s + 25080*D1*Dd*f**3*r - 16720*D1*Dd*f**3*s**2 + 25080*D1*Dd*f**3*s - 12540*D1*Dd*f**3 + 73920*D1*Dd*f**2*fd*r**2 + 147840*D1*Dd*f**2*fd*r*s - 104720*D1*Dd*f**2*fd*r + 73920*D1*Dd*f**2*fd*s**2 - 104720*D1*Dd*f**2*fd*s + 36960*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r**2 - 41184*D1*Dd*f**2*g2*r*s + 30888*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 30888*D1*Dd*f**2*g2*s - 15444*D1*Dd*f**2*g2 + 31680*D1*Dd*f**2*gd2*r**2 + 63360*D1*Dd*f**2*gd2*r*s - 55440*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 55440*D1*Dd*f**2*gd2*s + 23760*D1*Dd*f**2*gd2 + 63360*D1*Dd*f*fd*g2*r**2 + 126720*D1*Dd*f*fd*g2*r*s - 79200*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 79200*D1*Dd*f*fd*g2*s + 23760*D1*Dd*f*fd*g2 - 7920*D1*Ddd*K*b1*f**2*r**2 - 15840*D1*Ddd*K*b1*f**2*r*s + 11880*D1*Ddd*K*b1*f**2*r - 7920*D1*Ddd*K*b1*f**2*s**2 + 11880*D1*Ddd*K*b1*f**2*s - 5940*D1*Ddd*K*b1*f**2 + 7920*D1*Ddd*b1*f**2*r**2 + 15840*D1*Ddd*b1*f**2*r*s - 11880*D1*Ddd*b1*f**2*r + 7920*D1*Ddd*b1*f**2*s**2 - 11880*D1*Ddd*b1*f**2*s + 5940*D1*Ddd*b1*f**2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 12320*D1*Ddd*f**3*r**2 + 24640*D1*Ddd*f**3*r*s - 18480*D1*Ddd*f**3*r + 12320*D1*Ddd*f**3*s**2 - 18480*D1*Ddd*f**3*s + 9240*D1*Ddd*f**3 + 15840*D1*Ddd*f**2*g2*r**2 + 31680*D1*Ddd*f**2*g2*r*s - 23760*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 23760*D1*Ddd*f**2*g2*s + 11880*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 23760*Dd**2*K*b1*f**2*r**2 - 47520*Dd**2*K*b1*f**2*r*s + 35640*Dd**2*K*b1*f**2*r - 23760*Dd**2*K*b1*f**2*s**2 + 35640*Dd**2*K*b1*f**2*s - 11880*Dd**2*K*b1*f**2 + 23760*Dd**2*b1*f**2*r**2 + 47520*Dd**2*b1*f**2*r*s - 35640*Dd**2*b1*f**2*r + 23760*Dd**2*b1*f**2*s**2 - 35640*Dd**2*b1*f**2*s + 11880*Dd**2*b1*f**2 - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 36960*Dd**2*f**3*r**2 + 73920*Dd**2*f**3*r*s - 55440*Dd**2*f**3*r + 36960*Dd**2*f**3*s**2 - 55440*Dd**2*f**3*s + 18480*Dd**2*f**3 + 47520*Dd**2*f**2*g2*r**2 + 95040*Dd**2*f**2*g2*r*s - 71280*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 71280*Dd**2*f**2*g2*s + 23760*Dd**2*f**2*g2)/(770*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**7*k1**3*k2*(10890*C*D1**2*f**2*fd*r*s - 3630*C*D1**2*f**2*fd*r + 10890*C*D1**2*f**2*fd*s**2 - 10890*C*D1**2*f**2*fd*s + 3630*C*D1**2*f**2*fd - 6930*C*D1**2*f**2*fdd*r*s + 2310*C*D1**2*f**2*fdd*r - 6930*C*D1**2*f**2*fdd*s**2 + 6930*C*D1**2*f**2*fdd*s - 2310*C*D1**2*f**2*fdd - 13860*C*D1**2*f*fd**2*r*s + 4620*C*D1**2*f*fd**2*r - 13860*C*D1**2*f*fd**2*s**2 + 13860*C*D1**2*f*fd**2*s - 2310*C*D1**2*f*fd**2 + 14520*C*D1*Dd*f**3*r*s - 3630*C*D1*Dd*f**3*r + 14520*C*D1*Dd*f**3*s**2 - 14520*C*D1*Dd*f**3*s + 3630*C*D1*Dd*f**3 - 55440*C*D1*Dd*f**2*fd*r*s + 16170*C*D1*Dd*f**2*fd*r - 55440*C*D1*Dd*f**2*fd*s**2 + 55440*C*D1*Dd*f**2*fd*s - 11550*C*D1*Dd*f**2*fd - 9240*C*D1*Ddd*f**3*r*s + 2310*C*D1*Ddd*f**3*r - 9240*C*D1*Ddd*f**3*s**2 + 9240*C*D1*Ddd*f**3*s - 2310*C*D1*Ddd*f**3 - 27720*C*Dd**2*f**3*r*s + 6930*C*Dd**2*f**3*r - 27720*C*Dd**2*f**3*s**2 + 27720*C*Dd**2*f**3*s - 4620*C*Dd**2*f**3 - 1485*D1**2*K*bdd1*f**2*r*s - 1485*D1**2*K*bdd1*f**2*s**2 + 1485*D1**2*K*bdd1*f**2*s + 1485*D1**2*bdd1*f**2*r*s + 1485*D1**2*bdd1*f**2*s**2 - 1485*D1**2*bdd1*f**2*s + 8540*D1**2*f**3*fd*r*s - 2135*D1**2*f**3*fd*r + 8540*D1**2*f**3*fd*s**2 - 8540*D1**2*f**3*fd*s + 2135*D1**2*f**3*fd - 5040*D1**2*f**3*fdd*r*s + 1260*D1**2*f**3*fdd*r - 5040*D1**2*f**3*fdd*s**2 + 5040*D1**2*f**3*fdd*s - 1260*D1**2*f**3*fdd - 15120*D1**2*f**2*fd**2*r*s + 3780*D1**2*f**2*fd**2*r - 15120*D1**2*f**2*fd**2*s**2 + 15120*D1**2*f**2*fd**2*s - 2520*D1**2*f**2*fd**2 - 10890*D1**2*f**2*fd*r*s + 3630*D1**2*f**2*fd*r - 10890*D1**2*f**2*fd*s**2 + 10890*D1**2*f**2*fd*s - 3630*D1**2*f**2*fd + 6930*D1**2*f**2*fdd*r*s - 2310*D1**2*f**2*fdd*r + 6930*D1**2*f**2*fdd*s**2 - 6930*D1**2*f**2*fdd*s + 2310*D1**2*f**2*fdd - 4554*D1**2*f**2*gd2*r*s - 4554*D1**2*f**2*gd2*s**2 + 4554*D1**2*f**2*gd2*s + 2970*D1**2*f**2*gdd2*r*s + 2970*D1**2*f**2*gdd2*s**2 - 2970*D1**2*f**2*gdd2*s + 13860*D1**2*f*fd**2*r*s - 4620*D1**2*f*fd**2*r + 13860*D1**2*f*fd**2*s**2 - 13860*D1**2*f*fd**2*s + 2310*D1**2*f*fd**2 - 9108*D1**2*f*fd*g2*r*s + 4554*D1**2*f*fd*g2*r - 9108*D1**2*f*fd*g2*s**2 + 9108*D1**2*f*fd*g2*s - 4554*D1**2*f*fd*g2 + 11880*D1**2*f*fd*gd2*r*s - 2970*D1**2*f*fd*gd2*r + 11880*D1**2*f*fd*gd2*s**2 - 11880*D1**2*f*fd*gd2*s + 2970*D1**2*f*fd*gd2 + 5940*D1**2*f*fdd*g2*r*s - 2970*D1**2*f*fdd*g2*r + 5940*D1**2*f*fdd*g2*s**2 - 5940*D1**2*f*fdd*g2*s + 2970*D1**2*f*fdd*g2 + 5940*D1**2*fd**2*g2*r*s - 2970*D1**2*fd**2*g2*r + 5940*D1**2*fd**2*g2*s**2 - 5940*D1**2*fd**2*g2*s + 8540*D1*Dd*f**4*r*s - 2135*D1*Dd*f**4*r + 8540*D1*Dd*f**4*s**2 - 8540*D1*Dd*f**4*s + 2135*D1*Dd*f**4 - 40320*D1*Dd*f**3*fd*r*s + 10080*D1*Dd*f**3*fd*r - 40320*D1*Dd*f**3*fd*s**2 + 40320*D1*Dd*f**3*fd*s - 7560*D1*Dd*f**3*fd - 14520*D1*Dd*f**3*r*s + 3630*D1*Dd*f**3*r - 14520*D1*Dd*f**3*s**2 + 14520*D1*Dd*f**3*s - 3630*D1*Dd*f**3 + 55440*D1*Dd*f**2*fd*r*s - 16170*D1*Dd*f**2*fd*r + 55440*D1*Dd*f**2*fd*s**2 - 55440*D1*Dd*f**2*fd*s + 11550*D1*Dd*f**2*fd - 18216*D1*Dd*f**2*g2*r*s + 4554*D1*Dd*f**2*g2*r - 18216*D1*Dd*f**2*g2*s**2 + 18216*D1*Dd*f**2*g2*s - 4554*D1*Dd*f**2*g2 + 23760*D1*Dd*f**2*gd2*r*s - 2970*D1*Dd*f**2*gd2*r + 23760*D1*Dd*f**2*gd2*s**2 - 23760*D1*Dd*f**2*gd2*s + 2970*D1*Dd*f**2*gd2 + 47520*D1*Dd*f*fd*g2*r*s - 17820*D1*Dd*f*fd*g2*r + 47520*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 11880*D1*Dd*f*fd*g2 - 5040*D1*Ddd*f**4*r*s + 1260*D1*Ddd*f**4*r - 5040*D1*Ddd*f**4*s**2 + 5040*D1*Ddd*f**4*s - 1260*D1*Ddd*f**4 + 9240*D1*Ddd*f**3*r*s - 2310*D1*Ddd*f**3*r + 9240*D1*Ddd*f**3*s**2 - 9240*D1*Ddd*f**3*s + 2310*D1*Ddd*f**3 + 11880*D1*Ddd*f**2*g2*r*s - 2970*D1*Ddd*f**2*g2*r + 11880*D1*Ddd*f**2*g2*s**2 - 11880*D1*Ddd*f**2*g2*s + 2970*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 15120*Dd**2*f**4*r*s + 3780*Dd**2*f**4*r - 15120*Dd**2*f**4*s**2 + 15120*Dd**2*f**4*s - 2520*Dd**2*f**4 + 27720*Dd**2*f**3*r*s - 6930*Dd**2*f**3*r + 27720*Dd**2*f**3*s**2 - 27720*Dd**2*f**3*s + 4620*Dd**2*f**3 + 35640*Dd**2*f**2*g2*r*s - 8910*Dd**2*f**2*g2*r + 35640*Dd**2*f**2*g2*s**2 - 35640*Dd**2*f**2*g2*s + 5940*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**7*k1*k2**5*(168*C*D1**2*f**2*fd*r**2 + 336*C*D1**2*f**2*fd*r*s - 224*C*D1**2*f**2*fd*r + 168*C*D1**2*f**2*fd*s**2 - 224*C*D1**2*f**2*fd*s + 112*C*D1**2*f**2*fd - 84*C*D1**2*f**2*fdd*r**2 - 168*C*D1**2*f**2*fdd*r*s + 112*C*D1**2*f**2*fdd*r - 84*C*D1**2*f**2*fdd*s**2 + 112*C*D1**2*f**2*fdd*s - 56*C*D1**2*f**2*fdd - 168*C*D1**2*f*fd**2*r**2 - 336*C*D1**2*f*fd**2*r*s + 224*C*D1**2*f*fd**2*r - 168*C*D1**2*f*fd**2*s**2 + 224*C*D1**2*f*fd**2*s - 56*C*D1**2*f*fd**2 + 224*C*D1*Dd*f**3*r**2 + 448*C*D1*Dd*f**3*r*s - 336*C*D1*Dd*f**3*r + 224*C*D1*Dd*f**3*s**2 - 336*C*D1*Dd*f**3*s + 168*C*D1*Dd*f**3 - 672*C*D1*Dd*f**2*fd*r**2 - 1344*C*D1*Dd*f**2*fd*r*s + 952*C*D1*Dd*f**2*fd*r - 672*C*D1*Dd*f**2*fd*s**2 + 952*C*D1*Dd*f**2*fd*s - 336*C*D1*Dd*f**2*fd - 112*C*D1*Ddd*f**3*r**2 - 224*C*D1*Ddd*f**3*r*s + 168*C*D1*Ddd*f**3*r - 112*C*D1*Ddd*f**3*s**2 + 168*C*D1*Ddd*f**3*s - 84*C*D1*Ddd*f**3 - 336*C*Dd**2*f**3*r**2 - 672*C*Dd**2*f**3*r*s + 504*C*Dd**2*f**3*r - 336*C*Dd**2*f**3*s**2 + 504*C*Dd**2*f**3*s - 168*C*Dd**2*f**3 + 72*D1**2*K*b1*f*fd*r**2 + 144*D1**2*K*b1*f*fd*r*s - 72*D1**2*K*b1*f*fd*r + 72*D1**2*K*b1*f*fd*s**2 - 72*D1**2*K*b1*f*fd*s + 36*D1**2*K*b1*f*fd - 36*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*r*s + 36*D1**2*K*b1*f*fdd*r - 36*D1**2*K*b1*f*fdd*s**2 + 36*D1**2*K*b1*f*fdd*s - 18*D1**2*K*b1*f*fdd - 36*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*r*s + 36*D1**2*K*b1*fd**2*r - 36*D1**2*K*b1*fd**2*s**2 + 36*D1**2*K*b1*fd**2*s - 42*D1**2*b1*f**2*fd*r**2 - 84*D1**2*b1*f**2*fd*r*s + 56*D1**2*b1*f**2*fd*r - 42*D1**2*b1*f**2*fd*s**2 + 56*D1**2*b1*f**2*fd*s - 28*D1**2*b1*f**2*fd + 21*D1**2*b1*f**2*fdd*r**2 + 42*D1**2*b1*f**2*fdd*r*s - 28*D1**2*b1*f**2*fdd*r + 21*D1**2*b1*f**2*fdd*s**2 - 28*D1**2*b1*f**2*fdd*s + 14*D1**2*b1*f**2*fdd + 42*D1**2*b1*f*fd**2*r**2 + 84*D1**2*b1*f*fd**2*r*s - 56*D1**2*b1*f*fd**2*r + 42*D1**2*b1*f*fd**2*s**2 - 56*D1**2*b1*f*fd**2*s + 14*D1**2*b1*f*fd**2 - 36*D1**2*b1*f*fd*r**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 - 126*D1**2*f**2*fd*r**2 - 252*D1**2*f**2*fd*r*s + 168*D1**2*f**2*fd*r - 126*D1**2*f**2*fd*s**2 + 168*D1**2*f**2*fd*s - 84*D1**2*f**2*fd + 63*D1**2*f**2*fdd*r**2 + 126*D1**2*f**2*fdd*r*s - 84*D1**2*f**2*fdd*r + 63*D1**2*f**2*fdd*s**2 - 84*D1**2*f**2*fdd*s + 42*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r**2 - 144*D1**2*f**2*gd2*r*s + 144*D1**2*f**2*gd2*r - 72*D1**2*f**2*gd2*s**2 + 144*D1**2*f**2*gd2*s - 72*D1**2*f**2*gd2 + 36*D1**2*f**2*gdd2*r**2 + 72*D1**2*f**2*gdd2*r*s - 72*D1**2*f**2*gdd2*r + 36*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2*s + 36*D1**2*f**2*gdd2 + 126*D1**2*f*fd**2*r**2 + 252*D1**2*f*fd**2*r*s - 168*D1**2*f*fd**2*r + 126*D1**2*f*fd**2*s**2 - 168*D1**2*f*fd**2*s + 42*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r**2 - 288*D1**2*f*fd*g2*r*s + 144*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r*s - 216*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 216*D1**2*f*fd*gd2*s + 72*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*r*s - 72*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*r*s - 72*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s + 144*D1*Dd*K*b1*f**2*r**2 + 288*D1*Dd*K*b1*f**2*r*s - 216*D1*Dd*K*b1*f**2*r + 144*D1*Dd*K*b1*f**2*s**2 - 216*D1*Dd*K*b1*f**2*s + 108*D1*Dd*K*b1*f**2 - 288*D1*Dd*K*b1*f*fd*r**2 - 576*D1*Dd*K*b1*f*fd*r*s + 360*D1*Dd*K*b1*f*fd*r - 288*D1*Dd*K*b1*f*fd*s**2 + 360*D1*Dd*K*b1*f*fd*s - 108*D1*Dd*K*b1*f*fd - 56*D1*Dd*b1*f**3*r**2 - 112*D1*Dd*b1*f**3*r*s + 84*D1*Dd*b1*f**3*r - 56*D1*Dd*b1*f**3*s**2 + 84*D1*Dd*b1*f**3*s - 42*D1*Dd*b1*f**3 + 168*D1*Dd*b1*f**2*fd*r**2 + 336*D1*Dd*b1*f**2*fd*r*s - 238*D1*Dd*b1*f**2*fd*r + 168*D1*Dd*b1*f**2*fd*s**2 - 238*D1*Dd*b1*f**2*fd*s + 84*D1*Dd*b1*f**2*fd - 72*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 108*D1*Dd*b1*f**2*s - 54*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 168*D1*Dd*f**3*r**2 - 336*D1*Dd*f**3*r*s + 252*D1*Dd*f**3*r - 168*D1*Dd*f**3*s**2 + 252*D1*Dd*f**3*s - 126*D1*Dd*f**3 + 504*D1*Dd*f**2*fd*r**2 + 1008*D1*Dd*f**2*fd*r*s - 714*D1*Dd*f**2*fd*r + 504*D1*Dd*f**2*fd*s**2 - 714*D1*Dd*f**2*fd*s + 252*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r**2 - 576*D1*Dd*f**2*g2*r*s + 432*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 432*D1*Dd*f**2*g2*s - 216*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r**2 + 576*D1*Dd*f**2*gd2*r*s - 504*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 504*D1*Dd*f**2*gd2*s + 216*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r**2 + 1152*D1*Dd*f*fd*g2*r*s - 720*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 720*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 - 72*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r*s + 108*D1*Ddd*K*b1*f**2*r - 72*D1*Ddd*K*b1*f**2*s**2 + 108*D1*Ddd*K*b1*f**2*s - 54*D1*Ddd*K*b1*f**2 + 28*D1*Ddd*b1*f**3*r**2 + 56*D1*Ddd*b1*f**3*r*s - 42*D1*Ddd*b1*f**3*r + 28*D1*Ddd*b1*f**3*s**2 - 42*D1*Ddd*b1*f**3*s + 21*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 84*D1*Ddd*f**3*r**2 + 168*D1*Ddd*f**3*r*s - 126*D1*Ddd*f**3*r + 84*D1*Ddd*f**3*s**2 - 126*D1*Ddd*f**3*s + 63*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r*s - 216*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 216*D1*Ddd*f**2*g2*s + 108*D1*Ddd*f**2*g2 - 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) - 216*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r*s + 324*Dd**2*K*b1*f**2*r - 216*Dd**2*K*b1*f**2*s**2 + 324*Dd**2*K*b1*f**2*s - 108*Dd**2*K*b1*f**2 + 84*Dd**2*b1*f**3*r**2 + 168*Dd**2*b1*f**3*r*s - 126*Dd**2*b1*f**3*r + 84*Dd**2*b1*f**3*s**2 - 126*Dd**2*b1*f**3*s + 42*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 252*Dd**2*f**3*r**2 + 504*Dd**2*f**3*r*s - 378*Dd**2*f**3*r + 252*Dd**2*f**3*s**2 - 378*Dd**2*f**3*s + 126*Dd**2*f**3 + 432*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r*s - 648*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 648*Dd**2*f**2*g2*s + 216*Dd**2*f**2*g2)/(14*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**7*k1*k2**3*(-432*C*D1**2*f**2*fd*r**2 + 240*C*D1**2*f**2*fd*r*s + 208*C*D1**2*f**2*fd*r + 672*C*D1**2*f**2*fd*s**2 - 528*C*D1**2*f**2*fd*s + 80*C*D1**2*f**2*fd + 216*C*D1**2*f**2*fdd*r**2 - 120*C*D1**2*f**2*fdd*r*s - 104*C*D1**2*f**2*fdd*r - 336*C*D1**2*f**2*fdd*s**2 + 264*C*D1**2*f**2*fdd*s - 40*C*D1**2*f**2*fdd + 432*C*D1**2*f*fd**2*r**2 - 240*C*D1**2*f*fd**2*r*s - 208*C*D1**2*f*fd**2*r - 672*C*D1**2*f*fd**2*s**2 + 528*C*D1**2*f*fd**2*s - 40*C*D1**2*f*fd**2 - 576*C*D1*Dd*f**3*r**2 + 320*C*D1*Dd*f**3*r*s + 496*C*D1*Dd*f**3*r + 896*C*D1*Dd*f**3*s**2 - 608*C*D1*Dd*f**3*s - 64*C*D1*Dd*f**3 + 1728*C*D1*Dd*f**2*fd*r**2 - 960*C*D1*Dd*f**2*fd*r*s - 1160*C*D1*Dd*f**2*fd*r - 2688*C*D1*Dd*f**2*fd*s**2 + 1968*C*D1*Dd*f**2*fd*s - 56*C*D1*Dd*f**2*fd + 288*C*D1*Ddd*f**3*r**2 - 160*C*D1*Ddd*f**3*r*s - 248*C*D1*Ddd*f**3*r - 448*C*D1*Ddd*f**3*s**2 + 304*C*D1*Ddd*f**3*s + 32*C*D1*Ddd*f**3 + 864*C*Dd**2*f**3*r**2 - 480*C*Dd**2*f**3*r*s - 744*C*Dd**2*f**3*r - 1344*C*Dd**2*f**3*s**2 + 912*C*Dd**2*f**3*s + 64*C*Dd**2*f**3 - 144*D1**2*K*b1*f*fd*r**2 + 144*D1**2*K*b1*f*fd*r*s - 72*D1**2*K*b1*f*fd*r + 288*D1**2*K*b1*f*fd*s**2 - 288*D1**2*K*b1*f*fd*s + 144*D1**2*K*b1*f*fd + 72*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*r*s + 36*D1**2*K*b1*f*fdd*r - 144*D1**2*K*b1*f*fdd*s**2 + 144*D1**2*K*b1*f*fdd*s - 72*D1**2*K*b1*f*fdd + 72*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*r*s + 36*D1**2*K*b1*fd**2*r - 144*D1**2*K*b1*fd**2*s**2 + 144*D1**2*K*b1*fd**2*s + 210*D1**2*b1*f**2*fd*r**2 + 252*D1**2*b1*f**2*fd*r*s - 224*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 112*D1**2*b1*f**2*fd*s + 84*D1**2*b1*f**2*fd - 105*D1**2*b1*f**2*fdd*r**2 - 126*D1**2*b1*f**2*fdd*r*s + 112*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 56*D1**2*b1*f**2*fdd*s - 42*D1**2*b1*f**2*fdd - 210*D1**2*b1*f*fd**2*r**2 - 252*D1**2*b1*f*fd**2*r*s + 224*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 112*D1**2*b1*f*fd**2*s - 42*D1**2*b1*f*fd**2 + 324*D1**2*b1*f*fd*r**2 + 360*D1**2*b1*f*fd*r*s - 180*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 162*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 162*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(r + s - 1)*(9*K*(-4*r + 8*s + 4) + 7*f*(5*r + s - 5) + 81*r + 9*s - 81) - 112*D1**2*f**3*fd*r**2 - 112*D1**2*f**3*fd*r*s + 140*D1**2*f**3*fd*r + 56*D1**2*f**3*fd*s - 56*D1**2*f**3*fd + 112*D1**2*f**3*fdd*r**2 + 112*D1**2*f**3*fdd*r*s - 140*D1**2*f**3*fdd*r - 56*D1**2*f**3*fdd*s + 56*D1**2*f**3*fdd + 336*D1**2*f**2*fd**2*r**2 + 336*D1**2*f**2*fd**2*r*s - 420*D1**2*f**2*fd**2*r - 168*D1**2*f**2*fd**2*s + 112*D1**2*f**2*fd**2 + 642*D1**2*f**2*fd*r**2 + 348*D1**2*f**2*fd*r*s - 544*D1**2*f**2*fd*r - 294*D1**2*f**2*fd*s**2 + 80*D1**2*f**2*fd*s + 116*D1**2*f**2*fd - 321*D1**2*f**2*fdd*r**2 - 174*D1**2*f**2*fdd*r*s + 272*D1**2*f**2*fdd*r + 147*D1**2*f**2*fdd*s**2 - 40*D1**2*f**2*fdd*s - 58*D1**2*f**2*fdd + 144*D1**2*f**2*gd2*r**2 - 144*D1**2*f**2*gd2*r*s - 288*D1**2*f**2*gd2*r - 288*D1**2*f**2*gd2*s**2 + 144*D1**2*f**2*gd2*s + 144*D1**2*f**2*gd2 - 72*D1**2*f**2*gdd2*r**2 + 72*D1**2*f**2*gdd2*r*s + 144*D1**2*f**2*gdd2*r + 144*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2*s - 72*D1**2*f**2*gdd2 - 642*D1**2*f*fd**2*r**2 - 348*D1**2*f*fd**2*r*s + 544*D1**2*f*fd**2*r + 294*D1**2*f*fd**2*s**2 - 80*D1**2*f*fd**2*s - 58*D1**2*f*fd**2 + 288*D1**2*f*fd*g2*r**2 - 288*D1**2*f*fd*g2*r*s + 144*D1**2*f*fd*g2*r - 576*D1**2*f*fd*g2*s**2 + 576*D1**2*f*fd*g2*s - 288*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r + 576*D1**2*f*fd*gd2*s**2 - 432*D1**2*f*fd*gd2*s + 72*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*r*s - 72*D1**2*f*fdd*g2*r + 288*D1**2*f*fdd*g2*s**2 - 288*D1**2*f*fdd*g2*s + 144*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*r*s - 72*D1**2*fd**2*g2*r + 288*D1**2*fd**2*g2*s**2 - 288*D1**2*fd**2*g2*s - 288*D1*Dd*K*b1*f**2*r**2 + 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r + 576*D1*Dd*K*b1*f**2*s**2 - 432*D1*Dd*K*b1*f**2*s + 576*D1*Dd*K*b1*f*fd*r**2 - 576*D1*Dd*K*b1*f*fd*r*s - 72*D1*Dd*K*b1*f*fd*r - 1152*D1*Dd*K*b1*f*fd*s**2 + 1008*D1*Dd*K*b1*f*fd*s - 216*D1*Dd*K*b1*f*fd + 280*D1*Dd*b1*f**3*r**2 + 336*D1*Dd*b1*f**3*r*s - 364*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 196*D1*Dd*b1*f**3*s + 154*D1*Dd*b1*f**3 - 840*D1*Dd*b1*f**2*fd*r**2 - 1008*D1*Dd*b1*f**2*fd*r*s + 994*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 518*D1*Dd*b1*f**2*fd*s - 280*D1*Dd*b1*f**2*fd + 648*D1*Dd*b1*f**2*r**2 + 720*D1*Dd*b1*f**2*r*s - 828*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 342*D1*Dd*b1*f**2 - 1296*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 1188*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 468*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd - 112*D1*Dd*f**4*r**2 - 112*D1*Dd*f**4*r*s + 140*D1*Dd*f**4*r + 56*D1*Dd*f**4*s - 56*D1*Dd*f**4 + 896*D1*Dd*f**3*fd*r**2 + 896*D1*Dd*f**3*fd*r*s - 1120*D1*Dd*f**3*fd*r - 448*D1*Dd*f**3*fd*s + 336*D1*Dd*f**3*fd + 856*D1*Dd*f**3*r**2 + 464*D1*Dd*f**3*r*s - 972*D1*Dd*f**3*r - 392*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 330*D1*Dd*f**3 - 2568*D1*Dd*f**2*fd*r**2 - 1392*D1*Dd*f**2*fd*r*s + 2546*D1*Dd*f**2*fd*r + 1176*D1*Dd*f**2*fd*s**2 - 106*D1*Dd*f**2*fd*s - 504*D1*Dd*f**2*fd + 576*D1*Dd*f**2*g2*r**2 - 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r - 1152*D1*Dd*f**2*g2*s**2 + 864*D1*Dd*f**2*g2*s - 576*D1*Dd*f**2*gd2*r**2 + 576*D1*Dd*f**2*gd2*r*s + 792*D1*Dd*f**2*gd2*r + 1152*D1*Dd*f**2*gd2*s**2 - 720*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r**2 + 1152*D1*Dd*f*fd*g2*r*s + 144*D1*Dd*f*fd*g2*r + 2304*D1*Dd*f*fd*g2*s**2 - 2016*D1*Dd*f*fd*g2*s + 432*D1*Dd*f*fd*g2 + 144*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r - 288*D1*Ddd*K*b1*f**2*s**2 + 216*D1*Ddd*K*b1*f**2*s - 140*D1*Ddd*b1*f**3*r**2 - 168*D1*Ddd*b1*f**3*r*s + 182*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 98*D1*Ddd*b1*f**3*s - 77*D1*Ddd*b1*f**3 - 324*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 414*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 171*D1*Ddd*b1*f**2 + 112*D1*Ddd*f**4*r**2 + 112*D1*Ddd*f**4*r*s - 140*D1*Ddd*f**4*r - 56*D1*Ddd*f**4*s + 56*D1*Ddd*f**4 - 428*D1*Ddd*f**3*r**2 - 232*D1*Ddd*f**3*r*s + 486*D1*Ddd*f**3*r + 196*D1*Ddd*f**3*s**2 + 18*D1*Ddd*f**3*s - 165*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r + 576*D1*Ddd*f**2*g2*s**2 - 432*D1*Ddd*f**2*g2*s + 2*D1*bd1*f*(7*D1*f**2*(5*r**2 + 2*r*(3*s - 5) + s**2 - 6*s + 5) + D1*f*(-7*fd*(15*r**2 + r*(18*s - 23) + 3*s**2 - 13*s + 8) + (r + s - 1)*(-36*K*(r - 2*s - 1) + 81*r + 9*s - 81)) + 9*D1*fd*(2*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 18*r**2 - 20*r*s + 23*r - 2*s**2 + 11*s - 5) - 7*Dd*f**2*(20*r**2 + 3*r*(8*s - 11) + 4*s**2 - 19*s + 13) + 9*Dd*f*(2*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 36*r**2 - 40*r*s + 59*r - 4*s**2 + 31*s - 23)) + 432*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r - 864*Dd**2*K*b1*f**2*s**2 + 648*Dd**2*K*b1*f**2*s - 420*Dd**2*b1*f**3*r**2 - 504*Dd**2*b1*f**3*r*s + 546*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 294*Dd**2*b1*f**3*s - 154*Dd**2*b1*f**3 - 972*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 1242*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 342*Dd**2*b1*f**2 + 336*Dd**2*f**4*r**2 + 336*Dd**2*f**4*r*s - 420*Dd**2*f**4*r - 168*Dd**2*f**4*s + 112*Dd**2*f**4 - 1284*Dd**2*f**3*r**2 - 696*Dd**2*f**3*r*s + 1458*Dd**2*f**3*r + 588*Dd**2*f**3*s**2 + 54*Dd**2*f**3*s - 330*Dd**2*f**3 - 864*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r + 1728*Dd**2*f**2*g2*s**2 - 1296*Dd**2*f**2*g2*s)/(126*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**7*k1*k2*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(-7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 18*r*(4*s - 1) + 18*(1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(7*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(7*bdd1*f**2*s*(r + s - 1) + f*(9*bdd1*s*(r + s - 1) - 14*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 2*f*s*(7*f + 9)*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 7*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 7*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**6*k1**4*k2**2*(2574*C*D1**2*f**2*fd*r**2 + 5148*C*D1**2*f**2*fd*r*s - 3432*C*D1**2*f**2*fd*r + 2574*C*D1**2*f**2*fd*s**2 - 3432*C*D1**2*f**2*fd*s + 1716*C*D1**2*f**2*fd - 2772*C*D1**2*f**2*fdd*r**2 - 5544*C*D1**2*f**2*fdd*r*s + 3696*C*D1**2*f**2*fdd*r - 2772*C*D1**2*f**2*fdd*s**2 + 3696*C*D1**2*f**2*fdd*s - 1848*C*D1**2*f**2*fdd - 5544*C*D1**2*f*fd**2*r**2 - 11088*C*D1**2*f*fd**2*r*s + 7392*C*D1**2*f*fd**2*r - 5544*C*D1**2*f*fd**2*s**2 + 7392*C*D1**2*f*fd**2*s - 1848*C*D1**2*f*fd**2 + 3432*C*D1*Dd*f**3*r**2 + 6864*C*D1*Dd*f**3*r*s - 5148*C*D1*Dd*f**3*r + 3432*C*D1*Dd*f**3*s**2 - 5148*C*D1*Dd*f**3*s + 2574*C*D1*Dd*f**3 - 22176*C*D1*Dd*f**2*fd*r**2 - 44352*C*D1*Dd*f**2*fd*r*s + 31416*C*D1*Dd*f**2*fd*r - 22176*C*D1*Dd*f**2*fd*s**2 + 31416*C*D1*Dd*f**2*fd*s - 11088*C*D1*Dd*f**2*fd - 3696*C*D1*Ddd*f**3*r**2 - 7392*C*D1*Ddd*f**3*r*s + 5544*C*D1*Ddd*f**3*r - 3696*C*D1*Ddd*f**3*s**2 + 5544*C*D1*Ddd*f**3*s - 2772*C*D1*Ddd*f**3 - 11088*C*Dd**2*f**3*r**2 - 22176*C*Dd**2*f**3*r*s + 16632*C*Dd**2*f**3*r - 11088*C*Dd**2*f**3*s**2 + 16632*C*Dd**2*f**3*s - 5544*C*Dd**2*f**3 + 990*D1**2*K*b1*f*fd*r**2 + 1980*D1**2*K*b1*f*fd*r*s - 990*D1**2*K*b1*f*fd*r + 990*D1**2*K*b1*f*fd*s**2 - 990*D1**2*K*b1*f*fd*s + 495*D1**2*K*b1*f*fd - 1188*D1**2*K*b1*f*fdd*r**2 - 2376*D1**2*K*b1*f*fdd*r*s + 1188*D1**2*K*b1*f*fdd*r - 1188*D1**2*K*b1*f*fdd*s**2 + 1188*D1**2*K*b1*f*fdd*s - 594*D1**2*K*b1*f*fdd - 1188*D1**2*K*b1*fd**2*r**2 - 2376*D1**2*K*b1*fd**2*r*s + 1188*D1**2*K*b1*fd**2*r - 1188*D1**2*K*b1*fd**2*s**2 + 1188*D1**2*K*b1*fd**2*s - 990*D1**2*b1*f*fd*r**2 - 1980*D1**2*b1*f*fd*r*s + 990*D1**2*b1*f*fd*r - 990*D1**2*b1*f*fd*s**2 + 990*D1**2*b1*f*fd*s - 495*D1**2*b1*f*fd + 1188*D1**2*b1*f*fdd*r**2 + 2376*D1**2*b1*f*fdd*r*s - 1188*D1**2*b1*f*fdd*r + 1188*D1**2*b1*f*fdd*s**2 - 1188*D1**2*b1*f*fdd*s + 594*D1**2*b1*f*fdd + 1188*D1**2*b1*fd**2*r**2 + 2376*D1**2*b1*fd**2*r*s - 1188*D1**2*b1*fd**2*r + 1188*D1**2*b1*fd**2*s**2 - 1188*D1**2*b1*fd**2*s - 594*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 2884*D1**2*f**3*fd*r**2 + 5768*D1**2*f**3*fd*r*s - 4326*D1**2*f**3*fd*r + 2884*D1**2*f**3*fd*s**2 - 4326*D1**2*f**3*fd*s + 2163*D1**2*f**3*fd - 2520*D1**2*f**3*fdd*r**2 - 5040*D1**2*f**3*fdd*r*s + 3780*D1**2*f**3*fdd*r - 2520*D1**2*f**3*fdd*s**2 + 3780*D1**2*f**3*fdd*s - 1890*D1**2*f**3*fdd - 7560*D1**2*f**2*fd**2*r**2 - 15120*D1**2*f**2*fd**2*r*s + 11340*D1**2*f**2*fd**2*r - 7560*D1**2*f**2*fd**2*s**2 + 11340*D1**2*f**2*fd**2*s - 3780*D1**2*f**2*fd**2 - 2574*D1**2*f**2*fd*r**2 - 5148*D1**2*f**2*fd*r*s + 3432*D1**2*f**2*fd*r - 2574*D1**2*f**2*fd*s**2 + 3432*D1**2*f**2*fd*s - 1716*D1**2*f**2*fd + 2772*D1**2*f**2*fdd*r**2 + 5544*D1**2*f**2*fdd*r*s - 3696*D1**2*f**2*fdd*r + 2772*D1**2*f**2*fdd*s**2 - 3696*D1**2*f**2*fdd*s + 1848*D1**2*f**2*fdd - 990*D1**2*f**2*gd2*r**2 - 1980*D1**2*f**2*gd2*r*s + 1980*D1**2*f**2*gd2*r - 990*D1**2*f**2*gd2*s**2 + 1980*D1**2*f**2*gd2*s - 990*D1**2*f**2*gd2 + 1188*D1**2*f**2*gdd2*r**2 + 2376*D1**2*f**2*gdd2*r*s - 2376*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 2376*D1**2*f**2*gdd2*s + 1188*D1**2*f**2*gdd2 + 5544*D1**2*f*fd**2*r**2 + 11088*D1**2*f*fd**2*r*s - 7392*D1**2*f*fd**2*r + 5544*D1**2*f*fd**2*s**2 - 7392*D1**2*f*fd**2*s + 1848*D1**2*f*fd**2 - 1980*D1**2*f*fd*g2*r**2 - 3960*D1**2*f*fd*g2*r*s + 1980*D1**2*f*fd*g2*r - 1980*D1**2*f*fd*g2*s**2 + 1980*D1**2*f*fd*g2*s - 990*D1**2*f*fd*g2 + 4752*D1**2*f*fd*gd2*r**2 + 9504*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2376*D1**2*f*fd*gd2 + 2376*D1**2*f*fdd*g2*r**2 + 4752*D1**2*f*fdd*g2*r*s - 2376*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 2376*D1**2*fd**2*g2*r**2 + 4752*D1**2*fd**2*g2*r*s - 2376*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 1980*D1*Dd*K*b1*f**2*r**2 + 3960*D1*Dd*K*b1*f**2*r*s - 2970*D1*Dd*K*b1*f**2*r + 1980*D1*Dd*K*b1*f**2*s**2 - 2970*D1*Dd*K*b1*f**2*s + 1485*D1*Dd*K*b1*f**2 - 9504*D1*Dd*K*b1*f*fd*r**2 - 19008*D1*Dd*K*b1*f*fd*r*s + 11880*D1*Dd*K*b1*f*fd*r - 9504*D1*Dd*K*b1*f*fd*s**2 + 11880*D1*Dd*K*b1*f*fd*s - 3564*D1*Dd*K*b1*f*fd - 1980*D1*Dd*b1*f**2*r**2 - 3960*D1*Dd*b1*f**2*r*s + 2970*D1*Dd*b1*f**2*r - 1980*D1*Dd*b1*f**2*s**2 + 2970*D1*Dd*b1*f**2*s - 1485*D1*Dd*b1*f**2 + 9504*D1*Dd*b1*f*fd*r**2 + 19008*D1*Dd*b1*f*fd*r*s - 11880*D1*Dd*b1*f*fd*r + 9504*D1*Dd*b1*f*fd*s**2 - 11880*D1*Dd*b1*f*fd*s + 3564*D1*Dd*b1*f*fd + 2884*D1*Dd*f**4*r**2 + 5768*D1*Dd*f**4*r*s - 4326*D1*Dd*f**4*r + 2884*D1*Dd*f**4*s**2 - 4326*D1*Dd*f**4*s + 2163*D1*Dd*f**4 - 20160*D1*Dd*f**3*fd*r**2 - 40320*D1*Dd*f**3*fd*r*s + 30240*D1*Dd*f**3*fd*r - 20160*D1*Dd*f**3*fd*s**2 + 30240*D1*Dd*f**3*fd*s - 11340*D1*Dd*f**3*fd - 3432*D1*Dd*f**3*r**2 - 6864*D1*Dd*f**3*r*s + 5148*D1*Dd*f**3*r - 3432*D1*Dd*f**3*s**2 + 5148*D1*Dd*f**3*s - 2574*D1*Dd*f**3 + 22176*D1*Dd*f**2*fd*r**2 + 44352*D1*Dd*f**2*fd*r*s - 31416*D1*Dd*f**2*fd*r + 22176*D1*Dd*f**2*fd*s**2 - 31416*D1*Dd*f**2*fd*s + 11088*D1*Dd*f**2*fd - 3960*D1*Dd*f**2*g2*r**2 - 7920*D1*Dd*f**2*g2*r*s + 5940*D1*Dd*f**2*g2*r - 3960*D1*Dd*f**2*g2*s**2 + 5940*D1*Dd*f**2*g2*s - 2970*D1*Dd*f**2*g2 + 9504*D1*Dd*f**2*gd2*r**2 + 19008*D1*Dd*f**2*gd2*r*s - 16632*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 19008*D1*Dd*f*fd*g2*r**2 + 38016*D1*Dd*f*fd*g2*r*s - 23760*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 23760*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 2376*D1*Ddd*K*b1*f**2*r**2 - 4752*D1*Ddd*K*b1*f**2*r*s + 3564*D1*Ddd*K*b1*f**2*r - 2376*D1*Ddd*K*b1*f**2*s**2 + 3564*D1*Ddd*K*b1*f**2*s - 1782*D1*Ddd*K*b1*f**2 + 2376*D1*Ddd*b1*f**2*r**2 + 4752*D1*Ddd*b1*f**2*r*s - 3564*D1*Ddd*b1*f**2*r + 2376*D1*Ddd*b1*f**2*s**2 - 3564*D1*Ddd*b1*f**2*s + 1782*D1*Ddd*b1*f**2 - 2520*D1*Ddd*f**4*r**2 - 5040*D1*Ddd*f**4*r*s + 3780*D1*Ddd*f**4*r - 2520*D1*Ddd*f**4*s**2 + 3780*D1*Ddd*f**4*s - 1890*D1*Ddd*f**4 + 3696*D1*Ddd*f**3*r**2 + 7392*D1*Ddd*f**3*r*s - 5544*D1*Ddd*f**3*r + 3696*D1*Ddd*f**3*s**2 - 5544*D1*Ddd*f**3*s + 2772*D1*Ddd*f**3 + 4752*D1*Ddd*f**2*g2*r**2 + 9504*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 7128*Dd**2*K*b1*f**2*r**2 - 14256*Dd**2*K*b1*f**2*r*s + 10692*Dd**2*K*b1*f**2*r - 7128*Dd**2*K*b1*f**2*s**2 + 10692*Dd**2*K*b1*f**2*s - 3564*Dd**2*K*b1*f**2 + 7128*Dd**2*b1*f**2*r**2 + 14256*Dd**2*b1*f**2*r*s - 10692*Dd**2*b1*f**2*r + 7128*Dd**2*b1*f**2*s**2 - 10692*Dd**2*b1*f**2*s + 3564*Dd**2*b1*f**2 - 7560*Dd**2*f**4*r**2 - 15120*Dd**2*f**4*r*s + 11340*Dd**2*f**4*r - 7560*Dd**2*f**4*s**2 + 11340*Dd**2*f**4*s - 3780*Dd**2*f**4 + 11088*Dd**2*f**3*r**2 + 22176*Dd**2*f**3*r*s - 16632*Dd**2*f**3*r + 11088*Dd**2*f**3*s**2 - 16632*Dd**2*f**3*s + 5544*Dd**2*f**3 + 14256*Dd**2*f**2*g2*r**2 + 28512*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 7128*Dd**2*f**2*g2)/(154*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**6*k1**4*(2640*C*D1**2*f**2*fd*r*s - 880*C*D1**2*f**2*fd*r + 2640*C*D1**2*f**2*fd*s**2 - 2640*C*D1**2*f**2*fd*s + 880*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r*s + 770*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 2310*C*D1**2*f**2*fdd*s - 770*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r*s + 1540*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 4620*C*D1**2*f*fd**2*s - 770*C*D1**2*f*fd**2 + 3520*C*D1*Dd*f**3*r*s - 880*C*D1*Dd*f**3*r + 3520*C*D1*Dd*f**3*s**2 - 3520*C*D1*Dd*f**3*s + 880*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r*s + 5390*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 18480*C*D1*Dd*f**2*fd*s - 3850*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r*s + 770*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 3080*C*D1*Ddd*f**3*s - 770*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r*s + 2310*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 9240*C*Dd**2*f**3*s - 1540*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 3500*D1**2*f**3*fd*r*s - 875*D1**2*f**3*fd*r + 3500*D1**2*f**3*fd*s**2 - 3500*D1**2*f**3*fd*s + 875*D1**2*f**3*fd - 2520*D1**2*f**3*fdd*r*s + 630*D1**2*f**3*fdd*r - 2520*D1**2*f**3*fdd*s**2 + 2520*D1**2*f**3*fdd*s - 630*D1**2*f**3*fdd - 7560*D1**2*f**2*fd**2*r*s + 1890*D1**2*f**2*fd**2*r - 7560*D1**2*f**2*fd**2*s**2 + 7560*D1**2*f**2*fd**2*s - 1260*D1**2*f**2*fd**2 - 2640*D1**2*f**2*fd*r*s + 880*D1**2*f**2*fd*r - 2640*D1**2*f**2*fd*s**2 + 2640*D1**2*f**2*fd*s - 880*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r*s - 770*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2310*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd - 1056*D1**2*f**2*gd2*r*s - 1056*D1**2*f**2*gd2*s**2 + 1056*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 4620*D1**2*f*fd**2*r*s - 1540*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 4620*D1**2*f*fd**2*s + 770*D1**2*f*fd**2 - 2112*D1**2*f*fd*g2*r*s + 1056*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s**2 + 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 3500*D1*Dd*f**4*r*s - 875*D1*Dd*f**4*r + 3500*D1*Dd*f**4*s**2 - 3500*D1*Dd*f**4*s + 875*D1*Dd*f**4 - 20160*D1*Dd*f**3*fd*r*s + 5040*D1*Dd*f**3*fd*r - 20160*D1*Dd*f**3*fd*s**2 + 20160*D1*Dd*f**3*fd*s - 3780*D1*Dd*f**3*fd - 3520*D1*Dd*f**3*r*s + 880*D1*Dd*f**3*r - 3520*D1*Dd*f**3*s**2 + 3520*D1*Dd*f**3*s - 880*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r*s - 5390*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 18480*D1*Dd*f**2*fd*s + 3850*D1*Dd*f**2*fd - 4224*D1*Dd*f**2*g2*r*s + 1056*D1*Dd*f**2*g2*r - 4224*D1*Dd*f**2*g2*s**2 + 4224*D1*Dd*f**2*g2*s - 1056*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 2520*D1*Ddd*f**4*r*s + 630*D1*Ddd*f**4*r - 2520*D1*Ddd*f**4*s**2 + 2520*D1*Ddd*f**4*s - 630*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r*s - 770*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 3080*D1*Ddd*f**3*s + 770*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(16*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 7560*Dd**2*f**4*r*s + 1890*Dd**2*f**4*r - 7560*Dd**2*f**4*s**2 + 7560*Dd**2*f**4*s - 1260*Dd**2*f**4 + 9240*Dd**2*f**3*r*s - 2310*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 9240*Dd**2*f**3*s + 1540*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(16*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - 15*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**6*k1**2*k2**4*st**2*(1980*C*D1**2*f**2*fd*r**2 + 3960*C*D1**2*f**2*fd*r*s - 2640*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd*s**2 - 2640*C*D1**2*f**2*fd*s + 1320*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r**2 - 1980*C*D1**2*f**2*fdd*r*s + 1320*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 1320*C*D1**2*f**2*fdd*s - 660*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r**2 - 3960*C*D1**2*f*fd**2*r*s + 2640*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 2640*C*D1**2*f*fd**2*s - 660*C*D1**2*f*fd**2 + 2640*C*D1*Dd*f**3*r**2 + 5280*C*D1*Dd*f**3*r*s - 3960*C*D1*Dd*f**3*r + 2640*C*D1*Dd*f**3*s**2 - 3960*C*D1*Dd*f**3*s + 1980*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r**2 - 15840*C*D1*Dd*f**2*fd*r*s + 11220*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 11220*C*D1*Dd*f**2*fd*s - 3960*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r**2 - 2640*C*D1*Ddd*f**3*r*s + 1980*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1980*C*D1*Ddd*f**3*s - 990*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r**2 - 7920*C*Dd**2*f**3*r*s + 5940*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 5940*C*Dd**2*f**3*s - 1980*C*Dd**2*f**3 + 1188*D1**2*K*b1*f*fd*r**2 + 2376*D1**2*K*b1*f*fd*r*s - 1188*D1**2*K*b1*f*fd*r + 1188*D1**2*K*b1*f*fd*s**2 - 1188*D1**2*K*b1*f*fd*s + 594*D1**2*K*b1*f*fd - 594*D1**2*K*b1*f*fdd*r**2 - 1188*D1**2*K*b1*f*fdd*r*s + 594*D1**2*K*b1*f*fdd*r - 594*D1**2*K*b1*f*fdd*s**2 + 594*D1**2*K*b1*f*fdd*s - 297*D1**2*K*b1*f*fdd - 594*D1**2*K*b1*fd**2*r**2 - 1188*D1**2*K*b1*fd**2*r*s + 594*D1**2*K*b1*fd**2*r - 594*D1**2*K*b1*fd**2*s**2 + 594*D1**2*K*b1*fd**2*s - 1188*D1**2*b1*f*fd*r**2 - 2376*D1**2*b1*f*fd*r*s + 1188*D1**2*b1*f*fd*r - 1188*D1**2*b1*f*fd*s**2 + 1188*D1**2*b1*f*fd*s - 594*D1**2*b1*f*fd + 594*D1**2*b1*f*fdd*r**2 + 1188*D1**2*b1*f*fdd*r*s - 594*D1**2*b1*f*fdd*r + 594*D1**2*b1*f*fdd*s**2 - 594*D1**2*b1*f*fdd*s + 297*D1**2*b1*f*fdd + 594*D1**2*b1*fd**2*r**2 + 1188*D1**2*b1*fd**2*r*s - 594*D1**2*b1*fd**2*r + 594*D1**2*b1*fd**2*s**2 - 594*D1**2*b1*fd**2*s - 297*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 1568*D1**2*f**3*fd*r**2 + 3136*D1**2*f**3*fd*r*s - 2352*D1**2*f**3*fd*r + 1568*D1**2*f**3*fd*s**2 - 2352*D1**2*f**3*fd*s + 1176*D1**2*f**3*fd - 784*D1**2*f**3*fdd*r**2 - 1568*D1**2*f**3*fdd*r*s + 1176*D1**2*f**3*fdd*r - 784*D1**2*f**3*fdd*s**2 + 1176*D1**2*f**3*fdd*s - 588*D1**2*f**3*fdd - 2352*D1**2*f**2*fd**2*r**2 - 4704*D1**2*f**2*fd**2*r*s + 3528*D1**2*f**2*fd**2*r - 2352*D1**2*f**2*fd**2*s**2 + 3528*D1**2*f**2*fd**2*s - 1176*D1**2*f**2*fd**2 - 1980*D1**2*f**2*fd*r**2 - 3960*D1**2*f**2*fd*r*s + 2640*D1**2*f**2*fd*r - 1980*D1**2*f**2*fd*s**2 + 2640*D1**2*f**2*fd*s - 1320*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r**2 + 1980*D1**2*f**2*fdd*r*s - 1320*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 1320*D1**2*f**2*fdd*s + 660*D1**2*f**2*fdd - 1188*D1**2*f**2*gd2*r**2 - 2376*D1**2*f**2*gd2*r*s + 2376*D1**2*f**2*gd2*r - 1188*D1**2*f**2*gd2*s**2 + 2376*D1**2*f**2*gd2*s - 1188*D1**2*f**2*gd2 + 594*D1**2*f**2*gdd2*r**2 + 1188*D1**2*f**2*gdd2*r*s - 1188*D1**2*f**2*gdd2*r + 594*D1**2*f**2*gdd2*s**2 - 1188*D1**2*f**2*gdd2*s + 594*D1**2*f**2*gdd2 + 1980*D1**2*f*fd**2*r**2 + 3960*D1**2*f*fd**2*r*s - 2640*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 2640*D1**2*f*fd**2*s + 660*D1**2*f*fd**2 - 2376*D1**2*f*fd*g2*r**2 - 4752*D1**2*f*fd*g2*r*s + 2376*D1**2*f*fd*g2*r - 2376*D1**2*f*fd*g2*s**2 + 2376*D1**2*f*fd*g2*s - 1188*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r**2 + 4752*D1**2*f*fd*gd2*r*s - 3564*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 3564*D1**2*f*fd*gd2*s + 1188*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r**2 + 2376*D1**2*f*fdd*g2*r*s - 1188*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r**2 + 2376*D1**2*fd**2*g2*r*s - 1188*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 2376*D1*Dd*K*b1*f**2*r**2 + 4752*D1*Dd*K*b1*f**2*r*s - 3564*D1*Dd*K*b1*f**2*r + 2376*D1*Dd*K*b1*f**2*s**2 - 3564*D1*Dd*K*b1*f**2*s + 1782*D1*Dd*K*b1*f**2 - 4752*D1*Dd*K*b1*f*fd*r**2 - 9504*D1*Dd*K*b1*f*fd*r*s + 5940*D1*Dd*K*b1*f*fd*r - 4752*D1*Dd*K*b1*f*fd*s**2 + 5940*D1*Dd*K*b1*f*fd*s - 1782*D1*Dd*K*b1*f*fd - 2376*D1*Dd*b1*f**2*r**2 - 4752*D1*Dd*b1*f**2*r*s + 3564*D1*Dd*b1*f**2*r - 2376*D1*Dd*b1*f**2*s**2 + 3564*D1*Dd*b1*f**2*s - 1782*D1*Dd*b1*f**2 + 4752*D1*Dd*b1*f*fd*r**2 + 9504*D1*Dd*b1*f*fd*r*s - 5940*D1*Dd*b1*f*fd*r + 4752*D1*Dd*b1*f*fd*s**2 - 5940*D1*Dd*b1*f*fd*s + 1782*D1*Dd*b1*f*fd + 1568*D1*Dd*f**4*r**2 + 3136*D1*Dd*f**4*r*s - 2352*D1*Dd*f**4*r + 1568*D1*Dd*f**4*s**2 - 2352*D1*Dd*f**4*s + 1176*D1*Dd*f**4 - 6272*D1*Dd*f**3*fd*r**2 - 12544*D1*Dd*f**3*fd*r*s + 9408*D1*Dd*f**3*fd*r - 6272*D1*Dd*f**3*fd*s**2 + 9408*D1*Dd*f**3*fd*s - 3528*D1*Dd*f**3*fd - 2640*D1*Dd*f**3*r**2 - 5280*D1*Dd*f**3*r*s + 3960*D1*Dd*f**3*r - 2640*D1*Dd*f**3*s**2 + 3960*D1*Dd*f**3*s - 1980*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r**2 + 15840*D1*Dd*f**2*fd*r*s - 11220*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 11220*D1*Dd*f**2*fd*s + 3960*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*g2*r**2 - 9504*D1*Dd*f**2*g2*r*s + 7128*D1*Dd*f**2*g2*r - 4752*D1*Dd*f**2*g2*s**2 + 7128*D1*Dd*f**2*g2*s - 3564*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r**2 + 9504*D1*Dd*f**2*gd2*r*s - 8316*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 8316*D1*Dd*f**2*gd2*s + 3564*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r**2 + 19008*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 11880*D1*Dd*f*fd*g2*s + 3564*D1*Dd*f*fd*g2 - 1188*D1*Ddd*K*b1*f**2*r**2 - 2376*D1*Ddd*K*b1*f**2*r*s + 1782*D1*Ddd*K*b1*f**2*r - 1188*D1*Ddd*K*b1*f**2*s**2 + 1782*D1*Ddd*K*b1*f**2*s - 891*D1*Ddd*K*b1*f**2 + 1188*D1*Ddd*b1*f**2*r**2 + 2376*D1*Ddd*b1*f**2*r*s - 1782*D1*Ddd*b1*f**2*r + 1188*D1*Ddd*b1*f**2*s**2 - 1782*D1*Ddd*b1*f**2*s + 891*D1*Ddd*b1*f**2 - 784*D1*Ddd*f**4*r**2 - 1568*D1*Ddd*f**4*r*s + 1176*D1*Ddd*f**4*r - 784*D1*Ddd*f**4*s**2 + 1176*D1*Ddd*f**4*s - 588*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r**2 + 2640*D1*Ddd*f**3*r*s - 1980*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1980*D1*Ddd*f**3*s + 990*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r**2 + 4752*D1*Ddd*f**2*g2*r*s - 3564*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 3564*D1*Ddd*f**2*g2*s + 1782*D1*Ddd*f**2*g2 + 594*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 3564*Dd**2*K*b1*f**2*r**2 - 7128*Dd**2*K*b1*f**2*r*s + 5346*Dd**2*K*b1*f**2*r - 3564*Dd**2*K*b1*f**2*s**2 + 5346*Dd**2*K*b1*f**2*s - 1782*Dd**2*K*b1*f**2 + 3564*Dd**2*b1*f**2*r**2 + 7128*Dd**2*b1*f**2*r*s - 5346*Dd**2*b1*f**2*r + 3564*Dd**2*b1*f**2*s**2 - 5346*Dd**2*b1*f**2*s + 1782*Dd**2*b1*f**2 - 2352*Dd**2*f**4*r**2 - 4704*Dd**2*f**4*r*s + 3528*Dd**2*f**4*r - 2352*Dd**2*f**4*s**2 + 3528*Dd**2*f**4*s - 1176*Dd**2*f**4 + 3960*Dd**2*f**3*r**2 + 7920*Dd**2*f**3*r*s - 5940*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 5940*Dd**2*f**3*s + 1980*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r**2 + 14256*Dd**2*f**2*g2*r*s - 10692*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 10692*Dd**2*f**2*g2*s + 3564*Dd**2*f**2*g2)/(154*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**6*k1**2*k2**4*(-90*C*D1**2*bdd1*f**2*r**2 - 180*C*D1**2*bdd1*f**2*r*s + 180*C*D1**2*bdd1*f**2*r - 90*C*D1**2*bdd1*f**2*s**2 + 180*C*D1**2*bdd1*f**2*s - 90*C*D1**2*bdd1*f**2 + 2010*C*D1**2*f**2*fd*r**2 + 4020*C*D1**2*f**2*fd*r*s - 2680*C*D1**2*f**2*fd*r + 2010*C*D1**2*f**2*fd*s**2 - 2680*C*D1**2*f**2*fd*s + 1340*C*D1**2*f**2*fd - 1680*C*D1**2*f**2*fdd*r**2 - 3360*C*D1**2*f**2*fdd*r*s + 2240*C*D1**2*f**2*fdd*r - 1680*C*D1**2*f**2*fdd*s**2 + 2240*C*D1**2*f**2*fdd*s - 1120*C*D1**2*f**2*fdd - 3360*C*D1**2*f*fd**2*r**2 - 6720*C*D1**2*f*fd**2*r*s + 4480*C*D1**2*f*fd**2*r - 3360*C*D1**2*f*fd**2*s**2 + 4480*C*D1**2*f*fd**2*s - 1120*C*D1**2*f*fd**2 + 2680*C*D1*Dd*f**3*r**2 + 5360*C*D1*Dd*f**3*r*s - 4020*C*D1*Dd*f**3*r + 2680*C*D1*Dd*f**3*s**2 - 4020*C*D1*Dd*f**3*s + 2010*C*D1*Dd*f**3 - 13440*C*D1*Dd*f**2*fd*r**2 - 26880*C*D1*Dd*f**2*fd*r*s + 19040*C*D1*Dd*f**2*fd*r - 13440*C*D1*Dd*f**2*fd*s**2 + 19040*C*D1*Dd*f**2*fd*s - 6720*C*D1*Dd*f**2*fd - 2240*C*D1*Ddd*f**3*r**2 - 4480*C*D1*Ddd*f**3*r*s + 3360*C*D1*Ddd*f**3*r - 2240*C*D1*Ddd*f**3*s**2 + 3360*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 6720*C*Dd**2*f**3*r**2 - 13440*C*Dd**2*f**3*r*s + 10080*C*Dd**2*f**3*r - 6720*C*Dd**2*f**3*s**2 + 10080*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 360*D1**2*K*bdd1*f**2*r**2 - 720*D1**2*K*bdd1*f**2*r*s + 720*D1**2*K*bdd1*f**2*r - 360*D1**2*K*bdd1*f**2*s**2 + 720*D1**2*K*bdd1*f**2*s - 360*D1**2*K*bdd1*f**2 - 126*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 140*D1**2*bdd1*f**3*r**2 + 280*D1**2*bdd1*f**3*r*s - 280*D1**2*bdd1*f**3*r + 140*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 140*D1**2*bdd1*f**3 + 270*D1**2*bdd1*f**2*r**2 + 540*D1**2*bdd1*f**2*r*s - 540*D1**2*bdd1*f**2*r + 270*D1**2*bdd1*f**2*s**2 - 540*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 + 126*D1**2*bdd1*f*g2*r**2 + 252*D1**2*bdd1*f*g2*r*s - 252*D1**2*bdd1*f*g2*r + 126*D1**2*bdd1*f*g2*s**2 - 252*D1**2*bdd1*f*g2*s + 126*D1**2*bdd1*f*g2 - 140*D1**2*f**3*fd*r**2 - 280*D1**2*f**3*fd*r*s + 210*D1**2*f**3*fd*r - 140*D1**2*f**3*fd*s**2 + 210*D1**2*f**3*fd*s - 105*D1**2*f**3*fd - 1440*D1**2*f**2*fd*r**2 - 2880*D1**2*f**2*fd*r*s + 1920*D1**2*f**2*fd*r - 1440*D1**2*f**2*fd*s**2 + 1920*D1**2*f**2*fd*s - 960*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 2520*D1**2*f**2*fdd*r*s - 1680*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1680*D1**2*f**2*fdd*s + 840*D1**2*f**2*fdd - 810*D1**2*f**2*gd2*r**2 - 1620*D1**2*f**2*gd2*r*s + 1620*D1**2*f**2*gd2*r - 810*D1**2*f**2*gd2*s**2 + 1620*D1**2*f**2*gd2*s - 810*D1**2*f**2*gd2 + 720*D1**2*f**2*gdd2*r**2 + 1440*D1**2*f**2*gdd2*r*s - 1440*D1**2*f**2*gdd2*r + 720*D1**2*f**2*gdd2*s**2 - 1440*D1**2*f**2*gdd2*s + 720*D1**2*f**2*gdd2 + 2520*D1**2*f*fd**2*r**2 + 5040*D1**2*f*fd**2*r*s - 3360*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 3360*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 1620*D1**2*f*fd*g2*r**2 - 3240*D1**2*f*fd*g2*r*s + 1620*D1**2*f*fd*g2*r - 1620*D1**2*f*fd*g2*s**2 + 1620*D1**2*f*fd*g2*s - 810*D1**2*f*fd*g2 + 2880*D1**2*f*fd*gd2*r**2 + 5760*D1**2*f*fd*gd2*r*s - 4320*D1**2*f*fd*gd2*r + 2880*D1**2*f*fd*gd2*s**2 - 4320*D1**2*f*fd*gd2*s + 1440*D1**2*f*fd*gd2 + 1440*D1**2*f*fdd*g2*r**2 + 2880*D1**2*f*fdd*g2*r*s - 1440*D1**2*f*fdd*g2*r + 1440*D1**2*f*fdd*g2*s**2 - 1440*D1**2*f*fdd*g2*s + 720*D1**2*f*fdd*g2 + 1440*D1**2*fd**2*g2*r**2 + 2880*D1**2*fd**2*g2*r*s - 1440*D1**2*fd**2*g2*r + 1440*D1**2*fd**2*g2*s**2 - 1440*D1**2*fd**2*g2*s - 140*D1*Dd*f**4*r**2 - 280*D1*Dd*f**4*r*s + 210*D1*Dd*f**4*r - 140*D1*Dd*f**4*s**2 + 210*D1*Dd*f**4*s - 105*D1*Dd*f**4 - 1920*D1*Dd*f**3*r**2 - 3840*D1*Dd*f**3*r*s + 2880*D1*Dd*f**3*r - 1920*D1*Dd*f**3*s**2 + 2880*D1*Dd*f**3*s - 1440*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 20160*D1*Dd*f**2*fd*r*s - 14280*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 14280*D1*Dd*f**2*fd*s + 5040*D1*Dd*f**2*fd - 3240*D1*Dd*f**2*g2*r**2 - 6480*D1*Dd*f**2*g2*r*s + 4860*D1*Dd*f**2*g2*r - 3240*D1*Dd*f**2*g2*s**2 + 4860*D1*Dd*f**2*g2*s - 2430*D1*Dd*f**2*g2 + 5760*D1*Dd*f**2*gd2*r**2 + 11520*D1*Dd*f**2*gd2*r*s - 10080*D1*Dd*f**2*gd2*r + 5760*D1*Dd*f**2*gd2*s**2 - 10080*D1*Dd*f**2*gd2*s + 4320*D1*Dd*f**2*gd2 + 11520*D1*Dd*f*fd*g2*r**2 + 23040*D1*Dd*f*fd*g2*r*s - 14400*D1*Dd*f*fd*g2*r + 11520*D1*Dd*f*fd*g2*s**2 - 14400*D1*Dd*f*fd*g2*s + 4320*D1*Dd*f*fd*g2 + 1680*D1*Ddd*f**3*r**2 + 3360*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 2520*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 2880*D1*Ddd*f**2*g2*r**2 + 5760*D1*Ddd*f**2*g2*r*s - 4320*D1*Ddd*f**2*g2*r + 2880*D1*Ddd*f**2*g2*s**2 - 4320*D1*Ddd*f**2*g2*s + 2160*D1*Ddd*f**2*g2 - D1*bd1*(D1*(190*f**3*(r + s - 1) - f**2*(180*C*(r + s - 1) + 280*fd*(3*r + 3*s - 2) + (405*K - 351)*(r + s - 1)) + 36*f*(5*fd*(C + 4*K - 3)*(2*r + 2*s - 1) + (7*g2 - 7*gd2)*(r + s - 1)) - 252*fd*g2*(r + s)) - 4*Dd*f*(70*f**2 - 45*f*(C + 4*K - 3) + 63*g2)*(4*r + 4*s - 3))*(r + s - 1) + 5040*Dd**2*f**3*r**2 + 10080*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 7560*Dd**2*f**3*s + 2520*Dd**2*f**3 + 8640*Dd**2*f**2*g2*r**2 + 17280*Dd**2*f**2*g2*r*s - 12960*Dd**2*f**2*g2*r + 8640*Dd**2*f**2*g2*s**2 - 12960*Dd**2*f**2*g2*s + 4320*Dd**2*f**2*g2 + 63*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(360*C*D1**2*f*fd*r**2 + 720*C*D1**2*f*fd*r*s - 360*C*D1**2*f*fd*r + 360*C*D1**2*f*fd*s**2 - 360*C*D1**2*f*fd*s + 180*C*D1**2*f*fd - 180*C*D1**2*f*fdd*r**2 - 360*C*D1**2*f*fdd*r*s + 180*C*D1**2*f*fdd*r - 180*C*D1**2*f*fdd*s**2 + 180*C*D1**2*f*fdd*s - 90*C*D1**2*f*fdd - 180*C*D1**2*fd**2*r**2 - 360*C*D1**2*fd**2*r*s + 180*C*D1**2*fd**2*r - 180*C*D1**2*fd**2*s**2 + 180*C*D1**2*fd**2*s + 720*C*D1*Dd*f**2*r**2 + 1440*C*D1*Dd*f**2*r*s - 1080*C*D1*Dd*f**2*r + 720*C*D1*Dd*f**2*s**2 - 1080*C*D1*Dd*f**2*s + 540*C*D1*Dd*f**2 - 1440*C*D1*Dd*f*fd*r**2 - 2880*C*D1*Dd*f*fd*r*s + 1800*C*D1*Dd*f*fd*r - 1440*C*D1*Dd*f*fd*s**2 + 1800*C*D1*Dd*f*fd*s - 540*C*D1*Dd*f*fd - 360*C*D1*Ddd*f**2*r**2 - 720*C*D1*Ddd*f**2*r*s + 540*C*D1*Ddd*f**2*r - 360*C*D1*Ddd*f**2*s**2 + 540*C*D1*Ddd*f**2*s - 270*C*D1*Ddd*f**2 - 1080*C*Dd**2*f**2*r**2 - 2160*C*Dd**2*f**2*r*s + 1620*C*Dd**2*f**2*r - 1080*C*Dd**2*f**2*s**2 + 1620*C*Dd**2*f**2*s - 540*C*Dd**2*f**2 + 810*D1**2*K*f*fd*r**2 + 1620*D1**2*K*f*fd*r*s - 810*D1**2*K*f*fd*r + 810*D1**2*K*f*fd*s**2 - 810*D1**2*K*f*fd*s + 405*D1**2*K*f*fd - 720*D1**2*K*f*fdd*r**2 - 1440*D1**2*K*f*fdd*r*s + 720*D1**2*K*f*fdd*r - 720*D1**2*K*f*fdd*s**2 + 720*D1**2*K*f*fdd*s - 360*D1**2*K*f*fdd - 720*D1**2*K*fd**2*r**2 - 1440*D1**2*K*fd**2*r*s + 720*D1**2*K*fd**2*r - 720*D1**2*K*fd**2*s**2 + 720*D1**2*K*fd**2*s - 126*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 570*D1**2*f**2*fd*r**2 - 1140*D1**2*f**2*fd*r*s + 760*D1**2*f**2*fd*r - 570*D1**2*f**2*fd*s**2 + 760*D1**2*f**2*fd*s - 380*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 702*D1**2*f*fd*r**2 - 1404*D1**2*f*fd*r*s + 702*D1**2*f*fd*r - 702*D1**2*f*fd*s**2 + 702*D1**2*f*fd*s - 351*D1**2*f*fd + 540*D1**2*f*fdd*r**2 + 1080*D1**2*f*fdd*r*s - 540*D1**2*f*fdd*r + 540*D1**2*f*fdd*s**2 - 540*D1**2*f*fdd*s + 270*D1**2*f*fdd - 252*D1**2*f*gd2*r**2 - 504*D1**2*f*gd2*r*s + 504*D1**2*f*gd2*r - 252*D1**2*f*gd2*s**2 + 504*D1**2*f*gd2*s - 252*D1**2*f*gd2 + 126*D1**2*f*gdd2*r**2 + 252*D1**2*f*gdd2*r*s - 252*D1**2*f*gdd2*r + 126*D1**2*f*gdd2*s**2 - 252*D1**2*f*gdd2*s + 126*D1**2*f*gdd2 + 540*D1**2*fd**2*r**2 + 1080*D1**2*fd**2*r*s - 540*D1**2*fd**2*r + 540*D1**2*fd**2*s**2 - 540*D1**2*fd**2*s - 252*D1**2*fd*g2*r**2 - 504*D1**2*fd*g2*r*s - 252*D1**2*fd*g2*s**2 + 252*D1**2*fd*gd2*r**2 + 504*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*r + 252*D1**2*fd*gd2*s**2 - 252*D1**2*fd*gd2*s + 126*D1**2*fdd*g2*r**2 + 252*D1**2*fdd*g2*r*s + 126*D1**2*fdd*g2*s**2 + 1620*D1*Dd*K*f**2*r**2 + 3240*D1*Dd*K*f**2*r*s - 2430*D1*Dd*K*f**2*r + 1620*D1*Dd*K*f**2*s**2 - 2430*D1*Dd*K*f**2*s + 1215*D1*Dd*K*f**2 - 5760*D1*Dd*K*f*fd*r**2 - 11520*D1*Dd*K*f*fd*r*s + 7200*D1*Dd*K*f*fd*r - 5760*D1*Dd*K*f*fd*s**2 + 7200*D1*Dd*K*f*fd*s - 2160*D1*Dd*K*f*fd - 760*D1*Dd*f**3*r**2 - 1520*D1*Dd*f**3*r*s + 1140*D1*Dd*f**3*r - 760*D1*Dd*f**3*s**2 + 1140*D1*Dd*f**3*s - 570*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 1404*D1*Dd*f**2*r**2 - 2808*D1*Dd*f**2*r*s + 2106*D1*Dd*f**2*r - 1404*D1*Dd*f**2*s**2 + 2106*D1*Dd*f**2*s - 1053*D1*Dd*f**2 + 4320*D1*Dd*f*fd*r**2 + 8640*D1*Dd*f*fd*r*s - 5400*D1*Dd*f*fd*r + 4320*D1*Dd*f*fd*s**2 - 5400*D1*Dd*f*fd*s + 1620*D1*Dd*f*fd - 1008*D1*Dd*f*g2*r**2 - 2016*D1*Dd*f*g2*r*s + 1512*D1*Dd*f*g2*r - 1008*D1*Dd*f*g2*s**2 + 1512*D1*Dd*f*g2*s - 756*D1*Dd*f*g2 + 1008*D1*Dd*f*gd2*r**2 + 2016*D1*Dd*f*gd2*r*s - 1764*D1*Dd*f*gd2*r + 1008*D1*Dd*f*gd2*s**2 - 1764*D1*Dd*f*gd2*s + 756*D1*Dd*f*gd2 + 1008*D1*Dd*fd*g2*r**2 + 2016*D1*Dd*fd*g2*r*s - 756*D1*Dd*fd*g2*r + 1008*D1*Dd*fd*g2*s**2 - 756*D1*Dd*fd*g2*s - 1440*D1*Ddd*K*f**2*r**2 - 2880*D1*Ddd*K*f**2*r*s + 2160*D1*Ddd*K*f**2*r - 1440*D1*Ddd*K*f**2*s**2 + 2160*D1*Ddd*K*f**2*s - 1080*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 1080*D1*Ddd*f**2*r**2 + 2160*D1*Ddd*f**2*r*s - 1620*D1*Ddd*f**2*r + 1080*D1*Ddd*f**2*s**2 - 1620*D1*Ddd*f**2*s + 810*D1*Ddd*f**2 + 504*D1*Ddd*f*g2*r**2 + 1008*D1*Ddd*f*g2*r*s - 756*D1*Ddd*f*g2*r + 504*D1*Ddd*f*g2*s**2 - 756*D1*Ddd*f*g2*s + 378*D1*Ddd*f*g2 + 252*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 4320*Dd**2*K*f**2*r**2 - 8640*Dd**2*K*f**2*r*s + 6480*Dd**2*K*f**2*r - 4320*Dd**2*K*f**2*s**2 + 6480*Dd**2*K*f**2*s - 2160*Dd**2*K*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 3240*Dd**2*f**2*r**2 + 6480*Dd**2*f**2*r*s - 4860*Dd**2*f**2*r + 3240*Dd**2*f**2*s**2 - 4860*Dd**2*f**2*s + 1620*Dd**2*f**2 + 1512*Dd**2*f*g2*r**2 + 3024*Dd**2*f*g2*r*s - 2268*Dd**2*f*g2*r + 1512*Dd**2*f*g2*s**2 - 2268*Dd**2*f*g2*s + 756*Dd**2*f*g2))/(70*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**6*k1**2*k2**2*st**2*(1980*C*D1**2*f**2*fd*r*s - 660*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd*s**2 - 1980*C*D1**2*f**2*fd*s + 660*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 2640*C*D1*Dd*f**3*r*s - 660*C*D1*Dd*f**3*r + 2640*C*D1*Dd*f**3*s**2 - 2640*C*D1*Dd*f**3*s + 660*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 1568*D1**2*f**3*fd*r*s - 392*D1**2*f**3*fd*r + 1568*D1**2*f**3*fd*s**2 - 1568*D1**2*f**3*fd*s + 392*D1**2*f**3*fd - 784*D1**2*f**3*fdd*r*s + 196*D1**2*f**3*fdd*r - 784*D1**2*f**3*fdd*s**2 + 784*D1**2*f**3*fdd*s - 196*D1**2*f**3*fdd - 2352*D1**2*f**2*fd**2*r*s + 588*D1**2*f**2*fd**2*r - 2352*D1**2*f**2*fd**2*s**2 + 2352*D1**2*f**2*fd**2*s - 392*D1**2*f**2*fd**2 - 1980*D1**2*f**2*fd*r*s + 660*D1**2*f**2*fd*r - 1980*D1**2*f**2*fd*s**2 + 1980*D1**2*f**2*fd*s - 660*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 1188*D1**2*f**2*gd2*r*s - 1188*D1**2*f**2*gd2*s**2 + 1188*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 2376*D1**2*f*fd*g2*r*s + 1188*D1**2*f*fd*g2*r - 2376*D1**2*f*fd*g2*s**2 + 2376*D1**2*f*fd*g2*s - 1188*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 1568*D1*Dd*f**4*r*s - 392*D1*Dd*f**4*r + 1568*D1*Dd*f**4*s**2 - 1568*D1*Dd*f**4*s + 392*D1*Dd*f**4 - 6272*D1*Dd*f**3*fd*r*s + 1568*D1*Dd*f**3*fd*r - 6272*D1*Dd*f**3*fd*s**2 + 6272*D1*Dd*f**3*fd*s - 1176*D1*Dd*f**3*fd - 2640*D1*Dd*f**3*r*s + 660*D1*Dd*f**3*r - 2640*D1*Dd*f**3*s**2 + 2640*D1*Dd*f**3*s - 660*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*g2*r*s + 1188*D1*Dd*f**2*g2*r - 4752*D1*Dd*f**2*g2*s**2 + 4752*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 784*D1*Ddd*f**4*r*s + 196*D1*Ddd*f**4*r - 784*D1*Ddd*f**4*s**2 + 784*D1*Ddd*f**4*s - 196*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 297*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 2352*Dd**2*f**4*r*s + 588*Dd**2*f**4*r - 2352*Dd**2*f**4*s**2 + 2352*Dd**2*f**4*s - 392*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 297*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**6*k1**2*k2**2*(450*C*D1**2*bdd1*f**2*r**2 + 1260*C*D1**2*bdd1*f**2*r*s - 360*C*D1**2*bdd1*f**2*r + 810*C*D1**2*bdd1*f**2*s**2 - 720*C*D1**2*bdd1*f**2*s + 360*C*D1**2*bdd1*f**2 + 6210*C*D1**2*f**2*fd*r**2 + 2940*C*D1**2*f**2*fd*r*s - 5120*C*D1**2*f**2*fd*r - 3270*C*D1**2*f**2*fd*s**2 + 1200*C*D1**2*f**2*fd*s + 980*C*D1**2*f**2*fd - 4590*C*D1**2*f**2*fdd*r**2 - 2820*C*D1**2*f**2*fdd*r*s + 4000*C*D1**2*f**2*fdd*r + 1770*C*D1**2*f**2*fdd*s**2 - 240*C*D1**2*f**2*fdd*s - 940*C*D1**2*f**2*fdd - 9180*C*D1**2*f*fd**2*r**2 - 5640*C*D1**2*f*fd**2*r*s + 8000*C*D1**2*f*fd**2*r + 3540*C*D1**2*f*fd**2*s**2 - 480*C*D1**2*f*fd**2*s - 940*C*D1**2*f*fd**2 + 8280*C*D1*Dd*f**3*r**2 + 3920*C*D1*Dd*f**3*r*s - 9260*C*D1*Dd*f**3*r - 4360*C*D1*Dd*f**3*s**2 + 220*C*D1*Dd*f**3*s + 3050*C*D1*Dd*f**3 - 36720*C*D1*Dd*f**2*fd*r**2 - 22560*C*D1*Dd*f**2*fd*r*s + 37180*C*D1*Dd*f**2*fd*r + 14160*C*D1*Dd*f**2*fd*s**2 + 1140*C*D1*Dd*f**2*fd*s - 7760*C*D1*Dd*f**2*fd - 6120*C*D1*Ddd*f**3*r**2 - 3760*C*D1*Ddd*f**3*r*s + 7060*C*D1*Ddd*f**3*r + 2360*C*D1*Ddd*f**3*s**2 + 700*C*D1*Ddd*f**3*s - 2470*C*D1*Ddd*f**3 - 18360*C*Dd**2*f**3*r**2 - 11280*C*Dd**2*f**3*r*s + 21180*C*Dd**2*f**3*r + 7080*C*Dd**2*f**3*s**2 + 2100*C*Dd**2*f**3*s - 4940*C*Dd**2*f**3 - 855*D1**2*K*bdd1*f**2*r**2 - 522*D1**2*K*bdd1*f**2*r*s + 1710*D1**2*K*bdd1*f**2*r + 333*D1**2*K*bdd1*f**2*s**2 + 522*D1**2*K*bdd1*f**2*s - 855*D1**2*K*bdd1*f**2 + 126*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2) + 875*D1**2*bdd1*f**3*r**2 + 1330*D1**2*bdd1*f**3*r*s - 1540*D1**2*bdd1*f**3*r + 455*D1**2*bdd1*f**3*s**2 - 1120*D1**2*bdd1*f**3*s + 840*D1**2*bdd1*f**3 + 1305*D1**2*bdd1*f**2*r**2 + 1602*D1**2*bdd1*f**2*r*s - 3150*D1**2*bdd1*f**2*r + 297*D1**2*bdd1*f**2*s**2 - 2142*D1**2*bdd1*f**2*s + 1395*D1**2*bdd1*f**2 - 630*D1**2*bdd1*f*g2*r**2 - 1764*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 1134*D1**2*bdd1*f*g2*s**2 + 1008*D1**2*bdd1*f*g2*s - 504*D1**2*bdd1*f*g2 + 2940*D1**2*f**3*fd*r**2 + 5600*D1**2*f**3*fd*r*s - 4340*D1**2*f**3*fd*r + 2660*D1**2*f**3*fd*s**2 - 4130*D1**2*f**3*fd*s + 2135*D1**2*f**3*fd - 3220*D1**2*f**3*fdd*r**2 - 5040*D1**2*f**3*fdd*r*s + 4480*D1**2*f**3*fdd*r - 1820*D1**2*f**3*fdd*s**2 + 3430*D1**2*f**3*fdd*s - 2065*D1**2*f**3*fdd - 9660*D1**2*f**2*fd**2*r**2 - 15120*D1**2*f**2*fd**2*r*s + 13440*D1**2*f**2*fd**2*r - 5460*D1**2*f**2*fd**2*s**2 + 10290*D1**2*f**2*fd**2*s - 4130*D1**2*f**2*fd**2 - 9060*D1**2*f**2*fd*r**2 - 10620*D1**2*f**2*fd*r*s + 9580*D1**2*f**2*fd*r - 1560*D1**2*f**2*fd*s**2 + 4580*D1**2*f**2*fd*s - 3540*D1**2*f**2*fd + 6690*D1**2*f**2*fdd*r**2 + 8280*D1**2*f**2*fdd*r*s - 7220*D1**2*f**2*fdd*r + 1590*D1**2*f**2*fdd*s**2 - 3820*D1**2*f**2*fdd*s + 2760*D1**2*f**2*fdd - 2034*D1**2*f**2*gd2*r**2 - 828*D1**2*f**2*gd2*r*s + 4068*D1**2*f**2*gd2*r + 1206*D1**2*f**2*gd2*s**2 + 828*D1**2*f**2*gd2*s - 2034*D1**2*f**2*gd2 + 1710*D1**2*f**2*gdd2*r**2 + 1044*D1**2*f**2*gdd2*r*s - 3420*D1**2*f**2*gdd2*r - 666*D1**2*f**2*gdd2*s**2 - 1044*D1**2*f**2*gdd2*s + 1710*D1**2*f**2*gdd2 + 13380*D1**2*f*fd**2*r**2 + 16560*D1**2*f*fd**2*r*s - 14440*D1**2*f*fd**2*r + 3180*D1**2*f*fd**2*s**2 - 7640*D1**2*f*fd**2*s + 2760*D1**2*f*fd**2 - 4068*D1**2*f*fd*g2*r**2 - 1656*D1**2*f*fd*g2*r*s + 828*D1**2*f*fd*g2*r + 2412*D1**2*f*fd*g2*s**2 - 2412*D1**2*f*fd*g2*s + 1206*D1**2*f*fd*g2 + 6840*D1**2*f*fd*gd2*r**2 + 4176*D1**2*f*fd*gd2*r*s - 7884*D1**2*f*fd*gd2*r - 2664*D1**2*f*fd*gd2*s**2 - 756*D1**2*f*fd*gd2*s + 1044*D1**2*f*fd*gd2 + 3420*D1**2*f*fdd*g2*r**2 + 2088*D1**2*f*fdd*g2*r*s - 1044*D1**2*f*fdd*g2*r - 1332*D1**2*f*fdd*g2*s**2 + 1332*D1**2*f*fdd*g2*s - 666*D1**2*f*fdd*g2 + 3420*D1**2*fd**2*g2*r**2 + 2088*D1**2*fd**2*g2*r*s - 1044*D1**2*fd**2*g2*r - 1332*D1**2*fd**2*g2*s**2 + 1332*D1**2*fd**2*g2*s + 2940*D1*Dd*f**4*r**2 + 5600*D1*Dd*f**4*r*s - 4340*D1*Dd*f**4*r + 2660*D1*Dd*f**4*s**2 - 4130*D1*Dd*f**4*s + 2135*D1*Dd*f**4 - 25760*D1*Dd*f**3*fd*r**2 - 40320*D1*Dd*f**3*fd*r*s + 35840*D1*Dd*f**3*fd*r - 14560*D1*Dd*f**3*fd*s**2 + 27440*D1*Dd*f**3*fd*s - 12390*D1*Dd*f**3*fd - 12080*D1*Dd*f**3*r**2 - 14160*D1*Dd*f**3*r*s + 15620*D1*Dd*f**3*r - 2080*D1*Dd*f**3*s**2 + 8120*D1*Dd*f**3*s - 6560*D1*Dd*f**3 + 53520*D1*Dd*f**2*fd*r**2 + 66240*D1*Dd*f**2*fd*r*s - 63920*D1*Dd*f**2*fd*r + 12720*D1*Dd*f**2*fd*s**2 - 35020*D1*Dd*f**2*fd*s + 18260*D1*Dd*f**2*fd - 8136*D1*Dd*f**2*g2*r**2 - 3312*D1*Dd*f**2*g2*r*s + 8964*D1*Dd*f**2*g2*r + 4824*D1*Dd*f**2*g2*s**2 - 756*D1*Dd*f**2*g2*s - 2862*D1*Dd*f**2*g2 + 13680*D1*Dd*f**2*gd2*r**2 + 8352*D1*Dd*f**2*gd2*r*s - 21564*D1*Dd*f**2*gd2*r - 5328*D1*Dd*f**2*gd2*s**2 - 4932*D1*Dd*f**2*gd2*s + 7884*D1*Dd*f**2*gd2 + 27360*D1*Dd*f*fd*g2*r**2 + 16704*D1*Dd*f*fd*g2*r*s - 19944*D1*Dd*f*fd*g2*r - 10656*D1*Dd*f*fd*g2*s**2 + 3816*D1*Dd*f*fd*g2*s + 756*D1*Dd*f*fd*g2 - 3220*D1*Ddd*f**4*r**2 - 5040*D1*Ddd*f**4*r*s + 4480*D1*Ddd*f**4*r - 1820*D1*Ddd*f**4*s**2 + 3430*D1*Ddd*f**4*s - 2065*D1*Ddd*f**4 + 8920*D1*Ddd*f**3*r**2 + 11040*D1*Ddd*f**3*r*s - 11680*D1*Ddd*f**3*r + 2120*D1*Ddd*f**3*s**2 - 6580*D1*Ddd*f**3*s + 4990*D1*Ddd*f**3 + 6840*D1*Ddd*f**2*g2*r**2 + 4176*D1*Ddd*f**2*g2*r*s - 7884*D1*Ddd*f**2*g2*r - 2664*D1*Ddd*f**2*g2*s**2 - 756*D1*Ddd*f**2*g2*s + 2754*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-10*f**3*(130*r**2 + 2*r*(97*s - 109) + 64*s**2 - 152*s + 123) + f**2*(-180*C*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) + 9*K*(113*r**2 + 46*r*s - 226*r - 67*s**2 - 46*s + 113) + 70*fd*(75*r**2 + r*(114*s - 113) + 39*s**2 - 83*s + 36) - 1287*r**2 - 1062*r*s + 3654*r + 225*s**2 + 2142*s - 1467) + 18*f*(fd*(20*C*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 10*s + 1) + K*(-190*r**2 - 116*r*s + 219*r + 74*s**2 + 21*s - 29) + 290*r**2 + 356*r*s - 409*r + 66*s**2 - 241*s + 139) + 14*g2*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) - 14*gd2*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2)) - 252*fd*g2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9))) + 2*Dd*f*(35*f**2*(100*r**2 + r*(152*s - 157) + 52*s**2 - 115*s + 60) + 9*f*(10*C*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8) + K*(-380*r**2 - 232*r*s + 599*r + 148*s**2 + 137*s - 219) + 580*r**2 + 712*r*s - 1079*r + 132*s**2 - 687*s + 469) - 126*g2*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8))) - 9660*Dd**2*f**4*r**2 - 15120*Dd**2*f**4*r*s + 13440*Dd**2*f**4*r - 5460*Dd**2*f**4*s**2 + 10290*Dd**2*f**4*s - 4130*Dd**2*f**4 + 26760*Dd**2*f**3*r**2 + 33120*Dd**2*f**3*r*s - 35040*Dd**2*f**3*r + 6360*Dd**2*f**3*s**2 - 19740*Dd**2*f**3*s + 9980*Dd**2*f**3 + 20520*Dd**2*f**2*g2*r**2 + 12528*Dd**2*f**2*g2*r*s - 23652*Dd**2*f**2*g2*r - 7992*Dd**2*f**2*g2*s**2 - 2268*Dd**2*f**2*g2*s + 5508*Dd**2*f**2*g2 - 63*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + D1*(2*Dd*(f*(20*r**2 + 56*r*s - 34*r + 36*s**2 - 46*s + 19) - fd*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15)) - Ddd*f*(20*r**2 + r*(56*s - 34) + 36*s**2 - 46*s + 19)) - 2*Dd**2*f*(30*r**2 + r*(84*s - 51) + 54*s**2 - 69*s + 19)) + b1*(-1800*C*D1**2*f*fd*r**2 - 5040*C*D1**2*f*fd*r*s + 3600*C*D1**2*f*fd*r - 3240*C*D1**2*f*fd*s**2 + 4320*C*D1**2*f*fd*s - 1800*C*D1**2*f*fd + 900*C*D1**2*f*fdd*r**2 + 2520*C*D1**2*f*fdd*r*s - 1800*C*D1**2*f*fdd*r + 1620*C*D1**2*f*fdd*s**2 - 2160*C*D1**2*f*fdd*s + 900*C*D1**2*f*fdd + 900*C*D1**2*fd**2*r**2 + 2520*C*D1**2*fd**2*r*s - 1800*C*D1**2*fd**2*r + 1620*C*D1**2*fd**2*s**2 - 2160*C*D1**2*fd**2*s + 900*C*D1**2*fd**2 - 3600*C*D1*Dd*f**2*r**2 - 10080*C*D1*Dd*f**2*r*s + 6120*C*D1*Dd*f**2*r - 6480*C*D1*Dd*f**2*s**2 + 8280*C*D1*Dd*f**2*s - 3420*C*D1*Dd*f**2 + 7200*C*D1*Dd*f*fd*r**2 + 20160*C*D1*Dd*f*fd*r*s - 13320*C*D1*Dd*f*fd*r + 12960*C*D1*Dd*f*fd*s**2 - 16920*C*D1*Dd*f*fd*s + 5760*C*D1*Dd*f*fd + 1800*C*D1*Ddd*f**2*r**2 + 5040*C*D1*Ddd*f**2*r*s - 3060*C*D1*Ddd*f**2*r + 3240*C*D1*Ddd*f**2*s**2 - 4140*C*D1*Ddd*f**2*s + 1710*C*D1*Ddd*f**2 + 5400*C*Dd**2*f**2*r**2 + 15120*C*Dd**2*f**2*r*s - 9180*C*Dd**2*f**2*r + 9720*C*Dd**2*f**2*s**2 - 12420*C*Dd**2*f**2*s + 3420*C*Dd**2*f**2 + 2034*D1**2*K*f*fd*r**2 + 828*D1**2*K*f*fd*r*s - 414*D1**2*K*f*fd*r - 1206*D1**2*K*f*fd*s**2 + 1206*D1**2*K*f*fd*s - 603*D1**2*K*f*fd - 1710*D1**2*K*f*fdd*r**2 - 1044*D1**2*K*f*fdd*r*s + 522*D1**2*K*f*fdd*r + 666*D1**2*K*f*fdd*s**2 - 666*D1**2*K*f*fdd*s + 333*D1**2*K*f*fdd - 1710*D1**2*K*fd**2*r**2 - 1044*D1**2*K*fd**2*r*s + 522*D1**2*K*fd**2*r + 666*D1**2*K*fd**2*s**2 - 666*D1**2*K*fd**2*s + 63*D1**2*bdd1*f*(K - 1)*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) - 3900*D1**2*f**2*fd*r**2 - 5820*D1**2*f**2*fd*r*s + 4960*D1**2*f**2*fd*r - 1920*D1**2*f**2*fd*s**2 + 3640*D1**2*f**2*fd*s - 2010*D1**2*f**2*fd + 2625*D1**2*f**2*fdd*r**2 + 3990*D1**2*f**2*fdd*r*s - 3290*D1**2*f**2*fdd*r + 1365*D1**2*f**2*fdd*s**2 - 2450*D1**2*f**2*fdd*s + 1365*D1**2*f**2*fdd + 5250*D1**2*f*fd**2*r**2 + 7980*D1**2*f*fd**2*r*s - 6580*D1**2*f*fd**2*r + 2730*D1**2*f*fd**2*s**2 - 4900*D1**2*f*fd**2*s + 1890*D1**2*f*fd**2 - 2574*D1**2*f*fd*r**2 - 2124*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 450*D1**2*f*fd*s**2 - 1530*D1**2*f*fd*s + 405*D1**2*f*fd + 2610*D1**2*f*fdd*r**2 + 3204*D1**2*f*fdd*r*s - 1062*D1**2*f*fdd*r + 594*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 207*D1**2*f*fdd + 1260*D1**2*f*gd2*r**2 + 3528*D1**2*f*gd2*r*s - 2520*D1**2*f*gd2*r + 2268*D1**2*f*gd2*s**2 - 3528*D1**2*f*gd2*s + 1260*D1**2*f*gd2 - 630*D1**2*f*gdd2*r**2 - 1764*D1**2*f*gdd2*r*s + 1260*D1**2*f*gdd2*r - 1134*D1**2*f*gdd2*s**2 + 1764*D1**2*f*gdd2*s - 630*D1**2*f*gdd2 + 2610*D1**2*fd**2*r**2 + 3204*D1**2*fd**2*r*s - 1062*D1**2*fd**2*r + 594*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s - 900*D1**2*fd**2 + 1260*D1**2*fd*g2*r**2 + 3528*D1**2*fd*g2*r*s - 2520*D1**2*fd*g2*r + 2268*D1**2*fd*g2*s**2 - 2520*D1**2*fd*g2*s + 1260*D1**2*fd*g2 - 1260*D1**2*fd*gd2*r**2 - 3528*D1**2*fd*gd2*r*s + 2520*D1**2*fd*gd2*r - 2268*D1**2*fd*gd2*s**2 + 3024*D1**2*fd*gd2*s - 1260*D1**2*fd*gd2 - 630*D1**2*fdd*g2*r**2 - 1764*D1**2*fdd*g2*r*s + 1260*D1**2*fdd*g2*r - 1134*D1**2*fdd*g2*s**2 + 1260*D1**2*fdd*g2*s - 630*D1**2*fdd*g2 + 4068*D1*Dd*K*f**2*r**2 + 1656*D1*Dd*K*f**2*r*s - 4482*D1*Dd*K*f**2*r - 2412*D1*Dd*K*f**2*s**2 + 378*D1*Dd*K*f**2*s + 1431*D1*Dd*K*f**2 - 13680*D1*Dd*K*f*fd*r**2 - 8352*D1*Dd*K*f*fd*r*s + 9972*D1*Dd*K*f*fd*r + 5328*D1*Dd*K*f*fd*s**2 - 1908*D1*Dd*K*f*fd*s - 378*D1*Dd*K*f*fd - 5200*D1*Dd*f**3*r**2 - 7760*D1*Dd*f**3*r*s + 7140*D1*Dd*f**3*r - 2560*D1*Dd*f**3*s**2 + 5160*D1*Dd*f**3*s - 3240*D1*Dd*f**3 + 21000*D1*Dd*f**2*fd*r**2 + 31920*D1*Dd*f**2*fd*r*s - 27650*D1*Dd*f**2*fd*r + 10920*D1*Dd*f**2*fd*s**2 - 20510*D1*Dd*f**2*fd*s + 9030*D1*Dd*f**2*fd - 5148*D1*Dd*f**2*r**2 - 4248*D1*Dd*f**2*r*s + 6210*D1*Dd*f**2*r + 900*D1*Dd*f**2*s**2 + 1674*D1*Dd*f**2*s - 2349*D1*Dd*f**2 + 20880*D1*Dd*f*fd*r**2 + 25632*D1*Dd*f*fd*r*s - 17892*D1*Dd*f*fd*r + 4752*D1*Dd*f*fd*s**2 - 7812*D1*Dd*f*fd*s + 2178*D1*Dd*f*fd + 5040*D1*Dd*f*g2*r**2 + 14112*D1*Dd*f*g2*r*s - 8568*D1*Dd*f*g2*r + 9072*D1*Dd*f*g2*s**2 - 11592*D1*Dd*f*g2*s + 4788*D1*Dd*f*g2 - 5040*D1*Dd*f*gd2*r**2 - 14112*D1*Dd*f*gd2*r*s + 9324*D1*Dd*f*gd2*r - 9072*D1*Dd*f*gd2*s**2 + 12852*D1*Dd*f*gd2*s - 4284*D1*Dd*f*gd2 - 5040*D1*Dd*fd*g2*r**2 - 14112*D1*Dd*fd*g2*r*s + 9324*D1*Dd*fd*g2*r - 9072*D1*Dd*fd*g2*s**2 + 10836*D1*Dd*fd*g2*s - 3780*D1*Dd*fd*g2 - 3420*D1*Ddd*K*f**2*r**2 - 2088*D1*Ddd*K*f**2*r*s + 3942*D1*Ddd*K*f**2*r + 1332*D1*Ddd*K*f**2*s**2 + 378*D1*Ddd*K*f**2*s - 1377*D1*Ddd*K*f**2 + 3500*D1*Ddd*f**3*r**2 + 5320*D1*Ddd*f**3*r*s - 4830*D1*Ddd*f**3*r + 1820*D1*Ddd*f**3*s**2 - 3570*D1*Ddd*f**3*s + 2205*D1*Ddd*f**3 + 5220*D1*Ddd*f**2*r**2 + 6408*D1*Ddd*f**2*r*s - 6822*D1*Ddd*f**2*r + 1188*D1*Ddd*f**2*s**2 - 3798*D1*Ddd*f**2*s + 2907*D1*Ddd*f**2 - 2520*D1*Ddd*f*g2*r**2 - 7056*D1*Ddd*f*g2*r*s + 4284*D1*Ddd*f*g2*r - 4536*D1*Ddd*f*g2*s**2 + 5796*D1*Ddd*f*g2*s - 2394*D1*Ddd*f*g2 - 126*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) - fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 21*s + 5)) - Dd*f*(40*r**2 + 2*r*(56*s - 31) + 72*s**2 - 90*s + 25)) - 10260*Dd**2*K*f**2*r**2 - 6264*Dd**2*K*f**2*r*s + 11826*Dd**2*K*f**2*r + 3996*Dd**2*K*f**2*s**2 + 1134*Dd**2*K*f**2*s - 2754*Dd**2*K*f**2 + 10500*Dd**2*f**3*r**2 + 15960*Dd**2*f**3*r*s - 14490*Dd**2*f**3*r + 5460*Dd**2*f**3*s**2 - 10710*Dd**2*f**3*s + 4410*Dd**2*f**3 + 15660*Dd**2*f**2*r**2 + 19224*Dd**2*f**2*r*s - 20466*Dd**2*f**2*r + 3564*Dd**2*f**2*s**2 - 11394*Dd**2*f**2*s + 5814*Dd**2*f**2 - 7560*Dd**2*f*g2*r**2 - 21168*Dd**2*f*g2*r*s + 12852*Dd**2*f*g2*r - 13608*Dd**2*f*g2*s**2 + 17388*Dd**2*f*g2*s - 4788*Dd**2*f*g2))/(630*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**6*k1**2*(-63*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(5*f**3*s*(47*r + 47*s - 33) + f**2*(-35*fd*(6*s - 1)*(4*r + 4*s - 3) + 9*s*(20*C*s + r*(20*C + 3) + 3*s - 23)) - 9*f*(5*fd*(r*(2*C + 1)*(4*s - 1) + s**2*(8*C + 4) - s*(6*C + 6) + 3) + 14*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(35*f**2*(8*s - 1)*(4*r + 4*s - 3) + 45*f*(r*(2*C + 1)*(8*s - 1) + s**2*(16*C + 8) - s*(8*C + 16) + 3) - 126*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 63*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(5*f**2*(fd*(47*r*(3*s - 1) + 141*s**2 - 155*s + 47) - 7*fdd*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4)) + f*(-35*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) + 9*fd*(20*C*(2*s - 1)*(r + s - 1) + 6*r*s - 3*r + 6*s**2 + 14*s + 3) - 45*fdd*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 + 1) - 63*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) - 45*fd**2*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 - 2) - 126*fd*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 126*fdd*g2*(s - 1)*(r + s - 1)) - 63*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(235*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(180*C*(r*(4*s - 1) + (1 - 2*s)**2) - 35*fd*(24*s - 7)*(4*r + 4*s - 3) + 27*r*(4*s - 1) + 27*(1 - 2*s)**2) - 18*f*(5*fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + r*(8*s - 3) + 8*s**2 - 4*s + 1) + 7*g2*r*(8*s - 2) + 14*g2*(1 - 2*s)**2 + 7*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 126*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(140*f**2 + f*(90*C + 45) - 126*g2)) - Dd**2*f*(140*f**2 + f*(90*C + 45) - 126*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - f*(D1**2*(35*bdd1*f**2*s*(4*r + 4*s - 3) + 45*bdd1*f*s*(2*C*r + 2*C*s + r + s - 3) - 126*bdd1*g2*s*(r + s) - 165*f*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 105*f*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 105*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 15*D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 7*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 105*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**6*k2**6*(D1**2*(f**2*(fd*(28*C - 14)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(14*C - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-9*K*(-2*bd1 + bdd1) - 36*gd2 + 18*gdd2)) + f*(-fd**2*(28*C - 14)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 18*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 18*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(14*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(7 - 14*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 18*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 18*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 9*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(14*C*f + 9*K*b1 - 7*f - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(14*C*f + 9*K*b1 - 7*f - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(14*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**6*k2**4*(-948*C*D1**2*f**2*fd*r**2 - 1368*C*D1**2*f**2*fd*r*s + 1088*C*D1**2*f**2*fd*r - 420*C*D1**2*f**2*fd*s**2 + 736*C*D1**2*f**2*fd*s - 456*C*D1**2*f**2*fd + 474*C*D1**2*f**2*fdd*r**2 + 684*C*D1**2*f**2*fdd*r*s - 544*C*D1**2*f**2*fdd*r + 210*C*D1**2*f**2*fdd*s**2 - 368*C*D1**2*f**2*fdd*s + 228*C*D1**2*f**2*fdd + 948*C*D1**2*f*fd**2*r**2 + 1368*C*D1**2*f*fd**2*r*s - 1088*C*D1**2*f*fd**2*r + 420*C*D1**2*f*fd**2*s**2 - 736*C*D1**2*f*fd**2*s + 228*C*D1**2*f*fd**2 - 1264*C*D1*Dd*f**3*r**2 - 1824*C*D1*Dd*f**3*r*s + 1720*C*D1*Dd*f**3*r - 560*C*D1*Dd*f**3*s**2 + 1192*C*D1*Dd*f**3*s - 772*C*D1*Dd*f**3 + 3792*C*D1*Dd*f**2*fd*r**2 + 5472*C*D1*Dd*f**2*fd*r*s - 4756*C*D1*Dd*f**2*fd*r + 1680*C*D1*Dd*f**2*fd*s**2 - 3260*C*D1*Dd*f**2*fd*s + 1456*C*D1*Dd*f**2*fd + 632*C*D1*Ddd*f**3*r**2 + 912*C*D1*Ddd*f**3*r*s - 860*C*D1*Ddd*f**3*r + 280*C*D1*Ddd*f**3*s**2 - 596*C*D1*Ddd*f**3*s + 386*C*D1*Ddd*f**3 + 1896*C*Dd**2*f**3*r**2 + 2736*C*Dd**2*f**3*r*s - 2580*C*Dd**2*f**3*r + 840*C*Dd**2*f**3*s**2 - 1788*C*Dd**2*f**3*s + 772*C*Dd**2*f**3 - 324*D1**2*K*b1*f*fd*r**2 - 504*D1**2*K*b1*f*fd*r*s + 252*D1**2*K*b1*f*fd*r - 180*D1**2*K*b1*f*fd*s**2 + 180*D1**2*K*b1*f*fd*s - 90*D1**2*K*b1*f*fd + 162*D1**2*K*b1*f*fdd*r**2 + 252*D1**2*K*b1*f*fdd*r*s - 126*D1**2*K*b1*f*fdd*r + 90*D1**2*K*b1*f*fdd*s**2 - 90*D1**2*K*b1*f*fdd*s + 45*D1**2*K*b1*f*fdd + 162*D1**2*K*b1*fd**2*r**2 + 252*D1**2*K*b1*fd**2*r*s - 126*D1**2*K*b1*fd**2*r + 90*D1**2*K*b1*fd**2*s**2 - 90*D1**2*K*b1*fd**2*s + 81*D1**2*K*bdd1*f**2*r**2 + 126*D1**2*K*bdd1*f**2*r*s - 162*D1**2*K*bdd1*f**2*r + 45*D1**2*K*bdd1*f**2*s**2 - 126*D1**2*K*bdd1*f**2*s + 81*D1**2*K*bdd1*f**2 + 54*D1**2*b1*f**2*fd*r**2 + 54*D1**2*b1*f**2*fd*r*s - 54*D1**2*b1*f**2*fd*r - 18*D1**2*b1*f**2*fd*s + 18*D1**2*b1*f**2*fd - 54*D1**2*b1*f**2*fdd*r**2 - 54*D1**2*b1*f**2*fdd*r*s + 54*D1**2*b1*f**2*fdd*r + 18*D1**2*b1*f**2*fdd*s - 18*D1**2*b1*f**2*fdd - 108*D1**2*b1*f*fd**2*r**2 - 108*D1**2*b1*f*fd**2*r*s + 108*D1**2*b1*f*fd**2*r + 36*D1**2*b1*f*fd**2*s - 18*D1**2*b1*f*fd**2 + 72*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 36*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 180*D1**2*b2*f*fd*r**2 - 360*D1**2*b2*f*fd*r*s + 180*D1**2*b2*f*fd*r - 180*D1**2*b2*f*fd*s**2 + 180*D1**2*b2*f*fd*s - 90*D1**2*b2*f*fd + 90*D1**2*b2*f*fdd*r**2 + 180*D1**2*b2*f*fdd*r*s - 90*D1**2*b2*f*fdd*r + 90*D1**2*b2*f*fdd*s**2 - 90*D1**2*b2*f*fdd*s + 45*D1**2*b2*f*fdd + 90*D1**2*b2*fd**2*r**2 + 180*D1**2*b2*fd**2*r*s - 90*D1**2*b2*fd**2*r + 90*D1**2*b2*fd**2*s**2 - 90*D1**2*b2*fd**2*s - 18*D1**2*bdd1*f**3*r**2 - 18*D1**2*bdd1*f**3*r*s + 36*D1**2*bdd1*f**3*r + 18*D1**2*bdd1*f**3*s - 18*D1**2*bdd1*f**3 - 18*D1**2*bdd1*f**2*r**2 - 18*D1**2*bdd1*f**2*r*s + 36*D1**2*bdd1*f**2*r + 18*D1**2*bdd1*f**2*s - 18*D1**2*bdd1*f**2 + 45*D1**2*bdd2*f**2*r**2 + 90*D1**2*bdd2*f**2*r*s - 90*D1**2*bdd2*f**2*r + 45*D1**2*bdd2*f**2*s**2 - 90*D1**2*bdd2*f**2*s + 45*D1**2*bdd2*f**2 + 606*D1**2*f**2*fd*r**2 + 816*D1**2*f**2*fd*r*s - 676*D1**2*f**2*fd*r + 210*D1**2*f**2*fd*s**2 - 412*D1**2*f**2*fd*s + 272*D1**2*f**2*fd - 303*D1**2*f**2*fdd*r**2 - 408*D1**2*f**2*fdd*r*s + 338*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 206*D1**2*f**2*fdd*s - 136*D1**2*f**2*fdd + 324*D1**2*f**2*gd2*r**2 + 504*D1**2*f**2*gd2*r*s - 648*D1**2*f**2*gd2*r + 180*D1**2*f**2*gd2*s**2 - 504*D1**2*f**2*gd2*s + 324*D1**2*f**2*gd2 - 162*D1**2*f**2*gdd2*r**2 - 252*D1**2*f**2*gdd2*r*s + 324*D1**2*f**2*gdd2*r - 90*D1**2*f**2*gdd2*s**2 + 252*D1**2*f**2*gdd2*s - 162*D1**2*f**2*gdd2 - 606*D1**2*f*fd**2*r**2 - 816*D1**2*f*fd**2*r*s + 676*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 412*D1**2*f*fd**2*s - 136*D1**2*f*fd**2 + 648*D1**2*f*fd*g2*r**2 + 1008*D1**2*f*fd*g2*r*s - 504*D1**2*f*fd*g2*r + 360*D1**2*f*fd*g2*s**2 - 360*D1**2*f*fd*g2*s + 180*D1**2*f*fd*g2 - 648*D1**2*f*fd*gd2*r**2 - 1008*D1**2*f*fd*gd2*r*s + 900*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 684*D1**2*f*fd*gd2*s - 252*D1**2*f*fd*gd2 - 324*D1**2*f*fdd*g2*r**2 - 504*D1**2*f*fdd*g2*r*s + 252*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 324*D1**2*fd**2*g2*r**2 - 504*D1**2*fd**2*g2*r*s + 252*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s - 648*D1*Dd*K*b1*f**2*r**2 - 1008*D1*Dd*K*b1*f**2*r*s + 900*D1*Dd*K*b1*f**2*r - 360*D1*Dd*K*b1*f**2*s**2 + 684*D1*Dd*K*b1*f**2*s - 414*D1*Dd*K*b1*f**2 + 1296*D1*Dd*K*b1*f*fd*r**2 + 2016*D1*Dd*K*b1*f*fd*r*s - 1404*D1*Dd*K*b1*f*fd*r + 720*D1*Dd*K*b1*f*fd*s**2 - 1044*D1*Dd*K*b1*f*fd*s + 342*D1*Dd*K*b1*f*fd + 72*D1*Dd*b1*f**3*r**2 + 72*D1*Dd*b1*f**3*r*s - 90*D1*Dd*b1*f**3*r - 36*D1*Dd*b1*f**3*s + 36*D1*Dd*b1*f**3 - 432*D1*Dd*b1*f**2*fd*r**2 - 432*D1*Dd*b1*f**2*fd*r*s + 486*D1*Dd*b1*f**2*fd*r + 180*D1*Dd*b1*f**2*fd*s - 126*D1*Dd*b1*f**2*fd + 144*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 180*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s + 72*D1*Dd*b1*f**2 - 288*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 252*D1*Dd*b1*f*fd*r + 72*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd - 360*D1*Dd*b2*f**2*r**2 - 720*D1*Dd*b2*f**2*r*s + 540*D1*Dd*b2*f**2*r - 360*D1*Dd*b2*f**2*s**2 + 540*D1*Dd*b2*f**2*s - 270*D1*Dd*b2*f**2 + 720*D1*Dd*b2*f*fd*r**2 + 1440*D1*Dd*b2*f*fd*r*s - 900*D1*Dd*b2*f*fd*r + 720*D1*Dd*b2*f*fd*s**2 - 900*D1*Dd*b2*f*fd*s + 270*D1*Dd*b2*f*fd + 808*D1*Dd*f**3*r**2 + 1088*D1*Dd*f**3*r*s - 1080*D1*Dd*f**3*r + 280*D1*Dd*f**3*s**2 - 684*D1*Dd*f**3*s + 474*D1*Dd*f**3 - 2424*D1*Dd*f**2*fd*r**2 - 3264*D1*Dd*f**2*fd*r*s + 2972*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 1850*D1*Dd*f**2*fd*s - 882*D1*Dd*f**2*fd + 1296*D1*Dd*f**2*g2*r**2 + 2016*D1*Dd*f**2*g2*r*s - 1800*D1*Dd*f**2*g2*r + 720*D1*Dd*f**2*g2*s**2 - 1368*D1*Dd*f**2*g2*s + 828*D1*Dd*f**2*g2 - 1296*D1*Dd*f**2*gd2*r**2 - 2016*D1*Dd*f**2*gd2*r*s + 2196*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 1692*D1*Dd*f**2*gd2*s - 900*D1*Dd*f**2*gd2 - 2592*D1*Dd*f*fd*g2*r**2 - 4032*D1*Dd*f*fd*g2*r*s + 2808*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 2088*D1*Dd*f*fd*g2*s - 684*D1*Dd*f*fd*g2 + 324*D1*Ddd*K*b1*f**2*r**2 + 504*D1*Ddd*K*b1*f**2*r*s - 450*D1*Ddd*K*b1*f**2*r + 180*D1*Ddd*K*b1*f**2*s**2 - 342*D1*Ddd*K*b1*f**2*s + 207*D1*Ddd*K*b1*f**2 - 72*D1*Ddd*b1*f**3*r**2 - 72*D1*Ddd*b1*f**3*r*s + 90*D1*Ddd*b1*f**3*r + 36*D1*Ddd*b1*f**3*s - 36*D1*Ddd*b1*f**3 - 72*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 90*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s - 36*D1*Ddd*b1*f**2 + 180*D1*Ddd*b2*f**2*r**2 + 360*D1*Ddd*b2*f**2*r*s - 270*D1*Ddd*b2*f**2*r + 180*D1*Ddd*b2*f**2*s**2 - 270*D1*Ddd*b2*f**2*s + 135*D1*Ddd*b2*f**2 - 404*D1*Ddd*f**3*r**2 - 544*D1*Ddd*f**3*r*s + 540*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 342*D1*Ddd*f**3*s - 237*D1*Ddd*f**3 - 648*D1*Ddd*f**2*g2*r**2 - 1008*D1*Ddd*f**2*g2*r*s + 900*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 684*D1*Ddd*f**2*g2*s - 414*D1*Ddd*f**2*g2 + 18*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (r + s - 1)*(K*(9*r + 5*s - 9) - 2*r + 2)) + fd*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(K*(36*r**2 + 56*r*s - 61*r + 20*s**2 - 47*s + 25) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) - 90*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 972*Dd**2*K*b1*f**2*r**2 + 1512*Dd**2*K*b1*f**2*r*s - 1350*Dd**2*K*b1*f**2*r + 540*Dd**2*K*b1*f**2*s**2 - 1026*Dd**2*K*b1*f**2*s + 414*Dd**2*K*b1*f**2 - 216*Dd**2*b1*f**3*r**2 - 216*Dd**2*b1*f**3*r*s + 270*Dd**2*b1*f**3*r + 108*Dd**2*b1*f**3*s - 72*Dd**2*b1*f**3 - 216*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 270*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s - 72*Dd**2*b1*f**2 + 540*Dd**2*b2*f**2*r**2 + 1080*Dd**2*b2*f**2*r*s - 810*Dd**2*b2*f**2*r + 540*Dd**2*b2*f**2*s**2 - 810*Dd**2*b2*f**2*s + 270*Dd**2*b2*f**2 - 1212*Dd**2*f**3*r**2 - 1632*Dd**2*f**3*r*s + 1620*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 1026*Dd**2*f**3*s - 474*Dd**2*f**3 - 1944*Dd**2*f**2*g2*r**2 - 3024*Dd**2*f**2*g2*r*s + 2700*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 2052*Dd**2*f**2*g2*s - 828*Dd**2*f**2*g2)/(126*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**6*k2**2*(-168*C*D1**2*f**2*fd*r*s + 56*C*D1**2*f**2*fd*r - 168*C*D1**2*f**2*fd*s**2 + 168*C*D1**2*f**2*fd*s - 56*C*D1**2*f**2*fd + 84*C*D1**2*f**2*fdd*r*s - 28*C*D1**2*f**2*fdd*r + 84*C*D1**2*f**2*fdd*s**2 - 84*C*D1**2*f**2*fdd*s + 28*C*D1**2*f**2*fdd + 168*C*D1**2*f*fd**2*r*s - 56*C*D1**2*f*fd**2*r + 168*C*D1**2*f*fd**2*s**2 - 168*C*D1**2*f*fd**2*s + 28*C*D1**2*f*fd**2 - 224*C*D1*Dd*f**3*r*s + 56*C*D1*Dd*f**3*r - 224*C*D1*Dd*f**3*s**2 + 224*C*D1*Dd*f**3*s - 56*C*D1*Dd*f**3 + 672*C*D1*Dd*f**2*fd*r*s - 196*C*D1*Dd*f**2*fd*r + 672*C*D1*Dd*f**2*fd*s**2 - 672*C*D1*Dd*f**2*fd*s + 140*C*D1*Dd*f**2*fd + 112*C*D1*Ddd*f**3*r*s - 28*C*D1*Ddd*f**3*r + 112*C*D1*Ddd*f**3*s**2 - 112*C*D1*Ddd*f**3*s + 28*C*D1*Ddd*f**3 + 336*C*Dd**2*f**3*r*s - 84*C*Dd**2*f**3*r + 336*C*Dd**2*f**3*s**2 - 336*C*Dd**2*f**3*s + 56*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r*s + 36*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r*s - 18*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r*s - 18*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s - 27*D1**2*b1*f**2*fd*r**2 - 27*D1**2*b1*f**2*fd*r*s + 27*D1**2*b1*f**2*fd*r + 9*D1**2*b1*f**2*fd*s - 9*D1**2*b1*f**2*fd + 27*D1**2*b1*f**2*fdd*r**2 + 27*D1**2*b1*f**2*fdd*r*s - 27*D1**2*b1*f**2*fdd*r - 9*D1**2*b1*f**2*fdd*s + 9*D1**2*b1*f**2*fdd + 54*D1**2*b1*f*fd**2*r**2 + 54*D1**2*b1*f*fd**2*r*s - 54*D1**2*b1*f*fd**2*r - 18*D1**2*b1*f*fd**2*s + 9*D1**2*b1*f*fd**2 - 36*D1**2*b1*f*fd*r**2 - 36*D1**2*b1*f*fd*r*s + 18*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 18*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r - 72*D1**2*b2*f*fd*r*s + 36*D1**2*b2*f*fd*r - 72*D1**2*b2*f*fd*s**2 + 72*D1**2*b2*f*fd*s - 36*D1**2*b2*f*fd + 36*D1**2*b2*f*fdd*r*s - 18*D1**2*b2*f*fdd*r + 36*D1**2*b2*f*fdd*s**2 - 36*D1**2*b2*f*fdd*s + 18*D1**2*b2*f*fdd + 36*D1**2*b2*fd**2*r*s - 18*D1**2*b2*fd**2*r + 36*D1**2*b2*fd**2*s**2 - 36*D1**2*b2*fd**2*s - 36*D1**2*bd2*f**2*r*s - 36*D1**2*bd2*f**2*s**2 + 36*D1**2*bd2*f**2*s + 72*D1**2*bd2*f*fd*r*s - 18*D1**2*bd2*f*fd*r + 72*D1**2*bd2*f*fd*s**2 - 72*D1**2*bd2*f*fd*s + 18*D1**2*bd2*f*fd + 9*D1**2*bdd1*f**2*(r + s - 1)*(2*K*s + f*(r - 1) + r - 1) + 18*D1**2*bdd2*f**2*r*s + 18*D1**2*bdd2*f**2*s**2 - 18*D1**2*bdd2*f**2*s - 66*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s + 38*D1**2*f**2*fd*r + 84*D1**2*f**2*fd*s**2 - 62*D1**2*f**2*fd*s + 6*D1**2*f**2*fd + 33*D1**2*f**2*fdd*r**2 - 9*D1**2*f**2*fdd*r*s - 19*D1**2*f**2*fdd*r - 42*D1**2*f**2*fdd*s**2 + 31*D1**2*f**2*fdd*s - 3*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r*s + 72*D1**2*f**2*gd2*s**2 - 72*D1**2*f**2*gd2*s - 36*D1**2*f**2*gdd2*r*s - 36*D1**2*f**2*gdd2*s**2 + 36*D1**2*f**2*gdd2*s + 66*D1**2*f*fd**2*r**2 - 18*D1**2*f*fd**2*r*s - 38*D1**2*f*fd**2*r - 84*D1**2*f*fd**2*s**2 + 62*D1**2*f*fd**2*s - 3*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r*s - 72*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r*s + 36*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 144*D1**2*f*fd*gd2*s - 36*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r*s + 36*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r*s + 36*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r*s + 36*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 144*D1*Dd*K*b1*f**2*s - 36*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r*s - 108*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 288*D1*Dd*K*b1*f*fd*s + 72*D1*Dd*K*b1*f*fd - 36*D1*Dd*b1*f**3*r**2 - 36*D1*Dd*b1*f**3*r*s + 45*D1*Dd*b1*f**3*r + 18*D1*Dd*b1*f**3*s - 18*D1*Dd*b1*f**3 + 216*D1*Dd*b1*f**2*fd*r**2 + 216*D1*Dd*b1*f**2*fd*r*s - 243*D1*Dd*b1*f**2*fd*r - 90*D1*Dd*b1*f**2*fd*s + 63*D1*Dd*b1*f**2*fd - 72*D1*Dd*b1*f**2*r**2 - 72*D1*Dd*b1*f**2*r*s + 90*D1*Dd*b1*f**2*r + 36*D1*Dd*b1*f**2*s - 36*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 126*D1*Dd*b1*f*fd*r - 36*D1*Dd*b1*f*fd*s + 18*D1*Dd*b1*f*fd - 144*D1*Dd*b2*f**2*r*s + 36*D1*Dd*b2*f**2*r - 144*D1*Dd*b2*f**2*s**2 + 144*D1*Dd*b2*f**2*s - 36*D1*Dd*b2*f**2 + 288*D1*Dd*b2*f*fd*r*s - 108*D1*Dd*b2*f*fd*r + 288*D1*Dd*b2*f*fd*s**2 - 288*D1*Dd*b2*f*fd*s + 72*D1*Dd*b2*f*fd + 144*D1*Dd*bd2*f**2*r*s - 18*D1*Dd*bd2*f**2*r + 144*D1*Dd*bd2*f**2*s**2 - 144*D1*Dd*bd2*f**2*s + 18*D1*Dd*bd2*f**2 - 88*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s + 82*D1*Dd*f**3*r + 112*D1*Dd*f**3*s**2 - 68*D1*Dd*f**3*s - 16*D1*Dd*f**3 + 264*D1*Dd*f**2*fd*r**2 - 72*D1*Dd*f**2*fd*r*s - 199*D1*Dd*f**2*fd*r - 336*D1*Dd*f**2*fd*s**2 + 226*D1*Dd*f**2*fd*s + 7*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r*s - 72*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 288*D1*Dd*f**2*g2*s + 72*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r*s + 36*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 288*D1*Dd*f**2*gd2*s - 36*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r*s + 216*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 576*D1*Dd*f*fd*g2*s - 144*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r*s - 18*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 72*D1*Ddd*K*b1*f**2*s + 18*D1*Ddd*K*b1*f**2 + 36*D1*Ddd*b1*f**3*r**2 + 36*D1*Ddd*b1*f**3*r*s - 45*D1*Ddd*b1*f**3*r - 18*D1*Ddd*b1*f**3*s + 18*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 45*D1*Ddd*b1*f**2*r - 18*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 + 72*D1*Ddd*b2*f**2*r*s - 18*D1*Ddd*b2*f**2*r + 72*D1*Ddd*b2*f**2*s**2 - 72*D1*Ddd*b2*f**2*s + 18*D1*Ddd*b2*f**2 + 44*D1*Ddd*f**3*r**2 - 12*D1*Ddd*f**3*r*s - 41*D1*Ddd*f**3*r - 56*D1*Ddd*f**3*s**2 + 34*D1*Ddd*f**3*s + 8*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r*s + 36*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 144*D1*Ddd*f**2*g2*s - 36*D1*Ddd*f**2*g2 - 9*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) + f*(fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + (2*r + 2*s - 2)*(2*K*s + r - 1)) - fd*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(2*K*(8*r*s - r + 8*s**2 - 8*s + 1) + f*(8*r**2 + r*(8*s - 13) - 6*s + 5) + 8*r**2 + 8*r*s - 13*r - 6*s + 5)) + 216*Dd**2*K*b1*f**2*r*s - 54*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 216*Dd**2*K*b1*f**2*s + 36*Dd**2*K*b1*f**2 + 108*Dd**2*b1*f**3*r**2 + 108*Dd**2*b1*f**3*r*s - 135*Dd**2*b1*f**3*r - 54*Dd**2*b1*f**3*s + 36*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 135*Dd**2*b1*f**2*r - 54*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 + 216*Dd**2*b2*f**2*r*s - 54*Dd**2*b2*f**2*r + 216*Dd**2*b2*f**2*s**2 - 216*Dd**2*b2*f**2*s + 36*Dd**2*b2*f**2 + 132*Dd**2*f**3*r**2 - 36*Dd**2*f**3*r*s - 123*Dd**2*f**3*r - 168*Dd**2*f**3*s**2 + 102*Dd**2*f**3*s + 16*Dd**2*f**3 - 432*Dd**2*f**2*g2*r*s + 108*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 432*Dd**2*f**2*g2*s - 72*Dd**2*f**2*g2)/(63*d**2*k3**3) - D1**2*Pk2*Pkd3*ct**5*f*k2**5*(8*C - 4)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4))/(63*d**2*k1*k3**5) + D1**2*Pk2*Pkd3*ct**5*f*k2**3*(8*C - 4)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4))/(63*d**2*k1*k3**3) + D1**2*Pk2*Pkd3*ct**5*k1**5*k2*(6600*C*D1**2*f**2*fd*r**2 + 13200*C*D1**2*f**2*fd*r*s - 8800*C*D1**2*f**2*fd*r + 6600*C*D1**2*f**2*fd*s**2 - 8800*C*D1**2*f**2*fd*s + 4400*C*D1**2*f**2*fd - 9240*C*D1**2*f**2*fdd*r**2 - 18480*C*D1**2*f**2*fdd*r*s + 12320*C*D1**2*f**2*fdd*r - 9240*C*D1**2*f**2*fdd*s**2 + 12320*C*D1**2*f**2*fdd*s - 6160*C*D1**2*f**2*fdd - 18480*C*D1**2*f*fd**2*r**2 - 36960*C*D1**2*f*fd**2*r*s + 24640*C*D1**2*f*fd**2*r - 18480*C*D1**2*f*fd**2*s**2 + 24640*C*D1**2*f*fd**2*s - 6160*C*D1**2*f*fd**2 + 8800*C*D1*Dd*f**3*r**2 + 17600*C*D1*Dd*f**3*r*s - 13200*C*D1*Dd*f**3*r + 8800*C*D1*Dd*f**3*s**2 - 13200*C*D1*Dd*f**3*s + 6600*C*D1*Dd*f**3 - 73920*C*D1*Dd*f**2*fd*r**2 - 147840*C*D1*Dd*f**2*fd*r*s + 104720*C*D1*Dd*f**2*fd*r - 73920*C*D1*Dd*f**2*fd*s**2 + 104720*C*D1*Dd*f**2*fd*s - 36960*C*D1*Dd*f**2*fd - 12320*C*D1*Ddd*f**3*r**2 - 24640*C*D1*Ddd*f**3*r*s + 18480*C*D1*Ddd*f**3*r - 12320*C*D1*Ddd*f**3*s**2 + 18480*C*D1*Ddd*f**3*s - 9240*C*D1*Ddd*f**3 - 36960*C*Dd**2*f**3*r**2 - 73920*C*Dd**2*f**3*r*s + 55440*C*Dd**2*f**3*r - 36960*C*Dd**2*f**3*s**2 + 55440*C*Dd**2*f**3*s - 18480*C*Dd**2*f**3 + 2376*D1**2*K*b1*f*fd*r**2 + 4752*D1**2*K*b1*f*fd*r*s - 2376*D1**2*K*b1*f*fd*r + 2376*D1**2*K*b1*f*fd*s**2 - 2376*D1**2*K*b1*f*fd*s + 1188*D1**2*K*b1*f*fd - 3960*D1**2*K*b1*f*fdd*r**2 - 7920*D1**2*K*b1*f*fdd*r*s + 3960*D1**2*K*b1*f*fdd*r - 3960*D1**2*K*b1*f*fdd*s**2 + 3960*D1**2*K*b1*f*fdd*s - 1980*D1**2*K*b1*f*fdd - 3960*D1**2*K*b1*fd**2*r**2 - 7920*D1**2*K*b1*fd**2*r*s + 3960*D1**2*K*b1*fd**2*r - 3960*D1**2*K*b1*fd**2*s**2 + 3960*D1**2*K*b1*fd**2*s - 2376*D1**2*b1*f*fd*r**2 - 4752*D1**2*b1*f*fd*r*s + 2376*D1**2*b1*f*fd*r - 2376*D1**2*b1*f*fd*s**2 + 2376*D1**2*b1*f*fd*s - 1188*D1**2*b1*f*fd + 3960*D1**2*b1*f*fdd*r**2 + 7920*D1**2*b1*f*fdd*r*s - 3960*D1**2*b1*f*fdd*r + 3960*D1**2*b1*f*fdd*s**2 - 3960*D1**2*b1*f*fdd*s + 1980*D1**2*b1*f*fdd + 3960*D1**2*b1*fd**2*r**2 + 7920*D1**2*b1*fd**2*r*s - 3960*D1**2*b1*fd**2*r + 3960*D1**2*b1*fd**2*s**2 - 3960*D1**2*b1*fd**2*s - 1980*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 11340*D1**2*f**3*fd*r**2 + 22680*D1**2*f**3*fd*r*s - 17010*D1**2*f**3*fd*r + 11340*D1**2*f**3*fd*s**2 - 17010*D1**2*f**3*fd*s + 8505*D1**2*f**3*fd - 12600*D1**2*f**3*fdd*r**2 - 25200*D1**2*f**3*fdd*r*s + 18900*D1**2*f**3*fdd*r - 12600*D1**2*f**3*fdd*s**2 + 18900*D1**2*f**3*fdd*s - 9450*D1**2*f**3*fdd - 37800*D1**2*f**2*fd**2*r**2 - 75600*D1**2*f**2*fd**2*r*s + 56700*D1**2*f**2*fd**2*r - 37800*D1**2*f**2*fd**2*s**2 + 56700*D1**2*f**2*fd**2*s - 18900*D1**2*f**2*fd**2 - 6600*D1**2*f**2*fd*r**2 - 13200*D1**2*f**2*fd*r*s + 8800*D1**2*f**2*fd*r - 6600*D1**2*f**2*fd*s**2 + 8800*D1**2*f**2*fd*s - 4400*D1**2*f**2*fd + 9240*D1**2*f**2*fdd*r**2 + 18480*D1**2*f**2*fdd*r*s - 12320*D1**2*f**2*fdd*r + 9240*D1**2*f**2*fdd*s**2 - 12320*D1**2*f**2*fdd*s + 6160*D1**2*f**2*fdd - 2376*D1**2*f**2*gd2*r**2 - 4752*D1**2*f**2*gd2*r*s + 4752*D1**2*f**2*gd2*r - 2376*D1**2*f**2*gd2*s**2 + 4752*D1**2*f**2*gd2*s - 2376*D1**2*f**2*gd2 + 3960*D1**2*f**2*gdd2*r**2 + 7920*D1**2*f**2*gdd2*r*s - 7920*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 7920*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 + 18480*D1**2*f*fd**2*r**2 + 36960*D1**2*f*fd**2*r*s - 24640*D1**2*f*fd**2*r + 18480*D1**2*f*fd**2*s**2 - 24640*D1**2*f*fd**2*s + 6160*D1**2*f*fd**2 - 4752*D1**2*f*fd*g2*r**2 - 9504*D1**2*f*fd*g2*r*s + 4752*D1**2*f*fd*g2*r - 4752*D1**2*f*fd*g2*s**2 + 4752*D1**2*f*fd*g2*s - 2376*D1**2*f*fd*g2 + 15840*D1**2*f*fd*gd2*r**2 + 31680*D1**2*f*fd*gd2*r*s - 23760*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 23760*D1**2*f*fd*gd2*s + 7920*D1**2*f*fd*gd2 + 7920*D1**2*f*fdd*g2*r**2 + 15840*D1**2*f*fdd*g2*r*s - 7920*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 7920*D1**2*f*fdd*g2*s + 3960*D1**2*f*fdd*g2 + 7920*D1**2*fd**2*g2*r**2 + 15840*D1**2*fd**2*g2*r*s - 7920*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 7920*D1**2*fd**2*g2*s + 4752*D1*Dd*K*b1*f**2*r**2 + 9504*D1*Dd*K*b1*f**2*r*s - 7128*D1*Dd*K*b1*f**2*r + 4752*D1*Dd*K*b1*f**2*s**2 - 7128*D1*Dd*K*b1*f**2*s + 3564*D1*Dd*K*b1*f**2 - 31680*D1*Dd*K*b1*f*fd*r**2 - 63360*D1*Dd*K*b1*f*fd*r*s + 39600*D1*Dd*K*b1*f*fd*r - 31680*D1*Dd*K*b1*f*fd*s**2 + 39600*D1*Dd*K*b1*f*fd*s - 11880*D1*Dd*K*b1*f*fd - 4752*D1*Dd*b1*f**2*r**2 - 9504*D1*Dd*b1*f**2*r*s + 7128*D1*Dd*b1*f**2*r - 4752*D1*Dd*b1*f**2*s**2 + 7128*D1*Dd*b1*f**2*s - 3564*D1*Dd*b1*f**2 + 31680*D1*Dd*b1*f*fd*r**2 + 63360*D1*Dd*b1*f*fd*r*s - 39600*D1*Dd*b1*f*fd*r + 31680*D1*Dd*b1*f*fd*s**2 - 39600*D1*Dd*b1*f*fd*s + 11880*D1*Dd*b1*f*fd + 11340*D1*Dd*f**4*r**2 + 22680*D1*Dd*f**4*r*s - 17010*D1*Dd*f**4*r + 11340*D1*Dd*f**4*s**2 - 17010*D1*Dd*f**4*s + 8505*D1*Dd*f**4 - 100800*D1*Dd*f**3*fd*r**2 - 201600*D1*Dd*f**3*fd*r*s + 151200*D1*Dd*f**3*fd*r - 100800*D1*Dd*f**3*fd*s**2 + 151200*D1*Dd*f**3*fd*s - 56700*D1*Dd*f**3*fd - 8800*D1*Dd*f**3*r**2 - 17600*D1*Dd*f**3*r*s + 13200*D1*Dd*f**3*r - 8800*D1*Dd*f**3*s**2 + 13200*D1*Dd*f**3*s - 6600*D1*Dd*f**3 + 73920*D1*Dd*f**2*fd*r**2 + 147840*D1*Dd*f**2*fd*r*s - 104720*D1*Dd*f**2*fd*r + 73920*D1*Dd*f**2*fd*s**2 - 104720*D1*Dd*f**2*fd*s + 36960*D1*Dd*f**2*fd - 9504*D1*Dd*f**2*g2*r**2 - 19008*D1*Dd*f**2*g2*r*s + 14256*D1*Dd*f**2*g2*r - 9504*D1*Dd*f**2*g2*s**2 + 14256*D1*Dd*f**2*g2*s - 7128*D1*Dd*f**2*g2 + 31680*D1*Dd*f**2*gd2*r**2 + 63360*D1*Dd*f**2*gd2*r*s - 55440*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 55440*D1*Dd*f**2*gd2*s + 23760*D1*Dd*f**2*gd2 + 63360*D1*Dd*f*fd*g2*r**2 + 126720*D1*Dd*f*fd*g2*r*s - 79200*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 79200*D1*Dd*f*fd*g2*s + 23760*D1*Dd*f*fd*g2 - 7920*D1*Ddd*K*b1*f**2*r**2 - 15840*D1*Ddd*K*b1*f**2*r*s + 11880*D1*Ddd*K*b1*f**2*r - 7920*D1*Ddd*K*b1*f**2*s**2 + 11880*D1*Ddd*K*b1*f**2*s - 5940*D1*Ddd*K*b1*f**2 + 7920*D1*Ddd*b1*f**2*r**2 + 15840*D1*Ddd*b1*f**2*r*s - 11880*D1*Ddd*b1*f**2*r + 7920*D1*Ddd*b1*f**2*s**2 - 11880*D1*Ddd*b1*f**2*s + 5940*D1*Ddd*b1*f**2 - 12600*D1*Ddd*f**4*r**2 - 25200*D1*Ddd*f**4*r*s + 18900*D1*Ddd*f**4*r - 12600*D1*Ddd*f**4*s**2 + 18900*D1*Ddd*f**4*s - 9450*D1*Ddd*f**4 + 12320*D1*Ddd*f**3*r**2 + 24640*D1*Ddd*f**3*r*s - 18480*D1*Ddd*f**3*r + 12320*D1*Ddd*f**3*s**2 - 18480*D1*Ddd*f**3*s + 9240*D1*Ddd*f**3 + 15840*D1*Ddd*f**2*g2*r**2 + 31680*D1*Ddd*f**2*g2*r*s - 23760*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 23760*D1*Ddd*f**2*g2*s + 11880*D1*Ddd*f**2*g2 + 396*D1*bd1*f*(K - 1)*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 23760*Dd**2*K*b1*f**2*r**2 - 47520*Dd**2*K*b1*f**2*r*s + 35640*Dd**2*K*b1*f**2*r - 23760*Dd**2*K*b1*f**2*s**2 + 35640*Dd**2*K*b1*f**2*s - 11880*Dd**2*K*b1*f**2 + 23760*Dd**2*b1*f**2*r**2 + 47520*Dd**2*b1*f**2*r*s - 35640*Dd**2*b1*f**2*r + 23760*Dd**2*b1*f**2*s**2 - 35640*Dd**2*b1*f**2*s + 11880*Dd**2*b1*f**2 - 37800*Dd**2*f**4*r**2 - 75600*Dd**2*f**4*r*s + 56700*Dd**2*f**4*r - 37800*Dd**2*f**4*s**2 + 56700*Dd**2*f**4*s - 18900*Dd**2*f**4 + 36960*Dd**2*f**3*r**2 + 73920*Dd**2*f**3*r*s - 55440*Dd**2*f**3*r + 36960*Dd**2*f**3*s**2 - 55440*Dd**2*f**3*s + 18480*Dd**2*f**3 + 47520*Dd**2*f**2*g2*r**2 + 95040*Dd**2*f**2*g2*r*s - 71280*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 71280*Dd**2*f**2*g2*s + 23760*Dd**2*f**2*g2)/(770*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**5*k1**5*(1650*C*D1**2*f**2*fd*r*s - 550*C*D1**2*f**2*fd*r + 1650*C*D1**2*f**2*fd*s**2 - 1650*C*D1**2*f**2*fd*s + 550*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r*s + 770*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 2310*C*D1**2*f**2*fdd*s - 770*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r*s + 1540*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 4620*C*D1**2*f*fd**2*s - 770*C*D1**2*f*fd**2 + 2200*C*D1*Dd*f**3*r*s - 550*C*D1*Dd*f**3*r + 2200*C*D1*Dd*f**3*s**2 - 2200*C*D1*Dd*f**3*s + 550*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r*s + 5390*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 18480*C*D1*Dd*f**2*fd*s - 3850*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r*s + 770*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 3080*C*D1*Ddd*f**3*s - 770*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r*s + 2310*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 9240*C*Dd**2*f**3*s - 1540*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 5460*D1**2*f**3*fd*r*s - 1365*D1**2*f**3*fd*r + 5460*D1**2*f**3*fd*s**2 - 5460*D1**2*f**3*fd*s + 1365*D1**2*f**3*fd - 5040*D1**2*f**3*fdd*r*s + 1260*D1**2*f**3*fdd*r - 5040*D1**2*f**3*fdd*s**2 + 5040*D1**2*f**3*fdd*s - 1260*D1**2*f**3*fdd - 15120*D1**2*f**2*fd**2*r*s + 3780*D1**2*f**2*fd**2*r - 15120*D1**2*f**2*fd**2*s**2 + 15120*D1**2*f**2*fd**2*s - 2520*D1**2*f**2*fd**2 - 1650*D1**2*f**2*fd*r*s + 550*D1**2*f**2*fd*r - 1650*D1**2*f**2*fd*s**2 + 1650*D1**2*f**2*fd*s - 550*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r*s - 770*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2310*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd - 594*D1**2*f**2*gd2*r*s - 594*D1**2*f**2*gd2*s**2 + 594*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 4620*D1**2*f*fd**2*r*s - 1540*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 4620*D1**2*f*fd**2*s + 770*D1**2*f*fd**2 - 1188*D1**2*f*fd*g2*r*s + 594*D1**2*f*fd*g2*r - 1188*D1**2*f*fd*g2*s**2 + 1188*D1**2*f*fd*g2*s - 594*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 5460*D1*Dd*f**4*r*s - 1365*D1*Dd*f**4*r + 5460*D1*Dd*f**4*s**2 - 5460*D1*Dd*f**4*s + 1365*D1*Dd*f**4 - 40320*D1*Dd*f**3*fd*r*s + 10080*D1*Dd*f**3*fd*r - 40320*D1*Dd*f**3*fd*s**2 + 40320*D1*Dd*f**3*fd*s - 7560*D1*Dd*f**3*fd - 2200*D1*Dd*f**3*r*s + 550*D1*Dd*f**3*r - 2200*D1*Dd*f**3*s**2 + 2200*D1*Dd*f**3*s - 550*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r*s - 5390*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 18480*D1*Dd*f**2*fd*s + 3850*D1*Dd*f**2*fd - 2376*D1*Dd*f**2*g2*r*s + 594*D1*Dd*f**2*g2*r - 2376*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 594*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 5040*D1*Ddd*f**4*r*s + 1260*D1*Ddd*f**4*r - 5040*D1*Ddd*f**4*s**2 + 5040*D1*Ddd*f**4*s - 1260*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r*s - 770*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 3080*D1*Ddd*f**3*s + 770*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(3*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 15120*Dd**2*f**4*r*s + 3780*Dd**2*f**4*r - 15120*Dd**2*f**4*s**2 + 15120*Dd**2*f**4*s - 2520*Dd**2*f**4 + 9240*Dd**2*f**3*r*s - 2310*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 9240*Dd**2*f**3*s + 1540*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(3*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(3*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k2*k3**5) + D1**2*Pk2*Pkd3*ct**5*k1**3*k2**3*st**2*(19272*C*D1**2*f**2*fd*r**2 + 38544*C*D1**2*f**2*fd*r*s - 25696*C*D1**2*f**2*fd*r + 19272*C*D1**2*f**2*fd*s**2 - 25696*C*D1**2*f**2*fd*s + 12848*C*D1**2*f**2*fd - 13200*C*D1**2*f**2*fdd*r**2 - 26400*C*D1**2*f**2*fdd*r*s + 17600*C*D1**2*f**2*fdd*r - 13200*C*D1**2*f**2*fdd*s**2 + 17600*C*D1**2*f**2*fdd*s - 8800*C*D1**2*f**2*fdd - 26400*C*D1**2*f*fd**2*r**2 - 52800*C*D1**2*f*fd**2*r*s + 35200*C*D1**2*f*fd**2*r - 26400*C*D1**2*f*fd**2*s**2 + 35200*C*D1**2*f*fd**2*s - 8800*C*D1**2*f*fd**2 + 25696*C*D1*Dd*f**3*r**2 + 51392*C*D1*Dd*f**3*r*s - 38544*C*D1*Dd*f**3*r + 25696*C*D1*Dd*f**3*s**2 - 38544*C*D1*Dd*f**3*s + 19272*C*D1*Dd*f**3 - 105600*C*D1*Dd*f**2*fd*r**2 - 211200*C*D1*Dd*f**2*fd*r*s + 149600*C*D1*Dd*f**2*fd*r - 105600*C*D1*Dd*f**2*fd*s**2 + 149600*C*D1*Dd*f**2*fd*s - 52800*C*D1*Dd*f**2*fd - 17600*C*D1*Ddd*f**3*r**2 - 35200*C*D1*Ddd*f**3*r*s + 26400*C*D1*Ddd*f**3*r - 17600*C*D1*Ddd*f**3*s**2 + 26400*C*D1*Ddd*f**3*s - 13200*C*D1*Ddd*f**3 - 52800*C*Dd**2*f**3*r**2 - 105600*C*Dd**2*f**3*r*s + 79200*C*Dd**2*f**3*r - 52800*C*Dd**2*f**3*s**2 + 79200*C*Dd**2*f**3*s - 26400*C*Dd**2*f**3 + 10296*D1**2*K*b1*f*fd*r**2 + 20592*D1**2*K*b1*f*fd*r*s - 10296*D1**2*K*b1*f*fd*r + 10296*D1**2*K*b1*f*fd*s**2 - 10296*D1**2*K*b1*f*fd*s + 5148*D1**2*K*b1*f*fd - 7920*D1**2*K*b1*f*fdd*r**2 - 15840*D1**2*K*b1*f*fdd*r*s + 7920*D1**2*K*b1*f*fdd*r - 7920*D1**2*K*b1*f*fdd*s**2 + 7920*D1**2*K*b1*f*fdd*s - 3960*D1**2*K*b1*f*fdd - 7920*D1**2*K*b1*fd**2*r**2 - 15840*D1**2*K*b1*fd**2*r*s + 7920*D1**2*K*b1*fd**2*r - 7920*D1**2*K*b1*fd**2*s**2 + 7920*D1**2*K*b1*fd**2*s - 10296*D1**2*b1*f*fd*r**2 - 20592*D1**2*b1*f*fd*r*s + 10296*D1**2*b1*f*fd*r - 10296*D1**2*b1*f*fd*s**2 + 10296*D1**2*b1*f*fd*s - 5148*D1**2*b1*f*fd + 7920*D1**2*b1*f*fdd*r**2 + 15840*D1**2*b1*f*fdd*r*s - 7920*D1**2*b1*f*fdd*r + 7920*D1**2*b1*f*fdd*s**2 - 7920*D1**2*b1*f*fdd*s + 3960*D1**2*b1*f*fdd + 7920*D1**2*b1*fd**2*r**2 + 15840*D1**2*b1*fd**2*r*s - 7920*D1**2*b1*fd**2*r + 7920*D1**2*b1*fd**2*s**2 - 7920*D1**2*b1*fd**2*s - 3960*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 22800*D1**2*f**3*fd*r**2 + 45600*D1**2*f**3*fd*r*s - 34200*D1**2*f**3*fd*r + 22800*D1**2*f**3*fd*s**2 - 34200*D1**2*f**3*fd*s + 17100*D1**2*f**3*fd - 14700*D1**2*f**3*fdd*r**2 - 29400*D1**2*f**3*fdd*r*s + 22050*D1**2*f**3*fdd*r - 14700*D1**2*f**3*fdd*s**2 + 22050*D1**2*f**3*fdd*s - 11025*D1**2*f**3*fdd - 44100*D1**2*f**2*fd**2*r**2 - 88200*D1**2*f**2*fd**2*r*s + 66150*D1**2*f**2*fd**2*r - 44100*D1**2*f**2*fd**2*s**2 + 66150*D1**2*f**2*fd**2*s - 22050*D1**2*f**2*fd**2 - 19272*D1**2*f**2*fd*r**2 - 38544*D1**2*f**2*fd*r*s + 25696*D1**2*f**2*fd*r - 19272*D1**2*f**2*fd*s**2 + 25696*D1**2*f**2*fd*s - 12848*D1**2*f**2*fd + 13200*D1**2*f**2*fdd*r**2 + 26400*D1**2*f**2*fdd*r*s - 17600*D1**2*f**2*fdd*r + 13200*D1**2*f**2*fdd*s**2 - 17600*D1**2*f**2*fdd*s + 8800*D1**2*f**2*fdd - 10296*D1**2*f**2*gd2*r**2 - 20592*D1**2*f**2*gd2*r*s + 20592*D1**2*f**2*gd2*r - 10296*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s - 10296*D1**2*f**2*gd2 + 7920*D1**2*f**2*gdd2*r**2 + 15840*D1**2*f**2*gdd2*r*s - 15840*D1**2*f**2*gdd2*r + 7920*D1**2*f**2*gdd2*s**2 - 15840*D1**2*f**2*gdd2*s + 7920*D1**2*f**2*gdd2 + 26400*D1**2*f*fd**2*r**2 + 52800*D1**2*f*fd**2*r*s - 35200*D1**2*f*fd**2*r + 26400*D1**2*f*fd**2*s**2 - 35200*D1**2*f*fd**2*s + 8800*D1**2*f*fd**2 - 20592*D1**2*f*fd*g2*r**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 20592*D1**2*f*fd*g2*s**2 + 20592*D1**2*f*fd*g2*s - 10296*D1**2*f*fd*g2 + 31680*D1**2*f*fd*gd2*r**2 + 63360*D1**2*f*fd*gd2*r*s - 47520*D1**2*f*fd*gd2*r + 31680*D1**2*f*fd*gd2*s**2 - 47520*D1**2*f*fd*gd2*s + 15840*D1**2*f*fd*gd2 + 15840*D1**2*f*fdd*g2*r**2 + 31680*D1**2*f*fdd*g2*r*s - 15840*D1**2*f*fdd*g2*r + 15840*D1**2*f*fdd*g2*s**2 - 15840*D1**2*f*fdd*g2*s + 7920*D1**2*f*fdd*g2 + 15840*D1**2*fd**2*g2*r**2 + 31680*D1**2*fd**2*g2*r*s - 15840*D1**2*fd**2*g2*r + 15840*D1**2*fd**2*g2*s**2 - 15840*D1**2*fd**2*g2*s + 20592*D1*Dd*K*b1*f**2*r**2 + 41184*D1*Dd*K*b1*f**2*r*s - 30888*D1*Dd*K*b1*f**2*r + 20592*D1*Dd*K*b1*f**2*s**2 - 30888*D1*Dd*K*b1*f**2*s + 15444*D1*Dd*K*b1*f**2 - 63360*D1*Dd*K*b1*f*fd*r**2 - 126720*D1*Dd*K*b1*f*fd*r*s + 79200*D1*Dd*K*b1*f*fd*r - 63360*D1*Dd*K*b1*f*fd*s**2 + 79200*D1*Dd*K*b1*f*fd*s - 23760*D1*Dd*K*b1*f*fd - 20592*D1*Dd*b1*f**2*r**2 - 41184*D1*Dd*b1*f**2*r*s + 30888*D1*Dd*b1*f**2*r - 20592*D1*Dd*b1*f**2*s**2 + 30888*D1*Dd*b1*f**2*s - 15444*D1*Dd*b1*f**2 + 63360*D1*Dd*b1*f*fd*r**2 + 126720*D1*Dd*b1*f*fd*r*s - 79200*D1*Dd*b1*f*fd*r + 63360*D1*Dd*b1*f*fd*s**2 - 79200*D1*Dd*b1*f*fd*s + 23760*D1*Dd*b1*f*fd + 22800*D1*Dd*f**4*r**2 + 45600*D1*Dd*f**4*r*s - 34200*D1*Dd*f**4*r + 22800*D1*Dd*f**4*s**2 - 34200*D1*Dd*f**4*s + 17100*D1*Dd*f**4 - 117600*D1*Dd*f**3*fd*r**2 - 235200*D1*Dd*f**3*fd*r*s + 176400*D1*Dd*f**3*fd*r - 117600*D1*Dd*f**3*fd*s**2 + 176400*D1*Dd*f**3*fd*s - 66150*D1*Dd*f**3*fd - 25696*D1*Dd*f**3*r**2 - 51392*D1*Dd*f**3*r*s + 38544*D1*Dd*f**3*r - 25696*D1*Dd*f**3*s**2 + 38544*D1*Dd*f**3*s - 19272*D1*Dd*f**3 + 105600*D1*Dd*f**2*fd*r**2 + 211200*D1*Dd*f**2*fd*r*s - 149600*D1*Dd*f**2*fd*r + 105600*D1*Dd*f**2*fd*s**2 - 149600*D1*Dd*f**2*fd*s + 52800*D1*Dd*f**2*fd - 41184*D1*Dd*f**2*g2*r**2 - 82368*D1*Dd*f**2*g2*r*s + 61776*D1*Dd*f**2*g2*r - 41184*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 30888*D1*Dd*f**2*g2 + 63360*D1*Dd*f**2*gd2*r**2 + 126720*D1*Dd*f**2*gd2*r*s - 110880*D1*Dd*f**2*gd2*r + 63360*D1*Dd*f**2*gd2*s**2 - 110880*D1*Dd*f**2*gd2*s + 47520*D1*Dd*f**2*gd2 + 126720*D1*Dd*f*fd*g2*r**2 + 253440*D1*Dd*f*fd*g2*r*s - 158400*D1*Dd*f*fd*g2*r + 126720*D1*Dd*f*fd*g2*s**2 - 158400*D1*Dd*f*fd*g2*s + 47520*D1*Dd*f*fd*g2 - 15840*D1*Ddd*K*b1*f**2*r**2 - 31680*D1*Ddd*K*b1*f**2*r*s + 23760*D1*Ddd*K*b1*f**2*r - 15840*D1*Ddd*K*b1*f**2*s**2 + 23760*D1*Ddd*K*b1*f**2*s - 11880*D1*Ddd*K*b1*f**2 + 15840*D1*Ddd*b1*f**2*r**2 + 31680*D1*Ddd*b1*f**2*r*s - 23760*D1*Ddd*b1*f**2*r + 15840*D1*Ddd*b1*f**2*s**2 - 23760*D1*Ddd*b1*f**2*s + 11880*D1*Ddd*b1*f**2 - 14700*D1*Ddd*f**4*r**2 - 29400*D1*Ddd*f**4*r*s + 22050*D1*Ddd*f**4*r - 14700*D1*Ddd*f**4*s**2 + 22050*D1*Ddd*f**4*s - 11025*D1*Ddd*f**4 + 17600*D1*Ddd*f**3*r**2 + 35200*D1*Ddd*f**3*r*s - 26400*D1*Ddd*f**3*r + 17600*D1*Ddd*f**3*s**2 - 26400*D1*Ddd*f**3*s + 13200*D1*Ddd*f**3 + 31680*D1*Ddd*f**2*g2*r**2 + 63360*D1*Ddd*f**2*g2*r*s - 47520*D1*Ddd*f**2*g2*r + 31680*D1*Ddd*f**2*g2*s**2 - 47520*D1*Ddd*f**2*g2*s + 23760*D1*Ddd*f**2*g2 + 396*D1*bd1*f*(K - 1)*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 47520*Dd**2*K*b1*f**2*r**2 - 95040*Dd**2*K*b1*f**2*r*s + 71280*Dd**2*K*b1*f**2*r - 47520*Dd**2*K*b1*f**2*s**2 + 71280*Dd**2*K*b1*f**2*s - 23760*Dd**2*K*b1*f**2 + 47520*Dd**2*b1*f**2*r**2 + 95040*Dd**2*b1*f**2*r*s - 71280*Dd**2*b1*f**2*r + 47520*Dd**2*b1*f**2*s**2 - 71280*Dd**2*b1*f**2*s + 23760*Dd**2*b1*f**2 - 44100*Dd**2*f**4*r**2 - 88200*Dd**2*f**4*r*s + 66150*Dd**2*f**4*r - 44100*Dd**2*f**4*s**2 + 66150*Dd**2*f**4*s - 22050*Dd**2*f**4 + 52800*Dd**2*f**3*r**2 + 105600*Dd**2*f**3*r*s - 79200*Dd**2*f**3*r + 52800*Dd**2*f**3*s**2 - 79200*Dd**2*f**3*s + 26400*Dd**2*f**3 + 95040*Dd**2*f**2*g2*r**2 + 190080*Dd**2*f**2*g2*r*s - 142560*Dd**2*f**2*g2*r + 95040*Dd**2*f**2*g2*s**2 - 142560*Dd**2*f**2*g2*s + 47520*Dd**2*f**2*g2)/(770*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**5*k1**3*k2**3*(-360*C*D1**2*bdd1*f**2*r**2 - 720*C*D1**2*bdd1*f**2*r*s + 720*C*D1**2*bdd1*f**2*r - 360*C*D1**2*bdd1*f**2*s**2 + 720*C*D1**2*bdd1*f**2*s - 360*C*D1**2*bdd1*f**2 + 1800*C*D1**2*f**2*fd*r**2 + 3600*C*D1**2*f**2*fd*r*s - 2400*C*D1**2*f**2*fd*r + 1800*C*D1**2*f**2*fd*s**2 - 2400*C*D1**2*f**2*fd*s + 1200*C*D1**2*f**2*fd - 2520*C*D1**2*f**2*fdd*r**2 - 5040*C*D1**2*f**2*fdd*r*s + 3360*C*D1**2*f**2*fdd*r - 2520*C*D1**2*f**2*fdd*s**2 + 3360*C*D1**2*f**2*fdd*s - 1680*C*D1**2*f**2*fdd - 5040*C*D1**2*f*fd**2*r**2 - 10080*C*D1**2*f*fd**2*r*s + 6720*C*D1**2*f*fd**2*r - 5040*C*D1**2*f*fd**2*s**2 + 6720*C*D1**2*f*fd**2*s - 1680*C*D1**2*f*fd**2 + 2400*C*D1*Dd*f**3*r**2 + 4800*C*D1*Dd*f**3*r*s - 3600*C*D1*Dd*f**3*r + 2400*C*D1*Dd*f**3*s**2 - 3600*C*D1*Dd*f**3*s + 1800*C*D1*Dd*f**3 - 20160*C*D1*Dd*f**2*fd*r**2 - 40320*C*D1*Dd*f**2*fd*r*s + 28560*C*D1*Dd*f**2*fd*r - 20160*C*D1*Dd*f**2*fd*s**2 + 28560*C*D1*Dd*f**2*fd*s - 10080*C*D1*Dd*f**2*fd - 3360*C*D1*Ddd*f**3*r**2 - 6720*C*D1*Ddd*f**3*r*s + 5040*C*D1*Ddd*f**3*r - 3360*C*D1*Ddd*f**3*s**2 + 5040*C*D1*Ddd*f**3*s - 2520*C*D1*Ddd*f**3 - 10080*C*Dd**2*f**3*r**2 - 20160*C*Dd**2*f**3*r*s + 15120*C*Dd**2*f**3*r - 10080*C*Dd**2*f**3*s**2 + 15120*C*Dd**2*f**3*s - 5040*C*Dd**2*f**3 - 540*D1**2*K*bdd1*f**2*r**2 - 1080*D1**2*K*bdd1*f**2*r*s + 1080*D1**2*K*bdd1*f**2*r - 540*D1**2*K*bdd1*f**2*s**2 + 1080*D1**2*K*bdd1*f**2*s - 540*D1**2*K*bdd1*f**2 - 504*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 175*D1**2*bdd1*f**3*r**2 + 350*D1**2*bdd1*f**3*r*s - 350*D1**2*bdd1*f**3*r + 175*D1**2*bdd1*f**3*s**2 - 350*D1**2*bdd1*f**3*s + 175*D1**2*bdd1*f**3 + 630*D1**2*bdd1*f**2*r**2 + 1260*D1**2*bdd1*f**2*r*s - 1260*D1**2*bdd1*f**2*r + 630*D1**2*bdd1*f**2*s**2 - 1260*D1**2*bdd1*f**2*s + 630*D1**2*bdd1*f**2 + 504*D1**2*bdd1*f*g2*r**2 + 1008*D1**2*bdd1*f*g2*r*s - 1008*D1**2*bdd1*f*g2*r + 504*D1**2*bdd1*f*g2*s**2 - 1008*D1**2*bdd1*f*g2*s + 504*D1**2*bdd1*f*g2 - 420*D1**2*f**3*fd*r**2 - 840*D1**2*f**3*fd*r*s + 630*D1**2*f**3*fd*r - 420*D1**2*f**3*fd*s**2 + 630*D1**2*f**3*fd*s - 315*D1**2*f**3*fd - 1215*D1**2*f**2*fd*r**2 - 2430*D1**2*f**2*fd*r*s + 1620*D1**2*f**2*fd*r - 1215*D1**2*f**2*fd*s**2 + 1620*D1**2*f**2*fd*s - 810*D1**2*f**2*fd + 1890*D1**2*f**2*fdd*r**2 + 3780*D1**2*f**2*fdd*r*s - 2520*D1**2*f**2*fdd*r + 1890*D1**2*f**2*fdd*s**2 - 2520*D1**2*f**2*fdd*s + 1260*D1**2*f**2*fdd - 648*D1**2*f**2*gd2*r**2 - 1296*D1**2*f**2*gd2*r*s + 1296*D1**2*f**2*gd2*r - 648*D1**2*f**2*gd2*s**2 + 1296*D1**2*f**2*gd2*s - 648*D1**2*f**2*gd2 + 1080*D1**2*f**2*gdd2*r**2 + 2160*D1**2*f**2*gdd2*r*s - 2160*D1**2*f**2*gdd2*r + 1080*D1**2*f**2*gdd2*s**2 - 2160*D1**2*f**2*gdd2*s + 1080*D1**2*f**2*gdd2 + 3780*D1**2*f*fd**2*r**2 + 7560*D1**2*f*fd**2*r*s - 5040*D1**2*f*fd**2*r + 3780*D1**2*f*fd**2*s**2 - 5040*D1**2*f*fd**2*s + 1260*D1**2*f*fd**2 - 1296*D1**2*f*fd*g2*r**2 - 2592*D1**2*f*fd*g2*r*s + 1296*D1**2*f*fd*g2*r - 1296*D1**2*f*fd*g2*s**2 + 1296*D1**2*f*fd*g2*s - 648*D1**2*f*fd*g2 + 4320*D1**2*f*fd*gd2*r**2 + 8640*D1**2*f*fd*gd2*r*s - 6480*D1**2*f*fd*gd2*r + 4320*D1**2*f*fd*gd2*s**2 - 6480*D1**2*f*fd*gd2*s + 2160*D1**2*f*fd*gd2 + 2160*D1**2*f*fdd*g2*r**2 + 4320*D1**2*f*fdd*g2*r*s - 2160*D1**2*f*fdd*g2*r + 2160*D1**2*f*fdd*g2*s**2 - 2160*D1**2*f*fdd*g2*s + 1080*D1**2*f*fdd*g2 + 2160*D1**2*fd**2*g2*r**2 + 4320*D1**2*fd**2*g2*r*s - 2160*D1**2*fd**2*g2*r + 2160*D1**2*fd**2*g2*s**2 - 2160*D1**2*fd**2*g2*s - 420*D1*Dd*f**4*r**2 - 840*D1*Dd*f**4*r*s + 630*D1*Dd*f**4*r - 420*D1*Dd*f**4*s**2 + 630*D1*Dd*f**4*s - 315*D1*Dd*f**4 - 1620*D1*Dd*f**3*r**2 - 3240*D1*Dd*f**3*r*s + 2430*D1*Dd*f**3*r - 1620*D1*Dd*f**3*s**2 + 2430*D1*Dd*f**3*s - 1215*D1*Dd*f**3 + 15120*D1*Dd*f**2*fd*r**2 + 30240*D1*Dd*f**2*fd*r*s - 21420*D1*Dd*f**2*fd*r + 15120*D1*Dd*f**2*fd*s**2 - 21420*D1*Dd*f**2*fd*s + 7560*D1*Dd*f**2*fd - 2592*D1*Dd*f**2*g2*r**2 - 5184*D1*Dd*f**2*g2*r*s + 3888*D1*Dd*f**2*g2*r - 2592*D1*Dd*f**2*g2*s**2 + 3888*D1*Dd*f**2*g2*s - 1944*D1*Dd*f**2*g2 + 8640*D1*Dd*f**2*gd2*r**2 + 17280*D1*Dd*f**2*gd2*r*s - 15120*D1*Dd*f**2*gd2*r + 8640*D1*Dd*f**2*gd2*s**2 - 15120*D1*Dd*f**2*gd2*s + 6480*D1*Dd*f**2*gd2 + 17280*D1*Dd*f*fd*g2*r**2 + 34560*D1*Dd*f*fd*g2*r*s - 21600*D1*Dd*f*fd*g2*r + 17280*D1*Dd*f*fd*g2*s**2 - 21600*D1*Dd*f*fd*g2*s + 6480*D1*Dd*f*fd*g2 + 2520*D1*Ddd*f**3*r**2 + 5040*D1*Ddd*f**3*r*s - 3780*D1*Ddd*f**3*r + 2520*D1*Ddd*f**3*s**2 - 3780*D1*Ddd*f**3*s + 1890*D1*Ddd*f**3 + 4320*D1*Ddd*f**2*g2*r**2 + 8640*D1*Ddd*f**2*g2*r*s - 6480*D1*Ddd*f**2*g2*r + 4320*D1*Ddd*f**2*g2*s**2 - 6480*D1*Ddd*f**2*g2*s + 3240*D1*Ddd*f**2*g2 - D1*bd1*(D1*(125*f**3*(r + s - 1) - f**2*(468*C*(r + s - 1) + 350*fd*(3*r + 3*s - 2) + (324*K - 567)*(r + s - 1)) + 12*f*(15*fd*(4*C + 6*K - 7)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) - 1008*fd*g2*(r + s)) - 2*Dd*f*(175*f**2 - 90*f*(4*C + 6*K - 7) + 504*g2)*(4*r + 4*s - 3))*(r + s - 1) + 7560*Dd**2*f**3*r**2 + 15120*Dd**2*f**3*r*s - 11340*Dd**2*f**3*r + 7560*Dd**2*f**3*s**2 - 11340*Dd**2*f**3*s + 3780*Dd**2*f**3 + 12960*Dd**2*f**2*g2*r**2 + 25920*Dd**2*f**2*g2*r*s - 19440*Dd**2*f**2*g2*r + 12960*Dd**2*f**2*g2*s**2 - 19440*Dd**2*f**2*g2*s + 6480*Dd**2*f**2*g2 + 42*b1**2*(K - 1)*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(936*C*D1**2*f*fd*r**2 + 1872*C*D1**2*f*fd*r*s - 936*C*D1**2*f*fd*r + 936*C*D1**2*f*fd*s**2 - 936*C*D1**2*f*fd*s + 468*C*D1**2*f*fd - 720*C*D1**2*f*fdd*r**2 - 1440*C*D1**2*f*fdd*r*s + 720*C*D1**2*f*fdd*r - 720*C*D1**2*f*fdd*s**2 + 720*C*D1**2*f*fdd*s - 360*C*D1**2*f*fdd - 720*C*D1**2*fd**2*r**2 - 1440*C*D1**2*fd**2*r*s + 720*C*D1**2*fd**2*r - 720*C*D1**2*fd**2*s**2 + 720*C*D1**2*fd**2*s + 1872*C*D1*Dd*f**2*r**2 + 3744*C*D1*Dd*f**2*r*s - 2808*C*D1*Dd*f**2*r + 1872*C*D1*Dd*f**2*s**2 - 2808*C*D1*Dd*f**2*s + 1404*C*D1*Dd*f**2 - 5760*C*D1*Dd*f*fd*r**2 - 11520*C*D1*Dd*f*fd*r*s + 7200*C*D1*Dd*f*fd*r - 5760*C*D1*Dd*f*fd*s**2 + 7200*C*D1*Dd*f*fd*s - 2160*C*D1*Dd*f*fd - 1440*C*D1*Ddd*f**2*r**2 - 2880*C*D1*Ddd*f**2*r*s + 2160*C*D1*Ddd*f**2*r - 1440*C*D1*Ddd*f**2*s**2 + 2160*C*D1*Ddd*f**2*s - 1080*C*D1*Ddd*f**2 - 4320*C*Dd**2*f**2*r**2 - 8640*C*Dd**2*f**2*r*s + 6480*C*Dd**2*f**2*r - 4320*C*Dd**2*f**2*s**2 + 6480*C*Dd**2*f**2*s - 2160*C*Dd**2*f**2 + 648*D1**2*K*f*fd*r**2 + 1296*D1**2*K*f*fd*r*s - 648*D1**2*K*f*fd*r + 648*D1**2*K*f*fd*s**2 - 648*D1**2*K*f*fd*s + 324*D1**2*K*f*fd - 1080*D1**2*K*f*fdd*r**2 - 2160*D1**2*K*f*fdd*r*s + 1080*D1**2*K*f*fdd*r - 1080*D1**2*K*f*fdd*s**2 + 1080*D1**2*K*f*fdd*s - 540*D1**2*K*f*fdd - 1080*D1**2*K*fd**2*r**2 - 2160*D1**2*K*fd**2*r*s + 1080*D1**2*K*fd**2*r - 1080*D1**2*K*fd**2*s**2 + 1080*D1**2*K*fd**2*s - 504*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 375*D1**2*f**2*fd*r**2 - 750*D1**2*f**2*fd*r*s + 500*D1**2*f**2*fd*r - 375*D1**2*f**2*fd*s**2 + 500*D1**2*f**2*fd*s - 250*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 700*D1**2*f**2*fdd*s + 350*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1400*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 - 1134*D1**2*f*fd*r**2 - 2268*D1**2*f*fd*r*s + 1134*D1**2*f*fd*r - 1134*D1**2*f*fd*s**2 + 1134*D1**2*f*fd*s - 567*D1**2*f*fd + 1260*D1**2*f*fdd*r**2 + 2520*D1**2*f*fdd*r*s - 1260*D1**2*f*fdd*r + 1260*D1**2*f*fdd*s**2 - 1260*D1**2*f*fdd*s + 630*D1**2*f*fdd - 588*D1**2*f*gd2*r**2 - 1176*D1**2*f*gd2*r*s + 1176*D1**2*f*gd2*r - 588*D1**2*f*gd2*s**2 + 1176*D1**2*f*gd2*s - 588*D1**2*f*gd2 + 504*D1**2*f*gdd2*r**2 + 1008*D1**2*f*gdd2*r*s - 1008*D1**2*f*gdd2*r + 504*D1**2*f*gdd2*s**2 - 1008*D1**2*f*gdd2*s + 504*D1**2*f*gdd2 + 1260*D1**2*fd**2*r**2 + 2520*D1**2*fd**2*r*s - 1260*D1**2*fd**2*r + 1260*D1**2*fd**2*s**2 - 1260*D1**2*fd**2*s - 588*D1**2*fd*g2*r**2 - 1176*D1**2*fd*g2*r*s - 588*D1**2*fd*g2*s**2 + 1008*D1**2*fd*gd2*r**2 + 2016*D1**2*fd*gd2*r*s - 1008*D1**2*fd*gd2*r + 1008*D1**2*fd*gd2*s**2 - 1008*D1**2*fd*gd2*s + 504*D1**2*fdd*g2*r**2 + 1008*D1**2*fdd*g2*r*s + 504*D1**2*fdd*g2*s**2 + 1296*D1*Dd*K*f**2*r**2 + 2592*D1*Dd*K*f**2*r*s - 1944*D1*Dd*K*f**2*r + 1296*D1*Dd*K*f**2*s**2 - 1944*D1*Dd*K*f**2*s + 972*D1*Dd*K*f**2 - 8640*D1*Dd*K*f*fd*r**2 - 17280*D1*Dd*K*f*fd*r*s + 10800*D1*Dd*K*f*fd*r - 8640*D1*Dd*K*f*fd*s**2 + 10800*D1*Dd*K*f*fd*s - 3240*D1*Dd*K*f*fd - 500*D1*Dd*f**3*r**2 - 1000*D1*Dd*f**3*r*s + 750*D1*Dd*f**3*r - 500*D1*Dd*f**3*s**2 + 750*D1*Dd*f**3*s - 375*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 5950*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 5950*D1*Dd*f**2*fd*s + 2100*D1*Dd*f**2*fd - 2268*D1*Dd*f**2*r**2 - 4536*D1*Dd*f**2*r*s + 3402*D1*Dd*f**2*r - 2268*D1*Dd*f**2*s**2 + 3402*D1*Dd*f**2*s - 1701*D1*Dd*f**2 + 10080*D1*Dd*f*fd*r**2 + 20160*D1*Dd*f*fd*r*s - 12600*D1*Dd*f*fd*r + 10080*D1*Dd*f*fd*s**2 - 12600*D1*Dd*f*fd*s + 3780*D1*Dd*f*fd - 2352*D1*Dd*f*g2*r**2 - 4704*D1*Dd*f*g2*r*s + 3528*D1*Dd*f*g2*r - 2352*D1*Dd*f*g2*s**2 + 3528*D1*Dd*f*g2*s - 1764*D1*Dd*f*g2 + 4032*D1*Dd*f*gd2*r**2 + 8064*D1*Dd*f*gd2*r*s - 7056*D1*Dd*f*gd2*r + 4032*D1*Dd*f*gd2*s**2 - 7056*D1*Dd*f*gd2*s + 3024*D1*Dd*f*gd2 + 4032*D1*Dd*fd*g2*r**2 + 8064*D1*Dd*fd*g2*r*s - 3024*D1*Dd*fd*g2*r + 4032*D1*Dd*fd*g2*s**2 - 3024*D1*Dd*fd*g2*s - 2160*D1*Ddd*K*f**2*r**2 - 4320*D1*Ddd*K*f**2*r*s + 3240*D1*Ddd*K*f**2*r - 2160*D1*Ddd*K*f**2*s**2 + 3240*D1*Ddd*K*f**2*s - 1620*D1*Ddd*K*f**2 + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 1050*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 525*D1*Ddd*f**3 + 2520*D1*Ddd*f**2*r**2 + 5040*D1*Ddd*f**2*r*s - 3780*D1*Ddd*f**2*r + 2520*D1*Ddd*f**2*s**2 - 3780*D1*Ddd*f**2*s + 1890*D1*Ddd*f**2 + 2016*D1*Ddd*f*g2*r**2 + 4032*D1*Ddd*f*g2*r*s - 3024*D1*Ddd*f*g2*r + 2016*D1*Ddd*f*g2*s**2 - 3024*D1*Ddd*f*g2*s + 1512*D1*Ddd*f*g2 + 84*D1*bd1*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 6480*Dd**2*K*f**2*r**2 - 12960*Dd**2*K*f**2*r*s + 9720*Dd**2*K*f**2*r - 6480*Dd**2*K*f**2*s**2 + 9720*Dd**2*K*f**2*s - 3240*Dd**2*K*f**2 + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 3150*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 1050*Dd**2*f**3 + 7560*Dd**2*f**2*r**2 + 15120*Dd**2*f**2*r*s - 11340*Dd**2*f**2*r + 7560*Dd**2*f**2*s**2 - 11340*Dd**2*f**2*s + 3780*Dd**2*f**2 + 6048*Dd**2*f*g2*r**2 + 12096*Dd**2*f*g2*r*s - 9072*Dd**2*f*g2*r + 6048*Dd**2*f*g2*s**2 - 9072*Dd**2*f*g2*s + 3024*Dd**2*f*g2))/(70*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**5*k1**3*k2*st**2*(5412*C*D1**2*f**2*fd*r*s - 1804*C*D1**2*f**2*fd*r + 5412*C*D1**2*f**2*fd*s**2 - 5412*C*D1**2*f**2*fd*s + 1804*C*D1**2*f**2*fd - 3300*C*D1**2*f**2*fdd*r*s + 1100*C*D1**2*f**2*fdd*r - 3300*C*D1**2*f**2*fdd*s**2 + 3300*C*D1**2*f**2*fdd*s - 1100*C*D1**2*f**2*fdd - 6600*C*D1**2*f*fd**2*r*s + 2200*C*D1**2*f*fd**2*r - 6600*C*D1**2*f*fd**2*s**2 + 6600*C*D1**2*f*fd**2*s - 1100*C*D1**2*f*fd**2 + 7216*C*D1*Dd*f**3*r*s - 1804*C*D1*Dd*f**3*r + 7216*C*D1*Dd*f**3*s**2 - 7216*C*D1*Dd*f**3*s + 1804*C*D1*Dd*f**3 - 26400*C*D1*Dd*f**2*fd*r*s + 7700*C*D1*Dd*f**2*fd*r - 26400*C*D1*Dd*f**2*fd*s**2 + 26400*C*D1*Dd*f**2*fd*s - 5500*C*D1*Dd*f**2*fd - 4400*C*D1*Ddd*f**3*r*s + 1100*C*D1*Ddd*f**3*r - 4400*C*D1*Ddd*f**3*s**2 + 4400*C*D1*Ddd*f**3*s - 1100*C*D1*Ddd*f**3 - 13200*C*Dd**2*f**3*r*s + 3300*C*Dd**2*f**3*r - 13200*C*Dd**2*f**3*s**2 + 13200*C*Dd**2*f**3*s - 2200*C*Dd**2*f**3 - 990*D1**2*K*bdd1*f**2*r*s - 990*D1**2*K*bdd1*f**2*s**2 + 990*D1**2*K*bdd1*f**2*s + 990*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*s**2 - 990*D1**2*bdd1*f**2*s + 6740*D1**2*f**3*fd*r*s - 1685*D1**2*f**3*fd*r + 6740*D1**2*f**3*fd*s**2 - 6740*D1**2*f**3*fd*s + 1685*D1**2*f**3*fd - 3920*D1**2*f**3*fdd*r*s + 980*D1**2*f**3*fdd*r - 3920*D1**2*f**3*fdd*s**2 + 3920*D1**2*f**3*fdd*s - 980*D1**2*f**3*fdd - 11760*D1**2*f**2*fd**2*r*s + 2940*D1**2*f**2*fd**2*r - 11760*D1**2*f**2*fd**2*s**2 + 11760*D1**2*f**2*fd**2*s - 1960*D1**2*f**2*fd**2 - 5412*D1**2*f**2*fd*r*s + 1804*D1**2*f**2*fd*r - 5412*D1**2*f**2*fd*s**2 + 5412*D1**2*f**2*fd*s - 1804*D1**2*f**2*fd + 3300*D1**2*f**2*fdd*r*s - 1100*D1**2*f**2*fdd*r + 3300*D1**2*f**2*fdd*s**2 - 3300*D1**2*f**2*fdd*s + 1100*D1**2*f**2*fdd - 3036*D1**2*f**2*gd2*r*s - 3036*D1**2*f**2*gd2*s**2 + 3036*D1**2*f**2*gd2*s + 1980*D1**2*f**2*gdd2*r*s + 1980*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 6600*D1**2*f*fd**2*r*s - 2200*D1**2*f*fd**2*r + 6600*D1**2*f*fd**2*s**2 - 6600*D1**2*f*fd**2*s + 1100*D1**2*f*fd**2 - 6072*D1**2*f*fd*g2*r*s + 3036*D1**2*f*fd*g2*r - 6072*D1**2*f*fd*g2*s**2 + 6072*D1**2*f*fd*g2*s - 3036*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s + 6740*D1*Dd*f**4*r*s - 1685*D1*Dd*f**4*r + 6740*D1*Dd*f**4*s**2 - 6740*D1*Dd*f**4*s + 1685*D1*Dd*f**4 - 31360*D1*Dd*f**3*fd*r*s + 7840*D1*Dd*f**3*fd*r - 31360*D1*Dd*f**3*fd*s**2 + 31360*D1*Dd*f**3*fd*s - 5880*D1*Dd*f**3*fd - 7216*D1*Dd*f**3*r*s + 1804*D1*Dd*f**3*r - 7216*D1*Dd*f**3*s**2 + 7216*D1*Dd*f**3*s - 1804*D1*Dd*f**3 + 26400*D1*Dd*f**2*fd*r*s - 7700*D1*Dd*f**2*fd*r + 26400*D1*Dd*f**2*fd*s**2 - 26400*D1*Dd*f**2*fd*s + 5500*D1*Dd*f**2*fd - 12144*D1*Dd*f**2*g2*r*s + 3036*D1*Dd*f**2*g2*r - 12144*D1*Dd*f**2*g2*s**2 + 12144*D1*Dd*f**2*g2*s - 3036*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r*s - 1980*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 15840*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 31680*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 - 3920*D1*Ddd*f**4*r*s + 980*D1*Ddd*f**4*r - 3920*D1*Ddd*f**4*s**2 + 3920*D1*Ddd*f**4*s - 980*D1*Ddd*f**4 + 4400*D1*Ddd*f**3*r*s - 1100*D1*Ddd*f**3*r + 4400*D1*Ddd*f**3*s**2 - 4400*D1*Ddd*f**3*s + 1100*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 1980*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 11760*Dd**2*f**4*r*s + 2940*Dd**2*f**4*r - 11760*Dd**2*f**4*s**2 + 11760*Dd**2*f**4*s - 1960*Dd**2*f**4 + 13200*Dd**2*f**3*r*s - 3300*Dd**2*f**3*r + 13200*Dd**2*f**3*s**2 - 13200*Dd**2*f**3*s + 2200*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 3960*Dd**2*f**2*g2 + 66*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**5*k1**3*k2*(900*C*D1**2*bdd1*f**2*r**2 + 2880*C*D1**2*bdd1*f**2*r*s - 1080*C*D1**2*bdd1*f**2*r + 1980*C*D1**2*bdd1*f**2*s**2 - 2160*C*D1**2*bdd1*f**2*s + 1080*C*D1**2*bdd1*f**2 + 5940*C*D1**2*f**2*fd*r**2 + 11160*C*D1**2*f**2*fd*r*s - 7680*C*D1**2*f**2*fd*r + 5220*C*D1**2*f**2*fd*s**2 - 7200*C*D1**2*f**2*fd*s + 3720*C*D1**2*f**2*fd - 5940*C*D1**2*f**2*fdd*r**2 - 9360*C*D1**2*f**2*fdd*r*s + 7080*C*D1**2*f**2*fdd*r - 3420*C*D1**2*f**2*fdd*s**2 + 5400*C*D1**2*f**2*fdd*s - 3120*C*D1**2*f**2*fdd - 11880*C*D1**2*f*fd**2*r**2 - 18720*C*D1**2*f*fd**2*r*s + 14160*C*D1**2*f*fd**2*r - 6840*C*D1**2*f*fd**2*s**2 + 10800*C*D1**2*f*fd**2*s - 3120*C*D1**2*f*fd**2 + 7920*C*D1*Dd*f**3*r**2 + 14880*C*D1*Dd*f**3*r*s - 11640*C*D1*Dd*f**3*r + 6960*C*D1*Dd*f**3*s**2 - 10920*C*D1*Dd*f**3*s + 5700*C*D1*Dd*f**3 - 47520*C*D1*Dd*f**2*fd*r**2 - 74880*C*D1*Dd*f**2*fd*r*s + 61440*C*D1*Dd*f**2*fd*r - 27360*C*D1*Dd*f**2*fd*s**2 + 47160*C*D1*Dd*f**2*fd*s - 19560*C*D1*Dd*f**2*fd - 7920*C*D1*Ddd*f**3*r**2 - 12480*C*D1*Ddd*f**3*r*s + 11040*C*D1*Ddd*f**3*r - 4560*C*D1*Ddd*f**3*s**2 + 8520*C*D1*Ddd*f**3*s - 5100*C*D1*Ddd*f**3 - 23760*C*Dd**2*f**3*r**2 - 37440*C*Dd**2*f**3*r*s + 33120*C*Dd**2*f**3*r - 13680*C*Dd**2*f**3*s**2 + 25560*C*Dd**2*f**3*s - 10200*C*Dd**2*f**3 - 1170*D1**2*K*bdd1*f**2*r**2 - 2016*D1**2*K*bdd1*f**2*r*s + 2340*D1**2*K*bdd1*f**2*r - 846*D1**2*K*bdd1*f**2*s**2 + 2016*D1**2*K*bdd1*f**2*s - 1170*D1**2*K*bdd1*f**2 + 252*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 8*r*(2*s - 1) + 11*s**2 - 14*s + 3) + 1575*D1**2*bdd1*f**3*r**2 + 2870*D1**2*bdd1*f**3*r*s - 2660*D1**2*bdd1*f**3*r + 1295*D1**2*bdd1*f**3*s**2 - 2380*D1**2*bdd1*f**3*s + 1610*D1**2*bdd1*f**3 + 1620*D1**2*bdd1*f**2*r**2 + 2376*D1**2*bdd1*f**2*r*s - 3960*D1**2*bdd1*f**2*r + 756*D1**2*bdd1*f**2*s**2 - 3096*D1**2*bdd1*f**2*s + 1440*D1**2*bdd1*f**2 - 1260*D1**2*bdd1*f*g2*r**2 - 4032*D1**2*bdd1*f*g2*r*s + 1512*D1**2*bdd1*f*g2*r - 2772*D1**2*bdd1*f*g2*s**2 + 3024*D1**2*bdd1*f*g2*s - 1512*D1**2*bdd1*f*g2 + 5460*D1**2*f**3*fd*r**2 + 14280*D1**2*f**3*fd*r*s - 9030*D1**2*f**3*fd*r + 8820*D1**2*f**3*fd*s**2 - 11550*D1**2*f**3*fd*s + 4935*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 8865*D1**2*f**2*fd*r**2 - 18450*D1**2*f**2*fd*r*s + 12060*D1**2*f**2*fd*r - 9585*D1**2*f**2*fd*s**2 + 12540*D1**2*f**2*fd*s - 6150*D1**2*f**2*fd + 9090*D1**2*f**2*fdd*r**2 + 16920*D1**2*f**2*fdd*r*s - 11700*D1**2*f**2*fdd*r + 7830*D1**2*f**2*fdd*s**2 - 10860*D1**2*f**2*fdd*s + 5640*D1**2*f**2*fdd - 1908*D1**2*f**2*gd2*r**2 - 4536*D1**2*f**2*gd2*r*s + 3816*D1**2*f**2*gd2*r - 2628*D1**2*f**2*gd2*s**2 + 4536*D1**2*f**2*gd2*s - 1908*D1**2*f**2*gd2 + 2340*D1**2*f**2*gdd2*r**2 + 4032*D1**2*f**2*gdd2*r*s - 4680*D1**2*f**2*gdd2*r + 1692*D1**2*f**2*gdd2*s**2 - 4032*D1**2*f**2*gdd2*s + 2340*D1**2*f**2*gdd2 + 18180*D1**2*f*fd**2*r**2 + 33840*D1**2*f*fd**2*r*s - 23400*D1**2*f*fd**2*r + 15660*D1**2*f*fd**2*s**2 - 21720*D1**2*f*fd**2*s + 5640*D1**2*f*fd**2 - 3816*D1**2*f*fd*g2*r**2 - 9072*D1**2*f*fd*g2*r*s + 4536*D1**2*f*fd*g2*r - 5256*D1**2*f*fd*g2*s**2 + 5256*D1**2*f*fd*g2*s - 2628*D1**2*f*fd*g2 + 9360*D1**2*f*fd*gd2*r**2 + 16128*D1**2*f*fd*gd2*r*s - 13392*D1**2*f*fd*gd2*r + 6768*D1**2*f*fd*gd2*s**2 - 11448*D1**2*f*fd*gd2*s + 4032*D1**2*f*fd*gd2 + 4680*D1**2*f*fdd*g2*r**2 + 8064*D1**2*f*fdd*g2*r*s - 4032*D1**2*f*fdd*g2*r + 3384*D1**2*f*fdd*g2*s**2 - 3384*D1**2*f*fdd*g2*s + 1692*D1**2*f*fdd*g2 + 4680*D1**2*fd**2*g2*r**2 + 8064*D1**2*fd**2*g2*r*s - 4032*D1**2*fd**2*g2*r + 3384*D1**2*fd**2*g2*s**2 - 3384*D1**2*fd**2*g2*s + 5460*D1*Dd*f**4*r**2 + 14280*D1*Dd*f**4*r*s - 9030*D1*Dd*f**4*r + 8820*D1*Dd*f**4*s**2 - 11550*D1*Dd*f**4*s + 4935*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 11820*D1*Dd*f**3*r**2 - 24600*D1*Dd*f**3*r*s + 17970*D1*Dd*f**3*r - 12780*D1*Dd*f**3*s**2 + 18690*D1*Dd*f**3*s - 9105*D1*Dd*f**3 + 72720*D1*Dd*f**2*fd*r**2 + 135360*D1*Dd*f**2*fd*r*s - 100080*D1*Dd*f**2*fd*r + 62640*D1*Dd*f**2*fd*s**2 - 92940*D1*Dd*f**2*fd*s + 34260*D1*Dd*f**2*fd - 7632*D1*Dd*f**2*g2*r**2 - 18144*D1*Dd*f**2*g2*r*s + 12168*D1*Dd*f**2*g2*r - 10512*D1*Dd*f**2*g2*s**2 + 14328*D1*Dd*f**2*g2*s - 6444*D1*Dd*f**2*g2 + 18720*D1*Dd*f**2*gd2*r**2 + 32256*D1*Dd*f**2*gd2*r*s - 32112*D1*Dd*f**2*gd2*r + 13536*D1*Dd*f**2*gd2*s**2 - 27576*D1*Dd*f**2*gd2*s + 13392*D1*Dd*f**2*gd2 + 37440*D1*Dd*f*fd*g2*r**2 + 64512*D1*Dd*f*fd*g2*r*s - 42912*D1*Dd*f*fd*g2*r + 27072*D1*Dd*f*fd*g2*s**2 - 36432*D1*Dd*f*fd*g2*s + 11448*D1*Dd*f*fd*g2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 12120*D1*Ddd*f**3*r**2 + 22560*D1*Ddd*f**3*r*s - 17760*D1*Ddd*f**3*r + 10440*D1*Ddd*f**3*s**2 - 16500*D1*Ddd*f**3*s + 8670*D1*Ddd*f**3 + 9360*D1*Ddd*f**2*g2*r**2 + 16128*D1*Ddd*f**2*g2*r*s - 13392*D1*Ddd*f**2*g2*r + 6768*D1*Ddd*f**2*g2*s**2 - 11448*D1*Ddd*f**2*g2*s + 6372*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(315*r**2 + r*(590*s - 578) + 275*s**2 - 538*s + 383) + f**2*(-36*C*(15*r**2 + r*(76*s - 46) + 61*s**2 - 92*s + 46) + 18*K*(53*r**2 + 2*r*(63*s - 53) + 73*s**2 - 126*s + 53) + 70*fd*(135*r**2 + 3*r*(82*s - 69) + 111*s**2 - 187*s + 64) - 1539*r**2 - 2358*r*s + 2502*r - 819*s**2 + 1782*s - 423) + 12*f*(30*C*fd*(10*r**2 + 16*r*(2*s - 1) + 22*s**2 - 25*s + 3) - 3*K*fd*(130*r**2 + 2*r*(112*s - 93) + 94*s**2 - 159*s + 56) + 6*fd*(90*r**2 + r*(132*s - 133) + 42*s**2 - 97*s + 58) + 7*g2*(5*r**2 + r*(36*s - 26) + 31*s**2 - 52*s + 26) - 42*gd2*(5*r**2 + 8*r*(2*s - 1) + 11*s**2 - 14*s + 3)) - 504*fd*g2*(5*r**2 + 8*r*(2*s - 1) + s*(11*s - 11))) + 2*Dd*f*(35*f**2*(180*r**2 + r*(328*s - 283) + 148*s**2 - 255*s + 110) + 18*f*(10*C*(20*r**2 + r*(64*s - 30) + 44*s**2 - 51*s + 12) - K*(260*r**2 + 448*r*s - 446*r + 188*s**2 - 383*s + 186) + 360*r**2 + 528*r*s - 686*r + 168*s**2 - 518*s + 306) - 252*g2*(20*r**2 + r*(64*s - 30) + 44*s**2 - 51*s + 12))) - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 36360*Dd**2*f**3*r**2 + 67680*Dd**2*f**3*r*s - 53280*Dd**2*f**3*r + 31320*Dd**2*f**3*s**2 - 49500*Dd**2*f**3*s + 17340*Dd**2*f**3 + 28080*Dd**2*f**2*g2*r**2 + 48384*Dd**2*f**2*g2*r*s - 40176*Dd**2*f**2*g2*r + 20304*Dd**2*f**2*g2*s**2 - 34344*Dd**2*f**2*g2*s + 12744*Dd**2*f**2*g2 - 42*b1**2*(K - 1)*(D1**2*(fd*(5*r**2 + 2*r*(18*s - 5) + 31*s**2 - 10*s + 5) - 3*fdd*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5)) + D1*(Dd*(f*(20*r**2 + 8*r*(18*s - 7) + 124*s**2 - 134*s + 41) - 6*fd*(20*r**2 + r*(64*s - 38) + 44*s**2 - 47*s + 15)) - 3*Ddd*f*(20*r**2 + 4*r*(16*s - 9) + 44*s**2 - 54*s + 21)) - 18*Dd**2*f*(10*r**2 + 2*r*(16*s - 9) + 22*s**2 - 27*s + 7)) + b1*(-1080*C*D1**2*f*fd*r**2 - 5472*C*D1**2*f*fd*r*s + 2160*C*D1**2*f*fd*r - 4392*C*D1**2*f*fd*s**2 + 3816*C*D1**2*f*fd*s - 1080*C*D1**2*f*fd + 1800*C*D1**2*f*fdd*r**2 + 5760*C*D1**2*f*fdd*r*s - 3600*C*D1**2*f*fdd*r + 3960*C*D1**2*f*fdd*s**2 - 4680*C*D1**2*f*fdd*s + 1800*C*D1**2*f*fdd + 1800*C*D1**2*fd**2*r**2 + 5760*C*D1**2*fd**2*r*s - 3600*C*D1**2*fd**2*r + 3960*C*D1**2*fd**2*s**2 - 4680*C*D1**2*fd**2*s + 1800*C*D1**2*fd**2 - 2160*C*D1*Dd*f**2*r**2 - 10944*C*D1*Dd*f**2*r*s + 4896*C*D1*Dd*f**2*r - 8784*C*D1*Dd*f**2*s**2 + 9864*C*D1*Dd*f**2*s - 3276*C*D1*Dd*f**2 + 14400*C*D1*Dd*f*fd*r**2 + 46080*C*D1*Dd*f*fd*r*s - 27360*C*D1*Dd*f*fd*r + 31680*C*D1*Dd*f*fd*s**2 - 38160*C*D1*Dd*f*fd*s + 11880*C*D1*Dd*f*fd + 3600*C*D1*Ddd*f**2*r**2 + 11520*C*D1*Ddd*f**2*r*s - 6480*C*D1*Ddd*f**2*r + 7920*C*D1*Ddd*f**2*s**2 - 9720*C*D1*Ddd*f**2*s + 3780*C*D1*Ddd*f**2 + 10800*C*Dd**2*f**2*r**2 + 34560*C*Dd**2*f**2*r*s - 19440*C*Dd**2*f**2*r + 23760*C*Dd**2*f**2*s**2 - 29160*C*Dd**2*f**2*s + 7560*C*Dd**2*f**2 + 1908*D1**2*K*f*fd*r**2 + 4536*D1**2*K*f*fd*r*s - 2268*D1**2*K*f*fd*r + 2628*D1**2*K*f*fd*s**2 - 2628*D1**2*K*f*fd*s + 1314*D1**2*K*f*fd - 2340*D1**2*K*f*fdd*r**2 - 4032*D1**2*K*f*fdd*r*s + 2016*D1**2*K*f*fdd*r - 1692*D1**2*K*f*fdd*s**2 + 1692*D1**2*K*f*fdd*s - 846*D1**2*K*f*fdd - 2340*D1**2*K*fd**2*r**2 - 4032*D1**2*K*fd**2*r*s + 2016*D1**2*K*fd**2*r - 1692*D1**2*K*fd**2*s**2 + 1692*D1**2*K*fd**2*s + 126*D1**2*bdd1*f*(K - 1)*(10*r**2 + 32*r*s - 16*r + 22*s**2 - 28*s + 11) - 4725*D1**2*f**2*fd*r**2 - 8850*D1**2*f**2*fd*r*s + 6360*D1**2*f**2*fd*r - 4125*D1**2*f**2*fd*s**2 + 5960*D1**2*f**2*fd*s - 2610*D1**2*f**2*fd + 4725*D1**2*f**2*fdd*r**2 + 8610*D1**2*f**2*fdd*r*s - 6510*D1**2*f**2*fdd*r + 3885*D1**2*f**2*fdd*s**2 - 5950*D1**2*f**2*fdd*s + 2835*D1**2*f**2*fdd + 9450*D1**2*f*fd**2*r**2 + 17220*D1**2*f*fd**2*r*s - 13020*D1**2*f*fd**2*r + 7770*D1**2*f*fd**2*s**2 - 11900*D1**2*f*fd**2*s + 4410*D1**2*f*fd**2 - 3078*D1**2*f*fd*r**2 - 4716*D1**2*f*fd*r*s + 2934*D1**2*f*fd*r - 1638*D1**2*f*fd*s**2 + 2214*D1**2*f*fd*s - 1935*D1**2*f*fd + 3240*D1**2*f*fdd*r**2 + 4752*D1**2*f*fdd*r*s - 1656*D1**2*f*fdd*r + 1512*D1**2*f*fdd*s**2 - 792*D1**2*f*fdd*s + 936*D1**2*f*fdd + 420*D1**2*f*gd2*r**2 + 3024*D1**2*f*gd2*r*s - 840*D1**2*f*gd2*r + 2604*D1**2*f*gd2*s**2 - 3024*D1**2*f*gd2*s + 420*D1**2*f*gd2 - 1260*D1**2*f*gdd2*r**2 - 4032*D1**2*f*gdd2*r*s + 2520*D1**2*f*gdd2*r - 2772*D1**2*f*gdd2*s**2 + 4032*D1**2*f*gdd2*s - 1260*D1**2*f*gdd2 + 3240*D1**2*fd**2*r**2 + 4752*D1**2*fd**2*r*s - 1656*D1**2*fd**2*r + 1512*D1**2*fd**2*s**2 - 792*D1**2*fd**2*s - 1800*D1**2*fd**2 + 420*D1**2*fd*g2*r**2 + 3024*D1**2*fd*g2*r*s - 840*D1**2*fd*g2*r + 2604*D1**2*fd*g2*s**2 - 840*D1**2*fd*g2*s + 420*D1**2*fd*g2 - 2520*D1**2*fd*gd2*r**2 - 8064*D1**2*fd*gd2*r*s + 5040*D1**2*fd*gd2*r - 5544*D1**2*fd*gd2*s**2 + 6552*D1**2*fd*gd2*s - 2520*D1**2*fd*gd2 - 1260*D1**2*fdd*g2*r**2 - 4032*D1**2*fdd*g2*r*s + 2520*D1**2*fdd*g2*r - 2772*D1**2*fdd*g2*s**2 + 2520*D1**2*fdd*g2*s - 1260*D1**2*fdd*g2 + 3816*D1*Dd*K*f**2*r**2 + 9072*D1*Dd*K*f**2*r*s - 6084*D1*Dd*K*f**2*r + 5256*D1*Dd*K*f**2*s**2 - 7164*D1*Dd*K*f**2*s + 3222*D1*Dd*K*f**2 - 18720*D1*Dd*K*f*fd*r**2 - 32256*D1*Dd*K*f*fd*r*s + 21456*D1*Dd*K*f*fd*r - 13536*D1*Dd*K*f*fd*s**2 + 18216*D1*Dd*K*f*fd*s - 5724*D1*Dd*K*f*fd - 6300*D1*Dd*f**3*r**2 - 11800*D1*Dd*f**3*r*s + 9250*D1*Dd*f**3*r - 5500*D1*Dd*f**3*s**2 + 8650*D1*Dd*f**3*s - 4525*D1*Dd*f**3 + 37800*D1*Dd*f**2*fd*r**2 + 68880*D1*Dd*f**2*fd*r*s - 53550*D1*Dd*f**2*fd*r + 31080*D1*Dd*f**2*fd*s**2 - 48790*D1*Dd*f**2*fd*s + 18970*D1*Dd*f**2*fd - 6156*D1*Dd*f**2*r**2 - 9432*D1*Dd*f**2*r*s + 8514*D1*Dd*f**2*r - 3276*D1*Dd*f**2*s**2 + 6354*D1*Dd*f**2*s - 3897*D1*Dd*f**2 + 25920*D1*Dd*f*fd*r**2 + 38016*D1*Dd*f*fd*r*s - 24336*D1*Dd*f*fd*r + 12096*D1*Dd*f*fd*s**2 - 15696*D1*Dd*f*fd*s + 4104*D1*Dd*f*fd + 1680*D1*Dd*f*g2*r**2 + 12096*D1*Dd*f*g2*r*s - 4704*D1*Dd*f*g2*r + 10416*D1*Dd*f*g2*s**2 - 11256*D1*Dd*f*g2*s + 3444*D1*Dd*f*g2 - 10080*D1*Dd*f*gd2*r**2 - 32256*D1*Dd*f*gd2*r*s + 19152*D1*Dd*f*gd2*r - 22176*D1*Dd*f*gd2*s**2 + 29736*D1*Dd*f*gd2*s - 9072*D1*Dd*f*gd2 - 10080*D1*Dd*fd*g2*r**2 - 32256*D1*Dd*fd*g2*r*s + 19152*D1*Dd*fd*g2*r - 22176*D1*Dd*fd*g2*s**2 + 23688*D1*Dd*fd*g2*s - 7560*D1*Dd*fd*g2 - 4680*D1*Ddd*K*f**2*r**2 - 8064*D1*Ddd*K*f**2*r*s + 6696*D1*Ddd*K*f**2*r - 3384*D1*Ddd*K*f**2*s**2 + 5724*D1*Ddd*K*f**2*s - 3186*D1*Ddd*K*f**2 + 6300*D1*Ddd*f**3*r**2 + 11480*D1*Ddd*f**3*r*s - 9170*D1*Ddd*f**3*r + 5180*D1*Ddd*f**3*s**2 - 8330*D1*Ddd*f**3*s + 4445*D1*Ddd*f**3 + 6480*D1*Ddd*f**2*r**2 + 9504*D1*Ddd*f**2*r*s - 8856*D1*Ddd*f**2*r + 3024*D1*Ddd*f**2*s**2 - 6264*D1*Ddd*f**2*s + 3996*D1*Ddd*f**2 - 5040*D1*Ddd*f*g2*r**2 - 16128*D1*Ddd*f*g2*r*s + 9072*D1*Ddd*f*g2*r - 11088*D1*Ddd*f*g2*s**2 + 13608*D1*Ddd*f*g2*s - 5292*D1*Ddd*f*g2 - 42*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 72*r*s - 36*r + 62*s**2 - 88*s + 31) - 6*fd*(10*r**2 + 32*r*s - 18*r + 22*s**2 - 24*s + 5)) - 12*Dd*f*(20*r**2 + r*(64*s - 34) + 44*s**2 - 55*s + 15)) - 14040*Dd**2*K*f**2*r**2 - 24192*Dd**2*K*f**2*r*s + 20088*Dd**2*K*f**2*r - 10152*Dd**2*K*f**2*s**2 + 17172*Dd**2*K*f**2*s - 6372*Dd**2*K*f**2 + 18900*Dd**2*f**3*r**2 + 34440*Dd**2*f**3*r*s - 27510*Dd**2*f**3*r + 15540*Dd**2*f**3*s**2 - 24990*Dd**2*f**3*s + 8890*Dd**2*f**3 + 19440*Dd**2*f**2*r**2 + 28512*Dd**2*f**2*r*s - 26568*Dd**2*f**2*r + 9072*Dd**2*f**2*s**2 - 18792*Dd**2*f**2*s + 7992*Dd**2*f**2 - 15120*Dd**2*f*g2*r**2 - 48384*Dd**2*f*g2*r*s + 27216*Dd**2*f*g2*r - 33264*Dd**2*f*g2*s**2 + 40824*Dd**2*f*g2*s - 10584*Dd**2*f*g2))/(630*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**5*k1**3*(-63*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(5*f**3*s*(43*r + 43*s - 24) + f**2*(-35*fd*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3) + 18*s*(3*C*s + r*(3*C + 5) + 5*s - 8)) - 3*f*(15*fd*(r*(2*C + 1)*(4*s - 1) + s**2*(8*C + 4) - s*(6*C + 6) + 3) + 14*s*(g2*(r + s) + gd2*(-6*r - 6*s + 3))) + 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(35*f**2*(5*r*(8*s - 1) + 40*s**2 - 32*s + 3) + 45*f*(r*(2*C + 1)*(8*s - 1) + s**2*(16*C + 8) - s*(8*C + 16) + 3) - 126*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 21*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(5*f**2*(fd*(43*r*(3*s - 1) + 129*s**2 - 148*s + 43) - 7*fdd*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5)) - f*(35*fd**2*(10*r*(3*s - 1) + 30*s**2 - 34*s + 7) - 18*fd*(3*C*(2*s - 1)*(r + s - 1) + 10*r*s - 5*r + 10*s**2 - 7*s + 5) + 45*fdd*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 + 1) + 21*s*(3*bdd1*(K - 1)*(2*r + 2*s - 1) + (2*gd2 - 6*gdd2)*(r + s - 1))) - 45*fd**2*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 - 2) + 42*fd*(r + s - 1)*(-g2*s + g2 + 6*gd2*s - 3*gd2) + 126*fdd*g2*(s - 1)*(r + s - 1)) - 21*D1*bd1*(K - 1)*(D1*(f*s*(-2*r - 2*s + 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 3*Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(215*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(54*C*(r*(4*s - 1) + (1 - 2*s)**2) - 35*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) + 90*r*(4*s - 1) + 90*(1 - 2*s)**2) - 6*f*(15*fd*(C*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + 8*r*s - 3*r + 8*s**2 - 4*s + 1) + 7*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 21*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 126*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(175*f**2 + f*(90*C + 45) - 126*g2)) - Dd**2*f*(175*f**2 + f*(90*C + 45) - 126*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - f*(D1**2*(35*bdd1*f**2*s*(5*r + 5*s - 3) - 126*bdd1*g2*s*(r + s) - 15*f*(-3*bdd1*s*(2*C*r + 2*C*s + r + s - 3) + 8*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 105*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 15*D1*f*(Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - 7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 7*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 105*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k2*k3**3) - 3*D1**2*Pk2*Pkd3*ct**5*k1*k2**5*st**2*(-120*C*D1**2*f**2*fd*r**2 - 240*C*D1**2*f**2*fd*r*s + 160*C*D1**2*f**2*fd*r - 120*C*D1**2*f**2*fd*s**2 + 160*C*D1**2*f**2*fd*s - 80*C*D1**2*f**2*fd + 60*C*D1**2*f**2*fdd*r**2 + 120*C*D1**2*f**2*fdd*r*s - 80*C*D1**2*f**2*fdd*r + 60*C*D1**2*f**2*fdd*s**2 - 80*C*D1**2*f**2*fdd*s + 40*C*D1**2*f**2*fdd + 120*C*D1**2*f*fd**2*r**2 + 240*C*D1**2*f*fd**2*r*s - 160*C*D1**2*f*fd**2*r + 120*C*D1**2*f*fd**2*s**2 - 160*C*D1**2*f*fd**2*s + 40*C*D1**2*f*fd**2 - 160*C*D1*Dd*f**3*r**2 - 320*C*D1*Dd*f**3*r*s + 240*C*D1*Dd*f**3*r - 160*C*D1*Dd*f**3*s**2 + 240*C*D1*Dd*f**3*s - 120*C*D1*Dd*f**3 + 480*C*D1*Dd*f**2*fd*r**2 + 960*C*D1*Dd*f**2*fd*r*s - 680*C*D1*Dd*f**2*fd*r + 480*C*D1*Dd*f**2*fd*s**2 - 680*C*D1*Dd*f**2*fd*s + 240*C*D1*Dd*f**2*fd + 80*C*D1*Ddd*f**3*r**2 + 160*C*D1*Ddd*f**3*r*s - 120*C*D1*Ddd*f**3*r + 80*C*D1*Ddd*f**3*s**2 - 120*C*D1*Ddd*f**3*s + 60*C*D1*Ddd*f**3 + 240*C*Dd**2*f**3*r**2 + 480*C*Dd**2*f**3*r*s - 360*C*Dd**2*f**3*r + 240*C*Dd**2*f**3*s**2 - 360*C*Dd**2*f**3*s + 120*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 - 144*D1**2*K*b1*f*fd*r*s + 72*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 + 90*D1**2*f**2*fd*r**2 + 180*D1**2*f**2*fd*r*s - 120*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 45*D1**2*f**2*fdd*r**2 - 90*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 45*D1**2*f**2*fdd*s**2 + 60*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r - 36*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 90*D1**2*f*fd**2*r**2 - 180*D1**2*f*fd**2*r*s + 120*D1**2*f*fd**2*r - 90*D1**2*f*fd**2*s**2 + 120*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 - 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 216*D1*Dd*K*b1*f**2*s - 108*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r**2 + 576*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 360*D1*Dd*K*b1*f*fd*s + 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 120*D1*Dd*f**3*r**2 + 240*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r + 120*D1*Dd*f**3*s**2 - 180*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r**2 - 720*D1*Dd*f**2*fd*r*s + 510*D1*Dd*f**2*fd*r - 360*D1*Dd*f**2*fd*s**2 + 510*D1*Dd*f**2*fd*s - 180*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 504*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 720*D1*Dd*f*fd*g2*s - 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 + 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 108*D1*Ddd*K*b1*f**2*s + 54*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 60*D1*Ddd*f**3*r**2 - 120*D1*Ddd*f**3*r*s + 90*D1*Ddd*f**3*r - 60*D1*Ddd*f**3*s**2 + 90*D1*Ddd*f**3*s - 45*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 216*D1*Ddd*f**2*g2*s - 108*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*b1*f**2*r**2 + 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 324*Dd**2*K*b1*f**2*s + 108*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 180*Dd**2*f**3*r**2 - 360*Dd**2*f**3*r*s + 270*Dd**2*f**3*r - 180*Dd**2*f**3*s**2 + 270*Dd**2*f**3*s - 90*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 648*Dd**2*f**2*g2*s - 216*Dd**2*f**2*g2)/(14*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**5*k1*k2**5*(-180*C*D1**2*bdd1*f**2*r**2 - 360*C*D1**2*bdd1*f**2*r*s + 360*C*D1**2*bdd1*f**2*r - 180*C*D1**2*bdd1*f**2*s**2 + 360*C*D1**2*bdd1*f**2*s - 180*C*D1**2*bdd1*f**2 + 600*C*D1**2*f**2*fd*r**2 + 1200*C*D1**2*f**2*fd*r*s - 800*C*D1**2*f**2*fd*r + 600*C*D1**2*f**2*fd*s**2 - 800*C*D1**2*f**2*fd*s + 400*C*D1**2*f**2*fd - 840*C*D1**2*f**2*fdd*r**2 - 1680*C*D1**2*f**2*fdd*r*s + 1120*C*D1**2*f**2*fdd*r - 840*C*D1**2*f**2*fdd*s**2 + 1120*C*D1**2*f**2*fdd*s - 560*C*D1**2*f**2*fdd - 1680*C*D1**2*f*fd**2*r**2 - 3360*C*D1**2*f*fd**2*r*s + 2240*C*D1**2*f*fd**2*r - 1680*C*D1**2*f*fd**2*s**2 + 2240*C*D1**2*f*fd**2*s - 560*C*D1**2*f*fd**2 + 800*C*D1*Dd*f**3*r**2 + 1600*C*D1*Dd*f**3*r*s - 1200*C*D1*Dd*f**3*r + 800*C*D1*Dd*f**3*s**2 - 1200*C*D1*Dd*f**3*s + 600*C*D1*Dd*f**3 - 6720*C*D1*Dd*f**2*fd*r**2 - 13440*C*D1*Dd*f**2*fd*r*s + 9520*C*D1*Dd*f**2*fd*r - 6720*C*D1*Dd*f**2*fd*s**2 + 9520*C*D1*Dd*f**2*fd*s - 3360*C*D1*Dd*f**2*fd - 1120*C*D1*Ddd*f**3*r**2 - 2240*C*D1*Ddd*f**3*r*s + 1680*C*D1*Ddd*f**3*r - 1120*C*D1*Ddd*f**3*s**2 + 1680*C*D1*Ddd*f**3*s - 840*C*D1*Ddd*f**3 - 3360*C*Dd**2*f**3*r**2 - 6720*C*Dd**2*f**3*r*s + 5040*C*Dd**2*f**3*r - 3360*C*Dd**2*f**3*s**2 + 5040*C*Dd**2*f**3*s - 1680*C*Dd**2*f**3 - 180*D1**2*K*bdd1*f**2*r**2 - 360*D1**2*K*bdd1*f**2*r*s + 360*D1**2*K*bdd1*f**2*r - 180*D1**2*K*bdd1*f**2*s**2 + 360*D1**2*K*bdd1*f**2*s - 180*D1**2*K*bdd1*f**2 + 18*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 + 135*D1**2*bdd1*f**2*r**2 + 270*D1**2*bdd1*f**2*r*s - 270*D1**2*bdd1*f**2*r + 135*D1**2*bdd1*f**2*s**2 - 270*D1**2*bdd1*f**2*s + 135*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s - 504*D1**2*bdd1*f*g2*r + 252*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 - 165*D1**2*f**2*fd*r**2 - 330*D1**2*f**2*fd*r*s + 220*D1**2*f**2*fd*r - 165*D1**2*f**2*fd*s**2 + 220*D1**2*f**2*fd*s - 110*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd - 216*D1**2*f**2*gd2*r**2 - 432*D1**2*f**2*gd2*r*s + 432*D1**2*f**2*gd2*r - 216*D1**2*f**2*gd2*s**2 + 432*D1**2*f**2*gd2*s - 216*D1**2*f**2*gd2 + 360*D1**2*f**2*gdd2*r**2 + 720*D1**2*f**2*gdd2*r*s - 720*D1**2*f**2*gdd2*r + 360*D1**2*f**2*gdd2*s**2 - 720*D1**2*f**2*gdd2*s + 360*D1**2*f**2*gdd2 + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 432*D1**2*f*fd*g2*r**2 - 864*D1**2*f*fd*g2*r*s + 432*D1**2*f*fd*g2*r - 432*D1**2*f*fd*g2*s**2 + 432*D1**2*f*fd*g2*s - 216*D1**2*f*fd*g2 + 1440*D1**2*f*fd*gd2*r**2 + 2880*D1**2*f*fd*gd2*r*s - 2160*D1**2*f*fd*gd2*r + 1440*D1**2*f*fd*gd2*s**2 - 2160*D1**2*f*fd*gd2*s + 720*D1**2*f*fd*gd2 + 720*D1**2*f*fdd*g2*r**2 + 1440*D1**2*f*fdd*g2*r*s - 720*D1**2*f*fdd*g2*r + 720*D1**2*f*fdd*g2*s**2 - 720*D1**2*f*fdd*g2*s + 360*D1**2*f*fdd*g2 + 720*D1**2*fd**2*g2*r**2 + 1440*D1**2*fd**2*g2*r*s - 720*D1**2*fd**2*g2*r + 720*D1**2*fd**2*g2*s**2 - 720*D1**2*fd**2*g2*s - 220*D1*Dd*f**3*r**2 - 440*D1*Dd*f**3*r*s + 330*D1*Dd*f**3*r - 220*D1*Dd*f**3*s**2 + 330*D1*Dd*f**3*s - 165*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 864*D1*Dd*f**2*g2*r**2 - 1728*D1*Dd*f**2*g2*r*s + 1296*D1*Dd*f**2*g2*r - 864*D1*Dd*f**2*g2*s**2 + 1296*D1*Dd*f**2*g2*s - 648*D1*Dd*f**2*g2 + 2880*D1*Dd*f**2*gd2*r**2 + 5760*D1*Dd*f**2*gd2*r*s - 5040*D1*Dd*f**2*gd2*r + 2880*D1*Dd*f**2*gd2*s**2 - 5040*D1*Dd*f**2*gd2*s + 2160*D1*Dd*f**2*gd2 + 5760*D1*Dd*f*fd*g2*r**2 + 11520*D1*Dd*f*fd*g2*r*s - 7200*D1*Dd*f*fd*g2*r + 5760*D1*Dd*f*fd*g2*s**2 - 7200*D1*Dd*f*fd*g2*s + 2160*D1*Dd*f*fd*g2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 1440*D1*Ddd*f**2*g2*r**2 + 2880*D1*Ddd*f**2*g2*r*s - 2160*D1*Ddd*f**2*g2*r + 1440*D1*Ddd*f**2*g2*s**2 - 2160*D1*Ddd*f**2*g2*s + 1080*D1*Ddd*f**2*g2 + 9*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(40*C + 12*K - 23)*(r + s - 1) - 10*f*fd*(4*C + 4*K - 3)*(2*r + 2*s - 1) - 56*f*(g2 - gd2)*(r + s - 1) + 56*fd*g2*(r + s)) - 2*Dd*f*(5*f*(4*C + 4*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 4320*Dd**2*f**2*g2*r**2 + 8640*Dd**2*f**2*g2*r*s - 6480*Dd**2*f**2*g2*r + 4320*Dd**2*f**2*g2*s**2 - 6480*Dd**2*f**2*g2*s + 2160*Dd**2*f**2*g2 - 9*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(-80*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s + 80*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 80*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 240*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 240*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 400*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 46*D1**2*f*fd*r**2 + 92*D1**2*f*fd*r*s - 46*D1**2*f*fd*r + 46*D1**2*f*fd*s**2 - 46*D1**2*f*fd*s + 23*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 92*D1*Dd*f**2*r**2 + 184*D1*Dd*f**2*r*s - 138*D1*Dd*f**2*r + 92*D1*Dd*f**2*s**2 - 138*D1*Dd*f**2*s + 69*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(70*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**5*k1*k2**3*st**2*(-4656*C*D1**2*f**2*fd*r**2 + 2544*C*D1**2*f**2*fd*r*s + 2256*C*D1**2*f**2*fd*r + 7200*C*D1**2*f**2*fd*s**2 - 5648*C*D1**2*f**2*fd*s + 848*C*D1**2*f**2*fd + 2760*C*D1**2*f**2*fdd*r**2 - 840*C*D1**2*f**2*fdd*r*s - 1560*C*D1**2*f**2*fdd*r - 3600*C*D1**2*f**2*fdd*s**2 + 2680*C*D1**2*f**2*fdd*s - 280*C*D1**2*f**2*fdd + 5520*C*D1**2*f*fd**2*r**2 - 1680*C*D1**2*f*fd**2*r*s - 3120*C*D1**2*f*fd**2*r - 7200*C*D1**2*f*fd**2*s**2 + 5360*C*D1**2*f*fd**2*s - 280*C*D1**2*f*fd**2 - 6208*C*D1*Dd*f**3*r**2 + 3392*C*D1*Dd*f**3*r*s + 5360*C*D1*Dd*f**3*r + 9600*C*D1*Dd*f**3*s**2 - 6496*C*D1*Dd*f**3*s - 704*C*D1*Dd*f**3 + 22080*C*D1*Dd*f**2*fd*r**2 - 6720*C*D1*Dd*f**2*fd*r*s - 16440*C*D1*Dd*f**2*fd*r - 28800*C*D1*Dd*f**2*fd*s**2 + 19600*C*D1*Dd*f**2*fd*s + 440*C*D1*Dd*f**2*fd + 3680*C*D1*Ddd*f**3*r**2 - 1120*C*D1*Ddd*f**3*r*s - 3400*C*D1*Ddd*f**3*r - 4800*C*D1*Ddd*f**3*s**2 + 2960*C*D1*Ddd*f**3*s + 640*C*D1*Ddd*f**3 + 11040*C*Dd**2*f**3*r**2 - 3360*C*Dd**2*f**3*r*s - 10200*C*Dd**2*f**3*r - 14400*C*Dd**2*f**3*s**2 + 8880*C*Dd**2*f**3*s + 1280*C*Dd**2*f**3 - 2160*D1**2*K*b1*f*fd*r**2 + 2160*D1**2*K*b1*f*fd*r*s - 1080*D1**2*K*b1*f*fd*r + 4320*D1**2*K*b1*f*fd*s**2 - 4320*D1**2*K*b1*f*fd*s + 2160*D1**2*K*b1*f*fd + 1080*D1**2*K*b1*f*fdd*r**2 - 1080*D1**2*K*b1*f*fdd*r*s + 540*D1**2*K*b1*f*fdd*r - 2160*D1**2*K*b1*f*fdd*s**2 + 2160*D1**2*K*b1*f*fdd*s - 1080*D1**2*K*b1*f*fdd + 1080*D1**2*K*b1*fd**2*r**2 - 1080*D1**2*K*b1*fd**2*r*s + 540*D1**2*K*b1*fd**2*r - 2160*D1**2*K*b1*fd**2*s**2 + 2160*D1**2*K*b1*fd**2*s + 3150*D1**2*b1*f**2*fd*r**2 + 3780*D1**2*b1*f**2*fd*r*s - 3360*D1**2*b1*f**2*fd*r + 630*D1**2*b1*f**2*fd*s**2 - 1680*D1**2*b1*f**2*fd*s + 1260*D1**2*b1*f**2*fd - 1575*D1**2*b1*f**2*fdd*r**2 - 1890*D1**2*b1*f**2*fdd*r*s + 1680*D1**2*b1*f**2*fdd*r - 315*D1**2*b1*f**2*fdd*s**2 + 840*D1**2*b1*f**2*fdd*s - 630*D1**2*b1*f**2*fdd - 3150*D1**2*b1*f*fd**2*r**2 - 3780*D1**2*b1*f*fd**2*r*s + 3360*D1**2*b1*f*fd**2*r - 630*D1**2*b1*f*fd**2*s**2 + 1680*D1**2*b1*f*fd**2*s - 630*D1**2*b1*f*fd**2 + 4860*D1**2*b1*f*fd*r**2 + 5400*D1**2*b1*f*fd*r*s - 2700*D1**2*b1*f*fd*r + 540*D1**2*b1*f*fd*s**2 - 540*D1**2*b1*f*fd*s + 270*D1**2*b1*f*fd - 2430*D1**2*b1*f*fdd*r**2 - 2700*D1**2*b1*f*fdd*r*s + 1350*D1**2*b1*f*fdd*r - 270*D1**2*b1*f*fdd*s**2 + 270*D1**2*b1*f*fdd*s - 135*D1**2*b1*f*fdd - 2430*D1**2*b1*fd**2*r**2 - 2700*D1**2*b1*fd**2*r*s + 1350*D1**2*b1*fd**2*r - 270*D1**2*b1*fd**2*s**2 + 270*D1**2*b1*fd**2*s - 15*D1**2*bdd1*f**2*(r + s - 1)*(9*K*(-4*r + 8*s + 4) + 7*f*(5*r + s - 5) + 81*r + 9*s - 81) - 1680*D1**2*f**3*fd*r**2 - 1680*D1**2*f**3*fd*r*s + 2100*D1**2*f**3*fd*r + 840*D1**2*f**3*fd*s - 840*D1**2*f**3*fd + 1680*D1**2*f**3*fdd*r**2 + 1680*D1**2*f**3*fdd*r*s - 2100*D1**2*f**3*fdd*r - 840*D1**2*f**3*fdd*s + 840*D1**2*f**3*fdd + 5040*D1**2*f**2*fd**2*r**2 + 5040*D1**2*f**2*fd**2*r*s - 6300*D1**2*f**2*fd**2*r - 2520*D1**2*f**2*fd**2*s + 1680*D1**2*f**2*fd**2 + 6906*D1**2*f**2*fd*r**2 + 3756*D1**2*f**2*fd*r*s - 5856*D1**2*f**2*fd*r - 3150*D1**2*f**2*fd*s**2 + 848*D1**2*f**2*fd*s + 1252*D1**2*f**2*fd - 3885*D1**2*f**2*fdd*r**2 - 2310*D1**2*f**2*fdd*r*s + 3360*D1**2*f**2*fdd*r + 1575*D1**2*f**2*fdd*s**2 - 280*D1**2*f**2*fdd*s - 770*D1**2*f**2*fdd + 2160*D1**2*f**2*gd2*r**2 - 2160*D1**2*f**2*gd2*r*s - 4320*D1**2*f**2*gd2*r - 4320*D1**2*f**2*gd2*s**2 + 2160*D1**2*f**2*gd2*s + 2160*D1**2*f**2*gd2 - 1080*D1**2*f**2*gdd2*r**2 + 1080*D1**2*f**2*gdd2*r*s + 2160*D1**2*f**2*gdd2*r + 2160*D1**2*f**2*gdd2*s**2 - 1080*D1**2*f**2*gdd2*s - 1080*D1**2*f**2*gdd2 - 7770*D1**2*f*fd**2*r**2 - 4620*D1**2*f*fd**2*r*s + 6720*D1**2*f*fd**2*r + 3150*D1**2*f*fd**2*s**2 - 560*D1**2*f*fd**2*s - 770*D1**2*f*fd**2 + 4320*D1**2*f*fd*g2*r**2 - 4320*D1**2*f*fd*g2*r*s + 2160*D1**2*f*fd*g2*r - 8640*D1**2*f*fd*g2*s**2 + 8640*D1**2*f*fd*g2*s - 4320*D1**2*f*fd*g2 - 4320*D1**2*f*fd*gd2*r**2 + 4320*D1**2*f*fd*gd2*r*s + 3240*D1**2*f*fd*gd2*r + 8640*D1**2*f*fd*gd2*s**2 - 6480*D1**2*f*fd*gd2*s + 1080*D1**2*f*fd*gd2 - 2160*D1**2*f*fdd*g2*r**2 + 2160*D1**2*f*fdd*g2*r*s - 1080*D1**2*f*fdd*g2*r + 4320*D1**2*f*fdd*g2*s**2 - 4320*D1**2*f*fdd*g2*s + 2160*D1**2*f*fdd*g2 - 2160*D1**2*fd**2*g2*r**2 + 2160*D1**2*fd**2*g2*r*s - 1080*D1**2*fd**2*g2*r + 4320*D1**2*fd**2*g2*s**2 - 4320*D1**2*fd**2*g2*s - 4320*D1*Dd*K*b1*f**2*r**2 + 4320*D1*Dd*K*b1*f**2*r*s + 3240*D1*Dd*K*b1*f**2*r + 8640*D1*Dd*K*b1*f**2*s**2 - 6480*D1*Dd*K*b1*f**2*s + 8640*D1*Dd*K*b1*f*fd*r**2 - 8640*D1*Dd*K*b1*f*fd*r*s - 1080*D1*Dd*K*b1*f*fd*r - 17280*D1*Dd*K*b1*f*fd*s**2 + 15120*D1*Dd*K*b1*f*fd*s - 3240*D1*Dd*K*b1*f*fd + 4200*D1*Dd*b1*f**3*r**2 + 5040*D1*Dd*b1*f**3*r*s - 5460*D1*Dd*b1*f**3*r + 840*D1*Dd*b1*f**3*s**2 - 2940*D1*Dd*b1*f**3*s + 2310*D1*Dd*b1*f**3 - 12600*D1*Dd*b1*f**2*fd*r**2 - 15120*D1*Dd*b1*f**2*fd*r*s + 14910*D1*Dd*b1*f**2*fd*r - 2520*D1*Dd*b1*f**2*fd*s**2 + 7770*D1*Dd*b1*f**2*fd*s - 4200*D1*Dd*b1*f**2*fd + 9720*D1*Dd*b1*f**2*r**2 + 10800*D1*Dd*b1*f**2*r*s - 12420*D1*Dd*b1*f**2*r + 1080*D1*Dd*b1*f**2*s**2 - 5940*D1*Dd*b1*f**2*s + 5130*D1*Dd*b1*f**2 - 19440*D1*Dd*b1*f*fd*r**2 - 21600*D1*Dd*b1*f*fd*r*s + 17820*D1*Dd*b1*f*fd*r - 2160*D1*Dd*b1*f*fd*s**2 + 7020*D1*Dd*b1*f*fd*s - 2970*D1*Dd*b1*f*fd - 1680*D1*Dd*f**4*r**2 - 1680*D1*Dd*f**4*r*s + 2100*D1*Dd*f**4*r + 840*D1*Dd*f**4*s - 840*D1*Dd*f**4 + 13440*D1*Dd*f**3*fd*r**2 + 13440*D1*Dd*f**3*fd*r*s - 16800*D1*Dd*f**3*fd*r - 6720*D1*Dd*f**3*fd*s + 5040*D1*Dd*f**3*fd + 9208*D1*Dd*f**3*r**2 + 5008*D1*Dd*f**3*r*s - 10460*D1*Dd*f**3*r - 4200*D1*Dd*f**3*s**2 - 404*D1*Dd*f**3*s + 3554*D1*Dd*f**3 - 31080*D1*Dd*f**2*fd*r**2 - 18480*D1*Dd*f**2*fd*r*s + 31290*D1*Dd*f**2*fd*r + 12600*D1*Dd*f**2*fd*s**2 + 350*D1*Dd*f**2*fd*s - 6440*D1*Dd*f**2*fd + 8640*D1*Dd*f**2*g2*r**2 - 8640*D1*Dd*f**2*g2*r*s - 6480*D1*Dd*f**2*g2*r - 17280*D1*Dd*f**2*g2*s**2 + 12960*D1*Dd*f**2*g2*s - 8640*D1*Dd*f**2*gd2*r**2 + 8640*D1*Dd*f**2*gd2*r*s + 11880*D1*Dd*f**2*gd2*r + 17280*D1*Dd*f**2*gd2*s**2 - 10800*D1*Dd*f**2*gd2*s - 3240*D1*Dd*f**2*gd2 - 17280*D1*Dd*f*fd*g2*r**2 + 17280*D1*Dd*f*fd*g2*r*s + 2160*D1*Dd*f*fd*g2*r + 34560*D1*Dd*f*fd*g2*s**2 - 30240*D1*Dd*f*fd*g2*s + 6480*D1*Dd*f*fd*g2 + 2160*D1*Ddd*K*b1*f**2*r**2 - 2160*D1*Ddd*K*b1*f**2*r*s - 1620*D1*Ddd*K*b1*f**2*r - 4320*D1*Ddd*K*b1*f**2*s**2 + 3240*D1*Ddd*K*b1*f**2*s - 2100*D1*Ddd*b1*f**3*r**2 - 2520*D1*Ddd*b1*f**3*r*s + 2730*D1*Ddd*b1*f**3*r - 420*D1*Ddd*b1*f**3*s**2 + 1470*D1*Ddd*b1*f**3*s - 1155*D1*Ddd*b1*f**3 - 4860*D1*Ddd*b1*f**2*r**2 - 5400*D1*Ddd*b1*f**2*r*s + 6210*D1*Ddd*b1*f**2*r - 540*D1*Ddd*b1*f**2*s**2 + 2970*D1*Ddd*b1*f**2*s - 2565*D1*Ddd*b1*f**2 + 1680*D1*Ddd*f**4*r**2 + 1680*D1*Ddd*f**4*r*s - 2100*D1*Ddd*f**4*r - 840*D1*Ddd*f**4*s + 840*D1*Ddd*f**4 - 5180*D1*Ddd*f**3*r**2 - 3080*D1*Ddd*f**3*r*s + 5950*D1*Ddd*f**3*r + 2100*D1*Ddd*f**3*s**2 + 490*D1*Ddd*f**3*s - 2065*D1*Ddd*f**3 - 4320*D1*Ddd*f**2*g2*r**2 + 4320*D1*Ddd*f**2*g2*r*s + 3240*D1*Ddd*f**2*g2*r + 8640*D1*Ddd*f**2*g2*s**2 - 6480*D1*Ddd*f**2*g2*s + 30*D1*bd1*f*(7*D1*f**2*(5*r**2 + 2*r*(3*s - 5) + s**2 - 6*s + 5) + D1*f*(-7*fd*(15*r**2 + r*(18*s - 23) + 3*s**2 - 13*s + 8) + (r + s - 1)*(-36*K*(r - 2*s - 1) + 81*r + 9*s - 81)) + 9*D1*fd*(2*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 18*r**2 - 20*r*s + 23*r - 2*s**2 + 11*s - 5) - 7*Dd*f**2*(20*r**2 + 3*r*(8*s - 11) + 4*s**2 - 19*s + 13) + 9*Dd*f*(2*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 36*r**2 - 40*r*s + 59*r - 4*s**2 + 31*s - 23)) + 6480*Dd**2*K*b1*f**2*r**2 - 6480*Dd**2*K*b1*f**2*r*s - 4860*Dd**2*K*b1*f**2*r - 12960*Dd**2*K*b1*f**2*s**2 + 9720*Dd**2*K*b1*f**2*s - 6300*Dd**2*b1*f**3*r**2 - 7560*Dd**2*b1*f**3*r*s + 8190*Dd**2*b1*f**3*r - 1260*Dd**2*b1*f**3*s**2 + 4410*Dd**2*b1*f**3*s - 2310*Dd**2*b1*f**3 - 14580*Dd**2*b1*f**2*r**2 - 16200*Dd**2*b1*f**2*r*s + 18630*Dd**2*b1*f**2*r - 1620*Dd**2*b1*f**2*s**2 + 8910*Dd**2*b1*f**2*s - 5130*Dd**2*b1*f**2 + 5040*Dd**2*f**4*r**2 + 5040*Dd**2*f**4*r*s - 6300*Dd**2*f**4*r - 2520*Dd**2*f**4*s + 1680*Dd**2*f**4 - 15540*Dd**2*f**3*r**2 - 9240*Dd**2*f**3*r*s + 17850*Dd**2*f**3*r + 6300*Dd**2*f**3*s**2 + 1470*Dd**2*f**3*s - 4130*Dd**2*f**3 - 12960*Dd**2*f**2*g2*r**2 + 12960*Dd**2*f**2*g2*r*s + 9720*Dd**2*f**2*g2*r + 25920*Dd**2*f**2*g2*s**2 - 19440*Dd**2*f**2*g2*s)/(630*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**5*k1*k2**3*(-396*C*D1**2*bdd1*f**2*r**2 - 1296*C*D1**2*bdd1*f**2*r*s - 504*C*D1**2*bdd1*f**2*r - 900*C*D1**2*bdd1*f**2*s**2 - 13080*C*D1**2*f**2*fd*r**2 - 25320*C*D1**2*f**2*fd*r*s + 17160*C*D1**2*f**2*fd*r - 12240*C*D1**2*f**2*fd*s**2 + 16600*C*D1**2*f**2*fd*s - 8440*C*D1**2*f**2*fd + 10860*C*D1**2*f**2*fdd*r**2 + 20760*C*D1**2*f**2*fdd*r*s - 14160*C*D1**2*f**2*fdd*r + 9900*C*D1**2*f**2*fdd*s**2 - 13520*C*D1**2*f**2*fdd*s + 6920*C*D1**2*f**2*fdd + 21720*C*D1**2*f*fd**2*r**2 + 41520*C*D1**2*f*fd**2*r*s - 28320*C*D1**2*f*fd**2*r + 19800*C*D1**2*f*fd**2*s**2 - 27040*C*D1**2*f*fd**2*s + 6920*C*D1**2*f*fd**2 - 17440*C*D1*Dd*f**3*r**2 - 33760*C*D1*Dd*f**3*r*s + 25880*C*D1*Dd*f**3*r - 16320*C*D1*Dd*f**3*s**2 + 25040*C*D1*Dd*f**3*s - 12800*C*D1*Dd*f**3 + 86880*C*D1*Dd*f**2*fd*r**2 + 166080*C*D1*Dd*f**2*fd*r*s - 120840*C*D1*Dd*f**2*fd*r + 79200*C*D1*Dd*f**2*fd*s**2 - 115400*C*D1*Dd*f**2*fd*s + 41840*C*D1*Dd*f**2*fd + 14480*C*D1*Ddd*f**3*r**2 + 27680*C*D1*Ddd*f**3*r*s - 21400*C*D1*Ddd*f**3*r + 13200*C*D1*Ddd*f**3*s**2 - 20440*C*D1*Ddd*f**3*s + 10540*C*D1*Ddd*f**3 + 43440*C*Dd**2*f**3*r**2 + 83040*C*Dd**2*f**3*r*s - 64200*C*Dd**2*f**3*r + 39600*C*Dd**2*f**3*s**2 - 61320*C*Dd**2*f**3*s + 21080*C*Dd**2*f**3 + 2070*D1**2*K*bdd1*f**2*r**2 + 4284*D1**2*K*bdd1*f**2*r*s - 4140*D1**2*K*bdd1*f**2*r + 2214*D1**2*K*bdd1*f**2*s**2 - 4284*D1**2*K*bdd1*f**2*s + 2070*D1**2*K*bdd1*f**2 - 2340*D1**2*b2*f*fd*r**2 - 4680*D1**2*b2*f*fd*r*s + 2340*D1**2*b2*f*fd*r - 2340*D1**2*b2*f*fd*s**2 + 2340*D1**2*b2*f*fd*s - 1170*D1**2*b2*f*fd + 1800*D1**2*b2*f*fdd*r**2 + 3600*D1**2*b2*f*fdd*r*s - 1800*D1**2*b2*f*fdd*r + 1800*D1**2*b2*f*fdd*s**2 - 1800*D1**2*b2*f*fdd*s + 900*D1**2*b2*f*fdd + 1800*D1**2*b2*fd**2*r**2 + 3600*D1**2*b2*fd**2*r*s - 1800*D1**2*b2*fd**2*r + 1800*D1**2*b2*fd**2*s**2 - 1800*D1**2*b2*fd**2*s + 18*D1**2*bd1**2*f*(r + s - 1)*(-14*K*(3*r + 5*s + 1) + 25*f - 28*r + 49) - 1170*D1**2*bd2*f**2*r**2 - 2340*D1**2*bd2*f**2*r*s + 2340*D1**2*bd2*f**2*r - 1170*D1**2*bd2*f**2*s**2 + 2340*D1**2*bd2*f**2*s - 1170*D1**2*bd2*f**2 + 3600*D1**2*bd2*f*fd*r**2 + 7200*D1**2*bd2*f*fd*r*s - 5400*D1**2*bd2*f*fd*r + 3600*D1**2*bd2*f*fd*s**2 - 5400*D1**2*bd2*f*fd*s + 1800*D1**2*bd2*f*fd - 495*D1**2*bdd1*f**3*r**2 - 990*D1**2*bdd1*f**3*r*s + 1170*D1**2*bdd1*f**3*r - 495*D1**2*bdd1*f**3*s**2 + 1170*D1**2*bdd1*f**3*s - 675*D1**2*bdd1*f**3 - 639*D1**2*bdd1*f**2*r**2 - 846*D1**2*bdd1*f**2*r*s + 2124*D1**2*bdd1*f**2*r - 207*D1**2*bdd1*f**2*s**2 + 1692*D1**2*bdd1*f**2*s - 810*D1**2*bdd1*f**2 + 756*D1**2*bdd1*f*g2*r**2 + 2016*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r + 1260*D1**2*bdd1*f*g2*s**2 + 900*D1**2*bdd2*f**2*r**2 + 1800*D1**2*bdd2*f**2*r*s - 1800*D1**2*bdd2*f**2*r + 900*D1**2*bdd2*f**2*s**2 - 1800*D1**2*bdd2*f**2*s + 900*D1**2*bdd2*f**2 + 7440*D1**2*f**2*fd*r**2 + 14520*D1**2*f**2*fd*r*s - 9800*D1**2*f**2*fd*r + 7080*D1**2*f**2*fd*s**2 - 9560*D1**2*f**2*fd*s + 4840*D1**2*f**2*fd - 7095*D1**2*f**2*fdd*r**2 - 13470*D1**2*f**2*fdd*r*s + 9220*D1**2*f**2*fdd*r - 6375*D1**2*f**2*fdd*s**2 + 8740*D1**2*f**2*fdd*s - 4490*D1**2*f**2*fdd + 4248*D1**2*f**2*gd2*r**2 + 9576*D1**2*f**2*gd2*r*s - 8496*D1**2*f**2*gd2*r + 5328*D1**2*f**2*gd2*s**2 - 9576*D1**2*f**2*gd2*s + 4248*D1**2*f**2*gd2 - 4140*D1**2*f**2*gdd2*r**2 - 8568*D1**2*f**2*gdd2*r*s + 8280*D1**2*f**2*gdd2*r - 4428*D1**2*f**2*gdd2*s**2 + 8568*D1**2*f**2*gdd2*s - 4140*D1**2*f**2*gdd2 - 14190*D1**2*f*fd**2*r**2 - 26940*D1**2*f*fd**2*r*s + 18440*D1**2*f*fd**2*r - 12750*D1**2*f*fd**2*s**2 + 17480*D1**2*f*fd**2*s - 4490*D1**2*f*fd**2 + 8496*D1**2*f*fd*g2*r**2 + 19152*D1**2*f*fd*g2*r*s - 9576*D1**2*f*fd*g2*r + 10656*D1**2*f*fd*g2*s**2 - 10656*D1**2*f*fd*g2*s + 5328*D1**2*f*fd*g2 - 16560*D1**2*f*fd*gd2*r**2 - 34272*D1**2*f*fd*gd2*r*s + 25128*D1**2*f*fd*gd2*r - 17712*D1**2*f*fd*gd2*s**2 + 25992*D1**2*f*fd*gd2*s - 8568*D1**2*f*fd*gd2 - 8280*D1**2*f*fdd*g2*r**2 - 17136*D1**2*f*fdd*g2*r*s + 8568*D1**2*f*fdd*g2*r - 8856*D1**2*f*fdd*g2*s**2 + 8856*D1**2*f*fdd*g2*s - 4428*D1**2*f*fdd*g2 - 8280*D1**2*fd**2*g2*r**2 - 17136*D1**2*fd**2*g2*r*s + 8568*D1**2*fd**2*g2*r - 8856*D1**2*fd**2*g2*s**2 + 8856*D1**2*fd**2*g2*s - 4680*D1*Dd*b2*f**2*r**2 - 9360*D1*Dd*b2*f**2*r*s + 7020*D1*Dd*b2*f**2*r - 4680*D1*Dd*b2*f**2*s**2 + 7020*D1*Dd*b2*f**2*s - 3510*D1*Dd*b2*f**2 + 14400*D1*Dd*b2*f*fd*r**2 + 28800*D1*Dd*b2*f*fd*r*s - 18000*D1*Dd*b2*f*fd*r + 14400*D1*Dd*b2*f*fd*s**2 - 18000*D1*Dd*b2*f*fd*s + 5400*D1*Dd*b2*f*fd + 7200*D1*Dd*bd2*f**2*r**2 + 14400*D1*Dd*bd2*f**2*r*s - 12600*D1*Dd*bd2*f**2*r + 7200*D1*Dd*bd2*f**2*s**2 - 12600*D1*Dd*bd2*f**2*s + 5400*D1*Dd*bd2*f**2 + 9920*D1*Dd*f**3*r**2 + 19360*D1*Dd*f**3*r*s - 14760*D1*Dd*f**3*r + 9440*D1*Dd*f**3*s**2 - 14400*D1*Dd*f**3*s + 7320*D1*Dd*f**3 - 56760*D1*Dd*f**2*fd*r**2 - 107760*D1*Dd*f**2*fd*r*s + 78730*D1*Dd*f**2*fd*r - 51000*D1*Dd*f**2*fd*s**2 + 74650*D1*Dd*f**2*fd*s - 27180*D1*Dd*f**2*fd + 16992*D1*Dd*f**2*g2*r**2 + 38304*D1*Dd*f**2*g2*r*s - 26568*D1*Dd*f**2*g2*r + 21312*D1*Dd*f**2*g2*s**2 - 29808*D1*Dd*f**2*g2*s + 13824*D1*Dd*f**2*g2 - 33120*D1*Dd*f**2*gd2*r**2 - 68544*D1*Dd*f**2*gd2*r*s + 58248*D1*Dd*f**2*gd2*r - 35424*D1*Dd*f**2*gd2*s**2 + 60264*D1*Dd*f**2*gd2*s - 25128*D1*Dd*f**2*gd2 - 66240*D1*Dd*f*fd*g2*r**2 - 137088*D1*Dd*f*fd*g2*r*s + 84528*D1*Dd*f*fd*g2*r - 70848*D1*Dd*f*fd*g2*s**2 + 87408*D1*Dd*f*fd*g2*s - 25992*D1*Dd*f*fd*g2 + 3600*D1*Ddd*b2*f**2*r**2 + 7200*D1*Ddd*b2*f**2*r*s - 5400*D1*Ddd*b2*f**2*r + 3600*D1*Ddd*b2*f**2*s**2 - 5400*D1*Ddd*b2*f**2*s + 2700*D1*Ddd*b2*f**2 - 9460*D1*Ddd*f**3*r**2 - 17960*D1*Ddd*f**3*r*s + 13950*D1*Ddd*f**3*r - 8500*D1*Ddd*f**3*s**2 + 13230*D1*Ddd*f**3*s - 6855*D1*Ddd*f**3 - 16560*D1*Ddd*f**2*g2*r**2 - 34272*D1*Ddd*f**2*g2*r*s + 25128*D1*Ddd*f**2*g2*r - 17712*D1*Ddd*f**2*g2*s**2 + 25992*D1*Ddd*f**2*g2*s - 12708*D1*Ddd*f**2*g2 + 18*D1*bd1*(D1*(10*f**3*(r**2 + 3*r*(s - 1) + 2*(s - 1)**2) - f**2*(-44*C*r**2 - 144*C*r*s - 56*C*r - 100*C*s**2 + 2*K*(59*r**2 + 133*r*s - 118*r + 74*s**2 - 133*s + 59) + 5*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) - 8*r**2 + 18*r*s + 110*r + 26*s**2 + 76*s - 27) - 2*f*(fd*(2*C*(22*r**2 + r*(72*s - 22) + 50*s**2 - 43*s - 7) - K*(230*r**2 + 476*r*s - 349*r + 246*s**2 - 361*s + 119) + 71*r**2 + 94*r*s - 118*r + 23*s**2 - 82*s + 61) + 14*g2*(3*r**2 + r*(8*s + 2) + 5*s**2) + 14*gd2*(-3*r**2 + r*(2 - 8*s) - 5*s**2 + 4*s + 1)) + 28*fd*g2*(3*r**2 + r*(8*s - 4) + s*(5*s - 5))) - Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + f*(4*C*(44*r**2 + 12*r*(12*s - 1) + 100*s**2 - 61*s - 14) - 2*K*(460*r**2 + 952*r*s - 809*r + 492*s**2 - 837*s + 349) + 284*r**2 + 376*r*s - 661*r + 92*s**2 - 493*s + 330) - 28*g2*(12*r**2 + r*(32*s - 6) + 20*s**2 - 13*s - 2))) + 10800*Dd**2*b2*f**2*r**2 + 21600*Dd**2*b2*f**2*r*s - 16200*Dd**2*b2*f**2*r + 10800*Dd**2*b2*f**2*s**2 - 16200*Dd**2*b2*f**2*s + 5400*Dd**2*b2*f**2 - 28380*Dd**2*f**3*r**2 - 53880*Dd**2*f**3*r*s + 41850*Dd**2*f**3*r - 25500*Dd**2*f**3*s**2 + 39690*Dd**2*f**3*s - 13710*Dd**2*f**3 - 49680*Dd**2*f**2*g2*r**2 - 102816*Dd**2*f**2*g2*r*s + 75384*Dd**2*f**2*g2*r - 53136*Dd**2*f**2*g2*s**2 + 77976*Dd**2*f**2*g2*s - 25416*Dd**2*f**2*g2 + 9*b1**2*(D1**2*(50*f*fd*(2*r + 2*s - 1) - 25*f*fdd*(2*r + 2*s - 1) - 50*fd**2*(r + s - 1) + 14*fd*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 2*r*(2*s + 5) + 10*s - 5) - 7*fdd*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 2*r*(2*s + 5) + 10*s - 5)) - 2*D1*(Dd*(f*(-14*K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 25*fd*(4*r + 4*s - 3) - 112*r**2 - 112*r*s + 140*r + 56*s - 56) + 7*fd*(K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 16*r**2 + 2*r*(8*s + 5) + 16*s - 15)) + 7*Ddd*f*(K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 8*r**2 + 2*r*(4*s - 5) - 4*s + 4)) - 28*Dd**2*f*(K*(18*r**2 + 6*r*(8*s - 5) + 30*s**2 - 39*s + 11) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) - 9*b1*(-176*C*D1**2*f*fd*r**2 - 576*C*D1**2*f*fd*r*s + 576*C*D1**2*f*fd*r - 400*C*D1**2*f*fd*s**2 + 688*C*D1**2*f*fd*s - 288*C*D1**2*f*fd + 88*C*D1**2*f*fdd*r**2 + 288*C*D1**2*f*fdd*r*s - 288*C*D1**2*f*fdd*r + 200*C*D1**2*f*fdd*s**2 - 344*C*D1**2*f*fdd*s + 144*C*D1**2*f*fdd + 88*C*D1**2*fd**2*r**2 + 288*C*D1**2*fd**2*r*s - 288*C*D1**2*fd**2*r + 200*C*D1**2*fd**2*s**2 - 344*C*D1**2*fd**2*s + 200*C*D1**2*fd**2 - 352*C*D1*Dd*f**2*r**2 - 1152*C*D1*Dd*f**2*r*s + 640*C*D1*Dd*f**2*r - 800*C*D1*Dd*f**2*s**2 + 976*C*D1*Dd*f**2*s - 376*C*D1*Dd*f**2 + 704*C*D1*Dd*f*fd*r**2 + 2304*C*D1*Dd*f*fd*r*s - 1792*C*D1*Dd*f*fd*r + 1600*C*D1*Dd*f*fd*s**2 - 2352*C*D1*Dd*f*fd*s + 920*C*D1*Dd*f*fd + 176*C*D1*Ddd*f**2*r**2 + 576*C*D1*Ddd*f**2*r*s - 320*C*D1*Ddd*f**2*r + 400*C*D1*Ddd*f**2*s**2 - 488*C*D1*Ddd*f**2*s + 188*C*D1*Ddd*f**2 + 528*C*Dd**2*f**2*r**2 + 1728*C*Dd**2*f**2*r*s - 960*C*Dd**2*f**2*r + 1200*C*Dd**2*f**2*s**2 - 1464*C*Dd**2*f**2*s + 376*C*Dd**2*f**2 + 472*D1**2*K*f*fd*r**2 + 1064*D1**2*K*f*fd*r*s - 532*D1**2*K*f*fd*r + 592*D1**2*K*f*fd*s**2 - 592*D1**2*K*f*fd*s + 296*D1**2*K*f*fd - 460*D1**2*K*f*fdd*r**2 - 952*D1**2*K*f*fdd*r*s + 476*D1**2*K*f*fdd*r - 492*D1**2*K*f*fdd*s**2 + 492*D1**2*K*f*fdd*s - 246*D1**2*K*f*fdd - 460*D1**2*K*fd**2*r**2 - 952*D1**2*K*fd**2*r*s + 476*D1**2*K*fd**2*r - 492*D1**2*K*fd**2*s**2 + 492*D1**2*K*fd**2*s + D1**2*bdd1*f*(14*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) - 25*f*(2*r + 2*s - 1) + 56*r**2 + 56*r*s - 154*r - 98*s + 63) - 60*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 80*D1**2*f**2*fd*r - 120*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 40*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 32*D1**2*f*fd*r**2 + 72*D1**2*f*fd*r*s - 224*D1**2*f*fd*r + 104*D1**2*f*fd*s**2 - 292*D1**2*f*fd*s + 90*D1**2*f*fd + 142*D1**2*f*fdd*r**2 + 188*D1**2*f*fdd*r*s + 46*D1**2*f*fdd*s**2 + 48*D1**2*f*fdd*s + 4*D1**2*f*fdd + 168*D1**2*f*gd2*r**2 + 448*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r + 280*D1**2*f*gd2*s**2 - 448*D1**2*f*gd2*s + 168*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 224*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 140*D1**2*f*gdd2*s**2 + 224*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 + 142*D1**2*fd**2*r**2 + 188*D1**2*fd**2*r*s + 46*D1**2*fd**2*s**2 + 48*D1**2*fd**2*s - 150*D1**2*fd**2 + 168*D1**2*fd*g2*r**2 + 448*D1**2*fd*g2*r*s - 560*D1**2*fd*g2*r + 280*D1**2*fd*g2*s**2 - 560*D1**2*fd*g2*s + 280*D1**2*fd*g2 - 168*D1**2*fd*gd2*r**2 - 448*D1**2*fd*gd2*r*s + 448*D1**2*fd*gd2*r - 280*D1**2*fd*gd2*s**2 + 504*D1**2*fd*gd2*s - 280*D1**2*fd*gd2 - 84*D1**2*fdd*g2*r**2 - 224*D1**2*fdd*g2*r*s + 280*D1**2*fdd*g2*r - 140*D1**2*fdd*g2*s**2 + 280*D1**2*fdd*g2*s - 140*D1**2*fdd*g2 + 944*D1*Dd*K*f**2*r**2 + 2128*D1*Dd*K*f**2*r*s - 1476*D1*Dd*K*f**2*r + 1184*D1*Dd*K*f**2*s**2 - 1656*D1*Dd*K*f**2*s + 768*D1*Dd*K*f**2 - 3680*D1*Dd*K*f*fd*r**2 - 7616*D1*Dd*K*f*fd*r*s + 4696*D1*Dd*K*f*fd*r - 3936*D1*Dd*K*f*fd*s**2 + 4856*D1*Dd*K*f*fd*s - 1444*D1*Dd*K*f*fd - 80*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 140*D1*Dd*f**3*r - 160*D1*Dd*f**3*s**2 + 200*D1*Dd*f**3*s - 80*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1790*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 64*D1*Dd*f**2*r**2 + 144*D1*Dd*f**2*r*s + 28*D1*Dd*f**2*r + 208*D1*Dd*f**2*s**2 - 176*D1*Dd*f**2*s + 20*D1*Dd*f**2 + 1136*D1*Dd*f*fd*r**2 + 1504*D1*Dd*f*fd*r*s - 756*D1*Dd*f*fd*r + 368*D1*Dd*f*fd*s**2 - 276*D1*Dd*f*fd*s - 48*D1*Dd*f*fd + 672*D1*Dd*f*g2*r**2 + 1792*D1*Dd*f*g2*r*s - 1120*D1*Dd*f*g2*r + 1120*D1*Dd*f*g2*s**2 - 1456*D1*Dd*f*g2*s + 616*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1792*D1*Dd*f*gd2*r*s + 1232*D1*Dd*f*gd2*r - 1120*D1*Dd*f*gd2*s**2 + 1624*D1*Dd*f*gd2*s - 560*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1792*D1*Dd*fd*g2*r*s + 1680*D1*Dd*fd*g2*r - 1120*D1*Dd*fd*g2*s**2 + 1848*D1*Dd*fd*g2*s - 840*D1*Dd*fd*g2 - 920*D1*Ddd*K*f**2*r**2 - 1904*D1*Ddd*K*f**2*r*s + 1396*D1*Ddd*K*f**2*r - 984*D1*Ddd*K*f**2*s**2 + 1444*D1*Ddd*K*f**2*s - 706*D1*Ddd*K*f**2 + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 284*D1*Ddd*f**2*r**2 + 376*D1*Ddd*f**2*r*s - 378*D1*Ddd*f**2*r + 92*D1*Ddd*f**2*s**2 - 234*D1*Ddd*f**2*s + 165*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 896*D1*Ddd*f*g2*r*s + 560*D1*Ddd*f*g2*r - 560*D1*Ddd*f*g2*s**2 + 728*D1*Ddd*f*g2*s - 308*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(25*f**2*(2*r + 2*s - 1) - 7*f*(2*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) + 8*r**2 + 8*r*s - 22*r - 14*s + 9) + 7*fd*(2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) + 8*r**2 + 8*r*s - r + 3*s - 5)) + Dd*f*(28*K*(12*r**2 + 2*r*(16*s - 7) + 20*s**2 - 21*s + 4) - 25*f*(4*r + 4*s - 3) + 224*r**2 + 224*r*(s - 2) - 252*s + 203)) - 2760*Dd**2*K*f**2*r**2 - 5712*Dd**2*K*f**2*r*s + 4188*Dd**2*K*f**2*r - 2952*Dd**2*K*f**2*s**2 + 4332*Dd**2*K*f**2*s - 1412*Dd**2*K*f**2 + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 330*Dd**2*f**3 + 852*Dd**2*f**2*r**2 + 1128*Dd**2*f**2*r*s - 1134*Dd**2*f**2*r + 276*Dd**2*f**2*s**2 - 702*Dd**2*f**2*s + 330*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2688*Dd**2*f*g2*r*s + 1680*Dd**2*f*g2*r - 1680*Dd**2*f*g2*s**2 + 2184*Dd**2*f*g2*s - 616*Dd**2*f*g2))/(630*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**5*k1*k2*st**2*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(-7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 18*r*(4*s - 1) + 18*(1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(7*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(7*bdd1*f**2*s*(r + s - 1) + f*(9*bdd1*s*(r + s - 1) - 10*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 2*f*s*(7*f + 9)*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 5*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**5*k1*k2*(504*C*D1**2*bdd1*f**2*r**2 - 216*C*D1**2*bdd1*f**2*r*s - 720*C*D1**2*bdd1*f**2*s**2 - 3960*C*D1**2*f**2*fd*r*s + 1320*C*D1**2*f**2*fd*r - 3960*C*D1**2*f**2*fd*s**2 + 3960*C*D1**2*f**2*fd*s - 1320*C*D1**2*f**2*fd + 2520*C*D1**2*f**2*fdd*r*s - 840*C*D1**2*f**2*fdd*r + 2520*C*D1**2*f**2*fdd*s**2 - 2520*C*D1**2*f**2*fdd*s + 840*C*D1**2*f**2*fdd + 5040*C*D1**2*f*fd**2*r*s - 1680*C*D1**2*f*fd**2*r + 5040*C*D1**2*f*fd**2*s**2 - 5040*C*D1**2*f*fd**2*s + 840*C*D1**2*f*fd**2 - 5280*C*D1*Dd*f**3*r*s + 1320*C*D1*Dd*f**3*r - 5280*C*D1*Dd*f**3*s**2 + 5280*C*D1*Dd*f**3*s - 1320*C*D1*Dd*f**3 + 20160*C*D1*Dd*f**2*fd*r*s - 5880*C*D1*Dd*f**2*fd*r + 20160*C*D1*Dd*f**2*fd*s**2 - 20160*C*D1*Dd*f**2*fd*s + 4200*C*D1*Dd*f**2*fd + 3360*C*D1*Ddd*f**3*r*s - 840*C*D1*Ddd*f**3*r + 3360*C*D1*Ddd*f**3*s**2 - 3360*C*D1*Ddd*f**3*s + 840*C*D1*Ddd*f**3 + 10080*C*Dd**2*f**3*r*s - 2520*C*Dd**2*f**3*r + 10080*C*Dd**2*f**3*s**2 - 10080*C*Dd**2*f**3*s + 1680*C*Dd**2*f**3 + 540*D1**2*K*bdd1*f**2*r*s + 540*D1**2*K*bdd1*f**2*s**2 - 540*D1**2*K*bdd1*f**2*s - 1656*D1**2*b2*f*fd*r*s + 828*D1**2*b2*f*fd*r - 1656*D1**2*b2*f*fd*s**2 + 1656*D1**2*b2*f*fd*s - 828*D1**2*b2*f*fd + 1080*D1**2*b2*f*fdd*r*s - 540*D1**2*b2*f*fdd*r + 1080*D1**2*b2*f*fdd*s**2 - 1080*D1**2*b2*f*fdd*s + 540*D1**2*b2*f*fdd + 1080*D1**2*b2*fd**2*r*s - 540*D1**2*b2*fd**2*r + 1080*D1**2*b2*fd**2*s**2 - 1080*D1**2*b2*fd**2*s - 18*D1**2*bd1**2*f*(5*f*(r**2 + r*(2*s - 3) + s**2 - 5*s + 2) + 7*r**2*(5 - 4*K) + 7*r*(4*K*(s + 1) + 6*s - 7) + 7*s**2*(8*K + 1) - 7*s*(2*K + 7) + 14) - 828*D1**2*bd2*f**2*r*s - 828*D1**2*bd2*f**2*s**2 + 828*D1**2*bd2*f**2*s + 2160*D1**2*bd2*f*fd*r*s - 540*D1**2*bd2*f*fd*r + 2160*D1**2*bd2*f*fd*s**2 - 2160*D1**2*bd2*f*fd*s + 540*D1**2*bd2*f*fd + 675*D1**2*bdd1*f**3*r**2 + 1170*D1**2*bdd1*f**3*r*s - 990*D1**2*bdd1*f**3*r + 495*D1**2*bdd1*f**3*s**2 - 990*D1**2*bdd1*f**3*s + 495*D1**2*bdd1*f**3 + 36*D1**2*bdd1*f**2*r**2 + 1008*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*r + 972*D1**2*bdd1*f**2*s**2 - 882*D1**2*bdd1*f**2*s + 405*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s + 1008*D1**2*bdd1*f*g2*s**2 + 540*D1**2*bdd2*f**2*r*s + 540*D1**2*bdd2*f**2*s**2 - 540*D1**2*bdd2*f**2*s - 2115*D1**2*f**2*fd*r**2 - 2310*D1**2*f**2*fd*r*s + 2180*D1**2*f**2*fd*r - 195*D1**2*f**2*fd*s**2 + 900*D1**2*f**2*fd*s - 770*D1**2*f**2*fd + 1665*D1**2*f**2*fdd*r**2 + 1830*D1**2*f**2*fdd*r*s - 1720*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 720*D1**2*f**2*fdd*s + 610*D1**2*f**2*fdd + 1656*D1**2*f**2*gd2*r*s + 1656*D1**2*f**2*gd2*s**2 - 1656*D1**2*f**2*gd2*s - 1080*D1**2*f**2*gdd2*r*s - 1080*D1**2*f**2*gdd2*s**2 + 1080*D1**2*f**2*gdd2*s + 3330*D1**2*f*fd**2*r**2 + 3660*D1**2*f*fd**2*r*s - 3440*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 1440*D1**2*f*fd**2*s + 610*D1**2*f*fd**2 + 3312*D1**2*f*fd*g2*r*s - 1656*D1**2*f*fd*g2*r + 3312*D1**2*f*fd*g2*s**2 - 3312*D1**2*f*fd*g2*s + 1656*D1**2*f*fd*g2 - 4320*D1**2*f*fd*gd2*r*s + 1080*D1**2*f*fd*gd2*r - 4320*D1**2*f*fd*gd2*s**2 + 4320*D1**2*f*fd*gd2*s - 1080*D1**2*f*fd*gd2 - 2160*D1**2*f*fdd*g2*r*s + 1080*D1**2*f*fdd*g2*r - 2160*D1**2*f*fdd*g2*s**2 + 2160*D1**2*f*fdd*g2*s - 1080*D1**2*f*fdd*g2 - 2160*D1**2*fd**2*g2*r*s + 1080*D1**2*fd**2*g2*r - 2160*D1**2*fd**2*g2*s**2 + 2160*D1**2*fd**2*g2*s - 3312*D1*Dd*b2*f**2*r*s + 828*D1*Dd*b2*f**2*r - 3312*D1*Dd*b2*f**2*s**2 + 3312*D1*Dd*b2*f**2*s - 828*D1*Dd*b2*f**2 + 8640*D1*Dd*b2*f*fd*r*s - 3240*D1*Dd*b2*f*fd*r + 8640*D1*Dd*b2*f*fd*s**2 - 8640*D1*Dd*b2*f*fd*s + 2160*D1*Dd*b2*f*fd + 4320*D1*Dd*bd2*f**2*r*s - 540*D1*Dd*bd2*f**2*r + 4320*D1*Dd*bd2*f**2*s**2 - 4320*D1*Dd*bd2*f**2*s + 540*D1*Dd*bd2*f**2 - 2820*D1*Dd*f**3*r**2 - 3080*D1*Dd*f**3*r*s + 3590*D1*Dd*f**3*r - 260*D1*Dd*f**3*s**2 + 1670*D1*Dd*f**3*s - 1475*D1*Dd*f**3 + 13320*D1*Dd*f**2*fd*r**2 + 14640*D1*Dd*f**2*fd*r*s - 15370*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 6870*D1*Dd*f**2*fd*s + 4160*D1*Dd*f**2*fd + 6624*D1*Dd*f**2*g2*r*s - 1656*D1*Dd*f**2*g2*r + 6624*D1*Dd*f**2*g2*s**2 - 6624*D1*Dd*f**2*g2*s + 1656*D1*Dd*f**2*g2 - 8640*D1*Dd*f**2*gd2*r*s + 1080*D1*Dd*f**2*gd2*r - 8640*D1*Dd*f**2*gd2*s**2 + 8640*D1*Dd*f**2*gd2*s - 1080*D1*Dd*f**2*gd2 - 17280*D1*Dd*f*fd*g2*r*s + 6480*D1*Dd*f*fd*g2*r - 17280*D1*Dd*f*fd*g2*s**2 + 17280*D1*Dd*f*fd*g2*s - 4320*D1*Dd*f*fd*g2 + 2160*D1*Ddd*b2*f**2*r*s - 540*D1*Ddd*b2*f**2*r + 2160*D1*Ddd*b2*f**2*s**2 - 2160*D1*Ddd*b2*f**2*s + 540*D1*Ddd*b2*f**2 + 2220*D1*Ddd*f**3*r**2 + 2440*D1*Ddd*f**3*r*s - 2830*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 1330*D1*Ddd*f**3*s + 1165*D1*Ddd*f**3 - 4320*D1*Ddd*f**2*g2*r*s + 1080*D1*Ddd*f**2*g2*r - 4320*D1*Ddd*f**2*g2*s**2 + 4320*D1*Ddd*f**2*g2*s - 1080*D1*Ddd*f**2*g2 - 9*D1*bd1*(D1*(5*f**3*(13*r**2 + 6*r*(5*s - 3) + 17*s**2 - 26*s + 9) - f**2*(160*C*s**2 - 92*K*s**2 + 92*K*s + 10*fd*(45*r**2 + 13*r*(6*s - 5) + 33*s**2 - 59*s + 22) + r**2*(55 - 112*C) + 2*r*(s*(24*C - 46*K - 63) + 47) - 181*s**2 + 98*s - 27) - 2*f*(fd*(-160*C*s**2 + 92*C*s + 30*K*(r*(4*s - 1) + (1 - 2*s)**2) + r**2*(112*C + 8) - r*(48*C*s + 44*C - 224*s + 115) + 216*s**2 - 213*s + 59) + 56*g2*(r**2 - r*s - 2*s**2) + 28*gd2*(-2*r**2 + 2*r*(s + 1) + s*(4*s - 1))) + 56*fd*g2*(2*r**2 - 2*r*s + r - s*(4*s - 4))) - 2*Dd*f*(5*f**2*(60*r**2 + r*(104*s - 87) + 44*s**2 - 81*s + 33) + f*(-320*C*s**2 + 104*C*s + 30*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + r**2*(224*C + 16) - 4*r*(24*C*s + 25*C - 112*s + 71) + 432*s**2 - 416*s + 159) - 28*g2*(8*r**2 - r*(8*s + 3) + s*(6 - 16*s)))) + 6480*Dd**2*b2*f**2*r*s - 1620*Dd**2*b2*f**2*r + 6480*Dd**2*b2*f**2*s**2 - 6480*Dd**2*b2*f**2*s + 1080*Dd**2*b2*f**2 + 6660*Dd**2*f**3*r**2 + 7320*Dd**2*f**3*r*s - 8490*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 3990*Dd**2*f**3*s + 2330*Dd**2*f**3 - 12960*Dd**2*f**2*g2*r*s + 3240*Dd**2*f**2*g2*r - 12960*Dd**2*f**2*g2*s**2 + 12960*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 + 9*b1**2*(-D1**2*(-20*f*fd*(r**2 + 2*r*s + s**2 + 2*s - 1) + 10*fd**2*(r**2 + 2*r*s + s**2 + 2*s - 1) + 14*fd*(4*K*(r**2 - r*s + r - 2*(s - 1)**2) - 5*r**2 - 6*r*s + 2*r - s**2 - 6*s + 3) + fdd*(-28*K*(r**2 - r*s + r - 2*(s - 1)**2) + 10*f*(r**2 + 2*r*s + s**2 + 2*s - 1) + 35*r**2 + 42*r*s - 14*r + 7*s**2 + 42*s - 21)) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-10*fd*(4*r**2 + r*(8*s - 3) + 4*s**2 + s - 1) - 7*r**2*(16*K - 20) + 14*r*(K*(8*s + 6) + 12*s - 13) + 7*s**2*(32*K + 4) - 7*s*(24*K + 14) + 77) + 7*fd*(2*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) - 20*r**2 + r*(17 - 24*s) - 4*s**2 - 5*s + 1)) - Ddd*f*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*r**2*(16*K - 20) + 14*r*(K*(8*s + 6) + 12*s - 13) + 7*s**2*(32*K + 4) - 7*s*(24*K + 14) + 77)) - 2*Dd**2*f*(15*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 7*r**2*(24*K - 30) + 21*r*(K*(8*s + 6) + 12*s - 13) + 7*s**2*(48*K + 6) - 7*s*(36*K + 21) + 77)) + 9*b1*(-224*C*D1**2*f*fd*r**2 + 96*C*D1**2*f*fd*r*s + 176*C*D1**2*f*fd*r + 320*C*D1**2*f*fd*s**2 - 368*C*D1**2*f*fd*s + 48*C*D1**2*f*fd + 112*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s - 88*C*D1**2*f*fdd*r - 160*C*D1**2*f*fdd*s**2 + 184*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd + 112*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s - 88*C*D1**2*fd**2*r - 160*C*D1**2*fd**2*s**2 + 184*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 448*C*D1*Dd*f**2*r**2 + 192*C*D1*Dd*f**2*r*s + 400*C*D1*Dd*f**2*r + 640*C*D1*Dd*f**2*s**2 - 416*C*D1*Dd*f**2*s - 64*C*D1*Dd*f**2 + 896*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s - 752*C*D1*Dd*f*fd*r - 1280*C*D1*Dd*f*fd*s**2 + 1152*C*D1*Dd*f*fd*s - 8*C*D1*Dd*f*fd + 224*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r*s - 200*C*D1*Ddd*f**2*r - 320*C*D1*Ddd*f**2*s**2 + 208*C*D1*Ddd*f**2*s + 32*C*D1*Ddd*f**2 + 672*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r*s - 600*C*Dd**2*f**2*r - 960*C*Dd**2*f**2*s**2 + 624*C*Dd**2*f**2*s + 64*C*Dd**2*f**2 - 184*D1**2*K*f*fd*r*s + 92*D1**2*K*f*fd*r - 184*D1**2*K*f*fd*s**2 + 184*D1**2*K*f*fd*s - 92*D1**2*K*f*fd + 120*D1**2*K*f*fdd*r*s - 60*D1**2*K*f*fdd*r + 120*D1**2*K*f*fdd*s**2 - 120*D1**2*K*f*fdd*s + 60*D1**2*K*f*fdd + 120*D1**2*K*fd**2*r*s - 60*D1**2*K*fd**2*r + 120*D1**2*K*fd**2*s**2 - 120*D1**2*K*fd**2*s - D1**2*bdd1*f*(-28*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) + 5*f*(2*r**2 + r*(4*s - 6) + 2*s**2 - 10*s + 5) + 70*r**2 + 14*r*(6*s - 7) + 14*s**2 - 98*s + 63) - 195*D1**2*f**2*fd*r**2 - 450*D1**2*f**2*fd*r*s + 320*D1**2*f**2*fd*r - 255*D1**2*f**2*fd*s**2 + 340*D1**2*f**2*fd*s - 170*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 390*D1**2*f**2*fdd*r*s - 320*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 260*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 780*D1**2*f*fd**2*r*s - 640*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 520*D1**2*f*fd**2*s + 190*D1**2*f*fd**2 + 110*D1**2*f*fd*r**2 - 252*D1**2*f*fd*r*s - 78*D1**2*f*fd*r - 362*D1**2*f*fd*s**2 + 390*D1**2*f*fd*s - 99*D1**2*f*fd + 8*D1**2*f*fdd*r**2 + 224*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r + 216*D1**2*f*fdd*s**2 - 230*D1**2*f*fdd*s + 67*D1**2*f*fdd + 112*D1**2*f*gd2*r**2 - 112*D1**2*f*gd2*r*s - 224*D1**2*f*gd2*r - 224*D1**2*f*gd2*s**2 + 112*D1**2*f*gd2*s + 112*D1**2*f*gd2 - 56*D1**2*f*gdd2*r**2 + 56*D1**2*f*gdd2*r*s + 112*D1**2*f*gdd2*r + 112*D1**2*f*gdd2*s**2 - 56*D1**2*f*gdd2*s - 56*D1**2*f*gdd2 + 8*D1**2*fd**2*r**2 + 224*D1**2*fd**2*r*s - 10*D1**2*fd**2*r + 216*D1**2*fd**2*s**2 - 230*D1**2*fd**2*s - 6*D1**2*fd**2 + 112*D1**2*fd*g2*r**2 - 112*D1**2*fd*g2*r*s + 112*D1**2*fd*g2*r - 224*D1**2*fd*g2*s**2 + 448*D1**2*fd*g2*s - 224*D1**2*fd*g2 - 112*D1**2*fd*gd2*r**2 + 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r + 224*D1**2*fd*gd2*s**2 - 280*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r**2 + 56*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r + 112*D1**2*fdd*g2*s**2 - 224*D1**2*fdd*g2*s + 112*D1**2*fdd*g2 - 368*D1*Dd*K*f**2*r*s + 92*D1*Dd*K*f**2*r - 368*D1*Dd*K*f**2*s**2 + 368*D1*Dd*K*f**2*s - 92*D1*Dd*K*f**2 + 960*D1*Dd*K*f*fd*r*s - 360*D1*Dd*K*f*fd*r + 960*D1*Dd*K*f*fd*s**2 - 960*D1*Dd*K*f*fd*s + 240*D1*Dd*K*f*fd - 260*D1*Dd*f**3*r**2 - 600*D1*Dd*f**3*r*s + 410*D1*Dd*f**3*r - 340*D1*Dd*f**3*s**2 + 470*D1*Dd*f**3*s - 215*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 3120*D1*Dd*f**2*fd*r*s - 2570*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 2150*D1*Dd*f**2*fd*s + 900*D1*Dd*f**2*fd + 220*D1*Dd*f**2*r**2 - 504*D1*Dd*f**2*r*s - 94*D1*Dd*f**2*r - 724*D1*Dd*f**2*s**2 + 614*D1*Dd*f**2*s - 71*D1*Dd*f**2 + 64*D1*Dd*f*fd*r**2 + 1792*D1*Dd*f*fd*r*s - 296*D1*Dd*f*fd*r + 1728*D1*Dd*f*fd*s**2 - 1800*D1*Dd*f*fd*s + 250*D1*Dd*f*fd + 448*D1*Dd*f*g2*r**2 - 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r - 896*D1*Dd*f*g2*s**2 + 672*D1*Dd*f*g2*s - 448*D1*Dd*f*gd2*r**2 + 448*D1*Dd*f*gd2*r*s + 616*D1*Dd*f*gd2*r + 896*D1*Dd*f*gd2*s**2 - 560*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r**2 + 448*D1*Dd*fd*g2*r*s - 56*D1*Dd*fd*g2*r + 896*D1*Dd*fd*g2*s**2 - 1232*D1*Dd*fd*g2*s + 336*D1*Dd*fd*g2 + 240*D1*Ddd*K*f**2*r*s - 60*D1*Ddd*K*f**2*r + 240*D1*Ddd*K*f**2*s**2 - 240*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 + 300*D1*Ddd*f**3*r**2 + 520*D1*Ddd*f**3*r*s - 430*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 370*D1*Ddd*f**3*s + 205*D1*Ddd*f**3 + 16*D1*Ddd*f**2*r**2 + 448*D1*Ddd*f**2*r*s - 128*D1*Ddd*f**2*r + 432*D1*Ddd*f**2*s**2 - 440*D1*Ddd*f**2*s + 116*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r**2 + 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r + 448*D1*Ddd*f*g2*s**2 - 336*D1*Ddd*f*g2*s + 2*D1*bd1*(5*D1*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 10*s + 5) + D1*f*(-28*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) - 10*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 70*r**2 + 14*r*(6*s - 7) + 14*s**2 - 98*s + 63) + 7*D1*fd*(2*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) - 10*r**2 + r*(9 - 12*s) - 2*s**2 + s - 1) - 5*Dd*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 26*s + 11) + 7*Dd*f*(K*(32*r**2 - 4*r*(8*s + 7) - 64*s**2 + 32*s + 6) - 40*r**2 - 6*r*(8*s - 9) - 8*s**2 + 42*s - 21)) + 720*Dd**2*K*f**2*r*s - 180*Dd**2*K*f**2*r + 720*Dd**2*K*f**2*s**2 - 720*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 + 900*Dd**2*f**3*r**2 + 1560*Dd**2*f**3*r*s - 1290*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 1110*Dd**2*f**3*s + 410*Dd**2*f**3 + 48*Dd**2*f**2*r**2 + 1344*Dd**2*f**2*r*s - 384*Dd**2*f**2*r + 1296*Dd**2*f**2*s**2 - 1320*Dd**2*f**2*s + 232*Dd**2*f**2 - 672*Dd**2*f*g2*r**2 + 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r + 1344*Dd**2*f*g2*s**2 - 1008*Dd**2*f*g2*s))/(630*d**2*k3**3) + 4*D1**2*Pk2*Pkd3*ct**5*k1*(-D1*f*(D1*bd1**2*s*(5*f + 7)*(2*r + 2*s - 1) + 5*D1*bdd1*f*s*(r + s) + 5*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1)))) + b1**2*(-D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) - 2*fd*(10*f*s - 5*f + 7*s - 7) + fdd*(10*f*s - 5*f + 7*s - 7)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 14*r*(4*s - 1) + 14*(1 - 2*s)**2) - 7*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(5*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(7*bdd1*s*(2*r + 2*s - 1) - 10*fd*(2*s - 1)*(r + s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) + 5*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + 2*f*s*(5*f + 7)*(2*r + 2*s - 1) - 7*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - Dd*f*(5*f + 7)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 5*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(6 - 16*s) - 16*s**2 + 20*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k2*k3) + 4*D1**2*Pk2*Pkd3*ct**4*f**2*k1**6*(D1**2*(f*(7*fd - 9*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 9*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(7*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(4*s - 1)*(4*r + 4*s - 3)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(99*d**2*k2**2*k3**5) + D1**2*Pk2*Pkd3*ct**4*k1**6*(1650*C*D1**2*f**2*fd*r**2 + 3300*C*D1**2*f**2*fd*r*s - 2200*C*D1**2*f**2*fd*r + 1650*C*D1**2*f**2*fd*s**2 - 2200*C*D1**2*f**2*fd*s + 1100*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r**2 - 4620*C*D1**2*f**2*fdd*r*s + 3080*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 3080*C*D1**2*f**2*fdd*s - 1540*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r**2 - 9240*C*D1**2*f*fd**2*r*s + 6160*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 6160*C*D1**2*f*fd**2*s - 1540*C*D1**2*f*fd**2 + 2200*C*D1*Dd*f**3*r**2 + 4400*C*D1*Dd*f**3*r*s - 3300*C*D1*Dd*f**3*r + 2200*C*D1*Dd*f**3*s**2 - 3300*C*D1*Dd*f**3*s + 1650*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r**2 - 36960*C*D1*Dd*f**2*fd*r*s + 26180*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 26180*C*D1*Dd*f**2*fd*s - 9240*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r**2 - 6160*C*D1*Ddd*f**3*r*s + 4620*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 4620*C*D1*Ddd*f**3*s - 2310*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r**2 - 18480*C*Dd**2*f**3*r*s + 13860*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 13860*C*Dd**2*f**3*s - 4620*C*Dd**2*f**3 + 594*D1**2*K*b1*f*fd*r**2 + 1188*D1**2*K*b1*f*fd*r*s - 594*D1**2*K*b1*f*fd*r + 594*D1**2*K*b1*f*fd*s**2 - 594*D1**2*K*b1*f*fd*s + 297*D1**2*K*b1*f*fd - 990*D1**2*K*b1*f*fdd*r**2 - 1980*D1**2*K*b1*f*fdd*r*s + 990*D1**2*K*b1*f*fdd*r - 990*D1**2*K*b1*f*fdd*s**2 + 990*D1**2*K*b1*f*fdd*s - 495*D1**2*K*b1*f*fdd - 990*D1**2*K*b1*fd**2*r**2 - 1980*D1**2*K*b1*fd**2*r*s + 990*D1**2*K*b1*fd**2*r - 990*D1**2*K*b1*fd**2*s**2 + 990*D1**2*K*b1*fd**2*s - 594*D1**2*b1*f*fd*r**2 - 1188*D1**2*b1*f*fd*r*s + 594*D1**2*b1*f*fd*r - 594*D1**2*b1*f*fd*s**2 + 594*D1**2*b1*f*fd*s - 297*D1**2*b1*f*fd + 990*D1**2*b1*f*fdd*r**2 + 1980*D1**2*b1*f*fdd*r*s - 990*D1**2*b1*f*fdd*r + 990*D1**2*b1*f*fdd*s**2 - 990*D1**2*b1*f*fdd*s + 495*D1**2*b1*f*fdd + 990*D1**2*b1*fd**2*r**2 + 1980*D1**2*b1*fd**2*r*s - 990*D1**2*b1*fd**2*r + 990*D1**2*b1*fd**2*s**2 - 990*D1**2*b1*fd**2*s - 495*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 4900*D1**2*f**3*fd*r**2 + 9800*D1**2*f**3*fd*r*s - 7350*D1**2*f**3*fd*r + 4900*D1**2*f**3*fd*s**2 - 7350*D1**2*f**3*fd*s + 3675*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 1650*D1**2*f**2*fd*r**2 - 3300*D1**2*f**2*fd*r*s + 2200*D1**2*f**2*fd*r - 1650*D1**2*f**2*fd*s**2 + 2200*D1**2*f**2*fd*s - 1100*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r**2 + 4620*D1**2*f**2*fdd*r*s - 3080*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 3080*D1**2*f**2*fdd*s + 1540*D1**2*f**2*fdd - 594*D1**2*f**2*gd2*r**2 - 1188*D1**2*f**2*gd2*r*s + 1188*D1**2*f**2*gd2*r - 594*D1**2*f**2*gd2*s**2 + 1188*D1**2*f**2*gd2*s - 594*D1**2*f**2*gd2 + 990*D1**2*f**2*gdd2*r**2 + 1980*D1**2*f**2*gdd2*r*s - 1980*D1**2*f**2*gdd2*r + 990*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 990*D1**2*f**2*gdd2 + 4620*D1**2*f*fd**2*r**2 + 9240*D1**2*f*fd**2*r*s - 6160*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 6160*D1**2*f*fd**2*s + 1540*D1**2*f*fd**2 - 1188*D1**2*f*fd*g2*r**2 - 2376*D1**2*f*fd*g2*r*s + 1188*D1**2*f*fd*g2*r - 1188*D1**2*f*fd*g2*s**2 + 1188*D1**2*f*fd*g2*s - 594*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r**2 + 7920*D1**2*f*fd*gd2*r*s - 5940*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 5940*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r**2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r**2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 1188*D1*Dd*K*b1*f**2*r**2 + 2376*D1*Dd*K*b1*f**2*r*s - 1782*D1*Dd*K*b1*f**2*r + 1188*D1*Dd*K*b1*f**2*s**2 - 1782*D1*Dd*K*b1*f**2*s + 891*D1*Dd*K*b1*f**2 - 7920*D1*Dd*K*b1*f*fd*r**2 - 15840*D1*Dd*K*b1*f*fd*r*s + 9900*D1*Dd*K*b1*f*fd*r - 7920*D1*Dd*K*b1*f*fd*s**2 + 9900*D1*Dd*K*b1*f*fd*s - 2970*D1*Dd*K*b1*f*fd - 1188*D1*Dd*b1*f**2*r**2 - 2376*D1*Dd*b1*f**2*r*s + 1782*D1*Dd*b1*f**2*r - 1188*D1*Dd*b1*f**2*s**2 + 1782*D1*Dd*b1*f**2*s - 891*D1*Dd*b1*f**2 + 7920*D1*Dd*b1*f*fd*r**2 + 15840*D1*Dd*b1*f*fd*r*s - 9900*D1*Dd*b1*f*fd*r + 7920*D1*Dd*b1*f*fd*s**2 - 9900*D1*Dd*b1*f*fd*s + 2970*D1*Dd*b1*f*fd + 4900*D1*Dd*f**4*r**2 + 9800*D1*Dd*f**4*r*s - 7350*D1*Dd*f**4*r + 4900*D1*Dd*f**4*s**2 - 7350*D1*Dd*f**4*s + 3675*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 2200*D1*Dd*f**3*r**2 - 4400*D1*Dd*f**3*r*s + 3300*D1*Dd*f**3*r - 2200*D1*Dd*f**3*s**2 + 3300*D1*Dd*f**3*s - 1650*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r**2 + 36960*D1*Dd*f**2*fd*r*s - 26180*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 26180*D1*Dd*f**2*fd*s + 9240*D1*Dd*f**2*fd - 2376*D1*Dd*f**2*g2*r**2 - 4752*D1*Dd*f**2*g2*r*s + 3564*D1*Dd*f**2*g2*r - 2376*D1*Dd*f**2*g2*s**2 + 3564*D1*Dd*f**2*g2*s - 1782*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r**2 + 15840*D1*Dd*f**2*gd2*r*s - 13860*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 13860*D1*Dd*f**2*gd2*s + 5940*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r**2 + 31680*D1*Dd*f*fd*g2*r*s - 19800*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 19800*D1*Dd*f*fd*g2*s + 5940*D1*Dd*f*fd*g2 - 1980*D1*Ddd*K*b1*f**2*r**2 - 3960*D1*Ddd*K*b1*f**2*r*s + 2970*D1*Ddd*K*b1*f**2*r - 1980*D1*Ddd*K*b1*f**2*s**2 + 2970*D1*Ddd*K*b1*f**2*s - 1485*D1*Ddd*K*b1*f**2 + 1980*D1*Ddd*b1*f**2*r**2 + 3960*D1*Ddd*b1*f**2*r*s - 2970*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s**2 - 2970*D1*Ddd*b1*f**2*s + 1485*D1*Ddd*b1*f**2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r**2 + 6160*D1*Ddd*f**3*r*s - 4620*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 4620*D1*Ddd*f**3*s + 2310*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r**2 + 7920*D1*Ddd*f**2*g2*r*s - 5940*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 5940*D1*Ddd*f**2*g2*s + 2970*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 5940*Dd**2*K*b1*f**2*r**2 - 11880*Dd**2*K*b1*f**2*r*s + 8910*Dd**2*K*b1*f**2*r - 5940*Dd**2*K*b1*f**2*s**2 + 8910*Dd**2*K*b1*f**2*s - 2970*Dd**2*K*b1*f**2 + 5940*Dd**2*b1*f**2*r**2 + 11880*Dd**2*b1*f**2*r*s - 8910*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s**2 - 8910*Dd**2*b1*f**2*s + 2970*Dd**2*b1*f**2 - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 9240*Dd**2*f**3*r**2 + 18480*Dd**2*f**3*r*s - 13860*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 13860*Dd**2*f**3*s + 4620*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r**2 + 23760*Dd**2*f**2*g2*r*s - 17820*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 17820*Dd**2*f**2*g2*s + 5940*Dd**2*f**2*g2)/(770*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct**4*k1**4*k2**2*st**2*(4356*C*D1**2*f**2*fd*r**2 + 8712*C*D1**2*f**2*fd*r*s - 5808*C*D1**2*f**2*fd*r + 4356*C*D1**2*f**2*fd*s**2 - 5808*C*D1**2*f**2*fd*s + 2904*C*D1**2*f**2*fd - 3960*C*D1**2*f**2*fdd*r**2 - 7920*C*D1**2*f**2*fdd*r*s + 5280*C*D1**2*f**2*fdd*r - 3960*C*D1**2*f**2*fdd*s**2 + 5280*C*D1**2*f**2*fdd*s - 2640*C*D1**2*f**2*fdd - 7920*C*D1**2*f*fd**2*r**2 - 15840*C*D1**2*f*fd**2*r*s + 10560*C*D1**2*f*fd**2*r - 7920*C*D1**2*f*fd**2*s**2 + 10560*C*D1**2*f*fd**2*s - 2640*C*D1**2*f*fd**2 + 5808*C*D1*Dd*f**3*r**2 + 11616*C*D1*Dd*f**3*r*s - 8712*C*D1*Dd*f**3*r + 5808*C*D1*Dd*f**3*s**2 - 8712*C*D1*Dd*f**3*s + 4356*C*D1*Dd*f**3 - 31680*C*D1*Dd*f**2*fd*r**2 - 63360*C*D1*Dd*f**2*fd*r*s + 44880*C*D1*Dd*f**2*fd*r - 31680*C*D1*Dd*f**2*fd*s**2 + 44880*C*D1*Dd*f**2*fd*s - 15840*C*D1*Dd*f**2*fd - 5280*C*D1*Ddd*f**3*r**2 - 10560*C*D1*Ddd*f**3*r*s + 7920*C*D1*Ddd*f**3*r - 5280*C*D1*Ddd*f**3*s**2 + 7920*C*D1*Ddd*f**3*s - 3960*C*D1*Ddd*f**3 - 15840*C*Dd**2*f**3*r**2 - 31680*C*Dd**2*f**3*r*s + 23760*C*Dd**2*f**3*r - 15840*C*Dd**2*f**3*s**2 + 23760*C*Dd**2*f**3*s - 7920*C*Dd**2*f**3 + 1980*D1**2*K*b1*f*fd*r**2 + 3960*D1**2*K*b1*f*fd*r*s - 1980*D1**2*K*b1*f*fd*r + 1980*D1**2*K*b1*f*fd*s**2 - 1980*D1**2*K*b1*f*fd*s + 990*D1**2*K*b1*f*fd - 2376*D1**2*K*b1*f*fdd*r**2 - 4752*D1**2*K*b1*f*fdd*r*s + 2376*D1**2*K*b1*f*fdd*r - 2376*D1**2*K*b1*f*fdd*s**2 + 2376*D1**2*K*b1*f*fdd*s - 1188*D1**2*K*b1*f*fdd - 2376*D1**2*K*b1*fd**2*r**2 - 4752*D1**2*K*b1*fd**2*r*s + 2376*D1**2*K*b1*fd**2*r - 2376*D1**2*K*b1*fd**2*s**2 + 2376*D1**2*K*b1*fd**2*s - 1980*D1**2*b1*f*fd*r**2 - 3960*D1**2*b1*f*fd*r*s + 1980*D1**2*b1*f*fd*r - 1980*D1**2*b1*f*fd*s**2 + 1980*D1**2*b1*f*fd*s - 990*D1**2*b1*f*fd + 2376*D1**2*b1*f*fdd*r**2 + 4752*D1**2*b1*f*fdd*r*s - 2376*D1**2*b1*f*fdd*r + 2376*D1**2*b1*f*fdd*s**2 - 2376*D1**2*b1*f*fdd*s + 1188*D1**2*b1*f*fdd + 2376*D1**2*b1*fd**2*r**2 + 4752*D1**2*b1*fd**2*r*s - 2376*D1**2*b1*fd**2*r + 2376*D1**2*b1*fd**2*s**2 - 2376*D1**2*b1*fd**2*s - 1188*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 8500*D1**2*f**3*fd*r**2 + 17000*D1**2*f**3*fd*r*s - 12750*D1**2*f**3*fd*r + 8500*D1**2*f**3*fd*s**2 - 12750*D1**2*f**3*fd*s + 6375*D1**2*f**3*fd - 7000*D1**2*f**3*fdd*r**2 - 14000*D1**2*f**3*fdd*r*s + 10500*D1**2*f**3*fdd*r - 7000*D1**2*f**3*fdd*s**2 + 10500*D1**2*f**3*fdd*s - 5250*D1**2*f**3*fdd - 21000*D1**2*f**2*fd**2*r**2 - 42000*D1**2*f**2*fd**2*r*s + 31500*D1**2*f**2*fd**2*r - 21000*D1**2*f**2*fd**2*s**2 + 31500*D1**2*f**2*fd**2*s - 10500*D1**2*f**2*fd**2 - 4356*D1**2*f**2*fd*r**2 - 8712*D1**2*f**2*fd*r*s + 5808*D1**2*f**2*fd*r - 4356*D1**2*f**2*fd*s**2 + 5808*D1**2*f**2*fd*s - 2904*D1**2*f**2*fd + 3960*D1**2*f**2*fdd*r**2 + 7920*D1**2*f**2*fdd*r*s - 5280*D1**2*f**2*fdd*r + 3960*D1**2*f**2*fdd*s**2 - 5280*D1**2*f**2*fdd*s + 2640*D1**2*f**2*fdd - 1980*D1**2*f**2*gd2*r**2 - 3960*D1**2*f**2*gd2*r*s + 3960*D1**2*f**2*gd2*r - 1980*D1**2*f**2*gd2*s**2 + 3960*D1**2*f**2*gd2*s - 1980*D1**2*f**2*gd2 + 2376*D1**2*f**2*gdd2*r**2 + 4752*D1**2*f**2*gdd2*r*s - 4752*D1**2*f**2*gdd2*r + 2376*D1**2*f**2*gdd2*s**2 - 4752*D1**2*f**2*gdd2*s + 2376*D1**2*f**2*gdd2 + 7920*D1**2*f*fd**2*r**2 + 15840*D1**2*f*fd**2*r*s - 10560*D1**2*f*fd**2*r + 7920*D1**2*f*fd**2*s**2 - 10560*D1**2*f*fd**2*s + 2640*D1**2*f*fd**2 - 3960*D1**2*f*fd*g2*r**2 - 7920*D1**2*f*fd*g2*r*s + 3960*D1**2*f*fd*g2*r - 3960*D1**2*f*fd*g2*s**2 + 3960*D1**2*f*fd*g2*s - 1980*D1**2*f*fd*g2 + 9504*D1**2*f*fd*gd2*r**2 + 19008*D1**2*f*fd*gd2*r*s - 14256*D1**2*f*fd*gd2*r + 9504*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4752*D1**2*f*fd*gd2 + 4752*D1**2*f*fdd*g2*r**2 + 9504*D1**2*f*fdd*g2*r*s - 4752*D1**2*f*fdd*g2*r + 4752*D1**2*f*fdd*g2*s**2 - 4752*D1**2*f*fdd*g2*s + 2376*D1**2*f*fdd*g2 + 4752*D1**2*fd**2*g2*r**2 + 9504*D1**2*fd**2*g2*r*s - 4752*D1**2*fd**2*g2*r + 4752*D1**2*fd**2*g2*s**2 - 4752*D1**2*fd**2*g2*s + 3960*D1*Dd*K*b1*f**2*r**2 + 7920*D1*Dd*K*b1*f**2*r*s - 5940*D1*Dd*K*b1*f**2*r + 3960*D1*Dd*K*b1*f**2*s**2 - 5940*D1*Dd*K*b1*f**2*s + 2970*D1*Dd*K*b1*f**2 - 19008*D1*Dd*K*b1*f*fd*r**2 - 38016*D1*Dd*K*b1*f*fd*r*s + 23760*D1*Dd*K*b1*f*fd*r - 19008*D1*Dd*K*b1*f*fd*s**2 + 23760*D1*Dd*K*b1*f*fd*s - 7128*D1*Dd*K*b1*f*fd - 3960*D1*Dd*b1*f**2*r**2 - 7920*D1*Dd*b1*f**2*r*s + 5940*D1*Dd*b1*f**2*r - 3960*D1*Dd*b1*f**2*s**2 + 5940*D1*Dd*b1*f**2*s - 2970*D1*Dd*b1*f**2 + 19008*D1*Dd*b1*f*fd*r**2 + 38016*D1*Dd*b1*f*fd*r*s - 23760*D1*Dd*b1*f*fd*r + 19008*D1*Dd*b1*f*fd*s**2 - 23760*D1*Dd*b1*f*fd*s + 7128*D1*Dd*b1*f*fd + 8500*D1*Dd*f**4*r**2 + 17000*D1*Dd*f**4*r*s - 12750*D1*Dd*f**4*r + 8500*D1*Dd*f**4*s**2 - 12750*D1*Dd*f**4*s + 6375*D1*Dd*f**4 - 56000*D1*Dd*f**3*fd*r**2 - 112000*D1*Dd*f**3*fd*r*s + 84000*D1*Dd*f**3*fd*r - 56000*D1*Dd*f**3*fd*s**2 + 84000*D1*Dd*f**3*fd*s - 31500*D1*Dd*f**3*fd - 5808*D1*Dd*f**3*r**2 - 11616*D1*Dd*f**3*r*s + 8712*D1*Dd*f**3*r - 5808*D1*Dd*f**3*s**2 + 8712*D1*Dd*f**3*s - 4356*D1*Dd*f**3 + 31680*D1*Dd*f**2*fd*r**2 + 63360*D1*Dd*f**2*fd*r*s - 44880*D1*Dd*f**2*fd*r + 31680*D1*Dd*f**2*fd*s**2 - 44880*D1*Dd*f**2*fd*s + 15840*D1*Dd*f**2*fd - 7920*D1*Dd*f**2*g2*r**2 - 15840*D1*Dd*f**2*g2*r*s + 11880*D1*Dd*f**2*g2*r - 7920*D1*Dd*f**2*g2*s**2 + 11880*D1*Dd*f**2*g2*s - 5940*D1*Dd*f**2*g2 + 19008*D1*Dd*f**2*gd2*r**2 + 38016*D1*Dd*f**2*gd2*r*s - 33264*D1*Dd*f**2*gd2*r + 19008*D1*Dd*f**2*gd2*s**2 - 33264*D1*Dd*f**2*gd2*s + 14256*D1*Dd*f**2*gd2 + 38016*D1*Dd*f*fd*g2*r**2 + 76032*D1*Dd*f*fd*g2*r*s - 47520*D1*Dd*f*fd*g2*r + 38016*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 - 4752*D1*Ddd*K*b1*f**2*r**2 - 9504*D1*Ddd*K*b1*f**2*r*s + 7128*D1*Ddd*K*b1*f**2*r - 4752*D1*Ddd*K*b1*f**2*s**2 + 7128*D1*Ddd*K*b1*f**2*s - 3564*D1*Ddd*K*b1*f**2 + 4752*D1*Ddd*b1*f**2*r**2 + 9504*D1*Ddd*b1*f**2*r*s - 7128*D1*Ddd*b1*f**2*r + 4752*D1*Ddd*b1*f**2*s**2 - 7128*D1*Ddd*b1*f**2*s + 3564*D1*Ddd*b1*f**2 - 7000*D1*Ddd*f**4*r**2 - 14000*D1*Ddd*f**4*r*s + 10500*D1*Ddd*f**4*r - 7000*D1*Ddd*f**4*s**2 + 10500*D1*Ddd*f**4*s - 5250*D1*Ddd*f**4 + 5280*D1*Ddd*f**3*r**2 + 10560*D1*Ddd*f**3*r*s - 7920*D1*Ddd*f**3*r + 5280*D1*Ddd*f**3*s**2 - 7920*D1*Ddd*f**3*s + 3960*D1*Ddd*f**3 + 9504*D1*Ddd*f**2*g2*r**2 + 19008*D1*Ddd*f**2*g2*r*s - 14256*D1*Ddd*f**2*g2*r + 9504*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 7128*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 14256*Dd**2*K*b1*f**2*r**2 - 28512*Dd**2*K*b1*f**2*r*s + 21384*Dd**2*K*b1*f**2*r - 14256*Dd**2*K*b1*f**2*s**2 + 21384*Dd**2*K*b1*f**2*s - 7128*Dd**2*K*b1*f**2 + 14256*Dd**2*b1*f**2*r**2 + 28512*Dd**2*b1*f**2*r*s - 21384*Dd**2*b1*f**2*r + 14256*Dd**2*b1*f**2*s**2 - 21384*Dd**2*b1*f**2*s + 7128*Dd**2*b1*f**2 - 21000*Dd**2*f**4*r**2 - 42000*Dd**2*f**4*r*s + 31500*Dd**2*f**4*r - 21000*Dd**2*f**4*s**2 + 31500*Dd**2*f**4*s - 10500*Dd**2*f**4 + 15840*Dd**2*f**3*r**2 + 31680*Dd**2*f**3*r*s - 23760*Dd**2*f**3*r + 15840*Dd**2*f**3*s**2 - 23760*Dd**2*f**3*s + 7920*Dd**2*f**3 + 28512*Dd**2*f**2*g2*r**2 + 57024*Dd**2*f**2*g2*r*s - 42768*Dd**2*f**2*g2*r + 28512*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 14256*Dd**2*f**2*g2)/(770*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**4*k1**4*k2**2*(-540*C*D1**2*bdd1*f**2*r**2 - 1080*C*D1**2*bdd1*f**2*r*s + 1080*C*D1**2*bdd1*f**2*r - 540*C*D1**2*bdd1*f**2*s**2 + 1080*C*D1**2*bdd1*f**2*s - 540*C*D1**2*bdd1*f**2 + 930*C*D1**2*f**2*fd*r**2 + 1860*C*D1**2*f**2*fd*r*s - 1240*C*D1**2*f**2*fd*r + 930*C*D1**2*f**2*fd*s**2 - 1240*C*D1**2*f**2*fd*s + 620*C*D1**2*f**2*fd - 1680*C*D1**2*f**2*fdd*r**2 - 3360*C*D1**2*f**2*fdd*r*s + 2240*C*D1**2*f**2*fdd*r - 1680*C*D1**2*f**2*fdd*s**2 + 2240*C*D1**2*f**2*fdd*s - 1120*C*D1**2*f**2*fdd - 3360*C*D1**2*f*fd**2*r**2 - 6720*C*D1**2*f*fd**2*r*s + 4480*C*D1**2*f*fd**2*r - 3360*C*D1**2*f*fd**2*s**2 + 4480*C*D1**2*f*fd**2*s - 1120*C*D1**2*f*fd**2 + 1240*C*D1*Dd*f**3*r**2 + 2480*C*D1*Dd*f**3*r*s - 1860*C*D1*Dd*f**3*r + 1240*C*D1*Dd*f**3*s**2 - 1860*C*D1*Dd*f**3*s + 930*C*D1*Dd*f**3 - 13440*C*D1*Dd*f**2*fd*r**2 - 26880*C*D1*Dd*f**2*fd*r*s + 19040*C*D1*Dd*f**2*fd*r - 13440*C*D1*Dd*f**2*fd*s**2 + 19040*C*D1*Dd*f**2*fd*s - 6720*C*D1*Dd*f**2*fd - 2240*C*D1*Ddd*f**3*r**2 - 4480*C*D1*Ddd*f**3*r*s + 3360*C*D1*Ddd*f**3*r - 2240*C*D1*Ddd*f**3*s**2 + 3360*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 6720*C*Dd**2*f**3*r**2 - 13440*C*Dd**2*f**3*r*s + 10080*C*Dd**2*f**3*r - 6720*C*Dd**2*f**3*s**2 + 10080*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 360*D1**2*K*bdd1*f**2*r**2 - 720*D1**2*K*bdd1*f**2*r*s + 720*D1**2*K*bdd1*f**2*r - 360*D1**2*K*bdd1*f**2*s**2 + 720*D1**2*K*bdd1*f**2*s - 360*D1**2*K*bdd1*f**2 - 756*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 720*D1**2*bdd1*f**2*r**2 + 1440*D1**2*bdd1*f**2*r*s - 1440*D1**2*bdd1*f**2*r + 720*D1**2*bdd1*f**2*s**2 - 1440*D1**2*bdd1*f**2*s + 720*D1**2*bdd1*f**2 + 756*D1**2*bdd1*f*g2*r**2 + 1512*D1**2*bdd1*f*g2*r*s - 1512*D1**2*bdd1*f*g2*r + 756*D1**2*bdd1*f*g2*s**2 - 1512*D1**2*bdd1*f*g2*s + 756*D1**2*bdd1*f*g2 - 420*D1**2*f**3*fd*r**2 - 840*D1**2*f**3*fd*r*s + 630*D1**2*f**3*fd*r - 420*D1**2*f**3*fd*s**2 + 630*D1**2*f**3*fd*s - 315*D1**2*f**3*fd - 630*D1**2*f**2*fd*r**2 - 1260*D1**2*f**2*fd*r*s + 840*D1**2*f**2*fd*r - 630*D1**2*f**2*fd*s**2 + 840*D1**2*f**2*fd*s - 420*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 2520*D1**2*f**2*fdd*r*s - 1680*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1680*D1**2*f**2*fdd*s + 840*D1**2*f**2*fdd - 306*D1**2*f**2*gd2*r**2 - 612*D1**2*f**2*gd2*r*s + 612*D1**2*f**2*gd2*r - 306*D1**2*f**2*gd2*s**2 + 612*D1**2*f**2*gd2*s - 306*D1**2*f**2*gd2 + 720*D1**2*f**2*gdd2*r**2 + 1440*D1**2*f**2*gdd2*r*s - 1440*D1**2*f**2*gdd2*r + 720*D1**2*f**2*gdd2*s**2 - 1440*D1**2*f**2*gdd2*s + 720*D1**2*f**2*gdd2 + 2520*D1**2*f*fd**2*r**2 + 5040*D1**2*f*fd**2*r*s - 3360*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 3360*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 612*D1**2*f*fd*g2*r**2 - 1224*D1**2*f*fd*g2*r*s + 612*D1**2*f*fd*g2*r - 612*D1**2*f*fd*g2*s**2 + 612*D1**2*f*fd*g2*s - 306*D1**2*f*fd*g2 + 2880*D1**2*f*fd*gd2*r**2 + 5760*D1**2*f*fd*gd2*r*s - 4320*D1**2*f*fd*gd2*r + 2880*D1**2*f*fd*gd2*s**2 - 4320*D1**2*f*fd*gd2*s + 1440*D1**2*f*fd*gd2 + 1440*D1**2*f*fdd*g2*r**2 + 2880*D1**2*f*fdd*g2*r*s - 1440*D1**2*f*fdd*g2*r + 1440*D1**2*f*fdd*g2*s**2 - 1440*D1**2*f*fdd*g2*s + 720*D1**2*f*fdd*g2 + 1440*D1**2*fd**2*g2*r**2 + 2880*D1**2*fd**2*g2*r*s - 1440*D1**2*fd**2*g2*r + 1440*D1**2*fd**2*g2*s**2 - 1440*D1**2*fd**2*g2*s - 420*D1*Dd*f**4*r**2 - 840*D1*Dd*f**4*r*s + 630*D1*Dd*f**4*r - 420*D1*Dd*f**4*s**2 + 630*D1*Dd*f**4*s - 315*D1*Dd*f**4 - 840*D1*Dd*f**3*r**2 - 1680*D1*Dd*f**3*r*s + 1260*D1*Dd*f**3*r - 840*D1*Dd*f**3*s**2 + 1260*D1*Dd*f**3*s - 630*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 20160*D1*Dd*f**2*fd*r*s - 14280*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 14280*D1*Dd*f**2*fd*s + 5040*D1*Dd*f**2*fd - 1224*D1*Dd*f**2*g2*r**2 - 2448*D1*Dd*f**2*g2*r*s + 1836*D1*Dd*f**2*g2*r - 1224*D1*Dd*f**2*g2*s**2 + 1836*D1*Dd*f**2*g2*s - 918*D1*Dd*f**2*g2 + 5760*D1*Dd*f**2*gd2*r**2 + 11520*D1*Dd*f**2*gd2*r*s - 10080*D1*Dd*f**2*gd2*r + 5760*D1*Dd*f**2*gd2*s**2 - 10080*D1*Dd*f**2*gd2*s + 4320*D1*Dd*f**2*gd2 + 11520*D1*Dd*f*fd*g2*r**2 + 23040*D1*Dd*f*fd*g2*r*s - 14400*D1*Dd*f*fd*g2*r + 11520*D1*Dd*f*fd*g2*s**2 - 14400*D1*Dd*f*fd*g2*s + 4320*D1*Dd*f*fd*g2 + 1680*D1*Ddd*f**3*r**2 + 3360*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 2520*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 2880*D1*Ddd*f**2*g2*r**2 + 5760*D1*Ddd*f**2*g2*r*s - 4320*D1*Ddd*f**2*g2*r + 2880*D1*Ddd*f**2*g2*s**2 - 4320*D1*Ddd*f**2*g2*s + 2160*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(30*f**3*(r + s - 1) + 3*f**2*(50*C + 17*K - 55)*(r + s - 1) - 2*f*(60*fd*(3*C + 2*K - 4)*(2*r + 2*s - 1) + (77*g2 - 252*gd2)*(r + s - 1)) + 504*fd*g2*(r + s)) - 24*Dd*f*(5*f*(3*C + 2*K - 4) - 21*g2)*(4*r + 4*s - 3))*(r + s - 1) + 5040*Dd**2*f**3*r**2 + 10080*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 7560*Dd**2*f**3*s + 2520*Dd**2*f**3 + 8640*Dd**2*f**2*g2*r**2 + 17280*Dd**2*f**2*g2*r*s - 12960*Dd**2*f**2*g2*r + 8640*Dd**2*f**2*g2*s**2 - 12960*Dd**2*f**2*g2*s + 4320*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(11*fd - 18*fdd)*(r + s)**2 + D1*(Dd*(11*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 36*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 18*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(300*C*D1**2*f*fd*r**2 + 600*C*D1**2*f*fd*r*s - 300*C*D1**2*f*fd*r + 300*C*D1**2*f*fd*s**2 - 300*C*D1**2*f*fd*s + 150*C*D1**2*f*fd - 360*C*D1**2*f*fdd*r**2 - 720*C*D1**2*f*fdd*r*s + 360*C*D1**2*f*fdd*r - 360*C*D1**2*f*fdd*s**2 + 360*C*D1**2*f*fdd*s - 180*C*D1**2*f*fdd - 360*C*D1**2*fd**2*r**2 - 720*C*D1**2*fd**2*r*s + 360*C*D1**2*fd**2*r - 360*C*D1**2*fd**2*s**2 + 360*C*D1**2*fd**2*s + 600*C*D1*Dd*f**2*r**2 + 1200*C*D1*Dd*f**2*r*s - 900*C*D1*Dd*f**2*r + 600*C*D1*Dd*f**2*s**2 - 900*C*D1*Dd*f**2*s + 450*C*D1*Dd*f**2 - 2880*C*D1*Dd*f*fd*r**2 - 5760*C*D1*Dd*f*fd*r*s + 3600*C*D1*Dd*f*fd*r - 2880*C*D1*Dd*f*fd*s**2 + 3600*C*D1*Dd*f*fd*s - 1080*C*D1*Dd*f*fd - 720*C*D1*Ddd*f**2*r**2 - 1440*C*D1*Ddd*f**2*r*s + 1080*C*D1*Ddd*f**2*r - 720*C*D1*Ddd*f**2*s**2 + 1080*C*D1*Ddd*f**2*s - 540*C*D1*Ddd*f**2 - 2160*C*Dd**2*f**2*r**2 - 4320*C*Dd**2*f**2*r*s + 3240*C*Dd**2*f**2*r - 2160*C*Dd**2*f**2*s**2 + 3240*C*Dd**2*f**2*s - 1080*C*Dd**2*f**2 + 102*D1**2*K*f*fd*r**2 + 204*D1**2*K*f*fd*r*s - 102*D1**2*K*f*fd*r + 102*D1**2*K*f*fd*s**2 - 102*D1**2*K*f*fd*s + 51*D1**2*K*f*fd - 240*D1**2*K*f*fdd*r**2 - 480*D1**2*K*f*fdd*r*s + 240*D1**2*K*f*fdd*r - 240*D1**2*K*f*fdd*s**2 + 240*D1**2*K*f*fdd*s - 120*D1**2*K*f*fdd - 240*D1**2*K*fd**2*r**2 - 480*D1**2*K*fd**2*r*s + 240*D1**2*K*fd**2*r - 240*D1**2*K*fd**2*s**2 + 240*D1**2*K*fd**2*s - 252*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 90*D1**2*f**2*fd*r**2 + 180*D1**2*f**2*fd*r*s - 120*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 330*D1**2*f*fd*r**2 - 660*D1**2*f*fd*r*s + 330*D1**2*f*fd*r - 330*D1**2*f*fd*s**2 + 330*D1**2*f*fd*s - 165*D1**2*f*fd + 480*D1**2*f*fdd*r**2 + 960*D1**2*f*fdd*r*s - 480*D1**2*f*fdd*r + 480*D1**2*f*fdd*s**2 - 480*D1**2*f*fdd*s + 240*D1**2*f*fdd - 154*D1**2*f*gd2*r**2 - 308*D1**2*f*gd2*r*s + 308*D1**2*f*gd2*r - 154*D1**2*f*gd2*s**2 + 308*D1**2*f*gd2*s - 154*D1**2*f*gd2 + 252*D1**2*f*gdd2*r**2 + 504*D1**2*f*gdd2*r*s - 504*D1**2*f*gdd2*r + 252*D1**2*f*gdd2*s**2 - 504*D1**2*f*gdd2*s + 252*D1**2*f*gdd2 + 480*D1**2*fd**2*r**2 + 960*D1**2*fd**2*r*s - 480*D1**2*fd**2*r + 480*D1**2*fd**2*s**2 - 480*D1**2*fd**2*s - 154*D1**2*fd*g2*r**2 - 308*D1**2*fd*g2*r*s - 154*D1**2*fd*g2*s**2 + 504*D1**2*fd*gd2*r**2 + 1008*D1**2*fd*gd2*r*s - 504*D1**2*fd*gd2*r + 504*D1**2*fd*gd2*s**2 - 504*D1**2*fd*gd2*s + 252*D1**2*fdd*g2*r**2 + 504*D1**2*fdd*g2*r*s + 252*D1**2*fdd*g2*s**2 + 204*D1*Dd*K*f**2*r**2 + 408*D1*Dd*K*f**2*r*s - 306*D1*Dd*K*f**2*r + 204*D1*Dd*K*f**2*s**2 - 306*D1*Dd*K*f**2*s + 153*D1*Dd*K*f**2 - 1920*D1*Dd*K*f*fd*r**2 - 3840*D1*Dd*K*f*fd*r*s + 2400*D1*Dd*K*f*fd*r - 1920*D1*Dd*K*f*fd*s**2 + 2400*D1*Dd*K*f*fd*s - 720*D1*Dd*K*f*fd + 120*D1*Dd*f**3*r**2 + 240*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r + 120*D1*Dd*f**3*s**2 - 180*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 660*D1*Dd*f**2*r**2 - 1320*D1*Dd*f**2*r*s + 990*D1*Dd*f**2*r - 660*D1*Dd*f**2*s**2 + 990*D1*Dd*f**2*s - 495*D1*Dd*f**2 + 3840*D1*Dd*f*fd*r**2 + 7680*D1*Dd*f*fd*r*s - 4800*D1*Dd*f*fd*r + 3840*D1*Dd*f*fd*s**2 - 4800*D1*Dd*f*fd*s + 1440*D1*Dd*f*fd - 616*D1*Dd*f*g2*r**2 - 1232*D1*Dd*f*g2*r*s + 924*D1*Dd*f*g2*r - 616*D1*Dd*f*g2*s**2 + 924*D1*Dd*f*g2*s - 462*D1*Dd*f*g2 + 2016*D1*Dd*f*gd2*r**2 + 4032*D1*Dd*f*gd2*r*s - 3528*D1*Dd*f*gd2*r + 2016*D1*Dd*f*gd2*s**2 - 3528*D1*Dd*f*gd2*s + 1512*D1*Dd*f*gd2 + 2016*D1*Dd*fd*g2*r**2 + 4032*D1*Dd*fd*g2*r*s - 1512*D1*Dd*fd*g2*r + 2016*D1*Dd*fd*g2*s**2 - 1512*D1*Dd*fd*g2*s - 480*D1*Ddd*K*f**2*r**2 - 960*D1*Ddd*K*f**2*r*s + 720*D1*Ddd*K*f**2*r - 480*D1*Ddd*K*f**2*s**2 + 720*D1*Ddd*K*f**2*s - 360*D1*Ddd*K*f**2 + 960*D1*Ddd*f**2*r**2 + 1920*D1*Ddd*f**2*r*s - 1440*D1*Ddd*f**2*r + 960*D1*Ddd*f**2*s**2 - 1440*D1*Ddd*f**2*s + 720*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r**2 + 2016*D1*Ddd*f*g2*r*s - 1512*D1*Ddd*f*g2*r + 1008*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 756*D1*Ddd*f*g2 + 14*D1*bd1*(K - 1)*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) - 1440*Dd**2*K*f**2*r**2 - 2880*Dd**2*K*f**2*r*s + 2160*Dd**2*K*f**2*r - 1440*Dd**2*K*f**2*s**2 + 2160*Dd**2*K*f**2*s - 720*Dd**2*K*f**2 + 2880*Dd**2*f**2*r**2 + 5760*Dd**2*f**2*r*s - 4320*Dd**2*f**2*r + 2880*Dd**2*f**2*s**2 - 4320*Dd**2*f**2*s + 1440*Dd**2*f**2 + 3024*Dd**2*f*g2*r**2 + 6048*Dd**2*f*g2*r*s - 4536*Dd**2*f*g2*r + 3024*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 1512*Dd**2*f*g2))/(70*d**2*k3**7) + 8*D1**2*Pk2*Pkd3*ct**4*k1**4*st**2*(1386*C*D1**2*f**2*fd*r*s - 462*C*D1**2*f**2*fd*r + 1386*C*D1**2*f**2*fd*s**2 - 1386*C*D1**2*f**2*fd*s + 462*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 1848*C*D1*Dd*f**3*r*s - 462*C*D1*Dd*f**3*r + 1848*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 462*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 3100*D1**2*f**3*fd*r*s - 775*D1**2*f**3*fd*r + 3100*D1**2*f**3*fd*s**2 - 3100*D1**2*f**3*fd*s + 775*D1**2*f**3*fd - 2100*D1**2*f**3*fdd*r*s + 525*D1**2*f**3*fdd*r - 2100*D1**2*f**3*fdd*s**2 + 2100*D1**2*f**3*fdd*s - 525*D1**2*f**3*fdd - 6300*D1**2*f**2*fd**2*r*s + 1575*D1**2*f**2*fd**2*r - 6300*D1**2*f**2*fd**2*s**2 + 6300*D1**2*f**2*fd**2*s - 1050*D1**2*f**2*fd**2 - 1386*D1**2*f**2*fd*r*s + 462*D1**2*f**2*fd*r - 1386*D1**2*f**2*fd*s**2 + 1386*D1**2*f**2*fd*s - 462*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*s**2 + 726*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 1452*D1**2*f*fd*g2*r*s + 726*D1**2*f*fd*g2*r - 1452*D1**2*f*fd*g2*s**2 + 1452*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 3100*D1*Dd*f**4*r*s - 775*D1*Dd*f**4*r + 3100*D1*Dd*f**4*s**2 - 3100*D1*Dd*f**4*s + 775*D1*Dd*f**4 - 16800*D1*Dd*f**3*fd*r*s + 4200*D1*Dd*f**3*fd*r - 16800*D1*Dd*f**3*fd*s**2 + 16800*D1*Dd*f**3*fd*s - 3150*D1*Dd*f**3*fd - 1848*D1*Dd*f**3*r*s + 462*D1*Dd*f**3*r - 1848*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 462*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 2904*D1*Dd*f**2*g2*r*s + 726*D1*Dd*f**2*g2*r - 2904*D1*Dd*f**2*g2*s**2 + 2904*D1*Dd*f**2*g2*s - 726*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 2100*D1*Ddd*f**4*r*s + 525*D1*Ddd*f**4*r - 2100*D1*Ddd*f**4*s**2 + 2100*D1*Ddd*f**4*s - 525*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 6300*Dd**2*f**4*r*s + 1575*Dd**2*f**4*r - 6300*Dd**2*f**4*s**2 + 6300*Dd**2*f**4*s - 1050*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**4*k1**4*(450*C*D1**2*bdd1*f**2*r**2 + 1980*C*D1**2*bdd1*f**2*r*s - 1080*C*D1**2*bdd1*f**2*r + 1530*C*D1**2*bdd1*f**2*s**2 - 2160*C*D1**2*bdd1*f**2*s + 1080*C*D1**2*bdd1*f**2 + 1890*C*D1**2*f**2*fd*r**2 + 8700*C*D1**2*f**2*fd*r*s - 4160*C*D1**2*f**2*fd*r + 6810*C*D1**2*f**2*fd*s**2 - 7440*C*D1**2*f**2*fd*s + 2900*C*D1**2*f**2*fd - 2430*C*D1**2*f**2*fdd*r**2 - 7860*C*D1**2*f**2*fdd*r*s + 4240*C*D1**2*f**2*fdd*r - 5430*C*D1**2*f**2*fdd*s**2 + 6240*C*D1**2*f**2*fdd*s - 2620*C*D1**2*f**2*fdd - 4860*C*D1**2*f*fd**2*r**2 - 15720*C*D1**2*f*fd**2*r*s + 8480*C*D1**2*f*fd**2*r - 10860*C*D1**2*f*fd**2*s**2 + 12480*C*D1**2*f*fd**2*s - 2620*C*D1**2*f*fd**2 + 2520*C*D1*Dd*f**3*r**2 + 11600*C*D1*Dd*f**3*r*s - 5420*C*D1*Dd*f**3*r + 9080*C*D1*Dd*f**3*s**2 - 10340*C*D1*Dd*f**3*s + 3530*C*D1*Dd*f**3 - 19440*C*D1*Dd*f**2*fd*r**2 - 62880*C*D1*Dd*f**2*fd*r*s + 34540*C*D1*Dd*f**2*fd*r - 43440*C*D1*Dd*f**2*fd*s**2 + 51540*C*D1*Dd*f**2*fd*s - 14720*C*D1*Dd*f**2*fd - 3240*C*D1*Ddd*f**3*r**2 - 10480*C*D1*Ddd*f**3*r*s + 5860*C*D1*Ddd*f**3*r - 7240*C*D1*Ddd*f**3*s**2 + 8860*C*D1*Ddd*f**3*s - 3430*C*D1*Ddd*f**3 - 9720*C*Dd**2*f**3*r**2 - 31440*C*Dd**2*f**3*r*s + 17580*C*Dd**2*f**3*r - 21720*C*Dd**2*f**3*s**2 + 26580*C*Dd**2*f**3*s - 6860*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r**2 - 1746*D1**2*K*bdd1*f**2*r*s + 990*D1**2*K*bdd1*f**2*r - 1251*D1**2*K*bdd1*f**2*s**2 + 1746*D1**2*K*bdd1*f**2*s - 495*D1**2*K*bdd1*f**2 + 126*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 23*s + 6) + 1225*D1**2*bdd1*f**3*r**2 + 2730*D1**2*bdd1*f**3*r*s - 2240*D1**2*bdd1*f**3*r + 1505*D1**2*bdd1*f**3*s**2 - 2520*D1**2*bdd1*f**3*s + 1540*D1**2*bdd1*f**3 + 945*D1**2*bdd1*f**2*r**2 + 1746*D1**2*bdd1*f**2*r*s - 1710*D1**2*bdd1*f**2*r + 801*D1**2*bdd1*f**2*s**2 - 1566*D1**2*bdd1*f**2*s + 315*D1**2*bdd1*f**2 - 630*D1**2*bdd1*f*g2*r**2 - 2772*D1**2*bdd1*f*g2*r*s + 1512*D1**2*bdd1*f*g2*r - 2142*D1**2*bdd1*f*g2*s**2 + 3024*D1**2*bdd1*f*g2*s - 1512*D1**2*bdd1*f*g2 + 4340*D1**2*f**3*fd*r**2 + 14840*D1**2*f**3*fd*r*s - 8050*D1**2*f**3*fd*r + 10500*D1**2*f**3*fd*s**2 - 12670*D1**2*f**3*fd*s + 4795*D1**2*f**3*fd - 5180*D1**2*f**3*fdd*r**2 - 13160*D1**2*f**3*fdd*r*s + 8470*D1**2*f**3*fdd*r - 7980*D1**2*f**3*fdd*s**2 + 10570*D1**2*f**3*fdd*s - 4585*D1**2*f**3*fdd - 15540*D1**2*f**2*fd**2*r**2 - 39480*D1**2*f**2*fd**2*r*s + 25410*D1**2*f**2*fd**2*r - 23940*D1**2*f**2*fd**2*s**2 + 31710*D1**2*f**2*fd**2*s - 9170*D1**2*f**2*fd**2 - 3390*D1**2*f**2*fd*r**2 - 12000*D1**2*f**2*fd*r*s + 6260*D1**2*f**2*fd*r - 8610*D1**2*f**2*fd*s**2 + 9740*D1**2*f**2*fd*s - 4000*D1**2*f**2*fd + 4530*D1**2*f**2*fdd*r**2 + 12480*D1**2*f**2*fdd*r*s - 7180*D1**2*f**2*fdd*r + 7950*D1**2*f**2*fdd*s**2 - 9460*D1**2*f**2*fdd*s + 4160*D1**2*f**2*fdd - 594*D1**2*f**2*gd2*r**2 - 3708*D1**2*f**2*gd2*r*s + 1188*D1**2*f**2*gd2*r - 3114*D1**2*f**2*gd2*s**2 + 3708*D1**2*f**2*gd2*s - 594*D1**2*f**2*gd2 + 990*D1**2*f**2*gdd2*r**2 + 3492*D1**2*f**2*gdd2*r*s - 1980*D1**2*f**2*gdd2*r + 2502*D1**2*f**2*gdd2*s**2 - 3492*D1**2*f**2*gdd2*s + 990*D1**2*f**2*gdd2 + 9060*D1**2*f*fd**2*r**2 + 24960*D1**2*f*fd**2*r*s - 14360*D1**2*f*fd**2*r + 15900*D1**2*f*fd**2*s**2 - 18920*D1**2*f*fd**2*s + 4160*D1**2*f*fd**2 - 1188*D1**2*f*fd*g2*r**2 - 7416*D1**2*f*fd*g2*r*s + 3708*D1**2*f*fd*g2*r - 6228*D1**2*f*fd*g2*s**2 + 6228*D1**2*f*fd*g2*s - 3114*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r**2 + 13968*D1**2*f*fd*gd2*r*s - 7452*D1**2*f*fd*gd2*r + 10008*D1**2*f*fd*gd2*s**2 - 11988*D1**2*f*fd*gd2*s + 3492*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r**2 + 6984*D1**2*f*fdd*g2*r*s - 3492*D1**2*f*fdd*g2*r + 5004*D1**2*f*fdd*g2*s**2 - 5004*D1**2*f*fdd*g2*s + 2502*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r**2 + 6984*D1**2*fd**2*g2*r*s - 3492*D1**2*fd**2*g2*r + 5004*D1**2*fd**2*g2*s**2 - 5004*D1**2*fd**2*g2*s + 4340*D1*Dd*f**4*r**2 + 14840*D1*Dd*f**4*r*s - 8050*D1*Dd*f**4*r + 10500*D1*Dd*f**4*s**2 - 12670*D1*Dd*f**4*s + 4795*D1*Dd*f**4 - 41440*D1*Dd*f**3*fd*r**2 - 105280*D1*Dd*f**3*fd*r*s + 67760*D1*Dd*f**3*fd*r - 63840*D1*Dd*f**3*fd*s**2 + 84560*D1*Dd*f**3*fd*s - 27510*D1*Dd*f**3*fd - 4520*D1*Dd*f**3*r**2 - 16000*D1*Dd*f**3*r*s + 8520*D1*Dd*f**3*r - 11480*D1*Dd*f**3*s**2 + 13740*D1*Dd*f**3*s - 5130*D1*Dd*f**3 + 36240*D1*Dd*f**2*fd*r**2 + 99840*D1*Dd*f**2*fd*r*s - 59320*D1*Dd*f**2*fd*r + 63600*D1*Dd*f**2*fd*s**2 - 78700*D1*Dd*f**2*fd*s + 23820*D1*Dd*f**2*fd - 2376*D1*Dd*f**2*g2*r**2 - 14832*D1*Dd*f**2*g2*r*s + 6084*D1*Dd*f**2*g2*r - 12456*D1*Dd*f**2*g2*s**2 + 13644*D1*Dd*f**2*g2*s - 4302*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r**2 + 27936*D1*Dd*f**2*gd2*r*s - 15372*D1*Dd*f**2*gd2*r + 20016*D1*Dd*f**2*gd2*s**2 - 25956*D1*Dd*f**2*gd2*s + 7452*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r**2 + 55872*D1*Dd*f*fd*g2*r*s - 28872*D1*Dd*f*fd*g2*r + 40032*D1*Dd*f*fd*g2*s**2 - 43992*D1*Dd*f*fd*g2*s + 11988*D1*Dd*f*fd*g2 - 5180*D1*Ddd*f**4*r**2 - 13160*D1*Ddd*f**4*r*s + 8470*D1*Ddd*f**4*r - 7980*D1*Ddd*f**4*s**2 + 10570*D1*Ddd*f**4*s - 4585*D1*Ddd*f**4 + 6040*D1*Ddd*f**3*r**2 + 16640*D1*Ddd*f**3*r*s - 10200*D1*Ddd*f**3*r + 10600*D1*Ddd*f**3*s**2 - 13620*D1*Ddd*f**3*s + 5670*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r**2 + 13968*D1*Ddd*f**2*g2*r*s - 7452*D1*Ddd*f**2*g2*r + 10008*D1*Ddd*f**2*g2*s**2 - 11988*D1*Ddd*f**2*g2*s + 4482*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(175*r**2 + r*(462*s - 428) + 287*s**2 - 540*s + 328) + f**2*(-18*C*(15*r**2 + r*(94*s - 64) + 79*s**2 - 128*s + 64) + 9*K*(33*r**2 + 206*r*s - 66*r + 173*s**2 - 206*s + 33) + 70*fd*(105*r**2 + r*(234*s - 173) + 129*s**2 - 193*s + 56) - 567*r**2 - 1350*r*s + 522*r - 783*s**2 + 738*s + 315) + 6*f*(3*fd*(20*C*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 20*s + 3) - K*(110*r**2 + 388*r*s - 207*r + 278*s**2 - 333*s + 97) + 210*r**2 + 388*r*s - 297*r + 178*s**2 - 273*s + 147) + 7*g2*(5*r**2 + r*(42*s - 32) + 37*s**2 - 64*s + 32) - 42*gd2*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 23*s + 6)) - 252*fd*g2*(5*r**2 + 11*r*(2*s - 1) + s*(17*s - 17))) + 2*Dd*f*(35*f**2*(140*r**2 + 3*r*(104*s - 79) + 172*s**2 - 265*s + 100) + 9*f*(10*C*(20*r**2 + r*(88*s - 45) + 68*s**2 - 87*s + 24) - K*(220*r**2 + 776*r*s - 427*r + 556*s**2 - 721*s + 207) + 420*r**2 + 776*r*s - 687*r + 356*s**2 - 631*s + 277) - 126*g2*(20*r**2 + r*(88*s - 45) + 68*s**2 - 87*s + 24))) - 15540*Dd**2*f**4*r**2 - 39480*Dd**2*f**4*r*s + 25410*Dd**2*f**4*r - 23940*Dd**2*f**4*s**2 + 31710*Dd**2*f**4*s - 9170*Dd**2*f**4 + 18120*Dd**2*f**3*r**2 + 49920*Dd**2*f**3*r*s - 30600*Dd**2*f**3*r + 31800*Dd**2*f**3*s**2 - 40860*Dd**2*f**3*s + 11340*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r**2 + 41904*Dd**2*f**2*g2*r*s - 22356*Dd**2*f**2*g2*r + 30024*Dd**2*f**2*g2*s**2 - 35964*Dd**2*f**2*g2*s + 8964*Dd**2*f**2*g2 - 21*b1**2*(K - 1)*(D1**2*(fd*(5*r**2 + 42*r*s - 10*r + 37*s**2 - 10*s + 5) - 3*fdd*(5*r**2 + 22*r*s - 10*r + 17*s**2 - 10*s + 5)) + D1*(Dd*(f*(20*r**2 + 168*r*s - 62*r + 148*s**2 - 158*s + 47) - 6*fd*(20*r**2 + 88*r*s - 41*r + 68*s**2 - 59*s + 15)) - 3*Ddd*f*(20*r**2 + r*(88*s - 42) + 68*s**2 - 78*s + 27)) - 18*Dd**2*f*(10*r**2 + r*(44*s - 21) + 34*s**2 - 39*s + 9)) + b1*(-540*C*D1**2*f*fd*r**2 - 3384*C*D1**2*f*fd*r*s + 1080*C*D1**2*f*fd*r - 2844*C*D1**2*f*fd*s**2 + 2232*C*D1**2*f*fd*s - 540*C*D1**2*f*fd + 900*C*D1**2*f*fdd*r**2 + 3960*C*D1**2*f*fdd*r*s - 1800*C*D1**2*f*fdd*r + 3060*C*D1**2*f*fdd*s**2 - 2880*C*D1**2*f*fdd*s + 900*C*D1**2*f*fdd + 900*C*D1**2*fd**2*r**2 + 3960*C*D1**2*fd**2*r*s - 1800*C*D1**2*fd**2*r + 3060*C*D1**2*fd**2*s**2 - 2880*C*D1**2*fd**2*s + 900*C*D1**2*fd**2 - 1080*C*D1*Dd*f**2*r**2 - 6768*C*D1*Dd*f**2*r*s + 2772*C*D1*Dd*f**2*r - 5688*C*D1*Dd*f**2*s**2 + 6228*C*D1*Dd*f**2*s - 1962*C*D1*Dd*f**2 + 7200*C*D1*Dd*f*fd*r**2 + 31680*C*D1*Dd*f*fd*r*s - 14760*C*D1*Dd*f*fd*r + 24480*C*D1*Dd*f*fd*s**2 - 25560*C*D1*Dd*f*fd*s + 6480*C*D1*Dd*f*fd + 1800*C*D1*Ddd*f**2*r**2 + 7920*C*D1*Ddd*f**2*r*s - 3780*C*D1*Ddd*f**2*r + 6120*C*D1*Ddd*f**2*s**2 - 7020*C*D1*Ddd*f**2*s + 2430*C*D1*Ddd*f**2 + 5400*C*Dd**2*f**2*r**2 + 23760*C*Dd**2*f**2*r*s - 11340*C*Dd**2*f**2*r + 18360*C*Dd**2*f**2*s**2 - 21060*C*Dd**2*f**2*s + 4860*C*Dd**2*f**2 + 594*D1**2*K*f*fd*r**2 + 3708*D1**2*K*f*fd*r*s - 1854*D1**2*K*f*fd*r + 3114*D1**2*K*f*fd*s**2 - 3114*D1**2*K*f*fd*s + 1557*D1**2*K*f*fd - 990*D1**2*K*f*fdd*r**2 - 3492*D1**2*K*f*fdd*r*s + 1746*D1**2*K*f*fdd*r - 2502*D1**2*K*f*fdd*s**2 + 2502*D1**2*K*f*fdd*s - 1251*D1**2*K*f*fdd - 990*D1**2*K*fd**2*r**2 - 3492*D1**2*K*fd**2*r*s + 1746*D1**2*K*fd**2*r - 2502*D1**2*K*fd**2*s**2 + 2502*D1**2*K*fd**2*s + 63*D1**2*bdd1*f*(K - 1)*(10*r**2 + 44*r*s - 22*r + 34*s**2 - 46*s + 17) - 2625*D1**2*f**2*fd*r**2 - 6930*D1**2*f**2*fd*r*s + 3670*D1**2*f**2*fd*r - 4305*D1**2*f**2*fd*s**2 + 4790*D1**2*f**2*fd*s - 1545*D1**2*f**2*fd + 3675*D1**2*f**2*fdd*r**2 + 8190*D1**2*f**2*fdd*r*s - 5390*D1**2*f**2*fdd*r + 4515*D1**2*f**2*fdd*s**2 - 5950*D1**2*f**2*fdd*s + 2415*D1**2*f**2*fdd + 7350*D1**2*f*fd**2*r**2 + 16380*D1**2*f*fd**2*r*s - 10780*D1**2*f*fd**2*r + 9030*D1**2*f*fd**2*s**2 - 11900*D1**2*f*fd**2*s + 3990*D1**2*f*fd**2 - 1134*D1**2*f*fd*r**2 - 2700*D1**2*f*fd*r*s + 1962*D1**2*f*fd*r - 1566*D1**2*f*fd*s**2 + 2178*D1**2*f*fd*s - 1665*D1**2*f*fd + 1890*D1**2*f*fdd*r**2 + 3492*D1**2*f*fdd*r*s - 1926*D1**2*f*fdd*r + 1602*D1**2*f*fdd*s**2 - 1782*D1**2*f*fdd*s + 1431*D1**2*f*fdd + 210*D1**2*f*gd2*r**2 + 1764*D1**2*f*gd2*r*s - 420*D1**2*f*gd2*r + 1554*D1**2*f*gd2*s**2 - 1764*D1**2*f*gd2*s + 210*D1**2*f*gd2 - 630*D1**2*f*gdd2*r**2 - 2772*D1**2*f*gdd2*r*s + 1260*D1**2*f*gdd2*r - 2142*D1**2*f*gdd2*s**2 + 2772*D1**2*f*gdd2*s - 630*D1**2*f*gdd2 + 1890*D1**2*fd**2*r**2 + 3492*D1**2*fd**2*r*s - 1926*D1**2*fd**2*r + 1602*D1**2*fd**2*s**2 - 1782*D1**2*fd**2*s - 900*D1**2*fd**2 + 210*D1**2*fd*g2*r**2 + 1764*D1**2*fd*g2*r*s - 420*D1**2*fd*g2*r + 1554*D1**2*fd*g2*s**2 - 420*D1**2*fd*g2*s + 210*D1**2*fd*g2 - 1260*D1**2*fd*gd2*r**2 - 5544*D1**2*fd*gd2*r*s + 2520*D1**2*fd*gd2*r - 4284*D1**2*fd*gd2*s**2 + 4032*D1**2*fd*gd2*s - 1260*D1**2*fd*gd2 - 630*D1**2*fdd*g2*r**2 - 2772*D1**2*fdd*g2*r*s + 1260*D1**2*fdd*g2*r - 2142*D1**2*fdd*g2*s**2 + 1260*D1**2*fdd*g2*s - 630*D1**2*fdd*g2 + 1188*D1*Dd*K*f**2*r**2 + 7416*D1*Dd*K*f**2*r*s - 3042*D1*Dd*K*f**2*r + 6228*D1*Dd*K*f**2*s**2 - 6822*D1*Dd*K*f**2*s + 2151*D1*Dd*K*f**2 - 7920*D1*Dd*K*f*fd*r**2 - 27936*D1*Dd*K*f*fd*r*s + 14436*D1*Dd*K*f*fd*r - 20016*D1*Dd*K*f*fd*s**2 + 21996*D1*Dd*K*f*fd*s - 5994*D1*Dd*K*f*fd - 3500*D1*Dd*f**3*r**2 - 9240*D1*Dd*f**3*r*s + 5810*D1*Dd*f**3*r - 5740*D1*Dd*f**3*s**2 + 7490*D1*Dd*f**3*s - 3185*D1*Dd*f**3 + 29400*D1*Dd*f**2*fd*r**2 + 65520*D1*Dd*f**2*fd*r*s - 44450*D1*Dd*f**2*fd*r + 36120*D1*Dd*f**2*fd*s**2 - 49210*D1*Dd*f**2*fd*s + 16730*D1*Dd*f**2*fd - 2268*D1*Dd*f**2*r**2 - 5400*D1*Dd*f**2*r*s + 3618*D1*Dd*f**2*r - 3132*D1*Dd*f**2*s**2 + 4266*D1*Dd*f**2*s - 1917*D1*Dd*f**2 + 15120*D1*Dd*f*fd*r**2 + 27936*D1*Dd*f*fd*r*s - 18756*D1*Dd*f*fd*r + 12816*D1*Dd*f*fd*s**2 - 17316*D1*Dd*f*fd*s + 5634*D1*Dd*f*fd + 840*D1*Dd*f*g2*r**2 + 7056*D1*Dd*f*g2*r*s - 2604*D1*Dd*f*g2*r + 6216*D1*Dd*f*g2*s**2 - 6636*D1*Dd*f*g2*s + 1974*D1*Dd*f*g2 - 5040*D1*Dd*f*gd2*r**2 - 22176*D1*Dd*f*gd2*r*s + 10332*D1*Dd*f*gd2*r - 17136*D1*Dd*f*gd2*s**2 + 20916*D1*Dd*f*gd2*s - 5292*D1*Dd*f*gd2 - 5040*D1*Dd*fd*g2*r**2 - 22176*D1*Dd*fd*g2*r*s + 10332*D1*Dd*fd*g2*r - 17136*D1*Dd*fd*g2*s**2 + 14868*D1*Dd*fd*g2*s - 3780*D1*Dd*fd*g2 - 1980*D1*Ddd*K*f**2*r**2 - 6984*D1*Ddd*K*f**2*r*s + 3726*D1*Ddd*K*f**2*r - 5004*D1*Ddd*K*f**2*s**2 + 5994*D1*Ddd*K*f**2*s - 2241*D1*Ddd*K*f**2 + 4900*D1*Ddd*f**3*r**2 + 10920*D1*Ddd*f**3*r*s - 7630*D1*Ddd*f**3*r + 6020*D1*Ddd*f**3*s**2 - 8470*D1*Ddd*f**3*s + 3955*D1*Ddd*f**3 + 3780*D1*Ddd*f**2*r**2 + 6984*D1*Ddd*f**2*r*s - 5526*D1*Ddd*f**2*r + 3204*D1*Ddd*f**2*s**2 - 5094*D1*Ddd*f**2*s + 2691*D1*Ddd*f**2 - 2520*D1*Ddd*f*g2*r**2 - 11088*D1*Ddd*f*g2*r*s + 5292*D1*Ddd*f*g2*r - 8568*D1*Ddd*f*g2*s**2 + 9828*D1*Ddd*f*g2*s - 3402*D1*Ddd*f*g2 - 21*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 84*r*s - 42*r + 74*s**2 - 106*s + 37) - 6*fd*(10*r**2 + 44*r*s - 21*r + 34*s**2 - 33*s + 5)) - 6*Dd*f*(40*r**2 + 2*r*(88*s - 43) + 136*s**2 - 170*s + 45)) - 5940*Dd**2*K*f**2*r**2 - 20952*Dd**2*K*f**2*r*s + 11178*Dd**2*K*f**2*r - 15012*Dd**2*K*f**2*s**2 + 17982*Dd**2*K*f**2*s - 4482*Dd**2*K*f**2 + 14700*Dd**2*f**3*r**2 + 32760*Dd**2*f**3*r*s - 22890*Dd**2*f**3*r + 18060*Dd**2*f**3*s**2 - 25410*Dd**2*f**3*s + 7910*Dd**2*f**3 + 11340*Dd**2*f**2*r**2 + 20952*Dd**2*f**2*r*s - 16578*Dd**2*f**2*r + 9612*Dd**2*f**2*s**2 - 15282*Dd**2*f**2*s + 5382*Dd**2*f**2 - 7560*Dd**2*f*g2*r**2 - 33264*Dd**2*f*g2*r*s + 15876*Dd**2*f*g2*r - 25704*Dd**2*f*g2*s**2 + 29484*Dd**2*f*g2*s - 6804*Dd**2*f*g2))/(630*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**4*k1**4*(D1**2*b1*(5*f**2*(5*fd - 7*fdd)*(r*(6*s - 2) + 6*s**2 - 7*s + 2) + f*(-35*fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3) + 27*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 45*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 45*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*b1*f*(Dd*(50*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-35*fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11) + 27*r*(4*s - 1) + 27*(1 - 2*s)**2) - 90*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(14*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*bd1*f*(D1*(f*s*(25*f*(2*r + 2*s - 1) + 27*r + 27*s - 27) - 5*fd*(7*f*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + 9*r*(4*s - 1) + 9*(1 - 2*s)**2)) - 5*Dd*f*(7*f*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 72*r*s - 9*r + 72*s**2 - 72*s + 9)) - 5*Dd**2*b1*f**2*(14*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - 5*f*(D1**2*(7*bdd1*f**2*s*(2*r + 2*s - 1) + f*(9*bdd1*s*(r + s - 1) - 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(-5*f*(r*(4*s - 1) + (1 - 2*s)**2) + 7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 7*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k2**2*k3**3) + 3*D1**2*Pk2*Pkd3*ct**4*k1**2*k2**4*st**4*(396*C*D1**2*f**2*fd*r**2 + 792*C*D1**2*f**2*fd*r*s - 528*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 528*C*D1**2*f**2*fd*s + 264*C*D1**2*f**2*fd - 198*C*D1**2*f**2*fdd*r**2 - 396*C*D1**2*f**2*fdd*r*s + 264*C*D1**2*f**2*fdd*r - 198*C*D1**2*f**2*fdd*s**2 + 264*C*D1**2*f**2*fdd*s - 132*C*D1**2*f**2*fdd - 396*C*D1**2*f*fd**2*r**2 - 792*C*D1**2*f*fd**2*r*s + 528*C*D1**2*f*fd**2*r - 396*C*D1**2*f*fd**2*s**2 + 528*C*D1**2*f*fd**2*s - 132*C*D1**2*f*fd**2 + 528*C*D1*Dd*f**3*r**2 + 1056*C*D1*Dd*f**3*r*s - 792*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 792*C*D1*Dd*f**3*s + 396*C*D1*Dd*f**3 - 1584*C*D1*Dd*f**2*fd*r**2 - 3168*C*D1*Dd*f**2*fd*r*s + 2244*C*D1*Dd*f**2*fd*r - 1584*C*D1*Dd*f**2*fd*s**2 + 2244*C*D1*Dd*f**2*fd*s - 792*C*D1*Dd*f**2*fd - 264*C*D1*Ddd*f**3*r**2 - 528*C*D1*Ddd*f**3*r*s + 396*C*D1*Ddd*f**3*r - 264*C*D1*Ddd*f**3*s**2 + 396*C*D1*Ddd*f**3*s - 198*C*D1*Ddd*f**3 - 792*C*Dd**2*f**3*r**2 - 1584*C*Dd**2*f**3*r*s + 1188*C*Dd**2*f**3*r - 792*C*Dd**2*f**3*s**2 + 1188*C*Dd**2*f**3*s - 396*C*Dd**2*f**3 + 396*D1**2*K*b1*f*fd*r**2 + 792*D1**2*K*b1*f*fd*r*s - 396*D1**2*K*b1*f*fd*r + 396*D1**2*K*b1*f*fd*s**2 - 396*D1**2*K*b1*f*fd*s + 198*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 396*D1**2*K*b1*f*fdd*r*s + 198*D1**2*K*b1*f*fdd*r - 198*D1**2*K*b1*f*fdd*s**2 + 198*D1**2*K*b1*f*fdd*s - 99*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 396*D1**2*K*b1*fd**2*r*s + 198*D1**2*K*b1*fd**2*r - 198*D1**2*K*b1*fd**2*s**2 + 198*D1**2*K*b1*fd**2*s - 396*D1**2*b1*f*fd*r**2 - 792*D1**2*b1*f*fd*r*s + 396*D1**2*b1*f*fd*r - 396*D1**2*b1*f*fd*s**2 + 396*D1**2*b1*f*fd*s - 198*D1**2*b1*f*fd + 198*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 198*D1**2*b1*f*fdd*s**2 - 198*D1**2*b1*f*fdd*s + 99*D1**2*b1*f*fdd + 198*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 198*D1**2*b1*fd**2*s**2 - 198*D1**2*b1*fd**2*s - 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 560*D1**2*f**3*fd*r**2 + 1120*D1**2*f**3*fd*r*s - 840*D1**2*f**3*fd*r + 560*D1**2*f**3*fd*s**2 - 840*D1**2*f**3*fd*s + 420*D1**2*f**3*fd - 280*D1**2*f**3*fdd*r**2 - 560*D1**2*f**3*fdd*r*s + 420*D1**2*f**3*fdd*r - 280*D1**2*f**3*fdd*s**2 + 420*D1**2*f**3*fdd*s - 210*D1**2*f**3*fdd - 840*D1**2*f**2*fd**2*r**2 - 1680*D1**2*f**2*fd**2*r*s + 1260*D1**2*f**2*fd**2*r - 840*D1**2*f**2*fd**2*s**2 + 1260*D1**2*f**2*fd**2*s - 420*D1**2*f**2*fd**2 - 396*D1**2*f**2*fd*r**2 - 792*D1**2*f**2*fd*r*s + 528*D1**2*f**2*fd*r - 396*D1**2*f**2*fd*s**2 + 528*D1**2*f**2*fd*s - 264*D1**2*f**2*fd + 198*D1**2*f**2*fdd*r**2 + 396*D1**2*f**2*fdd*r*s - 264*D1**2*f**2*fdd*r + 198*D1**2*f**2*fdd*s**2 - 264*D1**2*f**2*fdd*s + 132*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 396*D1**2*f**2*gd2*s**2 + 792*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 396*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 396*D1**2*f*fd**2*r**2 + 792*D1**2*f*fd**2*r*s - 528*D1**2*f*fd**2*r + 396*D1**2*f*fd**2*s**2 - 528*D1**2*f*fd**2*s + 132*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 792*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1584*D1**2*f*fd*gd2*r*s - 1188*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1188*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 792*D1*Dd*K*b1*f**2*r**2 + 1584*D1*Dd*K*b1*f**2*r*s - 1188*D1*Dd*K*b1*f**2*r + 792*D1*Dd*K*b1*f**2*s**2 - 1188*D1*Dd*K*b1*f**2*s + 594*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 3168*D1*Dd*K*b1*f*fd*r*s + 1980*D1*Dd*K*b1*f*fd*r - 1584*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 594*D1*Dd*K*b1*f*fd - 792*D1*Dd*b1*f**2*r**2 - 1584*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 792*D1*Dd*b1*f**2*s**2 + 1188*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r + 1584*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s + 594*D1*Dd*b1*f*fd + 560*D1*Dd*f**4*r**2 + 1120*D1*Dd*f**4*r*s - 840*D1*Dd*f**4*r + 560*D1*Dd*f**4*s**2 - 840*D1*Dd*f**4*s + 420*D1*Dd*f**4 - 2240*D1*Dd*f**3*fd*r**2 - 4480*D1*Dd*f**3*fd*r*s + 3360*D1*Dd*f**3*fd*r - 2240*D1*Dd*f**3*fd*s**2 + 3360*D1*Dd*f**3*fd*s - 1260*D1*Dd*f**3*fd - 528*D1*Dd*f**3*r**2 - 1056*D1*Dd*f**3*r*s + 792*D1*Dd*f**3*r - 528*D1*Dd*f**3*s**2 + 792*D1*Dd*f**3*s - 396*D1*Dd*f**3 + 1584*D1*Dd*f**2*fd*r**2 + 3168*D1*Dd*f**2*fd*r*s - 2244*D1*Dd*f**2*fd*r + 1584*D1*Dd*f**2*fd*s**2 - 2244*D1*Dd*f**2*fd*s + 792*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 2376*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 3168*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 1188*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 6336*D1*Dd*f*fd*g2*r*s - 3960*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 1188*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 792*D1*Ddd*K*b1*f**2*r*s + 594*D1*Ddd*K*b1*f**2*r - 396*D1*Ddd*K*b1*f**2*s**2 + 594*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 396*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 396*D1*Ddd*b1*f**2*s**2 - 594*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 - 280*D1*Ddd*f**4*r**2 - 560*D1*Ddd*f**4*r*s + 420*D1*Ddd*f**4*r - 280*D1*Ddd*f**4*s**2 + 420*D1*Ddd*f**4*s - 210*D1*Ddd*f**4 + 264*D1*Ddd*f**3*r**2 + 528*D1*Ddd*f**3*r*s - 396*D1*Ddd*f**3*r + 264*D1*Ddd*f**3*s**2 - 396*D1*Ddd*f**3*s + 198*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1584*D1*Ddd*f**2*g2*r*s - 1188*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1188*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1188*Dd**2*K*b1*f**2*r**2 - 2376*Dd**2*K*b1*f**2*r*s + 1782*Dd**2*K*b1*f**2*r - 1188*Dd**2*K*b1*f**2*s**2 + 1782*Dd**2*K*b1*f**2*s - 594*Dd**2*K*b1*f**2 + 1188*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 1188*Dd**2*b1*f**2*s**2 - 1782*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 - 840*Dd**2*f**4*r**2 - 1680*Dd**2*f**4*r*s + 1260*Dd**2*f**4*r - 840*Dd**2*f**4*s**2 + 1260*Dd**2*f**4*s - 420*Dd**2*f**4 + 792*Dd**2*f**3*r**2 + 1584*Dd**2*f**3*r*s - 1188*Dd**2*f**3*r + 792*Dd**2*f**3*s**2 - 1188*Dd**2*f**3*s + 396*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 4752*Dd**2*f**2*g2*r*s - 3564*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3564*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2)/(154*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**4*k1**2*k2**4*st**2*(-108*C*D1**2*bdd1*f**2*r**2 - 216*C*D1**2*bdd1*f**2*r*s + 216*C*D1**2*bdd1*f**2*r - 108*C*D1**2*bdd1*f**2*s**2 + 216*C*D1**2*bdd1*f**2*s - 108*C*D1**2*bdd1*f**2 + 3180*C*D1**2*f**2*fd*r**2 + 6360*C*D1**2*f**2*fd*r*s - 4240*C*D1**2*f**2*fd*r + 3180*C*D1**2*f**2*fd*s**2 - 4240*C*D1**2*f**2*fd*s + 2120*C*D1**2*f**2*fd - 2400*C*D1**2*f**2*fdd*r**2 - 4800*C*D1**2*f**2*fdd*r*s + 3200*C*D1**2*f**2*fdd*r - 2400*C*D1**2*f**2*fdd*s**2 + 3200*C*D1**2*f**2*fdd*s - 1600*C*D1**2*f**2*fdd - 4800*C*D1**2*f*fd**2*r**2 - 9600*C*D1**2*f*fd**2*r*s + 6400*C*D1**2*f*fd**2*r - 4800*C*D1**2*f*fd**2*s**2 + 6400*C*D1**2*f*fd**2*s - 1600*C*D1**2*f*fd**2 + 4240*C*D1*Dd*f**3*r**2 + 8480*C*D1*Dd*f**3*r*s - 6360*C*D1*Dd*f**3*r + 4240*C*D1*Dd*f**3*s**2 - 6360*C*D1*Dd*f**3*s + 3180*C*D1*Dd*f**3 - 19200*C*D1*Dd*f**2*fd*r**2 - 38400*C*D1*Dd*f**2*fd*r*s + 27200*C*D1*Dd*f**2*fd*r - 19200*C*D1*Dd*f**2*fd*s**2 + 27200*C*D1*Dd*f**2*fd*s - 9600*C*D1*Dd*f**2*fd - 3200*C*D1*Ddd*f**3*r**2 - 6400*C*D1*Ddd*f**3*r*s + 4800*C*D1*Ddd*f**3*r - 3200*C*D1*Ddd*f**3*s**2 + 4800*C*D1*Ddd*f**3*s - 2400*C*D1*Ddd*f**3 - 9600*C*Dd**2*f**3*r**2 - 19200*C*Dd**2*f**3*r*s + 14400*C*Dd**2*f**3*r - 9600*C*Dd**2*f**3*s**2 + 14400*C*Dd**2*f**3*s - 4800*C*Dd**2*f**3 - 720*D1**2*K*bdd1*f**2*r**2 - 1440*D1**2*K*bdd1*f**2*r*s + 1440*D1**2*K*bdd1*f**2*r - 720*D1**2*K*bdd1*f**2*s**2 + 1440*D1**2*K*bdd1*f**2*s - 720*D1**2*K*bdd1*f**2 - 252*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 300*D1**2*bdd1*f**3*r**2 + 600*D1**2*bdd1*f**3*r*s - 600*D1**2*bdd1*f**3*r + 300*D1**2*bdd1*f**3*s**2 - 600*D1**2*bdd1*f**3*s + 300*D1**2*bdd1*f**3 + 468*D1**2*bdd1*f**2*r**2 + 936*D1**2*bdd1*f**2*r*s - 936*D1**2*bdd1*f**2*r + 468*D1**2*bdd1*f**2*s**2 - 936*D1**2*bdd1*f**2*s + 468*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s - 504*D1**2*bdd1*f*g2*r + 252*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 - 300*D1**2*f**3*fd*r**2 - 600*D1**2*f**3*fd*r*s + 450*D1**2*f**3*fd*r - 300*D1**2*f**3*fd*s**2 + 450*D1**2*f**3*fd*s - 225*D1**2*f**3*fd - 2304*D1**2*f**2*fd*r**2 - 4608*D1**2*f**2*fd*r*s + 3072*D1**2*f**2*fd*r - 2304*D1**2*f**2*fd*s**2 + 3072*D1**2*f**2*fd*s - 1536*D1**2*f**2*fd + 1800*D1**2*f**2*fdd*r**2 + 3600*D1**2*f**2*fdd*r*s - 2400*D1**2*f**2*fdd*r + 1800*D1**2*f**2*fdd*s**2 - 2400*D1**2*f**2*fdd*s + 1200*D1**2*f**2*fdd - 1620*D1**2*f**2*gd2*r**2 - 3240*D1**2*f**2*gd2*r*s + 3240*D1**2*f**2*gd2*r - 1620*D1**2*f**2*gd2*s**2 + 3240*D1**2*f**2*gd2*s - 1620*D1**2*f**2*gd2 + 1440*D1**2*f**2*gdd2*r**2 + 2880*D1**2*f**2*gdd2*r*s - 2880*D1**2*f**2*gdd2*r + 1440*D1**2*f**2*gdd2*s**2 - 2880*D1**2*f**2*gdd2*s + 1440*D1**2*f**2*gdd2 + 3600*D1**2*f*fd**2*r**2 + 7200*D1**2*f*fd**2*r*s - 4800*D1**2*f*fd**2*r + 3600*D1**2*f*fd**2*s**2 - 4800*D1**2*f*fd**2*s + 1200*D1**2*f*fd**2 - 3240*D1**2*f*fd*g2*r**2 - 6480*D1**2*f*fd*g2*r*s + 3240*D1**2*f*fd*g2*r - 3240*D1**2*f*fd*g2*s**2 + 3240*D1**2*f*fd*g2*s - 1620*D1**2*f*fd*g2 + 5760*D1**2*f*fd*gd2*r**2 + 11520*D1**2*f*fd*gd2*r*s - 8640*D1**2*f*fd*gd2*r + 5760*D1**2*f*fd*gd2*s**2 - 8640*D1**2*f*fd*gd2*s + 2880*D1**2*f*fd*gd2 + 2880*D1**2*f*fdd*g2*r**2 + 5760*D1**2*f*fdd*g2*r*s - 2880*D1**2*f*fdd*g2*r + 2880*D1**2*f*fdd*g2*s**2 - 2880*D1**2*f*fdd*g2*s + 1440*D1**2*f*fdd*g2 + 2880*D1**2*fd**2*g2*r**2 + 5760*D1**2*fd**2*g2*r*s - 2880*D1**2*fd**2*g2*r + 2880*D1**2*fd**2*g2*s**2 - 2880*D1**2*fd**2*g2*s - 300*D1*Dd*f**4*r**2 - 600*D1*Dd*f**4*r*s + 450*D1*Dd*f**4*r - 300*D1*Dd*f**4*s**2 + 450*D1*Dd*f**4*s - 225*D1*Dd*f**4 - 3072*D1*Dd*f**3*r**2 - 6144*D1*Dd*f**3*r*s + 4608*D1*Dd*f**3*r - 3072*D1*Dd*f**3*s**2 + 4608*D1*Dd*f**3*s - 2304*D1*Dd*f**3 + 14400*D1*Dd*f**2*fd*r**2 + 28800*D1*Dd*f**2*fd*r*s - 20400*D1*Dd*f**2*fd*r + 14400*D1*Dd*f**2*fd*s**2 - 20400*D1*Dd*f**2*fd*s + 7200*D1*Dd*f**2*fd - 6480*D1*Dd*f**2*g2*r**2 - 12960*D1*Dd*f**2*g2*r*s + 9720*D1*Dd*f**2*g2*r - 6480*D1*Dd*f**2*g2*s**2 + 9720*D1*Dd*f**2*g2*s - 4860*D1*Dd*f**2*g2 + 11520*D1*Dd*f**2*gd2*r**2 + 23040*D1*Dd*f**2*gd2*r*s - 20160*D1*Dd*f**2*gd2*r + 11520*D1*Dd*f**2*gd2*s**2 - 20160*D1*Dd*f**2*gd2*s + 8640*D1*Dd*f**2*gd2 + 23040*D1*Dd*f*fd*g2*r**2 + 46080*D1*Dd*f*fd*g2*r*s - 28800*D1*Dd*f*fd*g2*r + 23040*D1*Dd*f*fd*g2*s**2 - 28800*D1*Dd*f*fd*g2*s + 8640*D1*Dd*f*fd*g2 + 2400*D1*Ddd*f**3*r**2 + 4800*D1*Ddd*f**3*r*s - 3600*D1*Ddd*f**3*r + 2400*D1*Ddd*f**3*s**2 - 3600*D1*Ddd*f**3*s + 1800*D1*Ddd*f**3 + 5760*D1*Ddd*f**2*g2*r**2 + 11520*D1*Ddd*f**2*g2*r*s - 8640*D1*Ddd*f**2*g2*r + 5760*D1*Ddd*f**2*g2*s**2 - 8640*D1*Ddd*f**2*g2*s + 4320*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(70*f**3*(r + s - 1) - f**2*(36*C*(r + s - 1) + 100*fd*(3*r + 3*s - 2) + (135*K - 93)*(r + s - 1)) + 12*f*(fd*(3*C + 20*K - 13)*(2*r + 2*s - 1) + (7*g2 - 7*gd2)*(r + s - 1)) - 84*fd*g2*(r + s)) - 4*Dd*f*(25*f**2 + f*(-9*C - 60*K + 39) + 21*g2)*(4*r + 4*s - 3))*(r + s - 1) + 7200*Dd**2*f**3*r**2 + 14400*Dd**2*f**3*r*s - 10800*Dd**2*f**3*r + 7200*Dd**2*f**3*s**2 - 10800*Dd**2*f**3*s + 3600*Dd**2*f**3 + 17280*Dd**2*f**2*g2*r**2 + 34560*Dd**2*f**2*g2*r*s - 25920*Dd**2*f**2*g2*r + 17280*Dd**2*f**2*g2*s**2 - 25920*Dd**2*f**2*g2*s + 8640*Dd**2*f**2*g2 + 126*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*b1*(72*C*D1**2*f*fd*r**2 + 144*C*D1**2*f*fd*r*s - 72*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s**2 - 72*C*D1**2*f*fd*s + 36*C*D1**2*f*fd - 36*C*D1**2*f*fdd*r**2 - 72*C*D1**2*f*fdd*r*s + 36*C*D1**2*f*fdd*r - 36*C*D1**2*f*fdd*s**2 + 36*C*D1**2*f*fdd*s - 18*C*D1**2*f*fdd - 36*C*D1**2*fd**2*r**2 - 72*C*D1**2*fd**2*r*s + 36*C*D1**2*fd**2*r - 36*C*D1**2*fd**2*s**2 + 36*C*D1**2*fd**2*s + 144*C*D1*Dd*f**2*r**2 + 288*C*D1*Dd*f**2*r*s - 216*C*D1*Dd*f**2*r + 144*C*D1*Dd*f**2*s**2 - 216*C*D1*Dd*f**2*s + 108*C*D1*Dd*f**2 - 288*C*D1*Dd*f*fd*r**2 - 576*C*D1*Dd*f*fd*r*s + 360*C*D1*Dd*f*fd*r - 288*C*D1*Dd*f*fd*s**2 + 360*C*D1*Dd*f*fd*s - 108*C*D1*Dd*f*fd - 72*C*D1*Ddd*f**2*r**2 - 144*C*D1*Ddd*f**2*r*s + 108*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 108*C*D1*Ddd*f**2*s - 54*C*D1*Ddd*f**2 - 216*C*Dd**2*f**2*r**2 - 432*C*Dd**2*f**2*r*s + 324*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 324*C*Dd**2*f**2*s - 108*C*Dd**2*f**2 + 270*D1**2*K*f*fd*r**2 + 540*D1**2*K*f*fd*r*s - 270*D1**2*K*f*fd*r + 270*D1**2*K*f*fd*s**2 - 270*D1**2*K*f*fd*s + 135*D1**2*K*f*fd - 240*D1**2*K*f*fdd*r**2 - 480*D1**2*K*f*fdd*r*s + 240*D1**2*K*f*fdd*r - 240*D1**2*K*f*fdd*s**2 + 240*D1**2*K*f*fdd*s - 120*D1**2*K*f*fdd - 240*D1**2*K*fd**2*r**2 - 480*D1**2*K*fd**2*r*s + 240*D1**2*K*fd**2*r - 240*D1**2*K*fd**2*s**2 + 240*D1**2*K*fd**2*s - 42*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 210*D1**2*f**2*fd*r**2 - 420*D1**2*f**2*fd*r*s + 280*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 280*D1**2*f**2*fd*s - 140*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 186*D1**2*f*fd*r**2 - 372*D1**2*f*fd*r*s + 186*D1**2*f*fd*r - 186*D1**2*f*fd*s**2 + 186*D1**2*f*fd*s - 93*D1**2*f*fd + 156*D1**2*f*fdd*r**2 + 312*D1**2*f*fdd*r*s - 156*D1**2*f*fdd*r + 156*D1**2*f*fdd*s**2 - 156*D1**2*f*fdd*s + 78*D1**2*f*fdd - 84*D1**2*f*gd2*r**2 - 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*r - 84*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s - 84*D1**2*f*gd2 + 42*D1**2*f*gdd2*r**2 + 84*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*r + 42*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 42*D1**2*f*gdd2 + 156*D1**2*fd**2*r**2 + 312*D1**2*fd**2*r*s - 156*D1**2*fd**2*r + 156*D1**2*fd**2*s**2 - 156*D1**2*fd**2*s - 84*D1**2*fd*g2*r**2 - 168*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*s**2 + 84*D1**2*fd*gd2*r**2 + 168*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*r + 84*D1**2*fd*gd2*s**2 - 84*D1**2*fd*gd2*s + 42*D1**2*fdd*g2*r**2 + 84*D1**2*fdd*g2*r*s + 42*D1**2*fdd*g2*s**2 + 540*D1*Dd*K*f**2*r**2 + 1080*D1*Dd*K*f**2*r*s - 810*D1*Dd*K*f**2*r + 540*D1*Dd*K*f**2*s**2 - 810*D1*Dd*K*f**2*s + 405*D1*Dd*K*f**2 - 1920*D1*Dd*K*f*fd*r**2 - 3840*D1*Dd*K*f*fd*r*s + 2400*D1*Dd*K*f*fd*r - 1920*D1*Dd*K*f*fd*s**2 + 2400*D1*Dd*K*f*fd*s - 720*D1*Dd*K*f*fd - 280*D1*Dd*f**3*r**2 - 560*D1*Dd*f**3*r*s + 420*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 420*D1*Dd*f**3*s - 210*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 1700*D1*Dd*f**2*fd*r + 1200*D1*Dd*f**2*fd*s**2 - 1700*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 372*D1*Dd*f**2*r**2 - 744*D1*Dd*f**2*r*s + 558*D1*Dd*f**2*r - 372*D1*Dd*f**2*s**2 + 558*D1*Dd*f**2*s - 279*D1*Dd*f**2 + 1248*D1*Dd*f*fd*r**2 + 2496*D1*Dd*f*fd*r*s - 1560*D1*Dd*f*fd*r + 1248*D1*Dd*f*fd*s**2 - 1560*D1*Dd*f*fd*s + 468*D1*Dd*f*fd - 336*D1*Dd*f*g2*r**2 - 672*D1*Dd*f*g2*r*s + 504*D1*Dd*f*g2*r - 336*D1*Dd*f*g2*s**2 + 504*D1*Dd*f*g2*s - 252*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 + 672*D1*Dd*f*gd2*r*s - 588*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s**2 - 588*D1*Dd*f*gd2*s + 252*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r**2 + 672*D1*Dd*fd*g2*r*s - 252*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s**2 - 252*D1*Dd*fd*g2*s - 480*D1*Ddd*K*f**2*r**2 - 960*D1*Ddd*K*f**2*r*s + 720*D1*Ddd*K*f**2*r - 480*D1*Ddd*K*f**2*s**2 + 720*D1*Ddd*K*f**2*s - 360*D1*Ddd*K*f**2 + 200*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 300*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 + 312*D1*Ddd*f**2*r**2 + 624*D1*Ddd*f**2*r*s - 468*D1*Ddd*f**2*r + 312*D1*Ddd*f**2*s**2 - 468*D1*Ddd*f**2*s + 234*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r*s - 252*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s**2 - 252*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 + 84*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 1440*Dd**2*K*f**2*r**2 - 2880*Dd**2*K*f**2*r*s + 2160*Dd**2*K*f**2*r - 1440*Dd**2*K*f**2*s**2 + 2160*Dd**2*K*f**2*s - 720*Dd**2*K*f**2 + 600*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 900*Dd**2*f**3*r + 600*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 300*Dd**2*f**3 + 936*Dd**2*f**2*r**2 + 1872*Dd**2*f**2*r*s - 1404*Dd**2*f**2*r + 936*Dd**2*f**2*s**2 - 1404*Dd**2*f**2*s + 468*Dd**2*f**2 + 504*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r*s - 756*Dd**2*f*g2*r + 504*Dd**2*f*g2*s**2 - 756*Dd**2*f*g2*s + 252*Dd**2*f*g2))/(70*d**2*k3**7) - 3*D1**2*Pk2*Pkd3*ct**4*k1**2*k2**4*(240*C*D1**2*bdd1*f**2*r**2 + 480*C*D1**2*bdd1*f**2*r*s - 480*C*D1**2*bdd1*f**2*r + 240*C*D1**2*bdd1*f**2*s**2 - 480*C*D1**2*bdd1*f**2*s + 240*C*D1**2*bdd1*f**2 - 30*C*D1**2*f**2*fd*r**2 - 60*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 420*C*D1**2*f**2*fdd*r**2 + 840*C*D1**2*f**2*fdd*r*s - 560*C*D1**2*f**2*fdd*r + 420*C*D1**2*f**2*fdd*s**2 - 560*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 840*C*D1**2*f*fd**2*r**2 + 1680*C*D1**2*f*fd**2*r*s - 1120*C*D1**2*f*fd**2*r + 840*C*D1**2*f*fd**2*s**2 - 1120*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 40*C*D1*Dd*f**3*r**2 - 80*C*D1*Dd*f**3*r*s + 60*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 60*C*D1*Dd*f**3*s - 30*C*D1*Dd*f**3 + 3360*C*D1*Dd*f**2*fd*r**2 + 6720*C*D1*Dd*f**2*fd*r*s - 4760*C*D1*Dd*f**2*fd*r + 3360*C*D1*Dd*f**2*fd*s**2 - 4760*C*D1*Dd*f**2*fd*s + 1680*C*D1*Dd*f**2*fd + 560*C*D1*Ddd*f**3*r**2 + 1120*C*D1*Ddd*f**3*r*s - 840*C*D1*Ddd*f**3*r + 560*C*D1*Ddd*f**3*s**2 - 840*C*D1*Ddd*f**3*s + 420*C*D1*Ddd*f**3 + 1680*C*Dd**2*f**3*r**2 + 3360*C*Dd**2*f**3*r*s - 2520*C*Dd**2*f**3*r + 1680*C*Dd**2*f**3*s**2 - 2520*C*Dd**2*f**3*s + 840*C*Dd**2*f**3 + 90*D1**2*K*bdd1*f**2*r**2 + 180*D1**2*K*bdd1*f**2*r*s - 180*D1**2*K*bdd1*f**2*r + 90*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s + 90*D1**2*K*bdd1*f**2 - 6*D1**2*bd1**2*f*(-56*K + 25*f + 28)*(r + s - 1)**2 - 180*D1**2*bdd1*f**2*r**2 - 360*D1**2*bdd1*f**2*r*s + 360*D1**2*bdd1*f**2*r - 180*D1**2*bdd1*f**2*s**2 + 360*D1**2*bdd1*f**2*s - 180*D1**2*bdd1*f**2 - 336*D1**2*bdd1*f*g2*r**2 - 672*D1**2*bdd1*f*g2*r*s + 672*D1**2*bdd1*f*g2*r - 336*D1**2*bdd1*f*g2*s**2 + 672*D1**2*bdd1*f*g2*s - 336*D1**2*bdd1*f*g2 - 75*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 280*D1**2*f**2*fdd*r - 210*D1**2*f**2*fdd*s**2 + 280*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 18*D1**2*f**2*gd2*r**2 - 36*D1**2*f**2*gd2*r*s + 36*D1**2*f**2*gd2*r - 18*D1**2*f**2*gd2*s**2 + 36*D1**2*f**2*gd2*s - 18*D1**2*f**2*gd2 - 180*D1**2*f**2*gdd2*r**2 - 360*D1**2*f**2*gdd2*r*s + 360*D1**2*f**2*gdd2*r - 180*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s - 180*D1**2*f**2*gdd2 - 420*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 560*D1**2*f*fd**2*r - 420*D1**2*f*fd**2*s**2 + 560*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 36*D1**2*f*fd*g2*r**2 - 72*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r - 36*D1**2*f*fd*g2*s**2 + 36*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*r**2 - 1440*D1**2*f*fd*gd2*r*s + 1080*D1**2*f*fd*gd2*r - 720*D1**2*f*fd*gd2*s**2 + 1080*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 360*D1**2*f*fdd*g2*r**2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r - 360*D1**2*f*fdd*g2*s**2 + 360*D1**2*f*fdd*g2*s - 180*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*r**2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r - 360*D1**2*fd**2*g2*s**2 + 360*D1**2*fd**2*g2*s - 100*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 75*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2380*D1*Dd*f**2*fd*r - 1680*D1*Dd*f**2*fd*s**2 + 2380*D1*Dd*f**2*fd*s - 840*D1*Dd*f**2*fd - 72*D1*Dd*f**2*g2*r**2 - 144*D1*Dd*f**2*g2*r*s + 108*D1*Dd*f**2*g2*r - 72*D1*Dd*f**2*g2*s**2 + 108*D1*Dd*f**2*g2*s - 54*D1*Dd*f**2*g2 - 1440*D1*Dd*f**2*gd2*r**2 - 2880*D1*Dd*f**2*gd2*r*s + 2520*D1*Dd*f**2*gd2*r - 1440*D1*Dd*f**2*gd2*s**2 + 2520*D1*Dd*f**2*gd2*s - 1080*D1*Dd*f**2*gd2 - 2880*D1*Dd*f*fd*g2*r**2 - 5760*D1*Dd*f*fd*g2*r*s + 3600*D1*Dd*f*fd*g2*r - 2880*D1*Dd*f*fd*g2*s**2 + 3600*D1*Dd*f*fd*g2*s - 1080*D1*Dd*f*fd*g2 - 280*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s**2 + 420*D1*Ddd*f**3*s - 210*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*r**2 - 1440*D1*Ddd*f**2*g2*r*s + 1080*D1*Ddd*f**2*g2*r - 720*D1*Ddd*f**2*g2*s**2 + 1080*D1*Ddd*f**2*g2*s - 540*D1*Ddd*f**2*g2 - D1*bd1*(D1*(30*f**3*(r + s - 1) + 3*f**2*(90*C - 3*K - 50)*(r + s - 1) - 2*f*(30*fd*(8*C + 3*K - 6)*(2*r + 2*s - 1) + (161*g2 - 336*gd2)*(r + s - 1)) + 672*fd*g2*(r + s)) - 12*Dd*f*(5*f*(8*C + 3*K - 6) - 56*g2)*(4*r + 4*s - 3))*(r + s - 1) - 840*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 840*Dd**2*f**3*s**2 + 1260*Dd**2*f**3*s - 420*Dd**2*f**3 - 2160*Dd**2*f**2*g2*r**2 - 4320*Dd**2*f**2*g2*r*s + 3240*Dd**2*f**2*g2*r - 2160*Dd**2*f**2*g2*s**2 + 3240*Dd**2*f**2*g2*s - 1080*Dd**2*f**2*g2 + b1**2*(D1**2*(3*f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 7*fd*(23*K - 9)*(r + s) - 84*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(108*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(150*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (161*K - 63)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 168*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-56*K + 25*f + 28)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-56*K + 25*f + 28)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-540*C*D1**2*f*fd*r**2 - 1080*C*D1**2*f*fd*r*s + 540*C*D1**2*f*fd*r - 540*C*D1**2*f*fd*s**2 + 540*C*D1**2*f*fd*s - 270*C*D1**2*f*fd + 480*C*D1**2*f*fdd*r**2 + 960*C*D1**2*f*fdd*r*s - 480*C*D1**2*f*fdd*r + 480*C*D1**2*f*fdd*s**2 - 480*C*D1**2*f*fdd*s + 240*C*D1**2*f*fdd + 480*C*D1**2*fd**2*r**2 + 960*C*D1**2*fd**2*r*s - 480*C*D1**2*fd**2*r + 480*C*D1**2*fd**2*s**2 - 480*C*D1**2*fd**2*s - 1080*C*D1*Dd*f**2*r**2 - 2160*C*D1*Dd*f**2*r*s + 1620*C*D1*Dd*f**2*r - 1080*C*D1*Dd*f**2*s**2 + 1620*C*D1*Dd*f**2*s - 810*C*D1*Dd*f**2 + 3840*C*D1*Dd*f*fd*r**2 + 7680*C*D1*Dd*f*fd*r*s - 4800*C*D1*Dd*f*fd*r + 3840*C*D1*Dd*f*fd*s**2 - 4800*C*D1*Dd*f*fd*s + 1440*C*D1*Dd*f*fd + 960*C*D1*Ddd*f**2*r**2 + 1920*C*D1*Ddd*f**2*r*s - 1440*C*D1*Ddd*f**2*r + 960*C*D1*Ddd*f**2*s**2 - 1440*C*D1*Ddd*f**2*s + 720*C*D1*Ddd*f**2 + 2880*C*Dd**2*f**2*r**2 + 5760*C*Dd**2*f**2*r*s - 4320*C*Dd**2*f**2*r + 2880*C*Dd**2*f**2*s**2 - 4320*C*Dd**2*f**2*s + 1440*C*Dd**2*f**2 + 18*D1**2*K*f*fd*r**2 + 36*D1**2*K*f*fd*r*s - 18*D1**2*K*f*fd*r + 18*D1**2*K*f*fd*s**2 - 18*D1**2*K*f*fd*s + 9*D1**2*K*f*fd + 180*D1**2*K*f*fdd*r**2 + 360*D1**2*K*f*fdd*r*s - 180*D1**2*K*f*fdd*r + 180*D1**2*K*f*fdd*s**2 - 180*D1**2*K*f*fdd*s + 90*D1**2*K*f*fdd + 180*D1**2*K*fd**2*r**2 + 360*D1**2*K*fd**2*r*s - 180*D1**2*K*fd**2*r + 180*D1**2*K*fd**2*s**2 - 180*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-56*K + 25*f + 28)*(r + s - 1)**2 - 90*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 300*D1**2*f*fd*r**2 + 600*D1**2*f*fd*r*s - 300*D1**2*f*fd*r + 300*D1**2*f*fd*s**2 - 300*D1**2*f*fd*s + 150*D1**2*f*fd - 360*D1**2*f*fdd*r**2 - 720*D1**2*f*fdd*r*s + 360*D1**2*f*fdd*r - 360*D1**2*f*fdd*s**2 + 360*D1**2*f*fdd*s - 180*D1**2*f*fdd + 322*D1**2*f*gd2*r**2 + 644*D1**2*f*gd2*r*s - 644*D1**2*f*gd2*r + 322*D1**2*f*gd2*s**2 - 644*D1**2*f*gd2*s + 322*D1**2*f*gd2 - 336*D1**2*f*gdd2*r**2 - 672*D1**2*f*gdd2*r*s + 672*D1**2*f*gdd2*r - 336*D1**2*f*gdd2*s**2 + 672*D1**2*f*gdd2*s - 336*D1**2*f*gdd2 - 360*D1**2*fd**2*r**2 - 720*D1**2*fd**2*r*s + 360*D1**2*fd**2*r - 360*D1**2*fd**2*s**2 + 360*D1**2*fd**2*s + 322*D1**2*fd*g2*r**2 + 644*D1**2*fd*g2*r*s + 322*D1**2*fd*g2*s**2 - 672*D1**2*fd*gd2*r**2 - 1344*D1**2*fd*gd2*r*s + 672*D1**2*fd*gd2*r - 672*D1**2*fd*gd2*s**2 + 672*D1**2*fd*gd2*s - 336*D1**2*fdd*g2*r**2 - 672*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*s**2 + 36*D1*Dd*K*f**2*r**2 + 72*D1*Dd*K*f**2*r*s - 54*D1*Dd*K*f**2*r + 36*D1*Dd*K*f**2*s**2 - 54*D1*Dd*K*f**2*s + 27*D1*Dd*K*f**2 + 1440*D1*Dd*K*f*fd*r**2 + 2880*D1*Dd*K*f*fd*r*s - 1800*D1*Dd*K*f*fd*r + 1440*D1*Dd*K*f*fd*s**2 - 1800*D1*Dd*K*f*fd*s + 540*D1*Dd*K*f*fd - 120*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 180*D1*Dd*f**3*s - 90*D1*Dd*f**3 + 600*D1*Dd*f**2*r**2 + 1200*D1*Dd*f**2*r*s - 900*D1*Dd*f**2*r + 600*D1*Dd*f**2*s**2 - 900*D1*Dd*f**2*s + 450*D1*Dd*f**2 - 2880*D1*Dd*f*fd*r**2 - 5760*D1*Dd*f*fd*r*s + 3600*D1*Dd*f*fd*r - 2880*D1*Dd*f*fd*s**2 + 3600*D1*Dd*f*fd*s - 1080*D1*Dd*f*fd + 1288*D1*Dd*f*g2*r**2 + 2576*D1*Dd*f*g2*r*s - 1932*D1*Dd*f*g2*r + 1288*D1*Dd*f*g2*s**2 - 1932*D1*Dd*f*g2*s + 966*D1*Dd*f*g2 - 2688*D1*Dd*f*gd2*r**2 - 5376*D1*Dd*f*gd2*r*s + 4704*D1*Dd*f*gd2*r - 2688*D1*Dd*f*gd2*s**2 + 4704*D1*Dd*f*gd2*s - 2016*D1*Dd*f*gd2 - 2688*D1*Dd*fd*g2*r**2 - 5376*D1*Dd*fd*g2*r*s + 2016*D1*Dd*fd*g2*r - 2688*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s + 360*D1*Ddd*K*f**2*r**2 + 720*D1*Ddd*K*f**2*r*s - 540*D1*Ddd*K*f**2*r + 360*D1*Ddd*K*f**2*s**2 - 540*D1*Ddd*K*f**2*s + 270*D1*Ddd*K*f**2 - 720*D1*Ddd*f**2*r**2 - 1440*D1*Ddd*f**2*r*s + 1080*D1*Ddd*f**2*r - 720*D1*Ddd*f**2*s**2 + 1080*D1*Ddd*f**2*s - 540*D1*Ddd*f**2 - 1344*D1*Ddd*f*g2*r**2 - 2688*D1*Ddd*f*g2*r*s + 2016*D1*Ddd*f*g2*r - 1344*D1*Ddd*f*g2*s**2 + 2016*D1*Ddd*f*g2*s - 1008*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(108*f**2*(r + s - 1) - 150*f*fd*(2*r + 2*s - 1) - 7*f*(23*K - 9)*(r + s - 1) + 168*fd*(2*K - 1)*(r + s)) - 6*Dd*f*(-56*K + 25*f + 28)*(4*r + 4*s - 3))*(r + s - 1) + 1080*Dd**2*K*f**2*r**2 + 2160*Dd**2*K*f**2*r*s - 1620*Dd**2*K*f**2*r + 1080*Dd**2*K*f**2*s**2 - 1620*Dd**2*K*f**2*s + 540*Dd**2*K*f**2 - 2160*Dd**2*f**2*r**2 - 4320*Dd**2*f**2*r*s + 3240*Dd**2*f**2*r - 2160*Dd**2*f**2*s**2 + 3240*Dd**2*f**2*s - 1080*Dd**2*f**2 - 4032*Dd**2*f*g2*r**2 - 8064*Dd**2*f*g2*r*s + 6048*Dd**2*f*g2*r - 4032*Dd**2*f*g2*s**2 + 6048*Dd**2*f*g2*s - 2016*Dd**2*f*g2))/(70*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**4*k1**2*k2**2*st**4*(396*C*D1**2*f**2*fd*r*s - 132*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 396*C*D1**2*f**2*fd*s + 132*C*D1**2*f**2*fd - 198*C*D1**2*f**2*fdd*r*s + 66*C*D1**2*f**2*fdd*r - 198*C*D1**2*f**2*fdd*s**2 + 198*C*D1**2*f**2*fdd*s - 66*C*D1**2*f**2*fdd - 396*C*D1**2*f*fd**2*r*s + 132*C*D1**2*f*fd**2*r - 396*C*D1**2*f*fd**2*s**2 + 396*C*D1**2*f*fd**2*s - 66*C*D1**2*f*fd**2 + 528*C*D1*Dd*f**3*r*s - 132*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 528*C*D1*Dd*f**3*s + 132*C*D1*Dd*f**3 - 1584*C*D1*Dd*f**2*fd*r*s + 462*C*D1*Dd*f**2*fd*r - 1584*C*D1*Dd*f**2*fd*s**2 + 1584*C*D1*Dd*f**2*fd*s - 330*C*D1*Dd*f**2*fd - 264*C*D1*Ddd*f**3*r*s + 66*C*D1*Ddd*f**3*r - 264*C*D1*Ddd*f**3*s**2 + 264*C*D1*Ddd*f**3*s - 66*C*D1*Ddd*f**3 - 792*C*Dd**2*f**3*r*s + 198*C*Dd**2*f**3*r - 792*C*Dd**2*f**3*s**2 + 792*C*Dd**2*f**3*s - 132*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 560*D1**2*f**3*fd*r*s - 140*D1**2*f**3*fd*r + 560*D1**2*f**3*fd*s**2 - 560*D1**2*f**3*fd*s + 140*D1**2*f**3*fd - 280*D1**2*f**3*fdd*r*s + 70*D1**2*f**3*fdd*r - 280*D1**2*f**3*fdd*s**2 + 280*D1**2*f**3*fdd*s - 70*D1**2*f**3*fdd - 840*D1**2*f**2*fd**2*r*s + 210*D1**2*f**2*fd**2*r - 840*D1**2*f**2*fd**2*s**2 + 840*D1**2*f**2*fd**2*s - 140*D1**2*f**2*fd**2 - 396*D1**2*f**2*fd*r*s + 132*D1**2*f**2*fd*r - 396*D1**2*f**2*fd*s**2 + 396*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 198*D1**2*f**2*fdd*r*s - 66*D1**2*f**2*fdd*r + 198*D1**2*f**2*fdd*s**2 - 198*D1**2*f**2*fdd*s + 66*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 396*D1**2*f*fd**2*r*s - 132*D1**2*f*fd**2*r + 396*D1**2*f*fd**2*s**2 - 396*D1**2*f*fd**2*s + 66*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 560*D1*Dd*f**4*r*s - 140*D1*Dd*f**4*r + 560*D1*Dd*f**4*s**2 - 560*D1*Dd*f**4*s + 140*D1*Dd*f**4 - 2240*D1*Dd*f**3*fd*r*s + 560*D1*Dd*f**3*fd*r - 2240*D1*Dd*f**3*fd*s**2 + 2240*D1*Dd*f**3*fd*s - 420*D1*Dd*f**3*fd - 528*D1*Dd*f**3*r*s + 132*D1*Dd*f**3*r - 528*D1*Dd*f**3*s**2 + 528*D1*Dd*f**3*s - 132*D1*Dd*f**3 + 1584*D1*Dd*f**2*fd*r*s - 462*D1*Dd*f**2*fd*r + 1584*D1*Dd*f**2*fd*s**2 - 1584*D1*Dd*f**2*fd*s + 330*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 280*D1*Ddd*f**4*r*s + 70*D1*Ddd*f**4*r - 280*D1*Ddd*f**4*s**2 + 280*D1*Ddd*f**4*s - 70*D1*Ddd*f**4 + 264*D1*Ddd*f**3*r*s - 66*D1*Ddd*f**3*r + 264*D1*Ddd*f**3*s**2 - 264*D1*Ddd*f**3*s + 66*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 840*Dd**2*f**4*r*s + 210*Dd**2*f**4*r - 840*Dd**2*f**4*s**2 + 840*Dd**2*f**4*s - 140*Dd**2*f**4 + 792*Dd**2*f**3*r*s - 198*Dd**2*f**3*r + 792*Dd**2*f**3*s**2 - 792*Dd**2*f**3*s + 132*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(231*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**4*k1**2*k2**2*st**2*(-540*C*D1**2*bdd1*f**2*r**2 - 1512*C*D1**2*bdd1*f**2*r*s + 432*C*D1**2*bdd1*f**2*r - 972*C*D1**2*bdd1*f**2*s**2 + 864*C*D1**2*bdd1*f**2*s - 432*C*D1**2*bdd1*f**2 - 9036*C*D1**2*f**2*fd*r**2 - 3192*C*D1**2*f**2*fd*r*s + 7088*C*D1**2*f**2*fd*r + 5844*C*D1**2*f**2*fd*s**2 - 2832*C*D1**2*f**2*fd*s - 1064*C*D1**2*f**2*fd + 6948*C*D1**2*f**2*fdd*r**2 + 3864*C*D1**2*f**2*fdd*r*s - 5920*C*D1**2*f**2*fdd*r - 3084*C*D1**2*f**2*fdd*s**2 + 768*C*D1**2*f**2*fdd*s + 1288*C*D1**2*f**2*fdd + 13896*C*D1**2*f*fd**2*r**2 + 7728*C*D1**2*f*fd**2*r*s - 11840*C*D1**2*f*fd**2*r - 6168*C*D1**2*f*fd**2*s**2 + 1536*C*D1**2*f*fd**2*s + 1288*C*D1**2*f*fd**2 - 12048*C*D1*Dd*f**3*r**2 - 4256*C*D1*Dd*f**3*r*s + 13112*C*D1*Dd*f**3*r + 7792*C*D1*Dd*f**3*s**2 - 1768*C*D1*Dd*f**3*s - 4076*C*D1*Dd*f**3 + 55584*C*D1*Dd*f**2*fd*r**2 + 30912*C*D1*Dd*f**2*fd*r*s - 55336*C*D1*Dd*f**2*fd*r - 24672*C*D1*Dd*f**2*fd*s**2 + 1512*C*D1*Dd*f**2*fd*s + 11072*C*D1*Dd*f**2*fd + 9264*C*D1*Ddd*f**3*r**2 + 5152*C*D1*Ddd*f**3*r*s - 10552*C*D1*Ddd*f**3*r - 4112*C*D1*Ddd*f**3*s**2 - 520*C*D1*Ddd*f**3*s + 3604*C*D1*Ddd*f**3 + 27792*C*Dd**2*f**3*r**2 + 15456*C*Dd**2*f**3*r*s - 31656*C*Dd**2*f**3*r - 12336*C*Dd**2*f**3*s**2 - 1560*C*Dd**2*f**3*s + 7208*C*Dd**2*f**3 + 1710*D1**2*K*bdd1*f**2*r**2 + 1044*D1**2*K*bdd1*f**2*r*s - 3420*D1**2*K*bdd1*f**2*r - 666*D1**2*K*bdd1*f**2*s**2 - 1044*D1**2*K*bdd1*f**2*s + 1710*D1**2*K*bdd1*f**2 - 252*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2) - 1875*D1**2*bdd1*f**3*r**2 - 2850*D1**2*bdd1*f**3*r*s + 3300*D1**2*bdd1*f**3*r - 975*D1**2*bdd1*f**3*s**2 + 2400*D1**2*bdd1*f**3*s - 1800*D1**2*bdd1*f**3 - 2970*D1**2*bdd1*f**2*r**2 - 4212*D1**2*bdd1*f**2*r*s + 6588*D1**2*bdd1*f**2*r - 1242*D1**2*bdd1*f**2*s**2 + 4860*D1**2*bdd1*f**2*s - 3078*D1**2*bdd1*f**2 + 1260*D1**2*bdd1*f*g2*r**2 + 3528*D1**2*bdd1*f*g2*r*s - 1008*D1**2*bdd1*f*g2*r + 2268*D1**2*bdd1*f*g2*s**2 - 2016*D1**2*bdd1*f*g2*s + 1008*D1**2*bdd1*f*g2 - 6300*D1**2*f**3*fd*r**2 - 12000*D1**2*f**3*fd*r*s + 9300*D1**2*f**3*fd*r - 5700*D1**2*f**3*fd*s**2 + 8850*D1**2*f**3*fd*s - 4575*D1**2*f**3*fd + 6900*D1**2*f**3*fdd*r**2 + 10800*D1**2*f**3*fdd*r*s - 9600*D1**2*f**3*fdd*r + 3900*D1**2*f**3*fdd*s**2 - 7350*D1**2*f**3*fdd*s + 4425*D1**2*f**3*fdd + 20700*D1**2*f**2*fd**2*r**2 + 32400*D1**2*f**2*fd**2*r*s - 28800*D1**2*f**2*fd**2*r + 11700*D1**2*f**2*fd**2*s**2 - 22050*D1**2*f**2*fd**2*s + 8850*D1**2*f**2*fd**2 + 13416*D1**2*f**2*fd*r**2 + 14904*D1**2*f**2*fd*r*s - 13912*D1**2*f**2*fd*r + 1488*D1**2*f**2*fd*s**2 - 5960*D1**2*f**2*fd*s + 4968*D1**2*f**2*fd - 9948*D1**2*f**2*fdd*r**2 - 11664*D1**2*f**2*fdd*r*s + 10520*D1**2*f**2*fdd*r - 1716*D1**2*f**2*fdd*s**2 + 5032*D1**2*f**2*fdd*s - 3888*D1**2*f**2*fdd + 4068*D1**2*f**2*gd2*r**2 + 1656*D1**2*f**2*gd2*r*s - 8136*D1**2*f**2*gd2*r - 2412*D1**2*f**2*gd2*s**2 - 1656*D1**2*f**2*gd2*s + 4068*D1**2*f**2*gd2 - 3420*D1**2*f**2*gdd2*r**2 - 2088*D1**2*f**2*gdd2*r*s + 6840*D1**2*f**2*gdd2*r + 1332*D1**2*f**2*gdd2*s**2 + 2088*D1**2*f**2*gdd2*s - 3420*D1**2*f**2*gdd2 - 19896*D1**2*f*fd**2*r**2 - 23328*D1**2*f*fd**2*r*s + 21040*D1**2*f*fd**2*r - 3432*D1**2*f*fd**2*s**2 + 10064*D1**2*f*fd**2*s - 3888*D1**2*f*fd**2 + 8136*D1**2*f*fd*g2*r**2 + 3312*D1**2*f*fd*g2*r*s - 1656*D1**2*f*fd*g2*r - 4824*D1**2*f*fd*g2*s**2 + 4824*D1**2*f*fd*g2*s - 2412*D1**2*f*fd*g2 - 13680*D1**2*f*fd*gd2*r**2 - 8352*D1**2*f*fd*gd2*r*s + 15768*D1**2*f*fd*gd2*r + 5328*D1**2*f*fd*gd2*s**2 + 1512*D1**2*f*fd*gd2*s - 2088*D1**2*f*fd*gd2 - 6840*D1**2*f*fdd*g2*r**2 - 4176*D1**2*f*fdd*g2*r*s + 2088*D1**2*f*fdd*g2*r + 2664*D1**2*f*fdd*g2*s**2 - 2664*D1**2*f*fdd*g2*s + 1332*D1**2*f*fdd*g2 - 6840*D1**2*fd**2*g2*r**2 - 4176*D1**2*fd**2*g2*r*s + 2088*D1**2*fd**2*g2*r + 2664*D1**2*fd**2*g2*s**2 - 2664*D1**2*fd**2*g2*s - 6300*D1*Dd*f**4*r**2 - 12000*D1*Dd*f**4*r*s + 9300*D1*Dd*f**4*r - 5700*D1*Dd*f**4*s**2 + 8850*D1*Dd*f**4*s - 4575*D1*Dd*f**4 + 55200*D1*Dd*f**3*fd*r**2 + 86400*D1*Dd*f**3*fd*r*s - 76800*D1*Dd*f**3*fd*r + 31200*D1*Dd*f**3*fd*s**2 - 58800*D1*Dd*f**3*fd*s + 26550*D1*Dd*f**3*fd + 17888*D1*Dd*f**3*r**2 + 19872*D1*Dd*f**3*r*s - 22856*D1*Dd*f**3*r + 1984*D1*Dd*f**3*s**2 - 10928*D1*Dd*f**3*s + 9440*D1*Dd*f**3 - 79584*D1*Dd*f**2*fd*r**2 - 93312*D1*Dd*f**2*fd*r*s + 93536*D1*Dd*f**2*fd*r - 13728*D1*Dd*f**2*fd*s**2 + 46888*D1*Dd*f**2*fd*s - 26072*D1*Dd*f**2*fd + 16272*D1*Dd*f**2*g2*r**2 + 6624*D1*Dd*f**2*g2*r*s - 17928*D1*Dd*f**2*g2*r - 9648*D1*Dd*f**2*g2*s**2 + 1512*D1*Dd*f**2*g2*s + 5724*D1*Dd*f**2*g2 - 27360*D1*Dd*f**2*gd2*r**2 - 16704*D1*Dd*f**2*gd2*r*s + 43128*D1*Dd*f**2*gd2*r + 10656*D1*Dd*f**2*gd2*s**2 + 9864*D1*Dd*f**2*gd2*s - 15768*D1*Dd*f**2*gd2 - 54720*D1*Dd*f*fd*g2*r**2 - 33408*D1*Dd*f*fd*g2*r*s + 39888*D1*Dd*f*fd*g2*r + 21312*D1*Dd*f*fd*g2*s**2 - 7632*D1*Dd*f*fd*g2*s - 1512*D1*Dd*f*fd*g2 + 6900*D1*Ddd*f**4*r**2 + 10800*D1*Ddd*f**4*r*s - 9600*D1*Ddd*f**4*r + 3900*D1*Ddd*f**4*s**2 - 7350*D1*Ddd*f**4*s + 4425*D1*Ddd*f**4 - 13264*D1*Ddd*f**3*r**2 - 15552*D1*Ddd*f**3*r*s + 17152*D1*Ddd*f**3*r - 2288*D1*Ddd*f**3*s**2 + 8920*D1*Ddd*f**3*s - 7204*D1*Ddd*f**3 - 13680*D1*Ddd*f**2*g2*r**2 - 8352*D1*Ddd*f**2*g2*r*s + 15768*D1*Ddd*f**2*g2*r + 5328*D1*Ddd*f**2*g2*s**2 + 1512*D1*Ddd*f**2*g2*s - 5508*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(5*f**3*(95*r**2 + 2*r*(71*s - 80) + 47*s**2 - 112*s + 90) + f**2*(36*C*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) + 3*K*(-113*r**2 - 46*r*s + 226*r + 67*s**2 + 46*s - 113) - 25*fd*(75*r**2 + r*(114*s - 113) + 39*s**2 - 83*s + 36) + 549*r**2 + 690*r*s - 1314*r + 141*s**2 - 906*s + 585) - 6*f*(12*C*fd*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 10*s + 1) + K*fd*(-190*r**2 + r*(219 - 116*s) + 74*s**2 + 21*s - 29) + 3*fd*(110*r**2 + r*(156*s - 155) + 46*s**2 - 107*s + 49) + 14*g2*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) - 14*gd2*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2)) + 84*fd*g2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9))) - Dd*f*(25*f**2*(100*r**2 + r*(152*s - 157) + 52*s**2 - 115*s + 60) + 6*f*(6*C*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8) + K*(-380*r**2 - 232*r*s + 599*r + 148*s**2 + 137*s - 219) + 660*r**2 + 936*r*s - 1179*r + 276*s**2 - 843*s + 501) - 84*g2*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8))) + 20700*Dd**2*f**4*r**2 + 32400*Dd**2*f**4*r*s - 28800*Dd**2*f**4*r + 11700*Dd**2*f**4*s**2 - 22050*Dd**2*f**4*s + 8850*Dd**2*f**4 - 39792*Dd**2*f**3*r**2 - 46656*Dd**2*f**3*r*s + 51456*Dd**2*f**3*r - 6864*Dd**2*f**3*s**2 + 26760*Dd**2*f**3*s - 14408*Dd**2*f**3 - 41040*Dd**2*f**2*g2*r**2 - 25056*Dd**2*f**2*g2*r*s + 47304*Dd**2*f**2*g2*r + 15984*Dd**2*f**2*g2*s**2 + 4536*Dd**2*f**2*g2*s - 11016*Dd**2*f**2*g2 + 126*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + D1*(2*Dd*(f*(20*r**2 + 56*r*s - 34*r + 36*s**2 - 46*s + 19) - fd*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15)) - Ddd*f*(20*r**2 + r*(56*s - 34) + 36*s**2 - 46*s + 19)) - 2*Dd**2*f*(30*r**2 + r*(84*s - 51) + 54*s**2 - 69*s + 19)) + 3*b1*(720*C*D1**2*f*fd*r**2 + 2016*C*D1**2*f*fd*r*s - 1440*C*D1**2*f*fd*r + 1296*C*D1**2*f*fd*s**2 - 1728*C*D1**2*f*fd*s + 720*C*D1**2*f*fd - 360*C*D1**2*f*fdd*r**2 - 1008*C*D1**2*f*fdd*r*s + 720*C*D1**2*f*fdd*r - 648*C*D1**2*f*fdd*s**2 + 864*C*D1**2*f*fdd*s - 360*C*D1**2*f*fdd - 360*C*D1**2*fd**2*r**2 - 1008*C*D1**2*fd**2*r*s + 720*C*D1**2*fd**2*r - 648*C*D1**2*fd**2*s**2 + 864*C*D1**2*fd**2*s - 360*C*D1**2*fd**2 + 1440*C*D1*Dd*f**2*r**2 + 4032*C*D1*Dd*f**2*r*s - 2448*C*D1*Dd*f**2*r + 2592*C*D1*Dd*f**2*s**2 - 3312*C*D1*Dd*f**2*s + 1368*C*D1*Dd*f**2 - 2880*C*D1*Dd*f*fd*r**2 - 8064*C*D1*Dd*f*fd*r*s + 5328*C*D1*Dd*f*fd*r - 5184*C*D1*Dd*f*fd*s**2 + 6768*C*D1*Dd*f*fd*s - 2304*C*D1*Dd*f*fd - 720*C*D1*Ddd*f**2*r**2 - 2016*C*D1*Ddd*f**2*r*s + 1224*C*D1*Ddd*f**2*r - 1296*C*D1*Ddd*f**2*s**2 + 1656*C*D1*Ddd*f**2*s - 684*C*D1*Ddd*f**2 - 2160*C*Dd**2*f**2*r**2 - 6048*C*Dd**2*f**2*r*s + 3672*C*Dd**2*f**2*r - 3888*C*Dd**2*f**2*s**2 + 4968*C*Dd**2*f**2*s - 1368*C*Dd**2*f**2 - 1356*D1**2*K*f*fd*r**2 - 552*D1**2*K*f*fd*r*s + 276*D1**2*K*f*fd*r + 804*D1**2*K*f*fd*s**2 - 804*D1**2*K*f*fd*s + 402*D1**2*K*f*fd + 1140*D1**2*K*f*fdd*r**2 + 696*D1**2*K*f*fdd*r*s - 348*D1**2*K*f*fdd*r - 444*D1**2*K*f*fdd*s**2 + 444*D1**2*K*f*fdd*s - 222*D1**2*K*f*fdd + 1140*D1**2*K*fd**2*r**2 + 696*D1**2*K*fd**2*r*s - 348*D1**2*K*fd**2*r - 444*D1**2*K*fd**2*s**2 + 444*D1**2*K*fd**2*s - 42*D1**2*bdd1*f*(K - 1)*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) + 2850*D1**2*f**2*fd*r**2 + 4260*D1**2*f**2*fd*r*s - 3620*D1**2*f**2*fd*r + 1410*D1**2*f**2*fd*s**2 - 2660*D1**2*f**2*fd*s + 1470*D1**2*f**2*fd - 1875*D1**2*f**2*fdd*r**2 - 2850*D1**2*f**2*fdd*r*s + 2350*D1**2*f**2*fdd*r - 975*D1**2*f**2*fdd*s**2 + 1750*D1**2*f**2*fdd*s - 975*D1**2*f**2*fdd - 3750*D1**2*f*fd**2*r**2 - 5700*D1**2*f*fd**2*r*s + 4700*D1**2*f*fd**2*r - 1950*D1**2*f*fd**2*s**2 + 3500*D1**2*f*fd**2*s - 1350*D1**2*f*fd**2 + 2196*D1**2*f*fd*r**2 + 2760*D1**2*f*fd*r*s - 948*D1**2*f*fd*r + 564*D1**2*f*fd*s**2 - 132*D1**2*f*fd*s + 210*D1**2*f*fd - 1980*D1**2*f*fdd*r**2 - 2808*D1**2*f*fdd*r*s + 1188*D1**2*f*fdd*r - 828*D1**2*f*fdd*s**2 + 612*D1**2*f*fdd*s - 378*D1**2*f*fdd - 840*D1**2*f*gd2*r**2 - 2352*D1**2*f*gd2*r*s + 1680*D1**2*f*gd2*r - 1512*D1**2*f*gd2*s**2 + 2352*D1**2*f*gd2*s - 840*D1**2*f*gd2 + 420*D1**2*f*gdd2*r**2 + 1176*D1**2*f*gdd2*r*s - 840*D1**2*f*gdd2*r + 756*D1**2*f*gdd2*s**2 - 1176*D1**2*f*gdd2*s + 420*D1**2*f*gdd2 - 1980*D1**2*fd**2*r**2 - 2808*D1**2*fd**2*r*s + 1188*D1**2*fd**2*r - 828*D1**2*fd**2*s**2 + 612*D1**2*fd**2*s + 360*D1**2*fd**2 - 840*D1**2*fd*g2*r**2 - 2352*D1**2*fd*g2*r*s + 1680*D1**2*fd*g2*r - 1512*D1**2*fd*g2*s**2 + 1680*D1**2*fd*g2*s - 840*D1**2*fd*g2 + 840*D1**2*fd*gd2*r**2 + 2352*D1**2*fd*gd2*r*s - 1680*D1**2*fd*gd2*r + 1512*D1**2*fd*gd2*s**2 - 2016*D1**2*fd*gd2*s + 840*D1**2*fd*gd2 + 420*D1**2*fdd*g2*r**2 + 1176*D1**2*fdd*g2*r*s - 840*D1**2*fdd*g2*r + 756*D1**2*fdd*g2*s**2 - 840*D1**2*fdd*g2*s + 420*D1**2*fdd*g2 - 2712*D1*Dd*K*f**2*r**2 - 1104*D1*Dd*K*f**2*r*s + 2988*D1*Dd*K*f**2*r + 1608*D1*Dd*K*f**2*s**2 - 252*D1*Dd*K*f**2*s - 954*D1*Dd*K*f**2 + 9120*D1*Dd*K*f*fd*r**2 + 5568*D1*Dd*K*f*fd*r*s - 6648*D1*Dd*K*f*fd*r - 3552*D1*Dd*K*f*fd*s**2 + 1272*D1*Dd*K*f*fd*s + 252*D1*Dd*K*f*fd + 3800*D1*Dd*f**3*r**2 + 5680*D1*Dd*f**3*r*s - 5220*D1*Dd*f**3*r + 1880*D1*Dd*f**3*s**2 - 3780*D1*Dd*f**3*s + 2370*D1*Dd*f**3 - 15000*D1*Dd*f**2*fd*r**2 - 22800*D1*Dd*f**2*fd*r*s + 19750*D1*Dd*f**2*fd*r - 7800*D1*Dd*f**2*fd*s**2 + 14650*D1*Dd*f**2*fd*s - 6450*D1*Dd*f**2*fd + 4392*D1*Dd*f**2*r**2 + 5520*D1*Dd*f**2*r*s - 5772*D1*Dd*f**2*r + 1128*D1*Dd*f**2*s**2 - 3324*D1*Dd*f**2*s + 2478*D1*Dd*f**2 - 15840*D1*Dd*f*fd*r**2 - 22464*D1*Dd*f*fd*r*s + 15480*D1*Dd*f*fd*r - 6624*D1*Dd*f*fd*s**2 + 9720*D1*Dd*f*fd*s - 2988*D1*Dd*f*fd - 3360*D1*Dd*f*g2*r**2 - 9408*D1*Dd*f*g2*r*s + 5712*D1*Dd*f*g2*r - 6048*D1*Dd*f*g2*s**2 + 7728*D1*Dd*f*g2*s - 3192*D1*Dd*f*g2 + 3360*D1*Dd*f*gd2*r**2 + 9408*D1*Dd*f*gd2*r*s - 6216*D1*Dd*f*gd2*r + 6048*D1*Dd*f*gd2*s**2 - 8568*D1*Dd*f*gd2*s + 2856*D1*Dd*f*gd2 + 3360*D1*Dd*fd*g2*r**2 + 9408*D1*Dd*fd*g2*r*s - 6216*D1*Dd*fd*g2*r + 6048*D1*Dd*fd*g2*s**2 - 7224*D1*Dd*fd*g2*s + 2520*D1*Dd*fd*g2 + 2280*D1*Ddd*K*f**2*r**2 + 1392*D1*Ddd*K*f**2*r*s - 2628*D1*Ddd*K*f**2*r - 888*D1*Ddd*K*f**2*s**2 - 252*D1*Ddd*K*f**2*s + 918*D1*Ddd*K*f**2 - 2500*D1*Ddd*f**3*r**2 - 3800*D1*Ddd*f**3*r*s + 3450*D1*Ddd*f**3*r - 1300*D1*Ddd*f**3*s**2 + 2550*D1*Ddd*f**3*s - 1575*D1*Ddd*f**3 - 3960*D1*Ddd*f**2*r**2 - 5616*D1*Ddd*f**2*r*s + 5364*D1*Ddd*f**2*r - 1656*D1*Ddd*f**2*s**2 + 3636*D1*Ddd*f**2*s - 2394*D1*Ddd*f**2 + 1680*D1*Ddd*f*g2*r**2 + 4704*D1*Ddd*f*g2*r*s - 2856*D1*Ddd*f*g2*r + 3024*D1*Ddd*f*g2*s**2 - 3864*D1*Ddd*f*g2*s + 1596*D1*Ddd*f*g2 + 84*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) - fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 21*s + 5)) - Dd*f*(40*r**2 + 2*r*(56*s - 31) + 72*s**2 - 90*s + 25)) + 6840*Dd**2*K*f**2*r**2 + 4176*Dd**2*K*f**2*r*s - 7884*Dd**2*K*f**2*r - 2664*Dd**2*K*f**2*s**2 - 756*Dd**2*K*f**2*s + 1836*Dd**2*K*f**2 - 7500*Dd**2*f**3*r**2 - 11400*Dd**2*f**3*r*s + 10350*Dd**2*f**3*r - 3900*Dd**2*f**3*s**2 + 7650*Dd**2*f**3*s - 3150*Dd**2*f**3 - 11880*Dd**2*f**2*r**2 - 16848*Dd**2*f**2*r*s + 16092*Dd**2*f**2*r - 4968*Dd**2*f**2*s**2 + 10908*Dd**2*f**2*s - 4788*Dd**2*f**2 + 5040*Dd**2*f*g2*r**2 + 14112*Dd**2*f*g2*r*s - 8568*Dd**2*f*g2*r + 9072*Dd**2*f*g2*s**2 - 11592*Dd**2*f*g2*s + 3192*Dd**2*f*g2))/(630*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**4*k1**2*k2**2*(-114*C*D1**2*bdd1*f**2*r**2 + 156*C*D1**2*bdd1*f**2*r*s + 1044*C*D1**2*bdd1*f**2*r + 270*C*D1**2*bdd1*f**2*s**2 + 660*C*D1**2*bdd1*f**2*s - 330*C*D1**2*bdd1*f**2 + 4230*C*D1**2*f**2*fd*r**2 + 11460*C*D1**2*f**2*fd*r*s - 6640*C*D1**2*f**2*fd*r + 7230*C*D1**2*f**2*fd*s**2 - 8640*C*D1**2*f**2*fd*s + 3820*C*D1**2*f**2*fd - 5220*C*D1**2*f**2*fdd*r**2 - 12120*C*D1**2*f**2*fdd*r*s + 7520*C*D1**2*f**2*fdd*r - 6900*C*D1**2*f**2*fdd*s**2 + 8640*C*D1**2*f**2*fdd*s - 4040*C*D1**2*f**2*fdd - 10440*C*D1**2*f*fd**2*r**2 - 24240*C*D1**2*f*fd**2*r*s + 15040*C*D1**2*f*fd**2*r - 13800*C*D1**2*f*fd**2*s**2 + 17280*C*D1**2*f*fd**2*s - 4040*C*D1**2*f*fd**2 + 5640*C*D1*Dd*f**3*r**2 + 15280*C*D1*Dd*f**3*r*s - 9460*C*D1*Dd*f**3*r + 9640*C*D1*Dd*f**3*s**2 - 12460*C*D1*Dd*f**3*s + 5230*C*D1*Dd*f**3 - 41760*C*D1*Dd*f**2*fd*r**2 - 96960*C*D1*Dd*f**2*fd*r*s + 63080*C*D1*Dd*f**2*fd*r - 55200*C*D1*Dd*f**2*fd*s**2 + 72600*C*D1*Dd*f**2*fd*s - 23680*C*D1*Dd*f**2*fd - 6960*C*D1*Ddd*f**3*r**2 - 16160*C*D1*Ddd*f**3*r*s + 11000*C*D1*Ddd*f**3*r - 9200*C*D1*Ddd*f**3*s**2 + 12680*C*D1*Ddd*f**3*s - 5780*C*D1*Ddd*f**3 - 20880*C*Dd**2*f**3*r**2 - 48480*C*Dd**2*f**3*r*s + 33000*C*Dd**2*f**3*r - 27600*C*Dd**2*f**3*s**2 + 38040*C*Dd**2*f**3*s - 11560*C*Dd**2*f**3 - 1050*D1**2*K*bdd1*f**2*r**2 - 2604*D1**2*K*bdd1*f**2*r*s + 2100*D1**2*K*bdd1*f**2*r - 1554*D1**2*K*bdd1*f**2*s**2 + 2604*D1**2*K*bdd1*f**2*s - 1050*D1**2*K*bdd1*f**2 + 750*D1**2*b2*f*fd*r**2 + 1500*D1**2*b2*f*fd*r*s - 750*D1**2*b2*f*fd*r + 750*D1**2*b2*f*fd*s**2 - 750*D1**2*b2*f*fd*s + 375*D1**2*b2*f*fd - 900*D1**2*b2*f*fdd*r**2 - 1800*D1**2*b2*f*fdd*r*s + 900*D1**2*b2*f*fdd*r - 900*D1**2*b2*f*fdd*s**2 + 900*D1**2*b2*f*fdd*s - 450*D1**2*b2*f*fdd - 900*D1**2*b2*fd**2*r**2 - 1800*D1**2*b2*fd**2*r*s + 900*D1**2*b2*fd**2*r - 900*D1**2*b2*fd**2*s**2 + 900*D1**2*b2*fd**2*s + 2*D1**2*bd1**2*(r + s - 1)*(150*f**2*(r + s - 2) + 7*f*(30*C*r + 30*C*s + K*(-r + 23*s + 49) + 61*r + 37*s - 109) - 350*g2*(r + s)) + 375*D1**2*bd2*f**2*r**2 + 750*D1**2*bd2*f**2*r*s - 750*D1**2*bd2*f**2*r + 375*D1**2*bd2*f**2*s**2 - 750*D1**2*bd2*f**2*s + 375*D1**2*bd2*f**2 - 1800*D1**2*bd2*f*fd*r**2 - 3600*D1**2*bd2*f*fd*r*s + 2700*D1**2*bd2*f*fd*r - 1800*D1**2*bd2*f*fd*s**2 + 2700*D1**2*bd2*f*fd*s - 900*D1**2*bd2*f*fd + 150*D1**2*bdd1*f**3*r**2 + 570*D1**2*bdd1*f**3*r*s - 510*D1**2*bdd1*f**3*r + 420*D1**2*bdd1*f**3*s**2 - 780*D1**2*bdd1*f**3*s + 360*D1**2*bdd1*f**3 + 864*D1**2*bdd1*f**2*r**2 + 1596*D1**2*bdd1*f**2*r*s - 2244*D1**2*bdd1*f**2*r + 732*D1**2*bdd1*f**2*s**2 - 2112*D1**2*bdd1*f**2*s + 930*D1**2*bdd1*f**2 + 14*D1**2*bdd1*f*g2*r**2 - 308*D1**2*bdd1*f*g2*r*s - 1372*D1**2*bdd1*f*g2*r - 322*D1**2*bdd1*f*g2*s**2 - 1036*D1**2*bdd1*f*g2*s + 518*D1**2*bdd1*f*g2 - 450*D1**2*bdd2*f**2*r**2 - 900*D1**2*bdd2*f**2*r*s + 900*D1**2*bdd2*f**2*r - 450*D1**2*bdd2*f**2*s**2 + 900*D1**2*bdd2*f**2*s - 450*D1**2*bdd2*f**2 - 2055*D1**2*f**2*fd*r**2 - 6540*D1**2*f**2*fd*r*s + 3550*D1**2*f**2*fd*r - 4485*D1**2*f**2*fd*s**2 + 5170*D1**2*f**2*fd*s - 2180*D1**2*f**2*fd + 3390*D1**2*f**2*fdd*r**2 + 8040*D1**2*f**2*fdd*r*s - 4940*D1**2*f**2*fdd*r + 4650*D1**2*f**2*fdd*s**2 - 5780*D1**2*f**2*fdd*s + 2680*D1**2*f**2*fdd - 1302*D1**2*f**2*gd2*r**2 - 4452*D1**2*f**2*gd2*r*s + 2604*D1**2*f**2*gd2*r - 3150*D1**2*f**2*gd2*s**2 + 4452*D1**2*f**2*gd2*s - 1302*D1**2*f**2*gd2 + 2100*D1**2*f**2*gdd2*r**2 + 5208*D1**2*f**2*gdd2*r*s - 4200*D1**2*f**2*gdd2*r + 3108*D1**2*f**2*gdd2*s**2 - 5208*D1**2*f**2*gdd2*s + 2100*D1**2*f**2*gdd2 + 6780*D1**2*f*fd**2*r**2 + 16080*D1**2*f*fd**2*r*s - 9880*D1**2*f*fd**2*r + 9300*D1**2*f*fd**2*s**2 - 11560*D1**2*f*fd**2*s + 2680*D1**2*f*fd**2 - 2604*D1**2*f*fd*g2*r**2 - 8904*D1**2*f*fd*g2*r*s + 4452*D1**2*f*fd*g2*r - 6300*D1**2*f*fd*g2*s**2 + 6300*D1**2*f*fd*g2*s - 3150*D1**2*f*fd*g2 + 8400*D1**2*f*fd*gd2*r**2 + 20832*D1**2*f*fd*gd2*r*s - 13608*D1**2*f*fd*gd2*r + 12432*D1**2*f*fd*gd2*s**2 - 16632*D1**2*f*fd*gd2*s + 5208*D1**2*f*fd*gd2 + 4200*D1**2*f*fdd*g2*r**2 + 10416*D1**2*f*fdd*g2*r*s - 5208*D1**2*f*fdd*g2*r + 6216*D1**2*f*fdd*g2*s**2 - 6216*D1**2*f*fdd*g2*s + 3108*D1**2*f*fdd*g2 + 4200*D1**2*fd**2*g2*r**2 + 10416*D1**2*fd**2*g2*r*s - 5208*D1**2*fd**2*g2*r + 6216*D1**2*fd**2*g2*s**2 - 6216*D1**2*fd**2*g2*s + 1500*D1*Dd*b2*f**2*r**2 + 3000*D1*Dd*b2*f**2*r*s - 2250*D1*Dd*b2*f**2*r + 1500*D1*Dd*b2*f**2*s**2 - 2250*D1*Dd*b2*f**2*s + 1125*D1*Dd*b2*f**2 - 7200*D1*Dd*b2*f*fd*r**2 - 14400*D1*Dd*b2*f*fd*r*s + 9000*D1*Dd*b2*f*fd*r - 7200*D1*Dd*b2*f*fd*s**2 + 9000*D1*Dd*b2*f*fd*s - 2700*D1*Dd*b2*f*fd - 3600*D1*Dd*bd2*f**2*r**2 - 7200*D1*Dd*bd2*f**2*r*s + 6300*D1*Dd*bd2*f**2*r - 3600*D1*Dd*bd2*f**2*s**2 + 6300*D1*Dd*bd2*f**2*s - 2700*D1*Dd*bd2*f**2 - 2740*D1*Dd*f**3*r**2 - 8720*D1*Dd*f**3*r*s + 4920*D1*Dd*f**3*r - 5980*D1*Dd*f**3*s**2 + 7350*D1*Dd*f**3*s - 2865*D1*Dd*f**3 + 27120*D1*Dd*f**2*fd*r**2 + 64320*D1*Dd*f**2*fd*r*s - 41360*D1*Dd*f**2*fd*r + 37200*D1*Dd*f**2*fd*s**2 - 48500*D1*Dd*f**2*fd*s + 15660*D1*Dd*f**2*fd - 5208*D1*Dd*f**2*g2*r**2 - 17808*D1*Dd*f**2*g2*r*s + 9660*D1*Dd*f**2*g2*r - 12600*D1*Dd*f**2*g2*s**2 + 15204*D1*Dd*f**2*g2*s - 5754*D1*Dd*f**2*g2 + 16800*D1*Dd*f**2*gd2*r**2 + 41664*D1*Dd*f**2*gd2*r*s - 30408*D1*Dd*f**2*gd2*r + 24864*D1*Dd*f**2*gd2*s**2 - 37464*D1*Dd*f**2*gd2*s + 13608*D1*Dd*f**2*gd2 + 33600*D1*Dd*f*fd*g2*r**2 + 83328*D1*Dd*f*fd*g2*r*s - 48048*D1*Dd*f*fd*g2*r + 49728*D1*Dd*f*fd*g2*s**2 - 58128*D1*Dd*f*fd*g2*s + 16632*D1*Dd*f*fd*g2 - 1800*D1*Ddd*b2*f**2*r**2 - 3600*D1*Ddd*b2*f**2*r*s + 2700*D1*Ddd*b2*f**2*r - 1800*D1*Ddd*b2*f**2*s**2 + 2700*D1*Ddd*b2*f**2*s - 1350*D1*Ddd*b2*f**2 + 4520*D1*Ddd*f**3*r**2 + 10720*D1*Ddd*f**3*r*s - 7200*D1*Ddd*f**3*r + 6200*D1*Ddd*f**3*s**2 - 8460*D1*Ddd*f**3*s + 3810*D1*Ddd*f**3 + 8400*D1*Ddd*f**2*g2*r**2 + 20832*D1*Ddd*f**2*g2*r*s - 13608*D1*Ddd*f**2*g2*r + 12432*D1*Ddd*f**2*g2*s**2 - 16632*D1*Ddd*f**2*g2*s + 7308*D1*Ddd*f**2*g2 + D1*bd1*(D1*(15*f**3*(9*r**2 + r*(2 - 8*s) - 17*s**2 + 28*s - 6) + 3*f**2*(2*C*(136*r**2 + 2*r*(86*s - 111) + 36*s**2 - 122*s + 61) + 217*K*r**2 + 742*K*r*s - 434*K*r + 525*K*s**2 - 742*K*s + 217*K + 10*fd*(30*r**2 + 114*r*s - 73*r + 84*s**2 - 118*s + 36) - 380*r**2 - 742*r*s + 600*r - 362*s**2 + 582*s - 200) - 2*f*(6*fd*(C*(38*r**2 - r*(52*s + 93) - 90*s**2 + 3*s + 87) + 7*K*(50*r**2 + 124*r*s - 81*r + 74*s**2 - 99*s + 31) - 288*r**2 - 532*r*s + 464*r - 244*s**2 + 431*s - 208) + 7*g2*(72*r**2 + 2*r*(58*s - 53) + 44*s**2 - 78*s + 39) + 14*gd2*(-r**2 + r*(22*s + 50) + 23*s**2 + 26*s - 49)) + 28*fd*g2*(r**2 + r*(11 - 22*s) - s*(23*s - 23))) + 2*Dd*f*(15*f**2*(40*r**2 + 152*r*s - 107*r + 112*s**2 - 170*s + 60) - 6*f*(C*(76*r**2 - r*(104*s + 373) - 180*s**2 - 149*s + 229) + 7*K*(100*r**2 + 248*r*s - 181*r + 148*s**2 - 223*s + 81) - 576*r**2 - 1064*r*s + 1169*r - 488*s**2 + 1092*s - 550) + 14*g2*(4*r**2 - 11*r*(8*s + 17) - 92*s**2 - 103*s + 135))) - 5400*Dd**2*b2*f**2*r**2 - 10800*Dd**2*b2*f**2*r*s + 8100*Dd**2*b2*f**2*r - 5400*Dd**2*b2*f**2*s**2 + 8100*Dd**2*b2*f**2*s - 2700*Dd**2*b2*f**2 + 13560*Dd**2*f**3*r**2 + 32160*Dd**2*f**3*r*s - 21600*Dd**2*f**3*r + 18600*Dd**2*f**3*s**2 - 25380*Dd**2*f**3*s + 7620*Dd**2*f**3 + 25200*Dd**2*f**2*g2*r**2 + 62496*Dd**2*f**2*g2*r*s - 40824*Dd**2*f**2*g2*r + 37296*Dd**2*f**2*g2*s**2 - 49896*Dd**2*f**2*g2*s + 14616*Dd**2*f**2*g2 - 175*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-420*C*D1**2*fd*r**2 - 840*C*D1**2*fd*r*s + 840*C*D1**2*fd*r - 420*C*D1**2*fd*s**2 + 840*C*D1**2*fd*s - 420*C*D1**2*fd + 210*C*D1**2*fdd*r**2 + 420*C*D1**2*fdd*r*s - 420*C*D1**2*fdd*r + 210*C*D1**2*fdd*s**2 - 420*C*D1**2*fdd*s + 210*C*D1**2*fdd - 1680*C*D1*Dd*f*r**2 - 3360*C*D1*Dd*f*r*s + 2520*C*D1*Dd*f*r - 1680*C*D1*Dd*f*s**2 + 2520*C*D1*Dd*f*s - 1260*C*D1*Dd*f + 1680*C*D1*Dd*fd*r**2 + 3360*C*D1*Dd*fd*r*s - 2940*C*D1*Dd*fd*r + 1680*C*D1*Dd*fd*s**2 - 2940*C*D1*Dd*fd*s + 1260*C*D1*Dd*fd + 840*C*D1*Ddd*f*r**2 + 1680*C*D1*Ddd*f*r*s - 1260*C*D1*Ddd*f*r + 840*C*D1*Ddd*f*s**2 - 1260*C*D1*Ddd*f*s + 630*C*D1*Ddd*f + 2520*C*Dd**2*f*r**2 + 5040*C*Dd**2*f*r*s - 3780*C*Dd**2*f*r + 2520*C*Dd**2*f*s**2 - 3780*C*Dd**2*f*s + 1260*C*Dd**2*f + 504*D1**2*K*fd*r**2 + 812*D1**2*K*fd*r*s - 70*D1**2*K*fd*r + 308*D1**2*K*fd*s**2 - 70*D1**2*K*fd*s + 35*D1**2*K*fd - 7*D1**2*K*fdd*r**2 + 154*D1**2*K*fdd*r*s - 840*D1**2*K*fdd*r + 161*D1**2*K*fdd*s**2 - 840*D1**2*K*fdd*s + 420*D1**2*K*fdd + 175*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 600*D1**2*f*fd*r**2 - 1200*D1**2*f*fd*r*s + 420*D1**2*f*fd*r - 600*D1**2*f*fd*s**2 + 420*D1**2*f*fd*s - 210*D1**2*f*fd + 300*D1**2*f*fdd*r**2 + 600*D1**2*f*fdd*r*s + 300*D1**2*f*fdd*s**2 + 300*D1**2*fd**2*r**2 + 600*D1**2*fd**2*r*s + 300*D1**2*fd**2*s**2 - 300*D1**2*fd**2 - 644*D1**2*fd*r**2 - 1092*D1**2*fd*r*s - 630*D1**2*fd*r - 448*D1**2*fd*s**2 - 630*D1**2*fd*s + 315*D1**2*fd + 427*D1**2*fdd*r**2 + 686*D1**2*fdd*r*s + 840*D1**2*fdd*r + 259*D1**2*fdd*s**2 + 840*D1**2*fdd*s - 420*D1**2*fdd + 700*D1**2*gd2*r**2 + 1400*D1**2*gd2*r*s - 1400*D1**2*gd2*r + 700*D1**2*gd2*s**2 - 1400*D1**2*gd2*s + 700*D1**2*gd2 - 350*D1**2*gdd2*r**2 - 700*D1**2*gdd2*r*s + 700*D1**2*gdd2*r - 350*D1**2*gdd2*s**2 + 700*D1**2*gdd2*s - 350*D1**2*gdd2 + 2016*D1*Dd*K*f*r**2 + 3248*D1*Dd*K*f*r*s - 2828*D1*Dd*K*f*r + 1232*D1*Dd*K*f*s**2 - 2240*D1*Dd*K*f*s + 1316*D1*Dd*K*f - 56*D1*Dd*K*fd*r**2 + 1232*D1*Dd*K*fd*r*s - 3486*D1*Dd*K*fd*r + 1288*D1*Dd*K*fd*s**2 - 3990*D1*Dd*K*fd*s + 2520*D1*Dd*K*fd - 1200*D1*Dd*f**2*r**2 - 2400*D1*Dd*f**2*r*s + 1800*D1*Dd*f**2*r - 1200*D1*Dd*f**2*s**2 + 1800*D1*Dd*f**2*s - 900*D1*Dd*f**2 + 2400*D1*Dd*f*fd*r**2 + 4800*D1*Dd*f*fd*r*s - 1800*D1*Dd*f*fd*r + 2400*D1*Dd*f*fd*s**2 - 1800*D1*Dd*f*fd*s - 2576*D1*Dd*f*r**2 - 4368*D1*Dd*f*r*s + 3668*D1*Dd*f*r - 1792*D1*Dd*f*s**2 + 3080*D1*Dd*f*s - 1736*D1*Dd*f + 3416*D1*Dd*fd*r**2 + 5488*D1*Dd*fd*r*s + 966*D1*Dd*fd*r + 2072*D1*Dd*fd*s**2 + 1470*D1*Dd*fd*s - 2520*D1*Dd*fd + 2800*D1*Dd*g2*r**2 + 5600*D1*Dd*g2*r*s - 4200*D1*Dd*g2*r + 2800*D1*Dd*g2*s**2 - 4200*D1*Dd*g2*s + 2100*D1*Dd*g2 - 2800*D1*Dd*gd2*r**2 - 5600*D1*Dd*gd2*r*s + 4900*D1*Dd*gd2*r - 2800*D1*Dd*gd2*s**2 + 4900*D1*Dd*gd2*s - 2100*D1*Dd*gd2 - 28*D1*Ddd*K*f*r**2 + 616*D1*Ddd*K*f*r*s - 126*D1*Ddd*K*f*r + 644*D1*Ddd*K*f*s**2 - 630*D1*Ddd*K*f*s + 147*D1*Ddd*K*f + 600*D1*Ddd*f**2*r**2 + 1200*D1*Ddd*f**2*r*s - 900*D1*Ddd*f**2*r + 600*D1*Ddd*f**2*s**2 - 900*D1*Ddd*f**2*s + 450*D1*Ddd*f**2 + 1708*D1*Ddd*f*r**2 + 2744*D1*Ddd*f*r*s - 2394*D1*Ddd*f*r + 1036*D1*Ddd*f*s**2 - 1890*D1*Ddd*f*s + 1113*D1*Ddd*f - 1400*D1*Ddd*g2*r**2 - 2800*D1*Ddd*g2*r*s + 2100*D1*Ddd*g2*r - 1400*D1*Ddd*g2*s**2 + 2100*D1*Ddd*g2*s - 1050*D1*Ddd*g2 - 350*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 84*Dd**2*K*f*r**2 + 1848*Dd**2*K*f*r*s - 378*Dd**2*K*f*r + 1932*Dd**2*K*f*s**2 - 1890*Dd**2*K*f*s + 294*Dd**2*K*f + 1800*Dd**2*f**2*r**2 + 3600*Dd**2*f**2*r*s - 2700*Dd**2*f**2*r + 1800*Dd**2*f**2*s**2 - 2700*Dd**2*f**2*s + 900*Dd**2*f**2 + 5124*Dd**2*f*r**2 + 8232*Dd**2*f*r*s - 7182*Dd**2*f*r + 3108*Dd**2*f*s**2 - 5670*Dd**2*f*s + 2226*Dd**2*f - 4200*Dd**2*g2*r**2 - 8400*Dd**2*g2*r*s + 6300*Dd**2*g2*r - 4200*Dd**2*g2*s**2 + 6300*Dd**2*g2*s - 2100*Dd**2*g2) + b1*(1632*C*D1**2*f*fd*r**2 + 2064*C*D1**2*f*fd*r*s - 1332*C*D1**2*f*fd*r + 432*C*D1**2*f*fd*s**2 - 732*C*D1**2*f*fd*s + 666*C*D1**2*f*fd - 228*C*D1**2*f*fdd*r**2 + 312*C*D1**2*f*fdd*r*s - 972*C*D1**2*f*fdd*r + 540*C*D1**2*f*fdd*s**2 - 1356*C*D1**2*f*fdd*s + 486*C*D1**2*f*fdd - 228*C*D1**2*fd**2*r**2 + 312*C*D1**2*fd**2*r*s - 972*C*D1**2*fd**2*r + 540*C*D1**2*fd**2*s**2 - 1356*C*D1**2*fd**2*s + 1200*C*D1**2*fd**2 + 3264*C*D1*Dd*f**2*r**2 + 4128*C*D1*Dd*f**2*r*s - 4296*C*D1*Dd*f**2*r + 864*C*D1*Dd*f**2*s**2 - 2496*C*D1*Dd*f**2*s + 1848*C*D1*Dd*f**2 - 1824*C*D1*Dd*f*fd*r**2 + 2496*C*D1*Dd*f*fd*r*s - 3288*C*D1*Dd*f*fd*r + 4320*C*D1*Dd*f*fd*s**2 - 7128*C*D1*Dd*f*fd*s + 3300*C*D1*Dd*f*fd - 456*C*D1*Ddd*f**2*r**2 + 624*C*D1*Ddd*f**2*r*s + 300*C*D1*Ddd*f**2*r + 1080*C*D1*Ddd*f**2*s**2 - 852*C*D1*Ddd*f**2*s + 42*C*D1*Ddd*f**2 - 1368*C*Dd**2*f**2*r**2 + 1872*C*Dd**2*f**2*r*s + 900*C*Dd**2*f**2*r + 3240*C*Dd**2*f**2*s**2 - 2556*C*Dd**2*f**2*s + 84*C*Dd**2*f**2 + 1302*D1**2*K*f*fd*r**2 + 4452*D1**2*K*f*fd*r*s - 2226*D1**2*K*f*fd*r + 3150*D1**2*K*f*fd*s**2 - 3150*D1**2*K*f*fd*s + 1575*D1**2*K*f*fd - 2100*D1**2*K*f*fdd*r**2 - 5208*D1**2*K*f*fdd*r*s + 2604*D1**2*K*f*fdd*r - 3108*D1**2*K*f*fdd*s**2 + 3108*D1**2*K*f*fdd*s - 1554*D1**2*K*f*fdd - 2100*D1**2*K*fd**2*r**2 - 5208*D1**2*K*fd**2*r*s + 2604*D1**2*K*fd**2*r - 3108*D1**2*K*fd**2*s**2 + 3108*D1**2*K*fd**2*s + 350*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(75*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + 7*f*(15*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*(-r**2 + 22*r*s + 50*r + 23*s**2 + 26*s - 19) + 61*r**2 + 98*r*s - 170*r + 37*s**2 - 146*s + 79) - 175*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 405*D1**2*f**2*fd*r**2 - 360*D1**2*f**2*fd*r*s - 450*D1**2*f**2*fd*r - 765*D1**2*f**2*fd*s**2 + 330*D1**2*f**2*fd*s + 105*D1**2*f**2*fd + 450*D1**2*f**2*fdd*r**2 + 1710*D1**2*f**2*fdd*r*s - 660*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1200*D1**2*f**2*fdd*s + 360*D1**2*f**2*fdd + 900*D1**2*f*fd**2*r**2 + 3420*D1**2*f*fd**2*r*s - 1320*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 2400*D1**2*f*fd**2*s + 360*D1**2*f*fd**2 - 2280*D1**2*f*fd*r**2 - 4452*D1**2*f*fd*r*s + 2706*D1**2*f*fd*r - 2172*D1**2*f*fd*s**2 + 2652*D1**2*f*fd*s - 1626*D1**2*f*fd + 1728*D1**2*f*fdd*r**2 + 3192*D1**2*f*fdd*r*s - 1080*D1**2*f*fdd*r + 1464*D1**2*f*fdd*s**2 - 948*D1**2*f*fdd*s + 666*D1**2*f*fdd - 1008*D1**2*f*gd2*r**2 - 1624*D1**2*f*gd2*r*s + 2016*D1**2*f*gd2*r - 616*D1**2*f*gd2*s**2 + 1624*D1**2*f*gd2*s - 1008*D1**2*f*gd2 + 14*D1**2*f*gdd2*r**2 - 308*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r - 322*D1**2*f*gdd2*s**2 + 308*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 + 1728*D1**2*fd**2*r**2 + 3192*D1**2*fd**2*r*s - 1080*D1**2*fd**2*r + 1464*D1**2*fd**2*s**2 - 948*D1**2*fd**2*s - 900*D1**2*fd**2 - 1008*D1**2*fd*g2*r**2 - 1624*D1**2*fd*g2*r*s + 140*D1**2*fd*g2*r - 616*D1**2*fd*g2*s**2 + 140*D1**2*fd*g2*s - 70*D1**2*fd*g2 + 28*D1**2*fd*gd2*r**2 - 616*D1**2*fd*gd2*r*s + 1652*D1**2*fd*gd2*r - 644*D1**2*fd*gd2*s**2 + 1988*D1**2*fd*gd2*s - 1680*D1**2*fd*gd2 + 14*D1**2*fdd*g2*r**2 - 308*D1**2*fdd*g2*r*s + 1680*D1**2*fdd*g2*r - 322*D1**2*fdd*g2*s**2 + 1680*D1**2*fdd*g2*s - 840*D1**2*fdd*g2 + 2604*D1*Dd*K*f**2*r**2 + 8904*D1*Dd*K*f**2*r*s - 4830*D1*Dd*K*f**2*r + 6300*D1*Dd*K*f**2*s**2 - 7602*D1*Dd*K*f**2*s + 2877*D1*Dd*K*f**2 - 16800*D1*Dd*K*f*fd*r**2 - 41664*D1*Dd*K*f*fd*r*s + 24024*D1*Dd*K*f*fd*r - 24864*D1*Dd*K*f*fd*s**2 + 29064*D1*Dd*K*f*fd*s - 8316*D1*Dd*K*f*fd + 540*D1*Dd*f**3*r**2 - 480*D1*Dd*f**3*r*s - 420*D1*Dd*f**3*r - 1020*D1*Dd*f**3*s**2 + 750*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 3600*D1*Dd*f**2*fd*r**2 + 13680*D1*Dd*f**2*fd*r*s - 6150*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 10740*D1*Dd*f**2*fd*s + 2520*D1*Dd*f**2*fd - 4560*D1*Dd*f**2*r**2 - 8904*D1*Dd*f**2*r*s + 6786*D1*Dd*f**2*r - 4344*D1*Dd*f**2*s**2 + 6624*D1*Dd*f**2*s - 3366*D1*Dd*f**2 + 13824*D1*Dd*f*fd*r**2 + 25536*D1*Dd*f*fd*r*s - 14424*D1*Dd*f*fd*r + 11712*D1*Dd*f*fd*s**2 - 13104*D1*Dd*f*fd*s + 3108*D1*Dd*f*fd - 4032*D1*Dd*f*g2*r**2 - 6496*D1*Dd*f*g2*r*s + 5656*D1*Dd*f*g2*r - 2464*D1*Dd*f*g2*s**2 + 4480*D1*Dd*f*g2*s - 2632*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 - 2464*D1*Dd*f*gd2*r*s + 140*D1*Dd*f*gd2*r - 2576*D1*Dd*f*gd2*s**2 + 2492*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r**2 - 2464*D1*Dd*fd*g2*r*s + 6972*D1*Dd*fd*g2*r - 2576*D1*Dd*fd*g2*s**2 + 7980*D1*Dd*fd*g2*s - 5040*D1*Dd*fd*g2 - 4200*D1*Ddd*K*f**2*r**2 - 10416*D1*Ddd*K*f**2*r*s + 6804*D1*Ddd*K*f**2*r - 6216*D1*Ddd*K*f**2*s**2 + 8316*D1*Ddd*K*f**2*s - 3654*D1*Ddd*K*f**2 + 600*D1*Ddd*f**3*r**2 + 2280*D1*Ddd*f**3*r*s - 1170*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 1980*D1*Ddd*f**3*s + 720*D1*Ddd*f**3 + 3456*D1*Ddd*f**2*r**2 + 6384*D1*Ddd*f**2*r*s - 5052*D1*Ddd*f**2*r + 2928*D1*Ddd*f**2*s**2 - 4656*D1*Ddd*f**2*s + 2460*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 - 1232*D1*Ddd*f*g2*r*s + 252*D1*Ddd*f*g2*r - 1288*D1*Ddd*f*g2*s**2 + 1260*D1*Ddd*f*g2*s - 294*D1*Ddd*f*g2 + D1*bd1*(D1*(-30*f**2*(20*r**2 + r*(40*s - 46) + 20*s**2 - 46*s + 23) + f*(-420*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(144*r**2 + 232*r*s - 250*r + 88*s**2 - 194*s + 111) + 600*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 1288*r**2 - 2184*r*s + 3010*r - 896*s**2 + 2618*s - 1407) + 28*fd*(15*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - K*(r**2 - 22*r*s + 35*r - 23*s**2 + 47*s - 30) + 61*r**2 + 98*r*s - 25*r + 37*s**2 - 13*s - 30) + 700*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 700*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(75*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + 7*f*(15*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + K*(-4*r**2 + 88*r*s + 91*r + 92*s**2 + 7*s - 63) + 244*r**2 + 392*r*s - 511*r + 148*s**2 - 427*s + 243) - 175*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 12600*Dd**2*K*f**2*r**2 - 31248*Dd**2*K*f**2*r*s + 20412*Dd**2*K*f**2*r - 18648*Dd**2*K*f**2*s**2 + 24948*Dd**2*K*f**2*s - 7308*Dd**2*K*f**2 + 1800*Dd**2*f**3*r**2 + 6840*Dd**2*f**3*r*s - 3510*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 5940*Dd**2*f**3*s + 1440*Dd**2*f**3 + 10368*Dd**2*f**2*r**2 + 19152*Dd**2*f**2*r*s - 15156*Dd**2*f**2*r + 8784*Dd**2*f**2*s**2 - 13968*Dd**2*f**2*s + 4920*Dd**2*f**2 + 168*Dd**2*f*g2*r**2 - 3696*Dd**2*f*g2*r*s + 756*Dd**2*f*g2*r - 3864*Dd**2*f*g2*s**2 + 3780*Dd**2*f*g2*s - 588*Dd**2*f*g2))/(210*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**4*k1**2*st**2*(-42*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(10*f**3*s*(17*r + 17*s - 12) + f**2*(-25*fd*(6*s - 1)*(4*r + 4*s - 3) + 6*s*(12*C*s + r*(12*C + 11) + 11*s - 23)) - 6*f*(3*fd*(r*(2*C + 3)*(4*s - 1) + s**2*(8*C + 12) - s*(6*C + 14) + 5) + 14*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(25*f**2*(8*s - 1)*(4*r + 4*s - 3) + 18*f*(r*(2*C + 3)*(8*s - 1) + s**2*(16*C + 24) - s*(8*C + 32) + 5) - 84*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 42*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(5*f**2*(2*fd*(17*r*(3*s - 1) + 51*s**2 - 56*s + 17) - 5*fdd*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4)) + f*(-25*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) + 6*fd*(12*C*(2*s - 1)*(r + s - 1) + 22*r*s - 11*r + 22*s**2 - 10*s + 11) - 18*fdd*(2*C*(2*s - 1)*(r + s - 1) + 6*r*s - 3*r + 6*s**2 - 4*s + 3) - 42*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) - 18*fd**2*(2*C*(2*s - 1)*(r + s - 1) + r*(6*s - 3) + 6*s**2 - 4*s - 2) - 84*fd*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 84*fdd*g2*(s - 1)*(r + s - 1)) - 42*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(170*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(72*C*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(24*s - 7)*(4*r + 4*s - 3) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 12*f*(3*fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 3*r*(8*s - 3) + 24*s**2 - 20*s + 5) + 7*g2*r*(8*s - 2) + 14*g2*(1 - 2*s)**2 + 7*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 84*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(50*f**2 + f*(18*C + 27) - 42*g2)) - 2*Dd**2*f*(50*f**2 + f*(18*C + 27) - 42*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - f*(D1**2*(25*bdd1*f**2*s*(4*r + 4*s - 3) - 84*bdd1*g2*s*(r + s) + 2*f*(9*bdd1*s*(2*C*r + 2*C*s + 3*r + 3*s - 5) - 41*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 50*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 2*D1*f*(Dd*(41*f*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 25*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 50*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**4*k1**2*(210*C*D1**2*bdd1*f**2*r**2 + 300*C*D1**2*bdd1*f**2*r*s + 90*C*D1**2*bdd1*f**2*s**2 - 960*C*D1**2*f**2*fd*r*s + 320*C*D1**2*f**2*fd*r - 960*C*D1**2*f**2*fd*s**2 + 960*C*D1**2*f**2*fd*s - 320*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 1280*C*D1*Dd*f**3*r*s + 320*C*D1*Dd*f**3*r - 1280*C*D1*Dd*f**3*s**2 + 1280*C*D1*Dd*f**3*s - 320*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r*s + 180*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s - 384*D1**2*b2*f*fd*r*s + 192*D1**2*b2*f*fd*r - 384*D1**2*b2*f*fd*s**2 + 384*D1**2*b2*f*fd*s - 192*D1**2*b2*f*fd + 360*D1**2*b2*f*fdd*r*s - 180*D1**2*b2*f*fdd*r + 360*D1**2*b2*f*fdd*s**2 - 360*D1**2*b2*f*fdd*s + 180*D1**2*b2*f*fdd + 360*D1**2*b2*fd**2*r*s - 180*D1**2*b2*fd**2*r + 360*D1**2*b2*fd**2*s**2 - 360*D1**2*b2*fd**2*s - 2*D1**2*bd1**2*(30*f**2*(r**2 + r*(6*s - 5) + 5*s**2 - 10*s + 3) - 7*f*(r**2*(17*K - 23) + r*(C*(12 - 24*s) + 30*K*s - 17*K - 66*s + 29) + s**2*(-24*C + 13*K - 43) + s*(24*C - 15*K + 57) - 18) - 140*g2*(r*(2*s - 1) + s*(2*s - 2))) - 192*D1**2*bd2*f**2*r*s - 192*D1**2*bd2*f**2*s**2 + 192*D1**2*bd2*f**2*s + 720*D1**2*bd2*f*fd*r*s - 180*D1**2*bd2*f*fd*r + 720*D1**2*bd2*f*fd*s**2 - 720*D1**2*bd2*f*fd*s + 180*D1**2*bd2*f*fd + 405*D1**2*bdd1*f**3*r**2 + 960*D1**2*bdd1*f**3*r*s - 480*D1**2*bdd1*f**3*r + 555*D1**2*bdd1*f**3*s**2 - 660*D1**2*bdd1*f**3*s + 240*D1**2*bdd1*f**3 + 60*D1**2*bdd1*f**2*r**2 + 252*D1**2*bdd1*f**2*r*s - 420*D1**2*bdd1*f**2*r + 192*D1**2*bdd1*f**2*s**2 - 492*D1**2*bdd1*f**2*s + 120*D1**2*bdd1*f**2 - 238*D1**2*bdd1*f*g2*r**2 - 420*D1**2*bdd1*f*g2*r*s - 182*D1**2*bdd1*f*g2*s**2 + 180*D1**2*bdd2*f**2*r*s + 180*D1**2*bdd2*f**2*s**2 - 180*D1**2*bdd2*f**2*s - 750*D1**2*f**2*fd*r**2 - 1950*D1**2*f**2*fd*r*s + 1150*D1**2*f**2*fd*r - 1200*D1**2*f**2*fd*s**2 + 1450*D1**2*f**2*fd*s - 650*D1**2*f**2*fd + 780*D1**2*f**2*fdd*r**2 + 1560*D1**2*f**2*fdd*r*s - 1040*D1**2*f**2*fdd*r + 780*D1**2*f**2*fdd*s**2 - 1040*D1**2*f**2*fdd*s + 520*D1**2*f**2*fdd + 384*D1**2*f**2*gd2*r*s + 384*D1**2*f**2*gd2*s**2 - 384*D1**2*f**2*gd2*s - 360*D1**2*f**2*gdd2*r*s - 360*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s + 1560*D1**2*f*fd**2*r**2 + 3120*D1**2*f*fd**2*r*s - 2080*D1**2*f*fd**2*r + 1560*D1**2*f*fd**2*s**2 - 2080*D1**2*f*fd**2*s + 520*D1**2*f*fd**2 + 768*D1**2*f*fd*g2*r*s - 384*D1**2*f*fd*g2*r + 768*D1**2*f*fd*g2*s**2 - 768*D1**2*f*fd*g2*s + 384*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r*s + 360*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 1440*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s - 768*D1*Dd*b2*f**2*r*s + 192*D1*Dd*b2*f**2*r - 768*D1*Dd*b2*f**2*s**2 + 768*D1*Dd*b2*f**2*s - 192*D1*Dd*b2*f**2 + 2880*D1*Dd*b2*f*fd*r*s - 1080*D1*Dd*b2*f*fd*r + 2880*D1*Dd*b2*f*fd*s**2 - 2880*D1*Dd*b2*f*fd*s + 720*D1*Dd*b2*f*fd + 1440*D1*Dd*bd2*f**2*r*s - 180*D1*Dd*bd2*f**2*r + 1440*D1*Dd*bd2*f**2*s**2 - 1440*D1*Dd*bd2*f**2*s + 180*D1*Dd*bd2*f**2 - 1000*D1*Dd*f**3*r**2 - 2600*D1*Dd*f**3*r*s + 1650*D1*Dd*f**3*r - 1600*D1*Dd*f**3*s**2 + 2100*D1*Dd*f**3*s - 900*D1*Dd*f**3 + 6240*D1*Dd*f**2*fd*r**2 + 12480*D1*Dd*f**2*fd*r*s - 8840*D1*Dd*f**2*fd*r + 6240*D1*Dd*f**2*fd*s**2 - 8840*D1*Dd*f**2*fd*s + 3120*D1*Dd*f**2*fd + 1536*D1*Dd*f**2*g2*r*s - 384*D1*Dd*f**2*g2*r + 1536*D1*Dd*f**2*g2*s**2 - 1536*D1*Dd*f**2*g2*s + 384*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r*s + 360*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 2880*D1*Dd*f**2*gd2*s - 360*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r*s + 2160*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 5760*D1*Dd*f*fd*g2*s - 1440*D1*Dd*f*fd*g2 + 720*D1*Ddd*b2*f**2*r*s - 180*D1*Ddd*b2*f**2*r + 720*D1*Ddd*b2*f**2*s**2 - 720*D1*Ddd*b2*f**2*s + 180*D1*Ddd*b2*f**2 + 1040*D1*Ddd*f**3*r**2 + 2080*D1*Ddd*f**3*r*s - 1560*D1*Ddd*f**3*r + 1040*D1*Ddd*f**3*s**2 - 1560*D1*Ddd*f**3*s + 780*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r*s + 360*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 1440*D1*Ddd*f**2*g2*s - 360*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-15*f**3*(21*r**2 + 4*r*(19*s - 6) + 55*s**2 - 52*s + 12) + 6*f**2*(-65*C*s**2 - 32*K*s**2 + 32*K*s + 5*fd*(81*r**2 + 2*r*(96*s - 59) + 111*s**2 - 145*s + 38) - r**2*(21*C + 13) - r*s*(86*C + 32*K + 21) + 28*r - 8*s**2 + 73*s + 9) + 2*f*(6*fd*(30*C*s**2 - 40*C*s + 15*K*(r*(4*s - 1) + (1 - 2*s)**2) + r**2*(70*C + 20) + 2*r*(50*C*s - 30*C + 42*s - 33) + 64*s**2 - 94*s + 56) - 7*g2*(r**2 - 50*r*s - 51*s**2) - 7*gd2*(34*r**2 + r*(60*s - 34) + 2*s*(13*s - 15))) - 28*fd*g2*(17*r**2 + 15*r*(2*s - 1) + s*(13*s - 13))) + 2*Dd*f*(15*f**2*(108*r**2 + 2*r*(128*s - 75) + 148*s**2 - 189*s + 54) + 6*f*(60*C*s**2 - 65*C*s + 15*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + r**2*(140*C + 40) + r*(200*C*s - 95*C + 168*s - 181) + 128*s**2 - 238*s + 111) - 14*g2*(68*r**2 + r*(120*s - 49) + s*(52*s - 43)))) + 2160*Dd**2*b2*f**2*r*s - 540*Dd**2*b2*f**2*r + 2160*Dd**2*b2*f**2*s**2 - 2160*Dd**2*b2*f**2*s + 360*Dd**2*b2*f**2 + 3120*Dd**2*f**3*r**2 + 6240*Dd**2*f**3*r*s - 4680*Dd**2*f**3*r + 3120*Dd**2*f**3*s**2 - 4680*Dd**2*f**3*s + 1560*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r*s + 1080*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 4320*Dd**2*f**2*g2*s - 720*Dd**2*f**2*g2 + 140*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(336*C*D1**2*fd*r*s + 336*C*D1**2*fd*s**2 - 336*C*D1**2*fd*s - 168*C*D1**2*fdd*r*s - 168*C*D1**2*fdd*s**2 + 168*C*D1**2*fdd*s + 1344*C*D1*Dd*f*r*s - 336*C*D1*Dd*f*r + 1344*C*D1*Dd*f*s**2 - 1344*C*D1*Dd*f*s + 336*C*D1*Dd*f - 1344*C*D1*Dd*fd*r*s + 168*C*D1*Dd*fd*r - 1344*C*D1*Dd*fd*s**2 + 1344*C*D1*Dd*fd*s - 168*C*D1*Dd*fd - 672*C*D1*Ddd*f*r*s + 168*C*D1*Ddd*f*r - 672*C*D1*Ddd*f*s**2 + 672*C*D1*Ddd*f*s - 168*C*D1*Ddd*f - 2016*C*Dd**2*f*r*s + 504*C*Dd**2*f*r - 2016*C*Dd**2*f*s**2 + 2016*C*Dd**2*f*s - 336*C*Dd**2*f + 7*D1**2*K*fd*r**2 - 350*D1**2*K*fd*r*s + 350*D1**2*K*fd*r - 357*D1**2*K*fd*s**2 + 714*D1**2*K*fd*s - 357*D1**2*K*fd + 119*D1**2*K*fdd*r**2 + 210*D1**2*K*fdd*r*s - 210*D1**2*K*fdd*r + 91*D1**2*K*fdd*s**2 - 182*D1**2*K*fdd*s + 91*D1**2*K*fdd - 140*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 36*D1**2*f*fd*r**2 + 552*D1**2*f*fd*r*s + 84*D1**2*f*fd*r + 516*D1**2*f*fd*s**2 - 120*D1**2*f*fd*s - 120*D1**2*f*fd - 60*D1**2*f*fdd*r**2 - 360*D1**2*f*fdd*r*s - 300*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s + 60*D1**2*f*fdd - 60*D1**2*fd**2*r**2 - 360*D1**2*fd**2*r*s - 300*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s + 60*D1**2*fd**2 + 7*D1**2*fd*r**2 + 434*D1**2*fd*r*s - 406*D1**2*fd*r + 427*D1**2*fd*s**2 - 462*D1**2*fd*s + 399*D1**2*fd - 161*D1**2*fdd*r**2 - 462*D1**2*fdd*r*s + 378*D1**2*fdd*r - 301*D1**2*fdd*s**2 + 266*D1**2*fdd*s - 217*D1**2*fdd - 560*D1**2*gd2*r*s - 560*D1**2*gd2*s**2 + 560*D1**2*gd2*s + 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*s**2 - 280*D1**2*gdd2*s + 28*D1*Dd*K*f*r**2 - 1400*D1*Dd*K*f*r*s + 322*D1*Dd*K*f*r - 1428*D1*Dd*K*f*s**2 + 1414*D1*Dd*K*f*s - 343*D1*Dd*K*f + 952*D1*Dd*K*fd*r**2 + 1680*D1*Dd*K*fd*r*s - 1526*D1*Dd*K*fd*r + 728*D1*Dd*K*fd*s**2 - 1330*D1*Dd*K*fd*s + 602*D1*Dd*K*fd + 72*D1*Dd*f**2*r**2 + 1104*D1*Dd*f**2*r*s - 348*D1*Dd*f**2*r + 1032*D1*Dd*f**2*s**2 - 1068*D1*Dd*f**2*s + 294*D1*Dd*f**2 - 480*D1*Dd*f*fd*r**2 - 2880*D1*Dd*f*fd*r*s + 600*D1*Dd*f*fd*r - 2400*D1*Dd*f*fd*s**2 + 1560*D1*Dd*f*fd*s - 60*D1*Dd*f*fd + 28*D1*Dd*f*r**2 + 1736*D1*Dd*f*r*s - 462*D1*Dd*f*r + 1708*D1*Dd*f*s**2 - 1722*D1*Dd*f*s + 441*D1*Dd*f - 1288*D1*Dd*fd*r**2 - 3696*D1*Dd*fd*r*s + 2618*D1*Dd*fd*r - 2408*D1*Dd*fd*s**2 + 2590*D1*Dd*fd*s - 1022*D1*Dd*fd - 2240*D1*Dd*g2*r*s + 560*D1*Dd*g2*r - 2240*D1*Dd*g2*s**2 + 2240*D1*Dd*g2*s - 560*D1*Dd*g2 + 2240*D1*Dd*gd2*r*s - 280*D1*Dd*gd2*r + 2240*D1*Dd*gd2*s**2 - 2240*D1*Dd*gd2*s + 280*D1*Dd*gd2 + 476*D1*Ddd*K*f*r**2 + 840*D1*Ddd*K*f*r*s - 686*D1*Ddd*K*f*r + 364*D1*Ddd*K*f*s**2 - 602*D1*Ddd*K*f*s + 329*D1*Ddd*K*f - 120*D1*Ddd*f**2*r**2 - 720*D1*Ddd*f**2*r*s + 300*D1*Ddd*f**2*r - 600*D1*Ddd*f**2*s**2 + 660*D1*Ddd*f**2*s - 210*D1*Ddd*f**2 - 644*D1*Ddd*f*r**2 - 1848*D1*Ddd*f*r*s + 1106*D1*Ddd*f*r - 1204*D1*Ddd*f*s**2 + 1526*D1*Ddd*f*s - 623*D1*Ddd*f + 1120*D1*Ddd*g2*r*s - 280*D1*Ddd*g2*r + 1120*D1*Ddd*g2*s**2 - 1120*D1*Ddd*g2*s + 280*D1*Ddd*g2 + 140*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 1428*Dd**2*K*f*r**2 + 2520*Dd**2*K*f*r*s - 2058*Dd**2*K*f*r + 1092*Dd**2*K*f*s**2 - 1806*Dd**2*K*f*s + 658*Dd**2*K*f - 360*Dd**2*f**2*r**2 - 2160*Dd**2*f**2*r*s + 900*Dd**2*f**2*r - 1800*Dd**2*f**2*s**2 + 1980*Dd**2*f**2*s - 420*Dd**2*f**2 - 1932*Dd**2*f*r**2 - 5544*Dd**2*f*r*s + 3318*Dd**2*f*r - 3612*Dd**2*f*s**2 + 4578*Dd**2*f*s - 1246*Dd**2*f + 3360*Dd**2*g2*r*s - 840*Dd**2*g2*r + 3360*Dd**2*g2*s**2 - 3360*Dd**2*g2*s + 560*Dd**2*g2) + b1*(-252*C*D1**2*f*fd*r**2 - 1032*C*D1**2*f*fd*r*s + 768*C*D1**2*f*fd*r - 780*C*D1**2*f*fd*s**2 + 1296*C*D1**2*f*fd*s - 516*C*D1**2*f*fd + 420*C*D1**2*f*fdd*r**2 + 600*C*D1**2*f*fdd*r*s - 720*C*D1**2*f*fdd*r + 180*C*D1**2*f*fdd*s**2 - 480*C*D1**2*f*fdd*s + 300*C*D1**2*f*fdd + 420*C*D1**2*fd**2*r**2 + 600*C*D1**2*fd**2*r*s - 720*C*D1**2*fd**2*r + 180*C*D1**2*fd**2*s**2 - 480*C*D1**2*fd**2*s + 300*C*D1**2*fd**2 - 504*C*D1*Dd*f**2*r**2 - 2064*C*D1*Dd*f**2*r*s + 1020*C*D1*Dd*f**2*r - 1560*C*D1*Dd*f**2*s**2 + 1812*C*D1*Dd*f**2*s - 642*C*D1*Dd*f**2 + 3360*C*D1*Dd*f*fd*r**2 + 4800*C*D1*Dd*f*fd*r*s - 5160*C*D1*Dd*f*fd*r + 1440*C*D1*Dd*f*fd*s**2 - 3480*C*D1*Dd*f*fd*s + 1920*C*D1*Dd*f*fd + 840*C*D1*Ddd*f**2*r**2 + 1200*C*D1*Ddd*f**2*r*s - 1140*C*D1*Ddd*f**2*r + 360*C*D1*Ddd*f**2*s**2 - 780*C*D1*Ddd*f**2*s + 510*C*D1*Ddd*f**2 + 2520*C*Dd**2*f**2*r**2 + 3600*C*Dd**2*f**2*r*s - 3420*C*Dd**2*f**2*r + 1080*C*Dd**2*f**2*s**2 - 2340*C*Dd**2*f**2*s + 1020*C*Dd**2*f**2 - 384*D1**2*K*f*fd*r*s + 192*D1**2*K*f*fd*r - 384*D1**2*K*f*fd*s**2 + 384*D1**2*K*f*fd*s - 192*D1**2*K*f*fd + 360*D1**2*K*f*fdd*r*s - 180*D1**2*K*f*fdd*r + 360*D1**2*K*f*fdd*s**2 - 360*D1**2*K*f*fdd*s + 180*D1**2*K*f*fdd + 360*D1**2*K*fd**2*r*s - 180*D1**2*K*fd**2*r + 360*D1**2*K*fd**2*s**2 - 360*D1**2*K*fd**2*s - 140*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - D1**2*bdd1*(30*f**2*(2*r**2 + 2*r*(6*s - 5) + 10*s**2 - 20*s + 9) + 7*f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - K*(34*r**2 + 60*r*s - 34*r + 26*s**2 - 30*s + 17) + 46*r**2 + 132*r*s - 58*r + 86*s**2 - 114*s + 35) - 280*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 945*D1**2*f**2*fd*r**2 - 3420*D1**2*f**2*fd*r*s + 2040*D1**2*f**2*fd*r - 2475*D1**2*f**2*fd*s**2 + 3150*D1**2*f**2*fd*s - 1275*D1**2*f**2*fd + 1215*D1**2*f**2*fdd*r**2 + 2880*D1**2*f**2*fdd*r*s - 2100*D1**2*f**2*fdd*r + 1665*D1**2*f**2*fdd*s**2 - 2370*D1**2*f**2*fdd*s + 1125*D1**2*f**2*fdd + 2430*D1**2*f*fd**2*r**2 + 5760*D1**2*f*fd**2*r*s - 4200*D1**2*f*fd**2*r + 3330*D1**2*f*fd**2*s**2 - 4740*D1**2*f*fd**2*s + 1590*D1**2*f*fd**2 - 156*D1**2*f*fd*r**2 - 252*D1**2*f*fd*r*s + 114*D1**2*f*fd*r - 96*D1**2*f*fd*s**2 - 216*D1**2*f*fd*s - 180*D1**2*f*fd + 120*D1**2*f*fdd*r**2 + 504*D1**2*f*fdd*r*s + 48*D1**2*f*fdd*r + 384*D1**2*f*fdd*s**2 - 144*D1**2*f*fdd*s + 132*D1**2*f*fdd - 14*D1**2*f*gd2*r**2 + 700*D1**2*f*gd2*r*s + 28*D1**2*f*gd2*r + 714*D1**2*f*gd2*s**2 - 700*D1**2*f*gd2*s - 14*D1**2*f*gd2 - 238*D1**2*f*gdd2*r**2 - 420*D1**2*f*gdd2*r*s + 476*D1**2*f*gdd2*r - 182*D1**2*f*gdd2*s**2 + 420*D1**2*f*gdd2*s - 238*D1**2*f*gdd2 + 120*D1**2*fd**2*r**2 + 504*D1**2*fd**2*r*s + 48*D1**2*fd**2*r + 384*D1**2*fd**2*s**2 - 144*D1**2*fd**2*s - 420*D1**2*fd**2 - 14*D1**2*fd*g2*r**2 + 700*D1**2*fd*g2*r*s - 700*D1**2*fd*g2*r + 714*D1**2*fd*g2*s**2 - 1428*D1**2*fd*g2*s + 714*D1**2*fd*g2 - 476*D1**2*fd*gd2*r**2 - 840*D1**2*fd*gd2*r*s + 896*D1**2*fd*gd2*r - 364*D1**2*fd*gd2*s**2 + 784*D1**2*fd*gd2*s - 420*D1**2*fd*gd2 - 238*D1**2*fdd*g2*r**2 - 420*D1**2*fdd*g2*r*s + 420*D1**2*fdd*g2*r - 182*D1**2*fdd*g2*s**2 + 364*D1**2*fdd*g2*s - 182*D1**2*fdd*g2 - 768*D1*Dd*K*f**2*r*s + 192*D1*Dd*K*f**2*r - 768*D1*Dd*K*f**2*s**2 + 768*D1*Dd*K*f**2*s - 192*D1*Dd*K*f**2 + 2880*D1*Dd*K*f*fd*r*s - 1080*D1*Dd*K*f*fd*r + 2880*D1*Dd*K*f*fd*s**2 - 2880*D1*Dd*K*f*fd*s + 720*D1*Dd*K*f*fd - 1260*D1*Dd*f**3*r**2 - 4560*D1*Dd*f**3*r*s + 2400*D1*Dd*f**3*r - 3300*D1*Dd*f**3*s**2 + 3930*D1*Dd*f**3*s - 1455*D1*Dd*f**3 + 9720*D1*Dd*f**2*fd*r**2 + 23040*D1*Dd*f**2*fd*r*s - 16140*D1*Dd*f**2*fd*r + 13320*D1*Dd*f**2*fd*s**2 - 18570*D1*Dd*f**2*fd*s + 6570*D1*Dd*f**2*fd - 312*D1*Dd*f**2*r**2 - 504*D1*Dd*f**2*r*s + 438*D1*Dd*f**2*r - 192*D1*Dd*f**2*s**2 + 348*D1*Dd*f**2*s - 204*D1*Dd*f**2 + 960*D1*Dd*f*fd*r**2 + 4032*D1*Dd*f*fd*r*s - 792*D1*Dd*f*fd*r + 3072*D1*Dd*f*fd*s**2 - 2352*D1*Dd*f*fd*s + 48*D1*Dd*f*fd - 56*D1*Dd*f*g2*r**2 + 2800*D1*Dd*f*g2*r*s - 644*D1*Dd*f*g2*r + 2856*D1*Dd*f*g2*s**2 - 2828*D1*Dd*f*g2*s + 686*D1*Dd*f*g2 - 1904*D1*Dd*f*gd2*r**2 - 3360*D1*Dd*f*gd2*r*s + 3276*D1*Dd*f*gd2*r - 1456*D1*Dd*f*gd2*s**2 + 2884*D1*Dd*f*gd2*s - 1372*D1*Dd*f*gd2 - 1904*D1*Dd*fd*g2*r**2 - 3360*D1*Dd*fd*g2*r*s + 3052*D1*Dd*fd*g2*r - 1456*D1*Dd*fd*g2*s**2 + 2660*D1*Dd*fd*g2*s - 1204*D1*Dd*fd*g2 + 720*D1*Ddd*K*f**2*r*s - 180*D1*Ddd*K*f**2*r + 720*D1*Ddd*K*f**2*s**2 - 720*D1*Ddd*K*f**2*s + 180*D1*Ddd*K*f**2 + 1620*D1*Ddd*f**3*r**2 + 3840*D1*Ddd*f**3*r*s - 2580*D1*Ddd*f**3*r + 2220*D1*Ddd*f**3*s**2 - 3030*D1*Ddd*f**3*s + 1365*D1*Ddd*f**3 + 240*D1*Ddd*f**2*r**2 + 1008*D1*Ddd*f**2*r*s - 492*D1*Ddd*f**2*r + 768*D1*Ddd*f**2*s**2 - 888*D1*Ddd*f**2*s + 312*D1*Ddd*f**2 - 952*D1*Ddd*f*g2*r**2 - 1680*D1*Ddd*f*g2*r*s + 1372*D1*Ddd*f*g2*r - 728*D1*Ddd*f*g2*s**2 + 1204*D1*Ddd*f*g2*s - 658*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(6*r**2 + r*(92*s - 72) + 86*s**2 - 158*s + 69) + f*(336*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 7*K*(2*r**2 - 2*r*(50*s + 1) - 102*s**2 + 50*s + 1) - 60*fd*(4*r**2 + 2*r*(12*s - 5) + 20*s**2 - 22*s + 5) + 14*r**2 + 868*r*s - 42*r + 854*s**2 - 826*s + 35) - 14*fd*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(34*r**2 + 60*r*s - 47*r + 26*s**2 - 41*s + 15) + 46*r**2 + 132*r*s - 83*r + 86*s**2 - 95*s + 15) - 280*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 280*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd*(60*f**2*(4*r**2 + 3*r*(8*s - 5) + 20*s**2 - 31*s + 10) + 7*f*(24*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - K*(136*r**2 + 240*r*s - 166*r + 104*s**2 - 146*s + 49) + 184*r**2 + 528*r*s - 274*r + 344*s**2 - 446*s + 115) - 280*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 2160*Dd**2*K*f**2*r*s - 540*Dd**2*K*f**2*r + 2160*Dd**2*K*f**2*s**2 - 2160*Dd**2*K*f**2*s + 360*Dd**2*K*f**2 + 4860*Dd**2*f**3*r**2 + 11520*Dd**2*f**3*r*s - 7740*Dd**2*f**3*r + 6660*Dd**2*f**3*s**2 - 9090*Dd**2*f**3*s + 2730*Dd**2*f**3 + 720*Dd**2*f**2*r**2 + 3024*Dd**2*f**2*r*s - 1476*Dd**2*f**2*r + 2304*Dd**2*f**2*s**2 - 2664*Dd**2*f**2*s + 624*Dd**2*f**2 - 2856*Dd**2*f*g2*r**2 - 5040*Dd**2*f*g2*r*s + 4116*Dd**2*f*g2*r - 2184*Dd**2*f*g2*s**2 + 3612*Dd**2*f*g2*s - 1316*Dd**2*f*g2))/(210*d**2*k3**3) + 4*D1**2*Pk2*Pkd3*ct**4*k1**2*(-3*D1*f*(D1*bd1**2*s*(5*f + 7)*(2*r + 2*s - 1) + D1*bd1*(-3*f*s*(r + s) + 5*fd*(r*(4*s - 1) + s*(4*s - 3))) + 5*D1*bdd1*f*s*(r + s) + 5*Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + b1**2*(-D1**2*(r + s - 1)*(15*fd**2*(2*s - 1) + fd*(f*(9 - 18*s) - 7*s + 7) + 3*fdd*(10*f*s - 5*f + 7*s - 7)) + D1*(Dd*(9*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-15*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 7*r*(4*s - 1) + 7*(1 - 2*s)**2) - 21*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*Ddd*f*(5*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(7*bdd1*s*(2*r + 2*s - 1) - 3*fd*(2*s - 1)*(r + s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) + 5*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(f*s*(9*f + 7)*(2*r + 2*s - 1) - 3*fd*(5*f*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + 28*r*s - 14*r + 28*s**2 - 35*s + 7)) - 3*Dd*f*(5*f + 7)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) - 3*D1*f*(Dd*(-3*f*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2**2*k3) + 3*D1**2*Pk2*Pkd3*ct**4*k2**6*st**2*(D1**2*(f**2*(fd*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-9*K*(-2*bd1 + bdd1) - 36*gd2 + 18*gdd2)) + f*(-fd**2*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 18*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 18*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(10*C - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(5 - 10*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 18*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 18*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 9*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(10*C*f + 9*K*b1 - 5*f - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(10*C*f + 9*K*b1 - 5*f - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(14*d**2*k3**7) + 9*D1**2*Pk2*Pkd3*ct**4*k2**6*(40*C*D1**2*b1*f*fd*r**2 + 80*C*D1**2*b1*f*fd*r*s - 40*C*D1**2*b1*f*fd*r + 40*C*D1**2*b1*f*fd*s**2 - 40*C*D1**2*b1*f*fd*s + 20*C*D1**2*b1*f*fd - 20*C*D1**2*b1*f*fdd*r**2 - 40*C*D1**2*b1*f*fdd*r*s + 20*C*D1**2*b1*f*fdd*r - 20*C*D1**2*b1*f*fdd*s**2 + 20*C*D1**2*b1*f*fdd*s - 10*C*D1**2*b1*f*fdd - 20*C*D1**2*b1*fd**2*r**2 - 40*C*D1**2*b1*fd**2*r*s + 20*C*D1**2*b1*fd**2*r - 20*C*D1**2*b1*fd**2*s**2 + 20*C*D1**2*b1*fd**2*s - 30*C*D1**2*f**2*fd*r**2 - 60*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 80*C*D1*Dd*b1*f**2*r**2 + 160*C*D1*Dd*b1*f**2*r*s - 120*C*D1*Dd*b1*f**2*r + 80*C*D1*Dd*b1*f**2*s**2 - 120*C*D1*Dd*b1*f**2*s + 60*C*D1*Dd*b1*f**2 - 160*C*D1*Dd*b1*f*fd*r**2 - 320*C*D1*Dd*b1*f*fd*r*s + 200*C*D1*Dd*b1*f*fd*r - 160*C*D1*Dd*b1*f*fd*s**2 + 200*C*D1*Dd*b1*f*fd*s - 60*C*D1*Dd*b1*f*fd - 40*C*D1*Dd*f**3*r**2 - 80*C*D1*Dd*f**3*r*s + 60*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 60*C*D1*Dd*f**3*s - 30*C*D1*Dd*f**3 - 40*C*D1*Ddd*b1*f**2*r**2 - 80*C*D1*Ddd*b1*f**2*r*s + 60*C*D1*Ddd*b1*f**2*r - 40*C*D1*Ddd*b1*f**2*s**2 + 60*C*D1*Ddd*b1*f**2*s - 30*C*D1*Ddd*b1*f**2 - 120*C*Dd**2*b1*f**2*r**2 - 240*C*Dd**2*b1*f**2*r*s + 180*C*Dd**2*b1*f**2*r - 120*C*Dd**2*b1*f**2*s**2 + 180*C*Dd**2*b1*f**2*s - 60*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r**2 + 28*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r**2 - 14*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 14*D1**2*K*bd1**2*f*(r + s - 1)**2 - 20*D1**2*b1*f*fd*r**2 - 40*D1**2*b1*f*fd*r*s + 20*D1**2*b1*f*fd*r - 20*D1**2*b1*f*fd*s**2 + 20*D1**2*b1*f*fd*s - 10*D1**2*b1*f*fd + 10*D1**2*b1*f*fdd*r**2 + 20*D1**2*b1*f*fdd*r*s - 10*D1**2*b1*f*fdd*r + 10*D1**2*b1*f*fdd*s**2 - 10*D1**2*b1*f*fdd*s + 5*D1**2*b1*f*fdd - 28*D1**2*b1*f*gd2*r**2 - 56*D1**2*b1*f*gd2*r*s + 56*D1**2*b1*f*gd2*r - 28*D1**2*b1*f*gd2*s**2 + 56*D1**2*b1*f*gd2*s - 28*D1**2*b1*f*gd2 + 14*D1**2*b1*f*gdd2*r**2 + 28*D1**2*b1*f*gdd2*r*s - 28*D1**2*b1*f*gdd2*r + 14*D1**2*b1*f*gdd2*s**2 - 28*D1**2*b1*f*gdd2*s + 14*D1**2*b1*f*gdd2 + 10*D1**2*b1*fd**2*r**2 + 20*D1**2*b1*fd**2*r*s - 10*D1**2*b1*fd**2*r + 10*D1**2*b1*fd**2*s**2 - 10*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r**2 - 56*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r**2 + 56*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*r + 28*D1**2*b1*fd*gd2*s**2 - 28*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r**2 + 28*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 14*K*b1 - 5*f - 14*g2) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r**2 + 112*D1*Dd*K*b1**2*f*r*s - 84*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 84*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r**2 - 112*D1*Dd*K*b1**2*fd*r*s + 42*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 42*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 - 40*D1*Dd*b1*f**2*r**2 - 80*D1*Dd*b1*f**2*r*s + 60*D1*Dd*b1*f**2*r - 40*D1*Dd*b1*f**2*s**2 + 60*D1*Dd*b1*f**2*s - 30*D1*Dd*b1*f**2 + 80*D1*Dd*b1*f*fd*r**2 + 160*D1*Dd*b1*f*fd*r*s - 100*D1*Dd*b1*f*fd*r + 80*D1*Dd*b1*f*fd*s**2 - 100*D1*Dd*b1*f*fd*s + 30*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r**2 - 224*D1*Dd*b1*f*g2*r*s + 168*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 168*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r**2 + 224*D1*Dd*b1*f*gd2*r*s - 196*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 196*D1*Dd*b1*f*gd2*s + 84*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r**2 + 224*D1*Dd*b1*fd*g2*r*s - 84*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 84*D1*Dd*b1*fd*g2*s + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r**2 - 56*D1*Ddd*K*b1**2*f*r*s + 42*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 42*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 20*D1*Ddd*b1*f**2*r**2 + 40*D1*Ddd*b1*f**2*r*s - 30*D1*Ddd*b1*f**2*r + 20*D1*Ddd*b1*f**2*s**2 - 30*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r**2 + 112*D1*Ddd*b1*f*g2*r*s - 84*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 84*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(20*C - 7*K - 10)*(r + s - 1) - f*fd*(20*C - 10)*(2*r + 2*s - 1) - 28*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(10*C*f + 14*K*b1 - 5*f - 14*g2))*(r + s - 1) - 84*Dd**2*K*b1**2*f*r**2 - 168*Dd**2*K*b1**2*f*r*s + 126*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 126*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 60*Dd**2*b1*f**2*r**2 + 120*Dd**2*b1*f**2*r*s - 90*Dd**2*b1*f**2*r + 60*Dd**2*b1*f**2*s**2 - 90*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r**2 + 336*Dd**2*b1*f*g2*r*s - 252*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 252*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(70*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**4*k2**4*st**2*(-10212*C*D1**2*f**2*fd*r**2 - 14712*C*D1**2*f**2*fd*r*s + 11712*C*D1**2*f**2*fd*r - 4500*C*D1**2*f**2*fd*s**2 + 7904*C*D1**2*f**2*fd*s - 4904*C*D1**2*f**2*fd + 5970*C*D1**2*f**2*fdd*r**2 + 8220*C*D1**2*f**2*fdd*r*s - 6720*C*D1**2*f**2*fdd*r + 2250*C*D1**2*f**2*fdd*s**2 - 4240*C*D1**2*f**2*fdd*s + 2740*C*D1**2*f**2*fdd + 11940*C*D1**2*f*fd**2*r**2 + 16440*C*D1**2*f*fd**2*r*s - 13440*C*D1**2*f*fd**2*r + 4500*C*D1**2*f*fd**2*s**2 - 8480*C*D1**2*f*fd**2*s + 2740*C*D1**2*f*fd**2 - 13616*C*D1*Dd*f**3*r**2 - 19616*C*D1*Dd*f**3*r*s + 18520*C*D1*Dd*f**3*r - 6000*C*D1*Dd*f**3*s**2 + 12808*C*D1*Dd*f**3*s - 8308*C*D1*Dd*f**3 + 47760*C*D1*Dd*f**2*fd*r**2 + 65760*C*D1*Dd*f**2*fd*r*s - 58980*C*D1*Dd*f**2*fd*r + 18000*C*D1*Dd*f**2*fd*s**2 - 37900*C*D1*Dd*f**2*fd*s + 17680*C*D1*Dd*f**2*fd + 7960*C*D1*Ddd*f**3*r**2 + 10960*C*D1*Ddd*f**3*r*s - 10700*C*D1*Ddd*f**3*r + 3000*C*D1*Ddd*f**3*s**2 - 6980*C*D1*Ddd*f**3*s + 4730*C*D1*Ddd*f**3 + 23880*C*Dd**2*f**3*r**2 + 32880*C*Dd**2*f**3*r*s - 32100*C*Dd**2*f**3*r + 9000*C*Dd**2*f**3*s**2 - 20940*C*Dd**2*f**3*s + 9460*C*Dd**2*f**3 - 4860*D1**2*K*b1*f*fd*r**2 - 7560*D1**2*K*b1*f*fd*r*s + 3780*D1**2*K*b1*f*fd*r - 2700*D1**2*K*b1*f*fd*s**2 + 2700*D1**2*K*b1*f*fd*s - 1350*D1**2*K*b1*f*fd + 2430*D1**2*K*b1*f*fdd*r**2 + 3780*D1**2*K*b1*f*fdd*r*s - 1890*D1**2*K*b1*f*fdd*r + 1350*D1**2*K*b1*f*fdd*s**2 - 1350*D1**2*K*b1*f*fdd*s + 675*D1**2*K*b1*f*fdd + 2430*D1**2*K*b1*fd**2*r**2 + 3780*D1**2*K*b1*fd**2*r*s - 1890*D1**2*K*b1*fd**2*r + 1350*D1**2*K*b1*fd**2*s**2 - 1350*D1**2*K*b1*fd**2*s + 1215*D1**2*K*bdd1*f**2*r**2 + 1890*D1**2*K*bdd1*f**2*r*s - 2430*D1**2*K*bdd1*f**2*r + 675*D1**2*K*bdd1*f**2*s**2 - 1890*D1**2*K*bdd1*f**2*s + 1215*D1**2*K*bdd1*f**2 + 810*D1**2*b1*f**2*fd*r**2 + 810*D1**2*b1*f**2*fd*r*s - 810*D1**2*b1*f**2*fd*r - 270*D1**2*b1*f**2*fd*s + 270*D1**2*b1*f**2*fd - 810*D1**2*b1*f**2*fdd*r**2 - 810*D1**2*b1*f**2*fdd*r*s + 810*D1**2*b1*f**2*fdd*r + 270*D1**2*b1*f**2*fdd*s - 270*D1**2*b1*f**2*fdd - 1620*D1**2*b1*f*fd**2*r**2 - 1620*D1**2*b1*f*fd**2*r*s + 1620*D1**2*b1*f*fd**2*r + 540*D1**2*b1*f*fd**2*s - 270*D1**2*b1*f*fd**2 + 1080*D1**2*b1*f*fd*r**2 + 1080*D1**2*b1*f*fd*r*s - 540*D1**2*b1*f*fd*r - 540*D1**2*b1*f*fdd*r**2 - 540*D1**2*b1*f*fdd*r*s + 270*D1**2*b1*f*fdd*r - 540*D1**2*b1*fd**2*r**2 - 540*D1**2*b1*fd**2*r*s + 270*D1**2*b1*fd**2*r - 2700*D1**2*b2*f*fd*r**2 - 5400*D1**2*b2*f*fd*r*s + 2700*D1**2*b2*f*fd*r - 2700*D1**2*b2*f*fd*s**2 + 2700*D1**2*b2*f*fd*s - 1350*D1**2*b2*f*fd + 1350*D1**2*b2*f*fdd*r**2 + 2700*D1**2*b2*f*fdd*r*s - 1350*D1**2*b2*f*fdd*r + 1350*D1**2*b2*f*fdd*s**2 - 1350*D1**2*b2*f*fdd*s + 675*D1**2*b2*f*fdd + 1350*D1**2*b2*fd**2*r**2 + 2700*D1**2*b2*fd**2*r*s - 1350*D1**2*b2*fd**2*r + 1350*D1**2*b2*fd**2*s**2 - 1350*D1**2*b2*fd**2*s - 270*D1**2*bdd1*f**3*r**2 - 270*D1**2*bdd1*f**3*r*s + 540*D1**2*bdd1*f**3*r + 270*D1**2*bdd1*f**3*s - 270*D1**2*bdd1*f**3 - 270*D1**2*bdd1*f**2*r**2 - 270*D1**2*bdd1*f**2*r*s + 540*D1**2*bdd1*f**2*r + 270*D1**2*bdd1*f**2*s - 270*D1**2*bdd1*f**2 + 675*D1**2*bdd2*f**2*r**2 + 1350*D1**2*bdd2*f**2*r*s - 1350*D1**2*bdd2*f**2*r + 675*D1**2*bdd2*f**2*s**2 - 1350*D1**2*bdd2*f**2*s + 675*D1**2*bdd2*f**2 + 6534*D1**2*f**2*fd*r**2 + 8784*D1**2*f**2*fd*r*s - 7284*D1**2*f**2*fd*r + 2250*D1**2*f**2*fd*s**2 - 4428*D1**2*f**2*fd*s + 2928*D1**2*f**2*fd - 3915*D1**2*f**2*fdd*r**2 - 5040*D1**2*f**2*fdd*r*s + 4290*D1**2*f**2*fdd*r - 1125*D1**2*f**2*fdd*s**2 + 2430*D1**2*f**2*fdd*s - 1680*D1**2*f**2*fdd + 4860*D1**2*f**2*gd2*r**2 + 7560*D1**2*f**2*gd2*r*s - 9720*D1**2*f**2*gd2*r + 2700*D1**2*f**2*gd2*s**2 - 7560*D1**2*f**2*gd2*s + 4860*D1**2*f**2*gd2 - 2430*D1**2*f**2*gdd2*r**2 - 3780*D1**2*f**2*gdd2*r*s + 4860*D1**2*f**2*gdd2*r - 1350*D1**2*f**2*gdd2*s**2 + 3780*D1**2*f**2*gdd2*s - 2430*D1**2*f**2*gdd2 - 7830*D1**2*f*fd**2*r**2 - 10080*D1**2*f*fd**2*r*s + 8580*D1**2*f*fd**2*r - 2250*D1**2*f*fd**2*s**2 + 4860*D1**2*f*fd**2*s - 1680*D1**2*f*fd**2 + 9720*D1**2*f*fd*g2*r**2 + 15120*D1**2*f*fd*g2*r*s - 7560*D1**2*f*fd*g2*r + 5400*D1**2*f*fd*g2*s**2 - 5400*D1**2*f*fd*g2*s + 2700*D1**2*f*fd*g2 - 9720*D1**2*f*fd*gd2*r**2 - 15120*D1**2*f*fd*gd2*r*s + 13500*D1**2*f*fd*gd2*r - 5400*D1**2*f*fd*gd2*s**2 + 10260*D1**2*f*fd*gd2*s - 3780*D1**2*f*fd*gd2 - 4860*D1**2*f*fdd*g2*r**2 - 7560*D1**2*f*fdd*g2*r*s + 3780*D1**2*f*fdd*g2*r - 2700*D1**2*f*fdd*g2*s**2 + 2700*D1**2*f*fdd*g2*s - 1350*D1**2*f*fdd*g2 - 4860*D1**2*fd**2*g2*r**2 - 7560*D1**2*fd**2*g2*r*s + 3780*D1**2*fd**2*g2*r - 2700*D1**2*fd**2*g2*s**2 + 2700*D1**2*fd**2*g2*s - 9720*D1*Dd*K*b1*f**2*r**2 - 15120*D1*Dd*K*b1*f**2*r*s + 13500*D1*Dd*K*b1*f**2*r - 5400*D1*Dd*K*b1*f**2*s**2 + 10260*D1*Dd*K*b1*f**2*s - 6210*D1*Dd*K*b1*f**2 + 19440*D1*Dd*K*b1*f*fd*r**2 + 30240*D1*Dd*K*b1*f*fd*r*s - 21060*D1*Dd*K*b1*f*fd*r + 10800*D1*Dd*K*b1*f*fd*s**2 - 15660*D1*Dd*K*b1*f*fd*s + 5130*D1*Dd*K*b1*f*fd + 1080*D1*Dd*b1*f**3*r**2 + 1080*D1*Dd*b1*f**3*r*s - 1350*D1*Dd*b1*f**3*r - 540*D1*Dd*b1*f**3*s + 540*D1*Dd*b1*f**3 - 6480*D1*Dd*b1*f**2*fd*r**2 - 6480*D1*Dd*b1*f**2*fd*r*s + 7290*D1*Dd*b1*f**2*fd*r + 2700*D1*Dd*b1*f**2*fd*s - 1890*D1*Dd*b1*f**2*fd + 2160*D1*Dd*b1*f**2*r**2 + 2160*D1*Dd*b1*f**2*r*s - 2700*D1*Dd*b1*f**2*r - 1080*D1*Dd*b1*f**2*s + 1080*D1*Dd*b1*f**2 - 4320*D1*Dd*b1*f*fd*r**2 - 4320*D1*Dd*b1*f*fd*r*s + 3780*D1*Dd*b1*f*fd*r + 1080*D1*Dd*b1*f*fd*s - 540*D1*Dd*b1*f*fd - 5400*D1*Dd*b2*f**2*r**2 - 10800*D1*Dd*b2*f**2*r*s + 8100*D1*Dd*b2*f**2*r - 5400*D1*Dd*b2*f**2*s**2 + 8100*D1*Dd*b2*f**2*s - 4050*D1*Dd*b2*f**2 + 10800*D1*Dd*b2*f*fd*r**2 + 21600*D1*Dd*b2*f*fd*r*s - 13500*D1*Dd*b2*f*fd*r + 10800*D1*Dd*b2*f*fd*s**2 - 13500*D1*Dd*b2*f*fd*s + 4050*D1*Dd*b2*f*fd + 8712*D1*Dd*f**3*r**2 + 11712*D1*Dd*f**3*r*s - 11640*D1*Dd*f**3*r + 3000*D1*Dd*f**3*s**2 - 7356*D1*Dd*f**3*s + 5106*D1*Dd*f**3 - 31320*D1*Dd*f**2*fd*r**2 - 40320*D1*Dd*f**2*fd*r*s + 37860*D1*Dd*f**2*fd*r - 9000*D1*Dd*f**2*fd*s**2 + 22050*D1*Dd*f**2*fd*s - 11010*D1*Dd*f**2*fd + 19440*D1*Dd*f**2*g2*r**2 + 30240*D1*Dd*f**2*g2*r*s - 27000*D1*Dd*f**2*g2*r + 10800*D1*Dd*f**2*g2*s**2 - 20520*D1*Dd*f**2*g2*s + 12420*D1*Dd*f**2*g2 - 19440*D1*Dd*f**2*gd2*r**2 - 30240*D1*Dd*f**2*gd2*r*s + 32940*D1*Dd*f**2*gd2*r - 10800*D1*Dd*f**2*gd2*s**2 + 25380*D1*Dd*f**2*gd2*s - 13500*D1*Dd*f**2*gd2 - 38880*D1*Dd*f*fd*g2*r**2 - 60480*D1*Dd*f*fd*g2*r*s + 42120*D1*Dd*f*fd*g2*r - 21600*D1*Dd*f*fd*g2*s**2 + 31320*D1*Dd*f*fd*g2*s - 10260*D1*Dd*f*fd*g2 + 4860*D1*Ddd*K*b1*f**2*r**2 + 7560*D1*Ddd*K*b1*f**2*r*s - 6750*D1*Ddd*K*b1*f**2*r + 2700*D1*Ddd*K*b1*f**2*s**2 - 5130*D1*Ddd*K*b1*f**2*s + 3105*D1*Ddd*K*b1*f**2 - 1080*D1*Ddd*b1*f**3*r**2 - 1080*D1*Ddd*b1*f**3*r*s + 1350*D1*Ddd*b1*f**3*r + 540*D1*Ddd*b1*f**3*s - 540*D1*Ddd*b1*f**3 - 1080*D1*Ddd*b1*f**2*r**2 - 1080*D1*Ddd*b1*f**2*r*s + 1350*D1*Ddd*b1*f**2*r + 540*D1*Ddd*b1*f**2*s - 540*D1*Ddd*b1*f**2 + 2700*D1*Ddd*b2*f**2*r**2 + 5400*D1*Ddd*b2*f**2*r*s - 4050*D1*Ddd*b2*f**2*r + 2700*D1*Ddd*b2*f**2*s**2 - 4050*D1*Ddd*b2*f**2*s + 2025*D1*Ddd*b2*f**2 - 5220*D1*Ddd*f**3*r**2 - 6720*D1*Ddd*f**3*r*s + 6900*D1*Ddd*f**3*r - 1500*D1*Ddd*f**3*s**2 + 4110*D1*Ddd*f**3*s - 2985*D1*Ddd*f**3 - 9720*D1*Ddd*f**2*g2*r**2 - 15120*D1*Ddd*f**2*g2*r*s + 13500*D1*Ddd*f**2*g2*r - 5400*D1*Ddd*f**2*g2*s**2 + 10260*D1*Ddd*f**2*g2*s - 6210*D1*Ddd*f**2*g2 + 270*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (r + s - 1)*(K*(9*r + 5*s - 9) - 2*r + 2)) + fd*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(K*(36*r**2 + 56*r*s - 61*r + 20*s**2 - 47*s + 25) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) - 1350*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 14580*Dd**2*K*b1*f**2*r**2 + 22680*Dd**2*K*b1*f**2*r*s - 20250*Dd**2*K*b1*f**2*r + 8100*Dd**2*K*b1*f**2*s**2 - 15390*Dd**2*K*b1*f**2*s + 6210*Dd**2*K*b1*f**2 - 3240*Dd**2*b1*f**3*r**2 - 3240*Dd**2*b1*f**3*r*s + 4050*Dd**2*b1*f**3*r + 1620*Dd**2*b1*f**3*s - 1080*Dd**2*b1*f**3 - 3240*Dd**2*b1*f**2*r**2 - 3240*Dd**2*b1*f**2*r*s + 4050*Dd**2*b1*f**2*r + 1620*Dd**2*b1*f**2*s - 1080*Dd**2*b1*f**2 + 8100*Dd**2*b2*f**2*r**2 + 16200*Dd**2*b2*f**2*r*s - 12150*Dd**2*b2*f**2*r + 8100*Dd**2*b2*f**2*s**2 - 12150*Dd**2*b2*f**2*s + 4050*Dd**2*b2*f**2 - 15660*Dd**2*f**3*r**2 - 20160*Dd**2*f**3*r*s + 20700*Dd**2*f**3*r - 4500*Dd**2*f**3*s**2 + 12330*Dd**2*f**3*s - 5970*Dd**2*f**3 - 29160*Dd**2*f**2*g2*r**2 - 45360*Dd**2*f**2*g2*r*s + 40500*Dd**2*f**2*g2*r - 16200*Dd**2*f**2*g2*s**2 + 30780*Dd**2*f**2*g2*s - 12420*Dd**2*f**2*g2)/(630*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**4*k2**4*(432*C*D1**2*bd1*f**2*r**2 + 672*C*D1**2*bd1*f**2*r*s - 1272*C*D1**2*bd1*f**2*r + 240*C*D1**2*bd1*f**2*s**2 - 1080*C*D1**2*bd1*f**2*s + 540*C*D1**2*bd1*f**2 - 864*C*D1**2*bd1*f*fd*r**2 - 1344*C*D1**2*bd1*f*fd*r*s + 1404*C*D1**2*bd1*f*fd*r - 480*C*D1**2*bd1*f*fd*s**2 + 1116*C*D1**2*bd1*f*fd*s - 636*C*D1**2*bd1*f*fd - 216*C*D1**2*bdd1*f**2*r**2 - 336*C*D1**2*bdd1*f**2*r*s + 636*C*D1**2*bdd1*f**2*r - 120*C*D1**2*bdd1*f**2*s**2 + 540*C*D1**2*bdd1*f**2*s - 270*C*D1**2*bdd1*f**2 - 60*C*D1**2*f**2*fd*r**2 + 120*C*D1**2*f**2*fd*r*s + 180*C*D1**2*f**2*fd*s**2 - 160*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd - 690*C*D1**2*f**2*fdd*r**2 - 1500*C*D1**2*f**2*fdd*r*s + 960*C*D1**2*f**2*fdd*r - 810*C*D1**2*f**2*fdd*s**2 + 1040*C*D1**2*f**2*fdd*s - 500*C*D1**2*f**2*fdd - 1380*C*D1**2*f*fd**2*r**2 - 3000*C*D1**2*f*fd**2*r*s + 1920*C*D1**2*f*fd**2*r - 1620*C*D1**2*f*fd**2*s**2 + 2080*C*D1**2*f*fd**2*s - 500*C*D1**2*f*fd**2 - 1728*C*D1*Dd*bd1*f**2*r**2 - 2688*C*D1*Dd*bd1*f**2*r*s + 3744*C*D1*Dd*bd1*f**2*r - 960*C*D1*Dd*bd1*f**2*s**2 + 3072*C*D1*Dd*bd1*f**2*s - 1812*C*D1*Dd*bd1*f**2 - 80*C*D1*Dd*f**3*r**2 + 160*C*D1*Dd*f**3*r*s + 40*C*D1*Dd*f**3*r + 240*C*D1*Dd*f**3*s**2 - 200*C*D1*Dd*f**3*s + 20*C*D1*Dd*f**3 - 5520*C*D1*Dd*f**2*fd*r**2 - 12000*C*D1*Dd*f**2*fd*r*s + 8100*C*D1*Dd*f**2*fd*r - 6480*C*D1*Dd*f**2*fd*s**2 + 8780*C*D1*Dd*f**2*fd*s - 2960*C*D1*Dd*f**2*fd - 920*C*D1*Ddd*f**3*r**2 - 2000*C*D1*Ddd*f**3*r*s + 1420*C*D1*Ddd*f**3*r - 1080*C*D1*Ddd*f**3*s**2 + 1540*C*D1*Ddd*f**3*s - 730*C*D1*Ddd*f**3 - 2760*C*Dd**2*f**3*r**2 - 6000*C*Dd**2*f**3*r*s + 4260*C*Dd**2*f**3*r - 3240*C*Dd**2*f**3*s**2 + 4620*C*Dd**2*f**3*s - 1460*C*Dd**2*f**3 - 168*D1**2*K*bd1**2*f*r**2 - 336*D1**2*K*bd1**2*f*r*s + 546*D1**2*K*bd1**2*f*r - 168*D1**2*K*bd1**2*f*s**2 + 546*D1**2*K*bd1**2*f*s - 378*D1**2*K*bd1**2*f - 126*D1**2*K*bd1*f**2*r**2 - 84*D1**2*K*bd1*f**2*r*s + 252*D1**2*K*bd1*f**2*r + 42*D1**2*K*bd1*f**2*s**2 + 84*D1**2*K*bd1*f**2*s - 126*D1**2*K*bd1*f**2 - 420*D1**2*K*bd1*f*fd*r**2 - 1176*D1**2*K*bd1*f*fd*r*s + 714*D1**2*K*bd1*f*fd*r - 756*D1**2*K*bd1*f*fd*s**2 + 966*D1**2*K*bd1*f*fd*s - 294*D1**2*K*bd1*f*fd - 105*D1**2*K*bdd1*f**2*r**2 - 294*D1**2*K*bdd1*f**2*r*s + 210*D1**2*K*bdd1*f**2*r - 189*D1**2*K*bdd1*f**2*s**2 + 294*D1**2*K*bdd1*f**2*s - 105*D1**2*K*bdd1*f**2 + 84*D1**2*bd1**2*f**2*r**2 + 84*D1**2*bd1**2*f**2*r*s - 126*D1**2*bd1**2*f**2*r - 42*D1**2*bd1**2*f**2*s + 42*D1**2*bd1**2*f**2 + 84*D1**2*bd1**2*f*r**2 + 84*D1**2*bd1**2*f*r*s - 126*D1**2*bd1**2*f*r - 42*D1**2*bd1**2*f*s + 42*D1**2*bd1**2*f - 210*D1**2*bd1*bd2*f*r**2 - 420*D1**2*bd1*bd2*f*r*s + 420*D1**2*bd1*bd2*f*r - 210*D1**2*bd1*bd2*f*s**2 + 420*D1**2*bd1*bd2*f*s - 210*D1**2*bd1*bd2*f - 282*D1**2*bd1*f**2*r**2 - 402*D1**2*bd1*f**2*r*s + 660*D1**2*bd1*f**2*r - 120*D1**2*bd1*f**2*s**2 + 498*D1**2*bd1*f**2*s - 228*D1**2*bd1*f**2 + 648*D1**2*bd1*f*fd*r**2 + 888*D1**2*bd1*f*fd*r*s - 918*D1**2*bd1*f*fd*r + 240*D1**2*bd1*f*fd*s**2 - 612*D1**2*bd1*f*fd*s + 372*D1**2*bd1*f*fd - 336*D1**2*bd1*f*g2*r**2 - 672*D1**2*bd1*f*g2*r*s + 1512*D1**2*bd1*f*g2*r - 336*D1**2*bd1*f*g2*s**2 + 1512*D1**2*bd1*f*g2*s - 756*D1**2*bd1*f*g2 + 336*D1**2*bd1*f*gd2*r**2 + 672*D1**2*bd1*f*gd2*r*s - 1092*D1**2*bd1*f*gd2*r + 336*D1**2*bd1*f*gd2*s**2 - 1092*D1**2*bd1*f*gd2*s + 756*D1**2*bd1*f*gd2 + 336*D1**2*bd1*fd*g2*r**2 + 672*D1**2*bd1*fd*g2*r*s - 336*D1**2*bd1*fd*g2*r + 336*D1**2*bd1*fd*g2*s**2 - 336*D1**2*bd1*fd*g2*s - 105*D1**2*bd2*f**2*r**2 - 210*D1**2*bd2*f**2*r*s + 210*D1**2*bd2*f**2*r - 105*D1**2*bd2*f**2*s**2 + 210*D1**2*bd2*f**2*s - 105*D1**2*bd2*f**2 + 162*D1**2*bdd1*f**2*r**2 + 222*D1**2*bdd1*f**2*r*s - 372*D1**2*bdd1*f**2*r + 60*D1**2*bdd1*f**2*s**2 - 270*D1**2*bdd1*f**2*s + 135*D1**2*bdd1*f**2 + 168*D1**2*bdd1*f*g2*r**2 + 336*D1**2*bdd1*f*g2*r*s - 756*D1**2*bdd1*f*g2*r + 168*D1**2*bdd1*f*g2*s**2 - 756*D1**2*bdd1*f*g2*s + 378*D1**2*bdd1*f*g2 + 120*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 90*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 50*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 345*D1**2*f**2*fdd*r**2 + 750*D1**2*f**2*fdd*r*s - 480*D1**2*f**2*fdd*r + 405*D1**2*f**2*fdd*s**2 - 520*D1**2*f**2*fdd*s + 250*D1**2*f**2*fdd + 252*D1**2*f**2*gd2*r**2 + 168*D1**2*f**2*gd2*r*s - 504*D1**2*f**2*gd2*r - 84*D1**2*f**2*gd2*s**2 - 168*D1**2*f**2*gd2*s + 252*D1**2*f**2*gd2 + 210*D1**2*f**2*gdd2*r**2 + 588*D1**2*f**2*gdd2*r*s - 420*D1**2*f**2*gdd2*r + 378*D1**2*f**2*gdd2*s**2 - 588*D1**2*f**2*gdd2*s + 210*D1**2*f**2*gdd2 + 690*D1**2*f*fd**2*r**2 + 1500*D1**2*f*fd**2*r*s - 960*D1**2*f*fd**2*r + 810*D1**2*f*fd**2*s**2 - 1040*D1**2*f*fd**2*s + 250*D1**2*f*fd**2 + 504*D1**2*f*fd*g2*r**2 + 336*D1**2*f*fd*g2*r*s - 168*D1**2*f*fd*g2*r - 168*D1**2*f*fd*g2*s**2 + 168*D1**2*f*fd*g2*s - 84*D1**2*f*fd*g2 + 840*D1**2*f*fd*gd2*r**2 + 2352*D1**2*f*fd*gd2*r*s - 1428*D1**2*f*fd*gd2*r + 1512*D1**2*f*fd*gd2*s**2 - 1932*D1**2*f*fd*gd2*s + 588*D1**2*f*fd*gd2 + 420*D1**2*f*fdd*g2*r**2 + 1176*D1**2*f*fdd*g2*r*s - 588*D1**2*f*fdd*g2*r + 756*D1**2*f*fdd*g2*s**2 - 756*D1**2*f*fdd*g2*s + 378*D1**2*f*fdd*g2 + 420*D1**2*fd**2*g2*r**2 + 1176*D1**2*fd**2*g2*r*s - 588*D1**2*fd**2*g2*r + 756*D1**2*fd**2*g2*s**2 - 756*D1**2*fd**2*g2*s - 840*D1*Dd*K*bd1*f**2*r**2 - 2352*D1*Dd*K*bd1*f**2*r*s + 1554*D1*Dd*K*bd1*f**2*r - 1512*D1*Dd*K*bd1*f**2*s**2 + 2142*D1*Dd*K*bd1*f**2*s - 714*D1*Dd*K*bd1*f**2 + 1296*D1*Dd*bd1*f**2*r**2 + 1776*D1*Dd*bd1*f**2*r*s - 2358*D1*Dd*bd1*f**2*r + 480*D1*Dd*bd1*f**2*s**2 - 1644*D1*Dd*bd1*f**2*s + 1014*D1*Dd*bd1*f**2 + 1344*D1*Dd*bd1*f*g2*r**2 + 2688*D1*Dd*bd1*f*g2*r*s - 4032*D1*Dd*bd1*f*g2*r + 1344*D1*Dd*bd1*f*g2*s**2 - 4032*D1*Dd*bd1*f*g2*s + 2268*D1*Dd*bd1*f*g2 + 160*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 170*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 40*D1*Dd*f**3*s + 50*D1*Dd*f**3 + 2760*D1*Dd*f**2*fd*r**2 + 6000*D1*Dd*f**2*fd*r*s - 4050*D1*Dd*f**2*fd*r + 3240*D1*Dd*f**2*fd*s**2 - 4390*D1*Dd*f**2*fd*s + 1480*D1*Dd*f**2*fd + 1008*D1*Dd*f**2*g2*r**2 + 672*D1*Dd*f**2*g2*r*s - 1176*D1*Dd*f**2*g2*r - 336*D1*Dd*f**2*g2*s**2 - 168*D1*Dd*f**2*g2*s + 420*D1*Dd*f**2*g2 + 1680*D1*Dd*f**2*gd2*r**2 + 4704*D1*Dd*f**2*gd2*r*s - 3108*D1*Dd*f**2*gd2*r + 3024*D1*Dd*f**2*gd2*s**2 - 4284*D1*Dd*f**2*gd2*s + 1428*D1*Dd*f**2*gd2 + 3360*D1*Dd*f*fd*g2*r**2 + 9408*D1*Dd*f*fd*g2*r*s - 5208*D1*Dd*f*fd*g2*r + 6048*D1*Dd*f*fd*g2*s**2 - 6888*D1*Dd*f*fd*g2*s + 1932*D1*Dd*f*fd*g2 + 460*D1*Ddd*f**3*r**2 + 1000*D1*Ddd*f**3*r*s - 710*D1*Ddd*f**3*r + 540*D1*Ddd*f**3*s**2 - 770*D1*Ddd*f**3*s + 365*D1*Ddd*f**3 + 840*D1*Ddd*f**2*g2*r**2 + 2352*D1*Ddd*f**2*g2*r*s - 1428*D1*Ddd*f**2*g2*r + 1512*D1*Ddd*f**2*g2*s**2 - 1932*D1*Ddd*f**2*g2*s + 798*D1*Ddd*f**2*g2 + 105*D1*b2*(2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 1380*Dd**2*f**3*r**2 + 3000*Dd**2*f**3*r*s - 2130*Dd**2*f**3*r + 1620*Dd**2*f**3*s**2 - 2310*Dd**2*f**3*s + 730*Dd**2*f**3 + 2520*Dd**2*f**2*g2*r**2 + 7056*Dd**2*f**2*g2*r*s - 4284*Dd**2*f**2*g2*r + 4536*Dd**2*f**2*g2*s**2 - 5796*Dd**2*f**2*g2*s + 1596*Dd**2*f**2*g2 - 21*b1**2*(D1**2*(-2*K*fd*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-4*r**2 - 4*r*(s - 1) + 2*s) + 4*fd*r*(r + s) + fdd*(K*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) - 2*r*(r + s))) + 2*D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(K*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + 2*Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) - 3*b1*(-288*C*D1**2*f*fd*r**2 - 448*C*D1**2*f*fd*r*s + 88*C*D1**2*f*fd*r - 160*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s - 44*C*D1**2*f*fd + 144*C*D1**2*f*fdd*r**2 + 224*C*D1**2*f*fdd*r*s - 44*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 - 12*C*D1**2*f*fdd*s + 22*C*D1**2*f*fdd + 144*C*D1**2*fd**2*r**2 + 224*C*D1**2*fd**2*r*s - 44*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 - 12*C*D1**2*fd**2*s - 100*C*D1**2*fd**2 - 576*C*D1*Dd*f**2*r**2 - 896*C*D1*Dd*f**2*r*s + 800*C*D1*Dd*f**2*r - 320*C*D1*Dd*f**2*s**2 + 608*C*D1*Dd*f**2*s - 368*C*D1*Dd*f**2 + 1152*C*D1*Dd*f*fd*r**2 + 1792*C*D1*Dd*f*fd*r*s - 976*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 656*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 288*C*D1*Ddd*f**2*r**2 + 448*C*D1*Ddd*f**2*r*s - 400*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 304*C*D1*Ddd*f**2*s + 184*C*D1*Ddd*f**2 + 864*C*Dd**2*f**2*r**2 + 1344*C*Dd**2*f**2*r*s - 1200*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 912*C*Dd**2*f**2*s + 368*C*Dd**2*f**2 + 56*D1**2*K*bdd1*f*r**2 + 112*D1**2*K*bdd1*f*r*s - 182*D1**2*K*bdd1*f*r + 56*D1**2*K*bdd1*f*s**2 - 182*D1**2*K*bdd1*f*s + 91*D1**2*K*bdd1*f + 84*D1**2*K*f*fd*r**2 + 56*D1**2*K*f*fd*r*s - 28*D1**2*K*f*fd*r - 28*D1**2*K*f*fd*s**2 + 28*D1**2*K*f*fd*s - 14*D1**2*K*f*fd + 70*D1**2*K*f*fdd*r**2 + 196*D1**2*K*f*fdd*r*s - 98*D1**2*K*f*fdd*r + 126*D1**2*K*f*fdd*s**2 - 126*D1**2*K*f*fdd*s + 63*D1**2*K*f*fdd + 70*D1**2*K*fd**2*r**2 + 196*D1**2*K*fd**2*r*s - 98*D1**2*K*fd**2*r + 126*D1**2*K*fd**2*s**2 - 126*D1**2*K*fd**2*s - 70*D1**2*b2*fd*r**2 - 140*D1**2*b2*fd*r*s - 70*D1**2*b2*fd*s**2 + 35*D1**2*b2*fdd*r**2 + 70*D1**2*b2*fdd*r*s + 35*D1**2*b2*fdd*s**2 - 28*D1**2*bdd1*f**2*r**2 - 28*D1**2*bdd1*f**2*r*s + 42*D1**2*bdd1*f**2*r + 14*D1**2*bdd1*f**2*s - 14*D1**2*bdd1*f**2 - 28*D1**2*bdd1*f*r**2 - 28*D1**2*bdd1*f*r*s + 42*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s - 14*D1**2*bdd1*f + 35*D1**2*bdd2*f*r**2 + 70*D1**2*bdd2*f*r*s - 70*D1**2*bdd2*f*r + 35*D1**2*bdd2*f*s**2 - 70*D1**2*bdd2*f*s + 35*D1**2*bdd2*f + 188*D1**2*f*fd*r**2 + 268*D1**2*f*fd*r*s - 102*D1**2*f*fd*r + 80*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s + 58*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 148*D1**2*f*fdd*r*s + 58*D1**2*f*fdd*r - 40*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s - 29*D1**2*f*fdd + 112*D1**2*f*gd2*r**2 + 224*D1**2*f*gd2*r*s - 224*D1**2*f*gd2*r + 112*D1**2*f*gd2*s**2 - 224*D1**2*f*gd2*s + 112*D1**2*f*gd2 - 56*D1**2*f*gdd2*r**2 - 112*D1**2*f*gdd2*r*s + 112*D1**2*f*gdd2*r - 56*D1**2*f*gdd2*s**2 + 112*D1**2*f*gdd2*s - 56*D1**2*f*gdd2 - 108*D1**2*fd**2*r**2 - 148*D1**2*fd**2*r*s + 58*D1**2*fd**2*r - 40*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s + 50*D1**2*fd**2 + 112*D1**2*fd*g2*r**2 + 224*D1**2*fd*g2*r*s + 280*D1**2*fd*g2*r + 112*D1**2*fd*g2*s**2 + 280*D1**2*fd*g2*s - 140*D1**2*fd*g2 - 112*D1**2*fd*gd2*r**2 - 224*D1**2*fd*gd2*r*s - 28*D1**2*fd*gd2*r - 112*D1**2*fd*gd2*s**2 - 28*D1**2*fd*gd2*s + 140*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r**2 - 112*D1**2*fdd*g2*r*s - 140*D1**2*fdd*g2*r - 56*D1**2*fdd*g2*s**2 - 140*D1**2*fdd*g2*s + 70*D1**2*fdd*g2 + 168*D1*Dd*K*f**2*r**2 + 112*D1*Dd*K*f**2*r*s - 196*D1*Dd*K*f**2*r - 56*D1*Dd*K*f**2*s**2 - 28*D1*Dd*K*f**2*s + 70*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*r**2 + 1568*D1*Dd*K*f*fd*r*s - 868*D1*Dd*K*f*fd*r + 1008*D1*Dd*K*f*fd*s**2 - 1148*D1*Dd*K*f*fd*s + 322*D1*Dd*K*f*fd - 280*D1*Dd*b2*f*r**2 - 560*D1*Dd*b2*f*r*s + 420*D1*Dd*b2*f*r - 280*D1*Dd*b2*f*s**2 + 420*D1*Dd*b2*f*s - 210*D1*Dd*b2*f + 280*D1*Dd*b2*fd*r**2 + 560*D1*Dd*b2*fd*r*s - 210*D1*Dd*b2*fd*r + 280*D1*Dd*b2*fd*s**2 - 210*D1*Dd*b2*fd*s + 376*D1*Dd*f**2*r**2 + 536*D1*Dd*f**2*r*s - 510*D1*Dd*f**2*r + 160*D1*Dd*f**2*s**2 - 348*D1*Dd*f**2*s + 228*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 1184*D1*Dd*f*fd*r*s + 812*D1*Dd*f*fd*r - 320*D1*Dd*f*fd*s**2 + 472*D1*Dd*f*fd*s - 140*D1*Dd*f*fd + 448*D1*Dd*f*g2*r**2 + 896*D1*Dd*f*g2*r*s - 672*D1*Dd*f*g2*r + 448*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 336*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r**2 - 896*D1*Dd*f*gd2*r*s + 784*D1*Dd*f*gd2*r - 448*D1*Dd*f*gd2*s**2 + 784*D1*Dd*f*gd2*s - 336*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r**2 - 896*D1*Dd*fd*g2*r*s - 224*D1*Dd*fd*g2*r - 448*D1*Dd*fd*g2*s**2 - 224*D1*Dd*fd*g2*s + 420*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*r**2 + 392*D1*Ddd*K*f**2*r*s - 238*D1*Ddd*K*f**2*r + 252*D1*Ddd*K*f**2*s**2 - 322*D1*Ddd*K*f**2*s + 133*D1*Ddd*K*f**2 + 140*D1*Ddd*b2*f*r**2 + 280*D1*Ddd*b2*f*r*s - 210*D1*Ddd*b2*f*r + 140*D1*Ddd*b2*f*s**2 - 210*D1*Ddd*b2*f*s + 105*D1*Ddd*b2*f - 216*D1*Ddd*f**2*r**2 - 296*D1*Ddd*f**2*r*s + 290*D1*Ddd*f**2*r - 80*D1*Ddd*f**2*s**2 + 188*D1*Ddd*f**2*s - 128*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r**2 - 448*D1*Ddd*f*g2*r*s + 336*D1*Ddd*f*g2*r - 224*D1*Ddd*f*g2*s**2 + 336*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(K*(8*r**2 + 16*r*s - 26*r + 8*s**2 - 26*s + 13) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(K*(8*r**2 + r*(16*s - 3) + 8*s**2 - 3*s - 5) - 4*r**2 + r*(3 - 4*s) + s)) + Dd*f*(K*(32*r**2 + 64*r*s - 76*r + 32*s**2 - 76*s + 39) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 70*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 420*Dd**2*K*f**2*r**2 + 1176*Dd**2*K*f**2*r*s - 714*Dd**2*K*f**2*r + 756*Dd**2*K*f**2*s**2 - 966*Dd**2*K*f**2*s + 266*Dd**2*K*f**2 + 420*Dd**2*b2*f*r**2 + 840*Dd**2*b2*f*r*s - 630*Dd**2*b2*f*r + 420*Dd**2*b2*f*s**2 - 630*Dd**2*b2*f*s + 210*Dd**2*b2*f - 648*Dd**2*f**2*r**2 - 888*Dd**2*f**2*r*s + 870*Dd**2*f**2*r - 240*Dd**2*f**2*s**2 + 564*Dd**2*f**2*s - 256*Dd**2*f**2 - 672*Dd**2*f*g2*r**2 - 1344*Dd**2*f*g2*r*s + 1008*Dd**2*f*g2*r - 672*Dd**2*f*g2*s**2 + 1008*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(210*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**4*k2**2*st**2*(-1800*C*D1**2*f**2*fd*r*s + 600*C*D1**2*f**2*fd*r - 1800*C*D1**2*f**2*fd*s**2 + 1800*C*D1**2*f**2*fd*s - 600*C*D1**2*f**2*fd + 900*C*D1**2*f**2*fdd*r*s - 300*C*D1**2*f**2*fdd*r + 900*C*D1**2*f**2*fdd*s**2 - 900*C*D1**2*f**2*fdd*s + 300*C*D1**2*f**2*fdd + 1800*C*D1**2*f*fd**2*r*s - 600*C*D1**2*f*fd**2*r + 1800*C*D1**2*f*fd**2*s**2 - 1800*C*D1**2*f*fd**2*s + 300*C*D1**2*f*fd**2 - 2400*C*D1*Dd*f**3*r*s + 600*C*D1*Dd*f**3*r - 2400*C*D1*Dd*f**3*s**2 + 2400*C*D1*Dd*f**3*s - 600*C*D1*Dd*f**3 + 7200*C*D1*Dd*f**2*fd*r*s - 2100*C*D1*Dd*f**2*fd*r + 7200*C*D1*Dd*f**2*fd*s**2 - 7200*C*D1*Dd*f**2*fd*s + 1500*C*D1*Dd*f**2*fd + 1200*C*D1*Ddd*f**3*r*s - 300*C*D1*Ddd*f**3*r + 1200*C*D1*Ddd*f**3*s**2 - 1200*C*D1*Ddd*f**3*s + 300*C*D1*Ddd*f**3 + 3600*C*Dd**2*f**3*r*s - 900*C*Dd**2*f**3*r + 3600*C*Dd**2*f**3*s**2 - 3600*C*Dd**2*f**3*s + 600*C*Dd**2*f**3 - 1080*D1**2*K*b1*f*fd*r*s + 540*D1**2*K*b1*f*fd*r - 1080*D1**2*K*b1*f*fd*s**2 + 1080*D1**2*K*b1*f*fd*s - 540*D1**2*K*b1*f*fd + 540*D1**2*K*b1*f*fdd*r*s - 270*D1**2*K*b1*f*fdd*r + 540*D1**2*K*b1*f*fdd*s**2 - 540*D1**2*K*b1*f*fdd*s + 270*D1**2*K*b1*f*fdd + 540*D1**2*K*b1*fd**2*r*s - 270*D1**2*K*b1*fd**2*r + 540*D1**2*K*b1*fd**2*s**2 - 540*D1**2*K*b1*fd**2*s - 405*D1**2*b1*f**2*fd*r**2 - 405*D1**2*b1*f**2*fd*r*s + 405*D1**2*b1*f**2*fd*r + 135*D1**2*b1*f**2*fd*s - 135*D1**2*b1*f**2*fd + 405*D1**2*b1*f**2*fdd*r**2 + 405*D1**2*b1*f**2*fdd*r*s - 405*D1**2*b1*f**2*fdd*r - 135*D1**2*b1*f**2*fdd*s + 135*D1**2*b1*f**2*fdd + 810*D1**2*b1*f*fd**2*r**2 + 810*D1**2*b1*f*fd**2*r*s - 810*D1**2*b1*f*fd**2*r - 270*D1**2*b1*f*fd**2*s + 135*D1**2*b1*f*fd**2 - 540*D1**2*b1*f*fd*r**2 - 540*D1**2*b1*f*fd*r*s + 270*D1**2*b1*f*fd*r + 270*D1**2*b1*f*fdd*r**2 + 270*D1**2*b1*f*fdd*r*s - 135*D1**2*b1*f*fdd*r + 270*D1**2*b1*fd**2*r**2 + 270*D1**2*b1*fd**2*r*s - 135*D1**2*b1*fd**2*r - 1080*D1**2*b2*f*fd*r*s + 540*D1**2*b2*f*fd*r - 1080*D1**2*b2*f*fd*s**2 + 1080*D1**2*b2*f*fd*s - 540*D1**2*b2*f*fd + 540*D1**2*b2*f*fdd*r*s - 270*D1**2*b2*f*fdd*r + 540*D1**2*b2*f*fdd*s**2 - 540*D1**2*b2*f*fdd*s + 270*D1**2*b2*f*fdd + 540*D1**2*b2*fd**2*r*s - 270*D1**2*b2*fd**2*r + 540*D1**2*b2*fd**2*s**2 - 540*D1**2*b2*fd**2*s - 540*D1**2*bd2*f**2*r*s - 540*D1**2*bd2*f**2*s**2 + 540*D1**2*bd2*f**2*s + 1080*D1**2*bd2*f*fd*r*s - 270*D1**2*bd2*f*fd*r + 1080*D1**2*bd2*f*fd*s**2 - 1080*D1**2*bd2*f*fd*s + 270*D1**2*bd2*f*fd + 135*D1**2*bdd1*f**2*(r + s - 1)*(2*K*s + f*(r - 1) + r - 1) + 270*D1**2*bdd2*f**2*r*s + 270*D1**2*bdd2*f**2*s**2 - 270*D1**2*bdd2*f**2*s - 714*D1**2*f**2*fd*r**2 + 186*D1**2*f**2*fd*r*s + 414*D1**2*f**2*fd*r + 900*D1**2*f**2*fd*s**2 - 662*D1**2*f**2*fd*s + 62*D1**2*f**2*fd + 465*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 315*D1**2*f**2*fdd*r - 450*D1**2*f**2*fdd*s**2 + 295*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 1080*D1**2*f**2*gd2*r*s + 1080*D1**2*f**2*gd2*s**2 - 1080*D1**2*f**2*gd2*s - 540*D1**2*f**2*gdd2*r*s - 540*D1**2*f**2*gdd2*s**2 + 540*D1**2*f**2*gdd2*s + 930*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 630*D1**2*f*fd**2*r - 900*D1**2*f*fd**2*s**2 + 590*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 + 2160*D1**2*f*fd*g2*r*s - 1080*D1**2*f*fd*g2*r + 2160*D1**2*f*fd*g2*s**2 - 2160*D1**2*f*fd*g2*s + 1080*D1**2*f*fd*g2 - 2160*D1**2*f*fd*gd2*r*s + 540*D1**2*f*fd*gd2*r - 2160*D1**2*f*fd*gd2*s**2 + 2160*D1**2*f*fd*gd2*s - 540*D1**2*f*fd*gd2 - 1080*D1**2*f*fdd*g2*r*s + 540*D1**2*f*fdd*g2*r - 1080*D1**2*f*fdd*g2*s**2 + 1080*D1**2*f*fdd*g2*s - 540*D1**2*f*fdd*g2 - 1080*D1**2*fd**2*g2*r*s + 540*D1**2*fd**2*g2*r - 1080*D1**2*fd**2*g2*s**2 + 1080*D1**2*fd**2*g2*s - 2160*D1*Dd*K*b1*f**2*r*s + 540*D1*Dd*K*b1*f**2*r - 2160*D1*Dd*K*b1*f**2*s**2 + 2160*D1*Dd*K*b1*f**2*s - 540*D1*Dd*K*b1*f**2 + 4320*D1*Dd*K*b1*f*fd*r*s - 1620*D1*Dd*K*b1*f*fd*r + 4320*D1*Dd*K*b1*f*fd*s**2 - 4320*D1*Dd*K*b1*f*fd*s + 1080*D1*Dd*K*b1*f*fd - 540*D1*Dd*b1*f**3*r**2 - 540*D1*Dd*b1*f**3*r*s + 675*D1*Dd*b1*f**3*r + 270*D1*Dd*b1*f**3*s - 270*D1*Dd*b1*f**3 + 3240*D1*Dd*b1*f**2*fd*r**2 + 3240*D1*Dd*b1*f**2*fd*r*s - 3645*D1*Dd*b1*f**2*fd*r - 1350*D1*Dd*b1*f**2*fd*s + 945*D1*Dd*b1*f**2*fd - 1080*D1*Dd*b1*f**2*r**2 - 1080*D1*Dd*b1*f**2*r*s + 1350*D1*Dd*b1*f**2*r + 540*D1*Dd*b1*f**2*s - 540*D1*Dd*b1*f**2 + 2160*D1*Dd*b1*f*fd*r**2 + 2160*D1*Dd*b1*f*fd*r*s - 1890*D1*Dd*b1*f*fd*r - 540*D1*Dd*b1*f*fd*s + 270*D1*Dd*b1*f*fd - 2160*D1*Dd*b2*f**2*r*s + 540*D1*Dd*b2*f**2*r - 2160*D1*Dd*b2*f**2*s**2 + 2160*D1*Dd*b2*f**2*s - 540*D1*Dd*b2*f**2 + 4320*D1*Dd*b2*f*fd*r*s - 1620*D1*Dd*b2*f*fd*r + 4320*D1*Dd*b2*f*fd*s**2 - 4320*D1*Dd*b2*f*fd*s + 1080*D1*Dd*b2*f*fd + 2160*D1*Dd*bd2*f**2*r*s - 270*D1*Dd*bd2*f**2*r + 2160*D1*Dd*bd2*f**2*s**2 - 2160*D1*Dd*bd2*f**2*s + 270*D1*Dd*bd2*f**2 - 952*D1*Dd*f**3*r**2 + 248*D1*Dd*f**3*r*s + 890*D1*Dd*f**3*r + 1200*D1*Dd*f**3*s**2 - 724*D1*Dd*f**3*s - 176*D1*Dd*f**3 + 3720*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 3135*D1*Dd*f**2*fd*r - 3600*D1*Dd*f**2*fd*s**2 + 2050*D1*Dd*f**2*fd*s + 335*D1*Dd*f**2*fd + 4320*D1*Dd*f**2*g2*r*s - 1080*D1*Dd*f**2*g2*r + 4320*D1*Dd*f**2*g2*s**2 - 4320*D1*Dd*f**2*g2*s + 1080*D1*Dd*f**2*g2 - 4320*D1*Dd*f**2*gd2*r*s + 540*D1*Dd*f**2*gd2*r - 4320*D1*Dd*f**2*gd2*s**2 + 4320*D1*Dd*f**2*gd2*s - 540*D1*Dd*f**2*gd2 - 8640*D1*Dd*f*fd*g2*r*s + 3240*D1*Dd*f*fd*g2*r - 8640*D1*Dd*f*fd*g2*s**2 + 8640*D1*Dd*f*fd*g2*s - 2160*D1*Dd*f*fd*g2 + 1080*D1*Ddd*K*b1*f**2*r*s - 270*D1*Ddd*K*b1*f**2*r + 1080*D1*Ddd*K*b1*f**2*s**2 - 1080*D1*Ddd*K*b1*f**2*s + 270*D1*Ddd*K*b1*f**2 + 540*D1*Ddd*b1*f**3*r**2 + 540*D1*Ddd*b1*f**3*r*s - 675*D1*Ddd*b1*f**3*r - 270*D1*Ddd*b1*f**3*s + 270*D1*Ddd*b1*f**3 + 540*D1*Ddd*b1*f**2*r**2 + 540*D1*Ddd*b1*f**2*r*s - 675*D1*Ddd*b1*f**2*r - 270*D1*Ddd*b1*f**2*s + 270*D1*Ddd*b1*f**2 + 1080*D1*Ddd*b2*f**2*r*s - 270*D1*Ddd*b2*f**2*r + 1080*D1*Ddd*b2*f**2*s**2 - 1080*D1*Ddd*b2*f**2*s + 270*D1*Ddd*b2*f**2 + 620*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 625*D1*Ddd*f**3*r - 600*D1*Ddd*f**3*s**2 + 290*D1*Ddd*f**3*s + 160*D1*Ddd*f**3 - 2160*D1*Ddd*f**2*g2*r*s + 540*D1*Ddd*f**2*g2*r - 2160*D1*Ddd*f**2*g2*s**2 + 2160*D1*Ddd*f**2*g2*s - 540*D1*Ddd*f**2*g2 - 135*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) + f*(fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + (2*r + 2*s - 2)*(2*K*s + r - 1)) - fd*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(2*K*(8*r*s - r + 8*s**2 - 8*s + 1) + f*(8*r**2 + r*(8*s - 13) - 6*s + 5) + 8*r**2 + 8*r*s - 13*r - 6*s + 5)) + 3240*Dd**2*K*b1*f**2*r*s - 810*Dd**2*K*b1*f**2*r + 3240*Dd**2*K*b1*f**2*s**2 - 3240*Dd**2*K*b1*f**2*s + 540*Dd**2*K*b1*f**2 + 1620*Dd**2*b1*f**3*r**2 + 1620*Dd**2*b1*f**3*r*s - 2025*Dd**2*b1*f**3*r - 810*Dd**2*b1*f**3*s + 540*Dd**2*b1*f**3 + 1620*Dd**2*b1*f**2*r**2 + 1620*Dd**2*b1*f**2*r*s - 2025*Dd**2*b1*f**2*r - 810*Dd**2*b1*f**2*s + 540*Dd**2*b1*f**2 + 3240*Dd**2*b2*f**2*r*s - 810*Dd**2*b2*f**2*r + 3240*Dd**2*b2*f**2*s**2 - 3240*Dd**2*b2*f**2*s + 540*Dd**2*b2*f**2 + 1860*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 1875*Dd**2*f**3*r - 1800*Dd**2*f**3*s**2 + 870*Dd**2*f**3*s + 320*Dd**2*f**3 - 6480*Dd**2*f**2*g2*r*s + 1620*Dd**2*f**2*g2*r - 6480*Dd**2*f**2*g2*s**2 + 6480*Dd**2*f**2*g2*s - 1080*Dd**2*f**2*g2)/(315*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**4*k2**2*(246*C*D1**2*bdd1*f**2*r**2 + 276*C*D1**2*bdd1*f**2*r*s + 30*C*D1**2*bdd1*f**2*s**2 + 750*C*D1**2*f**2*fd*r**2 + 1740*C*D1**2*f**2*fd*r*s - 1080*C*D1**2*f**2*fd*r + 990*C*D1**2*f**2*fd*s**2 - 1240*C*D1**2*f**2*fd*s + 580*C*D1**2*f**2*fd - 690*C*D1**2*f**2*fdd*r**2 - 1500*C*D1**2*f**2*fdd*r*s + 960*C*D1**2*f**2*fdd*r - 810*C*D1**2*f**2*fdd*s**2 + 1040*C*D1**2*f**2*fdd*s - 500*C*D1**2*f**2*fdd - 1380*C*D1**2*f*fd**2*r**2 - 3000*C*D1**2*f*fd**2*r*s + 1920*C*D1**2*f*fd**2*r - 1620*C*D1**2*f*fd**2*s**2 + 2080*C*D1**2*f*fd**2*s - 500*C*D1**2*f*fd**2 + 1000*C*D1*Dd*f**3*r**2 + 2320*C*D1*Dd*f**3*r*s - 1580*C*D1*Dd*f**3*r + 1320*C*D1*Dd*f**3*s**2 - 1820*C*D1*Dd*f**3*s + 830*C*D1*Dd*f**3 - 5520*C*D1*Dd*f**2*fd*r**2 - 12000*C*D1*Dd*f**2*fd*r*s + 8100*C*D1*Dd*f**2*fd*r - 6480*C*D1*Dd*f**2*fd*s**2 + 8780*C*D1*Dd*f**2*fd*s - 2960*C*D1*Dd*f**2*fd - 920*C*D1*Ddd*f**3*r**2 - 2000*C*D1*Ddd*f**3*r*s + 1420*C*D1*Ddd*f**3*r - 1080*C*D1*Ddd*f**3*s**2 + 1540*C*D1*Ddd*f**3*s - 730*C*D1*Ddd*f**3 - 2760*C*Dd**2*f**3*r**2 - 6000*C*Dd**2*f**3*r*s + 4260*C*Dd**2*f**3*r - 3240*C*Dd**2*f**3*s**2 + 4620*C*Dd**2*f**3*s - 1460*C*Dd**2*f**3 - 105*D1**2*K*bdd1*f**2*r**2 - 294*D1**2*K*bdd1*f**2*r*s + 210*D1**2*K*bdd1*f**2*r - 189*D1**2*K*bdd1*f**2*s**2 + 294*D1**2*K*bdd1*f**2*s - 105*D1**2*K*bdd1*f**2 + 21*D1**2*b2*bdd1*f*r**2 + 42*D1**2*b2*bdd1*f*r*s + 21*D1**2*b2*bdd1*f*s**2 + 126*D1**2*b2*f*fd*r**2 + 588*D1**2*b2*f*fd*r*s - 294*D1**2*b2*f*fd*r + 462*D1**2*b2*f*fd*s**2 - 462*D1**2*b2*f*fd*s + 231*D1**2*b2*f*fd - 210*D1**2*b2*f*fdd*r**2 - 588*D1**2*b2*f*fdd*r*s + 294*D1**2*b2*f*fdd*r - 378*D1**2*b2*f*fdd*s**2 + 378*D1**2*b2*f*fdd*s - 189*D1**2*b2*f*fdd - 210*D1**2*b2*fd**2*r**2 - 588*D1**2*b2*fd**2*r*s + 294*D1**2*b2*fd**2*r - 378*D1**2*b2*fd**2*s**2 + 378*D1**2*b2*fd**2*s - 42*D1**2*bd1**2*f*(-5*K*r**2 - 6*K*r*s + 5*K*r - K*s**2 + 3*K*s + f*(r - 1) + r - 1) + 63*D1**2*bd2*f**2*r**2 + 294*D1**2*bd2*f**2*r*s - 126*D1**2*bd2*f**2*r + 231*D1**2*bd2*f**2*s**2 - 294*D1**2*bd2*f**2*s + 63*D1**2*bd2*f**2 - 420*D1**2*bd2*f*fd*r**2 - 1176*D1**2*bd2*f*fd*r*s + 714*D1**2*bd2*f*fd*r - 756*D1**2*bd2*f*fd*s**2 + 966*D1**2*bd2*f*fd*s - 294*D1**2*bd2*f*fd - 123*D1**2*bdd1*f**2*r**2 - 138*D1**2*bdd1*f**2*r*s - 54*D1**2*bdd1*f**2*r - 15*D1**2*bdd1*f**2*s**2 - 210*D1**2*bdd1*f*g2*r**2 - 252*D1**2*bdd1*f*g2*r*s - 42*D1**2*bdd1*f*g2*s**2 - 105*D1**2*bdd2*f**2*r**2 - 294*D1**2*bdd2*f**2*r*s + 210*D1**2*bdd2*f**2*r - 189*D1**2*bdd2*f**2*s**2 + 294*D1**2*bdd2*f**2*s - 105*D1**2*bdd2*f**2 - 285*D1**2*f**2*fd*r**2 - 780*D1**2*f**2*fd*r*s + 450*D1**2*f**2*fd*r - 495*D1**2*f**2*fd*s**2 + 590*D1**2*f**2*fd*s - 260*D1**2*f**2*fd + 345*D1**2*f**2*fdd*r**2 + 750*D1**2*f**2*fdd*r*s - 480*D1**2*f**2*fdd*r + 405*D1**2*f**2*fdd*s**2 - 520*D1**2*f**2*fdd*s + 250*D1**2*f**2*fdd - 126*D1**2*f**2*gd2*r**2 - 588*D1**2*f**2*gd2*r*s + 252*D1**2*f**2*gd2*r - 462*D1**2*f**2*gd2*s**2 + 588*D1**2*f**2*gd2*s - 126*D1**2*f**2*gd2 + 210*D1**2*f**2*gdd2*r**2 + 588*D1**2*f**2*gdd2*r*s - 420*D1**2*f**2*gdd2*r + 378*D1**2*f**2*gdd2*s**2 - 588*D1**2*f**2*gdd2*s + 210*D1**2*f**2*gdd2 + 690*D1**2*f*fd**2*r**2 + 1500*D1**2*f*fd**2*r*s - 960*D1**2*f*fd**2*r + 810*D1**2*f*fd**2*s**2 - 1040*D1**2*f*fd**2*s + 250*D1**2*f*fd**2 - 252*D1**2*f*fd*g2*r**2 - 1176*D1**2*f*fd*g2*r*s + 588*D1**2*f*fd*g2*r - 924*D1**2*f*fd*g2*s**2 + 924*D1**2*f*fd*g2*s - 462*D1**2*f*fd*g2 + 840*D1**2*f*fd*gd2*r**2 + 2352*D1**2*f*fd*gd2*r*s - 1428*D1**2*f*fd*gd2*r + 1512*D1**2*f*fd*gd2*s**2 - 1932*D1**2*f*fd*gd2*s + 588*D1**2*f*fd*gd2 + 420*D1**2*f*fdd*g2*r**2 + 1176*D1**2*f*fdd*g2*r*s - 588*D1**2*f*fdd*g2*r + 756*D1**2*f*fdd*g2*s**2 - 756*D1**2*f*fdd*g2*s + 378*D1**2*f*fdd*g2 + 420*D1**2*fd**2*g2*r**2 + 1176*D1**2*fd**2*g2*r*s - 588*D1**2*fd**2*g2*r + 756*D1**2*fd**2*g2*s**2 - 756*D1**2*fd**2*g2*s + 252*D1*Dd*b2*f**2*r**2 + 1176*D1*Dd*b2*f**2*r*s - 546*D1*Dd*b2*f**2*r + 924*D1*Dd*b2*f**2*s**2 - 1050*D1*Dd*b2*f**2*s + 357*D1*Dd*b2*f**2 - 1680*D1*Dd*b2*f*fd*r**2 - 4704*D1*Dd*b2*f*fd*r*s + 2604*D1*Dd*b2*f*fd*r - 3024*D1*Dd*b2*f*fd*s**2 + 3444*D1*Dd*b2*f*fd*s - 966*D1*Dd*b2*f*fd - 840*D1*Dd*bd2*f**2*r**2 - 2352*D1*Dd*bd2*f**2*r*s + 1554*D1*Dd*bd2*f**2*r - 1512*D1*Dd*bd2*f**2*s**2 + 2142*D1*Dd*bd2*f**2*s - 714*D1*Dd*bd2*f**2 - 380*D1*Dd*f**3*r**2 - 1040*D1*Dd*f**3*r*s + 640*D1*Dd*f**3*r - 660*D1*Dd*f**3*s**2 + 850*D1*Dd*f**3*s - 355*D1*Dd*f**3 + 2760*D1*Dd*f**2*fd*r**2 + 6000*D1*Dd*f**2*fd*r*s - 4050*D1*Dd*f**2*fd*r + 3240*D1*Dd*f**2*fd*s**2 - 4390*D1*Dd*f**2*fd*s + 1480*D1*Dd*f**2*fd - 504*D1*Dd*f**2*g2*r**2 - 2352*D1*Dd*f**2*g2*r*s + 1092*D1*Dd*f**2*g2*r - 1848*D1*Dd*f**2*g2*s**2 + 2100*D1*Dd*f**2*g2*s - 714*D1*Dd*f**2*g2 + 1680*D1*Dd*f**2*gd2*r**2 + 4704*D1*Dd*f**2*gd2*r*s - 3108*D1*Dd*f**2*gd2*r + 3024*D1*Dd*f**2*gd2*s**2 - 4284*D1*Dd*f**2*gd2*s + 1428*D1*Dd*f**2*gd2 + 3360*D1*Dd*f*fd*g2*r**2 + 9408*D1*Dd*f*fd*g2*r*s - 5208*D1*Dd*f*fd*g2*r + 6048*D1*Dd*f*fd*g2*s**2 - 6888*D1*Dd*f*fd*g2*s + 1932*D1*Dd*f*fd*g2 - 420*D1*Ddd*b2*f**2*r**2 - 1176*D1*Ddd*b2*f**2*r*s + 714*D1*Ddd*b2*f**2*r - 756*D1*Ddd*b2*f**2*s**2 + 966*D1*Ddd*b2*f**2*s - 399*D1*Ddd*b2*f**2 + 460*D1*Ddd*f**3*r**2 + 1000*D1*Ddd*f**3*r*s - 710*D1*Ddd*f**3*r + 540*D1*Ddd*f**3*s**2 - 770*D1*Ddd*f**3*s + 365*D1*Ddd*f**3 + 840*D1*Ddd*f**2*g2*r**2 + 2352*D1*Ddd*f**2*g2*r*s - 1428*D1*Ddd*f**2*g2*r + 1512*D1*Ddd*f**2*g2*s**2 - 1932*D1*Ddd*f**2*g2*s + 798*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(f**2*(7*K*(3*r**2 + 2*r*(7*s - 3) + 11*s**2 - 14*s + 3) - 2*r**2*(82*C - 48) - 2*r*(s*(92*C - 53) - 4) - 2*s**2*(10*C - 5) - 14*s + 14) - 2*f*(7*bd2*(-r**2 - 2*r*s + r - s**2 + s) + fd*(-20*C*s**2 + 56*C*s + 7*K*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) - r**2*(164*C - 82) + r*(-184*C*s + 128*C + 92*s - 55) + 10*s**2 - 28*s - 9) + 14*gd2*(5*r**2 + r*(6*s - 5) + s*(s - 3)) + 7*(r + s)*(b2*(r + s) - 2*g2*(5*r + s))) + 14*fd*(b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(5*r**2 + r*(6*s - 3) + s*(s - 1)))) - 2*Dd*f*(-7*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f*(-40*C*s**2 + 102*C*s + 7*K*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) - r**2*(328*C - 164) + r*(-368*C*s + 210*C + 184*s - 69) + 20*s**2 - 51*s - 18) + 14*g2*(20*r**2 + r*(24*s - 13) + s*(4*s - 7))) - 14*b1*(-D1*(f*(-K*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) + r*(f + 2)) + fd*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1)) + Dd*f*(-K*(40*r**2 + 48*r*s - 46*r + 8*s**2 - 26*s + 13) + f*(4*r - 2) + 4*r - 2))) - 1260*Dd**2*b2*f**2*r**2 - 3528*Dd**2*b2*f**2*r*s + 2142*Dd**2*b2*f**2*r - 2268*Dd**2*b2*f**2*s**2 + 2898*Dd**2*b2*f**2*s - 798*Dd**2*b2*f**2 + 1380*Dd**2*f**3*r**2 + 3000*Dd**2*f**3*r*s - 2130*Dd**2*f**3*r + 1620*Dd**2*f**3*s**2 - 2310*Dd**2*f**3*s + 730*Dd**2*f**3 + 2520*Dd**2*f**2*g2*r**2 + 7056*Dd**2*f**2*g2*r*s - 4284*Dd**2*f**2*g2*r + 4536*Dd**2*f**2*g2*s**2 - 5796*Dd**2*f**2*g2*s + 1596*Dd**2*f**2*g2 + 21*b1**2*(D1**2*(2*fd**2*(r - 1) - 2*fd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(f + 2)) + fdd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(2*f + 2))) + D1*(2*Dd*(-K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11) + fd*(K*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + f*(4*r - 2) + 4*r - 2)) + Ddd*K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11)) + 2*Dd**2*K*f*(30*r**2 + r*(36*s - 39) + 6*s**2 - 21*s + 11)) - 3*b1*(328*C*D1**2*f*fd*r**2 + 368*C*D1**2*f*fd*r*s - 512*C*D1**2*f*fd*r + 40*C*D1**2*f*fd*s**2 - 224*C*D1**2*f*fd*s + 184*C*D1**2*f*fd - 164*C*D1**2*f*fdd*r**2 - 184*C*D1**2*f*fdd*r*s + 256*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 112*C*D1**2*f*fdd*s - 92*C*D1**2*f*fdd - 164*C*D1**2*fd**2*r**2 - 184*C*D1**2*fd**2*r*s + 256*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 112*C*D1**2*fd**2*s - 92*C*D1**2*fd**2 + 656*C*D1*Dd*f**2*r**2 + 736*C*D1*Dd*f**2*r*s - 840*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s**2 - 408*C*D1*Dd*f**2*s + 348*C*D1*Dd*f**2 - 1312*C*D1*Dd*f*fd*r**2 - 1472*C*D1*Dd*f*fd*r*s + 1864*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 856*C*D1*Dd*f*fd*s - 624*C*D1*Dd*f*fd - 328*C*D1*Ddd*f**2*r**2 - 368*C*D1*Ddd*f**2*r*s + 420*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 204*C*D1*Ddd*f**2*s - 174*C*D1*Ddd*f**2 - 984*C*Dd**2*f**2*r**2 - 1104*C*Dd**2*f**2*r*s + 1260*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 612*C*Dd**2*f**2*s - 348*C*Dd**2*f**2 - 70*D1**2*K*bdd1*f*r**2 - 84*D1**2*K*bdd1*f*r*s + 70*D1**2*K*bdd1*f*r - 14*D1**2*K*bdd1*f*s**2 + 42*D1**2*K*bdd1*f*s - 35*D1**2*K*bdd1*f - 42*D1**2*K*f*fd*r**2 - 196*D1**2*K*f*fd*r*s + 98*D1**2*K*f*fd*r - 154*D1**2*K*f*fd*s**2 + 154*D1**2*K*f*fd*s - 77*D1**2*K*f*fd + 70*D1**2*K*f*fdd*r**2 + 196*D1**2*K*f*fdd*r*s - 98*D1**2*K*f*fdd*r + 126*D1**2*K*f*fdd*s**2 - 126*D1**2*K*f*fdd*s + 63*D1**2*K*f*fdd + 70*D1**2*K*fd**2*r**2 + 196*D1**2*K*fd**2*r*s - 98*D1**2*K*fd**2*r + 126*D1**2*K*fd**2*s**2 - 126*D1**2*K*fd**2*s + 14*D1**2*b2*fd*r**2 + 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*r + 14*D1**2*b2*fd*s**2 - 28*D1**2*b2*fd*s + 14*D1**2*b2*fd - 7*D1**2*b2*fdd*r**2 - 14*D1**2*b2*fdd*r*s + 14*D1**2*b2*fdd*r - 7*D1**2*b2*fdd*s**2 + 14*D1**2*b2*fdd*s - 7*D1**2*b2*fdd + 14*D1**2*bdd1*f**2*r + 14*D1**2*bdd1*f*r - 7*D1**2*bdd2*f*(r + s - 1)**2 - 192*D1**2*f*fd*r**2 - 212*D1**2*f*fd*r*s + 306*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 112*D1**2*f*fd*s - 92*D1**2*f*fd + 82*D1**2*f*fdd*r**2 + 92*D1**2*f*fdd*r*s - 146*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 56*D1**2*f*fdd*s + 46*D1**2*f*fdd - 140*D1**2*f*gd2*r**2 - 168*D1**2*f*gd2*r*s + 280*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s - 140*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 84*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 + 82*D1**2*fd**2*r**2 + 92*D1**2*fd**2*r*s - 146*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 56*D1**2*fd**2*s + 64*D1**2*fd**2 - 140*D1**2*fd*g2*r**2 - 168*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 140*D1**2*fd*gd2*r**2 + 168*D1**2*fd*gd2*r*s - 224*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 112*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 + 70*D1**2*fdd*g2*r**2 + 84*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 84*D1*Dd*K*f**2*r**2 - 392*D1*Dd*K*f**2*r*s + 182*D1*Dd*K*f**2*r - 308*D1*Dd*K*f**2*s**2 + 350*D1*Dd*K*f**2*s - 119*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*r**2 + 1568*D1*Dd*K*f*fd*r*s - 868*D1*Dd*K*f*fd*r + 1008*D1*Dd*K*f*fd*s**2 - 1148*D1*Dd*K*f*fd*s + 322*D1*Dd*K*f*fd + 56*D1*Dd*b2*f*r**2 + 112*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 56*D1*Dd*b2*f*s**2 - 84*D1*Dd*b2*f*s + 42*D1*Dd*b2*f - 56*D1*Dd*b2*fd*r**2 - 112*D1*Dd*b2*fd*r*s + 98*D1*Dd*b2*fd*r - 56*D1*Dd*b2*fd*s**2 + 98*D1*Dd*b2*fd*s - 42*D1*Dd*b2*fd - 384*D1*Dd*f**2*r**2 - 424*D1*Dd*f**2*r*s + 490*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 232*D1*Dd*f**2*s - 202*D1*Dd*f**2 + 656*D1*Dd*f*fd*r**2 + 736*D1*Dd*f*fd*r*s - 1004*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 428*D1*Dd*f*fd*s + 348*D1*Dd*f*fd - 560*D1*Dd*f*g2*r**2 - 672*D1*Dd*f*g2*r*s + 728*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 392*D1*Dd*f*g2*s - 308*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 672*D1*Dd*f*gd2*r*s - 924*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 532*D1*Dd*f*gd2*s + 364*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 672*D1*Dd*fd*g2*r*s - 700*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 308*D1*Dd*fd*g2*s + 196*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*r**2 + 392*D1*Ddd*K*f**2*r*s - 238*D1*Ddd*K*f**2*r + 252*D1*Ddd*K*f**2*s**2 - 322*D1*Ddd*K*f**2*s + 133*D1*Ddd*K*f**2 - 28*D1*Ddd*b2*f*r**2 - 56*D1*Ddd*b2*f*r*s + 42*D1*Ddd*b2*f*r - 28*D1*Ddd*b2*f*s**2 + 42*D1*Ddd*b2*f*s - 21*D1*Ddd*b2*f + 164*D1*Ddd*f**2*r**2 + 184*D1*Ddd*f**2*r*s - 210*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 102*D1*Ddd*f**2*s + 87*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r*s - 364*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 196*D1*Ddd*f*g2*s + 154*D1*Ddd*f*g2 + 14*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 420*Dd**2*K*f**2*r**2 + 1176*Dd**2*K*f**2*r*s - 714*Dd**2*K*f**2*r + 756*Dd**2*K*f**2*s**2 - 966*Dd**2*K*f**2*s + 266*Dd**2*K*f**2 - 84*Dd**2*b2*f*r**2 - 168*Dd**2*b2*f*r*s + 126*Dd**2*b2*f*r - 84*Dd**2*b2*f*s**2 + 126*Dd**2*b2*f*s - 42*Dd**2*b2*f + 492*Dd**2*f**2*r**2 + 552*Dd**2*f**2*r*s - 630*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 306*Dd**2*f**2*s + 174*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r*s - 1092*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 588*Dd**2*f*g2*s + 308*Dd**2*f*g2))/(210*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**4*(D1*(7*D1*bd1**2*f*(r**2*(2*f + 2) + 2*r*(2*K*s + f*(s - 1) + s - 1) + s*(4*K*s - 2*K - f - 1)) + D1*bdd1*f*(r + s)*(9*f*r + f*s*(20*C - 10) + s*(14*b2 - 28*g2)) + bd1*(D1*(-2*f**2*(r + s)*(9*r + s*(20*C - 10)) + f*(fd*(36*r**2 + r*(20*C*(4*s - 1) - 4*s - 17) + s*(20*C*(4*s - 3) - 40*s + 21)) + 14*s*(bd2*(2*r + 2*s - 1) + 4*g2*(r + s) + gd2*(-4*r - 4*s + 2))) + 28*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(72*r**2 + r*(20*C*(8*s - 1) - 8*s - 35) + 2*s*(40*C*(2*s - 1) - 40*s + 11)) - 28*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 14*b2*(D1*(-2*f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) - 7*b1**2*(D1**2*(r + s - 1)*(f*(fd - fdd)*(2*r - 1) + fd**2*(1 - 2*r) + 2*fd*(2*K*(s - 1) + r) - fdd*(2*K*(s - 1) + r)) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(2*r - 1)*(8*r + 8*s - 7) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) - fd*(2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + 8*r**2 + 8*r*s - 9*r - 2*s + 2)) - Ddd*f*(K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - Dd**2*f*(K*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + f*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 12*r**2 + 12*r*s - 15*r - 6*s + 4)) + b1*(-80*C*D1**2*f*fd*r*s + 40*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 120*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s + 20*C*D1**2*fd**2 - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 120*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 - 28*D1**2*b2*fd*r*s + 28*D1**2*b2*fd*r - 28*D1**2*b2*fd*s**2 + 56*D1**2*b2*fd*s - 28*D1**2*b2*fd + 14*D1**2*b2*fdd*r*s - 14*D1**2*b2*fdd*r + 14*D1**2*b2*fdd*s**2 - 28*D1**2*b2*fdd*s + 14*D1**2*b2*fdd - 28*D1**2*bd2*f*r*s - 28*D1**2*bd2*f*s**2 + 28*D1**2*bd2*f*s + 28*D1**2*bd2*fd*r*s - 14*D1**2*bd2*fd*r + 28*D1**2*bd2*fd*s**2 - 42*D1**2*bd2*fd*s + 14*D1**2*bd2*fd + 7*D1**2*bdd1*f*(4*K*s**2 - 2*K*s + f*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*r**2 + 2*r*(2*K*s + s - 1) - s + 1) + 14*D1**2*bdd2*f*r*s + 14*D1**2*bdd2*f*s**2 - 14*D1**2*bdd2*f*s - 36*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s + 34*D1**2*f*fd*r + 40*D1**2*f*fd*s**2 - 42*D1**2*f*fd*s + 2*D1**2*f*fd + 18*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r*s - 17*D1**2*f*fdd*r - 20*D1**2*f*fdd*s**2 + 21*D1**2*f*fdd*s - D1**2*f*fdd + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s + 18*D1**2*fd**2*r**2 - 2*D1**2*fd**2*r*s - 17*D1**2*fd**2*r - 20*D1**2*fd**2*s**2 + 21*D1**2*fd**2*s - D1**2*fd**2 + 56*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 56*D1**2*fd*g2*s**2 - 112*D1**2*fd*g2*s + 56*D1**2*fd*g2 - 56*D1**2*fd*gd2*r*s + 28*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s - 28*D1**2*fd*gd2 - 28*D1**2*fdd*g2*r*s + 28*D1**2*fdd*g2*r - 28*D1**2*fdd*g2*s**2 + 56*D1**2*fdd*g2*s - 28*D1**2*fdd*g2 - 112*D1*Dd*b2*f*r*s + 28*D1*Dd*b2*f*r - 112*D1*Dd*b2*f*s**2 + 112*D1*Dd*b2*f*s - 28*D1*Dd*b2*f + 112*D1*Dd*b2*fd*r*s - 70*D1*Dd*b2*fd*r + 112*D1*Dd*b2*fd*s**2 - 168*D1*Dd*b2*fd*s + 56*D1*Dd*b2*fd + 112*D1*Dd*bd2*f*r*s - 14*D1*Dd*bd2*f*r + 112*D1*Dd*bd2*f*s**2 - 112*D1*Dd*bd2*f*s + 14*D1*Dd*bd2*f - 72*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s + 70*D1*Dd*f**2*r + 80*D1*Dd*f**2*s**2 - 44*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 - 16*D1*Dd*f*fd*r*s - 138*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 128*D1*Dd*f*fd*s + 13*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 224*D1*Dd*f*gd2*s - 28*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r*s + 140*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 336*D1*Dd*fd*g2*s - 112*D1*Dd*fd*g2 + 56*D1*Ddd*b2*f*r*s - 14*D1*Ddd*b2*f*r + 56*D1*Ddd*b2*f*s**2 - 56*D1*Ddd*b2*f*s + 14*D1*Ddd*b2*f + 36*D1*Ddd*f**2*r**2 - 4*D1*Ddd*f**2*r*s - 35*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 22*D1*Ddd*f**2*s + 8*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 112*D1*Ddd*f*g2*s - 28*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(f**2*(2*r**2 + 2*r*(s - 1) - s + 1) + f*(8*K*s**2 - 4*K*s - fd*(2*r - 1)*(4*r + 4*s - 3) + 4*r**2 + 4*r*(2*K*s + s - 1) - 2*s + 2) + fd*(-2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r**2 - 4*r*(s - 1) + s - 1)) - Dd*f*(K*(32*r*s - 4*r + 32*s**2 - 24*s + 2) + f*(2*r - 1)*(8*r + 8*s - 5) + (2*r - 1)*(8*r + 8*s - 5))) + 168*Dd**2*b2*f*r*s - 42*Dd**2*b2*f*r + 168*Dd**2*b2*f*s**2 - 168*Dd**2*b2*f*s + 28*Dd**2*b2*f + 108*Dd**2*f**2*r**2 - 12*Dd**2*f**2*r*s - 105*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 66*Dd**2*f**2*s + 16*Dd**2*f**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 336*Dd**2*f*g2*s - 56*Dd**2*f*g2))/(35*d**2*k3) + D1**2*Pk2*Pkd3*ct**3*f**2*k1**7*(D1**2*(f*(7*fd - 9*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 54*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(7*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 18*fd*(4*r + 4*s - 3)**2) - 9*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 54*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(22*d**2*k2*k3**7) - D1**2*Pk2*Pkd3*ct**3*f*k2**5*st**2*(16*C - 8)*(D1**2*(f*(11*fd - 10*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 10*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(11*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 10*fd*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) - 10*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 10*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4))/(315*d**2*k1*k3**5) + D1**2*Pk2*Pkd3*ct**3*f*k2**3*st**2*(16*C - 8)*(D1**2*(f*(11*fd - 10*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 10*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(11*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 10*fd*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) - 10*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 10*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4))/(315*d**2*k1*k3**3) + D1**2*Pk2*Pkd3*ct**3*k1**5*k2*st**2*(1584*C*D1**2*f**2*fd*r**2 + 3168*C*D1**2*f**2*fd*r*s - 2112*C*D1**2*f**2*fd*r + 1584*C*D1**2*f**2*fd*s**2 - 2112*C*D1**2*f**2*fd*s + 1056*C*D1**2*f**2*fd - 1980*C*D1**2*f**2*fdd*r**2 - 3960*C*D1**2*f**2*fdd*r*s + 2640*C*D1**2*f**2*fdd*r - 1980*C*D1**2*f**2*fdd*s**2 + 2640*C*D1**2*f**2*fdd*s - 1320*C*D1**2*f**2*fdd - 3960*C*D1**2*f*fd**2*r**2 - 7920*C*D1**2*f*fd**2*r*s + 5280*C*D1**2*f*fd**2*r - 3960*C*D1**2*f*fd**2*s**2 + 5280*C*D1**2*f*fd**2*s - 1320*C*D1**2*f*fd**2 + 2112*C*D1*Dd*f**3*r**2 + 4224*C*D1*Dd*f**3*r*s - 3168*C*D1*Dd*f**3*r + 2112*C*D1*Dd*f**3*s**2 - 3168*C*D1*Dd*f**3*s + 1584*C*D1*Dd*f**3 - 15840*C*D1*Dd*f**2*fd*r**2 - 31680*C*D1*Dd*f**2*fd*r*s + 22440*C*D1*Dd*f**2*fd*r - 15840*C*D1*Dd*f**2*fd*s**2 + 22440*C*D1*Dd*f**2*fd*s - 7920*C*D1*Dd*f**2*fd - 2640*C*D1*Ddd*f**3*r**2 - 5280*C*D1*Ddd*f**3*r*s + 3960*C*D1*Ddd*f**3*r - 2640*C*D1*Ddd*f**3*s**2 + 3960*C*D1*Ddd*f**3*s - 1980*C*D1*Ddd*f**3 - 7920*C*Dd**2*f**3*r**2 - 15840*C*Dd**2*f**3*r*s + 11880*C*Dd**2*f**3*r - 7920*C*Dd**2*f**3*s**2 + 11880*C*Dd**2*f**3*s - 3960*C*Dd**2*f**3 + 528*D1**2*K*b1*f*fd*r**2 + 1056*D1**2*K*b1*f*fd*r*s - 528*D1**2*K*b1*f*fd*r + 528*D1**2*K*b1*f*fd*s**2 - 528*D1**2*K*b1*f*fd*s + 264*D1**2*K*b1*f*fd - 1188*D1**2*K*b1*f*fdd*r**2 - 2376*D1**2*K*b1*f*fdd*r*s + 1188*D1**2*K*b1*f*fdd*r - 1188*D1**2*K*b1*f*fdd*s**2 + 1188*D1**2*K*b1*f*fdd*s - 594*D1**2*K*b1*f*fdd - 1188*D1**2*K*b1*fd**2*r**2 - 2376*D1**2*K*b1*fd**2*r*s + 1188*D1**2*K*b1*fd**2*r - 1188*D1**2*K*b1*fd**2*s**2 + 1188*D1**2*K*b1*fd**2*s - 528*D1**2*b1*f*fd*r**2 - 1056*D1**2*b1*f*fd*r*s + 528*D1**2*b1*f*fd*r - 528*D1**2*b1*f*fd*s**2 + 528*D1**2*b1*f*fd*s - 264*D1**2*b1*f*fd + 1188*D1**2*b1*f*fdd*r**2 + 2376*D1**2*b1*f*fdd*r*s - 1188*D1**2*b1*f*fdd*r + 1188*D1**2*b1*f*fdd*s**2 - 1188*D1**2*b1*f*fdd*s + 594*D1**2*b1*f*fdd + 1188*D1**2*b1*fd**2*r**2 + 2376*D1**2*b1*fd**2*r*s - 1188*D1**2*b1*fd**2*r + 1188*D1**2*b1*fd**2*s**2 - 1188*D1**2*b1*fd**2*s - 594*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 6740*D1**2*f**3*fd*r**2 + 13480*D1**2*f**3*fd*r*s - 10110*D1**2*f**3*fd*r + 6740*D1**2*f**3*fd*s**2 - 10110*D1**2*f**3*fd*s + 5055*D1**2*f**3*fd - 7000*D1**2*f**3*fdd*r**2 - 14000*D1**2*f**3*fdd*r*s + 10500*D1**2*f**3*fdd*r - 7000*D1**2*f**3*fdd*s**2 + 10500*D1**2*f**3*fdd*s - 5250*D1**2*f**3*fdd - 21000*D1**2*f**2*fd**2*r**2 - 42000*D1**2*f**2*fd**2*r*s + 31500*D1**2*f**2*fd**2*r - 21000*D1**2*f**2*fd**2*s**2 + 31500*D1**2*f**2*fd**2*s - 10500*D1**2*f**2*fd**2 - 1584*D1**2*f**2*fd*r**2 - 3168*D1**2*f**2*fd*r*s + 2112*D1**2*f**2*fd*r - 1584*D1**2*f**2*fd*s**2 + 2112*D1**2*f**2*fd*s - 1056*D1**2*f**2*fd + 1980*D1**2*f**2*fdd*r**2 + 3960*D1**2*f**2*fdd*r*s - 2640*D1**2*f**2*fdd*r + 1980*D1**2*f**2*fdd*s**2 - 2640*D1**2*f**2*fdd*s + 1320*D1**2*f**2*fdd - 528*D1**2*f**2*gd2*r**2 - 1056*D1**2*f**2*gd2*r*s + 1056*D1**2*f**2*gd2*r - 528*D1**2*f**2*gd2*s**2 + 1056*D1**2*f**2*gd2*s - 528*D1**2*f**2*gd2 + 1188*D1**2*f**2*gdd2*r**2 + 2376*D1**2*f**2*gdd2*r*s - 2376*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 2376*D1**2*f**2*gdd2*s + 1188*D1**2*f**2*gdd2 + 3960*D1**2*f*fd**2*r**2 + 7920*D1**2*f*fd**2*r*s - 5280*D1**2*f*fd**2*r + 3960*D1**2*f*fd**2*s**2 - 5280*D1**2*f*fd**2*s + 1320*D1**2*f*fd**2 - 1056*D1**2*f*fd*g2*r**2 - 2112*D1**2*f*fd*g2*r*s + 1056*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 + 4752*D1**2*f*fd*gd2*r**2 + 9504*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2376*D1**2*f*fd*gd2 + 2376*D1**2*f*fdd*g2*r**2 + 4752*D1**2*f*fdd*g2*r*s - 2376*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 2376*D1**2*fd**2*g2*r**2 + 4752*D1**2*fd**2*g2*r*s - 2376*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 1056*D1*Dd*K*b1*f**2*r**2 + 2112*D1*Dd*K*b1*f**2*r*s - 1584*D1*Dd*K*b1*f**2*r + 1056*D1*Dd*K*b1*f**2*s**2 - 1584*D1*Dd*K*b1*f**2*s + 792*D1*Dd*K*b1*f**2 - 9504*D1*Dd*K*b1*f*fd*r**2 - 19008*D1*Dd*K*b1*f*fd*r*s + 11880*D1*Dd*K*b1*f*fd*r - 9504*D1*Dd*K*b1*f*fd*s**2 + 11880*D1*Dd*K*b1*f*fd*s - 3564*D1*Dd*K*b1*f*fd - 1056*D1*Dd*b1*f**2*r**2 - 2112*D1*Dd*b1*f**2*r*s + 1584*D1*Dd*b1*f**2*r - 1056*D1*Dd*b1*f**2*s**2 + 1584*D1*Dd*b1*f**2*s - 792*D1*Dd*b1*f**2 + 9504*D1*Dd*b1*f*fd*r**2 + 19008*D1*Dd*b1*f*fd*r*s - 11880*D1*Dd*b1*f*fd*r + 9504*D1*Dd*b1*f*fd*s**2 - 11880*D1*Dd*b1*f*fd*s + 3564*D1*Dd*b1*f*fd + 6740*D1*Dd*f**4*r**2 + 13480*D1*Dd*f**4*r*s - 10110*D1*Dd*f**4*r + 6740*D1*Dd*f**4*s**2 - 10110*D1*Dd*f**4*s + 5055*D1*Dd*f**4 - 56000*D1*Dd*f**3*fd*r**2 - 112000*D1*Dd*f**3*fd*r*s + 84000*D1*Dd*f**3*fd*r - 56000*D1*Dd*f**3*fd*s**2 + 84000*D1*Dd*f**3*fd*s - 31500*D1*Dd*f**3*fd - 2112*D1*Dd*f**3*r**2 - 4224*D1*Dd*f**3*r*s + 3168*D1*Dd*f**3*r - 2112*D1*Dd*f**3*s**2 + 3168*D1*Dd*f**3*s - 1584*D1*Dd*f**3 + 15840*D1*Dd*f**2*fd*r**2 + 31680*D1*Dd*f**2*fd*r*s - 22440*D1*Dd*f**2*fd*r + 15840*D1*Dd*f**2*fd*s**2 - 22440*D1*Dd*f**2*fd*s + 7920*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*g2*r**2 - 4224*D1*Dd*f**2*g2*r*s + 3168*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s**2 + 3168*D1*Dd*f**2*g2*s - 1584*D1*Dd*f**2*g2 + 9504*D1*Dd*f**2*gd2*r**2 + 19008*D1*Dd*f**2*gd2*r*s - 16632*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 19008*D1*Dd*f*fd*g2*r**2 + 38016*D1*Dd*f*fd*g2*r*s - 23760*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 23760*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 2376*D1*Ddd*K*b1*f**2*r**2 - 4752*D1*Ddd*K*b1*f**2*r*s + 3564*D1*Ddd*K*b1*f**2*r - 2376*D1*Ddd*K*b1*f**2*s**2 + 3564*D1*Ddd*K*b1*f**2*s - 1782*D1*Ddd*K*b1*f**2 + 2376*D1*Ddd*b1*f**2*r**2 + 4752*D1*Ddd*b1*f**2*r*s - 3564*D1*Ddd*b1*f**2*r + 2376*D1*Ddd*b1*f**2*s**2 - 3564*D1*Ddd*b1*f**2*s + 1782*D1*Ddd*b1*f**2 - 7000*D1*Ddd*f**4*r**2 - 14000*D1*Ddd*f**4*r*s + 10500*D1*Ddd*f**4*r - 7000*D1*Ddd*f**4*s**2 + 10500*D1*Ddd*f**4*s - 5250*D1*Ddd*f**4 + 2640*D1*Ddd*f**3*r**2 + 5280*D1*Ddd*f**3*r*s - 3960*D1*Ddd*f**3*r + 2640*D1*Ddd*f**3*s**2 - 3960*D1*Ddd*f**3*s + 1980*D1*Ddd*f**3 + 4752*D1*Ddd*f**2*g2*r**2 + 9504*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 + 132*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 9*D1*fd*(2*r + 2*s - 1) - 9*Dd*f*(4*r + 4*s - 3)) - 7128*Dd**2*K*b1*f**2*r**2 - 14256*Dd**2*K*b1*f**2*r*s + 10692*Dd**2*K*b1*f**2*r - 7128*Dd**2*K*b1*f**2*s**2 + 10692*Dd**2*K*b1*f**2*s - 3564*Dd**2*K*b1*f**2 + 7128*Dd**2*b1*f**2*r**2 + 14256*Dd**2*b1*f**2*r*s - 10692*Dd**2*b1*f**2*r + 7128*Dd**2*b1*f**2*s**2 - 10692*Dd**2*b1*f**2*s + 3564*Dd**2*b1*f**2 - 21000*Dd**2*f**4*r**2 - 42000*Dd**2*f**4*r*s + 31500*Dd**2*f**4*r - 21000*Dd**2*f**4*s**2 + 31500*Dd**2*f**4*s - 10500*Dd**2*f**4 + 7920*Dd**2*f**3*r**2 + 15840*Dd**2*f**3*r*s - 11880*Dd**2*f**3*r + 7920*Dd**2*f**3*s**2 - 11880*Dd**2*f**3*s + 3960*Dd**2*f**3 + 14256*Dd**2*f**2*g2*r**2 + 28512*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 7128*Dd**2*f**2*g2)/(385*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**3*k1**5*k2*(-360*C*D1**2*bdd1*f**2*r**2 - 720*C*D1**2*bdd1*f**2*r*s + 720*C*D1**2*bdd1*f**2*r - 360*C*D1**2*bdd1*f**2*s**2 + 720*C*D1**2*bdd1*f**2*s - 360*C*D1**2*bdd1*f**2 + 300*C*D1**2*f**2*fd*r**2 + 600*C*D1**2*f**2*fd*r*s - 400*C*D1**2*f**2*fd*r + 300*C*D1**2*f**2*fd*s**2 - 400*C*D1**2*f**2*fd*s + 200*C*D1**2*f**2*fd - 420*C*D1**2*f**2*fdd*r**2 - 840*C*D1**2*f**2*fdd*r*s + 560*C*D1**2*f**2*fdd*r - 420*C*D1**2*f**2*fdd*s**2 + 560*C*D1**2*f**2*fdd*s - 280*C*D1**2*f**2*fdd - 840*C*D1**2*f*fd**2*r**2 - 1680*C*D1**2*f*fd**2*r*s + 1120*C*D1**2*f*fd**2*r - 840*C*D1**2*f*fd**2*s**2 + 1120*C*D1**2*f*fd**2*s - 280*C*D1**2*f*fd**2 + 400*C*D1*Dd*f**3*r**2 + 800*C*D1*Dd*f**3*r*s - 600*C*D1*Dd*f**3*r + 400*C*D1*Dd*f**3*s**2 - 600*C*D1*Dd*f**3*s + 300*C*D1*Dd*f**3 - 3360*C*D1*Dd*f**2*fd*r**2 - 6720*C*D1*Dd*f**2*fd*r*s + 4760*C*D1*Dd*f**2*fd*r - 3360*C*D1*Dd*f**2*fd*s**2 + 4760*C*D1*Dd*f**2*fd*s - 1680*C*D1*Dd*f**2*fd - 560*C*D1*Ddd*f**3*r**2 - 1120*C*D1*Ddd*f**3*r*s + 840*C*D1*Ddd*f**3*r - 560*C*D1*Ddd*f**3*s**2 + 840*C*D1*Ddd*f**3*s - 420*C*D1*Ddd*f**3 - 1680*C*Dd**2*f**3*r**2 - 3360*C*Dd**2*f**3*r*s + 2520*C*Dd**2*f**3*r - 1680*C*Dd**2*f**3*s**2 + 2520*C*Dd**2*f**3*s - 840*C*Dd**2*f**3 - 90*D1**2*K*bdd1*f**2*r**2 - 180*D1**2*K*bdd1*f**2*r*s + 180*D1**2*K*bdd1*f**2*r - 90*D1**2*K*bdd1*f**2*s**2 + 180*D1**2*K*bdd1*f**2*s - 90*D1**2*K*bdd1*f**2 - 504*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 175*D1**2*bdd1*f**3*r**2 - 350*D1**2*bdd1*f**3*r*s + 350*D1**2*bdd1*f**3*r - 175*D1**2*bdd1*f**3*s**2 + 350*D1**2*bdd1*f**3*s - 175*D1**2*bdd1*f**3 + 405*D1**2*bdd1*f**2*r**2 + 810*D1**2*bdd1*f**2*r*s - 810*D1**2*bdd1*f**2*r + 405*D1**2*bdd1*f**2*s**2 - 810*D1**2*bdd1*f**2*s + 405*D1**2*bdd1*f**2 + 504*D1**2*bdd1*f*g2*r**2 + 1008*D1**2*bdd1*f*g2*r*s - 1008*D1**2*bdd1*f*g2*r + 504*D1**2*bdd1*f*g2*s**2 - 1008*D1**2*bdd1*f*g2*s + 504*D1**2*bdd1*f*g2 - 140*D1**2*f**3*fd*r**2 - 280*D1**2*f**3*fd*r*s + 210*D1**2*f**3*fd*r - 140*D1**2*f**3*fd*s**2 + 210*D1**2*f**3*fd*s - 105*D1**2*f**3*fd - 225*D1**2*f**2*fd*r**2 - 450*D1**2*f**2*fd*r*s + 300*D1**2*f**2*fd*r - 225*D1**2*f**2*fd*s**2 + 300*D1**2*f**2*fd*s - 150*D1**2*f**2*fd + 315*D1**2*f**2*fdd*r**2 + 630*D1**2*f**2*fdd*r*s - 420*D1**2*f**2*fdd*r + 315*D1**2*f**2*fdd*s**2 - 420*D1**2*f**2*fdd*s + 210*D1**2*f**2*fdd - 108*D1**2*f**2*gd2*r**2 - 216*D1**2*f**2*gd2*r*s + 216*D1**2*f**2*gd2*r - 108*D1**2*f**2*gd2*s**2 + 216*D1**2*f**2*gd2*s - 108*D1**2*f**2*gd2 + 180*D1**2*f**2*gdd2*r**2 + 360*D1**2*f**2*gdd2*r*s - 360*D1**2*f**2*gdd2*r + 180*D1**2*f**2*gdd2*s**2 - 360*D1**2*f**2*gdd2*s + 180*D1**2*f**2*gdd2 + 630*D1**2*f*fd**2*r**2 + 1260*D1**2*f*fd**2*r*s - 840*D1**2*f*fd**2*r + 630*D1**2*f*fd**2*s**2 - 840*D1**2*f*fd**2*s + 210*D1**2*f*fd**2 - 216*D1**2*f*fd*g2*r**2 - 432*D1**2*f*fd*g2*r*s + 216*D1**2*f*fd*g2*r - 216*D1**2*f*fd*g2*s**2 + 216*D1**2*f*fd*g2*s - 108*D1**2*f*fd*g2 + 720*D1**2*f*fd*gd2*r**2 + 1440*D1**2*f*fd*gd2*r*s - 1080*D1**2*f*fd*gd2*r + 720*D1**2*f*fd*gd2*s**2 - 1080*D1**2*f*fd*gd2*s + 360*D1**2*f*fd*gd2 + 360*D1**2*f*fdd*g2*r**2 + 720*D1**2*f*fdd*g2*r*s - 360*D1**2*f*fdd*g2*r + 360*D1**2*f*fdd*g2*s**2 - 360*D1**2*f*fdd*g2*s + 180*D1**2*f*fdd*g2 + 360*D1**2*fd**2*g2*r**2 + 720*D1**2*fd**2*g2*r*s - 360*D1**2*fd**2*g2*r + 360*D1**2*fd**2*g2*s**2 - 360*D1**2*fd**2*g2*s - 140*D1*Dd*f**4*r**2 - 280*D1*Dd*f**4*r*s + 210*D1*Dd*f**4*r - 140*D1*Dd*f**4*s**2 + 210*D1*Dd*f**4*s - 105*D1*Dd*f**4 - 300*D1*Dd*f**3*r**2 - 600*D1*Dd*f**3*r*s + 450*D1*Dd*f**3*r - 300*D1*Dd*f**3*s**2 + 450*D1*Dd*f**3*s - 225*D1*Dd*f**3 + 2520*D1*Dd*f**2*fd*r**2 + 5040*D1*Dd*f**2*fd*r*s - 3570*D1*Dd*f**2*fd*r + 2520*D1*Dd*f**2*fd*s**2 - 3570*D1*Dd*f**2*fd*s + 1260*D1*Dd*f**2*fd - 432*D1*Dd*f**2*g2*r**2 - 864*D1*Dd*f**2*g2*r*s + 648*D1*Dd*f**2*g2*r - 432*D1*Dd*f**2*g2*s**2 + 648*D1*Dd*f**2*g2*s - 324*D1*Dd*f**2*g2 + 1440*D1*Dd*f**2*gd2*r**2 + 2880*D1*Dd*f**2*gd2*r*s - 2520*D1*Dd*f**2*gd2*r + 1440*D1*Dd*f**2*gd2*s**2 - 2520*D1*Dd*f**2*gd2*s + 1080*D1*Dd*f**2*gd2 + 2880*D1*Dd*f*fd*g2*r**2 + 5760*D1*Dd*f*fd*g2*r*s - 3600*D1*Dd*f*fd*g2*r + 2880*D1*Dd*f*fd*g2*s**2 - 3600*D1*Dd*f*fd*g2*s + 1080*D1*Dd*f*fd*g2 + 420*D1*Ddd*f**3*r**2 + 840*D1*Ddd*f**3*r*s - 630*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s**2 - 630*D1*Ddd*f**3*s + 315*D1*Ddd*f**3 + 720*D1*Ddd*f**2*g2*r**2 + 1440*D1*Ddd*f**2*g2*r*s - 1080*D1*Ddd*f**2*g2*r + 720*D1*Ddd*f**2*g2*s**2 - 1080*D1*Ddd*f**2*g2*s + 540*D1*Ddd*f**2*g2 + D1*bd1*(D1*(170*f**3*(r + s - 1) + f**2*(216*C*(r + s - 1) - 350*fd*(3*r + 3*s - 2) + (54*K - 243)*(r + s - 1)) - 6*f*(15*fd*(8*C + 2*K - 9)*(2*r + 2*s - 1) + (28*g2 - 168*gd2)*(r + s - 1)) + 1008*fd*g2*(r + s)) - 2*Dd*f*(175*f**2 + 45*f*(8*C + 2*K - 9) - 504*g2)*(4*r + 4*s - 3))*(r + s - 1) + 1260*Dd**2*f**3*r**2 + 2520*Dd**2*f**3*r*s - 1890*Dd**2*f**3*r + 1260*Dd**2*f**3*s**2 - 1890*Dd**2*f**3*s + 630*Dd**2*f**3 + 2160*Dd**2*f**2*g2*r**2 + 4320*Dd**2*f**2*g2*r*s - 3240*Dd**2*f**2*g2*r + 2160*Dd**2*f**2*g2*s**2 - 3240*Dd**2*f**2*g2*s + 1080*Dd**2*f**2*g2 + 84*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(r + s)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(432*C*D1**2*f*fd*r**2 + 864*C*D1**2*f*fd*r*s - 432*C*D1**2*f*fd*r + 432*C*D1**2*f*fd*s**2 - 432*C*D1**2*f*fd*s + 216*C*D1**2*f*fd - 720*C*D1**2*f*fdd*r**2 - 1440*C*D1**2*f*fdd*r*s + 720*C*D1**2*f*fdd*r - 720*C*D1**2*f*fdd*s**2 + 720*C*D1**2*f*fdd*s - 360*C*D1**2*f*fdd - 720*C*D1**2*fd**2*r**2 - 1440*C*D1**2*fd**2*r*s + 720*C*D1**2*fd**2*r - 720*C*D1**2*fd**2*s**2 + 720*C*D1**2*fd**2*s + 864*C*D1*Dd*f**2*r**2 + 1728*C*D1*Dd*f**2*r*s - 1296*C*D1*Dd*f**2*r + 864*C*D1*Dd*f**2*s**2 - 1296*C*D1*Dd*f**2*s + 648*C*D1*Dd*f**2 - 5760*C*D1*Dd*f*fd*r**2 - 11520*C*D1*Dd*f*fd*r*s + 7200*C*D1*Dd*f*fd*r - 5760*C*D1*Dd*f*fd*s**2 + 7200*C*D1*Dd*f*fd*s - 2160*C*D1*Dd*f*fd - 1440*C*D1*Ddd*f**2*r**2 - 2880*C*D1*Ddd*f**2*r*s + 2160*C*D1*Ddd*f**2*r - 1440*C*D1*Ddd*f**2*s**2 + 2160*C*D1*Ddd*f**2*s - 1080*C*D1*Ddd*f**2 - 4320*C*Dd**2*f**2*r**2 - 8640*C*Dd**2*f**2*r*s + 6480*C*Dd**2*f**2*r - 4320*C*Dd**2*f**2*s**2 + 6480*C*Dd**2*f**2*s - 2160*C*Dd**2*f**2 + 108*D1**2*K*f*fd*r**2 + 216*D1**2*K*f*fd*r*s - 108*D1**2*K*f*fd*r + 108*D1**2*K*f*fd*s**2 - 108*D1**2*K*f*fd*s + 54*D1**2*K*f*fd - 180*D1**2*K*f*fdd*r**2 - 360*D1**2*K*f*fdd*r*s + 180*D1**2*K*f*fdd*r - 180*D1**2*K*f*fdd*s**2 + 180*D1**2*K*f*fdd*s - 90*D1**2*K*f*fdd - 180*D1**2*K*fd**2*r**2 - 360*D1**2*K*fd**2*r*s + 180*D1**2*K*fd**2*r - 180*D1**2*K*fd**2*s**2 + 180*D1**2*K*fd**2*s - 504*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 510*D1**2*f**2*fd*r**2 + 1020*D1**2*f**2*fd*r*s - 680*D1**2*f**2*fd*r + 510*D1**2*f**2*fd*s**2 - 680*D1**2*f**2*fd*s + 340*D1**2*f**2*fd - 525*D1**2*f**2*fdd*r**2 - 1050*D1**2*f**2*fdd*r*s + 700*D1**2*f**2*fdd*r - 525*D1**2*f**2*fdd*s**2 + 700*D1**2*f**2*fdd*s - 350*D1**2*f**2*fdd - 1050*D1**2*f*fd**2*r**2 - 2100*D1**2*f*fd**2*r*s + 1400*D1**2*f*fd**2*r - 1050*D1**2*f*fd**2*s**2 + 1400*D1**2*f*fd**2*s - 350*D1**2*f*fd**2 - 486*D1**2*f*fd*r**2 - 972*D1**2*f*fd*r*s + 486*D1**2*f*fd*r - 486*D1**2*f*fd*s**2 + 486*D1**2*f*fd*s - 243*D1**2*f*fd + 810*D1**2*f*fdd*r**2 + 1620*D1**2*f*fdd*r*s - 810*D1**2*f*fdd*r + 810*D1**2*f*fdd*s**2 - 810*D1**2*f*fdd*s + 405*D1**2*f*fdd - 168*D1**2*f*gd2*r**2 - 336*D1**2*f*gd2*r*s + 336*D1**2*f*gd2*r - 168*D1**2*f*gd2*s**2 + 336*D1**2*f*gd2*s - 168*D1**2*f*gd2 + 504*D1**2*f*gdd2*r**2 + 1008*D1**2*f*gdd2*r*s - 1008*D1**2*f*gdd2*r + 504*D1**2*f*gdd2*s**2 - 1008*D1**2*f*gdd2*s + 504*D1**2*f*gdd2 + 810*D1**2*fd**2*r**2 + 1620*D1**2*fd**2*r*s - 810*D1**2*fd**2*r + 810*D1**2*fd**2*s**2 - 810*D1**2*fd**2*s - 168*D1**2*fd*g2*r**2 - 336*D1**2*fd*g2*r*s - 168*D1**2*fd*g2*s**2 + 1008*D1**2*fd*gd2*r**2 + 2016*D1**2*fd*gd2*r*s - 1008*D1**2*fd*gd2*r + 1008*D1**2*fd*gd2*s**2 - 1008*D1**2*fd*gd2*s + 504*D1**2*fdd*g2*r**2 + 1008*D1**2*fdd*g2*r*s + 504*D1**2*fdd*g2*s**2 + 216*D1*Dd*K*f**2*r**2 + 432*D1*Dd*K*f**2*r*s - 324*D1*Dd*K*f**2*r + 216*D1*Dd*K*f**2*s**2 - 324*D1*Dd*K*f**2*s + 162*D1*Dd*K*f**2 - 1440*D1*Dd*K*f*fd*r**2 - 2880*D1*Dd*K*f*fd*r*s + 1800*D1*Dd*K*f*fd*r - 1440*D1*Dd*K*f*fd*s**2 + 1800*D1*Dd*K*f*fd*s - 540*D1*Dd*K*f*fd + 680*D1*Dd*f**3*r**2 + 1360*D1*Dd*f**3*r*s - 1020*D1*Dd*f**3*r + 680*D1*Dd*f**3*s**2 - 1020*D1*Dd*f**3*s + 510*D1*Dd*f**3 - 4200*D1*Dd*f**2*fd*r**2 - 8400*D1*Dd*f**2*fd*r*s + 5950*D1*Dd*f**2*fd*r - 4200*D1*Dd*f**2*fd*s**2 + 5950*D1*Dd*f**2*fd*s - 2100*D1*Dd*f**2*fd - 972*D1*Dd*f**2*r**2 - 1944*D1*Dd*f**2*r*s + 1458*D1*Dd*f**2*r - 972*D1*Dd*f**2*s**2 + 1458*D1*Dd*f**2*s - 729*D1*Dd*f**2 + 6480*D1*Dd*f*fd*r**2 + 12960*D1*Dd*f*fd*r*s - 8100*D1*Dd*f*fd*r + 6480*D1*Dd*f*fd*s**2 - 8100*D1*Dd*f*fd*s + 2430*D1*Dd*f*fd - 672*D1*Dd*f*g2*r**2 - 1344*D1*Dd*f*g2*r*s + 1008*D1*Dd*f*g2*r - 672*D1*Dd*f*g2*s**2 + 1008*D1*Dd*f*g2*s - 504*D1*Dd*f*g2 + 4032*D1*Dd*f*gd2*r**2 + 8064*D1*Dd*f*gd2*r*s - 7056*D1*Dd*f*gd2*r + 4032*D1*Dd*f*gd2*s**2 - 7056*D1*Dd*f*gd2*s + 3024*D1*Dd*f*gd2 + 4032*D1*Dd*fd*g2*r**2 + 8064*D1*Dd*fd*g2*r*s - 3024*D1*Dd*fd*g2*r + 4032*D1*Dd*fd*g2*s**2 - 3024*D1*Dd*fd*g2*s - 360*D1*Ddd*K*f**2*r**2 - 720*D1*Ddd*K*f**2*r*s + 540*D1*Ddd*K*f**2*r - 360*D1*Ddd*K*f**2*s**2 + 540*D1*Ddd*K*f**2*s - 270*D1*Ddd*K*f**2 - 700*D1*Ddd*f**3*r**2 - 1400*D1*Ddd*f**3*r*s + 1050*D1*Ddd*f**3*r - 700*D1*Ddd*f**3*s**2 + 1050*D1*Ddd*f**3*s - 525*D1*Ddd*f**3 + 1620*D1*Ddd*f**2*r**2 + 3240*D1*Ddd*f**2*r*s - 2430*D1*Ddd*f**2*r + 1620*D1*Ddd*f**2*s**2 - 2430*D1*Ddd*f**2*s + 1215*D1*Ddd*f**2 + 2016*D1*Ddd*f*g2*r**2 + 4032*D1*Ddd*f*g2*r*s - 3024*D1*Ddd*f*g2*r + 2016*D1*Ddd*f*g2*s**2 - 3024*D1*Ddd*f*g2*s + 1512*D1*Ddd*f*g2 + 168*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 1080*Dd**2*K*f**2*r**2 - 2160*Dd**2*K*f**2*r*s + 1620*Dd**2*K*f**2*r - 1080*Dd**2*K*f**2*s**2 + 1620*Dd**2*K*f**2*s - 540*Dd**2*K*f**2 - 2100*Dd**2*f**3*r**2 - 4200*Dd**2*f**3*r*s + 3150*Dd**2*f**3*r - 2100*Dd**2*f**3*s**2 + 3150*Dd**2*f**3*s - 1050*Dd**2*f**3 + 4860*Dd**2*f**2*r**2 + 9720*Dd**2*f**2*r*s - 7290*Dd**2*f**2*r + 4860*Dd**2*f**2*s**2 - 7290*Dd**2*f**2*s + 2430*Dd**2*f**2 + 6048*Dd**2*f*g2*r**2 + 12096*Dd**2*f*g2*r*s - 9072*Dd**2*f*g2*r + 6048*Dd**2*f*g2*s**2 - 9072*Dd**2*f*g2*s + 3024*Dd**2*f*g2))/(70*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**3*k1**5*st**2*(1386*C*D1**2*f**2*fd*r*s - 462*C*D1**2*f**2*fd*r + 1386*C*D1**2*f**2*fd*s**2 - 1386*C*D1**2*f**2*fd*s + 462*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 1848*C*D1*Dd*f**3*r*s - 462*C*D1*Dd*f**3*r + 1848*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 462*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 7240*D1**2*f**3*fd*r*s - 1810*D1**2*f**3*fd*r + 7240*D1**2*f**3*fd*s**2 - 7240*D1**2*f**3*fd*s + 1810*D1**2*f**3*fd - 5600*D1**2*f**3*fdd*r*s + 1400*D1**2*f**3*fdd*r - 5600*D1**2*f**3*fdd*s**2 + 5600*D1**2*f**3*fdd*s - 1400*D1**2*f**3*fdd - 16800*D1**2*f**2*fd**2*r*s + 4200*D1**2*f**2*fd**2*r - 16800*D1**2*f**2*fd**2*s**2 + 16800*D1**2*f**2*fd**2*s - 2800*D1**2*f**2*fd**2 - 1386*D1**2*f**2*fd*r*s + 462*D1**2*f**2*fd*r - 1386*D1**2*f**2*fd*s**2 + 1386*D1**2*f**2*fd*s - 462*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*s**2 + 726*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 1452*D1**2*f*fd*g2*r*s + 726*D1**2*f*fd*g2*r - 1452*D1**2*f*fd*g2*s**2 + 1452*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 7240*D1*Dd*f**4*r*s - 1810*D1*Dd*f**4*r + 7240*D1*Dd*f**4*s**2 - 7240*D1*Dd*f**4*s + 1810*D1*Dd*f**4 - 44800*D1*Dd*f**3*fd*r*s + 11200*D1*Dd*f**3*fd*r - 44800*D1*Dd*f**3*fd*s**2 + 44800*D1*Dd*f**3*fd*s - 8400*D1*Dd*f**3*fd - 1848*D1*Dd*f**3*r*s + 462*D1*Dd*f**3*r - 1848*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 462*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 2904*D1*Dd*f**2*g2*r*s + 726*D1*Dd*f**2*g2*r - 2904*D1*Dd*f**2*g2*s**2 + 2904*D1*Dd*f**2*g2*s - 726*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 5600*D1*Ddd*f**4*r*s + 1400*D1*Ddd*f**4*r - 5600*D1*Ddd*f**4*s**2 + 5600*D1*Ddd*f**4*s - 1400*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 16800*Dd**2*f**4*r*s + 4200*Dd**2*f**4*r - 16800*Dd**2*f**4*s**2 + 16800*Dd**2*f**4*s - 2800*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k2*k3**5) - D1**2*Pk2*Pkd3*ct**3*k1**5*(360*C*D1**2*bdd1*f**2*r*s - 360*C*D1**2*bdd1*f**2*r + 360*C*D1**2*bdd1*f**2*s**2 - 720*C*D1**2*bdd1*f**2*s + 360*C*D1**2*bdd1*f**2 + 1680*C*D1**2*f**2*fd*r*s - 560*C*D1**2*f**2*fd*r + 1680*C*D1**2*f**2*fd*s**2 - 1680*C*D1**2*f**2*fd*s + 560*C*D1**2*f**2*fd - 1920*C*D1**2*f**2*fdd*r*s + 640*C*D1**2*f**2*fdd*r - 1920*C*D1**2*f**2*fdd*s**2 + 1920*C*D1**2*f**2*fdd*s - 640*C*D1**2*f**2*fdd - 3840*C*D1**2*f*fd**2*r*s + 1280*C*D1**2*f*fd**2*r - 3840*C*D1**2*f*fd**2*s**2 + 3840*C*D1**2*f*fd**2*s - 640*C*D1**2*f*fd**2 + 2240*C*D1*Dd*f**3*r*s - 560*C*D1*Dd*f**3*r + 2240*C*D1*Dd*f**3*s**2 - 2240*C*D1*Dd*f**3*s + 560*C*D1*Dd*f**3 - 15360*C*D1*Dd*f**2*fd*r*s + 4480*C*D1*Dd*f**2*fd*r - 15360*C*D1*Dd*f**2*fd*s**2 + 15360*C*D1*Dd*f**2*fd*s - 3200*C*D1*Dd*f**2*fd - 2560*C*D1*Ddd*f**3*r*s + 640*C*D1*Ddd*f**3*r - 2560*C*D1*Ddd*f**3*s**2 + 2560*C*D1*Ddd*f**3*s - 640*C*D1*Ddd*f**3 - 7680*C*Dd**2*f**3*r*s + 1920*C*Dd**2*f**3*r - 7680*C*Dd**2*f**3*s**2 + 7680*C*Dd**2*f**3*s - 1280*C*Dd**2*f**3 - 432*D1**2*K*bdd1*f**2*r*s - 432*D1**2*K*bdd1*f**2*s**2 + 432*D1**2*K*bdd1*f**2*s + 252*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 350*D1**2*bdd1*f**3*r**2 + 1120*D1**2*bdd1*f**3*r*s - 910*D1**2*bdd1*f**3*r + 770*D1**2*bdd1*f**3*s**2 - 1330*D1**2*bdd1*f**3*s + 735*D1**2*bdd1*f**3 + 225*D1**2*bdd1*f**2*r**2 + 522*D1**2*bdd1*f**2*r*s - 90*D1**2*bdd1*f**2*r + 297*D1**2*bdd1*f**2*s**2 - 162*D1**2*bdd1*f**2*s - 135*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 504*D1**2*bdd1*f*g2*s**2 + 1008*D1**2*bdd1*f*g2*s - 504*D1**2*bdd1*f*g2 + 1260*D1**2*f**3*fd*r**2 + 6440*D1**2*f**3*fd*r*s - 2870*D1**2*f**3*fd*r + 5180*D1**2*f**3*fd*s**2 - 5810*D1**2*f**3*fd*s + 1925*D1**2*f**3*fd - 1540*D1**2*f**3*fdd*r**2 - 5880*D1**2*f**3*fdd*r*s + 3010*D1**2*f**3*fdd*r - 4340*D1**2*f**3*fdd*s**2 + 5110*D1**2*f**3*fdd*s - 1855*D1**2*f**3*fdd - 4620*D1**2*f**2*fd**2*r**2 - 17640*D1**2*f**2*fd**2*r*s + 9030*D1**2*f**2*fd**2*r - 13020*D1**2*f**2*fd**2*s**2 + 15330*D1**2*f**2*fd**2*s - 3710*D1**2*f**2*fd**2 - 375*D1**2*f**2*fd*r**2 - 2430*D1**2*f**2*fd*r*s + 1060*D1**2*f**2*fd*r - 2055*D1**2*f**2*fd*s**2 + 2180*D1**2*f**2*fd*s - 810*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 2970*D1**2*f**2*fdd*r*s - 1340*D1**2*f**2*fdd*r + 2445*D1**2*f**2*fdd*s**2 - 2620*D1**2*f**2*fdd*s + 990*D1**2*f**2*fdd - 720*D1**2*f**2*gd2*r*s - 720*D1**2*f**2*gd2*s**2 + 720*D1**2*f**2*gd2*s + 864*D1**2*f**2*gdd2*r*s + 864*D1**2*f**2*gdd2*s**2 - 864*D1**2*f**2*gdd2*s + 1050*D1**2*f*fd**2*r**2 + 5940*D1**2*f*fd**2*r*s - 2680*D1**2*f*fd**2*r + 4890*D1**2*f*fd**2*s**2 - 5240*D1**2*f*fd**2*s + 990*D1**2*f*fd**2 - 1440*D1**2*f*fd*g2*r*s + 720*D1**2*f*fd*g2*r - 1440*D1**2*f*fd*g2*s**2 + 1440*D1**2*f*fd*g2*s - 720*D1**2*f*fd*g2 + 3456*D1**2*f*fd*gd2*r*s - 864*D1**2*f*fd*gd2*r + 3456*D1**2*f*fd*gd2*s**2 - 3456*D1**2*f*fd*gd2*s + 864*D1**2*f*fd*gd2 + 1728*D1**2*f*fdd*g2*r*s - 864*D1**2*f*fdd*g2*r + 1728*D1**2*f*fdd*g2*s**2 - 1728*D1**2*f*fdd*g2*s + 864*D1**2*f*fdd*g2 + 1728*D1**2*fd**2*g2*r*s - 864*D1**2*fd**2*g2*r + 1728*D1**2*fd**2*g2*s**2 - 1728*D1**2*fd**2*g2*s + 1260*D1*Dd*f**4*r**2 + 6440*D1*Dd*f**4*r*s - 2870*D1*Dd*f**4*r + 5180*D1*Dd*f**4*s**2 - 5810*D1*Dd*f**4*s + 1925*D1*Dd*f**4 - 12320*D1*Dd*f**3*fd*r**2 - 47040*D1*Dd*f**3*fd*r*s + 24080*D1*Dd*f**3*fd*r - 34720*D1*Dd*f**3*fd*s**2 + 40880*D1*Dd*f**3*fd*s - 11130*D1*Dd*f**3*fd - 500*D1*Dd*f**3*r**2 - 3240*D1*Dd*f**3*r*s + 1310*D1*Dd*f**3*r - 2740*D1*Dd*f**3*s**2 + 2990*D1*Dd*f**3*s - 935*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 23760*D1*Dd*f**2*fd*r*s - 10430*D1*Dd*f**2*fd*r + 19560*D1*Dd*f**2*fd*s**2 - 21310*D1*Dd*f**2*fd*s + 5300*D1*Dd*f**2*fd - 2880*D1*Dd*f**2*g2*r*s + 720*D1*Dd*f**2*g2*r - 2880*D1*Dd*f**2*g2*s**2 + 2880*D1*Dd*f**2*g2*s - 720*D1*Dd*f**2*g2 + 6912*D1*Dd*f**2*gd2*r*s - 864*D1*Dd*f**2*gd2*r + 6912*D1*Dd*f**2*gd2*s**2 - 6912*D1*Dd*f**2*gd2*s + 864*D1*Dd*f**2*gd2 + 13824*D1*Dd*f*fd*g2*r*s - 5184*D1*Dd*f*fd*g2*r + 13824*D1*Dd*f*fd*g2*s**2 - 13824*D1*Dd*f*fd*g2*s + 3456*D1*Dd*f*fd*g2 - 1540*D1*Ddd*f**4*r**2 - 5880*D1*Ddd*f**4*r*s + 3010*D1*Ddd*f**4*r - 4340*D1*Ddd*f**4*s**2 + 5110*D1*Ddd*f**4*s - 1855*D1*Ddd*f**4 + 700*D1*Ddd*f**3*r**2 + 3960*D1*Ddd*f**3*r*s - 1690*D1*Ddd*f**3*r + 3260*D1*Ddd*f**3*s**2 - 3610*D1*Ddd*f**3*s + 1165*D1*Ddd*f**3 + 3456*D1*Ddd*f**2*g2*r*s - 864*D1*Ddd*f**2*g2*r + 3456*D1*Ddd*f**2*g2*s**2 - 3456*D1*Ddd*f**2*g2*s + 864*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(50*r**2 + 2*r*(98*s - 83) + 146*s**2 - 262*s + 141) + f**2*(-216*C*(s - 1)*(r + s - 1) + 140*fd*(15*r**2 + 48*r*s - 31*r + 33*s**2 - 46*s + 12) - (9*r + 9*s - 9)*(-40*K*s + 15*r + 31*s + 9)) + 6*f*(3*fd*(20*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 24*K*(r*(4*s - 1) + (1 - 2*s)**2) + 50*r**2 + 116*r*s - 59*r + 66*s**2 - 71*s + 29) + (28*g2*(s - 1) + 28*gd2*(3 - 6*s))*(r + s - 1)) - 504*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*Dd*f*(35*f**2*(40*r**2 + 8*r*(16*s - 11) + 88*s**2 - 130*s + 45) + 9*f*(20*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 24*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 100*r**2 + 232*r*s - 99*r + 132*s**2 - 127*s + 19) - 252*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 4620*Dd**2*f**4*r**2 - 17640*Dd**2*f**4*r*s + 9030*Dd**2*f**4*r - 13020*Dd**2*f**4*s**2 + 15330*Dd**2*f**4*s - 3710*Dd**2*f**4 + 2100*Dd**2*f**3*r**2 + 11880*Dd**2*f**3*r*s - 5070*Dd**2*f**3*r + 9780*Dd**2*f**3*s**2 - 10830*Dd**2*f**3*s + 2330*Dd**2*f**3 + 10368*Dd**2*f**2*g2*r*s - 2592*Dd**2*f**2*g2*r + 10368*Dd**2*f**2*g2*s**2 - 10368*Dd**2*f**2*g2*s + 1728*Dd**2*f**2*g2 - 84*b1**2*(K - 1)*(D1**2*s*(fd - 3*fdd)*(r + s) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*fd*(-8*r*s + r + s*(4 - 8*s))) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-432*C*D1**2*f*fd*r*s - 432*C*D1**2*f*fd*s**2 + 216*C*D1**2*f*fd*s + 720*C*D1**2*f*fdd*r*s + 720*C*D1**2*f*fdd*s**2 - 360*C*D1**2*f*fdd*s + 720*C*D1**2*fd**2*r*s + 720*C*D1**2*fd**2*s**2 - 360*C*D1**2*fd**2*s - 864*C*D1*Dd*f**2*r*s + 216*C*D1*Dd*f**2*r - 864*C*D1*Dd*f**2*s**2 + 864*C*D1*Dd*f**2*s - 216*C*D1*Dd*f**2 + 5760*C*D1*Dd*f*fd*r*s - 720*C*D1*Dd*f*fd*r + 5760*C*D1*Dd*f*fd*s**2 - 4320*C*D1*Dd*f*fd*s + 360*C*D1*Dd*f*fd + 1440*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 1440*C*D1*Ddd*f**2*s**2 - 1440*C*D1*Ddd*f**2*s + 360*C*D1*Ddd*f**2 + 4320*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 4320*C*Dd**2*f**2*s**2 - 4320*C*Dd**2*f**2*s + 720*C*Dd**2*f**2 + 720*D1**2*K*f*fd*r*s - 360*D1**2*K*f*fd*r + 720*D1**2*K*f*fd*s**2 - 720*D1**2*K*f*fd*s + 360*D1**2*K*f*fd - 864*D1**2*K*f*fdd*r*s + 432*D1**2*K*f*fdd*r - 864*D1**2*K*f*fdd*s**2 + 864*D1**2*K*f*fdd*s - 432*D1**2*K*f*fdd - 864*D1**2*K*fd**2*r*s + 432*D1**2*K*fd**2*r - 864*D1**2*K*fd**2*s**2 + 864*D1**2*K*fd**2*s + 252*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 750*D1**2*f**2*fd*r**2 - 2940*D1**2*f**2*fd*r*s + 1150*D1**2*f**2*fd*r - 2190*D1**2*f**2*fd*s**2 + 2110*D1**2*f**2*fd*s - 525*D1**2*f**2*fd + 1050*D1**2*f**2*fdd*r**2 + 3360*D1**2*f**2*fdd*r*s - 1610*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2450*D1**2*f**2*fdd*s + 735*D1**2*f**2*fdd + 2100*D1**2*f*fd**2*r**2 + 6720*D1**2*f*fd**2*r*s - 3220*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 4900*D1**2*f*fd**2*s + 1260*D1**2*f*fd**2 - 270*D1**2*f*fd*r**2 - 828*D1**2*f*fd*r*s + 630*D1**2*f*fd*r - 558*D1**2*f*fd*s**2 + 774*D1**2*f*fd*s - 495*D1**2*f*fd + 450*D1**2*f*fdd*r**2 + 1044*D1**2*f*fdd*r*s - 882*D1**2*f*fdd*r + 594*D1**2*f*fdd*s**2 - 954*D1**2*f*fdd*s + 657*D1**2*f*fdd + 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s - 504*D1**2*f*gdd2*r*s - 504*D1**2*f*gdd2*s**2 + 504*D1**2*f*gdd2*s + 450*D1**2*fd**2*r**2 + 1044*D1**2*fd**2*r*s - 882*D1**2*fd**2*r + 594*D1**2*fd**2*s**2 - 954*D1**2*fd**2*s + 168*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*s**2 - 1008*D1**2*fd*gd2*r*s - 1008*D1**2*fd*gd2*s**2 + 504*D1**2*fd*gd2*s - 504*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*s**2 + 1440*D1*Dd*K*f**2*r*s - 360*D1*Dd*K*f**2*r + 1440*D1*Dd*K*f**2*s**2 - 1440*D1*Dd*K*f**2*s + 360*D1*Dd*K*f**2 - 6912*D1*Dd*K*f*fd*r*s + 2592*D1*Dd*K*f*fd*r - 6912*D1*Dd*K*f*fd*s**2 + 6912*D1*Dd*K*f*fd*s - 1728*D1*Dd*K*f*fd - 1000*D1*Dd*f**3*r**2 - 3920*D1*Dd*f**3*r*s + 1980*D1*Dd*f**3*r - 2920*D1*Dd*f**3*s**2 + 3420*D1*Dd*f**3*s - 1230*D1*Dd*f**3 + 8400*D1*Dd*f**2*fd*r**2 + 26880*D1*Dd*f**2*fd*r*s - 14000*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 21140*D1*Dd*f**2*fd*s + 5670*D1*Dd*f**2*fd - 540*D1*Dd*f**2*r**2 - 1656*D1*Dd*f**2*r*s + 954*D1*Dd*f**2*r - 1116*D1*Dd*f**2*s**2 + 1386*D1*Dd*f**2*s - 549*D1*Dd*f**2 + 3600*D1*Dd*f*fd*r**2 + 8352*D1*Dd*f*fd*r*s - 6372*D1*Dd*f*fd*r + 4752*D1*Dd*f*fd*s**2 - 7092*D1*Dd*f*fd*s + 2718*D1*Dd*f*fd + 672*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r*s + 504*D1*Dd*f*gd2*r - 4032*D1*Dd*f*gd2*s**2 + 4032*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 4032*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s - 1728*D1*Ddd*K*f**2*r*s + 432*D1*Ddd*K*f**2*r - 1728*D1*Ddd*K*f**2*s**2 + 1728*D1*Ddd*K*f**2*s - 432*D1*Ddd*K*f**2 + 1400*D1*Ddd*f**3*r**2 + 4480*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 3780*D1*Ddd*f**3*s + 1470*D1*Ddd*f**3 + 900*D1*Ddd*f**2*r**2 + 2088*D1*Ddd*f**2*r*s - 1422*D1*Ddd*f**2*r + 1188*D1*Ddd*f**2*s**2 - 1638*D1*Ddd*f**2*s + 747*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 2016*D1*Ddd*f*g2*s**2 + 2016*D1*Ddd*f*g2*s - 504*D1*Ddd*f*g2 - 84*D1*bd1*(K - 1)*(D1*(f*(2*s - 1)*(r + s - 1) + 3*fd*(-4*r*s + r + s*(3 - 4*s))) - 3*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 5184*Dd**2*K*f**2*r*s + 1296*Dd**2*K*f**2*r - 5184*Dd**2*K*f**2*s**2 + 5184*Dd**2*K*f**2*s - 864*Dd**2*K*f**2 + 4200*Dd**2*f**3*r**2 + 13440*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 11340*Dd**2*f**3*s + 2940*Dd**2*f**3 + 2700*Dd**2*f**2*r**2 + 6264*Dd**2*f**2*r*s - 4266*Dd**2*f**2*r + 3564*Dd**2*f**2*s**2 - 4914*Dd**2*f**2*s + 1494*Dd**2*f**2 - 6048*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 6048*Dd**2*f*g2*s**2 + 6048*Dd**2*f*g2*s - 1008*Dd**2*f*g2))/(630*d**2*k2*k3**5) + 3*D1**2*Pk2*Pkd3*ct**3*k1**3*k2**3*st**4*(2244*C*D1**2*f**2*fd*r**2 + 4488*C*D1**2*f**2*fd*r*s - 2992*C*D1**2*f**2*fd*r + 2244*C*D1**2*f**2*fd*s**2 - 2992*C*D1**2*f**2*fd*s + 1496*C*D1**2*f**2*fd - 1320*C*D1**2*f**2*fdd*r**2 - 2640*C*D1**2*f**2*fdd*r*s + 1760*C*D1**2*f**2*fdd*r - 1320*C*D1**2*f**2*fdd*s**2 + 1760*C*D1**2*f**2*fdd*s - 880*C*D1**2*f**2*fdd - 2640*C*D1**2*f*fd**2*r**2 - 5280*C*D1**2*f*fd**2*r*s + 3520*C*D1**2*f*fd**2*r - 2640*C*D1**2*f*fd**2*s**2 + 3520*C*D1**2*f*fd**2*s - 880*C*D1**2*f*fd**2 + 2992*C*D1*Dd*f**3*r**2 + 5984*C*D1*Dd*f**3*r*s - 4488*C*D1*Dd*f**3*r + 2992*C*D1*Dd*f**3*s**2 - 4488*C*D1*Dd*f**3*s + 2244*C*D1*Dd*f**3 - 10560*C*D1*Dd*f**2*fd*r**2 - 21120*C*D1*Dd*f**2*fd*r*s + 14960*C*D1*Dd*f**2*fd*r - 10560*C*D1*Dd*f**2*fd*s**2 + 14960*C*D1*Dd*f**2*fd*s - 5280*C*D1*Dd*f**2*fd - 1760*C*D1*Ddd*f**3*r**2 - 3520*C*D1*Ddd*f**3*r*s + 2640*C*D1*Ddd*f**3*r - 1760*C*D1*Ddd*f**3*s**2 + 2640*C*D1*Ddd*f**3*s - 1320*C*D1*Ddd*f**3 - 5280*C*Dd**2*f**3*r**2 - 10560*C*Dd**2*f**3*r*s + 7920*C*Dd**2*f**3*r - 5280*C*Dd**2*f**3*s**2 + 7920*C*Dd**2*f**3*s - 2640*C*Dd**2*f**3 + 1716*D1**2*K*b1*f*fd*r**2 + 3432*D1**2*K*b1*f*fd*r*s - 1716*D1**2*K*b1*f*fd*r + 1716*D1**2*K*b1*f*fd*s**2 - 1716*D1**2*K*b1*f*fd*s + 858*D1**2*K*b1*f*fd - 1320*D1**2*K*b1*f*fdd*r**2 - 2640*D1**2*K*b1*f*fdd*r*s + 1320*D1**2*K*b1*f*fdd*r - 1320*D1**2*K*b1*f*fdd*s**2 + 1320*D1**2*K*b1*f*fdd*s - 660*D1**2*K*b1*f*fdd - 1320*D1**2*K*b1*fd**2*r**2 - 2640*D1**2*K*b1*fd**2*r*s + 1320*D1**2*K*b1*fd**2*r - 1320*D1**2*K*b1*fd**2*s**2 + 1320*D1**2*K*b1*fd**2*s - 1716*D1**2*b1*f*fd*r**2 - 3432*D1**2*b1*f*fd*r*s + 1716*D1**2*b1*f*fd*r - 1716*D1**2*b1*f*fd*s**2 + 1716*D1**2*b1*f*fd*s - 858*D1**2*b1*f*fd + 1320*D1**2*b1*f*fdd*r**2 + 2640*D1**2*b1*f*fdd*r*s - 1320*D1**2*b1*f*fdd*r + 1320*D1**2*b1*f*fdd*s**2 - 1320*D1**2*b1*f*fdd*s + 660*D1**2*b1*f*fdd + 1320*D1**2*b1*fd**2*r**2 + 2640*D1**2*b1*fd**2*r*s - 1320*D1**2*b1*fd**2*r + 1320*D1**2*b1*fd**2*s**2 - 1320*D1**2*b1*fd**2*s - 660*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 5680*D1**2*f**3*fd*r**2 + 11360*D1**2*f**3*fd*r*s - 8520*D1**2*f**3*fd*r + 5680*D1**2*f**3*fd*s**2 - 8520*D1**2*f**3*fd*s + 4260*D1**2*f**3*fd - 3500*D1**2*f**3*fdd*r**2 - 7000*D1**2*f**3*fdd*r*s + 5250*D1**2*f**3*fdd*r - 3500*D1**2*f**3*fdd*s**2 + 5250*D1**2*f**3*fdd*s - 2625*D1**2*f**3*fdd - 10500*D1**2*f**2*fd**2*r**2 - 21000*D1**2*f**2*fd**2*r*s + 15750*D1**2*f**2*fd**2*r - 10500*D1**2*f**2*fd**2*s**2 + 15750*D1**2*f**2*fd**2*s - 5250*D1**2*f**2*fd**2 - 2244*D1**2*f**2*fd*r**2 - 4488*D1**2*f**2*fd*r*s + 2992*D1**2*f**2*fd*r - 2244*D1**2*f**2*fd*s**2 + 2992*D1**2*f**2*fd*s - 1496*D1**2*f**2*fd + 1320*D1**2*f**2*fdd*r**2 + 2640*D1**2*f**2*fdd*r*s - 1760*D1**2*f**2*fdd*r + 1320*D1**2*f**2*fdd*s**2 - 1760*D1**2*f**2*fdd*s + 880*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 2640*D1**2*f*fd**2*r**2 + 5280*D1**2*f*fd**2*r*s - 3520*D1**2*f*fd**2*r + 2640*D1**2*f*fd**2*s**2 - 3520*D1**2*f*fd**2*s + 880*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s + 3432*D1*Dd*K*b1*f**2*r**2 + 6864*D1*Dd*K*b1*f**2*r*s - 5148*D1*Dd*K*b1*f**2*r + 3432*D1*Dd*K*b1*f**2*s**2 - 5148*D1*Dd*K*b1*f**2*s + 2574*D1*Dd*K*b1*f**2 - 10560*D1*Dd*K*b1*f*fd*r**2 - 21120*D1*Dd*K*b1*f*fd*r*s + 13200*D1*Dd*K*b1*f*fd*r - 10560*D1*Dd*K*b1*f*fd*s**2 + 13200*D1*Dd*K*b1*f*fd*s - 3960*D1*Dd*K*b1*f*fd - 3432*D1*Dd*b1*f**2*r**2 - 6864*D1*Dd*b1*f**2*r*s + 5148*D1*Dd*b1*f**2*r - 3432*D1*Dd*b1*f**2*s**2 + 5148*D1*Dd*b1*f**2*s - 2574*D1*Dd*b1*f**2 + 10560*D1*Dd*b1*f*fd*r**2 + 21120*D1*Dd*b1*f*fd*r*s - 13200*D1*Dd*b1*f*fd*r + 10560*D1*Dd*b1*f*fd*s**2 - 13200*D1*Dd*b1*f*fd*s + 3960*D1*Dd*b1*f*fd + 5680*D1*Dd*f**4*r**2 + 11360*D1*Dd*f**4*r*s - 8520*D1*Dd*f**4*r + 5680*D1*Dd*f**4*s**2 - 8520*D1*Dd*f**4*s + 4260*D1*Dd*f**4 - 28000*D1*Dd*f**3*fd*r**2 - 56000*D1*Dd*f**3*fd*r*s + 42000*D1*Dd*f**3*fd*r - 28000*D1*Dd*f**3*fd*s**2 + 42000*D1*Dd*f**3*fd*s - 15750*D1*Dd*f**3*fd - 2992*D1*Dd*f**3*r**2 - 5984*D1*Dd*f**3*r*s + 4488*D1*Dd*f**3*r - 2992*D1*Dd*f**3*s**2 + 4488*D1*Dd*f**3*s - 2244*D1*Dd*f**3 + 10560*D1*Dd*f**2*fd*r**2 + 21120*D1*Dd*f**2*fd*r*s - 14960*D1*Dd*f**2*fd*r + 10560*D1*Dd*f**2*fd*s**2 - 14960*D1*Dd*f**2*fd*s + 5280*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 - 2640*D1*Ddd*K*b1*f**2*r**2 - 5280*D1*Ddd*K*b1*f**2*r*s + 3960*D1*Ddd*K*b1*f**2*r - 2640*D1*Ddd*K*b1*f**2*s**2 + 3960*D1*Ddd*K*b1*f**2*s - 1980*D1*Ddd*K*b1*f**2 + 2640*D1*Ddd*b1*f**2*r**2 + 5280*D1*Ddd*b1*f**2*r*s - 3960*D1*Ddd*b1*f**2*r + 2640*D1*Ddd*b1*f**2*s**2 - 3960*D1*Ddd*b1*f**2*s + 1980*D1*Ddd*b1*f**2 - 3500*D1*Ddd*f**4*r**2 - 7000*D1*Ddd*f**4*r*s + 5250*D1*Ddd*f**4*r - 3500*D1*Ddd*f**4*s**2 + 5250*D1*Ddd*f**4*s - 2625*D1*Ddd*f**4 + 1760*D1*Ddd*f**3*r**2 + 3520*D1*Ddd*f**3*r*s - 2640*D1*Ddd*f**3*r + 1760*D1*Ddd*f**3*s**2 - 2640*D1*Ddd*f**3*s + 1320*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(K - 1)*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 7920*Dd**2*K*b1*f**2*r**2 - 15840*Dd**2*K*b1*f**2*r*s + 11880*Dd**2*K*b1*f**2*r - 7920*Dd**2*K*b1*f**2*s**2 + 11880*Dd**2*K*b1*f**2*s - 3960*Dd**2*K*b1*f**2 + 7920*Dd**2*b1*f**2*r**2 + 15840*Dd**2*b1*f**2*r*s - 11880*Dd**2*b1*f**2*r + 7920*Dd**2*b1*f**2*s**2 - 11880*Dd**2*b1*f**2*s + 3960*Dd**2*b1*f**2 - 10500*Dd**2*f**4*r**2 - 21000*Dd**2*f**4*r*s + 15750*Dd**2*f**4*r - 10500*Dd**2*f**4*s**2 + 15750*Dd**2*f**4*s - 5250*Dd**2*f**4 + 5280*Dd**2*f**3*r**2 + 10560*Dd**2*f**3*r*s - 7920*Dd**2*f**3*r + 5280*Dd**2*f**3*s**2 - 7920*Dd**2*f**3*s + 2640*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2)/(770*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**3*k1**3*k2**3*st**2*(-108*C*D1**2*bdd1*f**2*r**2 - 216*C*D1**2*bdd1*f**2*r*s + 216*C*D1**2*bdd1*f**2*r - 108*C*D1**2*bdd1*f**2*s**2 + 216*C*D1**2*bdd1*f**2*s - 108*C*D1**2*bdd1*f**2 + 1026*C*D1**2*f**2*fd*r**2 + 2052*C*D1**2*f**2*fd*r*s - 1368*C*D1**2*f**2*fd*r + 1026*C*D1**2*f**2*fd*s**2 - 1368*C*D1**2*f**2*fd*s + 684*C*D1**2*f**2*fd - 1080*C*D1**2*f**2*fdd*r**2 - 2160*C*D1**2*f**2*fdd*r*s + 1440*C*D1**2*f**2*fdd*r - 1080*C*D1**2*f**2*fdd*s**2 + 1440*C*D1**2*f**2*fdd*s - 720*C*D1**2*f**2*fdd - 2160*C*D1**2*f*fd**2*r**2 - 4320*C*D1**2*f*fd**2*r*s + 2880*C*D1**2*f*fd**2*r - 2160*C*D1**2*f*fd**2*s**2 + 2880*C*D1**2*f*fd**2*s - 720*C*D1**2*f*fd**2 + 1368*C*D1*Dd*f**3*r**2 + 2736*C*D1*Dd*f**3*r*s - 2052*C*D1*Dd*f**3*r + 1368*C*D1*Dd*f**3*s**2 - 2052*C*D1*Dd*f**3*s + 1026*C*D1*Dd*f**3 - 8640*C*D1*Dd*f**2*fd*r**2 - 17280*C*D1*Dd*f**2*fd*r*s + 12240*C*D1*Dd*f**2*fd*r - 8640*C*D1*Dd*f**2*fd*s**2 + 12240*C*D1*Dd*f**2*fd*s - 4320*C*D1*Dd*f**2*fd - 1440*C*D1*Ddd*f**3*r**2 - 2880*C*D1*Ddd*f**3*r*s + 2160*C*D1*Ddd*f**3*r - 1440*C*D1*Ddd*f**3*s**2 + 2160*C*D1*Ddd*f**3*s - 1080*C*D1*Ddd*f**3 - 4320*C*Dd**2*f**3*r**2 - 8640*C*Dd**2*f**3*r*s + 6480*C*Dd**2*f**3*r - 4320*C*Dd**2*f**3*s**2 + 6480*C*Dd**2*f**3*s - 2160*C*Dd**2*f**3 - 324*D1**2*K*bdd1*f**2*r**2 - 648*D1**2*K*bdd1*f**2*r*s + 648*D1**2*K*bdd1*f**2*r - 324*D1**2*K*bdd1*f**2*s**2 + 648*D1**2*K*bdd1*f**2*s - 324*D1**2*K*bdd1*f**2 - 252*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 125*D1**2*bdd1*f**3*r**2 + 250*D1**2*bdd1*f**3*r*s - 250*D1**2*bdd1*f**3*r + 125*D1**2*bdd1*f**3*s**2 - 250*D1**2*bdd1*f**3*s + 125*D1**2*bdd1*f**3 + 270*D1**2*bdd1*f**2*r**2 + 540*D1**2*bdd1*f**2*r*s - 540*D1**2*bdd1*f**2*r + 270*D1**2*bdd1*f**2*s**2 - 540*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s - 504*D1**2*bdd1*f*g2*r + 252*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 - 300*D1**2*f**3*fd*r**2 - 600*D1**2*f**3*fd*r*s + 450*D1**2*f**3*fd*r - 300*D1**2*f**3*fd*s**2 + 450*D1**2*f**3*fd*s - 225*D1**2*f**3*fd - 729*D1**2*f**2*fd*r**2 - 1458*D1**2*f**2*fd*r*s + 972*D1**2*f**2*fd*r - 729*D1**2*f**2*fd*s**2 + 972*D1**2*f**2*fd*s - 486*D1**2*f**2*fd + 810*D1**2*f**2*fdd*r**2 + 1620*D1**2*f**2*fdd*r*s - 1080*D1**2*f**2*fdd*r + 810*D1**2*f**2*fdd*s**2 - 1080*D1**2*f**2*fdd*s + 540*D1**2*f**2*fdd - 414*D1**2*f**2*gd2*r**2 - 828*D1**2*f**2*gd2*r*s + 828*D1**2*f**2*gd2*r - 414*D1**2*f**2*gd2*s**2 + 828*D1**2*f**2*gd2*s - 414*D1**2*f**2*gd2 + 648*D1**2*f**2*gdd2*r**2 + 1296*D1**2*f**2*gdd2*r*s - 1296*D1**2*f**2*gdd2*r + 648*D1**2*f**2*gdd2*s**2 - 1296*D1**2*f**2*gdd2*s + 648*D1**2*f**2*gdd2 + 1620*D1**2*f*fd**2*r**2 + 3240*D1**2*f*fd**2*r*s - 2160*D1**2*f*fd**2*r + 1620*D1**2*f*fd**2*s**2 - 2160*D1**2*f*fd**2*s + 540*D1**2*f*fd**2 - 828*D1**2*f*fd*g2*r**2 - 1656*D1**2*f*fd*g2*r*s + 828*D1**2*f*fd*g2*r - 828*D1**2*f*fd*g2*s**2 + 828*D1**2*f*fd*g2*s - 414*D1**2*f*fd*g2 + 2592*D1**2*f*fd*gd2*r**2 + 5184*D1**2*f*fd*gd2*r*s - 3888*D1**2*f*fd*gd2*r + 2592*D1**2*f*fd*gd2*s**2 - 3888*D1**2*f*fd*gd2*s + 1296*D1**2*f*fd*gd2 + 1296*D1**2*f*fdd*g2*r**2 + 2592*D1**2*f*fdd*g2*r*s - 1296*D1**2*f*fdd*g2*r + 1296*D1**2*f*fdd*g2*s**2 - 1296*D1**2*f*fdd*g2*s + 648*D1**2*f*fdd*g2 + 1296*D1**2*fd**2*g2*r**2 + 2592*D1**2*fd**2*g2*r*s - 1296*D1**2*fd**2*g2*r + 1296*D1**2*fd**2*g2*s**2 - 1296*D1**2*fd**2*g2*s - 300*D1*Dd*f**4*r**2 - 600*D1*Dd*f**4*r*s + 450*D1*Dd*f**4*r - 300*D1*Dd*f**4*s**2 + 450*D1*Dd*f**4*s - 225*D1*Dd*f**4 - 972*D1*Dd*f**3*r**2 - 1944*D1*Dd*f**3*r*s + 1458*D1*Dd*f**3*r - 972*D1*Dd*f**3*s**2 + 1458*D1*Dd*f**3*s - 729*D1*Dd*f**3 + 6480*D1*Dd*f**2*fd*r**2 + 12960*D1*Dd*f**2*fd*r*s - 9180*D1*Dd*f**2*fd*r + 6480*D1*Dd*f**2*fd*s**2 - 9180*D1*Dd*f**2*fd*s + 3240*D1*Dd*f**2*fd - 1656*D1*Dd*f**2*g2*r**2 - 3312*D1*Dd*f**2*g2*r*s + 2484*D1*Dd*f**2*g2*r - 1656*D1*Dd*f**2*g2*s**2 + 2484*D1*Dd*f**2*g2*s - 1242*D1*Dd*f**2*g2 + 5184*D1*Dd*f**2*gd2*r**2 + 10368*D1*Dd*f**2*gd2*r*s - 9072*D1*Dd*f**2*gd2*r + 5184*D1*Dd*f**2*gd2*s**2 - 9072*D1*Dd*f**2*gd2*s + 3888*D1*Dd*f**2*gd2 + 10368*D1*Dd*f*fd*g2*r**2 + 20736*D1*Dd*f*fd*g2*r*s - 12960*D1*Dd*f*fd*g2*r + 10368*D1*Dd*f*fd*g2*s**2 - 12960*D1*Dd*f*fd*g2*s + 3888*D1*Dd*f*fd*g2 + 1080*D1*Ddd*f**3*r**2 + 2160*D1*Ddd*f**3*r*s - 1620*D1*Ddd*f**3*r + 1080*D1*Ddd*f**3*s**2 - 1620*D1*Ddd*f**3*s + 810*D1*Ddd*f**3 + 2592*D1*Ddd*f**2*g2*r**2 + 5184*D1*Ddd*f**2*g2*r*s - 3888*D1*Ddd*f**2*g2*r + 2592*D1*Ddd*f**2*g2*s**2 - 3888*D1*Ddd*f**2*g2*s + 1944*D1*Ddd*f**2*g2 - D1*bd1*(D1*(97*f**3*(r + s - 1) - f**2*(174*C*(r + s - 1) + 250*fd*(3*r + 3*s - 2) + (207*K - 246)*(r + s - 1)) + 6*f*(18*fd*(2*C + 6*K - 5)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) - 504*fd*g2*(r + s)) - 2*Dd*f*(125*f**2 - 54*f*(2*C + 6*K - 5) + 252*g2)*(4*r + 4*s - 3))*(r + s - 1) + 3240*Dd**2*f**3*r**2 + 6480*Dd**2*f**3*r*s - 4860*Dd**2*f**3*r + 3240*Dd**2*f**3*s**2 - 4860*Dd**2*f**3*s + 1620*Dd**2*f**3 + 7776*Dd**2*f**2*g2*r**2 + 15552*Dd**2*f**2*g2*r*s - 11664*Dd**2*f**2*g2*r + 7776*Dd**2*f**2*g2*s**2 - 11664*Dd**2*f**2*g2*s + 3888*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(348*C*D1**2*f*fd*r**2 + 696*C*D1**2*f*fd*r*s - 348*C*D1**2*f*fd*r + 348*C*D1**2*f*fd*s**2 - 348*C*D1**2*f*fd*s + 174*C*D1**2*f*fd - 216*C*D1**2*f*fdd*r**2 - 432*C*D1**2*f*fdd*r*s + 216*C*D1**2*f*fdd*r - 216*C*D1**2*f*fdd*s**2 + 216*C*D1**2*f*fdd*s - 108*C*D1**2*f*fdd - 216*C*D1**2*fd**2*r**2 - 432*C*D1**2*fd**2*r*s + 216*C*D1**2*fd**2*r - 216*C*D1**2*fd**2*s**2 + 216*C*D1**2*fd**2*s + 696*C*D1*Dd*f**2*r**2 + 1392*C*D1*Dd*f**2*r*s - 1044*C*D1*Dd*f**2*r + 696*C*D1*Dd*f**2*s**2 - 1044*C*D1*Dd*f**2*s + 522*C*D1*Dd*f**2 - 1728*C*D1*Dd*f*fd*r**2 - 3456*C*D1*Dd*f*fd*r*s + 2160*C*D1*Dd*f*fd*r - 1728*C*D1*Dd*f*fd*s**2 + 2160*C*D1*Dd*f*fd*s - 648*C*D1*Dd*f*fd - 432*C*D1*Ddd*f**2*r**2 - 864*C*D1*Ddd*f**2*r*s + 648*C*D1*Ddd*f**2*r - 432*C*D1*Ddd*f**2*s**2 + 648*C*D1*Ddd*f**2*s - 324*C*D1*Ddd*f**2 - 1296*C*Dd**2*f**2*r**2 - 2592*C*Dd**2*f**2*r*s + 1944*C*Dd**2*f**2*r - 1296*C*Dd**2*f**2*s**2 + 1944*C*Dd**2*f**2*s - 648*C*Dd**2*f**2 + 414*D1**2*K*f*fd*r**2 + 828*D1**2*K*f*fd*r*s - 414*D1**2*K*f*fd*r + 414*D1**2*K*f*fd*s**2 - 414*D1**2*K*f*fd*s + 207*D1**2*K*f*fd - 648*D1**2*K*f*fdd*r**2 - 1296*D1**2*K*f*fdd*r*s + 648*D1**2*K*f*fdd*r - 648*D1**2*K*f*fdd*s**2 + 648*D1**2*K*f*fdd*s - 324*D1**2*K*f*fdd - 648*D1**2*K*fd**2*r**2 - 1296*D1**2*K*fd**2*r*s + 648*D1**2*K*fd**2*r - 648*D1**2*K*fd**2*s**2 + 648*D1**2*K*fd**2*s - 252*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 291*D1**2*f**2*fd*r**2 - 582*D1**2*f**2*fd*r*s + 388*D1**2*f**2*fd*r - 291*D1**2*f**2*fd*s**2 + 388*D1**2*f**2*fd*s - 194*D1**2*f**2*fd + 375*D1**2*f**2*fdd*r**2 + 750*D1**2*f**2*fdd*r*s - 500*D1**2*f**2*fdd*r + 375*D1**2*f**2*fdd*s**2 - 500*D1**2*f**2*fdd*s + 250*D1**2*f**2*fdd + 750*D1**2*f*fd**2*r**2 + 1500*D1**2*f*fd**2*r*s - 1000*D1**2*f*fd**2*r + 750*D1**2*f*fd**2*s**2 - 1000*D1**2*f*fd**2*s + 250*D1**2*f*fd**2 - 492*D1**2*f*fd*r**2 - 984*D1**2*f*fd*r*s + 492*D1**2*f*fd*r - 492*D1**2*f*fd*s**2 + 492*D1**2*f*fd*s - 246*D1**2*f*fd + 540*D1**2*f*fdd*r**2 + 1080*D1**2*f*fdd*r*s - 540*D1**2*f*fdd*r + 540*D1**2*f*fdd*s**2 - 540*D1**2*f*fdd*s + 270*D1**2*f*fdd - 294*D1**2*f*gd2*r**2 - 588*D1**2*f*gd2*r*s + 588*D1**2*f*gd2*r - 294*D1**2*f*gd2*s**2 + 588*D1**2*f*gd2*s - 294*D1**2*f*gd2 + 252*D1**2*f*gdd2*r**2 + 504*D1**2*f*gdd2*r*s - 504*D1**2*f*gdd2*r + 252*D1**2*f*gdd2*s**2 - 504*D1**2*f*gdd2*s + 252*D1**2*f*gdd2 + 540*D1**2*fd**2*r**2 + 1080*D1**2*fd**2*r*s - 540*D1**2*fd**2*r + 540*D1**2*fd**2*s**2 - 540*D1**2*fd**2*s - 294*D1**2*fd*g2*r**2 - 588*D1**2*fd*g2*r*s - 294*D1**2*fd*g2*s**2 + 504*D1**2*fd*gd2*r**2 + 1008*D1**2*fd*gd2*r*s - 504*D1**2*fd*gd2*r + 504*D1**2*fd*gd2*s**2 - 504*D1**2*fd*gd2*s + 252*D1**2*fdd*g2*r**2 + 504*D1**2*fdd*g2*r*s + 252*D1**2*fdd*g2*s**2 + 828*D1*Dd*K*f**2*r**2 + 1656*D1*Dd*K*f**2*r*s - 1242*D1*Dd*K*f**2*r + 828*D1*Dd*K*f**2*s**2 - 1242*D1*Dd*K*f**2*s + 621*D1*Dd*K*f**2 - 5184*D1*Dd*K*f*fd*r**2 - 10368*D1*Dd*K*f*fd*r*s + 6480*D1*Dd*K*f*fd*r - 5184*D1*Dd*K*f*fd*s**2 + 6480*D1*Dd*K*f*fd*s - 1944*D1*Dd*K*f*fd - 388*D1*Dd*f**3*r**2 - 776*D1*Dd*f**3*r*s + 582*D1*Dd*f**3*r - 388*D1*Dd*f**3*s**2 + 582*D1*Dd*f**3*s - 291*D1*Dd*f**3 + 3000*D1*Dd*f**2*fd*r**2 + 6000*D1*Dd*f**2*fd*r*s - 4250*D1*Dd*f**2*fd*r + 3000*D1*Dd*f**2*fd*s**2 - 4250*D1*Dd*f**2*fd*s + 1500*D1*Dd*f**2*fd - 984*D1*Dd*f**2*r**2 - 1968*D1*Dd*f**2*r*s + 1476*D1*Dd*f**2*r - 984*D1*Dd*f**2*s**2 + 1476*D1*Dd*f**2*s - 738*D1*Dd*f**2 + 4320*D1*Dd*f*fd*r**2 + 8640*D1*Dd*f*fd*r*s - 5400*D1*Dd*f*fd*r + 4320*D1*Dd*f*fd*s**2 - 5400*D1*Dd*f*fd*s + 1620*D1*Dd*f*fd - 1176*D1*Dd*f*g2*r**2 - 2352*D1*Dd*f*g2*r*s + 1764*D1*Dd*f*g2*r - 1176*D1*Dd*f*g2*s**2 + 1764*D1*Dd*f*g2*s - 882*D1*Dd*f*g2 + 2016*D1*Dd*f*gd2*r**2 + 4032*D1*Dd*f*gd2*r*s - 3528*D1*Dd*f*gd2*r + 2016*D1*Dd*f*gd2*s**2 - 3528*D1*Dd*f*gd2*s + 1512*D1*Dd*f*gd2 + 2016*D1*Dd*fd*g2*r**2 + 4032*D1*Dd*fd*g2*r*s - 1512*D1*Dd*fd*g2*r + 2016*D1*Dd*fd*g2*s**2 - 1512*D1*Dd*fd*g2*s - 1296*D1*Ddd*K*f**2*r**2 - 2592*D1*Ddd*K*f**2*r*s + 1944*D1*Ddd*K*f**2*r - 1296*D1*Ddd*K*f**2*s**2 + 1944*D1*Ddd*K*f**2*s - 972*D1*Ddd*K*f**2 + 500*D1*Ddd*f**3*r**2 + 1000*D1*Ddd*f**3*r*s - 750*D1*Ddd*f**3*r + 500*D1*Ddd*f**3*s**2 - 750*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 + 1080*D1*Ddd*f**2*r**2 + 2160*D1*Ddd*f**2*r*s - 1620*D1*Ddd*f**2*r + 1080*D1*Ddd*f**2*s**2 - 1620*D1*Ddd*f**2*s + 810*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r**2 + 2016*D1*Ddd*f*g2*r*s - 1512*D1*Ddd*f*g2*r + 1008*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 756*D1*Ddd*f*g2 + 42*D1*bd1*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3888*Dd**2*K*f**2*r**2 - 7776*Dd**2*K*f**2*r*s + 5832*Dd**2*K*f**2*r - 3888*Dd**2*K*f**2*s**2 + 5832*Dd**2*K*f**2*s - 1944*Dd**2*K*f**2 + 1500*Dd**2*f**3*r**2 + 3000*Dd**2*f**3*r*s - 2250*Dd**2*f**3*r + 1500*Dd**2*f**3*s**2 - 2250*Dd**2*f**3*s + 750*Dd**2*f**3 + 3240*Dd**2*f**2*r**2 + 6480*Dd**2*f**2*r*s - 4860*Dd**2*f**2*r + 3240*Dd**2*f**2*s**2 - 4860*Dd**2*f**2*s + 1620*Dd**2*f**2 + 3024*Dd**2*f*g2*r**2 + 6048*Dd**2*f*g2*r*s - 4536*Dd**2*f*g2*r + 3024*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 1512*Dd**2*f*g2))/(35*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**3*k1**3*k2**3*(-1080*C*D1**2*bdd1*f**2*r**2 - 2160*C*D1**2*bdd1*f**2*r*s + 2160*C*D1**2*bdd1*f**2*r - 1080*C*D1**2*bdd1*f**2*s**2 + 2160*C*D1**2*bdd1*f**2*s - 1080*C*D1**2*bdd1*f**2 + 60*C*D1**2*f**2*fd*r**2 + 120*C*D1**2*f**2*fd*r*s - 80*C*D1**2*f**2*fd*r + 60*C*D1**2*f**2*fd*s**2 - 80*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd - 840*C*D1**2*f**2*fdd*r**2 - 1680*C*D1**2*f**2*fdd*r*s + 1120*C*D1**2*f**2*fdd*r - 840*C*D1**2*f**2*fdd*s**2 + 1120*C*D1**2*f**2*fdd*s - 560*C*D1**2*f**2*fdd - 1680*C*D1**2*f*fd**2*r**2 - 3360*C*D1**2*f*fd**2*r*s + 2240*C*D1**2*f*fd**2*r - 1680*C*D1**2*f*fd**2*s**2 + 2240*C*D1**2*f*fd**2*s - 560*C*D1**2*f*fd**2 + 80*C*D1*Dd*f**3*r**2 + 160*C*D1*Dd*f**3*r*s - 120*C*D1*Dd*f**3*r + 80*C*D1*Dd*f**3*s**2 - 120*C*D1*Dd*f**3*s + 60*C*D1*Dd*f**3 - 6720*C*D1*Dd*f**2*fd*r**2 - 13440*C*D1*Dd*f**2*fd*r*s + 9520*C*D1*Dd*f**2*fd*r - 6720*C*D1*Dd*f**2*fd*s**2 + 9520*C*D1*Dd*f**2*fd*s - 3360*C*D1*Dd*f**2*fd - 1120*C*D1*Ddd*f**3*r**2 - 2240*C*D1*Ddd*f**3*r*s + 1680*C*D1*Ddd*f**3*r - 1120*C*D1*Ddd*f**3*s**2 + 1680*C*D1*Ddd*f**3*s - 840*C*D1*Ddd*f**3 - 3360*C*Dd**2*f**3*r**2 - 6720*C*Dd**2*f**3*r*s + 5040*C*Dd**2*f**3*r - 3360*C*Dd**2*f**3*s**2 + 5040*C*Dd**2*f**3*s - 1680*C*Dd**2*f**3 - 180*D1**2*K*bdd1*f**2*r**2 - 360*D1**2*K*bdd1*f**2*r*s + 360*D1**2*K*bdd1*f**2*r - 180*D1**2*K*bdd1*f**2*s**2 + 360*D1**2*K*bdd1*f**2*s - 180*D1**2*K*bdd1*f**2 + 36*D1**2*bd1**2*f*(-42*K + 25*f + 21)*(r + s - 1)**2 + 810*D1**2*bdd1*f**2*r**2 + 1620*D1**2*bdd1*f**2*r*s - 1620*D1**2*bdd1*f**2*r + 810*D1**2*bdd1*f**2*s**2 - 1620*D1**2*bdd1*f**2*s + 810*D1**2*bdd1*f**2 + 1512*D1**2*bdd1*f*g2*r**2 + 3024*D1**2*bdd1*f*g2*r*s - 3024*D1**2*bdd1*f*g2*r + 1512*D1**2*bdd1*f*g2*s**2 - 3024*D1**2*bdd1*f*g2*s + 1512*D1**2*bdd1*f*g2 + 105*D1**2*f**2*fd*r**2 + 210*D1**2*f**2*fd*r*s - 140*D1**2*f**2*fd*r + 105*D1**2*f**2*fd*s**2 - 140*D1**2*f**2*fd*s + 70*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 36*D1**2*f**2*gd2*r**2 + 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*r + 36*D1**2*f**2*gd2*s**2 - 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gd2 + 360*D1**2*f**2*gdd2*r**2 + 720*D1**2*f**2*gdd2*r*s - 720*D1**2*f**2*gdd2*r + 360*D1**2*f**2*gdd2*s**2 - 720*D1**2*f**2*gdd2*s + 360*D1**2*f**2*gdd2 + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 + 72*D1**2*f*fd*g2*r**2 + 144*D1**2*f*fd*g2*r*s - 72*D1**2*f*fd*g2*r + 72*D1**2*f*fd*g2*s**2 - 72*D1**2*f*fd*g2*s + 36*D1**2*f*fd*g2 + 1440*D1**2*f*fd*gd2*r**2 + 2880*D1**2*f*fd*gd2*r*s - 2160*D1**2*f*fd*gd2*r + 1440*D1**2*f*fd*gd2*s**2 - 2160*D1**2*f*fd*gd2*s + 720*D1**2*f*fd*gd2 + 720*D1**2*f*fdd*g2*r**2 + 1440*D1**2*f*fdd*g2*r*s - 720*D1**2*f*fdd*g2*r + 720*D1**2*f*fdd*g2*s**2 - 720*D1**2*f*fdd*g2*s + 360*D1**2*f*fdd*g2 + 720*D1**2*fd**2*g2*r**2 + 1440*D1**2*fd**2*g2*r*s - 720*D1**2*fd**2*g2*r + 720*D1**2*fd**2*g2*s**2 - 720*D1**2*fd**2*g2*s + 140*D1*Dd*f**3*r**2 + 280*D1*Dd*f**3*r*s - 210*D1*Dd*f**3*r + 140*D1*Dd*f**3*s**2 - 210*D1*Dd*f**3*s + 105*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd + 144*D1*Dd*f**2*g2*r**2 + 288*D1*Dd*f**2*g2*r*s - 216*D1*Dd*f**2*g2*r + 144*D1*Dd*f**2*g2*s**2 - 216*D1*Dd*f**2*g2*s + 108*D1*Dd*f**2*g2 + 2880*D1*Dd*f**2*gd2*r**2 + 5760*D1*Dd*f**2*gd2*r*s - 5040*D1*Dd*f**2*gd2*r + 2880*D1*Dd*f**2*gd2*s**2 - 5040*D1*Dd*f**2*gd2*s + 2160*D1*Dd*f**2*gd2 + 5760*D1*Dd*f*fd*g2*r**2 + 11520*D1*Dd*f*fd*g2*r*s - 7200*D1*Dd*f*fd*g2*r + 5760*D1*Dd*f*fd*g2*s**2 - 7200*D1*Dd*f*fd*g2*s + 2160*D1*Dd*f*fd*g2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 1440*D1*Ddd*f**2*g2*r**2 + 2880*D1*Ddd*f**2*g2*r*s - 2160*D1*Ddd*f**2*g2*r + 1440*D1*Ddd*f**2*g2*s**2 - 2160*D1*Ddd*f**2*g2*s + 1080*D1*Ddd*f**2*g2 + 18*D1*bd1*(D1*(f**2*(36*C - K - 20)*(r + s - 1) - 2*f*(5*fd*(12*C + 2*K - 9)*(2*r + 2*s - 1) + (14*g2 - 84*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 2*Dd*f*(5*f*(12*C + 2*K - 9) - 84*g2)*(4*r + 4*s - 3))*(r + s - 1) + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 4320*Dd**2*f**2*g2*r**2 + 8640*Dd**2*f**2*g2*r*s - 6480*Dd**2*f**2*g2*r + 4320*Dd**2*f**2*g2*s**2 - 6480*Dd**2*f**2*g2*s + 2160*Dd**2*f**2*g2 - 3*b1**2*(D1**2*(3*f*(51*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(300*fd**2*(r + s - 1) + 7*fd*(12*K - 1)*(r + s) - 126*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(153*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(300*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (84*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 252*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-42*K + 25*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-42*K + 25*f + 21)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 6*b1*(-6*D1**2*bdd1*f*(-42*K + 25*f + 21)*(r + s - 1)**2 - 3*D1**2*(f*(fd*(36*C - K - 20)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*fdd*(12*C + 2*K - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-28*gd2 + 84*gdd2)*(r + s - 1)**2) + (-2*r - 2*s)*(5*fd**2*(12*C + 2*K - 9)*(r + s - 1) + 14*fd*(g2*(r + s) - 6*gd2*(r + s - 1)) - 42*fdd*g2*(r + s))) + D1*bd1*(D1*(153*f**2*(r + s - 1) - 300*f*fd*(2*r + 2*s - 1) - 7*f*(12*K - 1)*(r + s - 1) + 252*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-42*K + 25*f + 21)*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(f**2*(36*C - K - 20)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(5*fd*(12*C + 2*K - 9)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 14*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 84*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 168*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(5*f*(12*C + 2*K - 9) - 84*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f*(5*f*(12*C + 2*K - 9) - 84*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**3*k1**3*k2*st**4*(1782*C*D1**2*f**2*fd*r*s - 594*C*D1**2*f**2*fd*r + 1782*C*D1**2*f**2*fd*s**2 - 1782*C*D1**2*f**2*fd*s + 594*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 2376*C*D1*Dd*f**3*r*s - 594*C*D1*Dd*f**3*r + 2376*C*D1*Dd*f**3*s**2 - 2376*C*D1*Dd*f**3*s + 594*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 4940*D1**2*f**3*fd*r*s - 1235*D1**2*f**3*fd*r + 4940*D1**2*f**3*fd*s**2 - 4940*D1**2*f**3*fd*s + 1235*D1**2*f**3*fd - 2800*D1**2*f**3*fdd*r*s + 700*D1**2*f**3*fdd*r - 2800*D1**2*f**3*fdd*s**2 + 2800*D1**2*f**3*fdd*s - 700*D1**2*f**3*fdd - 8400*D1**2*f**2*fd**2*r*s + 2100*D1**2*f**2*fd**2*r - 8400*D1**2*f**2*fd**2*s**2 + 8400*D1**2*f**2*fd**2*s - 1400*D1**2*f**2*fd**2 - 1782*D1**2*f**2*fd*r*s + 594*D1**2*f**2*fd*r - 1782*D1**2*f**2*fd*s**2 + 1782*D1**2*f**2*fd*s - 594*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 1518*D1**2*f**2*gd2*r*s - 1518*D1**2*f**2*gd2*s**2 + 1518*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 3036*D1**2*f*fd*g2*r*s + 1518*D1**2*f*fd*g2*r - 3036*D1**2*f*fd*g2*s**2 + 3036*D1**2*f*fd*g2*s - 1518*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 4940*D1*Dd*f**4*r*s - 1235*D1*Dd*f**4*r + 4940*D1*Dd*f**4*s**2 - 4940*D1*Dd*f**4*s + 1235*D1*Dd*f**4 - 22400*D1*Dd*f**3*fd*r*s + 5600*D1*Dd*f**3*fd*r - 22400*D1*Dd*f**3*fd*s**2 + 22400*D1*Dd*f**3*fd*s - 4200*D1*Dd*f**3*fd - 2376*D1*Dd*f**3*r*s + 594*D1*Dd*f**3*r - 2376*D1*Dd*f**3*s**2 + 2376*D1*Dd*f**3*s - 594*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 6072*D1*Dd*f**2*g2*r*s + 1518*D1*Dd*f**2*g2*r - 6072*D1*Dd*f**2*g2*s**2 + 6072*D1*Dd*f**2*g2*s - 1518*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 2800*D1*Ddd*f**4*r*s + 700*D1*Ddd*f**4*r - 2800*D1*Ddd*f**4*s**2 + 2800*D1*Ddd*f**4*s - 700*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 8400*Dd**2*f**4*r*s + 2100*Dd**2*f**4*r - 8400*Dd**2*f**4*s**2 + 8400*Dd**2*f**4*s - 1400*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**3*k1**3*k2*st**2*(270*C*D1**2*bdd1*f**2*r**2 + 864*C*D1**2*bdd1*f**2*r*s - 324*C*D1**2*bdd1*f**2*r + 594*C*D1**2*bdd1*f**2*s**2 - 648*C*D1**2*bdd1*f**2*s + 324*C*D1**2*bdd1*f**2 + 2646*C*D1**2*f**2*fd*r**2 + 3240*C*D1**2*f**2*fd*r*s - 2844*C*D1**2*f**2*fd*r + 594*C*D1**2*f**2*fd*s**2 - 1476*C*D1**2*f**2*fd*s + 1080*C*D1**2*f**2*fd - 2322*C*D1**2*f**2*fdd*r**2 - 3024*C*D1**2*f**2*fdd*r*s + 2556*C*D1**2*f**2*fdd*r - 702*C*D1**2*f**2*fdd*s**2 + 1476*C*D1**2*f**2*fdd*s - 1008*C*D1**2*f**2*fdd - 4644*C*D1**2*f*fd**2*r**2 - 6048*C*D1**2*f*fd**2*r*s + 5112*C*D1**2*f*fd**2*r - 1404*C*D1**2*f*fd**2*s**2 + 2952*C*D1**2*f*fd**2*s - 1008*C*D1**2*f*fd**2 + 3528*C*D1*Dd*f**3*r**2 + 4320*C*D1*Dd*f**3*r*s - 4608*C*D1*Dd*f**3*r + 792*C*D1*Dd*f**3*s**2 - 2556*C*D1*Dd*f**3*s + 1962*C*D1*Dd*f**3 - 18576*C*D1*Dd*f**2*fd*r**2 - 24192*C*D1*Dd*f**2*fd*r*s + 22536*C*D1*Dd*f**2*fd*r - 5616*C*D1*Dd*f**2*fd*s**2 + 13356*C*D1*Dd*f**2*fd*s - 6588*C*D1*Dd*f**2*fd - 3096*C*D1*Ddd*f**3*r**2 - 4032*C*D1*Ddd*f**3*r*s + 4104*C*D1*Ddd*f**3*r - 936*C*D1*Ddd*f**3*s**2 + 2484*C*D1*Ddd*f**3*s - 1782*C*D1*Ddd*f**3 - 9288*C*Dd**2*f**3*r**2 - 12096*C*Dd**2*f**3*r*s + 12312*C*Dd**2*f**3*r - 2808*C*Dd**2*f**3*s**2 + 7452*C*Dd**2*f**3*s - 3564*C*Dd**2*f**3 - 639*D1**2*K*bdd1*f**2*r**2 - 1008*D1**2*K*bdd1*f**2*r*s + 1278*D1**2*K*bdd1*f**2*r - 369*D1**2*K*bdd1*f**2*s**2 + 1008*D1**2*K*bdd1*f**2*s - 639*D1**2*K*bdd1*f**2 + 126*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 8*r*(2*s - 1) + 11*s**2 - 14*s + 3) + 1125*D1**2*bdd1*f**3*r**2 + 2050*D1**2*bdd1*f**3*r*s - 1900*D1**2*bdd1*f**3*r + 925*D1**2*bdd1*f**3*s**2 - 1700*D1**2*bdd1*f**3*s + 1150*D1**2*bdd1*f**3 + 1179*D1**2*bdd1*f**2*r**2 + 2088*D1**2*bdd1*f**2*r*s - 2574*D1**2*bdd1*f**2*r + 909*D1**2*bdd1*f**2*s**2 - 2304*D1**2*bdd1*f**2*s + 1125*D1**2*bdd1*f**2 - 630*D1**2*bdd1*f*g2*r**2 - 2016*D1**2*bdd1*f*g2*r*s + 756*D1**2*bdd1*f*g2*r - 1386*D1**2*bdd1*f*g2*s**2 + 1512*D1**2*bdd1*f*g2*s - 756*D1**2*bdd1*f*g2 + 3900*D1**2*f**3*fd*r**2 + 10200*D1**2*f**3*fd*r*s - 6450*D1**2*f**3*fd*r + 6300*D1**2*f**3*fd*s**2 - 8250*D1**2*f**3*fd*s + 3525*D1**2*f**3*fd - 4500*D1**2*f**3*fdd*r**2 - 9000*D1**2*f**3*fdd*r*s + 6750*D1**2*f**3*fdd*r - 4500*D1**2*f**3*fdd*s**2 + 6750*D1**2*f**3*fdd*s - 3375*D1**2*f**3*fdd - 13500*D1**2*f**2*fd**2*r**2 - 27000*D1**2*f**2*fd**2*r*s + 20250*D1**2*f**2*fd**2*r - 13500*D1**2*f**2*fd**2*s**2 + 20250*D1**2*f**2*fd**2*s - 6750*D1**2*f**2*fd**2 - 4131*D1**2*f**2*fd*r**2 - 6966*D1**2*f**2*fd*r*s + 5076*D1**2*f**2*fd*r - 2835*D1**2*f**2*fd*s**2 + 4212*D1**2*f**2*fd*s - 2322*D1**2*f**2*fd + 3672*D1**2*f**2*fdd*r**2 + 6264*D1**2*f**2*fdd*r*s - 4536*D1**2*f**2*fdd*r + 2592*D1**2*f**2*fdd*s**2 - 3816*D1**2*f**2*fdd*s + 2088*D1**2*f**2*fdd - 1170*D1**2*f**2*gd2*r**2 - 2016*D1**2*f**2*gd2*r*s + 2340*D1**2*f**2*gd2*r - 846*D1**2*f**2*gd2*s**2 + 2016*D1**2*f**2*gd2*s - 1170*D1**2*f**2*gd2 + 1278*D1**2*f**2*gdd2*r**2 + 2016*D1**2*f**2*gdd2*r*s - 2556*D1**2*f**2*gdd2*r + 738*D1**2*f**2*gdd2*s**2 - 2016*D1**2*f**2*gdd2*s + 1278*D1**2*f**2*gdd2 + 7344*D1**2*f*fd**2*r**2 + 12528*D1**2*f*fd**2*r*s - 9072*D1**2*f*fd**2*r + 5184*D1**2*f*fd**2*s**2 - 7632*D1**2*f*fd**2*s + 2088*D1**2*f*fd**2 - 2340*D1**2*f*fd*g2*r**2 - 4032*D1**2*f*fd*g2*r*s + 2016*D1**2*f*fd*g2*r - 1692*D1**2*f*fd*g2*s**2 + 1692*D1**2*f*fd*g2*s - 846*D1**2*f*fd*g2 + 5112*D1**2*f*fd*gd2*r**2 + 8064*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 2952*D1**2*f*fd*gd2*s**2 - 5508*D1**2*f*fd*gd2*s + 2016*D1**2*f*fd*gd2 + 2556*D1**2*f*fdd*g2*r**2 + 4032*D1**2*f*fdd*g2*r*s - 2016*D1**2*f*fdd*g2*r + 1476*D1**2*f*fdd*g2*s**2 - 1476*D1**2*f*fdd*g2*s + 738*D1**2*f*fdd*g2 + 2556*D1**2*fd**2*g2*r**2 + 4032*D1**2*fd**2*g2*r*s - 2016*D1**2*fd**2*g2*r + 1476*D1**2*fd**2*g2*s**2 - 1476*D1**2*fd**2*g2*s + 3900*D1*Dd*f**4*r**2 + 10200*D1*Dd*f**4*r*s - 6450*D1*Dd*f**4*r + 6300*D1*Dd*f**4*s**2 - 8250*D1*Dd*f**4*s + 3525*D1*Dd*f**4 - 36000*D1*Dd*f**3*fd*r**2 - 72000*D1*Dd*f**3*fd*r*s + 54000*D1*Dd*f**3*fd*r - 36000*D1*Dd*f**3*fd*s**2 + 54000*D1*Dd*f**3*fd*s - 20250*D1*Dd*f**3*fd - 5508*D1*Dd*f**3*r**2 - 9288*D1*Dd*f**3*r*s + 7830*D1*Dd*f**3*r - 3780*D1*Dd*f**3*s**2 + 6534*D1*Dd*f**3*s - 3699*D1*Dd*f**3 + 29376*D1*Dd*f**2*fd*r**2 + 50112*D1*Dd*f**2*fd*r*s - 39096*D1*Dd*f**2*fd*r + 20736*D1*Dd*f**2*fd*s**2 - 32976*D1*Dd*f**2*fd*s + 12888*D1*Dd*f**2*fd - 4680*D1*Dd*f**2*g2*r**2 - 8064*D1*Dd*f**2*g2*r*s + 6696*D1*Dd*f**2*g2*r - 3384*D1*Dd*f**2*g2*s**2 + 5724*D1*Dd*f**2*g2*s - 3186*D1*Dd*f**2*g2 + 10224*D1*Dd*f**2*gd2*r**2 + 16128*D1*Dd*f**2*gd2*r*s - 17352*D1*Dd*f**2*gd2*r + 5904*D1*Dd*f**2*gd2*s**2 - 13572*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 20448*D1*Dd*f*fd*g2*r**2 + 32256*D1*Dd*f*fd*g2*r*s - 22320*D1*Dd*f*fd*g2*r + 11808*D1*Dd*f*fd*g2*s**2 - 16920*D1*Dd*f*fd*g2*s + 5508*D1*Dd*f*fd*g2 - 4500*D1*Ddd*f**4*r**2 - 9000*D1*Ddd*f**4*r*s + 6750*D1*Ddd*f**4*r - 4500*D1*Ddd*f**4*s**2 + 6750*D1*Ddd*f**4*s - 3375*D1*Ddd*f**4 + 4896*D1*Ddd*f**3*r**2 + 8352*D1*Ddd*f**3*r*s - 6984*D1*Ddd*f**3*r + 3456*D1*Ddd*f**3*s**2 - 5904*D1*Ddd*f**3*s + 3312*D1*Ddd*f**3 + 5112*D1*Ddd*f**2*g2*r**2 + 8064*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 2952*D1*Ddd*f**2*g2*s**2 - 5508*D1*Ddd*f**2*g2*s + 3294*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-f**3*(1215*r**2 + r*(2246*s - 2162) + 1031*s**2 - 1978*s + 1427) + f**2*(-6*C*(55*r**2 + r*(204*s - 94) + 149*s**2 - 188*s + 94) + 9*K*(65*r**2 + 2*r*(56*s - 65) + 47*s**2 - 112*s + 65) + 50*fd*(135*r**2 + 3*r*(82*s - 69) + 111*s**2 - 187*s + 64) - 930*r**2 - 1530*r*s + 1956*r - 600*s**2 + 1626*s - 696) + 6*f*(3*fd*(6*C*(10*r**2 + 16*r*(2*s - 1) + 22*s**2 - 25*s + 3) - K*(142*r**2 + 224*r*s - 198*r + 82*s**2 - 153*s + 56) + 262*r**2 + 464*r*s - 390*r + 202*s**2 - 345*s + 146) + 7*g2*(5*r**2 + r*(36*s - 26) + 31*s**2 - 52*s + 26) - 42*gd2*(5*r**2 + 8*r*(2*s - 1) + 11*s**2 - 14*s + 3)) - 252*fd*g2*(5*r**2 + 8*r*(2*s - 1) + s*(11*s - 11))) + 2*Dd*f*(25*f**2*(180*r**2 + r*(328*s - 283) + 148*s**2 - 255*s + 110) + 9*f*(6*C*(20*r**2 + r*(64*s - 30) + 44*s**2 - 51*s + 12) - K*(284*r**2 + 448*r*s - 482*r + 164*s**2 - 377*s + 198) + 524*r**2 + 928*r*s - 950*r + 404*s**2 - 845*s + 414) - 126*g2*(20*r**2 + r*(64*s - 30) + 44*s**2 - 51*s + 12))) - 13500*Dd**2*f**4*r**2 - 27000*Dd**2*f**4*r*s + 20250*Dd**2*f**4*r - 13500*Dd**2*f**4*s**2 + 20250*Dd**2*f**4*s - 6750*Dd**2*f**4 + 14688*Dd**2*f**3*r**2 + 25056*Dd**2*f**3*r*s - 20952*Dd**2*f**3*r + 10368*Dd**2*f**3*s**2 - 17712*Dd**2*f**3*s + 6624*Dd**2*f**3 + 15336*Dd**2*f**2*g2*r**2 + 24192*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 8856*Dd**2*f**2*g2*s**2 - 16524*Dd**2*f**2*g2*s + 6588*Dd**2*f**2*g2 - 21*b1**2*(K - 1)*(D1**2*(fd*(5*r**2 + 2*r*(18*s - 5) + 31*s**2 - 10*s + 5) - 3*fdd*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5)) + D1*(Dd*(f*(20*r**2 + 8*r*(18*s - 7) + 124*s**2 - 134*s + 41) - 6*fd*(20*r**2 + r*(64*s - 38) + 44*s**2 - 47*s + 15)) - 3*Ddd*f*(20*r**2 + 4*r*(16*s - 9) + 44*s**2 - 54*s + 21)) - 18*Dd**2*f*(10*r**2 + 2*r*(16*s - 9) + 22*s**2 - 27*s + 7)) + b1*(-660*C*D1**2*f*fd*r**2 - 2448*C*D1**2*f*fd*r*s + 1320*C*D1**2*f*fd*r - 1788*C*D1**2*f*fd*s**2 + 1884*C*D1**2*f*fd*s - 660*C*D1**2*f*fd + 540*C*D1**2*f*fdd*r**2 + 1728*C*D1**2*f*fdd*r*s - 1080*C*D1**2*f*fdd*r + 1188*C*D1**2*f*fdd*s**2 - 1404*C*D1**2*f*fdd*s + 540*C*D1**2*f*fdd + 540*C*D1**2*fd**2*r**2 + 1728*C*D1**2*fd**2*r*s - 1080*C*D1**2*fd**2*r + 1188*C*D1**2*fd**2*s**2 - 1404*C*D1**2*fd**2*s + 540*C*D1**2*fd**2 - 1320*C*D1*Dd*f**2*r**2 - 4896*C*D1*Dd*f**2*r*s + 2544*C*D1*Dd*f**2*r - 3576*C*D1*Dd*f**2*s**2 + 4236*C*D1*Dd*f**2*s - 1554*C*D1*Dd*f**2 + 4320*C*D1*Dd*f*fd*r**2 + 13824*C*D1*Dd*f*fd*r*s - 8208*C*D1*Dd*f*fd*r + 9504*C*D1*Dd*f*fd*s**2 - 11448*C*D1*Dd*f*fd*s + 3564*C*D1*Dd*f*fd + 1080*C*D1*Ddd*f**2*r**2 + 3456*C*D1*Ddd*f**2*r*s - 1944*C*D1*Ddd*f**2*r + 2376*C*D1*Ddd*f**2*s**2 - 2916*C*D1*Ddd*f**2*s + 1134*C*D1*Ddd*f**2 + 3240*C*Dd**2*f**2*r**2 + 10368*C*Dd**2*f**2*r*s - 5832*C*Dd**2*f**2*r + 7128*C*Dd**2*f**2*s**2 - 8748*C*Dd**2*f**2*s + 2268*C*Dd**2*f**2 + 1170*D1**2*K*f*fd*r**2 + 2016*D1**2*K*f*fd*r*s - 1008*D1**2*K*f*fd*r + 846*D1**2*K*f*fd*s**2 - 846*D1**2*K*f*fd*s + 423*D1**2*K*f*fd - 1278*D1**2*K*f*fdd*r**2 - 2016*D1**2*K*f*fdd*r*s + 1008*D1**2*K*f*fdd*r - 738*D1**2*K*f*fdd*s**2 + 738*D1**2*K*f*fdd*s - 369*D1**2*K*f*fdd - 1278*D1**2*K*fd**2*r**2 - 2016*D1**2*K*fd**2*r*s + 1008*D1**2*K*fd**2*r - 738*D1**2*K*fd**2*s**2 + 738*D1**2*K*fd**2*s + 63*D1**2*bdd1*f*(K - 1)*(10*r**2 + 32*r*s - 16*r + 22*s**2 - 28*s + 11) - 3645*D1**2*f**2*fd*r**2 - 6738*D1**2*f**2*fd*r*s + 4944*D1**2*f**2*fd*r - 3093*D1**2*f**2*fd*s**2 + 4576*D1**2*f**2*fd*s - 2034*D1**2*f**2*fd + 3375*D1**2*f**2*fdd*r**2 + 6150*D1**2*f**2*fdd*r*s - 4650*D1**2*f**2*fdd*r + 2775*D1**2*f**2*fdd*s**2 - 4250*D1**2*f**2*fdd*s + 2025*D1**2*f**2*fdd + 6750*D1**2*f*fd**2*r**2 + 12300*D1**2*f*fd**2*r*s - 9300*D1**2*f*fd**2*r + 5550*D1**2*f*fd**2*s**2 - 8500*D1**2*f*fd**2*s + 3150*D1**2*f*fd**2 - 1860*D1**2*f*fd*r**2 - 3060*D1**2*f*fd*r*s + 1434*D1**2*f*fd*r - 1200*D1**2*f*fd*s**2 + 1104*D1**2*f*fd*s - 834*D1**2*f*fd + 2358*D1**2*f*fdd*r**2 + 4176*D1**2*f*fdd*r*s - 1872*D1**2*f*fdd*r + 1818*D1**2*f*fdd*s**2 - 1602*D1**2*f*fdd*s + 963*D1**2*f*fdd + 210*D1**2*f*gd2*r**2 + 1512*D1**2*f*gd2*r*s - 420*D1**2*f*gd2*r + 1302*D1**2*f*gd2*s**2 - 1512*D1**2*f*gd2*s + 210*D1**2*f*gd2 - 630*D1**2*f*gdd2*r**2 - 2016*D1**2*f*gdd2*r*s + 1260*D1**2*f*gdd2*r - 1386*D1**2*f*gdd2*s**2 + 2016*D1**2*f*gdd2*s - 630*D1**2*f*gdd2 + 2358*D1**2*fd**2*r**2 + 4176*D1**2*fd**2*r*s - 1872*D1**2*fd**2*r + 1818*D1**2*fd**2*s**2 - 1602*D1**2*fd**2*s - 540*D1**2*fd**2 + 210*D1**2*fd*g2*r**2 + 1512*D1**2*fd*g2*r*s - 420*D1**2*fd*g2*r + 1302*D1**2*fd*g2*s**2 - 420*D1**2*fd*g2*s + 210*D1**2*fd*g2 - 1260*D1**2*fd*gd2*r**2 - 4032*D1**2*fd*gd2*r*s + 2520*D1**2*fd*gd2*r - 2772*D1**2*fd*gd2*s**2 + 3276*D1**2*fd*gd2*s - 1260*D1**2*fd*gd2 - 630*D1**2*fdd*g2*r**2 - 2016*D1**2*fdd*g2*r*s + 1260*D1**2*fdd*g2*r - 1386*D1**2*fdd*g2*s**2 + 1260*D1**2*fdd*g2*s - 630*D1**2*fdd*g2 + 2340*D1*Dd*K*f**2*r**2 + 4032*D1*Dd*K*f**2*r*s - 3348*D1*Dd*K*f**2*r + 1692*D1*Dd*K*f**2*s**2 - 2862*D1*Dd*K*f**2*s + 1593*D1*Dd*K*f**2 - 10224*D1*Dd*K*f*fd*r**2 - 16128*D1*Dd*K*f*fd*r*s + 11160*D1*Dd*K*f*fd*r - 5904*D1*Dd*K*f*fd*s**2 + 8460*D1*Dd*K*f*fd*s - 2754*D1*Dd*K*f*fd - 4860*D1*Dd*f**3*r**2 - 8984*D1*Dd*f**3*r*s + 7106*D1*Dd*f**3*r - 4124*D1*Dd*f**3*s**2 + 6554*D1*Dd*f**3*s - 3461*D1*Dd*f**3 + 27000*D1*Dd*f**2*fd*r**2 + 49200*D1*Dd*f**2*fd*r*s - 38250*D1*Dd*f**2*fd*r + 22200*D1*Dd*f**2*fd*s**2 - 34850*D1*Dd*f**2*fd*s + 13550*D1*Dd*f**2*fd - 3720*D1*Dd*f**2*r**2 - 6120*D1*Dd*f**2*r*s + 5250*D1*Dd*f**2*r - 2400*D1*Dd*f**2*s**2 + 4260*D1*Dd*f**2*s - 2460*D1*Dd*f**2 + 18864*D1*Dd*f*fd*r**2 + 33408*D1*Dd*f*fd*r*s - 21096*D1*Dd*f*fd*r + 14544*D1*Dd*f*fd*s**2 - 18396*D1*Dd*f*fd*s + 5346*D1*Dd*f*fd + 840*D1*Dd*f*g2*r**2 + 6048*D1*Dd*f*g2*r*s - 2352*D1*Dd*f*g2*r + 5208*D1*Dd*f*g2*s**2 - 5628*D1*Dd*f*g2*s + 1722*D1*Dd*f*g2 - 5040*D1*Dd*f*gd2*r**2 - 16128*D1*Dd*f*gd2*r*s + 9576*D1*Dd*f*gd2*r - 11088*D1*Dd*f*gd2*s**2 + 14868*D1*Dd*f*gd2*s - 4536*D1*Dd*f*gd2 - 5040*D1*Dd*fd*g2*r**2 - 16128*D1*Dd*fd*g2*r*s + 9576*D1*Dd*fd*g2*r - 11088*D1*Dd*fd*g2*s**2 + 11844*D1*Dd*fd*g2*s - 3780*D1*Dd*fd*g2 - 2556*D1*Ddd*K*f**2*r**2 - 4032*D1*Ddd*K*f**2*r*s + 3564*D1*Ddd*K*f**2*r - 1476*D1*Ddd*K*f**2*s**2 + 2754*D1*Ddd*K*f**2*s - 1647*D1*Ddd*K*f**2 + 4500*D1*Ddd*f**3*r**2 + 8200*D1*Ddd*f**3*r*s - 6550*D1*Ddd*f**3*r + 3700*D1*Ddd*f**3*s**2 - 5950*D1*Ddd*f**3*s + 3175*D1*Ddd*f**3 + 4716*D1*Ddd*f**2*r**2 + 8352*D1*Ddd*f**2*r*s - 6804*D1*Ddd*f**2*r + 3636*D1*Ddd*f**2*s**2 - 5994*D1*Ddd*f**2*s + 3267*D1*Ddd*f**2 - 2520*D1*Ddd*f*g2*r**2 - 8064*D1*Ddd*f*g2*r*s + 4536*D1*Ddd*f*g2*r - 5544*D1*Ddd*f*g2*s**2 + 6804*D1*Ddd*f*g2*s - 2646*D1*Ddd*f*g2 - 21*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 72*r*s - 36*r + 62*s**2 - 88*s + 31) - 6*fd*(10*r**2 + 32*r*s - 18*r + 22*s**2 - 24*s + 5)) - 12*Dd*f*(20*r**2 + r*(64*s - 34) + 44*s**2 - 55*s + 15)) - 7668*Dd**2*K*f**2*r**2 - 12096*Dd**2*K*f**2*r*s + 10692*Dd**2*K*f**2*r - 4428*Dd**2*K*f**2*s**2 + 8262*Dd**2*K*f**2*s - 3294*Dd**2*K*f**2 + 13500*Dd**2*f**3*r**2 + 24600*Dd**2*f**3*r*s - 19650*Dd**2*f**3*r + 11100*Dd**2*f**3*s**2 - 17850*Dd**2*f**3*s + 6350*Dd**2*f**3 + 14148*Dd**2*f**2*r**2 + 25056*Dd**2*f**2*r*s - 20412*Dd**2*f**2*r + 10908*Dd**2*f**2*s**2 - 17982*Dd**2*f**2*s + 6534*Dd**2*f**2 - 7560*Dd**2*f*g2*r**2 - 24192*Dd**2*f*g2*r*s + 13608*Dd**2*f*g2*r - 16632*Dd**2*f*g2*s**2 + 20412*Dd**2*f*g2*s - 5292*Dd**2*f*g2))/(315*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**3*k1**3*k2*(-1872*C*D1**2*bdd1*f**2*r**2 - 3312*C*D1**2*bdd1*f**2*r*s + 5112*C*D1**2*bdd1*f**2*r - 1440*C*D1**2*bdd1*f**2*s**2 + 4680*C*D1**2*bdd1*f**2*s - 2340*C*D1**2*bdd1*f**2 + 5100*C*D1**2*f**2*fd*r**2 + 20160*C*D1**2*f**2*fd*r*s - 10120*C*D1**2*f**2*fd*r + 15060*C*D1**2*f**2*fd*s**2 - 16760*C*D1**2*f**2*fd*s + 6720*C*D1**2*f**2*fd - 8220*C*D1**2*f**2*fdd*r**2 - 24120*C*D1**2*f**2*fdd*r*s + 13520*C*D1**2*f**2*fdd*r - 15900*C*D1**2*f**2*fdd*s**2 + 18640*C*D1**2*f**2*fdd*s - 8040*C*D1**2*f**2*fdd - 16440*C*D1**2*f*fd**2*r**2 - 48240*C*D1**2*f*fd**2*r*s + 27040*C*D1**2*f*fd**2*r - 31800*C*D1**2*f*fd**2*s**2 + 37280*C*D1**2*f*fd**2*s - 8040*C*D1**2*f*fd**2 + 6800*C*D1*Dd*f**3*r**2 + 26880*C*D1*Dd*f**3*r*s - 13520*C*D1*Dd*f**3*r + 20080*C*D1*Dd*f**3*s**2 - 23480*C*D1*Dd*f**3*s + 8420*C*D1*Dd*f**3 - 65760*C*D1*Dd*f**2*fd*r**2 - 192960*C*D1*Dd*f**2*fd*r*s + 111080*C*D1*Dd*f**2*fd*r - 127200*C*D1*Dd*f**2*fd*s**2 + 154600*C*D1*Dd*f**2*fd*s - 45680*C*D1*Dd*f**2*fd - 10960*C*D1*Ddd*f**3*r**2 - 32160*C*D1*Ddd*f**3*r*s + 19000*C*D1*Ddd*f**3*r - 21200*C*D1*Ddd*f**3*s**2 + 26680*C*D1*Ddd*f**3*s - 10780*C*D1*Ddd*f**3 - 32880*C*Dd**2*f**3*r**2 - 96480*C*Dd**2*f**3*r*s + 57000*C*Dd**2*f**3*r - 63600*C*Dd**2*f**3*s**2 + 80040*C*Dd**2*f**3*s - 21560*C*Dd**2*f**3 - 1710*D1**2*K*bdd1*f**2*r**2 - 5292*D1**2*K*bdd1*f**2*r*s + 3420*D1**2*K*bdd1*f**2*r - 3582*D1**2*K*bdd1*f**2*s**2 + 5292*D1**2*K*bdd1*f**2*s - 1710*D1**2*K*bdd1*f**2 + 1080*D1**2*b2*f*fd*r**2 + 2160*D1**2*b2*f*fd*r*s - 1080*D1**2*b2*f*fd*r + 1080*D1**2*b2*f*fd*s**2 - 1080*D1**2*b2*f*fd*s + 540*D1**2*b2*f*fd - 1800*D1**2*b2*f*fdd*r**2 - 3600*D1**2*b2*f*fdd*r*s + 1800*D1**2*b2*f*fdd*r - 1800*D1**2*b2*f*fdd*s**2 + 1800*D1**2*b2*f*fdd*s - 900*D1**2*b2*f*fdd - 1800*D1**2*b2*fd**2*r**2 - 3600*D1**2*b2*fd**2*r*s + 1800*D1**2*b2*fd**2*r - 1800*D1**2*b2*fd**2*s**2 + 1800*D1**2*b2*fd**2*s + 6*D1**2*bd1**2*(r + s - 1)*(450*f**2*(r + s - 1) + 7*f*(60*C*r + 60*C*s + K*(-56*r - 56*s + 86) + 101*r + 101*s - 176) - 700*g2*(r + s)) + 540*D1**2*bd2*f**2*r**2 + 1080*D1**2*bd2*f**2*r*s - 1080*D1**2*bd2*f**2*r + 540*D1**2*bd2*f**2*s**2 - 1080*D1**2*bd2*f**2*s + 540*D1**2*bd2*f**2 - 3600*D1**2*bd2*f*fd*r**2 - 7200*D1**2*bd2*f*fd*r*s + 5400*D1**2*bd2*f*fd*r - 3600*D1**2*bd2*f*fd*s**2 + 5400*D1**2*bd2*f*fd*s - 1800*D1**2*bd2*f*fd - 720*D1**2*bdd1*f**3*r**2 + 720*D1**2*bdd1*f**3*r + 720*D1**2*bdd1*f**3*s**2 - 720*D1**2*bdd1*f**3*s + 3852*D1**2*bdd1*f**2*r**2 + 8208*D1**2*bdd1*f**2*r*s - 8622*D1**2*bdd1*f**2*r + 4356*D1**2*bdd1*f**2*s**2 - 9126*D1**2*bdd1*f**2*s + 4095*D1**2*bdd1*f**2 + 2352*D1**2*bdd1*f*g2*r**2 + 4704*D1**2*bdd1*f*g2*r*s - 7224*D1**2*bdd1*f*g2*r + 2352*D1**2*bdd1*f*g2*s**2 - 7224*D1**2*bdd1*f*g2*s + 3612*D1**2*bdd1*f*g2 - 900*D1**2*bdd2*f**2*r**2 - 1800*D1**2*bdd2*f**2*r*s + 1800*D1**2*bdd2*f**2*r - 900*D1**2*bdd2*f**2*s**2 + 1800*D1**2*bdd2*f**2*s - 900*D1**2*bdd2*f**2 - 2130*D1**2*f**2*fd*r**2 - 12000*D1**2*f**2*fd*r*s + 5420*D1**2*f**2*fd*r - 9870*D1**2*f**2*fd*s**2 + 10580*D1**2*f**2*fd*s - 4000*D1**2*f**2*fd + 5115*D1**2*f**2*fdd*r**2 + 15990*D1**2*f**2*fdd*r*s - 8740*D1**2*f**2*fdd*r + 10875*D1**2*f**2*fdd*s**2 - 12580*D1**2*f**2*fdd*s + 5330*D1**2*f**2*fdd - 1548*D1**2*f**2*gd2*r**2 - 8064*D1**2*f**2*gd2*r*s + 3096*D1**2*f**2*gd2*r - 6516*D1**2*f**2*gd2*s**2 + 8064*D1**2*f**2*gd2*s - 1548*D1**2*f**2*gd2 + 3420*D1**2*f**2*gdd2*r**2 + 10584*D1**2*f**2*gdd2*r*s - 6840*D1**2*f**2*gdd2*r + 7164*D1**2*f**2*gdd2*s**2 - 10584*D1**2*f**2*gdd2*s + 3420*D1**2*f**2*gdd2 + 10230*D1**2*f*fd**2*r**2 + 31980*D1**2*f*fd**2*r*s - 17480*D1**2*f*fd**2*r + 21750*D1**2*f*fd**2*s**2 - 25160*D1**2*f*fd**2*s + 5330*D1**2*f*fd**2 - 3096*D1**2*f*fd*g2*r**2 - 16128*D1**2*f*fd*g2*r*s + 8064*D1**2*f*fd*g2*r - 13032*D1**2*f*fd*g2*s**2 + 13032*D1**2*f*fd*g2*s - 6516*D1**2*f*fd*g2 + 13680*D1**2*f*fd*gd2*r**2 + 42336*D1**2*f*fd*gd2*r*s - 24264*D1**2*f*fd*gd2*r + 28656*D1**2*f*fd*gd2*s**2 - 35496*D1**2*f*fd*gd2*s + 10584*D1**2*f*fd*gd2 + 6840*D1**2*f*fdd*g2*r**2 + 21168*D1**2*f*fdd*g2*r*s - 10584*D1**2*f*fdd*g2*r + 14328*D1**2*f*fdd*g2*s**2 - 14328*D1**2*f*fdd*g2*s + 7164*D1**2*f*fdd*g2 + 6840*D1**2*fd**2*g2*r**2 + 21168*D1**2*fd**2*g2*r*s - 10584*D1**2*fd**2*g2*r + 14328*D1**2*fd**2*g2*s**2 - 14328*D1**2*fd**2*g2*s + 2160*D1*Dd*b2*f**2*r**2 + 4320*D1*Dd*b2*f**2*r*s - 3240*D1*Dd*b2*f**2*r + 2160*D1*Dd*b2*f**2*s**2 - 3240*D1*Dd*b2*f**2*s + 1620*D1*Dd*b2*f**2 - 14400*D1*Dd*b2*f*fd*r**2 - 28800*D1*Dd*b2*f*fd*r*s + 18000*D1*Dd*b2*f*fd*r - 14400*D1*Dd*b2*f*fd*s**2 + 18000*D1*Dd*b2*f*fd*s - 5400*D1*Dd*b2*f*fd - 7200*D1*Dd*bd2*f**2*r**2 - 14400*D1*Dd*bd2*f**2*r*s + 12600*D1*Dd*bd2*f**2*r - 7200*D1*Dd*bd2*f**2*s**2 + 12600*D1*Dd*bd2*f**2*s - 5400*D1*Dd*bd2*f**2 - 2840*D1*Dd*f**3*r**2 - 16000*D1*Dd*f**3*r*s + 6840*D1*Dd*f**3*r - 13160*D1*Dd*f**3*s**2 + 14580*D1*Dd*f**3*s - 4710*D1*Dd*f**3 + 40920*D1*Dd*f**2*fd*r**2 + 127920*D1*Dd*f**2*fd*r*s - 71410*D1*Dd*f**2*fd*r + 87000*D1*Dd*f**2*fd*s**2 - 104050*D1*Dd*f**2*fd*s + 30060*D1*Dd*f**2*fd - 6192*D1*Dd*f**2*g2*r**2 - 32256*D1*Dd*f**2*g2*r*s + 14256*D1*Dd*f**2*g2*r - 26064*D1*Dd*f**2*g2*s**2 + 29160*D1*Dd*f**2*g2*s - 9612*D1*Dd*f**2*g2 + 27360*D1*Dd*f**2*gd2*r**2 + 84672*D1*Dd*f**2*gd2*r*s - 51624*D1*Dd*f**2*gd2*r + 57312*D1*Dd*f**2*gd2*s**2 - 77832*D1*Dd*f**2*gd2*s + 24264*D1*Dd*f**2*gd2 + 54720*D1*Dd*f*fd*g2*r**2 + 169344*D1*Dd*f*fd*g2*r*s - 90864*D1*Dd*f*fd*g2*r + 114624*D1*Dd*f*fd*g2*s**2 - 128304*D1*Dd*f*fd*g2*s + 35496*D1*Dd*f*fd*g2 - 3600*D1*Ddd*b2*f**2*r**2 - 7200*D1*Ddd*b2*f**2*r*s + 5400*D1*Ddd*b2*f**2*r - 3600*D1*Ddd*b2*f**2*s**2 + 5400*D1*Ddd*b2*f**2*s - 2700*D1*Ddd*b2*f**2 + 6820*D1*Ddd*f**3*r**2 + 21320*D1*Ddd*f**3*r*s - 12150*D1*Ddd*f**3*r + 14500*D1*Ddd*f**3*s**2 - 17910*D1*Ddd*f**3*s + 7035*D1*Ddd*f**3 + 13680*D1*Ddd*f**2*g2*r**2 + 42336*D1*Ddd*f**2*g2*r*s - 24264*D1*Ddd*f**2*g2*r + 28656*D1*Ddd*f**2*g2*s**2 - 35496*D1*Ddd*f**2*g2*s + 14004*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(15*f**3*(26*r**2 + r*(20*s - 38) - 6*s**2 - 6*s + 17) + 3*f**2*(4*C*(62*r**2 + 6*r*(19*s - 24) + 52*s**2 - 134*s + 67) + 86*K*r**2 + 448*K*r*s - 172*K*r + 362*K*s**2 - 448*K*s + 86*K - 80*fd*(6*r**2 - 6*r - 6*s**2 + 4*s + 1) - 352*r**2 - 816*r*s + 754*r - 464*s**2 + 866*s - 357) - 2*f*(3*fd*(4*C*(104*r**2 + r*(184*s - 169) + 80*s**2 - 151*s + 71) + 2*K*(190*r**2 + 588*r*s - 337*r + 398*s**2 - 493*s + 147) - 856*r**2 - 1824*r*s + 1363*r - 968*s**2 + 1447*s - 531) + 14*g2*(26*r**2 + r*(62*s - 72) + 36*s**2 - 82*s + 41) - 28*gd2*(28*r**2 + r*(56*s - 71) + 28*s**2 - 71*s + 43)) + 1568*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(120*f**2*(8*r**2 - 8*r - 8*s**2 + 6*s + 1) + 3*f*(4*C*(208*r**2 + r*(368*s - 434) + 160*s**2 - 392*s + 207) + 2*K*(380*r**2 + 1176*r*s - 717*r + 796*s**2 - 1081*s + 337) - 1712*r**2 - 3648*r*s + 3228*r - 1936*s**2 + 3424*s - 1465) - 28*g2*(112*r**2 + 32*r*(7*s - 8) + 112*s**2 - 256*s + 129))) - 10800*Dd**2*b2*f**2*r**2 - 21600*Dd**2*b2*f**2*r*s + 16200*Dd**2*b2*f**2*r - 10800*Dd**2*b2*f**2*s**2 + 16200*Dd**2*b2*f**2*s - 5400*Dd**2*b2*f**2 + 20460*Dd**2*f**3*r**2 + 63960*Dd**2*f**3*r*s - 36450*Dd**2*f**3*r + 43500*Dd**2*f**3*s**2 - 53730*Dd**2*f**3*s + 14070*Dd**2*f**3 + 41040*Dd**2*f**2*g2*r**2 + 127008*Dd**2*f**2*g2*r*s - 72792*Dd**2*f**2*g2*r + 85968*Dd**2*f**2*g2*s**2 - 106488*Dd**2*f**2*g2*s + 28008*Dd**2*f**2*g2 + 1050*b1**3*(K - 1)*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(-140*C*D1**2*fd*r**2 - 280*C*D1**2*fd*r*s + 280*C*D1**2*fd*r - 140*C*D1**2*fd*s**2 + 280*C*D1**2*fd*s - 140*C*D1**2*fd + 420*C*D1**2*fdd*r**2 + 840*C*D1**2*fdd*r*s - 840*C*D1**2*fdd*r + 420*C*D1**2*fdd*s**2 - 840*C*D1**2*fdd*s + 420*C*D1**2*fdd - 560*C*D1*Dd*f*r**2 - 1120*C*D1*Dd*f*r*s + 840*C*D1*Dd*f*r - 560*C*D1*Dd*f*s**2 + 840*C*D1*Dd*f*s - 420*C*D1*Dd*f + 3360*C*D1*Dd*fd*r**2 + 6720*C*D1*Dd*fd*r*s - 5880*C*D1*Dd*fd*r + 3360*C*D1*Dd*fd*s**2 - 5880*C*D1*Dd*fd*s + 2520*C*D1*Dd*fd + 1680*C*D1*Ddd*f*r**2 + 3360*C*D1*Ddd*f*r*s - 2520*C*D1*Ddd*f*r + 1680*C*D1*Ddd*f*s**2 - 2520*C*D1*Ddd*f*s + 1260*C*D1*Ddd*f + 5040*C*Dd**2*f*r**2 + 10080*C*Dd**2*f*r*s - 7560*C*Dd**2*f*r + 5040*C*Dd**2*f*s**2 - 7560*C*Dd**2*f*s + 2520*C*Dd**2*f + 364*D1**2*K*fd*r**2 + 868*D1**2*K*fd*r*s + 140*D1**2*K*fd*r + 504*D1**2*K*fd*s**2 + 140*D1**2*K*fd*s - 70*D1**2*K*fd - 392*D1**2*K*fdd*r**2 - 784*D1**2*K*fdd*r*s - 420*D1**2*K*fdd*r - 392*D1**2*K*fdd*s**2 - 420*D1**2*K*fdd*s + 210*D1**2*K*fdd + 350*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 960*D1**2*f*fd*r**2 - 1920*D1**2*f*fd*r*s + 1170*D1**2*f*fd*r - 960*D1**2*f*fd*s**2 + 1170*D1**2*f*fd*s - 585*D1**2*f*fd + 900*D1**2*f*fdd*r**2 + 1800*D1**2*f*fdd*r*s - 900*D1**2*f*fdd*r + 900*D1**2*f*fdd*s**2 - 900*D1**2*f*fdd*s + 450*D1**2*f*fdd + 900*D1**2*fd**2*r**2 + 1800*D1**2*fd**2*r*s - 900*D1**2*fd**2*r + 900*D1**2*fd**2*s**2 - 900*D1**2*fd**2*s - 644*D1**2*fd*r**2 - 1428*D1**2*fd*r*s - 350*D1**2*fd*r - 784*D1**2*fd*s**2 - 350*D1**2*fd*s + 175*D1**2*fd + 707*D1**2*fdd*r**2 + 1414*D1**2*fdd*r*s + 1050*D1**2*fdd*r + 707*D1**2*fdd*s**2 + 1050*D1**2*fdd*s - 525*D1**2*fdd - 700*D1**2*gd2*r**2 - 1400*D1**2*gd2*r*s + 1400*D1**2*gd2*r - 700*D1**2*gd2*s**2 + 1400*D1**2*gd2*s - 700*D1**2*gd2 - 700*D1**2*gdd2*r**2 - 1400*D1**2*gdd2*r*s + 1400*D1**2*gdd2*r - 700*D1**2*gdd2*s**2 + 1400*D1**2*gdd2*s - 700*D1**2*gdd2 + 1456*D1*Dd*K*f*r**2 + 3472*D1*Dd*K*f*r*s - 2324*D1*Dd*K*f*r + 2016*D1*Dd*K*f*s**2 - 2744*D1*Dd*K*f*s + 1232*D1*Dd*K*f - 3136*D1*Dd*K*fd*r**2 - 6272*D1*Dd*K*fd*r*s + 672*D1*Dd*K*fd*r - 3136*D1*Dd*K*fd*s**2 + 672*D1*Dd*K*fd*s + 1260*D1*Dd*K*fd - 1920*D1*Dd*f**2*r**2 - 3840*D1*Dd*f**2*r*s + 2880*D1*Dd*f**2*r - 1920*D1*Dd*f**2*s**2 + 2880*D1*Dd*f**2*s - 1440*D1*Dd*f**2 + 7200*D1*Dd*f*fd*r**2 + 14400*D1*Dd*f*fd*r*s - 9000*D1*Dd*f*fd*r + 7200*D1*Dd*f*fd*s**2 - 9000*D1*Dd*f*fd*s + 2700*D1*Dd*f*fd - 2576*D1*Dd*f*r**2 - 5712*D1*Dd*f*r*s + 4004*D1*Dd*f*r - 3136*D1*Dd*f*s**2 + 4424*D1*Dd*f*s - 2072*D1*Dd*f + 5656*D1*Dd*fd*r**2 + 11312*D1*Dd*fd*r*s - 42*D1*Dd*fd*r + 5656*D1*Dd*fd*s**2 - 42*D1*Dd*fd*s - 3150*D1*Dd*fd - 2800*D1*Dd*g2*r**2 - 5600*D1*Dd*g2*r*s + 4200*D1*Dd*g2*r - 2800*D1*Dd*g2*s**2 + 4200*D1*Dd*g2*s - 2100*D1*Dd*g2 - 5600*D1*Dd*gd2*r**2 - 11200*D1*Dd*gd2*r*s + 9800*D1*Dd*gd2*r - 5600*D1*Dd*gd2*s**2 + 9800*D1*Dd*gd2*s - 4200*D1*Dd*gd2 - 1568*D1*Ddd*K*f*r**2 - 3136*D1*Ddd*K*f*r*s + 2352*D1*Ddd*K*f*r - 1568*D1*Ddd*K*f*s**2 + 2352*D1*Ddd*K*f*s - 1176*D1*Ddd*K*f + 1800*D1*Ddd*f**2*r**2 + 3600*D1*Ddd*f**2*r*s - 2700*D1*Ddd*f**2*r + 1800*D1*Ddd*f**2*s**2 - 2700*D1*Ddd*f**2*s + 1350*D1*Ddd*f**2 + 2828*D1*Ddd*f*r**2 + 5656*D1*Ddd*f*r*s - 4242*D1*Ddd*f*r + 2828*D1*Ddd*f*s**2 - 4242*D1*Ddd*f*s + 2121*D1*Ddd*f - 2800*D1*Ddd*g2*r**2 - 5600*D1*Ddd*g2*r*s + 4200*D1*Ddd*g2*r - 2800*D1*Ddd*g2*s**2 + 4200*D1*Ddd*g2*s - 2100*D1*Ddd*g2 + 350*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 4704*Dd**2*K*f*r**2 - 9408*Dd**2*K*f*r*s + 7056*Dd**2*K*f*r - 4704*Dd**2*K*f*s**2 + 7056*Dd**2*K*f*s - 2352*Dd**2*K*f + 5400*Dd**2*f**2*r**2 + 10800*Dd**2*f**2*r*s - 8100*Dd**2*f**2*r + 5400*Dd**2*f**2*s**2 - 8100*Dd**2*f**2*s + 2700*Dd**2*f**2 + 8484*Dd**2*f*r**2 + 16968*Dd**2*f*r*s - 12726*Dd**2*f*r + 8484*Dd**2*f*s**2 - 12726*Dd**2*f*s + 4242*Dd**2*f - 8400*Dd**2*g2*r**2 - 16800*Dd**2*g2*r*s + 12600*Dd**2*g2*r - 8400*Dd**2*g2*s**2 + 12600*Dd**2*g2*s - 4200*Dd**2*g2) + 3*b1*(1488*C*D1**2*f*fd*r**2 + 2736*C*D1**2*f*fd*r*s - 1128*C*D1**2*f*fd*r + 1248*C*D1**2*f*fd*s**2 - 1008*C*D1**2*f*fd*s + 564*C*D1**2*f*fd - 1248*C*D1**2*f*fdd*r**2 - 2208*C*D1**2*f*fdd*r*s + 648*C*D1**2*f*fdd*r - 960*C*D1**2*f*fdd*s**2 + 504*C*D1**2*f*fdd*s - 324*C*D1**2*f*fdd - 1248*C*D1**2*fd**2*r**2 - 2208*C*D1**2*fd**2*r*s + 648*C*D1**2*fd**2*r - 960*C*D1**2*fd**2*s**2 + 504*C*D1**2*fd**2*s + 600*C*D1**2*fd**2 + 2976*C*D1*Dd*f**2*r**2 + 5472*C*D1*Dd*f**2*r*s - 4344*C*D1*Dd*f**2*r + 2496*C*D1*Dd*f**2*s**2 - 3984*C*D1*Dd*f**2*s + 2112*C*D1*Dd*f**2 - 9984*C*D1*Dd*f*fd*r**2 - 17664*C*D1*Dd*f*fd*r*s + 9792*C*D1*Dd*f*fd*r - 7680*C*D1*Dd*f*fd*s**2 + 8352*C*D1*Dd*f*fd*s - 1800*C*D1*Dd*f*fd - 2496*C*D1*Ddd*f**2*r**2 - 4416*C*D1*Ddd*f**2*r*s + 3600*C*D1*Ddd*f**2*r - 1920*C*D1*Ddd*f**2*s**2 + 3168*C*D1*Ddd*f**2*s - 1728*C*D1*Ddd*f**2 - 7488*C*Dd**2*f**2*r**2 - 13248*C*Dd**2*f**2*r*s + 10800*C*Dd**2*f**2*r - 5760*C*Dd**2*f**2*s**2 + 9504*C*Dd**2*f**2*s - 3456*C*Dd**2*f**2 + 516*D1**2*K*f*fd*r**2 + 2688*D1**2*K*f*fd*r*s - 1344*D1**2*K*f*fd*r + 2172*D1**2*K*f*fd*s**2 - 2172*D1**2*K*f*fd*s + 1086*D1**2*K*f*fd - 1140*D1**2*K*f*fdd*r**2 - 3528*D1**2*K*f*fdd*r*s + 1764*D1**2*K*f*fdd*r - 2388*D1**2*K*f*fdd*s**2 + 2388*D1**2*K*f*fdd*s - 1194*D1**2*K*f*fdd - 1140*D1**2*K*fd**2*r**2 - 3528*D1**2*K*fd**2*r*s + 1764*D1**2*K*fd**2*r - 2388*D1**2*K*fd**2*s**2 + 2388*D1**2*K*fd**2*s + 700*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1**2*bdd1*(900*f**2*(r + s - 1)**2 + 7*f*(60*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*K*(56*r**2 + 2*r*(56*s - 71) + 56*s**2 - 142*s + 71) + 202*r**2 + 404*r*s - 554*r + 202*s**2 - 554*s + 277) - 700*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 1170*D1**2*f**2*fd*r**2 + 900*D1**2*f**2*fd*r*s - 1290*D1**2*f**2*fd*r - 270*D1**2*f**2*fd*s**2 - 330*D1**2*f**2*fd*s + 435*D1**2*f**2*fd - 720*D1**2*f**2*fdd*r**2 + 720*D1**2*f**2*fdd*r + 720*D1**2*f**2*fdd*s**2 - 240*D1**2*f**2*fdd*s - 240*D1**2*f**2*fdd - 1440*D1**2*f*fd**2*r**2 + 1440*D1**2*f*fd**2*r + 1440*D1**2*f*fd**2*s**2 - 480*D1**2*f*fd**2*s - 240*D1**2*f*fd**2 - 2112*D1**2*f*fd*r**2 - 4896*D1**2*f*fd*r*s + 2298*D1**2*f*fd*r - 2784*D1**2*f*fd*s**2 + 2634*D1**2*f*fd*s - 1377*D1**2*f*fd + 2568*D1**2*f*fdd*r**2 + 5472*D1**2*f*fdd*r*s - 2430*D1**2*f*fdd*r + 2904*D1**2*f*fdd*s**2 - 2598*D1**2*f*fdd*s + 1371*D1**2*f*fdd - 728*D1**2*f*gd2*r**2 - 1736*D1**2*f*gd2*r*s + 1456*D1**2*f*gd2*r - 1008*D1**2*f*gd2*s**2 + 1736*D1**2*f*gd2*s - 728*D1**2*f*gd2 + 784*D1**2*f*gdd2*r**2 + 1568*D1**2*f*gdd2*r*s - 1568*D1**2*f*gdd2*r + 784*D1**2*f*gdd2*s**2 - 1568*D1**2*f*gdd2*s + 784*D1**2*f*gdd2 + 2568*D1**2*fd**2*r**2 + 5472*D1**2*fd**2*r*s - 2430*D1**2*fd**2*r + 2904*D1**2*fd**2*s**2 - 2598*D1**2*fd**2*s - 450*D1**2*fd**2 - 728*D1**2*fd*g2*r**2 - 1736*D1**2*fd*g2*r*s - 280*D1**2*fd*g2*r - 1008*D1**2*fd*g2*s**2 - 280*D1**2*fd*g2*s + 140*D1**2*fd*g2 + 1568*D1**2*fd*gd2*r**2 + 3136*D1**2*fd*gd2*r*s - 728*D1**2*fd*gd2*r + 1568*D1**2*fd*gd2*s**2 - 728*D1**2*fd*gd2*s - 840*D1**2*fd*gd2 + 784*D1**2*fdd*g2*r**2 + 1568*D1**2*fdd*g2*r*s + 840*D1**2*fdd*g2*r + 784*D1**2*fdd*g2*s**2 + 840*D1**2*fdd*g2*s - 420*D1**2*fdd*g2 + 1032*D1*Dd*K*f**2*r**2 + 5376*D1*Dd*K*f**2*r*s - 2376*D1*Dd*K*f**2*r + 4344*D1*Dd*K*f**2*s**2 - 4860*D1*Dd*K*f**2*s + 1602*D1*Dd*K*f**2 - 9120*D1*Dd*K*f*fd*r**2 - 28224*D1*Dd*K*f*fd*r*s + 15144*D1*Dd*K*f*fd*r - 19104*D1*Dd*K*f*fd*s**2 + 21384*D1*Dd*K*f*fd*s - 5916*D1*Dd*K*f*fd + 1560*D1*Dd*f**3*r**2 + 1200*D1*Dd*f**3*r*s - 1860*D1*Dd*f**3*r - 360*D1*Dd*f**3*s**2 - 420*D1*Dd*f**3*s + 690*D1*Dd*f**3 - 5760*D1*Dd*f**2*fd*r**2 + 5760*D1*Dd*f**2*fd*r + 5760*D1*Dd*f**2*fd*s**2 - 2400*D1*Dd*f**2*fd*s - 1200*D1*Dd*f**2*fd - 4224*D1*Dd*f**2*r**2 - 9792*D1*Dd*f**2*r*s + 6672*D1*Dd*f**2*r - 5568*D1*Dd*f**2*s**2 + 7680*D1*Dd*f**2*s - 3504*D1*Dd*f**2 + 20544*D1*Dd*f*fd*r**2 + 43776*D1*Dd*f*fd*r*s - 25464*D1*Dd*f*fd*r + 23232*D1*Dd*f*fd*s**2 - 27144*D1*Dd*f*fd*s + 7458*D1*Dd*f*fd - 2912*D1*Dd*f*g2*r**2 - 6944*D1*Dd*f*g2*r*s + 4648*D1*Dd*f*g2*r - 4032*D1*Dd*f*g2*s**2 + 5488*D1*Dd*f*g2*s - 2464*D1*Dd*f*g2 + 6272*D1*Dd*f*gd2*r**2 + 12544*D1*Dd*f*gd2*r*s - 10976*D1*Dd*f*gd2*r + 6272*D1*Dd*f*gd2*s**2 - 10976*D1*Dd*f*gd2*s + 4704*D1*Dd*f*gd2 + 6272*D1*Dd*fd*g2*r**2 + 12544*D1*Dd*fd*g2*r*s - 1344*D1*Dd*fd*g2*r + 6272*D1*Dd*fd*g2*s**2 - 1344*D1*Dd*fd*g2*s - 2520*D1*Dd*fd*g2 - 2280*D1*Ddd*K*f**2*r**2 - 7056*D1*Ddd*K*f**2*r*s + 4044*D1*Ddd*K*f**2*r - 4776*D1*Ddd*K*f**2*s**2 + 5916*D1*Ddd*K*f**2*s - 2334*D1*Ddd*K*f**2 - 960*D1*Ddd*f**3*r**2 + 960*D1*Ddd*f**3*r + 960*D1*Ddd*f**3*s**2 - 480*D1*Ddd*f**3*s - 240*D1*Ddd*f**3 + 5136*D1*Ddd*f**2*r**2 + 10944*D1*Ddd*f**2*r*s - 7872*D1*Ddd*f**2*r + 5808*D1*Ddd*f**2*s**2 - 8376*D1*Ddd*f**2*s + 4020*D1*Ddd*f**2 + 3136*D1*Ddd*f*g2*r**2 + 6272*D1*Ddd*f*g2*r*s - 4704*D1*Ddd*f*g2*r + 3136*D1*Ddd*f*g2*s**2 - 4704*D1*Ddd*f*g2*s + 2352*D1*Ddd*f*g2 - D1*bd1*(D1*(15*f**2*(64*r**2 + 2*r*(64*s - 57) + 64*s**2 - 114*s + 57) + f*(140*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*K*(52*r**2 + 124*r*(s - 1) + 72*s**2 - 144*s + 67) - 1800*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 1288*r**2 + 2856*r*s - 3066*r + 1568*s**2 - 3346*s + 1603) - 14*fd*(r + s - 1)*(60*C*(2*r + 2*s - 1) - 2*K*(56*r + 56*s + 15) + 202*r + 202*s + 75) + 700*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 1400*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(4*r + 4*s - 3)*(900*f**2*(r + s - 1) + 7*f*(60*C*(2*r + 2*s - 1) - 2*K*(56*r + 56*s - 71) + 202*r + 202*s - 277) - 700*g2*(2*r + 2*s - 1))) - 6840*Dd**2*K*f**2*r**2 - 21168*Dd**2*K*f**2*r*s + 12132*Dd**2*K*f**2*r - 14328*Dd**2*K*f**2*s**2 + 17748*Dd**2*K*f**2*s - 4668*Dd**2*K*f**2 - 2880*Dd**2*f**3*r**2 + 2880*Dd**2*f**3*r + 2880*Dd**2*f**3*s**2 - 1440*Dd**2*f**3*s - 480*Dd**2*f**3 + 15408*Dd**2*f**2*r**2 + 32832*Dd**2*f**2*r*s - 23616*Dd**2*f**2*r + 17424*Dd**2*f**2*s**2 - 25128*Dd**2*f**2*s + 8040*Dd**2*f**2 + 9408*Dd**2*f*g2*r**2 + 18816*Dd**2*f*g2*r*s - 14112*Dd**2*f*g2*r + 9408*Dd**2*f*g2*s**2 - 14112*Dd**2*f*g2*s + 4704*Dd**2*f*g2))/(630*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**3*k1**3*st**2*(-63*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + 2*D1*bd1*(D1*(f**3*s*(169*r + 169*s - 96) + f**2*(-25*fd*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3) + 33*s*(r*(C + 2) + s*(C + 2) - 3)) - 3*f*(9*fd*(r*(C + 2)*(4*s - 1) + s**2*(4*C + 8) - s*(3*C + 9) + 3) + 7*s*(g2*(r + s) + gd2*(-6*r - 6*s + 3))) + 63*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(25*f**2*(5*r*(8*s - 1) + 40*s**2 - 32*s + 3) + 27*f*(r*(C + 2)*(8*s - 1) + s**2*(8*C + 16) - s*(4*C + 20) + 3) - 63*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 21*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(2*f**2*(fd*(169*r*(3*s - 1) + 507*s**2 - 580*s + 169) - 25*fdd*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5)) + f*(-50*fd**2*(10*r*(3*s - 1) + 30*s**2 - 34*s + 7) + 66*fd*(C*(2*s - 1)*(r + s - 1) + r*(4*s - 2) + 4*s**2 - 3*s + 2) - 54*fdd*(C*(2*s - 1)*(r + s - 1) + r*(4*s - 2) + 4*s**2 - 3*s + 2) - 21*s*(3*bdd1*(K - 1)*(2*r + 2*s - 1) + (2*gd2 - 6*gdd2)*(r + s - 1))) - 54*fd**2*(C*(2*s - 1)*(r + s - 1) + r*(4*s - 2) + 4*s**2 - 3*s - 1) - 42*fd*(g2*(s - 1) + gd2*(3 - 6*s))*(r + s - 1) + 126*fdd*g2*(s - 1)*(r + s - 1)) - 21*D1*bd1*(K - 1)*(D1*(f*s*(-2*r - 2*s + 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 3*Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 2*D1*(Dd*(169*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(33*C*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 3*f*(9*fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 4*r*(8*s - 3) + 32*s**2 - 28*s + 7) + 7*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 21*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 63*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(125*f**2 + f*(27*C + 54) - 63*g2)) - 2*Dd**2*f*(125*f**2 + f*(27*C + 54) - 63*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 2*f*(D1**2*(25*bdd1*f**2*s*(5*r + 5*s - 3) - 63*bdd1*g2*s*(r + s) - 9*f*(-3*bdd1*s*(r*(C + 2) + s*(C + 2) - 3) + 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + 45*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 9*D1*f*(Dd*(7*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 45*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k2*k3**3) + D1**2*Pk2*Pkd3*ct**3*k1**3*(864*C*D1**2*bdd1*f**2*r*s + 864*C*D1**2*bdd1*f**2*s**2 - 600*C*D1**2*f**2*fd*r*s + 200*C*D1**2*f**2*fd*r - 600*C*D1**2*f**2*fd*s**2 + 600*C*D1**2*f**2*fd*s - 200*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 800*C*D1*Dd*f**3*r*s + 200*C*D1*Dd*f**3*r - 800*C*D1*Dd*f**3*s**2 + 800*C*D1*Dd*f**3*s - 200*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r*s + 180*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s - 216*D1**2*b2*f*fd*r*s + 108*D1**2*b2*f*fd*r - 216*D1**2*b2*f*fd*s**2 + 216*D1**2*b2*f*fd*s - 108*D1**2*b2*f*fd + 360*D1**2*b2*f*fdd*r*s - 180*D1**2*b2*f*fdd*r + 360*D1**2*b2*f*fdd*s**2 - 360*D1**2*b2*f*fdd*s + 180*D1**2*b2*f*fdd + 360*D1**2*b2*fd**2*r*s - 180*D1**2*b2*fd**2*r + 360*D1**2*b2*fd**2*s**2 - 360*D1**2*b2*fd**2*s - 6*D1**2*bd1**2*(15*f**2*(r**2 + r*(18*s - 11) + 17*s**2 - 25*s + 6) + 7*f*(3*r**2 + r*(12*C*(2*s - 1) - 32*K*s + 50*s - 9) + s**2*(24*C - 32*K + 47) + s*(-24*C + 16*K - 49) + 18) - 140*g2*(r*(2*s - 1) + s*(2*s - 2))) - 108*D1**2*bd2*f**2*r*s - 108*D1**2*bd2*f**2*s**2 + 108*D1**2*bd2*f**2*s + 720*D1**2*bd2*f*fd*r*s - 180*D1**2*bd2*f*fd*r + 720*D1**2*bd2*f*fd*s**2 - 720*D1**2*bd2*f*fd*s + 180*D1**2*bd2*f*fd + 630*D1**2*bdd1*f**3*r**2 + 2340*D1**2*bdd1*f**3*r*s - 630*D1**2*bdd1*f**3*r + 1710*D1**2*bdd1*f**3*s**2 - 1350*D1**2*bdd1*f**3*s + 315*D1**2*bdd1*f**3 + 360*D1**2*bdd1*f**2*r**2 + 252*D1**2*bdd1*f**2*r*s - 270*D1**2*bdd1*f**2*r - 108*D1**2*bdd1*f**2*s**2 - 666*D1**2*bdd1*f**2*s - 135*D1**2*bdd1*f**2 - 1344*D1**2*bdd1*f*g2*r*s - 1344*D1**2*bdd1*f*g2*s**2 + 180*D1**2*bdd2*f**2*r*s + 180*D1**2*bdd2*f**2*s**2 - 180*D1**2*bdd2*f**2*s - 795*D1**2*f**2*fd*r**2 - 4050*D1**2*f**2*fd*r*s + 1880*D1**2*f**2*fd*r - 3255*D1**2*f**2*fd*s**2 + 3520*D1**2*f**2*fd*s - 1350*D1**2*f**2*fd + 1005*D1**2*f**2*fdd*r**2 + 3510*D1**2*f**2*fdd*r*s - 1840*D1**2*f**2*fdd*r + 2505*D1**2*f**2*fdd*s**2 - 2840*D1**2*f**2*fdd*s + 1170*D1**2*f**2*fdd + 216*D1**2*f**2*gd2*r*s + 216*D1**2*f**2*gd2*s**2 - 216*D1**2*f**2*gd2*s - 360*D1**2*f**2*gdd2*r*s - 360*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s + 2010*D1**2*f*fd**2*r**2 + 7020*D1**2*f*fd**2*r*s - 3680*D1**2*f*fd**2*r + 5010*D1**2*f*fd**2*s**2 - 5680*D1**2*f*fd**2*s + 1170*D1**2*f*fd**2 + 432*D1**2*f*fd*g2*r*s - 216*D1**2*f*fd*g2*r + 432*D1**2*f*fd*g2*s**2 - 432*D1**2*f*fd*g2*s + 216*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r*s + 360*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 1440*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s - 432*D1*Dd*b2*f**2*r*s + 108*D1*Dd*b2*f**2*r - 432*D1*Dd*b2*f**2*s**2 + 432*D1*Dd*b2*f**2*s - 108*D1*Dd*b2*f**2 + 2880*D1*Dd*b2*f*fd*r*s - 1080*D1*Dd*b2*f*fd*r + 2880*D1*Dd*b2*f*fd*s**2 - 2880*D1*Dd*b2*f*fd*s + 720*D1*Dd*b2*f*fd + 1440*D1*Dd*bd2*f**2*r*s - 180*D1*Dd*bd2*f**2*r + 1440*D1*Dd*bd2*f**2*s**2 - 1440*D1*Dd*bd2*f**2*s + 180*D1*Dd*bd2*f**2 - 1060*D1*Dd*f**3*r**2 - 5400*D1*Dd*f**3*r*s + 2410*D1*Dd*f**3*r - 4340*D1*Dd*f**3*s**2 + 4870*D1*Dd*f**3*s - 1615*D1*Dd*f**3 + 8040*D1*Dd*f**2*fd*r**2 + 28080*D1*Dd*f**2*fd*r*s - 14890*D1*Dd*f**2*fd*r + 20040*D1*Dd*f**2*fd*s**2 - 23390*D1*Dd*f**2*fd*s + 6520*D1*Dd*f**2*fd + 864*D1*Dd*f**2*g2*r*s - 216*D1*Dd*f**2*g2*r + 864*D1*Dd*f**2*g2*s**2 - 864*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r*s + 360*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 2880*D1*Dd*f**2*gd2*s - 360*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r*s + 2160*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 5760*D1*Dd*f*fd*g2*s - 1440*D1*Dd*f*fd*g2 + 720*D1*Ddd*b2*f**2*r*s - 180*D1*Ddd*b2*f**2*r + 720*D1*Ddd*b2*f**2*s**2 - 720*D1*Ddd*b2*f**2*s + 180*D1*Ddd*b2*f**2 + 1340*D1*Ddd*f**3*r**2 + 4680*D1*Ddd*f**3*r*s - 2510*D1*Ddd*f**3*r + 3340*D1*Ddd*f**3*s**2 - 4010*D1*Ddd*f**3*s + 1505*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r*s + 360*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 1440*D1*Ddd*f**2*g2*s - 360*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(15*f**3*(10*r**2 + 10*r*(6*s - 1) + 50*s**2 - 34*s + 5) - 3*f**2*(-80*C*s**2 - 12*K*s**2 + 12*K*s + 20*fd*(21*r**2 + r*(78*s - 34) + 57*s**2 - 60*s + 11) - 24*r**2 - 2*r*(s*(40*C + 6*K + 28) + 5) - 32*s**2 + 78*s + 37) - 2*f*(3*fd*(192*C*s**2 - 144*C*s + 10*K*(r*(4*s - 1) + (1 - 2*s)**2) + 80*r**2 + r*(48*C*(4*s - 1) + 56*s - 69) - 24*s**2 - 39*s + 67) + 56*s*(3*g2*(r + s) + gd2*(-8*r - 8*s + 4))) + 448*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*Dd*f*(15*f**2*(56*r**2 + r*(208*s - 82) + 152*s**2 - 150*s + 29) + 3*f*(384*C*s**2 - 192*C*s + 10*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 160*r**2 + 2*r*(24*C*(8*s - 1) + 56*s - 77) - 48*s**2 - 164*s + 67) - 224*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 2160*Dd**2*b2*f**2*r*s - 540*Dd**2*b2*f**2*r + 2160*Dd**2*b2*f**2*s**2 - 2160*Dd**2*b2*f**2*s + 360*Dd**2*b2*f**2 + 4020*Dd**2*f**3*r**2 + 14040*Dd**2*f**3*r*s - 7530*Dd**2*f**3*r + 10020*Dd**2*f**3*s**2 - 12030*Dd**2*f**3*s + 3010*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r*s + 1080*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 4320*Dd**2*f**2*g2*s - 720*Dd**2*f**2*g2 - 420*b1**3*(K - 1)*(D1*(Dd + Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 3*b1**2*(-56*C*D1**2*fd*r*s - 56*C*D1**2*fd*s**2 + 56*C*D1**2*fd*s + 168*C*D1**2*fdd*r*s + 168*C*D1**2*fdd*s**2 - 168*C*D1**2*fdd*s - 224*C*D1*Dd*f*r*s + 56*C*D1*Dd*f*r - 224*C*D1*Dd*f*s**2 + 224*C*D1*Dd*f*s - 56*C*D1*Dd*f + 1344*C*D1*Dd*fd*r*s - 168*C*D1*Dd*fd*r + 1344*C*D1*Dd*fd*s**2 - 1344*C*D1*Dd*fd*s + 168*C*D1*Dd*fd + 672*C*D1*Ddd*f*r*s - 168*C*D1*Ddd*f*r + 672*C*D1*Ddd*f*s**2 - 672*C*D1*Ddd*f*s + 168*C*D1*Ddd*f + 2016*C*Dd**2*f*r*s - 504*C*Dd**2*f*r + 2016*C*Dd**2*f*s**2 - 2016*C*Dd**2*f*s + 336*C*Dd**2*f + 168*D1**2*K*fd*r*s - 168*D1**2*K*fd*r + 168*D1**2*K*fd*s**2 - 336*D1**2*K*fd*s + 168*D1**2*K*fd - 224*D1**2*K*fdd*r*s + 224*D1**2*K*fdd*r - 224*D1**2*K*fdd*s**2 + 448*D1**2*K*fdd*s - 224*D1**2*K*fdd + 140*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 18*D1**2*f*fd*r**2 - 660*D1**2*f*fd*r*s - 642*D1**2*f*fd*s**2 + 432*D1**2*f*fd*s + 18*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 540*D1**2*f*fdd*r*s + 510*D1**2*f*fdd*s**2 - 300*D1**2*f*fdd*s - 30*D1**2*f*fdd + 30*D1**2*fd**2*r**2 + 540*D1**2*fd**2*r*s + 510*D1**2*fd**2*s**2 - 300*D1**2*fd**2*s - 30*D1**2*fd**2 - 7*D1**2*fd*r**2 - 350*D1**2*fd*r*s + 182*D1**2*fd*r - 343*D1**2*fd*s**2 + 294*D1**2*fd*s - 175*D1**2*fd + 21*D1**2*fdd*r**2 + 350*D1**2*fdd*r*s - 266*D1**2*fdd*r + 329*D1**2*fdd*s**2 - 322*D1**2*fdd*s + 245*D1**2*fdd - 280*D1**2*gd2*r*s - 280*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 280*D1**2*gdd2*r*s - 280*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s + 672*D1*Dd*K*f*r*s - 168*D1*Dd*K*f*r + 672*D1*Dd*K*f*s**2 - 672*D1*Dd*K*f*s + 168*D1*Dd*K*f - 1792*D1*Dd*K*fd*r*s + 1120*D1*Dd*K*fd*r - 1792*D1*Dd*K*fd*s**2 + 2688*D1*Dd*K*fd*s - 896*D1*Dd*K*fd - 36*D1*Dd*f**2*r**2 - 1320*D1*Dd*f**2*r*s + 366*D1*Dd*f**2*r - 1284*D1*Dd*f**2*s**2 + 1302*D1*Dd*f**2*s - 339*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 4320*D1*Dd*f*fd*r*s - 660*D1*Dd*f*fd*r + 4080*D1*Dd*f*fd*s**2 - 3300*D1*Dd*f*fd*s + 300*D1*Dd*f*fd - 28*D1*Dd*f*r**2 - 1400*D1*Dd*f*r*s + 378*D1*Dd*f*r - 1372*D1*Dd*f*s**2 + 1386*D1*Dd*f*s - 357*D1*Dd*f + 168*D1*Dd*fd*r**2 + 2800*D1*Dd*fd*r*s - 1498*D1*Dd*fd*r + 2632*D1*Dd*fd*s**2 - 2646*D1*Dd*fd*s + 854*D1*Dd*fd - 1120*D1*Dd*g2*r*s + 280*D1*Dd*g2*r - 1120*D1*Dd*g2*s**2 + 1120*D1*Dd*g2*s - 280*D1*Dd*g2 - 2240*D1*Dd*gd2*r*s + 280*D1*Dd*gd2*r - 2240*D1*Dd*gd2*s**2 + 2240*D1*Dd*gd2*s - 280*D1*Dd*gd2 - 896*D1*Ddd*K*f*r*s + 224*D1*Ddd*K*f*r - 896*D1*Ddd*K*f*s**2 + 896*D1*Ddd*K*f*s - 224*D1*Ddd*K*f + 60*D1*Ddd*f**2*r**2 + 1080*D1*Ddd*f**2*r*s - 330*D1*Ddd*f**2*r + 1020*D1*Ddd*f**2*s**2 - 1050*D1*Ddd*f**2*s + 285*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 + 1400*D1*Ddd*f*r*s - 434*D1*Ddd*f*r + 1316*D1*Ddd*f*s**2 - 1358*D1*Ddd*f*s + 371*D1*Ddd*f - 1120*D1*Ddd*g2*r*s + 280*D1*Ddd*g2*r - 1120*D1*Ddd*g2*s**2 + 1120*D1*Ddd*g2*s - 280*D1*Ddd*g2 + 140*D1*bd1*(K - 1)*(D1*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*(24*r*s - 7*r + 24*s**2 - 24*s + 5)) - 2688*Dd**2*K*f*r*s + 672*Dd**2*K*f*r - 2688*Dd**2*K*f*s**2 + 2688*Dd**2*K*f*s - 448*Dd**2*K*f + 180*Dd**2*f**2*r**2 + 3240*Dd**2*f**2*r*s - 990*Dd**2*f**2*r + 3060*Dd**2*f**2*s**2 - 3150*Dd**2*f**2*s + 570*Dd**2*f**2 + 252*Dd**2*f*r**2 + 4200*Dd**2*f*r*s - 1302*Dd**2*f*r + 3948*Dd**2*f*s**2 - 4074*Dd**2*f*s + 742*Dd**2*f - 3360*Dd**2*g2*r*s + 840*Dd**2*g2*r - 3360*Dd**2*g2*s**2 + 3360*Dd**2*g2*s - 560*Dd**2*g2) - 3*b1*(480*C*D1**2*f*fd*r*s - 240*C*D1**2*f*fd*r + 480*C*D1**2*f*fd*s**2 - 720*C*D1**2*f*fd*s + 240*C*D1**2*f*fd - 576*C*D1**2*f*fdd*r*s + 288*C*D1**2*f*fdd*r - 576*C*D1**2*f*fdd*s**2 + 864*C*D1**2*f*fdd*s - 288*C*D1**2*f*fdd - 576*C*D1**2*fd**2*r*s + 288*C*D1**2*fd**2*r - 576*C*D1**2*fd**2*s**2 + 864*C*D1**2*fd**2*s - 288*C*D1**2*fd**2 + 960*C*D1*Dd*f**2*r*s - 240*C*D1*Dd*f**2*r + 960*C*D1*Dd*f**2*s**2 - 960*C*D1*Dd*f**2*s + 240*C*D1*Dd*f**2 - 4608*C*D1*Dd*f*fd*r*s + 1728*C*D1*Dd*f*fd*r - 4608*C*D1*Dd*f*fd*s**2 + 5760*C*D1*Dd*f*fd*s - 1440*C*D1*Dd*f*fd - 1152*C*D1*Ddd*f**2*r*s + 288*C*D1*Ddd*f**2*r - 1152*C*D1*Ddd*f**2*s**2 + 1152*C*D1*Ddd*f**2*s - 288*C*D1*Ddd*f**2 - 3456*C*Dd**2*f**2*r*s + 864*C*Dd**2*f**2*r - 3456*C*Dd**2*f**2*s**2 + 3456*C*Dd**2*f**2*s - 576*C*Dd**2*f**2 + 72*D1**2*K*f*fd*r*s - 36*D1**2*K*f*fd*r + 72*D1**2*K*f*fd*s**2 - 72*D1**2*K*f*fd*s + 36*D1**2*K*f*fd - 120*D1**2*K*f*fdd*r*s + 60*D1**2*K*f*fdd*r - 120*D1**2*K*f*fdd*s**2 + 120*D1**2*K*f*fdd*s - 60*D1**2*K*f*fdd - 120*D1**2*K*fd**2*r*s + 60*D1**2*K*fd**2*r - 120*D1**2*K*fd**2*s**2 + 120*D1**2*K*fd**2*s + 140*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(15*f**2*(2*r**2 + r*(36*s - 22) + 34*s**2 - 50*s + 21) + 7*f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 64*K*s**2 + 32*K*s + 6*r**2 - 2*r*(32*K*s - 50*s + 9) + 94*s**2 - 98*s + 15) - 280*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 450*D1**2*f**2*fd*r**2 + 2700*D1**2*f**2*fd*r*s - 1350*D1**2*f**2*fd*r + 2250*D1**2*f**2*fd*s**2 - 2790*D1**2*f**2*fd*s + 975*D1**2*f**2*fd - 630*D1**2*f**2*fdd*r**2 - 2340*D1**2*f**2*fdd*r*s + 1410*D1**2*f**2*fdd*r - 1710*D1**2*f**2*fdd*s**2 + 2250*D1**2*f**2*fdd*s - 885*D1**2*f**2*fdd - 1260*D1**2*f*fd**2*r**2 - 4680*D1**2*f*fd**2*r*s + 2820*D1**2*f*fd**2*r - 3420*D1**2*f*fd**2*s**2 + 4500*D1**2*f*fd**2*s - 1320*D1**2*f*fd**2 + 144*D1**2*f*fd*r**2 + 336*D1**2*f*fd*r*s - 342*D1**2*f*fd*r + 192*D1**2*f*fd*s**2 - 126*D1**2*f*fd*s + 279*D1**2*f*fd - 240*D1**2*f*fdd*r**2 - 168*D1**2*f*fdd*r*s + 234*D1**2*f*fdd*r + 72*D1**2*f*fdd*s**2 - 210*D1**2*f*fdd*s - 129*D1**2*f*fdd - 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*s**2 + 336*D1**2*f*gd2*s + 448*D1**2*f*gdd2*r*s + 448*D1**2*f*gdd2*s**2 - 448*D1**2*f*gdd2*s - 240*D1**2*fd**2*r**2 - 168*D1**2*fd**2*r*s + 234*D1**2*fd**2*r + 72*D1**2*fd**2*s**2 - 210*D1**2*fd**2*s + 318*D1**2*fd**2 - 336*D1**2*fd*g2*r*s + 336*D1**2*fd*g2*r - 336*D1**2*fd*g2*s**2 + 672*D1**2*fd*g2*s - 336*D1**2*fd*g2 + 896*D1**2*fd*gd2*r*s - 448*D1**2*fd*gd2*r + 896*D1**2*fd*gd2*s**2 - 1344*D1**2*fd*gd2*s + 448*D1**2*fd*gd2 + 448*D1**2*fdd*g2*r*s - 448*D1**2*fdd*g2*r + 448*D1**2*fdd*g2*s**2 - 896*D1**2*fdd*g2*s + 448*D1**2*fdd*g2 + 144*D1*Dd*K*f**2*r*s - 36*D1*Dd*K*f**2*r + 144*D1*Dd*K*f**2*s**2 - 144*D1*Dd*K*f**2*s + 36*D1*Dd*K*f**2 - 960*D1*Dd*K*f*fd*r*s + 360*D1*Dd*K*f*fd*r - 960*D1*Dd*K*f*fd*s**2 + 960*D1*Dd*K*f*fd*s - 240*D1*Dd*K*f*fd + 600*D1*Dd*f**3*r**2 + 3600*D1*Dd*f**3*r*s - 1500*D1*Dd*f**3*r + 3000*D1*Dd*f**3*s**2 - 3300*D1*Dd*f**3*s + 1050*D1*Dd*f**3 - 5040*D1*Dd*f**2*fd*r**2 - 18720*D1*Dd*f**2*fd*r*s + 10500*D1*Dd*f**2*fd*r - 13680*D1*Dd*f**2*fd*s**2 + 17100*D1*Dd*f**2*fd*s - 5070*D1*Dd*f**2*fd + 288*D1*Dd*f**2*r**2 + 672*D1*Dd*f**2*r*s - 456*D1*Dd*f**2*r + 384*D1*Dd*f**2*s**2 - 528*D1*Dd*f**2*s + 240*D1*Dd*f**2 - 1920*D1*Dd*f*fd*r**2 - 1344*D1*Dd*f*fd*r*s + 2064*D1*Dd*f*fd*r + 576*D1*Dd*f*fd*s**2 - 648*D1*Dd*f*fd*s - 258*D1*Dd*f*fd - 1344*D1*Dd*f*g2*r*s + 336*D1*Dd*f*g2*r - 1344*D1*Dd*f*g2*s**2 + 1344*D1*Dd*f*g2*s - 336*D1*Dd*f*g2 + 3584*D1*Dd*f*gd2*r*s - 448*D1*Dd*f*gd2*r + 3584*D1*Dd*f*gd2*s**2 - 3584*D1*Dd*f*gd2*s + 448*D1*Dd*f*gd2 + 3584*D1*Dd*fd*g2*r*s - 2240*D1*Dd*fd*g2*r + 3584*D1*Dd*fd*g2*s**2 - 5376*D1*Dd*fd*g2*s + 1792*D1*Dd*fd*g2 - 240*D1*Ddd*K*f**2*r*s + 60*D1*Ddd*K*f**2*r - 240*D1*Ddd*K*f**2*s**2 + 240*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 - 840*D1*Ddd*f**3*r**2 - 3120*D1*Ddd*f**3*r*s + 1620*D1*Ddd*f**3*r - 2280*D1*Ddd*f**3*s**2 + 2700*D1*Ddd*f**3*s - 990*D1*Ddd*f**3 - 480*D1*Ddd*f**2*r**2 - 336*D1*Ddd*f**2*r*s + 564*D1*Ddd*f**2*r + 144*D1*Ddd*f**2*s**2 + 96*D1*Ddd*f**2*s - 204*D1*Ddd*f**2 + 1792*D1*Ddd*f*g2*r*s - 448*D1*Ddd*f*g2*r + 1792*D1*Ddd*f*g2*s**2 - 1792*D1*Ddd*f*g2*s + 448*D1*Ddd*f*g2 + D1*bd1*(-D1*(3*f**2*(6*r**2 + 2*r*(110*s - 61) + 214*s**2 - 290*s + 119) + f*(56*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 60*fd*(2*r**2 + r*(36*s - 11) + 34*s**2 - 35*s + 7) + 14*r**2 - 14*r*(s*(24*K - 50) + 13) + 7*s**2*(98 - 48*K) + 7*s*(24*K - 106) + 175) - 14*fd*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) - 16*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + 6*r**2 + 100*r*s - 47*r + 94*s**2 - 95*s + 7) + 280*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 280*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd*(15*f**2*(8*r**2 + 6*r*(24*s - 11) + 136*s**2 - 170*s + 47) + 7*f*(24*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 16*K*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 24*r**2 + 400*r*s - 98*r + 376*s**2 - 390*s + 67) - 280*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 720*Dd**2*K*f**2*r*s + 180*Dd**2*K*f**2*r - 720*Dd**2*K*f**2*s**2 + 720*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 - 2520*Dd**2*f**3*r**2 - 9360*Dd**2*f**3*r*s + 4860*Dd**2*f**3*r - 6840*Dd**2*f**3*s**2 + 8100*Dd**2*f**3*s - 1980*Dd**2*f**3 - 1440*Dd**2*f**2*r**2 - 1008*Dd**2*f**2*r*s + 1692*Dd**2*f**2*r + 432*Dd**2*f**2*s**2 + 288*Dd**2*f**2*s - 408*Dd**2*f**2 + 5376*Dd**2*f*g2*r*s - 1344*Dd**2*f*g2*r + 5376*Dd**2*f*g2*s**2 - 5376*Dd**2*f*g2*s + 896*Dd**2*f*g2))/(630*d**2*k2*k3**3) - 3*D1**2*Pk2*Pkd3*ct**3*k1*k2**5*st**4*(-72*C*D1**2*f**2*fd*r**2 - 144*C*D1**2*f**2*fd*r*s + 96*C*D1**2*f**2*fd*r - 72*C*D1**2*f**2*fd*s**2 + 96*C*D1**2*f**2*fd*s - 48*C*D1**2*f**2*fd + 36*C*D1**2*f**2*fdd*r**2 + 72*C*D1**2*f**2*fdd*r*s - 48*C*D1**2*f**2*fdd*r + 36*C*D1**2*f**2*fdd*s**2 - 48*C*D1**2*f**2*fdd*s + 24*C*D1**2*f**2*fdd + 72*C*D1**2*f*fd**2*r**2 + 144*C*D1**2*f*fd**2*r*s - 96*C*D1**2*f*fd**2*r + 72*C*D1**2*f*fd**2*s**2 - 96*C*D1**2*f*fd**2*s + 24*C*D1**2*f*fd**2 - 96*C*D1*Dd*f**3*r**2 - 192*C*D1*Dd*f**3*r*s + 144*C*D1*Dd*f**3*r - 96*C*D1*Dd*f**3*s**2 + 144*C*D1*Dd*f**3*s - 72*C*D1*Dd*f**3 + 288*C*D1*Dd*f**2*fd*r**2 + 576*C*D1*Dd*f**2*fd*r*s - 408*C*D1*Dd*f**2*fd*r + 288*C*D1*Dd*f**2*fd*s**2 - 408*C*D1*Dd*f**2*fd*s + 144*C*D1*Dd*f**2*fd + 48*C*D1*Ddd*f**3*r**2 + 96*C*D1*Ddd*f**3*r*s - 72*C*D1*Ddd*f**3*r + 48*C*D1*Ddd*f**3*s**2 - 72*C*D1*Ddd*f**3*s + 36*C*D1*Ddd*f**3 + 144*C*Dd**2*f**3*r**2 + 288*C*Dd**2*f**3*r*s - 216*C*Dd**2*f**3*r + 144*C*Dd**2*f**3*s**2 - 216*C*Dd**2*f**3*s + 72*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 - 144*D1**2*K*b1*f*fd*r*s + 72*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 + 54*D1**2*f**2*fd*r**2 + 108*D1**2*f**2*fd*r*s - 72*D1**2*f**2*fd*r + 54*D1**2*f**2*fd*s**2 - 72*D1**2*f**2*fd*s + 36*D1**2*f**2*fd - 27*D1**2*f**2*fdd*r**2 - 54*D1**2*f**2*fdd*r*s + 36*D1**2*f**2*fdd*r - 27*D1**2*f**2*fdd*s**2 + 36*D1**2*f**2*fdd*s - 18*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r - 36*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 54*D1**2*f*fd**2*r**2 - 108*D1**2*f*fd**2*r*s + 72*D1**2*f*fd**2*r - 54*D1**2*f*fd**2*s**2 + 72*D1**2*f*fd**2*s - 18*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 - 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 216*D1*Dd*K*b1*f**2*s - 108*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r**2 + 576*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 360*D1*Dd*K*b1*f*fd*s + 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 72*D1*Dd*f**3*r**2 + 144*D1*Dd*f**3*r*s - 108*D1*Dd*f**3*r + 72*D1*Dd*f**3*s**2 - 108*D1*Dd*f**3*s + 54*D1*Dd*f**3 - 216*D1*Dd*f**2*fd*r**2 - 432*D1*Dd*f**2*fd*r*s + 306*D1*Dd*f**2*fd*r - 216*D1*Dd*f**2*fd*s**2 + 306*D1*Dd*f**2*fd*s - 108*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 504*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 720*D1*Dd*f*fd*g2*s - 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 + 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 108*D1*Ddd*K*b1*f**2*s + 54*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 36*D1*Ddd*f**3*r**2 - 72*D1*Ddd*f**3*r*s + 54*D1*Ddd*f**3*r - 36*D1*Ddd*f**3*s**2 + 54*D1*Ddd*f**3*s - 27*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 216*D1*Ddd*f**2*g2*s - 108*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*b1*f**2*r**2 + 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 324*Dd**2*K*b1*f**2*s + 108*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 108*Dd**2*f**3*r**2 - 216*Dd**2*f**3*r*s + 162*Dd**2*f**3*r - 108*Dd**2*f**3*s**2 + 162*Dd**2*f**3*s - 54*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 648*Dd**2*f**2*g2*s - 216*Dd**2*f**2*g2)/(14*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**3*k1*k2**5*st**2*(-108*C*D1**2*bdd1*f**2*r**2 - 216*C*D1**2*bdd1*f**2*r*s + 216*C*D1**2*bdd1*f**2*r - 108*C*D1**2*bdd1*f**2*s**2 + 216*C*D1**2*bdd1*f**2*s - 108*C*D1**2*bdd1*f**2 + 552*C*D1**2*f**2*fd*r**2 + 1104*C*D1**2*f**2*fd*r*s - 736*C*D1**2*f**2*fd*r + 552*C*D1**2*f**2*fd*s**2 - 736*C*D1**2*f**2*fd*s + 368*C*D1**2*f**2*fd - 600*C*D1**2*f**2*fdd*r**2 - 1200*C*D1**2*f**2*fdd*r*s + 800*C*D1**2*f**2*fdd*r - 600*C*D1**2*f**2*fdd*s**2 + 800*C*D1**2*f**2*fdd*s - 400*C*D1**2*f**2*fdd - 1200*C*D1**2*f*fd**2*r**2 - 2400*C*D1**2*f*fd**2*r*s + 1600*C*D1**2*f*fd**2*r - 1200*C*D1**2*f*fd**2*s**2 + 1600*C*D1**2*f*fd**2*s - 400*C*D1**2*f*fd**2 + 736*C*D1*Dd*f**3*r**2 + 1472*C*D1*Dd*f**3*r*s - 1104*C*D1*Dd*f**3*r + 736*C*D1*Dd*f**3*s**2 - 1104*C*D1*Dd*f**3*s + 552*C*D1*Dd*f**3 - 4800*C*D1*Dd*f**2*fd*r**2 - 9600*C*D1*Dd*f**2*fd*r*s + 6800*C*D1*Dd*f**2*fd*r - 4800*C*D1*Dd*f**2*fd*s**2 + 6800*C*D1*Dd*f**2*fd*s - 2400*C*D1*Dd*f**2*fd - 800*C*D1*Ddd*f**3*r**2 - 1600*C*D1*Ddd*f**3*r*s + 1200*C*D1*Ddd*f**3*r - 800*C*D1*Ddd*f**3*s**2 + 1200*C*D1*Ddd*f**3*s - 600*C*D1*Ddd*f**3 - 2400*C*Dd**2*f**3*r**2 - 4800*C*Dd**2*f**3*r*s + 3600*C*Dd**2*f**3*r - 2400*C*Dd**2*f**3*s**2 + 3600*C*Dd**2*f**3*s - 1200*C*Dd**2*f**3 - 180*D1**2*K*bdd1*f**2*r**2 - 360*D1**2*K*bdd1*f**2*r*s + 360*D1**2*K*bdd1*f**2*r - 180*D1**2*K*bdd1*f**2*s**2 + 360*D1**2*K*bdd1*f**2*s - 180*D1**2*K*bdd1*f**2 + 18*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 + 81*D1**2*bdd1*f**2*r**2 + 162*D1**2*bdd1*f**2*r*s - 162*D1**2*bdd1*f**2*r + 81*D1**2*bdd1*f**2*s**2 - 162*D1**2*bdd1*f**2*s + 81*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s - 504*D1**2*bdd1*f*g2*r + 252*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 - 195*D1**2*f**2*fd*r**2 - 390*D1**2*f**2*fd*r*s + 260*D1**2*f**2*fd*r - 195*D1**2*f**2*fd*s**2 + 260*D1**2*f**2*fd*s - 130*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r**2 + 600*D1**2*f**2*fdd*r*s - 400*D1**2*f**2*fdd*r + 300*D1**2*f**2*fdd*s**2 - 400*D1**2*f**2*fdd*s + 200*D1**2*f**2*fdd - 216*D1**2*f**2*gd2*r**2 - 432*D1**2*f**2*gd2*r*s + 432*D1**2*f**2*gd2*r - 216*D1**2*f**2*gd2*s**2 + 432*D1**2*f**2*gd2*s - 216*D1**2*f**2*gd2 + 360*D1**2*f**2*gdd2*r**2 + 720*D1**2*f**2*gdd2*r*s - 720*D1**2*f**2*gdd2*r + 360*D1**2*f**2*gdd2*s**2 - 720*D1**2*f**2*gdd2*s + 360*D1**2*f**2*gdd2 + 600*D1**2*f*fd**2*r**2 + 1200*D1**2*f*fd**2*r*s - 800*D1**2*f*fd**2*r + 600*D1**2*f*fd**2*s**2 - 800*D1**2*f*fd**2*s + 200*D1**2*f*fd**2 - 432*D1**2*f*fd*g2*r**2 - 864*D1**2*f*fd*g2*r*s + 432*D1**2*f*fd*g2*r - 432*D1**2*f*fd*g2*s**2 + 432*D1**2*f*fd*g2*s - 216*D1**2*f*fd*g2 + 1440*D1**2*f*fd*gd2*r**2 + 2880*D1**2*f*fd*gd2*r*s - 2160*D1**2*f*fd*gd2*r + 1440*D1**2*f*fd*gd2*s**2 - 2160*D1**2*f*fd*gd2*s + 720*D1**2*f*fd*gd2 + 720*D1**2*f*fdd*g2*r**2 + 1440*D1**2*f*fdd*g2*r*s - 720*D1**2*f*fdd*g2*r + 720*D1**2*f*fdd*g2*s**2 - 720*D1**2*f*fdd*g2*s + 360*D1**2*f*fdd*g2 + 720*D1**2*fd**2*g2*r**2 + 1440*D1**2*fd**2*g2*r*s - 720*D1**2*fd**2*g2*r + 720*D1**2*fd**2*g2*s**2 - 720*D1**2*fd**2*g2*s - 260*D1*Dd*f**3*r**2 - 520*D1*Dd*f**3*r*s + 390*D1*Dd*f**3*r - 260*D1*Dd*f**3*s**2 + 390*D1*Dd*f**3*s - 195*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r**2 + 4800*D1*Dd*f**2*fd*r*s - 3400*D1*Dd*f**2*fd*r + 2400*D1*Dd*f**2*fd*s**2 - 3400*D1*Dd*f**2*fd*s + 1200*D1*Dd*f**2*fd - 864*D1*Dd*f**2*g2*r**2 - 1728*D1*Dd*f**2*g2*r*s + 1296*D1*Dd*f**2*g2*r - 864*D1*Dd*f**2*g2*s**2 + 1296*D1*Dd*f**2*g2*s - 648*D1*Dd*f**2*g2 + 2880*D1*Dd*f**2*gd2*r**2 + 5760*D1*Dd*f**2*gd2*r*s - 5040*D1*Dd*f**2*gd2*r + 2880*D1*Dd*f**2*gd2*s**2 - 5040*D1*Dd*f**2*gd2*s + 2160*D1*Dd*f**2*gd2 + 5760*D1*Dd*f*fd*g2*r**2 + 11520*D1*Dd*f*fd*g2*r*s - 7200*D1*Dd*f*fd*g2*r + 5760*D1*Dd*f*fd*g2*s**2 - 7200*D1*Dd*f*fd*g2*s + 2160*D1*Dd*f*fd*g2 + 400*D1*Ddd*f**3*r**2 + 800*D1*Ddd*f**3*r*s - 600*D1*Ddd*f**3*r + 400*D1*Ddd*f**3*s**2 - 600*D1*Ddd*f**3*s + 300*D1*Ddd*f**3 + 1440*D1*Ddd*f**2*g2*r**2 + 2880*D1*Ddd*f**2*g2*r*s - 2160*D1*Ddd*f**2*g2*r + 1440*D1*Ddd*f**2*g2*s**2 - 2160*D1*Ddd*f**2*g2*s + 1080*D1*Ddd*f**2*g2 + 9*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(24*C + 12*K - 11)*(r + s - 1) - 2*f*(fd*(12*C + 20*K - 9)*(2*r + 2*s - 1) + (28*g2 - 28*gd2)*(r + s - 1)) + 56*fd*g2*(r + s)) - 2*Dd*f*(f*(12*C + 20*K - 9) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) + 1200*Dd**2*f**3*r**2 + 2400*Dd**2*f**3*r*s - 1800*Dd**2*f**3*r + 1200*Dd**2*f**3*s**2 - 1800*Dd**2*f**3*s + 600*Dd**2*f**3 + 4320*Dd**2*f**2*g2*r**2 + 8640*Dd**2*f**2*g2*r*s - 6480*Dd**2*f**2*g2*r + 4320*Dd**2*f**2*g2*s**2 - 6480*Dd**2*f**2*g2*s + 2160*Dd**2*f**2*g2 - 9*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(-48*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 144*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(35*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct**3*k1*k2**5*(D1*(-168*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(3*f**2*(24*C - 14*K - 5)*(r + s - 1) - 8*f*(fd*(30*C - 15)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 336*fd*g2*(r + s)) - 24*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6*f*(2*D1*bdd1*(f*(10*C - 5) - 14*g2)*(r + s - 1)**2 + D1*(f*(fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*gd2*(r + s - 1)**2) - 14*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + 7*b1**2*(D1**2*(3*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-12*K*fdd + fd*(4*K + 5))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*K + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*(f*(3*fd*(24*C - 14*K - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(120*C - 60)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s - 1)**2*(-168*K*bdd1 - 56*gd2 + 168*gdd2)) + (-8*r - 8*s)*(fd**2*(30*C - 15)*(r + s - 1) + 7*fd*(g2*(r + s) - 6*gd2*(r + s - 1)) - 21*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-24*K*fd*(r + s) + 3*f**2*(r + s - 1) + f*(4*K + 5)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(3*f**2*(24*C - 14*K - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*f*(fd*(30*C - 15)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 42*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 336*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(10*C - 5) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**3*k1*k2**3*st**4*(-912*C*D1**2*f**2*fd*r**2 + 528*C*D1**2*f**2*fd*r*s + 432*C*D1**2*f**2*fd*r + 1440*C*D1**2*f**2*fd*s**2 - 1136*C*D1**2*f**2*fd*s + 176*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r**2 - 120*C*D1**2*f**2*fdd*r*s - 360*C*D1**2*f**2*fdd*r - 720*C*D1**2*f**2*fdd*s**2 + 520*C*D1**2*f**2*fdd*s - 40*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r**2 - 240*C*D1**2*f*fd**2*r*s - 720*C*D1**2*f*fd**2*r - 1440*C*D1**2*f*fd**2*s**2 + 1040*C*D1**2*f*fd**2*s - 40*C*D1**2*f*fd**2 - 1216*C*D1*Dd*f**3*r**2 + 704*C*D1*Dd*f**3*r*s + 1040*C*D1*Dd*f**3*r + 1920*C*D1*Dd*f**3*s**2 - 1312*C*D1*Dd*f**3*s - 128*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r**2 - 960*C*D1*Dd*f**2*fd*r*s - 3720*C*D1*Dd*f**2*fd*r - 5760*C*D1*Dd*f**2*fd*s**2 + 3760*C*D1*Dd*f**2*fd*s + 200*C*D1*Dd*f**2*fd + 800*C*D1*Ddd*f**3*r**2 - 160*C*D1*Ddd*f**3*r*s - 760*C*D1*Ddd*f**3*r - 960*C*D1*Ddd*f**3*s**2 + 560*C*D1*Ddd*f**3*s + 160*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r**2 - 480*C*Dd**2*f**3*r*s - 2280*C*Dd**2*f**3*r - 2880*C*Dd**2*f**3*s**2 + 1680*C*Dd**2*f**3*s + 320*C*Dd**2*f**3 - 720*D1**2*K*b1*f*fd*r**2 + 720*D1**2*K*b1*f*fd*r*s - 360*D1**2*K*b1*f*fd*r + 1440*D1**2*K*b1*f*fd*s**2 - 1440*D1**2*K*b1*f*fd*s + 720*D1**2*K*b1*f*fd + 360*D1**2*K*b1*f*fdd*r**2 - 360*D1**2*K*b1*f*fdd*r*s + 180*D1**2*K*b1*f*fdd*r - 720*D1**2*K*b1*f*fdd*s**2 + 720*D1**2*K*b1*f*fdd*s - 360*D1**2*K*b1*f*fdd + 360*D1**2*K*b1*fd**2*r**2 - 360*D1**2*K*b1*fd**2*r*s + 180*D1**2*K*b1*fd**2*r - 720*D1**2*K*b1*fd**2*s**2 + 720*D1**2*K*b1*fd**2*s + 1050*D1**2*b1*f**2*fd*r**2 + 1260*D1**2*b1*f**2*fd*r*s - 1120*D1**2*b1*f**2*fd*r + 210*D1**2*b1*f**2*fd*s**2 - 560*D1**2*b1*f**2*fd*s + 420*D1**2*b1*f**2*fd - 525*D1**2*b1*f**2*fdd*r**2 - 630*D1**2*b1*f**2*fdd*r*s + 560*D1**2*b1*f**2*fdd*r - 105*D1**2*b1*f**2*fdd*s**2 + 280*D1**2*b1*f**2*fdd*s - 210*D1**2*b1*f**2*fdd - 1050*D1**2*b1*f*fd**2*r**2 - 1260*D1**2*b1*f*fd**2*r*s + 1120*D1**2*b1*f*fd**2*r - 210*D1**2*b1*f*fd**2*s**2 + 560*D1**2*b1*f*fd**2*s - 210*D1**2*b1*f*fd**2 + 1620*D1**2*b1*f*fd*r**2 + 1800*D1**2*b1*f*fd*r*s - 900*D1**2*b1*f*fd*r + 180*D1**2*b1*f*fd*s**2 - 180*D1**2*b1*f*fd*s + 90*D1**2*b1*f*fd - 810*D1**2*b1*f*fdd*r**2 - 900*D1**2*b1*f*fdd*r*s + 450*D1**2*b1*f*fdd*r - 90*D1**2*b1*f*fdd*s**2 + 90*D1**2*b1*f*fdd*s - 45*D1**2*b1*f*fdd - 810*D1**2*b1*fd**2*r**2 - 900*D1**2*b1*fd**2*r*s + 450*D1**2*b1*fd**2*r - 90*D1**2*b1*fd**2*s**2 + 90*D1**2*b1*fd**2*s - 5*D1**2*bdd1*f**2*(r + s - 1)*(9*K*(-4*r + 8*s + 4) + 7*f*(5*r + s - 5) + 81*r + 9*s - 81) - 560*D1**2*f**3*fd*r**2 - 560*D1**2*f**3*fd*r*s + 700*D1**2*f**3*fd*r + 280*D1**2*f**3*fd*s - 280*D1**2*f**3*fd + 560*D1**2*f**3*fdd*r**2 + 560*D1**2*f**3*fdd*r*s - 700*D1**2*f**3*fdd*r - 280*D1**2*f**3*fdd*s + 280*D1**2*f**3*fdd + 1680*D1**2*f**2*fd**2*r**2 + 1680*D1**2*f**2*fd**2*r*s - 2100*D1**2*f**2*fd**2*r - 840*D1**2*f**2*fd**2*s + 560*D1**2*f**2*fd**2 + 1362*D1**2*f**2*fd*r**2 + 732*D1**2*f**2*fd*r*s - 1152*D1**2*f**2*fd*r - 630*D1**2*f**2*fd*s**2 + 176*D1**2*f**2*fd*s + 244*D1**2*f**2*fd - 825*D1**2*f**2*fdd*r**2 - 510*D1**2*f**2*fdd*r*s + 720*D1**2*f**2*fdd*r + 315*D1**2*f**2*fdd*s**2 - 40*D1**2*f**2*fdd*s - 170*D1**2*f**2*fdd + 720*D1**2*f**2*gd2*r**2 - 720*D1**2*f**2*gd2*r*s - 1440*D1**2*f**2*gd2*r - 1440*D1**2*f**2*gd2*s**2 + 720*D1**2*f**2*gd2*s + 720*D1**2*f**2*gd2 - 360*D1**2*f**2*gdd2*r**2 + 360*D1**2*f**2*gdd2*r*s + 720*D1**2*f**2*gdd2*r + 720*D1**2*f**2*gdd2*s**2 - 360*D1**2*f**2*gdd2*s - 360*D1**2*f**2*gdd2 - 1650*D1**2*f*fd**2*r**2 - 1020*D1**2*f*fd**2*r*s + 1440*D1**2*f*fd**2*r + 630*D1**2*f*fd**2*s**2 - 80*D1**2*f*fd**2*s - 170*D1**2*f*fd**2 + 1440*D1**2*f*fd*g2*r**2 - 1440*D1**2*f*fd*g2*r*s + 720*D1**2*f*fd*g2*r - 2880*D1**2*f*fd*g2*s**2 + 2880*D1**2*f*fd*g2*s - 1440*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r**2 + 1440*D1**2*f*fd*gd2*r*s + 1080*D1**2*f*fd*gd2*r + 2880*D1**2*f*fd*gd2*s**2 - 2160*D1**2*f*fd*gd2*s + 360*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r**2 + 720*D1**2*f*fdd*g2*r*s - 360*D1**2*f*fdd*g2*r + 1440*D1**2*f*fdd*g2*s**2 - 1440*D1**2*f*fdd*g2*s + 720*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r**2 + 720*D1**2*fd**2*g2*r*s - 360*D1**2*fd**2*g2*r + 1440*D1**2*fd**2*g2*s**2 - 1440*D1**2*fd**2*g2*s - 1440*D1*Dd*K*b1*f**2*r**2 + 1440*D1*Dd*K*b1*f**2*r*s + 1080*D1*Dd*K*b1*f**2*r + 2880*D1*Dd*K*b1*f**2*s**2 - 2160*D1*Dd*K*b1*f**2*s + 2880*D1*Dd*K*b1*f*fd*r**2 - 2880*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r - 5760*D1*Dd*K*b1*f*fd*s**2 + 5040*D1*Dd*K*b1*f*fd*s - 1080*D1*Dd*K*b1*f*fd + 1400*D1*Dd*b1*f**3*r**2 + 1680*D1*Dd*b1*f**3*r*s - 1820*D1*Dd*b1*f**3*r + 280*D1*Dd*b1*f**3*s**2 - 980*D1*Dd*b1*f**3*s + 770*D1*Dd*b1*f**3 - 4200*D1*Dd*b1*f**2*fd*r**2 - 5040*D1*Dd*b1*f**2*fd*r*s + 4970*D1*Dd*b1*f**2*fd*r - 840*D1*Dd*b1*f**2*fd*s**2 + 2590*D1*Dd*b1*f**2*fd*s - 1400*D1*Dd*b1*f**2*fd + 3240*D1*Dd*b1*f**2*r**2 + 3600*D1*Dd*b1*f**2*r*s - 4140*D1*Dd*b1*f**2*r + 360*D1*Dd*b1*f**2*s**2 - 1980*D1*Dd*b1*f**2*s + 1710*D1*Dd*b1*f**2 - 6480*D1*Dd*b1*f*fd*r**2 - 7200*D1*Dd*b1*f*fd*r*s + 5940*D1*Dd*b1*f*fd*r - 720*D1*Dd*b1*f*fd*s**2 + 2340*D1*Dd*b1*f*fd*s - 990*D1*Dd*b1*f*fd - 560*D1*Dd*f**4*r**2 - 560*D1*Dd*f**4*r*s + 700*D1*Dd*f**4*r + 280*D1*Dd*f**4*s - 280*D1*Dd*f**4 + 4480*D1*Dd*f**3*fd*r**2 + 4480*D1*Dd*f**3*fd*r*s - 5600*D1*Dd*f**3*fd*r - 2240*D1*Dd*f**3*fd*s + 1680*D1*Dd*f**3*fd + 1816*D1*Dd*f**3*r**2 + 976*D1*Dd*f**3*r*s - 2060*D1*Dd*f**3*r - 840*D1*Dd*f**3*s**2 - 68*D1*Dd*f**3*s + 698*D1*Dd*f**3 - 6600*D1*Dd*f**2*fd*r**2 - 4080*D1*Dd*f**2*fd*r*s + 6690*D1*Dd*f**2*fd*r + 2520*D1*Dd*f**2*fd*s**2 + 230*D1*Dd*f**2*fd*s - 1400*D1*Dd*f**2*fd + 2880*D1*Dd*f**2*g2*r**2 - 2880*D1*Dd*f**2*g2*r*s - 2160*D1*Dd*f**2*g2*r - 5760*D1*Dd*f**2*g2*s**2 + 4320*D1*Dd*f**2*g2*s - 2880*D1*Dd*f**2*gd2*r**2 + 2880*D1*Dd*f**2*gd2*r*s + 3960*D1*Dd*f**2*gd2*r + 5760*D1*Dd*f**2*gd2*s**2 - 3600*D1*Dd*f**2*gd2*s - 1080*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r**2 + 5760*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r + 11520*D1*Dd*f*fd*g2*s**2 - 10080*D1*Dd*f*fd*g2*s + 2160*D1*Dd*f*fd*g2 + 720*D1*Ddd*K*b1*f**2*r**2 - 720*D1*Ddd*K*b1*f**2*r*s - 540*D1*Ddd*K*b1*f**2*r - 1440*D1*Ddd*K*b1*f**2*s**2 + 1080*D1*Ddd*K*b1*f**2*s - 700*D1*Ddd*b1*f**3*r**2 - 840*D1*Ddd*b1*f**3*r*s + 910*D1*Ddd*b1*f**3*r - 140*D1*Ddd*b1*f**3*s**2 + 490*D1*Ddd*b1*f**3*s - 385*D1*Ddd*b1*f**3 - 1620*D1*Ddd*b1*f**2*r**2 - 1800*D1*Ddd*b1*f**2*r*s + 2070*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s**2 + 990*D1*Ddd*b1*f**2*s - 855*D1*Ddd*b1*f**2 + 560*D1*Ddd*f**4*r**2 + 560*D1*Ddd*f**4*r*s - 700*D1*Ddd*f**4*r - 280*D1*Ddd*f**4*s + 280*D1*Ddd*f**4 - 1100*D1*Ddd*f**3*r**2 - 680*D1*Ddd*f**3*r*s + 1270*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s**2 + 130*D1*Ddd*f**3*s - 445*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r**2 + 1440*D1*Ddd*f**2*g2*r*s + 1080*D1*Ddd*f**2*g2*r + 2880*D1*Ddd*f**2*g2*s**2 - 2160*D1*Ddd*f**2*g2*s + 10*D1*bd1*f*(7*D1*f**2*(5*r**2 + 2*r*(3*s - 5) + s**2 - 6*s + 5) + D1*f*(-7*fd*(15*r**2 + r*(18*s - 23) + 3*s**2 - 13*s + 8) + (r + s - 1)*(-36*K*(r - 2*s - 1) + 81*r + 9*s - 81)) + 9*D1*fd*(2*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 18*r**2 - 20*r*s + 23*r - 2*s**2 + 11*s - 5) - 7*Dd*f**2*(20*r**2 + 3*r*(8*s - 11) + 4*s**2 - 19*s + 13) + 9*Dd*f*(2*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 36*r**2 - 40*r*s + 59*r - 4*s**2 + 31*s - 23)) + 2160*Dd**2*K*b1*f**2*r**2 - 2160*Dd**2*K*b1*f**2*r*s - 1620*Dd**2*K*b1*f**2*r - 4320*Dd**2*K*b1*f**2*s**2 + 3240*Dd**2*K*b1*f**2*s - 2100*Dd**2*b1*f**3*r**2 - 2520*Dd**2*b1*f**3*r*s + 2730*Dd**2*b1*f**3*r - 420*Dd**2*b1*f**3*s**2 + 1470*Dd**2*b1*f**3*s - 770*Dd**2*b1*f**3 - 4860*Dd**2*b1*f**2*r**2 - 5400*Dd**2*b1*f**2*r*s + 6210*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s**2 + 2970*Dd**2*b1*f**2*s - 1710*Dd**2*b1*f**2 + 1680*Dd**2*f**4*r**2 + 1680*Dd**2*f**4*r*s - 2100*Dd**2*f**4*r - 840*Dd**2*f**4*s + 560*Dd**2*f**4 - 3300*Dd**2*f**3*r**2 - 2040*Dd**2*f**3*r*s + 3810*Dd**2*f**3*r + 1260*Dd**2*f**3*s**2 + 390*Dd**2*f**3*s - 890*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r**2 + 4320*Dd**2*f**2*g2*r*s + 3240*Dd**2*f**2*g2*r + 8640*Dd**2*f**2*g2*s**2 - 6480*Dd**2*f**2*g2*s)/(210*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**3*k1*k2**3*st**2*(-180*C*D1**2*bdd1*f**2*r**2 - 720*C*D1**2*bdd1*f**2*r*s - 360*C*D1**2*bdd1*f**2*r - 540*C*D1**2*bdd1*f**2*s**2 - 9816*C*D1**2*f**2*fd*r**2 - 18312*C*D1**2*f**2*fd*r*s + 12648*C*D1**2*f**2*fd*r - 8496*C*D1**2*f**2*fd*s**2 + 11768*C*D1**2*f**2*fd*s - 6104*C*D1**2*f**2*fd + 8148*C*D1**2*f**2*fdd*r**2 + 14664*C*D1**2*f**2*fdd*r*s - 10320*C*D1**2*f**2*fdd*r + 6516*C*D1**2*f**2*fdd*s**2 - 9232*C*D1**2*f**2*fdd*s + 4888*C*D1**2*f**2*fdd + 16296*C*D1**2*f*fd**2*r**2 + 29328*C*D1**2*f*fd**2*r*s - 20640*C*D1**2*f*fd**2*r + 13032*C*D1**2*f*fd**2*s**2 - 18464*C*D1**2*f*fd**2*s + 4888*C*D1**2*f*fd**2 - 13088*C*D1*Dd*f**3*r**2 - 24416*C*D1*Dd*f**3*r*s + 19192*C*D1*Dd*f**3*r - 11328*C*D1*Dd*f**3*s**2 + 17872*C*D1*Dd*f**3*s - 9376*C*D1*Dd*f**3 + 65184*C*D1*Dd*f**2*fd*r**2 + 117312*C*D1*Dd*f**2*fd*r*s - 88536*C*D1*Dd*f**2*fd*r + 52128*C*D1*Dd*f**2*fd*s**2 - 79288*C*D1*Dd*f**2*fd*s + 29872*C*D1*Dd*f**2*fd + 10864*C*D1*Ddd*f**3*r**2 + 19552*C*D1*Ddd*f**3*r*s - 15752*C*D1*Ddd*f**3*r + 8688*C*D1*Ddd*f**3*s**2 - 14120*C*D1*Ddd*f**3*s + 7604*C*D1*Ddd*f**3 + 32592*C*Dd**2*f**3*r**2 + 58656*C*Dd**2*f**3*r*s - 47256*C*Dd**2*f**3*r + 26064*C*Dd**2*f**3*s**2 - 42360*C*Dd**2*f**3*s + 15208*C*Dd**2*f**3 + 2070*D1**2*K*bdd1*f**2*r**2 + 4284*D1**2*K*bdd1*f**2*r*s - 4140*D1**2*K*bdd1*f**2*r + 2214*D1**2*K*bdd1*f**2*s**2 - 4284*D1**2*K*bdd1*f**2*s + 2070*D1**2*K*bdd1*f**2 - 2340*D1**2*b2*f*fd*r**2 - 4680*D1**2*b2*f*fd*r*s + 2340*D1**2*b2*f*fd*r - 2340*D1**2*b2*f*fd*s**2 + 2340*D1**2*b2*f*fd*s - 1170*D1**2*b2*f*fd + 1800*D1**2*b2*f*fdd*r**2 + 3600*D1**2*b2*f*fdd*r*s - 1800*D1**2*b2*f*fdd*r + 1800*D1**2*b2*f*fdd*s**2 - 1800*D1**2*b2*f*fdd*s + 900*D1**2*b2*f*fdd + 1800*D1**2*b2*fd**2*r**2 + 3600*D1**2*b2*fd**2*r*s - 1800*D1**2*b2*fd**2*r + 1800*D1**2*b2*fd**2*s**2 - 1800*D1**2*b2*fd**2*s + 18*D1**2*bd1**2*f*(r + s - 1)*(-14*K*(3*r + 5*s + 1) + 25*f - 28*r + 49) - 1170*D1**2*bd2*f**2*r**2 - 2340*D1**2*bd2*f**2*r*s + 2340*D1**2*bd2*f**2*r - 1170*D1**2*bd2*f**2*s**2 + 2340*D1**2*bd2*f**2*s - 1170*D1**2*bd2*f**2 + 3600*D1**2*bd2*f*fd*r**2 + 7200*D1**2*bd2*f*fd*r*s - 5400*D1**2*bd2*f*fd*r + 3600*D1**2*bd2*f*fd*s**2 - 5400*D1**2*bd2*f*fd*s + 1800*D1**2*bd2*f*fd - 495*D1**2*bdd1*f**3*r**2 - 990*D1**2*bdd1*f**3*r*s + 1170*D1**2*bdd1*f**3*r - 495*D1**2*bdd1*f**3*s**2 + 1170*D1**2*bdd1*f**3*s - 675*D1**2*bdd1*f**3 - 675*D1**2*bdd1*f**2*r**2 - 1062*D1**2*bdd1*f**2*r*s + 1800*D1**2*bdd1*f**2*r - 387*D1**2*bdd1*f**2*s**2 + 1512*D1**2*bdd1*f**2*s - 720*D1**2*bdd1*f**2 + 756*D1**2*bdd1*f*g2*r**2 + 2016*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r + 1260*D1**2*bdd1*f*g2*s**2 + 900*D1**2*bdd2*f**2*r**2 + 1800*D1**2*bdd2*f**2*r*s - 1800*D1**2*bdd2*f**2*r + 900*D1**2*bdd2*f**2*s**2 - 1800*D1**2*bdd2*f**2*s + 900*D1**2*bdd2*f**2 + 5700*D1**2*f**2*fd*r**2 + 10572*D1**2*f**2*fd*r*s - 7324*D1**2*f**2*fd*r + 4872*D1**2*f**2*fd*s**2 - 6772*D1**2*f**2*fd*s + 3524*D1**2*f**2*fd - 5361*D1**2*f**2*fdd*r**2 - 9498*D1**2*f**2*fdd*r*s + 6740*D1**2*f**2*fdd*r - 4137*D1**2*f**2*fdd*s**2 + 5924*D1**2*f**2*fdd*s - 3166*D1**2*f**2*fdd + 4248*D1**2*f**2*gd2*r**2 + 9576*D1**2*f**2*gd2*r*s - 8496*D1**2*f**2*gd2*r + 5328*D1**2*f**2*gd2*s**2 - 9576*D1**2*f**2*gd2*s + 4248*D1**2*f**2*gd2 - 4140*D1**2*f**2*gdd2*r**2 - 8568*D1**2*f**2*gdd2*r*s + 8280*D1**2*f**2*gdd2*r - 4428*D1**2*f**2*gdd2*s**2 + 8568*D1**2*f**2*gdd2*s - 4140*D1**2*f**2*gdd2 - 10722*D1**2*f*fd**2*r**2 - 18996*D1**2*f*fd**2*r*s + 13480*D1**2*f*fd**2*r - 8274*D1**2*f*fd**2*s**2 + 11848*D1**2*f*fd**2*s - 3166*D1**2*f*fd**2 + 8496*D1**2*f*fd*g2*r**2 + 19152*D1**2*f*fd*g2*r*s - 9576*D1**2*f*fd*g2*r + 10656*D1**2*f*fd*g2*s**2 - 10656*D1**2*f*fd*g2*s + 5328*D1**2*f*fd*g2 - 16560*D1**2*f*fd*gd2*r**2 - 34272*D1**2*f*fd*gd2*r*s + 25128*D1**2*f*fd*gd2*r - 17712*D1**2*f*fd*gd2*s**2 + 25992*D1**2*f*fd*gd2*s - 8568*D1**2*f*fd*gd2 - 8280*D1**2*f*fdd*g2*r**2 - 17136*D1**2*f*fdd*g2*r*s + 8568*D1**2*f*fdd*g2*r - 8856*D1**2*f*fdd*g2*s**2 + 8856*D1**2*f*fdd*g2*s - 4428*D1**2*f*fdd*g2 - 8280*D1**2*fd**2*g2*r**2 - 17136*D1**2*fd**2*g2*r*s + 8568*D1**2*fd**2*g2*r - 8856*D1**2*fd**2*g2*s**2 + 8856*D1**2*fd**2*g2*s - 4680*D1*Dd*b2*f**2*r**2 - 9360*D1*Dd*b2*f**2*r*s + 7020*D1*Dd*b2*f**2*r - 4680*D1*Dd*b2*f**2*s**2 + 7020*D1*Dd*b2*f**2*s - 3510*D1*Dd*b2*f**2 + 14400*D1*Dd*b2*f*fd*r**2 + 28800*D1*Dd*b2*f*fd*r*s - 18000*D1*Dd*b2*f*fd*r + 14400*D1*Dd*b2*f*fd*s**2 - 18000*D1*Dd*b2*f*fd*s + 5400*D1*Dd*b2*f*fd + 7200*D1*Dd*bd2*f**2*r**2 + 14400*D1*Dd*bd2*f**2*r*s - 12600*D1*Dd*bd2*f**2*r + 7200*D1*Dd*bd2*f**2*s**2 - 12600*D1*Dd*bd2*f**2*s + 5400*D1*Dd*bd2*f**2 + 7600*D1*Dd*f**3*r**2 + 14096*D1*Dd*f**3*r*s - 11124*D1*Dd*f**3*r + 6496*D1*Dd*f**3*s**2 - 10296*D1*Dd*f**3*s + 5424*D1*Dd*f**3 - 42888*D1*Dd*f**2*fd*r**2 - 75984*D1*Dd*f**2*fd*r*s + 57902*D1*Dd*f**2*fd*r - 33096*D1*Dd*f**2*fd*s**2 + 50966*D1*Dd*f**2*fd*s - 19404*D1*Dd*f**2*fd + 16992*D1*Dd*f**2*g2*r**2 + 38304*D1*Dd*f**2*g2*r*s - 26568*D1*Dd*f**2*g2*r + 21312*D1*Dd*f**2*g2*s**2 - 29808*D1*Dd*f**2*g2*s + 13824*D1*Dd*f**2*g2 - 33120*D1*Dd*f**2*gd2*r**2 - 68544*D1*Dd*f**2*gd2*r*s + 58248*D1*Dd*f**2*gd2*r - 35424*D1*Dd*f**2*gd2*s**2 + 60264*D1*Dd*f**2*gd2*s - 25128*D1*Dd*f**2*gd2 - 66240*D1*Dd*f*fd*g2*r**2 - 137088*D1*Dd*f*fd*g2*r*s + 84528*D1*Dd*f*fd*g2*r - 70848*D1*Dd*f*fd*g2*s**2 + 87408*D1*Dd*f*fd*g2*s - 25992*D1*Dd*f*fd*g2 + 3600*D1*Ddd*b2*f**2*r**2 + 7200*D1*Ddd*b2*f**2*r*s - 5400*D1*Ddd*b2*f**2*r + 3600*D1*Ddd*b2*f**2*s**2 - 5400*D1*Ddd*b2*f**2*s + 2700*D1*Ddd*b2*f**2 - 7148*D1*Ddd*f**3*r**2 - 12664*D1*Ddd*f**3*r*s + 10314*D1*Ddd*f**3*r - 5516*D1*Ddd*f**3*s**2 + 9090*D1*Ddd*f**3*s - 4953*D1*Ddd*f**3 - 16560*D1*Ddd*f**2*g2*r**2 - 34272*D1*Ddd*f**2*g2*r*s + 25128*D1*Ddd*f**2*g2*r - 17712*D1*Ddd*f**2*g2*s**2 + 25992*D1*Ddd*f**2*g2*s - 12708*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(30*f**3*(r**2 + 3*r*(s - 1) + 2*(s - 1)**2) - f**2*(-88*C*r**2 - 268*C*r*s - 92*C*r - 180*C*s**2 + 6*K*(59*r**2 + 133*r*s - 118*r + 74*s**2 - 133*s + 59) + 15*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) - 8*r**2 + 10*r*s + 194*r + 18*s**2 + 168*s - 51) - 6*f*(fd*(10*C*(2*r**2 + r*(8*s - 2) + 6*s**2 - 5*s - 1) - K*(230*r**2 + 476*r*s - 349*r + 246*s**2 - 361*s + 119) + 75*r**2 + 118*r*s - 117*r + 43*s**2 - 93*s + 52) + 14*g2*(3*r**2 + r*(8*s + 2) + 5*s**2) + 14*gd2*(-3*r**2 + r*(2 - 8*s) - 5*s**2 + 4*s + 1)) + 84*fd*g2*(3*r**2 + r*(8*s - 4) + s*(5*s - 5))) - 3*Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + f*(20*C*(4*r**2 + 16*r*s + 12*s**2 - 7*s - 2) - 2*K*(460*r**2 + 952*r*s - 809*r + 492*s**2 - 837*s + 349) + 300*r**2 + 472*r*s - 609*r + 172*s**2 - 497*s + 284) - 28*g2*(12*r**2 + r*(32*s - 6) + 20*s**2 - 13*s - 2))) + 10800*Dd**2*b2*f**2*r**2 + 21600*Dd**2*b2*f**2*r*s - 16200*Dd**2*b2*f**2*r + 10800*Dd**2*b2*f**2*s**2 - 16200*Dd**2*b2*f**2*s + 5400*Dd**2*b2*f**2 - 21444*Dd**2*f**3*r**2 - 37992*Dd**2*f**3*r*s + 30942*Dd**2*f**3*r - 16548*Dd**2*f**3*s**2 + 27270*Dd**2*f**3*s - 9906*Dd**2*f**3 - 49680*Dd**2*f**2*g2*r**2 - 102816*Dd**2*f**2*g2*r*s + 75384*Dd**2*f**2*g2*r - 53136*Dd**2*f**2*g2*s**2 + 77976*Dd**2*f**2*g2*s - 25416*Dd**2*f**2*g2 + 9*b1**2*(D1**2*(50*f*fd*(2*r + 2*s - 1) - 25*f*fdd*(2*r + 2*s - 1) - 50*fd**2*(r + s - 1) + 14*fd*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 2*r*(2*s + 5) + 10*s - 5) - 7*fdd*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 2*r*(2*s + 5) + 10*s - 5)) - 2*D1*(Dd*(f*(-14*K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 25*fd*(4*r + 4*s - 3) - 112*r**2 - 112*r*s + 140*r + 56*s - 56) + 7*fd*(K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 16*r**2 + 2*r*(8*s + 5) + 16*s - 15)) + 7*Ddd*f*(K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 8*r**2 + 2*r*(4*s - 5) - 4*s + 4)) - 28*Dd**2*f*(K*(18*r**2 + 6*r*(8*s - 5) + 30*s**2 - 39*s + 11) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) - 3*b1*(-352*C*D1**2*f*fd*r**2 - 1072*C*D1**2*f*fd*r*s + 1072*C*D1**2*f*fd*r - 720*C*D1**2*f*fd*s**2 + 1256*C*D1**2*f*fd*s - 536*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 480*C*D1**2*f*fdd*r*s - 480*C*D1**2*f*fdd*r + 360*C*D1**2*f*fdd*s**2 - 600*C*D1**2*f*fdd*s + 240*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 + 480*C*D1**2*fd**2*r*s - 480*C*D1**2*fd**2*r + 360*C*D1**2*fd**2*s**2 - 600*C*D1**2*fd**2*s + 360*C*D1**2*fd**2 - 704*C*D1*Dd*f**2*r**2 - 2144*C*D1*Dd*f**2*r*s + 1240*C*D1*Dd*f**2*r - 1440*C*D1*Dd*f**2*s**2 + 1792*C*D1*Dd*f**2*s - 712*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 3840*C*D1*Dd*f*fd*r*s - 2880*C*D1*Dd*f*fd*r + 2880*C*D1*Dd*f*fd*s**2 - 4080*C*D1*Dd*f*fd*s + 1560*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 960*C*D1*Ddd*f**2*r*s - 480*C*D1*Ddd*f**2*r + 720*C*D1*Ddd*f**2*s**2 - 840*C*D1*Ddd*f**2*s + 300*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 2880*C*Dd**2*f**2*r*s - 1440*C*Dd**2*f**2*r + 2160*C*Dd**2*f**2*s**2 - 2520*C*Dd**2*f**2*s + 600*C*Dd**2*f**2 + 1416*D1**2*K*f*fd*r**2 + 3192*D1**2*K*f*fd*r*s - 1596*D1**2*K*f*fd*r + 1776*D1**2*K*f*fd*s**2 - 1776*D1**2*K*f*fd*s + 888*D1**2*K*f*fd - 1380*D1**2*K*f*fdd*r**2 - 2856*D1**2*K*f*fdd*r*s + 1428*D1**2*K*f*fdd*r - 1476*D1**2*K*f*fdd*s**2 + 1476*D1**2*K*f*fdd*s - 738*D1**2*K*f*fdd - 1380*D1**2*K*fd**2*r**2 - 2856*D1**2*K*fd**2*r*s + 1428*D1**2*K*fd**2*r - 1476*D1**2*K*fd**2*s**2 + 1476*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(-14*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) + 25*f*(2*r + 2*s - 1) - 56*r**2 - 56*r*s + 154*r + 98*s - 63) - 180*D1**2*f**2*fd*r**2 - 540*D1**2*f**2*fd*r*s + 240*D1**2*f**2*fd*r - 360*D1**2*f**2*fd*s**2 + 360*D1**2*f**2*fd*s - 120*D1**2*f**2*fd + 495*D1**2*f**2*fdd*r**2 + 990*D1**2*f**2*fdd*r*s - 600*D1**2*f**2*fdd*r + 495*D1**2*f**2*fdd*s**2 - 600*D1**2*f**2*fdd*s + 270*D1**2*f**2*fdd + 990*D1**2*f*fd**2*r**2 + 1980*D1**2*f*fd**2*r*s - 1200*D1**2*f*fd**2*r + 990*D1**2*f*fd**2*s**2 - 1200*D1**2*f*fd**2*s + 270*D1**2*f*fd**2 - 32*D1**2*f*fd*r**2 + 40*D1**2*f*fd*r*s - 376*D1**2*f*fd*r + 72*D1**2*f*fd*s**2 - 428*D1**2*f*fd*s + 122*D1**2*f*fd + 450*D1**2*f*fdd*r**2 + 708*D1**2*f*fdd*r*s - 204*D1**2*f*fdd*r + 258*D1**2*f*fdd*s**2 - 108*D1**2*f*fdd*s + 114*D1**2*f*fdd + 504*D1**2*f*gd2*r**2 + 1344*D1**2*f*gd2*r*s - 1008*D1**2*f*gd2*r + 840*D1**2*f*gd2*s**2 - 1344*D1**2*f*gd2*s + 504*D1**2*f*gd2 - 252*D1**2*f*gdd2*r**2 - 672*D1**2*f*gdd2*r*s + 504*D1**2*f*gdd2*r - 420*D1**2*f*gdd2*s**2 + 672*D1**2*f*gdd2*s - 252*D1**2*f*gdd2 + 450*D1**2*fd**2*r**2 + 708*D1**2*fd**2*r*s - 204*D1**2*fd**2*r + 258*D1**2*fd**2*s**2 - 108*D1**2*fd**2*s - 270*D1**2*fd**2 + 504*D1**2*fd*g2*r**2 + 1344*D1**2*fd*g2*r*s - 1680*D1**2*fd*g2*r + 840*D1**2*fd*g2*s**2 - 1680*D1**2*fd*g2*s + 840*D1**2*fd*g2 - 504*D1**2*fd*gd2*r**2 - 1344*D1**2*fd*gd2*r*s + 1344*D1**2*fd*gd2*r - 840*D1**2*fd*gd2*s**2 + 1512*D1**2*fd*gd2*s - 840*D1**2*fd*gd2 - 252*D1**2*fdd*g2*r**2 - 672*D1**2*fdd*g2*r*s + 840*D1**2*fdd*g2*r - 420*D1**2*fdd*g2*s**2 + 840*D1**2*fdd*g2*s - 420*D1**2*fdd*g2 + 2832*D1*Dd*K*f**2*r**2 + 6384*D1*Dd*K*f**2*r*s - 4428*D1*Dd*K*f**2*r + 3552*D1*Dd*K*f**2*s**2 - 4968*D1*Dd*K*f**2*s + 2304*D1*Dd*K*f**2 - 11040*D1*Dd*K*f*fd*r**2 - 22848*D1*Dd*K*f*fd*r*s + 14088*D1*Dd*K*f*fd*r - 11808*D1*Dd*K*f*fd*s**2 + 14568*D1*Dd*K*f*fd*s - 4332*D1*Dd*K*f*fd - 240*D1*Dd*f**3*r**2 - 720*D1*Dd*f**3*r*s + 420*D1*Dd*f**3*r - 480*D1*Dd*f**3*s**2 + 600*D1*Dd*f**3*s - 240*D1*Dd*f**3 + 3960*D1*Dd*f**2*fd*r**2 + 7920*D1*Dd*f**2*fd*r*s - 5370*D1*Dd*f**2*fd*r + 3960*D1*Dd*f**2*fd*s**2 - 5370*D1*Dd*f**2*fd*s + 1800*D1*Dd*f**2*fd - 64*D1*Dd*f**2*r**2 + 80*D1*Dd*f**2*r*s + 44*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 112*D1*Dd*f**2*s + 4*D1*Dd*f**2 + 3600*D1*Dd*f*fd*r**2 + 5664*D1*Dd*f*fd*r*s - 3324*D1*Dd*f*fd*r + 2064*D1*Dd*f*fd*s**2 - 2364*D1*Dd*f*fd*s + 516*D1*Dd*f*fd + 2016*D1*Dd*f*g2*r**2 + 5376*D1*Dd*f*g2*r*s - 3360*D1*Dd*f*g2*r + 3360*D1*Dd*f*g2*s**2 - 4368*D1*Dd*f*g2*s + 1848*D1*Dd*f*g2 - 2016*D1*Dd*f*gd2*r**2 - 5376*D1*Dd*f*gd2*r*s + 3696*D1*Dd*f*gd2*r - 3360*D1*Dd*f*gd2*s**2 + 4872*D1*Dd*f*gd2*s - 1680*D1*Dd*f*gd2 - 2016*D1*Dd*fd*g2*r**2 - 5376*D1*Dd*fd*g2*r*s + 5040*D1*Dd*fd*g2*r - 3360*D1*Dd*fd*g2*s**2 + 5544*D1*Dd*fd*g2*s - 2520*D1*Dd*fd*g2 - 2760*D1*Ddd*K*f**2*r**2 - 5712*D1*Ddd*K*f**2*r*s + 4188*D1*Ddd*K*f**2*r - 2952*D1*Ddd*K*f**2*s**2 + 4332*D1*Ddd*K*f**2*s - 2118*D1*Ddd*K*f**2 + 660*D1*Ddd*f**3*r**2 + 1320*D1*Ddd*f**3*r*s - 990*D1*Ddd*f**3*r + 660*D1*Ddd*f**3*s**2 - 990*D1*Ddd*f**3*s + 495*D1*Ddd*f**3 + 900*D1*Ddd*f**2*r**2 + 1416*D1*Ddd*f**2*r*s - 1254*D1*Ddd*f**2*r + 516*D1*Ddd*f**2*s**2 - 966*D1*Ddd*f**2*s + 579*D1*Ddd*f**2 - 1008*D1*Ddd*f*g2*r**2 - 2688*D1*Ddd*f*g2*r*s + 1680*D1*Ddd*f*g2*r - 1680*D1*Ddd*f*g2*s**2 + 2184*D1*Ddd*f*g2*s - 924*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(25*f**2*(2*r + 2*s - 1) - 7*f*(2*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) + 8*r**2 + 8*r*s - 22*r - 14*s + 9) + 7*fd*(2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) + 8*r**2 + 8*r*s - r + 3*s - 5)) + Dd*f*(28*K*(12*r**2 + 2*r*(16*s - 7) + 20*s**2 - 21*s + 4) - 25*f*(4*r + 4*s - 3) + 224*r**2 + 224*r*(s - 2) - 252*s + 203)) - 8280*Dd**2*K*f**2*r**2 - 17136*Dd**2*K*f**2*r*s + 12564*Dd**2*K*f**2*r - 8856*Dd**2*K*f**2*s**2 + 12996*Dd**2*K*f**2*s - 4236*Dd**2*K*f**2 + 1980*Dd**2*f**3*r**2 + 3960*Dd**2*f**3*r*s - 2970*Dd**2*f**3*r + 1980*Dd**2*f**3*s**2 - 2970*Dd**2*f**3*s + 990*Dd**2*f**3 + 2700*Dd**2*f**2*r**2 + 4248*Dd**2*f**2*r*s - 3762*Dd**2*f**2*r + 1548*Dd**2*f**2*s**2 - 2898*Dd**2*f**2*s + 1158*Dd**2*f**2 - 3024*Dd**2*f*g2*r**2 - 8064*Dd**2*f*g2*r*s + 5040*Dd**2*f*g2*r - 5040*Dd**2*f*g2*s**2 + 6552*Dd**2*f*g2*s - 1848*Dd**2*f*g2))/(315*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**3*k1*k2**3*(840*C*D1**2*bd1**2*f*r**2 + 1680*C*D1**2*bd1**2*f*r*s - 840*C*D1**2*bd1**2*f*r + 840*C*D1**2*bd1**2*f*s**2 - 840*C*D1**2*bd1**2*f*s + 2232*C*D1**2*bd1*f**2*r**2 + 4128*C*D1**2*bd1*f**2*r*s - 3648*C*D1**2*bd1*f**2*r + 1896*C*D1**2*bd1*f**2*s**2 - 3312*C*D1**2*bd1*f**2*s + 1656*C*D1**2*bd1*f**2 - 5472*C*D1**2*bd1*f*fd*r**2 - 10272*C*D1**2*bd1*f*fd*r*s + 8472*C*D1**2*bd1*f*fd*r - 4800*C*D1**2*bd1*f*fd*s**2 + 7968*C*D1**2*bd1*f*fd*s - 3168*C*D1**2*bd1*f*fd - 1368*C*D1**2*bdd1*f**2*r**2 - 2568*C*D1**2*bdd1*f**2*r*s + 3168*C*D1**2*bdd1*f**2*r - 1200*C*D1**2*bdd1*f**2*s**2 + 3000*C*D1**2*bdd1*f**2*s - 1500*C*D1**2*bdd1*f**2 - 600*C*D1**2*f**2*fd*r**2 + 120*C*D1**2*f**2*fd*r*s + 360*C*D1**2*f**2*fd*r + 720*C*D1**2*f**2*fd*s**2 - 520*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd - 1140*C*D1**2*f**2*fdd*r**2 - 3120*C*D1**2*f**2*fdd*r*s + 1800*C*D1**2*f**2*fdd*r - 1980*C*D1**2*f**2*fdd*s**2 + 2360*C*D1**2*f**2*fdd*s - 1040*C*D1**2*f**2*fdd - 2280*C*D1**2*f*fd**2*r**2 - 6240*C*D1**2*f*fd**2*r*s + 3600*C*D1**2*f*fd**2*r - 3960*C*D1**2*f*fd**2*s**2 + 4720*C*D1**2*f*fd**2*s - 1040*C*D1**2*f*fd**2 - 10944*C*D1*Dd*bd1*f**2*r**2 - 20544*C*D1*Dd*bd1*f**2*r*s + 20712*C*D1*Dd*bd1*f**2*r - 9600*C*D1*Dd*bd1*f**2*s**2 + 19536*C*D1*Dd*bd1*f**2*s - 9336*C*D1*Dd*bd1*f**2 - 800*C*D1*Dd*f**3*r**2 + 160*C*D1*Dd*f**3*r*s + 760*C*D1*Dd*f**3*r + 960*C*D1*Dd*f**3*s**2 - 560*C*D1*Dd*f**3*s - 160*C*D1*Dd*f**3 - 9120*C*D1*Dd*f**2*fd*r**2 - 24960*C*D1*Dd*f**2*fd*r*s + 14880*C*D1*Dd*f**2*fd*r - 15840*C*D1*Dd*f**2*fd*s**2 + 19640*C*D1*Dd*f**2*fd*s - 5960*C*D1*Dd*f**2*fd - 1520*C*D1*Ddd*f**3*r**2 - 4160*C*D1*Ddd*f**3*r*s + 2560*C*D1*Ddd*f**3*r - 2640*C*D1*Ddd*f**3*s**2 + 3400*C*D1*Ddd*f**3*s - 1420*C*D1*Ddd*f**3 - 4560*C*Dd**2*f**3*r**2 - 12480*C*Dd**2*f**3*r*s + 7680*C*Dd**2*f**3*r - 7920*C*Dd**2*f**3*s**2 + 10200*C*Dd**2*f**3*s - 2840*C*Dd**2*f**3 - 1624*D1**2*K*bd1**2*f*r**2 - 3416*D1**2*K*bd1**2*f*r*s + 3752*D1**2*K*bd1**2*f*r - 1792*D1**2*K*bd1**2*f*s**2 + 3920*D1**2*K*bd1**2*f*s - 2128*D1**2*K*bd1**2*f - 252*D1**2*K*bd1*f**2*r**2 - 84*D1**2*K*bd1*f**2*r*s + 504*D1**2*K*bd1*f**2*r + 168*D1**2*K*bd1*f**2*s**2 + 84*D1**2*K*bd1*f**2*s - 252*D1**2*K*bd1*f**2 - 840*D1**2*K*bd1*f*fd*r**2 - 2688*D1**2*K*bd1*f*fd*r*s + 1512*D1**2*K*bd1*f*fd*r - 1848*D1**2*K*bd1*f*fd*s**2 + 2268*D1**2*K*bd1*f*fd*s - 672*D1**2*K*bd1*f*fd - 210*D1**2*K*bdd1*f**2*r**2 - 672*D1**2*K*bdd1*f**2*r*s + 420*D1**2*K*bdd1*f**2*r - 462*D1**2*K*bdd1*f**2*s**2 + 672*D1**2*K*bdd1*f**2*s - 210*D1**2*K*bdd1*f**2 + 630*D1**2*bd1**2*f**2*r**2 + 924*D1**2*bd1**2*f**2*r*s - 1092*D1**2*bd1**2*f**2*r + 294*D1**2*bd1**2*f**2*s**2 - 756*D1**2*bd1**2*f**2*s + 462*D1**2*bd1**2*f**2 - 28*D1**2*bd1**2*f*r**2 - 224*D1**2*bd1**2*f*r*s - 490*D1**2*bd1**2*f*r - 196*D1**2*bd1**2*f*s**2 - 322*D1**2*bd1**2*f*s + 518*D1**2*bd1**2*f - 1400*D1**2*bd1**2*g2*r**2 - 2800*D1**2*bd1**2*g2*r*s + 1400*D1**2*bd1**2*g2*r - 1400*D1**2*bd1**2*g2*s**2 + 1400*D1**2*bd1**2*g2*s - 840*D1**2*bd1*bd2*f*r**2 - 1680*D1**2*bd1*bd2*f*r*s + 1680*D1**2*bd1*bd2*f*r - 840*D1**2*bd1*bd2*f*s**2 + 1680*D1**2*bd1*bd2*f*s - 840*D1**2*bd1*bd2*f - 1293*D1**2*bd1*f**2*r**2 - 2322*D1**2*bd1*f**2*r*s + 1788*D1**2*bd1*f**2*r - 1029*D1**2*bd1*f**2*s**2 + 1524*D1**2*bd1*f**2*s - 720*D1**2*bd1*f**2 + 3804*D1**2*bd1*f*fd*r**2 + 6744*D1**2*bd1*f*fd*r*s - 5574*D1**2*bd1*f*fd*r + 2940*D1**2*bd1*f*fd*s**2 - 4926*D1**2*bd1*f*fd*s + 1986*D1**2*bd1*f*fd - 2408*D1**2*bd1*f*g2*r**2 - 5152*D1**2*bd1*f*g2*r*s + 4032*D1**2*bd1*f*g2*r - 2744*D1**2*bd1*f*g2*s**2 + 4368*D1**2*bd1*f*g2*s - 2184*D1**2*bd1*f*g2 + 3248*D1**2*bd1*f*gd2*r**2 + 6832*D1**2*bd1*f*gd2*r*s - 7504*D1**2*bd1*f*gd2*r + 3584*D1**2*bd1*f*gd2*s**2 - 7840*D1**2*bd1*f*gd2*s + 4256*D1**2*bd1*f*gd2 + 3248*D1**2*bd1*fd*g2*r**2 + 6832*D1**2*bd1*fd*g2*r*s - 3416*D1**2*bd1*fd*g2*r + 3584*D1**2*bd1*fd*g2*s**2 - 3584*D1**2*bd1*fd*g2*s - 210*D1**2*bd2*f**2*r**2 - 420*D1**2*bd2*f**2*r*s + 420*D1**2*bd2*f**2*r - 210*D1**2*bd2*f**2*s**2 + 420*D1**2*bd2*f**2*s - 210*D1**2*bd2*f**2 + 951*D1**2*bdd1*f**2*r**2 + 1686*D1**2*bdd1*f**2*r*s - 1986*D1**2*bdd1*f**2*r + 735*D1**2*bdd1*f**2*s**2 - 1770*D1**2*bdd1*f**2*s + 885*D1**2*bdd1*f**2 + 1624*D1**2*bdd1*f*g2*r**2 + 3416*D1**2*bdd1*f*g2*r*s - 4256*D1**2*bdd1*f*g2*r + 1792*D1**2*bdd1*f*g2*s**2 - 4424*D1**2*bdd1*f*g2*s + 2212*D1**2*bdd1*f*g2 + 480*D1**2*f**2*fd*r**2 + 120*D1**2*f**2*fd*r*s - 360*D1**2*f**2*fd*r - 360*D1**2*f**2*fd*s**2 + 200*D1**2*f**2*fd*s + 40*D1**2*f**2*fd + 570*D1**2*f**2*fdd*r**2 + 1560*D1**2*f**2*fdd*r*s - 900*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 1180*D1**2*f**2*fdd*s + 520*D1**2*f**2*fdd + 504*D1**2*f**2*gd2*r**2 + 168*D1**2*f**2*gd2*r*s - 1008*D1**2*f**2*gd2*r - 336*D1**2*f**2*gd2*s**2 - 168*D1**2*f**2*gd2*s + 504*D1**2*f**2*gd2 + 420*D1**2*f**2*gdd2*r**2 + 1344*D1**2*f**2*gdd2*r*s - 840*D1**2*f**2*gdd2*r + 924*D1**2*f**2*gdd2*s**2 - 1344*D1**2*f**2*gdd2*s + 420*D1**2*f**2*gdd2 + 1140*D1**2*f*fd**2*r**2 + 3120*D1**2*f*fd**2*r*s - 1800*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 2360*D1**2*f*fd**2*s + 520*D1**2*f*fd**2 + 1008*D1**2*f*fd*g2*r**2 + 336*D1**2*f*fd*g2*r*s - 168*D1**2*f*fd*g2*r - 672*D1**2*f*fd*g2*s**2 + 672*D1**2*f*fd*g2*s - 336*D1**2*f*fd*g2 + 1680*D1**2*f*fd*gd2*r**2 + 5376*D1**2*f*fd*gd2*r*s - 3024*D1**2*f*fd*gd2*r + 3696*D1**2*f*fd*gd2*s**2 - 4536*D1**2*f*fd*gd2*s + 1344*D1**2*f*fd*gd2 + 840*D1**2*f*fdd*g2*r**2 + 2688*D1**2*f*fdd*g2*r*s - 1344*D1**2*f*fdd*g2*r + 1848*D1**2*f*fdd*g2*s**2 - 1848*D1**2*f*fdd*g2*s + 924*D1**2*f*fdd*g2 + 840*D1**2*fd**2*g2*r**2 + 2688*D1**2*fd**2*g2*r*s - 1344*D1**2*fd**2*g2*r + 1848*D1**2*fd**2*g2*s**2 - 1848*D1**2*fd**2*g2*s - 1680*D1*Dd*K*bd1*f**2*r**2 - 5376*D1*Dd*K*bd1*f**2*r*s + 3192*D1*Dd*K*bd1*f**2*r - 3696*D1*Dd*K*bd1*f**2*s**2 + 4956*D1*Dd*K*bd1*f**2*s - 1512*D1*Dd*K*bd1*f**2 + 7608*D1*Dd*bd1*f**2*r**2 + 13488*D1*Dd*bd1*f**2*r*s - 13434*D1*Dd*bd1*f**2*r + 5880*D1*Dd*bd1*f**2*s**2 - 11922*D1*Dd*bd1*f**2*s + 5742*D1*Dd*bd1*f**2 + 12992*D1*Dd*bd1*f*g2*r**2 + 27328*D1*Dd*bd1*f*g2*r*s - 26936*D1*Dd*bd1*f*g2*r + 14336*D1*Dd*bd1*f*g2*s**2 - 28112*D1*Dd*bd1*f*g2*s + 12936*D1*Dd*bd1*f*g2 + 640*D1*Dd*f**3*r**2 + 160*D1*Dd*f**3*r*s - 680*D1*Dd*f**3*r - 480*D1*Dd*f**3*s**2 + 160*D1*Dd*f**3*s + 200*D1*Dd*f**3 + 4560*D1*Dd*f**2*fd*r**2 + 12480*D1*Dd*f**2*fd*r*s - 7440*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 9820*D1*Dd*f**2*fd*s + 2980*D1*Dd*f**2*fd + 2016*D1*Dd*f**2*g2*r**2 + 672*D1*Dd*f**2*g2*r*s - 2184*D1*Dd*f**2*g2*r - 1344*D1*Dd*f**2*g2*s**2 + 336*D1*Dd*f**2*g2*s + 672*D1*Dd*f**2*g2 + 3360*D1*Dd*f**2*gd2*r**2 + 10752*D1*Dd*f**2*gd2*r*s - 6384*D1*Dd*f**2*gd2*r + 7392*D1*Dd*f**2*gd2*s**2 - 9912*D1*Dd*f**2*gd2*s + 3024*D1*Dd*f**2*gd2 + 6720*D1*Dd*f*fd*g2*r**2 + 21504*D1*Dd*f*fd*g2*r*s - 11424*D1*Dd*f*fd*g2*r + 14784*D1*Dd*f*fd*g2*s**2 - 16464*D1*Dd*f*fd*g2*s + 4536*D1*Dd*f*fd*g2 + 760*D1*Ddd*f**3*r**2 + 2080*D1*Ddd*f**3*r*s - 1280*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1700*D1*Ddd*f**3*s + 710*D1*Ddd*f**3 + 1680*D1*Ddd*f**2*g2*r**2 + 5376*D1*Ddd*f**2*g2*r*s - 3024*D1*Ddd*f**2*g2*r + 3696*D1*Ddd*f**2*g2*s**2 - 4536*D1*Ddd*f**2*g2*s + 1764*D1*Ddd*f**2*g2 + 70*D1*b2*(bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 2280*Dd**2*f**3*r**2 + 6240*Dd**2*f**3*r*s - 3840*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 5100*Dd**2*f**3*s + 1420*Dd**2*f**3 + 5040*Dd**2*f**2*g2*r**2 + 16128*Dd**2*f**2*g2*r*s - 9072*Dd**2*f**2*g2*r + 11088*Dd**2*f**2*g2*s**2 - 13608*Dd**2*f**2*g2*s + 3528*Dd**2*f**2*g2 + 35*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-120*C*D1**2*fd*r**2 - 240*C*D1**2*fd*r*s + 240*C*D1**2*fd*r - 120*C*D1**2*fd*s**2 + 240*C*D1**2*fd*s - 120*C*D1**2*fd + 60*C*D1**2*fdd*r**2 + 120*C*D1**2*fdd*r*s - 120*C*D1**2*fdd*r + 60*C*D1**2*fdd*s**2 - 120*C*D1**2*fdd*s + 60*C*D1**2*fdd - 480*C*D1*Dd*f*r**2 - 960*C*D1*Dd*f*r*s + 720*C*D1*Dd*f*r - 480*C*D1*Dd*f*s**2 + 720*C*D1*Dd*f*s - 360*C*D1*Dd*f + 480*C*D1*Dd*fd*r**2 + 960*C*D1*Dd*fd*r*s - 840*C*D1*Dd*fd*r + 480*C*D1*Dd*fd*s**2 - 840*C*D1*Dd*fd*s + 360*C*D1*Dd*fd + 240*C*D1*Ddd*f*r**2 + 480*C*D1*Ddd*f*r*s - 360*C*D1*Ddd*f*r + 240*C*D1*Ddd*f*s**2 - 360*C*D1*Ddd*f*s + 180*C*D1*Ddd*f + 720*C*Dd**2*f*r**2 + 1440*C*Dd**2*f*r*s - 1080*C*Dd**2*f*r + 720*C*Dd**2*f*s**2 - 1080*C*Dd**2*f*s + 360*C*Dd**2*f + 172*D1**2*K*fd*r**2 + 368*D1**2*K*fd*r*s - 80*D1**2*K*fd*r + 196*D1**2*K*fd*s**2 - 80*D1**2*K*fd*s + 40*D1**2*K*fd - 116*D1**2*K*fdd*r**2 - 244*D1**2*K*fdd*r*s - 60*D1**2*K*fdd*r - 128*D1**2*K*fdd*s**2 - 60*D1**2*K*fdd*s + 30*D1**2*K*fdd - 5*D1**2*bdd1*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 78*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 108*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 84*D1**2*f*fd*s - 54*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 132*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 45*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 132*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s + 69*D1**2*fd*r**2 + 142*D1**2*fd*r*s - 130*D1**2*fd*r + 73*D1**2*fd*s**2 - 130*D1**2*fd*s + 65*D1**2*fd - 2*D1**2*fdd*r**2 - 16*D1**2*fdd*r*s + 90*D1**2*fdd*r - 14*D1**2*fdd*s**2 + 90*D1**2*fdd*s - 45*D1**2*fdd + 200*D1**2*gd2*r**2 + 400*D1**2*gd2*r*s - 400*D1**2*gd2*r + 200*D1**2*gd2*s**2 - 400*D1**2*gd2*s + 200*D1**2*gd2 - 100*D1**2*gdd2*r**2 - 200*D1**2*gdd2*r*s + 200*D1**2*gdd2*r - 100*D1**2*gdd2*s**2 + 200*D1**2*gdd2*s - 100*D1**2*gdd2 + 688*D1*Dd*K*f*r**2 + 1472*D1*Dd*K*f*r*s - 1056*D1*Dd*K*f*r + 784*D1*Dd*K*f*s**2 - 1128*D1*Dd*K*f*s + 540*D1*Dd*K*f - 928*D1*Dd*K*fd*r**2 - 1952*D1*Dd*K*fd*r*s + 468*D1*Dd*K*fd*r - 1024*D1*Dd*K*fd*s**2 + 504*D1*Dd*K*fd*s + 180*D1*Dd*K*fd - 156*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 93*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1056*D1*Dd*f*fd*r*s - 852*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 612*D1*Dd*f*fd*s + 246*D1*Dd*f*fd + 276*D1*Dd*f*r**2 + 568*D1*Dd*f*r*s - 418*D1*Dd*f*r + 292*D1*Dd*f*s**2 - 430*D1*Dd*f*s + 211*D1*Dd*f - 16*D1*Dd*fd*r**2 - 128*D1*Dd*fd*r*s + 384*D1*Dd*fd*r - 112*D1*Dd*fd*s**2 + 420*D1*Dd*fd*s - 270*D1*Dd*fd + 800*D1*Dd*g2*r**2 + 1600*D1*Dd*g2*r*s - 1200*D1*Dd*g2*r + 800*D1*Dd*g2*s**2 - 1200*D1*Dd*g2*s + 600*D1*Dd*g2 - 800*D1*Dd*gd2*r**2 - 1600*D1*Dd*gd2*r*s + 1400*D1*Dd*gd2*r - 800*D1*Dd*gd2*s**2 + 1400*D1*Dd*gd2*s - 600*D1*Dd*gd2 - 464*D1*Ddd*K*f*r**2 - 976*D1*Ddd*K*f*r*s + 708*D1*Ddd*K*f*r - 512*D1*Ddd*K*f*s**2 + 744*D1*Ddd*K*f*s - 360*D1*Ddd*K*f + 180*D1*Ddd*f**2*r**2 + 264*D1*Ddd*f**2*r*s - 246*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 174*D1*Ddd*f**2*s + 111*D1*Ddd*f**2 - 8*D1*Ddd*f*r**2 - 64*D1*Ddd*f*r*s + 24*D1*Ddd*f*r - 56*D1*Ddd*f*s**2 + 60*D1*Ddd*f*s - 18*D1*Ddd*f - 400*D1*Ddd*g2*r**2 - 800*D1*Ddd*g2*r*s + 600*D1*Ddd*g2*r - 400*D1*Ddd*g2*s**2 + 600*D1*Ddd*g2*s - 300*D1*Ddd*g2 + 10*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-10*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 1392*Dd**2*K*f*r**2 - 2928*Dd**2*K*f*r*s + 2124*Dd**2*K*f*r - 1536*Dd**2*K*f*s**2 + 2232*Dd**2*K*f*s - 720*Dd**2*K*f + 540*Dd**2*f**2*r**2 + 792*Dd**2*f**2*r*s - 738*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 522*Dd**2*f**2*s + 222*Dd**2*f**2 - 24*Dd**2*f*r**2 - 192*Dd**2*f*r*s + 72*Dd**2*f*r - 168*Dd**2*f*s**2 + 180*Dd**2*f*s - 36*Dd**2*f - 1200*Dd**2*g2*r**2 - 2400*Dd**2*g2*r*s + 1800*Dd**2*g2*r - 1200*Dd**2*g2*s**2 + 1800*Dd**2*g2*s - 600*Dd**2*g2) - b1*(-840*C*D1**2*bdd1*f*r**2 - 1680*C*D1**2*bdd1*f*r*s + 840*C*D1**2*bdd1*f*r - 840*C*D1**2*bdd1*f*s**2 + 840*C*D1**2*bdd1*f*s - 420*C*D1**2*bdd1*f - 4464*C*D1**2*f*fd*r**2 - 8256*C*D1**2*f*fd*r*s + 4944*C*D1**2*f*fd*r - 3792*C*D1**2*f*fd*s**2 + 4608*C*D1**2*f*fd*s - 2472*C*D1**2*f*fd + 2736*C*D1**2*f*fdd*r**2 + 5136*C*D1**2*f*fdd*r*s - 2136*C*D1**2*f*fdd*r + 2400*C*D1**2*f*fdd*s**2 - 1968*C*D1**2*f*fdd*s + 1068*C*D1**2*f*fdd + 2736*C*D1**2*fd**2*r**2 + 5136*C*D1**2*fd**2*r*s - 2136*C*D1**2*fd**2*r + 2400*C*D1**2*fd**2*s**2 - 1968*C*D1**2*fd**2*s - 600*C*D1**2*fd**2 - 8928*C*D1*Dd*f**2*r**2 - 16512*C*D1*Dd*f**2*r*s + 13056*C*D1*Dd*f**2*r - 7584*C*D1*Dd*f**2*s**2 + 12048*C*D1*Dd*f**2*s - 6360*C*D1*Dd*f**2 + 21888*C*D1*Dd*f*fd*r**2 + 41088*C*D1*Dd*f*fd*r*s - 24624*C*D1*Dd*f*fd*r + 19200*C*D1*Dd*f*fd*s**2 - 22944*C*D1*Dd*f*fd*s + 6240*C*D1*Dd*f*fd + 5472*C*D1*Ddd*f**2*r**2 + 10272*C*D1*Ddd*f**2*r*s - 8040*C*D1*Ddd*f**2*r + 4800*C*D1*Ddd*f**2*s**2 - 7536*C*D1*Ddd*f**2*s + 3936*C*D1*Ddd*f**2 + 16416*C*Dd**2*f**2*r**2 + 30816*C*Dd**2*f**2*r*s - 24120*C*Dd**2*f**2*r + 14400*C*Dd**2*f**2*s**2 - 22608*C*Dd**2*f**2*s + 7872*C*Dd**2*f**2 + 1624*D1**2*K*bdd1*f*r**2 + 3416*D1**2*K*bdd1*f*r*s - 3752*D1**2*K*bdd1*f*r + 1792*D1**2*K*bdd1*f*s**2 - 3920*D1**2*K*bdd1*f*s + 1918*D1**2*K*bdd1*f + 504*D1**2*K*f*fd*r**2 + 168*D1**2*K*f*fd*r*s - 84*D1**2*K*f*fd*r - 336*D1**2*K*f*fd*s**2 + 336*D1**2*K*f*fd*s - 168*D1**2*K*f*fd + 420*D1**2*K*f*fdd*r**2 + 1344*D1**2*K*f*fdd*r*s - 672*D1**2*K*f*fdd*r + 924*D1**2*K*f*fdd*s**2 - 924*D1**2*K*f*fdd*s + 462*D1**2*K*f*fdd + 420*D1**2*K*fd**2*r**2 + 1344*D1**2*K*fd**2*r*s - 672*D1**2*K*fd**2*r + 924*D1**2*K*fd**2*s**2 - 924*D1**2*K*fd**2*s - 490*D1**2*b2*fd*r**2 - 980*D1**2*b2*fd*r*s - 490*D1**2*b2*fd*s**2 + 420*D1**2*b2*fdd*r**2 + 840*D1**2*b2*fdd*r*s + 420*D1**2*b2*fdd*s**2 + 70*D1**2*bd1**2*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 630*D1**2*bdd1*f**2*r**2 - 924*D1**2*bdd1*f**2*r*s + 1092*D1**2*bdd1*f**2*r - 294*D1**2*bdd1*f**2*s**2 + 756*D1**2*bdd1*f**2*s - 462*D1**2*bdd1*f**2 + 28*D1**2*bdd1*f*r**2 + 224*D1**2*bdd1*f*r*s + 490*D1**2*bdd1*f*r + 196*D1**2*bdd1*f*s**2 + 322*D1**2*bdd1*f*s - 203*D1**2*bdd1*f + 1400*D1**2*bdd1*g2*r**2 + 2800*D1**2*bdd1*g2*r*s - 1400*D1**2*bdd1*g2*r + 1400*D1**2*bdd1*g2*s**2 - 1400*D1**2*bdd1*g2*s + 700*D1**2*bdd1*g2 + 420*D1**2*bdd2*f*r**2 + 840*D1**2*bdd2*f*r*s - 840*D1**2*bdd2*f*r + 420*D1**2*bdd2*f*s**2 - 840*D1**2*bdd2*f*s + 420*D1**2*bdd2*f + 2586*D1**2*f*fd*r**2 + 4644*D1**2*f*fd*r*s - 3120*D1**2*f*fd*r + 2058*D1**2*f*fd*s**2 - 2856*D1**2*f*fd*s + 1602*D1**2*f*fd - 1902*D1**2*f*fdd*r**2 - 3372*D1**2*f*fdd*r*s + 1602*D1**2*f*fdd*r - 1470*D1**2*f*fdd*s**2 + 1386*D1**2*f*fdd*s - 801*D1**2*f*fdd + 2408*D1**2*f*gd2*r**2 + 5152*D1**2*f*gd2*r*s - 4816*D1**2*f*gd2*r + 2744*D1**2*f*gd2*s**2 - 5152*D1**2*f*gd2*s + 2408*D1**2*f*gd2 - 1624*D1**2*f*gdd2*r**2 - 3416*D1**2*f*gdd2*r*s + 3248*D1**2*f*gdd2*r - 1792*D1**2*f*gdd2*s**2 + 3416*D1**2*f*gdd2*s - 1624*D1**2*f*gdd2 - 1902*D1**2*fd**2*r**2 - 3372*D1**2*fd**2*r*s + 1602*D1**2*fd**2*r - 1470*D1**2*fd**2*s**2 + 1386*D1**2*fd**2*s + 300*D1**2*fd**2 + 2408*D1**2*fd*g2*r**2 + 5152*D1**2*fd*g2*r*s - 1120*D1**2*fd*g2*r + 2744*D1**2*fd*g2*s**2 - 1120*D1**2*fd*g2*s + 560*D1**2*fd*g2 - 3248*D1**2*fd*gd2*r**2 - 6832*D1**2*fd*gd2*r*s + 2408*D1**2*fd*gd2*r - 3584*D1**2*fd*gd2*s**2 + 2576*D1**2*fd*gd2*s + 840*D1**2*fd*gd2 - 1624*D1**2*fdd*g2*r**2 - 3416*D1**2*fdd*g2*r*s - 840*D1**2*fdd*g2*r - 1792*D1**2*fdd*g2*s**2 - 840*D1**2*fdd*g2*s + 420*D1**2*fdd*g2 + 1008*D1*Dd*K*f**2*r**2 + 336*D1*Dd*K*f**2*r*s - 1092*D1*Dd*K*f**2*r - 672*D1*Dd*K*f**2*s**2 + 168*D1*Dd*K*f**2*s + 336*D1*Dd*K*f**2 + 3360*D1*Dd*K*f*fd*r**2 + 10752*D1*Dd*K*f*fd*r*s - 5712*D1*Dd*K*f*fd*r + 7392*D1*Dd*K*f*fd*s**2 - 8232*D1*Dd*K*f*fd*s + 2268*D1*Dd*K*f*fd - 1960*D1*Dd*b2*f*r**2 - 3920*D1*Dd*b2*f*r*s + 2940*D1*Dd*b2*f*r - 1960*D1*Dd*b2*f*s**2 + 2940*D1*Dd*b2*f*s - 1470*D1*Dd*b2*f + 3360*D1*Dd*b2*fd*r**2 + 6720*D1*Dd*b2*fd*r*s - 2520*D1*Dd*b2*fd*r + 3360*D1*Dd*b2*fd*s**2 - 2520*D1*Dd*b2*fd*s + 5172*D1*Dd*f**2*r**2 + 9288*D1*Dd*f**2*r*s - 7494*D1*Dd*f**2*r + 4116*D1*Dd*f**2*s**2 - 6702*D1*Dd*f**2*s + 3615*D1*Dd*f**2 - 15216*D1*Dd*f*fd*r**2 - 26976*D1*Dd*f*fd*r*s + 17388*D1*Dd*f*fd*r - 11760*D1*Dd*f*fd*s**2 + 15228*D1*Dd*f*fd*s - 4590*D1*Dd*f*fd + 9632*D1*Dd*f*g2*r**2 + 20608*D1*Dd*f*g2*r*s - 14784*D1*Dd*f*g2*r + 10976*D1*Dd*f*g2*s**2 - 15792*D1*Dd*f*g2*s + 7560*D1*Dd*f*g2 - 12992*D1*Dd*f*gd2*r**2 - 27328*D1*Dd*f*gd2*r*s + 22904*D1*Dd*f*gd2*r - 14336*D1*Dd*f*gd2*s**2 + 24080*D1*Dd*f*gd2*s - 9912*D1*Dd*f*gd2 - 12992*D1*Dd*fd*g2*r**2 - 27328*D1*Dd*fd*g2*r*s + 6552*D1*Dd*fd*g2*r - 14336*D1*Dd*fd*g2*s**2 + 7056*D1*Dd*fd*g2*s + 2520*D1*Dd*fd*g2 + 840*D1*Ddd*K*f**2*r**2 + 2688*D1*Ddd*K*f**2*r*s - 1512*D1*Ddd*K*f**2*r + 1848*D1*Ddd*K*f**2*s**2 - 2268*D1*Ddd*K*f**2*s + 882*D1*Ddd*K*f**2 + 1680*D1*Ddd*b2*f*r**2 + 3360*D1*Ddd*b2*f*r*s - 2520*D1*Ddd*b2*f*r + 1680*D1*Ddd*b2*f*s**2 - 2520*D1*Ddd*b2*f*s + 1260*D1*Ddd*b2*f - 3804*D1*Ddd*f**2*r**2 - 6744*D1*Ddd*f**2*r*s + 5490*D1*Ddd*f**2*r - 2940*D1*Ddd*f**2*s**2 + 4842*D1*Ddd*f**2*s - 2637*D1*Ddd*f**2 - 6496*D1*Ddd*f*g2*r**2 - 13664*D1*Ddd*f*g2*r*s + 9912*D1*Ddd*f*g2*r - 7168*D1*Ddd*f*g2*s**2 + 10416*D1*Ddd*f*g2*s - 5040*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(3*f**2*(26*r**2 + r*(36*s - 34) + 10*s**2 - 18*s + 13) + f*(120*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 344*K*r**2 - 736*K*r*s + 632*K*r - 392*K*s**2 + 680*K*s - 328*K - 12*fd*(30*r**2 + 44*r*s - 41*r + 14*s**2 - 29*s + 13) - 138*r**2 - 284*r*s + 150*r - 146*s**2 + 158*s - 77) + 2*fd*(-60*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(232*r**2 + 8*r*(61*s - 26) + 256*s**2 - 220*s - 30) + 4*r**2 + 32*r*s - 55*r + 28*s**2 - 67*s + 45) - 200*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 200*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(6*f**2*(60*r**2 + r*(88*s - 93) + 28*s**2 - 65*s + 35) + f*(60*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 4*K*(232*r**2 + 488*r*s - 445*r + 256*s**2 - 466*s + 204) - 16*r**2 - 128*r*s - 116*r - 112*s**2 - 32*s + 93) - 100*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 70*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 2520*Dd**2*K*f**2*r**2 + 8064*Dd**2*K*f**2*r*s - 4536*Dd**2*K*f**2*r + 5544*Dd**2*K*f**2*s**2 - 6804*Dd**2*K*f**2*s + 1764*Dd**2*K*f**2 + 5040*Dd**2*b2*f*r**2 + 10080*Dd**2*b2*f*r*s - 7560*Dd**2*b2*f*r + 5040*Dd**2*b2*f*s**2 - 7560*Dd**2*b2*f*s + 2520*Dd**2*b2*f - 11412*Dd**2*f**2*r**2 - 20232*Dd**2*f**2*r*s + 16470*Dd**2*f**2*r - 8820*Dd**2*f**2*s**2 + 14526*Dd**2*f**2*s - 5274*Dd**2*f**2 - 19488*Dd**2*f*g2*r**2 - 40992*Dd**2*f*g2*r*s + 29736*Dd**2*f*g2*r - 21504*Dd**2*f*g2*s**2 + 31248*Dd**2*f*g2*s - 10080*Dd**2*f*g2))/(210*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**3*k1*k2*st**4*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(-7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 18*r*(4*s - 1) + 18*(1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(7*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(7*bdd1*f**2*s*(r + s - 1) + 3*f*(3*bdd1*s*(r + s - 1) + fd*(r*(2 - 6*s) - 6*s**2 + 6*s - 2) + fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 3*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 2*f*s*(7*f + 9)*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 3*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**3*k1*k2*st**2*(360*C*D1**2*bdd1*f**2*r**2 - 72*C*D1**2*bdd1*f**2*r*s - 432*C*D1**2*bdd1*f**2*s**2 - 2952*C*D1**2*f**2*fd*r*s + 984*C*D1**2*f**2*fd*r - 2952*C*D1**2*f**2*fd*s**2 + 2952*C*D1**2*f**2*fd*s - 984*C*D1**2*f**2*fd + 1800*C*D1**2*f**2*fdd*r*s - 600*C*D1**2*f**2*fdd*r + 1800*C*D1**2*f**2*fdd*s**2 - 1800*C*D1**2*f**2*fdd*s + 600*C*D1**2*f**2*fdd + 3600*C*D1**2*f*fd**2*r*s - 1200*C*D1**2*f*fd**2*r + 3600*C*D1**2*f*fd**2*s**2 - 3600*C*D1**2*f*fd**2*s + 600*C*D1**2*f*fd**2 - 3936*C*D1*Dd*f**3*r*s + 984*C*D1*Dd*f**3*r - 3936*C*D1*Dd*f**3*s**2 + 3936*C*D1*Dd*f**3*s - 984*C*D1*Dd*f**3 + 14400*C*D1*Dd*f**2*fd*r*s - 4200*C*D1*Dd*f**2*fd*r + 14400*C*D1*Dd*f**2*fd*s**2 - 14400*C*D1*Dd*f**2*fd*s + 3000*C*D1*Dd*f**2*fd + 2400*C*D1*Ddd*f**3*r*s - 600*C*D1*Ddd*f**3*r + 2400*C*D1*Ddd*f**3*s**2 - 2400*C*D1*Ddd*f**3*s + 600*C*D1*Ddd*f**3 + 7200*C*Dd**2*f**3*r*s - 1800*C*Dd**2*f**3*r + 7200*C*Dd**2*f**3*s**2 - 7200*C*Dd**2*f**3*s + 1200*C*Dd**2*f**3 + 540*D1**2*K*bdd1*f**2*r*s + 540*D1**2*K*bdd1*f**2*s**2 - 540*D1**2*K*bdd1*f**2*s - 1656*D1**2*b2*f*fd*r*s + 828*D1**2*b2*f*fd*r - 1656*D1**2*b2*f*fd*s**2 + 1656*D1**2*b2*f*fd*s - 828*D1**2*b2*f*fd + 1080*D1**2*b2*f*fdd*r*s - 540*D1**2*b2*f*fdd*r + 1080*D1**2*b2*f*fdd*s**2 - 1080*D1**2*b2*f*fdd*s + 540*D1**2*b2*f*fdd + 1080*D1**2*b2*fd**2*r*s - 540*D1**2*b2*fd**2*r + 1080*D1**2*b2*fd**2*s**2 - 1080*D1**2*b2*fd**2*s - 18*D1**2*bd1**2*f*(5*f*(r**2 + r*(2*s - 3) + s**2 - 5*s + 2) + 7*r**2*(5 - 4*K) + 7*r*(4*K*(s + 1) + 6*s - 7) + 7*s**2*(8*K + 1) - 7*s*(2*K + 7) + 14) - 828*D1**2*bd2*f**2*r*s - 828*D1**2*bd2*f**2*s**2 + 828*D1**2*bd2*f**2*s + 2160*D1**2*bd2*f*fd*r*s - 540*D1**2*bd2*f*fd*r + 2160*D1**2*bd2*f*fd*s**2 - 2160*D1**2*bd2*f*fd*s + 540*D1**2*bd2*f*fd + 675*D1**2*bdd1*f**3*r**2 + 1170*D1**2*bdd1*f**3*r*s - 990*D1**2*bdd1*f**3*r + 495*D1**2*bdd1*f**3*s**2 - 990*D1**2*bdd1*f**3*s + 495*D1**2*bdd1*f**3 + 198*D1**2*bdd1*f**2*r**2 + 1044*D1**2*bdd1*f**2*r*s - 1062*D1**2*bdd1*f**2*r + 846*D1**2*bdd1*f**2*s**2 - 1026*D1**2*bdd1*f**2*s + 477*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s + 1008*D1**2*bdd1*f*g2*s**2 + 540*D1**2*bdd2*f**2*r*s + 540*D1**2*bdd2*f**2*s**2 - 540*D1**2*bdd2*f**2*s - 1521*D1**2*f**2*fd*r**2 - 1398*D1**2*f**2*fd*r*s + 1480*D1**2*f**2*fd*r + 123*D1**2*f**2*fd*s**2 + 384*D1**2*f**2*fd*s - 466*D1**2*f**2*fd + 1287*D1**2*f**2*fdd*r**2 + 1266*D1**2*f**2*fdd*r*s - 1280*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd*s**2 - 408*D1**2*f**2*fdd*s + 422*D1**2*f**2*fdd + 1656*D1**2*f**2*gd2*r*s + 1656*D1**2*f**2*gd2*s**2 - 1656*D1**2*f**2*gd2*s - 1080*D1**2*f**2*gdd2*r*s - 1080*D1**2*f**2*gdd2*s**2 + 1080*D1**2*f**2*gdd2*s + 2574*D1**2*f*fd**2*r**2 + 2532*D1**2*f*fd**2*r*s - 2560*D1**2*f*fd**2*r - 42*D1**2*f*fd**2*s**2 - 816*D1**2*f*fd**2*s + 422*D1**2*f*fd**2 + 3312*D1**2*f*fd*g2*r*s - 1656*D1**2*f*fd*g2*r + 3312*D1**2*f*fd*g2*s**2 - 3312*D1**2*f*fd*g2*s + 1656*D1**2*f*fd*g2 - 4320*D1**2*f*fd*gd2*r*s + 1080*D1**2*f*fd*gd2*r - 4320*D1**2*f*fd*gd2*s**2 + 4320*D1**2*f*fd*gd2*s - 1080*D1**2*f*fd*gd2 - 2160*D1**2*f*fdd*g2*r*s + 1080*D1**2*f*fdd*g2*r - 2160*D1**2*f*fdd*g2*s**2 + 2160*D1**2*f*fdd*g2*s - 1080*D1**2*f*fdd*g2 - 2160*D1**2*fd**2*g2*r*s + 1080*D1**2*fd**2*g2*r - 2160*D1**2*fd**2*g2*s**2 + 2160*D1**2*fd**2*g2*s - 3312*D1*Dd*b2*f**2*r*s + 828*D1*Dd*b2*f**2*r - 3312*D1*Dd*b2*f**2*s**2 + 3312*D1*Dd*b2*f**2*s - 828*D1*Dd*b2*f**2 + 8640*D1*Dd*b2*f*fd*r*s - 3240*D1*Dd*b2*f*fd*r + 8640*D1*Dd*b2*f*fd*s**2 - 8640*D1*Dd*b2*f*fd*s + 2160*D1*Dd*b2*f*fd + 4320*D1*Dd*bd2*f**2*r*s - 540*D1*Dd*bd2*f**2*r + 4320*D1*Dd*bd2*f**2*s**2 - 4320*D1*Dd*bd2*f**2*s + 540*D1*Dd*bd2*f**2 - 2028*D1*Dd*f**3*r**2 - 1864*D1*Dd*f**3*r*s + 2494*D1*Dd*f**3*r + 164*D1*Dd*f**3*s**2 + 850*D1*Dd*f**3*s - 973*D1*Dd*f**3 + 10296*D1*Dd*f**2*fd*r**2 + 10128*D1*Dd*f**2*fd*r*s - 11534*D1*Dd*f**2*fd*r - 168*D1*Dd*f**2*fd*s**2 - 4122*D1*Dd*f**2*fd*s + 2968*D1*Dd*f**2*fd + 6624*D1*Dd*f**2*g2*r*s - 1656*D1*Dd*f**2*g2*r + 6624*D1*Dd*f**2*g2*s**2 - 6624*D1*Dd*f**2*g2*s + 1656*D1*Dd*f**2*g2 - 8640*D1*Dd*f**2*gd2*r*s + 1080*D1*Dd*f**2*gd2*r - 8640*D1*Dd*f**2*gd2*s**2 + 8640*D1*Dd*f**2*gd2*s - 1080*D1*Dd*f**2*gd2 - 17280*D1*Dd*f*fd*g2*r*s + 6480*D1*Dd*f*fd*g2*r - 17280*D1*Dd*f*fd*g2*s**2 + 17280*D1*Dd*f*fd*g2*s - 4320*D1*Dd*f*fd*g2 + 2160*D1*Ddd*b2*f**2*r*s - 540*D1*Ddd*b2*f**2*r + 2160*D1*Ddd*b2*f**2*s**2 - 2160*D1*Ddd*b2*f**2*s + 540*D1*Ddd*b2*f**2 + 1716*D1*Ddd*f**3*r**2 + 1688*D1*Ddd*f**3*r*s - 2138*D1*Ddd*f**3*r - 28*D1*Ddd*f**3*s**2 - 830*D1*Ddd*f**3*s + 851*D1*Ddd*f**3 - 4320*D1*Ddd*f**2*g2*r*s + 1080*D1*Ddd*f**2*g2*r - 4320*D1*Ddd*f**2*g2*s**2 + 4320*D1*Ddd*f**2*g2*s - 1080*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(15*f**3*(13*r**2 + 6*r*(5*s - 3) + 17*s**2 - 26*s + 9) - f**2*(30*fd*(45*r**2 + 13*r*(6*s - 5) + 33*s**2 - 59*s + 22) + r**2*(1 - 184*C) + r*s*(104*C - 276*K - 458) + 330*r + s**2*(288*C - 276*K - 459) + s*(276*K + 390) - 129) - 6*f*(fd*(-96*C*s**2 + 52*C*s + 30*K*(r*(4*s - 1) + (1 - 2*s)**2) + r**2*(80*C + 44) - r*(4*C*(4*s + 9) - 232*s + 139) + 188*s**2 - 209*s + 63) + 56*g2*(r**2 - r*s - 2*s**2) + 28*gd2*(-2*r**2 + 2*r*(s + 1) + s*(4*s - 1))) + 168*fd*g2*(2*r**2 - 2*r*s + r - s*(4*s - 4))) - 6*Dd*f*(5*f**2*(60*r**2 + r*(104*s - 87) + 44*s**2 - 81*s + 33) + f*(-192*C*s**2 + 56*C*s + 30*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + r**2*(160*C + 88) - 2*r*(16*C*s + 38*C - 232*s + 169) + 376*s**2 - 438*s + 175) - 28*g2*(8*r**2 - r*(8*s + 3) + s*(6 - 16*s)))) + 6480*Dd**2*b2*f**2*r*s - 1620*Dd**2*b2*f**2*r + 6480*Dd**2*b2*f**2*s**2 - 6480*Dd**2*b2*f**2*s + 1080*Dd**2*b2*f**2 + 5148*Dd**2*f**3*r**2 + 5064*Dd**2*f**3*r*s - 6414*Dd**2*f**3*r - 84*Dd**2*f**3*s**2 - 2490*Dd**2*f**3*s + 1702*Dd**2*f**3 - 12960*Dd**2*f**2*g2*r*s + 3240*Dd**2*f**2*g2*r - 12960*Dd**2*f**2*g2*s**2 + 12960*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 + 9*b1**2*(-D1**2*(-20*f*fd*(r**2 + 2*r*s + s**2 + 2*s - 1) + 10*fd**2*(r**2 + 2*r*s + s**2 + 2*s - 1) + 14*fd*(4*K*(r**2 - r*s + r - 2*(s - 1)**2) - 5*r**2 - 6*r*s + 2*r - s**2 - 6*s + 3) + fdd*(-28*K*(r**2 - r*s + r - 2*(s - 1)**2) + 10*f*(r**2 + 2*r*s + s**2 + 2*s - 1) + 35*r**2 + 42*r*s - 14*r + 7*s**2 + 42*s - 21)) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-10*fd*(4*r**2 + r*(8*s - 3) + 4*s**2 + s - 1) - 7*r**2*(16*K - 20) + 14*r*(K*(8*s + 6) + 12*s - 13) + 7*s**2*(32*K + 4) - 7*s*(24*K + 14) + 77) + 7*fd*(2*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) - 20*r**2 + r*(17 - 24*s) - 4*s**2 - 5*s + 1)) - Ddd*f*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*r**2*(16*K - 20) + 14*r*(K*(8*s + 6) + 12*s - 13) + 7*s**2*(32*K + 4) - 7*s*(24*K + 14) + 77)) - 2*Dd**2*f*(15*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 7*r**2*(24*K - 30) + 21*r*(K*(8*s + 6) + 12*s - 13) + 7*s**2*(48*K + 6) - 7*s*(36*K + 21) + 77)) + 3*b1*(-368*C*D1**2*f*fd*r**2 + 208*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*r + 576*C*D1**2*f*fd*s**2 - 680*C*D1**2*f*fd*s + 104*C*D1**2*f*fd + 240*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s - 216*C*D1**2*f*fdd*r - 288*C*D1**2*f*fdd*s**2 + 312*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd + 240*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s - 216*C*D1**2*fd**2*r - 288*C*D1**2*fd**2*s**2 + 312*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 736*C*D1*Dd*f**2*r**2 + 416*C*D1*Dd*f**2*r*s + 632*C*D1*Dd*f**2*r + 1152*C*D1*Dd*f**2*s**2 - 784*C*D1*Dd*f**2*s - 80*C*D1*Dd*f**2 + 1920*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s - 1776*C*D1*Dd*f*fd*r - 2304*C*D1*Dd*f*fd*s**2 + 1920*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 480*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r*s - 456*C*D1*Ddd*f**2*r - 576*C*D1*Ddd*f**2*s**2 + 336*C*D1*Ddd*f**2*s + 96*C*D1*Ddd*f**2 + 1440*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r*s - 1368*C*Dd**2*f**2*r - 1728*C*Dd**2*f**2*s**2 + 1008*C*Dd**2*f**2*s + 192*C*Dd**2*f**2 - 552*D1**2*K*f*fd*r*s + 276*D1**2*K*f*fd*r - 552*D1**2*K*f*fd*s**2 + 552*D1**2*K*f*fd*s - 276*D1**2*K*f*fd + 360*D1**2*K*f*fdd*r*s - 180*D1**2*K*f*fdd*r + 360*D1**2*K*f*fdd*s**2 - 360*D1**2*K*f*fdd*s + 180*D1**2*K*f*fdd + 360*D1**2*K*fd**2*r*s - 180*D1**2*K*fd**2*r + 360*D1**2*K*fd**2*s**2 - 360*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(-28*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) + 5*f*(2*r**2 + r*(4*s - 6) + 2*s**2 - 10*s + 5) + 70*r**2 + 14*r*(6*s - 7) + 14*s**2 - 98*s + 63) - 585*D1**2*f**2*fd*r**2 - 1350*D1**2*f**2*fd*r*s + 960*D1**2*f**2*fd*r - 765*D1**2*f**2*fd*s**2 + 1020*D1**2*f**2*fd*s - 510*D1**2*f**2*fd + 675*D1**2*f**2*fdd*r**2 + 1170*D1**2*f**2*fdd*r*s - 960*D1**2*f**2*fdd*r + 495*D1**2*f**2*fdd*s**2 - 780*D1**2*f**2*fdd*s + 450*D1**2*f**2*fdd + 1350*D1**2*f*fd**2*r**2 + 2340*D1**2*f*fd**2*r*s - 1920*D1**2*f*fd**2*r + 990*D1**2*f*fd**2*s**2 - 1560*D1**2*f*fd**2*s + 570*D1**2*f*fd**2 + 2*D1**2*f*fd*r**2 - 916*D1**2*f*fd*r*s + 126*D1**2*f*fd*r - 918*D1**2*f*fd*s**2 + 986*D1**2*f*fd*s - 329*D1**2*f*fd + 132*D1**2*f*fdd*r**2 + 696*D1**2*f*fdd*r*s - 126*D1**2*f*fdd*r + 564*D1**2*f*fdd*s**2 - 570*D1**2*f*fdd*s + 189*D1**2*f*fdd + 336*D1**2*f*gd2*r**2 - 336*D1**2*f*gd2*r*s - 672*D1**2*f*gd2*r - 672*D1**2*f*gd2*s**2 + 336*D1**2*f*gd2*s + 336*D1**2*f*gd2 - 168*D1**2*f*gdd2*r**2 + 168*D1**2*f*gdd2*r*s + 336*D1**2*f*gdd2*r + 336*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s - 168*D1**2*f*gdd2 + 132*D1**2*fd**2*r**2 + 696*D1**2*fd**2*r*s - 126*D1**2*fd**2*r + 564*D1**2*fd**2*s**2 - 570*D1**2*fd**2*s - 30*D1**2*fd**2 + 336*D1**2*fd*g2*r**2 - 336*D1**2*fd*g2*r*s + 336*D1**2*fd*g2*r - 672*D1**2*fd*g2*s**2 + 1344*D1**2*fd*g2*s - 672*D1**2*fd*g2 - 336*D1**2*fd*gd2*r**2 + 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r + 672*D1**2*fd*gd2*s**2 - 840*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 - 168*D1**2*fdd*g2*r**2 + 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r + 336*D1**2*fdd*g2*s**2 - 672*D1**2*fdd*g2*s + 336*D1**2*fdd*g2 - 1104*D1*Dd*K*f**2*r*s + 276*D1*Dd*K*f**2*r - 1104*D1*Dd*K*f**2*s**2 + 1104*D1*Dd*K*f**2*s - 276*D1*Dd*K*f**2 + 2880*D1*Dd*K*f*fd*r*s - 1080*D1*Dd*K*f*fd*r + 2880*D1*Dd*K*f*fd*s**2 - 2880*D1*Dd*K*f*fd*s + 720*D1*Dd*K*f*fd - 780*D1*Dd*f**3*r**2 - 1800*D1*Dd*f**3*r*s + 1230*D1*Dd*f**3*r - 1020*D1*Dd*f**3*s**2 + 1410*D1*Dd*f**3*s - 645*D1*Dd*f**3 + 5400*D1*Dd*f**2*fd*r**2 + 9360*D1*Dd*f**2*fd*r*s - 7710*D1*Dd*f**2*fd*r + 3960*D1*Dd*f**2*fd*s**2 - 6450*D1*Dd*f**2*fd*s + 2700*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r**2 - 1832*D1*Dd*f**2*r*s + 454*D1*Dd*f**2*r - 1836*D1*Dd*f**2*s**2 + 1834*D1*Dd*f**2*s - 457*D1*Dd*f**2 + 1056*D1*Dd*f*fd*r**2 + 5568*D1*Dd*f*fd*r*s - 1728*D1*Dd*f*fd*r + 4512*D1*Dd*f*fd*s**2 - 4800*D1*Dd*f*fd*s + 822*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r**2 - 1344*D1*Dd*f*g2*r*s - 1008*D1*Dd*f*g2*r - 2688*D1*Dd*f*g2*s**2 + 2016*D1*Dd*f*g2*s - 1344*D1*Dd*f*gd2*r**2 + 1344*D1*Dd*f*gd2*r*s + 1848*D1*Dd*f*gd2*r + 2688*D1*Dd*f*gd2*s**2 - 1680*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r**2 + 1344*D1*Dd*fd*g2*r*s - 168*D1*Dd*fd*g2*r + 2688*D1*Dd*fd*g2*s**2 - 3696*D1*Dd*fd*g2*s + 1008*D1*Dd*fd*g2 + 720*D1*Ddd*K*f**2*r*s - 180*D1*Ddd*K*f**2*r + 720*D1*Ddd*K*f**2*s**2 - 720*D1*Ddd*K*f**2*s + 180*D1*Ddd*K*f**2 + 900*D1*Ddd*f**3*r**2 + 1560*D1*Ddd*f**3*r*s - 1290*D1*Ddd*f**3*r + 660*D1*Ddd*f**3*s**2 - 1110*D1*Ddd*f**3*s + 615*D1*Ddd*f**3 + 264*D1*Ddd*f**2*r**2 + 1392*D1*Ddd*f**2*r*s - 612*D1*Ddd*f**2*r + 1128*D1*Ddd*f**2*s**2 - 1260*D1*Ddd*f**2*s + 414*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 + 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r + 1344*D1*Ddd*f*g2*s**2 - 1008*D1*Ddd*f*g2*s + 6*D1*bd1*(5*D1*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 10*s + 5) + D1*f*(-28*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) - 10*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 70*r**2 + 14*r*(6*s - 7) + 14*s**2 - 98*s + 63) + 7*D1*fd*(2*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) - 10*r**2 + r*(9 - 12*s) - 2*s**2 + s - 1) - 5*Dd*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 26*s + 11) + 7*Dd*f*(K*(32*r**2 - 4*r*(8*s + 7) - 64*s**2 + 32*s + 6) - 40*r**2 - 6*r*(8*s - 9) - 8*s**2 + 42*s - 21)) + 2160*Dd**2*K*f**2*r*s - 540*Dd**2*K*f**2*r + 2160*Dd**2*K*f**2*s**2 - 2160*Dd**2*K*f**2*s + 360*Dd**2*K*f**2 + 2700*Dd**2*f**3*r**2 + 4680*Dd**2*f**3*r*s - 3870*Dd**2*f**3*r + 1980*Dd**2*f**3*s**2 - 3330*Dd**2*f**3*s + 1230*Dd**2*f**3 + 792*Dd**2*f**2*r**2 + 4176*Dd**2*f**2*r*s - 1836*Dd**2*f**2*r + 3384*Dd**2*f**2*s**2 - 3780*Dd**2*f**2*s + 828*Dd**2*f**2 - 2016*Dd**2*f*g2*r**2 + 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r + 4032*Dd**2*f*g2*s**2 - 3024*Dd**2*f*g2*s))/(315*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**3*k1*k2*(360*C*D1**2*bdd1*f**2*r**2 + 960*C*D1**2*bdd1*f**2*r*s + 600*C*D1**2*bdd1*f**2*s**2 + 1020*C*D1**2*f**2*fd*r**2 + 3360*C*D1**2*f**2*fd*r*s - 1800*C*D1**2*f**2*fd*r + 2340*C*D1**2*f**2*fd*s**2 - 2680*C*D1**2*f**2*fd*s + 1120*C*D1**2*f**2*fd - 1140*C*D1**2*f**2*fdd*r**2 - 3120*C*D1**2*f**2*fdd*r*s + 1800*C*D1**2*f**2*fdd*r - 1980*C*D1**2*f**2*fdd*s**2 + 2360*C*D1**2*f**2*fdd*s - 1040*C*D1**2*f**2*fdd - 2280*C*D1**2*f*fd**2*r**2 - 6240*C*D1**2*f*fd**2*r*s + 3600*C*D1**2*f*fd**2*r - 3960*C*D1**2*f*fd**2*s**2 + 4720*C*D1**2*f*fd**2*s - 1040*C*D1**2*f*fd**2 + 1360*C*D1*Dd*f**3*r**2 + 4480*C*D1*Dd*f**3*r*s - 2480*C*D1*Dd*f**3*r + 3120*C*D1*Dd*f**3*s**2 - 3800*C*D1*Dd*f**3*s + 1460*C*D1*Dd*f**3 - 9120*C*D1*Dd*f**2*fd*r**2 - 24960*C*D1*Dd*f**2*fd*r*s + 14880*C*D1*Dd*f**2*fd*r - 15840*C*D1*Dd*f**2*fd*s**2 + 19640*C*D1*Dd*f**2*fd*s - 5960*C*D1*Dd*f**2*fd - 1520*C*D1*Ddd*f**3*r**2 - 4160*C*D1*Ddd*f**3*r*s + 2560*C*D1*Ddd*f**3*r - 2640*C*D1*Ddd*f**3*s**2 + 3400*C*D1*Ddd*f**3*s - 1420*C*D1*Ddd*f**3 - 4560*C*Dd**2*f**3*r**2 - 12480*C*Dd**2*f**3*r*s + 7680*C*Dd**2*f**3*r - 7920*C*Dd**2*f**3*s**2 + 10200*C*Dd**2*f**3*s - 2840*C*Dd**2*f**3 - 210*D1**2*K*bdd1*f**2*r**2 - 672*D1**2*K*bdd1*f**2*r*s + 420*D1**2*K*bdd1*f**2*r - 462*D1**2*K*bdd1*f**2*s**2 + 672*D1**2*K*bdd1*f**2*s - 210*D1**2*K*bdd1*f**2 + 42*D1**2*b2*bdd1*f*r**2 + 84*D1**2*b2*bdd1*f*r*s + 42*D1**2*b2*bdd1*f*s**2 + 252*D1**2*b2*f*fd*r**2 + 1344*D1**2*b2*f*fd*r*s - 672*D1**2*b2*f*fd*r + 1092*D1**2*b2*f*fd*s**2 - 1092*D1**2*b2*f*fd*s + 546*D1**2*b2*f*fd - 420*D1**2*b2*f*fdd*r**2 - 1344*D1**2*b2*f*fdd*r*s + 672*D1**2*b2*f*fdd*r - 924*D1**2*b2*f*fdd*s**2 + 924*D1**2*b2*f*fdd*s - 462*D1**2*b2*f*fdd - 420*D1**2*b2*fd**2*r**2 - 1344*D1**2*b2*fd**2*r*s + 672*D1**2*b2*fd**2*r - 924*D1**2*b2*fd**2*s**2 + 924*D1**2*b2*fd**2*s + 14*D1**2*bd1**2*(3*f**2*(8*r**2 + r*(8*s - 15) - 9*s + 9) + f*(r**2*(40*C + 28*K - 11) + 2*r*(10*C*(2*s - 1) + 48*K*s - 14*K - 7*s - 23) + s**2*(68*K - 3) - s*(48*K + 44) + 37) - 20*g2*r*(2*r + 2*s - 1)) + 126*D1**2*bd2*f**2*r**2 + 672*D1**2*bd2*f**2*r*s - 252*D1**2*bd2*f**2*r + 546*D1**2*bd2*f**2*s**2 - 672*D1**2*bd2*f**2*s + 126*D1**2*bd2*f**2 - 840*D1**2*bd2*f*fd*r**2 - 2688*D1**2*bd2*f*fd*r*s + 1512*D1**2*bd2*f*fd*r - 1848*D1**2*bd2*f*fd*s**2 + 2268*D1**2*bd2*f*fd*s - 672*D1**2*bd2*f*fd + 12*D1**2*bdd1*f**2*r**2 - 288*D1**2*bdd1*f**2*r*s - 402*D1**2*bdd1*f**2*r - 300*D1**2*bdd1*f**2*s**2 - 270*D1**2*bdd1*f**2*s + 135*D1**2*bdd1*f**2 - 392*D1**2*bdd1*f*g2*r**2 - 1344*D1**2*bdd1*f*g2*r*s - 952*D1**2*bdd1*f*g2*s**2 - 210*D1**2*bdd2*f**2*r**2 - 672*D1**2*bdd2*f**2*r*s + 420*D1**2*bdd2*f**2*r - 462*D1**2*bdd2*f**2*s**2 + 672*D1**2*bdd2*f**2*s - 210*D1**2*bdd2*f**2 - 330*D1**2*f**2*fd*r**2 - 1500*D1**2*f**2*fd*r*s + 720*D1**2*f**2*fd*r - 1170*D1**2*f**2*fd*s**2 + 1280*D1**2*f**2*fd*s - 500*D1**2*f**2*fd + 570*D1**2*f**2*fdd*r**2 + 1560*D1**2*f**2*fdd*r*s - 900*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 1180*D1**2*f**2*fdd*s + 520*D1**2*f**2*fdd - 252*D1**2*f**2*gd2*r**2 - 1344*D1**2*f**2*gd2*r*s + 504*D1**2*f**2*gd2*r - 1092*D1**2*f**2*gd2*s**2 + 1344*D1**2*f**2*gd2*s - 252*D1**2*f**2*gd2 + 420*D1**2*f**2*gdd2*r**2 + 1344*D1**2*f**2*gdd2*r*s - 840*D1**2*f**2*gdd2*r + 924*D1**2*f**2*gdd2*s**2 - 1344*D1**2*f**2*gdd2*s + 420*D1**2*f**2*gdd2 + 1140*D1**2*f*fd**2*r**2 + 3120*D1**2*f*fd**2*r*s - 1800*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 2360*D1**2*f*fd**2*s + 520*D1**2*f*fd**2 - 504*D1**2*f*fd*g2*r**2 - 2688*D1**2*f*fd*g2*r*s + 1344*D1**2*f*fd*g2*r - 2184*D1**2*f*fd*g2*s**2 + 2184*D1**2*f*fd*g2*s - 1092*D1**2*f*fd*g2 + 1680*D1**2*f*fd*gd2*r**2 + 5376*D1**2*f*fd*gd2*r*s - 3024*D1**2*f*fd*gd2*r + 3696*D1**2*f*fd*gd2*s**2 - 4536*D1**2*f*fd*gd2*s + 1344*D1**2*f*fd*gd2 + 840*D1**2*f*fdd*g2*r**2 + 2688*D1**2*f*fdd*g2*r*s - 1344*D1**2*f*fdd*g2*r + 1848*D1**2*f*fdd*g2*s**2 - 1848*D1**2*f*fdd*g2*s + 924*D1**2*f*fdd*g2 + 840*D1**2*fd**2*g2*r**2 + 2688*D1**2*fd**2*g2*r*s - 1344*D1**2*fd**2*g2*r + 1848*D1**2*fd**2*g2*s**2 - 1848*D1**2*fd**2*g2*s + 504*D1*Dd*b2*f**2*r**2 + 2688*D1*Dd*b2*f**2*r*s - 1176*D1*Dd*b2*f**2*r + 2184*D1*Dd*b2*f**2*s**2 - 2436*D1*Dd*b2*f**2*s + 798*D1*Dd*b2*f**2 - 3360*D1*Dd*b2*f*fd*r**2 - 10752*D1*Dd*b2*f*fd*r*s + 5712*D1*Dd*b2*f*fd*r - 7392*D1*Dd*b2*f*fd*s**2 + 8232*D1*Dd*b2*f*fd*s - 2268*D1*Dd*b2*f*fd - 1680*D1*Dd*bd2*f**2*r**2 - 5376*D1*Dd*bd2*f**2*r*s + 3192*D1*Dd*bd2*f**2*r - 3696*D1*Dd*bd2*f**2*s**2 + 4956*D1*Dd*bd2*f**2*s - 1512*D1*Dd*bd2*f**2 - 440*D1*Dd*f**3*r**2 - 2000*D1*Dd*f**3*r*s + 940*D1*Dd*f**3*r - 1560*D1*Dd*f**3*s**2 + 1780*D1*Dd*f**3*s - 610*D1*Dd*f**3 + 4560*D1*Dd*f**2*fd*r**2 + 12480*D1*Dd*f**2*fd*r*s - 7440*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 9820*D1*Dd*f**2*fd*s + 2980*D1*Dd*f**2*fd - 1008*D1*Dd*f**2*g2*r**2 - 5376*D1*Dd*f**2*g2*r*s + 2352*D1*Dd*f**2*g2*r - 4368*D1*Dd*f**2*g2*s**2 + 4872*D1*Dd*f**2*g2*s - 1596*D1*Dd*f**2*g2 + 3360*D1*Dd*f**2*gd2*r**2 + 10752*D1*Dd*f**2*gd2*r*s - 6384*D1*Dd*f**2*gd2*r + 7392*D1*Dd*f**2*gd2*s**2 - 9912*D1*Dd*f**2*gd2*s + 3024*D1*Dd*f**2*gd2 + 6720*D1*Dd*f*fd*g2*r**2 + 21504*D1*Dd*f*fd*g2*r*s - 11424*D1*Dd*f*fd*g2*r + 14784*D1*Dd*f*fd*g2*s**2 - 16464*D1*Dd*f*fd*g2*s + 4536*D1*Dd*f*fd*g2 - 840*D1*Ddd*b2*f**2*r**2 - 2688*D1*Ddd*b2*f**2*r*s + 1512*D1*Ddd*b2*f**2*r - 1848*D1*Ddd*b2*f**2*s**2 + 2268*D1*Ddd*b2*f**2*s - 882*D1*Ddd*b2*f**2 + 760*D1*Ddd*f**3*r**2 + 2080*D1*Ddd*f**3*r*s - 1280*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1700*D1*Ddd*f**3*s + 710*D1*Ddd*f**3 + 1680*D1*Ddd*f**2*g2*r**2 + 5376*D1*Ddd*f**2*g2*r*s - 3024*D1*Ddd*f**2*g2*r + 3696*D1*Ddd*f**2*g2*s**2 - 4536*D1*Ddd*f**2*g2*s + 1764*D1*Ddd*f**2*g2 + D1*bd1*(D1*(3*f**2*(-232*C*s**2 + 14*K*(3*r**2 + 2*r*(8*s - 3) + 13*s**2 - 16*s + 3) - r**2*(16*C + 99) + r*(-248*C*s + 10*s + 114) + 109*s**2 + 82*s - 27) - 2*f*(-42*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*fd*(-400*C*s**2 + 360*C*s + 14*K*(10*r**2 + 2*r*(16*s - 9) + 22*s**2 - 27*s + 8) - r**2*(240*C + 8) + r*(-640*C*s + 280*C + 192*s + 23) + 200*s**2 - 103*s - 67) + 56*gd2*(7*r**2 + r*(24*s - 7) + s*(17*s - 12)) + 7*(r + s)*(b2*(r + s) + 4*g2*(6*r - 19*s))) + 28*fd*(3*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 4*g2*(7*r**2 + 12*r*(2*s - 1) + s*(17*s - 17)))) - 2*Dd*f*(-42*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f*(-800*C*s**2 + 520*C*s + 14*K*(20*r**2 + r*(64*s - 38) + 44*s**2 - 59*s + 18) - r**2*(480*C + 16) + 4*r*(-320*C*s + 100*C + 96*s + 57) + 400*s**2 - 16*s - 179) + 56*g2*(28*r**2 + r*(96*s - 26) + s*(68*s - 41)))) - 2520*Dd**2*b2*f**2*r**2 - 8064*Dd**2*b2*f**2*r*s + 4536*Dd**2*b2*f**2*r - 5544*Dd**2*b2*f**2*s**2 + 6804*Dd**2*b2*f**2*s - 1764*Dd**2*b2*f**2 + 2280*Dd**2*f**3*r**2 + 6240*Dd**2*f**3*r*s - 3840*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 5100*Dd**2*f**3*s + 1420*Dd**2*f**3 + 5040*Dd**2*f**2*g2*r**2 + 16128*Dd**2*f**2*g2*r*s - 9072*Dd**2*f**2*g2*r + 11088*Dd**2*f**2*g2*s**2 - 13608*Dd**2*f**2*g2*s + 3528*Dd**2*f**2*g2 + 7*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(-20*K*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + 3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 100*r**2 + 120*r*s - 130*r + 20*s**2 - 70*s + 55) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*Ddd*(4*K*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 20*r**2 + r*(26 - 24*s) - 4*s**2 + 14*s - 11)) - 2*Dd**2*(-10*K*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 9*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 150*r**2 + 180*r*s - 195*r + 30*s**2 - 105*s + 55)) + 7*b1**2*(-80*C*D1**2*fd*r**2 - 80*C*D1**2*fd*r*s + 160*C*D1**2*fd*r + 80*C*D1**2*fd*s - 80*C*D1**2*fd + 40*C*D1**2*fdd*r**2 + 40*C*D1**2*fdd*r*s - 80*C*D1**2*fdd*r - 40*C*D1**2*fdd*s + 40*C*D1**2*fdd - 320*C*D1*Dd*f*r**2 - 320*C*D1*Dd*f*r*s + 400*C*D1*Dd*f*r + 160*C*D1*Dd*f*s - 160*C*D1*Dd*f + 320*C*D1*Dd*fd*r**2 + 320*C*D1*Dd*fd*r*s - 520*C*D1*Dd*fd*r - 240*C*D1*Dd*fd*s + 200*C*D1*Dd*fd + 160*C*D1*Ddd*f*r**2 + 160*C*D1*Ddd*f*r*s - 200*C*D1*Ddd*f*r - 80*C*D1*Ddd*f*s + 80*C*D1*Ddd*f + 480*C*Dd**2*f*r**2 + 480*C*Dd**2*f*r*s - 600*C*Dd**2*f*r - 240*C*Dd**2*f*s + 160*C*Dd**2*f + 24*D1**2*K*fd*r**2 - 52*D1**2*K*fd*r*s + 52*D1**2*K*fd*r - 76*D1**2*K*fd*s**2 + 152*D1**2*K*fd*s - 76*D1**2*K*fd + 28*D1**2*K*fdd*r**2 + 96*D1**2*K*fdd*r*s - 96*D1**2*K*fdd*r + 68*D1**2*K*fdd*s**2 - 136*D1**2*K*fdd*s + 68*D1**2*K*fdd - D1**2*bdd1*(-20*K*(3*r**2 + 3*r*(s - 1) - s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 75*r**2 + 90*r*s - 80*r + 15*s**2 - 40*s + 30) - 54*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s - 15*D1**2*f*fd + 48*D1**2*f*fdd*r**2 + 48*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*r + 6*D1**2*f*fdd*s + 15*D1**2*f*fdd + 48*D1**2*fd**2*r**2 + 48*D1**2*fd**2*r*s - 30*D1**2*fd**2*r + 6*D1**2*fd**2*s - 18*D1**2*fd**2 + 17*D1**2*fd*r**2 + 18*D1**2*fd*r*s - 176*D1**2*fd*r + D1**2*fd*s**2 - 156*D1**2*fd*s + 118*D1**2*fd - 11*D1**2*fdd*r**2 - 14*D1**2*fdd*r*s + 128*D1**2*fdd*r - 3*D1**2*fdd*s**2 + 108*D1**2*fdd*s - 74*D1**2*fdd + 80*D1**2*gd2*r**2 + 80*D1**2*gd2*r*s - 160*D1**2*gd2*r - 80*D1**2*gd2*s + 80*D1**2*gd2 - 40*D1**2*gdd2*r**2 - 40*D1**2*gdd2*r*s + 80*D1**2*gdd2*r + 40*D1**2*gdd2*s - 40*D1**2*gdd2 + 96*D1*Dd*K*f*r**2 - 208*D1*Dd*K*f*r*s - 44*D1*Dd*K*f*r - 304*D1*Dd*K*f*s**2 + 256*D1*Dd*K*f*s - 28*D1*Dd*K*f + 224*D1*Dd*K*fd*r**2 + 768*D1*Dd*K*fd*r*s - 592*D1*Dd*K*fd*r + 544*D1*Dd*K*fd*s**2 - 872*D1*Dd*K*fd*s + 328*D1*Dd*K*fd - 108*D1*Dd*f**2*r**2 - 120*D1*Dd*f**2*r*s + 138*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 66*D1*Dd*f**2*s - 57*D1*Dd*f**2 + 384*D1*Dd*f*fd*r**2 + 384*D1*Dd*f*fd*r*s - 360*D1*Dd*f*fd*r - 72*D1*Dd*f*fd*s + 54*D1*Dd*f*fd + 68*D1*Dd*f*r**2 + 72*D1*Dd*f*r*s - 86*D1*Dd*f*r + 4*D1*Dd*f*s**2 - 38*D1*Dd*f*s + 35*D1*Dd*f - 88*D1*Dd*fd*r**2 - 112*D1*Dd*fd*r*s + 570*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 466*D1*Dd*fd*s - 364*D1*Dd*fd + 320*D1*Dd*g2*r**2 + 320*D1*Dd*g2*r*s - 400*D1*Dd*g2*r - 160*D1*Dd*g2*s + 160*D1*Dd*g2 - 320*D1*Dd*gd2*r**2 - 320*D1*Dd*gd2*r*s + 520*D1*Dd*gd2*r + 240*D1*Dd*gd2*s - 200*D1*Dd*gd2 + 112*D1*Ddd*K*f*r**2 + 384*D1*Ddd*K*f*r*s - 208*D1*Ddd*K*f*r + 272*D1*Ddd*K*f*s**2 - 328*D1*Ddd*K*f*s + 124*D1*Ddd*K*f + 96*D1*Ddd*f**2*r**2 + 96*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r - 48*D1*Ddd*f**2*s + 48*D1*Ddd*f**2 - 44*D1*Ddd*f*r**2 - 56*D1*Ddd*f*r*s + 58*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 34*D1*Ddd*f*s - 25*D1*Ddd*f - 160*D1*Ddd*g2*r**2 - 160*D1*Ddd*g2*r*s + 200*D1*Ddd*g2*r + 80*D1*Ddd*g2*s - 80*D1*Ddd*g2 + 2*D1*bd1*(D1*(-20*K*(3*r**2 + 3*r*(s - 1) - s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 75*r**2 + 90*r*s - 80*r + 15*s**2 - 40*s + 30) - 3*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 5*Dd*(2*K*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7) - 60*r**2 + r*(71 - 72*s) - 12*s**2 + 37*s - 20)) + 336*Dd**2*K*f*r**2 + 1152*Dd**2*K*f*r*s - 624*Dd**2*K*f*r + 816*Dd**2*K*f*s**2 - 984*Dd**2*K*f*s + 248*Dd**2*K*f + 288*Dd**2*f**2*r**2 + 288*Dd**2*f**2*r*s - 360*Dd**2*f**2*r - 144*Dd**2*f**2*s + 96*Dd**2*f**2 - 132*Dd**2*f*r**2 - 168*Dd**2*f*r*s + 174*Dd**2*f*r - 36*Dd**2*f*s**2 + 102*Dd**2*f*s - 50*Dd**2*f - 480*Dd**2*g2*r**2 - 480*Dd**2*g2*r*s + 600*Dd**2*g2*r + 240*Dd**2*g2*s - 160*Dd**2*g2) - b1*(-560*C*D1**2*bdd1*f*r**2 - 560*C*D1**2*bdd1*f*r*s + 280*C*D1**2*bdd1*f*r + 96*C*D1**2*f*fd*r**2 + 1488*C*D1**2*f*fd*r*s - 840*C*D1**2*f*fd*r + 1392*C*D1**2*f*fd*s**2 - 2136*C*D1**2*f*fd*s + 744*C*D1**2*f*fd - 720*C*D1**2*f*fdd*r**2 - 1920*C*D1**2*f*fdd*r*s + 1680*C*D1**2*f*fdd*r - 1200*C*D1**2*f*fdd*s**2 + 2160*C*D1**2*f*fdd*s - 960*C*D1**2*f*fdd - 720*C*D1**2*fd**2*r**2 - 1920*C*D1**2*fd**2*r*s + 1680*C*D1**2*fd**2*r - 1200*C*D1**2*fd**2*s**2 + 2160*C*D1**2*fd**2*s - 960*C*D1**2*fd**2 + 192*C*D1*Dd*f**2*r**2 + 2976*C*D1*Dd*f**2*r*s - 936*C*D1*Dd*f**2*r + 2784*C*D1*Dd*f**2*s**2 - 2880*C*D1*Dd*f**2*s + 792*C*D1*Dd*f**2 - 5760*C*D1*Dd*f*fd*r**2 - 15360*C*D1*Dd*f*fd*r*s + 11520*C*D1*Dd*f*fd*r - 9600*C*D1*Dd*f*fd*s**2 + 14880*C*D1*Dd*f*fd*s - 5520*C*D1*Dd*f*fd - 1440*C*D1*Ddd*f**2*r**2 - 3840*C*D1*Ddd*f**2*r*s + 2400*C*D1*Ddd*f**2*r - 2400*C*D1*Ddd*f**2*s**2 + 3120*C*D1*Ddd*f**2*s - 1320*C*D1*Ddd*f**2 - 4320*C*Dd**2*f**2*r**2 - 11520*C*Dd**2*f**2*r*s + 7200*C*Dd**2*f**2*r - 7200*C*Dd**2*f**2*s**2 + 9360*C*Dd**2*f**2*s - 2640*C*Dd**2*f**2 - 392*D1**2*K*bdd1*f*r**2 - 1344*D1**2*K*bdd1*f*r*s + 392*D1**2*K*bdd1*f*r - 952*D1**2*K*bdd1*f*s**2 + 672*D1**2*K*bdd1*f*s - 196*D1**2*K*bdd1*f - 252*D1**2*K*f*fd*r**2 - 1344*D1**2*K*f*fd*r*s + 672*D1**2*K*f*fd*r - 1092*D1**2*K*f*fd*s**2 + 1092*D1**2*K*f*fd*s - 546*D1**2*K*f*fd + 420*D1**2*K*f*fdd*r**2 + 1344*D1**2*K*f*fdd*r*s - 672*D1**2*K*f*fdd*r + 924*D1**2*K*f*fdd*s**2 - 924*D1**2*K*f*fdd*s + 462*D1**2*K*f*fdd + 420*D1**2*K*fd**2*r**2 + 1344*D1**2*K*fd**2*r*s - 672*D1**2*K*fd**2*r + 924*D1**2*K*fd**2*s**2 - 924*D1**2*K*fd**2*s + 14*D1**2*b2*fd*r**2 + 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*r + 14*D1**2*b2*fd*s**2 - 28*D1**2*b2*fd*s + 14*D1**2*b2*fd - 42*D1**2*b2*fdd*r**2 - 84*D1**2*b2*fdd*r*s + 84*D1**2*b2*fdd*r - 42*D1**2*b2*fdd*s**2 + 84*D1**2*b2*fdd*s - 42*D1**2*b2*fdd + 14*D1**2*bd1**2*(-10*K*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 75*r**2 + 90*r*s - 80*r + 15*s**2 - 40*s + 15) - 336*D1**2*bdd1*f**2*r**2 - 336*D1**2*bdd1*f**2*r*s + 630*D1**2*bdd1*f**2*r + 378*D1**2*bdd1*f**2*s - 231*D1**2*bdd1*f**2 + 154*D1**2*bdd1*f*r**2 + 196*D1**2*bdd1*f*r*s + 644*D1**2*bdd1*f*r + 42*D1**2*bdd1*f*s**2 + 616*D1**2*bdd1*f*s - 420*D1**2*bdd1*f + 560*D1**2*bdd1*g2*r**2 + 560*D1**2*bdd1*g2*r*s - 280*D1**2*bdd1*g2*r - 42*D1**2*bdd2*f*r**2 - 84*D1**2*bdd2*f*r*s + 84*D1**2*bdd2*f*r - 42*D1**2*bdd2*f*s**2 + 84*D1**2*bdd2*f*s - 42*D1**2*bdd2*f + 594*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s - 222*D1**2*f*fd*r - 654*D1**2*f*fd*s**2 + 930*D1**2*f*fd*s - 111*D1**2*f*fd - 24*D1**2*f*fdd*r**2 + 576*D1**2*f*fdd*r*s - 666*D1**2*f*fdd*r + 600*D1**2*f*fdd*s**2 - 1158*D1**2*f*fdd*s + 423*D1**2*f*fdd + 336*D1**2*f*gd2*r**2 - 728*D1**2*f*gd2*r*s - 672*D1**2*f*gd2*r - 1064*D1**2*f*gd2*s**2 + 728*D1**2*f*gd2*s + 336*D1**2*f*gd2 + 392*D1**2*f*gdd2*r**2 + 1344*D1**2*f*gdd2*r*s - 784*D1**2*f*gdd2*r + 952*D1**2*f*gdd2*s**2 - 1344*D1**2*f*gdd2*s + 392*D1**2*f*gdd2 - 24*D1**2*fd**2*r**2 + 576*D1**2*fd**2*r*s - 666*D1**2*fd**2*r + 600*D1**2*fd**2*s**2 - 1158*D1**2*fd**2*s + 690*D1**2*fd**2 + 336*D1**2*fd*g2*r**2 - 728*D1**2*fd*g2*r*s + 728*D1**2*fd*g2*r - 1064*D1**2*fd*g2*s**2 + 2128*D1**2*fd*g2*s - 1064*D1**2*fd*g2 + 784*D1**2*fd*gd2*r**2 + 2688*D1**2*fd*gd2*r*s - 2128*D1**2*fd*gd2*r + 1904*D1**2*fd*gd2*s**2 - 3248*D1**2*fd*gd2*s + 1344*D1**2*fd*gd2 + 392*D1**2*fdd*g2*r**2 + 1344*D1**2*fdd*g2*r*s - 1344*D1**2*fdd*g2*r + 952*D1**2*fdd*g2*s**2 - 1904*D1**2*fdd*g2*s + 952*D1**2*fdd*g2 - 504*D1*Dd*K*f**2*r**2 - 2688*D1*Dd*K*f**2*r*s + 1176*D1*Dd*K*f**2*r - 2184*D1*Dd*K*f**2*s**2 + 2436*D1*Dd*K*f**2*s - 798*D1*Dd*K*f**2 + 3360*D1*Dd*K*f*fd*r**2 + 10752*D1*Dd*K*f*fd*r*s - 5712*D1*Dd*K*f*fd*r + 7392*D1*Dd*K*f*fd*s**2 - 8232*D1*Dd*K*f*fd*s + 2268*D1*Dd*K*f*fd + 56*D1*Dd*b2*f*r**2 + 112*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 56*D1*Dd*b2*f*s**2 - 84*D1*Dd*b2*f*s + 42*D1*Dd*b2*f - 336*D1*Dd*b2*fd*r**2 - 672*D1*Dd*b2*fd*r*s + 588*D1*Dd*b2*fd*r - 336*D1*Dd*b2*fd*s**2 + 588*D1*Dd*b2*fd*s - 252*D1*Dd*b2*fd + 1188*D1*Dd*f**2*r**2 - 120*D1*Dd*f**2*r*s - 1158*D1*Dd*f**2*r - 1308*D1*Dd*f**2*s**2 + 714*D1*Dd*f**2*s + 267*D1*Dd*f**2 - 192*D1*Dd*f*fd*r**2 + 4608*D1*Dd*f*fd*r*s - 3144*D1*Dd*f*fd*r + 4800*D1*Dd*f*fd*s**2 - 6984*D1*Dd*f*fd*s + 2490*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r**2 - 2912*D1*Dd*f*g2*r*s - 616*D1*Dd*f*g2*r - 4256*D1*Dd*f*g2*s**2 + 3584*D1*Dd*f*g2*s - 392*D1*Dd*f*g2 + 3136*D1*Dd*f*gd2*r**2 + 10752*D1*Dd*f*gd2*r*s - 6048*D1*Dd*f*gd2*r + 7616*D1*Dd*f*gd2*s**2 - 9968*D1*Dd*f*gd2*s + 2912*D1*Dd*f*gd2 + 3136*D1*Dd*fd*g2*r**2 + 10752*D1*Dd*fd*g2*r*s - 8288*D1*Dd*fd*g2*r + 7616*D1*Dd*fd*g2*s**2 - 12208*D1*Dd*fd*g2*s + 4592*D1*Dd*fd*g2 + 840*D1*Ddd*K*f**2*r**2 + 2688*D1*Ddd*K*f**2*r*s - 1512*D1*Ddd*K*f**2*r + 1848*D1*Ddd*K*f**2*s**2 - 2268*D1*Ddd*K*f**2*s + 882*D1*Ddd*K*f**2 - 168*D1*Ddd*b2*f*r**2 - 336*D1*Ddd*b2*f*r*s + 252*D1*Ddd*b2*f*r - 168*D1*Ddd*b2*f*s**2 + 252*D1*Ddd*b2*f*s - 126*D1*Ddd*b2*f - 48*D1*Ddd*f**2*r**2 + 1152*D1*Ddd*f**2*r*s - 240*D1*Ddd*f**2*r + 1200*D1*Ddd*f**2*s**2 - 1176*D1*Ddd*f**2*s + 276*D1*Ddd*f**2 + 1568*D1*Ddd*f*g2*r**2 + 5376*D1*Ddd*f*g2*r*s - 2912*D1*Ddd*f*g2*r + 3808*D1*Ddd*f*g2*s**2 - 4592*D1*Ddd*f*g2*s + 1736*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(3*f**2*(9*r**2 + 2*r*(5*s - 8) + s**2 - 12*s + 7) - f*(-80*C*r**2 - 80*C*r*s + 40*C*r + 2*K*(12*r**2 - 2*r*(13*s + 6) - 38*s**2 + 13*s + 6) + 6*fd*(16*r**2 + 4*r*(4*s - 5) - 8*s + 5) + 17*r**2 + 18*r*s + 62*r + s**2 + 68*s - 50) - 2*fd*(10*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + K*(28*r**2 + 96*r*s - 62*r + 68*s**2 - 92*s + 24) - 11*r**2 - 14*r*s + 41*r - 3*s**2 + 32*s - 22) - 40*g2*r*(2*r + 2*s - 1) + 20*gd2*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*(-3*f**2*(16*r - 13)*(4*r + 4*s - 3) - 2*f*(20*C*(8*r**2 + r*(8*s - 7) - 2*s + 1) + 4*K*(28*r**2 + 96*r*s - 40*r + 68*s**2 - 65*s + 13) - 44*r**2 - 56*r*s - 63*r - 12*s**2 - 71*s + 68) + 40*g2*(8*r**2 + r*(8*s - 7) - 2*s + 1))) + 14*D1*bd2*(D1*(f - 6*fd)*(r + s - 1) - 6*Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 2520*Dd**2*K*f**2*r**2 + 8064*Dd**2*K*f**2*r*s - 4536*Dd**2*K*f**2*r + 5544*Dd**2*K*f**2*s**2 - 6804*Dd**2*K*f**2*s + 1764*Dd**2*K*f**2 - 504*Dd**2*b2*f*r**2 - 1008*Dd**2*b2*f*r*s + 756*Dd**2*b2*f*r - 504*Dd**2*b2*f*s**2 + 756*Dd**2*b2*f*s - 252*Dd**2*b2*f - 144*Dd**2*f**2*r**2 + 3456*Dd**2*f**2*r*s - 720*Dd**2*f**2*r + 3600*Dd**2*f**2*s**2 - 3528*Dd**2*f**2*s + 552*Dd**2*f**2 + 4704*Dd**2*f*g2*r**2 + 16128*Dd**2*f*g2*r*s - 8736*Dd**2*f*g2*r + 11424*Dd**2*f*g2*s**2 - 13776*Dd**2*f*g2*s + 3472*Dd**2*f*g2))/(210*d**2*k3**3) + 8*D1**2*Pk2*Pkd3*ct**3*k1*st**2*(-D1*f*(D1*bd1**2*s*(5*f + 7)*(2*r + 2*s - 1) + 3*D1*bdd1*f*s*(r + s) + 3*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1)))) + b1**2*(-D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) - 2*fd*(10*f*s - 5*f + 7*s - 7) + fdd*(10*f*s - 5*f + 7*s - 7)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 14*r*(4*s - 1) + 14*(1 - 2*s)**2) - 7*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(5*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(7*bdd1*s*(2*r + 2*s - 1) - 6*fd*(2*s - 1)*(r + s - 1) + 3*fdd*(2*s - 1)*(r + s - 1)) + 3*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + 2*f*s*(5*f + 7)*(2*r + 2*s - 1) - 7*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - Dd*f*(5*f + 7)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 3*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(6 - 16*s) - 16*s**2 + 20*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k2*k3) + D1**2*Pk2*Pkd3*ct**3*k1*(D1*(14*D1*bd1**2*f*(r**2*(9*f + 11) + r*(f*(30*s - 9) + s*(12*K + 30) - 5) + s*(6*K*(2*s - 1) + 3*f*(7*s - 5) + 19*s - 9)) + 3*D1*bdd1*f*(r + s)*(5*f*(5*r + s*(8*C + 5)) + s*(28*b2 - 56*g2)) + bd1*(-D1*(3*f**2*(r + s)*(15*r + s*(24*C + 71)) - 4*f*(15*fd*(5*r**2 + r*(8*C*s - 2*C + 10*s - 5) + s*(8*C*s - 6*C + 5*s - 5)) + 7*s*(bd2*(6*r + 6*s - 3) + 2*g2*(r + s) - 6*gd2*(2*r + 2*s - 1))) + 168*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 6*Dd*f*(5*f*(20*r**2 + r*(32*C*s - 4*C + 40*s - 15) + s*(32*C*s - 16*C + 20*s - 15)) - 28*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 28*b2*(D1*(-f*s*(r + s) + fd*r*(6*s - 3) + 6*fd*s*(s - 1)) + 3*Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 28*b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 10*r*(4*s - 1) + 10*(1 - 2*s)**2) - D1*Ddd*(3*f + 5)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(3*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(-4*D1**2*K*fd*r*s + 4*D1**2*K*fd*r - 4*D1**2*K*fd*s**2 + 8*D1**2*K*fd*s - 4*D1**2*K*fd + 12*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r + 12*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 4*D1**2*bdd1*(3*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 6*D1**2*f*fd*r**2 - 84*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 78*D1**2*f*fd*s**2 + 120*D1**2*f*fd*s - 42*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 48*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 30*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 48*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s + 30*D1**2*fd**2 + 3*D1**2*fd*r**2 - 30*D1**2*fd*r*s + 54*D1**2*fd*r - 33*D1**2*fd*s**2 + 90*D1**2*fd*s - 57*D1**2*fd + 11*D1**2*fdd*r**2 + 30*D1**2*fdd*r*s - 42*D1**2*fdd*r + 19*D1**2*fdd*s**2 - 50*D1**2*fdd*s + 31*D1**2*fdd - 16*D1*Dd*K*f*r*s + 4*D1*Dd*K*f*r - 16*D1*Dd*K*f*s**2 + 16*D1*Dd*K*f*s - 4*D1*Dd*K*f + 96*D1*Dd*K*fd*r*s - 60*D1*Dd*K*fd*r + 96*D1*Dd*K*fd*s**2 - 144*D1*Dd*K*fd*s + 48*D1*Dd*K*fd - 12*D1*Dd*f**2*r**2 - 168*D1*Dd*f**2*r*s + 54*D1*Dd*f**2*r - 156*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 45*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 324*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 492*D1*Dd*f*fd*s + 168*D1*Dd*f*fd + 12*D1*Dd*f*r**2 - 120*D1*Dd*f*r*s + 18*D1*Dd*f*r - 132*D1*Dd*f*s**2 + 126*D1*Dd*f*s - 27*D1*Dd*f + 88*D1*Dd*fd*r**2 + 240*D1*Dd*fd*r*s - 242*D1*Dd*fd*r + 152*D1*Dd*fd*s**2 - 298*D1*Dd*fd*s + 134*D1*Dd*fd + 48*D1*Ddd*K*f*r*s - 12*D1*Ddd*K*f*r + 48*D1*Ddd*K*f*s**2 - 48*D1*Ddd*K*f*s + 12*D1*Ddd*K*f + 36*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 66*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 102*D1*Ddd*f**2*s + 39*D1*Ddd*f**2 + 44*D1*Ddd*f*r**2 + 120*D1*Ddd*f*r*s - 74*D1*Ddd*f*r + 76*D1*Ddd*f*s**2 - 98*D1*Ddd*f*s + 41*D1*Ddd*f + 4*D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + 30*r*s - 10*r + 30*s**2 - 30*s + 10) - Dd*(3*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 144*Dd**2*K*f*r*s - 36*Dd**2*K*f*r + 144*Dd**2*K*f*s**2 - 144*Dd**2*K*f*s + 24*Dd**2*K*f + 108*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 198*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 306*Dd**2*f**2*s + 78*Dd**2*f**2 + 132*Dd**2*f*r**2 + 360*Dd**2*f*r*s - 222*Dd**2*f*r + 228*Dd**2*f*s**2 - 294*Dd**2*f*s + 82*Dd**2*f) + b1*(-144*C*D1**2*f*fd*r*s + 72*C*D1**2*f*fd*r - 144*C*D1**2*f*fd*s**2 + 216*C*D1**2*f*fd*s - 72*C*D1**2*f*fd + 240*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 240*C*D1**2*f*fdd*s**2 - 360*C*D1**2*f*fdd*s + 120*C*D1**2*f*fdd + 240*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 240*C*D1**2*fd**2*s**2 - 360*C*D1**2*fd**2*s + 120*C*D1**2*fd**2 - 288*C*D1*Dd*f**2*r*s + 72*C*D1*Dd*f**2*r - 288*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 1920*C*D1*Dd*f*fd*r*s - 720*C*D1*Dd*f*fd*r + 1920*C*D1*Dd*f*fd*s**2 - 2400*C*D1*Dd*f*fd*s + 600*C*D1*Dd*f*fd + 480*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 480*C*D1*Ddd*f**2*s**2 - 480*C*D1*Ddd*f**2*s + 120*C*D1*Ddd*f**2 + 1440*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 1440*C*Dd**2*f**2*s**2 - 1440*C*Dd**2*f**2*s + 240*C*Dd**2*f**2 - 28*D1**2*b2*fd*r*s + 28*D1**2*b2*fd*r - 28*D1**2*b2*fd*s**2 + 56*D1**2*b2*fd*s - 28*D1**2*b2*fd + 84*D1**2*b2*fdd*r*s - 84*D1**2*b2*fdd*r + 84*D1**2*b2*fdd*s**2 - 168*D1**2*b2*fdd*s + 84*D1**2*b2*fdd - 28*D1**2*bd1**2*(3*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 28*D1**2*bd2*f*r*s - 28*D1**2*bd2*f*s**2 + 28*D1**2*bd2*f*s + 168*D1**2*bd2*fd*r*s - 84*D1**2*bd2*fd*r + 168*D1**2*bd2*fd*s**2 - 252*D1**2*bd2*fd*s + 84*D1**2*bd2*fd + 7*D1**2*bdd1*f*(24*K*s**2 - 12*K*s + 3*f*(6*r**2 + r*(20*s - 6) + 14*s**2 - 10*s + 3) + 22*r**2 + 2*r*(s*(12*K + 30) - 5) + 38*s**2 - 18*s - 1) + 84*D1**2*bdd2*f*r*s + 84*D1**2*bdd2*f*s**2 - 84*D1**2*bdd2*f*s - 90*D1**2*f*fd*r**2 - 516*D1**2*f*fd*r*s + 348*D1**2*f*fd*r - 426*D1**2*f*fd*s**2 + 684*D1**2*f*fd*s - 258*D1**2*f*fd + 150*D1**2*f*fdd*r**2 + 300*D1**2*f*fdd*r*s - 300*D1**2*f*fdd*r + 150*D1**2*f*fdd*s**2 - 300*D1**2*f*fdd*s + 150*D1**2*f*fdd + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s + 150*D1**2*fd**2*r**2 + 300*D1**2*fd**2*r*s - 300*D1**2*fd**2*r + 150*D1**2*fd**2*s**2 - 300*D1**2*fd**2*s + 150*D1**2*fd**2 + 56*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 56*D1**2*fd*g2*s**2 - 112*D1**2*fd*g2*s + 56*D1**2*fd*g2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s**2 + 504*D1**2*fd*gd2*s - 168*D1**2*fd*gd2 - 168*D1**2*fdd*g2*r*s + 168*D1**2*fdd*g2*r - 168*D1**2*fdd*g2*s**2 + 336*D1**2*fdd*g2*s - 168*D1**2*fdd*g2 - 112*D1*Dd*b2*f*r*s + 28*D1*Dd*b2*f*r - 112*D1*Dd*b2*f*s**2 + 112*D1*Dd*b2*f*s - 28*D1*Dd*b2*f + 672*D1*Dd*b2*fd*r*s - 420*D1*Dd*b2*fd*r + 672*D1*Dd*b2*fd*s**2 - 1008*D1*Dd*b2*fd*s + 336*D1*Dd*b2*fd + 672*D1*Dd*bd2*f*r*s - 84*D1*Dd*bd2*f*r + 672*D1*Dd*bd2*f*s**2 - 672*D1*Dd*bd2*f*s + 84*D1*Dd*bd2*f - 180*D1*Dd*f**2*r**2 - 1032*D1*Dd*f**2*r*s + 438*D1*Dd*f**2*r - 852*D1*Dd*f**2*s**2 + 942*D1*Dd*f**2*s - 303*D1*Dd*f**2 + 1200*D1*Dd*f*fd*r**2 + 2400*D1*Dd*f*fd*r*s - 2100*D1*Dd*f*fd*r + 1200*D1*Dd*f*fd*s**2 - 2100*D1*Dd*f*fd*s + 900*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 1344*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r*s + 840*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s - 672*D1*Dd*fd*g2 + 336*D1*Ddd*b2*f*r*s - 84*D1*Ddd*b2*f*r + 336*D1*Ddd*b2*f*s**2 - 336*D1*Ddd*b2*f*s + 84*D1*Ddd*b2*f + 300*D1*Ddd*f**2*r**2 + 600*D1*Ddd*f**2*r*s - 450*D1*Ddd*f**2*r + 300*D1*Ddd*f**2*s**2 - 450*D1*Ddd*f**2*s + 225*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 672*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(f**2*(6*r**2 + r*(84*s - 6) + 78*s**2 - 42*s + 3) + f*(8*K*s**2 - 4*K*s - 12*fd*(6*r**2 + r*(20*s - 11) + 14*s**2 - 17*s + 4) - 6*r**2 + r*(8*K*s + 60*s + 30) + 66*s**2 - 6*s - 27) - 2*fd*(6*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 22*r**2 + r*(60*s - 47) + 38*s**2 - 59*s + 15)) - 2*Dd*f*(6*K*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 3*f*(24*r**2 + r*(80*s - 34) + 56*s**2 - 54*s + 11) + 88*r**2 + 240*r*s - 94*r + 152*s**2 - 134*s + 19)) + 1008*Dd**2*b2*f*r*s - 252*Dd**2*b2*f*r + 1008*Dd**2*b2*f*s**2 - 1008*Dd**2*b2*f*s + 168*Dd**2*b2*f + 900*Dd**2*f**2*r**2 + 1800*Dd**2*f**2*r*s - 1350*Dd**2*f**2*r + 900*Dd**2*f**2*s**2 - 1350*Dd**2*f**2*s + 450*Dd**2*f**2 - 2016*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 2016*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(210*d**2*k2*k3) - D1**2*Pk2*Pkd3*ct**3*k2**5*(8*C - 4)*(D1*f*(-D1*bdd1*f*r*(r + s - 1) + bd1*(2*D1*f*r*(r + s - 1) + D1*fd*(-4*r**2 - 4*r*(s - 1) + s - 1) + Dd*f*(-8*r**2 - 8*r*s + 9*r + 2*s - 2))) + b1*(D1**2*(f*(2*fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-2*r**2 - 2*r*(s - 1) + s)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - Dd*fd*(2*r - 1)*(8*r + 8*s - 5) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)))/(35*d**2*k1*k3**5) + D1**2*Pk2*Pkd3*ct**3*k2*(8*C - 4)*(D1*f*(D1*bd1*(2*f*r*(r + s) + fd*(-4*r**2 + r*(3 - 4*s) + s)) - D1*bdd1*f*r*(r + s) + Dd*bd1*f*(-8*r**2 + r*(5 - 8*s) + 2*s)) + b1*(D1**2*(2*r - 1)*(r + s - 1)*(2*f*fd - f*fdd - fd**2) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - Dd*fd*(2*r - 1)*(8*r + 8*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)))/(35*d**2*k1*k3) + 4*D1**2*Pk2*Pkd3*ct**2*f**2*k1**6*st**2*(D1**2*(f*(17*fd - 14*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 14*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(17*f*(r*(4*s - 1) + (1 - 2*s)**2) - 28*fd*(4*s - 1)*(4*r + 4*s - 3)) - 14*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 14*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k2**2*k3**5) + D1**2*Pk2*Pkd3*ct**2*f*k1**6*(30*D1**2*b1*f*fd*r*s + 30*D1**2*b1*f*fd*s**2 - 20*D1**2*b1*f*fd*s - 42*D1**2*b1*f*fdd*r*s - 42*D1**2*b1*f*fdd*s**2 + 28*D1**2*b1*f*fdd*s - 84*D1**2*b1*fd**2*r*s - 84*D1**2*b1*fd**2*s**2 + 56*D1**2*b1*fd**2*s - 14*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) - 84*D1**2*f**2*fd*r*s + 21*D1**2*f**2*fd*r - 84*D1**2*f**2*fd*s**2 + 84*D1**2*f**2*fd*s - 21*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r*s - 21*D1**2*f**2*fdd*r + 84*D1**2*f**2*fdd*s**2 - 84*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd + 252*D1**2*f*fd**2*r*s - 63*D1**2*f*fd**2*r + 252*D1**2*f*fd**2*s**2 - 252*D1**2*f*fd**2*s + 42*D1**2*f*fd**2 + 40*D1*Dd*b1*f**2*r*s - 10*D1*Dd*b1*f**2*r + 40*D1*Dd*b1*f**2*s**2 - 40*D1*Dd*b1*f**2*s + 10*D1*Dd*b1*f**2 - 336*D1*Dd*b1*f*fd*r*s + 42*D1*Dd*b1*f*fd*r - 336*D1*Dd*b1*f*fd*s**2 + 280*D1*Dd*b1*f*fd*s - 28*D1*Dd*b1*f*fd - 84*D1*Dd*f**3*r*s + 21*D1*Dd*f**3*r - 84*D1*Dd*f**3*s**2 + 84*D1*Dd*f**3*s - 21*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r*s - 168*D1*Dd*f**2*fd*r + 672*D1*Dd*f**2*fd*s**2 - 672*D1*Dd*f**2*fd*s + 126*D1*Dd*f**2*fd - 56*D1*Ddd*b1*f**2*r*s + 14*D1*Ddd*b1*f**2*r - 56*D1*Ddd*b1*f**2*s**2 + 56*D1*Ddd*b1*f**2*s - 14*D1*Ddd*b1*f**2 + 84*D1*Ddd*f**3*r*s - 21*D1*Ddd*f**3*r + 84*D1*Ddd*f**3*s**2 - 84*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 + 2*D1*bd1*f*(D1*(5*f*(s - 1)*(r + s - 1) - 7*fd*(6*r*s - 3*r + 6*s**2 - 8*s + 2)) - 7*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 168*Dd**2*b1*f**2*r*s + 42*Dd**2*b1*f**2*r - 168*Dd**2*b1*f**2*s**2 + 168*Dd**2*b1*f**2*s - 28*Dd**2*b1*f**2 + 252*Dd**2*f**3*r*s - 63*Dd**2*f**3*r + 252*Dd**2*f**3*s**2 - 252*Dd**2*f**3*s + 42*Dd**2*f**3)/(63*d**2*k2**2*k3**5) + D1**2*Pk2*Pkd3*ct**2*k1**6*st**2*(66*C*D1**2*f**2*fd*r**2 + 132*C*D1**2*f**2*fd*r*s - 88*C*D1**2*f**2*fd*r + 66*C*D1**2*f**2*fd*s**2 - 88*C*D1**2*f**2*fd*s + 44*C*D1**2*f**2*fd - 330*C*D1**2*f**2*fdd*r**2 - 660*C*D1**2*f**2*fdd*r*s + 440*C*D1**2*f**2*fdd*r - 330*C*D1**2*f**2*fdd*s**2 + 440*C*D1**2*f**2*fdd*s - 220*C*D1**2*f**2*fdd - 660*C*D1**2*f*fd**2*r**2 - 1320*C*D1**2*f*fd**2*r*s + 880*C*D1**2*f*fd**2*r - 660*C*D1**2*f*fd**2*s**2 + 880*C*D1**2*f*fd**2*s - 220*C*D1**2*f*fd**2 + 88*C*D1*Dd*f**3*r**2 + 176*C*D1*Dd*f**3*r*s - 132*C*D1*Dd*f**3*r + 88*C*D1*Dd*f**3*s**2 - 132*C*D1*Dd*f**3*s + 66*C*D1*Dd*f**3 - 2640*C*D1*Dd*f**2*fd*r**2 - 5280*C*D1*Dd*f**2*fd*r*s + 3740*C*D1*Dd*f**2*fd*r - 2640*C*D1*Dd*f**2*fd*s**2 + 3740*C*D1*Dd*f**2*fd*s - 1320*C*D1*Dd*f**2*fd - 440*C*D1*Ddd*f**3*r**2 - 880*C*D1*Ddd*f**3*r*s + 660*C*D1*Ddd*f**3*r - 440*C*D1*Ddd*f**3*s**2 + 660*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 1320*C*Dd**2*f**3*r**2 - 2640*C*Dd**2*f**3*r*s + 1980*C*Dd**2*f**3*r - 1320*C*Dd**2*f**3*s**2 + 1980*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 66*D1**2*K*b1*f*fd*r**2 - 132*D1**2*K*b1*f*fd*r*s + 66*D1**2*K*b1*f*fd*r - 66*D1**2*K*b1*f*fd*s**2 + 66*D1**2*K*b1*f*fd*s - 33*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 396*D1**2*K*b1*f*fdd*r*s + 198*D1**2*K*b1*f*fdd*r - 198*D1**2*K*b1*f*fdd*s**2 + 198*D1**2*K*b1*f*fdd*s - 99*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 396*D1**2*K*b1*fd**2*r*s + 198*D1**2*K*b1*fd**2*r - 198*D1**2*K*b1*fd**2*s**2 + 198*D1**2*K*b1*fd**2*s + 66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 66*D1**2*b1*f*fd*s + 33*D1**2*b1*f*fd + 198*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 198*D1**2*b1*f*fdd*s**2 - 198*D1**2*b1*f*fdd*s + 99*D1**2*b1*f*fdd + 198*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 198*D1**2*b1*fd**2*s**2 - 198*D1**2*b1*fd**2*s - 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 3120*D1**2*f**3*fd*r**2 + 6240*D1**2*f**3*fd*r*s - 4680*D1**2*f**3*fd*r + 3120*D1**2*f**3*fd*s**2 - 4680*D1**2*f**3*fd*s + 2340*D1**2*f**3*fd - 4200*D1**2*f**3*fdd*r**2 - 8400*D1**2*f**3*fdd*r*s + 6300*D1**2*f**3*fdd*r - 4200*D1**2*f**3*fdd*s**2 + 6300*D1**2*f**3*fdd*s - 3150*D1**2*f**3*fdd - 12600*D1**2*f**2*fd**2*r**2 - 25200*D1**2*f**2*fd**2*r*s + 18900*D1**2*f**2*fd**2*r - 12600*D1**2*f**2*fd**2*s**2 + 18900*D1**2*f**2*fd**2*s - 6300*D1**2*f**2*fd**2 - 66*D1**2*f**2*fd*r**2 - 132*D1**2*f**2*fd*r*s + 88*D1**2*f**2*fd*r - 66*D1**2*f**2*fd*s**2 + 88*D1**2*f**2*fd*s - 44*D1**2*f**2*fd + 330*D1**2*f**2*fdd*r**2 + 660*D1**2*f**2*fdd*r*s - 440*D1**2*f**2*fdd*r + 330*D1**2*f**2*fdd*s**2 - 440*D1**2*f**2*fdd*s + 220*D1**2*f**2*fdd + 66*D1**2*f**2*gd2*r**2 + 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*r + 66*D1**2*f**2*gd2*s**2 - 132*D1**2*f**2*gd2*s + 66*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 396*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 660*D1**2*f*fd**2*r**2 + 1320*D1**2*f*fd**2*r*s - 880*D1**2*f*fd**2*r + 660*D1**2*f*fd**2*s**2 - 880*D1**2*f*fd**2*s + 220*D1**2*f*fd**2 + 132*D1**2*f*fd*g2*r**2 + 264*D1**2*f*fd*g2*r*s - 132*D1**2*f*fd*g2*r + 132*D1**2*f*fd*g2*s**2 - 132*D1**2*f*fd*g2*s + 66*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1584*D1**2*f*fd*gd2*r*s - 1188*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1188*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s - 132*D1*Dd*K*b1*f**2*r**2 - 264*D1*Dd*K*b1*f**2*r*s + 198*D1*Dd*K*b1*f**2*r - 132*D1*Dd*K*b1*f**2*s**2 + 198*D1*Dd*K*b1*f**2*s - 99*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 3168*D1*Dd*K*b1*f*fd*r*s + 1980*D1*Dd*K*b1*f*fd*r - 1584*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 594*D1*Dd*K*b1*f*fd + 132*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 198*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2*s**2 - 198*D1*Dd*b1*f**2*s + 99*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r + 1584*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s + 594*D1*Dd*b1*f*fd + 3120*D1*Dd*f**4*r**2 + 6240*D1*Dd*f**4*r*s - 4680*D1*Dd*f**4*r + 3120*D1*Dd*f**4*s**2 - 4680*D1*Dd*f**4*s + 2340*D1*Dd*f**4 - 33600*D1*Dd*f**3*fd*r**2 - 67200*D1*Dd*f**3*fd*r*s + 50400*D1*Dd*f**3*fd*r - 33600*D1*Dd*f**3*fd*s**2 + 50400*D1*Dd*f**3*fd*s - 18900*D1*Dd*f**3*fd - 88*D1*Dd*f**3*r**2 - 176*D1*Dd*f**3*r*s + 132*D1*Dd*f**3*r - 88*D1*Dd*f**3*s**2 + 132*D1*Dd*f**3*s - 66*D1*Dd*f**3 + 2640*D1*Dd*f**2*fd*r**2 + 5280*D1*Dd*f**2*fd*r*s - 3740*D1*Dd*f**2*fd*r + 2640*D1*Dd*f**2*fd*s**2 - 3740*D1*Dd*f**2*fd*s + 1320*D1*Dd*f**2*fd + 264*D1*Dd*f**2*g2*r**2 + 528*D1*Dd*f**2*g2*r*s - 396*D1*Dd*f**2*g2*r + 264*D1*Dd*f**2*g2*s**2 - 396*D1*Dd*f**2*g2*s + 198*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 3168*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 1188*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 6336*D1*Dd*f*fd*g2*r*s - 3960*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 1188*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 792*D1*Ddd*K*b1*f**2*r*s + 594*D1*Ddd*K*b1*f**2*r - 396*D1*Ddd*K*b1*f**2*s**2 + 594*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 396*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 396*D1*Ddd*b1*f**2*s**2 - 594*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 - 4200*D1*Ddd*f**4*r**2 - 8400*D1*Ddd*f**4*r*s + 6300*D1*Ddd*f**4*r - 4200*D1*Ddd*f**4*s**2 + 6300*D1*Ddd*f**4*s - 3150*D1*Ddd*f**4 + 440*D1*Ddd*f**3*r**2 + 880*D1*Ddd*f**3*r*s - 660*D1*Ddd*f**3*r + 440*D1*Ddd*f**3*s**2 - 660*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1584*D1*Ddd*f**2*g2*r*s - 1188*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1188*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 - 33*D1*bd1*f*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) + 6*D1*fd*(2*r + 2*s - 1) + 6*Dd*f*(4*r + 4*s - 3)) - 1188*Dd**2*K*b1*f**2*r**2 - 2376*Dd**2*K*b1*f**2*r*s + 1782*Dd**2*K*b1*f**2*r - 1188*Dd**2*K*b1*f**2*s**2 + 1782*Dd**2*K*b1*f**2*s - 594*Dd**2*K*b1*f**2 + 1188*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 1188*Dd**2*b1*f**2*s**2 - 1782*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 - 12600*Dd**2*f**4*r**2 - 25200*Dd**2*f**4*r*s + 18900*Dd**2*f**4*r - 12600*Dd**2*f**4*s**2 + 18900*Dd**2*f**4*s - 6300*Dd**2*f**4 + 1320*Dd**2*f**3*r**2 + 2640*Dd**2*f**3*r*s - 1980*Dd**2*f**3*r + 1320*Dd**2*f**3*s**2 - 1980*Dd**2*f**3*s + 660*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 4752*Dd**2*f**2*g2*r*s - 3564*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3564*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2)/(770*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**2*k1**6*(-2*D1*(r + s - 1)*(63*D1*bd1**2*f*(K - 1)*(r + s - 1) - D1*bd1*(50*f**3*(r + s - 1) + f**2*(27*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) - 27*r - 27*s + 27) - 3*f*(fd*(30*C - 30)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 126*fd*g2*(r + s)) + D1*bdd1*f*(70*f**2 + f*(45*C - 45) - 63*g2)*(r + s - 1) + 2*Dd*bd1*f*(70*f**2 + f*(45*C - 45) - 63*g2)*(4*r + 4*s - 3)) + 21*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(r + s)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(54*C*D1**2*f*fd*r**2 + 108*C*D1**2*f*fd*r*s - 54*C*D1**2*f*fd*r + 54*C*D1**2*f*fd*s**2 - 54*C*D1**2*f*fd*s + 27*C*D1**2*f*fd - 90*C*D1**2*f*fdd*r**2 - 180*C*D1**2*f*fdd*r*s + 90*C*D1**2*f*fdd*r - 90*C*D1**2*f*fdd*s**2 + 90*C*D1**2*f*fdd*s - 45*C*D1**2*f*fdd - 90*C*D1**2*fd**2*r**2 - 180*C*D1**2*fd**2*r*s + 90*C*D1**2*fd**2*r - 90*C*D1**2*fd**2*s**2 + 90*C*D1**2*fd**2*s + 108*C*D1*Dd*f**2*r**2 + 216*C*D1*Dd*f**2*r*s - 162*C*D1*Dd*f**2*r + 108*C*D1*Dd*f**2*s**2 - 162*C*D1*Dd*f**2*s + 81*C*D1*Dd*f**2 - 720*C*D1*Dd*f*fd*r**2 - 1440*C*D1*Dd*f*fd*r*s + 900*C*D1*Dd*f*fd*r - 720*C*D1*Dd*f*fd*s**2 + 900*C*D1*Dd*f*fd*s - 270*C*D1*Dd*f*fd - 180*C*D1*Ddd*f**2*r**2 - 360*C*D1*Ddd*f**2*r*s + 270*C*D1*Ddd*f**2*r - 180*C*D1*Ddd*f**2*s**2 + 270*C*D1*Ddd*f**2*s - 135*C*D1*Ddd*f**2 - 540*C*Dd**2*f**2*r**2 - 1080*C*Dd**2*f**2*r*s + 810*C*Dd**2*f**2*r - 540*C*Dd**2*f**2*s**2 + 810*C*Dd**2*f**2*s - 270*C*Dd**2*f**2 - 63*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 150*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 - 200*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 280*D1**2*f**2*fdd*r - 210*D1**2*f**2*fdd*s**2 + 280*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 560*D1**2*f*fd**2*r - 420*D1**2*f*fd**2*s**2 + 560*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 54*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 54*D1**2*f*fd*r - 54*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 180*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 90*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 45*D1**2*f*fdd - 21*D1**2*f*gd2*r**2 - 42*D1**2*f*gd2*r*s + 42*D1**2*f*gd2*r - 21*D1**2*f*gd2*s**2 + 42*D1**2*f*gd2*s - 21*D1**2*f*gd2 + 63*D1**2*f*gdd2*r**2 + 126*D1**2*f*gdd2*r*s - 126*D1**2*f*gdd2*r + 63*D1**2*f*gdd2*s**2 - 126*D1**2*f*gdd2*s + 63*D1**2*f*gdd2 + 90*D1**2*fd**2*r**2 + 180*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 90*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 21*D1**2*fd*g2*r**2 - 42*D1**2*fd*g2*r*s - 21*D1**2*fd*g2*s**2 + 126*D1**2*fd*gd2*r**2 + 252*D1**2*fd*gd2*r*s - 126*D1**2*fd*gd2*r + 126*D1**2*fd*gd2*s**2 - 126*D1**2*fd*gd2*s + 63*D1**2*fdd*g2*r**2 + 126*D1**2*fdd*g2*r*s + 63*D1**2*fdd*g2*s**2 + 200*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 150*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2380*D1*Dd*f**2*fd*r - 1680*D1*Dd*f**2*fd*s**2 + 2380*D1*Dd*f**2*fd*s - 840*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 162*D1*Dd*f**2*r - 108*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1440*D1*Dd*f*fd*r*s - 900*D1*Dd*f*fd*r + 720*D1*Dd*f*fd*s**2 - 900*D1*Dd*f*fd*s + 270*D1*Dd*f*fd - 84*D1*Dd*f*g2*r**2 - 168*D1*Dd*f*g2*r*s + 126*D1*Dd*f*g2*r - 84*D1*Dd*f*g2*s**2 + 126*D1*Dd*f*g2*s - 63*D1*Dd*f*g2 + 504*D1*Dd*f*gd2*r**2 + 1008*D1*Dd*f*gd2*r*s - 882*D1*Dd*f*gd2*r + 504*D1*Dd*f*gd2*s**2 - 882*D1*Dd*f*gd2*s + 378*D1*Dd*f*gd2 + 504*D1*Dd*fd*g2*r**2 + 1008*D1*Dd*fd*g2*r*s - 378*D1*Dd*fd*g2*r + 504*D1*Dd*fd*g2*s**2 - 378*D1*Dd*fd*g2*s - 280*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s**2 + 420*D1*Ddd*f**3*s - 210*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 + 360*D1*Ddd*f**2*r*s - 270*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s**2 - 270*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 + 252*D1*Ddd*f*g2*r**2 + 504*D1*Ddd*f*g2*r*s - 378*D1*Ddd*f*g2*r + 252*D1*Ddd*f*g2*s**2 - 378*D1*Ddd*f*g2*s + 189*D1*Ddd*f*g2 + 21*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 840*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 840*Dd**2*f**3*s**2 + 1260*Dd**2*f**3*s - 420*Dd**2*f**3 + 540*Dd**2*f**2*r**2 + 1080*Dd**2*f**2*r*s - 810*Dd**2*f**2*r + 540*Dd**2*f**2*s**2 - 810*Dd**2*f**2*s + 270*Dd**2*f**2 + 756*Dd**2*f*g2*r**2 + 1512*Dd**2*f*g2*r*s - 1134*Dd**2*f*g2*r + 756*Dd**2*f*g2*s**2 - 1134*Dd**2*f*g2*s + 378*Dd**2*f*g2))/(70*d**2*k3**7) + 9*D1**2*Pk2*Pkd3*ct**2*k1**4*k2**2*st**4*(198*C*D1**2*f**2*fd*r**2 + 396*C*D1**2*f**2*fd*r*s - 264*C*D1**2*f**2*fd*r + 198*C*D1**2*f**2*fd*s**2 - 264*C*D1**2*f**2*fd*s + 132*C*D1**2*f**2*fd - 132*C*D1**2*f**2*fdd*r**2 - 264*C*D1**2*f**2*fdd*r*s + 176*C*D1**2*f**2*fdd*r - 132*C*D1**2*f**2*fdd*s**2 + 176*C*D1**2*f**2*fdd*s - 88*C*D1**2*f**2*fdd - 264*C*D1**2*f*fd**2*r**2 - 528*C*D1**2*f*fd**2*r*s + 352*C*D1**2*f*fd**2*r - 264*C*D1**2*f*fd**2*s**2 + 352*C*D1**2*f*fd**2*s - 88*C*D1**2*f*fd**2 + 264*C*D1*Dd*f**3*r**2 + 528*C*D1*Dd*f**3*r*s - 396*C*D1*Dd*f**3*r + 264*C*D1*Dd*f**3*s**2 - 396*C*D1*Dd*f**3*s + 198*C*D1*Dd*f**3 - 1056*C*D1*Dd*f**2*fd*r**2 - 2112*C*D1*Dd*f**2*fd*r*s + 1496*C*D1*Dd*f**2*fd*r - 1056*C*D1*Dd*f**2*fd*s**2 + 1496*C*D1*Dd*f**2*fd*s - 528*C*D1*Dd*f**2*fd - 176*C*D1*Ddd*f**3*r**2 - 352*C*D1*Ddd*f**3*r*s + 264*C*D1*Ddd*f**3*r - 176*C*D1*Ddd*f**3*s**2 + 264*C*D1*Ddd*f**3*s - 132*C*D1*Ddd*f**3 - 528*C*Dd**2*f**3*r**2 - 1056*C*Dd**2*f**3*r*s + 792*C*Dd**2*f**3*r - 528*C*Dd**2*f**3*s**2 + 792*C*Dd**2*f**3*s - 264*C*Dd**2*f**3 + 110*D1**2*K*b1*f*fd*r**2 + 220*D1**2*K*b1*f*fd*r*s - 110*D1**2*K*b1*f*fd*r + 110*D1**2*K*b1*f*fd*s**2 - 110*D1**2*K*b1*f*fd*s + 55*D1**2*K*b1*f*fd - 132*D1**2*K*b1*f*fdd*r**2 - 264*D1**2*K*b1*f*fdd*r*s + 132*D1**2*K*b1*f*fdd*r - 132*D1**2*K*b1*f*fdd*s**2 + 132*D1**2*K*b1*f*fdd*s - 66*D1**2*K*b1*f*fdd - 132*D1**2*K*b1*fd**2*r**2 - 264*D1**2*K*b1*fd**2*r*s + 132*D1**2*K*b1*fd**2*r - 132*D1**2*K*b1*fd**2*s**2 + 132*D1**2*K*b1*fd**2*s - 110*D1**2*b1*f*fd*r**2 - 220*D1**2*b1*f*fd*r*s + 110*D1**2*b1*f*fd*r - 110*D1**2*b1*f*fd*s**2 + 110*D1**2*b1*f*fd*s - 55*D1**2*b1*f*fd + 132*D1**2*b1*f*fdd*r**2 + 264*D1**2*b1*f*fdd*r*s - 132*D1**2*b1*f*fdd*r + 132*D1**2*b1*f*fdd*s**2 - 132*D1**2*b1*f*fdd*s + 66*D1**2*b1*f*fdd + 132*D1**2*b1*fd**2*r**2 + 264*D1**2*b1*fd**2*r*s - 132*D1**2*b1*fd**2*r + 132*D1**2*b1*fd**2*s**2 - 132*D1**2*b1*fd**2*s - 66*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 1340*D1**2*f**3*fd*r**2 + 2680*D1**2*f**3*fd*r*s - 2010*D1**2*f**3*fd*r + 1340*D1**2*f**3*fd*s**2 - 2010*D1**2*f**3*fd*s + 1005*D1**2*f**3*fd - 1000*D1**2*f**3*fdd*r**2 - 2000*D1**2*f**3*fdd*r*s + 1500*D1**2*f**3*fdd*r - 1000*D1**2*f**3*fdd*s**2 + 1500*D1**2*f**3*fdd*s - 750*D1**2*f**3*fdd - 3000*D1**2*f**2*fd**2*r**2 - 6000*D1**2*f**2*fd**2*r*s + 4500*D1**2*f**2*fd**2*r - 3000*D1**2*f**2*fd**2*s**2 + 4500*D1**2*f**2*fd**2*s - 1500*D1**2*f**2*fd**2 - 198*D1**2*f**2*fd*r**2 - 396*D1**2*f**2*fd*r*s + 264*D1**2*f**2*fd*r - 198*D1**2*f**2*fd*s**2 + 264*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 132*D1**2*f**2*fdd*r**2 + 264*D1**2*f**2*fdd*r*s - 176*D1**2*f**2*fdd*r + 132*D1**2*f**2*fdd*s**2 - 176*D1**2*f**2*fdd*s + 88*D1**2*f**2*fdd - 110*D1**2*f**2*gd2*r**2 - 220*D1**2*f**2*gd2*r*s + 220*D1**2*f**2*gd2*r - 110*D1**2*f**2*gd2*s**2 + 220*D1**2*f**2*gd2*s - 110*D1**2*f**2*gd2 + 132*D1**2*f**2*gdd2*r**2 + 264*D1**2*f**2*gdd2*r*s - 264*D1**2*f**2*gdd2*r + 132*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 132*D1**2*f**2*gdd2 + 264*D1**2*f*fd**2*r**2 + 528*D1**2*f*fd**2*r*s - 352*D1**2*f*fd**2*r + 264*D1**2*f*fd**2*s**2 - 352*D1**2*f*fd**2*s + 88*D1**2*f*fd**2 - 220*D1**2*f*fd*g2*r**2 - 440*D1**2*f*fd*g2*r*s + 220*D1**2*f*fd*g2*r - 220*D1**2*f*fd*g2*s**2 + 220*D1**2*f*fd*g2*s - 110*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r**2 + 1056*D1**2*f*fd*gd2*r*s - 792*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r**2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r**2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s + 220*D1*Dd*K*b1*f**2*r**2 + 440*D1*Dd*K*b1*f**2*r*s - 330*D1*Dd*K*b1*f**2*r + 220*D1*Dd*K*b1*f**2*s**2 - 330*D1*Dd*K*b1*f**2*s + 165*D1*Dd*K*b1*f**2 - 1056*D1*Dd*K*b1*f*fd*r**2 - 2112*D1*Dd*K*b1*f*fd*r*s + 1320*D1*Dd*K*b1*f*fd*r - 1056*D1*Dd*K*b1*f*fd*s**2 + 1320*D1*Dd*K*b1*f*fd*s - 396*D1*Dd*K*b1*f*fd - 220*D1*Dd*b1*f**2*r**2 - 440*D1*Dd*b1*f**2*r*s + 330*D1*Dd*b1*f**2*r - 220*D1*Dd*b1*f**2*s**2 + 330*D1*Dd*b1*f**2*s - 165*D1*Dd*b1*f**2 + 1056*D1*Dd*b1*f*fd*r**2 + 2112*D1*Dd*b1*f*fd*r*s - 1320*D1*Dd*b1*f*fd*r + 1056*D1*Dd*b1*f*fd*s**2 - 1320*D1*Dd*b1*f*fd*s + 396*D1*Dd*b1*f*fd + 1340*D1*Dd*f**4*r**2 + 2680*D1*Dd*f**4*r*s - 2010*D1*Dd*f**4*r + 1340*D1*Dd*f**4*s**2 - 2010*D1*Dd*f**4*s + 1005*D1*Dd*f**4 - 8000*D1*Dd*f**3*fd*r**2 - 16000*D1*Dd*f**3*fd*r*s + 12000*D1*Dd*f**3*fd*r - 8000*D1*Dd*f**3*fd*s**2 + 12000*D1*Dd*f**3*fd*s - 4500*D1*Dd*f**3*fd - 264*D1*Dd*f**3*r**2 - 528*D1*Dd*f**3*r*s + 396*D1*Dd*f**3*r - 264*D1*Dd*f**3*s**2 + 396*D1*Dd*f**3*s - 198*D1*Dd*f**3 + 1056*D1*Dd*f**2*fd*r**2 + 2112*D1*Dd*f**2*fd*r*s - 1496*D1*Dd*f**2*fd*r + 1056*D1*Dd*f**2*fd*s**2 - 1496*D1*Dd*f**2*fd*s + 528*D1*Dd*f**2*fd - 440*D1*Dd*f**2*g2*r**2 - 880*D1*Dd*f**2*g2*r*s + 660*D1*Dd*f**2*g2*r - 440*D1*Dd*f**2*g2*s**2 + 660*D1*Dd*f**2*g2*s - 330*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r**2 + 2112*D1*Dd*f**2*gd2*r*s - 1848*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1848*D1*Dd*f**2*gd2*s + 792*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r**2 + 4224*D1*Dd*f*fd*g2*r*s - 2640*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2640*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 264*D1*Ddd*K*b1*f**2*r**2 - 528*D1*Ddd*K*b1*f**2*r*s + 396*D1*Ddd*K*b1*f**2*r - 264*D1*Ddd*K*b1*f**2*s**2 + 396*D1*Ddd*K*b1*f**2*s - 198*D1*Ddd*K*b1*f**2 + 264*D1*Ddd*b1*f**2*r**2 + 528*D1*Ddd*b1*f**2*r*s - 396*D1*Ddd*b1*f**2*r + 264*D1*Ddd*b1*f**2*s**2 - 396*D1*Ddd*b1*f**2*s + 198*D1*Ddd*b1*f**2 - 1000*D1*Ddd*f**4*r**2 - 2000*D1*Ddd*f**4*r*s + 1500*D1*Ddd*f**4*r - 1000*D1*Ddd*f**4*s**2 + 1500*D1*Ddd*f**4*s - 750*D1*Ddd*f**4 + 176*D1*Ddd*f**3*r**2 + 352*D1*Ddd*f**3*r*s - 264*D1*Ddd*f**3*r + 176*D1*Ddd*f**3*s**2 - 264*D1*Ddd*f**3*s + 132*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r**2 + 1056*D1*Ddd*f**2*g2*r*s - 792*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 396*D1*Ddd*f**2*g2 + 11*D1*bd1*f*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 792*Dd**2*K*b1*f**2*r**2 - 1584*Dd**2*K*b1*f**2*r*s + 1188*Dd**2*K*b1*f**2*r - 792*Dd**2*K*b1*f**2*s**2 + 1188*Dd**2*K*b1*f**2*s - 396*Dd**2*K*b1*f**2 + 792*Dd**2*b1*f**2*r**2 + 1584*Dd**2*b1*f**2*r*s - 1188*Dd**2*b1*f**2*r + 792*Dd**2*b1*f**2*s**2 - 1188*Dd**2*b1*f**2*s + 396*Dd**2*b1*f**2 - 3000*Dd**2*f**4*r**2 - 6000*Dd**2*f**4*r*s + 4500*Dd**2*f**4*r - 3000*Dd**2*f**4*s**2 + 4500*Dd**2*f**4*s - 1500*Dd**2*f**4 + 528*Dd**2*f**3*r**2 + 1056*Dd**2*f**3*r*s - 792*Dd**2*f**3*r + 528*Dd**2*f**3*s**2 - 792*Dd**2*f**3*s + 264*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r**2 + 3168*Dd**2*f**2*g2*r*s - 2376*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 792*Dd**2*f**2*g2)/(770*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct**2*k1**4*k2**2*st**2*(-84*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 12*D1**2*bdd1*f*(3*f*(C + 2*K - 2) - 7*g2)*(r + s - 1)**2 - 2*D1**2*(15*f**3*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-fd*(29*C - 21)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(40*C - 30)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (25*gd2 - 72*gdd2)*(r + s - 1)**2) + f*(fd**2*(80*C - 60)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + fd*(25*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 144*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 72*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 144*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bd1*(D1*(36*f**3*(r + s - 1) + f**2*(58*C + 25*K - 67)*(r + s - 1) - 2*f*(36*fd*(C + 2*K - 2)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 24*Dd*f*(3*f*(C + 2*K - 2) - 7*g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(15*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(29*C - 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(fd*(80*C - 60)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 25*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 144*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 144*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2*Ddd*f*(f*(20*C - 15) - 36*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Dd**2*f**2*(f*(20*C - 15) - 36*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*b1**2*(K - 1)*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(116*C*D1**2*f*fd*r**2 + 232*C*D1**2*f*fd*r*s - 116*C*D1**2*f*fd*r + 116*C*D1**2*f*fd*s**2 - 116*C*D1**2*f*fd*s + 58*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r**2 - 144*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s**2 + 72*C*D1**2*f*fdd*s - 36*C*D1**2*f*fdd - 72*C*D1**2*fd**2*r**2 - 144*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*r - 72*C*D1**2*fd**2*s**2 + 72*C*D1**2*fd**2*s + 232*C*D1*Dd*f**2*r**2 + 464*C*D1*Dd*f**2*r*s - 348*C*D1*Dd*f**2*r + 232*C*D1*Dd*f**2*s**2 - 348*C*D1*Dd*f**2*s + 174*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r**2 - 1152*C*D1*Dd*f*fd*r*s + 720*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 720*C*D1*Dd*f*fd*s - 216*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r**2 - 288*C*D1*Ddd*f**2*r*s + 216*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 216*C*D1*Ddd*f**2*s - 108*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r**2 - 864*C*Dd**2*f**2*r*s + 648*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 648*C*Dd**2*f**2*s - 216*C*Dd**2*f**2 + 50*D1**2*K*f*fd*r**2 + 100*D1**2*K*f*fd*r*s - 50*D1**2*K*f*fd*r + 50*D1**2*K*f*fd*s**2 - 50*D1**2*K*f*fd*s + 25*D1**2*K*f*fd - 144*D1**2*K*f*fdd*r**2 - 288*D1**2*K*f*fdd*r*s + 144*D1**2*K*f*fdd*r - 144*D1**2*K*f*fdd*s**2 + 144*D1**2*K*f*fdd*s - 72*D1**2*K*f*fdd - 144*D1**2*K*fd**2*r**2 - 288*D1**2*K*fd**2*r*s + 144*D1**2*K*fd**2*r - 144*D1**2*K*fd**2*s**2 + 144*D1**2*K*fd**2*s - 84*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 108*D1**2*f**2*fd*r**2 + 216*D1**2*f**2*fd*r*s - 144*D1**2*f**2*fd*r + 108*D1**2*f**2*fd*s**2 - 144*D1**2*f**2*fd*s + 72*D1**2*f**2*fd - 134*D1**2*f*fd*r**2 - 268*D1**2*f*fd*r*s + 134*D1**2*f*fd*r - 134*D1**2*f*fd*s**2 + 134*D1**2*f*fd*s - 67*D1**2*f*fd + 144*D1**2*f*fdd*r**2 + 288*D1**2*f*fdd*r*s - 144*D1**2*f*fdd*r + 144*D1**2*f*fdd*s**2 - 144*D1**2*f*fdd*s + 72*D1**2*f*fdd - 98*D1**2*f*gd2*r**2 - 196*D1**2*f*gd2*r*s + 196*D1**2*f*gd2*r - 98*D1**2*f*gd2*s**2 + 196*D1**2*f*gd2*s - 98*D1**2*f*gd2 + 84*D1**2*f*gdd2*r**2 + 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*r + 84*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s + 84*D1**2*f*gdd2 + 144*D1**2*fd**2*r**2 + 288*D1**2*fd**2*r*s - 144*D1**2*fd**2*r + 144*D1**2*fd**2*s**2 - 144*D1**2*fd**2*s - 98*D1**2*fd*g2*r**2 - 196*D1**2*fd*g2*r*s - 98*D1**2*fd*g2*s**2 + 168*D1**2*fd*gd2*r**2 + 336*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 84*D1**2*fdd*g2*r**2 + 168*D1**2*fdd*g2*r*s + 84*D1**2*fdd*g2*s**2 + 100*D1*Dd*K*f**2*r**2 + 200*D1*Dd*K*f**2*r*s - 150*D1*Dd*K*f**2*r + 100*D1*Dd*K*f**2*s**2 - 150*D1*Dd*K*f**2*s + 75*D1*Dd*K*f**2 - 1152*D1*Dd*K*f*fd*r**2 - 2304*D1*Dd*K*f*fd*r*s + 1440*D1*Dd*K*f*fd*r - 1152*D1*Dd*K*f*fd*s**2 + 1440*D1*Dd*K*f*fd*s - 432*D1*Dd*K*f*fd + 144*D1*Dd*f**3*r**2 + 288*D1*Dd*f**3*r*s - 216*D1*Dd*f**3*r + 144*D1*Dd*f**3*s**2 - 216*D1*Dd*f**3*s + 108*D1*Dd*f**3 - 268*D1*Dd*f**2*r**2 - 536*D1*Dd*f**2*r*s + 402*D1*Dd*f**2*r - 268*D1*Dd*f**2*s**2 + 402*D1*Dd*f**2*s - 201*D1*Dd*f**2 + 1152*D1*Dd*f*fd*r**2 + 2304*D1*Dd*f*fd*r*s - 1440*D1*Dd*f*fd*r + 1152*D1*Dd*f*fd*s**2 - 1440*D1*Dd*f*fd*s + 432*D1*Dd*f*fd - 392*D1*Dd*f*g2*r**2 - 784*D1*Dd*f*g2*r*s + 588*D1*Dd*f*g2*r - 392*D1*Dd*f*g2*s**2 + 588*D1*Dd*f*g2*s - 294*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r**2 + 1344*D1*Dd*f*gd2*r*s - 1176*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 1176*D1*Dd*f*gd2*s + 504*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r**2 + 1344*D1*Dd*fd*g2*r*s - 504*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 504*D1*Dd*fd*g2*s - 288*D1*Ddd*K*f**2*r**2 - 576*D1*Ddd*K*f**2*r*s + 432*D1*Ddd*K*f**2*r - 288*D1*Ddd*K*f**2*s**2 + 432*D1*Ddd*K*f**2*s - 216*D1*Ddd*K*f**2 + 288*D1*Ddd*f**2*r**2 + 576*D1*Ddd*f**2*r*s - 432*D1*Ddd*f**2*r + 288*D1*Ddd*f**2*s**2 - 432*D1*Ddd*f**2*s + 216*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r**2 + 672*D1*Ddd*f*g2*r*s - 504*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 504*D1*Ddd*f*g2*s + 252*D1*Ddd*f*g2 + 14*D1*bd1*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 864*Dd**2*K*f**2*r**2 - 1728*Dd**2*K*f**2*r*s + 1296*Dd**2*K*f**2*r - 864*Dd**2*K*f**2*s**2 + 1296*Dd**2*K*f**2*s - 432*Dd**2*K*f**2 + 864*Dd**2*f**2*r**2 + 1728*Dd**2*f**2*r*s - 1296*Dd**2*f**2*r + 864*Dd**2*f**2*s**2 - 1296*Dd**2*f**2*s + 432*Dd**2*f**2 + 1008*Dd**2*f*g2*r**2 + 2016*Dd**2*f*g2*r*s - 1512*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1512*Dd**2*f*g2*s + 504*Dd**2*f*g2))/(70*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**2*k1**4*k2**2*(-720*C*D1**2*bdd1*f**2*r**2 - 1440*C*D1**2*bdd1*f**2*r*s + 1440*C*D1**2*bdd1*f**2*r - 720*C*D1**2*bdd1*f**2*s**2 + 1440*C*D1**2*bdd1*f**2*s - 720*C*D1**2*bdd1*f**2 + 150*C*D1**2*f**2*fd*r**2 + 300*C*D1**2*f**2*fd*r*s - 200*C*D1**2*f**2*fd*r + 150*C*D1**2*f**2*fd*s**2 - 200*C*D1**2*f**2*fd*s + 100*C*D1**2*f**2*fd - 210*C*D1**2*f**2*fdd*r**2 - 420*C*D1**2*f**2*fdd*r*s + 280*C*D1**2*f**2*fdd*r - 210*C*D1**2*f**2*fdd*s**2 + 280*C*D1**2*f**2*fdd*s - 140*C*D1**2*f**2*fdd - 420*C*D1**2*f*fd**2*r**2 - 840*C*D1**2*f*fd**2*r*s + 560*C*D1**2*f*fd**2*r - 420*C*D1**2*f*fd**2*s**2 + 560*C*D1**2*f*fd**2*s - 140*C*D1**2*f*fd**2 + 200*C*D1*Dd*f**3*r**2 + 400*C*D1*Dd*f**3*r*s - 300*C*D1*Dd*f**3*r + 200*C*D1*Dd*f**3*s**2 - 300*C*D1*Dd*f**3*s + 150*C*D1*Dd*f**3 - 1680*C*D1*Dd*f**2*fd*r**2 - 3360*C*D1*Dd*f**2*fd*r*s + 2380*C*D1*Dd*f**2*fd*r - 1680*C*D1*Dd*f**2*fd*s**2 + 2380*C*D1*Dd*f**2*fd*s - 840*C*D1*Dd*f**2*fd - 280*C*D1*Ddd*f**3*r**2 - 560*C*D1*Ddd*f**3*r*s + 420*C*D1*Ddd*f**3*r - 280*C*D1*Ddd*f**3*s**2 + 420*C*D1*Ddd*f**3*s - 210*C*D1*Ddd*f**3 - 840*C*Dd**2*f**3*r**2 - 1680*C*Dd**2*f**3*r*s + 1260*C*Dd**2*f**3*r - 840*C*Dd**2*f**3*s**2 + 1260*C*Dd**2*f**3*s - 420*C*Dd**2*f**3 - 45*D1**2*K*bdd1*f**2*r**2 - 90*D1**2*K*bdd1*f**2*r*s + 90*D1**2*K*bdd1*f**2*r - 45*D1**2*K*bdd1*f**2*s**2 + 90*D1**2*K*bdd1*f**2*s - 45*D1**2*K*bdd1*f**2 + 36*D1**2*bd1**2*f*(-28*K + 25*f + 14)*(r + s - 1)**2 + 540*D1**2*bdd1*f**2*r**2 + 1080*D1**2*bdd1*f**2*r*s - 1080*D1**2*bdd1*f**2*r + 540*D1**2*bdd1*f**2*s**2 - 1080*D1**2*bdd1*f**2*s + 540*D1**2*bdd1*f**2 + 1008*D1**2*bdd1*f*g2*r**2 + 2016*D1**2*bdd1*f*g2*r*s - 2016*D1**2*bdd1*f*g2*r + 1008*D1**2*bdd1*f*g2*s**2 - 2016*D1**2*bdd1*f*g2*s + 1008*D1**2*bdd1*f*g2 - 75*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 + 210*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 70*D1**2*f**2*fdd - 54*D1**2*f**2*gd2*r**2 - 108*D1**2*f**2*gd2*r*s + 108*D1**2*f**2*gd2*r - 54*D1**2*f**2*gd2*s**2 + 108*D1**2*f**2*gd2*s - 54*D1**2*f**2*gd2 + 90*D1**2*f**2*gdd2*r**2 + 180*D1**2*f**2*gdd2*r*s - 180*D1**2*f**2*gdd2*r + 90*D1**2*f**2*gdd2*s**2 - 180*D1**2*f**2*gdd2*s + 90*D1**2*f**2*gdd2 + 210*D1**2*f*fd**2*r**2 + 420*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s + 70*D1**2*f*fd**2 - 108*D1**2*f*fd*g2*r**2 - 216*D1**2*f*fd*g2*r*s + 108*D1**2*f*fd*g2*r - 108*D1**2*f*fd*g2*s**2 + 108*D1**2*f*fd*g2*s - 54*D1**2*f*fd*g2 + 360*D1**2*f*fd*gd2*r**2 + 720*D1**2*f*fd*gd2*r*s - 540*D1**2*f*fd*gd2*r + 360*D1**2*f*fd*gd2*s**2 - 540*D1**2*f*fd*gd2*s + 180*D1**2*f*fd*gd2 + 180*D1**2*f*fdd*g2*r**2 + 360*D1**2*f*fdd*g2*r*s - 180*D1**2*f*fdd*g2*r + 180*D1**2*f*fdd*g2*s**2 - 180*D1**2*f*fdd*g2*s + 90*D1**2*f*fdd*g2 + 180*D1**2*fd**2*g2*r**2 + 360*D1**2*fd**2*g2*r*s - 180*D1**2*fd**2*g2*r + 180*D1**2*fd**2*g2*s**2 - 180*D1**2*fd**2*g2*s - 100*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 75*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 + 1680*D1*Dd*f**2*fd*r*s - 1190*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 1190*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd - 216*D1*Dd*f**2*g2*r**2 - 432*D1*Dd*f**2*g2*r*s + 324*D1*Dd*f**2*g2*r - 216*D1*Dd*f**2*g2*s**2 + 324*D1*Dd*f**2*g2*s - 162*D1*Dd*f**2*g2 + 720*D1*Dd*f**2*gd2*r**2 + 1440*D1*Dd*f**2*gd2*r*s - 1260*D1*Dd*f**2*gd2*r + 720*D1*Dd*f**2*gd2*s**2 - 1260*D1*Dd*f**2*gd2*s + 540*D1*Dd*f**2*gd2 + 1440*D1*Dd*f*fd*g2*r**2 + 2880*D1*Dd*f*fd*g2*r*s - 1800*D1*Dd*f*fd*g2*r + 1440*D1*Dd*f*fd*g2*s**2 - 1800*D1*Dd*f*fd*g2*s + 540*D1*Dd*f*fd*g2 + 140*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r*s - 210*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 210*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 + 360*D1*Ddd*f**2*g2*r**2 + 720*D1*Ddd*f**2*g2*r*s - 540*D1*Ddd*f**2*g2*r + 360*D1*Ddd*f**2*g2*s**2 - 540*D1*Ddd*f**2*g2*s + 270*D1*Ddd*f**2*g2 - 6*D1*b1*bd1*(D1*(111*f**2*(r + s - 1) - 300*f*fd*(2*r + 2*s - 1) - 7*f*(3*K + 1)*(r + s - 1) + 168*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-28*K + 25*f + 14)*(4*r + 4*s - 3))*(r + s - 1) - 9*D1*bd1*(D1*(10*f**3*(r + s - 1) - f**2*(34*C + 3*K - 22)*(r + s - 1) + 2*f*(5*fd*(16*C + K - 12)*(2*r + 2*s - 1) + (7*g2 - 112*gd2)*(r + s - 1)) - 224*fd*g2*(r + s)) + 2*Dd*f*(5*f*(16*C + K - 12) - 112*g2)*(4*r + 4*s - 3))*(r + s - 1) + 420*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r*s - 630*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 630*Dd**2*f**3*s + 210*Dd**2*f**3 + 1080*Dd**2*f**2*g2*r**2 + 2160*Dd**2*f**2*g2*r*s - 1620*Dd**2*f**2*g2*r + 1080*Dd**2*f**2*g2*s**2 - 1620*Dd**2*f**2*g2*s + 540*Dd**2*f**2*g2 - 3*b1**2*(D1**2*(3*f*(37*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(300*fd**2*(r + s - 1) + 7*fd*(3*K + 1)*(r + s) - 84*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(111*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(300*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (21*K + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 168*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-28*K + 25*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-28*K + 25*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(4*D1**2*bdd1*f*(-28*K + 25*f + 14)*(r + s - 1)**2 - D1**2*(10*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-fd*(34*C + 3*K - 22)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*fdd*(16*C + K - 12)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (14*gd2 - 112*gdd2)*(r + s - 1)**2) + (2*r + 2*s)*(5*fd**2*(16*C + K - 12)*(r + s - 1) + 7*fd*(g2*(r + s) - 16*gd2*(r + s - 1)) - 56*fdd*g2*(r + s))) + D1*(Dd*(-10*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(34*C + 3*K - 22)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(5*fd*(16*C + K - 12)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 7*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 112*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 224*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(5*f*(16*C + K - 12) - 112*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(5*f*(16*C + K - 12) - 112*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**2*k1**4*st**4*(132*C*D1**2*f**2*fd*r*s - 44*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 132*C*D1**2*f**2*fd*s + 44*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r*s + 22*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 66*C*D1**2*f**2*fdd*s - 22*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r*s + 44*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 132*C*D1**2*f*fd**2*s - 22*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r*s - 44*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 176*C*D1*Dd*f**3*s + 44*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r*s + 154*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 528*C*D1*Dd*f**2*fd*s - 110*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r*s + 22*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 88*C*D1*Ddd*f**3*s - 22*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r*s + 66*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 264*C*Dd**2*f**3*s - 44*C*Dd**2*f**3 - 33*D1**2*K*bdd1*f**2*r*s - 33*D1**2*K*bdd1*f**2*s**2 + 33*D1**2*K*bdd1*f**2*s + 33*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s + 980*D1**2*f**3*fd*r*s - 245*D1**2*f**3*fd*r + 980*D1**2*f**3*fd*s**2 - 980*D1**2*f**3*fd*s + 245*D1**2*f**3*fd - 600*D1**2*f**3*fdd*r*s + 150*D1**2*f**3*fdd*r - 600*D1**2*f**3*fdd*s**2 + 600*D1**2*f**3*fdd*s - 150*D1**2*f**3*fdd - 1800*D1**2*f**2*fd**2*r*s + 450*D1**2*f**2*fd**2*r - 1800*D1**2*f**2*fd**2*s**2 + 1800*D1**2*f**2*fd**2*s - 300*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r*s + 44*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 132*D1**2*f**2*fd*s - 44*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r*s - 22*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 66*D1**2*f**2*fdd*s + 22*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s + 66*D1**2*f**2*gdd2*r*s + 66*D1**2*f**2*gdd2*s**2 - 66*D1**2*f**2*gdd2*s + 132*D1**2*f*fd**2*r*s - 44*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 132*D1**2*f*fd**2*s + 22*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r*s - 66*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 264*D1**2*f*fd*gd2*s + 66*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r*s - 66*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r*s - 66*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 980*D1*Dd*f**4*r*s - 245*D1*Dd*f**4*r + 980*D1*Dd*f**4*s**2 - 980*D1*Dd*f**4*s + 245*D1*Dd*f**4 - 4800*D1*Dd*f**3*fd*r*s + 1200*D1*Dd*f**3*fd*r - 4800*D1*Dd*f**3*fd*s**2 + 4800*D1*Dd*f**3*fd*s - 900*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 176*D1*Dd*f**3*s - 44*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r*s - 154*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 528*D1*Dd*f**2*fd*s + 110*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r*s + 132*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r*s - 66*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 528*D1*Dd*f**2*gd2*s + 66*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r*s - 396*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1056*D1*Dd*f*fd*g2*s + 264*D1*Dd*f*fd*g2 - 600*D1*Ddd*f**4*r*s + 150*D1*Ddd*f**4*r - 600*D1*Ddd*f**4*s**2 + 600*D1*Ddd*f**4*s - 150*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 88*D1*Ddd*f**3*s + 22*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r*s - 66*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 264*D1*Ddd*f**2*g2*s + 66*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 1800*Dd**2*f**4*r*s + 450*Dd**2*f**4*r - 1800*Dd**2*f**4*s**2 + 1800*Dd**2*f**4*s - 300*Dd**2*f**4 + 264*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 264*Dd**2*f**3*s + 44*Dd**2*f**3 + 792*Dd**2*f**2*g2*r*s - 198*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 792*Dd**2*f**2*g2*s + 132*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(385*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**2*k1**4*st**2*(90*C*D1**2*bdd1*f**2*r**2 + 396*C*D1**2*bdd1*f**2*r*s - 216*C*D1**2*bdd1*f**2*r + 306*C*D1**2*bdd1*f**2*s**2 - 432*C*D1**2*bdd1*f**2*s + 216*C*D1**2*bdd1*f**2 + 858*C*D1**2*f**2*fd*r**2 + 1740*C*D1**2*f**2*fd*r*s - 1152*C*D1**2*f**2*fd*r + 882*C*D1**2*f**2*fd*s**2 - 1168*C*D1**2*f**2*fd*s + 580*C*D1**2*f**2*fd - 726*C*D1**2*f**2*fdd*r**2 - 2004*C*D1**2*f**2*fdd*r*s + 1152*C*D1**2*f**2*fdd*r - 1278*C*D1**2*f**2*fdd*s**2 + 1520*C*D1**2*f**2*fdd*s - 668*C*D1**2*f**2*fdd - 1452*C*D1**2*f*fd**2*r**2 - 4008*C*D1**2*f*fd**2*r*s + 2304*C*D1**2*f*fd**2*r - 2556*C*D1**2*f*fd**2*s**2 + 3040*C*D1**2*f*fd**2*s - 668*C*D1**2*f*fd**2 + 1144*C*D1*Dd*f**3*r**2 + 2320*C*D1*Dd*f**3*r*s - 1724*C*D1*Dd*f**3*r + 1176*C*D1*Dd*f**3*s**2 - 1748*C*D1*Dd*f**3*s + 866*C*D1*Dd*f**3 - 5808*C*D1*Dd*f**2*fd*r**2 - 16032*C*D1*Dd*f**2*fd*r*s + 9516*C*D1*Dd*f**2*fd*r - 10224*C*D1*Dd*f**2*fd*s**2 + 12644*C*D1*Dd*f**2*fd*s - 3824*C*D1*Dd*f**2*fd - 968*C*D1*Ddd*f**3*r**2 - 2672*C*D1*Ddd*f**3*r*s + 1636*C*D1*Ddd*f**3*r - 1704*C*D1*Ddd*f**3*s**2 + 2188*C*D1*Ddd*f**3*s - 910*C*D1*Ddd*f**3 - 2904*C*Dd**2*f**3*r**2 - 8016*C*Dd**2*f**3*r*s + 4908*C*Dd**2*f**3*r - 5112*C*Dd**2*f**3*s**2 + 6564*C*Dd**2*f**3*s - 1820*C*Dd**2*f**3 - 213*D1**2*K*bdd1*f**2*r**2 - 678*D1**2*K*bdd1*f**2*r*s + 426*D1**2*K*bdd1*f**2*r - 465*D1**2*K*bdd1*f**2*s**2 + 678*D1**2*K*bdd1*f**2*s - 213*D1**2*K*bdd1*f**2 + 42*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 23*s + 6) + 1050*D1**2*bdd1*f**3*r**2 + 2340*D1**2*bdd1*f**3*r*s - 1920*D1**2*bdd1*f**3*r + 1290*D1**2*bdd1*f**3*s**2 - 2160*D1**2*bdd1*f**3*s + 1320*D1**2*bdd1*f**3 + 663*D1**2*bdd1*f**2*r**2 + 1470*D1**2*bdd1*f**2*r*s - 1290*D1**2*bdd1*f**2*r + 807*D1**2*bdd1*f**2*s**2 - 1434*D1**2*bdd1*f**2*s + 537*D1**2*bdd1*f**2 - 210*D1**2*bdd1*f*g2*r**2 - 924*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 714*D1**2*bdd1*f*g2*s**2 + 1008*D1**2*bdd1*f*g2*s - 504*D1**2*bdd1*f*g2 + 3720*D1**2*f**3*fd*r**2 + 12720*D1**2*f**3*fd*r*s - 6900*D1**2*f**3*fd*r + 9000*D1**2*f**3*fd*s**2 - 10860*D1**2*f**3*fd*s + 4110*D1**2*f**3*fd - 4440*D1**2*f**3*fdd*r**2 - 11280*D1**2*f**3*fdd*r*s + 7260*D1**2*f**3*fdd*r - 6840*D1**2*f**3*fdd*s**2 + 9060*D1**2*f**3*fdd*s - 3930*D1**2*f**3*fdd - 13320*D1**2*f**2*fd**2*r**2 - 33840*D1**2*f**2*fd**2*r*s + 21780*D1**2*f**2*fd**2*r - 20520*D1**2*f**2*fd**2*s**2 + 27180*D1**2*f**2*fd**2*s - 7860*D1**2*f**2*fd**2 - 1578*D1**2*f**2*fd*r**2 - 3432*D1**2*f**2*fd*r*s + 2196*D1**2*f**2*fd*r - 1854*D1**2*f**2*fd*s**2 + 2380*D1**2*f**2*fd*s - 1144*D1**2*f**2*fd + 1626*D1**2*f**2*fdd*r**2 + 3984*D1**2*f**2*fdd*r*s - 2412*D1**2*f**2*fdd*r + 2358*D1**2*f**2*fdd*s**2 - 2900*D1**2*f**2*fdd*s + 1328*D1**2*f**2*fdd - 390*D1**2*f**2*gd2*r**2 - 948*D1**2*f**2*gd2*r*s + 780*D1**2*f**2*gd2*r - 558*D1**2*f**2*gd2*s**2 + 948*D1**2*f**2*gd2*s - 390*D1**2*f**2*gd2 + 426*D1**2*f**2*gdd2*r**2 + 1356*D1**2*f**2*gdd2*r*s - 852*D1**2*f**2*gdd2*r + 930*D1**2*f**2*gdd2*s**2 - 1356*D1**2*f**2*gdd2*s + 426*D1**2*f**2*gdd2 + 3252*D1**2*f*fd**2*r**2 + 7968*D1**2*f*fd**2*r*s - 4824*D1**2*f*fd**2*r + 4716*D1**2*f*fd**2*s**2 - 5800*D1**2*f*fd**2*s + 1328*D1**2*f*fd**2 - 780*D1**2*f*fd*g2*r**2 - 1896*D1**2*f*fd*g2*r*s + 948*D1**2*f*fd*g2*r - 1116*D1**2*f*fd*g2*s**2 + 1116*D1**2*f*fd*g2*s - 558*D1**2*f*fd*g2 + 1704*D1**2*f*fd*gd2*r**2 + 5424*D1**2*f*fd*gd2*r*s - 3060*D1**2*f*fd*gd2*r + 3720*D1**2*f*fd*gd2*s**2 - 4572*D1**2*f*fd*gd2*s + 1356*D1**2*f*fd*gd2 + 852*D1**2*f*fdd*g2*r**2 + 2712*D1**2*f*fdd*g2*r*s - 1356*D1**2*f*fdd*g2*r + 1860*D1**2*f*fdd*g2*s**2 - 1860*D1**2*f*fdd*g2*s + 930*D1**2*f*fdd*g2 + 852*D1**2*fd**2*g2*r**2 + 2712*D1**2*fd**2*g2*r*s - 1356*D1**2*fd**2*g2*r + 1860*D1**2*fd**2*g2*s**2 - 1860*D1**2*fd**2*g2*s + 3720*D1*Dd*f**4*r**2 + 12720*D1*Dd*f**4*r*s - 6900*D1*Dd*f**4*r + 9000*D1*Dd*f**4*s**2 - 10860*D1*Dd*f**4*s + 4110*D1*Dd*f**4 - 35520*D1*Dd*f**3*fd*r**2 - 90240*D1*Dd*f**3*fd*r*s + 58080*D1*Dd*f**3*fd*r - 54720*D1*Dd*f**3*fd*s**2 + 72480*D1*Dd*f**3*fd*s - 23580*D1*Dd*f**3*fd - 2104*D1*Dd*f**3*r**2 - 4576*D1*Dd*f**3*r*s + 3248*D1*Dd*f**3*r - 2472*D1*Dd*f**3*s**2 + 3524*D1*Dd*f**3*s - 1670*D1*Dd*f**3 + 13008*D1*Dd*f**2*fd*r**2 + 31872*D1*Dd*f**2*fd*r*s - 20136*D1*Dd*f**2*fd*r + 18864*D1*Dd*f**2*fd*s**2 - 24284*D1*Dd*f**2*fd*s + 7724*D1*Dd*f**2*fd - 1560*D1*Dd*f**2*g2*r**2 - 3792*D1*Dd*f**2*g2*r*s + 2508*D1*Dd*f**2*g2*r - 2232*D1*Dd*f**2*g2*s**2 + 3012*D1*Dd*f**2*g2*s - 1338*D1*Dd*f**2*g2 + 3408*D1*Dd*f**2*gd2*r**2 + 10848*D1*Dd*f**2*gd2*r*s - 6468*D1*Dd*f**2*gd2*r + 7440*D1*Dd*f**2*gd2*s**2 - 9996*D1*Dd*f**2*gd2*s + 3060*D1*Dd*f**2*gd2 + 6816*D1*Dd*f*fd*g2*r**2 + 21696*D1*Dd*f*fd*g2*r*s - 11544*D1*Dd*f*fd*g2*r + 14880*D1*Dd*f*fd*g2*s**2 - 16584*D1*Dd*f*fd*g2*s + 4572*D1*Dd*f*fd*g2 - 4440*D1*Ddd*f**4*r**2 - 11280*D1*Ddd*f**4*r*s + 7260*D1*Ddd*f**4*r - 6840*D1*Ddd*f**4*s**2 + 9060*D1*Ddd*f**4*s - 3930*D1*Ddd*f**4 + 2168*D1*Ddd*f**3*r**2 + 5312*D1*Ddd*f**3*r*s - 3496*D1*Ddd*f**3*r + 3144*D1*Ddd*f**3*s**2 - 4228*D1*Ddd*f**3*s + 1870*D1*Ddd*f**3 + 1704*D1*Ddd*f**2*g2*r**2 + 5424*D1*Ddd*f**2*g2*r*s - 3060*D1*Ddd*f**2*g2*r + 3720*D1*Ddd*f**2*g2*s**2 - 4572*D1*Ddd*f**2*g2*s + 1782*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(f**3*(250*r**2 + r*(660*s - 632) + 410*s**2 - 792*s + 502) - f**2*(2*C*(5*r**2 + r*(72 - 62*s) - 67*s**2 + 144*s - 72) + 65*K*r**2 + 158*K*r*s - 130*K*r + 93*K*s**2 - 158*K*s + 65*K + 20*fd*(105*r**2 + 234*r*s - 173*r + 129*s**2 - 193*s + 56) - 155*r**2 - 238*r*s + 146*r - 83*s**2 + 74*s - 1) - 2*f*(fd*(12*C*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 20*s + 3) - K*(142*r**2 + 452*r*s - 255*r + 310*s**2 - 381*s + 113) + 442*r**2 + 980*r*s - 681*r + 538*s**2 - 753*s + 275) - 21*g2*(5*r**2 + 2*r*(s + 4) - 3*s**2 + 16*s - 8) - 14*gd2*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 23*s + 6)) + 28*fd*g2*(5*r**2 + 11*r*(2*s - 1) + s*(17*s - 17))) - 2*Dd*f*(10*f**2*(140*r**2 + 3*r*(104*s - 79) + 172*s**2 - 265*s + 100) + f*(6*C*(20*r**2 + r*(88*s - 45) + 68*s**2 - 87*s + 24) - K*(284*r**2 + 904*r*s - 539*r + 620*s**2 - 833*s + 255) + 884*r**2 + 1960*r*s - 1547*r + 1076*s**2 - 1715*s + 669) - 14*g2*(20*r**2 + r*(88*s - 45) + 68*s**2 - 87*s + 24))) - 13320*Dd**2*f**4*r**2 - 33840*Dd**2*f**4*r*s + 21780*Dd**2*f**4*r - 20520*Dd**2*f**4*s**2 + 27180*Dd**2*f**4*s - 7860*Dd**2*f**4 + 6504*Dd**2*f**3*r**2 + 15936*Dd**2*f**3*r*s - 10488*Dd**2*f**3*r + 9432*Dd**2*f**3*s**2 - 12684*Dd**2*f**3*s + 3740*Dd**2*f**3 + 5112*Dd**2*f**2*g2*r**2 + 16272*Dd**2*f**2*g2*r*s - 9180*Dd**2*f**2*g2*r + 11160*Dd**2*f**2*g2*s**2 - 13716*Dd**2*f**2*g2*s + 3564*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(3*fd*(5*r**2 + 2*r*(s - 5) - 3*s**2 - 10*s + 5) + fdd*(5*r**2 + 2*r*(11*s - 5) + 17*s**2 - 10*s + 5)) + D1*(Dd*(3*f*(20*r**2 + 8*r*s - 22*r - 12*s**2 + 2*s + 7) + 2*fd*(20*r**2 + 88*r*s - 41*r + 68*s**2 - 59*s + 15)) + Ddd*f*(20*r**2 + r*(88*s - 42) + 68*s**2 - 78*s + 27)) + 6*Dd**2*f*(10*r**2 + r*(44*s - 21) + 34*s**2 - 39*s + 9)) + 3*b1*(20*C*D1**2*f*fd*r**2 - 248*C*D1**2*f*fd*r*s - 40*C*D1**2*f*fd*r - 268*C*D1**2*f*fd*s**2 + 104*C*D1**2*f*fd*s + 20*C*D1**2*f*fd + 60*C*D1**2*f*fdd*r**2 + 264*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 204*C*D1**2*f*fdd*s**2 - 192*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 60*C*D1**2*fd**2*r**2 + 264*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 204*C*D1**2*fd**2*s**2 - 192*C*D1**2*fd**2*s + 60*C*D1**2*fd**2 + 40*C*D1*Dd*f**2*r**2 - 496*C*D1*Dd*f**2*r*s + 84*C*D1*Dd*f**2*r - 536*C*D1*Dd*f**2*s**2 + 516*C*D1*Dd*f**2*s - 114*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*r**2 + 2112*C*D1*Dd*f*fd*r*s - 984*C*D1*Dd*f*fd*r + 1632*C*D1*Dd*f*fd*s**2 - 1704*C*D1*Dd*f*fd*s + 432*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*r**2 + 528*C*D1*Ddd*f**2*r*s - 252*C*D1*Ddd*f**2*r + 408*C*D1*Ddd*f**2*s**2 - 468*C*D1*Ddd*f**2*s + 162*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*r**2 + 1584*C*Dd**2*f**2*r*s - 756*C*Dd**2*f**2*r + 1224*C*Dd**2*f**2*s**2 - 1404*C*Dd**2*f**2*s + 324*C*Dd**2*f**2 + 130*D1**2*K*f*fd*r**2 + 316*D1**2*K*f*fd*r*s - 158*D1**2*K*f*fd*r + 186*D1**2*K*f*fd*s**2 - 186*D1**2*K*f*fd*s + 93*D1**2*K*f*fd - 142*D1**2*K*f*fdd*r**2 - 452*D1**2*K*f*fdd*r*s + 226*D1**2*K*f*fdd*r - 310*D1**2*K*f*fdd*s**2 + 310*D1**2*K*f*fdd*s - 155*D1**2*K*f*fdd - 142*D1**2*K*fd**2*r**2 - 452*D1**2*K*fd**2*r*s + 226*D1**2*K*fd**2*r - 310*D1**2*K*fd**2*s**2 + 310*D1**2*K*fd**2*s + 7*D1**2*bdd1*f*(K - 1)*(10*r**2 + 44*r*s - 22*r + 34*s**2 - 46*s + 17) - 750*D1**2*f**2*fd*r**2 - 1980*D1**2*f**2*fd*r*s + 1028*D1**2*f**2*fd*r - 1230*D1**2*f**2*fd*s**2 + 1348*D1**2*f**2*fd*s - 408*D1**2*f**2*fd + 1050*D1**2*f**2*fdd*r**2 + 2340*D1**2*f**2*fdd*r*s - 1540*D1**2*f**2*fdd*r + 1290*D1**2*f**2*fdd*s**2 - 1700*D1**2*f**2*fdd*s + 690*D1**2*f**2*fdd + 2100*D1**2*f*fd**2*r**2 + 4680*D1**2*f*fd**2*r*s - 3080*D1**2*f*fd**2*r + 2580*D1**2*f*fd**2*s**2 - 3400*D1**2*f*fd**2*s + 1140*D1**2*f*fd**2 - 310*D1**2*f*fd*r**2 - 476*D1**2*f*fd*r*s + 402*D1**2*f*fd*r - 166*D1**2*f*fd*s**2 + 330*D1**2*f*fd*s - 237*D1**2*f*fd + 442*D1**2*f*fdd*r**2 + 980*D1**2*f*fdd*r*s - 502*D1**2*f*fdd*r + 538*D1**2*f*fdd*s**2 - 550*D1**2*f*fdd*s + 311*D1**2*f*fdd - 210*D1**2*f*gd2*r**2 - 84*D1**2*f*gd2*r*s + 420*D1**2*f*gd2*r + 126*D1**2*f*gd2*s**2 + 84*D1**2*f*gd2*s - 210*D1**2*f*gd2 - 70*D1**2*f*gdd2*r**2 - 308*D1**2*f*gdd2*r*s + 140*D1**2*f*gdd2*r - 238*D1**2*f*gdd2*s**2 + 308*D1**2*f*gdd2*s - 70*D1**2*f*gdd2 + 442*D1**2*fd**2*r**2 + 980*D1**2*fd**2*r*s - 502*D1**2*fd**2*r + 538*D1**2*fd**2*s**2 - 550*D1**2*fd**2*s - 60*D1**2*fd**2 - 210*D1**2*fd*g2*r**2 - 84*D1**2*fd*g2*r*s + 420*D1**2*fd*g2*r + 126*D1**2*fd*g2*s**2 + 420*D1**2*fd*g2*s - 210*D1**2*fd*g2 - 140*D1**2*fd*gd2*r**2 - 616*D1**2*fd*gd2*r*s + 280*D1**2*fd*gd2*r - 476*D1**2*fd*gd2*s**2 + 448*D1**2*fd*gd2*s - 140*D1**2*fd*gd2 - 70*D1**2*fdd*g2*r**2 - 308*D1**2*fdd*g2*r*s + 140*D1**2*fdd*g2*r - 238*D1**2*fdd*g2*s**2 + 140*D1**2*fdd*g2*s - 70*D1**2*fdd*g2 + 260*D1*Dd*K*f**2*r**2 + 632*D1*Dd*K*f**2*r*s - 418*D1*Dd*K*f**2*r + 372*D1*Dd*K*f**2*s**2 - 502*D1*Dd*K*f**2*s + 223*D1*Dd*K*f**2 - 1136*D1*Dd*K*f*fd*r**2 - 3616*D1*Dd*K*f*fd*r*s + 1924*D1*Dd*K*f*fd*r - 2480*D1*Dd*K*f*fd*s**2 + 2764*D1*Dd*K*f*fd*s - 762*D1*Dd*K*f*fd - 1000*D1*Dd*f**3*r**2 - 2640*D1*Dd*f**3*r*s + 1660*D1*Dd*f**3*r - 1640*D1*Dd*f**3*s**2 + 2140*D1*Dd*f**3*s - 910*D1*Dd*f**3 + 8400*D1*Dd*f**2*fd*r**2 + 18720*D1*Dd*f**2*fd*r*s - 12700*D1*Dd*f**2*fd*r + 10320*D1*Dd*f**2*fd*s**2 - 14060*D1*Dd*f**2*fd*s + 4780*D1*Dd*f**2*fd - 620*D1*Dd*f**2*r**2 - 952*D1*Dd*f**2*r*s + 858*D1*Dd*f**2*r - 332*D1*Dd*f**2*s**2 + 642*D1*Dd*f**2*s - 393*D1*Dd*f**2 + 3536*D1*Dd*f*fd*r**2 + 7840*D1*Dd*f*fd*r*s - 4756*D1*Dd*f*fd*r + 4304*D1*Dd*f*fd*s**2 - 5236*D1*Dd*f*fd*s + 1554*D1*Dd*f*fd - 840*D1*Dd*f*g2*r**2 - 336*D1*Dd*f*g2*r*s + 924*D1*Dd*f*g2*r + 504*D1*Dd*f*g2*s**2 - 84*D1*Dd*f*g2*s - 294*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*r**2 - 2464*D1*Dd*f*gd2*r*s + 1148*D1*Dd*f*gd2*r - 1904*D1*Dd*f*gd2*s**2 + 2324*D1*Dd*f*gd2*s - 588*D1*Dd*f*gd2 - 560*D1*Dd*fd*g2*r**2 - 2464*D1*Dd*fd*g2*r*s + 1148*D1*Dd*fd*g2*r - 1904*D1*Dd*fd*g2*s**2 + 1652*D1*Dd*fd*g2*s - 420*D1*Dd*fd*g2 - 284*D1*Ddd*K*f**2*r**2 - 904*D1*Ddd*K*f**2*r*s + 510*D1*Ddd*K*f**2*r - 620*D1*Ddd*K*f**2*s**2 + 762*D1*Ddd*K*f**2*s - 297*D1*Ddd*K*f**2 + 1400*D1*Ddd*f**3*r**2 + 3120*D1*Ddd*f**3*r*s - 2180*D1*Ddd*f**3*r + 1720*D1*Ddd*f**3*s**2 - 2420*D1*Ddd*f**3*s + 1130*D1*Ddd*f**3 + 884*D1*Ddd*f**2*r**2 + 1960*D1*Ddd*f**2*r*s - 1374*D1*Ddd*f**2*r + 1076*D1*Ddd*f**2*s**2 - 1518*D1*Ddd*f**2*s + 711*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*r**2 - 1232*D1*Ddd*f*g2*r*s + 588*D1*Ddd*f*g2*r - 952*D1*Ddd*f*g2*s**2 + 1092*D1*Ddd*f*g2*s - 378*D1*Ddd*f*g2 + 7*D1*bd1*(K - 1)*(D1*(3*f*(10*r**2 + 4*r*s - 2*r - 6*s**2 + 14*s - 3) + 2*fd*(10*r**2 + 44*r*s - 21*r + 34*s**2 - 33*s + 5)) + 2*Dd*f*(40*r**2 + 2*r*(88*s - 43) + 136*s**2 - 170*s + 45)) - 852*Dd**2*K*f**2*r**2 - 2712*Dd**2*K*f**2*r*s + 1530*Dd**2*K*f**2*r - 1860*Dd**2*K*f**2*s**2 + 2286*Dd**2*K*f**2*s - 594*Dd**2*K*f**2 + 4200*Dd**2*f**3*r**2 + 9360*Dd**2*f**3*r*s - 6540*Dd**2*f**3*r + 5160*Dd**2*f**3*s**2 - 7260*Dd**2*f**3*s + 2260*Dd**2*f**3 + 2652*Dd**2*f**2*r**2 + 5880*Dd**2*f**2*r*s - 4122*Dd**2*f**2*r + 3228*Dd**2*f**2*s**2 - 4554*Dd**2*f**2*s + 1422*Dd**2*f**2 - 840*Dd**2*f*g2*r**2 - 3696*Dd**2*f*g2*r*s + 1764*Dd**2*f*g2*r - 2856*Dd**2*f*g2*s**2 + 3276*Dd**2*f*g2*s - 756*Dd**2*f*g2))/(630*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**2*k1**4*(-1134*C*D1**2*bdd1*f**2*r**2 - 2844*C*D1**2*bdd1*f**2*r*s + 2844*C*D1**2*bdd1*f**2*r - 1710*C*D1**2*bdd1*f**2*s**2 + 3420*C*D1**2*bdd1*f**2*s - 1710*C*D1**2*bdd1*f**2 + 750*C*D1**2*f**2*fd*r**2 + 4260*C*D1**2*f**2*fd*r*s - 1920*C*D1**2*f**2*fd*r + 3510*C*D1**2*f**2*fd*s**2 - 3760*C*D1**2*f**2*fd*s + 1420*C*D1**2*f**2*fd - 1050*C*D1**2*f**2*fdd*r**2 - 5100*C*D1**2*f**2*fdd*r*s + 2400*C*D1**2*f**2*fdd*r - 4050*C*D1**2*f**2*fdd*s**2 + 4400*C*D1**2*f**2*fdd*s - 1700*C*D1**2*f**2*fdd - 2100*C*D1**2*f*fd**2*r**2 - 10200*C*D1**2*f*fd**2*r*s + 4800*C*D1**2*f*fd**2*r - 8100*C*D1**2*f*fd**2*s**2 + 8800*C*D1**2*f*fd**2*s - 1700*C*D1**2*f*fd**2 + 1000*C*D1*Dd*f**3*r**2 + 5680*C*D1*Dd*f**3*r*s - 2420*C*D1*Dd*f**3*r + 4680*C*D1*Dd*f**3*s**2 - 5180*C*D1*Dd*f**3*s + 1670*C*D1*Dd*f**3 - 8400*C*D1*Dd*f**2*fd*r**2 - 40800*C*D1*Dd*f**2*fd*r*s + 18900*C*D1*Dd*f**2*fd*r - 32400*C*D1*Dd*f**2*fd*s**2 + 35900*C*D1*Dd*f**2*fd*s - 9200*C*D1*Dd*f**2*fd - 1400*C*D1*Ddd*f**3*r**2 - 6800*C*D1*Ddd*f**3*r*s + 3100*C*D1*Ddd*f**3*r - 5400*C*D1*Ddd*f**3*s**2 + 6100*C*D1*Ddd*f**3*s - 2050*C*D1*Ddd*f**3 - 4200*C*Dd**2*f**3*r**2 - 20400*C*Dd**2*f**3*r*s + 9300*C*Dd**2*f**3*r - 16200*C*Dd**2*f**3*s**2 + 18300*C*Dd**2*f**3*s - 4100*C*Dd**2*f**3 - 225*D1**2*K*bdd1*f**2*r**2 - 1134*D1**2*K*bdd1*f**2*r*s + 450*D1**2*K*bdd1*f**2*r - 909*D1**2*K*bdd1*f**2*s**2 + 1134*D1**2*K*bdd1*f**2*s - 225*D1**2*K*bdd1*f**2 + 270*D1**2*b2*f*fd*r**2 + 540*D1**2*b2*f*fd*r*s - 270*D1**2*b2*f*fd*r + 270*D1**2*b2*f*fd*s**2 - 270*D1**2*b2*f*fd*s + 135*D1**2*b2*f*fd - 450*D1**2*b2*f*fdd*r**2 - 900*D1**2*b2*f*fdd*r*s + 450*D1**2*b2*f*fdd*r - 450*D1**2*b2*f*fdd*s**2 + 450*D1**2*b2*f*fdd*s - 225*D1**2*b2*f*fdd - 450*D1**2*b2*fd**2*r**2 - 900*D1**2*b2*fd**2*r*s + 450*D1**2*b2*fd**2*r - 450*D1**2*b2*fd**2*s**2 + 450*D1**2*b2*fd**2*s + 6*D1**2*bd1**2*(r + s - 1)*(150*f**2*(3*r + 3*s - 2) + 7*f*(30*C*r + 30*C*s + K*(-37*r - 61*s + 49) + 67*r + 91*s - 109) - 350*g2*(r + s)) + 135*D1**2*bd2*f**2*r**2 + 270*D1**2*bd2*f**2*r*s - 270*D1**2*bd2*f**2*r + 135*D1**2*bd2*f**2*s**2 - 270*D1**2*bd2*f**2*s + 135*D1**2*bd2*f**2 - 900*D1**2*bd2*f*fd*r**2 - 1800*D1**2*bd2*f*fd*r*s + 1350*D1**2*bd2*f*fd*r - 900*D1**2*bd2*f*fd*s**2 + 1350*D1**2*bd2*f*fd*s - 450*D1**2*bd2*f*fd - 1260*D1**2*bdd1*f**3*r**2 - 1710*D1**2*bdd1*f**3*r*s + 2340*D1**2*bdd1*f**3*r - 450*D1**2*bdd1*f**3*s**2 + 1530*D1**2*bdd1*f**3*s - 1080*D1**2*bdd1*f**3 + 2034*D1**2*bdd1*f**2*r**2 + 4986*D1**2*bdd1*f**2*r*s - 4644*D1**2*bdd1*f**2*r + 2952*D1**2*bdd1*f**2*s**2 - 5562*D1**2*bdd1*f**2*s + 2610*D1**2*bdd1*f**2 + 1554*D1**2*bdd1*f*g2*r**2 + 4116*D1**2*bdd1*f*g2*r*s - 4116*D1**2*bdd1*f*g2*r + 2562*D1**2*bdd1*f*g2*s**2 - 5124*D1**2*bdd1*f*g2*s + 2562*D1**2*bdd1*f*g2 - 225*D1**2*bdd2*f**2*r**2 - 450*D1**2*bdd2*f**2*r*s + 450*D1**2*bdd2*f**2*r - 225*D1**2*bdd2*f**2*s**2 + 450*D1**2*bdd2*f**2*s - 225*D1**2*bdd2*f**2 - 375*D1**2*f**2*fd*r**2 - 2820*D1**2*f**2*fd*r*s + 1190*D1**2*f**2*fd*r - 2445*D1**2*f**2*fd*s**2 + 2570*D1**2*f**2*fd*s - 940*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 3300*D1**2*f**2*fdd*r*s - 1450*D1**2*f**2*fdd*r + 2775*D1**2*f**2*fdd*s**2 - 2950*D1**2*f**2*fdd*s + 1100*D1**2*f**2*fdd - 270*D1**2*f**2*gd2*r**2 - 1764*D1**2*f**2*gd2*r*s + 540*D1**2*f**2*gd2*r - 1494*D1**2*f**2*gd2*s**2 + 1764*D1**2*f**2*gd2*s - 270*D1**2*f**2*gd2 + 450*D1**2*f**2*gdd2*r**2 + 2268*D1**2*f**2*gdd2*r*s - 900*D1**2*f**2*gdd2*r + 1818*D1**2*f**2*gdd2*s**2 - 2268*D1**2*f**2*gdd2*s + 450*D1**2*f**2*gdd2 + 1050*D1**2*f*fd**2*r**2 + 6600*D1**2*f*fd**2*r*s - 2900*D1**2*f*fd**2*r + 5550*D1**2*f*fd**2*s**2 - 5900*D1**2*f*fd**2*s + 1100*D1**2*f*fd**2 - 540*D1**2*f*fd*g2*r**2 - 3528*D1**2*f*fd*g2*r*s + 1764*D1**2*f*fd*g2*r - 2988*D1**2*f*fd*g2*s**2 + 2988*D1**2*f*fd*g2*s - 1494*D1**2*f*fd*g2 + 1800*D1**2*f*fd*gd2*r**2 + 9072*D1**2*f*fd*gd2*r*s - 4068*D1**2*f*fd*gd2*r + 7272*D1**2*f*fd*gd2*s**2 - 8172*D1**2*f*fd*gd2*s + 2268*D1**2*f*fd*gd2 + 900*D1**2*f*fdd*g2*r**2 + 4536*D1**2*f*fdd*g2*r*s - 2268*D1**2*f*fdd*g2*r + 3636*D1**2*f*fdd*g2*s**2 - 3636*D1**2*f*fdd*g2*s + 1818*D1**2*f*fdd*g2 + 900*D1**2*fd**2*g2*r**2 + 4536*D1**2*fd**2*g2*r*s - 2268*D1**2*fd**2*g2*r + 3636*D1**2*fd**2*g2*s**2 - 3636*D1**2*fd**2*g2*s + 540*D1*Dd*b2*f**2*r**2 + 1080*D1*Dd*b2*f**2*r*s - 810*D1*Dd*b2*f**2*r + 540*D1*Dd*b2*f**2*s**2 - 810*D1*Dd*b2*f**2*s + 405*D1*Dd*b2*f**2 - 3600*D1*Dd*b2*f*fd*r**2 - 7200*D1*Dd*b2*f*fd*r*s + 4500*D1*Dd*b2*f*fd*r - 3600*D1*Dd*b2*f*fd*s**2 + 4500*D1*Dd*b2*f*fd*s - 1350*D1*Dd*b2*f*fd - 1800*D1*Dd*bd2*f**2*r**2 - 3600*D1*Dd*bd2*f**2*r*s + 3150*D1*Dd*bd2*f**2*r - 1800*D1*Dd*bd2*f**2*s**2 + 3150*D1*Dd*bd2*f**2*s - 1350*D1*Dd*bd2*f**2 - 500*D1*Dd*f**3*r**2 - 3760*D1*Dd*f**3*r*s + 1440*D1*Dd*f**3*r - 3260*D1*Dd*f**3*s**2 + 3510*D1*Dd*f**3*s - 1065*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 26400*D1*Dd*f**2*fd*r*s - 11200*D1*Dd*f**2*fd*r + 22200*D1*Dd*f**2*fd*s**2 - 23950*D1*Dd*f**2*fd*s + 5850*D1*Dd*f**2*fd - 1080*D1*Dd*f**2*g2*r**2 - 7056*D1*Dd*f**2*g2*r*s + 2844*D1*Dd*f**2*g2*r - 5976*D1*Dd*f**2*g2*s**2 + 6516*D1*Dd*f**2*g2*s - 2034*D1*Dd*f**2*g2 + 3600*D1*Dd*f**2*gd2*r**2 + 18144*D1*Dd*f**2*gd2*r*s - 7668*D1*Dd*f**2*gd2*r + 14544*D1*Dd*f**2*gd2*s**2 - 17244*D1*Dd*f**2*gd2*s + 4068*D1*Dd*f**2*gd2 + 7200*D1*Dd*f*fd*g2*r**2 + 36288*D1*Dd*f*fd*g2*r*s - 17208*D1*Dd*f*fd*g2*r + 29088*D1*Dd*f*fd*g2*s**2 - 30888*D1*Dd*f*fd*g2*s + 8172*D1*Dd*f*fd*g2 - 900*D1*Ddd*b2*f**2*r**2 - 1800*D1*Ddd*b2*f**2*r*s + 1350*D1*Ddd*b2*f**2*r - 900*D1*Ddd*b2*f**2*s**2 + 1350*D1*Ddd*b2*f**2*s - 675*D1*Ddd*b2*f**2 + 700*D1*Ddd*f**3*r**2 + 4400*D1*Ddd*f**3*r*s - 1800*D1*Ddd*f**3*r + 3700*D1*Ddd*f**3*s**2 - 4050*D1*Ddd*f**3*s + 1275*D1*Ddd*f**3 + 1800*D1*Ddd*f**2*g2*r**2 + 9072*D1*Ddd*f**2*g2*r*s - 4068*D1*Ddd*f**2*g2*r + 7272*D1*Ddd*f**2*g2*s**2 - 8172*D1*Ddd*f**2*g2*s + 2718*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(30*f**3*(12*r**2 + r*(19*s - 28) + 7*s**2 - 23*s + 16) + 3*f**2*(2*C*(49*r**2 + 134*r*(s - 1) + 85*(s - 1)**2) - 10*fd*(84*r**2 + r*(114*s - 127) + 30*s**2 - 82*s + 45) + (r + s - 1)*(K*(15*r + 83*s - 15) - 158*r - 264*s + 230)) - 2*f*(3*fd*(2*C*(126*r**2 + r*(316*s - 221) + 190*s**2 - 269*s + 79) + K*(50*r**2 + 252*r*s - 113*r + 202*s**2 - 227*s + 63) - 452*r**2 - 1108*r*s + 761*r - 656*s**2 + 914*s - 277) + (7*r + 7*s - 7)*(19*g2*r + 47*g2*(s - 1) - 2*gd2*(37*r + 61*s - 49))) + 28*fd*g2*(37*r**2 + 49*r*(2*s - 1) + s*(61*s - 61))) - 2*Dd*f*(15*f**2*(112*r**2 + r*(152*s - 179) + 40*s**2 - 116*s + 69) + 3*f*(2*C*(252*r**2 + r*(632*s - 521) + 380*s**2 - 633*s + 253) + K*(100*r**2 + 504*r*s - 213*r + 404*s**2 - 479*s + 113) - 904*r**2 - 2216*r*s + 1761*r - 1312*s**2 + 2118*s - 825) - 14*g2*(148*r**2 + r*(392*s - 319) + 244*s**2 - 403*s + 159))) - 2700*Dd**2*b2*f**2*r**2 - 5400*Dd**2*b2*f**2*r*s + 4050*Dd**2*b2*f**2*r - 2700*Dd**2*b2*f**2*s**2 + 4050*Dd**2*b2*f**2*s - 1350*Dd**2*b2*f**2 + 2100*Dd**2*f**3*r**2 + 13200*Dd**2*f**3*r*s - 5400*Dd**2*f**3*r + 11100*Dd**2*f**3*s**2 - 12150*Dd**2*f**3*s + 2550*Dd**2*f**3 + 5400*Dd**2*f**2*g2*r**2 + 27216*Dd**2*f**2*g2*r*s - 12204*Dd**2*f**2*g2*r + 21816*Dd**2*f**2*g2*s**2 - 24516*Dd**2*f**2*g2*s + 5436*Dd**2*f**2*g2 + 525*b1**3*(K - 1)*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(-70*C*D1**2*fd*r**2 - 140*C*D1**2*fd*r*s + 140*C*D1**2*fd*r - 70*C*D1**2*fd*s**2 + 140*C*D1**2*fd*s - 70*C*D1**2*fd + 210*C*D1**2*fdd*r**2 + 420*C*D1**2*fdd*r*s - 420*C*D1**2*fdd*r + 210*C*D1**2*fdd*s**2 - 420*C*D1**2*fdd*s + 210*C*D1**2*fdd - 280*C*D1*Dd*f*r**2 - 560*C*D1*Dd*f*r*s + 420*C*D1*Dd*f*r - 280*C*D1*Dd*f*s**2 + 420*C*D1*Dd*f*s - 210*C*D1*Dd*f + 1680*C*D1*Dd*fd*r**2 + 3360*C*D1*Dd*fd*r*s - 2940*C*D1*Dd*fd*r + 1680*C*D1*Dd*fd*s**2 - 2940*C*D1*Dd*fd*s + 1260*C*D1*Dd*fd + 840*C*D1*Ddd*f*r**2 + 1680*C*D1*Ddd*f*r*s - 1260*C*D1*Ddd*f*r + 840*C*D1*Ddd*f*s**2 - 1260*C*D1*Ddd*f*s + 630*C*D1*Ddd*f + 2520*C*Dd**2*f*r**2 + 5040*C*Dd**2*f*r*s - 3780*C*Dd**2*f*r + 2520*C*Dd**2*f*s**2 - 3780*C*Dd**2*f*s + 1260*C*Dd**2*f + 133*D1**2*K*fd*r**2 + 462*D1**2*K*fd*r*s + 329*D1**2*K*fd*s**2 - 259*D1**2*K*fdd*r**2 - 686*D1**2*K*fdd*r*s - 427*D1**2*K*fdd*s**2 + 175*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 540*D1**2*f*fd*r**2 - 1080*D1**2*f*fd*r*s + 720*D1**2*f*fd*r - 540*D1**2*f*fd*s**2 + 720*D1**2*f*fd*s - 360*D1**2*f*fd + 900*D1**2*f*fdd*r**2 + 1800*D1**2*f*fdd*r*s - 1200*D1**2*f*fdd*r + 900*D1**2*f*fdd*s**2 - 1200*D1**2*f*fdd*s + 600*D1**2*f*fdd + 900*D1**2*fd**2*r**2 + 1800*D1**2*fd**2*r*s - 1200*D1**2*fd**2*r + 900*D1**2*fd**2*s**2 - 1200*D1**2*fd**2*s + 300*D1**2*fd**2 - 203*D1**2*fd*r**2 - 602*D1**2*fd*r*s - 140*D1**2*fd*r - 399*D1**2*fd*s**2 - 140*D1**2*fd*s + 70*D1**2*fd + 469*D1**2*fdd*r**2 + 1106*D1**2*fdd*r*s + 420*D1**2*fdd*r + 637*D1**2*fdd*s**2 + 420*D1**2*fdd*s - 210*D1**2*fdd - 350*D1**2*gd2*r**2 - 700*D1**2*gd2*r*s + 700*D1**2*gd2*r - 350*D1**2*gd2*s**2 + 700*D1**2*gd2*s - 350*D1**2*gd2 - 350*D1**2*gdd2*r**2 - 700*D1**2*gdd2*r*s + 700*D1**2*gdd2*r - 350*D1**2*gdd2*s**2 + 700*D1**2*gdd2*s - 350*D1**2*gdd2 + 532*D1*Dd*K*f*r**2 + 1848*D1*Dd*K*f*r*s - 994*D1*Dd*K*f*r + 1316*D1*Dd*K*f*s**2 - 1582*D1*Dd*K*f*s + 595*D1*Dd*K*f - 2072*D1*Dd*K*fd*r**2 - 5488*D1*Dd*K*fd*r*s + 1722*D1*Dd*K*fd*r - 3416*D1*Dd*K*fd*s**2 + 2226*D1*Dd*K*fd*s - 1080*D1*Dd*f**2*r**2 - 2160*D1*Dd*f**2*r*s + 1620*D1*Dd*f**2*r - 1080*D1*Dd*f**2*s**2 + 1620*D1*Dd*f**2*s - 810*D1*Dd*f**2 + 7200*D1*Dd*f*fd*r**2 + 14400*D1*Dd*f*fd*r*s - 10200*D1*Dd*f*fd*r + 7200*D1*Dd*f*fd*s**2 - 10200*D1*Dd*f*fd*s + 3600*D1*Dd*f*fd - 812*D1*Dd*f*r**2 - 2408*D1*Dd*f*r*s + 1414*D1*Dd*f*r - 1596*D1*Dd*f*s**2 + 2002*D1*Dd*f*s - 805*D1*Dd*f + 3752*D1*Dd*fd*r**2 + 8848*D1*Dd*fd*r*s - 1302*D1*Dd*fd*r + 5096*D1*Dd*fd*s**2 - 1806*D1*Dd*fd*s - 1260*D1*Dd*fd - 1400*D1*Dd*g2*r**2 - 2800*D1*Dd*g2*r*s + 2100*D1*Dd*g2*r - 1400*D1*Dd*g2*s**2 + 2100*D1*Dd*g2*s - 1050*D1*Dd*g2 - 2800*D1*Dd*gd2*r**2 - 5600*D1*Dd*gd2*r*s + 4900*D1*Dd*gd2*r - 2800*D1*Dd*gd2*s**2 + 4900*D1*Dd*gd2*s - 2100*D1*Dd*gd2 - 1036*D1*Ddd*K*f*r**2 - 2744*D1*Ddd*K*f*r*s + 1722*D1*Ddd*K*f*r - 1708*D1*Ddd*K*f*s**2 + 2226*D1*Ddd*K*f*s - 945*D1*Ddd*K*f + 1800*D1*Ddd*f**2*r**2 + 3600*D1*Ddd*f**2*r*s - 2700*D1*Ddd*f**2*r + 1800*D1*Ddd*f**2*s**2 - 2700*D1*Ddd*f**2*s + 1350*D1*Ddd*f**2 + 1876*D1*Ddd*f*r**2 + 4424*D1*Ddd*f*r*s - 2982*D1*Ddd*f*r + 2548*D1*Ddd*f*s**2 - 3486*D1*Ddd*f*s + 1575*D1*Ddd*f - 1400*D1*Ddd*g2*r**2 - 2800*D1*Ddd*g2*r*s + 2100*D1*Ddd*g2*r - 1400*D1*Ddd*g2*s**2 + 2100*D1*Ddd*g2*s - 1050*D1*Ddd*g2 + 175*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 3108*Dd**2*K*f*r**2 - 8232*Dd**2*K*f*r*s + 5166*Dd**2*K*f*r - 5124*Dd**2*K*f*s**2 + 6678*Dd**2*K*f*s - 1890*Dd**2*K*f + 5400*Dd**2*f**2*r**2 + 10800*Dd**2*f**2*r*s - 8100*Dd**2*f**2*r + 5400*Dd**2*f**2*s**2 - 8100*Dd**2*f**2*s + 2700*Dd**2*f**2 + 5628*Dd**2*f*r**2 + 13272*Dd**2*f*r*s - 8946*Dd**2*f*r + 7644*Dd**2*f*s**2 - 10458*Dd**2*f*s + 3150*Dd**2*f - 4200*Dd**2*g2*r**2 - 8400*Dd**2*g2*r*s + 6300*Dd**2*g2*r - 4200*Dd**2*g2*s**2 + 6300*Dd**2*g2*s - 2100*Dd**2*g2) + 3*b1*(588*C*D1**2*f*fd*r**2 + 1608*C*D1**2*f*fd*r*s - 588*C*D1**2*f*fd*r + 1020*C*D1**2*f*fd*s**2 - 804*C*D1**2*f*fd*s + 294*C*D1**2*f*fd - 756*C*D1**2*f*fdd*r**2 - 1896*C*D1**2*f*fdd*r*s + 756*C*D1**2*f*fdd*r - 1140*C*D1**2*f*fdd*s**2 + 948*C*D1**2*f*fdd*s - 378*C*D1**2*f*fdd - 756*C*D1**2*fd**2*r**2 - 1896*C*D1**2*fd**2*r*s + 756*C*D1**2*fd**2*r - 1140*C*D1**2*fd**2*s**2 + 948*C*D1**2*fd**2*s + 1176*C*D1*Dd*f**2*r**2 + 3216*C*D1*Dd*f**2*r*s - 1980*C*D1*Dd*f**2*r + 2040*C*D1*Dd*f**2*s**2 - 2628*C*D1*Dd*f**2*s + 1098*C*D1*Dd*f**2 - 6048*C*D1*Dd*f*fd*r**2 - 15168*C*D1*Dd*f*fd*r*s + 7944*C*D1*Dd*f*fd*r - 9120*C*D1*Dd*f*fd*s**2 + 9864*C*D1*Dd*f*fd*s - 2460*C*D1*Dd*f*fd - 1512*C*D1*Ddd*f**2*r**2 - 3792*C*D1*Ddd*f**2*r*s + 2460*C*D1*Ddd*f**2*r - 2280*C*D1*Ddd*f**2*s**2 + 3036*C*D1*Ddd*f**2*s - 1326*C*D1*Ddd*f**2 - 4536*C*Dd**2*f**2*r**2 - 11376*C*Dd**2*f**2*r*s + 7380*C*Dd**2*f**2*r - 6840*C*Dd**2*f**2*s**2 + 9108*C*Dd**2*f**2*s - 2652*C*Dd**2*f**2 + 90*D1**2*K*f*fd*r**2 + 588*D1**2*K*f*fd*r*s - 294*D1**2*K*f*fd*r + 498*D1**2*K*f*fd*s**2 - 498*D1**2*K*f*fd*s + 249*D1**2*K*f*fd - 150*D1**2*K*f*fdd*r**2 - 756*D1**2*K*f*fdd*r*s + 378*D1**2*K*f*fdd*r - 606*D1**2*K*f*fdd*s**2 + 606*D1**2*K*f*fdd*s - 303*D1**2*K*f*fdd - 150*D1**2*K*fd**2*r**2 - 756*D1**2*K*fd**2*r*s + 378*D1**2*K*fd**2*r - 606*D1**2*K*fd**2*s**2 + 606*D1**2*K*fd**2*s + 350*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(75*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 7*f*(15*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - K*(37*r**2 + 98*r*s - 86*r + 61*s**2 - 110*s + 49) + 67*r**2 + 158*r*s - 176*r + 91*s**2 - 200*s + 94) - 175*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 1080*D1**2*f**2*fd*r**2 + 1710*D1**2*f**2*fd*r*s - 1170*D1**2*f**2*fd*r + 630*D1**2*f**2*fd*s**2 - 870*D1**2*f**2*fd*s + 450*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r**2 - 1710*D1**2*f**2*fdd*r*s + 1470*D1**2*f**2*fdd*r - 450*D1**2*f**2*fdd*s**2 + 930*D1**2*f**2*fdd*s - 630*D1**2*f**2*fdd - 2520*D1**2*f*fd**2*r**2 - 3420*D1**2*f*fd**2*r*s + 2940*D1**2*f*fd**2*r - 900*D1**2*f*fd**2*s**2 + 1860*D1**2*f*fd**2*s - 630*D1**2*f*fd**2 - 948*D1**2*f*fd*r**2 - 2532*D1**2*f*fd*r*s + 1050*D1**2*f*fd*r - 1584*D1**2*f*fd*s**2 + 1368*D1**2*f*fd*s - 576*D1**2*f*fd + 1356*D1**2*f*fdd*r**2 + 3324*D1**2*f*fdd*r*s - 1470*D1**2*f*fdd*r + 1968*D1**2*f*fdd*s**2 - 1776*D1**2*f*fdd*s + 792*D1**2*f*fdd - 266*D1**2*f*gd2*r**2 - 924*D1**2*f*gd2*r*s + 532*D1**2*f*gd2*r - 658*D1**2*f*gd2*s**2 + 924*D1**2*f*gd2*s - 266*D1**2*f*gd2 + 518*D1**2*f*gdd2*r**2 + 1372*D1**2*f*gdd2*r*s - 1036*D1**2*f*gdd2*r + 854*D1**2*f*gdd2*s**2 - 1372*D1**2*f*gdd2*s + 518*D1**2*f*gdd2 + 1356*D1**2*fd**2*r**2 + 3324*D1**2*fd**2*r*s - 1470*D1**2*fd**2*r + 1968*D1**2*fd**2*s**2 - 1776*D1**2*fd**2*s - 266*D1**2*fd*g2*r**2 - 924*D1**2*fd*g2*r*s - 658*D1**2*fd*g2*s**2 + 1036*D1**2*fd*gd2*r**2 + 2744*D1**2*fd*gd2*r*s - 1036*D1**2*fd*gd2*r + 1708*D1**2*fd*gd2*s**2 - 1372*D1**2*fd*gd2*s + 518*D1**2*fdd*g2*r**2 + 1372*D1**2*fdd*g2*r*s + 854*D1**2*fdd*g2*s**2 + 180*D1*Dd*K*f**2*r**2 + 1176*D1*Dd*K*f**2*r*s - 474*D1*Dd*K*f**2*r + 996*D1*Dd*K*f**2*s**2 - 1086*D1*Dd*K*f**2*s + 339*D1*Dd*K*f**2 - 1200*D1*Dd*K*f*fd*r**2 - 6048*D1*Dd*K*f*fd*r*s + 2868*D1*Dd*K*f*fd*r - 4848*D1*Dd*K*f*fd*s**2 + 5148*D1*Dd*K*f*fd*s - 1362*D1*Dd*K*f*fd + 1440*D1*Dd*f**3*r**2 + 2280*D1*Dd*f**3*r*s - 2010*D1*Dd*f**3*r + 840*D1*Dd*f**3*s**2 - 1560*D1*Dd*f**3*s + 930*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r**2 - 13680*D1*Dd*f**2*fd*r*s + 12630*D1*Dd*f**2*fd*r - 3600*D1*Dd*f**2*fd*s**2 + 8040*D1*Dd*f**2*fd*s - 3870*D1*Dd*f**2*fd - 1896*D1*Dd*f**2*r**2 - 5064*D1*Dd*f**2*r*s + 3162*D1*Dd*f**2*r - 3168*D1*Dd*f**2*s**2 + 4116*D1*Dd*f**2*s - 1740*D1*Dd*f**2 + 10848*D1*Dd*f*fd*r**2 + 26592*D1*Dd*f*fd*r*s - 14628*D1*Dd*f*fd*r + 15744*D1*Dd*f*fd*s**2 - 17688*D1*Dd*f*fd*s + 4716*D1*Dd*f*fd - 1064*D1*Dd*f*g2*r**2 - 3696*D1*Dd*f*g2*r*s + 1988*D1*Dd*f*g2*r - 2632*D1*Dd*f*g2*s**2 + 3164*D1*Dd*f*g2*s - 1190*D1*Dd*f*g2 + 4144*D1*Dd*f*gd2*r**2 + 10976*D1*Dd*f*gd2*r*s - 7588*D1*Dd*f*gd2*r + 6832*D1*Dd*f*gd2*s**2 - 9940*D1*Dd*f*gd2*s + 3444*D1*Dd*f*gd2 + 4144*D1*Dd*fd*g2*r**2 + 10976*D1*Dd*fd*g2*r*s - 3444*D1*Dd*fd*g2*r + 6832*D1*Dd*fd*g2*s**2 - 4452*D1*Dd*fd*g2*s - 300*D1*Ddd*K*f**2*r**2 - 1512*D1*Ddd*K*f**2*r*s + 678*D1*Ddd*K*f**2*r - 1212*D1*Ddd*K*f**2*s**2 + 1362*D1*Ddd*K*f**2*s - 453*D1*Ddd*K*f**2 - 1680*D1*Ddd*f**3*r**2 - 2280*D1*Ddd*f**3*r*s + 2250*D1*Ddd*f**3*r - 600*D1*Ddd*f**3*s**2 + 1440*D1*Ddd*f**3*s - 990*D1*Ddd*f**3 + 2712*D1*Ddd*f**2*r**2 + 6648*D1*Ddd*f**2*r*s - 4374*D1*Ddd*f**2*r + 3936*D1*Ddd*f**2*s**2 - 5292*D1*Ddd*f**2*s + 2340*D1*Ddd*f**2 + 2072*D1*Ddd*f*g2*r**2 + 5488*D1*Ddd*f*g2*r*s - 3444*D1*Ddd*f*g2*r + 3416*D1*Ddd*f*g2*s**2 - 4452*D1*Ddd*f*g2*s + 1890*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(45*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + f*(35*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*K*(19*r**2 + 66*r*s - 52*r + 47*s**2 - 80*s + 33) - 900*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 203*r**2 + 602*r*s - 574*r + 399*s**2 - 770*s + 336) - 14*fd*(15*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 61*K*s**2 + 55*K*s + r**2*(67 - 37*K) + r*(-98*K*s + 43*K + 158*s - 58) + 91*s**2 - 70*s - 15) + 175*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 350*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(75*f**2*(24*r**2 + r*(48*s - 38) + 24*s**2 - 38*s + 15) + 7*f*(15*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(148*r**2 + 392*r*s - 295*r + 244*s**2 - 379*s + 141) + 268*r**2 + 632*r*s - 565*r + 364*s**2 - 649*s + 276) - 175*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 900*Dd**2*K*f**2*r**2 - 4536*Dd**2*K*f**2*r*s + 2034*Dd**2*K*f**2*r - 3636*Dd**2*K*f**2*s**2 + 4086*Dd**2*K*f**2*s - 906*Dd**2*K*f**2 - 5040*Dd**2*f**3*r**2 - 6840*Dd**2*f**3*r*s + 6750*Dd**2*f**3*r - 1800*Dd**2*f**3*s**2 + 4320*Dd**2*f**3*s - 1980*Dd**2*f**3 + 8136*Dd**2*f**2*r**2 + 19944*Dd**2*f**2*r*s - 13122*Dd**2*f**2*r + 11808*Dd**2*f**2*s**2 - 15876*Dd**2*f**2*s + 4680*Dd**2*f**2 + 6216*Dd**2*f*g2*r**2 + 16464*Dd**2*f*g2*r*s - 10332*Dd**2*f*g2*r + 10248*Dd**2*f*g2*s**2 - 13356*Dd**2*f*g2*s + 3780*Dd**2*f*g2))/(630*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**2*k1**4*st**2*(b1*(D1**2*(f**2*(11*fd - 10*fdd)*(r*(6*s - 2) + 6*s**2 - 7*s + 2) + f*(-10*fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3) + 11*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(22*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-10*fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11) + 11*r*(4*s - 1) + 11*(1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(20*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(20*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(10*bdd1*f**2*s*(2*r + 2*s - 1) + f*(9*bdd1*s*(r + s - 1) - 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(11*f*s*(f*(2*r + 2*s - 1) + r + s - 1) - fd*(10*f*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + 9*r*(4*s - 1) + 9*(1 - 2*s)**2)) - Dd*f*(10*f*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 72*r*s - 9*r + 72*s**2 - 72*s + 9)) + D1*f*(Dd*(7*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2**2*k3**3) + D1**2*Pk2*Pkd3*ct**2*k1**4*(6*D1*b1*bd1*(D1*(9*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(-15*fd*(4*s - 1)*(4*r + 4*s - 3) + (2*s - 1)*(7*r + 7*s - 7)) + 21*fd*(-4*r*s + r + s*(3 - 4*s))) - 3*Dd*f*(5*f*(8*s - 3)*(4*r + 4*s - 3) + 112*r*s - 42*r + 112*s**2 - 140*s + 35)) + 6*b1**2*(D1**2*s*(3*f*(3*fd - 5*fdd)*(4*r + 4*s - 3) - 15*fd**2*(4*r + 4*s - 3) + 7*fd*(r + s) - 21*fdd*(r + s)) + D1*(Dd*(18*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-15*fd*(8*s - 1)*(4*r + 4*s - 3) + 7*r*(4*s - 1) + 7*(1 - 2*s)**2) - 21*fd*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(10*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(10*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 9*b1*(2*D1**2*bdd1*f*(5*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + (2*s - 1)*(7*r + 7*s - 7)) + D1**2*(15*f**2*(fd - fdd)*(r*(6*s - 2) + 6*s**2 - 7*s + 2) + f*(-15*fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3) + fd*(22*r*s - 17*r + 22*s**2 - 28*s + 17) + fdd*(-18*r*s + 19*r - 18*s**2 + 28*s - 19)) + fd**2*(r*(19 - 18*s) + s*(28 - 18*s))) + D1*f*(Dd*(30*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-15*fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11) + 11*r*(4*s - 1) + 11*(1 - 2*s)**2) - 2*fd*(r*(72*s - 47) + 72*s**2 - 92*s + 33)) - 3*Ddd*f*(10*f + 3)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(10*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-18*D1**2*bd1**2*(5*f*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*s - 1)*(7*r + 7*s - 7)) + 9*D1**2*bdd1*f*(-15*f*s + r*(s*(30*f + 9) + 10) + s**2*(30*f + 9) + s - 10) - 5*D1**2*(f*(23*fd - 25*fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 9*D1*bd1*(D1*(15*f**2*s*(2*r + 2*s - 1) - 15*f*fd*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + f*(11*s + 6)*(r + s - 1) - fd*(36*r*s + r + 36*s**2 - 26*s + 9)) - Dd*f*(15*f*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 72*r*s + 31*r + 72*s**2 - 32*s - 21)) - 5*D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 25*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 125*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k2**2*k3**3) + D1**2*Pk2*Pkd3*ct**2*k1**2*k2**4*st**6*(132*C*D1**2*f**2*fd*r**2 + 264*C*D1**2*f**2*fd*r*s - 176*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 176*C*D1**2*f**2*fd*s + 88*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r**2 - 132*C*D1**2*f**2*fdd*r*s + 88*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 88*C*D1**2*f**2*fdd*s - 44*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r**2 - 264*C*D1**2*f*fd**2*r*s + 176*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 176*C*D1**2*f*fd**2*s - 44*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r**2 + 352*C*D1*Dd*f**3*r*s - 264*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 264*C*D1*Dd*f**3*s + 132*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r**2 - 1056*C*D1*Dd*f**2*fd*r*s + 748*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 748*C*D1*Dd*f**2*fd*s - 264*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r**2 - 176*C*D1*Ddd*f**3*r*s + 132*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 132*C*D1*Ddd*f**3*s - 66*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r**2 - 528*C*Dd**2*f**3*r*s + 396*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 396*C*Dd**2*f**3*s - 132*C*Dd**2*f**3 + 396*D1**2*K*b1*f*fd*r**2 + 792*D1**2*K*b1*f*fd*r*s - 396*D1**2*K*b1*f*fd*r + 396*D1**2*K*b1*f*fd*s**2 - 396*D1**2*K*b1*f*fd*s + 198*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 396*D1**2*K*b1*f*fdd*r*s + 198*D1**2*K*b1*f*fdd*r - 198*D1**2*K*b1*f*fdd*s**2 + 198*D1**2*K*b1*f*fdd*s - 99*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 396*D1**2*K*b1*fd**2*r*s + 198*D1**2*K*b1*fd**2*r - 198*D1**2*K*b1*fd**2*s**2 + 198*D1**2*K*b1*fd**2*s - 396*D1**2*b1*f*fd*r**2 - 792*D1**2*b1*f*fd*r*s + 396*D1**2*b1*f*fd*r - 396*D1**2*b1*f*fd*s**2 + 396*D1**2*b1*f*fd*s - 198*D1**2*b1*f*fd + 198*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 198*D1**2*b1*f*fdd*s**2 - 198*D1**2*b1*f*fdd*s + 99*D1**2*b1*f*fdd + 198*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 198*D1**2*b1*fd**2*s**2 - 198*D1**2*b1*fd**2*s - 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 672*D1**2*f**3*fd*r**2 + 1344*D1**2*f**3*fd*r*s - 1008*D1**2*f**3*fd*r + 672*D1**2*f**3*fd*s**2 - 1008*D1**2*f**3*fd*s + 504*D1**2*f**3*fd - 336*D1**2*f**3*fdd*r**2 - 672*D1**2*f**3*fdd*r*s + 504*D1**2*f**3*fdd*r - 336*D1**2*f**3*fdd*s**2 + 504*D1**2*f**3*fdd*s - 252*D1**2*f**3*fdd - 1008*D1**2*f**2*fd**2*r**2 - 2016*D1**2*f**2*fd**2*r*s + 1512*D1**2*f**2*fd**2*r - 1008*D1**2*f**2*fd**2*s**2 + 1512*D1**2*f**2*fd**2*s - 504*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r**2 - 264*D1**2*f**2*fd*r*s + 176*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 176*D1**2*f**2*fd*s - 88*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r**2 + 132*D1**2*f**2*fdd*r*s - 88*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 88*D1**2*f**2*fdd*s + 44*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 396*D1**2*f**2*gd2*s**2 + 792*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 396*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 132*D1**2*f*fd**2*r**2 + 264*D1**2*f*fd**2*r*s - 176*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 176*D1**2*f*fd**2*s + 44*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 792*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1584*D1**2*f*fd*gd2*r*s - 1188*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1188*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 792*D1*Dd*K*b1*f**2*r**2 + 1584*D1*Dd*K*b1*f**2*r*s - 1188*D1*Dd*K*b1*f**2*r + 792*D1*Dd*K*b1*f**2*s**2 - 1188*D1*Dd*K*b1*f**2*s + 594*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 3168*D1*Dd*K*b1*f*fd*r*s + 1980*D1*Dd*K*b1*f*fd*r - 1584*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 594*D1*Dd*K*b1*f*fd - 792*D1*Dd*b1*f**2*r**2 - 1584*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 792*D1*Dd*b1*f**2*s**2 + 1188*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r + 1584*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s + 594*D1*Dd*b1*f*fd + 672*D1*Dd*f**4*r**2 + 1344*D1*Dd*f**4*r*s - 1008*D1*Dd*f**4*r + 672*D1*Dd*f**4*s**2 - 1008*D1*Dd*f**4*s + 504*D1*Dd*f**4 - 2688*D1*Dd*f**3*fd*r**2 - 5376*D1*Dd*f**3*fd*r*s + 4032*D1*Dd*f**3*fd*r - 2688*D1*Dd*f**3*fd*s**2 + 4032*D1*Dd*f**3*fd*s - 1512*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r**2 - 352*D1*Dd*f**3*r*s + 264*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 264*D1*Dd*f**3*s - 132*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r**2 + 1056*D1*Dd*f**2*fd*r*s - 748*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 748*D1*Dd*f**2*fd*s + 264*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 2376*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 3168*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 1188*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 6336*D1*Dd*f*fd*g2*r*s - 3960*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 1188*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 792*D1*Ddd*K*b1*f**2*r*s + 594*D1*Ddd*K*b1*f**2*r - 396*D1*Ddd*K*b1*f**2*s**2 + 594*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 396*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 396*D1*Ddd*b1*f**2*s**2 - 594*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 - 336*D1*Ddd*f**4*r**2 - 672*D1*Ddd*f**4*r*s + 504*D1*Ddd*f**4*r - 336*D1*Ddd*f**4*s**2 + 504*D1*Ddd*f**4*s - 252*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r**2 + 176*D1*Ddd*f**3*r*s - 132*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 132*D1*Ddd*f**3*s + 66*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1584*D1*Ddd*f**2*g2*r*s - 1188*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1188*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1188*Dd**2*K*b1*f**2*r**2 - 2376*Dd**2*K*b1*f**2*r*s + 1782*Dd**2*K*b1*f**2*r - 1188*Dd**2*K*b1*f**2*s**2 + 1782*Dd**2*K*b1*f**2*s - 594*Dd**2*K*b1*f**2 + 1188*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 1188*Dd**2*b1*f**2*s**2 - 1782*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 - 1008*Dd**2*f**4*r**2 - 2016*Dd**2*f**4*r*s + 1512*Dd**2*f**4*r - 1008*Dd**2*f**4*s**2 + 1512*Dd**2*f**4*s - 504*Dd**2*f**4 + 264*Dd**2*f**3*r**2 + 528*Dd**2*f**3*r*s - 396*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 396*Dd**2*f**3*s + 132*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 4752*Dd**2*f**2*g2*r*s - 3564*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3564*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2)/(154*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct**2*k1**2*k2**4*st**4*(-6*C*D1**2*bdd1*f**2*r**2 - 12*C*D1**2*bdd1*f**2*r*s + 12*C*D1**2*bdd1*f**2*r - 6*C*D1**2*bdd1*f**2*s**2 + 12*C*D1**2*bdd1*f**2*s - 6*C*D1**2*bdd1*f**2 + 390*C*D1**2*f**2*fd*r**2 + 780*C*D1**2*f**2*fd*r*s - 520*C*D1**2*f**2*fd*r + 390*C*D1**2*f**2*fd*s**2 - 520*C*D1**2*f**2*fd*s + 260*C*D1**2*f**2*fd - 240*C*D1**2*f**2*fdd*r**2 - 480*C*D1**2*f**2*fdd*r*s + 320*C*D1**2*f**2*fdd*r - 240*C*D1**2*f**2*fdd*s**2 + 320*C*D1**2*f**2*fdd*s - 160*C*D1**2*f**2*fdd - 480*C*D1**2*f*fd**2*r**2 - 960*C*D1**2*f*fd**2*r*s + 640*C*D1**2*f*fd**2*r - 480*C*D1**2*f*fd**2*s**2 + 640*C*D1**2*f*fd**2*s - 160*C*D1**2*f*fd**2 + 520*C*D1*Dd*f**3*r**2 + 1040*C*D1*Dd*f**3*r*s - 780*C*D1*Dd*f**3*r + 520*C*D1*Dd*f**3*s**2 - 780*C*D1*Dd*f**3*s + 390*C*D1*Dd*f**3 - 1920*C*D1*Dd*f**2*fd*r**2 - 3840*C*D1*Dd*f**2*fd*r*s + 2720*C*D1*Dd*f**2*fd*r - 1920*C*D1*Dd*f**2*fd*s**2 + 2720*C*D1*Dd*f**2*fd*s - 960*C*D1*Dd*f**2*fd - 320*C*D1*Ddd*f**3*r**2 - 640*C*D1*Ddd*f**3*r*s + 480*C*D1*Ddd*f**3*r - 320*C*D1*Ddd*f**3*s**2 + 480*C*D1*Ddd*f**3*s - 240*C*D1*Ddd*f**3 - 960*C*Dd**2*f**3*r**2 - 1920*C*Dd**2*f**3*r*s + 1440*C*Dd**2*f**3*r - 960*C*Dd**2*f**3*s**2 + 1440*C*Dd**2*f**3*s - 480*C*Dd**2*f**3 - 120*D1**2*K*bdd1*f**2*r**2 - 240*D1**2*K*bdd1*f**2*r*s + 240*D1**2*K*bdd1*f**2*r - 120*D1**2*K*bdd1*f**2*s**2 + 240*D1**2*K*bdd1*f**2*s - 120*D1**2*K*bdd1*f**2 - 42*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 60*D1**2*bdd1*f**3*r**2 + 120*D1**2*bdd1*f**3*r*s - 120*D1**2*bdd1*f**3*r + 60*D1**2*bdd1*f**3*s**2 - 120*D1**2*bdd1*f**3*s + 60*D1**2*bdd1*f**3 + 66*D1**2*bdd1*f**2*r**2 + 132*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*r + 66*D1**2*bdd1*f**2*s**2 - 132*D1**2*bdd1*f**2*s + 66*D1**2*bdd1*f**2 + 42*D1**2*bdd1*f*g2*r**2 + 84*D1**2*bdd1*f*g2*r*s - 84*D1**2*bdd1*f*g2*r + 42*D1**2*bdd1*f*g2*s**2 - 84*D1**2*bdd1*f*g2*s + 42*D1**2*bdd1*f*g2 - 60*D1**2*f**3*fd*r**2 - 120*D1**2*f**3*fd*r*s + 90*D1**2*f**3*fd*r - 60*D1**2*f**3*fd*s**2 + 90*D1**2*f**3*fd*s - 45*D1**2*f**3*fd - 288*D1**2*f**2*fd*r**2 - 576*D1**2*f**2*fd*r*s + 384*D1**2*f**2*fd*r - 288*D1**2*f**2*fd*s**2 + 384*D1**2*f**2*fd*s - 192*D1**2*f**2*fd + 180*D1**2*f**2*fdd*r**2 + 360*D1**2*f**2*fdd*r*s - 240*D1**2*f**2*fdd*r + 180*D1**2*f**2*fdd*s**2 - 240*D1**2*f**2*fdd*s + 120*D1**2*f**2*fdd - 270*D1**2*f**2*gd2*r**2 - 540*D1**2*f**2*gd2*r*s + 540*D1**2*f**2*gd2*r - 270*D1**2*f**2*gd2*s**2 + 540*D1**2*f**2*gd2*s - 270*D1**2*f**2*gd2 + 240*D1**2*f**2*gdd2*r**2 + 480*D1**2*f**2*gdd2*r*s - 480*D1**2*f**2*gdd2*r + 240*D1**2*f**2*gdd2*s**2 - 480*D1**2*f**2*gdd2*s + 240*D1**2*f**2*gdd2 + 360*D1**2*f*fd**2*r**2 + 720*D1**2*f*fd**2*r*s - 480*D1**2*f*fd**2*r + 360*D1**2*f*fd**2*s**2 - 480*D1**2*f*fd**2*s + 120*D1**2*f*fd**2 - 540*D1**2*f*fd*g2*r**2 - 1080*D1**2*f*fd*g2*r*s + 540*D1**2*f*fd*g2*r - 540*D1**2*f*fd*g2*s**2 + 540*D1**2*f*fd*g2*s - 270*D1**2*f*fd*g2 + 960*D1**2*f*fd*gd2*r**2 + 1920*D1**2*f*fd*gd2*r*s - 1440*D1**2*f*fd*gd2*r + 960*D1**2*f*fd*gd2*s**2 - 1440*D1**2*f*fd*gd2*s + 480*D1**2*f*fd*gd2 + 480*D1**2*f*fdd*g2*r**2 + 960*D1**2*f*fdd*g2*r*s - 480*D1**2*f*fdd*g2*r + 480*D1**2*f*fdd*g2*s**2 - 480*D1**2*f*fdd*g2*s + 240*D1**2*f*fdd*g2 + 480*D1**2*fd**2*g2*r**2 + 960*D1**2*fd**2*g2*r*s - 480*D1**2*fd**2*g2*r + 480*D1**2*fd**2*g2*s**2 - 480*D1**2*fd**2*g2*s - 60*D1*Dd*f**4*r**2 - 120*D1*Dd*f**4*r*s + 90*D1*Dd*f**4*r - 60*D1*Dd*f**4*s**2 + 90*D1*Dd*f**4*s - 45*D1*Dd*f**4 - 384*D1*Dd*f**3*r**2 - 768*D1*Dd*f**3*r*s + 576*D1*Dd*f**3*r - 384*D1*Dd*f**3*s**2 + 576*D1*Dd*f**3*s - 288*D1*Dd*f**3 + 1440*D1*Dd*f**2*fd*r**2 + 2880*D1*Dd*f**2*fd*r*s - 2040*D1*Dd*f**2*fd*r + 1440*D1*Dd*f**2*fd*s**2 - 2040*D1*Dd*f**2*fd*s + 720*D1*Dd*f**2*fd - 1080*D1*Dd*f**2*g2*r**2 - 2160*D1*Dd*f**2*g2*r*s + 1620*D1*Dd*f**2*g2*r - 1080*D1*Dd*f**2*g2*s**2 + 1620*D1*Dd*f**2*g2*s - 810*D1*Dd*f**2*g2 + 1920*D1*Dd*f**2*gd2*r**2 + 3840*D1*Dd*f**2*gd2*r*s - 3360*D1*Dd*f**2*gd2*r + 1920*D1*Dd*f**2*gd2*s**2 - 3360*D1*Dd*f**2*gd2*s + 1440*D1*Dd*f**2*gd2 + 3840*D1*Dd*f*fd*g2*r**2 + 7680*D1*Dd*f*fd*g2*r*s - 4800*D1*Dd*f*fd*g2*r + 3840*D1*Dd*f*fd*g2*s**2 - 4800*D1*Dd*f*fd*g2*s + 1440*D1*Dd*f*fd*g2 + 240*D1*Ddd*f**3*r**2 + 480*D1*Ddd*f**3*r*s - 360*D1*Ddd*f**3*r + 240*D1*Ddd*f**3*s**2 - 360*D1*Ddd*f**3*s + 180*D1*Ddd*f**3 + 960*D1*Ddd*f**2*g2*r**2 + 1920*D1*Ddd*f**2*g2*r*s - 1440*D1*Ddd*f**2*g2*r + 960*D1*Ddd*f**2*g2*s**2 - 1440*D1*Ddd*f**2*g2*s + 720*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(30*f**3*(r + s - 1) - f**2*(4*C*(r + s - 1) + 40*fd*(3*r + 3*s - 2) + (45*K - 23)*(r + s - 1)) + 4*f*(fd*(C + 20*K - 11)*(2*r + 2*s - 1) + (7*g2 - 7*gd2)*(r + s - 1)) - 28*fd*g2*(r + s)) - 4*Dd*f*(10*f**2 - f*(C + 20*K - 11) + 7*g2)*(4*r + 4*s - 3))*(r + s - 1) + 720*Dd**2*f**3*r**2 + 1440*Dd**2*f**3*r*s - 1080*Dd**2*f**3*r + 720*Dd**2*f**3*s**2 - 1080*Dd**2*f**3*s + 360*Dd**2*f**3 + 2880*Dd**2*f**2*g2*r**2 + 5760*Dd**2*f**2*g2*r*s - 4320*Dd**2*f**2*g2*r + 2880*Dd**2*f**2*g2*s**2 - 4320*Dd**2*f**2*g2*s + 1440*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(8*C*D1**2*f*fd*r**2 + 16*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd*s + 4*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 - 8*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 4*C*D1**2*f*fdd*s - 2*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 - 8*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 4*C*D1**2*fd**2*s + 16*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 24*C*D1*Dd*f**2*s + 12*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 - 64*C*D1*Dd*f*fd*r*s + 40*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 40*C*D1*Dd*f*fd*s - 12*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 - 16*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 12*C*D1*Ddd*f**2*s - 6*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 - 48*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 36*C*Dd**2*f**2*s - 12*C*Dd**2*f**2 + 90*D1**2*K*f*fd*r**2 + 180*D1**2*K*f*fd*r*s - 90*D1**2*K*f*fd*r + 90*D1**2*K*f*fd*s**2 - 90*D1**2*K*f*fd*s + 45*D1**2*K*f*fd - 80*D1**2*K*f*fdd*r**2 - 160*D1**2*K*f*fdd*r*s + 80*D1**2*K*f*fdd*r - 80*D1**2*K*f*fdd*s**2 + 80*D1**2*K*f*fdd*s - 40*D1**2*K*f*fdd - 80*D1**2*K*fd**2*r**2 - 160*D1**2*K*fd**2*r*s + 80*D1**2*K*fd**2*r - 80*D1**2*K*fd**2*s**2 + 80*D1**2*K*fd**2*s - 14*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 90*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 120*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 80*D1**2*f**2*fdd*s + 40*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 240*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 160*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 46*D1**2*f*fd*r**2 - 92*D1**2*f*fd*r*s + 46*D1**2*f*fd*r - 46*D1**2*f*fd*s**2 + 46*D1**2*f*fd*s - 23*D1**2*f*fd + 44*D1**2*f*fdd*r**2 + 88*D1**2*f*fdd*r*s - 44*D1**2*f*fdd*r + 44*D1**2*f*fdd*s**2 - 44*D1**2*f*fdd*s + 22*D1**2*f*fdd - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 14*D1**2*f*gdd2*r**2 + 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 + 44*D1**2*fd**2*r**2 + 88*D1**2*fd**2*r*s - 44*D1**2*fd**2*r + 44*D1**2*fd**2*s**2 - 44*D1**2*fd**2*s - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s - 28*D1**2*fd*g2*s**2 + 28*D1**2*fd*gd2*r**2 + 56*D1**2*fd*gd2*r*s - 28*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 28*D1**2*fd*gd2*s + 14*D1**2*fdd*g2*r**2 + 28*D1**2*fdd*g2*r*s + 14*D1**2*fdd*g2*s**2 + 180*D1*Dd*K*f**2*r**2 + 360*D1*Dd*K*f**2*r*s - 270*D1*Dd*K*f**2*r + 180*D1*Dd*K*f**2*s**2 - 270*D1*Dd*K*f**2*s + 135*D1*Dd*K*f**2 - 640*D1*Dd*K*f*fd*r**2 - 1280*D1*Dd*K*f*fd*r*s + 800*D1*Dd*K*f*fd*r - 640*D1*Dd*K*f*fd*s**2 + 800*D1*Dd*K*f*fd*s - 240*D1*Dd*K*f*fd - 120*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 180*D1*Dd*f**3*s - 90*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 960*D1*Dd*f**2*fd*r*s - 680*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 680*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd - 92*D1*Dd*f**2*r**2 - 184*D1*Dd*f**2*r*s + 138*D1*Dd*f**2*r - 92*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 69*D1*Dd*f**2 + 352*D1*Dd*f*fd*r**2 + 704*D1*Dd*f*fd*r*s - 440*D1*Dd*f*fd*r + 352*D1*Dd*f*fd*s**2 - 440*D1*Dd*f*fd*s + 132*D1*Dd*f*fd - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 + 224*D1*Dd*f*gd2*r*s - 196*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 196*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r**2 + 224*D1*Dd*fd*g2*r*s - 84*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 84*D1*Dd*fd*g2*s - 160*D1*Ddd*K*f**2*r**2 - 320*D1*Ddd*K*f**2*r*s + 240*D1*Ddd*K*f**2*r - 160*D1*Ddd*K*f**2*s**2 + 240*D1*Ddd*K*f**2*s - 120*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r**2 + 160*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 120*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 88*D1*Ddd*f**2*r**2 + 176*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 88*D1*Ddd*f**2*s**2 - 132*D1*Ddd*f**2*s + 66*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 + 112*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 84*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 28*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 480*Dd**2*K*f**2*r**2 - 960*Dd**2*K*f**2*r*s + 720*Dd**2*K*f**2*r - 480*Dd**2*K*f**2*s**2 + 720*Dd**2*K*f**2*s - 240*Dd**2*K*f**2 + 240*Dd**2*f**3*r**2 + 480*Dd**2*f**3*r*s - 360*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 360*Dd**2*f**3*s + 120*Dd**2*f**3 + 264*Dd**2*f**2*r**2 + 528*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 264*Dd**2*f**2*s**2 - 396*Dd**2*f**2*s + 132*Dd**2*f**2 + 168*Dd**2*f*g2*r**2 + 336*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 252*Dd**2*f*g2*s + 84*Dd**2*f*g2))/(70*d**2*k3**7) - 3*D1**2*Pk2*Pkd3*ct**2*k1**2*k2**4*st**2*(-12*D1**2*bd1**2*f*(-28*K + 15*f + 14)*(r + s - 1)**2 + 12*D1**2*bdd1*f*(3*f*(4*C + 3*K - 3) - 28*g2)*(r + s - 1)**2 + 12*D1**2*(f**2*(-fd*(5*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (gd2 - 18*gdd2)*(r + s - 1)**2) + f*(fd**2*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + fd*(g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 36*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 18*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 36*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*D1*bd1*(D1*(18*f**3*(r + s - 1) + f**2*(109*C + 3*K - 59)*(r + s - 1) - 36*f*fd*(4*C + 3*K - 3)*(2*r + 2*s - 1) - 7*f*(23*g2 - 48*gd2)*(r + s - 1) + 336*fd*g2*(r + s)) - 12*Dd*f*(3*f*(4*C + 3*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 12*D1*f*(Dd*(f**2*(5*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-fd*(20*C - 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 36*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 36*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(f*(10*C - 5) - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 72*Dd**2*f**2*(f*(10*C - 5) - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + b1**2*(D1**2*(6*f*(23*fd - 15*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(180*fd**2*(r + s - 1) + 7*fd*(23*K - 9)*(r + s) - 84*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(138*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(180*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (161*K - 63)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 168*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-28*K + 15*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-28*K + 15*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(-218*C*D1**2*f*fd*r**2 - 436*C*D1**2*f*fd*r*s + 218*C*D1**2*f*fd*r - 218*C*D1**2*f*fd*s**2 + 218*C*D1**2*f*fd*s - 109*C*D1**2*f*fd + 144*C*D1**2*f*fdd*r**2 + 288*C*D1**2*f*fdd*r*s - 144*C*D1**2*f*fdd*r + 144*C*D1**2*f*fdd*s**2 - 144*C*D1**2*f*fdd*s + 72*C*D1**2*f*fdd + 144*C*D1**2*fd**2*r**2 + 288*C*D1**2*fd**2*r*s - 144*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 144*C*D1**2*fd**2*s - 436*C*D1*Dd*f**2*r**2 - 872*C*D1*Dd*f**2*r*s + 654*C*D1*Dd*f**2*r - 436*C*D1*Dd*f**2*s**2 + 654*C*D1*Dd*f**2*s - 327*C*D1*Dd*f**2 + 1152*C*D1*Dd*f*fd*r**2 + 2304*C*D1*Dd*f*fd*r*s - 1440*C*D1*Dd*f*fd*r + 1152*C*D1*Dd*f*fd*s**2 - 1440*C*D1*Dd*f*fd*s + 432*C*D1*Dd*f*fd + 288*C*D1*Ddd*f**2*r**2 + 576*C*D1*Ddd*f**2*r*s - 432*C*D1*Ddd*f**2*r + 288*C*D1*Ddd*f**2*s**2 - 432*C*D1*Ddd*f**2*s + 216*C*D1*Ddd*f**2 + 864*C*Dd**2*f**2*r**2 + 1728*C*Dd**2*f**2*r*s - 1296*C*Dd**2*f**2*r + 864*C*Dd**2*f**2*s**2 - 1296*C*Dd**2*f**2*s + 432*C*Dd**2*f**2 - 6*D1**2*K*f*fd*r**2 - 12*D1**2*K*f*fd*r*s + 6*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd + 108*D1**2*K*f*fdd*r**2 + 216*D1**2*K*f*fdd*r*s - 108*D1**2*K*f*fdd*r + 108*D1**2*K*f*fdd*s**2 - 108*D1**2*K*f*fdd*s + 54*D1**2*K*f*fdd + 108*D1**2*K*fd**2*r**2 + 216*D1**2*K*fd**2*r*s - 108*D1**2*K*fd**2*r + 108*D1**2*K*fd**2*s**2 - 108*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-28*K + 15*f + 14)*(r + s - 1)**2 - 54*D1**2*f**2*fd*r**2 - 108*D1**2*f**2*fd*r*s + 72*D1**2*f**2*fd*r - 54*D1**2*f**2*fd*s**2 + 72*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 118*D1**2*f*fd*r**2 + 236*D1**2*f*fd*r*s - 118*D1**2*f*fd*r + 118*D1**2*f*fd*s**2 - 118*D1**2*f*fd*s + 59*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 216*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*r - 108*D1**2*f*fdd*s**2 + 108*D1**2*f*fdd*s - 54*D1**2*f*fdd + 161*D1**2*f*gd2*r**2 + 322*D1**2*f*gd2*r*s - 322*D1**2*f*gd2*r + 161*D1**2*f*gd2*s**2 - 322*D1**2*f*gd2*s + 161*D1**2*f*gd2 - 168*D1**2*f*gdd2*r**2 - 336*D1**2*f*gdd2*r*s + 336*D1**2*f*gdd2*r - 168*D1**2*f*gdd2*s**2 + 336*D1**2*f*gdd2*s - 168*D1**2*f*gdd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 108*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 108*D1**2*fd**2*s + 161*D1**2*fd*g2*r**2 + 322*D1**2*fd*g2*r*s + 161*D1**2*fd*g2*s**2 - 336*D1**2*fd*gd2*r**2 - 672*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s**2 + 336*D1**2*fd*gd2*s - 168*D1**2*fdd*g2*r**2 - 336*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*s**2 - 12*D1*Dd*K*f**2*r**2 - 24*D1*Dd*K*f**2*r*s + 18*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 18*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 864*D1*Dd*K*f*fd*r**2 + 1728*D1*Dd*K*f*fd*r*s - 1080*D1*Dd*K*f*fd*r + 864*D1*Dd*K*f*fd*s**2 - 1080*D1*Dd*K*f*fd*s + 324*D1*Dd*K*f*fd - 72*D1*Dd*f**3*r**2 - 144*D1*Dd*f**3*r*s + 108*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 108*D1*Dd*f**3*s - 54*D1*Dd*f**3 + 236*D1*Dd*f**2*r**2 + 472*D1*Dd*f**2*r*s - 354*D1*Dd*f**2*r + 236*D1*Dd*f**2*s**2 - 354*D1*Dd*f**2*s + 177*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 1728*D1*Dd*f*fd*r*s + 1080*D1*Dd*f*fd*r - 864*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 324*D1*Dd*f*fd + 644*D1*Dd*f*g2*r**2 + 1288*D1*Dd*f*g2*r*s - 966*D1*Dd*f*g2*r + 644*D1*Dd*f*g2*s**2 - 966*D1*Dd*f*g2*s + 483*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r**2 - 2688*D1*Dd*f*gd2*r*s + 2352*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 2352*D1*Dd*f*gd2*s - 1008*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r**2 - 2688*D1*Dd*fd*g2*r*s + 1008*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 + 1008*D1*Dd*fd*g2*s + 216*D1*Ddd*K*f**2*r**2 + 432*D1*Ddd*K*f**2*r*s - 324*D1*Ddd*K*f**2*r + 216*D1*Ddd*K*f**2*s**2 - 324*D1*Ddd*K*f**2*s + 162*D1*Ddd*K*f**2 - 216*D1*Ddd*f**2*r**2 - 432*D1*Ddd*f**2*r*s + 324*D1*Ddd*f**2*r - 216*D1*Ddd*f**2*s**2 + 324*D1*Ddd*f**2*s - 162*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 - 1344*D1*Ddd*f*g2*r*s + 1008*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 1008*D1*Ddd*f*g2*s - 504*D1*Ddd*f*g2 + D1*bd1*(D1*(138*f**2*(r + s - 1) - 180*f*fd*(2*r + 2*s - 1) - 7*f*(23*K - 9)*(r + s - 1) + 168*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-28*K + 15*f + 14)*(4*r + 4*s - 3))*(r + s - 1) + 648*Dd**2*K*f**2*r**2 + 1296*Dd**2*K*f**2*r*s - 972*Dd**2*K*f**2*r + 648*Dd**2*K*f**2*s**2 - 972*Dd**2*K*f**2*s + 324*Dd**2*K*f**2 - 648*Dd**2*f**2*r**2 - 1296*Dd**2*f**2*r*s + 972*Dd**2*f**2*r - 648*Dd**2*f**2*s**2 + 972*Dd**2*f**2*s - 324*Dd**2*f**2 - 2016*Dd**2*f*g2*r**2 - 4032*Dd**2*f*g2*r*s + 3024*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 3024*Dd**2*f*g2*s - 1008*Dd**2*f*g2))/(70*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct**2*k1**2*k2**4*(-3*D1*(84*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(f**2*(6*C + 7*K - 17)*(r + s - 1) + f*fd*(120*C - 60)*(2*r + 2*s - 1) - 42*f*(g2 + 4*gd2)*(r + s - 1) - 168*fd*g2*(r + s)) + 12*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) + f*(6*D1*bdd1*(f*(10*C - 5) - 14*g2)*(r + s - 1)**2 + D1*(f*(fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*gd2*(r + s - 1)**2) - 14*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + 7*b1**2*(D1**2*(9*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)**2*(18*K*fdd + fd*(9*K - 10))) + D1*(Dd*(-36*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(9*K - 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-3*D1**2*(f*(fd*(6*C + 7*K - 17)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*(r + s - 1)**2*(14*K*bdd1 - 7*gd2 - 14*gdd2)) + (6*r + 6*s)*(fd**2*(20*C - 10)*(r + s - 1) - 7*fd*(g2*(r + s) + 4*gd2*(r + s - 1)) - 14*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-36*K*fd*(r + s) + 9*f**2*(r + s - 1) - f*(9*K - 10)*(r + s - 1)) - 36*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(f**2*(6*C + 7*K - 17)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*f*(fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 28*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 168*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 6*Ddd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*f*(f*(10*C - 5) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**2*k1**2*k2**2*st**6*(132*C*D1**2*f**2*fd*r*s - 44*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 132*C*D1**2*f**2*fd*s + 44*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r*s + 22*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 66*C*D1**2*f**2*fdd*s - 22*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r*s + 44*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 132*C*D1**2*f*fd**2*s - 22*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r*s - 44*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 176*C*D1*Dd*f**3*s + 44*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r*s + 154*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 528*C*D1*Dd*f**2*fd*s - 110*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r*s + 22*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 88*C*D1*Ddd*f**3*s - 22*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r*s + 66*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 264*C*Dd**2*f**3*s - 44*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 672*D1**2*f**3*fd*r*s - 168*D1**2*f**3*fd*r + 672*D1**2*f**3*fd*s**2 - 672*D1**2*f**3*fd*s + 168*D1**2*f**3*fd - 336*D1**2*f**3*fdd*r*s + 84*D1**2*f**3*fdd*r - 336*D1**2*f**3*fdd*s**2 + 336*D1**2*f**3*fdd*s - 84*D1**2*f**3*fdd - 1008*D1**2*f**2*fd**2*r*s + 252*D1**2*f**2*fd**2*r - 1008*D1**2*f**2*fd**2*s**2 + 1008*D1**2*f**2*fd**2*s - 168*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r*s + 44*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 132*D1**2*f**2*fd*s - 44*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r*s - 22*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 66*D1**2*f**2*fdd*s + 22*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 132*D1**2*f*fd**2*r*s - 44*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 132*D1**2*f*fd**2*s + 22*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 672*D1*Dd*f**4*r*s - 168*D1*Dd*f**4*r + 672*D1*Dd*f**4*s**2 - 672*D1*Dd*f**4*s + 168*D1*Dd*f**4 - 2688*D1*Dd*f**3*fd*r*s + 672*D1*Dd*f**3*fd*r - 2688*D1*Dd*f**3*fd*s**2 + 2688*D1*Dd*f**3*fd*s - 504*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 176*D1*Dd*f**3*s - 44*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r*s - 154*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 528*D1*Dd*f**2*fd*s + 110*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 336*D1*Ddd*f**4*r*s + 84*D1*Ddd*f**4*r - 336*D1*Ddd*f**4*s**2 + 336*D1*Ddd*f**4*s - 84*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 88*D1*Ddd*f**3*s + 22*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 1008*Dd**2*f**4*r*s + 252*Dd**2*f**4*r - 1008*Dd**2*f**4*s**2 + 1008*Dd**2*f**4*s - 168*Dd**2*f**4 + 264*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 264*Dd**2*f**3*s + 44*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**2*k1**2*k2**2*st**4*(-30*C*D1**2*bdd1*f**2*r**2 - 84*C*D1**2*bdd1*f**2*r*s + 24*C*D1**2*bdd1*f**2*r - 54*C*D1**2*bdd1*f**2*s**2 + 48*C*D1**2*bdd1*f**2*s - 24*C*D1**2*bdd1*f**2 - 846*C*D1**2*f**2*fd*r**2 + 12*C*D1**2*f**2*fd*r*s + 560*C*D1**2*f**2*fd*r + 858*C*D1**2*f**2*fd*s**2 - 576*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd + 594*C*D1**2*f**2*fdd*r**2 + 156*C*D1**2*f**2*fdd*r*s - 448*C*D1**2*f**2*fdd*r - 438*C*D1**2*f**2*fdd*s**2 + 240*C*D1**2*f**2*fdd*s + 52*C*D1**2*f**2*fdd + 1188*C*D1**2*f*fd**2*r**2 + 312*C*D1**2*f*fd**2*r*s - 896*C*D1**2*f*fd**2*r - 876*C*D1**2*f*fd**2*s**2 + 480*C*D1**2*f*fd**2*s + 52*C*D1**2*f*fd**2 - 1128*C*D1*Dd*f**3*r**2 + 16*C*D1*Dd*f**3*r*s + 1124*C*D1*Dd*f**3*r + 1144*C*D1*Dd*f**3*s**2 - 580*C*D1*Dd*f**3*s - 278*C*D1*Dd*f**3 + 4752*C*D1*Dd*f**2*fd*r**2 + 1248*C*D1*Dd*f**2*fd*r*s - 4324*C*D1*Dd*f**2*fd*r - 3504*C*D1*Dd*f**2*fd*s**2 + 1524*C*D1*Dd*f**2*fd*s + 656*C*D1*Dd*f**2*fd + 792*C*D1*Ddd*f**3*r**2 + 208*C*D1*Ddd*f**3*r*s - 844*C*D1*Ddd*f**3*r - 584*C*D1*Ddd*f**3*s**2 + 188*C*D1*Ddd*f**3*s + 250*C*D1*Ddd*f**3 + 2376*C*Dd**2*f**3*r**2 + 624*C*Dd**2*f**3*r*s - 2532*C*Dd**2*f**3*r - 1752*C*Dd**2*f**3*s**2 + 564*C*Dd**2*f**3*s + 500*C*Dd**2*f**3 + 285*D1**2*K*bdd1*f**2*r**2 + 174*D1**2*K*bdd1*f**2*r*s - 570*D1**2*K*bdd1*f**2*r - 111*D1**2*K*bdd1*f**2*s**2 - 174*D1**2*K*bdd1*f**2*s + 285*D1**2*K*bdd1*f**2 - 42*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2) - 375*D1**2*bdd1*f**3*r**2 - 570*D1**2*bdd1*f**3*r*s + 660*D1**2*bdd1*f**3*r - 195*D1**2*bdd1*f**3*s**2 + 480*D1**2*bdd1*f**3*s - 360*D1**2*bdd1*f**3 - 555*D1**2*bdd1*f**2*r**2 - 870*D1**2*bdd1*f**2*r*s + 1146*D1**2*bdd1*f**2*r - 315*D1**2*bdd1*f**2*s**2 + 906*D1**2*bdd1*f**2*s - 561*D1**2*bdd1*f**2 + 210*D1**2*bdd1*f*g2*r**2 + 588*D1**2*bdd1*f*g2*r*s - 168*D1**2*bdd1*f*g2*r + 378*D1**2*bdd1*f*g2*s**2 - 336*D1**2*bdd1*f*g2*s + 168*D1**2*bdd1*f*g2 - 1260*D1**2*f**3*fd*r**2 - 2400*D1**2*f**3*fd*r*s + 1860*D1**2*f**3*fd*r - 1140*D1**2*f**3*fd*s**2 + 1770*D1**2*f**3*fd*s - 915*D1**2*f**3*fd + 1380*D1**2*f**3*fdd*r**2 + 2160*D1**2*f**3*fdd*r*s - 1920*D1**2*f**3*fdd*r + 780*D1**2*f**3*fdd*s**2 - 1470*D1**2*f**3*fdd*s + 885*D1**2*f**3*fdd + 4140*D1**2*f**2*fd**2*r**2 + 6480*D1**2*f**2*fd**2*r*s - 5760*D1**2*f**2*fd**2*r + 2340*D1**2*f**2*fd**2*s**2 - 4410*D1**2*f**2*fd**2*s + 1770*D1**2*f**2*fd**2 + 1356*D1**2*f**2*fd*r**2 + 1332*D1**2*f**2*fd*r*s - 1348*D1**2*f**2*fd*r - 24*D1**2*f**2*fd*s**2 - 428*D1**2*f**2*fd*s + 444*D1**2*f**2*fd - 894*D1**2*f**2*fdd*r**2 - 936*D1**2*f**2*fdd*r*s + 908*D1**2*f**2*fdd*r - 42*D1**2*f**2*fdd*s**2 + 340*D1**2*f**2*fdd*s - 312*D1**2*f**2*fdd + 678*D1**2*f**2*gd2*r**2 + 276*D1**2*f**2*gd2*r*s - 1356*D1**2*f**2*gd2*r - 402*D1**2*f**2*gd2*s**2 - 276*D1**2*f**2*gd2*s + 678*D1**2*f**2*gd2 - 570*D1**2*f**2*gdd2*r**2 - 348*D1**2*f**2*gdd2*r*s + 1140*D1**2*f**2*gdd2*r + 222*D1**2*f**2*gdd2*s**2 + 348*D1**2*f**2*gdd2*s - 570*D1**2*f**2*gdd2 - 1788*D1**2*f*fd**2*r**2 - 1872*D1**2*f*fd**2*r*s + 1816*D1**2*f*fd**2*r - 84*D1**2*f*fd**2*s**2 + 680*D1**2*f*fd**2*s - 312*D1**2*f*fd**2 + 1356*D1**2*f*fd*g2*r**2 + 552*D1**2*f*fd*g2*r*s - 276*D1**2*f*fd*g2*r - 804*D1**2*f*fd*g2*s**2 + 804*D1**2*f*fd*g2*s - 402*D1**2*f*fd*g2 - 2280*D1**2*f*fd*gd2*r**2 - 1392*D1**2*f*fd*gd2*r*s + 2628*D1**2*f*fd*gd2*r + 888*D1**2*f*fd*gd2*s**2 + 252*D1**2*f*fd*gd2*s - 348*D1**2*f*fd*gd2 - 1140*D1**2*f*fdd*g2*r**2 - 696*D1**2*f*fdd*g2*r*s + 348*D1**2*f*fdd*g2*r + 444*D1**2*f*fdd*g2*s**2 - 444*D1**2*f*fdd*g2*s + 222*D1**2*f*fdd*g2 - 1140*D1**2*fd**2*g2*r**2 - 696*D1**2*fd**2*g2*r*s + 348*D1**2*fd**2*g2*r + 444*D1**2*fd**2*g2*s**2 - 444*D1**2*fd**2*g2*s - 1260*D1*Dd*f**4*r**2 - 2400*D1*Dd*f**4*r*s + 1860*D1*Dd*f**4*r - 1140*D1*Dd*f**4*s**2 + 1770*D1*Dd*f**4*s - 915*D1*Dd*f**4 + 11040*D1*Dd*f**3*fd*r**2 + 17280*D1*Dd*f**3*fd*r*s - 15360*D1*Dd*f**3*fd*r + 6240*D1*Dd*f**3*fd*s**2 - 11760*D1*Dd*f**3*fd*s + 5310*D1*Dd*f**3*fd + 1808*D1*Dd*f**3*r**2 + 1776*D1*Dd*f**3*r*s - 2252*D1*Dd*f**3*r - 32*D1*Dd*f**3*s**2 - 872*D1*Dd*f**3*s + 896*D1*Dd*f**3 - 7152*D1*Dd*f**2*fd*r**2 - 7488*D1*Dd*f**2*fd*r*s + 8144*D1*Dd*f**2*fd*r - 336*D1*Dd*f**2*fd*s**2 + 3316*D1*Dd*f**2*fd*s - 2156*D1*Dd*f**2*fd + 2712*D1*Dd*f**2*g2*r**2 + 1104*D1*Dd*f**2*g2*r*s - 2988*D1*Dd*f**2*g2*r - 1608*D1*Dd*f**2*g2*s**2 + 252*D1*Dd*f**2*g2*s + 954*D1*Dd*f**2*g2 - 4560*D1*Dd*f**2*gd2*r**2 - 2784*D1*Dd*f**2*gd2*r*s + 7188*D1*Dd*f**2*gd2*r + 1776*D1*Dd*f**2*gd2*s**2 + 1644*D1*Dd*f**2*gd2*s - 2628*D1*Dd*f**2*gd2 - 9120*D1*Dd*f*fd*g2*r**2 - 5568*D1*Dd*f*fd*g2*r*s + 6648*D1*Dd*f*fd*g2*r + 3552*D1*Dd*f*fd*g2*s**2 - 1272*D1*Dd*f*fd*g2*s - 252*D1*Dd*f*fd*g2 + 1380*D1*Ddd*f**4*r**2 + 2160*D1*Ddd*f**4*r*s - 1920*D1*Ddd*f**4*r + 780*D1*Ddd*f**4*s**2 - 1470*D1*Ddd*f**4*s + 885*D1*Ddd*f**4 - 1192*D1*Ddd*f**3*r**2 - 1248*D1*Ddd*f**3*r*s + 1504*D1*Ddd*f**3*r - 56*D1*Ddd*f**3*s**2 + 652*D1*Ddd*f**3*s - 610*D1*Ddd*f**3 - 2280*D1*Ddd*f**2*g2*r**2 - 1392*D1*Ddd*f**2*g2*r*s + 2628*D1*Ddd*f**2*g2*r + 888*D1*Ddd*f**2*g2*s**2 + 252*D1*Ddd*f**2*g2*s - 918*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(10*f**3*(20*r**2 + r*(30*s - 34) + 10*s**2 - 24*s + 19) + f**2*(4*C*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) - 113*K*r**2 - 46*K*r*s + 226*K*r + 67*K*s**2 + 46*K*s - 113*K - 10*fd*(75*r**2 + 114*r*s - 113*r + 39*s**2 - 83*s + 36) + 223*r**2 + 342*r*s - 470*r + 119*s**2 - 366*s + 227) - 2*f*(fd*(4*C*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 10*s + 1) + K*(-190*r**2 - 116*r*s + 219*r + 74*s**2 + 21*s - 29) + 370*r**2 + 580*r*s - 521*r + 210*s**2 - 401*s + 155) + 14*g2*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) - 14*gd2*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2)) + 28*fd*g2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9))) - 2*Dd*f*(5*f**2*(100*r**2 + r*(152*s - 157) + 52*s**2 - 115*s + 60) + f*(2*C*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8) + K*(-380*r**2 - 232*r*s + 599*r + 148*s**2 + 137*s - 219) + 740*r**2 + 1160*r*s - 1279*r + 420*s**2 - 999*s + 533) - 14*g2*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8))) + 4140*Dd**2*f**4*r**2 + 6480*Dd**2*f**4*r*s - 5760*Dd**2*f**4*r + 2340*Dd**2*f**4*s**2 - 4410*Dd**2*f**4*s + 1770*Dd**2*f**4 - 3576*Dd**2*f**3*r**2 - 3744*Dd**2*f**3*r*s + 4512*Dd**2*f**3*r - 168*Dd**2*f**3*s**2 + 1956*Dd**2*f**3*s - 1220*Dd**2*f**3 - 6840*Dd**2*f**2*g2*r**2 - 4176*Dd**2*f**2*g2*r*s + 7884*Dd**2*f**2*g2*r + 2664*Dd**2*f**2*g2*s**2 + 756*Dd**2*f**2*g2*s - 1836*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + D1*(2*Dd*(f*(20*r**2 + 56*r*s - 34*r + 36*s**2 - 46*s + 19) - fd*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15)) - Ddd*f*(20*r**2 + r*(56*s - 34) + 36*s**2 - 46*s + 19)) - 2*Dd**2*f*(30*r**2 + r*(84*s - 51) + 54*s**2 - 69*s + 19)) + 3*b1*(40*C*D1**2*f*fd*r**2 + 112*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s**2 - 96*C*D1**2*f*fd*s + 40*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 - 56*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*r - 36*C*D1**2*f*fdd*s**2 + 48*C*D1**2*f*fdd*s - 20*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 - 56*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*r - 36*C*D1**2*fd**2*s**2 + 48*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 + 80*C*D1*Dd*f**2*r**2 + 224*C*D1*Dd*f**2*r*s - 136*C*D1*Dd*f**2*r + 144*C*D1*Dd*f**2*s**2 - 184*C*D1*Dd*f**2*s + 76*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 - 448*C*D1*Dd*f*fd*r*s + 296*C*D1*Dd*f*fd*r - 288*C*D1*Dd*f*fd*s**2 + 376*C*D1*Dd*f*fd*s - 128*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 - 112*C*D1*Ddd*f**2*r*s + 68*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 92*C*D1*Ddd*f**2*s - 38*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 - 336*C*Dd**2*f**2*r*s + 204*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 276*C*Dd**2*f**2*s - 76*C*Dd**2*f**2 - 226*D1**2*K*f*fd*r**2 - 92*D1**2*K*f*fd*r*s + 46*D1**2*K*f*fd*r + 134*D1**2*K*f*fd*s**2 - 134*D1**2*K*f*fd*s + 67*D1**2*K*f*fd + 190*D1**2*K*f*fdd*r**2 + 116*D1**2*K*f*fdd*r*s - 58*D1**2*K*f*fdd*r - 74*D1**2*K*f*fdd*s**2 + 74*D1**2*K*f*fdd*s - 37*D1**2*K*f*fdd + 190*D1**2*K*fd**2*r**2 + 116*D1**2*K*fd**2*r*s - 58*D1**2*K*fd**2*r - 74*D1**2*K*fd**2*s**2 + 74*D1**2*K*fd**2*s - 7*D1**2*bdd1*f*(K - 1)*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) + 600*D1**2*f**2*fd*r**2 + 900*D1**2*f**2*fd*r*s - 760*D1**2*f**2*fd*r + 300*D1**2*f**2*fd*s**2 - 560*D1**2*f**2*fd*s + 310*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 570*D1**2*f**2*fdd*r*s + 470*D1**2*f**2*fdd*r - 195*D1**2*f**2*fdd*s**2 + 350*D1**2*f**2*fdd*s - 195*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 1140*D1**2*f*fd**2*r*s + 940*D1**2*f*fd**2*r - 390*D1**2*f*fd**2*s**2 + 700*D1**2*f*fd**2*s - 270*D1**2*f*fd**2 + 446*D1**2*f*fd*r**2 + 684*D1**2*f*fd*r*s - 318*D1**2*f*fd*r + 238*D1**2*f*fd*s**2 - 214*D1**2*f*fd*s + 115*D1**2*f*fd - 370*D1**2*f*fdd*r**2 - 580*D1**2*f*fdd*r*s + 278*D1**2*f*fdd*r - 210*D1**2*f*fdd*s**2 + 198*D1**2*f*fdd*s - 103*D1**2*f*fdd - 140*D1**2*f*gd2*r**2 - 392*D1**2*f*gd2*r*s + 280*D1**2*f*gd2*r - 252*D1**2*f*gd2*s**2 + 392*D1**2*f*gd2*s - 140*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 196*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*r + 126*D1**2*f*gdd2*s**2 - 196*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 - 370*D1**2*fd**2*r**2 - 580*D1**2*fd**2*r*s + 278*D1**2*fd**2*r - 210*D1**2*fd**2*s**2 + 198*D1**2*fd**2*s + 20*D1**2*fd**2 - 140*D1**2*fd*g2*r**2 - 392*D1**2*fd*g2*r*s + 280*D1**2*fd*g2*r - 252*D1**2*fd*g2*s**2 + 280*D1**2*fd*g2*s - 140*D1**2*fd*g2 + 140*D1**2*fd*gd2*r**2 + 392*D1**2*fd*gd2*r*s - 280*D1**2*fd*gd2*r + 252*D1**2*fd*gd2*s**2 - 336*D1**2*fd*gd2*s + 140*D1**2*fd*gd2 + 70*D1**2*fdd*g2*r**2 + 196*D1**2*fdd*g2*r*s - 140*D1**2*fdd*g2*r + 126*D1**2*fdd*g2*s**2 - 140*D1**2*fdd*g2*s + 70*D1**2*fdd*g2 - 452*D1*Dd*K*f**2*r**2 - 184*D1*Dd*K*f**2*r*s + 498*D1*Dd*K*f**2*r + 268*D1*Dd*K*f**2*s**2 - 42*D1*Dd*K*f**2*s - 159*D1*Dd*K*f**2 + 1520*D1*Dd*K*f*fd*r**2 + 928*D1*Dd*K*f*fd*r*s - 1108*D1*Dd*K*f*fd*r - 592*D1*Dd*K*f*fd*s**2 + 212*D1*Dd*K*f*fd*s + 42*D1*Dd*K*f*fd + 800*D1*Dd*f**3*r**2 + 1200*D1*Dd*f**3*r*s - 1100*D1*Dd*f**3*r + 400*D1*Dd*f**3*s**2 - 800*D1*Dd*f**3*s + 500*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 4560*D1*Dd*f**2*fd*r*s + 3950*D1*Dd*f**2*fd*r - 1560*D1*Dd*f**2*fd*s**2 + 2930*D1*Dd*f**2*fd*s - 1290*D1*Dd*f**2*fd + 892*D1*Dd*f**2*r**2 + 1368*D1*Dd*f**2*r*s - 1234*D1*Dd*f**2*r + 476*D1*Dd*f**2*s**2 - 922*D1*Dd*f**2*s + 565*D1*Dd*f**2 - 2960*D1*Dd*f*fd*r**2 - 4640*D1*Dd*f*fd*r*s + 3172*D1*Dd*f*fd*r - 1680*D1*Dd*f*fd*s**2 + 2372*D1*Dd*f*fd*s - 754*D1*Dd*f*fd - 560*D1*Dd*f*g2*r**2 - 1568*D1*Dd*f*g2*r*s + 952*D1*Dd*f*g2*r - 1008*D1*Dd*f*g2*s**2 + 1288*D1*Dd*f*g2*s - 532*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 1568*D1*Dd*f*gd2*r*s - 1036*D1*Dd*f*gd2*r + 1008*D1*Dd*f*gd2*s**2 - 1428*D1*Dd*f*gd2*s + 476*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 1568*D1*Dd*fd*g2*r*s - 1036*D1*Dd*fd*g2*r + 1008*D1*Dd*fd*g2*s**2 - 1204*D1*Dd*fd*g2*s + 420*D1*Dd*fd*g2 + 380*D1*Ddd*K*f**2*r**2 + 232*D1*Ddd*K*f**2*r*s - 438*D1*Ddd*K*f**2*r - 148*D1*Ddd*K*f**2*s**2 - 42*D1*Ddd*K*f**2*s + 153*D1*Ddd*K*f**2 - 500*D1*Ddd*f**3*r**2 - 760*D1*Ddd*f**3*r*s + 690*D1*Ddd*f**3*r - 260*D1*Ddd*f**3*s**2 + 510*D1*Ddd*f**3*s - 315*D1*Ddd*f**3 - 740*D1*Ddd*f**2*r**2 - 1160*D1*Ddd*f**2*r*s + 1030*D1*Ddd*f**2*r - 420*D1*Ddd*f**2*s**2 + 790*D1*Ddd*f**2*s - 475*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 784*D1*Ddd*f*g2*r*s - 476*D1*Ddd*f*g2*r + 504*D1*Ddd*f*g2*s**2 - 644*D1*Ddd*f*g2*s + 266*D1*Ddd*f*g2 + 14*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) - fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 21*s + 5)) - Dd*f*(40*r**2 + 2*r*(56*s - 31) + 72*s**2 - 90*s + 25)) + 1140*Dd**2*K*f**2*r**2 + 696*Dd**2*K*f**2*r*s - 1314*Dd**2*K*f**2*r - 444*Dd**2*K*f**2*s**2 - 126*Dd**2*K*f**2*s + 306*Dd**2*K*f**2 - 1500*Dd**2*f**3*r**2 - 2280*Dd**2*f**3*r*s + 2070*Dd**2*f**3*r - 780*Dd**2*f**3*s**2 + 1530*Dd**2*f**3*s - 630*Dd**2*f**3 - 2220*Dd**2*f**2*r**2 - 3480*Dd**2*f**2*r*s + 3090*Dd**2*f**2*r - 1260*Dd**2*f**2*s**2 + 2370*Dd**2*f**2*s - 950*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 2352*Dd**2*f*g2*r*s - 1428*Dd**2*f*g2*r + 1512*Dd**2*f*g2*s**2 - 1932*Dd**2*f*g2*s + 532*Dd**2*f*g2))/(210*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**2*k1**2*k2**2*st**2*(-22*C*D1**2*bdd1*f**2*r**2 + 196*C*D1**2*bdd1*f**2*r*s + 524*C*D1**2*bdd1*f**2*r + 218*C*D1**2*bdd1*f**2*s**2 + 284*C*D1**2*bdd1*f**2*s - 142*C*D1**2*bdd1*f**2 + 4068*C*D1**2*f**2*fd*r**2 + 9432*C*D1**2*f**2*fd*r*s - 5856*C*D1**2*f**2*fd*r + 5364*C*D1**2*f**2*fd*s**2 - 6720*C*D1**2*f**2*fd*s + 3144*C*D1**2*f**2*fd - 4176*C*D1**2*f**2*fdd*r**2 - 9072*C*D1**2*f**2*fdd*r*s + 5808*C*D1**2*f**2*fdd*r - 4896*C*D1**2*f**2*fdd*s**2 + 6288*C*D1**2*f**2*fdd*s - 3024*C*D1**2*f**2*fdd - 8352*C*D1**2*f*fd**2*r**2 - 18144*C*D1**2*f*fd**2*r*s + 11616*C*D1**2*f*fd**2*r - 9792*C*D1**2*f*fd**2*s**2 + 12576*C*D1**2*f*fd**2*s - 3024*C*D1**2*f*fd**2 + 5424*C*D1*Dd*f**3*r**2 + 12576*C*D1*Dd*f**3*r*s - 8568*C*D1*Dd*f**3*r + 7152*C*D1*Dd*f**3*s**2 - 9864*C*D1*Dd*f**3*s + 4500*C*D1*Dd*f**3 - 33408*C*D1*Dd*f**2*fd*r**2 - 72576*C*D1*Dd*f**2*fd*r*s + 49008*C*D1*Dd*f**2*fd*r - 39168*C*D1*Dd*f**2*fd*s**2 + 53088*C*D1*Dd*f**2*fd*s - 17904*C*D1*Dd*f**2*fd - 5568*C*D1*Ddd*f**3*r**2 - 12096*C*D1*Ddd*f**3*r*s + 8592*C*D1*Ddd*f**3*r - 6528*C*D1*Ddd*f**3*s**2 + 9312*C*D1*Ddd*f**3*s - 4416*C*D1*Ddd*f**3 - 16704*C*Dd**2*f**3*r**2 - 36288*C*Dd**2*f**3*r*s + 25776*C*Dd**2*f**3*r - 19584*C*Dd**2*f**3*s**2 + 27936*C*Dd**2*f**3*s - 8832*C*Dd**2*f**3 - 1176*D1**2*K*bdd1*f**2*r**2 - 2856*D1**2*K*bdd1*f**2*r*s + 2352*D1**2*K*bdd1*f**2*r - 1680*D1**2*K*bdd1*f**2*s**2 + 2856*D1**2*K*bdd1*f**2*s - 1176*D1**2*K*bdd1*f**2 + 900*D1**2*b2*f*fd*r**2 + 1800*D1**2*b2*f*fd*r*s - 900*D1**2*b2*f*fd*r + 900*D1**2*b2*f*fd*s**2 - 900*D1**2*b2*f*fd*s + 450*D1**2*b2*f*fd - 1080*D1**2*b2*f*fdd*r**2 - 2160*D1**2*b2*f*fdd*r*s + 1080*D1**2*b2*f*fdd*r - 1080*D1**2*b2*f*fdd*s**2 + 1080*D1**2*b2*f*fdd*s - 540*D1**2*b2*f*fdd - 1080*D1**2*b2*fd**2*r**2 - 2160*D1**2*b2*fd**2*r*s + 1080*D1**2*b2*fd**2*r - 1080*D1**2*b2*fd**2*s**2 + 1080*D1**2*b2*fd**2*s + 2*D1**2*bd1**2*(r + s - 1)*(180*f**2*(r + s - 2) + 7*f*(10*C*r + 10*C*s + K*(-r + 23*s + 49) + 81*r + 57*s - 109) - 350*g2*(r + s)) + 180*D1**2*bdd1*f**3*r**2 + 684*D1**2*bdd1*f**3*r*s - 612*D1**2*bdd1*f**3*r + 504*D1**2*bdd1*f**3*s**2 - 936*D1**2*bdd1*f**3*s + 432*D1**2*bdd1*f**3 + 610*D1**2*bdd1*f**2*r**2 + 1232*D1**2*bdd1*f**2*r*s - 1520*D1**2*bdd1*f**2*r + 622*D1**2*bdd1*f**2*s**2 - 1532*D1**2*bdd1*f**2*s + 640*D1**2*bdd1*f**2 + 14*D1**2*bdd1*f*g2*r**2 - 308*D1**2*bdd1*f*g2*r*s - 1372*D1**2*bdd1*f*g2*r - 322*D1**2*bdd1*f*g2*s**2 - 1036*D1**2*bdd1*f*g2*s + 518*D1**2*bdd1*f*g2 - 540*D1**2*bdd2*f**2*r**2 - 1080*D1**2*bdd2*f**2*r*s + 1080*D1**2*bdd2*f**2*r - 540*D1**2*bdd2*f**2*s**2 + 1080*D1**2*bdd2*f**2*s - 540*D1**2*bdd2*f**2 - 2178*D1**2*f**2*fd*r**2 - 5436*D1**2*f**2*fd*r*s + 3264*D1**2*f**2*fd*r - 3258*D1**2*f**2*fd*s**2 + 3984*D1**2*f**2*fd*s - 1812*D1**2*f**2*fd + 2682*D1**2*f**2*fdd*r**2 + 5904*D1**2*f**2*fdd*r*s - 3756*D1**2*f**2*fdd*r + 3222*D1**2*f**2*fdd*s**2 - 4116*D1**2*f**2*fdd*s + 1968*D1**2*f**2*fdd - 1596*D1**2*f**2*gd2*r**2 - 4872*D1**2*f**2*gd2*r*s + 3192*D1**2*f**2*gd2*r - 3276*D1**2*f**2*gd2*s**2 + 4872*D1**2*f**2*gd2*s - 1596*D1**2*f**2*gd2 + 2352*D1**2*f**2*gdd2*r**2 + 5712*D1**2*f**2*gdd2*r*s - 4704*D1**2*f**2*gdd2*r + 3360*D1**2*f**2*gdd2*s**2 - 5712*D1**2*f**2*gdd2*s + 2352*D1**2*f**2*gdd2 + 5364*D1**2*f*fd**2*r**2 + 11808*D1**2*f*fd**2*r*s - 7512*D1**2*f*fd**2*r + 6444*D1**2*f*fd**2*s**2 - 8232*D1**2*f*fd**2*s + 1968*D1**2*f*fd**2 - 3192*D1**2*f*fd*g2*r**2 - 9744*D1**2*f*fd*g2*r*s + 4872*D1**2*f*fd*g2*r - 6552*D1**2*f*fd*g2*s**2 + 6552*D1**2*f*fd*g2*s - 3276*D1**2*f*fd*g2 + 9408*D1**2*f*fd*gd2*r**2 + 22848*D1**2*f*fd*gd2*r*s - 15120*D1**2*f*fd*gd2*r + 13440*D1**2*f*fd*gd2*s**2 - 18144*D1**2*f*fd*gd2*s + 5712*D1**2*f*fd*gd2 + 4704*D1**2*f*fdd*g2*r**2 + 11424*D1**2*f*fdd*g2*r*s - 5712*D1**2*f*fdd*g2*r + 6720*D1**2*f*fdd*g2*s**2 - 6720*D1**2*f*fdd*g2*s + 3360*D1**2*f*fdd*g2 + 4704*D1**2*fd**2*g2*r**2 + 11424*D1**2*fd**2*g2*r*s - 5712*D1**2*fd**2*g2*r + 6720*D1**2*fd**2*g2*s**2 - 6720*D1**2*fd**2*g2*s + 1800*D1*Dd*b2*f**2*r**2 + 3600*D1*Dd*b2*f**2*r*s - 2700*D1*Dd*b2*f**2*r + 1800*D1*Dd*b2*f**2*s**2 - 2700*D1*Dd*b2*f**2*s + 1350*D1*Dd*b2*f**2 - 8640*D1*Dd*b2*f*fd*r**2 - 17280*D1*Dd*b2*f*fd*r*s + 10800*D1*Dd*b2*f*fd*r - 8640*D1*Dd*b2*f*fd*s**2 + 10800*D1*Dd*b2*f*fd*s - 3240*D1*Dd*b2*f*fd - 2904*D1*Dd*f**3*r**2 - 7248*D1*Dd*f**3*r*s + 4716*D1*Dd*f**3*r - 4344*D1*Dd*f**3*s**2 + 5796*D1*Dd*f**3*s - 2538*D1*Dd*f**3 + 21456*D1*Dd*f**2*fd*r**2 + 47232*D1*Dd*f**2*fd*r*s - 31656*D1*Dd*f**2*fd*r + 25776*D1*Dd*f**2*fd*s**2 - 34716*D1*Dd*f**2*fd*s + 11628*D1*Dd*f**2*fd - 6384*D1*Dd*f**2*g2*r**2 - 19488*D1*Dd*f**2*g2*r*s + 11256*D1*Dd*f**2*g2*r - 13104*D1*Dd*f**2*g2*s**2 + 16296*D1*Dd*f**2*g2*s - 6468*D1*Dd*f**2*g2 + 18816*D1*Dd*f**2*gd2*r**2 + 45696*D1*Dd*f**2*gd2*r*s - 33936*D1*Dd*f**2*gd2*r + 26880*D1*Dd*f**2*gd2*s**2 - 40992*D1*Dd*f**2*gd2*s + 15120*D1*Dd*f**2*gd2 + 37632*D1*Dd*f*fd*g2*r**2 + 91392*D1*Dd*f*fd*g2*r*s - 53088*D1*Dd*f*fd*g2*r + 53760*D1*Dd*f*fd*g2*s**2 - 63168*D1*Dd*f*fd*g2*s + 18144*D1*Dd*f*fd*g2 - 2160*D1*Ddd*b2*f**2*r**2 - 4320*D1*Ddd*b2*f**2*r*s + 3240*D1*Ddd*b2*f**2*r - 2160*D1*Ddd*b2*f**2*s**2 + 3240*D1*Ddd*b2*f**2*s - 1620*D1*Ddd*b2*f**2 + 3576*D1*Ddd*f**3*r**2 + 7872*D1*Ddd*f**3*r*s - 5544*D1*Ddd*f**3*r + 4296*D1*Ddd*f**3*s**2 - 6084*D1*Ddd*f**3*s + 2862*D1*Ddd*f**3 + 9408*D1*Ddd*f**2*g2*r**2 + 22848*D1*Ddd*f**2*g2*r*s - 15120*D1*Ddd*f**2*g2*r + 13440*D1*Ddd*f**2*g2*s**2 - 18144*D1*Ddd*f**2*g2*s + 8064*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(9*f**3*(9*r**2 + r*(2 - 8*s) - 17*s**2 + 28*s - 6) + f**2*(C*(64*r**2 - 2*r*(14*s + 171) - 92*s**2 - 186*s + 93) + 399*K*r**2 + 1218*K*r*s - 798*K*r + 819*K*s**2 - 1218*K*s + 399*K + 18*fd*(30*r**2 + 114*r*s - 73*r + 84*s**2 - 118*s + 36) - 204*r**2 - 504*r*s + 512*r - 300*s**2 + 608*s - 178) - f*(2*fd*(C*(22*r**2 - r*(196*s + 93) - 218*s**2 + 87*s + 131) + 42*K*(28*r**2 + 68*r*s - 45*r + 40*s**2 - 54*s + 17) - 610*r**2 - 1232*r*s + 993*r - 622*s**2 + 1002*s - 443) + 7*g2*(72*r**2 + 2*r*(58*s - 53) + 44*s**2 - 78*s + 39) + 14*gd2*(-r**2 + r*(22*s + 50) + 23*s**2 + 26*s - 49)) + 14*fd*g2*(r**2 + r*(11 - 22*s) - s*(23*s - 23))) + 2*Dd*f*(9*f**2*(40*r**2 + 152*r*s - 107*r + 112*s**2 - 170*s + 60) + f*(C*(-44*r**2 + 7*r*(56*s + 71) + 436*s**2 + 77*s - 333) - 42*K*(56*r**2 + 136*r*s - 101*r + 80*s**2 - 122*s + 45) + 1220*r**2 + 2464*r*s - 2438*r + 1244*s**2 - 2459*s + 1143) + 7*g2*(4*r**2 - 11*r*(8*s + 17) - 92*s**2 - 103*s + 135))) + 90*D1*bd2*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 6480*Dd**2*b2*f**2*r**2 - 12960*Dd**2*b2*f**2*r*s + 9720*Dd**2*b2*f**2*r - 6480*Dd**2*b2*f**2*s**2 + 9720*Dd**2*b2*f**2*s - 3240*Dd**2*b2*f**2 + 10728*Dd**2*f**3*r**2 + 23616*Dd**2*f**3*r*s - 16632*Dd**2*f**3*r + 12888*Dd**2*f**3*s**2 - 18252*Dd**2*f**3*s + 5724*Dd**2*f**3 + 28224*Dd**2*f**2*g2*r**2 + 68544*Dd**2*f**2*g2*r*s - 45360*Dd**2*f**2*g2*r + 40320*Dd**2*f**2*g2*s**2 - 54432*Dd**2*f**2*g2*s + 16128*Dd**2*f**2*g2 - 175*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-140*C*D1**2*fd*r**2 - 280*C*D1**2*fd*r*s + 280*C*D1**2*fd*r - 140*C*D1**2*fd*s**2 + 280*C*D1**2*fd*s - 140*C*D1**2*fd + 70*C*D1**2*fdd*r**2 + 140*C*D1**2*fdd*r*s - 140*C*D1**2*fdd*r + 70*C*D1**2*fdd*s**2 - 140*C*D1**2*fdd*s + 70*C*D1**2*fdd - 560*C*D1*Dd*f*r**2 - 1120*C*D1*Dd*f*r*s + 840*C*D1*Dd*f*r - 560*C*D1*Dd*f*s**2 + 840*C*D1*Dd*f*s - 420*C*D1*Dd*f + 560*C*D1*Dd*fd*r**2 + 1120*C*D1*Dd*fd*r*s - 980*C*D1*Dd*fd*r + 560*C*D1*Dd*fd*s**2 - 980*C*D1*Dd*fd*s + 420*C*D1*Dd*fd + 280*C*D1*Ddd*f*r**2 + 560*C*D1*Ddd*f*r*s - 420*C*D1*Ddd*f*r + 280*C*D1*Ddd*f*s**2 - 420*C*D1*Ddd*f*s + 210*C*D1*Ddd*f + 840*C*Dd**2*f*r**2 + 1680*C*Dd**2*f*r*s - 1260*C*Dd**2*f*r + 840*C*Dd**2*f*s**2 - 1260*C*Dd**2*f*s + 420*C*Dd**2*f + 504*D1**2*K*fd*r**2 + 812*D1**2*K*fd*r*s - 70*D1**2*K*fd*r + 308*D1**2*K*fd*s**2 - 70*D1**2*K*fd*s + 35*D1**2*K*fd - 7*D1**2*K*fdd*r**2 + 154*D1**2*K*fdd*r*s - 840*D1**2*K*fdd*r + 161*D1**2*K*fdd*s**2 - 840*D1**2*K*fdd*s + 420*D1**2*K*fdd + 175*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 720*D1**2*f*fd*r**2 - 1440*D1**2*f*fd*r*s + 420*D1**2*f*fd*r - 720*D1**2*f*fd*s**2 + 420*D1**2*f*fd*s - 210*D1**2*f*fd + 360*D1**2*f*fdd*r**2 + 720*D1**2*f*fdd*r*s + 360*D1**2*f*fdd*s**2 + 360*D1**2*fd**2*r**2 + 720*D1**2*fd**2*r*s + 360*D1**2*fd**2*s**2 - 360*D1**2*fd**2 - 924*D1**2*fd*r**2 - 1652*D1**2*fd*r*s - 70*D1**2*fd*r - 728*D1**2*fd*s**2 - 70*D1**2*fd*s + 35*D1**2*fd + 567*D1**2*fdd*r**2 + 966*D1**2*fdd*r*s + 560*D1**2*fdd*r + 399*D1**2*fdd*s**2 + 560*D1**2*fdd*s - 280*D1**2*fdd + 700*D1**2*gd2*r**2 + 1400*D1**2*gd2*r*s - 1400*D1**2*gd2*r + 700*D1**2*gd2*s**2 - 1400*D1**2*gd2*s + 700*D1**2*gd2 - 350*D1**2*gdd2*r**2 - 700*D1**2*gdd2*r*s + 700*D1**2*gdd2*r - 350*D1**2*gdd2*s**2 + 700*D1**2*gdd2*s - 350*D1**2*gdd2 + 2016*D1*Dd*K*f*r**2 + 3248*D1*Dd*K*f*r*s - 2828*D1*Dd*K*f*r + 1232*D1*Dd*K*f*s**2 - 2240*D1*Dd*K*f*s + 1316*D1*Dd*K*f - 56*D1*Dd*K*fd*r**2 + 1232*D1*Dd*K*fd*r*s - 3486*D1*Dd*K*fd*r + 1288*D1*Dd*K*fd*s**2 - 3990*D1*Dd*K*fd*s + 2520*D1*Dd*K*fd - 1440*D1*Dd*f**2*r**2 - 2880*D1*Dd*f**2*r*s + 2160*D1*Dd*f**2*r - 1440*D1*Dd*f**2*s**2 + 2160*D1*Dd*f**2*s - 1080*D1*Dd*f**2 + 2880*D1*Dd*f*fd*r**2 + 5760*D1*Dd*f*fd*r*s - 2160*D1*Dd*f*fd*r + 2880*D1*Dd*f*fd*s**2 - 2160*D1*Dd*f*fd*s - 3696*D1*Dd*f*r**2 - 6608*D1*Dd*f*r*s + 5348*D1*Dd*f*r - 2912*D1*Dd*f*s**2 + 4760*D1*Dd*f*s - 2576*D1*Dd*f + 4536*D1*Dd*fd*r**2 + 7728*D1*Dd*fd*r*s - 994*D1*Dd*fd*r + 3192*D1*Dd*fd*s**2 - 490*D1*Dd*fd*s - 1680*D1*Dd*fd + 2800*D1*Dd*g2*r**2 + 5600*D1*Dd*g2*r*s - 4200*D1*Dd*g2*r + 2800*D1*Dd*g2*s**2 - 4200*D1*Dd*g2*s + 2100*D1*Dd*g2 - 2800*D1*Dd*gd2*r**2 - 5600*D1*Dd*gd2*r*s + 4900*D1*Dd*gd2*r - 2800*D1*Dd*gd2*s**2 + 4900*D1*Dd*gd2*s - 2100*D1*Dd*gd2 - 28*D1*Ddd*K*f*r**2 + 616*D1*Ddd*K*f*r*s - 126*D1*Ddd*K*f*r + 644*D1*Ddd*K*f*s**2 - 630*D1*Ddd*K*f*s + 147*D1*Ddd*K*f + 720*D1*Ddd*f**2*r**2 + 1440*D1*Ddd*f**2*r*s - 1080*D1*Ddd*f**2*r + 720*D1*Ddd*f**2*s**2 - 1080*D1*Ddd*f**2*s + 540*D1*Ddd*f**2 + 2268*D1*Ddd*f*r**2 + 3864*D1*Ddd*f*r*s - 3234*D1*Ddd*f*r + 1596*D1*Ddd*f*s**2 - 2730*D1*Ddd*f*s + 1533*D1*Ddd*f - 1400*D1*Ddd*g2*r**2 - 2800*D1*Ddd*g2*r*s + 2100*D1*Ddd*g2*r - 1400*D1*Ddd*g2*s**2 + 2100*D1*Ddd*g2*s - 1050*D1*Ddd*g2 - 350*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 84*Dd**2*K*f*r**2 + 1848*Dd**2*K*f*r*s - 378*Dd**2*K*f*r + 1932*Dd**2*K*f*s**2 - 1890*Dd**2*K*f*s + 294*Dd**2*K*f + 2160*Dd**2*f**2*r**2 + 4320*Dd**2*f**2*r*s - 3240*Dd**2*f**2*r + 2160*Dd**2*f**2*s**2 - 3240*Dd**2*f**2*s + 1080*Dd**2*f**2 + 6804*Dd**2*f*r**2 + 11592*Dd**2*f*r*s - 9702*Dd**2*f*r + 4788*Dd**2*f*s**2 - 8190*Dd**2*f*s + 3066*Dd**2*f - 4200*Dd**2*g2*r**2 - 8400*Dd**2*g2*r*s + 6300*Dd**2*g2*r - 4200*Dd**2*g2*s**2 + 6300*Dd**2*g2*s - 2100*Dd**2*g2) + b1*(350*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(90*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + 7*f*(5*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*(-r**2 + 22*r*s + 50*r + 23*s**2 + 26*s - 19) + 81*r**2 + 138*r*s - 190*r + 57*s**2 - 166*s + 89) - 175*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*D1**2*(9*f**2*(fd*(27*r**2 - 6*r*(4*s + 5) - 51*s**2 + 22*s + 7) + 2*fdd*(15*r**2 + r*(57*s - 22) + 42*s**2 - 40*s + 12)) + f*(36*fd**2*(15*r**2 + r*(57*s - 22) + 42*s**2 - 40*s + 6) + fd*(C*(128*r**2 + r*(242 - 56*s) - 184*s**2 + 398*s - 121) + 21*K*(38*r**2 + 58*r*(2*s - 1) + 78*s**2 - 78*s + 39) - 408*r**2 - 16*r*(63*s - 25) - 600*s**2 + 496*s - 326) + fdd*(C*(-22*r**2 + 2*r*(98*s - 169) + 218*s**2 - 458*s + 169) - 84*K*(14*r**2 + 34*r*s - 17*r + 20*s**2 - 20*s + 10) + 610*r**2 + 1232*r*s - 466*r + 622*s**2 - 472*s + 296) + (-7*r - 7*s + 7)*(gd2*(72*r + 44*s - 72) - gdd2*r + 23*gdd2*s + gdd2)) - 2*fd**2*(C*(11*r**2 + r*(169 - 98*s) - 109*s**2 + 229*s - 180) + 840*K*s**2 - 840*K*s + r**2*(588*K - 305) + r*(714*K*(2*s - 1) - 616*s + 233) - 311*s**2 + 236*s + 135) - 7*fd*(g2*(72*r**2 + 2*r*(58*s - 5) + 44*s**2 - 10*s + 5) - 2*gd2*(r**2 + r*(59 - 22*s) - 23*s**2 + 71*s - 60)) + 7*fdd*g2*(r**2 + r*(120 - 22*s) - 23*s**2 + 120*s - 60)) + D1*bd1*(D1*(-30*f**2*(24*r**2 + r*(48*s - 58) + 24*s**2 - 58*s + 29) + f*(-140*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(144*r**2 + 232*r*s - 250*r + 88*s**2 - 194*s + 111) + 720*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 1848*r**2 - 3304*r*s + 3570*r - 1456*s**2 + 3178*s - 1687) + 28*fd*(5*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - K*(r**2 - 22*r*s + 35*r - 23*s**2 + 47*s - 30) + 81*r**2 + 138*r*s - 55*r + 57*s**2 - 43*s - 20) + 700*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 700*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(90*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + 7*f*(5*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + K*(-4*r**2 + 88*r*s + 91*r + 92*s**2 + 7*s - 63) + 324*r**2 + 552*r*s - 611*r + 228*s**2 - 527*s + 273) - 175*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 2*D1*(Dd*(9*f**3*(36*r**2 - 4*r*(8*s + 7) - 68*s**2 + 50*s + 1) + f**2*(4*C*(64*r**2 - r*(28*s + 57) - 92*s**2 + 60*s + 9) + 21*K*(76*r**2 + 2*r*(116*s - 67) + 156*s**2 - 194*s + 77) + 18*fd*(120*r**2 + r*(456*s - 205) + 336*s**2 - 358*s + 84) - 816*r**2 - 24*r*(84*s - 55) - 1200*s**2 + 1608*s - 708) - 2*f*(fd*(C*(88*r**2 + r*(730 - 784*s) - 872*s**2 + 1330*s - 567) + 84*K*(56*r**2 + 136*r*s - 79*r + 80*s**2 - 94*s + 27) - 2440*r**2 - 4928*r*s + 2768*r - 2488*s**2 + 2798*s - 702) + 14*g2*(72*r**2 + r*(116*s - 101) + 44*s**2 - 80*s + 47) + 7*gd2*(-4*r**2 + r*(88*s - 5) + 92*s**2 - 89*s + 9)) + 14*fd*g2*(4*r**2 + r*(249 - 88*s) - 92*s**2 + 285*s - 180)) + Ddd*f*(18*f**2*(20*r**2 + r*(76*s - 39) + 56*s**2 - 66*s + 24) + f*(C*(-44*r**2 + r*(392*s - 54) + 436*s**2 - 414*s + 87) - 84*K*(28*r**2 + 68*r*s - 45*r + 40*s**2 - 54*s + 24) + 1220*r**2 + 2464*r*s - 1836*r + 1244*s**2 - 1854*s + 921) + 7*g2*(4*r**2 + r*(18 - 88*s) - 92*s**2 + 90*s - 21))) + 12*Dd**2*f*(9*f**2*(20*r**2 + r*(76*s - 39) + 56*s**2 - 66*s + 16) + f*(C*(-22*r**2 + r*(196*s - 27) + 218*s**2 - 207*s + 29) - 42*K*(28*r**2 + 68*r*s - 45*r + 40*s**2 - 54*s + 16) + 610*r**2 + 1232*r*s - 918*r + 622*s**2 - 927*s + 307) + 7*g2*(2*r**2 + r*(9 - 44*s) - 46*s**2 + 45*s - 7))))/(210*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**2*k1**2*k2**2*(5040*C*D1**2*bd1**2*f*r**2 + 10080*C*D1**2*bd1**2*f*r*s - 5040*C*D1**2*bd1**2*f*r + 5040*C*D1**2*bd1**2*f*s**2 - 5040*C*D1**2*bd1**2*f*s + 5364*C*D1**2*bd1*f**2*r**2 + 10656*C*D1**2*bd1*f**2*r*s - 11196*C*D1**2*bd1*f**2*r + 5292*C*D1**2*bd1*f**2*s**2 - 11124*C*D1**2*bd1*f**2*s + 5562*C*D1**2*bd1*f**2 - 26856*C*D1**2*bd1*f*fd*r**2 - 54576*C*D1**2*bd1*f*fd*r*s + 41616*C*D1**2*bd1*f*fd*r - 27720*C*D1**2*bd1*f*fd*s**2 + 42264*C*D1**2*bd1*f*fd*s - 14544*C*D1**2*bd1*f*fd - 6714*C*D1**2*bdd1*f**2*r**2 - 13644*C*D1**2*bdd1*f**2*r*s + 14544*C*D1**2*bdd1*f**2*r - 6930*C*D1**2*bdd1*f**2*s**2 + 14760*C*D1**2*bdd1*f**2*s - 7380*C*D1**2*bdd1*f**2 - 1140*C*D1**2*f**2*fd*r**2 + 1560*C*D1**2*f**2*fd*r*s + 240*C*D1**2*f**2*fd*r + 2700*C*D1**2*f**2*fd*s**2 - 2320*C*D1**2*f**2*fd*s + 520*C*D1**2*f**2*fd - 1590*C*D1**2*f**2*fdd*r**2 - 6180*C*D1**2*f**2*fdd*r*s + 3120*C*D1**2*f**2*fdd*r - 4590*C*D1**2*f**2*fdd*s**2 + 5120*C*D1**2*f**2*fdd*s - 2060*C*D1**2*f**2*fdd - 3180*C*D1**2*f*fd**2*r**2 - 12360*C*D1**2*f*fd**2*r*s + 6240*C*D1**2*f*fd**2*r - 9180*C*D1**2*f*fd**2*s**2 + 10240*C*D1**2*f*fd**2*s - 2060*C*D1**2*f*fd**2 - 53712*C*D1*Dd*bd1*f**2*r**2 - 109152*C*D1*Dd*bd1*f**2*r*s + 98676*C*D1*Dd*bd1*f**2*r - 55440*C*D1*Dd*bd1*f**2*s**2 + 100188*C*D1*Dd*bd1*f**2*s - 43848*C*D1*Dd*bd1*f**2 - 1520*C*D1*Dd*f**3*r**2 + 2080*C*D1*Dd*f**3*r*s + 1000*C*D1*Dd*f**3*r + 3600*C*D1*Dd*f**3*s**2 - 2840*C*D1*Dd*f**3*s + 140*C*D1*Dd*f**3 - 12720*C*D1*Dd*f**2*fd*r**2 - 49440*C*D1*Dd*f**2*fd*r*s + 25020*C*D1*Dd*f**2*fd*r - 36720*C*D1*Dd*f**2*fd*s**2 + 42020*C*D1*Dd*f**2*fd*s - 11360*C*D1*Dd*f**2*fd - 2120*C*D1*Ddd*f**3*r**2 - 8240*C*D1*Ddd*f**3*r*s + 4180*C*D1*Ddd*f**3*r - 6120*C*D1*Ddd*f**3*s**2 + 7180*C*D1*Ddd*f**3*s - 2590*C*D1*Ddd*f**3 - 6360*C*Dd**2*f**3*r**2 - 24720*C*Dd**2*f**3*r*s + 12540*C*Dd**2*f**3*r - 18360*C*Dd**2*f**3*s**2 + 21540*C*Dd**2*f**3*s - 5180*C*Dd**2*f**3 - 8862*D1**2*K*bd1**2*f*r**2 - 19236*D1**2*K*bd1**2*f*r*s + 19110*D1**2*K*bd1**2*f*r - 10374*D1**2*K*bd1**2*f*s**2 + 20622*D1**2*K*bd1**2*f*s - 10248*D1**2*K*bd1**2*f - 378*D1**2*K*bd1*f**2*r**2 + 252*D1**2*K*bd1*f**2*r*s + 756*D1**2*K*bd1*f**2*r + 630*D1**2*K*bd1*f**2*s**2 - 252*D1**2*K*bd1*f**2*s - 378*D1**2*K*bd1*f**2 - 1260*D1**2*K*bd1*f*fd*r**2 - 5544*D1**2*K*bd1*f*fd*r*s + 2646*D1**2*K*bd1*f*fd*r - 4284*D1**2*K*bd1*f*fd*s**2 + 4914*D1**2*K*bd1*f*fd*s - 1386*D1**2*K*bd1*f*fd - 315*D1**2*K*bdd1*f**2*r**2 - 1386*D1**2*K*bdd1*f**2*r*s + 630*D1**2*K*bdd1*f**2*r - 1071*D1**2*K*bdd1*f**2*s**2 + 1386*D1**2*K*bdd1*f**2*s - 315*D1**2*K*bdd1*f**2 + 4158*D1**2*bd1**2*f**2*r**2 + 6804*D1**2*bd1**2*f**2*r*s - 7560*D1**2*bd1**2*f**2*r + 2646*D1**2*bd1**2*f**2*s**2 - 6048*D1**2*bd1**2*f**2*s + 3402*D1**2*bd1**2*f**2 - 924*D1**2*bd1**2*f*r**2 - 1848*D1**2*bd1**2*f*r*s - 1932*D1**2*bd1**2*f*r - 924*D1**2*bd1**2*f*s**2 - 1932*D1**2*bd1**2*f*s + 2856*D1**2*bd1**2*f - 8400*D1**2*bd1**2*g2*r**2 - 16800*D1**2*bd1**2*g2*r*s + 8400*D1**2*bd1**2*g2*r - 8400*D1**2*bd1**2*g2*s**2 + 8400*D1**2*bd1**2*g2*s - 3780*D1**2*bd1*bd2*f*r**2 - 7560*D1**2*bd1*bd2*f*r*s + 7560*D1**2*bd1*bd2*f*r - 3780*D1**2*bd1*bd2*f*s**2 + 7560*D1**2*bd1*bd2*f*s - 3780*D1**2*bd1*bd2*f - 2520*D1**2*bd1*f**2*r**2 - 5076*D1**2*bd1*f**2*r*s + 5220*D1**2*bd1*f**2*r - 2556*D1**2*bd1*f**2*s**2 + 5256*D1**2*bd1*f**2*s - 2565*D1**2*bd1*f**2 + 17892*D1**2*bd1*f*fd*r**2 + 35352*D1**2*bd1*f*fd*r*s - 27072*D1**2*bd1*f*fd*r + 17460*D1**2*bd1*f*fd*s**2 - 26748*D1**2*bd1*f*fd*s + 9288*D1**2*bd1*f*fd - 4284*D1**2*bd1*f*g2*r**2 - 10752*D1**2*bd1*f*g2*r*s + 11172*D1**2*bd1*f*g2*r - 6468*D1**2*bd1*f*g2*s**2 + 13356*D1**2*bd1*f*g2*s - 6678*D1**2*bd1*f*g2 + 17724*D1**2*bd1*f*gd2*r**2 + 38472*D1**2*bd1*f*gd2*r*s - 38220*D1**2*bd1*f*gd2*r + 20748*D1**2*bd1*f*gd2*s**2 - 41244*D1**2*bd1*f*gd2*s + 20496*D1**2*bd1*f*gd2 + 17724*D1**2*bd1*fd*g2*r**2 + 38472*D1**2*bd1*fd*g2*r*s - 19236*D1**2*bd1*fd*g2*r + 20748*D1**2*bd1*fd*g2*s**2 - 20748*D1**2*bd1*fd*g2*s - 315*D1**2*bd2*f**2*r**2 - 630*D1**2*bd2*f**2*r*s + 630*D1**2*bd2*f**2*r - 315*D1**2*bd2*f**2*s**2 + 630*D1**2*bd2*f**2*s - 315*D1**2*bd2*f**2 + 4473*D1**2*bdd1*f**2*r**2 + 8838*D1**2*bdd1*f**2*r*s - 9288*D1**2*bdd1*f**2*r + 4365*D1**2*bdd1*f**2*s**2 - 9180*D1**2*bdd1*f**2*s + 4590*D1**2*bdd1*f**2 + 8862*D1**2*bdd1*f*g2*r**2 + 19236*D1**2*bdd1*f*g2*r*s - 20496*D1**2*bdd1*f*g2*r + 10374*D1**2*bdd1*f*g2*s**2 - 22008*D1**2*bdd1*f*g2*s + 11004*D1**2*bdd1*f*g2 + 840*D1**2*f**2*fd*r**2 - 510*D1**2*f**2*fd*r*s - 390*D1**2*f**2*fd*r - 1350*D1**2*f**2*fd*s**2 + 1070*D1**2*f**2*fd*s - 170*D1**2*f**2*fd + 795*D1**2*f**2*fdd*r**2 + 3090*D1**2*f**2*fdd*r*s - 1560*D1**2*f**2*fdd*r + 2295*D1**2*f**2*fdd*s**2 - 2560*D1**2*f**2*fdd*s + 1030*D1**2*f**2*fdd + 756*D1**2*f**2*gd2*r**2 - 504*D1**2*f**2*gd2*r*s - 1512*D1**2*f**2*gd2*r - 1260*D1**2*f**2*gd2*s**2 + 504*D1**2*f**2*gd2*s + 756*D1**2*f**2*gd2 + 630*D1**2*f**2*gdd2*r**2 + 2772*D1**2*f**2*gdd2*r*s - 1260*D1**2*f**2*gdd2*r + 2142*D1**2*f**2*gdd2*s**2 - 2772*D1**2*f**2*gdd2*s + 630*D1**2*f**2*gdd2 + 1590*D1**2*f*fd**2*r**2 + 6180*D1**2*f*fd**2*r*s - 3120*D1**2*f*fd**2*r + 4590*D1**2*f*fd**2*s**2 - 5120*D1**2*f*fd**2*s + 1030*D1**2*f*fd**2 + 1512*D1**2*f*fd*g2*r**2 - 1008*D1**2*f*fd*g2*r*s + 504*D1**2*f*fd*g2*r - 2520*D1**2*f*fd*g2*s**2 + 2520*D1**2*f*fd*g2*s - 1260*D1**2*f*fd*g2 + 2520*D1**2*f*fd*gd2*r**2 + 11088*D1**2*f*fd*gd2*r*s - 5292*D1**2*f*fd*gd2*r + 8568*D1**2*f*fd*gd2*s**2 - 9828*D1**2*f*fd*gd2*s + 2772*D1**2*f*fd*gd2 + 1260*D1**2*f*fdd*g2*r**2 + 5544*D1**2*f*fdd*g2*r*s - 2772*D1**2*f*fdd*g2*r + 4284*D1**2*f*fdd*g2*s**2 - 4284*D1**2*f*fdd*g2*s + 2142*D1**2*f*fdd*g2 + 1260*D1**2*fd**2*g2*r**2 + 5544*D1**2*fd**2*g2*r*s - 2772*D1**2*fd**2*g2*r + 4284*D1**2*fd**2*g2*s**2 - 4284*D1**2*fd**2*g2*s - 2520*D1*Dd*K*bd1*f**2*r**2 - 11088*D1*Dd*K*bd1*f**2*r*s + 5166*D1*Dd*K*bd1*f**2*r - 8568*D1*Dd*K*bd1*f**2*s**2 + 10458*D1*Dd*K*bd1*f**2*s - 2646*D1*Dd*K*bd1*f**2 + 35784*D1*Dd*bd1*f**2*r**2 + 70704*D1*Dd*bd1*f**2*r*s - 63882*D1*Dd*bd1*f**2*r + 34920*D1*Dd*bd1*f**2*s**2 - 63126*D1*Dd*bd1*f**2*s + 27756*D1*Dd*bd1*f**2 + 70896*D1*Dd*bd1*f*g2*r**2 + 153888*D1*Dd*bd1*f*g2*r*s - 136668*D1*Dd*bd1*f*g2*r + 82992*D1*Dd*bd1*f*g2*s**2 - 147252*D1*Dd*bd1*f*g2*s + 63000*D1*Dd*bd1*f*g2 + 1120*D1*Dd*f**3*r**2 - 680*D1*Dd*f**3*r*s - 950*D1*Dd*f**3*r - 1800*D1*Dd*f**3*s**2 + 1240*D1*Dd*f**3*s + 110*D1*Dd*f**3 + 6360*D1*Dd*f**2*fd*r**2 + 24720*D1*Dd*f**2*fd*r*s - 12510*D1*Dd*f**2*fd*r + 18360*D1*Dd*f**2*fd*s**2 - 21010*D1*Dd*f**2*fd*s + 5680*D1*Dd*f**2*fd + 3024*D1*Dd*f**2*g2*r**2 - 2016*D1*Dd*f**2*g2*r*s - 2520*D1*Dd*f**2*g2*r - 5040*D1*Dd*f**2*g2*s**2 + 3528*D1*Dd*f**2*g2*s + 252*D1*Dd*f**2*g2 + 5040*D1*Dd*f**2*gd2*r**2 + 22176*D1*Dd*f**2*gd2*r*s - 10332*D1*Dd*f**2*gd2*r + 17136*D1*Dd*f**2*gd2*s**2 - 20916*D1*Dd*f**2*gd2*s + 5292*D1*Dd*f**2*gd2 + 10080*D1*Dd*f*fd*g2*r**2 + 44352*D1*Dd*f*fd*g2*r*s - 21672*D1*Dd*f*fd*g2*r + 34272*D1*Dd*f*fd*g2*s**2 - 36792*D1*Dd*f*fd*g2*s + 9828*D1*Dd*f*fd*g2 + 1060*D1*Ddd*f**3*r**2 + 4120*D1*Ddd*f**3*r*s - 2090*D1*Ddd*f**3*r + 3060*D1*Ddd*f**3*s**2 - 3590*D1*Ddd*f**3*s + 1295*D1*Ddd*f**3 + 2520*D1*Ddd*f**2*g2*r**2 + 11088*D1*Ddd*f**2*g2*r*s - 5292*D1*Ddd*f**2*g2*r + 8568*D1*Ddd*f**2*g2*s**2 - 9828*D1*Ddd*f**2*g2*s + 3402*D1*Ddd*f**2*g2 + 105*D1*b2*(bd1*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) - 3*f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 3180*Dd**2*f**3*r**2 + 12360*Dd**2*f**3*r*s - 6270*Dd**2*f**3*r + 9180*Dd**2*f**3*s**2 - 10770*Dd**2*f**3*s + 2590*Dd**2*f**3 + 7560*Dd**2*f**2*g2*r**2 + 33264*Dd**2*f**2*g2*r*s - 15876*Dd**2*f**2*g2*r + 25704*Dd**2*f**2*g2*s**2 - 29484*Dd**2*f**2*g2*s + 6804*Dd**2*f**2*g2 + 105*b1**3*(D1**2*(8*fd - 9*fdd)*(r + s - 1)**2 + D1*(Dd*(8*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (35*K - 25)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-20*K + 9*f + 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-20*K + 9*f + 10)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 21*b1**2*(10*C*D1**2*fd*r**2 + 20*C*D1**2*fd*r*s - 20*C*D1**2*fd*r + 10*C*D1**2*fd*s**2 - 20*C*D1**2*fd*s + 10*C*D1**2*fd + 120*C*D1**2*fdd*r**2 + 240*C*D1**2*fdd*r*s - 240*C*D1**2*fdd*r + 120*C*D1**2*fdd*s**2 - 240*C*D1**2*fdd*s + 120*C*D1**2*fdd + 40*C*D1*Dd*f*r**2 + 80*C*D1*Dd*f*r*s - 60*C*D1*Dd*f*r + 40*C*D1*Dd*f*s**2 - 60*C*D1*Dd*f*s + 30*C*D1*Dd*f + 960*C*D1*Dd*fd*r**2 + 1920*C*D1*Dd*fd*r*s - 1680*C*D1*Dd*fd*r + 960*C*D1*Dd*fd*s**2 - 1680*C*D1*Dd*fd*s + 720*C*D1*Dd*fd + 480*C*D1*Ddd*f*r**2 + 960*C*D1*Ddd*f*r*s - 720*C*D1*Ddd*f*r + 480*C*D1*Ddd*f*s**2 - 720*C*D1*Ddd*f*s + 360*C*D1*Ddd*f + 1440*C*Dd**2*f*r**2 + 2880*C*Dd**2*f*r*s - 2160*C*Dd**2*f*r + 1440*C*Dd**2*f*s**2 - 2160*C*Dd**2*f*s + 720*C*Dd**2*f + 102*D1**2*K*fd*r**2 + 256*D1**2*K*fd*r*s + 10*D1**2*K*fd*r + 154*D1**2*K*fd*s**2 + 10*D1**2*K*fd*s - 5*D1**2*K*fd - 211*D1**2*K*fdd*r**2 - 458*D1**2*K*fdd*r*s - 30*D1**2*K*fdd*r - 247*D1**2*K*fdd*s**2 - 30*D1**2*K*fdd*s + 15*D1**2*K*fdd - 5*D1**2*bdd1*(-20*K + 9*f + 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 102*D1**2*f*fd*r**2 - 132*D1**2*f*fd*r*s + 102*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 51*D1**2*f*fd + 198*D1**2*f*fdd*r**2 + 324*D1**2*f*fdd*r*s - 198*D1**2*f*fdd*r + 126*D1**2*f*fdd*s**2 - 162*D1**2*f*fdd*s + 99*D1**2*f*fdd + 198*D1**2*fd**2*r**2 + 324*D1**2*fd**2*r*s - 198*D1**2*fd**2*r + 126*D1**2*fd**2*s**2 - 162*D1**2*fd**2*s + 24*D1**2*fd*r**2 + 18*D1**2*fd*r*s + 40*D1**2*fd*r - 6*D1**2*fd*s**2 + 40*D1**2*fd*s - 20*D1**2*fd - 22*D1**2*fdd*r**2 - 44*D1**2*fdd*r*s + 180*D1**2*fdd*r - 22*D1**2*fdd*s**2 + 180*D1**2*fdd*s - 90*D1**2*fdd - 350*D1**2*gd2*r**2 - 700*D1**2*gd2*r*s + 700*D1**2*gd2*r - 350*D1**2*gd2*s**2 + 700*D1**2*gd2*s - 350*D1**2*gd2 - 200*D1**2*gdd2*r**2 - 400*D1**2*gdd2*r*s + 400*D1**2*gdd2*r - 200*D1**2*gdd2*s**2 + 400*D1**2*gdd2*s - 200*D1**2*gdd2 + 408*D1*Dd*K*f*r**2 + 1024*D1*Dd*K*f*r*s - 664*D1*Dd*K*f*r + 616*D1*Dd*K*f*s**2 - 820*D1*Dd*K*f*s + 358*D1*Dd*K*f - 1688*D1*Dd*K*fd*r**2 - 3664*D1*Dd*K*fd*r*s + 1182*D1*Dd*K*fd*r - 1976*D1*Dd*K*fd*s**2 + 1290*D1*Dd*K*fd*s + 90*D1*Dd*K*fd - 204*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r*s + 270*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 117*D1*Dd*f**2 + 1584*D1*Dd*f*fd*r**2 + 2592*D1*Dd*f*fd*r*s - 1908*D1*Dd*f*fd*r + 1008*D1*Dd*f*fd*s**2 - 1548*D1*Dd*f*fd*s + 558*D1*Dd*f*fd + 96*D1*Dd*f*r**2 + 72*D1*Dd*f*r*s - 114*D1*Dd*f*r - 24*D1*Dd*f*s**2 - 24*D1*Dd*f*s + 42*D1*Dd*f - 176*D1*Dd*fd*r**2 - 352*D1*Dd*fd*r*s + 852*D1*Dd*fd*r - 176*D1*Dd*fd*s**2 + 852*D1*Dd*fd*s - 540*D1*Dd*fd - 1400*D1*Dd*g2*r**2 - 2800*D1*Dd*g2*r*s + 2100*D1*Dd*g2*r - 1400*D1*Dd*g2*s**2 + 2100*D1*Dd*g2*s - 1050*D1*Dd*g2 - 1600*D1*Dd*gd2*r**2 - 3200*D1*Dd*gd2*r*s + 2800*D1*Dd*gd2*r - 1600*D1*Dd*gd2*s**2 + 2800*D1*Dd*gd2*s - 1200*D1*Dd*gd2 - 844*D1*Ddd*K*f*r**2 - 1832*D1*Ddd*K*f*r*s + 1302*D1*Ddd*K*f*r - 988*D1*Ddd*K*f*s**2 + 1410*D1*Ddd*K*f*s - 669*D1*Ddd*K*f + 396*D1*Ddd*f**2*r**2 + 648*D1*Ddd*f**2*r*s - 558*D1*Ddd*f**2*r + 252*D1*Ddd*f**2*s**2 - 450*D1*Ddd*f**2*s + 261*D1*Ddd*f**2 - 88*D1*Ddd*f*r**2 - 176*D1*Ddd*f*r*s + 132*D1*Ddd*f*r - 88*D1*Ddd*f*s**2 + 132*D1*Ddd*f*s - 66*D1*Ddd*f - 800*D1*Ddd*g2*r**2 - 1600*D1*Ddd*g2*r*s + 1200*D1*Ddd*g2*r - 800*D1*Ddd*g2*s**2 + 1200*D1*Ddd*g2*s - 600*D1*Ddd*g2 + 5*D1*bd1*(D1*(8*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (35*K - 25)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-20*K + 9*f + 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 2532*Dd**2*K*f*r**2 - 5496*Dd**2*K*f*r*s + 3906*Dd**2*K*f*r - 2964*Dd**2*K*f*s**2 + 4230*Dd**2*K*f*s - 1338*Dd**2*K*f + 1188*Dd**2*f**2*r**2 + 1944*Dd**2*f**2*r*s - 1674*Dd**2*f**2*r + 756*Dd**2*f**2*s**2 - 1350*Dd**2*f**2*s + 522*Dd**2*f**2 - 264*Dd**2*f*r**2 - 528*Dd**2*f*r*s + 396*Dd**2*f*r - 264*Dd**2*f*s**2 + 396*Dd**2*f*s - 132*Dd**2*f - 2400*Dd**2*g2*r**2 - 4800*Dd**2*g2*r*s + 3600*Dd**2*g2*r - 2400*Dd**2*g2*s**2 + 3600*Dd**2*g2*s - 1200*Dd**2*g2) - 3*b1*(-1680*C*D1**2*bdd1*f*r**2 - 3360*C*D1**2*bdd1*f*r*s + 1680*C*D1**2*bdd1*f*r - 1680*C*D1**2*bdd1*f*s**2 + 1680*C*D1**2*bdd1*f*s - 840*C*D1**2*bdd1*f - 3576*C*D1**2*f*fd*r**2 - 7104*C*D1**2*f*fd*r*s + 3396*C*D1**2*f*fd*r - 3528*C*D1**2*f*fd*s**2 + 3372*C*D1**2*f*fd*s - 1698*C*D1**2*f*fd + 4476*C*D1**2*f*fdd*r**2 + 9096*C*D1**2*f*fdd*r*s - 4176*C*D1**2*f*fdd*r + 4620*C*D1**2*f*fdd*s**2 - 4248*C*D1**2*f*fdd*s + 2088*C*D1**2*f*fdd + 4476*C*D1**2*fd**2*r**2 + 9096*C*D1**2*fd**2*r*s - 4176*C*D1**2*fd**2*r + 4620*C*D1**2*fd**2*s**2 - 4248*C*D1**2*fd**2*s - 300*C*D1**2*fd**2 - 7152*C*D1*Dd*f**2*r**2 - 14208*C*D1*Dd*f**2*r*s + 10704*C*D1*Dd*f**2*r - 7056*C*D1*Dd*f**2*s**2 + 10632*C*D1*Dd*f**2*s - 5340*C*D1*Dd*f**2 + 35808*C*D1*Dd*f*fd*r**2 + 72768*C*D1*Dd*f*fd*r*s - 43704*C*D1*Dd*f*fd*r + 36960*C*D1*Dd*f*fd*s**2 - 44424*C*D1*Dd*f*fd*s + 12600*C*D1*Dd*f*fd + 8952*C*D1*Ddd*f**2*r**2 + 18192*C*D1*Ddd*f**2*r*s - 13500*C*D1*Ddd*f**2*r + 9240*C*D1*Ddd*f**2*s**2 - 13716*C*D1*Ddd*f**2*s + 6786*C*D1*Ddd*f**2 + 26856*C*Dd**2*f**2*r**2 + 54576*C*Dd**2*f**2*r*s - 40500*C*Dd**2*f**2*r + 27720*C*Dd**2*f**2*s**2 - 41148*C*Dd**2*f**2*s + 13572*C*Dd**2*f**2 + 2954*D1**2*K*bdd1*f*r**2 + 6412*D1**2*K*bdd1*f*r*s - 6370*D1**2*K*bdd1*f*r + 3458*D1**2*K*bdd1*f*s**2 - 6874*D1**2*K*bdd1*f*s + 3311*D1**2*K*bdd1*f + 252*D1**2*K*f*fd*r**2 - 168*D1**2*K*f*fd*r*s + 84*D1**2*K*f*fd*r - 420*D1**2*K*f*fd*s**2 + 420*D1**2*K*f*fd*s - 210*D1**2*K*f*fd + 210*D1**2*K*f*fdd*r**2 + 924*D1**2*K*f*fdd*r*s - 462*D1**2*K*f*fdd*r + 714*D1**2*K*f*fdd*s**2 - 714*D1**2*K*f*fdd*s + 357*D1**2*K*f*fdd + 210*D1**2*K*fd**2*r**2 + 924*D1**2*K*fd**2*r*s - 462*D1**2*K*fd**2*r + 714*D1**2*K*fd**2*s**2 - 714*D1**2*K*fd**2*s - 385*D1**2*b2*fd*r**2 - 770*D1**2*b2*fd*r*s - 385*D1**2*b2*fd*s**2 + 630*D1**2*b2*fdd*r**2 + 1260*D1**2*b2*fdd*r*s + 630*D1**2*b2*fdd*s**2 + 70*D1**2*bd1**2*(-20*K + 9*f + 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 1386*D1**2*bdd1*f**2*r**2 - 2268*D1**2*bdd1*f**2*r*s + 2520*D1**2*bdd1*f**2*r - 882*D1**2*bdd1*f**2*s**2 + 2016*D1**2*bdd1*f**2*s - 1134*D1**2*bdd1*f**2 + 308*D1**2*bdd1*f*r**2 + 616*D1**2*bdd1*f*r*s + 644*D1**2*bdd1*f*r + 308*D1**2*bdd1*f*s**2 + 644*D1**2*bdd1*f*s - 322*D1**2*bdd1*f + 2800*D1**2*bdd1*g2*r**2 + 5600*D1**2*bdd1*g2*r*s - 2800*D1**2*bdd1*g2*r + 2800*D1**2*bdd1*g2*s**2 - 2800*D1**2*bdd1*g2*s + 1400*D1**2*bdd1*g2 + 630*D1**2*bdd2*f*r**2 + 1260*D1**2*bdd2*f*r*s - 1260*D1**2*bdd2*f*r + 630*D1**2*bdd2*f*s**2 - 1260*D1**2*bdd2*f*s + 630*D1**2*bdd2*f + 1680*D1**2*f*fd*r**2 + 3384*D1**2*f*fd*r*s - 1632*D1**2*f*fd*r + 1704*D1**2*f*fd*s**2 - 1644*D1**2*f*fd*s + 837*D1**2*f*fd - 2982*D1**2*f*fdd*r**2 - 5892*D1**2*f*fdd*r*s + 2832*D1**2*f*fdd*r - 2910*D1**2*f*fdd*s**2 + 2796*D1**2*f*fdd*s - 1416*D1**2*f*fdd + 1428*D1**2*f*gd2*r**2 + 3584*D1**2*f*gd2*r*s - 2856*D1**2*f*gd2*r + 2156*D1**2*f*gd2*s**2 - 3584*D1**2*f*gd2*s + 1428*D1**2*f*gd2 - 2954*D1**2*f*gdd2*r**2 - 6412*D1**2*f*gdd2*r*s + 5908*D1**2*f*gdd2*r - 3458*D1**2*f*gdd2*s**2 + 6412*D1**2*f*gdd2*s - 2954*D1**2*f*gdd2 - 2982*D1**2*fd**2*r**2 - 5892*D1**2*fd**2*r*s + 2832*D1**2*fd**2*r - 2910*D1**2*fd**2*s**2 + 2796*D1**2*fd**2*s + 150*D1**2*fd**2 + 1428*D1**2*fd*g2*r**2 + 3584*D1**2*fd*g2*r*s + 140*D1**2*fd*g2*r + 2156*D1**2*fd*g2*s**2 + 140*D1**2*fd*g2*s - 70*D1**2*fd*g2 - 5908*D1**2*fd*gd2*r**2 - 12824*D1**2*fd*gd2*r*s + 5488*D1**2*fd*gd2*r - 6916*D1**2*fd*gd2*s**2 + 5992*D1**2*fd*gd2*s + 420*D1**2*fd*gd2 - 2954*D1**2*fdd*g2*r**2 - 6412*D1**2*fdd*g2*r*s - 420*D1**2*fdd*g2*r - 3458*D1**2*fdd*g2*s**2 - 420*D1**2*fdd*g2*s + 210*D1**2*fdd*g2 + 504*D1*Dd*K*f**2*r**2 - 336*D1*Dd*K*f**2*r*s - 420*D1*Dd*K*f**2*r - 840*D1*Dd*K*f**2*s**2 + 588*D1*Dd*K*f**2*s + 42*D1*Dd*K*f**2 + 1680*D1*Dd*K*f*fd*r**2 + 7392*D1*Dd*K*f*fd*r*s - 3612*D1*Dd*K*f*fd*r + 5712*D1*Dd*K*f*fd*s**2 - 6132*D1*Dd*K*f*fd*s + 1638*D1*Dd*K*f*fd - 1540*D1*Dd*b2*f*r**2 - 3080*D1*Dd*b2*f*r*s + 2310*D1*Dd*b2*f*r - 1540*D1*Dd*b2*f*s**2 + 2310*D1*Dd*b2*f*s - 1155*D1*Dd*b2*f + 5040*D1*Dd*b2*fd*r**2 + 10080*D1*Dd*b2*fd*r*s - 3780*D1*Dd*b2*fd*r + 5040*D1*Dd*b2*fd*s**2 - 3780*D1*Dd*b2*fd*s + 3360*D1*Dd*f**2*r**2 + 6768*D1*Dd*f**2*r*s - 5052*D1*Dd*f**2*r + 3408*D1*Dd*f**2*s**2 - 5088*D1*Dd*f**2*s + 2532*D1*Dd*f**2 - 23856*D1*Dd*f*fd*r**2 - 47136*D1*Dd*f*fd*r*s + 29148*D1*Dd*f*fd*r - 23280*D1*Dd*f*fd*s**2 + 28788*D1*Dd*f*fd*s - 8460*D1*Dd*f*fd + 5712*D1*Dd*f*g2*r**2 + 14336*D1*Dd*f*g2*r*s - 9296*D1*Dd*f*g2*r + 8624*D1*Dd*f*g2*s**2 - 11480*D1*Dd*f*g2*s + 5012*D1*Dd*f*g2 - 23632*D1*Dd*f*gd2*r**2 - 51296*D1*Dd*f*gd2*r*s + 41860*D1*Dd*f*gd2*r - 27664*D1*Dd*f*gd2*s**2 + 45388*D1*Dd*f*gd2*s - 18228*D1*Dd*f*gd2 - 23632*D1*Dd*fd*g2*r**2 - 51296*D1*Dd*fd*g2*r*s + 16548*D1*Dd*fd*g2*r - 27664*D1*Dd*fd*g2*s**2 + 18060*D1*Dd*fd*g2*s + 1260*D1*Dd*fd*g2 + 420*D1*Ddd*K*f**2*r**2 + 1848*D1*Ddd*K*f**2*r*s - 882*D1*Ddd*K*f**2*r + 1428*D1*Ddd*K*f**2*s**2 - 1638*D1*Ddd*K*f**2*s + 567*D1*Ddd*K*f**2 + 2520*D1*Ddd*b2*f*r**2 + 5040*D1*Ddd*b2*f*r*s - 3780*D1*Ddd*b2*f*r + 2520*D1*Ddd*b2*f*s**2 - 3780*D1*Ddd*b2*f*s + 1890*D1*Ddd*b2*f - 5964*D1*Ddd*f**2*r**2 - 11784*D1*Ddd*f**2*r*s + 8910*D1*Ddd*f**2*r - 5820*D1*Ddd*f**2*s**2 + 8802*D1*Ddd*f**2*s - 4437*D1*Ddd*f**2 - 11816*D1*Ddd*f*g2*r**2 - 25648*D1*Ddd*f*g2*r*s + 18228*D1*Ddd*f*g2*r - 13832*D1*Ddd*f*g2*s**2 + 19740*D1*Ddd*f*g2*s - 9366*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(6*f**2*(17*r**2 + r*(22*s - 28) + 5*s**2 - 16*s + 11) - f*(10*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 204*K*r**2 + 512*K*r*s - 470*K*r + 308*K*s**2 - 574*K*s + 261*K + 36*fd*(22*r**2 + 36*r*s - 31*r + 14*s**2 - 25*s + 10) + 48*r**2 + 36*r*s - 106*r - 12*s**2 - 46*s + 38) + 2*fd*(-120*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(422*r**2 + 916*r*s - 425*r + 494*s**2 - 461*s - 15) + 44*r**2 + 88*r*s - 134*r + 44*s**2 - 134*s + 90) + 350*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 400*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(18*f**2*(44*r**2 + r*(72*s - 71) + 28*s**2 - 57*s + 28) + f*(120*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(1688*r**2 + 3664*r*s - 3122*r + 1976*s**2 - 3374*s + 1401) - 176*r**2 - 352*r*s - 52*r - 176*s**2 - 52*s + 138) - 200*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 35*D1*bd2*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) + 1260*Dd**2*K*f**2*r**2 + 5544*Dd**2*K*f**2*r*s - 2646*Dd**2*K*f**2*r + 4284*Dd**2*K*f**2*s**2 - 4914*Dd**2*K*f**2*s + 1134*Dd**2*K*f**2 + 7560*Dd**2*b2*f*r**2 + 15120*Dd**2*b2*f*r*s - 11340*Dd**2*b2*f*r + 7560*Dd**2*b2*f*s**2 - 11340*Dd**2*b2*f*s + 3780*Dd**2*b2*f - 17892*Dd**2*f**2*r**2 - 35352*Dd**2*f**2*r*s + 26730*Dd**2*f**2*r - 17460*Dd**2*f**2*s**2 + 26406*Dd**2*f**2*s - 8874*Dd**2*f**2 - 35448*Dd**2*f*g2*r**2 - 76944*Dd**2*f*g2*r*s + 54684*Dd**2*f*g2*r - 41496*Dd**2*f*g2*s**2 + 59220*Dd**2*f*g2*s - 18732*Dd**2*f*g2))/(630*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**2*k1**2*st**4*(-7*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(5*f**3*s*(7*r + 7*s - 5) + f**2*(-5*fd*(6*s - 1)*(4*r + 4*s - 3) + s*(4*C*s + r*(4*C + 19) + 19*s - 23)) - f*(fd*(r*(2*C + 13)*(4*s - 1) + s**2*(8*C + 52) - s*(6*C + 54) + 15) + 14*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 14*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(5*f**2*(8*s - 1)*(4*r + 4*s - 3) + f*(r*(2*C + 13)*(8*s - 1) + s**2*(16*C + 104) - s*(8*C + 112) + 15) - 14*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 7*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(5*f**2*(fd*(7*r*(3*s - 1) + 21*s**2 - 23*s + 7) + fdd*(r*(4 - 12*s) - 12*s**2 + 13*s - 4)) + f*(-5*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) + fd*(4*C*(2*s - 1)*(r + s - 1) + 38*r*s - 19*r + 38*s**2 - 34*s + 19) - fdd*(2*C*(2*s - 1)*(r + s - 1) + 26*r*s - 13*r + 26*s**2 - 24*s + 13) - 7*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) + fd**2*(-2*C*(2*s - 1)*(r + s - 1) + r*(13 - 26*s) - 26*s**2 + 24*s + 2) - 14*fd*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 14*fdd*g2*(s - 1)*(r + s - 1)) - 7*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(35*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(24*s - 7)*(4*r + 4*s - 3) + 19*r*(4*s - 1) + 19*(1 - 2*s)**2) - 2*f*(fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 13*r*(8*s - 3) + 104*s**2 - 100*s + 25) + 7*g2*r*(8*s - 2) + 14*g2*(1 - 2*s)**2 + 7*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 14*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(20*f**2 + f*(2*C + 13) - 14*g2)) - Dd**2*f*(20*f**2 + f*(2*C + 13) - 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - f*(D1**2*(5*bdd1*f**2*s*(4*r + 4*s - 3) - 14*bdd1*g2*s*(r + s) + f*(bdd1*s*(2*C*r + 2*C*s + 13*r + 13*s - 15) - 9*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(-9*f*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**2*k1**2*st**2*(-1008*C*D1**2*f**2*fd*r*s + 336*C*D1**2*f**2*fd*r - 1008*C*D1**2*f**2*fd*s**2 + 1008*C*D1**2*f**2*fd*s - 336*C*D1**2*f**2*fd + 720*C*D1**2*f**2*fdd*r*s - 240*C*D1**2*f**2*fdd*r + 720*C*D1**2*f**2*fdd*s**2 - 720*C*D1**2*f**2*fdd*s + 240*C*D1**2*f**2*fdd + 1440*C*D1**2*f*fd**2*r*s - 480*C*D1**2*f*fd**2*r + 1440*C*D1**2*f*fd**2*s**2 - 1440*C*D1**2*f*fd**2*s + 240*C*D1**2*f*fd**2 - 1344*C*D1*Dd*f**3*r*s + 336*C*D1*Dd*f**3*r - 1344*C*D1*Dd*f**3*s**2 + 1344*C*D1*Dd*f**3*s - 336*C*D1*Dd*f**3 + 5760*C*D1*Dd*f**2*fd*r*s - 1680*C*D1*Dd*f**2*fd*r + 5760*C*D1*Dd*f**2*fd*s**2 - 5760*C*D1*Dd*f**2*fd*s + 1200*C*D1*Dd*f**2*fd + 960*C*D1*Ddd*f**3*r*s - 240*C*D1*Ddd*f**3*r + 960*C*D1*Ddd*f**3*s**2 - 960*C*D1*Ddd*f**3*s + 240*C*D1*Ddd*f**3 + 2880*C*Dd**2*f**3*r*s - 720*C*Dd**2*f**3*r + 2880*C*Dd**2*f**3*s**2 - 2880*C*Dd**2*f**3*s + 480*C*Dd**2*f**3 - 2*D1**2*bd1**2*(36*f**2*(r**2 + r*(6*s - 5) + 5*s**2 - 10*s + 3) - 7*f*(r**2*(17*K - 23) + r*(C*(4 - 8*s) + 30*K*s - 17*K - 82*s + 37) + s**2*(-8*C + 13*K - 59) + s*(8*C - 15*K + 73) - 18) - 140*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*D1**2*bdd1*f*(9*f**2*(27*r**2 + 32*r*(2*s - 1) + 37*s**2 - 44*s + 16) + f*(r**2*(59*C + 91) + 2*r*(s*(29*C + 54*K + 148) - 132) + s**2*(-C + 108*K + 205) - s*(108*K + 336) + 105) - 7*g2*(17*r**2 + 30*r*s + 13*s**2)) + 216*D1**2*bdd2*f**2*r*s + 216*D1**2*bdd2*f**2*s**2 - 216*D1**2*bdd2*f**2*s - 630*D1**2*f**2*fd*r**2 - 1188*D1**2*f**2*fd*r*s + 816*D1**2*f**2*fd*r - 558*D1**2*f**2*fd*s**2 + 768*D1**2*f**2*fd*s - 396*D1**2*f**2*fd + 594*D1**2*f**2*fdd*r**2 + 1008*D1**2*f**2*fdd*r*s - 732*D1**2*f**2*fdd*r + 414*D1**2*f**2*fdd*s**2 - 612*D1**2*f**2*fdd*s + 336*D1**2*f**2*fdd + 528*D1**2*f**2*gd2*r*s + 528*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s - 432*D1**2*f**2*gdd2*r*s - 432*D1**2*f**2*gdd2*s**2 + 432*D1**2*f**2*gdd2*s + 1188*D1**2*f*fd**2*r**2 + 2016*D1**2*f*fd**2*r*s - 1464*D1**2*f*fd**2*r + 828*D1**2*f*fd**2*s**2 - 1224*D1**2*f*fd**2*s + 336*D1**2*f*fd**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 1056*D1**2*f*fd*g2*s**2 - 1056*D1**2*f*fd*g2*s + 528*D1**2*f*fd*g2 - 1728*D1**2*f*fd*gd2*r*s + 432*D1**2*f*fd*gd2*r - 1728*D1**2*f*fd*gd2*s**2 + 1728*D1**2*f*fd*gd2*s - 432*D1**2*f*fd*gd2 - 864*D1**2*f*fdd*g2*r*s + 432*D1**2*f*fdd*g2*r - 864*D1**2*f*fdd*g2*s**2 + 864*D1**2*f*fdd*g2*s - 432*D1**2*f*fdd*g2 - 864*D1**2*fd**2*g2*r*s + 432*D1**2*fd**2*g2*r - 864*D1**2*fd**2*g2*s**2 + 864*D1**2*fd**2*g2*s - 840*D1*Dd*f**3*r**2 - 1584*D1*Dd*f**3*r*s + 1236*D1*Dd*f**3*r - 744*D1*Dd*f**3*s**2 + 1164*D1*Dd*f**3*s - 606*D1*Dd*f**3 + 4752*D1*Dd*f**2*fd*r**2 + 8064*D1*Dd*f**2*fd*r*s - 6312*D1*Dd*f**2*fd*r + 3312*D1*Dd*f**2*fd*s**2 - 5292*D1*Dd*f**2*fd*s + 2076*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*g2*r*s - 528*D1*Dd*f**2*g2*r + 2112*D1*Dd*f**2*g2*s**2 - 2112*D1*Dd*f**2*g2*s + 528*D1*Dd*f**2*g2 - 3456*D1*Dd*f**2*gd2*r*s + 432*D1*Dd*f**2*gd2*r - 3456*D1*Dd*f**2*gd2*s**2 + 3456*D1*Dd*f**2*gd2*s - 432*D1*Dd*f**2*gd2 - 6912*D1*Dd*f*fd*g2*r*s + 2592*D1*Dd*f*fd*g2*r - 6912*D1*Dd*f*fd*g2*s**2 + 6912*D1*Dd*f*fd*g2*s - 1728*D1*Dd*f*fd*g2 + 792*D1*Ddd*f**3*r**2 + 1344*D1*Ddd*f**3*r*s - 1128*D1*Ddd*f**3*r + 552*D1*Ddd*f**3*s**2 - 948*D1*Ddd*f**3*s + 534*D1*Ddd*f**3 - 1728*D1*Ddd*f**2*g2*r*s + 432*D1*Ddd*f**2*g2*r - 1728*D1*Ddd*f**2*g2*s**2 + 1728*D1*Ddd*f**2*g2*s - 432*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(9*f**3*(21*r**2 + 4*r*(19*s - 6) + 55*s**2 - 52*s + 12) + f**2*(33*C*s**2 + 132*K*s**2 - 132*K*s - 18*fd*(81*r**2 + 2*r*(96*s - 59) + 111*s**2 - 145*s + 38) + r**2*(69*C + 49) + 2*r*(s*(51*C + 66*K + 135) - 82) + 221*s**2 - 322*s + 35) - 2*f*fd*(-2*C*s**2 - 28*C*s + 54*K*(r*(4*s - 1) + (1 - 2*s)**2) + r**2*(118*C + 182) + r*(116*C*s - 88*C + 592*s - 371) + 410*s**2 - 521*s + 195) + 7*f*(g2*(r**2 - 50*r*s - 51*s**2) + gd2*(34*r**2 + r*(60*s - 34) + 2*s*(13*s - 15))) + 14*fd*g2*(17*r**2 + 15*r*(2*s - 1) + s*(13*s - 13))) - 2*Dd*f*(9*f**2*(108*r**2 + 2*r*(128*s - 75) + 148*s**2 - 189*s + 54) + f*(-4*C*s**2 - 57*C*s + 54*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + r**2*(236*C + 364) + r*(232*C*s - 147*C + 1184*s - 858) + 820*s**2 - 1173*s + 432) - 7*g2*(68*r**2 + r*(120*s - 49) + s*(52*s - 43)))) - 24*D1*bd2*f*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 2376*Dd**2*f**3*r**2 + 4032*Dd**2*f**3*r*s - 3384*Dd**2*f**3*r + 1656*Dd**2*f**3*s**2 - 2844*Dd**2*f**3*s + 1068*Dd**2*f**3 - 5184*Dd**2*f**2*g2*r*s + 1296*Dd**2*f**2*g2*r - 5184*Dd**2*f**2*g2*s**2 + 5184*Dd**2*f**2*g2*s - 864*Dd**2*f**2*g2 + 140*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(112*C*D1**2*fd*r*s + 112*C*D1**2*fd*s**2 - 112*C*D1**2*fd*s - 56*C*D1**2*fdd*r*s - 56*C*D1**2*fdd*s**2 + 56*C*D1**2*fdd*s + 448*C*D1*Dd*f*r*s - 112*C*D1*Dd*f*r + 448*C*D1*Dd*f*s**2 - 448*C*D1*Dd*f*s + 112*C*D1*Dd*f - 448*C*D1*Dd*fd*r*s + 56*C*D1*Dd*fd*r - 448*C*D1*Dd*fd*s**2 + 448*C*D1*Dd*fd*s - 56*C*D1*Dd*fd - 224*C*D1*Ddd*f*r*s + 56*C*D1*Ddd*f*r - 224*C*D1*Ddd*f*s**2 + 224*C*D1*Ddd*f*s - 56*C*D1*Ddd*f - 672*C*Dd**2*f*r*s + 168*C*Dd**2*f*r - 672*C*Dd**2*f*s**2 + 672*C*Dd**2*f*s - 112*C*Dd**2*f + 7*D1**2*K*fd*r**2 - 350*D1**2*K*fd*r*s + 350*D1**2*K*fd*r - 357*D1**2*K*fd*s**2 + 714*D1**2*K*fd*s - 357*D1**2*K*fd + 119*D1**2*K*fdd*r**2 + 210*D1**2*K*fdd*r*s - 210*D1**2*K*fdd*r + 91*D1**2*K*fdd*s**2 - 182*D1**2*K*fdd*s + 91*D1**2*K*fdd - 140*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 60*D1**2*f*fd*r**2 + 696*D1**2*f*fd*r*s + 84*D1**2*f*fd*r + 636*D1**2*f*fd*s**2 - 144*D1**2*f*fd*s - 144*D1**2*f*fd - 72*D1**2*f*fdd*r**2 - 432*D1**2*f*fdd*r*s - 360*D1**2*f*fdd*s**2 + 72*D1**2*f*fdd*s + 72*D1**2*f*fdd - 72*D1**2*fd**2*r**2 - 432*D1**2*fd**2*r*s - 360*D1**2*fd**2*s**2 + 72*D1**2*fd**2*s + 72*D1**2*fd**2 + 7*D1**2*fd*r**2 + 658*D1**2*fd*r*s - 406*D1**2*fd*r + 651*D1**2*fd*s**2 - 686*D1**2*fd*s + 399*D1**2*fd - 161*D1**2*fdd*r**2 - 574*D1**2*fdd*r*s + 378*D1**2*fdd*r - 413*D1**2*fdd*s**2 + 378*D1**2*fdd*s - 217*D1**2*fdd - 560*D1**2*gd2*r*s - 560*D1**2*gd2*s**2 + 560*D1**2*gd2*s + 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*s**2 - 280*D1**2*gdd2*s + 28*D1*Dd*K*f*r**2 - 1400*D1*Dd*K*f*r*s + 322*D1*Dd*K*f*r - 1428*D1*Dd*K*f*s**2 + 1414*D1*Dd*K*f*s - 343*D1*Dd*K*f + 952*D1*Dd*K*fd*r**2 + 1680*D1*Dd*K*fd*r*s - 1526*D1*Dd*K*fd*r + 728*D1*Dd*K*fd*s**2 - 1330*D1*Dd*K*fd*s + 602*D1*Dd*K*fd + 120*D1*Dd*f**2*r**2 + 1392*D1*Dd*f**2*r*s - 468*D1*Dd*f**2*r + 1272*D1*Dd*f**2*s**2 - 1332*D1*Dd*f**2*s + 378*D1*Dd*f**2 - 576*D1*Dd*f*fd*r**2 - 3456*D1*Dd*f*fd*r*s + 720*D1*Dd*f*fd*r - 2880*D1*Dd*f*fd*s**2 + 1872*D1*Dd*f*fd*s - 72*D1*Dd*f*fd + 28*D1*Dd*f*r**2 + 2632*D1*Dd*f*r*s - 686*D1*Dd*f*r + 2604*D1*Dd*f*s**2 - 2618*D1*Dd*f*s + 665*D1*Dd*f - 1288*D1*Dd*fd*r**2 - 4592*D1*Dd*fd*r*s + 2730*D1*Dd*fd*r - 3304*D1*Dd*fd*s**2 + 3486*D1*Dd*fd*s - 1134*D1*Dd*fd - 2240*D1*Dd*g2*r*s + 560*D1*Dd*g2*r - 2240*D1*Dd*g2*s**2 + 2240*D1*Dd*g2*s - 560*D1*Dd*g2 + 2240*D1*Dd*gd2*r*s - 280*D1*Dd*gd2*r + 2240*D1*Dd*gd2*s**2 - 2240*D1*Dd*gd2*s + 280*D1*Dd*gd2 + 476*D1*Ddd*K*f*r**2 + 840*D1*Ddd*K*f*r*s - 686*D1*Ddd*K*f*r + 364*D1*Ddd*K*f*s**2 - 602*D1*Ddd*K*f*s + 329*D1*Ddd*K*f - 144*D1*Ddd*f**2*r**2 - 864*D1*Ddd*f**2*r*s + 360*D1*Ddd*f**2*r - 720*D1*Ddd*f**2*s**2 + 792*D1*Ddd*f**2*s - 252*D1*Ddd*f**2 - 644*D1*Ddd*f*r**2 - 2296*D1*Ddd*f*r*s + 1218*D1*Ddd*f*r - 1652*D1*Ddd*f*s**2 + 1974*D1*Ddd*f*s - 735*D1*Ddd*f + 1120*D1*Ddd*g2*r*s - 280*D1*Ddd*g2*r + 1120*D1*Ddd*g2*s**2 - 1120*D1*Ddd*g2*s + 280*D1*Ddd*g2 + 140*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 1428*Dd**2*K*f*r**2 + 2520*Dd**2*K*f*r*s - 2058*Dd**2*K*f*r + 1092*Dd**2*K*f*s**2 - 1806*Dd**2*K*f*s + 658*Dd**2*K*f - 432*Dd**2*f**2*r**2 - 2592*Dd**2*f**2*r*s + 1080*Dd**2*f**2*r - 2160*Dd**2*f**2*s**2 + 2376*Dd**2*f**2*s - 504*Dd**2*f**2 - 1932*Dd**2*f*r**2 - 6888*Dd**2*f*r*s + 3654*Dd**2*f*r - 4956*Dd**2*f*s**2 + 5922*Dd**2*f*s - 1470*Dd**2*f + 3360*Dd**2*g2*r*s - 840*Dd**2*g2*r + 3360*Dd**2*g2*s**2 - 3360*Dd**2*g2*s + 560*Dd**2*g2) - b1*(140*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(36*f**2*(2*r**2 + 2*r*(6*s - 5) + 10*s**2 - 20*s + 9) + 7*f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - K*(34*r**2 + 60*r*s - 34*r + 26*s**2 - 30*s + 17) + 46*r**2 + 164*r*s - 74*r + 118*s**2 - 146*s + 51) - 280*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 2*D1**2*(9*f**2*(fd*(63*r**2 + 4*r*(57*s - 34) + 165*s**2 - 210*s + 85) - fdd*(81*r**2 + 4*r*(48*s - 35) + 111*s**2 - 158*s + 75)) + f*(-18*fd**2*(81*r**2 + 4*r*(48*s - 35) + 111*s**2 - 158*s + 53) + fd*(6*C*(23*r**2 + r*(34*s - 40) + 11*s**2 - 28*s + 17) + 132*K*(2*r*s - r + 2*s**2 - 2*s + 1) + 98*r**2 + 540*r*s - 204*r + 442*s**2 - 390*s + 235) - fdd*(2*C*(59*r**2 + r*(58*s - 88) - s**2 - 28*s + 29) + 108*K*(2*r*s - r + 2*s**2 - 2*s + 1) + 182*r**2 + 592*r*s - 214*r + 410*s**2 - 370*s + 191) + (gd2*(r - 51*s - 1) + gdd2*(17*r + 13*s - 17))*(7*r + 7*s - 7)) - 2*fd**2*(C*(59*r**2 + r*(58*s - 88) - s**2 - 28*s + 29) + 108*K*s**2 - 108*K*s + 91*r**2 + r*(54*K*(2*s - 1) + 296*s - 107) + 205*s**2 - 185*s - 47) + 7*fd*(g2*(r - 51*s + 51) + 2*gd2*(17*r + 13*s - 15))*(r + s - 1) + 7*fdd*g2*(17*r**2 + 30*r*(s - 1) + 13*(s - 1)**2)) + D1*bd1*(-D1*(6*f**2*(10*r**2 + 4*r*(29*s - 23) + 106*s**2 - 198*s + 87) + f*(112*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 7*K*(2*r**2 - 2*r*(50*s + 1) - 102*s**2 + 50*s + 1) - 72*fd*(4*r**2 + 2*r*(12*s - 5) + 20*s**2 - 22*s + 5) + 14*r**2 + 1316*r*s - 266*r + 1302*s**2 - 1274*s + 259) - 14*fd*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(34*r**2 + 60*r*s - 47*r + 26*s**2 - 41*s + 15) + 46*r**2 + 164*r*s - 91*r + 118*s**2 - 127*s + 23) - 280*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 280*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(72*f**2*(4*r**2 + 3*r*(8*s - 5) + 20*s**2 - 31*s + 10) + 7*f*(8*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - K*(136*r**2 + 240*r*s - 166*r + 104*s**2 - 146*s + 49) + 184*r**2 + 656*r*s - 322*r + 472*s**2 - 574*s + 147) - 280*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 2*D1*(Dd*(9*f**3*(84*r**2 + 16*r*(19*s - 10) + 220*s**2 - 262*s + 97) + f**2*(3*C*(92*r**2 + 2*r*(68*s - 63) + 44*s**2 - 90*s + 57) + 528*K*r*s - 132*K*r + 528*K*s**2 - 528*K*s + 132*K - 18*fd*(324*r**2 + 768*r*s - 538*r + 444*s**2 - 619*s + 219) + 196*r**2 + 1080*r*s - 466*r + 884*s**2 - 982*s + 319) + f*(-2*fd*(C*(472*r**2 + r*(464*s - 646) - 8*s**2 - 226*s + 204) + 108*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) + 728*r**2 + 2368*r*s - 1088*r + 1640*s**2 - 1742*s + 399) + 7*g2*(4*r**2 + r*(46 - 200*s) - 204*s**2 + 202*s - 49) + 14*gd2*(68*r**2 + 3*r*(40*s - 39) + 52*s**2 - 103*s + 49)) + 14*fd*g2*(68*r**2 + r*(120*s - 109) + 52*s**2 - 95*s + 43)) - Ddd*f*(9*f**2*(108*r**2 + 4*r*(64*s - 43) + 148*s**2 - 202*s + 91) + f*(C*(236*r**2 + r*(232*s - 294) - 4*s**2 - 114*s + 117) + 108*K*(r*(4*s - 1) + (1 - 2*s)**2) + 364*r**2 + 1184*r*s - 660*r + 820*s**2 - 1002*s + 387) - 7*g2*(68*r**2 + 2*r*(60*s - 49) + 52*s**2 - 86*s + 47))) - 4*Dd**2*f*(9*f**2*(162*r**2 + 6*r*(64*s - 43) + 222*s**2 - 303*s + 91) + 3*f*(C*(118*r**2 + r*(116*s - 147) - 2*s**2 - 57*s + 39) + 18*K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 182*r**2 + 592*r*s - 330*r + 410*s**2 - 501*s + 129) - 7*g2*(102*r**2 + 3*r*(60*s - 49) + 78*s**2 - 129*s + 47))) - 24*b2*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(210*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**2*k1**2*(90*C*D1**2*bdd1*f**2*r**2 + 1548*C*D1**2*bdd1*f**2*r*s + 1458*C*D1**2*bdd1*f**2*s**2 + 1290*C*D1**2*f**2*fd*r**2 + 6420*C*D1**2*f**2*fd*r*s - 3000*C*D1**2*f**2*fd*r + 5130*C*D1**2*f**2*fd*s**2 - 5560*C*D1**2*f**2*fd*s + 2140*C*D1**2*f**2*fd - 1590*C*D1**2*f**2*fdd*r**2 - 6180*C*D1**2*f**2*fdd*r*s + 3120*C*D1**2*f**2*fdd*r - 4590*C*D1**2*f**2*fdd*s**2 + 5120*C*D1**2*f**2*fdd*s - 2060*C*D1**2*f**2*fdd - 3180*C*D1**2*f*fd**2*r**2 - 12360*C*D1**2*f*fd**2*r*s + 6240*C*D1**2*f*fd**2*r - 9180*C*D1**2*f*fd**2*s**2 + 10240*C*D1**2*f*fd**2*s - 2060*C*D1**2*f*fd**2 + 1720*C*D1*Dd*f**3*r**2 + 8560*C*D1*Dd*f**3*r*s - 3860*C*D1*Dd*f**3*r + 6840*C*D1*Dd*f**3*s**2 - 7700*C*D1*Dd*f**3*s + 2570*C*D1*Dd*f**3 - 12720*C*D1*Dd*f**2*fd*r**2 - 49440*C*D1*Dd*f**2*fd*r*s + 25020*C*D1*Dd*f**2*fd*r - 36720*C*D1*Dd*f**2*fd*s**2 + 42020*C*D1*Dd*f**2*fd*s - 11360*C*D1*Dd*f**2*fd - 2120*C*D1*Ddd*f**3*r**2 - 8240*C*D1*Ddd*f**3*r*s + 4180*C*D1*Ddd*f**3*r - 6120*C*D1*Ddd*f**3*s**2 + 7180*C*D1*Ddd*f**3*s - 2590*C*D1*Ddd*f**3 - 6360*C*Dd**2*f**3*r**2 - 24720*C*Dd**2*f**3*r*s + 12540*C*Dd**2*f**3*r - 18360*C*Dd**2*f**3*s**2 + 21540*C*Dd**2*f**3*s - 5180*C*Dd**2*f**3 - 315*D1**2*K*bdd1*f**2*r**2 - 1386*D1**2*K*bdd1*f**2*r*s + 630*D1**2*K*bdd1*f**2*r - 1071*D1**2*K*bdd1*f**2*s**2 + 1386*D1**2*K*bdd1*f**2*s - 315*D1**2*K*bdd1*f**2 + 63*D1**2*b2*bdd1*f*r**2 + 126*D1**2*b2*bdd1*f*r*s + 63*D1**2*b2*bdd1*f*s**2 + 378*D1**2*b2*f*fd*r**2 + 2772*D1**2*b2*f*fd*r*s - 1386*D1**2*b2*f*fd*r + 2394*D1**2*b2*f*fd*s**2 - 2394*D1**2*b2*f*fd*s + 1197*D1**2*b2*f*fd - 630*D1**2*b2*f*fdd*r**2 - 2772*D1**2*b2*f*fdd*r*s + 1386*D1**2*b2*f*fdd*r - 2142*D1**2*b2*f*fdd*s**2 + 2142*D1**2*b2*f*fdd*s - 1071*D1**2*b2*f*fdd - 630*D1**2*b2*fd**2*r**2 - 2772*D1**2*b2*fd**2*r*s + 1386*D1**2*b2*fd**2*r - 2142*D1**2*b2*fd**2*s**2 + 2142*D1**2*b2*fd**2*s + 42*D1**2*bd1**2*(3*f**2*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + f*(r**2*(50*C + 3*K + 12) + r*(42*C*(2*s - 1) + 58*K*s - 3*K + 14*s - 88) + s**2*(34*C + 55*K + 2) - s*(34*C + 29*K + 83) + 68) - 70*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 189*D1**2*bd2*f**2*r**2 + 1386*D1**2*bd2*f**2*r*s - 378*D1**2*bd2*f**2*r + 1197*D1**2*bd2*f**2*s**2 - 1386*D1**2*bd2*f**2*s + 189*D1**2*bd2*f**2 - 1260*D1**2*bd2*f*fd*r**2 - 5544*D1**2*bd2*f*fd*r*s + 2646*D1**2*bd2*f*fd*r - 4284*D1**2*bd2*f*fd*s**2 + 4914*D1**2*bd2*f*fd*s - 1386*D1**2*bd2*f*fd + 1071*D1**2*bdd1*f**2*r**2 + 900*D1**2*bdd1*f**2*r*s - 2016*D1**2*bdd1*f**2*r - 171*D1**2*bdd1*f**2*s**2 - 1800*D1**2*bdd1*f**2*s + 900*D1**2*bdd1*f**2 - 126*D1**2*bdd1*f*g2*r**2 - 2436*D1**2*bdd1*f*g2*r*s - 2310*D1**2*bdd1*f*g2*s**2 - 315*D1**2*bdd2*f**2*r**2 - 1386*D1**2*bdd2*f**2*r*s + 630*D1**2*bdd2*f**2*r - 1071*D1**2*bdd2*f**2*s**2 + 1386*D1**2*bdd2*f**2*s - 315*D1**2*bdd2*f**2 - 375*D1**2*f**2*fd*r**2 - 2940*D1**2*f**2*fd*r*s + 1230*D1**2*f**2*fd*r - 2565*D1**2*f**2*fd*s**2 + 2690*D1**2*f**2*fd*s - 980*D1**2*f**2*fd + 795*D1**2*f**2*fdd*r**2 + 3090*D1**2*f**2*fdd*r*s - 1560*D1**2*f**2*fdd*r + 2295*D1**2*f**2*fdd*s**2 - 2560*D1**2*f**2*fdd*s + 1030*D1**2*f**2*fdd - 378*D1**2*f**2*gd2*r**2 - 2772*D1**2*f**2*gd2*r*s + 756*D1**2*f**2*gd2*r - 2394*D1**2*f**2*gd2*s**2 + 2772*D1**2*f**2*gd2*s - 378*D1**2*f**2*gd2 + 630*D1**2*f**2*gdd2*r**2 + 2772*D1**2*f**2*gdd2*r*s - 1260*D1**2*f**2*gdd2*r + 2142*D1**2*f**2*gdd2*s**2 - 2772*D1**2*f**2*gdd2*s + 630*D1**2*f**2*gdd2 + 1590*D1**2*f*fd**2*r**2 + 6180*D1**2*f*fd**2*r*s - 3120*D1**2*f*fd**2*r + 4590*D1**2*f*fd**2*s**2 - 5120*D1**2*f*fd**2*s + 1030*D1**2*f*fd**2 - 756*D1**2*f*fd*g2*r**2 - 5544*D1**2*f*fd*g2*r*s + 2772*D1**2*f*fd*g2*r - 4788*D1**2*f*fd*g2*s**2 + 4788*D1**2*f*fd*g2*s - 2394*D1**2*f*fd*g2 + 2520*D1**2*f*fd*gd2*r**2 + 11088*D1**2*f*fd*gd2*r*s - 5292*D1**2*f*fd*gd2*r + 8568*D1**2*f*fd*gd2*s**2 - 9828*D1**2*f*fd*gd2*s + 2772*D1**2*f*fd*gd2 + 1260*D1**2*f*fdd*g2*r**2 + 5544*D1**2*f*fdd*g2*r*s - 2772*D1**2*f*fdd*g2*r + 4284*D1**2*f*fdd*g2*s**2 - 4284*D1**2*f*fdd*g2*s + 2142*D1**2*f*fdd*g2 + 1260*D1**2*fd**2*g2*r**2 + 5544*D1**2*fd**2*g2*r*s - 2772*D1**2*fd**2*g2*r + 4284*D1**2*fd**2*g2*s**2 - 4284*D1**2*fd**2*g2*s + 756*D1*Dd*b2*f**2*r**2 + 5544*D1*Dd*b2*f**2*r*s - 2142*D1*Dd*b2*f**2*r + 4788*D1*Dd*b2*f**2*s**2 - 5166*D1*Dd*b2*f**2*s + 1575*D1*Dd*b2*f**2 - 5040*D1*Dd*b2*f*fd*r**2 - 22176*D1*Dd*b2*f*fd*r*s + 10836*D1*Dd*b2*f*fd*r - 17136*D1*Dd*b2*f*fd*s**2 + 18396*D1*Dd*b2*f*fd*s - 4914*D1*Dd*b2*f*fd - 2520*D1*Dd*bd2*f**2*r**2 - 11088*D1*Dd*bd2*f**2*r*s + 5166*D1*Dd*bd2*f**2*r - 8568*D1*Dd*bd2*f**2*s**2 + 10458*D1*Dd*bd2*f**2*s - 2646*D1*Dd*bd2*f**2 - 500*D1*Dd*f**3*r**2 - 3920*D1*Dd*f**3*r*s + 1480*D1*Dd*f**3*r - 3420*D1*Dd*f**3*s**2 + 3670*D1*Dd*f**3*s - 1105*D1*Dd*f**3 + 6360*D1*Dd*f**2*fd*r**2 + 24720*D1*Dd*f**2*fd*r*s - 12510*D1*Dd*f**2*fd*r + 18360*D1*Dd*f**2*fd*s**2 - 21010*D1*Dd*f**2*fd*s + 5680*D1*Dd*f**2*fd - 1512*D1*Dd*f**2*g2*r**2 - 11088*D1*Dd*f**2*g2*r*s + 4284*D1*Dd*f**2*g2*r - 9576*D1*Dd*f**2*g2*s**2 + 10332*D1*Dd*f**2*g2*s - 3150*D1*Dd*f**2*g2 + 5040*D1*Dd*f**2*gd2*r**2 + 22176*D1*Dd*f**2*gd2*r*s - 10332*D1*Dd*f**2*gd2*r + 17136*D1*Dd*f**2*gd2*s**2 - 20916*D1*Dd*f**2*gd2*s + 5292*D1*Dd*f**2*gd2 + 10080*D1*Dd*f*fd*g2*r**2 + 44352*D1*Dd*f*fd*g2*r*s - 21672*D1*Dd*f*fd*g2*r + 34272*D1*Dd*f*fd*g2*s**2 - 36792*D1*Dd*f*fd*g2*s + 9828*D1*Dd*f*fd*g2 - 1260*D1*Ddd*b2*f**2*r**2 - 5544*D1*Ddd*b2*f**2*r*s + 2646*D1*Ddd*b2*f**2*r - 4284*D1*Ddd*b2*f**2*s**2 + 4914*D1*Ddd*b2*f**2*s - 1701*D1*Ddd*b2*f**2 + 1060*D1*Ddd*f**3*r**2 + 4120*D1*Ddd*f**3*r*s - 2090*D1*Ddd*f**3*r + 3060*D1*Ddd*f**3*s**2 - 3590*D1*Ddd*f**3*s + 1295*D1*Ddd*f**3 + 2520*D1*Ddd*f**2*g2*r**2 + 11088*D1*Ddd*f**2*g2*r*s - 5292*D1*Ddd*f**2*g2*r + 8568*D1*Ddd*f**2*g2*s**2 - 9828*D1*Ddd*f**2*g2*s + 3402*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(3*f**2*(-142*C*s**2 + 7*K*(3*r**2 + r*(22*s - 6) + 19*s**2 - 22*s + 3) - r**2*(6*C + 105) - 2*r*(74*C*s + 58*s - 105) - 11*s**2 + 218*s - 102) + f*(42*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 6*fd*(-324*C*s**2 + 248*C*s + 7*K*(10*r**2 + r*(44*s - 21) + 34*s**2 - 39*s + 11) - r**2*(20*C + 238) + r*(-344*C*s + 96*C - 200*s + 281) + 38*s**2 + 131*s - 112) - 28*gd2*(3*r**2 + r*(58*s - 3) + s*(55*s - 29)) - 7*(r + s)*(b2*(r + s) - 2*g2*(r + 45*s))) + 14*fd*(3*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(3*r**2 + 29*r*(2*s - 1) + s*(55*s - 55)))) - 2*Dd*f*(-21*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f*(-648*C*s**2 + 334*C*s + 7*K*(20*r**2 + r*(88*s - 41) + 68*s**2 - 83*s + 21) - r**2*(40*C + 476) + r*(-688*C*s + 106*C - 400*s + 736) + 76*s**2 + 481*s - 324) + 14*g2*(12*r**2 + r*(232*s - 35) + s*(220*s - 113)))) - 3780*Dd**2*b2*f**2*r**2 - 16632*Dd**2*b2*f**2*r*s + 7938*Dd**2*b2*f**2*r - 12852*Dd**2*b2*f**2*s**2 + 14742*Dd**2*b2*f**2*s - 3402*Dd**2*b2*f**2 + 3180*Dd**2*f**3*r**2 + 12360*Dd**2*f**3*r*s - 6270*Dd**2*f**3*r + 9180*Dd**2*f**3*s**2 - 10770*Dd**2*f**3*s + 2590*Dd**2*f**3 + 7560*Dd**2*f**2*g2*r**2 + 33264*Dd**2*f**2*g2*r*s - 15876*Dd**2*f**2*g2*r + 25704*Dd**2*f**2*g2*s**2 - 29484*Dd**2*f**2*g2*s + 6804*Dd**2*f**2*g2 + 21*b1**3*(2*D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(5*K*(28*r**2 + 8*r*s - 30*r - 20*s**2 + 6*s + 9) + 2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 180*r**2 - 120*r*s + 210*r + 60*s**2 + 30*s - 75) - Ddd*(-35*K + 6*f + 45)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-35*K + 6*f + 45)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 21*b1**2*(-30*C*D1**2*fd*r**2 - 68*C*D1**2*fd*r*s + 60*C*D1**2*fd*r - 38*C*D1**2*fd*s**2 + 68*C*D1**2*fd*s - 30*C*D1**2*fd + 50*C*D1**2*fdd*r**2 + 84*C*D1**2*fdd*r*s - 100*C*D1**2*fdd*r + 34*C*D1**2*fdd*s**2 - 84*C*D1**2*fdd*s + 50*C*D1**2*fdd - 120*C*D1*Dd*f*r**2 - 272*C*D1*Dd*f*r*s + 188*C*D1*Dd*f*r - 152*C*D1*Dd*f*s**2 + 212*C*D1*Dd*f*s - 98*C*D1*Dd*f + 400*C*D1*Dd*fd*r**2 + 672*C*D1*Dd*fd*r*s - 684*C*D1*Dd*fd*r + 272*C*D1*Dd*fd*s**2 - 572*C*D1*Dd*fd*s + 284*C*D1*Dd*fd + 200*C*D1*Ddd*f*r**2 + 336*C*D1*Ddd*f*r*s - 284*C*D1*Ddd*f*r + 136*C*D1*Ddd*f*s**2 - 236*C*D1*Ddd*f*s + 134*C*D1*Ddd*f + 600*C*Dd**2*f*r**2 + 1008*C*Dd**2*f*r*s - 852*C*Dd**2*f*r + 408*C*Dd**2*f*s**2 - 708*C*Dd**2*f*s + 268*C*Dd**2*f - D1**2*K*fd*r**2 - 46*D1**2*K*fd*r*s + 46*D1**2*K*fd*r - 45*D1**2*K*fd*s**2 + 90*D1**2*K*fd*s - 45*D1**2*K*fd + 3*D1**2*K*fdd*r**2 + 58*D1**2*K*fdd*r*s - 58*D1**2*K*fdd*r + 55*D1**2*K*fdd*s**2 - 110*D1**2*K*fdd*s + 55*D1**2*K*fdd - D1**2*bdd1*(-35*K + 6*f + 45)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 108*D1**2*f*fd*r**2 - 192*D1**2*f*fd*r*s + 114*D1**2*f*fd*r - 84*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 42*D1**2*f*fd + 132*D1**2*f*fdd*r**2 + 192*D1**2*f*fdd*r*s - 150*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 - 78*D1**2*f*fdd*s + 66*D1**2*f*fdd + 132*D1**2*fd**2*r**2 + 192*D1**2*fd**2*r*s - 150*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 78*D1**2*fd**2*s + 18*D1**2*fd**2 - 14*D1**2*fd*r**2 - 28*D1**2*fd*r*s - 86*D1**2*fd*r - 14*D1**2*fd*s**2 - 116*D1**2*fd*s + 54*D1**2*fd + 12*D1**2*fdd*r**2 + 14*D1**2*fdd*r*s + 138*D1**2*fdd*r + 2*D1**2*fdd*s**2 + 148*D1**2*fdd*s - 82*D1**2*fdd - 70*D1**2*gd2*r**2 - 20*D1**2*gd2*r*s + 140*D1**2*gd2*r + 50*D1**2*gd2*s**2 + 20*D1**2*gd2*s - 70*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 - 4*D1*Dd*K*f*r**2 - 184*D1*Dd*K*f*r*s + 50*D1*Dd*K*f*r - 180*D1*Dd*K*f*s**2 + 182*D1*Dd*K*f*s - 47*D1*Dd*K*f + 24*D1*Dd*K*fd*r**2 + 464*D1*Dd*K*fd*r*s - 302*D1*Dd*K*fd*r + 440*D1*Dd*K*fd*s**2 - 666*D1*Dd*K*fd*s + 226*D1*Dd*K*fd - 216*D1*Dd*f**2*r**2 - 384*D1*Dd*f**2*r*s + 312*D1*Dd*f**2*r - 168*D1*Dd*f**2*s**2 + 276*D1*Dd*f**2*s - 150*D1*Dd*f**2 + 1056*D1*Dd*f*fd*r**2 + 1536*D1*Dd*f*fd*r*s - 1320*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 816*D1*Dd*f*fd*s + 378*D1*Dd*f*fd - 56*D1*Dd*f*r**2 - 112*D1*Dd*f*r*s + 84*D1*Dd*f*r - 56*D1*Dd*f*s**2 + 84*D1*Dd*f*s - 42*D1*Dd*f + 96*D1*Dd*fd*r**2 + 112*D1*Dd*fd*r*s + 490*D1*Dd*fd*r + 16*D1*Dd*fd*s**2 + 560*D1*Dd*fd*s - 424*D1*Dd*fd - 280*D1*Dd*g2*r**2 - 80*D1*Dd*g2*r*s + 300*D1*Dd*g2*r + 200*D1*Dd*g2*s**2 - 60*D1*Dd*g2*s - 90*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 + 12*D1*Ddd*K*f*r**2 + 232*D1*Ddd*K*f*r*s - 70*D1*Ddd*K*f*r + 220*D1*Ddd*K*f*s**2 - 226*D1*Ddd*K*f*s + 61*D1*Ddd*K*f + 264*D1*Ddd*f**2*r**2 + 384*D1*Ddd*f**2*r*s - 360*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 252*D1*Ddd*f**2*s + 162*D1*Ddd*f**2 + 48*D1*Ddd*f*r**2 + 56*D1*Ddd*f*r*s - 62*D1*Ddd*f*r + 8*D1*Ddd*f*s**2 - 32*D1*Ddd*f*s + 26*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 + D1*bd1*(D1*(5*K*(21*r**2 + 6*r*s - 16*r - 15*s**2 + 8*s + 2) + 2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 135*r**2 - 90*r*s + 120*r + 45*s**2 - 30) - 2*Dd*(-35*K + 6*f + 45)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 36*Dd**2*K*f*r**2 + 696*Dd**2*K*f*r*s - 210*Dd**2*K*f*r + 660*Dd**2*K*f*s**2 - 678*Dd**2*K*f*s + 122*Dd**2*K*f + 792*Dd**2*f**2*r**2 + 1152*Dd**2*f**2*r*s - 1080*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 756*Dd**2*f**2*s + 324*Dd**2*f**2 + 144*Dd**2*f*r**2 + 168*Dd**2*f*r*s - 186*Dd**2*f*r + 24*Dd**2*f*s**2 - 96*Dd**2*f*s + 52*Dd**2*f - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) - 3*b1*(-700*C*D1**2*bdd1*f*r**2 - 1176*C*D1**2*bdd1*f*r*s + 588*C*D1**2*bdd1*f*r - 476*C*D1**2*bdd1*f*s**2 + 476*C*D1**2*bdd1*f*s - 238*C*D1**2*bdd1*f + 36*C*D1**2*f*fd*r**2 + 888*C*D1**2*f*fd*r*s - 480*C*D1**2*f*fd*r + 852*C*D1**2*f*fd*s**2 - 1296*C*D1**2*f*fd*s + 444*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r**2 - 1032*C*D1**2*f*fdd*r*s + 576*C*D1**2*f*fdd*r - 972*C*D1**2*f*fdd*s**2 + 1488*C*D1**2*f*fdd*s - 516*C*D1**2*f*fdd - 60*C*D1**2*fd**2*r**2 - 1032*C*D1**2*fd**2*r*s + 576*C*D1**2*fd**2*r - 972*C*D1**2*fd**2*s**2 + 1488*C*D1**2*fd**2*s - 516*C*D1**2*fd**2 + 72*C*D1*Dd*f**2*r**2 + 1776*C*D1*Dd*f**2*r*s - 516*C*D1*Dd*f**2*r + 1704*C*D1*Dd*f**2*s**2 - 1740*C*D1*Dd*f**2*s + 462*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r**2 - 8256*C*D1*Dd*f*fd*r*s + 3576*C*D1*Dd*f*fd*r - 7776*C*D1*Dd*f*fd*s**2 + 9960*C*D1*Dd*f*fd*s - 2640*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r**2 - 2064*C*D1*Ddd*f**2*r*s + 636*C*D1*Ddd*f**2*r - 1944*C*D1*Ddd*f**2*s**2 + 2004*C*D1*Ddd*f**2*s - 546*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r**2 - 6192*C*Dd**2*f**2*r*s + 1908*C*Dd**2*f**2*r - 5832*C*Dd**2*f**2*s**2 + 6012*C*Dd**2*f**2*s - 1092*C*Dd**2*f**2 - 42*D1**2*K*bdd1*f*r**2 - 812*D1**2*K*bdd1*f*r*s + 42*D1**2*K*bdd1*f*r - 770*D1**2*K*bdd1*f*s**2 + 406*D1**2*K*bdd1*f*s - 21*D1**2*K*bdd1*f - 126*D1**2*K*f*fd*r**2 - 924*D1**2*K*f*fd*r*s + 462*D1**2*K*f*fd*r - 798*D1**2*K*f*fd*s**2 + 798*D1**2*K*f*fd*s - 399*D1**2*K*f*fd + 210*D1**2*K*f*fdd*r**2 + 924*D1**2*K*f*fdd*r*s - 462*D1**2*K*f*fdd*r + 714*D1**2*K*f*fdd*s**2 - 714*D1**2*K*f*fdd*s + 357*D1**2*K*f*fdd + 210*D1**2*K*fd**2*r**2 + 924*D1**2*K*fd**2*r*s - 462*D1**2*K*fd**2*r + 714*D1**2*K*fd**2*s**2 - 714*D1**2*K*fd**2*s + 7*D1**2*b2*fd*r**2 + 14*D1**2*b2*fd*r*s - 14*D1**2*b2*fd*r + 7*D1**2*b2*fd*s**2 - 14*D1**2*b2*fd*s + 7*D1**2*b2*fd - 21*D1**2*b2*fdd*r**2 - 42*D1**2*b2*fdd*r*s + 42*D1**2*b2*fdd*r - 21*D1**2*b2*fdd*s**2 + 42*D1**2*b2*fdd*s - 21*D1**2*b2*fdd + 14*D1**2*bd1**2*(-35*K + 6*f + 45)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 924*D1**2*bdd1*f**2*r**2 - 1344*D1**2*bdd1*f**2*r*s + 1470*D1**2*bdd1*f**2*r - 420*D1**2*bdd1*f**2*s**2 + 1218*D1**2*bdd1*f**2*s - 672*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*r**2 - 196*D1**2*bdd1*f*r*s + 1232*D1**2*bdd1*f*r - 28*D1**2*bdd1*f*s**2 + 1162*D1**2*bdd1*f*s - 672*D1**2*bdd1*f + 980*D1**2*bdd1*g2*r**2 + 1960*D1**2*bdd1*g2*r*s - 980*D1**2*bdd1*g2*r + 980*D1**2*bdd1*g2*s**2 - 980*D1**2*bdd1*g2*s + 490*D1**2*bdd1*g2 - 21*D1**2*bdd2*f*r**2 - 42*D1**2*bdd2*f*r*s + 42*D1**2*bdd2*f*r - 21*D1**2*bdd2*f*s**2 + 42*D1**2*bdd2*f*s - 21*D1**2*bdd2*f + 630*D1**2*f*fd*r**2 + 696*D1**2*f*fd*r*s - 348*D1**2*f*fd*r + 66*D1**2*f*fd*s**2 + 240*D1**2*f*fd*s + 42*D1**2*f*fd - 714*D1**2*f*fdd*r**2 - 600*D1**2*f*fdd*r*s + 342*D1**2*f*fdd*r + 114*D1**2*f*fdd*s**2 - 414*D1**2*f*fdd*s - 14*D1**2*f*gd2*r**2 - 644*D1**2*f*gd2*r*s + 28*D1**2*f*gd2*r - 630*D1**2*f*gd2*s**2 + 644*D1**2*f*gd2*s - 14*D1**2*f*gd2 + 42*D1**2*f*gdd2*r**2 + 812*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*r + 770*D1**2*f*gdd2*s**2 - 812*D1**2*f*gdd2*s + 42*D1**2*f*gdd2 - 714*D1**2*fd**2*r**2 - 600*D1**2*fd**2*r*s + 342*D1**2*fd**2*r + 114*D1**2*fd**2*s**2 - 414*D1**2*fd**2*s + 372*D1**2*fd**2 - 14*D1**2*fd*g2*r**2 - 644*D1**2*fd*g2*r*s + 644*D1**2*fd*g2*r - 630*D1**2*fd*g2*s**2 + 1260*D1**2*fd*g2*s - 630*D1**2*fd*g2 + 84*D1**2*fd*gd2*r**2 + 1624*D1**2*fd*gd2*r*s - 896*D1**2*fd*gd2*r + 1540*D1**2*fd*gd2*s**2 - 2352*D1**2*fd*gd2*s + 812*D1**2*fd*gd2 + 42*D1**2*fdd*g2*r**2 + 812*D1**2*fdd*g2*r*s - 812*D1**2*fdd*g2*r + 770*D1**2*fdd*g2*s**2 - 1540*D1**2*fdd*g2*s + 770*D1**2*fdd*g2 - 252*D1*Dd*K*f**2*r**2 - 1848*D1*Dd*K*f**2*r*s + 714*D1*Dd*K*f**2*r - 1596*D1*Dd*K*f**2*s**2 + 1722*D1*Dd*K*f**2*s - 525*D1*Dd*K*f**2 + 1680*D1*Dd*K*f*fd*r**2 + 7392*D1*Dd*K*f*fd*r*s - 3612*D1*Dd*K*f*fd*r + 5712*D1*Dd*K*f*fd*s**2 - 6132*D1*Dd*K*f*fd*s + 1638*D1*Dd*K*f*fd + 28*D1*Dd*b2*f*r**2 + 56*D1*Dd*b2*f*r*s - 42*D1*Dd*b2*f*r + 28*D1*Dd*b2*f*s**2 - 42*D1*Dd*b2*f*s + 21*D1*Dd*b2*f - 168*D1*Dd*b2*fd*r**2 - 336*D1*Dd*b2*fd*r*s + 294*D1*Dd*b2*fd*r - 168*D1*Dd*b2*fd*s**2 + 294*D1*Dd*b2*fd*s - 126*D1*Dd*b2*fd + 1260*D1*Dd*f**2*r**2 + 1392*D1*Dd*f**2*r*s - 1608*D1*Dd*f**2*r + 132*D1*Dd*f**2*s**2 - 762*D1*Dd*f**2*s + 663*D1*Dd*f**2 - 5712*D1*Dd*f*fd*r**2 - 4800*D1*Dd*f*fd*r*s + 4824*D1*Dd*f*fd*r + 912*D1*Dd*f*fd*s**2 - 684*D1*Dd*f*fd*s - 270*D1*Dd*f*fd - 56*D1*Dd*f*g2*r**2 - 2576*D1*Dd*f*g2*r*s + 700*D1*Dd*f*g2*r - 2520*D1*Dd*f*g2*s**2 + 2548*D1*Dd*f*g2*s - 658*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 + 6496*D1*Dd*f*gd2*r*s - 1316*D1*Dd*f*gd2*r + 6160*D1*Dd*f*gd2*s**2 - 6412*D1*Dd*f*gd2*s + 980*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r**2 + 6496*D1*Dd*fd*g2*r*s - 4228*D1*Dd*fd*g2*r + 6160*D1*Dd*fd*g2*s**2 - 9324*D1*Dd*fd*g2*s + 3164*D1*Dd*fd*g2 + 420*D1*Ddd*K*f**2*r**2 + 1848*D1*Ddd*K*f**2*r*s - 882*D1*Ddd*K*f**2*r + 1428*D1*Ddd*K*f**2*s**2 - 1638*D1*Ddd*K*f**2*s + 567*D1*Ddd*K*f**2 - 84*D1*Ddd*b2*f*r**2 - 168*D1*Ddd*b2*f*r*s + 126*D1*Ddd*b2*f*r - 84*D1*Ddd*b2*f*s**2 + 126*D1*Ddd*b2*f*s - 63*D1*Ddd*b2*f - 1428*D1*Ddd*f**2*r**2 - 1200*D1*Ddd*f**2*r*s + 1728*D1*Ddd*f**2*r + 228*D1*Ddd*f**2*s**2 + 486*D1*Ddd*f**2*s - 657*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*r**2 + 3248*D1*Ddd*f*g2*r*s - 980*D1*Ddd*f*g2*r + 3080*D1*Ddd*f*g2*s**2 - 3164*D1*Ddd*f*g2*s + 854*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(6*f**2*(18*r**2 + r*(32*s - 33) + 14*s**2 - 35*s + 18) + f*(2*C*(30*r**2 + 68*r*s - 34*r + 38*s**2 - 38*s + 19) + 2*K*r**2 + 92*K*r*s - 2*K*r + 90*K*s**2 - 46*K*s + K - 6*fd*(88*r**2 + 8*r*(16*s - 15) + 40*s**2 - 84*s + 35) + 28*r**2 + 56*r*s - 142*r + 28*s**2 - 172*s + 82) - 2*fd*(2*C*(50*r**2 + r*(84*s - 71) + 34*s**2 - 59*s + 21) + K*(6*r**2 + 116*r*s - 61*r + 110*s**2 - 139*s + 29) + 24*r**2 + 28*r*s + 50*r + 4*s**2 + 65*s - 61) + 10*g2*(14*r**2 + 4*r*s - 2*r - 10*s**2 + 10*s - 5) + 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(3*f**2*(176*r**2 + 4*r*(64*s - 65) + 80*s**2 - 200*s + 99) + f*(2*C*(200*r**2 + r*(336*s - 226) + 136*s**2 - 186*s + 59) + K*(24*r**2 + 464*r*s - 82*r + 440*s**2 - 342*s + 35) + 96*r**2 + 112*r*s - 414*r + 16*s**2 - 364*s + 259) - 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 7*D1*bd2*(D1*(f - 6*fd)*(r + s - 1) - 6*Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 1260*Dd**2*K*f**2*r**2 + 5544*Dd**2*K*f**2*r*s - 2646*Dd**2*K*f**2*r + 4284*Dd**2*K*f**2*s**2 - 4914*Dd**2*K*f**2*s + 1134*Dd**2*K*f**2 - 252*Dd**2*b2*f*r**2 - 504*Dd**2*b2*f*r*s + 378*Dd**2*b2*f*r - 252*Dd**2*b2*f*s**2 + 378*Dd**2*b2*f*s - 126*Dd**2*b2*f - 4284*Dd**2*f**2*r**2 - 3600*Dd**2*f**2*r*s + 5184*Dd**2*f**2*r + 684*Dd**2*f**2*s**2 + 1458*Dd**2*f**2*s - 1314*Dd**2*f**2 + 504*Dd**2*f*g2*r**2 + 9744*Dd**2*f*g2*r*s - 2940*Dd**2*f*g2*r + 9240*Dd**2*f*g2*s**2 - 9492*Dd**2*f*g2*s + 1708*Dd**2*f*g2))/(630*d**2*k3**3) + 4*D1**2*Pk2*Pkd3*ct**2*k1**2*st**2*(-D1*f*(3*D1*bd1**2*s*(6*f + 7)*(2*r + 2*s - 1) + D1*bd1*(-11*f*s*(r + s) + 9*fd*(r*(4*s - 1) + s*(4*s - 3))) + 9*D1*bdd1*f*s*(r + s) + 9*Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + b1**2*(-D1**2*(r + s - 1)*(18*fd**2*(2*s - 1) + fd*(f*(15 - 30*s) - 7*s + 7) + 3*fdd*(12*f*s - 6*f + 7*s - 7)) + D1*(Dd*(15*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-18*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 7*r*(4*s - 1) + 7*(1 - 2*s)**2) - 21*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*Ddd*f*(6*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(6*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(18*bdd1*f**2*s*(2*r + 2*s - 1) + f*(21*bdd1*s*(2*r + 2*s - 1) - 11*fd*(2*s - 1)*(r + s - 1) + 9*fdd*(2*s - 1)*(r + s - 1)) + 9*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(f*s*(15*f + 7)*(2*r + 2*s - 1) - 3*fd*(6*f*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + 28*r*s - 14*r + 28*s**2 - 35*s + 7)) - 3*Dd*f*(6*f + 7)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2**2*k3) + D1**2*Pk2*Pkd3*ct**2*k1**2*(D1*f*(7*D1*bd1**2*(2*r*(9*f*s + 7*s + 3) + s*(18*f*s - 9*f + 14*s - 1)) + 57*D1*bdd1*f*s*(r + s) + 3*bd1*(D1*(-17*f*s*(r + s) + 19*fd*(r*(4*s - 1) + s*(4*s - 3))) + 19*Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 14*b1**3*(D1**2*s*(fd - 3*fdd)*(r + s - 1) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 5*r*(4*s - 1) - 5*(1 - 2*s)**2) - D1*Ddd*(3*f + 5)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(3*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(-2*D1**2*bdd1*(3*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 18*D1**2*f*fd*r*s + 9*D1**2*f*fd*r - 18*D1**2*f*fd*s**2 + 27*D1**2*f*fd*s - 9*D1**2*f*fd + 18*D1**2*f*fdd*r*s - 9*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 27*D1**2*f*fdd*s + 9*D1**2*f*fdd + 18*D1**2*fd**2*r*s - 9*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 27*D1**2*fd**2*s + 9*D1**2*fd**2 - 9*D1**2*fd*r*s + 11*D1**2*fd*r - 9*D1**2*fd*s**2 + 20*D1**2*fd*s - 11*D1**2*fd + 7*D1**2*fdd*r*s - 13*D1**2*fdd*r + 7*D1**2*fdd*s**2 - 20*D1**2*fdd*s + 13*D1**2*fdd - 36*D1*Dd*f**2*r*s + 9*D1*Dd*f**2*r - 36*D1*Dd*f**2*s**2 + 36*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 144*D1*Dd*f*fd*r*s - 54*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 180*D1*Dd*f*fd*s + 45*D1*Dd*f*fd - 36*D1*Dd*f*r*s + 9*D1*Dd*f*r - 36*D1*Dd*f*s**2 + 36*D1*Dd*f*s - 9*D1*Dd*f + 56*D1*Dd*fd*r*s - 59*D1*Dd*fd*r + 56*D1*Dd*fd*s**2 - 108*D1*Dd*fd*s + 46*D1*Dd*fd + 36*D1*Ddd*f**2*r*s - 9*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 28*D1*Ddd*f*r*s - 7*D1*Ddd*f*r + 28*D1*Ddd*f*s**2 - 28*D1*Ddd*f*s + 7*D1*Ddd*f + 2*D1*bd1*(D1*(f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) - 15*r*s + 5*r - 15*s**2 + 15*s - 5) - Dd*(3*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 108*Dd**2*f**2*r*s - 27*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 18*Dd**2*f**2 + 84*Dd**2*f*r*s - 21*Dd**2*f*r + 84*Dd**2*f*s**2 - 84*Dd**2*f*s + 14*Dd**2*f) + b1*(-14*D1**2*bd1**2*(3*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 7*D1**2*bdd1*f*(2*r*(s*(9*f + 7) + 3) + s**2*(18*f + 14) - s*(9*f + 1) - 6) - 3*D1**2*(2*s - 1)*(r + s - 1)*(17*f*fd - 19*f*fdd - 19*fd**2) - 7*D1*bd1*(D1*(9*f**2*s*(2*r + 2*s - 1) + f*(-9*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + 18*r*s + 2*r + 18*s**2 - 7*s - 2) + fd*(-4*r*(7*s - 5) - 28*s**2 + 41*s - 7)) - Dd*f*(9*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 2*r*(56*s + 5) + 112*s**2 - 60*s - 11)) - 3*D1*f*(Dd*(17*f*(r*(4*s - 1) + (1 - 2*s)**2) - 19*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 19*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 57*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2**2*k3) + 9*D1**2*Pk2*Pkd3*ct**2*k2**6*st**4*(D1**2*(f**2*(fd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-3*K*(-2*bd1 + bdd1) - 12*gd2 + 6*gdd2)) + f*(-fd**2*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 6*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 6*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(3*K*(b1*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - fd*(2*C - 1)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 6*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(3*K*b1 + f*(2*C - 1) - 6*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(3*K*b1 + f*(2*C - 1) - 6*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(14*d**2*k3**7) + 9*D1**2*Pk2*Pkd3*ct**2*k2**6*st**2*(24*C*D1**2*b1*f*fd*r**2 + 48*C*D1**2*b1*f*fd*r*s - 24*C*D1**2*b1*f*fd*r + 24*C*D1**2*b1*f*fd*s**2 - 24*C*D1**2*b1*f*fd*s + 12*C*D1**2*b1*f*fd - 12*C*D1**2*b1*f*fdd*r**2 - 24*C*D1**2*b1*f*fdd*r*s + 12*C*D1**2*b1*f*fdd*r - 12*C*D1**2*b1*f*fdd*s**2 + 12*C*D1**2*b1*f*fdd*s - 6*C*D1**2*b1*f*fdd - 12*C*D1**2*b1*fd**2*r**2 - 24*C*D1**2*b1*fd**2*r*s + 12*C*D1**2*b1*fd**2*r - 12*C*D1**2*b1*fd**2*s**2 + 12*C*D1**2*b1*fd**2*s - 18*C*D1**2*f**2*fd*r**2 - 36*C*D1**2*f**2*fd*r*s + 24*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 12*C*D1**2*f**2*fd + 48*C*D1*Dd*b1*f**2*r**2 + 96*C*D1*Dd*b1*f**2*r*s - 72*C*D1*Dd*b1*f**2*r + 48*C*D1*Dd*b1*f**2*s**2 - 72*C*D1*Dd*b1*f**2*s + 36*C*D1*Dd*b1*f**2 - 96*C*D1*Dd*b1*f*fd*r**2 - 192*C*D1*Dd*b1*f*fd*r*s + 120*C*D1*Dd*b1*f*fd*r - 96*C*D1*Dd*b1*f*fd*s**2 + 120*C*D1*Dd*b1*f*fd*s - 36*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r**2 - 48*C*D1*Dd*f**3*r*s + 36*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 36*C*D1*Dd*f**3*s - 18*C*D1*Dd*f**3 - 24*C*D1*Ddd*b1*f**2*r**2 - 48*C*D1*Ddd*b1*f**2*r*s + 36*C*D1*Ddd*b1*f**2*r - 24*C*D1*Ddd*b1*f**2*s**2 + 36*C*D1*Ddd*b1*f**2*s - 18*C*D1*Ddd*b1*f**2 - 72*C*Dd**2*b1*f**2*r**2 - 144*C*Dd**2*b1*f**2*r*s + 108*C*Dd**2*b1*f**2*r - 72*C*Dd**2*b1*f**2*s**2 + 108*C*Dd**2*b1*f**2*s - 36*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r**2 + 28*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r**2 - 14*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 14*D1**2*K*bd1**2*f*(r + s - 1)**2 - 12*D1**2*b1*f*fd*r**2 - 24*D1**2*b1*f*fd*r*s + 12*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s**2 + 12*D1**2*b1*f*fd*s - 6*D1**2*b1*f*fd + 6*D1**2*b1*f*fdd*r**2 + 12*D1**2*b1*f*fdd*r*s - 6*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 - 6*D1**2*b1*f*fdd*s + 3*D1**2*b1*f*fdd - 28*D1**2*b1*f*gd2*r**2 - 56*D1**2*b1*f*gd2*r*s + 56*D1**2*b1*f*gd2*r - 28*D1**2*b1*f*gd2*s**2 + 56*D1**2*b1*f*gd2*s - 28*D1**2*b1*f*gd2 + 14*D1**2*b1*f*gdd2*r**2 + 28*D1**2*b1*f*gdd2*r*s - 28*D1**2*b1*f*gdd2*r + 14*D1**2*b1*f*gdd2*s**2 - 28*D1**2*b1*f*gdd2*s + 14*D1**2*b1*f*gdd2 + 6*D1**2*b1*fd**2*r**2 + 12*D1**2*b1*fd**2*r*s - 6*D1**2*b1*fd**2*r + 6*D1**2*b1*fd**2*s**2 - 6*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r**2 - 56*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r**2 + 56*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*r + 28*D1**2*b1*fd*gd2*s**2 - 28*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r**2 + 28*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(6*C*f + 14*K*b1 - 3*f - 14*g2) + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r**2 + 112*D1*Dd*K*b1**2*f*r*s - 84*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 84*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r**2 - 112*D1*Dd*K*b1**2*fd*r*s + 42*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 42*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 - 24*D1*Dd*b1*f**2*r**2 - 48*D1*Dd*b1*f**2*r*s + 36*D1*Dd*b1*f**2*r - 24*D1*Dd*b1*f**2*s**2 + 36*D1*Dd*b1*f**2*s - 18*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 96*D1*Dd*b1*f*fd*r*s - 60*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 60*D1*Dd*b1*f*fd*s + 18*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r**2 - 224*D1*Dd*b1*f*g2*r*s + 168*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 168*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r**2 + 224*D1*Dd*b1*f*gd2*r*s - 196*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 196*D1*Dd*b1*f*gd2*s + 84*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r**2 + 224*D1*Dd*b1*fd*g2*r*s - 84*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 84*D1*Dd*b1*fd*g2*s + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r**2 - 56*D1*Ddd*K*b1**2*f*r*s + 42*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 42*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 12*D1*Ddd*b1*f**2*r**2 + 24*D1*Ddd*b1*f**2*r*s - 18*D1*Ddd*b1*f**2*r + 12*D1*Ddd*b1*f**2*s**2 - 18*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r**2 + 112*D1*Ddd*b1*f*g2*r*s - 84*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 84*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(12*C - 7*K - 6)*(r + s - 1) - f*fd*(12*C - 6)*(2*r + 2*s - 1) - 28*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(6*C*f + 14*K*b1 - 3*f - 14*g2))*(r + s - 1) - 84*Dd**2*K*b1**2*f*r**2 - 168*Dd**2*K*b1**2*f*r*s + 126*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 126*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 36*Dd**2*b1*f**2*r**2 + 72*Dd**2*b1*f**2*r*s - 54*Dd**2*b1*f**2*r + 36*Dd**2*b1*f**2*s**2 - 54*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r**2 + 336*Dd**2*b1*f*g2*r*s - 252*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 252*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(35*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**2*k2**4*st**4*(-2004*C*D1**2*f**2*fd*r**2 - 2904*C*D1**2*f**2*fd*r*s + 2304*C*D1**2*f**2*fd*r - 900*C*D1**2*f**2*fd*s**2 + 1568*C*D1**2*f**2*fd*s - 968*C*D1**2*f**2*fd + 1290*C*D1**2*f**2*fdd*r**2 + 1740*C*D1**2*f**2*fdd*r*s - 1440*C*D1**2*f**2*fdd*r + 450*C*D1**2*f**2*fdd*s**2 - 880*C*D1**2*f**2*fdd*s + 580*C*D1**2*f**2*fdd + 2580*C*D1**2*f*fd**2*r**2 + 3480*C*D1**2*f*fd**2*r*s - 2880*C*D1**2*f*fd**2*r + 900*C*D1**2*f*fd**2*s**2 - 1760*C*D1**2*f*fd**2*s + 580*C*D1**2*f*fd**2 - 2672*C*D1*Dd*f**3*r**2 - 3872*C*D1*Dd*f**3*r*s + 3640*C*D1*Dd*f**3*r - 1200*C*D1*Dd*f**3*s**2 + 2536*C*D1*Dd*f**3*s - 1636*C*D1*Dd*f**3 + 10320*C*D1*Dd*f**2*fd*r**2 + 13920*C*D1*Dd*f**2*fd*r*s - 12660*C*D1*Dd*f**2*fd*r + 3600*C*D1*Dd*f**2*fd*s**2 - 7900*C*D1*Dd*f**2*fd*s + 3760*C*D1*Dd*f**2*fd + 1720*C*D1*Ddd*f**3*r**2 + 2320*C*D1*Ddd*f**3*r*s - 2300*C*D1*Ddd*f**3*r + 600*C*D1*Ddd*f**3*s**2 - 1460*C*D1*Ddd*f**3*s + 1010*C*D1*Ddd*f**3 + 5160*C*Dd**2*f**3*r**2 + 6960*C*Dd**2*f**3*r*s - 6900*C*Dd**2*f**3*r + 1800*C*Dd**2*f**3*s**2 - 4380*C*Dd**2*f**3*s + 2020*C*Dd**2*f**3 - 1620*D1**2*K*b1*f*fd*r**2 - 2520*D1**2*K*b1*f*fd*r*s + 1260*D1**2*K*b1*f*fd*r - 900*D1**2*K*b1*f*fd*s**2 + 900*D1**2*K*b1*f*fd*s - 450*D1**2*K*b1*f*fd + 810*D1**2*K*b1*f*fdd*r**2 + 1260*D1**2*K*b1*f*fdd*r*s - 630*D1**2*K*b1*f*fdd*r + 450*D1**2*K*b1*f*fdd*s**2 - 450*D1**2*K*b1*f*fdd*s + 225*D1**2*K*b1*f*fdd + 810*D1**2*K*b1*fd**2*r**2 + 1260*D1**2*K*b1*fd**2*r*s - 630*D1**2*K*b1*fd**2*r + 450*D1**2*K*b1*fd**2*s**2 - 450*D1**2*K*b1*fd**2*s + 405*D1**2*K*bdd1*f**2*r**2 + 630*D1**2*K*bdd1*f**2*r*s - 810*D1**2*K*bdd1*f**2*r + 225*D1**2*K*bdd1*f**2*s**2 - 630*D1**2*K*bdd1*f**2*s + 405*D1**2*K*bdd1*f**2 + 270*D1**2*b1*f**2*fd*r**2 + 270*D1**2*b1*f**2*fd*r*s - 270*D1**2*b1*f**2*fd*r - 90*D1**2*b1*f**2*fd*s + 90*D1**2*b1*f**2*fd - 270*D1**2*b1*f**2*fdd*r**2 - 270*D1**2*b1*f**2*fdd*r*s + 270*D1**2*b1*f**2*fdd*r + 90*D1**2*b1*f**2*fdd*s - 90*D1**2*b1*f**2*fdd - 540*D1**2*b1*f*fd**2*r**2 - 540*D1**2*b1*f*fd**2*r*s + 540*D1**2*b1*f*fd**2*r + 180*D1**2*b1*f*fd**2*s - 90*D1**2*b1*f*fd**2 + 360*D1**2*b1*f*fd*r**2 + 360*D1**2*b1*f*fd*r*s - 180*D1**2*b1*f*fd*r - 180*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 180*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 900*D1**2*b2*f*fd*r**2 - 1800*D1**2*b2*f*fd*r*s + 900*D1**2*b2*f*fd*r - 900*D1**2*b2*f*fd*s**2 + 900*D1**2*b2*f*fd*s - 450*D1**2*b2*f*fd + 450*D1**2*b2*f*fdd*r**2 + 900*D1**2*b2*f*fdd*r*s - 450*D1**2*b2*f*fdd*r + 450*D1**2*b2*f*fdd*s**2 - 450*D1**2*b2*f*fdd*s + 225*D1**2*b2*f*fdd + 450*D1**2*b2*fd**2*r**2 + 900*D1**2*b2*fd**2*r*s - 450*D1**2*b2*fd**2*r + 450*D1**2*b2*fd**2*s**2 - 450*D1**2*b2*fd**2*s - 90*D1**2*bdd1*f**3*r**2 - 90*D1**2*bdd1*f**3*r*s + 180*D1**2*bdd1*f**3*r + 90*D1**2*bdd1*f**3*s - 90*D1**2*bdd1*f**3 - 90*D1**2*bdd1*f**2*r**2 - 90*D1**2*bdd1*f**2*r*s + 180*D1**2*bdd1*f**2*r + 90*D1**2*bdd1*f**2*s - 90*D1**2*bdd1*f**2 + 225*D1**2*bdd2*f**2*r**2 + 450*D1**2*bdd2*f**2*r*s - 450*D1**2*bdd2*f**2*r + 225*D1**2*bdd2*f**2*s**2 - 450*D1**2*bdd2*f**2*s + 225*D1**2*bdd2*f**2 + 1278*D1**2*f**2*fd*r**2 + 1728*D1**2*f**2*fd*r*s - 1428*D1**2*f**2*fd*r + 450*D1**2*f**2*fd*s**2 - 876*D1**2*f**2*fd*s + 576*D1**2*f**2*fd - 855*D1**2*f**2*fdd*r**2 - 1080*D1**2*f**2*fdd*r*s + 930*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 510*D1**2*f**2*fdd*s - 360*D1**2*f**2*fdd + 1620*D1**2*f**2*gd2*r**2 + 2520*D1**2*f**2*gd2*r*s - 3240*D1**2*f**2*gd2*r + 900*D1**2*f**2*gd2*s**2 - 2520*D1**2*f**2*gd2*s + 1620*D1**2*f**2*gd2 - 810*D1**2*f**2*gdd2*r**2 - 1260*D1**2*f**2*gdd2*r*s + 1620*D1**2*f**2*gdd2*r - 450*D1**2*f**2*gdd2*s**2 + 1260*D1**2*f**2*gdd2*s - 810*D1**2*f**2*gdd2 - 1710*D1**2*f*fd**2*r**2 - 2160*D1**2*f*fd**2*r*s + 1860*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 1020*D1**2*f*fd**2*s - 360*D1**2*f*fd**2 + 3240*D1**2*f*fd*g2*r**2 + 5040*D1**2*f*fd*g2*r*s - 2520*D1**2*f*fd*g2*r + 1800*D1**2*f*fd*g2*s**2 - 1800*D1**2*f*fd*g2*s + 900*D1**2*f*fd*g2 - 3240*D1**2*f*fd*gd2*r**2 - 5040*D1**2*f*fd*gd2*r*s + 4500*D1**2*f*fd*gd2*r - 1800*D1**2*f*fd*gd2*s**2 + 3420*D1**2*f*fd*gd2*s - 1260*D1**2*f*fd*gd2 - 1620*D1**2*f*fdd*g2*r**2 - 2520*D1**2*f*fdd*g2*r*s + 1260*D1**2*f*fdd*g2*r - 900*D1**2*f*fdd*g2*s**2 + 900*D1**2*f*fdd*g2*s - 450*D1**2*f*fdd*g2 - 1620*D1**2*fd**2*g2*r**2 - 2520*D1**2*fd**2*g2*r*s + 1260*D1**2*fd**2*g2*r - 900*D1**2*fd**2*g2*s**2 + 900*D1**2*fd**2*g2*s - 3240*D1*Dd*K*b1*f**2*r**2 - 5040*D1*Dd*K*b1*f**2*r*s + 4500*D1*Dd*K*b1*f**2*r - 1800*D1*Dd*K*b1*f**2*s**2 + 3420*D1*Dd*K*b1*f**2*s - 2070*D1*Dd*K*b1*f**2 + 6480*D1*Dd*K*b1*f*fd*r**2 + 10080*D1*Dd*K*b1*f*fd*r*s - 7020*D1*Dd*K*b1*f*fd*r + 3600*D1*Dd*K*b1*f*fd*s**2 - 5220*D1*Dd*K*b1*f*fd*s + 1710*D1*Dd*K*b1*f*fd + 360*D1*Dd*b1*f**3*r**2 + 360*D1*Dd*b1*f**3*r*s - 450*D1*Dd*b1*f**3*r - 180*D1*Dd*b1*f**3*s + 180*D1*Dd*b1*f**3 - 2160*D1*Dd*b1*f**2*fd*r**2 - 2160*D1*Dd*b1*f**2*fd*r*s + 2430*D1*Dd*b1*f**2*fd*r + 900*D1*Dd*b1*f**2*fd*s - 630*D1*Dd*b1*f**2*fd + 720*D1*Dd*b1*f**2*r**2 + 720*D1*Dd*b1*f**2*r*s - 900*D1*Dd*b1*f**2*r - 360*D1*Dd*b1*f**2*s + 360*D1*Dd*b1*f**2 - 1440*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 1260*D1*Dd*b1*f*fd*r + 360*D1*Dd*b1*f*fd*s - 180*D1*Dd*b1*f*fd - 1800*D1*Dd*b2*f**2*r**2 - 3600*D1*Dd*b2*f**2*r*s + 2700*D1*Dd*b2*f**2*r - 1800*D1*Dd*b2*f**2*s**2 + 2700*D1*Dd*b2*f**2*s - 1350*D1*Dd*b2*f**2 + 3600*D1*Dd*b2*f*fd*r**2 + 7200*D1*Dd*b2*f*fd*r*s - 4500*D1*Dd*b2*f*fd*r + 3600*D1*Dd*b2*f*fd*s**2 - 4500*D1*Dd*b2*f*fd*s + 1350*D1*Dd*b2*f*fd + 1704*D1*Dd*f**3*r**2 + 2304*D1*Dd*f**3*r*s - 2280*D1*Dd*f**3*r + 600*D1*Dd*f**3*s**2 - 1452*D1*Dd*f**3*s + 1002*D1*Dd*f**3 - 6840*D1*Dd*f**2*fd*r**2 - 8640*D1*Dd*f**2*fd*r*s + 8220*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 4650*D1*Dd*f**2*fd*s - 2370*D1*Dd*f**2*fd + 6480*D1*Dd*f**2*g2*r**2 + 10080*D1*Dd*f**2*g2*r*s - 9000*D1*Dd*f**2*g2*r + 3600*D1*Dd*f**2*g2*s**2 - 6840*D1*Dd*f**2*g2*s + 4140*D1*Dd*f**2*g2 - 6480*D1*Dd*f**2*gd2*r**2 - 10080*D1*Dd*f**2*gd2*r*s + 10980*D1*Dd*f**2*gd2*r - 3600*D1*Dd*f**2*gd2*s**2 + 8460*D1*Dd*f**2*gd2*s - 4500*D1*Dd*f**2*gd2 - 12960*D1*Dd*f*fd*g2*r**2 - 20160*D1*Dd*f*fd*g2*r*s + 14040*D1*Dd*f*fd*g2*r - 7200*D1*Dd*f*fd*g2*s**2 + 10440*D1*Dd*f*fd*g2*s - 3420*D1*Dd*f*fd*g2 + 1620*D1*Ddd*K*b1*f**2*r**2 + 2520*D1*Ddd*K*b1*f**2*r*s - 2250*D1*Ddd*K*b1*f**2*r + 900*D1*Ddd*K*b1*f**2*s**2 - 1710*D1*Ddd*K*b1*f**2*s + 1035*D1*Ddd*K*b1*f**2 - 360*D1*Ddd*b1*f**3*r**2 - 360*D1*Ddd*b1*f**3*r*s + 450*D1*Ddd*b1*f**3*r + 180*D1*Ddd*b1*f**3*s - 180*D1*Ddd*b1*f**3 - 360*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 450*D1*Ddd*b1*f**2*r + 180*D1*Ddd*b1*f**2*s - 180*D1*Ddd*b1*f**2 + 900*D1*Ddd*b2*f**2*r**2 + 1800*D1*Ddd*b2*f**2*r*s - 1350*D1*Ddd*b2*f**2*r + 900*D1*Ddd*b2*f**2*s**2 - 1350*D1*Ddd*b2*f**2*s + 675*D1*Ddd*b2*f**2 - 1140*D1*Ddd*f**3*r**2 - 1440*D1*Ddd*f**3*r*s + 1500*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 870*D1*Ddd*f**3*s - 645*D1*Ddd*f**3 - 3240*D1*Ddd*f**2*g2*r**2 - 5040*D1*Ddd*f**2*g2*r*s + 4500*D1*Ddd*f**2*g2*r - 1800*D1*Ddd*f**2*g2*s**2 + 3420*D1*Ddd*f**2*g2*s - 2070*D1*Ddd*f**2*g2 + 90*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (r + s - 1)*(K*(9*r + 5*s - 9) - 2*r + 2)) + fd*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(K*(36*r**2 + 56*r*s - 61*r + 20*s**2 - 47*s + 25) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) - 450*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 4860*Dd**2*K*b1*f**2*r**2 + 7560*Dd**2*K*b1*f**2*r*s - 6750*Dd**2*K*b1*f**2*r + 2700*Dd**2*K*b1*f**2*s**2 - 5130*Dd**2*K*b1*f**2*s + 2070*Dd**2*K*b1*f**2 - 1080*Dd**2*b1*f**3*r**2 - 1080*Dd**2*b1*f**3*r*s + 1350*Dd**2*b1*f**3*r + 540*Dd**2*b1*f**3*s - 360*Dd**2*b1*f**3 - 1080*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 1350*Dd**2*b1*f**2*r + 540*Dd**2*b1*f**2*s - 360*Dd**2*b1*f**2 + 2700*Dd**2*b2*f**2*r**2 + 5400*Dd**2*b2*f**2*r*s - 4050*Dd**2*b2*f**2*r + 2700*Dd**2*b2*f**2*s**2 - 4050*Dd**2*b2*f**2*s + 1350*Dd**2*b2*f**2 - 3420*Dd**2*f**3*r**2 - 4320*Dd**2*f**3*r*s + 4500*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 2610*Dd**2*f**3*s - 1290*Dd**2*f**3 - 9720*Dd**2*f**2*g2*r**2 - 15120*Dd**2*f**2*g2*r*s + 13500*Dd**2*f**2*g2*r - 5400*Dd**2*f**2*g2*s**2 + 10260*Dd**2*f**2*g2*s - 4140*Dd**2*f**2*g2)/(210*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**2*k2**4*st**2*(-224*C*D1**2*bd1*f**2*r**2 - 368*C*D1**2*bd1*f**2*r*s + 728*C*D1**2*bd1*f**2*r - 144*C*D1**2*bd1*f**2*s**2 + 648*C*D1**2*bd1*f**2*s - 324*C*D1**2*bd1*f**2 + 672*C*D1**2*bd1*f*fd*r**2 + 960*C*D1**2*bd1*f*fd*r*s - 996*C*D1**2*bd1*f*fd*r + 288*C*D1**2*bd1*f*fd*s**2 - 708*C*D1**2*bd1*f*fd*s + 420*C*D1**2*bd1*f*fd + 168*C*D1**2*bdd1*f**2*r**2 + 240*C*D1**2*bdd1*f**2*r*s - 420*C*D1**2*bdd1*f**2*r + 72*C*D1**2*bdd1*f**2*s**2 - 324*C*D1**2*bdd1*f**2*s + 162*C*D1**2*bdd1*f**2 - 36*C*D1**2*f**2*fd*r**2 - 144*C*D1**2*f**2*fd*r*s + 72*C*D1**2*f**2*fd*r - 108*C*D1**2*f**2*fd*s**2 + 120*C*D1**2*f**2*fd*s - 48*C*D1**2*f**2*fd + 558*C*D1**2*f**2*fdd*r**2 + 1044*C*D1**2*f**2*fdd*r*s - 720*C*D1**2*f**2*fdd*r + 486*C*D1**2*f**2*fdd*s**2 - 672*C*D1**2*f**2*fdd*s + 348*C*D1**2*f**2*fdd + 1116*C*D1**2*f*fd**2*r**2 + 2088*C*D1**2*f*fd**2*r*s - 1440*C*D1**2*f*fd**2*r + 972*C*D1**2*f*fd**2*s**2 - 1344*C*D1**2*f*fd**2*s + 348*C*D1**2*f*fd**2 + 1344*C*D1*Dd*bd1*f**2*r**2 + 1920*C*D1*Dd*bd1*f**2*r*s - 2592*C*D1*Dd*bd1*f**2*r + 576*C*D1*Dd*bd1*f**2*s**2 - 1920*C*D1*Dd*bd1*f**2*s + 1164*C*D1*Dd*bd1*f**2 - 48*C*D1*Dd*f**3*r**2 - 192*C*D1*Dd*f**3*r*s + 96*C*D1*Dd*f**3*r - 144*C*D1*Dd*f**3*s**2 + 168*C*D1*Dd*f**3*s - 60*C*D1*Dd*f**3 + 4464*C*D1*Dd*f**2*fd*r**2 + 8352*C*D1*Dd*f**2*fd*r*s - 6156*C*D1*Dd*f**2*fd*r + 3888*C*D1*Dd*f**2*fd*s**2 - 5748*C*D1*Dd*f**2*fd*s + 2112*C*D1*Dd*f**2*fd + 744*C*D1*Ddd*f**3*r**2 + 1392*C*D1*Ddd*f**3*r*s - 1092*C*D1*Ddd*f**3*r + 648*C*D1*Ddd*f**3*s**2 - 1020*C*D1*Ddd*f**3*s + 534*C*D1*Ddd*f**3 + 2232*C*Dd**2*f**3*r**2 + 4176*C*Dd**2*f**3*r*s - 3276*C*Dd**2*f**3*r + 1944*C*Dd**2*f**3*s**2 - 3060*C*Dd**2*f**3*s + 1068*C*Dd**2*f**3 + 168*D1**2*K*bd1**2*f*r**2 + 336*D1**2*K*bd1**2*f*r*s - 546*D1**2*K*bd1**2*f*r + 168*D1**2*K*bd1**2*f*s**2 - 546*D1**2*K*bd1**2*f*s + 378*D1**2*K*bd1**2*f + 126*D1**2*K*bd1*f**2*r**2 + 84*D1**2*K*bd1*f**2*r*s - 252*D1**2*K*bd1*f**2*r - 42*D1**2*K*bd1*f**2*s**2 - 84*D1**2*K*bd1*f**2*s + 126*D1**2*K*bd1*f**2 + 420*D1**2*K*bd1*f*fd*r**2 + 1176*D1**2*K*bd1*f*fd*r*s - 714*D1**2*K*bd1*f*fd*r + 756*D1**2*K*bd1*f*fd*s**2 - 966*D1**2*K*bd1*f*fd*s + 294*D1**2*K*bd1*f*fd + 105*D1**2*K*bdd1*f**2*r**2 + 294*D1**2*K*bdd1*f**2*r*s - 210*D1**2*K*bdd1*f**2*r + 189*D1**2*K*bdd1*f**2*s**2 - 294*D1**2*K*bdd1*f**2*s + 105*D1**2*K*bdd1*f**2 - 84*D1**2*bd1**2*f**2*r**2 - 84*D1**2*bd1**2*f**2*r*s + 126*D1**2*bd1**2*f**2*r + 42*D1**2*bd1**2*f**2*s - 42*D1**2*bd1**2*f**2 - 84*D1**2*bd1**2*f*r**2 - 84*D1**2*bd1**2*f*r*s + 126*D1**2*bd1**2*f*r + 42*D1**2*bd1**2*f*s - 42*D1**2*bd1**2*f + 210*D1**2*bd1*bd2*f*r**2 + 420*D1**2*bd1*bd2*f*r*s - 420*D1**2*bd1*bd2*f*r + 210*D1**2*bd1*bd2*f*s**2 - 420*D1**2*bd1*bd2*f*s + 210*D1**2*bd1*bd2*f + 126*D1**2*bd1*f**2*r**2 + 198*D1**2*bd1*f**2*r*s - 336*D1**2*bd1*f**2*r + 72*D1**2*bd1*f**2*s**2 - 282*D1**2*bd1*f**2*s + 120*D1**2*bd1*f**2 - 504*D1**2*bd1*f*fd*r**2 - 648*D1**2*bd1*f*fd*r*s + 666*D1**2*bd1*f*fd*r - 144*D1**2*bd1*f*fd*s**2 + 396*D1**2*bd1*f*fd*s - 252*D1**2*bd1*f*fd + 336*D1**2*bd1*f*g2*r**2 + 672*D1**2*bd1*f*g2*r*s - 1512*D1**2*bd1*f*g2*r + 336*D1**2*bd1*f*g2*s**2 - 1512*D1**2*bd1*f*g2*s + 756*D1**2*bd1*f*g2 - 336*D1**2*bd1*f*gd2*r**2 - 672*D1**2*bd1*f*gd2*r*s + 1092*D1**2*bd1*f*gd2*r - 336*D1**2*bd1*f*gd2*s**2 + 1092*D1**2*bd1*f*gd2*s - 756*D1**2*bd1*f*gd2 - 336*D1**2*bd1*fd*g2*r**2 - 672*D1**2*bd1*fd*g2*r*s + 336*D1**2*bd1*fd*g2*r - 336*D1**2*bd1*fd*g2*s**2 + 336*D1**2*bd1*fd*g2*s + 105*D1**2*bd2*f**2*r**2 + 210*D1**2*bd2*f**2*r*s - 210*D1**2*bd2*f**2*r + 105*D1**2*bd2*f**2*s**2 - 210*D1**2*bd2*f**2*s + 105*D1**2*bd2*f**2 - 126*D1**2*bdd1*f**2*r**2 - 162*D1**2*bdd1*f**2*r*s + 252*D1**2*bdd1*f**2*r - 36*D1**2*bdd1*f**2*s**2 + 162*D1**2*bdd1*f**2*s - 81*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r**2 - 336*D1**2*bdd1*f*g2*r*s + 756*D1**2*bdd1*f*g2*r - 168*D1**2*bdd1*f*g2*s**2 + 756*D1**2*bdd1*f*g2*s - 378*D1**2*bdd1*f*g2 - 36*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s + 18*D1**2*f**2*fd*r + 54*D1**2*f**2*fd*s**2 - 42*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 279*D1**2*f**2*fdd*r**2 - 522*D1**2*f**2*fdd*r*s + 360*D1**2*f**2*fdd*r - 243*D1**2*f**2*fdd*s**2 + 336*D1**2*f**2*fdd*s - 174*D1**2*f**2*fdd - 252*D1**2*f**2*gd2*r**2 - 168*D1**2*f**2*gd2*r*s + 504*D1**2*f**2*gd2*r + 84*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s - 252*D1**2*f**2*gd2 - 210*D1**2*f**2*gdd2*r**2 - 588*D1**2*f**2*gdd2*r*s + 420*D1**2*f**2*gdd2*r - 378*D1**2*f**2*gdd2*s**2 + 588*D1**2*f**2*gdd2*s - 210*D1**2*f**2*gdd2 - 558*D1**2*f*fd**2*r**2 - 1044*D1**2*f*fd**2*r*s + 720*D1**2*f*fd**2*r - 486*D1**2*f*fd**2*s**2 + 672*D1**2*f*fd**2*s - 174*D1**2*f*fd**2 - 504*D1**2*f*fd*g2*r**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r + 168*D1**2*f*fd*g2*s**2 - 168*D1**2*f*fd*g2*s + 84*D1**2*f*fd*g2 - 840*D1**2*f*fd*gd2*r**2 - 2352*D1**2*f*fd*gd2*r*s + 1428*D1**2*f*fd*gd2*r - 1512*D1**2*f*fd*gd2*s**2 + 1932*D1**2*f*fd*gd2*s - 588*D1**2*f*fd*gd2 - 420*D1**2*f*fdd*g2*r**2 - 1176*D1**2*f*fdd*g2*r*s + 588*D1**2*f*fdd*g2*r - 756*D1**2*f*fdd*g2*s**2 + 756*D1**2*f*fdd*g2*s - 378*D1**2*f*fdd*g2 - 420*D1**2*fd**2*g2*r**2 - 1176*D1**2*fd**2*g2*r*s + 588*D1**2*fd**2*g2*r - 756*D1**2*fd**2*g2*s**2 + 756*D1**2*fd**2*g2*s + 840*D1*Dd*K*bd1*f**2*r**2 + 2352*D1*Dd*K*bd1*f**2*r*s - 1554*D1*Dd*K*bd1*f**2*r + 1512*D1*Dd*K*bd1*f**2*s**2 - 2142*D1*Dd*K*bd1*f**2*s + 714*D1*Dd*K*bd1*f**2 - 1008*D1*Dd*bd1*f**2*r**2 - 1296*D1*Dd*bd1*f**2*r*s + 1674*D1*Dd*bd1*f**2*r - 288*D1*Dd*bd1*f**2*s**2 + 1044*D1*Dd*bd1*f**2*s - 666*D1*Dd*bd1*f**2 - 1344*D1*Dd*bd1*f*g2*r**2 - 2688*D1*Dd*bd1*f*g2*r*s + 4032*D1*Dd*bd1*f*g2*r - 1344*D1*Dd*bd1*f*g2*s**2 + 4032*D1*Dd*bd1*f*g2*s - 2268*D1*Dd*bd1*f*g2 - 48*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s + 42*D1*Dd*f**3*r + 72*D1*Dd*f**3*s**2 - 48*D1*Dd*f**3*s - 6*D1*Dd*f**3 - 2232*D1*Dd*f**2*fd*r**2 - 4176*D1*Dd*f**2*fd*r*s + 3078*D1*Dd*f**2*fd*r - 1944*D1*Dd*f**2*fd*s**2 + 2874*D1*Dd*f**2*fd*s - 1056*D1*Dd*f**2*fd - 1008*D1*Dd*f**2*g2*r**2 - 672*D1*Dd*f**2*g2*r*s + 1176*D1*Dd*f**2*g2*r + 336*D1*Dd*f**2*g2*s**2 + 168*D1*Dd*f**2*g2*s - 420*D1*Dd*f**2*g2 - 1680*D1*Dd*f**2*gd2*r**2 - 4704*D1*Dd*f**2*gd2*r*s + 3108*D1*Dd*f**2*gd2*r - 3024*D1*Dd*f**2*gd2*s**2 + 4284*D1*Dd*f**2*gd2*s - 1428*D1*Dd*f**2*gd2 - 3360*D1*Dd*f*fd*g2*r**2 - 9408*D1*Dd*f*fd*g2*r*s + 5208*D1*Dd*f*fd*g2*r - 6048*D1*Dd*f*fd*g2*s**2 + 6888*D1*Dd*f*fd*g2*s - 1932*D1*Dd*f*fd*g2 - 372*D1*Ddd*f**3*r**2 - 696*D1*Ddd*f**3*r*s + 546*D1*Ddd*f**3*r - 324*D1*Ddd*f**3*s**2 + 510*D1*Ddd*f**3*s - 267*D1*Ddd*f**3 - 840*D1*Ddd*f**2*g2*r**2 - 2352*D1*Ddd*f**2*g2*r*s + 1428*D1*Ddd*f**2*g2*r - 1512*D1*Ddd*f**2*g2*s**2 + 1932*D1*Ddd*f**2*g2*s - 798*D1*Ddd*f**2*g2 - 105*D1*b2*(2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 1116*Dd**2*f**3*r**2 - 2088*Dd**2*f**3*r*s + 1638*Dd**2*f**3*r - 972*Dd**2*f**3*s**2 + 1530*Dd**2*f**3*s - 534*Dd**2*f**3 - 2520*Dd**2*f**2*g2*r**2 - 7056*Dd**2*f**2*g2*r*s + 4284*Dd**2*f**2*g2*r - 4536*Dd**2*f**2*g2*s**2 + 5796*Dd**2*f**2*g2*s - 1596*Dd**2*f**2*g2 + 21*b1**2*(D1**2*(-2*K*fd*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-4*r**2 - 4*r*(s - 1) + 2*s) + 4*fd*r*(r + s) + fdd*(K*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) - 2*r*(r + s))) + 2*D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(K*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + 2*Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + b1*(-448*C*D1**2*f*fd*r**2 - 736*C*D1**2*f*fd*r*s + 88*C*D1**2*f*fd*r - 288*C*D1**2*f*fd*s**2 + 8*C*D1**2*f*fd*s - 44*C*D1**2*f*fd + 336*C*D1**2*f*fdd*r**2 + 480*C*D1**2*f*fdd*r*s - 156*C*D1**2*f*fdd*r + 144*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 78*C*D1**2*f*fdd + 336*C*D1**2*fd**2*r**2 + 480*C*D1**2*fd**2*r*s - 156*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s - 180*C*D1**2*fd**2 - 896*C*D1*Dd*f**2*r**2 - 1472*C*D1*Dd*f**2*r*s + 1264*C*D1*Dd*f**2*r - 576*C*D1*Dd*f**2*s**2 + 1024*C*D1*Dd*f**2*s - 592*C*D1*Dd*f**2 + 2688*C*D1*Dd*f*fd*r**2 + 3840*C*D1*Dd*f*fd*r*s - 2448*C*D1*Dd*f*fd*r + 1152*C*D1*Dd*f*fd*s**2 - 1488*C*D1*Dd*f*fd*s + 372*C*D1*Dd*f*fd + 672*C*D1*Ddd*f**2*r**2 + 960*C*D1*Ddd*f**2*r*s - 912*C*D1*Ddd*f**2*r + 288*C*D1*Ddd*f**2*s**2 - 624*C*D1*Ddd*f**2*s + 408*C*D1*Ddd*f**2 + 2016*C*Dd**2*f**2*r**2 + 2880*C*Dd**2*f**2*r*s - 2736*C*Dd**2*f**2*r + 864*C*Dd**2*f**2*s**2 - 1872*C*Dd**2*f**2*s + 816*C*Dd**2*f**2 + 168*D1**2*K*bdd1*f*r**2 + 336*D1**2*K*bdd1*f*r*s - 546*D1**2*K*bdd1*f*r + 168*D1**2*K*bdd1*f*s**2 - 546*D1**2*K*bdd1*f*s + 273*D1**2*K*bdd1*f + 252*D1**2*K*f*fd*r**2 + 168*D1**2*K*f*fd*r*s - 84*D1**2*K*f*fd*r - 84*D1**2*K*f*fd*s**2 + 84*D1**2*K*f*fd*s - 42*D1**2*K*f*fd + 210*D1**2*K*f*fdd*r**2 + 588*D1**2*K*f*fdd*r*s - 294*D1**2*K*f*fdd*r + 378*D1**2*K*f*fdd*s**2 - 378*D1**2*K*f*fdd*s + 189*D1**2*K*f*fdd + 210*D1**2*K*fd**2*r**2 + 588*D1**2*K*fd**2*r*s - 294*D1**2*K*fd**2*r + 378*D1**2*K*fd**2*s**2 - 378*D1**2*K*fd**2*s - 210*D1**2*b2*fd*r**2 - 420*D1**2*b2*fd*r*s - 210*D1**2*b2*fd*s**2 + 105*D1**2*b2*fdd*r**2 + 210*D1**2*b2*fdd*r*s + 105*D1**2*b2*fdd*s**2 - 84*D1**2*bdd1*f**2*r**2 - 84*D1**2*bdd1*f**2*r*s + 126*D1**2*bdd1*f**2*r + 42*D1**2*bdd1*f**2*s - 42*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*r**2 - 84*D1**2*bdd1*f*r*s + 126*D1**2*bdd1*f*r + 42*D1**2*bdd1*f*s - 42*D1**2*bdd1*f + 105*D1**2*bdd2*f*r**2 + 210*D1**2*bdd2*f*r*s - 210*D1**2*bdd2*f*r + 105*D1**2*bdd2*f*s**2 - 210*D1**2*bdd2*f*s + 105*D1**2*bdd2*f + 252*D1**2*f*fd*r**2 + 396*D1**2*f*fd*r*s - 114*D1**2*f*fd*r + 144*D1**2*f*fd*s**2 - 60*D1**2*f*fd*s + 78*D1**2*f*fd - 252*D1**2*f*fdd*r**2 - 324*D1**2*f*fdd*r*s + 162*D1**2*f*fdd*r - 72*D1**2*f*fdd*s**2 + 72*D1**2*f*fdd*s - 81*D1**2*f*fdd + 336*D1**2*f*gd2*r**2 + 672*D1**2*f*gd2*r*s - 672*D1**2*f*gd2*r + 336*D1**2*f*gd2*s**2 - 672*D1**2*f*gd2*s + 336*D1**2*f*gd2 - 168*D1**2*f*gdd2*r**2 - 336*D1**2*f*gdd2*r*s + 336*D1**2*f*gdd2*r - 168*D1**2*f*gdd2*s**2 + 336*D1**2*f*gdd2*s - 168*D1**2*f*gdd2 - 252*D1**2*fd**2*r**2 - 324*D1**2*fd**2*r*s + 162*D1**2*fd**2*r - 72*D1**2*fd**2*s**2 + 72*D1**2*fd**2*s + 90*D1**2*fd**2 + 336*D1**2*fd*g2*r**2 + 672*D1**2*fd*g2*r*s + 840*D1**2*fd*g2*r + 336*D1**2*fd*g2*s**2 + 840*D1**2*fd*g2*s - 420*D1**2*fd*g2 - 336*D1**2*fd*gd2*r**2 - 672*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s**2 - 84*D1**2*fd*gd2*s + 420*D1**2*fd*gd2 - 168*D1**2*fdd*g2*r**2 - 336*D1**2*fdd*g2*r*s - 420*D1**2*fdd*g2*r - 168*D1**2*fdd*g2*s**2 - 420*D1**2*fdd*g2*s + 210*D1**2*fdd*g2 + 504*D1*Dd*K*f**2*r**2 + 336*D1*Dd*K*f**2*r*s - 588*D1*Dd*K*f**2*r - 168*D1*Dd*K*f**2*s**2 - 84*D1*Dd*K*f**2*s + 210*D1*Dd*K*f**2 + 1680*D1*Dd*K*f*fd*r**2 + 4704*D1*Dd*K*f*fd*r*s - 2604*D1*Dd*K*f*fd*r + 3024*D1*Dd*K*f*fd*s**2 - 3444*D1*Dd*K*f*fd*s + 966*D1*Dd*K*f*fd - 840*D1*Dd*b2*f*r**2 - 1680*D1*Dd*b2*f*r*s + 1260*D1*Dd*b2*f*r - 840*D1*Dd*b2*f*s**2 + 1260*D1*Dd*b2*f*s - 630*D1*Dd*b2*f + 840*D1*Dd*b2*fd*r**2 + 1680*D1*Dd*b2*fd*r*s - 630*D1*Dd*b2*fd*r + 840*D1*Dd*b2*fd*s**2 - 630*D1*Dd*b2*fd*s + 504*D1*Dd*f**2*r**2 + 792*D1*Dd*f**2*r*s - 702*D1*Dd*f**2*r + 288*D1*Dd*f**2*s**2 - 540*D1*Dd*f**2*s + 324*D1*Dd*f**2 - 2016*D1*Dd*f*fd*r**2 - 2592*D1*Dd*f*fd*r*s + 1980*D1*Dd*f*fd*r - 576*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 396*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r**2 + 2688*D1*Dd*f*g2*r*s - 2016*D1*Dd*f*g2*r + 1344*D1*Dd*f*g2*s**2 - 2016*D1*Dd*f*g2*s + 1008*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r**2 - 2688*D1*Dd*f*gd2*r*s + 2352*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 2352*D1*Dd*f*gd2*s - 1008*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r**2 - 2688*D1*Dd*fd*g2*r*s - 672*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 - 672*D1*Dd*fd*g2*s + 1260*D1*Dd*fd*g2 + 420*D1*Ddd*K*f**2*r**2 + 1176*D1*Ddd*K*f**2*r*s - 714*D1*Ddd*K*f**2*r + 756*D1*Ddd*K*f**2*s**2 - 966*D1*Ddd*K*f**2*s + 399*D1*Ddd*K*f**2 + 420*D1*Ddd*b2*f*r**2 + 840*D1*Ddd*b2*f*r*s - 630*D1*Ddd*b2*f*r + 420*D1*Ddd*b2*f*s**2 - 630*D1*Ddd*b2*f*s + 315*D1*Ddd*b2*f - 504*D1*Ddd*f**2*r**2 - 648*D1*Ddd*f**2*r*s + 666*D1*Ddd*f**2*r - 144*D1*Ddd*f**2*s**2 + 396*D1*Ddd*f**2*s - 288*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 - 1344*D1*Ddd*f*g2*r*s + 1008*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 1008*D1*Ddd*f*g2*s - 504*D1*Ddd*f*g2 + 42*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(K*(8*r**2 + 16*r*s - 26*r + 8*s**2 - 26*s + 13) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(K*(8*r**2 + r*(16*s - 3) + 8*s**2 - 3*s - 5) - 4*r**2 + r*(3 - 4*s) + s)) + Dd*f*(K*(32*r**2 + 64*r*s - 76*r + 32*s**2 - 76*s + 39) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 210*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 1260*Dd**2*K*f**2*r**2 + 3528*Dd**2*K*f**2*r*s - 2142*Dd**2*K*f**2*r + 2268*Dd**2*K*f**2*s**2 - 2898*Dd**2*K*f**2*s + 798*Dd**2*K*f**2 + 1260*Dd**2*b2*f*r**2 + 2520*Dd**2*b2*f*r*s - 1890*Dd**2*b2*f*r + 1260*Dd**2*b2*f*s**2 - 1890*Dd**2*b2*f*s + 630*Dd**2*b2*f - 1512*Dd**2*f**2*r**2 - 1944*Dd**2*f**2*r*s + 1998*Dd**2*f**2*r - 432*Dd**2*f**2*s**2 + 1188*Dd**2*f**2*s - 576*Dd**2*f**2 - 2016*Dd**2*f*g2*r**2 - 4032*Dd**2*f*g2*r*s + 3024*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 3024*Dd**2*f*g2*s - 1008*Dd**2*f*g2))/(105*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**2*k2**4*(D1*(175*D1*b2*bd1*f*(r + s - 1)**2 + 70*D1*bd1**2*(r + s - 1)*(5*K*f*(r + s - 1) - f*(6*C - 3)*(r + s) + 10*g2*(r + s)) + D1*bdd1*f*(f*(6*C - 3)*(59*r + 35*s - 35) - 350*g2*(r + s - 1))*(r + s - 1) - bd1*(D1*(3*f**2*(2*C*(41*r**2 + r*(34*s + 36) - 7*s**2 + 84*s - 42) - 27*r**2 - 10*r*(2*s + 5) + 7*s**2 - 84*s + 42) - f*fd*(12*C - 6)*(118*r**2 + r*(188*s - 153) + 70*s**2 - 117*s + 47) + 70*f*(g2*(r**2 + 2*r*(s - 6) + s**2 - 12*s + 6) + 10*gd2*(r + s - 1)**2) + 700*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(-f*(6*C - 3)*(236*r**2 + r*(376*s - 353) + 140*s**2 - 269*s + 129) + 350*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 175*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 35*b1**2*(D1**2*(5*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(12*C*(r + s - 1)**2 + K*(r**2 + 2*r*(s + 5) + s**2 + 10*s - 5) - 8*r**2 - 2*r*(7*s - 6) - 6*(s - 1)**2) + fdd*(-6*C*(r + s - 1)**2 + 5*K*s**2 + r**2*(5*K + 3) + 2*r*(5*K*s + 3*s - 3) + 3*s**2 - 6*s + 3) - 20*gd2*(r + s - 1)**2 + 10*gdd2*(r + s - 1)**2) + D1*(Dd*(f*(12*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 32*r**2 - 56*r*s + 46*r - 24*s**2 + 40*s - 22) - 2*fd*(4*r + 4*s - 3)*(6*C*(r + s - 1) - 5*K*s - r*(5*K + 3) - 3*s + 3) - 20*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*(K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(20*r + 20*s - 15)) + Ddd*(f*(-6*C + 5*K + 3) + 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(-6*C + 5*K + 3) + 10*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - b1*(420*C*D1**2*bdd1*f*r**2 + 840*C*D1**2*bdd1*f*r*s - 420*C*D1**2*bdd1*f*r + 420*C*D1**2*bdd1*f*s**2 - 420*C*D1**2*bdd1*f*s + 210*C*D1**2*bdd1*f + 492*C*D1**2*f*fd*r**2 + 408*C*D1**2*f*fd*r*s - 912*C*D1**2*f*fd*r - 84*C*D1**2*f*fd*s**2 - 624*C*D1**2*f*fd*s + 456*C*D1**2*f*fd - 708*C*D1**2*f*fdd*r**2 - 1128*C*D1**2*f*fdd*r*s + 708*C*D1**2*f*fdd*r - 420*C*D1**2*f*fdd*s**2 + 564*C*D1**2*f*fdd*s - 354*C*D1**2*f*fdd - 708*C*D1**2*fd**2*r**2 - 1128*C*D1**2*fd**2*r*s + 708*C*D1**2*fd**2*r - 420*C*D1**2*fd**2*s**2 + 564*C*D1**2*fd**2*s + 984*C*D1*Dd*f**2*r**2 + 816*C*D1*Dd*f**2*r*s - 1188*C*D1*Dd*f**2*r - 168*C*D1*Dd*f**2*s**2 - 324*C*D1*Dd*f**2*s + 450*C*D1*Dd*f**2 - 5664*C*D1*Dd*f*fd*r**2 - 9024*C*D1*Dd*f*fd*r*s + 6792*C*D1*Dd*f*fd*r - 3360*C*D1*Dd*f*fd*s**2 + 5352*C*D1*Dd*f*fd*s - 1980*C*D1*Dd*f*fd - 1416*C*D1*Ddd*f**2*r**2 - 2256*C*D1*Ddd*f**2*r*s + 1980*C*D1*Ddd*f**2*r - 840*C*D1*Ddd*f**2*s**2 + 1548*C*D1*Ddd*f**2*s - 918*C*D1*Ddd*f**2 - 4248*C*Dd**2*f**2*r**2 - 6768*C*Dd**2*f**2*r*s + 5940*C*Dd**2*f**2*r - 2520*C*Dd**2*f**2*s**2 + 4644*C*Dd**2*f**2*s - 1836*C*Dd**2*f**2 + 350*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 350*D1**2*K*bdd1*f*r**2 - 700*D1**2*K*bdd1*f*r*s + 700*D1**2*K*bdd1*f*r - 350*D1**2*K*bdd1*f*s**2 + 700*D1**2*K*bdd1*f*s - 350*D1**2*K*bdd1*f - 175*D1**2*b2*fd*r**2 - 350*D1**2*b2*fd*r*s - 175*D1**2*b2*fd*s**2 - 175*D1**2*bd2*f*(r + s - 1)**2 - 210*D1**2*bdd1*f*r**2 - 420*D1**2*bdd1*f*r*s + 210*D1**2*bdd1*f*r - 210*D1**2*bdd1*f*s**2 + 210*D1**2*bdd1*f*s - 105*D1**2*bdd1*f - 700*D1**2*bdd1*g2*r**2 - 1400*D1**2*bdd1*g2*r*s + 700*D1**2*bdd1*g2*r - 700*D1**2*bdd1*g2*s**2 + 700*D1**2*bdd1*g2*s - 350*D1**2*bdd1*g2 - 162*D1**2*f*fd*r**2 - 120*D1**2*f*fd*r*s + 372*D1**2*f*fd*r + 42*D1**2*f*fd*s**2 + 270*D1**2*f*fd*s - 186*D1**2*f*fd + 354*D1**2*f*fdd*r**2 + 564*D1**2*f*fdd*r*s - 354*D1**2*f*fdd*r + 210*D1**2*f*fdd*s**2 - 282*D1**2*f*fdd*s + 177*D1**2*f*fdd + 70*D1**2*f*gd2*r**2 + 140*D1**2*f*gd2*r*s - 140*D1**2*f*gd2*r + 70*D1**2*f*gd2*s**2 - 140*D1**2*f*gd2*s + 70*D1**2*f*gd2 + 350*D1**2*f*gdd2*r**2 + 700*D1**2*f*gdd2*r*s - 700*D1**2*f*gdd2*r + 350*D1**2*f*gdd2*s**2 - 700*D1**2*f*gdd2*s + 350*D1**2*f*gdd2 + 354*D1**2*fd**2*r**2 + 564*D1**2*fd**2*r*s - 354*D1**2*fd**2*r + 210*D1**2*fd**2*s**2 - 282*D1**2*fd**2*s + 70*D1**2*fd*g2*r**2 + 140*D1**2*fd*g2*r*s + 700*D1**2*fd*g2*r + 70*D1**2*fd*g2*s**2 + 700*D1**2*fd*g2*s - 350*D1**2*fd*g2 + 700*D1**2*fd*gd2*r**2 + 1400*D1**2*fd*gd2*r*s - 700*D1**2*fd*gd2*r + 700*D1**2*fd*gd2*s**2 - 700*D1**2*fd*gd2*s + 350*D1**2*fdd*g2*r**2 + 700*D1**2*fdd*g2*r*s + 350*D1**2*fdd*g2*s**2 - 700*D1*Dd*b2*f*r**2 - 1400*D1*Dd*b2*f*r*s + 1050*D1*Dd*b2*f*r - 700*D1*Dd*b2*f*s**2 + 1050*D1*Dd*b2*f*s - 525*D1*Dd*b2*f - 324*D1*Dd*f**2*r**2 - 240*D1*Dd*f**2*r*s + 384*D1*Dd*f**2*r + 84*D1*Dd*f**2*s**2 + 78*D1*Dd*f**2*s - 141*D1*Dd*f**2 + 2832*D1*Dd*f*fd*r**2 + 4512*D1*Dd*f*fd*r*s - 3396*D1*Dd*f*fd*r + 1680*D1*Dd*f*fd*s**2 - 2676*D1*Dd*f*fd*s + 990*D1*Dd*f*fd + 280*D1*Dd*f*g2*r**2 + 560*D1*Dd*f*g2*r*s - 420*D1*Dd*f*g2*r + 280*D1*Dd*f*g2*s**2 - 420*D1*Dd*f*g2*s + 210*D1*Dd*f*g2 + 2800*D1*Dd*f*gd2*r**2 + 5600*D1*Dd*f*gd2*r*s - 4900*D1*Dd*f*gd2*r + 2800*D1*Dd*f*gd2*s**2 - 4900*D1*Dd*f*gd2*s + 2100*D1*Dd*f*gd2 + 2800*D1*Dd*fd*g2*r**2 + 5600*D1*Dd*fd*g2*r*s - 2100*D1*Dd*fd*g2*r + 2800*D1*Dd*fd*g2*s**2 - 2100*D1*Dd*fd*g2*s + 708*D1*Ddd*f**2*r**2 + 1128*D1*Ddd*f**2*r*s - 990*D1*Ddd*f**2*r + 420*D1*Ddd*f**2*s**2 - 774*D1*Ddd*f**2*s + 459*D1*Ddd*f**2 + 1400*D1*Ddd*f*g2*r**2 + 2800*D1*Ddd*f*g2*r*s - 2100*D1*Ddd*f*g2*r + 1400*D1*Ddd*f*g2*s**2 - 2100*D1*Ddd*f*g2*s + 1050*D1*Ddd*f*g2 - 35*D1*bd1*(D1*(12*C*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*f*(2*r**2 + 2*r*(2*s - 7) + 2*s**2 - 14*s + 7) - 2*f*(8*r**2 + r*(14*s - 9) + 6*s**2 - 7*s + 4) + 2*fd*(r + s - 1)*(-6*C*(2*r + 2*s - 1) + 10*K*s + r*(10*K + 6) + 6*s - 3) - 20*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(6*C*(2*r + 2*s - 1) - 10*K*(r + s - 1) - 6*r - 6*s + 3) - 10*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 2124*Dd**2*f**2*r**2 + 3384*Dd**2*f**2*r*s - 2970*Dd**2*f**2*r + 1260*Dd**2*f**2*s**2 - 2322*Dd**2*f**2*s + 918*Dd**2*f**2 + 4200*Dd**2*f*g2*r**2 + 8400*Dd**2*f*g2*r*s - 6300*Dd**2*f*g2*r + 4200*Dd**2*f*g2*s**2 - 6300*Dd**2*f*g2*s + 2100*Dd**2*f*g2))/(210*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**2*k2**2*st**4*(-360*C*D1**2*f**2*fd*r*s + 120*C*D1**2*f**2*fd*r - 360*C*D1**2*f**2*fd*s**2 + 360*C*D1**2*f**2*fd*s - 120*C*D1**2*f**2*fd + 180*C*D1**2*f**2*fdd*r*s - 60*C*D1**2*f**2*fdd*r + 180*C*D1**2*f**2*fdd*s**2 - 180*C*D1**2*f**2*fdd*s + 60*C*D1**2*f**2*fdd + 360*C*D1**2*f*fd**2*r*s - 120*C*D1**2*f*fd**2*r + 360*C*D1**2*f*fd**2*s**2 - 360*C*D1**2*f*fd**2*s + 60*C*D1**2*f*fd**2 - 480*C*D1*Dd*f**3*r*s + 120*C*D1*Dd*f**3*r - 480*C*D1*Dd*f**3*s**2 + 480*C*D1*Dd*f**3*s - 120*C*D1*Dd*f**3 + 1440*C*D1*Dd*f**2*fd*r*s - 420*C*D1*Dd*f**2*fd*r + 1440*C*D1*Dd*f**2*fd*s**2 - 1440*C*D1*Dd*f**2*fd*s + 300*C*D1*Dd*f**2*fd + 240*C*D1*Ddd*f**3*r*s - 60*C*D1*Ddd*f**3*r + 240*C*D1*Ddd*f**3*s**2 - 240*C*D1*Ddd*f**3*s + 60*C*D1*Ddd*f**3 + 720*C*Dd**2*f**3*r*s - 180*C*Dd**2*f**3*r + 720*C*Dd**2*f**3*s**2 - 720*C*Dd**2*f**3*s + 120*C*Dd**2*f**3 - 360*D1**2*K*b1*f*fd*r*s + 180*D1**2*K*b1*f*fd*r - 360*D1**2*K*b1*f*fd*s**2 + 360*D1**2*K*b1*f*fd*s - 180*D1**2*K*b1*f*fd + 180*D1**2*K*b1*f*fdd*r*s - 90*D1**2*K*b1*f*fdd*r + 180*D1**2*K*b1*f*fdd*s**2 - 180*D1**2*K*b1*f*fdd*s + 90*D1**2*K*b1*f*fdd + 180*D1**2*K*b1*fd**2*r*s - 90*D1**2*K*b1*fd**2*r + 180*D1**2*K*b1*fd**2*s**2 - 180*D1**2*K*b1*fd**2*s - 135*D1**2*b1*f**2*fd*r**2 - 135*D1**2*b1*f**2*fd*r*s + 135*D1**2*b1*f**2*fd*r + 45*D1**2*b1*f**2*fd*s - 45*D1**2*b1*f**2*fd + 135*D1**2*b1*f**2*fdd*r**2 + 135*D1**2*b1*f**2*fdd*r*s - 135*D1**2*b1*f**2*fdd*r - 45*D1**2*b1*f**2*fdd*s + 45*D1**2*b1*f**2*fdd + 270*D1**2*b1*f*fd**2*r**2 + 270*D1**2*b1*f*fd**2*r*s - 270*D1**2*b1*f*fd**2*r - 90*D1**2*b1*f*fd**2*s + 45*D1**2*b1*f*fd**2 - 180*D1**2*b1*f*fd*r**2 - 180*D1**2*b1*f*fd*r*s + 90*D1**2*b1*f*fd*r + 90*D1**2*b1*f*fdd*r**2 + 90*D1**2*b1*f*fdd*r*s - 45*D1**2*b1*f*fdd*r + 90*D1**2*b1*fd**2*r**2 + 90*D1**2*b1*fd**2*r*s - 45*D1**2*b1*fd**2*r - 360*D1**2*b2*f*fd*r*s + 180*D1**2*b2*f*fd*r - 360*D1**2*b2*f*fd*s**2 + 360*D1**2*b2*f*fd*s - 180*D1**2*b2*f*fd + 180*D1**2*b2*f*fdd*r*s - 90*D1**2*b2*f*fdd*r + 180*D1**2*b2*f*fdd*s**2 - 180*D1**2*b2*f*fdd*s + 90*D1**2*b2*f*fdd + 180*D1**2*b2*fd**2*r*s - 90*D1**2*b2*fd**2*r + 180*D1**2*b2*fd**2*s**2 - 180*D1**2*b2*fd**2*s - 180*D1**2*bd2*f**2*r*s - 180*D1**2*bd2*f**2*s**2 + 180*D1**2*bd2*f**2*s + 360*D1**2*bd2*f*fd*r*s - 90*D1**2*bd2*f*fd*r + 360*D1**2*bd2*f*fd*s**2 - 360*D1**2*bd2*f*fd*s + 90*D1**2*bd2*f*fd + 45*D1**2*bdd1*f**2*(r + s - 1)*(2*K*s + f*(r - 1) + r - 1) + 90*D1**2*bdd2*f**2*r*s + 90*D1**2*bdd2*f**2*s**2 - 90*D1**2*bdd2*f**2*s - 138*D1**2*f**2*fd*r**2 + 42*D1**2*f**2*fd*r*s + 78*D1**2*f**2*fd*r + 180*D1**2*f**2*fd*s**2 - 134*D1**2*f**2*fd*s + 14*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 75*D1**2*f**2*fdd*r - 90*D1**2*f**2*fdd*s**2 + 55*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 360*D1**2*f**2*gd2*r*s + 360*D1**2*f**2*gd2*s**2 - 360*D1**2*f**2*gd2*s - 180*D1**2*f**2*gdd2*r*s - 180*D1**2*f**2*gdd2*s**2 + 180*D1**2*f**2*gdd2*s + 210*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 150*D1**2*f*fd**2*r - 180*D1**2*f*fd**2*s**2 + 110*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 + 720*D1**2*f*fd*g2*r*s - 360*D1**2*f*fd*g2*r + 720*D1**2*f*fd*g2*s**2 - 720*D1**2*f*fd*g2*s + 360*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*r*s + 180*D1**2*f*fd*gd2*r - 720*D1**2*f*fd*gd2*s**2 + 720*D1**2*f*fd*gd2*s - 180*D1**2*f*fd*gd2 - 360*D1**2*f*fdd*g2*r*s + 180*D1**2*f*fdd*g2*r - 360*D1**2*f*fdd*g2*s**2 + 360*D1**2*f*fdd*g2*s - 180*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*r*s + 180*D1**2*fd**2*g2*r - 360*D1**2*fd**2*g2*s**2 + 360*D1**2*fd**2*g2*s - 720*D1*Dd*K*b1*f**2*r*s + 180*D1*Dd*K*b1*f**2*r - 720*D1*Dd*K*b1*f**2*s**2 + 720*D1*Dd*K*b1*f**2*s - 180*D1*Dd*K*b1*f**2 + 1440*D1*Dd*K*b1*f*fd*r*s - 540*D1*Dd*K*b1*f*fd*r + 1440*D1*Dd*K*b1*f*fd*s**2 - 1440*D1*Dd*K*b1*f*fd*s + 360*D1*Dd*K*b1*f*fd - 180*D1*Dd*b1*f**3*r**2 - 180*D1*Dd*b1*f**3*r*s + 225*D1*Dd*b1*f**3*r + 90*D1*Dd*b1*f**3*s - 90*D1*Dd*b1*f**3 + 1080*D1*Dd*b1*f**2*fd*r**2 + 1080*D1*Dd*b1*f**2*fd*r*s - 1215*D1*Dd*b1*f**2*fd*r - 450*D1*Dd*b1*f**2*fd*s + 315*D1*Dd*b1*f**2*fd - 360*D1*Dd*b1*f**2*r**2 - 360*D1*Dd*b1*f**2*r*s + 450*D1*Dd*b1*f**2*r + 180*D1*Dd*b1*f**2*s - 180*D1*Dd*b1*f**2 + 720*D1*Dd*b1*f*fd*r**2 + 720*D1*Dd*b1*f*fd*r*s - 630*D1*Dd*b1*f*fd*r - 180*D1*Dd*b1*f*fd*s + 90*D1*Dd*b1*f*fd - 720*D1*Dd*b2*f**2*r*s + 180*D1*Dd*b2*f**2*r - 720*D1*Dd*b2*f**2*s**2 + 720*D1*Dd*b2*f**2*s - 180*D1*Dd*b2*f**2 + 1440*D1*Dd*b2*f*fd*r*s - 540*D1*Dd*b2*f*fd*r + 1440*D1*Dd*b2*f*fd*s**2 - 1440*D1*Dd*b2*f*fd*s + 360*D1*Dd*b2*f*fd + 720*D1*Dd*bd2*f**2*r*s - 90*D1*Dd*bd2*f**2*r + 720*D1*Dd*bd2*f**2*s**2 - 720*D1*Dd*bd2*f**2*s + 90*D1*Dd*bd2*f**2 - 184*D1*Dd*f**3*r**2 + 56*D1*Dd*f**3*r*s + 170*D1*Dd*f**3*r + 240*D1*Dd*f**3*s**2 - 148*D1*Dd*f**3*s - 32*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 735*D1*Dd*f**2*fd*r - 720*D1*Dd*f**2*fd*s**2 + 370*D1*Dd*f**2*fd*s + 95*D1*Dd*f**2*fd + 1440*D1*Dd*f**2*g2*r*s - 360*D1*Dd*f**2*g2*r + 1440*D1*Dd*f**2*g2*s**2 - 1440*D1*Dd*f**2*g2*s + 360*D1*Dd*f**2*g2 - 1440*D1*Dd*f**2*gd2*r*s + 180*D1*Dd*f**2*gd2*r - 1440*D1*Dd*f**2*gd2*s**2 + 1440*D1*Dd*f**2*gd2*s - 180*D1*Dd*f**2*gd2 - 2880*D1*Dd*f*fd*g2*r*s + 1080*D1*Dd*f*fd*g2*r - 2880*D1*Dd*f*fd*g2*s**2 + 2880*D1*Dd*f*fd*g2*s - 720*D1*Dd*f*fd*g2 + 360*D1*Ddd*K*b1*f**2*r*s - 90*D1*Ddd*K*b1*f**2*r + 360*D1*Ddd*K*b1*f**2*s**2 - 360*D1*Ddd*K*b1*f**2*s + 90*D1*Ddd*K*b1*f**2 + 180*D1*Ddd*b1*f**3*r**2 + 180*D1*Ddd*b1*f**3*r*s - 225*D1*Ddd*b1*f**3*r - 90*D1*Ddd*b1*f**3*s + 90*D1*Ddd*b1*f**3 + 180*D1*Ddd*b1*f**2*r**2 + 180*D1*Ddd*b1*f**2*r*s - 225*D1*Ddd*b1*f**2*r - 90*D1*Ddd*b1*f**2*s + 90*D1*Ddd*b1*f**2 + 360*D1*Ddd*b2*f**2*r*s - 90*D1*Ddd*b2*f**2*r + 360*D1*Ddd*b2*f**2*s**2 - 360*D1*Ddd*b2*f**2*s + 90*D1*Ddd*b2*f**2 + 140*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 145*D1*Ddd*f**3*r - 120*D1*Ddd*f**3*s**2 + 50*D1*Ddd*f**3*s + 40*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*r*s + 180*D1*Ddd*f**2*g2*r - 720*D1*Ddd*f**2*g2*s**2 + 720*D1*Ddd*f**2*g2*s - 180*D1*Ddd*f**2*g2 - 45*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) + f*(fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + (2*r + 2*s - 2)*(2*K*s + r - 1)) - fd*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(2*K*(8*r*s - r + 8*s**2 - 8*s + 1) + f*(8*r**2 + r*(8*s - 13) - 6*s + 5) + 8*r**2 + 8*r*s - 13*r - 6*s + 5)) + 1080*Dd**2*K*b1*f**2*r*s - 270*Dd**2*K*b1*f**2*r + 1080*Dd**2*K*b1*f**2*s**2 - 1080*Dd**2*K*b1*f**2*s + 180*Dd**2*K*b1*f**2 + 540*Dd**2*b1*f**3*r**2 + 540*Dd**2*b1*f**3*r*s - 675*Dd**2*b1*f**3*r - 270*Dd**2*b1*f**3*s + 180*Dd**2*b1*f**3 + 540*Dd**2*b1*f**2*r**2 + 540*Dd**2*b1*f**2*r*s - 675*Dd**2*b1*f**2*r - 270*Dd**2*b1*f**2*s + 180*Dd**2*b1*f**2 + 1080*Dd**2*b2*f**2*r*s - 270*Dd**2*b2*f**2*r + 1080*Dd**2*b2*f**2*s**2 - 1080*Dd**2*b2*f**2*s + 180*Dd**2*b2*f**2 + 420*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 435*Dd**2*f**3*r - 360*Dd**2*f**3*s**2 + 150*Dd**2*f**3*s + 80*Dd**2*f**3 - 2160*Dd**2*f**2*g2*r*s + 540*Dd**2*f**2*g2*r - 2160*Dd**2*f**2*g2*s**2 + 2160*Dd**2*f**2*g2*s - 360*Dd**2*f**2*g2)/(105*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**2*k2**2*st**2*(186*C*D1**2*bdd1*f**2*r**2 + 204*C*D1**2*bdd1*f**2*r*s + 18*C*D1**2*bdd1*f**2*s**2 + 522*C*D1**2*f**2*fd*r**2 + 1116*C*D1**2*f**2*fd*r*s - 720*C*D1**2*f**2*fd*r + 594*C*D1**2*f**2*fd*s**2 - 768*C*D1**2*f**2*fd*s + 372*C*D1**2*f**2*fd - 558*C*D1**2*f**2*fdd*r**2 - 1044*C*D1**2*f**2*fdd*r*s + 720*C*D1**2*f**2*fdd*r - 486*C*D1**2*f**2*fdd*s**2 + 672*C*D1**2*f**2*fdd*s - 348*C*D1**2*f**2*fdd - 1116*C*D1**2*f*fd**2*r**2 - 2088*C*D1**2*f*fd**2*r*s + 1440*C*D1**2*f*fd**2*r - 972*C*D1**2*f*fd**2*s**2 + 1344*C*D1**2*f*fd**2*s - 348*C*D1**2*f*fd**2 + 696*C*D1*Dd*f**3*r**2 + 1488*C*D1*Dd*f**3*r*s - 1068*C*D1*Dd*f**3*r + 792*C*D1*Dd*f**3*s**2 - 1140*C*D1*Dd*f**3*s + 546*C*D1*Dd*f**3 - 4464*C*D1*Dd*f**2*fd*r**2 - 8352*C*D1*Dd*f**2*fd*r*s + 6156*C*D1*Dd*f**2*fd*r - 3888*C*D1*Dd*f**2*fd*s**2 + 5748*C*D1*Dd*f**2*fd*s - 2112*C*D1*Dd*f**2*fd - 744*C*D1*Ddd*f**3*r**2 - 1392*C*D1*Ddd*f**3*r*s + 1092*C*D1*Ddd*f**3*r - 648*C*D1*Ddd*f**3*s**2 + 1020*C*D1*Ddd*f**3*s - 534*C*D1*Ddd*f**3 - 2232*C*Dd**2*f**3*r**2 - 4176*C*Dd**2*f**3*r*s + 3276*C*Dd**2*f**3*r - 1944*C*Dd**2*f**3*s**2 + 3060*C*Dd**2*f**3*s - 1068*C*Dd**2*f**3 - 105*D1**2*K*bdd1*f**2*r**2 - 294*D1**2*K*bdd1*f**2*r*s + 210*D1**2*K*bdd1*f**2*r - 189*D1**2*K*bdd1*f**2*s**2 + 294*D1**2*K*bdd1*f**2*s - 105*D1**2*K*bdd1*f**2 + 21*D1**2*b2*bdd1*f*r**2 + 42*D1**2*b2*bdd1*f*r*s + 21*D1**2*b2*bdd1*f*s**2 + 126*D1**2*b2*f*fd*r**2 + 588*D1**2*b2*f*fd*r*s - 294*D1**2*b2*f*fd*r + 462*D1**2*b2*f*fd*s**2 - 462*D1**2*b2*f*fd*s + 231*D1**2*b2*f*fd - 210*D1**2*b2*f*fdd*r**2 - 588*D1**2*b2*f*fdd*r*s + 294*D1**2*b2*f*fdd*r - 378*D1**2*b2*f*fdd*s**2 + 378*D1**2*b2*f*fdd*s - 189*D1**2*b2*f*fdd - 210*D1**2*b2*fd**2*r**2 - 588*D1**2*b2*fd**2*r*s + 294*D1**2*b2*fd**2*r - 378*D1**2*b2*fd**2*s**2 + 378*D1**2*b2*fd**2*s - 42*D1**2*bd1**2*f*(-5*K*r**2 - 6*K*r*s + 5*K*r - K*s**2 + 3*K*s + f*(r - 1) + r - 1) - 93*D1**2*bdd1*f**2*r**2 - 102*D1**2*bdd1*f**2*r*s - 42*D1**2*bdd1*f**2*r - 9*D1**2*bdd1*f**2*s**2 - 210*D1**2*bdd1*f*g2*r**2 - 252*D1**2*bdd1*f*g2*r*s - 42*D1**2*bdd1*f*g2*s**2 - 21*D1**2*bdd2*f**2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) - 207*D1**2*f**2*fd*r**2 - 504*D1**2*f**2*fd*r*s + 306*D1**2*f**2*fd*r - 297*D1**2*f**2*fd*s**2 + 366*D1**2*f**2*fd*s - 168*D1**2*f**2*fd + 279*D1**2*f**2*fdd*r**2 + 522*D1**2*f**2*fdd*r*s - 360*D1**2*f**2*fdd*r + 243*D1**2*f**2*fdd*s**2 - 336*D1**2*f**2*fdd*s + 174*D1**2*f**2*fdd - 126*D1**2*f**2*gd2*r**2 - 588*D1**2*f**2*gd2*r*s + 252*D1**2*f**2*gd2*r - 462*D1**2*f**2*gd2*s**2 + 588*D1**2*f**2*gd2*s - 126*D1**2*f**2*gd2 + 210*D1**2*f**2*gdd2*r**2 + 588*D1**2*f**2*gdd2*r*s - 420*D1**2*f**2*gdd2*r + 378*D1**2*f**2*gdd2*s**2 - 588*D1**2*f**2*gdd2*s + 210*D1**2*f**2*gdd2 + 558*D1**2*f*fd**2*r**2 + 1044*D1**2*f*fd**2*r*s - 720*D1**2*f*fd**2*r + 486*D1**2*f*fd**2*s**2 - 672*D1**2*f*fd**2*s + 174*D1**2*f*fd**2 - 252*D1**2*f*fd*g2*r**2 - 1176*D1**2*f*fd*g2*r*s + 588*D1**2*f*fd*g2*r - 924*D1**2*f*fd*g2*s**2 + 924*D1**2*f*fd*g2*s - 462*D1**2*f*fd*g2 + 840*D1**2*f*fd*gd2*r**2 + 2352*D1**2*f*fd*gd2*r*s - 1428*D1**2*f*fd*gd2*r + 1512*D1**2*f*fd*gd2*s**2 - 1932*D1**2*f*fd*gd2*s + 588*D1**2*f*fd*gd2 + 420*D1**2*f*fdd*g2*r**2 + 1176*D1**2*f*fdd*g2*r*s - 588*D1**2*f*fdd*g2*r + 756*D1**2*f*fdd*g2*s**2 - 756*D1**2*f*fdd*g2*s + 378*D1**2*f*fdd*g2 + 420*D1**2*fd**2*g2*r**2 + 1176*D1**2*fd**2*g2*r*s - 588*D1**2*fd**2*g2*r + 756*D1**2*fd**2*g2*s**2 - 756*D1**2*fd**2*g2*s + 252*D1*Dd*b2*f**2*r**2 + 1176*D1*Dd*b2*f**2*r*s - 546*D1*Dd*b2*f**2*r + 924*D1*Dd*b2*f**2*s**2 - 1050*D1*Dd*b2*f**2*s + 357*D1*Dd*b2*f**2 - 1680*D1*Dd*b2*f*fd*r**2 - 4704*D1*Dd*b2*f*fd*r*s + 2604*D1*Dd*b2*f*fd*r - 3024*D1*Dd*b2*f*fd*s**2 + 3444*D1*Dd*b2*f*fd*s - 966*D1*Dd*b2*f*fd - 276*D1*Dd*f**3*r**2 - 672*D1*Dd*f**3*r*s + 444*D1*Dd*f**3*r - 396*D1*Dd*f**3*s**2 + 534*D1*Dd*f**3*s - 237*D1*Dd*f**3 + 2232*D1*Dd*f**2*fd*r**2 + 4176*D1*Dd*f**2*fd*r*s - 3078*D1*Dd*f**2*fd*r + 1944*D1*Dd*f**2*fd*s**2 - 2874*D1*Dd*f**2*fd*s + 1056*D1*Dd*f**2*fd - 504*D1*Dd*f**2*g2*r**2 - 2352*D1*Dd*f**2*g2*r*s + 1092*D1*Dd*f**2*g2*r - 1848*D1*Dd*f**2*g2*s**2 + 2100*D1*Dd*f**2*g2*s - 714*D1*Dd*f**2*g2 + 1680*D1*Dd*f**2*gd2*r**2 + 4704*D1*Dd*f**2*gd2*r*s - 3108*D1*Dd*f**2*gd2*r + 3024*D1*Dd*f**2*gd2*s**2 - 4284*D1*Dd*f**2*gd2*s + 1428*D1*Dd*f**2*gd2 + 3360*D1*Dd*f*fd*g2*r**2 + 9408*D1*Dd*f*fd*g2*r*s - 5208*D1*Dd*f*fd*g2*r + 6048*D1*Dd*f*fd*g2*s**2 - 6888*D1*Dd*f*fd*g2*s + 1932*D1*Dd*f*fd*g2 - 420*D1*Ddd*b2*f**2*r**2 - 1176*D1*Ddd*b2*f**2*r*s + 714*D1*Ddd*b2*f**2*r - 756*D1*Ddd*b2*f**2*s**2 + 966*D1*Ddd*b2*f**2*s - 399*D1*Ddd*b2*f**2 + 372*D1*Ddd*f**3*r**2 + 696*D1*Ddd*f**3*r*s - 546*D1*Ddd*f**3*r + 324*D1*Ddd*f**3*s**2 - 510*D1*Ddd*f**3*s + 267*D1*Ddd*f**3 + 840*D1*Ddd*f**2*g2*r**2 + 2352*D1*Ddd*f**2*g2*r*s - 1428*D1*Ddd*f**2*g2*r + 1512*D1*Ddd*f**2*g2*s**2 - 1932*D1*Ddd*f**2*g2*s + 798*D1*Ddd*f**2*g2 + D1*bd1*(D1*(f**2*(21*K*(3*r**2 + 2*r*(7*s - 3) + 11*s**2 - 14*s + 3) - 2*r**2*(130*C - 86) - 2*r*(s*(148*C - 95) + 14) - 6*s**2*(6*C - 3) - 42*s + 42) - 6*f*(7*bd2*(-r**2 - 2*r*s + r - s**2 + s) + fd*(-12*C*s**2 + 40*C*s + 7*K*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) - r**2*(124*C - 62) + r*(-136*C*s + 96*C + 68*s - 41) + 6*s**2 - 20*s - 7) + 14*gd2*(5*r**2 + r*(6*s - 5) + s*(s - 3)) + 7*(r + s)*(b2*(r + s) - 2*g2*(5*r + s))) + 42*fd*(b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(5*r**2 + r*(6*s - 3) + s*(s - 1)))) - 6*Dd*f*(-7*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f*(-24*C*s**2 + 74*C*s + 7*K*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) - r**2*(248*C - 124) + r*(-272*C*s + 158*C + 136*s - 51) + 12*s**2 - 37*s - 14) + 14*g2*(20*r**2 + r*(24*s - 13) + s*(4*s - 7))) - 42*b1*(-D1*(f*(-K*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) + r*(f + 2)) + fd*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1)) + Dd*f*(-K*(40*r**2 + 48*r*s - 46*r + 8*s**2 - 26*s + 13) + f*(4*r - 2) + 4*r - 2))) + 21*D1*bd2*f*(D1*(f*(3*r**2 + 14*r*s - 6*r + 11*s**2 - 14*s + 3) - 2*fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 23*s + 7)) - 2*Dd*f*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17)) - 1260*Dd**2*b2*f**2*r**2 - 3528*Dd**2*b2*f**2*r*s + 2142*Dd**2*b2*f**2*r - 2268*Dd**2*b2*f**2*s**2 + 2898*Dd**2*b2*f**2*s - 798*Dd**2*b2*f**2 + 1116*Dd**2*f**3*r**2 + 2088*Dd**2*f**3*r*s - 1638*Dd**2*f**3*r + 972*Dd**2*f**3*s**2 - 1530*Dd**2*f**3*s + 534*Dd**2*f**3 + 2520*Dd**2*f**2*g2*r**2 + 7056*Dd**2*f**2*g2*r*s - 4284*Dd**2*f**2*g2*r + 4536*Dd**2*f**2*g2*s**2 - 5796*Dd**2*f**2*g2*s + 1596*Dd**2*f**2*g2 + 21*b1**2*(D1**2*(2*fd**2*(r - 1) - 2*fd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(f + 2)) + fdd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(2*f + 2))) + D1*(2*Dd*(-K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11) + fd*(K*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + f*(4*r - 2) + 4*r - 2)) + Ddd*K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11)) + 2*Dd**2*K*f*(30*r**2 + r*(36*s - 39) + 6*s**2 - 21*s + 11)) - b1*(520*C*D1**2*f*fd*r**2 + 592*C*D1**2*f*fd*r*s - 816*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s**2 - 368*C*D1**2*f*fd*s + 296*C*D1**2*f*fd - 372*C*D1**2*f*fdd*r**2 - 408*C*D1**2*f*fdd*r*s + 576*C*D1**2*f*fdd*r - 36*C*D1**2*f*fdd*s**2 + 240*C*D1**2*f*fdd*s - 204*C*D1**2*f*fdd - 372*C*D1**2*fd**2*r**2 - 408*C*D1**2*fd**2*r*s + 576*C*D1**2*fd**2*r - 36*C*D1**2*fd**2*s**2 + 240*C*D1**2*fd**2*s - 204*C*D1**2*fd**2 + 1040*C*D1*Dd*f**2*r**2 + 1184*C*D1*Dd*f**2*r*s - 1336*C*D1*Dd*f**2*r + 144*C*D1*Dd*f**2*s**2 - 664*C*D1*Dd*f**2*s + 556*C*D1*Dd*f**2 - 2976*C*D1*Dd*f*fd*r**2 - 3264*C*D1*Dd*f*fd*r*s + 4200*C*D1*Dd*f*fd*r - 288*C*D1*Dd*f*fd*s**2 + 1848*C*D1*Dd*f*fd*s - 1392*C*D1*Dd*f*fd - 744*C*D1*Ddd*f**2*r**2 - 816*C*D1*Ddd*f**2*r*s + 948*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 444*C*D1*Ddd*f**2*s - 390*C*D1*Ddd*f**2 - 2232*C*Dd**2*f**2*r**2 - 2448*C*Dd**2*f**2*r*s + 2844*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 1332*C*Dd**2*f**2*s - 780*C*Dd**2*f**2 - 210*D1**2*K*bdd1*f*r**2 - 252*D1**2*K*bdd1*f*r*s + 210*D1**2*K*bdd1*f*r - 42*D1**2*K*bdd1*f*s**2 + 126*D1**2*K*bdd1*f*s - 105*D1**2*K*bdd1*f - 126*D1**2*K*f*fd*r**2 - 588*D1**2*K*f*fd*r*s + 294*D1**2*K*f*fd*r - 462*D1**2*K*f*fd*s**2 + 462*D1**2*K*f*fd*s - 231*D1**2*K*f*fd + 210*D1**2*K*f*fdd*r**2 + 588*D1**2*K*f*fdd*r*s - 294*D1**2*K*f*fdd*r + 378*D1**2*K*f*fdd*s**2 - 378*D1**2*K*f*fdd*s + 189*D1**2*K*f*fdd + 210*D1**2*K*fd**2*r**2 + 588*D1**2*K*fd**2*r*s - 294*D1**2*K*fd**2*r + 378*D1**2*K*fd**2*s**2 - 378*D1**2*K*fd**2*s + 42*D1**2*b2*fd*r**2 + 84*D1**2*b2*fd*r*s - 84*D1**2*b2*fd*r + 42*D1**2*b2*fd*s**2 - 84*D1**2*b2*fd*s + 42*D1**2*b2*fd - 21*D1**2*b2*fdd*r**2 - 42*D1**2*b2*fdd*r*s + 42*D1**2*b2*fdd*r - 21*D1**2*b2*fdd*s**2 + 42*D1**2*b2*fdd*s - 21*D1**2*b2*fdd + 42*D1**2*bdd1*f**2*r + 42*D1**2*bdd1*f*r - 21*D1**2*bdd2*f*(r + s - 1)**2 - 344*D1**2*f*fd*r**2 - 380*D1**2*f*fd*r*s + 506*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 184*D1**2*f*fd*s - 148*D1**2*f*fd + 186*D1**2*f*fdd*r**2 + 204*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 120*D1**2*f*fdd*s + 102*D1**2*f*fdd - 420*D1**2*f*gd2*r**2 - 504*D1**2*f*gd2*r*s + 840*D1**2*f*gd2*r - 84*D1**2*f*gd2*s**2 + 504*D1**2*f*gd2*s - 420*D1**2*f*gd2 + 210*D1**2*f*gdd2*r**2 + 252*D1**2*f*gdd2*r*s - 420*D1**2*f*gdd2*r + 42*D1**2*f*gdd2*s**2 - 252*D1**2*f*gdd2*s + 210*D1**2*f*gdd2 + 186*D1**2*fd**2*r**2 + 204*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 120*D1**2*fd**2*s + 144*D1**2*fd**2 - 420*D1**2*fd*g2*r**2 - 504*D1**2*fd*g2*r*s + 504*D1**2*fd*g2*r - 84*D1**2*fd*g2*s**2 + 168*D1**2*fd*g2*s - 84*D1**2*fd*g2 + 420*D1**2*fd*gd2*r**2 + 504*D1**2*fd*gd2*r*s - 672*D1**2*fd*gd2*r + 84*D1**2*fd*gd2*s**2 - 336*D1**2*fd*gd2*s + 252*D1**2*fd*gd2 + 210*D1**2*fdd*g2*r**2 + 252*D1**2*fdd*g2*r*s - 252*D1**2*fdd*g2*r + 42*D1**2*fdd*g2*s**2 - 84*D1**2*fdd*g2*s + 42*D1**2*fdd*g2 - 252*D1*Dd*K*f**2*r**2 - 1176*D1*Dd*K*f**2*r*s + 546*D1*Dd*K*f**2*r - 924*D1*Dd*K*f**2*s**2 + 1050*D1*Dd*K*f**2*s - 357*D1*Dd*K*f**2 + 1680*D1*Dd*K*f*fd*r**2 + 4704*D1*Dd*K*f*fd*r*s - 2604*D1*Dd*K*f*fd*r + 3024*D1*Dd*K*f*fd*s**2 - 3444*D1*Dd*K*f*fd*s + 966*D1*Dd*K*f*fd + 168*D1*Dd*b2*f*r**2 + 336*D1*Dd*b2*f*r*s - 252*D1*Dd*b2*f*r + 168*D1*Dd*b2*f*s**2 - 252*D1*Dd*b2*f*s + 126*D1*Dd*b2*f - 168*D1*Dd*b2*fd*r**2 - 336*D1*Dd*b2*fd*r*s + 294*D1*Dd*b2*fd*r - 168*D1*Dd*b2*fd*s**2 + 294*D1*Dd*b2*fd*s - 126*D1*Dd*b2*fd - 688*D1*Dd*f**2*r**2 - 760*D1*Dd*f**2*r*s + 878*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 416*D1*Dd*f**2*s - 362*D1*Dd*f**2 + 1488*D1*Dd*f*fd*r**2 + 1632*D1*Dd*f*fd*r*s - 2268*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 924*D1*Dd*f*fd*s + 780*D1*Dd*f*fd - 1680*D1*Dd*f*g2*r**2 - 2016*D1*Dd*f*g2*r*s + 2184*D1*Dd*f*g2*r - 336*D1*Dd*f*g2*s**2 + 1176*D1*Dd*f*g2*s - 924*D1*Dd*f*g2 + 1680*D1*Dd*f*gd2*r**2 + 2016*D1*Dd*f*gd2*r*s - 2772*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s**2 - 1596*D1*Dd*f*gd2*s + 1092*D1*Dd*f*gd2 + 1680*D1*Dd*fd*g2*r**2 + 2016*D1*Dd*fd*g2*r*s - 2100*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s**2 - 924*D1*Dd*fd*g2*s + 588*D1*Dd*fd*g2 + 420*D1*Ddd*K*f**2*r**2 + 1176*D1*Ddd*K*f**2*r*s - 714*D1*Ddd*K*f**2*r + 756*D1*Ddd*K*f**2*s**2 - 966*D1*Ddd*K*f**2*s + 399*D1*Ddd*K*f**2 - 84*D1*Ddd*b2*f*r**2 - 168*D1*Ddd*b2*f*r*s + 126*D1*Ddd*b2*f*r - 84*D1*Ddd*b2*f*s**2 + 126*D1*Ddd*b2*f*s - 63*D1*Ddd*b2*f + 372*D1*Ddd*f**2*r**2 + 408*D1*Ddd*f**2*r*s - 474*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 222*D1*Ddd*f**2*s + 195*D1*Ddd*f**2 + 840*D1*Ddd*f*g2*r**2 + 1008*D1*Ddd*f*g2*r*s - 1092*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s**2 - 588*D1*Ddd*f*g2*s + 462*D1*Ddd*f*g2 + 42*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 1260*Dd**2*K*f**2*r**2 + 3528*Dd**2*K*f**2*r*s - 2142*Dd**2*K*f**2*r + 2268*Dd**2*K*f**2*s**2 - 2898*Dd**2*K*f**2*s + 798*Dd**2*K*f**2 - 252*Dd**2*b2*f*r**2 - 504*Dd**2*b2*f*r*s + 378*Dd**2*b2*f*r - 252*Dd**2*b2*f*s**2 + 378*Dd**2*b2*f*s - 126*Dd**2*b2*f + 1116*Dd**2*f**2*r**2 + 1224*Dd**2*f**2*r*s - 1422*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 666*Dd**2*f**2*s + 390*Dd**2*f**2 + 2520*Dd**2*f*g2*r**2 + 3024*Dd**2*f*g2*r*s - 3276*Dd**2*f*g2*r + 504*Dd**2*f*g2*s**2 - 1764*Dd**2*f*g2*s + 924*Dd**2*f*g2))/(105*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**2*k2**2*(D1*(-14*D1*bd1**2*(f*(5*K*(4*r**2 + r*(4*s - 9) - 7*s + 5) + r**2*(45 - 62*C) - r*(46*C - 30)*(2*s - 1) - s*(30*C - 15)*(s - 1)) + 50*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bdd1*f*(-f*(6*C - 3)*(44*r**2 + r*(44*s - 94) - 70*s + 35) + 70*g2*(4*r**2 + 2*r*(2*s - 5) - 10*s + 5)) + 35*b2*(2*D1*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 5*D1*bdd1*f*(r + s - 1)**2 + bd1*(D1*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 10*Dd*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + bd1*(-350*D1*bd2*f*(r + s - 1)**2 + D1*(3*f**2*(2*C*(95*r**2 + 6*r*(17*s - 15) + 7*s**2 - 42*s + 21) - 95*r**2 + r*(76 - 102*s) - 7*s**2 + 42*s - 21) - 2*f*(fd*(6*C - 3)*(88*r**2 + r*(88*s - 113) - 57*s + 47) + 35*g2*(9*r**2 + 10*r*s - 6*r + s**2 - 6*s + 3) - 70*gd2*(4*r**2 + 4*r*s - 9*r - 7*s + 5)) + 280*fd*g2*r*(2*r + 2*s - 1)) - 2*Dd*f*(f*(6*C - 3)*(176*r**2 + 2*r*(88*s - 149) - 184*s + 129) - 70*g2*(16*r**2 + 2*r*(8*s - 15) - 24*s + 15)))) + 35*b1**3*(2*D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(2*Dd*(-20*K*r**2 - 40*K*r*s + 30*K*r - 20*K*s**2 + 30*K*s - 15*K + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 13*r + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) + Ddd*(5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 8*r**2 - 8*r*s + 10*r + 4*s - 4)) + 2*Dd**2*(15*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 7*b1**2*(-124*C*D1**2*fd*r**2 - 184*C*D1**2*fd*r*s + 248*C*D1**2*fd*r - 60*C*D1**2*fd*s**2 + 184*C*D1**2*fd*s - 124*C*D1**2*fd + 62*C*D1**2*fdd*r**2 + 92*C*D1**2*fdd*r*s - 124*C*D1**2*fdd*r + 30*C*D1**2*fdd*s**2 - 92*C*D1**2*fdd*s + 62*C*D1**2*fdd - 496*C*D1*Dd*f*r**2 - 736*C*D1*Dd*f*r*s + 680*C*D1*Dd*f*r - 240*C*D1*Dd*f*s**2 + 488*C*D1*Dd*f*s - 308*C*D1*Dd*f + 496*C*D1*Dd*fd*r**2 + 736*C*D1*Dd*fd*r*s - 836*C*D1*Dd*fd*r + 240*C*D1*Dd*fd*s**2 - 612*C*D1*Dd*fd*s + 340*C*D1*Dd*fd + 248*C*D1*Ddd*f*r**2 + 368*C*D1*Ddd*f*r*s - 340*C*D1*Ddd*f*r + 120*C*D1*Ddd*f*s**2 - 244*C*D1*Ddd*f*s + 154*C*D1*Ddd*f + 744*C*Dd**2*f*r**2 + 1104*C*Dd**2*f*r*s - 1020*C*Dd**2*f*r + 360*C*Dd**2*f*s**2 - 732*C*Dd**2*f*s + 308*C*Dd**2*f + 75*D1**2*K*bdd1*r**2 + 150*D1**2*K*bdd1*r*s - 100*D1**2*K*bdd1*r + 75*D1**2*K*bdd1*s**2 - 100*D1**2*K*bdd1*s + 50*D1**2*K*bdd1 + 45*D1**2*K*fd*r**2 + 50*D1**2*K*fd*r*s - 20*D1**2*K*fd*r + 5*D1**2*K*fd*s**2 + 20*D1**2*K*fd*s - 10*D1**2*K*fd - 20*D1**2*K*fdd*r**2 - 20*D1**2*K*fdd*r*s - 30*D1**2*K*fdd*r - 50*D1**2*K*fdd*s + 25*D1**2*K*fdd - 30*D1**2*bdd1*f*r**2 - 30*D1**2*bdd1*f*r*s + 30*D1**2*bdd1*f*r + 10*D1**2*bdd1*f*s - 10*D1**2*bdd1*f - 30*D1**2*bdd1*r**2 - 30*D1**2*bdd1*r*s + 30*D1**2*bdd1*r + 10*D1**2*bdd1*s - 10*D1**2*bdd1 + 5*D1**2*bdd2*r**2 + 10*D1**2*bdd2*r*s - 10*D1**2*bdd2*r + 5*D1**2*bdd2*s**2 - 10*D1**2*bdd2*s + 5*D1**2*bdd2 + 90*D1**2*fd*r**2 + 120*D1**2*fd*r*s - 170*D1**2*fd*r + 30*D1**2*fd*s**2 - 120*D1**2*fd*s + 90*D1**2*fd - 45*D1**2*fdd*r**2 - 60*D1**2*fdd*r*s + 90*D1**2*fdd*r - 15*D1**2*fdd*s**2 + 60*D1**2*fdd*s - 45*D1**2*fdd + 100*D1**2*gd2*r**2 + 200*D1**2*gd2*r*s - 200*D1**2*gd2*r + 100*D1**2*gd2*s**2 - 200*D1**2*gd2*s + 100*D1**2*gd2 - 50*D1**2*gdd2*r**2 - 100*D1**2*gdd2*r*s + 100*D1**2*gdd2*r - 50*D1**2*gdd2*s**2 + 100*D1**2*gdd2*s - 50*D1**2*gdd2 + 180*D1*Dd*K*f*r**2 + 200*D1*Dd*K*f*r*s - 230*D1*Dd*K*f*r + 20*D1*Dd*K*f*s**2 - 110*D1*Dd*K*f*s + 95*D1*Dd*K*f - 160*D1*Dd*K*fd*r**2 - 160*D1*Dd*K*fd*r*s - 20*D1*Dd*K*fd*r - 160*D1*Dd*K*fd*s + 110*D1*Dd*K*fd - 40*D1*Dd*b2*r**2 - 80*D1*Dd*b2*r*s + 60*D1*Dd*b2*r - 40*D1*Dd*b2*s**2 + 60*D1*Dd*b2*s - 30*D1*Dd*b2 + 360*D1*Dd*f*r**2 + 480*D1*Dd*f*r*s - 480*D1*Dd*f*r + 120*D1*Dd*f*s**2 - 300*D1*Dd*f*s + 210*D1*Dd*f - 360*D1*Dd*fd*r**2 - 480*D1*Dd*fd*r*s + 600*D1*Dd*fd*r - 120*D1*Dd*fd*s**2 + 390*D1*Dd*fd*s - 240*D1*Dd*fd + 400*D1*Dd*g2*r**2 + 800*D1*Dd*g2*r*s - 600*D1*Dd*g2*r + 400*D1*Dd*g2*s**2 - 600*D1*Dd*g2*s + 300*D1*Dd*g2 - 400*D1*Dd*gd2*r**2 - 800*D1*Dd*gd2*r*s + 700*D1*Dd*gd2*r - 400*D1*Dd*gd2*s**2 + 700*D1*Dd*gd2*s - 300*D1*Dd*gd2 - 80*D1*Ddd*K*f*r**2 - 80*D1*Ddd*K*f*r*s + 100*D1*Ddd*K*f*r + 40*D1*Ddd*K*f*s - 40*D1*Ddd*K*f + 20*D1*Ddd*b2*r**2 + 40*D1*Ddd*b2*r*s - 30*D1*Ddd*b2*r + 20*D1*Ddd*b2*s**2 - 30*D1*Ddd*b2*s + 15*D1*Ddd*b2 - 180*D1*Ddd*f*r**2 - 240*D1*Ddd*f*r*s + 240*D1*Ddd*f*r - 60*D1*Ddd*f*s**2 + 150*D1*Ddd*f*s - 105*D1*Ddd*f - 200*D1*Ddd*g2*r**2 - 400*D1*Ddd*g2*r*s + 300*D1*Ddd*g2*r - 200*D1*Ddd*g2*s**2 + 300*D1*Ddd*g2*s - 150*D1*Ddd*g2 + 10*D1*bd1*(D1*(-15*K*r**2 - 30*K*r*s + 20*K*r - 15*K*s**2 + 20*K*s - 10*K + f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 - 6*r*s + 9*r + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) + Dd*(5*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) - 24*r**2 - 24*r*s + 27*r + 10*s - 7)) - 10*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 240*Dd**2*K*f*r**2 - 240*Dd**2*K*f*r*s + 300*Dd**2*K*f*r + 120*Dd**2*K*f*s - 80*Dd**2*K*f + 60*Dd**2*b2*r**2 + 120*Dd**2*b2*r*s - 90*Dd**2*b2*r + 60*Dd**2*b2*s**2 - 90*Dd**2*b2*s + 30*Dd**2*b2 - 540*Dd**2*f*r**2 - 720*Dd**2*f*r*s + 720*Dd**2*f*r - 180*Dd**2*f*s**2 + 450*Dd**2*f*s - 210*Dd**2*f - 600*Dd**2*g2*r**2 - 1200*Dd**2*g2*r*s + 900*Dd**2*g2*r - 600*Dd**2*g2*s**2 + 900*Dd**2*g2*s - 300*Dd**2*g2) - b1*(-868*C*D1**2*bdd1*f*r**2 - 1288*C*D1**2*bdd1*f*r*s + 644*C*D1**2*bdd1*f*r - 420*C*D1**2*bdd1*f*s**2 + 420*C*D1**2*bdd1*f*s - 210*C*D1**2*bdd1*f - 1140*C*D1**2*f*fd*r**2 - 1224*C*D1**2*f*fd*r*s + 1212*C*D1**2*f*fd*r - 84*C*D1**2*f*fd*s**2 + 444*C*D1**2*f*fd*s - 486*C*D1**2*f*fd + 528*C*D1**2*f*fdd*r**2 + 528*C*D1**2*f*fdd*r*s - 228*C*D1**2*f*fdd*r + 156*C*D1**2*f*fdd*s + 54*C*D1**2*f*fdd + 528*C*D1**2*fd**2*r**2 + 528*C*D1**2*fd**2*r*s - 228*C*D1**2*fd**2*r + 156*C*D1**2*fd**2*s - 300*C*D1**2*fd**2 - 2280*C*D1*Dd*f**2*r**2 - 2448*C*D1*Dd*f**2*r*s + 2892*C*D1*Dd*f**2*r - 168*C*D1*Dd*f**2*s**2 + 1308*C*D1*Dd*f**2*s - 1182*C*D1*Dd*f**2 + 4224*C*D1*Dd*f*fd*r**2 + 4224*C*D1*Dd*f*fd*r*s - 3552*C*D1*Dd*f*fd*r - 432*C*D1*Dd*f*fd*s + 300*C*D1*Dd*f*fd + 1056*C*D1*Ddd*f**2*r**2 + 1056*C*D1*Ddd*f**2*r*s - 1320*C*D1*Ddd*f**2*r - 528*C*D1*Ddd*f**2*s + 528*C*D1*Ddd*f**2 + 3168*C*Dd**2*f**2*r**2 + 3168*C*Dd**2*f**2*r*s - 3960*C*Dd**2*f**2*r - 1584*C*Dd**2*f**2*s + 1056*C*Dd**2*f**2 + 280*D1**2*K*bdd1*f*r**2 + 280*D1**2*K*bdd1*f*r*s - 630*D1**2*K*bdd1*f*r - 490*D1**2*K*bdd1*f*s + 315*D1**2*K*bdd1*f + 70*D1**2*bd1**2*(-5*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*r**2 + 6*r*s - 6*r - 2*s + 1) - 140*D1**2*bd2*f*r**2 - 280*D1**2*bd2*f*r*s + 280*D1**2*bd2*f*r - 140*D1**2*bd2*f*s**2 + 280*D1**2*bd2*f*s - 140*D1**2*bd2*f + 350*D1**2*bd2*fd*r**2 + 700*D1**2*bd2*fd*r*s - 350*D1**2*bd2*fd*r + 350*D1**2*bd2*fd*s**2 - 350*D1**2*bd2*fd*s + 630*D1**2*bdd1*f*r**2 + 840*D1**2*bdd1*f*r*s - 420*D1**2*bdd1*f*r + 210*D1**2*bdd1*f*s**2 - 210*D1**2*bdd1*f*s + 105*D1**2*bdd1*f + 700*D1**2*bdd1*g2*r**2 + 1400*D1**2*bdd1*g2*r*s - 700*D1**2*bdd1*g2*r + 700*D1**2*bdd1*g2*s**2 - 700*D1**2*bdd1*g2*s + 350*D1**2*bdd1*g2 + 175*D1**2*bdd2*f*r**2 + 350*D1**2*bdd2*f*r*s - 350*D1**2*bdd2*f*r + 175*D1**2*bdd2*f*s**2 - 350*D1**2*bdd2*f*s + 175*D1**2*bdd2*f + 570*D1**2*f*fd*r**2 + 612*D1**2*f*fd*r*s - 648*D1**2*f*fd*r + 42*D1**2*f*fd*s**2 - 222*D1**2*f*fd*s + 243*D1**2*f*fd - 264*D1**2*f*fdd*r**2 - 264*D1**2*f*fdd*r*s + 114*D1**2*f*fdd*r - 78*D1**2*f*fdd*s - 27*D1**2*f*fdd + 630*D1**2*f*gd2*r**2 + 700*D1**2*f*gd2*r*s - 1260*D1**2*f*gd2*r + 70*D1**2*f*gd2*s**2 - 700*D1**2*f*gd2*s + 630*D1**2*f*gd2 - 280*D1**2*f*gdd2*r**2 - 280*D1**2*f*gdd2*r*s + 560*D1**2*f*gdd2*r + 280*D1**2*f*gdd2*s - 280*D1**2*f*gdd2 - 264*D1**2*fd**2*r**2 - 264*D1**2*fd**2*r*s + 114*D1**2*fd**2*r - 78*D1**2*fd**2*s + 150*D1**2*fd**2 + 630*D1**2*fd*g2*r**2 + 700*D1**2*fd*g2*r*s - 280*D1**2*fd*g2*r + 70*D1**2*fd*g2*s**2 + 280*D1**2*fd*g2*s - 140*D1**2*fd*g2 - 560*D1**2*fd*gd2*r**2 - 560*D1**2*fd*gd2*r*s + 140*D1**2*fd*gd2*r - 420*D1**2*fd*gd2*s + 420*D1**2*fd*gd2 - 280*D1**2*fdd*g2*r**2 - 280*D1**2*fdd*g2*r*s - 420*D1**2*fdd*g2*r - 700*D1**2*fdd*g2*s + 350*D1**2*fdd*g2 + 1400*D1*Dd*bd2*f*r**2 + 2800*D1*Dd*bd2*f*r*s - 2450*D1*Dd*bd2*f*r + 1400*D1*Dd*bd2*f*s**2 - 2450*D1*Dd*bd2*f*s + 1050*D1*Dd*bd2*f + 1140*D1*Dd*f**2*r**2 + 1224*D1*Dd*f**2*r*s - 1446*D1*Dd*f**2*r + 84*D1*Dd*f**2*s**2 - 654*D1*Dd*f**2*s + 591*D1*Dd*f**2 - 2112*D1*Dd*f*fd*r**2 - 2112*D1*Dd*f*fd*r*s + 1776*D1*Dd*f*fd*r + 216*D1*Dd*f*fd*s - 150*D1*Dd*f*fd + 2520*D1*Dd*f*g2*r**2 + 2800*D1*Dd*f*g2*r*s - 3220*D1*Dd*f*g2*r + 280*D1*Dd*f*g2*s**2 - 1540*D1*Dd*f*g2*s + 1330*D1*Dd*f*g2 - 2240*D1*Dd*f*gd2*r**2 - 2240*D1*Dd*f*gd2*r*s + 3640*D1*Dd*f*gd2*r + 1680*D1*Dd*f*gd2*s - 1400*D1*Dd*f*gd2 - 2240*D1*Dd*fd*g2*r**2 - 2240*D1*Dd*fd*g2*r*s - 280*D1*Dd*fd*g2*r - 2240*D1*Dd*fd*g2*s + 1540*D1*Dd*fd*g2 - 528*D1*Ddd*f**2*r**2 - 528*D1*Ddd*f**2*r*s + 660*D1*Ddd*f**2*r + 264*D1*Ddd*f**2*s - 264*D1*Ddd*f**2 - 1120*D1*Ddd*f*g2*r**2 - 1120*D1*Ddd*f*g2*r*s + 1400*D1*Ddd*f*g2*r + 560*D1*Ddd*f*g2*s - 560*D1*Ddd*f*g2 - 14*D1*bd1*(5*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(2*C*fd*(62*r**2 + r*(92*s - 85) + 30*s**2 - 61*s + 23) + f*(-2*C*(62*r**2 + 92*r*s - 46*r + 30*s**2 - 30*s + 15) + 5*K*(9*r**2 + 2*r*(5*s - 6) + s**2 - 8*s + 6) + 90*r**2 + 120*r*s - 65*r + 30*s**2 - 30*s + 15) - 5*fd*(K*(8*r**2 + 8*r*s - 3*r + 3*s - 3) + 18*r**2 + 24*r*(s - 1) + 6*s**2 - 15*s + 6) + 50*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 50*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*(f*(2*C*(248*r**2 + r*(368*s - 262) + 120*s**2 - 182*s + 61) - 5*K*(32*r**2 + 8*r*(4*s - 7) - 36*s + 25) - 360*r**2 - 120*r*(4*s - 3) - 120*s**2 + 210*s - 75) - 50*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 1584*Dd**2*f**2*r**2 - 1584*Dd**2*f**2*r*s + 1980*Dd**2*f**2*r + 792*Dd**2*f**2*s - 528*Dd**2*f**2 - 3360*Dd**2*f*g2*r**2 - 3360*Dd**2*f*g2*r*s + 4200*Dd**2*f*g2*r + 1680*Dd**2*f*g2*s - 1120*Dd**2*f*g2 + 35*b2*(-D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 4*D1**2*fd*r**2 - 8*D1**2*fd*r*s + 2*D1**2*fd*r - 4*D1**2*fd*s**2 + 2*D1**2*fd*s - D1**2*fd + 5*D1**2*fdd*r**2 + 10*D1**2*fdd*r*s + 5*D1**2*fdd*s**2 - 16*D1*Dd*f*r**2 - 32*D1*Dd*f*r*s + 24*D1*Dd*f*r - 16*D1*Dd*f*s**2 + 24*D1*Dd*f*s - 12*D1*Dd*f + 40*D1*Dd*fd*r**2 + 80*D1*Dd*fd*r*s - 30*D1*Dd*fd*r + 40*D1*Dd*fd*s**2 - 30*D1*Dd*fd*s + 20*D1*Ddd*f*r**2 + 40*D1*Ddd*f*r*s - 30*D1*Ddd*f*r + 20*D1*Ddd*f*s**2 - 30*D1*Ddd*f*s + 15*D1*Ddd*f + 2*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 60*Dd**2*f*r**2 + 120*Dd**2*f*r*s - 90*Dd**2*f*r + 60*Dd**2*f*s**2 - 90*Dd**2*f*s + 30*Dd**2*f)))/(210*d**2*k3**3) - 2*D1**2*Pk2*Pkd3*ct**2*st**2*(-D1*(21*D1*bd1**2*f*(r**2*(2*f + 2) + 2*r*(2*K*s + f*(s - 1) + s - 1) + s*(4*K*s - 2*K - f - 1)) + 3*D1*bdd1*f*(r + s)*(7*f*r + f*s*(12*C - 6) + s*(14*b2 - 28*g2)) + bd1*(D1*(-4*f**2*(r + s)*(7*r + s*(18*C - 9)) + 3*f*(fd*(28*r**2 + r*(12*C*(4*s - 1) + 4*s - 15) + s*(12*C*(4*s - 3) - 24*s + 11)) + 14*s*(bd2*(2*r + 2*s - 1) + 4*g2*(r + s) + gd2*(-4*r - 4*s + 2))) - 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 3*Dd*f*(f*(56*r**2 + r*(96*C*s - 12*C + 8*s - 29) + 2*s*(48*C*s - 24*C - 24*s + 5)) - 28*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 42*b2*(D1*(-2*f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 21*b1**2*(D1**2*(r + s - 1)*(f*(fd - fdd)*(2*r - 1) + fd**2*(1 - 2*r) + 2*fd*(2*K*(s - 1) + r) - fdd*(2*K*(s - 1) + r)) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(2*r - 1)*(8*r + 8*s - 7) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) - fd*(2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + 8*r**2 + 8*r*s - 9*r - 2*s + 2)) - Ddd*f*(K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - Dd**2*f*(K*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + f*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 12*r**2 + 12*r*s - 15*r - 6*s + 4)) + b1*(144*C*D1**2*f*fd*r*s - 72*C*D1**2*f*fd*r + 144*C*D1**2*f*fd*s**2 - 216*C*D1**2*f*fd*s + 72*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r*s + 36*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s**2 + 108*C*D1**2*f*fdd*s - 36*C*D1**2*f*fdd - 72*C*D1**2*fd**2*r*s + 36*C*D1**2*fd**2*r - 72*C*D1**2*fd**2*s**2 + 108*C*D1**2*fd**2*s - 36*C*D1**2*fd**2 + 288*C*D1*Dd*f**2*r*s - 72*C*D1*Dd*f**2*r + 288*C*D1*Dd*f**2*s**2 - 288*C*D1*Dd*f**2*s + 72*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r*s + 216*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 720*C*D1*Dd*f*fd*s - 180*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r*s + 36*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 144*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r*s + 108*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 432*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 + 84*D1**2*b2*fd*r*s - 84*D1**2*b2*fd*r + 84*D1**2*b2*fd*s**2 - 168*D1**2*b2*fd*s + 84*D1**2*b2*fd - 42*D1**2*b2*fdd*r*s + 42*D1**2*b2*fdd*r - 42*D1**2*b2*fdd*s**2 + 84*D1**2*b2*fdd*s - 42*D1**2*b2*fdd + 84*D1**2*bd2*f*r*s + 84*D1**2*bd2*f*s**2 - 84*D1**2*bd2*f*s - 84*D1**2*bd2*fd*r*s + 42*D1**2*bd2*fd*r - 84*D1**2*bd2*fd*s**2 + 126*D1**2*bd2*fd*s - 42*D1**2*bd2*fd - 21*D1**2*bdd1*f*(4*K*s**2 - 2*K*s + f*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*r**2 + 2*r*(2*K*s + s - 1) - s + 1) - 42*D1**2*bdd2*f*r*s - 42*D1**2*bdd2*f*s**2 + 42*D1**2*bdd2*f*s + 56*D1**2*f*fd*r**2 - 16*D1**2*f*fd*r*s - 48*D1**2*f*fd*r - 72*D1**2*f*fd*s**2 + 80*D1**2*f*fd*s - 8*D1**2*f*fd - 42*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s + 45*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 33*D1**2*f*fdd*s - 3*D1**2*f*fdd - 168*D1**2*f*gd2*r*s - 168*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s + 84*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s - 42*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 45*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 33*D1**2*fd**2*s - 3*D1**2*fd**2 - 168*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*r - 168*D1**2*fd*g2*s**2 + 336*D1**2*fd*g2*s - 168*D1**2*fd*g2 + 168*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 252*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 + 84*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r + 84*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 + 336*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 336*D1*Dd*b2*f*s**2 - 336*D1*Dd*b2*f*s + 84*D1*Dd*b2*f - 336*D1*Dd*b2*fd*r*s + 210*D1*Dd*b2*fd*r - 336*D1*Dd*b2*fd*s**2 + 504*D1*Dd*b2*fd*s - 168*D1*Dd*b2*fd - 336*D1*Dd*bd2*f*r*s + 42*D1*Dd*bd2*f*r - 336*D1*Dd*bd2*f*s**2 + 336*D1*Dd*bd2*f*s - 42*D1*Dd*bd2*f + 112*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s - 104*D1*Dd*f**2*r - 144*D1*Dd*f**2*s**2 + 88*D1*Dd*f**2*s + 20*D1*Dd*f**2 - 336*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s + 354*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s**2 - 192*D1*Dd*f*fd*s - 57*D1*Dd*f*fd - 672*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 672*D1*Dd*f*g2*s**2 + 672*D1*Dd*f*g2*s - 168*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r*s - 84*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 672*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r*s - 420*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 1008*D1*Dd*fd*g2*s + 336*D1*Dd*fd*g2 - 168*D1*Ddd*b2*f*r*s + 42*D1*Ddd*b2*f*r - 168*D1*Ddd*b2*f*s**2 + 168*D1*Ddd*b2*f*s - 42*D1*Ddd*b2*f - 84*D1*Ddd*f**2*r**2 - 12*D1*Ddd*f**2*r*s + 87*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s - 24*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 336*D1*Ddd*f*g2*s + 84*D1*Ddd*f*g2 + 21*D1*bd1*(D1*(f**2*(2*r**2 + 2*r*(s - 1) - s + 1) + f*(8*K*s**2 - 4*K*s - fd*(2*r - 1)*(4*r + 4*s - 3) + 4*r**2 + 4*r*(2*K*s + s - 1) - 2*s + 2) + fd*(-2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r**2 - 4*r*(s - 1) + s - 1)) - Dd*f*(K*(32*r*s - 4*r + 32*s**2 - 24*s + 2) + f*(2*r - 1)*(8*r + 8*s - 5) + (2*r - 1)*(8*r + 8*s - 5))) - 504*Dd**2*b2*f*r*s + 126*Dd**2*b2*f*r - 504*Dd**2*b2*f*s**2 + 504*Dd**2*b2*f*s - 84*Dd**2*b2*f - 252*Dd**2*f**2*r**2 - 36*Dd**2*f**2*r*s + 261*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s - 48*Dd**2*f**2 + 1008*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1008*Dd**2*f*g2*s + 168*Dd**2*f*g2))/(105*d**2*k3) + D1**2*Pk2*Pkd3*ct**2*(D1*(-14*D1*bd1**2*f*(5*K*s*(5*s - 3) + r**2*(5*K - 14) + r*(5*K*(6*s - 1) - 14*s + 7)) - 5*D1*bdd1*f*(r + s)*(7*b2*(r + 5*s) + f*(6*C - 3)*(3*r + 7*s) - 14*g2*(r + 5*s)) + bd1*(54*C*D1*f**2*r**2 + 348*C*D1*f**2*r*s + 294*C*D1*f**2*s**2 - 360*C*D1*f*fd*r**2 - 1200*C*D1*f*fd*r*s + 480*C*D1*f*fd*r - 840*C*D1*f*fd*s**2 + 720*C*D1*f*fd*s - 720*C*Dd*f**2*r**2 - 2400*C*Dd*f**2*r*s + 660*C*Dd*f**2*r - 1680*C*Dd*f**2*s**2 + 1020*C*Dd*f**2*s - 70*D1*bd2*f*(r**2 + r*(6*s - 1) + s*(5*s - 3)) + 15*D1*f**2*r**2 - 132*D1*f**2*r*s - 147*D1*f**2*s**2 + 180*D1*f*fd*r**2 + 600*D1*f*fd*r*s - 240*D1*f*fd*r + 420*D1*f*fd*s**2 - 360*D1*f*fd*s + 70*D1*f*g2*r**2 - 420*D1*f*g2*r*s - 490*D1*f*g2*s**2 + 140*D1*f*gd2*r**2 + 840*D1*f*gd2*r*s - 140*D1*f*gd2*r + 700*D1*f*gd2*s**2 - 420*D1*f*gd2*s + 140*D1*fd*g2*r**2 + 840*D1*fd*g2*r*s - 420*D1*fd*g2*r + 700*D1*fd*g2*s**2 - 700*D1*fd*g2*s + 360*Dd*f**2*r**2 + 1200*Dd*f**2*r*s - 330*Dd*f**2*r + 840*Dd*f**2*s**2 - 510*Dd*f**2*s + 560*Dd*f*g2*r**2 + 3360*Dd*f*g2*r*s - 700*Dd*f*g2*r + 2800*Dd*f*g2*s**2 - 1540*Dd*f*g2*s - 35*b2*(D1*(f*(r**2 - 6*r*s - 7*s**2) + 2*fd*(r**2 + r*(6*s - 3) + s*(5*s - 5))) + 2*Dd*f*(4*r**2 + r*(24*s - 5) + s*(20*s - 11))))) - 70*b1**3*(D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 13*r + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) - Ddd*(f + 1)*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - Dd**2*(f + 1)*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) - 7*b1**2*(5*D1**2*K*fd*r**2 - 30*D1**2*K*fd*r*s + 30*D1**2*K*fd*r - 35*D1**2*K*fd*s**2 + 70*D1**2*K*fd*s - 35*D1**2*K*fd + 5*D1**2*K*fdd*r**2 + 30*D1**2*K*fdd*r*s - 30*D1**2*K*fdd*r + 25*D1**2*K*fdd*s**2 - 50*D1**2*K*fdd*s + 25*D1**2*K*fdd - 10*D1**2*bdd1*(f + 1)*(3*r**2 + 3*r*(s - 1) - s + 1) + 18*D1**2*fd*r**2 + 18*D1**2*fd*r*s - 46*D1**2*fd*r - 28*D1**2*fd*s + 28*D1**2*fd - 14*D1**2*fdd*r**2 - 14*D1**2*fdd*r*s + 28*D1**2*fdd*r + 14*D1**2*fdd*s - 14*D1**2*fdd + 20*D1*Dd*K*f*r**2 - 120*D1*Dd*K*f*r*s + 10*D1*Dd*K*f*r - 140*D1*Dd*K*f*s**2 + 130*D1*Dd*K*f*s - 25*D1*Dd*K*f + 40*D1*Dd*K*fd*r**2 + 240*D1*Dd*K*fd*r*s - 170*D1*Dd*K*fd*r + 200*D1*Dd*K*fd*s**2 - 310*D1*Dd*K*fd*s + 110*D1*Dd*K*fd + 72*D1*Dd*f*r**2 + 72*D1*Dd*f*r*s - 90*D1*Dd*f*r - 36*D1*Dd*f*s + 36*D1*Dd*f - 112*D1*Dd*fd*r**2 - 112*D1*Dd*fd*r*s + 182*D1*Dd*fd*r + 84*D1*Dd*fd*s - 70*D1*Dd*fd + 20*D1*Ddd*K*f*r**2 + 120*D1*Ddd*K*f*r*s - 50*D1*Ddd*K*f*r + 100*D1*Ddd*K*f*s**2 - 110*D1*Ddd*K*f*s + 35*D1*Ddd*K*f - 56*D1*Ddd*f*r**2 - 56*D1*Ddd*f*r*s + 70*D1*Ddd*f*r + 28*D1*Ddd*f*s - 28*D1*Ddd*f + 10*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 - 6*r*s + 9*r + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) - Dd*(f + 1)*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) + 60*Dd**2*K*f*r**2 + 360*Dd**2*K*f*r*s - 150*Dd**2*K*f*r + 300*Dd**2*K*f*s**2 - 330*Dd**2*K*f*s + 70*Dd**2*K*f - 168*Dd**2*f*r**2 - 168*Dd**2*f*r*s + 210*Dd**2*f*r + 84*Dd**2*f*s - 56*Dd**2*f) + b1*(108*C*D1**2*f*fd*r**2 + 696*C*D1**2*f*fd*r*s - 456*C*D1**2*f*fd*r + 588*C*D1**2*f*fd*s**2 - 936*C*D1**2*f*fd*s + 348*C*D1**2*f*fd - 180*C*D1**2*f*fdd*r**2 - 600*C*D1**2*f*fdd*r*s + 480*C*D1**2*f*fdd*r - 420*C*D1**2*f*fdd*s**2 + 720*C*D1**2*f*fdd*s - 300*C*D1**2*f*fdd - 180*C*D1**2*fd**2*r**2 - 600*C*D1**2*fd**2*r*s + 480*C*D1**2*fd**2*r - 420*C*D1**2*fd**2*s**2 + 720*C*D1**2*fd**2*s - 300*C*D1**2*fd**2 + 216*C*D1*Dd*f**2*r**2 + 1392*C*D1*Dd*f**2*r*s - 564*C*D1*Dd*f**2*r + 1176*C*D1*Dd*f**2*s**2 - 1284*C*D1*Dd*f**2*s + 402*C*D1*Dd*f**2 - 1440*C*D1*Dd*f*fd*r**2 - 4800*C*D1*Dd*f*fd*r*s + 3240*C*D1*Dd*f*fd*r - 3360*C*D1*Dd*f*fd*s**2 + 4920*C*D1*Dd*f*fd*s - 1680*C*D1*Dd*f*fd - 360*C*D1*Ddd*f**2*r**2 - 1200*C*D1*Ddd*f**2*r*s + 660*C*D1*Ddd*f**2*r - 840*C*D1*Ddd*f**2*s**2 + 1020*C*D1*Ddd*f**2*s - 390*C*D1*Ddd*f**2 - 1080*C*Dd**2*f**2*r**2 - 3600*C*Dd**2*f**2*r*s + 1980*C*Dd**2*f**2*r - 2520*C*Dd**2*f**2*s**2 + 3060*C*Dd**2*f**2*s - 780*C*Dd**2*f**2 - 70*D1**2*K*bdd1*f*r**2 - 420*D1**2*K*bdd1*f*r*s + 70*D1**2*K*bdd1*f*r - 350*D1**2*K*bdd1*f*s**2 + 210*D1**2*K*bdd1*f*s - 35*D1**2*K*bdd1*f - 35*D1**2*b2*fd*r**2 + 210*D1**2*b2*fd*r*s - 210*D1**2*b2*fd*r + 245*D1**2*b2*fd*s**2 - 490*D1**2*b2*fd*s + 245*D1**2*b2*fd - 35*D1**2*b2*fdd*r**2 - 210*D1**2*b2*fdd*r*s + 210*D1**2*b2*fdd*r - 175*D1**2*b2*fdd*s**2 + 350*D1**2*b2*fdd*s - 175*D1**2*b2*fdd + 70*D1**2*bd1**2*(f + 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 196*D1**2*bdd1*f*r**2 + 196*D1**2*bdd1*f*r*s - 98*D1**2*bdd1*f*r - 35*D1**2*bdd2*f*r**2 - 210*D1**2*bdd2*f*r*s + 70*D1**2*bdd2*f*r - 175*D1**2*bdd2*f*s**2 + 210*D1**2*bdd2*f*s - 35*D1**2*bdd2*f + 30*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r*s + 102*D1**2*f*fd*r - 294*D1**2*f*fd*s**2 + 426*D1**2*f*fd*s - 132*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 300*D1**2*f*fdd*r*s - 240*D1**2*f*fdd*r + 210*D1**2*f*fdd*s**2 - 360*D1**2*f*fdd*s + 150*D1**2*f*fdd + 70*D1**2*f*gd2*r**2 - 420*D1**2*f*gd2*r*s - 140*D1**2*f*gd2*r - 490*D1**2*f*gd2*s**2 + 420*D1**2*f*gd2*s + 70*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 420*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*r + 350*D1**2*f*gdd2*s**2 - 420*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 + 90*D1**2*fd**2*r**2 + 300*D1**2*fd**2*r*s - 240*D1**2*fd**2*r + 210*D1**2*fd**2*s**2 - 360*D1**2*fd**2*s + 150*D1**2*fd**2 + 70*D1**2*fd*g2*r**2 - 420*D1**2*fd*g2*r*s + 420*D1**2*fd*g2*r - 490*D1**2*fd*g2*s**2 + 980*D1**2*fd*g2*s - 490*D1**2*fd*g2 + 140*D1**2*fd*gd2*r**2 + 840*D1**2*fd*gd2*r*s - 560*D1**2*fd*gd2*r + 700*D1**2*fd*gd2*s**2 - 1120*D1**2*fd*gd2*s + 420*D1**2*fd*gd2 + 70*D1**2*fdd*g2*r**2 + 420*D1**2*fdd*g2*r*s - 420*D1**2*fdd*g2*r + 350*D1**2*fdd*g2*s**2 - 700*D1**2*fdd*g2*s + 350*D1**2*fdd*g2 - 140*D1*Dd*b2*f*r**2 + 840*D1*Dd*b2*f*r*s - 70*D1*Dd*b2*f*r + 980*D1*Dd*b2*f*s**2 - 910*D1*Dd*b2*f*s + 175*D1*Dd*b2*f - 280*D1*Dd*b2*fd*r**2 - 1680*D1*Dd*b2*fd*r*s + 1190*D1*Dd*b2*fd*r - 1400*D1*Dd*b2*fd*s**2 + 2170*D1*Dd*b2*fd*s - 770*D1*Dd*b2*fd + 60*D1*Dd*f**2*r**2 - 528*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 588*D1*Dd*f**2*s**2 + 558*D1*Dd*f**2*s - 117*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 2400*D1*Dd*f*fd*r*s - 1620*D1*Dd*f*fd*r + 1680*D1*Dd*f*fd*s**2 - 2460*D1*Dd*f*fd*s + 840*D1*Dd*f*fd + 280*D1*Dd*f*g2*r**2 - 1680*D1*Dd*f*g2*r*s + 140*D1*Dd*f*g2*r - 1960*D1*Dd*f*g2*s**2 + 1820*D1*Dd*f*g2*s - 350*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 3360*D1*Dd*f*gd2*r*s - 1260*D1*Dd*f*gd2*r + 2800*D1*Dd*f*gd2*s**2 - 3220*D1*Dd*f*gd2*s + 700*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 3360*D1*Dd*fd*g2*r*s - 2380*D1*Dd*fd*g2*r + 2800*D1*Dd*fd*g2*s**2 - 4340*D1*Dd*fd*g2*s + 1540*D1*Dd*fd*g2 - 140*D1*Ddd*b2*f*r**2 - 840*D1*Ddd*b2*f*r*s + 350*D1*Ddd*b2*f*r - 700*D1*Ddd*b2*f*s**2 + 770*D1*Ddd*b2*f*s - 245*D1*Ddd*b2*f + 180*D1*Ddd*f**2*r**2 + 600*D1*Ddd*f**2*r*s - 330*D1*Ddd*f**2*r + 420*D1*Ddd*f**2*s**2 - 510*D1*Ddd*f**2*s + 195*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 1680*D1*Ddd*f*g2*r*s - 700*D1*Ddd*f*g2*r + 1400*D1*Ddd*f*g2*s**2 - 1540*D1*Ddd*f*g2*s + 490*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(5*K*f*(2*r**2 - 2*r*(6*s + 1) - 14*s**2 + 6*s + 1) + 10*K*fd*(2*r**2 + r*(12*s - 7) + 10*s**2 - 13*s + 3) + 2*f*(18*r**2 + 18*r*s - 4*r + 5*s - 5) - 14*fd*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + 2*Dd*f*(5*K*(8*r**2 + 48*r*s - 14*r + 40*s**2 - 34*s + 5) - 112*r**2 - 112*r*s + 98*r + 28*s - 14)) - 35*D1*bd2*(D1*(f*(r - 7*s - 1) + 2*fd*(r + 5*s - 3))*(r + s - 1) + 2*Dd*f*(4*r**2 + 3*r*(8*s - 3) + 20*s**2 - 23*s + 5)) - 420*Dd**2*b2*f*r**2 - 2520*Dd**2*b2*f*r*s + 1050*Dd**2*b2*f*r - 2100*Dd**2*b2*f*s**2 + 2310*Dd**2*b2*f*s - 490*Dd**2*b2*f + 540*Dd**2*f**2*r**2 + 1800*Dd**2*f**2*r*s - 990*Dd**2*f**2*r + 1260*Dd**2*f**2*s**2 - 1530*Dd**2*f**2*s + 390*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 5040*Dd**2*f*g2*r*s - 2100*Dd**2*f*g2*r + 4200*Dd**2*f*g2*s**2 - 4620*Dd**2*f*g2*s + 980*Dd**2*f*g2))/(210*d**2*k3) + 3*D1**2*Pk2*Pkd3*ct*f**2*k1**7*st**2*(D1**2*(f*(3*fd - 7*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 42*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 14*fd*(4*r + 4*s - 3)**2) - 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 42*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(154*d**2*k2*k3**7) + 3*D1**2*Pk2*Pkd3*ct*f**2*k1**5*k2*st**4*(D1**2*(f*(269*fd - 250*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 1500*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(269*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 500*fd*(4*r + 4*s - 3)**2) - 250*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 1500*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(770*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct*f**2*k1**5*st**4*(D1**2*(f*(167*fd - 100*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 100*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(167*f*(r*(4*s - 1) + (1 - 2*s)**2) - 200*fd*(4*s - 1)*(4*r + 4*s - 3)) - 100*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 100*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1155*d**2*k2*k3**5) + D1**2*Pk2*Pkd3*ct*f**2*k1**3*k2**3*st**6*(D1**2*(f*(188*fd - 105*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 630*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(2*Dd*(94*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 105*fd*(4*r + 4*s - 3)**2) - 105*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 630*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(154*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct*f**2*k1**3*k2*st**6*(D1**2*(f*(157*fd - 84*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 84*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(157*f*(r*(4*s - 1) + (1 - 2*s)**2) - 168*fd*(4*s - 1)*(4*r + 4*s - 3)) - 84*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 84*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(693*d**2*k3**5) + D1**2*Pk2*Pkd3*ct*f*k1**7*(-7*D1**2*bdd1*f**2*(r + s - 1)**2 + D1*bd1*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 14*D1*fd*(3*r + 3*s - 2) - 14*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 14*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 42*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(14*d**2*k2*k3**7) - D1**2*Pk2*Pkd3*ct*f*k2**5*st**4*(8*C - 4)*(D1**2*(f*(4*fd - 5*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 5*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(4*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 5*fd*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) - 5*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 5*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4))/(105*d**2*k1*k3**5) + D1**2*Pk2*Pkd3*ct*f*k2**3*st**4*(8*C - 4)*(D1**2*(f*(4*fd - 5*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 5*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(4*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 5*fd*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) - 5*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 5*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4))/(105*d**2*k1*k3**3) + D1**2*Pk2*Pkd3*ct*k1**5*k2*st**2*(12*C*D1**2*f**2*fd*r**2 + 24*C*D1**2*f**2*fd*r*s - 16*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 16*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 60*C*D1**2*f**2*fdd*r**2 - 120*C*D1**2*f**2*fdd*r*s + 80*C*D1**2*f**2*fdd*r - 60*C*D1**2*f**2*fdd*s**2 + 80*C*D1**2*f**2*fdd*s - 40*C*D1**2*f**2*fdd - 120*C*D1**2*f*fd**2*r**2 - 240*C*D1**2*f*fd**2*r*s + 160*C*D1**2*f*fd**2*r - 120*C*D1**2*f*fd**2*s**2 + 160*C*D1**2*f*fd**2*s - 40*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r**2 + 32*C*D1*Dd*f**3*r*s - 24*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 12*C*D1*Dd*f**3 - 480*C*D1*Dd*f**2*fd*r**2 - 960*C*D1*Dd*f**2*fd*r*s + 680*C*D1*Dd*f**2*fd*r - 480*C*D1*Dd*f**2*fd*s**2 + 680*C*D1*Dd*f**2*fd*s - 240*C*D1*Dd*f**2*fd - 80*C*D1*Ddd*f**3*r**2 - 160*C*D1*Ddd*f**3*r*s + 120*C*D1*Ddd*f**3*r - 80*C*D1*Ddd*f**3*s**2 + 120*C*D1*Ddd*f**3*s - 60*C*D1*Ddd*f**3 - 240*C*Dd**2*f**3*r**2 - 480*C*Dd**2*f**3*r*s + 360*C*Dd**2*f**3*r - 240*C*Dd**2*f**3*s**2 + 360*C*Dd**2*f**3*s - 120*C*Dd**2*f**3 - 12*D1**2*K*b1*f*fd*r**2 - 24*D1**2*K*b1*f*fd*r*s + 12*D1**2*K*b1*f*fd*r - 12*D1**2*K*b1*f*fd*s**2 + 12*D1**2*K*b1*f*fd*s - 6*D1**2*K*b1*f*fd - 36*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*r*s + 36*D1**2*K*b1*f*fdd*r - 36*D1**2*K*b1*f*fdd*s**2 + 36*D1**2*K*b1*f*fdd*s - 18*D1**2*K*b1*f*fdd - 36*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*r*s + 36*D1**2*K*b1*fd**2*r - 36*D1**2*K*b1*fd**2*s**2 + 36*D1**2*K*b1*fd**2*s + 342*D1**2*b1*f**2*fd*r**2 + 684*D1**2*b1*f**2*fd*r*s - 456*D1**2*b1*f**2*fd*r + 342*D1**2*b1*f**2*fd*s**2 - 456*D1**2*b1*f**2*fd*s + 228*D1**2*b1*f**2*fd - 225*D1**2*b1*f**2*fdd*r**2 - 450*D1**2*b1*f**2*fdd*r*s + 300*D1**2*b1*f**2*fdd*r - 225*D1**2*b1*f**2*fdd*s**2 + 300*D1**2*b1*f**2*fdd*s - 150*D1**2*b1*f**2*fdd - 450*D1**2*b1*f*fd**2*r**2 - 900*D1**2*b1*f*fd**2*r*s + 600*D1**2*b1*f*fd**2*r - 450*D1**2*b1*f*fd**2*s**2 + 600*D1**2*b1*f*fd**2*s - 150*D1**2*b1*f*fd**2 + 6*D1**2*b1*f*fd*r**2 + 12*D1**2*b1*f*fd*r*s - 6*D1**2*b1*f*fd*r + 6*D1**2*b1*f*fd*s**2 - 6*D1**2*b1*f*fd*s + 3*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(6*K + 25*f - 3)*(r + s - 1)**2 - 60*D1**2*f**3*fd*r**2 - 120*D1**2*f**3*fd*r*s + 90*D1**2*f**3*fd*r - 60*D1**2*f**3*fd*s**2 + 90*D1**2*f**3*fd*s - 45*D1**2*f**3*fd - 9*D1**2*f**2*fd*r**2 - 18*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 9*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 45*D1**2*f**2*fdd*r**2 + 90*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 60*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 12*D1**2*f**2*gd2*r**2 + 24*D1**2*f**2*gd2*r*s - 24*D1**2*f**2*gd2*r + 12*D1**2*f**2*gd2*s**2 - 24*D1**2*f**2*gd2*s + 12*D1**2*f**2*gd2 + 36*D1**2*f**2*gdd2*r**2 + 72*D1**2*f**2*gdd2*r*s - 72*D1**2*f**2*gdd2*r + 36*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2*s + 36*D1**2*f**2*gdd2 + 90*D1**2*f*fd**2*r**2 + 180*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 120*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 + 24*D1**2*f*fd*g2*r**2 + 48*D1**2*f*fd*g2*r*s - 24*D1**2*f*fd*g2*r + 24*D1**2*f*fd*g2*s**2 - 24*D1**2*f*fd*g2*s + 12*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r*s - 216*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 216*D1**2*f*fd*gd2*s + 72*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*r*s - 72*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*r*s - 72*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 24*D1*Dd*K*b1*f**2*r**2 - 48*D1*Dd*K*b1*f**2*r*s + 36*D1*Dd*K*b1*f**2*r - 24*D1*Dd*K*b1*f**2*s**2 + 36*D1*Dd*K*b1*f**2*s - 18*D1*Dd*K*b1*f**2 - 288*D1*Dd*K*b1*f*fd*r**2 - 576*D1*Dd*K*b1*f*fd*r*s + 360*D1*Dd*K*b1*f*fd*r - 288*D1*Dd*K*b1*f*fd*s**2 + 360*D1*Dd*K*b1*f*fd*s - 108*D1*Dd*K*b1*f*fd + 456*D1*Dd*b1*f**3*r**2 + 912*D1*Dd*b1*f**3*r*s - 684*D1*Dd*b1*f**3*r + 456*D1*Dd*b1*f**3*s**2 - 684*D1*Dd*b1*f**3*s + 342*D1*Dd*b1*f**3 - 1800*D1*Dd*b1*f**2*fd*r**2 - 3600*D1*Dd*b1*f**2*fd*r*s + 2550*D1*Dd*b1*f**2*fd*r - 1800*D1*Dd*b1*f**2*fd*s**2 + 2550*D1*Dd*b1*f**2*fd*s - 900*D1*Dd*b1*f**2*fd + 12*D1*Dd*b1*f**2*r**2 + 24*D1*Dd*b1*f**2*r*s - 18*D1*Dd*b1*f**2*r + 12*D1*Dd*b1*f**2*s**2 - 18*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 60*D1*Dd*f**4*r**2 - 120*D1*Dd*f**4*r*s + 90*D1*Dd*f**4*r - 60*D1*Dd*f**4*s**2 + 90*D1*Dd*f**4*s - 45*D1*Dd*f**4 - 12*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 + 18*D1*Dd*f**3*s - 9*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*r**2 + 720*D1*Dd*f**2*fd*r*s - 510*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 510*D1*Dd*f**2*fd*s + 180*D1*Dd*f**2*fd + 48*D1*Dd*f**2*g2*r**2 + 96*D1*Dd*f**2*g2*r*s - 72*D1*Dd*f**2*g2*r + 48*D1*Dd*f**2*g2*s**2 - 72*D1*Dd*f**2*g2*s + 36*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r**2 + 576*D1*Dd*f**2*gd2*r*s - 504*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 504*D1*Dd*f**2*gd2*s + 216*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r**2 + 1152*D1*Dd*f*fd*g2*r*s - 720*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 720*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 - 72*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r*s + 108*D1*Ddd*K*b1*f**2*r - 72*D1*Ddd*K*b1*f**2*s**2 + 108*D1*Ddd*K*b1*f**2*s - 54*D1*Ddd*K*b1*f**2 - 300*D1*Ddd*b1*f**3*r**2 - 600*D1*Ddd*b1*f**3*r*s + 450*D1*Ddd*b1*f**3*r - 300*D1*Ddd*b1*f**3*s**2 + 450*D1*Ddd*b1*f**3*s - 225*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 60*D1*Ddd*f**3*r**2 + 120*D1*Ddd*f**3*r*s - 90*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 90*D1*Ddd*f**3*s + 45*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r*s - 216*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 216*D1*Ddd*f**2*g2*s + 108*D1*Ddd*f**2*g2 + 3*D1*bd1*f*(D1*(38*f**2*(r + s - 1) - 50*f*fd*(3*r + 3*s - 2) - f*(2*K - 1)*(r + s - 1) - 6*fd*(2*K - 1)*(2*r + 2*s - 1)) - 2*Dd*f*(6*K + 25*f - 3)*(4*r + 4*s - 3))*(r + s - 1) - 216*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r*s + 324*Dd**2*K*b1*f**2*r - 216*Dd**2*K*b1*f**2*s**2 + 324*Dd**2*K*b1*f**2*s - 108*Dd**2*K*b1*f**2 - 900*Dd**2*b1*f**3*r**2 - 1800*Dd**2*b1*f**3*r*s + 1350*Dd**2*b1*f**3*r - 900*Dd**2*b1*f**3*s**2 + 1350*Dd**2*b1*f**3*s - 450*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 180*Dd**2*f**3*r**2 + 360*Dd**2*f**3*r*s - 270*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 270*Dd**2*f**3*s + 90*Dd**2*f**3 + 432*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r*s - 648*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 648*Dd**2*f**2*g2*s + 216*Dd**2*f**2*g2)/(70*d**2*k3**7) - 3*D1**2*Pk2*Pkd3*ct*k1**5*k2*(-D1*(r + s - 1)*(6*D1*bd1**2*f*(-14*K + 25*f + 7)*(r + s - 1) - 3*D1*bdd1*f*(f*(20*C - 15) - 28*g2)*(r + s - 1) + bd1*(D1*(-15*f**3*(r + s - 1) + f**2*(36*C - 27)*(r + s - 1) - f*fd*(120*C - 90)*(2*r + 2*s - 1) - 28*f*(g2 - 6*gd2)*(r + s - 1) + 168*fd*g2*(r + s)) - 6*Dd*f*(f*(20*C - 15) - 28*g2)*(4*r + 4*s - 3))) + b1**2*(D1**2*(15*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 7*fd*(2*K - 1)*(r + s) - 21*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(45*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(150*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-14*K + 25*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-14*K + 25*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-72*C*D1**2*f*fd*r**2 - 144*C*D1**2*f*fd*r*s + 72*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s - 36*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 144*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 216*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 216*C*D1*Dd*f**2*s - 108*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 1200*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1200*C*D1*Dd*f*fd*s + 360*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 360*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(-14*K + 25*f + 7)*(r + s - 1)**2 + 45*D1**2*f**2*fd*r**2 + 90*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s**2 - 60*D1**2*f**2*fd*s + 30*D1**2*f**2*fd + 54*D1**2*f*fd*r**2 + 108*D1**2*f*fd*r*s - 54*D1**2*f*fd*r + 54*D1**2*f*fd*s**2 - 54*D1**2*f*fd*s + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 45*D1**2*f*fdd + 28*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r + 28*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s + 28*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 28*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 + 60*D1*Dd*f**3*r**2 + 120*D1*Dd*f**3*r*s - 90*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 90*D1*Dd*f**3*s + 45*D1*Dd*f**3 + 108*D1*Dd*f**2*r**2 + 216*D1*Dd*f**2*r*s - 162*D1*Dd*f**2*r + 108*D1*Dd*f**2*s**2 - 162*D1*Dd*f**2*s + 81*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 900*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 270*D1*Dd*f*fd + 112*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 112*D1*Dd*f*g2*s**2 - 168*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s - 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(45*f**2*(r + s - 1) - 150*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 42*fd*(2*K - 1)*(r + s)) - 6*Dd*f*(-14*K + 25*f + 7)*(4*r + 4*s - 3))*(r + s - 1) - 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 270*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(70*d**2*k3**7) + D1**2*Pk2*Pkd3*ct*k1**5*st**2*(-24*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 24*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 8*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r*s - 40*C*D1**2*f**2*fdd*r + 120*C*D1**2*f**2*fdd*s**2 - 120*C*D1**2*f**2*fdd*s + 40*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r*s - 80*C*D1**2*f*fd**2*r + 240*C*D1**2*f*fd**2*s**2 - 240*C*D1**2*f*fd**2*s + 40*C*D1**2*f*fd**2 - 32*C*D1*Dd*f**3*r*s + 8*C*D1*Dd*f**3*r - 32*C*D1*Dd*f**3*s**2 + 32*C*D1*Dd*f**3*s - 8*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r*s - 280*C*D1*Dd*f**2*fd*r + 960*C*D1*Dd*f**2*fd*s**2 - 960*C*D1*Dd*f**2*fd*s + 200*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r*s - 40*C*D1*Ddd*f**3*r + 160*C*D1*Ddd*f**3*s**2 - 160*C*D1*Ddd*f**3*s + 40*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r*s - 120*C*Dd**2*f**3*r + 480*C*Dd**2*f**3*s**2 - 480*C*Dd**2*f**3*s + 80*C*Dd**2*f**3 + 24*D1**2*K*b1*f*fd*r*s - 12*D1**2*K*b1*f*fd*r + 24*D1**2*K*b1*f*fd*s**2 - 24*D1**2*K*b1*f*fd*s + 12*D1**2*K*b1*f*fd + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 72*D1**2*K*b1*f*fdd*s**2 - 72*D1**2*K*b1*f*fdd*s + 36*D1**2*K*b1*f*fdd + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 72*D1**2*K*b1*fd**2*s**2 - 72*D1**2*K*b1*fd**2*s + 90*D1**2*b1*f**2*fd*r**2 + 1044*D1**2*b1*f**2*fd*r*s - 66*D1**2*b1*f**2*fd*r + 954*D1**2*b1*f**2*fd*s**2 - 642*D1**2*b1*f**2*fd*s - 9*D1**2*b1*f**2*fd - 450*D1**2*b1*f**2*fdd*r**2 - 1440*D1**2*b1*f**2*fdd*r*s + 690*D1**2*b1*f**2*fdd*r - 990*D1**2*b1*f**2*fdd*s**2 + 1050*D1**2*b1*f**2*fdd*s - 315*D1**2*b1*f**2*fdd - 900*D1**2*b1*f*fd**2*r**2 - 2880*D1**2*b1*f*fd**2*r*s + 1380*D1**2*b1*f*fd**2*r - 1980*D1**2*b1*f*fd**2*s**2 + 2100*D1**2*b1*f*fd**2*s - 540*D1**2*b1*f*fd**2 - 30*D1**2*b1*f*fd*r**2 - 84*D1**2*b1*f*fd*r*s + 42*D1**2*b1*f*fd*r - 54*D1**2*b1*f*fd*s**2 + 54*D1**2*b1*f*fd*s - 27*D1**2*b1*f*fd - 90*D1**2*b1*f*fdd*r**2 - 252*D1**2*b1*f*fdd*r*s + 126*D1**2*b1*f*fdd*r - 162*D1**2*b1*f*fdd*s**2 + 162*D1**2*b1*f*fdd*s - 81*D1**2*b1*f*fdd - 90*D1**2*b1*fd**2*r**2 - 252*D1**2*b1*fd**2*r*s + 126*D1**2*b1*fd**2*r - 162*D1**2*b1*fd**2*s**2 + 162*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(5*f*(10*r**2 + r*(32*s - 26) + 22*s**2 - 38*s + 21) + (3*r + 3*s - 3)*(-4*K*s + 5*r + 9*s - 5)) - 540*D1**2*f**3*fd*r**2 - 2760*D1**2*f**3*fd*r*s + 1230*D1**2*f**3*fd*r - 2220*D1**2*f**3*fd*s**2 + 2490*D1**2*f**3*fd*s - 825*D1**2*f**3*fd + 660*D1**2*f**3*fdd*r**2 + 2520*D1**2*f**3*fdd*r*s - 1290*D1**2*f**3*fdd*r + 1860*D1**2*f**3*fdd*s**2 - 2190*D1**2*f**3*fdd*s + 795*D1**2*f**3*fdd + 1980*D1**2*f**2*fd**2*r**2 + 7560*D1**2*f**2*fd**2*r*s - 3870*D1**2*f**2*fd**2*r + 5580*D1**2*f**2*fd**2*s**2 - 6570*D1**2*f**2*fd**2*s + 1590*D1**2*f**2*fd**2 + 15*D1**2*f**2*fd*r**2 + 54*D1**2*f**2*fd*r*s - 28*D1**2*f**2*fd*r + 39*D1**2*f**2*fd*s**2 - 44*D1**2*f**2*fd*s + 18*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 270*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 195*D1**2*f**2*fdd*s**2 + 220*D1**2*f**2*fdd*s - 90*D1**2*f**2*fdd - 24*D1**2*f**2*gd2*r*s - 24*D1**2*f**2*gd2*s**2 + 24*D1**2*f**2*gd2*s - 72*D1**2*f**2*gdd2*r*s - 72*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 150*D1**2*f*fd**2*r**2 - 540*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 390*D1**2*f*fd**2*s**2 + 440*D1**2*f*fd**2*s - 90*D1**2*f*fd**2 - 48*D1**2*f*fd*g2*r*s + 24*D1**2*f*fd*g2*r - 48*D1**2*f*fd*g2*s**2 + 48*D1**2*f*fd*g2*s - 24*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r*s + 72*D1**2*f*fd*gd2*r - 288*D1**2*f*fd*gd2*s**2 + 288*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 144*D1**2*f*fdd*g2*s**2 + 144*D1**2*f*fdd*g2*s - 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 144*D1**2*fd**2*g2*s**2 + 144*D1**2*fd**2*g2*s + 48*D1*Dd*K*b1*f**2*r*s - 12*D1*Dd*K*b1*f**2*r + 48*D1*Dd*K*b1*f**2*s**2 - 48*D1*Dd*K*b1*f**2*s + 12*D1*Dd*K*b1*f**2 + 576*D1*Dd*K*b1*f*fd*r*s - 216*D1*Dd*K*b1*f*fd*r + 576*D1*Dd*K*b1*f*fd*s**2 - 576*D1*Dd*K*b1*f*fd*s + 144*D1*Dd*K*b1*f*fd + 120*D1*Dd*b1*f**3*r**2 + 1392*D1*Dd*b1*f**3*r*s - 468*D1*Dd*b1*f**3*r + 1272*D1*Dd*b1*f**3*s**2 - 1332*D1*Dd*b1*f**3*s + 378*D1*Dd*b1*f**3 - 3600*D1*Dd*b1*f**2*fd*r**2 - 11520*D1*Dd*b1*f**2*fd*r*s + 6000*D1*Dd*b1*f**2*fd*r - 7920*D1*Dd*b1*f**2*fd*s**2 + 9060*D1*Dd*b1*f**2*fd*s - 2430*D1*Dd*b1*f**2*fd - 60*D1*Dd*b1*f**2*r**2 - 168*D1*Dd*b1*f**2*r*s + 102*D1*Dd*b1*f**2*r - 108*D1*Dd*b1*f**2*s**2 + 138*D1*Dd*b1*f**2*s - 57*D1*Dd*b1*f**2 - 720*D1*Dd*b1*f*fd*r**2 - 2016*D1*Dd*b1*f*fd*r*s + 1116*D1*Dd*b1*f*fd*r - 1296*D1*Dd*b1*f*fd*s**2 + 1476*D1*Dd*b1*f*fd*s - 414*D1*Dd*b1*f*fd - 540*D1*Dd*f**4*r**2 - 2760*D1*Dd*f**4*r*s + 1230*D1*Dd*f**4*r - 2220*D1*Dd*f**4*s**2 + 2490*D1*Dd*f**4*s - 825*D1*Dd*f**4 + 5280*D1*Dd*f**3*fd*r**2 + 20160*D1*Dd*f**3*fd*r*s - 10320*D1*Dd*f**3*fd*r + 14880*D1*Dd*f**3*fd*s**2 - 17520*D1*Dd*f**3*fd*s + 4770*D1*Dd*f**3*fd + 20*D1*Dd*f**3*r**2 + 72*D1*Dd*f**3*r*s - 38*D1*Dd*f**3*r + 52*D1*Dd*f**3*s**2 - 62*D1*Dd*f**3*s + 23*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 2160*D1*Dd*f**2*fd*r*s + 1130*D1*Dd*f**2*fd*r - 1560*D1*Dd*f**2*fd*s**2 + 1810*D1*Dd*f**2*fd*s - 500*D1*Dd*f**2*fd - 96*D1*Dd*f**2*g2*r*s + 24*D1*Dd*f**2*g2*r - 96*D1*Dd*f**2*g2*s**2 + 96*D1*Dd*f**2*g2*s - 24*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r*s + 72*D1*Dd*f**2*gd2*r - 576*D1*Dd*f**2*gd2*s**2 + 576*D1*Dd*f**2*gd2*s - 72*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r*s + 432*D1*Dd*f*fd*g2*r - 1152*D1*Dd*f*fd*g2*s**2 + 1152*D1*Dd*f*fd*g2*s - 288*D1*Dd*f*fd*g2 + 144*D1*Ddd*K*b1*f**2*r*s - 36*D1*Ddd*K*b1*f**2*r + 144*D1*Ddd*K*b1*f**2*s**2 - 144*D1*Ddd*K*b1*f**2*s + 36*D1*Ddd*K*b1*f**2 - 600*D1*Ddd*b1*f**3*r**2 - 1920*D1*Ddd*b1*f**3*r*s + 1080*D1*Ddd*b1*f**3*r - 1320*D1*Ddd*b1*f**3*s**2 + 1620*D1*Ddd*b1*f**3*s - 630*D1*Ddd*b1*f**3 - 180*D1*Ddd*b1*f**2*r**2 - 504*D1*Ddd*b1*f**2*r*s + 306*D1*Ddd*b1*f**2*r - 324*D1*Ddd*b1*f**2*s**2 + 414*D1*Ddd*b1*f**2*s - 171*D1*Ddd*b1*f**2 + 660*D1*Ddd*f**4*r**2 + 2520*D1*Ddd*f**4*r*s - 1290*D1*Ddd*f**4*r + 1860*D1*Ddd*f**4*s**2 - 2190*D1*Ddd*f**4*s + 795*D1*Ddd*f**4 - 100*D1*Ddd*f**3*r**2 - 360*D1*Ddd*f**3*r*s + 190*D1*Ddd*f**3*r - 260*D1*Ddd*f**3*s**2 + 310*D1*Ddd*f**3*s - 115*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r*s + 72*D1*Ddd*f**2*g2*r - 288*D1*Ddd*f**2*g2*s**2 + 288*D1*Ddd*f**2*g2*s - 72*D1*Ddd*f**2*g2 + 3*D1*bd1*f*(D1*(f**2*(10*r**2 + 2*r*(58*s - 67) + 106*s**2 - 230*s + 129) - f*(20*fd*(15*r**2 + r*(48*s - 31) + 33*s**2 - 46*s + 12) + (r + s - 1)*(-4*K*s + 5*r + 9*s - 5)) + 6*fd*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 - 10*r**2 + r*(17 - 28*s) - 18*s**2 + 23*s - 7)) - 2*Dd*f*(-6*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 5*f*(40*r**2 + 8*r*(16*s - 11) + 88*s**2 - 130*s + 45) + 60*r**2 + 168*r*s - 111*r + 108*s**2 - 153*s + 51)) + 432*Dd**2*K*b1*f**2*r*s - 108*Dd**2*K*b1*f**2*r + 432*Dd**2*K*b1*f**2*s**2 - 432*Dd**2*K*b1*f**2*s + 72*Dd**2*K*b1*f**2 - 1800*Dd**2*b1*f**3*r**2 - 5760*Dd**2*b1*f**3*r*s + 3240*Dd**2*b1*f**3*r - 3960*Dd**2*b1*f**3*s**2 + 4860*Dd**2*b1*f**3*s - 1260*Dd**2*b1*f**3 - 540*Dd**2*b1*f**2*r**2 - 1512*Dd**2*b1*f**2*r*s + 918*Dd**2*b1*f**2*r - 972*Dd**2*b1*f**2*s**2 + 1242*Dd**2*b1*f**2*s - 342*Dd**2*b1*f**2 + 1980*Dd**2*f**4*r**2 + 7560*Dd**2*f**4*r*s - 3870*Dd**2*f**4*r + 5580*Dd**2*f**4*s**2 - 6570*Dd**2*f**4*s + 1590*Dd**2*f**4 - 300*Dd**2*f**3*r**2 - 1080*Dd**2*f**3*r*s + 570*Dd**2*f**3*r - 780*Dd**2*f**3*s**2 + 930*Dd**2*f**3*s - 230*Dd**2*f**3 - 864*Dd**2*f**2*g2*r*s + 216*Dd**2*f**2*g2*r - 864*Dd**2*f**2*g2*s**2 + 864*Dd**2*f**2*g2*s - 144*Dd**2*f**2*g2)/(630*d**2*k2*k3**5) + D1**2*Pk2*Pkd3*ct*k1**5*(-D1*(6*D1*bd1**2*f*(r + s - 1)*(7*K*(2 - 4*s) + 25*f*(2*r + 2*s - 1) + 35*r + 63*s - 49) - 3*D1*bdd1*f*(r + s - 1)*(f**2*(55*r + 55*s - 75) + 5*f*(8*C*(s - 1) - 5*r - 13*s + 13) - 56*g2*(s - 1)) + bd1*(D1*(15*f**3*(9*r**2 + r*(22*s - 26) + 13*s**2 - 30*s + 17) + 3*f**2*(24*C*(s - 1)*(r + s - 1) - 10*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) - 15*r**2 - 54*r*(s - 1) - 39*(s - 1)**2) - 2*f*(15*fd*(4*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 10*r**2 - 36*r*s + 23*r - 26*s**2 + 35*s - 9) + (28*r + 28*s - 28)*(g2*(s - 1) - 6*gd2*s + 3*gd2)) + 168*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 6*Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + 5*f*(4*C*(8*r*s - 5*r + 8*s**2 - 12*s + 4) - 20*r**2 - 72*r*s + 55*r - 52*s**2 + 83*s - 31) - 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)))) + b1**2*(D1**2*(15*f*(3*fd - 5*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 150*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*fd*(r + s)*(5*r + s*(9 - 4*K)) - 21*fdd*(r + s)*(5*r + s*(9 - 4*K))) + D1*(Dd*(90*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-28*K*(r*(4*s - 1) + (1 - 2*s)**2) - 150*fd*(4*r + 4*s - 3)**2 + 140*r**2 + 392*r*s - 238*r + 252*s**2 - 322*s + 133) - 42*fd*(20*r**2 + r*(-16*K*s + 2*K + 56*s - 17) + s*(-16*K*s + 8*K + 36*s - 23))) - 3*Ddd*f*(-28*K*(r*(4*s - 1) + (1 - 2*s)**2) + 50*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 140*r**2 + 392*r*s - 238*r + 252*s**2 - 322*s + 133)) - 6*Dd**2*f*(-7*K*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + 150*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 210*r**2 + 588*r*s - 357*r + 378*s**2 - 483*s + 133)) + b1*(-144*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s + 240*C*D1**2*f*fdd*r*s + 240*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 240*C*D1**2*fd**2*r*s + 240*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 288*C*D1*Dd*f**2*r*s + 72*C*D1*Dd*f**2*r - 288*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 1920*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 1920*C*D1*Dd*f*fd*s**2 - 1440*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 480*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 480*C*D1*Ddd*f**2*s**2 - 480*C*D1*Ddd*f**2*s + 120*C*D1*Ddd*f**2 + 1440*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 1440*C*Dd**2*f**2*s**2 - 1440*C*Dd**2*f**2*s + 240*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(25*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (14*r + 14*s - 14)*(-4*K*s + 2*K + 5*r + 9*s - 7)) - 405*D1**2*f**2*fd*r**2 - 990*D1**2*f**2*fd*r*s + 480*D1**2*f**2*fd*r - 585*D1**2*f**2*fd*s**2 + 600*D1**2*f**2*fd*s - 210*D1**2*f**2*fd + 495*D1**2*f**2*fdd*r**2 + 990*D1**2*f**2*fdd*r*s - 600*D1**2*f**2*fdd*r + 495*D1**2*f**2*fdd*s**2 - 600*D1**2*f**2*fdd*s + 270*D1**2*f**2*fdd + 990*D1**2*f*fd**2*r**2 + 1980*D1**2*f*fd**2*r*s - 1200*D1**2*f*fd**2*r + 990*D1**2*f*fd**2*s**2 - 1200*D1**2*f*fd**2*s + 270*D1**2*f*fd**2 + 90*D1**2*f*fd*r**2 + 324*D1**2*f*fd*r*s - 90*D1**2*f*fd*r + 234*D1**2*f*fd*s**2 - 162*D1**2*f*fd*s + 45*D1**2*f*fd - 150*D1**2*f*fdd*r**2 - 540*D1**2*f*fdd*r*s + 150*D1**2*f*fdd*r - 390*D1**2*f*fdd*s**2 + 270*D1**2*f*fdd*s - 75*D1**2*f*fdd + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 150*D1**2*fd**2*r**2 - 540*D1**2*fd**2*r*s + 150*D1**2*fd**2*r - 390*D1**2*fd**2*s**2 + 270*D1**2*fd**2*s + 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 336*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*s**2 - 540*D1*Dd*f**3*r**2 - 1320*D1*Dd*f**3*r*s + 870*D1*Dd*f**3*r - 780*D1*Dd*f**3*s**2 + 1050*D1*Dd*f**3*s - 465*D1*Dd*f**3 + 3960*D1*Dd*f**2*fd*r**2 + 7920*D1*Dd*f**2*fd*r*s - 5370*D1*Dd*f**2*fd*r + 3960*D1*Dd*f**2*fd*s**2 - 5370*D1*Dd*f**2*fd*s + 1800*D1*Dd*f**2*fd + 180*D1*Dd*f**2*r**2 + 648*D1*Dd*f**2*r*s - 342*D1*Dd*f**2*r + 468*D1*Dd*f**2*s**2 - 558*D1*Dd*f**2*s + 207*D1*Dd*f**2 - 1200*D1*Dd*f*fd*r**2 - 4320*D1*Dd*f*fd*r*s + 1740*D1*Dd*f*fd*r - 3120*D1*Dd*f*fd*s**2 + 2940*D1*Dd*f*fd*s - 570*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 1344*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 + 672*D1*Dd*fd*g2*s + 660*D1*Ddd*f**3*r**2 + 1320*D1*Ddd*f**3*r*s - 990*D1*Ddd*f**3*r + 660*D1*Ddd*f**3*s**2 - 990*D1*Ddd*f**3*s + 495*D1*Ddd*f**3 - 300*D1*Ddd*f**2*r**2 - 1080*D1*Ddd*f**2*r*s + 570*D1*Ddd*f**2*r - 780*D1*Ddd*f**2*s**2 + 930*D1*Ddd*f**2*s - 345*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 672*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 + D1*bd1*(D1*(45*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(r + s - 1)*(28*K*s - 14*K + 300*fd*(2*r + 2*s - 1) - 35*r - 63*s + 49) - 84*fd*(5*r**2 + r*(-4*K*s + K + 14*s - 6) + s*(-4*K*s + 3*K + 9*s - 8))) - 6*Dd*f*(-14*K*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + 25*f*(4*r + 4*s - 3)**2 + 280*r**2 + 784*r*s - 574*r + 504*s**2 - 770*s + 280)) + 1980*Dd**2*f**3*r**2 + 3960*Dd**2*f**3*r*s - 2970*Dd**2*f**3*r + 1980*Dd**2*f**3*s**2 - 2970*Dd**2*f**3*s + 990*Dd**2*f**3 - 900*Dd**2*f**2*r**2 - 3240*Dd**2*f**2*r*s + 1710*Dd**2*f**2*r - 2340*Dd**2*f**2*s**2 + 2790*Dd**2*f**2*s - 690*Dd**2*f**2 - 2016*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 2016*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(210*d**2*k2*k3**5) - 3*D1**2*Pk2*Pkd3*ct*k1**3*k2**3*st**4*(-108*C*D1**2*f**2*fd*r**2 - 216*C*D1**2*f**2*fd*r*s + 144*C*D1**2*f**2*fd*r - 108*C*D1**2*f**2*fd*s**2 + 144*C*D1**2*f**2*fd*s - 72*C*D1**2*f**2*fd + 72*C*D1**2*f**2*fdd*r**2 + 144*C*D1**2*f**2*fdd*r*s - 96*C*D1**2*f**2*fdd*r + 72*C*D1**2*f**2*fdd*s**2 - 96*C*D1**2*f**2*fdd*s + 48*C*D1**2*f**2*fdd + 144*C*D1**2*f*fd**2*r**2 + 288*C*D1**2*f*fd**2*r*s - 192*C*D1**2*f*fd**2*r + 144*C*D1**2*f*fd**2*s**2 - 192*C*D1**2*f*fd**2*s + 48*C*D1**2*f*fd**2 - 144*C*D1*Dd*f**3*r**2 - 288*C*D1*Dd*f**3*r*s + 216*C*D1*Dd*f**3*r - 144*C*D1*Dd*f**3*s**2 + 216*C*D1*Dd*f**3*s - 108*C*D1*Dd*f**3 + 576*C*D1*Dd*f**2*fd*r**2 + 1152*C*D1*Dd*f**2*fd*r*s - 816*C*D1*Dd*f**2*fd*r + 576*C*D1*Dd*f**2*fd*s**2 - 816*C*D1*Dd*f**2*fd*s + 288*C*D1*Dd*f**2*fd + 96*C*D1*Ddd*f**3*r**2 + 192*C*D1*Ddd*f**3*r*s - 144*C*D1*Ddd*f**3*r + 96*C*D1*Ddd*f**3*s**2 - 144*C*D1*Ddd*f**3*s + 72*C*D1*Ddd*f**3 + 288*C*Dd**2*f**3*r**2 + 576*C*Dd**2*f**3*r*s - 432*C*Dd**2*f**3*r + 288*C*Dd**2*f**3*s**2 - 432*C*Dd**2*f**3*s + 144*C*Dd**2*f**3 - 60*D1**2*K*b1*f*fd*r**2 - 120*D1**2*K*b1*f*fd*r*s + 60*D1**2*K*b1*f*fd*r - 60*D1**2*K*b1*f*fd*s**2 + 60*D1**2*K*b1*f*fd*s - 30*D1**2*K*b1*f*fd + 72*D1**2*K*b1*f*fdd*r**2 + 144*D1**2*K*b1*f*fdd*r*s - 72*D1**2*K*b1*f*fdd*r + 72*D1**2*K*b1*f*fdd*s**2 - 72*D1**2*K*b1*f*fdd*s + 36*D1**2*K*b1*f*fdd + 72*D1**2*K*b1*fd**2*r**2 + 144*D1**2*K*b1*fd**2*r*s - 72*D1**2*K*b1*fd**2*r + 72*D1**2*K*b1*fd**2*s**2 - 72*D1**2*K*b1*fd**2*s + 69*D1**2*b1*f**2*fd*r**2 + 138*D1**2*b1*f**2*fd*r*s - 92*D1**2*b1*f**2*fd*r + 69*D1**2*b1*f**2*fd*s**2 - 92*D1**2*b1*f**2*fd*s + 46*D1**2*b1*f**2*fd - 75*D1**2*b1*f**2*fdd*r**2 - 150*D1**2*b1*f**2*fdd*r*s + 100*D1**2*b1*f**2*fdd*r - 75*D1**2*b1*f**2*fdd*s**2 + 100*D1**2*b1*f**2*fdd*s - 50*D1**2*b1*f**2*fdd - 150*D1**2*b1*f*fd**2*r**2 - 300*D1**2*b1*f*fd**2*r*s + 200*D1**2*b1*f*fd**2*r - 150*D1**2*b1*f*fd**2*s**2 + 200*D1**2*b1*f*fd**2*s - 50*D1**2*b1*f*fd**2 + 30*D1**2*b1*f*fd*r**2 + 60*D1**2*b1*f*fd*r*s - 30*D1**2*b1*f*fd*r + 30*D1**2*b1*f*fd*s**2 - 30*D1**2*b1*f*fd*s + 15*D1**2*b1*f*fd - 36*D1**2*b1*f*fdd*r**2 - 72*D1**2*b1*f*fdd*r*s + 36*D1**2*b1*f*fdd*r - 36*D1**2*b1*f*fdd*s**2 + 36*D1**2*b1*f*fdd*s - 18*D1**2*b1*f*fdd - 36*D1**2*b1*fd**2*r**2 - 72*D1**2*b1*fd**2*r*s + 36*D1**2*b1*fd**2*r - 36*D1**2*b1*fd**2*s**2 + 36*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-36*K + 25*f + 18)*(r + s - 1)**2 + 60*D1**2*f**3*fd*r**2 + 120*D1**2*f**3*fd*r*s - 90*D1**2*f**3*fd*r + 60*D1**2*f**3*fd*s**2 - 90*D1**2*f**3*fd*s + 45*D1**2*f**3*fd + 81*D1**2*f**2*fd*r**2 + 162*D1**2*f**2*fd*r*s - 108*D1**2*f**2*fd*r + 81*D1**2*f**2*fd*s**2 - 108*D1**2*f**2*fd*s + 54*D1**2*f**2*fd - 54*D1**2*f**2*fdd*r**2 - 108*D1**2*f**2*fdd*r*s + 72*D1**2*f**2*fdd*r - 54*D1**2*f**2*fdd*s**2 + 72*D1**2*f**2*fdd*s - 36*D1**2*f**2*fdd + 60*D1**2*f**2*gd2*r**2 + 120*D1**2*f**2*gd2*r*s - 120*D1**2*f**2*gd2*r + 60*D1**2*f**2*gd2*s**2 - 120*D1**2*f**2*gd2*s + 60*D1**2*f**2*gd2 - 72*D1**2*f**2*gdd2*r**2 - 144*D1**2*f**2*gdd2*r*s + 144*D1**2*f**2*gdd2*r - 72*D1**2*f**2*gdd2*s**2 + 144*D1**2*f**2*gdd2*s - 72*D1**2*f**2*gdd2 - 108*D1**2*f*fd**2*r**2 - 216*D1**2*f*fd**2*r*s + 144*D1**2*f*fd**2*r - 108*D1**2*f*fd**2*s**2 + 144*D1**2*f*fd**2*s - 36*D1**2*f*fd**2 + 120*D1**2*f*fd*g2*r**2 + 240*D1**2*f*fd*g2*r*s - 120*D1**2*f*fd*g2*r + 120*D1**2*f*fd*g2*s**2 - 120*D1**2*f*fd*g2*s + 60*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r**2 - 576*D1**2*f*fd*gd2*r*s + 432*D1**2*f*fd*gd2*r - 288*D1**2*f*fd*gd2*s**2 + 432*D1**2*f*fd*gd2*s - 144*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r**2 - 288*D1**2*f*fdd*g2*r*s + 144*D1**2*f*fdd*g2*r - 144*D1**2*f*fdd*g2*s**2 + 144*D1**2*f*fdd*g2*s - 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r**2 - 288*D1**2*fd**2*g2*r*s + 144*D1**2*fd**2*g2*r - 144*D1**2*fd**2*g2*s**2 + 144*D1**2*fd**2*g2*s - 120*D1*Dd*K*b1*f**2*r**2 - 240*D1*Dd*K*b1*f**2*r*s + 180*D1*Dd*K*b1*f**2*r - 120*D1*Dd*K*b1*f**2*s**2 + 180*D1*Dd*K*b1*f**2*s - 90*D1*Dd*K*b1*f**2 + 576*D1*Dd*K*b1*f*fd*r**2 + 1152*D1*Dd*K*b1*f*fd*r*s - 720*D1*Dd*K*b1*f*fd*r + 576*D1*Dd*K*b1*f*fd*s**2 - 720*D1*Dd*K*b1*f*fd*s + 216*D1*Dd*K*b1*f*fd + 92*D1*Dd*b1*f**3*r**2 + 184*D1*Dd*b1*f**3*r*s - 138*D1*Dd*b1*f**3*r + 92*D1*Dd*b1*f**3*s**2 - 138*D1*Dd*b1*f**3*s + 69*D1*Dd*b1*f**3 - 600*D1*Dd*b1*f**2*fd*r**2 - 1200*D1*Dd*b1*f**2*fd*r*s + 850*D1*Dd*b1*f**2*fd*r - 600*D1*Dd*b1*f**2*fd*s**2 + 850*D1*Dd*b1*f**2*fd*s - 300*D1*Dd*b1*f**2*fd + 60*D1*Dd*b1*f**2*r**2 + 120*D1*Dd*b1*f**2*r*s - 90*D1*Dd*b1*f**2*r + 60*D1*Dd*b1*f**2*s**2 - 90*D1*Dd*b1*f**2*s + 45*D1*Dd*b1*f**2 - 288*D1*Dd*b1*f*fd*r**2 - 576*D1*Dd*b1*f*fd*r*s + 360*D1*Dd*b1*f*fd*r - 288*D1*Dd*b1*f*fd*s**2 + 360*D1*Dd*b1*f*fd*s - 108*D1*Dd*b1*f*fd + 60*D1*Dd*f**4*r**2 + 120*D1*Dd*f**4*r*s - 90*D1*Dd*f**4*r + 60*D1*Dd*f**4*s**2 - 90*D1*Dd*f**4*s + 45*D1*Dd*f**4 + 108*D1*Dd*f**3*r**2 + 216*D1*Dd*f**3*r*s - 162*D1*Dd*f**3*r + 108*D1*Dd*f**3*s**2 - 162*D1*Dd*f**3*s + 81*D1*Dd*f**3 - 432*D1*Dd*f**2*fd*r**2 - 864*D1*Dd*f**2*fd*r*s + 612*D1*Dd*f**2*fd*r - 432*D1*Dd*f**2*fd*s**2 + 612*D1*Dd*f**2*fd*s - 216*D1*Dd*f**2*fd + 240*D1*Dd*f**2*g2*r**2 + 480*D1*Dd*f**2*g2*r*s - 360*D1*Dd*f**2*g2*r + 240*D1*Dd*f**2*g2*s**2 - 360*D1*Dd*f**2*g2*s + 180*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r**2 - 1152*D1*Dd*f**2*gd2*r*s + 1008*D1*Dd*f**2*gd2*r - 576*D1*Dd*f**2*gd2*s**2 + 1008*D1*Dd*f**2*gd2*s - 432*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r**2 - 2304*D1*Dd*f*fd*g2*r*s + 1440*D1*Dd*f*fd*g2*r - 1152*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 432*D1*Dd*f*fd*g2 + 144*D1*Ddd*K*b1*f**2*r**2 + 288*D1*Ddd*K*b1*f**2*r*s - 216*D1*Ddd*K*b1*f**2*r + 144*D1*Ddd*K*b1*f**2*s**2 - 216*D1*Ddd*K*b1*f**2*s + 108*D1*Ddd*K*b1*f**2 - 100*D1*Ddd*b1*f**3*r**2 - 200*D1*Ddd*b1*f**3*r*s + 150*D1*Ddd*b1*f**3*r - 100*D1*Ddd*b1*f**3*s**2 + 150*D1*Ddd*b1*f**3*s - 75*D1*Ddd*b1*f**3 - 72*D1*Ddd*b1*f**2*r**2 - 144*D1*Ddd*b1*f**2*r*s + 108*D1*Ddd*b1*f**2*r - 72*D1*Ddd*b1*f**2*s**2 + 108*D1*Ddd*b1*f**2*s - 54*D1*Ddd*b1*f**2 - 72*D1*Ddd*f**3*r**2 - 144*D1*Ddd*f**3*r*s + 108*D1*Ddd*f**3*r - 72*D1*Ddd*f**3*s**2 + 108*D1*Ddd*f**3*s - 54*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r**2 - 576*D1*Ddd*f**2*g2*r*s + 432*D1*Ddd*f**2*g2*r - 288*D1*Ddd*f**2*g2*s**2 + 432*D1*Ddd*f**2*g2*s - 216*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(23*f**2*(r + s - 1) - 5*f*(10*fd*(3*r + 3*s - 2) + (6*K - 3)*(r + s - 1)) + 36*fd*(2*K - 1)*(2*r + 2*s - 1)) - 2*Dd*f*(-36*K + 25*f + 18)*(4*r + 4*s - 3))*(r + s - 1) + 432*Dd**2*K*b1*f**2*r**2 + 864*Dd**2*K*b1*f**2*r*s - 648*Dd**2*K*b1*f**2*r + 432*Dd**2*K*b1*f**2*s**2 - 648*Dd**2*K*b1*f**2*s + 216*Dd**2*K*b1*f**2 - 300*Dd**2*b1*f**3*r**2 - 600*Dd**2*b1*f**3*r*s + 450*Dd**2*b1*f**3*r - 300*Dd**2*b1*f**3*s**2 + 450*Dd**2*b1*f**3*s - 150*Dd**2*b1*f**3 - 216*Dd**2*b1*f**2*r**2 - 432*Dd**2*b1*f**2*r*s + 324*Dd**2*b1*f**2*r - 216*Dd**2*b1*f**2*s**2 + 324*Dd**2*b1*f**2*s - 108*Dd**2*b1*f**2 - 216*Dd**2*f**3*r**2 - 432*Dd**2*f**3*r*s + 324*Dd**2*f**3*r - 216*Dd**2*f**3*s**2 + 324*Dd**2*f**3*s - 108*Dd**2*f**3 - 864*Dd**2*f**2*g2*r**2 - 1728*Dd**2*f**2*g2*r*s + 1296*Dd**2*f**2*g2*r - 864*Dd**2*f**2*g2*s**2 + 1296*Dd**2*f**2*g2*s - 432*Dd**2*f**2*g2)/(70*d**2*k3**7) - 3*D1**2*Pk2*Pkd3*ct*k1**3*k2**3*st**2*(72*C*D1**2*bdd1*f**2*r**2 + 144*C*D1**2*bdd1*f**2*r*s - 144*C*D1**2*bdd1*f**2*r + 72*C*D1**2*bdd1*f**2*s**2 - 144*C*D1**2*bdd1*f**2*s + 72*C*D1**2*bdd1*f**2 - 60*C*D1**2*f**2*fd*r**2 - 120*C*D1**2*f**2*fd*r*s + 80*C*D1**2*f**2*fd*r - 60*C*D1**2*f**2*fd*s**2 + 80*C*D1**2*f**2*fd*s - 40*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r**2 + 240*C*D1**2*f**2*fdd*r*s - 160*C*D1**2*f**2*fdd*r + 120*C*D1**2*f**2*fdd*s**2 - 160*C*D1**2*f**2*fdd*s + 80*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r**2 + 480*C*D1**2*f*fd**2*r*s - 320*C*D1**2*f*fd**2*r + 240*C*D1**2*f*fd**2*s**2 - 320*C*D1**2*f*fd**2*s + 80*C*D1**2*f*fd**2 - 80*C*D1*Dd*f**3*r**2 - 160*C*D1*Dd*f**3*r*s + 120*C*D1*Dd*f**3*r - 80*C*D1*Dd*f**3*s**2 + 120*C*D1*Dd*f**3*s - 60*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r**2 + 1920*C*D1*Dd*f**2*fd*r*s - 1360*C*D1*Dd*f**2*fd*r + 960*C*D1*Dd*f**2*fd*s**2 - 1360*C*D1*Dd*f**2*fd*s + 480*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r**2 + 320*C*D1*Ddd*f**3*r*s - 240*C*D1*Ddd*f**3*r + 160*C*D1*Ddd*f**3*s**2 - 240*C*D1*Ddd*f**3*s + 120*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r**2 + 960*C*Dd**2*f**3*r*s - 720*C*Dd**2*f**3*r + 480*C*Dd**2*f**3*s**2 - 720*C*Dd**2*f**3*s + 240*C*Dd**2*f**3 + 36*D1**2*K*bdd1*f**2*r**2 + 72*D1**2*K*bdd1*f**2*r*s - 72*D1**2*K*bdd1*f**2*r + 36*D1**2*K*bdd1*f**2*s**2 - 72*D1**2*K*bdd1*f**2*s + 36*D1**2*K*bdd1*f**2 - 12*D1**2*bd1**2*f*(-14*K + 15*f + 7)*(r + s - 1)**2 - 54*D1**2*bdd1*f**2*r**2 - 108*D1**2*bdd1*f**2*r*s + 108*D1**2*bdd1*f**2*r - 54*D1**2*bdd1*f**2*s**2 + 108*D1**2*bdd1*f**2*s - 54*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r**2 - 336*D1**2*bdd1*f*g2*r*s + 336*D1**2*bdd1*f*g2*r - 168*D1**2*bdd1*f*g2*s**2 + 336*D1**2*bdd1*f*g2*s - 168*D1**2*bdd1*f*g2 + 21*D1**2*f**2*fd*r**2 + 42*D1**2*f**2*fd*r*s - 28*D1**2*f**2*fd*r + 21*D1**2*f**2*fd*s**2 - 28*D1**2*f**2*fd*s + 14*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd + 4*D1**2*f**2*gd2*r**2 + 8*D1**2*f**2*gd2*r*s - 8*D1**2*f**2*gd2*r + 4*D1**2*f**2*gd2*s**2 - 8*D1**2*f**2*gd2*s + 4*D1**2*f**2*gd2 - 72*D1**2*f**2*gdd2*r**2 - 144*D1**2*f**2*gdd2*r*s + 144*D1**2*f**2*gdd2*r - 72*D1**2*f**2*gdd2*s**2 + 144*D1**2*f**2*gdd2*s - 72*D1**2*f**2*gdd2 - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 8*D1**2*f*fd*g2*r**2 + 16*D1**2*f*fd*g2*r*s - 8*D1**2*f*fd*g2*r + 8*D1**2*f*fd*g2*s**2 - 8*D1**2*f*fd*g2*s + 4*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r**2 - 576*D1**2*f*fd*gd2*r*s + 432*D1**2*f*fd*gd2*r - 288*D1**2*f*fd*gd2*s**2 + 432*D1**2*f*fd*gd2*s - 144*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r**2 - 288*D1**2*f*fdd*g2*r*s + 144*D1**2*f*fdd*g2*r - 144*D1**2*f*fdd*g2*s**2 + 144*D1**2*f*fdd*g2*s - 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r**2 - 288*D1**2*fd**2*g2*r*s + 144*D1**2*fd**2*g2*r - 144*D1**2*fd**2*g2*s**2 + 144*D1**2*fd**2*g2*s + 28*D1*Dd*f**3*r**2 + 56*D1*Dd*f**3*r*s - 42*D1*Dd*f**3*r + 28*D1*Dd*f**3*s**2 - 42*D1*Dd*f**3*s + 21*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 680*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 680*D1*Dd*f**2*fd*s - 240*D1*Dd*f**2*fd + 16*D1*Dd*f**2*g2*r**2 + 32*D1*Dd*f**2*g2*r*s - 24*D1*Dd*f**2*g2*r + 16*D1*Dd*f**2*g2*s**2 - 24*D1*Dd*f**2*g2*s + 12*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r**2 - 1152*D1*Dd*f**2*gd2*r*s + 1008*D1*Dd*f**2*gd2*r - 576*D1*Dd*f**2*gd2*s**2 + 1008*D1*Dd*f**2*gd2*s - 432*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r**2 - 2304*D1*Dd*f*fd*g2*r*s + 1440*D1*Dd*f*fd*g2*r - 1152*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 432*D1*Dd*f*fd*g2 - 80*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 120*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r**2 - 576*D1*Ddd*f**2*g2*r*s + 432*D1*Ddd*f**2*g2*r - 288*D1*Ddd*f**2*g2*s**2 + 432*D1*Ddd*f**2*g2*s - 216*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(f**2*(58*C + K - 40)*(r + s - 1) - 2*f*(9*fd*(4*C + 2*K - 3)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 6*Dd*f*(3*f*(4*C + 2*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 240*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 360*Dd**2*f**3*s - 120*Dd**2*f**3 - 864*Dd**2*f**2*g2*r**2 - 1728*Dd**2*f**2*g2*r*s + 1296*Dd**2*f**2*g2*r - 864*Dd**2*f**2*g2*s**2 + 1296*Dd**2*f**2*g2*s - 432*Dd**2*f**2*g2 + b1**2*(D1**2*(9*f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(180*fd**2*(r + s - 1) + 49*fd*(2*K - 1)*(r + s) - 42*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(117*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(180*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (98*K - 49)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 84*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-14*K + 15*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-14*K + 15*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(-116*C*D1**2*f*fd*r**2 - 232*C*D1**2*f*fd*r*s + 116*C*D1**2*f*fd*r - 116*C*D1**2*f*fd*s**2 + 116*C*D1**2*f*fd*s - 58*C*D1**2*f*fd + 72*C*D1**2*f*fdd*r**2 + 144*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 36*C*D1**2*f*fdd + 72*C*D1**2*fd**2*r**2 + 144*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*r + 72*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s - 232*C*D1*Dd*f**2*r**2 - 464*C*D1*Dd*f**2*r*s + 348*C*D1*Dd*f**2*r - 232*C*D1*Dd*f**2*s**2 + 348*C*D1*Dd*f**2*s - 174*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 + 1152*C*D1*Dd*f*fd*r*s - 720*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 216*C*D1*Dd*f*fd + 144*C*D1*Ddd*f**2*r**2 + 288*C*D1*Ddd*f**2*r*s - 216*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 216*C*D1*Ddd*f**2*s + 108*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r**2 + 864*C*Dd**2*f**2*r*s - 648*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 648*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 - 2*D1**2*K*f*fd*r**2 - 4*D1**2*K*f*fd*r*s + 2*D1**2*K*f*fd*r - 2*D1**2*K*f*fd*s**2 + 2*D1**2*K*f*fd*s - D1**2*K*f*fd + 36*D1**2*K*f*fdd*r**2 + 72*D1**2*K*f*fdd*r*s - 36*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r**2 + 72*D1**2*K*fd**2*r*s - 36*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-14*K + 15*f + 7)*(r + s - 1)**2 + 80*D1**2*f*fd*r**2 + 160*D1**2*f*fd*r*s - 80*D1**2*f*fd*r + 80*D1**2*f*fd*s**2 - 80*D1**2*f*fd*s + 40*D1**2*f*fd - 54*D1**2*f*fdd*r**2 - 108*D1**2*f*fdd*r*s + 54*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 54*D1**2*f*fdd*s - 27*D1**2*f*fdd + 98*D1**2*f*gd2*r**2 + 196*D1**2*f*gd2*r*s - 196*D1**2*f*gd2*r + 98*D1**2*f*gd2*s**2 - 196*D1**2*f*gd2*s + 98*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 54*D1**2*fd**2*r**2 - 108*D1**2*fd**2*r*s + 54*D1**2*fd**2*r - 54*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s + 98*D1**2*fd*g2*r**2 + 196*D1**2*fd*g2*r*s + 98*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 - 4*D1*Dd*K*f**2*r**2 - 8*D1*Dd*K*f**2*r*s + 6*D1*Dd*K*f**2*r - 4*D1*Dd*K*f**2*s**2 + 6*D1*Dd*K*f**2*s - 3*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r**2 + 576*D1*Dd*K*f*fd*r*s - 360*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 360*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd + 160*D1*Dd*f**2*r**2 + 320*D1*Dd*f**2*r*s - 240*D1*Dd*f**2*r + 160*D1*Dd*f**2*s**2 - 240*D1*Dd*f**2*s + 120*D1*Dd*f**2 - 432*D1*Dd*f*fd*r**2 - 864*D1*Dd*f*fd*r*s + 540*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 540*D1*Dd*f*fd*s - 162*D1*Dd*f*fd + 392*D1*Dd*f*g2*r**2 + 784*D1*Dd*f*g2*r*s - 588*D1*Dd*f*g2*r + 392*D1*Dd*f*g2*s**2 - 588*D1*Dd*f*g2*s + 294*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s + 72*D1*Ddd*K*f**2*r**2 + 144*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 108*D1*Ddd*K*f**2*s + 54*D1*Ddd*K*f**2 - 108*D1*Ddd*f**2*r**2 - 216*D1*Ddd*f**2*r*s + 162*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 162*D1*Ddd*f**2*s - 81*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + D1*bd1*(D1*(117*f**2*(r + s - 1) - 180*f*fd*(2*r + 2*s - 1) - 49*f*(2*K - 1)*(r + s - 1) + 84*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-14*K + 15*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*f**2*r**2 + 432*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 324*Dd**2*K*f**2*s + 108*Dd**2*K*f**2 - 324*Dd**2*f**2*r**2 - 648*Dd**2*f**2*r*s + 486*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 486*Dd**2*f**2*s - 162*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(70*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct*k1**3*k2**3*(-3*D1*(r + s - 1)*(56*D1*K*bd1**2*f*(r + s - 1) + 4*D1*bdd1*f*(f*(10*C - 5) - 14*g2)*(r + s - 1) + bd1*(D1*(f**2*(4*C - 9)*(r + s - 1) + f*fd*(80*C - 40)*(2*r + 2*s - 1) - 28*f*(g2 + 4*gd2)*(r + s - 1) - 112*fd*g2*(r + s)) + 8*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))) + 7*b1**2*(D1**2*(9*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)**2*(12*K*fdd + fd*(6*K - 5))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(6*K - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-3*D1**2*(f*(fd*(4*C - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*(r + s - 1)**2*(14*K*bdd1 - 7*gd2 - 14*gdd2)) + (4*r + 4*s)*(fd**2*(20*C - 10)*(r + s - 1) - 7*fd*(g2*(r + s) + 4*gd2*(r + s - 1)) - 14*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-24*K*fd*(r + s) + 9*f**2*(r + s - 1) - f*(6*K - 5)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(f**2*(4*C - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4*f*(fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 28*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 112*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 4*Ddd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(10*C - 5) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k3**7) + D1**2*Pk2*Pkd3*ct*k1**3*k2*st**4*(-144*C*D1**2*f**2*fd*r**2 + 72*C*D1**2*f**2*fd*r*s + 72*C*D1**2*f**2*fd*r + 216*C*D1**2*f**2*fd*s**2 - 168*C*D1**2*f**2*fd*s + 24*C*D1**2*f**2*fd + 72*C*D1**2*f**2*fdd*r**2 - 48*C*D1**2*f**2*fdd*r - 72*C*D1**2*f**2*fdd*s**2 + 48*C*D1**2*f**2*fdd*s + 144*C*D1**2*f*fd**2*r**2 - 96*C*D1**2*f*fd**2*r - 144*C*D1**2*f*fd**2*s**2 + 96*C*D1**2*f*fd**2*s - 192*C*D1*Dd*f**3*r**2 + 96*C*D1*Dd*f**3*r*s + 168*C*D1*Dd*f**3*r + 288*C*D1*Dd*f**3*s**2 - 192*C*D1*Dd*f**3*s - 24*C*D1*Dd*f**3 + 576*C*D1*Dd*f**2*fd*r**2 - 480*C*D1*Dd*f**2*fd*r - 576*C*D1*Dd*f**2*fd*s**2 + 336*C*D1*Dd*f**2*fd*s + 48*C*D1*Dd*f**2*fd + 96*C*D1*Ddd*f**3*r**2 - 96*C*D1*Ddd*f**3*r - 96*C*D1*Ddd*f**3*s**2 + 48*C*D1*Ddd*f**3*s + 24*C*D1*Ddd*f**3 + 288*C*Dd**2*f**3*r**2 - 288*C*Dd**2*f**3*r - 288*C*Dd**2*f**3*s**2 + 144*C*Dd**2*f**3*s + 48*C*Dd**2*f**3 - 144*D1**2*K*b1*f*fd*r**2 + 168*D1**2*K*b1*f*fd*r*s - 84*D1**2*K*b1*f*fd*r + 312*D1**2*K*b1*f*fd*s**2 - 312*D1**2*K*b1*f*fd*s + 156*D1**2*K*b1*f*fd + 72*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*s**2 + 72*D1**2*K*b1*f*fdd*s - 36*D1**2*K*b1*f*fdd + 72*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*s**2 + 72*D1**2*K*b1*fd**2*s + 855*D1**2*b1*f**2*fd*r**2 + 1542*D1**2*b1*f**2*fd*r*s - 1176*D1**2*b1*f**2*fd*r + 687*D1**2*b1*f**2*fd*s**2 - 1064*D1**2*b1*f**2*fd*s + 486*D1**2*b1*f**2*fd - 675*D1**2*b1*f**2*fdd*r**2 - 1230*D1**2*b1*f**2*fdd*r*s + 930*D1**2*b1*f**2*fdd*r - 555*D1**2*b1*f**2*fdd*s**2 + 850*D1**2*b1*f**2*fdd*s - 405*D1**2*b1*f**2*fdd - 1350*D1**2*b1*f*fd**2*r**2 - 2460*D1**2*b1*f*fd**2*r*s + 1860*D1**2*b1*f*fd**2*r - 1110*D1**2*b1*f*fd**2*s**2 + 1700*D1**2*b1*f*fd**2*s - 630*D1**2*b1*f*fd**2 + 294*D1**2*b1*f*fd*r**2 + 276*D1**2*b1*f*fd*r*s - 138*D1**2*b1*f*fd*r - 18*D1**2*b1*f*fd*s**2 + 18*D1**2*b1*f*fd*s - 9*D1**2*b1*f*fd - 252*D1**2*b1*f*fdd*r**2 - 432*D1**2*b1*f*fdd*r*s + 216*D1**2*b1*f*fdd*r - 180*D1**2*b1*f*fdd*s**2 + 180*D1**2*b1*f*fdd*s - 90*D1**2*b1*f*fdd - 252*D1**2*b1*fd**2*r**2 - 432*D1**2*b1*fd**2*r*s + 216*D1**2*b1*fd**2*r - 180*D1**2*b1*fd**2*s**2 + 180*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(5*f*(45*r**2 + r*(82*s - 76) + 37*s**2 - 68*s + 46) + (r + s - 1)*(-36*K*(r - s - 1) + 126*r + 90*s - 126)) - 780*D1**2*f**3*fd*r**2 - 2040*D1**2*f**3*fd*r*s + 1290*D1**2*f**3*fd*r - 1260*D1**2*f**3*fd*s**2 + 1650*D1**2*f**3*fd*s - 705*D1**2*f**3*fd + 900*D1**2*f**3*fdd*r**2 + 1800*D1**2*f**3*fdd*r*s - 1350*D1**2*f**3*fdd*r + 900*D1**2*f**3*fdd*s**2 - 1350*D1**2*f**3*fdd*s + 675*D1**2*f**3*fdd + 2700*D1**2*f**2*fd**2*r**2 + 5400*D1**2*f**2*fd**2*r*s - 4050*D1**2*f**2*fd**2*r + 2700*D1**2*f**2*fd**2*s**2 - 4050*D1**2*f**2*fd**2*s + 1350*D1**2*f**2*fd**2 + 279*D1**2*f**2*fd*r**2 + 270*D1**2*f**2*fd*r*s - 276*D1**2*f**2*fd*r - 9*D1**2*f**2*fd*s**2 - 84*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 162*D1**2*f**2*fdd*r**2 - 216*D1**2*f**2*fdd*r*s + 180*D1**2*f**2*fdd*r - 54*D1**2*f**2*fdd*s**2 + 108*D1**2*f**2*fdd*s - 72*D1**2*f**2*fdd + 144*D1**2*f**2*gd2*r**2 - 168*D1**2*f**2*gd2*r*s - 288*D1**2*f**2*gd2*r - 312*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s + 144*D1**2*f**2*gd2 - 72*D1**2*f**2*gdd2*r**2 + 144*D1**2*f**2*gdd2*r + 72*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2 - 324*D1**2*f*fd**2*r**2 - 432*D1**2*f*fd**2*r*s + 360*D1**2*f*fd**2*r - 108*D1**2*f*fd**2*s**2 + 216*D1**2*f*fd**2*s - 72*D1**2*f*fd**2 + 288*D1**2*f*fd*g2*r**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r - 624*D1**2*f*fd*g2*s**2 + 624*D1**2*f*fd*g2*s - 312*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r + 288*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s - 144*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*s**2 - 144*D1**2*f*fdd*g2*s + 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*s**2 - 144*D1**2*fd**2*g2*s - 288*D1*Dd*K*b1*f**2*r**2 + 336*D1*Dd*K*b1*f**2*r*s + 204*D1*Dd*K*b1*f**2*r + 624*D1*Dd*K*b1*f**2*s**2 - 480*D1*Dd*K*b1*f**2*s + 12*D1*Dd*K*b1*f**2 + 576*D1*Dd*K*b1*f*fd*r**2 - 288*D1*Dd*K*b1*f*fd*r - 576*D1*Dd*K*b1*f*fd*s**2 + 432*D1*Dd*K*b1*f*fd*s - 72*D1*Dd*K*b1*f*fd + 1140*D1*Dd*b1*f**3*r**2 + 2056*D1*Dd*b1*f**3*r*s - 1654*D1*Dd*b1*f**3*r + 916*D1*Dd*b1*f**3*s**2 - 1486*D1*Dd*b1*f**3*s + 799*D1*Dd*b1*f**3 - 5400*D1*Dd*b1*f**2*fd*r**2 - 9840*D1*Dd*b1*f**2*fd*r*s + 7650*D1*Dd*b1*f**2*fd*r - 4440*D1*Dd*b1*f**2*fd*s**2 + 6970*D1*Dd*b1*f**2*fd*s - 2710*D1*Dd*b1*f**2*fd + 588*D1*Dd*b1*f**2*r**2 + 552*D1*Dd*b1*f**2*r*s - 726*D1*Dd*b1*f**2*r - 36*D1*Dd*b1*f**2*s**2 - 258*D1*Dd*b1*f**2*s + 285*D1*Dd*b1*f**2 - 2016*D1*Dd*b1*f*fd*r**2 - 3456*D1*Dd*b1*f*fd*r*s + 2304*D1*Dd*b1*f*fd*r - 1440*D1*Dd*b1*f*fd*s**2 + 1944*D1*Dd*b1*f*fd*s - 612*D1*Dd*b1*f*fd - 780*D1*Dd*f**4*r**2 - 2040*D1*Dd*f**4*r*s + 1290*D1*Dd*f**4*r - 1260*D1*Dd*f**4*s**2 + 1650*D1*Dd*f**4*s - 705*D1*Dd*f**4 + 7200*D1*Dd*f**3*fd*r**2 + 14400*D1*Dd*f**3*fd*r*s - 10800*D1*Dd*f**3*fd*r + 7200*D1*Dd*f**3*fd*s**2 - 10800*D1*Dd*f**3*fd*s + 4050*D1*Dd*f**3*fd + 372*D1*Dd*f**3*r**2 + 360*D1*Dd*f**3*r*s - 462*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 - 174*D1*Dd*f**3*s + 183*D1*Dd*f**3 - 1296*D1*Dd*f**2*fd*r**2 - 1728*D1*Dd*f**2*fd*r*s + 1584*D1*Dd*f**2*fd*r - 432*D1*Dd*f**2*fd*s**2 + 972*D1*Dd*f**2*fd*s - 468*D1*Dd*f**2*fd + 576*D1*Dd*f**2*g2*r**2 - 672*D1*Dd*f**2*g2*r*s - 408*D1*Dd*f**2*g2*r - 1248*D1*Dd*f**2*g2*s**2 + 960*D1*Dd*f**2*g2*s - 24*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r**2 + 864*D1*Dd*f**2*gd2*r + 576*D1*Dd*f**2*gd2*s**2 - 144*D1*Dd*f**2*gd2*s - 288*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r**2 + 576*D1*Dd*f*fd*g2*r + 1152*D1*Dd*f*fd*g2*s**2 - 864*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 144*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r - 144*D1*Ddd*K*b1*f**2*s**2 + 72*D1*Ddd*K*b1*f**2*s + 36*D1*Ddd*K*b1*f**2 - 900*D1*Ddd*b1*f**3*r**2 - 1640*D1*Ddd*b1*f**3*r*s + 1310*D1*Ddd*b1*f**3*r - 740*D1*Ddd*b1*f**3*s**2 + 1190*D1*Ddd*b1*f**3*s - 635*D1*Ddd*b1*f**3 - 504*D1*Ddd*b1*f**2*r**2 - 864*D1*Ddd*b1*f**2*r*s + 720*D1*Ddd*b1*f**2*r - 360*D1*Ddd*b1*f**2*s**2 + 612*D1*Ddd*b1*f**2*s - 342*D1*Ddd*b1*f**2 + 900*D1*Ddd*f**4*r**2 + 1800*D1*Ddd*f**4*r*s - 1350*D1*Ddd*f**4*r + 900*D1*Ddd*f**4*s**2 - 1350*D1*Ddd*f**4*s + 675*D1*Ddd*f**4 - 216*D1*Ddd*f**3*r**2 - 288*D1*Ddd*f**3*r*s + 288*D1*Ddd*f**3*r - 72*D1*Ddd*f**3*s**2 + 180*D1*Ddd*f**3*s - 126*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r + 288*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s - 72*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(f**2*(285*r**2 + r*(514*s - 478) + 229*s**2 - 422*s + 313) - f*(10*fd*(135*r**2 + 3*r*(82*s - 69) + 111*s**2 - 187*s + 64) + (3*r + 3*s - 3)*(4*K*(6*r - 13*s - 6) - 49*r + 3*s + 49)) + 36*fd*(r**2*(4*K - 14) - 4*r*(K + 6*s - 5) - (2*s - 1)*(2*K*s + 5*s - 6))) - 2*Dd*f*(-36*K*(4*r**2 - 6*r - 4*s**2 + s + 2) + 5*f*(180*r**2 + r*(328*s - 283) + 148*s**2 - 255*s + 110) + 504*r**2 + 864*r*(s - 1) + 360*s**2 - 738*s + 360)) + 432*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r - 432*Dd**2*K*b1*f**2*s**2 + 216*Dd**2*K*b1*f**2*s + 72*Dd**2*K*b1*f**2 - 2700*Dd**2*b1*f**3*r**2 - 4920*Dd**2*b1*f**3*r*s + 3930*Dd**2*b1*f**3*r - 2220*Dd**2*b1*f**3*s**2 + 3570*Dd**2*b1*f**3*s - 1270*Dd**2*b1*f**3 - 1512*Dd**2*b1*f**2*r**2 - 2592*Dd**2*b1*f**2*r*s + 2160*Dd**2*b1*f**2*r - 1080*Dd**2*b1*f**2*s**2 + 1836*Dd**2*b1*f**2*s - 684*Dd**2*b1*f**2 + 2700*Dd**2*f**4*r**2 + 5400*Dd**2*f**4*r*s - 4050*Dd**2*f**4*r + 2700*Dd**2*f**4*s**2 - 4050*Dd**2*f**4*s + 1350*Dd**2*f**4 - 648*Dd**2*f**3*r**2 - 864*Dd**2*f**3*r*s + 864*Dd**2*f**3*r - 216*Dd**2*f**3*s**2 + 540*Dd**2*f**3*s - 252*Dd**2*f**3 - 864*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r + 864*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s - 144*Dd**2*f**2*g2)/(210*d**2*k3**5) + D1**2*Pk2*Pkd3*ct*k1**3*k2*st**2*(36*C*D1**2*bdd1*f**2*r**2 + 72*C*D1**2*bdd1*f**2*r*s - 432*C*D1**2*bdd1*f**2*r + 36*C*D1**2*bdd1*f**2*s**2 - 432*C*D1**2*bdd1*f**2*s + 216*C*D1**2*bdd1*f**2 - 2436*C*D1**2*f**2*fd*r**2 - 6576*C*D1**2*f**2*fd*r*s + 3816*C*D1**2*f**2*fd*r - 4140*C*D1**2*f**2*fd*s**2 + 4952*C*D1**2*f**2*fd*s - 2192*C*D1**2*f**2*fd + 2892*C*D1**2*f**2*fdd*r**2 + 7608*C*D1**2*f**2*fdd*r*s - 4464*C*D1**2*f**2*fdd*r + 4716*C*D1**2*f**2*fdd*s**2 - 5680*C*D1**2*f**2*fdd*s + 2536*C*D1**2*f**2*fdd + 5784*C*D1**2*f*fd**2*r**2 + 15216*C*D1**2*f*fd**2*r*s - 8928*C*D1**2*f*fd**2*r + 9432*C*D1**2*f*fd**2*s**2 - 11360*C*D1**2*f*fd**2*s + 2536*C*D1**2*f*fd**2 - 3248*C*D1*Dd*f**3*r**2 - 8768*C*D1*Dd*f**3*r*s + 5440*C*D1*Dd*f**3*r - 5520*C*D1*Dd*f**3*s**2 + 7144*C*D1*Dd*f**3*s - 3004*C*D1*Dd*f**3 + 23136*C*D1*Dd*f**2*fd*r**2 + 60864*C*D1*Dd*f**2*fd*r*s - 37032*C*D1*Dd*f**2*fd*r + 37728*C*D1*Dd*f**2*fd*s**2 - 47368*C*D1*Dd*f**2*fd*s + 14608*C*D1*Dd*f**2*fd + 3856*C*D1*Ddd*f**3*r**2 + 10144*C*D1*Ddd*f**3*r*s - 6392*C*D1*Ddd*f**3*r + 6288*C*D1*Ddd*f**3*s**2 - 8216*C*D1*Ddd*f**3*s + 3500*C*D1*Ddd*f**3 + 11568*C*Dd**2*f**3*r**2 + 30432*C*Dd**2*f**3*r*s - 19176*C*Dd**2*f**3*r + 18864*C*Dd**2*f**3*s**2 - 24648*C*Dd**2*f**3*s + 7000*C*Dd**2*f**3 + 858*D1**2*K*bdd1*f**2*r**2 + 2436*D1**2*K*bdd1*f**2*r*s - 1716*D1**2*K*bdd1*f**2*r + 1578*D1**2*K*bdd1*f**2*s**2 - 2436*D1**2*K*bdd1*f**2*s + 858*D1**2*K*bdd1*f**2 - 480*D1**2*b2*f*fd*r**2 - 960*D1**2*b2*f*fd*r*s + 480*D1**2*b2*f*fd*r - 480*D1**2*b2*f*fd*s**2 + 480*D1**2*b2*f*fd*s - 240*D1**2*b2*f*fd + 1080*D1**2*b2*f*fdd*r**2 + 2160*D1**2*b2*f*fdd*r*s - 1080*D1**2*b2*f*fdd*r + 1080*D1**2*b2*f*fdd*s**2 - 1080*D1**2*b2*f*fdd*s + 540*D1**2*b2*f*fdd + 1080*D1**2*b2*fd**2*r**2 + 2160*D1**2*b2*fd**2*r*s - 1080*D1**2*b2*fd**2*r + 1080*D1**2*b2*fd**2*s**2 - 1080*D1**2*b2*fd**2*s - 6*D1**2*bd1**2*f*(r + s - 1)*(-14*K*(r + s - 6) + 270*f*(r + s - 1) + 259*r + 259*s - 294) - 240*D1**2*bd2*f**2*r**2 - 480*D1**2*bd2*f**2*r*s + 480*D1**2*bd2*f**2*r - 240*D1**2*bd2*f**2*s**2 + 480*D1**2*bd2*f**2*s - 240*D1**2*bd2*f**2 + 2160*D1**2*bd2*f*fd*r**2 + 4320*D1**2*bd2*f*fd*r*s - 3240*D1**2*bd2*f*fd*r + 2160*D1**2*bd2*f*fd*s**2 - 3240*D1**2*bd2*f*fd*s + 1080*D1**2*bd2*f*fd + 432*D1**2*bdd1*f**3*r**2 - 432*D1**2*bdd1*f**3*r - 432*D1**2*bdd1*f**3*s**2 + 432*D1**2*bdd1*f**3*s - 510*D1**2*bdd1*f**2*r**2 - 1380*D1**2*bdd1*f**2*r*s + 1290*D1**2*bdd1*f**2*r - 870*D1**2*bdd1*f**2*s**2 + 1650*D1**2*bdd1*f**2*s - 645*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r**2 - 168*D1**2*bdd1*f*g2*r*s + 1008*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 1008*D1**2*bdd1*f*g2*s - 504*D1**2*bdd1*f*g2 + 540*D1**2*bdd2*f**2*r**2 + 1080*D1**2*bdd2*f**2*r*s - 1080*D1**2*bdd2*f**2*r + 540*D1**2*bdd2*f**2*s**2 - 1080*D1**2*bdd2*f**2*s + 540*D1**2*bdd2*f**2 + 1278*D1**2*f**2*fd*r**2 + 3888*D1**2*f**2*fd*r*s - 2148*D1**2*f**2*fd*r + 2610*D1**2*f**2*fd*s**2 - 3036*D1**2*f**2*fd*s + 1296*D1**2*f**2*fd - 1719*D1**2*f**2*fdd*r**2 - 4806*D1**2*f**2*fdd*r*s + 2748*D1**2*f**2*fdd*r - 3087*D1**2*f**2*fdd*s**2 + 3660*D1**2*f**2*fdd*s - 1602*D1**2*f**2*fdd + 828*D1**2*f**2*gd2*r**2 + 3024*D1**2*f**2*gd2*r*s - 1656*D1**2*f**2*gd2*r + 2196*D1**2*f**2*gd2*s**2 - 3024*D1**2*f**2*gd2*s + 828*D1**2*f**2*gd2 - 1716*D1**2*f**2*gdd2*r**2 - 4872*D1**2*f**2*gdd2*r*s + 3432*D1**2*f**2*gdd2*r - 3156*D1**2*f**2*gdd2*s**2 + 4872*D1**2*f**2*gdd2*s - 1716*D1**2*f**2*gdd2 - 3438*D1**2*f*fd**2*r**2 - 9612*D1**2*f*fd**2*r*s + 5496*D1**2*f*fd**2*r - 6174*D1**2*f*fd**2*s**2 + 7320*D1**2*f*fd**2*s - 1602*D1**2*f*fd**2 + 1656*D1**2*f*fd*g2*r**2 + 6048*D1**2*f*fd*g2*r*s - 3024*D1**2*f*fd*g2*r + 4392*D1**2*f*fd*g2*s**2 - 4392*D1**2*f*fd*g2*s + 2196*D1**2*f*fd*g2 - 6864*D1**2*f*fd*gd2*r**2 - 19488*D1**2*f*fd*gd2*r*s + 11736*D1**2*f*fd*gd2*r - 12624*D1**2*f*fd*gd2*s**2 + 16056*D1**2*f*fd*gd2*s - 4872*D1**2*f*fd*gd2 - 3432*D1**2*f*fdd*g2*r**2 - 9744*D1**2*f*fdd*g2*r*s + 4872*D1**2*f*fdd*g2*r - 6312*D1**2*f*fdd*g2*s**2 + 6312*D1**2*f*fdd*g2*s - 3156*D1**2*f*fdd*g2 - 3432*D1**2*fd**2*g2*r**2 - 9744*D1**2*fd**2*g2*r*s + 4872*D1**2*fd**2*g2*r - 6312*D1**2*fd**2*g2*s**2 + 6312*D1**2*fd**2*g2*s - 960*D1*Dd*b2*f**2*r**2 - 1920*D1*Dd*b2*f**2*r*s + 1440*D1*Dd*b2*f**2*r - 960*D1*Dd*b2*f**2*s**2 + 1440*D1*Dd*b2*f**2*s - 720*D1*Dd*b2*f**2 + 8640*D1*Dd*b2*f*fd*r**2 + 17280*D1*Dd*b2*f*fd*r*s - 10800*D1*Dd*b2*f*fd*r + 8640*D1*Dd*b2*f*fd*s**2 - 10800*D1*Dd*b2*f*fd*s + 3240*D1*Dd*b2*f*fd + 4320*D1*Dd*bd2*f**2*r**2 + 8640*D1*Dd*bd2*f**2*r*s - 7560*D1*Dd*bd2*f**2*r + 4320*D1*Dd*bd2*f**2*s**2 - 7560*D1*Dd*bd2*f**2*s + 3240*D1*Dd*bd2*f**2 + 1704*D1*Dd*f**3*r**2 + 5184*D1*Dd*f**3*r*s - 3000*D1*Dd*f**3*r + 3480*D1*Dd*f**3*s**2 - 4332*D1*Dd*f**3*s + 1722*D1*Dd*f**3 - 13752*D1*Dd*f**2*fd*r**2 - 38448*D1*Dd*f**2*fd*r*s + 22674*D1*Dd*f**2*fd*r - 24696*D1*Dd*f**2*fd*s**2 + 30426*D1*Dd*f**2*fd*s - 9156*D1*Dd*f**2*fd + 3312*D1*Dd*f**2*g2*r**2 + 12096*D1*Dd*f**2*g2*r*s - 6336*D1*Dd*f**2*g2*r + 8784*D1*Dd*f**2*g2*s**2 - 10440*D1*Dd*f**2*g2*s + 3852*D1*Dd*f**2*g2 - 13728*D1*Dd*f**2*gd2*r**2 - 38976*D1*Dd*f**2*gd2*r*s + 25464*D1*Dd*f**2*gd2*r - 25248*D1*Dd*f**2*gd2*s**2 + 35544*D1*Dd*f**2*gd2*s - 11736*D1*Dd*f**2*gd2 - 27456*D1*Dd*f*fd*g2*r**2 - 77952*D1*Dd*f*fd*g2*r*s + 42960*D1*Dd*f*fd*g2*r - 50496*D1*Dd*f*fd*g2*s**2 + 57360*D1*Dd*f*fd*g2*s - 16056*D1*Dd*f*fd*g2 + 2160*D1*Ddd*b2*f**2*r**2 + 4320*D1*Ddd*b2*f**2*r*s - 3240*D1*Ddd*b2*f**2*r + 2160*D1*Ddd*b2*f**2*s**2 - 3240*D1*Ddd*b2*f**2*s + 1620*D1*Ddd*b2*f**2 - 2292*D1*Ddd*f**3*r**2 - 6408*D1*Ddd*f**3*r*s + 3894*D1*Ddd*f**3*r - 4116*D1*Ddd*f**3*s**2 + 5262*D1*Ddd*f**3*s - 2175*D1*Ddd*f**3 - 6864*D1*Ddd*f**2*g2*r**2 - 19488*D1*Ddd*f**2*g2*r*s + 11736*D1*Ddd*f**2*g2*r - 12624*D1*Ddd*f**2*g2*s**2 + 16056*D1*Ddd*f**2*g2*s - 6588*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(9*f**3*(26*r**2 + r*(20*s - 38) - 6*s**2 - 6*s + 17) + f**2*(4*C*(41*r**2 + r*(68*s - 58) + 27*s**2 - 44*s + 22) + 138*K*r**2 + 504*K*r*s - 276*K*r + 366*K*s**2 - 504*K*s + 138*K - 144*fd*(6*r**2 - 6*r - 6*s**2 + 4*s + 1) - 284*r**2 - 640*r*s + 482*r - 356*s**2 + 554*s - 213) - 2*f*(24*C*fd*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 3) + 2*K*fd*(286*r**2 + r*(812*s - 489) + 526*s**2 - 669*s + 203) - 5*fd*(68*r**2 + r*(184*s - 123) + 116*s**2 - 159*s + 55) + 14*g2*(27*r**2 + 2*r*(22*s - 7) + 17*s**2 - 4*s + 2) - 28*gd2*(r**2 + r*(2*s - 7) + s**2 - 7*s + 6)) + 56*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(72*f**2*(8*r**2 - 8*r - 8*s**2 + 6*s + 1) + f*(12*C*(4*r**2 + r*(8*s - 27) + 4*s**2 - 27*s + 18) + 2*K*(572*r**2 + 1624*r*s - 1061*r + 1052*s**2 - 1481*s + 489) - 680*r**2 - 1840*r*s + 1430*r - 1160*s**2 + 1850*s - 705) - 28*g2*(4*r**2 + r*(8*s - 27) + 4*s**2 - 27*s + 18))) + 6480*Dd**2*b2*f**2*r**2 + 12960*Dd**2*b2*f**2*r*s - 9720*Dd**2*b2*f**2*r + 6480*Dd**2*b2*f**2*s**2 - 9720*Dd**2*b2*f**2*s + 3240*Dd**2*b2*f**2 - 6876*Dd**2*f**3*r**2 - 19224*Dd**2*f**3*r*s + 11682*Dd**2*f**3*r - 12348*Dd**2*f**3*s**2 + 15786*Dd**2*f**3*s - 4350*Dd**2*f**3 - 20592*Dd**2*f**2*g2*r**2 - 58464*Dd**2*f**2*g2*r*s + 35208*Dd**2*f**2*g2*r - 37872*Dd**2*f**2*g2*s**2 + 48168*Dd**2*f**2*g2*s - 13176*Dd**2*f**2*g2 + 3*b1**2*(D1**2*(-540*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(-7*K*(54*r**2 + 88*r*s - 60*r + 34*s**2 - 60*s + 30) + 5*f*(160*r**2 + r*(320*s - 202) + 160*s**2 - 202*s + 101) + 518*r**2 + 896*r*s - 210*r + 378*s**2 - 210*s + 105) - fdd*(-14*K*(r**2 + 2*r*(s + 5) + s**2 + 10*s - 5) + 270*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 259*r**2 + 518*r*s + 70*r + 259*s**2 + 70*s - 35)) + D1*(2*Dd*(200*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(7*K*(108*r**2 + 8*r*(22*s - 19) + 68*s**2 - 122*s + 71) + 270*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 1036*r**2 - 1792*r*s + 1484*r - 756*s**2 + 1274*s - 707) + 7*fd*(4*r + 4*s - 3)*(2*K*(r + s + 5) - 37*r - 37*s - 5)) - Ddd*f*(-14*K + 270*f + 259)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 270*f + 259)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-328*C*D1**2*f*fd*r**2 - 544*C*D1**2*f*fd*r*s + 368*C*D1**2*f*fd*r - 216*C*D1**2*f*fd*s**2 + 312*C*D1**2*f*fd*s - 184*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s + 96*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 + 96*C*D1**2*f*fdd*s - 48*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s + 96*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 + 96*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 - 656*C*D1*Dd*f**2*r**2 - 1088*C*D1*Dd*f**2*r*s + 928*C*D1*Dd*f**2*r - 432*C*D1*Dd*f**2*s**2 + 760*C*D1*Dd*f**2*s - 436*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s + 240*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 + 240*C*D1*Dd*f*fd*s - 288*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 276*D1**2*K*f*fd*r**2 - 1008*D1**2*K*f*fd*r*s + 504*D1**2*K*f*fd*r - 732*D1**2*K*f*fd*s**2 + 732*D1**2*K*f*fd*s - 366*D1**2*K*f*fd + 572*D1**2*K*f*fdd*r**2 + 1624*D1**2*K*f*fdd*r*s - 812*D1**2*K*f*fdd*r + 1052*D1**2*K*f*fdd*s**2 - 1052*D1**2*K*f*fdd*s + 526*D1**2*K*f*fdd + 572*D1**2*K*fd**2*r**2 + 1624*D1**2*K*fd**2*r*s - 812*D1**2*K*fd**2*r + 1052*D1**2*K*fd**2*s**2 - 1052*D1**2*K*fd**2*s - D1**2*bdd1*f*(-14*K*(2*r**2 + 4*r*s - 14*r + 2*s**2 - 14*s + 7) + 540*f*(r + s - 1)**2 + 518*r**2 + 1036*r*s - 1106*r + 518*s**2 - 1106*s + 553) - 702*D1**2*f**2*fd*r**2 - 540*D1**2*f**2*fd*r*s + 774*D1**2*f**2*fd*r + 162*D1**2*f**2*fd*s**2 + 198*D1**2*f**2*fd*s - 261*D1**2*f**2*fd + 432*D1**2*f**2*fdd*r**2 - 432*D1**2*f**2*fdd*r - 432*D1**2*f**2*fdd*s**2 + 144*D1**2*f**2*fdd*s + 144*D1**2*f**2*fdd + 864*D1**2*f*fd**2*r**2 - 864*D1**2*f*fd**2*r - 864*D1**2*f*fd**2*s**2 + 288*D1**2*f*fd**2*s + 144*D1**2*f*fd**2 + 568*D1**2*f*fd*r**2 + 1280*D1**2*f*fd*r*s - 726*D1**2*f*fd*r + 712*D1**2*f*fd*s**2 - 798*D1**2*f*fd*s + 427*D1**2*f*fd - 340*D1**2*f*fdd*r**2 - 920*D1**2*f*fdd*r*s + 370*D1**2*f*fdd*r - 580*D1**2*f*fdd*s**2 + 490*D1**2*f*fdd*s - 245*D1**2*f*fdd + 756*D1**2*f*gd2*r**2 + 1232*D1**2*f*gd2*r*s - 1512*D1**2*f*gd2*r + 476*D1**2*f*gd2*s**2 - 1232*D1**2*f*gd2*s + 756*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 340*D1**2*fd**2*r**2 - 920*D1**2*fd**2*r*s + 370*D1**2*fd**2*r - 580*D1**2*fd**2*s**2 + 490*D1**2*fd**2*s + 90*D1**2*fd**2 + 756*D1**2*fd*g2*r**2 + 1232*D1**2*fd*g2*r*s - 840*D1**2*fd*g2*r + 476*D1**2*fd*g2*s**2 - 840*D1**2*fd*g2*s + 420*D1**2*fd*g2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s - 224*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 - 224*D1**2*fd*gd2*s + 280*D1**2*fd*gd2 - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 280*D1**2*fdd*g2*r - 28*D1**2*fdd*g2*s**2 - 280*D1**2*fdd*g2*s + 140*D1**2*fdd*g2 - 552*D1*Dd*K*f**2*r**2 - 2016*D1*Dd*K*f**2*r*s + 1056*D1*Dd*K*f**2*r - 1464*D1*Dd*K*f**2*s**2 + 1740*D1*Dd*K*f**2*s - 642*D1*Dd*K*f**2 + 4576*D1*Dd*K*f*fd*r**2 + 12992*D1*Dd*K*f*fd*r*s - 7160*D1*Dd*K*f*fd*r + 8416*D1*Dd*K*f*fd*s**2 - 9560*D1*Dd*K*f*fd*s + 2676*D1*Dd*K*f*fd - 936*D1*Dd*f**3*r**2 - 720*D1*Dd*f**3*r*s + 1116*D1*Dd*f**3*r + 216*D1*Dd*f**3*s**2 + 252*D1*Dd*f**3*s - 414*D1*Dd*f**3 + 3456*D1*Dd*f**2*fd*r**2 - 3456*D1*Dd*f**2*fd*r - 3456*D1*Dd*f**2*fd*s**2 + 1440*D1*Dd*f**2*fd*s + 720*D1*Dd*f**2*fd + 1136*D1*Dd*f**2*r**2 + 2560*D1*Dd*f**2*r*s - 1776*D1*Dd*f**2*r + 1424*D1*Dd*f**2*s**2 - 1992*D1*Dd*f**2*s + 924*D1*Dd*f**2 - 2720*D1*Dd*f*fd*r**2 - 7360*D1*Dd*f*fd*r*s + 3760*D1*Dd*f*fd*r - 4640*D1*Dd*f*fd*s**2 + 4960*D1*Dd*f*fd*s - 1230*D1*Dd*f*fd + 3024*D1*Dd*f*g2*r**2 + 4928*D1*Dd*f*g2*r*s - 4256*D1*Dd*f*g2*r + 1904*D1*Dd*f*g2*s**2 - 3416*D1*Dd*f*g2*s + 1988*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s - 952*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 - 952*D1*Dd*fd*g2*s + 840*D1*Dd*fd*g2 + 1144*D1*Ddd*K*f**2*r**2 + 3248*D1*Ddd*K*f**2*r*s - 1956*D1*Ddd*K*f**2*r + 2104*D1*Ddd*K*f**2*s**2 - 2676*D1*Ddd*K*f**2*s + 1098*D1*Ddd*K*f**2 + 576*D1*Ddd*f**3*r**2 - 576*D1*Ddd*f**3*r - 576*D1*Ddd*f**3*s**2 + 288*D1*Ddd*f**3*s + 144*D1*Ddd*f**3 - 680*D1*Ddd*f**2*r**2 - 1840*D1*Ddd*f**2*r*s + 1140*D1*Ddd*f**2*r - 1160*D1*Ddd*f**2*s**2 + 1500*D1*Ddd*f**2*s - 630*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + D1*bd1*(D1*(5*f**2*(160*r**2 + r*(320*s - 278) + 160*s**2 - 278*s + 139) - f*(14*K*(54*r**2 + 88*r*s - 68*r + 34*s**2 - 48*s + 29) + 1080*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 1036*r**2 - 1792*r*s + 1722*r - 756*s**2 + 1442*s - 791) + 14*fd*(r + s - 1)*(2*K*(2*r + 2*s + 5) - 74*r - 74*s - 5)) - 2*Dd*f*(4*r + 4*s - 3)*(-14*K*(2*r + 2*s - 7) + 540*f*(r + s - 1) + 518*r + 518*s - 553)) + 3432*Dd**2*K*f**2*r**2 + 9744*Dd**2*K*f**2*r*s - 5868*Dd**2*K*f**2*r + 6312*Dd**2*K*f**2*s**2 - 8028*Dd**2*K*f**2*s + 2196*Dd**2*K*f**2 + 1728*Dd**2*f**3*r**2 - 1728*Dd**2*f**3*r - 1728*Dd**2*f**3*s**2 + 864*Dd**2*f**3*s + 288*Dd**2*f**3 - 2040*Dd**2*f**2*r**2 - 5520*Dd**2*f**2*r*s + 3420*Dd**2*f**2*r - 3480*Dd**2*f**2*s**2 + 4500*Dd**2*f**2*s - 1260*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(630*d**2*k3**5) - D1**2*Pk2*Pkd3*ct*k1**3*k2*(840*C*D1**2*bd1**2*f*r**2 + 1680*C*D1**2*bd1**2*f*r*s - 840*C*D1**2*bd1**2*f*r + 840*C*D1**2*bd1**2*f*s**2 - 840*C*D1**2*bd1**2*f*s + 708*C*D1**2*bd1*f**2*r**2 + 1608*C*D1**2*bd1*f**2*r*s - 1608*C*D1**2*bd1*f**2*r + 900*C*D1**2*bd1*f**2*s**2 - 1800*C*D1**2*bd1*f**2*s + 900*C*D1**2*bd1*f**2 - 4944*C*D1**2*bd1*f*fd*r**2 - 10944*C*D1**2*bd1*f*fd*r*s + 7944*C*D1**2*bd1*f*fd*r - 6000*C*D1**2*bd1*f*fd*s**2 + 8736*C*D1**2*bd1*f*fd*s - 2736*C*D1**2*bd1*f*fd - 1236*C*D1**2*bdd1*f**2*r**2 - 2736*C*D1**2*bdd1*f**2*r*s + 2736*C*D1**2*bdd1*f**2*r - 1500*C*D1**2*bdd1*f**2*s**2 + 3000*C*D1**2*bdd1*f**2*s - 1500*C*D1**2*bdd1*f**2 + 360*C*D1**2*f**2*fd*r*s - 120*C*D1**2*f**2*fd*r + 360*C*D1**2*f**2*fd*s**2 - 360*C*D1**2*f**2*fd*s + 120*C*D1**2*f**2*fd - 360*C*D1**2*f**2*fdd*r*s + 120*C*D1**2*f**2*fdd*r - 360*C*D1**2*f**2*fdd*s**2 + 360*C*D1**2*f**2*fdd*s - 120*C*D1**2*f**2*fdd - 720*C*D1**2*f*fd**2*r*s + 240*C*D1**2*f*fd**2*r - 720*C*D1**2*f*fd**2*s**2 + 720*C*D1**2*f*fd**2*s - 120*C*D1**2*f*fd**2 - 9888*C*D1*Dd*bd1*f**2*r**2 - 21888*C*D1*Dd*bd1*f**2*r*s + 18624*C*D1*Dd*bd1*f**2*r - 12000*C*D1*Dd*bd1*f**2*s**2 + 20472*C*D1*Dd*bd1*f**2*s - 8472*C*D1*Dd*bd1*f**2 + 480*C*D1*Dd*f**3*r*s - 120*C*D1*Dd*f**3*r + 480*C*D1*Dd*f**3*s**2 - 480*C*D1*Dd*f**3*s + 120*C*D1*Dd*f**3 - 2880*C*D1*Dd*f**2*fd*r*s + 840*C*D1*Dd*f**2*fd*r - 2880*C*D1*Dd*f**2*fd*s**2 + 2880*C*D1*Dd*f**2*fd*s - 600*C*D1*Dd*f**2*fd - 480*C*D1*Ddd*f**3*r*s + 120*C*D1*Ddd*f**3*r - 480*C*D1*Ddd*f**3*s**2 + 480*C*D1*Ddd*f**3*s - 120*C*D1*Ddd*f**3 - 1440*C*Dd**2*f**3*r*s + 360*C*Dd**2*f**3*r - 1440*C*Dd**2*f**3*s**2 + 1440*C*Dd**2*f**3*s - 240*C*Dd**2*f**3 - 1708*D1**2*K*bd1**2*f*r**2 - 3920*D1**2*K*bd1**2*f*r*s + 3668*D1**2*K*bd1**2*f*r - 2212*D1**2*K*bd1**2*f*s**2 + 4172*D1**2*K*bd1**2*f*s - 1960*D1**2*K*bd1**2*f + 84*D1**2*K*bd1*f**2*r*s + 84*D1**2*K*bd1*f**2*s**2 - 84*D1**2*K*bd1*f**2*s - 336*D1**2*K*bd1*f*fd*r*s + 84*D1**2*K*bd1*f*fd*r - 336*D1**2*K*bd1*f*fd*s**2 + 336*D1**2*K*bd1*f*fd*s - 84*D1**2*K*bd1*f*fd - 84*D1**2*K*bdd1*f**2*r*s - 84*D1**2*K*bdd1*f**2*s**2 + 84*D1**2*K*bdd1*f**2*s + 1218*D1**2*bd1**2*f**2*r**2 + 2100*D1**2*bd1**2*f**2*r*s - 2268*D1**2*bd1**2*f**2*r + 882*D1**2*bd1**2*f**2*s**2 - 1932*D1**2*bd1**2*f**2*s + 1050*D1**2*bd1**2*f**2 - 196*D1**2*bd1**2*f*r**2 - 224*D1**2*bd1**2*f*r*s - 322*D1**2*bd1**2*f*r - 28*D1**2*bd1**2*f*s**2 - 490*D1**2*bd1**2*f*s + 518*D1**2*bd1**2*f - 1400*D1**2*bd1**2*g2*r**2 - 2800*D1**2*bd1**2*g2*r*s + 1400*D1**2*bd1**2*g2*r - 1400*D1**2*bd1**2*g2*s**2 + 1400*D1**2*bd1**2*g2*s - 840*D1**2*bd1*bd2*f*r**2 - 1680*D1**2*bd1*bd2*f*r*s + 1680*D1**2*bd1*bd2*f*r - 840*D1**2*bd1*bd2*f*s**2 + 1680*D1**2*bd1*bd2*f*s - 840*D1**2*bd1*bd2*f - 294*D1**2*bd1*f**2*r**2 - 756*D1**2*bd1*f**2*r*s + 756*D1**2*bd1*f**2*r - 462*D1**2*bd1*f**2*s**2 + 924*D1**2*bd1*f**2*s - 462*D1**2*bd1*f**2 + 3108*D1**2*bd1*f*fd*r**2 + 6888*D1**2*bd1*f*fd*r*s - 4998*D1**2*bd1*f*fd*r + 3780*D1**2*bd1*f*fd*s**2 - 5502*D1**2*bd1*f*fd*s + 1722*D1**2*bd1*f*fd - 476*D1**2*bd1*f*g2*r**2 - 1400*D1**2*bd1*f*g2*r*s + 1400*D1**2*bd1*f*g2*r - 924*D1**2*bd1*f*g2*s**2 + 1848*D1**2*bd1*f*g2*s - 924*D1**2*bd1*f*g2 + 3416*D1**2*bd1*f*gd2*r**2 + 7840*D1**2*bd1*f*gd2*r*s - 7336*D1**2*bd1*f*gd2*r + 4424*D1**2*bd1*f*gd2*s**2 - 8344*D1**2*bd1*f*gd2*s + 3920*D1**2*bd1*f*gd2 + 3416*D1**2*bd1*fd*g2*r**2 + 7840*D1**2*bd1*fd*g2*r*s - 3920*D1**2*bd1*fd*g2*r + 4424*D1**2*bd1*fd*g2*s**2 - 4424*D1**2*bd1*fd*g2*s + 777*D1**2*bdd1*f**2*r**2 + 1722*D1**2*bdd1*f**2*r*s - 1722*D1**2*bdd1*f**2*r + 945*D1**2*bdd1*f**2*s**2 - 1890*D1**2*bdd1*f**2*s + 945*D1**2*bdd1*f**2 + 1708*D1**2*bdd1*f*g2*r**2 + 3920*D1**2*bdd1*f*g2*r*s - 3920*D1**2*bdd1*f*g2*r + 2212*D1**2*bdd1*f*g2*s**2 - 4424*D1**2*bdd1*f*g2*s + 2212*D1**2*bdd1*f*g2 - 180*D1**2*f**2*fd*r*s + 60*D1**2*f**2*fd*r - 180*D1**2*f**2*fd*s**2 + 180*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 180*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 180*D1**2*f**2*fdd*s**2 - 180*D1**2*f**2*fdd*s + 60*D1**2*f**2*fdd - 168*D1**2*f**2*gd2*r*s - 168*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s + 168*D1**2*f**2*gdd2*r*s + 168*D1**2*f**2*gdd2*s**2 - 168*D1**2*f**2*gdd2*s + 360*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 360*D1**2*f*fd**2*s**2 - 360*D1**2*f*fd**2*s + 60*D1**2*f*fd**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r - 336*D1**2*f*fd*g2*s**2 + 336*D1**2*f*fd*g2*s - 168*D1**2*f*fd*g2 + 672*D1**2*f*fd*gd2*r*s - 168*D1**2*f*fd*gd2*r + 672*D1**2*f*fd*gd2*s**2 - 672*D1**2*f*fd*gd2*s + 168*D1**2*f*fd*gd2 + 336*D1**2*f*fdd*g2*r*s - 168*D1**2*f*fdd*g2*r + 336*D1**2*f*fdd*g2*s**2 - 336*D1**2*f*fdd*g2*s + 168*D1**2*f*fdd*g2 + 336*D1**2*fd**2*g2*r*s - 168*D1**2*fd**2*g2*r + 336*D1**2*fd**2*g2*s**2 - 336*D1**2*fd**2*g2*s - 672*D1*Dd*K*bd1*f**2*r*s + 84*D1*Dd*K*bd1*f**2*r - 672*D1*Dd*K*bd1*f**2*s**2 + 672*D1*Dd*K*bd1*f**2*s - 84*D1*Dd*K*bd1*f**2 + 6216*D1*Dd*bd1*f**2*r**2 + 13776*D1*Dd*bd1*f**2*r*s - 11718*D1*Dd*bd1*f**2*r + 7560*D1*Dd*bd1*f**2*s**2 - 12894*D1*Dd*bd1*f**2*s + 5334*D1*Dd*bd1*f**2 + 13664*D1*Dd*bd1*f*g2*r**2 + 31360*D1*Dd*bd1*f*g2*r*s - 26432*D1*Dd*bd1*f*g2*r + 17696*D1*Dd*bd1*f*g2*s**2 - 29960*D1*Dd*bd1*f*g2*s + 12264*D1*Dd*bd1*f*g2 - 240*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 240*D1*Dd*f**3*s**2 + 240*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 1440*D1*Dd*f**2*fd*r*s - 420*D1*Dd*f**2*fd*r + 1440*D1*Dd*f**2*fd*s**2 - 1440*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd - 672*D1*Dd*f**2*g2*r*s + 168*D1*Dd*f**2*g2*r - 672*D1*Dd*f**2*g2*s**2 + 672*D1*Dd*f**2*g2*s - 168*D1*Dd*f**2*g2 + 1344*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 1344*D1*Dd*f**2*gd2*s**2 - 1344*D1*Dd*f**2*gd2*s + 168*D1*Dd*f**2*gd2 + 2688*D1*Dd*f*fd*g2*r*s - 1008*D1*Dd*f*fd*g2*r + 2688*D1*Dd*f*fd*g2*s**2 - 2688*D1*Dd*f*fd*g2*s + 672*D1*Dd*f*fd*g2 + 240*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 240*D1*Ddd*f**3*s**2 - 240*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 672*D1*Ddd*f**2*g2*r*s - 168*D1*Ddd*f**2*g2*r + 672*D1*Ddd*f**2*g2*s**2 - 672*D1*Ddd*f**2*g2*s + 168*D1*Ddd*f**2*g2 + 140*D1*b2*(-3*D1*bdd1*f*(r + s - 1) + bd1*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + 720*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 720*Dd**2*f**3*s**2 - 720*Dd**2*f**3*s + 120*Dd**2*f**3 + 2016*Dd**2*f**2*g2*r*s - 504*Dd**2*f**2*g2*r + 2016*Dd**2*f**2*g2*s**2 - 2016*Dd**2*f**2*g2*s + 336*Dd**2*f**2*g2 + 35*b1**3*(3*D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 9*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 9*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-20*C*D1**2*fd*r**2 - 40*C*D1**2*fd*r*s + 40*C*D1**2*fd*r - 20*C*D1**2*fd*s**2 + 40*C*D1**2*fd*s - 20*C*D1**2*fd + 60*C*D1**2*fdd*r**2 + 120*C*D1**2*fdd*r*s - 120*C*D1**2*fdd*r + 60*C*D1**2*fdd*s**2 - 120*C*D1**2*fdd*s + 60*C*D1**2*fdd - 80*C*D1*Dd*f*r**2 - 160*C*D1*Dd*f*r*s + 120*C*D1*Dd*f*r - 80*C*D1*Dd*f*s**2 + 120*C*D1*Dd*f*s - 60*C*D1*Dd*f + 480*C*D1*Dd*fd*r**2 + 960*C*D1*Dd*fd*r*s - 840*C*D1*Dd*fd*r + 480*C*D1*Dd*fd*s**2 - 840*C*D1*Dd*fd*s + 360*C*D1*Dd*fd + 240*C*D1*Ddd*f*r**2 + 480*C*D1*Ddd*f*r*s - 360*C*D1*Ddd*f*r + 240*C*D1*Ddd*f*s**2 - 360*C*D1*Ddd*f*s + 180*C*D1*Ddd*f + 720*C*Dd**2*f*r**2 + 1440*C*Dd**2*f*r*s - 1080*C*Dd**2*f*r + 720*C*Dd**2*f*s**2 - 1080*C*Dd**2*f*s + 360*C*Dd**2*f + 34*D1**2*K*fd*r**2 + 100*D1**2*K*fd*r*s + 66*D1**2*K*fd*s**2 - 122*D1**2*K*fdd*r**2 - 280*D1**2*K*fdd*r*s - 158*D1**2*K*fdd*s**2 - 5*D1**2*bdd1*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 78*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 24*D1**2*f*fd + 174*D1**2*f*fdd*r**2 + 300*D1**2*f*fdd*r*s - 174*D1**2*f*fdd*r + 126*D1**2*f*fdd*s**2 - 150*D1**2*f*fdd*s + 87*D1**2*f*fdd + 174*D1**2*fd**2*r**2 + 300*D1**2*fd**2*r*s - 174*D1**2*fd**2*r + 126*D1**2*fd**2*s**2 - 150*D1**2*fd**2*s + 43*D1**2*fd*r**2 + 62*D1**2*fd*r*s - 30*D1**2*fd*r + 19*D1**2*fd*s**2 - 30*D1**2*fd*s + 15*D1**2*fd - 14*D1**2*fdd*r**2 - 16*D1**2*fdd*r*s + 90*D1**2*fdd*r - 2*D1**2*fdd*s**2 + 90*D1**2*fdd*s - 45*D1**2*fdd - 100*D1**2*gd2*r**2 - 200*D1**2*gd2*r*s + 200*D1**2*gd2*r - 100*D1**2*gd2*s**2 + 200*D1**2*gd2*s - 100*D1**2*gd2 - 100*D1**2*gdd2*r**2 - 200*D1**2*gdd2*r*s + 200*D1**2*gdd2*r - 100*D1**2*gdd2*s**2 + 200*D1**2*gdd2*s - 100*D1**2*gdd2 + 136*D1*Dd*K*f*r**2 + 400*D1*Dd*K*f*r*s - 236*D1*Dd*K*f*r + 264*D1*Dd*K*f*s**2 - 332*D1*Dd*K*f*s + 134*D1*Dd*K*f - 976*D1*Dd*K*fd*r**2 - 2240*D1*Dd*K*fd*r*s + 768*D1*Dd*K*fd*r - 1264*D1*Dd*K*fd*s**2 + 876*D1*Dd*K*fd*s - 156*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 93*D1*Dd*f**2 + 1392*D1*Dd*f*fd*r**2 + 2400*D1*Dd*f*fd*r*s - 1692*D1*Dd*f*fd*r + 1008*D1*Dd*f*fd*s**2 - 1452*D1*Dd*f*fd*s + 498*D1*Dd*f*fd + 172*D1*Dd*f*r**2 + 248*D1*Dd*f*r*s - 234*D1*Dd*f*r + 76*D1*Dd*f*s**2 - 162*D1*Dd*f*s + 105*D1*Dd*f - 112*D1*Dd*fd*r**2 - 128*D1*Dd*fd*r*s + 432*D1*Dd*fd*r - 16*D1*Dd*fd*s**2 + 396*D1*Dd*fd*s - 270*D1*Dd*fd - 400*D1*Dd*g2*r**2 - 800*D1*Dd*g2*r*s + 600*D1*Dd*g2*r - 400*D1*Dd*g2*s**2 + 600*D1*Dd*g2*s - 300*D1*Dd*g2 - 800*D1*Dd*gd2*r**2 - 1600*D1*Dd*gd2*r*s + 1400*D1*Dd*gd2*r - 800*D1*Dd*gd2*s**2 + 1400*D1*Dd*gd2*s - 600*D1*Dd*gd2 - 488*D1*Ddd*K*f*r**2 - 1120*D1*Ddd*K*f*r*s + 768*D1*Ddd*K*f*r - 632*D1*Ddd*K*f*s**2 + 876*D1*Ddd*K*f*s - 402*D1*Ddd*K*f + 348*D1*Ddd*f**2*r**2 + 600*D1*Ddd*f**2*r*s - 498*D1*Ddd*f**2*r + 252*D1*Ddd*f**2*s**2 - 426*D1*Ddd*f**2*s + 237*D1*Ddd*f**2 - 56*D1*Ddd*f*r**2 - 64*D1*Ddd*f*r*s + 72*D1*Ddd*f*r - 8*D1*Ddd*f*s**2 + 36*D1*Ddd*f*s - 30*D1*Ddd*f - 400*D1*Ddd*g2*r**2 - 800*D1*Ddd*g2*r*s + 600*D1*Ddd*g2*r - 400*D1*Ddd*g2*s**2 + 600*D1*Ddd*g2*s - 300*D1*Ddd*g2 + 5*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-10*K + 9*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 1464*Dd**2*K*f*r**2 - 3360*Dd**2*K*f*r*s + 2304*Dd**2*K*f*r - 1896*Dd**2*K*f*s**2 + 2628*Dd**2*K*f*s - 804*Dd**2*K*f + 1044*Dd**2*f**2*r**2 + 1800*Dd**2*f**2*r*s - 1494*Dd**2*f**2*r + 756*Dd**2*f**2*s**2 - 1278*Dd**2*f**2*s + 474*Dd**2*f**2 - 168*Dd**2*f*r**2 - 192*Dd**2*f*r*s + 216*Dd**2*f*r - 24*Dd**2*f*s**2 + 108*Dd**2*f*s - 60*Dd**2*f - 1200*Dd**2*g2*r**2 - 2400*Dd**2*g2*r*s + 1800*Dd**2*g2*r - 1200*Dd**2*g2*s**2 + 1800*Dd**2*g2*s - 600*Dd**2*g2) - b1*(-840*C*D1**2*bdd1*f*r**2 - 1680*C*D1**2*bdd1*f*r*s + 840*C*D1**2*bdd1*f*r - 840*C*D1**2*bdd1*f*s**2 + 840*C*D1**2*bdd1*f*s - 420*C*D1**2*bdd1*f - 1416*C*D1**2*f*fd*r**2 - 3216*C*D1**2*f*fd*r*s + 1416*C*D1**2*f*fd*r - 1800*C*D1**2*f*fd*s**2 + 1608*C*D1**2*f*fd*s - 708*C*D1**2*f*fd + 2472*C*D1**2*f*fdd*r**2 + 5472*C*D1**2*f*fdd*r*s - 2472*C*D1**2*f*fdd*r + 3000*C*D1**2*f*fdd*s**2 - 2736*C*D1**2*f*fdd*s + 1236*C*D1**2*f*fdd + 2472*C*D1**2*fd**2*r**2 + 5472*C*D1**2*fd**2*r*s - 2472*C*D1**2*fd**2*r + 3000*C*D1**2*fd**2*s**2 - 2736*C*D1**2*fd**2*s - 2832*C*D1*Dd*f**2*r**2 - 6432*C*D1*Dd*f**2*r*s + 4440*C*D1*Dd*f**2*r - 3600*C*D1*Dd*f**2*s**2 + 5016*C*D1*Dd*f**2*s - 2316*C*D1*Dd*f**2 + 19776*C*D1*Dd*f*fd*r**2 + 43776*C*D1*Dd*f*fd*r*s - 25248*C*D1*Dd*f*fd*r + 24000*C*D1*Dd*f*fd*s**2 - 27888*C*D1*Dd*f*fd*s + 7680*C*D1*Dd*f*fd + 4944*C*D1*Ddd*f**2*r**2 + 10944*C*D1*Ddd*f**2*r*s - 7680*C*D1*Ddd*f**2*r + 6000*C*D1*Ddd*f**2*s**2 - 8472*C*D1*Ddd*f**2*s + 3972*C*D1*Ddd*f**2 + 14832*C*Dd**2*f**2*r**2 + 32832*C*Dd**2*f**2*r*s - 23040*C*Dd**2*f**2*r + 18000*C*Dd**2*f**2*s**2 - 25416*C*Dd**2*f**2*s + 7944*C*Dd**2*f**2 + 1708*D1**2*K*bdd1*f*r**2 + 3920*D1**2*K*bdd1*f*r*s - 3668*D1**2*K*bdd1*f*r + 2212*D1**2*K*bdd1*f*s**2 - 4172*D1**2*K*bdd1*f*s + 1960*D1**2*K*bdd1*f - 168*D1**2*K*f*fd*r*s + 84*D1**2*K*f*fd*r - 168*D1**2*K*f*fd*s**2 + 168*D1**2*K*f*fd*s - 84*D1**2*K*f*fd + 168*D1**2*K*f*fdd*r*s - 84*D1**2*K*f*fdd*r + 168*D1**2*K*f*fdd*s**2 - 168*D1**2*K*f*fdd*s + 84*D1**2*K*f*fdd + 168*D1**2*K*fd**2*r*s - 84*D1**2*K*fd**2*r + 168*D1**2*K*fd**2*s**2 - 168*D1**2*K*fd**2*s - 140*D1**2*b2*fd*r**2 - 280*D1**2*b2*fd*r*s - 140*D1**2*b2*fd*s**2 + 420*D1**2*b2*fdd*r**2 + 840*D1**2*b2*fdd*r*s + 420*D1**2*b2*fdd*s**2 + 70*D1**2*bd1**2*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 1218*D1**2*bdd1*f**2*r**2 - 2100*D1**2*bdd1*f**2*r*s + 2268*D1**2*bdd1*f**2*r - 882*D1**2*bdd1*f**2*s**2 + 1932*D1**2*bdd1*f**2*s - 1050*D1**2*bdd1*f**2 + 196*D1**2*bdd1*f*r**2 + 224*D1**2*bdd1*f*r*s + 322*D1**2*bdd1*f*r + 28*D1**2*bdd1*f*s**2 + 490*D1**2*bdd1*f*s - 203*D1**2*bdd1*f + 1400*D1**2*bdd1*g2*r**2 + 2800*D1**2*bdd1*g2*r*s - 1400*D1**2*bdd1*g2*r + 1400*D1**2*bdd1*g2*s**2 - 1400*D1**2*bdd1*g2*s + 700*D1**2*bdd1*g2 + 420*D1**2*bdd2*f*r**2 + 840*D1**2*bdd2*f*r*s - 840*D1**2*bdd2*f*r + 420*D1**2*bdd2*f*s**2 - 840*D1**2*bdd2*f*s + 420*D1**2*bdd2*f + 588*D1**2*f*fd*r**2 + 1512*D1**2*f*fd*r*s - 588*D1**2*f*fd*r + 924*D1**2*f*fd*s**2 - 756*D1**2*f*fd*s + 294*D1**2*f*fd - 1554*D1**2*f*fdd*r**2 - 3444*D1**2*f*fdd*r*s + 1554*D1**2*f*fdd*r - 1890*D1**2*f*fdd*s**2 + 1722*D1**2*f*fdd*s - 777*D1**2*f*fdd + 476*D1**2*f*gd2*r**2 + 1400*D1**2*f*gd2*r*s - 952*D1**2*f*gd2*r + 924*D1**2*f*gd2*s**2 - 1400*D1**2*f*gd2*s + 476*D1**2*f*gd2 - 1708*D1**2*f*gdd2*r**2 - 3920*D1**2*f*gdd2*r*s + 3416*D1**2*f*gdd2*r - 2212*D1**2*f*gdd2*s**2 + 3920*D1**2*f*gdd2*s - 1708*D1**2*f*gdd2 - 1554*D1**2*fd**2*r**2 - 3444*D1**2*fd**2*r*s + 1554*D1**2*fd**2*r - 1890*D1**2*fd**2*s**2 + 1722*D1**2*fd**2*s + 476*D1**2*fd*g2*r**2 + 1400*D1**2*fd*g2*r*s + 924*D1**2*fd*g2*s**2 - 3416*D1**2*fd*gd2*r**2 - 7840*D1**2*fd*gd2*r*s + 3416*D1**2*fd*gd2*r - 4424*D1**2*fd*gd2*s**2 + 3920*D1**2*fd*gd2*s - 1708*D1**2*fdd*g2*r**2 - 3920*D1**2*fdd*g2*r*s - 2212*D1**2*fdd*g2*s**2 - 336*D1*Dd*K*f**2*r*s + 84*D1*Dd*K*f**2*r - 336*D1*Dd*K*f**2*s**2 + 336*D1*Dd*K*f**2*s - 84*D1*Dd*K*f**2 + 1344*D1*Dd*K*f*fd*r*s - 504*D1*Dd*K*f*fd*r + 1344*D1*Dd*K*f*fd*s**2 - 1344*D1*Dd*K*f*fd*s + 336*D1*Dd*K*f*fd - 560*D1*Dd*b2*f*r**2 - 1120*D1*Dd*b2*f*r*s + 840*D1*Dd*b2*f*r - 560*D1*Dd*b2*f*s**2 + 840*D1*Dd*b2*f*s - 420*D1*Dd*b2*f + 3360*D1*Dd*b2*fd*r**2 + 6720*D1*Dd*b2*fd*r*s - 2520*D1*Dd*b2*fd*r + 3360*D1*Dd*b2*fd*s**2 - 2520*D1*Dd*b2*fd*s + 1176*D1*Dd*f**2*r**2 + 3024*D1*Dd*f**2*r*s - 1932*D1*Dd*f**2*r + 1848*D1*Dd*f**2*s**2 - 2436*D1*Dd*f**2*s + 1050*D1*Dd*f**2 - 12432*D1*Dd*f*fd*r**2 - 27552*D1*Dd*f*fd*r*s + 15876*D1*Dd*f*fd*r - 15120*D1*Dd*f*fd*s**2 + 17556*D1*Dd*f*fd*s - 4830*D1*Dd*f*fd + 1904*D1*Dd*f*g2*r**2 + 5600*D1*Dd*f*g2*r*s - 3304*D1*Dd*f*g2*r + 3696*D1*Dd*f*g2*s**2 - 4648*D1*Dd*f*g2*s + 1876*D1*Dd*f*g2 - 13664*D1*Dd*f*gd2*r**2 - 31360*D1*Dd*f*gd2*r*s + 24416*D1*Dd*f*gd2*r - 17696*D1*Dd*f*gd2*s**2 + 27944*D1*Dd*f*gd2*s - 10752*D1*Dd*f*gd2 - 13664*D1*Dd*fd*g2*r**2 - 31360*D1*Dd*fd*g2*r*s + 10752*D1*Dd*fd*g2*r - 17696*D1*Dd*fd*g2*s**2 + 12264*D1*Dd*fd*g2*s + 336*D1*Ddd*K*f**2*r*s - 84*D1*Ddd*K*f**2*r + 336*D1*Ddd*K*f**2*s**2 - 336*D1*Ddd*K*f**2*s + 84*D1*Ddd*K*f**2 + 1680*D1*Ddd*b2*f*r**2 + 3360*D1*Ddd*b2*f*r*s - 2520*D1*Ddd*b2*f*r + 1680*D1*Ddd*b2*f*s**2 - 2520*D1*Ddd*b2*f*s + 1260*D1*Ddd*b2*f - 3108*D1*Ddd*f**2*r**2 - 6888*D1*Ddd*f**2*r*s + 4830*D1*Ddd*f**2*r - 3780*D1*Ddd*f**2*s**2 + 5334*D1*Ddd*f**2*s - 2499*D1*Ddd*f**2 - 6832*D1*Ddd*f*g2*r**2 - 15680*D1*Ddd*f*g2*r*s + 10752*D1*Ddd*f*g2*r - 8848*D1*Ddd*f*g2*s**2 + 12264*D1*Ddd*f*g2*s - 5628*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(3*f**2*(26*r**2 + 18*r*(2*s - 3) + 10*s**2 - 38*s + 23) + f*(20*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 68*K*r**2 - 200*K*r*s + 168*K*r - 132*K*s**2 + 232*K*s - 100*K - 12*fd*(58*r**2 + 100*r*s - 83*r + 42*s**2 - 71*s + 27) - 86*r**2 - 124*r*s + 118*r - 38*s**2 + 70*s - 47) + 2*fd*(-60*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 316*K*s**2 - 298*K*s + r**2*(244*K + 28) + r*(560*K*s - 262*K + 32*s - 67) + 4*s**2 - 55*s + 45) + 100*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 200*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(6*f**2*(116*r**2 + r*(200*s - 191) + 84*s**2 - 163*s + 77) + f*(60*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 2*K*(488*r**2 + 1120*r*s - 908*r + 632*s**2 - 1034*s + 411) - 112*r**2 - 128*r*s - 20*r - 16*s**2 - 104*s + 81) - 100*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 140*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 1008*Dd**2*K*f**2*r*s - 252*Dd**2*K*f**2*r + 1008*Dd**2*K*f**2*s**2 - 1008*Dd**2*K*f**2*s + 168*Dd**2*K*f**2 + 5040*Dd**2*b2*f*r**2 + 10080*Dd**2*b2*f*r*s - 7560*Dd**2*b2*f*r + 5040*Dd**2*b2*f*s**2 - 7560*Dd**2*b2*f*s + 2520*Dd**2*b2*f - 9324*Dd**2*f**2*r**2 - 20664*Dd**2*f**2*r*s + 14490*Dd**2*f**2*r - 11340*Dd**2*f**2*s**2 + 16002*Dd**2*f**2*s - 4998*Dd**2*f**2 - 20496*Dd**2*f*g2*r**2 - 47040*Dd**2*f*g2*r*s + 32256*Dd**2*f*g2*r - 26544*Dd**2*f*g2*s**2 + 36792*Dd**2*f*g2*s - 11256*Dd**2*f*g2))/(210*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct*k1**3*st**4*(b1*(D1**2*(f**2*(fd*(41*r*(3*s - 1) + 123*s**2 - 140*s + 41) - 5*fdd*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5)) + f*(-5*fd**2*(30*r*s - 10*r + 30*s**2 - 34*s + 7) + 18*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(41*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) + 18*r*(4*s - 1) + 18*(1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(25*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(25*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(5*bdd1*f**2*s*(5*r + 5*s - 3) + 3*f*(3*bdd1*s*(r + s - 1) + fd*(r*(2 - 6*s) - 6*s**2 + 6*s - 2) + fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 3*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(f*(41*r + 41*s - 24) + 18*r + 18*s - 18) - fd*(5*f*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3) + 9*r*(4*s - 1) + 9*(1 - 2*s)**2)) - Dd*f*(5*f*(40*r*s - 5*r + 40*s**2 - 32*s + 3) + 72*r*s - 9*r + 72*s**2 - 72*s + 9)) + 3*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2*k3**3) + D1**2*Pk2*Pkd3*ct*k1**3*st**2*(72*C*D1**2*bdd1*f**2*r*s + 72*C*D1**2*bdd1*f**2*s**2 - 504*C*D1**2*f**2*fd*r*s + 168*C*D1**2*f**2*fd*r - 504*C*D1**2*f**2*fd*s**2 + 504*C*D1**2*f**2*fd*s - 168*C*D1**2*f**2*fd + 360*C*D1**2*f**2*fdd*r*s - 120*C*D1**2*f**2*fdd*r + 360*C*D1**2*f**2*fdd*s**2 - 360*C*D1**2*f**2*fdd*s + 120*C*D1**2*f**2*fdd + 720*C*D1**2*f*fd**2*r*s - 240*C*D1**2*f*fd**2*r + 720*C*D1**2*f*fd**2*s**2 - 720*C*D1**2*f*fd**2*s + 120*C*D1**2*f*fd**2 - 672*C*D1*Dd*f**3*r*s + 168*C*D1*Dd*f**3*r - 672*C*D1*Dd*f**3*s**2 + 672*C*D1*Dd*f**3*s - 168*C*D1*Dd*f**3 + 2880*C*D1*Dd*f**2*fd*r*s - 840*C*D1*Dd*f**2*fd*r + 2880*C*D1*Dd*f**2*fd*s**2 - 2880*C*D1*Dd*f**2*fd*s + 600*C*D1*Dd*f**2*fd + 480*C*D1*Ddd*f**3*r*s - 120*C*D1*Ddd*f**3*r + 480*C*D1*Ddd*f**3*s**2 - 480*C*D1*Ddd*f**3*s + 120*C*D1*Ddd*f**3 + 1440*C*Dd**2*f**3*r*s - 360*C*Dd**2*f**3*r + 1440*C*Dd**2*f**3*s**2 - 1440*C*Dd**2*f**3*s + 240*C*Dd**2*f**3 + 108*D1**2*K*bdd1*f**2*r*s + 108*D1**2*K*bdd1*f**2*s**2 - 108*D1**2*K*bdd1*f**2*s - 264*D1**2*b2*f*fd*r*s + 132*D1**2*b2*f*fd*r - 264*D1**2*b2*f*fd*s**2 + 264*D1**2*b2*f*fd*s - 132*D1**2*b2*f*fd + 216*D1**2*b2*f*fdd*r*s - 108*D1**2*b2*f*fdd*r + 216*D1**2*b2*f*fdd*s**2 - 216*D1**2*b2*f*fdd*s + 108*D1**2*b2*f*fdd + 216*D1**2*b2*fd**2*r*s - 108*D1**2*b2*fd**2*r + 216*D1**2*b2*fd**2*s**2 - 216*D1**2*b2*fd**2*s - 6*D1**2*bd1**2*f*(9*f*(r**2 + r*(18*s - 11) + 17*s**2 - 25*s + 6) + 7*r**2 + 7*r*(s*(18 - 4*K) - 7) + 7*s**2*(17 - 4*K) + 7*s*(2*K - 21) + 42) - 132*D1**2*bd2*f**2*r*s - 132*D1**2*bd2*f**2*s**2 + 132*D1**2*bd2*f**2*s + 432*D1**2*bd2*f*fd*r*s - 108*D1**2*bd2*f*fd*r + 432*D1**2*bd2*f*fd*s**2 - 432*D1**2*bd2*f*fd*s + 108*D1**2*bd2*f*fd + 378*D1**2*bdd1*f**3*r**2 + 1404*D1**2*bdd1*f**3*r*s - 378*D1**2*bdd1*f**3*r + 1026*D1**2*bdd1*f**3*s**2 - 810*D1**2*bdd1*f**3*s + 189*D1**2*bdd1*f**3 + 150*D1**2*bdd1*f**2*r**2 + 480*D1**2*bdd1*f**2*r*s - 210*D1**2*bdd1*f**2*r + 330*D1**2*bdd1*f**2*s**2 - 462*D1**2*bdd1*f**2*s + 51*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r*s - 168*D1**2*bdd1*f*g2*s**2 + 108*D1**2*bdd2*f**2*r*s + 108*D1**2*bdd2*f**2*s**2 - 108*D1**2*bdd2*f**2*s - 303*D1**2*f**2*fd*r**2 - 834*D1**2*f**2*fd*r*s + 480*D1**2*f**2*fd*r - 531*D1**2*f**2*fd*s**2 + 632*D1**2*f**2*fd*s - 278*D1**2*f**2*fd + 273*D1**2*f**2*fdd*r**2 + 822*D1**2*f**2*fdd*r*s - 456*D1**2*f**2*fdd*r + 549*D1**2*f**2*fdd*s**2 - 640*D1**2*f**2*fdd*s + 274*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s - 216*D1**2*f**2*gdd2*r*s - 216*D1**2*f**2*gdd2*s**2 + 216*D1**2*f**2*gdd2*s + 546*D1**2*f*fd**2*r**2 + 1644*D1**2*f*fd**2*r*s - 912*D1**2*f*fd**2*r + 1098*D1**2*f*fd**2*s**2 - 1280*D1**2*f*fd**2*s + 274*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 864*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 864*D1**2*f*fd*gd2*s**2 + 864*D1**2*f*fd*gd2*s - 216*D1**2*f*fd*gd2 - 432*D1**2*f*fdd*g2*r*s + 216*D1**2*f*fdd*g2*r - 432*D1**2*f*fdd*g2*s**2 + 432*D1**2*f*fdd*g2*s - 216*D1**2*f*fdd*g2 - 432*D1**2*fd**2*g2*r*s + 216*D1**2*fd**2*g2*r - 432*D1**2*fd**2*g2*s**2 + 432*D1**2*fd**2*g2*s - 528*D1*Dd*b2*f**2*r*s + 132*D1*Dd*b2*f**2*r - 528*D1*Dd*b2*f**2*s**2 + 528*D1*Dd*b2*f**2*s - 132*D1*Dd*b2*f**2 + 1728*D1*Dd*b2*f*fd*r*s - 648*D1*Dd*b2*f*fd*r + 1728*D1*Dd*b2*f*fd*s**2 - 1728*D1*Dd*b2*f*fd*s + 432*D1*Dd*b2*f*fd + 864*D1*Dd*bd2*f**2*r*s - 108*D1*Dd*bd2*f**2*r + 864*D1*Dd*bd2*f**2*s**2 - 864*D1*Dd*bd2*f**2*s + 108*D1*Dd*bd2*f**2 - 404*D1*Dd*f**3*r**2 - 1112*D1*Dd*f**3*r*s + 682*D1*Dd*f**3*r - 708*D1*Dd*f**3*s**2 + 910*D1*Dd*f**3*s - 379*D1*Dd*f**3 + 2184*D1*Dd*f**2*fd*r**2 + 6576*D1*Dd*f**2*fd*r*s - 3738*D1*Dd*f**2*fd*r + 4392*D1*Dd*f**2*fd*s**2 - 5302*D1*Dd*f**2*fd*s + 1552*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r*s - 264*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1056*D1*Dd*f**2*g2*s + 264*D1*Dd*f**2*g2 - 1728*D1*Dd*f**2*gd2*r*s + 216*D1*Dd*f**2*gd2*r - 1728*D1*Dd*f**2*gd2*s**2 + 1728*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 3456*D1*Dd*f*fd*g2*r*s + 1296*D1*Dd*f*fd*g2*r - 3456*D1*Dd*f*fd*g2*s**2 + 3456*D1*Dd*f*fd*g2*s - 864*D1*Dd*f*fd*g2 + 432*D1*Ddd*b2*f**2*r*s - 108*D1*Ddd*b2*f**2*r + 432*D1*Ddd*b2*f**2*s**2 - 432*D1*Ddd*b2*f**2*s + 108*D1*Ddd*b2*f**2 + 364*D1*Ddd*f**3*r**2 + 1096*D1*Ddd*f**3*r*s - 638*D1*Ddd*f**3*r + 732*D1*Ddd*f**3*s**2 - 914*D1*Ddd*f**3*s + 365*D1*Ddd*f**3 - 864*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 864*D1*Ddd*f**2*g2*s**2 + 864*D1*Ddd*f**2*g2*s - 216*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(9*f**3*(10*r**2 + 10*r*(6*s - 1) + 50*s**2 - 34*s + 5) - f**2*(8*C*s**2 - 44*K*s**2 + 44*K*s + 36*fd*(21*r**2 + r*(78*s - 34) + 57*s**2 - 60*s + 11) - 44*r**2 + 2*r*(s*(4*C - 22*K - 76) + 7) - 108*s**2 + 70*s + 29) - 2*f*fd*(48*C*s**2 - 36*C*s + 18*K*(r*(4*s - 1) + (1 - 2*s)**2) + 100*r**2 + r*(48*C*s - 12*C + 320*s - 165) + 220*s**2 - 267*s + 95) + 56*f*s*(3*g2*(r + s) + gd2*(2*r + 2*s - 1)) + 56*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*Dd*f*(9*f**2*(56*r**2 + r*(208*s - 82) + 152*s**2 - 150*s + 29) + f*(96*C*s**2 - 48*C*s + 18*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 200*r**2 + 4*r*(24*C*s - 3*C + 160*s - 80) + 440*s**2 - 578*s + 147) - 28*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 1296*Dd**2*b2*f**2*r*s - 324*Dd**2*b2*f**2*r + 1296*Dd**2*b2*f**2*s**2 - 1296*Dd**2*b2*f**2*s + 216*Dd**2*b2*f**2 + 1092*Dd**2*f**3*r**2 + 3288*Dd**2*f**3*r*s - 1914*Dd**2*f**3*r + 2196*Dd**2*f**3*s**2 - 2742*Dd**2*f**3*s + 730*Dd**2*f**3 - 2592*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 2592*Dd**2*f**2*g2*s**2 + 2592*Dd**2*f**2*g2*s - 432*Dd**2*f**2*g2 - 3*b1**2*(D1**2*(f*fd*(6*r**2 - 4*r*(113*s + 14) - 458*s**2 + 248*s + 50) + 18*f*fdd*(r**2 + 18*r*s + 17*s**2 - 10*s - 1) + 18*fd**2*(r**2 + 18*r*s + 17*s**2 - 10*s - 1) - 21*fd*(4*K*(s - 1)*(r + s - 1) - r**2 + 2*r*(s + 3) + 3*s**2 + 10*s - 5) - 7*fdd*(4*K*(s - 1)*(r + s - 1) - r**2 + r*(6 - 18*s) - 17*s**2 + 10*s - 5)) + D1*(Dd*(f**2*(12*r**2 + r*(214 - 904*s) - 916*s**2 + 910*s - 223) + 3*f*(-28*K*(r*(4*s - 1) + (1 - 2*s)**2) + 12*fd*(4*r**2 + r*(72*s - 11) + 68*s**2 - 55*s + 5) + 28*r**2 - 56*r*s - 14*r - 84*s**2 + 70*s - 7) - 14*fd*(2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) - 4*r**2 - 72*r*s + 23*r - 68*s**2 + 55*s - 11)) + Ddd*f*(-28*K*(r*(4*s - 1) + (1 - 2*s)**2) + 9*f*(4*r**2 + r*(72*s - 22) + 68*s**2 - 70*s + 19) + 28*r**2 + 504*r*s - 154*r + 476*s**2 - 490*s + 133)) + 2*Dd**2*f*(-7*K*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + 9*f*(6*r**2 + 3*r*(36*s - 11) + 102*s**2 - 105*s + 19) + 42*r**2 + 756*r*s - 231*r + 714*s**2 - 735*s + 133)) - 3*b1*(-16*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s - 8*C*D1**2*f*fd - 48*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r - 48*C*D1**2*f*fdd*s**2 + 72*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r - 48*C*D1**2*fd**2*s**2 + 72*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 32*C*D1*Dd*f**2*r*s + 8*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 32*C*D1*Dd*f**2*s - 8*C*D1*Dd*f**2 - 384*C*D1*Dd*f*fd*r*s + 144*C*D1*Dd*f*fd*r - 384*C*D1*Dd*f*fd*s**2 + 480*C*D1*Dd*f*fd*s - 120*C*D1*Dd*f*fd - 96*C*D1*Ddd*f**2*r*s + 24*C*D1*Ddd*f**2*r - 96*C*D1*Ddd*f**2*s**2 + 96*C*D1*Ddd*f**2*s - 24*C*D1*Ddd*f**2 - 288*C*Dd**2*f**2*r*s + 72*C*Dd**2*f**2*r - 288*C*Dd**2*f**2*s**2 + 288*C*Dd**2*f**2*s - 48*C*Dd**2*f**2 + 88*D1**2*K*f*fd*r*s - 44*D1**2*K*f*fd*r + 88*D1**2*K*f*fd*s**2 - 88*D1**2*K*f*fd*s + 44*D1**2*K*f*fd - 72*D1**2*K*f*fdd*r*s + 36*D1**2*K*f*fdd*r - 72*D1**2*K*f*fdd*s**2 + 72*D1**2*K*f*fdd*s - 36*D1**2*K*f*fdd - 72*D1**2*K*fd**2*r*s + 36*D1**2*K*fd**2*r - 72*D1**2*K*fd**2*s**2 + 72*D1**2*K*fd**2*s + D1**2*bdd1*f*(9*f*(2*r**2 + r*(36*s - 22) + 34*s**2 - 50*s + 21) + 14*r**2 - 14*r*(s*(4*K - 18) + 7) + 7*s**2*(34 - 8*K) + 7*s*(4*K - 42) + 91) + 270*D1**2*f**2*fd*r**2 + 1620*D1**2*f**2*fd*r*s - 810*D1**2*f**2*fd*r + 1350*D1**2*f**2*fd*s**2 - 1674*D1**2*f**2*fd*s + 585*D1**2*f**2*fd - 378*D1**2*f**2*fdd*r**2 - 1404*D1**2*f**2*fdd*r*s + 846*D1**2*f**2*fdd*r - 1026*D1**2*f**2*fdd*s**2 + 1350*D1**2*f**2*fdd*s - 531*D1**2*f**2*fdd - 756*D1**2*f*fd**2*r**2 - 2808*D1**2*f*fd**2*r*s + 1692*D1**2*f*fd**2*r - 2052*D1**2*f*fd**2*s**2 + 2700*D1**2*f*fd**2*s - 792*D1**2*f*fd**2 + 88*D1**2*f*fd*r**2 + 304*D1**2*f*fd*r*s - 226*D1**2*f*fd*r + 216*D1**2*f*fd*s**2 - 298*D1**2*f*fd*s + 181*D1**2*f*fd - 100*D1**2*f*fdd*r**2 - 320*D1**2*f*fdd*r*s + 190*D1**2*f*fdd*r - 220*D1**2*f*fdd*s**2 + 226*D1**2*f*fdd*s - 143*D1**2*f*fdd + 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s + 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*s**2 - 56*D1**2*f*gdd2*s - 100*D1**2*fd**2*r**2 - 320*D1**2*fd**2*r*s + 190*D1**2*fd**2*r - 220*D1**2*fd**2*s**2 + 226*D1**2*fd**2*s + 30*D1**2*fd**2 + 168*D1**2*fd*g2*r*s - 168*D1**2*fd*g2*r + 168*D1**2*fd*g2*s**2 - 336*D1**2*fd*g2*s + 168*D1**2*fd*g2 + 112*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*r + 112*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 + 56*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r + 56*D1**2*fdd*g2*s**2 - 112*D1**2*fdd*g2*s + 56*D1**2*fdd*g2 + 176*D1*Dd*K*f**2*r*s - 44*D1*Dd*K*f**2*r + 176*D1*Dd*K*f**2*s**2 - 176*D1*Dd*K*f**2*s + 44*D1*Dd*K*f**2 - 576*D1*Dd*K*f*fd*r*s + 216*D1*Dd*K*f*fd*r - 576*D1*Dd*K*f*fd*s**2 + 576*D1*Dd*K*f*fd*s - 144*D1*Dd*K*f*fd + 360*D1*Dd*f**3*r**2 + 2160*D1*Dd*f**3*r*s - 900*D1*Dd*f**3*r + 1800*D1*Dd*f**3*s**2 - 1980*D1*Dd*f**3*s + 630*D1*Dd*f**3 - 3024*D1*Dd*f**2*fd*r**2 - 11232*D1*Dd*f**2*fd*r*s + 6300*D1*Dd*f**2*fd*r - 8208*D1*Dd*f**2*fd*s**2 + 10260*D1*Dd*f**2*fd*s - 3042*D1*Dd*f**2*fd + 176*D1*Dd*f**2*r**2 + 608*D1*Dd*f**2*r*s - 328*D1*Dd*f**2*r + 432*D1*Dd*f**2*s**2 - 520*D1*Dd*f**2*s + 196*D1*Dd*f**2 - 800*D1*Dd*f*fd*r**2 - 2560*D1*Dd*f*fd*r*s + 1480*D1*Dd*f*fd*r - 1760*D1*Dd*f*fd*s**2 + 1984*D1*Dd*f*fd*s - 606*D1*Dd*f*fd + 672*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 + 448*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r + 448*D1*Dd*f*gd2*s**2 - 448*D1*Dd*f*gd2*s + 56*D1*Dd*f*gd2 + 448*D1*Dd*fd*g2*r*s - 280*D1*Dd*fd*g2*r + 448*D1*Dd*fd*g2*s**2 - 672*D1*Dd*fd*g2*s + 224*D1*Dd*fd*g2 - 144*D1*Ddd*K*f**2*r*s + 36*D1*Ddd*K*f**2*r - 144*D1*Ddd*K*f**2*s**2 + 144*D1*Ddd*K*f**2*s - 36*D1*Ddd*K*f**2 - 504*D1*Ddd*f**3*r**2 - 1872*D1*Ddd*f**3*r*s + 972*D1*Ddd*f**3*r - 1368*D1*Ddd*f**3*s**2 + 1620*D1*Ddd*f**3*s - 594*D1*Ddd*f**3 - 200*D1*Ddd*f**2*r**2 - 640*D1*Ddd*f**2*r*s + 360*D1*Ddd*f**2*r - 440*D1*Ddd*f**2*s**2 + 540*D1*Ddd*f**2*s - 210*D1*Ddd*f**2 + 224*D1*Ddd*f*g2*r*s - 56*D1*Ddd*f*g2*r + 224*D1*Ddd*f*g2*s**2 - 224*D1*Ddd*f*g2*s + 56*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(6*r**2 + r*(270 - 452*s) - 458*s**2 + 662*s - 273) + 3*f*(12*fd*(2*r**2 + r*(36*s - 11) + 34*s**2 - 35*s + 7) + 14*r**2 - 7*r*(s*(8*K + 4) - 6) - 7*s**2*(8*K + 6) + 7*s*(4*K + 18) - 49) - 14*fd*(2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*r**2 + r*(13 - 36*s) - 34*s**2 + 31*s - 3)) + 2*Dd*f*(-7*K*(32*r*s - 4*r + 32*s**2 - 24*s + 2) + 9*f*(8*r**2 + 6*r*(24*s - 11) + 136*s**2 - 170*s + 47) + 56*r**2 + 1008*r*s - 350*r + 952*s**2 - 1078*s + 245)) - 432*Dd**2*K*f**2*r*s + 108*Dd**2*K*f**2*r - 432*Dd**2*K*f**2*s**2 + 432*Dd**2*K*f**2*s - 72*Dd**2*K*f**2 - 1512*Dd**2*f**3*r**2 - 5616*Dd**2*f**3*r*s + 2916*Dd**2*f**3*r - 4104*Dd**2*f**3*s**2 + 4860*Dd**2*f**3*s - 1188*Dd**2*f**3 - 600*Dd**2*f**2*r**2 - 1920*Dd**2*f**2*r*s + 1080*Dd**2*f**2*r - 1320*Dd**2*f**2*s**2 + 1620*Dd**2*f**2*s - 420*Dd**2*f**2 + 672*Dd**2*f*g2*r*s - 168*Dd**2*f*g2*r + 672*Dd**2*f*g2*s**2 - 672*Dd**2*f*g2*s + 112*Dd**2*f*g2))/(630*d**2*k2*k3**3) + D1**2*Pk2*Pkd3*ct*k1**3*(360*C*D1**2*f**2*fd*r*s - 120*C*D1**2*f**2*fd*r + 360*C*D1**2*f**2*fd*s**2 - 360*C*D1**2*f**2*fd*s + 120*C*D1**2*f**2*fd - 360*C*D1**2*f**2*fdd*r*s + 120*C*D1**2*f**2*fdd*r - 360*C*D1**2*f**2*fdd*s**2 + 360*C*D1**2*f**2*fdd*s - 120*C*D1**2*f**2*fdd - 720*C*D1**2*f*fd**2*r*s + 240*C*D1**2*f*fd**2*r - 720*C*D1**2*f*fd**2*s**2 + 720*C*D1**2*f*fd**2*s - 120*C*D1**2*f*fd**2 + 480*C*D1*Dd*f**3*r*s - 120*C*D1*Dd*f**3*r + 480*C*D1*Dd*f**3*s**2 - 480*C*D1*Dd*f**3*s + 120*C*D1*Dd*f**3 - 2880*C*D1*Dd*f**2*fd*r*s + 840*C*D1*Dd*f**2*fd*r - 2880*C*D1*Dd*f**2*fd*s**2 + 2880*C*D1*Dd*f**2*fd*s - 600*C*D1*Dd*f**2*fd - 480*C*D1*Ddd*f**3*r*s + 120*C*D1*Ddd*f**3*r - 480*C*D1*Ddd*f**3*s**2 + 480*C*D1*Ddd*f**3*s - 120*C*D1*Ddd*f**3 - 1440*C*Dd**2*f**3*r*s + 360*C*Dd**2*f**3*r - 1440*C*Dd**2*f**3*s**2 + 1440*C*Dd**2*f**3*s - 240*C*Dd**2*f**3 + 14*D1**2*bd1**2*(3*f**2*(14*r**2 + r*(28*s - 23) + 14*s**2 - 25*s + 9) + f*(28*r**2 + r*(12*C*(2*s - 1) + 44*s - 53) + (s - 1)*(s*(24*C + 16) - 37)) + 20*g2*(-2*r*s + r - s*(2*s - 2))) + 3*D1**2*bdd1*f**2*(r + s - 1)*(53*r + s*(65 - 28*K) - 65) - 84*D1**2*bdd2*f**2*r*s - 84*D1**2*bdd2*f**2*s**2 + 84*D1**2*bdd2*f**2*s - 180*D1**2*f**2*fd*r*s + 60*D1**2*f**2*fd*r - 180*D1**2*f**2*fd*s**2 + 180*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 180*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 180*D1**2*f**2*fdd*s**2 - 180*D1**2*f**2*fdd*s + 60*D1**2*f**2*fdd - 168*D1**2*f**2*gd2*r*s - 168*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s + 168*D1**2*f**2*gdd2*r*s + 168*D1**2*f**2*gdd2*s**2 - 168*D1**2*f**2*gdd2*s + 360*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 360*D1**2*f*fd**2*s**2 - 360*D1**2*f*fd**2*s + 60*D1**2*f*fd**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r - 336*D1**2*f*fd*g2*s**2 + 336*D1**2*f*fd*g2*s - 168*D1**2*f*fd*g2 + 672*D1**2*f*fd*gd2*r*s - 168*D1**2*f*fd*gd2*r + 672*D1**2*f*fd*gd2*s**2 - 672*D1**2*f*fd*gd2*s + 168*D1**2*f*fd*gd2 + 336*D1**2*f*fdd*g2*r*s - 168*D1**2*f*fdd*g2*r + 336*D1**2*f*fdd*g2*s**2 - 336*D1**2*f*fdd*g2*s + 168*D1**2*f*fdd*g2 + 336*D1**2*fd**2*g2*r*s - 168*D1**2*fd**2*g2*r + 336*D1**2*fd**2*g2*s**2 - 336*D1**2*fd**2*g2*s - 240*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 240*D1*Dd*f**3*s**2 + 240*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 1440*D1*Dd*f**2*fd*r*s - 420*D1*Dd*f**2*fd*r + 1440*D1*Dd*f**2*fd*s**2 - 1440*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd - 672*D1*Dd*f**2*g2*r*s + 168*D1*Dd*f**2*g2*r - 672*D1*Dd*f**2*g2*s**2 + 672*D1*Dd*f**2*g2*s - 168*D1*Dd*f**2*g2 + 1344*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 1344*D1*Dd*f**2*gd2*s**2 - 1344*D1*Dd*f**2*gd2*s + 168*D1*Dd*f**2*gd2 + 2688*D1*Dd*f*fd*g2*r*s - 1008*D1*Dd*f*fd*g2*r + 2688*D1*Dd*f*fd*g2*s**2 - 2688*D1*Dd*f*fd*g2*s + 672*D1*Dd*f*fd*g2 + 240*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 240*D1*Ddd*f**3*s**2 - 240*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 672*D1*Ddd*f**2*g2*r*s - 168*D1*Ddd*f**2*g2*r + 672*D1*Ddd*f**2*g2*s**2 - 672*D1*Ddd*f**2*g2*s + 168*D1*Ddd*f**2*g2 + 3*D1*bd1*f*(D1*(-f*(r + s - 1)*(-28*K*s + 43*r + 67*s - 67) + 2*fd*(-14*K*(r*(4*s - 1) + (1 - 2*s)**2) + 106*r**2 + 236*r*s - 171*r + 130*s**2 - 189*s + 59)) + 2*Dd*f*(-14*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 212*r**2 + 472*r*s - 401*r + 260*s**2 - 443*s + 183)) + 84*D1*bd2*f*(D1*(f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 720*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 720*Dd**2*f**3*s**2 - 720*Dd**2*f**3*s + 120*Dd**2*f**3 + 2016*Dd**2*f**2*g2*r*s - 504*Dd**2*f**2*g2*r + 2016*Dd**2*f**2*g2*s**2 - 2016*Dd**2*f**2*g2*s + 336*Dd**2*f**2*g2 + 7*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(20*K*(r*(4*s - 1) + (1 - 2*s)**2) + f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 20*r**2 - 120*r*s + 50*r - 100*s**2 + 110*s - 35) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*Ddd*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - 4*r**2 + r*(10 - 24*s) - 20*s**2 + 22*s - 7)) - 2*Dd**2*(-5*K*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + 9*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 30*r**2 + 180*r*s - 75*r + 150*s**2 - 165*s + 35)) + 7*b1**2*(-8*C*D1**2*fd*r*s - 8*C*D1**2*fd*s**2 + 8*C*D1**2*fd*s + 24*C*D1**2*fdd*r*s + 24*C*D1**2*fdd*s**2 - 24*C*D1**2*fdd*s - 32*C*D1*Dd*f*r*s + 8*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 + 32*C*D1*Dd*f*s - 8*C*D1*Dd*f + 192*C*D1*Dd*fd*r*s - 24*C*D1*Dd*fd*r + 192*C*D1*Dd*fd*s**2 - 192*C*D1*Dd*fd*s + 24*C*D1*Dd*fd + 96*C*D1*Ddd*f*r*s - 24*C*D1*Ddd*f*r + 96*C*D1*Ddd*f*s**2 - 96*C*D1*Ddd*f*s + 24*C*D1*Ddd*f + 288*C*Dd**2*f*r*s - 72*C*Dd**2*f*r + 288*C*Dd**2*f*s**2 - 288*C*Dd**2*f*s + 48*C*Dd**2*f - D1**2*bdd1*(-20*K*(3*r*s - r + 3*s**2 - 3*s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 15*r**2 + 90*r*s - 40*r + 75*s**2 - 80*s + 30) - 60*D1**2*f*fd*r**2 - 168*D1**2*f*fd*r*s + 78*D1**2*f*fd*r - 108*D1**2*f*fd*s**2 + 102*D1**2*f*fd*s - 33*D1**2*f*fd + 84*D1**2*f*fdd*r**2 + 168*D1**2*f*fdd*r*s - 114*D1**2*f*fdd*r + 84*D1**2*f*fdd*s**2 - 102*D1**2*f*fdd*s + 51*D1**2*f*fdd + 84*D1**2*fd**2*r**2 + 168*D1**2*fd**2*r*s - 114*D1**2*fd**2*r + 84*D1**2*fd**2*s**2 - 102*D1**2*fd**2*s + 30*D1**2*fd**2 - 16*D1**2*fd*r**2 - 48*D1**2*fd*r*s - 2*D1**2*fd*r - 32*D1**2*fd*s**2 - 10*D1**2*fd*s + D1**2*fd + 28*D1**2*fdd*r**2 + 44*D1**2*fdd*r*s + 6*D1**2*fdd*r + 16*D1**2*fdd*s**2 + 30*D1**2*fdd*s - 3*D1**2*fdd - 40*D1**2*gd2*r*s - 40*D1**2*gd2*s**2 + 40*D1**2*gd2*s - 40*D1**2*gdd2*r*s - 40*D1**2*gdd2*s**2 + 40*D1**2*gdd2*s - 120*D1*Dd*f**2*r**2 - 336*D1*Dd*f**2*r*s + 204*D1*Dd*f**2*r - 216*D1*Dd*f**2*s**2 + 276*D1*Dd*f**2*s - 114*D1*Dd*f**2 + 672*D1*Dd*f*fd*r**2 + 1344*D1*Dd*f*fd*r*s - 960*D1*Dd*f*fd*r + 672*D1*Dd*f*fd*s**2 - 912*D1*Dd*f*fd*s + 330*D1*Dd*f*fd - 64*D1*Dd*f*r**2 - 192*D1*Dd*f*r*s + 112*D1*Dd*f*r - 128*D1*Dd*f*s**2 + 160*D1*Dd*f*s - 64*D1*Dd*f + 224*D1*Dd*fd*r**2 + 352*D1*Dd*fd*r*s - 132*D1*Dd*fd*r + 128*D1*Dd*fd*s**2 - 42*D1*Dd*fd - 160*D1*Dd*g2*r*s + 40*D1*Dd*g2*r - 160*D1*Dd*g2*s**2 + 160*D1*Dd*g2*s - 40*D1*Dd*g2 - 320*D1*Dd*gd2*r*s + 40*D1*Dd*gd2*r - 320*D1*Dd*gd2*s**2 + 320*D1*Dd*gd2*s - 40*D1*Dd*gd2 + 168*D1*Ddd*f**2*r**2 + 336*D1*Ddd*f**2*r*s - 252*D1*Ddd*f**2*r + 168*D1*Ddd*f**2*s**2 - 252*D1*Ddd*f**2*s + 126*D1*Ddd*f**2 + 112*D1*Ddd*f*r**2 + 176*D1*Ddd*f*r*s - 156*D1*Ddd*f*r + 64*D1*Ddd*f*s**2 - 120*D1*Ddd*f*s + 72*D1*Ddd*f - 160*D1*Ddd*g2*r*s + 40*D1*Ddd*g2*r - 160*D1*Ddd*g2*s**2 + 160*D1*Ddd*g2*s - 40*D1*Ddd*g2 + D1*bd1*(D1*(20*K*(3*r*s - r + 3*s**2 - 3*s + 1) + f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 15*r**2 - 90*r*s + 40*r - 75*s**2 + 80*s - 30) - 6*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 10*Dd*(2*K*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 12*r**2 + r*(31 - 72*s) - 60*s**2 + 65*s - 16)) + 504*Dd**2*f**2*r**2 + 1008*Dd**2*f**2*r*s - 756*Dd**2*f**2*r + 504*Dd**2*f**2*s**2 - 756*Dd**2*f**2*s + 252*Dd**2*f**2 + 336*Dd**2*f*r**2 + 528*Dd**2*f*r*s - 468*Dd**2*f*r + 192*Dd**2*f*s**2 - 360*Dd**2*f*s + 144*Dd**2*f - 480*Dd**2*g2*r*s + 120*Dd**2*g2*r - 480*Dd**2*g2*s**2 + 480*Dd**2*g2*s - 80*Dd**2*g2) + b1*(-14*D1**2*bd1**2*(-10*K*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 15*r**2 + 90*r*s - 40*r + 75*s**2 - 80*s + 15) + 7*D1**2*bdd1*(3*f**2*(28*r**2 + r*(56*s - 46) + 28*s**2 - 50*s + 25) + f*(24*C*(2*r*s - r + 2*s**2 - 2*s + 1) + 56*r**2 + 88*r*s - 106*r + 32*s**2 - 106*s + 47) - 40*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 3*D1**2*(f*(fd*(28*K*(2*r*s - r + 2*s**2 - 2*s + 1) - 86*r**2 - 220*r*s + 86*r - 134*s**2 + 110*s - 43) + fdd*(-28*K*(2*r*s - r + 2*s**2 - 2*s + 1) + 106*r**2 + 236*r*s - 106*r + 130*s**2 - 118*s + 53)) + 2*fd**2*(53*r**2 + r*(K*(14 - 28*s) + 118*s - 53) + s*(-28*K*(s - 1) + 65*s - 59))) - 7*D1*bd1*(D1*(3*f**2*(20*r**2 + 14*r*(4*s - 3) + 36*s**2 - 58*s + 27) + f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 168*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 32*r**2 + 96*r*s - 82*r + 64*s**2 - 122*s + 49) - 2*fd*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) + 56*r**2 + r*(88*s - 47) + 32*s**2 - 23*s - 15) + 40*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 40*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd*(3*f**2*(112*r**2 + 16*r*(14*s - 11) + 112*s**2 - 184*s + 71) + f*(24*C*(8*r*s - 3*r + 8*s**2 - 8*s + 2) + 224*r**2 + 352*r*s - 368*r + 128*s**2 - 332*s + 159) - 40*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 3*D1*f*(Dd*(f*(28*K*(r*(4*s - 1) + (1 - 2*s)**2) - 172*r**2 - 440*r*s + 282*r - 268*s**2 + 354*s - 153) - 2*fd*(28*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 424*r**2 - 944*r*s + 542*r - 520*s**2 + 602*s - 165)) + Ddd*f*(-28*K*(r*(4*s - 1) + (1 - 2*s)**2) + 212*r**2 + 472*r*s - 330*r + 260*s**2 - 366*s + 171)) + 6*Dd**2*f**2*(-14*K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 318*r**2 + 708*r*s - 495*r + 390*s**2 - 549*s + 171)) + 84*b2*(D1**2*(f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(210*d**2*k2*k3**3) + D1**2*Pk2*Pkd3*ct*k1*k2**5*st**6*(24*C*D1**2*f**2*fd*r**2 + 48*C*D1**2*f**2*fd*r*s - 32*C*D1**2*f**2*fd*r + 24*C*D1**2*f**2*fd*s**2 - 32*C*D1**2*f**2*fd*s + 16*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 16*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 16*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 32*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 32*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 32*C*D1*Dd*f**3*r**2 + 64*C*D1*Dd*f**3*r*s - 48*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s**2 - 48*C*D1*Dd*f**3*s + 24*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 136*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 136*C*D1*Dd*f**2*fd*s - 48*C*D1*Dd*f**2*fd - 16*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 24*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 48*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 72*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s - 24*C*Dd**2*f**3 + 72*D1**2*K*b1*f*fd*r**2 + 144*D1**2*K*b1*f*fd*r*s - 72*D1**2*K*b1*f*fd*r + 72*D1**2*K*b1*f*fd*s**2 - 72*D1**2*K*b1*f*fd*s + 36*D1**2*K*b1*f*fd - 36*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*r*s + 36*D1**2*K*b1*f*fdd*r - 36*D1**2*K*b1*f*fdd*s**2 + 36*D1**2*K*b1*f*fdd*s - 18*D1**2*K*b1*f*fdd - 36*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*r*s + 36*D1**2*K*b1*fd**2*r - 36*D1**2*K*b1*fd**2*s**2 + 36*D1**2*K*b1*fd**2*s - 42*D1**2*b1*f**2*fd*r**2 - 84*D1**2*b1*f**2*fd*r*s + 56*D1**2*b1*f**2*fd*r - 42*D1**2*b1*f**2*fd*s**2 + 56*D1**2*b1*f**2*fd*s - 28*D1**2*b1*f**2*fd + 21*D1**2*b1*f**2*fdd*r**2 + 42*D1**2*b1*f**2*fdd*r*s - 28*D1**2*b1*f**2*fdd*r + 21*D1**2*b1*f**2*fdd*s**2 - 28*D1**2*b1*f**2*fdd*s + 14*D1**2*b1*f**2*fdd + 42*D1**2*b1*f*fd**2*r**2 + 84*D1**2*b1*f*fd**2*r*s - 56*D1**2*b1*f*fd**2*r + 42*D1**2*b1*f*fd**2*s**2 - 56*D1**2*b1*f*fd**2*s + 14*D1**2*b1*f*fd**2 - 36*D1**2*b1*f*fd*r**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 - 18*D1**2*f**2*fd*r**2 - 36*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 24*D1**2*f**2*fd*s - 12*D1**2*f**2*fd + 9*D1**2*f**2*fdd*r**2 + 18*D1**2*f**2*fdd*r*s - 12*D1**2*f**2*fdd*r + 9*D1**2*f**2*fdd*s**2 - 12*D1**2*f**2*fdd*s + 6*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r**2 - 144*D1**2*f**2*gd2*r*s + 144*D1**2*f**2*gd2*r - 72*D1**2*f**2*gd2*s**2 + 144*D1**2*f**2*gd2*s - 72*D1**2*f**2*gd2 + 36*D1**2*f**2*gdd2*r**2 + 72*D1**2*f**2*gdd2*r*s - 72*D1**2*f**2*gdd2*r + 36*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2*s + 36*D1**2*f**2*gdd2 + 18*D1**2*f*fd**2*r**2 + 36*D1**2*f*fd**2*r*s - 24*D1**2*f*fd**2*r + 18*D1**2*f*fd**2*s**2 - 24*D1**2*f*fd**2*s + 6*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r**2 - 288*D1**2*f*fd*g2*r*s + 144*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r*s - 216*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 216*D1**2*f*fd*gd2*s + 72*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*r*s - 72*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*r*s - 72*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s + 144*D1*Dd*K*b1*f**2*r**2 + 288*D1*Dd*K*b1*f**2*r*s - 216*D1*Dd*K*b1*f**2*r + 144*D1*Dd*K*b1*f**2*s**2 - 216*D1*Dd*K*b1*f**2*s + 108*D1*Dd*K*b1*f**2 - 288*D1*Dd*K*b1*f*fd*r**2 - 576*D1*Dd*K*b1*f*fd*r*s + 360*D1*Dd*K*b1*f*fd*r - 288*D1*Dd*K*b1*f*fd*s**2 + 360*D1*Dd*K*b1*f*fd*s - 108*D1*Dd*K*b1*f*fd - 56*D1*Dd*b1*f**3*r**2 - 112*D1*Dd*b1*f**3*r*s + 84*D1*Dd*b1*f**3*r - 56*D1*Dd*b1*f**3*s**2 + 84*D1*Dd*b1*f**3*s - 42*D1*Dd*b1*f**3 + 168*D1*Dd*b1*f**2*fd*r**2 + 336*D1*Dd*b1*f**2*fd*r*s - 238*D1*Dd*b1*f**2*fd*r + 168*D1*Dd*b1*f**2*fd*s**2 - 238*D1*Dd*b1*f**2*fd*s + 84*D1*Dd*b1*f**2*fd - 72*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 108*D1*Dd*b1*f**2*s - 54*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 24*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 36*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 72*D1*Dd*f**2*fd*r**2 + 144*D1*Dd*f**2*fd*r*s - 102*D1*Dd*f**2*fd*r + 72*D1*Dd*f**2*fd*s**2 - 102*D1*Dd*f**2*fd*s + 36*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r**2 - 576*D1*Dd*f**2*g2*r*s + 432*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 432*D1*Dd*f**2*g2*s - 216*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r**2 + 576*D1*Dd*f**2*gd2*r*s - 504*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 504*D1*Dd*f**2*gd2*s + 216*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r**2 + 1152*D1*Dd*f*fd*g2*r*s - 720*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 720*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 - 72*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r*s + 108*D1*Ddd*K*b1*f**2*r - 72*D1*Ddd*K*b1*f**2*s**2 + 108*D1*Ddd*K*b1*f**2*s - 54*D1*Ddd*K*b1*f**2 + 28*D1*Ddd*b1*f**3*r**2 + 56*D1*Ddd*b1*f**3*r*s - 42*D1*Ddd*b1*f**3*r + 28*D1*Ddd*b1*f**3*s**2 - 42*D1*Ddd*b1*f**3*s + 21*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*r**2 + 24*D1*Ddd*f**3*r*s - 18*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 18*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r*s - 216*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 216*D1*Ddd*f**2*g2*s + 108*D1*Ddd*f**2*g2 - 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) - 216*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r*s + 324*Dd**2*K*b1*f**2*r - 216*Dd**2*K*b1*f**2*s**2 + 324*Dd**2*K*b1*f**2*s - 108*Dd**2*K*b1*f**2 + 84*Dd**2*b1*f**3*r**2 + 168*Dd**2*b1*f**3*r*s - 126*Dd**2*b1*f**3*r + 84*Dd**2*b1*f**3*s**2 - 126*Dd**2*b1*f**3*s + 42*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 36*Dd**2*f**3*r**2 + 72*Dd**2*f**3*r*s - 54*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 54*Dd**2*f**3*s + 18*Dd**2*f**3 + 432*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r*s - 648*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 648*Dd**2*f**2*g2*s + 216*Dd**2*f**2*g2)/(14*d**2*k3**7) - 3*D1**2*Pk2*Pkd3*ct*k1*k2**5*st**4*(12*C*D1**2*bdd1*f**2*r**2 + 24*C*D1**2*bdd1*f**2*r*s - 24*C*D1**2*bdd1*f**2*r + 12*C*D1**2*bdd1*f**2*s**2 - 24*C*D1**2*bdd1*f**2*s + 12*C*D1**2*bdd1*f**2 - 168*C*D1**2*f**2*fd*r**2 - 336*C*D1**2*f**2*fd*r*s + 224*C*D1**2*f**2*fd*r - 168*C*D1**2*f**2*fd*s**2 + 224*C*D1**2*f**2*fd*s - 112*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r**2 + 240*C*D1**2*f**2*fdd*r*s - 160*C*D1**2*f**2*fdd*r + 120*C*D1**2*f**2*fdd*s**2 - 160*C*D1**2*f**2*fdd*s + 80*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r**2 + 480*C*D1**2*f*fd**2*r*s - 320*C*D1**2*f*fd**2*r + 240*C*D1**2*f*fd**2*s**2 - 320*C*D1**2*f*fd**2*s + 80*C*D1**2*f*fd**2 - 224*C*D1*Dd*f**3*r**2 - 448*C*D1*Dd*f**3*r*s + 336*C*D1*Dd*f**3*r - 224*C*D1*Dd*f**3*s**2 + 336*C*D1*Dd*f**3*s - 168*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r**2 + 1920*C*D1*Dd*f**2*fd*r*s - 1360*C*D1*Dd*f**2*fd*r + 960*C*D1*Dd*f**2*fd*s**2 - 1360*C*D1*Dd*f**2*fd*s + 480*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r**2 + 320*C*D1*Ddd*f**3*r*s - 240*C*D1*Ddd*f**3*r + 160*C*D1*Ddd*f**3*s**2 - 240*C*D1*Ddd*f**3*s + 120*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r**2 + 960*C*Dd**2*f**3*r*s - 720*C*Dd**2*f**3*r + 480*C*Dd**2*f**3*s**2 - 720*C*Dd**2*f**3*s + 240*C*Dd**2*f**3 + 60*D1**2*K*bdd1*f**2*r**2 + 120*D1**2*K*bdd1*f**2*r*s - 120*D1**2*K*bdd1*f**2*r + 60*D1**2*K*bdd1*f**2*s**2 - 120*D1**2*K*bdd1*f**2*s + 60*D1**2*K*bdd1*f**2 - 6*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 9*D1**2*bdd1*f**2*r**2 - 18*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*r - 9*D1**2*bdd1*f**2*s**2 + 18*D1**2*bdd1*f**2*s - 9*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r**2 - 168*D1**2*bdd1*f*g2*r*s + 168*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 120*D1**2*f**2*gdd2*r**2 - 240*D1**2*f**2*gdd2*r*s + 240*D1**2*f**2*gdd2*r - 120*D1**2*f**2*gdd2*s**2 + 240*D1**2*f**2*gdd2*s - 120*D1**2*f**2*gdd2 - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 480*D1**2*f*fd*gd2*r**2 - 960*D1**2*f*fd*gd2*r*s + 720*D1**2*f*fd*gd2*r - 480*D1**2*f*fd*gd2*s**2 + 720*D1**2*f*fd*gd2*s - 240*D1**2*f*fd*gd2 - 240*D1**2*f*fdd*g2*r**2 - 480*D1**2*f*fdd*g2*r*s + 240*D1**2*f*fdd*g2*r - 240*D1**2*f*fdd*g2*s**2 + 240*D1**2*f*fdd*g2*s - 120*D1**2*f*fdd*g2 - 240*D1**2*fd**2*g2*r**2 - 480*D1**2*fd**2*g2*r*s + 240*D1**2*fd**2*g2*r - 240*D1**2*fd**2*g2*s**2 + 240*D1**2*fd**2*g2*s + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 680*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 680*D1*Dd*f**2*fd*s - 240*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 960*D1*Dd*f**2*gd2*r**2 - 1920*D1*Dd*f**2*gd2*r*s + 1680*D1*Dd*f**2*gd2*r - 960*D1*Dd*f**2*gd2*s**2 + 1680*D1*Dd*f**2*gd2*s - 720*D1*Dd*f**2*gd2 - 1920*D1*Dd*f*fd*g2*r**2 - 3840*D1*Dd*f*fd*g2*r*s + 2400*D1*Dd*f*fd*g2*r - 1920*D1*Dd*f*fd*g2*s**2 + 2400*D1*Dd*f*fd*g2*s - 720*D1*Dd*f*fd*g2 - 80*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 120*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 - 480*D1*Ddd*f**2*g2*r**2 - 960*D1*Ddd*f**2*g2*r*s + 720*D1*Ddd*f**2*g2*r - 480*D1*Ddd*f**2*g2*s**2 + 720*D1*Ddd*f**2*g2*s - 360*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(8*C + 12*K + 1)*(r + s - 1) - 2*f*(fd*(4*C + 20*K - 3)*(2*r + 2*s - 1) + (28*g2 - 28*gd2)*(r + s - 1)) + 56*fd*g2*(r + s)) - 2*Dd*f*(f*(4*C + 20*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 240*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 360*Dd**2*f**3*s - 120*Dd**2*f**3 - 1440*Dd**2*f**2*g2*r**2 - 2880*Dd**2*f**2*g2*r*s + 2160*Dd**2*f**2*g2*r - 1440*Dd**2*f**2*g2*s**2 + 2160*Dd**2*f**2*g2*s - 720*Dd**2*f**2*g2 + 3*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-16*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 16*C*D1**2*f*fd*s - 8*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r**2 + 16*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r + 8*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s + 4*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r**2 + 16*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s - 32*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r**2 + 128*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r + 64*C*D1*Dd*f*fd*s**2 - 80*C*D1*Dd*f*fd*s + 24*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r**2 + 32*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s**2 - 24*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r**2 + 96*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s**2 - 72*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 3*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 18*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 12*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 18*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 36*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 54*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 18*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(70*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct*k1*k2**5*st**2*(D1*(-168*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(f**2*(88*C - 42*K - 37)*(r + s - 1) - 8*f*(fd*(18*C - 9)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 336*fd*g2*(r + s)) - 24*Dd*f*(f*(6*C - 3) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6*f*(2*D1*bdd1*(f*(6*C - 3) - 14*g2)*(r + s - 1)**2 + D1*(f*(fd*(6*C - 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*gd2*(r + s - 1)**2) - 14*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(6*C - 3) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + 7*b1**2*(D1**2*(3*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-12*K*fdd + fd*(4*K + 5))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*K + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*(f*(fd*(88*C - 42*K - 37)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*fdd*(18*C - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*(r + s - 1)**2*(42*K*bdd1 + 14*gd2 - 42*gdd2)) + (-8*r - 8*s)*(fd**2*(18*C - 9)*(r + s - 1) + 7*fd*(g2*(r + s) - 6*gd2*(r + s - 1)) - 21*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-24*K*fd*(r + s) + 3*f**2*(r + s - 1) + f*(4*K + 5)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(88*C - 42*K - 37)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*f*(fd*(18*C - 9)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 42*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 336*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(f*(6*C - 3) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(6*C - 3) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k3**7) + D1**2*Pk2*Pkd3*ct*k1*k2**3*st**6*(-48*C*D1**2*f**2*fd*r**2 + 48*C*D1**2*f**2*fd*r*s + 16*C*D1**2*f**2*fd*r + 96*C*D1**2*f**2*fd*s**2 - 80*C*D1**2*f**2*fd*s + 16*C*D1**2*f**2*fd + 24*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s - 8*C*D1**2*f**2*fdd*r - 48*C*D1**2*f**2*fdd*s**2 + 40*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd + 48*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s - 16*C*D1**2*f*fd**2*r - 96*C*D1**2*f*fd**2*s**2 + 80*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 - 64*C*D1*Dd*f**3*r**2 + 64*C*D1*Dd*f**3*r*s + 48*C*D1*Dd*f**3*r + 128*C*D1*Dd*f**3*s**2 - 96*C*D1*Dd*f**3*s + 192*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s - 104*C*D1*Dd*f**2*fd*r - 384*C*D1*Dd*f**2*fd*s**2 + 304*C*D1*Dd*f**2*fd*s - 24*C*D1*Dd*f**2*fd + 32*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s - 24*C*D1*Ddd*f**3*r - 64*C*D1*Ddd*f**3*s**2 + 48*C*D1*Ddd*f**3*s + 96*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s - 72*C*Dd**2*f**3*r - 192*C*Dd**2*f**3*s**2 + 144*C*Dd**2*f**3*s - 144*D1**2*K*b1*f*fd*r**2 + 144*D1**2*K*b1*f*fd*r*s - 72*D1**2*K*b1*f*fd*r + 288*D1**2*K*b1*f*fd*s**2 - 288*D1**2*K*b1*f*fd*s + 144*D1**2*K*b1*f*fd + 72*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*r*s + 36*D1**2*K*b1*f*fdd*r - 144*D1**2*K*b1*f*fdd*s**2 + 144*D1**2*K*b1*f*fdd*s - 72*D1**2*K*b1*f*fdd + 72*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*r*s + 36*D1**2*K*b1*fd**2*r - 144*D1**2*K*b1*fd**2*s**2 + 144*D1**2*K*b1*fd**2*s + 210*D1**2*b1*f**2*fd*r**2 + 252*D1**2*b1*f**2*fd*r*s - 224*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 112*D1**2*b1*f**2*fd*s + 84*D1**2*b1*f**2*fd - 105*D1**2*b1*f**2*fdd*r**2 - 126*D1**2*b1*f**2*fdd*r*s + 112*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 56*D1**2*b1*f**2*fdd*s - 42*D1**2*b1*f**2*fdd - 210*D1**2*b1*f*fd**2*r**2 - 252*D1**2*b1*f*fd**2*r*s + 224*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 112*D1**2*b1*f*fd**2*s - 42*D1**2*b1*f*fd**2 + 324*D1**2*b1*f*fd*r**2 + 360*D1**2*b1*f*fd*r*s - 180*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 162*D1**2*b1*f*fdd*r**2 - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 162*D1**2*b1*fd**2*r**2 - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(r + s - 1)*(9*K*(-4*r + 8*s + 4) + 7*f*(5*r + s - 5) + 81*r + 9*s - 81) - 112*D1**2*f**3*fd*r**2 - 112*D1**2*f**3*fd*r*s + 140*D1**2*f**3*fd*r + 56*D1**2*f**3*fd*s - 56*D1**2*f**3*fd + 112*D1**2*f**3*fdd*r**2 + 112*D1**2*f**3*fdd*r*s - 140*D1**2*f**3*fdd*r - 56*D1**2*f**3*fdd*s + 56*D1**2*f**3*fdd + 336*D1**2*f**2*fd**2*r**2 + 336*D1**2*f**2*fd**2*r*s - 420*D1**2*f**2*fd**2*r - 168*D1**2*f**2*fd**2*s + 112*D1**2*f**2*fd**2 + 78*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 64*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 16*D1**2*f**2*fd*s + 12*D1**2*f**2*fd - 39*D1**2*f**2*fdd*r**2 - 18*D1**2*f**2*fdd*r*s + 32*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s**2 - 8*D1**2*f**2*fdd*s - 6*D1**2*f**2*fdd + 144*D1**2*f**2*gd2*r**2 - 144*D1**2*f**2*gd2*r*s - 288*D1**2*f**2*gd2*r - 288*D1**2*f**2*gd2*s**2 + 144*D1**2*f**2*gd2*s + 144*D1**2*f**2*gd2 - 72*D1**2*f**2*gdd2*r**2 + 72*D1**2*f**2*gdd2*r*s + 144*D1**2*f**2*gdd2*r + 144*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2*s - 72*D1**2*f**2*gdd2 - 78*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 64*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s**2 - 16*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 + 288*D1**2*f*fd*g2*r**2 - 288*D1**2*f*fd*g2*r*s + 144*D1**2*f*fd*g2*r - 576*D1**2*f*fd*g2*s**2 + 576*D1**2*f*fd*g2*s - 288*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r + 576*D1**2*f*fd*gd2*s**2 - 432*D1**2*f*fd*gd2*s + 72*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*r*s - 72*D1**2*f*fdd*g2*r + 288*D1**2*f*fdd*g2*s**2 - 288*D1**2*f*fdd*g2*s + 144*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*r*s - 72*D1**2*fd**2*g2*r + 288*D1**2*fd**2*g2*s**2 - 288*D1**2*fd**2*g2*s - 288*D1*Dd*K*b1*f**2*r**2 + 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r + 576*D1*Dd*K*b1*f**2*s**2 - 432*D1*Dd*K*b1*f**2*s + 576*D1*Dd*K*b1*f*fd*r**2 - 576*D1*Dd*K*b1*f*fd*r*s - 72*D1*Dd*K*b1*f*fd*r - 1152*D1*Dd*K*b1*f*fd*s**2 + 1008*D1*Dd*K*b1*f*fd*s - 216*D1*Dd*K*b1*f*fd + 280*D1*Dd*b1*f**3*r**2 + 336*D1*Dd*b1*f**3*r*s - 364*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 196*D1*Dd*b1*f**3*s + 154*D1*Dd*b1*f**3 - 840*D1*Dd*b1*f**2*fd*r**2 - 1008*D1*Dd*b1*f**2*fd*r*s + 994*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 518*D1*Dd*b1*f**2*fd*s - 280*D1*Dd*b1*f**2*fd + 648*D1*Dd*b1*f**2*r**2 + 720*D1*Dd*b1*f**2*r*s - 828*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 342*D1*Dd*b1*f**2 - 1296*D1*Dd*b1*f*fd*r**2 - 1440*D1*Dd*b1*f*fd*r*s + 1188*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 468*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd - 112*D1*Dd*f**4*r**2 - 112*D1*Dd*f**4*r*s + 140*D1*Dd*f**4*r + 56*D1*Dd*f**4*s - 56*D1*Dd*f**4 + 896*D1*Dd*f**3*fd*r**2 + 896*D1*Dd*f**3*fd*r*s - 1120*D1*Dd*f**3*fd*r - 448*D1*Dd*f**3*fd*s + 336*D1*Dd*f**3*fd + 104*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 116*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 4*D1*Dd*f**3*s + 38*D1*Dd*f**3 - 312*D1*Dd*f**2*fd*r**2 - 144*D1*Dd*f**2*fd*r*s + 302*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s**2 - 38*D1*Dd*f**2*fd*s - 56*D1*Dd*f**2*fd + 576*D1*Dd*f**2*g2*r**2 - 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r - 1152*D1*Dd*f**2*g2*s**2 + 864*D1*Dd*f**2*g2*s - 576*D1*Dd*f**2*gd2*r**2 + 576*D1*Dd*f**2*gd2*r*s + 792*D1*Dd*f**2*gd2*r + 1152*D1*Dd*f**2*gd2*s**2 - 720*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r**2 + 1152*D1*Dd*f*fd*g2*r*s + 144*D1*Dd*f*fd*g2*r + 2304*D1*Dd*f*fd*g2*s**2 - 2016*D1*Dd*f*fd*g2*s + 432*D1*Dd*f*fd*g2 + 144*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r - 288*D1*Ddd*K*b1*f**2*s**2 + 216*D1*Ddd*K*b1*f**2*s - 140*D1*Ddd*b1*f**3*r**2 - 168*D1*Ddd*b1*f**3*r*s + 182*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 98*D1*Ddd*b1*f**3*s - 77*D1*Ddd*b1*f**3 - 324*D1*Ddd*b1*f**2*r**2 - 360*D1*Ddd*b1*f**2*r*s + 414*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 171*D1*Ddd*b1*f**2 + 112*D1*Ddd*f**4*r**2 + 112*D1*Ddd*f**4*r*s - 140*D1*Ddd*f**4*r - 56*D1*Ddd*f**4*s + 56*D1*Ddd*f**4 - 52*D1*Ddd*f**3*r**2 - 24*D1*Ddd*f**3*r*s + 58*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 2*D1*Ddd*f**3*s - 19*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r + 576*D1*Ddd*f**2*g2*s**2 - 432*D1*Ddd*f**2*g2*s + 2*D1*bd1*f*(7*D1*f**2*(5*r**2 + 2*r*(3*s - 5) + s**2 - 6*s + 5) + D1*f*(-7*fd*(15*r**2 + r*(18*s - 23) + 3*s**2 - 13*s + 8) + (r + s - 1)*(-36*K*(r - 2*s - 1) + 81*r + 9*s - 81)) + 9*D1*fd*(2*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 18*r**2 - 20*r*s + 23*r - 2*s**2 + 11*s - 5) - 7*Dd*f**2*(20*r**2 + 3*r*(8*s - 11) + 4*s**2 - 19*s + 13) + 9*Dd*f*(2*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 36*r**2 - 40*r*s + 59*r - 4*s**2 + 31*s - 23)) + 432*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r - 864*Dd**2*K*b1*f**2*s**2 + 648*Dd**2*K*b1*f**2*s - 420*Dd**2*b1*f**3*r**2 - 504*Dd**2*b1*f**3*r*s + 546*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 294*Dd**2*b1*f**3*s - 154*Dd**2*b1*f**3 - 972*Dd**2*b1*f**2*r**2 - 1080*Dd**2*b1*f**2*r*s + 1242*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 342*Dd**2*b1*f**2 + 336*Dd**2*f**4*r**2 + 336*Dd**2*f**4*r*s - 420*Dd**2*f**4*r - 168*Dd**2*f**4*s + 112*Dd**2*f**4 - 156*Dd**2*f**3*r**2 - 72*Dd**2*f**3*r*s + 174*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 6*Dd**2*f**3*s - 38*Dd**2*f**3 - 864*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r + 1728*Dd**2*f**2*g2*s**2 - 1296*Dd**2*f**2*g2*s)/(126*d**2*k3**5) + D1**2*Pk2*Pkd3*ct*k1*k2**3*st**4*(-36*C*D1**2*bdd1*f**2*r**2 - 96*C*D1**2*bdd1*f**2*r*s - 24*C*D1**2*bdd1*f**2*r - 60*C*D1**2*bdd1*f**2*s**2 - 1992*C*D1**2*f**2*fd*r**2 - 3576*C*D1**2*f**2*fd*r*s + 2520*C*D1**2*f**2*fd*r - 1584*C*D1**2*f**2*fd*s**2 + 2248*C*D1**2*f**2*fd*s - 1192*C*D1**2*f**2*fd + 1428*C*D1**2*f**2*fdd*r**2 + 2472*C*D1**2*f**2*fdd*r*s - 1776*C*D1**2*f**2*fdd*r + 1044*C*D1**2*f**2*fdd*s**2 - 1520*C*D1**2*f**2*fdd*s + 824*C*D1**2*f**2*fdd + 2856*C*D1**2*f*fd**2*r**2 + 4944*C*D1**2*f*fd**2*r*s - 3552*C*D1**2*f*fd**2*r + 2088*C*D1**2*f*fd**2*s**2 - 3040*C*D1**2*f*fd**2*s + 824*C*D1**2*f*fd**2 - 2656*C*D1*Dd*f**3*r**2 - 4768*C*D1*Dd*f**3*r*s + 3848*C*D1*Dd*f**3*r - 2112*C*D1*Dd*f**3*s**2 + 3440*C*D1*Dd*f**3*s - 1856*C*D1*Dd*f**3 + 11424*C*D1*Dd*f**2*fd*r**2 + 19776*C*D1*Dd*f**2*fd*r*s - 15288*C*D1*Dd*f**2*fd*r + 8352*C*D1*Dd*f**2*fd*s**2 - 13112*C*D1*Dd*f**2*fd*s + 5072*C*D1*Dd*f**2*fd + 1904*C*D1*Ddd*f**3*r**2 + 3296*C*D1*Ddd*f**3*r*s - 2728*C*D1*Ddd*f**3*r + 1392*C*D1*Ddd*f**3*s**2 - 2344*C*D1*Ddd*f**3*s + 1300*C*D1*Ddd*f**3 + 5712*C*Dd**2*f**3*r**2 + 9888*C*Dd**2*f**3*r*s - 8184*C*Dd**2*f**3*r + 4176*C*Dd**2*f**3*s**2 - 7032*C*Dd**2*f**3*s + 2600*C*Dd**2*f**3 + 690*D1**2*K*bdd1*f**2*r**2 + 1428*D1**2*K*bdd1*f**2*r*s - 1380*D1**2*K*bdd1*f**2*r + 738*D1**2*K*bdd1*f**2*s**2 - 1428*D1**2*K*bdd1*f**2*s + 690*D1**2*K*bdd1*f**2 - 780*D1**2*b2*f*fd*r**2 - 1560*D1**2*b2*f*fd*r*s + 780*D1**2*b2*f*fd*r - 780*D1**2*b2*f*fd*s**2 + 780*D1**2*b2*f*fd*s - 390*D1**2*b2*f*fd + 600*D1**2*b2*f*fdd*r**2 + 1200*D1**2*b2*f*fdd*r*s - 600*D1**2*b2*f*fdd*r + 600*D1**2*b2*f*fdd*s**2 - 600*D1**2*b2*f*fdd*s + 300*D1**2*b2*f*fdd + 600*D1**2*b2*fd**2*r**2 + 1200*D1**2*b2*fd**2*r*s - 600*D1**2*b2*fd**2*r + 600*D1**2*b2*fd**2*s**2 - 600*D1**2*b2*fd**2*s + 6*D1**2*bd1**2*f*(r + s - 1)*(-14*K*(3*r + 5*s + 1) + 25*f - 28*r + 49) - 390*D1**2*bd2*f**2*r**2 - 780*D1**2*bd2*f**2*r*s + 780*D1**2*bd2*f**2*r - 390*D1**2*bd2*f**2*s**2 + 780*D1**2*bd2*f**2*s - 390*D1**2*bd2*f**2 + 1200*D1**2*bd2*f*fd*r**2 + 2400*D1**2*bd2*f*fd*r*s - 1800*D1**2*bd2*f*fd*r + 1200*D1**2*bd2*f*fd*s**2 - 1800*D1**2*bd2*f*fd*s + 600*D1**2*bd2*f*fd - 165*D1**2*bdd1*f**3*r**2 - 330*D1**2*bdd1*f**3*r*s + 390*D1**2*bdd1*f**3*r - 165*D1**2*bdd1*f**3*s**2 + 390*D1**2*bdd1*f**3*s - 225*D1**2*bdd1*f**3 - 189*D1**2*bdd1*f**2*r**2 - 378*D1**2*bdd1*f**2*r*s + 444*D1**2*bdd1*f**2*r - 189*D1**2*bdd1*f**2*s**2 + 444*D1**2*bdd1*f**2*s - 210*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 672*D1**2*bdd1*f*g2*r*s + 168*D1**2*bdd1*f*g2*r + 420*D1**2*bdd1*f*g2*s**2 + 300*D1**2*bdd2*f**2*r**2 + 600*D1**2*bdd2*f**2*r*s - 600*D1**2*bdd2*f**2*r + 300*D1**2*bdd2*f**2*s**2 - 600*D1**2*bdd2*f**2*s + 300*D1**2*bdd2*f**2 + 1176*D1**2*f**2*fd*r**2 + 2064*D1**2*f**2*fd*r*s - 1472*D1**2*f**2*fd*r + 888*D1**2*f**2*fd*s**2 - 1280*D1**2*f**2*fd*s + 688*D1**2*f**2*fd - 921*D1**2*f**2*fdd*r**2 - 1554*D1**2*f**2*fdd*r*s + 1132*D1**2*f**2*fdd*r - 633*D1**2*f**2*fdd*s**2 + 940*D1**2*f**2*fdd*s - 518*D1**2*f**2*fdd + 1416*D1**2*f**2*gd2*r**2 + 3192*D1**2*f**2*gd2*r*s - 2832*D1**2*f**2*gd2*r + 1776*D1**2*f**2*gd2*s**2 - 3192*D1**2*f**2*gd2*s + 1416*D1**2*f**2*gd2 - 1380*D1**2*f**2*gdd2*r**2 - 2856*D1**2*f**2*gdd2*r*s + 2760*D1**2*f**2*gdd2*r - 1476*D1**2*f**2*gdd2*s**2 + 2856*D1**2*f**2*gdd2*s - 1380*D1**2*f**2*gdd2 - 1842*D1**2*f*fd**2*r**2 - 3108*D1**2*f*fd**2*r*s + 2264*D1**2*f*fd**2*r - 1266*D1**2*f*fd**2*s**2 + 1880*D1**2*f*fd**2*s - 518*D1**2*f*fd**2 + 2832*D1**2*f*fd*g2*r**2 + 6384*D1**2*f*fd*g2*r*s - 3192*D1**2*f*fd*g2*r + 3552*D1**2*f*fd*g2*s**2 - 3552*D1**2*f*fd*g2*s + 1776*D1**2*f*fd*g2 - 5520*D1**2*f*fd*gd2*r**2 - 11424*D1**2*f*fd*gd2*r*s + 8376*D1**2*f*fd*gd2*r - 5904*D1**2*f*fd*gd2*s**2 + 8664*D1**2*f*fd*gd2*s - 2856*D1**2*f*fd*gd2 - 2760*D1**2*f*fdd*g2*r**2 - 5712*D1**2*f*fdd*g2*r*s + 2856*D1**2*f*fdd*g2*r - 2952*D1**2*f*fdd*g2*s**2 + 2952*D1**2*f*fdd*g2*s - 1476*D1**2*f*fdd*g2 - 2760*D1**2*fd**2*g2*r**2 - 5712*D1**2*fd**2*g2*r*s + 2856*D1**2*fd**2*g2*r - 2952*D1**2*fd**2*g2*s**2 + 2952*D1**2*fd**2*g2*s - 1560*D1*Dd*b2*f**2*r**2 - 3120*D1*Dd*b2*f**2*r*s + 2340*D1*Dd*b2*f**2*r - 1560*D1*Dd*b2*f**2*s**2 + 2340*D1*Dd*b2*f**2*s - 1170*D1*Dd*b2*f**2 + 4800*D1*Dd*b2*f*fd*r**2 + 9600*D1*Dd*b2*f*fd*r*s - 6000*D1*Dd*b2*f*fd*r + 4800*D1*Dd*b2*f*fd*s**2 - 6000*D1*Dd*b2*f*fd*s + 1800*D1*Dd*b2*f*fd + 2400*D1*Dd*bd2*f**2*r**2 + 4800*D1*Dd*bd2*f**2*r*s - 4200*D1*Dd*bd2*f**2*r + 2400*D1*Dd*bd2*f**2*s**2 - 4200*D1*Dd*bd2*f**2*s + 1800*D1*Dd*bd2*f**2 + 1568*D1*Dd*f**3*r**2 + 2752*D1*Dd*f**3*r*s - 2256*D1*Dd*f**3*r + 1184*D1*Dd*f**3*s**2 - 1968*D1*Dd*f**3*s + 1080*D1*Dd*f**3 - 7368*D1*Dd*f**2*fd*r**2 - 12432*D1*Dd*f**2*fd*r*s + 9766*D1*Dd*f**2*fd*r - 5064*D1*Dd*f**2*fd*s**2 + 8134*D1*Dd*f**2*fd*s - 3204*D1*Dd*f**2*fd + 5664*D1*Dd*f**2*g2*r**2 + 12768*D1*Dd*f**2*g2*r*s - 8856*D1*Dd*f**2*g2*r + 7104*D1*Dd*f**2*g2*s**2 - 9936*D1*Dd*f**2*g2*s + 4608*D1*Dd*f**2*g2 - 11040*D1*Dd*f**2*gd2*r**2 - 22848*D1*Dd*f**2*gd2*r*s + 19416*D1*Dd*f**2*gd2*r - 11808*D1*Dd*f**2*gd2*s**2 + 20088*D1*Dd*f**2*gd2*s - 8376*D1*Dd*f**2*gd2 - 22080*D1*Dd*f*fd*g2*r**2 - 45696*D1*Dd*f*fd*g2*r*s + 28176*D1*Dd*f*fd*g2*r - 23616*D1*Dd*f*fd*g2*s**2 + 29136*D1*Dd*f*fd*g2*s - 8664*D1*Dd*f*fd*g2 + 1200*D1*Ddd*b2*f**2*r**2 + 2400*D1*Ddd*b2*f**2*r*s - 1800*D1*Ddd*b2*f**2*r + 1200*D1*Ddd*b2*f**2*s**2 - 1800*D1*Ddd*b2*f**2*s + 900*D1*Ddd*b2*f**2 - 1228*D1*Ddd*f**3*r**2 - 2072*D1*Ddd*f**3*r*s + 1746*D1*Ddd*f**3*r - 844*D1*Ddd*f**3*s**2 + 1458*D1*Ddd*f**3*s - 825*D1*Ddd*f**3 - 5520*D1*Ddd*f**2*g2*r**2 - 11424*D1*Ddd*f**2*g2*r*s + 8376*D1*Ddd*f**2*g2*r - 5904*D1*Ddd*f**2*g2*s**2 + 8664*D1*Ddd*f**2*g2*s - 4236*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(10*f**3*(r**2 + 3*r*(s - 1) + 2*(s - 1)**2) + f**2*(12*C*r**2 + 32*C*r*s + 8*C*r + 20*C*s**2 - 2*K*(59*r**2 + 133*r*s - 118*r + 74*s**2 - 133*s + 59) - 5*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) + 14*r*s - 22*r + 14*s**2 - 36*s + 7) - 2*f*(fd*(2*C*(6*r**2 + 2*r*(8*s - 3) + 10*s**2 - 9*s - 1) - K*(230*r**2 + 476*r*s - 349*r + 246*s**2 - 361*s + 119) + 63*r**2 + 126*r*s - 100*r + 63*s**2 - 100*s + 39) + 14*g2*(3*r**2 + r*(8*s + 2) + 5*s**2) + 14*gd2*(-3*r**2 + r*(2 - 8*s) - 5*s**2 + 4*s + 1)) + 28*fd*g2*(3*r**2 + r*(8*s - 4) + s*(5*s - 5))) - Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + f*(4*C*(12*r**2 + r*(32*s - 6) + 20*s**2 - 13*s - 2) - 2*K*(460*r**2 + 952*r*s - 809*r + 492*s**2 - 837*s + 349) + 252*r**2 + 504*r*s - 485*r + 252*s**2 - 485*s + 222) - 28*g2*(12*r**2 + r*(32*s - 6) + 20*s**2 - 13*s - 2))) + 3600*Dd**2*b2*f**2*r**2 + 7200*Dd**2*b2*f**2*r*s - 5400*Dd**2*b2*f**2*r + 3600*Dd**2*b2*f**2*s**2 - 5400*Dd**2*b2*f**2*s + 1800*Dd**2*b2*f**2 - 3684*Dd**2*f**3*r**2 - 6216*Dd**2*f**3*r*s + 5238*Dd**2*f**3*r - 2532*Dd**2*f**3*s**2 + 4374*Dd**2*f**3*s - 1650*Dd**2*f**3 - 16560*Dd**2*f**2*g2*r**2 - 34272*Dd**2*f**2*g2*r*s + 25128*Dd**2*f**2*g2*r - 17712*Dd**2*f**2*g2*s**2 + 25992*Dd**2*f**2*g2*s - 8472*Dd**2*f**2*g2 + 3*b1**2*(D1**2*(50*f*fd*(2*r + 2*s - 1) - 25*f*fdd*(2*r + 2*s - 1) - 50*fd**2*(r + s - 1) + 14*fd*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 2*r*(2*s + 5) + 10*s - 5) - 7*fdd*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 2*r*(2*s + 5) + 10*s - 5)) - 2*D1*(Dd*(f*(-14*K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 25*fd*(4*r + 4*s - 3) - 112*r**2 - 112*r*s + 140*r + 56*s - 56) + 7*fd*(K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 16*r**2 + 2*r*(8*s + 5) + 16*s - 15)) + 7*Ddd*f*(K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 8*r**2 + 2*r*(4*s - 5) - 4*s + 4)) - 28*Dd**2*f*(K*(18*r**2 + 6*r*(8*s - 5) + 30*s**2 - 39*s + 11) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) - 3*b1*(-48*C*D1**2*f*fd*r**2 - 128*C*D1**2*f*fd*r*s + 128*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 144*C*D1**2*f*fd*s - 64*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 64*C*D1**2*f*fdd*r*s - 64*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 32*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 64*C*D1**2*fd**2*r*s - 64*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s + 40*C*D1**2*fd**2 - 96*C*D1*Dd*f**2*r**2 - 256*C*D1*Dd*f**2*r*s + 160*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 208*C*D1*Dd*f**2*s - 88*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 512*C*D1*Dd*f*fd*r*s - 416*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 496*C*D1*Dd*f*fd*s + 200*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 128*C*D1*Ddd*f**2*r*s - 80*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 104*C*D1*Ddd*f**2*s + 44*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 384*C*Dd**2*f**2*r*s - 240*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 312*C*Dd**2*f**2*s + 88*C*Dd**2*f**2 + 472*D1**2*K*f*fd*r**2 + 1064*D1**2*K*f*fd*r*s - 532*D1**2*K*f*fd*r + 592*D1**2*K*f*fd*s**2 - 592*D1**2*K*f*fd*s + 296*D1**2*K*f*fd - 460*D1**2*K*f*fdd*r**2 - 952*D1**2*K*f*fdd*r*s + 476*D1**2*K*f*fdd*r - 492*D1**2*K*f*fdd*s**2 + 492*D1**2*K*f*fdd*s - 246*D1**2*K*f*fdd - 460*D1**2*K*fd**2*r**2 - 952*D1**2*K*fd**2*r*s + 476*D1**2*K*fd**2*r - 492*D1**2*K*fd**2*s**2 + 492*D1**2*K*fd**2*s + D1**2*bdd1*f*(14*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) - 25*f*(2*r + 2*s - 1) + 56*r**2 + 56*r*s - 154*r - 98*s + 63) - 60*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 80*D1**2*f**2*fd*r - 120*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 40*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 56*D1**2*f*fd*r*s - 16*D1**2*f*fd*r - 56*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 14*D1**2*f*fd + 126*D1**2*f*fdd*r**2 + 252*D1**2*f*fdd*r*s - 104*D1**2*f*fdd*r + 126*D1**2*f*fdd*s**2 - 104*D1**2*f*fdd*s + 56*D1**2*f*fdd + 168*D1**2*f*gd2*r**2 + 448*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r + 280*D1**2*f*gd2*s**2 - 448*D1**2*f*gd2*s + 168*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 224*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 140*D1**2*f*gdd2*s**2 + 224*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 + 126*D1**2*fd**2*r**2 + 252*D1**2*fd**2*r*s - 104*D1**2*fd**2*r + 126*D1**2*fd**2*s**2 - 104*D1**2*fd**2*s - 30*D1**2*fd**2 + 168*D1**2*fd*g2*r**2 + 448*D1**2*fd*g2*r*s - 560*D1**2*fd*g2*r + 280*D1**2*fd*g2*s**2 - 560*D1**2*fd*g2*s + 280*D1**2*fd*g2 - 168*D1**2*fd*gd2*r**2 - 448*D1**2*fd*gd2*r*s + 448*D1**2*fd*gd2*r - 280*D1**2*fd*gd2*s**2 + 504*D1**2*fd*gd2*s - 280*D1**2*fd*gd2 - 84*D1**2*fdd*g2*r**2 - 224*D1**2*fdd*g2*r*s + 280*D1**2*fdd*g2*r - 140*D1**2*fdd*g2*s**2 + 280*D1**2*fdd*g2*s - 140*D1**2*fdd*g2 + 944*D1*Dd*K*f**2*r**2 + 2128*D1*Dd*K*f**2*r*s - 1476*D1*Dd*K*f**2*r + 1184*D1*Dd*K*f**2*s**2 - 1656*D1*Dd*K*f**2*s + 768*D1*Dd*K*f**2 - 3680*D1*Dd*K*f*fd*r**2 - 7616*D1*Dd*K*f*fd*r*s + 4696*D1*Dd*K*f*fd*r - 3936*D1*Dd*K*f*fd*s**2 + 4856*D1*Dd*K*f*fd*s - 1444*D1*Dd*K*f*fd - 80*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 140*D1*Dd*f**3*r - 160*D1*Dd*f**3*s**2 + 200*D1*Dd*f**3*s - 80*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1790*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 112*D1*Dd*f**2*r*s + 28*D1*Dd*f**2*r - 112*D1*Dd*f**2*s**2 + 112*D1*Dd*f**2*s - 28*D1*Dd*f**2 + 1008*D1*Dd*f*fd*r**2 + 2016*D1*Dd*f*fd*r*s - 1172*D1*Dd*f*fd*r + 1008*D1*Dd*f*fd*s**2 - 1172*D1*Dd*f*fd*s + 312*D1*Dd*f*fd + 672*D1*Dd*f*g2*r**2 + 1792*D1*Dd*f*g2*r*s - 1120*D1*Dd*f*g2*r + 1120*D1*Dd*f*g2*s**2 - 1456*D1*Dd*f*g2*s + 616*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1792*D1*Dd*f*gd2*r*s + 1232*D1*Dd*f*gd2*r - 1120*D1*Dd*f*gd2*s**2 + 1624*D1*Dd*f*gd2*s - 560*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1792*D1*Dd*fd*g2*r*s + 1680*D1*Dd*fd*g2*r - 1120*D1*Dd*fd*g2*s**2 + 1848*D1*Dd*fd*g2*s - 840*D1*Dd*fd*g2 - 920*D1*Ddd*K*f**2*r**2 - 1904*D1*Ddd*K*f**2*r*s + 1396*D1*Ddd*K*f**2*r - 984*D1*Ddd*K*f**2*s**2 + 1444*D1*Ddd*K*f**2*s - 706*D1*Ddd*K*f**2 + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 252*D1*Ddd*f**2*r**2 + 504*D1*Ddd*f**2*r*s - 378*D1*Ddd*f**2*r + 252*D1*Ddd*f**2*s**2 - 378*D1*Ddd*f**2*s + 189*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 896*D1*Ddd*f*g2*r*s + 560*D1*Ddd*f*g2*r - 560*D1*Ddd*f*g2*s**2 + 728*D1*Ddd*f*g2*s - 308*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(25*f**2*(2*r + 2*s - 1) - 7*f*(2*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) + 8*r**2 + 8*r*s - 22*r - 14*s + 9) + 7*fd*(2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) + 8*r**2 + 8*r*s - r + 3*s - 5)) + Dd*f*(28*K*(12*r**2 + 2*r*(16*s - 7) + 20*s**2 - 21*s + 4) - 25*f*(4*r + 4*s - 3) + 224*r**2 + 224*r*(s - 2) - 252*s + 203)) - 2760*Dd**2*K*f**2*r**2 - 5712*Dd**2*K*f**2*r*s + 4188*Dd**2*K*f**2*r - 2952*Dd**2*K*f**2*s**2 + 4332*Dd**2*K*f**2*s - 1412*Dd**2*K*f**2 + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 330*Dd**2*f**3 + 756*Dd**2*f**2*r**2 + 1512*Dd**2*f**2*r*s - 1134*Dd**2*f**2*r + 756*Dd**2*f**2*s**2 - 1134*Dd**2*f**2*s + 378*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2688*Dd**2*f*g2*r*s + 1680*Dd**2*f*g2*r - 1680*Dd**2*f*g2*s**2 + 2184*Dd**2*f*g2*s - 616*Dd**2*f*g2))/(210*d**2*k3**5) - D1**2*Pk2*Pkd3*ct*k1*k2**3*st**2*(280*C*D1**2*bd1**2*f*r**2 + 560*C*D1**2*bd1**2*f*r*s - 280*C*D1**2*bd1**2*f*r + 280*C*D1**2*bd1**2*f*s**2 - 280*C*D1**2*bd1**2*f*s + 1064*C*D1**2*bd1*f**2*r**2 + 2112*C*D1**2*bd1*f**2*r*s - 2272*C*D1**2*bd1*f**2*r + 1048*C*D1**2*bd1*f**2*s**2 - 2256*C*D1**2*bd1*f**2*s + 1128*C*D1**2*bd1*f**2 - 2912*C*D1**2*bd1*f*fd*r**2 - 5344*C*D1**2*bd1*f*fd*r*s + 4488*C*D1**2*bd1*f*fd*r - 2432*C*D1**2*bd1*f*fd*s**2 + 4128*C*D1**2*bd1*f*fd*s - 1696*C*D1**2*bd1*f*fd - 728*C*D1**2*bdd1*f**2*r**2 - 1336*C*D1**2*bdd1*f**2*r*s + 1696*C*D1**2*bdd1*f**2*r - 608*C*D1**2*bdd1*f**2*s**2 + 1576*C*D1**2*bdd1*f**2*s - 788*C*D1**2*bdd1*f**2 - 216*C*D1**2*f**2*fd*r**2 + 216*C*D1**2*f**2*fd*r*s + 72*C*D1**2*f**2*fd*r + 432*C*D1**2*f**2*fd*s**2 - 360*C*D1**2*f**2*fd*s + 72*C*D1**2*f**2*fd - 828*C*D1**2*f**2*fdd*r**2 - 2016*C*D1**2*f**2*fdd*r*s + 1224*C*D1**2*f**2*fdd*r - 1188*C*D1**2*f**2*fdd*s**2 + 1464*C*D1**2*f**2*fdd*s - 672*C*D1**2*f**2*fdd - 1656*C*D1**2*f*fd**2*r**2 - 4032*C*D1**2*f*fd**2*r*s + 2448*C*D1**2*f*fd**2*r - 2376*C*D1**2*f*fd**2*s**2 + 2928*C*D1**2*f*fd**2*s - 672*C*D1**2*f*fd**2 - 5824*C*D1*Dd*bd1*f**2*r**2 - 10688*C*D1*Dd*bd1*f**2*r*s + 11032*C*D1*Dd*bd1*f**2*r - 4864*C*D1*Dd*bd1*f**2*s**2 + 10192*C*D1*Dd*bd1*f**2*s - 4968*C*D1*Dd*bd1*f**2 - 288*C*D1*Dd*f**3*r**2 + 288*C*D1*Dd*f**3*r*s + 216*C*D1*Dd*f**3*r + 576*C*D1*Dd*f**3*s**2 - 432*C*D1*Dd*f**3*s - 6624*C*D1*Dd*f**2*fd*r**2 - 16128*C*D1*Dd*f**2*fd*r*s + 10224*C*D1*Dd*f**2*fd*r - 9504*C*D1*Dd*f**2*fd*s**2 + 12264*C*D1*Dd*f**2*fd*s - 3912*C*D1*Dd*f**2*fd - 1104*C*D1*Ddd*f**3*r**2 - 2688*C*D1*Ddd*f**3*r*s + 1776*C*D1*Ddd*f**3*r - 1584*C*D1*Ddd*f**3*s**2 + 2136*C*D1*Ddd*f**3*s - 948*C*D1*Ddd*f**3 - 3312*C*Dd**2*f**3*r**2 - 8064*C*Dd**2*f**3*r*s + 5328*C*Dd**2*f**3*r - 4752*C*Dd**2*f**3*s**2 + 6408*C*Dd**2*f**3*s - 1896*C*Dd**2*f**3 - 1624*D1**2*K*bd1**2*f*r**2 - 3416*D1**2*K*bd1**2*f*r*s + 3752*D1**2*K*bd1**2*f*r - 1792*D1**2*K*bd1**2*f*s**2 + 3920*D1**2*K*bd1**2*f*s - 2128*D1**2*K*bd1**2*f - 252*D1**2*K*bd1*f**2*r**2 - 84*D1**2*K*bd1*f**2*r*s + 504*D1**2*K*bd1*f**2*r + 168*D1**2*K*bd1*f**2*s**2 + 84*D1**2*K*bd1*f**2*s - 252*D1**2*K*bd1*f**2 - 840*D1**2*K*bd1*f*fd*r**2 - 2688*D1**2*K*bd1*f*fd*r*s + 1512*D1**2*K*bd1*f*fd*r - 1848*D1**2*K*bd1*f*fd*s**2 + 2268*D1**2*K*bd1*f*fd*s - 672*D1**2*K*bd1*f*fd - 210*D1**2*K*bdd1*f**2*r**2 - 672*D1**2*K*bdd1*f**2*r*s + 420*D1**2*K*bdd1*f**2*r - 462*D1**2*K*bdd1*f**2*s**2 + 672*D1**2*K*bdd1*f**2*s - 210*D1**2*K*bdd1*f**2 + 630*D1**2*bd1**2*f**2*r**2 + 924*D1**2*bd1**2*f**2*r*s - 1092*D1**2*bd1**2*f**2*r + 294*D1**2*bd1**2*f**2*s**2 - 756*D1**2*bd1**2*f**2*s + 462*D1**2*bd1**2*f**2 + 392*D1**2*bd1**2*f*r**2 + 616*D1**2*bd1**2*f*r*s - 910*D1**2*bd1**2*f*r + 224*D1**2*bd1**2*f*s**2 - 742*D1**2*bd1**2*f*s + 518*D1**2*bd1**2*f - 1400*D1**2*bd1**2*g2*r**2 - 2800*D1**2*bd1**2*g2*r*s + 1400*D1**2*bd1**2*g2*r - 1400*D1**2*bd1**2*g2*s**2 + 1400*D1**2*bd1**2*g2*s - 840*D1**2*bd1*bd2*f*r**2 - 1680*D1**2*bd1*bd2*f*r*s + 1680*D1**2*bd1*bd2*f*r - 840*D1**2*bd1*bd2*f*s**2 + 1680*D1**2*bd1*bd2*f*s - 840*D1**2*bd1*bd2*f - 575*D1**2*bd1*f**2*r**2 - 1142*D1**2*bd1*f**2*r*s + 1068*D1**2*bd1*f**2*r - 567*D1**2*bd1*f**2*s**2 + 1060*D1**2*bd1*f**2*s - 488*D1**2*bd1*f**2 + 2004*D1**2*bd1*f*fd*r**2 + 3432*D1**2*bd1*f*fd*r*s - 2898*D1**2*bd1*f*fd*r + 1428*D1**2*bd1*f*fd*s**2 - 2466*D1**2*bd1*f*fd*s + 1038*D1**2*bd1*f*fd - 2408*D1**2*bd1*f*g2*r**2 - 5152*D1**2*bd1*f*g2*r*s + 4032*D1**2*bd1*f*g2*r - 2744*D1**2*bd1*f*g2*s**2 + 4368*D1**2*bd1*f*g2*s - 2184*D1**2*bd1*f*g2 + 3248*D1**2*bd1*f*gd2*r**2 + 6832*D1**2*bd1*f*gd2*r*s - 7504*D1**2*bd1*f*gd2*r + 3584*D1**2*bd1*f*gd2*s**2 - 7840*D1**2*bd1*f*gd2*s + 4256*D1**2*bd1*f*gd2 + 3248*D1**2*bd1*fd*g2*r**2 + 6832*D1**2*bd1*fd*g2*r*s - 3416*D1**2*bd1*fd*g2*r + 3584*D1**2*bd1*fd*g2*s**2 - 3584*D1**2*bd1*fd*g2*s - 210*D1**2*bd2*f**2*r**2 - 420*D1**2*bd2*f**2*r*s + 420*D1**2*bd2*f**2*r - 210*D1**2*bd2*f**2*s**2 + 420*D1**2*bd2*f**2*s - 210*D1**2*bd2*f**2 + 501*D1**2*bdd1*f**2*r**2 + 858*D1**2*bdd1*f**2*r*s - 1038*D1**2*bdd1*f**2*r + 357*D1**2*bdd1*f**2*s**2 - 894*D1**2*bdd1*f**2*s + 447*D1**2*bdd1*f**2 + 1624*D1**2*bdd1*f*g2*r**2 + 3416*D1**2*bdd1*f*g2*r*s - 4256*D1**2*bdd1*f*g2*r + 1792*D1**2*bdd1*f*g2*s**2 - 4424*D1**2*bdd1*f*g2*s + 2212*D1**2*bdd1*f*g2 + 216*D1**2*f**2*fd*r**2 - 144*D1**2*f**2*fd*r - 216*D1**2*f**2*fd*s**2 + 144*D1**2*f**2*fd*s + 414*D1**2*f**2*fdd*r**2 + 1008*D1**2*f**2*fdd*r*s - 612*D1**2*f**2*fdd*r + 594*D1**2*f**2*fdd*s**2 - 732*D1**2*f**2*fdd*s + 336*D1**2*f**2*fdd + 504*D1**2*f**2*gd2*r**2 + 168*D1**2*f**2*gd2*r*s - 1008*D1**2*f**2*gd2*r - 336*D1**2*f**2*gd2*s**2 - 168*D1**2*f**2*gd2*s + 504*D1**2*f**2*gd2 + 420*D1**2*f**2*gdd2*r**2 + 1344*D1**2*f**2*gdd2*r*s - 840*D1**2*f**2*gdd2*r + 924*D1**2*f**2*gdd2*s**2 - 1344*D1**2*f**2*gdd2*s + 420*D1**2*f**2*gdd2 + 828*D1**2*f*fd**2*r**2 + 2016*D1**2*f*fd**2*r*s - 1224*D1**2*f*fd**2*r + 1188*D1**2*f*fd**2*s**2 - 1464*D1**2*f*fd**2*s + 336*D1**2*f*fd**2 + 1008*D1**2*f*fd*g2*r**2 + 336*D1**2*f*fd*g2*r*s - 168*D1**2*f*fd*g2*r - 672*D1**2*f*fd*g2*s**2 + 672*D1**2*f*fd*g2*s - 336*D1**2*f*fd*g2 + 1680*D1**2*f*fd*gd2*r**2 + 5376*D1**2*f*fd*gd2*r*s - 3024*D1**2*f*fd*gd2*r + 3696*D1**2*f*fd*gd2*s**2 - 4536*D1**2*f*fd*gd2*s + 1344*D1**2*f*fd*gd2 + 840*D1**2*f*fdd*g2*r**2 + 2688*D1**2*f*fdd*g2*r*s - 1344*D1**2*f*fdd*g2*r + 1848*D1**2*f*fdd*g2*s**2 - 1848*D1**2*f*fdd*g2*s + 924*D1**2*f*fdd*g2 + 840*D1**2*fd**2*g2*r**2 + 2688*D1**2*fd**2*g2*r*s - 1344*D1**2*fd**2*g2*r + 1848*D1**2*fd**2*g2*s**2 - 1848*D1**2*fd**2*g2*s - 1680*D1*Dd*K*bd1*f**2*r**2 - 5376*D1*Dd*K*bd1*f**2*r*s + 3192*D1*Dd*K*bd1*f**2*r - 3696*D1*Dd*K*bd1*f**2*s**2 + 4956*D1*Dd*K*bd1*f**2*s - 1512*D1*Dd*K*bd1*f**2 + 4008*D1*Dd*bd1*f**2*r**2 + 6864*D1*Dd*bd1*f**2*r*s - 7014*D1*Dd*bd1*f**2*r + 2856*D1*Dd*bd1*f**2*s**2 - 6006*D1*Dd*bd1*f**2*s + 2970*D1*Dd*bd1*f**2 + 12992*D1*Dd*bd1*f*g2*r**2 + 27328*D1*Dd*bd1*f*g2*r*s - 26936*D1*Dd*bd1*f*g2*r + 14336*D1*Dd*bd1*f*g2*s**2 - 28112*D1*Dd*bd1*f*g2*s + 12936*D1*Dd*bd1*f*g2 + 288*D1*Dd*f**3*r**2 - 288*D1*Dd*f**3*r - 288*D1*Dd*f**3*s**2 + 144*D1*Dd*f**3*s + 72*D1*Dd*f**3 + 3312*D1*Dd*f**2*fd*r**2 + 8064*D1*Dd*f**2*fd*r*s - 5112*D1*Dd*f**2*fd*r + 4752*D1*Dd*f**2*fd*s**2 - 6132*D1*Dd*f**2*fd*s + 1956*D1*Dd*f**2*fd + 2016*D1*Dd*f**2*g2*r**2 + 672*D1*Dd*f**2*g2*r*s - 2184*D1*Dd*f**2*g2*r - 1344*D1*Dd*f**2*g2*s**2 + 336*D1*Dd*f**2*g2*s + 672*D1*Dd*f**2*g2 + 3360*D1*Dd*f**2*gd2*r**2 + 10752*D1*Dd*f**2*gd2*r*s - 6384*D1*Dd*f**2*gd2*r + 7392*D1*Dd*f**2*gd2*s**2 - 9912*D1*Dd*f**2*gd2*s + 3024*D1*Dd*f**2*gd2 + 6720*D1*Dd*f*fd*g2*r**2 + 21504*D1*Dd*f*fd*g2*r*s - 11424*D1*Dd*f*fd*g2*r + 14784*D1*Dd*f*fd*g2*s**2 - 16464*D1*Dd*f*fd*g2*s + 4536*D1*Dd*f*fd*g2 + 552*D1*Ddd*f**3*r**2 + 1344*D1*Ddd*f**3*r*s - 888*D1*Ddd*f**3*r + 792*D1*Ddd*f**3*s**2 - 1068*D1*Ddd*f**3*s + 474*D1*Ddd*f**3 + 1680*D1*Ddd*f**2*g2*r**2 + 5376*D1*Ddd*f**2*g2*r*s - 3024*D1*Ddd*f**2*g2*r + 3696*D1*Ddd*f**2*g2*s**2 - 4536*D1*Ddd*f**2*g2*s + 1764*D1*Ddd*f**2*g2 + 70*D1*b2*(bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 1656*Dd**2*f**3*r**2 + 4032*Dd**2*f**3*r*s - 2664*Dd**2*f**3*r + 2376*Dd**2*f**3*s**2 - 3204*Dd**2*f**3*s + 948*Dd**2*f**3 + 5040*Dd**2*f**2*g2*r**2 + 16128*Dd**2*f**2*g2*r*s - 9072*Dd**2*f**2*g2*r + 11088*Dd**2*f**2*g2*s**2 - 13608*Dd**2*f**2*g2*s + 3528*Dd**2*f**2*g2 + 35*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-40*C*D1**2*fd*r**2 - 80*C*D1**2*fd*r*s + 80*C*D1**2*fd*r - 40*C*D1**2*fd*s**2 + 80*C*D1**2*fd*s - 40*C*D1**2*fd + 20*C*D1**2*fdd*r**2 + 40*C*D1**2*fdd*r*s - 40*C*D1**2*fdd*r + 20*C*D1**2*fdd*s**2 - 40*C*D1**2*fdd*s + 20*C*D1**2*fdd - 160*C*D1*Dd*f*r**2 - 320*C*D1*Dd*f*r*s + 240*C*D1*Dd*f*r - 160*C*D1*Dd*f*s**2 + 240*C*D1*Dd*f*s - 120*C*D1*Dd*f + 160*C*D1*Dd*fd*r**2 + 320*C*D1*Dd*fd*r*s - 280*C*D1*Dd*fd*r + 160*C*D1*Dd*fd*s**2 - 280*C*D1*Dd*fd*s + 120*C*D1*Dd*fd + 80*C*D1*Ddd*f*r**2 + 160*C*D1*Ddd*f*r*s - 120*C*D1*Ddd*f*r + 80*C*D1*Ddd*f*s**2 - 120*C*D1*Ddd*f*s + 60*C*D1*Ddd*f + 240*C*Dd**2*f*r**2 + 480*C*Dd**2*f*r*s - 360*C*Dd**2*f*r + 240*C*Dd**2*f*s**2 - 360*C*Dd**2*f*s + 120*C*Dd**2*f + 172*D1**2*K*fd*r**2 + 368*D1**2*K*fd*r*s - 80*D1**2*K*fd*r + 196*D1**2*K*fd*s**2 - 80*D1**2*K*fd*s + 40*D1**2*K*fd - 116*D1**2*K*fdd*r**2 - 244*D1**2*K*fdd*r*s - 60*D1**2*K*fdd*r - 128*D1**2*K*fdd*s**2 - 60*D1**2*K*fdd*s + 30*D1**2*K*fdd - 5*D1**2*bdd1*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 78*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 108*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 84*D1**2*f*fd*s - 54*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 132*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 45*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 132*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s + 9*D1**2*fd*r**2 + 22*D1**2*fd*r*s - 10*D1**2*fd*r + 13*D1**2*fd*s**2 - 10*D1**2*fd*s + 5*D1**2*fd + 28*D1**2*fdd*r**2 + 44*D1**2*fdd*r*s + 30*D1**2*fdd*r + 16*D1**2*fdd*s**2 + 30*D1**2*fdd*s - 15*D1**2*fdd + 200*D1**2*gd2*r**2 + 400*D1**2*gd2*r*s - 400*D1**2*gd2*r + 200*D1**2*gd2*s**2 - 400*D1**2*gd2*s + 200*D1**2*gd2 - 100*D1**2*gdd2*r**2 - 200*D1**2*gdd2*r*s + 200*D1**2*gdd2*r - 100*D1**2*gdd2*s**2 + 200*D1**2*gdd2*s - 100*D1**2*gdd2 + 688*D1*Dd*K*f*r**2 + 1472*D1*Dd*K*f*r*s - 1056*D1*Dd*K*f*r + 784*D1*Dd*K*f*s**2 - 1128*D1*Dd*K*f*s + 540*D1*Dd*K*f - 928*D1*Dd*K*fd*r**2 - 1952*D1*Dd*K*fd*r*s + 468*D1*Dd*K*fd*r - 1024*D1*Dd*K*fd*s**2 + 504*D1*Dd*K*fd*s + 180*D1*Dd*K*fd - 156*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 93*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1056*D1*Dd*f*fd*r*s - 852*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 612*D1*Dd*f*fd*s + 246*D1*Dd*f*fd + 36*D1*Dd*f*r**2 + 88*D1*Dd*f*r*s - 58*D1*Dd*f*r + 52*D1*Dd*f*s**2 - 70*D1*Dd*f*s + 31*D1*Dd*f + 224*D1*Dd*fd*r**2 + 352*D1*Dd*fd*r*s - 36*D1*Dd*fd*r + 128*D1*Dd*fd*s**2 - 90*D1*Dd*fd + 800*D1*Dd*g2*r**2 + 1600*D1*Dd*g2*r*s - 1200*D1*Dd*g2*r + 800*D1*Dd*g2*s**2 - 1200*D1*Dd*g2*s + 600*D1*Dd*g2 - 800*D1*Dd*gd2*r**2 - 1600*D1*Dd*gd2*r*s + 1400*D1*Dd*gd2*r - 800*D1*Dd*gd2*s**2 + 1400*D1*Dd*gd2*s - 600*D1*Dd*gd2 - 464*D1*Ddd*K*f*r**2 - 976*D1*Ddd*K*f*r*s + 708*D1*Ddd*K*f*r - 512*D1*Ddd*K*f*s**2 + 744*D1*Ddd*K*f*s - 360*D1*Ddd*K*f + 180*D1*Ddd*f**2*r**2 + 264*D1*Ddd*f**2*r*s - 246*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 174*D1*Ddd*f**2*s + 111*D1*Ddd*f**2 + 112*D1*Ddd*f*r**2 + 176*D1*Ddd*f*r*s - 156*D1*Ddd*f*r + 64*D1*Ddd*f*s**2 - 120*D1*Ddd*f*s + 72*D1*Ddd*f - 400*D1*Ddd*g2*r**2 - 800*D1*Ddd*g2*r*s + 600*D1*Ddd*g2*r - 400*D1*Ddd*g2*s**2 + 600*D1*Ddd*g2*s - 300*D1*Ddd*g2 + 10*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-10*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 1392*Dd**2*K*f*r**2 - 2928*Dd**2*K*f*r*s + 2124*Dd**2*K*f*r - 1536*Dd**2*K*f*s**2 + 2232*Dd**2*K*f*s - 720*Dd**2*K*f + 540*Dd**2*f**2*r**2 + 792*Dd**2*f**2*r*s - 738*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 522*Dd**2*f**2*s + 222*Dd**2*f**2 + 336*Dd**2*f*r**2 + 528*Dd**2*f*r*s - 468*Dd**2*f*r + 192*Dd**2*f*s**2 - 360*Dd**2*f*s + 144*Dd**2*f - 1200*Dd**2*g2*r**2 - 2400*Dd**2*g2*r*s + 1800*Dd**2*g2*r - 1200*Dd**2*g2*s**2 + 1800*Dd**2*g2*s - 600*Dd**2*g2) - b1*(-280*C*D1**2*bdd1*f*r**2 - 560*C*D1**2*bdd1*f*r*s + 280*C*D1**2*bdd1*f*r - 280*C*D1**2*bdd1*f*s**2 + 280*C*D1**2*bdd1*f*s - 140*C*D1**2*bdd1*f - 2128*C*D1**2*f*fd*r**2 - 4224*C*D1**2*f*fd*r*s + 1968*C*D1**2*f*fd*r - 2096*C*D1**2*f*fd*s**2 + 1952*C*D1**2*f*fd*s - 984*C*D1**2*f*fd + 1456*C*D1**2*f*fdd*r**2 + 2672*C*D1**2*f*fdd*r*s - 1096*C*D1**2*f*fdd*r + 1216*C*D1**2*f*fdd*s**2 - 976*C*D1**2*f*fdd*s + 548*C*D1**2*f*fdd + 1456*C*D1**2*fd**2*r**2 + 2672*C*D1**2*fd**2*r*s - 1096*C*D1**2*fd**2*r + 1216*C*D1**2*fd**2*s**2 - 976*C*D1**2*fd**2*s - 360*C*D1**2*fd**2 - 4256*C*D1*Dd*f**2*r**2 - 8448*C*D1*Dd*f**2*r*s + 6368*C*D1*Dd*f**2*r - 4192*C*D1*Dd*f**2*s**2 + 6320*C*D1*Dd*f**2*s - 3176*C*D1*Dd*f**2 + 11648*C*D1*Dd*f*fd*r**2 + 21376*C*D1*Dd*f*fd*r*s - 12880*C*D1*Dd*f*fd*r + 9728*C*D1*Dd*f*fd*s**2 - 11680*C*D1*Dd*f*fd*s + 3168*C*D1*Dd*f*fd + 2912*C*D1*Ddd*f**2*r**2 + 5344*C*D1*Ddd*f**2*r*s - 4248*C*D1*Ddd*f**2*r + 2432*C*D1*Ddd*f**2*s**2 - 3888*C*D1*Ddd*f**2*s + 2064*C*D1*Ddd*f**2 + 8736*C*Dd**2*f**2*r**2 + 16032*C*Dd**2*f**2*r*s - 12744*C*Dd**2*f**2*r + 7296*C*Dd**2*f**2*s**2 - 11664*C*Dd**2*f**2*s + 4128*C*Dd**2*f**2 + 1624*D1**2*K*bdd1*f*r**2 + 3416*D1**2*K*bdd1*f*r*s - 3752*D1**2*K*bdd1*f*r + 1792*D1**2*K*bdd1*f*s**2 - 3920*D1**2*K*bdd1*f*s + 1918*D1**2*K*bdd1*f + 504*D1**2*K*f*fd*r**2 + 168*D1**2*K*f*fd*r*s - 84*D1**2*K*f*fd*r - 336*D1**2*K*f*fd*s**2 + 336*D1**2*K*f*fd*s - 168*D1**2*K*f*fd + 420*D1**2*K*f*fdd*r**2 + 1344*D1**2*K*f*fdd*r*s - 672*D1**2*K*f*fdd*r + 924*D1**2*K*f*fdd*s**2 - 924*D1**2*K*f*fdd*s + 462*D1**2*K*f*fdd + 420*D1**2*K*fd**2*r**2 + 1344*D1**2*K*fd**2*r*s - 672*D1**2*K*fd**2*r + 924*D1**2*K*fd**2*s**2 - 924*D1**2*K*fd**2*s - 490*D1**2*b2*fd*r**2 - 980*D1**2*b2*fd*r*s - 490*D1**2*b2*fd*s**2 + 420*D1**2*b2*fdd*r**2 + 840*D1**2*b2*fdd*r*s + 420*D1**2*b2*fdd*s**2 + 70*D1**2*bd1**2*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 630*D1**2*bdd1*f**2*r**2 - 924*D1**2*bdd1*f**2*r*s + 1092*D1**2*bdd1*f**2*r - 294*D1**2*bdd1*f**2*s**2 + 756*D1**2*bdd1*f**2*s - 462*D1**2*bdd1*f**2 - 392*D1**2*bdd1*f*r**2 - 616*D1**2*bdd1*f*r*s + 910*D1**2*bdd1*f*r - 224*D1**2*bdd1*f*s**2 + 742*D1**2*bdd1*f*s - 413*D1**2*bdd1*f + 1400*D1**2*bdd1*g2*r**2 + 2800*D1**2*bdd1*g2*r*s - 1400*D1**2*bdd1*g2*r + 1400*D1**2*bdd1*g2*s**2 - 1400*D1**2*bdd1*g2*s + 700*D1**2*bdd1*g2 + 420*D1**2*bdd2*f*r**2 + 840*D1**2*bdd2*f*r*s - 840*D1**2*bdd2*f*r + 420*D1**2*bdd2*f*s**2 - 840*D1**2*bdd2*f*s + 420*D1**2*bdd2*f + 1150*D1**2*f*fd*r**2 + 2284*D1**2*f*fd*r*s - 1224*D1**2*f*fd*r + 1134*D1**2*f*fd*s**2 - 1216*D1**2*f*fd*s + 654*D1**2*f*fd - 1002*D1**2*f*fdd*r**2 - 1716*D1**2*f*fdd*r*s + 822*D1**2*f*fdd*r - 714*D1**2*f*fdd*s**2 + 678*D1**2*f*fdd*s - 411*D1**2*f*fdd + 2408*D1**2*f*gd2*r**2 + 5152*D1**2*f*gd2*r*s - 4816*D1**2*f*gd2*r + 2744*D1**2*f*gd2*s**2 - 5152*D1**2*f*gd2*s + 2408*D1**2*f*gd2 - 1624*D1**2*f*gdd2*r**2 - 3416*D1**2*f*gdd2*r*s + 3248*D1**2*f*gdd2*r - 1792*D1**2*f*gdd2*s**2 + 3416*D1**2*f*gdd2*s - 1624*D1**2*f*gdd2 - 1002*D1**2*fd**2*r**2 - 1716*D1**2*fd**2*r*s + 822*D1**2*fd**2*r - 714*D1**2*fd**2*s**2 + 678*D1**2*fd**2*s + 180*D1**2*fd**2 + 2408*D1**2*fd*g2*r**2 + 5152*D1**2*fd*g2*r*s - 1120*D1**2*fd*g2*r + 2744*D1**2*fd*g2*s**2 - 1120*D1**2*fd*g2*s + 560*D1**2*fd*g2 - 3248*D1**2*fd*gd2*r**2 - 6832*D1**2*fd*gd2*r*s + 2408*D1**2*fd*gd2*r - 3584*D1**2*fd*gd2*s**2 + 2576*D1**2*fd*gd2*s + 840*D1**2*fd*gd2 - 1624*D1**2*fdd*g2*r**2 - 3416*D1**2*fdd*g2*r*s - 840*D1**2*fdd*g2*r - 1792*D1**2*fdd*g2*s**2 - 840*D1**2*fdd*g2*s + 420*D1**2*fdd*g2 + 1008*D1*Dd*K*f**2*r**2 + 336*D1*Dd*K*f**2*r*s - 1092*D1*Dd*K*f**2*r - 672*D1*Dd*K*f**2*s**2 + 168*D1*Dd*K*f**2*s + 336*D1*Dd*K*f**2 + 3360*D1*Dd*K*f*fd*r**2 + 10752*D1*Dd*K*f*fd*r*s - 5712*D1*Dd*K*f*fd*r + 7392*D1*Dd*K*f*fd*s**2 - 8232*D1*Dd*K*f*fd*s + 2268*D1*Dd*K*f*fd - 1960*D1*Dd*b2*f*r**2 - 3920*D1*Dd*b2*f*r*s + 2940*D1*Dd*b2*f*r - 1960*D1*Dd*b2*f*s**2 + 2940*D1*Dd*b2*f*s - 1470*D1*Dd*b2*f + 3360*D1*Dd*b2*fd*r**2 + 6720*D1*Dd*b2*fd*r*s - 2520*D1*Dd*b2*fd*r + 3360*D1*Dd*b2*fd*s**2 - 2520*D1*Dd*b2*fd*s + 2300*D1*Dd*f**2*r**2 + 4568*D1*Dd*f**2*r*s - 3442*D1*Dd*f**2*r + 2268*D1*Dd*f**2*s**2 - 3418*D1*Dd*f**2*s + 1717*D1*Dd*f**2 - 8016*D1*Dd*f*fd*r**2 - 13728*D1*Dd*f*fd*r*s + 9012*D1*Dd*f*fd*r - 5712*D1*Dd*f*fd*s**2 + 7572*D1*Dd*f*fd*s - 2322*D1*Dd*f*fd + 9632*D1*Dd*f*g2*r**2 + 20608*D1*Dd*f*g2*r*s - 14784*D1*Dd*f*g2*r + 10976*D1*Dd*f*g2*s**2 - 15792*D1*Dd*f*g2*s + 7560*D1*Dd*f*g2 - 12992*D1*Dd*f*gd2*r**2 - 27328*D1*Dd*f*gd2*r*s + 22904*D1*Dd*f*gd2*r - 14336*D1*Dd*f*gd2*s**2 + 24080*D1*Dd*f*gd2*s - 9912*D1*Dd*f*gd2 - 12992*D1*Dd*fd*g2*r**2 - 27328*D1*Dd*fd*g2*r*s + 6552*D1*Dd*fd*g2*r - 14336*D1*Dd*fd*g2*s**2 + 7056*D1*Dd*fd*g2*s + 2520*D1*Dd*fd*g2 + 840*D1*Ddd*K*f**2*r**2 + 2688*D1*Ddd*K*f**2*r*s - 1512*D1*Ddd*K*f**2*r + 1848*D1*Ddd*K*f**2*s**2 - 2268*D1*Ddd*K*f**2*s + 882*D1*Ddd*K*f**2 + 1680*D1*Ddd*b2*f*r**2 + 3360*D1*Ddd*b2*f*r*s - 2520*D1*Ddd*b2*f*r + 1680*D1*Ddd*b2*f*s**2 - 2520*D1*Ddd*b2*f*s + 1260*D1*Ddd*b2*f - 2004*D1*Ddd*f**2*r**2 - 3432*D1*Ddd*f**2*r*s + 2862*D1*Ddd*f**2*r - 1428*D1*Ddd*f**2*s**2 + 2430*D1*Ddd*f**2*s - 1359*D1*Ddd*f**2 - 6496*D1*Ddd*f*g2*r**2 - 13664*D1*Ddd*f*g2*r*s + 9912*D1*Ddd*f*g2*r - 7168*D1*Ddd*f*g2*s**2 + 10416*D1*Ddd*f*g2*s - 5040*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(3*f**2*(26*r**2 + r*(36*s - 34) + 10*s**2 - 18*s + 13) + f*(40*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 344*K*r**2 - 736*K*r*s + 632*K*r - 392*K*s**2 + 680*K*s - 328*K - 12*fd*(30*r**2 + 44*r*s - 41*r + 14*s**2 - 29*s + 13) - 18*r**2 - 44*r*s + 30*r - 26*s**2 + 38*s - 17) - 2*fd*(20*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-232*r**2 - 488*r*s + 208*r - 256*s**2 + 220*s + 30) + 56*r**2 + 88*r*s - 35*r + 32*s**2 - 23*s - 15) - 200*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 200*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(6*f**2*(60*r**2 + r*(88*s - 93) + 28*s**2 - 65*s + 35) + f*(20*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 4*K*(232*r**2 + 488*r*s - 445*r + 256*s**2 - 466*s + 204) + 224*r**2 + 352*r*s - 416*r + 128*s**2 - 332*s + 183) - 100*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 70*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 2520*Dd**2*K*f**2*r**2 + 8064*Dd**2*K*f**2*r*s - 4536*Dd**2*K*f**2*r + 5544*Dd**2*K*f**2*s**2 - 6804*Dd**2*K*f**2*s + 1764*Dd**2*K*f**2 + 5040*Dd**2*b2*f*r**2 + 10080*Dd**2*b2*f*r*s - 7560*Dd**2*b2*f*r + 5040*Dd**2*b2*f*s**2 - 7560*Dd**2*b2*f*s + 2520*Dd**2*b2*f - 6012*Dd**2*f**2*r**2 - 10296*Dd**2*f**2*r*s + 8586*Dd**2*f**2*r - 4284*Dd**2*f**2*s**2 + 7290*Dd**2*f**2*s - 2718*Dd**2*f**2 - 19488*Dd**2*f*g2*r**2 - 40992*Dd**2*f*g2*r*s + 29736*Dd**2*f*g2*r - 21504*Dd**2*f*g2*s**2 + 31248*Dd**2*f*g2*s - 10080*Dd**2*f*g2))/(210*d**2*k3**5) + D1**2*Pk2*Pkd3*ct*k1*k2**3*(2*D1*(175*D1*b2*bd1*f*(r + s - 1)**2 + 70*D1*bd1**2*(r + s - 1)*(5*K*f*(r + s - 1) - f*(6*C - 3)*(r + s) + 10*g2*(r + s)) + D1*bdd1*f*(f*(6*C - 3)*(47*r + 35*s - 35) - 350*g2*(r + s - 1))*(r + s - 1) + 2*bd1*(D1*(3*f**2*(r + s - 1)*(6*C*(3*r + 7*s - 7) - 16*r - 21*s + 21) + f*(fd*(6*C - 3)*(94*r**2 + r*(164*s - 129) + 70*s**2 - 111*s + 41) + (-210*g2 - 350*gd2)*(r + s - 1)**2) - 350*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + Dd*f*(f*(6*C - 3)*(188*r**2 + r*(328*s - 299) + 140*s**2 - 257*s + 117) - 350*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 175*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(-8*K + f + 3) - 2*Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 35*b1**2*(D1**2*(-10*K*bdd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(-16*C*(r + s - 1)**2 + 12*K*s**2 + r**2*(12*K + 9) + r*(24*K*s + 22*s - 26) + 13*s**2 - 26*s + 13) - 2*fdd*(6*C*(r + s - 1)**2 - 5*K*s**2 - r**2*(5*K + 3) - 2*r*(5*K*s + 3*s - 3) - 3*s**2 + 6*s - 3) + 80*gd2*(r + s - 1)**2 + 20*gdd2*(r + s - 1)**2) + 5*D1*bd1*(D1*(-8*K + f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 4*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(f*(-16*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 12*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 36*r**2 + 88*r*s - 58*r + 52*s**2 - 70*s + 31) - 4*fd*(4*r + 4*s - 3)*(6*C*(r + s - 1) - 5*K*s - r*(5*K + 3) - 3*s + 3) + 80*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 40*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 2*Ddd*(f*(-6*C + 5*K + 3) + 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*(f*(-6*C + 5*K + 3) + 10*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(432*C*D1**2*f*fd*r**2 + 1440*C*D1**2*f*fd*r*s - 432*C*D1**2*f*fd*r + 1008*C*D1**2*f*fd*s**2 - 720*C*D1**2*f*fd*s + 216*C*D1**2*f*fd + 1128*C*D1**2*f*fdd*r**2 + 1968*C*D1**2*f*fdd*r*s - 1128*C*D1**2*f*fdd*r + 840*C*D1**2*f*fdd*s**2 - 984*C*D1**2*f*fdd*s + 564*C*D1**2*f*fdd + 1128*C*D1**2*fd**2*r**2 + 1968*C*D1**2*fd**2*r*s - 1128*C*D1**2*fd**2*r + 840*C*D1**2*fd**2*s**2 - 984*C*D1**2*fd**2*s + 864*C*D1*Dd*f**2*r**2 + 2880*C*D1*Dd*f**2*r*s - 1584*C*D1*Dd*f**2*r + 2016*C*D1*Dd*f**2*s**2 - 2448*C*D1*Dd*f**2*s + 936*C*D1*Dd*f**2 + 9024*C*D1*Dd*f*fd*r**2 + 15744*C*D1*Dd*f*fd*r*s - 10992*C*D1*Dd*f*fd*r + 6720*C*D1*Dd*f*fd*s**2 - 9552*C*D1*Dd*f*fd*s + 3240*C*D1*Dd*f*fd + 2256*C*D1*Ddd*f**2*r**2 + 3936*C*D1*Ddd*f**2*r*s - 3240*C*D1*Ddd*f**2*r + 1680*C*D1*Ddd*f**2*s**2 - 2808*C*D1*Ddd*f**2*s + 1548*C*D1*Ddd*f**2 + 6768*C*Dd**2*f**2*r**2 + 11808*C*Dd**2*f**2*r*s - 9720*C*Dd**2*f**2*r + 5040*C*Dd**2*f**2*s**2 - 8424*C*Dd**2*f**2*s + 3096*C*Dd**2*f**2 - 700*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 350*D1**2*b2*fd*r**2 + 700*D1**2*b2*fd*r*s + 350*D1**2*b2*fd*s**2 + 350*D1**2*bd2*f*(r + s - 1)**2 - 70*D1**2*bdd1*(f*(6*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*K*(r + s - 1)**2 - 6*r**2 - 12*r*s + 6*r - 6*s**2 + 6*s - 3) - 10*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 384*D1**2*f*fd*r**2 - 888*D1**2*f*fd*r*s + 384*D1**2*f*fd*r - 504*D1**2*f*fd*s**2 + 444*D1**2*f*fd*s - 192*D1**2*f*fd - 564*D1**2*f*fdd*r**2 - 984*D1**2*f*fdd*r*s + 564*D1**2*f*fdd*r - 420*D1**2*f*fdd*s**2 + 492*D1**2*f*fdd*s - 282*D1**2*f*fdd - 840*D1**2*f*gd2*r**2 - 1680*D1**2*f*gd2*r*s + 1680*D1**2*f*gd2*r - 840*D1**2*f*gd2*s**2 + 1680*D1**2*f*gd2*s - 840*D1**2*f*gd2 - 700*D1**2*f*gdd2*r**2 - 1400*D1**2*f*gdd2*r*s + 1400*D1**2*f*gdd2*r - 700*D1**2*f*gdd2*s**2 + 1400*D1**2*f*gdd2*s - 700*D1**2*f*gdd2 - 564*D1**2*fd**2*r**2 - 984*D1**2*fd**2*r*s + 564*D1**2*fd**2*r - 420*D1**2*fd**2*s**2 + 492*D1**2*fd**2*s - 840*D1**2*fd*g2*r**2 - 1680*D1**2*fd*g2*r*s - 840*D1**2*fd*g2*s**2 - 1400*D1**2*fd*gd2*r**2 - 2800*D1**2*fd*gd2*r*s + 1400*D1**2*fd*gd2*r - 1400*D1**2*fd*gd2*s**2 + 1400*D1**2*fd*gd2*s - 700*D1**2*fdd*g2*r**2 - 1400*D1**2*fdd*g2*r*s - 700*D1**2*fdd*g2*s**2 + 1400*D1*Dd*b2*f*r**2 + 2800*D1*Dd*b2*f*r*s - 2100*D1*Dd*b2*f*r + 1400*D1*Dd*b2*f*s**2 - 2100*D1*Dd*b2*f*s + 1050*D1*Dd*b2*f - 768*D1*Dd*f**2*r**2 - 1776*D1*Dd*f**2*r*s + 1212*D1*Dd*f**2*r - 1008*D1*Dd*f**2*s**2 + 1392*D1*Dd*f**2*s - 636*D1*Dd*f**2 - 4512*D1*Dd*f*fd*r**2 - 7872*D1*Dd*f*fd*r*s + 5496*D1*Dd*f*fd*r - 3360*D1*Dd*f*fd*s**2 + 4776*D1*Dd*f*fd*s - 1620*D1*Dd*f*fd - 3360*D1*Dd*f*g2*r**2 - 6720*D1*Dd*f*g2*r*s + 5040*D1*Dd*f*g2*r - 3360*D1*Dd*f*g2*s**2 + 5040*D1*Dd*f*g2*s - 2520*D1*Dd*f*g2 - 5600*D1*Dd*f*gd2*r**2 - 11200*D1*Dd*f*gd2*r*s + 9800*D1*Dd*f*gd2*r - 5600*D1*Dd*f*gd2*s**2 + 9800*D1*Dd*f*gd2*s - 4200*D1*Dd*f*gd2 - 5600*D1*Dd*fd*g2*r**2 - 11200*D1*Dd*fd*g2*r*s + 4200*D1*Dd*fd*g2*r - 5600*D1*Dd*fd*g2*s**2 + 4200*D1*Dd*fd*g2*s - 1128*D1*Ddd*f**2*r**2 - 1968*D1*Ddd*f**2*r*s + 1620*D1*Ddd*f**2*r - 840*D1*Ddd*f**2*s**2 + 1404*D1*Ddd*f**2*s - 774*D1*Ddd*f**2 - 2800*D1*Ddd*f*g2*r**2 - 5600*D1*Ddd*f*g2*r*s + 4200*D1*Ddd*f*g2*r - 2800*D1*Ddd*f*g2*s**2 + 4200*D1*Ddd*f*g2*s - 2100*D1*Ddd*f*g2 - 35*D1*bd1*(D1*(f*(16*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 24*K*(r + s - 1)**2 - 18*r**2 - 44*r*s + 14*r - 26*s**2 + 22*s - 9) + 4*fd*(r + s - 1)*(6*C*(2*r + 2*s - 1) - 10*K*s - r*(10*K + 6) - 6*s + 3) - 40*g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 40*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(f*(6*C*(2*r + 2*s - 1) - 10*K*(r + s - 1) - 6*r - 6*s + 3) - 10*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 3384*Dd**2*f**2*r**2 - 5904*Dd**2*f**2*r*s + 4860*Dd**2*f**2*r - 2520*Dd**2*f**2*s**2 + 4212*Dd**2*f**2*s - 1548*Dd**2*f**2 - 8400*Dd**2*f*g2*r**2 - 16800*Dd**2*f*g2*r*s + 12600*Dd**2*f*g2*r - 8400*Dd**2*f*g2*s**2 + 12600*Dd**2*f*g2*s - 4200*Dd**2*f*g2))/(210*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct*k1*k2*st**6*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(-7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 18*r*(4*s - 1) + 18*(1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(7*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(7*bdd1*f**2*s*(r + s - 1) + f*(9*bdd1*s*(r + s - 1) + fd*(r*(2 - 6*s) - 6*s**2 + 6*s - 2) + fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 2*f*s*(7*f + 9)*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(63*d**2*k3**3) + D1**2*Pk2*Pkd3*ct*k1*k2*st**4*(24*C*D1**2*bdd1*f**2*r**2 - 24*C*D1**2*bdd1*f**2*r*s - 48*C*D1**2*bdd1*f**2*s**2 - 648*C*D1**2*f**2*fd*r*s + 216*C*D1**2*f**2*fd*r - 648*C*D1**2*f**2*fd*s**2 + 648*C*D1**2*f**2*fd*s - 216*C*D1**2*f**2*fd + 360*C*D1**2*f**2*fdd*r*s - 120*C*D1**2*f**2*fdd*r + 360*C*D1**2*f**2*fdd*s**2 - 360*C*D1**2*f**2*fdd*s + 120*C*D1**2*f**2*fdd + 720*C*D1**2*f*fd**2*r*s - 240*C*D1**2*f*fd**2*r + 720*C*D1**2*f*fd**2*s**2 - 720*C*D1**2*f*fd**2*s + 120*C*D1**2*f*fd**2 - 864*C*D1*Dd*f**3*r*s + 216*C*D1*Dd*f**3*r - 864*C*D1*Dd*f**3*s**2 + 864*C*D1*Dd*f**3*s - 216*C*D1*Dd*f**3 + 2880*C*D1*Dd*f**2*fd*r*s - 840*C*D1*Dd*f**2*fd*r + 2880*C*D1*Dd*f**2*fd*s**2 - 2880*C*D1*Dd*f**2*fd*s + 600*C*D1*Dd*f**2*fd + 480*C*D1*Ddd*f**3*r*s - 120*C*D1*Ddd*f**3*r + 480*C*D1*Ddd*f**3*s**2 - 480*C*D1*Ddd*f**3*s + 120*C*D1*Ddd*f**3 + 1440*C*Dd**2*f**3*r*s - 360*C*Dd**2*f**3*r + 1440*C*Dd**2*f**3*s**2 - 1440*C*Dd**2*f**3*s + 240*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r*s + 180*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s - 552*D1**2*b2*f*fd*r*s + 276*D1**2*b2*f*fd*r - 552*D1**2*b2*f*fd*s**2 + 552*D1**2*b2*f*fd*s - 276*D1**2*b2*f*fd + 360*D1**2*b2*f*fdd*r*s - 180*D1**2*b2*f*fdd*r + 360*D1**2*b2*f*fdd*s**2 - 360*D1**2*b2*f*fdd*s + 180*D1**2*b2*f*fdd + 360*D1**2*b2*fd**2*r*s - 180*D1**2*b2*fd**2*r + 360*D1**2*b2*fd**2*s**2 - 360*D1**2*b2*fd**2*s - 6*D1**2*bd1**2*f*(5*f*(r**2 + r*(2*s - 3) + s**2 - 5*s + 2) + 7*r**2*(5 - 4*K) + 7*r*(4*K*(s + 1) + 6*s - 7) + 7*s**2*(8*K + 1) - 7*s*(2*K + 7) + 14) - 276*D1**2*bd2*f**2*r*s - 276*D1**2*bd2*f**2*s**2 + 276*D1**2*bd2*f**2*s + 720*D1**2*bd2*f*fd*r*s - 180*D1**2*bd2*f*fd*r + 720*D1**2*bd2*f*fd*s**2 - 720*D1**2*bd2*f*fd*s + 180*D1**2*bd2*f*fd + 225*D1**2*bdd1*f**3*r**2 + 390*D1**2*bdd1*f**3*r*s - 330*D1**2*bdd1*f**3*r + 165*D1**2*bdd1*f**3*s**2 - 330*D1**2*bdd1*f**3*s + 165*D1**2*bdd1*f**3 + 168*D1**2*bdd1*f**2*r**2 + 408*D1**2*bdd1*f**2*r*s - 378*D1**2*bdd1*f**2*r + 240*D1**2*bdd1*f**2*s**2 - 390*D1**2*bdd1*f**2*s + 183*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r**2 + 168*D1**2*bdd1*f*g2*r*s + 336*D1**2*bdd1*f*g2*s**2 + 180*D1**2*bdd2*f**2*r*s + 180*D1**2*bdd2*f**2*s**2 - 180*D1**2*bdd2*f**2*s - 261*D1**2*f**2*fd*r**2 - 114*D1**2*f**2*fd*r*s + 212*D1**2*f**2*fd*r + 147*D1**2*f**2*fd*s**2 - 60*D1**2*f**2*fd*s - 38*D1**2*f**2*fd + 207*D1**2*f**2*fdd*r**2 + 138*D1**2*f**2*fdd*r*s - 184*D1**2*f**2*fdd*r - 69*D1**2*f**2*fdd*s**2 + 46*D1**2*f**2*fdd + 552*D1**2*f**2*gd2*r*s + 552*D1**2*f**2*gd2*s**2 - 552*D1**2*f**2*gd2*s - 360*D1**2*f**2*gdd2*r*s - 360*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s + 414*D1**2*f*fd**2*r**2 + 276*D1**2*f*fd**2*r*s - 368*D1**2*f*fd**2*r - 138*D1**2*f*fd**2*s**2 + 46*D1**2*f*fd**2 + 1104*D1**2*f*fd*g2*r*s - 552*D1**2*f*fd*g2*r + 1104*D1**2*f*fd*g2*s**2 - 1104*D1**2*f*fd*g2*s + 552*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r*s + 360*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 1440*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s - 1104*D1*Dd*b2*f**2*r*s + 276*D1*Dd*b2*f**2*r - 1104*D1*Dd*b2*f**2*s**2 + 1104*D1*Dd*b2*f**2*s - 276*D1*Dd*b2*f**2 + 2880*D1*Dd*b2*f*fd*r*s - 1080*D1*Dd*b2*f*fd*r + 2880*D1*Dd*b2*f*fd*s**2 - 2880*D1*Dd*b2*f*fd*s + 720*D1*Dd*b2*f*fd + 1440*D1*Dd*bd2*f**2*r*s - 180*D1*Dd*bd2*f**2*r + 1440*D1*Dd*bd2*f**2*s**2 - 1440*D1*Dd*bd2*f**2*s + 180*D1*Dd*bd2*f**2 - 348*D1*Dd*f**3*r**2 - 152*D1*Dd*f**3*r*s + 386*D1*Dd*f**3*r + 196*D1*Dd*f**3*s**2 - 22*D1*Dd*f**3*s - 125*D1*Dd*f**3 + 1656*D1*Dd*f**2*fd*r**2 + 1104*D1*Dd*f**2*fd*r*s - 1702*D1*Dd*f**2*fd*r - 552*D1*Dd*f**2*fd*s**2 - 138*D1*Dd*f**2*fd*s + 368*D1*Dd*f**2*fd + 2208*D1*Dd*f**2*g2*r*s - 552*D1*Dd*f**2*g2*r + 2208*D1*Dd*f**2*g2*s**2 - 2208*D1*Dd*f**2*g2*s + 552*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r*s + 360*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 2880*D1*Dd*f**2*gd2*s - 360*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r*s + 2160*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 5760*D1*Dd*f*fd*g2*s - 1440*D1*Dd*f*fd*g2 + 720*D1*Ddd*b2*f**2*r*s - 180*D1*Ddd*b2*f**2*r + 720*D1*Ddd*b2*f**2*s**2 - 720*D1*Ddd*b2*f**2*s + 180*D1*Ddd*b2*f**2 + 276*D1*Ddd*f**3*r**2 + 184*D1*Ddd*f**3*r*s - 322*D1*Ddd*f**3*r - 92*D1*Ddd*f**3*s**2 - 46*D1*Ddd*f**3*s + 115*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r*s + 360*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 1440*D1*Ddd*f**2*g2*s - 360*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*(13*r**2 + 6*r*(5*s - 3) + 17*s**2 - 26*s + 9) + f**2*(-32*C*s**2 + 92*K*s**2 - 92*K*s - 10*fd*(45*r**2 + 13*r*(6*s - 5) + 33*s**2 - 59*s + 22) + r**2*(16*C + 49) - 2*r*(s*(8*C - 46*K - 87) + 63) + 125*s**2 - 162*s + 59) - 2*f*(fd*(-32*C*s**2 + 20*C*s + 30*K*(r*(4*s - 1) + (1 - 2*s)**2) + r**2*(16*C + 112) - r*(16*C*s + 4*C - 272*s + 187) + 160*s**2 - 213*s + 67) + 56*g2*(r**2 - r*s - 2*s**2) + 28*gd2*(-2*r**2 + 2*r*(s + 1) + s*(4*s - 1))) + 56*fd*g2*(2*r**2 - 2*r*s + r - s*(4*s - 4))) - 2*Dd*f*(5*f**2*(60*r**2 + r*(104*s - 87) + 44*s**2 - 81*s + 33) + f*(-64*C*s**2 + 24*C*s + 30*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + r**2*(32*C + 224) - 4*r*(8*C*s + 3*C - 136*s + 108) + 320*s**2 - 476*s + 191) - 28*g2*(8*r**2 - r*(8*s + 3) + s*(6 - 16*s)))) + 2160*Dd**2*b2*f**2*r*s - 540*Dd**2*b2*f**2*r + 2160*Dd**2*b2*f**2*s**2 - 2160*Dd**2*b2*f**2*s + 360*Dd**2*b2*f**2 + 828*Dd**2*f**3*r**2 + 552*Dd**2*f**3*r*s - 966*Dd**2*f**3*r - 276*Dd**2*f**3*s**2 - 138*Dd**2*f**3*s + 230*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r*s + 1080*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 4320*Dd**2*f**2*g2*s - 720*Dd**2*f**2*g2 + 3*b1**2*(-D1**2*(-20*f*fd*(r**2 + 2*r*s + s**2 + 2*s - 1) + 10*fd**2*(r**2 + 2*r*s + s**2 + 2*s - 1) + 14*fd*(4*K*(r**2 - r*s + r - 2*(s - 1)**2) - 5*r**2 - 6*r*s + 2*r - s**2 - 6*s + 3) + fdd*(-28*K*(r**2 - r*s + r - 2*(s - 1)**2) + 10*f*(r**2 + 2*r*s + s**2 + 2*s - 1) + 35*r**2 + 42*r*s - 14*r + 7*s**2 + 42*s - 21)) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-10*fd*(4*r**2 + r*(8*s - 3) + 4*s**2 + s - 1) - 7*r**2*(16*K - 20) + 14*r*(K*(8*s + 6) + 12*s - 13) + 7*s**2*(32*K + 4) - 7*s*(24*K + 14) + 77) + 7*fd*(2*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) - 20*r**2 + r*(17 - 24*s) - 4*s**2 - 5*s + 1)) - Ddd*f*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*r**2*(16*K - 20) + 14*r*(K*(8*s + 6) + 12*s - 13) + 7*s**2*(32*K + 4) - 7*s*(24*K + 14) + 77)) - 2*Dd**2*f*(15*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 7*r**2*(24*K - 30) + 21*r*(K*(8*s + 6) + 12*s - 13) + 7*s**2*(48*K + 6) - 7*s*(36*K + 21) + 77)) + 3*b1*(-32*C*D1**2*f*fd*r**2 + 32*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r + 64*C*D1**2*f*fd*s**2 - 80*C*D1**2*f*fd*s + 16*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r**2 - 16*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r - 32*C*D1**2*f*fdd*s**2 + 40*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r**2 - 16*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r - 32*C*D1**2*fd**2*s**2 + 40*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 - 64*C*D1*Dd*f**2*r**2 + 64*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r + 128*C*D1*Dd*f**2*s**2 - 96*C*D1*Dd*f**2*s + 128*C*D1*Dd*f*fd*r**2 - 128*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r - 256*C*D1*Dd*f*fd*s**2 + 256*C*D1*Dd*f*fd*s - 24*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r**2 - 32*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r - 64*C*D1*Ddd*f**2*s**2 + 48*C*D1*Ddd*f**2*s + 96*C*Dd**2*f**2*r**2 - 96*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r - 192*C*Dd**2*f**2*s**2 + 144*C*Dd**2*f**2*s - 184*D1**2*K*f*fd*r*s + 92*D1**2*K*f*fd*r - 184*D1**2*K*f*fd*s**2 + 184*D1**2*K*f*fd*s - 92*D1**2*K*f*fd + 120*D1**2*K*f*fdd*r*s - 60*D1**2*K*f*fdd*r + 120*D1**2*K*f*fdd*s**2 - 120*D1**2*K*f*fdd*s + 60*D1**2*K*f*fdd + 120*D1**2*K*fd**2*r*s - 60*D1**2*K*fd**2*r + 120*D1**2*K*fd**2*s**2 - 120*D1**2*K*fd**2*s - D1**2*bdd1*f*(-28*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) + 5*f*(2*r**2 + r*(4*s - 6) + 2*s**2 - 10*s + 5) + 70*r**2 + 14*r*(6*s - 7) + 14*s**2 - 98*s + 63) - 195*D1**2*f**2*fd*r**2 - 450*D1**2*f**2*fd*r*s + 320*D1**2*f**2*fd*r - 255*D1**2*f**2*fd*s**2 + 340*D1**2*f**2*fd*s - 170*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 390*D1**2*f**2*fdd*r*s - 320*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 260*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 780*D1**2*f*fd**2*r*s - 640*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 520*D1**2*f*fd**2*s + 190*D1**2*f*fd**2 - 98*D1**2*f*fd*r**2 - 348*D1**2*f*fd*r*s + 146*D1**2*f*fd*r - 250*D1**2*f*fd*s**2 + 262*D1**2*f*fd*s - 115*D1**2*f*fd + 112*D1**2*f*fdd*r**2 + 272*D1**2*f*fdd*r*s - 122*D1**2*f*fdd*r + 160*D1**2*f*fdd*s**2 - 166*D1**2*f*fdd*s + 75*D1**2*f*fdd + 112*D1**2*f*gd2*r**2 - 112*D1**2*f*gd2*r*s - 224*D1**2*f*gd2*r - 224*D1**2*f*gd2*s**2 + 112*D1**2*f*gd2*s + 112*D1**2*f*gd2 - 56*D1**2*f*gdd2*r**2 + 56*D1**2*f*gdd2*r*s + 112*D1**2*f*gdd2*r + 112*D1**2*f*gdd2*s**2 - 56*D1**2*f*gdd2*s - 56*D1**2*f*gdd2 + 112*D1**2*fd**2*r**2 + 272*D1**2*fd**2*r*s - 122*D1**2*fd**2*r + 160*D1**2*fd**2*s**2 - 166*D1**2*fd**2*s + 2*D1**2*fd**2 + 112*D1**2*fd*g2*r**2 - 112*D1**2*fd*g2*r*s + 112*D1**2*fd*g2*r - 224*D1**2*fd*g2*s**2 + 448*D1**2*fd*g2*s - 224*D1**2*fd*g2 - 112*D1**2*fd*gd2*r**2 + 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r + 224*D1**2*fd*gd2*s**2 - 280*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r**2 + 56*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r + 112*D1**2*fdd*g2*s**2 - 224*D1**2*fdd*g2*s + 112*D1**2*fdd*g2 - 368*D1*Dd*K*f**2*r*s + 92*D1*Dd*K*f**2*r - 368*D1*Dd*K*f**2*s**2 + 368*D1*Dd*K*f**2*s - 92*D1*Dd*K*f**2 + 960*D1*Dd*K*f*fd*r*s - 360*D1*Dd*K*f*fd*r + 960*D1*Dd*K*f*fd*s**2 - 960*D1*Dd*K*f*fd*s + 240*D1*Dd*K*f*fd - 260*D1*Dd*f**3*r**2 - 600*D1*Dd*f**3*r*s + 410*D1*Dd*f**3*r - 340*D1*Dd*f**3*s**2 + 470*D1*Dd*f**3*s - 215*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 3120*D1*Dd*f**2*fd*r*s - 2570*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 2150*D1*Dd*f**2*fd*s + 900*D1*Dd*f**2*fd - 196*D1*Dd*f**2*r**2 - 696*D1*Dd*f**2*r*s + 370*D1*Dd*f**2*r - 500*D1*Dd*f**2*s**2 + 598*D1*Dd*f**2*s - 223*D1*Dd*f**2 + 896*D1*Dd*f*fd*r**2 + 2176*D1*Dd*f*fd*r*s - 1208*D1*Dd*f*fd*r + 1280*D1*Dd*f*fd*s**2 - 1528*D1*Dd*f*fd*s + 410*D1*Dd*f*fd + 448*D1*Dd*f*g2*r**2 - 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r - 896*D1*Dd*f*g2*s**2 + 672*D1*Dd*f*g2*s - 448*D1*Dd*f*gd2*r**2 + 448*D1*Dd*f*gd2*r*s + 616*D1*Dd*f*gd2*r + 896*D1*Dd*f*gd2*s**2 - 560*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r**2 + 448*D1*Dd*fd*g2*r*s - 56*D1*Dd*fd*g2*r + 896*D1*Dd*fd*g2*s**2 - 1232*D1*Dd*fd*g2*s + 336*D1*Dd*fd*g2 + 240*D1*Ddd*K*f**2*r*s - 60*D1*Ddd*K*f**2*r + 240*D1*Ddd*K*f**2*s**2 - 240*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 + 300*D1*Ddd*f**3*r**2 + 520*D1*Ddd*f**3*r*s - 430*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 370*D1*Ddd*f**3*s + 205*D1*Ddd*f**3 + 224*D1*Ddd*f**2*r**2 + 544*D1*Ddd*f**2*r*s - 360*D1*Ddd*f**2*r + 320*D1*Ddd*f**2*s**2 - 432*D1*Ddd*f**2*s + 192*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r**2 + 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r + 448*D1*Ddd*f*g2*s**2 - 336*D1*Ddd*f*g2*s + 2*D1*bd1*(5*D1*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 10*s + 5) + D1*f*(-28*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) - 10*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 70*r**2 + 14*r*(6*s - 7) + 14*s**2 - 98*s + 63) + 7*D1*fd*(2*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) - 10*r**2 + r*(9 - 12*s) - 2*s**2 + s - 1) - 5*Dd*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 26*s + 11) + 7*Dd*f*(K*(32*r**2 - 4*r*(8*s + 7) - 64*s**2 + 32*s + 6) - 40*r**2 - 6*r*(8*s - 9) - 8*s**2 + 42*s - 21)) + 720*Dd**2*K*f**2*r*s - 180*Dd**2*K*f**2*r + 720*Dd**2*K*f**2*s**2 - 720*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 + 900*Dd**2*f**3*r**2 + 1560*Dd**2*f**3*r*s - 1290*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 1110*Dd**2*f**3*s + 410*Dd**2*f**3 + 672*Dd**2*f**2*r**2 + 1632*Dd**2*f**2*r*s - 1080*Dd**2*f**2*r + 960*Dd**2*f**2*s**2 - 1296*Dd**2*f**2*s + 384*Dd**2*f**2 - 672*Dd**2*f*g2*r**2 + 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r + 1344*Dd**2*f*g2*s**2 - 1008*Dd**2*f*g2*s))/(210*d**2*k3**3) + D1**2*Pk2*Pkd3*ct*k1*k2*st**2*(200*C*D1**2*bdd1*f**2*r**2 + 448*C*D1**2*bdd1*f**2*r*s + 248*C*D1**2*bdd1*f**2*s**2 + 756*C*D1**2*f**2*fd*r**2 + 2160*C*D1**2*f**2*fd*r*s - 1224*C*D1**2*f**2*fd*r + 1404*C*D1**2*f**2*fd*s**2 - 1656*C*D1**2*f**2*fd*s + 720*C*D1**2*f**2*fd - 828*C*D1**2*f**2*fdd*r**2 - 2016*C*D1**2*f**2*fdd*r*s + 1224*C*D1**2*f**2*fdd*r - 1188*C*D1**2*f**2*fdd*s**2 + 1464*C*D1**2*f**2*fdd*s - 672*C*D1**2*f**2*fdd - 1656*C*D1**2*f*fd**2*r**2 - 4032*C*D1**2*f*fd**2*r*s + 2448*C*D1**2*f*fd**2*r - 2376*C*D1**2*f*fd**2*s**2 + 2928*C*D1**2*f*fd**2*s - 672*C*D1**2*f*fd**2 + 1008*C*D1*Dd*f**3*r**2 + 2880*C*D1*Dd*f**3*r*s - 1728*C*D1*Dd*f**3*r + 1872*C*D1*Dd*f**3*s**2 - 2376*C*D1*Dd*f**3*s + 972*C*D1*Dd*f**3 - 6624*C*D1*Dd*f**2*fd*r**2 - 16128*C*D1*Dd*f**2*fd*r*s + 10224*C*D1*Dd*f**2*fd*r - 9504*C*D1*Dd*f**2*fd*s**2 + 12264*C*D1*Dd*f**2*fd*s - 3912*C*D1*Dd*f**2*fd - 1104*C*D1*Ddd*f**3*r**2 - 2688*C*D1*Ddd*f**3*r*s + 1776*C*D1*Ddd*f**3*r - 1584*C*D1*Ddd*f**3*s**2 + 2136*C*D1*Ddd*f**3*s - 948*C*D1*Ddd*f**3 - 3312*C*Dd**2*f**3*r**2 - 8064*C*Dd**2*f**3*r*s + 5328*C*Dd**2*f**3*r - 4752*C*Dd**2*f**3*s**2 + 6408*C*Dd**2*f**3*s - 1896*C*Dd**2*f**3 - 210*D1**2*K*bdd1*f**2*r**2 - 672*D1**2*K*bdd1*f**2*r*s + 420*D1**2*K*bdd1*f**2*r - 462*D1**2*K*bdd1*f**2*s**2 + 672*D1**2*K*bdd1*f**2*s - 210*D1**2*K*bdd1*f**2 + 42*D1**2*b2*bdd1*f*r**2 + 84*D1**2*b2*bdd1*f*r*s + 42*D1**2*b2*bdd1*f*s**2 + 252*D1**2*b2*f*fd*r**2 + 1344*D1**2*b2*f*fd*r*s - 672*D1**2*b2*f*fd*r + 1092*D1**2*b2*f*fd*s**2 - 1092*D1**2*b2*f*fd*s + 546*D1**2*b2*f*fd - 420*D1**2*b2*f*fdd*r**2 - 1344*D1**2*b2*f*fdd*r*s + 672*D1**2*b2*f*fdd*r - 924*D1**2*b2*f*fdd*s**2 + 924*D1**2*b2*f*fdd*s - 462*D1**2*b2*f*fdd - 420*D1**2*b2*fd**2*r**2 - 1344*D1**2*b2*fd**2*r*s + 672*D1**2*b2*fd**2*r - 924*D1**2*b2*fd**2*s**2 + 924*D1**2*b2*fd**2*s + 14*D1**2*bd1**2*(3*f**2*(8*r**2 + r*(8*s - 15) - 9*s + 9) + f*(r**2*(8*C + 28*K + 23) + r*(C*(8*s - 4) + 96*K*s - 28*K + 22*s - 64) + s**2*(68*K - 1) - s*(48*K + 46) + 37) - 20*g2*r*(2*r + 2*s - 1)) + 126*D1**2*bd2*f**2*r**2 + 672*D1**2*bd2*f**2*r*s - 252*D1**2*bd2*f**2*r + 546*D1**2*bd2*f**2*s**2 - 672*D1**2*bd2*f**2*s + 126*D1**2*bd2*f**2 - 840*D1**2*bd2*f*fd*r**2 - 2688*D1**2*bd2*f*fd*r*s + 1512*D1**2*bd2*f*fd*r - 1848*D1**2*bd2*f*fd*s**2 + 2268*D1**2*bd2*f*fd*s - 672*D1**2*bd2*f*fd - 4*D1**2*bdd1*f**2*r**2 - 128*D1**2*bdd1*f**2*r*s - 190*D1**2*bdd1*f**2*r - 124*D1**2*bdd1*f**2*s**2 - 106*D1**2*bdd1*f**2*s + 53*D1**2*bdd1*f**2 - 392*D1**2*bdd1*f*g2*r**2 - 1344*D1**2*bdd1*f*g2*r*s - 952*D1**2*bdd1*f*g2*s**2 - 210*D1**2*bdd2*f**2*r**2 - 672*D1**2*bdd2*f**2*r*s + 420*D1**2*bdd2*f**2*r - 462*D1**2*bdd2*f**2*s**2 + 672*D1**2*bdd2*f**2*s - 210*D1**2*bdd2*f**2 - 270*D1**2*f**2*fd*r**2 - 972*D1**2*f**2*fd*r*s + 504*D1**2*f**2*fd*r - 702*D1**2*f**2*fd*s**2 + 792*D1**2*f**2*fd*s - 324*D1**2*f**2*fd + 414*D1**2*f**2*fdd*r**2 + 1008*D1**2*f**2*fdd*r*s - 612*D1**2*f**2*fdd*r + 594*D1**2*f**2*fdd*s**2 - 732*D1**2*f**2*fdd*s + 336*D1**2*f**2*fdd - 252*D1**2*f**2*gd2*r**2 - 1344*D1**2*f**2*gd2*r*s + 504*D1**2*f**2*gd2*r - 1092*D1**2*f**2*gd2*s**2 + 1344*D1**2*f**2*gd2*s - 252*D1**2*f**2*gd2 + 420*D1**2*f**2*gdd2*r**2 + 1344*D1**2*f**2*gdd2*r*s - 840*D1**2*f**2*gdd2*r + 924*D1**2*f**2*gdd2*s**2 - 1344*D1**2*f**2*gdd2*s + 420*D1**2*f**2*gdd2 + 828*D1**2*f*fd**2*r**2 + 2016*D1**2*f*fd**2*r*s - 1224*D1**2*f*fd**2*r + 1188*D1**2*f*fd**2*s**2 - 1464*D1**2*f*fd**2*s + 336*D1**2*f*fd**2 - 504*D1**2*f*fd*g2*r**2 - 2688*D1**2*f*fd*g2*r*s + 1344*D1**2*f*fd*g2*r - 2184*D1**2*f*fd*g2*s**2 + 2184*D1**2*f*fd*g2*s - 1092*D1**2*f*fd*g2 + 1680*D1**2*f*fd*gd2*r**2 + 5376*D1**2*f*fd*gd2*r*s - 3024*D1**2*f*fd*gd2*r + 3696*D1**2*f*fd*gd2*s**2 - 4536*D1**2*f*fd*gd2*s + 1344*D1**2*f*fd*gd2 + 840*D1**2*f*fdd*g2*r**2 + 2688*D1**2*f*fdd*g2*r*s - 1344*D1**2*f*fdd*g2*r + 1848*D1**2*f*fdd*g2*s**2 - 1848*D1**2*f*fdd*g2*s + 924*D1**2*f*fdd*g2 + 840*D1**2*fd**2*g2*r**2 + 2688*D1**2*fd**2*g2*r*s - 1344*D1**2*fd**2*g2*r + 1848*D1**2*fd**2*g2*s**2 - 1848*D1**2*fd**2*g2*s + 504*D1*Dd*b2*f**2*r**2 + 2688*D1*Dd*b2*f**2*r*s - 1176*D1*Dd*b2*f**2*r + 2184*D1*Dd*b2*f**2*s**2 - 2436*D1*Dd*b2*f**2*s + 798*D1*Dd*b2*f**2 - 3360*D1*Dd*b2*f*fd*r**2 - 10752*D1*Dd*b2*f*fd*r*s + 5712*D1*Dd*b2*f*fd*r - 7392*D1*Dd*b2*f*fd*s**2 + 8232*D1*Dd*b2*f*fd*s - 2268*D1*Dd*b2*f*fd - 1680*D1*Dd*bd2*f**2*r**2 - 5376*D1*Dd*bd2*f**2*r*s + 3192*D1*Dd*bd2*f**2*r - 3696*D1*Dd*bd2*f**2*s**2 + 4956*D1*Dd*bd2*f**2*s - 1512*D1*Dd*bd2*f**2 - 360*D1*Dd*f**3*r**2 - 1296*D1*Dd*f**3*r*s + 684*D1*Dd*f**3*r - 936*D1*Dd*f**3*s**2 + 1116*D1*Dd*f**3*s - 414*D1*Dd*f**3 + 3312*D1*Dd*f**2*fd*r**2 + 8064*D1*Dd*f**2*fd*r*s - 5112*D1*Dd*f**2*fd*r + 4752*D1*Dd*f**2*fd*s**2 - 6132*D1*Dd*f**2*fd*s + 1956*D1*Dd*f**2*fd - 1008*D1*Dd*f**2*g2*r**2 - 5376*D1*Dd*f**2*g2*r*s + 2352*D1*Dd*f**2*g2*r - 4368*D1*Dd*f**2*g2*s**2 + 4872*D1*Dd*f**2*g2*s - 1596*D1*Dd*f**2*g2 + 3360*D1*Dd*f**2*gd2*r**2 + 10752*D1*Dd*f**2*gd2*r*s - 6384*D1*Dd*f**2*gd2*r + 7392*D1*Dd*f**2*gd2*s**2 - 9912*D1*Dd*f**2*gd2*s + 3024*D1*Dd*f**2*gd2 + 6720*D1*Dd*f*fd*g2*r**2 + 21504*D1*Dd*f*fd*g2*r*s - 11424*D1*Dd*f*fd*g2*r + 14784*D1*Dd*f*fd*g2*s**2 - 16464*D1*Dd*f*fd*g2*s + 4536*D1*Dd*f*fd*g2 - 840*D1*Ddd*b2*f**2*r**2 - 2688*D1*Ddd*b2*f**2*r*s + 1512*D1*Ddd*b2*f**2*r - 1848*D1*Ddd*b2*f**2*s**2 + 2268*D1*Ddd*b2*f**2*s - 882*D1*Ddd*b2*f**2 + 552*D1*Ddd*f**3*r**2 + 1344*D1*Ddd*f**3*r*s - 888*D1*Ddd*f**3*r + 792*D1*Ddd*f**3*s**2 - 1068*D1*Ddd*f**3*s + 474*D1*Ddd*f**3 + 1680*D1*Ddd*f**2*g2*r**2 + 5376*D1*Ddd*f**2*g2*r*s - 3024*D1*Ddd*f**2*g2*r + 3696*D1*Ddd*f**2*g2*s**2 - 4536*D1*Ddd*f**2*g2*s + 1764*D1*Ddd*f**2*g2 + D1*bd1*(D1*(f**2*(-328*C*s**2 + 42*K*(3*r**2 + 2*r*(8*s - 3) + 13*s**2 - 16*s + 3) + r**2*(29 - 176*C) + r*(-504*C*s + 186*s + 58) + 157*s**2 + 58*s + 13) - 2*f*(-42*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(-496*C*s**2 + 472*C*s + 42*K*(10*r**2 + 2*r*(16*s - 9) + 22*s**2 - 27*s + 8) + r**2*(8 - 400*C) + r*(-896*C*s + 424*C + 256*s + 27) + 248*s**2 - 135*s - 95) + 56*gd2*(7*r**2 + r*(24*s - 7) + s*(17*s - 12)) + 7*(r + s)*(b2*(r + s) + 4*g2*(6*r - 19*s))) + 28*fd*(3*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 4*g2*(7*r**2 + 12*r*(2*s - 1) + s*(17*s - 17)))) - 2*Dd*f*(-42*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f*(-992*C*s**2 + 696*C*s + 42*K*(20*r**2 + r*(64*s - 38) + 44*s**2 - 59*s + 18) + r**2*(16 - 800*C) + r*(-1792*C*s + 624*C + 512*s + 308) + 496*s**2 - 40*s - 243) + 56*g2*(28*r**2 + r*(96*s - 26) + s*(68*s - 41)))) - 2520*Dd**2*b2*f**2*r**2 - 8064*Dd**2*b2*f**2*r*s + 4536*Dd**2*b2*f**2*r - 5544*Dd**2*b2*f**2*s**2 + 6804*Dd**2*b2*f**2*s - 1764*Dd**2*b2*f**2 + 1656*Dd**2*f**3*r**2 + 4032*Dd**2*f**3*r*s - 2664*Dd**2*f**3*r + 2376*Dd**2*f**3*s**2 - 3204*Dd**2*f**3*s + 948*Dd**2*f**3 + 5040*Dd**2*f**2*g2*r**2 + 16128*Dd**2*f**2*g2*r*s - 9072*Dd**2*f**2*g2*r + 11088*Dd**2*f**2*g2*s**2 - 13608*Dd**2*f**2*g2*s + 3528*Dd**2*f**2*g2 + 7*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(-20*K*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + 3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 100*r**2 + 120*r*s - 130*r + 20*s**2 - 70*s + 55) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*Ddd*(4*K*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 20*r**2 + r*(26 - 24*s) - 4*s**2 + 14*s - 11)) - 2*Dd**2*(-10*K*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 9*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 150*r**2 + 180*r*s - 195*r + 30*s**2 - 105*s + 55)) + 7*b1**2*(-16*C*D1**2*fd*r**2 - 16*C*D1**2*fd*r*s + 32*C*D1**2*fd*r + 16*C*D1**2*fd*s - 16*C*D1**2*fd + 8*C*D1**2*fdd*r**2 + 8*C*D1**2*fdd*r*s - 16*C*D1**2*fdd*r - 8*C*D1**2*fdd*s + 8*C*D1**2*fdd - 64*C*D1*Dd*f*r**2 - 64*C*D1*Dd*f*r*s + 80*C*D1*Dd*f*r + 32*C*D1*Dd*f*s - 32*C*D1*Dd*f + 64*C*D1*Dd*fd*r**2 + 64*C*D1*Dd*fd*r*s - 104*C*D1*Dd*fd*r - 48*C*D1*Dd*fd*s + 40*C*D1*Dd*fd + 32*C*D1*Ddd*f*r**2 + 32*C*D1*Ddd*f*r*s - 40*C*D1*Ddd*f*r - 16*C*D1*Ddd*f*s + 16*C*D1*Ddd*f + 96*C*Dd**2*f*r**2 + 96*C*Dd**2*f*r*s - 120*C*Dd**2*f*r - 48*C*Dd**2*f*s + 32*C*Dd**2*f + 24*D1**2*K*fd*r**2 - 52*D1**2*K*fd*r*s + 52*D1**2*K*fd*r - 76*D1**2*K*fd*s**2 + 152*D1**2*K*fd*s - 76*D1**2*K*fd + 28*D1**2*K*fdd*r**2 + 96*D1**2*K*fdd*r*s - 96*D1**2*K*fdd*r + 68*D1**2*K*fdd*s**2 - 136*D1**2*K*fdd*s + 68*D1**2*K*fdd - D1**2*bdd1*(-20*K*(3*r**2 + 3*r*(s - 1) - s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 75*r**2 + 90*r*s - 80*r + 15*s**2 - 40*s + 30) - 54*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s - 15*D1**2*f*fd + 48*D1**2*f*fdd*r**2 + 48*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*r + 6*D1**2*f*fdd*s + 15*D1**2*f*fdd + 48*D1**2*fd**2*r**2 + 48*D1**2*fd**2*r*s - 30*D1**2*fd**2*r + 6*D1**2*fd**2*s - 18*D1**2*fd**2 - 51*D1**2*fd*r**2 - 54*D1**2*fd*r*s - 40*D1**2*fd*r - 3*D1**2*fd*s**2 - 84*D1**2*fd*s + 50*D1**2*fd + 23*D1**2*fdd*r**2 + 22*D1**2*fdd*r*s + 60*D1**2*fdd*r - D1**2*fdd*s**2 + 72*D1**2*fdd*s - 40*D1**2*fdd + 80*D1**2*gd2*r**2 + 80*D1**2*gd2*r*s - 160*D1**2*gd2*r - 80*D1**2*gd2*s + 80*D1**2*gd2 - 40*D1**2*gdd2*r**2 - 40*D1**2*gdd2*r*s + 80*D1**2*gdd2*r + 40*D1**2*gdd2*s - 40*D1**2*gdd2 + 96*D1*Dd*K*f*r**2 - 208*D1*Dd*K*f*r*s - 44*D1*Dd*K*f*r - 304*D1*Dd*K*f*s**2 + 256*D1*Dd*K*f*s - 28*D1*Dd*K*f + 224*D1*Dd*K*fd*r**2 + 768*D1*Dd*K*fd*r*s - 592*D1*Dd*K*fd*r + 544*D1*Dd*K*fd*s**2 - 872*D1*Dd*K*fd*s + 328*D1*Dd*K*fd - 108*D1*Dd*f**2*r**2 - 120*D1*Dd*f**2*r*s + 138*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 66*D1*Dd*f**2*s - 57*D1*Dd*f**2 + 384*D1*Dd*f*fd*r**2 + 384*D1*Dd*f*fd*r*s - 360*D1*Dd*f*fd*r - 72*D1*Dd*f*fd*s + 54*D1*Dd*f*fd - 204*D1*Dd*f*r**2 - 216*D1*Dd*f*r*s + 258*D1*Dd*f*r - 12*D1*Dd*f*s**2 + 114*D1*Dd*f*s - 105*D1*Dd*f + 184*D1*Dd*fd*r**2 + 176*D1*Dd*fd*r*s + 126*D1*Dd*fd*r - 8*D1*Dd*fd*s**2 + 246*D1*Dd*fd*s - 192*D1*Dd*fd + 320*D1*Dd*g2*r**2 + 320*D1*Dd*g2*r*s - 400*D1*Dd*g2*r - 160*D1*Dd*g2*s + 160*D1*Dd*g2 - 320*D1*Dd*gd2*r**2 - 320*D1*Dd*gd2*r*s + 520*D1*Dd*gd2*r + 240*D1*Dd*gd2*s - 200*D1*Dd*gd2 + 112*D1*Ddd*K*f*r**2 + 384*D1*Ddd*K*f*r*s - 208*D1*Ddd*K*f*r + 272*D1*Ddd*K*f*s**2 - 328*D1*Ddd*K*f*s + 124*D1*Ddd*K*f + 96*D1*Ddd*f**2*r**2 + 96*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r - 48*D1*Ddd*f**2*s + 48*D1*Ddd*f**2 + 92*D1*Ddd*f*r**2 + 88*D1*Ddd*f*r*s - 114*D1*Ddd*f*r - 4*D1*Ddd*f*s**2 - 42*D1*Ddd*f*s + 45*D1*Ddd*f - 160*D1*Ddd*g2*r**2 - 160*D1*Ddd*g2*r*s + 200*D1*Ddd*g2*r + 80*D1*Ddd*g2*s - 80*D1*Ddd*g2 + 2*D1*bd1*(D1*(-20*K*(3*r**2 + 3*r*(s - 1) - s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 75*r**2 + 90*r*s - 80*r + 15*s**2 - 40*s + 30) - 3*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 5*Dd*(2*K*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7) - 60*r**2 + r*(71 - 72*s) - 12*s**2 + 37*s - 20)) + 336*Dd**2*K*f*r**2 + 1152*Dd**2*K*f*r*s - 624*Dd**2*K*f*r + 816*Dd**2*K*f*s**2 - 984*Dd**2*K*f*s + 248*Dd**2*K*f + 288*Dd**2*f**2*r**2 + 288*Dd**2*f**2*r*s - 360*Dd**2*f**2*r - 144*Dd**2*f**2*s + 96*Dd**2*f**2 + 276*Dd**2*f*r**2 + 264*Dd**2*f*r*s - 342*Dd**2*f*r - 12*Dd**2*f*s**2 - 126*Dd**2*f*s + 90*Dd**2*f - 480*Dd**2*g2*r**2 - 480*Dd**2*g2*r*s + 600*Dd**2*g2*r + 240*Dd**2*g2*s - 160*Dd**2*g2) - b1*(-112*C*D1**2*bdd1*f*r**2 - 112*C*D1**2*bdd1*f*r*s + 56*C*D1**2*bdd1*f*r + 352*C*D1**2*f*fd*r**2 + 1008*C*D1**2*f*fd*r*s - 856*C*D1**2*f*fd*r + 656*C*D1**2*f*fd*s**2 - 1160*C*D1**2*f*fd*s + 504*C*D1**2*f*fd - 400*C*D1**2*f*fdd*r**2 - 896*C*D1**2*f*fdd*r*s + 848*C*D1**2*f*fdd*r - 496*C*D1**2*f*fdd*s**2 + 944*C*D1**2*f*fdd*s - 448*C*D1**2*f*fdd - 400*C*D1**2*fd**2*r**2 - 896*C*D1**2*fd**2*r*s + 848*C*D1**2*fd**2*r - 496*C*D1**2*fd**2*s**2 + 944*C*D1**2*fd**2*s - 448*C*D1**2*fd**2 + 704*C*D1*Dd*f**2*r**2 + 2016*C*D1*Dd*f**2*r*s - 1208*C*D1*Dd*f**2*r + 1312*C*D1*Dd*f**2*s**2 - 1664*C*D1*Dd*f**2*s + 680*C*D1*Dd*f**2 - 3200*C*D1*Dd*f*fd*r**2 - 7168*C*D1*Dd*f*fd*r*s + 5888*C*D1*Dd*f*fd*r - 3968*C*D1*Dd*f*fd*s**2 + 6560*C*D1*Dd*f*fd*s - 2640*C*D1*Dd*f*fd - 800*C*D1*Ddd*f**2*r**2 - 1792*C*D1*Ddd*f**2*r*s + 1248*C*D1*Ddd*f**2*r - 992*C*D1*Ddd*f**2*s**2 + 1392*C*D1*Ddd*f**2*s - 648*C*D1*Ddd*f**2 - 2400*C*Dd**2*f**2*r**2 - 5376*C*Dd**2*f**2*r*s + 3744*C*Dd**2*f**2*r - 2976*C*Dd**2*f**2*s**2 + 4176*C*Dd**2*f**2*s - 1296*C*Dd**2*f**2 - 392*D1**2*K*bdd1*f*r**2 - 1344*D1**2*K*bdd1*f*r*s + 392*D1**2*K*bdd1*f*r - 952*D1**2*K*bdd1*f*s**2 + 672*D1**2*K*bdd1*f*s - 196*D1**2*K*bdd1*f - 252*D1**2*K*f*fd*r**2 - 1344*D1**2*K*f*fd*r*s + 672*D1**2*K*f*fd*r - 1092*D1**2*K*f*fd*s**2 + 1092*D1**2*K*f*fd*s - 546*D1**2*K*f*fd + 420*D1**2*K*f*fdd*r**2 + 1344*D1**2*K*f*fdd*r*s - 672*D1**2*K*f*fdd*r + 924*D1**2*K*f*fdd*s**2 - 924*D1**2*K*f*fdd*s + 462*D1**2*K*f*fdd + 420*D1**2*K*fd**2*r**2 + 1344*D1**2*K*fd**2*r*s - 672*D1**2*K*fd**2*r + 924*D1**2*K*fd**2*s**2 - 924*D1**2*K*fd**2*s + 14*D1**2*b2*fd*r**2 + 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*r + 14*D1**2*b2*fd*s**2 - 28*D1**2*b2*fd*s + 14*D1**2*b2*fd - 42*D1**2*b2*fdd*r**2 - 84*D1**2*b2*fdd*r*s + 84*D1**2*b2*fdd*r - 42*D1**2*b2*fdd*s**2 + 84*D1**2*b2*fdd*s - 42*D1**2*b2*fdd + 14*D1**2*bd1**2*(-10*K*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 75*r**2 + 90*r*s - 80*r + 15*s**2 - 40*s + 15) - 336*D1**2*bdd1*f**2*r**2 - 336*D1**2*bdd1*f**2*r*s + 630*D1**2*bdd1*f**2*r + 378*D1**2*bdd1*f**2*s - 231*D1**2*bdd1*f**2 - 322*D1**2*bdd1*f*r**2 - 308*D1**2*bdd1*f*r*s + 896*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s**2 + 644*D1**2*bdd1*f*s - 434*D1**2*bdd1*f + 560*D1**2*bdd1*g2*r**2 + 560*D1**2*bdd1*g2*r*s - 280*D1**2*bdd1*g2*r - 42*D1**2*bdd2*f*r**2 - 84*D1**2*bdd2*f*r*s + 84*D1**2*bdd2*f*r - 42*D1**2*bdd2*f*s**2 + 84*D1**2*bdd2*f*s - 42*D1**2*bdd2*f - 58*D1**2*f*fd*r**2 - 372*D1**2*f*fd*r*s + 302*D1**2*f*fd*r - 314*D1**2*f*fd*s**2 + 558*D1**2*f*fd*s - 173*D1**2*f*fd + 8*D1**2*f*fdd*r**2 + 256*D1**2*f*fdd*r*s - 326*D1**2*f*fdd*r + 248*D1**2*f*fdd*s**2 - 482*D1**2*f*fdd*s + 181*D1**2*f*fdd + 336*D1**2*f*gd2*r**2 - 728*D1**2*f*gd2*r*s - 672*D1**2*f*gd2*r - 1064*D1**2*f*gd2*s**2 + 728*D1**2*f*gd2*s + 336*D1**2*f*gd2 + 392*D1**2*f*gdd2*r**2 + 1344*D1**2*f*gdd2*r*s - 784*D1**2*f*gdd2*r + 952*D1**2*f*gdd2*s**2 - 1344*D1**2*f*gdd2*s + 392*D1**2*f*gdd2 + 8*D1**2*fd**2*r**2 + 256*D1**2*fd**2*r*s - 326*D1**2*fd**2*r + 248*D1**2*fd**2*s**2 - 482*D1**2*fd**2*s + 318*D1**2*fd**2 + 336*D1**2*fd*g2*r**2 - 728*D1**2*fd*g2*r*s + 728*D1**2*fd*g2*r - 1064*D1**2*fd*g2*s**2 + 2128*D1**2*fd*g2*s - 1064*D1**2*fd*g2 + 784*D1**2*fd*gd2*r**2 + 2688*D1**2*fd*gd2*r*s - 2128*D1**2*fd*gd2*r + 1904*D1**2*fd*gd2*s**2 - 3248*D1**2*fd*gd2*s + 1344*D1**2*fd*gd2 + 392*D1**2*fdd*g2*r**2 + 1344*D1**2*fdd*g2*r*s - 1344*D1**2*fdd*g2*r + 952*D1**2*fdd*g2*s**2 - 1904*D1**2*fdd*g2*s + 952*D1**2*fdd*g2 - 504*D1*Dd*K*f**2*r**2 - 2688*D1*Dd*K*f**2*r*s + 1176*D1*Dd*K*f**2*r - 2184*D1*Dd*K*f**2*s**2 + 2436*D1*Dd*K*f**2*s - 798*D1*Dd*K*f**2 + 3360*D1*Dd*K*f*fd*r**2 + 10752*D1*Dd*K*f*fd*r*s - 5712*D1*Dd*K*f*fd*r + 7392*D1*Dd*K*f*fd*s**2 - 8232*D1*Dd*K*f*fd*s + 2268*D1*Dd*K*f*fd + 56*D1*Dd*b2*f*r**2 + 112*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 56*D1*Dd*b2*f*s**2 - 84*D1*Dd*b2*f*s + 42*D1*Dd*b2*f - 336*D1*Dd*b2*fd*r**2 - 672*D1*Dd*b2*fd*r*s + 588*D1*Dd*b2*fd*r - 336*D1*Dd*b2*fd*s**2 + 588*D1*Dd*b2*fd*s - 252*D1*Dd*b2*fd - 116*D1*Dd*f**2*r**2 - 744*D1*Dd*f**2*r*s + 302*D1*Dd*f**2*r - 628*D1*Dd*f**2*s**2 + 686*D1*Dd*f**2*s - 215*D1*Dd*f**2 + 64*D1*Dd*f*fd*r**2 + 2048*D1*Dd*f*fd*r*s - 1592*D1*Dd*f*fd*r + 1984*D1*Dd*f*fd*s**2 - 2936*D1*Dd*f*fd*s + 1134*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r**2 - 2912*D1*Dd*f*g2*r*s - 616*D1*Dd*f*g2*r - 4256*D1*Dd*f*g2*s**2 + 3584*D1*Dd*f*g2*s - 392*D1*Dd*f*g2 + 3136*D1*Dd*f*gd2*r**2 + 10752*D1*Dd*f*gd2*r*s - 6048*D1*Dd*f*gd2*r + 7616*D1*Dd*f*gd2*s**2 - 9968*D1*Dd*f*gd2*s + 2912*D1*Dd*f*gd2 + 3136*D1*Dd*fd*g2*r**2 + 10752*D1*Dd*fd*g2*r*s - 8288*D1*Dd*fd*g2*r + 7616*D1*Dd*fd*g2*s**2 - 12208*D1*Dd*fd*g2*s + 4592*D1*Dd*fd*g2 + 840*D1*Ddd*K*f**2*r**2 + 2688*D1*Ddd*K*f**2*r*s - 1512*D1*Ddd*K*f**2*r + 1848*D1*Ddd*K*f**2*s**2 - 2268*D1*Ddd*K*f**2*s + 882*D1*Ddd*K*f**2 - 168*D1*Ddd*b2*f*r**2 - 336*D1*Ddd*b2*f*r*s + 252*D1*Ddd*b2*f*r - 168*D1*Ddd*b2*f*s**2 + 252*D1*Ddd*b2*f*s - 126*D1*Ddd*b2*f + 16*D1*Ddd*f**2*r**2 + 512*D1*Ddd*f**2*r*s - 144*D1*Ddd*f**2*r + 496*D1*Ddd*f**2*s**2 - 504*D1*Ddd*f**2*s + 132*D1*Ddd*f**2 + 1568*D1*Ddd*f*g2*r**2 + 5376*D1*Ddd*f*g2*r*s - 2912*D1*Ddd*f*g2*r + 3808*D1*Ddd*f*g2*s**2 - 4592*D1*Ddd*f*g2*s + 1736*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(3*f**2*(9*r**2 + 2*r*(5*s - 8) + s**2 - 12*s + 7) + f*(16*C*r**2 + 16*C*r*s - 8*C*r + K*(-24*r**2 + 52*r*s + 24*r + 76*s**2 - 26*s - 12) - 6*fd*(16*r**2 + 4*r*(4*s - 5) - 8*s + 5) + 51*r**2 + 54*r*s - 98*r + 3*s**2 - 72*s + 52) - 2*fd*(2*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + K*(28*r**2 + 96*r*s - 62*r + 68*s**2 - 92*s + 24) + 23*r**2 + 22*r*s - 2*r - s**2 + 13*s - 13) - 40*g2*r*(2*r + 2*s - 1) + 20*gd2*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*(3*f**2*(16*r - 13)*(4*r + 4*s - 3) + 2*f*(4*C*(8*r**2 + r*(8*s - 7) - 2*s + 1) + 4*K*(28*r**2 + 96*r*s - 40*r + 68*s**2 - 65*s + 13) + 92*r**2 + 88*r*s - 185*r - 4*s**2 - 113*s + 87) - 40*g2*(8*r**2 + r*(8*s - 7) - 2*s + 1))) + 14*D1*bd2*(D1*(f - 6*fd)*(r + s - 1) - 6*Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 2520*Dd**2*K*f**2*r**2 + 8064*Dd**2*K*f**2*r*s - 4536*Dd**2*K*f**2*r + 5544*Dd**2*K*f**2*s**2 - 6804*Dd**2*K*f**2*s + 1764*Dd**2*K*f**2 - 504*Dd**2*b2*f*r**2 - 1008*Dd**2*b2*f*r*s + 756*Dd**2*b2*f*r - 504*Dd**2*b2*f*s**2 + 756*Dd**2*b2*f*s - 252*Dd**2*b2*f + 48*Dd**2*f**2*r**2 + 1536*Dd**2*f**2*r*s - 432*Dd**2*f**2*r + 1488*Dd**2*f**2*s**2 - 1512*Dd**2*f**2*s + 264*Dd**2*f**2 + 4704*Dd**2*f*g2*r**2 + 16128*Dd**2*f*g2*r*s - 8736*Dd**2*f*g2*r + 11424*Dd**2*f*g2*s**2 - 13776*Dd**2*f*g2*s + 3472*Dd**2*f*g2))/(210*d**2*k3**3) + D1**2*Pk2*Pkd3*ct*k1*k2*(2*D1*(-7*D1*bd1**2*(f*(10*K*(5*r**2 + 2*r*(4*s - 5) + 3*s**2 - 9*s + 5) + r**2*(63 - 88*C) - r*(84*C - 57)*(2*s - 1) - s*(80*C - 51)*(s - 1)) + 20*g2*(6*r**2 + 7*r*(2*s - 1) + s*(8*s - 8))) + D1*bdd1*f*(f*(3 - 6*C)*(47*r**2 + 68*r*s - 82*r + 21*s**2 - 70*s + 35) + 70*g2*(5*r**2 + 2*r*(4*s - 5) + 3*s**2 - 10*s + 5)) + 35*b2*(r + s - 1)*(2*D1*bd1**2*(r + s) - 5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3))) + bd1*(-350*D1*bd2*f*(r + s - 1)**2 + D1*(3*f**2*(2*C*(45*r**2 + r*(52*s - 66) + 7*s**2 - 42*s + 21) - 31*r**2 + r*(52 - 38*s) - 7*s**2 + 42*s - 21) - 2*f*(fd*(6*C - 3)*(94*r**2 + 2*r*(68*s - 61) + 42*s**2 - 90*s + 41) + 35*g2*(3*r**2 + 4*r*s - 6*r + s**2 - 6*s + 3) - 70*gd2*(5*r**2 + 8*r*s - 10*r + 3*s**2 - 9*s + 5)) + 140*fd*g2*(5*r**2 + r*(8*s - 4) + s*(3*s - 3))) - 2*Dd*f*(f*(6*C - 3)*(188*r**2 + 4*r*(68*s - 73) + 84*s**2 - 229*s + 117) - 70*g2*(20*r**2 + r*(32*s - 34) + 12*s**2 - 31*s + 15)))) + 35*b1**3*(D1**2*(4*fd*(r - 1) + fdd*(-7*r - 3*s + 7))*(r + s - 1) + D1*(2*Dd*(48*K*r**2 + 80*K*r*s - 68*K*r + 32*K*s**2 - 56*K*s + 32*K + 2*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - fd*(28*r**2 + 40*r*s - 47*r + 12*s**2 - 33*s + 19) - 40*r**2 - 56*r*s + 54*r - 16*s**2 + 36*s - 24) - Ddd*(-4*K*(12*r**2 + 28*r*s - 19*r + 16*s**2 - 22*s + 10) + f*(28*r**2 + r*(40*s - 38) + 12*s**2 - 26*s + 17) + 20*r**2 + 40*r*s - 30*r + 20*s**2 - 30*s + 15)) - 2*Dd**2*(-2*K*(36*r**2 + 84*r*s - 57*r + 48*s**2 - 66*s + 20) + f*(42*r**2 + r*(60*s - 57) + 18*s**2 - 39*s + 17) + 30*r**2 + 60*r*s - 45*r + 30*s**2 - 45*s + 15)) + 7*b1**2*(-16*C*D1**2*fd*r**2 - 16*C*D1**2*fd*r*s + 32*C*D1**2*fd*r + 16*C*D1**2*fd*s - 16*C*D1**2*fd + 88*C*D1**2*fdd*r**2 + 168*C*D1**2*fdd*r*s - 176*C*D1**2*fdd*r + 80*C*D1**2*fdd*s**2 - 168*C*D1**2*fdd*s + 88*C*D1**2*fdd - 64*C*D1*Dd*f*r**2 - 64*C*D1*Dd*f*r*s + 80*C*D1*Dd*f*r + 32*C*D1*Dd*f*s - 32*C*D1*Dd*f + 704*C*D1*Dd*fd*r**2 + 1344*C*D1*Dd*fd*r*s - 1224*C*D1*Dd*fd*r + 640*C*D1*Dd*fd*s**2 - 1168*C*D1*Dd*fd*s + 520*C*D1*Dd*fd + 352*C*D1*Ddd*f*r**2 + 672*C*D1*Ddd*f*r*s - 520*C*D1*Ddd*f*r + 320*C*D1*Ddd*f*s**2 - 496*C*D1*Ddd*f*s + 256*C*D1*Ddd*f + 1056*C*Dd**2*f*r**2 + 2016*C*Dd**2*f*r*s - 1560*C*Dd**2*f*r + 960*C*Dd**2*f*s**2 - 1488*C*Dd**2*f*s + 512*C*Dd**2*f + 180*D1**2*K*bdd1*r**2 + 420*D1**2*K*bdd1*r*s - 260*D1**2*K*bdd1*r + 240*D1**2*K*bdd1*s**2 - 300*D1**2*K*bdd1*s + 140*D1**2*K*bdd1 + 30*D1**2*K*fd*r**2 + 40*D1**2*K*fd*r*s + 20*D1**2*K*fd*r + 10*D1**2*K*fd*s**2 + 40*D1**2*K*fd*s - 20*D1**2*K*fd - 50*D1**2*K*fdd*r**2 - 80*D1**2*K*fdd*r*s - 20*D1**2*K*fdd*r - 30*D1**2*K*fdd*s**2 - 40*D1**2*K*fdd*s + 20*D1**2*K*fdd - 105*D1**2*bdd1*f*r**2 - 150*D1**2*bdd1*f*r*s + 120*D1**2*bdd1*f*r - 45*D1**2*bdd1*f*s**2 + 80*D1**2*bdd1*f*s - 50*D1**2*bdd1*f - 75*D1**2*bdd1*r**2 - 150*D1**2*bdd1*r*s + 100*D1**2*bdd1*r - 75*D1**2*bdd1*s**2 + 100*D1**2*bdd1*s - 50*D1**2*bdd1 + 10*D1**2*bdd2*r**2 + 20*D1**2*bdd2*r*s - 20*D1**2*bdd2*r + 10*D1**2*bdd2*s**2 - 20*D1**2*bdd2*s + 10*D1**2*bdd2 + 16*D1**2*fd*r**2 + 8*D1**2*fd*r*s + 8*D1**2*fd*r - 8*D1**2*fd*s**2 + 12*D1**2*fd*s - 4*D1**2*fd - 63*D1**2*fdd*r**2 - 114*D1**2*fdd*r*s + 126*D1**2*fdd*r - 51*D1**2*fdd*s**2 + 114*D1**2*fdd*s - 63*D1**2*fdd - 240*D1**2*gd2*r**2 - 400*D1**2*gd2*r*s + 480*D1**2*gd2*r - 160*D1**2*gd2*s**2 + 400*D1**2*gd2*s - 240*D1**2*gd2 - 120*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 240*D1**2*gdd2*r - 160*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 120*D1**2*gdd2 + 120*D1*Dd*K*f*r**2 + 160*D1*Dd*K*f*r*s - 160*D1*Dd*K*f*r + 40*D1*Dd*K*f*s**2 - 100*D1*Dd*K*f*s + 70*D1*Dd*K*f - 400*D1*Dd*K*fd*r**2 - 640*D1*Dd*K*fd*r*s + 200*D1*Dd*K*fd*r - 240*D1*Dd*K*fd*s**2 + 60*D1*Dd*K*fd*s + 80*D1*Dd*K*fd + 40*D1*Dd*b2*r**2 + 80*D1*Dd*b2*r*s - 60*D1*Dd*b2*r + 40*D1*Dd*b2*s**2 - 60*D1*Dd*b2*s + 30*D1*Dd*b2 + 64*D1*Dd*f*r**2 + 32*D1*Dd*f*r*s - 72*D1*Dd*f*r - 32*D1*Dd*f*s**2 + 24*D1*Dd*f - 504*D1*Dd*fd*r**2 - 912*D1*Dd*fd*r*s + 870*D1*Dd*fd*r - 408*D1*Dd*fd*s**2 + 786*D1*Dd*fd*s - 366*D1*Dd*fd - 960*D1*Dd*g2*r**2 - 1600*D1*Dd*g2*r*s + 1360*D1*Dd*g2*r - 640*D1*Dd*g2*s**2 + 1120*D1*Dd*g2*s - 640*D1*Dd*g2 - 960*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1720*D1*Dd*gd2*r - 1280*D1*Dd*gd2*s**2 + 2000*D1*Dd*gd2*s - 760*D1*Dd*gd2 - 200*D1*Ddd*K*f*r**2 - 320*D1*Ddd*K*f*r*s + 280*D1*Ddd*K*f*r - 120*D1*Ddd*K*f*s**2 + 220*D1*Ddd*K*f*s - 130*D1*Ddd*K*f + 40*D1*Ddd*b2*r**2 + 80*D1*Ddd*b2*r*s - 60*D1*Ddd*b2*r + 40*D1*Ddd*b2*s**2 - 60*D1*Ddd*b2*s + 30*D1*Ddd*b2 - 252*D1*Ddd*f*r**2 - 456*D1*Ddd*f*r*s + 366*D1*Ddd*f*r - 204*D1*Ddd*f*s**2 + 330*D1*Ddd*f*s - 177*D1*Ddd*f - 480*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 760*D1*Ddd*g2*r - 640*D1*Ddd*g2*s**2 + 880*D1*Ddd*g2*s - 400*D1*Ddd*g2 + 10*D1*bd1*(D1*(4*K*(9*r**2 + 15*r*s - 11*r + 6*s**2 - 9*s + 5) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 2) - fd*(21*r**2 + r*(30*s - 33) + 9*s**2 - 23*s + 12) - 30*r**2 - 42*r*s + 34*r - 12*s**2 + 22*s - 14) - Dd*(-2*K*(72*r**2 + 168*r*s - 109*r + 96*s**2 - 126*s + 41) + f*(84*r**2 + 15*r*(8*s - 7) + 36*s**2 - 71*s + 32) + 60*r**2 + 120*r*s - 85*r + 60*s**2 - 85*s + 30)) + 10*D1*bd2*(D1*(r + s - 1) + 2*Dd*(4*r + 4*s - 3))*(r + s - 1) - 600*Dd**2*K*f*r**2 - 960*Dd**2*K*f*r*s + 840*Dd**2*K*f*r - 360*Dd**2*K*f*s**2 + 660*Dd**2*K*f*s - 260*Dd**2*K*f + 120*Dd**2*b2*r**2 + 240*Dd**2*b2*r*s - 180*Dd**2*b2*r + 120*Dd**2*b2*s**2 - 180*Dd**2*b2*s + 60*Dd**2*b2 - 756*Dd**2*f*r**2 - 1368*Dd**2*f*r*s + 1098*Dd**2*f*r - 612*Dd**2*f*s**2 + 990*Dd**2*f*s - 354*Dd**2*f - 1440*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2280*Dd**2*g2*r - 1920*Dd**2*g2*s**2 + 2640*Dd**2*g2*s - 800*Dd**2*g2) + b1*(1232*C*D1**2*bdd1*f*r**2 + 2352*C*D1**2*bdd1*f*r*s - 1176*C*D1**2*bdd1*f*r + 1120*C*D1**2*bdd1*f*s**2 - 1120*C*D1**2*bdd1*f*s + 560*C*D1**2*bdd1*f + 1080*C*D1**2*f*fd*r**2 + 1248*C*D1**2*f*fd*r*s - 912*C*D1**2*f*fd*r + 168*C*D1**2*f*fd*s**2 - 288*C*D1**2*f*fd*s + 372*C*D1**2*f*fd - 1128*C*D1**2*f*fdd*r**2 - 1632*C*D1**2*f*fdd*r*s + 960*C*D1**2*f*fdd*r - 504*C*D1**2*f*fdd*s**2 + 480*C*D1**2*f*fdd*s - 396*C*D1**2*f*fdd - 1128*C*D1**2*fd**2*r**2 - 1632*C*D1**2*fd**2*r*s + 960*C*D1**2*fd**2*r - 504*C*D1**2*fd**2*s**2 + 480*C*D1**2*fd**2*s + 168*C*D1**2*fd**2 + 2160*C*D1*Dd*f**2*r**2 + 2496*C*D1*Dd*f**2*r*s - 2784*C*D1*Dd*f**2*r + 336*C*D1*Dd*f**2*s**2 - 1416*C*D1*Dd*f**2*s + 1164*C*D1*Dd*f**2 - 9024*C*D1*Dd*f*fd*r**2 - 13056*C*D1*Dd*f*fd*r*s + 9984*C*D1*Dd*f*fd*r - 4032*C*D1*Dd*f*fd*s**2 + 6192*C*D1*Dd*f*fd*s - 2400*C*D1*Dd*f*fd - 2256*C*D1*Ddd*f**2*r**2 - 3264*C*D1*Ddd*f**2*r*s + 3072*C*D1*Ddd*f**2*r - 1008*C*D1*Ddd*f**2*s**2 + 2136*C*D1*Ddd*f**2*s - 1380*C*D1*Ddd*f**2 - 6768*C*Dd**2*f**2*r**2 - 9792*C*Dd**2*f**2*r*s + 9216*C*Dd**2*f**2*r - 3024*C*Dd**2*f**2*s**2 + 6408*C*Dd**2*f**2*s - 2760*C*Dd**2*f**2 - 700*D1**2*K*bdd1*f*r**2 - 1120*D1**2*K*bdd1*f*r*s + 1400*D1**2*K*bdd1*f*r - 420*D1**2*K*bdd1*f*s**2 + 1260*D1**2*K*bdd1*f*s - 700*D1**2*K*bdd1*f - 70*D1**2*bd1**2*(-2*K*(18*r**2 + 42*r*s - 26*r + 24*s**2 - 30*s + 7) + f*(21*r**2 + 6*r*(5*s - 4) + 9*s**2 - 16*s + 5) + 15*r**2 + 30*r*s - 20*r + 15*s**2 - 20*s + 5) + 210*D1**2*bd2*f*r**2 + 420*D1**2*bd2*f*r*s - 420*D1**2*bd2*f*r + 210*D1**2*bd2*f*s**2 - 420*D1**2*bd2*f*s + 210*D1**2*bd2*f - 700*D1**2*bd2*fd*r**2 - 1400*D1**2*bd2*fd*r*s + 700*D1**2*bd2*fd*r - 700*D1**2*bd2*fd*s**2 + 700*D1**2*bd2*fd*s - 882*D1**2*bdd1*f*r**2 - 1596*D1**2*bdd1*f*r*s + 798*D1**2*bdd1*f*r - 714*D1**2*bdd1*f*s**2 + 714*D1**2*bdd1*f*s - 357*D1**2*bdd1*f - 1680*D1**2*bdd1*g2*r**2 - 3920*D1**2*bdd1*g2*r*s + 1960*D1**2*bdd1*g2*r - 2240*D1**2*bdd1*g2*s**2 + 2240*D1**2*bdd1*g2*s - 1120*D1**2*bdd1*g2 - 350*D1**2*bdd2*f*r**2 - 700*D1**2*bdd2*f*r*s + 700*D1**2*bdd2*f*r - 350*D1**2*bdd2*f*s**2 + 700*D1**2*bdd2*f*s - 350*D1**2*bdd2*f - 372*D1**2*f*fd*r**2 - 456*D1**2*f*fd*r*s + 288*D1**2*f*fd*r - 84*D1**2*f*fd*s**2 + 60*D1**2*f*fd*s - 102*D1**2*f*fd + 564*D1**2*f*fdd*r**2 + 816*D1**2*f*fdd*r*s - 480*D1**2*f*fdd*r + 252*D1**2*f*fdd*s**2 - 240*D1**2*f*fdd*s + 198*D1**2*f*fdd - 420*D1**2*f*gd2*r**2 - 560*D1**2*f*gd2*r*s + 840*D1**2*f*gd2*r - 140*D1**2*f*gd2*s**2 + 560*D1**2*f*gd2*s - 420*D1**2*f*gd2 + 700*D1**2*f*gdd2*r**2 + 1120*D1**2*f*gdd2*r*s - 1400*D1**2*f*gdd2*r + 420*D1**2*f*gdd2*s**2 - 1120*D1**2*f*gdd2*s + 700*D1**2*f*gdd2 + 564*D1**2*fd**2*r**2 + 816*D1**2*fd**2*r*s - 480*D1**2*fd**2*r + 252*D1**2*fd**2*s**2 - 240*D1**2*fd**2*s - 84*D1**2*fd**2 - 420*D1**2*fd*g2*r**2 - 560*D1**2*fd*g2*r*s - 280*D1**2*fd*g2*r - 140*D1**2*fd*g2*s**2 - 560*D1**2*fd*g2*s + 280*D1**2*fd*g2 + 1400*D1**2*fd*gd2*r**2 + 2240*D1**2*fd*gd2*r*s - 1120*D1**2*fd*gd2*r + 840*D1**2*fd*gd2*s**2 - 560*D1**2*fd*gd2*s - 280*D1**2*fd*gd2 + 700*D1**2*fdd*g2*r**2 + 1120*D1**2*fdd*g2*r*s + 280*D1**2*fdd*g2*r + 420*D1**2*fdd*g2*s**2 + 560*D1**2*fdd*g2*s - 280*D1**2*fdd*g2 - 2800*D1*Dd*bd2*f*r**2 - 5600*D1*Dd*bd2*f*r*s + 4900*D1*Dd*bd2*f*r - 2800*D1*Dd*bd2*f*s**2 + 4900*D1*Dd*bd2*f*s - 2100*D1*Dd*bd2*f - 744*D1*Dd*f**2*r**2 - 912*D1*Dd*f**2*r*s + 972*D1*Dd*f**2*r - 168*D1*Dd*f**2*s**2 + 540*D1*Dd*f**2*s - 414*D1*Dd*f**2 + 4512*D1*Dd*f*fd*r**2 + 6528*D1*Dd*f*fd*r*s - 4992*D1*Dd*f*fd*r + 2016*D1*Dd*f*fd*s**2 - 3096*D1*Dd*f*fd*s + 1200*D1*Dd*f*fd - 1680*D1*Dd*f*g2*r**2 - 2240*D1*Dd*f*g2*r*s + 2240*D1*Dd*f*g2*r - 560*D1*Dd*f*g2*s**2 + 1400*D1*Dd*f*g2*s - 980*D1*Dd*f*g2 + 5600*D1*Dd*f*gd2*r**2 + 8960*D1*Dd*f*gd2*r*s - 9520*D1*Dd*f*gd2*r + 3360*D1*Dd*f*gd2*s**2 - 7560*D1*Dd*f*gd2*s + 3920*D1*Dd*f*gd2 + 5600*D1*Dd*fd*g2*r**2 + 8960*D1*Dd*fd*g2*r*s - 2800*D1*Dd*fd*g2*r + 3360*D1*Dd*fd*g2*s**2 - 840*D1*Dd*fd*g2*s - 1120*D1*Dd*fd*g2 + 1128*D1*Ddd*f**2*r**2 + 1632*D1*Ddd*f**2*r*s - 1536*D1*Ddd*f**2*r + 504*D1*Ddd*f**2*s**2 - 1068*D1*Ddd*f**2*s + 690*D1*Ddd*f**2 + 2800*D1*Ddd*f*g2*r**2 + 4480*D1*Ddd*f*g2*r*s - 3920*D1*Ddd*f*g2*r + 1680*D1*Ddd*f*g2*s**2 - 3080*D1*Ddd*f*g2*s + 1820*D1*Ddd*f*g2 + 14*D1*bd1*(10*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - D1*(-2*f*(5*K*(3*r**2 + r*(4*s - 6) + s**2 - 5*s + 3) - r**2*(8*C - 8) + 4*r*(-2*C*s + C + s - 3) - 4*s**2 - s + 3) + fd*(-4*C*(44*r**2 + r*(84*s - 65) + 40*s**2 - 62*s + 21) + 10*K*(10*r**2 + 16*r*s - 8*r + 6*s**2 - 5*s - 1) + 126*r**2 + 228*r*s - 183*r + 102*s**2 - 165*s + 57) + 40*g2*(6*r**2 + 5*r*(2*s - 1) + 4*s**2 - 4*s + 2) + 20*gd2*(12*r**2 + r*(28*s - 19) + 16*s**2 - 22*s + 7)) + Dd*(f*(8*C*(88*r**2 + r*(168*s - 107) + 80*s**2 - 102*s + 31) - 10*K*(40*r**2 + 64*r*s - 68*r + 24*s**2 - 58*s + 29) - 504*r**2 - 912*r*s + 594*r - 408*s**2 + 534*s - 165) - 40*g2*(24*r**2 + r*(56*s - 33) + 32*s**2 - 38*s + 11))) + 3384*Dd**2*f**2*r**2 + 4896*Dd**2*f**2*r*s - 4608*Dd**2*f**2*r + 1512*Dd**2*f**2*s**2 - 3204*Dd**2*f**2*s + 1380*Dd**2*f**2 + 8400*Dd**2*f*g2*r**2 + 13440*Dd**2*f*g2*r*s - 11760*Dd**2*f*g2*r + 5040*Dd**2*f*g2*s**2 - 9240*Dd**2*f*g2*s + 3640*Dd**2*f*g2 + 70*b2*(D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 3*D1**2*fd*r**2 + 6*D1**2*fd*r*s + 3*D1**2*fd*s**2 - 5*D1**2*fdd*r**2 - 10*D1**2*fdd*r*s - 5*D1**2*fdd*s**2 + 12*D1*Dd*f*r**2 + 24*D1*Dd*f*r*s - 18*D1*Dd*f*r + 12*D1*Dd*f*s**2 - 18*D1*Dd*f*s + 9*D1*Dd*f - 40*D1*Dd*fd*r**2 - 80*D1*Dd*fd*r*s + 30*D1*Dd*fd*r - 40*D1*Dd*fd*s**2 + 30*D1*Dd*fd*s - 20*D1*Ddd*f*r**2 - 40*D1*Ddd*f*r*s + 30*D1*Ddd*f*r - 20*D1*Ddd*f*s**2 + 30*D1*Ddd*f*s - 15*D1*Ddd*f + D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 60*Dd**2*f*r**2 - 120*Dd**2*f*r*s + 90*Dd**2*f*r - 60*Dd**2*f*s**2 + 90*Dd**2*f*s - 30*Dd**2*f)))/(210*d**2*k3**3) + 4*D1**2*Pk2*Pkd3*ct*k1*st**4*(-D1*f*(D1*bd1**2*s*(5*f + 7)*(2*r + 2*s - 1) + D1*bd1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + D1*bdd1*f*s*(r + s) + Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + b1**2*(-D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) - 2*fd*(10*f*s - 5*f + 7*s - 7) + fdd*(10*f*s - 5*f + 7*s - 7)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 14*r*(4*s - 1) + 14*(1 - 2*s)**2) - 7*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(5*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(7*bdd1*s*(2*r + 2*s - 1) - 2*fd*(2*s - 1)*(r + s - 1) + fdd*(2*s - 1)*(r + s - 1)) + fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + 2*f*s*(5*f + 7)*(2*r + 2*s - 1) - 7*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - Dd*f*(5*f + 7)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(6 - 16*s) - 16*s**2 + 20*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(35*d**2*k2*k3) + D1**2*Pk2*Pkd3*ct*k1*st**2*(D1*(14*D1*bd1**2*f*(r**2*(9*f + 11) + r*(12*K*s + f*(30*s - 9) + 38*s - 9) + s*(12*K*s - 6*K + 3*f*(7*s - 5) + 27*s - 17)) + D1*bdd1*f*(r + s)*(41*f*r + f*s*(72*C + 17) + s*(84*b2 - 168*g2)) + bd1*(-D1*(f**2*(r + s)*(47*r + s*(88*C + 55)) - 4*f*(fd*(41*r**2 + r*(72*C*s - 18*C + 58*s - 35) + s*(72*C*s - 54*C + 17*s - 23)) + 7*s*(bd2*(6*r + 6*s - 3) + 2*g2*(r + s) - 6*gd2*(2*r + 2*s - 1))) + 168*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*Dd*f*(f*(164*r**2 + r*(36*C*(8*s - 1) + 232*s - 111) + s*(144*C*(2*s - 1) + 68*s - 75)) - 84*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 28*b2*(D1*(-f*s*(r + s) + fd*r*(6*s - 3) + 6*fd*s*(s - 1)) + 3*Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 28*b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 10*r*(4*s - 1) + 10*(1 - 2*s)**2) - D1*Ddd*(3*f + 5)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(3*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(-4*D1**2*K*fd*r*s + 4*D1**2*K*fd*r - 4*D1**2*K*fd*s**2 + 8*D1**2*K*fd*s - 4*D1**2*K*fd + 12*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r + 12*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 4*D1**2*bdd1*(3*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 6*D1**2*f*fd*r**2 - 84*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 78*D1**2*f*fd*s**2 + 120*D1**2*f*fd*s - 42*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 48*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 30*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 48*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s + 30*D1**2*fd**2 + 3*D1**2*fd*r**2 - 46*D1**2*fd*r*s + 54*D1**2*fd*r - 49*D1**2*fd*s**2 + 106*D1**2*fd*s - 57*D1**2*fd + 11*D1**2*fdd*r**2 + 38*D1**2*fdd*r*s - 42*D1**2*fdd*r + 27*D1**2*fdd*s**2 - 58*D1**2*fdd*s + 31*D1**2*fdd - 16*D1*Dd*K*f*r*s + 4*D1*Dd*K*f*r - 16*D1*Dd*K*f*s**2 + 16*D1*Dd*K*f*s - 4*D1*Dd*K*f + 96*D1*Dd*K*fd*r*s - 60*D1*Dd*K*fd*r + 96*D1*Dd*K*fd*s**2 - 144*D1*Dd*K*fd*s + 48*D1*Dd*K*fd - 12*D1*Dd*f**2*r**2 - 168*D1*Dd*f**2*r*s + 54*D1*Dd*f**2*r - 156*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 45*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 324*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 492*D1*Dd*f*fd*s + 168*D1*Dd*f*fd + 12*D1*Dd*f*r**2 - 184*D1*Dd*f*r*s + 34*D1*Dd*f*r - 196*D1*Dd*f*s**2 + 190*D1*Dd*f*s - 43*D1*Dd*f + 88*D1*Dd*fd*r**2 + 304*D1*Dd*fd*r*s - 250*D1*Dd*fd*r + 216*D1*Dd*fd*s**2 - 362*D1*Dd*fd*s + 142*D1*Dd*fd + 48*D1*Ddd*K*f*r*s - 12*D1*Ddd*K*f*r + 48*D1*Ddd*K*f*s**2 - 48*D1*Ddd*K*f*s + 12*D1*Ddd*K*f + 36*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 66*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 102*D1*Ddd*f**2*s + 39*D1*Ddd*f**2 + 44*D1*Ddd*f*r**2 + 152*D1*Ddd*f*r*s - 82*D1*Ddd*f*r + 108*D1*Ddd*f*s**2 - 130*D1*Ddd*f*s + 49*D1*Ddd*f + 4*D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + 30*r*s - 10*r + 30*s**2 - 30*s + 10) - Dd*(3*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 144*Dd**2*K*f*r*s - 36*Dd**2*K*f*r + 144*Dd**2*K*f*s**2 - 144*Dd**2*K*f*s + 24*Dd**2*K*f + 108*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 198*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 306*Dd**2*f**2*s + 78*Dd**2*f**2 + 132*Dd**2*f*r**2 + 456*Dd**2*f*r*s - 246*Dd**2*f*r + 324*Dd**2*f*s**2 - 390*Dd**2*f*s + 98*Dd**2*f) + b1*(-176*C*D1**2*f*fd*r*s + 88*C*D1**2*f*fd*r - 176*C*D1**2*f*fd*s**2 + 264*C*D1**2*f*fd*s - 88*C*D1**2*f*fd + 144*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*r + 144*C*D1**2*f*fdd*s**2 - 216*C*D1**2*f*fdd*s + 72*C*D1**2*f*fdd + 144*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 216*C*D1**2*fd**2*s + 72*C*D1**2*fd**2 - 352*C*D1*Dd*f**2*r*s + 88*C*D1*Dd*f**2*r - 352*C*D1*Dd*f**2*s**2 + 352*C*D1*Dd*f**2*s - 88*C*D1*Dd*f**2 + 1152*C*D1*Dd*f*fd*r*s - 432*C*D1*Dd*f*fd*r + 1152*C*D1*Dd*f*fd*s**2 - 1440*C*D1*Dd*f*fd*s + 360*C*D1*Dd*f*fd + 288*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 288*C*D1*Ddd*f**2*s**2 - 288*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 864*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 864*C*Dd**2*f**2*s**2 - 864*C*Dd**2*f**2*s + 144*C*Dd**2*f**2 - 28*D1**2*b2*fd*r*s + 28*D1**2*b2*fd*r - 28*D1**2*b2*fd*s**2 + 56*D1**2*b2*fd*s - 28*D1**2*b2*fd + 84*D1**2*b2*fdd*r*s - 84*D1**2*b2*fdd*r + 84*D1**2*b2*fdd*s**2 - 168*D1**2*b2*fdd*s + 84*D1**2*b2*fdd - 28*D1**2*bd1**2*(3*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 28*D1**2*bd2*f*r*s - 28*D1**2*bd2*f*s**2 + 28*D1**2*bd2*f*s + 168*D1**2*bd2*fd*r*s - 84*D1**2*bd2*fd*r + 168*D1**2*bd2*fd*s**2 - 252*D1**2*bd2*fd*s + 84*D1**2*bd2*fd + 7*D1**2*bdd1*f*(24*K*s**2 - 12*K*s + 3*f*(6*r**2 + r*(20*s - 6) + 14*s**2 - 10*s + 3) + 22*r**2 + 2*r*(12*K*s + 38*s - 9) + 54*s**2 - 34*s + 7) + 84*D1**2*bdd2*f*r*s + 84*D1**2*bdd2*f*s**2 - 84*D1**2*bdd2*f*s - 94*D1**2*f*fd*r**2 - 204*D1**2*f*fd*r*s + 196*D1**2*f*fd*r - 110*D1**2*f*fd*s**2 + 212*D1**2*f*fd*s - 102*D1**2*f*fd + 82*D1**2*f*fdd*r**2 + 116*D1**2*f*fdd*r*s - 140*D1**2*f*fdd*r + 34*D1**2*f*fdd*s**2 - 92*D1**2*f*fdd*s + 58*D1**2*f*fdd + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s + 82*D1**2*fd**2*r**2 + 116*D1**2*fd**2*r*s - 140*D1**2*fd**2*r + 34*D1**2*fd**2*s**2 - 92*D1**2*fd**2*s + 58*D1**2*fd**2 + 56*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 56*D1**2*fd*g2*s**2 - 112*D1**2*fd*g2*s + 56*D1**2*fd*g2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s**2 + 504*D1**2*fd*gd2*s - 168*D1**2*fd*gd2 - 168*D1**2*fdd*g2*r*s + 168*D1**2*fdd*g2*r - 168*D1**2*fdd*g2*s**2 + 336*D1**2*fdd*g2*s - 168*D1**2*fdd*g2 - 112*D1*Dd*b2*f*r*s + 28*D1*Dd*b2*f*r - 112*D1*Dd*b2*f*s**2 + 112*D1*Dd*b2*f*s - 28*D1*Dd*b2*f + 672*D1*Dd*b2*fd*r*s - 420*D1*Dd*b2*fd*r + 672*D1*Dd*b2*fd*s**2 - 1008*D1*Dd*b2*fd*s + 336*D1*Dd*b2*fd + 672*D1*Dd*bd2*f*r*s - 84*D1*Dd*bd2*f*r + 672*D1*Dd*bd2*f*s**2 - 672*D1*Dd*bd2*f*s + 84*D1*Dd*bd2*f - 188*D1*Dd*f**2*r**2 - 408*D1*Dd*f**2*r*s + 290*D1*Dd*f**2*r - 220*D1*Dd*f**2*s**2 + 314*D1*Dd*f**2*s - 149*D1*Dd*f**2 + 656*D1*Dd*f*fd*r**2 + 928*D1*Dd*f*fd*r*s - 1004*D1*Dd*f*fd*r + 272*D1*Dd*f*fd*s**2 - 668*D1*Dd*f*fd*s + 372*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 1344*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r*s + 840*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s - 672*D1*Dd*fd*g2 + 336*D1*Ddd*b2*f*r*s - 84*D1*Ddd*b2*f*r + 336*D1*Ddd*b2*f*s**2 - 336*D1*Ddd*b2*f*s + 84*D1*Ddd*b2*f + 164*D1*Ddd*f**2*r**2 + 232*D1*Ddd*f**2*r*s - 222*D1*Ddd*f**2*r + 68*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 99*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 672*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(f**2*(6*r**2 + r*(84*s - 6) + 78*s**2 - 42*s + 3) + f*(8*K*s**2 - 4*K*s - 12*fd*(6*r**2 + r*(20*s - 11) + 14*s**2 - 17*s + 4) - 6*r**2 + 2*r*(4*K*s + 46*s + 7) + 98*s**2 - 38*s - 11) - 2*fd*(6*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 22*r**2 + r*(76*s - 51) + 54*s**2 - 75*s + 19)) - 2*Dd*f*(6*K*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 3*f*(24*r**2 + r*(80*s - 34) + 56*s**2 - 54*s + 11) + 88*r**2 + 304*r*s - 118*r + 216*s**2 - 198*s + 35)) + 1008*Dd**2*b2*f*r*s - 252*Dd**2*b2*f*r + 1008*Dd**2*b2*f*s**2 - 1008*Dd**2*b2*f*s + 168*Dd**2*b2*f + 492*Dd**2*f**2*r**2 + 696*Dd**2*f**2*r*s - 666*Dd**2*f**2*r + 204*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 198*Dd**2*f**2 - 2016*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 2016*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(210*d**2*k2*k3) + D1**2*Pk2*Pkd3*ct*k1*(2*D1*(D1*bd1**2*f*(19*r**2 - 5*r*(s*(4*K - 6) + 3) + s*(K*(10 - 20*s) + 11*s - 11)) - 2*D1*bdd1*f*s*(r + s)*(5*b2 + f*(6*C - 3) - 10*g2) - 2*bd1*(D1*(f**2*s*(3 - 6*C)*(r + s) + f*(fd*(6*C - 3)*(r*(4*s - 1) + s*(4*s - 3)) + 5*s*(bd2*(2*r + 2*s - 1) + 2*g2*(r + s) - 2*gd2*(2*r + 2*s - 1))) + 10*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(6*C - 3) - 10*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + 5*b2*(D1*(-f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) - 5*b1**3*(D1**2*(fd*(r + 5*s - 1) - 3*fdd*(r + s - 1))*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 2*r*(12*s - 5) + 20*s**2 - 22*s + 7) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 20*r**2 + 8*r*s + 18*r + 28*s**2 - 18*s - 3) - Ddd*(3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(20*D1**2*K*fd*r*s - 20*D1**2*K*fd*r + 20*D1**2*K*fd*s**2 - 40*D1**2*K*fd*s + 20*D1**2*K*fd - 20*D1**2*K*fdd*r*s + 20*D1**2*K*fdd*r - 20*D1**2*K*fdd*s**2 + 40*D1**2*K*fdd*s - 20*D1**2*K*fdd + 5*D1**2*bdd1*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 13*D1**2*fd*r**2 - 30*D1**2*fd*r*s + 26*D1**2*fd*r - 17*D1**2*fd*s**2 + 30*D1**2*fd*s - 13*D1**2*fd + 19*D1**2*fdd*r**2 + 30*D1**2*fdd*r*s - 38*D1**2*fdd*r + 11*D1**2*fdd*s**2 - 30*D1**2*fdd*s + 19*D1**2*fdd + 80*D1*Dd*K*f*r*s - 20*D1*Dd*K*f*r + 80*D1*Dd*K*f*s**2 - 80*D1*Dd*K*f*s + 20*D1*Dd*K*f - 160*D1*Dd*K*fd*r*s + 100*D1*Dd*K*fd*r - 160*D1*Dd*K*fd*s**2 + 240*D1*Dd*K*fd*s - 80*D1*Dd*K*fd - 52*D1*Dd*f*r**2 - 120*D1*Dd*f*r*s + 82*D1*Dd*f*r - 68*D1*Dd*f*s**2 + 94*D1*Dd*f*s - 43*D1*Dd*f + 152*D1*Dd*fd*r**2 + 240*D1*Dd*fd*r*s - 258*D1*Dd*fd*r + 88*D1*Dd*fd*s**2 - 202*D1*Dd*fd*s + 106*D1*Dd*fd - 80*D1*Ddd*K*f*r*s + 20*D1*Ddd*K*f*r - 80*D1*Ddd*K*f*s**2 + 80*D1*Ddd*K*f*s - 20*D1*Ddd*K*f + 76*D1*Ddd*f*r**2 + 120*D1*Ddd*f*r*s - 106*D1*Ddd*f*r + 44*D1*Ddd*f*s**2 - 82*D1*Ddd*f*s + 49*D1*Ddd*f - 5*D1*bd1*(D1*(f*(3*r**2 + 2*r*(9*s - 4) + 15*s**2 - 16*s + 6) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 15*r**2 + 6*r*s + 8*r + 21*s**2 - 16*s + 2) - 2*Dd*(3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 240*Dd**2*K*f*r*s + 60*Dd**2*K*f*r - 240*Dd**2*K*f*s**2 + 240*Dd**2*K*f*s - 40*Dd**2*K*f + 228*Dd**2*f*r**2 + 360*Dd**2*f*r*s - 318*Dd**2*f*r + 132*Dd**2*f*s**2 - 246*Dd**2*f*s + 98*Dd**2*f) + b1*(48*C*D1**2*f*fd*r*s - 24*C*D1**2*f*fd*r + 48*C*D1**2*f*fd*s**2 - 72*C*D1**2*f*fd*s + 24*C*D1**2*f*fd - 48*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r - 48*C*D1**2*f*fdd*s**2 + 72*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r - 48*C*D1**2*fd**2*s**2 + 72*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 + 96*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r + 96*C*D1*Dd*f**2*s**2 - 96*C*D1*Dd*f**2*s + 24*C*D1*Dd*f**2 - 384*C*D1*Dd*f*fd*r*s + 144*C*D1*Dd*f*fd*r - 384*C*D1*Dd*f*fd*s**2 + 480*C*D1*Dd*f*fd*s - 120*C*D1*Dd*f*fd - 96*C*D1*Ddd*f**2*r*s + 24*C*D1*Ddd*f**2*r - 96*C*D1*Ddd*f**2*s**2 + 96*C*D1*Ddd*f**2*s - 24*C*D1*Ddd*f**2 - 288*C*Dd**2*f**2*r*s + 72*C*Dd**2*f**2*r - 288*C*Dd**2*f**2*s**2 + 288*C*Dd**2*f**2*s - 48*C*Dd**2*f**2 + 10*D1**2*bd1**2*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1**2*bdd1*f*(38*r**2 - 10*r*(s*(4*K - 6) + 3) + s**2*(22 - 40*K) + s*(20*K - 22) + 11) - 20*D1**2*bdd2*f*r*s - 20*D1**2*bdd2*f*s**2 + 20*D1**2*bdd2*f*s - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 12*D1**2*f*fd + 24*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 24*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 12*D1**2*f*fdd - 40*D1**2*f*gd2*r*s - 40*D1**2*f*gd2*s**2 + 40*D1**2*f*gd2*s + 40*D1**2*f*gdd2*r*s + 40*D1**2*f*gdd2*s**2 - 40*D1**2*f*gdd2*s + 24*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 24*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s + 12*D1**2*fd**2 - 40*D1**2*fd*g2*r*s + 40*D1**2*fd*g2*r - 40*D1**2*fd*g2*s**2 + 80*D1**2*fd*g2*s - 40*D1**2*fd*g2 + 80*D1**2*fd*gd2*r*s - 40*D1**2*fd*gd2*r + 80*D1**2*fd*gd2*s**2 - 120*D1**2*fd*gd2*s + 40*D1**2*fd*gd2 + 40*D1**2*fdd*g2*r*s - 40*D1**2*fdd*g2*r + 40*D1**2*fdd*g2*s**2 - 80*D1**2*fdd*g2*s + 40*D1**2*fdd*g2 - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 48*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r + 192*D1*Dd*f*fd*s**2 - 240*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 160*D1*Dd*f*g2*r*s + 40*D1*Dd*f*g2*r - 160*D1*Dd*f*g2*s**2 + 160*D1*Dd*f*g2*s - 40*D1*Dd*f*g2 + 320*D1*Dd*f*gd2*r*s - 40*D1*Dd*f*gd2*r + 320*D1*Dd*f*gd2*s**2 - 320*D1*Dd*f*gd2*s + 40*D1*Dd*f*gd2 + 320*D1*Dd*fd*g2*r*s - 200*D1*Dd*fd*g2*r + 320*D1*Dd*fd*g2*s**2 - 480*D1*Dd*fd*g2*s + 160*D1*Dd*fd*g2 + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 48*D1*Ddd*f**2*s**2 - 48*D1*Ddd*f**2*s + 12*D1*Ddd*f**2 + 160*D1*Ddd*f*g2*r*s - 40*D1*Ddd*f*g2*r + 160*D1*Ddd*f*g2*s**2 - 160*D1*Ddd*f*g2*s + 40*D1*Ddd*f*g2 + D1*bd1*(D1*(f*(-26*r**2 + 10*r*(s*(4*K - 6) + 3) + s**2*(40*K - 34) + s*(34 - 20*K) - 17) + 2*fd*(-10*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 38*r**2 + r*(60*s - 53) + 22*s**2 - 41*s + 15)) + 2*Dd*f*(-10*K*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 152*r**2 + 2*r*(120*s - 83) + 88*s**2 - 126*s + 41)) + 20*D1*bd2*(D1*(r + s - 1)*(f*s - 2*fd*s + fd) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 144*Dd**2*f**2*s**2 - 144*Dd**2*f**2*s + 24*Dd**2*f**2 + 480*Dd**2*f*g2*r*s - 120*Dd**2*f*g2*r + 480*Dd**2*f*g2*s**2 - 480*Dd**2*f*g2*s + 80*Dd**2*f*g2 + 20*b2*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(30*d**2*k2*k3) - D1**2*Pk2*Pkd3*ct*k2**5*st**2*(8*C - 4)*(D1*f*(D1*bd1*(5*f*r*(r + s - 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*D1*bdd1*f*r*(r + s - 1) - 6*Dd*bd1*f*(8*r**2 + r*(8*s - 9) - 2*s + 2)) + b1*(D1**2*(f*(5*fd - 6*fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + 6*fd**2*(-2*r**2 - 2*r*(s - 1) + s)) + D1*f*(Dd*(5*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) - 6*fd*(2*r - 1)*(8*r + 8*s - 5)) - 6*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 6*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4)))/(105*d**2*k1*k3**5) - D1**2*Pk2*Pkd3*ct*k2**3*(8*C - 4)*(D1**2*bd1**2*f*r*(-2*r - 2*s + 1) + D1*b1*(D1*bdd1*f*r*(-2*r - 2*s + 1) - bd1*(D1*(-2*f*r*(2*r + 2*s - 1) + fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 2*Dd*f*(8*r**2 + r*(8*s - 7) - 2*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(r - 1)*(r + s - 1) + D1*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)))/(15*d**2*k1*k3**3) + D1**2*Pk2*Pkd3*ct*k2*st**2*(8*C - 4)*(D1*f*(D1*bd1*(5*f*r*(r + s) - 6*fd*(4*r**2 + r*(4*s - 3) - s)) - 6*D1*bdd1*f*r*(r + s) - 6*Dd*bd1*f*(8*r**2 + r*(8*s - 5) - 2*s)) + b1*(D1**2*(2*r - 1)*(r + s - 1)*(5*f*fd - 6*f*fdd - 6*fd**2) + D1*f*(Dd*(5*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) - 6*fd*(2*r - 1)*(8*r + 8*s - 7)) - 6*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 6*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4)))/(105*d**2*k1*k3) + D1**2*Pk2*Pkd3*ct*k2*(8*C - 4)*(D1**2*bd1**2*f*r*(-2*r - 2*s + 1) + D1*b1*(D1*bdd1*f*r*(-2*r - 2*s + 1) - bd1*(D1*(-2*f*r*(2*r + 2*s - 1) + fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 2*Dd*f*(8*r**2 + r*(8*s - 7) - 2*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(r - 1)*(r + s - 1) + D1*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)))/(15*d**2*k1*k3) + 3*D1**2*Pk2*Pkd3*f**2*k1**6*st**4*(D1**2*(f*(17*fd - 25*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 150*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(17*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 50*fd*(4*r + 4*s - 3)**2) - 25*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 150*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(770*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*f**2*k1**6*st**4*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(231*d**2*k2**2*k3**5) + D1**2*Pk2*Pkd3*f**2*k1**4*k2**2*st**6*(D1**2*(f*(49*fd - 30*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 180*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(49*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 60*fd*(4*r + 4*s - 3)**2) - 30*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(154*d**2*k3**7) + 8*D1**2*Pk2*Pkd3*f**2*k1**4*st**6*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(77*d**2*k3**5) + D1**2*Pk2*Pkd3*f**2*k1**2*k2**4*st**8*(D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(22*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*f**2*k1**2*k2**2*st**8*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(99*d**2*k3**5) + D1**2*Pk2*Pkd3*f*k1**6*st**2*(-10*D1**2*bdd1*f**2*(r + s - 1)**2 + D1*bd1*f*(r + s - 1)*(11*D1*f*(r + s - 1) - 20*D1*fd*(3*r + 3*s - 2) - 20*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(f*(11*fd - 10*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 20*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(11*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 20*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(35*d**2*k3**7) + D1**2*Pk2*Pkd3*f*k1**6*st**2*(12*D1**2*b1*f*fd*r*s + 12*D1**2*b1*f*fd*s**2 - 8*D1**2*b1*f*fd*s - 6*D1**2*b1*f*fdd*r*s - 6*D1**2*b1*f*fdd*s**2 + 4*D1**2*b1*f*fdd*s - 12*D1**2*b1*fd**2*r*s - 12*D1**2*b1*fd**2*s**2 + 8*D1**2*b1*fd**2*s - 2*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) - 12*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r - 12*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 3*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r + 12*D1**2*f**2*fdd*s**2 - 12*D1**2*f**2*fdd*s + 3*D1**2*f**2*fdd + 36*D1**2*f*fd**2*r*s - 9*D1**2*f*fd**2*r + 36*D1**2*f*fd**2*s**2 - 36*D1**2*f*fd**2*s + 6*D1**2*f*fd**2 + 16*D1*Dd*b1*f**2*r*s - 4*D1*Dd*b1*f**2*r + 16*D1*Dd*b1*f**2*s**2 - 16*D1*Dd*b1*f**2*s + 4*D1*Dd*b1*f**2 - 48*D1*Dd*b1*f*fd*r*s + 6*D1*Dd*b1*f*fd*r - 48*D1*Dd*b1*f*fd*s**2 + 40*D1*Dd*b1*f*fd*s - 4*D1*Dd*b1*f*fd - 12*D1*Dd*f**3*r*s + 3*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r*s - 24*D1*Dd*f**2*fd*r + 96*D1*Dd*f**2*fd*s**2 - 96*D1*Dd*f**2*fd*s + 18*D1*Dd*f**2*fd - 8*D1*Ddd*b1*f**2*r*s + 2*D1*Ddd*b1*f**2*r - 8*D1*Ddd*b1*f**2*s**2 + 8*D1*Ddd*b1*f**2*s - 2*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 2*D1*bd1*f*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 24*Dd**2*b1*f**2*r*s + 6*Dd**2*b1*f**2*r - 24*Dd**2*b1*f**2*s**2 + 24*Dd**2*b1*f**2*s - 4*Dd**2*b1*f**2 + 36*Dd**2*f**3*r*s - 9*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 6*Dd**2*f**3)/(63*d**2*k2**2*k3**5) + D1**2*Pk2*Pkd3*f*k1**6*(D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(-D1*(f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + b1*(D1**2*s*(f*(-fd + fdd) + 2*fd**2)*(3*r + 3*s - 2) + D1*f*(Dd*(f*(-4*r*s + r - 4*s**2 + 4*s - 1) + fd*(24*r*s - 3*r + 24*s**2 - 20*s + 2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(7*d**2*k2**2*k3**5) - D1**2*Pk2*Pkd3*f*k1**4*st**4*(-75*D1**2*b1*f*fd*r**2 - 198*D1**2*b1*f*fd*r*s + 98*D1**2*b1*f*fd*r - 123*D1**2*b1*f*fd*s**2 + 130*D1**2*b1*f*fd*s - 33*D1**2*b1*f*fd + 105*D1**2*b1*f*fdd*r**2 + 234*D1**2*b1*f*fdd*r*s - 154*D1**2*b1*f*fdd*r + 129*D1**2*b1*f*fdd*s**2 - 170*D1**2*b1*f*fdd*s + 69*D1**2*b1*f*fdd + 210*D1**2*b1*fd**2*r**2 + 468*D1**2*b1*fd**2*r*s - 308*D1**2*b1*fd**2*r + 258*D1**2*b1*fd**2*s**2 - 340*D1**2*b1*fd**2*s + 114*D1**2*b1*fd**2 + D1**2*bdd1*f**2*(35*r**2 + 78*r*s - 64*r + 43*s**2 - 72*s + 44) + 124*D1**2*f**2*fd*r**2 + 424*D1**2*f**2*fd*r*s - 230*D1**2*f**2*fd*r + 300*D1**2*f**2*fd*s**2 - 362*D1**2*f**2*fd*s + 137*D1**2*f**2*fd - 148*D1**2*f**2*fdd*r**2 - 376*D1**2*f**2*fdd*r*s + 242*D1**2*f**2*fdd*r - 228*D1**2*f**2*fdd*s**2 + 302*D1**2*f**2*fdd*s - 131*D1**2*f**2*fdd - 444*D1**2*f*fd**2*r**2 - 1128*D1**2*f*fd**2*r*s + 726*D1**2*f*fd**2*r - 684*D1**2*f*fd**2*s**2 + 906*D1**2*f*fd**2*s - 262*D1**2*f*fd**2 - 100*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 166*D1*Dd*b1*f**2*r - 164*D1*Dd*b1*f**2*s**2 + 214*D1*Dd*b1*f**2*s - 91*D1*Dd*b1*f**2 + 840*D1*Dd*b1*f*fd*r**2 + 1872*D1*Dd*b1*f*fd*r*s - 1270*D1*Dd*b1*f*fd*r + 1032*D1*Dd*b1*f*fd*s**2 - 1406*D1*Dd*b1*f*fd*s + 478*D1*Dd*b1*f*fd + 124*D1*Dd*f**3*r**2 + 424*D1*Dd*f**3*r*s - 230*D1*Dd*f**3*r + 300*D1*Dd*f**3*s**2 - 362*D1*Dd*f**3*s + 137*D1*Dd*f**3 - 1184*D1*Dd*f**2*fd*r**2 - 3008*D1*Dd*f**2*fd*r*s + 1936*D1*Dd*f**2*fd*r - 1824*D1*Dd*f**2*fd*s**2 + 2416*D1*Dd*f**2*fd*s - 786*D1*Dd*f**2*fd + 140*D1*Ddd*b1*f**2*r**2 + 312*D1*Ddd*b1*f**2*r*s - 218*D1*Ddd*b1*f**2*r + 172*D1*Ddd*b1*f**2*s**2 - 242*D1*Ddd*b1*f**2*s + 113*D1*Ddd*b1*f**2 - 148*D1*Ddd*f**3*r**2 - 376*D1*Ddd*f**3*r*s + 242*D1*Ddd*f**3*r - 228*D1*Ddd*f**3*s**2 + 302*D1*Ddd*f**3*s - 131*D1*Ddd*f**3 + D1*bd1*f*(D1*(-f*(25*r**2 + 66*r*s - 68*r + 41*s**2 - 84*s + 58) + 2*fd*(105*r**2 + 234*r*s - 173*r + 129*s**2 - 193*s + 56)) + 2*Dd*f*(140*r**2 + 3*r*(104*s - 79) + 172*s**2 - 265*s + 100)) + 420*Dd**2*b1*f**2*r**2 + 936*Dd**2*b1*f**2*r*s - 654*Dd**2*b1*f**2*r + 516*Dd**2*b1*f**2*s**2 - 726*Dd**2*b1*f**2*s + 226*Dd**2*b1*f**2 - 444*Dd**2*f**3*r**2 - 1128*Dd**2*f**3*r*s + 726*Dd**2*f**3*r - 684*Dd**2*f**3*s**2 + 906*Dd**2*f**3*s - 262*Dd**2*f**3)/(210*d**2*k3**5) - 4*D1**2*Pk2*Pkd3*f*k1**4*st**4*(D1*f*(D1*bd1*(-2*f*s*(2*r + 2*s - 1) + fd*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1)) + D1*bdd1*f*s*(2*r + 2*s - 1) + Dd*bd1*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + b1*(D1**2*(-f*(2*fd - fdd)*(6*r*s - 2*r + 6*s**2 - 7*s + 2) + fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3)) + D1*f*(Dd*(-4*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11)) + 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2**2*k3**3) + D1**2*Pk2*Pkd3*f*k1**2*k2**4*st**6*(-24*D1**2*b1*f*fd*r**2 - 48*D1**2*b1*f*fd*r*s + 32*D1**2*b1*f*fd*r - 24*D1**2*b1*f*fd*s**2 + 32*D1**2*b1*f*fd*s - 16*D1**2*b1*f*fd + 12*D1**2*b1*f*fdd*r**2 + 24*D1**2*b1*f*fdd*r*s - 16*D1**2*b1*f*fdd*r + 12*D1**2*b1*f*fdd*s**2 - 16*D1**2*b1*f*fdd*s + 8*D1**2*b1*f*fdd + 24*D1**2*b1*fd**2*r**2 + 48*D1**2*b1*fd**2*r*s - 32*D1**2*b1*fd**2*r + 24*D1**2*b1*fd**2*s**2 - 32*D1**2*b1*fd**2*s + 8*D1**2*b1*fd**2 + 4*D1**2*bdd1*f**2*(r + s - 1)**2 - 4*D1**2*f**2*fd*r**2 - 8*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r - 4*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 3*D1**2*f**2*fd - 32*D1*Dd*b1*f**2*r**2 - 64*D1*Dd*b1*f**2*r*s + 48*D1*Dd*b1*f**2*r - 32*D1*Dd*b1*f**2*s**2 + 48*D1*Dd*b1*f**2*s - 24*D1*Dd*b1*f**2 + 96*D1*Dd*b1*f*fd*r**2 + 192*D1*Dd*b1*f*fd*r*s - 136*D1*Dd*b1*f*fd*r + 96*D1*Dd*b1*f*fd*s**2 - 136*D1*Dd*b1*f*fd*s + 48*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 6*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 16*D1*Ddd*b1*f**2*r**2 + 32*D1*Ddd*b1*f**2*r*s - 24*D1*Ddd*b1*f**2*r + 16*D1*Ddd*b1*f**2*s**2 - 24*D1*Ddd*b1*f**2*s + 12*D1*Ddd*b1*f**2 - 8*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + 48*Dd**2*b1*f**2*r**2 + 96*Dd**2*b1*f**2*r*s - 72*Dd**2*b1*f**2*r + 48*Dd**2*b1*f**2*s**2 - 72*Dd**2*b1*f**2*s + 24*Dd**2*b1*f**2)/(14*d**2*k3**7) + D1**2*Pk2*Pkd3*f*k1**2*k2**2*st**6*(150*D1**2*b1*f*fd*r**2 + 228*D1**2*b1*f*fd*r*s - 188*D1**2*b1*f*fd*r + 78*D1**2*b1*f*fd*s**2 - 140*D1**2*b1*f*fd*s + 78*D1**2*b1*f*fd - 75*D1**2*b1*f*fdd*r**2 - 114*D1**2*b1*f*fdd*r*s + 94*D1**2*b1*f*fdd*r - 39*D1**2*b1*f*fdd*s**2 + 70*D1**2*b1*f*fdd*s - 39*D1**2*b1*f*fdd - 150*D1**2*b1*fd**2*r**2 - 228*D1**2*b1*fd**2*r*s + 188*D1**2*b1*fd**2*r - 78*D1**2*b1*fd**2*s**2 + 140*D1**2*b1*fd**2*s - 54*D1**2*b1*fd**2 - D1**2*bdd1*f**2*(25*r**2 + 38*r*s - 44*r + 13*s**2 - 32*s + 24) - 84*D1**2*f**2*fd*r**2 - 160*D1**2*f**2*fd*r*s + 124*D1**2*f**2*fd*r - 76*D1**2*f**2*fd*s**2 + 118*D1**2*f**2*fd*s - 61*D1**2*f**2*fd + 92*D1**2*f**2*fdd*r**2 + 144*D1**2*f**2*fdd*r*s - 128*D1**2*f**2*fdd*r + 52*D1**2*f**2*fdd*s**2 - 98*D1**2*f**2*fdd*s + 59*D1**2*f**2*fdd + 276*D1**2*f*fd**2*r**2 + 432*D1**2*f*fd**2*r*s - 384*D1**2*f*fd**2*r + 156*D1**2*f*fd**2*s**2 - 294*D1**2*f*fd**2*s + 118*D1**2*f*fd**2 + 200*D1*Dd*b1*f**2*r**2 + 304*D1*Dd*b1*f**2*r*s - 276*D1*Dd*b1*f**2*r + 104*D1*Dd*b1*f**2*s**2 - 204*D1*Dd*b1*f**2*s + 126*D1*Dd*b1*f**2 - 600*D1*Dd*b1*f*fd*r**2 - 912*D1*Dd*b1*f*fd*r*s + 790*D1*Dd*b1*f*fd*r - 312*D1*Dd*b1*f*fd*s**2 + 586*D1*Dd*b1*f*fd*s - 258*D1*Dd*b1*f*fd - 84*D1*Dd*f**3*r**2 - 160*D1*Dd*f**3*r*s + 124*D1*Dd*f**3*r - 76*D1*Dd*f**3*s**2 + 118*D1*Dd*f**3*s - 61*D1*Dd*f**3 + 736*D1*Dd*f**2*fd*r**2 + 1152*D1*Dd*f**2*fd*r*s - 1024*D1*Dd*f**2*fd*r + 416*D1*Dd*f**2*fd*s**2 - 784*D1*Dd*f**2*fd*s + 354*D1*Dd*f**2*fd - 100*D1*Ddd*b1*f**2*r**2 - 152*D1*Ddd*b1*f**2*r*s + 138*D1*Ddd*b1*f**2*r - 52*D1*Ddd*b1*f**2*s**2 + 102*D1*Ddd*b1*f**2*s - 63*D1*Ddd*b1*f**2 + 92*D1*Ddd*f**3*r**2 + 144*D1*Ddd*f**3*r*s - 128*D1*Ddd*f**3*r + 52*D1*Ddd*f**3*s**2 - 98*D1*Ddd*f**3*s + 59*D1*Ddd*f**3 + 2*D1*bd1*f*(D1*(f*(25*r**2 + 38*r*s - 44*r + 13*s**2 - 32*s + 24) - fd*(75*r**2 + 114*r*s - 113*r + 39*s**2 - 83*s + 36)) - Dd*f*(100*r**2 + r*(152*s - 157) + 52*s**2 - 115*s + 60)) - 300*Dd**2*b1*f**2*r**2 - 456*Dd**2*b1*f**2*r*s + 414*Dd**2*b1*f**2*r - 156*Dd**2*b1*f**2*s**2 + 306*Dd**2*b1*f**2*s - 126*Dd**2*b1*f**2 + 276*Dd**2*f**3*r**2 + 432*Dd**2*f**3*r*s - 384*Dd**2*f**3*r + 156*Dd**2*f**3*s**2 - 294*Dd**2*f**3*s + 118*Dd**2*f**3)/(126*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*f*k1**2*st**6*(-D1*f*(4*r + 4*s - 3)*(-D1*bd1*(2*f*s - 6*fd*s + fd) + D1*bdd1*f*s + Dd*bd1*f*(8*s - 1)) + b1*(D1**2*(f*(2*fd - fdd)*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4) + fd**2*(r*(8 - 24*s) - 24*s**2 + 26*s - 5)) + D1*f*(Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(24*s - 7)*(4*r + 4*s - 3)) - 4*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 4*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k3**3) - 9*D1**2*Pk2*Pkd3*k1**6*(-10*D1**2*bd1**2*f**2*(r + s - 1)**2 + 2*D1*b1*f*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + b1**2*(D1**2*(f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k3**7) + D1**2*Pk2*Pkd3*k1**4*k2**2*st**2*(6*C*D1**2*f**2*fd*r**2 + 12*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r + 6*C*D1**2*f**2*fd*s**2 - 8*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd - 30*C*D1**2*f**2*fdd*r**2 - 60*C*D1**2*f**2*fdd*r*s + 40*C*D1**2*f**2*fdd*r - 30*C*D1**2*f**2*fdd*s**2 + 40*C*D1**2*f**2*fdd*s - 20*C*D1**2*f**2*fdd - 60*C*D1**2*f*fd**2*r**2 - 120*C*D1**2*f*fd**2*r*s + 80*C*D1**2*f*fd**2*r - 60*C*D1**2*f*fd**2*s**2 + 80*C*D1**2*f*fd**2*s - 20*C*D1**2*f*fd**2 + 8*C*D1*Dd*f**3*r**2 + 16*C*D1*Dd*f**3*r*s - 12*C*D1*Dd*f**3*r + 8*C*D1*Dd*f**3*s**2 - 12*C*D1*Dd*f**3*s + 6*C*D1*Dd*f**3 - 240*C*D1*Dd*f**2*fd*r**2 - 480*C*D1*Dd*f**2*fd*r*s + 340*C*D1*Dd*f**2*fd*r - 240*C*D1*Dd*f**2*fd*s**2 + 340*C*D1*Dd*f**2*fd*s - 120*C*D1*Dd*f**2*fd - 40*C*D1*Ddd*f**3*r**2 - 80*C*D1*Ddd*f**3*r*s + 60*C*D1*Ddd*f**3*r - 40*C*D1*Ddd*f**3*s**2 + 60*C*D1*Ddd*f**3*s - 30*C*D1*Ddd*f**3 - 120*C*Dd**2*f**3*r**2 - 240*C*Dd**2*f**3*r*s + 180*C*Dd**2*f**3*r - 120*C*Dd**2*f**3*s**2 + 180*C*Dd**2*f**3*s - 60*C*Dd**2*f**3 - 9*D1**2*K*bdd1*f**2*r**2 - 18*D1**2*K*bdd1*f**2*r*s + 18*D1**2*K*bdd1*f**2*r - 9*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s - 9*D1**2*K*bdd1*f**2 + 180*D1**2*bd1**2*f**2*(r + s - 1)**2 - 3*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s**2 + 4*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 6*D1**2*f**2*gd2*r**2 + 12*D1**2*f**2*gd2*r*s - 12*D1**2*f**2*gd2*r + 6*D1**2*f**2*gd2*s**2 - 12*D1**2*f**2*gd2*s + 6*D1**2*f**2*gd2 + 18*D1**2*f**2*gdd2*r**2 + 36*D1**2*f**2*gdd2*r*s - 36*D1**2*f**2*gdd2*r + 18*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 18*D1**2*f**2*gdd2 + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 + 12*D1**2*f*fd*g2*r**2 + 24*D1**2*f*fd*g2*r*s - 12*D1**2*f*fd*g2*r + 12*D1**2*f*fd*g2*s**2 - 12*D1**2*f*fd*g2*s + 6*D1**2*f*fd*g2 + 72*D1**2*f*fd*gd2*r**2 + 144*D1**2*f*fd*gd2*r*s - 108*D1**2*f*fd*gd2*r + 72*D1**2*f*fd*gd2*s**2 - 108*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 36*D1**2*f*fdd*g2*r**2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 36*D1**2*fd**2*g2*r**2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s - 4*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 6*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 170*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 170*D1*Dd*f**2*fd*s + 60*D1*Dd*f**2*fd + 24*D1*Dd*f**2*g2*r**2 + 48*D1*Dd*f**2*g2*r*s - 36*D1*Dd*f**2*g2*r + 24*D1*Dd*f**2*g2*s**2 - 36*D1*Dd*f**2*g2*s + 18*D1*Dd*f**2*g2 + 144*D1*Dd*f**2*gd2*r**2 + 288*D1*Dd*f**2*gd2*r*s - 252*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s**2 - 252*D1*Dd*f**2*gd2*s + 108*D1*Dd*f**2*gd2 + 288*D1*Dd*f*fd*g2*r**2 + 576*D1*Dd*f*fd*g2*r*s - 360*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s**2 - 360*D1*Dd*f*fd*g2*s + 108*D1*Dd*f*fd*g2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 72*D1*Ddd*f**2*g2*r**2 + 144*D1*Ddd*f**2*g2*r*s - 108*D1*Ddd*f**2*g2*r + 72*D1*Ddd*f**2*g2*s**2 - 108*D1*Ddd*f**2*g2*s + 54*D1*Ddd*f**2*g2 - 3*D1*bd1*f*(D1*(K*f*(r + s - 1) + 6*K*fd*(2*r + 2*s - 1) + 6*f**2*(r + s - 1)) + 6*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 30*Dd**2*f**3 + 216*Dd**2*f**2*g2*r**2 + 432*Dd**2*f**2*g2*r*s - 324*Dd**2*f**2*g2*r + 216*Dd**2*f**2*g2*s**2 - 324*Dd**2*f**2*g2*s + 108*Dd**2*f**2*g2 - 9*b1**2*(D1**2*(f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 20*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(13*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 20*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(2*D1**2*K*f*fd*r**2 + 4*D1**2*K*f*fd*r*s - 2*D1**2*K*f*fd*r + 2*D1**2*K*f*fd*s**2 - 2*D1**2*K*f*fd*s + D1**2*K*f*fd + 6*D1**2*K*f*fdd*r**2 + 12*D1**2*K*f*fdd*r*s - 6*D1**2*K*f*fdd*r + 6*D1**2*K*f*fdd*s**2 - 6*D1**2*K*f*fdd*s + 3*D1**2*K*f*fdd + 6*D1**2*K*fd**2*r**2 + 12*D1**2*K*fd**2*r*s - 6*D1**2*K*fd**2*r + 6*D1**2*K*fd**2*s**2 - 6*D1**2*K*fd**2*s - 60*D1**2*bdd1*f**2*(r + s - 1)**2 + 18*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 24*D1**2*f**2*fd*s + 12*D1**2*f**2*fd + 4*D1*Dd*K*f**2*r**2 + 8*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r + 4*D1*Dd*K*f**2*s**2 - 6*D1*Dd*K*f**2*s + 3*D1*Dd*K*f**2 + 48*D1*Dd*K*f*fd*r**2 + 96*D1*Dd*K*f*fd*r*s - 60*D1*Dd*K*f*fd*r + 48*D1*Dd*K*f*fd*s**2 - 60*D1*Dd*K*f*fd*s + 18*D1*Dd*K*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 + 12*D1*Ddd*K*f**2*r**2 + 24*D1*Ddd*K*f**2*r*s - 18*D1*Ddd*K*f**2*r + 12*D1*Ddd*K*f**2*s**2 - 18*D1*Ddd*K*f**2*s + 9*D1*Ddd*K*f**2 + 6*D1*bd1*f*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) + 36*Dd**2*K*f**2*r**2 + 72*Dd**2*K*f**2*r*s - 54*Dd**2*K*f**2*r + 36*Dd**2*K*f**2*s**2 - 54*Dd**2*K*f**2*s + 18*Dd**2*K*f**2))/(70*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*k1**4*k2**2*(-42*D1**2*K*bd1**2*f*(r + s - 1)**2 - 3*D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 14*K*b1 - 5*f - 14*g2) + D1*bd1*(D1*(f**2*(18*C + 42*b1 - 9)*(r + s - 1) - 2*f*(fd*(30*C - 15)*(2*r + 2*s - 1) + (r + s - 1)*(-7*K*b1 + 7*g2 - 42*gd2)) + 84*fd*(r + s)*(-K*b1 + g2)) - 6*Dd*f*(4*r + 4*s - 3)*(10*C*f + 14*K*b1 - 5*f - 14*g2))*(r + s - 1) + b1*(D1**2*(f*(fd*(18*C + 21*b1 - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(30*C - 15)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-14*gd2 + 42*gdd2)*(r + s - 1)**2) - (r + s)*(fd**2*(60*C - 30)*(r + s - 1) - 84*fd*gd2*(r + s - 1) + 7*fd*(r + s)*(-K*b1 + 2*g2) - 21*fdd*(r + s)*(-K*b1 + 2*g2))) + D1*(Dd*(f**2*(18*C + 21*b1 - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(7*K*b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + fd*(30 - 60*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 14*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 84*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 42*fd*(-K*b1 + 2*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(10*C*f + 7*K*b1 - 5*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(10*C*f + 7*K*b1 - 5*f - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k3**7) + D1**2*Pk2*Pkd3*k1**4*st**2*(-30*C*D1**2*f**2*fd*r**2 - 84*C*D1**2*f**2*fd*r*s + 48*C*D1**2*f**2*fd*r - 54*C*D1**2*f**2*fd*s**2 + 64*C*D1**2*f**2*fd*s - 28*C*D1**2*f**2*fd + 150*C*D1**2*f**2*fdd*r**2 + 420*C*D1**2*f**2*fdd*r*s - 240*C*D1**2*f**2*fdd*r + 270*C*D1**2*f**2*fdd*s**2 - 320*C*D1**2*f**2*fdd*s + 140*C*D1**2*f**2*fdd + 300*C*D1**2*f*fd**2*r**2 + 840*C*D1**2*f*fd**2*r*s - 480*C*D1**2*f*fd**2*r + 540*C*D1**2*f*fd**2*s**2 - 640*C*D1**2*f*fd**2*s + 140*C*D1**2*f*fd**2 - 40*C*D1*Dd*f**3*r**2 - 112*C*D1*Dd*f**3*r*s + 68*C*D1*Dd*f**3*r - 72*C*D1*Dd*f**3*s**2 + 92*C*D1*Dd*f**3*s - 38*C*D1*Dd*f**3 + 1200*C*D1*Dd*f**2*fd*r**2 + 3360*C*D1*Dd*f**2*fd*r*s - 1980*C*D1*Dd*f**2*fd*r + 2160*C*D1*Dd*f**2*fd*s**2 - 2660*C*D1*Dd*f**2*fd*s + 800*C*D1*Dd*f**2*fd + 200*C*D1*Ddd*f**3*r**2 + 560*C*D1*Ddd*f**3*r*s - 340*C*D1*Ddd*f**3*r + 360*C*D1*Ddd*f**3*s**2 - 460*C*D1*Ddd*f**3*s + 190*C*D1*Ddd*f**3 + 600*C*Dd**2*f**3*r**2 + 1680*C*Dd**2*f**3*r*s - 1020*C*Dd**2*f**3*r + 1080*C*Dd**2*f**3*s**2 - 1380*C*Dd**2*f**3*s + 380*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r**2 + 126*D1**2*K*bdd1*f**2*r*s - 90*D1**2*K*bdd1*f**2*r + 81*D1**2*K*bdd1*f**2*s**2 - 126*D1**2*K*bdd1*f**2*s + 45*D1**2*K*bdd1*f**2 + 30*D1**2*b2*f*fd*r**2 + 60*D1**2*b2*f*fd*r*s - 30*D1**2*b2*f*fd*r + 30*D1**2*b2*f*fd*s**2 - 30*D1**2*b2*f*fd*s + 15*D1**2*b2*f*fd + 90*D1**2*b2*f*fdd*r**2 + 180*D1**2*b2*f*fdd*r*s - 90*D1**2*b2*f*fdd*r + 90*D1**2*b2*f*fdd*s**2 - 90*D1**2*b2*f*fdd*s + 45*D1**2*b2*f*fdd + 90*D1**2*b2*fd**2*r**2 + 180*D1**2*b2*fd**2*r*s - 90*D1**2*b2*fd**2*r + 90*D1**2*b2*fd**2*s**2 - 90*D1**2*b2*fd**2*s - 180*D1**2*bd1**2*f**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 15*D1**2*bd2*f**2*r**2 + 30*D1**2*bd2*f**2*r*s - 30*D1**2*bd2*f**2*r + 15*D1**2*bd2*f**2*s**2 - 30*D1**2*bd2*f**2*s + 15*D1**2*bd2*f**2 + 180*D1**2*bd2*f*fd*r**2 + 360*D1**2*bd2*f*fd*r*s - 270*D1**2*bd2*f*fd*r + 180*D1**2*bd2*f*fd*s**2 - 270*D1**2*bd2*f*fd*s + 90*D1**2*bd2*f*fd + 252*D1**2*bdd1*f**3*r**2 + 342*D1**2*bdd1*f**3*r*s - 468*D1**2*bdd1*f**3*r + 90*D1**2*bdd1*f**3*s**2 - 306*D1**2*bdd1*f**3*s + 216*D1**2*bdd1*f**3 - 18*D1**2*bdd1*f**2*r*s - 18*D1**2*bdd1*f**2*s**2 + 18*D1**2*bdd1*f**2*s + 45*D1**2*bdd2*f**2*r**2 + 90*D1**2*bdd2*f**2*r*s - 90*D1**2*bdd2*f**2*r + 45*D1**2*bdd2*f**2*s**2 - 90*D1**2*bdd2*f**2*s + 45*D1**2*bdd2*f**2 + 15*D1**2*f**2*fd*r**2 + 48*D1**2*f**2*fd*r*s - 26*D1**2*f**2*fd*r + 33*D1**2*f**2*fd*s**2 - 38*D1**2*f**2*fd*s + 16*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 240*D1**2*f**2*fdd*r*s + 130*D1**2*f**2*fdd*r - 165*D1**2*f**2*fdd*s**2 + 190*D1**2*f**2*fdd*s - 80*D1**2*f**2*fdd - 30*D1**2*f**2*gd2*r**2 - 84*D1**2*f**2*gd2*r*s + 60*D1**2*f**2*gd2*r - 54*D1**2*f**2*gd2*s**2 + 84*D1**2*f**2*gd2*s - 30*D1**2*f**2*gd2 - 90*D1**2*f**2*gdd2*r**2 - 252*D1**2*f**2*gdd2*r*s + 180*D1**2*f**2*gdd2*r - 162*D1**2*f**2*gdd2*s**2 + 252*D1**2*f**2*gdd2*s - 90*D1**2*f**2*gdd2 - 150*D1**2*f*fd**2*r**2 - 480*D1**2*f*fd**2*r*s + 260*D1**2*f*fd**2*r - 330*D1**2*f*fd**2*s**2 + 380*D1**2*f*fd**2*s - 80*D1**2*f*fd**2 - 60*D1**2*f*fd*g2*r**2 - 168*D1**2*f*fd*g2*r*s + 84*D1**2*f*fd*g2*r - 108*D1**2*f*fd*g2*s**2 + 108*D1**2*f*fd*g2*s - 54*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r**2 - 1008*D1**2*f*fd*gd2*r*s + 612*D1**2*f*fd*gd2*r - 648*D1**2*f*fd*gd2*s**2 + 828*D1**2*f*fd*gd2*s - 252*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r**2 - 504*D1**2*f*fdd*g2*r*s + 252*D1**2*f*fdd*g2*r - 324*D1**2*f*fdd*g2*s**2 + 324*D1**2*f*fdd*g2*s - 162*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r**2 - 504*D1**2*fd**2*g2*r*s + 252*D1**2*fd**2*g2*r - 324*D1**2*fd**2*g2*s**2 + 324*D1**2*fd**2*g2*s + 60*D1*Dd*b2*f**2*r**2 + 120*D1*Dd*b2*f**2*r*s - 90*D1*Dd*b2*f**2*r + 60*D1*Dd*b2*f**2*s**2 - 90*D1*Dd*b2*f**2*s + 45*D1*Dd*b2*f**2 + 720*D1*Dd*b2*f*fd*r**2 + 1440*D1*Dd*b2*f*fd*r*s - 900*D1*Dd*b2*f*fd*r + 720*D1*Dd*b2*f*fd*s**2 - 900*D1*Dd*b2*f*fd*s + 270*D1*Dd*b2*f*fd + 360*D1*Dd*bd2*f**2*r**2 + 720*D1*Dd*bd2*f**2*r*s - 630*D1*Dd*bd2*f**2*r + 360*D1*Dd*bd2*f**2*s**2 - 630*D1*Dd*bd2*f**2*s + 270*D1*Dd*bd2*f**2 + 20*D1*Dd*f**3*r**2 + 64*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 44*D1*Dd*f**3*s**2 - 54*D1*Dd*f**3*s + 21*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1920*D1*Dd*f**2*fd*r*s + 1060*D1*Dd*f**2*fd*r - 1320*D1*Dd*f**2*fd*s**2 + 1570*D1*Dd*f**2*fd*s - 450*D1*Dd*f**2*fd - 120*D1*Dd*f**2*g2*r**2 - 336*D1*Dd*f**2*g2*r*s + 204*D1*Dd*f**2*g2*r - 216*D1*Dd*f**2*g2*s**2 + 276*D1*Dd*f**2*g2*s - 114*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r**2 - 2016*D1*Dd*f**2*gd2*r*s + 1332*D1*Dd*f**2*gd2*r - 1296*D1*Dd*f**2*gd2*s**2 + 1836*D1*Dd*f**2*gd2*s - 612*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r**2 - 4032*D1*Dd*f*fd*g2*r*s + 2232*D1*Dd*f*fd*g2*r - 2592*D1*Dd*f*fd*g2*s**2 + 2952*D1*Dd*f*fd*g2*s - 828*D1*Dd*f*fd*g2 + 180*D1*Ddd*b2*f**2*r**2 + 360*D1*Ddd*b2*f**2*r*s - 270*D1*Ddd*b2*f**2*r + 180*D1*Ddd*b2*f**2*s**2 - 270*D1*Ddd*b2*f**2*s + 135*D1*Ddd*b2*f**2 - 100*D1*Ddd*f**3*r**2 - 320*D1*Ddd*f**3*r*s + 180*D1*Ddd*f**3*r - 220*D1*Ddd*f**3*s**2 + 270*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r**2 - 1008*D1*Ddd*f**2*g2*r*s + 612*D1*Ddd*f**2*g2*r - 648*D1*Ddd*f**2*g2*s**2 + 828*D1*Ddd*f**2*g2*s - 342*D1*Ddd*f**2*g2 - 3*D1*bd1*f*(D1*(6*f**2*(12*r**2 + r*(19*s - 28) + 7*s**2 - 23*s + 16) - f*(6*fd*(84*r**2 + r*(114*s - 127) + 30*s**2 - 82*s + 45) + (K*(5*r + 9*s - 5) - 2*s)*(r + s - 1)) - 6*fd*(K*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 23*s + 7) - 4*r*s + r - 4*s**2 + 4*s - 1)) - 6*Dd*f*(K*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 51*s + 17) + f*(112*r**2 + r*(152*s - 179) + 40*s**2 - 116*s + 69) - 8*r*s + r - 8*s**2 + 8*s - 1)) + 540*Dd**2*b2*f**2*r**2 + 1080*Dd**2*b2*f**2*r*s - 810*Dd**2*b2*f**2*r + 540*Dd**2*b2*f**2*s**2 - 810*Dd**2*b2*f**2*s + 270*Dd**2*b2*f**2 - 300*Dd**2*f**3*r**2 - 960*Dd**2*f**3*r*s + 540*Dd**2*f**3*r - 660*Dd**2*f**3*s**2 + 810*Dd**2*f**3*s - 210*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r**2 - 3024*Dd**2*f**2*g2*r*s + 1836*Dd**2*f**2*g2*r - 1944*Dd**2*f**2*g2*s**2 + 2484*Dd**2*f**2*g2*s - 684*Dd**2*f**2*g2 + 30*b1**2*(D1**2*(f*(fd*(22*r**2 + 44*r*s - 34*r + 22*s**2 - 34*s + 17) - 6*fdd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 6*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(11*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 9*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 54*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(10*D1**2*K*f*fd*r**2 + 28*D1**2*K*f*fd*r*s - 14*D1**2*K*f*fd*r + 18*D1**2*K*f*fd*s**2 - 18*D1**2*K*f*fd*s + 9*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 + 84*D1**2*K*f*fdd*r*s - 42*D1**2*K*f*fdd*r + 54*D1**2*K*f*fdd*s**2 - 54*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 + 84*D1**2*K*fd**2*r*s - 42*D1**2*K*fd**2*r + 54*D1**2*K*fd**2*s**2 - 54*D1**2*K*fd**2*s - 30*D1**2*bdd1*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - 216*D1**2*f**2*fd*r**2 - 342*D1**2*f**2*fd*r*s + 234*D1**2*f**2*fd*r - 126*D1**2*f**2*fd*s**2 + 174*D1**2*f**2*fd*s - 90*D1**2*f**2*fd + 252*D1**2*f**2*fdd*r**2 + 342*D1**2*f**2*fdd*r*s - 294*D1**2*f**2*fdd*r + 90*D1**2*f**2*fdd*s**2 - 186*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd + 504*D1**2*f*fd**2*r**2 + 684*D1**2*f*fd**2*r*s - 588*D1**2*f*fd**2*r + 180*D1**2*f*fd**2*s**2 - 372*D1**2*f*fd**2*s + 126*D1**2*f*fd**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 2*D1**2*f*fd - 12*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 12*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 12*D1**2*fd**2*s + 20*D1*Dd*K*f**2*r**2 + 56*D1*Dd*K*f**2*r*s - 34*D1*Dd*K*f**2*r + 36*D1*Dd*K*f**2*s**2 - 46*D1*Dd*K*f**2*s + 19*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 + 672*D1*Dd*K*f*fd*r*s - 372*D1*Dd*K*f*fd*r + 432*D1*Dd*K*f*fd*s**2 - 492*D1*Dd*K*f*fd*s + 138*D1*Dd*K*f*fd - 288*D1*Dd*f**3*r**2 - 456*D1*Dd*f**3*r*s + 402*D1*Dd*f**3*r - 168*D1*Dd*f**3*s**2 + 312*D1*Dd*f**3*s - 186*D1*Dd*f**3 + 2016*D1*Dd*f**2*fd*r**2 + 2736*D1*Dd*f**2*fd*r*s - 2526*D1*Dd*f**2*fd*r + 720*D1*Dd*f**2*fd*s**2 - 1608*D1*Dd*f**2*fd*s + 774*D1*Dd*f**2*fd - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 8*D1*Dd*f**2*s - 2*D1*Dd*f**2 - 96*D1*Dd*f*fd*r*s + 36*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 96*D1*Dd*f*fd*s - 24*D1*Dd*f*fd + 60*D1*Ddd*K*f**2*r**2 + 168*D1*Ddd*K*f**2*r*s - 102*D1*Ddd*K*f**2*r + 108*D1*Ddd*K*f**2*s**2 - 138*D1*Ddd*K*f**2*s + 57*D1*Ddd*K*f**2 + 336*D1*Ddd*f**3*r**2 + 456*D1*Ddd*f**3*r*s - 450*D1*Ddd*f**3*r + 120*D1*Ddd*f**3*s**2 - 288*D1*Ddd*f**3*s + 198*D1*Ddd*f**3 - 24*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 24*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 + 20*D1*bd1*f*(D1*(f*(11*r**2 + 22*r*s - 16*r + 11*s**2 - 16*s + 8) - 18*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 3*Dd*f*(24*r**2 + r*(48*s - 38) + 24*s**2 - 38*s + 15)) + 180*Dd**2*K*f**2*r**2 + 504*Dd**2*K*f**2*r*s - 306*Dd**2*K*f**2*r + 324*Dd**2*K*f**2*s**2 - 414*Dd**2*K*f**2*s + 114*Dd**2*K*f**2 + 1008*Dd**2*f**3*r**2 + 1368*Dd**2*f**3*r*s - 1350*Dd**2*f**3*r + 360*Dd**2*f**3*s**2 - 864*Dd**2*f**3*s + 396*Dd**2*f**3 - 72*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 72*Dd**2*f**2*s - 12*Dd**2*f**2))/(630*d**2*k3**5) - D1**2*Pk2*Pkd3*k1**4*(D1*(42*D1*bd1**2*f*(r + s - 1)*(K*(-5*r - 9*s + 7) + f*(9*r + 7*s - 8) + 2*s - 1) - 3*D1*bdd1*f*(5*f*(2*C*(5*r + 9*s - 9) - 5*r - 11*s + 11) - 14*g2*(5*r + 9*s - 9))*(r + s - 1) + 35*b2*(-3*D1*bdd1*f*(r + s - 1) + bd1*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + bd1*(-210*D1*bd2*f*(r + s - 1)**2 + D1*(9*f**2*(r + s - 1)*(2*C*(5*r + 9*s - 9) - 5*r - 11*s + 11) - 2*f*(15*fd*(2*C*(10*r**2 + 28*r*s - 19*r + 18*s**2 - 25*s + 7) - 10*r**2 - 32*r*s + 21*r - 22*s**2 + 30*s - 8) + (g2*(5*r + 9*s - 9) - 6*gd2*(5*r + 9*s - 7))*(7*r + 7*s - 7)) + 84*fd*g2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9))) - 6*Dd*f*(5*f*(2*C*(20*r**2 + 56*r*s - 45*r + 36*s**2 - 59*s + 23) - 20*r**2 - 64*r*s + 50*r - 44*s**2 + 71*s - 27) - 14*g2*(20*r**2 + r*(56*s - 45) + 36*s**2 - 59*s + 23)))) + 35*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(5*D1**2*K*fd*r**2 + 14*D1**2*K*fd*r*s + 9*D1**2*K*fd*s**2 - 15*D1**2*K*fdd*r**2 - 42*D1**2*K*fdd*r*s - 27*D1**2*K*fdd*s**2 - 15*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 42*D1**2*f*fd*r**2 - 72*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 21*D1**2*f*fd + 54*D1**2*f*fdd*r**2 + 96*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 27*D1**2*f*fdd + 54*D1**2*fd**2*r**2 + 96*D1**2*fd**2*r*s - 54*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 48*D1**2*fd**2*s - 2*D1**2*fd*r*s - 2*D1**2*fd*s**2 + 6*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 + 20*D1*Dd*K*f*r**2 + 56*D1*Dd*K*f*r*s - 34*D1*Dd*K*f*r + 36*D1*Dd*K*f*s**2 - 46*D1*Dd*K*f*s + 19*D1*Dd*K*f - 120*D1*Dd*K*fd*r**2 - 336*D1*Dd*K*fd*r*s + 102*D1*Dd*K*fd*r - 216*D1*Dd*K*fd*s**2 + 138*D1*Dd*K*fd*s - 84*D1*Dd*f**2*r**2 - 144*D1*Dd*f**2*r*s + 120*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 102*D1*Dd*f**2*s - 57*D1*Dd*f**2 + 432*D1*Dd*f*fd*r**2 + 768*D1*Dd*f*fd*r*s - 528*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 468*D1*Dd*f*fd*s + 156*D1*Dd*f*fd - 8*D1*Dd*f*r*s + 2*D1*Dd*f*r - 8*D1*Dd*f*s**2 + 8*D1*Dd*f*s - 2*D1*Dd*f + 48*D1*Dd*fd*r*s - 6*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 24*D1*Dd*fd*s - 60*D1*Ddd*K*f*r**2 - 168*D1*Ddd*K*f*r*s + 102*D1*Ddd*K*f*r - 108*D1*Ddd*K*f*s**2 + 138*D1*Ddd*K*f*s - 57*D1*Ddd*K*f + 108*D1*Ddd*f**2*r**2 + 192*D1*Ddd*f**2*r*s - 156*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 138*D1*Ddd*f**2*s + 75*D1*Ddd*f**2 + 24*D1*Ddd*f*r*s - 6*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 24*D1*Ddd*f*s + 6*D1*Ddd*f + 5*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - 6*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 180*Dd**2*K*f*r**2 - 504*Dd**2*K*f*r*s + 306*Dd**2*K*f*r - 324*Dd**2*K*f*s**2 + 414*Dd**2*K*f*s - 114*Dd**2*K*f + 324*Dd**2*f**2*r**2 + 576*Dd**2*f**2*r*s - 468*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 414*Dd**2*f**2*s + 150*Dd**2*f**2 + 72*Dd**2*f*r*s - 18*Dd**2*f*r + 72*Dd**2*f*s**2 - 72*Dd**2*f*s + 12*Dd**2*f) + b1*(180*C*D1**2*f*fd*r**2 + 504*C*D1**2*f*fd*r*s - 180*C*D1**2*f*fd*r + 324*C*D1**2*f*fd*s**2 - 252*C*D1**2*f*fd*s + 90*C*D1**2*f*fd - 300*C*D1**2*f*fdd*r**2 - 840*C*D1**2*f*fdd*r*s + 300*C*D1**2*f*fdd*r - 540*C*D1**2*f*fdd*s**2 + 420*C*D1**2*f*fdd*s - 150*C*D1**2*f*fdd - 300*C*D1**2*fd**2*r**2 - 840*C*D1**2*fd**2*r*s + 300*C*D1**2*fd**2*r - 540*C*D1**2*fd**2*s**2 + 420*C*D1**2*fd**2*s + 360*C*D1*Dd*f**2*r**2 + 1008*C*D1*Dd*f**2*r*s - 612*C*D1*Dd*f**2*r + 648*C*D1*Dd*f**2*s**2 - 828*C*D1*Dd*f**2*s + 342*C*D1*Dd*f**2 - 2400*C*D1*Dd*f*fd*r**2 - 6720*C*D1*Dd*f*fd*r*s + 3240*C*D1*Dd*f*fd*r - 4320*C*D1*Dd*f*fd*s**2 + 4440*C*D1*Dd*f*fd*s - 1020*C*D1*Dd*f*fd - 600*C*D1*Ddd*f**2*r**2 - 1680*C*D1*Ddd*f**2*r*s + 1020*C*D1*Ddd*f**2*r - 1080*C*D1*Ddd*f**2*s**2 + 1380*C*D1*Ddd*f**2*s - 570*C*D1*Ddd*f**2 - 1800*C*Dd**2*f**2*r**2 - 5040*C*Dd**2*f**2*r*s + 3060*C*Dd**2*f**2*r - 3240*C*Dd**2*f**2*s**2 + 4140*C*Dd**2*f**2*s - 1140*C*Dd**2*f**2 - 210*D1**2*K*bdd1*f*r**2 - 588*D1**2*K*bdd1*f*r*s + 504*D1**2*K*bdd1*f*r - 378*D1**2*K*bdd1*f*s**2 + 672*D1**2*K*bdd1*f*s - 294*D1**2*K*bdd1*f + 35*D1**2*b2*fd*r**2 + 70*D1**2*b2*fd*r*s + 35*D1**2*b2*fd*s**2 - 105*D1**2*b2*fdd*r**2 - 210*D1**2*b2*fdd*r*s - 105*D1**2*b2*fdd*s**2 - 210*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 378*D1**2*bdd1*f**2*r**2 + 672*D1**2*bdd1*f**2*r*s - 714*D1**2*bdd1*f**2*r + 294*D1**2*bdd1*f**2*s**2 - 630*D1**2*bdd1*f**2*s + 336*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*r*s - 42*D1**2*bdd1*f*r + 84*D1**2*bdd1*f*s**2 - 126*D1**2*bdd1*f*s + 42*D1**2*bdd1*f - 105*D1**2*bdd2*f*r**2 - 210*D1**2*bdd2*f*r*s + 210*D1**2*bdd2*f*r - 105*D1**2*bdd2*f*s**2 + 210*D1**2*bdd2*f*s - 105*D1**2*bdd2*f - 90*D1**2*f*fd*r**2 - 288*D1**2*f*fd*r*s + 90*D1**2*f*fd*r - 198*D1**2*f*fd*s**2 + 144*D1**2*f*fd*s - 45*D1**2*f*fd + 150*D1**2*f*fdd*r**2 + 480*D1**2*f*fdd*r*s - 150*D1**2*f*fdd*r + 330*D1**2*f*fdd*s**2 - 240*D1**2*f*fdd*s + 75*D1**2*f*fdd - 70*D1**2*f*gd2*r**2 - 196*D1**2*f*gd2*r*s + 140*D1**2*f*gd2*r - 126*D1**2*f*gd2*s**2 + 196*D1**2*f*gd2*s - 70*D1**2*f*gd2 + 210*D1**2*f*gdd2*r**2 + 588*D1**2*f*gdd2*r*s - 420*D1**2*f*gdd2*r + 378*D1**2*f*gdd2*s**2 - 588*D1**2*f*gdd2*s + 210*D1**2*f*gdd2 + 150*D1**2*fd**2*r**2 + 480*D1**2*fd**2*r*s - 150*D1**2*fd**2*r + 330*D1**2*fd**2*s**2 - 240*D1**2*fd**2*s - 70*D1**2*fd*g2*r**2 - 196*D1**2*fd*g2*r*s - 126*D1**2*fd*g2*s**2 + 420*D1**2*fd*gd2*r**2 + 1176*D1**2*fd*gd2*r*s - 420*D1**2*fd*gd2*r + 756*D1**2*fd*gd2*s**2 - 588*D1**2*fd*gd2*s + 210*D1**2*fdd*g2*r**2 + 588*D1**2*fdd*g2*r*s + 378*D1**2*fdd*g2*s**2 + 140*D1*Dd*b2*f*r**2 + 280*D1*Dd*b2*f*r*s - 210*D1*Dd*b2*f*r + 140*D1*Dd*b2*f*s**2 - 210*D1*Dd*b2*f*s + 105*D1*Dd*b2*f - 840*D1*Dd*b2*fd*r**2 - 1680*D1*Dd*b2*fd*r*s + 630*D1*Dd*b2*fd*r - 840*D1*Dd*b2*fd*s**2 + 630*D1*Dd*b2*fd*s - 180*D1*Dd*f**2*r**2 - 576*D1*Dd*f**2*r*s + 324*D1*Dd*f**2*r - 396*D1*Dd*f**2*s**2 + 486*D1*Dd*f**2*s - 189*D1*Dd*f**2 + 1200*D1*Dd*f*fd*r**2 + 3840*D1*Dd*f*fd*r*s - 1680*D1*Dd*f*fd*r + 2640*D1*Dd*f*fd*s**2 - 2580*D1*Dd*f*fd*s + 540*D1*Dd*f*fd - 280*D1*Dd*f*g2*r**2 - 784*D1*Dd*f*g2*r*s + 476*D1*Dd*f*g2*r - 504*D1*Dd*f*g2*s**2 + 644*D1*Dd*f*g2*s - 266*D1*Dd*f*g2 + 1680*D1*Dd*f*gd2*r**2 + 4704*D1*Dd*f*gd2*r*s - 3108*D1*Dd*f*gd2*r + 3024*D1*Dd*f*gd2*s**2 - 4284*D1*Dd*f*gd2*s + 1428*D1*Dd*f*gd2 + 1680*D1*Dd*fd*g2*r**2 + 4704*D1*Dd*fd*g2*r*s - 1428*D1*Dd*fd*g2*r + 3024*D1*Dd*fd*g2*s**2 - 1932*D1*Dd*fd*g2*s - 420*D1*Ddd*b2*f*r**2 - 840*D1*Ddd*b2*f*r*s + 630*D1*Ddd*b2*f*r - 420*D1*Ddd*b2*f*s**2 + 630*D1*Ddd*b2*f*s - 315*D1*Ddd*b2*f + 300*D1*Ddd*f**2*r**2 + 960*D1*Ddd*f**2*r*s - 540*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s**2 - 810*D1*Ddd*f**2*s + 315*D1*Ddd*f**2 + 840*D1*Ddd*f*g2*r**2 + 2352*D1*Ddd*f*g2*r*s - 1428*D1*Ddd*f*g2*r + 1512*D1*Ddd*f*g2*s**2 - 1932*D1*Ddd*f*g2*s + 798*D1*Ddd*f*g2 - 14*D1*bd1*(D1*(3*f**2*(7*r**2 + r*(12*s - 13) + 5*s**2 - 11*s + 6) - f*(3*fd*(36*r**2 + r*(64*s - 52) + 28*s**2 - 46*s + 17) + (r + s - 1)*(K*(5*r + 9*s - 7) - 2*s + 1)) + 3*fd*(10*K*r**2 + r*(4*K*(7*s - 3) - 4*s + 1) + s*(2*K*(9*s - 8) - 4*s + 3))) - 3*Dd*f*(-2*K*(20*r**2 + 56*r*s - 41*r + 36*s**2 - 55*s + 20) + f*(72*r**2 + 8*r*(16*s - 15) + 56*s**2 - 106*s + 49) + 16*r*s - 6*r + 16*s**2 - 20*s + 5)) + 35*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 1260*Dd**2*b2*f*r**2 - 2520*Dd**2*b2*f*r*s + 1890*Dd**2*b2*f*r - 1260*Dd**2*b2*f*s**2 + 1890*Dd**2*b2*f*s - 630*Dd**2*b2*f + 900*Dd**2*f**2*r**2 + 2880*Dd**2*f**2*r*s - 1620*Dd**2*f**2*r + 1980*Dd**2*f**2*s**2 - 2430*Dd**2*f**2*s + 630*Dd**2*f**2 + 2520*Dd**2*f*g2*r**2 + 7056*Dd**2*f*g2*r*s - 4284*Dd**2*f*g2*r + 4536*Dd**2*f*g2*s**2 - 5796*Dd**2*f*g2*s + 1596*Dd**2*f*g2))/(210*d**2*k3**5) + D1**2*Pk2*Pkd3*k1**4*st**2*(18*b1**2*(D1**2*s*(4*r + 4*s - 3)*(2*f*fd - f*fdd - fd**2) + D1*f*(4*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - Dd*fd*(8*s - 1)*(4*r + 4*s - 3) + 2*Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 3*b1*(-6*D1**2*bdd1*f**2*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 54*D1**2*f**2*fd*r*s + 18*D1**2*f**2*fd*r - 54*D1**2*f**2*fd*s**2 + 63*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 54*D1**2*f**2*fdd*r*s - 18*D1**2*f**2*fdd*r + 54*D1**2*f**2*fdd*s**2 - 63*D1**2*f**2*fdd*s + 18*D1**2*f**2*fdd + 108*D1**2*f*fd**2*r*s - 36*D1**2*f*fd**2*r + 108*D1**2*f*fd**2*s**2 - 126*D1**2*f*fd**2*s + 27*D1**2*f*fd**2 + 2*D1**2*f*fd*r*s - D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + D1**2*f*fd + 6*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 6*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r*s - 3*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 6*D1**2*fd**2*s - 72*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 72*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 432*D1*Dd*f**2*fd*r*s - 126*D1*Dd*f**2*fd*r + 432*D1*Dd*f**2*fd*s**2 - 468*D1*Dd*f**2*fd*s + 99*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r*s - D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 4*D1*Dd*f**2*s + D1*Dd*f**2 + 48*D1*Dd*f*fd*r*s - 18*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 48*D1*Dd*f*fd*s + 12*D1*Dd*f*fd + 72*D1*Ddd*f**3*r*s - 18*D1*Ddd*f**3*r + 72*D1*Ddd*f**3*s**2 - 72*D1*Ddd*f**3*s + 18*D1*Ddd*f**3 + 12*D1*Ddd*f**2*r*s - 3*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 6*D1*bd1*f*(2*D1*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - D1*fd*(4*s - 1)*(4*r + 4*s - 3) - Dd*f*(8*s - 3)*(4*r + 4*s - 3)) + 216*Dd**2*f**3*r*s - 54*Dd**2*f**3*r + 216*Dd**2*f**3*s**2 - 216*Dd**2*f**3*s + 36*Dd**2*f**3 + 36*Dd**2*f**2*r*s - 9*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 6*Dd**2*f**2) + f*(-18*D1**2*bd1**2*f*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1**2*(27*bdd1*f**2*s*(2*r + 2*s - 1) + f*(9*bdd1*s*(r + s - 1) + fd*(-3*r*s + r - 3*s**2 + 3*s - 1) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 3*D1*bd1*(D1*(f*s*(-9*f*(2*r + 2*s - 1) + r + s - 1) + 3*fd*(f*(6*r*(6*s - 1) + 36*s**2 - 30*s + 3) + r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd*f*(f*(6*r*(8*s - 1) + 48*s**2 - 36*s + 3) + r*(8*s - 1) + 8*s**2 - 8*s + 1)) + D1*f*(Dd*(f*(-4*r*s + r - 4*s**2 + 4*s - 1) + 5*fd*(24*r*s - 7*r + 24*s**2 - 24*s + 5)) + 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k2**2*k3**3) + D1**2*Pk2*Pkd3*k1**4*(3*D1*f*(7*D1*bd1**2*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + (2*s - 1)*(r + s - 1)) + 5*D1*bdd1*f*(s - 1)*(r + s - 1) + bd1*(D1*(-3*f*(s - 1)*(r + s - 1) + 5*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 7*b1**2*(D1**2*s*(3*f*(fd - fdd)*(4*r + 4*s - 3) - 3*fd**2*(4*r + 4*s - 3) + fd*(r + s) - 3*fdd*(r + s)) + D1*(Dd*(6*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(3*fd*(8*s - 1)*(4*r + 4*s - 3) - 4*r*s + r - 4*s**2 + 4*s - 1) + 3*fd*(-8*r*s + r + s*(4 - 8*s))) - 3*Ddd*f*(2*f + 1)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(2*f + 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(21*D1**2*bdd1*f*(f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + (2*s - 1)*(r + s - 1)) - 3*D1**2*s*(2*r + 2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) - 7*D1*bd1*(D1*(3*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 3*f*fd*(4*s - 1)*(4*r + 4*s - 3) + f*(2*s - 1)*(r + s - 1) + 3*fd*(-4*r*s + r + s*(3 - 4*s))) - 3*Dd*f*(f*(8*s - 3)*(4*r + 4*s - 3) + 16*r*s - 6*r + 16*s**2 - 20*s + 5)) + 3*D1*f*(Dd*(-3*f*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2**2*k3**3) + 9*D1**2*Pk2*Pkd3*k1**2*k2**4*st**4*(18*C*D1**2*f**2*fd*r**2 + 36*C*D1**2*f**2*fd*r*s - 24*C*D1**2*f**2*fd*r + 18*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 12*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 16*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 16*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 32*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 32*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 24*C*D1*Dd*f**3*r**2 + 48*C*D1*Dd*f**3*r*s - 36*C*D1*Dd*f**3*r + 24*C*D1*Dd*f**3*s**2 - 36*C*D1*Dd*f**3*s + 18*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 136*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 136*C*D1*Dd*f**2*fd*s - 48*C*D1*Dd*f**2*fd - 16*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 24*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 48*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 72*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s - 24*C*Dd**2*f**3 - 6*D1**2*K*bdd1*f**2*r**2 - 12*D1**2*K*bdd1*f**2*r*s + 12*D1**2*K*bdd1*f**2*r - 6*D1**2*K*bdd1*f**2*s**2 + 12*D1**2*K*bdd1*f**2*s - 6*D1**2*K*bdd1*f**2 + 10*D1**2*bd1**2*f**2*(r + s - 1)**2 - 9*D1**2*f**2*fd*r**2 - 18*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 9*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r*s - 8*D1**2*f**2*fdd*r + 6*D1**2*f**2*fdd*s**2 - 8*D1**2*f**2*fdd*s + 4*D1**2*f**2*fdd - 10*D1**2*f**2*gd2*r**2 - 20*D1**2*f**2*gd2*r*s + 20*D1**2*f**2*gd2*r - 10*D1**2*f**2*gd2*s**2 + 20*D1**2*f**2*gd2*s - 10*D1**2*f**2*gd2 + 12*D1**2*f**2*gdd2*r**2 + 24*D1**2*f**2*gdd2*r*s - 24*D1**2*f**2*gdd2*r + 12*D1**2*f**2*gdd2*s**2 - 24*D1**2*f**2*gdd2*s + 12*D1**2*f**2*gdd2 + 12*D1**2*f*fd**2*r**2 + 24*D1**2*f*fd**2*r*s - 16*D1**2*f*fd**2*r + 12*D1**2*f*fd**2*s**2 - 16*D1**2*f*fd**2*s + 4*D1**2*f*fd**2 - 20*D1**2*f*fd*g2*r**2 - 40*D1**2*f*fd*g2*r*s + 20*D1**2*f*fd*g2*r - 20*D1**2*f*fd*g2*s**2 + 20*D1**2*f*fd*g2*s - 10*D1**2*f*fd*g2 + 48*D1**2*f*fd*gd2*r**2 + 96*D1**2*f*fd*gd2*r*s - 72*D1**2*f*fd*gd2*r + 48*D1**2*f*fd*gd2*s**2 - 72*D1**2*f*fd*gd2*s + 24*D1**2*f*fd*gd2 + 24*D1**2*f*fdd*g2*r**2 + 48*D1**2*f*fdd*g2*r*s - 24*D1**2*f*fdd*g2*r + 24*D1**2*f*fdd*g2*s**2 - 24*D1**2*f*fdd*g2*s + 12*D1**2*f*fdd*g2 + 24*D1**2*fd**2*g2*r**2 + 48*D1**2*fd**2*g2*r*s - 24*D1**2*fd**2*g2*r + 24*D1**2*fd**2*g2*s**2 - 24*D1**2*fd**2*g2*s - 12*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 + 18*D1*Dd*f**3*s - 9*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 96*D1*Dd*f**2*fd*r*s - 68*D1*Dd*f**2*fd*r + 48*D1*Dd*f**2*fd*s**2 - 68*D1*Dd*f**2*fd*s + 24*D1*Dd*f**2*fd - 40*D1*Dd*f**2*g2*r**2 - 80*D1*Dd*f**2*g2*r*s + 60*D1*Dd*f**2*g2*r - 40*D1*Dd*f**2*g2*s**2 + 60*D1*Dd*f**2*g2*s - 30*D1*Dd*f**2*g2 + 96*D1*Dd*f**2*gd2*r**2 + 192*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 96*D1*Dd*f**2*gd2*s**2 - 168*D1*Dd*f**2*gd2*s + 72*D1*Dd*f**2*gd2 + 192*D1*Dd*f*fd*g2*r**2 + 384*D1*Dd*f*fd*g2*r*s - 240*D1*Dd*f*fd*g2*r + 192*D1*Dd*f*fd*g2*s**2 - 240*D1*Dd*f*fd*g2*s + 72*D1*Dd*f*fd*g2 + 8*D1*Ddd*f**3*r**2 + 16*D1*Ddd*f**3*r*s - 12*D1*Ddd*f**3*r + 8*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 6*D1*Ddd*f**3 + 48*D1*Ddd*f**2*g2*r**2 + 96*D1*Ddd*f**2*g2*r*s - 72*D1*Ddd*f**2*g2*r + 48*D1*Ddd*f**2*g2*s**2 - 72*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(5*K*f*(r + s - 1) - 12*K*fd*(2*r + 2*s - 1) + 2*f**2*(r + s - 1)) - 12*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + 24*Dd**2*f**3*r**2 + 48*Dd**2*f**3*r*s - 36*Dd**2*f**3*r + 24*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 12*Dd**2*f**3 + 144*Dd**2*f**2*g2*r**2 + 288*Dd**2*f**2*g2*r*s - 216*Dd**2*f**2*g2*r + 144*Dd**2*f**2*g2*s**2 - 216*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 - 5*b1**2*(D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(10*D1**2*K*f*fd*r**2 + 20*D1**2*K*f*fd*r*s - 10*D1**2*K*f*fd*r + 10*D1**2*K*f*fd*s**2 - 10*D1**2*K*f*fd*s + 5*D1**2*K*f*fd - 12*D1**2*K*f*fdd*r**2 - 24*D1**2*K*f*fdd*r*s + 12*D1**2*K*f*fdd*r - 12*D1**2*K*f*fdd*s**2 + 12*D1**2*K*f*fdd*s - 6*D1**2*K*f*fdd - 12*D1**2*K*fd**2*r**2 - 24*D1**2*K*fd**2*r*s + 12*D1**2*K*fd**2*r - 12*D1**2*K*fd**2*s**2 + 12*D1**2*K*fd**2*s + 10*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd + 20*D1*Dd*K*f**2*r**2 + 40*D1*Dd*K*f**2*r*s - 30*D1*Dd*K*f**2*r + 20*D1*Dd*K*f**2*s**2 - 30*D1*Dd*K*f**2*s + 15*D1*Dd*K*f**2 - 96*D1*Dd*K*f*fd*r**2 - 192*D1*Dd*K*f*fd*r*s + 120*D1*Dd*K*f*fd*r - 96*D1*Dd*K*f*fd*s**2 + 120*D1*Dd*K*f*fd*s - 36*D1*Dd*K*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Ddd*K*f**2*r**2 - 48*D1*Ddd*K*f**2*r*s + 36*D1*Ddd*K*f**2*r - 24*D1*Ddd*K*f**2*s**2 + 36*D1*Ddd*K*f**2*s - 18*D1*Ddd*K*f**2 - 20*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 72*Dd**2*K*f**2*r**2 - 144*Dd**2*K*f**2*r*s + 108*Dd**2*K*f**2*r - 72*Dd**2*K*f**2*s**2 + 108*Dd**2*K*f**2*s - 36*Dd**2*K*f**2))/(70*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*k1**2*k2**4*st**2*(116*C*D1**2*b1*f*fd*r**2 + 232*C*D1**2*b1*f*fd*r*s - 116*C*D1**2*b1*f*fd*r + 116*C*D1**2*b1*f*fd*s**2 - 116*C*D1**2*b1*f*fd*s + 58*C*D1**2*b1*f*fd - 72*C*D1**2*b1*f*fdd*r**2 - 144*C*D1**2*b1*f*fdd*r*s + 72*C*D1**2*b1*f*fdd*r - 72*C*D1**2*b1*f*fdd*s**2 + 72*C*D1**2*b1*f*fdd*s - 36*C*D1**2*b1*f*fdd - 72*C*D1**2*b1*fd**2*r**2 - 144*C*D1**2*b1*fd**2*r*s + 72*C*D1**2*b1*fd**2*r - 72*C*D1**2*b1*fd**2*s**2 + 72*C*D1**2*b1*fd**2*s - 18*C*D1**2*f**2*fd*r**2 - 36*C*D1**2*f**2*fd*r*s + 24*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 12*C*D1**2*f**2*fd + 232*C*D1*Dd*b1*f**2*r**2 + 464*C*D1*Dd*b1*f**2*r*s - 348*C*D1*Dd*b1*f**2*r + 232*C*D1*Dd*b1*f**2*s**2 - 348*C*D1*Dd*b1*f**2*s + 174*C*D1*Dd*b1*f**2 - 576*C*D1*Dd*b1*f*fd*r**2 - 1152*C*D1*Dd*b1*f*fd*r*s + 720*C*D1*Dd*b1*f*fd*r - 576*C*D1*Dd*b1*f*fd*s**2 + 720*C*D1*Dd*b1*f*fd*s - 216*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r**2 - 48*C*D1*Dd*f**3*r*s + 36*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 36*C*D1*Dd*f**3*s - 18*C*D1*Dd*f**3 - 144*C*D1*Ddd*b1*f**2*r**2 - 288*C*D1*Ddd*b1*f**2*r*s + 216*C*D1*Ddd*b1*f**2*r - 144*C*D1*Ddd*b1*f**2*s**2 + 216*C*D1*Ddd*b1*f**2*s - 108*C*D1*Ddd*b1*f**2 - 432*C*Dd**2*b1*f**2*r**2 - 864*C*Dd**2*b1*f**2*r*s + 648*C*Dd**2*b1*f**2*r - 432*C*Dd**2*b1*f**2*s**2 + 648*C*Dd**2*b1*f**2*s - 216*C*Dd**2*b1*f**2 + 49*D1**2*K*b1**2*fd*r**2 + 98*D1**2*K*b1**2*fd*r*s + 49*D1**2*K*b1**2*fd*s**2 - 42*D1**2*K*b1**2*fdd*r**2 - 84*D1**2*K*b1**2*fdd*r*s - 42*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 84*D1**2*K*bd1**2*f*(r + s - 1)**2 + 42*D1**2*b1**2*f*fd*r**2 + 84*D1**2*b1**2*f*fd*r*s - 42*D1**2*b1**2*f*fd*r + 42*D1**2*b1**2*f*fd*s**2 - 42*D1**2*b1**2*f*fd*s + 21*D1**2*b1**2*f*fd - 58*D1**2*b1*f*fd*r**2 - 116*D1**2*b1*f*fd*r*s + 58*D1**2*b1*f*fd*r - 58*D1**2*b1*f*fd*s**2 + 58*D1**2*b1*f*fd*s - 29*D1**2*b1*f*fd + 36*D1**2*b1*f*fdd*r**2 + 72*D1**2*b1*f*fdd*r*s - 36*D1**2*b1*f*fdd*r + 36*D1**2*b1*f*fdd*s**2 - 36*D1**2*b1*f*fdd*s + 18*D1**2*b1*f*fdd - 98*D1**2*b1*f*gd2*r**2 - 196*D1**2*b1*f*gd2*r*s + 196*D1**2*b1*f*gd2*r - 98*D1**2*b1*f*gd2*s**2 + 196*D1**2*b1*f*gd2*s - 98*D1**2*b1*f*gd2 + 84*D1**2*b1*f*gdd2*r**2 + 168*D1**2*b1*f*gdd2*r*s - 168*D1**2*b1*f*gdd2*r + 84*D1**2*b1*f*gdd2*s**2 - 168*D1**2*b1*f*gdd2*s + 84*D1**2*b1*f*gdd2 + 36*D1**2*b1*fd**2*r**2 + 72*D1**2*b1*fd**2*r*s - 36*D1**2*b1*fd**2*r + 36*D1**2*b1*fd**2*s**2 - 36*D1**2*b1*fd**2*s - 98*D1**2*b1*fd*g2*r**2 - 196*D1**2*b1*fd*g2*r*s - 98*D1**2*b1*fd*g2*s**2 + 168*D1**2*b1*fd*gd2*r**2 + 336*D1**2*b1*fd*gd2*r*s - 168*D1**2*b1*fd*gd2*r + 168*D1**2*b1*fd*gd2*s**2 - 168*D1**2*b1*fd*gd2*s + 84*D1**2*b1*fdd*g2*r**2 + 168*D1**2*b1*fdd*g2*r*s + 84*D1**2*b1*fdd*g2*s**2 - 6*D1**2*bdd1*f*(r + s - 1)**2*(6*C*f + 14*K*b1 - 3*f - 14*g2) + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 196*D1*Dd*K*b1**2*f*r**2 + 392*D1*Dd*K*b1**2*f*r*s - 294*D1*Dd*K*b1**2*f*r + 196*D1*Dd*K*b1**2*f*s**2 - 294*D1*Dd*K*b1**2*f*s + 147*D1*Dd*K*b1**2*f - 336*D1*Dd*K*b1**2*fd*r**2 - 672*D1*Dd*K*b1**2*fd*r*s + 252*D1*Dd*K*b1**2*fd*r - 336*D1*Dd*K*b1**2*fd*s**2 + 252*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 + 84*D1*Dd*b1**2*f**2*r**2 + 168*D1*Dd*b1**2*f**2*r*s - 126*D1*Dd*b1**2*f**2*r + 84*D1*Dd*b1**2*f**2*s**2 - 126*D1*Dd*b1**2*f**2*s + 63*D1*Dd*b1**2*f**2 - 116*D1*Dd*b1*f**2*r**2 - 232*D1*Dd*b1*f**2*r*s + 174*D1*Dd*b1*f**2*r - 116*D1*Dd*b1*f**2*s**2 + 174*D1*Dd*b1*f**2*s - 87*D1*Dd*b1*f**2 + 288*D1*Dd*b1*f*fd*r**2 + 576*D1*Dd*b1*f*fd*r*s - 360*D1*Dd*b1*f*fd*r + 288*D1*Dd*b1*f*fd*s**2 - 360*D1*Dd*b1*f*fd*s + 108*D1*Dd*b1*f*fd - 392*D1*Dd*b1*f*g2*r**2 - 784*D1*Dd*b1*f*g2*r*s + 588*D1*Dd*b1*f*g2*r - 392*D1*Dd*b1*f*g2*s**2 + 588*D1*Dd*b1*f*g2*s - 294*D1*Dd*b1*f*g2 + 672*D1*Dd*b1*f*gd2*r**2 + 1344*D1*Dd*b1*f*gd2*r*s - 1176*D1*Dd*b1*f*gd2*r + 672*D1*Dd*b1*f*gd2*s**2 - 1176*D1*Dd*b1*f*gd2*s + 504*D1*Dd*b1*f*gd2 + 672*D1*Dd*b1*fd*g2*r**2 + 1344*D1*Dd*b1*fd*g2*r*s - 504*D1*Dd*b1*fd*g2*r + 672*D1*Dd*b1*fd*g2*s**2 - 504*D1*Dd*b1*fd*g2*s + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 168*D1*Ddd*K*b1**2*f*r**2 - 336*D1*Ddd*K*b1**2*f*r*s + 252*D1*Ddd*K*b1**2*f*r - 168*D1*Ddd*K*b1**2*f*s**2 + 252*D1*Ddd*K*b1**2*f*s - 126*D1*Ddd*K*b1**2*f + 72*D1*Ddd*b1*f**2*r**2 + 144*D1*Ddd*b1*f**2*r*s - 108*D1*Ddd*b1*f**2*r + 72*D1*Ddd*b1*f**2*s**2 - 108*D1*Ddd*b1*f**2*s + 54*D1*Ddd*b1*f**2 + 336*D1*Ddd*b1*f*g2*r**2 + 672*D1*Ddd*b1*f*g2*r*s - 504*D1*Ddd*b1*f*g2*r + 336*D1*Ddd*b1*f*g2*s**2 - 504*D1*Ddd*b1*f*g2*s + 252*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(58*C - 7*K + 42*b1 - 29) - 2*f*(fd*(36*C - 18)*(2*r + 2*s - 1) + (r + s - 1)*(-49*K*b1 + 49*g2 - 84*gd2)) + 168*fd*(r + s)*(-K*b1 + g2)) - 12*Dd*f*(4*r + 4*s - 3)*(6*C*f + 14*K*b1 - 3*f - 14*g2))*(r + s - 1) - 504*Dd**2*K*b1**2*f*r**2 - 1008*Dd**2*K*b1**2*f*r*s + 756*Dd**2*K*b1**2*f*r - 504*Dd**2*K*b1**2*f*s**2 + 756*Dd**2*K*b1**2*f*s - 252*Dd**2*K*b1**2*f + 216*Dd**2*b1*f**2*r**2 + 432*Dd**2*b1*f**2*r*s - 324*Dd**2*b1*f**2*r + 216*Dd**2*b1*f**2*s**2 - 324*Dd**2*b1*f**2*s + 108*Dd**2*b1*f**2 + 1008*Dd**2*b1*f*g2*r**2 + 2016*Dd**2*b1*f*g2*r*s - 1512*Dd**2*b1*f*g2*r + 1008*Dd**2*b1*f*g2*s**2 - 1512*Dd**2*b1*f*g2*s + 504*Dd**2*b1*f*g2)/(70*d**2*k3**7) - D1**2*Pk2*Pkd3*k1**2*k2**2*st**4*(138*C*D1**2*f**2*fd*r**2 + 252*C*D1**2*f**2*fd*r*s - 176*C*D1**2*f**2*fd*r + 114*C*D1**2*f**2*fd*s**2 - 160*C*D1**2*f**2*fd*s + 84*C*D1**2*f**2*fd - 84*C*D1**2*f**2*fdd*r**2 - 168*C*D1**2*f**2*fdd*r*s + 112*C*D1**2*f**2*fdd*r - 84*C*D1**2*f**2*fdd*s**2 + 112*C*D1**2*f**2*fdd*s - 56*C*D1**2*f**2*fdd - 168*C*D1**2*f*fd**2*r**2 - 336*C*D1**2*f*fd**2*r*s + 224*C*D1**2*f*fd**2*r - 168*C*D1**2*f*fd**2*s**2 + 224*C*D1**2*f*fd**2*s - 56*C*D1**2*f*fd**2 + 184*C*D1*Dd*f**3*r**2 + 336*C*D1*Dd*f**3*r*s - 268*C*D1*Dd*f**3*r + 152*C*D1*Dd*f**3*s**2 - 244*C*D1*Dd*f**3*s + 130*C*D1*Dd*f**3 - 672*C*D1*Dd*f**2*fd*r**2 - 1344*C*D1*Dd*f**2*fd*r*s + 952*C*D1*Dd*f**2*fd*r - 672*C*D1*Dd*f**2*fd*s**2 + 952*C*D1*Dd*f**2*fd*s - 336*C*D1*Dd*f**2*fd - 112*C*D1*Ddd*f**3*r**2 - 224*C*D1*Ddd*f**3*r*s + 168*C*D1*Ddd*f**3*r - 112*C*D1*Ddd*f**3*s**2 + 168*C*D1*Ddd*f**3*s - 84*C*D1*Ddd*f**3 - 336*C*Dd**2*f**3*r**2 - 672*C*Dd**2*f**3*r*s + 504*C*Dd**2*f**3*r - 336*C*Dd**2*f**3*s**2 + 504*C*Dd**2*f**3*s - 168*C*Dd**2*f**3 + 98*D1**2*K*b1*f*fd*r**2 + 140*D1**2*K*b1*f*fd*r*s - 70*D1**2*K*b1*f*fd*r + 42*D1**2*K*b1*f*fd*s**2 - 42*D1**2*K*b1*f*fd*s + 21*D1**2*K*b1*f*fd - 84*D1**2*K*b1*f*fdd*r**2 - 168*D1**2*K*b1*f*fdd*r*s + 84*D1**2*K*b1*f*fdd*r - 84*D1**2*K*b1*f*fdd*s**2 + 84*D1**2*K*b1*f*fdd*s - 42*D1**2*K*b1*f*fdd - 84*D1**2*K*b1*fd**2*r**2 - 168*D1**2*K*b1*fd**2*r*s + 84*D1**2*K*b1*fd**2*r - 84*D1**2*K*b1*fd**2*s**2 + 84*D1**2*K*b1*fd**2*s - 42*D1**2*K*bdd1*f**2*r**2 - 84*D1**2*K*bdd1*f**2*r*s + 84*D1**2*K*bdd1*f**2*r - 42*D1**2*K*bdd1*f**2*s**2 + 84*D1**2*K*bdd1*f**2*s - 42*D1**2*K*bdd1*f**2 - 40*D1**2*b1**2*f*fd*r**2 - 80*D1**2*b1**2*f*fd*r*s - 40*D1**2*b1**2*f*fd*s**2 + 20*D1**2*b1**2*f*fdd*r**2 + 40*D1**2*b1**2*f*fdd*r*s + 20*D1**2*b1**2*f*fdd*s**2 + 20*D1**2*b1**2*fd**2*r**2 + 40*D1**2*b1**2*fd**2*r*s + 20*D1**2*b1**2*fd**2*s**2 - 20*D1**2*b1**2*fd**2 + 20*D1**2*b1*bdd1*f**2*r**2 + 40*D1**2*b1*bdd1*f**2*r*s - 60*D1**2*b1*bdd1*f**2*r + 20*D1**2*b1*bdd1*f**2*s**2 - 60*D1**2*b1*bdd1*f**2*s + 30*D1**2*b1*bdd1*f**2 + 27*D1**2*b1*f**2*fd*r**2 - 24*D1**2*b1*f**2*fd*r*s - 30*D1**2*b1*f**2*fd*r - 51*D1**2*b1*f**2*fd*s**2 + 22*D1**2*b1*f**2*fd*s + 7*D1**2*b1*f**2*fd + 30*D1**2*b1*f**2*fdd*r**2 + 114*D1**2*b1*f**2*fdd*r*s - 44*D1**2*b1*f**2*fdd*r + 84*D1**2*b1*f**2*fdd*s**2 - 80*D1**2*b1*f**2*fdd*s + 24*D1**2*b1*f**2*fdd + 60*D1**2*b1*f*fd**2*r**2 + 228*D1**2*b1*f*fd**2*r*s - 88*D1**2*b1*f*fd**2*r + 168*D1**2*b1*f*fd**2*s**2 - 160*D1**2*b1*f*fd**2*s + 24*D1**2*b1*f*fd**2 - 24*D1**2*b1*f*fd*r**2 - 20*D1**2*b1*f*fd*r*s + 10*D1**2*b1*f*fd*r + 4*D1**2*b1*f*fd*s**2 - 4*D1**2*b1*f*fd*s + 2*D1**2*b1*f*fd + 12*D1**2*b1*f*fdd*r**2 + 24*D1**2*b1*f*fdd*r*s - 12*D1**2*b1*f*fdd*r + 12*D1**2*b1*f*fdd*s**2 - 12*D1**2*b1*f*fdd*s + 6*D1**2*b1*f*fdd + 12*D1**2*b1*fd**2*r**2 + 24*D1**2*b1*fd**2*r*s - 12*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 - 12*D1**2*b1*fd**2*s + 50*D1**2*b2*f*fd*r**2 + 100*D1**2*b2*f*fd*r*s - 50*D1**2*b2*f*fd*r + 50*D1**2*b2*f*fd*s**2 - 50*D1**2*b2*f*fd*s + 25*D1**2*b2*f*fd - 60*D1**2*b2*f*fdd*r**2 - 120*D1**2*b2*f*fdd*r*s + 60*D1**2*b2*f*fdd*r - 60*D1**2*b2*f*fdd*s**2 + 60*D1**2*b2*f*fdd*s - 30*D1**2*b2*f*fdd - 60*D1**2*b2*fd**2*r**2 - 120*D1**2*b2*fd**2*r*s + 60*D1**2*b2*fd**2*r - 60*D1**2*b2*fd**2*s**2 + 60*D1**2*b2*fd**2*s + 20*D1**2*bd1**2*f**2*(r**2 + r*(2*s - 3) + s**2 - 3*s + 2) + 10*D1**2*bdd1*f**3*r**2 + 38*D1**2*bdd1*f**3*r*s - 34*D1**2*bdd1*f**3*r + 28*D1**2*bdd1*f**3*s**2 - 52*D1**2*bdd1*f**3*s + 24*D1**2*bdd1*f**3 + 6*D1**2*bdd1*f**2*r**2 + 12*D1**2*bdd1*f**2*r*s - 12*D1**2*bdd1*f**2*r + 6*D1**2*bdd1*f**2*s**2 - 12*D1**2*bdd1*f**2*s + 6*D1**2*bdd1*f**2 - 30*D1**2*bdd2*f**2*r**2 - 60*D1**2*bdd2*f**2*r*s + 60*D1**2*bdd2*f**2*r - 30*D1**2*bdd2*f**2*s**2 + 60*D1**2*bdd2*f**2*s - 30*D1**2*bdd2*f**2 - 81*D1**2*f**2*fd*r**2 - 144*D1**2*f**2*fd*r*s + 102*D1**2*f**2*fd*r - 63*D1**2*f**2*fd*s**2 + 90*D1**2*f**2*fd*s - 48*D1**2*f**2*fd + 48*D1**2*f**2*fdd*r**2 + 96*D1**2*f**2*fdd*r*s - 64*D1**2*f**2*fdd*r + 48*D1**2*f**2*fdd*s**2 - 64*D1**2*f**2*fdd*s + 32*D1**2*f**2*fdd - 98*D1**2*f**2*gd2*r**2 - 140*D1**2*f**2*gd2*r*s + 196*D1**2*f**2*gd2*r - 42*D1**2*f**2*gd2*s**2 + 140*D1**2*f**2*gd2*s - 98*D1**2*f**2*gd2 + 84*D1**2*f**2*gdd2*r**2 + 168*D1**2*f**2*gdd2*r*s - 168*D1**2*f**2*gdd2*r + 84*D1**2*f**2*gdd2*s**2 - 168*D1**2*f**2*gdd2*s + 84*D1**2*f**2*gdd2 + 96*D1**2*f*fd**2*r**2 + 192*D1**2*f*fd**2*r*s - 128*D1**2*f*fd**2*r + 96*D1**2*f*fd**2*s**2 - 128*D1**2*f*fd**2*s + 32*D1**2*f*fd**2 - 196*D1**2*f*fd*g2*r**2 - 280*D1**2*f*fd*g2*r*s + 140*D1**2*f*fd*g2*r - 84*D1**2*f*fd*g2*s**2 + 84*D1**2*f*fd*g2*s - 42*D1**2*f*fd*g2 + 336*D1**2*f*fd*gd2*r**2 + 672*D1**2*f*fd*gd2*r*s - 504*D1**2*f*fd*gd2*r + 336*D1**2*f*fd*gd2*s**2 - 504*D1**2*f*fd*gd2*s + 168*D1**2*f*fd*gd2 + 168*D1**2*f*fdd*g2*r**2 + 336*D1**2*f*fdd*g2*r*s - 168*D1**2*f*fdd*g2*r + 168*D1**2*f*fdd*g2*s**2 - 168*D1**2*f*fdd*g2*s + 84*D1**2*f*fdd*g2 + 168*D1**2*fd**2*g2*r**2 + 336*D1**2*fd**2*g2*r*s - 168*D1**2*fd**2*g2*r + 168*D1**2*fd**2*g2*s**2 - 168*D1**2*fd**2*g2*s + 196*D1*Dd*K*b1*f**2*r**2 + 280*D1*Dd*K*b1*f**2*r*s - 266*D1*Dd*K*b1*f**2*r + 84*D1*Dd*K*b1*f**2*s**2 - 182*D1*Dd*K*b1*f**2*s + 119*D1*Dd*K*b1*f**2 - 672*D1*Dd*K*b1*f*fd*r**2 - 1344*D1*Dd*K*b1*f*fd*r*s + 840*D1*Dd*K*b1*f*fd*r - 672*D1*Dd*K*b1*f*fd*s**2 + 840*D1*Dd*K*b1*f*fd*s - 252*D1*Dd*K*b1*f*fd - 80*D1*Dd*b1**2*f**2*r**2 - 160*D1*Dd*b1**2*f**2*r*s + 120*D1*Dd*b1**2*f**2*r - 80*D1*Dd*b1**2*f**2*s**2 + 120*D1*Dd*b1**2*f**2*s - 60*D1*Dd*b1**2*f**2 + 160*D1*Dd*b1**2*f*fd*r**2 + 320*D1*Dd*b1**2*f*fd*r*s - 120*D1*Dd*b1**2*f*fd*r + 160*D1*Dd*b1**2*f*fd*s**2 - 120*D1*Dd*b1**2*f*fd*s + 36*D1*Dd*b1*f**3*r**2 - 32*D1*Dd*b1*f**3*r*s - 28*D1*Dd*b1*f**3*r - 68*D1*Dd*b1*f**3*s**2 + 50*D1*Dd*b1*f**3*s + D1*Dd*b1*f**3 + 240*D1*Dd*b1*f**2*fd*r**2 + 912*D1*Dd*b1*f**2*fd*r*s - 410*D1*Dd*b1*f**2*fd*r + 672*D1*Dd*b1*f**2*fd*s**2 - 716*D1*Dd*b1*f**2*fd*s + 168*D1*Dd*b1*f**2*fd - 48*D1*Dd*b1*f**2*r**2 - 40*D1*Dd*b1*f**2*r*s + 58*D1*Dd*b1*f**2*r + 8*D1*Dd*b1*f**2*s**2 + 16*D1*Dd*b1*f**2*s - 22*D1*Dd*b1*f**2 + 96*D1*Dd*b1*f*fd*r**2 + 192*D1*Dd*b1*f*fd*r*s - 120*D1*Dd*b1*f*fd*r + 96*D1*Dd*b1*f*fd*s**2 - 120*D1*Dd*b1*f*fd*s + 36*D1*Dd*b1*f*fd + 100*D1*Dd*b2*f**2*r**2 + 200*D1*Dd*b2*f**2*r*s - 150*D1*Dd*b2*f**2*r + 100*D1*Dd*b2*f**2*s**2 - 150*D1*Dd*b2*f**2*s + 75*D1*Dd*b2*f**2 - 480*D1*Dd*b2*f*fd*r**2 - 960*D1*Dd*b2*f*fd*r*s + 600*D1*Dd*b2*f*fd*r - 480*D1*Dd*b2*f*fd*s**2 + 600*D1*Dd*b2*f*fd*s - 180*D1*Dd*b2*f*fd - 108*D1*Dd*f**3*r**2 - 192*D1*Dd*f**3*r*s + 156*D1*Dd*f**3*r - 84*D1*Dd*f**3*s**2 + 138*D1*Dd*f**3*s - 75*D1*Dd*f**3 + 384*D1*Dd*f**2*fd*r**2 + 768*D1*Dd*f**2*fd*r*s - 544*D1*Dd*f**2*fd*r + 384*D1*Dd*f**2*fd*s**2 - 544*D1*Dd*f**2*fd*s + 192*D1*Dd*f**2*fd - 392*D1*Dd*f**2*g2*r**2 - 560*D1*Dd*f**2*g2*r*s + 532*D1*Dd*f**2*g2*r - 168*D1*Dd*f**2*g2*s**2 + 364*D1*Dd*f**2*g2*s - 238*D1*Dd*f**2*g2 + 672*D1*Dd*f**2*gd2*r**2 + 1344*D1*Dd*f**2*gd2*r*s - 1176*D1*Dd*f**2*gd2*r + 672*D1*Dd*f**2*gd2*s**2 - 1176*D1*Dd*f**2*gd2*s + 504*D1*Dd*f**2*gd2 + 1344*D1*Dd*f*fd*g2*r**2 + 2688*D1*Dd*f*fd*g2*r*s - 1680*D1*Dd*f*fd*g2*r + 1344*D1*Dd*f*fd*g2*s**2 - 1680*D1*Dd*f*fd*g2*s + 504*D1*Dd*f*fd*g2 - 168*D1*Ddd*K*b1*f**2*r**2 - 336*D1*Ddd*K*b1*f**2*r*s + 252*D1*Ddd*K*b1*f**2*r - 168*D1*Ddd*K*b1*f**2*s**2 + 252*D1*Ddd*K*b1*f**2*s - 126*D1*Ddd*K*b1*f**2 + 40*D1*Ddd*b1**2*f**2*r**2 + 80*D1*Ddd*b1**2*f**2*r*s - 60*D1*Ddd*b1**2*f**2*r + 40*D1*Ddd*b1**2*f**2*s**2 - 60*D1*Ddd*b1**2*f**2*s + 30*D1*Ddd*b1**2*f**2 + 40*D1*Ddd*b1*f**3*r**2 + 152*D1*Ddd*b1*f**3*r*s - 78*D1*Ddd*b1*f**3*r + 112*D1*Ddd*b1*f**3*s**2 - 132*D1*Ddd*b1*f**3*s + 48*D1*Ddd*b1*f**3 + 24*D1*Ddd*b1*f**2*r**2 + 48*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r + 24*D1*Ddd*b1*f**2*s**2 - 36*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 - 120*D1*Ddd*b2*f**2*r**2 - 240*D1*Ddd*b2*f**2*r*s + 180*D1*Ddd*b2*f**2*r - 120*D1*Ddd*b2*f**2*s**2 + 180*D1*Ddd*b2*f**2*s - 90*D1*Ddd*b2*f**2 + 64*D1*Ddd*f**3*r**2 + 128*D1*Ddd*f**3*r*s - 96*D1*Ddd*f**3*r + 64*D1*Ddd*f**3*s**2 - 96*D1*Ddd*f**3*s + 48*D1*Ddd*f**3 + 336*D1*Ddd*f**2*g2*r**2 + 672*D1*Ddd*f**2*g2*r*s - 504*D1*Ddd*f**2*g2*r + 336*D1*Ddd*f**2*g2*s**2 - 504*D1*Ddd*f**2*g2*s + 252*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(f**2*(9*r**2 + r*(2 - 8*s) - 17*s**2 + 28*s - 6) + f*(-20*b1*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + 2*fd*(30*r**2 + r*(114*s - 73) + 84*s**2 - 118*s + 36) + (r + s - 1)*(7*K*(7*r + 3*s - 7) - 12*r + 2*s + 12)) + 4*fd*(-21*K + 10*b1 + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(10*b1*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + f*(40*r**2 + 152*r*s - 107*r + 112*s**2 - 170*s + 60) + (6 - 42*K)*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3))) + 5*D1*bd2*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 504*Dd**2*K*b1*f**2*r**2 - 1008*Dd**2*K*b1*f**2*r*s + 756*Dd**2*K*b1*f**2*r - 504*Dd**2*K*b1*f**2*s**2 + 756*Dd**2*K*b1*f**2*s - 252*Dd**2*K*b1*f**2 + 120*Dd**2*b1**2*f**2*r**2 + 240*Dd**2*b1**2*f**2*r*s - 180*Dd**2*b1**2*f**2*r + 120*Dd**2*b1**2*f**2*s**2 - 180*Dd**2*b1**2*f**2*s + 60*Dd**2*b1**2*f**2 + 120*Dd**2*b1*f**3*r**2 + 456*Dd**2*b1*f**3*r*s - 234*Dd**2*b1*f**3*r + 336*Dd**2*b1*f**3*s**2 - 396*Dd**2*b1*f**3*s + 96*Dd**2*b1*f**3 + 72*Dd**2*b1*f**2*r**2 + 144*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r + 72*Dd**2*b1*f**2*s**2 - 108*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 - 360*Dd**2*b2*f**2*r**2 - 720*Dd**2*b2*f**2*r*s + 540*Dd**2*b2*f**2*r - 360*Dd**2*b2*f**2*s**2 + 540*Dd**2*b2*f**2*s - 180*Dd**2*b2*f**2 + 192*Dd**2*f**3*r**2 + 384*Dd**2*f**3*r*s - 288*Dd**2*f**3*r + 192*Dd**2*f**3*s**2 - 288*Dd**2*f**3*s + 96*Dd**2*f**3 + 1008*Dd**2*f**2*g2*r**2 + 2016*Dd**2*f**2*g2*r*s - 1512*Dd**2*f**2*g2*r + 1008*Dd**2*f**2*g2*s**2 - 1512*Dd**2*f**2*g2*s + 504*Dd**2*f**2*g2)/(70*d**2*k3**5) - D1**2*Pk2*Pkd3*k1**2*k2**2*st**2*(1332*C*D1**2*bd1*f**2*r**2 + 2928*C*D1**2*bd1*f**2*r*s - 2868*C*D1**2*bd1*f**2*r + 1596*C*D1**2*bd1*f**2*s**2 - 3132*C*D1**2*bd1*f**2*s + 1566*C*D1**2*bd1*f**2 - 2664*C*D1**2*bd1*f*fd*r**2 - 6192*C*D1**2*bd1*f*fd*r*s + 4608*C*D1**2*bd1*f*fd*r - 3528*C*D1**2*bd1*f*fd*s**2 + 5256*C*D1**2*bd1*f*fd*s - 1728*C*D1**2*bd1*f*fd - 666*C*D1**2*bdd1*f**2*r**2 - 1548*C*D1**2*bdd1*f**2*r*s + 1728*C*D1**2*bdd1*f**2*r - 882*C*D1**2*bdd1*f**2*s**2 + 1944*C*D1**2*bdd1*f**2*s - 972*C*D1**2*bdd1*f**2 - 132*C*D1**2*f**2*fd*r**2 + 408*C*D1**2*f**2*fd*r*s - 48*C*D1**2*f**2*fd*r + 540*C*D1**2*f**2*fd*s**2 - 496*C*D1**2*f**2*fd*s + 136*C*D1**2*f**2*fd - 366*C*D1**2*f**2*fdd*r**2 - 1284*C*D1**2*f**2*fdd*r*s + 672*C*D1**2*f**2*fdd*r - 918*C*D1**2*f**2*fdd*s**2 + 1040*C*D1**2*f**2*fdd*s - 428*C*D1**2*f**2*fdd - 732*C*D1**2*f*fd**2*r**2 - 2568*C*D1**2*f*fd**2*r*s + 1344*C*D1**2*f*fd**2*r - 1836*C*D1**2*f*fd**2*s**2 + 2080*C*D1**2*f*fd**2*s - 428*C*D1**2*f*fd**2 - 5328*C*D1*Dd*bd1*f**2*r**2 - 12384*C*D1*Dd*bd1*f**2*r*s + 11124*C*D1*Dd*bd1*f**2*r - 7056*C*D1*Dd*bd1*f**2*s**2 + 12636*C*D1*Dd*bd1*f**2*s - 5400*C*D1*Dd*bd1*f**2 - 176*C*D1*Dd*f**3*r**2 + 544*C*D1*Dd*f**3*r*s + 40*C*D1*Dd*f**3*r + 720*C*D1*Dd*f**3*s**2 - 632*C*D1*Dd*f**3*s + 92*C*D1*Dd*f**3 - 2928*C*D1*Dd*f**2*fd*r**2 - 10272*C*D1*Dd*f**2*fd*r*s + 5436*C*D1*Dd*f**2*fd*r - 7344*C*D1*Dd*f**2*fd*s**2 + 8564*C*D1*Dd*f**2*fd*s - 2384*C*D1*Dd*f**2*fd - 488*C*D1*Ddd*f**3*r**2 - 1712*C*D1*Ddd*f**3*r*s + 916*C*D1*Ddd*f**3*r - 1224*C*D1*Ddd*f**3*s**2 + 1468*C*D1*Ddd*f**3*s - 550*C*D1*Ddd*f**3 - 1464*C*Dd**2*f**3*r**2 - 5136*C*Dd**2*f**3*r*s + 2748*C*Dd**2*f**3*r - 3672*C*Dd**2*f**3*s**2 + 4404*C*Dd**2*f**3*s - 1100*C*Dd**2*f**3 - 1554*D1**2*K*bd1**2*f*r**2 - 3612*D1**2*K*bd1**2*f*r*s + 3570*D1**2*K*bd1**2*f*r - 2058*D1**2*K*bd1**2*f*s**2 + 4074*D1**2*K*bd1**2*f*s - 2016*D1**2*K*bd1**2*f - 126*D1**2*K*bd1*f**2*r**2 + 84*D1**2*K*bd1*f**2*r*s + 252*D1**2*K*bd1*f**2*r + 210*D1**2*K*bd1*f**2*s**2 - 84*D1**2*K*bd1*f**2*s - 126*D1**2*K*bd1*f**2 - 420*D1**2*K*bd1*f*fd*r**2 - 1848*D1**2*K*bd1*f*fd*r*s + 882*D1**2*K*bd1*f*fd*r - 1428*D1**2*K*bd1*f*fd*s**2 + 1638*D1**2*K*bd1*f*fd*s - 462*D1**2*K*bd1*f*fd - 105*D1**2*K*bdd1*f**2*r**2 - 462*D1**2*K*bdd1*f**2*r*s + 210*D1**2*K*bdd1*f**2*r - 357*D1**2*K*bdd1*f**2*s**2 + 462*D1**2*K*bdd1*f**2*s - 105*D1**2*K*bdd1*f**2 + 1386*D1**2*bd1**2*f**2*r**2 + 2268*D1**2*bd1**2*f**2*r*s - 2520*D1**2*bd1**2*f**2*r + 882*D1**2*bd1**2*f**2*s**2 - 2016*D1**2*bd1**2*f**2*s + 1134*D1**2*bd1**2*f**2 + 252*D1**2*bd1**2*f*r**2 + 504*D1**2*bd1**2*f*r*s - 504*D1**2*bd1**2*f*r + 252*D1**2*bd1**2*f*s**2 - 504*D1**2*bd1**2*f*s + 252*D1**2*bd1**2*f - 1260*D1**2*bd1*bd2*f*r**2 - 2520*D1**2*bd1*bd2*f*r*s + 2520*D1**2*bd1*bd2*f*r - 1260*D1**2*bd1*bd2*f*s**2 + 2520*D1**2*bd1*bd2*f*s - 1260*D1**2*bd1*bd2*f - 732*D1**2*bd1*f**2*r**2 - 1596*D1**2*bd1*f**2*r*s + 1524*D1**2*bd1*f**2*r - 864*D1**2*bd1*f**2*s**2 + 1656*D1**2*bd1*f**2*s - 807*D1**2*bd1*f**2 + 1548*D1**2*bd1*f*fd*r**2 + 3528*D1**2*bd1*f*fd*r*s - 2628*D1**2*bd1*f*fd*r + 1980*D1**2*bd1*f*fd*s**2 - 2952*D1**2*bd1*f*fd*s + 972*D1**2*bd1*f*fd - 3108*D1**2*bd1*f*g2*r**2 - 6384*D1**2*bd1*f*g2*r*s + 5124*D1**2*bd1*f*g2*r - 3276*D1**2*bd1*f*g2*s**2 + 5292*D1**2*bd1*f*g2*s - 2646*D1**2*bd1*f*g2 + 3108*D1**2*bd1*f*gd2*r**2 + 7224*D1**2*bd1*f*gd2*r*s - 7140*D1**2*bd1*f*gd2*r + 4116*D1**2*bd1*f*gd2*s**2 - 8148*D1**2*bd1*f*gd2*s + 4032*D1**2*bd1*f*gd2 + 3108*D1**2*bd1*fd*g2*r**2 + 7224*D1**2*bd1*fd*g2*r*s - 3612*D1**2*bd1*fd*g2*r + 4116*D1**2*bd1*fd*g2*s**2 - 4116*D1**2*bd1*fd*g2*s - 105*D1**2*bd2*f**2*r**2 - 210*D1**2*bd2*f**2*r*s + 210*D1**2*bd2*f**2*r - 105*D1**2*bd2*f**2*s**2 + 210*D1**2*bd2*f**2*s - 105*D1**2*bd2*f**2 + 387*D1**2*bdd1*f**2*r**2 + 882*D1**2*bdd1*f**2*r*s - 972*D1**2*bdd1*f**2*r + 495*D1**2*bdd1*f**2*s**2 - 1080*D1**2*bdd1*f**2*s + 540*D1**2*bdd1*f**2 + 1554*D1**2*bdd1*f*g2*r**2 + 3612*D1**2*bdd1*f*g2*r*s - 4032*D1**2*bdd1*f*g2*r + 2058*D1**2*bdd1*f*g2*s**2 - 4536*D1**2*bdd1*f*g2*s + 2268*D1**2*bdd1*f*g2 + 120*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s - 30*D1**2*f**2*fd*r - 270*D1**2*f**2*fd*s**2 + 230*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 183*D1**2*f**2*fdd*r**2 + 642*D1**2*f**2*fdd*r*s - 336*D1**2*f**2*fdd*r + 459*D1**2*f**2*fdd*s**2 - 520*D1**2*f**2*fdd*s + 214*D1**2*f**2*fdd + 252*D1**2*f**2*gd2*r**2 - 168*D1**2*f**2*gd2*r*s - 504*D1**2*f**2*gd2*r - 420*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s + 252*D1**2*f**2*gd2 + 210*D1**2*f**2*gdd2*r**2 + 924*D1**2*f**2*gdd2*r*s - 420*D1**2*f**2*gdd2*r + 714*D1**2*f**2*gdd2*s**2 - 924*D1**2*f**2*gdd2*s + 210*D1**2*f**2*gdd2 + 366*D1**2*f*fd**2*r**2 + 1284*D1**2*f*fd**2*r*s - 672*D1**2*f*fd**2*r + 918*D1**2*f*fd**2*s**2 - 1040*D1**2*f*fd**2*s + 214*D1**2*f*fd**2 + 504*D1**2*f*fd*g2*r**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r - 840*D1**2*f*fd*g2*s**2 + 840*D1**2*f*fd*g2*s - 420*D1**2*f*fd*g2 + 840*D1**2*f*fd*gd2*r**2 + 3696*D1**2*f*fd*gd2*r*s - 1764*D1**2*f*fd*gd2*r + 2856*D1**2*f*fd*gd2*s**2 - 3276*D1**2*f*fd*gd2*s + 924*D1**2*f*fd*gd2 + 420*D1**2*f*fdd*g2*r**2 + 1848*D1**2*f*fdd*g2*r*s - 924*D1**2*f*fdd*g2*r + 1428*D1**2*f*fdd*g2*s**2 - 1428*D1**2*f*fdd*g2*s + 714*D1**2*f*fdd*g2 + 420*D1**2*fd**2*g2*r**2 + 1848*D1**2*fd**2*g2*r*s - 924*D1**2*fd**2*g2*r + 1428*D1**2*fd**2*g2*s**2 - 1428*D1**2*fd**2*g2*s - 840*D1*Dd*K*bd1*f**2*r**2 - 3696*D1*Dd*K*bd1*f**2*r*s + 1722*D1*Dd*K*bd1*f**2*r - 2856*D1*Dd*K*bd1*f**2*s**2 + 3486*D1*Dd*K*bd1*f**2*s - 882*D1*Dd*K*bd1*f**2 + 3096*D1*Dd*bd1*f**2*r**2 + 7056*D1*Dd*bd1*f**2*r*s - 6318*D1*Dd*bd1*f**2*r + 3960*D1*Dd*bd1*f**2*s**2 - 7074*D1*Dd*bd1*f**2*s + 3024*D1*Dd*bd1*f**2 + 12432*D1*Dd*bd1*f*g2*r**2 + 28896*D1*Dd*bd1*f*g2*r*s - 25956*D1*Dd*bd1*f*g2*r + 16464*D1*Dd*bd1*f*g2*s**2 - 29484*D1*Dd*bd1*f*g2*s + 12600*D1*Dd*bd1*f*g2 + 160*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s - 110*D1*Dd*f**3*r - 360*D1*Dd*f**3*s**2 + 280*D1*Dd*f**3*s - 10*D1*Dd*f**3 + 1464*D1*Dd*f**2*fd*r**2 + 5136*D1*Dd*f**2*fd*r*s - 2718*D1*Dd*f**2*fd*r + 3672*D1*Dd*f**2*fd*s**2 - 4282*D1*Dd*f**2*fd*s + 1192*D1*Dd*f**2*fd + 1008*D1*Dd*f**2*g2*r**2 - 672*D1*Dd*f**2*g2*r*s - 840*D1*Dd*f**2*g2*r - 1680*D1*Dd*f**2*g2*s**2 + 1176*D1*Dd*f**2*g2*s + 84*D1*Dd*f**2*g2 + 1680*D1*Dd*f**2*gd2*r**2 + 7392*D1*Dd*f**2*gd2*r*s - 3444*D1*Dd*f**2*gd2*r + 5712*D1*Dd*f**2*gd2*s**2 - 6972*D1*Dd*f**2*gd2*s + 1764*D1*Dd*f**2*gd2 + 3360*D1*Dd*f*fd*g2*r**2 + 14784*D1*Dd*f*fd*g2*r*s - 7224*D1*Dd*f*fd*g2*r + 11424*D1*Dd*f*fd*g2*s**2 - 12264*D1*Dd*f*fd*g2*s + 3276*D1*Dd*f*fd*g2 + 244*D1*Ddd*f**3*r**2 + 856*D1*Ddd*f**3*r*s - 458*D1*Ddd*f**3*r + 612*D1*Ddd*f**3*s**2 - 734*D1*Ddd*f**3*s + 275*D1*Ddd*f**3 + 840*D1*Ddd*f**2*g2*r**2 + 3696*D1*Ddd*f**2*g2*r*s - 1764*D1*Ddd*f**2*g2*r + 2856*D1*Ddd*f**2*g2*s**2 - 3276*D1*Ddd*f**2*g2*s + 1134*D1*Ddd*f**2*g2 + 105*D1*b2*(bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 732*Dd**2*f**3*r**2 + 2568*Dd**2*f**3*r*s - 1374*Dd**2*f**3*r + 1836*Dd**2*f**3*s**2 - 2202*Dd**2*f**3*s + 550*Dd**2*f**3 + 2520*Dd**2*f**2*g2*r**2 + 11088*Dd**2*f**2*g2*r*s - 5292*Dd**2*f**2*g2*r + 8568*Dd**2*f**2*g2*s**2 - 9828*Dd**2*f**2*g2*s + 2268*Dd**2*f**2*g2 + 315*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 21*b1**2*(74*D1**2*K*fd*r**2 + 152*D1**2*K*fd*r*s - 30*D1**2*K*fd*r + 78*D1**2*K*fd*s**2 - 30*D1**2*K*fd*s + 15*D1**2*K*fd - 37*D1**2*K*fdd*r**2 - 86*D1**2*K*fdd*r*s - 10*D1**2*K*fdd*r - 49*D1**2*K*fdd*s**2 - 10*D1**2*K*fdd*s + 5*D1**2*K*fdd - 15*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 34*D1**2*f*fd*r**2 - 44*D1**2*f*fd*r*s + 34*D1**2*f*fd*r - 10*D1**2*f*fd*s**2 + 22*D1**2*f*fd*s - 17*D1**2*f*fd + 66*D1**2*f*fdd*r**2 + 108*D1**2*f*fdd*r*s - 66*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 33*D1**2*f*fdd + 66*D1**2*fd**2*r**2 + 108*D1**2*fd**2*r*s - 66*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s - 12*D1**2*fd*r**2 - 14*D1**2*fd*r*s - 2*D1**2*fd*s**2 + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 + 296*D1*Dd*K*f*r**2 + 608*D1*Dd*K*f*r*s - 448*D1*Dd*K*f*r + 312*D1*Dd*K*f*s**2 - 460*D1*Dd*K*f*s + 226*D1*Dd*K*f - 296*D1*Dd*K*fd*r**2 - 688*D1*Dd*K*fd*r*s + 194*D1*Dd*K*fd*r - 392*D1*Dd*K*fd*s**2 + 230*D1*Dd*K*fd*s + 30*D1*Dd*K*fd - 68*D1*Dd*f**2*r**2 - 88*D1*Dd*f**2*r*s + 90*D1*Dd*f**2*r - 20*D1*Dd*f**2*s**2 + 54*D1*Dd*f**2*s - 39*D1*Dd*f**2 + 528*D1*Dd*f*fd*r**2 + 864*D1*Dd*f*fd*r*s - 636*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 516*D1*Dd*f*fd*s + 186*D1*Dd*f*fd - 48*D1*Dd*f*r**2 - 56*D1*Dd*f*r*s + 62*D1*Dd*f*r - 8*D1*Dd*f*s**2 + 32*D1*Dd*f*s - 26*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 36*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 36*D1*Dd*fd*s - 148*D1*Ddd*K*f*r**2 - 344*D1*Ddd*K*f*r*s + 234*D1*Ddd*K*f*r - 196*D1*Ddd*K*f*s**2 + 270*D1*Ddd*K*f*s - 123*D1*Ddd*K*f + 132*D1*Ddd*f**2*r**2 + 216*D1*Ddd*f**2*r*s - 186*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 87*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f + 30*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 444*Dd**2*K*f*r**2 - 1032*Dd**2*K*f*r*s + 702*Dd**2*K*f*r - 588*Dd**2*K*f*s**2 + 810*Dd**2*K*f*s - 246*Dd**2*K*f + 396*Dd**2*f**2*r**2 + 648*Dd**2*f**2*r*s - 558*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 174*Dd**2*f**2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f) - 3*b1*(-888*C*D1**2*f*fd*r**2 - 1952*C*D1**2*f*fd*r*s + 908*C*D1**2*f*fd*r - 1064*C*D1**2*f*fd*s**2 + 996*C*D1**2*f*fd*s - 454*C*D1**2*f*fd + 444*C*D1**2*f*fdd*r**2 + 1032*C*D1**2*f*fdd*r*s - 384*C*D1**2*f*fdd*r + 588*C*D1**2*f*fdd*s**2 - 456*C*D1**2*f*fdd*s + 192*C*D1**2*f*fdd + 444*C*D1**2*fd**2*r**2 + 1032*C*D1**2*fd**2*r*s - 384*C*D1**2*fd**2*r + 588*C*D1**2*fd**2*s**2 - 456*C*D1**2*fd**2*s - 60*C*D1**2*fd**2 - 1776*C*D1*Dd*f**2*r**2 - 3904*C*D1*Dd*f**2*r*s + 2752*C*D1*Dd*f**2*r - 2128*C*D1*Dd*f**2*s**2 + 3016*C*D1*Dd*f**2*s - 1420*C*D1*Dd*f**2 + 3552*C*D1*Dd*f*fd*r**2 + 8256*C*D1*Dd*f*fd*r*s - 4344*C*D1*Dd*f*fd*r + 4704*C*D1*Dd*f*fd*s**2 - 5064*C*D1*Dd*f*fd*s + 1224*C*D1*Dd*f*fd + 888*C*D1*Ddd*f**2*r**2 + 2064*C*D1*Ddd*f**2*r*s - 1404*C*D1*Ddd*f**2*r + 1176*C*D1*Ddd*f**2*s**2 - 1620*C*D1*Ddd*f**2*s + 738*C*D1*Ddd*f**2 + 2664*C*Dd**2*f**2*r**2 + 6192*C*Dd**2*f**2*r*s - 4212*C*Dd**2*f**2*r + 3528*C*Dd**2*f**2*s**2 - 4860*C*Dd**2*f**2*s + 1476*C*Dd**2*f**2 + 518*D1**2*K*bdd1*f*r**2 + 1204*D1**2*K*bdd1*f*r*s - 1190*D1**2*K*bdd1*f*r + 686*D1**2*K*bdd1*f*s**2 - 1358*D1**2*K*bdd1*f*s + 637*D1**2*K*bdd1*f + 84*D1**2*K*f*fd*r**2 - 56*D1**2*K*f*fd*r*s + 28*D1**2*K*f*fd*r - 140*D1**2*K*f*fd*s**2 + 140*D1**2*K*f*fd*s - 70*D1**2*K*f*fd + 70*D1**2*K*f*fdd*r**2 + 308*D1**2*K*f*fdd*r*s - 154*D1**2*K*f*fdd*r + 238*D1**2*K*f*fdd*s**2 - 238*D1**2*K*f*fdd*s + 119*D1**2*K*f*fdd + 70*D1**2*K*fd**2*r**2 + 308*D1**2*K*fd**2*r*s - 154*D1**2*K*fd**2*r + 238*D1**2*K*fd**2*s**2 - 238*D1**2*K*fd**2*s - 245*D1**2*b2*fd*r**2 - 490*D1**2*b2*fd*r*s - 245*D1**2*b2*fd*s**2 + 210*D1**2*b2*fdd*r**2 + 420*D1**2*b2*fdd*r*s + 210*D1**2*b2*fdd*s**2 + 210*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 462*D1**2*bdd1*f**2*r**2 - 756*D1**2*bdd1*f**2*r*s + 840*D1**2*bdd1*f**2*r - 294*D1**2*bdd1*f**2*s**2 + 672*D1**2*bdd1*f**2*s - 378*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*r**2 - 168*D1**2*bdd1*f*r*s + 168*D1**2*bdd1*f*r - 84*D1**2*bdd1*f*s**2 + 168*D1**2*bdd1*f*s - 84*D1**2*bdd1*f + 210*D1**2*bdd2*f*r**2 + 420*D1**2*bdd2*f*r*s - 420*D1**2*bdd2*f*r + 210*D1**2*bdd2*f*s**2 - 420*D1**2*bdd2*f*s + 210*D1**2*bdd2*f + 488*D1**2*f*fd*r**2 + 1064*D1**2*f*fd*r*s - 512*D1**2*f*fd*r + 576*D1**2*f*fd*s**2 - 556*D1**2*f*fd*s + 263*D1**2*f*fd - 258*D1**2*f*fdd*r**2 - 588*D1**2*f*fdd*r*s + 228*D1**2*f*fdd*r - 330*D1**2*f*fdd*s**2 + 264*D1**2*f*fdd*s - 114*D1**2*f*fdd + 1036*D1**2*f*gd2*r**2 + 2128*D1**2*f*gd2*r*s - 2072*D1**2*f*gd2*r + 1092*D1**2*f*gd2*s**2 - 2128*D1**2*f*gd2*s + 1036*D1**2*f*gd2 - 518*D1**2*f*gdd2*r**2 - 1204*D1**2*f*gdd2*r*s + 1036*D1**2*f*gdd2*r - 686*D1**2*f*gdd2*s**2 + 1204*D1**2*f*gdd2*s - 518*D1**2*f*gdd2 - 258*D1**2*fd**2*r**2 - 588*D1**2*fd**2*r*s + 228*D1**2*fd**2*r - 330*D1**2*fd**2*s**2 + 264*D1**2*fd**2*s + 30*D1**2*fd**2 + 1036*D1**2*fd*g2*r**2 + 2128*D1**2*fd*g2*r*s - 420*D1**2*fd*g2*r + 1092*D1**2*fd*g2*s**2 - 420*D1**2*fd*g2*s + 210*D1**2*fd*g2 - 1036*D1**2*fd*gd2*r**2 - 2408*D1**2*fd*gd2*r*s + 896*D1**2*fd*gd2*r - 1372*D1**2*fd*gd2*s**2 + 1064*D1**2*fd*gd2*s + 140*D1**2*fd*gd2 - 518*D1**2*fdd*g2*r**2 - 1204*D1**2*fdd*g2*r*s - 140*D1**2*fdd*g2*r - 686*D1**2*fdd*g2*s**2 - 140*D1**2*fdd*g2*s + 70*D1**2*fdd*g2 + 168*D1*Dd*K*f**2*r**2 - 112*D1*Dd*K*f**2*r*s - 140*D1*Dd*K*f**2*r - 280*D1*Dd*K*f**2*s**2 + 196*D1*Dd*K*f**2*s + 14*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*r**2 + 2464*D1*Dd*K*f*fd*r*s - 1204*D1*Dd*K*f*fd*r + 1904*D1*Dd*K*f*fd*s**2 - 2044*D1*Dd*K*f*fd*s + 546*D1*Dd*K*f*fd - 980*D1*Dd*b2*f*r**2 - 1960*D1*Dd*b2*f*r*s + 1470*D1*Dd*b2*f*r - 980*D1*Dd*b2*f*s**2 + 1470*D1*Dd*b2*f*s - 735*D1*Dd*b2*f + 1680*D1*Dd*b2*fd*r**2 + 3360*D1*Dd*b2*fd*r*s - 1260*D1*Dd*b2*fd*r + 1680*D1*Dd*b2*fd*s**2 - 1260*D1*Dd*b2*fd*s + 976*D1*Dd*f**2*r**2 + 2128*D1*Dd*f**2*r*s - 1508*D1*Dd*f**2*r + 1152*D1*Dd*f**2*s**2 - 1640*D1*Dd*f**2*s + 776*D1*Dd*f**2 - 2064*D1*Dd*f*fd*r**2 - 4704*D1*Dd*f*fd*r*s + 2532*D1*Dd*f*fd*r - 2640*D1*Dd*f*fd*s**2 + 2892*D1*Dd*f*fd*s - 720*D1*Dd*f*fd + 4144*D1*Dd*f*g2*r**2 + 8512*D1*Dd*f*g2*r*s - 6272*D1*Dd*f*g2*r + 4368*D1*Dd*f*g2*s**2 - 6440*D1*Dd*f*g2*s + 3164*D1*Dd*f*g2 - 4144*D1*Dd*f*gd2*r**2 - 9632*D1*Dd*f*gd2*r*s + 7420*D1*Dd*f*gd2*r - 5488*D1*Dd*f*gd2*s**2 + 8596*D1*Dd*f*gd2*s - 3276*D1*Dd*f*gd2 - 4144*D1*Dd*fd*g2*r**2 - 9632*D1*Dd*fd*g2*r*s + 2716*D1*Dd*fd*g2*r - 5488*D1*Dd*fd*g2*s**2 + 3220*D1*Dd*fd*g2*s + 420*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*r**2 + 616*D1*Ddd*K*f**2*r*s - 294*D1*Ddd*K*f**2*r + 476*D1*Ddd*K*f**2*s**2 - 546*D1*Ddd*K*f**2*s + 189*D1*Ddd*K*f**2 + 840*D1*Ddd*b2*f*r**2 + 1680*D1*Ddd*b2*f*r*s - 1260*D1*Ddd*b2*f*r + 840*D1*Ddd*b2*f*s**2 - 1260*D1*Ddd*b2*f*s + 630*D1*Ddd*b2*f - 516*D1*Ddd*f**2*r**2 - 1176*D1*Ddd*f**2*r*s + 810*D1*Ddd*f**2*r - 660*D1*Ddd*f**2*s**2 + 918*D1*Ddd*f**2*s - 423*D1*Ddd*f**2 - 2072*D1*Ddd*f*g2*r**2 - 4816*D1*Ddd*f*g2*r*s + 3276*D1*Ddd*f*g2*r - 2744*D1*Ddd*f*g2*s**2 + 3780*D1*Ddd*f*g2*s - 1722*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(2*f**2*(17*r**2 + r*(22*s - 28) + 5*s**2 - 16*s + 11) - f*(K*(148*r**2 + 304*r*s - 270*r + 156*s**2 - 278*s + 137) + 12*fd*(22*r**2 + r*(36*s - 31) + 14*s**2 - 25*s + 10) - 24*r**2 - 28*r*s + 38*r - 4*s**2 + 18*s - 14) + 2*fd*(K*(74*r**2 + r*(172*s - 75) + 98*s**2 - 87*s - 5) - 12*r**2 - 12*r*(2*s - 1) - 12*s*(s - 1))) - 2*Dd*f*(-K*(296*r**2 + 688*r*s - 574*r + 392*s**2 - 658*s + 267) + 6*f*(44*r**2 + r*(72*s - 71) + 28*s**2 - 57*s + 28) + 48*r**2 + 96*r*s - 84*r + 48*s**2 - 84*s + 36)) - 35*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 420*Dd**2*K*f**2*r**2 + 1848*Dd**2*K*f**2*r*s - 882*Dd**2*K*f**2*r + 1428*Dd**2*K*f**2*s**2 - 1638*Dd**2*K*f**2*s + 378*Dd**2*K*f**2 + 2520*Dd**2*b2*f*r**2 + 5040*Dd**2*b2*f*r*s - 3780*Dd**2*b2*f*r + 2520*Dd**2*b2*f*s**2 - 3780*Dd**2*b2*f*s + 1260*Dd**2*b2*f - 1548*Dd**2*f**2*r**2 - 3528*Dd**2*f**2*r*s + 2430*Dd**2*f**2*r - 1980*Dd**2*f**2*s**2 + 2754*Dd**2*f**2*s - 846*Dd**2*f**2 - 6216*Dd**2*f*g2*r**2 - 14448*Dd**2*f*g2*r*s + 9828*Dd**2*f*g2*r - 8232*Dd**2*f*g2*s**2 + 11340*Dd**2*f*g2*s - 3444*Dd**2*f*g2))/(630*d**2*k3**5) + D1**2*Pk2*Pkd3*k1**2*k2**2*(D1*(175*D1*b2*bd1*f*(r + s - 1)**2 + 70*D1*bd1**2*(r + s - 1)*(5*K*f*(r + s - 1) - f*(6*C - 3)*(r + s) + 10*g2*(r + s)) + D1*bdd1*f*(f*(6*C - 3)*(43*r + 35*s - 35) - 350*g2*(r + s - 1))*(r + s - 1) + 2*bd1*(D1*(3*f**2*(r + s - 1)*(26*C*r + 42*C*(s - 1) - 20*r - 21*s + 21) + f*(fd*(6*C - 3)*(86*r**2 + r*(156*s - 121) + 70*s**2 - 109*s + 39) + (-210*g2 - 350*gd2)*(r + s - 1)**2) - 350*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + Dd*f*(f*(6*C - 3)*(172*r**2 + r*(312*s - 281) + 140*s**2 - 253*s + 113) - 350*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 175*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(-K + f) - Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 35*b1**2*(D1**2*(-5*K*bdd1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + fd*(2*C*(r + s - 1)**2 + 6*K*s**2 + r**2*(6*K - 3) + 2*r*(6*K*s - 2*s + 1) - s**2 + 2*s - 1) + fdd*(-6*C*(r + s - 1)**2 + 5*K*s**2 + r**2*(5*K + 3) + 2*r*(5*K*s + 3*s - 3) + 3*s**2 - 6*s + 3) + 10*gd2*(r + s - 1)**2 + 10*gdd2*(r + s - 1)**2) + 5*D1*bd1*(D1*(-K + f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(f*(2*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*r**2 - 16*r*s + 16*r - 4*s**2 + 10*s - 7) + 2*fd*(4*r + 4*s - 3)*(-6*C*(r + s - 1) + 5*K*s + r*(5*K + 3) + 3*s - 3) + 10*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 20*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*(f*(-6*C + 5*K + 3) + 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(-6*C + 5*K + 3) + 10*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-420*C*D1**2*bdd1*f*r**2 - 840*C*D1**2*bdd1*f*r*s + 420*C*D1**2*bdd1*f*r - 420*C*D1**2*bdd1*f*s**2 + 420*C*D1**2*bdd1*f*s - 210*C*D1**2*bdd1*f + 312*C*D1**2*f*fd*r**2 + 816*C*D1**2*f*fd*r*s - 312*C*D1**2*f*fd*r + 504*C*D1**2*f*fd*s**2 - 408*C*D1**2*f*fd*s + 156*C*D1**2*f*fd + 516*C*D1**2*f*fdd*r**2 + 936*C*D1**2*f*fdd*r*s - 516*C*D1**2*f*fdd*r + 420*C*D1**2*f*fdd*s**2 - 468*C*D1**2*f*fdd*s + 258*C*D1**2*f*fdd + 516*C*D1**2*fd**2*r**2 + 936*C*D1**2*fd**2*r*s - 516*C*D1**2*fd**2*r + 420*C*D1**2*fd**2*s**2 - 468*C*D1**2*fd**2*s + 624*C*D1*Dd*f**2*r**2 + 1632*C*D1*Dd*f**2*r*s - 1032*C*D1*Dd*f**2*r + 1008*C*D1*Dd*f**2*s**2 - 1320*C*D1*Dd*f**2*s + 564*C*D1*Dd*f**2 + 4128*C*D1*Dd*f*fd*r**2 + 7488*C*D1*Dd*f*fd*r*s - 5064*C*D1*Dd*f*fd*r + 3360*C*D1*Dd*f*fd*s**2 - 4584*C*D1*Dd*f*fd*s + 1500*C*D1*Dd*f*fd + 1032*C*D1*Ddd*f**2*r**2 + 1872*C*D1*Ddd*f**2*r*s - 1500*C*D1*Ddd*f**2*r + 840*C*D1*Ddd*f**2*s**2 - 1356*C*D1*Ddd*f**2*s + 726*C*D1*Ddd*f**2 + 3096*C*Dd**2*f**2*r**2 + 5616*C*Dd**2*f**2*r*s - 4500*C*Dd**2*f**2*r + 2520*C*Dd**2*f**2*s**2 - 4068*C*Dd**2*f**2*s + 1452*C*Dd**2*f**2 - 350*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 350*D1**2*K*bdd1*f*r**2 + 700*D1**2*K*bdd1*f*r*s - 700*D1**2*K*bdd1*f*r + 350*D1**2*K*bdd1*f*s**2 - 700*D1**2*K*bdd1*f*s + 350*D1**2*K*bdd1*f + 175*D1**2*b2*fd*r**2 + 350*D1**2*b2*fd*r*s + 175*D1**2*b2*fd*s**2 + 175*D1**2*bd2*f*(r + s - 1)**2 + 210*D1**2*bdd1*f*r**2 + 420*D1**2*bdd1*f*r*s - 210*D1**2*bdd1*f*r + 210*D1**2*bdd1*f*s**2 - 210*D1**2*bdd1*f*s + 105*D1**2*bdd1*f + 700*D1**2*bdd1*g2*r**2 + 1400*D1**2*bdd1*g2*r*s - 700*D1**2*bdd1*g2*r + 700*D1**2*bdd1*g2*s**2 - 700*D1**2*bdd1*g2*s + 350*D1**2*bdd1*g2 - 240*D1**2*f*fd*r**2 - 492*D1**2*f*fd*r*s + 240*D1**2*f*fd*r - 252*D1**2*f*fd*s**2 + 246*D1**2*f*fd*s - 120*D1**2*f*fd - 258*D1**2*f*fdd*r**2 - 468*D1**2*f*fdd*r*s + 258*D1**2*f*fdd*r - 210*D1**2*f*fdd*s**2 + 234*D1**2*f*fdd*s - 129*D1**2*f*fdd - 420*D1**2*f*gd2*r**2 - 840*D1**2*f*gd2*r*s + 840*D1**2*f*gd2*r - 420*D1**2*f*gd2*s**2 + 840*D1**2*f*gd2*s - 420*D1**2*f*gd2 - 350*D1**2*f*gdd2*r**2 - 700*D1**2*f*gdd2*r*s + 700*D1**2*f*gdd2*r - 350*D1**2*f*gdd2*s**2 + 700*D1**2*f*gdd2*s - 350*D1**2*f*gdd2 - 258*D1**2*fd**2*r**2 - 468*D1**2*fd**2*r*s + 258*D1**2*fd**2*r - 210*D1**2*fd**2*s**2 + 234*D1**2*fd**2*s - 420*D1**2*fd*g2*r**2 - 840*D1**2*fd*g2*r*s - 420*D1**2*fd*g2*s**2 - 700*D1**2*fd*gd2*r**2 - 1400*D1**2*fd*gd2*r*s + 700*D1**2*fd*gd2*r - 700*D1**2*fd*gd2*s**2 + 700*D1**2*fd*gd2*s - 350*D1**2*fdd*g2*r**2 - 700*D1**2*fdd*g2*r*s - 350*D1**2*fdd*g2*s**2 + 700*D1*Dd*b2*f*r**2 + 1400*D1*Dd*b2*f*r*s - 1050*D1*Dd*b2*f*r + 700*D1*Dd*b2*f*s**2 - 1050*D1*Dd*b2*f*s + 525*D1*Dd*b2*f - 480*D1*Dd*f**2*r**2 - 984*D1*Dd*f**2*r*s + 726*D1*Dd*f**2*r - 504*D1*Dd*f**2*s**2 + 744*D1*Dd*f**2*s - 366*D1*Dd*f**2 - 2064*D1*Dd*f*fd*r**2 - 3744*D1*Dd*f*fd*r*s + 2532*D1*Dd*f*fd*r - 1680*D1*Dd*f*fd*s**2 + 2292*D1*Dd*f*fd*s - 750*D1*Dd*f*fd - 1680*D1*Dd*f*g2*r**2 - 3360*D1*Dd*f*g2*r*s + 2520*D1*Dd*f*g2*r - 1680*D1*Dd*f*g2*s**2 + 2520*D1*Dd*f*g2*s - 1260*D1*Dd*f*g2 - 2800*D1*Dd*f*gd2*r**2 - 5600*D1*Dd*f*gd2*r*s + 4900*D1*Dd*f*gd2*r - 2800*D1*Dd*f*gd2*s**2 + 4900*D1*Dd*f*gd2*s - 2100*D1*Dd*f*gd2 - 2800*D1*Dd*fd*g2*r**2 - 5600*D1*Dd*fd*g2*r*s + 2100*D1*Dd*fd*g2*r - 2800*D1*Dd*fd*g2*s**2 + 2100*D1*Dd*fd*g2*s - 516*D1*Ddd*f**2*r**2 - 936*D1*Ddd*f**2*r*s + 750*D1*Ddd*f**2*r - 420*D1*Ddd*f**2*s**2 + 678*D1*Ddd*f**2*s - 363*D1*Ddd*f**2 - 1400*D1*Ddd*f*g2*r**2 - 2800*D1*Ddd*f*g2*r*s + 2100*D1*Ddd*f*g2*r - 1400*D1*Ddd*f*g2*s**2 + 2100*D1*Ddd*f*g2*s - 1050*D1*Ddd*f*g2 + 35*D1*bd1*(D1*(f*(C*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) + 12*K*(r + s - 1)**2 - 6*r**2 - 8*r*s + 8*r - 2*s**2 + 4*s - 3) + 2*fd*(r + s - 1)*(-6*C*(2*r + 2*s - 1) + 10*K*r + 10*K*s + 6*r + 6*s - 3) + 10*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(6*C*(2*r + 2*s - 1) - 10*K*(r + s - 1) - 6*r - 6*s + 3) - 10*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 1548*Dd**2*f**2*r**2 - 2808*Dd**2*f**2*r*s + 2250*Dd**2*f**2*r - 1260*Dd**2*f**2*s**2 + 2034*Dd**2*f**2*s - 726*Dd**2*f**2 - 4200*Dd**2*f*g2*r**2 - 8400*Dd**2*f*g2*r*s + 6300*Dd**2*f*g2*r - 4200*Dd**2*f*g2*s**2 + 6300*Dd**2*f*g2*s - 2100*Dd**2*f*g2))/(210*d**2*k3**5) + D1**2*Pk2*Pkd3*k1**2*st**4*(-48*C*D1**2*f**2*fd*r*s + 16*C*D1**2*f**2*fd*r - 48*C*D1**2*f**2*fd*s**2 + 48*C*D1**2*f**2*fd*s - 16*C*D1**2*f**2*fd + 24*C*D1**2*f**2*fdd*r*s - 8*C*D1**2*f**2*fdd*r + 24*C*D1**2*f**2*fdd*s**2 - 24*C*D1**2*f**2*fdd*s + 8*C*D1**2*f**2*fdd + 48*C*D1**2*f*fd**2*r*s - 16*C*D1**2*f*fd**2*r + 48*C*D1**2*f*fd**2*s**2 - 48*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 64*C*D1*Dd*f**3*r*s + 16*C*D1*Dd*f**3*r - 64*C*D1*Dd*f**3*s**2 + 64*C*D1*Dd*f**3*s - 16*C*D1*Dd*f**3 + 192*C*D1*Dd*f**2*fd*r*s - 56*C*D1*Dd*f**2*fd*r + 192*C*D1*Dd*f**2*fd*s**2 - 192*C*D1*Dd*f**2*fd*s + 40*C*D1*Dd*f**2*fd + 32*C*D1*Ddd*f**3*r*s - 8*C*D1*Ddd*f**3*r + 32*C*D1*Ddd*f**3*s**2 - 32*C*D1*Ddd*f**3*s + 8*C*D1*Ddd*f**3 + 96*C*Dd**2*f**3*r*s - 24*C*Dd**2*f**3*r + 96*C*Dd**2*f**3*s**2 - 96*C*Dd**2*f**3*s + 16*C*Dd**2*f**3 - 48*D1**2*K*b1*f*fd*r*s + 24*D1**2*K*b1*f*fd*r - 48*D1**2*K*b1*f*fd*s**2 + 48*D1**2*K*b1*f*fd*s - 24*D1**2*K*b1*f*fd + 24*D1**2*K*b1*f*fdd*r*s - 12*D1**2*K*b1*f*fdd*r + 24*D1**2*K*b1*f*fdd*s**2 - 24*D1**2*K*b1*f*fdd*s + 12*D1**2*K*b1*f*fdd + 24*D1**2*K*b1*fd**2*r*s - 12*D1**2*K*b1*fd**2*r + 24*D1**2*K*b1*fd**2*s**2 - 24*D1**2*K*b1*fd**2*s + 8*D1**2*b1**2*f*fd*r**2 + 48*D1**2*b1**2*f*fd*r*s + 40*D1**2*b1**2*f*fd*s**2 - 8*D1**2*b1**2*f*fd*s - 8*D1**2*b1**2*f*fd - 4*D1**2*b1**2*f*fdd*r**2 - 24*D1**2*b1**2*f*fdd*r*s - 20*D1**2*b1**2*f*fdd*s**2 + 4*D1**2*b1**2*f*fdd*s + 4*D1**2*b1**2*f*fdd - 4*D1**2*b1**2*fd**2*r**2 - 24*D1**2*b1**2*fd**2*r*s - 20*D1**2*b1**2*fd**2*s**2 + 4*D1**2*b1**2*fd**2*s + 4*D1**2*b1**2*fd**2 - 63*D1**2*b1*f**2*fd*r**2 - 228*D1**2*b1*f**2*fd*r*s + 136*D1**2*b1*f**2*fd*r - 165*D1**2*b1*f**2*fd*s**2 + 210*D1**2*b1*f**2*fd*s - 85*D1**2*b1*f**2*fd + 81*D1**2*b1*f**2*fdd*r**2 + 192*D1**2*b1*f**2*fdd*r*s - 140*D1**2*b1*f**2*fdd*r + 111*D1**2*b1*f**2*fdd*s**2 - 158*D1**2*b1*f**2*fdd*s + 75*D1**2*b1*f**2*fdd + 162*D1**2*b1*f*fd**2*r**2 + 384*D1**2*b1*f*fd**2*r*s - 280*D1**2*b1*f*fd**2*r + 222*D1**2*b1*f*fd**2*s**2 - 316*D1**2*b1*f*fd**2*s + 106*D1**2*b1*f*fd**2 - 24*D1**2*b1*f*fd*r**2 - 20*D1**2*b1*f*fd*r*s + 10*D1**2*b1*f*fd*r + 4*D1**2*b1*f*fd*s**2 - 4*D1**2*b1*f*fd*s + 2*D1**2*b1*f*fd + 12*D1**2*b1*f*fdd*r**2 + 24*D1**2*b1*f*fdd*r*s - 12*D1**2*b1*f*fdd*r + 12*D1**2*b1*f*fdd*s**2 - 12*D1**2*b1*f*fdd*s + 6*D1**2*b1*f*fdd + 12*D1**2*b1*fd**2*r**2 + 24*D1**2*b1*fd**2*r*s - 12*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 - 12*D1**2*b1*fd**2*s - 48*D1**2*b2*f*fd*r*s + 24*D1**2*b2*f*fd*r - 48*D1**2*b2*f*fd*s**2 + 48*D1**2*b2*f*fd*s - 24*D1**2*b2*f*fd + 24*D1**2*b2*f*fdd*r*s - 12*D1**2*b2*f*fdd*r + 24*D1**2*b2*f*fdd*s**2 - 24*D1**2*b2*f*fdd*s + 12*D1**2*b2*f*fdd + 24*D1**2*b2*fd**2*r*s - 12*D1**2*b2*fd**2*r + 24*D1**2*b2*fd**2*s**2 - 24*D1**2*b2*fd**2*s - 4*D1**2*bd1**2*f**2*(r**2 + r*(6*s - 5) + 5*s**2 - 10*s + 3) - 24*D1**2*bd2*f**2*r*s - 24*D1**2*bd2*f**2*s**2 + 24*D1**2*bd2*f**2*s + 48*D1**2*bd2*f*fd*r*s - 12*D1**2*bd2*f*fd*r + 48*D1**2*bd2*f*fd*s**2 - 48*D1**2*bd2*f*fd*s + 12*D1**2*bd2*f*fd + D1**2*bdd1*f**2*(-2*b1*(2*r**2 + 2*r*(6*s - 5) + 10*s**2 - 20*s + 9) + f*(27*r**2 + 64*r*s - 32*r + 37*s**2 - 44*s + 16) + (6*r + 6*s - 6)*(2*K*s + r + s - 1)) + 12*D1**2*bdd2*f**2*r*s + 12*D1**2*bdd2*f**2*s**2 - 12*D1**2*bdd2*f**2*s - 12*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 14*D1**2*f**2*fd*s + 2*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 - 4*D1**2*f**2*fdd*r - 6*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s + 48*D1**2*f**2*gd2*r*s + 48*D1**2*f**2*gd2*s**2 - 48*D1**2*f**2*gd2*s - 24*D1**2*f**2*gdd2*r*s - 24*D1**2*f**2*gdd2*s**2 + 24*D1**2*f**2*gdd2*s + 12*D1**2*f*fd**2*r**2 - 8*D1**2*f*fd**2*r - 12*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s + 96*D1**2*f*fd*g2*r*s - 48*D1**2*f*fd*g2*r + 96*D1**2*f*fd*g2*s**2 - 96*D1**2*f*fd*g2*s + 48*D1**2*f*fd*g2 - 96*D1**2*f*fd*gd2*r*s + 24*D1**2*f*fd*gd2*r - 96*D1**2*f*fd*gd2*s**2 + 96*D1**2*f*fd*gd2*s - 24*D1**2*f*fd*gd2 - 48*D1**2*f*fdd*g2*r*s + 24*D1**2*f*fdd*g2*r - 48*D1**2*f*fdd*g2*s**2 + 48*D1**2*f*fdd*g2*s - 24*D1**2*f*fdd*g2 - 48*D1**2*fd**2*g2*r*s + 24*D1**2*fd**2*g2*r - 48*D1**2*fd**2*g2*s**2 + 48*D1**2*fd**2*g2*s - 96*D1*Dd*K*b1*f**2*r*s + 24*D1*Dd*K*b1*f**2*r - 96*D1*Dd*K*b1*f**2*s**2 + 96*D1*Dd*K*b1*f**2*s - 24*D1*Dd*K*b1*f**2 + 192*D1*Dd*K*b1*f*fd*r*s - 72*D1*Dd*K*b1*f*fd*r + 192*D1*Dd*K*b1*f*fd*s**2 - 192*D1*Dd*K*b1*f*fd*s + 48*D1*Dd*K*b1*f*fd + 16*D1*Dd*b1**2*f**2*r**2 + 96*D1*Dd*b1**2*f**2*r*s - 40*D1*Dd*b1**2*f**2*r + 80*D1*Dd*b1**2*f**2*s**2 - 88*D1*Dd*b1**2*f**2*s + 28*D1*Dd*b1**2*f**2 - 32*D1*Dd*b1**2*f*fd*r**2 - 192*D1*Dd*b1**2*f*fd*r*s + 40*D1*Dd*b1**2*f*fd*r - 160*D1*Dd*b1**2*f*fd*s**2 + 104*D1*Dd*b1**2*f*fd*s - 4*D1*Dd*b1**2*f*fd - 84*D1*Dd*b1*f**3*r**2 - 304*D1*Dd*b1*f**3*r*s + 160*D1*Dd*b1*f**3*r - 220*D1*Dd*b1*f**3*s**2 + 262*D1*Dd*b1*f**3*s - 97*D1*Dd*b1*f**3 + 648*D1*Dd*b1*f**2*fd*r**2 + 1536*D1*Dd*b1*f**2*fd*r*s - 1076*D1*Dd*b1*f**2*fd*r + 888*D1*Dd*b1*f**2*fd*s**2 - 1238*D1*Dd*b1*f**2*fd*s + 438*D1*Dd*b1*f**2*fd - 48*D1*Dd*b1*f**2*r**2 - 40*D1*Dd*b1*f**2*r*s + 58*D1*Dd*b1*f**2*r + 8*D1*Dd*b1*f**2*s**2 + 16*D1*Dd*b1*f**2*s - 22*D1*Dd*b1*f**2 + 96*D1*Dd*b1*f*fd*r**2 + 192*D1*Dd*b1*f*fd*r*s - 120*D1*Dd*b1*f*fd*r + 96*D1*Dd*b1*f*fd*s**2 - 120*D1*Dd*b1*f*fd*s + 36*D1*Dd*b1*f*fd - 96*D1*Dd*b2*f**2*r*s + 24*D1*Dd*b2*f**2*r - 96*D1*Dd*b2*f**2*s**2 + 96*D1*Dd*b2*f**2*s - 24*D1*Dd*b2*f**2 + 192*D1*Dd*b2*f*fd*r*s - 72*D1*Dd*b2*f*fd*r + 192*D1*Dd*b2*f*fd*s**2 - 192*D1*Dd*b2*f*fd*s + 48*D1*Dd*b2*f*fd + 96*D1*Dd*bd2*f**2*r*s - 12*D1*Dd*bd2*f**2*r + 96*D1*Dd*bd2*f**2*s**2 - 96*D1*Dd*bd2*f**2*s + 12*D1*Dd*bd2*f**2 - 16*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s + 14*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 16*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 - 40*D1*Dd*f**2*fd*r - 48*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s + 4*D1*Dd*f**2*fd + 192*D1*Dd*f**2*g2*r*s - 48*D1*Dd*f**2*g2*r + 192*D1*Dd*f**2*g2*s**2 - 192*D1*Dd*f**2*g2*s + 48*D1*Dd*f**2*g2 - 192*D1*Dd*f**2*gd2*r*s + 24*D1*Dd*f**2*gd2*r - 192*D1*Dd*f**2*gd2*s**2 + 192*D1*Dd*f**2*gd2*s - 24*D1*Dd*f**2*gd2 - 384*D1*Dd*f*fd*g2*r*s + 144*D1*Dd*f*fd*g2*r - 384*D1*Dd*f*fd*g2*s**2 + 384*D1*Dd*f*fd*g2*s - 96*D1*Dd*f*fd*g2 + 48*D1*Ddd*K*b1*f**2*r*s - 12*D1*Ddd*K*b1*f**2*r + 48*D1*Ddd*K*b1*f**2*s**2 - 48*D1*Ddd*K*b1*f**2*s + 12*D1*Ddd*K*b1*f**2 - 8*D1*Ddd*b1**2*f**2*r**2 - 48*D1*Ddd*b1**2*f**2*r*s + 20*D1*Ddd*b1**2*f**2*r - 40*D1*Ddd*b1**2*f**2*s**2 + 44*D1*Ddd*b1**2*f**2*s - 14*D1*Ddd*b1**2*f**2 + 108*D1*Ddd*b1*f**3*r**2 + 256*D1*Ddd*b1*f**3*r*s - 172*D1*Ddd*b1*f**3*r + 148*D1*Ddd*b1*f**3*s**2 - 202*D1*Ddd*b1*f**3*s + 91*D1*Ddd*b1*f**3 + 24*D1*Ddd*b1*f**2*r**2 + 48*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r + 24*D1*Ddd*b1*f**2*s**2 - 36*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 + 48*D1*Ddd*b2*f**2*r*s - 12*D1*Ddd*b2*f**2*r + 48*D1*Ddd*b2*f**2*s**2 - 48*D1*Ddd*b2*f**2*s + 12*D1*Ddd*b2*f**2 + 8*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r - 8*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s + 2*D1*Ddd*f**3 - 96*D1*Ddd*f**2*g2*r*s + 24*D1*Ddd*f**2*g2*r - 96*D1*Ddd*f**2*g2*s**2 + 96*D1*Ddd*f**2*g2*s - 24*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(-f**2*(21*r**2 + 4*r*(19*s - 6) + 55*s**2 - 52*s + 12) + 2*f*(2*b1*(2*r**2 + 2*r*(6*s - 5) + 10*s**2 - 20*s + 9) + fd*(81*r**2 + 2*r*(96*s - 59) + 111*s**2 - 145*s + 38) - (r + s - 1)*(12*K*s + 6*r - s - 6)) - 4*fd*(-3*K*(r*(4*s - 1) + (1 - 2*s)**2) + b1*(4*r**2 + 2*r*(12*s - 5) + 20*s**2 - 22*s + 5) - 6*r**2 - 12*r*s + 9*r - 6*s**2 + 9*s - 3)) + 2*Dd*f*(6*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 4*b1*(4*r**2 + 3*r*(8*s - 5) + 20*s**2 - 31*s + 10) + f*(108*r**2 + 2*r*(128*s - 75) + 148*s**2 - 189*s + 54) + 24*r**2 + 48*r*s - 42*r + 24*s**2 - 42*s + 18)) + 144*Dd**2*K*b1*f**2*r*s - 36*Dd**2*K*b1*f**2*r + 144*Dd**2*K*b1*f**2*s**2 - 144*Dd**2*K*b1*f**2*s + 24*Dd**2*K*b1*f**2 - 24*Dd**2*b1**2*f**2*r**2 - 144*Dd**2*b1**2*f**2*r*s + 60*Dd**2*b1**2*f**2*r - 120*Dd**2*b1**2*f**2*s**2 + 132*Dd**2*b1**2*f**2*s - 28*Dd**2*b1**2*f**2 + 324*Dd**2*b1*f**3*r**2 + 768*Dd**2*b1*f**3*r*s - 516*Dd**2*b1*f**3*r + 444*Dd**2*b1*f**3*s**2 - 606*Dd**2*b1*f**3*s + 182*Dd**2*b1*f**3 + 72*Dd**2*b1*f**2*r**2 + 144*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r + 72*Dd**2*b1*f**2*s**2 - 108*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 + 144*Dd**2*b2*f**2*r*s - 36*Dd**2*b2*f**2*r + 144*Dd**2*b2*f**2*s**2 - 144*Dd**2*b2*f**2*s + 24*Dd**2*b2*f**2 + 24*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r - 24*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s + 4*Dd**2*f**3 - 288*Dd**2*f**2*g2*r*s + 72*Dd**2*f**2*g2*r - 288*Dd**2*f**2*g2*s**2 + 288*Dd**2*f**2*g2*s - 48*Dd**2*f**2*g2)/(70*d**2*k3**3) + D1**2*Pk2*Pkd3*k1**2*st**2*(18*C*D1**2*bdd1*f**2*r**2 + 108*C*D1**2*bdd1*f**2*r*s + 90*C*D1**2*bdd1*f**2*s**2 + 354*C*D1**2*f**2*fd*r**2 + 1380*C*D1**2*f**2*fd*r*s - 696*C*D1**2*f**2*fd*r + 1026*C*D1**2*f**2*fd*s**2 - 1144*C*D1**2*f**2*fd*s + 460*C*D1**2*f**2*fd - 366*C*D1**2*f**2*fdd*r**2 - 1284*C*D1**2*f**2*fdd*r*s + 672*C*D1**2*f**2*fdd*r - 918*C*D1**2*f**2*fdd*s**2 + 1040*C*D1**2*f**2*fdd*s - 428*C*D1**2*f**2*fdd - 732*C*D1**2*f*fd**2*r**2 - 2568*C*D1**2*f*fd**2*r*s + 1344*C*D1**2*f*fd**2*r - 1836*C*D1**2*f*fd**2*s**2 + 2080*C*D1**2*f*fd**2*s - 428*C*D1**2*f*fd**2 + 472*C*D1*Dd*f**3*r**2 + 1840*C*D1*Dd*f**3*r*s - 932*C*D1*Dd*f**3*r + 1368*C*D1*Dd*f**3*s**2 - 1604*C*D1*Dd*f**3*s + 578*C*D1*Dd*f**3 - 2928*C*D1*Dd*f**2*fd*r**2 - 10272*C*D1*Dd*f**2*fd*r*s + 5436*C*D1*Dd*f**2*fd*r - 7344*C*D1*Dd*f**2*fd*s**2 + 8564*C*D1*Dd*f**2*fd*s - 2384*C*D1*Dd*f**2*fd - 488*C*D1*Ddd*f**3*r**2 - 1712*C*D1*Ddd*f**3*r*s + 916*C*D1*Ddd*f**3*r - 1224*C*D1*Ddd*f**3*s**2 + 1468*C*D1*Ddd*f**3*s - 550*C*D1*Ddd*f**3 - 1464*C*Dd**2*f**3*r**2 - 5136*C*Dd**2*f**3*r*s + 2748*C*Dd**2*f**3*r - 3672*C*Dd**2*f**3*s**2 + 4404*C*Dd**2*f**3*s - 1100*C*Dd**2*f**3 - 105*D1**2*K*bdd1*f**2*r**2 - 462*D1**2*K*bdd1*f**2*r*s + 210*D1**2*K*bdd1*f**2*r - 357*D1**2*K*bdd1*f**2*s**2 + 462*D1**2*K*bdd1*f**2*s - 105*D1**2*K*bdd1*f**2 + 21*D1**2*b2*bdd1*f*r**2 + 42*D1**2*b2*bdd1*f*r*s + 21*D1**2*b2*bdd1*f*s**2 + 126*D1**2*b2*f*fd*r**2 + 924*D1**2*b2*f*fd*r*s - 462*D1**2*b2*f*fd*r + 798*D1**2*b2*f*fd*s**2 - 798*D1**2*b2*f*fd*s + 399*D1**2*b2*f*fd - 210*D1**2*b2*f*fdd*r**2 - 924*D1**2*b2*f*fdd*r*s + 462*D1**2*b2*f*fdd*r - 714*D1**2*b2*f*fdd*s**2 + 714*D1**2*b2*f*fdd*s - 357*D1**2*b2*f*fdd - 210*D1**2*b2*fd**2*r**2 - 924*D1**2*b2*fd**2*r*s + 462*D1**2*b2*fd**2*r - 714*D1**2*b2*fd**2*s**2 + 714*D1**2*b2*fd**2*s + 42*D1**2*bd1**2*f*(5*K*s**2 - 3*K*s + f*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + r**2*(K + 6) + r*(6*K*s - K + 10*s - 12) + 4*s**2 - 11*s + 6) + 63*D1**2*bd2*f**2*r**2 + 462*D1**2*bd2*f**2*r*s - 126*D1**2*bd2*f**2*r + 399*D1**2*bd2*f**2*s**2 - 462*D1**2*bd2*f**2*s + 63*D1**2*bd2*f**2 - 420*D1**2*bd2*f*fd*r**2 - 1848*D1**2*bd2*f*fd*r*s + 882*D1**2*bd2*f*fd*r - 1428*D1**2*bd2*f*fd*s**2 + 1638*D1**2*bd2*f*fd*s - 462*D1**2*bd2*f*fd + 45*D1**2*bdd1*f**2*r**2 + 36*D1**2*bdd1*f**2*r*s - 108*D1**2*bdd1*f**2*r - 9*D1**2*bdd1*f**2*s**2 - 108*D1**2*bdd1*f**2*s + 54*D1**2*bdd1*f**2 - 42*D1**2*bdd1*f*g2*r**2 - 252*D1**2*bdd1*f*g2*r*s - 210*D1**2*bdd1*f*g2*s**2 - 105*D1**2*bdd2*f**2*r**2 - 462*D1**2*bdd2*f**2*r*s + 210*D1**2*bdd2*f**2*r - 357*D1**2*bdd2*f**2*s**2 + 462*D1**2*bdd2*f**2*s - 105*D1**2*bdd2*f**2 - 123*D1**2*f**2*fd*r**2 - 636*D1**2*f**2*fd*r*s + 294*D1**2*f**2*fd*r - 513*D1**2*f**2*fd*s**2 + 554*D1**2*f**2*fd*s - 212*D1**2*f**2*fd + 183*D1**2*f**2*fdd*r**2 + 642*D1**2*f**2*fdd*r*s - 336*D1**2*f**2*fdd*r + 459*D1**2*f**2*fdd*s**2 - 520*D1**2*f**2*fdd*s + 214*D1**2*f**2*fdd - 126*D1**2*f**2*gd2*r**2 - 924*D1**2*f**2*gd2*r*s + 252*D1**2*f**2*gd2*r - 798*D1**2*f**2*gd2*s**2 + 924*D1**2*f**2*gd2*s - 126*D1**2*f**2*gd2 + 210*D1**2*f**2*gdd2*r**2 + 924*D1**2*f**2*gdd2*r*s - 420*D1**2*f**2*gdd2*r + 714*D1**2*f**2*gdd2*s**2 - 924*D1**2*f**2*gdd2*s + 210*D1**2*f**2*gdd2 + 366*D1**2*f*fd**2*r**2 + 1284*D1**2*f*fd**2*r*s - 672*D1**2*f*fd**2*r + 918*D1**2*f*fd**2*s**2 - 1040*D1**2*f*fd**2*s + 214*D1**2*f*fd**2 - 252*D1**2*f*fd*g2*r**2 - 1848*D1**2*f*fd*g2*r*s + 924*D1**2*f*fd*g2*r - 1596*D1**2*f*fd*g2*s**2 + 1596*D1**2*f*fd*g2*s - 798*D1**2*f*fd*g2 + 840*D1**2*f*fd*gd2*r**2 + 3696*D1**2*f*fd*gd2*r*s - 1764*D1**2*f*fd*gd2*r + 2856*D1**2*f*fd*gd2*s**2 - 3276*D1**2*f*fd*gd2*s + 924*D1**2*f*fd*gd2 + 420*D1**2*f*fdd*g2*r**2 + 1848*D1**2*f*fdd*g2*r*s - 924*D1**2*f*fdd*g2*r + 1428*D1**2*f*fdd*g2*s**2 - 1428*D1**2*f*fdd*g2*s + 714*D1**2*f*fdd*g2 + 420*D1**2*fd**2*g2*r**2 + 1848*D1**2*fd**2*g2*r*s - 924*D1**2*fd**2*g2*r + 1428*D1**2*fd**2*g2*s**2 - 1428*D1**2*fd**2*g2*s + 252*D1*Dd*b2*f**2*r**2 + 1848*D1*Dd*b2*f**2*r*s - 714*D1*Dd*b2*f**2*r + 1596*D1*Dd*b2*f**2*s**2 - 1722*D1*Dd*b2*f**2*s + 525*D1*Dd*b2*f**2 - 1680*D1*Dd*b2*f*fd*r**2 - 7392*D1*Dd*b2*f*fd*r*s + 3612*D1*Dd*b2*f*fd*r - 5712*D1*Dd*b2*f*fd*s**2 + 6132*D1*Dd*b2*f*fd*s - 1638*D1*Dd*b2*f*fd - 840*D1*Dd*bd2*f**2*r**2 - 3696*D1*Dd*bd2*f**2*r*s + 1722*D1*Dd*bd2*f**2*r - 2856*D1*Dd*bd2*f**2*s**2 + 3486*D1*Dd*bd2*f**2*s - 882*D1*Dd*bd2*f**2 - 164*D1*Dd*f**3*r**2 - 848*D1*Dd*f**3*r*s + 376*D1*Dd*f**3*r - 684*D1*Dd*f**3*s**2 + 766*D1*Dd*f**3*s - 253*D1*Dd*f**3 + 1464*D1*Dd*f**2*fd*r**2 + 5136*D1*Dd*f**2*fd*r*s - 2718*D1*Dd*f**2*fd*r + 3672*D1*Dd*f**2*fd*s**2 - 4282*D1*Dd*f**2*fd*s + 1192*D1*Dd*f**2*fd - 504*D1*Dd*f**2*g2*r**2 - 3696*D1*Dd*f**2*g2*r*s + 1428*D1*Dd*f**2*g2*r - 3192*D1*Dd*f**2*g2*s**2 + 3444*D1*Dd*f**2*g2*s - 1050*D1*Dd*f**2*g2 + 1680*D1*Dd*f**2*gd2*r**2 + 7392*D1*Dd*f**2*gd2*r*s - 3444*D1*Dd*f**2*gd2*r + 5712*D1*Dd*f**2*gd2*s**2 - 6972*D1*Dd*f**2*gd2*s + 1764*D1*Dd*f**2*gd2 + 3360*D1*Dd*f*fd*g2*r**2 + 14784*D1*Dd*f*fd*g2*r*s - 7224*D1*Dd*f*fd*g2*r + 11424*D1*Dd*f*fd*g2*s**2 - 12264*D1*Dd*f*fd*g2*s + 3276*D1*Dd*f*fd*g2 - 420*D1*Ddd*b2*f**2*r**2 - 1848*D1*Ddd*b2*f**2*r*s + 882*D1*Ddd*b2*f**2*r - 1428*D1*Ddd*b2*f**2*s**2 + 1638*D1*Ddd*b2*f**2*s - 567*D1*Ddd*b2*f**2 + 244*D1*Ddd*f**3*r**2 + 856*D1*Ddd*f**3*r*s - 458*D1*Ddd*f**3*r + 612*D1*Ddd*f**3*s**2 - 734*D1*Ddd*f**3*s + 275*D1*Ddd*f**3 + 840*D1*Ddd*f**2*g2*r**2 + 3696*D1*Ddd*f**2*g2*r*s - 1764*D1*Ddd*f**2*g2*r + 2856*D1*Ddd*f**2*g2*s**2 - 3276*D1*Ddd*f**2*g2*s + 1134*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(f**2*(10*C*s**2 + 7*K*(3*r**2 + r*(22*s - 6) + 19*s**2 - 22*s + 3) + r**2*(2*C - 23) + 2*r*(6*C*s - 26*s + 15) - 29*s**2 + 30*s - 8) + f*(-14*K*fd*(10*r**2 + r*(44*s - 21) + 34*s**2 - 39*s + 11) + 14*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 6*fd*(r**2*(4*C + 10) + r*(8*C*(3*s - 1) + 8*s - 13) + s**2*(20*C - 2) - s*(16*C + 7) + 6) - 28*gd2*(r**2 + r*(6*s - 1) + s*(5*s - 3)) + 7*(3*r + 3*s)*(b2*(r + s) - 2*g2*(r + 5*s))) + 14*fd*(b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(r**2 + r*(6*s - 3) + s*(5*s - 5)))) - 2*Dd*f*(-7*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f*(7*K*(20*r**2 + r*(88*s - 41) + 68*s**2 - 83*s + 21) - 3*r**2*(8*C + 20) - 6*r*(C*(24*s - 5) + 8*s - 18) - 3*s**2*(40*C - 4) + 3*s*(22*C + 27) - 54) + 14*g2*(4*r**2 + r*(24*s - 5) + s*(20*s - 11)))) - 1260*Dd**2*b2*f**2*r**2 - 5544*Dd**2*b2*f**2*r*s + 2646*Dd**2*b2*f**2*r - 4284*Dd**2*b2*f**2*s**2 + 4914*Dd**2*b2*f**2*s - 1134*Dd**2*b2*f**2 + 732*Dd**2*f**3*r**2 + 2568*Dd**2*f**3*r*s - 1374*Dd**2*f**3*r + 1836*Dd**2*f**3*s**2 - 2202*Dd**2*f**3*s + 550*Dd**2*f**3 + 2520*Dd**2*f**2*g2*r**2 + 11088*Dd**2*f**2*g2*r*s - 5292*Dd**2*f**2*g2*r + 8568*Dd**2*f**2*g2*s**2 - 9828*Dd**2*f**2*g2*s + 2268*Dd**2*f**2*g2 + 42*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 21*b1**2*(3*D1**2*K*fd*r**2 + 18*D1**2*K*fd*r*s - 18*D1**2*K*fd*r + 15*D1**2*K*fd*s**2 - 30*D1**2*K*fd*s + 15*D1**2*K*fd + D1**2*K*fdd*r**2 + 6*D1**2*K*fdd*r*s - 6*D1**2*K*fdd*r + 5*D1**2*K*fdd*s**2 - 10*D1**2*K*fdd*s + 5*D1**2*K*fdd - 2*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 36*D1**2*f*fd*r**2 - 64*D1**2*f*fd*r*s + 38*D1**2*f*fd*r - 28*D1**2*f*fd*s**2 + 22*D1**2*f*fd*s - 14*D1**2*f*fd + 44*D1**2*f*fdd*r**2 + 64*D1**2*f*fdd*r*s - 50*D1**2*f*fdd*r + 20*D1**2*f*fdd*s**2 - 26*D1**2*f*fdd*s + 22*D1**2*f*fdd + 44*D1**2*fd**2*r**2 + 64*D1**2*fd**2*r*s - 50*D1**2*fd**2*r + 20*D1**2*fd**2*s**2 - 26*D1**2*fd**2*s + 6*D1**2*fd**2 - 12*D1**2*fd*r**2 - 20*D1**2*fd*r*s + 6*D1**2*fd*r - 8*D1**2*fd*s**2 + 12*D1**2*fd*s - 6*D1**2*fd + 6*D1**2*fdd*r**2 + 10*D1**2*fdd*r*s + 2*D1**2*fdd*r + 4*D1**2*fdd*s**2 + 4*D1**2*fdd*s - 2*D1**2*fdd + 12*D1*Dd*K*f*r**2 + 72*D1*Dd*K*f*r*s - 30*D1*Dd*K*f*r + 60*D1*Dd*K*f*s**2 - 66*D1*Dd*K*f*s + 21*D1*Dd*K*f + 8*D1*Dd*K*fd*r**2 + 48*D1*Dd*K*fd*r*s - 34*D1*Dd*K*fd*r + 40*D1*Dd*K*fd*s**2 - 62*D1*Dd*K*fd*s + 22*D1*Dd*K*fd - 72*D1*Dd*f**2*r**2 - 128*D1*Dd*f**2*r*s + 104*D1*Dd*f**2*r - 56*D1*Dd*f**2*s**2 + 92*D1*Dd*f**2*s - 50*D1*Dd*f**2 + 352*D1*Dd*f*fd*r**2 + 512*D1*Dd*f*fd*r*s - 440*D1*Dd*f*fd*r + 160*D1*Dd*f*fd*s**2 - 272*D1*Dd*f*fd*s + 126*D1*Dd*f*fd - 48*D1*Dd*f*r**2 - 80*D1*Dd*f*r*s + 68*D1*Dd*f*r - 32*D1*Dd*f*s**2 + 56*D1*Dd*f*s - 32*D1*Dd*f + 48*D1*Dd*fd*r**2 + 80*D1*Dd*fd*r*s - 26*D1*Dd*fd*r + 32*D1*Dd*fd*s**2 - 12*D1*Dd*fd*s - 8*D1*Dd*fd + 4*D1*Ddd*K*f*r**2 + 24*D1*Ddd*K*f*r*s - 10*D1*Ddd*K*f*r + 20*D1*Ddd*K*f*s**2 - 22*D1*Ddd*K*f*s + 7*D1*Ddd*K*f + 88*D1*Ddd*f**2*r**2 + 128*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 84*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 40*D1*Ddd*f*r*s - 34*D1*Ddd*f*r + 16*D1*Ddd*f*s**2 - 28*D1*Ddd*f*s + 16*D1*Ddd*f + 4*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 12*Dd**2*K*f*r**2 + 72*Dd**2*K*f*r*s - 30*Dd**2*K*f*r + 60*Dd**2*K*f*s**2 - 66*Dd**2*K*f*s + 14*Dd**2*K*f + 264*Dd**2*f**2*r**2 + 384*Dd**2*f**2*r*s - 360*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 252*Dd**2*f**2*s + 108*Dd**2*f**2 + 72*Dd**2*f*r**2 + 120*Dd**2*f*r*s - 102*Dd**2*f*r + 48*Dd**2*f*s**2 - 84*Dd**2*f*s + 32*Dd**2*f) - 3*b1*(-4*C*D1**2*f*fd*r**2 - 24*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r - 20*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s - 12*C*D1**2*f*fd - 12*C*D1**2*f*fdd*r**2 - 72*C*D1**2*f*fdd*r*s + 48*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 96*C*D1**2*f*fdd*s - 36*C*D1**2*f*fdd - 12*C*D1**2*fd**2*r**2 - 72*C*D1**2*fd**2*r*s + 48*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 96*C*D1**2*fd**2*s - 36*C*D1**2*fd**2 - 8*C*D1*Dd*f**2*r**2 - 48*C*D1*Dd*f**2*r*s + 20*C*D1*Dd*f**2*r - 40*C*D1*Dd*f**2*s**2 + 44*C*D1*Dd*f**2*s - 14*C*D1*Dd*f**2 - 96*C*D1*Dd*f*fd*r**2 - 576*C*D1*Dd*f*fd*r*s + 312*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 648*C*D1*Dd*f*fd*s - 192*C*D1*Dd*f*fd - 24*C*D1*Ddd*f**2*r**2 - 144*C*D1*Ddd*f**2*r*s + 60*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 132*C*D1*Ddd*f**2*s - 42*C*D1*Ddd*f**2 - 72*C*Dd**2*f**2*r**2 - 432*C*Dd**2*f**2*r*s + 180*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 396*C*Dd**2*f**2*s - 84*C*Dd**2*f**2 - 14*D1**2*K*bdd1*f*r**2 - 84*D1**2*K*bdd1*f*r*s + 14*D1**2*K*bdd1*f*r - 70*D1**2*K*bdd1*f*s**2 + 42*D1**2*K*bdd1*f*s - 7*D1**2*K*bdd1*f - 42*D1**2*K*f*fd*r**2 - 308*D1**2*K*f*fd*r*s + 154*D1**2*K*f*fd*r - 266*D1**2*K*f*fd*s**2 + 266*D1**2*K*f*fd*s - 133*D1**2*K*f*fd + 70*D1**2*K*f*fdd*r**2 + 308*D1**2*K*f*fdd*r*s - 154*D1**2*K*f*fdd*r + 238*D1**2*K*f*fdd*s**2 - 238*D1**2*K*f*fdd*s + 119*D1**2*K*f*fdd + 70*D1**2*K*fd**2*r**2 + 308*D1**2*K*fd**2*r*s - 154*D1**2*K*fd**2*r + 238*D1**2*K*fd**2*s**2 - 238*D1**2*K*fd**2*s - 21*D1**2*b2*fd*r**2 - 42*D1**2*b2*fd*r*s + 42*D1**2*b2*fd*r - 21*D1**2*b2*fd*s**2 + 42*D1**2*b2*fd*s - 21*D1**2*b2*fd - 7*D1**2*b2*fdd*r**2 - 14*D1**2*b2*fdd*r*s + 14*D1**2*b2*fdd*r - 7*D1**2*b2*fdd*s**2 + 14*D1**2*b2*fdd*s - 7*D1**2*b2*fdd + 28*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 308*D1**2*bdd1*f**2*r**2 - 448*D1**2*bdd1*f**2*r*s + 490*D1**2*bdd1*f**2*r - 140*D1**2*bdd1*f**2*s**2 + 406*D1**2*bdd1*f**2*s - 224*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*r**2 - 140*D1**2*bdd1*f*r*s + 168*D1**2*bdd1*f*r - 56*D1**2*bdd1*f*s**2 + 154*D1**2*bdd1*f*s - 84*D1**2*bdd1*f - 7*D1**2*bdd2*f*r**2 - 14*D1**2*bdd2*f*r*s + 14*D1**2*bdd2*f*r - 7*D1**2*bdd2*f*s**2 + 14*D1**2*bdd2*f*s - 7*D1**2*bdd2*f + 46*D1**2*f*fd*r**2 + 104*D1**2*f*fd*r*s - 68*D1**2*f*fd*r + 58*D1**2*f*fd*s**2 - 80*D1**2*f*fd*s + 44*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s + 6*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 252*D1**2*f*gd2*r*s - 84*D1**2*f*gd2*r + 210*D1**2*f*gd2*s**2 - 252*D1**2*f*gd2*s + 42*D1**2*f*gd2 + 14*D1**2*f*gdd2*r**2 + 84*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r + 70*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s + 24*D1**2*fd**2 + 42*D1**2*fd*g2*r**2 + 252*D1**2*fd*g2*r*s - 252*D1**2*fd*g2*r + 210*D1**2*fd*g2*s**2 - 420*D1**2*fd*g2*s + 210*D1**2*fd*g2 + 28*D1**2*fd*gd2*r**2 + 168*D1**2*fd*gd2*r*s - 112*D1**2*fd*gd2*r + 140*D1**2*fd*gd2*s**2 - 224*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 + 14*D1**2*fdd*g2*r**2 + 84*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r + 70*D1**2*fdd*g2*s**2 - 140*D1**2*fdd*g2*s + 70*D1**2*fdd*g2 - 84*D1*Dd*K*f**2*r**2 - 616*D1*Dd*K*f**2*r*s + 238*D1*Dd*K*f**2*r - 532*D1*Dd*K*f**2*s**2 + 574*D1*Dd*K*f**2*s - 175*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*r**2 + 2464*D1*Dd*K*f*fd*r*s - 1204*D1*Dd*K*f*fd*r + 1904*D1*Dd*K*f*fd*s**2 - 2044*D1*Dd*K*f*fd*s + 546*D1*Dd*K*f*fd - 84*D1*Dd*b2*f*r**2 - 168*D1*Dd*b2*f*r*s + 126*D1*Dd*b2*f*r - 84*D1*Dd*b2*f*s**2 + 126*D1*Dd*b2*f*s - 63*D1*Dd*b2*f - 56*D1*Dd*b2*fd*r**2 - 112*D1*Dd*b2*fd*r*s + 98*D1*Dd*b2*fd*r - 56*D1*Dd*b2*fd*s**2 + 98*D1*Dd*b2*fd*s - 42*D1*Dd*b2*fd + 92*D1*Dd*f**2*r**2 + 208*D1*Dd*f**2*r*s - 144*D1*Dd*f**2*r + 116*D1*Dd*f**2*s**2 - 162*D1*Dd*f**2*s + 75*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 168*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 84*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 1008*D1*Dd*f*g2*r*s - 420*D1*Dd*f*g2*r + 840*D1*Dd*f*g2*s**2 - 924*D1*Dd*f*g2*s + 294*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 + 672*D1*Dd*f*gd2*r*s - 252*D1*Dd*f*gd2*r + 560*D1*Dd*f*gd2*s**2 - 644*D1*Dd*f*gd2*s + 140*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r**2 + 672*D1*Dd*fd*g2*r*s - 476*D1*Dd*fd*g2*r + 560*D1*Dd*fd*g2*s**2 - 868*D1*Dd*fd*g2*s + 308*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*r**2 + 616*D1*Ddd*K*f**2*r*s - 294*D1*Ddd*K*f**2*r + 476*D1*Ddd*K*f**2*s**2 - 546*D1*Ddd*K*f**2*s + 189*D1*Ddd*K*f**2 - 28*D1*Ddd*b2*f*r**2 - 56*D1*Ddd*b2*f*r*s + 42*D1*Ddd*b2*f*r - 28*D1*Ddd*b2*f*s**2 + 42*D1*Ddd*b2*f*s - 21*D1*Ddd*b2*f - 60*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 72*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r*s - 140*D1*Ddd*f*g2*r + 280*D1*Ddd*f*g2*s**2 - 308*D1*Ddd*f*g2*s + 98*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(f**2*(36*r**2 + r*(64*s - 66) + 28*s**2 - 70*s + 36) - f*(3*K*(2*r**2 + 12*r*s - 2*r + 10*s**2 - 6*s + 1) + 2*fd*(88*r**2 + 8*r*(16*s - 15) + 40*s**2 - 84*s + 35) - 24*r**2 - 40*r*s + 38*r - 16*s**2 + 24*s - 14) - 2*fd*(K*(2*r**2 + r*(12*s - 7) + 10*s**2 - 13*s + 3) + 12*r**2 + 10*r*(2*s - 1) + 8*s**2 - 7*s - 1)) - 2*Dd*f*(K*(8*r**2 + 48*r*s - 14*r + 40*s**2 - 34*s + 5) + f*(176*r**2 + 4*r*(64*s - 65) + 80*s**2 - 200*s + 99) + 48*r**2 + 80*r*s - 82*r + 32*s**2 - 72*s + 35)) - 7*D1*bd2*(D1*(3*f + 2*fd)*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 420*Dd**2*K*f**2*r**2 + 1848*Dd**2*K*f**2*r*s - 882*Dd**2*K*f**2*r + 1428*Dd**2*K*f**2*s**2 - 1638*Dd**2*K*f**2*s + 378*Dd**2*K*f**2 - 84*Dd**2*b2*f*r**2 - 168*Dd**2*b2*f*r*s + 126*Dd**2*b2*f*r - 84*Dd**2*b2*f*s**2 + 126*Dd**2*b2*f*s - 42*Dd**2*b2*f - 180*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 216*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 54*Dd**2*f**2 + 168*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r*s - 420*Dd**2*f*g2*r + 840*Dd**2*f*g2*s**2 - 924*Dd**2*f*g2*s + 196*Dd**2*f*g2))/(630*d**2*k3**3) - D1**2*Pk2*Pkd3*k1**2*(D1*(14*D1*bd1**2*(f*(25*K*(r + s - 1)**2 - 3*r**2*(2*C - 1) - 3*r*(6*C - 4)*(2*s - 1) - 3*s*(10*C - 7)*(s - 1)) + 10*g2*(r**2 + r*(6*s - 3) + s*(5*s - 5))) + D1*bdd1*f*(f*(6*C - 3)*(43*r + 35*s - 35) - 350*g2*(r + s - 1))*(r + s - 1) - 35*b2*(r + s - 1)*(2*D1*bd1**2*(r + s) - 5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3))) + bd1*(350*D1*bd2*f*(r + s - 1)**2 + D1*(-3*f**2*(r + s - 1)*(74*C*r + 42*C*(s - 1) - 23*r - 21*s + 21) + f*fd*(12*C - 6)*(86*r**2 + r*(156*s - 121) + 70*s**2 - 109*s + 39) + 70*f*(3*g2 - 10*gd2)*(r + s - 1)**2 - 700*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(f*(6*C - 3)*(172*r**2 + r*(312*s - 281) + 140*s**2 - 253*s + 113) - 350*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) - 35*b1**3*(D1**2*(fd*(3*r + s - 3) + fdd*(-5*r - 3*s + 5))*(r + s - 1) + D1*(Dd*(4*K*r**2 + 24*K*r*s - 10*K*r + 20*K*s**2 - 22*K*s + 7*K + f*(12*r**2 + 16*r*(s - 1) + 4*s**2 - 10*s + 7) - 2*fd*(20*r**2 + 32*r*s - 34*r + 12*s**2 - 27*s + 14) - 8*r*s + 2*r - 8*s**2 + 8*s - 2) + Ddd*(K*(4*r**2 + 24*r*s - 10*r + 20*s**2 - 22*s + 7) - f*(20*r**2 + 4*r*(8*s - 7) + 12*s**2 - 22*s + 13) - 8*r*s + 2*r - 8*s**2 + 8*s - 2)) - 2*Dd**2*(-K*(6*r**2 + 36*r*s - 15*r + 30*s**2 - 33*s + 7) + f*(30*r**2 + 6*r*(8*s - 7) + 18*s**2 - 33*s + 13) + 12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 7*b1**2*(-2*C*D1**2*fd*r**2 - 12*C*D1**2*fd*r*s + 4*C*D1**2*fd*r - 10*C*D1**2*fd*s**2 + 12*C*D1**2*fd*s - 2*C*D1**2*fd + 6*C*D1**2*fdd*r**2 + 36*C*D1**2*fdd*r*s - 12*C*D1**2*fdd*r + 30*C*D1**2*fdd*s**2 - 36*C*D1**2*fdd*s + 6*C*D1**2*fdd - 8*C*D1*Dd*f*r**2 - 48*C*D1*Dd*f*r*s + 20*C*D1*Dd*f*r - 40*C*D1*Dd*f*s**2 + 44*C*D1*Dd*f*s - 14*C*D1*Dd*f + 48*C*D1*Dd*fd*r**2 + 288*C*D1*Dd*fd*r*s - 108*C*D1*Dd*fd*r + 240*C*D1*Dd*fd*s**2 - 276*C*D1*Dd*fd*s + 60*C*D1*Dd*fd + 24*C*D1*Ddd*f*r**2 + 144*C*D1*Ddd*f*r*s - 60*C*D1*Ddd*f*r + 120*C*D1*Ddd*f*s**2 - 132*C*D1*Ddd*f*s + 42*C*D1*Ddd*f + 72*C*Dd**2*f*r**2 + 432*C*Dd**2*f*r*s - 180*C*Dd**2*f*r + 360*C*Dd**2*f*s**2 - 396*C*Dd**2*f*s + 84*C*Dd**2*f + 15*D1**2*K*bdd1*r**2 + 90*D1**2*K*bdd1*r*s - 40*D1**2*K*bdd1*r + 75*D1**2*K*bdd1*s**2 - 80*D1**2*K*bdd1*s + 30*D1**2*K*bdd1 + 15*D1**2*K*fd*r**2 + 30*D1**2*K*fd*r*s + 15*D1**2*K*fd*s**2 - 25*D1**2*K*fdd*r**2 - 50*D1**2*K*fdd*r*s - 25*D1**2*K*fdd*s**2 - 75*D1**2*bdd1*f*r**2 - 120*D1**2*bdd1*f*r*s + 90*D1**2*bdd1*f*r - 45*D1**2*bdd1*f*s**2 + 70*D1**2*bdd1*f*s - 40*D1**2*bdd1*f - 30*D1**2*bdd1*r*s + 10*D1**2*bdd1*r - 30*D1**2*bdd1*s**2 + 30*D1**2*bdd1*s - 10*D1**2*bdd1 + 5*D1**2*bdd2*r**2 + 10*D1**2*bdd2*r*s - 10*D1**2*bdd2*r + 5*D1**2*bdd2*s**2 - 10*D1**2*bdd2*s + 5*D1**2*bdd2 + 11*D1**2*fd*r**2 + 18*D1**2*fd*r*s - 2*D1**2*fd*r + 7*D1**2*fd*s**2 - 8*D1**2*fd*s + D1**2*fd - 3*D1**2*fdd*r**2 - 24*D1**2*fdd*r*s + 6*D1**2*fdd*r - 21*D1**2*fdd*s**2 + 24*D1**2*fdd*s - 3*D1**2*fdd - 10*D1**2*gd2*r**2 - 60*D1**2*gd2*r*s + 20*D1**2*gd2*r - 50*D1**2*gd2*s**2 + 60*D1**2*gd2*s - 10*D1**2*gd2 - 10*D1**2*gdd2*r**2 - 60*D1**2*gdd2*r*s + 20*D1**2*gdd2*r - 50*D1**2*gdd2*s**2 + 60*D1**2*gdd2*s - 10*D1**2*gdd2 + 60*D1*Dd*K*f*r**2 + 120*D1*Dd*K*f*r*s - 90*D1*Dd*K*f*r + 60*D1*Dd*K*f*s**2 - 90*D1*Dd*K*f*s + 45*D1*Dd*K*f - 200*D1*Dd*K*fd*r**2 - 400*D1*Dd*K*fd*r*s + 150*D1*Dd*K*fd*r - 200*D1*Dd*K*fd*s**2 + 150*D1*Dd*K*fd*s + 20*D1*Dd*b2*r**2 + 40*D1*Dd*b2*r*s - 30*D1*Dd*b2*r + 20*D1*Dd*b2*s**2 - 30*D1*Dd*b2*s + 15*D1*Dd*b2 + 44*D1*Dd*f*r**2 + 72*D1*Dd*f*r*s - 62*D1*Dd*f*r + 28*D1*Dd*f*s**2 - 50*D1*Dd*f*s + 29*D1*Dd*f - 24*D1*Dd*fd*r**2 - 192*D1*Dd*fd*r*s + 60*D1*Dd*fd*r - 168*D1*Dd*fd*s**2 + 186*D1*Dd*fd*s - 36*D1*Dd*fd - 40*D1*Dd*g2*r**2 - 240*D1*Dd*g2*r*s + 100*D1*Dd*g2*r - 200*D1*Dd*g2*s**2 + 220*D1*Dd*g2*s - 70*D1*Dd*g2 - 80*D1*Dd*gd2*r**2 - 480*D1*Dd*gd2*r*s + 180*D1*Dd*gd2*r - 400*D1*Dd*gd2*s**2 + 460*D1*Dd*gd2*s - 100*D1*Dd*gd2 - 100*D1*Ddd*K*f*r**2 - 200*D1*Ddd*K*f*r*s + 150*D1*Ddd*K*f*r - 100*D1*Ddd*K*f*s**2 + 150*D1*Ddd*K*f*s - 75*D1*Ddd*K*f + 20*D1*Ddd*b2*r**2 + 40*D1*Ddd*b2*r*s - 30*D1*Ddd*b2*r + 20*D1*Ddd*b2*s**2 - 30*D1*Ddd*b2*s + 15*D1*Ddd*b2 - 12*D1*Ddd*f*r**2 - 96*D1*Ddd*f*r*s + 36*D1*Ddd*f*r - 84*D1*Ddd*f*s**2 + 90*D1*Ddd*f*s - 27*D1*Ddd*f - 40*D1*Ddd*g2*r**2 - 240*D1*Ddd*g2*r*s + 100*D1*Ddd*g2*r - 200*D1*Ddd*g2*s**2 + 220*D1*Ddd*g2*s - 70*D1*Ddd*g2 + 5*D1*bd1*(D1*(3*K*r**2 + 18*K*r*s - 8*K*r + 15*K*s**2 - 16*K*s + 6*K + f*(9*r**2 + 2*r*(6*s - 5) + 3*s**2 - 6*s + 4) - 2*fd*(15*r**2 + 24*r*(s - 1) + 9*s**2 - 19*s + 9) - 6*r*s + 2*r - 6*s**2 + 6*s - 2) - 2*Dd*(-K*(12*r**2 + 72*r*s - 31*r + 60*s**2 - 65*s + 16) + f*(60*r**2 + r*(96*s - 78) + 36*s**2 - 61*s + 25) + 24*r*s - 7*r + 24*s**2 - 24*s + 5)) + 5*D1*bd2*(D1*(r + s - 1) + 2*Dd*(4*r + 4*s - 3))*(r + s - 1) - 300*Dd**2*K*f*r**2 - 600*Dd**2*K*f*r*s + 450*Dd**2*K*f*r - 300*Dd**2*K*f*s**2 + 450*Dd**2*K*f*s - 150*Dd**2*K*f + 60*Dd**2*b2*r**2 + 120*Dd**2*b2*r*s - 90*Dd**2*b2*r + 60*Dd**2*b2*s**2 - 90*Dd**2*b2*s + 30*Dd**2*b2 - 36*Dd**2*f*r**2 - 288*Dd**2*f*r*s + 108*Dd**2*f*r - 252*Dd**2*f*s**2 + 270*Dd**2*f*s - 54*Dd**2*f - 120*Dd**2*g2*r**2 - 720*Dd**2*g2*r*s + 300*Dd**2*g2*r - 600*Dd**2*g2*s**2 + 660*Dd**2*g2*s - 140*Dd**2*g2) + b1*(-84*C*D1**2*bdd1*f*r**2 - 504*C*D1**2*bdd1*f*r*s + 252*C*D1**2*bdd1*f*r - 420*C*D1**2*bdd1*f*s**2 + 420*C*D1**2*bdd1*f*s - 210*C*D1**2*bdd1*f - 444*C*D1**2*f*fd*r**2 - 696*C*D1**2*f*fd*r*s + 444*C*D1**2*f*fd*r - 252*C*D1**2*f*fd*s**2 + 348*C*D1**2*f*fd*s - 222*C*D1**2*f*fd + 516*C*D1**2*f*fdd*r**2 + 936*C*D1**2*f*fdd*r*s - 516*C*D1**2*f*fdd*r + 420*C*D1**2*f*fdd*s**2 - 468*C*D1**2*f*fdd*s + 258*C*D1**2*f*fdd + 516*C*D1**2*fd**2*r**2 + 936*C*D1**2*fd**2*r*s - 516*C*D1**2*fd**2*r + 420*C*D1**2*fd**2*s**2 - 468*C*D1**2*fd**2*s - 888*C*D1*Dd*f**2*r**2 - 1392*C*D1*Dd*f**2*r*s + 1236*C*D1*Dd*f**2*r - 504*C*D1*Dd*f**2*s**2 + 948*C*D1*Dd*f**2*s - 570*C*D1*Dd*f**2 + 4128*C*D1*Dd*f*fd*r**2 + 7488*C*D1*Dd*f*fd*r*s - 5064*C*D1*Dd*f*fd*r + 3360*C*D1*Dd*f*fd*s**2 - 4584*C*D1*Dd*f*fd*s + 1500*C*D1*Dd*f*fd + 1032*C*D1*Ddd*f**2*r**2 + 1872*C*D1*Ddd*f**2*r*s - 1500*C*D1*Ddd*f**2*r + 840*C*D1*Ddd*f**2*s**2 - 1356*C*D1*Ddd*f**2*s + 726*C*D1*Ddd*f**2 + 3096*C*Dd**2*f**2*r**2 + 5616*C*Dd**2*f**2*r*s - 4500*C*Dd**2*f**2*r + 2520*C*Dd**2*f**2*s**2 - 4068*C*Dd**2*f**2*s + 1452*C*Dd**2*f**2 + 350*D1**2*K*bdd1*f*r**2 + 700*D1**2*K*bdd1*f*r*s - 700*D1**2*K*bdd1*f*r + 350*D1**2*K*bdd1*f*s**2 - 700*D1**2*K*bdd1*f*s + 350*D1**2*K*bdd1*f + 70*D1**2*bd1**2*(-K*(3*r**2 + 18*r*s - 8*r + 15*s**2 - 16*s + 3) + f*(15*r**2 + 6*r*(4*s - 3) + 9*s**2 - 14*s + 4) + 6*r*s - 2*r + 6*s**2 - 6*s + 1) - 105*D1**2*bd2*f*r**2 - 210*D1**2*bd2*f*r*s + 210*D1**2*bd2*f*r - 105*D1**2*bd2*f*s**2 + 210*D1**2*bd2*f*s - 105*D1**2*bd2*f + 350*D1**2*bd2*fd*r**2 + 700*D1**2*bd2*fd*r*s - 350*D1**2*bd2*fd*r + 350*D1**2*bd2*fd*s**2 - 350*D1**2*bd2*fd*s + 42*D1**2*bdd1*f*r**2 + 336*D1**2*bdd1*f*r*s - 168*D1**2*bdd1*f*r + 294*D1**2*bdd1*f*s**2 - 294*D1**2*bdd1*f*s + 147*D1**2*bdd1*f + 140*D1**2*bdd1*g2*r**2 + 840*D1**2*bdd1*g2*r*s - 420*D1**2*bdd1*g2*r + 700*D1**2*bdd1*g2*s**2 - 700*D1**2*bdd1*g2*s + 350*D1**2*bdd1*g2 + 175*D1**2*bdd2*f*r**2 + 350*D1**2*bdd2*f*r*s - 350*D1**2*bdd2*f*r + 175*D1**2*bdd2*f*s**2 - 350*D1**2*bdd2*f*s + 175*D1**2*bdd2*f + 138*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 138*D1**2*f*fd*r + 126*D1**2*f*fd*s**2 - 132*D1**2*f*fd*s + 69*D1**2*f*fd - 258*D1**2*f*fdd*r**2 - 468*D1**2*f*fdd*r*s + 258*D1**2*f*fdd*r - 210*D1**2*f*fdd*s**2 + 234*D1**2*f*fdd*s - 129*D1**2*f*fdd + 210*D1**2*f*gd2*r**2 + 420*D1**2*f*gd2*r*s - 420*D1**2*f*gd2*r + 210*D1**2*f*gd2*s**2 - 420*D1**2*f*gd2*s + 210*D1**2*f*gd2 - 350*D1**2*f*gdd2*r**2 - 700*D1**2*f*gdd2*r*s + 700*D1**2*f*gdd2*r - 350*D1**2*f*gdd2*s**2 + 700*D1**2*f*gdd2*s - 350*D1**2*f*gdd2 - 258*D1**2*fd**2*r**2 - 468*D1**2*fd**2*r*s + 258*D1**2*fd**2*r - 210*D1**2*fd**2*s**2 + 234*D1**2*fd**2*s + 210*D1**2*fd*g2*r**2 + 420*D1**2*fd*g2*r*s + 210*D1**2*fd*g2*s**2 - 700*D1**2*fd*gd2*r**2 - 1400*D1**2*fd*gd2*r*s + 700*D1**2*fd*gd2*r - 700*D1**2*fd*gd2*s**2 + 700*D1**2*fd*gd2*s - 350*D1**2*fdd*g2*r**2 - 700*D1**2*fdd*g2*r*s - 350*D1**2*fdd*g2*s**2 + 1400*D1*Dd*bd2*f*r**2 + 2800*D1*Dd*bd2*f*r*s - 2450*D1*Dd*bd2*f*r + 1400*D1*Dd*bd2*f*s**2 - 2450*D1*Dd*bd2*f*s + 1050*D1*Dd*bd2*f + 276*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 408*D1*Dd*f**2*r + 252*D1*Dd*f**2*s**2 - 390*D1*Dd*f**2*s + 201*D1*Dd*f**2 - 2064*D1*Dd*f*fd*r**2 - 3744*D1*Dd*f*fd*r*s + 2532*D1*Dd*f*fd*r - 1680*D1*Dd*f*fd*s**2 + 2292*D1*Dd*f*fd*s - 750*D1*Dd*f*fd + 840*D1*Dd*f*g2*r**2 + 1680*D1*Dd*f*g2*r*s - 1260*D1*Dd*f*g2*r + 840*D1*Dd*f*g2*s**2 - 1260*D1*Dd*f*g2*s + 630*D1*Dd*f*g2 - 2800*D1*Dd*f*gd2*r**2 - 5600*D1*Dd*f*gd2*r*s + 4900*D1*Dd*f*gd2*r - 2800*D1*Dd*f*gd2*s**2 + 4900*D1*Dd*f*gd2*s - 2100*D1*Dd*f*gd2 - 2800*D1*Dd*fd*g2*r**2 - 5600*D1*Dd*fd*g2*r*s + 2100*D1*Dd*fd*g2*r - 2800*D1*Dd*fd*g2*s**2 + 2100*D1*Dd*fd*g2*s - 516*D1*Ddd*f**2*r**2 - 936*D1*Ddd*f**2*r*s + 750*D1*Ddd*f**2*r - 420*D1*Ddd*f**2*s**2 + 678*D1*Ddd*f**2*s - 363*D1*Ddd*f**2 - 1400*D1*Ddd*f*g2*r**2 - 2800*D1*Ddd*f*g2*r*s + 2100*D1*Ddd*f*g2*r - 1400*D1*Ddd*f*g2*s**2 + 2100*D1*Ddd*f*g2*s - 1050*D1*Ddd*f*g2 - 7*D1*bd1*(10*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - D1*f*(2*C*(2*r**2 + 12*r*s - 6*r + 10*s**2 - 10*s + 5) - 30*K*(r + s - 1)**2 - 22*r**2 - 36*r*s + 38*r - 14*s**2 + 24*s - 17) + 2*D1*fd*(6*C*(2*r**2 + r*(12*s - 5) + 10*s**2 - 11*s + 3) - 50*K*s**2 + 50*K*s - r**2*(50*K + 6) - 2*r*(50*K*s - 25*K + 24*s - 9) - 42*s**2 + 45*s - 12) - 10*D1*(g2*(2*r**2 + 12*r*s - 6*r + 10*s**2 - 10*s + 5) + 2*gd2*(2*r**2 + r*(12*s - 5) + 10*s**2 - 11*s + 3)) + 2*Dd*f*(6*C*(8*r**2 + r*(48*s - 22) + 40*s**2 - 42*s + 11) - 50*K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 24*r**2 - 192*r*s + 84*r - 168*s**2 + 174*s - 45) - 20*Dd*g2*(8*r**2 + r*(48*s - 22) + 40*s**2 - 42*s + 11)) - 1548*Dd**2*f**2*r**2 - 2808*Dd**2*f**2*r*s + 2250*Dd**2*f**2*r - 1260*Dd**2*f**2*s**2 + 2034*Dd**2*f**2*s - 726*Dd**2*f**2 - 4200*Dd**2*f*g2*r**2 - 8400*Dd**2*f*g2*r*s + 6300*Dd**2*f*g2*r - 4200*Dd**2*f*g2*s**2 + 6300*Dd**2*f*g2*s - 2100*Dd**2*f*g2 - 35*b2*(D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 3*D1**2*fd*r**2 + 6*D1**2*fd*r*s + 3*D1**2*fd*s**2 - 5*D1**2*fdd*r**2 - 10*D1**2*fdd*r*s - 5*D1**2*fdd*s**2 + 12*D1*Dd*f*r**2 + 24*D1*Dd*f*r*s - 18*D1*Dd*f*r + 12*D1*Dd*f*s**2 - 18*D1*Dd*f*s + 9*D1*Dd*f - 40*D1*Dd*fd*r**2 - 80*D1*Dd*fd*r*s + 30*D1*Dd*fd*r - 40*D1*Dd*fd*s**2 + 30*D1*Dd*fd*s - 20*D1*Ddd*f*r**2 - 40*D1*Ddd*f*r*s + 30*D1*Ddd*f*r - 20*D1*Ddd*f*s**2 + 30*D1*Ddd*f*s - 15*D1*Ddd*f + D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 60*Dd**2*f*r**2 - 120*Dd**2*f*r*s + 90*Dd**2*f*r - 60*Dd**2*f*s**2 + 90*Dd**2*f*s - 30*Dd**2*f)))/(210*d**2*k3**3) + 4*D1**2*Pk2*Pkd3*k1**2*st**4*(D1**2*bd1**2*f**2*s*(-2*r - 2*s + 1) + D1*b1*f*(D1*bdd1*f*s*(-2*r - 2*s + 1) - bd1*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1))) + b1**2*(D1**2*(2*s - 1)*(r + s - 1)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(6 - 16*s) - 16*s**2 + 20*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(35*d**2*k2**2*k3) + D1**2*Pk2*Pkd3*k1**2*st**2*(D1*f*(7*D1*bd1**2*s*(3*f + 1)*(2*r + 2*s - 1) + D1*bd1*(f*s*(r + s) + 3*fd*(r*(4*s - 1) + s*(4*s - 3))) + 3*D1*bdd1*f*s*(r + s) + 3*Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + 14*b1**3*(D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r - 8*s**2 + 8*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 7*b1**2*(-2*D1**2*bdd1*f*(3*r*s - r + 3*s**2 - 3*s + 1) - 6*D1**2*f*fd*r*s + 3*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 + 9*D1**2*f*fd*s - 3*D1**2*f*fd + 6*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 9*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r*s - 3*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 9*D1**2*fd**2*s + 3*D1**2*fd**2 + 3*D1**2*fd*r*s - 3*D1**2*fd*r + 3*D1**2*fd*s**2 - 6*D1**2*fd*s + 3*D1**2*fd + D1**2*fdd*r*s - D1**2*fdd*r + D1**2*fdd*s**2 - 2*D1**2*fdd*s + D1**2*fdd - 12*D1*Dd*f**2*r*s + 3*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 48*D1*Dd*f*fd*r*s - 18*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 12*D1*Dd*f*r*s - 3*D1*Dd*f*r + 12*D1*Dd*f*s**2 - 12*D1*Dd*f*s + 3*D1*Dd*f + 8*D1*Dd*fd*r*s - 5*D1*Dd*fd*r + 8*D1*Dd*fd*s**2 - 12*D1*Dd*fd*s + 4*D1*Dd*fd + 12*D1*Ddd*f**2*r*s - 3*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 4*D1*Ddd*f*r*s - D1*Ddd*f*r + 4*D1*Ddd*f*s**2 - 4*D1*Ddd*f*s + D1*Ddd*f + 2*D1*bd1*(D1*(f*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + fd*(-6*r*s + r - 6*s**2 + 6*s - 1)) + Dd*f*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) + 36*Dd**2*f**2*r*s - 9*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 6*Dd**2*f**2 + 12*Dd**2*f*r*s - 3*Dd**2*f*r + 12*Dd**2*f*s**2 - 12*Dd**2*f*s + 2*Dd**2*f) + b1*(-14*D1**2*bd1**2*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*(21*bdd1*f**2*s*(2*r + 2*s - 1) + f*(7*bdd1*s*(2*r + 2*s - 1) + fd*(2*s - 1)*(r + s - 1) + 3*fdd*(2*s - 1)*(r + s - 1)) + 3*fd**2*(2*s - 1)*(r + s - 1)) - 7*D1*bd1*(3*D1*f*s*(f - 1)*(2*r + 2*s - 1) - D1*fd*(3*f*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + 4*r*s - 2*r + 4*s**2 - 5*s + 1) - Dd*f*(3*f + 1)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*f*(Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2**2*k3) + D1**2*Pk2*Pkd3*k1**2*(3*D1**2*bd1**2*f*(r*(2*s - 1) + s*(2*s - 2)) + D1*b1*(5*D1*bd1**2*(f + 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 3*D1*bdd1*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + bd1*(D1*(f*(-2*r*s + r - 2*s**2 + 2*s - 1) + 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*Dd*f*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 5*b1**3*(D1**2*s*(fd - fdd)*(r + s - 1) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(-8*r*s + r - 8*s**2 + 8*s - 1) - 4*r*s + r - 4*s**2 + 4*s - 1) - D1*Ddd*(f + 1)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(f + 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(5*D1**2*bdd1*(f + 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - D1**2*fd*r*s - D1**2*fd*s**2 + D1**2*fd*s + 3*D1**2*fdd*r*s + 3*D1**2*fdd*s**2 - 3*D1**2*fdd*s - 4*D1*Dd*f*r*s + D1*Dd*f*r - 4*D1*Dd*f*s**2 + 4*D1*Dd*f*s - D1*Dd*f + 24*D1*Dd*fd*r*s - 3*D1*Dd*fd*r + 24*D1*Dd*fd*s**2 - 24*D1*Dd*fd*s + 3*D1*Dd*fd + 12*D1*Ddd*f*r*s - 3*D1*Ddd*f*r + 12*D1*Ddd*f*s**2 - 12*D1*Ddd*f*s + 3*D1*Ddd*f - 5*D1*bd1*(D1*(f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd*(-6*r*s + r - 6*s**2 + 6*s - 1) - 3*r*s + r - 3*s**2 + 3*s - 1) - Dd*(f + 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 36*Dd**2*f*r*s - 9*Dd**2*f*r + 36*Dd**2*f*s**2 - 36*Dd**2*f*s + 6*Dd**2*f))/(15*d**2*k2**2*k3) + D1**2*Pk2*Pkd3*k2**6*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-9*K*(-2*bd1 + bdd1) - 36*gd2 + 18*gdd2)) + f*(-fd**2*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 18*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 18*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - fd*(2*C - 1)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 18*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 18*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 9*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(2*C*f + 9*K*b1 - f - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*C*f + 9*K*b1 - f - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(14*d**2*k3**7) + 9*D1**2*Pk2*Pkd3*k2**6*st**4*(8*C*D1**2*b1*f*fd*r**2 + 16*C*D1**2*b1*f*fd*r*s - 8*C*D1**2*b1*f*fd*r + 8*C*D1**2*b1*f*fd*s**2 - 8*C*D1**2*b1*f*fd*s + 4*C*D1**2*b1*f*fd - 4*C*D1**2*b1*f*fdd*r**2 - 8*C*D1**2*b1*f*fdd*r*s + 4*C*D1**2*b1*f*fdd*r - 4*C*D1**2*b1*f*fdd*s**2 + 4*C*D1**2*b1*f*fdd*s - 2*C*D1**2*b1*f*fdd - 4*C*D1**2*b1*fd**2*r**2 - 8*C*D1**2*b1*fd**2*r*s + 4*C*D1**2*b1*fd**2*r - 4*C*D1**2*b1*fd**2*s**2 + 4*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 16*C*D1*Dd*b1*f**2*r**2 + 32*C*D1*Dd*b1*f**2*r*s - 24*C*D1*Dd*b1*f**2*r + 16*C*D1*Dd*b1*f**2*s**2 - 24*C*D1*Dd*b1*f**2*s + 12*C*D1*Dd*b1*f**2 - 32*C*D1*Dd*b1*f*fd*r**2 - 64*C*D1*Dd*b1*f*fd*r*s + 40*C*D1*Dd*b1*f*fd*r - 32*C*D1*Dd*b1*f*fd*s**2 + 40*C*D1*Dd*b1*f*fd*s - 12*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 8*C*D1*Ddd*b1*f**2*r**2 - 16*C*D1*Ddd*b1*f**2*r*s + 12*C*D1*Ddd*b1*f**2*r - 8*C*D1*Ddd*b1*f**2*s**2 + 12*C*D1*Ddd*b1*f**2*s - 6*C*D1*Ddd*b1*f**2 - 24*C*Dd**2*b1*f**2*r**2 - 48*C*Dd**2*b1*f**2*r*s + 36*C*Dd**2*b1*f**2*r - 24*C*Dd**2*b1*f**2*s**2 + 36*C*Dd**2*b1*f**2*s - 12*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r**2 + 28*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r**2 - 14*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 14*D1**2*K*bd1**2*f*(r + s - 1)**2 - 4*D1**2*b1*f*fd*r**2 - 8*D1**2*b1*f*fd*r*s + 4*D1**2*b1*f*fd*r - 4*D1**2*b1*f*fd*s**2 + 4*D1**2*b1*f*fd*s - 2*D1**2*b1*f*fd + 2*D1**2*b1*f*fdd*r**2 + 4*D1**2*b1*f*fdd*r*s - 2*D1**2*b1*f*fdd*r + 2*D1**2*b1*f*fdd*s**2 - 2*D1**2*b1*f*fdd*s + D1**2*b1*f*fdd - 28*D1**2*b1*f*gd2*r**2 - 56*D1**2*b1*f*gd2*r*s + 56*D1**2*b1*f*gd2*r - 28*D1**2*b1*f*gd2*s**2 + 56*D1**2*b1*f*gd2*s - 28*D1**2*b1*f*gd2 + 14*D1**2*b1*f*gdd2*r**2 + 28*D1**2*b1*f*gdd2*r*s - 28*D1**2*b1*f*gdd2*r + 14*D1**2*b1*f*gdd2*s**2 - 28*D1**2*b1*f*gdd2*s + 14*D1**2*b1*f*gdd2 + 2*D1**2*b1*fd**2*r**2 + 4*D1**2*b1*fd**2*r*s - 2*D1**2*b1*fd**2*r + 2*D1**2*b1*fd**2*s**2 - 2*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r**2 - 56*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r**2 + 56*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*r + 28*D1**2*b1*fd*gd2*s**2 - 28*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r**2 + 28*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(2*C*f + 14*K*b1 - f - 14*g2) + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r**2 + 112*D1*Dd*K*b1**2*f*r*s - 84*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 84*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r**2 - 112*D1*Dd*K*b1**2*fd*r*s + 42*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 42*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 - 8*D1*Dd*b1*f**2*r**2 - 16*D1*Dd*b1*f**2*r*s + 12*D1*Dd*b1*f**2*r - 8*D1*Dd*b1*f**2*s**2 + 12*D1*Dd*b1*f**2*s - 6*D1*Dd*b1*f**2 + 16*D1*Dd*b1*f*fd*r**2 + 32*D1*Dd*b1*f*fd*r*s - 20*D1*Dd*b1*f*fd*r + 16*D1*Dd*b1*f*fd*s**2 - 20*D1*Dd*b1*f*fd*s + 6*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r**2 - 224*D1*Dd*b1*f*g2*r*s + 168*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 168*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r**2 + 224*D1*Dd*b1*f*gd2*r*s - 196*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 196*D1*Dd*b1*f*gd2*s + 84*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r**2 + 224*D1*Dd*b1*fd*g2*r*s - 84*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 84*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r**2 - 56*D1*Ddd*K*b1**2*f*r*s + 42*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 42*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 4*D1*Ddd*b1*f**2*r**2 + 8*D1*Ddd*b1*f**2*r*s - 6*D1*Ddd*b1*f**2*r + 4*D1*Ddd*b1*f**2*s**2 - 6*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r**2 + 112*D1*Ddd*b1*f*g2*r*s - 84*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 84*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(4*C - 7*K - 2)*(r + s - 1) - f*fd*(4*C - 2)*(2*r + 2*s - 1) - 28*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(2*C*f + 14*K*b1 - f - 14*g2))*(r + s - 1) - 84*Dd**2*K*b1**2*f*r**2 - 168*Dd**2*K*b1**2*f*r*s + 126*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 126*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 12*Dd**2*b1*f**2*r**2 + 24*Dd**2*b1*f**2*r*s - 18*Dd**2*b1*f**2*r + 12*Dd**2*b1*f**2*s**2 - 18*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r**2 + 336*Dd**2*b1*f*g2*r*s - 252*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 252*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(70*d**2*k3**7) + D1**2*Pk2*Pkd3*k2**4*st**6*(-108*C*D1**2*f**2*fd*r**2 - 168*C*D1**2*f**2*fd*r*s + 128*C*D1**2*f**2*fd*r - 60*C*D1**2*f**2*fd*s**2 + 96*C*D1**2*f**2*fd*s - 56*C*D1**2*f**2*fd + 54*C*D1**2*f**2*fdd*r**2 + 84*C*D1**2*f**2*fdd*r*s - 64*C*D1**2*f**2*fdd*r + 30*C*D1**2*f**2*fdd*s**2 - 48*C*D1**2*f**2*fdd*s + 28*C*D1**2*f**2*fdd + 108*C*D1**2*f*fd**2*r**2 + 168*C*D1**2*f*fd**2*r*s - 128*C*D1**2*f*fd**2*r + 60*C*D1**2*f*fd**2*s**2 - 96*C*D1**2*f*fd**2*s + 28*C*D1**2*f*fd**2 - 144*C*D1*Dd*f**3*r**2 - 224*C*D1*Dd*f**3*r*s + 200*C*D1*Dd*f**3*r - 80*C*D1*Dd*f**3*s**2 + 152*C*D1*Dd*f**3*s - 92*C*D1*Dd*f**3 + 432*C*D1*Dd*f**2*fd*r**2 + 672*C*D1*Dd*f**2*fd*r*s - 556*C*D1*Dd*f**2*fd*r + 240*C*D1*Dd*f**2*fd*s**2 - 420*C*D1*Dd*f**2*fd*s + 176*C*D1*Dd*f**2*fd + 72*C*D1*Ddd*f**3*r**2 + 112*C*D1*Ddd*f**3*r*s - 100*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s**2 - 76*C*D1*Ddd*f**3*s + 46*C*D1*Ddd*f**3 + 216*C*Dd**2*f**3*r**2 + 336*C*Dd**2*f**3*r*s - 300*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s**2 - 228*C*Dd**2*f**3*s + 92*C*Dd**2*f**3 - 324*D1**2*K*b1*f*fd*r**2 - 504*D1**2*K*b1*f*fd*r*s + 252*D1**2*K*b1*f*fd*r - 180*D1**2*K*b1*f*fd*s**2 + 180*D1**2*K*b1*f*fd*s - 90*D1**2*K*b1*f*fd + 162*D1**2*K*b1*f*fdd*r**2 + 252*D1**2*K*b1*f*fdd*r*s - 126*D1**2*K*b1*f*fdd*r + 90*D1**2*K*b1*f*fdd*s**2 - 90*D1**2*K*b1*f*fdd*s + 45*D1**2*K*b1*f*fdd + 162*D1**2*K*b1*fd**2*r**2 + 252*D1**2*K*b1*fd**2*r*s - 126*D1**2*K*b1*fd**2*r + 90*D1**2*K*b1*fd**2*s**2 - 90*D1**2*K*b1*fd**2*s + 81*D1**2*K*bdd1*f**2*r**2 + 126*D1**2*K*bdd1*f**2*r*s - 162*D1**2*K*bdd1*f**2*r + 45*D1**2*K*bdd1*f**2*s**2 - 126*D1**2*K*bdd1*f**2*s + 81*D1**2*K*bdd1*f**2 + 54*D1**2*b1*f**2*fd*r**2 + 54*D1**2*b1*f**2*fd*r*s - 54*D1**2*b1*f**2*fd*r - 18*D1**2*b1*f**2*fd*s + 18*D1**2*b1*f**2*fd - 54*D1**2*b1*f**2*fdd*r**2 - 54*D1**2*b1*f**2*fdd*r*s + 54*D1**2*b1*f**2*fdd*r + 18*D1**2*b1*f**2*fdd*s - 18*D1**2*b1*f**2*fdd - 108*D1**2*b1*f*fd**2*r**2 - 108*D1**2*b1*f*fd**2*r*s + 108*D1**2*b1*f*fd**2*r + 36*D1**2*b1*f*fd**2*s - 18*D1**2*b1*f*fd**2 + 72*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 36*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 180*D1**2*b2*f*fd*r**2 - 360*D1**2*b2*f*fd*r*s + 180*D1**2*b2*f*fd*r - 180*D1**2*b2*f*fd*s**2 + 180*D1**2*b2*f*fd*s - 90*D1**2*b2*f*fd + 90*D1**2*b2*f*fdd*r**2 + 180*D1**2*b2*f*fdd*r*s - 90*D1**2*b2*f*fdd*r + 90*D1**2*b2*f*fdd*s**2 - 90*D1**2*b2*f*fdd*s + 45*D1**2*b2*f*fdd + 90*D1**2*b2*fd**2*r**2 + 180*D1**2*b2*fd**2*r*s - 90*D1**2*b2*fd**2*r + 90*D1**2*b2*fd**2*s**2 - 90*D1**2*b2*fd**2*s - 18*D1**2*bdd1*f**3*r**2 - 18*D1**2*bdd1*f**3*r*s + 36*D1**2*bdd1*f**3*r + 18*D1**2*bdd1*f**3*s - 18*D1**2*bdd1*f**3 - 18*D1**2*bdd1*f**2*r**2 - 18*D1**2*bdd1*f**2*r*s + 36*D1**2*bdd1*f**2*r + 18*D1**2*bdd1*f**2*s - 18*D1**2*bdd1*f**2 + 45*D1**2*bdd2*f**2*r**2 + 90*D1**2*bdd2*f**2*r*s - 90*D1**2*bdd2*f**2*r + 45*D1**2*bdd2*f**2*s**2 - 90*D1**2*bdd2*f**2*s + 45*D1**2*bdd2*f**2 + 66*D1**2*f**2*fd*r**2 + 96*D1**2*f**2*fd*r*s - 76*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 52*D1**2*f**2*fd*s + 32*D1**2*f**2*fd - 33*D1**2*f**2*fdd*r**2 - 48*D1**2*f**2*fdd*r*s + 38*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 26*D1**2*f**2*fdd*s - 16*D1**2*f**2*fdd + 324*D1**2*f**2*gd2*r**2 + 504*D1**2*f**2*gd2*r*s - 648*D1**2*f**2*gd2*r + 180*D1**2*f**2*gd2*s**2 - 504*D1**2*f**2*gd2*s + 324*D1**2*f**2*gd2 - 162*D1**2*f**2*gdd2*r**2 - 252*D1**2*f**2*gdd2*r*s + 324*D1**2*f**2*gdd2*r - 90*D1**2*f**2*gdd2*s**2 + 252*D1**2*f**2*gdd2*s - 162*D1**2*f**2*gdd2 - 66*D1**2*f*fd**2*r**2 - 96*D1**2*f*fd**2*r*s + 76*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 52*D1**2*f*fd**2*s - 16*D1**2*f*fd**2 + 648*D1**2*f*fd*g2*r**2 + 1008*D1**2*f*fd*g2*r*s - 504*D1**2*f*fd*g2*r + 360*D1**2*f*fd*g2*s**2 - 360*D1**2*f*fd*g2*s + 180*D1**2*f*fd*g2 - 648*D1**2*f*fd*gd2*r**2 - 1008*D1**2*f*fd*gd2*r*s + 900*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 684*D1**2*f*fd*gd2*s - 252*D1**2*f*fd*gd2 - 324*D1**2*f*fdd*g2*r**2 - 504*D1**2*f*fdd*g2*r*s + 252*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 324*D1**2*fd**2*g2*r**2 - 504*D1**2*fd**2*g2*r*s + 252*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s - 648*D1*Dd*K*b1*f**2*r**2 - 1008*D1*Dd*K*b1*f**2*r*s + 900*D1*Dd*K*b1*f**2*r - 360*D1*Dd*K*b1*f**2*s**2 + 684*D1*Dd*K*b1*f**2*s - 414*D1*Dd*K*b1*f**2 + 1296*D1*Dd*K*b1*f*fd*r**2 + 2016*D1*Dd*K*b1*f*fd*r*s - 1404*D1*Dd*K*b1*f*fd*r + 720*D1*Dd*K*b1*f*fd*s**2 - 1044*D1*Dd*K*b1*f*fd*s + 342*D1*Dd*K*b1*f*fd + 72*D1*Dd*b1*f**3*r**2 + 72*D1*Dd*b1*f**3*r*s - 90*D1*Dd*b1*f**3*r - 36*D1*Dd*b1*f**3*s + 36*D1*Dd*b1*f**3 - 432*D1*Dd*b1*f**2*fd*r**2 - 432*D1*Dd*b1*f**2*fd*r*s + 486*D1*Dd*b1*f**2*fd*r + 180*D1*Dd*b1*f**2*fd*s - 126*D1*Dd*b1*f**2*fd + 144*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 180*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s + 72*D1*Dd*b1*f**2 - 288*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 252*D1*Dd*b1*f*fd*r + 72*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd - 360*D1*Dd*b2*f**2*r**2 - 720*D1*Dd*b2*f**2*r*s + 540*D1*Dd*b2*f**2*r - 360*D1*Dd*b2*f**2*s**2 + 540*D1*Dd*b2*f**2*s - 270*D1*Dd*b2*f**2 + 720*D1*Dd*b2*f*fd*r**2 + 1440*D1*Dd*b2*f*fd*r*s - 900*D1*Dd*b2*f*fd*r + 720*D1*Dd*b2*f*fd*s**2 - 900*D1*Dd*b2*f*fd*s + 270*D1*Dd*b2*f*fd + 88*D1*Dd*f**3*r**2 + 128*D1*Dd*f**3*r*s - 120*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 84*D1*Dd*f**3*s + 54*D1*Dd*f**3 - 264*D1*Dd*f**2*fd*r**2 - 384*D1*Dd*f**2*fd*r*s + 332*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 230*D1*Dd*f**2*fd*s - 102*D1*Dd*f**2*fd + 1296*D1*Dd*f**2*g2*r**2 + 2016*D1*Dd*f**2*g2*r*s - 1800*D1*Dd*f**2*g2*r + 720*D1*Dd*f**2*g2*s**2 - 1368*D1*Dd*f**2*g2*s + 828*D1*Dd*f**2*g2 - 1296*D1*Dd*f**2*gd2*r**2 - 2016*D1*Dd*f**2*gd2*r*s + 2196*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 1692*D1*Dd*f**2*gd2*s - 900*D1*Dd*f**2*gd2 - 2592*D1*Dd*f*fd*g2*r**2 - 4032*D1*Dd*f*fd*g2*r*s + 2808*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 2088*D1*Dd*f*fd*g2*s - 684*D1*Dd*f*fd*g2 + 324*D1*Ddd*K*b1*f**2*r**2 + 504*D1*Ddd*K*b1*f**2*r*s - 450*D1*Ddd*K*b1*f**2*r + 180*D1*Ddd*K*b1*f**2*s**2 - 342*D1*Ddd*K*b1*f**2*s + 207*D1*Ddd*K*b1*f**2 - 72*D1*Ddd*b1*f**3*r**2 - 72*D1*Ddd*b1*f**3*r*s + 90*D1*Ddd*b1*f**3*r + 36*D1*Ddd*b1*f**3*s - 36*D1*Ddd*b1*f**3 - 72*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 90*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s - 36*D1*Ddd*b1*f**2 + 180*D1*Ddd*b2*f**2*r**2 + 360*D1*Ddd*b2*f**2*r*s - 270*D1*Ddd*b2*f**2*r + 180*D1*Ddd*b2*f**2*s**2 - 270*D1*Ddd*b2*f**2*s + 135*D1*Ddd*b2*f**2 - 44*D1*Ddd*f**3*r**2 - 64*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 42*D1*Ddd*f**3*s - 27*D1*Ddd*f**3 - 648*D1*Ddd*f**2*g2*r**2 - 1008*D1*Ddd*f**2*g2*r*s + 900*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 684*D1*Ddd*f**2*g2*s - 414*D1*Ddd*f**2*g2 + 18*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (r + s - 1)*(K*(9*r + 5*s - 9) - 2*r + 2)) + fd*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(K*(36*r**2 + 56*r*s - 61*r + 20*s**2 - 47*s + 25) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) - 90*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 972*Dd**2*K*b1*f**2*r**2 + 1512*Dd**2*K*b1*f**2*r*s - 1350*Dd**2*K*b1*f**2*r + 540*Dd**2*K*b1*f**2*s**2 - 1026*Dd**2*K*b1*f**2*s + 414*Dd**2*K*b1*f**2 - 216*Dd**2*b1*f**3*r**2 - 216*Dd**2*b1*f**3*r*s + 270*Dd**2*b1*f**3*r + 108*Dd**2*b1*f**3*s - 72*Dd**2*b1*f**3 - 216*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 270*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s - 72*Dd**2*b1*f**2 + 540*Dd**2*b2*f**2*r**2 + 1080*Dd**2*b2*f**2*r*s - 810*Dd**2*b2*f**2*r + 540*Dd**2*b2*f**2*s**2 - 810*Dd**2*b2*f**2*s + 270*Dd**2*b2*f**2 - 132*Dd**2*f**3*r**2 - 192*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 126*Dd**2*f**3*s - 54*Dd**2*f**3 - 1944*Dd**2*f**2*g2*r**2 - 3024*Dd**2*f**2*g2*r*s + 2700*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 2052*Dd**2*f**2*g2*s - 828*Dd**2*f**2*g2)/(126*d**2*k3**5) + D1**2*Pk2*Pkd3*k2**4*st**4*(-16*C*D1**2*bd1*f**2*r**2 - 32*C*D1**2*bd1*f**2*r*s + 72*C*D1**2*bd1*f**2*r - 16*C*D1**2*bd1*f**2*s**2 + 72*C*D1**2*bd1*f**2*s - 36*C*D1**2*bd1*f**2 + 32*C*D1**2*bd1*f*fd*r**2 + 64*C*D1**2*bd1*f*fd*r*s - 68*C*D1**2*bd1*f*fd*r + 32*C*D1**2*bd1*f*fd*s**2 - 68*C*D1**2*bd1*f*fd*s + 36*C*D1**2*bd1*f*fd + 8*C*D1**2*bdd1*f**2*r**2 + 16*C*D1**2*bdd1*f**2*r*s - 36*C*D1**2*bdd1*f**2*r + 8*C*D1**2*bdd1*f**2*s**2 - 36*C*D1**2*bdd1*f**2*s + 18*C*D1**2*bdd1*f**2 - 12*C*D1**2*f**2*fd*r**2 - 24*C*D1**2*f**2*fd*r*s + 16*C*D1**2*f**2*fd*r - 12*C*D1**2*f**2*fd*s**2 + 16*C*D1**2*f**2*fd*s - 8*C*D1**2*f**2*fd + 78*C*D1**2*f**2*fdd*r**2 + 132*C*D1**2*f**2*fdd*r*s - 96*C*D1**2*f**2*fdd*r + 54*C*D1**2*f**2*fdd*s**2 - 80*C*D1**2*f**2*fdd*s + 44*C*D1**2*f**2*fdd + 156*C*D1**2*f*fd**2*r**2 + 264*C*D1**2*f*fd**2*r*s - 192*C*D1**2*f*fd**2*r + 108*C*D1**2*f*fd**2*s**2 - 160*C*D1**2*f*fd**2*s + 44*C*D1**2*f*fd**2 + 64*C*D1*Dd*bd1*f**2*r**2 + 128*C*D1*Dd*bd1*f**2*r*s - 192*C*D1*Dd*bd1*f**2*r + 64*C*D1*Dd*bd1*f**2*s**2 - 192*C*D1*Dd*bd1*f**2*s + 108*C*D1*Dd*bd1*f**2 - 16*C*D1*Dd*f**3*r**2 - 32*C*D1*Dd*f**3*r*s + 24*C*D1*Dd*f**3*r - 16*C*D1*Dd*f**3*s**2 + 24*C*D1*Dd*f**3*s - 12*C*D1*Dd*f**3 + 624*C*D1*Dd*f**2*fd*r**2 + 1056*C*D1*Dd*f**2*fd*r*s - 828*C*D1*Dd*f**2*fd*r + 432*C*D1*Dd*f**2*fd*s**2 - 692*C*D1*Dd*f**2*fd*s + 272*C*D1*Dd*f**2*fd + 104*C*D1*Ddd*f**3*r**2 + 176*C*D1*Ddd*f**3*r*s - 148*C*D1*Ddd*f**3*r + 72*C*D1*Ddd*f**3*s**2 - 124*C*D1*Ddd*f**3*s + 70*C*D1*Ddd*f**3 + 312*C*Dd**2*f**3*r**2 + 528*C*Dd**2*f**3*r*s - 444*C*Dd**2*f**3*r + 216*C*Dd**2*f**3*s**2 - 372*C*Dd**2*f**3*s + 140*C*Dd**2*f**3 + 56*D1**2*K*bd1**2*f*r**2 + 112*D1**2*K*bd1**2*f*r*s - 182*D1**2*K*bd1**2*f*r + 56*D1**2*K*bd1**2*f*s**2 - 182*D1**2*K*bd1**2*f*s + 126*D1**2*K*bd1**2*f + 42*D1**2*K*bd1*f**2*r**2 + 28*D1**2*K*bd1*f**2*r*s - 84*D1**2*K*bd1*f**2*r - 14*D1**2*K*bd1*f**2*s**2 - 28*D1**2*K*bd1*f**2*s + 42*D1**2*K*bd1*f**2 + 140*D1**2*K*bd1*f*fd*r**2 + 392*D1**2*K*bd1*f*fd*r*s - 238*D1**2*K*bd1*f*fd*r + 252*D1**2*K*bd1*f*fd*s**2 - 322*D1**2*K*bd1*f*fd*s + 98*D1**2*K*bd1*f*fd + 35*D1**2*K*bdd1*f**2*r**2 + 98*D1**2*K*bdd1*f**2*r*s - 70*D1**2*K*bdd1*f**2*r + 63*D1**2*K*bdd1*f**2*s**2 - 98*D1**2*K*bdd1*f**2*s + 35*D1**2*K*bdd1*f**2 - 28*D1**2*bd1**2*f**2*r**2 - 28*D1**2*bd1**2*f**2*r*s + 42*D1**2*bd1**2*f**2*r + 14*D1**2*bd1**2*f**2*s - 14*D1**2*bd1**2*f**2 - 28*D1**2*bd1**2*f*r**2 - 28*D1**2*bd1**2*f*r*s + 42*D1**2*bd1**2*f*r + 14*D1**2*bd1**2*f*s - 14*D1**2*bd1**2*f + 70*D1**2*bd1*bd2*f*r**2 + 140*D1**2*bd1*bd2*f*r*s - 140*D1**2*bd1*bd2*f*r + 70*D1**2*bd1*bd2*f*s**2 - 140*D1**2*bd1*bd2*f*s + 70*D1**2*bd1*bd2*f - 2*D1**2*bd1*f**2*r**2 + 6*D1**2*bd1*f**2*r*s - 12*D1**2*bd1*f**2*r + 8*D1**2*bd1*f**2*s**2 - 22*D1**2*bd1*f**2*s + 4*D1**2*bd1*f**2 - 24*D1**2*bd1*f*fd*r**2 - 40*D1**2*bd1*f*fd*r*s + 42*D1**2*bd1*f*fd*r - 16*D1**2*bd1*f*fd*s**2 + 36*D1**2*bd1*f*fd*s - 20*D1**2*bd1*f*fd + 112*D1**2*bd1*f*g2*r**2 + 224*D1**2*bd1*f*g2*r*s - 504*D1**2*bd1*f*g2*r + 112*D1**2*bd1*f*g2*s**2 - 504*D1**2*bd1*f*g2*s + 252*D1**2*bd1*f*g2 - 112*D1**2*bd1*f*gd2*r**2 - 224*D1**2*bd1*f*gd2*r*s + 364*D1**2*bd1*f*gd2*r - 112*D1**2*bd1*f*gd2*s**2 + 364*D1**2*bd1*f*gd2*s - 252*D1**2*bd1*f*gd2 - 112*D1**2*bd1*fd*g2*r**2 - 224*D1**2*bd1*fd*g2*r*s + 112*D1**2*bd1*fd*g2*r - 112*D1**2*bd1*fd*g2*s**2 + 112*D1**2*bd1*fd*g2*s + 35*D1**2*bd2*f**2*r**2 + 70*D1**2*bd2*f**2*r*s - 70*D1**2*bd2*f**2*r + 35*D1**2*bd2*f**2*s**2 - 70*D1**2*bd2*f**2*s + 35*D1**2*bd2*f**2 - 6*D1**2*bdd1*f**2*r**2 - 10*D1**2*bdd1*f**2*r*s + 20*D1**2*bdd1*f**2*r - 4*D1**2*bdd1*f**2*s**2 + 18*D1**2*bdd1*f**2*s - 9*D1**2*bdd1*f**2 - 56*D1**2*bdd1*f*g2*r**2 - 112*D1**2*bdd1*f*g2*r*s + 252*D1**2*bdd1*f*g2*r - 56*D1**2*bdd1*f*g2*s**2 + 252*D1**2*bdd1*f*g2*s - 126*D1**2*bdd1*f*g2 + 6*D1**2*f**2*fd*r*s - 2*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 6*D1**2*f**2*fd*s + 2*D1**2*f**2*fd - 39*D1**2*f**2*fdd*r**2 - 66*D1**2*f**2*fdd*r*s + 48*D1**2*f**2*fdd*r - 27*D1**2*f**2*fdd*s**2 + 40*D1**2*f**2*fdd*s - 22*D1**2*f**2*fdd - 84*D1**2*f**2*gd2*r**2 - 56*D1**2*f**2*gd2*r*s + 168*D1**2*f**2*gd2*r + 28*D1**2*f**2*gd2*s**2 + 56*D1**2*f**2*gd2*s - 84*D1**2*f**2*gd2 - 70*D1**2*f**2*gdd2*r**2 - 196*D1**2*f**2*gdd2*r*s + 140*D1**2*f**2*gdd2*r - 126*D1**2*f**2*gdd2*s**2 + 196*D1**2*f**2*gdd2*s - 70*D1**2*f**2*gdd2 - 78*D1**2*f*fd**2*r**2 - 132*D1**2*f*fd**2*r*s + 96*D1**2*f*fd**2*r - 54*D1**2*f*fd**2*s**2 + 80*D1**2*f*fd**2*s - 22*D1**2*f*fd**2 - 168*D1**2*f*fd*g2*r**2 - 112*D1**2*f*fd*g2*r*s + 56*D1**2*f*fd*g2*r + 56*D1**2*f*fd*g2*s**2 - 56*D1**2*f*fd*g2*s + 28*D1**2*f*fd*g2 - 280*D1**2*f*fd*gd2*r**2 - 784*D1**2*f*fd*gd2*r*s + 476*D1**2*f*fd*gd2*r - 504*D1**2*f*fd*gd2*s**2 + 644*D1**2*f*fd*gd2*s - 196*D1**2*f*fd*gd2 - 140*D1**2*f*fdd*g2*r**2 - 392*D1**2*f*fdd*g2*r*s + 196*D1**2*f*fdd*g2*r - 252*D1**2*f*fdd*g2*s**2 + 252*D1**2*f*fdd*g2*s - 126*D1**2*f*fdd*g2 - 140*D1**2*fd**2*g2*r**2 - 392*D1**2*fd**2*g2*r*s + 196*D1**2*fd**2*g2*r - 252*D1**2*fd**2*g2*s**2 + 252*D1**2*fd**2*g2*s + 280*D1*Dd*K*bd1*f**2*r**2 + 784*D1*Dd*K*bd1*f**2*r*s - 518*D1*Dd*K*bd1*f**2*r + 504*D1*Dd*K*bd1*f**2*s**2 - 714*D1*Dd*K*bd1*f**2*s + 238*D1*Dd*K*bd1*f**2 - 48*D1*Dd*bd1*f**2*r**2 - 80*D1*Dd*bd1*f**2*r*s + 114*D1*Dd*bd1*f**2*r - 32*D1*Dd*bd1*f**2*s**2 + 100*D1*Dd*bd1*f**2*s - 58*D1*Dd*bd1*f**2 - 448*D1*Dd*bd1*f*g2*r**2 - 896*D1*Dd*bd1*f*g2*r*s + 1344*D1*Dd*bd1*f*g2*r - 448*D1*Dd*bd1*f*g2*s**2 + 1344*D1*Dd*bd1*f*g2*s - 756*D1*Dd*bd1*f*g2 + 8*D1*Dd*f**3*r*s - 2*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 2*D1*Dd*f**3 - 312*D1*Dd*f**2*fd*r**2 - 528*D1*Dd*f**2*fd*r*s + 414*D1*Dd*f**2*fd*r - 216*D1*Dd*f**2*fd*s**2 + 346*D1*Dd*f**2*fd*s - 136*D1*Dd*f**2*fd - 336*D1*Dd*f**2*g2*r**2 - 224*D1*Dd*f**2*g2*r*s + 392*D1*Dd*f**2*g2*r + 112*D1*Dd*f**2*g2*s**2 + 56*D1*Dd*f**2*g2*s - 140*D1*Dd*f**2*g2 - 560*D1*Dd*f**2*gd2*r**2 - 1568*D1*Dd*f**2*gd2*r*s + 1036*D1*Dd*f**2*gd2*r - 1008*D1*Dd*f**2*gd2*s**2 + 1428*D1*Dd*f**2*gd2*s - 476*D1*Dd*f**2*gd2 - 1120*D1*Dd*f*fd*g2*r**2 - 3136*D1*Dd*f*fd*g2*r*s + 1736*D1*Dd*f*fd*g2*r - 2016*D1*Dd*f*fd*g2*s**2 + 2296*D1*Dd*f*fd*g2*s - 644*D1*Dd*f*fd*g2 - 52*D1*Ddd*f**3*r**2 - 88*D1*Ddd*f**3*r*s + 74*D1*Ddd*f**3*r - 36*D1*Ddd*f**3*s**2 + 62*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 280*D1*Ddd*f**2*g2*r**2 - 784*D1*Ddd*f**2*g2*r*s + 476*D1*Ddd*f**2*g2*r - 504*D1*Ddd*f**2*g2*s**2 + 644*D1*Ddd*f**2*g2*s - 266*D1*Ddd*f**2*g2 - 70*D1*b2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 35*D1*b2*f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 156*Dd**2*f**3*r**2 - 264*Dd**2*f**3*r*s + 222*Dd**2*f**3*r - 108*Dd**2*f**3*s**2 + 186*Dd**2*f**3*s - 70*Dd**2*f**3 - 840*Dd**2*f**2*g2*r**2 - 2352*Dd**2*f**2*g2*r*s + 1428*Dd**2*f**2*g2*r - 1512*Dd**2*f**2*g2*s**2 + 1932*Dd**2*f**2*g2*s - 532*Dd**2*f**2*g2 + 7*b1**2*(D1**2*(-2*K*fd*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-4*r**2 - 4*r*(s - 1) + 2*s) + 4*fd*r*(r + s) + fdd*(K*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) - 2*r*(r + s))) + 2*D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(K*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + 2*Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + b1*(-32*C*D1**2*f*fd*r**2 - 64*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd*s + 4*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r**2 + 32*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*r + 16*C*D1**2*f*fdd*s**2 + 4*C*D1**2*f*fdd*s - 2*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r**2 + 32*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*r + 16*C*D1**2*fd**2*s**2 + 4*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 64*C*D1*Dd*f**2*r**2 - 128*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r**2 + 256*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r + 128*C*D1*Dd*f*fd*s**2 - 80*C*D1*Dd*f*fd*s - 12*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r**2 + 64*C*D1*Ddd*f**2*r*s - 48*C*D1*Ddd*f**2*r + 32*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 24*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r**2 + 192*C*Dd**2*f**2*r*s - 144*C*Dd**2*f**2*r + 96*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 + 56*D1**2*K*bdd1*f*r**2 + 112*D1**2*K*bdd1*f*r*s - 182*D1**2*K*bdd1*f*r + 56*D1**2*K*bdd1*f*s**2 - 182*D1**2*K*bdd1*f*s + 91*D1**2*K*bdd1*f + 84*D1**2*K*f*fd*r**2 + 56*D1**2*K*f*fd*r*s - 28*D1**2*K*f*fd*r - 28*D1**2*K*f*fd*s**2 + 28*D1**2*K*f*fd*s - 14*D1**2*K*f*fd + 70*D1**2*K*f*fdd*r**2 + 196*D1**2*K*f*fdd*r*s - 98*D1**2*K*f*fdd*r + 126*D1**2*K*f*fdd*s**2 - 126*D1**2*K*f*fdd*s + 63*D1**2*K*f*fdd + 70*D1**2*K*fd**2*r**2 + 196*D1**2*K*fd**2*r*s - 98*D1**2*K*fd**2*r + 126*D1**2*K*fd**2*s**2 - 126*D1**2*K*fd**2*s - 70*D1**2*b2*fd*r**2 - 140*D1**2*b2*fd*r*s - 70*D1**2*b2*fd*s**2 + 35*D1**2*b2*fdd*r**2 + 70*D1**2*b2*fdd*r*s + 35*D1**2*b2*fdd*s**2 - 28*D1**2*bdd1*f**2*r**2 - 28*D1**2*bdd1*f**2*r*s + 42*D1**2*bdd1*f**2*r + 14*D1**2*bdd1*f**2*s - 14*D1**2*bdd1*f**2 - 28*D1**2*bdd1*f*r**2 - 28*D1**2*bdd1*f*r*s + 42*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s - 14*D1**2*bdd1*f + 35*D1**2*bdd2*f*r**2 + 70*D1**2*bdd2*f*r*s - 70*D1**2*bdd2*f*r + 35*D1**2*bdd2*f*s**2 - 70*D1**2*bdd2*f*s + 35*D1**2*bdd2*f - 4*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s + 10*D1**2*f*fd*r + 16*D1**2*f*fd*s**2 + 2*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 8*D1**2*f*fdd*s**2 - D1**2*f*fdd + 112*D1**2*f*gd2*r**2 + 224*D1**2*f*gd2*r*s - 224*D1**2*f*gd2*r + 112*D1**2*f*gd2*s**2 - 224*D1**2*f*gd2*s + 112*D1**2*f*gd2 - 56*D1**2*f*gdd2*r**2 - 112*D1**2*f*gdd2*r*s + 112*D1**2*f*gdd2*r - 56*D1**2*f*gdd2*s**2 + 112*D1**2*f*gdd2*s - 56*D1**2*f*gdd2 - 12*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 8*D1**2*fd**2*s**2 + 10*D1**2*fd**2 + 112*D1**2*fd*g2*r**2 + 224*D1**2*fd*g2*r*s + 280*D1**2*fd*g2*r + 112*D1**2*fd*g2*s**2 + 280*D1**2*fd*g2*s - 140*D1**2*fd*g2 - 112*D1**2*fd*gd2*r**2 - 224*D1**2*fd*gd2*r*s - 28*D1**2*fd*gd2*r - 112*D1**2*fd*gd2*s**2 - 28*D1**2*fd*gd2*s + 140*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r**2 - 112*D1**2*fdd*g2*r*s - 140*D1**2*fdd*g2*r - 56*D1**2*fdd*g2*s**2 - 140*D1**2*fdd*g2*s + 70*D1**2*fdd*g2 + 168*D1*Dd*K*f**2*r**2 + 112*D1*Dd*K*f**2*r*s - 196*D1*Dd*K*f**2*r - 56*D1*Dd*K*f**2*s**2 - 28*D1*Dd*K*f**2*s + 70*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*r**2 + 1568*D1*Dd*K*f*fd*r*s - 868*D1*Dd*K*f*fd*r + 1008*D1*Dd*K*f*fd*s**2 - 1148*D1*Dd*K*f*fd*s + 322*D1*Dd*K*f*fd - 280*D1*Dd*b2*f*r**2 - 560*D1*Dd*b2*f*r*s + 420*D1*Dd*b2*f*r - 280*D1*Dd*b2*f*s**2 + 420*D1*Dd*b2*f*s - 210*D1*Dd*b2*f + 280*D1*Dd*b2*fd*r**2 + 560*D1*Dd*b2*fd*r*s - 210*D1*Dd*b2*fd*r + 280*D1*Dd*b2*fd*s**2 - 210*D1*Dd*b2*fd*s - 8*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r + 32*D1*Dd*f**2*s**2 - 28*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 76*D1*Dd*f*fd*r - 64*D1*Dd*f*fd*s**2 + 56*D1*Dd*f*fd*s - 4*D1*Dd*f*fd + 448*D1*Dd*f*g2*r**2 + 896*D1*Dd*f*g2*r*s - 672*D1*Dd*f*g2*r + 448*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 336*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r**2 - 896*D1*Dd*f*gd2*r*s + 784*D1*Dd*f*gd2*r - 448*D1*Dd*f*gd2*s**2 + 784*D1*Dd*f*gd2*s - 336*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r**2 - 896*D1*Dd*fd*g2*r*s - 224*D1*Dd*fd*g2*r - 448*D1*Dd*fd*g2*s**2 - 224*D1*Dd*fd*g2*s + 420*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*r**2 + 392*D1*Ddd*K*f**2*r*s - 238*D1*Ddd*K*f**2*r + 252*D1*Ddd*K*f**2*s**2 - 322*D1*Ddd*K*f**2*s + 133*D1*Ddd*K*f**2 + 140*D1*Ddd*b2*f*r**2 + 280*D1*Ddd*b2*f*r*s - 210*D1*Ddd*b2*f*r + 140*D1*Ddd*b2*f*s**2 - 210*D1*Ddd*b2*f*s + 105*D1*Ddd*b2*f - 24*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 34*D1*Ddd*f**2*r - 16*D1*Ddd*f**2*s**2 + 28*D1*Ddd*f**2*s - 16*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r**2 - 448*D1*Ddd*f*g2*r*s + 336*D1*Ddd*f*g2*r - 224*D1*Ddd*f*g2*s**2 + 336*D1*Ddd*f*g2*s - 168*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(K*(8*r**2 + 16*r*s - 26*r + 8*s**2 - 26*s + 13) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(K*(8*r**2 + r*(16*s - 3) + 8*s**2 - 3*s - 5) - 4*r**2 + r*(3 - 4*s) + s)) + Dd*f*(K*(32*r**2 + 64*r*s - 76*r + 32*s**2 - 76*s + 39) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 70*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 420*Dd**2*K*f**2*r**2 + 1176*Dd**2*K*f**2*r*s - 714*Dd**2*K*f**2*r + 756*Dd**2*K*f**2*s**2 - 966*Dd**2*K*f**2*s + 266*Dd**2*K*f**2 + 420*Dd**2*b2*f*r**2 + 840*Dd**2*b2*f*r*s - 630*Dd**2*b2*f*r + 420*Dd**2*b2*f*s**2 - 630*Dd**2*b2*f*s + 210*Dd**2*b2*f - 72*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 102*Dd**2*f**2*r - 48*Dd**2*f**2*s**2 + 84*Dd**2*f**2*s - 32*Dd**2*f**2 - 672*Dd**2*f*g2*r**2 - 1344*Dd**2*f*g2*r*s + 1008*Dd**2*f*g2*r - 672*Dd**2*f*g2*s**2 + 1008*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(70*d**2*k3**5) + D1**2*Pk2*Pkd3*k2**4*st**2*(D1*(175*D1*b2*bd1*f*(r + s - 1)**2 + 70*D1*bd1**2*(r + s - 1)*(5*K*f*(r + s - 1) - f*(2*C - 1)*(r + s) + 10*g2*(r + s)) + D1*bdd1*f*(f*(2*C - 1)*(83*r + 35*s - 35) - 350*g2*(r + s - 1))*(r + s - 1) - bd1*(D1*(f**2*(2*C*(33*r**2 + r*(26*s + 44) - 7*s**2 + 84*s - 42) - 19*r**2 - 2*r*(6*s + 29) + 7*s**2 - 84*s + 42) - f*fd*(4*C - 2)*(166*r**2 + r*(236*s - 201) + 70*s**2 - 129*s + 59) + 70*f*(g2*(r**2 + 2*r*(s - 6) + s**2 - 12*s + 6) + 10*gd2*(r + s - 1)**2) + 700*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(-f*(2*C - 1)*(332*r**2 + r*(472*s - 461) + 140*s**2 - 293*s + 153) + 350*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 175*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 35*b1**2*(D1**2*(5*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(4*C*(r + s - 1)**2 + K*(r**2 + 2*r*(s + 5) + s**2 + 10*s - 5) - 4*r**2 - 2*r*(3*s - 2) - 2*(s - 1)**2) + fdd*(-2*C*(r + s - 1)**2 + 5*K*s**2 + r**2*(5*K + 1) + 2*r*(5*K*s + s - 1) + s**2 - 2*s + 1) - 20*gd2*(r + s - 1)**2 + 10*gdd2*(r + s - 1)**2) + D1*(Dd*(f*(4*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 16*r**2 - 24*r*s + 22*r - 8*s**2 + 16*s - 10) + 2*fd*(4*r + 4*s - 3)*(-2*C*(r + s - 1) + 5*K*r + 5*K*s + r + s - 1) - 20*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(40*r + 40*s - 30)) + Ddd*(-2*C*f + 5*K*f + f + 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(-2*C*f + 5*K*f + f + 10*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - b1*(140*C*D1**2*bdd1*f*r**2 + 280*C*D1**2*bdd1*f*r*s - 140*C*D1**2*bdd1*f*r + 140*C*D1**2*bdd1*f*s**2 - 140*C*D1**2*bdd1*f*s + 70*C*D1**2*bdd1*f + 132*C*D1**2*f*fd*r**2 + 104*C*D1**2*f*fd*r*s - 272*C*D1**2*f*fd*r - 28*C*D1**2*f*fd*s**2 - 192*C*D1**2*f*fd*s + 136*C*D1**2*f*fd - 332*C*D1**2*f*fdd*r**2 - 472*C*D1**2*f*fdd*r*s + 332*C*D1**2*f*fdd*r - 140*C*D1**2*f*fdd*s**2 + 236*C*D1**2*f*fdd*s - 166*C*D1**2*f*fdd - 332*C*D1**2*fd**2*r**2 - 472*C*D1**2*fd**2*r*s + 332*C*D1**2*fd**2*r - 140*C*D1**2*fd**2*s**2 + 236*C*D1**2*fd**2*s + 264*C*D1*Dd*f**2*r**2 + 208*C*D1*Dd*f**2*r*s - 316*C*D1*Dd*f**2*r - 56*C*D1*Dd*f**2*s**2 - 76*C*D1*Dd*f**2*s + 118*C*D1*Dd*f**2 - 2656*C*D1*Dd*f*fd*r**2 - 3776*C*D1*Dd*f*fd*r*s + 3128*C*D1*Dd*f*fd*r - 1120*C*D1*Dd*f*fd*s**2 + 2168*C*D1*Dd*f*fd*s - 900*C*D1*Dd*f*fd - 664*C*D1*Ddd*f**2*r**2 - 944*C*D1*Ddd*f**2*r*s + 900*C*D1*Ddd*f**2*r - 280*C*D1*Ddd*f**2*s**2 + 612*C*D1*Ddd*f**2*s - 402*C*D1*Ddd*f**2 - 1992*C*Dd**2*f**2*r**2 - 2832*C*Dd**2*f**2*r*s + 2700*C*Dd**2*f**2*r - 840*C*Dd**2*f**2*s**2 + 1836*C*Dd**2*f**2*s - 804*C*Dd**2*f**2 + 350*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 350*D1**2*K*bdd1*f*r**2 - 700*D1**2*K*bdd1*f*r*s + 700*D1**2*K*bdd1*f*r - 350*D1**2*K*bdd1*f*s**2 + 700*D1**2*K*bdd1*f*s - 350*D1**2*K*bdd1*f - 175*D1**2*b2*fd*r**2 - 350*D1**2*b2*fd*r*s - 175*D1**2*b2*fd*s**2 - 175*D1**2*bd2*f*(r + s - 1)**2 - 70*D1**2*bdd1*f*r**2 - 140*D1**2*bdd1*f*r*s + 70*D1**2*bdd1*f*r - 70*D1**2*bdd1*f*s**2 + 70*D1**2*bdd1*f*s - 35*D1**2*bdd1*f - 700*D1**2*bdd1*g2*r**2 - 1400*D1**2*bdd1*g2*r*s + 700*D1**2*bdd1*g2*r - 700*D1**2*bdd1*g2*s**2 + 700*D1**2*bdd1*g2*s - 350*D1**2*bdd1*g2 - 38*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 108*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 + 82*D1**2*f*fd*s - 54*D1**2*f*fd + 166*D1**2*f*fdd*r**2 + 236*D1**2*f*fdd*r*s - 166*D1**2*f*fdd*r + 70*D1**2*f*fdd*s**2 - 118*D1**2*f*fdd*s + 83*D1**2*f*fdd + 70*D1**2*f*gd2*r**2 + 140*D1**2*f*gd2*r*s - 140*D1**2*f*gd2*r + 70*D1**2*f*gd2*s**2 - 140*D1**2*f*gd2*s + 70*D1**2*f*gd2 + 350*D1**2*f*gdd2*r**2 + 700*D1**2*f*gdd2*r*s - 700*D1**2*f*gdd2*r + 350*D1**2*f*gdd2*s**2 - 700*D1**2*f*gdd2*s + 350*D1**2*f*gdd2 + 166*D1**2*fd**2*r**2 + 236*D1**2*fd**2*r*s - 166*D1**2*fd**2*r + 70*D1**2*fd**2*s**2 - 118*D1**2*fd**2*s + 70*D1**2*fd*g2*r**2 + 140*D1**2*fd*g2*r*s + 700*D1**2*fd*g2*r + 70*D1**2*fd*g2*s**2 + 700*D1**2*fd*g2*s - 350*D1**2*fd*g2 + 700*D1**2*fd*gd2*r**2 + 1400*D1**2*fd*gd2*r*s - 700*D1**2*fd*gd2*r + 700*D1**2*fd*gd2*s**2 - 700*D1**2*fd*gd2*s + 350*D1**2*fdd*g2*r**2 + 700*D1**2*fdd*g2*r*s + 350*D1**2*fdd*g2*s**2 - 700*D1*Dd*b2*f*r**2 - 1400*D1*Dd*b2*f*r*s + 1050*D1*Dd*b2*f*r - 700*D1*Dd*b2*f*s**2 + 1050*D1*Dd*b2*f*s - 525*D1*Dd*b2*f - 76*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 88*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 + 10*D1*Dd*f**2*s - 31*D1*Dd*f**2 + 1328*D1*Dd*f*fd*r**2 + 1888*D1*Dd*f*fd*r*s - 1564*D1*Dd*f*fd*r + 560*D1*Dd*f*fd*s**2 - 1084*D1*Dd*f*fd*s + 450*D1*Dd*f*fd + 280*D1*Dd*f*g2*r**2 + 560*D1*Dd*f*g2*r*s - 420*D1*Dd*f*g2*r + 280*D1*Dd*f*g2*s**2 - 420*D1*Dd*f*g2*s + 210*D1*Dd*f*g2 + 2800*D1*Dd*f*gd2*r**2 + 5600*D1*Dd*f*gd2*r*s - 4900*D1*Dd*f*gd2*r + 2800*D1*Dd*f*gd2*s**2 - 4900*D1*Dd*f*gd2*s + 2100*D1*Dd*f*gd2 + 2800*D1*Dd*fd*g2*r**2 + 5600*D1*Dd*fd*g2*r*s - 2100*D1*Dd*fd*g2*r + 2800*D1*Dd*fd*g2*s**2 - 2100*D1*Dd*fd*g2*s + 332*D1*Ddd*f**2*r**2 + 472*D1*Ddd*f**2*r*s - 450*D1*Ddd*f**2*r + 140*D1*Ddd*f**2*s**2 - 306*D1*Ddd*f**2*s + 201*D1*Ddd*f**2 + 1400*D1*Ddd*f*g2*r**2 + 2800*D1*Ddd*f*g2*r*s - 2100*D1*Ddd*f*g2*r + 1400*D1*Ddd*f*g2*s**2 - 2100*D1*Ddd*f*g2*s + 1050*D1*Ddd*f*g2 - 35*D1*bd1*(D1*(f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*(2*r**2 + 4*r*s - 14*r + 2*s**2 - 14*s + 7) - 8*r**2 - 12*r*s + 10*r - 4*s**2 + 6*s - 4) + 2*fd*(r + s - 1)*(C*(-4*r - 4*s + 2) + 10*K*s + r*(10*K + 2) + 2*s - 1) - 20*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(C*(4*r + 4*s - 2) - 10*K*(r + s - 1) - 2*r - 2*s + 1) - 10*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 996*Dd**2*f**2*r**2 + 1416*Dd**2*f**2*r*s - 1350*Dd**2*f**2*r + 420*Dd**2*f**2*s**2 - 918*Dd**2*f**2*s + 402*Dd**2*f**2 + 4200*Dd**2*f*g2*r**2 + 8400*Dd**2*f*g2*r*s - 6300*Dd**2*f*g2*r + 4200*Dd**2*f*g2*s**2 - 6300*Dd**2*f*g2*s + 2100*Dd**2*f*g2))/(210*d**2*k3**5) + D1**2*Pk2*Pkd3*k2**2*st**6*(-24*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 24*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 8*C*D1**2*f**2*fd + 12*C*D1**2*f**2*fdd*r*s - 4*C*D1**2*f**2*fdd*r + 12*C*D1**2*f**2*fdd*s**2 - 12*C*D1**2*f**2*fdd*s + 4*C*D1**2*f**2*fdd + 24*C*D1**2*f*fd**2*r*s - 8*C*D1**2*f*fd**2*r + 24*C*D1**2*f*fd**2*s**2 - 24*C*D1**2*f*fd**2*s + 4*C*D1**2*f*fd**2 - 32*C*D1*Dd*f**3*r*s + 8*C*D1*Dd*f**3*r - 32*C*D1*Dd*f**3*s**2 + 32*C*D1*Dd*f**3*s - 8*C*D1*Dd*f**3 + 96*C*D1*Dd*f**2*fd*r*s - 28*C*D1*Dd*f**2*fd*r + 96*C*D1*Dd*f**2*fd*s**2 - 96*C*D1*Dd*f**2*fd*s + 20*C*D1*Dd*f**2*fd + 16*C*D1*Ddd*f**3*r*s - 4*C*D1*Ddd*f**3*r + 16*C*D1*Ddd*f**3*s**2 - 16*C*D1*Ddd*f**3*s + 4*C*D1*Ddd*f**3 + 48*C*Dd**2*f**3*r*s - 12*C*Dd**2*f**3*r + 48*C*Dd**2*f**3*s**2 - 48*C*Dd**2*f**3*s + 8*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r*s + 36*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r*s - 18*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r*s - 18*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s - 27*D1**2*b1*f**2*fd*r**2 - 27*D1**2*b1*f**2*fd*r*s + 27*D1**2*b1*f**2*fd*r + 9*D1**2*b1*f**2*fd*s - 9*D1**2*b1*f**2*fd + 27*D1**2*b1*f**2*fdd*r**2 + 27*D1**2*b1*f**2*fdd*r*s - 27*D1**2*b1*f**2*fdd*r - 9*D1**2*b1*f**2*fdd*s + 9*D1**2*b1*f**2*fdd + 54*D1**2*b1*f*fd**2*r**2 + 54*D1**2*b1*f*fd**2*r*s - 54*D1**2*b1*f*fd**2*r - 18*D1**2*b1*f*fd**2*s + 9*D1**2*b1*f*fd**2 - 36*D1**2*b1*f*fd*r**2 - 36*D1**2*b1*f*fd*r*s + 18*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fdd*r**2 + 18*D1**2*b1*f*fdd*r*s - 9*D1**2*b1*f*fdd*r + 18*D1**2*b1*fd**2*r**2 + 18*D1**2*b1*fd**2*r*s - 9*D1**2*b1*fd**2*r - 72*D1**2*b2*f*fd*r*s + 36*D1**2*b2*f*fd*r - 72*D1**2*b2*f*fd*s**2 + 72*D1**2*b2*f*fd*s - 36*D1**2*b2*f*fd + 36*D1**2*b2*f*fdd*r*s - 18*D1**2*b2*f*fdd*r + 36*D1**2*b2*f*fdd*s**2 - 36*D1**2*b2*f*fdd*s + 18*D1**2*b2*f*fdd + 36*D1**2*b2*fd**2*r*s - 18*D1**2*b2*fd**2*r + 36*D1**2*b2*fd**2*s**2 - 36*D1**2*b2*fd**2*s - 36*D1**2*bd2*f**2*r*s - 36*D1**2*bd2*f**2*s**2 + 36*D1**2*bd2*f**2*s + 72*D1**2*bd2*f*fd*r*s - 18*D1**2*bd2*f*fd*r + 72*D1**2*bd2*f*fd*s**2 - 72*D1**2*bd2*f*fd*s + 18*D1**2*bd2*f*fd + 9*D1**2*bdd1*f**2*(r + s - 1)*(2*K*s + f*(r - 1) + r - 1) + 18*D1**2*bdd2*f**2*r*s + 18*D1**2*bdd2*f**2*s**2 - 18*D1**2*bdd2*f**2*s - 6*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s + 2*D1**2*f**2*fd*r + 12*D1**2*f**2*fd*s**2 - 10*D1**2*f**2*fd*s + 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 3*D1**2*f**2*fdd*r*s - D1**2*f**2*fdd*r - 6*D1**2*f**2*fdd*s**2 + 5*D1**2*f**2*fdd*s - D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r*s + 72*D1**2*f**2*gd2*s**2 - 72*D1**2*f**2*gd2*s - 36*D1**2*f**2*gdd2*r*s - 36*D1**2*f**2*gdd2*s**2 + 36*D1**2*f**2*gdd2*s + 6*D1**2*f*fd**2*r**2 - 6*D1**2*f*fd**2*r*s - 2*D1**2*f*fd**2*r - 12*D1**2*f*fd**2*s**2 + 10*D1**2*f*fd**2*s - D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r*s - 72*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r*s + 36*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 144*D1**2*f*fd*gd2*s - 36*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r*s + 36*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r*s + 36*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r*s + 36*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 144*D1*Dd*K*b1*f**2*s - 36*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r*s - 108*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 288*D1*Dd*K*b1*f*fd*s + 72*D1*Dd*K*b1*f*fd - 36*D1*Dd*b1*f**3*r**2 - 36*D1*Dd*b1*f**3*r*s + 45*D1*Dd*b1*f**3*r + 18*D1*Dd*b1*f**3*s - 18*D1*Dd*b1*f**3 + 216*D1*Dd*b1*f**2*fd*r**2 + 216*D1*Dd*b1*f**2*fd*r*s - 243*D1*Dd*b1*f**2*fd*r - 90*D1*Dd*b1*f**2*fd*s + 63*D1*Dd*b1*f**2*fd - 72*D1*Dd*b1*f**2*r**2 - 72*D1*Dd*b1*f**2*r*s + 90*D1*Dd*b1*f**2*r + 36*D1*Dd*b1*f**2*s - 36*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 144*D1*Dd*b1*f*fd*r*s - 126*D1*Dd*b1*f*fd*r - 36*D1*Dd*b1*f*fd*s + 18*D1*Dd*b1*f*fd - 144*D1*Dd*b2*f**2*r*s + 36*D1*Dd*b2*f**2*r - 144*D1*Dd*b2*f**2*s**2 + 144*D1*Dd*b2*f**2*s - 36*D1*Dd*b2*f**2 + 288*D1*Dd*b2*f*fd*r*s - 108*D1*Dd*b2*f*fd*r + 288*D1*Dd*b2*f*fd*s**2 - 288*D1*Dd*b2*f*fd*s + 72*D1*Dd*b2*f*fd + 144*D1*Dd*bd2*f**2*r*s - 18*D1*Dd*bd2*f**2*r + 144*D1*Dd*bd2*f**2*s**2 - 144*D1*Dd*bd2*f**2*s + 18*D1*Dd*bd2*f**2 - 8*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r + 16*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 24*D1*Dd*f**2*fd*r**2 - 24*D1*Dd*f**2*fd*r*s - 13*D1*Dd*f**2*fd*r - 48*D1*Dd*f**2*fd*s**2 + 38*D1*Dd*f**2*fd*s - 3*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r*s - 72*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 288*D1*Dd*f**2*g2*s + 72*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r*s + 36*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 288*D1*Dd*f**2*gd2*s - 36*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r*s + 216*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 576*D1*Dd*f*fd*g2*s - 144*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r*s - 18*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 72*D1*Ddd*K*b1*f**2*s + 18*D1*Ddd*K*b1*f**2 + 36*D1*Ddd*b1*f**3*r**2 + 36*D1*Ddd*b1*f**3*r*s - 45*D1*Ddd*b1*f**3*r - 18*D1*Ddd*b1*f**3*s + 18*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 36*D1*Ddd*b1*f**2*r*s - 45*D1*Ddd*b1*f**2*r - 18*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 + 72*D1*Ddd*b2*f**2*r*s - 18*D1*Ddd*b2*f**2*r + 72*D1*Ddd*b2*f**2*s**2 - 72*D1*Ddd*b2*f**2*s + 18*D1*Ddd*b2*f**2 + 4*D1*Ddd*f**3*r**2 - 4*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r - 8*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 144*D1*Ddd*f**2*g2*r*s + 36*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 144*D1*Ddd*f**2*g2*s - 36*D1*Ddd*f**2*g2 - 9*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) + f*(fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + (2*r + 2*s - 2)*(2*K*s + r - 1)) - fd*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(2*K*(8*r*s - r + 8*s**2 - 8*s + 1) + f*(8*r**2 + r*(8*s - 13) - 6*s + 5) + 8*r**2 + 8*r*s - 13*r - 6*s + 5)) + 216*Dd**2*K*b1*f**2*r*s - 54*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 216*Dd**2*K*b1*f**2*s + 36*Dd**2*K*b1*f**2 + 108*Dd**2*b1*f**3*r**2 + 108*Dd**2*b1*f**3*r*s - 135*Dd**2*b1*f**3*r - 54*Dd**2*b1*f**3*s + 36*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 108*Dd**2*b1*f**2*r*s - 135*Dd**2*b1*f**2*r - 54*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 + 216*Dd**2*b2*f**2*r*s - 54*Dd**2*b2*f**2*r + 216*Dd**2*b2*f**2*s**2 - 216*Dd**2*b2*f**2*s + 36*Dd**2*b2*f**2 + 12*Dd**2*f**3*r**2 - 12*Dd**2*f**3*r*s - 9*Dd**2*f**3*r - 24*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 432*Dd**2*f**2*g2*r*s + 108*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 432*Dd**2*f**2*g2*s - 72*Dd**2*f**2*g2)/(63*d**2*k3**3) + D1**2*Pk2*Pkd3*k2**2*st**4*(10*C*D1**2*bdd1*f**2*r**2 + 12*C*D1**2*bdd1*f**2*r*s + 2*C*D1**2*bdd1*f**2*s**2 + 66*C*D1**2*f**2*fd*r**2 + 132*C*D1**2*f**2*fd*r*s - 88*C*D1**2*f**2*fd*r + 66*C*D1**2*f**2*fd*s**2 - 88*C*D1**2*f**2*fd*s + 44*C*D1**2*f**2*fd - 78*C*D1**2*f**2*fdd*r**2 - 132*C*D1**2*f**2*fdd*r*s + 96*C*D1**2*f**2*fdd*r - 54*C*D1**2*f**2*fdd*s**2 + 80*C*D1**2*f**2*fdd*s - 44*C*D1**2*f**2*fdd - 156*C*D1**2*f*fd**2*r**2 - 264*C*D1**2*f*fd**2*r*s + 192*C*D1**2*f*fd**2*r - 108*C*D1**2*f*fd**2*s**2 + 160*C*D1**2*f*fd**2*s - 44*C*D1**2*f*fd**2 + 88*C*D1*Dd*f**3*r**2 + 176*C*D1*Dd*f**3*r*s - 132*C*D1*Dd*f**3*r + 88*C*D1*Dd*f**3*s**2 - 132*C*D1*Dd*f**3*s + 66*C*D1*Dd*f**3 - 624*C*D1*Dd*f**2*fd*r**2 - 1056*C*D1*Dd*f**2*fd*r*s + 828*C*D1*Dd*f**2*fd*r - 432*C*D1*Dd*f**2*fd*s**2 + 692*C*D1*Dd*f**2*fd*s - 272*C*D1*Dd*f**2*fd - 104*C*D1*Ddd*f**3*r**2 - 176*C*D1*Ddd*f**3*r*s + 148*C*D1*Ddd*f**3*r - 72*C*D1*Ddd*f**3*s**2 + 124*C*D1*Ddd*f**3*s - 70*C*D1*Ddd*f**3 - 312*C*Dd**2*f**3*r**2 - 528*C*Dd**2*f**3*r*s + 444*C*Dd**2*f**3*r - 216*C*Dd**2*f**3*s**2 + 372*C*Dd**2*f**3*s - 140*C*Dd**2*f**3 - 35*D1**2*K*bdd1*f**2*r**2 - 98*D1**2*K*bdd1*f**2*r*s + 70*D1**2*K*bdd1*f**2*r - 63*D1**2*K*bdd1*f**2*s**2 + 98*D1**2*K*bdd1*f**2*s - 35*D1**2*K*bdd1*f**2 + 7*D1**2*b2*bdd1*f*r**2 + 14*D1**2*b2*bdd1*f*r*s + 7*D1**2*b2*bdd1*f*s**2 + 42*D1**2*b2*f*fd*r**2 + 196*D1**2*b2*f*fd*r*s - 98*D1**2*b2*f*fd*r + 154*D1**2*b2*f*fd*s**2 - 154*D1**2*b2*f*fd*s + 77*D1**2*b2*f*fd - 70*D1**2*b2*f*fdd*r**2 - 196*D1**2*b2*f*fdd*r*s + 98*D1**2*b2*f*fdd*r - 126*D1**2*b2*f*fdd*s**2 + 126*D1**2*b2*f*fdd*s - 63*D1**2*b2*f*fdd - 70*D1**2*b2*fd**2*r**2 - 196*D1**2*b2*fd**2*r*s + 98*D1**2*b2*fd**2*r - 126*D1**2*b2*fd**2*s**2 + 126*D1**2*b2*fd**2*s - 14*D1**2*bd1**2*f*(-5*K*r**2 - 6*K*r*s + 5*K*r - K*s**2 + 3*K*s + f*(r - 1) + r - 1) + 21*D1**2*bd2*f**2*r**2 + 98*D1**2*bd2*f**2*r*s - 42*D1**2*bd2*f**2*r + 77*D1**2*bd2*f**2*s**2 - 98*D1**2*bd2*f**2*s + 21*D1**2*bd2*f**2 - 140*D1**2*bd2*f*fd*r**2 - 392*D1**2*bd2*f*fd*r*s + 238*D1**2*bd2*f*fd*r - 252*D1**2*bd2*f*fd*s**2 + 322*D1**2*bd2*f*fd*s - 98*D1**2*bd2*f*fd - 5*D1**2*bdd1*f**2*r**2 - 6*D1**2*bdd1*f**2*r*s - 2*D1**2*bdd1*f**2*r - D1**2*bdd1*f**2*s**2 - 70*D1**2*bdd1*f*g2*r**2 - 84*D1**2*bdd1*f*g2*r*s - 14*D1**2*bdd1*f*g2*s**2 - 35*D1**2*bdd2*f**2*r**2 - 98*D1**2*bdd2*f**2*r*s + 70*D1**2*bdd2*f**2*r - 63*D1**2*bdd2*f**2*s**2 + 98*D1**2*bdd2*f**2*s - 35*D1**2*bdd2*f**2 - 27*D1**2*f**2*fd*r**2 - 60*D1**2*f**2*fd*r*s + 38*D1**2*f**2*fd*r - 33*D1**2*f**2*fd*s**2 + 42*D1**2*f**2*fd*s - 20*D1**2*f**2*fd + 39*D1**2*f**2*fdd*r**2 + 66*D1**2*f**2*fdd*r*s - 48*D1**2*f**2*fdd*r + 27*D1**2*f**2*fdd*s**2 - 40*D1**2*f**2*fdd*s + 22*D1**2*f**2*fdd - 42*D1**2*f**2*gd2*r**2 - 196*D1**2*f**2*gd2*r*s + 84*D1**2*f**2*gd2*r - 154*D1**2*f**2*gd2*s**2 + 196*D1**2*f**2*gd2*s - 42*D1**2*f**2*gd2 + 70*D1**2*f**2*gdd2*r**2 + 196*D1**2*f**2*gdd2*r*s - 140*D1**2*f**2*gdd2*r + 126*D1**2*f**2*gdd2*s**2 - 196*D1**2*f**2*gdd2*s + 70*D1**2*f**2*gdd2 + 78*D1**2*f*fd**2*r**2 + 132*D1**2*f*fd**2*r*s - 96*D1**2*f*fd**2*r + 54*D1**2*f*fd**2*s**2 - 80*D1**2*f*fd**2*s + 22*D1**2*f*fd**2 - 84*D1**2*f*fd*g2*r**2 - 392*D1**2*f*fd*g2*r*s + 196*D1**2*f*fd*g2*r - 308*D1**2*f*fd*g2*s**2 + 308*D1**2*f*fd*g2*s - 154*D1**2*f*fd*g2 + 280*D1**2*f*fd*gd2*r**2 + 784*D1**2*f*fd*gd2*r*s - 476*D1**2*f*fd*gd2*r + 504*D1**2*f*fd*gd2*s**2 - 644*D1**2*f*fd*gd2*s + 196*D1**2*f*fd*gd2 + 140*D1**2*f*fdd*g2*r**2 + 392*D1**2*f*fdd*g2*r*s - 196*D1**2*f*fdd*g2*r + 252*D1**2*f*fdd*g2*s**2 - 252*D1**2*f*fdd*g2*s + 126*D1**2*f*fdd*g2 + 140*D1**2*fd**2*g2*r**2 + 392*D1**2*fd**2*g2*r*s - 196*D1**2*fd**2*g2*r + 252*D1**2*fd**2*g2*s**2 - 252*D1**2*fd**2*g2*s + 84*D1*Dd*b2*f**2*r**2 + 392*D1*Dd*b2*f**2*r*s - 182*D1*Dd*b2*f**2*r + 308*D1*Dd*b2*f**2*s**2 - 350*D1*Dd*b2*f**2*s + 119*D1*Dd*b2*f**2 - 560*D1*Dd*b2*f*fd*r**2 - 1568*D1*Dd*b2*f*fd*r*s + 868*D1*Dd*b2*f*fd*r - 1008*D1*Dd*b2*f*fd*s**2 + 1148*D1*Dd*b2*f*fd*s - 322*D1*Dd*b2*f*fd - 280*D1*Dd*bd2*f**2*r**2 - 784*D1*Dd*bd2*f**2*r*s + 518*D1*Dd*bd2*f**2*r - 504*D1*Dd*bd2*f**2*s**2 + 714*D1*Dd*bd2*f**2*s - 238*D1*Dd*bd2*f**2 - 36*D1*Dd*f**3*r**2 - 80*D1*Dd*f**3*r*s + 56*D1*Dd*f**3*r - 44*D1*Dd*f**3*s**2 + 62*D1*Dd*f**3*s - 29*D1*Dd*f**3 + 312*D1*Dd*f**2*fd*r**2 + 528*D1*Dd*f**2*fd*r*s - 414*D1*Dd*f**2*fd*r + 216*D1*Dd*f**2*fd*s**2 - 346*D1*Dd*f**2*fd*s + 136*D1*Dd*f**2*fd - 168*D1*Dd*f**2*g2*r**2 - 784*D1*Dd*f**2*g2*r*s + 364*D1*Dd*f**2*g2*r - 616*D1*Dd*f**2*g2*s**2 + 700*D1*Dd*f**2*g2*s - 238*D1*Dd*f**2*g2 + 560*D1*Dd*f**2*gd2*r**2 + 1568*D1*Dd*f**2*gd2*r*s - 1036*D1*Dd*f**2*gd2*r + 1008*D1*Dd*f**2*gd2*s**2 - 1428*D1*Dd*f**2*gd2*s + 476*D1*Dd*f**2*gd2 + 1120*D1*Dd*f*fd*g2*r**2 + 3136*D1*Dd*f*fd*g2*r*s - 1736*D1*Dd*f*fd*g2*r + 2016*D1*Dd*f*fd*g2*s**2 - 2296*D1*Dd*f*fd*g2*s + 644*D1*Dd*f*fd*g2 - 140*D1*Ddd*b2*f**2*r**2 - 392*D1*Ddd*b2*f**2*r*s + 238*D1*Ddd*b2*f**2*r - 252*D1*Ddd*b2*f**2*s**2 + 322*D1*Ddd*b2*f**2*s - 133*D1*Ddd*b2*f**2 + 52*D1*Ddd*f**3*r**2 + 88*D1*Ddd*f**3*r*s - 74*D1*Ddd*f**3*r + 36*D1*Ddd*f**3*s**2 - 62*D1*Ddd*f**3*s + 35*D1*Ddd*f**3 + 280*D1*Ddd*f**2*g2*r**2 + 784*D1*Ddd*f**2*g2*r*s - 476*D1*Ddd*f**2*g2*r + 504*D1*Ddd*f**2*g2*s**2 - 644*D1*Ddd*f**2*g2*s + 266*D1*Ddd*f**2*g2 + D1*bd1*(D1*(f**2*(-4*C*s**2 + 7*K*(3*r**2 + 2*r*(7*s - 3) + 11*s**2 - 14*s + 3) - 2*r**2*(10*C - 12) + 2*r*(-12*C*s + 13*s - 12) + 2*s**2 - 14*s + 14) - 2*f*(7*bd2*(-r**2 - 2*r*s + r - s**2 + s) + fd*(-4*C*s**2 + 8*C*s + 7*K*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) + r**2*(10 - 20*C) + r*(-24*C*s + 16*C + 12*s - 7) + 2*s**2 - 4*s - 1) + 14*gd2*(5*r**2 + r*(6*s - 5) + s*(s - 3)) + 7*(r + s)*(b2*(r + s) - 2*g2*(5*r + s))) + 14*fd*(b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(5*r**2 + r*(6*s - 3) + s*(s - 1)))) - 2*Dd*f*(-7*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f*(-8*C*s**2 + 14*C*s + 7*K*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) + r**2*(20 - 40*C) + r*(-48*C*s + 26*C + 24*s - 9) + 4*s**2 - 7*s - 2) + 14*g2*(20*r**2 + r*(24*s - 13) + s*(4*s - 7))) - 14*b1*(-D1*(f*(-K*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) + r*(f + 2)) + fd*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1)) + Dd*f*(-K*(40*r**2 + 48*r*s - 46*r + 8*s**2 - 26*s + 13) + f*(4*r - 2) + 4*r - 2))) - 420*Dd**2*b2*f**2*r**2 - 1176*Dd**2*b2*f**2*r*s + 714*Dd**2*b2*f**2*r - 756*Dd**2*b2*f**2*s**2 + 966*Dd**2*b2*f**2*s - 266*Dd**2*b2*f**2 + 156*Dd**2*f**3*r**2 + 264*Dd**2*f**3*r*s - 222*Dd**2*f**3*r + 108*Dd**2*f**3*s**2 - 186*Dd**2*f**3*s + 70*Dd**2*f**3 + 840*Dd**2*f**2*g2*r**2 + 2352*Dd**2*f**2*g2*r*s - 1428*Dd**2*f**2*g2*r + 1512*Dd**2*f**2*g2*s**2 - 1932*Dd**2*f**2*g2*s + 532*Dd**2*f**2*g2 + 7*b1**2*(D1**2*(2*fd**2*(r - 1) - 2*fd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(f + 2)) + fdd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(2*f + 2))) + D1*(2*Dd*(-K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11) + fd*(K*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + f*(4*r - 2) + 4*r - 2)) + Ddd*K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11)) + 2*Dd**2*K*f*(30*r**2 + r*(36*s - 39) + 6*s**2 - 21*s + 11)) - b1*(40*C*D1**2*f*fd*r**2 + 48*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 32*C*D1**2*f*fd*s + 24*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r*s + 32*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 16*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r*s + 32*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 16*C*D1**2*fd**2*s - 12*C*D1**2*fd**2 + 80*C*D1*Dd*f**2*r**2 + 96*C*D1*Dd*f**2*r*s - 104*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 56*C*D1*Dd*f**2*s + 44*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 - 192*C*D1*Dd*f*fd*r*s + 232*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 120*C*D1*Dd*f*fd*s - 80*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 - 48*C*D1*Ddd*f**2*r*s + 52*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 28*C*D1*Ddd*f**2*s - 22*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 - 144*C*Dd**2*f**2*r*s + 156*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 84*C*Dd**2*f**2*s - 44*C*Dd**2*f**2 - 70*D1**2*K*bdd1*f*r**2 - 84*D1**2*K*bdd1*f*r*s + 70*D1**2*K*bdd1*f*r - 14*D1**2*K*bdd1*f*s**2 + 42*D1**2*K*bdd1*f*s - 35*D1**2*K*bdd1*f - 42*D1**2*K*f*fd*r**2 - 196*D1**2*K*f*fd*r*s + 98*D1**2*K*f*fd*r - 154*D1**2*K*f*fd*s**2 + 154*D1**2*K*f*fd*s - 77*D1**2*K*f*fd + 70*D1**2*K*f*fdd*r**2 + 196*D1**2*K*f*fdd*r*s - 98*D1**2*K*f*fdd*r + 126*D1**2*K*f*fdd*s**2 - 126*D1**2*K*f*fdd*s + 63*D1**2*K*f*fdd + 70*D1**2*K*fd**2*r**2 + 196*D1**2*K*fd**2*r*s - 98*D1**2*K*fd**2*r + 126*D1**2*K*fd**2*s**2 - 126*D1**2*K*fd**2*s + 14*D1**2*b2*fd*r**2 + 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*r + 14*D1**2*b2*fd*s**2 - 28*D1**2*b2*fd*s + 14*D1**2*b2*fd - 7*D1**2*b2*fdd*r**2 - 14*D1**2*b2*fdd*r*s + 14*D1**2*b2*fdd*r - 7*D1**2*b2*fdd*s**2 + 14*D1**2*b2*fdd*s - 7*D1**2*b2*fdd + 14*D1**2*bdd1*f**2*r + 14*D1**2*bdd1*f*r - 7*D1**2*bdd2*f*(r + s - 1)**2 - 48*D1**2*f*fd*r**2 - 52*D1**2*f*fd*r*s + 50*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 12*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s + 6*D1**2*f*fdd - 140*D1**2*f*gd2*r**2 - 168*D1**2*f*gd2*r*s + 280*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s - 140*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 84*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 + 10*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 18*D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 8*D1**2*fd**2*s + 8*D1**2*fd**2 - 140*D1**2*fd*g2*r**2 - 168*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 140*D1**2*fd*gd2*r**2 + 168*D1**2*fd*gd2*r*s - 224*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 112*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 + 70*D1**2*fdd*g2*r**2 + 84*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 84*D1*Dd*K*f**2*r**2 - 392*D1*Dd*K*f**2*r*s + 182*D1*Dd*K*f**2*r - 308*D1*Dd*K*f**2*s**2 + 350*D1*Dd*K*f**2*s - 119*D1*Dd*K*f**2 + 560*D1*Dd*K*f*fd*r**2 + 1568*D1*Dd*K*f*fd*r*s - 868*D1*Dd*K*f*fd*r + 1008*D1*Dd*K*f*fd*s**2 - 1148*D1*Dd*K*f*fd*s + 322*D1*Dd*K*f*fd + 56*D1*Dd*b2*f*r**2 + 112*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 56*D1*Dd*b2*f*s**2 - 84*D1*Dd*b2*f*s + 42*D1*Dd*b2*f - 56*D1*Dd*b2*fd*r**2 - 112*D1*Dd*b2*fd*r*s + 98*D1*Dd*b2*fd*r - 56*D1*Dd*b2*fd*s**2 + 98*D1*Dd*b2*fd*s - 42*D1*Dd*b2*fd - 96*D1*Dd*f**2*r**2 - 104*D1*Dd*f**2*r*s + 122*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 56*D1*Dd*f**2*s - 50*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 124*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 44*D1*Dd*f*fd - 560*D1*Dd*f*g2*r**2 - 672*D1*Dd*f*g2*r*s + 728*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 392*D1*Dd*f*g2*s - 308*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 672*D1*Dd*f*gd2*r*s - 924*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 532*D1*Dd*f*gd2*s + 364*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 672*D1*Dd*fd*g2*r*s - 700*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 308*D1*Dd*fd*g2*s + 196*D1*Dd*fd*g2 + 140*D1*Ddd*K*f**2*r**2 + 392*D1*Ddd*K*f**2*r*s - 238*D1*Ddd*K*f**2*r + 252*D1*Ddd*K*f**2*s**2 - 322*D1*Ddd*K*f**2*s + 133*D1*Ddd*K*f**2 - 28*D1*Ddd*b2*f*r**2 - 56*D1*Ddd*b2*f*r*s + 42*D1*Ddd*b2*f*r - 28*D1*Ddd*b2*f*s**2 + 42*D1*Ddd*b2*f*s - 21*D1*Ddd*b2*f + 20*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 26*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 14*D1*Ddd*f**2*s + 11*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r*s - 364*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 196*D1*Ddd*f*g2*s + 154*D1*Ddd*f*g2 + 14*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 420*Dd**2*K*f**2*r**2 + 1176*Dd**2*K*f**2*r*s - 714*Dd**2*K*f**2*r + 756*Dd**2*K*f**2*s**2 - 966*Dd**2*K*f**2*s + 266*Dd**2*K*f**2 - 84*Dd**2*b2*f*r**2 - 168*Dd**2*b2*f*r*s + 126*Dd**2*b2*f*r - 84*Dd**2*b2*f*s**2 + 126*Dd**2*b2*f*s - 42*Dd**2*b2*f + 60*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 78*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 42*Dd**2*f**2*s + 22*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r*s - 1092*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 588*Dd**2*f*g2*s + 308*Dd**2*f*g2))/(70*d**2*k3**3) + D1**2*Pk2*Pkd3*k2**2*st**2*(D1*(-14*D1*bd1**2*(f*(5*K*(4*r**2 + r*(4*s - 9) - 7*s + 5) + r**2*(7 - 10*C) - r*(10*C - 6)*(2*s - 1) - s*(10*C - 5)*(s - 1)) + 50*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bdd1*f*(-f*(2*C - 1)*(60*r**2 + 2*r*(30*s - 59) - 70*s + 35) + 70*g2*(4*r**2 + 2*r*(2*s - 5) - 10*s + 5)) + 35*b2*(2*D1*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 5*D1*bdd1*f*(r + s - 1)**2 + bd1*(D1*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 10*Dd*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + bd1*(-350*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(2*C*(71*r**2 + r*(78*s - 82) + 7*s**2 - 42*s + 21) - 71*r**2 + r*(68 - 78*s) - 7*s**2 + 42*s - 21) - 2*f*(fd*(2*C - 1)*(120*r**2 + r*(120*s - 149) - 65*s + 59) + 35*g2*(9*r**2 + 10*r*s - 6*r + s**2 - 6*s + 3) - 70*gd2*(4*r**2 + 4*r*s - 9*r - 7*s + 5)) + 280*fd*g2*r*(2*r + 2*s - 1)) + 2*Dd*f*(-f*(2*C - 1)*(240*r**2 + r*(240*s - 386) - 200*s + 153) + 70*g2*(16*r**2 + 2*r*(8*s - 15) - 24*s + 15)))) + 35*b1**3*(2*D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(2*Dd*(-20*K*r**2 - 40*K*r*s + 30*K*r - 20*K*s**2 + 30*K*s - 15*K + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 13*r + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) + Ddd*(5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 8*r**2 - 8*r*s + 10*r + 4*s - 4)) + 2*Dd**2*(15*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 7*b1**2*(-20*C*D1**2*fd*r**2 - 40*C*D1**2*fd*r*s + 40*C*D1**2*fd*r - 20*C*D1**2*fd*s**2 + 40*C*D1**2*fd*s - 20*C*D1**2*fd + 10*C*D1**2*fdd*r**2 + 20*C*D1**2*fdd*r*s - 20*C*D1**2*fdd*r + 10*C*D1**2*fdd*s**2 - 20*C*D1**2*fdd*s + 10*C*D1**2*fdd - 80*C*D1*Dd*f*r**2 - 160*C*D1*Dd*f*r*s + 120*C*D1*Dd*f*r - 80*C*D1*Dd*f*s**2 + 120*C*D1*Dd*f*s - 60*C*D1*Dd*f + 80*C*D1*Dd*fd*r**2 + 160*C*D1*Dd*fd*r*s - 140*C*D1*Dd*fd*r + 80*C*D1*Dd*fd*s**2 - 140*C*D1*Dd*fd*s + 60*C*D1*Dd*fd + 40*C*D1*Ddd*f*r**2 + 80*C*D1*Ddd*f*r*s - 60*C*D1*Ddd*f*r + 40*C*D1*Ddd*f*s**2 - 60*C*D1*Ddd*f*s + 30*C*D1*Ddd*f + 120*C*Dd**2*f*r**2 + 240*C*Dd**2*f*r*s - 180*C*Dd**2*f*r + 120*C*Dd**2*f*s**2 - 180*C*Dd**2*f*s + 60*C*Dd**2*f + 75*D1**2*K*bdd1*r**2 + 150*D1**2*K*bdd1*r*s - 100*D1**2*K*bdd1*r + 75*D1**2*K*bdd1*s**2 - 100*D1**2*K*bdd1*s + 50*D1**2*K*bdd1 + 45*D1**2*K*fd*r**2 + 50*D1**2*K*fd*r*s - 20*D1**2*K*fd*r + 5*D1**2*K*fd*s**2 + 20*D1**2*K*fd*s - 10*D1**2*K*fd - 20*D1**2*K*fdd*r**2 - 20*D1**2*K*fdd*r*s - 30*D1**2*K*fdd*r - 50*D1**2*K*fdd*s + 25*D1**2*K*fdd - 30*D1**2*bdd1*f*r**2 - 30*D1**2*bdd1*f*r*s + 30*D1**2*bdd1*f*r + 10*D1**2*bdd1*f*s - 10*D1**2*bdd1*f - 30*D1**2*bdd1*r**2 - 30*D1**2*bdd1*r*s + 30*D1**2*bdd1*r + 10*D1**2*bdd1*s - 10*D1**2*bdd1 + 5*D1**2*bdd2*r**2 + 10*D1**2*bdd2*r*s - 10*D1**2*bdd2*r + 5*D1**2*bdd2*s**2 - 10*D1**2*bdd2*s + 5*D1**2*bdd2 + 14*D1**2*fd*r**2 + 24*D1**2*fd*r*s - 18*D1**2*fd*r + 10*D1**2*fd*s**2 - 24*D1**2*fd*s + 14*D1**2*fd - 7*D1**2*fdd*r**2 - 12*D1**2*fdd*r*s + 14*D1**2*fdd*r - 5*D1**2*fdd*s**2 + 12*D1**2*fdd*s - 7*D1**2*fdd + 100*D1**2*gd2*r**2 + 200*D1**2*gd2*r*s - 200*D1**2*gd2*r + 100*D1**2*gd2*s**2 - 200*D1**2*gd2*s + 100*D1**2*gd2 - 50*D1**2*gdd2*r**2 - 100*D1**2*gdd2*r*s + 100*D1**2*gdd2*r - 50*D1**2*gdd2*s**2 + 100*D1**2*gdd2*s - 50*D1**2*gdd2 + 180*D1*Dd*K*f*r**2 + 200*D1*Dd*K*f*r*s - 230*D1*Dd*K*f*r + 20*D1*Dd*K*f*s**2 - 110*D1*Dd*K*f*s + 95*D1*Dd*K*f - 160*D1*Dd*K*fd*r**2 - 160*D1*Dd*K*fd*r*s - 20*D1*Dd*K*fd*r - 160*D1*Dd*K*fd*s + 110*D1*Dd*K*fd - 40*D1*Dd*b2*r**2 - 80*D1*Dd*b2*r*s + 60*D1*Dd*b2*r - 40*D1*Dd*b2*s**2 + 60*D1*Dd*b2*s - 30*D1*Dd*b2 + 56*D1*Dd*f*r**2 + 96*D1*Dd*f*r*s - 80*D1*Dd*f*r + 40*D1*Dd*f*s**2 - 68*D1*Dd*f*s + 38*D1*Dd*f - 56*D1*Dd*fd*r**2 - 96*D1*Dd*fd*r*s + 96*D1*Dd*fd*r - 40*D1*Dd*fd*s**2 + 82*D1*Dd*fd*s - 40*D1*Dd*fd + 400*D1*Dd*g2*r**2 + 800*D1*Dd*g2*r*s - 600*D1*Dd*g2*r + 400*D1*Dd*g2*s**2 - 600*D1*Dd*g2*s + 300*D1*Dd*g2 - 400*D1*Dd*gd2*r**2 - 800*D1*Dd*gd2*r*s + 700*D1*Dd*gd2*r - 400*D1*Dd*gd2*s**2 + 700*D1*Dd*gd2*s - 300*D1*Dd*gd2 - 80*D1*Ddd*K*f*r**2 - 80*D1*Ddd*K*f*r*s + 100*D1*Ddd*K*f*r + 40*D1*Ddd*K*f*s - 40*D1*Ddd*K*f + 20*D1*Ddd*b2*r**2 + 40*D1*Ddd*b2*r*s - 30*D1*Ddd*b2*r + 20*D1*Ddd*b2*s**2 - 30*D1*Ddd*b2*s + 15*D1*Ddd*b2 - 28*D1*Ddd*f*r**2 - 48*D1*Ddd*f*r*s + 40*D1*Ddd*f*r - 20*D1*Ddd*f*s**2 + 34*D1*Ddd*f*s - 19*D1*Ddd*f - 200*D1*Ddd*g2*r**2 - 400*D1*Ddd*g2*r*s + 300*D1*Ddd*g2*r - 200*D1*Ddd*g2*s**2 + 300*D1*Ddd*g2*s - 150*D1*Ddd*g2 + 10*D1*bd1*(D1*(-15*K*r**2 - 30*K*r*s + 20*K*r - 15*K*s**2 + 20*K*s - 10*K + f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 - 6*r*s + 9*r + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) + Dd*(5*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) - 24*r**2 - 24*r*s + 27*r + 10*s - 7)) - 10*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 240*Dd**2*K*f*r**2 - 240*Dd**2*K*f*r*s + 300*Dd**2*K*f*r + 120*Dd**2*K*f*s - 80*Dd**2*K*f + 60*Dd**2*b2*r**2 + 120*Dd**2*b2*r*s - 90*Dd**2*b2*r + 60*Dd**2*b2*s**2 - 90*Dd**2*b2*s + 30*Dd**2*b2 - 84*Dd**2*f*r**2 - 144*Dd**2*f*r*s + 120*Dd**2*f*r - 60*Dd**2*f*s**2 + 102*Dd**2*f*s - 38*Dd**2*f - 600*Dd**2*g2*r**2 - 1200*Dd**2*g2*r*s + 900*Dd**2*g2*r - 600*Dd**2*g2*s**2 + 900*Dd**2*g2*s - 300*Dd**2*g2) - b1*(-140*C*D1**2*bdd1*f*r**2 - 280*C*D1**2*bdd1*f*r*s + 140*C*D1**2*bdd1*f*r - 140*C*D1**2*bdd1*f*s**2 + 140*C*D1**2*bdd1*f*s - 70*C*D1**2*bdd1*f - 284*C*D1**2*f*fd*r**2 - 312*C*D1**2*f*fd*r*s + 276*C*D1**2*f*fd*r - 28*C*D1**2*f*fd*s**2 + 100*C*D1**2*f*fd*s - 114*C*D1**2*f*fd + 240*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 124*C*D1**2*f*fdd*r + 20*C*D1**2*f*fdd*s + 50*C*D1**2*f*fdd + 240*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s - 124*C*D1**2*fd**2*r + 20*C*D1**2*fd**2*s - 116*C*D1**2*fd**2 - 568*C*D1*Dd*f**2*r**2 - 624*C*D1*Dd*f**2*r*s + 724*C*D1*Dd*f**2*r - 56*C*D1*Dd*f**2*s**2 + 340*C*D1*Dd*f**2*s - 298*C*D1*Dd*f**2 + 1920*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 1696*C*D1*Dd*f*fd*r - 400*C*D1*Dd*f*fd*s + 228*C*D1*Dd*f*fd + 480*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 600*C*D1*Ddd*f**2*r - 240*C*D1*Ddd*f**2*s + 240*C*D1*Ddd*f**2 + 1440*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1800*C*Dd**2*f**2*r - 720*C*Dd**2*f**2*s + 480*C*Dd**2*f**2 + 280*D1**2*K*bdd1*f*r**2 + 280*D1**2*K*bdd1*f*r*s - 630*D1**2*K*bdd1*f*r - 490*D1**2*K*bdd1*f*s + 315*D1**2*K*bdd1*f + 70*D1**2*bd1**2*(-5*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*r**2 + 6*r*s - 6*r - 2*s + 1) - 140*D1**2*bd2*f*r**2 - 280*D1**2*bd2*f*r*s + 280*D1**2*bd2*f*r - 140*D1**2*bd2*f*s**2 + 280*D1**2*bd2*f*s - 140*D1**2*bd2*f + 350*D1**2*bd2*fd*r**2 + 700*D1**2*bd2*fd*r*s - 350*D1**2*bd2*fd*r + 350*D1**2*bd2*fd*s**2 - 350*D1**2*bd2*fd*s + 98*D1**2*bdd1*f*r**2 + 168*D1**2*bdd1*f*r*s - 84*D1**2*bdd1*f*r + 70*D1**2*bdd1*f*s**2 - 70*D1**2*bdd1*f*s + 35*D1**2*bdd1*f + 700*D1**2*bdd1*g2*r**2 + 1400*D1**2*bdd1*g2*r*s - 700*D1**2*bdd1*g2*r + 700*D1**2*bdd1*g2*s**2 - 700*D1**2*bdd1*g2*s + 350*D1**2*bdd1*g2 + 175*D1**2*bdd2*f*r**2 + 350*D1**2*bdd2*f*r*s - 350*D1**2*bdd2*f*r + 175*D1**2*bdd2*f*s**2 - 350*D1**2*bdd2*f*s + 175*D1**2*bdd2*f + 142*D1**2*f*fd*r**2 + 156*D1**2*f*fd*r*s - 152*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 - 50*D1**2*f*fd*s + 57*D1**2*f*fd - 120*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s + 62*D1**2*f*fdd*r - 10*D1**2*f*fdd*s - 25*D1**2*f*fdd + 630*D1**2*f*gd2*r**2 + 700*D1**2*f*gd2*r*s - 1260*D1**2*f*gd2*r + 70*D1**2*f*gd2*s**2 - 700*D1**2*f*gd2*s + 630*D1**2*f*gd2 - 280*D1**2*f*gdd2*r**2 - 280*D1**2*f*gdd2*r*s + 560*D1**2*f*gdd2*r + 280*D1**2*f*gdd2*s - 280*D1**2*f*gdd2 - 120*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s + 62*D1**2*fd**2*r - 10*D1**2*fd**2*s + 58*D1**2*fd**2 + 630*D1**2*fd*g2*r**2 + 700*D1**2*fd*g2*r*s - 280*D1**2*fd*g2*r + 70*D1**2*fd*g2*s**2 + 280*D1**2*fd*g2*s - 140*D1**2*fd*g2 - 560*D1**2*fd*gd2*r**2 - 560*D1**2*fd*gd2*r*s + 140*D1**2*fd*gd2*r - 420*D1**2*fd*gd2*s + 420*D1**2*fd*gd2 - 280*D1**2*fdd*g2*r**2 - 280*D1**2*fdd*g2*r*s - 420*D1**2*fdd*g2*r - 700*D1**2*fdd*g2*s + 350*D1**2*fdd*g2 + 1400*D1*Dd*bd2*f*r**2 + 2800*D1*Dd*bd2*f*r*s - 2450*D1*Dd*bd2*f*r + 1400*D1*Dd*bd2*f*s**2 - 2450*D1*Dd*bd2*f*s + 1050*D1*Dd*bd2*f + 284*D1*Dd*f**2*r**2 + 312*D1*Dd*f**2*r*s - 362*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 - 170*D1*Dd*f**2*s + 149*D1*Dd*f**2 - 960*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 848*D1*Dd*f*fd*r + 200*D1*Dd*f*fd*s - 114*D1*Dd*f*fd + 2520*D1*Dd*f*g2*r**2 + 2800*D1*Dd*f*g2*r*s - 3220*D1*Dd*f*g2*r + 280*D1*Dd*f*g2*s**2 - 1540*D1*Dd*f*g2*s + 1330*D1*Dd*f*g2 - 2240*D1*Dd*f*gd2*r**2 - 2240*D1*Dd*f*gd2*r*s + 3640*D1*Dd*f*gd2*r + 1680*D1*Dd*f*gd2*s - 1400*D1*Dd*f*gd2 - 2240*D1*Dd*fd*g2*r**2 - 2240*D1*Dd*fd*g2*r*s - 280*D1*Dd*fd*g2*r - 2240*D1*Dd*fd*g2*s + 1540*D1*Dd*fd*g2 - 240*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 300*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s - 120*D1*Ddd*f**2 - 1120*D1*Ddd*f*g2*r**2 - 1120*D1*Ddd*f*g2*r*s + 1400*D1*Ddd*f*g2*r + 560*D1*Ddd*f*g2*s - 560*D1*Ddd*f*g2 - 14*D1*bd1*(5*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f*(-10*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*K*(9*r**2 + 2*r*(5*s - 6) + s**2 - 8*s + 6) + 14*r**2 + 24*r*s - 17*r + 10*s**2 - 10*s + 5) + fd*(10*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 5*K*(8*r**2 + 8*r*s - 3*r + 3*s - 3) - 14*r**2 - 24*r*s + 20*r - 10*s**2 + 17*s - 6) + 50*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 50*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*(f*(10*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 5*K*(32*r**2 + 8*r*(4*s - 7) - 36*s + 25) - 56*r**2 - 96*r*s + 64*r - 40*s**2 + 54*s - 17) - 50*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 720*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 900*Dd**2*f**2*r + 360*Dd**2*f**2*s - 240*Dd**2*f**2 - 3360*Dd**2*f*g2*r**2 - 3360*Dd**2*f*g2*r*s + 4200*Dd**2*f*g2*r + 1680*Dd**2*f*g2*s - 1120*Dd**2*f*g2 + 35*b2*(-D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 4*D1**2*fd*r**2 - 8*D1**2*fd*r*s + 2*D1**2*fd*r - 4*D1**2*fd*s**2 + 2*D1**2*fd*s - D1**2*fd + 5*D1**2*fdd*r**2 + 10*D1**2*fdd*r*s + 5*D1**2*fdd*s**2 - 16*D1*Dd*f*r**2 - 32*D1*Dd*f*r*s + 24*D1*Dd*f*r - 16*D1*Dd*f*s**2 + 24*D1*Dd*f*s - 12*D1*Dd*f + 40*D1*Dd*fd*r**2 + 80*D1*Dd*fd*r*s - 30*D1*Dd*fd*r + 40*D1*Dd*fd*s**2 - 30*D1*Dd*fd*s + 20*D1*Ddd*f*r**2 + 40*D1*Ddd*f*r*s - 30*D1*Ddd*f*r + 20*D1*Ddd*f*s**2 - 30*D1*Ddd*f*s + 15*D1*Ddd*f + 2*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 60*Dd**2*f*r**2 + 120*Dd**2*f*r*s - 90*Dd**2*f*r + 60*Dd**2*f*s**2 - 90*Dd**2*f*s + 30*Dd**2*f)))/(210*d**2*k3**3) + D1**2*Pk2*Pkd3*k2**2*(2*D1**2*bd1**2*(f*(2*C - 1)*(13*r**2 + 9*r*(2*s - 1) + s*(5*s - 5)) - 30*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*b1*(30*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 15*D1*b2*bd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1*bdd1*(f*(2*C - 1)*(26*r**2 + 36*r*s - 18*r + 10*s**2 - 10*s + 5) - 30*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*bd1*(D1*f*(C*(28*r**2 + 88*r*s - 44*r + 60*s**2 - 60*s + 30) - 24*r**2 - 54*r*s + 27*r - 30*s**2 + 30*s - 15) + D1*fd*(2*C - 1)*(26*r**2 + r*(36*s - 35) + 10*s**2 - 23*s + 9) - 30*D1*(3*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(2*C - 1)*(104*r**2 + 2*r*(72*s - 53) + 40*s**2 - 66*s + 23) - 30*Dd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 15*b1**3*(D1*(2*Dd*(3*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 4*r**2 - 4*r*s + 5*r + 2*s - 2) + Ddd*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(28*C*D1**2*fd*r**2 + 88*C*D1**2*fd*r*s - 56*C*D1**2*fd*r + 60*C*D1**2*fd*s**2 - 88*C*D1**2*fd*s + 28*C*D1**2*fd + 26*C*D1**2*fdd*r**2 + 36*C*D1**2*fdd*r*s - 52*C*D1**2*fdd*r + 10*C*D1**2*fdd*s**2 - 36*C*D1**2*fdd*s + 26*C*D1**2*fdd + 112*C*D1*Dd*f*r**2 + 352*C*D1*Dd*f*r*s - 200*C*D1*Dd*f*r + 240*C*D1*Dd*f*s**2 - 296*C*D1*Dd*f*s + 116*C*D1*Dd*f + 208*C*D1*Dd*fd*r**2 + 288*C*D1*Dd*fd*r*s - 348*C*D1*Dd*fd*r + 80*C*D1*Dd*fd*s**2 - 236*C*D1*Dd*fd*s + 140*C*D1*Dd*fd + 104*C*D1*Ddd*f*r**2 + 144*C*D1*Ddd*f*r*s - 140*C*D1*Ddd*f*r + 40*C*D1*Ddd*f*s**2 - 92*C*D1*Ddd*f*s + 62*C*D1*Ddd*f + 312*C*Dd**2*f*r**2 + 432*C*Dd**2*f*r*s - 420*C*Dd**2*f*r + 120*C*Dd**2*f*s**2 - 276*C*Dd**2*f*s + 124*C*Dd**2*f + 45*D1**2*K*bdd1*r**2 + 90*D1**2*K*bdd1*r*s - 60*D1**2*K*bdd1*r + 45*D1**2*K*bdd1*s**2 - 60*D1**2*K*bdd1*s + 30*D1**2*K*bdd1 + 15*D1**2*bd2*(r + s - 1)**2 - 24*D1**2*fd*r**2 - 54*D1**2*fd*r*s + 48*D1**2*fd*r - 30*D1**2*fd*s**2 + 54*D1**2*fd*s - 24*D1**2*fd - 13*D1**2*fdd*r**2 - 18*D1**2*fdd*r*s + 26*D1**2*fdd*r - 5*D1**2*fdd*s**2 + 18*D1**2*fdd*s - 13*D1**2*fdd - 180*D1**2*gd2*r**2 - 360*D1**2*gd2*r*s + 360*D1**2*gd2*r - 180*D1**2*gd2*s**2 + 360*D1**2*gd2*s - 180*D1**2*gd2 - 30*D1**2*gdd2*r**2 - 60*D1**2*gdd2*r*s + 60*D1**2*gdd2*r - 30*D1**2*gdd2*s**2 + 60*D1**2*gdd2*s - 30*D1**2*gdd2 + 60*D1*Dd*b2*r**2 + 120*D1*Dd*b2*r*s - 90*D1*Dd*b2*r + 60*D1*Dd*b2*s**2 - 90*D1*Dd*b2*s + 45*D1*Dd*b2 - 96*D1*Dd*f*r**2 - 216*D1*Dd*f*r*s + 150*D1*Dd*f*r - 120*D1*Dd*f*s**2 + 168*D1*Dd*f*s - 78*D1*Dd*f - 104*D1*Dd*fd*r**2 - 144*D1*Dd*fd*r*s + 174*D1*Dd*fd*r - 40*D1*Dd*fd*s**2 + 118*D1*Dd*fd*s - 70*D1*Dd*fd - 720*D1*Dd*g2*r**2 - 1440*D1*Dd*g2*r*s + 1080*D1*Dd*g2*r - 720*D1*Dd*g2*s**2 + 1080*D1*Dd*g2*s - 540*D1*Dd*g2 - 240*D1*Dd*gd2*r**2 - 480*D1*Dd*gd2*r*s + 420*D1*Dd*gd2*r - 240*D1*Dd*gd2*s**2 + 420*D1*Dd*gd2*s - 180*D1*Dd*gd2 - 52*D1*Ddd*f*r**2 - 72*D1*Ddd*f*r*s + 70*D1*Ddd*f*r - 20*D1*Ddd*f*s**2 + 46*D1*Ddd*f*s - 31*D1*Ddd*f - 120*D1*Ddd*g2*r**2 - 240*D1*Ddd*g2*r*s + 180*D1*Ddd*g2*r - 120*D1*Ddd*g2*s**2 + 180*D1*Ddd*g2*s - 90*D1*Ddd*g2 + 30*D1*bd1*(D1*(3*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 3*r**2 - 3*r*s + 3*r + s - 1) + Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 156*Dd**2*f*r**2 - 216*Dd**2*f*r*s + 210*Dd**2*f*r - 60*Dd**2*f*s**2 + 138*Dd**2*f*s - 62*Dd**2*f - 360*Dd**2*g2*r**2 - 720*Dd**2*g2*r*s + 540*Dd**2*g2*r - 360*Dd**2*g2*s**2 + 540*Dd**2*g2*s - 180*Dd**2*g2))/(30*d**2*k3**3) - D1**2*Pk2*Pkd3*st**4*(D1*(-7*D1*bd1**2*f*(r**2*(2*f + 2) + 2*r*(2*K*s + f*(s - 1) + s - 1) + s*(4*K*s - 2*K - f - 1)) - D1*bdd1*f*(r + s)*(f*(4*C*s + r - 2*s) + s*(14*b2 - 28*g2)) + bd1*(D1*(2*f**2*(r + s)*(4*C*s + r - 2*s) + f*(fd*(-4*r**2 + r*(C*(4 - 16*s) + 4*s + 1) + s*(-4*C*(4*s - 3) + 8*s - 5)) - 14*s*(bd2*(2*r + 2*s - 1) + 4*g2*(r + s) + gd2*(-4*r - 4*s + 2))) + 28*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(f*(-8*r**2 + r*(-32*C*s + 4*C + 8*s + 3) + 2*s*(-16*C*s + 8*C + 8*s - 3)) + 28*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - 14*b2*(D1*(-2*f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 7*b1**2*(D1**2*(r + s - 1)*(f*(fd - fdd)*(2*r - 1) + fd**2*(1 - 2*r) + 2*fd*(2*K*(s - 1) + r) - fdd*(2*K*(s - 1) + r)) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(2*r - 1)*(8*r + 8*s - 7) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) - fd*(2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + 8*r**2 + 8*r*s - 9*r - 2*s + 2)) - Ddd*f*(K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - Dd**2*f*(K*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + f*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 12*r**2 + 12*r*s - 15*r - 6*s + 4)) + b1*(16*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r + 16*C*D1**2*f*fd*s**2 - 24*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 8*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*r - 8*C*D1**2*f*fdd*s**2 + 12*C*D1**2*f*fdd*s - 4*C*D1**2*f*fdd - 8*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*r - 8*C*D1**2*fd**2*s**2 + 12*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r*s - 8*C*D1*Dd*f**2*r + 32*C*D1*Dd*f**2*s**2 - 32*C*D1*Dd*f**2*s + 8*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r*s + 24*C*D1*Dd*f*fd*r - 64*C*D1*Dd*f*fd*s**2 + 80*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r*s + 4*C*D1*Ddd*f**2*r - 16*C*D1*Ddd*f**2*s**2 + 16*C*D1*Ddd*f**2*s - 4*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r*s + 12*C*Dd**2*f**2*r - 48*C*Dd**2*f**2*s**2 + 48*C*Dd**2*f**2*s - 8*C*Dd**2*f**2 + 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*r + 28*D1**2*b2*fd*s**2 - 56*D1**2*b2*fd*s + 28*D1**2*b2*fd - 14*D1**2*b2*fdd*r*s + 14*D1**2*b2*fdd*r - 14*D1**2*b2*fdd*s**2 + 28*D1**2*b2*fdd*s - 14*D1**2*b2*fdd + 28*D1**2*bd2*f*r*s + 28*D1**2*bd2*f*s**2 - 28*D1**2*bd2*f*s - 28*D1**2*bd2*fd*r*s + 14*D1**2*bd2*fd*r - 28*D1**2*bd2*fd*s**2 + 42*D1**2*bd2*fd*s - 14*D1**2*bd2*fd - 7*D1**2*bdd1*f*(4*K*s**2 - 2*K*s + f*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*r**2 + 2*r*(2*K*s + s - 1) - s + 1) - 14*D1**2*bdd2*f*r*s - 14*D1**2*bdd2*f*s**2 + 14*D1**2*bdd2*f*s + 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + 10*D1**2*f*fd*s - 2*D1**2*f*fd - 2*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r*s + D1**2*f*fdd*r + 4*D1**2*f*fdd*s**2 - 5*D1**2*f*fdd*s + D1**2*f*fdd - 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s + 28*D1**2*f*gdd2*r*s + 28*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s - 2*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r*s + D1**2*fd**2*r + 4*D1**2*fd**2*s**2 - 5*D1**2*fd**2*s + D1**2*fd**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 56*D1**2*fd*g2*s**2 + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 + 56*D1**2*fd*gd2*r*s - 28*D1**2*fd*gd2*r + 56*D1**2*fd*gd2*s**2 - 84*D1**2*fd*gd2*s + 28*D1**2*fd*gd2 + 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*r + 28*D1**2*fdd*g2*s**2 - 56*D1**2*fdd*g2*s + 28*D1**2*fdd*g2 + 112*D1*Dd*b2*f*r*s - 28*D1*Dd*b2*f*r + 112*D1*Dd*b2*f*s**2 - 112*D1*Dd*b2*f*s + 28*D1*Dd*b2*f - 112*D1*Dd*b2*fd*r*s + 70*D1*Dd*b2*fd*r - 112*D1*Dd*b2*fd*s**2 + 168*D1*Dd*b2*fd*s - 56*D1*Dd*b2*fd - 112*D1*Dd*bd2*f*r*s + 14*D1*Dd*bd2*f*r - 112*D1*Dd*bd2*f*s**2 + 112*D1*Dd*bd2*f*s - 14*D1*Dd*bd2*f + 8*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 16*D1*Dd*f*fd*r**2 + 16*D1*Dd*f*fd*r*s + 10*D1*Dd*f*fd*r + 32*D1*Dd*f*fd*s**2 - 32*D1*Dd*f*fd*s + 3*D1*Dd*f*fd - 224*D1*Dd*f*g2*r*s + 56*D1*Dd*f*g2*r - 224*D1*Dd*f*g2*s**2 + 224*D1*Dd*f*g2*s - 56*D1*Dd*f*g2 + 224*D1*Dd*f*gd2*r*s - 28*D1*Dd*f*gd2*r + 224*D1*Dd*f*gd2*s**2 - 224*D1*Dd*f*gd2*s + 28*D1*Dd*f*gd2 + 224*D1*Dd*fd*g2*r*s - 140*D1*Dd*fd*g2*r + 224*D1*Dd*fd*g2*s**2 - 336*D1*Dd*fd*g2*s + 112*D1*Dd*fd*g2 - 56*D1*Ddd*b2*f*r*s + 14*D1*Ddd*b2*f*r - 56*D1*Ddd*b2*f*s**2 + 56*D1*Ddd*b2*f*s - 14*D1*Ddd*b2*f - 4*D1*Ddd*f**2*r**2 + 4*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r + 8*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 112*D1*Ddd*f*g2*r*s - 28*D1*Ddd*f*g2*r + 112*D1*Ddd*f*g2*s**2 - 112*D1*Ddd*f*g2*s + 28*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(f**2*(2*r**2 + 2*r*(s - 1) - s + 1) + f*(8*K*s**2 - 4*K*s - fd*(2*r - 1)*(4*r + 4*s - 3) + 4*r**2 + 4*r*(2*K*s + s - 1) - 2*s + 2) + fd*(-2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r**2 - 4*r*(s - 1) + s - 1)) - Dd*f*(K*(32*r*s - 4*r + 32*s**2 - 24*s + 2) + f*(2*r - 1)*(8*r + 8*s - 5) + (2*r - 1)*(8*r + 8*s - 5))) - 168*Dd**2*b2*f*r*s + 42*Dd**2*b2*f*r - 168*Dd**2*b2*f*s**2 + 168*Dd**2*b2*f*s - 28*Dd**2*b2*f - 12*Dd**2*f**2*r**2 + 12*Dd**2*f**2*r*s + 9*Dd**2*f**2*r + 24*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s + 336*Dd**2*f*g2*r*s - 84*Dd**2*f*g2*r + 336*Dd**2*f*g2*s**2 - 336*Dd**2*f*g2*s + 56*Dd**2*f*g2))/(35*d**2*k3) - D1**2*Pk2*Pkd3*st**2*(D1*(14*D1*bd1**2*f*(5*K*r*(6*s - 1) + 5*K*s*(5*s - 3) + r**2*(5*K - 2) - 2*r*s + r) + D1*bdd1*f*(r + s)*(35*b2*(r + 5*s) + f*(2*C - 1)*(23*r + 35*s) - 70*g2*(r + 5*s)) + bd1*(-50*C*D1*f**2*r**2 - 148*C*D1*f**2*r*s - 98*C*D1*f**2*s**2 + 184*C*D1*f*fd*r**2 + 464*C*D1*f*fd*r*s - 208*C*D1*f*fd*r + 280*C*D1*f*fd*s**2 - 256*C*D1*f*fd*s + 368*C*Dd*f**2*r**2 + 928*C*Dd*f**2*r*s - 300*C*Dd*f**2*r + 560*C*Dd*f**2*s**2 - 372*C*Dd*f**2*s + 70*D1*bd2*f*(r**2 + r*(6*s - 1) + s*(5*s - 3)) + 11*D1*f**2*r**2 + 60*D1*f**2*r*s + 49*D1*f**2*s**2 - 92*D1*f*fd*r**2 - 232*D1*f*fd*r*s + 104*D1*f*fd*r - 140*D1*f*fd*s**2 + 128*D1*f*fd*s - 70*D1*f*g2*r**2 + 420*D1*f*g2*r*s + 490*D1*f*g2*s**2 - 140*D1*f*gd2*r**2 - 840*D1*f*gd2*r*s + 140*D1*f*gd2*r - 700*D1*f*gd2*s**2 + 420*D1*f*gd2*s - 140*D1*fd*g2*r**2 - 840*D1*fd*g2*r*s + 420*D1*fd*g2*r - 700*D1*fd*g2*s**2 + 700*D1*fd*g2*s - 184*Dd*f**2*r**2 - 464*Dd*f**2*r*s + 150*Dd*f**2*r - 280*Dd*f**2*s**2 + 186*Dd*f**2*s - 560*Dd*f*g2*r**2 - 3360*Dd*f*g2*r*s + 700*Dd*f*g2*r - 2800*Dd*f*g2*s**2 + 1540*Dd*f*g2*s + 35*b2*(D1*(f*(r**2 - 6*r*s - 7*s**2) + 2*fd*(r**2 + r*(6*s - 3) + s*(5*s - 5))) + 2*Dd*f*(4*r**2 + r*(24*s - 5) + s*(20*s - 11))))) + 70*b1**3*(D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 13*r + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) - Ddd*(f + 1)*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - Dd**2*(f + 1)*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) + 7*b1**2*(5*D1**2*K*fd*r**2 - 30*D1**2*K*fd*r*s + 30*D1**2*K*fd*r - 35*D1**2*K*fd*s**2 + 70*D1**2*K*fd*s - 35*D1**2*K*fd + 5*D1**2*K*fdd*r**2 + 30*D1**2*K*fdd*r*s - 30*D1**2*K*fdd*r + 25*D1**2*K*fdd*s**2 - 50*D1**2*K*fdd*s + 25*D1**2*K*fdd - 10*D1**2*bdd1*(f + 1)*(3*r**2 + 3*r*(s - 1) - s + 1) - 6*D1**2*fd*r**2 - 6*D1**2*fd*r*s + 2*D1**2*fd*r - 4*D1**2*fd*s + 4*D1**2*fd - 2*D1**2*fdd*r**2 - 2*D1**2*fdd*r*s + 4*D1**2*fdd*r + 2*D1**2*fdd*s - 2*D1**2*fdd + 20*D1*Dd*K*f*r**2 - 120*D1*Dd*K*f*r*s + 10*D1*Dd*K*f*r - 140*D1*Dd*K*f*s**2 + 130*D1*Dd*K*f*s - 25*D1*Dd*K*f + 40*D1*Dd*K*fd*r**2 + 240*D1*Dd*K*fd*r*s - 170*D1*Dd*K*fd*r + 200*D1*Dd*K*fd*s**2 - 310*D1*Dd*K*fd*s + 110*D1*Dd*K*fd - 24*D1*Dd*f*r**2 - 24*D1*Dd*f*r*s + 30*D1*Dd*f*r + 12*D1*Dd*f*s - 12*D1*Dd*f - 16*D1*Dd*fd*r**2 - 16*D1*Dd*fd*r*s + 26*D1*Dd*fd*r + 12*D1*Dd*fd*s - 10*D1*Dd*fd + 20*D1*Ddd*K*f*r**2 + 120*D1*Ddd*K*f*r*s - 50*D1*Ddd*K*f*r + 100*D1*Ddd*K*f*s**2 - 110*D1*Ddd*K*f*s + 35*D1*Ddd*K*f - 8*D1*Ddd*f*r**2 - 8*D1*Ddd*f*r*s + 10*D1*Ddd*f*r + 4*D1*Ddd*f*s - 4*D1*Ddd*f + 10*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 - 6*r*s + 9*r + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) - Dd*(f + 1)*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) + 60*Dd**2*K*f*r**2 + 360*Dd**2*K*f*r*s - 150*Dd**2*K*f*r + 300*Dd**2*K*f*s**2 - 330*Dd**2*K*f*s + 70*Dd**2*K*f - 24*Dd**2*f*r**2 - 24*Dd**2*f*r*s + 30*Dd**2*f*r + 12*Dd**2*f*s - 8*Dd**2*f) + b1*(-100*C*D1**2*f*fd*r**2 - 296*C*D1**2*f*fd*r*s + 248*C*D1**2*f*fd*r - 196*C*D1**2*f*fd*s**2 + 344*C*D1**2*f*fd*s - 148*C*D1**2*f*fd + 92*C*D1**2*f*fdd*r**2 + 232*C*D1**2*f*fdd*r*s - 208*C*D1**2*f*fdd*r + 140*C*D1**2*f*fdd*s**2 - 256*C*D1**2*f*fdd*s + 116*C*D1**2*f*fdd + 92*C*D1**2*fd**2*r**2 + 232*C*D1**2*fd**2*r*s - 208*C*D1**2*fd**2*r + 140*C*D1**2*fd**2*s**2 - 256*C*D1**2*fd**2*s + 116*C*D1**2*fd**2 - 200*C*D1*Dd*f**2*r**2 - 592*C*D1*Dd*f**2*r*s + 348*C*D1*Dd*f**2*r - 392*C*D1*Dd*f**2*s**2 + 492*C*D1*Dd*f**2*s - 198*C*D1*Dd*f**2 + 736*C*D1*Dd*f*fd*r**2 + 1856*C*D1*Dd*f*fd*r*s - 1432*C*D1*Dd*f*fd*r + 1120*C*D1*Dd*f*fd*s**2 - 1768*C*D1*Dd*f*fd*s + 672*C*D1*Dd*f*fd + 184*C*D1*Ddd*f**2*r**2 + 464*C*D1*Ddd*f**2*r*s - 300*C*D1*Ddd*f**2*r + 280*C*D1*Ddd*f**2*s**2 - 372*C*D1*Ddd*f**2*s + 162*C*D1*Ddd*f**2 + 552*C*Dd**2*f**2*r**2 + 1392*C*Dd**2*f**2*r*s - 900*C*Dd**2*f**2*r + 840*C*Dd**2*f**2*s**2 - 1116*C*Dd**2*f**2*s + 324*C*Dd**2*f**2 + 70*D1**2*K*bdd1*f*r**2 + 420*D1**2*K*bdd1*f*r*s - 70*D1**2*K*bdd1*f*r + 350*D1**2*K*bdd1*f*s**2 - 210*D1**2*K*bdd1*f*s + 35*D1**2*K*bdd1*f + 35*D1**2*b2*fd*r**2 - 210*D1**2*b2*fd*r*s + 210*D1**2*b2*fd*r - 245*D1**2*b2*fd*s**2 + 490*D1**2*b2*fd*s - 245*D1**2*b2*fd + 35*D1**2*b2*fdd*r**2 + 210*D1**2*b2*fdd*r*s - 210*D1**2*b2*fdd*r + 175*D1**2*b2*fdd*s**2 - 350*D1**2*b2*fdd*s + 175*D1**2*b2*fdd - 70*D1**2*bd1**2*(f + 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 28*D1**2*bdd1*f*r**2 - 28*D1**2*bdd1*f*r*s + 14*D1**2*bdd1*f*r + 35*D1**2*bdd2*f*r**2 + 210*D1**2*bdd2*f*r*s - 70*D1**2*bdd2*f*r + 175*D1**2*bdd2*f*s**2 - 210*D1**2*bdd2*f*s + 35*D1**2*bdd2*f + 22*D1**2*f*fd*r**2 + 120*D1**2*f*fd*r*s - 82*D1**2*f*fd*r + 98*D1**2*f*fd*s**2 - 158*D1**2*f*fd*s + 60*D1**2*f*fd - 46*D1**2*f*fdd*r**2 - 116*D1**2*f*fdd*r*s + 104*D1**2*f*fdd*r - 70*D1**2*f*fdd*s**2 + 128*D1**2*f*fdd*s - 58*D1**2*f*fdd - 70*D1**2*f*gd2*r**2 + 420*D1**2*f*gd2*r*s + 140*D1**2*f*gd2*r + 490*D1**2*f*gd2*s**2 - 420*D1**2*f*gd2*s - 70*D1**2*f*gd2 - 70*D1**2*f*gdd2*r**2 - 420*D1**2*f*gdd2*r*s + 140*D1**2*f*gdd2*r - 350*D1**2*f*gdd2*s**2 + 420*D1**2*f*gdd2*s - 70*D1**2*f*gdd2 - 46*D1**2*fd**2*r**2 - 116*D1**2*fd**2*r*s + 104*D1**2*fd**2*r - 70*D1**2*fd**2*s**2 + 128*D1**2*fd**2*s - 58*D1**2*fd**2 - 70*D1**2*fd*g2*r**2 + 420*D1**2*fd*g2*r*s - 420*D1**2*fd*g2*r + 490*D1**2*fd*g2*s**2 - 980*D1**2*fd*g2*s + 490*D1**2*fd*g2 - 140*D1**2*fd*gd2*r**2 - 840*D1**2*fd*gd2*r*s + 560*D1**2*fd*gd2*r - 700*D1**2*fd*gd2*s**2 + 1120*D1**2*fd*gd2*s - 420*D1**2*fd*gd2 - 70*D1**2*fdd*g2*r**2 - 420*D1**2*fdd*g2*r*s + 420*D1**2*fdd*g2*r - 350*D1**2*fdd*g2*s**2 + 700*D1**2*fdd*g2*s - 350*D1**2*fdd*g2 + 140*D1*Dd*b2*f*r**2 - 840*D1*Dd*b2*f*r*s + 70*D1*Dd*b2*f*r - 980*D1*Dd*b2*f*s**2 + 910*D1*Dd*b2*f*s - 175*D1*Dd*b2*f + 280*D1*Dd*b2*fd*r**2 + 1680*D1*Dd*b2*fd*r*s - 1190*D1*Dd*b2*fd*r + 1400*D1*Dd*b2*fd*s**2 - 2170*D1*Dd*b2*fd*s + 770*D1*Dd*b2*fd + 44*D1*Dd*f**2*r**2 + 240*D1*Dd*f**2*r*s - 104*D1*Dd*f**2*r + 196*D1*Dd*f**2*s**2 - 218*D1*Dd*f**2*s + 71*D1*Dd*f**2 - 368*D1*Dd*f*fd*r**2 - 928*D1*Dd*f*fd*r*s + 716*D1*Dd*f*fd*r - 560*D1*Dd*f*fd*s**2 + 884*D1*Dd*f*fd*s - 336*D1*Dd*f*fd - 280*D1*Dd*f*g2*r**2 + 1680*D1*Dd*f*g2*r*s - 140*D1*Dd*f*g2*r + 1960*D1*Dd*f*g2*s**2 - 1820*D1*Dd*f*g2*s + 350*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*r**2 - 3360*D1*Dd*f*gd2*r*s + 1260*D1*Dd*f*gd2*r - 2800*D1*Dd*f*gd2*s**2 + 3220*D1*Dd*f*gd2*s - 700*D1*Dd*f*gd2 - 560*D1*Dd*fd*g2*r**2 - 3360*D1*Dd*fd*g2*r*s + 2380*D1*Dd*fd*g2*r - 2800*D1*Dd*fd*g2*s**2 + 4340*D1*Dd*fd*g2*s - 1540*D1*Dd*fd*g2 + 140*D1*Ddd*b2*f*r**2 + 840*D1*Ddd*b2*f*r*s - 350*D1*Ddd*b2*f*r + 700*D1*Ddd*b2*f*s**2 - 770*D1*Ddd*b2*f*s + 245*D1*Ddd*b2*f - 92*D1*Ddd*f**2*r**2 - 232*D1*Ddd*f**2*r*s + 150*D1*Ddd*f**2*r - 140*D1*Ddd*f**2*s**2 + 186*D1*Ddd*f**2*s - 81*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*r**2 - 1680*D1*Ddd*f*g2*r*s + 700*D1*Ddd*f*g2*r - 1400*D1*Ddd*f*g2*s**2 + 1540*D1*Ddd*f*g2*s - 490*D1*Ddd*f*g2 + 7*D1*bd1*(D1*f*(5*K*(2*r**2 - 2*r*(6*s + 1) - 14*s**2 + 6*s + 1) - 12*r**2 - 2*r*(6*s - 8) + 10*s - 10) + 2*D1*fd*(5*K*(2*r**2 + 12*r*s - 7*r + 10*s**2 - 13*s + 3) - 4*r**2 - 4*r*s + 5*r + 2*s - 1) + 10*Dd*K*f*(8*r**2 + 2*r*(24*s - 7) + 40*s**2 - 34*s + 5) - 4*Dd*f*(8*r**2 + r*(8*s - 7) - 2*s + 1)) + 35*D1*bd2*(D1*(f*(r - 7*s - 1) + 2*fd*(r + 5*s - 3))*(r + s - 1) + 2*Dd*f*(4*r**2 + 3*r*(8*s - 3) + 20*s**2 - 23*s + 5)) + 420*Dd**2*b2*f*r**2 + 2520*Dd**2*b2*f*r*s - 1050*Dd**2*b2*f*r + 2100*Dd**2*b2*f*s**2 - 2310*Dd**2*b2*f*s + 490*Dd**2*b2*f - 276*Dd**2*f**2*r**2 - 696*Dd**2*f**2*r*s + 450*Dd**2*f**2*r - 420*Dd**2*f**2*s**2 + 558*Dd**2*f**2*s - 162*Dd**2*f**2 - 840*Dd**2*f*g2*r**2 - 5040*Dd**2*f*g2*r*s + 2100*Dd**2*f*g2*r - 4200*Dd**2*f*g2*s**2 + 4620*Dd**2*f*g2*s - 980*Dd**2*f*g2))/(210*d**2*k3) - D1**2*Pk2*Pkd3*(2*D1**2*bd1**2*(15*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) + f*(2*C - 1)*(13*r**2 + 9*r*(2*s - 1) + s*(5*s - 5)) - 30*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*b1*(30*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1*bdd1*(f*(2*C - 1)*(26*r**2 + 36*r*s - 18*r + 10*s**2 - 10*s + 5) - 30*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 15*b2*(D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + bd1*(30*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - D1*f*(2*C*(22*r**2 + 12*r*s - 6*r - 10*s**2 + 10*s - 5) - 2*r**2 + 8*r*s - 4*r + 10*s**2 - 10*s + 5) + D1*fd*(4*C - 2)*(26*r**2 + r*(36*s - 35) + 10*s**2 - 23*s + 9) - 30*D1*(g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + Dd*f*(4*C - 2)*(104*r**2 + 2*r*(72*s - 53) + 40*s**2 - 66*s + 23) - 60*Dd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 15*b1**3*(D1*(Dd*(K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + Ddd*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-22*C*D1**2*fd*r**2 - 12*C*D1**2*fd*r*s + 44*C*D1**2*fd*r + 10*C*D1**2*fd*s**2 + 12*C*D1**2*fd*s - 22*C*D1**2*fd + 26*C*D1**2*fdd*r**2 + 36*C*D1**2*fdd*r*s - 52*C*D1**2*fdd*r + 10*C*D1**2*fdd*s**2 - 36*C*D1**2*fdd*s + 26*C*D1**2*fdd - 88*C*D1*Dd*f*r**2 - 48*C*D1*Dd*f*r*s + 100*C*D1*Dd*f*r + 40*C*D1*Dd*f*s**2 + 4*C*D1*Dd*f*s - 34*C*D1*Dd*f + 208*C*D1*Dd*fd*r**2 + 288*C*D1*Dd*fd*r*s - 348*C*D1*Dd*fd*r + 80*C*D1*Dd*fd*s**2 - 236*C*D1*Dd*fd*s + 140*C*D1*Dd*fd + 104*C*D1*Ddd*f*r**2 + 144*C*D1*Ddd*f*r*s - 140*C*D1*Ddd*f*r + 40*C*D1*Ddd*f*s**2 - 92*C*D1*Ddd*f*s + 62*C*D1*Ddd*f + 312*C*Dd**2*f*r**2 + 432*C*Dd**2*f*r*s - 420*C*Dd**2*f*r + 120*C*Dd**2*f*s**2 - 276*C*Dd**2*f*s + 124*C*Dd**2*f + 45*D1**2*K*bdd1*r**2 + 90*D1**2*K*bdd1*r*s - 60*D1**2*K*bdd1*r + 45*D1**2*K*bdd1*s**2 - 60*D1**2*K*bdd1*s + 30*D1**2*K*bdd1 + 15*D1**2*bdd2*r**2 + 30*D1**2*bdd2*r*s - 30*D1**2*bdd2*r + 15*D1**2*bdd2*s**2 - 30*D1**2*bdd2*s + 15*D1**2*bdd2 + D1**2*fd*r**2 - 4*D1**2*fd*r*s - 2*D1**2*fd*r - 5*D1**2*fd*s**2 + 4*D1**2*fd*s + D1**2*fd - 13*D1**2*fdd*r**2 - 18*D1**2*fdd*r*s + 26*D1**2*fdd*r - 5*D1**2*fdd*s**2 + 18*D1**2*fdd*s - 13*D1**2*fdd - 30*D1**2*gd2*r**2 - 60*D1**2*gd2*r*s + 60*D1**2*gd2*r - 30*D1**2*gd2*s**2 + 60*D1**2*gd2*s - 30*D1**2*gd2 - 30*D1**2*gdd2*r**2 - 60*D1**2*gdd2*r*s + 60*D1**2*gdd2*r - 30*D1**2*gdd2*s**2 + 60*D1**2*gdd2*s - 30*D1**2*gdd2 + 60*D1*Dd*b2*r**2 + 120*D1*Dd*b2*r*s - 90*D1*Dd*b2*r + 60*D1*Dd*b2*s**2 - 90*D1*Dd*b2*s + 45*D1*Dd*b2 + 4*D1*Dd*f*r**2 - 16*D1*Dd*f*r*s - 20*D1*Dd*f*s**2 + 18*D1*Dd*f*s - 3*D1*Dd*f - 104*D1*Dd*fd*r**2 - 144*D1*Dd*fd*r*s + 174*D1*Dd*fd*r - 40*D1*Dd*fd*s**2 + 118*D1*Dd*fd*s - 70*D1*Dd*fd - 120*D1*Dd*g2*r**2 - 240*D1*Dd*g2*r*s + 180*D1*Dd*g2*r - 120*D1*Dd*g2*s**2 + 180*D1*Dd*g2*s - 90*D1*Dd*g2 - 240*D1*Dd*gd2*r**2 - 480*D1*Dd*gd2*r*s + 420*D1*Dd*gd2*r - 240*D1*Dd*gd2*s**2 + 420*D1*Dd*gd2*s - 180*D1*Dd*gd2 + 60*D1*Ddd*b2*r**2 + 120*D1*Ddd*b2*r*s - 90*D1*Ddd*b2*r + 60*D1*Ddd*b2*s**2 - 90*D1*Ddd*b2*s + 45*D1*Ddd*b2 - 52*D1*Ddd*f*r**2 - 72*D1*Ddd*f*r*s + 70*D1*Ddd*f*r - 20*D1*Ddd*f*s**2 + 46*D1*Ddd*f*s - 31*D1*Ddd*f - 120*D1*Ddd*g2*r**2 - 240*D1*Ddd*g2*r*s + 180*D1*Ddd*g2*r - 120*D1*Ddd*g2*s**2 + 180*D1*Ddd*g2*s - 90*D1*Ddd*g2 + 15*D1*bd1*(D1*(K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 6*r**2 - 6*r*s + 6*r + 2*s - 2) + 2*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 15*D1*bd2*(D1*(r + s - 1) + 2*Dd*(4*r + 4*s - 3))*(r + s - 1) + 180*Dd**2*b2*r**2 + 360*Dd**2*b2*r*s - 270*Dd**2*b2*r + 180*Dd**2*b2*s**2 - 270*Dd**2*b2*s + 90*Dd**2*b2 - 156*Dd**2*f*r**2 - 216*Dd**2*f*r*s + 210*Dd**2*f*r - 60*Dd**2*f*s**2 + 138*Dd**2*f*s - 62*Dd**2*f - 360*Dd**2*g2*r**2 - 720*Dd**2*g2*r*s + 540*Dd**2*g2*r - 360*Dd**2*g2*s**2 + 540*Dd**2*g2*s - 180*Dd**2*g2))/(30*d**2*k3) - D1**2*Pk2*Pkdd3*ct**8*k1**2*k2**4*(924*C*D1**2*f**2*fd*r**2 + 1848*C*D1**2*f**2*fd*r*s - 1232*C*D1**2*f**2*fd*r + 924*C*D1**2*f**2*fd*s**2 - 1232*C*D1**2*f**2*fd*s + 616*C*D1**2*f**2*fd - 462*C*D1**2*f**2*fdd*r**2 - 924*C*D1**2*f**2*fdd*r*s + 616*C*D1**2*f**2*fdd*r - 462*C*D1**2*f**2*fdd*s**2 + 616*C*D1**2*f**2*fdd*s - 308*C*D1**2*f**2*fdd - 924*C*D1**2*f*fd**2*r**2 - 1848*C*D1**2*f*fd**2*r*s + 1232*C*D1**2*f*fd**2*r - 924*C*D1**2*f*fd**2*s**2 + 1232*C*D1**2*f*fd**2*s - 308*C*D1**2*f*fd**2 + 1232*C*D1*Dd*f**3*r**2 + 2464*C*D1*Dd*f**3*r*s - 1848*C*D1*Dd*f**3*r + 1232*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 924*C*D1*Dd*f**3 - 3696*C*D1*Dd*f**2*fd*r**2 - 7392*C*D1*Dd*f**2*fd*r*s + 5236*C*D1*Dd*f**2*fd*r - 3696*C*D1*Dd*f**2*fd*s**2 + 5236*C*D1*Dd*f**2*fd*s - 1848*C*D1*Dd*f**2*fd - 616*C*D1*Ddd*f**3*r**2 - 1232*C*D1*Ddd*f**3*r*s + 924*C*D1*Ddd*f**3*r - 616*C*D1*Ddd*f**3*s**2 + 924*C*D1*Ddd*f**3*s - 462*C*D1*Ddd*f**3 - 1848*C*Dd**2*f**3*r**2 - 3696*C*Dd**2*f**3*r*s + 2772*C*Dd**2*f**3*r - 1848*C*Dd**2*f**3*s**2 + 2772*C*Dd**2*f**3*s - 924*C*Dd**2*f**3 + 396*D1**2*K*b1*f*fd*r**2 + 792*D1**2*K*b1*f*fd*r*s - 396*D1**2*K*b1*f*fd*r + 396*D1**2*K*b1*f*fd*s**2 - 396*D1**2*K*b1*f*fd*s + 198*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 396*D1**2*K*b1*f*fdd*r*s + 198*D1**2*K*b1*f*fdd*r - 198*D1**2*K*b1*f*fdd*s**2 + 198*D1**2*K*b1*f*fdd*s - 99*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 396*D1**2*K*b1*fd**2*r*s + 198*D1**2*K*b1*fd**2*r - 198*D1**2*K*b1*fd**2*s**2 + 198*D1**2*K*b1*fd**2*s - 396*D1**2*b1*f*fd*r**2 - 792*D1**2*b1*f*fd*r*s + 396*D1**2*b1*f*fd*r - 396*D1**2*b1*f*fd*s**2 + 396*D1**2*b1*f*fd*s - 198*D1**2*b1*f*fd + 198*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 198*D1**2*b1*f*fdd*s**2 - 198*D1**2*b1*f*fdd*s + 99*D1**2*b1*f*fdd + 198*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 198*D1**2*b1*fd**2*s**2 - 198*D1**2*b1*fd**2*s - 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 504*D1**2*f**3*fd*r**2 + 1008*D1**2*f**3*fd*r*s - 756*D1**2*f**3*fd*r + 504*D1**2*f**3*fd*s**2 - 756*D1**2*f**3*fd*s + 378*D1**2*f**3*fd - 252*D1**2*f**3*fdd*r**2 - 504*D1**2*f**3*fdd*r*s + 378*D1**2*f**3*fdd*r - 252*D1**2*f**3*fdd*s**2 + 378*D1**2*f**3*fdd*s - 189*D1**2*f**3*fdd - 756*D1**2*f**2*fd**2*r**2 - 1512*D1**2*f**2*fd**2*r*s + 1134*D1**2*f**2*fd**2*r - 756*D1**2*f**2*fd**2*s**2 + 1134*D1**2*f**2*fd**2*s - 378*D1**2*f**2*fd**2 - 924*D1**2*f**2*fd*r**2 - 1848*D1**2*f**2*fd*r*s + 1232*D1**2*f**2*fd*r - 924*D1**2*f**2*fd*s**2 + 1232*D1**2*f**2*fd*s - 616*D1**2*f**2*fd + 462*D1**2*f**2*fdd*r**2 + 924*D1**2*f**2*fdd*r*s - 616*D1**2*f**2*fdd*r + 462*D1**2*f**2*fdd*s**2 - 616*D1**2*f**2*fdd*s + 308*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 396*D1**2*f**2*gd2*s**2 + 792*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 396*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 924*D1**2*f*fd**2*r**2 + 1848*D1**2*f*fd**2*r*s - 1232*D1**2*f*fd**2*r + 924*D1**2*f*fd**2*s**2 - 1232*D1**2*f*fd**2*s + 308*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 792*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1584*D1**2*f*fd*gd2*r*s - 1188*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1188*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 792*D1*Dd*K*b1*f**2*r**2 + 1584*D1*Dd*K*b1*f**2*r*s - 1188*D1*Dd*K*b1*f**2*r + 792*D1*Dd*K*b1*f**2*s**2 - 1188*D1*Dd*K*b1*f**2*s + 594*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 3168*D1*Dd*K*b1*f*fd*r*s + 1980*D1*Dd*K*b1*f*fd*r - 1584*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 594*D1*Dd*K*b1*f*fd - 792*D1*Dd*b1*f**2*r**2 - 1584*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 792*D1*Dd*b1*f**2*s**2 + 1188*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r + 1584*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s + 594*D1*Dd*b1*f*fd + 504*D1*Dd*f**4*r**2 + 1008*D1*Dd*f**4*r*s - 756*D1*Dd*f**4*r + 504*D1*Dd*f**4*s**2 - 756*D1*Dd*f**4*s + 378*D1*Dd*f**4 - 2016*D1*Dd*f**3*fd*r**2 - 4032*D1*Dd*f**3*fd*r*s + 3024*D1*Dd*f**3*fd*r - 2016*D1*Dd*f**3*fd*s**2 + 3024*D1*Dd*f**3*fd*s - 1134*D1*Dd*f**3*fd - 1232*D1*Dd*f**3*r**2 - 2464*D1*Dd*f**3*r*s + 1848*D1*Dd*f**3*r - 1232*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 924*D1*Dd*f**3 + 3696*D1*Dd*f**2*fd*r**2 + 7392*D1*Dd*f**2*fd*r*s - 5236*D1*Dd*f**2*fd*r + 3696*D1*Dd*f**2*fd*s**2 - 5236*D1*Dd*f**2*fd*s + 1848*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 2376*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 3168*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 1188*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 6336*D1*Dd*f*fd*g2*r*s - 3960*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 1188*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 792*D1*Ddd*K*b1*f**2*r*s + 594*D1*Ddd*K*b1*f**2*r - 396*D1*Ddd*K*b1*f**2*s**2 + 594*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 396*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 396*D1*Ddd*b1*f**2*s**2 - 594*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 - 252*D1*Ddd*f**4*r**2 - 504*D1*Ddd*f**4*r*s + 378*D1*Ddd*f**4*r - 252*D1*Ddd*f**4*s**2 + 378*D1*Ddd*f**4*s - 189*D1*Ddd*f**4 + 616*D1*Ddd*f**3*r**2 + 1232*D1*Ddd*f**3*r*s - 924*D1*Ddd*f**3*r + 616*D1*Ddd*f**3*s**2 - 924*D1*Ddd*f**3*s + 462*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1584*D1*Ddd*f**2*g2*r*s - 1188*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1188*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1188*Dd**2*K*b1*f**2*r**2 - 2376*Dd**2*K*b1*f**2*r*s + 1782*Dd**2*K*b1*f**2*r - 1188*Dd**2*K*b1*f**2*s**2 + 1782*Dd**2*K*b1*f**2*s - 594*Dd**2*K*b1*f**2 + 1188*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 1188*Dd**2*b1*f**2*s**2 - 1782*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 - 756*Dd**2*f**4*r**2 - 1512*Dd**2*f**4*r*s + 1134*Dd**2*f**4*r - 756*Dd**2*f**4*s**2 + 1134*Dd**2*f**4*s - 378*Dd**2*f**4 + 1848*Dd**2*f**3*r**2 + 3696*Dd**2*f**3*r*s - 2772*Dd**2*f**3*r + 1848*Dd**2*f**3*s**2 - 2772*Dd**2*f**3*s + 924*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 4752*Dd**2*f**2*g2*r*s - 3564*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3564*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2)/(1386*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**7*k1**3*k2**3*(12540*C*D1**2*f**2*fd*r**2 + 25080*C*D1**2*f**2*fd*r*s - 16720*C*D1**2*f**2*fd*r + 12540*C*D1**2*f**2*fd*s**2 - 16720*C*D1**2*f**2*fd*s + 8360*C*D1**2*f**2*fd - 9240*C*D1**2*f**2*fdd*r**2 - 18480*C*D1**2*f**2*fdd*r*s + 12320*C*D1**2*f**2*fdd*r - 9240*C*D1**2*f**2*fdd*s**2 + 12320*C*D1**2*f**2*fdd*s - 6160*C*D1**2*f**2*fdd - 18480*C*D1**2*f*fd**2*r**2 - 36960*C*D1**2*f*fd**2*r*s + 24640*C*D1**2*f*fd**2*r - 18480*C*D1**2*f*fd**2*s**2 + 24640*C*D1**2*f*fd**2*s - 6160*C*D1**2*f*fd**2 + 16720*C*D1*Dd*f**3*r**2 + 33440*C*D1*Dd*f**3*r*s - 25080*C*D1*Dd*f**3*r + 16720*C*D1*Dd*f**3*s**2 - 25080*C*D1*Dd*f**3*s + 12540*C*D1*Dd*f**3 - 73920*C*D1*Dd*f**2*fd*r**2 - 147840*C*D1*Dd*f**2*fd*r*s + 104720*C*D1*Dd*f**2*fd*r - 73920*C*D1*Dd*f**2*fd*s**2 + 104720*C*D1*Dd*f**2*fd*s - 36960*C*D1*Dd*f**2*fd - 12320*C*D1*Ddd*f**3*r**2 - 24640*C*D1*Ddd*f**3*r*s + 18480*C*D1*Ddd*f**3*r - 12320*C*D1*Ddd*f**3*s**2 + 18480*C*D1*Ddd*f**3*s - 9240*C*D1*Ddd*f**3 - 36960*C*Dd**2*f**3*r**2 - 73920*C*Dd**2*f**3*r*s + 55440*C*Dd**2*f**3*r - 36960*C*Dd**2*f**3*s**2 + 55440*C*Dd**2*f**3*s - 18480*C*Dd**2*f**3 + 5148*D1**2*K*b1*f*fd*r**2 + 10296*D1**2*K*b1*f*fd*r*s - 5148*D1**2*K*b1*f*fd*r + 5148*D1**2*K*b1*f*fd*s**2 - 5148*D1**2*K*b1*f*fd*s + 2574*D1**2*K*b1*f*fd - 3960*D1**2*K*b1*f*fdd*r**2 - 7920*D1**2*K*b1*f*fdd*r*s + 3960*D1**2*K*b1*f*fdd*r - 3960*D1**2*K*b1*f*fdd*s**2 + 3960*D1**2*K*b1*f*fdd*s - 1980*D1**2*K*b1*f*fdd - 3960*D1**2*K*b1*fd**2*r**2 - 7920*D1**2*K*b1*fd**2*r*s + 3960*D1**2*K*b1*fd**2*r - 3960*D1**2*K*b1*fd**2*s**2 + 3960*D1**2*K*b1*fd**2*s - 5148*D1**2*b1*f*fd*r**2 - 10296*D1**2*b1*f*fd*r*s + 5148*D1**2*b1*f*fd*r - 5148*D1**2*b1*f*fd*s**2 + 5148*D1**2*b1*f*fd*s - 2574*D1**2*b1*f*fd + 3960*D1**2*b1*f*fdd*r**2 + 7920*D1**2*b1*f*fdd*r*s - 3960*D1**2*b1*f*fdd*r + 3960*D1**2*b1*f*fdd*s**2 - 3960*D1**2*b1*f*fdd*s + 1980*D1**2*b1*f*fdd + 3960*D1**2*b1*fd**2*r**2 + 7920*D1**2*b1*fd**2*r*s - 3960*D1**2*b1*fd**2*r + 3960*D1**2*b1*fd**2*s**2 - 3960*D1**2*b1*fd**2*s - 1980*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 9520*D1**2*f**3*fd*r**2 + 19040*D1**2*f**3*fd*r*s - 14280*D1**2*f**3*fd*r + 9520*D1**2*f**3*fd*s**2 - 14280*D1**2*f**3*fd*s + 7140*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 12540*D1**2*f**2*fd*r**2 - 25080*D1**2*f**2*fd*r*s + 16720*D1**2*f**2*fd*r - 12540*D1**2*f**2*fd*s**2 + 16720*D1**2*f**2*fd*s - 8360*D1**2*f**2*fd + 9240*D1**2*f**2*fdd*r**2 + 18480*D1**2*f**2*fdd*r*s - 12320*D1**2*f**2*fdd*r + 9240*D1**2*f**2*fdd*s**2 - 12320*D1**2*f**2*fdd*s + 6160*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r**2 - 10296*D1**2*f**2*gd2*r*s + 10296*D1**2*f**2*gd2*r - 5148*D1**2*f**2*gd2*s**2 + 10296*D1**2*f**2*gd2*s - 5148*D1**2*f**2*gd2 + 3960*D1**2*f**2*gdd2*r**2 + 7920*D1**2*f**2*gdd2*r*s - 7920*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 7920*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 + 18480*D1**2*f*fd**2*r**2 + 36960*D1**2*f*fd**2*r*s - 24640*D1**2*f*fd**2*r + 18480*D1**2*f*fd**2*s**2 - 24640*D1**2*f*fd**2*s + 6160*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r**2 - 20592*D1**2*f*fd*g2*r*s + 10296*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 15840*D1**2*f*fd*gd2*r**2 + 31680*D1**2*f*fd*gd2*r*s - 23760*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 23760*D1**2*f*fd*gd2*s + 7920*D1**2*f*fd*gd2 + 7920*D1**2*f*fdd*g2*r**2 + 15840*D1**2*f*fdd*g2*r*s - 7920*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 7920*D1**2*f*fdd*g2*s + 3960*D1**2*f*fdd*g2 + 7920*D1**2*fd**2*g2*r**2 + 15840*D1**2*fd**2*g2*r*s - 7920*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 7920*D1**2*fd**2*g2*s + 10296*D1*Dd*K*b1*f**2*r**2 + 20592*D1*Dd*K*b1*f**2*r*s - 15444*D1*Dd*K*b1*f**2*r + 10296*D1*Dd*K*b1*f**2*s**2 - 15444*D1*Dd*K*b1*f**2*s + 7722*D1*Dd*K*b1*f**2 - 31680*D1*Dd*K*b1*f*fd*r**2 - 63360*D1*Dd*K*b1*f*fd*r*s + 39600*D1*Dd*K*b1*f*fd*r - 31680*D1*Dd*K*b1*f*fd*s**2 + 39600*D1*Dd*K*b1*f*fd*s - 11880*D1*Dd*K*b1*f*fd - 10296*D1*Dd*b1*f**2*r**2 - 20592*D1*Dd*b1*f**2*r*s + 15444*D1*Dd*b1*f**2*r - 10296*D1*Dd*b1*f**2*s**2 + 15444*D1*Dd*b1*f**2*s - 7722*D1*Dd*b1*f**2 + 31680*D1*Dd*b1*f*fd*r**2 + 63360*D1*Dd*b1*f*fd*r*s - 39600*D1*Dd*b1*f*fd*r + 31680*D1*Dd*b1*f*fd*s**2 - 39600*D1*Dd*b1*f*fd*s + 11880*D1*Dd*b1*f*fd + 9520*D1*Dd*f**4*r**2 + 19040*D1*Dd*f**4*r*s - 14280*D1*Dd*f**4*r + 9520*D1*Dd*f**4*s**2 - 14280*D1*Dd*f**4*s + 7140*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 16720*D1*Dd*f**3*r**2 - 33440*D1*Dd*f**3*r*s + 25080*D1*Dd*f**3*r - 16720*D1*Dd*f**3*s**2 + 25080*D1*Dd*f**3*s - 12540*D1*Dd*f**3 + 73920*D1*Dd*f**2*fd*r**2 + 147840*D1*Dd*f**2*fd*r*s - 104720*D1*Dd*f**2*fd*r + 73920*D1*Dd*f**2*fd*s**2 - 104720*D1*Dd*f**2*fd*s + 36960*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r**2 - 41184*D1*Dd*f**2*g2*r*s + 30888*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 30888*D1*Dd*f**2*g2*s - 15444*D1*Dd*f**2*g2 + 31680*D1*Dd*f**2*gd2*r**2 + 63360*D1*Dd*f**2*gd2*r*s - 55440*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 55440*D1*Dd*f**2*gd2*s + 23760*D1*Dd*f**2*gd2 + 63360*D1*Dd*f*fd*g2*r**2 + 126720*D1*Dd*f*fd*g2*r*s - 79200*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 79200*D1*Dd*f*fd*g2*s + 23760*D1*Dd*f*fd*g2 - 7920*D1*Ddd*K*b1*f**2*r**2 - 15840*D1*Ddd*K*b1*f**2*r*s + 11880*D1*Ddd*K*b1*f**2*r - 7920*D1*Ddd*K*b1*f**2*s**2 + 11880*D1*Ddd*K*b1*f**2*s - 5940*D1*Ddd*K*b1*f**2 + 7920*D1*Ddd*b1*f**2*r**2 + 15840*D1*Ddd*b1*f**2*r*s - 11880*D1*Ddd*b1*f**2*r + 7920*D1*Ddd*b1*f**2*s**2 - 11880*D1*Ddd*b1*f**2*s + 5940*D1*Ddd*b1*f**2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 12320*D1*Ddd*f**3*r**2 + 24640*D1*Ddd*f**3*r*s - 18480*D1*Ddd*f**3*r + 12320*D1*Ddd*f**3*s**2 - 18480*D1*Ddd*f**3*s + 9240*D1*Ddd*f**3 + 15840*D1*Ddd*f**2*g2*r**2 + 31680*D1*Ddd*f**2*g2*r*s - 23760*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 23760*D1*Ddd*f**2*g2*s + 11880*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 23760*Dd**2*K*b1*f**2*r**2 - 47520*Dd**2*K*b1*f**2*r*s + 35640*Dd**2*K*b1*f**2*r - 23760*Dd**2*K*b1*f**2*s**2 + 35640*Dd**2*K*b1*f**2*s - 11880*Dd**2*K*b1*f**2 + 23760*Dd**2*b1*f**2*r**2 + 47520*Dd**2*b1*f**2*r*s - 35640*Dd**2*b1*f**2*r + 23760*Dd**2*b1*f**2*s**2 - 35640*Dd**2*b1*f**2*s + 11880*Dd**2*b1*f**2 - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 36960*Dd**2*f**3*r**2 + 73920*Dd**2*f**3*r*s - 55440*Dd**2*f**3*r + 36960*Dd**2*f**3*s**2 - 55440*Dd**2*f**3*s + 18480*Dd**2*f**3 + 47520*Dd**2*f**2*g2*r**2 + 95040*Dd**2*f**2*g2*r*s - 71280*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 71280*Dd**2*f**2*g2*s + 23760*Dd**2*f**2*g2)/(6930*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**7*k1*k2**5*(-168*C*D1**2*f**2*fd*r**2 - 336*C*D1**2*f**2*fd*r*s + 224*C*D1**2*f**2*fd*r - 168*C*D1**2*f**2*fd*s**2 + 224*C*D1**2*f**2*fd*s - 112*C*D1**2*f**2*fd + 84*C*D1**2*f**2*fdd*r**2 + 168*C*D1**2*f**2*fdd*r*s - 112*C*D1**2*f**2*fdd*r + 84*C*D1**2*f**2*fdd*s**2 - 112*C*D1**2*f**2*fdd*s + 56*C*D1**2*f**2*fdd + 168*C*D1**2*f*fd**2*r**2 + 336*C*D1**2*f*fd**2*r*s - 224*C*D1**2*f*fd**2*r + 168*C*D1**2*f*fd**2*s**2 - 224*C*D1**2*f*fd**2*s + 56*C*D1**2*f*fd**2 - 224*C*D1*Dd*f**3*r**2 - 448*C*D1*Dd*f**3*r*s + 336*C*D1*Dd*f**3*r - 224*C*D1*Dd*f**3*s**2 + 336*C*D1*Dd*f**3*s - 168*C*D1*Dd*f**3 + 672*C*D1*Dd*f**2*fd*r**2 + 1344*C*D1*Dd*f**2*fd*r*s - 952*C*D1*Dd*f**2*fd*r + 672*C*D1*Dd*f**2*fd*s**2 - 952*C*D1*Dd*f**2*fd*s + 336*C*D1*Dd*f**2*fd + 112*C*D1*Ddd*f**3*r**2 + 224*C*D1*Ddd*f**3*r*s - 168*C*D1*Ddd*f**3*r + 112*C*D1*Ddd*f**3*s**2 - 168*C*D1*Ddd*f**3*s + 84*C*D1*Ddd*f**3 + 336*C*Dd**2*f**3*r**2 + 672*C*Dd**2*f**3*r*s - 504*C*Dd**2*f**3*r + 336*C*Dd**2*f**3*s**2 - 504*C*Dd**2*f**3*s + 168*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 - 144*D1**2*K*b1*f*fd*r*s + 72*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 + 126*D1**2*f**2*fd*r**2 + 252*D1**2*f**2*fd*r*s - 168*D1**2*f**2*fd*r + 126*D1**2*f**2*fd*s**2 - 168*D1**2*f**2*fd*s + 84*D1**2*f**2*fd - 63*D1**2*f**2*fdd*r**2 - 126*D1**2*f**2*fdd*r*s + 84*D1**2*f**2*fdd*r - 63*D1**2*f**2*fdd*s**2 + 84*D1**2*f**2*fdd*s - 42*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r - 36*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 126*D1**2*f*fd**2*r**2 - 252*D1**2*f*fd**2*r*s + 168*D1**2*f*fd**2*r - 126*D1**2*f*fd**2*s**2 + 168*D1**2*f*fd**2*s - 42*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 - 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 216*D1*Dd*K*b1*f**2*s - 108*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r**2 + 576*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 360*D1*Dd*K*b1*f*fd*s + 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 168*D1*Dd*f**3*r**2 + 336*D1*Dd*f**3*r*s - 252*D1*Dd*f**3*r + 168*D1*Dd*f**3*s**2 - 252*D1*Dd*f**3*s + 126*D1*Dd*f**3 - 504*D1*Dd*f**2*fd*r**2 - 1008*D1*Dd*f**2*fd*r*s + 714*D1*Dd*f**2*fd*r - 504*D1*Dd*f**2*fd*s**2 + 714*D1*Dd*f**2*fd*s - 252*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 504*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 720*D1*Dd*f*fd*g2*s - 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 + 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 108*D1*Ddd*K*b1*f**2*s + 54*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 84*D1*Ddd*f**3*r**2 - 168*D1*Ddd*f**3*r*s + 126*D1*Ddd*f**3*r - 84*D1*Ddd*f**3*s**2 + 126*D1*Ddd*f**3*s - 63*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 216*D1*Ddd*f**2*g2*s - 108*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*b1*f**2*r**2 + 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 324*Dd**2*K*b1*f**2*s + 108*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 252*Dd**2*f**3*r**2 - 504*Dd**2*f**3*r*s + 378*Dd**2*f**3*r - 252*Dd**2*f**3*s**2 + 378*Dd**2*f**3*s - 126*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 648*Dd**2*f**2*g2*s - 216*Dd**2*f**2*g2)/(126*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**7*k1*k2**3*(-42*D1**2*b1*f**2*fd*r**2 - 84*D1**2*b1*f**2*fd*r*s + 56*D1**2*b1*f**2*fd*r - 42*D1**2*b1*f**2*fd*s**2 + 56*D1**2*b1*f**2*fd*s - 28*D1**2*b1*f**2*fd + 21*D1**2*b1*f**2*fdd*r**2 + 42*D1**2*b1*f**2*fdd*r*s - 28*D1**2*b1*f**2*fdd*r + 21*D1**2*b1*f**2*fdd*s**2 - 28*D1**2*b1*f**2*fdd*s + 14*D1**2*b1*f**2*fdd + 42*D1**2*b1*f*fd**2*r**2 + 84*D1**2*b1*f*fd**2*r*s - 56*D1**2*b1*f*fd**2*r + 42*D1**2*b1*f*fd**2*s**2 - 56*D1**2*b1*f*fd**2*s + 14*D1**2*b1*f*fd**2 - 36*D1**2*b1*f*fd*r**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + D1**2*bdd1*f**2*(7*f + 9)*(r + s - 1)**2 - 42*D1**2*f**2*fd*r**2 - 84*D1**2*f**2*fd*r*s + 56*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 56*D1**2*f**2*fd*s - 28*D1**2*f**2*fd + 21*D1**2*f**2*fdd*r**2 + 42*D1**2*f**2*fdd*r*s - 28*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s**2 - 28*D1**2*f**2*fdd*s + 14*D1**2*f**2*fdd + 42*D1**2*f*fd**2*r**2 + 84*D1**2*f*fd**2*r*s - 56*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s**2 - 56*D1**2*f*fd**2*s + 14*D1**2*f*fd**2 - 56*D1*Dd*b1*f**3*r**2 - 112*D1*Dd*b1*f**3*r*s + 84*D1*Dd*b1*f**3*r - 56*D1*Dd*b1*f**3*s**2 + 84*D1*Dd*b1*f**3*s - 42*D1*Dd*b1*f**3 + 168*D1*Dd*b1*f**2*fd*r**2 + 336*D1*Dd*b1*f**2*fd*r*s - 238*D1*Dd*b1*f**2*fd*r + 168*D1*Dd*b1*f**2*fd*s**2 - 238*D1*Dd*b1*f**2*fd*s + 84*D1*Dd*b1*f**2*fd - 72*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 108*D1*Dd*b1*f**2*s - 54*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 56*D1*Dd*f**3*r**2 - 112*D1*Dd*f**3*r*s + 84*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 84*D1*Dd*f**3*s - 42*D1*Dd*f**3 + 168*D1*Dd*f**2*fd*r**2 + 336*D1*Dd*f**2*fd*r*s - 238*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s**2 - 238*D1*Dd*f**2*fd*s + 84*D1*Dd*f**2*fd + 28*D1*Ddd*b1*f**3*r**2 + 56*D1*Ddd*b1*f**3*r*s - 42*D1*Ddd*b1*f**3*r + 28*D1*Ddd*b1*f**3*s**2 - 42*D1*Ddd*b1*f**3*s + 21*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 28*D1*Ddd*f**3*r**2 + 56*D1*Ddd*f**3*r*s - 42*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 42*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) + 9*f*(r + s - 1) - 9*fd*(2*r + 2*s - 1)) - Dd*f*(7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 84*Dd**2*b1*f**3*r**2 + 168*Dd**2*b1*f**3*r*s - 126*Dd**2*b1*f**3*r + 84*Dd**2*b1*f**3*s**2 - 126*Dd**2*b1*f**3*s + 42*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 84*Dd**2*f**3*r**2 + 168*Dd**2*f**3*r*s - 126*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 126*Dd**2*f**3*s + 42*Dd**2*f**3)/(126*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**6*k1**4*k2**2*(2574*C*D1**2*f**2*fd*r**2 + 5148*C*D1**2*f**2*fd*r*s - 3432*C*D1**2*f**2*fd*r + 2574*C*D1**2*f**2*fd*s**2 - 3432*C*D1**2*f**2*fd*s + 1716*C*D1**2*f**2*fd - 2772*C*D1**2*f**2*fdd*r**2 - 5544*C*D1**2*f**2*fdd*r*s + 3696*C*D1**2*f**2*fdd*r - 2772*C*D1**2*f**2*fdd*s**2 + 3696*C*D1**2*f**2*fdd*s - 1848*C*D1**2*f**2*fdd - 5544*C*D1**2*f*fd**2*r**2 - 11088*C*D1**2*f*fd**2*r*s + 7392*C*D1**2*f*fd**2*r - 5544*C*D1**2*f*fd**2*s**2 + 7392*C*D1**2*f*fd**2*s - 1848*C*D1**2*f*fd**2 + 3432*C*D1*Dd*f**3*r**2 + 6864*C*D1*Dd*f**3*r*s - 5148*C*D1*Dd*f**3*r + 3432*C*D1*Dd*f**3*s**2 - 5148*C*D1*Dd*f**3*s + 2574*C*D1*Dd*f**3 - 22176*C*D1*Dd*f**2*fd*r**2 - 44352*C*D1*Dd*f**2*fd*r*s + 31416*C*D1*Dd*f**2*fd*r - 22176*C*D1*Dd*f**2*fd*s**2 + 31416*C*D1*Dd*f**2*fd*s - 11088*C*D1*Dd*f**2*fd - 3696*C*D1*Ddd*f**3*r**2 - 7392*C*D1*Ddd*f**3*r*s + 5544*C*D1*Ddd*f**3*r - 3696*C*D1*Ddd*f**3*s**2 + 5544*C*D1*Ddd*f**3*s - 2772*C*D1*Ddd*f**3 - 11088*C*Dd**2*f**3*r**2 - 22176*C*Dd**2*f**3*r*s + 16632*C*Dd**2*f**3*r - 11088*C*Dd**2*f**3*s**2 + 16632*C*Dd**2*f**3*s - 5544*C*Dd**2*f**3 + 990*D1**2*K*b1*f*fd*r**2 + 1980*D1**2*K*b1*f*fd*r*s - 990*D1**2*K*b1*f*fd*r + 990*D1**2*K*b1*f*fd*s**2 - 990*D1**2*K*b1*f*fd*s + 495*D1**2*K*b1*f*fd - 1188*D1**2*K*b1*f*fdd*r**2 - 2376*D1**2*K*b1*f*fdd*r*s + 1188*D1**2*K*b1*f*fdd*r - 1188*D1**2*K*b1*f*fdd*s**2 + 1188*D1**2*K*b1*f*fdd*s - 594*D1**2*K*b1*f*fdd - 1188*D1**2*K*b1*fd**2*r**2 - 2376*D1**2*K*b1*fd**2*r*s + 1188*D1**2*K*b1*fd**2*r - 1188*D1**2*K*b1*fd**2*s**2 + 1188*D1**2*K*b1*fd**2*s - 990*D1**2*b1*f*fd*r**2 - 1980*D1**2*b1*f*fd*r*s + 990*D1**2*b1*f*fd*r - 990*D1**2*b1*f*fd*s**2 + 990*D1**2*b1*f*fd*s - 495*D1**2*b1*f*fd + 1188*D1**2*b1*f*fdd*r**2 + 2376*D1**2*b1*f*fdd*r*s - 1188*D1**2*b1*f*fdd*r + 1188*D1**2*b1*f*fdd*s**2 - 1188*D1**2*b1*f*fdd*s + 594*D1**2*b1*f*fdd + 1188*D1**2*b1*fd**2*r**2 + 2376*D1**2*b1*fd**2*r*s - 1188*D1**2*b1*fd**2*r + 1188*D1**2*b1*fd**2*s**2 - 1188*D1**2*b1*fd**2*s - 594*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 2884*D1**2*f**3*fd*r**2 + 5768*D1**2*f**3*fd*r*s - 4326*D1**2*f**3*fd*r + 2884*D1**2*f**3*fd*s**2 - 4326*D1**2*f**3*fd*s + 2163*D1**2*f**3*fd - 2520*D1**2*f**3*fdd*r**2 - 5040*D1**2*f**3*fdd*r*s + 3780*D1**2*f**3*fdd*r - 2520*D1**2*f**3*fdd*s**2 + 3780*D1**2*f**3*fdd*s - 1890*D1**2*f**3*fdd - 7560*D1**2*f**2*fd**2*r**2 - 15120*D1**2*f**2*fd**2*r*s + 11340*D1**2*f**2*fd**2*r - 7560*D1**2*f**2*fd**2*s**2 + 11340*D1**2*f**2*fd**2*s - 3780*D1**2*f**2*fd**2 - 2574*D1**2*f**2*fd*r**2 - 5148*D1**2*f**2*fd*r*s + 3432*D1**2*f**2*fd*r - 2574*D1**2*f**2*fd*s**2 + 3432*D1**2*f**2*fd*s - 1716*D1**2*f**2*fd + 2772*D1**2*f**2*fdd*r**2 + 5544*D1**2*f**2*fdd*r*s - 3696*D1**2*f**2*fdd*r + 2772*D1**2*f**2*fdd*s**2 - 3696*D1**2*f**2*fdd*s + 1848*D1**2*f**2*fdd - 990*D1**2*f**2*gd2*r**2 - 1980*D1**2*f**2*gd2*r*s + 1980*D1**2*f**2*gd2*r - 990*D1**2*f**2*gd2*s**2 + 1980*D1**2*f**2*gd2*s - 990*D1**2*f**2*gd2 + 1188*D1**2*f**2*gdd2*r**2 + 2376*D1**2*f**2*gdd2*r*s - 2376*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 2376*D1**2*f**2*gdd2*s + 1188*D1**2*f**2*gdd2 + 5544*D1**2*f*fd**2*r**2 + 11088*D1**2*f*fd**2*r*s - 7392*D1**2*f*fd**2*r + 5544*D1**2*f*fd**2*s**2 - 7392*D1**2*f*fd**2*s + 1848*D1**2*f*fd**2 - 1980*D1**2*f*fd*g2*r**2 - 3960*D1**2*f*fd*g2*r*s + 1980*D1**2*f*fd*g2*r - 1980*D1**2*f*fd*g2*s**2 + 1980*D1**2*f*fd*g2*s - 990*D1**2*f*fd*g2 + 4752*D1**2*f*fd*gd2*r**2 + 9504*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2376*D1**2*f*fd*gd2 + 2376*D1**2*f*fdd*g2*r**2 + 4752*D1**2*f*fdd*g2*r*s - 2376*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 2376*D1**2*fd**2*g2*r**2 + 4752*D1**2*fd**2*g2*r*s - 2376*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 1980*D1*Dd*K*b1*f**2*r**2 + 3960*D1*Dd*K*b1*f**2*r*s - 2970*D1*Dd*K*b1*f**2*r + 1980*D1*Dd*K*b1*f**2*s**2 - 2970*D1*Dd*K*b1*f**2*s + 1485*D1*Dd*K*b1*f**2 - 9504*D1*Dd*K*b1*f*fd*r**2 - 19008*D1*Dd*K*b1*f*fd*r*s + 11880*D1*Dd*K*b1*f*fd*r - 9504*D1*Dd*K*b1*f*fd*s**2 + 11880*D1*Dd*K*b1*f*fd*s - 3564*D1*Dd*K*b1*f*fd - 1980*D1*Dd*b1*f**2*r**2 - 3960*D1*Dd*b1*f**2*r*s + 2970*D1*Dd*b1*f**2*r - 1980*D1*Dd*b1*f**2*s**2 + 2970*D1*Dd*b1*f**2*s - 1485*D1*Dd*b1*f**2 + 9504*D1*Dd*b1*f*fd*r**2 + 19008*D1*Dd*b1*f*fd*r*s - 11880*D1*Dd*b1*f*fd*r + 9504*D1*Dd*b1*f*fd*s**2 - 11880*D1*Dd*b1*f*fd*s + 3564*D1*Dd*b1*f*fd + 2884*D1*Dd*f**4*r**2 + 5768*D1*Dd*f**4*r*s - 4326*D1*Dd*f**4*r + 2884*D1*Dd*f**4*s**2 - 4326*D1*Dd*f**4*s + 2163*D1*Dd*f**4 - 20160*D1*Dd*f**3*fd*r**2 - 40320*D1*Dd*f**3*fd*r*s + 30240*D1*Dd*f**3*fd*r - 20160*D1*Dd*f**3*fd*s**2 + 30240*D1*Dd*f**3*fd*s - 11340*D1*Dd*f**3*fd - 3432*D1*Dd*f**3*r**2 - 6864*D1*Dd*f**3*r*s + 5148*D1*Dd*f**3*r - 3432*D1*Dd*f**3*s**2 + 5148*D1*Dd*f**3*s - 2574*D1*Dd*f**3 + 22176*D1*Dd*f**2*fd*r**2 + 44352*D1*Dd*f**2*fd*r*s - 31416*D1*Dd*f**2*fd*r + 22176*D1*Dd*f**2*fd*s**2 - 31416*D1*Dd*f**2*fd*s + 11088*D1*Dd*f**2*fd - 3960*D1*Dd*f**2*g2*r**2 - 7920*D1*Dd*f**2*g2*r*s + 5940*D1*Dd*f**2*g2*r - 3960*D1*Dd*f**2*g2*s**2 + 5940*D1*Dd*f**2*g2*s - 2970*D1*Dd*f**2*g2 + 9504*D1*Dd*f**2*gd2*r**2 + 19008*D1*Dd*f**2*gd2*r*s - 16632*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 19008*D1*Dd*f*fd*g2*r**2 + 38016*D1*Dd*f*fd*g2*r*s - 23760*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 23760*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 2376*D1*Ddd*K*b1*f**2*r**2 - 4752*D1*Ddd*K*b1*f**2*r*s + 3564*D1*Ddd*K*b1*f**2*r - 2376*D1*Ddd*K*b1*f**2*s**2 + 3564*D1*Ddd*K*b1*f**2*s - 1782*D1*Ddd*K*b1*f**2 + 2376*D1*Ddd*b1*f**2*r**2 + 4752*D1*Ddd*b1*f**2*r*s - 3564*D1*Ddd*b1*f**2*r + 2376*D1*Ddd*b1*f**2*s**2 - 3564*D1*Ddd*b1*f**2*s + 1782*D1*Ddd*b1*f**2 - 2520*D1*Ddd*f**4*r**2 - 5040*D1*Ddd*f**4*r*s + 3780*D1*Ddd*f**4*r - 2520*D1*Ddd*f**4*s**2 + 3780*D1*Ddd*f**4*s - 1890*D1*Ddd*f**4 + 3696*D1*Ddd*f**3*r**2 + 7392*D1*Ddd*f**3*r*s - 5544*D1*Ddd*f**3*r + 3696*D1*Ddd*f**3*s**2 - 5544*D1*Ddd*f**3*s + 2772*D1*Ddd*f**3 + 4752*D1*Ddd*f**2*g2*r**2 + 9504*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 7128*Dd**2*K*b1*f**2*r**2 - 14256*Dd**2*K*b1*f**2*r*s + 10692*Dd**2*K*b1*f**2*r - 7128*Dd**2*K*b1*f**2*s**2 + 10692*Dd**2*K*b1*f**2*s - 3564*Dd**2*K*b1*f**2 + 7128*Dd**2*b1*f**2*r**2 + 14256*Dd**2*b1*f**2*r*s - 10692*Dd**2*b1*f**2*r + 7128*Dd**2*b1*f**2*s**2 - 10692*Dd**2*b1*f**2*s + 3564*Dd**2*b1*f**2 - 7560*Dd**2*f**4*r**2 - 15120*Dd**2*f**4*r*s + 11340*Dd**2*f**4*r - 7560*Dd**2*f**4*s**2 + 11340*Dd**2*f**4*s - 3780*Dd**2*f**4 + 11088*Dd**2*f**3*r**2 + 22176*Dd**2*f**3*r*s - 16632*Dd**2*f**3*r + 11088*Dd**2*f**3*s**2 - 16632*Dd**2*f**3*s + 5544*Dd**2*f**3 + 14256*Dd**2*f**2*g2*r**2 + 28512*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 7128*Dd**2*f**2*g2)/(1386*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**6*k1**2*k2**4*st**2*(1980*C*D1**2*f**2*fd*r**2 + 3960*C*D1**2*f**2*fd*r*s - 2640*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd*s**2 - 2640*C*D1**2*f**2*fd*s + 1320*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r**2 - 1980*C*D1**2*f**2*fdd*r*s + 1320*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 1320*C*D1**2*f**2*fdd*s - 660*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r**2 - 3960*C*D1**2*f*fd**2*r*s + 2640*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 2640*C*D1**2*f*fd**2*s - 660*C*D1**2*f*fd**2 + 2640*C*D1*Dd*f**3*r**2 + 5280*C*D1*Dd*f**3*r*s - 3960*C*D1*Dd*f**3*r + 2640*C*D1*Dd*f**3*s**2 - 3960*C*D1*Dd*f**3*s + 1980*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r**2 - 15840*C*D1*Dd*f**2*fd*r*s + 11220*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 11220*C*D1*Dd*f**2*fd*s - 3960*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r**2 - 2640*C*D1*Ddd*f**3*r*s + 1980*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1980*C*D1*Ddd*f**3*s - 990*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r**2 - 7920*C*Dd**2*f**3*r*s + 5940*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 5940*C*Dd**2*f**3*s - 1980*C*Dd**2*f**3 + 1188*D1**2*K*b1*f*fd*r**2 + 2376*D1**2*K*b1*f*fd*r*s - 1188*D1**2*K*b1*f*fd*r + 1188*D1**2*K*b1*f*fd*s**2 - 1188*D1**2*K*b1*f*fd*s + 594*D1**2*K*b1*f*fd - 594*D1**2*K*b1*f*fdd*r**2 - 1188*D1**2*K*b1*f*fdd*r*s + 594*D1**2*K*b1*f*fdd*r - 594*D1**2*K*b1*f*fdd*s**2 + 594*D1**2*K*b1*f*fdd*s - 297*D1**2*K*b1*f*fdd - 594*D1**2*K*b1*fd**2*r**2 - 1188*D1**2*K*b1*fd**2*r*s + 594*D1**2*K*b1*fd**2*r - 594*D1**2*K*b1*fd**2*s**2 + 594*D1**2*K*b1*fd**2*s - 1188*D1**2*b1*f*fd*r**2 - 2376*D1**2*b1*f*fd*r*s + 1188*D1**2*b1*f*fd*r - 1188*D1**2*b1*f*fd*s**2 + 1188*D1**2*b1*f*fd*s - 594*D1**2*b1*f*fd + 594*D1**2*b1*f*fdd*r**2 + 1188*D1**2*b1*f*fdd*r*s - 594*D1**2*b1*f*fdd*r + 594*D1**2*b1*f*fdd*s**2 - 594*D1**2*b1*f*fdd*s + 297*D1**2*b1*f*fdd + 594*D1**2*b1*fd**2*r**2 + 1188*D1**2*b1*fd**2*r*s - 594*D1**2*b1*fd**2*r + 594*D1**2*b1*fd**2*s**2 - 594*D1**2*b1*fd**2*s - 297*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 1568*D1**2*f**3*fd*r**2 + 3136*D1**2*f**3*fd*r*s - 2352*D1**2*f**3*fd*r + 1568*D1**2*f**3*fd*s**2 - 2352*D1**2*f**3*fd*s + 1176*D1**2*f**3*fd - 784*D1**2*f**3*fdd*r**2 - 1568*D1**2*f**3*fdd*r*s + 1176*D1**2*f**3*fdd*r - 784*D1**2*f**3*fdd*s**2 + 1176*D1**2*f**3*fdd*s - 588*D1**2*f**3*fdd - 2352*D1**2*f**2*fd**2*r**2 - 4704*D1**2*f**2*fd**2*r*s + 3528*D1**2*f**2*fd**2*r - 2352*D1**2*f**2*fd**2*s**2 + 3528*D1**2*f**2*fd**2*s - 1176*D1**2*f**2*fd**2 - 1980*D1**2*f**2*fd*r**2 - 3960*D1**2*f**2*fd*r*s + 2640*D1**2*f**2*fd*r - 1980*D1**2*f**2*fd*s**2 + 2640*D1**2*f**2*fd*s - 1320*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r**2 + 1980*D1**2*f**2*fdd*r*s - 1320*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 1320*D1**2*f**2*fdd*s + 660*D1**2*f**2*fdd - 1188*D1**2*f**2*gd2*r**2 - 2376*D1**2*f**2*gd2*r*s + 2376*D1**2*f**2*gd2*r - 1188*D1**2*f**2*gd2*s**2 + 2376*D1**2*f**2*gd2*s - 1188*D1**2*f**2*gd2 + 594*D1**2*f**2*gdd2*r**2 + 1188*D1**2*f**2*gdd2*r*s - 1188*D1**2*f**2*gdd2*r + 594*D1**2*f**2*gdd2*s**2 - 1188*D1**2*f**2*gdd2*s + 594*D1**2*f**2*gdd2 + 1980*D1**2*f*fd**2*r**2 + 3960*D1**2*f*fd**2*r*s - 2640*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 2640*D1**2*f*fd**2*s + 660*D1**2*f*fd**2 - 2376*D1**2*f*fd*g2*r**2 - 4752*D1**2*f*fd*g2*r*s + 2376*D1**2*f*fd*g2*r - 2376*D1**2*f*fd*g2*s**2 + 2376*D1**2*f*fd*g2*s - 1188*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r**2 + 4752*D1**2*f*fd*gd2*r*s - 3564*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 3564*D1**2*f*fd*gd2*s + 1188*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r**2 + 2376*D1**2*f*fdd*g2*r*s - 1188*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r**2 + 2376*D1**2*fd**2*g2*r*s - 1188*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 2376*D1*Dd*K*b1*f**2*r**2 + 4752*D1*Dd*K*b1*f**2*r*s - 3564*D1*Dd*K*b1*f**2*r + 2376*D1*Dd*K*b1*f**2*s**2 - 3564*D1*Dd*K*b1*f**2*s + 1782*D1*Dd*K*b1*f**2 - 4752*D1*Dd*K*b1*f*fd*r**2 - 9504*D1*Dd*K*b1*f*fd*r*s + 5940*D1*Dd*K*b1*f*fd*r - 4752*D1*Dd*K*b1*f*fd*s**2 + 5940*D1*Dd*K*b1*f*fd*s - 1782*D1*Dd*K*b1*f*fd - 2376*D1*Dd*b1*f**2*r**2 - 4752*D1*Dd*b1*f**2*r*s + 3564*D1*Dd*b1*f**2*r - 2376*D1*Dd*b1*f**2*s**2 + 3564*D1*Dd*b1*f**2*s - 1782*D1*Dd*b1*f**2 + 4752*D1*Dd*b1*f*fd*r**2 + 9504*D1*Dd*b1*f*fd*r*s - 5940*D1*Dd*b1*f*fd*r + 4752*D1*Dd*b1*f*fd*s**2 - 5940*D1*Dd*b1*f*fd*s + 1782*D1*Dd*b1*f*fd + 1568*D1*Dd*f**4*r**2 + 3136*D1*Dd*f**4*r*s - 2352*D1*Dd*f**4*r + 1568*D1*Dd*f**4*s**2 - 2352*D1*Dd*f**4*s + 1176*D1*Dd*f**4 - 6272*D1*Dd*f**3*fd*r**2 - 12544*D1*Dd*f**3*fd*r*s + 9408*D1*Dd*f**3*fd*r - 6272*D1*Dd*f**3*fd*s**2 + 9408*D1*Dd*f**3*fd*s - 3528*D1*Dd*f**3*fd - 2640*D1*Dd*f**3*r**2 - 5280*D1*Dd*f**3*r*s + 3960*D1*Dd*f**3*r - 2640*D1*Dd*f**3*s**2 + 3960*D1*Dd*f**3*s - 1980*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r**2 + 15840*D1*Dd*f**2*fd*r*s - 11220*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 11220*D1*Dd*f**2*fd*s + 3960*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*g2*r**2 - 9504*D1*Dd*f**2*g2*r*s + 7128*D1*Dd*f**2*g2*r - 4752*D1*Dd*f**2*g2*s**2 + 7128*D1*Dd*f**2*g2*s - 3564*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r**2 + 9504*D1*Dd*f**2*gd2*r*s - 8316*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 8316*D1*Dd*f**2*gd2*s + 3564*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r**2 + 19008*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 11880*D1*Dd*f*fd*g2*s + 3564*D1*Dd*f*fd*g2 - 1188*D1*Ddd*K*b1*f**2*r**2 - 2376*D1*Ddd*K*b1*f**2*r*s + 1782*D1*Ddd*K*b1*f**2*r - 1188*D1*Ddd*K*b1*f**2*s**2 + 1782*D1*Ddd*K*b1*f**2*s - 891*D1*Ddd*K*b1*f**2 + 1188*D1*Ddd*b1*f**2*r**2 + 2376*D1*Ddd*b1*f**2*r*s - 1782*D1*Ddd*b1*f**2*r + 1188*D1*Ddd*b1*f**2*s**2 - 1782*D1*Ddd*b1*f**2*s + 891*D1*Ddd*b1*f**2 - 784*D1*Ddd*f**4*r**2 - 1568*D1*Ddd*f**4*r*s + 1176*D1*Ddd*f**4*r - 784*D1*Ddd*f**4*s**2 + 1176*D1*Ddd*f**4*s - 588*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r**2 + 2640*D1*Ddd*f**3*r*s - 1980*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1980*D1*Ddd*f**3*s + 990*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r**2 + 4752*D1*Ddd*f**2*g2*r*s - 3564*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 3564*D1*Ddd*f**2*g2*s + 1782*D1*Ddd*f**2*g2 + 594*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 3564*Dd**2*K*b1*f**2*r**2 - 7128*Dd**2*K*b1*f**2*r*s + 5346*Dd**2*K*b1*f**2*r - 3564*Dd**2*K*b1*f**2*s**2 + 5346*Dd**2*K*b1*f**2*s - 1782*Dd**2*K*b1*f**2 + 3564*Dd**2*b1*f**2*r**2 + 7128*Dd**2*b1*f**2*r*s - 5346*Dd**2*b1*f**2*r + 3564*Dd**2*b1*f**2*s**2 - 5346*Dd**2*b1*f**2*s + 1782*Dd**2*b1*f**2 - 2352*Dd**2*f**4*r**2 - 4704*Dd**2*f**4*r*s + 3528*Dd**2*f**4*r - 2352*Dd**2*f**4*s**2 + 3528*Dd**2*f**4*s - 1176*Dd**2*f**4 + 3960*Dd**2*f**3*r**2 + 7920*Dd**2*f**3*r*s - 5940*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 5940*Dd**2*f**3*s + 1980*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r**2 + 14256*Dd**2*f**2*g2*r*s - 10692*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 10692*Dd**2*f**2*g2*s + 3564*Dd**2*f**2*g2)/(1386*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**6*k1**2*k2**4*(-90*C*D1**2*bdd1*f**2*r**2 - 180*C*D1**2*bdd1*f**2*r*s + 180*C*D1**2*bdd1*f**2*r - 90*C*D1**2*bdd1*f**2*s**2 + 180*C*D1**2*bdd1*f**2*s - 90*C*D1**2*bdd1*f**2 + 2010*C*D1**2*f**2*fd*r**2 + 4020*C*D1**2*f**2*fd*r*s - 2680*C*D1**2*f**2*fd*r + 2010*C*D1**2*f**2*fd*s**2 - 2680*C*D1**2*f**2*fd*s + 1340*C*D1**2*f**2*fd - 1680*C*D1**2*f**2*fdd*r**2 - 3360*C*D1**2*f**2*fdd*r*s + 2240*C*D1**2*f**2*fdd*r - 1680*C*D1**2*f**2*fdd*s**2 + 2240*C*D1**2*f**2*fdd*s - 1120*C*D1**2*f**2*fdd - 3360*C*D1**2*f*fd**2*r**2 - 6720*C*D1**2*f*fd**2*r*s + 4480*C*D1**2*f*fd**2*r - 3360*C*D1**2*f*fd**2*s**2 + 4480*C*D1**2*f*fd**2*s - 1120*C*D1**2*f*fd**2 + 2680*C*D1*Dd*f**3*r**2 + 5360*C*D1*Dd*f**3*r*s - 4020*C*D1*Dd*f**3*r + 2680*C*D1*Dd*f**3*s**2 - 4020*C*D1*Dd*f**3*s + 2010*C*D1*Dd*f**3 - 13440*C*D1*Dd*f**2*fd*r**2 - 26880*C*D1*Dd*f**2*fd*r*s + 19040*C*D1*Dd*f**2*fd*r - 13440*C*D1*Dd*f**2*fd*s**2 + 19040*C*D1*Dd*f**2*fd*s - 6720*C*D1*Dd*f**2*fd - 2240*C*D1*Ddd*f**3*r**2 - 4480*C*D1*Ddd*f**3*r*s + 3360*C*D1*Ddd*f**3*r - 2240*C*D1*Ddd*f**3*s**2 + 3360*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 6720*C*Dd**2*f**3*r**2 - 13440*C*Dd**2*f**3*r*s + 10080*C*Dd**2*f**3*r - 6720*C*Dd**2*f**3*s**2 + 10080*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 360*D1**2*K*bdd1*f**2*r**2 - 720*D1**2*K*bdd1*f**2*r*s + 720*D1**2*K*bdd1*f**2*r - 360*D1**2*K*bdd1*f**2*s**2 + 720*D1**2*K*bdd1*f**2*s - 360*D1**2*K*bdd1*f**2 - 126*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 140*D1**2*bdd1*f**3*r**2 + 280*D1**2*bdd1*f**3*r*s - 280*D1**2*bdd1*f**3*r + 140*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 140*D1**2*bdd1*f**3 + 270*D1**2*bdd1*f**2*r**2 + 540*D1**2*bdd1*f**2*r*s - 540*D1**2*bdd1*f**2*r + 270*D1**2*bdd1*f**2*s**2 - 540*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 + 126*D1**2*bdd1*f*g2*r**2 + 252*D1**2*bdd1*f*g2*r*s - 252*D1**2*bdd1*f*g2*r + 126*D1**2*bdd1*f*g2*s**2 - 252*D1**2*bdd1*f*g2*s + 126*D1**2*bdd1*f*g2 - 140*D1**2*f**3*fd*r**2 - 280*D1**2*f**3*fd*r*s + 210*D1**2*f**3*fd*r - 140*D1**2*f**3*fd*s**2 + 210*D1**2*f**3*fd*s - 105*D1**2*f**3*fd - 1440*D1**2*f**2*fd*r**2 - 2880*D1**2*f**2*fd*r*s + 1920*D1**2*f**2*fd*r - 1440*D1**2*f**2*fd*s**2 + 1920*D1**2*f**2*fd*s - 960*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 2520*D1**2*f**2*fdd*r*s - 1680*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1680*D1**2*f**2*fdd*s + 840*D1**2*f**2*fdd - 810*D1**2*f**2*gd2*r**2 - 1620*D1**2*f**2*gd2*r*s + 1620*D1**2*f**2*gd2*r - 810*D1**2*f**2*gd2*s**2 + 1620*D1**2*f**2*gd2*s - 810*D1**2*f**2*gd2 + 720*D1**2*f**2*gdd2*r**2 + 1440*D1**2*f**2*gdd2*r*s - 1440*D1**2*f**2*gdd2*r + 720*D1**2*f**2*gdd2*s**2 - 1440*D1**2*f**2*gdd2*s + 720*D1**2*f**2*gdd2 + 2520*D1**2*f*fd**2*r**2 + 5040*D1**2*f*fd**2*r*s - 3360*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 3360*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 1620*D1**2*f*fd*g2*r**2 - 3240*D1**2*f*fd*g2*r*s + 1620*D1**2*f*fd*g2*r - 1620*D1**2*f*fd*g2*s**2 + 1620*D1**2*f*fd*g2*s - 810*D1**2*f*fd*g2 + 2880*D1**2*f*fd*gd2*r**2 + 5760*D1**2*f*fd*gd2*r*s - 4320*D1**2*f*fd*gd2*r + 2880*D1**2*f*fd*gd2*s**2 - 4320*D1**2*f*fd*gd2*s + 1440*D1**2*f*fd*gd2 + 1440*D1**2*f*fdd*g2*r**2 + 2880*D1**2*f*fdd*g2*r*s - 1440*D1**2*f*fdd*g2*r + 1440*D1**2*f*fdd*g2*s**2 - 1440*D1**2*f*fdd*g2*s + 720*D1**2*f*fdd*g2 + 1440*D1**2*fd**2*g2*r**2 + 2880*D1**2*fd**2*g2*r*s - 1440*D1**2*fd**2*g2*r + 1440*D1**2*fd**2*g2*s**2 - 1440*D1**2*fd**2*g2*s - 140*D1*Dd*f**4*r**2 - 280*D1*Dd*f**4*r*s + 210*D1*Dd*f**4*r - 140*D1*Dd*f**4*s**2 + 210*D1*Dd*f**4*s - 105*D1*Dd*f**4 - 1920*D1*Dd*f**3*r**2 - 3840*D1*Dd*f**3*r*s + 2880*D1*Dd*f**3*r - 1920*D1*Dd*f**3*s**2 + 2880*D1*Dd*f**3*s - 1440*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 20160*D1*Dd*f**2*fd*r*s - 14280*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 14280*D1*Dd*f**2*fd*s + 5040*D1*Dd*f**2*fd - 3240*D1*Dd*f**2*g2*r**2 - 6480*D1*Dd*f**2*g2*r*s + 4860*D1*Dd*f**2*g2*r - 3240*D1*Dd*f**2*g2*s**2 + 4860*D1*Dd*f**2*g2*s - 2430*D1*Dd*f**2*g2 + 5760*D1*Dd*f**2*gd2*r**2 + 11520*D1*Dd*f**2*gd2*r*s - 10080*D1*Dd*f**2*gd2*r + 5760*D1*Dd*f**2*gd2*s**2 - 10080*D1*Dd*f**2*gd2*s + 4320*D1*Dd*f**2*gd2 + 11520*D1*Dd*f*fd*g2*r**2 + 23040*D1*Dd*f*fd*g2*r*s - 14400*D1*Dd*f*fd*g2*r + 11520*D1*Dd*f*fd*g2*s**2 - 14400*D1*Dd*f*fd*g2*s + 4320*D1*Dd*f*fd*g2 + 1680*D1*Ddd*f**3*r**2 + 3360*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 2520*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 2880*D1*Ddd*f**2*g2*r**2 + 5760*D1*Ddd*f**2*g2*r*s - 4320*D1*Ddd*f**2*g2*r + 2880*D1*Ddd*f**2*g2*s**2 - 4320*D1*Ddd*f**2*g2*s + 2160*D1*Ddd*f**2*g2 - D1*bd1*(D1*(190*f**3*(r + s - 1) - f**2*(180*C*(r + s - 1) + 280*fd*(3*r + 3*s - 2) + (405*K - 351)*(r + s - 1)) + 36*f*(5*fd*(C + 4*K - 3)*(2*r + 2*s - 1) + (7*g2 - 7*gd2)*(r + s - 1)) - 252*fd*g2*(r + s)) - 4*Dd*f*(70*f**2 - 45*f*(C + 4*K - 3) + 63*g2)*(4*r + 4*s - 3))*(r + s - 1) + 5040*Dd**2*f**3*r**2 + 10080*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 7560*Dd**2*f**3*s + 2520*Dd**2*f**3 + 8640*Dd**2*f**2*g2*r**2 + 17280*Dd**2*f**2*g2*r*s - 12960*Dd**2*f**2*g2*r + 8640*Dd**2*f**2*g2*s**2 - 12960*Dd**2*f**2*g2*s + 4320*Dd**2*f**2*g2 + 63*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(360*C*D1**2*f*fd*r**2 + 720*C*D1**2*f*fd*r*s - 360*C*D1**2*f*fd*r + 360*C*D1**2*f*fd*s**2 - 360*C*D1**2*f*fd*s + 180*C*D1**2*f*fd - 180*C*D1**2*f*fdd*r**2 - 360*C*D1**2*f*fdd*r*s + 180*C*D1**2*f*fdd*r - 180*C*D1**2*f*fdd*s**2 + 180*C*D1**2*f*fdd*s - 90*C*D1**2*f*fdd - 180*C*D1**2*fd**2*r**2 - 360*C*D1**2*fd**2*r*s + 180*C*D1**2*fd**2*r - 180*C*D1**2*fd**2*s**2 + 180*C*D1**2*fd**2*s + 720*C*D1*Dd*f**2*r**2 + 1440*C*D1*Dd*f**2*r*s - 1080*C*D1*Dd*f**2*r + 720*C*D1*Dd*f**2*s**2 - 1080*C*D1*Dd*f**2*s + 540*C*D1*Dd*f**2 - 1440*C*D1*Dd*f*fd*r**2 - 2880*C*D1*Dd*f*fd*r*s + 1800*C*D1*Dd*f*fd*r - 1440*C*D1*Dd*f*fd*s**2 + 1800*C*D1*Dd*f*fd*s - 540*C*D1*Dd*f*fd - 360*C*D1*Ddd*f**2*r**2 - 720*C*D1*Ddd*f**2*r*s + 540*C*D1*Ddd*f**2*r - 360*C*D1*Ddd*f**2*s**2 + 540*C*D1*Ddd*f**2*s - 270*C*D1*Ddd*f**2 - 1080*C*Dd**2*f**2*r**2 - 2160*C*Dd**2*f**2*r*s + 1620*C*Dd**2*f**2*r - 1080*C*Dd**2*f**2*s**2 + 1620*C*Dd**2*f**2*s - 540*C*Dd**2*f**2 + 810*D1**2*K*f*fd*r**2 + 1620*D1**2*K*f*fd*r*s - 810*D1**2*K*f*fd*r + 810*D1**2*K*f*fd*s**2 - 810*D1**2*K*f*fd*s + 405*D1**2*K*f*fd - 720*D1**2*K*f*fdd*r**2 - 1440*D1**2*K*f*fdd*r*s + 720*D1**2*K*f*fdd*r - 720*D1**2*K*f*fdd*s**2 + 720*D1**2*K*f*fdd*s - 360*D1**2*K*f*fdd - 720*D1**2*K*fd**2*r**2 - 1440*D1**2*K*fd**2*r*s + 720*D1**2*K*fd**2*r - 720*D1**2*K*fd**2*s**2 + 720*D1**2*K*fd**2*s - 126*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 570*D1**2*f**2*fd*r**2 - 1140*D1**2*f**2*fd*r*s + 760*D1**2*f**2*fd*r - 570*D1**2*f**2*fd*s**2 + 760*D1**2*f**2*fd*s - 380*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 702*D1**2*f*fd*r**2 - 1404*D1**2*f*fd*r*s + 702*D1**2*f*fd*r - 702*D1**2*f*fd*s**2 + 702*D1**2*f*fd*s - 351*D1**2*f*fd + 540*D1**2*f*fdd*r**2 + 1080*D1**2*f*fdd*r*s - 540*D1**2*f*fdd*r + 540*D1**2*f*fdd*s**2 - 540*D1**2*f*fdd*s + 270*D1**2*f*fdd - 252*D1**2*f*gd2*r**2 - 504*D1**2*f*gd2*r*s + 504*D1**2*f*gd2*r - 252*D1**2*f*gd2*s**2 + 504*D1**2*f*gd2*s - 252*D1**2*f*gd2 + 126*D1**2*f*gdd2*r**2 + 252*D1**2*f*gdd2*r*s - 252*D1**2*f*gdd2*r + 126*D1**2*f*gdd2*s**2 - 252*D1**2*f*gdd2*s + 126*D1**2*f*gdd2 + 540*D1**2*fd**2*r**2 + 1080*D1**2*fd**2*r*s - 540*D1**2*fd**2*r + 540*D1**2*fd**2*s**2 - 540*D1**2*fd**2*s - 252*D1**2*fd*g2*r**2 - 504*D1**2*fd*g2*r*s - 252*D1**2*fd*g2*s**2 + 252*D1**2*fd*gd2*r**2 + 504*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*r + 252*D1**2*fd*gd2*s**2 - 252*D1**2*fd*gd2*s + 126*D1**2*fdd*g2*r**2 + 252*D1**2*fdd*g2*r*s + 126*D1**2*fdd*g2*s**2 + 1620*D1*Dd*K*f**2*r**2 + 3240*D1*Dd*K*f**2*r*s - 2430*D1*Dd*K*f**2*r + 1620*D1*Dd*K*f**2*s**2 - 2430*D1*Dd*K*f**2*s + 1215*D1*Dd*K*f**2 - 5760*D1*Dd*K*f*fd*r**2 - 11520*D1*Dd*K*f*fd*r*s + 7200*D1*Dd*K*f*fd*r - 5760*D1*Dd*K*f*fd*s**2 + 7200*D1*Dd*K*f*fd*s - 2160*D1*Dd*K*f*fd - 760*D1*Dd*f**3*r**2 - 1520*D1*Dd*f**3*r*s + 1140*D1*Dd*f**3*r - 760*D1*Dd*f**3*s**2 + 1140*D1*Dd*f**3*s - 570*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 1404*D1*Dd*f**2*r**2 - 2808*D1*Dd*f**2*r*s + 2106*D1*Dd*f**2*r - 1404*D1*Dd*f**2*s**2 + 2106*D1*Dd*f**2*s - 1053*D1*Dd*f**2 + 4320*D1*Dd*f*fd*r**2 + 8640*D1*Dd*f*fd*r*s - 5400*D1*Dd*f*fd*r + 4320*D1*Dd*f*fd*s**2 - 5400*D1*Dd*f*fd*s + 1620*D1*Dd*f*fd - 1008*D1*Dd*f*g2*r**2 - 2016*D1*Dd*f*g2*r*s + 1512*D1*Dd*f*g2*r - 1008*D1*Dd*f*g2*s**2 + 1512*D1*Dd*f*g2*s - 756*D1*Dd*f*g2 + 1008*D1*Dd*f*gd2*r**2 + 2016*D1*Dd*f*gd2*r*s - 1764*D1*Dd*f*gd2*r + 1008*D1*Dd*f*gd2*s**2 - 1764*D1*Dd*f*gd2*s + 756*D1*Dd*f*gd2 + 1008*D1*Dd*fd*g2*r**2 + 2016*D1*Dd*fd*g2*r*s - 756*D1*Dd*fd*g2*r + 1008*D1*Dd*fd*g2*s**2 - 756*D1*Dd*fd*g2*s - 1440*D1*Ddd*K*f**2*r**2 - 2880*D1*Ddd*K*f**2*r*s + 2160*D1*Ddd*K*f**2*r - 1440*D1*Ddd*K*f**2*s**2 + 2160*D1*Ddd*K*f**2*s - 1080*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 1080*D1*Ddd*f**2*r**2 + 2160*D1*Ddd*f**2*r*s - 1620*D1*Ddd*f**2*r + 1080*D1*Ddd*f**2*s**2 - 1620*D1*Ddd*f**2*s + 810*D1*Ddd*f**2 + 504*D1*Ddd*f*g2*r**2 + 1008*D1*Ddd*f*g2*r*s - 756*D1*Ddd*f*g2*r + 504*D1*Ddd*f*g2*s**2 - 756*D1*Ddd*f*g2*s + 378*D1*Ddd*f*g2 + 252*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 4320*Dd**2*K*f**2*r**2 - 8640*Dd**2*K*f**2*r*s + 6480*Dd**2*K*f**2*r - 4320*Dd**2*K*f**2*s**2 + 6480*Dd**2*K*f**2*s - 2160*Dd**2*K*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 3240*Dd**2*f**2*r**2 + 6480*Dd**2*f**2*r*s - 4860*Dd**2*f**2*r + 3240*Dd**2*f**2*s**2 - 4860*Dd**2*f**2*s + 1620*Dd**2*f**2 + 1512*Dd**2*f*g2*r**2 + 3024*Dd**2*f*g2*r*s - 2268*Dd**2*f*g2*r + 1512*Dd**2*f*g2*s**2 - 2268*Dd**2*f*g2*s + 756*Dd**2*f*g2))/(630*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**6*k1**2*k2**2*(126*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*D1*bd1*(D1*(5*f**3*(26*r**2 + r*(52*s - 38) + 26*s**2 - 38*s + 19) + f**2*(-35*fd*(15*r**2 + r*(30*s - 23) + 15*s**2 - 23*s + 8) + 9*r**2*(10*C + 3) + 9*r*(s*(20*C + 6) - 26) + 9*s**2*(10*C + 3) - 234*s + 117) - 18*f*(10*fd*(r + s - 1)*(C*r + C*s + r + s - 1) - (7*r + 7*s)*(-g2*(r + s) + gd2*(r + s - 1))) + 126*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(35*f**2*(5*r + 5*s - 4) + 90*f*(C*r + C*s + r + s - 2) - 126*g2*(r + s))) - 63*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-360*C*D1**2*f*fd*r**2 - 720*C*D1**2*f*fd*r*s + 720*C*D1**2*f*fd*r - 360*C*D1**2*f*fd*s**2 + 720*C*D1**2*f*fd*s - 360*C*D1**2*f*fd + 180*C*D1**2*f*fdd*r**2 + 360*C*D1**2*f*fdd*r*s - 360*C*D1**2*f*fdd*r + 180*C*D1**2*f*fdd*s**2 - 360*C*D1**2*f*fdd*s + 180*C*D1**2*f*fdd + 180*C*D1**2*fd**2*r**2 + 360*C*D1**2*fd**2*r*s - 360*C*D1**2*fd**2*r + 180*C*D1**2*fd**2*s**2 - 360*C*D1**2*fd**2*s + 180*C*D1**2*fd**2 - 720*C*D1*Dd*f**2*r**2 - 1440*C*D1*Dd*f**2*r*s + 1080*C*D1*Dd*f**2*r - 720*C*D1*Dd*f**2*s**2 + 1080*C*D1*Dd*f**2*s - 540*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r**2 + 2880*C*D1*Dd*f*fd*r*s - 2520*C*D1*Dd*f*fd*r + 1440*C*D1*Dd*f*fd*s**2 - 2520*C*D1*Dd*f*fd*s + 1080*C*D1*Dd*f*fd + 360*C*D1*Ddd*f**2*r**2 + 720*C*D1*Ddd*f**2*r*s - 540*C*D1*Ddd*f**2*r + 360*C*D1*Ddd*f**2*s**2 - 540*C*D1*Ddd*f**2*s + 270*C*D1*Ddd*f**2 + 1080*C*Dd**2*f**2*r**2 + 2160*C*Dd**2*f**2*r*s - 1620*C*Dd**2*f**2*r + 1080*C*Dd**2*f**2*s**2 - 1620*C*Dd**2*f**2*s + 540*C*Dd**2*f**2 + 63*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 780*D1**2*f**2*fd*r**2 - 1560*D1**2*f**2*fd*r*s + 1180*D1**2*f**2*fd*r - 780*D1**2*f**2*fd*s**2 + 1180*D1**2*f**2*fd*s - 590*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 770*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 770*D1**2*f**2*fdd*s + 385*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1540*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1540*D1**2*f*fd**2*s + 490*D1**2*f*fd**2 - 108*D1**2*f*fd*r**2 - 216*D1**2*f*fd*r*s - 252*D1**2*f*fd*r - 108*D1**2*f*fd*s**2 - 252*D1**2*f*fd*s + 126*D1**2*f*fd + 180*D1**2*f*fdd*r**2 + 360*D1**2*f*fdd*r*s + 180*D1**2*f*fdd*s**2 + 252*D1**2*f*gd2*r**2 + 504*D1**2*f*gd2*r*s - 504*D1**2*f*gd2*r + 252*D1**2*f*gd2*s**2 - 504*D1**2*f*gd2*s + 252*D1**2*f*gd2 - 126*D1**2*f*gdd2*r**2 - 252*D1**2*f*gdd2*r*s + 252*D1**2*f*gdd2*r - 126*D1**2*f*gdd2*s**2 + 252*D1**2*f*gdd2*s - 126*D1**2*f*gdd2 + 180*D1**2*fd**2*r**2 + 360*D1**2*fd**2*r*s + 180*D1**2*fd**2*s**2 - 180*D1**2*fd**2 + 252*D1**2*fd*g2*r**2 + 504*D1**2*fd*g2*r*s - 504*D1**2*fd*g2*r + 252*D1**2*fd*g2*s**2 - 504*D1**2*fd*g2*s + 252*D1**2*fd*g2 - 252*D1**2*fd*gd2*r**2 - 504*D1**2*fd*gd2*r*s + 504*D1**2*fd*gd2*r - 252*D1**2*fd*gd2*s**2 + 504*D1**2*fd*gd2*s - 252*D1**2*fd*gd2 - 126*D1**2*fdd*g2*r**2 - 252*D1**2*fdd*g2*r*s + 252*D1**2*fdd*g2*r - 126*D1**2*fdd*g2*s**2 + 252*D1**2*fdd*g2*s - 126*D1**2*fdd*g2 - 1040*D1*Dd*f**3*r**2 - 2080*D1*Dd*f**3*r*s + 1560*D1*Dd*f**3*r - 1040*D1*Dd*f**3*s**2 + 1560*D1*Dd*f**3*s - 780*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 6230*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 6230*D1*Dd*f**2*fd*s + 2310*D1*Dd*f**2*fd - 216*D1*Dd*f**2*r**2 - 432*D1*Dd*f**2*r*s + 324*D1*Dd*f**2*r - 216*D1*Dd*f**2*s**2 + 324*D1*Dd*f**2*s - 162*D1*Dd*f**2 + 1440*D1*Dd*f*fd*r**2 + 2880*D1*Dd*f*fd*r*s - 1080*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 1080*D1*Dd*f*fd*s + 1008*D1*Dd*f*g2*r**2 + 2016*D1*Dd*f*g2*r*s - 1512*D1*Dd*f*g2*r + 1008*D1*Dd*f*g2*s**2 - 1512*D1*Dd*f*g2*s + 756*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 2016*D1*Dd*f*gd2*r*s + 1764*D1*Dd*f*gd2*r - 1008*D1*Dd*f*gd2*s**2 + 1764*D1*Dd*f*gd2*s - 756*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 2016*D1*Dd*fd*g2*r*s + 1764*D1*Dd*fd*g2*r - 1008*D1*Dd*fd*g2*s**2 + 1764*D1*Dd*fd*g2*s - 756*D1*Dd*fd*g2 + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 1050*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 525*D1*Ddd*f**3 + 360*D1*Ddd*f**2*r**2 + 720*D1*Ddd*f**2*r*s - 540*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 540*D1*Ddd*f**2*s + 270*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 1008*D1*Ddd*f*g2*r*s + 756*D1*Ddd*f*g2*r - 504*D1*Ddd*f*g2*s**2 + 756*D1*Ddd*f*g2*s - 378*D1*Ddd*f*g2 - 126*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 3150*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 1050*Dd**2*f**3 + 1080*Dd**2*f**2*r**2 + 2160*Dd**2*f**2*r*s - 1620*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1620*Dd**2*f**2*s + 540*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 3024*Dd**2*f*g2*r*s + 2268*Dd**2*f*g2*r - 1512*Dd**2*f*g2*s**2 + 2268*Dd**2*f*g2*s - 756*Dd**2*f*g2) + f*(D1**2*bdd1*(35*f**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 4) + 90*f*(r**2*(C + 1) + 2*r*(C*s + s - 2) + s**2*(C + 1) - 4*s + 2) - 126*g2*(r + s)**2) - 10*D1**2*(f*(19*fd - 14*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 28*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 10*D1*f*(Dd*(19*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 28*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 14*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 840*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**6*k2**6*(D1**2*(f**2*(-fd*(28*C - 14)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(14*C - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(9*K*(-2*bd1 + bdd1) + 36*gd2 - 18*gdd2)) + f*(fd**2*(28*C - 14)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 18*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 18*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(-2*Dd*(f**2*(14*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(7 - 14*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 18*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 18*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 9*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + Ddd*f*(14*C*f + 9*K*b1 - 7*f - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f**2*(14*C*f + 9*K*b1 - 7*f - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(126*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**6*k2**4*(84*C*D1**2*f**2*fd*r**2 + 168*C*D1**2*f**2*fd*r*s - 112*C*D1**2*f**2*fd*r + 84*C*D1**2*f**2*fd*s**2 - 112*C*D1**2*f**2*fd*s + 56*C*D1**2*f**2*fd - 42*C*D1**2*f**2*fdd*r**2 - 84*C*D1**2*f**2*fdd*r*s + 56*C*D1**2*f**2*fdd*r - 42*C*D1**2*f**2*fdd*s**2 + 56*C*D1**2*f**2*fdd*s - 28*C*D1**2*f**2*fdd - 84*C*D1**2*f*fd**2*r**2 - 168*C*D1**2*f*fd**2*r*s + 112*C*D1**2*f*fd**2*r - 84*C*D1**2*f*fd**2*s**2 + 112*C*D1**2*f*fd**2*s - 28*C*D1**2*f*fd**2 + 112*C*D1*Dd*f**3*r**2 + 224*C*D1*Dd*f**3*r*s - 168*C*D1*Dd*f**3*r + 112*C*D1*Dd*f**3*s**2 - 168*C*D1*Dd*f**3*s + 84*C*D1*Dd*f**3 - 336*C*D1*Dd*f**2*fd*r**2 - 672*C*D1*Dd*f**2*fd*r*s + 476*C*D1*Dd*f**2*fd*r - 336*C*D1*Dd*f**2*fd*s**2 + 476*C*D1*Dd*f**2*fd*s - 168*C*D1*Dd*f**2*fd - 56*C*D1*Ddd*f**3*r**2 - 112*C*D1*Ddd*f**3*r*s + 84*C*D1*Ddd*f**3*r - 56*C*D1*Ddd*f**3*s**2 + 84*C*D1*Ddd*f**3*s - 42*C*D1*Ddd*f**3 - 168*C*Dd**2*f**3*r**2 - 336*C*Dd**2*f**3*r*s + 252*C*Dd**2*f**3*r - 168*C*Dd**2*f**3*s**2 + 252*C*Dd**2*f**3*s - 84*C*Dd**2*f**3 + 36*D1**2*K*b1*f*fd*r**2 + 72*D1**2*K*b1*f*fd*r*s - 36*D1**2*K*b1*f*fd*r + 36*D1**2*K*b1*f*fd*s**2 - 36*D1**2*K*b1*f*fd*s + 18*D1**2*K*b1*f*fd - 18*D1**2*K*b1*f*fdd*r**2 - 36*D1**2*K*b1*f*fdd*r*s + 18*D1**2*K*b1*f*fdd*r - 18*D1**2*K*b1*f*fdd*s**2 + 18*D1**2*K*b1*f*fdd*s - 9*D1**2*K*b1*f*fdd - 18*D1**2*K*b1*fd**2*r**2 - 36*D1**2*K*b1*fd**2*r*s + 18*D1**2*K*b1*fd**2*r - 18*D1**2*K*b1*fd**2*s**2 + 18*D1**2*K*b1*fd**2*s + 18*D1**2*K*bd1*f**2*r**2 + 36*D1**2*K*bd1*f**2*r*s - 36*D1**2*K*bd1*f**2*r + 18*D1**2*K*bd1*f**2*s**2 - 36*D1**2*K*bd1*f**2*s + 18*D1**2*K*bd1*f**2 - 36*D1**2*K*bd1*f*fd*r**2 - 72*D1**2*K*bd1*f*fd*r*s + 54*D1**2*K*bd1*f*fd*r - 36*D1**2*K*bd1*f*fd*s**2 + 54*D1**2*K*bd1*f*fd*s - 18*D1**2*K*bd1*f*fd - 9*D1**2*K*bdd1*f**2*r**2 - 18*D1**2*K*bdd1*f**2*r*s + 18*D1**2*K*bdd1*f**2*r - 9*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s - 9*D1**2*K*bdd1*f**2 + 36*D1**2*b2*f*fd*r**2 + 72*D1**2*b2*f*fd*r*s - 36*D1**2*b2*f*fd*r + 36*D1**2*b2*f*fd*s**2 - 36*D1**2*b2*f*fd*s + 18*D1**2*b2*f*fd - 18*D1**2*b2*f*fdd*r**2 - 36*D1**2*b2*f*fdd*r*s + 18*D1**2*b2*f*fdd*r - 18*D1**2*b2*f*fdd*s**2 + 18*D1**2*b2*f*fdd*s - 9*D1**2*b2*f*fdd - 18*D1**2*b2*fd**2*r**2 - 36*D1**2*b2*fd**2*r*s + 18*D1**2*b2*fd**2*r - 18*D1**2*b2*fd**2*s**2 + 18*D1**2*b2*fd**2*s - 9*D1**2*bdd2*f**2*(r + s - 1)**2 - 42*D1**2*f**2*fd*r**2 - 84*D1**2*f**2*fd*r*s + 56*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 56*D1**2*f**2*fd*s - 28*D1**2*f**2*fd + 21*D1**2*f**2*fdd*r**2 + 42*D1**2*f**2*fdd*r*s - 28*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s**2 - 28*D1**2*f**2*fdd*s + 14*D1**2*f**2*fdd - 36*D1**2*f**2*gd2*r**2 - 72*D1**2*f**2*gd2*r*s + 72*D1**2*f**2*gd2*r - 36*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s - 36*D1**2*f**2*gd2 + 18*D1**2*f**2*gdd2*r**2 + 36*D1**2*f**2*gdd2*r*s - 36*D1**2*f**2*gdd2*r + 18*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 18*D1**2*f**2*gdd2 + 42*D1**2*f*fd**2*r**2 + 84*D1**2*f*fd**2*r*s - 56*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s**2 - 56*D1**2*f*fd**2*s + 14*D1**2*f*fd**2 - 72*D1**2*f*fd*g2*r**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 72*D1**2*f*fd*g2*s - 36*D1**2*f*fd*g2 + 72*D1**2*f*fd*gd2*r**2 + 144*D1**2*f*fd*gd2*r*s - 108*D1**2*f*fd*gd2*r + 72*D1**2*f*fd*gd2*s**2 - 108*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 36*D1**2*f*fdd*g2*r**2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 36*D1**2*fd**2*g2*r**2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 72*D1*Dd*K*b1*f**2*r**2 + 144*D1*Dd*K*b1*f**2*r*s - 108*D1*Dd*K*b1*f**2*r + 72*D1*Dd*K*b1*f**2*s**2 - 108*D1*Dd*K*b1*f**2*s + 54*D1*Dd*K*b1*f**2 - 144*D1*Dd*K*b1*f*fd*r**2 - 288*D1*Dd*K*b1*f*fd*r*s + 180*D1*Dd*K*b1*f*fd*r - 144*D1*Dd*K*b1*f*fd*s**2 + 180*D1*Dd*K*b1*f*fd*s - 54*D1*Dd*K*b1*f*fd - 72*D1*Dd*K*bd1*f**2*r**2 - 144*D1*Dd*K*bd1*f**2*r*s + 126*D1*Dd*K*bd1*f**2*r - 72*D1*Dd*K*bd1*f**2*s**2 + 126*D1*Dd*K*bd1*f**2*s - 54*D1*Dd*K*bd1*f**2 + 72*D1*Dd*b2*f**2*r**2 + 144*D1*Dd*b2*f**2*r*s - 108*D1*Dd*b2*f**2*r + 72*D1*Dd*b2*f**2*s**2 - 108*D1*Dd*b2*f**2*s + 54*D1*Dd*b2*f**2 - 144*D1*Dd*b2*f*fd*r**2 - 288*D1*Dd*b2*f*fd*r*s + 180*D1*Dd*b2*f*fd*r - 144*D1*Dd*b2*f*fd*s**2 + 180*D1*Dd*b2*f*fd*s - 54*D1*Dd*b2*f*fd - 56*D1*Dd*f**3*r**2 - 112*D1*Dd*f**3*r*s + 84*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 84*D1*Dd*f**3*s - 42*D1*Dd*f**3 + 168*D1*Dd*f**2*fd*r**2 + 336*D1*Dd*f**2*fd*r*s - 238*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s**2 - 238*D1*Dd*f**2*fd*s + 84*D1*Dd*f**2*fd - 144*D1*Dd*f**2*g2*r**2 - 288*D1*Dd*f**2*g2*r*s + 216*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 216*D1*Dd*f**2*g2*s - 108*D1*Dd*f**2*g2 + 144*D1*Dd*f**2*gd2*r**2 + 288*D1*Dd*f**2*gd2*r*s - 252*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s**2 - 252*D1*Dd*f**2*gd2*s + 108*D1*Dd*f**2*gd2 + 288*D1*Dd*f*fd*g2*r**2 + 576*D1*Dd*f*fd*g2*r*s - 360*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s**2 - 360*D1*Dd*f*fd*g2*s + 108*D1*Dd*f*fd*g2 - 36*D1*Ddd*K*b1*f**2*r**2 - 72*D1*Ddd*K*b1*f**2*r*s + 54*D1*Ddd*K*b1*f**2*r - 36*D1*Ddd*K*b1*f**2*s**2 + 54*D1*Ddd*K*b1*f**2*s - 27*D1*Ddd*K*b1*f**2 - 36*D1*Ddd*b2*f**2*r**2 - 72*D1*Ddd*b2*f**2*r*s + 54*D1*Ddd*b2*f**2*r - 36*D1*Ddd*b2*f**2*s**2 + 54*D1*Ddd*b2*f**2*s - 27*D1*Ddd*b2*f**2 + 28*D1*Ddd*f**3*r**2 + 56*D1*Ddd*f**3*r*s - 42*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 42*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 + 72*D1*Ddd*f**2*g2*r**2 + 144*D1*Ddd*f**2*g2*r*s - 108*D1*Ddd*f**2*g2*r + 72*D1*Ddd*f**2*g2*s**2 - 108*D1*Ddd*f**2*g2*s + 54*D1*Ddd*f**2*g2 + 18*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*K*b1*f**2*r**2 - 216*Dd**2*K*b1*f**2*r*s + 162*Dd**2*K*b1*f**2*r - 108*Dd**2*K*b1*f**2*s**2 + 162*Dd**2*K*b1*f**2*s - 54*Dd**2*K*b1*f**2 - 108*Dd**2*b2*f**2*r**2 - 216*Dd**2*b2*f**2*r*s + 162*Dd**2*b2*f**2*r - 108*Dd**2*b2*f**2*s**2 + 162*Dd**2*b2*f**2*s - 54*Dd**2*b2*f**2 + 84*Dd**2*f**3*r**2 + 168*Dd**2*f**3*r*s - 126*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 126*Dd**2*f**3*s + 42*Dd**2*f**3 + 216*Dd**2*f**2*g2*r**2 + 432*Dd**2*f**2*g2*r*s - 324*Dd**2*f**2*g2*r + 216*Dd**2*f**2*g2*s**2 - 324*Dd**2*f**2*g2*s + 108*Dd**2*f**2*g2)/(126*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**5*k1**5*k2*(6600*C*D1**2*f**2*fd*r**2 + 13200*C*D1**2*f**2*fd*r*s - 8800*C*D1**2*f**2*fd*r + 6600*C*D1**2*f**2*fd*s**2 - 8800*C*D1**2*f**2*fd*s + 4400*C*D1**2*f**2*fd - 9240*C*D1**2*f**2*fdd*r**2 - 18480*C*D1**2*f**2*fdd*r*s + 12320*C*D1**2*f**2*fdd*r - 9240*C*D1**2*f**2*fdd*s**2 + 12320*C*D1**2*f**2*fdd*s - 6160*C*D1**2*f**2*fdd - 18480*C*D1**2*f*fd**2*r**2 - 36960*C*D1**2*f*fd**2*r*s + 24640*C*D1**2*f*fd**2*r - 18480*C*D1**2*f*fd**2*s**2 + 24640*C*D1**2*f*fd**2*s - 6160*C*D1**2*f*fd**2 + 8800*C*D1*Dd*f**3*r**2 + 17600*C*D1*Dd*f**3*r*s - 13200*C*D1*Dd*f**3*r + 8800*C*D1*Dd*f**3*s**2 - 13200*C*D1*Dd*f**3*s + 6600*C*D1*Dd*f**3 - 73920*C*D1*Dd*f**2*fd*r**2 - 147840*C*D1*Dd*f**2*fd*r*s + 104720*C*D1*Dd*f**2*fd*r - 73920*C*D1*Dd*f**2*fd*s**2 + 104720*C*D1*Dd*f**2*fd*s - 36960*C*D1*Dd*f**2*fd - 12320*C*D1*Ddd*f**3*r**2 - 24640*C*D1*Ddd*f**3*r*s + 18480*C*D1*Ddd*f**3*r - 12320*C*D1*Ddd*f**3*s**2 + 18480*C*D1*Ddd*f**3*s - 9240*C*D1*Ddd*f**3 - 36960*C*Dd**2*f**3*r**2 - 73920*C*Dd**2*f**3*r*s + 55440*C*Dd**2*f**3*r - 36960*C*Dd**2*f**3*s**2 + 55440*C*Dd**2*f**3*s - 18480*C*Dd**2*f**3 + 2376*D1**2*K*b1*f*fd*r**2 + 4752*D1**2*K*b1*f*fd*r*s - 2376*D1**2*K*b1*f*fd*r + 2376*D1**2*K*b1*f*fd*s**2 - 2376*D1**2*K*b1*f*fd*s + 1188*D1**2*K*b1*f*fd - 3960*D1**2*K*b1*f*fdd*r**2 - 7920*D1**2*K*b1*f*fdd*r*s + 3960*D1**2*K*b1*f*fdd*r - 3960*D1**2*K*b1*f*fdd*s**2 + 3960*D1**2*K*b1*f*fdd*s - 1980*D1**2*K*b1*f*fdd - 3960*D1**2*K*b1*fd**2*r**2 - 7920*D1**2*K*b1*fd**2*r*s + 3960*D1**2*K*b1*fd**2*r - 3960*D1**2*K*b1*fd**2*s**2 + 3960*D1**2*K*b1*fd**2*s - 2376*D1**2*b1*f*fd*r**2 - 4752*D1**2*b1*f*fd*r*s + 2376*D1**2*b1*f*fd*r - 2376*D1**2*b1*f*fd*s**2 + 2376*D1**2*b1*f*fd*s - 1188*D1**2*b1*f*fd + 3960*D1**2*b1*f*fdd*r**2 + 7920*D1**2*b1*f*fdd*r*s - 3960*D1**2*b1*f*fdd*r + 3960*D1**2*b1*f*fdd*s**2 - 3960*D1**2*b1*f*fdd*s + 1980*D1**2*b1*f*fdd + 3960*D1**2*b1*fd**2*r**2 + 7920*D1**2*b1*fd**2*r*s - 3960*D1**2*b1*fd**2*r + 3960*D1**2*b1*fd**2*s**2 - 3960*D1**2*b1*fd**2*s - 1980*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 11340*D1**2*f**3*fd*r**2 + 22680*D1**2*f**3*fd*r*s - 17010*D1**2*f**3*fd*r + 11340*D1**2*f**3*fd*s**2 - 17010*D1**2*f**3*fd*s + 8505*D1**2*f**3*fd - 12600*D1**2*f**3*fdd*r**2 - 25200*D1**2*f**3*fdd*r*s + 18900*D1**2*f**3*fdd*r - 12600*D1**2*f**3*fdd*s**2 + 18900*D1**2*f**3*fdd*s - 9450*D1**2*f**3*fdd - 37800*D1**2*f**2*fd**2*r**2 - 75600*D1**2*f**2*fd**2*r*s + 56700*D1**2*f**2*fd**2*r - 37800*D1**2*f**2*fd**2*s**2 + 56700*D1**2*f**2*fd**2*s - 18900*D1**2*f**2*fd**2 - 6600*D1**2*f**2*fd*r**2 - 13200*D1**2*f**2*fd*r*s + 8800*D1**2*f**2*fd*r - 6600*D1**2*f**2*fd*s**2 + 8800*D1**2*f**2*fd*s - 4400*D1**2*f**2*fd + 9240*D1**2*f**2*fdd*r**2 + 18480*D1**2*f**2*fdd*r*s - 12320*D1**2*f**2*fdd*r + 9240*D1**2*f**2*fdd*s**2 - 12320*D1**2*f**2*fdd*s + 6160*D1**2*f**2*fdd - 2376*D1**2*f**2*gd2*r**2 - 4752*D1**2*f**2*gd2*r*s + 4752*D1**2*f**2*gd2*r - 2376*D1**2*f**2*gd2*s**2 + 4752*D1**2*f**2*gd2*s - 2376*D1**2*f**2*gd2 + 3960*D1**2*f**2*gdd2*r**2 + 7920*D1**2*f**2*gdd2*r*s - 7920*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 7920*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 + 18480*D1**2*f*fd**2*r**2 + 36960*D1**2*f*fd**2*r*s - 24640*D1**2*f*fd**2*r + 18480*D1**2*f*fd**2*s**2 - 24640*D1**2*f*fd**2*s + 6160*D1**2*f*fd**2 - 4752*D1**2*f*fd*g2*r**2 - 9504*D1**2*f*fd*g2*r*s + 4752*D1**2*f*fd*g2*r - 4752*D1**2*f*fd*g2*s**2 + 4752*D1**2*f*fd*g2*s - 2376*D1**2*f*fd*g2 + 15840*D1**2*f*fd*gd2*r**2 + 31680*D1**2*f*fd*gd2*r*s - 23760*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 23760*D1**2*f*fd*gd2*s + 7920*D1**2*f*fd*gd2 + 7920*D1**2*f*fdd*g2*r**2 + 15840*D1**2*f*fdd*g2*r*s - 7920*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 7920*D1**2*f*fdd*g2*s + 3960*D1**2*f*fdd*g2 + 7920*D1**2*fd**2*g2*r**2 + 15840*D1**2*fd**2*g2*r*s - 7920*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 7920*D1**2*fd**2*g2*s + 4752*D1*Dd*K*b1*f**2*r**2 + 9504*D1*Dd*K*b1*f**2*r*s - 7128*D1*Dd*K*b1*f**2*r + 4752*D1*Dd*K*b1*f**2*s**2 - 7128*D1*Dd*K*b1*f**2*s + 3564*D1*Dd*K*b1*f**2 - 31680*D1*Dd*K*b1*f*fd*r**2 - 63360*D1*Dd*K*b1*f*fd*r*s + 39600*D1*Dd*K*b1*f*fd*r - 31680*D1*Dd*K*b1*f*fd*s**2 + 39600*D1*Dd*K*b1*f*fd*s - 11880*D1*Dd*K*b1*f*fd - 4752*D1*Dd*b1*f**2*r**2 - 9504*D1*Dd*b1*f**2*r*s + 7128*D1*Dd*b1*f**2*r - 4752*D1*Dd*b1*f**2*s**2 + 7128*D1*Dd*b1*f**2*s - 3564*D1*Dd*b1*f**2 + 31680*D1*Dd*b1*f*fd*r**2 + 63360*D1*Dd*b1*f*fd*r*s - 39600*D1*Dd*b1*f*fd*r + 31680*D1*Dd*b1*f*fd*s**2 - 39600*D1*Dd*b1*f*fd*s + 11880*D1*Dd*b1*f*fd + 11340*D1*Dd*f**4*r**2 + 22680*D1*Dd*f**4*r*s - 17010*D1*Dd*f**4*r + 11340*D1*Dd*f**4*s**2 - 17010*D1*Dd*f**4*s + 8505*D1*Dd*f**4 - 100800*D1*Dd*f**3*fd*r**2 - 201600*D1*Dd*f**3*fd*r*s + 151200*D1*Dd*f**3*fd*r - 100800*D1*Dd*f**3*fd*s**2 + 151200*D1*Dd*f**3*fd*s - 56700*D1*Dd*f**3*fd - 8800*D1*Dd*f**3*r**2 - 17600*D1*Dd*f**3*r*s + 13200*D1*Dd*f**3*r - 8800*D1*Dd*f**3*s**2 + 13200*D1*Dd*f**3*s - 6600*D1*Dd*f**3 + 73920*D1*Dd*f**2*fd*r**2 + 147840*D1*Dd*f**2*fd*r*s - 104720*D1*Dd*f**2*fd*r + 73920*D1*Dd*f**2*fd*s**2 - 104720*D1*Dd*f**2*fd*s + 36960*D1*Dd*f**2*fd - 9504*D1*Dd*f**2*g2*r**2 - 19008*D1*Dd*f**2*g2*r*s + 14256*D1*Dd*f**2*g2*r - 9504*D1*Dd*f**2*g2*s**2 + 14256*D1*Dd*f**2*g2*s - 7128*D1*Dd*f**2*g2 + 31680*D1*Dd*f**2*gd2*r**2 + 63360*D1*Dd*f**2*gd2*r*s - 55440*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 55440*D1*Dd*f**2*gd2*s + 23760*D1*Dd*f**2*gd2 + 63360*D1*Dd*f*fd*g2*r**2 + 126720*D1*Dd*f*fd*g2*r*s - 79200*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 79200*D1*Dd*f*fd*g2*s + 23760*D1*Dd*f*fd*g2 - 7920*D1*Ddd*K*b1*f**2*r**2 - 15840*D1*Ddd*K*b1*f**2*r*s + 11880*D1*Ddd*K*b1*f**2*r - 7920*D1*Ddd*K*b1*f**2*s**2 + 11880*D1*Ddd*K*b1*f**2*s - 5940*D1*Ddd*K*b1*f**2 + 7920*D1*Ddd*b1*f**2*r**2 + 15840*D1*Ddd*b1*f**2*r*s - 11880*D1*Ddd*b1*f**2*r + 7920*D1*Ddd*b1*f**2*s**2 - 11880*D1*Ddd*b1*f**2*s + 5940*D1*Ddd*b1*f**2 - 12600*D1*Ddd*f**4*r**2 - 25200*D1*Ddd*f**4*r*s + 18900*D1*Ddd*f**4*r - 12600*D1*Ddd*f**4*s**2 + 18900*D1*Ddd*f**4*s - 9450*D1*Ddd*f**4 + 12320*D1*Ddd*f**3*r**2 + 24640*D1*Ddd*f**3*r*s - 18480*D1*Ddd*f**3*r + 12320*D1*Ddd*f**3*s**2 - 18480*D1*Ddd*f**3*s + 9240*D1*Ddd*f**3 + 15840*D1*Ddd*f**2*g2*r**2 + 31680*D1*Ddd*f**2*g2*r*s - 23760*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 23760*D1*Ddd*f**2*g2*s + 11880*D1*Ddd*f**2*g2 + 396*D1*bd1*f*(K - 1)*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 23760*Dd**2*K*b1*f**2*r**2 - 47520*Dd**2*K*b1*f**2*r*s + 35640*Dd**2*K*b1*f**2*r - 23760*Dd**2*K*b1*f**2*s**2 + 35640*Dd**2*K*b1*f**2*s - 11880*Dd**2*K*b1*f**2 + 23760*Dd**2*b1*f**2*r**2 + 47520*Dd**2*b1*f**2*r*s - 35640*Dd**2*b1*f**2*r + 23760*Dd**2*b1*f**2*s**2 - 35640*Dd**2*b1*f**2*s + 11880*Dd**2*b1*f**2 - 37800*Dd**2*f**4*r**2 - 75600*Dd**2*f**4*r*s + 56700*Dd**2*f**4*r - 37800*Dd**2*f**4*s**2 + 56700*Dd**2*f**4*s - 18900*Dd**2*f**4 + 36960*Dd**2*f**3*r**2 + 73920*Dd**2*f**3*r*s - 55440*Dd**2*f**3*r + 36960*Dd**2*f**3*s**2 - 55440*Dd**2*f**3*s + 18480*Dd**2*f**3 + 47520*Dd**2*f**2*g2*r**2 + 95040*Dd**2*f**2*g2*r*s - 71280*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 71280*Dd**2*f**2*g2*s + 23760*Dd**2*f**2*g2)/(6930*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**5*k1**3*k2**3*st**2*(19272*C*D1**2*f**2*fd*r**2 + 38544*C*D1**2*f**2*fd*r*s - 25696*C*D1**2*f**2*fd*r + 19272*C*D1**2*f**2*fd*s**2 - 25696*C*D1**2*f**2*fd*s + 12848*C*D1**2*f**2*fd - 13200*C*D1**2*f**2*fdd*r**2 - 26400*C*D1**2*f**2*fdd*r*s + 17600*C*D1**2*f**2*fdd*r - 13200*C*D1**2*f**2*fdd*s**2 + 17600*C*D1**2*f**2*fdd*s - 8800*C*D1**2*f**2*fdd - 26400*C*D1**2*f*fd**2*r**2 - 52800*C*D1**2*f*fd**2*r*s + 35200*C*D1**2*f*fd**2*r - 26400*C*D1**2*f*fd**2*s**2 + 35200*C*D1**2*f*fd**2*s - 8800*C*D1**2*f*fd**2 + 25696*C*D1*Dd*f**3*r**2 + 51392*C*D1*Dd*f**3*r*s - 38544*C*D1*Dd*f**3*r + 25696*C*D1*Dd*f**3*s**2 - 38544*C*D1*Dd*f**3*s + 19272*C*D1*Dd*f**3 - 105600*C*D1*Dd*f**2*fd*r**2 - 211200*C*D1*Dd*f**2*fd*r*s + 149600*C*D1*Dd*f**2*fd*r - 105600*C*D1*Dd*f**2*fd*s**2 + 149600*C*D1*Dd*f**2*fd*s - 52800*C*D1*Dd*f**2*fd - 17600*C*D1*Ddd*f**3*r**2 - 35200*C*D1*Ddd*f**3*r*s + 26400*C*D1*Ddd*f**3*r - 17600*C*D1*Ddd*f**3*s**2 + 26400*C*D1*Ddd*f**3*s - 13200*C*D1*Ddd*f**3 - 52800*C*Dd**2*f**3*r**2 - 105600*C*Dd**2*f**3*r*s + 79200*C*Dd**2*f**3*r - 52800*C*Dd**2*f**3*s**2 + 79200*C*Dd**2*f**3*s - 26400*C*Dd**2*f**3 + 10296*D1**2*K*b1*f*fd*r**2 + 20592*D1**2*K*b1*f*fd*r*s - 10296*D1**2*K*b1*f*fd*r + 10296*D1**2*K*b1*f*fd*s**2 - 10296*D1**2*K*b1*f*fd*s + 5148*D1**2*K*b1*f*fd - 7920*D1**2*K*b1*f*fdd*r**2 - 15840*D1**2*K*b1*f*fdd*r*s + 7920*D1**2*K*b1*f*fdd*r - 7920*D1**2*K*b1*f*fdd*s**2 + 7920*D1**2*K*b1*f*fdd*s - 3960*D1**2*K*b1*f*fdd - 7920*D1**2*K*b1*fd**2*r**2 - 15840*D1**2*K*b1*fd**2*r*s + 7920*D1**2*K*b1*fd**2*r - 7920*D1**2*K*b1*fd**2*s**2 + 7920*D1**2*K*b1*fd**2*s - 10296*D1**2*b1*f*fd*r**2 - 20592*D1**2*b1*f*fd*r*s + 10296*D1**2*b1*f*fd*r - 10296*D1**2*b1*f*fd*s**2 + 10296*D1**2*b1*f*fd*s - 5148*D1**2*b1*f*fd + 7920*D1**2*b1*f*fdd*r**2 + 15840*D1**2*b1*f*fdd*r*s - 7920*D1**2*b1*f*fdd*r + 7920*D1**2*b1*f*fdd*s**2 - 7920*D1**2*b1*f*fdd*s + 3960*D1**2*b1*f*fdd + 7920*D1**2*b1*fd**2*r**2 + 15840*D1**2*b1*fd**2*r*s - 7920*D1**2*b1*fd**2*r + 7920*D1**2*b1*fd**2*s**2 - 7920*D1**2*b1*fd**2*s - 3960*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 22800*D1**2*f**3*fd*r**2 + 45600*D1**2*f**3*fd*r*s - 34200*D1**2*f**3*fd*r + 22800*D1**2*f**3*fd*s**2 - 34200*D1**2*f**3*fd*s + 17100*D1**2*f**3*fd - 14700*D1**2*f**3*fdd*r**2 - 29400*D1**2*f**3*fdd*r*s + 22050*D1**2*f**3*fdd*r - 14700*D1**2*f**3*fdd*s**2 + 22050*D1**2*f**3*fdd*s - 11025*D1**2*f**3*fdd - 44100*D1**2*f**2*fd**2*r**2 - 88200*D1**2*f**2*fd**2*r*s + 66150*D1**2*f**2*fd**2*r - 44100*D1**2*f**2*fd**2*s**2 + 66150*D1**2*f**2*fd**2*s - 22050*D1**2*f**2*fd**2 - 19272*D1**2*f**2*fd*r**2 - 38544*D1**2*f**2*fd*r*s + 25696*D1**2*f**2*fd*r - 19272*D1**2*f**2*fd*s**2 + 25696*D1**2*f**2*fd*s - 12848*D1**2*f**2*fd + 13200*D1**2*f**2*fdd*r**2 + 26400*D1**2*f**2*fdd*r*s - 17600*D1**2*f**2*fdd*r + 13200*D1**2*f**2*fdd*s**2 - 17600*D1**2*f**2*fdd*s + 8800*D1**2*f**2*fdd - 10296*D1**2*f**2*gd2*r**2 - 20592*D1**2*f**2*gd2*r*s + 20592*D1**2*f**2*gd2*r - 10296*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s - 10296*D1**2*f**2*gd2 + 7920*D1**2*f**2*gdd2*r**2 + 15840*D1**2*f**2*gdd2*r*s - 15840*D1**2*f**2*gdd2*r + 7920*D1**2*f**2*gdd2*s**2 - 15840*D1**2*f**2*gdd2*s + 7920*D1**2*f**2*gdd2 + 26400*D1**2*f*fd**2*r**2 + 52800*D1**2*f*fd**2*r*s - 35200*D1**2*f*fd**2*r + 26400*D1**2*f*fd**2*s**2 - 35200*D1**2*f*fd**2*s + 8800*D1**2*f*fd**2 - 20592*D1**2*f*fd*g2*r**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 20592*D1**2*f*fd*g2*s**2 + 20592*D1**2*f*fd*g2*s - 10296*D1**2*f*fd*g2 + 31680*D1**2*f*fd*gd2*r**2 + 63360*D1**2*f*fd*gd2*r*s - 47520*D1**2*f*fd*gd2*r + 31680*D1**2*f*fd*gd2*s**2 - 47520*D1**2*f*fd*gd2*s + 15840*D1**2*f*fd*gd2 + 15840*D1**2*f*fdd*g2*r**2 + 31680*D1**2*f*fdd*g2*r*s - 15840*D1**2*f*fdd*g2*r + 15840*D1**2*f*fdd*g2*s**2 - 15840*D1**2*f*fdd*g2*s + 7920*D1**2*f*fdd*g2 + 15840*D1**2*fd**2*g2*r**2 + 31680*D1**2*fd**2*g2*r*s - 15840*D1**2*fd**2*g2*r + 15840*D1**2*fd**2*g2*s**2 - 15840*D1**2*fd**2*g2*s + 20592*D1*Dd*K*b1*f**2*r**2 + 41184*D1*Dd*K*b1*f**2*r*s - 30888*D1*Dd*K*b1*f**2*r + 20592*D1*Dd*K*b1*f**2*s**2 - 30888*D1*Dd*K*b1*f**2*s + 15444*D1*Dd*K*b1*f**2 - 63360*D1*Dd*K*b1*f*fd*r**2 - 126720*D1*Dd*K*b1*f*fd*r*s + 79200*D1*Dd*K*b1*f*fd*r - 63360*D1*Dd*K*b1*f*fd*s**2 + 79200*D1*Dd*K*b1*f*fd*s - 23760*D1*Dd*K*b1*f*fd - 20592*D1*Dd*b1*f**2*r**2 - 41184*D1*Dd*b1*f**2*r*s + 30888*D1*Dd*b1*f**2*r - 20592*D1*Dd*b1*f**2*s**2 + 30888*D1*Dd*b1*f**2*s - 15444*D1*Dd*b1*f**2 + 63360*D1*Dd*b1*f*fd*r**2 + 126720*D1*Dd*b1*f*fd*r*s - 79200*D1*Dd*b1*f*fd*r + 63360*D1*Dd*b1*f*fd*s**2 - 79200*D1*Dd*b1*f*fd*s + 23760*D1*Dd*b1*f*fd + 22800*D1*Dd*f**4*r**2 + 45600*D1*Dd*f**4*r*s - 34200*D1*Dd*f**4*r + 22800*D1*Dd*f**4*s**2 - 34200*D1*Dd*f**4*s + 17100*D1*Dd*f**4 - 117600*D1*Dd*f**3*fd*r**2 - 235200*D1*Dd*f**3*fd*r*s + 176400*D1*Dd*f**3*fd*r - 117600*D1*Dd*f**3*fd*s**2 + 176400*D1*Dd*f**3*fd*s - 66150*D1*Dd*f**3*fd - 25696*D1*Dd*f**3*r**2 - 51392*D1*Dd*f**3*r*s + 38544*D1*Dd*f**3*r - 25696*D1*Dd*f**3*s**2 + 38544*D1*Dd*f**3*s - 19272*D1*Dd*f**3 + 105600*D1*Dd*f**2*fd*r**2 + 211200*D1*Dd*f**2*fd*r*s - 149600*D1*Dd*f**2*fd*r + 105600*D1*Dd*f**2*fd*s**2 - 149600*D1*Dd*f**2*fd*s + 52800*D1*Dd*f**2*fd - 41184*D1*Dd*f**2*g2*r**2 - 82368*D1*Dd*f**2*g2*r*s + 61776*D1*Dd*f**2*g2*r - 41184*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 30888*D1*Dd*f**2*g2 + 63360*D1*Dd*f**2*gd2*r**2 + 126720*D1*Dd*f**2*gd2*r*s - 110880*D1*Dd*f**2*gd2*r + 63360*D1*Dd*f**2*gd2*s**2 - 110880*D1*Dd*f**2*gd2*s + 47520*D1*Dd*f**2*gd2 + 126720*D1*Dd*f*fd*g2*r**2 + 253440*D1*Dd*f*fd*g2*r*s - 158400*D1*Dd*f*fd*g2*r + 126720*D1*Dd*f*fd*g2*s**2 - 158400*D1*Dd*f*fd*g2*s + 47520*D1*Dd*f*fd*g2 - 15840*D1*Ddd*K*b1*f**2*r**2 - 31680*D1*Ddd*K*b1*f**2*r*s + 23760*D1*Ddd*K*b1*f**2*r - 15840*D1*Ddd*K*b1*f**2*s**2 + 23760*D1*Ddd*K*b1*f**2*s - 11880*D1*Ddd*K*b1*f**2 + 15840*D1*Ddd*b1*f**2*r**2 + 31680*D1*Ddd*b1*f**2*r*s - 23760*D1*Ddd*b1*f**2*r + 15840*D1*Ddd*b1*f**2*s**2 - 23760*D1*Ddd*b1*f**2*s + 11880*D1*Ddd*b1*f**2 - 14700*D1*Ddd*f**4*r**2 - 29400*D1*Ddd*f**4*r*s + 22050*D1*Ddd*f**4*r - 14700*D1*Ddd*f**4*s**2 + 22050*D1*Ddd*f**4*s - 11025*D1*Ddd*f**4 + 17600*D1*Ddd*f**3*r**2 + 35200*D1*Ddd*f**3*r*s - 26400*D1*Ddd*f**3*r + 17600*D1*Ddd*f**3*s**2 - 26400*D1*Ddd*f**3*s + 13200*D1*Ddd*f**3 + 31680*D1*Ddd*f**2*g2*r**2 + 63360*D1*Ddd*f**2*g2*r*s - 47520*D1*Ddd*f**2*g2*r + 31680*D1*Ddd*f**2*g2*s**2 - 47520*D1*Ddd*f**2*g2*s + 23760*D1*Ddd*f**2*g2 + 396*D1*bd1*f*(K - 1)*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 47520*Dd**2*K*b1*f**2*r**2 - 95040*Dd**2*K*b1*f**2*r*s + 71280*Dd**2*K*b1*f**2*r - 47520*Dd**2*K*b1*f**2*s**2 + 71280*Dd**2*K*b1*f**2*s - 23760*Dd**2*K*b1*f**2 + 47520*Dd**2*b1*f**2*r**2 + 95040*Dd**2*b1*f**2*r*s - 71280*Dd**2*b1*f**2*r + 47520*Dd**2*b1*f**2*s**2 - 71280*Dd**2*b1*f**2*s + 23760*Dd**2*b1*f**2 - 44100*Dd**2*f**4*r**2 - 88200*Dd**2*f**4*r*s + 66150*Dd**2*f**4*r - 44100*Dd**2*f**4*s**2 + 66150*Dd**2*f**4*s - 22050*Dd**2*f**4 + 52800*Dd**2*f**3*r**2 + 105600*Dd**2*f**3*r*s - 79200*Dd**2*f**3*r + 52800*Dd**2*f**3*s**2 - 79200*Dd**2*f**3*s + 26400*Dd**2*f**3 + 95040*Dd**2*f**2*g2*r**2 + 190080*Dd**2*f**2*g2*r*s - 142560*Dd**2*f**2*g2*r + 95040*Dd**2*f**2*g2*s**2 - 142560*Dd**2*f**2*g2*s + 47520*Dd**2*f**2*g2)/(6930*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**5*k1**3*k2**3*(-360*C*D1**2*bdd1*f**2*r**2 - 720*C*D1**2*bdd1*f**2*r*s + 720*C*D1**2*bdd1*f**2*r - 360*C*D1**2*bdd1*f**2*s**2 + 720*C*D1**2*bdd1*f**2*s - 360*C*D1**2*bdd1*f**2 + 1800*C*D1**2*f**2*fd*r**2 + 3600*C*D1**2*f**2*fd*r*s - 2400*C*D1**2*f**2*fd*r + 1800*C*D1**2*f**2*fd*s**2 - 2400*C*D1**2*f**2*fd*s + 1200*C*D1**2*f**2*fd - 2520*C*D1**2*f**2*fdd*r**2 - 5040*C*D1**2*f**2*fdd*r*s + 3360*C*D1**2*f**2*fdd*r - 2520*C*D1**2*f**2*fdd*s**2 + 3360*C*D1**2*f**2*fdd*s - 1680*C*D1**2*f**2*fdd - 5040*C*D1**2*f*fd**2*r**2 - 10080*C*D1**2*f*fd**2*r*s + 6720*C*D1**2*f*fd**2*r - 5040*C*D1**2*f*fd**2*s**2 + 6720*C*D1**2*f*fd**2*s - 1680*C*D1**2*f*fd**2 + 2400*C*D1*Dd*f**3*r**2 + 4800*C*D1*Dd*f**3*r*s - 3600*C*D1*Dd*f**3*r + 2400*C*D1*Dd*f**3*s**2 - 3600*C*D1*Dd*f**3*s + 1800*C*D1*Dd*f**3 - 20160*C*D1*Dd*f**2*fd*r**2 - 40320*C*D1*Dd*f**2*fd*r*s + 28560*C*D1*Dd*f**2*fd*r - 20160*C*D1*Dd*f**2*fd*s**2 + 28560*C*D1*Dd*f**2*fd*s - 10080*C*D1*Dd*f**2*fd - 3360*C*D1*Ddd*f**3*r**2 - 6720*C*D1*Ddd*f**3*r*s + 5040*C*D1*Ddd*f**3*r - 3360*C*D1*Ddd*f**3*s**2 + 5040*C*D1*Ddd*f**3*s - 2520*C*D1*Ddd*f**3 - 10080*C*Dd**2*f**3*r**2 - 20160*C*Dd**2*f**3*r*s + 15120*C*Dd**2*f**3*r - 10080*C*Dd**2*f**3*s**2 + 15120*C*Dd**2*f**3*s - 5040*C*Dd**2*f**3 - 540*D1**2*K*bdd1*f**2*r**2 - 1080*D1**2*K*bdd1*f**2*r*s + 1080*D1**2*K*bdd1*f**2*r - 540*D1**2*K*bdd1*f**2*s**2 + 1080*D1**2*K*bdd1*f**2*s - 540*D1**2*K*bdd1*f**2 - 504*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 175*D1**2*bdd1*f**3*r**2 + 350*D1**2*bdd1*f**3*r*s - 350*D1**2*bdd1*f**3*r + 175*D1**2*bdd1*f**3*s**2 - 350*D1**2*bdd1*f**3*s + 175*D1**2*bdd1*f**3 + 630*D1**2*bdd1*f**2*r**2 + 1260*D1**2*bdd1*f**2*r*s - 1260*D1**2*bdd1*f**2*r + 630*D1**2*bdd1*f**2*s**2 - 1260*D1**2*bdd1*f**2*s + 630*D1**2*bdd1*f**2 + 504*D1**2*bdd1*f*g2*r**2 + 1008*D1**2*bdd1*f*g2*r*s - 1008*D1**2*bdd1*f*g2*r + 504*D1**2*bdd1*f*g2*s**2 - 1008*D1**2*bdd1*f*g2*s + 504*D1**2*bdd1*f*g2 - 420*D1**2*f**3*fd*r**2 - 840*D1**2*f**3*fd*r*s + 630*D1**2*f**3*fd*r - 420*D1**2*f**3*fd*s**2 + 630*D1**2*f**3*fd*s - 315*D1**2*f**3*fd - 1215*D1**2*f**2*fd*r**2 - 2430*D1**2*f**2*fd*r*s + 1620*D1**2*f**2*fd*r - 1215*D1**2*f**2*fd*s**2 + 1620*D1**2*f**2*fd*s - 810*D1**2*f**2*fd + 1890*D1**2*f**2*fdd*r**2 + 3780*D1**2*f**2*fdd*r*s - 2520*D1**2*f**2*fdd*r + 1890*D1**2*f**2*fdd*s**2 - 2520*D1**2*f**2*fdd*s + 1260*D1**2*f**2*fdd - 648*D1**2*f**2*gd2*r**2 - 1296*D1**2*f**2*gd2*r*s + 1296*D1**2*f**2*gd2*r - 648*D1**2*f**2*gd2*s**2 + 1296*D1**2*f**2*gd2*s - 648*D1**2*f**2*gd2 + 1080*D1**2*f**2*gdd2*r**2 + 2160*D1**2*f**2*gdd2*r*s - 2160*D1**2*f**2*gdd2*r + 1080*D1**2*f**2*gdd2*s**2 - 2160*D1**2*f**2*gdd2*s + 1080*D1**2*f**2*gdd2 + 3780*D1**2*f*fd**2*r**2 + 7560*D1**2*f*fd**2*r*s - 5040*D1**2*f*fd**2*r + 3780*D1**2*f*fd**2*s**2 - 5040*D1**2*f*fd**2*s + 1260*D1**2*f*fd**2 - 1296*D1**2*f*fd*g2*r**2 - 2592*D1**2*f*fd*g2*r*s + 1296*D1**2*f*fd*g2*r - 1296*D1**2*f*fd*g2*s**2 + 1296*D1**2*f*fd*g2*s - 648*D1**2*f*fd*g2 + 4320*D1**2*f*fd*gd2*r**2 + 8640*D1**2*f*fd*gd2*r*s - 6480*D1**2*f*fd*gd2*r + 4320*D1**2*f*fd*gd2*s**2 - 6480*D1**2*f*fd*gd2*s + 2160*D1**2*f*fd*gd2 + 2160*D1**2*f*fdd*g2*r**2 + 4320*D1**2*f*fdd*g2*r*s - 2160*D1**2*f*fdd*g2*r + 2160*D1**2*f*fdd*g2*s**2 - 2160*D1**2*f*fdd*g2*s + 1080*D1**2*f*fdd*g2 + 2160*D1**2*fd**2*g2*r**2 + 4320*D1**2*fd**2*g2*r*s - 2160*D1**2*fd**2*g2*r + 2160*D1**2*fd**2*g2*s**2 - 2160*D1**2*fd**2*g2*s - 420*D1*Dd*f**4*r**2 - 840*D1*Dd*f**4*r*s + 630*D1*Dd*f**4*r - 420*D1*Dd*f**4*s**2 + 630*D1*Dd*f**4*s - 315*D1*Dd*f**4 - 1620*D1*Dd*f**3*r**2 - 3240*D1*Dd*f**3*r*s + 2430*D1*Dd*f**3*r - 1620*D1*Dd*f**3*s**2 + 2430*D1*Dd*f**3*s - 1215*D1*Dd*f**3 + 15120*D1*Dd*f**2*fd*r**2 + 30240*D1*Dd*f**2*fd*r*s - 21420*D1*Dd*f**2*fd*r + 15120*D1*Dd*f**2*fd*s**2 - 21420*D1*Dd*f**2*fd*s + 7560*D1*Dd*f**2*fd - 2592*D1*Dd*f**2*g2*r**2 - 5184*D1*Dd*f**2*g2*r*s + 3888*D1*Dd*f**2*g2*r - 2592*D1*Dd*f**2*g2*s**2 + 3888*D1*Dd*f**2*g2*s - 1944*D1*Dd*f**2*g2 + 8640*D1*Dd*f**2*gd2*r**2 + 17280*D1*Dd*f**2*gd2*r*s - 15120*D1*Dd*f**2*gd2*r + 8640*D1*Dd*f**2*gd2*s**2 - 15120*D1*Dd*f**2*gd2*s + 6480*D1*Dd*f**2*gd2 + 17280*D1*Dd*f*fd*g2*r**2 + 34560*D1*Dd*f*fd*g2*r*s - 21600*D1*Dd*f*fd*g2*r + 17280*D1*Dd*f*fd*g2*s**2 - 21600*D1*Dd*f*fd*g2*s + 6480*D1*Dd*f*fd*g2 + 2520*D1*Ddd*f**3*r**2 + 5040*D1*Ddd*f**3*r*s - 3780*D1*Ddd*f**3*r + 2520*D1*Ddd*f**3*s**2 - 3780*D1*Ddd*f**3*s + 1890*D1*Ddd*f**3 + 4320*D1*Ddd*f**2*g2*r**2 + 8640*D1*Ddd*f**2*g2*r*s - 6480*D1*Ddd*f**2*g2*r + 4320*D1*Ddd*f**2*g2*s**2 - 6480*D1*Ddd*f**2*g2*s + 3240*D1*Ddd*f**2*g2 - D1*bd1*(D1*(125*f**3*(r + s - 1) - f**2*(468*C*(r + s - 1) + 350*fd*(3*r + 3*s - 2) + (324*K - 567)*(r + s - 1)) + 12*f*(15*fd*(4*C + 6*K - 7)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) - 1008*fd*g2*(r + s)) - 2*Dd*f*(175*f**2 - 90*f*(4*C + 6*K - 7) + 504*g2)*(4*r + 4*s - 3))*(r + s - 1) + 7560*Dd**2*f**3*r**2 + 15120*Dd**2*f**3*r*s - 11340*Dd**2*f**3*r + 7560*Dd**2*f**3*s**2 - 11340*Dd**2*f**3*s + 3780*Dd**2*f**3 + 12960*Dd**2*f**2*g2*r**2 + 25920*Dd**2*f**2*g2*r*s - 19440*Dd**2*f**2*g2*r + 12960*Dd**2*f**2*g2*s**2 - 19440*Dd**2*f**2*g2*s + 6480*Dd**2*f**2*g2 + 42*b1**2*(K - 1)*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(936*C*D1**2*f*fd*r**2 + 1872*C*D1**2*f*fd*r*s - 936*C*D1**2*f*fd*r + 936*C*D1**2*f*fd*s**2 - 936*C*D1**2*f*fd*s + 468*C*D1**2*f*fd - 720*C*D1**2*f*fdd*r**2 - 1440*C*D1**2*f*fdd*r*s + 720*C*D1**2*f*fdd*r - 720*C*D1**2*f*fdd*s**2 + 720*C*D1**2*f*fdd*s - 360*C*D1**2*f*fdd - 720*C*D1**2*fd**2*r**2 - 1440*C*D1**2*fd**2*r*s + 720*C*D1**2*fd**2*r - 720*C*D1**2*fd**2*s**2 + 720*C*D1**2*fd**2*s + 1872*C*D1*Dd*f**2*r**2 + 3744*C*D1*Dd*f**2*r*s - 2808*C*D1*Dd*f**2*r + 1872*C*D1*Dd*f**2*s**2 - 2808*C*D1*Dd*f**2*s + 1404*C*D1*Dd*f**2 - 5760*C*D1*Dd*f*fd*r**2 - 11520*C*D1*Dd*f*fd*r*s + 7200*C*D1*Dd*f*fd*r - 5760*C*D1*Dd*f*fd*s**2 + 7200*C*D1*Dd*f*fd*s - 2160*C*D1*Dd*f*fd - 1440*C*D1*Ddd*f**2*r**2 - 2880*C*D1*Ddd*f**2*r*s + 2160*C*D1*Ddd*f**2*r - 1440*C*D1*Ddd*f**2*s**2 + 2160*C*D1*Ddd*f**2*s - 1080*C*D1*Ddd*f**2 - 4320*C*Dd**2*f**2*r**2 - 8640*C*Dd**2*f**2*r*s + 6480*C*Dd**2*f**2*r - 4320*C*Dd**2*f**2*s**2 + 6480*C*Dd**2*f**2*s - 2160*C*Dd**2*f**2 + 648*D1**2*K*f*fd*r**2 + 1296*D1**2*K*f*fd*r*s - 648*D1**2*K*f*fd*r + 648*D1**2*K*f*fd*s**2 - 648*D1**2*K*f*fd*s + 324*D1**2*K*f*fd - 1080*D1**2*K*f*fdd*r**2 - 2160*D1**2*K*f*fdd*r*s + 1080*D1**2*K*f*fdd*r - 1080*D1**2*K*f*fdd*s**2 + 1080*D1**2*K*f*fdd*s - 540*D1**2*K*f*fdd - 1080*D1**2*K*fd**2*r**2 - 2160*D1**2*K*fd**2*r*s + 1080*D1**2*K*fd**2*r - 1080*D1**2*K*fd**2*s**2 + 1080*D1**2*K*fd**2*s - 504*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 375*D1**2*f**2*fd*r**2 - 750*D1**2*f**2*fd*r*s + 500*D1**2*f**2*fd*r - 375*D1**2*f**2*fd*s**2 + 500*D1**2*f**2*fd*s - 250*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 700*D1**2*f**2*fdd*s + 350*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1400*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 - 1134*D1**2*f*fd*r**2 - 2268*D1**2*f*fd*r*s + 1134*D1**2*f*fd*r - 1134*D1**2*f*fd*s**2 + 1134*D1**2*f*fd*s - 567*D1**2*f*fd + 1260*D1**2*f*fdd*r**2 + 2520*D1**2*f*fdd*r*s - 1260*D1**2*f*fdd*r + 1260*D1**2*f*fdd*s**2 - 1260*D1**2*f*fdd*s + 630*D1**2*f*fdd - 588*D1**2*f*gd2*r**2 - 1176*D1**2*f*gd2*r*s + 1176*D1**2*f*gd2*r - 588*D1**2*f*gd2*s**2 + 1176*D1**2*f*gd2*s - 588*D1**2*f*gd2 + 504*D1**2*f*gdd2*r**2 + 1008*D1**2*f*gdd2*r*s - 1008*D1**2*f*gdd2*r + 504*D1**2*f*gdd2*s**2 - 1008*D1**2*f*gdd2*s + 504*D1**2*f*gdd2 + 1260*D1**2*fd**2*r**2 + 2520*D1**2*fd**2*r*s - 1260*D1**2*fd**2*r + 1260*D1**2*fd**2*s**2 - 1260*D1**2*fd**2*s - 588*D1**2*fd*g2*r**2 - 1176*D1**2*fd*g2*r*s - 588*D1**2*fd*g2*s**2 + 1008*D1**2*fd*gd2*r**2 + 2016*D1**2*fd*gd2*r*s - 1008*D1**2*fd*gd2*r + 1008*D1**2*fd*gd2*s**2 - 1008*D1**2*fd*gd2*s + 504*D1**2*fdd*g2*r**2 + 1008*D1**2*fdd*g2*r*s + 504*D1**2*fdd*g2*s**2 + 1296*D1*Dd*K*f**2*r**2 + 2592*D1*Dd*K*f**2*r*s - 1944*D1*Dd*K*f**2*r + 1296*D1*Dd*K*f**2*s**2 - 1944*D1*Dd*K*f**2*s + 972*D1*Dd*K*f**2 - 8640*D1*Dd*K*f*fd*r**2 - 17280*D1*Dd*K*f*fd*r*s + 10800*D1*Dd*K*f*fd*r - 8640*D1*Dd*K*f*fd*s**2 + 10800*D1*Dd*K*f*fd*s - 3240*D1*Dd*K*f*fd - 500*D1*Dd*f**3*r**2 - 1000*D1*Dd*f**3*r*s + 750*D1*Dd*f**3*r - 500*D1*Dd*f**3*s**2 + 750*D1*Dd*f**3*s - 375*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 5950*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 5950*D1*Dd*f**2*fd*s + 2100*D1*Dd*f**2*fd - 2268*D1*Dd*f**2*r**2 - 4536*D1*Dd*f**2*r*s + 3402*D1*Dd*f**2*r - 2268*D1*Dd*f**2*s**2 + 3402*D1*Dd*f**2*s - 1701*D1*Dd*f**2 + 10080*D1*Dd*f*fd*r**2 + 20160*D1*Dd*f*fd*r*s - 12600*D1*Dd*f*fd*r + 10080*D1*Dd*f*fd*s**2 - 12600*D1*Dd*f*fd*s + 3780*D1*Dd*f*fd - 2352*D1*Dd*f*g2*r**2 - 4704*D1*Dd*f*g2*r*s + 3528*D1*Dd*f*g2*r - 2352*D1*Dd*f*g2*s**2 + 3528*D1*Dd*f*g2*s - 1764*D1*Dd*f*g2 + 4032*D1*Dd*f*gd2*r**2 + 8064*D1*Dd*f*gd2*r*s - 7056*D1*Dd*f*gd2*r + 4032*D1*Dd*f*gd2*s**2 - 7056*D1*Dd*f*gd2*s + 3024*D1*Dd*f*gd2 + 4032*D1*Dd*fd*g2*r**2 + 8064*D1*Dd*fd*g2*r*s - 3024*D1*Dd*fd*g2*r + 4032*D1*Dd*fd*g2*s**2 - 3024*D1*Dd*fd*g2*s - 2160*D1*Ddd*K*f**2*r**2 - 4320*D1*Ddd*K*f**2*r*s + 3240*D1*Ddd*K*f**2*r - 2160*D1*Ddd*K*f**2*s**2 + 3240*D1*Ddd*K*f**2*s - 1620*D1*Ddd*K*f**2 + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 1050*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 525*D1*Ddd*f**3 + 2520*D1*Ddd*f**2*r**2 + 5040*D1*Ddd*f**2*r*s - 3780*D1*Ddd*f**2*r + 2520*D1*Ddd*f**2*s**2 - 3780*D1*Ddd*f**2*s + 1890*D1*Ddd*f**2 + 2016*D1*Ddd*f*g2*r**2 + 4032*D1*Ddd*f*g2*r*s - 3024*D1*Ddd*f*g2*r + 2016*D1*Ddd*f*g2*s**2 - 3024*D1*Ddd*f*g2*s + 1512*D1*Ddd*f*g2 + 84*D1*bd1*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 6480*Dd**2*K*f**2*r**2 - 12960*Dd**2*K*f**2*r*s + 9720*Dd**2*K*f**2*r - 6480*Dd**2*K*f**2*s**2 + 9720*Dd**2*K*f**2*s - 3240*Dd**2*K*f**2 + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 3150*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 1050*Dd**2*f**3 + 7560*Dd**2*f**2*r**2 + 15120*Dd**2*f**2*r*s - 11340*Dd**2*f**2*r + 7560*Dd**2*f**2*s**2 - 11340*Dd**2*f**2*s + 3780*Dd**2*f**2 + 6048*Dd**2*f*g2*r**2 + 12096*Dd**2*f*g2*r*s - 9072*Dd**2*f*g2*r + 6048*Dd**2*f*g2*s**2 - 9072*Dd**2*f*g2*s + 3024*Dd**2*f*g2))/(630*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**5*k1**3*k2*(84*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*bd1*(D1*(-5*f**3*(21*r**2 + r*(42*s - 26) + 21*s**2 - 26*s + 13) + f**2*(70*fd*(9*r**2 + r*(18*s - 13) + 9*s**2 - 13*s + 4) - 3*r**2*(12*C + 13) - 3*r*(s*(24*C + 26) - 50) - 3*s**2*(12*C + 13) + 150*s - 75) + 4*f*(15*fd*(r + s - 1)*(r*(4*C + 2) + s*(4*C + 2) - 3) - (7*r + 7*s)*(-g2*(r + s) + 6*gd2*(r + s - 1))) - 168*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(4*r + 4*s - 3)*(35*f**2*(3*r + 3*s - 2) + 30*f*(2*C*r + 2*C*s + r + s - 3) - 84*g2*(r + s))) - 14*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-72*C*D1**2*f*fd*r**2 - 144*C*D1**2*f*fd*r*s + 144*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 144*C*D1**2*f*fd*s - 72*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 240*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 240*C*D1**2*f*fdd*s + 120*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s - 240*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 240*C*D1**2*fd**2*s + 120*C*D1**2*fd**2 - 144*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 216*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 216*C*D1*Dd*f**2*s - 108*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 1680*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1680*C*D1*Dd*f*fd*s + 720*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 360*C*Dd**2*f**2 + 42*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 315*D1**2*f**2*fd*r**2 - 630*D1**2*f**2*fd*r*s + 500*D1**2*f**2*fd*r - 315*D1**2*f**2*fd*s**2 + 500*D1**2*f**2*fd*s - 250*D1**2*f**2*fd + 315*D1**2*f**2*fdd*r**2 + 630*D1**2*f**2*fdd*r*s - 490*D1**2*f**2*fdd*r + 315*D1**2*f**2*fdd*s**2 - 490*D1**2*f**2*fdd*s + 245*D1**2*f**2*fdd + 630*D1**2*f*fd**2*r**2 + 1260*D1**2*f*fd**2*r*s - 980*D1**2*f*fd**2*r + 630*D1**2*f*fd**2*s**2 - 980*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 - 78*D1**2*f*fd*r**2 - 156*D1**2*f*fd*r*s + 6*D1**2*f*fd*r - 78*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 60*D1**2*f*fdd*r**2 + 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s - 30*D1**2*f*fdd + 28*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r + 28*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s + 28*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 + 60*D1**2*fd**2*r**2 + 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s - 120*D1**2*fd**2 + 28*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 28*D1**2*fd*g2*s**2 - 56*D1**2*fd*g2*s + 28*D1**2*fd*g2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 336*D1**2*fd*gd2*s - 168*D1**2*fd*gd2 - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s + 168*D1**2*fdd*g2*r - 84*D1**2*fdd*g2*s**2 + 168*D1**2*fdd*g2*s - 84*D1**2*fdd*g2 - 420*D1*Dd*f**3*r**2 - 840*D1*Dd*f**3*r*s + 630*D1*Dd*f**3*r - 420*D1*Dd*f**3*s**2 + 630*D1*Dd*f**3*s - 315*D1*Dd*f**3 + 2520*D1*Dd*f**2*fd*r**2 + 5040*D1*Dd*f**2*fd*r*s - 3850*D1*Dd*f**2*fd*r + 2520*D1*Dd*f**2*fd*s**2 - 3850*D1*Dd*f**2*fd*s + 1470*D1*Dd*f**2*fd - 156*D1*Dd*f**2*r**2 - 312*D1*Dd*f**2*r*s + 234*D1*Dd*f**2*r - 156*D1*Dd*f**2*s**2 + 234*D1*Dd*f**2*s - 117*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 + 960*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 120*D1*Dd*f*fd*s - 180*D1*Dd*f*fd + 112*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 112*D1*Dd*f*g2*s**2 - 168*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 1176*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 1176*D1*Dd*fd*g2*s - 504*D1*Dd*fd*g2 + 420*D1*Ddd*f**3*r**2 + 840*D1*Ddd*f**3*r*s - 630*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s**2 - 630*D1*Ddd*f**3*s + 315*D1*Ddd*f**3 + 120*D1*Ddd*f**2*r**2 + 240*D1*Ddd*f**2*r*s - 180*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 180*D1*Ddd*f**2*s + 90*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 - 14*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 1260*Dd**2*f**3*r**2 + 2520*Dd**2*f**3*r*s - 1890*Dd**2*f**3*r + 1260*Dd**2*f**3*s**2 - 1890*Dd**2*f**3*s + 630*Dd**2*f**3 + 360*Dd**2*f**2*r**2 + 720*Dd**2*f**2*r*s - 540*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 540*Dd**2*f**2*s + 180*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2) + f*(D1**2*bdd1*(35*f**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 30*f*(2*C*s**2 + r**2*(2*C + 1) + 2*r*(2*C*s + s - 3) + s**2 - 6*s + 3) - 84*g2*(r + s)**2) - 5*D1**2*(f*(13*fd - 14*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 28*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 5*D1*f*(Dd*(13*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 28*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 14*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 420*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**5*k1*k2**5*st**2*(-120*C*D1**2*f**2*fd*r**2 - 240*C*D1**2*f**2*fd*r*s + 160*C*D1**2*f**2*fd*r - 120*C*D1**2*f**2*fd*s**2 + 160*C*D1**2*f**2*fd*s - 80*C*D1**2*f**2*fd + 60*C*D1**2*f**2*fdd*r**2 + 120*C*D1**2*f**2*fdd*r*s - 80*C*D1**2*f**2*fdd*r + 60*C*D1**2*f**2*fdd*s**2 - 80*C*D1**2*f**2*fdd*s + 40*C*D1**2*f**2*fdd + 120*C*D1**2*f*fd**2*r**2 + 240*C*D1**2*f*fd**2*r*s - 160*C*D1**2*f*fd**2*r + 120*C*D1**2*f*fd**2*s**2 - 160*C*D1**2*f*fd**2*s + 40*C*D1**2*f*fd**2 - 160*C*D1*Dd*f**3*r**2 - 320*C*D1*Dd*f**3*r*s + 240*C*D1*Dd*f**3*r - 160*C*D1*Dd*f**3*s**2 + 240*C*D1*Dd*f**3*s - 120*C*D1*Dd*f**3 + 480*C*D1*Dd*f**2*fd*r**2 + 960*C*D1*Dd*f**2*fd*r*s - 680*C*D1*Dd*f**2*fd*r + 480*C*D1*Dd*f**2*fd*s**2 - 680*C*D1*Dd*f**2*fd*s + 240*C*D1*Dd*f**2*fd + 80*C*D1*Ddd*f**3*r**2 + 160*C*D1*Ddd*f**3*r*s - 120*C*D1*Ddd*f**3*r + 80*C*D1*Ddd*f**3*s**2 - 120*C*D1*Ddd*f**3*s + 60*C*D1*Ddd*f**3 + 240*C*Dd**2*f**3*r**2 + 480*C*Dd**2*f**3*r*s - 360*C*Dd**2*f**3*r + 240*C*Dd**2*f**3*s**2 - 360*C*Dd**2*f**3*s + 120*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 - 144*D1**2*K*b1*f*fd*r*s + 72*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 + 90*D1**2*f**2*fd*r**2 + 180*D1**2*f**2*fd*r*s - 120*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 45*D1**2*f**2*fdd*r**2 - 90*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 45*D1**2*f**2*fdd*s**2 + 60*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r - 36*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 90*D1**2*f*fd**2*r**2 - 180*D1**2*f*fd**2*r*s + 120*D1**2*f*fd**2*r - 90*D1**2*f*fd**2*s**2 + 120*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 - 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 216*D1*Dd*K*b1*f**2*s - 108*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r**2 + 576*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 360*D1*Dd*K*b1*f*fd*s + 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 120*D1*Dd*f**3*r**2 + 240*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r + 120*D1*Dd*f**3*s**2 - 180*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r**2 - 720*D1*Dd*f**2*fd*r*s + 510*D1*Dd*f**2*fd*r - 360*D1*Dd*f**2*fd*s**2 + 510*D1*Dd*f**2*fd*s - 180*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 504*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 720*D1*Dd*f*fd*g2*s - 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 + 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 108*D1*Ddd*K*b1*f**2*s + 54*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 60*D1*Ddd*f**3*r**2 - 120*D1*Ddd*f**3*r*s + 90*D1*Ddd*f**3*r - 60*D1*Ddd*f**3*s**2 + 90*D1*Ddd*f**3*s - 45*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 216*D1*Ddd*f**2*g2*s - 108*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*b1*f**2*r**2 + 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 324*Dd**2*K*b1*f**2*s + 108*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 180*Dd**2*f**3*r**2 - 360*Dd**2*f**3*r*s + 270*Dd**2*f**3*r - 180*Dd**2*f**3*s**2 + 270*Dd**2*f**3*s - 90*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 648*Dd**2*f**2*g2*s - 216*Dd**2*f**2*g2)/(42*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**5*k1*k2**5*(180*C*D1**2*bdd1*f**2*r**2 + 360*C*D1**2*bdd1*f**2*r*s - 360*C*D1**2*bdd1*f**2*r + 180*C*D1**2*bdd1*f**2*s**2 - 360*C*D1**2*bdd1*f**2*s + 180*C*D1**2*bdd1*f**2 - 600*C*D1**2*f**2*fd*r**2 - 1200*C*D1**2*f**2*fd*r*s + 800*C*D1**2*f**2*fd*r - 600*C*D1**2*f**2*fd*s**2 + 800*C*D1**2*f**2*fd*s - 400*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r**2 + 1680*C*D1**2*f**2*fdd*r*s - 1120*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 1120*C*D1**2*f**2*fdd*s + 560*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r**2 + 3360*C*D1**2*f*fd**2*r*s - 2240*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 2240*C*D1**2*f*fd**2*s + 560*C*D1**2*f*fd**2 - 800*C*D1*Dd*f**3*r**2 - 1600*C*D1*Dd*f**3*r*s + 1200*C*D1*Dd*f**3*r - 800*C*D1*Dd*f**3*s**2 + 1200*C*D1*Dd*f**3*s - 600*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r**2 + 13440*C*D1*Dd*f**2*fd*r*s - 9520*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 9520*C*D1*Dd*f**2*fd*s + 3360*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r**2 + 2240*C*D1*Ddd*f**3*r*s - 1680*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1680*C*D1*Ddd*f**3*s + 840*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r**2 + 6720*C*Dd**2*f**3*r*s - 5040*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 5040*C*Dd**2*f**3*s + 1680*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r**2 + 360*D1**2*K*bdd1*f**2*r*s - 360*D1**2*K*bdd1*f**2*r + 180*D1**2*K*bdd1*f**2*s**2 - 360*D1**2*K*bdd1*f**2*s + 180*D1**2*K*bdd1*f**2 - 18*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 135*D1**2*bdd1*f**2*r**2 - 270*D1**2*bdd1*f**2*r*s + 270*D1**2*bdd1*f**2*r - 135*D1**2*bdd1*f**2*s**2 + 270*D1**2*bdd1*f**2*s - 135*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r**2 - 504*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 252*D1**2*bdd1*f*g2*s**2 + 504*D1**2*bdd1*f*g2*s - 252*D1**2*bdd1*f*g2 + 165*D1**2*f**2*fd*r**2 + 330*D1**2*f**2*fd*r*s - 220*D1**2*f**2*fd*r + 165*D1**2*f**2*fd*s**2 - 220*D1**2*f**2*fd*s + 110*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd + 216*D1**2*f**2*gd2*r**2 + 432*D1**2*f**2*gd2*r*s - 432*D1**2*f**2*gd2*r + 216*D1**2*f**2*gd2*s**2 - 432*D1**2*f**2*gd2*s + 216*D1**2*f**2*gd2 - 360*D1**2*f**2*gdd2*r**2 - 720*D1**2*f**2*gdd2*r*s + 720*D1**2*f**2*gdd2*r - 360*D1**2*f**2*gdd2*s**2 + 720*D1**2*f**2*gdd2*s - 360*D1**2*f**2*gdd2 - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 432*D1**2*f*fd*g2*r**2 + 864*D1**2*f*fd*g2*r*s - 432*D1**2*f*fd*g2*r + 432*D1**2*f*fd*g2*s**2 - 432*D1**2*f*fd*g2*s + 216*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r**2 - 2880*D1**2*f*fd*gd2*r*s + 2160*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 2160*D1**2*f*fd*gd2*s - 720*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r**2 - 1440*D1**2*f*fdd*g2*r*s + 720*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r**2 - 1440*D1**2*fd**2*g2*r*s + 720*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s + 220*D1*Dd*f**3*r**2 + 440*D1*Dd*f**3*r*s - 330*D1*Dd*f**3*r + 220*D1*Dd*f**3*s**2 - 330*D1*Dd*f**3*s + 165*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd + 864*D1*Dd*f**2*g2*r**2 + 1728*D1*Dd*f**2*g2*r*s - 1296*D1*Dd*f**2*g2*r + 864*D1*Dd*f**2*g2*s**2 - 1296*D1*Dd*f**2*g2*s + 648*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r**2 - 5760*D1*Dd*f**2*gd2*r*s + 5040*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 5040*D1*Dd*f**2*gd2*s - 2160*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r**2 - 11520*D1*Dd*f*fd*g2*r*s + 7200*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 7200*D1*Dd*f*fd*g2*s - 2160*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r**2 - 2880*D1*Ddd*f**2*g2*r*s + 2160*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 2160*D1*Ddd*f**2*g2*s - 1080*D1*Ddd*f**2*g2 - 9*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(40*C + 12*K - 23)*(r + s - 1) - 10*f*fd*(4*C + 4*K - 3)*(2*r + 2*s - 1) - 56*f*(g2 - gd2)*(r + s - 1) + 56*fd*g2*(r + s)) - 2*Dd*f*(5*f*(4*C + 4*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r**2 - 8640*Dd**2*f**2*g2*r*s + 6480*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 6480*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 + 9*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(-80*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s + 80*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 80*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 240*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 240*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 400*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 46*D1**2*f*fd*r**2 + 92*D1**2*f*fd*r*s - 46*D1**2*f*fd*r + 46*D1**2*f*fd*s**2 - 46*D1**2*f*fd*s + 23*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 92*D1*Dd*f**2*r**2 + 184*D1*Dd*f**2*r*s - 138*D1*Dd*f**2*r + 92*D1*Dd*f**2*s**2 - 138*D1*Dd*f**2*s + 69*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(630*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**5*k1*k2**3*st**2*(-42*D1**2*b1*f**2*fd*r**2 - 84*D1**2*b1*f**2*fd*r*s + 56*D1**2*b1*f**2*fd*r - 42*D1**2*b1*f**2*fd*s**2 + 56*D1**2*b1*f**2*fd*s - 28*D1**2*b1*f**2*fd + 21*D1**2*b1*f**2*fdd*r**2 + 42*D1**2*b1*f**2*fdd*r*s - 28*D1**2*b1*f**2*fdd*r + 21*D1**2*b1*f**2*fdd*s**2 - 28*D1**2*b1*f**2*fdd*s + 14*D1**2*b1*f**2*fdd + 42*D1**2*b1*f*fd**2*r**2 + 84*D1**2*b1*f*fd**2*r*s - 56*D1**2*b1*f*fd**2*r + 42*D1**2*b1*f*fd**2*s**2 - 56*D1**2*b1*f*fd**2*s + 14*D1**2*b1*f*fd**2 - 36*D1**2*b1*f*fd*r**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + D1**2*bdd1*f**2*(7*f + 9)*(r + s - 1)**2 - 30*D1**2*f**2*fd*r**2 - 60*D1**2*f**2*fd*r*s + 40*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 40*D1**2*f**2*fd*s - 20*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 - 56*D1*Dd*b1*f**3*r**2 - 112*D1*Dd*b1*f**3*r*s + 84*D1*Dd*b1*f**3*r - 56*D1*Dd*b1*f**3*s**2 + 84*D1*Dd*b1*f**3*s - 42*D1*Dd*b1*f**3 + 168*D1*Dd*b1*f**2*fd*r**2 + 336*D1*Dd*b1*f**2*fd*r*s - 238*D1*Dd*b1*f**2*fd*r + 168*D1*Dd*b1*f**2*fd*s**2 - 238*D1*Dd*b1*f**2*fd*s + 84*D1*Dd*b1*f**2*fd - 72*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 108*D1*Dd*b1*f**2*s - 54*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 40*D1*Dd*f**3*r**2 - 80*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 60*D1*Dd*f**3*s - 30*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 170*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 170*D1*Dd*f**2*fd*s + 60*D1*Dd*f**2*fd + 28*D1*Ddd*b1*f**3*r**2 + 56*D1*Ddd*b1*f**3*r*s - 42*D1*Ddd*b1*f**3*r + 28*D1*Ddd*b1*f**3*s**2 - 42*D1*Ddd*b1*f**3*s + 21*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) + 9*f*(r + s - 1) - 9*fd*(2*r + 2*s - 1)) - Dd*f*(7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 84*Dd**2*b1*f**3*r**2 + 168*Dd**2*b1*f**3*r*s - 126*Dd**2*b1*f**3*r + 84*Dd**2*b1*f**3*s**2 - 126*Dd**2*b1*f**3*s + 42*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 30*Dd**2*f**3)/(42*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**5*k1*k2**3*(-180*C*D1**2*bdd1*f**2*r**2 - 360*C*D1**2*bdd1*f**2*r*s - 180*C*D1**2*bdd1*f**2*s**2 - 1140*C*D1**2*f**2*fd*r**2 - 2280*C*D1**2*f**2*fd*r*s + 1520*C*D1**2*f**2*fd*r - 1140*C*D1**2*f**2*fd*s**2 + 1520*C*D1**2*f**2*fd*s - 760*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r**2 + 1680*C*D1**2*f**2*fdd*r*s - 1120*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 1120*C*D1**2*f**2*fdd*s + 560*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r**2 + 3360*C*D1**2*f*fd**2*r*s - 2240*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 2240*C*D1**2*f*fd**2*s + 560*C*D1**2*f*fd**2 - 1520*C*D1*Dd*f**3*r**2 - 3040*C*D1*Dd*f**3*r*s + 2280*C*D1*Dd*f**3*r - 1520*C*D1*Dd*f**3*s**2 + 2280*C*D1*Dd*f**3*s - 1140*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r**2 + 13440*C*D1*Dd*f**2*fd*r*s - 9520*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 9520*C*D1*Dd*f**2*fd*s + 3360*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r**2 + 2240*C*D1*Ddd*f**3*r*s - 1680*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1680*C*D1*Ddd*f**3*s + 840*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r**2 + 6720*C*Dd**2*f**3*r*s - 5040*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 5040*C*Dd**2*f**3*s + 1680*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r**2 + 360*D1**2*K*bdd1*f**2*r*s - 360*D1**2*K*bdd1*f**2*r + 180*D1**2*K*bdd1*f**2*s**2 - 360*D1**2*K*bdd1*f**2*s + 180*D1**2*K*bdd1*f**2 - 468*D1**2*b2*f*fd*r**2 - 936*D1**2*b2*f*fd*r*s + 468*D1**2*b2*f*fd*r - 468*D1**2*b2*f*fd*s**2 + 468*D1**2*b2*f*fd*s - 234*D1**2*b2*f*fd + 360*D1**2*b2*f*fdd*r**2 + 720*D1**2*b2*f*fdd*r*s - 360*D1**2*b2*f*fdd*r + 360*D1**2*b2*f*fdd*s**2 - 360*D1**2*b2*f*fdd*s + 180*D1**2*b2*f*fdd + 360*D1**2*b2*fd**2*r**2 + 720*D1**2*b2*fd**2*r*s - 360*D1**2*b2*fd**2*r + 360*D1**2*b2*fd**2*s**2 - 360*D1**2*b2*fd**2*s + 18*D1**2*bd1**2*f*(r + s - 1)*(-14*K*(r + s) + 5*f + 7) - 234*D1**2*bd2*f**2*r**2 - 468*D1**2*bd2*f**2*r*s + 468*D1**2*bd2*f**2*r - 234*D1**2*bd2*f**2*s**2 + 468*D1**2*bd2*f**2*s - 234*D1**2*bd2*f**2 + 720*D1**2*bd2*f*fd*r**2 + 1440*D1**2*bd2*f*fd*r*s - 1080*D1**2*bd2*f*fd*r + 720*D1**2*bd2*f*fd*s**2 - 1080*D1**2*bd2*f*fd*s + 360*D1**2*bd2*f*fd + 90*D1**2*bdd1*f**2*r**2 + 180*D1**2*bdd1*f**2*r*s + 90*D1**2*bdd1*f**2*r + 90*D1**2*bdd1*f**2*s**2 + 90*D1**2*bdd1*f**2*s - 45*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s + 252*D1**2*bdd1*f*g2*s**2 + 180*D1**2*bdd2*f**2*r**2 + 360*D1**2*bdd2*f**2*r*s - 360*D1**2*bdd2*f**2*r + 180*D1**2*bdd2*f**2*s**2 - 360*D1**2*bdd2*f**2*s + 180*D1**2*bdd2*f**2 + 435*D1**2*f**2*fd*r**2 + 870*D1**2*f**2*fd*r*s - 580*D1**2*f**2*fd*r + 435*D1**2*f**2*fd*s**2 - 580*D1**2*f**2*fd*s + 290*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd + 468*D1**2*f**2*gd2*r**2 + 936*D1**2*f**2*gd2*r*s - 936*D1**2*f**2*gd2*r + 468*D1**2*f**2*gd2*s**2 - 936*D1**2*f**2*gd2*s + 468*D1**2*f**2*gd2 - 360*D1**2*f**2*gdd2*r**2 - 720*D1**2*f**2*gdd2*r*s + 720*D1**2*f**2*gdd2*r - 360*D1**2*f**2*gdd2*s**2 + 720*D1**2*f**2*gdd2*s - 360*D1**2*f**2*gdd2 - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 936*D1**2*f*fd*g2*r**2 + 1872*D1**2*f*fd*g2*r*s - 936*D1**2*f*fd*g2*r + 936*D1**2*f*fd*g2*s**2 - 936*D1**2*f*fd*g2*s + 468*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r**2 - 2880*D1**2*f*fd*gd2*r*s + 2160*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 2160*D1**2*f*fd*gd2*s - 720*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r**2 - 1440*D1**2*f*fdd*g2*r*s + 720*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r**2 - 1440*D1**2*fd**2*g2*r*s + 720*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s - 936*D1*Dd*b2*f**2*r**2 - 1872*D1*Dd*b2*f**2*r*s + 1404*D1*Dd*b2*f**2*r - 936*D1*Dd*b2*f**2*s**2 + 1404*D1*Dd*b2*f**2*s - 702*D1*Dd*b2*f**2 + 2880*D1*Dd*b2*f*fd*r**2 + 5760*D1*Dd*b2*f*fd*r*s - 3600*D1*Dd*b2*f*fd*r + 2880*D1*Dd*b2*f*fd*s**2 - 3600*D1*Dd*b2*f*fd*s + 1080*D1*Dd*b2*f*fd + 1440*D1*Dd*bd2*f**2*r**2 + 2880*D1*Dd*bd2*f**2*r*s - 2520*D1*Dd*bd2*f**2*r + 1440*D1*Dd*bd2*f**2*s**2 - 2520*D1*Dd*bd2*f**2*s + 1080*D1*Dd*bd2*f**2 + 580*D1*Dd*f**3*r**2 + 1160*D1*Dd*f**3*r*s - 870*D1*Dd*f**3*r + 580*D1*Dd*f**3*s**2 - 870*D1*Dd*f**3*s + 435*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd + 1872*D1*Dd*f**2*g2*r**2 + 3744*D1*Dd*f**2*g2*r*s - 2808*D1*Dd*f**2*g2*r + 1872*D1*Dd*f**2*g2*s**2 - 2808*D1*Dd*f**2*g2*s + 1404*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r**2 - 5760*D1*Dd*f**2*gd2*r*s + 5040*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 5040*D1*Dd*f**2*gd2*s - 2160*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r**2 - 11520*D1*Dd*f*fd*g2*r*s + 7200*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 7200*D1*Dd*f*fd*g2*s - 2160*D1*Dd*f*fd*g2 + 720*D1*Ddd*b2*f**2*r**2 + 1440*D1*Ddd*b2*f**2*r*s - 1080*D1*Ddd*b2*f**2*r + 720*D1*Ddd*b2*f**2*s**2 - 1080*D1*Ddd*b2*f**2*s + 540*D1*Ddd*b2*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r**2 - 2880*D1*Ddd*f**2*g2*r*s + 2160*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 2160*D1*Ddd*f**2*g2*s - 1080*D1*Ddd*f**2*g2 - 9*D1*bd1*(D1*(5*f**3*(r + s - 1)**2 + f**2*(-40*C*s**2 + 26*K*(r + s - 1)**2 + r**2*(27 - 40*C) + r*(-80*C*s + 54*s + 6) + 27*s**2 + 6*s - 3) - 2*f*(5*fd*(r + s - 1)*(-8*C*s + K*(8*r + 8*s - 4) + r*(4 - 8*C) + 4*s + 1) + (28*r + 28*s)*(-g2*(r + s) + gd2*(r + s - 1))) - 56*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(5*f*(-4*C*r - 4*C*s + 4*K*(r + s - 1) + 2*r + 2*s + 1) + 28*g2*(r + s))*(4*r + 4*s - 3)) + 2160*Dd**2*b2*f**2*r**2 + 4320*Dd**2*b2*f**2*r*s - 3240*Dd**2*b2*f**2*r + 2160*Dd**2*b2*f**2*s**2 - 3240*Dd**2*b2*f**2*s + 1080*Dd**2*b2*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r**2 - 8640*Dd**2*f**2*g2*r*s + 6480*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 6480*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 - 9*b1**2*(D1**2*(10*fd**2*(r + s - 1) - 2*fd*(14*K*(r + s - 1)**2 + 5*f*(2*r + 2*s - 1) + 14*r + 14*s - 7) + fdd*(14*K*(r + s - 1)**2 + 5*f*(2*r + 2*s - 1) + 14*r + 14*s - 7)) + 2*D1*(Dd*(-14*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(4*r + 4*s - 3)*(14*K*(r + s - 1) + 5*f + 7)) + 7*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 84*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(-80*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s + 160*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 160*C*D1**2*f*fd*s - 80*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 80*C*D1**2*f*fdd*s + 40*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 80*C*D1**2*fd**2*s + 40*C*D1**2*fd**2 - 160*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 240*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 240*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 560*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 560*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 + 52*D1**2*K*f*fd*r**2 + 104*D1**2*K*f*fd*r*s - 52*D1**2*K*f*fd*r + 52*D1**2*K*f*fd*s**2 - 52*D1**2*K*f*fd*s + 26*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r**2 - 80*D1**2*K*f*fdd*r*s + 40*D1**2*K*f*fdd*r - 40*D1**2*K*f*fdd*s**2 + 40*D1**2*K*f*fdd*s - 20*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r**2 - 80*D1**2*K*fd**2*r*s + 40*D1**2*K*fd**2*r - 40*D1**2*K*fd**2*s**2 + 40*D1**2*K*fd**2*s + D1**2*bdd1*f*(7*K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 5*f*(2*r + 2*s - 1) - 14*r - 14*s + 7) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 54*D1**2*f*fd*r**2 + 108*D1**2*f*fd*r*s - 114*D1**2*f*fd*r + 54*D1**2*f*fd*s**2 - 114*D1**2*f*fd*s + 57*D1**2*f*fd - 20*D1**2*f*fdd*r**2 - 40*D1**2*f*fdd*r*s + 50*D1**2*f*fdd*r - 20*D1**2*f*fdd*s**2 + 50*D1**2*f*fdd*s - 25*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 20*D1**2*fd**2*r**2 - 40*D1**2*fd**2*r*s + 50*D1**2*fd**2*r - 20*D1**2*fd**2*s**2 + 50*D1**2*fd**2*s - 30*D1**2*fd**2 + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s - 112*D1**2*fd*g2*r + 56*D1**2*fd*g2*s**2 - 112*D1**2*fd*g2*s + 56*D1**2*fd*g2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 112*D1**2*fd*gd2*s - 56*D1**2*fd*gd2 - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s + 56*D1**2*fdd*g2*r - 28*D1**2*fdd*g2*s**2 + 56*D1**2*fdd*g2*s - 28*D1**2*fdd*g2 + 104*D1*Dd*K*f**2*r**2 + 208*D1*Dd*K*f**2*r*s - 156*D1*Dd*K*f**2*r + 104*D1*Dd*K*f**2*s**2 - 156*D1*Dd*K*f**2*s + 78*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r**2 - 640*D1*Dd*K*f*fd*r*s + 400*D1*Dd*K*f*fd*r - 320*D1*Dd*K*f*fd*s**2 + 400*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 108*D1*Dd*f**2*r**2 + 216*D1*Dd*f**2*r*s - 162*D1*Dd*f**2*r + 108*D1*Dd*f**2*s**2 - 162*D1*Dd*f**2*s + 81*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 - 320*D1*Dd*f*fd*r*s + 320*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 320*D1*Dd*f*fd*s - 150*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 392*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 392*D1*Dd*fd*g2*s - 168*D1*Dd*fd*g2 - 80*D1*Ddd*K*f**2*r**2 - 160*D1*Ddd*K*f**2*r*s + 120*D1*Ddd*K*f**2*r - 80*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 - 40*D1*Ddd*f**2*r**2 - 80*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*f**2*(2*r + 2*s - 1) - 7*f*(K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 2*r - 2*s + 1) + 7*fd*(K*(4*r + 4*s - 2) + 1)*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(7*K*(4*r + 4*s - 2) - 5*f - 7)) - 240*Dd**2*K*f**2*r**2 - 480*Dd**2*K*f**2*r*s + 360*Dd**2*K*f**2*r - 240*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 - 120*Dd**2*f**2*r**2 - 240*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 60*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(630*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**5*k1*k2*(D1*f*(r + s)*(2*D1*bd1**2*(5*f + 7)*(r + s - 1) + 5*D1*bdd1*f*(r + s) + 10*bd1*(-D1*f*(r + s) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(10*fd**2 + fd*(-20*f - 14) + fdd*(10*f + 7))*(r + s - 1)**2 + D1*(-2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-10*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) - 7*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*bdd1*f*(5*f + 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*D1**2*(r + s - 1)**2*(2*f*fd - f*fdd - fd**2) - 2*D1*bd1*(D1*(5*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(-10*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 14*r**2 + 28*r*s - 14*r + 14*s**2 - 14*s + 7) - 7*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - Dd*f*(5*f + 7)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k3**2) - D1**2*Pk2*Pkdd3*ct**4*k1**6*(1650*C*D1**2*f**2*fd*r**2 + 3300*C*D1**2*f**2*fd*r*s - 2200*C*D1**2*f**2*fd*r + 1650*C*D1**2*f**2*fd*s**2 - 2200*C*D1**2*f**2*fd*s + 1100*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r**2 - 4620*C*D1**2*f**2*fdd*r*s + 3080*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 3080*C*D1**2*f**2*fdd*s - 1540*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r**2 - 9240*C*D1**2*f*fd**2*r*s + 6160*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 6160*C*D1**2*f*fd**2*s - 1540*C*D1**2*f*fd**2 + 2200*C*D1*Dd*f**3*r**2 + 4400*C*D1*Dd*f**3*r*s - 3300*C*D1*Dd*f**3*r + 2200*C*D1*Dd*f**3*s**2 - 3300*C*D1*Dd*f**3*s + 1650*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r**2 - 36960*C*D1*Dd*f**2*fd*r*s + 26180*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 26180*C*D1*Dd*f**2*fd*s - 9240*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r**2 - 6160*C*D1*Ddd*f**3*r*s + 4620*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 4620*C*D1*Ddd*f**3*s - 2310*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r**2 - 18480*C*Dd**2*f**3*r*s + 13860*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 13860*C*Dd**2*f**3*s - 4620*C*Dd**2*f**3 + 594*D1**2*K*b1*f*fd*r**2 + 1188*D1**2*K*b1*f*fd*r*s - 594*D1**2*K*b1*f*fd*r + 594*D1**2*K*b1*f*fd*s**2 - 594*D1**2*K*b1*f*fd*s + 297*D1**2*K*b1*f*fd - 990*D1**2*K*b1*f*fdd*r**2 - 1980*D1**2*K*b1*f*fdd*r*s + 990*D1**2*K*b1*f*fdd*r - 990*D1**2*K*b1*f*fdd*s**2 + 990*D1**2*K*b1*f*fdd*s - 495*D1**2*K*b1*f*fdd - 990*D1**2*K*b1*fd**2*r**2 - 1980*D1**2*K*b1*fd**2*r*s + 990*D1**2*K*b1*fd**2*r - 990*D1**2*K*b1*fd**2*s**2 + 990*D1**2*K*b1*fd**2*s - 594*D1**2*b1*f*fd*r**2 - 1188*D1**2*b1*f*fd*r*s + 594*D1**2*b1*f*fd*r - 594*D1**2*b1*f*fd*s**2 + 594*D1**2*b1*f*fd*s - 297*D1**2*b1*f*fd + 990*D1**2*b1*f*fdd*r**2 + 1980*D1**2*b1*f*fdd*r*s - 990*D1**2*b1*f*fdd*r + 990*D1**2*b1*f*fdd*s**2 - 990*D1**2*b1*f*fdd*s + 495*D1**2*b1*f*fdd + 990*D1**2*b1*fd**2*r**2 + 1980*D1**2*b1*fd**2*r*s - 990*D1**2*b1*fd**2*r + 990*D1**2*b1*fd**2*s**2 - 990*D1**2*b1*fd**2*s - 495*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 4900*D1**2*f**3*fd*r**2 + 9800*D1**2*f**3*fd*r*s - 7350*D1**2*f**3*fd*r + 4900*D1**2*f**3*fd*s**2 - 7350*D1**2*f**3*fd*s + 3675*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 1650*D1**2*f**2*fd*r**2 - 3300*D1**2*f**2*fd*r*s + 2200*D1**2*f**2*fd*r - 1650*D1**2*f**2*fd*s**2 + 2200*D1**2*f**2*fd*s - 1100*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r**2 + 4620*D1**2*f**2*fdd*r*s - 3080*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 3080*D1**2*f**2*fdd*s + 1540*D1**2*f**2*fdd - 594*D1**2*f**2*gd2*r**2 - 1188*D1**2*f**2*gd2*r*s + 1188*D1**2*f**2*gd2*r - 594*D1**2*f**2*gd2*s**2 + 1188*D1**2*f**2*gd2*s - 594*D1**2*f**2*gd2 + 990*D1**2*f**2*gdd2*r**2 + 1980*D1**2*f**2*gdd2*r*s - 1980*D1**2*f**2*gdd2*r + 990*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 990*D1**2*f**2*gdd2 + 4620*D1**2*f*fd**2*r**2 + 9240*D1**2*f*fd**2*r*s - 6160*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 6160*D1**2*f*fd**2*s + 1540*D1**2*f*fd**2 - 1188*D1**2*f*fd*g2*r**2 - 2376*D1**2*f*fd*g2*r*s + 1188*D1**2*f*fd*g2*r - 1188*D1**2*f*fd*g2*s**2 + 1188*D1**2*f*fd*g2*s - 594*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r**2 + 7920*D1**2*f*fd*gd2*r*s - 5940*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 5940*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r**2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r**2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 1188*D1*Dd*K*b1*f**2*r**2 + 2376*D1*Dd*K*b1*f**2*r*s - 1782*D1*Dd*K*b1*f**2*r + 1188*D1*Dd*K*b1*f**2*s**2 - 1782*D1*Dd*K*b1*f**2*s + 891*D1*Dd*K*b1*f**2 - 7920*D1*Dd*K*b1*f*fd*r**2 - 15840*D1*Dd*K*b1*f*fd*r*s + 9900*D1*Dd*K*b1*f*fd*r - 7920*D1*Dd*K*b1*f*fd*s**2 + 9900*D1*Dd*K*b1*f*fd*s - 2970*D1*Dd*K*b1*f*fd - 1188*D1*Dd*b1*f**2*r**2 - 2376*D1*Dd*b1*f**2*r*s + 1782*D1*Dd*b1*f**2*r - 1188*D1*Dd*b1*f**2*s**2 + 1782*D1*Dd*b1*f**2*s - 891*D1*Dd*b1*f**2 + 7920*D1*Dd*b1*f*fd*r**2 + 15840*D1*Dd*b1*f*fd*r*s - 9900*D1*Dd*b1*f*fd*r + 7920*D1*Dd*b1*f*fd*s**2 - 9900*D1*Dd*b1*f*fd*s + 2970*D1*Dd*b1*f*fd + 4900*D1*Dd*f**4*r**2 + 9800*D1*Dd*f**4*r*s - 7350*D1*Dd*f**4*r + 4900*D1*Dd*f**4*s**2 - 7350*D1*Dd*f**4*s + 3675*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 2200*D1*Dd*f**3*r**2 - 4400*D1*Dd*f**3*r*s + 3300*D1*Dd*f**3*r - 2200*D1*Dd*f**3*s**2 + 3300*D1*Dd*f**3*s - 1650*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r**2 + 36960*D1*Dd*f**2*fd*r*s - 26180*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 26180*D1*Dd*f**2*fd*s + 9240*D1*Dd*f**2*fd - 2376*D1*Dd*f**2*g2*r**2 - 4752*D1*Dd*f**2*g2*r*s + 3564*D1*Dd*f**2*g2*r - 2376*D1*Dd*f**2*g2*s**2 + 3564*D1*Dd*f**2*g2*s - 1782*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r**2 + 15840*D1*Dd*f**2*gd2*r*s - 13860*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 13860*D1*Dd*f**2*gd2*s + 5940*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r**2 + 31680*D1*Dd*f*fd*g2*r*s - 19800*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 19800*D1*Dd*f*fd*g2*s + 5940*D1*Dd*f*fd*g2 - 1980*D1*Ddd*K*b1*f**2*r**2 - 3960*D1*Ddd*K*b1*f**2*r*s + 2970*D1*Ddd*K*b1*f**2*r - 1980*D1*Ddd*K*b1*f**2*s**2 + 2970*D1*Ddd*K*b1*f**2*s - 1485*D1*Ddd*K*b1*f**2 + 1980*D1*Ddd*b1*f**2*r**2 + 3960*D1*Ddd*b1*f**2*r*s - 2970*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s**2 - 2970*D1*Ddd*b1*f**2*s + 1485*D1*Ddd*b1*f**2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r**2 + 6160*D1*Ddd*f**3*r*s - 4620*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 4620*D1*Ddd*f**3*s + 2310*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r**2 + 7920*D1*Ddd*f**2*g2*r*s - 5940*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 5940*D1*Ddd*f**2*g2*s + 2970*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 5940*Dd**2*K*b1*f**2*r**2 - 11880*Dd**2*K*b1*f**2*r*s + 8910*Dd**2*K*b1*f**2*r - 5940*Dd**2*K*b1*f**2*s**2 + 8910*Dd**2*K*b1*f**2*s - 2970*Dd**2*K*b1*f**2 + 5940*Dd**2*b1*f**2*r**2 + 11880*Dd**2*b1*f**2*r*s - 8910*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s**2 - 8910*Dd**2*b1*f**2*s + 2970*Dd**2*b1*f**2 - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 9240*Dd**2*f**3*r**2 + 18480*Dd**2*f**3*r*s - 13860*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 13860*Dd**2*f**3*s + 4620*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r**2 + 23760*Dd**2*f**2*g2*r*s - 17820*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 17820*Dd**2*f**2*g2*s + 5940*Dd**2*f**2*g2)/(6930*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**4*k1**4*k2**2*st**2*(4356*C*D1**2*f**2*fd*r**2 + 8712*C*D1**2*f**2*fd*r*s - 5808*C*D1**2*f**2*fd*r + 4356*C*D1**2*f**2*fd*s**2 - 5808*C*D1**2*f**2*fd*s + 2904*C*D1**2*f**2*fd - 3960*C*D1**2*f**2*fdd*r**2 - 7920*C*D1**2*f**2*fdd*r*s + 5280*C*D1**2*f**2*fdd*r - 3960*C*D1**2*f**2*fdd*s**2 + 5280*C*D1**2*f**2*fdd*s - 2640*C*D1**2*f**2*fdd - 7920*C*D1**2*f*fd**2*r**2 - 15840*C*D1**2*f*fd**2*r*s + 10560*C*D1**2*f*fd**2*r - 7920*C*D1**2*f*fd**2*s**2 + 10560*C*D1**2*f*fd**2*s - 2640*C*D1**2*f*fd**2 + 5808*C*D1*Dd*f**3*r**2 + 11616*C*D1*Dd*f**3*r*s - 8712*C*D1*Dd*f**3*r + 5808*C*D1*Dd*f**3*s**2 - 8712*C*D1*Dd*f**3*s + 4356*C*D1*Dd*f**3 - 31680*C*D1*Dd*f**2*fd*r**2 - 63360*C*D1*Dd*f**2*fd*r*s + 44880*C*D1*Dd*f**2*fd*r - 31680*C*D1*Dd*f**2*fd*s**2 + 44880*C*D1*Dd*f**2*fd*s - 15840*C*D1*Dd*f**2*fd - 5280*C*D1*Ddd*f**3*r**2 - 10560*C*D1*Ddd*f**3*r*s + 7920*C*D1*Ddd*f**3*r - 5280*C*D1*Ddd*f**3*s**2 + 7920*C*D1*Ddd*f**3*s - 3960*C*D1*Ddd*f**3 - 15840*C*Dd**2*f**3*r**2 - 31680*C*Dd**2*f**3*r*s + 23760*C*Dd**2*f**3*r - 15840*C*Dd**2*f**3*s**2 + 23760*C*Dd**2*f**3*s - 7920*C*Dd**2*f**3 + 1980*D1**2*K*b1*f*fd*r**2 + 3960*D1**2*K*b1*f*fd*r*s - 1980*D1**2*K*b1*f*fd*r + 1980*D1**2*K*b1*f*fd*s**2 - 1980*D1**2*K*b1*f*fd*s + 990*D1**2*K*b1*f*fd - 2376*D1**2*K*b1*f*fdd*r**2 - 4752*D1**2*K*b1*f*fdd*r*s + 2376*D1**2*K*b1*f*fdd*r - 2376*D1**2*K*b1*f*fdd*s**2 + 2376*D1**2*K*b1*f*fdd*s - 1188*D1**2*K*b1*f*fdd - 2376*D1**2*K*b1*fd**2*r**2 - 4752*D1**2*K*b1*fd**2*r*s + 2376*D1**2*K*b1*fd**2*r - 2376*D1**2*K*b1*fd**2*s**2 + 2376*D1**2*K*b1*fd**2*s - 1980*D1**2*b1*f*fd*r**2 - 3960*D1**2*b1*f*fd*r*s + 1980*D1**2*b1*f*fd*r - 1980*D1**2*b1*f*fd*s**2 + 1980*D1**2*b1*f*fd*s - 990*D1**2*b1*f*fd + 2376*D1**2*b1*f*fdd*r**2 + 4752*D1**2*b1*f*fdd*r*s - 2376*D1**2*b1*f*fdd*r + 2376*D1**2*b1*f*fdd*s**2 - 2376*D1**2*b1*f*fdd*s + 1188*D1**2*b1*f*fdd + 2376*D1**2*b1*fd**2*r**2 + 4752*D1**2*b1*fd**2*r*s - 2376*D1**2*b1*fd**2*r + 2376*D1**2*b1*fd**2*s**2 - 2376*D1**2*b1*fd**2*s - 1188*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 8500*D1**2*f**3*fd*r**2 + 17000*D1**2*f**3*fd*r*s - 12750*D1**2*f**3*fd*r + 8500*D1**2*f**3*fd*s**2 - 12750*D1**2*f**3*fd*s + 6375*D1**2*f**3*fd - 7000*D1**2*f**3*fdd*r**2 - 14000*D1**2*f**3*fdd*r*s + 10500*D1**2*f**3*fdd*r - 7000*D1**2*f**3*fdd*s**2 + 10500*D1**2*f**3*fdd*s - 5250*D1**2*f**3*fdd - 21000*D1**2*f**2*fd**2*r**2 - 42000*D1**2*f**2*fd**2*r*s + 31500*D1**2*f**2*fd**2*r - 21000*D1**2*f**2*fd**2*s**2 + 31500*D1**2*f**2*fd**2*s - 10500*D1**2*f**2*fd**2 - 4356*D1**2*f**2*fd*r**2 - 8712*D1**2*f**2*fd*r*s + 5808*D1**2*f**2*fd*r - 4356*D1**2*f**2*fd*s**2 + 5808*D1**2*f**2*fd*s - 2904*D1**2*f**2*fd + 3960*D1**2*f**2*fdd*r**2 + 7920*D1**2*f**2*fdd*r*s - 5280*D1**2*f**2*fdd*r + 3960*D1**2*f**2*fdd*s**2 - 5280*D1**2*f**2*fdd*s + 2640*D1**2*f**2*fdd - 1980*D1**2*f**2*gd2*r**2 - 3960*D1**2*f**2*gd2*r*s + 3960*D1**2*f**2*gd2*r - 1980*D1**2*f**2*gd2*s**2 + 3960*D1**2*f**2*gd2*s - 1980*D1**2*f**2*gd2 + 2376*D1**2*f**2*gdd2*r**2 + 4752*D1**2*f**2*gdd2*r*s - 4752*D1**2*f**2*gdd2*r + 2376*D1**2*f**2*gdd2*s**2 - 4752*D1**2*f**2*gdd2*s + 2376*D1**2*f**2*gdd2 + 7920*D1**2*f*fd**2*r**2 + 15840*D1**2*f*fd**2*r*s - 10560*D1**2*f*fd**2*r + 7920*D1**2*f*fd**2*s**2 - 10560*D1**2*f*fd**2*s + 2640*D1**2*f*fd**2 - 3960*D1**2*f*fd*g2*r**2 - 7920*D1**2*f*fd*g2*r*s + 3960*D1**2*f*fd*g2*r - 3960*D1**2*f*fd*g2*s**2 + 3960*D1**2*f*fd*g2*s - 1980*D1**2*f*fd*g2 + 9504*D1**2*f*fd*gd2*r**2 + 19008*D1**2*f*fd*gd2*r*s - 14256*D1**2*f*fd*gd2*r + 9504*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4752*D1**2*f*fd*gd2 + 4752*D1**2*f*fdd*g2*r**2 + 9504*D1**2*f*fdd*g2*r*s - 4752*D1**2*f*fdd*g2*r + 4752*D1**2*f*fdd*g2*s**2 - 4752*D1**2*f*fdd*g2*s + 2376*D1**2*f*fdd*g2 + 4752*D1**2*fd**2*g2*r**2 + 9504*D1**2*fd**2*g2*r*s - 4752*D1**2*fd**2*g2*r + 4752*D1**2*fd**2*g2*s**2 - 4752*D1**2*fd**2*g2*s + 3960*D1*Dd*K*b1*f**2*r**2 + 7920*D1*Dd*K*b1*f**2*r*s - 5940*D1*Dd*K*b1*f**2*r + 3960*D1*Dd*K*b1*f**2*s**2 - 5940*D1*Dd*K*b1*f**2*s + 2970*D1*Dd*K*b1*f**2 - 19008*D1*Dd*K*b1*f*fd*r**2 - 38016*D1*Dd*K*b1*f*fd*r*s + 23760*D1*Dd*K*b1*f*fd*r - 19008*D1*Dd*K*b1*f*fd*s**2 + 23760*D1*Dd*K*b1*f*fd*s - 7128*D1*Dd*K*b1*f*fd - 3960*D1*Dd*b1*f**2*r**2 - 7920*D1*Dd*b1*f**2*r*s + 5940*D1*Dd*b1*f**2*r - 3960*D1*Dd*b1*f**2*s**2 + 5940*D1*Dd*b1*f**2*s - 2970*D1*Dd*b1*f**2 + 19008*D1*Dd*b1*f*fd*r**2 + 38016*D1*Dd*b1*f*fd*r*s - 23760*D1*Dd*b1*f*fd*r + 19008*D1*Dd*b1*f*fd*s**2 - 23760*D1*Dd*b1*f*fd*s + 7128*D1*Dd*b1*f*fd + 8500*D1*Dd*f**4*r**2 + 17000*D1*Dd*f**4*r*s - 12750*D1*Dd*f**4*r + 8500*D1*Dd*f**4*s**2 - 12750*D1*Dd*f**4*s + 6375*D1*Dd*f**4 - 56000*D1*Dd*f**3*fd*r**2 - 112000*D1*Dd*f**3*fd*r*s + 84000*D1*Dd*f**3*fd*r - 56000*D1*Dd*f**3*fd*s**2 + 84000*D1*Dd*f**3*fd*s - 31500*D1*Dd*f**3*fd - 5808*D1*Dd*f**3*r**2 - 11616*D1*Dd*f**3*r*s + 8712*D1*Dd*f**3*r - 5808*D1*Dd*f**3*s**2 + 8712*D1*Dd*f**3*s - 4356*D1*Dd*f**3 + 31680*D1*Dd*f**2*fd*r**2 + 63360*D1*Dd*f**2*fd*r*s - 44880*D1*Dd*f**2*fd*r + 31680*D1*Dd*f**2*fd*s**2 - 44880*D1*Dd*f**2*fd*s + 15840*D1*Dd*f**2*fd - 7920*D1*Dd*f**2*g2*r**2 - 15840*D1*Dd*f**2*g2*r*s + 11880*D1*Dd*f**2*g2*r - 7920*D1*Dd*f**2*g2*s**2 + 11880*D1*Dd*f**2*g2*s - 5940*D1*Dd*f**2*g2 + 19008*D1*Dd*f**2*gd2*r**2 + 38016*D1*Dd*f**2*gd2*r*s - 33264*D1*Dd*f**2*gd2*r + 19008*D1*Dd*f**2*gd2*s**2 - 33264*D1*Dd*f**2*gd2*s + 14256*D1*Dd*f**2*gd2 + 38016*D1*Dd*f*fd*g2*r**2 + 76032*D1*Dd*f*fd*g2*r*s - 47520*D1*Dd*f*fd*g2*r + 38016*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 - 4752*D1*Ddd*K*b1*f**2*r**2 - 9504*D1*Ddd*K*b1*f**2*r*s + 7128*D1*Ddd*K*b1*f**2*r - 4752*D1*Ddd*K*b1*f**2*s**2 + 7128*D1*Ddd*K*b1*f**2*s - 3564*D1*Ddd*K*b1*f**2 + 4752*D1*Ddd*b1*f**2*r**2 + 9504*D1*Ddd*b1*f**2*r*s - 7128*D1*Ddd*b1*f**2*r + 4752*D1*Ddd*b1*f**2*s**2 - 7128*D1*Ddd*b1*f**2*s + 3564*D1*Ddd*b1*f**2 - 7000*D1*Ddd*f**4*r**2 - 14000*D1*Ddd*f**4*r*s + 10500*D1*Ddd*f**4*r - 7000*D1*Ddd*f**4*s**2 + 10500*D1*Ddd*f**4*s - 5250*D1*Ddd*f**4 + 5280*D1*Ddd*f**3*r**2 + 10560*D1*Ddd*f**3*r*s - 7920*D1*Ddd*f**3*r + 5280*D1*Ddd*f**3*s**2 - 7920*D1*Ddd*f**3*s + 3960*D1*Ddd*f**3 + 9504*D1*Ddd*f**2*g2*r**2 + 19008*D1*Ddd*f**2*g2*r*s - 14256*D1*Ddd*f**2*g2*r + 9504*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 7128*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 14256*Dd**2*K*b1*f**2*r**2 - 28512*Dd**2*K*b1*f**2*r*s + 21384*Dd**2*K*b1*f**2*r - 14256*Dd**2*K*b1*f**2*s**2 + 21384*Dd**2*K*b1*f**2*s - 7128*Dd**2*K*b1*f**2 + 14256*Dd**2*b1*f**2*r**2 + 28512*Dd**2*b1*f**2*r*s - 21384*Dd**2*b1*f**2*r + 14256*Dd**2*b1*f**2*s**2 - 21384*Dd**2*b1*f**2*s + 7128*Dd**2*b1*f**2 - 21000*Dd**2*f**4*r**2 - 42000*Dd**2*f**4*r*s + 31500*Dd**2*f**4*r - 21000*Dd**2*f**4*s**2 + 31500*Dd**2*f**4*s - 10500*Dd**2*f**4 + 15840*Dd**2*f**3*r**2 + 31680*Dd**2*f**3*r*s - 23760*Dd**2*f**3*r + 15840*Dd**2*f**3*s**2 - 23760*Dd**2*f**3*s + 7920*Dd**2*f**3 + 28512*Dd**2*f**2*g2*r**2 + 57024*Dd**2*f**2*g2*r*s - 42768*Dd**2*f**2*g2*r + 28512*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 14256*Dd**2*f**2*g2)/(2310*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**4*k1**4*k2**2*(-540*C*D1**2*bdd1*f**2*r**2 - 1080*C*D1**2*bdd1*f**2*r*s + 1080*C*D1**2*bdd1*f**2*r - 540*C*D1**2*bdd1*f**2*s**2 + 1080*C*D1**2*bdd1*f**2*s - 540*C*D1**2*bdd1*f**2 + 930*C*D1**2*f**2*fd*r**2 + 1860*C*D1**2*f**2*fd*r*s - 1240*C*D1**2*f**2*fd*r + 930*C*D1**2*f**2*fd*s**2 - 1240*C*D1**2*f**2*fd*s + 620*C*D1**2*f**2*fd - 1680*C*D1**2*f**2*fdd*r**2 - 3360*C*D1**2*f**2*fdd*r*s + 2240*C*D1**2*f**2*fdd*r - 1680*C*D1**2*f**2*fdd*s**2 + 2240*C*D1**2*f**2*fdd*s - 1120*C*D1**2*f**2*fdd - 3360*C*D1**2*f*fd**2*r**2 - 6720*C*D1**2*f*fd**2*r*s + 4480*C*D1**2*f*fd**2*r - 3360*C*D1**2*f*fd**2*s**2 + 4480*C*D1**2*f*fd**2*s - 1120*C*D1**2*f*fd**2 + 1240*C*D1*Dd*f**3*r**2 + 2480*C*D1*Dd*f**3*r*s - 1860*C*D1*Dd*f**3*r + 1240*C*D1*Dd*f**3*s**2 - 1860*C*D1*Dd*f**3*s + 930*C*D1*Dd*f**3 - 13440*C*D1*Dd*f**2*fd*r**2 - 26880*C*D1*Dd*f**2*fd*r*s + 19040*C*D1*Dd*f**2*fd*r - 13440*C*D1*Dd*f**2*fd*s**2 + 19040*C*D1*Dd*f**2*fd*s - 6720*C*D1*Dd*f**2*fd - 2240*C*D1*Ddd*f**3*r**2 - 4480*C*D1*Ddd*f**3*r*s + 3360*C*D1*Ddd*f**3*r - 2240*C*D1*Ddd*f**3*s**2 + 3360*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 6720*C*Dd**2*f**3*r**2 - 13440*C*Dd**2*f**3*r*s + 10080*C*Dd**2*f**3*r - 6720*C*Dd**2*f**3*s**2 + 10080*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 360*D1**2*K*bdd1*f**2*r**2 - 720*D1**2*K*bdd1*f**2*r*s + 720*D1**2*K*bdd1*f**2*r - 360*D1**2*K*bdd1*f**2*s**2 + 720*D1**2*K*bdd1*f**2*s - 360*D1**2*K*bdd1*f**2 - 756*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 720*D1**2*bdd1*f**2*r**2 + 1440*D1**2*bdd1*f**2*r*s - 1440*D1**2*bdd1*f**2*r + 720*D1**2*bdd1*f**2*s**2 - 1440*D1**2*bdd1*f**2*s + 720*D1**2*bdd1*f**2 + 756*D1**2*bdd1*f*g2*r**2 + 1512*D1**2*bdd1*f*g2*r*s - 1512*D1**2*bdd1*f*g2*r + 756*D1**2*bdd1*f*g2*s**2 - 1512*D1**2*bdd1*f*g2*s + 756*D1**2*bdd1*f*g2 - 420*D1**2*f**3*fd*r**2 - 840*D1**2*f**3*fd*r*s + 630*D1**2*f**3*fd*r - 420*D1**2*f**3*fd*s**2 + 630*D1**2*f**3*fd*s - 315*D1**2*f**3*fd - 630*D1**2*f**2*fd*r**2 - 1260*D1**2*f**2*fd*r*s + 840*D1**2*f**2*fd*r - 630*D1**2*f**2*fd*s**2 + 840*D1**2*f**2*fd*s - 420*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 2520*D1**2*f**2*fdd*r*s - 1680*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1680*D1**2*f**2*fdd*s + 840*D1**2*f**2*fdd - 306*D1**2*f**2*gd2*r**2 - 612*D1**2*f**2*gd2*r*s + 612*D1**2*f**2*gd2*r - 306*D1**2*f**2*gd2*s**2 + 612*D1**2*f**2*gd2*s - 306*D1**2*f**2*gd2 + 720*D1**2*f**2*gdd2*r**2 + 1440*D1**2*f**2*gdd2*r*s - 1440*D1**2*f**2*gdd2*r + 720*D1**2*f**2*gdd2*s**2 - 1440*D1**2*f**2*gdd2*s + 720*D1**2*f**2*gdd2 + 2520*D1**2*f*fd**2*r**2 + 5040*D1**2*f*fd**2*r*s - 3360*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 3360*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 612*D1**2*f*fd*g2*r**2 - 1224*D1**2*f*fd*g2*r*s + 612*D1**2*f*fd*g2*r - 612*D1**2*f*fd*g2*s**2 + 612*D1**2*f*fd*g2*s - 306*D1**2*f*fd*g2 + 2880*D1**2*f*fd*gd2*r**2 + 5760*D1**2*f*fd*gd2*r*s - 4320*D1**2*f*fd*gd2*r + 2880*D1**2*f*fd*gd2*s**2 - 4320*D1**2*f*fd*gd2*s + 1440*D1**2*f*fd*gd2 + 1440*D1**2*f*fdd*g2*r**2 + 2880*D1**2*f*fdd*g2*r*s - 1440*D1**2*f*fdd*g2*r + 1440*D1**2*f*fdd*g2*s**2 - 1440*D1**2*f*fdd*g2*s + 720*D1**2*f*fdd*g2 + 1440*D1**2*fd**2*g2*r**2 + 2880*D1**2*fd**2*g2*r*s - 1440*D1**2*fd**2*g2*r + 1440*D1**2*fd**2*g2*s**2 - 1440*D1**2*fd**2*g2*s - 420*D1*Dd*f**4*r**2 - 840*D1*Dd*f**4*r*s + 630*D1*Dd*f**4*r - 420*D1*Dd*f**4*s**2 + 630*D1*Dd*f**4*s - 315*D1*Dd*f**4 - 840*D1*Dd*f**3*r**2 - 1680*D1*Dd*f**3*r*s + 1260*D1*Dd*f**3*r - 840*D1*Dd*f**3*s**2 + 1260*D1*Dd*f**3*s - 630*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 20160*D1*Dd*f**2*fd*r*s - 14280*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 14280*D1*Dd*f**2*fd*s + 5040*D1*Dd*f**2*fd - 1224*D1*Dd*f**2*g2*r**2 - 2448*D1*Dd*f**2*g2*r*s + 1836*D1*Dd*f**2*g2*r - 1224*D1*Dd*f**2*g2*s**2 + 1836*D1*Dd*f**2*g2*s - 918*D1*Dd*f**2*g2 + 5760*D1*Dd*f**2*gd2*r**2 + 11520*D1*Dd*f**2*gd2*r*s - 10080*D1*Dd*f**2*gd2*r + 5760*D1*Dd*f**2*gd2*s**2 - 10080*D1*Dd*f**2*gd2*s + 4320*D1*Dd*f**2*gd2 + 11520*D1*Dd*f*fd*g2*r**2 + 23040*D1*Dd*f*fd*g2*r*s - 14400*D1*Dd*f*fd*g2*r + 11520*D1*Dd*f*fd*g2*s**2 - 14400*D1*Dd*f*fd*g2*s + 4320*D1*Dd*f*fd*g2 + 1680*D1*Ddd*f**3*r**2 + 3360*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 2520*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 2880*D1*Ddd*f**2*g2*r**2 + 5760*D1*Ddd*f**2*g2*r*s - 4320*D1*Ddd*f**2*g2*r + 2880*D1*Ddd*f**2*g2*s**2 - 4320*D1*Ddd*f**2*g2*s + 2160*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(30*f**3*(r + s - 1) + 3*f**2*(50*C + 17*K - 55)*(r + s - 1) - 2*f*(60*fd*(3*C + 2*K - 4)*(2*r + 2*s - 1) + (77*g2 - 252*gd2)*(r + s - 1)) + 504*fd*g2*(r + s)) - 24*Dd*f*(5*f*(3*C + 2*K - 4) - 21*g2)*(4*r + 4*s - 3))*(r + s - 1) + 5040*Dd**2*f**3*r**2 + 10080*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 7560*Dd**2*f**3*s + 2520*Dd**2*f**3 + 8640*Dd**2*f**2*g2*r**2 + 17280*Dd**2*f**2*g2*r*s - 12960*Dd**2*f**2*g2*r + 8640*Dd**2*f**2*g2*s**2 - 12960*Dd**2*f**2*g2*s + 4320*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(11*fd - 18*fdd)*(r + s)**2 + D1*(Dd*(11*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 36*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 18*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(300*C*D1**2*f*fd*r**2 + 600*C*D1**2*f*fd*r*s - 300*C*D1**2*f*fd*r + 300*C*D1**2*f*fd*s**2 - 300*C*D1**2*f*fd*s + 150*C*D1**2*f*fd - 360*C*D1**2*f*fdd*r**2 - 720*C*D1**2*f*fdd*r*s + 360*C*D1**2*f*fdd*r - 360*C*D1**2*f*fdd*s**2 + 360*C*D1**2*f*fdd*s - 180*C*D1**2*f*fdd - 360*C*D1**2*fd**2*r**2 - 720*C*D1**2*fd**2*r*s + 360*C*D1**2*fd**2*r - 360*C*D1**2*fd**2*s**2 + 360*C*D1**2*fd**2*s + 600*C*D1*Dd*f**2*r**2 + 1200*C*D1*Dd*f**2*r*s - 900*C*D1*Dd*f**2*r + 600*C*D1*Dd*f**2*s**2 - 900*C*D1*Dd*f**2*s + 450*C*D1*Dd*f**2 - 2880*C*D1*Dd*f*fd*r**2 - 5760*C*D1*Dd*f*fd*r*s + 3600*C*D1*Dd*f*fd*r - 2880*C*D1*Dd*f*fd*s**2 + 3600*C*D1*Dd*f*fd*s - 1080*C*D1*Dd*f*fd - 720*C*D1*Ddd*f**2*r**2 - 1440*C*D1*Ddd*f**2*r*s + 1080*C*D1*Ddd*f**2*r - 720*C*D1*Ddd*f**2*s**2 + 1080*C*D1*Ddd*f**2*s - 540*C*D1*Ddd*f**2 - 2160*C*Dd**2*f**2*r**2 - 4320*C*Dd**2*f**2*r*s + 3240*C*Dd**2*f**2*r - 2160*C*Dd**2*f**2*s**2 + 3240*C*Dd**2*f**2*s - 1080*C*Dd**2*f**2 + 102*D1**2*K*f*fd*r**2 + 204*D1**2*K*f*fd*r*s - 102*D1**2*K*f*fd*r + 102*D1**2*K*f*fd*s**2 - 102*D1**2*K*f*fd*s + 51*D1**2*K*f*fd - 240*D1**2*K*f*fdd*r**2 - 480*D1**2*K*f*fdd*r*s + 240*D1**2*K*f*fdd*r - 240*D1**2*K*f*fdd*s**2 + 240*D1**2*K*f*fdd*s - 120*D1**2*K*f*fdd - 240*D1**2*K*fd**2*r**2 - 480*D1**2*K*fd**2*r*s + 240*D1**2*K*fd**2*r - 240*D1**2*K*fd**2*s**2 + 240*D1**2*K*fd**2*s - 252*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 90*D1**2*f**2*fd*r**2 + 180*D1**2*f**2*fd*r*s - 120*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 330*D1**2*f*fd*r**2 - 660*D1**2*f*fd*r*s + 330*D1**2*f*fd*r - 330*D1**2*f*fd*s**2 + 330*D1**2*f*fd*s - 165*D1**2*f*fd + 480*D1**2*f*fdd*r**2 + 960*D1**2*f*fdd*r*s - 480*D1**2*f*fdd*r + 480*D1**2*f*fdd*s**2 - 480*D1**2*f*fdd*s + 240*D1**2*f*fdd - 154*D1**2*f*gd2*r**2 - 308*D1**2*f*gd2*r*s + 308*D1**2*f*gd2*r - 154*D1**2*f*gd2*s**2 + 308*D1**2*f*gd2*s - 154*D1**2*f*gd2 + 252*D1**2*f*gdd2*r**2 + 504*D1**2*f*gdd2*r*s - 504*D1**2*f*gdd2*r + 252*D1**2*f*gdd2*s**2 - 504*D1**2*f*gdd2*s + 252*D1**2*f*gdd2 + 480*D1**2*fd**2*r**2 + 960*D1**2*fd**2*r*s - 480*D1**2*fd**2*r + 480*D1**2*fd**2*s**2 - 480*D1**2*fd**2*s - 154*D1**2*fd*g2*r**2 - 308*D1**2*fd*g2*r*s - 154*D1**2*fd*g2*s**2 + 504*D1**2*fd*gd2*r**2 + 1008*D1**2*fd*gd2*r*s - 504*D1**2*fd*gd2*r + 504*D1**2*fd*gd2*s**2 - 504*D1**2*fd*gd2*s + 252*D1**2*fdd*g2*r**2 + 504*D1**2*fdd*g2*r*s + 252*D1**2*fdd*g2*s**2 + 204*D1*Dd*K*f**2*r**2 + 408*D1*Dd*K*f**2*r*s - 306*D1*Dd*K*f**2*r + 204*D1*Dd*K*f**2*s**2 - 306*D1*Dd*K*f**2*s + 153*D1*Dd*K*f**2 - 1920*D1*Dd*K*f*fd*r**2 - 3840*D1*Dd*K*f*fd*r*s + 2400*D1*Dd*K*f*fd*r - 1920*D1*Dd*K*f*fd*s**2 + 2400*D1*Dd*K*f*fd*s - 720*D1*Dd*K*f*fd + 120*D1*Dd*f**3*r**2 + 240*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r + 120*D1*Dd*f**3*s**2 - 180*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 660*D1*Dd*f**2*r**2 - 1320*D1*Dd*f**2*r*s + 990*D1*Dd*f**2*r - 660*D1*Dd*f**2*s**2 + 990*D1*Dd*f**2*s - 495*D1*Dd*f**2 + 3840*D1*Dd*f*fd*r**2 + 7680*D1*Dd*f*fd*r*s - 4800*D1*Dd*f*fd*r + 3840*D1*Dd*f*fd*s**2 - 4800*D1*Dd*f*fd*s + 1440*D1*Dd*f*fd - 616*D1*Dd*f*g2*r**2 - 1232*D1*Dd*f*g2*r*s + 924*D1*Dd*f*g2*r - 616*D1*Dd*f*g2*s**2 + 924*D1*Dd*f*g2*s - 462*D1*Dd*f*g2 + 2016*D1*Dd*f*gd2*r**2 + 4032*D1*Dd*f*gd2*r*s - 3528*D1*Dd*f*gd2*r + 2016*D1*Dd*f*gd2*s**2 - 3528*D1*Dd*f*gd2*s + 1512*D1*Dd*f*gd2 + 2016*D1*Dd*fd*g2*r**2 + 4032*D1*Dd*fd*g2*r*s - 1512*D1*Dd*fd*g2*r + 2016*D1*Dd*fd*g2*s**2 - 1512*D1*Dd*fd*g2*s - 480*D1*Ddd*K*f**2*r**2 - 960*D1*Ddd*K*f**2*r*s + 720*D1*Ddd*K*f**2*r - 480*D1*Ddd*K*f**2*s**2 + 720*D1*Ddd*K*f**2*s - 360*D1*Ddd*K*f**2 + 960*D1*Ddd*f**2*r**2 + 1920*D1*Ddd*f**2*r*s - 1440*D1*Ddd*f**2*r + 960*D1*Ddd*f**2*s**2 - 1440*D1*Ddd*f**2*s + 720*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r**2 + 2016*D1*Ddd*f*g2*r*s - 1512*D1*Ddd*f*g2*r + 1008*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 756*D1*Ddd*f*g2 + 14*D1*bd1*(K - 1)*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) - 1440*Dd**2*K*f**2*r**2 - 2880*Dd**2*K*f**2*r*s + 2160*Dd**2*K*f**2*r - 1440*Dd**2*K*f**2*s**2 + 2160*Dd**2*K*f**2*s - 720*Dd**2*K*f**2 + 2880*Dd**2*f**2*r**2 + 5760*Dd**2*f**2*r*s - 4320*Dd**2*f**2*r + 2880*Dd**2*f**2*s**2 - 4320*Dd**2*f**2*s + 1440*Dd**2*f**2 + 3024*Dd**2*f*g2*r**2 + 6048*Dd**2*f*g2*r*s - 4536*Dd**2*f*g2*r + 3024*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 1512*Dd**2*f*g2))/(630*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**4*k1**4*(126*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*bd1*(D1*(-25*f**3*(7*r**2 + 2*r*(7*s - 4) + 7*s**2 - 8*s + 4) + 2*f**2*(35*fd*(21*r**2 + r*(42*s - 29) + 21*s**2 - 29*s + 8) - 27*r**2*(C + 1) - 54*r*(C*s + s - 2) - 27*s**2*(C + 1) + 108*s - 54) + 6*f*(60*fd*(r + s - 1)*(C*r + C*s + r + s - 1) - (7*r + 7*s)*(-g2*(r + s) + 6*gd2*(r + s - 1))) - 252*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(4*r + 4*s - 3)*(35*f**2*(7*r + 7*s - 4) + 90*f*(C*r + C*s + r + s - 2) - 126*g2*(r + s))) - 21*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-108*C*D1**2*f*fd*r**2 - 216*C*D1**2*f*fd*r*s + 216*C*D1**2*f*fd*r - 108*C*D1**2*f*fd*s**2 + 216*C*D1**2*f*fd*s - 108*C*D1**2*f*fd + 180*C*D1**2*f*fdd*r**2 + 360*C*D1**2*f*fdd*r*s - 360*C*D1**2*f*fdd*r + 180*C*D1**2*f*fdd*s**2 - 360*C*D1**2*f*fdd*s + 180*C*D1**2*f*fdd + 180*C*D1**2*fd**2*r**2 + 360*C*D1**2*fd**2*r*s - 360*C*D1**2*fd**2*r + 180*C*D1**2*fd**2*s**2 - 360*C*D1**2*fd**2*s + 180*C*D1**2*fd**2 - 216*C*D1*Dd*f**2*r**2 - 432*C*D1*Dd*f**2*r*s + 324*C*D1*Dd*f**2*r - 216*C*D1*Dd*f**2*s**2 + 324*C*D1*Dd*f**2*s - 162*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r**2 + 2880*C*D1*Dd*f*fd*r*s - 2520*C*D1*Dd*f*fd*r + 1440*C*D1*Dd*f*fd*s**2 - 2520*C*D1*Dd*f*fd*s + 1080*C*D1*Dd*f*fd + 360*C*D1*Ddd*f**2*r**2 + 720*C*D1*Ddd*f**2*r*s - 540*C*D1*Ddd*f**2*r + 360*C*D1*Ddd*f**2*s**2 - 540*C*D1*Ddd*f**2*s + 270*C*D1*Ddd*f**2 + 1080*C*Dd**2*f**2*r**2 + 2160*C*Dd**2*f**2*r*s - 1620*C*Dd**2*f**2*r + 1080*C*Dd**2*f**2*s**2 - 1620*C*Dd**2*f**2*s + 540*C*Dd**2*f**2 + 63*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 525*D1**2*f**2*fd*r**2 - 1050*D1**2*f**2*fd*r*s + 850*D1**2*f**2*fd*r - 525*D1**2*f**2*fd*s**2 + 850*D1**2*f**2*fd*s - 425*D1**2*f**2*fd + 735*D1**2*f**2*fdd*r**2 + 1470*D1**2*f**2*fdd*r*s - 1190*D1**2*f**2*fdd*r + 735*D1**2*f**2*fdd*s**2 - 1190*D1**2*f**2*fdd*s + 595*D1**2*f**2*fdd + 1470*D1**2*f*fd**2*r**2 + 2940*D1**2*f*fd**2*r*s - 2380*D1**2*f*fd**2*r + 1470*D1**2*f*fd**2*s**2 - 2380*D1**2*f*fd**2*s + 910*D1**2*f*fd**2 - 108*D1**2*f*fd*r**2 - 216*D1**2*f*fd*r*s - 108*D1**2*f*fd*s**2 + 180*D1**2*f*fdd*r**2 + 360*D1**2*f*fdd*r*s + 180*D1**2*f*fdd*s**2 + 42*D1**2*f*gd2*r**2 + 84*D1**2*f*gd2*r*s - 84*D1**2*f*gd2*r + 42*D1**2*f*gd2*s**2 - 84*D1**2*f*gd2*s + 42*D1**2*f*gd2 - 126*D1**2*f*gdd2*r**2 - 252*D1**2*f*gdd2*r*s + 252*D1**2*f*gdd2*r - 126*D1**2*f*gdd2*s**2 + 252*D1**2*f*gdd2*s - 126*D1**2*f*gdd2 + 180*D1**2*fd**2*r**2 + 360*D1**2*fd**2*r*s + 180*D1**2*fd**2*s**2 - 180*D1**2*fd**2 + 42*D1**2*fd*g2*r**2 + 84*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*r + 42*D1**2*fd*g2*s**2 - 84*D1**2*fd*g2*s + 42*D1**2*fd*g2 - 252*D1**2*fd*gd2*r**2 - 504*D1**2*fd*gd2*r*s + 504*D1**2*fd*gd2*r - 252*D1**2*fd*gd2*s**2 + 504*D1**2*fd*gd2*s - 252*D1**2*fd*gd2 - 126*D1**2*fdd*g2*r**2 - 252*D1**2*fdd*g2*r*s + 252*D1**2*fdd*g2*r - 126*D1**2*fdd*g2*s**2 + 252*D1**2*fdd*g2*s - 126*D1**2*fdd*g2 - 700*D1*Dd*f**3*r**2 - 1400*D1*Dd*f**3*r*s + 1050*D1*Dd*f**3*r - 700*D1*Dd*f**3*s**2 + 1050*D1*Dd*f**3*s - 525*D1*Dd*f**3 + 5880*D1*Dd*f**2*fd*r**2 + 11760*D1*Dd*f**2*fd*r*s - 9170*D1*Dd*f**2*fd*r + 5880*D1*Dd*f**2*fd*s**2 - 9170*D1*Dd*f**2*fd*s + 3570*D1*Dd*f**2*fd - 216*D1*Dd*f**2*r**2 - 432*D1*Dd*f**2*r*s + 324*D1*Dd*f**2*r - 216*D1*Dd*f**2*s**2 + 324*D1*Dd*f**2*s - 162*D1*Dd*f**2 + 1440*D1*Dd*f*fd*r**2 + 2880*D1*Dd*f*fd*r*s - 1080*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 1080*D1*Dd*f*fd*s + 168*D1*Dd*f*g2*r**2 + 336*D1*Dd*f*g2*r*s - 252*D1*Dd*f*g2*r + 168*D1*Dd*f*g2*s**2 - 252*D1*Dd*f*g2*s + 126*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r**2 - 2016*D1*Dd*f*gd2*r*s + 1764*D1*Dd*f*gd2*r - 1008*D1*Dd*f*gd2*s**2 + 1764*D1*Dd*f*gd2*s - 756*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r**2 - 2016*D1*Dd*fd*g2*r*s + 1764*D1*Dd*fd*g2*r - 1008*D1*Dd*fd*g2*s**2 + 1764*D1*Dd*fd*g2*s - 756*D1*Dd*fd*g2 + 980*D1*Ddd*f**3*r**2 + 1960*D1*Ddd*f**3*r*s - 1470*D1*Ddd*f**3*r + 980*D1*Ddd*f**3*s**2 - 1470*D1*Ddd*f**3*s + 735*D1*Ddd*f**3 + 360*D1*Ddd*f**2*r**2 + 720*D1*Ddd*f**2*r*s - 540*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 540*D1*Ddd*f**2*s + 270*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r**2 - 1008*D1*Ddd*f*g2*r*s + 756*D1*Ddd*f*g2*r - 504*D1*Ddd*f*g2*s**2 + 756*D1*Ddd*f*g2*s - 378*D1*Ddd*f*g2 - 21*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2940*Dd**2*f**3*r**2 + 5880*Dd**2*f**3*r*s - 4410*Dd**2*f**3*r + 2940*Dd**2*f**3*s**2 - 4410*Dd**2*f**3*s + 1470*Dd**2*f**3 + 1080*Dd**2*f**2*r**2 + 2160*Dd**2*f**2*r*s - 1620*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1620*Dd**2*f**2*s + 540*Dd**2*f**2 - 1512*Dd**2*f*g2*r**2 - 3024*Dd**2*f*g2*r*s + 2268*Dd**2*f*g2*r - 1512*Dd**2*f*g2*s**2 + 2268*Dd**2*f*g2*s - 756*Dd**2*f*g2) + f*(D1**2*bdd1*(35*f**2*(7*r**2 + 2*r*(7*s - 4) + 7*s**2 - 8*s + 4) + 90*f*(r**2*(C + 1) + 2*r*(C*s + s - 2) + s**2*(C + 1) - 4*s + 2) - 126*g2*(r + s)**2) - 20*D1**2*(f*(5*fd - 7*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 20*D1*f*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 14*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 840*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**4*k1**2*k2**4*st**4*(396*C*D1**2*f**2*fd*r**2 + 792*C*D1**2*f**2*fd*r*s - 528*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 528*C*D1**2*f**2*fd*s + 264*C*D1**2*f**2*fd - 198*C*D1**2*f**2*fdd*r**2 - 396*C*D1**2*f**2*fdd*r*s + 264*C*D1**2*f**2*fdd*r - 198*C*D1**2*f**2*fdd*s**2 + 264*C*D1**2*f**2*fdd*s - 132*C*D1**2*f**2*fdd - 396*C*D1**2*f*fd**2*r**2 - 792*C*D1**2*f*fd**2*r*s + 528*C*D1**2*f*fd**2*r - 396*C*D1**2*f*fd**2*s**2 + 528*C*D1**2*f*fd**2*s - 132*C*D1**2*f*fd**2 + 528*C*D1*Dd*f**3*r**2 + 1056*C*D1*Dd*f**3*r*s - 792*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 792*C*D1*Dd*f**3*s + 396*C*D1*Dd*f**3 - 1584*C*D1*Dd*f**2*fd*r**2 - 3168*C*D1*Dd*f**2*fd*r*s + 2244*C*D1*Dd*f**2*fd*r - 1584*C*D1*Dd*f**2*fd*s**2 + 2244*C*D1*Dd*f**2*fd*s - 792*C*D1*Dd*f**2*fd - 264*C*D1*Ddd*f**3*r**2 - 528*C*D1*Ddd*f**3*r*s + 396*C*D1*Ddd*f**3*r - 264*C*D1*Ddd*f**3*s**2 + 396*C*D1*Ddd*f**3*s - 198*C*D1*Ddd*f**3 - 792*C*Dd**2*f**3*r**2 - 1584*C*Dd**2*f**3*r*s + 1188*C*Dd**2*f**3*r - 792*C*Dd**2*f**3*s**2 + 1188*C*Dd**2*f**3*s - 396*C*Dd**2*f**3 + 396*D1**2*K*b1*f*fd*r**2 + 792*D1**2*K*b1*f*fd*r*s - 396*D1**2*K*b1*f*fd*r + 396*D1**2*K*b1*f*fd*s**2 - 396*D1**2*K*b1*f*fd*s + 198*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 396*D1**2*K*b1*f*fdd*r*s + 198*D1**2*K*b1*f*fdd*r - 198*D1**2*K*b1*f*fdd*s**2 + 198*D1**2*K*b1*f*fdd*s - 99*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 396*D1**2*K*b1*fd**2*r*s + 198*D1**2*K*b1*fd**2*r - 198*D1**2*K*b1*fd**2*s**2 + 198*D1**2*K*b1*fd**2*s - 396*D1**2*b1*f*fd*r**2 - 792*D1**2*b1*f*fd*r*s + 396*D1**2*b1*f*fd*r - 396*D1**2*b1*f*fd*s**2 + 396*D1**2*b1*f*fd*s - 198*D1**2*b1*f*fd + 198*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 198*D1**2*b1*f*fdd*s**2 - 198*D1**2*b1*f*fdd*s + 99*D1**2*b1*f*fdd + 198*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 198*D1**2*b1*fd**2*s**2 - 198*D1**2*b1*fd**2*s - 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 560*D1**2*f**3*fd*r**2 + 1120*D1**2*f**3*fd*r*s - 840*D1**2*f**3*fd*r + 560*D1**2*f**3*fd*s**2 - 840*D1**2*f**3*fd*s + 420*D1**2*f**3*fd - 280*D1**2*f**3*fdd*r**2 - 560*D1**2*f**3*fdd*r*s + 420*D1**2*f**3*fdd*r - 280*D1**2*f**3*fdd*s**2 + 420*D1**2*f**3*fdd*s - 210*D1**2*f**3*fdd - 840*D1**2*f**2*fd**2*r**2 - 1680*D1**2*f**2*fd**2*r*s + 1260*D1**2*f**2*fd**2*r - 840*D1**2*f**2*fd**2*s**2 + 1260*D1**2*f**2*fd**2*s - 420*D1**2*f**2*fd**2 - 396*D1**2*f**2*fd*r**2 - 792*D1**2*f**2*fd*r*s + 528*D1**2*f**2*fd*r - 396*D1**2*f**2*fd*s**2 + 528*D1**2*f**2*fd*s - 264*D1**2*f**2*fd + 198*D1**2*f**2*fdd*r**2 + 396*D1**2*f**2*fdd*r*s - 264*D1**2*f**2*fdd*r + 198*D1**2*f**2*fdd*s**2 - 264*D1**2*f**2*fdd*s + 132*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 396*D1**2*f**2*gd2*s**2 + 792*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 396*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 396*D1**2*f*fd**2*r**2 + 792*D1**2*f*fd**2*r*s - 528*D1**2*f*fd**2*r + 396*D1**2*f*fd**2*s**2 - 528*D1**2*f*fd**2*s + 132*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 792*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1584*D1**2*f*fd*gd2*r*s - 1188*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1188*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 792*D1*Dd*K*b1*f**2*r**2 + 1584*D1*Dd*K*b1*f**2*r*s - 1188*D1*Dd*K*b1*f**2*r + 792*D1*Dd*K*b1*f**2*s**2 - 1188*D1*Dd*K*b1*f**2*s + 594*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 3168*D1*Dd*K*b1*f*fd*r*s + 1980*D1*Dd*K*b1*f*fd*r - 1584*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 594*D1*Dd*K*b1*f*fd - 792*D1*Dd*b1*f**2*r**2 - 1584*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 792*D1*Dd*b1*f**2*s**2 + 1188*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r + 1584*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s + 594*D1*Dd*b1*f*fd + 560*D1*Dd*f**4*r**2 + 1120*D1*Dd*f**4*r*s - 840*D1*Dd*f**4*r + 560*D1*Dd*f**4*s**2 - 840*D1*Dd*f**4*s + 420*D1*Dd*f**4 - 2240*D1*Dd*f**3*fd*r**2 - 4480*D1*Dd*f**3*fd*r*s + 3360*D1*Dd*f**3*fd*r - 2240*D1*Dd*f**3*fd*s**2 + 3360*D1*Dd*f**3*fd*s - 1260*D1*Dd*f**3*fd - 528*D1*Dd*f**3*r**2 - 1056*D1*Dd*f**3*r*s + 792*D1*Dd*f**3*r - 528*D1*Dd*f**3*s**2 + 792*D1*Dd*f**3*s - 396*D1*Dd*f**3 + 1584*D1*Dd*f**2*fd*r**2 + 3168*D1*Dd*f**2*fd*r*s - 2244*D1*Dd*f**2*fd*r + 1584*D1*Dd*f**2*fd*s**2 - 2244*D1*Dd*f**2*fd*s + 792*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 2376*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 3168*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 1188*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 6336*D1*Dd*f*fd*g2*r*s - 3960*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 1188*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 792*D1*Ddd*K*b1*f**2*r*s + 594*D1*Ddd*K*b1*f**2*r - 396*D1*Ddd*K*b1*f**2*s**2 + 594*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 396*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 396*D1*Ddd*b1*f**2*s**2 - 594*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 - 280*D1*Ddd*f**4*r**2 - 560*D1*Ddd*f**4*r*s + 420*D1*Ddd*f**4*r - 280*D1*Ddd*f**4*s**2 + 420*D1*Ddd*f**4*s - 210*D1*Ddd*f**4 + 264*D1*Ddd*f**3*r**2 + 528*D1*Ddd*f**3*r*s - 396*D1*Ddd*f**3*r + 264*D1*Ddd*f**3*s**2 - 396*D1*Ddd*f**3*s + 198*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1584*D1*Ddd*f**2*g2*r*s - 1188*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1188*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1188*Dd**2*K*b1*f**2*r**2 - 2376*Dd**2*K*b1*f**2*r*s + 1782*Dd**2*K*b1*f**2*r - 1188*Dd**2*K*b1*f**2*s**2 + 1782*Dd**2*K*b1*f**2*s - 594*Dd**2*K*b1*f**2 + 1188*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 1188*Dd**2*b1*f**2*s**2 - 1782*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 - 840*Dd**2*f**4*r**2 - 1680*Dd**2*f**4*r*s + 1260*Dd**2*f**4*r - 840*Dd**2*f**4*s**2 + 1260*Dd**2*f**4*s - 420*Dd**2*f**4 + 792*Dd**2*f**3*r**2 + 1584*Dd**2*f**3*r*s - 1188*Dd**2*f**3*r + 792*Dd**2*f**3*s**2 - 1188*Dd**2*f**3*s + 396*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 4752*Dd**2*f**2*g2*r*s - 3564*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3564*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2)/(462*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**4*k1**2*k2**4*st**2*(-108*C*D1**2*bdd1*f**2*r**2 - 216*C*D1**2*bdd1*f**2*r*s + 216*C*D1**2*bdd1*f**2*r - 108*C*D1**2*bdd1*f**2*s**2 + 216*C*D1**2*bdd1*f**2*s - 108*C*D1**2*bdd1*f**2 + 3180*C*D1**2*f**2*fd*r**2 + 6360*C*D1**2*f**2*fd*r*s - 4240*C*D1**2*f**2*fd*r + 3180*C*D1**2*f**2*fd*s**2 - 4240*C*D1**2*f**2*fd*s + 2120*C*D1**2*f**2*fd - 2400*C*D1**2*f**2*fdd*r**2 - 4800*C*D1**2*f**2*fdd*r*s + 3200*C*D1**2*f**2*fdd*r - 2400*C*D1**2*f**2*fdd*s**2 + 3200*C*D1**2*f**2*fdd*s - 1600*C*D1**2*f**2*fdd - 4800*C*D1**2*f*fd**2*r**2 - 9600*C*D1**2*f*fd**2*r*s + 6400*C*D1**2*f*fd**2*r - 4800*C*D1**2*f*fd**2*s**2 + 6400*C*D1**2*f*fd**2*s - 1600*C*D1**2*f*fd**2 + 4240*C*D1*Dd*f**3*r**2 + 8480*C*D1*Dd*f**3*r*s - 6360*C*D1*Dd*f**3*r + 4240*C*D1*Dd*f**3*s**2 - 6360*C*D1*Dd*f**3*s + 3180*C*D1*Dd*f**3 - 19200*C*D1*Dd*f**2*fd*r**2 - 38400*C*D1*Dd*f**2*fd*r*s + 27200*C*D1*Dd*f**2*fd*r - 19200*C*D1*Dd*f**2*fd*s**2 + 27200*C*D1*Dd*f**2*fd*s - 9600*C*D1*Dd*f**2*fd - 3200*C*D1*Ddd*f**3*r**2 - 6400*C*D1*Ddd*f**3*r*s + 4800*C*D1*Ddd*f**3*r - 3200*C*D1*Ddd*f**3*s**2 + 4800*C*D1*Ddd*f**3*s - 2400*C*D1*Ddd*f**3 - 9600*C*Dd**2*f**3*r**2 - 19200*C*Dd**2*f**3*r*s + 14400*C*Dd**2*f**3*r - 9600*C*Dd**2*f**3*s**2 + 14400*C*Dd**2*f**3*s - 4800*C*Dd**2*f**3 - 720*D1**2*K*bdd1*f**2*r**2 - 1440*D1**2*K*bdd1*f**2*r*s + 1440*D1**2*K*bdd1*f**2*r - 720*D1**2*K*bdd1*f**2*s**2 + 1440*D1**2*K*bdd1*f**2*s - 720*D1**2*K*bdd1*f**2 - 252*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 300*D1**2*bdd1*f**3*r**2 + 600*D1**2*bdd1*f**3*r*s - 600*D1**2*bdd1*f**3*r + 300*D1**2*bdd1*f**3*s**2 - 600*D1**2*bdd1*f**3*s + 300*D1**2*bdd1*f**3 + 468*D1**2*bdd1*f**2*r**2 + 936*D1**2*bdd1*f**2*r*s - 936*D1**2*bdd1*f**2*r + 468*D1**2*bdd1*f**2*s**2 - 936*D1**2*bdd1*f**2*s + 468*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s - 504*D1**2*bdd1*f*g2*r + 252*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 - 300*D1**2*f**3*fd*r**2 - 600*D1**2*f**3*fd*r*s + 450*D1**2*f**3*fd*r - 300*D1**2*f**3*fd*s**2 + 450*D1**2*f**3*fd*s - 225*D1**2*f**3*fd - 2304*D1**2*f**2*fd*r**2 - 4608*D1**2*f**2*fd*r*s + 3072*D1**2*f**2*fd*r - 2304*D1**2*f**2*fd*s**2 + 3072*D1**2*f**2*fd*s - 1536*D1**2*f**2*fd + 1800*D1**2*f**2*fdd*r**2 + 3600*D1**2*f**2*fdd*r*s - 2400*D1**2*f**2*fdd*r + 1800*D1**2*f**2*fdd*s**2 - 2400*D1**2*f**2*fdd*s + 1200*D1**2*f**2*fdd - 1620*D1**2*f**2*gd2*r**2 - 3240*D1**2*f**2*gd2*r*s + 3240*D1**2*f**2*gd2*r - 1620*D1**2*f**2*gd2*s**2 + 3240*D1**2*f**2*gd2*s - 1620*D1**2*f**2*gd2 + 1440*D1**2*f**2*gdd2*r**2 + 2880*D1**2*f**2*gdd2*r*s - 2880*D1**2*f**2*gdd2*r + 1440*D1**2*f**2*gdd2*s**2 - 2880*D1**2*f**2*gdd2*s + 1440*D1**2*f**2*gdd2 + 3600*D1**2*f*fd**2*r**2 + 7200*D1**2*f*fd**2*r*s - 4800*D1**2*f*fd**2*r + 3600*D1**2*f*fd**2*s**2 - 4800*D1**2*f*fd**2*s + 1200*D1**2*f*fd**2 - 3240*D1**2*f*fd*g2*r**2 - 6480*D1**2*f*fd*g2*r*s + 3240*D1**2*f*fd*g2*r - 3240*D1**2*f*fd*g2*s**2 + 3240*D1**2*f*fd*g2*s - 1620*D1**2*f*fd*g2 + 5760*D1**2*f*fd*gd2*r**2 + 11520*D1**2*f*fd*gd2*r*s - 8640*D1**2*f*fd*gd2*r + 5760*D1**2*f*fd*gd2*s**2 - 8640*D1**2*f*fd*gd2*s + 2880*D1**2*f*fd*gd2 + 2880*D1**2*f*fdd*g2*r**2 + 5760*D1**2*f*fdd*g2*r*s - 2880*D1**2*f*fdd*g2*r + 2880*D1**2*f*fdd*g2*s**2 - 2880*D1**2*f*fdd*g2*s + 1440*D1**2*f*fdd*g2 + 2880*D1**2*fd**2*g2*r**2 + 5760*D1**2*fd**2*g2*r*s - 2880*D1**2*fd**2*g2*r + 2880*D1**2*fd**2*g2*s**2 - 2880*D1**2*fd**2*g2*s - 300*D1*Dd*f**4*r**2 - 600*D1*Dd*f**4*r*s + 450*D1*Dd*f**4*r - 300*D1*Dd*f**4*s**2 + 450*D1*Dd*f**4*s - 225*D1*Dd*f**4 - 3072*D1*Dd*f**3*r**2 - 6144*D1*Dd*f**3*r*s + 4608*D1*Dd*f**3*r - 3072*D1*Dd*f**3*s**2 + 4608*D1*Dd*f**3*s - 2304*D1*Dd*f**3 + 14400*D1*Dd*f**2*fd*r**2 + 28800*D1*Dd*f**2*fd*r*s - 20400*D1*Dd*f**2*fd*r + 14400*D1*Dd*f**2*fd*s**2 - 20400*D1*Dd*f**2*fd*s + 7200*D1*Dd*f**2*fd - 6480*D1*Dd*f**2*g2*r**2 - 12960*D1*Dd*f**2*g2*r*s + 9720*D1*Dd*f**2*g2*r - 6480*D1*Dd*f**2*g2*s**2 + 9720*D1*Dd*f**2*g2*s - 4860*D1*Dd*f**2*g2 + 11520*D1*Dd*f**2*gd2*r**2 + 23040*D1*Dd*f**2*gd2*r*s - 20160*D1*Dd*f**2*gd2*r + 11520*D1*Dd*f**2*gd2*s**2 - 20160*D1*Dd*f**2*gd2*s + 8640*D1*Dd*f**2*gd2 + 23040*D1*Dd*f*fd*g2*r**2 + 46080*D1*Dd*f*fd*g2*r*s - 28800*D1*Dd*f*fd*g2*r + 23040*D1*Dd*f*fd*g2*s**2 - 28800*D1*Dd*f*fd*g2*s + 8640*D1*Dd*f*fd*g2 + 2400*D1*Ddd*f**3*r**2 + 4800*D1*Ddd*f**3*r*s - 3600*D1*Ddd*f**3*r + 2400*D1*Ddd*f**3*s**2 - 3600*D1*Ddd*f**3*s + 1800*D1*Ddd*f**3 + 5760*D1*Ddd*f**2*g2*r**2 + 11520*D1*Ddd*f**2*g2*r*s - 8640*D1*Ddd*f**2*g2*r + 5760*D1*Ddd*f**2*g2*s**2 - 8640*D1*Ddd*f**2*g2*s + 4320*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(70*f**3*(r + s - 1) - f**2*(36*C*(r + s - 1) + 100*fd*(3*r + 3*s - 2) + (135*K - 93)*(r + s - 1)) + 12*f*(fd*(3*C + 20*K - 13)*(2*r + 2*s - 1) + (7*g2 - 7*gd2)*(r + s - 1)) - 84*fd*g2*(r + s)) - 4*Dd*f*(25*f**2 + f*(-9*C - 60*K + 39) + 21*g2)*(4*r + 4*s - 3))*(r + s - 1) + 7200*Dd**2*f**3*r**2 + 14400*Dd**2*f**3*r*s - 10800*Dd**2*f**3*r + 7200*Dd**2*f**3*s**2 - 10800*Dd**2*f**3*s + 3600*Dd**2*f**3 + 17280*Dd**2*f**2*g2*r**2 + 34560*Dd**2*f**2*g2*r*s - 25920*Dd**2*f**2*g2*r + 17280*Dd**2*f**2*g2*s**2 - 25920*Dd**2*f**2*g2*s + 8640*Dd**2*f**2*g2 + 126*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*b1*(72*C*D1**2*f*fd*r**2 + 144*C*D1**2*f*fd*r*s - 72*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s**2 - 72*C*D1**2*f*fd*s + 36*C*D1**2*f*fd - 36*C*D1**2*f*fdd*r**2 - 72*C*D1**2*f*fdd*r*s + 36*C*D1**2*f*fdd*r - 36*C*D1**2*f*fdd*s**2 + 36*C*D1**2*f*fdd*s - 18*C*D1**2*f*fdd - 36*C*D1**2*fd**2*r**2 - 72*C*D1**2*fd**2*r*s + 36*C*D1**2*fd**2*r - 36*C*D1**2*fd**2*s**2 + 36*C*D1**2*fd**2*s + 144*C*D1*Dd*f**2*r**2 + 288*C*D1*Dd*f**2*r*s - 216*C*D1*Dd*f**2*r + 144*C*D1*Dd*f**2*s**2 - 216*C*D1*Dd*f**2*s + 108*C*D1*Dd*f**2 - 288*C*D1*Dd*f*fd*r**2 - 576*C*D1*Dd*f*fd*r*s + 360*C*D1*Dd*f*fd*r - 288*C*D1*Dd*f*fd*s**2 + 360*C*D1*Dd*f*fd*s - 108*C*D1*Dd*f*fd - 72*C*D1*Ddd*f**2*r**2 - 144*C*D1*Ddd*f**2*r*s + 108*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 108*C*D1*Ddd*f**2*s - 54*C*D1*Ddd*f**2 - 216*C*Dd**2*f**2*r**2 - 432*C*Dd**2*f**2*r*s + 324*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 324*C*Dd**2*f**2*s - 108*C*Dd**2*f**2 + 270*D1**2*K*f*fd*r**2 + 540*D1**2*K*f*fd*r*s - 270*D1**2*K*f*fd*r + 270*D1**2*K*f*fd*s**2 - 270*D1**2*K*f*fd*s + 135*D1**2*K*f*fd - 240*D1**2*K*f*fdd*r**2 - 480*D1**2*K*f*fdd*r*s + 240*D1**2*K*f*fdd*r - 240*D1**2*K*f*fdd*s**2 + 240*D1**2*K*f*fdd*s - 120*D1**2*K*f*fdd - 240*D1**2*K*fd**2*r**2 - 480*D1**2*K*fd**2*r*s + 240*D1**2*K*fd**2*r - 240*D1**2*K*fd**2*s**2 + 240*D1**2*K*fd**2*s - 42*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 210*D1**2*f**2*fd*r**2 - 420*D1**2*f**2*fd*r*s + 280*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 280*D1**2*f**2*fd*s - 140*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 186*D1**2*f*fd*r**2 - 372*D1**2*f*fd*r*s + 186*D1**2*f*fd*r - 186*D1**2*f*fd*s**2 + 186*D1**2*f*fd*s - 93*D1**2*f*fd + 156*D1**2*f*fdd*r**2 + 312*D1**2*f*fdd*r*s - 156*D1**2*f*fdd*r + 156*D1**2*f*fdd*s**2 - 156*D1**2*f*fdd*s + 78*D1**2*f*fdd - 84*D1**2*f*gd2*r**2 - 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*r - 84*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s - 84*D1**2*f*gd2 + 42*D1**2*f*gdd2*r**2 + 84*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*r + 42*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 42*D1**2*f*gdd2 + 156*D1**2*fd**2*r**2 + 312*D1**2*fd**2*r*s - 156*D1**2*fd**2*r + 156*D1**2*fd**2*s**2 - 156*D1**2*fd**2*s - 84*D1**2*fd*g2*r**2 - 168*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*s**2 + 84*D1**2*fd*gd2*r**2 + 168*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*r + 84*D1**2*fd*gd2*s**2 - 84*D1**2*fd*gd2*s + 42*D1**2*fdd*g2*r**2 + 84*D1**2*fdd*g2*r*s + 42*D1**2*fdd*g2*s**2 + 540*D1*Dd*K*f**2*r**2 + 1080*D1*Dd*K*f**2*r*s - 810*D1*Dd*K*f**2*r + 540*D1*Dd*K*f**2*s**2 - 810*D1*Dd*K*f**2*s + 405*D1*Dd*K*f**2 - 1920*D1*Dd*K*f*fd*r**2 - 3840*D1*Dd*K*f*fd*r*s + 2400*D1*Dd*K*f*fd*r - 1920*D1*Dd*K*f*fd*s**2 + 2400*D1*Dd*K*f*fd*s - 720*D1*Dd*K*f*fd - 280*D1*Dd*f**3*r**2 - 560*D1*Dd*f**3*r*s + 420*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 420*D1*Dd*f**3*s - 210*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 1700*D1*Dd*f**2*fd*r + 1200*D1*Dd*f**2*fd*s**2 - 1700*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 372*D1*Dd*f**2*r**2 - 744*D1*Dd*f**2*r*s + 558*D1*Dd*f**2*r - 372*D1*Dd*f**2*s**2 + 558*D1*Dd*f**2*s - 279*D1*Dd*f**2 + 1248*D1*Dd*f*fd*r**2 + 2496*D1*Dd*f*fd*r*s - 1560*D1*Dd*f*fd*r + 1248*D1*Dd*f*fd*s**2 - 1560*D1*Dd*f*fd*s + 468*D1*Dd*f*fd - 336*D1*Dd*f*g2*r**2 - 672*D1*Dd*f*g2*r*s + 504*D1*Dd*f*g2*r - 336*D1*Dd*f*g2*s**2 + 504*D1*Dd*f*g2*s - 252*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 + 672*D1*Dd*f*gd2*r*s - 588*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s**2 - 588*D1*Dd*f*gd2*s + 252*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r**2 + 672*D1*Dd*fd*g2*r*s - 252*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s**2 - 252*D1*Dd*fd*g2*s - 480*D1*Ddd*K*f**2*r**2 - 960*D1*Ddd*K*f**2*r*s + 720*D1*Ddd*K*f**2*r - 480*D1*Ddd*K*f**2*s**2 + 720*D1*Ddd*K*f**2*s - 360*D1*Ddd*K*f**2 + 200*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 300*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 + 312*D1*Ddd*f**2*r**2 + 624*D1*Ddd*f**2*r*s - 468*D1*Ddd*f**2*r + 312*D1*Ddd*f**2*s**2 - 468*D1*Ddd*f**2*s + 234*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r*s - 252*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s**2 - 252*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 + 84*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 1440*Dd**2*K*f**2*r**2 - 2880*Dd**2*K*f**2*r*s + 2160*Dd**2*K*f**2*r - 1440*Dd**2*K*f**2*s**2 + 2160*Dd**2*K*f**2*s - 720*Dd**2*K*f**2 + 600*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 900*Dd**2*f**3*r + 600*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 300*Dd**2*f**3 + 936*Dd**2*f**2*r**2 + 1872*Dd**2*f**2*r*s - 1404*Dd**2*f**2*r + 936*Dd**2*f**2*s**2 - 1404*Dd**2*f**2*s + 468*Dd**2*f**2 + 504*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r*s - 756*Dd**2*f*g2*r + 504*Dd**2*f*g2*s**2 - 756*Dd**2*f*g2*s + 252*Dd**2*f*g2))/(630*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**4*k1**2*k2**4*(240*C*D1**2*bdd1*f**2*r**2 + 480*C*D1**2*bdd1*f**2*r*s - 480*C*D1**2*bdd1*f**2*r + 240*C*D1**2*bdd1*f**2*s**2 - 480*C*D1**2*bdd1*f**2*s + 240*C*D1**2*bdd1*f**2 - 30*C*D1**2*f**2*fd*r**2 - 60*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 420*C*D1**2*f**2*fdd*r**2 + 840*C*D1**2*f**2*fdd*r*s - 560*C*D1**2*f**2*fdd*r + 420*C*D1**2*f**2*fdd*s**2 - 560*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 840*C*D1**2*f*fd**2*r**2 + 1680*C*D1**2*f*fd**2*r*s - 1120*C*D1**2*f*fd**2*r + 840*C*D1**2*f*fd**2*s**2 - 1120*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 40*C*D1*Dd*f**3*r**2 - 80*C*D1*Dd*f**3*r*s + 60*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 60*C*D1*Dd*f**3*s - 30*C*D1*Dd*f**3 + 3360*C*D1*Dd*f**2*fd*r**2 + 6720*C*D1*Dd*f**2*fd*r*s - 4760*C*D1*Dd*f**2*fd*r + 3360*C*D1*Dd*f**2*fd*s**2 - 4760*C*D1*Dd*f**2*fd*s + 1680*C*D1*Dd*f**2*fd + 560*C*D1*Ddd*f**3*r**2 + 1120*C*D1*Ddd*f**3*r*s - 840*C*D1*Ddd*f**3*r + 560*C*D1*Ddd*f**3*s**2 - 840*C*D1*Ddd*f**3*s + 420*C*D1*Ddd*f**3 + 1680*C*Dd**2*f**3*r**2 + 3360*C*Dd**2*f**3*r*s - 2520*C*Dd**2*f**3*r + 1680*C*Dd**2*f**3*s**2 - 2520*C*Dd**2*f**3*s + 840*C*Dd**2*f**3 + 90*D1**2*K*bdd1*f**2*r**2 + 180*D1**2*K*bdd1*f**2*r*s - 180*D1**2*K*bdd1*f**2*r + 90*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s + 90*D1**2*K*bdd1*f**2 - 6*D1**2*bd1**2*f*(-56*K + 25*f + 28)*(r + s - 1)**2 - 180*D1**2*bdd1*f**2*r**2 - 360*D1**2*bdd1*f**2*r*s + 360*D1**2*bdd1*f**2*r - 180*D1**2*bdd1*f**2*s**2 + 360*D1**2*bdd1*f**2*s - 180*D1**2*bdd1*f**2 - 336*D1**2*bdd1*f*g2*r**2 - 672*D1**2*bdd1*f*g2*r*s + 672*D1**2*bdd1*f*g2*r - 336*D1**2*bdd1*f*g2*s**2 + 672*D1**2*bdd1*f*g2*s - 336*D1**2*bdd1*f*g2 - 75*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 280*D1**2*f**2*fdd*r - 210*D1**2*f**2*fdd*s**2 + 280*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 18*D1**2*f**2*gd2*r**2 - 36*D1**2*f**2*gd2*r*s + 36*D1**2*f**2*gd2*r - 18*D1**2*f**2*gd2*s**2 + 36*D1**2*f**2*gd2*s - 18*D1**2*f**2*gd2 - 180*D1**2*f**2*gdd2*r**2 - 360*D1**2*f**2*gdd2*r*s + 360*D1**2*f**2*gdd2*r - 180*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s - 180*D1**2*f**2*gdd2 - 420*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 560*D1**2*f*fd**2*r - 420*D1**2*f*fd**2*s**2 + 560*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 36*D1**2*f*fd*g2*r**2 - 72*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r - 36*D1**2*f*fd*g2*s**2 + 36*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*r**2 - 1440*D1**2*f*fd*gd2*r*s + 1080*D1**2*f*fd*gd2*r - 720*D1**2*f*fd*gd2*s**2 + 1080*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 360*D1**2*f*fdd*g2*r**2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r - 360*D1**2*f*fdd*g2*s**2 + 360*D1**2*f*fdd*g2*s - 180*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*r**2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r - 360*D1**2*fd**2*g2*s**2 + 360*D1**2*fd**2*g2*s - 100*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 75*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2380*D1*Dd*f**2*fd*r - 1680*D1*Dd*f**2*fd*s**2 + 2380*D1*Dd*f**2*fd*s - 840*D1*Dd*f**2*fd - 72*D1*Dd*f**2*g2*r**2 - 144*D1*Dd*f**2*g2*r*s + 108*D1*Dd*f**2*g2*r - 72*D1*Dd*f**2*g2*s**2 + 108*D1*Dd*f**2*g2*s - 54*D1*Dd*f**2*g2 - 1440*D1*Dd*f**2*gd2*r**2 - 2880*D1*Dd*f**2*gd2*r*s + 2520*D1*Dd*f**2*gd2*r - 1440*D1*Dd*f**2*gd2*s**2 + 2520*D1*Dd*f**2*gd2*s - 1080*D1*Dd*f**2*gd2 - 2880*D1*Dd*f*fd*g2*r**2 - 5760*D1*Dd*f*fd*g2*r*s + 3600*D1*Dd*f*fd*g2*r - 2880*D1*Dd*f*fd*g2*s**2 + 3600*D1*Dd*f*fd*g2*s - 1080*D1*Dd*f*fd*g2 - 280*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s**2 + 420*D1*Ddd*f**3*s - 210*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*r**2 - 1440*D1*Ddd*f**2*g2*r*s + 1080*D1*Ddd*f**2*g2*r - 720*D1*Ddd*f**2*g2*s**2 + 1080*D1*Ddd*f**2*g2*s - 540*D1*Ddd*f**2*g2 - D1*bd1*(D1*(30*f**3*(r + s - 1) + 3*f**2*(90*C - 3*K - 50)*(r + s - 1) - 2*f*(30*fd*(8*C + 3*K - 6)*(2*r + 2*s - 1) + (161*g2 - 336*gd2)*(r + s - 1)) + 672*fd*g2*(r + s)) - 12*Dd*f*(5*f*(8*C + 3*K - 6) - 56*g2)*(4*r + 4*s - 3))*(r + s - 1) - 840*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 840*Dd**2*f**3*s**2 + 1260*Dd**2*f**3*s - 420*Dd**2*f**3 - 2160*Dd**2*f**2*g2*r**2 - 4320*Dd**2*f**2*g2*r*s + 3240*Dd**2*f**2*g2*r - 2160*Dd**2*f**2*g2*s**2 + 3240*Dd**2*f**2*g2*s - 1080*Dd**2*f**2*g2 + b1**2*(D1**2*(3*f*(36*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 7*fd*(23*K - 9)*(r + s) - 84*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(108*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(150*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (161*K - 63)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 168*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-56*K + 25*f + 28)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-56*K + 25*f + 28)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-540*C*D1**2*f*fd*r**2 - 1080*C*D1**2*f*fd*r*s + 540*C*D1**2*f*fd*r - 540*C*D1**2*f*fd*s**2 + 540*C*D1**2*f*fd*s - 270*C*D1**2*f*fd + 480*C*D1**2*f*fdd*r**2 + 960*C*D1**2*f*fdd*r*s - 480*C*D1**2*f*fdd*r + 480*C*D1**2*f*fdd*s**2 - 480*C*D1**2*f*fdd*s + 240*C*D1**2*f*fdd + 480*C*D1**2*fd**2*r**2 + 960*C*D1**2*fd**2*r*s - 480*C*D1**2*fd**2*r + 480*C*D1**2*fd**2*s**2 - 480*C*D1**2*fd**2*s - 1080*C*D1*Dd*f**2*r**2 - 2160*C*D1*Dd*f**2*r*s + 1620*C*D1*Dd*f**2*r - 1080*C*D1*Dd*f**2*s**2 + 1620*C*D1*Dd*f**2*s - 810*C*D1*Dd*f**2 + 3840*C*D1*Dd*f*fd*r**2 + 7680*C*D1*Dd*f*fd*r*s - 4800*C*D1*Dd*f*fd*r + 3840*C*D1*Dd*f*fd*s**2 - 4800*C*D1*Dd*f*fd*s + 1440*C*D1*Dd*f*fd + 960*C*D1*Ddd*f**2*r**2 + 1920*C*D1*Ddd*f**2*r*s - 1440*C*D1*Ddd*f**2*r + 960*C*D1*Ddd*f**2*s**2 - 1440*C*D1*Ddd*f**2*s + 720*C*D1*Ddd*f**2 + 2880*C*Dd**2*f**2*r**2 + 5760*C*Dd**2*f**2*r*s - 4320*C*Dd**2*f**2*r + 2880*C*Dd**2*f**2*s**2 - 4320*C*Dd**2*f**2*s + 1440*C*Dd**2*f**2 + 18*D1**2*K*f*fd*r**2 + 36*D1**2*K*f*fd*r*s - 18*D1**2*K*f*fd*r + 18*D1**2*K*f*fd*s**2 - 18*D1**2*K*f*fd*s + 9*D1**2*K*f*fd + 180*D1**2*K*f*fdd*r**2 + 360*D1**2*K*f*fdd*r*s - 180*D1**2*K*f*fdd*r + 180*D1**2*K*f*fdd*s**2 - 180*D1**2*K*f*fdd*s + 90*D1**2*K*f*fdd + 180*D1**2*K*fd**2*r**2 + 360*D1**2*K*fd**2*r*s - 180*D1**2*K*fd**2*r + 180*D1**2*K*fd**2*s**2 - 180*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-56*K + 25*f + 28)*(r + s - 1)**2 - 90*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 300*D1**2*f*fd*r**2 + 600*D1**2*f*fd*r*s - 300*D1**2*f*fd*r + 300*D1**2*f*fd*s**2 - 300*D1**2*f*fd*s + 150*D1**2*f*fd - 360*D1**2*f*fdd*r**2 - 720*D1**2*f*fdd*r*s + 360*D1**2*f*fdd*r - 360*D1**2*f*fdd*s**2 + 360*D1**2*f*fdd*s - 180*D1**2*f*fdd + 322*D1**2*f*gd2*r**2 + 644*D1**2*f*gd2*r*s - 644*D1**2*f*gd2*r + 322*D1**2*f*gd2*s**2 - 644*D1**2*f*gd2*s + 322*D1**2*f*gd2 - 336*D1**2*f*gdd2*r**2 - 672*D1**2*f*gdd2*r*s + 672*D1**2*f*gdd2*r - 336*D1**2*f*gdd2*s**2 + 672*D1**2*f*gdd2*s - 336*D1**2*f*gdd2 - 360*D1**2*fd**2*r**2 - 720*D1**2*fd**2*r*s + 360*D1**2*fd**2*r - 360*D1**2*fd**2*s**2 + 360*D1**2*fd**2*s + 322*D1**2*fd*g2*r**2 + 644*D1**2*fd*g2*r*s + 322*D1**2*fd*g2*s**2 - 672*D1**2*fd*gd2*r**2 - 1344*D1**2*fd*gd2*r*s + 672*D1**2*fd*gd2*r - 672*D1**2*fd*gd2*s**2 + 672*D1**2*fd*gd2*s - 336*D1**2*fdd*g2*r**2 - 672*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*s**2 + 36*D1*Dd*K*f**2*r**2 + 72*D1*Dd*K*f**2*r*s - 54*D1*Dd*K*f**2*r + 36*D1*Dd*K*f**2*s**2 - 54*D1*Dd*K*f**2*s + 27*D1*Dd*K*f**2 + 1440*D1*Dd*K*f*fd*r**2 + 2880*D1*Dd*K*f*fd*r*s - 1800*D1*Dd*K*f*fd*r + 1440*D1*Dd*K*f*fd*s**2 - 1800*D1*Dd*K*f*fd*s + 540*D1*Dd*K*f*fd - 120*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 180*D1*Dd*f**3*s - 90*D1*Dd*f**3 + 600*D1*Dd*f**2*r**2 + 1200*D1*Dd*f**2*r*s - 900*D1*Dd*f**2*r + 600*D1*Dd*f**2*s**2 - 900*D1*Dd*f**2*s + 450*D1*Dd*f**2 - 2880*D1*Dd*f*fd*r**2 - 5760*D1*Dd*f*fd*r*s + 3600*D1*Dd*f*fd*r - 2880*D1*Dd*f*fd*s**2 + 3600*D1*Dd*f*fd*s - 1080*D1*Dd*f*fd + 1288*D1*Dd*f*g2*r**2 + 2576*D1*Dd*f*g2*r*s - 1932*D1*Dd*f*g2*r + 1288*D1*Dd*f*g2*s**2 - 1932*D1*Dd*f*g2*s + 966*D1*Dd*f*g2 - 2688*D1*Dd*f*gd2*r**2 - 5376*D1*Dd*f*gd2*r*s + 4704*D1*Dd*f*gd2*r - 2688*D1*Dd*f*gd2*s**2 + 4704*D1*Dd*f*gd2*s - 2016*D1*Dd*f*gd2 - 2688*D1*Dd*fd*g2*r**2 - 5376*D1*Dd*fd*g2*r*s + 2016*D1*Dd*fd*g2*r - 2688*D1*Dd*fd*g2*s**2 + 2016*D1*Dd*fd*g2*s + 360*D1*Ddd*K*f**2*r**2 + 720*D1*Ddd*K*f**2*r*s - 540*D1*Ddd*K*f**2*r + 360*D1*Ddd*K*f**2*s**2 - 540*D1*Ddd*K*f**2*s + 270*D1*Ddd*K*f**2 - 720*D1*Ddd*f**2*r**2 - 1440*D1*Ddd*f**2*r*s + 1080*D1*Ddd*f**2*r - 720*D1*Ddd*f**2*s**2 + 1080*D1*Ddd*f**2*s - 540*D1*Ddd*f**2 - 1344*D1*Ddd*f*g2*r**2 - 2688*D1*Ddd*f*g2*r*s + 2016*D1*Ddd*f*g2*r - 1344*D1*Ddd*f*g2*s**2 + 2016*D1*Ddd*f*g2*s - 1008*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(108*f**2*(r + s - 1) - 150*f*fd*(2*r + 2*s - 1) - 7*f*(23*K - 9)*(r + s - 1) + 168*fd*(2*K - 1)*(r + s)) - 6*Dd*f*(-56*K + 25*f + 28)*(4*r + 4*s - 3))*(r + s - 1) + 1080*Dd**2*K*f**2*r**2 + 2160*Dd**2*K*f**2*r*s - 1620*Dd**2*K*f**2*r + 1080*Dd**2*K*f**2*s**2 - 1620*Dd**2*K*f**2*s + 540*Dd**2*K*f**2 - 2160*Dd**2*f**2*r**2 - 4320*Dd**2*f**2*r*s + 3240*Dd**2*f**2*r - 2160*Dd**2*f**2*s**2 + 3240*Dd**2*f**2*s - 1080*Dd**2*f**2 - 4032*Dd**2*f*g2*r**2 - 8064*Dd**2*f*g2*r*s + 6048*Dd**2*f*g2*r - 4032*Dd**2*f*g2*s**2 + 6048*Dd**2*f*g2*s - 2016*Dd**2*f*g2))/(210*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**4*k1**2*k2**2*st**2*(252*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 6*D1*bd1*(D1*(5*f**3*(19*r**2 + r*(38*s - 28) + 19*s**2 - 28*s + 14) + f**2*(-25*fd*(15*r**2 + r*(30*s - 23) + 15*s**2 - 23*s + 8) + 6*r**2*(6*C + 7) + 12*r*(s*(6*C + 7) - 13) + 6*s**2*(6*C + 7) - 156*s + 78) - 24*f*fd*(r + s - 1)*(r*(3*C + 7) + s*(3*C + 7) - 5) + 84*f*(r + s)*(-g2*(r + s) + gd2*(r + s - 1)) + 84*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(25*f**2*(5*r + 5*s - 4) + 12*f*(3*C*s + r*(3*C + 7) + 7*s - 10) - 84*g2*(r + s))) - 126*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(144*C*D1**2*f*fd*r**2 + 288*C*D1**2*f*fd*r*s - 288*C*D1**2*f*fd*r + 144*C*D1**2*f*fd*s**2 - 288*C*D1**2*f*fd*s + 144*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r**2 - 144*C*D1**2*f*fdd*r*s + 144*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s**2 + 144*C*D1**2*f*fdd*s - 72*C*D1**2*f*fdd - 72*C*D1**2*fd**2*r**2 - 144*C*D1**2*fd**2*r*s + 144*C*D1**2*fd**2*r - 72*C*D1**2*fd**2*s**2 + 144*C*D1**2*fd**2*s - 72*C*D1**2*fd**2 + 288*C*D1*Dd*f**2*r**2 + 576*C*D1*Dd*f**2*r*s - 432*C*D1*Dd*f**2*r + 288*C*D1*Dd*f**2*s**2 - 432*C*D1*Dd*f**2*s + 216*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r**2 - 1152*C*D1*Dd*f*fd*r*s + 1008*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 1008*C*D1*Dd*f*fd*s - 432*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r**2 - 288*C*D1*Ddd*f**2*r*s + 216*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 216*C*D1*Ddd*f**2*s - 108*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r**2 - 864*C*Dd**2*f**2*r*s + 648*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 648*C*Dd**2*f**2*s - 216*C*Dd**2*f**2 - 42*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 570*D1**2*f**2*fd*r**2 + 1140*D1**2*f**2*fd*r*s - 860*D1**2*f**2*fd*r + 570*D1**2*f**2*fd*s**2 - 860*D1**2*f**2*fd*s + 430*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 750*D1**2*f**2*fdd*r*s + 550*D1**2*f**2*fdd*r - 375*D1**2*f**2*fdd*s**2 + 550*D1**2*f**2*fdd*s - 275*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 1500*D1**2*f*fd**2*r*s + 1100*D1**2*f*fd**2*r - 750*D1**2*f*fd**2*s**2 + 1100*D1**2*f*fd**2*s - 350*D1**2*f*fd**2 + 168*D1**2*f*fd*r**2 + 336*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 168*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 12*D1**2*f*fd - 168*D1**2*f*fdd*r**2 - 336*D1**2*f*fdd*r*s + 96*D1**2*f*fdd*r - 168*D1**2*f*fdd*s**2 + 96*D1**2*f*fdd*s - 48*D1**2*f*fdd - 168*D1**2*f*gd2*r**2 - 336*D1**2*f*gd2*r*s + 336*D1**2*f*gd2*r - 168*D1**2*f*gd2*s**2 + 336*D1**2*f*gd2*s - 168*D1**2*f*gd2 + 84*D1**2*f*gdd2*r**2 + 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*r + 84*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s + 84*D1**2*f*gdd2 - 168*D1**2*fd**2*r**2 - 336*D1**2*fd**2*r*s + 96*D1**2*fd**2*r - 168*D1**2*fd**2*s**2 + 96*D1**2*fd**2*s + 72*D1**2*fd**2 - 168*D1**2*fd*g2*r**2 - 336*D1**2*fd*g2*r*s + 336*D1**2*fd*g2*r - 168*D1**2*fd*g2*s**2 + 336*D1**2*fd*g2*s - 168*D1**2*fd*g2 + 168*D1**2*fd*gd2*r**2 + 336*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 336*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 + 84*D1**2*fdd*g2*r**2 + 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r + 84*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 + 760*D1*Dd*f**3*r**2 + 1520*D1*Dd*f**3*r*s - 1140*D1*Dd*f**3*r + 760*D1*Dd*f**3*s**2 - 1140*D1*Dd*f**3*s + 570*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 6000*D1*Dd*f**2*fd*r*s + 4450*D1*Dd*f**2*fd*r - 3000*D1*Dd*f**2*fd*s**2 + 4450*D1*Dd*f**2*fd*s - 1650*D1*Dd*f**2*fd + 336*D1*Dd*f**2*r**2 + 672*D1*Dd*f**2*r*s - 504*D1*Dd*f**2*r + 336*D1*Dd*f**2*s**2 - 504*D1*Dd*f**2*s + 252*D1*Dd*f**2 - 1344*D1*Dd*f*fd*r**2 - 2688*D1*Dd*f*fd*r*s + 1392*D1*Dd*f*fd*r - 1344*D1*Dd*f*fd*s**2 + 1392*D1*Dd*f*fd*s - 288*D1*Dd*f*fd - 672*D1*Dd*f*g2*r**2 - 1344*D1*Dd*f*g2*r*s + 1008*D1*Dd*f*g2*r - 672*D1*Dd*f*g2*s**2 + 1008*D1*Dd*f*g2*s - 504*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r**2 + 1344*D1*Dd*f*gd2*r*s - 1176*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 1176*D1*Dd*f*gd2*s + 504*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r**2 + 1344*D1*Dd*fd*g2*r*s - 1176*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 1176*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 - 500*D1*Ddd*f**3*r**2 - 1000*D1*Ddd*f**3*r*s + 750*D1*Ddd*f**3*r - 500*D1*Ddd*f**3*s**2 + 750*D1*Ddd*f**3*s - 375*D1*Ddd*f**3 - 336*D1*Ddd*f**2*r**2 - 672*D1*Ddd*f**2*r*s + 504*D1*Ddd*f**2*r - 336*D1*Ddd*f**2*s**2 + 504*D1*Ddd*f**2*s - 252*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r**2 + 672*D1*Ddd*f*g2*r*s - 504*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 504*D1*Ddd*f*g2*s + 252*D1*Ddd*f*g2 + 84*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 1500*Dd**2*f**3*r**2 - 3000*Dd**2*f**3*r*s + 2250*Dd**2*f**3*r - 1500*Dd**2*f**3*s**2 + 2250*Dd**2*f**3*s - 750*Dd**2*f**3 - 1008*Dd**2*f**2*r**2 - 2016*Dd**2*f**2*r*s + 1512*Dd**2*f**2*r - 1008*Dd**2*f**2*s**2 + 1512*Dd**2*f**2*s - 504*Dd**2*f**2 + 1008*Dd**2*f*g2*r**2 + 2016*Dd**2*f*g2*r*s - 1512*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1512*Dd**2*f*g2*s + 504*Dd**2*f*g2) + f*(3*D1**2*bdd1*(25*f**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 4) + 12*f*(r**2*(3*C + 7) + 2*r*(s*(3*C + 7) - 10) + s**2*(3*C + 7) - 20*s + 10) - 84*g2*(r + s)**2) - 4*D1**2*(f*(73*fd - 50*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 100*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 4*D1*f*(Dd*(73*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 100*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 50*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 1200*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**4*k1**2*k2**2*(-120*C*D1**2*bdd1*f**2*r**2 - 240*C*D1**2*bdd1*f**2*r*s - 120*C*D1**2*bdd1*f**2*s**2 - 390*C*D1**2*f**2*fd*r**2 - 780*C*D1**2*f**2*fd*r*s + 520*C*D1**2*f**2*fd*r - 390*C*D1**2*f**2*fd*s**2 + 520*C*D1**2*f**2*fd*s - 260*C*D1**2*f**2*fd + 420*C*D1**2*f**2*fdd*r**2 + 840*C*D1**2*f**2*fdd*r*s - 560*C*D1**2*f**2*fdd*r + 420*C*D1**2*f**2*fdd*s**2 - 560*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 840*C*D1**2*f*fd**2*r**2 + 1680*C*D1**2*f*fd**2*r*s - 1120*C*D1**2*f*fd**2*r + 840*C*D1**2*f*fd**2*s**2 - 1120*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 520*C*D1*Dd*f**3*r**2 - 1040*C*D1*Dd*f**3*r*s + 780*C*D1*Dd*f**3*r - 520*C*D1*Dd*f**3*s**2 + 780*C*D1*Dd*f**3*s - 390*C*D1*Dd*f**3 + 3360*C*D1*Dd*f**2*fd*r**2 + 6720*C*D1*Dd*f**2*fd*r*s - 4760*C*D1*Dd*f**2*fd*r + 3360*C*D1*Dd*f**2*fd*s**2 - 4760*C*D1*Dd*f**2*fd*s + 1680*C*D1*Dd*f**2*fd + 560*C*D1*Ddd*f**3*r**2 + 1120*C*D1*Ddd*f**3*r*s - 840*C*D1*Ddd*f**3*r + 560*C*D1*Ddd*f**3*s**2 - 840*C*D1*Ddd*f**3*s + 420*C*D1*Ddd*f**3 + 1680*C*Dd**2*f**3*r**2 + 3360*C*Dd**2*f**3*r*s - 2520*C*Dd**2*f**3*r + 1680*C*Dd**2*f**3*s**2 - 2520*C*Dd**2*f**3*s + 840*C*Dd**2*f**3 + 90*D1**2*K*bdd1*f**2*r**2 + 180*D1**2*K*bdd1*f**2*r*s - 180*D1**2*K*bdd1*f**2*r + 90*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s + 90*D1**2*K*bdd1*f**2 - 150*D1**2*b2*f*fd*r**2 - 300*D1**2*b2*f*fd*r*s + 150*D1**2*b2*f*fd*r - 150*D1**2*b2*f*fd*s**2 + 150*D1**2*b2*f*fd*s - 75*D1**2*b2*f*fd + 180*D1**2*b2*f*fdd*r**2 + 360*D1**2*b2*f*fdd*r*s - 180*D1**2*b2*f*fdd*r + 180*D1**2*b2*f*fdd*s**2 - 180*D1**2*b2*f*fdd*s + 90*D1**2*b2*f*fdd + 180*D1**2*b2*fd**2*r**2 + 360*D1**2*b2*fd**2*r*s - 180*D1**2*b2*fd**2*r + 180*D1**2*b2*fd**2*s**2 - 180*D1**2*b2*fd**2*s - 4*D1**2*bd1**2*(r + s - 1)*(15*f**2*(r + s - 2) + 21*f*(C*(r + s) + 2*K*(r + s) - 2) - 35*g2*(r + s)) - 75*D1**2*bd2*f**2*r**2 - 150*D1**2*bd2*f**2*r*s + 150*D1**2*bd2*f**2*r - 75*D1**2*bd2*f**2*s**2 + 150*D1**2*bd2*f**2*s - 75*D1**2*bd2*f**2 + 360*D1**2*bd2*f*fd*r**2 + 720*D1**2*bd2*f*fd*r*s - 540*D1**2*bd2*f*fd*r + 360*D1**2*bd2*f*fd*s**2 - 540*D1**2*bd2*f*fd*s + 180*D1**2*bd2*f*fd + 30*D1**2*bdd1*f**2*r**2 + 60*D1**2*bdd1*f**2*r*s + 120*D1**2*bdd1*f**2*r + 30*D1**2*bdd1*f**2*s**2 + 120*D1**2*bdd1*f**2*s - 60*D1**2*bdd1*f**2 + 168*D1**2*bdd1*f*g2*r**2 + 336*D1**2*bdd1*f*g2*r*s + 168*D1**2*bdd1*f*g2*s**2 + 90*D1**2*bdd2*f**2*r**2 + 180*D1**2*bdd2*f**2*r*s - 180*D1**2*bdd2*f**2*r + 90*D1**2*bdd2*f**2*s**2 - 180*D1**2*bdd2*f**2*s + 90*D1**2*bdd2*f**2 + 105*D1**2*f**2*fd*r**2 + 210*D1**2*f**2*fd*r*s - 140*D1**2*f**2*fd*r + 105*D1**2*f**2*fd*s**2 - 140*D1**2*f**2*fd*s + 70*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 280*D1**2*f**2*fdd*r - 210*D1**2*f**2*fdd*s**2 + 280*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd + 150*D1**2*f**2*gd2*r**2 + 300*D1**2*f**2*gd2*r*s - 300*D1**2*f**2*gd2*r + 150*D1**2*f**2*gd2*s**2 - 300*D1**2*f**2*gd2*s + 150*D1**2*f**2*gd2 - 180*D1**2*f**2*gdd2*r**2 - 360*D1**2*f**2*gdd2*r*s + 360*D1**2*f**2*gdd2*r - 180*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s - 180*D1**2*f**2*gdd2 - 420*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 560*D1**2*f*fd**2*r - 420*D1**2*f*fd**2*s**2 + 560*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 300*D1**2*f*fd*g2*r**2 + 600*D1**2*f*fd*g2*r*s - 300*D1**2*f*fd*g2*r + 300*D1**2*f*fd*g2*s**2 - 300*D1**2*f*fd*g2*s + 150*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*r**2 - 1440*D1**2*f*fd*gd2*r*s + 1080*D1**2*f*fd*gd2*r - 720*D1**2*f*fd*gd2*s**2 + 1080*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 360*D1**2*f*fdd*g2*r**2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r - 360*D1**2*f*fdd*g2*s**2 + 360*D1**2*f*fdd*g2*s - 180*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*r**2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r - 360*D1**2*fd**2*g2*s**2 + 360*D1**2*fd**2*g2*s - 300*D1*Dd*b2*f**2*r**2 - 600*D1*Dd*b2*f**2*r*s + 450*D1*Dd*b2*f**2*r - 300*D1*Dd*b2*f**2*s**2 + 450*D1*Dd*b2*f**2*s - 225*D1*Dd*b2*f**2 + 1440*D1*Dd*b2*f*fd*r**2 + 2880*D1*Dd*b2*f*fd*r*s - 1800*D1*Dd*b2*f*fd*r + 1440*D1*Dd*b2*f*fd*s**2 - 1800*D1*Dd*b2*f*fd*s + 540*D1*Dd*b2*f*fd + 720*D1*Dd*bd2*f**2*r**2 + 1440*D1*Dd*bd2*f**2*r*s - 1260*D1*Dd*bd2*f**2*r + 720*D1*Dd*bd2*f**2*s**2 - 1260*D1*Dd*bd2*f**2*s + 540*D1*Dd*bd2*f**2 + 140*D1*Dd*f**3*r**2 + 280*D1*Dd*f**3*r*s - 210*D1*Dd*f**3*r + 140*D1*Dd*f**3*s**2 - 210*D1*Dd*f**3*s + 105*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2380*D1*Dd*f**2*fd*r - 1680*D1*Dd*f**2*fd*s**2 + 2380*D1*Dd*f**2*fd*s - 840*D1*Dd*f**2*fd + 600*D1*Dd*f**2*g2*r**2 + 1200*D1*Dd*f**2*g2*r*s - 900*D1*Dd*f**2*g2*r + 600*D1*Dd*f**2*g2*s**2 - 900*D1*Dd*f**2*g2*s + 450*D1*Dd*f**2*g2 - 1440*D1*Dd*f**2*gd2*r**2 - 2880*D1*Dd*f**2*gd2*r*s + 2520*D1*Dd*f**2*gd2*r - 1440*D1*Dd*f**2*gd2*s**2 + 2520*D1*Dd*f**2*gd2*s - 1080*D1*Dd*f**2*gd2 - 2880*D1*Dd*f*fd*g2*r**2 - 5760*D1*Dd*f*fd*g2*r*s + 3600*D1*Dd*f*fd*g2*r - 2880*D1*Dd*f*fd*g2*s**2 + 3600*D1*Dd*f*fd*g2*s - 1080*D1*Dd*f*fd*g2 + 360*D1*Ddd*b2*f**2*r**2 + 720*D1*Ddd*b2*f**2*r*s - 540*D1*Ddd*b2*f**2*r + 360*D1*Ddd*b2*f**2*s**2 - 540*D1*Ddd*b2*f**2*s + 270*D1*Ddd*b2*f**2 - 280*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s**2 + 420*D1*Ddd*f**3*s - 210*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*r**2 - 1440*D1*Ddd*f**2*g2*r*s + 1080*D1*Ddd*f**2*g2*r - 720*D1*Ddd*f**2*g2*s**2 + 1080*D1*Ddd*f**2*g2*s - 540*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-15*f**3*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*f**2*(25*K*(r + s - 1)**2 - 2*r**2*(5*C + 4) - 4*r*(s*(5*C + 4) - 6) - 2*s**2*(5*C + 4) + 24*s - 12) + 2*f*(30*fd*(r + s - 1)*(-8*C*r - 8*C*s + K*(6*r + 6*s - 3) + 2*r + 2*s + 2) + (7*r + 7*s)*(g2*(r + s) + 24*gd2*(r + s - 1))) + 336*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 12*Dd*f*(5*f*(-4*C*r - 4*C*s + 3*K*(r + s - 1) + r + s + 2) + 28*g2*(r + s))*(4*r + 4*s - 3)) + 1080*Dd**2*b2*f**2*r**2 + 2160*Dd**2*b2*f**2*r*s - 1620*Dd**2*b2*f**2*r + 1080*Dd**2*b2*f**2*s**2 - 1620*Dd**2*b2*f**2*s + 540*Dd**2*b2*f**2 - 840*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 840*Dd**2*f**3*s**2 + 1260*Dd**2*f**3*s - 420*Dd**2*f**3 - 2160*Dd**2*f**2*g2*r**2 - 4320*Dd**2*f**2*g2*r*s + 3240*Dd**2*f**2*g2*r - 2160*Dd**2*f**2*g2*s**2 + 3240*Dd**2*f**2*g2*s - 1080*Dd**2*f**2*g2 + 35*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(84*C*D1**2*fd*r**2 + 168*C*D1**2*fd*r*s - 168*C*D1**2*fd*r + 84*C*D1**2*fd*s**2 - 168*C*D1**2*fd*s + 84*C*D1**2*fd - 42*C*D1**2*fdd*r**2 - 84*C*D1**2*fdd*r*s + 84*C*D1**2*fdd*r - 42*C*D1**2*fdd*s**2 + 84*C*D1**2*fdd*s - 42*C*D1**2*fdd + 336*C*D1*Dd*f*r**2 + 672*C*D1*Dd*f*r*s - 504*C*D1*Dd*f*r + 336*C*D1*Dd*f*s**2 - 504*C*D1*Dd*f*s + 252*C*D1*Dd*f - 336*C*D1*Dd*fd*r**2 - 672*C*D1*Dd*fd*r*s + 588*C*D1*Dd*fd*r - 336*C*D1*Dd*fd*s**2 + 588*C*D1*Dd*fd*s - 252*C*D1*Dd*fd - 168*C*D1*Ddd*f*r**2 - 336*C*D1*Ddd*f*r*s + 252*C*D1*Ddd*f*r - 168*C*D1*Ddd*f*s**2 + 252*C*D1*Ddd*f*s - 126*C*D1*Ddd*f - 504*C*Dd**2*f*r**2 - 1008*C*Dd**2*f*r*s + 756*C*Dd**2*f*r - 504*C*Dd**2*f*s**2 + 756*C*Dd**2*f*s - 252*C*Dd**2*f - 7*D1**2*K*fd*r**2 - 14*D1**2*K*fd*r*s + 14*D1**2*K*fd*r - 7*D1**2*K*fd*s**2 + 14*D1**2*K*fd*s - 7*D1**2*K*fd - 84*D1**2*K*fdd*r**2 - 168*D1**2*K*fdd*r*s + 168*D1**2*K*fdd*r - 84*D1**2*K*fdd*s**2 + 168*D1**2*K*fdd*s - 84*D1**2*K*fdd - 35*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 120*D1**2*f*fd*r**2 + 240*D1**2*f*fd*r*s - 84*D1**2*f*fd*r + 120*D1**2*f*fd*s**2 - 84*D1**2*f*fd*s + 42*D1**2*f*fd - 60*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*s**2 - 60*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s - 60*D1**2*fd**2*s**2 + 60*D1**2*fd**2 + 35*D1**2*fd*r**2 + 70*D1**2*fd*r*s + 126*D1**2*fd*r + 35*D1**2*fd*s**2 + 126*D1**2*fd*s - 63*D1**2*fd - 168*D1**2*fdd*r - 168*D1**2*fdd*s + 84*D1**2*fdd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 + 70*D1**2*gdd2*r**2 + 140*D1**2*gdd2*r*s - 140*D1**2*gdd2*r + 70*D1**2*gdd2*s**2 - 140*D1**2*gdd2*s + 70*D1**2*gdd2 - 28*D1*Dd*K*f*r**2 - 56*D1*Dd*K*f*r*s + 42*D1*Dd*K*f*r - 28*D1*Dd*K*f*s**2 + 42*D1*Dd*K*f*s - 21*D1*Dd*K*f - 672*D1*Dd*K*fd*r**2 - 1344*D1*Dd*K*fd*r*s + 1176*D1*Dd*K*fd*r - 672*D1*Dd*K*fd*s**2 + 1176*D1*Dd*K*fd*s - 504*D1*Dd*K*fd + 240*D1*Dd*f**2*r**2 + 480*D1*Dd*f**2*r*s - 360*D1*Dd*f**2*r + 240*D1*Dd*f**2*s**2 - 360*D1*Dd*f**2*s + 180*D1*Dd*f**2 - 480*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s + 140*D1*Dd*f*r**2 + 280*D1*Dd*f*r*s - 210*D1*Dd*f*r + 140*D1*Dd*f*s**2 - 210*D1*Dd*f*s + 105*D1*Dd*f - 672*D1*Dd*fd*r - 672*D1*Dd*fd*s + 504*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 + 1120*D1*Dd*gd2*r*s - 980*D1*Dd*gd2*r + 560*D1*Dd*gd2*s**2 - 980*D1*Dd*gd2*s + 420*D1*Dd*gd2 - 336*D1*Ddd*K*f*r**2 - 672*D1*Ddd*K*f*r*s + 504*D1*Ddd*K*f*r - 336*D1*Ddd*K*f*s**2 + 504*D1*Ddd*K*f*s - 252*D1*Ddd*K*f - 120*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 90*D1*Ddd*f**2 + 280*D1*Ddd*g2*r**2 + 560*D1*Ddd*g2*r*s - 420*D1*Ddd*g2*r + 280*D1*Ddd*g2*s**2 - 420*D1*Ddd*g2*s + 210*D1*Ddd*g2 + 70*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 1008*Dd**2*K*f*r**2 - 2016*Dd**2*K*f*r*s + 1512*Dd**2*K*f*r - 1008*Dd**2*K*f*s**2 + 1512*Dd**2*K*f*s - 504*Dd**2*K*f - 360*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 540*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 180*Dd**2*f**2 + 840*Dd**2*g2*r**2 + 1680*Dd**2*g2*r*s - 1260*Dd**2*g2*r + 840*Dd**2*g2*s**2 - 1260*Dd**2*g2*s + 420*Dd**2*g2) + b1*(60*C*D1**2*f*fd*r**2 + 120*C*D1**2*f*fd*r*s - 120*C*D1**2*f*fd*r + 60*C*D1**2*f*fd*s**2 - 120*C*D1**2*f*fd*s + 60*C*D1**2*f*fd - 240*C*D1**2*f*fdd*r**2 - 480*C*D1**2*f*fdd*r*s + 480*C*D1**2*f*fdd*r - 240*C*D1**2*f*fdd*s**2 + 480*C*D1**2*f*fdd*s - 240*C*D1**2*f*fdd - 240*C*D1**2*fd**2*r**2 - 480*C*D1**2*fd**2*r*s + 480*C*D1**2*fd**2*r - 240*C*D1**2*fd**2*s**2 + 480*C*D1**2*fd**2*s - 240*C*D1**2*fd**2 + 120*C*D1*Dd*f**2*r**2 + 240*C*D1*Dd*f**2*r*s - 180*C*D1*Dd*f**2*r + 120*C*D1*Dd*f**2*s**2 - 180*C*D1*Dd*f**2*s + 90*C*D1*Dd*f**2 - 1920*C*D1*Dd*f*fd*r**2 - 3840*C*D1*Dd*f*fd*r*s + 3360*C*D1*Dd*f*fd*r - 1920*C*D1*Dd*f*fd*s**2 + 3360*C*D1*Dd*f*fd*s - 1440*C*D1*Dd*f*fd - 480*C*D1*Ddd*f**2*r**2 - 960*C*D1*Ddd*f**2*r*s + 720*C*D1*Ddd*f**2*r - 480*C*D1*Ddd*f**2*s**2 + 720*C*D1*Ddd*f**2*s - 360*C*D1*Ddd*f**2 - 1440*C*Dd**2*f**2*r**2 - 2880*C*Dd**2*f**2*r*s + 2160*C*Dd**2*f**2*r - 1440*C*Dd**2*f**2*s**2 + 2160*C*Dd**2*f**2*s - 720*C*Dd**2*f**2 - 150*D1**2*K*f*fd*r**2 - 300*D1**2*K*f*fd*r*s + 150*D1**2*K*f*fd*r - 150*D1**2*K*f*fd*s**2 + 150*D1**2*K*f*fd*s - 75*D1**2*K*f*fd + 180*D1**2*K*f*fdd*r**2 + 360*D1**2*K*f*fdd*r*s - 180*D1**2*K*f*fdd*r + 180*D1**2*K*f*fdd*s**2 - 180*D1**2*K*f*fdd*s + 90*D1**2*K*f*fdd + 180*D1**2*K*fd**2*r**2 + 360*D1**2*K*fd**2*r*s - 180*D1**2*K*fd**2*r + 180*D1**2*K*fd**2*s**2 - 180*D1**2*K*fd**2*s - 70*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2*D1**2*bdd1*(15*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + 21*f*(C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 4*r - 4*s + 2) - 35*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 135*D1**2*f**2*fd*r**2 - 270*D1**2*f**2*fd*r*s + 210*D1**2*f**2*fd*r - 135*D1**2*f**2*fd*s**2 + 210*D1**2*f**2*fd*s - 105*D1**2*f**2*fd + 48*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 12*D1**2*f*fd + 60*D1**2*f*fdd*r**2 + 120*D1**2*f*fdd*r*s - 240*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 - 240*D1**2*f*fdd*s + 120*D1**2*f*fdd + 14*D1**2*f*gd2*r**2 + 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*r + 14*D1**2*f*gd2*s**2 - 28*D1**2*f*gd2*s + 14*D1**2*f*gd2 + 168*D1**2*f*gdd2*r**2 + 336*D1**2*f*gdd2*r*s - 336*D1**2*f*gdd2*r + 168*D1**2*f*gdd2*s**2 - 336*D1**2*f*gdd2*s + 168*D1**2*f*gdd2 + 60*D1**2*fd**2*r**2 + 120*D1**2*fd**2*r*s - 240*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 240*D1**2*fd**2*s + 180*D1**2*fd**2 + 14*D1**2*fd*g2*r**2 + 28*D1**2*fd*g2*r*s - 28*D1**2*fd*g2*r + 14*D1**2*fd*g2*s**2 - 28*D1**2*fd*g2*s + 14*D1**2*fd*g2 + 336*D1**2*fd*gd2*r**2 + 672*D1**2*fd*gd2*r*s - 672*D1**2*fd*gd2*r + 336*D1**2*fd*gd2*s**2 - 672*D1**2*fd*gd2*s + 336*D1**2*fd*gd2 + 168*D1**2*fdd*g2*r**2 + 336*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*r + 168*D1**2*fdd*g2*s**2 - 336*D1**2*fdd*g2*s + 168*D1**2*fdd*g2 - 300*D1*Dd*K*f**2*r**2 - 600*D1*Dd*K*f**2*r*s + 450*D1*Dd*K*f**2*r - 300*D1*Dd*K*f**2*s**2 + 450*D1*Dd*K*f**2*s - 225*D1*Dd*K*f**2 + 1440*D1*Dd*K*f*fd*r**2 + 2880*D1*Dd*K*f*fd*r*s - 1800*D1*Dd*K*f*fd*r + 1440*D1*Dd*K*f*fd*s**2 - 1800*D1*Dd*K*f*fd*s + 540*D1*Dd*K*f*fd - 180*D1*Dd*f**3*r**2 - 360*D1*Dd*f**3*r*s + 270*D1*Dd*f**3*r - 180*D1*Dd*f**3*s**2 + 270*D1*Dd*f**3*s - 135*D1*Dd*f**3 + 96*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s - 144*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 144*D1*Dd*f**2*s + 72*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 + 960*D1*Dd*f*fd*r*s - 1320*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 1320*D1*Dd*f*fd*s + 720*D1*Dd*f*fd + 56*D1*Dd*f*g2*r**2 + 112*D1*Dd*f*g2*r*s - 84*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s**2 - 84*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 + 1344*D1*Dd*f*gd2*r**2 + 2688*D1*Dd*f*gd2*r*s - 2352*D1*Dd*f*gd2*r + 1344*D1*Dd*f*gd2*s**2 - 2352*D1*Dd*f*gd2*s + 1008*D1*Dd*f*gd2 + 1344*D1*Dd*fd*g2*r**2 + 2688*D1*Dd*fd*g2*r*s - 2352*D1*Dd*fd*g2*r + 1344*D1*Dd*fd*g2*s**2 - 2352*D1*Dd*fd*g2*s + 1008*D1*Dd*fd*g2 + 360*D1*Ddd*K*f**2*r**2 + 720*D1*Ddd*K*f**2*r*s - 540*D1*Ddd*K*f**2*r + 360*D1*Ddd*K*f**2*s**2 - 540*D1*Ddd*K*f**2*s + 270*D1*Ddd*K*f**2 + 120*D1*Ddd*f**2*r**2 + 240*D1*Ddd*f**2*r*s - 180*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 180*D1*Ddd*f**2*s + 90*D1*Ddd*f**2 + 672*D1*Ddd*f*g2*r**2 + 1344*D1*Ddd*f*g2*r*s - 1008*D1*Ddd*f*g2*r + 672*D1*Ddd*f*g2*s**2 - 1008*D1*Ddd*f*g2*s + 504*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(20*r**2 + r*(40*s - 46) + 20*s**2 - 46*s + 23) + f*(84*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*K*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 120*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 70*r**2 + 140*r*s - 266*r + 70*s**2 - 266*s + 133) - 84*fd*(r + s - 1)*(C*(2*r + 2*s - 1) + K*(4*r + 4*s - 2) + 2) - 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(4*r + 4*s - 3)*(15*f**2*(2*r + 2*s - 3) + 21*f*(C*(2*r + 2*s - 1) + K*(4*r + 4*s - 2) - 2) - 35*g2*(2*r + 2*s - 1))) + 1080*Dd**2*K*f**2*r**2 + 2160*Dd**2*K*f**2*r*s - 1620*Dd**2*K*f**2*r + 1080*Dd**2*K*f**2*s**2 - 1620*Dd**2*K*f**2*s + 540*Dd**2*K*f**2 + 360*Dd**2*f**2*r**2 + 720*Dd**2*f**2*r*s - 540*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 540*Dd**2*f**2*s + 180*Dd**2*f**2 + 2016*Dd**2*f*g2*r**2 + 4032*Dd**2*f*g2*r*s - 3024*Dd**2*f*g2*r + 2016*Dd**2*f*g2*s**2 - 3024*Dd**2*f*g2*s + 1008*Dd**2*f*g2))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**4*k1**2*(3*D1*f*(r + s)*(2*D1*bd1**2*(5*f + 7)*(r + s - 1) + 5*D1*bdd1*f*(r + s) + bd1*(-3*D1*f*(r + s) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(30*fd**2 - fd*(18*f + 7) + fdd*(30*f + 21))*(r + s - 1)**2 + D1*(Dd*(-9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(60*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 28*r**2 - 56*r*s + 42*r - 28*s**2 + 42*s - 21) + 42*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*Ddd*f*(5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f*(5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(3*D1**2*bdd1*f*(5*f + 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*D1**2*(r + s - 1)**2*(3*f*fd - 5*f*fdd - 5*fd**2) + D1*bd1*(D1*(-9*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(60*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 14*r**2 - 28*r*s + 14*r - 14*s**2 + 14*s - 7) + 42*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*Dd*f*(5*f + 7)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 3*D1*f*(Dd*(-3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 20*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(105*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**4*k2**6*st**2*(D1**2*(f**2*(-fd*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(9*K*(-2*bd1 + bdd1) + 36*gd2 - 18*gdd2)) + f*(fd**2*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 18*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 18*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(-2*Dd*(f**2*(10*C - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(5 - 10*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 18*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 18*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 9*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + Ddd*f*(10*C*f + 9*K*b1 - 5*f - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f**2*(10*C*f + 9*K*b1 - 5*f - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(42*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**4*k2**6*(40*C*D1**2*b1*f*fd*r**2 + 80*C*D1**2*b1*f*fd*r*s - 40*C*D1**2*b1*f*fd*r + 40*C*D1**2*b1*f*fd*s**2 - 40*C*D1**2*b1*f*fd*s + 20*C*D1**2*b1*f*fd - 20*C*D1**2*b1*f*fdd*r**2 - 40*C*D1**2*b1*f*fdd*r*s + 20*C*D1**2*b1*f*fdd*r - 20*C*D1**2*b1*f*fdd*s**2 + 20*C*D1**2*b1*f*fdd*s - 10*C*D1**2*b1*f*fdd - 20*C*D1**2*b1*fd**2*r**2 - 40*C*D1**2*b1*fd**2*r*s + 20*C*D1**2*b1*fd**2*r - 20*C*D1**2*b1*fd**2*s**2 + 20*C*D1**2*b1*fd**2*s - 30*C*D1**2*f**2*fd*r**2 - 60*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 80*C*D1*Dd*b1*f**2*r**2 + 160*C*D1*Dd*b1*f**2*r*s - 120*C*D1*Dd*b1*f**2*r + 80*C*D1*Dd*b1*f**2*s**2 - 120*C*D1*Dd*b1*f**2*s + 60*C*D1*Dd*b1*f**2 - 160*C*D1*Dd*b1*f*fd*r**2 - 320*C*D1*Dd*b1*f*fd*r*s + 200*C*D1*Dd*b1*f*fd*r - 160*C*D1*Dd*b1*f*fd*s**2 + 200*C*D1*Dd*b1*f*fd*s - 60*C*D1*Dd*b1*f*fd - 40*C*D1*Dd*f**3*r**2 - 80*C*D1*Dd*f**3*r*s + 60*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 60*C*D1*Dd*f**3*s - 30*C*D1*Dd*f**3 - 40*C*D1*Ddd*b1*f**2*r**2 - 80*C*D1*Ddd*b1*f**2*r*s + 60*C*D1*Ddd*b1*f**2*r - 40*C*D1*Ddd*b1*f**2*s**2 + 60*C*D1*Ddd*b1*f**2*s - 30*C*D1*Ddd*b1*f**2 - 120*C*Dd**2*b1*f**2*r**2 - 240*C*Dd**2*b1*f**2*r*s + 180*C*Dd**2*b1*f**2*r - 120*C*Dd**2*b1*f**2*s**2 + 180*C*Dd**2*b1*f**2*s - 60*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r**2 + 28*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r**2 - 14*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 14*D1**2*K*bd1**2*f*(r + s - 1)**2 - 20*D1**2*b1*f*fd*r**2 - 40*D1**2*b1*f*fd*r*s + 20*D1**2*b1*f*fd*r - 20*D1**2*b1*f*fd*s**2 + 20*D1**2*b1*f*fd*s - 10*D1**2*b1*f*fd + 10*D1**2*b1*f*fdd*r**2 + 20*D1**2*b1*f*fdd*r*s - 10*D1**2*b1*f*fdd*r + 10*D1**2*b1*f*fdd*s**2 - 10*D1**2*b1*f*fdd*s + 5*D1**2*b1*f*fdd - 28*D1**2*b1*f*gd2*r**2 - 56*D1**2*b1*f*gd2*r*s + 56*D1**2*b1*f*gd2*r - 28*D1**2*b1*f*gd2*s**2 + 56*D1**2*b1*f*gd2*s - 28*D1**2*b1*f*gd2 + 14*D1**2*b1*f*gdd2*r**2 + 28*D1**2*b1*f*gdd2*r*s - 28*D1**2*b1*f*gdd2*r + 14*D1**2*b1*f*gdd2*s**2 - 28*D1**2*b1*f*gdd2*s + 14*D1**2*b1*f*gdd2 + 10*D1**2*b1*fd**2*r**2 + 20*D1**2*b1*fd**2*r*s - 10*D1**2*b1*fd**2*r + 10*D1**2*b1*fd**2*s**2 - 10*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r**2 - 56*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r**2 + 56*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*r + 28*D1**2*b1*fd*gd2*s**2 - 28*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r**2 + 28*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 14*K*b1 - 5*f - 14*g2) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r**2 + 112*D1*Dd*K*b1**2*f*r*s - 84*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 84*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r**2 - 112*D1*Dd*K*b1**2*fd*r*s + 42*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 42*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 - 40*D1*Dd*b1*f**2*r**2 - 80*D1*Dd*b1*f**2*r*s + 60*D1*Dd*b1*f**2*r - 40*D1*Dd*b1*f**2*s**2 + 60*D1*Dd*b1*f**2*s - 30*D1*Dd*b1*f**2 + 80*D1*Dd*b1*f*fd*r**2 + 160*D1*Dd*b1*f*fd*r*s - 100*D1*Dd*b1*f*fd*r + 80*D1*Dd*b1*f*fd*s**2 - 100*D1*Dd*b1*f*fd*s + 30*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r**2 - 224*D1*Dd*b1*f*g2*r*s + 168*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 168*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r**2 + 224*D1*Dd*b1*f*gd2*r*s - 196*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 196*D1*Dd*b1*f*gd2*s + 84*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r**2 + 224*D1*Dd*b1*fd*g2*r*s - 84*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 84*D1*Dd*b1*fd*g2*s + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r**2 - 56*D1*Ddd*K*b1**2*f*r*s + 42*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 42*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 20*D1*Ddd*b1*f**2*r**2 + 40*D1*Ddd*b1*f**2*r*s - 30*D1*Ddd*b1*f**2*r + 20*D1*Ddd*b1*f**2*s**2 - 30*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r**2 + 112*D1*Ddd*b1*f*g2*r*s - 84*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 84*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(20*C - 7*K - 10)*(r + s - 1) - f*fd*(20*C - 10)*(2*r + 2*s - 1) - 28*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(10*C*f + 14*K*b1 - 5*f - 14*g2))*(r + s - 1) - 84*Dd**2*K*b1**2*f*r**2 - 168*Dd**2*K*b1**2*f*r*s + 126*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 126*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 60*Dd**2*b1*f**2*r**2 + 120*Dd**2*b1*f**2*r*s - 90*Dd**2*b1*f**2*r + 60*Dd**2*b1*f**2*s**2 - 90*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r**2 + 336*Dd**2*b1*f*g2*r*s - 252*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 252*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(70*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**4*k2**4*st**2*(60*C*D1**2*f**2*fd*r**2 + 120*C*D1**2*f**2*fd*r*s - 80*C*D1**2*f**2*fd*r + 60*C*D1**2*f**2*fd*s**2 - 80*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd - 30*C*D1**2*f**2*fdd*r**2 - 60*C*D1**2*f**2*fdd*r*s + 40*C*D1**2*f**2*fdd*r - 30*C*D1**2*f**2*fdd*s**2 + 40*C*D1**2*f**2*fdd*s - 20*C*D1**2*f**2*fdd - 60*C*D1**2*f*fd**2*r**2 - 120*C*D1**2*f*fd**2*r*s + 80*C*D1**2*f*fd**2*r - 60*C*D1**2*f*fd**2*s**2 + 80*C*D1**2*f*fd**2*s - 20*C*D1**2*f*fd**2 + 80*C*D1*Dd*f**3*r**2 + 160*C*D1*Dd*f**3*r*s - 120*C*D1*Dd*f**3*r + 80*C*D1*Dd*f**3*s**2 - 120*C*D1*Dd*f**3*s + 60*C*D1*Dd*f**3 - 240*C*D1*Dd*f**2*fd*r**2 - 480*C*D1*Dd*f**2*fd*r*s + 340*C*D1*Dd*f**2*fd*r - 240*C*D1*Dd*f**2*fd*s**2 + 340*C*D1*Dd*f**2*fd*s - 120*C*D1*Dd*f**2*fd - 40*C*D1*Ddd*f**3*r**2 - 80*C*D1*Ddd*f**3*r*s + 60*C*D1*Ddd*f**3*r - 40*C*D1*Ddd*f**3*s**2 + 60*C*D1*Ddd*f**3*s - 30*C*D1*Ddd*f**3 - 120*C*Dd**2*f**3*r**2 - 240*C*Dd**2*f**3*r*s + 180*C*Dd**2*f**3*r - 120*C*Dd**2*f**3*s**2 + 180*C*Dd**2*f**3*s - 60*C*Dd**2*f**3 + 36*D1**2*K*b1*f*fd*r**2 + 72*D1**2*K*b1*f*fd*r*s - 36*D1**2*K*b1*f*fd*r + 36*D1**2*K*b1*f*fd*s**2 - 36*D1**2*K*b1*f*fd*s + 18*D1**2*K*b1*f*fd - 18*D1**2*K*b1*f*fdd*r**2 - 36*D1**2*K*b1*f*fdd*r*s + 18*D1**2*K*b1*f*fdd*r - 18*D1**2*K*b1*f*fdd*s**2 + 18*D1**2*K*b1*f*fdd*s - 9*D1**2*K*b1*f*fdd - 18*D1**2*K*b1*fd**2*r**2 - 36*D1**2*K*b1*fd**2*r*s + 18*D1**2*K*b1*fd**2*r - 18*D1**2*K*b1*fd**2*s**2 + 18*D1**2*K*b1*fd**2*s + 18*D1**2*K*bd1*f**2*r**2 + 36*D1**2*K*bd1*f**2*r*s - 36*D1**2*K*bd1*f**2*r + 18*D1**2*K*bd1*f**2*s**2 - 36*D1**2*K*bd1*f**2*s + 18*D1**2*K*bd1*f**2 - 36*D1**2*K*bd1*f*fd*r**2 - 72*D1**2*K*bd1*f*fd*r*s + 54*D1**2*K*bd1*f*fd*r - 36*D1**2*K*bd1*f*fd*s**2 + 54*D1**2*K*bd1*f*fd*s - 18*D1**2*K*bd1*f*fd - 9*D1**2*K*bdd1*f**2*r**2 - 18*D1**2*K*bdd1*f**2*r*s + 18*D1**2*K*bdd1*f**2*r - 9*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s - 9*D1**2*K*bdd1*f**2 + 36*D1**2*b2*f*fd*r**2 + 72*D1**2*b2*f*fd*r*s - 36*D1**2*b2*f*fd*r + 36*D1**2*b2*f*fd*s**2 - 36*D1**2*b2*f*fd*s + 18*D1**2*b2*f*fd - 18*D1**2*b2*f*fdd*r**2 - 36*D1**2*b2*f*fdd*r*s + 18*D1**2*b2*f*fdd*r - 18*D1**2*b2*f*fdd*s**2 + 18*D1**2*b2*f*fdd*s - 9*D1**2*b2*f*fdd - 18*D1**2*b2*fd**2*r**2 - 36*D1**2*b2*fd**2*r*s + 18*D1**2*b2*fd**2*r - 18*D1**2*b2*fd**2*s**2 + 18*D1**2*b2*fd**2*s - 9*D1**2*bdd2*f**2*(r + s - 1)**2 - 30*D1**2*f**2*fd*r**2 - 60*D1**2*f**2*fd*r*s + 40*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 40*D1**2*f**2*fd*s - 20*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd - 36*D1**2*f**2*gd2*r**2 - 72*D1**2*f**2*gd2*r*s + 72*D1**2*f**2*gd2*r - 36*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s - 36*D1**2*f**2*gd2 + 18*D1**2*f**2*gdd2*r**2 + 36*D1**2*f**2*gdd2*r*s - 36*D1**2*f**2*gdd2*r + 18*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 18*D1**2*f**2*gdd2 + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 - 72*D1**2*f*fd*g2*r**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 72*D1**2*f*fd*g2*s - 36*D1**2*f*fd*g2 + 72*D1**2*f*fd*gd2*r**2 + 144*D1**2*f*fd*gd2*r*s - 108*D1**2*f*fd*gd2*r + 72*D1**2*f*fd*gd2*s**2 - 108*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 36*D1**2*f*fdd*g2*r**2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 36*D1**2*fd**2*g2*r**2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 72*D1*Dd*K*b1*f**2*r**2 + 144*D1*Dd*K*b1*f**2*r*s - 108*D1*Dd*K*b1*f**2*r + 72*D1*Dd*K*b1*f**2*s**2 - 108*D1*Dd*K*b1*f**2*s + 54*D1*Dd*K*b1*f**2 - 144*D1*Dd*K*b1*f*fd*r**2 - 288*D1*Dd*K*b1*f*fd*r*s + 180*D1*Dd*K*b1*f*fd*r - 144*D1*Dd*K*b1*f*fd*s**2 + 180*D1*Dd*K*b1*f*fd*s - 54*D1*Dd*K*b1*f*fd - 72*D1*Dd*K*bd1*f**2*r**2 - 144*D1*Dd*K*bd1*f**2*r*s + 126*D1*Dd*K*bd1*f**2*r - 72*D1*Dd*K*bd1*f**2*s**2 + 126*D1*Dd*K*bd1*f**2*s - 54*D1*Dd*K*bd1*f**2 + 72*D1*Dd*b2*f**2*r**2 + 144*D1*Dd*b2*f**2*r*s - 108*D1*Dd*b2*f**2*r + 72*D1*Dd*b2*f**2*s**2 - 108*D1*Dd*b2*f**2*s + 54*D1*Dd*b2*f**2 - 144*D1*Dd*b2*f*fd*r**2 - 288*D1*Dd*b2*f*fd*r*s + 180*D1*Dd*b2*f*fd*r - 144*D1*Dd*b2*f*fd*s**2 + 180*D1*Dd*b2*f*fd*s - 54*D1*Dd*b2*f*fd - 40*D1*Dd*f**3*r**2 - 80*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 60*D1*Dd*f**3*s - 30*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 170*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 170*D1*Dd*f**2*fd*s + 60*D1*Dd*f**2*fd - 144*D1*Dd*f**2*g2*r**2 - 288*D1*Dd*f**2*g2*r*s + 216*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 216*D1*Dd*f**2*g2*s - 108*D1*Dd*f**2*g2 + 144*D1*Dd*f**2*gd2*r**2 + 288*D1*Dd*f**2*gd2*r*s - 252*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s**2 - 252*D1*Dd*f**2*gd2*s + 108*D1*Dd*f**2*gd2 + 288*D1*Dd*f*fd*g2*r**2 + 576*D1*Dd*f*fd*g2*r*s - 360*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s**2 - 360*D1*Dd*f*fd*g2*s + 108*D1*Dd*f*fd*g2 - 36*D1*Ddd*K*b1*f**2*r**2 - 72*D1*Ddd*K*b1*f**2*r*s + 54*D1*Ddd*K*b1*f**2*r - 36*D1*Ddd*K*b1*f**2*s**2 + 54*D1*Ddd*K*b1*f**2*s - 27*D1*Ddd*K*b1*f**2 - 36*D1*Ddd*b2*f**2*r**2 - 72*D1*Ddd*b2*f**2*r*s + 54*D1*Ddd*b2*f**2*r - 36*D1*Ddd*b2*f**2*s**2 + 54*D1*Ddd*b2*f**2*s - 27*D1*Ddd*b2*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 72*D1*Ddd*f**2*g2*r**2 + 144*D1*Ddd*f**2*g2*r*s - 108*D1*Ddd*f**2*g2*r + 72*D1*Ddd*f**2*g2*s**2 - 108*D1*Ddd*f**2*g2*s + 54*D1*Ddd*f**2*g2 + 18*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*K*b1*f**2*r**2 - 216*Dd**2*K*b1*f**2*r*s + 162*Dd**2*K*b1*f**2*r - 108*Dd**2*K*b1*f**2*s**2 + 162*Dd**2*K*b1*f**2*s - 54*Dd**2*K*b1*f**2 - 108*Dd**2*b2*f**2*r**2 - 216*Dd**2*b2*f**2*r*s + 162*Dd**2*b2*f**2*r - 108*Dd**2*b2*f**2*s**2 + 162*Dd**2*b2*f**2*s - 54*Dd**2*b2*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 30*Dd**2*f**3 + 216*Dd**2*f**2*g2*r**2 + 432*Dd**2*f**2*g2*r*s - 324*Dd**2*f**2*g2*r + 216*Dd**2*f**2*g2*s**2 - 324*Dd**2*f**2*g2*s + 108*Dd**2*f**2*g2)/(42*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**4*k2**4*(D1*(7*K*b1**2*(D1*(2*fd - fdd)*(2*r + 2*s - 1) - 2*Dd*fd*(4*r + 4*s - 3)) + b1*(40*C*D1*f*fd*r + 40*C*D1*f*fd*s - 20*C*D1*f*fd - 20*C*D1*f*fdd*r - 20*C*D1*f*fdd*s + 10*C*D1*f*fdd - 20*C*D1*fd**2*r - 20*C*D1*fd**2*s + 20*C*D1*fd**2 - 80*C*Dd*f*fd*r - 80*C*Dd*f*fd*s + 60*C*Dd*f*fd - 28*D1*K*bd1*f*r - 28*D1*K*bd1*f*s + 14*D1*K*bd1*f - 14*D1*K*bd1*fd*r - 14*D1*K*bd1*fd*s + 14*D1*K*bd1*fd + 14*D1*K*bdd1*f*r + 14*D1*K*bdd1*f*s - 7*D1*K*bdd1*f - 14*D1*K*f*fd*r**2 - 28*D1*K*f*fd*r*s + 14*D1*K*f*fd*r - 14*D1*K*f*fd*s**2 + 14*D1*K*f*fd*s - 7*D1*K*f*fd - 7*D1*bdd2*f*(r + s - 1)**2 - 20*D1*f*fd*r - 20*D1*f*fd*s + 10*D1*f*fd + 10*D1*f*fdd*r + 10*D1*f*fdd*s - 5*D1*f*fdd + 10*D1*fd**2*r + 10*D1*fd**2*s - 10*D1*fd**2 - 56*D1*fd*g2*r - 56*D1*fd*g2*s + 28*D1*fd*g2 + 28*D1*fd*gd2*r + 28*D1*fd*gd2*s - 28*D1*fd*gd2 + 28*D1*fdd*g2*r + 28*D1*fdd*g2*s - 14*D1*fdd*g2 + 56*Dd*K*bd1*f*r + 56*Dd*K*bd1*f*s - 42*Dd*K*bd1*f - 28*Dd*K*f**2*r**2 - 56*Dd*K*f**2*r*s + 42*Dd*K*f**2*r - 28*Dd*K*f**2*s**2 + 42*Dd*K*f**2*s - 21*Dd*K*f**2 + 40*Dd*f*fd*r + 40*Dd*f*fd*s - 30*Dd*f*fd + 112*Dd*fd*g2*r + 112*Dd*fd*g2*s - 84*Dd*fd*g2 + 14*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3))) + f*(20*C*D1*bdd1*f*r + 20*C*D1*bdd1*f*s - 10*C*D1*bdd1*f - 30*C*D1*f*fd*r**2 - 60*C*D1*f*fd*r*s + 40*C*D1*f*fd*r - 30*C*D1*f*fd*s**2 + 40*C*D1*f*fd*s - 20*C*D1*f*fd - 40*C*Dd*f**2*r**2 - 80*C*Dd*f**2*r*s + 60*C*Dd*f**2*r - 40*C*Dd*f**2*s**2 + 60*C*Dd*f**2*s - 30*C*Dd*f**2 + 14*D1*K*bd1**2*(r + s - 1) - 7*D1*bd2*f*r**2 - 14*D1*bd2*f*r*s + 14*D1*bd2*f*r - 7*D1*bd2*f*s**2 + 14*D1*bd2*f*s - 7*D1*bd2*f - 10*D1*bdd1*f*r - 10*D1*bdd1*f*s + 5*D1*bdd1*f - 28*D1*bdd1*g2*r - 28*D1*bdd1*g2*s + 14*D1*bdd1*g2 + 15*D1*f*fd*r**2 + 30*D1*f*fd*r*s - 20*D1*f*fd*r + 15*D1*f*fd*s**2 - 20*D1*f*fd*s + 10*D1*f*fd + 14*D1*f*gd2*r**2 + 28*D1*f*gd2*r*s - 28*D1*f*gd2*r + 14*D1*f*gd2*s**2 - 28*D1*f*gd2*s + 14*D1*f*gd2 + 28*D1*fd*g2*r**2 + 56*D1*fd*g2*r*s - 28*D1*fd*g2*r + 28*D1*fd*g2*s**2 - 28*D1*fd*g2*s + 14*D1*fd*g2 + 20*Dd*f**2*r**2 + 40*Dd*f**2*r*s - 30*Dd*f**2*r + 20*Dd*f**2*s**2 - 30*Dd*f**2*s + 15*Dd*f**2 + 56*Dd*f*g2*r**2 + 112*Dd*f*g2*r*s - 84*Dd*f*g2*r + 56*Dd*f*g2*s**2 - 84*Dd*f*g2*s + 42*Dd*f*g2 - bd1*(14*D1*bd2*(r + s - 1)**2 + D1*(f*(20*C*(2*r + 2*s - 1) + 7*K*(r + s - 1)**2 - 20*r - 20*s + 10) + fd*(10 - 20*C)*(r + s - 1) - 28*g2*(2*r + 2*s - 1) + 28*gd2*(r + s - 1)) - 2*Dd*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3)))) + 7*b2*(2*D1**2*b1*fd*r**2 + 4*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r**2 - 2*D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r**2 + 16*D1*Dd*b1*f*r*s - 12*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 12*D1*Dd*b1*f*s + 6*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r**2 - 16*D1*Dd*b1*fd*r*s + 6*D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 6*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 4*D1*Ddd*b1*f*r**2 - 8*D1*Ddd*b1*f*r*s + 6*D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 6*D1*Ddd*b1*f*s - 3*D1*Ddd*b1*f + 2*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*b1*f*r**2 - 24*Dd**2*b1*f*r*s + 18*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 18*Dd**2*b1*f*s - 6*Dd**2*b1*f))/(70*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**4*k2**2*(-D1*(r + s)*(14*D1*K*bd1**2*f*(r + s - 1) + D1*bdd1*f*(r + s)*(7*b2 + f*(10*C - 5) - 14*g2) + 2*bd1*(-10*C*D1*f**2*r - 10*C*D1*f**2*s + 20*C*D1*f*fd*r + 20*C*D1*f*fd*s - 20*C*D1*f*fd + 40*C*Dd*f**2*r + 40*C*Dd*f**2*s - 30*C*Dd*f**2 + 7*D1*bd2*f*(r + s - 1) + 5*D1*f**2*r + 5*D1*f**2*s - 10*D1*f*fd*r - 10*D1*f*fd*s + 10*D1*f*fd + 14*D1*f*g2*r + 14*D1*f*g2*s - 14*D1*f*gd2*r - 14*D1*f*gd2*s + 14*D1*f*gd2 - 14*D1*fd*g2*r - 14*D1*fd*g2*s + 14*D1*fd*g2 - 20*Dd*f**2*r - 20*Dd*f**2*s + 15*Dd*f**2 - 56*Dd*f*g2*r - 56*Dd*f*g2*s + 42*Dd*f*g2 + 7*b2*(-D1*f*(r + s) + D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))) + 7*K*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(40*C*D1**2*f*fd*r**2 + 80*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*r + 40*C*D1**2*f*fd*s**2 - 80*C*D1**2*f*fd*s + 40*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 - 40*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 40*C*D1**2*f*fdd*s - 20*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 - 40*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 40*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 + 80*C*D1*Dd*f**2*r**2 + 160*C*D1*Dd*f**2*r*s - 120*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s**2 - 120*C*D1*Dd*f**2*s + 60*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 - 320*C*D1*Dd*f*fd*r*s + 280*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 280*C*D1*Dd*f*fd*s - 120*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 - 80*C*D1*Ddd*f**2*r*s + 60*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 60*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 - 240*C*Dd**2*f**2*r*s + 180*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 180*C*Dd**2*f**2*s - 60*C*Dd**2*f**2 + 28*D1**2*K*bd1*f*r**2 + 56*D1**2*K*bd1*f*r*s - 28*D1**2*K*bd1*f*r + 28*D1**2*K*bd1*f*s**2 - 28*D1**2*K*bd1*f*s + 14*D1**2*K*bd1*f - 28*D1**2*K*bd1*fd*r**2 - 56*D1**2*K*bd1*fd*r*s + 42*D1**2*K*bd1*fd*r - 28*D1**2*K*bd1*fd*s**2 + 42*D1**2*K*bd1*fd*s - 14*D1**2*K*bd1*fd - 14*D1**2*K*bdd1*f*r**2 - 28*D1**2*K*bdd1*f*r*s + 14*D1**2*K*bdd1*f*r - 14*D1**2*K*bdd1*f*s**2 + 14*D1**2*K*bdd1*f*s - 7*D1**2*K*bdd1*f + 14*D1**2*b2*fd*r**2 + 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*r + 14*D1**2*b2*fd*s**2 - 28*D1**2*b2*fd*s + 14*D1**2*b2*fd - 7*D1**2*b2*fdd*r**2 - 14*D1**2*b2*fdd*r*s + 14*D1**2*b2*fdd*r - 7*D1**2*b2*fdd*s**2 + 14*D1**2*b2*fdd*s - 7*D1**2*b2*fdd - 7*D1**2*bdd2*f*(r + s - 1)**2 - 20*D1**2*f*fd*r**2 - 40*D1**2*f*fd*r*s + 40*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 40*D1**2*f*fd*s - 20*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 10*D1**2*f*fdd - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 14*D1**2*f*gdd2*r**2 + 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 20*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s + 10*D1**2*fd**2 - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 28*D1**2*fd*gd2*r**2 + 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 56*D1**2*fd*gd2*s + 28*D1**2*fd*gd2 + 14*D1**2*fdd*g2*r**2 + 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 112*D1*Dd*K*bd1*f*r**2 - 224*D1*Dd*K*bd1*f*r*s + 140*D1*Dd*K*bd1*f*r - 112*D1*Dd*K*bd1*f*s**2 + 140*D1*Dd*K*bd1*f*s - 42*D1*Dd*K*bd1*f + 56*D1*Dd*b2*f*r**2 + 112*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 56*D1*Dd*b2*f*s**2 - 84*D1*Dd*b2*f*s + 42*D1*Dd*b2*f - 56*D1*Dd*b2*fd*r**2 - 112*D1*Dd*b2*fd*r*s + 98*D1*Dd*b2*fd*r - 56*D1*Dd*b2*fd*s**2 + 98*D1*Dd*b2*fd*s - 42*D1*Dd*b2*fd - 40*D1*Dd*f**2*r**2 - 80*D1*Dd*f**2*r*s + 60*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 60*D1*Dd*f**2*s - 30*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 140*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 140*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 + 224*D1*Dd*f*gd2*r*s - 196*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 196*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r**2 + 224*D1*Dd*fd*g2*r*s - 196*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 196*D1*Dd*fd*g2*s + 84*D1*Dd*fd*g2 - 28*D1*Ddd*b2*f*r**2 - 56*D1*Ddd*b2*f*r*s + 42*D1*Ddd*b2*f*r - 28*D1*Ddd*b2*f*s**2 + 42*D1*Ddd*b2*f*s - 21*D1*Ddd*b2*f + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 + 112*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 84*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 14*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 84*Dd**2*b2*f*r**2 - 168*Dd**2*b2*f*r*s + 126*Dd**2*b2*f*r - 84*Dd**2*b2*f*s**2 + 126*Dd**2*b2*f*s - 42*Dd**2*b2*f + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2 + 168*Dd**2*f*g2*r**2 + 336*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 252*Dd**2*f*g2*s + 84*Dd**2*f*g2))/(70*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**3*f**2*k1**7*(D1**2*(-f*(7*fd - 9*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 54*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(-7*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 18*fd*(4*r + 4*s - 3)**2) + 9*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 54*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(198*d**2*k2*k3**6) - D1**2*Pk2*Pkdd3*ct**3*k1**5*k2*st**2*(1584*C*D1**2*f**2*fd*r**2 + 3168*C*D1**2*f**2*fd*r*s - 2112*C*D1**2*f**2*fd*r + 1584*C*D1**2*f**2*fd*s**2 - 2112*C*D1**2*f**2*fd*s + 1056*C*D1**2*f**2*fd - 1980*C*D1**2*f**2*fdd*r**2 - 3960*C*D1**2*f**2*fdd*r*s + 2640*C*D1**2*f**2*fdd*r - 1980*C*D1**2*f**2*fdd*s**2 + 2640*C*D1**2*f**2*fdd*s - 1320*C*D1**2*f**2*fdd - 3960*C*D1**2*f*fd**2*r**2 - 7920*C*D1**2*f*fd**2*r*s + 5280*C*D1**2*f*fd**2*r - 3960*C*D1**2*f*fd**2*s**2 + 5280*C*D1**2*f*fd**2*s - 1320*C*D1**2*f*fd**2 + 2112*C*D1*Dd*f**3*r**2 + 4224*C*D1*Dd*f**3*r*s - 3168*C*D1*Dd*f**3*r + 2112*C*D1*Dd*f**3*s**2 - 3168*C*D1*Dd*f**3*s + 1584*C*D1*Dd*f**3 - 15840*C*D1*Dd*f**2*fd*r**2 - 31680*C*D1*Dd*f**2*fd*r*s + 22440*C*D1*Dd*f**2*fd*r - 15840*C*D1*Dd*f**2*fd*s**2 + 22440*C*D1*Dd*f**2*fd*s - 7920*C*D1*Dd*f**2*fd - 2640*C*D1*Ddd*f**3*r**2 - 5280*C*D1*Ddd*f**3*r*s + 3960*C*D1*Ddd*f**3*r - 2640*C*D1*Ddd*f**3*s**2 + 3960*C*D1*Ddd*f**3*s - 1980*C*D1*Ddd*f**3 - 7920*C*Dd**2*f**3*r**2 - 15840*C*Dd**2*f**3*r*s + 11880*C*Dd**2*f**3*r - 7920*C*Dd**2*f**3*s**2 + 11880*C*Dd**2*f**3*s - 3960*C*Dd**2*f**3 + 528*D1**2*K*b1*f*fd*r**2 + 1056*D1**2*K*b1*f*fd*r*s - 528*D1**2*K*b1*f*fd*r + 528*D1**2*K*b1*f*fd*s**2 - 528*D1**2*K*b1*f*fd*s + 264*D1**2*K*b1*f*fd - 1188*D1**2*K*b1*f*fdd*r**2 - 2376*D1**2*K*b1*f*fdd*r*s + 1188*D1**2*K*b1*f*fdd*r - 1188*D1**2*K*b1*f*fdd*s**2 + 1188*D1**2*K*b1*f*fdd*s - 594*D1**2*K*b1*f*fdd - 1188*D1**2*K*b1*fd**2*r**2 - 2376*D1**2*K*b1*fd**2*r*s + 1188*D1**2*K*b1*fd**2*r - 1188*D1**2*K*b1*fd**2*s**2 + 1188*D1**2*K*b1*fd**2*s - 528*D1**2*b1*f*fd*r**2 - 1056*D1**2*b1*f*fd*r*s + 528*D1**2*b1*f*fd*r - 528*D1**2*b1*f*fd*s**2 + 528*D1**2*b1*f*fd*s - 264*D1**2*b1*f*fd + 1188*D1**2*b1*f*fdd*r**2 + 2376*D1**2*b1*f*fdd*r*s - 1188*D1**2*b1*f*fdd*r + 1188*D1**2*b1*f*fdd*s**2 - 1188*D1**2*b1*f*fdd*s + 594*D1**2*b1*f*fdd + 1188*D1**2*b1*fd**2*r**2 + 2376*D1**2*b1*fd**2*r*s - 1188*D1**2*b1*fd**2*r + 1188*D1**2*b1*fd**2*s**2 - 1188*D1**2*b1*fd**2*s - 594*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 6740*D1**2*f**3*fd*r**2 + 13480*D1**2*f**3*fd*r*s - 10110*D1**2*f**3*fd*r + 6740*D1**2*f**3*fd*s**2 - 10110*D1**2*f**3*fd*s + 5055*D1**2*f**3*fd - 7000*D1**2*f**3*fdd*r**2 - 14000*D1**2*f**3*fdd*r*s + 10500*D1**2*f**3*fdd*r - 7000*D1**2*f**3*fdd*s**2 + 10500*D1**2*f**3*fdd*s - 5250*D1**2*f**3*fdd - 21000*D1**2*f**2*fd**2*r**2 - 42000*D1**2*f**2*fd**2*r*s + 31500*D1**2*f**2*fd**2*r - 21000*D1**2*f**2*fd**2*s**2 + 31500*D1**2*f**2*fd**2*s - 10500*D1**2*f**2*fd**2 - 1584*D1**2*f**2*fd*r**2 - 3168*D1**2*f**2*fd*r*s + 2112*D1**2*f**2*fd*r - 1584*D1**2*f**2*fd*s**2 + 2112*D1**2*f**2*fd*s - 1056*D1**2*f**2*fd + 1980*D1**2*f**2*fdd*r**2 + 3960*D1**2*f**2*fdd*r*s - 2640*D1**2*f**2*fdd*r + 1980*D1**2*f**2*fdd*s**2 - 2640*D1**2*f**2*fdd*s + 1320*D1**2*f**2*fdd - 528*D1**2*f**2*gd2*r**2 - 1056*D1**2*f**2*gd2*r*s + 1056*D1**2*f**2*gd2*r - 528*D1**2*f**2*gd2*s**2 + 1056*D1**2*f**2*gd2*s - 528*D1**2*f**2*gd2 + 1188*D1**2*f**2*gdd2*r**2 + 2376*D1**2*f**2*gdd2*r*s - 2376*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 2376*D1**2*f**2*gdd2*s + 1188*D1**2*f**2*gdd2 + 3960*D1**2*f*fd**2*r**2 + 7920*D1**2*f*fd**2*r*s - 5280*D1**2*f*fd**2*r + 3960*D1**2*f*fd**2*s**2 - 5280*D1**2*f*fd**2*s + 1320*D1**2*f*fd**2 - 1056*D1**2*f*fd*g2*r**2 - 2112*D1**2*f*fd*g2*r*s + 1056*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 + 4752*D1**2*f*fd*gd2*r**2 + 9504*D1**2*f*fd*gd2*r*s - 7128*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2376*D1**2*f*fd*gd2 + 2376*D1**2*f*fdd*g2*r**2 + 4752*D1**2*f*fdd*g2*r*s - 2376*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 2376*D1**2*fd**2*g2*r**2 + 4752*D1**2*fd**2*g2*r*s - 2376*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 1056*D1*Dd*K*b1*f**2*r**2 + 2112*D1*Dd*K*b1*f**2*r*s - 1584*D1*Dd*K*b1*f**2*r + 1056*D1*Dd*K*b1*f**2*s**2 - 1584*D1*Dd*K*b1*f**2*s + 792*D1*Dd*K*b1*f**2 - 9504*D1*Dd*K*b1*f*fd*r**2 - 19008*D1*Dd*K*b1*f*fd*r*s + 11880*D1*Dd*K*b1*f*fd*r - 9504*D1*Dd*K*b1*f*fd*s**2 + 11880*D1*Dd*K*b1*f*fd*s - 3564*D1*Dd*K*b1*f*fd - 1056*D1*Dd*b1*f**2*r**2 - 2112*D1*Dd*b1*f**2*r*s + 1584*D1*Dd*b1*f**2*r - 1056*D1*Dd*b1*f**2*s**2 + 1584*D1*Dd*b1*f**2*s - 792*D1*Dd*b1*f**2 + 9504*D1*Dd*b1*f*fd*r**2 + 19008*D1*Dd*b1*f*fd*r*s - 11880*D1*Dd*b1*f*fd*r + 9504*D1*Dd*b1*f*fd*s**2 - 11880*D1*Dd*b1*f*fd*s + 3564*D1*Dd*b1*f*fd + 6740*D1*Dd*f**4*r**2 + 13480*D1*Dd*f**4*r*s - 10110*D1*Dd*f**4*r + 6740*D1*Dd*f**4*s**2 - 10110*D1*Dd*f**4*s + 5055*D1*Dd*f**4 - 56000*D1*Dd*f**3*fd*r**2 - 112000*D1*Dd*f**3*fd*r*s + 84000*D1*Dd*f**3*fd*r - 56000*D1*Dd*f**3*fd*s**2 + 84000*D1*Dd*f**3*fd*s - 31500*D1*Dd*f**3*fd - 2112*D1*Dd*f**3*r**2 - 4224*D1*Dd*f**3*r*s + 3168*D1*Dd*f**3*r - 2112*D1*Dd*f**3*s**2 + 3168*D1*Dd*f**3*s - 1584*D1*Dd*f**3 + 15840*D1*Dd*f**2*fd*r**2 + 31680*D1*Dd*f**2*fd*r*s - 22440*D1*Dd*f**2*fd*r + 15840*D1*Dd*f**2*fd*s**2 - 22440*D1*Dd*f**2*fd*s + 7920*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*g2*r**2 - 4224*D1*Dd*f**2*g2*r*s + 3168*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s**2 + 3168*D1*Dd*f**2*g2*s - 1584*D1*Dd*f**2*g2 + 9504*D1*Dd*f**2*gd2*r**2 + 19008*D1*Dd*f**2*gd2*r*s - 16632*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 7128*D1*Dd*f**2*gd2 + 19008*D1*Dd*f*fd*g2*r**2 + 38016*D1*Dd*f*fd*g2*r*s - 23760*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 23760*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 2376*D1*Ddd*K*b1*f**2*r**2 - 4752*D1*Ddd*K*b1*f**2*r*s + 3564*D1*Ddd*K*b1*f**2*r - 2376*D1*Ddd*K*b1*f**2*s**2 + 3564*D1*Ddd*K*b1*f**2*s - 1782*D1*Ddd*K*b1*f**2 + 2376*D1*Ddd*b1*f**2*r**2 + 4752*D1*Ddd*b1*f**2*r*s - 3564*D1*Ddd*b1*f**2*r + 2376*D1*Ddd*b1*f**2*s**2 - 3564*D1*Ddd*b1*f**2*s + 1782*D1*Ddd*b1*f**2 - 7000*D1*Ddd*f**4*r**2 - 14000*D1*Ddd*f**4*r*s + 10500*D1*Ddd*f**4*r - 7000*D1*Ddd*f**4*s**2 + 10500*D1*Ddd*f**4*s - 5250*D1*Ddd*f**4 + 2640*D1*Ddd*f**3*r**2 + 5280*D1*Ddd*f**3*r*s - 3960*D1*Ddd*f**3*r + 2640*D1*Ddd*f**3*s**2 - 3960*D1*Ddd*f**3*s + 1980*D1*Ddd*f**3 + 4752*D1*Ddd*f**2*g2*r**2 + 9504*D1*Ddd*f**2*g2*r*s - 7128*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 + 132*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 9*D1*fd*(2*r + 2*s - 1) - 9*Dd*f*(4*r + 4*s - 3)) - 7128*Dd**2*K*b1*f**2*r**2 - 14256*Dd**2*K*b1*f**2*r*s + 10692*Dd**2*K*b1*f**2*r - 7128*Dd**2*K*b1*f**2*s**2 + 10692*Dd**2*K*b1*f**2*s - 3564*Dd**2*K*b1*f**2 + 7128*Dd**2*b1*f**2*r**2 + 14256*Dd**2*b1*f**2*r*s - 10692*Dd**2*b1*f**2*r + 7128*Dd**2*b1*f**2*s**2 - 10692*Dd**2*b1*f**2*s + 3564*Dd**2*b1*f**2 - 21000*Dd**2*f**4*r**2 - 42000*Dd**2*f**4*r*s + 31500*Dd**2*f**4*r - 21000*Dd**2*f**4*s**2 + 31500*Dd**2*f**4*s - 10500*Dd**2*f**4 + 7920*Dd**2*f**3*r**2 + 15840*Dd**2*f**3*r*s - 11880*Dd**2*f**3*r + 7920*Dd**2*f**3*s**2 - 11880*Dd**2*f**3*s + 3960*Dd**2*f**3 + 14256*Dd**2*f**2*g2*r**2 + 28512*Dd**2*f**2*g2*r*s - 21384*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 7128*Dd**2*f**2*g2)/(3465*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**3*k1**5*k2*(360*C*D1**2*bdd1*f**2*r**2 + 720*C*D1**2*bdd1*f**2*r*s - 720*C*D1**2*bdd1*f**2*r + 360*C*D1**2*bdd1*f**2*s**2 - 720*C*D1**2*bdd1*f**2*s + 360*C*D1**2*bdd1*f**2 - 300*C*D1**2*f**2*fd*r**2 - 600*C*D1**2*f**2*fd*r*s + 400*C*D1**2*f**2*fd*r - 300*C*D1**2*f**2*fd*s**2 + 400*C*D1**2*f**2*fd*s - 200*C*D1**2*f**2*fd + 420*C*D1**2*f**2*fdd*r**2 + 840*C*D1**2*f**2*fdd*r*s - 560*C*D1**2*f**2*fdd*r + 420*C*D1**2*f**2*fdd*s**2 - 560*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 840*C*D1**2*f*fd**2*r**2 + 1680*C*D1**2*f*fd**2*r*s - 1120*C*D1**2*f*fd**2*r + 840*C*D1**2*f*fd**2*s**2 - 1120*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 400*C*D1*Dd*f**3*r**2 - 800*C*D1*Dd*f**3*r*s + 600*C*D1*Dd*f**3*r - 400*C*D1*Dd*f**3*s**2 + 600*C*D1*Dd*f**3*s - 300*C*D1*Dd*f**3 + 3360*C*D1*Dd*f**2*fd*r**2 + 6720*C*D1*Dd*f**2*fd*r*s - 4760*C*D1*Dd*f**2*fd*r + 3360*C*D1*Dd*f**2*fd*s**2 - 4760*C*D1*Dd*f**2*fd*s + 1680*C*D1*Dd*f**2*fd + 560*C*D1*Ddd*f**3*r**2 + 1120*C*D1*Ddd*f**3*r*s - 840*C*D1*Ddd*f**3*r + 560*C*D1*Ddd*f**3*s**2 - 840*C*D1*Ddd*f**3*s + 420*C*D1*Ddd*f**3 + 1680*C*Dd**2*f**3*r**2 + 3360*C*Dd**2*f**3*r*s - 2520*C*Dd**2*f**3*r + 1680*C*Dd**2*f**3*s**2 - 2520*C*Dd**2*f**3*s + 840*C*Dd**2*f**3 + 90*D1**2*K*bdd1*f**2*r**2 + 180*D1**2*K*bdd1*f**2*r*s - 180*D1**2*K*bdd1*f**2*r + 90*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s + 90*D1**2*K*bdd1*f**2 + 504*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 175*D1**2*bdd1*f**3*r**2 + 350*D1**2*bdd1*f**3*r*s - 350*D1**2*bdd1*f**3*r + 175*D1**2*bdd1*f**3*s**2 - 350*D1**2*bdd1*f**3*s + 175*D1**2*bdd1*f**3 - 405*D1**2*bdd1*f**2*r**2 - 810*D1**2*bdd1*f**2*r*s + 810*D1**2*bdd1*f**2*r - 405*D1**2*bdd1*f**2*s**2 + 810*D1**2*bdd1*f**2*s - 405*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r**2 - 1008*D1**2*bdd1*f*g2*r*s + 1008*D1**2*bdd1*f*g2*r - 504*D1**2*bdd1*f*g2*s**2 + 1008*D1**2*bdd1*f*g2*s - 504*D1**2*bdd1*f*g2 + 140*D1**2*f**3*fd*r**2 + 280*D1**2*f**3*fd*r*s - 210*D1**2*f**3*fd*r + 140*D1**2*f**3*fd*s**2 - 210*D1**2*f**3*fd*s + 105*D1**2*f**3*fd + 225*D1**2*f**2*fd*r**2 + 450*D1**2*f**2*fd*r*s - 300*D1**2*f**2*fd*r + 225*D1**2*f**2*fd*s**2 - 300*D1**2*f**2*fd*s + 150*D1**2*f**2*fd - 315*D1**2*f**2*fdd*r**2 - 630*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r - 315*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 210*D1**2*f**2*fdd + 108*D1**2*f**2*gd2*r**2 + 216*D1**2*f**2*gd2*r*s - 216*D1**2*f**2*gd2*r + 108*D1**2*f**2*gd2*s**2 - 216*D1**2*f**2*gd2*s + 108*D1**2*f**2*gd2 - 180*D1**2*f**2*gdd2*r**2 - 360*D1**2*f**2*gdd2*r*s + 360*D1**2*f**2*gdd2*r - 180*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s - 180*D1**2*f**2*gdd2 - 630*D1**2*f*fd**2*r**2 - 1260*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r - 630*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 210*D1**2*f*fd**2 + 216*D1**2*f*fd*g2*r**2 + 432*D1**2*f*fd*g2*r*s - 216*D1**2*f*fd*g2*r + 216*D1**2*f*fd*g2*s**2 - 216*D1**2*f*fd*g2*s + 108*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*r**2 - 1440*D1**2*f*fd*gd2*r*s + 1080*D1**2*f*fd*gd2*r - 720*D1**2*f*fd*gd2*s**2 + 1080*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 360*D1**2*f*fdd*g2*r**2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r - 360*D1**2*f*fdd*g2*s**2 + 360*D1**2*f*fdd*g2*s - 180*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*r**2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r - 360*D1**2*fd**2*g2*s**2 + 360*D1**2*fd**2*g2*s + 140*D1*Dd*f**4*r**2 + 280*D1*Dd*f**4*r*s - 210*D1*Dd*f**4*r + 140*D1*Dd*f**4*s**2 - 210*D1*Dd*f**4*s + 105*D1*Dd*f**4 + 300*D1*Dd*f**3*r**2 + 600*D1*Dd*f**3*r*s - 450*D1*Dd*f**3*r + 300*D1*Dd*f**3*s**2 - 450*D1*Dd*f**3*s + 225*D1*Dd*f**3 - 2520*D1*Dd*f**2*fd*r**2 - 5040*D1*Dd*f**2*fd*r*s + 3570*D1*Dd*f**2*fd*r - 2520*D1*Dd*f**2*fd*s**2 + 3570*D1*Dd*f**2*fd*s - 1260*D1*Dd*f**2*fd + 432*D1*Dd*f**2*g2*r**2 + 864*D1*Dd*f**2*g2*r*s - 648*D1*Dd*f**2*g2*r + 432*D1*Dd*f**2*g2*s**2 - 648*D1*Dd*f**2*g2*s + 324*D1*Dd*f**2*g2 - 1440*D1*Dd*f**2*gd2*r**2 - 2880*D1*Dd*f**2*gd2*r*s + 2520*D1*Dd*f**2*gd2*r - 1440*D1*Dd*f**2*gd2*s**2 + 2520*D1*Dd*f**2*gd2*s - 1080*D1*Dd*f**2*gd2 - 2880*D1*Dd*f*fd*g2*r**2 - 5760*D1*Dd*f*fd*g2*r*s + 3600*D1*Dd*f*fd*g2*r - 2880*D1*Dd*f*fd*g2*s**2 + 3600*D1*Dd*f*fd*g2*s - 1080*D1*Dd*f*fd*g2 - 420*D1*Ddd*f**3*r**2 - 840*D1*Ddd*f**3*r*s + 630*D1*Ddd*f**3*r - 420*D1*Ddd*f**3*s**2 + 630*D1*Ddd*f**3*s - 315*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*r**2 - 1440*D1*Ddd*f**2*g2*r*s + 1080*D1*Ddd*f**2*g2*r - 720*D1*Ddd*f**2*g2*s**2 + 1080*D1*Ddd*f**2*g2*s - 540*D1*Ddd*f**2*g2 - D1*bd1*(D1*(170*f**3*(r + s - 1) + f**2*(216*C*(r + s - 1) - 350*fd*(3*r + 3*s - 2) + (54*K - 243)*(r + s - 1)) - 6*f*(15*fd*(8*C + 2*K - 9)*(2*r + 2*s - 1) + (28*g2 - 168*gd2)*(r + s - 1)) + 1008*fd*g2*(r + s)) - 2*Dd*f*(175*f**2 + 45*f*(8*C + 2*K - 9) - 504*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1260*Dd**2*f**3*r**2 - 2520*Dd**2*f**3*r*s + 1890*Dd**2*f**3*r - 1260*Dd**2*f**3*s**2 + 1890*Dd**2*f**3*s - 630*Dd**2*f**3 - 2160*Dd**2*f**2*g2*r**2 - 4320*Dd**2*f**2*g2*r*s + 3240*Dd**2*f**2*g2*r - 2160*Dd**2*f**2*g2*s**2 + 3240*Dd**2*f**2*g2*s - 1080*Dd**2*f**2*g2 - 84*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(r + s)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-432*C*D1**2*f*fd*r**2 - 864*C*D1**2*f*fd*r*s + 432*C*D1**2*f*fd*r - 432*C*D1**2*f*fd*s**2 + 432*C*D1**2*f*fd*s - 216*C*D1**2*f*fd + 720*C*D1**2*f*fdd*r**2 + 1440*C*D1**2*f*fdd*r*s - 720*C*D1**2*f*fdd*r + 720*C*D1**2*f*fdd*s**2 - 720*C*D1**2*f*fdd*s + 360*C*D1**2*f*fdd + 720*C*D1**2*fd**2*r**2 + 1440*C*D1**2*fd**2*r*s - 720*C*D1**2*fd**2*r + 720*C*D1**2*fd**2*s**2 - 720*C*D1**2*fd**2*s - 864*C*D1*Dd*f**2*r**2 - 1728*C*D1*Dd*f**2*r*s + 1296*C*D1*Dd*f**2*r - 864*C*D1*Dd*f**2*s**2 + 1296*C*D1*Dd*f**2*s - 648*C*D1*Dd*f**2 + 5760*C*D1*Dd*f*fd*r**2 + 11520*C*D1*Dd*f*fd*r*s - 7200*C*D1*Dd*f*fd*r + 5760*C*D1*Dd*f*fd*s**2 - 7200*C*D1*Dd*f*fd*s + 2160*C*D1*Dd*f*fd + 1440*C*D1*Ddd*f**2*r**2 + 2880*C*D1*Ddd*f**2*r*s - 2160*C*D1*Ddd*f**2*r + 1440*C*D1*Ddd*f**2*s**2 - 2160*C*D1*Ddd*f**2*s + 1080*C*D1*Ddd*f**2 + 4320*C*Dd**2*f**2*r**2 + 8640*C*Dd**2*f**2*r*s - 6480*C*Dd**2*f**2*r + 4320*C*Dd**2*f**2*s**2 - 6480*C*Dd**2*f**2*s + 2160*C*Dd**2*f**2 - 108*D1**2*K*f*fd*r**2 - 216*D1**2*K*f*fd*r*s + 108*D1**2*K*f*fd*r - 108*D1**2*K*f*fd*s**2 + 108*D1**2*K*f*fd*s - 54*D1**2*K*f*fd + 180*D1**2*K*f*fdd*r**2 + 360*D1**2*K*f*fdd*r*s - 180*D1**2*K*f*fdd*r + 180*D1**2*K*f*fdd*s**2 - 180*D1**2*K*f*fdd*s + 90*D1**2*K*f*fdd + 180*D1**2*K*fd**2*r**2 + 360*D1**2*K*fd**2*r*s - 180*D1**2*K*fd**2*r + 180*D1**2*K*fd**2*s**2 - 180*D1**2*K*fd**2*s + 504*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 510*D1**2*f**2*fd*r**2 - 1020*D1**2*f**2*fd*r*s + 680*D1**2*f**2*fd*r - 510*D1**2*f**2*fd*s**2 + 680*D1**2*f**2*fd*s - 340*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 700*D1**2*f**2*fdd*s + 350*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1400*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 + 486*D1**2*f*fd*r**2 + 972*D1**2*f*fd*r*s - 486*D1**2*f*fd*r + 486*D1**2*f*fd*s**2 - 486*D1**2*f*fd*s + 243*D1**2*f*fd - 810*D1**2*f*fdd*r**2 - 1620*D1**2*f*fdd*r*s + 810*D1**2*f*fdd*r - 810*D1**2*f*fdd*s**2 + 810*D1**2*f*fdd*s - 405*D1**2*f*fdd + 168*D1**2*f*gd2*r**2 + 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r + 168*D1**2*f*gd2*s**2 - 336*D1**2*f*gd2*s + 168*D1**2*f*gd2 - 504*D1**2*f*gdd2*r**2 - 1008*D1**2*f*gdd2*r*s + 1008*D1**2*f*gdd2*r - 504*D1**2*f*gdd2*s**2 + 1008*D1**2*f*gdd2*s - 504*D1**2*f*gdd2 - 810*D1**2*fd**2*r**2 - 1620*D1**2*fd**2*r*s + 810*D1**2*fd**2*r - 810*D1**2*fd**2*s**2 + 810*D1**2*fd**2*s + 168*D1**2*fd*g2*r**2 + 336*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*s**2 - 1008*D1**2*fd*gd2*r**2 - 2016*D1**2*fd*gd2*r*s + 1008*D1**2*fd*gd2*r - 1008*D1**2*fd*gd2*s**2 + 1008*D1**2*fd*gd2*s - 504*D1**2*fdd*g2*r**2 - 1008*D1**2*fdd*g2*r*s - 504*D1**2*fdd*g2*s**2 - 216*D1*Dd*K*f**2*r**2 - 432*D1*Dd*K*f**2*r*s + 324*D1*Dd*K*f**2*r - 216*D1*Dd*K*f**2*s**2 + 324*D1*Dd*K*f**2*s - 162*D1*Dd*K*f**2 + 1440*D1*Dd*K*f*fd*r**2 + 2880*D1*Dd*K*f*fd*r*s - 1800*D1*Dd*K*f*fd*r + 1440*D1*Dd*K*f*fd*s**2 - 1800*D1*Dd*K*f*fd*s + 540*D1*Dd*K*f*fd - 680*D1*Dd*f**3*r**2 - 1360*D1*Dd*f**3*r*s + 1020*D1*Dd*f**3*r - 680*D1*Dd*f**3*s**2 + 1020*D1*Dd*f**3*s - 510*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 5950*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 5950*D1*Dd*f**2*fd*s + 2100*D1*Dd*f**2*fd + 972*D1*Dd*f**2*r**2 + 1944*D1*Dd*f**2*r*s - 1458*D1*Dd*f**2*r + 972*D1*Dd*f**2*s**2 - 1458*D1*Dd*f**2*s + 729*D1*Dd*f**2 - 6480*D1*Dd*f*fd*r**2 - 12960*D1*Dd*f*fd*r*s + 8100*D1*Dd*f*fd*r - 6480*D1*Dd*f*fd*s**2 + 8100*D1*Dd*f*fd*s - 2430*D1*Dd*f*fd + 672*D1*Dd*f*g2*r**2 + 1344*D1*Dd*f*g2*r*s - 1008*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 1008*D1*Dd*f*g2*s + 504*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r**2 - 8064*D1*Dd*f*gd2*r*s + 7056*D1*Dd*f*gd2*r - 4032*D1*Dd*f*gd2*s**2 + 7056*D1*Dd*f*gd2*s - 3024*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r**2 - 8064*D1*Dd*fd*g2*r*s + 3024*D1*Dd*fd*g2*r - 4032*D1*Dd*fd*g2*s**2 + 3024*D1*Dd*fd*g2*s + 360*D1*Ddd*K*f**2*r**2 + 720*D1*Ddd*K*f**2*r*s - 540*D1*Ddd*K*f**2*r + 360*D1*Ddd*K*f**2*s**2 - 540*D1*Ddd*K*f**2*s + 270*D1*Ddd*K*f**2 + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 1050*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 525*D1*Ddd*f**3 - 1620*D1*Ddd*f**2*r**2 - 3240*D1*Ddd*f**2*r*s + 2430*D1*Ddd*f**2*r - 1620*D1*Ddd*f**2*s**2 + 2430*D1*Ddd*f**2*s - 1215*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r**2 - 4032*D1*Ddd*f*g2*r*s + 3024*D1*Ddd*f*g2*r - 2016*D1*Ddd*f*g2*s**2 + 3024*D1*Ddd*f*g2*s - 1512*D1*Ddd*f*g2 - 168*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 1080*Dd**2*K*f**2*r**2 + 2160*Dd**2*K*f**2*r*s - 1620*Dd**2*K*f**2*r + 1080*Dd**2*K*f**2*s**2 - 1620*Dd**2*K*f**2*s + 540*Dd**2*K*f**2 + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 3150*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 1050*Dd**2*f**3 - 4860*Dd**2*f**2*r**2 - 9720*Dd**2*f**2*r*s + 7290*Dd**2*f**2*r - 4860*Dd**2*f**2*s**2 + 7290*Dd**2*f**2*s - 2430*Dd**2*f**2 - 6048*Dd**2*f*g2*r**2 - 12096*Dd**2*f*g2*r*s + 9072*Dd**2*f*g2*r - 6048*Dd**2*f*g2*s**2 + 9072*Dd**2*f*g2*s - 3024*Dd**2*f*g2))/(630*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**3*k1**5*(-150*D1**2*b1*f**2*fd*r**2 - 300*D1**2*b1*f**2*fd*r*s + 250*D1**2*b1*f**2*fd*r - 150*D1**2*b1*f**2*fd*s**2 + 250*D1**2*b1*f**2*fd*s - 125*D1**2*b1*f**2*fd + 210*D1**2*b1*f**2*fdd*r**2 + 420*D1**2*b1*f**2*fdd*r*s - 350*D1**2*b1*f**2*fdd*r + 210*D1**2*b1*f**2*fdd*s**2 - 350*D1**2*b1*f**2*fdd*s + 175*D1**2*b1*f**2*fdd + 420*D1**2*b1*f*fd**2*r**2 + 840*D1**2*b1*f*fd**2*r*s - 700*D1**2*b1*f*fd**2*r + 420*D1**2*b1*f*fd**2*s**2 - 700*D1**2*b1*f*fd**2*s + 280*D1**2*b1*f*fd**2 - 54*D1**2*b1*f*fd*r**2 - 108*D1**2*b1*f*fd*r*s + 54*D1**2*b1*f*fd*r - 54*D1**2*b1*f*fd*s**2 + 54*D1**2*b1*f*fd*s - 27*D1**2*b1*f*fd + 90*D1**2*b1*f*fdd*r**2 + 180*D1**2*b1*f*fdd*r*s - 90*D1**2*b1*f*fdd*r + 90*D1**2*b1*f*fdd*s**2 - 90*D1**2*b1*f*fdd*s + 45*D1**2*b1*f*fdd + 90*D1**2*b1*fd**2*r**2 + 180*D1**2*b1*fd**2*r*s - 90*D1**2*b1*fd**2*r + 90*D1**2*b1*fd**2*s**2 - 90*D1**2*b1*fd**2*s + 5*D1**2*bdd1*f**2*(7*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 9*(r + s - 1)**2) - 75*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 + 210*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 70*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 + 420*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s + 70*D1**2*f*fd**2 - 200*D1*Dd*b1*f**3*r**2 - 400*D1*Dd*b1*f**3*r*s + 300*D1*Dd*b1*f**3*r - 200*D1*Dd*b1*f**3*s**2 + 300*D1*Dd*b1*f**3*s - 150*D1*Dd*b1*f**3 + 1680*D1*Dd*b1*f**2*fd*r**2 + 3360*D1*Dd*b1*f**2*fd*r*s - 2660*D1*Dd*b1*f**2*fd*r + 1680*D1*Dd*b1*f**2*fd*s**2 - 2660*D1*Dd*b1*f**2*fd*s + 1050*D1*Dd*b1*f**2*fd - 108*D1*Dd*b1*f**2*r**2 - 216*D1*Dd*b1*f**2*r*s + 162*D1*Dd*b1*f**2*r - 108*D1*Dd*b1*f**2*s**2 + 162*D1*Dd*b1*f**2*s - 81*D1*Dd*b1*f**2 + 720*D1*Dd*b1*f*fd*r**2 + 1440*D1*Dd*b1*f*fd*r*s - 900*D1*Dd*b1*f*fd*r + 720*D1*Dd*b1*f*fd*s**2 - 900*D1*Dd*b1*f*fd*s + 270*D1*Dd*b1*f*fd - 100*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 75*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 + 1680*D1*Dd*f**2*fd*r*s - 1190*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 1190*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd + 280*D1*Ddd*b1*f**3*r**2 + 560*D1*Ddd*b1*f**3*r*s - 420*D1*Ddd*b1*f**3*r + 280*D1*Ddd*b1*f**3*s**2 - 420*D1*Ddd*b1*f**3*s + 210*D1*Ddd*b1*f**3 + 180*D1*Ddd*b1*f**2*r**2 + 360*D1*Ddd*b1*f**2*r*s - 270*D1*Ddd*b1*f**2*r + 180*D1*Ddd*b1*f**2*s**2 - 270*D1*Ddd*b1*f**2*s + 135*D1*Ddd*b1*f**2 + 140*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r*s - 210*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 210*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 + D1*bd1*f*(D1*(-25*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(r + s - 1)*(140*fd*(3*r + 3*s - 1) - 27*r - 27*s + 27) + 90*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 10*Dd*f*(4*r + 4*s - 3)*(7*f*(2*r + 2*s - 1) + 9*r + 9*s - 9)) + 840*Dd**2*b1*f**3*r**2 + 1680*Dd**2*b1*f**3*r*s - 1260*Dd**2*b1*f**3*r + 840*Dd**2*b1*f**3*s**2 - 1260*Dd**2*b1*f**3*s + 420*Dd**2*b1*f**3 + 540*Dd**2*b1*f**2*r**2 + 1080*Dd**2*b1*f**2*r*s - 810*Dd**2*b1*f**2*r + 540*Dd**2*b1*f**2*s**2 - 810*Dd**2*b1*f**2*s + 270*Dd**2*b1*f**2 + 420*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r*s - 630*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 630*Dd**2*f**3*s + 210*Dd**2*f**3)/(630*d**2*k2*k3**4) - D1**2*Pk2*Pkdd3*ct**3*k1**3*k2**3*st**4*(2244*C*D1**2*f**2*fd*r**2 + 4488*C*D1**2*f**2*fd*r*s - 2992*C*D1**2*f**2*fd*r + 2244*C*D1**2*f**2*fd*s**2 - 2992*C*D1**2*f**2*fd*s + 1496*C*D1**2*f**2*fd - 1320*C*D1**2*f**2*fdd*r**2 - 2640*C*D1**2*f**2*fdd*r*s + 1760*C*D1**2*f**2*fdd*r - 1320*C*D1**2*f**2*fdd*s**2 + 1760*C*D1**2*f**2*fdd*s - 880*C*D1**2*f**2*fdd - 2640*C*D1**2*f*fd**2*r**2 - 5280*C*D1**2*f*fd**2*r*s + 3520*C*D1**2*f*fd**2*r - 2640*C*D1**2*f*fd**2*s**2 + 3520*C*D1**2*f*fd**2*s - 880*C*D1**2*f*fd**2 + 2992*C*D1*Dd*f**3*r**2 + 5984*C*D1*Dd*f**3*r*s - 4488*C*D1*Dd*f**3*r + 2992*C*D1*Dd*f**3*s**2 - 4488*C*D1*Dd*f**3*s + 2244*C*D1*Dd*f**3 - 10560*C*D1*Dd*f**2*fd*r**2 - 21120*C*D1*Dd*f**2*fd*r*s + 14960*C*D1*Dd*f**2*fd*r - 10560*C*D1*Dd*f**2*fd*s**2 + 14960*C*D1*Dd*f**2*fd*s - 5280*C*D1*Dd*f**2*fd - 1760*C*D1*Ddd*f**3*r**2 - 3520*C*D1*Ddd*f**3*r*s + 2640*C*D1*Ddd*f**3*r - 1760*C*D1*Ddd*f**3*s**2 + 2640*C*D1*Ddd*f**3*s - 1320*C*D1*Ddd*f**3 - 5280*C*Dd**2*f**3*r**2 - 10560*C*Dd**2*f**3*r*s + 7920*C*Dd**2*f**3*r - 5280*C*Dd**2*f**3*s**2 + 7920*C*Dd**2*f**3*s - 2640*C*Dd**2*f**3 + 1716*D1**2*K*b1*f*fd*r**2 + 3432*D1**2*K*b1*f*fd*r*s - 1716*D1**2*K*b1*f*fd*r + 1716*D1**2*K*b1*f*fd*s**2 - 1716*D1**2*K*b1*f*fd*s + 858*D1**2*K*b1*f*fd - 1320*D1**2*K*b1*f*fdd*r**2 - 2640*D1**2*K*b1*f*fdd*r*s + 1320*D1**2*K*b1*f*fdd*r - 1320*D1**2*K*b1*f*fdd*s**2 + 1320*D1**2*K*b1*f*fdd*s - 660*D1**2*K*b1*f*fdd - 1320*D1**2*K*b1*fd**2*r**2 - 2640*D1**2*K*b1*fd**2*r*s + 1320*D1**2*K*b1*fd**2*r - 1320*D1**2*K*b1*fd**2*s**2 + 1320*D1**2*K*b1*fd**2*s - 1716*D1**2*b1*f*fd*r**2 - 3432*D1**2*b1*f*fd*r*s + 1716*D1**2*b1*f*fd*r - 1716*D1**2*b1*f*fd*s**2 + 1716*D1**2*b1*f*fd*s - 858*D1**2*b1*f*fd + 1320*D1**2*b1*f*fdd*r**2 + 2640*D1**2*b1*f*fdd*r*s - 1320*D1**2*b1*f*fdd*r + 1320*D1**2*b1*f*fdd*s**2 - 1320*D1**2*b1*f*fdd*s + 660*D1**2*b1*f*fdd + 1320*D1**2*b1*fd**2*r**2 + 2640*D1**2*b1*fd**2*r*s - 1320*D1**2*b1*fd**2*r + 1320*D1**2*b1*fd**2*s**2 - 1320*D1**2*b1*fd**2*s - 660*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 5680*D1**2*f**3*fd*r**2 + 11360*D1**2*f**3*fd*r*s - 8520*D1**2*f**3*fd*r + 5680*D1**2*f**3*fd*s**2 - 8520*D1**2*f**3*fd*s + 4260*D1**2*f**3*fd - 3500*D1**2*f**3*fdd*r**2 - 7000*D1**2*f**3*fdd*r*s + 5250*D1**2*f**3*fdd*r - 3500*D1**2*f**3*fdd*s**2 + 5250*D1**2*f**3*fdd*s - 2625*D1**2*f**3*fdd - 10500*D1**2*f**2*fd**2*r**2 - 21000*D1**2*f**2*fd**2*r*s + 15750*D1**2*f**2*fd**2*r - 10500*D1**2*f**2*fd**2*s**2 + 15750*D1**2*f**2*fd**2*s - 5250*D1**2*f**2*fd**2 - 2244*D1**2*f**2*fd*r**2 - 4488*D1**2*f**2*fd*r*s + 2992*D1**2*f**2*fd*r - 2244*D1**2*f**2*fd*s**2 + 2992*D1**2*f**2*fd*s - 1496*D1**2*f**2*fd + 1320*D1**2*f**2*fdd*r**2 + 2640*D1**2*f**2*fdd*r*s - 1760*D1**2*f**2*fdd*r + 1320*D1**2*f**2*fdd*s**2 - 1760*D1**2*f**2*fdd*s + 880*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 2640*D1**2*f*fd**2*r**2 + 5280*D1**2*f*fd**2*r*s - 3520*D1**2*f*fd**2*r + 2640*D1**2*f*fd**2*s**2 - 3520*D1**2*f*fd**2*s + 880*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s + 3432*D1*Dd*K*b1*f**2*r**2 + 6864*D1*Dd*K*b1*f**2*r*s - 5148*D1*Dd*K*b1*f**2*r + 3432*D1*Dd*K*b1*f**2*s**2 - 5148*D1*Dd*K*b1*f**2*s + 2574*D1*Dd*K*b1*f**2 - 10560*D1*Dd*K*b1*f*fd*r**2 - 21120*D1*Dd*K*b1*f*fd*r*s + 13200*D1*Dd*K*b1*f*fd*r - 10560*D1*Dd*K*b1*f*fd*s**2 + 13200*D1*Dd*K*b1*f*fd*s - 3960*D1*Dd*K*b1*f*fd - 3432*D1*Dd*b1*f**2*r**2 - 6864*D1*Dd*b1*f**2*r*s + 5148*D1*Dd*b1*f**2*r - 3432*D1*Dd*b1*f**2*s**2 + 5148*D1*Dd*b1*f**2*s - 2574*D1*Dd*b1*f**2 + 10560*D1*Dd*b1*f*fd*r**2 + 21120*D1*Dd*b1*f*fd*r*s - 13200*D1*Dd*b1*f*fd*r + 10560*D1*Dd*b1*f*fd*s**2 - 13200*D1*Dd*b1*f*fd*s + 3960*D1*Dd*b1*f*fd + 5680*D1*Dd*f**4*r**2 + 11360*D1*Dd*f**4*r*s - 8520*D1*Dd*f**4*r + 5680*D1*Dd*f**4*s**2 - 8520*D1*Dd*f**4*s + 4260*D1*Dd*f**4 - 28000*D1*Dd*f**3*fd*r**2 - 56000*D1*Dd*f**3*fd*r*s + 42000*D1*Dd*f**3*fd*r - 28000*D1*Dd*f**3*fd*s**2 + 42000*D1*Dd*f**3*fd*s - 15750*D1*Dd*f**3*fd - 2992*D1*Dd*f**3*r**2 - 5984*D1*Dd*f**3*r*s + 4488*D1*Dd*f**3*r - 2992*D1*Dd*f**3*s**2 + 4488*D1*Dd*f**3*s - 2244*D1*Dd*f**3 + 10560*D1*Dd*f**2*fd*r**2 + 21120*D1*Dd*f**2*fd*r*s - 14960*D1*Dd*f**2*fd*r + 10560*D1*Dd*f**2*fd*s**2 - 14960*D1*Dd*f**2*fd*s + 5280*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 - 2640*D1*Ddd*K*b1*f**2*r**2 - 5280*D1*Ddd*K*b1*f**2*r*s + 3960*D1*Ddd*K*b1*f**2*r - 2640*D1*Ddd*K*b1*f**2*s**2 + 3960*D1*Ddd*K*b1*f**2*s - 1980*D1*Ddd*K*b1*f**2 + 2640*D1*Ddd*b1*f**2*r**2 + 5280*D1*Ddd*b1*f**2*r*s - 3960*D1*Ddd*b1*f**2*r + 2640*D1*Ddd*b1*f**2*s**2 - 3960*D1*Ddd*b1*f**2*s + 1980*D1*Ddd*b1*f**2 - 3500*D1*Ddd*f**4*r**2 - 7000*D1*Ddd*f**4*r*s + 5250*D1*Ddd*f**4*r - 3500*D1*Ddd*f**4*s**2 + 5250*D1*Ddd*f**4*s - 2625*D1*Ddd*f**4 + 1760*D1*Ddd*f**3*r**2 + 3520*D1*Ddd*f**3*r*s - 2640*D1*Ddd*f**3*r + 1760*D1*Ddd*f**3*s**2 - 2640*D1*Ddd*f**3*s + 1320*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(K - 1)*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 7920*Dd**2*K*b1*f**2*r**2 - 15840*Dd**2*K*b1*f**2*r*s + 11880*Dd**2*K*b1*f**2*r - 7920*Dd**2*K*b1*f**2*s**2 + 11880*Dd**2*K*b1*f**2*s - 3960*Dd**2*K*b1*f**2 + 7920*Dd**2*b1*f**2*r**2 + 15840*Dd**2*b1*f**2*r*s - 11880*Dd**2*b1*f**2*r + 7920*Dd**2*b1*f**2*s**2 - 11880*Dd**2*b1*f**2*s + 3960*Dd**2*b1*f**2 - 10500*Dd**2*f**4*r**2 - 21000*Dd**2*f**4*r*s + 15750*Dd**2*f**4*r - 10500*Dd**2*f**4*s**2 + 15750*Dd**2*f**4*s - 5250*Dd**2*f**4 + 5280*Dd**2*f**3*r**2 + 10560*Dd**2*f**3*r*s - 7920*Dd**2*f**3*r + 5280*Dd**2*f**3*s**2 - 7920*Dd**2*f**3*s + 2640*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2)/(2310*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**3*k1**3*k2**3*st**2*(-108*C*D1**2*bdd1*f**2*r**2 - 216*C*D1**2*bdd1*f**2*r*s + 216*C*D1**2*bdd1*f**2*r - 108*C*D1**2*bdd1*f**2*s**2 + 216*C*D1**2*bdd1*f**2*s - 108*C*D1**2*bdd1*f**2 + 1026*C*D1**2*f**2*fd*r**2 + 2052*C*D1**2*f**2*fd*r*s - 1368*C*D1**2*f**2*fd*r + 1026*C*D1**2*f**2*fd*s**2 - 1368*C*D1**2*f**2*fd*s + 684*C*D1**2*f**2*fd - 1080*C*D1**2*f**2*fdd*r**2 - 2160*C*D1**2*f**2*fdd*r*s + 1440*C*D1**2*f**2*fdd*r - 1080*C*D1**2*f**2*fdd*s**2 + 1440*C*D1**2*f**2*fdd*s - 720*C*D1**2*f**2*fdd - 2160*C*D1**2*f*fd**2*r**2 - 4320*C*D1**2*f*fd**2*r*s + 2880*C*D1**2*f*fd**2*r - 2160*C*D1**2*f*fd**2*s**2 + 2880*C*D1**2*f*fd**2*s - 720*C*D1**2*f*fd**2 + 1368*C*D1*Dd*f**3*r**2 + 2736*C*D1*Dd*f**3*r*s - 2052*C*D1*Dd*f**3*r + 1368*C*D1*Dd*f**3*s**2 - 2052*C*D1*Dd*f**3*s + 1026*C*D1*Dd*f**3 - 8640*C*D1*Dd*f**2*fd*r**2 - 17280*C*D1*Dd*f**2*fd*r*s + 12240*C*D1*Dd*f**2*fd*r - 8640*C*D1*Dd*f**2*fd*s**2 + 12240*C*D1*Dd*f**2*fd*s - 4320*C*D1*Dd*f**2*fd - 1440*C*D1*Ddd*f**3*r**2 - 2880*C*D1*Ddd*f**3*r*s + 2160*C*D1*Ddd*f**3*r - 1440*C*D1*Ddd*f**3*s**2 + 2160*C*D1*Ddd*f**3*s - 1080*C*D1*Ddd*f**3 - 4320*C*Dd**2*f**3*r**2 - 8640*C*Dd**2*f**3*r*s + 6480*C*Dd**2*f**3*r - 4320*C*Dd**2*f**3*s**2 + 6480*C*Dd**2*f**3*s - 2160*C*Dd**2*f**3 - 324*D1**2*K*bdd1*f**2*r**2 - 648*D1**2*K*bdd1*f**2*r*s + 648*D1**2*K*bdd1*f**2*r - 324*D1**2*K*bdd1*f**2*s**2 + 648*D1**2*K*bdd1*f**2*s - 324*D1**2*K*bdd1*f**2 - 252*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 125*D1**2*bdd1*f**3*r**2 + 250*D1**2*bdd1*f**3*r*s - 250*D1**2*bdd1*f**3*r + 125*D1**2*bdd1*f**3*s**2 - 250*D1**2*bdd1*f**3*s + 125*D1**2*bdd1*f**3 + 270*D1**2*bdd1*f**2*r**2 + 540*D1**2*bdd1*f**2*r*s - 540*D1**2*bdd1*f**2*r + 270*D1**2*bdd1*f**2*s**2 - 540*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s - 504*D1**2*bdd1*f*g2*r + 252*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 - 300*D1**2*f**3*fd*r**2 - 600*D1**2*f**3*fd*r*s + 450*D1**2*f**3*fd*r - 300*D1**2*f**3*fd*s**2 + 450*D1**2*f**3*fd*s - 225*D1**2*f**3*fd - 729*D1**2*f**2*fd*r**2 - 1458*D1**2*f**2*fd*r*s + 972*D1**2*f**2*fd*r - 729*D1**2*f**2*fd*s**2 + 972*D1**2*f**2*fd*s - 486*D1**2*f**2*fd + 810*D1**2*f**2*fdd*r**2 + 1620*D1**2*f**2*fdd*r*s - 1080*D1**2*f**2*fdd*r + 810*D1**2*f**2*fdd*s**2 - 1080*D1**2*f**2*fdd*s + 540*D1**2*f**2*fdd - 414*D1**2*f**2*gd2*r**2 - 828*D1**2*f**2*gd2*r*s + 828*D1**2*f**2*gd2*r - 414*D1**2*f**2*gd2*s**2 + 828*D1**2*f**2*gd2*s - 414*D1**2*f**2*gd2 + 648*D1**2*f**2*gdd2*r**2 + 1296*D1**2*f**2*gdd2*r*s - 1296*D1**2*f**2*gdd2*r + 648*D1**2*f**2*gdd2*s**2 - 1296*D1**2*f**2*gdd2*s + 648*D1**2*f**2*gdd2 + 1620*D1**2*f*fd**2*r**2 + 3240*D1**2*f*fd**2*r*s - 2160*D1**2*f*fd**2*r + 1620*D1**2*f*fd**2*s**2 - 2160*D1**2*f*fd**2*s + 540*D1**2*f*fd**2 - 828*D1**2*f*fd*g2*r**2 - 1656*D1**2*f*fd*g2*r*s + 828*D1**2*f*fd*g2*r - 828*D1**2*f*fd*g2*s**2 + 828*D1**2*f*fd*g2*s - 414*D1**2*f*fd*g2 + 2592*D1**2*f*fd*gd2*r**2 + 5184*D1**2*f*fd*gd2*r*s - 3888*D1**2*f*fd*gd2*r + 2592*D1**2*f*fd*gd2*s**2 - 3888*D1**2*f*fd*gd2*s + 1296*D1**2*f*fd*gd2 + 1296*D1**2*f*fdd*g2*r**2 + 2592*D1**2*f*fdd*g2*r*s - 1296*D1**2*f*fdd*g2*r + 1296*D1**2*f*fdd*g2*s**2 - 1296*D1**2*f*fdd*g2*s + 648*D1**2*f*fdd*g2 + 1296*D1**2*fd**2*g2*r**2 + 2592*D1**2*fd**2*g2*r*s - 1296*D1**2*fd**2*g2*r + 1296*D1**2*fd**2*g2*s**2 - 1296*D1**2*fd**2*g2*s - 300*D1*Dd*f**4*r**2 - 600*D1*Dd*f**4*r*s + 450*D1*Dd*f**4*r - 300*D1*Dd*f**4*s**2 + 450*D1*Dd*f**4*s - 225*D1*Dd*f**4 - 972*D1*Dd*f**3*r**2 - 1944*D1*Dd*f**3*r*s + 1458*D1*Dd*f**3*r - 972*D1*Dd*f**3*s**2 + 1458*D1*Dd*f**3*s - 729*D1*Dd*f**3 + 6480*D1*Dd*f**2*fd*r**2 + 12960*D1*Dd*f**2*fd*r*s - 9180*D1*Dd*f**2*fd*r + 6480*D1*Dd*f**2*fd*s**2 - 9180*D1*Dd*f**2*fd*s + 3240*D1*Dd*f**2*fd - 1656*D1*Dd*f**2*g2*r**2 - 3312*D1*Dd*f**2*g2*r*s + 2484*D1*Dd*f**2*g2*r - 1656*D1*Dd*f**2*g2*s**2 + 2484*D1*Dd*f**2*g2*s - 1242*D1*Dd*f**2*g2 + 5184*D1*Dd*f**2*gd2*r**2 + 10368*D1*Dd*f**2*gd2*r*s - 9072*D1*Dd*f**2*gd2*r + 5184*D1*Dd*f**2*gd2*s**2 - 9072*D1*Dd*f**2*gd2*s + 3888*D1*Dd*f**2*gd2 + 10368*D1*Dd*f*fd*g2*r**2 + 20736*D1*Dd*f*fd*g2*r*s - 12960*D1*Dd*f*fd*g2*r + 10368*D1*Dd*f*fd*g2*s**2 - 12960*D1*Dd*f*fd*g2*s + 3888*D1*Dd*f*fd*g2 + 1080*D1*Ddd*f**3*r**2 + 2160*D1*Ddd*f**3*r*s - 1620*D1*Ddd*f**3*r + 1080*D1*Ddd*f**3*s**2 - 1620*D1*Ddd*f**3*s + 810*D1*Ddd*f**3 + 2592*D1*Ddd*f**2*g2*r**2 + 5184*D1*Ddd*f**2*g2*r*s - 3888*D1*Ddd*f**2*g2*r + 2592*D1*Ddd*f**2*g2*s**2 - 3888*D1*Ddd*f**2*g2*s + 1944*D1*Ddd*f**2*g2 - D1*bd1*(D1*(97*f**3*(r + s - 1) - f**2*(174*C*(r + s - 1) + 250*fd*(3*r + 3*s - 2) + (207*K - 246)*(r + s - 1)) + 6*f*(18*fd*(2*C + 6*K - 5)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) - 504*fd*g2*(r + s)) - 2*Dd*f*(125*f**2 - 54*f*(2*C + 6*K - 5) + 252*g2)*(4*r + 4*s - 3))*(r + s - 1) + 3240*Dd**2*f**3*r**2 + 6480*Dd**2*f**3*r*s - 4860*Dd**2*f**3*r + 3240*Dd**2*f**3*s**2 - 4860*Dd**2*f**3*s + 1620*Dd**2*f**3 + 7776*Dd**2*f**2*g2*r**2 + 15552*Dd**2*f**2*g2*r*s - 11664*Dd**2*f**2*g2*r + 7776*Dd**2*f**2*g2*s**2 - 11664*Dd**2*f**2*g2*s + 3888*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(348*C*D1**2*f*fd*r**2 + 696*C*D1**2*f*fd*r*s - 348*C*D1**2*f*fd*r + 348*C*D1**2*f*fd*s**2 - 348*C*D1**2*f*fd*s + 174*C*D1**2*f*fd - 216*C*D1**2*f*fdd*r**2 - 432*C*D1**2*f*fdd*r*s + 216*C*D1**2*f*fdd*r - 216*C*D1**2*f*fdd*s**2 + 216*C*D1**2*f*fdd*s - 108*C*D1**2*f*fdd - 216*C*D1**2*fd**2*r**2 - 432*C*D1**2*fd**2*r*s + 216*C*D1**2*fd**2*r - 216*C*D1**2*fd**2*s**2 + 216*C*D1**2*fd**2*s + 696*C*D1*Dd*f**2*r**2 + 1392*C*D1*Dd*f**2*r*s - 1044*C*D1*Dd*f**2*r + 696*C*D1*Dd*f**2*s**2 - 1044*C*D1*Dd*f**2*s + 522*C*D1*Dd*f**2 - 1728*C*D1*Dd*f*fd*r**2 - 3456*C*D1*Dd*f*fd*r*s + 2160*C*D1*Dd*f*fd*r - 1728*C*D1*Dd*f*fd*s**2 + 2160*C*D1*Dd*f*fd*s - 648*C*D1*Dd*f*fd - 432*C*D1*Ddd*f**2*r**2 - 864*C*D1*Ddd*f**2*r*s + 648*C*D1*Ddd*f**2*r - 432*C*D1*Ddd*f**2*s**2 + 648*C*D1*Ddd*f**2*s - 324*C*D1*Ddd*f**2 - 1296*C*Dd**2*f**2*r**2 - 2592*C*Dd**2*f**2*r*s + 1944*C*Dd**2*f**2*r - 1296*C*Dd**2*f**2*s**2 + 1944*C*Dd**2*f**2*s - 648*C*Dd**2*f**2 + 414*D1**2*K*f*fd*r**2 + 828*D1**2*K*f*fd*r*s - 414*D1**2*K*f*fd*r + 414*D1**2*K*f*fd*s**2 - 414*D1**2*K*f*fd*s + 207*D1**2*K*f*fd - 648*D1**2*K*f*fdd*r**2 - 1296*D1**2*K*f*fdd*r*s + 648*D1**2*K*f*fdd*r - 648*D1**2*K*f*fdd*s**2 + 648*D1**2*K*f*fdd*s - 324*D1**2*K*f*fdd - 648*D1**2*K*fd**2*r**2 - 1296*D1**2*K*fd**2*r*s + 648*D1**2*K*fd**2*r - 648*D1**2*K*fd**2*s**2 + 648*D1**2*K*fd**2*s - 252*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 291*D1**2*f**2*fd*r**2 - 582*D1**2*f**2*fd*r*s + 388*D1**2*f**2*fd*r - 291*D1**2*f**2*fd*s**2 + 388*D1**2*f**2*fd*s - 194*D1**2*f**2*fd + 375*D1**2*f**2*fdd*r**2 + 750*D1**2*f**2*fdd*r*s - 500*D1**2*f**2*fdd*r + 375*D1**2*f**2*fdd*s**2 - 500*D1**2*f**2*fdd*s + 250*D1**2*f**2*fdd + 750*D1**2*f*fd**2*r**2 + 1500*D1**2*f*fd**2*r*s - 1000*D1**2*f*fd**2*r + 750*D1**2*f*fd**2*s**2 - 1000*D1**2*f*fd**2*s + 250*D1**2*f*fd**2 - 492*D1**2*f*fd*r**2 - 984*D1**2*f*fd*r*s + 492*D1**2*f*fd*r - 492*D1**2*f*fd*s**2 + 492*D1**2*f*fd*s - 246*D1**2*f*fd + 540*D1**2*f*fdd*r**2 + 1080*D1**2*f*fdd*r*s - 540*D1**2*f*fdd*r + 540*D1**2*f*fdd*s**2 - 540*D1**2*f*fdd*s + 270*D1**2*f*fdd - 294*D1**2*f*gd2*r**2 - 588*D1**2*f*gd2*r*s + 588*D1**2*f*gd2*r - 294*D1**2*f*gd2*s**2 + 588*D1**2*f*gd2*s - 294*D1**2*f*gd2 + 252*D1**2*f*gdd2*r**2 + 504*D1**2*f*gdd2*r*s - 504*D1**2*f*gdd2*r + 252*D1**2*f*gdd2*s**2 - 504*D1**2*f*gdd2*s + 252*D1**2*f*gdd2 + 540*D1**2*fd**2*r**2 + 1080*D1**2*fd**2*r*s - 540*D1**2*fd**2*r + 540*D1**2*fd**2*s**2 - 540*D1**2*fd**2*s - 294*D1**2*fd*g2*r**2 - 588*D1**2*fd*g2*r*s - 294*D1**2*fd*g2*s**2 + 504*D1**2*fd*gd2*r**2 + 1008*D1**2*fd*gd2*r*s - 504*D1**2*fd*gd2*r + 504*D1**2*fd*gd2*s**2 - 504*D1**2*fd*gd2*s + 252*D1**2*fdd*g2*r**2 + 504*D1**2*fdd*g2*r*s + 252*D1**2*fdd*g2*s**2 + 828*D1*Dd*K*f**2*r**2 + 1656*D1*Dd*K*f**2*r*s - 1242*D1*Dd*K*f**2*r + 828*D1*Dd*K*f**2*s**2 - 1242*D1*Dd*K*f**2*s + 621*D1*Dd*K*f**2 - 5184*D1*Dd*K*f*fd*r**2 - 10368*D1*Dd*K*f*fd*r*s + 6480*D1*Dd*K*f*fd*r - 5184*D1*Dd*K*f*fd*s**2 + 6480*D1*Dd*K*f*fd*s - 1944*D1*Dd*K*f*fd - 388*D1*Dd*f**3*r**2 - 776*D1*Dd*f**3*r*s + 582*D1*Dd*f**3*r - 388*D1*Dd*f**3*s**2 + 582*D1*Dd*f**3*s - 291*D1*Dd*f**3 + 3000*D1*Dd*f**2*fd*r**2 + 6000*D1*Dd*f**2*fd*r*s - 4250*D1*Dd*f**2*fd*r + 3000*D1*Dd*f**2*fd*s**2 - 4250*D1*Dd*f**2*fd*s + 1500*D1*Dd*f**2*fd - 984*D1*Dd*f**2*r**2 - 1968*D1*Dd*f**2*r*s + 1476*D1*Dd*f**2*r - 984*D1*Dd*f**2*s**2 + 1476*D1*Dd*f**2*s - 738*D1*Dd*f**2 + 4320*D1*Dd*f*fd*r**2 + 8640*D1*Dd*f*fd*r*s - 5400*D1*Dd*f*fd*r + 4320*D1*Dd*f*fd*s**2 - 5400*D1*Dd*f*fd*s + 1620*D1*Dd*f*fd - 1176*D1*Dd*f*g2*r**2 - 2352*D1*Dd*f*g2*r*s + 1764*D1*Dd*f*g2*r - 1176*D1*Dd*f*g2*s**2 + 1764*D1*Dd*f*g2*s - 882*D1*Dd*f*g2 + 2016*D1*Dd*f*gd2*r**2 + 4032*D1*Dd*f*gd2*r*s - 3528*D1*Dd*f*gd2*r + 2016*D1*Dd*f*gd2*s**2 - 3528*D1*Dd*f*gd2*s + 1512*D1*Dd*f*gd2 + 2016*D1*Dd*fd*g2*r**2 + 4032*D1*Dd*fd*g2*r*s - 1512*D1*Dd*fd*g2*r + 2016*D1*Dd*fd*g2*s**2 - 1512*D1*Dd*fd*g2*s - 1296*D1*Ddd*K*f**2*r**2 - 2592*D1*Ddd*K*f**2*r*s + 1944*D1*Ddd*K*f**2*r - 1296*D1*Ddd*K*f**2*s**2 + 1944*D1*Ddd*K*f**2*s - 972*D1*Ddd*K*f**2 + 500*D1*Ddd*f**3*r**2 + 1000*D1*Ddd*f**3*r*s - 750*D1*Ddd*f**3*r + 500*D1*Ddd*f**3*s**2 - 750*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 + 1080*D1*Ddd*f**2*r**2 + 2160*D1*Ddd*f**2*r*s - 1620*D1*Ddd*f**2*r + 1080*D1*Ddd*f**2*s**2 - 1620*D1*Ddd*f**2*s + 810*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r**2 + 2016*D1*Ddd*f*g2*r*s - 1512*D1*Ddd*f*g2*r + 1008*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 756*D1*Ddd*f*g2 + 42*D1*bd1*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3888*Dd**2*K*f**2*r**2 - 7776*Dd**2*K*f**2*r*s + 5832*Dd**2*K*f**2*r - 3888*Dd**2*K*f**2*s**2 + 5832*Dd**2*K*f**2*s - 1944*Dd**2*K*f**2 + 1500*Dd**2*f**3*r**2 + 3000*Dd**2*f**3*r*s - 2250*Dd**2*f**3*r + 1500*Dd**2*f**3*s**2 - 2250*Dd**2*f**3*s + 750*Dd**2*f**3 + 3240*Dd**2*f**2*r**2 + 6480*Dd**2*f**2*r*s - 4860*Dd**2*f**2*r + 3240*Dd**2*f**2*s**2 - 4860*Dd**2*f**2*s + 1620*Dd**2*f**2 + 3024*Dd**2*f*g2*r**2 + 6048*Dd**2*f*g2*r*s - 4536*Dd**2*f*g2*r + 3024*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 1512*Dd**2*f*g2))/(315*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**3*k1**3*k2**3*(1080*C*D1**2*bdd1*f**2*r**2 + 2160*C*D1**2*bdd1*f**2*r*s - 2160*C*D1**2*bdd1*f**2*r + 1080*C*D1**2*bdd1*f**2*s**2 - 2160*C*D1**2*bdd1*f**2*s + 1080*C*D1**2*bdd1*f**2 - 60*C*D1**2*f**2*fd*r**2 - 120*C*D1**2*f**2*fd*r*s + 80*C*D1**2*f**2*fd*r - 60*C*D1**2*f**2*fd*s**2 + 80*C*D1**2*f**2*fd*s - 40*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r**2 + 1680*C*D1**2*f**2*fdd*r*s - 1120*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 1120*C*D1**2*f**2*fdd*s + 560*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r**2 + 3360*C*D1**2*f*fd**2*r*s - 2240*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 2240*C*D1**2*f*fd**2*s + 560*C*D1**2*f*fd**2 - 80*C*D1*Dd*f**3*r**2 - 160*C*D1*Dd*f**3*r*s + 120*C*D1*Dd*f**3*r - 80*C*D1*Dd*f**3*s**2 + 120*C*D1*Dd*f**3*s - 60*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r**2 + 13440*C*D1*Dd*f**2*fd*r*s - 9520*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 9520*C*D1*Dd*f**2*fd*s + 3360*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r**2 + 2240*C*D1*Ddd*f**3*r*s - 1680*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1680*C*D1*Ddd*f**3*s + 840*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r**2 + 6720*C*Dd**2*f**3*r*s - 5040*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 5040*C*Dd**2*f**3*s + 1680*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r**2 + 360*D1**2*K*bdd1*f**2*r*s - 360*D1**2*K*bdd1*f**2*r + 180*D1**2*K*bdd1*f**2*s**2 - 360*D1**2*K*bdd1*f**2*s + 180*D1**2*K*bdd1*f**2 - 36*D1**2*bd1**2*f*(-42*K + 25*f + 21)*(r + s - 1)**2 - 810*D1**2*bdd1*f**2*r**2 - 1620*D1**2*bdd1*f**2*r*s + 1620*D1**2*bdd1*f**2*r - 810*D1**2*bdd1*f**2*s**2 + 1620*D1**2*bdd1*f**2*s - 810*D1**2*bdd1*f**2 - 1512*D1**2*bdd1*f*g2*r**2 - 3024*D1**2*bdd1*f*g2*r*s + 3024*D1**2*bdd1*f*g2*r - 1512*D1**2*bdd1*f*g2*s**2 + 3024*D1**2*bdd1*f*g2*s - 1512*D1**2*bdd1*f*g2 - 105*D1**2*f**2*fd*r**2 - 210*D1**2*f**2*fd*r*s + 140*D1**2*f**2*fd*r - 105*D1**2*f**2*fd*s**2 + 140*D1**2*f**2*fd*s - 70*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 36*D1**2*f**2*gd2*r**2 - 72*D1**2*f**2*gd2*r*s + 72*D1**2*f**2*gd2*r - 36*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s - 36*D1**2*f**2*gd2 - 360*D1**2*f**2*gdd2*r**2 - 720*D1**2*f**2*gdd2*r*s + 720*D1**2*f**2*gdd2*r - 360*D1**2*f**2*gdd2*s**2 + 720*D1**2*f**2*gdd2*s - 360*D1**2*f**2*gdd2 - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 - 72*D1**2*f*fd*g2*r**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 72*D1**2*f*fd*g2*s - 36*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r**2 - 2880*D1**2*f*fd*gd2*r*s + 2160*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 2160*D1**2*f*fd*gd2*s - 720*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r**2 - 1440*D1**2*f*fdd*g2*r*s + 720*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r**2 - 1440*D1**2*fd**2*g2*r*s + 720*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s - 140*D1*Dd*f**3*r**2 - 280*D1*Dd*f**3*r*s + 210*D1*Dd*f**3*r - 140*D1*Dd*f**3*s**2 + 210*D1*Dd*f**3*s - 105*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd - 144*D1*Dd*f**2*g2*r**2 - 288*D1*Dd*f**2*g2*r*s + 216*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 216*D1*Dd*f**2*g2*s - 108*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r**2 - 5760*D1*Dd*f**2*gd2*r*s + 5040*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 5040*D1*Dd*f**2*gd2*s - 2160*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r**2 - 11520*D1*Dd*f*fd*g2*r*s + 7200*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 7200*D1*Dd*f*fd*g2*s - 2160*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r**2 - 2880*D1*Ddd*f**2*g2*r*s + 2160*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 2160*D1*Ddd*f**2*g2*s - 1080*D1*Ddd*f**2*g2 - 18*D1*bd1*(D1*(f**2*(36*C - K - 20)*(r + s - 1) - 2*f*(5*fd*(12*C + 2*K - 9)*(2*r + 2*s - 1) + (14*g2 - 84*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 2*Dd*f*(5*f*(12*C + 2*K - 9) - 84*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r**2 - 8640*Dd**2*f**2*g2*r*s + 6480*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 6480*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 + 3*b1**2*(D1**2*(3*f*(51*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(300*fd**2*(r + s - 1) + 7*fd*(12*K - 1)*(r + s) - 126*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(153*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(300*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (84*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 252*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-42*K + 25*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-42*K + 25*f + 21)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*b1*(-6*D1**2*bdd1*f*(-42*K + 25*f + 21)*(r + s - 1)**2 - 3*D1**2*(f*(fd*(36*C - K - 20)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*fdd*(12*C + 2*K - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-28*gd2 + 84*gdd2)*(r + s - 1)**2) + (-2*r - 2*s)*(5*fd**2*(12*C + 2*K - 9)*(r + s - 1) + 14*fd*(g2*(r + s) - 6*gd2*(r + s - 1)) - 42*fdd*g2*(r + s))) + D1*bd1*(D1*(153*f**2*(r + s - 1) - 300*f*fd*(2*r + 2*s - 1) - 7*f*(12*K - 1)*(r + s - 1) + 252*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-42*K + 25*f + 21)*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(f**2*(36*C - K - 20)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(5*fd*(12*C + 2*K - 9)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 14*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 84*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 168*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(5*f*(12*C + 2*K - 9) - 84*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f*(5*f*(12*C + 2*K - 9) - 84*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**3*k1**3*k2*st**2*(42*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*bd1*(D1*(-f**3*(81*r**2 + 2*r*(81*s - 49) + 81*s**2 - 98*s + 49) + f**2*(-22*C*s**2 + 50*fd*(9*r**2 + r*(18*s - 13) + 9*s**2 - 13*s + 4) - r**2*(22*C + 23) + r*(-44*C*s - 46*s + 90) - 23*s**2 + 90*s - 45) + 2*f*(18*fd*(r + s - 1)*(r*(2*C + 4) + s*(2*C + 4) - 3) - (7*r + 7*s)*(-g2*(r + s) + 6*gd2*(r + s - 1))) - 84*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(4*r + 4*s - 3)*(25*f**2*(3*r + 3*s - 2) + 18*f*(r*(C + 2) + s*(C + 2) - 3) - 42*g2*(r + s))) - 7*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-44*C*D1**2*f*fd*r**2 - 88*C*D1**2*f*fd*r*s + 88*C*D1**2*f*fd*r - 44*C*D1**2*f*fd*s**2 + 88*C*D1**2*f*fd*s - 44*C*D1**2*f*fd + 36*C*D1**2*f*fdd*r**2 + 72*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*r + 36*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 36*C*D1**2*f*fdd + 36*C*D1**2*fd**2*r**2 + 72*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*r + 36*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s + 36*C*D1**2*fd**2 - 88*C*D1*Dd*f**2*r**2 - 176*C*D1*Dd*f**2*r*s + 132*C*D1*Dd*f**2*r - 88*C*D1*Dd*f**2*s**2 + 132*C*D1*Dd*f**2*s - 66*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r**2 + 576*C*D1*Dd*f*fd*r*s - 504*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 504*C*D1*Dd*f*fd*s + 216*C*D1*Dd*f*fd + 72*C*D1*Ddd*f**2*r**2 + 144*C*D1*Ddd*f**2*r*s - 108*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s**2 - 108*C*D1*Ddd*f**2*s + 54*C*D1*Ddd*f**2 + 216*C*Dd**2*f**2*r**2 + 432*C*Dd**2*f**2*r*s - 324*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s**2 - 324*C*Dd**2*f**2*s + 108*C*Dd**2*f**2 + 21*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 243*D1**2*f**2*fd*r**2 - 486*D1**2*f**2*fd*r*s + 388*D1**2*f**2*fd*r - 243*D1**2*f**2*fd*s**2 + 388*D1**2*f**2*fd*s - 194*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 450*D1**2*f**2*fdd*r*s - 350*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 350*D1**2*f**2*fdd*s + 175*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 900*D1**2*f*fd**2*r*s - 700*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 700*D1**2*f*fd**2*s + 250*D1**2*f*fd**2 - 46*D1**2*f*fd*r**2 - 92*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 46*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 72*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 72*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 18*D1**2*f*fdd + 14*D1**2*f*gd2*r**2 + 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*r + 14*D1**2*f*gd2*s**2 - 28*D1**2*f*gd2*s + 14*D1**2*f*gd2 - 42*D1**2*f*gdd2*r**2 - 84*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*r - 42*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s - 42*D1**2*f*gdd2 + 72*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 72*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s - 36*D1**2*fd**2 + 14*D1**2*fd*g2*r**2 + 28*D1**2*fd*g2*r*s - 28*D1**2*fd*g2*r + 14*D1**2*fd*g2*s**2 - 28*D1**2*fd*g2*s + 14*D1**2*fd*g2 - 84*D1**2*fd*gd2*r**2 - 168*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 84*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 84*D1**2*fd*gd2 - 42*D1**2*fdd*g2*r**2 - 84*D1**2*fdd*g2*r*s + 84*D1**2*fdd*g2*r - 42*D1**2*fdd*g2*s**2 + 84*D1**2*fdd*g2*s - 42*D1**2*fdd*g2 - 324*D1*Dd*f**3*r**2 - 648*D1*Dd*f**3*r*s + 486*D1*Dd*f**3*r - 324*D1*Dd*f**3*s**2 + 486*D1*Dd*f**3*s - 243*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 3600*D1*Dd*f**2*fd*r*s - 2750*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 2750*D1*Dd*f**2*fd*s + 1050*D1*Dd*f**2*fd - 92*D1*Dd*f**2*r**2 - 184*D1*Dd*f**2*r*s + 138*D1*Dd*f**2*r - 92*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 69*D1*Dd*f**2 + 576*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 576*D1*Dd*f*fd*r + 576*D1*Dd*f*fd*s**2 - 576*D1*Dd*f*fd*s + 108*D1*Dd*f*fd + 56*D1*Dd*f*g2*r**2 + 112*D1*Dd*f*g2*r*s - 84*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s**2 - 84*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r**2 - 672*D1*Dd*f*gd2*r*s + 588*D1*Dd*f*gd2*r - 336*D1*Dd*f*gd2*s**2 + 588*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 336*D1*Dd*fd*g2*r**2 - 672*D1*Dd*fd*g2*r*s + 588*D1*Dd*fd*g2*r - 336*D1*Dd*fd*g2*s**2 + 588*D1*Dd*fd*g2*s - 252*D1*Dd*fd*g2 + 300*D1*Ddd*f**3*r**2 + 600*D1*Ddd*f**3*r*s - 450*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 450*D1*Ddd*f**3*s + 225*D1*Ddd*f**3 + 144*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 216*D1*Ddd*f**2*r + 144*D1*Ddd*f**2*s**2 - 216*D1*Ddd*f**2*s + 108*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r**2 - 336*D1*Ddd*f*g2*r*s + 252*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s**2 + 252*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 - 7*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 900*Dd**2*f**3*r**2 + 1800*Dd**2*f**3*r*s - 1350*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 1350*Dd**2*f**3*s + 450*Dd**2*f**3 + 432*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 648*Dd**2*f**2*r + 432*Dd**2*f**2*s**2 - 648*Dd**2*f**2*s + 216*Dd**2*f**2 - 504*Dd**2*f*g2*r**2 - 1008*Dd**2*f*g2*r*s + 756*Dd**2*f*g2*r - 504*Dd**2*f*g2*s**2 + 756*Dd**2*f*g2*s - 252*Dd**2*f*g2) + f*(D1**2*bdd1*(25*f**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 18*f*(r**2*(C + 2) + 2*r*(s*(C + 2) - 3) + s**2*(C + 2) - 6*s + 3) - 42*g2*(r + s)**2) - 3*D1**2*(f*(11*fd - 10*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 20*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 3*D1*f*(Dd*(11*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 20*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(105*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**3*k1**3*k2*(180*C*D1**2*bdd1*f**2*r**2 + 360*C*D1**2*bdd1*f**2*r*s + 180*C*D1**2*bdd1*f**2*s**2 + 600*C*D1**2*f**2*fd*r**2 + 1200*C*D1**2*f**2*fd*r*s - 800*C*D1**2*f**2*fd*r + 600*C*D1**2*f**2*fd*s**2 - 800*C*D1**2*f**2*fd*s + 400*C*D1**2*f**2*fd - 840*C*D1**2*f**2*fdd*r**2 - 1680*C*D1**2*f**2*fdd*r*s + 1120*C*D1**2*f**2*fdd*r - 840*C*D1**2*f**2*fdd*s**2 + 1120*C*D1**2*f**2*fdd*s - 560*C*D1**2*f**2*fdd - 1680*C*D1**2*f*fd**2*r**2 - 3360*C*D1**2*f*fd**2*r*s + 2240*C*D1**2*f*fd**2*r - 1680*C*D1**2*f*fd**2*s**2 + 2240*C*D1**2*f*fd**2*s - 560*C*D1**2*f*fd**2 + 800*C*D1*Dd*f**3*r**2 + 1600*C*D1*Dd*f**3*r*s - 1200*C*D1*Dd*f**3*r + 800*C*D1*Dd*f**3*s**2 - 1200*C*D1*Dd*f**3*s + 600*C*D1*Dd*f**3 - 6720*C*D1*Dd*f**2*fd*r**2 - 13440*C*D1*Dd*f**2*fd*r*s + 9520*C*D1*Dd*f**2*fd*r - 6720*C*D1*Dd*f**2*fd*s**2 + 9520*C*D1*Dd*f**2*fd*s - 3360*C*D1*Dd*f**2*fd - 1120*C*D1*Ddd*f**3*r**2 - 2240*C*D1*Ddd*f**3*r*s + 1680*C*D1*Ddd*f**3*r - 1120*C*D1*Ddd*f**3*s**2 + 1680*C*D1*Ddd*f**3*s - 840*C*D1*Ddd*f**3 - 3360*C*Dd**2*f**3*r**2 - 6720*C*Dd**2*f**3*r*s + 5040*C*Dd**2*f**3*r - 3360*C*Dd**2*f**3*s**2 + 5040*C*Dd**2*f**3*s - 1680*C*Dd**2*f**3 - 180*D1**2*K*bdd1*f**2*r**2 - 360*D1**2*K*bdd1*f**2*r*s + 360*D1**2*K*bdd1*f**2*r - 180*D1**2*K*bdd1*f**2*s**2 + 360*D1**2*K*bdd1*f**2*s - 180*D1**2*K*bdd1*f**2 + 216*D1**2*b2*f*fd*r**2 + 432*D1**2*b2*f*fd*r*s - 216*D1**2*b2*f*fd*r + 216*D1**2*b2*f*fd*s**2 - 216*D1**2*b2*f*fd*s + 108*D1**2*b2*f*fd - 360*D1**2*b2*f*fdd*r**2 - 720*D1**2*b2*f*fdd*r*s + 360*D1**2*b2*f*fdd*r - 360*D1**2*b2*f*fdd*s**2 + 360*D1**2*b2*f*fdd*s - 180*D1**2*b2*f*fdd - 360*D1**2*b2*fd**2*r**2 - 720*D1**2*b2*fd**2*r*s + 360*D1**2*b2*fd**2*r - 360*D1**2*b2*fd**2*s**2 + 360*D1**2*b2*fd**2*s + 6*D1**2*bd1**2*(r + s - 1)*(90*f**2*(r + s - 1) + 21*f*(4*C*r + 4*C*s + 2*K*r + 2*K*s + r + s - 6) - 140*g2*(r + s)) + 108*D1**2*bd2*f**2*r**2 + 216*D1**2*bd2*f**2*r*s - 216*D1**2*bd2*f**2*r + 108*D1**2*bd2*f**2*s**2 - 216*D1**2*bd2*f**2*s + 108*D1**2*bd2*f**2 - 720*D1**2*bd2*f*fd*r**2 - 1440*D1**2*bd2*f*fd*r*s + 1080*D1**2*bd2*f*fd*r - 720*D1**2*bd2*f*fd*s**2 + 1080*D1**2*bd2*f*fd*s - 360*D1**2*bd2*f*fd + 135*D1**2*bdd1*f**2*r**2 + 270*D1**2*bdd1*f**2*r*s - 540*D1**2*bdd1*f**2*r + 135*D1**2*bdd1*f**2*s**2 - 540*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r**2 - 504*D1**2*bdd1*f*g2*r*s - 252*D1**2*bdd1*f*g2*s**2 - 180*D1**2*bdd2*f**2*r**2 - 360*D1**2*bdd2*f**2*r*s + 360*D1**2*bdd2*f**2*r - 180*D1**2*bdd2*f**2*s**2 + 360*D1**2*bdd2*f**2*s - 180*D1**2*bdd2*f**2 - 165*D1**2*f**2*fd*r**2 - 330*D1**2*f**2*fd*r*s + 220*D1**2*f**2*fd*r - 165*D1**2*f**2*fd*s**2 + 220*D1**2*f**2*fd*s - 110*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd - 216*D1**2*f**2*gd2*r**2 - 432*D1**2*f**2*gd2*r*s + 432*D1**2*f**2*gd2*r - 216*D1**2*f**2*gd2*s**2 + 432*D1**2*f**2*gd2*s - 216*D1**2*f**2*gd2 + 360*D1**2*f**2*gdd2*r**2 + 720*D1**2*f**2*gdd2*r*s - 720*D1**2*f**2*gdd2*r + 360*D1**2*f**2*gdd2*s**2 - 720*D1**2*f**2*gdd2*s + 360*D1**2*f**2*gdd2 + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 432*D1**2*f*fd*g2*r**2 - 864*D1**2*f*fd*g2*r*s + 432*D1**2*f*fd*g2*r - 432*D1**2*f*fd*g2*s**2 + 432*D1**2*f*fd*g2*s - 216*D1**2*f*fd*g2 + 1440*D1**2*f*fd*gd2*r**2 + 2880*D1**2*f*fd*gd2*r*s - 2160*D1**2*f*fd*gd2*r + 1440*D1**2*f*fd*gd2*s**2 - 2160*D1**2*f*fd*gd2*s + 720*D1**2*f*fd*gd2 + 720*D1**2*f*fdd*g2*r**2 + 1440*D1**2*f*fdd*g2*r*s - 720*D1**2*f*fdd*g2*r + 720*D1**2*f*fdd*g2*s**2 - 720*D1**2*f*fdd*g2*s + 360*D1**2*f*fdd*g2 + 720*D1**2*fd**2*g2*r**2 + 1440*D1**2*fd**2*g2*r*s - 720*D1**2*fd**2*g2*r + 720*D1**2*fd**2*g2*s**2 - 720*D1**2*fd**2*g2*s + 432*D1*Dd*b2*f**2*r**2 + 864*D1*Dd*b2*f**2*r*s - 648*D1*Dd*b2*f**2*r + 432*D1*Dd*b2*f**2*s**2 - 648*D1*Dd*b2*f**2*s + 324*D1*Dd*b2*f**2 - 2880*D1*Dd*b2*f*fd*r**2 - 5760*D1*Dd*b2*f*fd*r*s + 3600*D1*Dd*b2*f*fd*r - 2880*D1*Dd*b2*f*fd*s**2 + 3600*D1*Dd*b2*f*fd*s - 1080*D1*Dd*b2*f*fd - 1440*D1*Dd*bd2*f**2*r**2 - 2880*D1*Dd*bd2*f**2*r*s + 2520*D1*Dd*bd2*f**2*r - 1440*D1*Dd*bd2*f**2*s**2 + 2520*D1*Dd*bd2*f**2*s - 1080*D1*Dd*bd2*f**2 - 220*D1*Dd*f**3*r**2 - 440*D1*Dd*f**3*r*s + 330*D1*Dd*f**3*r - 220*D1*Dd*f**3*s**2 + 330*D1*Dd*f**3*s - 165*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 864*D1*Dd*f**2*g2*r**2 - 1728*D1*Dd*f**2*g2*r*s + 1296*D1*Dd*f**2*g2*r - 864*D1*Dd*f**2*g2*s**2 + 1296*D1*Dd*f**2*g2*s - 648*D1*Dd*f**2*g2 + 2880*D1*Dd*f**2*gd2*r**2 + 5760*D1*Dd*f**2*gd2*r*s - 5040*D1*Dd*f**2*gd2*r + 2880*D1*Dd*f**2*gd2*s**2 - 5040*D1*Dd*f**2*gd2*s + 2160*D1*Dd*f**2*gd2 + 5760*D1*Dd*f*fd*g2*r**2 + 11520*D1*Dd*f*fd*g2*r*s - 7200*D1*Dd*f*fd*g2*r + 5760*D1*Dd*f*fd*g2*s**2 - 7200*D1*Dd*f*fd*g2*s + 2160*D1*Dd*f*fd*g2 - 720*D1*Ddd*b2*f**2*r**2 - 1440*D1*Ddd*b2*f**2*r*s + 1080*D1*Ddd*b2*f**2*r - 720*D1*Ddd*b2*f**2*s**2 + 1080*D1*Ddd*b2*f**2*s - 540*D1*Ddd*b2*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 1440*D1*Ddd*f**2*g2*r**2 + 2880*D1*Ddd*f**2*g2*r*s - 2160*D1*Ddd*f**2*g2*r + 1440*D1*Ddd*f**2*g2*s**2 - 2160*D1*Ddd*f**2*g2*s + 1080*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(15*f**3*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 9*f**2*(-4*C*s**2 + 4*K*(r + s - 1)**2 - r**2*(4*C + 3) - 2*r*(4*C*s + 3*s - 6) - 3*s**2 + 12*s - 6) + 60*f*fd*(r + s - 1)*(4*C*s + K*(-4*r - 4*s + 2) + r*(4*C + 3) + 3*s - 3) - 28*f*(r + s)*(-g2*(r + s) + 6*gd2*(r + s - 1)) - 168*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 6*Dd*f*(5*f*(-4*C*r - 4*C*s + 4*K*(r + s - 1) - 3*r - 3*s + 6) + 28*g2*(r + s))*(4*r + 4*s - 3)) - 2160*Dd**2*b2*f**2*r**2 - 4320*Dd**2*b2*f**2*r*s + 3240*Dd**2*b2*f**2*r - 2160*Dd**2*b2*f**2*s**2 + 3240*Dd**2*b2*f**2*s - 1080*Dd**2*b2*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 4320*Dd**2*f**2*g2*r**2 + 8640*Dd**2*f**2*g2*r*s - 6480*Dd**2*f**2*g2*r + 4320*Dd**2*f**2*g2*s**2 - 6480*Dd**2*f**2*g2*s + 2160*Dd**2*f**2*g2 + 210*b1**3*(K - 1)*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(-28*C*D1**2*fd*r**2 - 56*C*D1**2*fd*r*s + 56*C*D1**2*fd*r - 28*C*D1**2*fd*s**2 + 56*C*D1**2*fd*s - 28*C*D1**2*fd + 84*C*D1**2*fdd*r**2 + 168*C*D1**2*fdd*r*s - 168*C*D1**2*fdd*r + 84*C*D1**2*fdd*s**2 - 168*C*D1**2*fdd*s + 84*C*D1**2*fdd - 112*C*D1*Dd*f*r**2 - 224*C*D1*Dd*f*r*s + 168*C*D1*Dd*f*r - 112*C*D1*Dd*f*s**2 + 168*C*D1*Dd*f*s - 84*C*D1*Dd*f + 672*C*D1*Dd*fd*r**2 + 1344*C*D1*Dd*fd*r*s - 1176*C*D1*Dd*fd*r + 672*C*D1*Dd*fd*s**2 - 1176*C*D1*Dd*fd*s + 504*C*D1*Dd*fd + 336*C*D1*Ddd*f*r**2 + 672*C*D1*Ddd*f*r*s - 504*C*D1*Ddd*f*r + 336*C*D1*Ddd*f*s**2 - 504*C*D1*Ddd*f*s + 252*C*D1*Ddd*f + 1008*C*Dd**2*f*r**2 + 2016*C*Dd**2*f*r*s - 1512*C*Dd**2*f*r + 1008*C*Dd**2*f*s**2 - 1512*C*Dd**2*f*s + 504*C*Dd**2*f - 14*D1**2*K*fd*r**2 - 28*D1**2*K*fd*r*s + 28*D1**2*K*fd*r - 14*D1**2*K*fd*s**2 + 28*D1**2*K*fd*s - 14*D1**2*K*fd + 42*D1**2*K*fdd*r**2 + 84*D1**2*K*fdd*r*s - 84*D1**2*K*fdd*r + 42*D1**2*K*fdd*s**2 - 84*D1**2*K*fdd*s + 42*D1**2*K*fdd + 70*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 192*D1**2*f*fd*r**2 - 384*D1**2*f*fd*r*s + 234*D1**2*f*fd*r - 192*D1**2*f*fd*s**2 + 234*D1**2*f*fd*s - 117*D1**2*f*fd + 180*D1**2*f*fdd*r**2 + 360*D1**2*f*fdd*r*s - 180*D1**2*f*fdd*r + 180*D1**2*f*fdd*s**2 - 180*D1**2*f*fdd*s + 90*D1**2*f*fdd + 180*D1**2*fd**2*r**2 + 360*D1**2*fd**2*r*s - 180*D1**2*fd**2*r + 180*D1**2*fd**2*s**2 - 180*D1**2*fd**2*s - 42*D1**2*fd*r**2 - 84*D1**2*fd*r*s - 70*D1**2*fd*r - 42*D1**2*fd*s**2 - 70*D1**2*fd*s + 35*D1**2*fd + 21*D1**2*fdd*r**2 + 42*D1**2*fdd*r*s + 210*D1**2*fdd*r + 21*D1**2*fdd*s**2 + 210*D1**2*fdd*s - 105*D1**2*fdd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 - 56*D1*Dd*K*f*r**2 - 112*D1*Dd*K*f*r*s + 84*D1*Dd*K*f*r - 56*D1*Dd*K*f*s**2 + 84*D1*Dd*K*f*s - 42*D1*Dd*K*f + 336*D1*Dd*K*fd*r**2 + 672*D1*Dd*K*fd*r*s - 588*D1*Dd*K*fd*r + 336*D1*Dd*K*fd*s**2 - 588*D1*Dd*K*fd*s + 252*D1*Dd*K*fd - 384*D1*Dd*f**2*r**2 - 768*D1*Dd*f**2*r*s + 576*D1*Dd*f**2*r - 384*D1*Dd*f**2*s**2 + 576*D1*Dd*f**2*s - 288*D1*Dd*f**2 + 1440*D1*Dd*f*fd*r**2 + 2880*D1*Dd*f*fd*r*s - 1800*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 1800*D1*Dd*f*fd*s + 540*D1*Dd*f*fd - 168*D1*Dd*f*r**2 - 336*D1*Dd*f*r*s + 252*D1*Dd*f*r - 168*D1*Dd*f*s**2 + 252*D1*Dd*f*s - 126*D1*Dd*f + 168*D1*Dd*fd*r**2 + 336*D1*Dd*fd*r*s + 714*D1*Dd*fd*r + 168*D1*Dd*fd*s**2 + 714*D1*Dd*fd*s - 630*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 + 168*D1*Ddd*K*f*r**2 + 336*D1*Ddd*K*f*r*s - 252*D1*Ddd*K*f*r + 168*D1*Ddd*K*f*s**2 - 252*D1*Ddd*K*f*s + 126*D1*Ddd*K*f + 360*D1*Ddd*f**2*r**2 + 720*D1*Ddd*f**2*r*s - 540*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 540*D1*Ddd*f**2*s + 270*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 + 168*D1*Ddd*f*r*s - 126*D1*Ddd*f*r + 84*D1*Ddd*f*s**2 - 126*D1*Ddd*f*s + 63*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 + 70*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 504*Dd**2*K*f*r**2 + 1008*Dd**2*K*f*r*s - 756*Dd**2*K*f*r + 504*Dd**2*K*f*s**2 - 756*Dd**2*K*f*s + 252*Dd**2*K*f + 1080*Dd**2*f**2*r**2 + 2160*Dd**2*f**2*r*s - 1620*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1620*Dd**2*f**2*s + 540*Dd**2*f**2 + 252*Dd**2*f*r**2 + 504*Dd**2*f*r*s - 378*Dd**2*f*r + 252*Dd**2*f*s**2 - 378*Dd**2*f*s + 126*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) + 3*b1*(-72*C*D1**2*f*fd*r**2 - 144*C*D1**2*f*fd*r*s + 144*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 144*C*D1**2*f*fd*s - 72*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 240*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 240*C*D1**2*f*fdd*s + 120*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s - 240*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 240*C*D1**2*fd**2*s + 120*C*D1**2*fd**2 - 144*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 216*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 216*C*D1*Dd*f**2*s - 108*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 1680*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1680*C*D1*Dd*f*fd*s + 720*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 360*C*Dd**2*f**2 + 72*D1**2*K*f*fd*r**2 + 144*D1**2*K*f*fd*r*s - 72*D1**2*K*f*fd*r + 72*D1**2*K*f*fd*s**2 - 72*D1**2*K*f*fd*s + 36*D1**2*K*f*fd - 120*D1**2*K*f*fdd*r**2 - 240*D1**2*K*f*fdd*r*s + 120*D1**2*K*f*fdd*r - 120*D1**2*K*f*fdd*s**2 + 120*D1**2*K*f*fdd*s - 60*D1**2*K*f*fdd - 120*D1**2*K*fd**2*r**2 - 240*D1**2*K*fd**2*r*s + 120*D1**2*K*fd**2*r - 120*D1**2*K*fd**2*s**2 + 120*D1**2*K*fd**2*s + 140*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1**2*bdd1*(180*f**2*(r + s - 1)**2 + 21*f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) + 2*r**2 + 4*r*s - 14*r + 2*s**2 - 14*s + 7) - 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 90*D1**2*f**2*fd*r**2 + 180*D1**2*f**2*fd*r*s - 150*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s**2 - 150*D1**2*f**2*fd*s + 75*D1**2*f**2*fd - 54*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s - 54*D1**2*f*fd*s**2 + 90*D1**2*f*fdd*r**2 + 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*s**2 + 28*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r + 28*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s + 28*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 + 90*D1**2*fd**2*r**2 + 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*s**2 - 90*D1**2*fd**2 + 28*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 28*D1**2*fd*g2*s**2 - 56*D1**2*fd*g2*s + 28*D1**2*fd*g2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 336*D1**2*fd*gd2*s - 168*D1**2*fd*gd2 - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s + 168*D1**2*fdd*g2*r - 84*D1**2*fdd*g2*s**2 + 168*D1**2*fdd*g2*s - 84*D1**2*fdd*g2 + 144*D1*Dd*K*f**2*r**2 + 288*D1*Dd*K*f**2*r*s - 216*D1*Dd*K*f**2*r + 144*D1*Dd*K*f**2*s**2 - 216*D1*Dd*K*f**2*s + 108*D1*Dd*K*f**2 - 960*D1*Dd*K*f*fd*r**2 - 1920*D1*Dd*K*f*fd*r*s + 1200*D1*Dd*K*f*fd*r - 960*D1*Dd*K*f*fd*s**2 + 1200*D1*Dd*K*f*fd*s - 360*D1*Dd*K*f*fd + 120*D1*Dd*f**3*r**2 + 240*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r + 120*D1*Dd*f**3*s**2 - 180*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 108*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 162*D1*Dd*f**2*r - 108*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1440*D1*Dd*f*fd*r*s - 540*D1*Dd*f*fd*r + 720*D1*Dd*f*fd*s**2 - 540*D1*Dd*f*fd*s + 112*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 112*D1*Dd*f*g2*s**2 - 168*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 1176*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 1176*D1*Dd*fd*g2*s - 504*D1*Dd*fd*g2 - 240*D1*Ddd*K*f**2*r**2 - 480*D1*Ddd*K*f**2*r*s + 360*D1*Ddd*K*f**2*r - 240*D1*Ddd*K*f**2*s**2 + 360*D1*Ddd*K*f**2*s - 180*D1*Ddd*K*f**2 + 180*D1*Ddd*f**2*r**2 + 360*D1*Ddd*f**2*r*s - 270*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s**2 - 270*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + D1*bd1*(-D1*(3*f**2*(64*r**2 + 2*r*(64*s - 57) + 64*s**2 - 114*s + 57) + f*(28*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 360*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 84*r**2 + 168*r*s - 238*r + 84*s**2 - 238*s + 119) - 42*fd*(r + s - 1)*(C*(8*r + 8*s - 4) + K*(4*r + 4*s - 2) + 2*r + 2*s + 5) + 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 280*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(4*r + 4*s - 3)*(180*f**2*(r + s - 1) + 21*f*(C*(8*r + 8*s - 4) + K*(4*r + 4*s - 2) + 2*r + 2*s - 7) - 140*g2*(2*r + 2*s - 1))) - 720*Dd**2*K*f**2*r**2 - 1440*Dd**2*K*f**2*r*s + 1080*Dd**2*K*f**2*r - 720*Dd**2*K*f**2*s**2 + 1080*Dd**2*K*f**2*s - 360*Dd**2*K*f**2 + 540*Dd**2*f**2*r**2 + 1080*Dd**2*f**2*r*s - 810*Dd**2*f**2*r + 540*Dd**2*f**2*s**2 - 810*Dd**2*f**2*s + 270*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(630*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**3*k1**3*(3*D1*f*(r + s)*(2*D1*bd1**2*(5*f + 7)*(r + s - 1) + 5*D1*bdd1*f*(r + s) + bd1*(-3*D1*f*(r + s) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(30*fd**2 - fd*(18*f + 7) + fdd*(30*f + 21))*(r + s - 1)**2 + D1*(Dd*(-9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(60*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 28*r**2 - 56*r*s + 42*r - 28*s**2 + 42*s - 21) + 42*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*Ddd*f*(5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f*(5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(3*D1**2*bdd1*f*(5*f + 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*D1**2*(r + s - 1)**2*(3*f*fd - 5*f*fdd - 5*fd**2) + D1*bd1*(D1*(-9*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(60*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 14*r**2 - 28*r*s + 14*r - 14*s**2 + 14*s - 7) + 42*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*Dd*f*(5*f + 7)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 3*D1*f*(Dd*(-3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 20*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k2*k3**2) + D1**2*Pk2*Pkdd3*ct**3*k1*k2**5*st**4*(-72*C*D1**2*f**2*fd*r**2 - 144*C*D1**2*f**2*fd*r*s + 96*C*D1**2*f**2*fd*r - 72*C*D1**2*f**2*fd*s**2 + 96*C*D1**2*f**2*fd*s - 48*C*D1**2*f**2*fd + 36*C*D1**2*f**2*fdd*r**2 + 72*C*D1**2*f**2*fdd*r*s - 48*C*D1**2*f**2*fdd*r + 36*C*D1**2*f**2*fdd*s**2 - 48*C*D1**2*f**2*fdd*s + 24*C*D1**2*f**2*fdd + 72*C*D1**2*f*fd**2*r**2 + 144*C*D1**2*f*fd**2*r*s - 96*C*D1**2*f*fd**2*r + 72*C*D1**2*f*fd**2*s**2 - 96*C*D1**2*f*fd**2*s + 24*C*D1**2*f*fd**2 - 96*C*D1*Dd*f**3*r**2 - 192*C*D1*Dd*f**3*r*s + 144*C*D1*Dd*f**3*r - 96*C*D1*Dd*f**3*s**2 + 144*C*D1*Dd*f**3*s - 72*C*D1*Dd*f**3 + 288*C*D1*Dd*f**2*fd*r**2 + 576*C*D1*Dd*f**2*fd*r*s - 408*C*D1*Dd*f**2*fd*r + 288*C*D1*Dd*f**2*fd*s**2 - 408*C*D1*Dd*f**2*fd*s + 144*C*D1*Dd*f**2*fd + 48*C*D1*Ddd*f**3*r**2 + 96*C*D1*Ddd*f**3*r*s - 72*C*D1*Ddd*f**3*r + 48*C*D1*Ddd*f**3*s**2 - 72*C*D1*Ddd*f**3*s + 36*C*D1*Ddd*f**3 + 144*C*Dd**2*f**3*r**2 + 288*C*Dd**2*f**3*r*s - 216*C*Dd**2*f**3*r + 144*C*Dd**2*f**3*s**2 - 216*C*Dd**2*f**3*s + 72*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 - 144*D1**2*K*b1*f*fd*r*s + 72*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 + 54*D1**2*f**2*fd*r**2 + 108*D1**2*f**2*fd*r*s - 72*D1**2*f**2*fd*r + 54*D1**2*f**2*fd*s**2 - 72*D1**2*f**2*fd*s + 36*D1**2*f**2*fd - 27*D1**2*f**2*fdd*r**2 - 54*D1**2*f**2*fdd*r*s + 36*D1**2*f**2*fdd*r - 27*D1**2*f**2*fdd*s**2 + 36*D1**2*f**2*fdd*s - 18*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r - 36*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 54*D1**2*f*fd**2*r**2 - 108*D1**2*f*fd**2*r*s + 72*D1**2*f*fd**2*r - 54*D1**2*f*fd**2*s**2 + 72*D1**2*f*fd**2*s - 18*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 - 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 216*D1*Dd*K*b1*f**2*s - 108*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r**2 + 576*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 360*D1*Dd*K*b1*f*fd*s + 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 72*D1*Dd*f**3*r**2 + 144*D1*Dd*f**3*r*s - 108*D1*Dd*f**3*r + 72*D1*Dd*f**3*s**2 - 108*D1*Dd*f**3*s + 54*D1*Dd*f**3 - 216*D1*Dd*f**2*fd*r**2 - 432*D1*Dd*f**2*fd*r*s + 306*D1*Dd*f**2*fd*r - 216*D1*Dd*f**2*fd*s**2 + 306*D1*Dd*f**2*fd*s - 108*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 504*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 720*D1*Dd*f*fd*g2*s - 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 + 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 108*D1*Ddd*K*b1*f**2*s + 54*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 36*D1*Ddd*f**3*r**2 - 72*D1*Ddd*f**3*r*s + 54*D1*Ddd*f**3*r - 36*D1*Ddd*f**3*s**2 + 54*D1*Ddd*f**3*s - 27*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 216*D1*Ddd*f**2*g2*s - 108*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*b1*f**2*r**2 + 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 324*Dd**2*K*b1*f**2*s + 108*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 108*Dd**2*f**3*r**2 - 216*Dd**2*f**3*r*s + 162*Dd**2*f**3*r - 108*Dd**2*f**3*s**2 + 162*Dd**2*f**3*s - 54*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 648*Dd**2*f**2*g2*s - 216*Dd**2*f**2*g2)/(42*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**3*k1*k2**5*st**2*(108*C*D1**2*bdd1*f**2*r**2 + 216*C*D1**2*bdd1*f**2*r*s - 216*C*D1**2*bdd1*f**2*r + 108*C*D1**2*bdd1*f**2*s**2 - 216*C*D1**2*bdd1*f**2*s + 108*C*D1**2*bdd1*f**2 - 552*C*D1**2*f**2*fd*r**2 - 1104*C*D1**2*f**2*fd*r*s + 736*C*D1**2*f**2*fd*r - 552*C*D1**2*f**2*fd*s**2 + 736*C*D1**2*f**2*fd*s - 368*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r**2 + 1200*C*D1**2*f**2*fdd*r*s - 800*C*D1**2*f**2*fdd*r + 600*C*D1**2*f**2*fdd*s**2 - 800*C*D1**2*f**2*fdd*s + 400*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r**2 + 2400*C*D1**2*f*fd**2*r*s - 1600*C*D1**2*f*fd**2*r + 1200*C*D1**2*f*fd**2*s**2 - 1600*C*D1**2*f*fd**2*s + 400*C*D1**2*f*fd**2 - 736*C*D1*Dd*f**3*r**2 - 1472*C*D1*Dd*f**3*r*s + 1104*C*D1*Dd*f**3*r - 736*C*D1*Dd*f**3*s**2 + 1104*C*D1*Dd*f**3*s - 552*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r**2 + 9600*C*D1*Dd*f**2*fd*r*s - 6800*C*D1*Dd*f**2*fd*r + 4800*C*D1*Dd*f**2*fd*s**2 - 6800*C*D1*Dd*f**2*fd*s + 2400*C*D1*Dd*f**2*fd + 800*C*D1*Ddd*f**3*r**2 + 1600*C*D1*Ddd*f**3*r*s - 1200*C*D1*Ddd*f**3*r + 800*C*D1*Ddd*f**3*s**2 - 1200*C*D1*Ddd*f**3*s + 600*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r**2 + 4800*C*Dd**2*f**3*r*s - 3600*C*Dd**2*f**3*r + 2400*C*Dd**2*f**3*s**2 - 3600*C*Dd**2*f**3*s + 1200*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r**2 + 360*D1**2*K*bdd1*f**2*r*s - 360*D1**2*K*bdd1*f**2*r + 180*D1**2*K*bdd1*f**2*s**2 - 360*D1**2*K*bdd1*f**2*s + 180*D1**2*K*bdd1*f**2 - 18*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 81*D1**2*bdd1*f**2*r**2 - 162*D1**2*bdd1*f**2*r*s + 162*D1**2*bdd1*f**2*r - 81*D1**2*bdd1*f**2*s**2 + 162*D1**2*bdd1*f**2*s - 81*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r**2 - 504*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r - 252*D1**2*bdd1*f*g2*s**2 + 504*D1**2*bdd1*f*g2*s - 252*D1**2*bdd1*f*g2 + 195*D1**2*f**2*fd*r**2 + 390*D1**2*f**2*fd*r*s - 260*D1**2*f**2*fd*r + 195*D1**2*f**2*fd*s**2 - 260*D1**2*f**2*fd*s + 130*D1**2*f**2*fd - 300*D1**2*f**2*fdd*r**2 - 600*D1**2*f**2*fdd*r*s + 400*D1**2*f**2*fdd*r - 300*D1**2*f**2*fdd*s**2 + 400*D1**2*f**2*fdd*s - 200*D1**2*f**2*fdd + 216*D1**2*f**2*gd2*r**2 + 432*D1**2*f**2*gd2*r*s - 432*D1**2*f**2*gd2*r + 216*D1**2*f**2*gd2*s**2 - 432*D1**2*f**2*gd2*s + 216*D1**2*f**2*gd2 - 360*D1**2*f**2*gdd2*r**2 - 720*D1**2*f**2*gdd2*r*s + 720*D1**2*f**2*gdd2*r - 360*D1**2*f**2*gdd2*s**2 + 720*D1**2*f**2*gdd2*s - 360*D1**2*f**2*gdd2 - 600*D1**2*f*fd**2*r**2 - 1200*D1**2*f*fd**2*r*s + 800*D1**2*f*fd**2*r - 600*D1**2*f*fd**2*s**2 + 800*D1**2*f*fd**2*s - 200*D1**2*f*fd**2 + 432*D1**2*f*fd*g2*r**2 + 864*D1**2*f*fd*g2*r*s - 432*D1**2*f*fd*g2*r + 432*D1**2*f*fd*g2*s**2 - 432*D1**2*f*fd*g2*s + 216*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r**2 - 2880*D1**2*f*fd*gd2*r*s + 2160*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 2160*D1**2*f*fd*gd2*s - 720*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r**2 - 1440*D1**2*f*fdd*g2*r*s + 720*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r**2 - 1440*D1**2*fd**2*g2*r*s + 720*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s + 260*D1*Dd*f**3*r**2 + 520*D1*Dd*f**3*r*s - 390*D1*Dd*f**3*r + 260*D1*Dd*f**3*s**2 - 390*D1*Dd*f**3*s + 195*D1*Dd*f**3 - 2400*D1*Dd*f**2*fd*r**2 - 4800*D1*Dd*f**2*fd*r*s + 3400*D1*Dd*f**2*fd*r - 2400*D1*Dd*f**2*fd*s**2 + 3400*D1*Dd*f**2*fd*s - 1200*D1*Dd*f**2*fd + 864*D1*Dd*f**2*g2*r**2 + 1728*D1*Dd*f**2*g2*r*s - 1296*D1*Dd*f**2*g2*r + 864*D1*Dd*f**2*g2*s**2 - 1296*D1*Dd*f**2*g2*s + 648*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r**2 - 5760*D1*Dd*f**2*gd2*r*s + 5040*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 5040*D1*Dd*f**2*gd2*s - 2160*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r**2 - 11520*D1*Dd*f*fd*g2*r*s + 7200*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 7200*D1*Dd*f*fd*g2*s - 2160*D1*Dd*f*fd*g2 - 400*D1*Ddd*f**3*r**2 - 800*D1*Ddd*f**3*r*s + 600*D1*Ddd*f**3*r - 400*D1*Ddd*f**3*s**2 + 600*D1*Ddd*f**3*s - 300*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r**2 - 2880*D1*Ddd*f**2*g2*r*s + 2160*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 2160*D1*Ddd*f**2*g2*s - 1080*D1*Ddd*f**2*g2 - 9*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(24*C + 12*K - 11)*(r + s - 1) - 2*f*(fd*(12*C + 20*K - 9)*(2*r + 2*s - 1) + (28*g2 - 28*gd2)*(r + s - 1)) + 56*fd*g2*(r + s)) - 2*Dd*f*(f*(12*C + 20*K - 9) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1200*Dd**2*f**3*r**2 - 2400*Dd**2*f**3*r*s + 1800*Dd**2*f**3*r - 1200*Dd**2*f**3*s**2 + 1800*Dd**2*f**3*s - 600*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r**2 - 8640*Dd**2*f**2*g2*r*s + 6480*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 6480*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 + 9*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 9*b1*(-48*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 144*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(315*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**3*k1*k2**5*(D1*(-168*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(3*f**2*(24*C - 14*K - 5)*(r + s - 1) - 8*f*(fd*(30*C - 15)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 336*fd*g2*(r + s)) - 24*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6*f*(2*D1*bdd1*(f*(10*C - 5) - 14*g2)*(r + s - 1)**2 + D1*(f*(fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*gd2*(r + s - 1)**2) - 14*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + 7*b1**2*(D1**2*(3*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-12*K*fdd + fd*(4*K + 5))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*K + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*(f*(3*fd*(24*C - 14*K - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(120*C - 60)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s - 1)**2*(-168*K*bdd1 - 56*gd2 + 168*gdd2)) + (-8*r - 8*s)*(fd**2*(30*C - 15)*(r + s - 1) + 7*fd*(g2*(r + s) - 6*gd2*(r + s - 1)) - 21*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-24*K*fd*(r + s) + 3*f**2*(r + s - 1) + f*(4*K + 5)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(3*f**2*(24*C - 14*K - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*f*(fd*(30*C - 15)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 42*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 336*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(10*C - 5) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**3*k1*k2**3*st**4*(-42*D1**2*b1*f**2*fd*r**2 - 84*D1**2*b1*f**2*fd*r*s + 56*D1**2*b1*f**2*fd*r - 42*D1**2*b1*f**2*fd*s**2 + 56*D1**2*b1*f**2*fd*s - 28*D1**2*b1*f**2*fd + 21*D1**2*b1*f**2*fdd*r**2 + 42*D1**2*b1*f**2*fdd*r*s - 28*D1**2*b1*f**2*fdd*r + 21*D1**2*b1*f**2*fdd*s**2 - 28*D1**2*b1*f**2*fdd*s + 14*D1**2*b1*f**2*fdd + 42*D1**2*b1*f*fd**2*r**2 + 84*D1**2*b1*f*fd**2*r*s - 56*D1**2*b1*f*fd**2*r + 42*D1**2*b1*f*fd**2*s**2 - 56*D1**2*b1*f*fd**2*s + 14*D1**2*b1*f*fd**2 - 36*D1**2*b1*f*fd*r**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + D1**2*bdd1*f**2*(7*f + 9)*(r + s - 1)**2 - 18*D1**2*f**2*fd*r**2 - 36*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 24*D1**2*f**2*fd*s - 12*D1**2*f**2*fd + 9*D1**2*f**2*fdd*r**2 + 18*D1**2*f**2*fdd*r*s - 12*D1**2*f**2*fdd*r + 9*D1**2*f**2*fdd*s**2 - 12*D1**2*f**2*fdd*s + 6*D1**2*f**2*fdd + 18*D1**2*f*fd**2*r**2 + 36*D1**2*f*fd**2*r*s - 24*D1**2*f*fd**2*r + 18*D1**2*f*fd**2*s**2 - 24*D1**2*f*fd**2*s + 6*D1**2*f*fd**2 - 56*D1*Dd*b1*f**3*r**2 - 112*D1*Dd*b1*f**3*r*s + 84*D1*Dd*b1*f**3*r - 56*D1*Dd*b1*f**3*s**2 + 84*D1*Dd*b1*f**3*s - 42*D1*Dd*b1*f**3 + 168*D1*Dd*b1*f**2*fd*r**2 + 336*D1*Dd*b1*f**2*fd*r*s - 238*D1*Dd*b1*f**2*fd*r + 168*D1*Dd*b1*f**2*fd*s**2 - 238*D1*Dd*b1*f**2*fd*s + 84*D1*Dd*b1*f**2*fd - 72*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 108*D1*Dd*b1*f**2*s - 54*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 24*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 36*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 72*D1*Dd*f**2*fd*r**2 + 144*D1*Dd*f**2*fd*r*s - 102*D1*Dd*f**2*fd*r + 72*D1*Dd*f**2*fd*s**2 - 102*D1*Dd*f**2*fd*s + 36*D1*Dd*f**2*fd + 28*D1*Ddd*b1*f**3*r**2 + 56*D1*Ddd*b1*f**3*r*s - 42*D1*Ddd*b1*f**3*r + 28*D1*Ddd*b1*f**3*s**2 - 42*D1*Ddd*b1*f**3*s + 21*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*r**2 + 24*D1*Ddd*f**3*r*s - 18*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 18*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) + 9*f*(r + s - 1) - 9*fd*(2*r + 2*s - 1)) - Dd*f*(7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 84*Dd**2*b1*f**3*r**2 + 168*Dd**2*b1*f**3*r*s - 126*Dd**2*b1*f**3*r + 84*Dd**2*b1*f**3*s**2 - 126*Dd**2*b1*f**3*s + 42*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 36*Dd**2*f**3*r**2 + 72*Dd**2*f**3*r*s - 54*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 54*Dd**2*f**3*s + 18*Dd**2*f**3)/(42*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**3*k1*k2**3*st**2*(-108*C*D1**2*bdd1*f**2*r**2 - 216*C*D1**2*bdd1*f**2*r*s - 108*C*D1**2*bdd1*f**2*s**2 - 876*C*D1**2*f**2*fd*r**2 - 1752*C*D1**2*f**2*fd*r*s + 1168*C*D1**2*f**2*fd*r - 876*C*D1**2*f**2*fd*s**2 + 1168*C*D1**2*f**2*fd*s - 584*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r**2 + 1200*C*D1**2*f**2*fdd*r*s - 800*C*D1**2*f**2*fdd*r + 600*C*D1**2*f**2*fdd*s**2 - 800*C*D1**2*f**2*fdd*s + 400*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r**2 + 2400*C*D1**2*f*fd**2*r*s - 1600*C*D1**2*f*fd**2*r + 1200*C*D1**2*f*fd**2*s**2 - 1600*C*D1**2*f*fd**2*s + 400*C*D1**2*f*fd**2 - 1168*C*D1*Dd*f**3*r**2 - 2336*C*D1*Dd*f**3*r*s + 1752*C*D1*Dd*f**3*r - 1168*C*D1*Dd*f**3*s**2 + 1752*C*D1*Dd*f**3*s - 876*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r**2 + 9600*C*D1*Dd*f**2*fd*r*s - 6800*C*D1*Dd*f**2*fd*r + 4800*C*D1*Dd*f**2*fd*s**2 - 6800*C*D1*Dd*f**2*fd*s + 2400*C*D1*Dd*f**2*fd + 800*C*D1*Ddd*f**3*r**2 + 1600*C*D1*Ddd*f**3*r*s - 1200*C*D1*Ddd*f**3*r + 800*C*D1*Ddd*f**3*s**2 - 1200*C*D1*Ddd*f**3*s + 600*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r**2 + 4800*C*Dd**2*f**3*r*s - 3600*C*Dd**2*f**3*r + 2400*C*Dd**2*f**3*s**2 - 3600*C*Dd**2*f**3*s + 1200*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r**2 + 360*D1**2*K*bdd1*f**2*r*s - 360*D1**2*K*bdd1*f**2*r + 180*D1**2*K*bdd1*f**2*s**2 - 360*D1**2*K*bdd1*f**2*s + 180*D1**2*K*bdd1*f**2 - 468*D1**2*b2*f*fd*r**2 - 936*D1**2*b2*f*fd*r*s + 468*D1**2*b2*f*fd*r - 468*D1**2*b2*f*fd*s**2 + 468*D1**2*b2*f*fd*s - 234*D1**2*b2*f*fd + 360*D1**2*b2*f*fdd*r**2 + 720*D1**2*b2*f*fdd*r*s - 360*D1**2*b2*f*fdd*r + 360*D1**2*b2*f*fdd*s**2 - 360*D1**2*b2*f*fdd*s + 180*D1**2*b2*f*fdd + 360*D1**2*b2*fd**2*r**2 + 720*D1**2*b2*fd**2*r*s - 360*D1**2*b2*fd**2*r + 360*D1**2*b2*fd**2*s**2 - 360*D1**2*b2*fd**2*s + 18*D1**2*bd1**2*f*(r + s - 1)*(-14*K*(r + s) + 5*f + 7) - 234*D1**2*bd2*f**2*r**2 - 468*D1**2*bd2*f**2*r*s + 468*D1**2*bd2*f**2*r - 234*D1**2*bd2*f**2*s**2 + 468*D1**2*bd2*f**2*s - 234*D1**2*bd2*f**2 + 720*D1**2*bd2*f*fd*r**2 + 1440*D1**2*bd2*f*fd*r*s - 1080*D1**2*bd2*f*fd*r + 720*D1**2*bd2*f*fd*s**2 - 1080*D1**2*bd2*f*fd*s + 360*D1**2*bd2*f*fd + 54*D1**2*bdd1*f**2*r**2 + 108*D1**2*bdd1*f**2*r*s + 54*D1**2*bdd1*f**2*r + 54*D1**2*bdd1*f**2*s**2 + 54*D1**2*bdd1*f**2*s - 27*D1**2*bdd1*f**2 + 252*D1**2*bdd1*f*g2*r**2 + 504*D1**2*bdd1*f*g2*r*s + 252*D1**2*bdd1*f*g2*s**2 + 180*D1**2*bdd2*f**2*r**2 + 360*D1**2*bdd2*f**2*r*s - 360*D1**2*bdd2*f**2*r + 180*D1**2*bdd2*f**2*s**2 - 360*D1**2*bdd2*f**2*s + 180*D1**2*bdd2*f**2 + 357*D1**2*f**2*fd*r**2 + 714*D1**2*f**2*fd*r*s - 476*D1**2*f**2*fd*r + 357*D1**2*f**2*fd*s**2 - 476*D1**2*f**2*fd*s + 238*D1**2*f**2*fd - 300*D1**2*f**2*fdd*r**2 - 600*D1**2*f**2*fdd*r*s + 400*D1**2*f**2*fdd*r - 300*D1**2*f**2*fdd*s**2 + 400*D1**2*f**2*fdd*s - 200*D1**2*f**2*fdd + 468*D1**2*f**2*gd2*r**2 + 936*D1**2*f**2*gd2*r*s - 936*D1**2*f**2*gd2*r + 468*D1**2*f**2*gd2*s**2 - 936*D1**2*f**2*gd2*s + 468*D1**2*f**2*gd2 - 360*D1**2*f**2*gdd2*r**2 - 720*D1**2*f**2*gdd2*r*s + 720*D1**2*f**2*gdd2*r - 360*D1**2*f**2*gdd2*s**2 + 720*D1**2*f**2*gdd2*s - 360*D1**2*f**2*gdd2 - 600*D1**2*f*fd**2*r**2 - 1200*D1**2*f*fd**2*r*s + 800*D1**2*f*fd**2*r - 600*D1**2*f*fd**2*s**2 + 800*D1**2*f*fd**2*s - 200*D1**2*f*fd**2 + 936*D1**2*f*fd*g2*r**2 + 1872*D1**2*f*fd*g2*r*s - 936*D1**2*f*fd*g2*r + 936*D1**2*f*fd*g2*s**2 - 936*D1**2*f*fd*g2*s + 468*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r**2 - 2880*D1**2*f*fd*gd2*r*s + 2160*D1**2*f*fd*gd2*r - 1440*D1**2*f*fd*gd2*s**2 + 2160*D1**2*f*fd*gd2*s - 720*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r**2 - 1440*D1**2*f*fdd*g2*r*s + 720*D1**2*f*fdd*g2*r - 720*D1**2*f*fdd*g2*s**2 + 720*D1**2*f*fdd*g2*s - 360*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r**2 - 1440*D1**2*fd**2*g2*r*s + 720*D1**2*fd**2*g2*r - 720*D1**2*fd**2*g2*s**2 + 720*D1**2*fd**2*g2*s - 936*D1*Dd*b2*f**2*r**2 - 1872*D1*Dd*b2*f**2*r*s + 1404*D1*Dd*b2*f**2*r - 936*D1*Dd*b2*f**2*s**2 + 1404*D1*Dd*b2*f**2*s - 702*D1*Dd*b2*f**2 + 2880*D1*Dd*b2*f*fd*r**2 + 5760*D1*Dd*b2*f*fd*r*s - 3600*D1*Dd*b2*f*fd*r + 2880*D1*Dd*b2*f*fd*s**2 - 3600*D1*Dd*b2*f*fd*s + 1080*D1*Dd*b2*f*fd + 1440*D1*Dd*bd2*f**2*r**2 + 2880*D1*Dd*bd2*f**2*r*s - 2520*D1*Dd*bd2*f**2*r + 1440*D1*Dd*bd2*f**2*s**2 - 2520*D1*Dd*bd2*f**2*s + 1080*D1*Dd*bd2*f**2 + 476*D1*Dd*f**3*r**2 + 952*D1*Dd*f**3*r*s - 714*D1*Dd*f**3*r + 476*D1*Dd*f**3*s**2 - 714*D1*Dd*f**3*s + 357*D1*Dd*f**3 - 2400*D1*Dd*f**2*fd*r**2 - 4800*D1*Dd*f**2*fd*r*s + 3400*D1*Dd*f**2*fd*r - 2400*D1*Dd*f**2*fd*s**2 + 3400*D1*Dd*f**2*fd*s - 1200*D1*Dd*f**2*fd + 1872*D1*Dd*f**2*g2*r**2 + 3744*D1*Dd*f**2*g2*r*s - 2808*D1*Dd*f**2*g2*r + 1872*D1*Dd*f**2*g2*s**2 - 2808*D1*Dd*f**2*g2*s + 1404*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r**2 - 5760*D1*Dd*f**2*gd2*r*s + 5040*D1*Dd*f**2*gd2*r - 2880*D1*Dd*f**2*gd2*s**2 + 5040*D1*Dd*f**2*gd2*s - 2160*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r**2 - 11520*D1*Dd*f*fd*g2*r*s + 7200*D1*Dd*f*fd*g2*r - 5760*D1*Dd*f*fd*g2*s**2 + 7200*D1*Dd*f*fd*g2*s - 2160*D1*Dd*f*fd*g2 + 720*D1*Ddd*b2*f**2*r**2 + 1440*D1*Ddd*b2*f**2*r*s - 1080*D1*Ddd*b2*f**2*r + 720*D1*Ddd*b2*f**2*s**2 - 1080*D1*Ddd*b2*f**2*s + 540*D1*Ddd*b2*f**2 - 400*D1*Ddd*f**3*r**2 - 800*D1*Ddd*f**3*r*s + 600*D1*Ddd*f**3*r - 400*D1*Ddd*f**3*s**2 + 600*D1*Ddd*f**3*s - 300*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r**2 - 2880*D1*Ddd*f**2*g2*r*s + 2160*D1*Ddd*f**2*g2*r - 1440*D1*Ddd*f**2*g2*s**2 + 2160*D1*Ddd*f**2*g2*s - 1080*D1*Ddd*f**2*g2 - 9*D1*bd1*(D1*(5*f**3*(r + s - 1)**2 + f**2*(-24*C*s**2 + 26*K*(r + s - 1)**2 + r**2*(19 - 24*C) + r*(-48*C*s + 38*s - 2) + 19*s**2 - 2*s + 1) - 2*f*(fd*(r + s - 1)*(-24*C*s + 20*K*(2*r + 2*s - 1) + 3*r*(4 - 8*C) + 12*s + 3) + (28*r + 28*s)*(-g2*(r + s) + gd2*(r + s - 1))) - 56*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(f*(-12*C*r - 12*C*s + 20*K*(r + s - 1) + 6*r + 6*s + 3) + 28*g2*(r + s))*(4*r + 4*s - 3)) + 2160*Dd**2*b2*f**2*r**2 + 4320*Dd**2*b2*f**2*r*s - 3240*Dd**2*b2*f**2*r + 2160*Dd**2*b2*f**2*s**2 - 3240*Dd**2*b2*f**2*s + 1080*Dd**2*b2*f**2 - 1200*Dd**2*f**3*r**2 - 2400*Dd**2*f**3*r*s + 1800*Dd**2*f**3*r - 1200*Dd**2*f**3*s**2 + 1800*Dd**2*f**3*s - 600*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r**2 - 8640*Dd**2*f**2*g2*r*s + 6480*Dd**2*f**2*g2*r - 4320*Dd**2*f**2*g2*s**2 + 6480*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 - 9*b1**2*(D1**2*(10*fd**2*(r + s - 1) - 2*fd*(14*K*(r + s - 1)**2 + 5*f*(2*r + 2*s - 1) + 14*r + 14*s - 7) + fdd*(14*K*(r + s - 1)**2 + 5*f*(2*r + 2*s - 1) + 14*r + 14*s - 7)) + 2*D1*(Dd*(-14*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(4*r + 4*s - 3)*(14*K*(r + s - 1) + 5*f + 7)) + 7*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 84*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(-48*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 48*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 48*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 48*C*D1**2*fd**2*s + 24*C*D1**2*fd**2 - 96*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 144*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 336*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 336*C*D1*Dd*f*fd*s + 144*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 + 52*D1**2*K*f*fd*r**2 + 104*D1**2*K*f*fd*r*s - 52*D1**2*K*f*fd*r + 52*D1**2*K*f*fd*s**2 - 52*D1**2*K*f*fd*s + 26*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r**2 - 80*D1**2*K*f*fdd*r*s + 40*D1**2*K*f*fdd*r - 40*D1**2*K*f*fdd*s**2 + 40*D1**2*K*f*fdd*s - 20*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r**2 - 80*D1**2*K*fd**2*r*s + 40*D1**2*K*fd**2*r - 40*D1**2*K*fd**2*s**2 + 40*D1**2*K*fd**2*s + D1**2*bdd1*f*(7*K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 5*f*(2*r + 2*s - 1) - 14*r - 14*s + 7) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 38*D1**2*f*fd*r**2 + 76*D1**2*f*fd*r*s - 74*D1**2*f*fd*r + 38*D1**2*f*fd*s**2 - 74*D1**2*f*fd*s + 37*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 12*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s - 18*D1**2*fd**2 + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s - 112*D1**2*fd*g2*r + 56*D1**2*fd*g2*s**2 - 112*D1**2*fd*g2*s + 56*D1**2*fd*g2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 112*D1**2*fd*gd2*s - 56*D1**2*fd*gd2 - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s + 56*D1**2*fdd*g2*r - 28*D1**2*fdd*g2*s**2 + 56*D1**2*fdd*g2*s - 28*D1**2*fdd*g2 + 104*D1*Dd*K*f**2*r**2 + 208*D1*Dd*K*f**2*r*s - 156*D1*Dd*K*f**2*r + 104*D1*Dd*K*f**2*s**2 - 156*D1*Dd*K*f**2*s + 78*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r**2 - 640*D1*Dd*K*f*fd*r*s + 400*D1*Dd*K*f*fd*r - 320*D1*Dd*K*f*fd*s**2 + 400*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 76*D1*Dd*f**2*r**2 + 152*D1*Dd*f**2*r*s - 114*D1*Dd*f**2*r + 76*D1*Dd*f**2*s**2 - 114*D1*Dd*f**2*s + 57*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 192*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 192*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 392*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 392*D1*Dd*fd*g2*s - 168*D1*Dd*fd*g2 - 80*D1*Ddd*K*f**2*r**2 - 160*D1*Ddd*K*f**2*r*s + 120*D1*Ddd*K*f**2*r - 80*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 - 24*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*f**2*(2*r + 2*s - 1) - 7*f*(K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 2*r - 2*s + 1) + 7*fd*(K*(4*r + 4*s - 2) + 1)*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(7*K*(4*r + 4*s - 2) - 5*f - 7)) - 240*Dd**2*K*f**2*r**2 - 480*Dd**2*K*f**2*r*s + 360*Dd**2*K*f**2*r - 240*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 - 72*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 36*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(315*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**3*k1*k2**3*(D1*(-14*D1*bd1**2*(r + s - 1)*(6*K*f*(r + s - 2) - f*(12*C - 9)*(r + s) + 20*g2*(r + s)) + 14*b2*(bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + bd1*(-168*D1*bd2*f*(r + s - 1)**2 + D1*(3*f**2*(4*C*(17*r**2 + r*(34*s - 26) + 17*s**2 - 26*s + 13) - 14*K*(r + s - 1)**2 - 34*r**2 - 68*r*s + 38*r - 34*s**2 + 38*s - 19) - 4*f*(fd*(60*C - 30)*(r + s - 1)**2 + 7*g2*(11*r**2 + 2*r*(11*s - 7) + 11*s**2 - 14*s + 7) - 42*gd2*(r**2 + r*(2*s - 3) + s**2 - 3*s + 2)) + 168*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 12*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 11) + 4*s**2 - 11*s + 6)) - 6*f*(30*C*D1*f*fd*r**2 + 60*C*D1*f*fd*r*s - 40*C*D1*f*fd*r + 30*C*D1*f*fd*s**2 - 40*C*D1*f*fd*s + 20*C*D1*f*fd + 40*C*Dd*f**2*r**2 + 80*C*Dd*f**2*r*s - 60*C*Dd*f**2*r + 40*C*Dd*f**2*s**2 - 60*C*Dd*f**2*s + 30*C*Dd*f**2 + 7*D1*bd2*f*(r + s - 1)**2 + D1*bdd1*(f*(10*C - 5) - 14*g2)*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) - 15*D1*f*fd*r**2 - 30*D1*f*fd*r*s + 20*D1*f*fd*r - 15*D1*f*fd*s**2 + 20*D1*f*fd*s - 10*D1*f*fd - 14*D1*f*gd2*r**2 - 28*D1*f*gd2*r*s + 28*D1*f*gd2*r - 14*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 14*D1*f*gd2 - 28*D1*fd*g2*r**2 - 56*D1*fd*g2*r*s + 28*D1*fd*g2*r - 28*D1*fd*g2*s**2 + 28*D1*fd*g2*s - 14*D1*fd*g2 - 20*Dd*f**2*r**2 - 40*Dd*f**2*r*s + 30*Dd*f**2*r - 20*Dd*f**2*s**2 + 30*Dd*f**2*s - 15*Dd*f**2 - 56*Dd*f*g2*r**2 - 112*Dd*f*g2*r*s + 84*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 84*Dd*f*g2*s - 42*Dd*f*g2)) + 7*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-24*C*D1**2*fd*r**2 - 48*C*D1**2*fd*r*s + 48*C*D1**2*fd*r - 24*C*D1**2*fd*s**2 + 48*C*D1**2*fd*s - 24*C*D1**2*fd + 12*C*D1**2*fdd*r**2 + 24*C*D1**2*fdd*r*s - 24*C*D1**2*fdd*r + 12*C*D1**2*fdd*s**2 - 24*C*D1**2*fdd*s + 12*C*D1**2*fdd - 96*C*D1*Dd*f*r**2 - 192*C*D1*Dd*f*r*s + 144*C*D1*Dd*f*r - 96*C*D1*Dd*f*s**2 + 144*C*D1*Dd*f*s - 72*C*D1*Dd*f + 96*C*D1*Dd*fd*r**2 + 192*C*D1*Dd*fd*r*s - 168*C*D1*Dd*fd*r + 96*C*D1*Dd*fd*s**2 - 168*C*D1*Dd*fd*s + 72*C*D1*Dd*fd + 48*C*D1*Ddd*f*r**2 + 96*C*D1*Ddd*f*r*s - 72*C*D1*Ddd*f*r + 48*C*D1*Ddd*f*s**2 - 72*C*D1*Ddd*f*s + 36*C*D1*Ddd*f + 144*C*Dd**2*f*r**2 + 288*C*Dd**2*f*r*s - 216*C*Dd**2*f*r + 144*C*Dd**2*f*s**2 - 216*C*Dd**2*f*s + 72*C*Dd**2*f + 22*D1**2*K*fd*r**2 + 44*D1**2*K*fd*r*s - 16*D1**2*K*fd*r + 22*D1**2*K*fd*s**2 - 16*D1**2*K*fd*s + 8*D1**2*K*fd - 6*D1**2*K*fdd*r**2 - 12*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r - 6*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - D1**2*bdd1*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 6*D1**2*f*fd*r + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 18*D1**2*fd*r**2 + 36*D1**2*fd*r*s - 26*D1**2*fd*r + 18*D1**2*fd*s**2 - 26*D1**2*fd*s + 13*D1**2*fd - 9*D1**2*fdd*r**2 - 18*D1**2*fdd*r*s + 18*D1**2*fdd*r - 9*D1**2*fdd*s**2 + 18*D1**2*fdd*s - 9*D1**2*fdd + 40*D1**2*gd2*r**2 + 80*D1**2*gd2*r*s - 80*D1**2*gd2*r + 40*D1**2*gd2*s**2 - 80*D1**2*gd2*s + 40*D1**2*gd2 - 20*D1**2*gdd2*r**2 - 40*D1**2*gdd2*r*s + 40*D1**2*gdd2*r - 20*D1**2*gdd2*s**2 + 40*D1**2*gdd2*s - 20*D1**2*gdd2 + 88*D1*Dd*K*f*r**2 + 176*D1*Dd*K*f*r*s - 132*D1*Dd*K*f*r + 88*D1*Dd*K*f*s**2 - 132*D1*Dd*K*f*s + 66*D1*Dd*K*f - 48*D1*Dd*K*fd*r**2 - 96*D1*Dd*K*fd*r*s - 12*D1*Dd*K*fd*r - 48*D1*Dd*K*fd*s**2 - 12*D1*Dd*K*fd*s + 36*D1*Dd*K*fd + 72*D1*Dd*f*r**2 + 144*D1*Dd*f*r*s - 108*D1*Dd*f*r + 72*D1*Dd*f*s**2 - 108*D1*Dd*f*s + 54*D1*Dd*f - 72*D1*Dd*fd*r**2 - 144*D1*Dd*fd*r*s + 126*D1*Dd*fd*r - 72*D1*Dd*fd*s**2 + 126*D1*Dd*fd*s - 54*D1*Dd*fd + 160*D1*Dd*g2*r**2 + 320*D1*Dd*g2*r*s - 240*D1*Dd*g2*r + 160*D1*Dd*g2*s**2 - 240*D1*Dd*g2*s + 120*D1*Dd*g2 - 160*D1*Dd*gd2*r**2 - 320*D1*Dd*gd2*r*s + 280*D1*Dd*gd2*r - 160*D1*Dd*gd2*s**2 + 280*D1*Dd*gd2*s - 120*D1*Dd*gd2 - 24*D1*Ddd*K*f*r**2 - 48*D1*Ddd*K*f*r*s + 36*D1*Ddd*K*f*r - 24*D1*Ddd*K*f*s**2 + 36*D1*Ddd*K*f*s - 18*D1*Ddd*K*f - 36*D1*Ddd*f*r**2 - 72*D1*Ddd*f*r*s + 54*D1*Ddd*f*r - 36*D1*Ddd*f*s**2 + 54*D1*Ddd*f*s - 27*D1*Ddd*f - 80*D1*Ddd*g2*r**2 - 160*D1*Ddd*g2*r*s + 120*D1*Ddd*g2*r - 80*D1*Ddd*g2*s**2 + 120*D1*Ddd*g2*s - 60*D1*Ddd*g2 + 2*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-10*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 72*Dd**2*K*f*r**2 - 144*Dd**2*K*f*r*s + 108*Dd**2*K*f*r - 72*Dd**2*K*f*s**2 + 108*Dd**2*K*f*s - 36*Dd**2*K*f - 108*Dd**2*f*r**2 - 216*Dd**2*f*r*s + 162*Dd**2*f*r - 108*Dd**2*f*s**2 + 162*Dd**2*f*s - 54*Dd**2*f - 240*Dd**2*g2*r**2 - 480*Dd**2*g2*r*s + 360*Dd**2*g2*r - 240*Dd**2*g2*s**2 + 360*Dd**2*g2*s - 120*Dd**2*g2) - b1*(-168*C*D1**2*bdd1*f*r**2 - 336*C*D1**2*bdd1*f*r*s + 168*C*D1**2*bdd1*f*r - 168*C*D1**2*bdd1*f*s**2 + 168*C*D1**2*bdd1*f*s - 84*C*D1**2*bdd1*f - 408*C*D1**2*f*fd*r**2 - 816*C*D1**2*f*fd*r*s + 504*C*D1**2*f*fd*r - 408*C*D1**2*f*fd*s**2 + 504*C*D1**2*f*fd*s - 252*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s + 120*C*D1**2*f*fdd*s**2 + 120*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s + 120*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2 - 816*C*D1*Dd*f**2*r**2 - 1632*C*D1*Dd*f**2*r*s + 1224*C*D1*Dd*f**2*r - 816*C*D1*Dd*f**2*s**2 + 1224*C*D1*Dd*f**2*s - 612*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 720*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 360*C*Dd**2*f**2 + 84*D1**2*K*bdd1*f*r**2 + 168*D1**2*K*bdd1*f*r*s - 252*D1**2*K*bdd1*f*r + 84*D1**2*K*bdd1*f*s**2 - 252*D1**2*K*bdd1*f*s + 126*D1**2*K*bdd1*f + 84*D1**2*K*f*fd*r**2 + 168*D1**2*K*f*fd*r*s - 84*D1**2*K*f*fd*r + 84*D1**2*K*f*fd*s**2 - 84*D1**2*K*f*fd*s + 42*D1**2*K*f*fd - 98*D1**2*b2*fd*r**2 - 196*D1**2*b2*fd*r*s - 98*D1**2*b2*fd*s**2 + 84*D1**2*b2*fdd*r**2 + 168*D1**2*b2*fdd*r*s + 84*D1**2*b2*fdd*s**2 + 14*D1**2*bd1**2*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 126*D1**2*bdd1*f*r**2 + 252*D1**2*bdd1*f*r*s - 126*D1**2*bdd1*f*r + 126*D1**2*bdd1*f*s**2 - 126*D1**2*bdd1*f*s + 63*D1**2*bdd1*f + 280*D1**2*bdd1*g2*r**2 + 560*D1**2*bdd1*g2*r*s - 280*D1**2*bdd1*g2*r + 280*D1**2*bdd1*g2*s**2 - 280*D1**2*bdd1*g2*s + 140*D1**2*bdd1*g2 + 84*D1**2*bdd2*f*r**2 + 168*D1**2*bdd2*f*r*s - 168*D1**2*bdd2*f*r + 84*D1**2*bdd2*f*s**2 - 168*D1**2*bdd2*f*s + 84*D1**2*bdd2*f + 204*D1**2*f*fd*r**2 + 408*D1**2*f*fd*r*s - 294*D1**2*f*fd*r + 204*D1**2*f*fd*s**2 - 294*D1**2*f*fd*s + 147*D1**2*f*fd - 60*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*s**2 + 308*D1**2*f*gd2*r**2 + 616*D1**2*f*gd2*r*s - 616*D1**2*f*gd2*r + 308*D1**2*f*gd2*s**2 - 616*D1**2*f*gd2*s + 308*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 60*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s - 60*D1**2*fd**2*s**2 + 60*D1**2*fd**2 + 308*D1**2*fd*g2*r**2 + 616*D1**2*fd*g2*r*s - 224*D1**2*fd*g2*r + 308*D1**2*fd*g2*s**2 - 224*D1**2*fd*g2*s + 112*D1**2*fd*g2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2 - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r - 84*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 + 168*D1*Dd*K*f**2*r**2 + 336*D1*Dd*K*f**2*r*s - 252*D1*Dd*K*f**2*r + 168*D1*Dd*K*f**2*s**2 - 252*D1*Dd*K*f**2*s + 126*D1*Dd*K*f**2 - 392*D1*Dd*b2*f*r**2 - 784*D1*Dd*b2*f*r*s + 588*D1*Dd*b2*f*r - 392*D1*Dd*b2*f*s**2 + 588*D1*Dd*b2*f*s - 294*D1*Dd*b2*f + 672*D1*Dd*b2*fd*r**2 + 1344*D1*Dd*b2*fd*r*s - 504*D1*Dd*b2*fd*r + 672*D1*Dd*b2*fd*s**2 - 504*D1*Dd*b2*fd*s + 408*D1*Dd*f**2*r**2 + 816*D1*Dd*f**2*r*s - 612*D1*Dd*f**2*r + 408*D1*Dd*f**2*s**2 - 612*D1*Dd*f**2*s + 306*D1*Dd*f**2 - 480*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s + 1232*D1*Dd*f*g2*r**2 + 2464*D1*Dd*f*g2*r*s - 1848*D1*Dd*f*g2*r + 1232*D1*Dd*f*g2*s**2 - 1848*D1*Dd*f*g2*s + 924*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s - 168*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 + 336*D1*Ddd*b2*f*r**2 + 672*D1*Ddd*b2*f*r*s - 504*D1*Ddd*b2*f*r + 336*D1*Ddd*b2*f*s**2 - 504*D1*Ddd*b2*f*s + 252*D1*Ddd*b2*f - 120*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 90*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(f**2*(6*r + 6*s - 3) + f*(24*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*K*(11*r**2 + 22*r*s - 18*r + 11*s**2 - 18*s + 9) - 36*r**2 - 72*r*s + 46*r - 36*s**2 + 46*s - 23) + 6*fd*(r + s - 1)*(C*(-8*r - 8*s + 4) + K*(4*r + 4*s + 2) + 6*r + 6*s - 3) - 40*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(3*f*(C*(8*r + 8*s - 4) + K*(-4*r - 4*s + 6) - 6*r - 6*s + 3) - 20*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 14*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 1008*Dd**2*b2*f*r**2 + 2016*Dd**2*b2*f*r*s - 1512*Dd**2*b2*f*r + 1008*Dd**2*b2*f*s**2 - 1512*Dd**2*b2*f*s + 504*Dd**2*b2*f - 360*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 540*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 180*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**3*k1*k2*st**2*(D1*f*(r + s)*(2*D1*bd1**2*(5*f + 7)*(r + s - 1) + 3*D1*bdd1*f*(r + s) + 6*bd1*(-D1*f*(r + s) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(10*fd**2 + fd*(-20*f - 14) + fdd*(10*f + 7))*(r + s - 1)**2 + D1*(-2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-10*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) - 7*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*bdd1*f*(5*f + 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*D1**2*(r + s - 1)**2*(2*f*fd - f*fdd - fd**2) - 2*D1*bd1*(D1*(5*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(-10*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 14*r**2 + 28*r*s - 14*r + 14*s**2 - 14*s + 7) - 7*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - Dd*f*(5*f + 7)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 3*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(35*d**2*k3**2) - D1**2*Pk2*Pkdd3*ct**3*k1*k2*(D1*(r + s)*(42*D1*bd1**2*f*(2*K - 1)*(r + s - 1) + 6*D1*bdd1*f*(r + s)*(7*b2 + f*(10*C - 5) - 14*g2) + bd1*(-36*C*D1*f**2*r - 36*C*D1*f**2*s + 240*C*D1*f*fd*r + 240*C*D1*f*fd*s - 240*C*D1*f*fd + 480*C*Dd*f**2*r + 480*C*Dd*f**2*s - 360*C*Dd*f**2 + 84*D1*bd2*f*(r + s - 1) - 3*D1*f**2*r - 3*D1*f**2*s - 120*D1*f*fd*r - 120*D1*f*fd*s + 120*D1*f*fd + 28*D1*f*g2*r + 28*D1*f*g2*s - 168*D1*f*gd2*r - 168*D1*f*gd2*s + 168*D1*f*gd2 - 168*D1*fd*g2*r - 168*D1*fd*g2*s + 168*D1*fd*g2 - 240*Dd*f**2*r - 240*Dd*f**2*s + 180*Dd*f**2 - 672*Dd*f*g2*r - 672*Dd*f*g2*s + 504*Dd*f*g2 + 14*b2*(-D1*f*(r + s) + 6*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3)))) + 7*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 20*r**2 + 40*r*s - 30*r + 20*s**2 - 30*s + 15) - Ddd*(3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-2*D1**2*K*fd*r**2 - 4*D1**2*K*fd*r*s + 4*D1**2*K*fd*r - 2*D1**2*K*fd*s**2 + 4*D1**2*K*fd*s - 2*D1**2*K*fd + 6*D1**2*K*fdd*r**2 + 12*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r + 6*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - D1**2*bdd1*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 6*D1**2*f*fd + D1**2*fd*r**2 + 2*D1**2*fd*r*s - 2*D1**2*fd*r + D1**2*fd*s**2 - 2*D1**2*fd*s + D1**2*fd - 3*D1**2*fdd*r**2 - 6*D1**2*fdd*r*s + 6*D1**2*fdd*r - 3*D1**2*fdd*s**2 + 6*D1**2*fdd*s - 3*D1**2*fdd - 8*D1*Dd*K*f*r**2 - 16*D1*Dd*K*f*r*s + 12*D1*Dd*K*f*r - 8*D1*Dd*K*f*s**2 + 12*D1*Dd*K*f*s - 6*D1*Dd*K*f + 48*D1*Dd*K*fd*r**2 + 96*D1*Dd*K*fd*r*s - 84*D1*Dd*K*fd*r + 48*D1*Dd*K*fd*s**2 - 84*D1*Dd*K*fd*s + 36*D1*Dd*K*fd - 12*D1*Dd*f**2*r**2 - 24*D1*Dd*f**2*r*s + 18*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 18*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 4*D1*Dd*f*r**2 + 8*D1*Dd*f*r*s - 6*D1*Dd*f*r + 4*D1*Dd*f*s**2 - 6*D1*Dd*f*s + 3*D1*Dd*f - 24*D1*Dd*fd*r**2 - 48*D1*Dd*fd*r*s + 42*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 42*D1*Dd*fd*s - 18*D1*Dd*fd + 24*D1*Ddd*K*f*r**2 + 48*D1*Ddd*K*f*r*s - 36*D1*Ddd*K*f*r + 24*D1*Ddd*K*f*s**2 - 36*D1*Ddd*K*f*s + 18*D1*Ddd*K*f - 12*D1*Ddd*f*r**2 - 24*D1*Ddd*f*r*s + 18*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 18*D1*Ddd*f*s - 9*D1*Ddd*f + 2*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 15*r**2 + 30*r*s - 20*r + 15*s**2 - 20*s + 10) - Dd*(3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 72*Dd**2*K*f*r**2 + 144*Dd**2*K*f*r*s - 108*Dd**2*K*f*r + 72*Dd**2*K*f*s**2 - 108*Dd**2*K*f*s + 36*Dd**2*K*f - 36*Dd**2*f*r**2 - 72*Dd**2*f*r*s + 54*Dd**2*f*r - 36*Dd**2*f*s**2 + 54*Dd**2*f*s - 18*Dd**2*f) - b1*(72*C*D1**2*f*fd*r**2 + 144*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s**2 - 144*C*D1**2*f*fd*s + 72*C*D1**2*f*fd - 120*C*D1**2*f*fdd*r**2 - 240*C*D1**2*f*fdd*r*s + 240*C*D1**2*f*fdd*r - 120*C*D1**2*f*fdd*s**2 + 240*C*D1**2*f*fdd*s - 120*C*D1**2*f*fdd - 120*C*D1**2*fd**2*r**2 - 240*C*D1**2*fd**2*r*s + 240*C*D1**2*fd**2*r - 120*C*D1**2*fd**2*s**2 + 240*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 + 144*C*D1*Dd*f**2*r**2 + 288*C*D1*Dd*f**2*r*s - 216*C*D1*Dd*f**2*r + 144*C*D1*Dd*f**2*s**2 - 216*C*D1*Dd*f**2*s + 108*C*D1*Dd*f**2 - 960*C*D1*Dd*f*fd*r**2 - 1920*C*D1*Dd*f*fd*r*s + 1680*C*D1*Dd*f*fd*r - 960*C*D1*Dd*f*fd*s**2 + 1680*C*D1*Dd*f*fd*s - 720*C*D1*Dd*f*fd - 240*C*D1*Ddd*f**2*r**2 - 480*C*D1*Ddd*f**2*r*s + 360*C*D1*Ddd*f**2*r - 240*C*D1*Ddd*f**2*s**2 + 360*C*D1*Ddd*f**2*s - 180*C*D1*Ddd*f**2 - 720*C*Dd**2*f**2*r**2 - 1440*C*Dd**2*f**2*r*s + 1080*C*Dd**2*f**2*r - 720*C*Dd**2*f**2*s**2 + 1080*C*Dd**2*f**2*s - 360*C*Dd**2*f**2 - 84*D1**2*K*bdd1*f*r**2 - 168*D1**2*K*bdd1*f*r*s + 84*D1**2*K*bdd1*f*r - 84*D1**2*K*bdd1*f*s**2 + 84*D1**2*K*bdd1*f*s - 42*D1**2*K*bdd1*f + 14*D1**2*b2*fd*r**2 + 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*r + 14*D1**2*b2*fd*s**2 - 28*D1**2*b2*fd*s + 14*D1**2*b2*fd - 42*D1**2*b2*fdd*r**2 - 84*D1**2*b2*fdd*r*s + 84*D1**2*b2*fdd*r - 42*D1**2*b2*fdd*s**2 + 84*D1**2*b2*fdd*s - 42*D1**2*b2*fdd + 14*D1**2*bd1**2*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 42*D1**2*bdd1*f*r**2 + 84*D1**2*bdd1*f*r*s - 42*D1**2*bdd1*f*r + 42*D1**2*bdd1*f*s**2 - 42*D1**2*bdd1*f*s + 21*D1**2*bdd1*f - 42*D1**2*bdd2*f*r**2 - 84*D1**2*bdd2*f*r*s + 84*D1**2*bdd2*f*r - 42*D1**2*bdd2*f*s**2 + 84*D1**2*bdd2*f*s - 42*D1**2*bdd2*f + 6*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s - 12*D1**2*f*fd*r + 6*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s + 6*D1**2*f*fd + 60*D1**2*f*fdd*r**2 + 120*D1**2*f*fdd*r*s - 120*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 - 120*D1**2*f*fdd*s + 60*D1**2*f*fdd - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 84*D1**2*f*gdd2*r**2 + 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*r + 84*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s + 84*D1**2*f*gdd2 + 60*D1**2*fd**2*r**2 + 120*D1**2*fd**2*r*s - 120*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 120*D1**2*fd**2*s + 60*D1**2*fd**2 - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 168*D1**2*fd*gd2*r**2 + 336*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 336*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 + 84*D1**2*fdd*g2*r**2 + 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r + 84*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 + 56*D1*Dd*b2*f*r**2 + 112*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 56*D1*Dd*b2*f*s**2 - 84*D1*Dd*b2*f*s + 42*D1*Dd*b2*f - 336*D1*Dd*b2*fd*r**2 - 672*D1*Dd*b2*fd*r*s + 588*D1*Dd*b2*fd*r - 336*D1*Dd*b2*fd*s**2 + 588*D1*Dd*b2*fd*s - 252*D1*Dd*b2*fd + 12*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 12*D1*Dd*f**2*s**2 - 18*D1*Dd*f**2*s + 9*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 + 960*D1*Dd*f*fd*r*s - 840*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 840*D1*Dd*f*fd*s + 360*D1*Dd*f*fd - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r**2 + 1344*D1*Dd*f*gd2*r*s - 1176*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 1176*D1*Dd*f*gd2*s + 504*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r**2 + 1344*D1*Dd*fd*g2*r*s - 1176*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 1176*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 - 168*D1*Ddd*b2*f*r**2 - 336*D1*Ddd*b2*f*r*s + 252*D1*Ddd*b2*f*r - 168*D1*Ddd*b2*f*s**2 + 252*D1*Ddd*b2*f*s - 126*D1*Ddd*b2*f + 120*D1*Ddd*f**2*r**2 + 240*D1*Ddd*f**2*r*s - 180*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 180*D1*Ddd*f**2*s + 90*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r**2 + 672*D1*Ddd*f*g2*r*s - 504*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 504*D1*Ddd*f*g2*s + 252*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(3*f**2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + f*(2*K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*K - 1)*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(2*K - 1)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 14*D1*bd2*(D1*(f - 6*fd)*(r + s - 1) - 6*Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 504*Dd**2*b2*f*r**2 - 1008*Dd**2*b2*f*r*s + 756*Dd**2*b2*f*r - 504*Dd**2*b2*f*s**2 + 756*Dd**2*b2*f*s - 252*Dd**2*b2*f + 360*Dd**2*f**2*r**2 + 720*Dd**2*f**2*r*s - 540*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 540*Dd**2*f**2*s + 180*Dd**2*f**2 + 1008*Dd**2*f*g2*r**2 + 2016*Dd**2*f*g2*r*s - 1512*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1512*Dd**2*f*g2*s + 504*Dd**2*f*g2))/(210*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**2*k1**6*st**2*(-66*C*D1**2*f**2*fd*r**2 - 132*C*D1**2*f**2*fd*r*s + 88*C*D1**2*f**2*fd*r - 66*C*D1**2*f**2*fd*s**2 + 88*C*D1**2*f**2*fd*s - 44*C*D1**2*f**2*fd + 330*C*D1**2*f**2*fdd*r**2 + 660*C*D1**2*f**2*fdd*r*s - 440*C*D1**2*f**2*fdd*r + 330*C*D1**2*f**2*fdd*s**2 - 440*C*D1**2*f**2*fdd*s + 220*C*D1**2*f**2*fdd + 660*C*D1**2*f*fd**2*r**2 + 1320*C*D1**2*f*fd**2*r*s - 880*C*D1**2*f*fd**2*r + 660*C*D1**2*f*fd**2*s**2 - 880*C*D1**2*f*fd**2*s + 220*C*D1**2*f*fd**2 - 88*C*D1*Dd*f**3*r**2 - 176*C*D1*Dd*f**3*r*s + 132*C*D1*Dd*f**3*r - 88*C*D1*Dd*f**3*s**2 + 132*C*D1*Dd*f**3*s - 66*C*D1*Dd*f**3 + 2640*C*D1*Dd*f**2*fd*r**2 + 5280*C*D1*Dd*f**2*fd*r*s - 3740*C*D1*Dd*f**2*fd*r + 2640*C*D1*Dd*f**2*fd*s**2 - 3740*C*D1*Dd*f**2*fd*s + 1320*C*D1*Dd*f**2*fd + 440*C*D1*Ddd*f**3*r**2 + 880*C*D1*Ddd*f**3*r*s - 660*C*D1*Ddd*f**3*r + 440*C*D1*Ddd*f**3*s**2 - 660*C*D1*Ddd*f**3*s + 330*C*D1*Ddd*f**3 + 1320*C*Dd**2*f**3*r**2 + 2640*C*Dd**2*f**3*r*s - 1980*C*Dd**2*f**3*r + 1320*C*Dd**2*f**3*s**2 - 1980*C*Dd**2*f**3*s + 660*C*Dd**2*f**3 + 66*D1**2*K*b1*f*fd*r**2 + 132*D1**2*K*b1*f*fd*r*s - 66*D1**2*K*b1*f*fd*r + 66*D1**2*K*b1*f*fd*s**2 - 66*D1**2*K*b1*f*fd*s + 33*D1**2*K*b1*f*fd + 198*D1**2*K*b1*f*fdd*r**2 + 396*D1**2*K*b1*f*fdd*r*s - 198*D1**2*K*b1*f*fdd*r + 198*D1**2*K*b1*f*fdd*s**2 - 198*D1**2*K*b1*f*fdd*s + 99*D1**2*K*b1*f*fdd + 198*D1**2*K*b1*fd**2*r**2 + 396*D1**2*K*b1*fd**2*r*s - 198*D1**2*K*b1*fd**2*r + 198*D1**2*K*b1*fd**2*s**2 - 198*D1**2*K*b1*fd**2*s - 66*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fd*s**2 + 66*D1**2*b1*f*fd*s - 33*D1**2*b1*f*fd - 198*D1**2*b1*f*fdd*r**2 - 396*D1**2*b1*f*fdd*r*s + 198*D1**2*b1*f*fdd*r - 198*D1**2*b1*f*fdd*s**2 + 198*D1**2*b1*f*fdd*s - 99*D1**2*b1*f*fdd - 198*D1**2*b1*fd**2*r**2 - 396*D1**2*b1*fd**2*r*s + 198*D1**2*b1*fd**2*r - 198*D1**2*b1*fd**2*s**2 + 198*D1**2*b1*fd**2*s + 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 - 3120*D1**2*f**3*fd*r**2 - 6240*D1**2*f**3*fd*r*s + 4680*D1**2*f**3*fd*r - 3120*D1**2*f**3*fd*s**2 + 4680*D1**2*f**3*fd*s - 2340*D1**2*f**3*fd + 4200*D1**2*f**3*fdd*r**2 + 8400*D1**2*f**3*fdd*r*s - 6300*D1**2*f**3*fdd*r + 4200*D1**2*f**3*fdd*s**2 - 6300*D1**2*f**3*fdd*s + 3150*D1**2*f**3*fdd + 12600*D1**2*f**2*fd**2*r**2 + 25200*D1**2*f**2*fd**2*r*s - 18900*D1**2*f**2*fd**2*r + 12600*D1**2*f**2*fd**2*s**2 - 18900*D1**2*f**2*fd**2*s + 6300*D1**2*f**2*fd**2 + 66*D1**2*f**2*fd*r**2 + 132*D1**2*f**2*fd*r*s - 88*D1**2*f**2*fd*r + 66*D1**2*f**2*fd*s**2 - 88*D1**2*f**2*fd*s + 44*D1**2*f**2*fd - 330*D1**2*f**2*fdd*r**2 - 660*D1**2*f**2*fdd*r*s + 440*D1**2*f**2*fdd*r - 330*D1**2*f**2*fdd*s**2 + 440*D1**2*f**2*fdd*s - 220*D1**2*f**2*fdd - 66*D1**2*f**2*gd2*r**2 - 132*D1**2*f**2*gd2*r*s + 132*D1**2*f**2*gd2*r - 66*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s - 66*D1**2*f**2*gd2 - 198*D1**2*f**2*gdd2*r**2 - 396*D1**2*f**2*gdd2*r*s + 396*D1**2*f**2*gdd2*r - 198*D1**2*f**2*gdd2*s**2 + 396*D1**2*f**2*gdd2*s - 198*D1**2*f**2*gdd2 - 660*D1**2*f*fd**2*r**2 - 1320*D1**2*f*fd**2*r*s + 880*D1**2*f*fd**2*r - 660*D1**2*f*fd**2*s**2 + 880*D1**2*f*fd**2*s - 220*D1**2*f*fd**2 - 132*D1**2*f*fd*g2*r**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 132*D1**2*f*fd*g2*s**2 + 132*D1**2*f*fd*g2*s - 66*D1**2*f*fd*g2 - 792*D1**2*f*fd*gd2*r**2 - 1584*D1**2*f*fd*gd2*r*s + 1188*D1**2*f*fd*gd2*r - 792*D1**2*f*fd*gd2*s**2 + 1188*D1**2*f*fd*gd2*s - 396*D1**2*f*fd*gd2 - 396*D1**2*f*fdd*g2*r**2 - 792*D1**2*f*fdd*g2*r*s + 396*D1**2*f*fdd*g2*r - 396*D1**2*f*fdd*g2*s**2 + 396*D1**2*f*fdd*g2*s - 198*D1**2*f*fdd*g2 - 396*D1**2*fd**2*g2*r**2 - 792*D1**2*fd**2*g2*r*s + 396*D1**2*fd**2*g2*r - 396*D1**2*fd**2*g2*s**2 + 396*D1**2*fd**2*g2*s + 132*D1*Dd*K*b1*f**2*r**2 + 264*D1*Dd*K*b1*f**2*r*s - 198*D1*Dd*K*b1*f**2*r + 132*D1*Dd*K*b1*f**2*s**2 - 198*D1*Dd*K*b1*f**2*s + 99*D1*Dd*K*b1*f**2 + 1584*D1*Dd*K*b1*f*fd*r**2 + 3168*D1*Dd*K*b1*f*fd*r*s - 1980*D1*Dd*K*b1*f*fd*r + 1584*D1*Dd*K*b1*f*fd*s**2 - 1980*D1*Dd*K*b1*f*fd*s + 594*D1*Dd*K*b1*f*fd - 132*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 198*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s**2 + 198*D1*Dd*b1*f**2*s - 99*D1*Dd*b1*f**2 - 1584*D1*Dd*b1*f*fd*r**2 - 3168*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r - 1584*D1*Dd*b1*f*fd*s**2 + 1980*D1*Dd*b1*f*fd*s - 594*D1*Dd*b1*f*fd - 3120*D1*Dd*f**4*r**2 - 6240*D1*Dd*f**4*r*s + 4680*D1*Dd*f**4*r - 3120*D1*Dd*f**4*s**2 + 4680*D1*Dd*f**4*s - 2340*D1*Dd*f**4 + 33600*D1*Dd*f**3*fd*r**2 + 67200*D1*Dd*f**3*fd*r*s - 50400*D1*Dd*f**3*fd*r + 33600*D1*Dd*f**3*fd*s**2 - 50400*D1*Dd*f**3*fd*s + 18900*D1*Dd*f**3*fd + 88*D1*Dd*f**3*r**2 + 176*D1*Dd*f**3*r*s - 132*D1*Dd*f**3*r + 88*D1*Dd*f**3*s**2 - 132*D1*Dd*f**3*s + 66*D1*Dd*f**3 - 2640*D1*Dd*f**2*fd*r**2 - 5280*D1*Dd*f**2*fd*r*s + 3740*D1*Dd*f**2*fd*r - 2640*D1*Dd*f**2*fd*s**2 + 3740*D1*Dd*f**2*fd*s - 1320*D1*Dd*f**2*fd - 264*D1*Dd*f**2*g2*r**2 - 528*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 264*D1*Dd*f**2*g2*s**2 + 396*D1*Dd*f**2*g2*s - 198*D1*Dd*f**2*g2 - 1584*D1*Dd*f**2*gd2*r**2 - 3168*D1*Dd*f**2*gd2*r*s + 2772*D1*Dd*f**2*gd2*r - 1584*D1*Dd*f**2*gd2*s**2 + 2772*D1*Dd*f**2*gd2*s - 1188*D1*Dd*f**2*gd2 - 3168*D1*Dd*f*fd*g2*r**2 - 6336*D1*Dd*f*fd*g2*r*s + 3960*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s**2 + 3960*D1*Dd*f*fd*g2*s - 1188*D1*Dd*f*fd*g2 + 396*D1*Ddd*K*b1*f**2*r**2 + 792*D1*Ddd*K*b1*f**2*r*s - 594*D1*Ddd*K*b1*f**2*r + 396*D1*Ddd*K*b1*f**2*s**2 - 594*D1*Ddd*K*b1*f**2*s + 297*D1*Ddd*K*b1*f**2 - 396*D1*Ddd*b1*f**2*r**2 - 792*D1*Ddd*b1*f**2*r*s + 594*D1*Ddd*b1*f**2*r - 396*D1*Ddd*b1*f**2*s**2 + 594*D1*Ddd*b1*f**2*s - 297*D1*Ddd*b1*f**2 + 4200*D1*Ddd*f**4*r**2 + 8400*D1*Ddd*f**4*r*s - 6300*D1*Ddd*f**4*r + 4200*D1*Ddd*f**4*s**2 - 6300*D1*Ddd*f**4*s + 3150*D1*Ddd*f**4 - 440*D1*Ddd*f**3*r**2 - 880*D1*Ddd*f**3*r*s + 660*D1*Ddd*f**3*r - 440*D1*Ddd*f**3*s**2 + 660*D1*Ddd*f**3*s - 330*D1*Ddd*f**3 - 792*D1*Ddd*f**2*g2*r**2 - 1584*D1*Ddd*f**2*g2*r*s + 1188*D1*Ddd*f**2*g2*r - 792*D1*Ddd*f**2*g2*s**2 + 1188*D1*Ddd*f**2*g2*s - 594*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) + 6*D1*fd*(2*r + 2*s - 1) + 6*Dd*f*(4*r + 4*s - 3)) + 1188*Dd**2*K*b1*f**2*r**2 + 2376*Dd**2*K*b1*f**2*r*s - 1782*Dd**2*K*b1*f**2*r + 1188*Dd**2*K*b1*f**2*s**2 - 1782*Dd**2*K*b1*f**2*s + 594*Dd**2*K*b1*f**2 - 1188*Dd**2*b1*f**2*r**2 - 2376*Dd**2*b1*f**2*r*s + 1782*Dd**2*b1*f**2*r - 1188*Dd**2*b1*f**2*s**2 + 1782*Dd**2*b1*f**2*s - 594*Dd**2*b1*f**2 + 12600*Dd**2*f**4*r**2 + 25200*Dd**2*f**4*r*s - 18900*Dd**2*f**4*r + 12600*Dd**2*f**4*s**2 - 18900*Dd**2*f**4*s + 6300*Dd**2*f**4 - 1320*Dd**2*f**3*r**2 - 2640*Dd**2*f**3*r*s + 1980*Dd**2*f**3*r - 1320*Dd**2*f**3*s**2 + 1980*Dd**2*f**3*s - 660*Dd**2*f**3 - 2376*Dd**2*f**2*g2*r**2 - 4752*Dd**2*f**2*g2*r*s + 3564*Dd**2*f**2*g2*r - 2376*Dd**2*f**2*g2*s**2 + 3564*Dd**2*f**2*g2*s - 1188*Dd**2*f**2*g2)/(6930*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**6*(2*D1*(r + s - 1)*(63*D1*bd1**2*f*(K - 1)*(r + s - 1) - D1*bd1*(50*f**3*(r + s - 1) + f**2*(27*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) - 27*r - 27*s + 27) - 3*f*(fd*(30*C - 30)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 126*fd*g2*(r + s)) + D1*bdd1*f*(70*f**2 + f*(45*C - 45) - 63*g2)*(r + s - 1) + 2*Dd*bd1*f*(70*f**2 + f*(45*C - 45) - 63*g2)*(4*r + 4*s - 3)) - 21*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(r + s)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*b1*(54*C*D1**2*f*fd*r**2 + 108*C*D1**2*f*fd*r*s - 54*C*D1**2*f*fd*r + 54*C*D1**2*f*fd*s**2 - 54*C*D1**2*f*fd*s + 27*C*D1**2*f*fd - 90*C*D1**2*f*fdd*r**2 - 180*C*D1**2*f*fdd*r*s + 90*C*D1**2*f*fdd*r - 90*C*D1**2*f*fdd*s**2 + 90*C*D1**2*f*fdd*s - 45*C*D1**2*f*fdd - 90*C*D1**2*fd**2*r**2 - 180*C*D1**2*fd**2*r*s + 90*C*D1**2*fd**2*r - 90*C*D1**2*fd**2*s**2 + 90*C*D1**2*fd**2*s + 108*C*D1*Dd*f**2*r**2 + 216*C*D1*Dd*f**2*r*s - 162*C*D1*Dd*f**2*r + 108*C*D1*Dd*f**2*s**2 - 162*C*D1*Dd*f**2*s + 81*C*D1*Dd*f**2 - 720*C*D1*Dd*f*fd*r**2 - 1440*C*D1*Dd*f*fd*r*s + 900*C*D1*Dd*f*fd*r - 720*C*D1*Dd*f*fd*s**2 + 900*C*D1*Dd*f*fd*s - 270*C*D1*Dd*f*fd - 180*C*D1*Ddd*f**2*r**2 - 360*C*D1*Ddd*f**2*r*s + 270*C*D1*Ddd*f**2*r - 180*C*D1*Ddd*f**2*s**2 + 270*C*D1*Ddd*f**2*s - 135*C*D1*Ddd*f**2 - 540*C*Dd**2*f**2*r**2 - 1080*C*Dd**2*f**2*r*s + 810*C*Dd**2*f**2*r - 540*C*Dd**2*f**2*s**2 + 810*C*Dd**2*f**2*s - 270*C*Dd**2*f**2 - 63*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 150*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 - 200*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 280*D1**2*f**2*fdd*r - 210*D1**2*f**2*fdd*s**2 + 280*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 560*D1**2*f*fd**2*r - 420*D1**2*f*fd**2*s**2 + 560*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 54*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 54*D1**2*f*fd*r - 54*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s - 27*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 180*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 90*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s + 45*D1**2*f*fdd - 21*D1**2*f*gd2*r**2 - 42*D1**2*f*gd2*r*s + 42*D1**2*f*gd2*r - 21*D1**2*f*gd2*s**2 + 42*D1**2*f*gd2*s - 21*D1**2*f*gd2 + 63*D1**2*f*gdd2*r**2 + 126*D1**2*f*gdd2*r*s - 126*D1**2*f*gdd2*r + 63*D1**2*f*gdd2*s**2 - 126*D1**2*f*gdd2*s + 63*D1**2*f*gdd2 + 90*D1**2*fd**2*r**2 + 180*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 90*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 21*D1**2*fd*g2*r**2 - 42*D1**2*fd*g2*r*s - 21*D1**2*fd*g2*s**2 + 126*D1**2*fd*gd2*r**2 + 252*D1**2*fd*gd2*r*s - 126*D1**2*fd*gd2*r + 126*D1**2*fd*gd2*s**2 - 126*D1**2*fd*gd2*s + 63*D1**2*fdd*g2*r**2 + 126*D1**2*fdd*g2*r*s + 63*D1**2*fdd*g2*s**2 + 200*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 150*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2380*D1*Dd*f**2*fd*r - 1680*D1*Dd*f**2*fd*s**2 + 2380*D1*Dd*f**2*fd*s - 840*D1*Dd*f**2*fd - 108*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 162*D1*Dd*f**2*r - 108*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1440*D1*Dd*f*fd*r*s - 900*D1*Dd*f*fd*r + 720*D1*Dd*f*fd*s**2 - 900*D1*Dd*f*fd*s + 270*D1*Dd*f*fd - 84*D1*Dd*f*g2*r**2 - 168*D1*Dd*f*g2*r*s + 126*D1*Dd*f*g2*r - 84*D1*Dd*f*g2*s**2 + 126*D1*Dd*f*g2*s - 63*D1*Dd*f*g2 + 504*D1*Dd*f*gd2*r**2 + 1008*D1*Dd*f*gd2*r*s - 882*D1*Dd*f*gd2*r + 504*D1*Dd*f*gd2*s**2 - 882*D1*Dd*f*gd2*s + 378*D1*Dd*f*gd2 + 504*D1*Dd*fd*g2*r**2 + 1008*D1*Dd*fd*g2*r*s - 378*D1*Dd*fd*g2*r + 504*D1*Dd*fd*g2*s**2 - 378*D1*Dd*fd*g2*s - 280*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s**2 + 420*D1*Ddd*f**3*s - 210*D1*Ddd*f**3 + 180*D1*Ddd*f**2*r**2 + 360*D1*Ddd*f**2*r*s - 270*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s**2 - 270*D1*Ddd*f**2*s + 135*D1*Ddd*f**2 + 252*D1*Ddd*f*g2*r**2 + 504*D1*Ddd*f*g2*r*s - 378*D1*Ddd*f*g2*r + 252*D1*Ddd*f*g2*s**2 - 378*D1*Ddd*f*g2*s + 189*D1*Ddd*f*g2 + 21*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 840*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 840*Dd**2*f**3*s**2 + 1260*Dd**2*f**3*s - 420*Dd**2*f**3 + 540*Dd**2*f**2*r**2 + 1080*Dd**2*f**2*r*s - 810*Dd**2*f**2*r + 540*Dd**2*f**2*s**2 - 810*Dd**2*f**2*s + 270*Dd**2*f**2 + 756*Dd**2*f*g2*r**2 + 1512*Dd**2*f*g2*r*s - 1134*Dd**2*f*g2*r + 756*Dd**2*f*g2*s**2 - 1134*Dd**2*f*g2*s + 378*Dd**2*f*g2))/(630*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**2*k1**4*k2**2*st**4*(198*C*D1**2*f**2*fd*r**2 + 396*C*D1**2*f**2*fd*r*s - 264*C*D1**2*f**2*fd*r + 198*C*D1**2*f**2*fd*s**2 - 264*C*D1**2*f**2*fd*s + 132*C*D1**2*f**2*fd - 132*C*D1**2*f**2*fdd*r**2 - 264*C*D1**2*f**2*fdd*r*s + 176*C*D1**2*f**2*fdd*r - 132*C*D1**2*f**2*fdd*s**2 + 176*C*D1**2*f**2*fdd*s - 88*C*D1**2*f**2*fdd - 264*C*D1**2*f*fd**2*r**2 - 528*C*D1**2*f*fd**2*r*s + 352*C*D1**2*f*fd**2*r - 264*C*D1**2*f*fd**2*s**2 + 352*C*D1**2*f*fd**2*s - 88*C*D1**2*f*fd**2 + 264*C*D1*Dd*f**3*r**2 + 528*C*D1*Dd*f**3*r*s - 396*C*D1*Dd*f**3*r + 264*C*D1*Dd*f**3*s**2 - 396*C*D1*Dd*f**3*s + 198*C*D1*Dd*f**3 - 1056*C*D1*Dd*f**2*fd*r**2 - 2112*C*D1*Dd*f**2*fd*r*s + 1496*C*D1*Dd*f**2*fd*r - 1056*C*D1*Dd*f**2*fd*s**2 + 1496*C*D1*Dd*f**2*fd*s - 528*C*D1*Dd*f**2*fd - 176*C*D1*Ddd*f**3*r**2 - 352*C*D1*Ddd*f**3*r*s + 264*C*D1*Ddd*f**3*r - 176*C*D1*Ddd*f**3*s**2 + 264*C*D1*Ddd*f**3*s - 132*C*D1*Ddd*f**3 - 528*C*Dd**2*f**3*r**2 - 1056*C*Dd**2*f**3*r*s + 792*C*Dd**2*f**3*r - 528*C*Dd**2*f**3*s**2 + 792*C*Dd**2*f**3*s - 264*C*Dd**2*f**3 + 110*D1**2*K*b1*f*fd*r**2 + 220*D1**2*K*b1*f*fd*r*s - 110*D1**2*K*b1*f*fd*r + 110*D1**2*K*b1*f*fd*s**2 - 110*D1**2*K*b1*f*fd*s + 55*D1**2*K*b1*f*fd - 132*D1**2*K*b1*f*fdd*r**2 - 264*D1**2*K*b1*f*fdd*r*s + 132*D1**2*K*b1*f*fdd*r - 132*D1**2*K*b1*f*fdd*s**2 + 132*D1**2*K*b1*f*fdd*s - 66*D1**2*K*b1*f*fdd - 132*D1**2*K*b1*fd**2*r**2 - 264*D1**2*K*b1*fd**2*r*s + 132*D1**2*K*b1*fd**2*r - 132*D1**2*K*b1*fd**2*s**2 + 132*D1**2*K*b1*fd**2*s - 110*D1**2*b1*f*fd*r**2 - 220*D1**2*b1*f*fd*r*s + 110*D1**2*b1*f*fd*r - 110*D1**2*b1*f*fd*s**2 + 110*D1**2*b1*f*fd*s - 55*D1**2*b1*f*fd + 132*D1**2*b1*f*fdd*r**2 + 264*D1**2*b1*f*fdd*r*s - 132*D1**2*b1*f*fdd*r + 132*D1**2*b1*f*fdd*s**2 - 132*D1**2*b1*f*fdd*s + 66*D1**2*b1*f*fdd + 132*D1**2*b1*fd**2*r**2 + 264*D1**2*b1*fd**2*r*s - 132*D1**2*b1*fd**2*r + 132*D1**2*b1*fd**2*s**2 - 132*D1**2*b1*fd**2*s - 66*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 1340*D1**2*f**3*fd*r**2 + 2680*D1**2*f**3*fd*r*s - 2010*D1**2*f**3*fd*r + 1340*D1**2*f**3*fd*s**2 - 2010*D1**2*f**3*fd*s + 1005*D1**2*f**3*fd - 1000*D1**2*f**3*fdd*r**2 - 2000*D1**2*f**3*fdd*r*s + 1500*D1**2*f**3*fdd*r - 1000*D1**2*f**3*fdd*s**2 + 1500*D1**2*f**3*fdd*s - 750*D1**2*f**3*fdd - 3000*D1**2*f**2*fd**2*r**2 - 6000*D1**2*f**2*fd**2*r*s + 4500*D1**2*f**2*fd**2*r - 3000*D1**2*f**2*fd**2*s**2 + 4500*D1**2*f**2*fd**2*s - 1500*D1**2*f**2*fd**2 - 198*D1**2*f**2*fd*r**2 - 396*D1**2*f**2*fd*r*s + 264*D1**2*f**2*fd*r - 198*D1**2*f**2*fd*s**2 + 264*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 132*D1**2*f**2*fdd*r**2 + 264*D1**2*f**2*fdd*r*s - 176*D1**2*f**2*fdd*r + 132*D1**2*f**2*fdd*s**2 - 176*D1**2*f**2*fdd*s + 88*D1**2*f**2*fdd - 110*D1**2*f**2*gd2*r**2 - 220*D1**2*f**2*gd2*r*s + 220*D1**2*f**2*gd2*r - 110*D1**2*f**2*gd2*s**2 + 220*D1**2*f**2*gd2*s - 110*D1**2*f**2*gd2 + 132*D1**2*f**2*gdd2*r**2 + 264*D1**2*f**2*gdd2*r*s - 264*D1**2*f**2*gdd2*r + 132*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 132*D1**2*f**2*gdd2 + 264*D1**2*f*fd**2*r**2 + 528*D1**2*f*fd**2*r*s - 352*D1**2*f*fd**2*r + 264*D1**2*f*fd**2*s**2 - 352*D1**2*f*fd**2*s + 88*D1**2*f*fd**2 - 220*D1**2*f*fd*g2*r**2 - 440*D1**2*f*fd*g2*r*s + 220*D1**2*f*fd*g2*r - 220*D1**2*f*fd*g2*s**2 + 220*D1**2*f*fd*g2*s - 110*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r**2 + 1056*D1**2*f*fd*gd2*r*s - 792*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r**2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r**2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s + 220*D1*Dd*K*b1*f**2*r**2 + 440*D1*Dd*K*b1*f**2*r*s - 330*D1*Dd*K*b1*f**2*r + 220*D1*Dd*K*b1*f**2*s**2 - 330*D1*Dd*K*b1*f**2*s + 165*D1*Dd*K*b1*f**2 - 1056*D1*Dd*K*b1*f*fd*r**2 - 2112*D1*Dd*K*b1*f*fd*r*s + 1320*D1*Dd*K*b1*f*fd*r - 1056*D1*Dd*K*b1*f*fd*s**2 + 1320*D1*Dd*K*b1*f*fd*s - 396*D1*Dd*K*b1*f*fd - 220*D1*Dd*b1*f**2*r**2 - 440*D1*Dd*b1*f**2*r*s + 330*D1*Dd*b1*f**2*r - 220*D1*Dd*b1*f**2*s**2 + 330*D1*Dd*b1*f**2*s - 165*D1*Dd*b1*f**2 + 1056*D1*Dd*b1*f*fd*r**2 + 2112*D1*Dd*b1*f*fd*r*s - 1320*D1*Dd*b1*f*fd*r + 1056*D1*Dd*b1*f*fd*s**2 - 1320*D1*Dd*b1*f*fd*s + 396*D1*Dd*b1*f*fd + 1340*D1*Dd*f**4*r**2 + 2680*D1*Dd*f**4*r*s - 2010*D1*Dd*f**4*r + 1340*D1*Dd*f**4*s**2 - 2010*D1*Dd*f**4*s + 1005*D1*Dd*f**4 - 8000*D1*Dd*f**3*fd*r**2 - 16000*D1*Dd*f**3*fd*r*s + 12000*D1*Dd*f**3*fd*r - 8000*D1*Dd*f**3*fd*s**2 + 12000*D1*Dd*f**3*fd*s - 4500*D1*Dd*f**3*fd - 264*D1*Dd*f**3*r**2 - 528*D1*Dd*f**3*r*s + 396*D1*Dd*f**3*r - 264*D1*Dd*f**3*s**2 + 396*D1*Dd*f**3*s - 198*D1*Dd*f**3 + 1056*D1*Dd*f**2*fd*r**2 + 2112*D1*Dd*f**2*fd*r*s - 1496*D1*Dd*f**2*fd*r + 1056*D1*Dd*f**2*fd*s**2 - 1496*D1*Dd*f**2*fd*s + 528*D1*Dd*f**2*fd - 440*D1*Dd*f**2*g2*r**2 - 880*D1*Dd*f**2*g2*r*s + 660*D1*Dd*f**2*g2*r - 440*D1*Dd*f**2*g2*s**2 + 660*D1*Dd*f**2*g2*s - 330*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r**2 + 2112*D1*Dd*f**2*gd2*r*s - 1848*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1848*D1*Dd*f**2*gd2*s + 792*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r**2 + 4224*D1*Dd*f*fd*g2*r*s - 2640*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2640*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 264*D1*Ddd*K*b1*f**2*r**2 - 528*D1*Ddd*K*b1*f**2*r*s + 396*D1*Ddd*K*b1*f**2*r - 264*D1*Ddd*K*b1*f**2*s**2 + 396*D1*Ddd*K*b1*f**2*s - 198*D1*Ddd*K*b1*f**2 + 264*D1*Ddd*b1*f**2*r**2 + 528*D1*Ddd*b1*f**2*r*s - 396*D1*Ddd*b1*f**2*r + 264*D1*Ddd*b1*f**2*s**2 - 396*D1*Ddd*b1*f**2*s + 198*D1*Ddd*b1*f**2 - 1000*D1*Ddd*f**4*r**2 - 2000*D1*Ddd*f**4*r*s + 1500*D1*Ddd*f**4*r - 1000*D1*Ddd*f**4*s**2 + 1500*D1*Ddd*f**4*s - 750*D1*Ddd*f**4 + 176*D1*Ddd*f**3*r**2 + 352*D1*Ddd*f**3*r*s - 264*D1*Ddd*f**3*r + 176*D1*Ddd*f**3*s**2 - 264*D1*Ddd*f**3*s + 132*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r**2 + 1056*D1*Ddd*f**2*g2*r*s - 792*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 396*D1*Ddd*f**2*g2 + 11*D1*bd1*f*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 792*Dd**2*K*b1*f**2*r**2 - 1584*Dd**2*K*b1*f**2*r*s + 1188*Dd**2*K*b1*f**2*r - 792*Dd**2*K*b1*f**2*s**2 + 1188*Dd**2*K*b1*f**2*s - 396*Dd**2*K*b1*f**2 + 792*Dd**2*b1*f**2*r**2 + 1584*Dd**2*b1*f**2*r*s - 1188*Dd**2*b1*f**2*r + 792*Dd**2*b1*f**2*s**2 - 1188*Dd**2*b1*f**2*s + 396*Dd**2*b1*f**2 - 3000*Dd**2*f**4*r**2 - 6000*Dd**2*f**4*r*s + 4500*Dd**2*f**4*r - 3000*Dd**2*f**4*s**2 + 4500*Dd**2*f**4*s - 1500*Dd**2*f**4 + 528*Dd**2*f**3*r**2 + 1056*Dd**2*f**3*r*s - 792*Dd**2*f**3*r + 528*Dd**2*f**3*s**2 - 792*Dd**2*f**3*s + 264*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r**2 + 3168*Dd**2*f**2*g2*r*s - 2376*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 792*Dd**2*f**2*g2)/(770*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**2*k1**4*k2**2*st**2*(-84*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 12*D1**2*bdd1*f*(3*f*(C + 2*K - 2) - 7*g2)*(r + s - 1)**2 - 2*D1**2*(15*f**3*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-fd*(29*C - 21)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(40*C - 30)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (25*gd2 - 72*gdd2)*(r + s - 1)**2) + f*(fd**2*(80*C - 60)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + fd*(25*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 144*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 72*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 144*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bd1*(D1*(36*f**3*(r + s - 1) + f**2*(58*C + 25*K - 67)*(r + s - 1) - 2*f*(36*fd*(C + 2*K - 2)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 24*Dd*f*(3*f*(C + 2*K - 2) - 7*g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(15*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(29*C - 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(fd*(80*C - 60)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 25*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 144*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 144*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2*Ddd*f*(f*(20*C - 15) - 36*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Dd**2*f**2*(f*(20*C - 15) - 36*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*b1**2*(K - 1)*(D1**2*(7*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(116*C*D1**2*f*fd*r**2 + 232*C*D1**2*f*fd*r*s - 116*C*D1**2*f*fd*r + 116*C*D1**2*f*fd*s**2 - 116*C*D1**2*f*fd*s + 58*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r**2 - 144*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s**2 + 72*C*D1**2*f*fdd*s - 36*C*D1**2*f*fdd - 72*C*D1**2*fd**2*r**2 - 144*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*r - 72*C*D1**2*fd**2*s**2 + 72*C*D1**2*fd**2*s + 232*C*D1*Dd*f**2*r**2 + 464*C*D1*Dd*f**2*r*s - 348*C*D1*Dd*f**2*r + 232*C*D1*Dd*f**2*s**2 - 348*C*D1*Dd*f**2*s + 174*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r**2 - 1152*C*D1*Dd*f*fd*r*s + 720*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 720*C*D1*Dd*f*fd*s - 216*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r**2 - 288*C*D1*Ddd*f**2*r*s + 216*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 216*C*D1*Ddd*f**2*s - 108*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r**2 - 864*C*Dd**2*f**2*r*s + 648*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 648*C*Dd**2*f**2*s - 216*C*Dd**2*f**2 + 50*D1**2*K*f*fd*r**2 + 100*D1**2*K*f*fd*r*s - 50*D1**2*K*f*fd*r + 50*D1**2*K*f*fd*s**2 - 50*D1**2*K*f*fd*s + 25*D1**2*K*f*fd - 144*D1**2*K*f*fdd*r**2 - 288*D1**2*K*f*fdd*r*s + 144*D1**2*K*f*fdd*r - 144*D1**2*K*f*fdd*s**2 + 144*D1**2*K*f*fdd*s - 72*D1**2*K*f*fdd - 144*D1**2*K*fd**2*r**2 - 288*D1**2*K*fd**2*r*s + 144*D1**2*K*fd**2*r - 144*D1**2*K*fd**2*s**2 + 144*D1**2*K*fd**2*s - 84*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 108*D1**2*f**2*fd*r**2 + 216*D1**2*f**2*fd*r*s - 144*D1**2*f**2*fd*r + 108*D1**2*f**2*fd*s**2 - 144*D1**2*f**2*fd*s + 72*D1**2*f**2*fd - 134*D1**2*f*fd*r**2 - 268*D1**2*f*fd*r*s + 134*D1**2*f*fd*r - 134*D1**2*f*fd*s**2 + 134*D1**2*f*fd*s - 67*D1**2*f*fd + 144*D1**2*f*fdd*r**2 + 288*D1**2*f*fdd*r*s - 144*D1**2*f*fdd*r + 144*D1**2*f*fdd*s**2 - 144*D1**2*f*fdd*s + 72*D1**2*f*fdd - 98*D1**2*f*gd2*r**2 - 196*D1**2*f*gd2*r*s + 196*D1**2*f*gd2*r - 98*D1**2*f*gd2*s**2 + 196*D1**2*f*gd2*s - 98*D1**2*f*gd2 + 84*D1**2*f*gdd2*r**2 + 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*r + 84*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s + 84*D1**2*f*gdd2 + 144*D1**2*fd**2*r**2 + 288*D1**2*fd**2*r*s - 144*D1**2*fd**2*r + 144*D1**2*fd**2*s**2 - 144*D1**2*fd**2*s - 98*D1**2*fd*g2*r**2 - 196*D1**2*fd*g2*r*s - 98*D1**2*fd*g2*s**2 + 168*D1**2*fd*gd2*r**2 + 336*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 84*D1**2*fdd*g2*r**2 + 168*D1**2*fdd*g2*r*s + 84*D1**2*fdd*g2*s**2 + 100*D1*Dd*K*f**2*r**2 + 200*D1*Dd*K*f**2*r*s - 150*D1*Dd*K*f**2*r + 100*D1*Dd*K*f**2*s**2 - 150*D1*Dd*K*f**2*s + 75*D1*Dd*K*f**2 - 1152*D1*Dd*K*f*fd*r**2 - 2304*D1*Dd*K*f*fd*r*s + 1440*D1*Dd*K*f*fd*r - 1152*D1*Dd*K*f*fd*s**2 + 1440*D1*Dd*K*f*fd*s - 432*D1*Dd*K*f*fd + 144*D1*Dd*f**3*r**2 + 288*D1*Dd*f**3*r*s - 216*D1*Dd*f**3*r + 144*D1*Dd*f**3*s**2 - 216*D1*Dd*f**3*s + 108*D1*Dd*f**3 - 268*D1*Dd*f**2*r**2 - 536*D1*Dd*f**2*r*s + 402*D1*Dd*f**2*r - 268*D1*Dd*f**2*s**2 + 402*D1*Dd*f**2*s - 201*D1*Dd*f**2 + 1152*D1*Dd*f*fd*r**2 + 2304*D1*Dd*f*fd*r*s - 1440*D1*Dd*f*fd*r + 1152*D1*Dd*f*fd*s**2 - 1440*D1*Dd*f*fd*s + 432*D1*Dd*f*fd - 392*D1*Dd*f*g2*r**2 - 784*D1*Dd*f*g2*r*s + 588*D1*Dd*f*g2*r - 392*D1*Dd*f*g2*s**2 + 588*D1*Dd*f*g2*s - 294*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r**2 + 1344*D1*Dd*f*gd2*r*s - 1176*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 1176*D1*Dd*f*gd2*s + 504*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r**2 + 1344*D1*Dd*fd*g2*r*s - 504*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 504*D1*Dd*fd*g2*s - 288*D1*Ddd*K*f**2*r**2 - 576*D1*Ddd*K*f**2*r*s + 432*D1*Ddd*K*f**2*r - 288*D1*Ddd*K*f**2*s**2 + 432*D1*Ddd*K*f**2*s - 216*D1*Ddd*K*f**2 + 288*D1*Ddd*f**2*r**2 + 576*D1*Ddd*f**2*r*s - 432*D1*Ddd*f**2*r + 288*D1*Ddd*f**2*s**2 - 432*D1*Ddd*f**2*s + 216*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r**2 + 672*D1*Ddd*f*g2*r*s - 504*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 504*D1*Ddd*f*g2*s + 252*D1*Ddd*f*g2 + 14*D1*bd1*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 864*Dd**2*K*f**2*r**2 - 1728*Dd**2*K*f**2*r*s + 1296*Dd**2*K*f**2*r - 864*Dd**2*K*f**2*s**2 + 1296*Dd**2*K*f**2*s - 432*Dd**2*K*f**2 + 864*Dd**2*f**2*r**2 + 1728*Dd**2*f**2*r*s - 1296*Dd**2*f**2*r + 864*Dd**2*f**2*s**2 - 1296*Dd**2*f**2*s + 432*Dd**2*f**2 + 1008*Dd**2*f*g2*r**2 + 2016*Dd**2*f*g2*r*s - 1512*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1512*Dd**2*f*g2*s + 504*Dd**2*f*g2))/(210*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**4*k2**2*(720*C*D1**2*bdd1*f**2*r**2 + 1440*C*D1**2*bdd1*f**2*r*s - 1440*C*D1**2*bdd1*f**2*r + 720*C*D1**2*bdd1*f**2*s**2 - 1440*C*D1**2*bdd1*f**2*s + 720*C*D1**2*bdd1*f**2 - 150*C*D1**2*f**2*fd*r**2 - 300*C*D1**2*f**2*fd*r*s + 200*C*D1**2*f**2*fd*r - 150*C*D1**2*f**2*fd*s**2 + 200*C*D1**2*f**2*fd*s - 100*C*D1**2*f**2*fd + 210*C*D1**2*f**2*fdd*r**2 + 420*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 210*C*D1**2*f**2*fdd*s**2 - 280*C*D1**2*f**2*fdd*s + 140*C*D1**2*f**2*fdd + 420*C*D1**2*f*fd**2*r**2 + 840*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 420*C*D1**2*f*fd**2*s**2 - 560*C*D1**2*f*fd**2*s + 140*C*D1**2*f*fd**2 - 200*C*D1*Dd*f**3*r**2 - 400*C*D1*Dd*f**3*r*s + 300*C*D1*Dd*f**3*r - 200*C*D1*Dd*f**3*s**2 + 300*C*D1*Dd*f**3*s - 150*C*D1*Dd*f**3 + 1680*C*D1*Dd*f**2*fd*r**2 + 3360*C*D1*Dd*f**2*fd*r*s - 2380*C*D1*Dd*f**2*fd*r + 1680*C*D1*Dd*f**2*fd*s**2 - 2380*C*D1*Dd*f**2*fd*s + 840*C*D1*Dd*f**2*fd + 280*C*D1*Ddd*f**3*r**2 + 560*C*D1*Ddd*f**3*r*s - 420*C*D1*Ddd*f**3*r + 280*C*D1*Ddd*f**3*s**2 - 420*C*D1*Ddd*f**3*s + 210*C*D1*Ddd*f**3 + 840*C*Dd**2*f**3*r**2 + 1680*C*Dd**2*f**3*r*s - 1260*C*Dd**2*f**3*r + 840*C*Dd**2*f**3*s**2 - 1260*C*Dd**2*f**3*s + 420*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r**2 + 90*D1**2*K*bdd1*f**2*r*s - 90*D1**2*K*bdd1*f**2*r + 45*D1**2*K*bdd1*f**2*s**2 - 90*D1**2*K*bdd1*f**2*s + 45*D1**2*K*bdd1*f**2 - 36*D1**2*bd1**2*f*(-28*K + 25*f + 14)*(r + s - 1)**2 - 540*D1**2*bdd1*f**2*r**2 - 1080*D1**2*bdd1*f**2*r*s + 1080*D1**2*bdd1*f**2*r - 540*D1**2*bdd1*f**2*s**2 + 1080*D1**2*bdd1*f**2*s - 540*D1**2*bdd1*f**2 - 1008*D1**2*bdd1*f*g2*r**2 - 2016*D1**2*bdd1*f*g2*r*s + 2016*D1**2*bdd1*f*g2*r - 1008*D1**2*bdd1*f*g2*s**2 + 2016*D1**2*bdd1*f*g2*s - 1008*D1**2*bdd1*f*g2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd + 54*D1**2*f**2*gd2*r**2 + 108*D1**2*f**2*gd2*r*s - 108*D1**2*f**2*gd2*r + 54*D1**2*f**2*gd2*s**2 - 108*D1**2*f**2*gd2*s + 54*D1**2*f**2*gd2 - 90*D1**2*f**2*gdd2*r**2 - 180*D1**2*f**2*gdd2*r*s + 180*D1**2*f**2*gdd2*r - 90*D1**2*f**2*gdd2*s**2 + 180*D1**2*f**2*gdd2*s - 90*D1**2*f**2*gdd2 - 210*D1**2*f*fd**2*r**2 - 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 280*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 108*D1**2*f*fd*g2*r**2 + 216*D1**2*f*fd*g2*r*s - 108*D1**2*f*fd*g2*r + 108*D1**2*f*fd*g2*s**2 - 108*D1**2*f*fd*g2*s + 54*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r**2 - 720*D1**2*f*fd*gd2*r*s + 540*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 540*D1**2*f*fd*gd2*s - 180*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r**2 - 360*D1**2*f*fdd*g2*r*s + 180*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r**2 - 360*D1**2*fd**2*g2*r*s + 180*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 1680*D1*Dd*f**2*fd*r*s + 1190*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 1190*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd + 216*D1*Dd*f**2*g2*r**2 + 432*D1*Dd*f**2*g2*r*s - 324*D1*Dd*f**2*g2*r + 216*D1*Dd*f**2*g2*s**2 - 324*D1*Dd*f**2*g2*s + 162*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r**2 - 1440*D1*Dd*f**2*gd2*r*s + 1260*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 1260*D1*Dd*f**2*gd2*s - 540*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r**2 - 2880*D1*Dd*f*fd*g2*r*s + 1800*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1800*D1*Dd*f*fd*g2*s - 540*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r*s + 210*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 210*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r**2 - 720*D1*Ddd*f**2*g2*r*s + 540*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 540*D1*Ddd*f**2*g2*s - 270*D1*Ddd*f**2*g2 + 6*D1*b1*bd1*(D1*(111*f**2*(r + s - 1) - 300*f*fd*(2*r + 2*s - 1) - 7*f*(3*K + 1)*(r + s - 1) + 168*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-28*K + 25*f + 14)*(4*r + 4*s - 3))*(r + s - 1) + 9*D1*bd1*(D1*(10*f**3*(r + s - 1) - f**2*(34*C + 3*K - 22)*(r + s - 1) + 2*f*(5*fd*(16*C + K - 12)*(2*r + 2*s - 1) + (7*g2 - 112*gd2)*(r + s - 1)) - 224*fd*g2*(r + s)) + 2*Dd*f*(5*f*(16*C + K - 12) - 112*g2)*(4*r + 4*s - 3))*(r + s - 1) - 420*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r*s + 630*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 630*Dd**2*f**3*s - 210*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r**2 - 2160*Dd**2*f**2*g2*r*s + 1620*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1620*Dd**2*f**2*g2*s - 540*Dd**2*f**2*g2 + 3*b1**2*(D1**2*(3*f*(37*fd - 50*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(300*fd**2*(r + s - 1) + 7*fd*(3*K + 1)*(r + s) - 84*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(111*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(300*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (21*K + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 168*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-28*K + 25*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-28*K + 25*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*b1*(4*D1**2*bdd1*f*(-28*K + 25*f + 14)*(r + s - 1)**2 - D1**2*(10*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-fd*(34*C + 3*K - 22)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*fdd*(16*C + K - 12)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (14*gd2 - 112*gdd2)*(r + s - 1)**2) + (2*r + 2*s)*(5*fd**2*(16*C + K - 12)*(r + s - 1) + 7*fd*(g2*(r + s) - 16*gd2*(r + s - 1)) - 56*fdd*g2*(r + s))) + D1*(Dd*(-10*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(34*C + 3*K - 22)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(5*fd*(16*C + K - 12)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 7*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 112*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 224*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(5*f*(16*C + K - 12) - 112*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(5*f*(16*C + K - 12) - 112*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(630*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**4*st**2*(14*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*D1*bd1*(D1*(-f**3*(25*r**2 + r*(50*s - 26) + 25*s**2 - 26*s + 13) + f**2*(C*s**2 + 10*fd*(21*r**2 + r*(42*s - 29) + 21*s**2 - 29*s + 8) + r**2*(C - 9) + 2*r*(s*(C - 9) + 8) - 9*s**2 + 16*s - 8) + f*(12*fd*(r + s - 1)*(r*(C + 5) + s*(C + 5) - 3) - (7*r + 7*s)*(3*g2*(r + s) + 2*gd2*(r + s - 1))) - 14*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(4*r + 4*s - 3)*(5*f**2*(7*r + 7*s - 4) + 3*f*(r*(C + 5) + s*(C + 5) - 6) - 7*g2*(r + s))) + 7*b1**2*(K - 1)*(D1**2*(3*fd + fdd)*(r + s - 1)**2 + D1*(Dd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(7*D1**2*bdd1*f*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*D1**2*(f**2*(fd*(75*r**2 + 2*r*(75*s - 62) + 75*s**2 - 124*s + 62) - 5*fdd*(21*r**2 + r*(42*s - 34) + 21*s**2 - 34*s + 17)) - f*(10*fd**2*(21*r**2 + r*(42*s - 34) + 21*s**2 - 34*s + 13) + 2*fd*(C*(r + s - 1)**2 - 9*r**2 - 2*r*(9*s - 5) - 9*s**2 + 10*s - 5) + 6*fdd*(C*(r + s - 1)**2 + 5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s + 2) + (-21*gd2 - 7*gdd2)*(r + s - 1)**2) - (r + s - 1)*(6*fd**2*(C*(r + s - 1) + 5*r + 5*s + 1) - 7*fd*(3*g2 + 2*gd2)*(r + s - 1) - 7*fdd*g2*(r + s - 1))) + 7*D1*bd1*(K - 1)*(D1*(3*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2*D1*(-Dd*(25*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(84*r**2 + 168*r*s - 131*r + 84*s**2 - 131*s + 51) - 36*r**2 - 72*r*s + 54*r - 36*s**2 + 54*s - 27) + f*(-12*fd*(4*r + 4*s - 3)*(C*(r + s - 1) + 5*r + 5*s - 2) + 21*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 14*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 14*fd*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(35*f**2 + f*(3*C + 15) - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f*(35*f**2 + f*(3*C + 15) - 7*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*f*(D1**2*bdd1*(5*f**2*(7*r**2 + 2*r*(7*s - 4) + 7*s**2 - 8*s + 4) + 3*f*(r**2*(C + 5) + 2*r*(s*(C + 5) - 6) + s**2*(C + 5) - 12*s + 6) - 7*g2*(r + s)**2) + 2*D1**2*(-f*(4*fd - 5*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 10*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 2*D1*f*(-4*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*Dd*fd*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k1**4*(150*C*D1**2*f**2*fd*r**2 + 300*C*D1**2*f**2*fd*r*s - 200*C*D1**2*f**2*fd*r + 150*C*D1**2*f**2*fd*s**2 - 200*C*D1**2*f**2*fd*s + 100*C*D1**2*f**2*fd - 210*C*D1**2*f**2*fdd*r**2 - 420*C*D1**2*f**2*fdd*r*s + 280*C*D1**2*f**2*fdd*r - 210*C*D1**2*f**2*fdd*s**2 + 280*C*D1**2*f**2*fdd*s - 140*C*D1**2*f**2*fdd - 420*C*D1**2*f*fd**2*r**2 - 840*C*D1**2*f*fd**2*r*s + 560*C*D1**2*f*fd**2*r - 420*C*D1**2*f*fd**2*s**2 + 560*C*D1**2*f*fd**2*s - 140*C*D1**2*f*fd**2 + 200*C*D1*Dd*f**3*r**2 + 400*C*D1*Dd*f**3*r*s - 300*C*D1*Dd*f**3*r + 200*C*D1*Dd*f**3*s**2 - 300*C*D1*Dd*f**3*s + 150*C*D1*Dd*f**3 - 1680*C*D1*Dd*f**2*fd*r**2 - 3360*C*D1*Dd*f**2*fd*r*s + 2380*C*D1*Dd*f**2*fd*r - 1680*C*D1*Dd*f**2*fd*s**2 + 2380*C*D1*Dd*f**2*fd*s - 840*C*D1*Dd*f**2*fd - 280*C*D1*Ddd*f**3*r**2 - 560*C*D1*Ddd*f**3*r*s + 420*C*D1*Ddd*f**3*r - 280*C*D1*Ddd*f**3*s**2 + 420*C*D1*Ddd*f**3*s - 210*C*D1*Ddd*f**3 - 840*C*Dd**2*f**3*r**2 - 1680*C*Dd**2*f**3*r*s + 1260*C*Dd**2*f**3*r - 840*C*Dd**2*f**3*s**2 + 1260*C*Dd**2*f**3*s - 420*C*Dd**2*f**3 - 45*D1**2*K*bdd1*f**2*r**2 - 90*D1**2*K*bdd1*f**2*r*s + 90*D1**2*K*bdd1*f**2*r - 45*D1**2*K*bdd1*f**2*s**2 + 90*D1**2*K*bdd1*f**2*s - 45*D1**2*K*bdd1*f**2 + 54*D1**2*b2*f*fd*r**2 + 108*D1**2*b2*f*fd*r*s - 54*D1**2*b2*f*fd*r + 54*D1**2*b2*f*fd*s**2 - 54*D1**2*b2*f*fd*s + 27*D1**2*b2*f*fd - 90*D1**2*b2*f*fdd*r**2 - 180*D1**2*b2*f*fdd*r*s + 90*D1**2*b2*f*fdd*r - 90*D1**2*b2*f*fdd*s**2 + 90*D1**2*b2*f*fdd*s - 45*D1**2*b2*f*fdd - 90*D1**2*b2*fd**2*r**2 - 180*D1**2*b2*fd**2*r*s + 90*D1**2*b2*fd**2*r - 90*D1**2*b2*fd**2*s**2 + 90*D1**2*b2*fd**2*s + 12*D1**2*bd1**2*(r + s - 1)*(15*f**2*(3*r + 3*s - 2) + 21*f*(C*r + C*s + r + s - 2) - 35*g2*(r + s)) + 27*D1**2*bd2*f**2*r**2 + 54*D1**2*bd2*f**2*r*s - 54*D1**2*bd2*f**2*r + 27*D1**2*bd2*f**2*s**2 - 54*D1**2*bd2*f**2*s + 27*D1**2*bd2*f**2 - 180*D1**2*bd2*f*fd*r**2 - 360*D1**2*bd2*f*fd*r*s + 270*D1**2*bd2*f*fd*r - 180*D1**2*bd2*f*fd*s**2 + 270*D1**2*bd2*f*fd*s - 90*D1**2*bd2*f*fd + 180*D1**2*bdd1*f**2*r**2 + 360*D1**2*bdd1*f**2*r*s - 360*D1**2*bdd1*f**2*r + 180*D1**2*bdd1*f**2*s**2 - 360*D1**2*bdd1*f**2*s + 180*D1**2*bdd1*f**2 - 45*D1**2*bdd2*f**2*r**2 - 90*D1**2*bdd2*f**2*r*s + 90*D1**2*bdd2*f**2*r - 45*D1**2*bdd2*f**2*s**2 + 90*D1**2*bdd2*f**2*s - 45*D1**2*bdd2*f**2 - 75*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 + 210*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd*s + 70*D1**2*f**2*fdd - 54*D1**2*f**2*gd2*r**2 - 108*D1**2*f**2*gd2*r*s + 108*D1**2*f**2*gd2*r - 54*D1**2*f**2*gd2*s**2 + 108*D1**2*f**2*gd2*s - 54*D1**2*f**2*gd2 + 90*D1**2*f**2*gdd2*r**2 + 180*D1**2*f**2*gdd2*r*s - 180*D1**2*f**2*gdd2*r + 90*D1**2*f**2*gdd2*s**2 - 180*D1**2*f**2*gdd2*s + 90*D1**2*f**2*gdd2 + 210*D1**2*f*fd**2*r**2 + 420*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 280*D1**2*f*fd**2*s + 70*D1**2*f*fd**2 - 108*D1**2*f*fd*g2*r**2 - 216*D1**2*f*fd*g2*r*s + 108*D1**2*f*fd*g2*r - 108*D1**2*f*fd*g2*s**2 + 108*D1**2*f*fd*g2*s - 54*D1**2*f*fd*g2 + 360*D1**2*f*fd*gd2*r**2 + 720*D1**2*f*fd*gd2*r*s - 540*D1**2*f*fd*gd2*r + 360*D1**2*f*fd*gd2*s**2 - 540*D1**2*f*fd*gd2*s + 180*D1**2*f*fd*gd2 + 180*D1**2*f*fdd*g2*r**2 + 360*D1**2*f*fdd*g2*r*s - 180*D1**2*f*fdd*g2*r + 180*D1**2*f*fdd*g2*s**2 - 180*D1**2*f*fdd*g2*s + 90*D1**2*f*fdd*g2 + 180*D1**2*fd**2*g2*r**2 + 360*D1**2*fd**2*g2*r*s - 180*D1**2*fd**2*g2*r + 180*D1**2*fd**2*g2*s**2 - 180*D1**2*fd**2*g2*s + 108*D1*Dd*b2*f**2*r**2 + 216*D1*Dd*b2*f**2*r*s - 162*D1*Dd*b2*f**2*r + 108*D1*Dd*b2*f**2*s**2 - 162*D1*Dd*b2*f**2*s + 81*D1*Dd*b2*f**2 - 720*D1*Dd*b2*f*fd*r**2 - 1440*D1*Dd*b2*f*fd*r*s + 900*D1*Dd*b2*f*fd*r - 720*D1*Dd*b2*f*fd*s**2 + 900*D1*Dd*b2*f*fd*s - 270*D1*Dd*b2*f*fd - 360*D1*Dd*bd2*f**2*r**2 - 720*D1*Dd*bd2*f**2*r*s + 630*D1*Dd*bd2*f**2*r - 360*D1*Dd*bd2*f**2*s**2 + 630*D1*Dd*bd2*f**2*s - 270*D1*Dd*bd2*f**2 - 100*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 150*D1*Dd*f**3*s - 75*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 + 1680*D1*Dd*f**2*fd*r*s - 1190*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 1190*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd - 216*D1*Dd*f**2*g2*r**2 - 432*D1*Dd*f**2*g2*r*s + 324*D1*Dd*f**2*g2*r - 216*D1*Dd*f**2*g2*s**2 + 324*D1*Dd*f**2*g2*s - 162*D1*Dd*f**2*g2 + 720*D1*Dd*f**2*gd2*r**2 + 1440*D1*Dd*f**2*gd2*r*s - 1260*D1*Dd*f**2*gd2*r + 720*D1*Dd*f**2*gd2*s**2 - 1260*D1*Dd*f**2*gd2*s + 540*D1*Dd*f**2*gd2 + 1440*D1*Dd*f*fd*g2*r**2 + 2880*D1*Dd*f*fd*g2*r*s - 1800*D1*Dd*f*fd*g2*r + 1440*D1*Dd*f*fd*g2*s**2 - 1800*D1*Dd*f*fd*g2*s + 540*D1*Dd*f*fd*g2 - 180*D1*Ddd*b2*f**2*r**2 - 360*D1*Ddd*b2*f**2*r*s + 270*D1*Ddd*b2*f**2*r - 180*D1*Ddd*b2*f**2*s**2 + 270*D1*Ddd*b2*f**2*s - 135*D1*Ddd*b2*f**2 + 140*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r*s - 210*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 210*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 + 360*D1*Ddd*f**2*g2*r**2 + 720*D1*Ddd*f**2*g2*r*s - 540*D1*Ddd*f**2*g2*r + 360*D1*Ddd*f**2*g2*s**2 - 540*D1*Ddd*f**2*g2*s + 270*D1*Ddd*f**2*g2 + 9*D1*bd1*f*(K - 4)*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 540*Dd**2*b2*f**2*r**2 - 1080*Dd**2*b2*f**2*r*s + 810*Dd**2*b2*f**2*r - 540*Dd**2*b2*f**2*s**2 + 810*Dd**2*b2*f**2*s - 270*Dd**2*b2*f**2 + 420*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r*s - 630*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 630*Dd**2*f**3*s + 210*Dd**2*f**3 + 1080*Dd**2*f**2*g2*r**2 + 2160*Dd**2*f**2*g2*r*s - 1620*Dd**2*f**2*g2*r + 1080*Dd**2*f**2*g2*s**2 - 1620*Dd**2*f**2*g2*s + 540*Dd**2*f**2*g2 + 105*b1**3*(K - 1)*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1**2*(35*D1**2*bdd1*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*D1**2*(-30*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + fd*(7*C*(r + s - 1)**2 + 18*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 7*r**2 + 14*r*(s + 1) + 7*s**2 + 14*s - 7) - 3*fdd*(7*C*(r + s - 1)**2 + 10*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 7*r**2 + 14*r*(s + 1) + 7*s**2 + 14*s - 7) + (35*gd2 + 35*gdd2)*(r + s - 1)**2) + 35*D1*bd1*(K - 1)*(D1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*Dd*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 2*D1*(Dd*(27*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(7*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 60*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) - 42*fd*(4*r + 4*s - 3)*(C*(r + s - 1) + r + s + 1) + 35*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 70*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*(45*f**2 + f*(21*C + 21) - 35*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*(45*f**2 + f*(21*C + 21) - 35*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(70*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(15*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 21*f*(C*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*r**2 + 4*r*s - 6*r + 2*s**2 - 6*s + 3) - 35*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*D1*bd1*(D1*(9*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + f*(7*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 180*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 14*r**2 + 28*r*s - 42*r + 14*s**2 - 42*s + 21) - 42*fd*(r + s - 1)*(C*(2*r + 2*s - 1) + 2*r + 2*s + 1) + 35*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(4*r + 4*s - 3)*(15*f**2*(6*r + 6*s - 5) + 21*f*(C*(2*r + 2*s - 1) + 2*r + 2*s - 3) - 35*g2*(2*r + 2*s - 1))) + (3*K - 12)*(D1**2*(f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(630*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**4*st**6*(132*C*D1**2*f**2*fd*r**2 + 264*C*D1**2*f**2*fd*r*s - 176*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 176*C*D1**2*f**2*fd*s + 88*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r**2 - 132*C*D1**2*f**2*fdd*r*s + 88*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 88*C*D1**2*f**2*fdd*s - 44*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r**2 - 264*C*D1**2*f*fd**2*r*s + 176*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 176*C*D1**2*f*fd**2*s - 44*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r**2 + 352*C*D1*Dd*f**3*r*s - 264*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 264*C*D1*Dd*f**3*s + 132*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r**2 - 1056*C*D1*Dd*f**2*fd*r*s + 748*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 748*C*D1*Dd*f**2*fd*s - 264*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r**2 - 176*C*D1*Ddd*f**3*r*s + 132*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 132*C*D1*Ddd*f**3*s - 66*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r**2 - 528*C*Dd**2*f**3*r*s + 396*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 396*C*Dd**2*f**3*s - 132*C*Dd**2*f**3 + 396*D1**2*K*b1*f*fd*r**2 + 792*D1**2*K*b1*f*fd*r*s - 396*D1**2*K*b1*f*fd*r + 396*D1**2*K*b1*f*fd*s**2 - 396*D1**2*K*b1*f*fd*s + 198*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 396*D1**2*K*b1*f*fdd*r*s + 198*D1**2*K*b1*f*fdd*r - 198*D1**2*K*b1*f*fdd*s**2 + 198*D1**2*K*b1*f*fdd*s - 99*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 396*D1**2*K*b1*fd**2*r*s + 198*D1**2*K*b1*fd**2*r - 198*D1**2*K*b1*fd**2*s**2 + 198*D1**2*K*b1*fd**2*s - 396*D1**2*b1*f*fd*r**2 - 792*D1**2*b1*f*fd*r*s + 396*D1**2*b1*f*fd*r - 396*D1**2*b1*f*fd*s**2 + 396*D1**2*b1*f*fd*s - 198*D1**2*b1*f*fd + 198*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 198*D1**2*b1*f*fdd*s**2 - 198*D1**2*b1*f*fdd*s + 99*D1**2*b1*f*fdd + 198*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 198*D1**2*b1*fd**2*s**2 - 198*D1**2*b1*fd**2*s - 99*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 672*D1**2*f**3*fd*r**2 + 1344*D1**2*f**3*fd*r*s - 1008*D1**2*f**3*fd*r + 672*D1**2*f**3*fd*s**2 - 1008*D1**2*f**3*fd*s + 504*D1**2*f**3*fd - 336*D1**2*f**3*fdd*r**2 - 672*D1**2*f**3*fdd*r*s + 504*D1**2*f**3*fdd*r - 336*D1**2*f**3*fdd*s**2 + 504*D1**2*f**3*fdd*s - 252*D1**2*f**3*fdd - 1008*D1**2*f**2*fd**2*r**2 - 2016*D1**2*f**2*fd**2*r*s + 1512*D1**2*f**2*fd**2*r - 1008*D1**2*f**2*fd**2*s**2 + 1512*D1**2*f**2*fd**2*s - 504*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r**2 - 264*D1**2*f**2*fd*r*s + 176*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 176*D1**2*f**2*fd*s - 88*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r**2 + 132*D1**2*f**2*fdd*r*s - 88*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 88*D1**2*f**2*fdd*s + 44*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 396*D1**2*f**2*gd2*s**2 + 792*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 396*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 132*D1**2*f*fd**2*r**2 + 264*D1**2*f*fd**2*r*s - 176*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 176*D1**2*f*fd**2*s + 44*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 792*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1584*D1**2*f*fd*gd2*r*s - 1188*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1188*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 792*D1*Dd*K*b1*f**2*r**2 + 1584*D1*Dd*K*b1*f**2*r*s - 1188*D1*Dd*K*b1*f**2*r + 792*D1*Dd*K*b1*f**2*s**2 - 1188*D1*Dd*K*b1*f**2*s + 594*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 3168*D1*Dd*K*b1*f*fd*r*s + 1980*D1*Dd*K*b1*f*fd*r - 1584*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 594*D1*Dd*K*b1*f*fd - 792*D1*Dd*b1*f**2*r**2 - 1584*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 792*D1*Dd*b1*f**2*s**2 + 1188*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 1584*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r + 1584*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s + 594*D1*Dd*b1*f*fd + 672*D1*Dd*f**4*r**2 + 1344*D1*Dd*f**4*r*s - 1008*D1*Dd*f**4*r + 672*D1*Dd*f**4*s**2 - 1008*D1*Dd*f**4*s + 504*D1*Dd*f**4 - 2688*D1*Dd*f**3*fd*r**2 - 5376*D1*Dd*f**3*fd*r*s + 4032*D1*Dd*f**3*fd*r - 2688*D1*Dd*f**3*fd*s**2 + 4032*D1*Dd*f**3*fd*s - 1512*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r**2 - 352*D1*Dd*f**3*r*s + 264*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 264*D1*Dd*f**3*s - 132*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r**2 + 1056*D1*Dd*f**2*fd*r*s - 748*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 748*D1*Dd*f**2*fd*s + 264*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 2376*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 3168*D1*Dd*f**2*gd2*r*s - 2772*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 1188*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 6336*D1*Dd*f*fd*g2*r*s - 3960*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 1188*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 792*D1*Ddd*K*b1*f**2*r*s + 594*D1*Ddd*K*b1*f**2*r - 396*D1*Ddd*K*b1*f**2*s**2 + 594*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 396*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 396*D1*Ddd*b1*f**2*s**2 - 594*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 - 336*D1*Ddd*f**4*r**2 - 672*D1*Ddd*f**4*r*s + 504*D1*Ddd*f**4*r - 336*D1*Ddd*f**4*s**2 + 504*D1*Ddd*f**4*s - 252*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r**2 + 176*D1*Ddd*f**3*r*s - 132*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 132*D1*Ddd*f**3*s + 66*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1584*D1*Ddd*f**2*g2*r*s - 1188*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1188*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 198*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1188*Dd**2*K*b1*f**2*r**2 - 2376*Dd**2*K*b1*f**2*r*s + 1782*Dd**2*K*b1*f**2*r - 1188*Dd**2*K*b1*f**2*s**2 + 1782*Dd**2*K*b1*f**2*s - 594*Dd**2*K*b1*f**2 + 1188*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 1188*Dd**2*b1*f**2*s**2 - 1782*Dd**2*b1*f**2*s + 594*Dd**2*b1*f**2 - 1008*Dd**2*f**4*r**2 - 2016*Dd**2*f**4*r*s + 1512*Dd**2*f**4*r - 1008*Dd**2*f**4*s**2 + 1512*Dd**2*f**4*s - 504*Dd**2*f**4 + 264*Dd**2*f**3*r**2 + 528*Dd**2*f**3*r*s - 396*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 396*Dd**2*f**3*s + 132*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 4752*Dd**2*f**2*g2*r*s - 3564*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3564*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2)/(1386*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**4*st**4*(-6*C*D1**2*bdd1*f**2*r**2 - 12*C*D1**2*bdd1*f**2*r*s + 12*C*D1**2*bdd1*f**2*r - 6*C*D1**2*bdd1*f**2*s**2 + 12*C*D1**2*bdd1*f**2*s - 6*C*D1**2*bdd1*f**2 + 390*C*D1**2*f**2*fd*r**2 + 780*C*D1**2*f**2*fd*r*s - 520*C*D1**2*f**2*fd*r + 390*C*D1**2*f**2*fd*s**2 - 520*C*D1**2*f**2*fd*s + 260*C*D1**2*f**2*fd - 240*C*D1**2*f**2*fdd*r**2 - 480*C*D1**2*f**2*fdd*r*s + 320*C*D1**2*f**2*fdd*r - 240*C*D1**2*f**2*fdd*s**2 + 320*C*D1**2*f**2*fdd*s - 160*C*D1**2*f**2*fdd - 480*C*D1**2*f*fd**2*r**2 - 960*C*D1**2*f*fd**2*r*s + 640*C*D1**2*f*fd**2*r - 480*C*D1**2*f*fd**2*s**2 + 640*C*D1**2*f*fd**2*s - 160*C*D1**2*f*fd**2 + 520*C*D1*Dd*f**3*r**2 + 1040*C*D1*Dd*f**3*r*s - 780*C*D1*Dd*f**3*r + 520*C*D1*Dd*f**3*s**2 - 780*C*D1*Dd*f**3*s + 390*C*D1*Dd*f**3 - 1920*C*D1*Dd*f**2*fd*r**2 - 3840*C*D1*Dd*f**2*fd*r*s + 2720*C*D1*Dd*f**2*fd*r - 1920*C*D1*Dd*f**2*fd*s**2 + 2720*C*D1*Dd*f**2*fd*s - 960*C*D1*Dd*f**2*fd - 320*C*D1*Ddd*f**3*r**2 - 640*C*D1*Ddd*f**3*r*s + 480*C*D1*Ddd*f**3*r - 320*C*D1*Ddd*f**3*s**2 + 480*C*D1*Ddd*f**3*s - 240*C*D1*Ddd*f**3 - 960*C*Dd**2*f**3*r**2 - 1920*C*Dd**2*f**3*r*s + 1440*C*Dd**2*f**3*r - 960*C*Dd**2*f**3*s**2 + 1440*C*Dd**2*f**3*s - 480*C*Dd**2*f**3 - 120*D1**2*K*bdd1*f**2*r**2 - 240*D1**2*K*bdd1*f**2*r*s + 240*D1**2*K*bdd1*f**2*r - 120*D1**2*K*bdd1*f**2*s**2 + 240*D1**2*K*bdd1*f**2*s - 120*D1**2*K*bdd1*f**2 - 42*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 60*D1**2*bdd1*f**3*r**2 + 120*D1**2*bdd1*f**3*r*s - 120*D1**2*bdd1*f**3*r + 60*D1**2*bdd1*f**3*s**2 - 120*D1**2*bdd1*f**3*s + 60*D1**2*bdd1*f**3 + 66*D1**2*bdd1*f**2*r**2 + 132*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*r + 66*D1**2*bdd1*f**2*s**2 - 132*D1**2*bdd1*f**2*s + 66*D1**2*bdd1*f**2 + 42*D1**2*bdd1*f*g2*r**2 + 84*D1**2*bdd1*f*g2*r*s - 84*D1**2*bdd1*f*g2*r + 42*D1**2*bdd1*f*g2*s**2 - 84*D1**2*bdd1*f*g2*s + 42*D1**2*bdd1*f*g2 - 60*D1**2*f**3*fd*r**2 - 120*D1**2*f**3*fd*r*s + 90*D1**2*f**3*fd*r - 60*D1**2*f**3*fd*s**2 + 90*D1**2*f**3*fd*s - 45*D1**2*f**3*fd - 288*D1**2*f**2*fd*r**2 - 576*D1**2*f**2*fd*r*s + 384*D1**2*f**2*fd*r - 288*D1**2*f**2*fd*s**2 + 384*D1**2*f**2*fd*s - 192*D1**2*f**2*fd + 180*D1**2*f**2*fdd*r**2 + 360*D1**2*f**2*fdd*r*s - 240*D1**2*f**2*fdd*r + 180*D1**2*f**2*fdd*s**2 - 240*D1**2*f**2*fdd*s + 120*D1**2*f**2*fdd - 270*D1**2*f**2*gd2*r**2 - 540*D1**2*f**2*gd2*r*s + 540*D1**2*f**2*gd2*r - 270*D1**2*f**2*gd2*s**2 + 540*D1**2*f**2*gd2*s - 270*D1**2*f**2*gd2 + 240*D1**2*f**2*gdd2*r**2 + 480*D1**2*f**2*gdd2*r*s - 480*D1**2*f**2*gdd2*r + 240*D1**2*f**2*gdd2*s**2 - 480*D1**2*f**2*gdd2*s + 240*D1**2*f**2*gdd2 + 360*D1**2*f*fd**2*r**2 + 720*D1**2*f*fd**2*r*s - 480*D1**2*f*fd**2*r + 360*D1**2*f*fd**2*s**2 - 480*D1**2*f*fd**2*s + 120*D1**2*f*fd**2 - 540*D1**2*f*fd*g2*r**2 - 1080*D1**2*f*fd*g2*r*s + 540*D1**2*f*fd*g2*r - 540*D1**2*f*fd*g2*s**2 + 540*D1**2*f*fd*g2*s - 270*D1**2*f*fd*g2 + 960*D1**2*f*fd*gd2*r**2 + 1920*D1**2*f*fd*gd2*r*s - 1440*D1**2*f*fd*gd2*r + 960*D1**2*f*fd*gd2*s**2 - 1440*D1**2*f*fd*gd2*s + 480*D1**2*f*fd*gd2 + 480*D1**2*f*fdd*g2*r**2 + 960*D1**2*f*fdd*g2*r*s - 480*D1**2*f*fdd*g2*r + 480*D1**2*f*fdd*g2*s**2 - 480*D1**2*f*fdd*g2*s + 240*D1**2*f*fdd*g2 + 480*D1**2*fd**2*g2*r**2 + 960*D1**2*fd**2*g2*r*s - 480*D1**2*fd**2*g2*r + 480*D1**2*fd**2*g2*s**2 - 480*D1**2*fd**2*g2*s - 60*D1*Dd*f**4*r**2 - 120*D1*Dd*f**4*r*s + 90*D1*Dd*f**4*r - 60*D1*Dd*f**4*s**2 + 90*D1*Dd*f**4*s - 45*D1*Dd*f**4 - 384*D1*Dd*f**3*r**2 - 768*D1*Dd*f**3*r*s + 576*D1*Dd*f**3*r - 384*D1*Dd*f**3*s**2 + 576*D1*Dd*f**3*s - 288*D1*Dd*f**3 + 1440*D1*Dd*f**2*fd*r**2 + 2880*D1*Dd*f**2*fd*r*s - 2040*D1*Dd*f**2*fd*r + 1440*D1*Dd*f**2*fd*s**2 - 2040*D1*Dd*f**2*fd*s + 720*D1*Dd*f**2*fd - 1080*D1*Dd*f**2*g2*r**2 - 2160*D1*Dd*f**2*g2*r*s + 1620*D1*Dd*f**2*g2*r - 1080*D1*Dd*f**2*g2*s**2 + 1620*D1*Dd*f**2*g2*s - 810*D1*Dd*f**2*g2 + 1920*D1*Dd*f**2*gd2*r**2 + 3840*D1*Dd*f**2*gd2*r*s - 3360*D1*Dd*f**2*gd2*r + 1920*D1*Dd*f**2*gd2*s**2 - 3360*D1*Dd*f**2*gd2*s + 1440*D1*Dd*f**2*gd2 + 3840*D1*Dd*f*fd*g2*r**2 + 7680*D1*Dd*f*fd*g2*r*s - 4800*D1*Dd*f*fd*g2*r + 3840*D1*Dd*f*fd*g2*s**2 - 4800*D1*Dd*f*fd*g2*s + 1440*D1*Dd*f*fd*g2 + 240*D1*Ddd*f**3*r**2 + 480*D1*Ddd*f**3*r*s - 360*D1*Ddd*f**3*r + 240*D1*Ddd*f**3*s**2 - 360*D1*Ddd*f**3*s + 180*D1*Ddd*f**3 + 960*D1*Ddd*f**2*g2*r**2 + 1920*D1*Ddd*f**2*g2*r*s - 1440*D1*Ddd*f**2*g2*r + 960*D1*Ddd*f**2*g2*s**2 - 1440*D1*Ddd*f**2*g2*s + 720*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(30*f**3*(r + s - 1) - f**2*(4*C*(r + s - 1) + 40*fd*(3*r + 3*s - 2) + (45*K - 23)*(r + s - 1)) + 4*f*(fd*(C + 20*K - 11)*(2*r + 2*s - 1) + (7*g2 - 7*gd2)*(r + s - 1)) - 28*fd*g2*(r + s)) - 4*Dd*f*(10*f**2 - f*(C + 20*K - 11) + 7*g2)*(4*r + 4*s - 3))*(r + s - 1) + 720*Dd**2*f**3*r**2 + 1440*Dd**2*f**3*r*s - 1080*Dd**2*f**3*r + 720*Dd**2*f**3*s**2 - 1080*Dd**2*f**3*s + 360*Dd**2*f**3 + 2880*Dd**2*f**2*g2*r**2 + 5760*Dd**2*f**2*g2*r*s - 4320*Dd**2*f**2*g2*r + 2880*Dd**2*f**2*g2*s**2 - 4320*Dd**2*f**2*g2*s + 1440*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(8*C*D1**2*f*fd*r**2 + 16*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd*s + 4*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 - 8*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 4*C*D1**2*f*fdd*s - 2*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 - 8*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 4*C*D1**2*fd**2*s + 16*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 24*C*D1*Dd*f**2*s + 12*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 - 64*C*D1*Dd*f*fd*r*s + 40*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 40*C*D1*Dd*f*fd*s - 12*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 - 16*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 12*C*D1*Ddd*f**2*s - 6*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 - 48*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 36*C*Dd**2*f**2*s - 12*C*Dd**2*f**2 + 90*D1**2*K*f*fd*r**2 + 180*D1**2*K*f*fd*r*s - 90*D1**2*K*f*fd*r + 90*D1**2*K*f*fd*s**2 - 90*D1**2*K*f*fd*s + 45*D1**2*K*f*fd - 80*D1**2*K*f*fdd*r**2 - 160*D1**2*K*f*fdd*r*s + 80*D1**2*K*f*fdd*r - 80*D1**2*K*f*fdd*s**2 + 80*D1**2*K*f*fdd*s - 40*D1**2*K*f*fdd - 80*D1**2*K*fd**2*r**2 - 160*D1**2*K*fd**2*r*s + 80*D1**2*K*fd**2*r - 80*D1**2*K*fd**2*s**2 + 80*D1**2*K*fd**2*s - 14*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 90*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 120*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 80*D1**2*f**2*fdd*s + 40*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r**2 + 240*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 160*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 46*D1**2*f*fd*r**2 - 92*D1**2*f*fd*r*s + 46*D1**2*f*fd*r - 46*D1**2*f*fd*s**2 + 46*D1**2*f*fd*s - 23*D1**2*f*fd + 44*D1**2*f*fdd*r**2 + 88*D1**2*f*fdd*r*s - 44*D1**2*f*fdd*r + 44*D1**2*f*fdd*s**2 - 44*D1**2*f*fdd*s + 22*D1**2*f*fdd - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 14*D1**2*f*gdd2*r**2 + 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 + 44*D1**2*fd**2*r**2 + 88*D1**2*fd**2*r*s - 44*D1**2*fd**2*r + 44*D1**2*fd**2*s**2 - 44*D1**2*fd**2*s - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s - 28*D1**2*fd*g2*s**2 + 28*D1**2*fd*gd2*r**2 + 56*D1**2*fd*gd2*r*s - 28*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 28*D1**2*fd*gd2*s + 14*D1**2*fdd*g2*r**2 + 28*D1**2*fdd*g2*r*s + 14*D1**2*fdd*g2*s**2 + 180*D1*Dd*K*f**2*r**2 + 360*D1*Dd*K*f**2*r*s - 270*D1*Dd*K*f**2*r + 180*D1*Dd*K*f**2*s**2 - 270*D1*Dd*K*f**2*s + 135*D1*Dd*K*f**2 - 640*D1*Dd*K*f*fd*r**2 - 1280*D1*Dd*K*f*fd*r*s + 800*D1*Dd*K*f*fd*r - 640*D1*Dd*K*f*fd*s**2 + 800*D1*Dd*K*f*fd*s - 240*D1*Dd*K*f*fd - 120*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 180*D1*Dd*f**3*s - 90*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 960*D1*Dd*f**2*fd*r*s - 680*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 680*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd - 92*D1*Dd*f**2*r**2 - 184*D1*Dd*f**2*r*s + 138*D1*Dd*f**2*r - 92*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 69*D1*Dd*f**2 + 352*D1*Dd*f*fd*r**2 + 704*D1*Dd*f*fd*r*s - 440*D1*Dd*f*fd*r + 352*D1*Dd*f*fd*s**2 - 440*D1*Dd*f*fd*s + 132*D1*Dd*f*fd - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 + 224*D1*Dd*f*gd2*r*s - 196*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 196*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r**2 + 224*D1*Dd*fd*g2*r*s - 84*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 84*D1*Dd*fd*g2*s - 160*D1*Ddd*K*f**2*r**2 - 320*D1*Ddd*K*f**2*r*s + 240*D1*Ddd*K*f**2*r - 160*D1*Ddd*K*f**2*s**2 + 240*D1*Ddd*K*f**2*s - 120*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r**2 + 160*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 120*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 88*D1*Ddd*f**2*r**2 + 176*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 88*D1*Ddd*f**2*s**2 - 132*D1*Ddd*f**2*s + 66*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 + 112*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 84*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 28*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 480*Dd**2*K*f**2*r**2 - 960*Dd**2*K*f**2*r*s + 720*Dd**2*K*f**2*r - 480*Dd**2*K*f**2*s**2 + 720*Dd**2*K*f**2*s - 240*Dd**2*K*f**2 + 240*Dd**2*f**3*r**2 + 480*Dd**2*f**3*r*s - 360*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 360*Dd**2*f**3*s + 120*Dd**2*f**3 + 264*Dd**2*f**2*r**2 + 528*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 264*Dd**2*f**2*s**2 - 396*Dd**2*f**2*s + 132*Dd**2*f**2 + 168*Dd**2*f*g2*r**2 + 336*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 252*Dd**2*f*g2*s + 84*Dd**2*f*g2))/(210*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**4*st**2*(-12*D1**2*bd1**2*f*(-28*K + 15*f + 14)*(r + s - 1)**2 + 12*D1**2*bdd1*f*(3*f*(4*C + 3*K - 3) - 28*g2)*(r + s - 1)**2 + 12*D1**2*(f**2*(-fd*(5*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (gd2 - 18*gdd2)*(r + s - 1)**2) + f*(fd**2*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + fd*(g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 36*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 18*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 36*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*D1*bd1*(D1*(18*f**3*(r + s - 1) + f**2*(109*C + 3*K - 59)*(r + s - 1) - 36*f*fd*(4*C + 3*K - 3)*(2*r + 2*s - 1) - 7*f*(23*g2 - 48*gd2)*(r + s - 1) + 336*fd*g2*(r + s)) - 12*Dd*f*(3*f*(4*C + 3*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 12*D1*f*(Dd*(f**2*(5*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-fd*(20*C - 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 36*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 36*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(f*(10*C - 5) - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 72*Dd**2*f**2*(f*(10*C - 5) - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + b1**2*(D1**2*(6*f*(23*fd - 15*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(180*fd**2*(r + s - 1) + 7*fd*(23*K - 9)*(r + s) - 84*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(138*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(180*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (161*K - 63)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 168*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-28*K + 15*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-28*K + 15*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(-218*C*D1**2*f*fd*r**2 - 436*C*D1**2*f*fd*r*s + 218*C*D1**2*f*fd*r - 218*C*D1**2*f*fd*s**2 + 218*C*D1**2*f*fd*s - 109*C*D1**2*f*fd + 144*C*D1**2*f*fdd*r**2 + 288*C*D1**2*f*fdd*r*s - 144*C*D1**2*f*fdd*r + 144*C*D1**2*f*fdd*s**2 - 144*C*D1**2*f*fdd*s + 72*C*D1**2*f*fdd + 144*C*D1**2*fd**2*r**2 + 288*C*D1**2*fd**2*r*s - 144*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 144*C*D1**2*fd**2*s - 436*C*D1*Dd*f**2*r**2 - 872*C*D1*Dd*f**2*r*s + 654*C*D1*Dd*f**2*r - 436*C*D1*Dd*f**2*s**2 + 654*C*D1*Dd*f**2*s - 327*C*D1*Dd*f**2 + 1152*C*D1*Dd*f*fd*r**2 + 2304*C*D1*Dd*f*fd*r*s - 1440*C*D1*Dd*f*fd*r + 1152*C*D1*Dd*f*fd*s**2 - 1440*C*D1*Dd*f*fd*s + 432*C*D1*Dd*f*fd + 288*C*D1*Ddd*f**2*r**2 + 576*C*D1*Ddd*f**2*r*s - 432*C*D1*Ddd*f**2*r + 288*C*D1*Ddd*f**2*s**2 - 432*C*D1*Ddd*f**2*s + 216*C*D1*Ddd*f**2 + 864*C*Dd**2*f**2*r**2 + 1728*C*Dd**2*f**2*r*s - 1296*C*Dd**2*f**2*r + 864*C*Dd**2*f**2*s**2 - 1296*C*Dd**2*f**2*s + 432*C*Dd**2*f**2 - 6*D1**2*K*f*fd*r**2 - 12*D1**2*K*f*fd*r*s + 6*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd + 108*D1**2*K*f*fdd*r**2 + 216*D1**2*K*f*fdd*r*s - 108*D1**2*K*f*fdd*r + 108*D1**2*K*f*fdd*s**2 - 108*D1**2*K*f*fdd*s + 54*D1**2*K*f*fdd + 108*D1**2*K*fd**2*r**2 + 216*D1**2*K*fd**2*r*s - 108*D1**2*K*fd**2*r + 108*D1**2*K*fd**2*s**2 - 108*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-28*K + 15*f + 14)*(r + s - 1)**2 - 54*D1**2*f**2*fd*r**2 - 108*D1**2*f**2*fd*r*s + 72*D1**2*f**2*fd*r - 54*D1**2*f**2*fd*s**2 + 72*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 118*D1**2*f*fd*r**2 + 236*D1**2*f*fd*r*s - 118*D1**2*f*fd*r + 118*D1**2*f*fd*s**2 - 118*D1**2*f*fd*s + 59*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 216*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*r - 108*D1**2*f*fdd*s**2 + 108*D1**2*f*fdd*s - 54*D1**2*f*fdd + 161*D1**2*f*gd2*r**2 + 322*D1**2*f*gd2*r*s - 322*D1**2*f*gd2*r + 161*D1**2*f*gd2*s**2 - 322*D1**2*f*gd2*s + 161*D1**2*f*gd2 - 168*D1**2*f*gdd2*r**2 - 336*D1**2*f*gdd2*r*s + 336*D1**2*f*gdd2*r - 168*D1**2*f*gdd2*s**2 + 336*D1**2*f*gdd2*s - 168*D1**2*f*gdd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 108*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 108*D1**2*fd**2*s + 161*D1**2*fd*g2*r**2 + 322*D1**2*fd*g2*r*s + 161*D1**2*fd*g2*s**2 - 336*D1**2*fd*gd2*r**2 - 672*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s**2 + 336*D1**2*fd*gd2*s - 168*D1**2*fdd*g2*r**2 - 336*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*s**2 - 12*D1*Dd*K*f**2*r**2 - 24*D1*Dd*K*f**2*r*s + 18*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 18*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 864*D1*Dd*K*f*fd*r**2 + 1728*D1*Dd*K*f*fd*r*s - 1080*D1*Dd*K*f*fd*r + 864*D1*Dd*K*f*fd*s**2 - 1080*D1*Dd*K*f*fd*s + 324*D1*Dd*K*f*fd - 72*D1*Dd*f**3*r**2 - 144*D1*Dd*f**3*r*s + 108*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 108*D1*Dd*f**3*s - 54*D1*Dd*f**3 + 236*D1*Dd*f**2*r**2 + 472*D1*Dd*f**2*r*s - 354*D1*Dd*f**2*r + 236*D1*Dd*f**2*s**2 - 354*D1*Dd*f**2*s + 177*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 1728*D1*Dd*f*fd*r*s + 1080*D1*Dd*f*fd*r - 864*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 324*D1*Dd*f*fd + 644*D1*Dd*f*g2*r**2 + 1288*D1*Dd*f*g2*r*s - 966*D1*Dd*f*g2*r + 644*D1*Dd*f*g2*s**2 - 966*D1*Dd*f*g2*s + 483*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r**2 - 2688*D1*Dd*f*gd2*r*s + 2352*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 2352*D1*Dd*f*gd2*s - 1008*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r**2 - 2688*D1*Dd*fd*g2*r*s + 1008*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 + 1008*D1*Dd*fd*g2*s + 216*D1*Ddd*K*f**2*r**2 + 432*D1*Ddd*K*f**2*r*s - 324*D1*Ddd*K*f**2*r + 216*D1*Ddd*K*f**2*s**2 - 324*D1*Ddd*K*f**2*s + 162*D1*Ddd*K*f**2 - 216*D1*Ddd*f**2*r**2 - 432*D1*Ddd*f**2*r*s + 324*D1*Ddd*f**2*r - 216*D1*Ddd*f**2*s**2 + 324*D1*Ddd*f**2*s - 162*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 - 1344*D1*Ddd*f*g2*r*s + 1008*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 1008*D1*Ddd*f*g2*s - 504*D1*Ddd*f*g2 + D1*bd1*(D1*(138*f**2*(r + s - 1) - 180*f*fd*(2*r + 2*s - 1) - 7*f*(23*K - 9)*(r + s - 1) + 168*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-28*K + 15*f + 14)*(4*r + 4*s - 3))*(r + s - 1) + 648*Dd**2*K*f**2*r**2 + 1296*Dd**2*K*f**2*r*s - 972*Dd**2*K*f**2*r + 648*Dd**2*K*f**2*s**2 - 972*Dd**2*K*f**2*s + 324*Dd**2*K*f**2 - 648*Dd**2*f**2*r**2 - 1296*Dd**2*f**2*r*s + 972*Dd**2*f**2*r - 648*Dd**2*f**2*s**2 + 972*Dd**2*f**2*s - 324*Dd**2*f**2 - 2016*Dd**2*f*g2*r**2 - 4032*Dd**2*f*g2*r*s + 3024*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 3024*Dd**2*f*g2*s - 1008*Dd**2*f*g2))/(210*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**4*(-3*D1*(84*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(f**2*(6*C + 7*K - 17)*(r + s - 1) + f*fd*(120*C - 60)*(2*r + 2*s - 1) - 42*f*(g2 + 4*gd2)*(r + s - 1) - 168*fd*g2*(r + s)) + 12*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) + f*(6*D1*bdd1*(f*(10*C - 5) - 14*g2)*(r + s - 1)**2 + D1*(f*(fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*gd2*(r + s - 1)**2) - 14*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + 7*b1**2*(D1**2*(9*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)**2*(18*K*fdd + fd*(9*K - 10))) + D1*(Dd*(-36*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(9*K - 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-3*D1**2*(f*(fd*(6*C + 7*K - 17)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*(r + s - 1)**2*(14*K*bdd1 - 7*gd2 - 14*gdd2)) + (6*r + 6*s)*(fd**2*(20*C - 10)*(r + s - 1) - 7*fd*(g2*(r + s) + 4*gd2*(r + s - 1)) - 14*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-36*K*fd*(r + s) + 9*f**2*(r + s - 1) - f*(9*K - 10)*(r + s - 1)) - 36*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(f**2*(6*C + 7*K - 17)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*f*(fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 28*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 168*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 6*Ddd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 108*Dd**2*f*(f*(10*C - 5) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**2*st**4*(42*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 6*D1*bd1*(D1*(5*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(2*C*s**2 - 5*fd*(15*r**2 + r*(30*s - 23) + 15*s**2 - 23*s + 8) + r**2*(2*C + 11) + r*(4*C*s + 22*s - 26) + 11*s**2 - 26*s + 13) - 4*f*fd*(r + s - 1)*(r*(C + 9) + s*(C + 9) - 5) + 14*f*(r + s)*(-g2*(r + s) + gd2*(r + s - 1)) + 14*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(5*f**2*(5*r + 5*s - 4) + 2*f*(r*(C + 9) + s*(C + 9) - 10) - 14*g2*(r + s))) - 21*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(8*C*D1**2*f*fd*r**2 + 16*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 16*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 - 8*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 8*C*D1**2*f*fdd*s - 4*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 - 8*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 8*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 + 16*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 24*C*D1*Dd*f**2*s + 12*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 - 64*C*D1*Dd*f*fd*r*s + 56*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 56*C*D1*Dd*f*fd*s - 24*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 - 16*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 12*C*D1*Ddd*f**2*s - 6*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 - 48*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 36*C*Dd**2*f**2*s - 12*C*Dd**2*f**2 - 7*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 120*D1**2*f**2*fd*r**2 + 240*D1**2*f**2*fd*r*s - 180*D1**2*f**2*fd*r + 120*D1**2*f**2*fd*s**2 - 180*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 110*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 110*D1**2*f**2*fdd*s - 55*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 220*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 220*D1**2*f*fd**2*s - 70*D1**2*f*fd**2 + 44*D1**2*f*fd*r**2 + 88*D1**2*f*fd*r*s - 36*D1**2*f*fd*r + 44*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s + 18*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 32*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 32*D1**2*f*fdd*s - 16*D1**2*f*fdd - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 14*D1**2*f*gdd2*r**2 + 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 32*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 32*D1**2*fd**2*s + 4*D1**2*fd**2 - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 28*D1**2*fd*gd2*r**2 + 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 56*D1**2*fd*gd2*s + 28*D1**2*fd*gd2 + 14*D1**2*fdd*g2*r**2 + 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 + 160*D1*Dd*f**3*r**2 + 320*D1*Dd*f**3*r*s - 240*D1*Dd*f**3*r + 160*D1*Dd*f**3*s**2 - 240*D1*Dd*f**3*s + 120*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 890*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 890*D1*Dd*f**2*fd*s - 330*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r**2 + 176*D1*Dd*f**2*r*s - 132*D1*Dd*f**2*r + 88*D1*Dd*f**2*s**2 - 132*D1*Dd*f**2*s + 66*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 344*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 344*D1*Dd*f*fd*s - 96*D1*Dd*f*fd - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 + 224*D1*Dd*f*gd2*r*s - 196*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 196*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r**2 + 224*D1*Dd*fd*g2*r*s - 196*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 196*D1*Dd*fd*g2*s + 84*D1*Dd*fd*g2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 + 112*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 84*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 14*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3 - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 + 168*Dd**2*f*g2*r**2 + 336*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 252*Dd**2*f*g2*s + 84*Dd**2*f*g2) + f*(3*D1**2*bdd1*(5*f**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 4) + 2*f*(r**2*(C + 9) + 2*r*(s*(C + 9) - 10) + s**2*(C + 9) - 20*s + 10) - 14*g2*(r + s)**2) - 2*D1**2*(f*(17*fd - 10*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 20*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 2*D1*f*(Dd*(17*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 20*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 120*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**2*st**2*(396*C*D1**2*f**2*fd*r**2 + 792*C*D1**2*f**2*fd*r*s - 528*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 528*C*D1**2*f**2*fd*s + 264*C*D1**2*f**2*fd - 360*C*D1**2*f**2*fdd*r**2 - 720*C*D1**2*f**2*fdd*r*s + 480*C*D1**2*f**2*fdd*r - 360*C*D1**2*f**2*fdd*s**2 + 480*C*D1**2*f**2*fdd*s - 240*C*D1**2*f**2*fdd - 720*C*D1**2*f*fd**2*r**2 - 1440*C*D1**2*f*fd**2*r*s + 960*C*D1**2*f*fd**2*r - 720*C*D1**2*f*fd**2*s**2 + 960*C*D1**2*f*fd**2*s - 240*C*D1**2*f*fd**2 + 528*C*D1*Dd*f**3*r**2 + 1056*C*D1*Dd*f**3*r*s - 792*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 792*C*D1*Dd*f**3*s + 396*C*D1*Dd*f**3 - 2880*C*D1*Dd*f**2*fd*r**2 - 5760*C*D1*Dd*f**2*fd*r*s + 4080*C*D1*Dd*f**2*fd*r - 2880*C*D1*Dd*f**2*fd*s**2 + 4080*C*D1*Dd*f**2*fd*s - 1440*C*D1*Dd*f**2*fd - 480*C*D1*Ddd*f**3*r**2 - 960*C*D1*Ddd*f**3*r*s + 720*C*D1*Ddd*f**3*r - 480*C*D1*Ddd*f**3*s**2 + 720*C*D1*Ddd*f**3*s - 360*C*D1*Ddd*f**3 - 1440*C*Dd**2*f**3*r**2 - 2880*C*Dd**2*f**3*r*s + 2160*C*Dd**2*f**3*r - 1440*C*Dd**2*f**3*s**2 + 2160*C*Dd**2*f**3*s - 720*C*Dd**2*f**3 + 180*D1**2*b2*f*fd*r**2 + 360*D1**2*b2*f*fd*r*s - 180*D1**2*b2*f*fd*r + 180*D1**2*b2*f*fd*s**2 - 180*D1**2*b2*f*fd*s + 90*D1**2*b2*f*fd - 216*D1**2*b2*f*fdd*r**2 - 432*D1**2*b2*f*fdd*r*s + 216*D1**2*b2*f*fdd*r - 216*D1**2*b2*f*fdd*s**2 + 216*D1**2*b2*f*fdd*s - 108*D1**2*b2*f*fdd - 216*D1**2*b2*fd**2*r**2 - 432*D1**2*b2*fd**2*r*s + 216*D1**2*b2*fd**2*r - 216*D1**2*b2*fd**2*s**2 + 216*D1**2*b2*fd**2*s + 4*D1**2*bd1**2*(r + s - 1)*(18*f**2*(r + s - 2) + 7*f*(r*(C + 6*K + 2) + s*(C + 6*K + 2) - 6) - 35*g2*(r + s)) - 6*D1**2*bdd1*f*(3*f*(-4*C*s**2 + 6*K*(r + s - 1)**2 + r**2*(1 - 4*C) + r*(-8*C*s + 2*s + 4) + s**2 + 4*s - 2) + 28*g2*(r + s)**2) - 108*D1**2*bdd2*f**2*r**2 - 216*D1**2*bdd2*f**2*r*s + 216*D1**2*bdd2*f**2*r - 108*D1**2*bdd2*f**2*s**2 + 216*D1**2*bdd2*f**2*s - 108*D1**2*bdd2*f**2 - 144*D1**2*f**2*fd*r**2 - 288*D1**2*f**2*fd*r*s + 192*D1**2*f**2*fd*r - 144*D1**2*f**2*fd*s**2 + 192*D1**2*f**2*fd*s - 96*D1**2*f**2*fd + 180*D1**2*f**2*fdd*r**2 + 360*D1**2*f**2*fdd*r*s - 240*D1**2*f**2*fdd*r + 180*D1**2*f**2*fdd*s**2 - 240*D1**2*f**2*fdd*s + 120*D1**2*f**2*fdd - 180*D1**2*f**2*gd2*r**2 - 360*D1**2*f**2*gd2*r*s + 360*D1**2*f**2*gd2*r - 180*D1**2*f**2*gd2*s**2 + 360*D1**2*f**2*gd2*s - 180*D1**2*f**2*gd2 + 216*D1**2*f**2*gdd2*r**2 + 432*D1**2*f**2*gdd2*r*s - 432*D1**2*f**2*gdd2*r + 216*D1**2*f**2*gdd2*s**2 - 432*D1**2*f**2*gdd2*s + 216*D1**2*f**2*gdd2 + 360*D1**2*f*fd**2*r**2 + 720*D1**2*f*fd**2*r*s - 480*D1**2*f*fd**2*r + 360*D1**2*f*fd**2*s**2 - 480*D1**2*f*fd**2*s + 120*D1**2*f*fd**2 - 360*D1**2*f*fd*g2*r**2 - 720*D1**2*f*fd*g2*r*s + 360*D1**2*f*fd*g2*r - 360*D1**2*f*fd*g2*s**2 + 360*D1**2*f*fd*g2*s - 180*D1**2*f*fd*g2 + 864*D1**2*f*fd*gd2*r**2 + 1728*D1**2*f*fd*gd2*r*s - 1296*D1**2*f*fd*gd2*r + 864*D1**2*f*fd*gd2*s**2 - 1296*D1**2*f*fd*gd2*s + 432*D1**2*f*fd*gd2 + 432*D1**2*f*fdd*g2*r**2 + 864*D1**2*f*fdd*g2*r*s - 432*D1**2*f*fdd*g2*r + 432*D1**2*f*fdd*g2*s**2 - 432*D1**2*f*fdd*g2*s + 216*D1**2*f*fdd*g2 + 432*D1**2*fd**2*g2*r**2 + 864*D1**2*fd**2*g2*r*s - 432*D1**2*fd**2*g2*r + 432*D1**2*fd**2*g2*s**2 - 432*D1**2*fd**2*g2*s + 360*D1*Dd*b2*f**2*r**2 + 720*D1*Dd*b2*f**2*r*s - 540*D1*Dd*b2*f**2*r + 360*D1*Dd*b2*f**2*s**2 - 540*D1*Dd*b2*f**2*s + 270*D1*Dd*b2*f**2 - 1728*D1*Dd*b2*f*fd*r**2 - 3456*D1*Dd*b2*f*fd*r*s + 2160*D1*Dd*b2*f*fd*r - 1728*D1*Dd*b2*f*fd*s**2 + 2160*D1*Dd*b2*f*fd*s - 648*D1*Dd*b2*f*fd - 192*D1*Dd*f**3*r**2 - 384*D1*Dd*f**3*r*s + 288*D1*Dd*f**3*r - 192*D1*Dd*f**3*s**2 + 288*D1*Dd*f**3*s - 144*D1*Dd*f**3 + 1440*D1*Dd*f**2*fd*r**2 + 2880*D1*Dd*f**2*fd*r*s - 2040*D1*Dd*f**2*fd*r + 1440*D1*Dd*f**2*fd*s**2 - 2040*D1*Dd*f**2*fd*s + 720*D1*Dd*f**2*fd - 720*D1*Dd*f**2*g2*r**2 - 1440*D1*Dd*f**2*g2*r*s + 1080*D1*Dd*f**2*g2*r - 720*D1*Dd*f**2*g2*s**2 + 1080*D1*Dd*f**2*g2*s - 540*D1*Dd*f**2*g2 + 1728*D1*Dd*f**2*gd2*r**2 + 3456*D1*Dd*f**2*gd2*r*s - 3024*D1*Dd*f**2*gd2*r + 1728*D1*Dd*f**2*gd2*s**2 - 3024*D1*Dd*f**2*gd2*s + 1296*D1*Dd*f**2*gd2 + 3456*D1*Dd*f*fd*g2*r**2 + 6912*D1*Dd*f*fd*g2*r*s - 4320*D1*Dd*f*fd*g2*r + 3456*D1*Dd*f*fd*g2*s**2 - 4320*D1*Dd*f*fd*g2*s + 1296*D1*Dd*f*fd*g2 - 432*D1*Ddd*b2*f**2*r**2 - 864*D1*Ddd*b2*f**2*r*s + 648*D1*Ddd*b2*f**2*r - 432*D1*Ddd*b2*f**2*s**2 + 648*D1*Ddd*b2*f**2*s - 324*D1*Ddd*b2*f**2 + 240*D1*Ddd*f**3*r**2 + 480*D1*Ddd*f**3*r*s - 360*D1*Ddd*f**3*r + 240*D1*Ddd*f**3*s**2 - 360*D1*Ddd*f**3*s + 180*D1*Ddd*f**3 + 864*D1*Ddd*f**2*g2*r**2 + 1728*D1*Ddd*f**2*g2*r*s - 1296*D1*Ddd*f**2*g2*r + 864*D1*Ddd*f**2*g2*s**2 - 1296*D1*Ddd*f**2*g2*s + 648*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(9*f**3*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f**2*(-37*C*s**2 + 45*K*(r + s - 1)**2 + r**2*(18 - 37*C) + r*(-74*C*s + 36*s + 16) + 18*s**2 + 16*s - 8) - f*(36*fd*(r + s - 1)*(-4*C*r - 4*C*s + K*(6*r + 6*s - 3) + r + s + 1) + (7*r + 7*s)*(g2*(r + s) + 24*gd2*(r + s - 1))) - 168*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 6*Dd*f*(3*f*(-4*C*r - 4*C*s + 6*K*(r + s - 1) + r + s + 2) + 28*g2*(r + s))*(4*r + 4*s - 3)) + 18*D1*bd2*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(4*r + 4*s - 3)) - 1296*Dd**2*b2*f**2*r**2 - 2592*Dd**2*b2*f**2*r*s + 1944*Dd**2*b2*f**2*r - 1296*Dd**2*b2*f**2*s**2 + 1944*Dd**2*b2*f**2*s - 648*Dd**2*b2*f**2 + 720*Dd**2*f**3*r**2 + 1440*Dd**2*f**3*r*s - 1080*Dd**2*f**3*r + 720*Dd**2*f**3*s**2 - 1080*Dd**2*f**3*s + 360*Dd**2*f**3 + 2592*Dd**2*f**2*g2*r**2 + 5184*Dd**2*f**2*g2*r*s - 3888*Dd**2*f**2*g2*r + 2592*Dd**2*f**2*g2*s**2 - 3888*Dd**2*f**2*g2*s + 1296*Dd**2*f**2*g2 - 35*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-28*C*D1**2*fd*r**2 - 56*C*D1**2*fd*r*s + 56*C*D1**2*fd*r - 28*C*D1**2*fd*s**2 + 56*C*D1**2*fd*s - 28*C*D1**2*fd + 14*C*D1**2*fdd*r**2 + 28*C*D1**2*fdd*r*s - 28*C*D1**2*fdd*r + 14*C*D1**2*fdd*s**2 - 28*C*D1**2*fdd*s + 14*C*D1**2*fdd - 112*C*D1*Dd*f*r**2 - 224*C*D1*Dd*f*r*s + 168*C*D1*Dd*f*r - 112*C*D1*Dd*f*s**2 + 168*C*D1*Dd*f*s - 84*C*D1*Dd*f + 112*C*D1*Dd*fd*r**2 + 224*C*D1*Dd*fd*r*s - 196*C*D1*Dd*fd*r + 112*C*D1*Dd*fd*s**2 - 196*C*D1*Dd*fd*s + 84*C*D1*Dd*fd + 56*C*D1*Ddd*f*r**2 + 112*C*D1*Ddd*f*r*s - 84*C*D1*Ddd*f*r + 56*C*D1*Ddd*f*s**2 - 84*C*D1*Ddd*f*s + 42*C*D1*Ddd*f + 168*C*Dd**2*f*r**2 + 336*C*Dd**2*f*r*s - 252*C*Dd**2*f*r + 168*C*Dd**2*f*s**2 - 252*C*Dd**2*f*s + 84*C*Dd**2*f + 7*D1**2*K*fd*r**2 + 14*D1**2*K*fd*r*s - 14*D1**2*K*fd*r + 7*D1**2*K*fd*s**2 - 14*D1**2*K*fd*s + 7*D1**2*K*fd + 84*D1**2*K*fdd*r**2 + 168*D1**2*K*fdd*r*s - 168*D1**2*K*fdd*r + 84*D1**2*K*fdd*s**2 - 168*D1**2*K*fdd*s + 84*D1**2*K*fdd + 35*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 144*D1**2*f*fd*r**2 - 288*D1**2*f*fd*r*s + 84*D1**2*f*fd*r - 144*D1**2*f*fd*s**2 + 84*D1**2*f*fd*s - 42*D1**2*f*fd + 72*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s + 72*D1**2*f*fdd*s**2 + 72*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s + 72*D1**2*fd**2*s**2 - 72*D1**2*fd**2 - 91*D1**2*fd*r**2 - 182*D1**2*fd*r*s - 14*D1**2*fd*r - 91*D1**2*fd*s**2 - 14*D1**2*fd*s + 7*D1**2*fd + 28*D1**2*fdd*r**2 + 56*D1**2*fdd*r*s + 112*D1**2*fdd*r + 28*D1**2*fdd*s**2 + 112*D1**2*fdd*s - 56*D1**2*fdd + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 + 28*D1*Dd*K*f*r**2 + 56*D1*Dd*K*f*r*s - 42*D1*Dd*K*f*r + 28*D1*Dd*K*f*s**2 - 42*D1*Dd*K*f*s + 21*D1*Dd*K*f + 672*D1*Dd*K*fd*r**2 + 1344*D1*Dd*K*fd*r*s - 1176*D1*Dd*K*fd*r + 672*D1*Dd*K*fd*s**2 - 1176*D1*Dd*K*fd*s + 504*D1*Dd*K*fd - 288*D1*Dd*f**2*r**2 - 576*D1*Dd*f**2*r*s + 432*D1*Dd*f**2*r - 288*D1*Dd*f**2*s**2 + 432*D1*Dd*f**2*s - 216*D1*Dd*f**2 + 576*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 432*D1*Dd*f*fd*r + 576*D1*Dd*f*fd*s**2 - 432*D1*Dd*f*fd*s - 364*D1*Dd*f*r**2 - 728*D1*Dd*f*r*s + 546*D1*Dd*f*r - 364*D1*Dd*f*s**2 + 546*D1*Dd*f*s - 273*D1*Dd*f + 224*D1*Dd*fd*r**2 + 448*D1*Dd*fd*r*s + 280*D1*Dd*fd*r + 224*D1*Dd*fd*s**2 + 280*D1*Dd*fd*s - 336*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 + 336*D1*Ddd*K*f*r**2 + 672*D1*Ddd*K*f*r*s - 504*D1*Ddd*K*f*r + 336*D1*Ddd*K*f*s**2 - 504*D1*Ddd*K*f*s + 252*D1*Ddd*K*f + 144*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 216*D1*Ddd*f**2*r + 144*D1*Ddd*f**2*s**2 - 216*D1*Ddd*f**2*s + 108*D1*Ddd*f**2 + 112*D1*Ddd*f*r**2 + 224*D1*Ddd*f*r*s - 168*D1*Ddd*f*r + 112*D1*Ddd*f*s**2 - 168*D1*Ddd*f*s + 84*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 - 70*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 1008*Dd**2*K*f*r**2 + 2016*Dd**2*K*f*r*s - 1512*Dd**2*K*f*r + 1008*Dd**2*K*f*s**2 - 1512*Dd**2*K*f*s + 504*Dd**2*K*f + 432*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 648*Dd**2*f**2*r + 432*Dd**2*f**2*s**2 - 648*Dd**2*f**2*s + 216*Dd**2*f**2 + 336*Dd**2*f*r**2 + 672*Dd**2*f*r*s - 504*Dd**2*f*r + 336*Dd**2*f*s**2 - 504*Dd**2*f*s + 168*Dd**2*f - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) + b1*(70*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(18*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + 7*f*(C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*K*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*r**2 + 8*r*(s - 2) + 4*s**2 - 16*s + 8) - 35*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*D1**2*(9*f**2*fd*(9*r**2 + 2*r*(9*s - 7) + 9*s**2 - 14*s + 7) - f*(fd*(74*C*(r + s - 1)**2 - 45*K*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 36*r**2 - 72*r*s + 88*r - 36*s**2 + 88*s - 44) - 18*fdd*(4*C*(r + s - 1)**2 - 3*K*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - r**2 - 2*r*s + 4*r - s**2 + 4*s - 2) + (7*gd2 + 84*gdd2)*(r + s - 1)**2) + (r + s - 1)*(-18*fd**2*(-4*C*(r + s - 1) + 6*K*r + 6*K*s + r + s - 3) - 7*fd*(g2 + 24*gd2)*(r + s - 1) - 84*fdd*g2*(r + s - 1))) + D1*bd1*(D1*(-6*f**2*(24*r**2 + r*(48*s - 58) + 24*s**2 - 58*s + 29) + f*(-28*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 144*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 182*r**2 - 364*r*s + 378*r - 182*s**2 + 378*s - 189) + 28*fd*(r + s - 1)*(C*(2*r + 2*s - 1) + 6*K*(2*r + 2*s - 1) + 4*r + 4*s + 4) + 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(4*r + 4*s - 3)*(18*f**2*(2*r + 2*s - 3) + 7*f*(C*(2*r + 2*s - 1) + 6*K*(2*r + 2*s - 1) + 4*r + 4*s - 8) - 35*g2*(2*r + 2*s - 1))) + 2*D1*(Dd*(27*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(37*C - 45*K - 18)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-36*fd*(4*r + 4*s - 3)*(-4*C*(r + s - 1) + K*(6*r + 6*s - 3) + r + s - 2) - 7*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 168*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - 168*fd*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*Ddd*f*(3*f*(4*C - 6*K - 1) - 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 36*Dd**2*f*(3*f*(4*C - 6*K - 1) - 28*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**2*(D1*(-14*D1*bd1**2*(r + s - 1)*(3*K*f*(5*r + 5*s - 6) + f*(18 - 24*C)*(r + s) + 40*g2*(r + s)) + 7*b2*(bd1*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) - 3*f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + bd1*(-252*D1*bd2*f*(r + s - 1)**2 + D1*(3*f**2*(2*C*(22*r**2 + r*(44*s - 50) + 22*s**2 - 50*s + 25) - 7*K*(r + s - 1)**2 - 8*r**2 - 16*r*s + 22*r - 8*s**2 + 22*s - 11) - 2*f*(fd*(60*C - 30)*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) + 7*g2*(10*r**2 + 20*r*s - 22*r + 10*s**2 - 22*s + 11) - 42*gd2*(5*r**2 + 10*r*s - 11*r + 5*s**2 - 11*s + 6)) + 420*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 6*Dd*f*(f*(10*C - 5) - 14*g2)*(20*r**2 + r*(40*s - 39) + 20*s**2 - 39*s + 18)) - 3*f*(30*C*D1*f*fd*r**2 + 60*C*D1*f*fd*r*s - 40*C*D1*f*fd*r + 30*C*D1*f*fd*s**2 - 40*C*D1*f*fd*s + 20*C*D1*f*fd + 40*C*Dd*f**2*r**2 + 80*C*Dd*f**2*r*s - 60*C*Dd*f**2*r + 40*C*Dd*f**2*s**2 - 60*C*Dd*f**2*s + 30*C*Dd*f**2 + 7*D1*bd2*f*(r + s - 1)**2 + D1*bdd1*(f*(10*C - 5) - 14*g2)*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) - 15*D1*f*fd*r**2 - 30*D1*f*fd*r*s + 20*D1*f*fd*r - 15*D1*f*fd*s**2 + 20*D1*f*fd*s - 10*D1*f*fd - 14*D1*f*gd2*r**2 - 28*D1*f*gd2*r*s + 28*D1*f*gd2*r - 14*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 14*D1*f*gd2 - 28*D1*fd*g2*r**2 - 56*D1*fd*g2*r*s + 28*D1*fd*g2*r - 28*D1*fd*g2*s**2 + 28*D1*fd*g2*s - 14*D1*fd*g2 - 20*Dd*f**2*r**2 - 40*Dd*f**2*r*s + 30*Dd*f**2*r - 20*Dd*f**2*s**2 + 30*Dd*f**2*s - 15*Dd*f**2 - 56*Dd*f*g2*r**2 - 112*Dd*f*g2*r*s + 84*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 84*Dd*f*g2*s - 42*Dd*f*g2)) + 7*b1**3*(D1**2*(8*fd - 9*fdd)*(r + s - 1)**2 + D1*(Dd*(8*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (35*K - 25)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-20*K + 9*f + 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-20*K + 9*f + 10)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(2*C*D1**2*fd*r**2 + 4*C*D1**2*fd*r*s - 4*C*D1**2*fd*r + 2*C*D1**2*fd*s**2 - 4*C*D1**2*fd*s + 2*C*D1**2*fd + 24*C*D1**2*fdd*r**2 + 48*C*D1**2*fdd*r*s - 48*C*D1**2*fdd*r + 24*C*D1**2*fdd*s**2 - 48*C*D1**2*fdd*s + 24*C*D1**2*fdd + 8*C*D1*Dd*f*r**2 + 16*C*D1*Dd*f*r*s - 12*C*D1*Dd*f*r + 8*C*D1*Dd*f*s**2 - 12*C*D1*Dd*f*s + 6*C*D1*Dd*f + 192*C*D1*Dd*fd*r**2 + 384*C*D1*Dd*fd*r*s - 336*C*D1*Dd*fd*r + 192*C*D1*Dd*fd*s**2 - 336*C*D1*Dd*fd*s + 144*C*D1*Dd*fd + 96*C*D1*Ddd*f*r**2 + 192*C*D1*Ddd*f*r*s - 144*C*D1*Ddd*f*r + 96*C*D1*Ddd*f*s**2 - 144*C*D1*Ddd*f*s + 72*C*D1*Ddd*f + 288*C*Dd**2*f*r**2 + 576*C*Dd**2*f*r*s - 432*C*Dd**2*f*r + 288*C*Dd**2*f*s**2 - 432*C*Dd**2*f*s + 144*C*Dd**2*f + 10*D1**2*K*fd*r**2 + 20*D1**2*K*fd*r*s + 2*D1**2*K*fd*r + 10*D1**2*K*fd*s**2 + 2*D1**2*K*fd*s - D1**2*K*fd - 15*D1**2*K*fdd*r**2 - 30*D1**2*K*fdd*r*s - 6*D1**2*K*fdd*r - 15*D1**2*K*fdd*s**2 - 6*D1**2*K*fdd*s + 3*D1**2*K*fdd - D1**2*bdd1*(-20*K + 9*f + 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 12*D1**2*f*fd*r**2 + 24*D1**2*f*fd*r*s - 12*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s + 6*D1**2*f*fd + 6*D1**2*fd*r**2 + 12*D1**2*fd*r*s + 8*D1**2*fd*r + 6*D1**2*fd*s**2 + 8*D1**2*fd*s - 4*D1**2*fd - 18*D1**2*fdd*r**2 - 36*D1**2*fdd*r*s + 36*D1**2*fdd*r - 18*D1**2*fdd*s**2 + 36*D1**2*fdd*s - 18*D1**2*fdd - 70*D1**2*gd2*r**2 - 140*D1**2*gd2*r*s + 140*D1**2*gd2*r - 70*D1**2*gd2*s**2 + 140*D1**2*gd2*s - 70*D1**2*gd2 - 40*D1**2*gdd2*r**2 - 80*D1**2*gdd2*r*s + 80*D1**2*gdd2*r - 40*D1**2*gdd2*s**2 + 80*D1**2*gdd2*s - 40*D1**2*gdd2 + 40*D1*Dd*K*f*r**2 + 80*D1*Dd*K*f*r*s - 60*D1*Dd*K*f*r + 40*D1*Dd*K*f*s**2 - 60*D1*Dd*K*f*s + 30*D1*Dd*K*f - 120*D1*Dd*K*fd*r**2 - 240*D1*Dd*K*fd*r*s + 66*D1*Dd*K*fd*r - 120*D1*Dd*K*fd*s**2 + 66*D1*Dd*K*fd*s + 18*D1*Dd*K*fd + 24*D1*Dd*f**2*r**2 + 48*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 36*D1*Dd*f**2*s + 18*D1*Dd*f**2 + 24*D1*Dd*f*r**2 + 48*D1*Dd*f*r*s - 36*D1*Dd*f*r + 24*D1*Dd*f*s**2 - 36*D1*Dd*f*s + 18*D1*Dd*f - 144*D1*Dd*fd*r**2 - 288*D1*Dd*fd*r*s + 252*D1*Dd*fd*r - 144*D1*Dd*fd*s**2 + 252*D1*Dd*fd*s - 108*D1*Dd*fd - 280*D1*Dd*g2*r**2 - 560*D1*Dd*g2*r*s + 420*D1*Dd*g2*r - 280*D1*Dd*g2*s**2 + 420*D1*Dd*g2*s - 210*D1*Dd*g2 - 320*D1*Dd*gd2*r**2 - 640*D1*Dd*gd2*r*s + 560*D1*Dd*gd2*r - 320*D1*Dd*gd2*s**2 + 560*D1*Dd*gd2*s - 240*D1*Dd*gd2 - 60*D1*Ddd*K*f*r**2 - 120*D1*Ddd*K*f*r*s + 90*D1*Ddd*K*f*r - 60*D1*Ddd*K*f*s**2 + 90*D1*Ddd*K*f*s - 45*D1*Ddd*K*f - 72*D1*Ddd*f*r**2 - 144*D1*Ddd*f*r*s + 108*D1*Ddd*f*r - 72*D1*Ddd*f*s**2 + 108*D1*Ddd*f*s - 54*D1*Ddd*f - 160*D1*Ddd*g2*r**2 - 320*D1*Ddd*g2*r*s + 240*D1*Ddd*g2*r - 160*D1*Ddd*g2*s**2 + 240*D1*Ddd*g2*s - 120*D1*Ddd*g2 + D1*bd1*(D1*(8*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (35*K - 25)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-20*K + 9*f + 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 180*Dd**2*K*f*r**2 - 360*Dd**2*K*f*r*s + 270*Dd**2*K*f*r - 180*Dd**2*K*f*s**2 + 270*Dd**2*K*f*s - 90*Dd**2*K*f - 216*Dd**2*f*r**2 - 432*Dd**2*f*r*s + 324*Dd**2*f*r - 216*Dd**2*f*s**2 + 324*Dd**2*f*s - 108*Dd**2*f - 480*Dd**2*g2*r**2 - 960*Dd**2*g2*r*s + 720*Dd**2*g2*r - 480*Dd**2*g2*s**2 + 720*Dd**2*g2*s - 240*Dd**2*g2) - b1*(-336*C*D1**2*bdd1*f*r**2 - 672*C*D1**2*bdd1*f*r*s + 336*C*D1**2*bdd1*f*r - 336*C*D1**2*bdd1*f*s**2 + 336*C*D1**2*bdd1*f*s - 168*C*D1**2*bdd1*f - 264*C*D1**2*f*fd*r**2 - 528*C*D1**2*f*fd*r*s + 228*C*D1**2*f*fd*r - 264*C*D1**2*f*fd*s**2 + 228*C*D1**2*f*fd*s - 114*C*D1**2*f*fd + 300*C*D1**2*f*fdd*r**2 + 600*C*D1**2*f*fdd*r*s - 240*C*D1**2*f*fdd*r + 300*C*D1**2*f*fdd*s**2 - 240*C*D1**2*f*fdd*s + 120*C*D1**2*f*fdd + 300*C*D1**2*fd**2*r**2 + 600*C*D1**2*fd**2*r*s - 240*C*D1**2*fd**2*r + 300*C*D1**2*fd**2*s**2 - 240*C*D1**2*fd**2*s - 60*C*D1**2*fd**2 - 528*C*D1*Dd*f**2*r**2 - 1056*C*D1*Dd*f**2*r*s + 792*C*D1*Dd*f**2*r - 528*C*D1*Dd*f**2*s**2 + 792*C*D1*Dd*f**2*s - 396*C*D1*Dd*f**2 + 2400*C*D1*Dd*f*fd*r**2 + 4800*C*D1*Dd*f*fd*r*s - 2760*C*D1*Dd*f*fd*r + 2400*C*D1*Dd*f*fd*s**2 - 2760*C*D1*Dd*f*fd*s + 720*C*D1*Dd*f*fd + 600*C*D1*Ddd*f**2*r**2 + 1200*C*D1*Ddd*f**2*r*s - 900*C*D1*Ddd*f**2*r + 600*C*D1*Ddd*f**2*s**2 - 900*C*D1*Ddd*f**2*s + 450*C*D1*Ddd*f**2 + 1800*C*Dd**2*f**2*r**2 + 3600*C*Dd**2*f**2*r*s - 2700*C*Dd**2*f**2*r + 1800*C*Dd**2*f**2*s**2 - 2700*C*Dd**2*f**2*s + 900*C*Dd**2*f**2 + 210*D1**2*K*bdd1*f*r**2 + 420*D1**2*K*bdd1*f*r*s - 462*D1**2*K*bdd1*f*r + 210*D1**2*K*bdd1*f*s**2 - 462*D1**2*K*bdd1*f*s + 231*D1**2*K*bdd1*f + 42*D1**2*K*f*fd*r**2 + 84*D1**2*K*f*fd*r*s - 42*D1**2*K*f*fd*r + 42*D1**2*K*f*fd*s**2 - 42*D1**2*K*f*fd*s + 21*D1**2*K*f*fd - 77*D1**2*b2*fd*r**2 - 154*D1**2*b2*fd*r*s - 77*D1**2*b2*fd*s**2 + 126*D1**2*b2*fdd*r**2 + 252*D1**2*b2*fdd*r*s + 126*D1**2*b2*fdd*s**2 + 14*D1**2*bd1**2*(-20*K + 9*f + 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 252*D1**2*bdd1*f*r**2 + 504*D1**2*bdd1*f*r*s - 252*D1**2*bdd1*f*r + 252*D1**2*bdd1*f*s**2 - 252*D1**2*bdd1*f*s + 126*D1**2*bdd1*f + 560*D1**2*bdd1*g2*r**2 + 1120*D1**2*bdd1*g2*r*s - 560*D1**2*bdd1*g2*r + 560*D1**2*bdd1*g2*s**2 - 560*D1**2*bdd1*g2*s + 280*D1**2*bdd1*g2 + 126*D1**2*bdd2*f*r**2 + 252*D1**2*bdd2*f*r*s - 252*D1**2*bdd2*f*r + 126*D1**2*bdd2*f*s**2 - 252*D1**2*bdd2*f*s + 126*D1**2*bdd2*f + 48*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s - 30*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 30*D1**2*f*fd*s + 15*D1**2*f*fd - 150*D1**2*f*fdd*r**2 - 300*D1**2*f*fdd*r*s + 120*D1**2*f*fdd*r - 150*D1**2*f*fdd*s**2 + 120*D1**2*f*fdd*s - 60*D1**2*f*fdd + 140*D1**2*f*gd2*r**2 + 280*D1**2*f*gd2*r*s - 280*D1**2*f*gd2*r + 140*D1**2*f*gd2*s**2 - 280*D1**2*f*gd2*s + 140*D1**2*f*gd2 - 210*D1**2*f*gdd2*r**2 - 420*D1**2*f*gdd2*r*s + 420*D1**2*f*gdd2*r - 210*D1**2*f*gdd2*s**2 + 420*D1**2*f*gdd2*s - 210*D1**2*f*gdd2 - 150*D1**2*fd**2*r**2 - 300*D1**2*fd**2*r*s + 120*D1**2*fd**2*r - 150*D1**2*fd**2*s**2 + 120*D1**2*fd**2*s + 30*D1**2*fd**2 + 140*D1**2*fd*g2*r**2 + 280*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*r + 140*D1**2*fd*g2*s**2 + 28*D1**2*fd*g2*s - 14*D1**2*fd*g2 - 420*D1**2*fd*gd2*r**2 - 840*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r - 420*D1**2*fd*gd2*s**2 + 336*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 - 210*D1**2*fdd*g2*r**2 - 420*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r - 210*D1**2*fdd*g2*s**2 - 84*D1**2*fdd*g2*s + 42*D1**2*fdd*g2 + 84*D1*Dd*K*f**2*r**2 + 168*D1*Dd*K*f**2*r*s - 126*D1*Dd*K*f**2*r + 84*D1*Dd*K*f**2*s**2 - 126*D1*Dd*K*f**2*s + 63*D1*Dd*K*f**2 - 308*D1*Dd*b2*f*r**2 - 616*D1*Dd*b2*f*r*s + 462*D1*Dd*b2*f*r - 308*D1*Dd*b2*f*s**2 + 462*D1*Dd*b2*f*s - 231*D1*Dd*b2*f + 1008*D1*Dd*b2*fd*r**2 + 2016*D1*Dd*b2*fd*r*s - 756*D1*Dd*b2*fd*r + 1008*D1*Dd*b2*fd*s**2 - 756*D1*Dd*b2*fd*s + 96*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s - 144*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 144*D1*Dd*f**2*s + 72*D1*Dd*f**2 - 1200*D1*Dd*f*fd*r**2 - 2400*D1*Dd*f*fd*r*s + 1380*D1*Dd*f*fd*r - 1200*D1*Dd*f*fd*s**2 + 1380*D1*Dd*f*fd*s - 360*D1*Dd*f*fd + 560*D1*Dd*f*g2*r**2 + 1120*D1*Dd*f*g2*r*s - 840*D1*Dd*f*g2*r + 560*D1*Dd*f*g2*s**2 - 840*D1*Dd*f*g2*s + 420*D1*Dd*f*g2 - 1680*D1*Dd*f*gd2*r**2 - 3360*D1*Dd*f*gd2*r*s + 2940*D1*Dd*f*gd2*r - 1680*D1*Dd*f*gd2*s**2 + 2940*D1*Dd*f*gd2*s - 1260*D1*Dd*f*gd2 - 1680*D1*Dd*fd*g2*r**2 - 3360*D1*Dd*fd*g2*r*s + 924*D1*Dd*fd*g2*r - 1680*D1*Dd*fd*g2*s**2 + 924*D1*Dd*fd*g2*s + 252*D1*Dd*fd*g2 + 504*D1*Ddd*b2*f*r**2 + 1008*D1*Ddd*b2*f*r*s - 756*D1*Ddd*b2*f*r + 504*D1*Ddd*b2*f*s**2 - 756*D1*Ddd*b2*f*s + 378*D1*Ddd*b2*f - 300*D1*Ddd*f**2*r**2 - 600*D1*Ddd*f**2*r*s + 450*D1*Ddd*f**2*r - 300*D1*Ddd*f**2*s**2 + 450*D1*Ddd*f**2*s - 225*D1*Ddd*f**2 - 840*D1*Ddd*f*g2*r**2 - 1680*D1*Ddd*f*g2*r*s + 1260*D1*Ddd*f*g2*r - 840*D1*Ddd*f*g2*s**2 + 1260*D1*Ddd*f*g2*s - 630*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(12*f**2*(r + s - 1)**2 + f*(C*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) + K*(20*r**2 + 40*r*s - 42*r + 20*s**2 - 42*s + 21) + 12*r**2 + 24*r*s - 32*r + 12*s**2 - 32*s + 16) - 6*fd*(r + s - 1)*(-8*C*(2*r + 2*s - 1) + 10*K*r + 10*K*s + K + 12*r + 12*s - 6) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 80*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(3*f*(8*C*(2*r + 2*s - 1) - 10*K*r - 10*K*s + 11*K - 12*r - 12*s + 6) - 40*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 7*D1*bd2*(r + s - 1)*(11*D1*f*(r + s - 1) - 36*D1*fd*(r + s) - 36*Dd*f*(4*r + 4*s - 3)) + 1512*Dd**2*b2*f*r**2 + 3024*Dd**2*b2*f*r*s - 2268*Dd**2*b2*f*r + 1512*Dd**2*b2*f*s**2 - 2268*Dd**2*b2*f*s + 756*Dd**2*b2*f - 900*Dd**2*f**2*r**2 - 1800*Dd**2*f**2*r*s + 1350*Dd**2*f**2*r - 900*Dd**2*f**2*s**2 + 1350*Dd**2*f**2*s - 450*Dd**2*f**2 - 2520*Dd**2*f*g2*r**2 - 5040*Dd**2*f*g2*r*s + 3780*Dd**2*f*g2*r - 2520*Dd**2*f*g2*s**2 + 3780*Dd**2*f*g2*s - 1260*Dd**2*f*g2))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k1**2*st**2*(D1*f*(r + s)*(6*D1*bd1**2*(6*f + 7)*(r + s - 1) + 9*D1*bdd1*f*(r + s) + bd1*(-11*D1*f*(r + s) + 36*D1*fd*(r + s - 1) + 18*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(36*fd**2 - fd*(30*f + 7) + fdd*(36*f + 21))*(r + s - 1)**2 + D1*(Dd*(-15*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(72*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 28*r**2 - 56*r*s + 42*r - 28*s**2 + 42*s - 21) + 42*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*Ddd*f*(6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f*(6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(3*D1**2*bdd1*f*(6*f + 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 22*D1**2*f*fd*r**2 - 44*D1**2*f*fd*r*s + 44*D1**2*f*fd*r - 22*D1**2*f*fd*s**2 + 44*D1**2*f*fd*s - 22*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 36*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 18*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 36*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s + 18*D1**2*fd**2 - 44*D1*Dd*f**2*r**2 - 88*D1*Dd*f**2*r*s + 66*D1*Dd*f**2*r - 44*D1*Dd*f**2*s**2 + 66*D1*Dd*f**2*s - 33*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 288*D1*Dd*f*fd*r*s - 252*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 252*D1*Dd*f*fd*s + 108*D1*Dd*f*fd + 36*D1*Ddd*f**2*r**2 + 72*D1*Ddd*f**2*r*s - 54*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 54*D1*Ddd*f**2*s + 27*D1*Ddd*f**2 + D1*bd1*(D1*(-15*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(72*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 14*r**2 - 28*r*s + 14*r - 14*s**2 + 14*s - 7) + 42*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*Dd*f*(6*f + 7)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 108*Dd**2*f**2*r**2 + 216*Dd**2*f**2*r*s - 162*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 162*Dd**2*f**2*s + 54*Dd**2*f**2))/(105*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**2*k1**2*(-D1*(r + s)*(42*D1*bd1**2*f*(K - 2)*(r + s - 1) + 3*D1*bdd1*f*(r + s)*(7*b2 + f*(10*C - 5) - 14*g2) + bd1*(-18*C*D1*f**2*r - 18*C*D1*f**2*s + 120*C*D1*f*fd*r + 120*C*D1*f*fd*s - 120*C*D1*f*fd + 240*C*Dd*f**2*r + 240*C*Dd*f**2*s - 180*C*Dd*f**2 + 42*D1*bd2*f*(r + s - 1) + 9*D1*f**2*r + 9*D1*f**2*s - 60*D1*f*fd*r - 60*D1*f*fd*s + 60*D1*f*fd + 14*D1*f*g2*r + 14*D1*f*g2*s - 84*D1*f*gd2*r - 84*D1*f*gd2*s + 84*D1*f*gd2 - 84*D1*fd*g2*r - 84*D1*fd*g2*s + 84*D1*fd*g2 - 120*Dd*f**2*r - 120*Dd*f**2*s + 90*Dd*f**2 - 336*Dd*f*g2*r - 336*Dd*f*g2*s + 252*Dd*f*g2 + 7*b2*(-D1*f*(r + s) + 6*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3)))) - 14*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 20*r**2 - 40*r*s + 30*r - 20*s**2 + 30*s - 15) - Ddd*(3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 7*b1**2*(-2*D1**2*bdd1*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*D1*bd1*(D1*(f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 15*r**2 - 30*r*s + 20*r - 15*s**2 + 20*s - 10) - 2*Dd*(3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - (K - 2)*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + b1*(36*C*D1**2*f*fd*r**2 + 72*C*D1**2*f*fd*r*s - 72*C*D1**2*f*fd*r + 36*C*D1**2*f*fd*s**2 - 72*C*D1**2*f*fd*s + 36*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r**2 - 120*C*D1**2*f*fdd*r*s + 120*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 120*C*D1**2*f*fdd*s - 60*C*D1**2*f*fdd - 60*C*D1**2*fd**2*r**2 - 120*C*D1**2*fd**2*r*s + 120*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 120*C*D1**2*fd**2*s - 60*C*D1**2*fd**2 + 72*C*D1*Dd*f**2*r**2 + 144*C*D1*Dd*f**2*r*s - 108*C*D1*Dd*f**2*r + 72*C*D1*Dd*f**2*s**2 - 108*C*D1*Dd*f**2*s + 54*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r**2 - 960*C*D1*Dd*f*fd*r*s + 840*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 840*C*D1*Dd*f*fd*s - 360*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r**2 - 240*C*D1*Ddd*f**2*r*s + 180*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 180*C*D1*Ddd*f**2*s - 90*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r**2 - 720*C*Dd**2*f**2*r*s + 540*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 540*C*Dd**2*f**2*s - 180*C*Dd**2*f**2 - 42*D1**2*K*bdd1*f*r**2 - 84*D1**2*K*bdd1*f*r*s + 42*D1**2*K*bdd1*f*r - 42*D1**2*K*bdd1*f*s**2 + 42*D1**2*K*bdd1*f*s - 21*D1**2*K*bdd1*f + 7*D1**2*b2*fd*r**2 + 14*D1**2*b2*fd*r*s - 14*D1**2*b2*fd*r + 7*D1**2*b2*fd*s**2 - 14*D1**2*b2*fd*s + 7*D1**2*b2*fd - 21*D1**2*b2*fdd*r**2 - 42*D1**2*b2*fdd*r*s + 42*D1**2*b2*fdd*r - 21*D1**2*b2*fdd*s**2 + 42*D1**2*b2*fdd*s - 21*D1**2*b2*fdd + 28*D1**2*bd1**2*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 84*D1**2*bdd1*f*r**2 + 168*D1**2*bdd1*f*r*s - 84*D1**2*bdd1*f*r + 84*D1**2*bdd1*f*s**2 - 84*D1**2*bdd1*f*s + 42*D1**2*bdd1*f - 21*D1**2*bdd2*f*r**2 - 42*D1**2*bdd2*f*r*s + 42*D1**2*bdd2*f*r - 21*D1**2*bdd2*f*s**2 + 42*D1**2*bdd2*f*s - 21*D1**2*bdd2*f - 18*D1**2*f*fd*r**2 - 36*D1**2*f*fd*r*s + 36*D1**2*f*fd*r - 18*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 18*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s + 30*D1**2*f*fdd - 14*D1**2*f*gd2*r**2 - 28*D1**2*f*gd2*r*s + 28*D1**2*f*gd2*r - 14*D1**2*f*gd2*s**2 + 28*D1**2*f*gd2*s - 14*D1**2*f*gd2 + 42*D1**2*f*gdd2*r**2 + 84*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*r + 42*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 42*D1**2*f*gdd2 + 30*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 60*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s + 30*D1**2*fd**2 - 14*D1**2*fd*g2*r**2 - 28*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*r - 14*D1**2*fd*g2*s**2 + 28*D1**2*fd*g2*s - 14*D1**2*fd*g2 + 84*D1**2*fd*gd2*r**2 + 168*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*r + 84*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 + 42*D1**2*fdd*g2*r**2 + 84*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r + 42*D1**2*fdd*g2*s**2 - 84*D1**2*fdd*g2*s + 42*D1**2*fdd*g2 + 28*D1*Dd*b2*f*r**2 + 56*D1*Dd*b2*f*r*s - 42*D1*Dd*b2*f*r + 28*D1*Dd*b2*f*s**2 - 42*D1*Dd*b2*f*s + 21*D1*Dd*b2*f - 168*D1*Dd*b2*fd*r**2 - 336*D1*Dd*b2*fd*r*s + 294*D1*Dd*b2*fd*r - 168*D1*Dd*b2*fd*s**2 + 294*D1*Dd*b2*fd*s - 126*D1*Dd*b2*fd - 36*D1*Dd*f**2*r**2 - 72*D1*Dd*f**2*r*s + 54*D1*Dd*f**2*r - 36*D1*Dd*f**2*s**2 + 54*D1*Dd*f**2*s - 27*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 420*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 420*D1*Dd*f*fd*s + 180*D1*Dd*f*fd - 56*D1*Dd*f*g2*r**2 - 112*D1*Dd*f*g2*r*s + 84*D1*Dd*f*g2*r - 56*D1*Dd*f*g2*s**2 + 84*D1*Dd*f*g2*s - 42*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r**2 + 672*D1*Dd*f*gd2*r*s - 588*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s**2 - 588*D1*Dd*f*gd2*s + 252*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r**2 + 672*D1*Dd*fd*g2*r*s - 588*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s**2 - 588*D1*Dd*fd*g2*s + 252*D1*Dd*fd*g2 - 84*D1*Ddd*b2*f*r**2 - 168*D1*Ddd*b2*f*r*s + 126*D1*Ddd*b2*f*r - 84*D1*Ddd*b2*f*s**2 + 126*D1*Ddd*b2*f*s - 63*D1*Ddd*b2*f + 60*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 90*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 90*D1*Ddd*f**2*s + 45*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r*s - 252*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s**2 - 252*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 + 7*D1*bd1*(K - 2)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 7*D1*bd2*(D1*(f - 6*fd)*(r + s - 1) - 6*Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 252*Dd**2*b2*f*r**2 - 504*Dd**2*b2*f*r*s + 378*Dd**2*b2*f*r - 252*Dd**2*b2*f*s**2 + 378*Dd**2*b2*f*s - 126*Dd**2*b2*f + 180*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 270*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 270*Dd**2*f**2*s + 90*Dd**2*f**2 + 504*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r*s - 756*Dd**2*f*g2*r + 504*Dd**2*f*g2*s**2 - 756*Dd**2*f*g2*s + 252*Dd**2*f*g2))/(210*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**2*k2**6*st**4*(D1**2*(f**2*(-fd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(3*K*(-2*bd1 + bdd1) + 12*gd2 - 6*gdd2)) + f*(fd**2*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 6*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 6*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(-2*Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(3*K*(b1*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - fd*(2*C - 1)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 6*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + Ddd*f*(3*K*b1 + f*(2*C - 1) - 6*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f**2*(3*K*b1 + f*(2*C - 1) - 6*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(14*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**2*k2**6*st**2*(24*C*D1**2*b1*f*fd*r**2 + 48*C*D1**2*b1*f*fd*r*s - 24*C*D1**2*b1*f*fd*r + 24*C*D1**2*b1*f*fd*s**2 - 24*C*D1**2*b1*f*fd*s + 12*C*D1**2*b1*f*fd - 12*C*D1**2*b1*f*fdd*r**2 - 24*C*D1**2*b1*f*fdd*r*s + 12*C*D1**2*b1*f*fdd*r - 12*C*D1**2*b1*f*fdd*s**2 + 12*C*D1**2*b1*f*fdd*s - 6*C*D1**2*b1*f*fdd - 12*C*D1**2*b1*fd**2*r**2 - 24*C*D1**2*b1*fd**2*r*s + 12*C*D1**2*b1*fd**2*r - 12*C*D1**2*b1*fd**2*s**2 + 12*C*D1**2*b1*fd**2*s - 18*C*D1**2*f**2*fd*r**2 - 36*C*D1**2*f**2*fd*r*s + 24*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 12*C*D1**2*f**2*fd + 48*C*D1*Dd*b1*f**2*r**2 + 96*C*D1*Dd*b1*f**2*r*s - 72*C*D1*Dd*b1*f**2*r + 48*C*D1*Dd*b1*f**2*s**2 - 72*C*D1*Dd*b1*f**2*s + 36*C*D1*Dd*b1*f**2 - 96*C*D1*Dd*b1*f*fd*r**2 - 192*C*D1*Dd*b1*f*fd*r*s + 120*C*D1*Dd*b1*f*fd*r - 96*C*D1*Dd*b1*f*fd*s**2 + 120*C*D1*Dd*b1*f*fd*s - 36*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r**2 - 48*C*D1*Dd*f**3*r*s + 36*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 36*C*D1*Dd*f**3*s - 18*C*D1*Dd*f**3 - 24*C*D1*Ddd*b1*f**2*r**2 - 48*C*D1*Ddd*b1*f**2*r*s + 36*C*D1*Ddd*b1*f**2*r - 24*C*D1*Ddd*b1*f**2*s**2 + 36*C*D1*Ddd*b1*f**2*s - 18*C*D1*Ddd*b1*f**2 - 72*C*Dd**2*b1*f**2*r**2 - 144*C*Dd**2*b1*f**2*r*s + 108*C*Dd**2*b1*f**2*r - 72*C*Dd**2*b1*f**2*s**2 + 108*C*Dd**2*b1*f**2*s - 36*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r**2 + 28*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r**2 - 14*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 14*D1**2*K*bd1**2*f*(r + s - 1)**2 - 12*D1**2*b1*f*fd*r**2 - 24*D1**2*b1*f*fd*r*s + 12*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s**2 + 12*D1**2*b1*f*fd*s - 6*D1**2*b1*f*fd + 6*D1**2*b1*f*fdd*r**2 + 12*D1**2*b1*f*fdd*r*s - 6*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 - 6*D1**2*b1*f*fdd*s + 3*D1**2*b1*f*fdd - 28*D1**2*b1*f*gd2*r**2 - 56*D1**2*b1*f*gd2*r*s + 56*D1**2*b1*f*gd2*r - 28*D1**2*b1*f*gd2*s**2 + 56*D1**2*b1*f*gd2*s - 28*D1**2*b1*f*gd2 + 14*D1**2*b1*f*gdd2*r**2 + 28*D1**2*b1*f*gdd2*r*s - 28*D1**2*b1*f*gdd2*r + 14*D1**2*b1*f*gdd2*s**2 - 28*D1**2*b1*f*gdd2*s + 14*D1**2*b1*f*gdd2 + 6*D1**2*b1*fd**2*r**2 + 12*D1**2*b1*fd**2*r*s - 6*D1**2*b1*fd**2*r + 6*D1**2*b1*fd**2*s**2 - 6*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r**2 - 56*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r**2 + 56*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*r + 28*D1**2*b1*fd*gd2*s**2 - 28*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r**2 + 28*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(6*C*f + 14*K*b1 - 3*f - 14*g2) + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r**2 + 112*D1*Dd*K*b1**2*f*r*s - 84*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 84*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r**2 - 112*D1*Dd*K*b1**2*fd*r*s + 42*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 42*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 - 24*D1*Dd*b1*f**2*r**2 - 48*D1*Dd*b1*f**2*r*s + 36*D1*Dd*b1*f**2*r - 24*D1*Dd*b1*f**2*s**2 + 36*D1*Dd*b1*f**2*s - 18*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r**2 + 96*D1*Dd*b1*f*fd*r*s - 60*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 60*D1*Dd*b1*f*fd*s + 18*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r**2 - 224*D1*Dd*b1*f*g2*r*s + 168*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 168*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r**2 + 224*D1*Dd*b1*f*gd2*r*s - 196*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 196*D1*Dd*b1*f*gd2*s + 84*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r**2 + 224*D1*Dd*b1*fd*g2*r*s - 84*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 84*D1*Dd*b1*fd*g2*s + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r**2 - 56*D1*Ddd*K*b1**2*f*r*s + 42*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 42*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 12*D1*Ddd*b1*f**2*r**2 + 24*D1*Ddd*b1*f**2*r*s - 18*D1*Ddd*b1*f**2*r + 12*D1*Ddd*b1*f**2*s**2 - 18*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r**2 + 112*D1*Ddd*b1*f*g2*r*s - 84*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 84*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(12*C - 7*K - 6)*(r + s - 1) - f*fd*(12*C - 6)*(2*r + 2*s - 1) - 28*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(6*C*f + 14*K*b1 - 3*f - 14*g2))*(r + s - 1) - 84*Dd**2*K*b1**2*f*r**2 - 168*Dd**2*K*b1**2*f*r*s + 126*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 126*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 36*Dd**2*b1*f**2*r**2 + 72*Dd**2*b1*f**2*r*s - 54*Dd**2*b1*f**2*r + 36*Dd**2*b1*f**2*s**2 - 54*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r**2 + 336*Dd**2*b1*f*g2*r*s - 252*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 252*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(35*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k2**4*st**4*(12*C*D1**2*f**2*fd*r**2 + 24*C*D1**2*f**2*fd*r*s - 16*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 16*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r**2 - 12*C*D1**2*f**2*fdd*r*s + 8*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 8*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r**2 - 24*C*D1**2*f*fd**2*r*s + 16*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 16*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r**2 + 32*C*D1*Dd*f**3*r*s - 24*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 12*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r**2 - 96*C*D1*Dd*f**2*fd*r*s + 68*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 68*C*D1*Dd*f**2*fd*s - 24*C*D1*Dd*f**2*fd - 8*C*D1*Ddd*f**3*r**2 - 16*C*D1*Ddd*f**3*r*s + 12*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 12*C*D1*Ddd*f**3*s - 6*C*D1*Ddd*f**3 - 24*C*Dd**2*f**3*r**2 - 48*C*Dd**2*f**3*r*s + 36*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 36*C*Dd**2*f**3*s - 12*C*Dd**2*f**3 + 12*D1**2*K*b1*f*fd*r**2 + 24*D1**2*K*b1*f*fd*r*s - 12*D1**2*K*b1*f*fd*r + 12*D1**2*K*b1*f*fd*s**2 - 12*D1**2*K*b1*f*fd*s + 6*D1**2*K*b1*f*fd - 6*D1**2*K*b1*f*fdd*r**2 - 12*D1**2*K*b1*f*fdd*r*s + 6*D1**2*K*b1*f*fdd*r - 6*D1**2*K*b1*f*fdd*s**2 + 6*D1**2*K*b1*f*fdd*s - 3*D1**2*K*b1*f*fdd - 6*D1**2*K*b1*fd**2*r**2 - 12*D1**2*K*b1*fd**2*r*s + 6*D1**2*K*b1*fd**2*r - 6*D1**2*K*b1*fd**2*s**2 + 6*D1**2*K*b1*fd**2*s + 6*D1**2*K*bd1*f**2*r**2 + 12*D1**2*K*bd1*f**2*r*s - 12*D1**2*K*bd1*f**2*r + 6*D1**2*K*bd1*f**2*s**2 - 12*D1**2*K*bd1*f**2*s + 6*D1**2*K*bd1*f**2 - 12*D1**2*K*bd1*f*fd*r**2 - 24*D1**2*K*bd1*f*fd*r*s + 18*D1**2*K*bd1*f*fd*r - 12*D1**2*K*bd1*f*fd*s**2 + 18*D1**2*K*bd1*f*fd*s - 6*D1**2*K*bd1*f*fd - 3*D1**2*K*bdd1*f**2*r**2 - 6*D1**2*K*bdd1*f**2*r*s + 6*D1**2*K*bdd1*f**2*r - 3*D1**2*K*bdd1*f**2*s**2 + 6*D1**2*K*bdd1*f**2*s - 3*D1**2*K*bdd1*f**2 + 12*D1**2*b2*f*fd*r**2 + 24*D1**2*b2*f*fd*r*s - 12*D1**2*b2*f*fd*r + 12*D1**2*b2*f*fd*s**2 - 12*D1**2*b2*f*fd*s + 6*D1**2*b2*f*fd - 6*D1**2*b2*f*fdd*r**2 - 12*D1**2*b2*f*fdd*r*s + 6*D1**2*b2*f*fdd*r - 6*D1**2*b2*f*fdd*s**2 + 6*D1**2*b2*f*fdd*s - 3*D1**2*b2*f*fdd - 6*D1**2*b2*fd**2*r**2 - 12*D1**2*b2*fd**2*r*s + 6*D1**2*b2*fd**2*r - 6*D1**2*b2*fd**2*s**2 + 6*D1**2*b2*fd**2*s - 3*D1**2*bdd2*f**2*(r + s - 1)**2 - 6*D1**2*f**2*fd*r**2 - 12*D1**2*f**2*fd*r*s + 8*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 8*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 6*D1**2*f**2*fdd*r*s - 4*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 4*D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd - 12*D1**2*f**2*gd2*r**2 - 24*D1**2*f**2*gd2*r*s + 24*D1**2*f**2*gd2*r - 12*D1**2*f**2*gd2*s**2 + 24*D1**2*f**2*gd2*s - 12*D1**2*f**2*gd2 + 6*D1**2*f**2*gdd2*r**2 + 12*D1**2*f**2*gdd2*r*s - 12*D1**2*f**2*gdd2*r + 6*D1**2*f**2*gdd2*s**2 - 12*D1**2*f**2*gdd2*s + 6*D1**2*f**2*gdd2 + 6*D1**2*f*fd**2*r**2 + 12*D1**2*f*fd**2*r*s - 8*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 8*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 - 24*D1**2*f*fd*g2*r**2 - 48*D1**2*f*fd*g2*r*s + 24*D1**2*f*fd*g2*r - 24*D1**2*f*fd*g2*s**2 + 24*D1**2*f*fd*g2*s - 12*D1**2*f*fd*g2 + 24*D1**2*f*fd*gd2*r**2 + 48*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 24*D1**2*f*fd*gd2*s**2 - 36*D1**2*f*fd*gd2*s + 12*D1**2*f*fd*gd2 + 12*D1**2*f*fdd*g2*r**2 + 24*D1**2*f*fdd*g2*r*s - 12*D1**2*f*fdd*g2*r + 12*D1**2*f*fdd*g2*s**2 - 12*D1**2*f*fdd*g2*s + 6*D1**2*f*fdd*g2 + 12*D1**2*fd**2*g2*r**2 + 24*D1**2*fd**2*g2*r*s - 12*D1**2*fd**2*g2*r + 12*D1**2*fd**2*g2*s**2 - 12*D1**2*fd**2*g2*s + 24*D1*Dd*K*b1*f**2*r**2 + 48*D1*Dd*K*b1*f**2*r*s - 36*D1*Dd*K*b1*f**2*r + 24*D1*Dd*K*b1*f**2*s**2 - 36*D1*Dd*K*b1*f**2*s + 18*D1*Dd*K*b1*f**2 - 48*D1*Dd*K*b1*f*fd*r**2 - 96*D1*Dd*K*b1*f*fd*r*s + 60*D1*Dd*K*b1*f*fd*r - 48*D1*Dd*K*b1*f*fd*s**2 + 60*D1*Dd*K*b1*f*fd*s - 18*D1*Dd*K*b1*f*fd - 24*D1*Dd*K*bd1*f**2*r**2 - 48*D1*Dd*K*bd1*f**2*r*s + 42*D1*Dd*K*bd1*f**2*r - 24*D1*Dd*K*bd1*f**2*s**2 + 42*D1*Dd*K*bd1*f**2*s - 18*D1*Dd*K*bd1*f**2 + 24*D1*Dd*b2*f**2*r**2 + 48*D1*Dd*b2*f**2*r*s - 36*D1*Dd*b2*f**2*r + 24*D1*Dd*b2*f**2*s**2 - 36*D1*Dd*b2*f**2*s + 18*D1*Dd*b2*f**2 - 48*D1*Dd*b2*f*fd*r**2 - 96*D1*Dd*b2*f*fd*r*s + 60*D1*Dd*b2*f*fd*r - 48*D1*Dd*b2*f*fd*s**2 + 60*D1*Dd*b2*f*fd*s - 18*D1*Dd*b2*f*fd - 8*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 48*D1*Dd*f**2*fd*r*s - 34*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 34*D1*Dd*f**2*fd*s + 12*D1*Dd*f**2*fd - 48*D1*Dd*f**2*g2*r**2 - 96*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 48*D1*Dd*f**2*g2*s**2 + 72*D1*Dd*f**2*g2*s - 36*D1*Dd*f**2*g2 + 48*D1*Dd*f**2*gd2*r**2 + 96*D1*Dd*f**2*gd2*r*s - 84*D1*Dd*f**2*gd2*r + 48*D1*Dd*f**2*gd2*s**2 - 84*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 96*D1*Dd*f*fd*g2*r**2 + 192*D1*Dd*f*fd*g2*r*s - 120*D1*Dd*f*fd*g2*r + 96*D1*Dd*f*fd*g2*s**2 - 120*D1*Dd*f*fd*g2*s + 36*D1*Dd*f*fd*g2 - 12*D1*Ddd*K*b1*f**2*r**2 - 24*D1*Ddd*K*b1*f**2*r*s + 18*D1*Ddd*K*b1*f**2*r - 12*D1*Ddd*K*b1*f**2*s**2 + 18*D1*Ddd*K*b1*f**2*s - 9*D1*Ddd*K*b1*f**2 - 12*D1*Ddd*b2*f**2*r**2 - 24*D1*Ddd*b2*f**2*r*s + 18*D1*Ddd*b2*f**2*r - 12*D1*Ddd*b2*f**2*s**2 + 18*D1*Ddd*b2*f**2*s - 9*D1*Ddd*b2*f**2 + 4*D1*Ddd*f**3*r**2 + 8*D1*Ddd*f**3*r*s - 6*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 6*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 24*D1*Ddd*f**2*g2*r**2 + 48*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 24*D1*Ddd*f**2*g2*s**2 - 36*D1*Ddd*f**2*g2*s + 18*D1*Ddd*f**2*g2 + 6*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 36*Dd**2*K*b1*f**2*r**2 - 72*Dd**2*K*b1*f**2*r*s + 54*Dd**2*K*b1*f**2*r - 36*Dd**2*K*b1*f**2*s**2 + 54*Dd**2*K*b1*f**2*s - 18*Dd**2*K*b1*f**2 - 36*Dd**2*b2*f**2*r**2 - 72*Dd**2*b2*f**2*r*s + 54*Dd**2*b2*f**2*r - 36*Dd**2*b2*f**2*s**2 + 54*Dd**2*b2*f**2*s - 18*Dd**2*b2*f**2 + 12*Dd**2*f**3*r**2 + 24*Dd**2*f**3*r*s - 18*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 18*Dd**2*f**3*s + 6*Dd**2*f**3 + 72*Dd**2*f**2*g2*r**2 + 144*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 72*Dd**2*f**2*g2*s**2 - 108*Dd**2*f**2*g2*s + 36*Dd**2*f**2*g2)/(14*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k2**4*st**2*(D1*(7*K*b1**2*(D1*(2*fd - fdd)*(2*r + 2*s - 1) - 2*Dd*fd*(4*r + 4*s - 3)) + b1*(24*C*D1*f*fd*r + 24*C*D1*f*fd*s - 12*C*D1*f*fd - 12*C*D1*f*fdd*r - 12*C*D1*f*fdd*s + 6*C*D1*f*fdd - 12*C*D1*fd**2*r - 12*C*D1*fd**2*s + 12*C*D1*fd**2 - 48*C*Dd*f*fd*r - 48*C*Dd*f*fd*s + 36*C*Dd*f*fd - 28*D1*K*bd1*f*r - 28*D1*K*bd1*f*s + 14*D1*K*bd1*f - 14*D1*K*bd1*fd*r - 14*D1*K*bd1*fd*s + 14*D1*K*bd1*fd + 14*D1*K*bdd1*f*r + 14*D1*K*bdd1*f*s - 7*D1*K*bdd1*f - 14*D1*K*f*fd*r**2 - 28*D1*K*f*fd*r*s + 14*D1*K*f*fd*r - 14*D1*K*f*fd*s**2 + 14*D1*K*f*fd*s - 7*D1*K*f*fd - 7*D1*bdd2*f*(r + s - 1)**2 - 12*D1*f*fd*r - 12*D1*f*fd*s + 6*D1*f*fd + 6*D1*f*fdd*r + 6*D1*f*fdd*s - 3*D1*f*fdd + 6*D1*fd**2*r + 6*D1*fd**2*s - 6*D1*fd**2 - 56*D1*fd*g2*r - 56*D1*fd*g2*s + 28*D1*fd*g2 + 28*D1*fd*gd2*r + 28*D1*fd*gd2*s - 28*D1*fd*gd2 + 28*D1*fdd*g2*r + 28*D1*fdd*g2*s - 14*D1*fdd*g2 + 56*Dd*K*bd1*f*r + 56*Dd*K*bd1*f*s - 42*Dd*K*bd1*f - 28*Dd*K*f**2*r**2 - 56*Dd*K*f**2*r*s + 42*Dd*K*f**2*r - 28*Dd*K*f**2*s**2 + 42*Dd*K*f**2*s - 21*Dd*K*f**2 + 24*Dd*f*fd*r + 24*Dd*f*fd*s - 18*Dd*f*fd + 112*Dd*fd*g2*r + 112*Dd*fd*g2*s - 84*Dd*fd*g2 + 14*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3))) + f*(12*C*D1*bdd1*f*r + 12*C*D1*bdd1*f*s - 6*C*D1*bdd1*f - 18*C*D1*f*fd*r**2 - 36*C*D1*f*fd*r*s + 24*C*D1*f*fd*r - 18*C*D1*f*fd*s**2 + 24*C*D1*f*fd*s - 12*C*D1*f*fd - 24*C*Dd*f**2*r**2 - 48*C*Dd*f**2*r*s + 36*C*Dd*f**2*r - 24*C*Dd*f**2*s**2 + 36*C*Dd*f**2*s - 18*C*Dd*f**2 + 14*D1*K*bd1**2*(r + s - 1) - 7*D1*bd2*f*r**2 - 14*D1*bd2*f*r*s + 14*D1*bd2*f*r - 7*D1*bd2*f*s**2 + 14*D1*bd2*f*s - 7*D1*bd2*f - 6*D1*bdd1*f*r - 6*D1*bdd1*f*s + 3*D1*bdd1*f - 28*D1*bdd1*g2*r - 28*D1*bdd1*g2*s + 14*D1*bdd1*g2 + 9*D1*f*fd*r**2 + 18*D1*f*fd*r*s - 12*D1*f*fd*r + 9*D1*f*fd*s**2 - 12*D1*f*fd*s + 6*D1*f*fd + 14*D1*f*gd2*r**2 + 28*D1*f*gd2*r*s - 28*D1*f*gd2*r + 14*D1*f*gd2*s**2 - 28*D1*f*gd2*s + 14*D1*f*gd2 + 28*D1*fd*g2*r**2 + 56*D1*fd*g2*r*s - 28*D1*fd*g2*r + 28*D1*fd*g2*s**2 - 28*D1*fd*g2*s + 14*D1*fd*g2 + 12*Dd*f**2*r**2 + 24*Dd*f**2*r*s - 18*Dd*f**2*r + 12*Dd*f**2*s**2 - 18*Dd*f**2*s + 9*Dd*f**2 + 56*Dd*f*g2*r**2 + 112*Dd*f*g2*r*s - 84*Dd*f*g2*r + 56*Dd*f*g2*s**2 - 84*Dd*f*g2*s + 42*Dd*f*g2 - bd1*(14*D1*bd2*(r + s - 1)**2 + D1*(f*(12*C*(2*r + 2*s - 1) + 7*K*(r + s - 1)**2 - 12*r - 12*s + 6) + fd*(6 - 12*C)*(r + s - 1) - 28*g2*(2*r + 2*s - 1) + 28*gd2*(r + s - 1)) - 2*Dd*(f*(6*C - 3) - 14*g2)*(4*r + 4*s - 3)))) + 7*b2*(2*D1**2*b1*fd*r**2 + 4*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r**2 - 2*D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r**2 + 16*D1*Dd*b1*f*r*s - 12*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 12*D1*Dd*b1*f*s + 6*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r**2 - 16*D1*Dd*b1*fd*r*s + 6*D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 6*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 4*D1*Ddd*b1*f*r**2 - 8*D1*Ddd*b1*f*r*s + 6*D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 6*D1*Ddd*b1*f*s - 3*D1*Ddd*b1*f + 2*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*b1*f*r**2 - 24*Dd**2*b1*f*r*s + 18*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 18*Dd**2*b1*f*s - 6*Dd**2*b1*f))/(35*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**2*k2**4*(D1**2*bd1*(5*b2*f*(r + s - 1)**2 - (2*bd1*(r**2 + r*(2*s - 1) + s*(s - 1)) + f*(2*r + 2*s - 1))*(f*(6*C - 3) - 10*g2)) + D1*b1*(-12*C*D1*bdd1*f*r**2 - 24*C*D1*bdd1*f*r*s + 12*C*D1*bdd1*f*r - 12*C*D1*bdd1*f*s**2 + 12*C*D1*bdd1*f*s - 6*C*D1*bdd1*f + 12*C*D1*f*fd*r + 12*C*D1*f*fd*s - 6*C*D1*f*fd - 10*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 5*D1*b2*fd*r**2 + 10*D1*b2*fd*r*s + 5*D1*b2*fd*s**2 + 5*D1*bd2*f*(r + s - 1)**2 + 6*D1*bdd1*f*r**2 + 12*D1*bdd1*f*r*s - 6*D1*bdd1*f*r + 6*D1*bdd1*f*s**2 - 6*D1*bdd1*f*s + 3*D1*bdd1*f + 20*D1*bdd1*g2*r**2 + 40*D1*bdd1*g2*r*s - 20*D1*bdd1*g2*r + 20*D1*bdd1*g2*s**2 - 20*D1*bdd1*g2*s + 10*D1*bdd1*g2 - 6*D1*f*fd*r - 6*D1*f*fd*s + 3*D1*f*fd - 20*D1*fd*g2*r - 20*D1*fd*g2*s + 10*D1*fd*g2 + 20*Dd*b2*f*r**2 + 40*Dd*b2*f*r*s - 30*Dd*b2*f*r + 20*Dd*b2*f*s**2 - 30*Dd*b2*f*s + 15*Dd*b2*f + bd1*(D1*(f*(12*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*K*(2*r + 2*s - 1) - 12*r**2 - 24*r*s + 12*r - 12*s**2 + 12*s - 6) + fd*(6 - 12*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 20*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(6*C - 3) - 10*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 5*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(5*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(12*C*(r + s - 1)**2 + 5*K*(2*r + 2*s - 1) - 6*(r + s - 1)**2) + fdd*(3 - 6*C)*(r + s - 1)**2 - 20*gd2*(r + s - 1)**2 + 10*gdd2*(r + s - 1)**2) + D1*(2*Dd*(f*(6*C - 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(6*C - 3)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 10*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(20*r + 20*s - 15)) - Ddd*(f*(6*C - 3) - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(f*(6*C - 3) - 10*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(30*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k2**2*st**2*(-D1*(r + s)*(14*D1*K*bd1**2*f*(r + s - 1) + D1*bdd1*f*(r + s)*(7*b2 + f*(6*C - 3) - 14*g2) + 2*bd1*(-6*C*D1*f**2*r - 6*C*D1*f**2*s + 12*C*D1*f*fd*r + 12*C*D1*f*fd*s - 12*C*D1*f*fd + 24*C*Dd*f**2*r + 24*C*Dd*f**2*s - 18*C*Dd*f**2 + 7*D1*bd2*f*(r + s - 1) + 3*D1*f**2*r + 3*D1*f**2*s - 6*D1*f*fd*r - 6*D1*f*fd*s + 6*D1*f*fd + 14*D1*f*g2*r + 14*D1*f*g2*s - 14*D1*f*gd2*r - 14*D1*f*gd2*s + 14*D1*f*gd2 - 14*D1*fd*g2*r - 14*D1*fd*g2*s + 14*D1*fd*g2 - 12*Dd*f**2*r - 12*Dd*f**2*s + 9*Dd*f**2 - 56*Dd*f*g2*r - 56*Dd*f*g2*s + 42*Dd*f*g2 + 7*b2*(-D1*f*(r + s) + D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))) + 7*K*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(24*C*D1**2*f*fd*r**2 + 48*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*r + 24*C*D1**2*f*fd*s**2 - 48*C*D1**2*f*fd*s + 24*C*D1**2*f*fd - 12*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s**2 + 24*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 12*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s**2 + 24*C*D1**2*fd**2*s - 12*C*D1**2*fd**2 + 48*C*D1*Dd*f**2*r**2 + 96*C*D1*Dd*f**2*r*s - 72*C*D1*Dd*f**2*r + 48*C*D1*Dd*f**2*s**2 - 72*C*D1*Dd*f**2*s + 36*C*D1*Dd*f**2 - 96*C*D1*Dd*f*fd*r**2 - 192*C*D1*Dd*f*fd*r*s + 168*C*D1*Dd*f*fd*r - 96*C*D1*Dd*f*fd*s**2 + 168*C*D1*Dd*f*fd*s - 72*C*D1*Dd*f*fd - 24*C*D1*Ddd*f**2*r**2 - 48*C*D1*Ddd*f**2*r*s + 36*C*D1*Ddd*f**2*r - 24*C*D1*Ddd*f**2*s**2 + 36*C*D1*Ddd*f**2*s - 18*C*D1*Ddd*f**2 - 72*C*Dd**2*f**2*r**2 - 144*C*Dd**2*f**2*r*s + 108*C*Dd**2*f**2*r - 72*C*Dd**2*f**2*s**2 + 108*C*Dd**2*f**2*s - 36*C*Dd**2*f**2 + 28*D1**2*K*bd1*f*r**2 + 56*D1**2*K*bd1*f*r*s - 28*D1**2*K*bd1*f*r + 28*D1**2*K*bd1*f*s**2 - 28*D1**2*K*bd1*f*s + 14*D1**2*K*bd1*f - 28*D1**2*K*bd1*fd*r**2 - 56*D1**2*K*bd1*fd*r*s + 42*D1**2*K*bd1*fd*r - 28*D1**2*K*bd1*fd*s**2 + 42*D1**2*K*bd1*fd*s - 14*D1**2*K*bd1*fd - 14*D1**2*K*bdd1*f*r**2 - 28*D1**2*K*bdd1*f*r*s + 14*D1**2*K*bdd1*f*r - 14*D1**2*K*bdd1*f*s**2 + 14*D1**2*K*bdd1*f*s - 7*D1**2*K*bdd1*f + 14*D1**2*b2*fd*r**2 + 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*r + 14*D1**2*b2*fd*s**2 - 28*D1**2*b2*fd*s + 14*D1**2*b2*fd - 7*D1**2*b2*fdd*r**2 - 14*D1**2*b2*fdd*r*s + 14*D1**2*b2*fdd*r - 7*D1**2*b2*fdd*s**2 + 14*D1**2*b2*fdd*s - 7*D1**2*b2*fdd - 7*D1**2*bdd2*f*(r + s - 1)**2 - 12*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 24*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 12*D1**2*f*fdd*s + 6*D1**2*f*fdd - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 14*D1**2*f*gdd2*r**2 + 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 + 6*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 12*D1**2*fd**2*s + 6*D1**2*fd**2 - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 28*D1**2*fd*gd2*r**2 + 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 56*D1**2*fd*gd2*s + 28*D1**2*fd*gd2 + 14*D1**2*fdd*g2*r**2 + 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 112*D1*Dd*K*bd1*f*r**2 - 224*D1*Dd*K*bd1*f*r*s + 140*D1*Dd*K*bd1*f*r - 112*D1*Dd*K*bd1*f*s**2 + 140*D1*Dd*K*bd1*f*s - 42*D1*Dd*K*bd1*f + 56*D1*Dd*b2*f*r**2 + 112*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 56*D1*Dd*b2*f*s**2 - 84*D1*Dd*b2*f*s + 42*D1*Dd*b2*f - 56*D1*Dd*b2*fd*r**2 - 112*D1*Dd*b2*fd*r*s + 98*D1*Dd*b2*fd*r - 56*D1*Dd*b2*fd*s**2 + 98*D1*Dd*b2*fd*s - 42*D1*Dd*b2*fd - 24*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 + 36*D1*Dd*f**2*s - 18*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 84*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 84*D1*Dd*f*fd*s + 36*D1*Dd*f*fd - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 + 224*D1*Dd*f*gd2*r*s - 196*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 196*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r**2 + 224*D1*Dd*fd*g2*r*s - 196*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 196*D1*Dd*fd*g2*s + 84*D1*Dd*fd*g2 - 28*D1*Ddd*b2*f*r**2 - 56*D1*Ddd*b2*f*r*s + 42*D1*Ddd*b2*f*r - 28*D1*Ddd*b2*f*s**2 + 42*D1*Ddd*b2*f*s - 21*D1*Ddd*b2*f + 12*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 + 112*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 84*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 14*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 84*Dd**2*b2*f*r**2 - 168*Dd**2*b2*f*r*s + 126*Dd**2*b2*f*r - 84*Dd**2*b2*f*s**2 + 126*Dd**2*b2*f*s - 42*Dd**2*b2*f + 36*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 18*Dd**2*f**2 + 168*Dd**2*f*g2*r**2 + 336*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 252*Dd**2*f*g2*s + 84*Dd**2*f*g2))/(35*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**2*k2**2*(-D1**2*bd1*(r + s)*(2*bd1*(r + s - 1) + f*(r + s))*(5*b2 + f*(6*C - 3) - 10*g2) + D1*b1*(-12*C*D1*bdd1*f*r**2 - 24*C*D1*bdd1*f*r*s + 12*C*D1*bdd1*f*r - 12*C*D1*bdd1*f*s**2 + 12*C*D1*bdd1*f*s - 6*C*D1*bdd1*f - 12*C*D1*f*fd*r**2 - 24*C*D1*f*fd*r*s + 24*C*D1*f*fd*r - 12*C*D1*f*fd*s**2 + 24*C*D1*f*fd*s - 12*C*D1*f*fd - 24*C*Dd*f**2*r**2 - 48*C*Dd*f**2*r*s + 36*C*Dd*f**2*r - 24*C*Dd*f**2*s**2 + 36*C*Dd*f**2*s - 18*C*Dd*f**2 - 10*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 5*D1*bd2*f*r**2 - 10*D1*bd2*f*r*s + 10*D1*bd2*f*r - 5*D1*bd2*f*s**2 + 10*D1*bd2*f*s - 5*D1*bd2*f + 6*D1*bdd1*f*r**2 + 12*D1*bdd1*f*r*s - 6*D1*bdd1*f*r + 6*D1*bdd1*f*s**2 - 6*D1*bdd1*f*s + 3*D1*bdd1*f + 20*D1*bdd1*g2*r**2 + 40*D1*bdd1*g2*r*s - 20*D1*bdd1*g2*r + 20*D1*bdd1*g2*s**2 - 20*D1*bdd1*g2*s + 10*D1*bdd1*g2 + 6*D1*f*fd*r**2 + 12*D1*f*fd*r*s - 12*D1*f*fd*r + 6*D1*f*fd*s**2 - 12*D1*f*fd*s + 6*D1*f*fd + 10*D1*f*gd2*r**2 + 20*D1*f*gd2*r*s - 20*D1*f*gd2*r + 10*D1*f*gd2*s**2 - 20*D1*f*gd2*s + 10*D1*f*gd2 + 10*D1*fd*g2*r**2 + 20*D1*fd*g2*r*s - 20*D1*fd*g2*r + 10*D1*fd*g2*s**2 - 20*D1*fd*g2*s + 10*D1*fd*g2 + 12*Dd*f**2*r**2 + 24*Dd*f**2*r*s - 18*Dd*f**2*r + 12*Dd*f**2*s**2 - 18*Dd*f**2*s + 9*Dd*f**2 + 40*Dd*f*g2*r**2 + 80*Dd*f*g2*r*s - 60*Dd*f*g2*r + 40*Dd*f*g2*s**2 - 60*Dd*f*g2*s + 30*Dd*f*g2 + 5*b2*(2*D1*bd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - D1*fd*r**2 - 2*D1*fd*r*s + 2*D1*fd*r - D1*fd*s**2 + 2*D1*fd*s - D1*fd - 2*Dd*bd1*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 4*Dd*f*r**2 - 8*Dd*f*r*s + 6*Dd*f*r - 4*Dd*f*s**2 + 6*Dd*f*s - 3*Dd*f) - bd1*(10*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-f*(12*C - 5*K - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(12*C - 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 20*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 20*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(f*(6*C - 3) - 10*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 5*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(12*C*D1**2*fd*r**2 + 24*C*D1**2*fd*r*s - 24*C*D1**2*fd*r + 12*C*D1**2*fd*s**2 - 24*C*D1**2*fd*s + 12*C*D1**2*fd - 6*C*D1**2*fdd*r**2 - 12*C*D1**2*fdd*r*s + 12*C*D1**2*fdd*r - 6*C*D1**2*fdd*s**2 + 12*C*D1**2*fdd*s - 6*C*D1**2*fdd + 48*C*D1*Dd*f*r**2 + 96*C*D1*Dd*f*r*s - 72*C*D1*Dd*f*r + 48*C*D1*Dd*f*s**2 - 72*C*D1*Dd*f*s + 36*C*D1*Dd*f - 48*C*D1*Dd*fd*r**2 - 96*C*D1*Dd*fd*r*s + 84*C*D1*Dd*fd*r - 48*C*D1*Dd*fd*s**2 + 84*C*D1*Dd*fd*s - 36*C*D1*Dd*fd - 24*C*D1*Ddd*f*r**2 - 48*C*D1*Ddd*f*r*s + 36*C*D1*Ddd*f*r - 24*C*D1*Ddd*f*s**2 + 36*C*D1*Ddd*f*s - 18*C*D1*Ddd*f - 72*C*Dd**2*f*r**2 - 144*C*Dd**2*f*r*s + 108*C*Dd**2*f*r - 72*C*Dd**2*f*s**2 + 108*C*Dd**2*f*s - 36*C*Dd**2*f + 30*D1**2*K*bd1*r**2 + 60*D1**2*K*bd1*r*s - 40*D1**2*K*bd1*r + 30*D1**2*K*bd1*s**2 - 40*D1**2*K*bd1*s + 20*D1**2*K*bd1 - 15*D1**2*K*bdd1*r**2 - 30*D1**2*K*bdd1*r*s + 20*D1**2*K*bdd1*r - 15*D1**2*K*bdd1*s**2 + 20*D1**2*K*bdd1*s - 10*D1**2*K*bdd1 - 5*D1**2*K*fd*r**2 - 10*D1**2*K*fd*r*s + 10*D1**2*K*fd*r - 5*D1**2*K*fd*s**2 + 10*D1**2*K*fd*s - 5*D1**2*K*fd - 5*D1**2*bdd2*(r + s - 1)**2 - 6*D1**2*fd*r**2 - 12*D1**2*fd*r*s + 12*D1**2*fd*r - 6*D1**2*fd*s**2 + 12*D1**2*fd*s - 6*D1**2*fd + 3*D1**2*fdd*r**2 + 6*D1**2*fdd*r*s - 6*D1**2*fdd*r + 3*D1**2*fdd*s**2 - 6*D1**2*fdd*s + 3*D1**2*fdd - 20*D1**2*gd2*r**2 - 40*D1**2*gd2*r*s + 40*D1**2*gd2*r - 20*D1**2*gd2*s**2 + 40*D1**2*gd2*s - 20*D1**2*gd2 + 10*D1**2*gdd2*r**2 + 20*D1**2*gdd2*r*s - 20*D1**2*gdd2*r + 10*D1**2*gdd2*s**2 - 20*D1**2*gdd2*s + 10*D1**2*gdd2 - 120*D1*Dd*K*bd1*r**2 - 240*D1*Dd*K*bd1*r*s + 170*D1*Dd*K*bd1*r - 120*D1*Dd*K*bd1*s**2 + 170*D1*Dd*K*bd1*s - 60*D1*Dd*K*bd1 - 20*D1*Dd*K*f*r**2 - 40*D1*Dd*K*f*r*s + 30*D1*Dd*K*f*r - 20*D1*Dd*K*f*s**2 + 30*D1*Dd*K*f*s - 15*D1*Dd*K*f + 40*D1*Dd*b2*r**2 + 80*D1*Dd*b2*r*s - 60*D1*Dd*b2*r + 40*D1*Dd*b2*s**2 - 60*D1*Dd*b2*s + 30*D1*Dd*b2 - 24*D1*Dd*f*r**2 - 48*D1*Dd*f*r*s + 36*D1*Dd*f*r - 24*D1*Dd*f*s**2 + 36*D1*Dd*f*s - 18*D1*Dd*f + 24*D1*Dd*fd*r**2 + 48*D1*Dd*fd*r*s - 42*D1*Dd*fd*r + 24*D1*Dd*fd*s**2 - 42*D1*Dd*fd*s + 18*D1*Dd*fd - 80*D1*Dd*g2*r**2 - 160*D1*Dd*g2*r*s + 120*D1*Dd*g2*r - 80*D1*Dd*g2*s**2 + 120*D1*Dd*g2*s - 60*D1*Dd*g2 + 80*D1*Dd*gd2*r**2 + 160*D1*Dd*gd2*r*s - 140*D1*Dd*gd2*r + 80*D1*Dd*gd2*s**2 - 140*D1*Dd*gd2*s + 60*D1*Dd*gd2 - 20*D1*Ddd*b2*r**2 - 40*D1*Ddd*b2*r*s + 30*D1*Ddd*b2*r - 20*D1*Ddd*b2*s**2 + 30*D1*Ddd*b2*s - 15*D1*Ddd*b2 + 12*D1*Ddd*f*r**2 + 24*D1*Ddd*f*r*s - 18*D1*Ddd*f*r + 12*D1*Ddd*f*s**2 - 18*D1*Ddd*f*s + 9*D1*Ddd*f + 40*D1*Ddd*g2*r**2 + 80*D1*Ddd*g2*r*s - 60*D1*Ddd*g2*r + 40*D1*Ddd*g2*s**2 - 60*D1*Ddd*g2*s + 30*D1*Ddd*g2 + 10*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 60*Dd**2*b2*r**2 - 120*Dd**2*b2*r*s + 90*Dd**2*b2*r - 60*Dd**2*b2*s**2 + 90*Dd**2*b2*s - 30*Dd**2*b2 + 36*Dd**2*f*r**2 + 72*Dd**2*f*r*s - 54*Dd**2*f*r + 36*Dd**2*f*s**2 - 54*Dd**2*f*s + 18*Dd**2*f + 120*Dd**2*g2*r**2 + 240*Dd**2*g2*r*s - 180*Dd**2*g2*r + 120*Dd**2*g2*s**2 - 180*Dd**2*g2*s + 60*Dd**2*g2))/(30*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct*f**2*k1**7*st**2*(D1**2*(-f*(3*fd - 7*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 42*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(-3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 14*fd*(4*r + 4*s - 3)**2) + 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(462*d**2*k2*k3**6) + D1**2*Pk2*Pkdd3*ct*f**2*k1**5*k2*st**4*(D1**2*(-f*(269*fd - 250*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 1500*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(-269*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 500*fd*(4*r + 4*s - 3)**2) + 250*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 1500*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(2310*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*f**2*k1**3*k2**3*st**6*(D1**2*(-f*(188*fd - 105*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 630*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(-188*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 210*Dd*fd*(4*r + 4*s - 3)**2 + 105*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 630*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1386*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*f*k1**7*(7*D1**2*bdd1*f**2*(r + s - 1)**2 - D1*bd1*f*(r + s - 1)*(5*D1*f*(r + s - 1) - 14*D1*fd*(3*r + 3*s - 2) - 14*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(-f*(5*fd - 7*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 14*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(-5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 14*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(126*d**2*k2*k3**6) - D1**2*Pk2*Pkdd3*ct*k1**5*k2*st**2*(12*C*D1**2*f**2*fd*r**2 + 24*C*D1**2*f**2*fd*r*s - 16*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 16*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 60*C*D1**2*f**2*fdd*r**2 - 120*C*D1**2*f**2*fdd*r*s + 80*C*D1**2*f**2*fdd*r - 60*C*D1**2*f**2*fdd*s**2 + 80*C*D1**2*f**2*fdd*s - 40*C*D1**2*f**2*fdd - 120*C*D1**2*f*fd**2*r**2 - 240*C*D1**2*f*fd**2*r*s + 160*C*D1**2*f*fd**2*r - 120*C*D1**2*f*fd**2*s**2 + 160*C*D1**2*f*fd**2*s - 40*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r**2 + 32*C*D1*Dd*f**3*r*s - 24*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 12*C*D1*Dd*f**3 - 480*C*D1*Dd*f**2*fd*r**2 - 960*C*D1*Dd*f**2*fd*r*s + 680*C*D1*Dd*f**2*fd*r - 480*C*D1*Dd*f**2*fd*s**2 + 680*C*D1*Dd*f**2*fd*s - 240*C*D1*Dd*f**2*fd - 80*C*D1*Ddd*f**3*r**2 - 160*C*D1*Ddd*f**3*r*s + 120*C*D1*Ddd*f**3*r - 80*C*D1*Ddd*f**3*s**2 + 120*C*D1*Ddd*f**3*s - 60*C*D1*Ddd*f**3 - 240*C*Dd**2*f**3*r**2 - 480*C*Dd**2*f**3*r*s + 360*C*Dd**2*f**3*r - 240*C*Dd**2*f**3*s**2 + 360*C*Dd**2*f**3*s - 120*C*Dd**2*f**3 - 12*D1**2*K*b1*f*fd*r**2 - 24*D1**2*K*b1*f*fd*r*s + 12*D1**2*K*b1*f*fd*r - 12*D1**2*K*b1*f*fd*s**2 + 12*D1**2*K*b1*f*fd*s - 6*D1**2*K*b1*f*fd - 36*D1**2*K*b1*f*fdd*r**2 - 72*D1**2*K*b1*f*fdd*r*s + 36*D1**2*K*b1*f*fdd*r - 36*D1**2*K*b1*f*fdd*s**2 + 36*D1**2*K*b1*f*fdd*s - 18*D1**2*K*b1*f*fdd - 36*D1**2*K*b1*fd**2*r**2 - 72*D1**2*K*b1*fd**2*r*s + 36*D1**2*K*b1*fd**2*r - 36*D1**2*K*b1*fd**2*s**2 + 36*D1**2*K*b1*fd**2*s + 342*D1**2*b1*f**2*fd*r**2 + 684*D1**2*b1*f**2*fd*r*s - 456*D1**2*b1*f**2*fd*r + 342*D1**2*b1*f**2*fd*s**2 - 456*D1**2*b1*f**2*fd*s + 228*D1**2*b1*f**2*fd - 225*D1**2*b1*f**2*fdd*r**2 - 450*D1**2*b1*f**2*fdd*r*s + 300*D1**2*b1*f**2*fdd*r - 225*D1**2*b1*f**2*fdd*s**2 + 300*D1**2*b1*f**2*fdd*s - 150*D1**2*b1*f**2*fdd - 450*D1**2*b1*f*fd**2*r**2 - 900*D1**2*b1*f*fd**2*r*s + 600*D1**2*b1*f*fd**2*r - 450*D1**2*b1*f*fd**2*s**2 + 600*D1**2*b1*f*fd**2*s - 150*D1**2*b1*f*fd**2 + 6*D1**2*b1*f*fd*r**2 + 12*D1**2*b1*f*fd*r*s - 6*D1**2*b1*f*fd*r + 6*D1**2*b1*f*fd*s**2 - 6*D1**2*b1*f*fd*s + 3*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(6*K + 25*f - 3)*(r + s - 1)**2 - 60*D1**2*f**3*fd*r**2 - 120*D1**2*f**3*fd*r*s + 90*D1**2*f**3*fd*r - 60*D1**2*f**3*fd*s**2 + 90*D1**2*f**3*fd*s - 45*D1**2*f**3*fd - 9*D1**2*f**2*fd*r**2 - 18*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 9*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 45*D1**2*f**2*fdd*r**2 + 90*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 60*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 12*D1**2*f**2*gd2*r**2 + 24*D1**2*f**2*gd2*r*s - 24*D1**2*f**2*gd2*r + 12*D1**2*f**2*gd2*s**2 - 24*D1**2*f**2*gd2*s + 12*D1**2*f**2*gd2 + 36*D1**2*f**2*gdd2*r**2 + 72*D1**2*f**2*gdd2*r*s - 72*D1**2*f**2*gdd2*r + 36*D1**2*f**2*gdd2*s**2 - 72*D1**2*f**2*gdd2*s + 36*D1**2*f**2*gdd2 + 90*D1**2*f*fd**2*r**2 + 180*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 120*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 + 24*D1**2*f*fd*g2*r**2 + 48*D1**2*f*fd*g2*r*s - 24*D1**2*f*fd*g2*r + 24*D1**2*f*fd*g2*s**2 - 24*D1**2*f*fd*g2*s + 12*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r**2 + 288*D1**2*f*fd*gd2*r*s - 216*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 216*D1**2*f*fd*gd2*s + 72*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r**2 + 144*D1**2*f*fdd*g2*r*s - 72*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r**2 + 144*D1**2*fd**2*g2*r*s - 72*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 24*D1*Dd*K*b1*f**2*r**2 - 48*D1*Dd*K*b1*f**2*r*s + 36*D1*Dd*K*b1*f**2*r - 24*D1*Dd*K*b1*f**2*s**2 + 36*D1*Dd*K*b1*f**2*s - 18*D1*Dd*K*b1*f**2 - 288*D1*Dd*K*b1*f*fd*r**2 - 576*D1*Dd*K*b1*f*fd*r*s + 360*D1*Dd*K*b1*f*fd*r - 288*D1*Dd*K*b1*f*fd*s**2 + 360*D1*Dd*K*b1*f*fd*s - 108*D1*Dd*K*b1*f*fd + 456*D1*Dd*b1*f**3*r**2 + 912*D1*Dd*b1*f**3*r*s - 684*D1*Dd*b1*f**3*r + 456*D1*Dd*b1*f**3*s**2 - 684*D1*Dd*b1*f**3*s + 342*D1*Dd*b1*f**3 - 1800*D1*Dd*b1*f**2*fd*r**2 - 3600*D1*Dd*b1*f**2*fd*r*s + 2550*D1*Dd*b1*f**2*fd*r - 1800*D1*Dd*b1*f**2*fd*s**2 + 2550*D1*Dd*b1*f**2*fd*s - 900*D1*Dd*b1*f**2*fd + 12*D1*Dd*b1*f**2*r**2 + 24*D1*Dd*b1*f**2*r*s - 18*D1*Dd*b1*f**2*r + 12*D1*Dd*b1*f**2*s**2 - 18*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 60*D1*Dd*f**4*r**2 - 120*D1*Dd*f**4*r*s + 90*D1*Dd*f**4*r - 60*D1*Dd*f**4*s**2 + 90*D1*Dd*f**4*s - 45*D1*Dd*f**4 - 12*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 + 18*D1*Dd*f**3*s - 9*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*r**2 + 720*D1*Dd*f**2*fd*r*s - 510*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 510*D1*Dd*f**2*fd*s + 180*D1*Dd*f**2*fd + 48*D1*Dd*f**2*g2*r**2 + 96*D1*Dd*f**2*g2*r*s - 72*D1*Dd*f**2*g2*r + 48*D1*Dd*f**2*g2*s**2 - 72*D1*Dd*f**2*g2*s + 36*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r**2 + 576*D1*Dd*f**2*gd2*r*s - 504*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 504*D1*Dd*f**2*gd2*s + 216*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r**2 + 1152*D1*Dd*f*fd*g2*r*s - 720*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 720*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 - 72*D1*Ddd*K*b1*f**2*r**2 - 144*D1*Ddd*K*b1*f**2*r*s + 108*D1*Ddd*K*b1*f**2*r - 72*D1*Ddd*K*b1*f**2*s**2 + 108*D1*Ddd*K*b1*f**2*s - 54*D1*Ddd*K*b1*f**2 - 300*D1*Ddd*b1*f**3*r**2 - 600*D1*Ddd*b1*f**3*r*s + 450*D1*Ddd*b1*f**3*r - 300*D1*Ddd*b1*f**3*s**2 + 450*D1*Ddd*b1*f**3*s - 225*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 60*D1*Ddd*f**3*r**2 + 120*D1*Ddd*f**3*r*s - 90*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 90*D1*Ddd*f**3*s + 45*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r**2 + 288*D1*Ddd*f**2*g2*r*s - 216*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 216*D1*Ddd*f**2*g2*s + 108*D1*Ddd*f**2*g2 + 3*D1*bd1*f*(D1*(38*f**2*(r + s - 1) - 50*f*fd*(3*r + 3*s - 2) - f*(2*K - 1)*(r + s - 1) - 6*fd*(2*K - 1)*(2*r + 2*s - 1)) - 2*Dd*f*(6*K + 25*f - 3)*(4*r + 4*s - 3))*(r + s - 1) - 216*Dd**2*K*b1*f**2*r**2 - 432*Dd**2*K*b1*f**2*r*s + 324*Dd**2*K*b1*f**2*r - 216*Dd**2*K*b1*f**2*s**2 + 324*Dd**2*K*b1*f**2*s - 108*Dd**2*K*b1*f**2 - 900*Dd**2*b1*f**3*r**2 - 1800*Dd**2*b1*f**3*r*s + 1350*Dd**2*b1*f**3*r - 900*Dd**2*b1*f**3*s**2 + 1350*Dd**2*b1*f**3*s - 450*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 180*Dd**2*f**3*r**2 + 360*Dd**2*f**3*r*s - 270*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 270*Dd**2*f**3*s + 90*Dd**2*f**3 + 432*Dd**2*f**2*g2*r**2 + 864*Dd**2*f**2*g2*r*s - 648*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 648*Dd**2*f**2*g2*s + 216*Dd**2*f**2*g2)/(630*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*k1**5*k2*(-D1*(r + s - 1)*(6*D1*bd1**2*f*(-14*K + 25*f + 7)*(r + s - 1) - 3*D1*bdd1*f*(f*(20*C - 15) - 28*g2)*(r + s - 1) + bd1*(D1*(-15*f**3*(r + s - 1) + f**2*(36*C - 27)*(r + s - 1) - f*fd*(120*C - 90)*(2*r + 2*s - 1) - 28*f*(g2 - 6*gd2)*(r + s - 1) + 168*fd*g2*(r + s)) - 6*Dd*f*(f*(20*C - 15) - 28*g2)*(4*r + 4*s - 3))) + b1**2*(D1**2*(15*f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(150*fd**2*(r + s - 1) + 7*fd*(2*K - 1)*(r + s) - 21*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(45*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(150*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(-14*K + 25*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(-14*K + 25*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-72*C*D1**2*f*fd*r**2 - 144*C*D1**2*f*fd*r*s + 72*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s - 36*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 144*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 216*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 216*C*D1*Dd*f**2*s - 108*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 1200*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1200*C*D1*Dd*f*fd*s + 360*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 360*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(-14*K + 25*f + 7)*(r + s - 1)**2 + 45*D1**2*f**2*fd*r**2 + 90*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s**2 - 60*D1**2*f**2*fd*s + 30*D1**2*f**2*fd + 54*D1**2*f*fd*r**2 + 108*D1**2*f*fd*r*s - 54*D1**2*f*fd*r + 54*D1**2*f*fd*s**2 - 54*D1**2*f*fd*s + 27*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 45*D1**2*f*fdd + 28*D1**2*f*gd2*r**2 + 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r + 28*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s + 28*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 28*D1**2*fd*g2*r**2 + 56*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 + 60*D1*Dd*f**3*r**2 + 120*D1*Dd*f**3*r*s - 90*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 90*D1*Dd*f**3*s + 45*D1*Dd*f**3 + 108*D1*Dd*f**2*r**2 + 216*D1*Dd*f**2*r*s - 162*D1*Dd*f**2*r + 108*D1*Dd*f**2*s**2 - 162*D1*Dd*f**2*s + 81*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 900*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 270*D1*Dd*f*fd + 112*D1*Dd*f*g2*r**2 + 224*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 112*D1*Dd*f*g2*s**2 - 168*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s - 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(45*f**2*(r + s - 1) - 150*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 42*fd*(2*K - 1)*(r + s)) - 6*Dd*f*(-14*K + 25*f + 7)*(4*r + 4*s - 3))*(r + s - 1) - 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 270*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(210*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*k1**5*st**2*(-18*D1**2*b1*f**2*fd*r**2 - 36*D1**2*b1*f**2*fd*r*s + 30*D1**2*b1*f**2*fd*r - 18*D1**2*b1*f**2*fd*s**2 + 30*D1**2*b1*f**2*fd*s - 15*D1**2*b1*f**2*fd + 90*D1**2*b1*f**2*fdd*r**2 + 180*D1**2*b1*f**2*fdd*r*s - 150*D1**2*b1*f**2*fdd*r + 90*D1**2*b1*f**2*fdd*s**2 - 150*D1**2*b1*f**2*fdd*s + 75*D1**2*b1*f**2*fdd + 180*D1**2*b1*f*fd**2*r**2 + 360*D1**2*b1*f*fd**2*r*s - 300*D1**2*b1*f*fd**2*r + 180*D1**2*b1*f*fd**2*s**2 - 300*D1**2*b1*f*fd**2*s + 120*D1**2*b1*f*fd**2 + 6*D1**2*b1*f*fd*r**2 + 12*D1**2*b1*f*fd*r*s - 6*D1**2*b1*f*fd*r + 6*D1**2*b1*f*fd*s**2 - 6*D1**2*b1*f*fd*s + 3*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + 3*D1**2*bdd1*f**2*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 3*(r + s - 1)**2) - 3*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s**2 + 4*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 30*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 10*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 10*D1**2*f*fd**2 - 24*D1*Dd*b1*f**3*r**2 - 48*D1*Dd*b1*f**3*r*s + 36*D1*Dd*b1*f**3*r - 24*D1*Dd*b1*f**3*s**2 + 36*D1*Dd*b1*f**3*s - 18*D1*Dd*b1*f**3 + 720*D1*Dd*b1*f**2*fd*r**2 + 1440*D1*Dd*b1*f**2*fd*r*s - 1140*D1*Dd*b1*f**2*fd*r + 720*D1*Dd*b1*f**2*fd*s**2 - 1140*D1*Dd*b1*f**2*fd*s + 450*D1*Dd*b1*f**2*fd + 12*D1*Dd*b1*f**2*r**2 + 24*D1*Dd*b1*f**2*r*s - 18*D1*Dd*b1*f**2*r + 12*D1*Dd*b1*f**2*s**2 - 18*D1*Dd*b1*f**2*s + 9*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 4*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 6*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 240*D1*Dd*f**2*fd*r*s - 170*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 170*D1*Dd*f**2*fd*s + 60*D1*Dd*f**2*fd + 120*D1*Ddd*b1*f**3*r**2 + 240*D1*Ddd*b1*f**3*r*s - 180*D1*Ddd*b1*f**3*r + 120*D1*Ddd*b1*f**3*s**2 - 180*D1*Ddd*b1*f**3*s + 90*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 40*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 - 3*D1*bd1*f*(D1*(f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - f*(r + s - 1)*(20*fd*(3*r + 3*s - 1) + r + s - 1) - 6*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*f*(4*r + 4*s - 3)*(5*f*(2*r + 2*s - 1) + 3*r + 3*s - 3)) + 360*Dd**2*b1*f**3*r**2 + 720*Dd**2*b1*f**3*r*s - 540*Dd**2*b1*f**3*r + 360*Dd**2*b1*f**3*s**2 - 540*Dd**2*b1*f**3*s + 180*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 120*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 30*Dd**2*f**3)/(630*d**2*k2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1**5*(3*D1*f*(r + s - 1)*(2*D1*bd1**2*(5*f*(2*r + 2*s - 1) + 7*r + 7*s - 7) + 5*D1*bdd1*f*(r + s - 1) + bd1*(-3*D1*f*(r + s - 1) + 10*D1*fd*(2*r + 2*s - 1) + 10*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(-3*f*(3*fd - 5*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 30*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 7*fd*(r + s)**2 + 21*fdd*(r + s)**2) + D1*(Dd*(-18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(30*fd*(4*r + 4*s - 3)**2 - 28*r**2 - 56*r*s + 42*r - 28*s**2 + 42*s - 21) + 42*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 3*Ddd*f*(10*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f*(10*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(3*D1**2*bdd1*f*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 14*(r + s - 1)**2) + 3*D1**2*(-f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bd1*(D1*(-9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*f*(r + s - 1)*(60*fd*(2*r + 2*s - 1) - 7*r - 7*s + 7) + 84*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) + 6*Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 14*r + 14*s - 14)) + 3*D1*f*(Dd*(-3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1**3*k2**3*st**4*(-108*C*D1**2*f**2*fd*r**2 - 216*C*D1**2*f**2*fd*r*s + 144*C*D1**2*f**2*fd*r - 108*C*D1**2*f**2*fd*s**2 + 144*C*D1**2*f**2*fd*s - 72*C*D1**2*f**2*fd + 72*C*D1**2*f**2*fdd*r**2 + 144*C*D1**2*f**2*fdd*r*s - 96*C*D1**2*f**2*fdd*r + 72*C*D1**2*f**2*fdd*s**2 - 96*C*D1**2*f**2*fdd*s + 48*C*D1**2*f**2*fdd + 144*C*D1**2*f*fd**2*r**2 + 288*C*D1**2*f*fd**2*r*s - 192*C*D1**2*f*fd**2*r + 144*C*D1**2*f*fd**2*s**2 - 192*C*D1**2*f*fd**2*s + 48*C*D1**2*f*fd**2 - 144*C*D1*Dd*f**3*r**2 - 288*C*D1*Dd*f**3*r*s + 216*C*D1*Dd*f**3*r - 144*C*D1*Dd*f**3*s**2 + 216*C*D1*Dd*f**3*s - 108*C*D1*Dd*f**3 + 576*C*D1*Dd*f**2*fd*r**2 + 1152*C*D1*Dd*f**2*fd*r*s - 816*C*D1*Dd*f**2*fd*r + 576*C*D1*Dd*f**2*fd*s**2 - 816*C*D1*Dd*f**2*fd*s + 288*C*D1*Dd*f**2*fd + 96*C*D1*Ddd*f**3*r**2 + 192*C*D1*Ddd*f**3*r*s - 144*C*D1*Ddd*f**3*r + 96*C*D1*Ddd*f**3*s**2 - 144*C*D1*Ddd*f**3*s + 72*C*D1*Ddd*f**3 + 288*C*Dd**2*f**3*r**2 + 576*C*Dd**2*f**3*r*s - 432*C*Dd**2*f**3*r + 288*C*Dd**2*f**3*s**2 - 432*C*Dd**2*f**3*s + 144*C*Dd**2*f**3 - 60*D1**2*K*b1*f*fd*r**2 - 120*D1**2*K*b1*f*fd*r*s + 60*D1**2*K*b1*f*fd*r - 60*D1**2*K*b1*f*fd*s**2 + 60*D1**2*K*b1*f*fd*s - 30*D1**2*K*b1*f*fd + 72*D1**2*K*b1*f*fdd*r**2 + 144*D1**2*K*b1*f*fdd*r*s - 72*D1**2*K*b1*f*fdd*r + 72*D1**2*K*b1*f*fdd*s**2 - 72*D1**2*K*b1*f*fdd*s + 36*D1**2*K*b1*f*fdd + 72*D1**2*K*b1*fd**2*r**2 + 144*D1**2*K*b1*fd**2*r*s - 72*D1**2*K*b1*fd**2*r + 72*D1**2*K*b1*fd**2*s**2 - 72*D1**2*K*b1*fd**2*s + 69*D1**2*b1*f**2*fd*r**2 + 138*D1**2*b1*f**2*fd*r*s - 92*D1**2*b1*f**2*fd*r + 69*D1**2*b1*f**2*fd*s**2 - 92*D1**2*b1*f**2*fd*s + 46*D1**2*b1*f**2*fd - 75*D1**2*b1*f**2*fdd*r**2 - 150*D1**2*b1*f**2*fdd*r*s + 100*D1**2*b1*f**2*fdd*r - 75*D1**2*b1*f**2*fdd*s**2 + 100*D1**2*b1*f**2*fdd*s - 50*D1**2*b1*f**2*fdd - 150*D1**2*b1*f*fd**2*r**2 - 300*D1**2*b1*f*fd**2*r*s + 200*D1**2*b1*f*fd**2*r - 150*D1**2*b1*f*fd**2*s**2 + 200*D1**2*b1*f*fd**2*s - 50*D1**2*b1*f*fd**2 + 30*D1**2*b1*f*fd*r**2 + 60*D1**2*b1*f*fd*r*s - 30*D1**2*b1*f*fd*r + 30*D1**2*b1*f*fd*s**2 - 30*D1**2*b1*f*fd*s + 15*D1**2*b1*f*fd - 36*D1**2*b1*f*fdd*r**2 - 72*D1**2*b1*f*fdd*r*s + 36*D1**2*b1*f*fdd*r - 36*D1**2*b1*f*fdd*s**2 + 36*D1**2*b1*f*fdd*s - 18*D1**2*b1*f*fdd - 36*D1**2*b1*fd**2*r**2 - 72*D1**2*b1*fd**2*r*s + 36*D1**2*b1*fd**2*r - 36*D1**2*b1*fd**2*s**2 + 36*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-36*K + 25*f + 18)*(r + s - 1)**2 + 60*D1**2*f**3*fd*r**2 + 120*D1**2*f**3*fd*r*s - 90*D1**2*f**3*fd*r + 60*D1**2*f**3*fd*s**2 - 90*D1**2*f**3*fd*s + 45*D1**2*f**3*fd + 81*D1**2*f**2*fd*r**2 + 162*D1**2*f**2*fd*r*s - 108*D1**2*f**2*fd*r + 81*D1**2*f**2*fd*s**2 - 108*D1**2*f**2*fd*s + 54*D1**2*f**2*fd - 54*D1**2*f**2*fdd*r**2 - 108*D1**2*f**2*fdd*r*s + 72*D1**2*f**2*fdd*r - 54*D1**2*f**2*fdd*s**2 + 72*D1**2*f**2*fdd*s - 36*D1**2*f**2*fdd + 60*D1**2*f**2*gd2*r**2 + 120*D1**2*f**2*gd2*r*s - 120*D1**2*f**2*gd2*r + 60*D1**2*f**2*gd2*s**2 - 120*D1**2*f**2*gd2*s + 60*D1**2*f**2*gd2 - 72*D1**2*f**2*gdd2*r**2 - 144*D1**2*f**2*gdd2*r*s + 144*D1**2*f**2*gdd2*r - 72*D1**2*f**2*gdd2*s**2 + 144*D1**2*f**2*gdd2*s - 72*D1**2*f**2*gdd2 - 108*D1**2*f*fd**2*r**2 - 216*D1**2*f*fd**2*r*s + 144*D1**2*f*fd**2*r - 108*D1**2*f*fd**2*s**2 + 144*D1**2*f*fd**2*s - 36*D1**2*f*fd**2 + 120*D1**2*f*fd*g2*r**2 + 240*D1**2*f*fd*g2*r*s - 120*D1**2*f*fd*g2*r + 120*D1**2*f*fd*g2*s**2 - 120*D1**2*f*fd*g2*s + 60*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r**2 - 576*D1**2*f*fd*gd2*r*s + 432*D1**2*f*fd*gd2*r - 288*D1**2*f*fd*gd2*s**2 + 432*D1**2*f*fd*gd2*s - 144*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r**2 - 288*D1**2*f*fdd*g2*r*s + 144*D1**2*f*fdd*g2*r - 144*D1**2*f*fdd*g2*s**2 + 144*D1**2*f*fdd*g2*s - 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r**2 - 288*D1**2*fd**2*g2*r*s + 144*D1**2*fd**2*g2*r - 144*D1**2*fd**2*g2*s**2 + 144*D1**2*fd**2*g2*s - 120*D1*Dd*K*b1*f**2*r**2 - 240*D1*Dd*K*b1*f**2*r*s + 180*D1*Dd*K*b1*f**2*r - 120*D1*Dd*K*b1*f**2*s**2 + 180*D1*Dd*K*b1*f**2*s - 90*D1*Dd*K*b1*f**2 + 576*D1*Dd*K*b1*f*fd*r**2 + 1152*D1*Dd*K*b1*f*fd*r*s - 720*D1*Dd*K*b1*f*fd*r + 576*D1*Dd*K*b1*f*fd*s**2 - 720*D1*Dd*K*b1*f*fd*s + 216*D1*Dd*K*b1*f*fd + 92*D1*Dd*b1*f**3*r**2 + 184*D1*Dd*b1*f**3*r*s - 138*D1*Dd*b1*f**3*r + 92*D1*Dd*b1*f**3*s**2 - 138*D1*Dd*b1*f**3*s + 69*D1*Dd*b1*f**3 - 600*D1*Dd*b1*f**2*fd*r**2 - 1200*D1*Dd*b1*f**2*fd*r*s + 850*D1*Dd*b1*f**2*fd*r - 600*D1*Dd*b1*f**2*fd*s**2 + 850*D1*Dd*b1*f**2*fd*s - 300*D1*Dd*b1*f**2*fd + 60*D1*Dd*b1*f**2*r**2 + 120*D1*Dd*b1*f**2*r*s - 90*D1*Dd*b1*f**2*r + 60*D1*Dd*b1*f**2*s**2 - 90*D1*Dd*b1*f**2*s + 45*D1*Dd*b1*f**2 - 288*D1*Dd*b1*f*fd*r**2 - 576*D1*Dd*b1*f*fd*r*s + 360*D1*Dd*b1*f*fd*r - 288*D1*Dd*b1*f*fd*s**2 + 360*D1*Dd*b1*f*fd*s - 108*D1*Dd*b1*f*fd + 60*D1*Dd*f**4*r**2 + 120*D1*Dd*f**4*r*s - 90*D1*Dd*f**4*r + 60*D1*Dd*f**4*s**2 - 90*D1*Dd*f**4*s + 45*D1*Dd*f**4 + 108*D1*Dd*f**3*r**2 + 216*D1*Dd*f**3*r*s - 162*D1*Dd*f**3*r + 108*D1*Dd*f**3*s**2 - 162*D1*Dd*f**3*s + 81*D1*Dd*f**3 - 432*D1*Dd*f**2*fd*r**2 - 864*D1*Dd*f**2*fd*r*s + 612*D1*Dd*f**2*fd*r - 432*D1*Dd*f**2*fd*s**2 + 612*D1*Dd*f**2*fd*s - 216*D1*Dd*f**2*fd + 240*D1*Dd*f**2*g2*r**2 + 480*D1*Dd*f**2*g2*r*s - 360*D1*Dd*f**2*g2*r + 240*D1*Dd*f**2*g2*s**2 - 360*D1*Dd*f**2*g2*s + 180*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r**2 - 1152*D1*Dd*f**2*gd2*r*s + 1008*D1*Dd*f**2*gd2*r - 576*D1*Dd*f**2*gd2*s**2 + 1008*D1*Dd*f**2*gd2*s - 432*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r**2 - 2304*D1*Dd*f*fd*g2*r*s + 1440*D1*Dd*f*fd*g2*r - 1152*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 432*D1*Dd*f*fd*g2 + 144*D1*Ddd*K*b1*f**2*r**2 + 288*D1*Ddd*K*b1*f**2*r*s - 216*D1*Ddd*K*b1*f**2*r + 144*D1*Ddd*K*b1*f**2*s**2 - 216*D1*Ddd*K*b1*f**2*s + 108*D1*Ddd*K*b1*f**2 - 100*D1*Ddd*b1*f**3*r**2 - 200*D1*Ddd*b1*f**3*r*s + 150*D1*Ddd*b1*f**3*r - 100*D1*Ddd*b1*f**3*s**2 + 150*D1*Ddd*b1*f**3*s - 75*D1*Ddd*b1*f**3 - 72*D1*Ddd*b1*f**2*r**2 - 144*D1*Ddd*b1*f**2*r*s + 108*D1*Ddd*b1*f**2*r - 72*D1*Ddd*b1*f**2*s**2 + 108*D1*Ddd*b1*f**2*s - 54*D1*Ddd*b1*f**2 - 72*D1*Ddd*f**3*r**2 - 144*D1*Ddd*f**3*r*s + 108*D1*Ddd*f**3*r - 72*D1*Ddd*f**3*s**2 + 108*D1*Ddd*f**3*s - 54*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r**2 - 576*D1*Ddd*f**2*g2*r*s + 432*D1*Ddd*f**2*g2*r - 288*D1*Ddd*f**2*g2*s**2 + 432*D1*Ddd*f**2*g2*s - 216*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(23*f**2*(r + s - 1) - 5*f*(10*fd*(3*r + 3*s - 2) + (6*K - 3)*(r + s - 1)) + 36*fd*(2*K - 1)*(2*r + 2*s - 1)) - 2*Dd*f*(-36*K + 25*f + 18)*(4*r + 4*s - 3))*(r + s - 1) + 432*Dd**2*K*b1*f**2*r**2 + 864*Dd**2*K*b1*f**2*r*s - 648*Dd**2*K*b1*f**2*r + 432*Dd**2*K*b1*f**2*s**2 - 648*Dd**2*K*b1*f**2*s + 216*Dd**2*K*b1*f**2 - 300*Dd**2*b1*f**3*r**2 - 600*Dd**2*b1*f**3*r*s + 450*Dd**2*b1*f**3*r - 300*Dd**2*b1*f**3*s**2 + 450*Dd**2*b1*f**3*s - 150*Dd**2*b1*f**3 - 216*Dd**2*b1*f**2*r**2 - 432*Dd**2*b1*f**2*r*s + 324*Dd**2*b1*f**2*r - 216*Dd**2*b1*f**2*s**2 + 324*Dd**2*b1*f**2*s - 108*Dd**2*b1*f**2 - 216*Dd**2*f**3*r**2 - 432*Dd**2*f**3*r*s + 324*Dd**2*f**3*r - 216*Dd**2*f**3*s**2 + 324*Dd**2*f**3*s - 108*Dd**2*f**3 - 864*Dd**2*f**2*g2*r**2 - 1728*Dd**2*f**2*g2*r*s + 1296*Dd**2*f**2*g2*r - 864*Dd**2*f**2*g2*s**2 + 1296*Dd**2*f**2*g2*s - 432*Dd**2*f**2*g2)/(210*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*k1**3*k2**3*st**2*(72*C*D1**2*bdd1*f**2*r**2 + 144*C*D1**2*bdd1*f**2*r*s - 144*C*D1**2*bdd1*f**2*r + 72*C*D1**2*bdd1*f**2*s**2 - 144*C*D1**2*bdd1*f**2*s + 72*C*D1**2*bdd1*f**2 - 60*C*D1**2*f**2*fd*r**2 - 120*C*D1**2*f**2*fd*r*s + 80*C*D1**2*f**2*fd*r - 60*C*D1**2*f**2*fd*s**2 + 80*C*D1**2*f**2*fd*s - 40*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r**2 + 240*C*D1**2*f**2*fdd*r*s - 160*C*D1**2*f**2*fdd*r + 120*C*D1**2*f**2*fdd*s**2 - 160*C*D1**2*f**2*fdd*s + 80*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r**2 + 480*C*D1**2*f*fd**2*r*s - 320*C*D1**2*f*fd**2*r + 240*C*D1**2*f*fd**2*s**2 - 320*C*D1**2*f*fd**2*s + 80*C*D1**2*f*fd**2 - 80*C*D1*Dd*f**3*r**2 - 160*C*D1*Dd*f**3*r*s + 120*C*D1*Dd*f**3*r - 80*C*D1*Dd*f**3*s**2 + 120*C*D1*Dd*f**3*s - 60*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r**2 + 1920*C*D1*Dd*f**2*fd*r*s - 1360*C*D1*Dd*f**2*fd*r + 960*C*D1*Dd*f**2*fd*s**2 - 1360*C*D1*Dd*f**2*fd*s + 480*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r**2 + 320*C*D1*Ddd*f**3*r*s - 240*C*D1*Ddd*f**3*r + 160*C*D1*Ddd*f**3*s**2 - 240*C*D1*Ddd*f**3*s + 120*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r**2 + 960*C*Dd**2*f**3*r*s - 720*C*Dd**2*f**3*r + 480*C*Dd**2*f**3*s**2 - 720*C*Dd**2*f**3*s + 240*C*Dd**2*f**3 + 36*D1**2*K*bdd1*f**2*r**2 + 72*D1**2*K*bdd1*f**2*r*s - 72*D1**2*K*bdd1*f**2*r + 36*D1**2*K*bdd1*f**2*s**2 - 72*D1**2*K*bdd1*f**2*s + 36*D1**2*K*bdd1*f**2 - 12*D1**2*bd1**2*f*(-14*K + 15*f + 7)*(r + s - 1)**2 - 54*D1**2*bdd1*f**2*r**2 - 108*D1**2*bdd1*f**2*r*s + 108*D1**2*bdd1*f**2*r - 54*D1**2*bdd1*f**2*s**2 + 108*D1**2*bdd1*f**2*s - 54*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r**2 - 336*D1**2*bdd1*f*g2*r*s + 336*D1**2*bdd1*f*g2*r - 168*D1**2*bdd1*f*g2*s**2 + 336*D1**2*bdd1*f*g2*s - 168*D1**2*bdd1*f*g2 + 21*D1**2*f**2*fd*r**2 + 42*D1**2*f**2*fd*r*s - 28*D1**2*f**2*fd*r + 21*D1**2*f**2*fd*s**2 - 28*D1**2*f**2*fd*s + 14*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd + 4*D1**2*f**2*gd2*r**2 + 8*D1**2*f**2*gd2*r*s - 8*D1**2*f**2*gd2*r + 4*D1**2*f**2*gd2*s**2 - 8*D1**2*f**2*gd2*s + 4*D1**2*f**2*gd2 - 72*D1**2*f**2*gdd2*r**2 - 144*D1**2*f**2*gdd2*r*s + 144*D1**2*f**2*gdd2*r - 72*D1**2*f**2*gdd2*s**2 + 144*D1**2*f**2*gdd2*s - 72*D1**2*f**2*gdd2 - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 8*D1**2*f*fd*g2*r**2 + 16*D1**2*f*fd*g2*r*s - 8*D1**2*f*fd*g2*r + 8*D1**2*f*fd*g2*s**2 - 8*D1**2*f*fd*g2*s + 4*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r**2 - 576*D1**2*f*fd*gd2*r*s + 432*D1**2*f*fd*gd2*r - 288*D1**2*f*fd*gd2*s**2 + 432*D1**2*f*fd*gd2*s - 144*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r**2 - 288*D1**2*f*fdd*g2*r*s + 144*D1**2*f*fdd*g2*r - 144*D1**2*f*fdd*g2*s**2 + 144*D1**2*f*fdd*g2*s - 72*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r**2 - 288*D1**2*fd**2*g2*r*s + 144*D1**2*fd**2*g2*r - 144*D1**2*fd**2*g2*s**2 + 144*D1**2*fd**2*g2*s + 28*D1*Dd*f**3*r**2 + 56*D1*Dd*f**3*r*s - 42*D1*Dd*f**3*r + 28*D1*Dd*f**3*s**2 - 42*D1*Dd*f**3*s + 21*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 680*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 680*D1*Dd*f**2*fd*s - 240*D1*Dd*f**2*fd + 16*D1*Dd*f**2*g2*r**2 + 32*D1*Dd*f**2*g2*r*s - 24*D1*Dd*f**2*g2*r + 16*D1*Dd*f**2*g2*s**2 - 24*D1*Dd*f**2*g2*s + 12*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r**2 - 1152*D1*Dd*f**2*gd2*r*s + 1008*D1*Dd*f**2*gd2*r - 576*D1*Dd*f**2*gd2*s**2 + 1008*D1*Dd*f**2*gd2*s - 432*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r**2 - 2304*D1*Dd*f*fd*g2*r*s + 1440*D1*Dd*f*fd*g2*r - 1152*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 432*D1*Dd*f*fd*g2 - 80*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 120*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r**2 - 576*D1*Ddd*f**2*g2*r*s + 432*D1*Ddd*f**2*g2*r - 288*D1*Ddd*f**2*g2*s**2 + 432*D1*Ddd*f**2*g2*s - 216*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(f**2*(58*C + K - 40)*(r + s - 1) - 2*f*(9*fd*(4*C + 2*K - 3)*(2*r + 2*s - 1) + (49*g2 - 84*gd2)*(r + s - 1)) + 168*fd*g2*(r + s)) - 6*Dd*f*(3*f*(4*C + 2*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 240*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 360*Dd**2*f**3*s - 120*Dd**2*f**3 - 864*Dd**2*f**2*g2*r**2 - 1728*Dd**2*f**2*g2*r*s + 1296*Dd**2*f**2*g2*r - 864*Dd**2*f**2*g2*s**2 + 1296*Dd**2*f**2*g2*s - 432*Dd**2*f**2*g2 + b1**2*(D1**2*(9*f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(180*fd**2*(r + s - 1) + 49*fd*(2*K - 1)*(r + s) - 42*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(117*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(180*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (98*K - 49)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 84*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-14*K + 15*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-14*K + 15*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(-116*C*D1**2*f*fd*r**2 - 232*C*D1**2*f*fd*r*s + 116*C*D1**2*f*fd*r - 116*C*D1**2*f*fd*s**2 + 116*C*D1**2*f*fd*s - 58*C*D1**2*f*fd + 72*C*D1**2*f*fdd*r**2 + 144*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 36*C*D1**2*f*fdd + 72*C*D1**2*fd**2*r**2 + 144*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*r + 72*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s - 232*C*D1*Dd*f**2*r**2 - 464*C*D1*Dd*f**2*r*s + 348*C*D1*Dd*f**2*r - 232*C*D1*Dd*f**2*s**2 + 348*C*D1*Dd*f**2*s - 174*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 + 1152*C*D1*Dd*f*fd*r*s - 720*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 216*C*D1*Dd*f*fd + 144*C*D1*Ddd*f**2*r**2 + 288*C*D1*Ddd*f**2*r*s - 216*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 216*C*D1*Ddd*f**2*s + 108*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r**2 + 864*C*Dd**2*f**2*r*s - 648*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 648*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 - 2*D1**2*K*f*fd*r**2 - 4*D1**2*K*f*fd*r*s + 2*D1**2*K*f*fd*r - 2*D1**2*K*f*fd*s**2 + 2*D1**2*K*f*fd*s - D1**2*K*f*fd + 36*D1**2*K*f*fdd*r**2 + 72*D1**2*K*f*fdd*r*s - 36*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r**2 + 72*D1**2*K*fd**2*r*s - 36*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-14*K + 15*f + 7)*(r + s - 1)**2 + 80*D1**2*f*fd*r**2 + 160*D1**2*f*fd*r*s - 80*D1**2*f*fd*r + 80*D1**2*f*fd*s**2 - 80*D1**2*f*fd*s + 40*D1**2*f*fd - 54*D1**2*f*fdd*r**2 - 108*D1**2*f*fdd*r*s + 54*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 54*D1**2*f*fdd*s - 27*D1**2*f*fdd + 98*D1**2*f*gd2*r**2 + 196*D1**2*f*gd2*r*s - 196*D1**2*f*gd2*r + 98*D1**2*f*gd2*s**2 - 196*D1**2*f*gd2*s + 98*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 54*D1**2*fd**2*r**2 - 108*D1**2*fd**2*r*s + 54*D1**2*fd**2*r - 54*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s + 98*D1**2*fd*g2*r**2 + 196*D1**2*fd*g2*r*s + 98*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 - 4*D1*Dd*K*f**2*r**2 - 8*D1*Dd*K*f**2*r*s + 6*D1*Dd*K*f**2*r - 4*D1*Dd*K*f**2*s**2 + 6*D1*Dd*K*f**2*s - 3*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r**2 + 576*D1*Dd*K*f*fd*r*s - 360*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 360*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd + 160*D1*Dd*f**2*r**2 + 320*D1*Dd*f**2*r*s - 240*D1*Dd*f**2*r + 160*D1*Dd*f**2*s**2 - 240*D1*Dd*f**2*s + 120*D1*Dd*f**2 - 432*D1*Dd*f*fd*r**2 - 864*D1*Dd*f*fd*r*s + 540*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 540*D1*Dd*f*fd*s - 162*D1*Dd*f*fd + 392*D1*Dd*f*g2*r**2 + 784*D1*Dd*f*g2*r*s - 588*D1*Dd*f*g2*r + 392*D1*Dd*f*g2*s**2 - 588*D1*Dd*f*g2*s + 294*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s + 72*D1*Ddd*K*f**2*r**2 + 144*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 108*D1*Ddd*K*f**2*s + 54*D1*Ddd*K*f**2 - 108*D1*Ddd*f**2*r**2 - 216*D1*Ddd*f**2*r*s + 162*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 162*D1*Ddd*f**2*s - 81*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + D1*bd1*(D1*(117*f**2*(r + s - 1) - 180*f*fd*(2*r + 2*s - 1) - 49*f*(2*K - 1)*(r + s - 1) + 84*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-14*K + 15*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*f**2*r**2 + 432*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 324*Dd**2*K*f**2*s + 108*Dd**2*K*f**2 - 324*Dd**2*f**2*r**2 - 648*Dd**2*f**2*r*s + 486*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 486*Dd**2*f**2*s - 162*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(210*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct*k1**3*k2**3*(-3*D1*(r + s - 1)*(56*D1*K*bd1**2*f*(r + s - 1) + 4*D1*bdd1*f*(f*(10*C - 5) - 14*g2)*(r + s - 1) + bd1*(D1*(f**2*(4*C - 9)*(r + s - 1) + f*fd*(80*C - 40)*(2*r + 2*s - 1) - 28*f*(g2 + 4*gd2)*(r + s - 1) - 112*fd*g2*(r + s)) + 8*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))) + 7*b1**2*(D1**2*(9*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)**2*(12*K*fdd + fd*(6*K - 5))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(6*K - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-3*D1**2*(f*(fd*(4*C - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*(r + s - 1)**2*(14*K*bdd1 - 7*gd2 - 14*gdd2)) + (4*r + 4*s)*(fd**2*(20*C - 10)*(r + s - 1) - 7*fd*(g2*(r + s) + 4*gd2*(r + s - 1)) - 14*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-24*K*fd*(r + s) + 9*f**2*(r + s - 1) - f*(6*K - 5)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) - 3*D1*(Dd*(f**2*(4*C - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4*f*(fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 28*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 112*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 4*Ddd*f*(f*(10*C - 5) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(10*C - 5) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*k1**3*k2*st**4*(-57*D1**2*b1*f**2*fd*r**2 - 114*D1**2*b1*f**2*fd*r*s + 92*D1**2*b1*f**2*fd*r - 57*D1**2*b1*f**2*fd*s**2 + 92*D1**2*b1*f**2*fd*s - 46*D1**2*b1*f**2*fd + 45*D1**2*b1*f**2*fdd*r**2 + 90*D1**2*b1*f**2*fdd*r*s - 70*D1**2*b1*f**2*fdd*r + 45*D1**2*b1*f**2*fdd*s**2 - 70*D1**2*b1*f**2*fdd*s + 35*D1**2*b1*f**2*fdd + 90*D1**2*b1*f*fd**2*r**2 + 180*D1**2*b1*f*fd**2*r*s - 140*D1**2*b1*f*fd**2*r + 90*D1**2*b1*f*fd**2*s**2 - 140*D1**2*b1*f*fd**2*s + 50*D1**2*b1*f*fd**2 - 10*D1**2*b1*f*fd*r**2 - 20*D1**2*b1*f*fd*r*s + 10*D1**2*b1*f*fd*r - 10*D1**2*b1*f*fd*s**2 + 10*D1**2*b1*f*fd*s - 5*D1**2*b1*f*fd + 12*D1**2*b1*f*fdd*r**2 + 24*D1**2*b1*f*fdd*r*s - 12*D1**2*b1*f*fdd*r + 12*D1**2*b1*f*fdd*s**2 - 12*D1**2*b1*f*fdd*s + 6*D1**2*b1*f*fdd + 12*D1**2*b1*fd**2*r**2 + 24*D1**2*b1*fd**2*r*s - 12*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 - 12*D1**2*b1*fd**2*s + D1**2*bdd1*f**2*(5*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 6*(r + s - 1)**2) - 9*D1**2*f**2*fd*r**2 - 18*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 9*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r*s - 8*D1**2*f**2*fdd*r + 6*D1**2*f**2*fdd*s**2 - 8*D1**2*f**2*fdd*s + 4*D1**2*f**2*fdd + 12*D1**2*f*fd**2*r**2 + 24*D1**2*f*fd**2*r*s - 16*D1**2*f*fd**2*r + 12*D1**2*f*fd**2*s**2 - 16*D1**2*f*fd**2*s + 4*D1**2*f*fd**2 - 76*D1*Dd*b1*f**3*r**2 - 152*D1*Dd*b1*f**3*r*s + 114*D1*Dd*b1*f**3*r - 76*D1*Dd*b1*f**3*s**2 + 114*D1*Dd*b1*f**3*s - 57*D1*Dd*b1*f**3 + 360*D1*Dd*b1*f**2*fd*r**2 + 720*D1*Dd*b1*f**2*fd*r*s - 550*D1*Dd*b1*f**2*fd*r + 360*D1*Dd*b1*f**2*fd*s**2 - 550*D1*Dd*b1*f**2*fd*s + 210*D1*Dd*b1*f**2*fd - 20*D1*Dd*b1*f**2*r**2 - 40*D1*Dd*b1*f**2*r*s + 30*D1*Dd*b1*f**2*r - 20*D1*Dd*b1*f**2*s**2 + 30*D1*Dd*b1*f**2*s - 15*D1*Dd*b1*f**2 + 96*D1*Dd*b1*f*fd*r**2 + 192*D1*Dd*b1*f*fd*r*s - 120*D1*Dd*b1*f*fd*r + 96*D1*Dd*b1*f*fd*s**2 - 120*D1*Dd*b1*f*fd*s + 36*D1*Dd*b1*f*fd - 12*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 + 18*D1*Dd*f**3*s - 9*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 96*D1*Dd*f**2*fd*r*s - 68*D1*Dd*f**2*fd*r + 48*D1*Dd*f**2*fd*s**2 - 68*D1*Dd*f**2*fd*s + 24*D1*Dd*f**2*fd + 60*D1*Ddd*b1*f**3*r**2 + 120*D1*Ddd*b1*f**3*r*s - 90*D1*Ddd*b1*f**3*r + 60*D1*Ddd*b1*f**3*s**2 - 90*D1*Ddd*b1*f**3*s + 45*D1*Ddd*b1*f**3 + 24*D1*Ddd*b1*f**2*r**2 + 48*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r + 24*D1*Ddd*b1*f**2*s**2 - 36*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 + 8*D1*Ddd*f**3*r**2 + 16*D1*Ddd*f**3*r*s - 12*D1*Ddd*f**3*r + 8*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 6*D1*Ddd*f**3 + D1*bd1*f*(D1*(-f**2*(19*r**2 + r*(38*s - 22) + 19*s**2 - 22*s + 11) + 5*f*(r + s - 1)*(2*fd*(9*r + 9*s - 4) - r - s + 1) + 12*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(4*r + 4*s - 3)*(5*f*(3*r + 3*s - 2) + 6*r + 6*s - 6)) + 180*Dd**2*b1*f**3*r**2 + 360*Dd**2*b1*f**3*r*s - 270*Dd**2*b1*f**3*r + 180*Dd**2*b1*f**3*s**2 - 270*Dd**2*b1*f**3*s + 90*Dd**2*b1*f**3 + 72*Dd**2*b1*f**2*r**2 + 144*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r + 72*Dd**2*b1*f**2*s**2 - 108*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 + 24*Dd**2*f**3*r**2 + 48*Dd**2*f**3*r*s - 36*Dd**2*f**3*r + 24*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 12*Dd**2*f**3)/(70*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1**3*k2*st**2*(12*C*D1**2*bdd1*f**2*r**2 + 24*C*D1**2*bdd1*f**2*r*s + 12*C*D1**2*bdd1*f**2*s**2 + 96*C*D1**2*f**2*fd*r**2 + 192*C*D1**2*f**2*fd*r*s - 128*C*D1**2*f**2*fd*r + 96*C*D1**2*f**2*fd*s**2 - 128*C*D1**2*f**2*fd*s + 64*C*D1**2*f**2*fd - 120*C*D1**2*f**2*fdd*r**2 - 240*C*D1**2*f**2*fdd*r*s + 160*C*D1**2*f**2*fdd*r - 120*C*D1**2*f**2*fdd*s**2 + 160*C*D1**2*f**2*fdd*s - 80*C*D1**2*f**2*fdd - 240*C*D1**2*f*fd**2*r**2 - 480*C*D1**2*f*fd**2*r*s + 320*C*D1**2*f*fd**2*r - 240*C*D1**2*f*fd**2*s**2 + 320*C*D1**2*f*fd**2*s - 80*C*D1**2*f*fd**2 + 128*C*D1*Dd*f**3*r**2 + 256*C*D1*Dd*f**3*r*s - 192*C*D1*Dd*f**3*r + 128*C*D1*Dd*f**3*s**2 - 192*C*D1*Dd*f**3*s + 96*C*D1*Dd*f**3 - 960*C*D1*Dd*f**2*fd*r**2 - 1920*C*D1*Dd*f**2*fd*r*s + 1360*C*D1*Dd*f**2*fd*r - 960*C*D1*Dd*f**2*fd*s**2 + 1360*C*D1*Dd*f**2*fd*s - 480*C*D1*Dd*f**2*fd - 160*C*D1*Ddd*f**3*r**2 - 320*C*D1*Ddd*f**3*r*s + 240*C*D1*Ddd*f**3*r - 160*C*D1*Ddd*f**3*s**2 + 240*C*D1*Ddd*f**3*s - 120*C*D1*Ddd*f**3 - 480*C*Dd**2*f**3*r**2 - 960*C*Dd**2*f**3*r*s + 720*C*Dd**2*f**3*r - 480*C*Dd**2*f**3*s**2 + 720*C*Dd**2*f**3*s - 240*C*Dd**2*f**3 - 36*D1**2*K*bdd1*f**2*r**2 - 72*D1**2*K*bdd1*f**2*r*s + 72*D1**2*K*bdd1*f**2*r - 36*D1**2*K*bdd1*f**2*s**2 + 72*D1**2*K*bdd1*f**2*s - 36*D1**2*K*bdd1*f**2 + 32*D1**2*b2*f*fd*r**2 + 64*D1**2*b2*f*fd*r*s - 32*D1**2*b2*f*fd*r + 32*D1**2*b2*f*fd*s**2 - 32*D1**2*b2*f*fd*s + 16*D1**2*b2*f*fd - 72*D1**2*b2*f*fdd*r**2 - 144*D1**2*b2*f*fdd*r*s + 72*D1**2*b2*f*fdd*r - 72*D1**2*b2*f*fdd*s**2 + 72*D1**2*b2*f*fdd*s - 36*D1**2*b2*f*fdd - 72*D1**2*b2*fd**2*r**2 - 144*D1**2*b2*fd**2*r*s + 72*D1**2*b2*fd**2*r - 72*D1**2*b2*fd**2*s**2 + 72*D1**2*b2*fd**2*s + 2*D1**2*bd1**2*f*(r + s - 1)*(14*K*s + 54*f*(r + s - 1) + 7*r*(2*K + 5) + 35*s - 42) + 16*D1**2*bd2*f**2*r**2 + 32*D1**2*bd2*f**2*r*s - 32*D1**2*bd2*f**2*r + 16*D1**2*bd2*f**2*s**2 - 32*D1**2*bd2*f**2*s + 16*D1**2*bd2*f**2 - 144*D1**2*bd2*f*fd*r**2 - 288*D1**2*bd2*f*fd*r*s + 216*D1**2*bd2*f*fd*r - 144*D1**2*bd2*f*fd*s**2 + 216*D1**2*bd2*f*fd*s - 72*D1**2*bd2*f*fd + 9*D1**2*bdd1*f**2*r**2 + 18*D1**2*bdd1*f**2*r*s - 36*D1**2*bdd1*f**2*r + 9*D1**2*bdd1*f**2*s**2 - 36*D1**2*bdd1*f**2*s + 18*D1**2*bdd1*f**2 - 28*D1**2*bdd1*f*g2*r**2 - 56*D1**2*bdd1*f*g2*r*s - 28*D1**2*bdd1*f*g2*s**2 - 36*D1**2*bdd2*f**2*r**2 - 72*D1**2*bdd2*f**2*r*s + 72*D1**2*bdd2*f**2*r - 36*D1**2*bdd2*f**2*s**2 + 72*D1**2*bdd2*f**2*s - 36*D1**2*bdd2*f**2 - 39*D1**2*f**2*fd*r**2 - 78*D1**2*f**2*fd*r*s + 52*D1**2*f**2*fd*r - 39*D1**2*f**2*fd*s**2 + 52*D1**2*f**2*fd*s - 26*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r**2 + 120*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 80*D1**2*f**2*fdd*s + 40*D1**2*f**2*fdd - 32*D1**2*f**2*gd2*r**2 - 64*D1**2*f**2*gd2*r*s + 64*D1**2*f**2*gd2*r - 32*D1**2*f**2*gd2*s**2 + 64*D1**2*f**2*gd2*s - 32*D1**2*f**2*gd2 + 72*D1**2*f**2*gdd2*r**2 + 144*D1**2*f**2*gdd2*r*s - 144*D1**2*f**2*gdd2*r + 72*D1**2*f**2*gdd2*s**2 - 144*D1**2*f**2*gdd2*s + 72*D1**2*f**2*gdd2 + 120*D1**2*f*fd**2*r**2 + 240*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 160*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 64*D1**2*f*fd*g2*r**2 - 128*D1**2*f*fd*g2*r*s + 64*D1**2*f*fd*g2*r - 64*D1**2*f*fd*g2*s**2 + 64*D1**2*f*fd*g2*s - 32*D1**2*f*fd*g2 + 288*D1**2*f*fd*gd2*r**2 + 576*D1**2*f*fd*gd2*r*s - 432*D1**2*f*fd*gd2*r + 288*D1**2*f*fd*gd2*s**2 - 432*D1**2*f*fd*gd2*s + 144*D1**2*f*fd*gd2 + 144*D1**2*f*fdd*g2*r**2 + 288*D1**2*f*fdd*g2*r*s - 144*D1**2*f*fdd*g2*r + 144*D1**2*f*fdd*g2*s**2 - 144*D1**2*f*fdd*g2*s + 72*D1**2*f*fdd*g2 + 144*D1**2*fd**2*g2*r**2 + 288*D1**2*fd**2*g2*r*s - 144*D1**2*fd**2*g2*r + 144*D1**2*fd**2*g2*s**2 - 144*D1**2*fd**2*g2*s + 64*D1*Dd*b2*f**2*r**2 + 128*D1*Dd*b2*f**2*r*s - 96*D1*Dd*b2*f**2*r + 64*D1*Dd*b2*f**2*s**2 - 96*D1*Dd*b2*f**2*s + 48*D1*Dd*b2*f**2 - 576*D1*Dd*b2*f*fd*r**2 - 1152*D1*Dd*b2*f*fd*r*s + 720*D1*Dd*b2*f*fd*r - 576*D1*Dd*b2*f*fd*s**2 + 720*D1*Dd*b2*f*fd*s - 216*D1*Dd*b2*f*fd - 288*D1*Dd*bd2*f**2*r**2 - 576*D1*Dd*bd2*f**2*r*s + 504*D1*Dd*bd2*f**2*r - 288*D1*Dd*bd2*f**2*s**2 + 504*D1*Dd*bd2*f**2*s - 216*D1*Dd*bd2*f**2 - 52*D1*Dd*f**3*r**2 - 104*D1*Dd*f**3*r*s + 78*D1*Dd*f**3*r - 52*D1*Dd*f**3*s**2 + 78*D1*Dd*f**3*s - 39*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r**2 + 960*D1*Dd*f**2*fd*r*s - 680*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 680*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd - 128*D1*Dd*f**2*g2*r**2 - 256*D1*Dd*f**2*g2*r*s + 192*D1*Dd*f**2*g2*r - 128*D1*Dd*f**2*g2*s**2 + 192*D1*Dd*f**2*g2*s - 96*D1*Dd*f**2*g2 + 576*D1*Dd*f**2*gd2*r**2 + 1152*D1*Dd*f**2*gd2*r*s - 1008*D1*Dd*f**2*gd2*r + 576*D1*Dd*f**2*gd2*s**2 - 1008*D1*Dd*f**2*gd2*s + 432*D1*Dd*f**2*gd2 + 1152*D1*Dd*f*fd*g2*r**2 + 2304*D1*Dd*f*fd*g2*r*s - 1440*D1*Dd*f*fd*g2*r + 1152*D1*Dd*f*fd*g2*s**2 - 1440*D1*Dd*f*fd*g2*s + 432*D1*Dd*f*fd*g2 - 144*D1*Ddd*b2*f**2*r**2 - 288*D1*Ddd*b2*f**2*r*s + 216*D1*Ddd*b2*f**2*r - 144*D1*Ddd*b2*f**2*s**2 + 216*D1*Ddd*b2*f**2*s - 108*D1*Ddd*b2*f**2 + 80*D1*Ddd*f**3*r**2 + 160*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 120*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 + 288*D1*Ddd*f**2*g2*r**2 + 576*D1*Ddd*f**2*g2*r*s - 432*D1*Ddd*f**2*g2*r + 288*D1*Ddd*f**2*g2*s**2 - 432*D1*Ddd*f**2*g2*s + 216*D1*Ddd*f**2*g2 + D1*bd1*(D1*(9*f**3*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f**2*(4*C*s**2 + 16*K*(r + s - 1)**2 + r**2*(4*C - 25) + r*(8*C*s - 50*s + 44) - 25*s**2 + 44*s - 22) - 4*f*(3*fd*(r + s - 1)*(-4*C*s + 6*K*(2*r + 2*s - 1) - r*(4*C + 3) - 3*s + 3) + (7*r + 7*s)*(3*g2*(r + s) + 2*gd2*(r + s - 1))) - 56*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(3*f*(-4*C*r - 4*C*s + 12*K*(r + s - 1) - 3*r - 3*s + 6) + 28*g2*(r + s))*(4*r + 4*s - 3)) - 432*Dd**2*b2*f**2*r**2 - 864*Dd**2*b2*f**2*r*s + 648*Dd**2*b2*f**2*r - 432*Dd**2*b2*f**2*s**2 + 648*Dd**2*b2*f**2*s - 216*Dd**2*b2*f**2 + 240*Dd**2*f**3*r**2 + 480*Dd**2*f**3*r*s - 360*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 360*Dd**2*f**3*s + 120*Dd**2*f**3 + 864*Dd**2*f**2*g2*r**2 + 1728*Dd**2*f**2*g2*r*s - 1296*Dd**2*f**2*g2*r + 864*Dd**2*f**2*g2*s**2 - 1296*Dd**2*f**2*g2*s + 432*Dd**2*f**2*g2 + b1**2*(D1**2*(-f*fd*(160*r**2 + r*(320*s - 202) + 160*s**2 - 202*s + 101) + 108*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 7*fd*(6*K*(r + s - 1)**2 - 10*r**2 - 20*r*s + 6*r - 10*s**2 + 6*s - 3) + fdd*(14*K*(r + s - 1)**2 + 54*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 35*r**2 + 70*r*s + 14*r + 35*s**2 + 14*s - 7)) + D1*(2*Dd*(-40*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(54*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (21*K - 35)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(4*r + 4*s - 3)*(2*K*(r + s - 1) + 5*r + 5*s + 1)) + Ddd*f*(14*K + 54*f + 35)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(14*K + 54*f + 35)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(8*C*D1**2*f*fd*r**2 + 16*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 16*C*D1**2*f*fd*s + 8*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 48*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 48*C*D1**2*fd**2*s + 24*C*D1**2*fd**2 + 16*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 24*C*D1*Dd*f**2*s + 12*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 336*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 336*C*D1*Dd*f*fd*s + 144*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 + 32*D1**2*K*f*fd*r**2 + 64*D1**2*K*f*fd*r*s - 32*D1**2*K*f*fd*r + 32*D1**2*K*f*fd*s**2 - 32*D1**2*K*f*fd*s + 16*D1**2*K*f*fd - 72*D1**2*K*f*fdd*r**2 - 144*D1**2*K*f*fdd*r*s + 72*D1**2*K*f*fdd*r - 72*D1**2*K*f*fdd*s**2 + 72*D1**2*K*f*fdd*s - 36*D1**2*K*f*fdd - 72*D1**2*K*fd**2*r**2 - 144*D1**2*K*fd**2*r*s + 72*D1**2*K*fd**2*r - 72*D1**2*K*fd**2*s**2 + 72*D1**2*K*fd**2*s + D1**2*bdd1*f*(7*K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) + 108*f*(r + s - 1)**2 + 70*r**2 + 140*r*s - 154*r + 70*s**2 - 154*s + 77) + 54*D1**2*f**2*fd*r**2 + 108*D1**2*f**2*fd*r*s - 90*D1**2*f**2*fd*r + 54*D1**2*f**2*fd*s**2 - 90*D1**2*f**2*fd*s + 45*D1**2*f**2*fd - 50*D1**2*f*fd*r**2 - 100*D1**2*f*fd*r*s + 56*D1**2*f*fd*r - 50*D1**2*f*fd*s**2 + 56*D1**2*f*fd*s - 28*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*s**2 - 84*D1**2*f*gd2*r**2 - 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*r - 84*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s - 84*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 + 18*D1**2*fd**2*r**2 + 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2 - 84*D1**2*fd*g2*r**2 - 168*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*r - 84*D1**2*fd*g2*s**2 + 168*D1**2*fd*g2*s - 84*D1**2*fd*g2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 112*D1**2*fd*gd2*s - 56*D1**2*fd*gd2 - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s + 56*D1**2*fdd*g2*r - 28*D1**2*fdd*g2*s**2 + 56*D1**2*fdd*g2*s - 28*D1**2*fdd*g2 + 64*D1*Dd*K*f**2*r**2 + 128*D1*Dd*K*f**2*r*s - 96*D1*Dd*K*f**2*r + 64*D1*Dd*K*f**2*s**2 - 96*D1*Dd*K*f**2*s + 48*D1*Dd*K*f**2 - 576*D1*Dd*K*f*fd*r**2 - 1152*D1*Dd*K*f*fd*r*s + 720*D1*Dd*K*f*fd*r - 576*D1*Dd*K*f*fd*s**2 + 720*D1*Dd*K*f*fd*s - 216*D1*Dd*K*f*fd + 72*D1*Dd*f**3*r**2 + 144*D1*Dd*f**3*r*s - 108*D1*Dd*f**3*r + 72*D1*Dd*f**3*s**2 - 108*D1*Dd*f**3*s + 54*D1*Dd*f**3 - 100*D1*Dd*f**2*r**2 - 200*D1*Dd*f**2*r*s + 150*D1*Dd*f**2*r - 100*D1*Dd*f**2*s**2 + 150*D1*Dd*f**2*s - 75*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 288*D1*Dd*f*fd*r*s - 108*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 108*D1*Dd*f*fd*s - 336*D1*Dd*f*g2*r**2 - 672*D1*Dd*f*g2*r*s + 504*D1*Dd*f*g2*r - 336*D1*Dd*f*g2*s**2 + 504*D1*Dd*f*g2*s - 252*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 392*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 392*D1*Dd*fd*g2*s - 168*D1*Dd*fd*g2 - 144*D1*Ddd*K*f**2*r**2 - 288*D1*Ddd*K*f**2*r*s + 216*D1*Ddd*K*f**2*r - 144*D1*Ddd*K*f**2*s**2 + 216*D1*Ddd*K*f**2*s - 108*D1*Ddd*K*f**2 + 36*D1*Ddd*f**2*r**2 + 72*D1*Ddd*f**2*r*s - 54*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 54*D1*Ddd*f**2*s + 27*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + D1*bd1*(D1*(-f**2*(160*r**2 + r*(320*s - 278) + 160*s**2 - 278*s + 139) + f*(42*K*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 216*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 140*r**2 - 280*r*s + 238*r - 140*s**2 + 238*s - 119) + 14*fd*(r + s - 1)*(K*(4*r + 4*s - 2) + 10*r + 10*s + 1)) + 2*Dd*f*(4*r + 4*s - 3)*(7*K*(4*r + 4*s - 2) + 108*f*(r + s - 1) + 70*r + 70*s - 77)) - 432*Dd**2*K*f**2*r**2 - 864*Dd**2*K*f**2*r*s + 648*Dd**2*K*f**2*r - 432*Dd**2*K*f**2*s**2 + 648*Dd**2*K*f**2*s - 216*Dd**2*K*f**2 + 108*Dd**2*f**2*r**2 + 216*Dd**2*f**2*r*s - 162*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 162*Dd**2*f**2*s + 54*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1**3*k2*(D1*(r + s - 1)*(-14*D1*bd1**2*(12*K*f*(r + s - 1) - f*(12*C - 9)*(r + s) + 20*g2*(r + s)) - 12*D1*bdd1*f*(f*(10*C - 5) - 14*g2)*(r + s - 1) + 28*b2*(-3*D1*bdd1*f*(r + s - 1) + bd1*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3))) + bd1*(-168*D1*bd2*f*(r + s - 1) + D1*(f**2*(72*C - 15)*(r + s - 1) - 8*f*(fd*(30*C - 15)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 336*fd*g2*(r + s)) - 24*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))) + 7*b1**3*(3*D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 9*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 9*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-4*C*D1**2*fd*r**2 - 8*C*D1**2*fd*r*s + 8*C*D1**2*fd*r - 4*C*D1**2*fd*s**2 + 8*C*D1**2*fd*s - 4*C*D1**2*fd + 12*C*D1**2*fdd*r**2 + 24*C*D1**2*fdd*r*s - 24*C*D1**2*fdd*r + 12*C*D1**2*fdd*s**2 - 24*C*D1**2*fdd*s + 12*C*D1**2*fdd - 16*C*D1*Dd*f*r**2 - 32*C*D1*Dd*f*r*s + 24*C*D1*Dd*f*r - 16*C*D1*Dd*f*s**2 + 24*C*D1*Dd*f*s - 12*C*D1*Dd*f + 96*C*D1*Dd*fd*r**2 + 192*C*D1*Dd*fd*r*s - 168*C*D1*Dd*fd*r + 96*C*D1*Dd*fd*s**2 - 168*C*D1*Dd*fd*s + 72*C*D1*Dd*fd + 48*C*D1*Ddd*f*r**2 + 96*C*D1*Ddd*f*r*s - 72*C*D1*Ddd*f*r + 48*C*D1*Ddd*f*s**2 - 72*C*D1*Ddd*f*s + 36*C*D1*Ddd*f + 144*C*Dd**2*f*r**2 + 288*C*Dd**2*f*r*s - 216*C*Dd**2*f*r + 144*C*Dd**2*f*s**2 - 216*C*Dd**2*f*s + 72*C*Dd**2*f + 4*D1**2*K*fd*r**2 + 8*D1**2*K*fd*r*s + 4*D1**2*K*fd*s**2 - 12*D1**2*K*fdd*r**2 - 24*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*s**2 - D1**2*bdd1*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 12*D1**2*f*fd*r**2 + 24*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 9*D1**2*f*fd + 8*D1**2*fd*r**2 + 16*D1**2*fd*r*s - 6*D1**2*fd*r + 8*D1**2*fd*s**2 - 6*D1**2*fd*s + 3*D1**2*fd - 9*D1**2*fdd*r**2 - 18*D1**2*fdd*r*s + 18*D1**2*fdd*r - 9*D1**2*fdd*s**2 + 18*D1**2*fdd*s - 9*D1**2*fdd - 20*D1**2*gd2*r**2 - 40*D1**2*gd2*r*s + 40*D1**2*gd2*r - 20*D1**2*gd2*s**2 + 40*D1**2*gd2*s - 20*D1**2*gd2 - 20*D1**2*gdd2*r**2 - 40*D1**2*gdd2*r*s + 40*D1**2*gdd2*r - 20*D1**2*gdd2*s**2 + 40*D1**2*gdd2*s - 20*D1**2*gdd2 + 16*D1*Dd*K*f*r**2 + 32*D1*Dd*K*f*r*s - 24*D1*Dd*K*f*r + 16*D1*Dd*K*f*s**2 - 24*D1*Dd*K*f*s + 12*D1*Dd*K*f - 96*D1*Dd*K*fd*r**2 - 192*D1*Dd*K*fd*r*s + 72*D1*Dd*K*fd*r - 96*D1*Dd*K*fd*s**2 + 72*D1*Dd*K*fd*s + 24*D1*Dd*f**2*r**2 + 48*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 36*D1*Dd*f**2*s + 18*D1*Dd*f**2 + 32*D1*Dd*f*r**2 + 64*D1*Dd*f*r*s - 48*D1*Dd*f*r + 32*D1*Dd*f*s**2 - 48*D1*Dd*f*s + 24*D1*Dd*f - 72*D1*Dd*fd*r**2 - 144*D1*Dd*fd*r*s + 126*D1*Dd*fd*r - 72*D1*Dd*fd*s**2 + 126*D1*Dd*fd*s - 54*D1*Dd*fd - 80*D1*Dd*g2*r**2 - 160*D1*Dd*g2*r*s + 120*D1*Dd*g2*r - 80*D1*Dd*g2*s**2 + 120*D1*Dd*g2*s - 60*D1*Dd*g2 - 160*D1*Dd*gd2*r**2 - 320*D1*Dd*gd2*r*s + 280*D1*Dd*gd2*r - 160*D1*Dd*gd2*s**2 + 280*D1*Dd*gd2*s - 120*D1*Dd*gd2 - 48*D1*Ddd*K*f*r**2 - 96*D1*Ddd*K*f*r*s + 72*D1*Ddd*K*f*r - 48*D1*Ddd*K*f*s**2 + 72*D1*Ddd*K*f*s - 36*D1*Ddd*K*f - 36*D1*Ddd*f*r**2 - 72*D1*Ddd*f*r*s + 54*D1*Ddd*f*r - 36*D1*Ddd*f*s**2 + 54*D1*Ddd*f*s - 27*D1*Ddd*f - 80*D1*Ddd*g2*r**2 - 160*D1*Ddd*g2*r*s + 120*D1*Ddd*g2*r - 80*D1*Ddd*g2*s**2 + 120*D1*Ddd*g2*s - 60*D1*Ddd*g2 + D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-10*K + 9*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 144*Dd**2*K*f*r**2 - 288*Dd**2*K*f*r*s + 216*Dd**2*K*f*r - 144*Dd**2*K*f*s**2 + 216*Dd**2*K*f*s - 72*Dd**2*K*f - 108*Dd**2*f*r**2 - 216*Dd**2*f*r*s + 162*Dd**2*f*r - 108*Dd**2*f*s**2 + 162*Dd**2*f*s - 54*Dd**2*f - 240*Dd**2*g2*r**2 - 480*Dd**2*g2*r*s + 360*Dd**2*g2*r - 240*Dd**2*g2*s**2 + 360*Dd**2*g2*s - 120*Dd**2*g2) - b1*(-168*C*D1**2*bdd1*f*r**2 - 336*C*D1**2*bdd1*f*r*s + 168*C*D1**2*bdd1*f*r - 168*C*D1**2*bdd1*f*s**2 + 168*C*D1**2*bdd1*f*s - 84*C*D1**2*bdd1*f - 144*C*D1**2*f*fd*r**2 - 288*C*D1**2*f*fd*r*s + 144*C*D1**2*f*fd*r - 144*C*D1**2*f*fd*s**2 + 144*C*D1**2*f*fd*s - 72*C*D1**2*f*fd + 240*C*D1**2*f*fdd*r**2 + 480*C*D1**2*f*fdd*r*s - 240*C*D1**2*f*fdd*r + 240*C*D1**2*f*fdd*s**2 - 240*C*D1**2*f*fdd*s + 120*C*D1**2*f*fdd + 240*C*D1**2*fd**2*r**2 + 480*C*D1**2*fd**2*r*s - 240*C*D1**2*fd**2*r + 240*C*D1**2*fd**2*s**2 - 240*C*D1**2*fd**2*s - 288*C*D1*Dd*f**2*r**2 - 576*C*D1*Dd*f**2*r*s + 432*C*D1*Dd*f**2*r - 288*C*D1*Dd*f**2*s**2 + 432*C*D1*Dd*f**2*s - 216*C*D1*Dd*f**2 + 1920*C*D1*Dd*f*fd*r**2 + 3840*C*D1*Dd*f*fd*r*s - 2400*C*D1*Dd*f*fd*r + 1920*C*D1*Dd*f*fd*s**2 - 2400*C*D1*Dd*f*fd*s + 720*C*D1*Dd*f*fd + 480*C*D1*Ddd*f**2*r**2 + 960*C*D1*Ddd*f**2*r*s - 720*C*D1*Ddd*f**2*r + 480*C*D1*Ddd*f**2*s**2 - 720*C*D1*Ddd*f**2*s + 360*C*D1*Ddd*f**2 + 1440*C*Dd**2*f**2*r**2 + 2880*C*Dd**2*f**2*r*s - 2160*C*Dd**2*f**2*r + 1440*C*Dd**2*f**2*s**2 - 2160*C*Dd**2*f**2*s + 720*C*Dd**2*f**2 + 168*D1**2*K*bdd1*f*r**2 + 336*D1**2*K*bdd1*f*r*s - 336*D1**2*K*bdd1*f*r + 168*D1**2*K*bdd1*f*s**2 - 336*D1**2*K*bdd1*f*s + 168*D1**2*K*bdd1*f - 28*D1**2*b2*fd*r**2 - 56*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*s**2 + 84*D1**2*b2*fdd*r**2 + 168*D1**2*b2*fdd*r*s + 84*D1**2*b2*fdd*s**2 + 14*D1**2*bd1**2*(-10*K + 9*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 126*D1**2*bdd1*f*r**2 + 252*D1**2*bdd1*f*r*s - 126*D1**2*bdd1*f*r + 126*D1**2*bdd1*f*s**2 - 126*D1**2*bdd1*f*s + 63*D1**2*bdd1*f + 280*D1**2*bdd1*g2*r**2 + 560*D1**2*bdd1*g2*r*s - 280*D1**2*bdd1*g2*r + 280*D1**2*bdd1*g2*s**2 - 280*D1**2*bdd1*g2*s + 140*D1**2*bdd1*g2 + 84*D1**2*bdd2*f*r**2 + 168*D1**2*bdd2*f*r*s - 168*D1**2*bdd2*f*r + 84*D1**2*bdd2*f*s**2 - 168*D1**2*bdd2*f*s + 84*D1**2*bdd2*f + 30*D1**2*f*fd*r**2 + 60*D1**2*f*fd*r*s - 30*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 30*D1**2*f*fd*s + 15*D1**2*f*fd - 120*D1**2*f*fdd*r**2 - 240*D1**2*f*fdd*r*s + 120*D1**2*f*fdd*r - 120*D1**2*f*fdd*s**2 + 120*D1**2*f*fdd*s - 60*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 168*D1**2*f*gdd2*r**2 - 336*D1**2*f*gdd2*r*s + 336*D1**2*f*gdd2*r - 168*D1**2*f*gdd2*s**2 + 336*D1**2*f*gdd2*s - 168*D1**2*f*gdd2 - 120*D1**2*fd**2*r**2 - 240*D1**2*fd**2*r*s + 120*D1**2*fd**2*r - 120*D1**2*fd**2*s**2 + 120*D1**2*fd**2*s + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 336*D1**2*fd*gd2*r**2 - 672*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r - 336*D1**2*fd*gd2*s**2 + 336*D1**2*fd*gd2*s - 168*D1**2*fdd*g2*r**2 - 336*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*s**2 - 112*D1*Dd*b2*f*r**2 - 224*D1*Dd*b2*f*r*s + 168*D1*Dd*b2*f*r - 112*D1*Dd*b2*f*s**2 + 168*D1*Dd*b2*f*s - 84*D1*Dd*b2*f + 672*D1*Dd*b2*fd*r**2 + 1344*D1*Dd*b2*fd*r*s - 504*D1*Dd*b2*fd*r + 672*D1*Dd*b2*fd*s**2 - 504*D1*Dd*b2*fd*s + 60*D1*Dd*f**2*r**2 + 120*D1*Dd*f**2*r*s - 90*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 90*D1*Dd*f**2*s + 45*D1*Dd*f**2 - 960*D1*Dd*f*fd*r**2 - 1920*D1*Dd*f*fd*r*s + 1200*D1*Dd*f*fd*r - 960*D1*Dd*f*fd*s**2 + 1200*D1*Dd*f*fd*s - 360*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r**2 - 2688*D1*Dd*f*gd2*r*s + 2352*D1*Dd*f*gd2*r - 1344*D1*Dd*f*gd2*s**2 + 2352*D1*Dd*f*gd2*s - 1008*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r**2 - 2688*D1*Dd*fd*g2*r*s + 1008*D1*Dd*fd*g2*r - 1344*D1*Dd*fd*g2*s**2 + 1008*D1*Dd*fd*g2*s + 336*D1*Ddd*b2*f*r**2 + 672*D1*Ddd*b2*f*r*s - 504*D1*Ddd*b2*f*r + 336*D1*Ddd*b2*f*s**2 - 504*D1*Ddd*b2*f*s + 252*D1*Ddd*b2*f - 240*D1*Ddd*f**2*r**2 - 480*D1*Ddd*f**2*r*s + 360*D1*Ddd*f**2*r - 240*D1*Ddd*f**2*s**2 + 360*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r**2 - 1344*D1*Ddd*f*g2*r*s + 1008*D1*Ddd*f*g2*r - 672*D1*Ddd*f*g2*s**2 + 1008*D1*Ddd*f*g2*s - 504*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 8*K*(r + s - 1)**2 + 16*r**2 + 32*r*s - 26*r + 16*s**2 - 26*s + 13) - 6*fd*(r + s - 1)*(C*(-8*r - 8*s + 4) + 8*K*s + r*(8*K + 6) + 6*s - 3) - 20*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 40*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(3*f*(C*(8*r + 8*s - 4) - 8*K*(r + s - 1) - 6*r - 6*s + 3) - 20*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 28*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 1008*Dd**2*b2*f*r**2 + 2016*Dd**2*b2*f*r*s - 1512*Dd**2*b2*f*r + 1008*Dd**2*b2*f*s**2 - 1512*Dd**2*b2*f*s + 504*Dd**2*b2*f - 720*Dd**2*f**2*r**2 - 1440*Dd**2*f**2*r*s + 1080*Dd**2*f**2*r - 720*Dd**2*f**2*s**2 + 1080*Dd**2*f**2*s - 360*Dd**2*f**2 - 2016*Dd**2*f*g2*r**2 - 4032*Dd**2*f*g2*r*s + 3024*Dd**2*f*g2*r - 2016*Dd**2*f*g2*s**2 + 3024*Dd**2*f*g2*s - 1008*Dd**2*f*g2))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1**3*st**2*(D1*f*(r + s)*(2*D1*bd1**2*(9*f + 7)*(r + s - 1) + 3*D1*bdd1*f*(r + s) + bd1*(D1*f*(r + s) + 12*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(18*fd**2 + fd*(6*f + 21) + fdd*(18*f + 7))*(r + s - 1)**2 + D1*(Dd*(3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 3*f*(12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) + 14*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(9*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(9*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*bdd1*f*(9*f + 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 12*D1**2*f*fdd*s + 6*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 12*D1**2*fd**2*s + 6*D1**2*fd**2 + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s + 3*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 84*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 84*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + D1*bd1*(D1*(3*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*f*(12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 14*r**2 + 28*r*s - 14*r + 14*s**2 - 14*s + 7) + 14*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(9*f + 7)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 36*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 18*Dd**2*f**2))/(210*d**2*k2*k3**2) + D1**2*Pk2*Pkdd3*ct*k1**3*(6*D1**2*bd1**2*f*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*b1*(2*D1*bd1**2*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 3*D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + bd1*(-D1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*D1*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + b1**3*(-D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(-f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 20*r**2 + 40*r*s - 30*r + 20*s**2 - 30*s + 15) + Ddd*(3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*bdd1*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - D1**2*fd*r**2 - 2*D1**2*fd*r*s + 2*D1**2*fd*r - D1**2*fd*s**2 + 2*D1**2*fd*s - D1**2*fd + 3*D1**2*fdd*r**2 + 6*D1**2*fdd*r*s - 6*D1**2*fdd*r + 3*D1**2*fdd*s**2 - 6*D1**2*fdd*s + 3*D1**2*fdd - 4*D1*Dd*f*r**2 - 8*D1*Dd*f*r*s + 6*D1*Dd*f*r - 4*D1*Dd*f*s**2 + 6*D1*Dd*f*s - 3*D1*Dd*f + 24*D1*Dd*fd*r**2 + 48*D1*Dd*fd*r*s - 42*D1*Dd*fd*r + 24*D1*Dd*fd*s**2 - 42*D1*Dd*fd*s + 18*D1*Dd*fd + 12*D1*Ddd*f*r**2 + 24*D1*Ddd*f*r*s - 18*D1*Ddd*f*r + 12*D1*Ddd*f*s**2 - 18*D1*Ddd*f*s + 9*D1*Ddd*f + D1*bd1*(D1*(-f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 15*r**2 + 30*r*s - 20*r + 15*s**2 - 20*s + 10) + 2*Dd*(3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 36*Dd**2*f*r**2 + 72*Dd**2*f*r*s - 54*Dd**2*f*r + 36*Dd**2*f*s**2 - 54*Dd**2*f*s + 18*Dd**2*f))/(30*d**2*k2*k3**2) + D1**2*Pk2*Pkdd3*ct*k1*k2**5*st**6*(-24*C*D1**2*f**2*fd*r**2 - 48*C*D1**2*f**2*fd*r*s + 32*C*D1**2*f**2*fd*r - 24*C*D1**2*f**2*fd*s**2 + 32*C*D1**2*f**2*fd*s - 16*C*D1**2*f**2*fd + 12*C*D1**2*f**2*fdd*r**2 + 24*C*D1**2*f**2*fdd*r*s - 16*C*D1**2*f**2*fdd*r + 12*C*D1**2*f**2*fdd*s**2 - 16*C*D1**2*f**2*fdd*s + 8*C*D1**2*f**2*fdd + 24*C*D1**2*f*fd**2*r**2 + 48*C*D1**2*f*fd**2*r*s - 32*C*D1**2*f*fd**2*r + 24*C*D1**2*f*fd**2*s**2 - 32*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 32*C*D1*Dd*f**3*r**2 - 64*C*D1*Dd*f**3*r*s + 48*C*D1*Dd*f**3*r - 32*C*D1*Dd*f**3*s**2 + 48*C*D1*Dd*f**3*s - 24*C*D1*Dd*f**3 + 96*C*D1*Dd*f**2*fd*r**2 + 192*C*D1*Dd*f**2*fd*r*s - 136*C*D1*Dd*f**2*fd*r + 96*C*D1*Dd*f**2*fd*s**2 - 136*C*D1*Dd*f**2*fd*s + 48*C*D1*Dd*f**2*fd + 16*C*D1*Ddd*f**3*r**2 + 32*C*D1*Ddd*f**3*r*s - 24*C*D1*Ddd*f**3*r + 16*C*D1*Ddd*f**3*s**2 - 24*C*D1*Ddd*f**3*s + 12*C*D1*Ddd*f**3 + 48*C*Dd**2*f**3*r**2 + 96*C*Dd**2*f**3*r*s - 72*C*Dd**2*f**3*r + 48*C*Dd**2*f**3*s**2 - 72*C*Dd**2*f**3*s + 24*C*Dd**2*f**3 - 72*D1**2*K*b1*f*fd*r**2 - 144*D1**2*K*b1*f*fd*r*s + 72*D1**2*K*b1*f*fd*r - 72*D1**2*K*b1*f*fd*s**2 + 72*D1**2*K*b1*f*fd*s - 36*D1**2*K*b1*f*fd + 36*D1**2*K*b1*f*fdd*r**2 + 72*D1**2*K*b1*f*fdd*r*s - 36*D1**2*K*b1*f*fdd*r + 36*D1**2*K*b1*f*fdd*s**2 - 36*D1**2*K*b1*f*fdd*s + 18*D1**2*K*b1*f*fdd + 36*D1**2*K*b1*fd**2*r**2 + 72*D1**2*K*b1*fd**2*r*s - 36*D1**2*K*b1*fd**2*r + 36*D1**2*K*b1*fd**2*s**2 - 36*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 36*D1**2*b1*f*fd*r**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fd - 18*D1**2*b1*f*fdd*r**2 - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 9*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r**2 - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 18*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-18*K + 7*f + 9)*(r + s - 1)**2 + 18*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 24*D1**2*f**2*fd*s + 12*D1**2*f**2*fd - 9*D1**2*f**2*fdd*r**2 - 18*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r - 9*D1**2*f**2*fdd*s**2 + 12*D1**2*f**2*fdd*s - 6*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 36*D1**2*f**2*gdd2*r**2 - 72*D1**2*f**2*gdd2*r*s + 72*D1**2*f**2*gdd2*r - 36*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 36*D1**2*f**2*gdd2 - 18*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 24*D1**2*f*fd**2*r - 18*D1**2*f*fd**2*s**2 + 24*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r**2 - 288*D1**2*f*fd*gd2*r*s + 216*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r**2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r**2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s - 144*D1*Dd*K*b1*f**2*r**2 - 288*D1*Dd*K*b1*f**2*r*s + 216*D1*Dd*K*b1*f**2*r - 144*D1*Dd*K*b1*f**2*s**2 + 216*D1*Dd*K*b1*f**2*s - 108*D1*Dd*K*b1*f**2 + 288*D1*Dd*K*b1*f*fd*r**2 + 576*D1*Dd*K*b1*f*fd*r*s - 360*D1*Dd*K*b1*f*fd*r + 288*D1*Dd*K*b1*f*fd*s**2 - 360*D1*Dd*K*b1*f*fd*s + 108*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 72*D1*Dd*b1*f**2*r**2 + 144*D1*Dd*b1*f**2*r*s - 108*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 108*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 144*D1*Dd*b1*f*fd*r**2 - 288*D1*Dd*b1*f*fd*r*s + 180*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 180*D1*Dd*b1*f*fd*s - 54*D1*Dd*b1*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 72*D1*Dd*f**2*fd*r**2 - 144*D1*Dd*f**2*fd*r*s + 102*D1*Dd*f**2*fd*r - 72*D1*Dd*f**2*fd*s**2 + 102*D1*Dd*f**2*fd*s - 36*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r**2 - 576*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 504*D1*Dd*f**2*gd2*s - 216*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r**2 - 1152*D1*Dd*f*fd*g2*r*s + 720*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 720*D1*Dd*f*fd*g2*s - 216*D1*Dd*f*fd*g2 + 72*D1*Ddd*K*b1*f**2*r**2 + 144*D1*Ddd*K*b1*f**2*r*s - 108*D1*Ddd*K*b1*f**2*r + 72*D1*Ddd*K*b1*f**2*s**2 - 108*D1*Ddd*K*b1*f**2*s + 54*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 36*D1*Ddd*b1*f**2*r**2 - 72*D1*Ddd*b1*f**2*r*s + 54*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 24*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 18*D1*Ddd*f**3*s - 9*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r**2 - 288*D1*Ddd*f**2*g2*r*s + 216*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 216*D1*Ddd*f**2*g2*s - 108*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 9*f*(2*K - 1)*(r + s - 1) + 9*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-18*K + 7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*b1*f**2*r**2 + 432*Dd**2*K*b1*f**2*r*s - 324*Dd**2*K*b1*f**2*r + 216*Dd**2*K*b1*f**2*s**2 - 324*Dd**2*K*b1*f**2*s + 108*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 108*Dd**2*b1*f**2*r**2 - 216*Dd**2*b1*f**2*r*s + 162*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 54*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 72*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 54*Dd**2*f**3*s - 18*Dd**2*f**3 - 432*Dd**2*f**2*g2*r**2 - 864*Dd**2*f**2*g2*r*s + 648*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 648*Dd**2*f**2*g2*s - 216*Dd**2*f**2*g2)/(126*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*k1*k2**5*st**4*(12*C*D1**2*bdd1*f**2*r**2 + 24*C*D1**2*bdd1*f**2*r*s - 24*C*D1**2*bdd1*f**2*r + 12*C*D1**2*bdd1*f**2*s**2 - 24*C*D1**2*bdd1*f**2*s + 12*C*D1**2*bdd1*f**2 - 168*C*D1**2*f**2*fd*r**2 - 336*C*D1**2*f**2*fd*r*s + 224*C*D1**2*f**2*fd*r - 168*C*D1**2*f**2*fd*s**2 + 224*C*D1**2*f**2*fd*s - 112*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r**2 + 240*C*D1**2*f**2*fdd*r*s - 160*C*D1**2*f**2*fdd*r + 120*C*D1**2*f**2*fdd*s**2 - 160*C*D1**2*f**2*fdd*s + 80*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r**2 + 480*C*D1**2*f*fd**2*r*s - 320*C*D1**2*f*fd**2*r + 240*C*D1**2*f*fd**2*s**2 - 320*C*D1**2*f*fd**2*s + 80*C*D1**2*f*fd**2 - 224*C*D1*Dd*f**3*r**2 - 448*C*D1*Dd*f**3*r*s + 336*C*D1*Dd*f**3*r - 224*C*D1*Dd*f**3*s**2 + 336*C*D1*Dd*f**3*s - 168*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r**2 + 1920*C*D1*Dd*f**2*fd*r*s - 1360*C*D1*Dd*f**2*fd*r + 960*C*D1*Dd*f**2*fd*s**2 - 1360*C*D1*Dd*f**2*fd*s + 480*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r**2 + 320*C*D1*Ddd*f**3*r*s - 240*C*D1*Ddd*f**3*r + 160*C*D1*Ddd*f**3*s**2 - 240*C*D1*Ddd*f**3*s + 120*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r**2 + 960*C*Dd**2*f**3*r*s - 720*C*Dd**2*f**3*r + 480*C*Dd**2*f**3*s**2 - 720*C*Dd**2*f**3*s + 240*C*Dd**2*f**3 + 60*D1**2*K*bdd1*f**2*r**2 + 120*D1**2*K*bdd1*f**2*r*s - 120*D1**2*K*bdd1*f**2*r + 60*D1**2*K*bdd1*f**2*s**2 - 120*D1**2*K*bdd1*f**2*s + 60*D1**2*K*bdd1*f**2 - 6*D1**2*bd1**2*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 9*D1**2*bdd1*f**2*r**2 - 18*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*r - 9*D1**2*bdd1*f**2*s**2 + 18*D1**2*bdd1*f**2*s - 9*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r**2 - 168*D1**2*bdd1*f*g2*r*s + 168*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 + 75*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 100*D1**2*f**2*fd*r + 75*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 50*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd + 72*D1**2*f**2*gd2*r**2 + 144*D1**2*f**2*gd2*r*s - 144*D1**2*f**2*gd2*r + 72*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s + 72*D1**2*f**2*gd2 - 120*D1**2*f**2*gdd2*r**2 - 240*D1**2*f**2*gdd2*r*s + 240*D1**2*f**2*gdd2*r - 120*D1**2*f**2*gdd2*s**2 + 240*D1**2*f**2*gdd2*s - 120*D1**2*f**2*gdd2 - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 144*D1**2*f*fd*g2*r**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r + 144*D1**2*f*fd*g2*s**2 - 144*D1**2*f*fd*g2*s + 72*D1**2*f*fd*g2 - 480*D1**2*f*fd*gd2*r**2 - 960*D1**2*f*fd*gd2*r*s + 720*D1**2*f*fd*gd2*r - 480*D1**2*f*fd*gd2*s**2 + 720*D1**2*f*fd*gd2*s - 240*D1**2*f*fd*gd2 - 240*D1**2*f*fdd*g2*r**2 - 480*D1**2*f*fdd*g2*r*s + 240*D1**2*f*fdd*g2*r - 240*D1**2*f*fdd*g2*s**2 + 240*D1**2*f*fdd*g2*s - 120*D1**2*f*fdd*g2 - 240*D1**2*fd**2*g2*r**2 - 480*D1**2*fd**2*g2*r*s + 240*D1**2*fd**2*g2*r - 240*D1**2*fd**2*g2*s**2 + 240*D1**2*fd**2*g2*s + 100*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 150*D1*Dd*f**3*s + 75*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 680*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 680*D1*Dd*f**2*fd*s - 240*D1*Dd*f**2*fd + 288*D1*Dd*f**2*g2*r**2 + 576*D1*Dd*f**2*g2*r*s - 432*D1*Dd*f**2*g2*r + 288*D1*Dd*f**2*g2*s**2 - 432*D1*Dd*f**2*g2*s + 216*D1*Dd*f**2*g2 - 960*D1*Dd*f**2*gd2*r**2 - 1920*D1*Dd*f**2*gd2*r*s + 1680*D1*Dd*f**2*gd2*r - 960*D1*Dd*f**2*gd2*s**2 + 1680*D1*Dd*f**2*gd2*s - 720*D1*Dd*f**2*gd2 - 1920*D1*Dd*f*fd*g2*r**2 - 3840*D1*Dd*f*fd*g2*r*s + 2400*D1*Dd*f*fd*g2*r - 1920*D1*Dd*f*fd*g2*s**2 + 2400*D1*Dd*f*fd*g2*s - 720*D1*Dd*f*fd*g2 - 80*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 120*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 - 480*D1*Ddd*f**2*g2*r**2 - 960*D1*Ddd*f**2*g2*r*s + 720*D1*Ddd*f**2*g2*r - 480*D1*Ddd*f**2*g2*s**2 + 720*D1*Ddd*f**2*g2*s - 360*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(8*C + 12*K + 1)*(r + s - 1) - 2*f*(fd*(4*C + 20*K - 3)*(2*r + 2*s - 1) + (28*g2 - 28*gd2)*(r + s - 1)) + 56*fd*g2*(r + s)) - 2*Dd*f*(f*(4*C + 20*K - 3) - 28*g2)*(4*r + 4*s - 3))*(r + s - 1) - 240*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 360*Dd**2*f**3*s - 120*Dd**2*f**3 - 1440*Dd**2*f**2*g2*r**2 - 2880*Dd**2*f**2*g2*r*s + 2160*Dd**2*f**2*g2*r - 1440*Dd**2*f**2*g2*s**2 + 2160*Dd**2*f**2*g2*s - 720*Dd**2*f**2*g2 + 3*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 14*fd*(2*K - 1)*(r + s) - 7*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (14*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 7*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-14*K + 5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-14*K + 5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-16*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 16*C*D1**2*f*fd*s - 8*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r**2 + 16*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r + 8*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s + 4*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r**2 + 16*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s - 32*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r**2 + 128*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r + 64*C*D1*Dd*f*fd*s**2 - 80*C*D1*Dd*f*fd*s + 24*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r**2 + 32*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s**2 - 24*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r**2 + 96*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s**2 - 72*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-14*K + 5*f + 7)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 3*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 72*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 36*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 18*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 12*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 18*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 7*f*(2*K - 1)*(r + s - 1) + 7*fd*(2*K - 1)*(r + s)) - Dd*f*(-14*K + 5*f + 7)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 36*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 54*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 18*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(210*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct*k1*k2**5*st**2*(D1*(-168*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(f**2*(88*C - 42*K - 37)*(r + s - 1) - 8*f*(fd*(18*C - 9)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 336*fd*g2*(r + s)) - 24*Dd*f*(f*(6*C - 3) - 14*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6*f*(2*D1*bdd1*(f*(6*C - 3) - 14*g2)*(r + s - 1)**2 + D1*(f*(fd*(6*C - 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 14*gd2*(r + s - 1)**2) - 14*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(6*C - 3) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + 7*b1**2*(D1**2*(3*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-12*K*fdd + fd*(4*K + 5))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*K + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*(f*(fd*(88*C - 42*K - 37)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*fdd*(18*C - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*(r + s - 1)**2*(42*K*bdd1 + 14*gd2 - 42*gdd2)) + (-8*r - 8*s)*(fd**2*(18*C - 9)*(r + s - 1) + 7*fd*(g2*(r + s) - 6*gd2*(r + s - 1)) - 21*fdd*g2*(r + s))) + 14*D1*bd1*(D1*(-24*K*fd*(r + s) + 3*f**2*(r + s - 1) + f*(4*K + 5)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(88*C - 42*K - 37)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*f*(fd*(18*C - 9)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 7*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 42*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 336*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(f*(6*C - 3) - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(6*C - 3) - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*k1*k2**3*st**6*(-42*D1**2*b1*f**2*fd*r**2 - 84*D1**2*b1*f**2*fd*r*s + 56*D1**2*b1*f**2*fd*r - 42*D1**2*b1*f**2*fd*s**2 + 56*D1**2*b1*f**2*fd*s - 28*D1**2*b1*f**2*fd + 21*D1**2*b1*f**2*fdd*r**2 + 42*D1**2*b1*f**2*fdd*r*s - 28*D1**2*b1*f**2*fdd*r + 21*D1**2*b1*f**2*fdd*s**2 - 28*D1**2*b1*f**2*fdd*s + 14*D1**2*b1*f**2*fdd + 42*D1**2*b1*f*fd**2*r**2 + 84*D1**2*b1*f*fd**2*r*s - 56*D1**2*b1*f*fd**2*r + 42*D1**2*b1*f*fd**2*s**2 - 56*D1**2*b1*f*fd**2*s + 14*D1**2*b1*f*fd**2 - 36*D1**2*b1*f*fd*r**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 36*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd + 18*D1**2*b1*f*fdd*r**2 + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 18*D1**2*b1*fd**2*r**2 + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r + 18*D1**2*b1*fd**2*s**2 - 18*D1**2*b1*fd**2*s + D1**2*bdd1*f**2*(7*f + 9)*(r + s - 1)**2 - 6*D1**2*f**2*fd*r**2 - 12*D1**2*f**2*fd*r*s + 8*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 8*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 6*D1**2*f**2*fdd*r*s - 4*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 4*D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 12*D1**2*f*fd**2*r*s - 8*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 8*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 - 56*D1*Dd*b1*f**3*r**2 - 112*D1*Dd*b1*f**3*r*s + 84*D1*Dd*b1*f**3*r - 56*D1*Dd*b1*f**3*s**2 + 84*D1*Dd*b1*f**3*s - 42*D1*Dd*b1*f**3 + 168*D1*Dd*b1*f**2*fd*r**2 + 336*D1*Dd*b1*f**2*fd*r*s - 238*D1*Dd*b1*f**2*fd*r + 168*D1*Dd*b1*f**2*fd*s**2 - 238*D1*Dd*b1*f**2*fd*s + 84*D1*Dd*b1*f**2*fd - 72*D1*Dd*b1*f**2*r**2 - 144*D1*Dd*b1*f**2*r*s + 108*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 108*D1*Dd*b1*f**2*s - 54*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r**2 + 288*D1*Dd*b1*f*fd*r*s - 180*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 180*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd - 8*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 48*D1*Dd*f**2*fd*r*s - 34*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 34*D1*Dd*f**2*fd*s + 12*D1*Dd*f**2*fd + 28*D1*Ddd*b1*f**3*r**2 + 56*D1*Ddd*b1*f**3*r*s - 42*D1*Ddd*b1*f**3*r + 28*D1*Ddd*b1*f**3*s**2 - 42*D1*Ddd*b1*f**3*s + 21*D1*Ddd*b1*f**3 + 36*D1*Ddd*b1*f**2*r**2 + 72*D1*Ddd*b1*f**2*r*s - 54*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 54*D1*Ddd*b1*f**2*s + 27*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 8*D1*Ddd*f**3*r*s - 6*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 6*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) + 9*f*(r + s - 1) - 9*fd*(2*r + 2*s - 1)) - Dd*f*(7*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 84*Dd**2*b1*f**3*r**2 + 168*Dd**2*b1*f**3*r*s - 126*Dd**2*b1*f**3*r + 84*Dd**2*b1*f**3*s**2 - 126*Dd**2*b1*f**3*s + 42*Dd**2*b1*f**3 + 108*Dd**2*b1*f**2*r**2 + 216*Dd**2*b1*f**2*r*s - 162*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 162*Dd**2*b1*f**2*s + 54*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 24*Dd**2*f**3*r*s - 18*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 18*Dd**2*f**3*s + 6*Dd**2*f**3)/(126*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct*k1*k2**3*st**4*(-12*C*D1**2*bdd1*f**2*r**2 - 24*C*D1**2*bdd1*f**2*r*s - 12*C*D1**2*bdd1*f**2*s**2 - 204*C*D1**2*f**2*fd*r**2 - 408*C*D1**2*f**2*fd*r*s + 272*C*D1**2*f**2*fd*r - 204*C*D1**2*f**2*fd*s**2 + 272*C*D1**2*f**2*fd*s - 136*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r**2 + 240*C*D1**2*f**2*fdd*r*s - 160*C*D1**2*f**2*fdd*r + 120*C*D1**2*f**2*fdd*s**2 - 160*C*D1**2*f**2*fdd*s + 80*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r**2 + 480*C*D1**2*f*fd**2*r*s - 320*C*D1**2*f*fd**2*r + 240*C*D1**2*f*fd**2*s**2 - 320*C*D1**2*f*fd**2*s + 80*C*D1**2*f*fd**2 - 272*C*D1*Dd*f**3*r**2 - 544*C*D1*Dd*f**3*r*s + 408*C*D1*Dd*f**3*r - 272*C*D1*Dd*f**3*s**2 + 408*C*D1*Dd*f**3*s - 204*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r**2 + 1920*C*D1*Dd*f**2*fd*r*s - 1360*C*D1*Dd*f**2*fd*r + 960*C*D1*Dd*f**2*fd*s**2 - 1360*C*D1*Dd*f**2*fd*s + 480*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r**2 + 320*C*D1*Ddd*f**3*r*s - 240*C*D1*Ddd*f**3*r + 160*C*D1*Ddd*f**3*s**2 - 240*C*D1*Ddd*f**3*s + 120*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r**2 + 960*C*Dd**2*f**3*r*s - 720*C*Dd**2*f**3*r + 480*C*Dd**2*f**3*s**2 - 720*C*Dd**2*f**3*s + 240*C*Dd**2*f**3 + 60*D1**2*K*bdd1*f**2*r**2 + 120*D1**2*K*bdd1*f**2*r*s - 120*D1**2*K*bdd1*f**2*r + 60*D1**2*K*bdd1*f**2*s**2 - 120*D1**2*K*bdd1*f**2*s + 60*D1**2*K*bdd1*f**2 - 156*D1**2*b2*f*fd*r**2 - 312*D1**2*b2*f*fd*r*s + 156*D1**2*b2*f*fd*r - 156*D1**2*b2*f*fd*s**2 + 156*D1**2*b2*f*fd*s - 78*D1**2*b2*f*fd + 120*D1**2*b2*f*fdd*r**2 + 240*D1**2*b2*f*fdd*r*s - 120*D1**2*b2*f*fdd*r + 120*D1**2*b2*f*fdd*s**2 - 120*D1**2*b2*f*fdd*s + 60*D1**2*b2*f*fdd + 120*D1**2*b2*fd**2*r**2 + 240*D1**2*b2*fd**2*r*s - 120*D1**2*b2*fd**2*r + 120*D1**2*b2*fd**2*s**2 - 120*D1**2*b2*fd**2*s + 6*D1**2*bd1**2*f*(r + s - 1)*(-14*K*(r + s) + 5*f + 7) - 78*D1**2*bd2*f**2*r**2 - 156*D1**2*bd2*f**2*r*s + 156*D1**2*bd2*f**2*r - 78*D1**2*bd2*f**2*s**2 + 156*D1**2*bd2*f**2*s - 78*D1**2*bd2*f**2 + 240*D1**2*bd2*f*fd*r**2 + 480*D1**2*bd2*f*fd*r*s - 360*D1**2*bd2*f*fd*r + 240*D1**2*bd2*f*fd*s**2 - 360*D1**2*bd2*f*fd*s + 120*D1**2*bd2*f*fd + 6*D1**2*bdd1*f**2*r**2 + 12*D1**2*bdd1*f**2*r*s + 6*D1**2*bdd1*f**2*r + 6*D1**2*bdd1*f**2*s**2 + 6*D1**2*bdd1*f**2*s - 3*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*g2*r**2 + 168*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*s**2 + 60*D1**2*bdd2*f**2*r**2 + 120*D1**2*bdd2*f**2*r*s - 120*D1**2*bdd2*f**2*r + 60*D1**2*bdd2*f**2*s**2 - 120*D1**2*bdd2*f**2*s + 60*D1**2*bdd2*f**2 + 93*D1**2*f**2*fd*r**2 + 186*D1**2*f**2*fd*r*s - 124*D1**2*f**2*fd*r + 93*D1**2*f**2*fd*s**2 - 124*D1**2*f**2*fd*s + 62*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd + 156*D1**2*f**2*gd2*r**2 + 312*D1**2*f**2*gd2*r*s - 312*D1**2*f**2*gd2*r + 156*D1**2*f**2*gd2*s**2 - 312*D1**2*f**2*gd2*s + 156*D1**2*f**2*gd2 - 120*D1**2*f**2*gdd2*r**2 - 240*D1**2*f**2*gdd2*r*s + 240*D1**2*f**2*gdd2*r - 120*D1**2*f**2*gdd2*s**2 + 240*D1**2*f**2*gdd2*s - 120*D1**2*f**2*gdd2 - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 312*D1**2*f*fd*g2*r**2 + 624*D1**2*f*fd*g2*r*s - 312*D1**2*f*fd*g2*r + 312*D1**2*f*fd*g2*s**2 - 312*D1**2*f*fd*g2*s + 156*D1**2*f*fd*g2 - 480*D1**2*f*fd*gd2*r**2 - 960*D1**2*f*fd*gd2*r*s + 720*D1**2*f*fd*gd2*r - 480*D1**2*f*fd*gd2*s**2 + 720*D1**2*f*fd*gd2*s - 240*D1**2*f*fd*gd2 - 240*D1**2*f*fdd*g2*r**2 - 480*D1**2*f*fdd*g2*r*s + 240*D1**2*f*fdd*g2*r - 240*D1**2*f*fdd*g2*s**2 + 240*D1**2*f*fdd*g2*s - 120*D1**2*f*fdd*g2 - 240*D1**2*fd**2*g2*r**2 - 480*D1**2*fd**2*g2*r*s + 240*D1**2*fd**2*g2*r - 240*D1**2*fd**2*g2*s**2 + 240*D1**2*fd**2*g2*s - 312*D1*Dd*b2*f**2*r**2 - 624*D1*Dd*b2*f**2*r*s + 468*D1*Dd*b2*f**2*r - 312*D1*Dd*b2*f**2*s**2 + 468*D1*Dd*b2*f**2*s - 234*D1*Dd*b2*f**2 + 960*D1*Dd*b2*f*fd*r**2 + 1920*D1*Dd*b2*f*fd*r*s - 1200*D1*Dd*b2*f*fd*r + 960*D1*Dd*b2*f*fd*s**2 - 1200*D1*Dd*b2*f*fd*s + 360*D1*Dd*b2*f*fd + 480*D1*Dd*bd2*f**2*r**2 + 960*D1*Dd*bd2*f**2*r*s - 840*D1*Dd*bd2*f**2*r + 480*D1*Dd*bd2*f**2*s**2 - 840*D1*Dd*bd2*f**2*s + 360*D1*Dd*bd2*f**2 + 124*D1*Dd*f**3*r**2 + 248*D1*Dd*f**3*r*s - 186*D1*Dd*f**3*r + 124*D1*Dd*f**3*s**2 - 186*D1*Dd*f**3*s + 93*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 680*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 680*D1*Dd*f**2*fd*s - 240*D1*Dd*f**2*fd + 624*D1*Dd*f**2*g2*r**2 + 1248*D1*Dd*f**2*g2*r*s - 936*D1*Dd*f**2*g2*r + 624*D1*Dd*f**2*g2*s**2 - 936*D1*Dd*f**2*g2*s + 468*D1*Dd*f**2*g2 - 960*D1*Dd*f**2*gd2*r**2 - 1920*D1*Dd*f**2*gd2*r*s + 1680*D1*Dd*f**2*gd2*r - 960*D1*Dd*f**2*gd2*s**2 + 1680*D1*Dd*f**2*gd2*s - 720*D1*Dd*f**2*gd2 - 1920*D1*Dd*f*fd*g2*r**2 - 3840*D1*Dd*f*fd*g2*r*s + 2400*D1*Dd*f*fd*g2*r - 1920*D1*Dd*f*fd*g2*s**2 + 2400*D1*Dd*f*fd*g2*s - 720*D1*Dd*f*fd*g2 + 240*D1*Ddd*b2*f**2*r**2 + 480*D1*Ddd*b2*f**2*r*s - 360*D1*Ddd*b2*f**2*r + 240*D1*Ddd*b2*f**2*s**2 - 360*D1*Ddd*b2*f**2*s + 180*D1*Ddd*b2*f**2 - 80*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 120*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 - 480*D1*Ddd*f**2*g2*r**2 - 960*D1*Ddd*f**2*g2*r*s + 720*D1*Ddd*f**2*g2*r - 480*D1*Ddd*f**2*g2*s**2 + 720*D1*Ddd*f**2*g2*s - 360*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*(r + s - 1)**2 + f**2*(-8*C*s**2 + 26*K*(r + s - 1)**2 + r**2*(11 - 8*C) - 2*r*(8*C*s - 11*s + 5) + 11*s**2 - 10*s + 5) - 2*f*(fd*(r + s - 1)*(-8*C*s + 20*K*(2*r + 2*s - 1) + r*(4 - 8*C) + 4*s + 1) + (28*r + 28*s)*(-g2*(r + s) + gd2*(r + s - 1))) - 56*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(f*(-4*C*r - 4*C*s + 20*K*(r + s - 1) + 2*r + 2*s + 1) + 28*g2*(r + s))*(4*r + 4*s - 3)) + 720*Dd**2*b2*f**2*r**2 + 1440*Dd**2*b2*f**2*r*s - 1080*Dd**2*b2*f**2*r + 720*Dd**2*b2*f**2*s**2 - 1080*Dd**2*b2*f**2*s + 360*Dd**2*b2*f**2 - 240*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 360*Dd**2*f**3*s - 120*Dd**2*f**3 - 1440*Dd**2*f**2*g2*r**2 - 2880*Dd**2*f**2*g2*r*s + 2160*Dd**2*f**2*g2*r - 1440*Dd**2*f**2*g2*s**2 + 2160*Dd**2*f**2*g2*s - 720*Dd**2*f**2*g2 - 3*b1**2*(D1**2*(10*fd**2*(r + s - 1) - 2*fd*(14*K*(r + s - 1)**2 + 5*f*(2*r + 2*s - 1) + 14*r + 14*s - 7) + fdd*(14*K*(r + s - 1)**2 + 5*f*(2*r + 2*s - 1) + 14*r + 14*s - 7)) + 2*D1*(Dd*(-14*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(4*r + 4*s - 3)*(14*K*(r + s - 1) + 5*f + 7)) + 7*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 84*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(-16*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 32*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s - 16*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r**2 + 16*C*D1**2*f*fdd*r*s - 16*C*D1**2*f*fdd*r + 8*C*D1**2*f*fdd*s**2 - 16*C*D1**2*f*fdd*s + 8*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r**2 + 16*C*D1**2*fd**2*r*s - 16*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s**2 - 16*C*D1**2*fd**2*s + 8*C*D1**2*fd**2 - 32*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r**2 + 128*C*D1*Dd*f*fd*r*s - 112*C*D1*Dd*f*fd*r + 64*C*D1*Dd*f*fd*s**2 - 112*C*D1*Dd*f*fd*s + 48*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r**2 + 32*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s**2 - 24*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r**2 + 96*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s**2 - 72*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 + 52*D1**2*K*f*fd*r**2 + 104*D1**2*K*f*fd*r*s - 52*D1**2*K*f*fd*r + 52*D1**2*K*f*fd*s**2 - 52*D1**2*K*f*fd*s + 26*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r**2 - 80*D1**2*K*f*fdd*r*s + 40*D1**2*K*f*fdd*r - 40*D1**2*K*f*fdd*s**2 + 40*D1**2*K*f*fdd*s - 20*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r**2 - 80*D1**2*K*fd**2*r*s + 40*D1**2*K*fd**2*r - 40*D1**2*K*fd**2*s**2 + 40*D1**2*K*fd**2*s + D1**2*bdd1*f*(7*K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 5*f*(2*r + 2*s - 1) - 14*r - 14*s + 7) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 34*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 34*D1**2*f*fd*s + 17*D1**2*f*fd - 4*D1**2*f*fdd*r**2 - 8*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 4*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd + 56*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*r + 56*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 56*D1**2*f*gd2 - 28*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*r - 28*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 28*D1**2*f*gdd2 - 4*D1**2*fd**2*r**2 - 8*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 4*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s - 6*D1**2*fd**2 + 56*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s - 112*D1**2*fd*g2*r + 56*D1**2*fd*g2*s**2 - 112*D1**2*fd*g2*s + 56*D1**2*fd*g2 - 56*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 112*D1**2*fd*gd2*s - 56*D1**2*fd*gd2 - 28*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s + 56*D1**2*fdd*g2*r - 28*D1**2*fdd*g2*s**2 + 56*D1**2*fdd*g2*s - 28*D1**2*fdd*g2 + 104*D1*Dd*K*f**2*r**2 + 208*D1*Dd*K*f**2*r*s - 156*D1*Dd*K*f**2*r + 104*D1*Dd*K*f**2*s**2 - 156*D1*Dd*K*f**2*s + 78*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r**2 - 640*D1*Dd*K*f*fd*r*s + 400*D1*Dd*K*f*fd*r - 320*D1*Dd*K*f*fd*s**2 + 400*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 32*D1*Dd*f*fd*r**2 - 64*D1*Dd*f*fd*r*s + 64*D1*Dd*f*fd*r - 32*D1*Dd*f*fd*s**2 + 64*D1*Dd*f*fd*s - 30*D1*Dd*f*fd + 224*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 392*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 392*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s + 392*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 392*D1*Dd*fd*g2*s - 168*D1*Dd*fd*g2 - 80*D1*Ddd*K*f**2*r**2 - 160*D1*Ddd*K*f**2*r*s + 120*D1*Ddd*K*f**2*r - 80*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 - 8*D1*Ddd*f**2*r**2 - 16*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r - 8*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*f**2*(2*r + 2*s - 1) - 7*f*(K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 2*r - 2*s + 1) + 7*fd*(K*(4*r + 4*s - 2) + 1)*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(7*K*(4*r + 4*s - 2) - 5*f - 7)) - 240*Dd**2*K*f**2*r**2 - 480*Dd**2*K*f**2*r*s + 360*Dd**2*K*f**2*r - 240*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 - 24*Dd**2*f**2*r**2 - 48*Dd**2*f**2*r*s + 36*Dd**2*f**2*r - 24*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s - 12*Dd**2*f**2 - 336*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1*k2**3*st**2*(D1*(-14*D1*bd1**2*(r + s - 1)*(6*K*f*(r + s - 2) - f*(4*C - 3)*(r + s) + 20*g2*(r + s)) + 14*b2*(bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + bd1*(-168*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(4*C*(25*r**2 + r*(50*s - 58) + 25*s**2 - 58*s + 29) - 42*K*(r + s - 1)**2 - 50*r**2 - 100*r*s + 102*r - 50*s**2 + 102*s - 51) - 4*f*(fd*(36*C - 18)*(r + s - 1)**2 + 7*g2*(11*r**2 + 2*r*(11*s - 7) + 11*s**2 - 14*s + 7) - 42*gd2*(r**2 + r*(2*s - 3) + s**2 - 3*s + 2)) + 168*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 12*Dd*f*(f*(6*C - 3) - 14*g2)*(4*r**2 + r*(8*s - 11) + 4*s**2 - 11*s + 6)) - 6*f*(18*C*D1*f*fd*r**2 + 36*C*D1*f*fd*r*s - 24*C*D1*f*fd*r + 18*C*D1*f*fd*s**2 - 24*C*D1*f*fd*s + 12*C*D1*f*fd + 24*C*Dd*f**2*r**2 + 48*C*Dd*f**2*r*s - 36*C*Dd*f**2*r + 24*C*Dd*f**2*s**2 - 36*C*Dd*f**2*s + 18*C*Dd*f**2 + 7*D1*bd2*f*(r + s - 1)**2 + D1*bdd1*(f*(6*C - 3) - 14*g2)*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) - 9*D1*f*fd*r**2 - 18*D1*f*fd*r*s + 12*D1*f*fd*r - 9*D1*f*fd*s**2 + 12*D1*f*fd*s - 6*D1*f*fd - 14*D1*f*gd2*r**2 - 28*D1*f*gd2*r*s + 28*D1*f*gd2*r - 14*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 14*D1*f*gd2 - 28*D1*fd*g2*r**2 - 56*D1*fd*g2*r*s + 28*D1*fd*g2*r - 28*D1*fd*g2*s**2 + 28*D1*fd*g2*s - 14*D1*fd*g2 - 12*Dd*f**2*r**2 - 24*Dd*f**2*r*s + 18*Dd*f**2*r - 12*Dd*f**2*s**2 + 18*Dd*f**2*s - 9*Dd*f**2 - 56*Dd*f*g2*r**2 - 112*Dd*f*g2*r*s + 84*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 84*Dd*f*g2*s - 42*Dd*f*g2)) + 7*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (10*K - 5)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-10*K + 3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-10*K + 3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-8*C*D1**2*fd*r**2 - 16*C*D1**2*fd*r*s + 16*C*D1**2*fd*r - 8*C*D1**2*fd*s**2 + 16*C*D1**2*fd*s - 8*C*D1**2*fd + 4*C*D1**2*fdd*r**2 + 8*C*D1**2*fdd*r*s - 8*C*D1**2*fdd*r + 4*C*D1**2*fdd*s**2 - 8*C*D1**2*fdd*s + 4*C*D1**2*fdd - 32*C*D1*Dd*f*r**2 - 64*C*D1*Dd*f*r*s + 48*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 + 48*C*D1*Dd*f*s - 24*C*D1*Dd*f + 32*C*D1*Dd*fd*r**2 + 64*C*D1*Dd*fd*r*s - 56*C*D1*Dd*fd*r + 32*C*D1*Dd*fd*s**2 - 56*C*D1*Dd*fd*s + 24*C*D1*Dd*fd + 16*C*D1*Ddd*f*r**2 + 32*C*D1*Ddd*f*r*s - 24*C*D1*Ddd*f*r + 16*C*D1*Ddd*f*s**2 - 24*C*D1*Ddd*f*s + 12*C*D1*Ddd*f + 48*C*Dd**2*f*r**2 + 96*C*Dd**2*f*r*s - 72*C*Dd**2*f*r + 48*C*Dd**2*f*s**2 - 72*C*Dd**2*f*s + 24*C*Dd**2*f + 22*D1**2*K*fd*r**2 + 44*D1**2*K*fd*r*s - 16*D1**2*K*fd*r + 22*D1**2*K*fd*s**2 - 16*D1**2*K*fd*s + 8*D1**2*K*fd - 6*D1**2*K*fdd*r**2 - 12*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r - 6*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - D1**2*bdd1*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 6*D1**2*f*fd*r + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 6*D1**2*fd*r**2 + 12*D1**2*fd*r*s - 2*D1**2*fd*r + 6*D1**2*fd*s**2 - 2*D1**2*fd*s + D1**2*fd - 3*D1**2*fdd*r**2 - 6*D1**2*fdd*r*s + 6*D1**2*fdd*r - 3*D1**2*fdd*s**2 + 6*D1**2*fdd*s - 3*D1**2*fdd + 40*D1**2*gd2*r**2 + 80*D1**2*gd2*r*s - 80*D1**2*gd2*r + 40*D1**2*gd2*s**2 - 80*D1**2*gd2*s + 40*D1**2*gd2 - 20*D1**2*gdd2*r**2 - 40*D1**2*gdd2*r*s + 40*D1**2*gdd2*r - 20*D1**2*gdd2*s**2 + 40*D1**2*gdd2*s - 20*D1**2*gdd2 + 88*D1*Dd*K*f*r**2 + 176*D1*Dd*K*f*r*s - 132*D1*Dd*K*f*r + 88*D1*Dd*K*f*s**2 - 132*D1*Dd*K*f*s + 66*D1*Dd*K*f - 48*D1*Dd*K*fd*r**2 - 96*D1*Dd*K*fd*r*s - 12*D1*Dd*K*fd*r - 48*D1*Dd*K*fd*s**2 - 12*D1*Dd*K*fd*s + 36*D1*Dd*K*fd + 24*D1*Dd*f*r**2 + 48*D1*Dd*f*r*s - 36*D1*Dd*f*r + 24*D1*Dd*f*s**2 - 36*D1*Dd*f*s + 18*D1*Dd*f - 24*D1*Dd*fd*r**2 - 48*D1*Dd*fd*r*s + 42*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 42*D1*Dd*fd*s - 18*D1*Dd*fd + 160*D1*Dd*g2*r**2 + 320*D1*Dd*g2*r*s - 240*D1*Dd*g2*r + 160*D1*Dd*g2*s**2 - 240*D1*Dd*g2*s + 120*D1*Dd*g2 - 160*D1*Dd*gd2*r**2 - 320*D1*Dd*gd2*r*s + 280*D1*Dd*gd2*r - 160*D1*Dd*gd2*s**2 + 280*D1*Dd*gd2*s - 120*D1*Dd*gd2 - 24*D1*Ddd*K*f*r**2 - 48*D1*Ddd*K*f*r*s + 36*D1*Ddd*K*f*r - 24*D1*Ddd*K*f*s**2 + 36*D1*Ddd*K*f*s - 18*D1*Ddd*K*f - 12*D1*Ddd*f*r**2 - 24*D1*Ddd*f*r*s + 18*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 18*D1*Ddd*f*s - 9*D1*Ddd*f - 80*D1*Ddd*g2*r**2 - 160*D1*Ddd*g2*r*s + 120*D1*Ddd*g2*r - 80*D1*Ddd*g2*s**2 + 120*D1*Ddd*g2*s - 60*D1*Ddd*g2 + 2*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (10*K - 5)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-10*K + 3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 72*Dd**2*K*f*r**2 - 144*Dd**2*K*f*r*s + 108*Dd**2*K*f*r - 72*Dd**2*K*f*s**2 + 108*Dd**2*K*f*s - 36*Dd**2*K*f - 36*Dd**2*f*r**2 - 72*Dd**2*f*r*s + 54*Dd**2*f*r - 36*Dd**2*f*s**2 + 54*Dd**2*f*s - 18*Dd**2*f - 240*Dd**2*g2*r**2 - 480*Dd**2*g2*r*s + 360*Dd**2*g2*r - 240*Dd**2*g2*s**2 + 360*Dd**2*g2*s - 120*Dd**2*g2) - b1*(-56*C*D1**2*bdd1*f*r**2 - 112*C*D1**2*bdd1*f*r*s + 56*C*D1**2*bdd1*f*r - 56*C*D1**2*bdd1*f*s**2 + 56*C*D1**2*bdd1*f*s - 28*C*D1**2*bdd1*f - 200*C*D1**2*f*fd*r**2 - 400*C*D1**2*f*fd*r*s + 168*C*D1**2*f*fd*r - 200*C*D1**2*f*fd*s**2 + 168*C*D1**2*f*fd*s - 84*C*D1**2*f*fd + 72*C*D1**2*f*fdd*r**2 + 144*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*s**2 + 72*C*D1**2*fd**2*r**2 + 144*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2 - 400*C*D1*Dd*f**2*r**2 - 800*C*D1*Dd*f**2*r*s + 600*C*D1*Dd*f**2*r - 400*C*D1*Dd*f**2*s**2 + 600*C*D1*Dd*f**2*s - 300*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 + 1152*C*D1*Dd*f*fd*r*s - 432*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 432*C*D1*Dd*f*fd*s + 144*C*D1*Ddd*f**2*r**2 + 288*C*D1*Ddd*f**2*r*s - 216*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 216*C*D1*Ddd*f**2*s + 108*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r**2 + 864*C*Dd**2*f**2*r*s - 648*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 648*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 + 84*D1**2*K*bdd1*f*r**2 + 168*D1**2*K*bdd1*f*r*s - 252*D1**2*K*bdd1*f*r + 84*D1**2*K*bdd1*f*s**2 - 252*D1**2*K*bdd1*f*s + 126*D1**2*K*bdd1*f + 84*D1**2*K*f*fd*r**2 + 168*D1**2*K*f*fd*r*s - 84*D1**2*K*f*fd*r + 84*D1**2*K*f*fd*s**2 - 84*D1**2*K*f*fd*s + 42*D1**2*K*f*fd - 98*D1**2*b2*fd*r**2 - 196*D1**2*b2*fd*r*s - 98*D1**2*b2*fd*s**2 + 84*D1**2*b2*fdd*r**2 + 168*D1**2*b2*fdd*r*s + 84*D1**2*b2*fdd*s**2 + 14*D1**2*bd1**2*(-10*K + 3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 42*D1**2*bdd1*f*r**2 + 84*D1**2*bdd1*f*r*s - 42*D1**2*bdd1*f*r + 42*D1**2*bdd1*f*s**2 - 42*D1**2*bdd1*f*s + 21*D1**2*bdd1*f + 280*D1**2*bdd1*g2*r**2 + 560*D1**2*bdd1*g2*r*s - 280*D1**2*bdd1*g2*r + 280*D1**2*bdd1*g2*s**2 - 280*D1**2*bdd1*g2*s + 140*D1**2*bdd1*g2 + 84*D1**2*bdd2*f*r**2 + 168*D1**2*bdd2*f*r*s - 168*D1**2*bdd2*f*r + 84*D1**2*bdd2*f*s**2 - 168*D1**2*bdd2*f*s + 84*D1**2*bdd2*f + 100*D1**2*f*fd*r**2 + 200*D1**2*f*fd*r*s - 98*D1**2*f*fd*r + 100*D1**2*f*fd*s**2 - 98*D1**2*f*fd*s + 49*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*s**2 + 308*D1**2*f*gd2*r**2 + 616*D1**2*f*gd2*r*s - 616*D1**2*f*gd2*r + 308*D1**2*f*gd2*s**2 - 616*D1**2*f*gd2*s + 308*D1**2*f*gd2 - 84*D1**2*f*gdd2*r**2 - 168*D1**2*f*gdd2*r*s + 168*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s - 84*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2 + 308*D1**2*fd*g2*r**2 + 616*D1**2*fd*g2*r*s - 224*D1**2*fd*g2*r + 308*D1**2*fd*g2*s**2 - 224*D1**2*fd*g2*s + 112*D1**2*fd*g2 - 168*D1**2*fd*gd2*r**2 - 336*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*s**2 + 168*D1**2*fd*gd2 - 84*D1**2*fdd*g2*r**2 - 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r - 84*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 + 168*D1*Dd*K*f**2*r**2 + 336*D1*Dd*K*f**2*r*s - 252*D1*Dd*K*f**2*r + 168*D1*Dd*K*f**2*s**2 - 252*D1*Dd*K*f**2*s + 126*D1*Dd*K*f**2 - 392*D1*Dd*b2*f*r**2 - 784*D1*Dd*b2*f*r*s + 588*D1*Dd*b2*f*r - 392*D1*Dd*b2*f*s**2 + 588*D1*Dd*b2*f*s - 294*D1*Dd*b2*f + 672*D1*Dd*b2*fd*r**2 + 1344*D1*Dd*b2*fd*r*s - 504*D1*Dd*b2*fd*r + 672*D1*Dd*b2*fd*s**2 - 504*D1*Dd*b2*fd*s + 200*D1*Dd*f**2*r**2 + 400*D1*Dd*f**2*r*s - 300*D1*Dd*f**2*r + 200*D1*Dd*f**2*s**2 - 300*D1*Dd*f**2*s + 150*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 216*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 216*D1*Dd*f*fd*s + 1232*D1*Dd*f*g2*r**2 + 2464*D1*Dd*f*g2*r*s - 1848*D1*Dd*f*g2*r + 1232*D1*Dd*f*g2*s**2 - 1848*D1*Dd*f*g2*s + 924*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r**2 - 1344*D1*Dd*f*gd2*r*s + 1176*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1176*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r**2 - 1344*D1*Dd*fd*g2*r*s - 168*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 + 336*D1*Ddd*b2*f*r**2 + 672*D1*Ddd*b2*f*r*s - 504*D1*Ddd*b2*f*r + 336*D1*Ddd*b2*f*s**2 - 504*D1*Ddd*b2*f*s + 252*D1*Ddd*b2*f - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r**2 - 672*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(f**2*(6*r + 6*s - 3) + f*(8*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*K*(11*r**2 + 22*r*s - 18*r + 11*s**2 - 18*s + 9) - 12*r**2 - 24*r*s + 22*r - 12*s**2 + 22*s - 11) - 2*fd*(r + s - 1)*(C*(8*r + 8*s - 4) - 6*K*(2*r + 2*s + 1) - 6*r - 6*s + 3) - 40*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 40*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(C*(8*r + 8*s - 4) - 6*K*(2*r + 2*s - 3) - 6*r - 6*s + 3) - 20*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 14*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 1008*Dd**2*b2*f*r**2 + 2016*Dd**2*b2*f*r*s - 1512*Dd**2*b2*f*r + 1008*Dd**2*b2*f*s**2 - 1512*Dd**2*b2*f*s + 504*Dd**2*b2*f - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 - 1008*Dd**2*f*g2*r**2 - 2016*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(210*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct*k1*k2**3*(2*D1**2*bd1*(5*b2*f*(r + s - 1) + (-2*bd1*(r + s) + f*(r + s - 1))*(f*(6*C - 3) - 10*g2))*(r + s - 1) + D1*b1*(24*C*D1*f*fd*r**2 + 48*C*D1*f*fd*r*s - 24*C*D1*f*fd*r + 24*C*D1*f*fd*s**2 - 24*C*D1*f*fd*s + 12*C*D1*f*fd + 48*C*Dd*f**2*r**2 + 96*C*Dd*f**2*r*s - 72*C*Dd*f**2*r + 48*C*Dd*f**2*s**2 - 72*C*Dd*f**2*s + 36*C*Dd*f**2 - 20*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 10*D1*b2*fd*r**2 + 20*D1*b2*fd*r*s + 10*D1*b2*fd*s**2 + 10*D1*bd2*f*(r + s - 1)**2 - 2*D1*bdd1*(6*C*f - 3*f - 10*g2)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*D1*f*fd*r**2 - 24*D1*f*fd*r*s + 12*D1*f*fd*r - 12*D1*f*fd*s**2 + 12*D1*f*fd*s - 6*D1*f*fd - 20*D1*f*gd2*r**2 - 40*D1*f*gd2*r*s + 40*D1*f*gd2*r - 20*D1*f*gd2*s**2 + 40*D1*f*gd2*s - 20*D1*f*gd2 - 20*D1*fd*g2*r**2 - 40*D1*fd*g2*r*s - 20*D1*fd*g2*s**2 + 40*Dd*b2*f*r**2 + 80*Dd*b2*f*r*s - 60*Dd*b2*f*r + 40*Dd*b2*f*s**2 - 60*Dd*b2*f*s + 30*Dd*b2*f - 24*Dd*f**2*r**2 - 48*Dd*f**2*r*s + 36*Dd*f**2*r - 24*Dd*f**2*s**2 + 36*Dd*f**2*s - 18*Dd*f**2 - 80*Dd*f*g2*r**2 - 160*Dd*f*g2*r*s + 120*Dd*f*g2*r - 80*Dd*f*g2*s**2 + 120*Dd*f*g2*s - 60*Dd*f*g2 + bd1*(D1*(f*(-16*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*K*(r + s - 1)**2 + 26*r**2 + 52*r*s - 26*r + 26*s**2 - 26*s + 13) + fd*(12 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 40*g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) + 40*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(f*(6*C - 3) - 10*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 5*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(-8*K + f + 3) - 2*Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(-10*K*bdd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(-16*C*(r + s - 1)**2 + 10*K*s**2 + r**2*(10*K + 13) + r*(20*K*s + 26*s - 26) + 13*s**2 - 26*s + 13) + fdd*(6 - 12*C)*(r + s - 1)**2 + 80*gd2*(r + s - 1)**2 + 20*gdd2*(r + s - 1)**2) + 5*D1*bd1*(D1*(-8*K + f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 4*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(-f*(16*C - 10*K - 13)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(12 - 24*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 80*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 40*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - 2*Ddd*(f*(6*C - 3) - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*(f*(6*C - 3) - 10*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(30*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1*k2*st**4*(D1*f*(r + s)*(2*D1*bd1**2*(5*f + 7)*(r + s - 1) + D1*bdd1*f*(r + s) + bd1*(-2*D1*f*(r + s) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(10*fd**2 + fd*(-20*f - 14) + fdd*(10*f + 7))*(r + s - 1)**2 + D1*(-2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-10*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) - 7*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(5*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(5*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*bdd1*f*(5*f + 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 4*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 4*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 4*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 4*D1**2*f*fdd*s + 2*D1**2*f*fdd + 2*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 4*D1**2*fd**2*s + 2*D1**2*fd**2 - 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 32*D1*Dd*f*fd*r*s - 28*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 28*D1*Dd*f*fd*s + 12*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 - 2*D1*bd1*(D1*(5*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(-10*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 14*r**2 + 28*r*s - 14*r + 14*s**2 - 14*s + 7) - 7*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - Dd*f*(5*f + 7)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 12*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 18*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s + 6*Dd**2*f**2))/(70*d**2*k3**2) - D1**2*Pk2*Pkdd3*ct*k1*k2*st**2*(D1*(r + s)*(14*D1*bd1**2*f*(6*K - 1)*(r + s - 1) + 6*D1*bdd1*f*(r + s)*(7*b2 + f*(6*C - 3) - 14*g2) + bd1*(-44*C*D1*f**2*r - 44*C*D1*f**2*s + 144*C*D1*f*fd*r + 144*C*D1*f*fd*s - 144*C*D1*f*fd + 288*C*Dd*f**2*r + 288*C*Dd*f**2*s - 216*C*Dd*f**2 + 84*D1*bd2*f*(r + s - 1) + 15*D1*f**2*r + 15*D1*f**2*s - 72*D1*f*fd*r - 72*D1*f*fd*s + 72*D1*f*fd + 28*D1*f*g2*r + 28*D1*f*g2*s - 168*D1*f*gd2*r - 168*D1*f*gd2*s + 168*D1*f*gd2 - 168*D1*fd*g2*r - 168*D1*fd*g2*s + 168*D1*fd*g2 - 144*Dd*f**2*r - 144*Dd*f**2*s + 108*Dd*f**2 - 672*Dd*f*g2*r - 672*Dd*f*g2*s + 504*Dd*f*g2 + 14*b2*(-D1*f*(r + s) + 6*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3)))) + 7*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 20*r**2 + 40*r*s - 30*r + 20*s**2 - 30*s + 15) - Ddd*(3*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(3*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-2*D1**2*K*fd*r**2 - 4*D1**2*K*fd*r*s + 4*D1**2*K*fd*r - 2*D1**2*K*fd*s**2 + 4*D1**2*K*fd*s - 2*D1**2*K*fd + 6*D1**2*K*fdd*r**2 + 12*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r + 6*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - D1**2*bdd1*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 6*D1**2*f*fd - 3*D1**2*fd*r**2 - 6*D1**2*fd*r*s + 6*D1**2*fd*r - 3*D1**2*fd*s**2 + 6*D1**2*fd*s - 3*D1**2*fd - D1**2*fdd*r**2 - 2*D1**2*fdd*r*s + 2*D1**2*fdd*r - D1**2*fdd*s**2 + 2*D1**2*fdd*s - D1**2*fdd - 8*D1*Dd*K*f*r**2 - 16*D1*Dd*K*f*r*s + 12*D1*Dd*K*f*r - 8*D1*Dd*K*f*s**2 + 12*D1*Dd*K*f*s - 6*D1*Dd*K*f + 48*D1*Dd*K*fd*r**2 + 96*D1*Dd*K*fd*r*s - 84*D1*Dd*K*fd*r + 48*D1*Dd*K*fd*s**2 - 84*D1*Dd*K*fd*s + 36*D1*Dd*K*fd - 12*D1*Dd*f**2*r**2 - 24*D1*Dd*f**2*r*s + 18*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 18*D1*Dd*f**2*s - 9*D1*Dd*f**2 - 12*D1*Dd*f*r**2 - 24*D1*Dd*f*r*s + 18*D1*Dd*f*r - 12*D1*Dd*f*s**2 + 18*D1*Dd*f*s - 9*D1*Dd*f - 8*D1*Dd*fd*r**2 - 16*D1*Dd*fd*r*s + 14*D1*Dd*fd*r - 8*D1*Dd*fd*s**2 + 14*D1*Dd*fd*s - 6*D1*Dd*fd + 24*D1*Ddd*K*f*r**2 + 48*D1*Ddd*K*f*r*s - 36*D1*Ddd*K*f*r + 24*D1*Ddd*K*f*s**2 - 36*D1*Ddd*K*f*s + 18*D1*Ddd*K*f - 4*D1*Ddd*f*r**2 - 8*D1*Ddd*f*r*s + 6*D1*Ddd*f*r - 4*D1*Ddd*f*s**2 + 6*D1*Ddd*f*s - 3*D1*Ddd*f + 2*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 15*r**2 + 30*r*s - 20*r + 15*s**2 - 20*s + 10) - Dd*(3*f + 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 72*Dd**2*K*f*r**2 + 144*Dd**2*K*f*r*s - 108*Dd**2*K*f*r + 72*Dd**2*K*f*s**2 - 108*Dd**2*K*f*s + 36*Dd**2*K*f - 12*Dd**2*f*r**2 - 24*Dd**2*f*r*s + 18*Dd**2*f*r - 12*Dd**2*f*s**2 + 18*Dd**2*f*s - 6*Dd**2*f) - b1*(88*C*D1**2*f*fd*r**2 + 176*C*D1**2*f*fd*r*s - 176*C*D1**2*f*fd*r + 88*C*D1**2*f*fd*s**2 - 176*C*D1**2*f*fd*s + 88*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r**2 - 144*C*D1**2*f*fdd*r*s + 144*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s**2 + 144*C*D1**2*f*fdd*s - 72*C*D1**2*f*fdd - 72*C*D1**2*fd**2*r**2 - 144*C*D1**2*fd**2*r*s + 144*C*D1**2*fd**2*r - 72*C*D1**2*fd**2*s**2 + 144*C*D1**2*fd**2*s - 72*C*D1**2*fd**2 + 176*C*D1*Dd*f**2*r**2 + 352*C*D1*Dd*f**2*r*s - 264*C*D1*Dd*f**2*r + 176*C*D1*Dd*f**2*s**2 - 264*C*D1*Dd*f**2*s + 132*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r**2 - 1152*C*D1*Dd*f*fd*r*s + 1008*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 1008*C*D1*Dd*f*fd*s - 432*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r**2 - 288*C*D1*Ddd*f**2*r*s + 216*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 216*C*D1*Ddd*f**2*s - 108*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r**2 - 864*C*Dd**2*f**2*r*s + 648*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 648*C*Dd**2*f**2*s - 216*C*Dd**2*f**2 - 84*D1**2*K*bdd1*f*r**2 - 168*D1**2*K*bdd1*f*r*s + 84*D1**2*K*bdd1*f*r - 84*D1**2*K*bdd1*f*s**2 + 84*D1**2*K*bdd1*f*s - 42*D1**2*K*bdd1*f + 14*D1**2*b2*fd*r**2 + 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*r + 14*D1**2*b2*fd*s**2 - 28*D1**2*b2*fd*s + 14*D1**2*b2*fd - 42*D1**2*b2*fdd*r**2 - 84*D1**2*b2*fdd*r*s + 84*D1**2*b2*fdd*r - 42*D1**2*b2*fdd*s**2 + 84*D1**2*b2*fdd*s - 42*D1**2*b2*fdd + 14*D1**2*bd1**2*(3*f + 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 14*D1**2*bdd1*f*r**2 + 28*D1**2*bdd1*f*r*s - 14*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s**2 - 14*D1**2*bdd1*f*s + 7*D1**2*bdd1*f - 42*D1**2*bdd2*f*r**2 - 84*D1**2*bdd2*f*r*s + 84*D1**2*bdd2*f*r - 42*D1**2*bdd2*f*s**2 + 84*D1**2*bdd2*f*s - 42*D1**2*bdd2*f - 30*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s + 60*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 60*D1**2*f*fd*s - 30*D1**2*f*fd + 36*D1**2*f*fdd*r**2 + 72*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 36*D1**2*f*fdd - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 84*D1**2*f*gdd2*r**2 + 168*D1**2*f*gdd2*r*s - 168*D1**2*f*gdd2*r + 84*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s + 84*D1**2*f*gdd2 + 36*D1**2*fd**2*r**2 + 72*D1**2*fd**2*r*s - 72*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s + 36*D1**2*fd**2 - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 168*D1**2*fd*gd2*r**2 + 336*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 336*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 + 84*D1**2*fdd*g2*r**2 + 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r + 84*D1**2*fdd*g2*s**2 - 168*D1**2*fdd*g2*s + 84*D1**2*fdd*g2 + 56*D1*Dd*b2*f*r**2 + 112*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 56*D1*Dd*b2*f*s**2 - 84*D1*Dd*b2*f*s + 42*D1*Dd*b2*f - 336*D1*Dd*b2*fd*r**2 - 672*D1*Dd*b2*fd*r*s + 588*D1*Dd*b2*fd*r - 336*D1*Dd*b2*fd*s**2 + 588*D1*Dd*b2*fd*s - 252*D1*Dd*b2*fd - 60*D1*Dd*f**2*r**2 - 120*D1*Dd*f**2*r*s + 90*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 90*D1*Dd*f**2*s - 45*D1*Dd*f**2 + 288*D1*Dd*f*fd*r**2 + 576*D1*Dd*f*fd*r*s - 504*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s**2 - 504*D1*Dd*f*fd*s + 216*D1*Dd*f*fd - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r**2 + 1344*D1*Dd*f*gd2*r*s - 1176*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 1176*D1*Dd*f*gd2*s + 504*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r**2 + 1344*D1*Dd*fd*g2*r*s - 1176*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 1176*D1*Dd*fd*g2*s + 504*D1*Dd*fd*g2 - 168*D1*Ddd*b2*f*r**2 - 336*D1*Ddd*b2*f*r*s + 252*D1*Ddd*b2*f*r - 168*D1*Ddd*b2*f*s**2 + 252*D1*Ddd*b2*f*s - 126*D1*Ddd*b2*f + 72*D1*Ddd*f**2*r**2 + 144*D1*Ddd*f**2*r*s - 108*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 108*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r**2 + 672*D1*Ddd*f*g2*r*s - 504*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 504*D1*Ddd*f*g2*s + 252*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(3*f**2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + f*(2*K + 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 2*fd*(6*K - 1)*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*f*(6*K - 1)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 14*D1*bd2*(D1*(f - 6*fd)*(r + s - 1) - 6*Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 504*Dd**2*b2*f*r**2 - 1008*Dd**2*b2*f*r*s + 756*Dd**2*b2*f*r - 504*Dd**2*b2*f*s**2 + 756*Dd**2*b2*f*s - 252*Dd**2*b2*f + 216*Dd**2*f**2*r**2 + 432*Dd**2*f**2*r*s - 324*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 324*Dd**2*f**2*s + 108*Dd**2*f**2 + 1008*Dd**2*f*g2*r**2 + 2016*Dd**2*f*g2*r*s - 1512*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1512*Dd**2*f*g2*s + 504*Dd**2*f*g2))/(210*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct*k1*k2*(-4*D1**2*bd1**2*(5*b2 + f*(6*C - 3) - 10*g2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*b1*(-20*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2*D1*bdd1*(f*(6*C - 3) - 10*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*b2*(D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + bd1*(-20*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f*(4*C + 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(12 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 20*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 40*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 4*Dd*(f*(6*C - 3) - 10*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 5*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(-2*K + f + 3) - 2*Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(4*C*D1**2*fd*r**2 + 8*C*D1**2*fd*r*s - 8*C*D1**2*fd*r + 4*C*D1**2*fd*s**2 - 8*C*D1**2*fd*s + 4*C*D1**2*fd - 12*C*D1**2*fdd*r**2 - 24*C*D1**2*fdd*r*s + 24*C*D1**2*fdd*r - 12*C*D1**2*fdd*s**2 + 24*C*D1**2*fdd*s - 12*C*D1**2*fdd + 16*C*D1*Dd*f*r**2 + 32*C*D1*Dd*f*r*s - 24*C*D1*Dd*f*r + 16*C*D1*Dd*f*s**2 - 24*C*D1*Dd*f*s + 12*C*D1*Dd*f - 96*C*D1*Dd*fd*r**2 - 192*C*D1*Dd*fd*r*s + 168*C*D1*Dd*fd*r - 96*C*D1*Dd*fd*s**2 + 168*C*D1*Dd*fd*s - 72*C*D1*Dd*fd - 48*C*D1*Ddd*f*r**2 - 96*C*D1*Ddd*f*r*s + 72*C*D1*Ddd*f*r - 48*C*D1*Ddd*f*s**2 + 72*C*D1*Ddd*f*s - 36*C*D1*Ddd*f - 144*C*Dd**2*f*r**2 - 288*C*Dd**2*f*r*s + 216*C*Dd**2*f*r - 144*C*Dd**2*f*s**2 + 216*C*Dd**2*f*s - 72*C*Dd**2*f - 30*D1**2*K*bdd1*r**2 - 60*D1**2*K*bdd1*r*s + 40*D1**2*K*bdd1*r - 30*D1**2*K*bdd1*s**2 + 40*D1**2*K*bdd1*s - 20*D1**2*K*bdd1 - 10*D1**2*bdd2*r**2 - 20*D1**2*bdd2*r*s + 20*D1**2*bdd2*r - 10*D1**2*bdd2*s**2 + 20*D1**2*bdd2*s - 10*D1**2*bdd2 + 3*D1**2*fd*r**2 + 6*D1**2*fd*r*s - 6*D1**2*fd*r + 3*D1**2*fd*s**2 - 6*D1**2*fd*s + 3*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r + 6*D1**2*fdd*s**2 - 12*D1**2*fdd*s + 6*D1**2*fdd + 20*D1**2*gd2*r**2 + 40*D1**2*gd2*r*s - 40*D1**2*gd2*r + 20*D1**2*gd2*s**2 - 40*D1**2*gd2*s + 20*D1**2*gd2 + 20*D1**2*gdd2*r**2 + 40*D1**2*gdd2*r*s - 40*D1**2*gdd2*r + 20*D1**2*gdd2*s**2 - 40*D1**2*gdd2*s + 20*D1**2*gdd2 - 40*D1*Dd*b2*r**2 - 80*D1*Dd*b2*r*s + 60*D1*Dd*b2*r - 40*D1*Dd*b2*s**2 + 60*D1*Dd*b2*s - 30*D1*Dd*b2 + 12*D1*Dd*f*r**2 + 24*D1*Dd*f*r*s - 18*D1*Dd*f*r + 12*D1*Dd*f*s**2 - 18*D1*Dd*f*s + 9*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 84*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 84*D1*Dd*fd*s + 36*D1*Dd*fd + 80*D1*Dd*g2*r**2 + 160*D1*Dd*g2*r*s - 120*D1*Dd*g2*r + 80*D1*Dd*g2*s**2 - 120*D1*Dd*g2*s + 60*D1*Dd*g2 + 160*D1*Dd*gd2*r**2 + 320*D1*Dd*gd2*r*s - 280*D1*Dd*gd2*r + 160*D1*Dd*gd2*s**2 - 280*D1*Dd*gd2*s + 120*D1*Dd*gd2 - 40*D1*Ddd*b2*r**2 - 80*D1*Ddd*b2*r*s + 60*D1*Ddd*b2*r - 40*D1*Ddd*b2*s**2 + 60*D1*Ddd*b2*s - 30*D1*Ddd*b2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f + 80*D1*Ddd*g2*r**2 + 160*D1*Ddd*g2*r*s - 120*D1*Ddd*g2*r + 80*D1*Ddd*g2*s**2 - 120*D1*Ddd*g2*s + 60*D1*Ddd*g2 + 5*D1*bd1*(D1*(-2*K + f + 3)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 4*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 10*D1*bd2*(D1*(r + s - 1) + 2*Dd*(4*r + 4*s - 3))*(r + s - 1) - 120*Dd**2*b2*r**2 - 240*Dd**2*b2*r*s + 180*Dd**2*b2*r - 120*Dd**2*b2*s**2 + 180*Dd**2*b2*s - 60*Dd**2*b2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f + 240*Dd**2*g2*r**2 + 480*Dd**2*g2*r*s - 360*Dd**2*g2*r + 240*Dd**2*g2*s**2 - 360*Dd**2*g2*s + 120*Dd**2*g2))/(30*d**2*k3**2) + D1**2*Pk2*Pkdd3*f**2*k1**6*st**4*(D1**2*(-f*(17*fd - 25*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 150*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(-17*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 50*fd*(4*r + 4*s - 3)**2) + 25*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 150*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(2310*d**2*k3**6) + D1**2*Pk2*Pkdd3*f**2*k1**4*k2**2*st**6*(D1**2*(-f*(49*fd - 30*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 180*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(-49*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 60*fd*(4*r + 4*s - 3)**2) + 30*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1386*d**2*k3**6) + D1**2*Pk2*Pkdd3*f**2*k1**2*k2**4*st**8*(D1**2*(-f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(-2*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*Dd*fd*(4*r + 4*s - 3)**2 + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(198*d**2*k3**6) + D1**2*Pk2*Pkdd3*f*k1**6*st**2*(10*D1**2*bdd1*f**2*(r + s - 1)**2 - D1*bd1*f*(r + s - 1)*(11*D1*f*(r + s - 1) - 20*D1*fd*(3*r + 3*s - 2) - 20*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(-f*(11*fd - 10*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 20*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(-11*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 20*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(315*d**2*k3**6) + D1**2*Pk2*Pkdd3*f*k1**4*st**4*(D1**2*bdd1*f**2*(7*r**2 + 2*r*(7*s - 4) + 7*s**2 - 8*s + 4) + D1*bd1*f*(D1*(-f*(5*r**2 + 10*r*s - 4*r + 5*s**2 - 4*s + 2) + 2*fd*(21*r**2 + 42*r*s - 29*r + 21*s**2 - 29*s + 8)) + 2*Dd*f*(28*r**2 + r*(56*s - 37) + 28*s**2 - 37*s + 12)) + b1*(D1**2*(f*(-fd*(15*r**2 + 30*r*s - 26*r + 15*s**2 - 26*s + 13) + fdd*(21*r**2 + 42*r*s - 34*r + 21*s**2 - 34*s + 17)) + 2*fd**2*(21*r**2 + r*(42*s - 34) + 21*s**2 - 34*s + 13)) + D1*f*(Dd*(-5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*fd*(84*r**2 + 168*r*s - 131*r + 84*s**2 - 131*s + 51)) + 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**4) + D1**2*Pk2*Pkdd3*f*k1**2*k2**4*st**6*(24*D1**2*b1*f*fd*r**2 + 48*D1**2*b1*f*fd*r*s - 32*D1**2*b1*f*fd*r + 24*D1**2*b1*f*fd*s**2 - 32*D1**2*b1*f*fd*s + 16*D1**2*b1*f*fd - 12*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 16*D1**2*b1*f*fdd*r - 12*D1**2*b1*f*fdd*s**2 + 16*D1**2*b1*f*fdd*s - 8*D1**2*b1*f*fdd - 24*D1**2*b1*fd**2*r**2 - 48*D1**2*b1*fd**2*r*s + 32*D1**2*b1*fd**2*r - 24*D1**2*b1*fd**2*s**2 + 32*D1**2*b1*fd**2*s - 8*D1**2*b1*fd**2 - 4*D1**2*bdd1*f**2*(r + s - 1)**2 + 4*D1**2*f**2*fd*r**2 + 8*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r + 4*D1**2*f**2*fd*s**2 - 6*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 32*D1*Dd*b1*f**2*r**2 + 64*D1*Dd*b1*f**2*r*s - 48*D1*Dd*b1*f**2*r + 32*D1*Dd*b1*f**2*s**2 - 48*D1*Dd*b1*f**2*s + 24*D1*Dd*b1*f**2 - 96*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 136*D1*Dd*b1*f*fd*r - 96*D1*Dd*b1*f*fd*s**2 + 136*D1*Dd*b1*f*fd*s - 48*D1*Dd*b1*f*fd + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 16*D1*Ddd*b1*f**2*r**2 - 32*D1*Ddd*b1*f**2*r*s + 24*D1*Ddd*b1*f**2*r - 16*D1*Ddd*b1*f**2*s**2 + 24*D1*Ddd*b1*f**2*s - 12*D1*Ddd*b1*f**2 + 8*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 48*Dd**2*b1*f**2*r**2 - 96*Dd**2*b1*f**2*r*s + 72*Dd**2*b1*f**2*r - 48*Dd**2*b1*f**2*s**2 + 72*Dd**2*b1*f**2*s - 24*Dd**2*b1*f**2)/(126*d**2*k3**6) + D1**2*Pk2*Pkdd3*f*k1**2*k2**2*st**6*(D1**2*bdd1*f**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 4) - 2*D1*bd1*f*(D1*(f*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 4) - fd*(15*r**2 + 30*r*s - 23*r + 15*s**2 - 23*s + 8)) - Dd*f*(20*r**2 + r*(40*s - 31) + 20*s**2 - 31*s + 12)) + b1*(D1**2*(-f*(2*fd - fdd)*(15*r**2 + r*(30*s - 22) + 15*s**2 - 22*s + 11) + 2*fd**2*(15*r**2 + r*(30*s - 22) + 15*s**2 - 22*s + 7)) + D1*f*(2*Dd*(-5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + fd*(60*r**2 + 120*r*s - 89*r + 60*s**2 - 89*s + 33)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(126*d**2*k3**4) + D1**2*Pk2*Pkdd3*k1**6*(-10*D1**2*bd1**2*f**2*(r + s - 1)**2 + 2*D1*b1*f*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + b1**2*(D1**2*(f*(3*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(70*d**2*k3**6) + D1**2*Pk2*Pkdd3*k1**4*k2**2*st**2*(-6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r**2 + 60*C*D1**2*f**2*fdd*r*s - 40*C*D1**2*f**2*fdd*r + 30*C*D1**2*f**2*fdd*s**2 - 40*C*D1**2*f**2*fdd*s + 20*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r**2 + 120*C*D1**2*f*fd**2*r*s - 80*C*D1**2*f*fd**2*r + 60*C*D1**2*f*fd**2*s**2 - 80*C*D1**2*f*fd**2*s + 20*C*D1**2*f*fd**2 - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r**2 + 480*C*D1*Dd*f**2*fd*r*s - 340*C*D1*Dd*f**2*fd*r + 240*C*D1*Dd*f**2*fd*s**2 - 340*C*D1*Dd*f**2*fd*s + 120*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*r**2 + 80*C*D1*Ddd*f**3*r*s - 60*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s**2 - 60*C*D1*Ddd*f**3*s + 30*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*r**2 + 240*C*Dd**2*f**3*r*s - 180*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s**2 - 180*C*Dd**2*f**3*s + 60*C*Dd**2*f**3 + 9*D1**2*K*bdd1*f**2*r**2 + 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*r + 9*D1**2*K*bdd1*f**2*s**2 - 18*D1**2*K*bdd1*f**2*s + 9*D1**2*K*bdd1*f**2 - 180*D1**2*bd1**2*f**2*(r + s - 1)**2 + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 20*D1**2*f**2*fdd*s - 10*D1**2*f**2*fdd - 6*D1**2*f**2*gd2*r**2 - 12*D1**2*f**2*gd2*r*s + 12*D1**2*f**2*gd2*r - 6*D1**2*f**2*gd2*s**2 + 12*D1**2*f**2*gd2*s - 6*D1**2*f**2*gd2 - 18*D1**2*f**2*gdd2*r**2 - 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*r - 18*D1**2*f**2*gdd2*s**2 + 36*D1**2*f**2*gdd2*s - 18*D1**2*f**2*gdd2 - 30*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 40*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 - 12*D1**2*f*fd*g2*r**2 - 24*D1**2*f*fd*g2*r*s + 12*D1**2*f*fd*g2*r - 12*D1**2*f*fd*g2*s**2 + 12*D1**2*f*fd*g2*s - 6*D1**2*f*fd*g2 - 72*D1**2*f*fd*gd2*r**2 - 144*D1**2*f*fd*gd2*r*s + 108*D1**2*f*fd*gd2*r - 72*D1**2*f*fd*gd2*s**2 + 108*D1**2*f*fd*gd2*s - 36*D1**2*f*fd*gd2 - 36*D1**2*f*fdd*g2*r**2 - 72*D1**2*f*fdd*g2*r*s + 36*D1**2*f*fdd*g2*r - 36*D1**2*f*fdd*g2*s**2 + 36*D1**2*f*fdd*g2*s - 18*D1**2*f*fdd*g2 - 36*D1**2*fd**2*g2*r**2 - 72*D1**2*fd**2*g2*r*s + 36*D1**2*fd**2*g2*r - 36*D1**2*fd**2*g2*s**2 + 36*D1**2*fd**2*g2*s + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 170*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 170*D1*Dd*f**2*fd*s - 60*D1*Dd*f**2*fd - 24*D1*Dd*f**2*g2*r**2 - 48*D1*Dd*f**2*g2*r*s + 36*D1*Dd*f**2*g2*r - 24*D1*Dd*f**2*g2*s**2 + 36*D1*Dd*f**2*g2*s - 18*D1*Dd*f**2*g2 - 144*D1*Dd*f**2*gd2*r**2 - 288*D1*Dd*f**2*gd2*r*s + 252*D1*Dd*f**2*gd2*r - 144*D1*Dd*f**2*gd2*s**2 + 252*D1*Dd*f**2*gd2*s - 108*D1*Dd*f**2*gd2 - 288*D1*Dd*f*fd*g2*r**2 - 576*D1*Dd*f*fd*g2*r*s + 360*D1*Dd*f*fd*g2*r - 288*D1*Dd*f*fd*g2*s**2 + 360*D1*Dd*f*fd*g2*s - 108*D1*Dd*f*fd*g2 - 20*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 30*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 30*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 - 72*D1*Ddd*f**2*g2*r**2 - 144*D1*Ddd*f**2*g2*r*s + 108*D1*Ddd*f**2*g2*r - 72*D1*Ddd*f**2*g2*s**2 + 108*D1*Ddd*f**2*g2*s - 54*D1*Ddd*f**2*g2 + 3*D1*bd1*f*(D1*(K*f*(r + s - 1) + 6*K*fd*(2*r + 2*s - 1) + 6*f**2*(r + s - 1)) + 6*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) - 60*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 90*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 90*Dd**2*f**3*s - 30*Dd**2*f**3 - 216*Dd**2*f**2*g2*r**2 - 432*Dd**2*f**2*g2*r*s + 324*Dd**2*f**2*g2*r - 216*Dd**2*f**2*g2*s**2 + 324*Dd**2*f**2*g2*s - 108*Dd**2*f**2*g2 + 9*b1**2*(D1**2*(f*(13*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 20*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(13*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 20*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(2*D1**2*K*f*fd*r**2 + 4*D1**2*K*f*fd*r*s - 2*D1**2*K*f*fd*r + 2*D1**2*K*f*fd*s**2 - 2*D1**2*K*f*fd*s + D1**2*K*f*fd + 6*D1**2*K*f*fdd*r**2 + 12*D1**2*K*f*fdd*r*s - 6*D1**2*K*f*fdd*r + 6*D1**2*K*f*fdd*s**2 - 6*D1**2*K*f*fdd*s + 3*D1**2*K*f*fdd + 6*D1**2*K*fd**2*r**2 + 12*D1**2*K*fd**2*r*s - 6*D1**2*K*fd**2*r + 6*D1**2*K*fd**2*s**2 - 6*D1**2*K*fd**2*s - 60*D1**2*bdd1*f**2*(r + s - 1)**2 + 18*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 24*D1**2*f**2*fd*s + 12*D1**2*f**2*fd + 4*D1*Dd*K*f**2*r**2 + 8*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r + 4*D1*Dd*K*f**2*s**2 - 6*D1*Dd*K*f**2*s + 3*D1*Dd*K*f**2 + 48*D1*Dd*K*f*fd*r**2 + 96*D1*Dd*K*f*fd*r*s - 60*D1*Dd*K*f*fd*r + 48*D1*Dd*K*f*fd*s**2 - 60*D1*Dd*K*f*fd*s + 18*D1*Dd*K*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 + 12*D1*Ddd*K*f**2*r**2 + 24*D1*Ddd*K*f**2*r*s - 18*D1*Ddd*K*f**2*r + 12*D1*Ddd*K*f**2*s**2 - 18*D1*Ddd*K*f**2*s + 9*D1*Ddd*K*f**2 + 6*D1*bd1*f*(r + s - 1)*(13*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) + 36*Dd**2*K*f**2*r**2 + 72*Dd**2*K*f**2*r*s - 54*Dd**2*K*f**2*r + 36*Dd**2*K*f**2*s**2 - 54*Dd**2*K*f**2*s + 18*Dd**2*K*f**2))/(630*d**2*k3**6) + D1**2*Pk2*Pkdd3*k1**4*k2**2*(42*D1**2*K*bd1**2*f*(r + s - 1)**2 + 3*D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 14*K*b1 - 5*f - 14*g2) - D1*bd1*(D1*(f**2*(18*C + 42*b1 - 9)*(r + s - 1) - 2*f*(fd*(30*C - 15)*(2*r + 2*s - 1) + (r + s - 1)*(-7*K*b1 + 7*g2 - 42*gd2)) + 84*fd*(r + s)*(-K*b1 + g2)) - 6*Dd*f*(4*r + 4*s - 3)*(10*C*f + 14*K*b1 - 5*f - 14*g2))*(r + s - 1) - b1*(D1**2*(f*(fd*(18*C + 21*b1 - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(30*C - 15)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-14*gd2 + 42*gdd2)*(r + s - 1)**2) - (r + s)*(fd**2*(60*C - 30)*(r + s - 1) - 84*fd*gd2*(r + s - 1) + 7*fd*(r + s)*(-K*b1 + 2*g2) - 21*fdd*(r + s)*(-K*b1 + 2*g2))) + D1*(Dd*(f**2*(18*C + 21*b1 - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(7*K*b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + fd*(30 - 60*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 14*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 84*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 42*fd*(-K*b1 + 2*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(10*C*f + 7*K*b1 - 5*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(10*C*f + 7*K*b1 - 5*f - 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(210*d**2*k3**6) - D1**2*Pk2*Pkdd3*k1**4*st**2*(-6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r**2 + 60*C*D1**2*f**2*fdd*r*s - 40*C*D1**2*f**2*fdd*r + 30*C*D1**2*f**2*fdd*s**2 - 40*C*D1**2*f**2*fdd*s + 20*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r**2 + 120*C*D1**2*f*fd**2*r*s - 80*C*D1**2*f*fd**2*r + 60*C*D1**2*f*fd**2*s**2 - 80*C*D1**2*f*fd**2*s + 20*C*D1**2*f*fd**2 - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r**2 + 480*C*D1*Dd*f**2*fd*r*s - 340*C*D1*Dd*f**2*fd*r + 240*C*D1*Dd*f**2*fd*s**2 - 340*C*D1*Dd*f**2*fd*s + 120*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*r**2 + 80*C*D1*Ddd*f**3*r*s - 60*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s**2 - 60*C*D1*Ddd*f**3*s + 30*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*r**2 + 240*C*Dd**2*f**3*r*s - 180*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s**2 - 180*C*Dd**2*f**3*s + 60*C*Dd**2*f**3 + 9*D1**2*K*bdd1*f**2*r**2 + 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*r + 9*D1**2*K*bdd1*f**2*s**2 - 18*D1**2*K*bdd1*f**2*s + 9*D1**2*K*bdd1*f**2 + 6*D1**2*b2*f*fd*r**2 + 12*D1**2*b2*f*fd*r*s - 6*D1**2*b2*f*fd*r + 6*D1**2*b2*f*fd*s**2 - 6*D1**2*b2*f*fd*s + 3*D1**2*b2*f*fd + 18*D1**2*b2*f*fdd*r**2 + 36*D1**2*b2*f*fdd*r*s - 18*D1**2*b2*f*fdd*r + 18*D1**2*b2*f*fdd*s**2 - 18*D1**2*b2*f*fdd*s + 9*D1**2*b2*f*fdd + 18*D1**2*b2*fd**2*r**2 + 36*D1**2*b2*fd**2*r*s - 18*D1**2*b2*fd**2*r + 18*D1**2*b2*fd**2*s**2 - 18*D1**2*b2*fd**2*s - 36*D1**2*bd1**2*f**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 3*D1**2*bd2*f**2*r**2 + 6*D1**2*bd2*f**2*r*s - 6*D1**2*bd2*f**2*r + 3*D1**2*bd2*f**2*s**2 - 6*D1**2*bd2*f**2*s + 3*D1**2*bd2*f**2 + 36*D1**2*bd2*f*fd*r**2 + 72*D1**2*bd2*f*fd*r*s - 54*D1**2*bd2*f*fd*r + 36*D1**2*bd2*f*fd*s**2 - 54*D1**2*bd2*f*fd*s + 18*D1**2*bd2*f*fd + 9*D1**2*bdd2*f**2*r**2 + 18*D1**2*bdd2*f**2*r*s - 18*D1**2*bdd2*f**2*r + 9*D1**2*bdd2*f**2*s**2 - 18*D1**2*bdd2*f**2*s + 9*D1**2*bdd2*f**2 + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 20*D1**2*f**2*fdd*s - 10*D1**2*f**2*fdd - 6*D1**2*f**2*gd2*r**2 - 12*D1**2*f**2*gd2*r*s + 12*D1**2*f**2*gd2*r - 6*D1**2*f**2*gd2*s**2 + 12*D1**2*f**2*gd2*s - 6*D1**2*f**2*gd2 - 18*D1**2*f**2*gdd2*r**2 - 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*r - 18*D1**2*f**2*gdd2*s**2 + 36*D1**2*f**2*gdd2*s - 18*D1**2*f**2*gdd2 - 30*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 40*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 - 12*D1**2*f*fd*g2*r**2 - 24*D1**2*f*fd*g2*r*s + 12*D1**2*f*fd*g2*r - 12*D1**2*f*fd*g2*s**2 + 12*D1**2*f*fd*g2*s - 6*D1**2*f*fd*g2 - 72*D1**2*f*fd*gd2*r**2 - 144*D1**2*f*fd*gd2*r*s + 108*D1**2*f*fd*gd2*r - 72*D1**2*f*fd*gd2*s**2 + 108*D1**2*f*fd*gd2*s - 36*D1**2*f*fd*gd2 - 36*D1**2*f*fdd*g2*r**2 - 72*D1**2*f*fdd*g2*r*s + 36*D1**2*f*fdd*g2*r - 36*D1**2*f*fdd*g2*s**2 + 36*D1**2*f*fdd*g2*s - 18*D1**2*f*fdd*g2 - 36*D1**2*fd**2*g2*r**2 - 72*D1**2*fd**2*g2*r*s + 36*D1**2*fd**2*g2*r - 36*D1**2*fd**2*g2*s**2 + 36*D1**2*fd**2*g2*s + 12*D1*Dd*b2*f**2*r**2 + 24*D1*Dd*b2*f**2*r*s - 18*D1*Dd*b2*f**2*r + 12*D1*Dd*b2*f**2*s**2 - 18*D1*Dd*b2*f**2*s + 9*D1*Dd*b2*f**2 + 144*D1*Dd*b2*f*fd*r**2 + 288*D1*Dd*b2*f*fd*r*s - 180*D1*Dd*b2*f*fd*r + 144*D1*Dd*b2*f*fd*s**2 - 180*D1*Dd*b2*f*fd*s + 54*D1*Dd*b2*f*fd + 72*D1*Dd*bd2*f**2*r**2 + 144*D1*Dd*bd2*f**2*r*s - 126*D1*Dd*bd2*f**2*r + 72*D1*Dd*bd2*f**2*s**2 - 126*D1*Dd*bd2*f**2*s + 54*D1*Dd*bd2*f**2 + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 170*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 170*D1*Dd*f**2*fd*s - 60*D1*Dd*f**2*fd - 24*D1*Dd*f**2*g2*r**2 - 48*D1*Dd*f**2*g2*r*s + 36*D1*Dd*f**2*g2*r - 24*D1*Dd*f**2*g2*s**2 + 36*D1*Dd*f**2*g2*s - 18*D1*Dd*f**2*g2 - 144*D1*Dd*f**2*gd2*r**2 - 288*D1*Dd*f**2*gd2*r*s + 252*D1*Dd*f**2*gd2*r - 144*D1*Dd*f**2*gd2*s**2 + 252*D1*Dd*f**2*gd2*s - 108*D1*Dd*f**2*gd2 - 288*D1*Dd*f*fd*g2*r**2 - 576*D1*Dd*f*fd*g2*r*s + 360*D1*Dd*f*fd*g2*r - 288*D1*Dd*f*fd*g2*s**2 + 360*D1*Dd*f*fd*g2*s - 108*D1*Dd*f*fd*g2 + 36*D1*Ddd*b2*f**2*r**2 + 72*D1*Ddd*b2*f**2*r*s - 54*D1*Ddd*b2*f**2*r + 36*D1*Ddd*b2*f**2*s**2 - 54*D1*Ddd*b2*f**2*s + 27*D1*Ddd*b2*f**2 - 20*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 30*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 30*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 - 72*D1*Ddd*f**2*g2*r**2 - 144*D1*Ddd*f**2*g2*r*s + 108*D1*Ddd*f**2*g2*r - 72*D1*Ddd*f**2*g2*s**2 + 108*D1*Ddd*f**2*g2*s - 54*D1*Ddd*f**2*g2 + 3*D1*K*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + 6*D1*fd*(2*r + 2*s - 1) + 6*Dd*f*(4*r + 4*s - 3)) + 108*Dd**2*b2*f**2*r**2 + 216*Dd**2*b2*f**2*r*s - 162*Dd**2*b2*f**2*r + 108*Dd**2*b2*f**2*s**2 - 162*Dd**2*b2*f**2*s + 54*Dd**2*b2*f**2 - 60*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 90*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 90*Dd**2*f**3*s - 30*Dd**2*f**3 - 216*Dd**2*f**2*g2*r**2 - 432*Dd**2*f**2*g2*r*s + 324*Dd**2*f**2*g2*r - 216*Dd**2*f**2*g2*s**2 + 324*Dd**2*f**2*g2*s - 108*Dd**2*f**2*g2 + 6*b1**2*(D1**2*(f*(fd*(22*r**2 + 44*r*s - 34*r + 22*s**2 - 34*s + 17) - 6*fdd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 6*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(11*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 9*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 54*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-6*D1**2*bdd1*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 4*D1*bd1*f*(D1*(f*(11*r**2 + 22*r*s - 16*r + 11*s**2 - 16*s + 8) - 18*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 3*Dd*f*(24*r**2 + r*(48*s - 38) + 24*s**2 - 38*s + 15)) + K*(D1**2*(f*(fd + 3*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(630*d**2*k3**4) + D1**2*Pk2*Pkdd3*k1**4*(D1*(r + s - 1)*(-42*D1*K*bd1**2*f*(r + s - 1) - 3*D1*bdd1*f*(f*(10*C - 5) - 14*g2)*(r + s - 1) + 7*b2*(-3*D1*bdd1*f*(r + s - 1) + bd1*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3))) + bd1*(-42*D1*bd2*f*(r + s - 1) + D1*(f**2*(18*C - 9)*(r + s - 1) - 2*f*(fd*(30*C - 15)*(2*r + 2*s - 1) + (7*g2 - 42*gd2)*(r + s - 1)) + 84*fd*g2*(r + s)) - 6*Dd*f*(f*(10*C - 5) - 14*g2)*(4*r + 4*s - 3))) + 7*b1**3*(D1**2*(fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-3*D1**2*bdd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - 6*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + K*(D1**2*(fd - 3*fdd)*(r + s)**2 + D1*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - b1*(-36*C*D1**2*f*fd*r**2 - 72*C*D1**2*f*fd*r*s + 36*C*D1**2*f*fd*r - 36*C*D1**2*f*fd*s**2 + 36*C*D1**2*f*fd*s - 18*C*D1**2*f*fd + 60*C*D1**2*f*fdd*r**2 + 120*C*D1**2*f*fdd*r*s - 60*C*D1**2*f*fdd*r + 60*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 30*C*D1**2*f*fdd + 60*C*D1**2*fd**2*r**2 + 120*C*D1**2*fd**2*r*s - 60*C*D1**2*fd**2*r + 60*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s - 72*C*D1*Dd*f**2*r**2 - 144*C*D1*Dd*f**2*r*s + 108*C*D1*Dd*f**2*r - 72*C*D1*Dd*f**2*s**2 + 108*C*D1*Dd*f**2*s - 54*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*r**2 + 960*C*D1*Dd*f*fd*r*s - 600*C*D1*Dd*f*fd*r + 480*C*D1*Dd*f*fd*s**2 - 600*C*D1*Dd*f*fd*s + 180*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*r**2 + 240*C*D1*Ddd*f**2*r*s - 180*C*D1*Ddd*f**2*r + 120*C*D1*Ddd*f**2*s**2 - 180*C*D1*Ddd*f**2*s + 90*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*r**2 + 720*C*Dd**2*f**2*r*s - 540*C*Dd**2*f**2*r + 360*C*Dd**2*f**2*s**2 - 540*C*Dd**2*f**2*s + 180*C*Dd**2*f**2 + 42*D1**2*K*bdd1*f*r**2 + 84*D1**2*K*bdd1*f*r*s - 84*D1**2*K*bdd1*f*r + 42*D1**2*K*bdd1*f*s**2 - 84*D1**2*K*bdd1*f*s + 42*D1**2*K*bdd1*f - 7*D1**2*b2*fd*r**2 - 14*D1**2*b2*fd*r*s - 7*D1**2*b2*fd*s**2 + 21*D1**2*b2*fdd*r**2 + 42*D1**2*b2*fdd*r*s + 21*D1**2*b2*fdd*s**2 + 42*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 21*D1**2*bdd2*f*r**2 + 42*D1**2*bdd2*f*r*s - 42*D1**2*bdd2*f*r + 21*D1**2*bdd2*f*s**2 - 42*D1**2*bdd2*f*s + 21*D1**2*bdd2*f + 18*D1**2*f*fd*r**2 + 36*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 18*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 9*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 14*D1**2*f*gd2*r**2 + 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*r + 14*D1**2*f*gd2*s**2 - 28*D1**2*f*gd2*s + 14*D1**2*f*gd2 - 42*D1**2*f*gdd2*r**2 - 84*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*r - 42*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s - 42*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 14*D1**2*fd*g2*r**2 + 28*D1**2*fd*g2*r*s + 14*D1**2*fd*g2*s**2 - 84*D1**2*fd*gd2*r**2 - 168*D1**2*fd*gd2*r*s + 84*D1**2*fd*gd2*r - 84*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s - 42*D1**2*fdd*g2*r**2 - 84*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*s**2 - 28*D1*Dd*b2*f*r**2 - 56*D1*Dd*b2*f*r*s + 42*D1*Dd*b2*f*r - 28*D1*Dd*b2*f*s**2 + 42*D1*Dd*b2*f*s - 21*D1*Dd*b2*f + 168*D1*Dd*b2*fd*r**2 + 336*D1*Dd*b2*fd*r*s - 126*D1*Dd*b2*fd*r + 168*D1*Dd*b2*fd*s**2 - 126*D1*Dd*b2*fd*s + 36*D1*Dd*f**2*r**2 + 72*D1*Dd*f**2*r*s - 54*D1*Dd*f**2*r + 36*D1*Dd*f**2*s**2 - 54*D1*Dd*f**2*s + 27*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 56*D1*Dd*f*g2*r**2 + 112*D1*Dd*f*g2*r*s - 84*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s**2 - 84*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r**2 - 672*D1*Dd*f*gd2*r*s + 588*D1*Dd*f*gd2*r - 336*D1*Dd*f*gd2*s**2 + 588*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 336*D1*Dd*fd*g2*r**2 - 672*D1*Dd*fd*g2*r*s + 252*D1*Dd*fd*g2*r - 336*D1*Dd*fd*g2*s**2 + 252*D1*Dd*fd*g2*s + 84*D1*Ddd*b2*f*r**2 + 168*D1*Ddd*b2*f*r*s - 126*D1*Ddd*b2*f*r + 84*D1*Ddd*b2*f*s**2 - 126*D1*Ddd*b2*f*s + 63*D1*Ddd*b2*f - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r**2 - 336*D1*Ddd*f*g2*r*s + 252*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s**2 + 252*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 - 14*D1*K*bd1*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) - 7*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - 6*D1*fd*(r + s) - 6*Dd*f*(4*r + 4*s - 3)) + 252*Dd**2*b2*f*r**2 + 504*Dd**2*b2*f*r*s - 378*Dd**2*b2*f*r + 252*Dd**2*b2*f*s**2 - 378*Dd**2*b2*f*s + 126*Dd**2*b2*f - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 504*Dd**2*f*g2*r**2 - 1008*Dd**2*f*g2*r*s + 756*Dd**2*f*g2*r - 504*Dd**2*f*g2*s**2 + 756*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(210*d**2*k3**4) - D1**2*Pk2*Pkdd3*k1**2*k2**4*st**4*(18*C*D1**2*f**2*fd*r**2 + 36*C*D1**2*f**2*fd*r*s - 24*C*D1**2*f**2*fd*r + 18*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 12*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 16*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 16*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 32*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 32*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 24*C*D1*Dd*f**3*r**2 + 48*C*D1*Dd*f**3*r*s - 36*C*D1*Dd*f**3*r + 24*C*D1*Dd*f**3*s**2 - 36*C*D1*Dd*f**3*s + 18*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 136*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 136*C*D1*Dd*f**2*fd*s - 48*C*D1*Dd*f**2*fd - 16*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 24*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 48*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 72*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s - 24*C*Dd**2*f**3 - 6*D1**2*K*bdd1*f**2*r**2 - 12*D1**2*K*bdd1*f**2*r*s + 12*D1**2*K*bdd1*f**2*r - 6*D1**2*K*bdd1*f**2*s**2 + 12*D1**2*K*bdd1*f**2*s - 6*D1**2*K*bdd1*f**2 + 10*D1**2*bd1**2*f**2*(r + s - 1)**2 - 9*D1**2*f**2*fd*r**2 - 18*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 9*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r*s - 8*D1**2*f**2*fdd*r + 6*D1**2*f**2*fdd*s**2 - 8*D1**2*f**2*fdd*s + 4*D1**2*f**2*fdd - 10*D1**2*f**2*gd2*r**2 - 20*D1**2*f**2*gd2*r*s + 20*D1**2*f**2*gd2*r - 10*D1**2*f**2*gd2*s**2 + 20*D1**2*f**2*gd2*s - 10*D1**2*f**2*gd2 + 12*D1**2*f**2*gdd2*r**2 + 24*D1**2*f**2*gdd2*r*s - 24*D1**2*f**2*gdd2*r + 12*D1**2*f**2*gdd2*s**2 - 24*D1**2*f**2*gdd2*s + 12*D1**2*f**2*gdd2 + 12*D1**2*f*fd**2*r**2 + 24*D1**2*f*fd**2*r*s - 16*D1**2*f*fd**2*r + 12*D1**2*f*fd**2*s**2 - 16*D1**2*f*fd**2*s + 4*D1**2*f*fd**2 - 20*D1**2*f*fd*g2*r**2 - 40*D1**2*f*fd*g2*r*s + 20*D1**2*f*fd*g2*r - 20*D1**2*f*fd*g2*s**2 + 20*D1**2*f*fd*g2*s - 10*D1**2*f*fd*g2 + 48*D1**2*f*fd*gd2*r**2 + 96*D1**2*f*fd*gd2*r*s - 72*D1**2*f*fd*gd2*r + 48*D1**2*f*fd*gd2*s**2 - 72*D1**2*f*fd*gd2*s + 24*D1**2*f*fd*gd2 + 24*D1**2*f*fdd*g2*r**2 + 48*D1**2*f*fdd*g2*r*s - 24*D1**2*f*fdd*g2*r + 24*D1**2*f*fdd*g2*s**2 - 24*D1**2*f*fdd*g2*s + 12*D1**2*f*fdd*g2 + 24*D1**2*fd**2*g2*r**2 + 48*D1**2*fd**2*g2*r*s - 24*D1**2*fd**2*g2*r + 24*D1**2*fd**2*g2*s**2 - 24*D1**2*fd**2*g2*s - 12*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 + 18*D1*Dd*f**3*s - 9*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 96*D1*Dd*f**2*fd*r*s - 68*D1*Dd*f**2*fd*r + 48*D1*Dd*f**2*fd*s**2 - 68*D1*Dd*f**2*fd*s + 24*D1*Dd*f**2*fd - 40*D1*Dd*f**2*g2*r**2 - 80*D1*Dd*f**2*g2*r*s + 60*D1*Dd*f**2*g2*r - 40*D1*Dd*f**2*g2*s**2 + 60*D1*Dd*f**2*g2*s - 30*D1*Dd*f**2*g2 + 96*D1*Dd*f**2*gd2*r**2 + 192*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 96*D1*Dd*f**2*gd2*s**2 - 168*D1*Dd*f**2*gd2*s + 72*D1*Dd*f**2*gd2 + 192*D1*Dd*f*fd*g2*r**2 + 384*D1*Dd*f*fd*g2*r*s - 240*D1*Dd*f*fd*g2*r + 192*D1*Dd*f*fd*g2*s**2 - 240*D1*Dd*f*fd*g2*s + 72*D1*Dd*f*fd*g2 + 8*D1*Ddd*f**3*r**2 + 16*D1*Ddd*f**3*r*s - 12*D1*Ddd*f**3*r + 8*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 6*D1*Ddd*f**3 + 48*D1*Ddd*f**2*g2*r**2 + 96*D1*Ddd*f**2*g2*r*s - 72*D1*Ddd*f**2*g2*r + 48*D1*Ddd*f**2*g2*s**2 - 72*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(5*K*f*(r + s - 1) - 12*K*fd*(2*r + 2*s - 1) + 2*f**2*(r + s - 1)) - 12*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + 24*Dd**2*f**3*r**2 + 48*Dd**2*f**3*r*s - 36*Dd**2*f**3*r + 24*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 12*Dd**2*f**3 + 144*Dd**2*f**2*g2*r**2 + 288*Dd**2*f**2*g2*r*s - 216*Dd**2*f**2*g2*r + 144*Dd**2*f**2*g2*s**2 - 216*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 - 5*b1**2*(D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(10*D1**2*K*f*fd*r**2 + 20*D1**2*K*f*fd*r*s - 10*D1**2*K*f*fd*r + 10*D1**2*K*f*fd*s**2 - 10*D1**2*K*f*fd*s + 5*D1**2*K*f*fd - 12*D1**2*K*f*fdd*r**2 - 24*D1**2*K*f*fdd*r*s + 12*D1**2*K*f*fdd*r - 12*D1**2*K*f*fdd*s**2 + 12*D1**2*K*f*fdd*s - 6*D1**2*K*f*fdd - 12*D1**2*K*fd**2*r**2 - 24*D1**2*K*fd**2*r*s + 12*D1**2*K*fd**2*r - 12*D1**2*K*fd**2*s**2 + 12*D1**2*K*fd**2*s + 10*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd + 20*D1*Dd*K*f**2*r**2 + 40*D1*Dd*K*f**2*r*s - 30*D1*Dd*K*f**2*r + 20*D1*Dd*K*f**2*s**2 - 30*D1*Dd*K*f**2*s + 15*D1*Dd*K*f**2 - 96*D1*Dd*K*f*fd*r**2 - 192*D1*Dd*K*f*fd*r*s + 120*D1*Dd*K*f*fd*r - 96*D1*Dd*K*f*fd*s**2 + 120*D1*Dd*K*f*fd*s - 36*D1*Dd*K*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Ddd*K*f**2*r**2 - 48*D1*Ddd*K*f**2*r*s + 36*D1*Ddd*K*f**2*r - 24*D1*Ddd*K*f**2*s**2 + 36*D1*Ddd*K*f**2*s - 18*D1*Ddd*K*f**2 - 20*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 72*Dd**2*K*f**2*r**2 - 144*Dd**2*K*f**2*r*s + 108*Dd**2*K*f**2*r - 72*Dd**2*K*f**2*s**2 + 108*Dd**2*K*f**2*s - 36*Dd**2*K*f**2))/(70*d**2*k3**6) - D1**2*Pk2*Pkdd3*k1**2*k2**4*st**2*(116*C*D1**2*b1*f*fd*r**2 + 232*C*D1**2*b1*f*fd*r*s - 116*C*D1**2*b1*f*fd*r + 116*C*D1**2*b1*f*fd*s**2 - 116*C*D1**2*b1*f*fd*s + 58*C*D1**2*b1*f*fd - 72*C*D1**2*b1*f*fdd*r**2 - 144*C*D1**2*b1*f*fdd*r*s + 72*C*D1**2*b1*f*fdd*r - 72*C*D1**2*b1*f*fdd*s**2 + 72*C*D1**2*b1*f*fdd*s - 36*C*D1**2*b1*f*fdd - 72*C*D1**2*b1*fd**2*r**2 - 144*C*D1**2*b1*fd**2*r*s + 72*C*D1**2*b1*fd**2*r - 72*C*D1**2*b1*fd**2*s**2 + 72*C*D1**2*b1*fd**2*s - 18*C*D1**2*f**2*fd*r**2 - 36*C*D1**2*f**2*fd*r*s + 24*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 12*C*D1**2*f**2*fd + 232*C*D1*Dd*b1*f**2*r**2 + 464*C*D1*Dd*b1*f**2*r*s - 348*C*D1*Dd*b1*f**2*r + 232*C*D1*Dd*b1*f**2*s**2 - 348*C*D1*Dd*b1*f**2*s + 174*C*D1*Dd*b1*f**2 - 576*C*D1*Dd*b1*f*fd*r**2 - 1152*C*D1*Dd*b1*f*fd*r*s + 720*C*D1*Dd*b1*f*fd*r - 576*C*D1*Dd*b1*f*fd*s**2 + 720*C*D1*Dd*b1*f*fd*s - 216*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r**2 - 48*C*D1*Dd*f**3*r*s + 36*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 36*C*D1*Dd*f**3*s - 18*C*D1*Dd*f**3 - 144*C*D1*Ddd*b1*f**2*r**2 - 288*C*D1*Ddd*b1*f**2*r*s + 216*C*D1*Ddd*b1*f**2*r - 144*C*D1*Ddd*b1*f**2*s**2 + 216*C*D1*Ddd*b1*f**2*s - 108*C*D1*Ddd*b1*f**2 - 432*C*Dd**2*b1*f**2*r**2 - 864*C*Dd**2*b1*f**2*r*s + 648*C*Dd**2*b1*f**2*r - 432*C*Dd**2*b1*f**2*s**2 + 648*C*Dd**2*b1*f**2*s - 216*C*Dd**2*b1*f**2 + 49*D1**2*K*b1**2*fd*r**2 + 98*D1**2*K*b1**2*fd*r*s + 49*D1**2*K*b1**2*fd*s**2 - 42*D1**2*K*b1**2*fdd*r**2 - 84*D1**2*K*b1**2*fdd*r*s - 42*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 84*D1**2*K*bd1**2*f*(r + s - 1)**2 + 42*D1**2*b1**2*f*fd*r**2 + 84*D1**2*b1**2*f*fd*r*s - 42*D1**2*b1**2*f*fd*r + 42*D1**2*b1**2*f*fd*s**2 - 42*D1**2*b1**2*f*fd*s + 21*D1**2*b1**2*f*fd - 58*D1**2*b1*f*fd*r**2 - 116*D1**2*b1*f*fd*r*s + 58*D1**2*b1*f*fd*r - 58*D1**2*b1*f*fd*s**2 + 58*D1**2*b1*f*fd*s - 29*D1**2*b1*f*fd + 36*D1**2*b1*f*fdd*r**2 + 72*D1**2*b1*f*fdd*r*s - 36*D1**2*b1*f*fdd*r + 36*D1**2*b1*f*fdd*s**2 - 36*D1**2*b1*f*fdd*s + 18*D1**2*b1*f*fdd - 98*D1**2*b1*f*gd2*r**2 - 196*D1**2*b1*f*gd2*r*s + 196*D1**2*b1*f*gd2*r - 98*D1**2*b1*f*gd2*s**2 + 196*D1**2*b1*f*gd2*s - 98*D1**2*b1*f*gd2 + 84*D1**2*b1*f*gdd2*r**2 + 168*D1**2*b1*f*gdd2*r*s - 168*D1**2*b1*f*gdd2*r + 84*D1**2*b1*f*gdd2*s**2 - 168*D1**2*b1*f*gdd2*s + 84*D1**2*b1*f*gdd2 + 36*D1**2*b1*fd**2*r**2 + 72*D1**2*b1*fd**2*r*s - 36*D1**2*b1*fd**2*r + 36*D1**2*b1*fd**2*s**2 - 36*D1**2*b1*fd**2*s - 98*D1**2*b1*fd*g2*r**2 - 196*D1**2*b1*fd*g2*r*s - 98*D1**2*b1*fd*g2*s**2 + 168*D1**2*b1*fd*gd2*r**2 + 336*D1**2*b1*fd*gd2*r*s - 168*D1**2*b1*fd*gd2*r + 168*D1**2*b1*fd*gd2*s**2 - 168*D1**2*b1*fd*gd2*s + 84*D1**2*b1*fdd*g2*r**2 + 168*D1**2*b1*fdd*g2*r*s + 84*D1**2*b1*fdd*g2*s**2 - 6*D1**2*bdd1*f*(r + s - 1)**2*(6*C*f + 14*K*b1 - 3*f - 14*g2) + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 12*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 6*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 196*D1*Dd*K*b1**2*f*r**2 + 392*D1*Dd*K*b1**2*f*r*s - 294*D1*Dd*K*b1**2*f*r + 196*D1*Dd*K*b1**2*f*s**2 - 294*D1*Dd*K*b1**2*f*s + 147*D1*Dd*K*b1**2*f - 336*D1*Dd*K*b1**2*fd*r**2 - 672*D1*Dd*K*b1**2*fd*r*s + 252*D1*Dd*K*b1**2*fd*r - 336*D1*Dd*K*b1**2*fd*s**2 + 252*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 + 84*D1*Dd*b1**2*f**2*r**2 + 168*D1*Dd*b1**2*f**2*r*s - 126*D1*Dd*b1**2*f**2*r + 84*D1*Dd*b1**2*f**2*s**2 - 126*D1*Dd*b1**2*f**2*s + 63*D1*Dd*b1**2*f**2 - 116*D1*Dd*b1*f**2*r**2 - 232*D1*Dd*b1*f**2*r*s + 174*D1*Dd*b1*f**2*r - 116*D1*Dd*b1*f**2*s**2 + 174*D1*Dd*b1*f**2*s - 87*D1*Dd*b1*f**2 + 288*D1*Dd*b1*f*fd*r**2 + 576*D1*Dd*b1*f*fd*r*s - 360*D1*Dd*b1*f*fd*r + 288*D1*Dd*b1*f*fd*s**2 - 360*D1*Dd*b1*f*fd*s + 108*D1*Dd*b1*f*fd - 392*D1*Dd*b1*f*g2*r**2 - 784*D1*Dd*b1*f*g2*r*s + 588*D1*Dd*b1*f*g2*r - 392*D1*Dd*b1*f*g2*s**2 + 588*D1*Dd*b1*f*g2*s - 294*D1*Dd*b1*f*g2 + 672*D1*Dd*b1*f*gd2*r**2 + 1344*D1*Dd*b1*f*gd2*r*s - 1176*D1*Dd*b1*f*gd2*r + 672*D1*Dd*b1*f*gd2*s**2 - 1176*D1*Dd*b1*f*gd2*s + 504*D1*Dd*b1*f*gd2 + 672*D1*Dd*b1*fd*g2*r**2 + 1344*D1*Dd*b1*fd*g2*r*s - 504*D1*Dd*b1*fd*g2*r + 672*D1*Dd*b1*fd*g2*s**2 - 504*D1*Dd*b1*fd*g2*s + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 168*D1*Ddd*K*b1**2*f*r**2 - 336*D1*Ddd*K*b1**2*f*r*s + 252*D1*Ddd*K*b1**2*f*r - 168*D1*Ddd*K*b1**2*f*s**2 + 252*D1*Ddd*K*b1**2*f*s - 126*D1*Ddd*K*b1**2*f + 72*D1*Ddd*b1*f**2*r**2 + 144*D1*Ddd*b1*f**2*r*s - 108*D1*Ddd*b1*f**2*r + 72*D1*Ddd*b1*f**2*s**2 - 108*D1*Ddd*b1*f**2*s + 54*D1*Ddd*b1*f**2 + 336*D1*Ddd*b1*f*g2*r**2 + 672*D1*Ddd*b1*f*g2*r*s - 504*D1*Ddd*b1*f*g2*r + 336*D1*Ddd*b1*f*g2*s**2 - 504*D1*Ddd*b1*f*g2*s + 252*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(58*C - 7*K + 42*b1 - 29) - 2*f*(fd*(36*C - 18)*(2*r + 2*s - 1) + (r + s - 1)*(-49*K*b1 + 49*g2 - 84*gd2)) + 168*fd*(r + s)*(-K*b1 + g2)) - 12*Dd*f*(4*r + 4*s - 3)*(6*C*f + 14*K*b1 - 3*f - 14*g2))*(r + s - 1) - 504*Dd**2*K*b1**2*f*r**2 - 1008*Dd**2*K*b1**2*f*r*s + 756*Dd**2*K*b1**2*f*r - 504*Dd**2*K*b1**2*f*s**2 + 756*Dd**2*K*b1**2*f*s - 252*Dd**2*K*b1**2*f + 216*Dd**2*b1*f**2*r**2 + 432*Dd**2*b1*f**2*r*s - 324*Dd**2*b1*f**2*r + 216*Dd**2*b1*f**2*s**2 - 324*Dd**2*b1*f**2*s + 108*Dd**2*b1*f**2 + 1008*Dd**2*b1*f*g2*r**2 + 2016*Dd**2*b1*f*g2*r*s - 1512*Dd**2*b1*f*g2*r + 1008*Dd**2*b1*f*g2*s**2 - 1512*Dd**2*b1*f*g2*s + 504*Dd**2*b1*f*g2)/(210*d**2*k3**6) + D1**2*Pk2*Pkdd3*k1**2*k2**2*st**4*(18*C*D1**2*f**2*fd*r**2 + 36*C*D1**2*f**2*fd*r*s - 24*C*D1**2*f**2*fd*r + 18*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 12*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 16*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 16*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 32*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 32*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 24*C*D1*Dd*f**3*r**2 + 48*C*D1*Dd*f**3*r*s - 36*C*D1*Dd*f**3*r + 24*C*D1*Dd*f**3*s**2 - 36*C*D1*Dd*f**3*s + 18*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 136*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 136*C*D1*Dd*f**2*fd*s - 48*C*D1*Dd*f**2*fd - 16*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 24*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 48*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 72*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s - 24*C*Dd**2*f**3 - 6*D1**2*K*bdd1*f**2*r**2 - 12*D1**2*K*bdd1*f**2*r*s + 12*D1**2*K*bdd1*f**2*r - 6*D1**2*K*bdd1*f**2*s**2 + 12*D1**2*K*bdd1*f**2*s - 6*D1**2*K*bdd1*f**2 + 10*D1**2*b2*f*fd*r**2 + 20*D1**2*b2*f*fd*r*s - 10*D1**2*b2*f*fd*r + 10*D1**2*b2*f*fd*s**2 - 10*D1**2*b2*f*fd*s + 5*D1**2*b2*f*fd - 12*D1**2*b2*f*fdd*r**2 - 24*D1**2*b2*f*fdd*r*s + 12*D1**2*b2*f*fdd*r - 12*D1**2*b2*f*fdd*s**2 + 12*D1**2*b2*f*fdd*s - 6*D1**2*b2*f*fdd - 12*D1**2*b2*fd**2*r**2 - 24*D1**2*b2*fd**2*r*s + 12*D1**2*b2*fd**2*r - 12*D1**2*b2*fd**2*s**2 + 12*D1**2*b2*fd**2*s + 4*D1**2*bd1**2*f**2*(r**2 + r*(2*s - 3) + s**2 - 3*s + 2) + 5*D1**2*bd2*f**2*r**2 + 10*D1**2*bd2*f**2*r*s - 10*D1**2*bd2*f**2*r + 5*D1**2*bd2*f**2*s**2 - 10*D1**2*bd2*f**2*s + 5*D1**2*bd2*f**2 - 24*D1**2*bd2*f*fd*r**2 - 48*D1**2*bd2*f*fd*r*s + 36*D1**2*bd2*f*fd*r - 24*D1**2*bd2*f*fd*s**2 + 36*D1**2*bd2*f*fd*s - 12*D1**2*bd2*f*fd - 6*D1**2*bdd2*f**2*r**2 - 12*D1**2*bdd2*f**2*r*s + 12*D1**2*bdd2*f**2*r - 6*D1**2*bdd2*f**2*s**2 + 12*D1**2*bdd2*f**2*s - 6*D1**2*bdd2*f**2 - 9*D1**2*f**2*fd*r**2 - 18*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 9*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r*s - 8*D1**2*f**2*fdd*r + 6*D1**2*f**2*fdd*s**2 - 8*D1**2*f**2*fdd*s + 4*D1**2*f**2*fdd - 10*D1**2*f**2*gd2*r**2 - 20*D1**2*f**2*gd2*r*s + 20*D1**2*f**2*gd2*r - 10*D1**2*f**2*gd2*s**2 + 20*D1**2*f**2*gd2*s - 10*D1**2*f**2*gd2 + 12*D1**2*f**2*gdd2*r**2 + 24*D1**2*f**2*gdd2*r*s - 24*D1**2*f**2*gdd2*r + 12*D1**2*f**2*gdd2*s**2 - 24*D1**2*f**2*gdd2*s + 12*D1**2*f**2*gdd2 + 12*D1**2*f*fd**2*r**2 + 24*D1**2*f*fd**2*r*s - 16*D1**2*f*fd**2*r + 12*D1**2*f*fd**2*s**2 - 16*D1**2*f*fd**2*s + 4*D1**2*f*fd**2 - 20*D1**2*f*fd*g2*r**2 - 40*D1**2*f*fd*g2*r*s + 20*D1**2*f*fd*g2*r - 20*D1**2*f*fd*g2*s**2 + 20*D1**2*f*fd*g2*s - 10*D1**2*f*fd*g2 + 48*D1**2*f*fd*gd2*r**2 + 96*D1**2*f*fd*gd2*r*s - 72*D1**2*f*fd*gd2*r + 48*D1**2*f*fd*gd2*s**2 - 72*D1**2*f*fd*gd2*s + 24*D1**2*f*fd*gd2 + 24*D1**2*f*fdd*g2*r**2 + 48*D1**2*f*fdd*g2*r*s - 24*D1**2*f*fdd*g2*r + 24*D1**2*f*fdd*g2*s**2 - 24*D1**2*f*fdd*g2*s + 12*D1**2*f*fdd*g2 + 24*D1**2*fd**2*g2*r**2 + 48*D1**2*fd**2*g2*r*s - 24*D1**2*fd**2*g2*r + 24*D1**2*fd**2*g2*s**2 - 24*D1**2*fd**2*g2*s + 20*D1*Dd*b2*f**2*r**2 + 40*D1*Dd*b2*f**2*r*s - 30*D1*Dd*b2*f**2*r + 20*D1*Dd*b2*f**2*s**2 - 30*D1*Dd*b2*f**2*s + 15*D1*Dd*b2*f**2 - 96*D1*Dd*b2*f*fd*r**2 - 192*D1*Dd*b2*f*fd*r*s + 120*D1*Dd*b2*f*fd*r - 96*D1*Dd*b2*f*fd*s**2 + 120*D1*Dd*b2*f*fd*s - 36*D1*Dd*b2*f*fd - 48*D1*Dd*bd2*f**2*r**2 - 96*D1*Dd*bd2*f**2*r*s + 84*D1*Dd*bd2*f**2*r - 48*D1*Dd*bd2*f**2*s**2 + 84*D1*Dd*bd2*f**2*s - 36*D1*Dd*bd2*f**2 - 12*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 + 18*D1*Dd*f**3*s - 9*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 96*D1*Dd*f**2*fd*r*s - 68*D1*Dd*f**2*fd*r + 48*D1*Dd*f**2*fd*s**2 - 68*D1*Dd*f**2*fd*s + 24*D1*Dd*f**2*fd - 40*D1*Dd*f**2*g2*r**2 - 80*D1*Dd*f**2*g2*r*s + 60*D1*Dd*f**2*g2*r - 40*D1*Dd*f**2*g2*s**2 + 60*D1*Dd*f**2*g2*s - 30*D1*Dd*f**2*g2 + 96*D1*Dd*f**2*gd2*r**2 + 192*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 96*D1*Dd*f**2*gd2*s**2 - 168*D1*Dd*f**2*gd2*s + 72*D1*Dd*f**2*gd2 + 192*D1*Dd*f*fd*g2*r**2 + 384*D1*Dd*f*fd*g2*r*s - 240*D1*Dd*f*fd*g2*r + 192*D1*Dd*f*fd*g2*s**2 - 240*D1*Dd*f*fd*g2*s + 72*D1*Dd*f*fd*g2 - 24*D1*Ddd*b2*f**2*r**2 - 48*D1*Ddd*b2*f**2*r*s + 36*D1*Ddd*b2*f**2*r - 24*D1*Ddd*b2*f**2*s**2 + 36*D1*Ddd*b2*f**2*s - 18*D1*Ddd*b2*f**2 + 8*D1*Ddd*f**3*r**2 + 16*D1*Ddd*f**3*r*s - 12*D1*Ddd*f**3*r + 8*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 6*D1*Ddd*f**3 + 48*D1*Ddd*f**2*g2*r**2 + 96*D1*Ddd*f**2*g2*r*s - 72*D1*Ddd*f**2*g2*r + 48*D1*Ddd*f**2*g2*s**2 - 72*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(5*K*f*(r + s - 1)**2 - 12*K*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f**2*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 12*Dd*K*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - 72*Dd**2*b2*f**2*r**2 - 144*Dd**2*b2*f**2*r*s + 108*Dd**2*b2*f**2*r - 72*Dd**2*b2*f**2*s**2 + 108*Dd**2*b2*f**2*s - 36*Dd**2*b2*f**2 + 24*Dd**2*f**3*r**2 + 48*Dd**2*f**3*r*s - 36*Dd**2*f**3*r + 24*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 12*Dd**2*f**3 + 144*Dd**2*f**2*g2*r**2 + 288*Dd**2*f**2*g2*r*s - 216*Dd**2*f**2*g2*r + 144*Dd**2*f**2*g2*s**2 - 216*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 - 2*b1**2*(-2*D1**2*(-2*f*fd*(r + s)**2 + f*fdd*(r + s)**2 + fd**2*(r**2 + 2*r*s + s**2 - 1)) + D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(10*D1**2*K*f*fd*r**2 + 20*D1**2*K*f*fd*r*s - 10*D1**2*K*f*fd*r + 10*D1**2*K*f*fd*s**2 - 10*D1**2*K*f*fd*s + 5*D1**2*K*f*fd - 12*D1**2*K*f*fdd*r**2 - 24*D1**2*K*f*fdd*r*s + 12*D1**2*K*f*fdd*r - 12*D1**2*K*f*fdd*s**2 + 12*D1**2*K*f*fdd*s - 6*D1**2*K*f*fdd - 12*D1**2*K*fd**2*r**2 - 24*D1**2*K*fd**2*r*s + 12*D1**2*K*fd**2*r - 12*D1**2*K*fd**2*s**2 + 12*D1**2*K*fd**2*s + 2*D1**2*bdd1*f**2*(2*r**2 + 4*r*s - 6*r + 2*s**2 - 6*s + 3) + 9*D1**2*f**2*fd*r**2 + 18*D1**2*f**2*fd*r*s - 14*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 14*D1**2*f**2*fd*s + 7*D1**2*f**2*fd + 20*D1*Dd*K*f**2*r**2 + 40*D1*Dd*K*f**2*r*s - 30*D1*Dd*K*f**2*r + 20*D1*Dd*K*f**2*s**2 - 30*D1*Dd*K*f**2*s + 15*D1*Dd*K*f**2 - 96*D1*Dd*K*f*fd*r**2 - 192*D1*Dd*K*f*fd*r*s + 120*D1*Dd*K*f*fd*r - 96*D1*Dd*K*f*fd*s**2 + 120*D1*Dd*K*f*fd*s - 36*D1*Dd*K*f*fd + 12*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 18*D1*Dd*f**3*s + 9*D1*Dd*f**3 - 24*D1*Ddd*K*f**2*r**2 - 48*D1*Ddd*K*f**2*r*s + 36*D1*Ddd*K*f**2*r - 24*D1*Ddd*K*f**2*s**2 + 36*D1*Ddd*K*f**2*s - 18*D1*Ddd*K*f**2 - 4*D1*bd1*f*(D1*(f*(2*r**2 + 4*r*s - 6*r + 2*s**2 - 6*s + 3) - 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9)) - 72*Dd**2*K*f**2*r**2 - 144*Dd**2*K*f**2*r*s + 108*Dd**2*K*f**2*r - 72*Dd**2*K*f**2*s**2 + 108*Dd**2*K*f**2*s - 36*Dd**2*K*f**2))/(70*d**2*k3**4) + D1**2*Pk2*Pkdd3*k1**2*k2**2*st**2*(D1*(-14*D1*K*bd1**2*f*(5*r**2 + r*(10*s - 11) + 5*s**2 - 11*s + 6) + 7*b2*(bd1*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + bd1*(-84*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(2*C*(30*r**2 + r*(60*s - 58) + 30*s**2 - 58*s + 29) - 7*K*(r + s - 1)**2 - 30*r**2 - 60*r*s + 58*r - 30*s**2 + 58*s - 29) - 2*f*(fd*(12*C - 6)*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) + 7*g2*(10*r**2 + 20*r*s - 14*r + 10*s**2 - 14*s + 7) - 14*gd2*(5*r**2 + 10*r*s - 11*r + 5*s**2 - 11*s + 6)) + 140*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(f*(6*C - 3) - 14*g2)*(20*r**2 + r*(40*s - 39) + 20*s**2 - 39*s + 18)) + f*(-18*C*D1*f*fd*r**2 - 36*C*D1*f*fd*r*s + 24*C*D1*f*fd*r - 18*C*D1*f*fd*s**2 + 24*C*D1*f*fd*s - 12*C*D1*f*fd - 24*C*Dd*f**2*r**2 - 48*C*Dd*f**2*r*s + 36*C*Dd*f**2*r - 24*C*Dd*f**2*s**2 + 36*C*Dd*f**2*s - 18*C*Dd*f**2 - 7*D1*bd2*f*(r + s - 1)**2 - D1*bdd1*(f*(6*C - 3) - 14*g2)*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) + 9*D1*f*fd*r**2 + 18*D1*f*fd*r*s - 12*D1*f*fd*r + 9*D1*f*fd*s**2 - 12*D1*f*fd*s + 6*D1*f*fd + 14*D1*f*gd2*r**2 + 28*D1*f*gd2*r*s - 28*D1*f*gd2*r + 14*D1*f*gd2*s**2 - 28*D1*f*gd2*s + 14*D1*f*gd2 + 28*D1*fd*g2*r**2 + 56*D1*fd*g2*r*s - 28*D1*fd*g2*r + 28*D1*fd*g2*s**2 - 28*D1*fd*g2*s + 14*D1*fd*g2 + 12*Dd*f**2*r**2 + 24*Dd*f**2*r*s - 18*Dd*f**2*r + 12*Dd*f**2*s**2 - 18*Dd*f**2*s + 9*Dd*f**2 + 56*Dd*f*g2*r**2 + 112*Dd*f*g2*r*s - 84*Dd*f*g2*r + 56*Dd*f*g2*s**2 - 84*Dd*f*g2*s + 42*Dd*f*g2)) + 21*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(10*D1**2*K*fd*r**2 + 20*D1**2*K*fd*r*s - 6*D1**2*K*fd*r + 10*D1**2*K*fd*s**2 - 6*D1**2*K*fd*s + 3*D1**2*K*fd - 5*D1**2*K*fdd*r**2 - 10*D1**2*K*fdd*r*s - 2*D1**2*K*fdd*r - 5*D1**2*K*fdd*s**2 - 2*D1**2*K*fdd*s + D1**2*K*fdd - 3*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd + 40*D1*Dd*K*f*r**2 + 80*D1*Dd*K*f*r*s - 60*D1*Dd*K*f*r + 40*D1*Dd*K*f*s**2 - 60*D1*Dd*K*f*s + 30*D1*Dd*K*f - 40*D1*Dd*K*fd*r**2 - 80*D1*Dd*K*fd*r*s + 22*D1*Dd*K*fd*r - 40*D1*Dd*K*fd*s**2 + 22*D1*Dd*K*fd*s + 6*D1*Dd*K*fd + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 20*D1*Ddd*K*f*r**2 - 40*D1*Ddd*K*f*r*s + 30*D1*Ddd*K*f*r - 20*D1*Ddd*K*f*s**2 + 30*D1*Ddd*K*f*s - 15*D1*Ddd*K*f + 6*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 60*Dd**2*K*f*r**2 - 120*Dd**2*K*f*r*s + 90*Dd**2*K*f*r - 60*Dd**2*K*f*s**2 + 90*Dd**2*K*f*s - 30*Dd**2*K*f) - b1*(-120*C*D1**2*f*fd*r**2 - 240*C*D1**2*f*fd*r*s + 124*C*D1**2*f*fd*r - 120*C*D1**2*f*fd*s**2 + 124*C*D1**2*f*fd*s - 62*C*D1**2*f*fd + 60*C*D1**2*f*fdd*r**2 + 120*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 60*C*D1**2*f*fdd*s**2 - 48*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 60*C*D1**2*fd**2*r**2 + 120*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 60*C*D1**2*fd**2*s**2 - 48*C*D1**2*fd**2*s - 12*C*D1**2*fd**2 - 240*C*D1*Dd*f**2*r**2 - 480*C*D1*Dd*f**2*r*s + 360*C*D1*Dd*f**2*r - 240*C*D1*Dd*f**2*s**2 + 360*C*D1*Dd*f**2*s - 180*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*r**2 + 960*C*D1*Dd*f*fd*r*s - 552*C*D1*Dd*f*fd*r + 480*C*D1*Dd*f*fd*s**2 - 552*C*D1*Dd*f*fd*s + 144*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*r**2 + 240*C*D1*Ddd*f**2*r*s - 180*C*D1*Ddd*f**2*r + 120*C*D1*Ddd*f**2*s**2 - 180*C*D1*Ddd*f**2*s + 90*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*r**2 + 720*C*Dd**2*f**2*r*s - 540*C*Dd**2*f**2*r + 360*C*Dd**2*f**2*s**2 - 540*C*Dd**2*f**2*s + 180*C*Dd**2*f**2 + 70*D1**2*K*bdd1*f*r**2 + 140*D1**2*K*bdd1*f*r*s - 154*D1**2*K*bdd1*f*r + 70*D1**2*K*bdd1*f*s**2 - 154*D1**2*K*bdd1*f*s + 77*D1**2*K*bdd1*f + 14*D1**2*K*f*fd*r**2 + 28*D1**2*K*f*fd*r*s - 14*D1**2*K*f*fd*r + 14*D1**2*K*f*fd*s**2 - 14*D1**2*K*f*fd*s + 7*D1**2*K*f*fd - 49*D1**2*b2*fd*r**2 - 98*D1**2*b2*fd*r*s - 49*D1**2*b2*fd*s**2 + 42*D1**2*b2*fdd*r**2 + 84*D1**2*b2*fdd*r*s + 42*D1**2*b2*fdd*s**2 + 42*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 42*D1**2*bdd2*f*r**2 + 84*D1**2*bdd2*f*r*s - 84*D1**2*bdd2*f*r + 42*D1**2*bdd2*f*s**2 - 84*D1**2*bdd2*f*s + 42*D1**2*bdd2*f + 60*D1**2*f*fd*r**2 + 120*D1**2*f*fd*r*s - 62*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 62*D1**2*f*fd*s + 31*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 24*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s - 12*D1**2*f*fdd + 140*D1**2*f*gd2*r**2 + 280*D1**2*f*gd2*r*s - 280*D1**2*f*gd2*r + 140*D1**2*f*gd2*s**2 - 280*D1**2*f*gd2*s + 140*D1**2*f*gd2 - 70*D1**2*f*gdd2*r**2 - 140*D1**2*f*gdd2*r*s + 140*D1**2*f*gdd2*r - 70*D1**2*f*gdd2*s**2 + 140*D1**2*f*gdd2*s - 70*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 24*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s + 6*D1**2*fd**2 + 140*D1**2*fd*g2*r**2 + 280*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*r + 140*D1**2*fd*g2*s**2 - 84*D1**2*fd*g2*s + 42*D1**2*fd*g2 - 140*D1**2*fd*gd2*r**2 - 280*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 140*D1**2*fd*gd2*s**2 + 112*D1**2*fd*gd2*s + 28*D1**2*fd*gd2 - 70*D1**2*fdd*g2*r**2 - 140*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*r - 70*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 + 28*D1*Dd*K*f**2*r**2 + 56*D1*Dd*K*f**2*r*s - 42*D1*Dd*K*f**2*r + 28*D1*Dd*K*f**2*s**2 - 42*D1*Dd*K*f**2*s + 21*D1*Dd*K*f**2 - 196*D1*Dd*b2*f*r**2 - 392*D1*Dd*b2*f*r*s + 294*D1*Dd*b2*f*r - 196*D1*Dd*b2*f*s**2 + 294*D1*Dd*b2*f*s - 147*D1*Dd*b2*f + 336*D1*Dd*b2*fd*r**2 + 672*D1*Dd*b2*fd*r*s - 252*D1*Dd*b2*fd*r + 336*D1*Dd*b2*fd*s**2 - 252*D1*Dd*b2*fd*s + 120*D1*Dd*f**2*r**2 + 240*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 180*D1*Dd*f**2*s + 90*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 276*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 276*D1*Dd*f*fd*s - 72*D1*Dd*f*fd + 560*D1*Dd*f*g2*r**2 + 1120*D1*Dd*f*g2*r*s - 840*D1*Dd*f*g2*r + 560*D1*Dd*f*g2*s**2 - 840*D1*Dd*f*g2*s + 420*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*r**2 - 1120*D1*Dd*f*gd2*r*s + 980*D1*Dd*f*gd2*r - 560*D1*Dd*f*gd2*s**2 + 980*D1*Dd*f*gd2*s - 420*D1*Dd*f*gd2 - 560*D1*Dd*fd*g2*r**2 - 1120*D1*Dd*fd*g2*r*s + 308*D1*Dd*fd*g2*r - 560*D1*Dd*fd*g2*s**2 + 308*D1*Dd*fd*g2*s + 84*D1*Dd*fd*g2 + 168*D1*Ddd*b2*f*r**2 + 336*D1*Ddd*b2*f*r*s - 252*D1*Ddd*b2*f*r + 168*D1*Ddd*b2*f*s**2 - 252*D1*Ddd*b2*f*s + 126*D1*Ddd*b2*f - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*r**2 - 560*D1*Ddd*f*g2*r*s + 420*D1*Ddd*f*g2*r - 280*D1*Ddd*f*g2*s**2 + 420*D1*Ddd*f*g2*s - 210*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(K*f*(20*r**2 + 40*r*s - 34*r + 20*s**2 - 34*s + 17) + 2*K*fd*(-10*r**2 - 20*r*s + 9*r - 10*s**2 + 9*s + 1) + 4*f**2*(r + s - 1)**2) - 2*Dd*K*f*(40*r**2 + r*(80*s - 74) + 40*s**2 - 74*s + 33)) - 7*D1*bd2*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 504*Dd**2*b2*f*r**2 + 1008*Dd**2*b2*f*r*s - 756*Dd**2*b2*f*r + 504*Dd**2*b2*f*s**2 - 756*Dd**2*b2*f*s + 252*Dd**2*b2*f - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 840*Dd**2*f*g2*r**2 - 1680*Dd**2*f*g2*r*s + 1260*Dd**2*f*g2*r - 840*Dd**2*f*g2*s**2 + 1260*Dd**2*f*g2*s - 420*Dd**2*f*g2))/(210*d**2*k3**4) - D1**2*Pk2*Pkdd3*k1**2*k2**2*(D1**2*bd1*(5*b2*f*(r + s - 1) + (-2*bd1*(r + s) + f*(r + s - 1))*(f*(6*C - 3) - 10*g2))*(r + s - 1) + D1*b1*(-12*C*D1*bdd1*f*r**2 - 24*C*D1*bdd1*f*r*s + 12*C*D1*bdd1*f*r - 12*C*D1*bdd1*f*s**2 + 12*C*D1*bdd1*f*s - 6*C*D1*bdd1*f + 12*C*D1*f*fd*r**2 + 24*C*D1*f*fd*r*s - 12*C*D1*f*fd*r + 12*C*D1*f*fd*s**2 - 12*C*D1*f*fd*s + 6*C*D1*f*fd + 24*C*Dd*f**2*r**2 + 48*C*Dd*f**2*r*s - 36*C*Dd*f**2*r + 24*C*Dd*f**2*s**2 - 36*C*Dd*f**2*s + 18*C*Dd*f**2 - 10*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 5*D1*b2*fd*r**2 + 10*D1*b2*fd*r*s + 5*D1*b2*fd*s**2 + 5*D1*bd2*f*(r + s - 1)**2 + 6*D1*bdd1*f*r**2 + 12*D1*bdd1*f*r*s - 6*D1*bdd1*f*r + 6*D1*bdd1*f*s**2 - 6*D1*bdd1*f*s + 3*D1*bdd1*f + 20*D1*bdd1*g2*r**2 + 40*D1*bdd1*g2*r*s - 20*D1*bdd1*g2*r + 20*D1*bdd1*g2*s**2 - 20*D1*bdd1*g2*s + 10*D1*bdd1*g2 - 6*D1*f*fd*r**2 - 12*D1*f*fd*r*s + 6*D1*f*fd*r - 6*D1*f*fd*s**2 + 6*D1*f*fd*s - 3*D1*f*fd - 10*D1*f*gd2*r**2 - 20*D1*f*gd2*r*s + 20*D1*f*gd2*r - 10*D1*f*gd2*s**2 + 20*D1*f*gd2*s - 10*D1*f*gd2 - 10*D1*fd*g2*r**2 - 20*D1*fd*g2*r*s - 10*D1*fd*g2*s**2 + 20*Dd*b2*f*r**2 + 40*Dd*b2*f*r*s - 30*Dd*b2*f*r + 20*Dd*b2*f*s**2 - 30*Dd*b2*f*s + 15*Dd*b2*f - 12*Dd*f**2*r**2 - 24*Dd*f**2*r*s + 18*Dd*f**2*r - 12*Dd*f**2*s**2 + 18*Dd*f**2*s - 9*Dd*f**2 - 40*Dd*f*g2*r**2 - 80*Dd*f*g2*r*s + 60*Dd*f*g2*r - 40*Dd*f*g2*s**2 + 60*Dd*f*g2*s - 30*Dd*f*g2 + bd1*(D1*(f*(C*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) + 10*K*(r + s - 1)**2 - 2*r**2 - 4*r*s + 2*r - 2*s**2 + 2*s - 1) + fd*(6 - 12*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 10*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(6*C - 3) - 10*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 5*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(-K + f) - Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(-5*K*bdd1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + fd*(2*C*(r + s - 1)**2 + 5*K*s**2 + r**2*(5*K - 1) + 2*r*(5*K*s - s + 1) - s**2 + 2*s - 1) + fdd*(3 - 6*C)*(r + s - 1)**2 + 10*gd2*(r + s - 1)**2 + 10*gdd2*(r + s - 1)**2) + 5*D1*bd1*(D1*(-K + f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(f*(2*C + 5*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(6 - 12*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 10*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 20*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*(f*(6*C - 3) - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(f*(6*C - 3) - 10*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(30*d**2*k3**4) + D1**2*Pk2*Pkdd3*k1**2*st**4*(2*D1**2*bd1**2*f**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*b1*f*(-2*D1*bd1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*bd1*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + b1**2*(-2*D1**2*(r + s - 1)**2*(2*f*fd - f*fdd - fd**2) + D1*f*(-2*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4*Dd*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(35*d**2*k3**2) - D1**2*Pk2*Pkdd3*k1**2*st**2*(D1*(r + s)*(14*D1*K*bd1**2*f*(r + s - 1) + D1*bdd1*f*(r + s)*(7*b2 + f*(6*C - 3) - 14*g2) + bd1*(2*C*D1*f**2*r + 2*C*D1*f**2*s + 24*C*D1*f*fd*r + 24*C*D1*f*fd*s - 24*C*D1*f*fd + 48*C*Dd*f**2*r + 48*C*Dd*f**2*s - 36*C*Dd*f**2 + 14*D1*bd2*f*(r + s - 1) - D1*f**2*r - D1*f**2*s - 12*D1*f*fd*r - 12*D1*f*fd*s + 12*D1*f*fd - 42*D1*f*g2*r - 42*D1*f*g2*s - 28*D1*f*gd2*r - 28*D1*f*gd2*s + 28*D1*f*gd2 - 28*D1*fd*g2*r - 28*D1*fd*g2*s + 28*D1*fd*g2 - 24*Dd*f**2*r - 24*Dd*f**2*s + 18*Dd*f**2 - 112*Dd*f*g2*r - 112*Dd*f*g2*s + 84*Dd*f*g2 + 7*b2*(3*D1*f*(r + s) + 2*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3)))) + 14*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 7*b1**2*(-2*D1**2*bdd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 4*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + K*(D1**2*(3*fd + fdd)*(r + s - 1)**2 + D1*(Dd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + b1*(4*C*D1**2*f*fd*r**2 + 8*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd*s + 4*C*D1**2*f*fd + 12*C*D1**2*f*fdd*r**2 + 24*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 12*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 12*C*D1**2*fd**2*r**2 + 24*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 12*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 + 8*C*D1*Dd*f**2*r**2 + 16*C*D1*Dd*f**2*r*s - 12*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s**2 - 12*C*D1*Dd*f**2*s + 6*C*D1*Dd*f**2 + 96*C*D1*Dd*f*fd*r**2 + 192*C*D1*Dd*f*fd*r*s - 168*C*D1*Dd*f*fd*r + 96*C*D1*Dd*f*fd*s**2 - 168*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 24*C*D1*Ddd*f**2*r**2 + 48*C*D1*Ddd*f**2*r*s - 36*C*D1*Ddd*f**2*r + 24*C*D1*Ddd*f**2*s**2 - 36*C*D1*Ddd*f**2*s + 18*C*D1*Ddd*f**2 + 72*C*Dd**2*f**2*r**2 + 144*C*Dd**2*f**2*r*s - 108*C*Dd**2*f**2*r + 72*C*Dd**2*f**2*s**2 - 108*C*Dd**2*f**2*s + 36*C*Dd**2*f**2 + 14*D1**2*K*bdd1*f*r**2 + 28*D1**2*K*bdd1*f*r*s - 14*D1**2*K*bdd1*f*r + 14*D1**2*K*bdd1*f*s**2 - 14*D1**2*K*bdd1*f*s + 7*D1**2*K*bdd1*f + 21*D1**2*b2*fd*r**2 + 42*D1**2*b2*fd*r*s - 42*D1**2*b2*fd*r + 21*D1**2*b2*fd*s**2 - 42*D1**2*b2*fd*s + 21*D1**2*b2*fd + 7*D1**2*b2*fdd*r**2 + 14*D1**2*b2*fdd*r*s - 14*D1**2*b2*fdd*r + 7*D1**2*b2*fdd*s**2 - 14*D1**2*b2*fdd*s + 7*D1**2*b2*fdd - 28*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*D1**2*bdd2*f*r**2 + 14*D1**2*bdd2*f*r*s - 14*D1**2*bdd2*f*r + 7*D1**2*bdd2*f*s**2 - 14*D1**2*bdd2*f*s + 7*D1**2*bdd2*f - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 2*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 12*D1**2*f*fdd*s - 6*D1**2*f*fdd - 42*D1**2*f*gd2*r**2 - 84*D1**2*f*gd2*r*s + 84*D1**2*f*gd2*r - 42*D1**2*f*gd2*s**2 + 84*D1**2*f*gd2*s - 42*D1**2*f*gd2 - 14*D1**2*f*gdd2*r**2 - 28*D1**2*f*gdd2*r*s + 28*D1**2*f*gdd2*r - 14*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 14*D1**2*f*gdd2 - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 12*D1**2*fd**2*s - 6*D1**2*fd**2 - 42*D1**2*fd*g2*r**2 - 84*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*r - 42*D1**2*fd*g2*s**2 + 84*D1**2*fd*g2*s - 42*D1**2*fd*g2 - 28*D1**2*fd*gd2*r**2 - 56*D1**2*fd*gd2*r*s + 56*D1**2*fd*gd2*r - 28*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 28*D1**2*fd*gd2 - 14*D1**2*fdd*g2*r**2 - 28*D1**2*fdd*g2*r*s + 28*D1**2*fdd*g2*r - 14*D1**2*fdd*g2*s**2 + 28*D1**2*fdd*g2*s - 14*D1**2*fdd*g2 + 84*D1*Dd*b2*f*r**2 + 168*D1*Dd*b2*f*r*s - 126*D1*Dd*b2*f*r + 84*D1*Dd*b2*f*s**2 - 126*D1*Dd*b2*f*s + 63*D1*Dd*b2*f + 56*D1*Dd*b2*fd*r**2 + 112*D1*Dd*b2*fd*r*s - 98*D1*Dd*b2*fd*r + 56*D1*Dd*b2*fd*s**2 - 98*D1*Dd*b2*fd*s + 42*D1*Dd*b2*fd - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 84*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 84*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 168*D1*Dd*f*g2*r**2 - 336*D1*Dd*f*g2*r*s + 252*D1*Dd*f*g2*r - 168*D1*Dd*f*g2*s**2 + 252*D1*Dd*f*g2*s - 126*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*r**2 - 224*D1*Dd*f*gd2*r*s + 196*D1*Dd*f*gd2*r - 112*D1*Dd*f*gd2*s**2 + 196*D1*Dd*f*gd2*s - 84*D1*Dd*f*gd2 - 112*D1*Dd*fd*g2*r**2 - 224*D1*Dd*fd*g2*r*s + 196*D1*Dd*fd*g2*r - 112*D1*Dd*fd*g2*s**2 + 196*D1*Dd*fd*g2*s - 84*D1*Dd*fd*g2 + 28*D1*Ddd*b2*f*r**2 + 56*D1*Ddd*b2*f*r*s - 42*D1*Ddd*b2*f*r + 28*D1*Ddd*b2*f*s**2 - 42*D1*Ddd*b2*f*s + 21*D1*Ddd*b2*f - 12*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 18*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 56*D1*Ddd*f*g2*r**2 - 112*D1*Ddd*f*g2*r*s + 84*D1*Ddd*f*g2*r - 56*D1*Ddd*f*g2*s**2 + 84*D1*Ddd*f*g2*s - 42*D1*Ddd*f*g2 + 7*D1*K*bd1*(D1*(3*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 7*D1*bd2*(D1*(3*f + 2*fd)*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 84*Dd**2*b2*f*r**2 + 168*Dd**2*b2*f*r*s - 126*Dd**2*b2*f*r + 84*Dd**2*b2*f*s**2 - 126*Dd**2*b2*f*s + 42*Dd**2*b2*f - 36*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 54*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 18*Dd**2*f**2 - 168*Dd**2*f*g2*r**2 - 336*Dd**2*f*g2*r*s + 252*Dd**2*f*g2*r - 168*Dd**2*f*g2*s**2 + 252*Dd**2*f*g2*s - 84*Dd**2*f*g2))/(210*d**2*k3**2) - D1**2*Pk2*Pkdd3*k1**2*(2*D1**2*bd1**2*(5*b2 + f*(6*C - 3) - 10*g2)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*b1*(10*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1*bdd1*(f*(6*C - 3) - 10*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*b2*(D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + bd1*(10*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - D1*(f*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(6 - 12*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 10*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(f*(6*C - 3) - 10*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 5*K*b1**3*(D1*(Dd + Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-2*C*D1**2*fd*r**2 - 4*C*D1**2*fd*r*s + 4*C*D1**2*fd*r - 2*C*D1**2*fd*s**2 + 4*C*D1**2*fd*s - 2*C*D1**2*fd + 6*C*D1**2*fdd*r**2 + 12*C*D1**2*fdd*r*s - 12*C*D1**2*fdd*r + 6*C*D1**2*fdd*s**2 - 12*C*D1**2*fdd*s + 6*C*D1**2*fdd - 8*C*D1*Dd*f*r**2 - 16*C*D1*Dd*f*r*s + 12*C*D1*Dd*f*r - 8*C*D1*Dd*f*s**2 + 12*C*D1*Dd*f*s - 6*C*D1*Dd*f + 48*C*D1*Dd*fd*r**2 + 96*C*D1*Dd*fd*r*s - 84*C*D1*Dd*fd*r + 48*C*D1*Dd*fd*s**2 - 84*C*D1*Dd*fd*s + 36*C*D1*Dd*fd + 24*C*D1*Ddd*f*r**2 + 48*C*D1*Ddd*f*r*s - 36*C*D1*Ddd*f*r + 24*C*D1*Ddd*f*s**2 - 36*C*D1*Ddd*f*s + 18*C*D1*Ddd*f + 72*C*Dd**2*f*r**2 + 144*C*Dd**2*f*r*s - 108*C*Dd**2*f*r + 72*C*Dd**2*f*s**2 - 108*C*Dd**2*f*s + 36*C*Dd**2*f + 15*D1**2*K*bd1*r**2 + 30*D1**2*K*bd1*r*s - 20*D1**2*K*bd1*r + 15*D1**2*K*bd1*s**2 - 20*D1**2*K*bd1*s + 10*D1**2*K*bd1 + 15*D1**2*K*bdd1*r**2 + 30*D1**2*K*bdd1*r*s - 20*D1**2*K*bdd1*r + 15*D1**2*K*bdd1*s**2 - 20*D1**2*K*bdd1*s + 10*D1**2*K*bdd1 + 5*D1**2*bdd2*(r + s - 1)**2 + D1**2*fd*r**2 + 2*D1**2*fd*r*s - 2*D1**2*fd*r + D1**2*fd*s**2 - 2*D1**2*fd*s + D1**2*fd - 3*D1**2*fdd*r**2 - 6*D1**2*fdd*r*s + 6*D1**2*fdd*r - 3*D1**2*fdd*s**2 + 6*D1**2*fdd*s - 3*D1**2*fdd - 10*D1**2*gd2*r**2 - 20*D1**2*gd2*r*s + 20*D1**2*gd2*r - 10*D1**2*gd2*s**2 + 20*D1**2*gd2*s - 10*D1**2*gd2 - 10*D1**2*gdd2*r**2 - 20*D1**2*gdd2*r*s + 20*D1**2*gdd2*r - 10*D1**2*gdd2*s**2 + 20*D1**2*gdd2*s - 10*D1**2*gdd2 + 120*D1*Dd*K*bd1*r**2 + 240*D1*Dd*K*bd1*r*s - 170*D1*Dd*K*bd1*r + 120*D1*Dd*K*bd1*s**2 - 170*D1*Dd*K*bd1*s + 60*D1*Dd*K*bd1 + 20*D1*Dd*b2*r**2 + 40*D1*Dd*b2*r*s - 30*D1*Dd*b2*r + 20*D1*Dd*b2*s**2 - 30*D1*Dd*b2*s + 15*D1*Dd*b2 + 4*D1*Dd*f*r**2 + 8*D1*Dd*f*r*s - 6*D1*Dd*f*r + 4*D1*Dd*f*s**2 - 6*D1*Dd*f*s + 3*D1*Dd*f - 24*D1*Dd*fd*r**2 - 48*D1*Dd*fd*r*s + 42*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 42*D1*Dd*fd*s - 18*D1*Dd*fd - 40*D1*Dd*g2*r**2 - 80*D1*Dd*g2*r*s + 60*D1*Dd*g2*r - 40*D1*Dd*g2*s**2 + 60*D1*Dd*g2*s - 30*D1*Dd*g2 - 80*D1*Dd*gd2*r**2 - 160*D1*Dd*gd2*r*s + 140*D1*Dd*gd2*r - 80*D1*Dd*gd2*s**2 + 140*D1*Dd*gd2*s - 60*D1*Dd*gd2 + 20*D1*Ddd*b2*r**2 + 40*D1*Ddd*b2*r*s - 30*D1*Ddd*b2*r + 20*D1*Ddd*b2*s**2 - 30*D1*Ddd*b2*s + 15*D1*Ddd*b2 - 12*D1*Ddd*f*r**2 - 24*D1*Ddd*f*r*s + 18*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 18*D1*Ddd*f*s - 9*D1*Ddd*f - 40*D1*Ddd*g2*r**2 - 80*D1*Ddd*g2*r*s + 60*D1*Ddd*g2*r - 40*D1*Ddd*g2*s**2 + 60*D1*Ddd*g2*s - 30*D1*Ddd*g2 + 5*D1*bd2*(D1*(r + s - 1) + 2*Dd*(4*r + 4*s - 3))*(r + s - 1) + 60*Dd**2*b2*r**2 + 120*Dd**2*b2*r*s - 90*Dd**2*b2*r + 60*Dd**2*b2*s**2 - 90*Dd**2*b2*s + 30*Dd**2*b2 - 36*Dd**2*f*r**2 - 72*Dd**2*f*r*s + 54*Dd**2*f*r - 36*Dd**2*f*s**2 + 54*Dd**2*f*s - 18*Dd**2*f - 120*Dd**2*g2*r**2 - 240*Dd**2*g2*r*s + 180*Dd**2*g2*r - 120*Dd**2*g2*s**2 + 180*Dd**2*g2*s - 60*Dd**2*g2))/(30*d**2*k3**2) + D1**2*Pk2*Pkdd3*k2**6*st**6*(D1**2*(f**2*(-fd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(9*K*(-2*bd1 + bdd1) + 36*gd2 - 18*gdd2)) + f*(fd**2*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 18*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 9*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 18*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(-2*Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - fd*(2*C - 1)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 18*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 18*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 9*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + Ddd*f*(2*C*f + 9*K*b1 - f - 18*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f**2*(2*C*f + 9*K*b1 - f - 18*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(126*d**2*k3**6) - D1**2*Pk2*Pkdd3*k2**6*st**4*(8*C*D1**2*b1*f*fd*r**2 + 16*C*D1**2*b1*f*fd*r*s - 8*C*D1**2*b1*f*fd*r + 8*C*D1**2*b1*f*fd*s**2 - 8*C*D1**2*b1*f*fd*s + 4*C*D1**2*b1*f*fd - 4*C*D1**2*b1*f*fdd*r**2 - 8*C*D1**2*b1*f*fdd*r*s + 4*C*D1**2*b1*f*fdd*r - 4*C*D1**2*b1*f*fdd*s**2 + 4*C*D1**2*b1*f*fdd*s - 2*C*D1**2*b1*f*fdd - 4*C*D1**2*b1*fd**2*r**2 - 8*C*D1**2*b1*fd**2*r*s + 4*C*D1**2*b1*fd**2*r - 4*C*D1**2*b1*fd**2*s**2 + 4*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 16*C*D1*Dd*b1*f**2*r**2 + 32*C*D1*Dd*b1*f**2*r*s - 24*C*D1*Dd*b1*f**2*r + 16*C*D1*Dd*b1*f**2*s**2 - 24*C*D1*Dd*b1*f**2*s + 12*C*D1*Dd*b1*f**2 - 32*C*D1*Dd*b1*f*fd*r**2 - 64*C*D1*Dd*b1*f*fd*r*s + 40*C*D1*Dd*b1*f*fd*r - 32*C*D1*Dd*b1*f*fd*s**2 + 40*C*D1*Dd*b1*f*fd*s - 12*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 8*C*D1*Ddd*b1*f**2*r**2 - 16*C*D1*Ddd*b1*f**2*r*s + 12*C*D1*Ddd*b1*f**2*r - 8*C*D1*Ddd*b1*f**2*s**2 + 12*C*D1*Ddd*b1*f**2*s - 6*C*D1*Ddd*b1*f**2 - 24*C*Dd**2*b1*f**2*r**2 - 48*C*Dd**2*b1*f**2*r*s + 36*C*Dd**2*b1*f**2*r - 24*C*Dd**2*b1*f**2*s**2 + 36*C*Dd**2*b1*f**2*s - 12*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r**2 + 28*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r**2 - 14*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r**2 - 28*D1**2*K*b1*f*fd*r*s + 14*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 14*D1**2*K*bd1**2*f*(r + s - 1)**2 - 4*D1**2*b1*f*fd*r**2 - 8*D1**2*b1*f*fd*r*s + 4*D1**2*b1*f*fd*r - 4*D1**2*b1*f*fd*s**2 + 4*D1**2*b1*f*fd*s - 2*D1**2*b1*f*fd + 2*D1**2*b1*f*fdd*r**2 + 4*D1**2*b1*f*fdd*r*s - 2*D1**2*b1*f*fdd*r + 2*D1**2*b1*f*fdd*s**2 - 2*D1**2*b1*f*fdd*s + D1**2*b1*f*fdd - 28*D1**2*b1*f*gd2*r**2 - 56*D1**2*b1*f*gd2*r*s + 56*D1**2*b1*f*gd2*r - 28*D1**2*b1*f*gd2*s**2 + 56*D1**2*b1*f*gd2*s - 28*D1**2*b1*f*gd2 + 14*D1**2*b1*f*gdd2*r**2 + 28*D1**2*b1*f*gdd2*r*s - 28*D1**2*b1*f*gdd2*r + 14*D1**2*b1*f*gdd2*s**2 - 28*D1**2*b1*f*gdd2*s + 14*D1**2*b1*f*gdd2 + 2*D1**2*b1*fd**2*r**2 + 4*D1**2*b1*fd**2*r*s - 2*D1**2*b1*fd**2*r + 2*D1**2*b1*fd**2*s**2 - 2*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r**2 - 56*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r**2 + 56*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*r + 28*D1**2*b1*fd*gd2*s**2 - 28*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r**2 + 28*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(2*C*f + 14*K*b1 - f - 14*g2) + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r**2 + 28*D1**2*f**2*gd2*r*s - 28*D1**2*f**2*gd2*r + 14*D1**2*f**2*gd2*s**2 - 28*D1**2*f**2*gd2*s + 14*D1**2*f**2*gd2 + 28*D1**2*f*fd*g2*r**2 + 56*D1**2*f*fd*g2*r*s - 28*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r**2 + 112*D1*Dd*K*b1**2*f*r*s - 84*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 84*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r**2 - 112*D1*Dd*K*b1**2*fd*r*s + 42*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 42*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r**2 - 56*D1*Dd*K*b1*f**2*r*s + 42*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 42*D1*Dd*K*b1*f**2*s - 21*D1*Dd*K*b1*f**2 - 8*D1*Dd*b1*f**2*r**2 - 16*D1*Dd*b1*f**2*r*s + 12*D1*Dd*b1*f**2*r - 8*D1*Dd*b1*f**2*s**2 + 12*D1*Dd*b1*f**2*s - 6*D1*Dd*b1*f**2 + 16*D1*Dd*b1*f*fd*r**2 + 32*D1*Dd*b1*f*fd*r*s - 20*D1*Dd*b1*f*fd*r + 16*D1*Dd*b1*f*fd*s**2 - 20*D1*Dd*b1*f*fd*s + 6*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r**2 - 224*D1*Dd*b1*f*g2*r*s + 168*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 168*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r**2 + 224*D1*Dd*b1*f*gd2*r*s - 196*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 196*D1*Dd*b1*f*gd2*s + 84*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r**2 + 224*D1*Dd*b1*fd*g2*r*s - 84*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 84*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r**2 + 112*D1*Dd*f**2*g2*r*s - 84*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 84*D1*Dd*f**2*g2*s + 42*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r**2 - 56*D1*Ddd*K*b1**2*f*r*s + 42*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 42*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 4*D1*Ddd*b1*f**2*r**2 + 8*D1*Ddd*b1*f**2*r*s - 6*D1*Ddd*b1*f**2*r + 4*D1*Ddd*b1*f**2*s**2 - 6*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r**2 + 112*D1*Ddd*b1*f*g2*r*s - 84*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 84*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(4*C - 7*K - 2)*(r + s - 1) - f*fd*(4*C - 2)*(2*r + 2*s - 1) - 28*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 28*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(2*C*f + 14*K*b1 - f - 14*g2))*(r + s - 1) - 84*Dd**2*K*b1**2*f*r**2 - 168*Dd**2*K*b1**2*f*r*s + 126*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 126*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 12*Dd**2*b1*f**2*r**2 + 24*Dd**2*b1*f**2*r*s - 18*Dd**2*b1*f**2*r + 12*Dd**2*b1*f**2*s**2 - 18*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r**2 + 336*Dd**2*b1*f*g2*r*s - 252*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 252*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(70*d**2*k3**6) + D1**2*Pk2*Pkdd3*k2**4*st**6*(12*C*D1**2*f**2*fd*r**2 + 24*C*D1**2*f**2*fd*r*s - 16*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 16*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r**2 - 12*C*D1**2*f**2*fdd*r*s + 8*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 8*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r**2 - 24*C*D1**2*f*fd**2*r*s + 16*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 16*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r**2 + 32*C*D1*Dd*f**3*r*s - 24*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 12*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r**2 - 96*C*D1*Dd*f**2*fd*r*s + 68*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 68*C*D1*Dd*f**2*fd*s - 24*C*D1*Dd*f**2*fd - 8*C*D1*Ddd*f**3*r**2 - 16*C*D1*Ddd*f**3*r*s + 12*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 12*C*D1*Ddd*f**3*s - 6*C*D1*Ddd*f**3 - 24*C*Dd**2*f**3*r**2 - 48*C*Dd**2*f**3*r*s + 36*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 36*C*Dd**2*f**3*s - 12*C*Dd**2*f**3 + 36*D1**2*K*b1*f*fd*r**2 + 72*D1**2*K*b1*f*fd*r*s - 36*D1**2*K*b1*f*fd*r + 36*D1**2*K*b1*f*fd*s**2 - 36*D1**2*K*b1*f*fd*s + 18*D1**2*K*b1*f*fd - 18*D1**2*K*b1*f*fdd*r**2 - 36*D1**2*K*b1*f*fdd*r*s + 18*D1**2*K*b1*f*fdd*r - 18*D1**2*K*b1*f*fdd*s**2 + 18*D1**2*K*b1*f*fdd*s - 9*D1**2*K*b1*f*fdd - 18*D1**2*K*b1*fd**2*r**2 - 36*D1**2*K*b1*fd**2*r*s + 18*D1**2*K*b1*fd**2*r - 18*D1**2*K*b1*fd**2*s**2 + 18*D1**2*K*b1*fd**2*s + 18*D1**2*K*bd1*f**2*r**2 + 36*D1**2*K*bd1*f**2*r*s - 36*D1**2*K*bd1*f**2*r + 18*D1**2*K*bd1*f**2*s**2 - 36*D1**2*K*bd1*f**2*s + 18*D1**2*K*bd1*f**2 - 36*D1**2*K*bd1*f*fd*r**2 - 72*D1**2*K*bd1*f*fd*r*s + 54*D1**2*K*bd1*f*fd*r - 36*D1**2*K*bd1*f*fd*s**2 + 54*D1**2*K*bd1*f*fd*s - 18*D1**2*K*bd1*f*fd - 9*D1**2*K*bdd1*f**2*r**2 - 18*D1**2*K*bdd1*f**2*r*s + 18*D1**2*K*bdd1*f**2*r - 9*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s - 9*D1**2*K*bdd1*f**2 + 36*D1**2*b2*f*fd*r**2 + 72*D1**2*b2*f*fd*r*s - 36*D1**2*b2*f*fd*r + 36*D1**2*b2*f*fd*s**2 - 36*D1**2*b2*f*fd*s + 18*D1**2*b2*f*fd - 18*D1**2*b2*f*fdd*r**2 - 36*D1**2*b2*f*fdd*r*s + 18*D1**2*b2*f*fdd*r - 18*D1**2*b2*f*fdd*s**2 + 18*D1**2*b2*f*fdd*s - 9*D1**2*b2*f*fdd - 18*D1**2*b2*fd**2*r**2 - 36*D1**2*b2*fd**2*r*s + 18*D1**2*b2*fd**2*r - 18*D1**2*b2*fd**2*s**2 + 18*D1**2*b2*fd**2*s - 9*D1**2*bdd2*f**2*(r + s - 1)**2 - 6*D1**2*f**2*fd*r**2 - 12*D1**2*f**2*fd*r*s + 8*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 8*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 6*D1**2*f**2*fdd*r*s - 4*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 4*D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd - 36*D1**2*f**2*gd2*r**2 - 72*D1**2*f**2*gd2*r*s + 72*D1**2*f**2*gd2*r - 36*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s - 36*D1**2*f**2*gd2 + 18*D1**2*f**2*gdd2*r**2 + 36*D1**2*f**2*gdd2*r*s - 36*D1**2*f**2*gdd2*r + 18*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 18*D1**2*f**2*gdd2 + 6*D1**2*f*fd**2*r**2 + 12*D1**2*f*fd**2*r*s - 8*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 8*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 - 72*D1**2*f*fd*g2*r**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 72*D1**2*f*fd*g2*s - 36*D1**2*f*fd*g2 + 72*D1**2*f*fd*gd2*r**2 + 144*D1**2*f*fd*gd2*r*s - 108*D1**2*f*fd*gd2*r + 72*D1**2*f*fd*gd2*s**2 - 108*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 36*D1**2*f*fdd*g2*r**2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 36*D1**2*fd**2*g2*r**2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 72*D1*Dd*K*b1*f**2*r**2 + 144*D1*Dd*K*b1*f**2*r*s - 108*D1*Dd*K*b1*f**2*r + 72*D1*Dd*K*b1*f**2*s**2 - 108*D1*Dd*K*b1*f**2*s + 54*D1*Dd*K*b1*f**2 - 144*D1*Dd*K*b1*f*fd*r**2 - 288*D1*Dd*K*b1*f*fd*r*s + 180*D1*Dd*K*b1*f*fd*r - 144*D1*Dd*K*b1*f*fd*s**2 + 180*D1*Dd*K*b1*f*fd*s - 54*D1*Dd*K*b1*f*fd - 72*D1*Dd*K*bd1*f**2*r**2 - 144*D1*Dd*K*bd1*f**2*r*s + 126*D1*Dd*K*bd1*f**2*r - 72*D1*Dd*K*bd1*f**2*s**2 + 126*D1*Dd*K*bd1*f**2*s - 54*D1*Dd*K*bd1*f**2 + 72*D1*Dd*b2*f**2*r**2 + 144*D1*Dd*b2*f**2*r*s - 108*D1*Dd*b2*f**2*r + 72*D1*Dd*b2*f**2*s**2 - 108*D1*Dd*b2*f**2*s + 54*D1*Dd*b2*f**2 - 144*D1*Dd*b2*f*fd*r**2 - 288*D1*Dd*b2*f*fd*r*s + 180*D1*Dd*b2*f*fd*r - 144*D1*Dd*b2*f*fd*s**2 + 180*D1*Dd*b2*f*fd*s - 54*D1*Dd*b2*f*fd - 8*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 48*D1*Dd*f**2*fd*r*s - 34*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 34*D1*Dd*f**2*fd*s + 12*D1*Dd*f**2*fd - 144*D1*Dd*f**2*g2*r**2 - 288*D1*Dd*f**2*g2*r*s + 216*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 216*D1*Dd*f**2*g2*s - 108*D1*Dd*f**2*g2 + 144*D1*Dd*f**2*gd2*r**2 + 288*D1*Dd*f**2*gd2*r*s - 252*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s**2 - 252*D1*Dd*f**2*gd2*s + 108*D1*Dd*f**2*gd2 + 288*D1*Dd*f*fd*g2*r**2 + 576*D1*Dd*f*fd*g2*r*s - 360*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s**2 - 360*D1*Dd*f*fd*g2*s + 108*D1*Dd*f*fd*g2 - 36*D1*Ddd*K*b1*f**2*r**2 - 72*D1*Ddd*K*b1*f**2*r*s + 54*D1*Ddd*K*b1*f**2*r - 36*D1*Ddd*K*b1*f**2*s**2 + 54*D1*Ddd*K*b1*f**2*s - 27*D1*Ddd*K*b1*f**2 - 36*D1*Ddd*b2*f**2*r**2 - 72*D1*Ddd*b2*f**2*r*s + 54*D1*Ddd*b2*f**2*r - 36*D1*Ddd*b2*f**2*s**2 + 54*D1*Ddd*b2*f**2*s - 27*D1*Ddd*b2*f**2 + 4*D1*Ddd*f**3*r**2 + 8*D1*Ddd*f**3*r*s - 6*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 6*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 72*D1*Ddd*f**2*g2*r**2 + 144*D1*Ddd*f**2*g2*r*s - 108*D1*Ddd*f**2*g2*r + 72*D1*Ddd*f**2*g2*s**2 - 108*D1*Ddd*f**2*g2*s + 54*D1*Ddd*f**2*g2 + 18*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 108*Dd**2*K*b1*f**2*r**2 - 216*Dd**2*K*b1*f**2*r*s + 162*Dd**2*K*b1*f**2*r - 108*Dd**2*K*b1*f**2*s**2 + 162*Dd**2*K*b1*f**2*s - 54*Dd**2*K*b1*f**2 - 108*Dd**2*b2*f**2*r**2 - 216*Dd**2*b2*f**2*r*s + 162*Dd**2*b2*f**2*r - 108*Dd**2*b2*f**2*s**2 + 162*Dd**2*b2*f**2*s - 54*Dd**2*b2*f**2 + 12*Dd**2*f**3*r**2 + 24*Dd**2*f**3*r*s - 18*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 18*Dd**2*f**3*s + 6*Dd**2*f**3 + 216*Dd**2*f**2*g2*r**2 + 432*Dd**2*f**2*g2*r*s - 324*Dd**2*f**2*g2*r + 216*Dd**2*f**2*g2*s**2 - 324*Dd**2*f**2*g2*s + 108*Dd**2*f**2*g2)/(126*d**2*k3**4) + D1**2*Pk2*Pkdd3*k2**4*st**4*(D1*(7*K*b1**2*(D1*(2*fd - fdd)*(2*r + 2*s - 1) - 2*Dd*fd*(4*r + 4*s - 3)) + b1*(8*C*D1*f*fd*r + 8*C*D1*f*fd*s - 4*C*D1*f*fd - 4*C*D1*f*fdd*r - 4*C*D1*f*fdd*s + 2*C*D1*f*fdd - 4*C*D1*fd**2*r - 4*C*D1*fd**2*s + 4*C*D1*fd**2 - 16*C*Dd*f*fd*r - 16*C*Dd*f*fd*s + 12*C*Dd*f*fd - 28*D1*K*bd1*f*r - 28*D1*K*bd1*f*s + 14*D1*K*bd1*f - 14*D1*K*bd1*fd*r - 14*D1*K*bd1*fd*s + 14*D1*K*bd1*fd + 14*D1*K*bdd1*f*r + 14*D1*K*bdd1*f*s - 7*D1*K*bdd1*f - 14*D1*K*f*fd*r**2 - 28*D1*K*f*fd*r*s + 14*D1*K*f*fd*r - 14*D1*K*f*fd*s**2 + 14*D1*K*f*fd*s - 7*D1*K*f*fd - 7*D1*bdd2*f*(r + s - 1)**2 - 4*D1*f*fd*r - 4*D1*f*fd*s + 2*D1*f*fd + 2*D1*f*fdd*r + 2*D1*f*fdd*s - D1*f*fdd + 2*D1*fd**2*r + 2*D1*fd**2*s - 2*D1*fd**2 - 56*D1*fd*g2*r - 56*D1*fd*g2*s + 28*D1*fd*g2 + 28*D1*fd*gd2*r + 28*D1*fd*gd2*s - 28*D1*fd*gd2 + 28*D1*fdd*g2*r + 28*D1*fdd*g2*s - 14*D1*fdd*g2 + 56*Dd*K*bd1*f*r + 56*Dd*K*bd1*f*s - 42*Dd*K*bd1*f - 28*Dd*K*f**2*r**2 - 56*Dd*K*f**2*r*s + 42*Dd*K*f**2*r - 28*Dd*K*f**2*s**2 + 42*Dd*K*f**2*s - 21*Dd*K*f**2 + 8*Dd*f*fd*r + 8*Dd*f*fd*s - 6*Dd*f*fd + 112*Dd*fd*g2*r + 112*Dd*fd*g2*s - 84*Dd*fd*g2 + 14*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3))) + f*(4*C*D1*bdd1*f*r + 4*C*D1*bdd1*f*s - 2*C*D1*bdd1*f - 6*C*D1*f*fd*r**2 - 12*C*D1*f*fd*r*s + 8*C*D1*f*fd*r - 6*C*D1*f*fd*s**2 + 8*C*D1*f*fd*s - 4*C*D1*f*fd - 8*C*Dd*f**2*r**2 - 16*C*Dd*f**2*r*s + 12*C*Dd*f**2*r - 8*C*Dd*f**2*s**2 + 12*C*Dd*f**2*s - 6*C*Dd*f**2 + 14*D1*K*bd1**2*(r + s - 1) - 7*D1*bd2*f*r**2 - 14*D1*bd2*f*r*s + 14*D1*bd2*f*r - 7*D1*bd2*f*s**2 + 14*D1*bd2*f*s - 7*D1*bd2*f - 2*D1*bdd1*f*r - 2*D1*bdd1*f*s + D1*bdd1*f - 28*D1*bdd1*g2*r - 28*D1*bdd1*g2*s + 14*D1*bdd1*g2 + 3*D1*f*fd*r**2 + 6*D1*f*fd*r*s - 4*D1*f*fd*r + 3*D1*f*fd*s**2 - 4*D1*f*fd*s + 2*D1*f*fd + 14*D1*f*gd2*r**2 + 28*D1*f*gd2*r*s - 28*D1*f*gd2*r + 14*D1*f*gd2*s**2 - 28*D1*f*gd2*s + 14*D1*f*gd2 + 28*D1*fd*g2*r**2 + 56*D1*fd*g2*r*s - 28*D1*fd*g2*r + 28*D1*fd*g2*s**2 - 28*D1*fd*g2*s + 14*D1*fd*g2 + 4*Dd*f**2*r**2 + 8*Dd*f**2*r*s - 6*Dd*f**2*r + 4*Dd*f**2*s**2 - 6*Dd*f**2*s + 3*Dd*f**2 + 56*Dd*f*g2*r**2 + 112*Dd*f*g2*r*s - 84*Dd*f*g2*r + 56*Dd*f*g2*s**2 - 84*Dd*f*g2*s + 42*Dd*f*g2 - bd1*(14*D1*bd2*(r + s - 1)**2 + D1*(-4*C*fd*r - 4*C*fd*s + 4*C*fd + f*(C*(8*r + 8*s - 4) + 7*K*(r + s - 1)**2 - 4*r - 4*s + 2) + 2*fd*r + 2*fd*s - 2*fd - 56*g2*r - 56*g2*s + 28*g2 + 28*gd2*r + 28*gd2*s - 28*gd2) - 2*Dd*(f*(2*C - 1) - 14*g2)*(4*r + 4*s - 3)))) + 7*b2*(2*D1**2*b1*fd*r**2 + 4*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r**2 - 2*D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r**2 + 16*D1*Dd*b1*f*r*s - 12*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 12*D1*Dd*b1*f*s + 6*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r**2 - 16*D1*Dd*b1*fd*r*s + 6*D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 6*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 4*D1*Ddd*b1*f*r**2 - 8*D1*Ddd*b1*f*r*s + 6*D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 6*D1*Ddd*b1*f*s - 3*D1*Ddd*b1*f + 2*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*b1*f*r**2 - 24*Dd**2*b1*f*r*s + 18*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 18*Dd**2*b1*f*s - 6*Dd**2*b1*f))/(70*d**2*k3**4) - D1**2*Pk2*Pkdd3*k2**4*st**2*(D1**2*bd1*(5*b2*f*(r + s - 1)**2 - (2*bd1*(r**2 + r*(2*s - 1) + s*(s - 1)) + f*(2*r + 2*s - 1))*(f*(2*C - 1) - 10*g2)) + D1*b1*(-4*C*D1*bdd1*f*r**2 - 8*C*D1*bdd1*f*r*s + 4*C*D1*bdd1*f*r - 4*C*D1*bdd1*f*s**2 + 4*C*D1*bdd1*f*s - 2*C*D1*bdd1*f + 4*C*D1*f*fd*r + 4*C*D1*f*fd*s - 2*C*D1*f*fd - 10*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 5*D1*b2*fd*r**2 + 10*D1*b2*fd*r*s + 5*D1*b2*fd*s**2 + 5*D1*bd2*f*(r + s - 1)**2 + 2*D1*bdd1*f*r**2 + 4*D1*bdd1*f*r*s - 2*D1*bdd1*f*r + 2*D1*bdd1*f*s**2 - 2*D1*bdd1*f*s + D1*bdd1*f + 20*D1*bdd1*g2*r**2 + 40*D1*bdd1*g2*r*s - 20*D1*bdd1*g2*r + 20*D1*bdd1*g2*s**2 - 20*D1*bdd1*g2*s + 10*D1*bdd1*g2 - 2*D1*f*fd*r - 2*D1*f*fd*s + D1*f*fd - 20*D1*fd*g2*r - 20*D1*fd*g2*s + 10*D1*fd*g2 + 20*Dd*b2*f*r**2 + 40*Dd*b2*f*r*s - 30*Dd*b2*f*r + 20*Dd*b2*f*s**2 - 30*Dd*b2*f*s + 15*Dd*b2*f + bd1*(D1*(f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*K*(2*r + 2*s - 1) - 4*r**2 - 8*r*s + 4*r - 4*s**2 + 4*s - 2) + fd*(2 - 4*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 20*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(2*C - 1) - 10*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 5*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(5*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(4*C*(r + s - 1)**2 + 5*K*(2*r + 2*s - 1) - 2*(r + s - 1)**2) - fdd*(2*C - 1)*(r + s - 1)**2 - 20*gd2*(r + s - 1)**2 + 10*gdd2*(r + s - 1)**2) + D1*(2*Dd*(f*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(2*C - 1)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 10*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(20*r + 20*s - 15)) - Ddd*(f*(2*C - 1) - 10*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(f*(2*C - 1) - 10*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(30*d**2*k3**4) + D1**2*Pk2*Pkdd3*k2**2*st**4*(-D1*(r + s)*(14*D1*K*bd1**2*f*(r + s - 1) + D1*bdd1*f*(r + s)*(7*b2 + f*(2*C - 1) - 14*g2) + 2*bd1*(-2*C*D1*f**2*r - 2*C*D1*f**2*s + 4*C*D1*f*fd*r + 4*C*D1*f*fd*s - 4*C*D1*f*fd + 8*C*Dd*f**2*r + 8*C*Dd*f**2*s - 6*C*Dd*f**2 + 7*D1*bd2*f*(r + s - 1) + D1*f**2*r + D1*f**2*s - 2*D1*f*fd*r - 2*D1*f*fd*s + 2*D1*f*fd + 14*D1*f*g2*r + 14*D1*f*g2*s - 14*D1*f*gd2*r - 14*D1*f*gd2*s + 14*D1*f*gd2 - 14*D1*fd*g2*r - 14*D1*fd*g2*s + 14*D1*fd*g2 - 4*Dd*f**2*r - 4*Dd*f**2*s + 3*Dd*f**2 - 56*Dd*f*g2*r - 56*Dd*f*g2*s + 42*Dd*f*g2 + 7*b2*(-D1*f*(r + s) + D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))) + 7*K*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(8*C*D1**2*f*fd*r**2 + 16*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 16*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 - 8*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 8*C*D1**2*f*fdd*s - 4*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 - 8*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 8*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 + 16*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 24*C*D1*Dd*f**2*s + 12*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 - 64*C*D1*Dd*f*fd*r*s + 56*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 56*C*D1*Dd*f*fd*s - 24*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 - 16*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 12*C*D1*Ddd*f**2*s - 6*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 - 48*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 36*C*Dd**2*f**2*s - 12*C*Dd**2*f**2 + 28*D1**2*K*bd1*f*r**2 + 56*D1**2*K*bd1*f*r*s - 28*D1**2*K*bd1*f*r + 28*D1**2*K*bd1*f*s**2 - 28*D1**2*K*bd1*f*s + 14*D1**2*K*bd1*f - 28*D1**2*K*bd1*fd*r**2 - 56*D1**2*K*bd1*fd*r*s + 42*D1**2*K*bd1*fd*r - 28*D1**2*K*bd1*fd*s**2 + 42*D1**2*K*bd1*fd*s - 14*D1**2*K*bd1*fd - 14*D1**2*K*bdd1*f*r**2 - 28*D1**2*K*bdd1*f*r*s + 14*D1**2*K*bdd1*f*r - 14*D1**2*K*bdd1*f*s**2 + 14*D1**2*K*bdd1*f*s - 7*D1**2*K*bdd1*f + 14*D1**2*b2*fd*r**2 + 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*r + 14*D1**2*b2*fd*s**2 - 28*D1**2*b2*fd*s + 14*D1**2*b2*fd - 7*D1**2*b2*fdd*r**2 - 14*D1**2*b2*fdd*r*s + 14*D1**2*b2*fdd*r - 7*D1**2*b2*fdd*s**2 + 14*D1**2*b2*fdd*s - 7*D1**2*b2*fdd - 7*D1**2*bdd2*f*(r + s - 1)**2 - 4*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 4*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 4*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 4*D1**2*f*fdd*s + 2*D1**2*f*fdd - 28*D1**2*f*gd2*r**2 - 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*r - 28*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s - 28*D1**2*f*gd2 + 14*D1**2*f*gdd2*r**2 + 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 + 2*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 4*D1**2*fd**2*s + 2*D1**2*fd**2 - 28*D1**2*fd*g2*r**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 28*D1**2*fd*gd2*r**2 + 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 56*D1**2*fd*gd2*s + 28*D1**2*fd*gd2 + 14*D1**2*fdd*g2*r**2 + 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 112*D1*Dd*K*bd1*f*r**2 - 224*D1*Dd*K*bd1*f*r*s + 140*D1*Dd*K*bd1*f*r - 112*D1*Dd*K*bd1*f*s**2 + 140*D1*Dd*K*bd1*f*s - 42*D1*Dd*K*bd1*f + 56*D1*Dd*b2*f*r**2 + 112*D1*Dd*b2*f*r*s - 84*D1*Dd*b2*f*r + 56*D1*Dd*b2*f*s**2 - 84*D1*Dd*b2*f*s + 42*D1*Dd*b2*f - 56*D1*Dd*b2*fd*r**2 - 112*D1*Dd*b2*fd*r*s + 98*D1*Dd*b2*fd*r - 56*D1*Dd*b2*fd*s**2 + 98*D1*Dd*b2*fd*s - 42*D1*Dd*b2*fd - 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 32*D1*Dd*f*fd*r*s - 28*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 28*D1*Dd*f*fd*s + 12*D1*Dd*f*fd - 112*D1*Dd*f*g2*r**2 - 224*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 84*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r**2 + 224*D1*Dd*f*gd2*r*s - 196*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 196*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r**2 + 224*D1*Dd*fd*g2*r*s - 196*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 196*D1*Dd*fd*g2*s + 84*D1*Dd*fd*g2 - 28*D1*Ddd*b2*f*r**2 - 56*D1*Ddd*b2*f*r*s + 42*D1*Ddd*b2*f*r - 28*D1*Ddd*b2*f*s**2 + 42*D1*Ddd*b2*f*s - 21*D1*Ddd*b2*f + 4*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r**2 + 112*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 84*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 14*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 84*Dd**2*b2*f*r**2 - 168*Dd**2*b2*f*r*s + 126*Dd**2*b2*f*r - 84*Dd**2*b2*f*s**2 + 126*Dd**2*b2*f*s - 42*Dd**2*b2*f + 12*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 18*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s + 6*Dd**2*f**2 + 168*Dd**2*f*g2*r**2 + 336*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 252*Dd**2*f*g2*s + 84*Dd**2*f*g2))/(70*d**2*k3**2) + D1**2*Pk2*Pkdd3*k2**2*st**2*(-D1**2*bd1*(r + s)*(2*bd1*(r + s - 1) + f*(r + s))*(5*b2 + f*(2*C - 1) - 10*g2) + D1*b1*(-4*C*D1*bdd1*f*r**2 - 8*C*D1*bdd1*f*r*s + 4*C*D1*bdd1*f*r - 4*C*D1*bdd1*f*s**2 + 4*C*D1*bdd1*f*s - 2*C*D1*bdd1*f - 4*C*D1*f*fd*r**2 - 8*C*D1*f*fd*r*s + 8*C*D1*f*fd*r - 4*C*D1*f*fd*s**2 + 8*C*D1*f*fd*s - 4*C*D1*f*fd - 8*C*Dd*f**2*r**2 - 16*C*Dd*f**2*r*s + 12*C*Dd*f**2*r - 8*C*Dd*f**2*s**2 + 12*C*Dd*f**2*s - 6*C*Dd*f**2 - 10*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 5*D1*bd2*f*r**2 - 10*D1*bd2*f*r*s + 10*D1*bd2*f*r - 5*D1*bd2*f*s**2 + 10*D1*bd2*f*s - 5*D1*bd2*f + 2*D1*bdd1*f*r**2 + 4*D1*bdd1*f*r*s - 2*D1*bdd1*f*r + 2*D1*bdd1*f*s**2 - 2*D1*bdd1*f*s + D1*bdd1*f + 20*D1*bdd1*g2*r**2 + 40*D1*bdd1*g2*r*s - 20*D1*bdd1*g2*r + 20*D1*bdd1*g2*s**2 - 20*D1*bdd1*g2*s + 10*D1*bdd1*g2 + 2*D1*f*fd*r**2 + 4*D1*f*fd*r*s - 4*D1*f*fd*r + 2*D1*f*fd*s**2 - 4*D1*f*fd*s + 2*D1*f*fd + 10*D1*f*gd2*r**2 + 20*D1*f*gd2*r*s - 20*D1*f*gd2*r + 10*D1*f*gd2*s**2 - 20*D1*f*gd2*s + 10*D1*f*gd2 + 10*D1*fd*g2*r**2 + 20*D1*fd*g2*r*s - 20*D1*fd*g2*r + 10*D1*fd*g2*s**2 - 20*D1*fd*g2*s + 10*D1*fd*g2 + 4*Dd*f**2*r**2 + 8*Dd*f**2*r*s - 6*Dd*f**2*r + 4*Dd*f**2*s**2 - 6*Dd*f**2*s + 3*Dd*f**2 + 40*Dd*f*g2*r**2 + 80*Dd*f*g2*r*s - 60*Dd*f*g2*r + 40*Dd*f*g2*s**2 - 60*Dd*f*g2*s + 30*Dd*f*g2 + 5*b2*(2*D1*bd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - D1*fd*r**2 - 2*D1*fd*r*s + 2*D1*fd*r - D1*fd*s**2 + 2*D1*fd*s - D1*fd - 2*Dd*bd1*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 4*Dd*f*r**2 - 8*Dd*f*r*s + 6*Dd*f*r - 4*Dd*f*s**2 + 6*Dd*f*s - 3*Dd*f) - bd1*(10*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-f*(4*C - 5*K - 2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(4*C - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 20*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 20*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(f*(2*C - 1) - 10*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 5*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(4*C*D1**2*fd*r**2 + 8*C*D1**2*fd*r*s - 8*C*D1**2*fd*r + 4*C*D1**2*fd*s**2 - 8*C*D1**2*fd*s + 4*C*D1**2*fd - 2*C*D1**2*fdd*r**2 - 4*C*D1**2*fdd*r*s + 4*C*D1**2*fdd*r - 2*C*D1**2*fdd*s**2 + 4*C*D1**2*fdd*s - 2*C*D1**2*fdd + 16*C*D1*Dd*f*r**2 + 32*C*D1*Dd*f*r*s - 24*C*D1*Dd*f*r + 16*C*D1*Dd*f*s**2 - 24*C*D1*Dd*f*s + 12*C*D1*Dd*f - 16*C*D1*Dd*fd*r**2 - 32*C*D1*Dd*fd*r*s + 28*C*D1*Dd*fd*r - 16*C*D1*Dd*fd*s**2 + 28*C*D1*Dd*fd*s - 12*C*D1*Dd*fd - 8*C*D1*Ddd*f*r**2 - 16*C*D1*Ddd*f*r*s + 12*C*D1*Ddd*f*r - 8*C*D1*Ddd*f*s**2 + 12*C*D1*Ddd*f*s - 6*C*D1*Ddd*f - 24*C*Dd**2*f*r**2 - 48*C*Dd**2*f*r*s + 36*C*Dd**2*f*r - 24*C*Dd**2*f*s**2 + 36*C*Dd**2*f*s - 12*C*Dd**2*f + 30*D1**2*K*bd1*r**2 + 60*D1**2*K*bd1*r*s - 40*D1**2*K*bd1*r + 30*D1**2*K*bd1*s**2 - 40*D1**2*K*bd1*s + 20*D1**2*K*bd1 - 15*D1**2*K*bdd1*r**2 - 30*D1**2*K*bdd1*r*s + 20*D1**2*K*bdd1*r - 15*D1**2*K*bdd1*s**2 + 20*D1**2*K*bdd1*s - 10*D1**2*K*bdd1 - 5*D1**2*K*fd*r**2 - 10*D1**2*K*fd*r*s + 10*D1**2*K*fd*r - 5*D1**2*K*fd*s**2 + 10*D1**2*K*fd*s - 5*D1**2*K*fd - 5*D1**2*bdd2*(r + s - 1)**2 - 2*D1**2*fd*r**2 - 4*D1**2*fd*r*s + 4*D1**2*fd*r - 2*D1**2*fd*s**2 + 4*D1**2*fd*s - 2*D1**2*fd + D1**2*fdd*r**2 + 2*D1**2*fdd*r*s - 2*D1**2*fdd*r + D1**2*fdd*s**2 - 2*D1**2*fdd*s + D1**2*fdd - 20*D1**2*gd2*r**2 - 40*D1**2*gd2*r*s + 40*D1**2*gd2*r - 20*D1**2*gd2*s**2 + 40*D1**2*gd2*s - 20*D1**2*gd2 + 10*D1**2*gdd2*r**2 + 20*D1**2*gdd2*r*s - 20*D1**2*gdd2*r + 10*D1**2*gdd2*s**2 - 20*D1**2*gdd2*s + 10*D1**2*gdd2 - 120*D1*Dd*K*bd1*r**2 - 240*D1*Dd*K*bd1*r*s + 170*D1*Dd*K*bd1*r - 120*D1*Dd*K*bd1*s**2 + 170*D1*Dd*K*bd1*s - 60*D1*Dd*K*bd1 - 20*D1*Dd*K*f*r**2 - 40*D1*Dd*K*f*r*s + 30*D1*Dd*K*f*r - 20*D1*Dd*K*f*s**2 + 30*D1*Dd*K*f*s - 15*D1*Dd*K*f + 40*D1*Dd*b2*r**2 + 80*D1*Dd*b2*r*s - 60*D1*Dd*b2*r + 40*D1*Dd*b2*s**2 - 60*D1*Dd*b2*s + 30*D1*Dd*b2 - 8*D1*Dd*f*r**2 - 16*D1*Dd*f*r*s + 12*D1*Dd*f*r - 8*D1*Dd*f*s**2 + 12*D1*Dd*f*s - 6*D1*Dd*f + 8*D1*Dd*fd*r**2 + 16*D1*Dd*fd*r*s - 14*D1*Dd*fd*r + 8*D1*Dd*fd*s**2 - 14*D1*Dd*fd*s + 6*D1*Dd*fd - 80*D1*Dd*g2*r**2 - 160*D1*Dd*g2*r*s + 120*D1*Dd*g2*r - 80*D1*Dd*g2*s**2 + 120*D1*Dd*g2*s - 60*D1*Dd*g2 + 80*D1*Dd*gd2*r**2 + 160*D1*Dd*gd2*r*s - 140*D1*Dd*gd2*r + 80*D1*Dd*gd2*s**2 - 140*D1*Dd*gd2*s + 60*D1*Dd*gd2 - 20*D1*Ddd*b2*r**2 - 40*D1*Ddd*b2*r*s + 30*D1*Ddd*b2*r - 20*D1*Ddd*b2*s**2 + 30*D1*Ddd*b2*s - 15*D1*Ddd*b2 + 4*D1*Ddd*f*r**2 + 8*D1*Ddd*f*r*s - 6*D1*Ddd*f*r + 4*D1*Ddd*f*s**2 - 6*D1*Ddd*f*s + 3*D1*Ddd*f + 40*D1*Ddd*g2*r**2 + 80*D1*Ddd*g2*r*s - 60*D1*Ddd*g2*r + 40*D1*Ddd*g2*s**2 - 60*D1*Ddd*g2*s + 30*D1*Ddd*g2 + 10*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 60*Dd**2*b2*r**2 - 120*Dd**2*b2*r*s + 90*Dd**2*b2*r - 60*Dd**2*b2*s**2 + 90*Dd**2*b2*s - 30*Dd**2*b2 + 12*Dd**2*f*r**2 + 24*Dd**2*f*r*s - 18*Dd**2*f*r + 12*Dd**2*f*s**2 - 18*Dd**2*f*s + 6*Dd**2*f + 120*Dd**2*g2*r**2 + 240*Dd**2*g2*r*s - 180*Dd**2*g2*r + 120*Dd**2*g2*s**2 - 180*Dd**2*g2*s + 60*Dd**2*g2))/(30*d**2*k3**2) + 4*D1**2*Pk3*Pkd2*ct**8*k1**2*k2**3*(924*C*D1**2*f**2*fd*r*s - 308*C*D1**2*f**2*fd*r + 924*C*D1**2*f**2*fd*s**2 - 924*C*D1**2*f**2*fd*s + 308*C*D1**2*f**2*fd - 462*C*D1**2*f**2*fdd*r*s + 154*C*D1**2*f**2*fdd*r - 462*C*D1**2*f**2*fdd*s**2 + 462*C*D1**2*f**2*fdd*s - 154*C*D1**2*f**2*fdd - 924*C*D1**2*f*fd**2*r*s + 308*C*D1**2*f*fd**2*r - 924*C*D1**2*f*fd**2*s**2 + 924*C*D1**2*f*fd**2*s - 154*C*D1**2*f*fd**2 + 1232*C*D1*Dd*f**3*r*s - 308*C*D1*Dd*f**3*r + 1232*C*D1*Dd*f**3*s**2 - 1232*C*D1*Dd*f**3*s + 308*C*D1*Dd*f**3 - 3696*C*D1*Dd*f**2*fd*r*s + 1078*C*D1*Dd*f**2*fd*r - 3696*C*D1*Dd*f**2*fd*s**2 + 3696*C*D1*Dd*f**2*fd*s - 770*C*D1*Dd*f**2*fd - 616*C*D1*Ddd*f**3*r*s + 154*C*D1*Ddd*f**3*r - 616*C*D1*Ddd*f**3*s**2 + 616*C*D1*Ddd*f**3*s - 154*C*D1*Ddd*f**3 - 1848*C*Dd**2*f**3*r*s + 462*C*Dd**2*f**3*r - 1848*C*Dd**2*f**3*s**2 + 1848*C*Dd**2*f**3*s - 308*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 504*D1**2*f**3*fd*r*s - 126*D1**2*f**3*fd*r + 504*D1**2*f**3*fd*s**2 - 504*D1**2*f**3*fd*s + 126*D1**2*f**3*fd - 252*D1**2*f**3*fdd*r*s + 63*D1**2*f**3*fdd*r - 252*D1**2*f**3*fdd*s**2 + 252*D1**2*f**3*fdd*s - 63*D1**2*f**3*fdd - 756*D1**2*f**2*fd**2*r*s + 189*D1**2*f**2*fd**2*r - 756*D1**2*f**2*fd**2*s**2 + 756*D1**2*f**2*fd**2*s - 126*D1**2*f**2*fd**2 - 924*D1**2*f**2*fd*r*s + 308*D1**2*f**2*fd*r - 924*D1**2*f**2*fd*s**2 + 924*D1**2*f**2*fd*s - 308*D1**2*f**2*fd + 462*D1**2*f**2*fdd*r*s - 154*D1**2*f**2*fdd*r + 462*D1**2*f**2*fdd*s**2 - 462*D1**2*f**2*fdd*s + 154*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 924*D1**2*f*fd**2*r*s - 308*D1**2*f*fd**2*r + 924*D1**2*f*fd**2*s**2 - 924*D1**2*f*fd**2*s + 154*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 504*D1*Dd*f**4*r*s - 126*D1*Dd*f**4*r + 504*D1*Dd*f**4*s**2 - 504*D1*Dd*f**4*s + 126*D1*Dd*f**4 - 2016*D1*Dd*f**3*fd*r*s + 504*D1*Dd*f**3*fd*r - 2016*D1*Dd*f**3*fd*s**2 + 2016*D1*Dd*f**3*fd*s - 378*D1*Dd*f**3*fd - 1232*D1*Dd*f**3*r*s + 308*D1*Dd*f**3*r - 1232*D1*Dd*f**3*s**2 + 1232*D1*Dd*f**3*s - 308*D1*Dd*f**3 + 3696*D1*Dd*f**2*fd*r*s - 1078*D1*Dd*f**2*fd*r + 3696*D1*Dd*f**2*fd*s**2 - 3696*D1*Dd*f**2*fd*s + 770*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 252*D1*Ddd*f**4*r*s + 63*D1*Ddd*f**4*r - 252*D1*Ddd*f**4*s**2 + 252*D1*Ddd*f**4*s - 63*D1*Ddd*f**4 + 616*D1*Ddd*f**3*r*s - 154*D1*Ddd*f**3*r + 616*D1*Ddd*f**3*s**2 - 616*D1*Ddd*f**3*s + 154*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 756*Dd**2*f**4*r*s + 189*Dd**2*f**4*r - 756*Dd**2*f**4*s**2 + 756*Dd**2*f**4*s - 126*Dd**2*f**4 + 1848*Dd**2*f**3*r*s - 462*Dd**2*f**3*r + 1848*Dd**2*f**3*s**2 - 1848*Dd**2*f**3*s + 308*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**8*k1**2*k2*(D1**2*(63*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-378*fd**2*s*(2*s - 1) + fd*(308*C - 308)*(3*s**2 - 2*s + 1) - fdd*(154*C - 154)*(3*s**2 - 2*s + 1) + s**2*(-99*K*bdd1 + 198*bd1*(K - 1) + 99*bdd1 - 396*gd2 + 198*gdd2)) - 22*f*(fd**2*s*(14*C - 14)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 396*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(63*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(22*C*(4*s**2 - 2*s + 1) - 9*fd*(1 - 4*s)**2 - 88*s**2 + 44*s - 22) - 11*f*(fd*(14*C - 14)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(63*f**2 + f*(154*C - 154) - 198*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(63*f**2 + f*(154*C - 154) - 198*g2) + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**4) + 4*D1**2*Pk3*Pkd2*ct**7*k1**3*k2**2*(10890*C*D1**2*f**2*fd*r*s - 3630*C*D1**2*f**2*fd*r + 10890*C*D1**2*f**2*fd*s**2 - 10890*C*D1**2*f**2*fd*s + 3630*C*D1**2*f**2*fd - 6930*C*D1**2*f**2*fdd*r*s + 2310*C*D1**2*f**2*fdd*r - 6930*C*D1**2*f**2*fdd*s**2 + 6930*C*D1**2*f**2*fdd*s - 2310*C*D1**2*f**2*fdd - 13860*C*D1**2*f*fd**2*r*s + 4620*C*D1**2*f*fd**2*r - 13860*C*D1**2*f*fd**2*s**2 + 13860*C*D1**2*f*fd**2*s - 2310*C*D1**2*f*fd**2 + 14520*C*D1*Dd*f**3*r*s - 3630*C*D1*Dd*f**3*r + 14520*C*D1*Dd*f**3*s**2 - 14520*C*D1*Dd*f**3*s + 3630*C*D1*Dd*f**3 - 55440*C*D1*Dd*f**2*fd*r*s + 16170*C*D1*Dd*f**2*fd*r - 55440*C*D1*Dd*f**2*fd*s**2 + 55440*C*D1*Dd*f**2*fd*s - 11550*C*D1*Dd*f**2*fd - 9240*C*D1*Ddd*f**3*r*s + 2310*C*D1*Ddd*f**3*r - 9240*C*D1*Ddd*f**3*s**2 + 9240*C*D1*Ddd*f**3*s - 2310*C*D1*Ddd*f**3 - 27720*C*Dd**2*f**3*r*s + 6930*C*Dd**2*f**3*r - 27720*C*Dd**2*f**3*s**2 + 27720*C*Dd**2*f**3*s - 4620*C*Dd**2*f**3 - 1485*D1**2*K*bdd1*f**2*r*s - 1485*D1**2*K*bdd1*f**2*s**2 + 1485*D1**2*K*bdd1*f**2*s + 1485*D1**2*bdd1*f**2*r*s + 1485*D1**2*bdd1*f**2*s**2 - 1485*D1**2*bdd1*f**2*s + 8540*D1**2*f**3*fd*r*s - 2135*D1**2*f**3*fd*r + 8540*D1**2*f**3*fd*s**2 - 8540*D1**2*f**3*fd*s + 2135*D1**2*f**3*fd - 5040*D1**2*f**3*fdd*r*s + 1260*D1**2*f**3*fdd*r - 5040*D1**2*f**3*fdd*s**2 + 5040*D1**2*f**3*fdd*s - 1260*D1**2*f**3*fdd - 15120*D1**2*f**2*fd**2*r*s + 3780*D1**2*f**2*fd**2*r - 15120*D1**2*f**2*fd**2*s**2 + 15120*D1**2*f**2*fd**2*s - 2520*D1**2*f**2*fd**2 - 10890*D1**2*f**2*fd*r*s + 3630*D1**2*f**2*fd*r - 10890*D1**2*f**2*fd*s**2 + 10890*D1**2*f**2*fd*s - 3630*D1**2*f**2*fd + 6930*D1**2*f**2*fdd*r*s - 2310*D1**2*f**2*fdd*r + 6930*D1**2*f**2*fdd*s**2 - 6930*D1**2*f**2*fdd*s + 2310*D1**2*f**2*fdd - 4554*D1**2*f**2*gd2*r*s - 4554*D1**2*f**2*gd2*s**2 + 4554*D1**2*f**2*gd2*s + 2970*D1**2*f**2*gdd2*r*s + 2970*D1**2*f**2*gdd2*s**2 - 2970*D1**2*f**2*gdd2*s + 13860*D1**2*f*fd**2*r*s - 4620*D1**2*f*fd**2*r + 13860*D1**2*f*fd**2*s**2 - 13860*D1**2*f*fd**2*s + 2310*D1**2*f*fd**2 - 9108*D1**2*f*fd*g2*r*s + 4554*D1**2*f*fd*g2*r - 9108*D1**2*f*fd*g2*s**2 + 9108*D1**2*f*fd*g2*s - 4554*D1**2*f*fd*g2 + 11880*D1**2*f*fd*gd2*r*s - 2970*D1**2*f*fd*gd2*r + 11880*D1**2*f*fd*gd2*s**2 - 11880*D1**2*f*fd*gd2*s + 2970*D1**2*f*fd*gd2 + 5940*D1**2*f*fdd*g2*r*s - 2970*D1**2*f*fdd*g2*r + 5940*D1**2*f*fdd*g2*s**2 - 5940*D1**2*f*fdd*g2*s + 2970*D1**2*f*fdd*g2 + 5940*D1**2*fd**2*g2*r*s - 2970*D1**2*fd**2*g2*r + 5940*D1**2*fd**2*g2*s**2 - 5940*D1**2*fd**2*g2*s + 8540*D1*Dd*f**4*r*s - 2135*D1*Dd*f**4*r + 8540*D1*Dd*f**4*s**2 - 8540*D1*Dd*f**4*s + 2135*D1*Dd*f**4 - 40320*D1*Dd*f**3*fd*r*s + 10080*D1*Dd*f**3*fd*r - 40320*D1*Dd*f**3*fd*s**2 + 40320*D1*Dd*f**3*fd*s - 7560*D1*Dd*f**3*fd - 14520*D1*Dd*f**3*r*s + 3630*D1*Dd*f**3*r - 14520*D1*Dd*f**3*s**2 + 14520*D1*Dd*f**3*s - 3630*D1*Dd*f**3 + 55440*D1*Dd*f**2*fd*r*s - 16170*D1*Dd*f**2*fd*r + 55440*D1*Dd*f**2*fd*s**2 - 55440*D1*Dd*f**2*fd*s + 11550*D1*Dd*f**2*fd - 18216*D1*Dd*f**2*g2*r*s + 4554*D1*Dd*f**2*g2*r - 18216*D1*Dd*f**2*g2*s**2 + 18216*D1*Dd*f**2*g2*s - 4554*D1*Dd*f**2*g2 + 23760*D1*Dd*f**2*gd2*r*s - 2970*D1*Dd*f**2*gd2*r + 23760*D1*Dd*f**2*gd2*s**2 - 23760*D1*Dd*f**2*gd2*s + 2970*D1*Dd*f**2*gd2 + 47520*D1*Dd*f*fd*g2*r*s - 17820*D1*Dd*f*fd*g2*r + 47520*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 11880*D1*Dd*f*fd*g2 - 5040*D1*Ddd*f**4*r*s + 1260*D1*Ddd*f**4*r - 5040*D1*Ddd*f**4*s**2 + 5040*D1*Ddd*f**4*s - 1260*D1*Ddd*f**4 + 9240*D1*Ddd*f**3*r*s - 2310*D1*Ddd*f**3*r + 9240*D1*Ddd*f**3*s**2 - 9240*D1*Ddd*f**3*s + 2310*D1*Ddd*f**3 + 11880*D1*Ddd*f**2*g2*r*s - 2970*D1*Ddd*f**2*g2*r + 11880*D1*Ddd*f**2*g2*s**2 - 11880*D1*Ddd*f**2*g2*s + 2970*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 15120*Dd**2*f**4*r*s + 3780*Dd**2*f**4*r - 15120*Dd**2*f**4*s**2 + 15120*Dd**2*f**4*s - 2520*Dd**2*f**4 + 27720*Dd**2*f**3*r*s - 6930*Dd**2*f**3*r + 27720*Dd**2*f**3*s**2 - 27720*Dd**2*f**3*s + 4620*Dd**2*f**3 + 35640*Dd**2*f**2*g2*r*s - 8910*Dd**2*f**2*g2*r + 35640*Dd**2*f**2*g2*s**2 - 35640*Dd**2*f**2*g2*s + 5940*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**7*k1**3*(D1**2*(189*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(567*fd**2*s*(2*s - 1) - fd*(308*C - 308)*(3*s**2 - 2*s + 1) + fdd*(154*C - 154)*(3*s**2 - 2*s + 1) + s**2*(99*K*bdd1 - 198*bd1*(K - 1) - 99*bdd1 + 396*gd2 - 198*gdd2)) - 44*f*(fd**2*s*(14*C - 14)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 792*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(189*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(44*C*(4*s**2 - 2*s + 1) - 27*fd*(1 - 4*s)**2 - 176*s**2 + 88*s - 44) - 22*f*(fd*(14*C - 14)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 396*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(189*f**2 + f*(308*C - 308) - 396*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(189*f**2 + f*(308*C - 308) - 396*g2) + 198*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**4) + 4*D1**2*Pk3*Pkd2*ct**7*k1*k2**4*(168*C*D1**2*f**2*fd*r*s - 56*C*D1**2*f**2*fd*r + 168*C*D1**2*f**2*fd*s**2 - 168*C*D1**2*f**2*fd*s + 56*C*D1**2*f**2*fd - 84*C*D1**2*f**2*fdd*r*s + 28*C*D1**2*f**2*fdd*r - 84*C*D1**2*f**2*fdd*s**2 + 84*C*D1**2*f**2*fdd*s - 28*C*D1**2*f**2*fdd - 168*C*D1**2*f*fd**2*r*s + 56*C*D1**2*f*fd**2*r - 168*C*D1**2*f*fd**2*s**2 + 168*C*D1**2*f*fd**2*s - 28*C*D1**2*f*fd**2 + 224*C*D1*Dd*f**3*r*s - 56*C*D1*Dd*f**3*r + 224*C*D1*Dd*f**3*s**2 - 224*C*D1*Dd*f**3*s + 56*C*D1*Dd*f**3 - 672*C*D1*Dd*f**2*fd*r*s + 196*C*D1*Dd*f**2*fd*r - 672*C*D1*Dd*f**2*fd*s**2 + 672*C*D1*Dd*f**2*fd*s - 140*C*D1*Dd*f**2*fd - 112*C*D1*Ddd*f**3*r*s + 28*C*D1*Ddd*f**3*r - 112*C*D1*Ddd*f**3*s**2 + 112*C*D1*Ddd*f**3*s - 28*C*D1*Ddd*f**3 - 336*C*Dd**2*f**3*r*s + 84*C*Dd**2*f**3*r - 336*C*Dd**2*f**3*s**2 + 336*C*Dd**2*f**3*s - 56*C*Dd**2*f**3 - 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s + 7*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 - 7*D1**2*bdd1*f**3*s + 9*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 - 9*D1**2*bdd1*f**2*s - 126*D1**2*f**2*fd*r*s + 42*D1**2*f**2*fd*r - 126*D1**2*f**2*fd*s**2 + 126*D1**2*f**2*fd*s - 42*D1**2*f**2*fd + 63*D1**2*f**2*fdd*r*s - 21*D1**2*f**2*fdd*r + 63*D1**2*f**2*fdd*s**2 - 63*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 126*D1**2*f*fd**2*r*s - 42*D1**2*f*fd**2*r + 126*D1**2*f*fd**2*s**2 - 126*D1**2*f*fd**2*s + 21*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 168*D1*Dd*f**3*r*s + 42*D1*Dd*f**3*r - 168*D1*Dd*f**3*s**2 + 168*D1*Dd*f**3*s - 42*D1*Dd*f**3 + 504*D1*Dd*f**2*fd*r*s - 147*D1*Dd*f**2*fd*r + 504*D1*Dd*f**2*fd*s**2 - 504*D1*Dd*f**2*fd*s + 105*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r*s - 36*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 288*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r*s - 216*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 576*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 84*D1*Ddd*f**3*r*s - 21*D1*Ddd*f**3*r + 84*D1*Ddd*f**3*s**2 - 84*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-18*K + 7*f + 9)*(r + s - 1) - 9*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-18*K + 7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 252*Dd**2*f**3*r*s - 63*Dd**2*f**3*r + 252*Dd**2*f**3*s**2 - 252*Dd**2*f**3*s + 42*Dd**2*f**3 + 432*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1)) - 9*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (36*K - 18)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 7*f + 9)) + Dd**2*f**2*(-18*K + 7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**7*k1*k2**2*(-432*C*D1**2*f**2*fd*r*s + 144*C*D1**2*f**2*fd*r + 840*C*D1**2*f**2*fd*s**2 - 416*C*D1**2*f**2*fd*s + 280*C*D1**2*f**2*fd + 216*C*D1**2*f**2*fdd*r*s - 72*C*D1**2*f**2*fdd*r - 420*C*D1**2*f**2*fdd*s**2 + 208*C*D1**2*f**2*fdd*s - 140*C*D1**2*f**2*fdd + 432*C*D1**2*f*fd**2*r*s - 144*C*D1**2*f*fd**2*r - 840*C*D1**2*f*fd**2*s**2 + 416*C*D1**2*f*fd**2*s + 72*C*D1**2*f*fd**2 - 576*C*D1*Dd*f**3*r*s + 144*C*D1*Dd*f**3*r + 1120*C*D1*Dd*f**3*s**2 - 272*C*D1*Dd*f**3*s + 280*C*D1*Dd*f**3 + 1728*C*D1*Dd*f**2*fd*r*s - 504*C*D1*Dd*f**2*fd*r - 3360*C*D1*Dd*f**2*fd*s**2 + 1240*C*D1*Dd*f**2*fd*s - 64*C*D1*Dd*f**2*fd + 288*C*D1*Ddd*f**3*r*s - 72*C*D1*Ddd*f**3*r - 560*C*D1*Ddd*f**3*s**2 + 136*C*D1*Ddd*f**3*s - 140*C*D1*Ddd*f**3 + 864*C*Dd**2*f**3*r*s - 216*C*Dd**2*f**3*r - 1680*C*Dd**2*f**3*s**2 + 408*C*Dd**2*f**3*s + 144*C*Dd**2*f**3 + 36*D1**2*K*bdd1*f**2*r*s - 90*D1**2*K*bdd1*f**2*s**2 - 36*D1**2*K*bdd1*f**2*s - 28*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 + 28*D1**2*bdd1*f**3*s - 72*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 + 72*D1**2*bdd1*f**2*s - 112*D1**2*f**3*fd*r*s + 28*D1**2*f**3*fd*r + 56*D1**2*f**3*fd*s + 112*D1**2*f**3*fdd*r*s - 28*D1**2*f**3*fdd*r - 56*D1**2*f**3*fdd*s + 336*D1**2*f**2*fd**2*r*s - 84*D1**2*f**2*fd**2*r - 168*D1**2*f**2*fd**2*s + 56*D1**2*f**2*fd**2 + 600*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r - 462*D1**2*f**2*fd*s**2 + 108*D1**2*f**2*fd*s - 154*D1**2*f**2*fd - 300*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r + 231*D1**2*f**2*fdd*s**2 - 54*D1**2*f**2*fdd*s + 77*D1**2*f**2*fdd + 144*D1**2*f**2*gd2*r*s - 360*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s - 72*D1**2*f**2*gdd2*r*s + 180*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 600*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r + 462*D1**2*f*fd**2*s**2 - 108*D1**2*f*fd**2*s - 100*D1**2*f*fd**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r - 720*D1**2*f*fd*g2*s**2 + 720*D1**2*f*fd*g2*s - 360*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r*s + 72*D1**2*f*fd*gd2*r + 720*D1**2*f*fd*gd2*s**2 - 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r + 360*D1**2*f*fdd*g2*s**2 - 360*D1**2*f*fdd*g2*s + 180*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r + 360*D1**2*fd**2*g2*s**2 - 360*D1**2*fd**2*g2*s - 112*D1*Dd*f**4*r*s + 28*D1*Dd*f**4*r + 56*D1*Dd*f**4*s + 896*D1*Dd*f**3*fd*r*s - 224*D1*Dd*f**3*fd*r - 448*D1*Dd*f**3*fd*s + 112*D1*Dd*f**3*fd + 800*D1*Dd*f**3*r*s - 200*D1*Dd*f**3*r - 616*D1*Dd*f**3*s**2 - 92*D1*Dd*f**3*s - 154*D1*Dd*f**3 - 2400*D1*Dd*f**2*fd*r*s + 700*D1*Dd*f**2*fd*r + 1848*D1*Dd*f**2*fd*s**2 - 78*D1*Dd*f**2*fd*s - 146*D1*Dd*f**2*fd + 576*D1*Dd*f**2*g2*r*s - 144*D1*Dd*f**2*g2*r - 1440*D1*Dd*f**2*g2*s**2 + 432*D1*Dd*f**2*g2*s - 360*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r*s + 72*D1*Dd*f**2*gd2*r + 1440*D1*Dd*f**2*gd2*s**2 + 72*D1*Dd*f**2*gd2*s - 72*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r*s + 432*D1*Dd*f*fd*g2*r + 2880*D1*Dd*f*fd*g2*s**2 - 1872*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 + 112*D1*Ddd*f**4*r*s - 28*D1*Ddd*f**4*r - 56*D1*Ddd*f**4*s - 400*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r + 308*D1*Ddd*f**3*s**2 + 46*D1*Ddd*f**3*s + 77*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r*s + 72*D1*Ddd*f**2*g2*r + 720*D1*Ddd*f**2*g2*s**2 - 216*D1*Ddd*f**2*g2*s + 180*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(f*s*(-18*K*(2*r - 5*s - 2) + 7*f*(4*r - s - 4) + 72*r - 9*s - 72) + fd*(9*K*(8*r*s - 2*r - 20*s**2 + 6*s + 2) + 7*f*(r*(2 - 12*s) + 3*s**2 + 7*s - 2) - 144*r*s + 36*r + 18*s**2 + 63*s - 36)) + Dd*f*(-18*K*(-8*r*s + r + 20*s**2 + s - 1) + 7*f*(r*(2 - 16*s) + 4*s**2 + 11*s - 2) - 288*r*s + 36*r + 36*s**2 + 207*s - 36)) + 336*Dd**2*f**4*r*s - 84*Dd**2*f**4*r - 168*Dd**2*f**4*s + 56*Dd**2*f**4 - 1200*Dd**2*f**3*r*s + 300*Dd**2*f**3*r + 924*Dd**2*f**3*s**2 + 138*Dd**2*f**3*s - 200*Dd**2*f**3 - 864*Dd**2*f**2*g2*r*s + 216*Dd**2*f**2*g2*r + 2160*Dd**2*f**2*g2*s**2 - 648*Dd**2*f**2*g2*s - 144*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(4 - 12*s) + 3*s**2 + 2*s + 1) + f*(14*fd**2*(r*(4 - 12*s) + 3*s**2 + 2*s - 2) - 18*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1) + 9*fdd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1)) + 18*fd**2*(r*(2*K - 4)*(2*s - 1) - s*(10*K - 1)*(s - 1))) + D1*f*(2*Dd*(-7*f**2*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) + f*(-18*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + fd*(r*(98 - 336*s) + 84*s**2 + 91*s - 35) + 288*r*s - 72*r - 36*s**2 - 126*s - 9) + 9*fd*(2*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) - 64*r*s + 24*r + 8*s**2 + 10*s - 7)) + Ddd*f*(18*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + 7*f*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) - 288*r*s + 72*r + 36*s**2 + 126*s + 9)) + 2*Dd**2*f**2*(18*K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) + 7*f*(r*(6 - 24*s) + 6*s**2 + 9*s - 4) - 432*r*s + 108*r + 54*s**2 + 189*s - 72)))/(126*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**7*k1*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 18*fd*(2*s**2 - 2*s + 1) - 9*fdd*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) + f*(-14*fd*(s**2*(3*bd1 - 3) - s*(bd1 - 2) - 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(-2*Dd*(7*f*(s**2*(4*bd1 - 4) - s*(bd1 - 2) - 1) + (4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1))) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k3**2) + 4*D1**2*Pk3*Pkd2*ct**6*k1**4*k2*(2640*C*D1**2*f**2*fd*r*s - 880*C*D1**2*f**2*fd*r + 2640*C*D1**2*f**2*fd*s**2 - 2640*C*D1**2*f**2*fd*s + 880*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r*s + 770*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 2310*C*D1**2*f**2*fdd*s - 770*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r*s + 1540*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 4620*C*D1**2*f*fd**2*s - 770*C*D1**2*f*fd**2 + 3520*C*D1*Dd*f**3*r*s - 880*C*D1*Dd*f**3*r + 3520*C*D1*Dd*f**3*s**2 - 3520*C*D1*Dd*f**3*s + 880*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r*s + 5390*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 18480*C*D1*Dd*f**2*fd*s - 3850*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r*s + 770*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 3080*C*D1*Ddd*f**3*s - 770*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r*s + 2310*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 9240*C*Dd**2*f**3*s - 1540*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 3500*D1**2*f**3*fd*r*s - 875*D1**2*f**3*fd*r + 3500*D1**2*f**3*fd*s**2 - 3500*D1**2*f**3*fd*s + 875*D1**2*f**3*fd - 2520*D1**2*f**3*fdd*r*s + 630*D1**2*f**3*fdd*r - 2520*D1**2*f**3*fdd*s**2 + 2520*D1**2*f**3*fdd*s - 630*D1**2*f**3*fdd - 7560*D1**2*f**2*fd**2*r*s + 1890*D1**2*f**2*fd**2*r - 7560*D1**2*f**2*fd**2*s**2 + 7560*D1**2*f**2*fd**2*s - 1260*D1**2*f**2*fd**2 - 2640*D1**2*f**2*fd*r*s + 880*D1**2*f**2*fd*r - 2640*D1**2*f**2*fd*s**2 + 2640*D1**2*f**2*fd*s - 880*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r*s - 770*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2310*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd - 1056*D1**2*f**2*gd2*r*s - 1056*D1**2*f**2*gd2*s**2 + 1056*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 4620*D1**2*f*fd**2*r*s - 1540*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 4620*D1**2*f*fd**2*s + 770*D1**2*f*fd**2 - 2112*D1**2*f*fd*g2*r*s + 1056*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s**2 + 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 3500*D1*Dd*f**4*r*s - 875*D1*Dd*f**4*r + 3500*D1*Dd*f**4*s**2 - 3500*D1*Dd*f**4*s + 875*D1*Dd*f**4 - 20160*D1*Dd*f**3*fd*r*s + 5040*D1*Dd*f**3*fd*r - 20160*D1*Dd*f**3*fd*s**2 + 20160*D1*Dd*f**3*fd*s - 3780*D1*Dd*f**3*fd - 3520*D1*Dd*f**3*r*s + 880*D1*Dd*f**3*r - 3520*D1*Dd*f**3*s**2 + 3520*D1*Dd*f**3*s - 880*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r*s - 5390*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 18480*D1*Dd*f**2*fd*s + 3850*D1*Dd*f**2*fd - 4224*D1*Dd*f**2*g2*r*s + 1056*D1*Dd*f**2*g2*r - 4224*D1*Dd*f**2*g2*s**2 + 4224*D1*Dd*f**2*g2*s - 1056*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 2520*D1*Ddd*f**4*r*s + 630*D1*Ddd*f**4*r - 2520*D1*Ddd*f**4*s**2 + 2520*D1*Ddd*f**4*s - 630*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r*s - 770*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 3080*D1*Ddd*f**3*s + 770*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(16*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 7560*Dd**2*f**4*r*s + 1890*Dd**2*f**4*r - 7560*Dd**2*f**4*s**2 + 7560*Dd**2*f**4*s - 1260*Dd**2*f**4 + 9240*Dd**2*f**3*r*s - 2310*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 9240*Dd**2*f**3*s + 1540*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(16*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - 15*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**6*k1**4*(D1**2*(189*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-1134*fd**2*s*(2*s - 1) + fd*(308*C - 308)*(3*s**2 - 2*s + 1) - fdd*(154*C - 154)*(3*s**2 - 2*s + 1) + s**2*(-99*K*bdd1 + 198*bd1*(K - 1) + 99*bdd1 - 396*gd2 + 198*gdd2)) - 22*f*(fd**2*s*(14*C - 14)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 396*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(189*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(22*C*(4*s**2 - 2*s + 1) - 27*fd*(1 - 4*s)**2 - 88*s**2 + 44*s - 22) - 11*f*(fd*(14*C - 14)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(189*f**2 + f*(154*C - 154) - 198*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(189*f**2 + f*(154*C - 154) - 198*g2) + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k2*k3**4) + 4*D1**2*Pk3*Pkd2*ct**6*k1**2*k2**3*st**2*(1980*C*D1**2*f**2*fd*r*s - 660*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd*s**2 - 1980*C*D1**2*f**2*fd*s + 660*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 2640*C*D1*Dd*f**3*r*s - 660*C*D1*Dd*f**3*r + 2640*C*D1*Dd*f**3*s**2 - 2640*C*D1*Dd*f**3*s + 660*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 1568*D1**2*f**3*fd*r*s - 392*D1**2*f**3*fd*r + 1568*D1**2*f**3*fd*s**2 - 1568*D1**2*f**3*fd*s + 392*D1**2*f**3*fd - 784*D1**2*f**3*fdd*r*s + 196*D1**2*f**3*fdd*r - 784*D1**2*f**3*fdd*s**2 + 784*D1**2*f**3*fdd*s - 196*D1**2*f**3*fdd - 2352*D1**2*f**2*fd**2*r*s + 588*D1**2*f**2*fd**2*r - 2352*D1**2*f**2*fd**2*s**2 + 2352*D1**2*f**2*fd**2*s - 392*D1**2*f**2*fd**2 - 1980*D1**2*f**2*fd*r*s + 660*D1**2*f**2*fd*r - 1980*D1**2*f**2*fd*s**2 + 1980*D1**2*f**2*fd*s - 660*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 1188*D1**2*f**2*gd2*r*s - 1188*D1**2*f**2*gd2*s**2 + 1188*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 2376*D1**2*f*fd*g2*r*s + 1188*D1**2*f*fd*g2*r - 2376*D1**2*f*fd*g2*s**2 + 2376*D1**2*f*fd*g2*s - 1188*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 1568*D1*Dd*f**4*r*s - 392*D1*Dd*f**4*r + 1568*D1*Dd*f**4*s**2 - 1568*D1*Dd*f**4*s + 392*D1*Dd*f**4 - 6272*D1*Dd*f**3*fd*r*s + 1568*D1*Dd*f**3*fd*r - 6272*D1*Dd*f**3*fd*s**2 + 6272*D1*Dd*f**3*fd*s - 1176*D1*Dd*f**3*fd - 2640*D1*Dd*f**3*r*s + 660*D1*Dd*f**3*r - 2640*D1*Dd*f**3*s**2 + 2640*D1*Dd*f**3*s - 660*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*g2*r*s + 1188*D1*Dd*f**2*g2*r - 4752*D1*Dd*f**2*g2*s**2 + 4752*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 784*D1*Ddd*f**4*r*s + 196*D1*Ddd*f**4*r - 784*D1*Ddd*f**4*s**2 + 784*D1*Ddd*f**4*s - 196*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 297*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 2352*Dd**2*f**4*r*s + 588*Dd**2*f**4*r - 2352*Dd**2*f**4*s**2 + 2352*Dd**2*f**4*s - 392*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 297*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**6*k1**2*k2**3*(-90*C*D1**2*bdd1*f**2*r*s + 90*C*D1**2*bdd1*f**2*r - 90*C*D1**2*bdd1*f**2*s**2 + 180*C*D1**2*bdd1*f**2*s - 90*C*D1**2*bdd1*f**2 + 1710*C*D1**2*f**2*fd*r*s - 570*C*D1**2*f**2*fd*r + 1710*C*D1**2*f**2*fd*s**2 - 1710*C*D1**2*f**2*fd*s + 570*C*D1**2*f**2*fd - 1260*C*D1**2*f**2*fdd*r*s + 420*C*D1**2*f**2*fdd*r - 1260*C*D1**2*f**2*fdd*s**2 + 1260*C*D1**2*f**2*fdd*s - 420*C*D1**2*f**2*fdd - 2520*C*D1**2*f*fd**2*r*s + 840*C*D1**2*f*fd**2*r - 2520*C*D1**2*f*fd**2*s**2 + 2520*C*D1**2*f*fd**2*s - 420*C*D1**2*f*fd**2 + 2280*C*D1*Dd*f**3*r*s - 570*C*D1*Dd*f**3*r + 2280*C*D1*Dd*f**3*s**2 - 2280*C*D1*Dd*f**3*s + 570*C*D1*Dd*f**3 - 10080*C*D1*Dd*f**2*fd*r*s + 2940*C*D1*Dd*f**2*fd*r - 10080*C*D1*Dd*f**2*fd*s**2 + 10080*C*D1*Dd*f**2*fd*s - 2100*C*D1*Dd*f**2*fd - 1680*C*D1*Ddd*f**3*r*s + 420*C*D1*Ddd*f**3*r - 1680*C*D1*Ddd*f**3*s**2 + 1680*C*D1*Ddd*f**3*s - 420*C*D1*Ddd*f**3 - 5040*C*Dd**2*f**3*r*s + 1260*C*Dd**2*f**3*r - 5040*C*Dd**2*f**3*s**2 + 5040*C*Dd**2*f**3*s - 840*C*Dd**2*f**3 - 270*D1**2*K*bdd1*f**2*r*s - 270*D1**2*K*bdd1*f**2*s**2 + 270*D1**2*K*bdd1*f**2*s - 63*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 105*D1**2*bdd1*f**3*r*s + 35*D1**2*bdd1*f**3*r + 105*D1**2*bdd1*f**3*s**2 - 70*D1**2*bdd1*f**3*s - 35*D1**2*bdd1*f**3 + 225*D1**2*bdd1*f**2*r*s - 90*D1**2*bdd1*f**2*r + 225*D1**2*bdd1*f**2*s**2 - 315*D1**2*bdd1*f**2*s + 90*D1**2*bdd1*f**2 + 126*D1**2*bdd1*f*g2*r*s - 126*D1**2*bdd1*f*g2*r + 126*D1**2*bdd1*f*g2*s**2 - 252*D1**2*bdd1*f*g2*s + 126*D1**2*bdd1*f*g2 - 140*D1**2*f**3*fd*r*s + 35*D1**2*f**3*fd*r - 140*D1**2*f**3*fd*s**2 + 140*D1**2*f**3*fd*s - 35*D1**2*f**3*fd - 1215*D1**2*f**2*fd*r*s + 405*D1**2*f**2*fd*r - 1215*D1**2*f**2*fd*s**2 + 1215*D1**2*f**2*fd*s - 405*D1**2*f**2*fd + 945*D1**2*f**2*fdd*r*s - 315*D1**2*f**2*fdd*r + 945*D1**2*f**2*fdd*s**2 - 945*D1**2*f**2*fdd*s + 315*D1**2*f**2*fdd - 702*D1**2*f**2*gd2*r*s - 702*D1**2*f**2*gd2*s**2 + 702*D1**2*f**2*gd2*s + 540*D1**2*f**2*gdd2*r*s + 540*D1**2*f**2*gdd2*s**2 - 540*D1**2*f**2*gdd2*s + 1890*D1**2*f*fd**2*r*s - 630*D1**2*f*fd**2*r + 1890*D1**2*f*fd**2*s**2 - 1890*D1**2*f*fd**2*s + 315*D1**2*f*fd**2 - 1404*D1**2*f*fd*g2*r*s + 702*D1**2*f*fd*g2*r - 1404*D1**2*f*fd*g2*s**2 + 1404*D1**2*f*fd*g2*s - 702*D1**2*f*fd*g2 + 2160*D1**2*f*fd*gd2*r*s - 540*D1**2*f*fd*gd2*r + 2160*D1**2*f*fd*gd2*s**2 - 2160*D1**2*f*fd*gd2*s + 540*D1**2*f*fd*gd2 + 1080*D1**2*f*fdd*g2*r*s - 540*D1**2*f*fdd*g2*r + 1080*D1**2*f*fdd*g2*s**2 - 1080*D1**2*f*fdd*g2*s + 540*D1**2*f*fdd*g2 + 1080*D1**2*fd**2*g2*r*s - 540*D1**2*fd**2*g2*r + 1080*D1**2*fd**2*g2*s**2 - 1080*D1**2*fd**2*g2*s - 140*D1*Dd*f**4*r*s + 35*D1*Dd*f**4*r - 140*D1*Dd*f**4*s**2 + 140*D1*Dd*f**4*s - 35*D1*Dd*f**4 - 1620*D1*Dd*f**3*r*s + 405*D1*Dd*f**3*r - 1620*D1*Dd*f**3*s**2 + 1620*D1*Dd*f**3*s - 405*D1*Dd*f**3 + 7560*D1*Dd*f**2*fd*r*s - 2205*D1*Dd*f**2*fd*r + 7560*D1*Dd*f**2*fd*s**2 - 7560*D1*Dd*f**2*fd*s + 1575*D1*Dd*f**2*fd - 2808*D1*Dd*f**2*g2*r*s + 702*D1*Dd*f**2*g2*r - 2808*D1*Dd*f**2*g2*s**2 + 2808*D1*Dd*f**2*g2*s - 702*D1*Dd*f**2*g2 + 4320*D1*Dd*f**2*gd2*r*s - 540*D1*Dd*f**2*gd2*r + 4320*D1*Dd*f**2*gd2*s**2 - 4320*D1*Dd*f**2*gd2*s + 540*D1*Dd*f**2*gd2 + 8640*D1*Dd*f*fd*g2*r*s - 3240*D1*Dd*f*fd*g2*r + 8640*D1*Dd*f*fd*g2*s**2 - 8640*D1*Dd*f*fd*g2*s + 2160*D1*Dd*f*fd*g2 + 1260*D1*Ddd*f**3*r*s - 315*D1*Ddd*f**3*r + 1260*D1*Ddd*f**3*s**2 - 1260*D1*Ddd*f**3*s + 315*D1*Ddd*f**3 + 2160*D1*Ddd*f**2*g2*r*s - 540*D1*Ddd*f**2*g2*r + 2160*D1*Ddd*f**2*g2*s**2 - 2160*D1*Ddd*f**2*g2*s + 540*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(33*s + 14)*(r + s - 1) + f**2*(180*C*(s - 1)*(r + s - 1) + 35*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + (9*r + 9*s - 9)*(39*K*s - 36*s + 20)) - 9*f*(5*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 6*K*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 7*r - 20*s**2 + 22*s - 5) + (14*r + 14*s - 14)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(35*f**2*(24*r*s + r + 4*s*(6*s - 5)) - 45*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 6*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 40*r*s + 13*r - 40*s**2 + 48*s - 11) + 126*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 3780*Dd**2*f**3*r*s - 945*Dd**2*f**3*r + 3780*Dd**2*f**3*s**2 - 3780*Dd**2*f**3*s + 630*Dd**2*f**3 + 6480*Dd**2*f**2*g2*r*s - 1620*Dd**2*f**2*g2*r + 6480*Dd**2*f**2*g2*s**2 - 6480*Dd**2*f**2*g2*s + 1080*Dd**2*f**2*g2 + 63*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(360*C*D1**2*f*fd*r*s + 360*C*D1**2*f*fd*s**2 - 180*C*D1**2*f*fd*s - 180*C*D1**2*f*fdd*r*s - 180*C*D1**2*f*fdd*s**2 + 90*C*D1**2*f*fdd*s - 180*C*D1**2*fd**2*r*s - 180*C*D1**2*fd**2*s**2 + 90*C*D1**2*fd**2*s + 720*C*D1*Dd*f**2*r*s - 180*C*D1*Dd*f**2*r + 720*C*D1*Dd*f**2*s**2 - 720*C*D1*Dd*f**2*s + 180*C*D1*Dd*f**2 - 1440*C*D1*Dd*f*fd*r*s + 180*C*D1*Dd*f*fd*r - 1440*C*D1*Dd*f*fd*s**2 + 1080*C*D1*Dd*f*fd*s - 90*C*D1*Dd*f*fd - 360*C*D1*Ddd*f**2*r*s + 90*C*D1*Ddd*f**2*r - 360*C*D1*Ddd*f**2*s**2 + 360*C*D1*Ddd*f**2*s - 90*C*D1*Ddd*f**2 - 1080*C*Dd**2*f**2*r*s + 270*C*Dd**2*f**2*r - 1080*C*Dd**2*f**2*s**2 + 1080*C*Dd**2*f**2*s - 180*C*Dd**2*f**2 + 702*D1**2*K*f*fd*r*s - 351*D1**2*K*f*fd*r + 702*D1**2*K*f*fd*s**2 - 702*D1**2*K*f*fd*s + 351*D1**2*K*f*fd - 540*D1**2*K*f*fdd*r*s + 270*D1**2*K*f*fdd*r - 540*D1**2*K*f*fdd*s**2 + 540*D1**2*K*f*fdd*s - 270*D1**2*K*f*fdd - 540*D1**2*K*fd**2*r*s + 270*D1**2*K*fd**2*r - 540*D1**2*K*fd**2*s**2 + 540*D1**2*K*fd**2*s - 63*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 495*D1**2*f**2*fd*r*s + 235*D1**2*f**2*fd*r - 495*D1**2*f**2*fd*s**2 + 565*D1**2*f**2*fd*s - 235*D1**2*f**2*fd + 315*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r + 315*D1**2*f**2*fdd*s**2 - 350*D1**2*f**2*fdd*s + 140*D1**2*f**2*fdd + 630*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r + 630*D1**2*f*fd**2*s**2 - 700*D1**2*f*fd**2*s + 140*D1**2*f*fd**2 - 648*D1**2*f*fd*r*s + 144*D1**2*f*fd*r - 648*D1**2*f*fd*s**2 + 468*D1**2*f*fd*s - 144*D1**2*f*fd + 450*D1**2*f*fdd*r*s - 135*D1**2*f*fdd*r + 450*D1**2*f*fdd*s**2 - 360*D1**2*f*fdd*s + 135*D1**2*f*fdd - 252*D1**2*f*gd2*r*s - 252*D1**2*f*gd2*s**2 + 252*D1**2*f*gd2*s + 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*s**2 - 126*D1**2*f*gdd2*s + 450*D1**2*fd**2*r*s - 135*D1**2*fd**2*r + 450*D1**2*fd**2*s**2 - 360*D1**2*fd**2*s - 252*D1**2*fd*g2*r*s - 252*D1**2*fd*g2*s**2 + 252*D1**2*fd*gd2*r*s + 252*D1**2*fd*gd2*s**2 - 126*D1**2*fd*gd2*s + 126*D1**2*fdd*g2*r*s + 126*D1**2*fdd*g2*s**2 + 1404*D1*Dd*K*f**2*r*s - 351*D1*Dd*K*f**2*r + 1404*D1*Dd*K*f**2*s**2 - 1404*D1*Dd*K*f**2*s + 351*D1*Dd*K*f**2 - 4320*D1*Dd*K*f*fd*r*s + 1620*D1*Dd*K*f*fd*r - 4320*D1*Dd*K*f*fd*s**2 + 4320*D1*Dd*K*f*fd*s - 1080*D1*Dd*K*f*fd - 660*D1*Dd*f**3*r*s + 165*D1*Dd*f**3*r - 660*D1*Dd*f**3*s**2 + 660*D1*Dd*f**3*s - 165*D1*Dd*f**3 + 2520*D1*Dd*f**2*fd*r*s - 875*D1*Dd*f**2*fd*r + 2520*D1*Dd*f**2*fd*s**2 - 2660*D1*Dd*f**2*fd*s + 630*D1*Dd*f**2*fd - 1296*D1*Dd*f**2*r*s + 324*D1*Dd*f**2*r - 1296*D1*Dd*f**2*s**2 + 1296*D1*Dd*f**2*s - 324*D1*Dd*f**2 + 3600*D1*Dd*f*fd*r*s - 990*D1*Dd*f*fd*r + 3600*D1*Dd*f*fd*s**2 - 3240*D1*Dd*f*fd*s + 630*D1*Dd*f*fd - 1008*D1*Dd*f*g2*r*s + 252*D1*Dd*f*g2*r - 1008*D1*Dd*f*g2*s**2 + 1008*D1*Dd*f*g2*s - 252*D1*Dd*f*g2 + 1008*D1*Dd*f*gd2*r*s - 126*D1*Dd*f*gd2*r + 1008*D1*Dd*f*gd2*s**2 - 1008*D1*Dd*f*gd2*s + 126*D1*Dd*f*gd2 + 1008*D1*Dd*fd*g2*r*s - 126*D1*Dd*fd*g2*r + 1008*D1*Dd*fd*g2*s**2 - 504*D1*Dd*fd*g2*s - 1080*D1*Ddd*K*f**2*r*s + 270*D1*Ddd*K*f**2*r - 1080*D1*Ddd*K*f**2*s**2 + 1080*D1*Ddd*K*f**2*s - 270*D1*Ddd*K*f**2 + 420*D1*Ddd*f**3*r*s - 105*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s**2 - 420*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 + 900*D1*Ddd*f**2*r*s - 225*D1*Ddd*f**2*r + 900*D1*Ddd*f**2*s**2 - 900*D1*Ddd*f**2*s + 225*D1*Ddd*f**2 + 504*D1*Ddd*f*g2*r*s - 126*D1*Ddd*f*g2*r + 504*D1*Ddd*f*g2*s**2 - 504*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 + 63*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 3240*Dd**2*K*f**2*r*s + 810*Dd**2*K*f**2*r - 3240*Dd**2*K*f**2*s**2 + 3240*Dd**2*K*f**2*s - 540*Dd**2*K*f**2 + 1260*Dd**2*f**3*r*s - 315*Dd**2*f**3*r + 1260*Dd**2*f**3*s**2 - 1260*Dd**2*f**3*s + 210*Dd**2*f**3 + 2700*Dd**2*f**2*r*s - 675*Dd**2*f**2*r + 2700*Dd**2*f**2*s**2 - 2700*Dd**2*f**2*s + 450*Dd**2*f**2 + 1512*Dd**2*f*g2*r*s - 378*Dd**2*f*g2*r + 1512*Dd**2*f*g2*s**2 - 1512*Dd**2*f*g2*s + 252*Dd**2*f*g2))/(315*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**6*k1**2*k2*st**2*(D1**2*(196*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 3*f**2*(392*fd**2*s*(2*s - 1) - fd*(220*C - 220)*(3*s**2 - 2*s + 1) + fdd*(110*C - 110)*(3*s**2 - 2*s + 1) + s**2*(99*K*bdd1 - 198*bd1*(K - 1) - 99*bdd1 + 396*gd2 - 198*gdd2)) - 66*f*(fd**2*s*(10*C - 10)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 1188*fd**2*g2*s*(s - 1)) + 2*D1*f*(Dd*(196*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(165*C*(4*s**2 - 2*s + 1) - 98*fd*(1 - 4*s)**2 - 660*s**2 + 330*s - 165) - 33*f*(fd*(10*C - 10)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 594*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(98*f**2 + f*(165*C - 165) - 297*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(2*s - 1)*(98*f**2 + f*(165*C - 165) - 297*g2) + 297*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**6*k1**2*k2*(360*C*D1**2*bdd1*f**2*r*s + 810*C*D1**2*bdd1*f**2*s**2 - 900*C*D1**2*bdd1*f**2*s + 450*C*D1**2*bdd1*f**2 + 5400*C*D1**2*f**2*fd*r*s - 1800*C*D1**2*f**2*fd*r - 3480*C*D1**2*f**2*fd*s**2 + 520*C*D1**2*f**2*fd*s - 1160*C*D1**2*f**2*fd - 3240*C*D1**2*f**2*fdd*r*s + 1080*C*D1**2*f**2*fdd*r + 930*C*D1**2*f**2*fdd*s**2 + 460*C*D1**2*f**2*fdd*s + 310*C*D1**2*f**2*fdd - 6480*C*D1**2*f*fd**2*r*s + 2160*C*D1**2*f*fd**2*r + 1860*C*D1**2*f*fd**2*s**2 + 920*C*D1**2*f*fd**2*s - 1080*C*D1**2*f*fd**2 + 7200*C*D1*Dd*f**3*r*s - 1800*C*D1*Dd*f**3*r - 4640*C*D1*Dd*f**3*s**2 - 1280*C*D1*Dd*f**3*s - 1160*C*D1*Dd*f**3 - 25920*C*D1*Dd*f**2*fd*r*s + 7560*C*D1*Dd*f**2*fd*r + 7440*C*D1*Dd*f**2*fd*s**2 + 6460*C*D1*Dd*f**2*fd*s - 2620*C*D1*Dd*f**2*fd - 4320*C*D1*Ddd*f**3*r*s + 1080*C*D1*Ddd*f**3*r + 1240*C*D1*Ddd*f**3*s**2 + 1540*C*D1*Ddd*f**3*s + 310*C*D1*Ddd*f**3 - 12960*C*Dd**2*f**3*r*s + 3240*C*Dd**2*f**3*r + 3720*C*Dd**2*f**3*s**2 + 4620*C*Dd**2*f**3*s - 2160*C*Dd**2*f**3 - 612*D1**2*K*bdd1*f**2*r*s + 153*D1**2*K*bdd1*f**2*s**2 + 612*D1**2*K*bdd1*f**2*s + 126*D1**2*bd1**2*f*s*(K - 1)*(4*r + 9*s - 7) + 560*D1**2*bdd1*f**3*r*s + 210*D1**2*bdd1*f**3*s**2 - 770*D1**2*bdd1*f**3*s + 175*D1**2*bdd1*f**3 + 792*D1**2*bdd1*f**2*r*s + 27*D1**2*bdd1*f**2*s**2 - 252*D1**2*bdd1*f**2*s - 450*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r*s - 1134*D1**2*bdd1*f*g2*s**2 + 1260*D1**2*bdd1*f*g2*s - 630*D1**2*bdd1*f*g2 + 2520*D1**2*f**3*fd*r*s - 630*D1**2*f**3*fd*r + 2800*D1**2*f**3*fd*s**2 - 2660*D1**2*f**3*fd*s + 700*D1**2*f**3*fd - 2520*D1**2*f**3*fdd*r*s + 630*D1**2*f**3*fdd*r - 1820*D1**2*f**3*fdd*s**2 + 2170*D1**2*f**3*fdd*s - 455*D1**2*f**3*fdd - 7560*D1**2*f**2*fd**2*r*s + 1890*D1**2*f**2*fd**2*r - 5460*D1**2*f**2*fd**2*s**2 + 6510*D1**2*f**2*fd**2*s - 1260*D1**2*f**2*fd**2 - 7380*D1**2*f**2*fd*r*s + 2460*D1**2*f**2*fd*r - 600*D1**2*f**2*fd*s**2 + 2860*D1**2*f**2*fd*s - 200*D1**2*f**2*fd + 4500*D1**2*f**2*fdd*r*s - 1500*D1**2*f**2*fdd*r + 1380*D1**2*f**2*fdd*s**2 - 2420*D1**2*f**2*fdd*s + 460*D1**2*f**2*fdd - 1944*D1**2*f**2*gd2*r*s + 1368*D1**2*f**2*gd2*s**2 + 1944*D1**2*f**2*gd2*s + 1224*D1**2*f**2*gdd2*r*s - 306*D1**2*f**2*gdd2*s**2 - 1224*D1**2*f**2*gdd2*s + 9000*D1**2*f*fd**2*r*s - 3000*D1**2*f*fd**2*r + 2760*D1**2*f*fd**2*s**2 - 4840*D1**2*f*fd**2*s + 1500*D1**2*f*fd**2 - 3888*D1**2*f*fd*g2*r*s + 1944*D1**2*f*fd*g2*r + 2736*D1**2*f*fd*g2*s**2 - 2736*D1**2*f*fd*g2*s + 1368*D1**2*f*fd*g2 + 4896*D1**2*f*fd*gd2*r*s - 1224*D1**2*f*fd*gd2*r - 1224*D1**2*f*fd*gd2*s**2 - 1836*D1**2*f*fd*gd2*s + 1224*D1**2*f*fd*gd2 + 2448*D1**2*f*fdd*g2*r*s - 1224*D1**2*f*fdd*g2*r - 612*D1**2*f*fdd*g2*s**2 + 612*D1**2*f*fdd*g2*s - 306*D1**2*f*fdd*g2 + 2448*D1**2*fd**2*g2*r*s - 1224*D1**2*fd**2*g2*r - 612*D1**2*fd**2*g2*s**2 + 612*D1**2*fd**2*g2*s + 2520*D1*Dd*f**4*r*s - 630*D1*Dd*f**4*r + 2800*D1*Dd*f**4*s**2 - 2660*D1*Dd*f**4*s + 700*D1*Dd*f**4 - 20160*D1*Dd*f**3*fd*r*s + 5040*D1*Dd*f**3*fd*r - 14560*D1*Dd*f**3*fd*s**2 + 17360*D1*Dd*f**3*fd*s - 3430*D1*Dd*f**3*fd - 9840*D1*Dd*f**3*r*s + 2460*D1*Dd*f**3*r - 800*D1*Dd*f**3*s**2 + 5320*D1*Dd*f**3*s - 200*D1*Dd*f**3 + 36000*D1*Dd*f**2*fd*r*s - 10500*D1*Dd*f**2*fd*r + 11040*D1*Dd*f**2*fd*s**2 - 21440*D1*Dd*f**2*fd*s + 5420*D1*Dd*f**2*fd - 7776*D1*Dd*f**2*g2*r*s + 1944*D1*Dd*f**2*g2*r + 5472*D1*Dd*f**2*g2*s**2 + 1152*D1*Dd*f**2*g2*s + 1368*D1*Dd*f**2*g2 + 9792*D1*Dd*f**2*gd2*r*s - 1224*D1*Dd*f**2*gd2*r - 2448*D1*Dd*f**2*gd2*s**2 - 6732*D1*Dd*f**2*gd2*s + 1224*D1*Dd*f**2*gd2 + 19584*D1*Dd*f*fd*g2*r*s - 7344*D1*Dd*f*fd*g2*r - 4896*D1*Dd*f*fd*g2*s**2 - 1224*D1*Dd*f*fd*g2*s + 1836*D1*Dd*f*fd*g2 - 2520*D1*Ddd*f**4*r*s + 630*D1*Ddd*f**4*r - 1820*D1*Ddd*f**4*s**2 + 2170*D1*Ddd*f**4*s - 455*D1*Ddd*f**4 + 6000*D1*Ddd*f**3*r*s - 1500*D1*Ddd*f**3*r + 1840*D1*Ddd*f**3*s**2 - 3920*D1*Ddd*f**3*s + 460*D1*Ddd*f**3 + 4896*D1*Ddd*f**2*g2*r*s - 1224*D1*Ddd*f**2*g2*r - 1224*D1*Ddd*f**2*g2*s**2 - 1836*D1*Ddd*f**2*g2*s - 306*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(5*f**3*(24*s**2 + s*(94*r - 136) + 35) + 2*f**2*(45*C*(9*s**2 + s*(4*r - 10) + 5) + 9*K*s*(-27*r + 19*s + 27) - 35*fd*(4*r*(6*s - 1) + 9*s**2 - 22*s + 3) + 270*r*s - 144*s**2 - 225) + 9*f*(fd*(-180*C*s**2 + 160*C*s + 17*K*(r*(8*s - 2) - 2*s**2 - 3*s + 2) - r*(20*C + 44)*(4*s - 1) - 6*s**2 + 61*s - 64) - 14*g2*(9*s**2 + s*(4*r - 10) + 5) - 14*gd2*s*(-4*r - 9*s + 7)) + 126*fd*g2*(r*(4*s - 2) + s*(9*s - 9))) - Dd*f*(35*f**2*(8*r*(8*s - 1) + 24*s**2 - 66*s + 11) + 9*f*(10*C*(2*r*(8*s - 1) + 36*s**2 - 33*s + 5) + 17*K*(r*(2 - 16*s) + 4*s**2 + 11*s - 2) + 352*r*s - 44*r + 12*s**2 - 147*s + 14) - 126*g2*(2*r*(8*s - 1) + 36*s**2 - 33*s + 5))) - 7560*Dd**2*f**4*r*s + 1890*Dd**2*f**4*r - 5460*Dd**2*f**4*s**2 + 6510*Dd**2*f**4*s - 1260*Dd**2*f**4 + 18000*Dd**2*f**3*r*s - 4500*Dd**2*f**3*r + 5520*Dd**2*f**3*s**2 - 11760*Dd**2*f**3*s + 3000*Dd**2*f**3 + 14688*Dd**2*f**2*g2*r*s - 3672*Dd**2*f**2*g2*r - 3672*Dd**2*f**2*g2*s**2 - 5508*Dd**2*f**2*g2*s + 2448*Dd**2*f**2*g2 - 63*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(4*r*(s - 1) + 9*s**2 - 8*s + 4) + D1*(2*Dd*(f*(16*r*s - 4*r + 36*s**2 - 26*s + 9) + fd*(-16*r*s + 10*r - 36*s**2 + 29*s - 8)) + Ddd*f*(r*(4 - 16*s) - 36*s**2 + 26*s - 9)) - 2*Dd**2*f*(6*r*(4*s - 1) + 54*s**2 - 39*s + 4)) + b1*(-1440*C*D1**2*f*fd*r*s + 720*C*D1**2*f*fd*r - 3240*C*D1**2*f*fd*s**2 + 2160*C*D1**2*f*fd*s - 720*C*D1**2*f*fd + 720*C*D1**2*f*fdd*r*s - 360*C*D1**2*f*fdd*r + 1620*C*D1**2*f*fdd*s**2 - 1080*C*D1**2*f*fdd*s + 360*C*D1**2*f*fdd + 720*C*D1**2*fd**2*r*s - 360*C*D1**2*fd**2*r + 1620*C*D1**2*fd**2*s**2 - 1080*C*D1**2*fd**2*s + 360*C*D1**2*fd**2 - 2880*C*D1*Dd*f**2*r*s + 720*C*D1*Dd*f**2*r - 6480*C*D1*Dd*f**2*s**2 + 4680*C*D1*Dd*f**2*s - 1620*C*D1*Dd*f**2 + 5760*C*D1*Dd*f*fd*r*s - 2160*C*D1*Dd*f*fd*r + 12960*C*D1*Dd*f*fd*s**2 - 9000*C*D1*Dd*f*fd*s + 1800*C*D1*Dd*f*fd + 1440*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 3240*C*D1*Ddd*f**2*s**2 - 2340*C*D1*Ddd*f**2*s + 810*C*D1*Ddd*f**2 + 4320*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 9720*C*Dd**2*f**2*s**2 - 7020*C*Dd**2*f**2*s + 720*C*Dd**2*f**2 + 1944*D1**2*K*f*fd*r*s - 972*D1**2*K*f*fd*r - 1368*D1**2*K*f*fd*s**2 + 1368*D1**2*K*f*fd*s - 684*D1**2*K*f*fd - 1224*D1**2*K*f*fdd*r*s + 612*D1**2*K*f*fdd*r + 306*D1**2*K*f*fdd*s**2 - 306*D1**2*K*f*fdd*s + 153*D1**2*K*f*fdd - 1224*D1**2*K*fd**2*r*s + 612*D1**2*K*fd**2*r + 306*D1**2*K*fd**2*s**2 - 306*D1**2*K*fd**2*s + 63*D1**2*bdd1*f*(K - 1)*(8*r*s + 18*s**2 - 14*s + 5) - 2820*D1**2*f**2*fd*r*s + 940*D1**2*f**2*fd*r - 720*D1**2*f**2*fd*s**2 + 1000*D1**2*f**2*fd*s + 110*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 630*D1**2*f**2*fdd*s**2 - 770*D1**2*f**2*fdd*s + 35*D1**2*f**2*fdd + 3360*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 1260*D1**2*f*fd**2*s**2 - 1540*D1**2*f*fd**2*s + 700*D1**2*f*fd**2 - 2160*D1**2*f*fd*r*s + 1080*D1**2*f*fd*r + 1152*D1**2*f*fd*s**2 - 72*D1**2*f*fd*s - 324*D1**2*f*fd + 1584*D1**2*f*fdd*r*s - 792*D1**2*f*fdd*r + 54*D1**2*f*fdd*s**2 - 594*D1**2*f*fdd*s + 477*D1**2*f*fdd + 1008*D1**2*f*gd2*r*s + 2268*D1**2*f*gd2*s**2 - 1008*D1**2*f*gd2*s - 504*D1**2*f*gdd2*r*s - 1134*D1**2*f*gdd2*s**2 + 504*D1**2*f*gdd2*s + 1584*D1**2*fd**2*r*s - 792*D1**2*fd**2*r + 54*D1**2*fd**2*s**2 - 594*D1**2*fd**2*s - 360*D1**2*fd**2 + 1008*D1**2*fd*g2*r*s - 1008*D1**2*fd*g2*r + 2268*D1**2*fd*g2*s**2 - 2016*D1**2*fd*g2*s + 1008*D1**2*fd*g2 - 1008*D1**2*fd*gd2*r*s + 504*D1**2*fd*gd2*r - 2268*D1**2*fd*gd2*s**2 + 1512*D1**2*fd*gd2*s - 504*D1**2*fd*gd2 - 504*D1**2*fdd*g2*r*s + 504*D1**2*fdd*g2*r - 1134*D1**2*fdd*g2*s**2 + 1008*D1**2*fdd*g2*s - 504*D1**2*fdd*g2 + 3888*D1*Dd*K*f**2*r*s - 972*D1*Dd*K*f**2*r - 2736*D1*Dd*K*f**2*s**2 - 576*D1*Dd*K*f**2*s - 684*D1*Dd*K*f**2 - 9792*D1*Dd*K*f*fd*r*s + 3672*D1*Dd*K*f*fd*r + 2448*D1*Dd*K*f*fd*s**2 + 612*D1*Dd*K*f*fd*s - 918*D1*Dd*K*f*fd - 3760*D1*Dd*f**3*r*s + 940*D1*Dd*f**3*r - 960*D1*Dd*f**3*s**2 + 2360*D1*Dd*f**3*s - 240*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*r*s - 3920*D1*Dd*f**2*fd*r + 5040*D1*Dd*f**2*fd*s**2 - 7700*D1*Dd*f**2*fd*s + 1890*D1*Dd*f**2*fd - 4320*D1*Dd*f**2*r*s + 1080*D1*Dd*f**2*r + 2304*D1*Dd*f**2*s**2 + 1008*D1*Dd*f**2*s + 576*D1*Dd*f**2 + 12672*D1*Dd*f*fd*r*s - 4752*D1*Dd*f*fd*r + 432*D1*Dd*f*fd*s**2 - 5652*D1*Dd*f*fd*s + 2178*D1*Dd*f*fd + 4032*D1*Dd*f*g2*r*s - 1008*D1*Dd*f*g2*r + 9072*D1*Dd*f*g2*s**2 - 6552*D1*Dd*f*g2*s + 2268*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r*s + 504*D1*Dd*f*gd2*r - 9072*D1*Dd*f*gd2*s**2 + 5292*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r*s + 2520*D1*Dd*fd*g2*r - 9072*D1*Dd*fd*g2*s**2 + 7308*D1*Dd*fd*g2*s - 2016*D1*Dd*fd*g2 - 2448*D1*Ddd*K*f**2*r*s + 612*D1*Ddd*K*f**2*r + 612*D1*Ddd*K*f**2*s**2 + 918*D1*Ddd*K*f**2*s + 153*D1*Ddd*K*f**2 + 2240*D1*Ddd*f**3*r*s - 560*D1*Ddd*f**3*r + 840*D1*Ddd*f**3*s**2 - 1540*D1*Ddd*f**3*s + 210*D1*Ddd*f**3 + 3168*D1*Ddd*f**2*r*s - 792*D1*Ddd*f**2*r + 108*D1*Ddd*f**2*s**2 - 1638*D1*Ddd*f**2*s + 27*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 4536*D1*Ddd*f*g2*s**2 + 3276*D1*Ddd*f*g2*s - 1134*D1*Ddd*f*g2 - 126*D1*bd1*(K - 1)*(D1*(f*(8*r*s + 18*s**2 - 14*s + 5) + fd*(-8*r*s + 4*r - 18*s**2 + 15*s - 2)) + Dd*f*(r*(4 - 32*s) - 72*s**2 + 54*s - 7)) - 7344*Dd**2*K*f**2*r*s + 1836*Dd**2*K*f**2*r + 1836*Dd**2*K*f**2*s**2 + 2754*Dd**2*K*f**2*s - 1224*Dd**2*K*f**2 + 6720*Dd**2*f**3*r*s - 1680*Dd**2*f**3*r + 2520*Dd**2*f**3*s**2 - 4620*Dd**2*f**3*s + 1120*Dd**2*f**3 + 9504*Dd**2*f**2*r*s - 2376*Dd**2*f**2*r + 324*Dd**2*f**2*s**2 - 4914*Dd**2*f**2*s + 1584*Dd**2*f**2 - 6048*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 13608*Dd**2*f*g2*s**2 + 9828*Dd**2*f*g2*s - 1008*Dd**2*f*g2))/(630*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**6*k1**2*(D1**2*(252*bd1*fd*g2*s*(s - 1) + f**3*s**2*(210*bd1 - 105*bdd1) - 10*f**2*(C*s**2*(-18*bd1 + 9*bdd1) + 7*fd*(s**2*(9*bd1 - 6) + s*(4 - 3*bd1) - 2) + 7*fdd*(3*s**2 - 2*s + 1)) - 2*f*s*(63*bd1**2*s*(K - 1) + 18*bd1*(5*C*fd*(2*s - 1) + s*(7*g2 - 7*gd2)) - 63*bdd1*g2*s - 7*fd**2*(20 - 30*s))) - 2*D1*f*(Dd*(126*bd1*g2*s*(1 - 4*s) + 35*f**2*(s**2*(12*bd1 - 8) + s*(4 - 3*bd1) - 2) + 10*f*(4*s - 1)*(9*C*bd1*s + 7*fd*(3*s - 1))) + 35*Ddd*f**2*(4*s**2 - 2*s + 1)) + 420*Dd**2*f**3*s*(1 - 2*s) + 63*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(30*C*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + 7*D1**2*(5*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) - 2*f*s*(5*fd**2*(3*s - 2) + s*(3*K*bdd1 - 6*bd1*(K - 1) - 3*bdd1 + 6*gd2 - 3*gdd2)) + (6 - 6*s)*(2*fd*g2*(s - 1) - 2*fd*s*(-K*bd1 + bd1 + gd2) - fdd*g2*(s - 1))) + 7*D1*(2*Dd*(5*f**3*(4*s**2 - 2*s + 1) - 5*f**2*fd*(12*s**2 - 7*s + 1) - 6*f*g2*(4*s**2 - 2*s + 1) + 6*f*s*(4*s - 1)*(-K*bd1 + bd1 + gd2) + 6*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f**2 - 6*g2)*(4*s**2 - 2*s + 1)) - 42*Dd**2*f*s*(5*f**2 - 6*g2)*(2*s - 1)))/(70*d**2*k2*k3**2) + 4*D1**2*Pk3*Pkd2*ct**6*k2**5*(D1**2*(f**2*(fd*(28*C - 14)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(14*C - 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-9*K*(-2*bd1 + bdd1) - 36*gd2 + 18*gdd2)) + f*(-fd**2*(14*C - 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 9*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) + 9*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 9*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(28*C - 14)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(9*K*(b1*r*(8*s - 2) + 2*b1*(1 - 2*s)**2 + bd1*(-8*r*s + r - 8*s**2 + 8*s - 1)) + fd*(7 - 14*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 36*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 18*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 18*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(14*C*f + 9*K*b1 - 7*f - 18*g2)) - Dd**2*f**2*(14*C*f + 9*K*b1 - 7*f - 18*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(63*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**6*k2**3*(-864*C*D1**2*f**2*fd*r*s + 288*C*D1**2*f**2*fd*r - 252*C*D1**2*f**2*fd*s**2 + 456*C*D1**2*f**2*fd*s - 84*C*D1**2*f**2*fd + 432*C*D1**2*f**2*fdd*r*s - 144*C*D1**2*f**2*fdd*r + 126*C*D1**2*f**2*fdd*s**2 - 228*C*D1**2*f**2*fdd*s + 42*C*D1**2*f**2*fdd + 864*C*D1**2*f*fd**2*r*s - 288*C*D1**2*f*fd**2*r + 252*C*D1**2*f*fd**2*s**2 - 456*C*D1**2*f*fd**2*s + 144*C*D1**2*f*fd**2 - 1152*C*D1*Dd*f**3*r*s + 288*C*D1*Dd*f**3*r - 336*C*D1*Dd*f**3*s**2 + 744*C*D1*Dd*f**3*s - 84*C*D1*Dd*f**3 + 3456*C*D1*Dd*f**2*fd*r*s - 1008*C*D1*Dd*f**2*fd*r + 1008*C*D1*Dd*f**2*fd*s**2 - 2028*C*D1*Dd*f**2*fd*s + 516*C*D1*Dd*f**2*fd + 576*C*D1*Ddd*f**3*r*s - 144*C*D1*Ddd*f**3*r + 168*C*D1*Ddd*f**3*s**2 - 372*C*D1*Ddd*f**3*s + 42*C*D1*Ddd*f**3 + 1728*C*Dd**2*f**3*r*s - 432*C*Dd**2*f**3*r + 504*C*Dd**2*f**3*s**2 - 1116*C*Dd**2*f**3*s + 288*C*Dd**2*f**3 - 288*D1**2*K*b1*f*fd*r*s + 144*D1**2*K*b1*f*fd*r - 108*D1**2*K*b1*f*fd*s**2 + 108*D1**2*K*b1*f*fd*s - 54*D1**2*K*b1*f*fd + 144*D1**2*K*b1*f*fdd*r*s - 72*D1**2*K*b1*f*fdd*r + 54*D1**2*K*b1*f*fdd*s**2 - 54*D1**2*K*b1*f*fdd*s + 27*D1**2*K*b1*f*fdd + 144*D1**2*K*b1*fd**2*r*s - 72*D1**2*K*b1*fd**2*r + 54*D1**2*K*b1*fd**2*s**2 - 54*D1**2*K*b1*fd**2*s + 72*D1**2*K*bdd1*f**2*r*s + 27*D1**2*K*bdd1*f**2*s**2 - 72*D1**2*K*bdd1*f**2*s + 54*D1**2*b1*f**2*fd*r*s - 18*D1**2*b1*f**2*fd*r - 18*D1**2*b1*f**2*fd*s - 54*D1**2*b1*f**2*fdd*r*s + 18*D1**2*b1*f**2*fdd*r + 18*D1**2*b1*f**2*fdd*s - 108*D1**2*b1*f*fd**2*r*s + 36*D1**2*b1*f*fd**2*r + 36*D1**2*b1*f*fd**2*s - 18*D1**2*b1*f*fd**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 72*D1**2*bd2*f**2*r*s - 72*D1**2*bd2*f**2*s**2 + 72*D1**2*bd2*f**2*s + 144*D1**2*bd2*f*fd*r*s - 36*D1**2*bd2*f*fd*r + 144*D1**2*bd2*f*fd*s**2 - 144*D1**2*bd2*f*fd*s + 36*D1**2*bd2*f*fd - 18*D1**2*bdd1*f**3*r*s + 18*D1**2*bdd1*f**3*s - 18*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*s + 36*D1**2*bdd2*f**2*r*s + 36*D1**2*bdd2*f**2*s**2 - 36*D1**2*bdd2*f**2*s + 564*D1**2*f**2*fd*r*s - 188*D1**2*f**2*fd*r + 126*D1**2*f**2*fd*s**2 - 272*D1**2*f**2*fd*s + 42*D1**2*f**2*fd - 282*D1**2*f**2*fdd*r*s + 94*D1**2*f**2*fdd*r - 63*D1**2*f**2*fdd*s**2 + 136*D1**2*f**2*fdd*s - 21*D1**2*f**2*fdd + 288*D1**2*f**2*gd2*r*s + 108*D1**2*f**2*gd2*s**2 - 288*D1**2*f**2*gd2*s - 144*D1**2*f**2*gdd2*r*s - 54*D1**2*f**2*gdd2*s**2 + 144*D1**2*f**2*gdd2*s - 564*D1**2*f*fd**2*r*s + 188*D1**2*f*fd**2*r - 126*D1**2*f*fd**2*s**2 + 272*D1**2*f*fd**2*s - 94*D1**2*f*fd**2 + 576*D1**2*f*fd*g2*r*s - 288*D1**2*f*fd*g2*r + 216*D1**2*f*fd*g2*s**2 - 216*D1**2*f*fd*g2*s + 108*D1**2*f*fd*g2 - 576*D1**2*f*fd*gd2*r*s + 144*D1**2*f*fd*gd2*r - 216*D1**2*f*fd*gd2*s**2 + 396*D1**2*f*fd*gd2*s - 144*D1**2*f*fd*gd2 - 288*D1**2*f*fdd*g2*r*s + 144*D1**2*f*fdd*g2*r - 108*D1**2*f*fdd*g2*s**2 + 108*D1**2*f*fdd*g2*s - 54*D1**2*f*fdd*g2 - 288*D1**2*fd**2*g2*r*s + 144*D1**2*fd**2*g2*r - 108*D1**2*fd**2*g2*s**2 + 108*D1**2*fd**2*g2*s - 576*D1*Dd*K*b1*f**2*r*s + 144*D1*Dd*K*b1*f**2*r - 216*D1*Dd*K*b1*f**2*s**2 + 396*D1*Dd*K*b1*f**2*s - 54*D1*Dd*K*b1*f**2 + 1152*D1*Dd*K*b1*f*fd*r*s - 432*D1*Dd*K*b1*f*fd*r + 432*D1*Dd*K*b1*f*fd*s**2 - 612*D1*Dd*K*b1*f*fd*s + 198*D1*Dd*K*b1*f*fd + 72*D1*Dd*b1*f**3*r*s - 18*D1*Dd*b1*f**3*r - 36*D1*Dd*b1*f**3*s - 432*D1*Dd*b1*f**2*fd*r*s + 126*D1*Dd*b1*f**2*fd*r + 180*D1*Dd*b1*f**2*fd*s - 54*D1*Dd*b1*f**2*fd + 144*D1*Dd*b1*f**2*r*s - 36*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s - 288*D1*Dd*b1*f*fd*r*s + 108*D1*Dd*b1*f*fd*r + 72*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 288*D1*Dd*bd2*f**2*r*s - 36*D1*Dd*bd2*f**2*r + 288*D1*Dd*bd2*f**2*s**2 - 288*D1*Dd*bd2*f**2*s + 36*D1*Dd*bd2*f**2 + 752*D1*Dd*f**3*r*s - 188*D1*Dd*f**3*r + 168*D1*Dd*f**3*s**2 - 460*D1*Dd*f**3*s + 42*D1*Dd*f**3 - 2256*D1*Dd*f**2*fd*r*s + 658*D1*Dd*f**2*fd*r - 504*D1*Dd*f**2*fd*s**2 + 1234*D1*Dd*f**2*fd*s - 324*D1*Dd*f**2*fd + 1152*D1*Dd*f**2*g2*r*s - 288*D1*Dd*f**2*g2*r + 432*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 108*D1*Dd*f**2*g2 - 1152*D1*Dd*f**2*gd2*r*s + 144*D1*Dd*f**2*gd2*r - 432*D1*Dd*f**2*gd2*s**2 + 972*D1*Dd*f**2*gd2*s - 144*D1*Dd*f**2*gd2 - 2304*D1*Dd*f*fd*g2*r*s + 864*D1*Dd*f*fd*g2*r - 864*D1*Dd*f*fd*g2*s**2 + 1224*D1*Dd*f*fd*g2*s - 396*D1*Dd*f*fd*g2 + 288*D1*Ddd*K*b1*f**2*r*s - 72*D1*Ddd*K*b1*f**2*r + 108*D1*Ddd*K*b1*f**2*s**2 - 198*D1*Ddd*K*b1*f**2*s + 27*D1*Ddd*K*b1*f**2 - 72*D1*Ddd*b1*f**3*r*s + 18*D1*Ddd*b1*f**3*r + 36*D1*Ddd*b1*f**3*s - 72*D1*Ddd*b1*f**2*r*s + 18*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s - 376*D1*Ddd*f**3*r*s + 94*D1*Ddd*f**3*r - 84*D1*Ddd*f**3*s**2 + 230*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 - 576*D1*Ddd*f**2*g2*r*s + 144*D1*Ddd*f**2*g2*r - 216*D1*Ddd*f**2*g2*s**2 + 396*D1*Ddd*f**2*g2*s - 54*D1*Ddd*f**2*g2 + 18*D1*bd1*f*(D1*(f*s*(K*(-8*r - 3*s + 8) + f*(r - 1) + 2*r - 2) + fd*(K*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + f*(-6*r*s + r + 4*s - 1) - 4*r*s + r + 2*s - 1)) + Dd*f*(K*(32*r*s - 4*r + 12*s**2 - 27*s + 4) + f*(-8*r*s + r + 6*s - 1) - 8*r*s + r + 6*s - 1)) + 864*Dd**2*K*b1*f**2*r*s - 216*Dd**2*K*b1*f**2*r + 324*Dd**2*K*b1*f**2*s**2 - 594*Dd**2*K*b1*f**2*s + 144*Dd**2*K*b1*f**2 - 216*Dd**2*b1*f**3*r*s + 54*Dd**2*b1*f**3*r + 108*Dd**2*b1*f**3*s - 36*Dd**2*b1*f**3 - 216*Dd**2*b1*f**2*r*s + 54*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s - 36*Dd**2*b1*f**2 - 1128*Dd**2*f**3*r*s + 282*Dd**2*f**3*r - 252*Dd**2*f**3*s**2 + 690*Dd**2*f**3*s - 188*Dd**2*f**3 - 1728*Dd**2*f**2*g2*r*s + 432*Dd**2*f**2*g2*r - 648*Dd**2*f**2*g2*s**2 + 1188*Dd**2*f**2*g2*s - 288*Dd**2*f**2*g2 - 36*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(126*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**6*k2*(-420*C*D1**2*f**2*fd*s**2 + 280*C*D1**2*f**2*fd*s - 140*C*D1**2*f**2*fd + 210*C*D1**2*f**2*fdd*s**2 - 140*C*D1**2*f**2*fdd*s + 70*C*D1**2*f**2*fdd + 420*C*D1**2*f*fd**2*s**2 - 280*C*D1**2*f*fd**2*s - 560*C*D1*Dd*f**3*s**2 + 280*C*D1*Dd*f**3*s - 140*C*D1*Dd*f**3 + 1680*C*D1*Dd*f**2*fd*s**2 - 980*C*D1*Dd*f**2*fd*s + 140*C*D1*Dd*f**2*fd + 280*C*D1*Ddd*f**3*s**2 - 140*C*D1*Ddd*f**3*s + 70*C*D1*Ddd*f**3 + 840*C*Dd**2*f**3*s**2 - 420*C*Dd**2*f**3*s - 180*D1**2*K*b1*f*fd*s**2 + 180*D1**2*K*b1*f*fd*s - 90*D1**2*K*b1*f*fd + 90*D1**2*K*b1*f*fdd*s**2 - 90*D1**2*K*b1*f*fdd*s + 45*D1**2*K*b1*f*fdd + 90*D1**2*K*b1*fd**2*s**2 - 90*D1**2*K*b1*fd**2*s + 45*D1**2*K*bdd1*f**2*s**2 - 54*D1**2*b1*f**2*fd*r*s + 18*D1**2*b1*f**2*fd*r + 18*D1**2*b1*f**2*fd*s + 54*D1**2*b1*f**2*fdd*r*s - 18*D1**2*b1*f**2*fdd*r - 18*D1**2*b1*f**2*fdd*s + 108*D1**2*b1*f*fd**2*r*s - 36*D1**2*b1*f*fd**2*r - 36*D1**2*b1*f*fd**2*s + 18*D1**2*b1*f*fd**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r - 90*D1**2*bd2*f**2*s**2 + 180*D1**2*bd2*f*fd*s**2 - 90*D1**2*bd2*f*fd*s + 18*D1**2*bdd1*f**3*r*s - 18*D1**2*bdd1*f**3*s + 18*D1**2*bdd1*f**2*r*s - 18*D1**2*bdd1*f**2*s + 45*D1**2*bdd2*f**2*s**2 - 132*D1**2*f**2*fd*r*s + 44*D1**2*f**2*fd*r + 210*D1**2*f**2*fd*s**2 - 96*D1**2*f**2*fd*s + 70*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r*s - 22*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 48*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd + 180*D1**2*f**2*gd2*s**2 - 90*D1**2*f**2*gdd2*s**2 + 132*D1**2*f*fd**2*r*s - 44*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 96*D1**2*f*fd**2*s + 22*D1**2*f*fd**2 + 360*D1**2*f*fd*g2*s**2 - 360*D1**2*f*fd*g2*s + 180*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*s**2 + 180*D1**2*f*fd*gd2*s - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s - 360*D1*Dd*K*b1*f**2*s**2 + 180*D1*Dd*K*b1*f**2*s - 90*D1*Dd*K*b1*f**2 + 720*D1*Dd*K*b1*f*fd*s**2 - 540*D1*Dd*K*b1*f*fd*s + 90*D1*Dd*K*b1*f*fd - 72*D1*Dd*b1*f**3*r*s + 18*D1*Dd*b1*f**3*r + 36*D1*Dd*b1*f**3*s + 432*D1*Dd*b1*f**2*fd*r*s - 126*D1*Dd*b1*f**2*fd*r - 180*D1*Dd*b1*f**2*fd*s + 54*D1*Dd*b1*f**2*fd - 144*D1*Dd*b1*f**2*r*s + 36*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s + 288*D1*Dd*b1*f*fd*r*s - 108*D1*Dd*b1*f*fd*r - 72*D1*Dd*b1*f*fd*s + 36*D1*Dd*b1*f*fd + 360*D1*Dd*bd2*f**2*s**2 - 90*D1*Dd*bd2*f**2*s - 176*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r + 280*D1*Dd*f**3*s**2 - 52*D1*Dd*f**3*s + 70*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r*s - 154*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 270*D1*Dd*f**2*fd*s - 4*D1*Dd*f**2*fd + 720*D1*Dd*f**2*g2*s**2 - 360*D1*Dd*f**2*g2*s + 180*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*s**2 + 180*D1*Dd*f**2*gd2*s - 1440*D1*Dd*f*fd*g2*s**2 + 1080*D1*Dd*f*fd*g2*s - 180*D1*Dd*f*fd*g2 + 180*D1*Ddd*K*b1*f**2*s**2 - 90*D1*Ddd*K*b1*f**2*s + 45*D1*Ddd*K*b1*f**2 + 72*D1*Ddd*b1*f**3*r*s - 18*D1*Ddd*b1*f**3*r - 36*D1*Ddd*b1*f**3*s + 72*D1*Ddd*b1*f**2*r*s - 18*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s + 88*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 26*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*s**2 + 180*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 18*D1*bd1*f*(D1*(f*s*(5*K*s + f*(r - 1) + 2*r - 2) + fd*(f*(-6*r*s + r + 4*s - 1) - 4*r*s + r - (2*s - 1)*(5*K*s - 1))) - Dd*f*(20*K*s**2 - 5*K*s + f*r*(8*s - 1) - 6*f*s + f + r*(8*s - 1) - 6*s + 1)) + 540*Dd**2*K*b1*f**2*s**2 - 270*Dd**2*K*b1*f**2*s + 216*Dd**2*b1*f**3*r*s - 54*Dd**2*b1*f**3*r - 108*Dd**2*b1*f**3*s + 36*Dd**2*b1*f**3 + 216*Dd**2*b1*f**2*r*s - 54*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 + 264*Dd**2*f**3*r*s - 66*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 78*Dd**2*f**3*s + 44*Dd**2*f**3 - 1080*Dd**2*f**2*g2*s**2 + 540*Dd**2*f**2*g2*s - 45*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(126*d**2*k3**2) + 9*D1**2*Pk3*Pkd2*ct**5*f**2*k1**5*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(22*d**2*k2**2*k3**4) + D1**2*Pk3*Pkd2*ct**5*f*k2**4*(8*C - 4)*(D1*Dd*f*(2*f*(-4*r*s + r + 2*s) + fd*(24*r*s - 7*r - 10*s + 3)) + D1*(D1*(2*f*fd*(-3*r*s + r + s) + f*fdd*(3*r*s - r - s) + fd**2*(6*r*s - 2*r - 2*s + 1)) + Ddd*f**2*(r*(4*s - 1) - 2*s)) + Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2))/(63*d**2*k1*k3**4) + D1**2*Pk3*Pkd2*ct**5*f*k2**2*(8*C - 4)*(D1*Dd*f*(2*f*(4*r*s - r - 2*s) + fd*(-24*r*s + 7*r + 10*s - 3)) + D1*(D1*(2*f*fd*(3*r*s - r - s) + f*fdd*(-3*r*s + r + s) + fd**2*(-6*r*s + 2*r + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + 2*s)) + Dd**2*f**2*(r*(3 - 12*s) + 6*s - 2))/(63*d**2*k1*k3**2) + 4*D1**2*Pk3*Pkd2*ct**5*k1**5*(1650*C*D1**2*f**2*fd*r*s - 550*C*D1**2*f**2*fd*r + 1650*C*D1**2*f**2*fd*s**2 - 1650*C*D1**2*f**2*fd*s + 550*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r*s + 770*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 2310*C*D1**2*f**2*fdd*s - 770*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r*s + 1540*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 4620*C*D1**2*f*fd**2*s - 770*C*D1**2*f*fd**2 + 2200*C*D1*Dd*f**3*r*s - 550*C*D1*Dd*f**3*r + 2200*C*D1*Dd*f**3*s**2 - 2200*C*D1*Dd*f**3*s + 550*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r*s + 5390*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 18480*C*D1*Dd*f**2*fd*s - 3850*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r*s + 770*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 3080*C*D1*Ddd*f**3*s - 770*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r*s + 2310*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 9240*C*Dd**2*f**3*s - 1540*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 5460*D1**2*f**3*fd*r*s - 1365*D1**2*f**3*fd*r + 5460*D1**2*f**3*fd*s**2 - 5460*D1**2*f**3*fd*s + 1365*D1**2*f**3*fd - 5040*D1**2*f**3*fdd*r*s + 1260*D1**2*f**3*fdd*r - 5040*D1**2*f**3*fdd*s**2 + 5040*D1**2*f**3*fdd*s - 1260*D1**2*f**3*fdd - 15120*D1**2*f**2*fd**2*r*s + 3780*D1**2*f**2*fd**2*r - 15120*D1**2*f**2*fd**2*s**2 + 15120*D1**2*f**2*fd**2*s - 2520*D1**2*f**2*fd**2 - 1650*D1**2*f**2*fd*r*s + 550*D1**2*f**2*fd*r - 1650*D1**2*f**2*fd*s**2 + 1650*D1**2*f**2*fd*s - 550*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r*s - 770*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2310*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd - 594*D1**2*f**2*gd2*r*s - 594*D1**2*f**2*gd2*s**2 + 594*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 4620*D1**2*f*fd**2*r*s - 1540*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 4620*D1**2*f*fd**2*s + 770*D1**2*f*fd**2 - 1188*D1**2*f*fd*g2*r*s + 594*D1**2*f*fd*g2*r - 1188*D1**2*f*fd*g2*s**2 + 1188*D1**2*f*fd*g2*s - 594*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 5460*D1*Dd*f**4*r*s - 1365*D1*Dd*f**4*r + 5460*D1*Dd*f**4*s**2 - 5460*D1*Dd*f**4*s + 1365*D1*Dd*f**4 - 40320*D1*Dd*f**3*fd*r*s + 10080*D1*Dd*f**3*fd*r - 40320*D1*Dd*f**3*fd*s**2 + 40320*D1*Dd*f**3*fd*s - 7560*D1*Dd*f**3*fd - 2200*D1*Dd*f**3*r*s + 550*D1*Dd*f**3*r - 2200*D1*Dd*f**3*s**2 + 2200*D1*Dd*f**3*s - 550*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r*s - 5390*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 18480*D1*Dd*f**2*fd*s + 3850*D1*Dd*f**2*fd - 2376*D1*Dd*f**2*g2*r*s + 594*D1*Dd*f**2*g2*r - 2376*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 594*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 5040*D1*Ddd*f**4*r*s + 1260*D1*Ddd*f**4*r - 5040*D1*Ddd*f**4*s**2 + 5040*D1*Ddd*f**4*s - 1260*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r*s - 770*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 3080*D1*Ddd*f**3*s + 770*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(3*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 15120*Dd**2*f**4*r*s + 3780*Dd**2*f**4*r - 15120*Dd**2*f**4*s**2 + 15120*Dd**2*f**4*s - 2520*Dd**2*f**4 + 9240*Dd**2*f**3*r*s - 2310*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 9240*Dd**2*f**3*s + 1540*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(3*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(3*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**5*k1**3*k2**2*st**2*(5412*C*D1**2*f**2*fd*r*s - 1804*C*D1**2*f**2*fd*r + 5412*C*D1**2*f**2*fd*s**2 - 5412*C*D1**2*f**2*fd*s + 1804*C*D1**2*f**2*fd - 3300*C*D1**2*f**2*fdd*r*s + 1100*C*D1**2*f**2*fdd*r - 3300*C*D1**2*f**2*fdd*s**2 + 3300*C*D1**2*f**2*fdd*s - 1100*C*D1**2*f**2*fdd - 6600*C*D1**2*f*fd**2*r*s + 2200*C*D1**2*f*fd**2*r - 6600*C*D1**2*f*fd**2*s**2 + 6600*C*D1**2*f*fd**2*s - 1100*C*D1**2*f*fd**2 + 7216*C*D1*Dd*f**3*r*s - 1804*C*D1*Dd*f**3*r + 7216*C*D1*Dd*f**3*s**2 - 7216*C*D1*Dd*f**3*s + 1804*C*D1*Dd*f**3 - 26400*C*D1*Dd*f**2*fd*r*s + 7700*C*D1*Dd*f**2*fd*r - 26400*C*D1*Dd*f**2*fd*s**2 + 26400*C*D1*Dd*f**2*fd*s - 5500*C*D1*Dd*f**2*fd - 4400*C*D1*Ddd*f**3*r*s + 1100*C*D1*Ddd*f**3*r - 4400*C*D1*Ddd*f**3*s**2 + 4400*C*D1*Ddd*f**3*s - 1100*C*D1*Ddd*f**3 - 13200*C*Dd**2*f**3*r*s + 3300*C*Dd**2*f**3*r - 13200*C*Dd**2*f**3*s**2 + 13200*C*Dd**2*f**3*s - 2200*C*Dd**2*f**3 - 990*D1**2*K*bdd1*f**2*r*s - 990*D1**2*K*bdd1*f**2*s**2 + 990*D1**2*K*bdd1*f**2*s + 990*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*s**2 - 990*D1**2*bdd1*f**2*s + 6740*D1**2*f**3*fd*r*s - 1685*D1**2*f**3*fd*r + 6740*D1**2*f**3*fd*s**2 - 6740*D1**2*f**3*fd*s + 1685*D1**2*f**3*fd - 3920*D1**2*f**3*fdd*r*s + 980*D1**2*f**3*fdd*r - 3920*D1**2*f**3*fdd*s**2 + 3920*D1**2*f**3*fdd*s - 980*D1**2*f**3*fdd - 11760*D1**2*f**2*fd**2*r*s + 2940*D1**2*f**2*fd**2*r - 11760*D1**2*f**2*fd**2*s**2 + 11760*D1**2*f**2*fd**2*s - 1960*D1**2*f**2*fd**2 - 5412*D1**2*f**2*fd*r*s + 1804*D1**2*f**2*fd*r - 5412*D1**2*f**2*fd*s**2 + 5412*D1**2*f**2*fd*s - 1804*D1**2*f**2*fd + 3300*D1**2*f**2*fdd*r*s - 1100*D1**2*f**2*fdd*r + 3300*D1**2*f**2*fdd*s**2 - 3300*D1**2*f**2*fdd*s + 1100*D1**2*f**2*fdd - 3036*D1**2*f**2*gd2*r*s - 3036*D1**2*f**2*gd2*s**2 + 3036*D1**2*f**2*gd2*s + 1980*D1**2*f**2*gdd2*r*s + 1980*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 6600*D1**2*f*fd**2*r*s - 2200*D1**2*f*fd**2*r + 6600*D1**2*f*fd**2*s**2 - 6600*D1**2*f*fd**2*s + 1100*D1**2*f*fd**2 - 6072*D1**2*f*fd*g2*r*s + 3036*D1**2*f*fd*g2*r - 6072*D1**2*f*fd*g2*s**2 + 6072*D1**2*f*fd*g2*s - 3036*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s + 6740*D1*Dd*f**4*r*s - 1685*D1*Dd*f**4*r + 6740*D1*Dd*f**4*s**2 - 6740*D1*Dd*f**4*s + 1685*D1*Dd*f**4 - 31360*D1*Dd*f**3*fd*r*s + 7840*D1*Dd*f**3*fd*r - 31360*D1*Dd*f**3*fd*s**2 + 31360*D1*Dd*f**3*fd*s - 5880*D1*Dd*f**3*fd - 7216*D1*Dd*f**3*r*s + 1804*D1*Dd*f**3*r - 7216*D1*Dd*f**3*s**2 + 7216*D1*Dd*f**3*s - 1804*D1*Dd*f**3 + 26400*D1*Dd*f**2*fd*r*s - 7700*D1*Dd*f**2*fd*r + 26400*D1*Dd*f**2*fd*s**2 - 26400*D1*Dd*f**2*fd*s + 5500*D1*Dd*f**2*fd - 12144*D1*Dd*f**2*g2*r*s + 3036*D1*Dd*f**2*g2*r - 12144*D1*Dd*f**2*g2*s**2 + 12144*D1*Dd*f**2*g2*s - 3036*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r*s - 1980*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 15840*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 31680*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 - 3920*D1*Ddd*f**4*r*s + 980*D1*Ddd*f**4*r - 3920*D1*Ddd*f**4*s**2 + 3920*D1*Ddd*f**4*s - 980*D1*Ddd*f**4 + 4400*D1*Ddd*f**3*r*s - 1100*D1*Ddd*f**3*r + 4400*D1*Ddd*f**3*s**2 - 4400*D1*Ddd*f**3*s + 1100*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 1980*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 11760*Dd**2*f**4*r*s + 2940*Dd**2*f**4*r - 11760*Dd**2*f**4*s**2 + 11760*Dd**2*f**4*s - 1960*Dd**2*f**4 + 13200*Dd**2*f**3*r*s - 3300*Dd**2*f**3*r + 13200*Dd**2*f**3*s**2 - 13200*Dd**2*f**3*s + 2200*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 3960*Dd**2*f**2*g2 + 66*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**5*k1**3*k2**2*(-270*C*D1**2*bdd1*f**2*r*s + 270*C*D1**2*bdd1*f**2*r - 270*C*D1**2*bdd1*f**2*s**2 + 540*C*D1**2*bdd1*f**2*s - 270*C*D1**2*bdd1*f**2 + 900*C*D1**2*f**2*fd*r*s - 300*C*D1**2*f**2*fd*r + 900*C*D1**2*f**2*fd*s**2 - 900*C*D1**2*f**2*fd*s + 300*C*D1**2*f**2*fd - 1260*C*D1**2*f**2*fdd*r*s + 420*C*D1**2*f**2*fdd*r - 1260*C*D1**2*f**2*fdd*s**2 + 1260*C*D1**2*f**2*fdd*s - 420*C*D1**2*f**2*fdd - 2520*C*D1**2*f*fd**2*r*s + 840*C*D1**2*f*fd**2*r - 2520*C*D1**2*f*fd**2*s**2 + 2520*C*D1**2*f*fd**2*s - 420*C*D1**2*f*fd**2 + 1200*C*D1*Dd*f**3*r*s - 300*C*D1*Dd*f**3*r + 1200*C*D1*Dd*f**3*s**2 - 1200*C*D1*Dd*f**3*s + 300*C*D1*Dd*f**3 - 10080*C*D1*Dd*f**2*fd*r*s + 2940*C*D1*Dd*f**2*fd*r - 10080*C*D1*Dd*f**2*fd*s**2 + 10080*C*D1*Dd*f**2*fd*s - 2100*C*D1*Dd*f**2*fd - 1680*C*D1*Ddd*f**3*r*s + 420*C*D1*Ddd*f**3*r - 1680*C*D1*Ddd*f**3*s**2 + 1680*C*D1*Ddd*f**3*s - 420*C*D1*Ddd*f**3 - 5040*C*Dd**2*f**3*r*s + 1260*C*Dd**2*f**3*r - 5040*C*Dd**2*f**3*s**2 + 5040*C*Dd**2*f**3*s - 840*C*Dd**2*f**3 - 270*D1**2*K*bdd1*f**2*r*s - 270*D1**2*K*bdd1*f**2*s**2 + 270*D1**2*K*bdd1*f**2*s - 189*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 70*D1**2*bdd1*f**3*r*s + 140*D1**2*bdd1*f**3*r + 70*D1**2*bdd1*f**3*s**2 + 70*D1**2*bdd1*f**3*s - 140*D1**2*bdd1*f**3 + 405*D1**2*bdd1*f**2*r*s - 270*D1**2*bdd1*f**2*r + 405*D1**2*bdd1*f**2*s**2 - 675*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 + 378*D1**2*bdd1*f*g2*r*s - 378*D1**2*bdd1*f*g2*r + 378*D1**2*bdd1*f*g2*s**2 - 756*D1**2*bdd1*f*g2*s + 378*D1**2*bdd1*f*g2 - 420*D1**2*f**3*fd*r*s + 105*D1**2*f**3*fd*r - 420*D1**2*f**3*fd*s**2 + 420*D1**2*f**3*fd*s - 105*D1**2*f**3*fd - 540*D1**2*f**2*fd*r*s + 180*D1**2*f**2*fd*r - 540*D1**2*f**2*fd*s**2 + 540*D1**2*f**2*fd*s - 180*D1**2*f**2*fd + 945*D1**2*f**2*fdd*r*s - 315*D1**2*f**2*fdd*r + 945*D1**2*f**2*fdd*s**2 - 945*D1**2*f**2*fdd*s + 315*D1**2*f**2*fdd - 324*D1**2*f**2*gd2*r*s - 324*D1**2*f**2*gd2*s**2 + 324*D1**2*f**2*gd2*s + 540*D1**2*f**2*gdd2*r*s + 540*D1**2*f**2*gdd2*s**2 - 540*D1**2*f**2*gdd2*s + 1890*D1**2*f*fd**2*r*s - 630*D1**2*f*fd**2*r + 1890*D1**2*f*fd**2*s**2 - 1890*D1**2*f*fd**2*s + 315*D1**2*f*fd**2 - 648*D1**2*f*fd*g2*r*s + 324*D1**2*f*fd*g2*r - 648*D1**2*f*fd*g2*s**2 + 648*D1**2*f*fd*g2*s - 324*D1**2*f*fd*g2 + 2160*D1**2*f*fd*gd2*r*s - 540*D1**2*f*fd*gd2*r + 2160*D1**2*f*fd*gd2*s**2 - 2160*D1**2*f*fd*gd2*s + 540*D1**2*f*fd*gd2 + 1080*D1**2*f*fdd*g2*r*s - 540*D1**2*f*fdd*g2*r + 1080*D1**2*f*fdd*g2*s**2 - 1080*D1**2*f*fdd*g2*s + 540*D1**2*f*fdd*g2 + 1080*D1**2*fd**2*g2*r*s - 540*D1**2*fd**2*g2*r + 1080*D1**2*fd**2*g2*s**2 - 1080*D1**2*fd**2*g2*s - 420*D1*Dd*f**4*r*s + 105*D1*Dd*f**4*r - 420*D1*Dd*f**4*s**2 + 420*D1*Dd*f**4*s - 105*D1*Dd*f**4 - 720*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 720*D1*Dd*f**3*s**2 + 720*D1*Dd*f**3*s - 180*D1*Dd*f**3 + 7560*D1*Dd*f**2*fd*r*s - 2205*D1*Dd*f**2*fd*r + 7560*D1*Dd*f**2*fd*s**2 - 7560*D1*Dd*f**2*fd*s + 1575*D1*Dd*f**2*fd - 1296*D1*Dd*f**2*g2*r*s + 324*D1*Dd*f**2*g2*r - 1296*D1*Dd*f**2*g2*s**2 + 1296*D1*Dd*f**2*g2*s - 324*D1*Dd*f**2*g2 + 4320*D1*Dd*f**2*gd2*r*s - 540*D1*Dd*f**2*gd2*r + 4320*D1*Dd*f**2*gd2*s**2 - 4320*D1*Dd*f**2*gd2*s + 540*D1*Dd*f**2*gd2 + 8640*D1*Dd*f*fd*g2*r*s - 3240*D1*Dd*f*fd*g2*r + 8640*D1*Dd*f*fd*g2*s**2 - 8640*D1*Dd*f*fd*g2*s + 2160*D1*Dd*f*fd*g2 + 1260*D1*Ddd*f**3*r*s - 315*D1*Ddd*f**3*r + 1260*D1*Ddd*f**3*s**2 - 1260*D1*Ddd*f**3*s + 315*D1*Ddd*f**3 + 2160*D1*Ddd*f**2*g2*r*s - 540*D1*Ddd*f**2*g2*r + 2160*D1*Ddd*f**2*g2*s**2 - 2160*D1*Ddd*f**2*g2*s + 540*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(5*f**3*(10*s + 47)*(r + s - 1) - 2*f**2*(207*C*(s - 1)*(r + s - 1) + 35*fd*(r*(6*s + 3) + 6*s**2 - 2*s - 1) + (s*(9*K - 24) + 23)*(9*r + 9*s - 9)) + 3*f*(45*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 5*r - 12*s**2 + 14*s - 3) + (182*g2*(s - 1) + 126*gd2*(1 - 2*s))*(r + s - 1)) - 378*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(70*f**2*(r*(8*s + 7) + 8*s**2 - 5) - 135*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 11*r - 24*s**2 + 32*s - 9) + 378*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 3780*Dd**2*f**3*r*s - 945*Dd**2*f**3*r + 3780*Dd**2*f**3*s**2 - 3780*Dd**2*f**3*s + 630*Dd**2*f**3 + 6480*Dd**2*f**2*g2*r*s - 1620*Dd**2*f**2*g2*r + 6480*Dd**2*f**2*g2*s**2 - 6480*Dd**2*f**2*g2*s + 1080*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*s*(13*fd - 9*fdd)*(r + s) + D1*Dd*(13*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(-8*r*s + r + s*(4 - 8*s))) - 9*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(828*C*D1**2*f*fd*r*s + 828*C*D1**2*f*fd*s**2 - 414*C*D1**2*f*fd*s - 540*C*D1**2*f*fdd*r*s - 540*C*D1**2*f*fdd*s**2 + 270*C*D1**2*f*fdd*s - 540*C*D1**2*fd**2*r*s - 540*C*D1**2*fd**2*s**2 + 270*C*D1**2*fd**2*s + 1656*C*D1*Dd*f**2*r*s - 414*C*D1*Dd*f**2*r + 1656*C*D1*Dd*f**2*s**2 - 1656*C*D1*Dd*f**2*s + 414*C*D1*Dd*f**2 - 4320*C*D1*Dd*f*fd*r*s + 540*C*D1*Dd*f*fd*r - 4320*C*D1*Dd*f*fd*s**2 + 3240*C*D1*Dd*f*fd*s - 270*C*D1*Dd*f*fd - 1080*C*D1*Ddd*f**2*r*s + 270*C*D1*Ddd*f**2*r - 1080*C*D1*Ddd*f**2*s**2 + 1080*C*D1*Ddd*f**2*s - 270*C*D1*Ddd*f**2 - 3240*C*Dd**2*f**2*r*s + 810*C*Dd**2*f**2*r - 3240*C*Dd**2*f**2*s**2 + 3240*C*Dd**2*f**2*s - 540*C*Dd**2*f**2 + 324*D1**2*K*f*fd*r*s - 162*D1**2*K*f*fd*r + 324*D1**2*K*f*fd*s**2 - 324*D1**2*K*f*fd*s + 162*D1**2*K*f*fd - 540*D1**2*K*f*fdd*r*s + 270*D1**2*K*f*fdd*r - 540*D1**2*K*f*fdd*s**2 + 540*D1**2*K*f*fdd*s - 270*D1**2*K*f*fdd - 540*D1**2*K*fd**2*r*s + 270*D1**2*K*fd**2*r - 540*D1**2*K*fd**2*s**2 + 540*D1**2*K*fd**2*s - 189*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 150*D1**2*f**2*fd*r*s + 285*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 385*D1**2*f**2*fd*s - 285*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r*s - 210*D1**2*f**2*fdd*r + 210*D1**2*f**2*fdd*s**2 - 350*D1**2*f**2*fdd*s + 210*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r*s - 420*D1**2*f*fd**2*r + 420*D1**2*f*fd**2*s**2 - 700*D1**2*f*fd**2*s + 210*D1**2*f*fd**2 - 864*D1**2*f*fd*r*s + 18*D1**2*f*fd*r - 864*D1**2*f*fd*s**2 + 450*D1**2*f*fd*s - 18*D1**2*f*fd + 810*D1**2*f*fdd*r*s - 135*D1**2*f*fdd*r + 810*D1**2*f*fdd*s**2 - 540*D1**2*f*fdd*s + 135*D1**2*f*fdd - 546*D1**2*f*gd2*r*s - 546*D1**2*f*gd2*s**2 + 546*D1**2*f*gd2*s + 378*D1**2*f*gdd2*r*s + 378*D1**2*f*gdd2*s**2 - 378*D1**2*f*gdd2*s + 810*D1**2*fd**2*r*s - 135*D1**2*fd**2*r + 810*D1**2*fd**2*s**2 - 540*D1**2*fd**2*s - 546*D1**2*fd*g2*r*s - 546*D1**2*fd*g2*s**2 + 756*D1**2*fd*gd2*r*s + 756*D1**2*fd*gd2*s**2 - 378*D1**2*fd*gd2*s + 378*D1**2*fdd*g2*r*s + 378*D1**2*fdd*g2*s**2 + 648*D1*Dd*K*f**2*r*s - 162*D1*Dd*K*f**2*r + 648*D1*Dd*K*f**2*s**2 - 648*D1*Dd*K*f**2*s + 162*D1*Dd*K*f**2 - 4320*D1*Dd*K*f*fd*r*s + 1620*D1*Dd*K*f*fd*r - 4320*D1*Dd*K*f*fd*s**2 + 4320*D1*Dd*K*f*fd*s - 1080*D1*Dd*K*f*fd - 200*D1*Dd*f**3*r*s + 50*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 200*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r*s - 1050*D1*Dd*f**2*fd*r + 1680*D1*Dd*f**2*fd*s**2 - 2240*D1*Dd*f**2*fd*s + 770*D1*Dd*f**2*fd - 1728*D1*Dd*f**2*r*s + 432*D1*Dd*f**2*r - 1728*D1*Dd*f**2*s**2 + 1728*D1*Dd*f**2*s - 432*D1*Dd*f**2 + 6480*D1*Dd*f*fd*r*s - 1350*D1*Dd*f*fd*r + 6480*D1*Dd*f*fd*s**2 - 5400*D1*Dd*f*fd*s + 810*D1*Dd*f*fd - 2184*D1*Dd*f*g2*r*s + 546*D1*Dd*f*g2*r - 2184*D1*Dd*f*g2*s**2 + 2184*D1*Dd*f*g2*s - 546*D1*Dd*f*g2 + 3024*D1*Dd*f*gd2*r*s - 378*D1*Dd*f*gd2*r + 3024*D1*Dd*f*gd2*s**2 - 3024*D1*Dd*f*gd2*s + 378*D1*Dd*f*gd2 + 3024*D1*Dd*fd*g2*r*s - 378*D1*Dd*fd*g2*r + 3024*D1*Dd*fd*g2*s**2 - 1512*D1*Dd*fd*g2*s - 1080*D1*Ddd*K*f**2*r*s + 270*D1*Ddd*K*f**2*r - 1080*D1*Ddd*K*f**2*s**2 + 1080*D1*Ddd*K*f**2*s - 270*D1*Ddd*K*f**2 + 280*D1*Ddd*f**3*r*s - 70*D1*Ddd*f**3*r + 280*D1*Ddd*f**3*s**2 - 280*D1*Ddd*f**3*s + 70*D1*Ddd*f**3 + 1620*D1*Ddd*f**2*r*s - 405*D1*Ddd*f**2*r + 1620*D1*Ddd*f**2*s**2 - 1620*D1*Ddd*f**2*s + 405*D1*Ddd*f**2 + 1512*D1*Ddd*f*g2*r*s - 378*D1*Ddd*f*g2*r + 1512*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 378*D1*Ddd*f*g2 + 21*D1*bd1*(K - 1)*(D1*(13*f*(2*s - 1)*(r + s - 1) + 9*fd*(-4*r*s + r + s*(3 - 4*s))) - 9*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3240*Dd**2*K*f**2*r*s + 810*Dd**2*K*f**2*r - 3240*Dd**2*K*f**2*s**2 + 3240*Dd**2*K*f**2*s - 540*Dd**2*K*f**2 + 840*Dd**2*f**3*r*s - 210*Dd**2*f**3*r + 840*Dd**2*f**3*s**2 - 840*Dd**2*f**3*s + 140*Dd**2*f**3 + 4860*Dd**2*f**2*r*s - 1215*Dd**2*f**2*r + 4860*Dd**2*f**2*s**2 - 4860*Dd**2*f**2*s + 810*Dd**2*f**2 + 4536*Dd**2*f*g2*r*s - 1134*Dd**2*f*g2*r + 4536*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 756*Dd**2*f*g2))/(315*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**5*k1**3*st**2*(D1**2*(441*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(1323*fd**2*s*(2*s - 1) - fd*(440*C - 440)*(3*s**2 - 2*s + 1) + fdd*(220*C - 220)*(3*s**2 - 2*s + 1) + s**2*(198*K*bdd1 - 396*bd1*(K - 1) - 198*bdd1 + 792*gd2 - 396*gdd2)) - 88*f*(fd**2*s*(10*C - 10)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 1584*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(441*f**3*(4*s**2 - 2*s + 1) + f**2*(440*C*(4*s**2 - 2*s + 1) - 441*fd*(1 - 4*s)**2 - 1760*s**2 + 880*s - 440) - 44*f*(fd*(10*C - 10)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 792*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(441*f**2 + f*(440*C - 440) - 792*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(441*f**2 + f*(440*C - 440) - 792*g2) + 396*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**5*k1**3*(360*C*D1**2*bdd1*f**2*r*s + 1260*C*D1**2*bdd1*f**2*s**2 - 1800*C*D1**2*bdd1*f**2*s + 900*C*D1**2*bdd1*f**2 + 3240*C*D1**2*f**2*fd*r*s - 1080*C*D1**2*f**2*fd*r + 4560*C*D1**2*f**2*fd*s**2 - 4120*C*D1**2*f**2*fd*s + 1520*C*D1**2*f**2*fd - 2160*C*D1**2*f**2*fdd*r*s + 720*C*D1**2*f**2*fdd*r - 3360*C*D1**2*f**2*fdd*s**2 + 2960*C*D1**2*f**2*fdd*s - 1120*C*D1**2*f**2*fdd - 4320*C*D1**2*f*fd**2*r*s + 1440*C*D1**2*f*fd**2*r - 6720*C*D1**2*f*fd**2*s**2 + 5920*C*D1**2*f*fd**2*s - 720*C*D1**2*f*fd**2 + 4320*C*D1*Dd*f**3*r*s - 1080*C*D1*Dd*f**3*r + 6080*C*D1*Dd*f**3*s**2 - 5200*C*D1*Dd*f**3*s + 1520*C*D1*Dd*f**3 - 17280*C*D1*Dd*f**2*fd*r*s + 5040*C*D1*Dd*f**2*fd*r - 26880*C*D1*Dd*f**2*fd*s**2 + 22880*C*D1*Dd*f**2*fd*s - 4400*C*D1*Dd*f**2*fd - 2880*C*D1*Ddd*f**3*r*s + 720*C*D1*Ddd*f**3*r - 4480*C*D1*Ddd*f**3*s**2 + 3680*C*D1*Ddd*f**3*s - 1120*C*D1*Ddd*f**3 - 8640*C*Dd**2*f**3*r*s + 2160*C*Dd**2*f**3*r - 13440*C*Dd**2*f**3*s**2 + 11040*C*Dd**2*f**3*s - 1440*C*Dd**2*f**3 - 432*D1**2*K*bdd1*f**2*r*s - 792*D1**2*K*bdd1*f**2*s**2 + 432*D1**2*K*bdd1*f**2*s + 252*D1**2*bd1**2*f*s*(K - 1)*(2*r + 7*s - 6) + 700*D1**2*bdd1*f**3*r*s + 700*D1**2*bdd1*f**3*s**2 - 1470*D1**2*bdd1*f**3*s + 525*D1**2*bdd1*f**3 + 612*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 + 828*D1**2*bdd1*f**2*s - 900*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r*s - 1764*D1**2*bdd1*f*g2*s**2 + 2520*D1**2*bdd1*f*g2*s - 1260*D1**2*bdd1*f*g2 + 3360*D1**2*f**3*fd*r*s - 840*D1**2*f**3*fd*r + 7560*D1**2*f**3*fd*s**2 - 5460*D1**2*f**3*fd*s + 1890*D1**2*f**3*fd - 3360*D1**2*f**3*fdd*r*s + 840*D1**2*f**3*fdd*r - 4620*D1**2*f**3*fdd*s**2 + 3990*D1**2*f**3*fdd*s - 1155*D1**2*f**3*fdd - 10080*D1**2*f**2*fd**2*r*s + 2520*D1**2*f**2*fd**2*r - 13860*D1**2*f**2*fd**2*s**2 + 11970*D1**2*f**2*fd**2*s - 1680*D1**2*f**2*fd**2 - 4680*D1**2*f**2*fd*r*s + 1560*D1**2*f**2*fd*r - 7050*D1**2*f**2*fd*s**2 + 6260*D1**2*f**2*fd*s - 2350*D1**2*f**2*fd + 3420*D1**2*f**2*fdd*r*s - 1140*D1**2*f**2*fdd*r + 5145*D1**2*f**2*fdd*s**2 - 4570*D1**2*f**2*fdd*s + 1715*D1**2*f**2*fdd - 1224*D1**2*f**2*gd2*r*s - 2160*D1**2*f**2*gd2*s**2 + 1224*D1**2*f**2*gd2*s + 864*D1**2*f**2*gdd2*r*s + 1584*D1**2*f**2*gdd2*s**2 - 864*D1**2*f**2*gdd2*s + 6840*D1**2*f*fd**2*r*s - 2280*D1**2*f*fd**2*r + 10290*D1**2*f*fd**2*s**2 - 9140*D1**2*f*fd**2*s + 1140*D1**2*f*fd**2 - 2448*D1**2*f*fd*g2*r*s + 1224*D1**2*f*fd*g2*r - 4320*D1**2*f*fd*g2*s**2 + 4320*D1**2*f*fd*g2*s - 2160*D1**2*f*fd*g2 + 3456*D1**2*f*fd*gd2*r*s - 864*D1**2*f*fd*gd2*r + 6336*D1**2*f*fd*gd2*s**2 - 4896*D1**2*f*fd*gd2*s + 864*D1**2*f*fd*gd2 + 1728*D1**2*f*fdd*g2*r*s - 864*D1**2*f*fdd*g2*r + 3168*D1**2*f*fdd*g2*s**2 - 3168*D1**2*f*fdd*g2*s + 1584*D1**2*f*fdd*g2 + 1728*D1**2*fd**2*g2*r*s - 864*D1**2*fd**2*g2*r + 3168*D1**2*fd**2*g2*s**2 - 3168*D1**2*fd**2*g2*s + 3360*D1*Dd*f**4*r*s - 840*D1*Dd*f**4*r + 7560*D1*Dd*f**4*s**2 - 5460*D1*Dd*f**4*s + 1890*D1*Dd*f**4 - 26880*D1*Dd*f**3*fd*r*s + 6720*D1*Dd*f**3*fd*r - 36960*D1*Dd*f**3*fd*s**2 + 31920*D1*Dd*f**3*fd*s - 5670*D1*Dd*f**3*fd - 6240*D1*Dd*f**3*r*s + 1560*D1*Dd*f**3*r - 9400*D1*Dd*f**3*s**2 + 7820*D1*Dd*f**3*s - 2350*D1*Dd*f**3 + 27360*D1*Dd*f**2*fd*r*s - 7980*D1*Dd*f**2*fd*r + 41160*D1*Dd*f**2*fd*s**2 - 35410*D1*Dd*f**2*fd*s + 6850*D1*Dd*f**2*fd - 4896*D1*Dd*f**2*g2*r*s + 1224*D1*Dd*f**2*g2*r - 8640*D1*Dd*f**2*g2*s**2 + 6768*D1*Dd*f**2*g2*s - 2160*D1*Dd*f**2*g2 + 6912*D1*Dd*f**2*gd2*r*s - 864*D1*Dd*f**2*gd2*r + 12672*D1*Dd*f**2*gd2*s**2 - 8352*D1*Dd*f**2*gd2*s + 864*D1*Dd*f**2*gd2 + 13824*D1*Dd*f*fd*g2*r*s - 5184*D1*Dd*f*fd*g2*r + 25344*D1*Dd*f*fd*g2*s**2 - 22464*D1*Dd*f*fd*g2*s + 4896*D1*Dd*f*fd*g2 - 3360*D1*Ddd*f**4*r*s + 840*D1*Ddd*f**4*r - 4620*D1*Ddd*f**4*s**2 + 3990*D1*Ddd*f**4*s - 1155*D1*Ddd*f**4 + 4560*D1*Ddd*f**3*r*s - 1140*D1*Ddd*f**3*r + 6860*D1*Ddd*f**3*s**2 - 5710*D1*Ddd*f**3*s + 1715*D1*Ddd*f**3 + 3456*D1*Ddd*f**2*g2*r*s - 864*D1*Ddd*f**2*g2*r + 6336*D1*Ddd*f**2*g2*s**2 - 4896*D1*Ddd*f**2*g2*s + 1584*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(5*f**3*(86*s**2 + s*(86*r - 258) + 105) + f**2*(36*C*(28*s**2 + s*(3*r - 50) + 25) - 70*fd*(5*r*(6*s - 1) + 30*s**2 - 41*s + 3) - 9*s**2*(60*K - 5) - 9*s*(34*K*(r - 1) - 54*r - 134) - 900) + 3*f*(3*fd*(-280*C*s**2 + 260*C*s + 8*K*(3*r*(4*s - 1) + 22*s**2 - 17*s + 3) - r*(20*C + 34)*(4*s - 1) - 66*s**2 + 21*s - 54) - 28*g2*(16*s**2 + s*(r - 30) + 15) + 84*gd2*s*(2*r + 7*s - 6)) + 252*fd*g2*(r*(2*s - 1) + s*(7*s - 7))) + Dd*f*(-35*f**2*(10*r*(8*s - 1) + 80*s**2 - 124*s + 21) - 9*f*(20*C*(r*(8*s - 1) + 28*s**2 - 29*s + 5) - 8*K*(24*r*s - 3*r + 44*s**2 - 29*s + 3) + 272*r*s - 34*r + 132*s**2 + 83*s - 46) + 252*g2*(r*(8*s - 1) + 28*s**2 - 29*s + 5))) - 10080*Dd**2*f**4*r*s + 2520*Dd**2*f**4*r - 13860*Dd**2*f**4*s**2 + 11970*Dd**2*f**4*s - 1680*Dd**2*f**4 + 13680*Dd**2*f**3*r*s - 3420*Dd**2*f**3*r + 20580*Dd**2*f**3*s**2 - 17130*Dd**2*f**3*s + 2280*Dd**2*f**3 + 10368*Dd**2*f**2*g2*r*s - 2592*Dd**2*f**2*g2*r + 19008*Dd**2*f**2*g2*s**2 - 14688*Dd**2*f**2*g2*s + 1728*Dd**2*f**2*g2 - 42*b1**2*(K - 1)*(D1**2*(2*fd*(r*(s - 1) + 16*s**2 - 2*s + 1) - 3*fdd*(2*r*(s - 1) + 7*s**2 - 4*s + 2)) + D1*(2*Dd*(f*(4*r*s - r + 64*s**2 - 34*s + 16) - 3*fd*(8*r*s - 5*r + 28*s**2 - 17*s + 4)) - 3*Ddd*f*(r*(8*s - 2) + 28*s**2 - 18*s + 7)) - 6*Dd**2*f*(3*r*(4*s - 1) + 42*s**2 - 27*s + 2)) + b1*(-432*C*D1**2*f*fd*r*s + 216*C*D1**2*f*fd*r - 4032*C*D1**2*f*fd*s**2 + 648*C*D1**2*f*fd*s - 216*C*D1**2*f*fd + 720*C*D1**2*f*fdd*r*s - 360*C*D1**2*f*fdd*r + 2520*C*D1**2*f*fdd*s**2 - 1080*C*D1**2*f*fdd*s + 360*C*D1**2*f*fdd + 720*C*D1**2*fd**2*r*s - 360*C*D1**2*fd**2*r + 2520*C*D1**2*fd**2*s**2 - 1080*C*D1**2*fd**2*s + 360*C*D1**2*fd**2 - 864*C*D1*Dd*f**2*r*s + 216*C*D1*Dd*f**2*r - 8064*C*D1*Dd*f**2*s**2 + 4464*C*D1*Dd*f**2*s - 2016*C*D1*Dd*f**2 + 5760*C*D1*Dd*f*fd*r*s - 2160*C*D1*Dd*f*fd*r + 20160*C*D1*Dd*f*fd*s**2 - 10800*C*D1*Dd*f*fd*s + 1800*C*D1*Dd*f*fd + 1440*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 5040*C*D1*Ddd*f**2*s**2 - 3240*C*D1*Ddd*f**2*s + 1260*C*D1*Ddd*f**2 + 4320*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 15120*C*Dd**2*f**2*s**2 - 9720*C*Dd**2*f**2*s + 720*C*Dd**2*f**2 + 1224*D1**2*K*f*fd*r*s - 612*D1**2*K*f*fd*r + 2160*D1**2*K*f*fd*s**2 - 2160*D1**2*K*f*fd*s + 1080*D1**2*K*f*fd - 864*D1**2*K*f*fdd*r*s + 432*D1**2*K*f*fdd*r - 1584*D1**2*K*f*fdd*s**2 + 1584*D1**2*K*f*fdd*s - 792*D1**2*K*f*fdd - 864*D1**2*K*fd**2*r*s + 432*D1**2*K*fd**2*r - 1584*D1**2*K*fd**2*s**2 + 1584*D1**2*K*fd**2*s + 126*D1**2*bdd1*f*(K - 1)*(14*s**2 + s*(4*r - 12) + 5) - 2580*D1**2*f**2*fd*r*s + 860*D1**2*f**2*fd*r - 2580*D1**2*f**2*fd*s**2 + 860*D1**2*f**2*fd*s + 190*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 1330*D1**2*f**2*fdd*s + 175*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 2660*D1**2*f*fd**2*s + 980*D1**2*f*fd**2 - 1944*D1**2*f*fd*r*s + 972*D1**2*f*fd*r - 180*D1**2*f*fd*s**2 + 3564*D1**2*f*fd*s - 1890*D1**2*f*fd + 1224*D1**2*f*fdd*r*s - 612*D1**2*f*fdd*r + 594*D1**2*f*fdd*s**2 - 2034*D1**2*f*fdd*s + 1197*D1**2*f*fdd + 168*D1**2*f*gd2*r*s + 2688*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s - 504*D1**2*f*gdd2*r*s - 1764*D1**2*f*gdd2*s**2 + 504*D1**2*f*gdd2*s + 1224*D1**2*fd**2*r*s - 612*D1**2*fd**2*r + 594*D1**2*fd**2*s**2 - 2034*D1**2*fd**2*s - 360*D1**2*fd**2 + 168*D1**2*fd*g2*r*s - 168*D1**2*fd*g2*r + 2688*D1**2*fd*g2*s**2 - 336*D1**2*fd*g2*s + 168*D1**2*fd*g2 - 1008*D1**2*fd*gd2*r*s + 504*D1**2*fd*gd2*r - 3528*D1**2*fd*gd2*s**2 + 1512*D1**2*fd*gd2*s - 504*D1**2*fd*gd2 - 504*D1**2*fdd*g2*r*s + 504*D1**2*fdd*g2*r - 1764*D1**2*fdd*g2*s**2 + 1008*D1**2*fdd*g2*s - 504*D1**2*fdd*g2 + 2448*D1*Dd*K*f**2*r*s - 612*D1*Dd*K*f**2*r + 4320*D1*Dd*K*f**2*s**2 - 3384*D1*Dd*K*f**2*s + 1080*D1*Dd*K*f**2 - 6912*D1*Dd*K*f*fd*r*s + 2592*D1*Dd*K*f*fd*r - 12672*D1*Dd*K*f*fd*s**2 + 11232*D1*Dd*K*f*fd*s - 2448*D1*Dd*K*f*fd - 3440*D1*Dd*f**3*r*s + 860*D1*Dd*f**3*r - 3440*D1*Dd*f**3*s**2 + 3440*D1*Dd*f**3*s - 860*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r*s - 4900*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 13720*D1*Dd*f**2*fd*s + 2730*D1*Dd*f**2*fd - 3888*D1*Dd*f**2*r*s + 972*D1*Dd*f**2*r - 360*D1*Dd*f**2*s**2 + 2124*D1*Dd*f**2*s - 90*D1*Dd*f**2 + 9792*D1*Dd*f*fd*r*s - 3672*D1*Dd*f*fd*r + 4752*D1*Dd*f*fd*s**2 - 11772*D1*Dd*f*fd*s + 3258*D1*Dd*f*fd + 672*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 10752*D1*Dd*f*g2*s**2 - 5712*D1*Dd*f*g2*s + 2688*D1*Dd*f*g2 - 4032*D1*Dd*f*gd2*r*s + 504*D1*Dd*f*gd2*r - 14112*D1*Dd*f*gd2*s**2 + 6552*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 4032*D1*Dd*fd*g2*r*s + 2520*D1*Dd*fd*g2*r - 14112*D1*Dd*fd*g2*s**2 + 8568*D1*Dd*fd*g2*s - 2016*D1*Dd*fd*g2 - 1728*D1*Ddd*K*f**2*r*s + 432*D1*Ddd*K*f**2*r - 3168*D1*Ddd*K*f**2*s**2 + 2448*D1*Ddd*K*f**2*s - 792*D1*Ddd*K*f**2 + 2800*D1*Ddd*f**3*r*s - 700*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 2800*D1*Ddd*f**3*s + 700*D1*Ddd*f**3 + 2448*D1*Ddd*f**2*r*s - 612*D1*Ddd*f**2*r + 1188*D1*Ddd*f**2*s**2 - 1818*D1*Ddd*f**2*s + 297*D1*Ddd*f**2 - 2016*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 7056*D1*Ddd*f*g2*s**2 + 4536*D1*Ddd*f*g2*s - 1764*D1*Ddd*f*g2 - 84*D1*bd1*(K - 1)*(D1*(f*(2*r*s + 32*s**2 - 31*s + 15) - 3*fd*(4*r*s - 2*r + 14*s**2 - 10*s + 1)) - 6*Dd*f*(r*(8*s - 1) + 28*s**2 - 21*s + 3)) - 5184*Dd**2*K*f**2*r*s + 1296*Dd**2*K*f**2*r - 9504*Dd**2*K*f**2*s**2 + 7344*Dd**2*K*f**2*s - 864*Dd**2*K*f**2 + 8400*Dd**2*f**3*r*s - 2100*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 8400*Dd**2*f**3*s + 1400*Dd**2*f**3 + 7344*Dd**2*f**2*r*s - 1836*Dd**2*f**2*r + 3564*Dd**2*f**2*s**2 - 5454*Dd**2*f**2*s + 1224*Dd**2*f**2 - 6048*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 21168*Dd**2*f*g2*s**2 + 13608*Dd**2*f*g2*s - 1008*Dd**2*f*g2))/(630*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**5*k1**3*(b1*(D1**2*(14*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(28*fd**2*s*(2 - 3*s) + 18*fd*(2*s**2 - 2*s + 1) - 9*fdd*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)) + D1*f*(2*Dd*(14*f**2*(4*s**2 - 2*s + 1) - 14*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(14*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(14*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(28*bd1 - 14*bdd1) + f*(-14*fd*(s**2*(6*bd1 - 3) - s*(2*bd1 - 2) - 1) - 7*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 7*fd*(2 - 3*s))) + D1*f*(-2*Dd*(7*f*(s**2*(8*bd1 - 4) - s*(2*bd1 - 2) - 1) + (4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1))) - 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k2**2*k3**2) + 4*D1**2*Pk3*Pkd2*ct**5*k1*k2**4*st**2*(120*C*D1**2*f**2*fd*r*s - 40*C*D1**2*f**2*fd*r + 120*C*D1**2*f**2*fd*s**2 - 120*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd - 60*C*D1**2*f**2*fdd*r*s + 20*C*D1**2*f**2*fdd*r - 60*C*D1**2*f**2*fdd*s**2 + 60*C*D1**2*f**2*fdd*s - 20*C*D1**2*f**2*fdd - 120*C*D1**2*f*fd**2*r*s + 40*C*D1**2*f*fd**2*r - 120*C*D1**2*f*fd**2*s**2 + 120*C*D1**2*f*fd**2*s - 20*C*D1**2*f*fd**2 + 160*C*D1*Dd*f**3*r*s - 40*C*D1*Dd*f**3*r + 160*C*D1*Dd*f**3*s**2 - 160*C*D1*Dd*f**3*s + 40*C*D1*Dd*f**3 - 480*C*D1*Dd*f**2*fd*r*s + 140*C*D1*Dd*f**2*fd*r - 480*C*D1*Dd*f**2*fd*s**2 + 480*C*D1*Dd*f**2*fd*s - 100*C*D1*Dd*f**2*fd - 80*C*D1*Ddd*f**3*r*s + 20*C*D1*Ddd*f**3*r - 80*C*D1*Ddd*f**3*s**2 + 80*C*D1*Ddd*f**3*s - 20*C*D1*Ddd*f**3 - 240*C*Dd**2*f**3*r*s + 60*C*Dd**2*f**3*r - 240*C*Dd**2*f**3*s**2 + 240*C*Dd**2*f**3*s - 40*C*Dd**2*f**3 - 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s + 7*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 - 7*D1**2*bdd1*f**3*s + 9*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 - 9*D1**2*bdd1*f**2*s - 90*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 90*D1**2*f**2*fd*s - 30*D1**2*f**2*fd + 45*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 45*D1**2*f**2*fdd*s + 15*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 90*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 90*D1**2*f*fd**2*s + 15*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 120*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 120*D1*Dd*f**3*s - 30*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*r*s - 105*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 360*D1*Dd*f**2*fd*s + 75*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r*s - 36*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 288*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r*s - 216*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 576*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 60*D1*Ddd*f**3*r*s - 15*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-18*K + 7*f + 9)*(r + s - 1) - 9*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-18*K + 7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 180*Dd**2*f**3*r*s - 45*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 30*Dd**2*f**3 + 432*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1)) - 9*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (36*K - 18)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 7*f + 9)) + Dd**2*f**2*(-18*K + 7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**6) - 4*D1**2*Pk3*Pkd2*ct**5*k1*k2**4*(60*C*D1**2*bdd1*f**2*r*s - 60*C*D1**2*bdd1*f**2*r + 60*C*D1**2*bdd1*f**2*s**2 - 120*C*D1**2*bdd1*f**2*s + 60*C*D1**2*bdd1*f**2 - 150*C*D1**2*f**2*fd*r*s + 50*C*D1**2*f**2*fd*r - 150*C*D1**2*f**2*fd*s**2 + 150*C*D1**2*f**2*fd*s - 50*C*D1**2*f**2*fd + 210*C*D1**2*f**2*fdd*r*s - 70*C*D1**2*f**2*fdd*r + 210*C*D1**2*f**2*fdd*s**2 - 210*C*D1**2*f**2*fdd*s + 70*C*D1**2*f**2*fdd + 420*C*D1**2*f*fd**2*r*s - 140*C*D1**2*f*fd**2*r + 420*C*D1**2*f*fd**2*s**2 - 420*C*D1**2*f*fd**2*s + 70*C*D1**2*f*fd**2 - 200*C*D1*Dd*f**3*r*s + 50*C*D1*Dd*f**3*r - 200*C*D1*Dd*f**3*s**2 + 200*C*D1*Dd*f**3*s - 50*C*D1*Dd*f**3 + 1680*C*D1*Dd*f**2*fd*r*s - 490*C*D1*Dd*f**2*fd*r + 1680*C*D1*Dd*f**2*fd*s**2 - 1680*C*D1*Dd*f**2*fd*s + 350*C*D1*Dd*f**2*fd + 280*C*D1*Ddd*f**3*r*s - 70*C*D1*Ddd*f**3*r + 280*C*D1*Ddd*f**3*s**2 - 280*C*D1*Ddd*f**3*s + 70*C*D1*Ddd*f**3 + 840*C*Dd**2*f**3*r*s - 210*C*Dd**2*f**3*r + 840*C*Dd**2*f**3*s**2 - 840*C*Dd**2*f**3*s + 140*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*s**2 - 45*D1**2*K*bdd1*f**2*s - 3*D1**2*bd1**2*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 45*D1**2*bdd1*f**2*r*s + 45*D1**2*bdd1*f**2*r - 45*D1**2*bdd1*f**2*s**2 + 90*D1**2*bdd1*f**2*s - 45*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 + 30*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 30*D1**2*f**2*fd*s + 10*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r*s + 35*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 105*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd + 54*D1**2*f**2*gd2*r*s + 54*D1**2*f**2*gd2*s**2 - 54*D1**2*f**2*gd2*s - 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*s**2 + 90*D1**2*f**2*gdd2*s - 210*D1**2*f*fd**2*r*s + 70*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 210*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1**2*f*fd*g2*r*s - 54*D1**2*f*fd*g2*r + 108*D1**2*f*fd*g2*s**2 - 108*D1**2*f*fd*g2*s + 54*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r*s + 90*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 90*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r*s + 90*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r*s + 90*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s + 40*D1*Dd*f**3*r*s - 10*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 40*D1*Dd*f**3*s + 10*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r*s + 245*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 840*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd + 216*D1*Dd*f**2*g2*r*s - 54*D1*Dd*f**2*g2*r + 216*D1*Dd*f**2*g2*s**2 - 216*D1*Dd*f**2*g2*s + 54*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r*s + 90*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 720*D1*Dd*f**2*gd2*s - 90*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r*s + 540*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**3*r*s + 35*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 140*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r*s + 90*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + f**2*(r + s - 1)*(40*C*(s - 1) + s*(9*K - 23) + 30) + f*(-5*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 3*K*(r*(4*s - 1) + (1 - 2*s)**2) - 12*r*s + 6*r - 12*s**2 + 15*s - 3) + (-28*r - 28*s + 28)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 28*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-5*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 3*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) + 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 420*Dd**2*f**3*r*s + 105*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 420*Dd**2*f**3*s - 70*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r*s + 270*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 + 3*b1**2*(D1**2*s*(5*f*(2*fd - fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 14*fd*(2*K - 1)*(r + s) + 7*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (14 - 28*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 5*f + 7)) - Dd**2*f*(-14*K + 5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 3*b1*(-80*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*s**2 + 40*C*D1**2*f*fd*s + 40*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 40*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 40*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 - 18*D1**2*K*f*fd*r*s + 9*D1**2*K*f*fd*r - 18*D1**2*K*f*fd*s**2 + 18*D1**2*K*f*fd*s - 9*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 46*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 46*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s - 7*D1**2*f*fd - 30*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*s**2 + 15*D1**2*f*fdd*s + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 30*D1**2*fd**2*r*s - 30*D1**2*fd**2*s**2 + 15*D1**2*fd**2*s + 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*s**2 + 28*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 36*D1*Dd*K*f**2*r*s + 9*D1*Dd*K*f**2*r - 36*D1*Dd*K*f**2*s**2 + 36*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 + 92*D1*Dd*f**2*r*s - 23*D1*Dd*f**2*r + 92*D1*Dd*f**2*s**2 - 92*D1*Dd*f**2*s + 23*D1*Dd*f**2 - 240*D1*Dd*f*fd*r*s + 30*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 15*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 224*D1*Dd*f*gd2*s - 28*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r*s + 28*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 112*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 60*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 112*D1*Ddd*f*g2*s - 28*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(2*s - 1)*(r + s - 1) + f*(-5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (14 - 28*K)*(2*s - 1)*(r + s - 1)) + 7*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-14*K + 5*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 180*Dd**2*f**2*r*s + 45*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 30*Dd**2*f**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 336*Dd**2*f*g2*s - 56*Dd**2*f*g2))/(105*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**5*k1*k2**2*st**2*(-4656*C*D1**2*f**2*fd*r*s + 1552*C*D1**2*f**2*fd*r + 9000*C*D1**2*f**2*fd*s**2 - 4448*C*D1**2*f**2*fd*s + 3000*C*D1**2*f**2*fd + 2760*C*D1**2*f**2*fdd*r*s - 920*C*D1**2*f**2*fdd*r - 4500*C*D1**2*f**2*fdd*s**2 + 2080*C*D1**2*f**2*fdd*s - 1500*C*D1**2*f**2*fdd + 5520*C*D1**2*f*fd**2*r*s - 1840*C*D1**2*f*fd**2*r - 9000*C*D1**2*f*fd**2*s**2 + 4160*C*D1**2*f*fd**2*s + 920*C*D1**2*f*fd**2 - 6208*C*D1*Dd*f**3*r*s + 1552*C*D1*Dd*f**3*r + 12000*C*D1*Dd*f**3*s**2 - 2896*C*D1*Dd*f**3*s + 3000*C*D1*Dd*f**3 + 22080*C*D1*Dd*f**2*fd*r*s - 6440*C*D1*Dd*f**2*fd*r - 36000*C*D1*Dd*f**2*fd*s**2 + 11800*C*D1*Dd*f**2*fd*s - 240*C*D1*Dd*f**2*fd + 3680*C*D1*Ddd*f**3*r*s - 920*C*D1*Ddd*f**3*r - 6000*C*D1*Ddd*f**3*s**2 + 1160*C*D1*Ddd*f**3*s - 1500*C*D1*Ddd*f**3 + 11040*C*Dd**2*f**3*r*s - 2760*C*Dd**2*f**3*r - 18000*C*Dd**2*f**3*s**2 + 3480*C*Dd**2*f**3*s + 1840*C*Dd**2*f**3 + 540*D1**2*K*bdd1*f**2*r*s - 1350*D1**2*K*bdd1*f**2*s**2 - 540*D1**2*K*bdd1*f**2*s - 420*D1**2*bdd1*f**3*r*s + 105*D1**2*bdd1*f**3*s**2 + 420*D1**2*bdd1*f**3*s - 1080*D1**2*bdd1*f**2*r*s + 135*D1**2*bdd1*f**2*s**2 + 1080*D1**2*bdd1*f**2*s - 1680*D1**2*f**3*fd*r*s + 420*D1**2*f**3*fd*r + 840*D1**2*f**3*fd*s + 1680*D1**2*f**3*fdd*r*s - 420*D1**2*f**3*fdd*r - 840*D1**2*f**3*fdd*s + 5040*D1**2*f**2*fd**2*r*s - 1260*D1**2*f**2*fd**2*r - 2520*D1**2*f**2*fd**2*s + 840*D1**2*f**2*fd**2 + 6456*D1**2*f**2*fd*r*s - 2152*D1**2*f**2*fd*r - 4950*D1**2*f**2*fd*s**2 + 1148*D1**2*f**2*fd*s - 1650*D1**2*f**2*fd - 3660*D1**2*f**2*fdd*r*s + 1220*D1**2*f**2*fdd*r + 2475*D1**2*f**2*fdd*s**2 - 430*D1**2*f**2*fdd*s + 825*D1**2*f**2*fdd + 2160*D1**2*f**2*gd2*r*s - 5400*D1**2*f**2*gd2*s**2 - 2160*D1**2*f**2*gd2*s - 1080*D1**2*f**2*gdd2*r*s + 2700*D1**2*f**2*gdd2*s**2 + 1080*D1**2*f**2*gdd2*s - 7320*D1**2*f*fd**2*r*s + 2440*D1**2*f*fd**2*r + 4950*D1**2*f*fd**2*s**2 - 860*D1**2*f*fd**2*s - 1220*D1**2*f*fd**2 + 4320*D1**2*f*fd*g2*r*s - 2160*D1**2*f*fd*g2*r - 10800*D1**2*f*fd*g2*s**2 + 10800*D1**2*f*fd*g2*s - 5400*D1**2*f*fd*g2 - 4320*D1**2*f*fd*gd2*r*s + 1080*D1**2*f*fd*gd2*r + 10800*D1**2*f*fd*gd2*s**2 - 3240*D1**2*f*fd*gd2*s - 1080*D1**2*f*fd*gd2 - 2160*D1**2*f*fdd*g2*r*s + 1080*D1**2*f*fdd*g2*r + 5400*D1**2*f*fdd*g2*s**2 - 5400*D1**2*f*fdd*g2*s + 2700*D1**2*f*fdd*g2 - 2160*D1**2*fd**2*g2*r*s + 1080*D1**2*fd**2*g2*r + 5400*D1**2*fd**2*g2*s**2 - 5400*D1**2*fd**2*g2*s - 1680*D1*Dd*f**4*r*s + 420*D1*Dd*f**4*r + 840*D1*Dd*f**4*s + 13440*D1*Dd*f**3*fd*r*s - 3360*D1*Dd*f**3*fd*r - 6720*D1*Dd*f**3*fd*s + 1680*D1*Dd*f**3*fd + 8608*D1*Dd*f**3*r*s - 2152*D1*Dd*f**3*r - 6600*D1*Dd*f**3*s**2 - 1004*D1*Dd*f**3*s - 1650*D1*Dd*f**3 - 29280*D1*Dd*f**2*fd*r*s + 8540*D1*Dd*f**2*fd*r + 19800*D1*Dd*f**2*fd*s**2 + 650*D1*Dd*f**2*fd*s - 2010*D1*Dd*f**2*fd + 8640*D1*Dd*f**2*g2*r*s - 2160*D1*Dd*f**2*g2*r - 21600*D1*Dd*f**2*g2*s**2 + 6480*D1*Dd*f**2*g2*s - 5400*D1*Dd*f**2*g2 - 8640*D1*Dd*f**2*gd2*r*s + 1080*D1*Dd*f**2*gd2*r + 21600*D1*Dd*f**2*gd2*s**2 + 1080*D1*Dd*f**2*gd2*s - 1080*D1*Dd*f**2*gd2 - 17280*D1*Dd*f*fd*g2*r*s + 6480*D1*Dd*f*fd*g2*r + 43200*D1*Dd*f*fd*g2*s**2 - 28080*D1*Dd*f*fd*g2*s + 3240*D1*Dd*f*fd*g2 + 1680*D1*Ddd*f**4*r*s - 420*D1*Ddd*f**4*r - 840*D1*Ddd*f**4*s - 4880*D1*Ddd*f**3*r*s + 1220*D1*Ddd*f**3*r + 3300*D1*Ddd*f**3*s**2 + 790*D1*Ddd*f**3*s + 825*D1*Ddd*f**3 - 4320*D1*Ddd*f**2*g2*r*s + 1080*D1*Ddd*f**2*g2*r + 10800*D1*Ddd*f**2*g2*s**2 - 3240*D1*Ddd*f**2*g2*s + 2700*D1*Ddd*f**2*g2 + 30*D1*bd1*f*(D1*(f*s*(-18*K*(2*r - 5*s - 2) + 7*f*(4*r - s - 4) + 72*r - 9*s - 72) + fd*(9*K*(8*r*s - 2*r - 20*s**2 + 6*s + 2) + 7*f*(r*(2 - 12*s) + 3*s**2 + 7*s - 2) - 144*r*s + 36*r + 18*s**2 + 63*s - 36)) + Dd*f*(-18*K*(-8*r*s + r + 20*s**2 + s - 1) + 7*f*(r*(2 - 16*s) + 4*s**2 + 11*s - 2) - 288*r*s + 36*r + 36*s**2 + 207*s - 36)) + 5040*Dd**2*f**4*r*s - 1260*Dd**2*f**4*r - 2520*Dd**2*f**4*s + 840*Dd**2*f**4 - 14640*Dd**2*f**3*r*s + 3660*Dd**2*f**3*r + 9900*Dd**2*f**3*s**2 + 2370*Dd**2*f**3*s - 2440*Dd**2*f**3 - 12960*Dd**2*f**2*g2*r*s + 3240*Dd**2*f**2*g2*r + 32400*Dd**2*f**2*g2*s**2 - 9720*Dd**2*f**2*g2*s - 2160*Dd**2*f**2*g2 + 15*b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(4 - 12*s) + 3*s**2 + 2*s + 1) + f*(14*fd**2*(r*(4 - 12*s) + 3*s**2 + 2*s - 2) - 18*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1) + 9*fdd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1)) + 18*fd**2*(r*(2*K - 4)*(2*s - 1) - s*(10*K - 1)*(s - 1))) + D1*f*(2*Dd*(-7*f**2*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) + f*(-18*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + fd*(r*(98 - 336*s) + 84*s**2 + 91*s - 35) + 288*r*s - 72*r - 36*s**2 - 126*s - 9) + 9*fd*(2*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) - 64*r*s + 24*r + 8*s**2 + 10*s - 7)) + Ddd*f*(18*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + 7*f*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) - 288*r*s + 72*r + 36*s**2 + 126*s + 9)) + 2*Dd**2*f**2*(18*K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) + 7*f*(r*(6 - 24*s) + 6*s**2 + 9*s - 4) - 432*r*s + 108*r + 54*s**2 + 189*s - 72)))/(630*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**5*k1*k2**2*(-216*C*D1**2*bdd1*f**2*r*s - 504*C*D1**2*bdd1*f**2*r - 900*C*D1**2*bdd1*f**2*s**2 + 360*C*D1**2*bdd1*f**2*s - 180*C*D1**2*bdd1*f**2 - 10320*C*D1**2*f**2*fd*r*s + 3440*C*D1**2*f**2*fd*r - 10200*C*D1**2*f**2*fd*s**2 + 10240*C*D1**2*f**2*fd*s - 3400*C*D1**2*f**2*fd + 7320*C*D1**2*f**2*fdd*r*s - 2440*C*D1**2*f**2*fdd*r + 7800*C*D1**2*f**2*fdd*s**2 - 7640*C*D1**2*f**2*fdd*s + 2600*C*D1**2*f**2*fdd + 14640*C*D1**2*f*fd**2*r*s - 4880*C*D1**2*f*fd**2*r + 15600*C*D1**2*f*fd**2*s**2 - 15280*C*D1**2*f*fd**2*s + 2440*C*D1**2*f*fd**2 - 13760*C*D1*Dd*f**3*r*s + 3440*C*D1*Dd*f**3*r - 13600*C*D1*Dd*f**3*s**2 + 13680*C*D1*Dd*f**3*s - 3400*C*D1*Dd*f**3 + 58560*C*D1*Dd*f**2*fd*r*s - 17080*C*D1*Dd*f**2*fd*r + 62400*C*D1*Dd*f**2*fd*s**2 - 60800*C*D1*Dd*f**2*fd*s + 12520*C*D1*Dd*f**2*fd + 9760*C*D1*Ddd*f**3*r*s - 2440*C*D1*Ddd*f**3*r + 10400*C*D1*Ddd*f**3*s**2 - 10080*C*D1*Ddd*f**3*s + 2600*C*D1*Ddd*f**3 + 29280*C*Dd**2*f**3*r*s - 7320*C*Dd**2*f**3*r + 31200*C*Dd**2*f**3*s**2 - 30240*C*Dd**2*f**3*s + 4880*C*Dd**2*f**3 + 1404*D1**2*K*bdd1*f**2*r*s + 1764*D1**2*K*bdd1*f**2*s**2 - 1404*D1**2*K*bdd1*f**2*s - 1656*D1**2*b2*f*fd*r*s + 828*D1**2*b2*f*fd*r - 1656*D1**2*b2*f*fd*s**2 + 1656*D1**2*b2*f*fd*s - 828*D1**2*b2*f*fd + 1080*D1**2*b2*f*fdd*r*s - 540*D1**2*b2*f*fdd*r + 1080*D1**2*b2*f*fdd*s**2 - 1080*D1**2*b2*f*fdd*s + 540*D1**2*b2*f*fdd + 1080*D1**2*b2*fd**2*r*s - 540*D1**2*b2*fd**2*r + 1080*D1**2*b2*fd**2*s**2 - 1080*D1**2*b2*fd**2*s + 18*D1**2*bd1**2*f*(-14*K*(2*r*s + r + 5*s**2 - 2*s - 1) + 5*f*(2*r + s**2 + 3*s - 2) - 28*r*(s - 1) + 7*s**2 + 35*s - 28) - 828*D1**2*bd2*f**2*r*s - 828*D1**2*bd2*f**2*s**2 + 828*D1**2*bd2*f**2*s + 2160*D1**2*bd2*f*fd*r*s - 540*D1**2*bd2*f*fd*r + 2160*D1**2*bd2*f*fd*s**2 - 2160*D1**2*bd2*f*fd*s + 540*D1**2*bd2*f*fd - 360*D1**2*bdd1*f**3*r*s - 180*D1**2*bdd1*f**3*r - 495*D1**2*bdd1*f**3*s**2 + 540*D1**2*bdd1*f**3*s - 576*D1**2*bdd1*f**2*r*s + 684*D1**2*bdd1*f**2*r - 162*D1**2*bdd1*f**2*s**2 + 522*D1**2*bdd1*f**2*s - 45*D1**2*bdd1*f**2 + 504*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r + 1260*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 + 540*D1**2*bdd2*f**2*r*s + 540*D1**2*bdd2*f**2*s**2 - 540*D1**2*bdd2*f**2*s + 5940*D1**2*f**2*fd*r*s - 1980*D1**2*f**2*fd*r + 6330*D1**2*f**2*fd*s**2 - 6200*D1**2*f**2*fd*s + 2110*D1**2*f**2*fd - 4860*D1**2*f**2*fdd*r*s + 1620*D1**2*f**2*fdd*r - 5325*D1**2*f**2*fdd*s**2 + 5170*D1**2*f**2*fdd*s - 1775*D1**2*f**2*fdd + 3600*D1**2*f**2*gd2*r*s + 4536*D1**2*f**2*gd2*s**2 - 3600*D1**2*f**2*gd2*s - 2808*D1**2*f**2*gdd2*r*s - 3528*D1**2*f**2*gdd2*s**2 + 2808*D1**2*f**2*gdd2*s - 9720*D1**2*f*fd**2*r*s + 3240*D1**2*f*fd**2*r - 10650*D1**2*f*fd**2*s**2 + 10340*D1**2*f*fd**2*s - 1620*D1**2*f*fd**2 + 7200*D1**2*f*fd*g2*r*s - 3600*D1**2*f*fd*g2*r + 9072*D1**2*f*fd*g2*s**2 - 9072*D1**2*f*fd*g2*s + 4536*D1**2*f*fd*g2 - 11232*D1**2*f*fd*gd2*r*s + 2808*D1**2*f*fd*gd2*r - 14112*D1**2*f*fd*gd2*s**2 + 12672*D1**2*f*fd*gd2*s - 2808*D1**2*f*fd*gd2 - 5616*D1**2*f*fdd*g2*r*s + 2808*D1**2*f*fdd*g2*r - 7056*D1**2*f*fdd*g2*s**2 + 7056*D1**2*f*fdd*g2*s - 3528*D1**2*f*fdd*g2 - 5616*D1**2*fd**2*g2*r*s + 2808*D1**2*fd**2*g2*r - 7056*D1**2*fd**2*g2*s**2 + 7056*D1**2*fd**2*g2*s - 3312*D1*Dd*b2*f**2*r*s + 828*D1*Dd*b2*f**2*r - 3312*D1*Dd*b2*f**2*s**2 + 3312*D1*Dd*b2*f**2*s - 828*D1*Dd*b2*f**2 + 8640*D1*Dd*b2*f*fd*r*s - 3240*D1*Dd*b2*f*fd*r + 8640*D1*Dd*b2*f*fd*s**2 - 8640*D1*Dd*b2*f*fd*s + 2160*D1*Dd*b2*f*fd + 4320*D1*Dd*bd2*f**2*r*s - 540*D1*Dd*bd2*f**2*r + 4320*D1*Dd*bd2*f**2*s**2 - 4320*D1*Dd*bd2*f**2*s + 540*D1*Dd*bd2*f**2 + 7920*D1*Dd*f**3*r*s - 1980*D1*Dd*f**3*r + 8440*D1*Dd*f**3*s**2 - 8180*D1*Dd*f**3*s + 2110*D1*Dd*f**3 - 38880*D1*Dd*f**2*fd*r*s + 11340*D1*Dd*f**2*fd*r - 42600*D1*Dd*f**2*fd*s**2 + 41050*D1*Dd*f**2*fd*s - 8410*D1*Dd*f**2*fd + 14400*D1*Dd*f**2*g2*r*s - 3600*D1*Dd*f**2*g2*r + 18144*D1*Dd*f**2*g2*s**2 - 16272*D1*Dd*f**2*g2*s + 4536*D1*Dd*f**2*g2 - 22464*D1*Dd*f**2*gd2*r*s + 2808*D1*Dd*f**2*gd2*r - 28224*D1*Dd*f**2*gd2*s**2 + 23904*D1*Dd*f**2*gd2*s - 2808*D1*Dd*f**2*gd2 - 44928*D1*Dd*f*fd*g2*r*s + 16848*D1*Dd*f*fd*g2*r - 56448*D1*Dd*f*fd*g2*s**2 + 53568*D1*Dd*f*fd*g2*s - 12672*D1*Dd*f*fd*g2 + 2160*D1*Ddd*b2*f**2*r*s - 540*D1*Ddd*b2*f**2*r + 2160*D1*Ddd*b2*f**2*s**2 - 2160*D1*Ddd*b2*f**2*s + 540*D1*Ddd*b2*f**2 - 6480*D1*Ddd*f**3*r*s + 1620*D1*Ddd*f**3*r - 7100*D1*Ddd*f**3*s**2 + 6790*D1*Ddd*f**3*s - 1775*D1*Ddd*f**3 - 11232*D1*Ddd*f**2*g2*r*s + 2808*D1*Ddd*f**2*g2*r - 14112*D1*Ddd*f**2*g2*s**2 + 12672*D1*Ddd*f**2*g2*s - 3528*D1*Ddd*f**2*g2 + 18*D1*bd1*(D1*(5*f**3*(2*r*(s + 1) + s*(5*s - 4)) + f**2*(4*C*(6*r*s + 14*r + 25*s**2 - 10*s + 5) - 100*K*r*s - 126*K*s**2 + 100*K*s - 5*fd*(24*r*s + 33*s**2 - 31*s + 2) + 22*r*s - 76*r - 24*s**2 - 16*s + 5) - f*(fd*(4*C*(4*r*(3*s + 1) + 50*s**2 - 33*s - 7) + K*(-312*r*s + 78*r - 392*s**2 + 352*s - 78) + 128*r*s - 70*r + 36*s**2 - 79*s + 62) + 28*g2*(2*r*(s + 1) + 5*s**2 - 2*s + 1) - 28*gd2*(2*r*s + r + 5*s**2 - 2*s - 1)) + 28*fd*g2*(r*(2*s - 1) + s*(5*s - 5))) - Dd*f*(5*f**2*(4*r*(8*s + 1) + 44*s**2 - 43*s + 2) + f*(4*C*(r*(24*s + 25) + 100*s**2 - 51*s - 9) + K*(-624*r*s + 78*r - 784*s**2 + 664*s - 78) + 256*r*s - 184*r + 72*s**2 - 198*s + 105) - 28*g2*(r*(8*s + 3) + 20*s**2 - 11*s - 1))) + 6480*Dd**2*b2*f**2*r*s - 1620*Dd**2*b2*f**2*r + 6480*Dd**2*b2*f**2*s**2 - 6480*Dd**2*b2*f**2*s + 1080*Dd**2*b2*f**2 - 19440*Dd**2*f**3*r*s + 4860*Dd**2*f**3*r - 21300*Dd**2*f**3*s**2 + 20370*Dd**2*f**3*s - 3240*Dd**2*f**3 - 33696*Dd**2*f**2*g2*r*s + 8424*Dd**2*f**2*g2*r - 42336*Dd**2*f**2*g2*s**2 + 38016*Dd**2*f**2*g2*s - 5616*Dd**2*f**2*g2 + 9*b1**2*(D1**2*(20*f*fd*(2*r - s**2 + 4*s - 2) - 10*f*fdd*(2*r - s**2 + 4*s - 2) - 10*fd**2*(2*r - s**2 + 4*s - 2) + 14*fd*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4) - 7*fdd*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4)) - 2*D1*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(-14*K*(r*(8*s - 2) + 20*s**2 - 14*s + 5) + 10*fd*(4*r - 4*s**2 + 9*s - 4) - 112*r*s + 28*r + 28*s**2 + 42*s + 7) + 7*fd*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8)) + D1*Ddd*f*(-14*K*(r*(8*s - 2) + 20*s**2 - 14*s + 5) + 5*f*(4*s**2 - 2*s + 1) - 112*r*s + 28*r + 28*s**2 + 42*s + 7) + 2*Dd**2*f*(-14*K*(3*r*(4*s - 1) + 30*s**2 - 21*s + 2) + 30*f*s**2 - 15*f*s - 42*r*(4*s - 1) + 42*s**2 + 63*s - 28)) - 9*b1*(-96*C*D1**2*f*fd*r*s + 160*C*D1**2*f*fd*r - 400*C*D1**2*f*fd*s**2 + 368*C*D1**2*f*fd*s - 160*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 200*C*D1**2*f*fdd*s**2 - 184*C*D1**2*f*fdd*s + 80*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 200*C*D1**2*fd**2*s**2 - 184*C*D1**2*fd**2*s + 80*C*D1**2*fd**2 - 192*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 800*C*D1*Dd*f**2*s**2 + 496*C*D1*Dd*f**2*s - 200*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r*s - 368*C*D1*Dd*f*fd*r + 1600*C*D1*Dd*f*fd*s**2 - 1232*C*D1*Dd*f*fd*s + 344*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 400*C*D1*Ddd*f**2*s**2 - 248*C*D1*Ddd*f**2*s + 100*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 1200*C*Dd**2*f**2*s**2 - 744*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 + 400*D1**2*K*f*fd*r*s - 200*D1**2*K*f*fd*r + 504*D1**2*K*f*fd*s**2 - 504*D1**2*K*f*fd*s + 252*D1**2*K*f*fd - 312*D1**2*K*f*fdd*r*s + 156*D1**2*K*f*fdd*r - 392*D1**2*K*f*fdd*s**2 + 392*D1**2*K*f*fdd*s - 196*D1**2*K*f*fdd - 312*D1**2*K*fd**2*r*s + 156*D1**2*K*fd**2*r - 392*D1**2*K*fd**2*s**2 + 392*D1**2*K*fd**2*s + D1**2*bdd1*f*(7*K*(r*(8*s + 4) + 20*s**2 - 8*s + 2) - 5*f*(4*r + 2*s**2 + 6*s - 3) + 56*r*(s - 1) - 14*s**2 - 70*s + 21) - 60*D1**2*f**2*fd*r*s + 40*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 120*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 130*D1**2*f**2*fdd*s + 55*D1**2*f**2*fdd + 240*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 260*D1**2*f*fd**2*s + 60*D1**2*f*fd**2 - 88*D1**2*f*fd*r*s - 108*D1**2*f*fd*r + 96*D1**2*f*fd*s**2 - 84*D1**2*f*fd*s + 58*D1**2*f*fd + 128*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 13*D1**2*f*fdd + 112*D1**2*f*gd2*r*s + 280*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s - 56*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s + 128*D1**2*fd**2*r*s + 12*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s - 60*D1**2*fd**2 + 112*D1**2*fd*g2*r*s - 224*D1**2*fd*g2*r + 280*D1**2*fd*g2*s**2 - 448*D1**2*fd*g2*s + 224*D1**2*fd*g2 - 112*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 280*D1**2*fd*gd2*s**2 + 280*D1**2*fd*gd2*s - 112*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r*s + 112*D1**2*fdd*g2*r - 140*D1**2*fdd*g2*s**2 + 224*D1**2*fdd*g2*s - 112*D1**2*fdd*g2 + 800*D1*Dd*K*f**2*r*s - 200*D1*Dd*K*f**2*r + 1008*D1*Dd*K*f**2*s**2 - 904*D1*Dd*K*f**2*s + 252*D1*Dd*K*f**2 - 2496*D1*Dd*K*f*fd*r*s + 936*D1*Dd*K*f*fd*r - 3136*D1*Dd*K*f*fd*s**2 + 2976*D1*Dd*K*f*fd*s - 704*D1*Dd*K*f*fd - 80*D1*Dd*f**3*r*s + 20*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 140*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 960*D1*Dd*f**2*fd*r*s - 360*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1090*D1*Dd*f**2*fd*s + 250*D1*Dd*f**2*fd - 176*D1*Dd*f**2*r*s + 44*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 48*D1*Dd*f**2 + 1024*D1*Dd*f*fd*r*s - 80*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s**2 - 496*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 448*D1*Dd*f*g2*r*s - 112*D1*Dd*f*g2*r + 1120*D1*Dd*f*g2*s**2 - 784*D1*Dd*f*g2*s + 280*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r*s + 56*D1*Dd*f*gd2*r - 1120*D1*Dd*f*gd2*s**2 + 616*D1*Dd*f*gd2*s - 56*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 1120*D1*Dd*fd*g2*s**2 + 1288*D1*Dd*fd*g2*s - 448*D1*Dd*fd*g2 - 624*D1*Ddd*K*f**2*r*s + 156*D1*Ddd*K*f**2*r - 784*D1*Ddd*K*f**2*s**2 + 704*D1*Ddd*K*f**2*s - 196*D1*Ddd*K*f**2 + 160*D1*Ddd*f**3*r*s - 40*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 190*D1*Ddd*f**3*s + 55*D1*Ddd*f**3 + 256*D1*Ddd*f**2*r*s - 64*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 164*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r*s + 56*D1*Ddd*f*g2*r - 560*D1*Ddd*f*g2*s**2 + 392*D1*Ddd*f*g2*s - 140*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*f**2*(4*r + 2*s**2 + 6*s - 3) - f*(14*K*(r*(4*s + 2) + 10*s**2 - 4*s + 1) + 20*fd*s**2 - 10*fd*s + 56*r*(s - 1) - 14*s**2 - 70*s + 21) + 7*fd*(K*(8*r*s - 6*r + 20*s**2 - 20*s + 4) - 2*s**2 + s*(8*r + 3) - 2)) + Dd*f*(-5*f*(8*r + 8*s**2 + 10*s - 7) + 28*r*(8*K*s + K + 8*s - 5) + 7*s**2*(80*K - 8) - 7*s*(44*K + 26) + 91)) - 1872*Dd**2*K*f**2*r*s + 468*Dd**2*K*f**2*r - 2352*Dd**2*K*f**2*s**2 + 2112*Dd**2*K*f**2*s - 312*Dd**2*K*f**2 + 480*Dd**2*f**3*r*s - 120*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 570*Dd**2*f**3*s + 80*Dd**2*f**3 + 768*Dd**2*f**2*r*s - 192*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 492*Dd**2*f**2*s + 128*Dd**2*f**2 - 672*Dd**2*f*g2*r*s + 168*Dd**2*f*g2*r - 1680*Dd**2*f*g2*s**2 + 1176*Dd**2*f*g2*s - 112*Dd**2*f*g2))/(630*d**2*k3**4) + 3*D1**2*Pk3*Pkd2*ct**5*k1*st**2*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 18*fd*(2*s**2 - 2*s + 1) - 9*fdd*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) + f*(fd*(-s**2*(42*bd1 - 30) + s*(14*bd1 - 20) + 10) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(18*bd1 - 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(-2*Dd*(f*(s**2*(28*bd1 - 20) + s*(10 - 7*bd1) - 5) + (4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1))) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**5*k1*(504*C*D1**2*bdd1*f**2*r*s - 900*C*D1**2*bdd1*f**2*s**2 - 4200*C*D1**2*f**2*fd*s**2 + 2800*C*D1**2*f**2*fd*s - 1400*C*D1**2*f**2*fd + 2100*C*D1**2*f**2*fdd*s**2 - 1400*C*D1**2*f**2*fdd*s + 700*C*D1**2*f**2*fdd + 4200*C*D1**2*f*fd**2*s**2 - 2800*C*D1**2*f*fd**2*s - 5600*C*D1*Dd*f**3*s**2 + 2800*C*D1*Dd*f**3*s - 1400*C*D1*Dd*f**3 + 16800*C*D1*Dd*f**2*fd*s**2 - 9800*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 2800*C*D1*Ddd*f**3*s**2 - 1400*C*D1*Ddd*f**3*s + 700*C*D1*Ddd*f**3 + 8400*C*Dd**2*f**3*s**2 - 4200*C*Dd**2*f**3*s + 450*D1**2*K*bdd1*f**2*s**2 - 1800*D1**2*b2*f*fd*s**2 + 1800*D1**2*b2*f*fd*s - 900*D1**2*b2*f*fd + 900*D1**2*b2*f*fdd*s**2 - 900*D1**2*b2*f*fdd*s + 450*D1**2*b2*f*fdd + 900*D1**2*b2*fd**2*s**2 - 900*D1**2*b2*fd**2*s + 18*D1**2*bd1**2*f*s*(14*K*(2*r - 5*s - 1) + 25*f - 28*r + 49) - 900*D1**2*bd2*f**2*s**2 + 1800*D1**2*bd2*f*fd*s**2 - 900*D1**2*bd2*f*fd*s + 540*D1**2*bdd1*f**3*r*s + 495*D1**2*bdd1*f**3*s**2 - 360*D1**2*bdd1*f**3*s - 72*D1**2*bdd1*f**2*r*s + 1107*D1**2*bdd1*f**2*s**2 + 18*D1**2*bdd1*f**2*s - 225*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r*s + 1260*D1**2*bdd1*f*g2*s**2 + 450*D1**2*bdd2*f**2*s**2 - 1860*D1**2*f**2*fd*r*s + 620*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 760*D1**2*f**2*fd*s - 70*D1**2*f**2*fd + 1200*D1**2*f**2*fdd*r*s - 400*D1**2*f**2*fdd*r + 375*D1**2*f**2*fdd*s**2 - 650*D1**2*f**2*fdd*s + 125*D1**2*f**2*fdd + 1800*D1**2*f**2*gd2*s**2 - 900*D1**2*f**2*gdd2*s**2 + 2400*D1**2*f*fd**2*r*s - 800*D1**2*f*fd**2*r + 750*D1**2*f*fd**2*s**2 - 1300*D1**2*f*fd**2*s + 400*D1**2*f*fd**2 + 3600*D1**2*f*fd*g2*s**2 - 3600*D1**2*f*fd*g2*s + 1800*D1**2*f*fd*g2 - 3600*D1**2*f*fd*gd2*s**2 + 1800*D1**2*f*fd*gd2*s - 1800*D1**2*f*fdd*g2*s**2 + 1800*D1**2*f*fdd*g2*s - 900*D1**2*f*fdd*g2 - 1800*D1**2*fd**2*g2*s**2 + 1800*D1**2*fd**2*g2*s - 3600*D1*Dd*b2*f**2*s**2 + 1800*D1*Dd*b2*f**2*s - 900*D1*Dd*b2*f**2 + 7200*D1*Dd*b2*f*fd*s**2 - 5400*D1*Dd*b2*f*fd*s + 900*D1*Dd*b2*f*fd + 3600*D1*Dd*bd2*f**2*s**2 - 900*D1*Dd*bd2*f**2*s - 2480*D1*Dd*f**3*r*s + 620*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 1380*D1*Dd*f**3*s - 70*D1*Dd*f**3 + 9600*D1*Dd*f**2*fd*r*s - 2800*D1*Dd*f**2*fd*r + 3000*D1*Dd*f**2*fd*s**2 - 5750*D1*Dd*f**2*fd*s + 1450*D1*Dd*f**2*fd + 7200*D1*Dd*f**2*g2*s**2 - 3600*D1*Dd*f**2*g2*s + 1800*D1*Dd*f**2*g2 - 7200*D1*Dd*f**2*gd2*s**2 + 1800*D1*Dd*f**2*gd2*s - 14400*D1*Dd*f*fd*g2*s**2 + 10800*D1*Dd*f*fd*g2*s - 1800*D1*Dd*f*fd*g2 + 1800*D1*Ddd*b2*f**2*s**2 - 900*D1*Ddd*b2*f**2*s + 450*D1*Ddd*b2*f**2 + 1600*D1*Ddd*f**3*r*s - 400*D1*Ddd*f**3*r + 500*D1*Ddd*f**3*s**2 - 1050*D1*Ddd*f**3*s + 125*D1*Ddd*f**3 - 3600*D1*Ddd*f**2*g2*s**2 + 1800*D1*Ddd*f**2*g2*s - 900*D1*Ddd*f**2*g2 - 18*D1*bd1*(D1*(5*f**3*s*(6*r + 9*s - 4) + f**2*(-5*fd*(6*r*(6*s - 1) + 33*s**2 - 31*s + 4) + s**2*(-100*C + 50*K + 109) + s*(56*C*r - 22*r + 16) - 25) - 2*f*(fd*(r*(14*C - 2)*(4*s - 1) + s**2*(-100*C + 50*K + 123) + s*(36*C - 25*K - 59) + 12) + 14*s*(2*g2*r - 5*g2*s - 2*gd2*r + 5*gd2*s + gd2)) - 28*fd*g2*(-2*r*s + r + s*(5*s - 5))) + Dd*f*(-5*f**2*(6*r*(8*s - 1) + 44*s**2 - 39*s + 4) + f*(-r*(28*C - 4)*(8*s - 1) + s**2*(400*C - 200*K - 492) + s*(-44*C + 50*K + 111) + 1) - 28*g2*(-8*r*s + r + s*(20*s - 3)))) + 5400*Dd**2*b2*f**2*s**2 - 2700*Dd**2*b2*f**2*s + 4800*Dd**2*f**3*r*s - 1200*Dd**2*f**3*r + 1500*Dd**2*f**3*s**2 - 3150*Dd**2*f**3*s + 800*Dd**2*f**3 - 10800*Dd**2*f**2*g2*s**2 + 5400*Dd**2*f**2*g2*s + 9*b1**2*(-2*D1*Dd*(14*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s) + fd*(-14*K*(8*r*s - 5*r - 20*s**2 + 23*s - 3) + 25*f*(4*s - 1) + 112*r*s - 70*r + 112*s - 7)) + D1*(D1*(50*f*fd*(2*s - 1) + f*fdd*(25 - 50*s) - 50*fd**2*s - 14*fd*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + 7*fdd*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5)) + 14*Ddd*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s)) + 28*Dd**2*f*(K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) - 12*r*s + 3*r + 6*s - 2)) - 9*b1*(224*C*D1**2*f*fd*r*s - 112*C*D1**2*f*fd*r - 400*C*D1**2*f*fd*s**2 + 288*C*D1**2*f*fd*s - 200*C*D1**2*f*fd - 112*C*D1**2*f*fdd*r*s + 56*C*D1**2*f*fdd*r + 200*C*D1**2*f*fdd*s**2 - 144*C*D1**2*f*fdd*s + 100*C*D1**2*f*fdd - 112*C*D1**2*fd**2*r*s + 56*C*D1**2*fd**2*r + 200*C*D1**2*fd**2*s**2 - 144*C*D1**2*fd**2*s - 56*C*D1**2*fd**2 + 448*C*D1*Dd*f**2*r*s - 112*C*D1*Dd*f**2*r - 800*C*D1*Dd*f**2*s**2 + 176*C*D1*Dd*f**2*s - 200*C*D1*Dd*f**2 - 896*C*D1*Dd*f*fd*r*s + 336*C*D1*Dd*f*fd*r + 1600*C*D1*Dd*f*fd*s**2 - 752*C*D1*Dd*f*fd*s + 32*C*D1*Dd*f*fd - 224*C*D1*Ddd*f**2*r*s + 56*C*D1*Ddd*f**2*r + 400*C*D1*Ddd*f**2*s**2 - 88*C*D1*Ddd*f**2*s + 100*C*D1*Ddd*f**2 - 672*C*Dd**2*f**2*r*s + 168*C*Dd**2*f**2*r + 1200*C*Dd**2*f**2*s**2 - 264*C*Dd**2*f**2*s - 112*C*Dd**2*f**2 + 200*D1**2*K*f*fd*s**2 - 200*D1**2*K*f*fd*s + 100*D1**2*K*f*fd - 100*D1**2*K*f*fdd*s**2 + 100*D1**2*K*f*fdd*s - 50*D1**2*K*f*fdd - 100*D1**2*K*fd**2*s**2 + 100*D1**2*K*fd**2*s + D1**2*bdd1*f*(140*K*s**2 + f*(25 - 50*s) + 7*s*(-8*K*r + 4*K + 8*r - 14) + 35) + 180*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 270*D1**2*f**2*fd*s**2 - 260*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 165*D1**2*f**2*fdd*s**2 + 190*D1**2*f**2*fdd*s - 55*D1**2*f**2*fdd - 360*D1**2*f*fd**2*r*s + 120*D1**2*f*fd**2*r - 330*D1**2*f*fd**2*s**2 + 380*D1**2*f*fd**2*s - 80*D1**2*f*fd**2 - 88*D1**2*f*fd*r*s + 44*D1**2*f*fd*r + 436*D1**2*f*fd*s**2 - 424*D1**2*f*fd*s + 268*D1**2*f*fd + 16*D1**2*f*fdd*r*s - 8*D1**2*f*fdd*r - 246*D1**2*f*fdd*s**2 + 240*D1**2*f*fdd*s - 148*D1**2*f*fdd - 112*D1**2*f*gd2*r*s + 280*D1**2*f*gd2*s**2 + 112*D1**2*f*gd2*s + 56*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*s**2 - 56*D1**2*f*gdd2*s + 16*D1**2*fd**2*r*s - 8*D1**2*fd**2*r - 246*D1**2*fd**2*s**2 + 240*D1**2*fd**2*s + 56*D1**2*fd**2 - 112*D1**2*fd*g2*r*s + 112*D1**2*fd*g2*r + 280*D1**2*fd*g2*s**2 - 560*D1**2*fd*g2*s + 280*D1**2*fd*g2 + 112*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*r - 280*D1**2*fd*gd2*s**2 + 224*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 + 56*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r - 140*D1**2*fdd*g2*s**2 + 280*D1**2*fdd*g2*s - 140*D1**2*fdd*g2 + 400*D1*Dd*K*f**2*s**2 - 200*D1*Dd*K*f**2*s + 100*D1*Dd*K*f**2 - 800*D1*Dd*K*f*fd*s**2 + 600*D1*Dd*K*f*fd*s - 100*D1*Dd*K*f*fd + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 360*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r*s + 420*D1*Dd*f**2*fd*r - 1320*D1*Dd*f**2*fd*s**2 + 1450*D1*Dd*f**2*fd*s - 310*D1*Dd*f**2*fd - 176*D1*Dd*f**2*r*s + 44*D1*Dd*f**2*r + 872*D1*Dd*f**2*s**2 - 348*D1*Dd*f**2*s + 218*D1*Dd*f**2 + 128*D1*Dd*f*fd*r*s - 48*D1*Dd*f*fd*r - 1968*D1*Dd*f*fd*s**2 + 1420*D1*Dd*f*fd*s - 224*D1*Dd*f*fd - 448*D1*Dd*f*g2*r*s + 112*D1*Dd*f*g2*r + 1120*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 280*D1*Dd*f*g2 + 448*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r - 1120*D1*Dd*f*gd2*s**2 - 56*D1*Dd*f*gd2*s + 56*D1*Dd*f*gd2 + 448*D1*Dd*fd*g2*r*s - 280*D1*Dd*fd*g2*r - 1120*D1*Dd*fd*g2*s**2 + 1288*D1*Dd*fd*g2*s - 168*D1*Dd*fd*g2 - 200*D1*Ddd*K*f**2*s**2 + 100*D1*Ddd*K*f**2*s - 50*D1*Ddd*K*f**2 - 240*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 220*D1*Ddd*f**3*s**2 + 230*D1*Ddd*f**3*s - 55*D1*Ddd*f**3 + 32*D1*Ddd*f**2*r*s - 8*D1*Ddd*f**2*r - 492*D1*Ddd*f**2*s**2 + 230*D1*Ddd*f**2*s - 123*D1*Ddd*f**2 + 224*D1*Ddd*f*g2*r*s - 56*D1*Ddd*f*g2*r - 560*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 140*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(25*f**2*(2*s - 1) - 7*f*(20*K*s**2 + s*(-8*K*r + 4*K + 8*r - 14) + 5) - 7*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) - 8*r*s + 4*r - 3*s - 2)) + Dd*f*(-7*K*(32*r*s - 4*r - 80*s**2 + 4*s + 2) - 25*f*(4*s - 1) + 224*r*s - 28*r - 252*s + 49)) - 600*Dd**2*K*f**2*s**2 + 300*Dd**2*K*f**2*s - 720*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 660*Dd**2*f**3*s**2 + 690*Dd**2*f**3*s - 120*Dd**2*f**3 + 96*Dd**2*f**2*r*s - 24*Dd**2*f**2*r - 1476*Dd**2*f**2*s**2 + 690*Dd**2*f**2*s + 16*Dd**2*f**2 + 672*Dd**2*f*g2*r*s - 168*Dd**2*f*g2*r - 1680*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s + 112*Dd**2*f*g2))/(630*d**2*k3**2) + 9*D1**2*Pk3*Pkd2*ct**5*k1*(-D1*f*s*(2*D1*bd1**2*s*(5*f + 7) + 5*D1*bdd1*f*s + 10*bd1*(-D1*(f*s - 2*fd*s + fd) + Dd*f*(4*s - 1))) + b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) + f*(-10*fd*(s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(28*bd1 - 14*bdd1)) - 2*fd*s*(14*bd1 + 5*fd)*(s - 1)) + D1*f*(-2*Dd*(5*f*(s**2*(8*bd1 - 4) - s*(2*bd1 - 2) - 1) + (4*s - 1)*(14*bd1*s + 5*fd*(2*s - 1))) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(70*d**2*k2**2) + 4*D1**2*Pk3*Pkd2*ct**4*f**2*k1**6*(D1**2*(f*(7*fd - 9*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 9*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(7*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(4*s - 1)*(4*r + 4*s - 3)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(99*d**2*k2*k3**6) + 8*D1**2*Pk3*Pkd2*ct**4*k1**4*k2*st**2*(1386*C*D1**2*f**2*fd*r*s - 462*C*D1**2*f**2*fd*r + 1386*C*D1**2*f**2*fd*s**2 - 1386*C*D1**2*f**2*fd*s + 462*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 1848*C*D1*Dd*f**3*r*s - 462*C*D1*Dd*f**3*r + 1848*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 462*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 3100*D1**2*f**3*fd*r*s - 775*D1**2*f**3*fd*r + 3100*D1**2*f**3*fd*s**2 - 3100*D1**2*f**3*fd*s + 775*D1**2*f**3*fd - 2100*D1**2*f**3*fdd*r*s + 525*D1**2*f**3*fdd*r - 2100*D1**2*f**3*fdd*s**2 + 2100*D1**2*f**3*fdd*s - 525*D1**2*f**3*fdd - 6300*D1**2*f**2*fd**2*r*s + 1575*D1**2*f**2*fd**2*r - 6300*D1**2*f**2*fd**2*s**2 + 6300*D1**2*f**2*fd**2*s - 1050*D1**2*f**2*fd**2 - 1386*D1**2*f**2*fd*r*s + 462*D1**2*f**2*fd*r - 1386*D1**2*f**2*fd*s**2 + 1386*D1**2*f**2*fd*s - 462*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*s**2 + 726*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 1452*D1**2*f*fd*g2*r*s + 726*D1**2*f*fd*g2*r - 1452*D1**2*f*fd*g2*s**2 + 1452*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 3100*D1*Dd*f**4*r*s - 775*D1*Dd*f**4*r + 3100*D1*Dd*f**4*s**2 - 3100*D1*Dd*f**4*s + 775*D1*Dd*f**4 - 16800*D1*Dd*f**3*fd*r*s + 4200*D1*Dd*f**3*fd*r - 16800*D1*Dd*f**3*fd*s**2 + 16800*D1*Dd*f**3*fd*s - 3150*D1*Dd*f**3*fd - 1848*D1*Dd*f**3*r*s + 462*D1*Dd*f**3*r - 1848*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 462*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 2904*D1*Dd*f**2*g2*r*s + 726*D1*Dd*f**2*g2*r - 2904*D1*Dd*f**2*g2*s**2 + 2904*D1*Dd*f**2*g2*s - 726*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 2100*D1*Ddd*f**4*r*s + 525*D1*Ddd*f**4*r - 2100*D1*Ddd*f**4*s**2 + 2100*D1*Ddd*f**4*s - 525*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 6300*Dd**2*f**4*r*s + 1575*Dd**2*f**4*r - 6300*Dd**2*f**4*s**2 + 6300*Dd**2*f**4*s - 1050*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**4*k1**4*k2*(-270*C*D1**2*bdd1*f**2*r*s + 270*C*D1**2*bdd1*f**2*r - 270*C*D1**2*bdd1*f**2*s**2 + 540*C*D1**2*bdd1*f**2*s - 270*C*D1**2*bdd1*f**2 + 30*C*D1**2*f**2*fd*r*s - 10*C*D1**2*f**2*fd*r + 30*C*D1**2*f**2*fd*s**2 - 30*C*D1**2*f**2*fd*s + 10*C*D1**2*f**2*fd - 420*C*D1**2*f**2*fdd*r*s + 140*C*D1**2*f**2*fdd*r - 420*C*D1**2*f**2*fdd*s**2 + 420*C*D1**2*f**2*fdd*s - 140*C*D1**2*f**2*fdd - 840*C*D1**2*f*fd**2*r*s + 280*C*D1**2*f*fd**2*r - 840*C*D1**2*f*fd**2*s**2 + 840*C*D1**2*f*fd**2*s - 140*C*D1**2*f*fd**2 + 40*C*D1*Dd*f**3*r*s - 10*C*D1*Dd*f**3*r + 40*C*D1*Dd*f**3*s**2 - 40*C*D1*Dd*f**3*s + 10*C*D1*Dd*f**3 - 3360*C*D1*Dd*f**2*fd*r*s + 980*C*D1*Dd*f**2*fd*r - 3360*C*D1*Dd*f**2*fd*s**2 + 3360*C*D1*Dd*f**2*fd*s - 700*C*D1*Dd*f**2*fd - 560*C*D1*Ddd*f**3*r*s + 140*C*D1*Ddd*f**3*r - 560*C*D1*Ddd*f**3*s**2 + 560*C*D1*Ddd*f**3*s - 140*C*D1*Ddd*f**3 - 1680*C*Dd**2*f**3*r*s + 420*C*Dd**2*f**3*r - 1680*C*Dd**2*f**3*s**2 + 1680*C*Dd**2*f**3*s - 280*C*Dd**2*f**3 - 90*D1**2*K*bdd1*f**2*r*s - 90*D1**2*K*bdd1*f**2*s**2 + 90*D1**2*K*bdd1*f**2*s - 189*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) - 70*D1**2*bdd1*f**3*r*s + 210*D1**2*bdd1*f**3*r - 70*D1**2*bdd1*f**3*s**2 + 280*D1**2*bdd1*f**3*s - 210*D1**2*bdd1*f**3 + 315*D1**2*bdd1*f**2*r*s - 270*D1**2*bdd1*f**2*r + 315*D1**2*bdd1*f**2*s**2 - 585*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 + 378*D1**2*bdd1*f*g2*r*s - 378*D1**2*bdd1*f*g2*r + 378*D1**2*bdd1*f*g2*s**2 - 756*D1**2*bdd1*f*g2*s + 378*D1**2*bdd1*f*g2 - 420*D1**2*f**3*fd*r*s + 105*D1**2*f**3*fd*r - 420*D1**2*f**3*fd*s**2 + 420*D1**2*f**3*fd*s - 105*D1**2*f**3*fd + 45*D1**2*f**2*fd*r*s - 15*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s**2 - 45*D1**2*f**2*fd*s + 15*D1**2*f**2*fd + 315*D1**2*f**2*fdd*r*s - 105*D1**2*f**2*fdd*r + 315*D1**2*f**2*fdd*s**2 - 315*D1**2*f**2*fdd*s + 105*D1**2*f**2*fdd + 18*D1**2*f**2*gd2*r*s + 18*D1**2*f**2*gd2*s**2 - 18*D1**2*f**2*gd2*s + 180*D1**2*f**2*gdd2*r*s + 180*D1**2*f**2*gdd2*s**2 - 180*D1**2*f**2*gdd2*s + 630*D1**2*f*fd**2*r*s - 210*D1**2*f*fd**2*r + 630*D1**2*f*fd**2*s**2 - 630*D1**2*f*fd**2*s + 105*D1**2*f*fd**2 + 36*D1**2*f*fd*g2*r*s - 18*D1**2*f*fd*g2*r + 36*D1**2*f*fd*g2*s**2 - 36*D1**2*f*fd*g2*s + 18*D1**2*f*fd*g2 + 720*D1**2*f*fd*gd2*r*s - 180*D1**2*f*fd*gd2*r + 720*D1**2*f*fd*gd2*s**2 - 720*D1**2*f*fd*gd2*s + 180*D1**2*f*fd*gd2 + 360*D1**2*f*fdd*g2*r*s - 180*D1**2*f*fdd*g2*r + 360*D1**2*f*fdd*g2*s**2 - 360*D1**2*f*fdd*g2*s + 180*D1**2*f*fdd*g2 + 360*D1**2*fd**2*g2*r*s - 180*D1**2*fd**2*g2*r + 360*D1**2*fd**2*g2*s**2 - 360*D1**2*fd**2*g2*s - 420*D1*Dd*f**4*r*s + 105*D1*Dd*f**4*r - 420*D1*Dd*f**4*s**2 + 420*D1*Dd*f**4*s - 105*D1*Dd*f**4 + 60*D1*Dd*f**3*r*s - 15*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 2520*D1*Dd*f**2*fd*r*s - 735*D1*Dd*f**2*fd*r + 2520*D1*Dd*f**2*fd*s**2 - 2520*D1*Dd*f**2*fd*s + 525*D1*Dd*f**2*fd + 72*D1*Dd*f**2*g2*r*s - 18*D1*Dd*f**2*g2*r + 72*D1*Dd*f**2*g2*s**2 - 72*D1*Dd*f**2*g2*s + 18*D1*Dd*f**2*g2 + 1440*D1*Dd*f**2*gd2*r*s - 180*D1*Dd*f**2*gd2*r + 1440*D1*Dd*f**2*gd2*s**2 - 1440*D1*Dd*f**2*gd2*s + 180*D1*Dd*f**2*gd2 + 2880*D1*Dd*f*fd*g2*r*s - 1080*D1*Dd*f*fd*g2*r + 2880*D1*Dd*f*fd*g2*s**2 - 2880*D1*Dd*f*fd*g2*s + 720*D1*Dd*f*fd*g2 + 420*D1*Ddd*f**3*r*s - 105*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s**2 - 420*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 + 720*D1*Ddd*f**2*g2*r*s - 180*D1*Ddd*f**2*g2*r + 720*D1*Ddd*f**2*g2*s**2 - 720*D1*Ddd*f**2*g2*s + 180*D1*Ddd*f**2*g2 + D1*bd1*(D1*(5*f**3*(28*s - 57)*(r + s - 1) + f**2*(288*C*(s - 1)*(r + s - 1) - 70*fd*(r*(6*s - 7) + 6*s**2 - 12*s + 4) - (s*(K + 28) - 32)*(9*r + 9*s - 9)) - 3*f*(15*fd*(6*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 28*r*s + 13*r - 28*s**2 + 34*s - 7) + (112*g2*(s - 1) + 126*gd2*(1 - 2*s))*(r + s - 1)) + 378*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-70*f**2*(r*(8*s - 13) + 8*s**2 - 20*s + 10) - 45*f*(6*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 56*r*s + 31*r - 56*s**2 + 80*s - 25) + 378*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 1260*Dd**2*f**3*r*s - 315*Dd**2*f**3*r + 1260*Dd**2*f**3*s**2 - 1260*Dd**2*f**3*s + 210*Dd**2*f**3 + 2160*Dd**2*f**2*g2*r*s - 540*Dd**2*f**2*g2*r + 2160*Dd**2*f**2*g2*s**2 - 2160*Dd**2*f**2*g2*s + 360*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*s*(8*fd - 9*fdd)*(r + s) + D1*Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(-8*r*s + r + s*(4 - 8*s))) - 9*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(576*C*D1**2*f*fd*r*s + 576*C*D1**2*f*fd*s**2 - 288*C*D1**2*f*fd*s - 540*C*D1**2*f*fdd*r*s - 540*C*D1**2*f*fdd*s**2 + 270*C*D1**2*f*fdd*s - 540*C*D1**2*fd**2*r*s - 540*C*D1**2*fd**2*s**2 + 270*C*D1**2*fd**2*s + 1152*C*D1*Dd*f**2*r*s - 288*C*D1*Dd*f**2*r + 1152*C*D1*Dd*f**2*s**2 - 1152*C*D1*Dd*f**2*s + 288*C*D1*Dd*f**2 - 4320*C*D1*Dd*f*fd*r*s + 540*C*D1*Dd*f*fd*r - 4320*C*D1*Dd*f*fd*s**2 + 3240*C*D1*Dd*f*fd*s - 270*C*D1*Dd*f*fd - 1080*C*D1*Ddd*f**2*r*s + 270*C*D1*Ddd*f**2*r - 1080*C*D1*Ddd*f**2*s**2 + 1080*C*D1*Ddd*f**2*s - 270*C*D1*Ddd*f**2 - 3240*C*Dd**2*f**2*r*s + 810*C*Dd**2*f**2*r - 3240*C*Dd**2*f**2*s**2 + 3240*C*Dd**2*f**2*s - 540*C*Dd**2*f**2 - 18*D1**2*K*f*fd*r*s + 9*D1**2*K*f*fd*r - 18*D1**2*K*f*fd*s**2 + 18*D1**2*K*f*fd*s - 9*D1**2*K*f*fd - 180*D1**2*K*f*fdd*r*s + 90*D1**2*K*f*fdd*r - 180*D1**2*K*f*fdd*s**2 + 180*D1**2*K*f*fdd*s - 90*D1**2*K*f*fdd - 180*D1**2*K*fd**2*r*s + 90*D1**2*K*fd**2*r - 180*D1**2*K*fd**2*s**2 + 180*D1**2*K*fd**2*s - 189*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 420*D1**2*f**2*fd*r*s + 145*D1**2*f**2*fd*r + 420*D1**2*f**2*fd*s**2 - 135*D1**2*f**2*fd*s - 145*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r - 210*D1**2*f**2*fdd*s**2 + 140*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r - 420*D1**2*f*fd**2*s**2 + 140*D1**2*f*fd**2 - 504*D1**2*f*fd*r*s - 36*D1**2*f*fd*r - 504*D1**2*f*fd*s**2 + 216*D1**2*f*fd*s + 36*D1**2*f*fd + 630*D1**2*f*fdd*r*s - 45*D1**2*f*fdd*r + 630*D1**2*f*fdd*s**2 - 360*D1**2*f*fdd*s + 45*D1**2*f*fdd - 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*s**2 + 336*D1**2*f*gd2*s + 378*D1**2*f*gdd2*r*s + 378*D1**2*f*gdd2*s**2 - 378*D1**2*f*gdd2*s + 630*D1**2*fd**2*r*s - 45*D1**2*fd**2*r + 630*D1**2*fd**2*s**2 - 360*D1**2*fd**2*s - 336*D1**2*fd*g2*r*s - 336*D1**2*fd*g2*s**2 + 756*D1**2*fd*gd2*r*s + 756*D1**2*fd*gd2*s**2 - 378*D1**2*fd*gd2*s + 378*D1**2*fdd*g2*r*s + 378*D1**2*fdd*g2*s**2 - 36*D1*Dd*K*f**2*r*s + 9*D1*Dd*K*f**2*r - 36*D1*Dd*K*f**2*s**2 + 36*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 - 1440*D1*Dd*K*f*fd*r*s + 540*D1*Dd*K*f*fd*r - 1440*D1*Dd*K*f*fd*s**2 + 1440*D1*Dd*K*f*fd*s - 360*D1*Dd*K*f*fd + 560*D1*Dd*f**3*r*s - 140*D1*Dd*f**3*r + 560*D1*Dd*f**3*s**2 - 560*D1*Dd*f**3*s + 140*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r*s - 350*D1*Dd*f**2*fd*r - 1680*D1*Dd*f**2*fd*s**2 + 840*D1*Dd*f**2*fd*s + 280*D1*Dd*f**2*fd - 1008*D1*Dd*f**2*r*s + 252*D1*Dd*f**2*r - 1008*D1*Dd*f**2*s**2 + 1008*D1*Dd*f**2*s - 252*D1*Dd*f**2 + 5040*D1*Dd*f*fd*r*s - 810*D1*Dd*f*fd*r + 5040*D1*Dd*f*fd*s**2 - 3960*D1*Dd*f*fd*s + 450*D1*Dd*f*fd - 1344*D1*Dd*f*g2*r*s + 336*D1*Dd*f*g2*r - 1344*D1*Dd*f*g2*s**2 + 1344*D1*Dd*f*g2*s - 336*D1*Dd*f*g2 + 3024*D1*Dd*f*gd2*r*s - 378*D1*Dd*f*gd2*r + 3024*D1*Dd*f*gd2*s**2 - 3024*D1*Dd*f*gd2*s + 378*D1*Dd*f*gd2 + 3024*D1*Dd*fd*g2*r*s - 378*D1*Dd*fd*g2*r + 3024*D1*Dd*fd*g2*s**2 - 1512*D1*Dd*fd*g2*s - 360*D1*Ddd*K*f**2*r*s + 90*D1*Ddd*K*f**2*r - 360*D1*Ddd*K*f**2*s**2 + 360*D1*Ddd*K*f**2*s - 90*D1*Ddd*K*f**2 - 280*D1*Ddd*f**3*r*s + 70*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s**2 + 280*D1*Ddd*f**3*s - 70*D1*Ddd*f**3 + 1260*D1*Ddd*f**2*r*s - 315*D1*Ddd*f**2*r + 1260*D1*Ddd*f**2*s**2 - 1260*D1*Ddd*f**2*s + 315*D1*Ddd*f**2 + 1512*D1*Ddd*f*g2*r*s - 378*D1*Ddd*f*g2*r + 1512*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 378*D1*Ddd*f*g2 + 21*D1*bd1*(K - 1)*(D1*(8*f*(2*s - 1)*(r + s - 1) + 9*fd*(-4*r*s + r + s*(3 - 4*s))) - 9*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 1080*Dd**2*K*f**2*r*s + 270*Dd**2*K*f**2*r - 1080*Dd**2*K*f**2*s**2 + 1080*Dd**2*K*f**2*s - 180*Dd**2*K*f**2 - 840*Dd**2*f**3*r*s + 210*Dd**2*f**3*r - 840*Dd**2*f**3*s**2 + 840*Dd**2*f**3*s - 140*Dd**2*f**3 + 3780*Dd**2*f**2*r*s - 945*Dd**2*f**2*r + 3780*Dd**2*f**2*s**2 - 3780*Dd**2*f**2*s + 630*Dd**2*f**2 + 4536*Dd**2*f*g2*r*s - 1134*Dd**2*f*g2*r + 4536*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 756*Dd**2*f*g2))/(315*d**2*k3**6) + 3*D1**2*Pk3*Pkd2*ct**4*k1**4*st**2*(D1**2*(525*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(1575*fd**2*s*(2*s - 1) - fd*(220*C - 220)*(3*s**2 - 2*s + 1) + fdd*(110*C - 110)*(3*s**2 - 2*s + 1) + s**2*(99*K*bdd1 - 198*bd1*(K - 1) - 99*bdd1 + 396*gd2 - 198*gdd2)) - 44*f*(fd**2*s*(10*C - 10)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 792*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(525*f**3*(4*s**2 - 2*s + 1) + 5*f**2*(44*C*(4*s**2 - 2*s + 1) - 105*fd*(1 - 4*s)**2 - 176*s**2 + 88*s - 44) - 22*f*(fd*(10*C - 10)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 396*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(525*f**2 + f*(220*C - 220) - 396*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(525*f**2 + f*(220*C - 220) - 396*g2) + 198*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(770*d**2*k2*k3**4) - D1**2*Pk3*Pkd2*ct**4*k1**4*(450*C*D1**2*bdd1*f**2*s**2 - 900*C*D1**2*bdd1*f**2*s + 450*C*D1**2*bdd1*f**2 + 3840*C*D1**2*f**2*fd*s**2 - 2560*C*D1**2*f**2*fd*s + 1280*C*D1**2*f**2*fd - 2190*C*D1**2*f**2*fdd*s**2 + 1460*C*D1**2*f**2*fdd*s - 730*C*D1**2*f**2*fdd - 4380*C*D1**2*f*fd**2*s**2 + 2920*C*D1**2*f*fd**2*s + 5120*C*D1*Dd*f**3*s**2 - 2560*C*D1*Dd*f**3*s + 1280*C*D1*Dd*f**3 - 17520*C*D1*Dd*f**2*fd*s**2 + 10220*C*D1*Dd*f**2*fd*s - 1460*C*D1*Dd*f**2*fd - 2920*C*D1*Ddd*f**3*s**2 + 1460*C*D1*Ddd*f**3*s - 730*C*D1*Ddd*f**3 - 8760*C*Dd**2*f**3*s**2 + 4380*C*Dd**2*f**3*s - 495*D1**2*K*bdd1*f**2*s**2 + 630*D1**2*bd1**2*f*s*(K - 1)*(s - 1) + 280*D1**2*bdd1*f**3*r*s + 630*D1**2*bdd1*f**3*s**2 - 1190*D1**2*bdd1*f**3*s + 525*D1**2*bdd1*f**3 + 180*D1**2*bdd1*f**2*r*s + 225*D1**2*bdd1*f**2*s**2 + 720*D1**2*bdd1*f**2*s - 450*D1**2*bdd1*f**2 - 630*D1**2*bdd1*f*g2*s**2 + 1260*D1**2*bdd1*f*g2*s - 630*D1**2*bdd1*f*g2 + 1400*D1**2*f**3*fd*r*s - 350*D1**2*f**3*fd*r + 6720*D1**2*f**3*fd*s**2 - 4060*D1**2*f**3*fd*s + 1680*D1**2*f**3*fd - 1400*D1**2*f**3*fdd*r*s + 350*D1**2*f**3*fdd*r - 3780*D1**2*f**3*fdd*s**2 + 2590*D1**2*f**3*fdd*s - 945*D1**2*f**3*fdd - 4200*D1**2*f**2*fd**2*r*s + 1050*D1**2*f**2*fd**2*r - 11340*D1**2*f**2*fd**2*s**2 + 7770*D1**2*f**2*fd**2*s - 700*D1**2*f**2*fd**2 - 300*D1**2*f**2*fd*r*s + 100*D1**2*f**2*fd*r - 4140*D1**2*f**2*fd*s**2 + 2860*D1**2*f**2*fd*s - 1380*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r + 2610*D1**2*f**2*fdd*s**2 - 1880*D1**2*f**2*fdd*s + 870*D1**2*f**2*fdd - 1728*D1**2*f**2*gd2*s**2 + 990*D1**2*f**2*gdd2*s**2 + 840*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r + 5220*D1**2*f*fd**2*s**2 - 3760*D1**2*f*fd**2*s + 140*D1**2*f*fd**2 - 3456*D1**2*f*fd*g2*s**2 + 3456*D1**2*f*fd*g2*s - 1728*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*s**2 - 1980*D1**2*f*fd*gd2*s + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 1400*D1*Dd*f**4*r*s - 350*D1*Dd*f**4*r + 6720*D1*Dd*f**4*s**2 - 4060*D1*Dd*f**4*s + 1680*D1*Dd*f**4 - 11200*D1*Dd*f**3*fd*r*s + 2800*D1*Dd*f**3*fd*r - 30240*D1*Dd*f**3*fd*s**2 + 20720*D1*Dd*f**3*fd*s - 3290*D1*Dd*f**3*fd - 400*D1*Dd*f**3*r*s + 100*D1*Dd*f**3*r - 5520*D1*Dd*f**3*s**2 + 2960*D1*Dd*f**3*s - 1380*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r*s - 980*D1*Dd*f**2*fd*r + 20880*D1*Dd*f**2*fd*s**2 - 13580*D1*Dd*f**2*fd*s + 2160*D1*Dd*f**2*fd - 6912*D1*Dd*f**2*g2*s**2 + 3456*D1*Dd*f**2*g2*s - 1728*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*s**2 - 1980*D1*Dd*f**2*gd2*s + 15840*D1*Dd*f*fd*g2*s**2 - 11880*D1*Dd*f*fd*g2*s + 1980*D1*Dd*f*fd*g2 - 1400*D1*Ddd*f**4*r*s + 350*D1*Ddd*f**4*r - 3780*D1*Ddd*f**4*s**2 + 2590*D1*Ddd*f**4*s - 945*D1*Ddd*f**4 + 560*D1*Ddd*f**3*r*s - 140*D1*Ddd*f**3*r + 3480*D1*Ddd*f**3*s**2 - 2020*D1*Ddd*f**3*s + 870*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*s**2 - 1980*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(25*f**3*(18*s**2 + s*(4*r - 44) + 21) + 2*f**2*(225*C*(s - 1)**2 - 35*fd*(2*r*(6*s - 1) + 27*s**2 - 30*s + 1) + 9*s**2*(2 - 24*K) + 9*s*(3*r + 47) - 225) - 45*f*(fd*(r*(8*s - 2) + s**2*(20*C - 22*K + 10) + s*(-20*C + 11*K + 1) + 2) + (14*s - 14)*(g2*(s - 1) - gd2*s)) + 630*fd*g2*s*(s - 1)) - 5*Dd*f*(7*f**2*(4*r*(8*s - 1) + 72*s**2 - 94*s + 17) + 9*f*(10*C*(4*s**2 - 5*s + 1) - 44*K*s**2 + 11*K*s + 16*r*s - 2*r + 20*s**2 + 23*s - 8) - 126*g2*(4*s**2 - 5*s + 1))) - 4200*Dd**2*f**4*r*s + 1050*Dd**2*f**4*r - 11340*Dd**2*f**4*s**2 + 7770*Dd**2*f**4*s - 700*Dd**2*f**4 + 1680*Dd**2*f**3*r*s - 420*Dd**2*f**3*r + 10440*Dd**2*f**3*s**2 - 6060*Dd**2*f**3*s + 280*Dd**2*f**3 + 11880*Dd**2*f**2*g2*s**2 - 5940*Dd**2*f**2*g2*s - 315*b1**2*(K - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-1800*C*D1**2*f*fd*s**2 + 900*C*D1**2*f*fdd*s**2 + 900*C*D1**2*fd**2*s**2 - 3600*C*D1*Dd*f**2*s**2 + 1800*C*D1*Dd*f**2*s - 900*C*D1*Dd*f**2 + 7200*C*D1*Dd*f*fd*s**2 - 1800*C*D1*Dd*f*fd*s + 1800*C*D1*Ddd*f**2*s**2 - 900*C*D1*Ddd*f**2*s + 450*C*D1*Ddd*f**2 + 5400*C*Dd**2*f**2*s**2 - 2700*C*Dd**2*f**2*s + 1728*D1**2*K*f*fd*s**2 - 1728*D1**2*K*f*fd*s + 864*D1**2*K*f*fd - 990*D1**2*K*f*fdd*s**2 + 990*D1**2*K*f*fdd*s - 495*D1**2*K*f*fdd - 990*D1**2*K*fd**2*s**2 + 990*D1**2*K*fd**2*s + 315*D1**2*bdd1*f*(K - 1)*(2*s**2 - 2*s + 1) - 600*D1**2*f**2*fd*r*s + 200*D1**2*f**2*fd*r - 2700*D1**2*f**2*fd*s**2 + 150*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r*s - 280*D1**2*f**2*fdd*r + 1890*D1**2*f**2*fdd*s**2 - 630*D1**2*f**2*fdd*s + 105*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r*s - 560*D1**2*f*fd**2*r + 3780*D1**2*f*fd**2*s**2 - 1260*D1**2*f*fd**2*s + 420*D1**2*f*fd**2 - 216*D1**2*f*fd*r*s + 108*D1**2*f*fd*r - 144*D1**2*f*fd*s**2 + 1944*D1**2*f*fd*s - 972*D1**2*f*fd + 360*D1**2*f*fdd*r*s - 180*D1**2*f*fdd*r + 450*D1**2*f*fdd*s**2 - 1350*D1**2*f*fdd*s + 675*D1**2*f*fdd + 1260*D1**2*f*gd2*s**2 - 630*D1**2*f*gdd2*s**2 + 360*D1**2*fd**2*r*s - 180*D1**2*fd**2*r + 450*D1**2*fd**2*s**2 - 1350*D1**2*fd**2*s + 1260*D1**2*fd*g2*s**2 - 1260*D1**2*fd*gd2*s**2 - 630*D1**2*fdd*g2*s**2 + 3456*D1*Dd*K*f**2*s**2 - 1728*D1*Dd*K*f**2*s + 864*D1*Dd*K*f**2 - 7920*D1*Dd*K*f*fd*s**2 + 5940*D1*Dd*K*f*fd*s - 990*D1*Dd*K*f*fd - 800*D1*Dd*f**3*r*s + 200*D1*Dd*f**3*r - 3600*D1*Dd*f**3*s**2 + 2200*D1*Dd*f**3*s - 900*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r*s - 1960*D1*Dd*f**2*fd*r + 15120*D1*Dd*f**2*fd*s**2 - 7980*D1*Dd*f**2*fd*s + 1190*D1*Dd*f**2*fd - 432*D1*Dd*f**2*r*s + 108*D1*Dd*f**2*r - 288*D1*Dd*f**2*s**2 + 360*D1*Dd*f**2*s - 72*D1*Dd*f**2 + 2880*D1*Dd*f*fd*r*s - 1080*D1*Dd*f*fd*r + 3600*D1*Dd*f*fd*s**2 - 7020*D1*Dd*f*fd*s + 1710*D1*Dd*f*fd + 5040*D1*Dd*f*g2*s**2 - 2520*D1*Dd*f*g2*s + 1260*D1*Dd*f*g2 - 5040*D1*Dd*f*gd2*s**2 + 1260*D1*Dd*f*gd2*s - 5040*D1*Dd*fd*g2*s**2 + 1260*D1*Dd*fd*g2*s - 1980*D1*Ddd*K*f**2*s**2 + 990*D1*Ddd*K*f**2*s - 495*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r + 2520*D1*Ddd*f**3*s**2 - 1820*D1*Ddd*f**3*s + 630*D1*Ddd*f**3 + 720*D1*Ddd*f**2*r*s - 180*D1*Ddd*f**2*r + 900*D1*Ddd*f**2*s**2 - 810*D1*Ddd*f**2*s + 225*D1*Ddd*f**2 - 2520*D1*Ddd*f*g2*s**2 + 1260*D1*Ddd*f*g2*s - 630*D1*Ddd*f*g2 - 630*D1*bd1*(K - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 5940*Dd**2*K*f**2*s**2 + 2970*Dd**2*K*f**2*s + 3360*Dd**2*f**3*r*s - 840*Dd**2*f**3*r + 7560*Dd**2*f**3*s**2 - 5460*Dd**2*f**3*s + 560*Dd**2*f**3 + 2160*Dd**2*f**2*r*s - 540*Dd**2*f**2*r + 2700*Dd**2*f**2*s**2 - 2430*Dd**2*f**2*s + 360*Dd**2*f**2 - 7560*Dd**2*f*g2*s**2 + 3780*Dd**2*f*g2*s))/(630*d**2*k2*k3**4) + 4*D1**2*Pk3*Pkd2*ct**4*k1**2*k2**3*st**4*(396*C*D1**2*f**2*fd*r*s - 132*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 396*C*D1**2*f**2*fd*s + 132*C*D1**2*f**2*fd - 198*C*D1**2*f**2*fdd*r*s + 66*C*D1**2*f**2*fdd*r - 198*C*D1**2*f**2*fdd*s**2 + 198*C*D1**2*f**2*fdd*s - 66*C*D1**2*f**2*fdd - 396*C*D1**2*f*fd**2*r*s + 132*C*D1**2*f*fd**2*r - 396*C*D1**2*f*fd**2*s**2 + 396*C*D1**2*f*fd**2*s - 66*C*D1**2*f*fd**2 + 528*C*D1*Dd*f**3*r*s - 132*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 528*C*D1*Dd*f**3*s + 132*C*D1*Dd*f**3 - 1584*C*D1*Dd*f**2*fd*r*s + 462*C*D1*Dd*f**2*fd*r - 1584*C*D1*Dd*f**2*fd*s**2 + 1584*C*D1*Dd*f**2*fd*s - 330*C*D1*Dd*f**2*fd - 264*C*D1*Ddd*f**3*r*s + 66*C*D1*Ddd*f**3*r - 264*C*D1*Ddd*f**3*s**2 + 264*C*D1*Ddd*f**3*s - 66*C*D1*Ddd*f**3 - 792*C*Dd**2*f**3*r*s + 198*C*Dd**2*f**3*r - 792*C*Dd**2*f**3*s**2 + 792*C*Dd**2*f**3*s - 132*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 560*D1**2*f**3*fd*r*s - 140*D1**2*f**3*fd*r + 560*D1**2*f**3*fd*s**2 - 560*D1**2*f**3*fd*s + 140*D1**2*f**3*fd - 280*D1**2*f**3*fdd*r*s + 70*D1**2*f**3*fdd*r - 280*D1**2*f**3*fdd*s**2 + 280*D1**2*f**3*fdd*s - 70*D1**2*f**3*fdd - 840*D1**2*f**2*fd**2*r*s + 210*D1**2*f**2*fd**2*r - 840*D1**2*f**2*fd**2*s**2 + 840*D1**2*f**2*fd**2*s - 140*D1**2*f**2*fd**2 - 396*D1**2*f**2*fd*r*s + 132*D1**2*f**2*fd*r - 396*D1**2*f**2*fd*s**2 + 396*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 198*D1**2*f**2*fdd*r*s - 66*D1**2*f**2*fdd*r + 198*D1**2*f**2*fdd*s**2 - 198*D1**2*f**2*fdd*s + 66*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 396*D1**2*f*fd**2*r*s - 132*D1**2*f*fd**2*r + 396*D1**2*f*fd**2*s**2 - 396*D1**2*f*fd**2*s + 66*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 560*D1*Dd*f**4*r*s - 140*D1*Dd*f**4*r + 560*D1*Dd*f**4*s**2 - 560*D1*Dd*f**4*s + 140*D1*Dd*f**4 - 2240*D1*Dd*f**3*fd*r*s + 560*D1*Dd*f**3*fd*r - 2240*D1*Dd*f**3*fd*s**2 + 2240*D1*Dd*f**3*fd*s - 420*D1*Dd*f**3*fd - 528*D1*Dd*f**3*r*s + 132*D1*Dd*f**3*r - 528*D1*Dd*f**3*s**2 + 528*D1*Dd*f**3*s - 132*D1*Dd*f**3 + 1584*D1*Dd*f**2*fd*r*s - 462*D1*Dd*f**2*fd*r + 1584*D1*Dd*f**2*fd*s**2 - 1584*D1*Dd*f**2*fd*s + 330*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 280*D1*Ddd*f**4*r*s + 70*D1*Ddd*f**4*r - 280*D1*Ddd*f**4*s**2 + 280*D1*Ddd*f**4*s - 70*D1*Ddd*f**4 + 264*D1*Ddd*f**3*r*s - 66*D1*Ddd*f**3*r + 264*D1*Ddd*f**3*s**2 - 264*D1*Ddd*f**3*s + 66*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 840*Dd**2*f**4*r*s + 210*Dd**2*f**4*r - 840*Dd**2*f**4*s**2 + 840*Dd**2*f**4*s - 140*Dd**2*f**4 + 792*Dd**2*f**3*r*s - 198*Dd**2*f**3*r + 792*Dd**2*f**3*s**2 - 792*Dd**2*f**3*s + 132*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(231*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**4*k1**2*k2**3*st**2*(-36*C*D1**2*bdd1*f**2*r*s + 36*C*D1**2*bdd1*f**2*r - 36*C*D1**2*bdd1*f**2*s**2 + 72*C*D1**2*bdd1*f**2*s - 36*C*D1**2*bdd1*f**2 + 876*C*D1**2*f**2*fd*r*s - 292*C*D1**2*f**2*fd*r + 876*C*D1**2*f**2*fd*s**2 - 876*C*D1**2*f**2*fd*s + 292*C*D1**2*f**2*fd - 600*C*D1**2*f**2*fdd*r*s + 200*C*D1**2*f**2*fdd*r - 600*C*D1**2*f**2*fdd*s**2 + 600*C*D1**2*f**2*fdd*s - 200*C*D1**2*f**2*fdd - 1200*C*D1**2*f*fd**2*r*s + 400*C*D1**2*f*fd**2*r - 1200*C*D1**2*f*fd**2*s**2 + 1200*C*D1**2*f*fd**2*s - 200*C*D1**2*f*fd**2 + 1168*C*D1*Dd*f**3*r*s - 292*C*D1*Dd*f**3*r + 1168*C*D1*Dd*f**3*s**2 - 1168*C*D1*Dd*f**3*s + 292*C*D1*Dd*f**3 - 4800*C*D1*Dd*f**2*fd*r*s + 1400*C*D1*Dd*f**2*fd*r - 4800*C*D1*Dd*f**2*fd*s**2 + 4800*C*D1*Dd*f**2*fd*s - 1000*C*D1*Dd*f**2*fd - 800*C*D1*Ddd*f**3*r*s + 200*C*D1*Ddd*f**3*r - 800*C*D1*Ddd*f**3*s**2 + 800*C*D1*Ddd*f**3*s - 200*C*D1*Ddd*f**3 - 2400*C*Dd**2*f**3*r*s + 600*C*Dd**2*f**3*r - 2400*C*Dd**2*f**3*s**2 + 2400*C*Dd**2*f**3*s - 400*C*Dd**2*f**3 - 180*D1**2*K*bdd1*f**2*r*s - 180*D1**2*K*bdd1*f**2*s**2 + 180*D1**2*K*bdd1*f**2*s - 42*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 75*D1**2*bdd1*f**3*r*s + 25*D1**2*bdd1*f**3*r + 75*D1**2*bdd1*f**3*s**2 - 50*D1**2*bdd1*f**3*s - 25*D1**2*bdd1*f**3 + 126*D1**2*bdd1*f**2*r*s - 36*D1**2*bdd1*f**2*r + 126*D1**2*bdd1*f**2*s**2 - 162*D1**2*bdd1*f**2*s + 36*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*g2*r*s - 84*D1**2*bdd1*f*g2*r + 84*D1**2*bdd1*f*g2*s**2 - 168*D1**2*bdd1*f*g2*s + 84*D1**2*bdd1*f*g2 - 100*D1**2*f**3*fd*r*s + 25*D1**2*f**3*fd*r - 100*D1**2*f**3*fd*s**2 + 100*D1**2*f**3*fd*s - 25*D1**2*f**3*fd - 630*D1**2*f**2*fd*r*s + 210*D1**2*f**2*fd*r - 630*D1**2*f**2*fd*s**2 + 630*D1**2*f**2*fd*s - 210*D1**2*f**2*fd + 450*D1**2*f**2*fdd*r*s - 150*D1**2*f**2*fdd*r + 450*D1**2*f**2*fdd*s**2 - 450*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd - 468*D1**2*f**2*gd2*r*s - 468*D1**2*f**2*gd2*s**2 + 468*D1**2*f**2*gd2*s + 360*D1**2*f**2*gdd2*r*s + 360*D1**2*f**2*gdd2*s**2 - 360*D1**2*f**2*gdd2*s + 900*D1**2*f*fd**2*r*s - 300*D1**2*f*fd**2*r + 900*D1**2*f*fd**2*s**2 - 900*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 936*D1**2*f*fd*g2*r*s + 468*D1**2*f*fd*g2*r - 936*D1**2*f*fd*g2*s**2 + 936*D1**2*f*fd*g2*s - 468*D1**2*f*fd*g2 + 1440*D1**2*f*fd*gd2*r*s - 360*D1**2*f*fd*gd2*r + 1440*D1**2*f*fd*gd2*s**2 - 1440*D1**2*f*fd*gd2*s + 360*D1**2*f*fd*gd2 + 720*D1**2*f*fdd*g2*r*s - 360*D1**2*f*fdd*g2*r + 720*D1**2*f*fdd*g2*s**2 - 720*D1**2*f*fdd*g2*s + 360*D1**2*f*fdd*g2 + 720*D1**2*fd**2*g2*r*s - 360*D1**2*fd**2*g2*r + 720*D1**2*fd**2*g2*s**2 - 720*D1**2*fd**2*g2*s - 100*D1*Dd*f**4*r*s + 25*D1*Dd*f**4*r - 100*D1*Dd*f**4*s**2 + 100*D1*Dd*f**4*s - 25*D1*Dd*f**4 - 840*D1*Dd*f**3*r*s + 210*D1*Dd*f**3*r - 840*D1*Dd*f**3*s**2 + 840*D1*Dd*f**3*s - 210*D1*Dd*f**3 + 3600*D1*Dd*f**2*fd*r*s - 1050*D1*Dd*f**2*fd*r + 3600*D1*Dd*f**2*fd*s**2 - 3600*D1*Dd*f**2*fd*s + 750*D1*Dd*f**2*fd - 1872*D1*Dd*f**2*g2*r*s + 468*D1*Dd*f**2*g2*r - 1872*D1*Dd*f**2*g2*s**2 + 1872*D1*Dd*f**2*g2*s - 468*D1*Dd*f**2*g2 + 2880*D1*Dd*f**2*gd2*r*s - 360*D1*Dd*f**2*gd2*r + 2880*D1*Dd*f**2*gd2*s**2 - 2880*D1*Dd*f**2*gd2*s + 360*D1*Dd*f**2*gd2 + 5760*D1*Dd*f*fd*g2*r*s - 2160*D1*Dd*f*fd*g2*r + 5760*D1*Dd*f*fd*g2*s**2 - 5760*D1*Dd*f*fd*g2*s + 1440*D1*Dd*f*fd*g2 + 600*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 600*D1*Ddd*f**3*s**2 - 600*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 + 1440*D1*Ddd*f**2*g2*r*s - 360*D1*Ddd*f**2*g2*r + 1440*D1*Ddd*f**2*g2*s**2 - 1440*D1*Ddd*f**2*g2*s + 360*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-10*f**3*(12*s + 5)*(r + s - 1) + f**2*(72*C*(s - 1)*(r + s - 1) + 25*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + (6*r + 6*s - 6)*(39*K*s - 28*s + 12)) - 6*f*(3*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 10*K*(r*(4*s - 1) + (1 - 2*s)**2) - 28*r*s + 9*r - 28*s**2 + 30*s - 7) + (14*r + 14*s - 14)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(25*f**2*(24*r*s + r + 4*s*(6*s - 5)) - 18*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 56*r*s + 15*r - 56*s**2 + 64*s - 13) + 84*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 1800*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 1800*Dd**2*f**3*s**2 - 1800*Dd**2*f**3*s + 300*Dd**2*f**3 + 4320*Dd**2*f**2*g2*r*s - 1080*Dd**2*f**2*g2*r + 4320*Dd**2*f**2*g2*s**2 - 4320*Dd**2*f**2*g2*s + 720*Dd**2*f**2*g2 + 42*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(144*C*D1**2*f*fd*r*s + 144*C*D1**2*f*fd*s**2 - 72*C*D1**2*f*fd*s - 72*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*s**2 + 36*C*D1**2*f*fdd*s - 72*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*s**2 + 36*C*D1**2*fd**2*s + 288*C*D1*Dd*f**2*r*s - 72*C*D1*Dd*f**2*r + 288*C*D1*Dd*f**2*s**2 - 288*C*D1*Dd*f**2*s + 72*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r*s + 72*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 432*C*D1*Dd*f*fd*s - 36*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r*s + 36*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 144*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r*s + 108*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 432*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 + 468*D1**2*K*f*fd*r*s - 234*D1**2*K*f*fd*r + 468*D1**2*K*f*fd*s**2 - 468*D1**2*K*f*fd*s + 234*D1**2*K*f*fd - 360*D1**2*K*f*fdd*r*s + 180*D1**2*K*f*fdd*r - 360*D1**2*K*f*fdd*s**2 + 360*D1**2*K*f*fdd*s - 180*D1**2*K*f*fdd - 360*D1**2*K*fd**2*r*s + 180*D1**2*K*fd**2*r - 360*D1**2*K*fd**2*s**2 + 360*D1**2*K*fd**2*s - 42*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 360*D1**2*f**2*fd*r*s + 170*D1**2*f**2*fd*r - 360*D1**2*f**2*fd*s**2 + 410*D1**2*f**2*fd*s - 170*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 250*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 500*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 336*D1**2*f*fd*r*s + 96*D1**2*f*fd*r - 336*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 96*D1**2*f*fd + 252*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 252*D1**2*f*fdd*s**2 - 216*D1**2*f*fdd*s + 90*D1**2*f*fdd - 168*D1**2*f*gd2*r*s - 168*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s + 84*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 252*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 252*D1**2*fd**2*s**2 - 216*D1**2*fd**2*s - 168*D1**2*fd*g2*r*s - 168*D1**2*fd*g2*s**2 + 168*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*s**2 - 84*D1**2*fd*gd2*s + 84*D1**2*fdd*g2*r*s + 84*D1**2*fdd*g2*s**2 + 936*D1*Dd*K*f**2*r*s - 234*D1*Dd*K*f**2*r + 936*D1*Dd*K*f**2*s**2 - 936*D1*Dd*K*f**2*s + 234*D1*Dd*K*f**2 - 2880*D1*Dd*K*f*fd*r*s + 1080*D1*Dd*K*f*fd*r - 2880*D1*Dd*K*f*fd*s**2 + 2880*D1*Dd*K*f*fd*s - 720*D1*Dd*K*f*fd - 480*D1*Dd*f**3*r*s + 120*D1*Dd*f**3*r - 480*D1*Dd*f**3*s**2 + 480*D1*Dd*f**3*s - 120*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r*s - 625*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 1900*D1*Dd*f**2*fd*s + 450*D1*Dd*f**2*fd - 672*D1*Dd*f**2*r*s + 168*D1*Dd*f**2*r - 672*D1*Dd*f**2*s**2 + 672*D1*Dd*f**2*s - 168*D1*Dd*f**2 + 2016*D1*Dd*f*fd*r*s - 612*D1*Dd*f*fd*r + 2016*D1*Dd*f*fd*s**2 - 1872*D1*Dd*f*fd*s + 396*D1*Dd*f*fd - 672*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 672*D1*Dd*f*g2*s**2 + 672*D1*Dd*f*g2*s - 168*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r*s - 84*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 672*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r*s - 84*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 336*D1*Dd*fd*g2*s - 720*D1*Ddd*K*f**2*r*s + 180*D1*Ddd*K*f**2*r - 720*D1*Ddd*K*f**2*s**2 + 720*D1*Ddd*K*f**2*s - 180*D1*Ddd*K*f**2 + 300*D1*Ddd*f**3*r*s - 75*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 504*D1*Ddd*f**2*r*s - 126*D1*Ddd*f**2*r + 504*D1*Ddd*f**2*s**2 - 504*D1*Ddd*f**2*s + 126*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 336*D1*Ddd*f*g2*s + 84*D1*Ddd*f*g2 + 42*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 2160*Dd**2*K*f**2*r*s + 540*Dd**2*K*f**2*r - 2160*Dd**2*K*f**2*s**2 + 2160*Dd**2*K*f**2*s - 360*Dd**2*K*f**2 + 900*Dd**2*f**3*r*s - 225*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 150*Dd**2*f**3 + 1512*Dd**2*f**2*r*s - 378*Dd**2*f**2*r + 1512*Dd**2*f**2*s**2 - 1512*Dd**2*f**2*s + 252*Dd**2*f**2 + 1008*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1008*Dd**2*f*g2*s + 168*Dd**2*f*g2))/(105*d**2*k3**6) - 4*D1**2*Pk3*Pkd2*ct**4*k1**2*k2**3*(180*C*D1**2*bdd1*f**2*r*s - 180*C*D1**2*bdd1*f**2*r + 180*C*D1**2*bdd1*f**2*s**2 - 360*C*D1**2*bdd1*f**2*s + 180*C*D1**2*bdd1*f**2 + 120*C*D1**2*f**2*fd*r*s - 40*C*D1**2*f**2*fd*r + 120*C*D1**2*f**2*fd*s**2 - 120*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd + 210*C*D1**2*f**2*fdd*r*s - 70*C*D1**2*f**2*fdd*r + 210*C*D1**2*f**2*fdd*s**2 - 210*C*D1**2*f**2*fdd*s + 70*C*D1**2*f**2*fdd + 420*C*D1**2*f*fd**2*r*s - 140*C*D1**2*f*fd**2*r + 420*C*D1**2*f*fd**2*s**2 - 420*C*D1**2*f*fd**2*s + 70*C*D1**2*f*fd**2 + 160*C*D1*Dd*f**3*r*s - 40*C*D1*Dd*f**3*r + 160*C*D1*Dd*f**3*s**2 - 160*C*D1*Dd*f**3*s + 40*C*D1*Dd*f**3 + 1680*C*D1*Dd*f**2*fd*r*s - 490*C*D1*Dd*f**2*fd*r + 1680*C*D1*Dd*f**2*fd*s**2 - 1680*C*D1*Dd*f**2*fd*s + 350*C*D1*Dd*f**2*fd + 280*C*D1*Ddd*f**3*r*s - 70*C*D1*Ddd*f**3*r + 280*C*D1*Ddd*f**3*s**2 - 280*C*D1*Ddd*f**3*s + 70*C*D1*Ddd*f**3 + 840*C*Dd**2*f**3*r*s - 210*C*Dd**2*f**3*r + 840*C*Dd**2*f**3*s**2 - 840*C*Dd**2*f**3*s + 140*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*s**2 - 45*D1**2*K*bdd1*f**2*s - 3*D1**2*bd1**2*f*(2*s - 1)*(-42*K + 20*f + 21)*(r + s - 1) - 135*D1**2*bdd1*f**2*r*s + 135*D1**2*bdd1*f**2*r - 135*D1**2*bdd1*f**2*s**2 + 270*D1**2*bdd1*f**2*s - 135*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r*s + 252*D1**2*bdd1*f*g2*r - 252*D1**2*bdd1*f*g2*s**2 + 504*D1**2*bdd1*f*g2*s - 252*D1**2*bdd1*f*g2 - 150*D1**2*f**2*fd*r*s + 50*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 150*D1**2*f**2*fd*s - 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r*s + 35*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 105*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s - 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*s**2 + 90*D1**2*f**2*gdd2*s - 210*D1**2*f*fd**2*r*s + 70*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 210*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r*s + 90*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 90*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r*s + 90*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r*s + 90*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s - 200*D1*Dd*f**3*r*s + 50*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 200*D1*Dd*f**3*s - 50*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r*s + 245*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 840*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r*s + 90*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 720*D1*Dd*f**2*gd2*s - 90*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r*s + 540*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**3*r*s + 35*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 140*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r*s + 90*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*(2*s + 1)*(r + s - 1) + f**2*(r + s - 1)*(78*C*(s - 1) - s*(12*K + 41) + 55) + f*(-15*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + (-7*g2*(s - 1) + 6*gd2*(2*s - 1))*(14*r + 14*s - 14)) + 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(5*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 420*Dd**2*f**3*r*s + 105*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 420*Dd**2*f**3*s - 70*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r*s + 270*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 + b1**2*(D1**2*s*(3*f*(33*fd - 20*fdd)*(2*r + 2*s - 1) - 60*fd**2*(2*r + 2*s - 1) - 7*fd*(21*K - 8)*(r + s) + 63*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(99*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-60*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (56 - 147*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 63*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-42*K + 20*f + 21)) - 3*Dd**2*f*(-42*K + 20*f + 21)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*bdd1*f*(2*s - 1)*(-42*K + 20*f + 21)*(r + s - 1) - 3*D1**2*(5*f**2*fd*(r*(6*s - 3) + 6*s**2 - 7*s + 3) - f*(fd*(-156*C*s**2 + 78*C*s + 12*K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + r*(-156*C*s + 82*s + 14) + 82*s**2 - 27*s - 14) + 15*fdd*(K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + s*(4*C - 3)*(2*r + 2*s - 1)) + s*(98*gd2 - 84*gdd2)*(r + s - 1)) - 15*fd**2*(K*r*(2*s - 1) + 2*K*s*(s - 1) + s*(4*C - 3)*(2*r + 2*s - 1)) + 14*fd*s*(-7*g2*(r + s) + 6*gd2*(2*r + 2*s - 1)) + 84*fdd*g2*s*(r + s)) + D1*bd1*(D1*(99*f**2*(2*s - 1)*(r + s - 1) + f*(-60*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + (56 - 147*K)*(2*s - 1)*(r + s - 1)) + 63*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 3*Dd*f*(-42*K + 20*f + 21)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*D1*(Dd*(10*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(78*C - 12*K - 41) + f*(-15*fd*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) + 2*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 48*r*s + 6*r - 48*s**2 + 36*s - 3) - 98*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 84*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 84*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(5*f*(4*C + K - 3) - 28*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*Dd**2*f*(5*f*(4*C + K - 3) - 28*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**6) + 3*D1**2*Pk3*Pkd2*ct**4*k1**2*k2*st**4*(D1**2*(70*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 3*f**2*(140*fd**2*s*(2*s - 1) - fd*(44*C - 44)*(3*s**2 - 2*s + 1) + fdd*(22*C - 22)*(3*s**2 - 2*s + 1) + s**2*(33*K*bdd1 - 66*bd1*(K - 1) - 33*bdd1 + 132*gd2 - 66*gdd2)) - 66*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 3*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 3*fdd*g2*(2*s**2 - 2*s + 1)) + 396*fd**2*g2*s*(s - 1)) + 2*D1*f*(Dd*(70*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(33*C*(4*s**2 - 2*s + 1) - 35*fd*(1 - 4*s)**2 - 132*s**2 + 66*s - 33) - 33*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 6*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(3*K*bd1 - 3*bd1 - 6*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(35*f**2 + f*(33*C - 33) - 99*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(2*s - 1)*(35*f**2 + f*(33*C - 33) - 99*g2) + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**4*k1**2*k2*st**2*(432*C*D1**2*bdd1*f**2*r*s + 972*C*D1**2*bdd1*f**2*s**2 - 1080*C*D1**2*bdd1*f**2*s + 540*C*D1**2*bdd1*f**2 + 7104*C*D1**2*f**2*fd*r*s - 2368*C*D1**2*f**2*fd*r - 5712*C*D1**2*f**2*fd*s**2 + 1440*C*D1**2*f**2*fd*s - 1904*C*D1**2*f**2*fd - 4848*C*D1**2*f**2*fdd*r*s + 1616*C*D1**2*f**2*fdd*r + 1884*C*D1**2*f**2*fdd*s**2 + 360*C*D1**2*f**2*fdd*s + 628*C*D1**2*f**2*fdd - 9696*C*D1**2*f*fd**2*r*s + 3232*C*D1**2*f*fd**2*r + 3768*C*D1**2*f*fd**2*s**2 + 720*C*D1**2*f*fd**2*s - 1616*C*D1**2*f*fd**2 + 9472*C*D1*Dd*f**3*r*s - 2368*C*D1*Dd*f**3*r - 7616*C*D1*Dd*f**3*s**2 - 928*C*D1*Dd*f**3*s - 1904*C*D1*Dd*f**3 - 38784*C*D1*Dd*f**2*fd*r*s + 11312*C*D1*Dd*f**2*fd*r + 15072*C*D1*Dd*f**2*fd*s**2 + 7368*C*D1*Dd*f**2*fd*s - 3592*C*D1*Dd*f**2*fd - 6464*C*D1*Ddd*f**3*r*s + 1616*C*D1*Ddd*f**3*r + 2512*C*D1*Ddd*f**3*s**2 + 1976*C*D1*Ddd*f**3*s + 628*C*D1*Ddd*f**3 - 19392*C*Dd**2*f**3*r*s + 4848*C*Dd**2*f**3*r + 7536*C*Dd**2*f**3*s**2 + 5928*C*Dd**2*f**3*s - 3232*C*Dd**2*f**3 - 1224*D1**2*K*bdd1*f**2*r*s + 306*D1**2*K*bdd1*f**2*s**2 + 1224*D1**2*K*bdd1*f**2*s + 252*D1**2*bd1**2*f*s*(K - 1)*(4*r + 9*s - 7) + 1200*D1**2*bdd1*f**3*r*s + 450*D1**2*bdd1*f**3*s**2 - 1650*D1**2*bdd1*f**3*s + 375*D1**2*bdd1*f**3 + 1872*D1**2*bdd1*f**2*r*s + 702*D1**2*bdd1*f**2*s**2 - 1224*D1**2*bdd1*f**2*s - 540*D1**2*bdd1*f**2 - 1008*D1**2*bdd1*f*g2*r*s - 2268*D1**2*bdd1*f*g2*s**2 + 2520*D1**2*bdd1*f*g2*s - 1260*D1**2*bdd1*f*g2 + 5400*D1**2*f**3*fd*r*s - 1350*D1**2*f**3*fd*r + 6000*D1**2*f**3*fd*s**2 - 5700*D1**2*f**3*fd*s + 1500*D1**2*f**3*fd - 5400*D1**2*f**3*fdd*r*s + 1350*D1**2*f**3*fdd*r - 3900*D1**2*f**3*fdd*s**2 + 4650*D1**2*f**3*fdd*s - 975*D1**2*f**3*fdd - 16200*D1**2*f**2*fd**2*r*s + 4050*D1**2*f**2*fd**2*r - 11700*D1**2*f**2*fd**2*s**2 + 13950*D1**2*f**2*fd**2*s - 2700*D1**2*f**2*fd**2 - 10056*D1**2*f**2*fd*r*s + 3352*D1**2*f**2*fd*r - 240*D1**2*f**2*fd*s**2 + 3512*D1**2*f**2*fd*s - 80*D1**2*f**2*fd + 6648*D1**2*f**2*fdd*r*s - 2216*D1**2*f**2*fdd*r + 1416*D1**2*f**2*fdd*s**2 - 3160*D1**2*f**2*fdd*s + 472*D1**2*f**2*fdd - 3888*D1**2*f**2*gd2*r*s + 2736*D1**2*f**2*gd2*s**2 + 3888*D1**2*f**2*gd2*s + 2448*D1**2*f**2*gdd2*r*s - 612*D1**2*f**2*gdd2*s**2 - 2448*D1**2*f**2*gdd2*s + 13296*D1**2*f*fd**2*r*s - 4432*D1**2*f*fd**2*r + 2832*D1**2*f*fd**2*s**2 - 6320*D1**2*f*fd**2*s + 2216*D1**2*f*fd**2 - 7776*D1**2*f*fd*g2*r*s + 3888*D1**2*f*fd*g2*r + 5472*D1**2*f*fd*g2*s**2 - 5472*D1**2*f*fd*g2*s + 2736*D1**2*f*fd*g2 + 9792*D1**2*f*fd*gd2*r*s - 2448*D1**2*f*fd*gd2*r - 2448*D1**2*f*fd*gd2*s**2 - 3672*D1**2*f*fd*gd2*s + 2448*D1**2*f*fd*gd2 + 4896*D1**2*f*fdd*g2*r*s - 2448*D1**2*f*fdd*g2*r - 1224*D1**2*f*fdd*g2*s**2 + 1224*D1**2*f*fdd*g2*s - 612*D1**2*f*fdd*g2 + 4896*D1**2*fd**2*g2*r*s - 2448*D1**2*fd**2*g2*r - 1224*D1**2*fd**2*g2*s**2 + 1224*D1**2*fd**2*g2*s + 5400*D1*Dd*f**4*r*s - 1350*D1*Dd*f**4*r + 6000*D1*Dd*f**4*s**2 - 5700*D1*Dd*f**4*s + 1500*D1*Dd*f**4 - 43200*D1*Dd*f**3*fd*r*s + 10800*D1*Dd*f**3*fd*r - 31200*D1*Dd*f**3*fd*s**2 + 37200*D1*Dd*f**3*fd*s - 7350*D1*Dd*f**3*fd - 13408*D1*Dd*f**3*r*s + 3352*D1*Dd*f**3*r - 320*D1*Dd*f**3*s**2 + 6864*D1*Dd*f**3*s - 80*D1*Dd*f**3 + 53184*D1*Dd*f**2*fd*r*s - 15512*D1*Dd*f**2*fd*r + 11328*D1*Dd*f**2*fd*s**2 - 28768*D1*Dd*f**2*fd*s + 7592*D1*Dd*f**2*fd - 15552*D1*Dd*f**2*g2*r*s + 3888*D1*Dd*f**2*g2*r + 10944*D1*Dd*f**2*g2*s**2 + 2304*D1*Dd*f**2*g2*s + 2736*D1*Dd*f**2*g2 + 19584*D1*Dd*f**2*gd2*r*s - 2448*D1*Dd*f**2*gd2*r - 4896*D1*Dd*f**2*gd2*s**2 - 13464*D1*Dd*f**2*gd2*s + 2448*D1*Dd*f**2*gd2 + 39168*D1*Dd*f*fd*g2*r*s - 14688*D1*Dd*f*fd*g2*r - 9792*D1*Dd*f*fd*g2*s**2 - 2448*D1*Dd*f*fd*g2*s + 3672*D1*Dd*f*fd*g2 - 5400*D1*Ddd*f**4*r*s + 1350*D1*Ddd*f**4*r - 3900*D1*Ddd*f**4*s**2 + 4650*D1*Ddd*f**4*s - 975*D1*Ddd*f**4 + 8864*D1*Ddd*f**3*r*s - 2216*D1*Ddd*f**3*r + 1888*D1*Ddd*f**3*s**2 - 5376*D1*Ddd*f**3*s + 472*D1*Ddd*f**3 + 9792*D1*Ddd*f**2*g2*r*s - 2448*D1*Ddd*f**2*g2*r - 2448*D1*Ddd*f**2*g2*s**2 - 3672*D1*Ddd*f**2*g2*s - 612*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(5*f**3*(18*s**2 + s*(68*r - 98) + 25) + 2*f**2*(18*C*(9*s**2 + s*(4*r - 10) + 5) - 25*fd*(4*r*(6*s - 1) + 9*s**2 - 22*s + 3) + 6*s**2*(19*K + 2) + 6*s*(-27*K*(r - 1) + 38*r - 20) - 90) + 6*f*(fd*(-108*C*s**2 + 96*C*s + 17*K*(r*(8*s - 2) - 2*s**2 - 3*s + 2) - r*(12*C + 52)*(4*s - 1) - 78*s**2 + 125*s - 64) - 14*g2*(9*s**2 + s*(4*r - 10) + 5) - 14*gd2*s*(-4*r - 9*s + 7)) + 84*fd*g2*(r*(4*s - 2) + s*(9*s - 9))) - Dd*f*(25*f**2*(8*r*(8*s - 1) + 24*s**2 - 66*s + 11) + 6*f*(6*C*(2*r*(8*s - 1) + 36*s**2 - 33*s + 5) + 17*K*(r*(2 - 16*s) + 4*s**2 + 11*s - 2) + 416*r*s - 52*r + 156*s**2 - 279*s + 34) - 84*g2*(2*r*(8*s - 1) + 36*s**2 - 33*s + 5))) - 16200*Dd**2*f**4*r*s + 4050*Dd**2*f**4*r - 11700*Dd**2*f**4*s**2 + 13950*Dd**2*f**4*s - 2700*Dd**2*f**4 + 26592*Dd**2*f**3*r*s - 6648*Dd**2*f**3*r + 5664*Dd**2*f**3*s**2 - 16128*Dd**2*f**3*s + 4432*Dd**2*f**3 + 29376*Dd**2*f**2*g2*r*s - 7344*Dd**2*f**2*g2*r - 7344*Dd**2*f**2*g2*s**2 - 11016*Dd**2*f**2*g2*s + 4896*Dd**2*f**2*g2 - 126*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(4*r*(s - 1) + 9*s**2 - 8*s + 4) + D1*(2*Dd*(f*(16*r*s - 4*r + 36*s**2 - 26*s + 9) + fd*(-16*r*s + 10*r - 36*s**2 + 29*s - 8)) + Ddd*f*(r*(4 - 16*s) - 36*s**2 + 26*s - 9)) - 2*Dd**2*f*(6*r*(4*s - 1) + 54*s**2 - 39*s + 4)) - 3*b1*(576*C*D1**2*f*fd*r*s - 288*C*D1**2*f*fd*r + 1296*C*D1**2*f*fd*s**2 - 864*C*D1**2*f*fd*s + 288*C*D1**2*f*fd - 288*C*D1**2*f*fdd*r*s + 144*C*D1**2*f*fdd*r - 648*C*D1**2*f*fdd*s**2 + 432*C*D1**2*f*fdd*s - 144*C*D1**2*f*fdd - 288*C*D1**2*fd**2*r*s + 144*C*D1**2*fd**2*r - 648*C*D1**2*fd**2*s**2 + 432*C*D1**2*fd**2*s - 144*C*D1**2*fd**2 + 1152*C*D1*Dd*f**2*r*s - 288*C*D1*Dd*f**2*r + 2592*C*D1*Dd*f**2*s**2 - 1872*C*D1*Dd*f**2*s + 648*C*D1*Dd*f**2 - 2304*C*D1*Dd*f*fd*r*s + 864*C*D1*Dd*f*fd*r - 5184*C*D1*Dd*f*fd*s**2 + 3600*C*D1*Dd*f*fd*s - 720*C*D1*Dd*f*fd - 576*C*D1*Ddd*f**2*r*s + 144*C*D1*Ddd*f**2*r - 1296*C*D1*Ddd*f**2*s**2 + 936*C*D1*Ddd*f**2*s - 324*C*D1*Ddd*f**2 - 1728*C*Dd**2*f**2*r*s + 432*C*Dd**2*f**2*r - 3888*C*Dd**2*f**2*s**2 + 2808*C*Dd**2*f**2*s - 288*C*Dd**2*f**2 - 1296*D1**2*K*f*fd*r*s + 648*D1**2*K*f*fd*r + 912*D1**2*K*f*fd*s**2 - 912*D1**2*K*f*fd*s + 456*D1**2*K*f*fd + 816*D1**2*K*f*fdd*r*s - 408*D1**2*K*f*fdd*r - 204*D1**2*K*f*fdd*s**2 + 204*D1**2*K*f*fdd*s - 102*D1**2*K*f*fdd + 816*D1**2*K*fd**2*r*s - 408*D1**2*K*fd**2*r - 204*D1**2*K*fd**2*s**2 + 204*D1**2*K*fd**2*s - 42*D1**2*bdd1*f*(K - 1)*(8*r*s + 18*s**2 - 14*s + 5) + 2040*D1**2*f**2*fd*r*s - 680*D1**2*f**2*fd*r + 540*D1**2*f**2*fd*s**2 - 740*D1**2*f**2*fd*s - 70*D1**2*f**2*fd - 1200*D1**2*f**2*fdd*r*s + 400*D1**2*f**2*fdd*r - 450*D1**2*f**2*fdd*s**2 + 550*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 2400*D1**2*f*fd**2*r*s + 800*D1**2*f*fd**2*r - 900*D1**2*f*fd**2*s**2 + 1100*D1**2*f*fd**2*s - 500*D1**2*f*fd**2 + 1824*D1**2*f*fd*r*s - 912*D1**2*f*fd*r + 96*D1**2*f*fd*s**2 - 528*D1**2*f*fd*s + 408*D1**2*f*fd - 1248*D1**2*f*fdd*r*s + 624*D1**2*f*fdd*r - 468*D1**2*f*fdd*s**2 + 684*D1**2*f*fdd*s - 414*D1**2*f*fdd - 672*D1**2*f*gd2*r*s - 1512*D1**2*f*gd2*s**2 + 672*D1**2*f*gd2*s + 336*D1**2*f*gdd2*r*s + 756*D1**2*f*gdd2*s**2 - 336*D1**2*f*gdd2*s - 1248*D1**2*fd**2*r*s + 624*D1**2*fd**2*r - 468*D1**2*fd**2*s**2 + 684*D1**2*fd**2*s + 144*D1**2*fd**2 - 672*D1**2*fd*g2*r*s + 672*D1**2*fd*g2*r - 1512*D1**2*fd*g2*s**2 + 1344*D1**2*fd*g2*s - 672*D1**2*fd*g2 + 672*D1**2*fd*gd2*r*s - 336*D1**2*fd*gd2*r + 1512*D1**2*fd*gd2*s**2 - 1008*D1**2*fd*gd2*s + 336*D1**2*fd*gd2 + 336*D1**2*fdd*g2*r*s - 336*D1**2*fdd*g2*r + 756*D1**2*fdd*g2*s**2 - 672*D1**2*fdd*g2*s + 336*D1**2*fdd*g2 - 2592*D1*Dd*K*f**2*r*s + 648*D1*Dd*K*f**2*r + 1824*D1*Dd*K*f**2*s**2 + 384*D1*Dd*K*f**2*s + 456*D1*Dd*K*f**2 + 6528*D1*Dd*K*f*fd*r*s - 2448*D1*Dd*K*f*fd*r - 1632*D1*Dd*K*f*fd*s**2 - 408*D1*Dd*K*f*fd*s + 612*D1*Dd*K*f*fd + 2720*D1*Dd*f**3*r*s - 680*D1*Dd*f**3*r + 720*D1*Dd*f**3*s**2 - 1720*D1*Dd*f**3*s + 180*D1*Dd*f**3 - 9600*D1*Dd*f**2*fd*r*s + 2800*D1*Dd*f**2*fd*r - 3600*D1*Dd*f**2*fd*s**2 + 5500*D1*Dd*f**2*fd*s - 1350*D1*Dd*f**2*fd + 3648*D1*Dd*f**2*r*s - 912*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 1920*D1*Dd*f**2*s + 48*D1*Dd*f**2 - 9984*D1*Dd*f*fd*r*s + 3744*D1*Dd*f*fd*r - 3744*D1*Dd*f*fd*s**2 + 6168*D1*Dd*f*fd*s - 1932*D1*Dd*f*fd - 2688*D1*Dd*f*g2*r*s + 672*D1*Dd*f*g2*r - 6048*D1*Dd*f*g2*s**2 + 4368*D1*Dd*f*g2*s - 1512*D1*Dd*f*g2 + 2688*D1*Dd*f*gd2*r*s - 336*D1*Dd*f*gd2*r + 6048*D1*Dd*f*gd2*s**2 - 3528*D1*Dd*f*gd2*s + 336*D1*Dd*f*gd2 + 2688*D1*Dd*fd*g2*r*s - 1680*D1*Dd*fd*g2*r + 6048*D1*Dd*fd*g2*s**2 - 4872*D1*Dd*fd*g2*s + 1344*D1*Dd*fd*g2 + 1632*D1*Ddd*K*f**2*r*s - 408*D1*Ddd*K*f**2*r - 408*D1*Ddd*K*f**2*s**2 - 612*D1*Ddd*K*f**2*s - 102*D1*Ddd*K*f**2 - 1600*D1*Ddd*f**3*r*s + 400*D1*Ddd*f**3*r - 600*D1*Ddd*f**3*s**2 + 1100*D1*Ddd*f**3*s - 150*D1*Ddd*f**3 - 2496*D1*Ddd*f**2*r*s + 624*D1*Ddd*f**2*r - 936*D1*Ddd*f**2*s**2 + 1716*D1*Ddd*f**2*s - 234*D1*Ddd*f**2 + 1344*D1*Ddd*f*g2*r*s - 336*D1*Ddd*f*g2*r + 3024*D1*Ddd*f*g2*s**2 - 2184*D1*Ddd*f*g2*s + 756*D1*Ddd*f*g2 + 84*D1*bd1*(K - 1)*(D1*(f*(8*r*s + 18*s**2 - 14*s + 5) + fd*(-8*r*s + 4*r - 18*s**2 + 15*s - 2)) + Dd*f*(r*(4 - 32*s) - 72*s**2 + 54*s - 7)) + 4896*Dd**2*K*f**2*r*s - 1224*Dd**2*K*f**2*r - 1224*Dd**2*K*f**2*s**2 - 1836*Dd**2*K*f**2*s + 816*Dd**2*K*f**2 - 4800*Dd**2*f**3*r*s + 1200*Dd**2*f**3*r - 1800*Dd**2*f**3*s**2 + 3300*Dd**2*f**3*s - 800*Dd**2*f**3 - 7488*Dd**2*f**2*r*s + 1872*Dd**2*f**2*r - 2808*Dd**2*f**2*s**2 + 5148*Dd**2*f**2*s - 1248*Dd**2*f**2 + 4032*Dd**2*f*g2*r*s - 1008*Dd**2*f*g2*r + 9072*Dd**2*f*g2*s**2 - 6552*Dd**2*f*g2*s + 672*Dd**2*f*g2))/(630*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**4*k1**2*k2*(-792*C*D1**2*bdd1*f**2*r*s + 1512*C*D1**2*bdd1*f**2*r + 90*C*D1**2*bdd1*f**2*s**2 + 1260*C*D1**2*bdd1*f**2*s - 630*C*D1**2*bdd1*f**2 + 5520*C*D1**2*f**2*fd*r*s - 1840*C*D1**2*f**2*fd*r + 14460*C*D1**2*f**2*fd*s**2 - 11480*C*D1**2*f**2*fd*s + 4820*C*D1**2*f**2*fd - 6000*C*D1**2*f**2*fdd*r*s + 2000*C*D1**2*f**2*fdd*r - 11550*C*D1**2*f**2*fdd*s**2 + 9700*C*D1**2*f**2*fdd*s - 3850*C*D1**2*f**2*fdd - 12000*C*D1**2*f*fd**2*r*s + 4000*C*D1**2*f*fd**2*r - 23100*C*D1**2*f*fd**2*s**2 + 19400*C*D1**2*f*fd**2*s - 2000*C*D1**2*f*fd**2 + 7360*C*D1*Dd*f**3*r*s - 1840*C*D1*Dd*f**3*r + 19280*C*D1*Dd*f**3*s**2 - 13320*C*D1*Dd*f**3*s + 4820*C*D1*Dd*f**3 - 48000*C*D1*Dd*f**2*fd*r*s + 14000*C*D1*Dd*f**2*fd*r - 92400*C*D1*Dd*f**2*fd*s**2 + 73900*C*D1*Dd*f**2*fd*s - 13700*C*D1*Dd*f**2*fd - 8000*C*D1*Ddd*f**3*r*s + 2000*C*D1*Ddd*f**3*r - 15400*C*D1*Ddd*f**3*s**2 + 11700*C*D1*Ddd*f**3*s - 3850*C*D1*Ddd*f**3 - 24000*C*Dd**2*f**3*r*s + 6000*C*Dd**2*f**3*r - 46200*C*Dd**2*f**3*s**2 + 35100*C*Dd**2*f**3*s - 4000*C*Dd**2*f**3 - 1224*D1**2*K*bdd1*f**2*r*s - 2619*D1**2*K*bdd1*f**2*s**2 + 1224*D1**2*K*bdd1*f**2*s + 1152*D1**2*b2*f*fd*r*s - 576*D1**2*b2*f*fd*r + 1152*D1**2*b2*f*fd*s**2 - 1152*D1**2*b2*f*fd*s + 576*D1**2*b2*f*fd - 1080*D1**2*b2*f*fdd*r*s + 540*D1**2*b2*f*fdd*r - 1080*D1**2*b2*f*fdd*s**2 + 1080*D1**2*b2*f*fdd*s - 540*D1**2*b2*f*fdd - 1080*D1**2*b2*fd**2*r*s + 540*D1**2*b2*fd**2*r - 1080*D1**2*b2*fd**2*s**2 + 1080*D1**2*b2*fd**2*s + 6*D1**2*bd1**2*(15*f**2*(8*r*(s - 1) + 5*s**2 - 15*s + 6) - 7*f*(-24*C*s**2 + 24*C*s + K*(r*(20*s - 22) + s**2 - 35*s + 22) - 4*r*(6*C*s - 3*C + 11*s - 7) - 31*s**2 + 77*s - 40) - 140*g2*(r*(2*s - 1) + s*(2*s - 2))) + 576*D1**2*bd2*f**2*r*s + 576*D1**2*bd2*f**2*s**2 - 576*D1**2*bd2*f**2*s - 2160*D1**2*bd2*f*fd*r*s + 540*D1**2*bd2*f*fd*r - 2160*D1**2*bd2*f*fd*s**2 + 2160*D1**2*bd2*f*fd*s - 540*D1**2*bd2*f*fd + 810*D1**2*bdd1*f**3*r + 810*D1**2*bdd1*f**3*s**2 - 405*D1**2*bdd1*f**3 + 1854*D1**2*bdd1*f**2*r*s - 2052*D1**2*bdd1*f**2*r + 1782*D1**2*bdd1*f**2*s**2 - 2862*D1**2*bdd1*f**2*s + 1260*D1**2*bdd1*f**2 + 840*D1**2*bdd1*f*g2*r*s - 1848*D1**2*bdd1*f*g2*r + 42*D1**2*bdd1*f*g2*s**2 - 2100*D1**2*bdd1*f*g2*s + 1050*D1**2*bdd1*f*g2 - 540*D1**2*bdd2*f**2*r*s - 540*D1**2*bdd2*f**2*s**2 + 540*D1**2*bdd2*f**2*s - 1800*D1**2*f**2*fd*r*s + 600*D1**2*f**2*fd*r - 9150*D1**2*f**2*fd*s**2 + 6700*D1**2*f**2*fd*s - 3050*D1**2*f**2*fd + 3870*D1**2*f**2*fdd*r*s - 1290*D1**2*f**2*fdd*r + 8085*D1**2*f**2*fdd*s**2 - 6680*D1**2*f**2*fdd*s + 2695*D1**2*f**2*fdd - 1872*D1**2*f**2*gd2*r*s - 6444*D1**2*f**2*gd2*s**2 + 1872*D1**2*f**2*gd2*s + 2448*D1**2*f**2*gdd2*r*s + 5238*D1**2*f**2*gdd2*s**2 - 2448*D1**2*f**2*gdd2*s + 7740*D1**2*f*fd**2*r*s - 2580*D1**2*f*fd**2*r + 16170*D1**2*f*fd**2*s**2 - 13360*D1**2*f*fd**2*s + 1290*D1**2*f*fd**2 - 3744*D1**2*f*fd*g2*r*s + 1872*D1**2*f*fd*g2*r - 12888*D1**2*f*fd*g2*s**2 + 12888*D1**2*f*fd*g2*s - 6444*D1**2*f*fd*g2 + 9792*D1**2*f*fd*gd2*r*s - 2448*D1**2*f*fd*gd2*r + 20952*D1**2*f*fd*gd2*s**2 - 15372*D1**2*f*fd*gd2*s + 2448*D1**2*f*fd*gd2 + 4896*D1**2*f*fdd*g2*r*s - 2448*D1**2*f*fdd*g2*r + 10476*D1**2*f*fdd*g2*s**2 - 10476*D1**2*f*fdd*g2*s + 5238*D1**2*f*fdd*g2 + 4896*D1**2*fd**2*g2*r*s - 2448*D1**2*fd**2*g2*r + 10476*D1**2*fd**2*g2*s**2 - 10476*D1**2*fd**2*g2*s + 2304*D1*Dd*b2*f**2*r*s - 576*D1*Dd*b2*f**2*r + 2304*D1*Dd*b2*f**2*s**2 - 2304*D1*Dd*b2*f**2*s + 576*D1*Dd*b2*f**2 - 8640*D1*Dd*b2*f*fd*r*s + 3240*D1*Dd*b2*f*fd*r - 8640*D1*Dd*b2*f*fd*s**2 + 8640*D1*Dd*b2*f*fd*s - 2160*D1*Dd*b2*f*fd - 4320*D1*Dd*bd2*f**2*r*s + 540*D1*Dd*bd2*f**2*r - 4320*D1*Dd*bd2*f**2*s**2 + 4320*D1*Dd*bd2*f**2*s - 540*D1*Dd*bd2*f**2 - 2400*D1*Dd*f**3*r*s + 600*D1*Dd*f**3*r - 12200*D1*Dd*f**3*s**2 + 7300*D1*Dd*f**3*s - 3050*D1*Dd*f**3 + 30960*D1*Dd*f**2*fd*r*s - 9030*D1*Dd*f**2*fd*r + 64680*D1*Dd*f**2*fd*s**2 - 50630*D1*Dd*f**2*fd*s + 9260*D1*Dd*f**2*fd - 7488*D1*Dd*f**2*g2*r*s + 1872*D1*Dd*f**2*g2*r - 25776*D1*Dd*f**2*g2*s**2 + 16632*D1*Dd*f**2*g2*s - 6444*D1*Dd*f**2*g2 + 19584*D1*Dd*f**2*gd2*r*s - 2448*D1*Dd*f**2*gd2*r + 41904*D1*Dd*f**2*gd2*s**2 - 25164*D1*Dd*f**2*gd2*s + 2448*D1*Dd*f**2*gd2 + 39168*D1*Dd*f*fd*g2*r*s - 14688*D1*Dd*f*fd*g2*r + 83808*D1*Dd*f*fd*g2*s**2 - 72648*D1*Dd*f*fd*g2*s + 15372*D1*Dd*f*fd*g2 - 2160*D1*Ddd*b2*f**2*r*s + 540*D1*Ddd*b2*f**2*r - 2160*D1*Ddd*b2*f**2*s**2 + 2160*D1*Ddd*b2*f**2*s - 540*D1*Ddd*b2*f**2 + 5160*D1*Ddd*f**3*r*s - 1290*D1*Ddd*f**3*r + 10780*D1*Ddd*f**3*s**2 - 7970*D1*Ddd*f**3*s + 2695*D1*Ddd*f**3 + 9792*D1*Ddd*f**2*g2*r*s - 2448*D1*Ddd*f**2*g2*r + 20952*D1*Ddd*f**2*g2*s**2 - 15372*D1*Ddd*f**2*g2*s + 5238*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(15*f**3*(r*(6*s - 9) - 6*s**2 - 7*s + 6) + 3*f**2*(4*C*(r*(36*s - 35) + 8*s**2 - 14*s + 7) + 52*K*r*s + 179*K*s**2 - 52*K*s + 45*fd*(2*r + 6*s**2 - 2*s - 1) - 164*r*s + 186*r - 142*s**2 + 136*s - 84) + f*(-3*fd*(4*C*(4*r*(11*s - 8) - 5*s**2 - 26*s + 21) + K*(68*r*(4*s - 1) + 582*s**2 - 427*s + 68) - 412*r*s + 217*r - 396*s**2 + 460*s - 133) - 28*g2*(r*(20*s - 17) + 8*s**2 - 10*s + 5) + 14*gd2*(r*(20*s - 22) + s**2 - 35*s + 22)) + 14*fd*g2*(10*r*(2*s - 1) + s*(s - 1))) + Dd*f*(270*f**2*(2*r + 4*s**2 - s - 1) - 3*f*(C*(4*r*(88*s - 95) - 40*s**2 - 358*s + 238) + K*(68*r*(8*s - 1) + 1164*s**2 - 699*s + 68) - 824*r*s + 559*r - 792*s**2 + 1040*s - 387) + 14*g2*(r*(80*s - 98) + 4*s**2 - 121*s + 69))) - 6480*Dd**2*b2*f**2*r*s + 1620*Dd**2*b2*f**2*r - 6480*Dd**2*b2*f**2*s**2 + 6480*Dd**2*b2*f**2*s - 1080*Dd**2*b2*f**2 + 15480*Dd**2*f**3*r*s - 3870*Dd**2*f**3*r + 32340*Dd**2*f**3*s**2 - 23910*Dd**2*f**3*s + 2580*Dd**2*f**3 + 29376*Dd**2*f**2*g2*r*s - 7344*Dd**2*f**2*g2*r + 62856*Dd**2*f**2*g2*s**2 - 46116*Dd**2*f**2*g2*s + 4896*Dd**2*f**2*g2 - 420*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) - 3*b1**2*(336*C*D1**2*fd*r*s + 336*C*D1**2*fd*s**2 - 336*C*D1**2*fd*s - 168*C*D1**2*fdd*r*s - 168*C*D1**2*fdd*s**2 + 168*C*D1**2*fdd*s + 1344*C*D1*Dd*f*r*s - 336*C*D1*Dd*f*r + 1344*C*D1*Dd*f*s**2 - 1344*C*D1*Dd*f*s + 336*C*D1*Dd*f - 1344*C*D1*Dd*fd*r*s + 168*C*D1*Dd*fd*r - 1344*C*D1*Dd*fd*s**2 + 1344*C*D1*Dd*fd*s - 168*C*D1*Dd*fd - 672*C*D1*Ddd*f*r*s + 168*C*D1*Ddd*f*r - 672*C*D1*Ddd*f*s**2 + 672*C*D1*Ddd*f*s - 168*C*D1*Ddd*f - 2016*C*Dd**2*f*r*s + 504*C*Dd**2*f*r - 2016*C*Dd**2*f*s**2 + 2016*C*Dd**2*f*s - 336*C*Dd**2*f - 560*D1**2*K*fd*r*s + 84*D1**2*K*fd*r - 224*D1**2*K*fd*s**2 + 168*D1**2*K*fd*s - 84*D1**2*K*fd + 140*D1**2*K*fdd*r*s + 168*D1**2*K*fdd*r + 7*D1**2*K*fdd*s**2 + 336*D1**2*K*fdd*s - 168*D1**2*K*fdd - 140*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 480*D1**2*f*fd*r*s + 156*D1**2*f*fd*r + 300*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s - 156*D1**2*f*fd - 240*D1**2*f*fdd*r*s - 120*D1**2*f*fdd*r - 150*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s + 120*D1**2*f*fdd - 240*D1**2*fd**2*r*s - 120*D1**2*fd**2*r - 150*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s + 120*D1**2*fd**2 + 616*D1**2*fd*r*s - 112*D1**2*fd*r + 364*D1**2*fd*s**2 + 112*D1**2*fd*s + 112*D1**2*fd - 308*D1**2*fdd*r*s - 84*D1**2*fdd*r - 217*D1**2*fdd*s**2 - 336*D1**2*fdd*s + 84*D1**2*fdd - 560*D1**2*gd2*r*s - 560*D1**2*gd2*s**2 + 560*D1**2*gd2*s + 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*s**2 - 280*D1**2*gdd2*s - 2240*D1*Dd*K*f*r*s + 560*D1*Dd*K*f*r - 896*D1*Dd*K*f*s**2 + 1568*D1*Dd*K*f*s - 224*D1*Dd*K*f + 1120*D1*Dd*K*fd*r*s + 532*D1*Dd*K*fd*r + 56*D1*Dd*K*fd*s**2 + 1050*D1*Dd*K*fd*s - 672*D1*Dd*K*fd + 960*D1*Dd*f**2*r*s - 240*D1*Dd*f**2*r + 600*D1*Dd*f**2*s**2 - 780*D1*Dd*f**2*s + 150*D1*Dd*f**2 - 1920*D1*Dd*f*fd*r*s - 240*D1*Dd*f*fd*r - 1200*D1*Dd*f*fd*s**2 + 540*D1*Dd*f*fd*s + 300*D1*Dd*f*fd + 2464*D1*Dd*f*r*s - 616*D1*Dd*f*r + 1456*D1*Dd*f*s**2 - 1960*D1*Dd*f*s + 364*D1*Dd*f - 2464*D1*Dd*fd*r*s - 28*D1*Dd*fd*r - 1736*D1*Dd*fd*s**2 - 294*D1*Dd*fd*s + 504*D1*Dd*fd - 2240*D1*Dd*g2*r*s + 560*D1*Dd*g2*r - 2240*D1*Dd*g2*s**2 + 2240*D1*Dd*g2*s - 560*D1*Dd*g2 + 2240*D1*Dd*gd2*r*s - 280*D1*Dd*gd2*r + 2240*D1*Dd*gd2*s**2 - 2240*D1*Dd*gd2*s + 280*D1*Dd*gd2 + 560*D1*Ddd*K*f*r*s - 140*D1*Ddd*K*f*r + 28*D1*Ddd*K*f*s**2 - 294*D1*Ddd*K*f*s + 7*D1*Ddd*K*f - 480*D1*Ddd*f**2*r*s + 120*D1*Ddd*f**2*r - 300*D1*Ddd*f**2*s**2 + 390*D1*Ddd*f**2*s - 75*D1*Ddd*f**2 - 1232*D1*Ddd*f*r*s + 308*D1*Ddd*f*r - 868*D1*Ddd*f*s**2 + 1050*D1*Ddd*f*s - 217*D1*Ddd*f + 1120*D1*Ddd*g2*r*s - 280*D1*Ddd*g2*r + 1120*D1*Ddd*g2*s**2 - 1120*D1*Ddd*g2*s + 280*D1*Ddd*g2 + 140*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 1680*Dd**2*K*f*r*s - 420*Dd**2*K*f*r + 84*Dd**2*K*f*s**2 - 882*Dd**2*K*f*s + 280*Dd**2*K*f - 1440*Dd**2*f**2*r*s + 360*Dd**2*f**2*r - 900*Dd**2*f**2*s**2 + 1170*Dd**2*f**2*s - 240*Dd**2*f**2 - 3696*Dd**2*f*r*s + 924*Dd**2*f*r - 2604*Dd**2*f*s**2 + 3150*Dd**2*f*s - 616*Dd**2*f + 3360*Dd**2*g2*r*s - 840*Dd**2*g2*r + 3360*Dd**2*g2*s**2 - 3360*Dd**2*g2*s + 560*Dd**2*g2) + 3*b1*(1728*C*D1**2*f*fd*r*s - 24*C*D1**2*f*fd*r + 384*C*D1**2*f*fd*s**2 - 912*C*D1**2*f*fd*s + 24*C*D1**2*f*fd - 528*C*D1**2*f*fdd*r*s - 240*C*D1**2*f*fdd*r + 60*C*D1**2*f*fdd*s**2 - 216*C*D1**2*f*fdd*s + 240*C*D1**2*f*fdd - 528*C*D1**2*fd**2*r*s - 240*C*D1**2*fd**2*r + 60*C*D1**2*fd**2*s**2 - 216*C*D1**2*fd**2*s + 240*C*D1**2*fd**2 + 3456*C*D1*Dd*f**2*r*s - 864*C*D1*Dd*f**2*r + 768*C*D1*Dd*f**2*s**2 - 2112*C*D1*Dd*f**2*s + 192*C*D1*Dd*f**2 - 4224*C*D1*Dd*f*fd*r*s - 432*C*D1*Dd*f*fd*r + 480*C*D1*Dd*f*fd*s**2 + 72*C*D1*Dd*f*fd*s + 696*C*D1*Dd*f*fd - 1056*C*D1*Ddd*f**2*r*s + 264*C*D1*Ddd*f**2*r + 120*C*D1*Ddd*f**2*s**2 + 468*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 - 3168*C*Dd**2*f**2*r*s + 792*C*Dd**2*f**2*r + 360*C*Dd**2*f**2*s**2 + 1404*C*Dd**2*f**2*s - 528*C*Dd**2*f**2 + 624*D1**2*K*f*fd*r*s - 312*D1**2*K*f*fd*r + 2148*D1**2*K*f*fd*s**2 - 2148*D1**2*K*f*fd*s + 1074*D1**2*K*f*fd - 816*D1**2*K*f*fdd*r*s + 408*D1**2*K*f*fdd*r - 1746*D1**2*K*f*fdd*s**2 + 1746*D1**2*K*f*fdd*s - 873*D1**2*K*f*fdd - 816*D1**2*K*fd**2*r*s + 408*D1**2*K*fd**2*r - 1746*D1**2*K*fd**2*s**2 + 1746*D1**2*K*fd**2*s + 140*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(15*f**2*(16*r*(s - 1) + 10*s**2 - 30*s + 13) + 7*f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-40*r*s + 44*r - 2*s**2 + 70*s - 25) + 88*r*s - 56*r + 62*s**2 - 154*s + 43) - 280*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 540*D1**2*f**2*fd*r*s + 90*D1**2*f**2*fd*r - 540*D1**2*f**2*fd*s**2 + 210*D1**2*f**2*fd*s - 360*D1**2*f**2*fd - 270*D1**2*f**2*fdd*r + 810*D1**2*f**2*fdd*s**2 - 540*D1**2*f**2*fdd*s + 405*D1**2*f**2*fdd - 540*D1**2*f*fd**2*r + 1620*D1**2*f*fd**2*s**2 - 1080*D1**2*f*fd**2*s + 270*D1**2*f*fd**2 - 1968*D1**2*f*fd*r*s - 132*D1**2*f*fd*r - 1704*D1**2*f*fd*s**2 + 1872*D1**2*f*fd*s - 348*D1**2*f*fd + 1236*D1**2*f*fdd*r*s + 66*D1**2*f*fdd*r + 1188*D1**2*f*fdd*s**2 - 852*D1**2*f*fdd*s + 174*D1**2*f*fdd - 1120*D1**2*f*gd2*r*s - 448*D1**2*f*gd2*s**2 + 1120*D1**2*f*gd2*s + 280*D1**2*f*gdd2*r*s + 14*D1**2*f*gdd2*s**2 - 280*D1**2*f*gdd2*s + 1236*D1**2*fd**2*r*s + 66*D1**2*fd**2*r + 1188*D1**2*fd**2*s**2 - 852*D1**2*fd**2*s - 180*D1**2*fd**2 - 1120*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*r - 448*D1**2*fd*g2*s**2 + 336*D1**2*fd*g2*s - 168*D1**2*fd*g2 + 560*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 + 392*D1**2*fd*gd2*s - 336*D1**2*fd*gd2 + 280*D1**2*fdd*g2*r*s + 336*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 + 672*D1**2*fdd*g2*s - 336*D1**2*fdd*g2 + 1248*D1*Dd*K*f**2*r*s - 312*D1*Dd*K*f**2*r + 4296*D1*Dd*K*f**2*s**2 - 2772*D1*Dd*K*f**2*s + 1074*D1*Dd*K*f**2 - 6528*D1*Dd*K*f*fd*r*s + 2448*D1*Dd*K*f*fd*r - 13968*D1*Dd*K*f*fd*s**2 + 12108*D1*Dd*K*f*fd*s - 2562*D1*Dd*K*f*fd + 720*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r - 720*D1*Dd*f**3*s**2 - 180*D1*Dd*f**3 - 1080*D1*Dd*f**2*fd*r + 6480*D1*Dd*f**2*fd*s**2 - 3780*D1*Dd*f**2*fd*s + 1080*D1*Dd*f**2*fd - 3936*D1*Dd*f**2*r*s + 984*D1*Dd*f**2*r - 3408*D1*Dd*f**2*s**2 + 3672*D1*Dd*f**2*s - 852*D1*Dd*f**2 + 9888*D1*Dd*f*fd*r*s - 972*D1*Dd*f*fd*r + 9504*D1*Dd*f*fd*s**2 - 8256*D1*Dd*f*fd*s + 720*D1*Dd*f*fd - 4480*D1*Dd*f*g2*r*s + 1120*D1*Dd*f*g2*r - 1792*D1*Dd*f*g2*s**2 + 3136*D1*Dd*f*g2*s - 448*D1*Dd*f*g2 + 2240*D1*Dd*f*gd2*r*s - 280*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 1708*D1*Dd*f*gd2*s + 280*D1*Dd*f*gd2 + 2240*D1*Dd*fd*g2*r*s + 1064*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 + 2100*D1*Dd*fd*g2*s - 1344*D1*Dd*fd*g2 - 1632*D1*Ddd*K*f**2*r*s + 408*D1*Ddd*K*f**2*r - 3492*D1*Ddd*K*f**2*s**2 + 2562*D1*Ddd*K*f**2*s - 873*D1*Ddd*K*f**2 + 1080*D1*Ddd*f**3*s**2 - 540*D1*Ddd*f**3*s + 270*D1*Ddd*f**3 + 2472*D1*Ddd*f**2*r*s - 618*D1*Ddd*f**2*r + 2376*D1*Ddd*f**2*s**2 - 2424*D1*Ddd*f**2*s + 594*D1*Ddd*f**2 + 1120*D1*Ddd*f*g2*r*s - 280*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 588*D1*Ddd*f*g2*s + 14*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(3*f**2*(r*(80*s - 66) + 50*s**2 - 122*s + 51) + 2*f*(84*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 7*K*(40*r*s - 17*r + 16*s**2 - 30*s + 5) - 15*fd*(4*r*(4*s - 1) + 10*s**2 - 13*s + 3) + 308*r*s - 126*r + 182*s**2 - 364*s + 63) - 7*fd*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(40*r*s + 2*r + 2*s**2 + 13*s - 12) + 88*r*s - 16*r + 62*s**2 - 29*s - 18) - 140*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 140*gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*(-15*f**2*(8*r*(8*s - 5) + 40*s**2 - 86*s + 31) - 7*f*(24*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + K*(-160*r*s + 108*r - 8*s**2 + 182*s - 79) + 352*r*s - 156*r + 248*s**2 - 458*s + 133) + 280*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 4896*Dd**2*K*f**2*r*s + 1224*Dd**2*K*f**2*r - 10476*Dd**2*K*f**2*s**2 + 7686*Dd**2*K*f**2*s - 816*Dd**2*K*f**2 + 3240*Dd**2*f**3*s**2 - 1620*Dd**2*f**3*s + 7416*Dd**2*f**2*r*s - 1854*Dd**2*f**2*r + 7128*Dd**2*f**2*s**2 - 7272*Dd**2*f**2*s + 1236*Dd**2*f**2 + 3360*Dd**2*f*g2*r*s - 840*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 1764*Dd**2*f*g2*s + 560*Dd**2*f*g2))/(630*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**4*k1**2*st**2*(D1**2*(504*bd1*fd*g2*s*(s - 1) + f**3*s**2*(450*bd1 - 225*bdd1) - 2*f**2*(25*fd*(s**2*(27*bd1 - 12) + s*(8 - 9*bd1) - 4) + 50*fdd*(3*s**2 - 2*s + 1) + s**2*(3*C + 2)*(-36*bd1 + 18*bdd1)) - 4*f*s*(63*bd1**2*s*(K - 1) + 18*bd1*(fd*(3*C + 2)*(2*s - 1) + s*(7*g2 - 7*gd2)) - 63*bdd1*g2*s + 50*fd**2*(3*s - 2))) - 2*D1*f*(Dd*(252*bd1*g2*s*(1 - 4*s) + 25*f**2*(s**2*(36*bd1 - 16) + s*(8 - 9*bd1) - 4) + 4*f*(4*s - 1)*(9*bd1*s*(3*C + 2) + 25*fd*(3*s - 1))) + 50*Ddd*f**2*(4*s**2 - 2*s + 1)) + 600*Dd**2*f**3*s*(1 - 2*s) + 126*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 9*b1*(D1**2*(25*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) - 2*f*(25*fd**2*s*(3*s - 2) - fd*(12*C + 8)*(2*s**2 - 2*s + 1) + fdd*(6*C + 4)*(2*s**2 - 2*s + 1) + s**2*(14*K*bdd1 - 28*bd1*(K - 1) - 14*bdd1 + 28*gd2 - 14*gdd2)) - (4*s - 4)*(fd**2*s*(6*C + 4) + 14*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(25*f**3*(4*s**2 - 2*s + 1) + f**2*(12*C*(4*s**2 - 2*s + 1) - 25*fd*(12*s**2 - 7*s + 1) + 32*s**2 - 16*s + 8) - 4*f*(fd*(3*C + 2)*(8*s**2 - 6*s + 1) + 7*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(7*K*bd1 - 7*bd1 - 7*gd2)) + 28*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(25*f**2 + f*(12*C + 8) - 28*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(25*f**2 + f*(12*C + 8) - 28*g2)))/(70*d**2*k2*k3**2) + D1**2*Pk3*Pkd2*ct**4*k1**2*(990*C*D1**2*bdd1*f**2*s**2 - 2100*C*D1**2*f**2*fd*s**2 + 1400*C*D1**2*f**2*fd*s - 700*C*D1**2*f**2*fd + 1050*C*D1**2*f**2*fdd*s**2 - 700*C*D1**2*f**2*fdd*s + 350*C*D1**2*f**2*fdd + 2100*C*D1**2*f*fd**2*s**2 - 1400*C*D1**2*f*fd**2*s - 2800*C*D1*Dd*f**3*s**2 + 1400*C*D1*Dd*f**3*s - 700*C*D1*Dd*f**3 + 8400*C*D1*Dd*f**2*fd*s**2 - 4900*C*D1*Dd*f**2*fd*s + 700*C*D1*Dd*f**2*fd + 1400*C*D1*Ddd*f**3*s**2 - 700*C*D1*Ddd*f**3*s + 350*C*D1*Ddd*f**3 + 4200*C*Dd**2*f**3*s**2 - 2100*C*Dd**2*f**3*s + 225*D1**2*K*bdd1*f**2*s**2 - 900*D1**2*b2*f*fd*s**2 + 900*D1**2*b2*f*fd*s - 450*D1**2*b2*f*fd + 450*D1**2*b2*f*fdd*s**2 - 450*D1**2*b2*f*fdd*s + 225*D1**2*b2*f*fdd + 450*D1**2*b2*fd**2*s**2 - 450*D1**2*b2*fd**2*s - 6*D1**2*bd1**2*s*(210*C*f*(s - 1) + 75*f**2*(2*s - 3) - 259*f*s*(K - 1) - 350*g2*(s - 1)) - 450*D1**2*bd2*f**2*s**2 + 900*D1**2*bd2*f*fd*s**2 - 450*D1**2*bd2*f*fd*s + 540*D1**2*bdd1*f**3*r*s + 1215*D1**2*bdd1*f**3*s**2 - 270*D1**2*bdd1*f**3*s + 342*D1**2*bdd1*f**2*r*s - 378*D1**2*bdd1*f**2*s**2 + 558*D1**2*bdd1*f**2*s - 450*D1**2*bdd1*f**2 - 1554*D1**2*bdd1*f*g2*s**2 + 225*D1**2*bdd2*f**2*s**2 - 1200*D1**2*f**2*fd*r*s + 400*D1**2*f**2*fd*r - 3030*D1**2*f**2*fd*s**2 + 2420*D1**2*f**2*fd*s - 1010*D1**2*f**2*fd + 870*D1**2*f**2*fdd*r*s - 290*D1**2*f**2*fdd*r + 1785*D1**2*f**2*fdd*s**2 - 1480*D1**2*f**2*fdd*s + 595*D1**2*f**2*fdd + 900*D1**2*f**2*gd2*s**2 - 450*D1**2*f**2*gdd2*s**2 + 1740*D1**2*f*fd**2*r*s - 580*D1**2*f*fd**2*r + 3570*D1**2*f*fd**2*s**2 - 2960*D1**2*f*fd**2*s + 290*D1**2*f*fd**2 + 1800*D1**2*f*fd*g2*s**2 - 1800*D1**2*f*fd*g2*s + 900*D1**2*f*fd*g2 - 1800*D1**2*f*fd*gd2*s**2 + 900*D1**2*f*fd*gd2*s - 900*D1**2*f*fdd*g2*s**2 + 900*D1**2*f*fdd*g2*s - 450*D1**2*f*fdd*g2 - 900*D1**2*fd**2*g2*s**2 + 900*D1**2*fd**2*g2*s - 1800*D1*Dd*b2*f**2*s**2 + 900*D1*Dd*b2*f**2*s - 450*D1*Dd*b2*f**2 + 3600*D1*Dd*b2*f*fd*s**2 - 2700*D1*Dd*b2*f*fd*s + 450*D1*Dd*b2*f*fd + 1800*D1*Dd*bd2*f**2*s**2 - 450*D1*Dd*bd2*f**2*s - 1600*D1*Dd*f**3*r*s + 400*D1*Dd*f**3*r - 4040*D1*Dd*f**3*s**2 + 2820*D1*Dd*f**3*s - 1010*D1*Dd*f**3 + 6960*D1*Dd*f**2*fd*r*s - 2030*D1*Dd*f**2*fd*r + 14280*D1*Dd*f**2*fd*s**2 - 11230*D1*Dd*f**2*fd*s + 2060*D1*Dd*f**2*fd + 3600*D1*Dd*f**2*g2*s**2 - 1800*D1*Dd*f**2*g2*s + 900*D1*Dd*f**2*g2 - 3600*D1*Dd*f**2*gd2*s**2 + 900*D1*Dd*f**2*gd2*s - 7200*D1*Dd*f*fd*g2*s**2 + 5400*D1*Dd*f*fd*g2*s - 900*D1*Dd*f*fd*g2 + 900*D1*Ddd*b2*f**2*s**2 - 450*D1*Ddd*b2*f**2*s + 225*D1*Ddd*b2*f**2 + 1160*D1*Ddd*f**3*r*s - 290*D1*Ddd*f**3*r + 2380*D1*Ddd*f**3*s**2 - 1770*D1*Ddd*f**3*s + 595*D1*Ddd*f**3 - 1800*D1*Ddd*f**2*g2*s**2 + 900*D1*Ddd*f**2*g2*s - 450*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(45*f**3*s*(2*r + 8*s - 1) - 3*f**2*(15*fd*(2*r*(6*s - 1) + 27*s**2 - 15*s + 1) + s**2*(-96*C - 25*K + 42) - s*(24*r + 76) + 50) + f*(-3*fd*(19*r*(4*s - 1) + s**2*(220*C + 50*K - 84) + s*(-110*C - 25*K + 54) + 19) + s**2*(-448*g2 + 518*gd2)) + 518*fd*g2*s*(s - 1)) + Dd*f*(-45*f**2*(2*r*(8*s - 1) + 36*s**2 - 17*s + 1) + f*(-57*r*(8*s - 1) - s**2*(1320*C + 300*K - 504) + s*(330*C + 75*K - 384) + 93) + 518*g2*s*(4*s - 1))) + 2700*Dd**2*b2*f**2*s**2 - 1350*Dd**2*b2*f**2*s + 3480*Dd**2*f**3*r*s - 870*Dd**2*f**3*r + 7140*Dd**2*f**3*s**2 - 5310*Dd**2*f**3*s + 580*Dd**2*f**3 - 5400*Dd**2*f**2*g2*s**2 + 2700*Dd**2*f**2*g2*s + 525*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 3*b1**2*(420*C*D1**2*fd*s**2 - 210*C*D1**2*fdd*s**2 + 1680*C*D1*Dd*f*s**2 - 840*C*D1*Dd*f*s + 420*C*D1*Dd*f - 1680*C*D1*Dd*fd*s**2 + 420*C*D1*Dd*fd*s - 840*C*D1*Ddd*f*s**2 + 420*C*D1*Ddd*f*s - 210*C*D1*Ddd*f - 2520*C*Dd**2*f*s**2 + 1260*C*Dd**2*f*s - 448*D1**2*K*fd*s**2 + 896*D1**2*K*fd*s - 448*D1**2*K*fd + 259*D1**2*K*fdd*s**2 - 518*D1**2*K*fdd*s + 259*D1**2*K*fdd - 175*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) + 600*D1**2*f*fd*s**2 + 300*D1**2*f*fd*s - 150*D1**2*f*fd - 300*D1**2*f*fdd*s**2 - 150*D1**2*f*fdd*s + 75*D1**2*f*fdd - 300*D1**2*fd**2*s**2 - 150*D1**2*fd**2*s + 448*D1**2*fd*s**2 - 896*D1**2*fd*s + 448*D1**2*fd - 259*D1**2*fdd*s**2 + 518*D1**2*fdd*s - 259*D1**2*fdd - 700*D1**2*gd2*s**2 + 350*D1**2*gdd2*s**2 - 1792*D1*Dd*K*f*s**2 + 896*D1*Dd*K*f*s - 448*D1*Dd*K*f + 2072*D1*Dd*K*fd*s**2 - 2590*D1*Dd*K*fd*s + 518*D1*Dd*K*fd + 1200*D1*Dd*f**2*s**2 - 600*D1*Dd*f**2*s + 300*D1*Dd*f**2 - 2400*D1*Dd*f*fd*s**2 + 150*D1*Dd*f*fd + 1792*D1*Dd*f*s**2 - 896*D1*Dd*f*s + 448*D1*Dd*f - 2072*D1*Dd*fd*s**2 + 2590*D1*Dd*fd*s - 518*D1*Dd*fd - 2800*D1*Dd*g2*s**2 + 1400*D1*Dd*g2*s - 700*D1*Dd*g2 + 2800*D1*Dd*gd2*s**2 - 700*D1*Dd*gd2*s + 1036*D1*Ddd*K*f*s**2 - 518*D1*Ddd*K*f*s + 259*D1*Ddd*K*f - 600*D1*Ddd*f**2*s**2 + 300*D1*Ddd*f**2*s - 150*D1*Ddd*f**2 - 1036*D1*Ddd*f*s**2 + 518*D1*Ddd*f*s - 259*D1*Ddd*f + 1400*D1*Ddd*g2*s**2 - 700*D1*Ddd*g2*s + 350*D1*Ddd*g2 + 350*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) + 3108*Dd**2*K*f*s**2 - 1554*Dd**2*K*f*s - 1800*Dd**2*f**2*s**2 + 900*Dd**2*f**2*s - 3108*Dd**2*f*s**2 + 1554*Dd**2*f*s + 4200*Dd**2*g2*s**2 - 2100*Dd**2*g2*s) - 3*b1*(420*C*D1**2*bdd1*f*s**2 - 420*C*D1**2*bdd1*f*s + 210*C*D1**2*bdd1*f + 1152*C*D1**2*f*fd*s**2 - 1152*C*D1**2*f*fd*s + 576*C*D1**2*f*fd - 660*C*D1**2*f*fdd*s**2 + 660*C*D1**2*f*fdd*s - 330*C*D1**2*f*fdd - 660*C*D1**2*fd**2*s**2 + 660*C*D1**2*fd**2*s + 2304*C*D1*Dd*f**2*s**2 - 1152*C*D1*Dd*f**2*s + 576*C*D1*Dd*f**2 - 5280*C*D1*Dd*f*fd*s**2 + 3960*C*D1*Dd*f*fd*s - 660*C*D1*Dd*f*fd - 1320*C*D1*Ddd*f**2*s**2 + 660*C*D1*Ddd*f**2*s - 330*C*D1*Ddd*f**2 - 3960*C*Dd**2*f**2*s**2 + 1980*C*Dd**2*f**2*s - 518*D1**2*K*bdd1*f*s**2 + 300*D1**2*K*f*fd*s**2 - 300*D1**2*K*f*fd*s + 150*D1**2*K*f*fd - 150*D1**2*K*f*fdd*s**2 + 150*D1**2*K*f*fdd*s - 75*D1**2*K*f*fdd - 150*D1**2*K*fd**2*s**2 + 150*D1**2*K*fd**2*s + 350*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + 300*D1**2*bdd1*f**2*s**2 - 450*D1**2*bdd1*f**2*s + 225*D1**2*bdd1*f**2 + 518*D1**2*bdd1*f*s**2 - 700*D1**2*bdd1*g2*s**2 + 700*D1**2*bdd1*g2*s - 350*D1**2*bdd1*g2 + 540*D1**2*f**2*fd*r*s - 180*D1**2*f**2*fd*r + 2160*D1**2*f**2*fd*s**2 - 1710*D1**2*f**2*fd*s + 720*D1**2*f**2*fd - 540*D1**2*f**2*fdd*r*s + 180*D1**2*f**2*fdd*r - 1215*D1**2*f**2*fdd*s**2 + 1080*D1**2*f**2*fdd*s - 405*D1**2*f**2*fdd - 1080*D1**2*f*fd**2*r*s + 360*D1**2*f*fd**2*r - 2430*D1**2*f*fd**2*s**2 + 2160*D1**2*f*fd**2*s - 270*D1**2*f*fd**2 + 288*D1**2*f*fd*r*s - 144*D1**2*f*fd*r - 504*D1**2*f*fd*s**2 - 96*D1**2*f*fd*s + 48*D1**2*f*fd - 228*D1**2*f*fdd*r*s + 114*D1**2*f*fdd*r + 252*D1**2*f*fdd*s**2 + 48*D1**2*f*fdd*s - 24*D1**2*f*fdd - 896*D1**2*f*gd2*s**2 + 518*D1**2*f*gdd2*s**2 - 228*D1**2*fd**2*r*s + 114*D1**2*fd**2*r + 252*D1**2*fd**2*s**2 + 48*D1**2*fd**2*s - 896*D1**2*fd*g2*s**2 + 1792*D1**2*fd*g2*s - 896*D1**2*fd*g2 + 1036*D1**2*fd*gd2*s**2 - 1036*D1**2*fd*gd2*s + 518*D1**2*fdd*g2*s**2 - 1036*D1**2*fdd*g2*s + 518*D1**2*fdd*g2 + 600*D1*Dd*K*f**2*s**2 - 300*D1*Dd*K*f**2*s + 150*D1*Dd*K*f**2 - 1200*D1*Dd*K*f*fd*s**2 + 900*D1*Dd*K*f*fd*s - 150*D1*Dd*K*f*fd + 720*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r + 2880*D1*Dd*f**3*s**2 - 1800*D1*Dd*f**3*s + 720*D1*Dd*f**3 - 4320*D1*Dd*f**2*fd*r*s + 1260*D1*Dd*f**2*fd*r - 9720*D1*Dd*f**2*fd*s**2 + 7830*D1*Dd*f**2*fd*s - 1440*D1*Dd*f**2*fd + 576*D1*Dd*f**2*r*s - 144*D1*Dd*f**2*r - 1008*D1*Dd*f**2*s**2 + 216*D1*Dd*f**2*s - 252*D1*Dd*f**2 - 1824*D1*Dd*f*fd*r*s + 684*D1*Dd*f*fd*r + 2016*D1*Dd*f*fd*s**2 + 144*D1*Dd*f*fd*s - 276*D1*Dd*f*fd - 3584*D1*Dd*f*g2*s**2 + 1792*D1*Dd*f*g2*s - 896*D1*Dd*f*g2 + 4144*D1*Dd*f*gd2*s**2 - 1036*D1*Dd*f*gd2*s + 4144*D1*Dd*fd*g2*s**2 - 5180*D1*Dd*fd*g2*s + 1036*D1*Dd*fd*g2 - 300*D1*Ddd*K*f**2*s**2 + 150*D1*Ddd*K*f**2*s - 75*D1*Ddd*K*f**2 - 720*D1*Ddd*f**3*r*s + 180*D1*Ddd*f**3*r - 1620*D1*Ddd*f**3*s**2 + 1170*D1*Ddd*f**3*s - 405*D1*Ddd*f**3 - 456*D1*Ddd*f**2*r*s + 114*D1*Ddd*f**2*r + 504*D1*Ddd*f**2*s**2 - 24*D1*Ddd*f**2*s + 126*D1*Ddd*f**2 + 2072*D1*Ddd*f*g2*s**2 - 1036*D1*Ddd*f*g2*s + 518*D1*Ddd*f*g2 - 2*D1*bd1*(210*C*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + D1*(75*f**2*(4*s**2 - 6*s + 3) + 4*f*s*(-75*fd*(2*s - 1) + s*(112 - 112*K)) + 518*fd*s*(K - 1)*(s - 1) - 350*g2*(2*s**2 - 2*s + 1) + 350*gd2*s*(2*s - 1)) - Dd*(4*s - 1)*(75*f**2*(4*s - 3) - 518*f*s*(K - 1) + 350*g2*(1 - 2*s))) - 900*Dd**2*K*f**2*s**2 + 450*Dd**2*K*f**2*s - 2160*Dd**2*f**3*r*s + 540*Dd**2*f**3*r - 4860*Dd**2*f**3*s**2 + 3510*Dd**2*f**3*s - 360*Dd**2*f**3 - 1368*Dd**2*f**2*r*s + 342*Dd**2*f**2*r + 1512*Dd**2*f**2*s**2 - 72*Dd**2*f**2*s - 228*Dd**2*f**2 + 6216*Dd**2*f*g2*s**2 - 3108*Dd**2*f*g2*s))/(630*d**2*k2*k3**2) + 4*D1**2*Pk3*Pkd2*ct**4*k2**5*st**2*(D1**2*(f**2*(fd*(20*C - 10)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-9*K*(-2*bd1 + bdd1) - 36*gd2 + 18*gdd2)) + f*(-fd**2*(10*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 9*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) + 9*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 9*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(20*C - 10)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(9*K*(b1*r*(8*s - 2) + 2*b1*(1 - 2*s)**2 + bd1*(-8*r*s + r - 8*s**2 + 8*s - 1)) + fd*(5 - 10*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 36*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 18*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 18*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(10*C*f + 9*K*b1 - 5*f - 18*g2)) - Dd**2*f**2*(10*C*f + 9*K*b1 - 5*f - 18*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(21*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**4*k2**5*(40*C*D1**2*b1*f*fd*r*s + 40*C*D1**2*b1*f*fd*s**2 - 20*C*D1**2*b1*f*fd*s - 20*C*D1**2*b1*f*fdd*r*s - 20*C*D1**2*b1*f*fdd*s**2 + 10*C*D1**2*b1*f*fdd*s - 20*C*D1**2*b1*fd**2*r*s - 20*C*D1**2*b1*fd**2*s**2 + 10*C*D1**2*b1*fd**2*s - 30*C*D1**2*f**2*fd*r*s + 10*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 30*C*D1**2*f**2*fd*s - 10*C*D1**2*f**2*fd + 80*C*D1*Dd*b1*f**2*r*s - 20*C*D1*Dd*b1*f**2*r + 80*C*D1*Dd*b1*f**2*s**2 - 80*C*D1*Dd*b1*f**2*s + 20*C*D1*Dd*b1*f**2 - 160*C*D1*Dd*b1*f*fd*r*s + 20*C*D1*Dd*b1*f*fd*r - 160*C*D1*Dd*b1*f*fd*s**2 + 120*C*D1*Dd*b1*f*fd*s - 10*C*D1*Dd*b1*f*fd - 40*C*D1*Dd*f**3*r*s + 10*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 40*C*D1*Dd*f**3*s - 10*C*D1*Dd*f**3 - 40*C*D1*Ddd*b1*f**2*r*s + 10*C*D1*Ddd*b1*f**2*r - 40*C*D1*Ddd*b1*f**2*s**2 + 40*C*D1*Ddd*b1*f**2*s - 10*C*D1*Ddd*b1*f**2 - 120*C*Dd**2*b1*f**2*r*s + 30*C*Dd**2*b1*f**2*r - 120*C*Dd**2*b1*f**2*s**2 + 120*C*Dd**2*b1*f**2*s - 20*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r*s + 7*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 7*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 20*D1**2*b1*f*fd*r*s - 20*D1**2*b1*f*fd*s**2 + 10*D1**2*b1*f*fd*s + 10*D1**2*b1*f*fdd*r*s + 10*D1**2*b1*f*fdd*s**2 - 5*D1**2*b1*f*fdd*s - 28*D1**2*b1*f*gd2*r*s - 28*D1**2*b1*f*gd2*s**2 + 28*D1**2*b1*f*gd2*s + 14*D1**2*b1*f*gdd2*r*s + 14*D1**2*b1*f*gdd2*s**2 - 14*D1**2*b1*f*gdd2*s + 10*D1**2*b1*fd**2*r*s + 10*D1**2*b1*fd**2*s**2 - 5*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r*s + 28*D1**2*b1*fd*gd2*s**2 - 14*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(10*C - 5)*(s - 1) - 14*g2*(s - 1)) + 15*D1**2*f**2*fd*r*s - 5*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 15*D1**2*f**2*fd*s + 5*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r*s + 14*D1**2*f**2*gd2*s**2 - 14*D1**2*f**2*gd2*s + 28*D1**2*f*fd*g2*r*s - 14*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r*s - 14*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 56*D1*Dd*K*b1**2*f*s + 14*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r*s + 7*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 28*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r*s + 7*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 28*D1*Dd*K*b1*f**2*s - 7*D1*Dd*K*b1*f**2 - 40*D1*Dd*b1*f**2*r*s + 10*D1*Dd*b1*f**2*r - 40*D1*Dd*b1*f**2*s**2 + 40*D1*Dd*b1*f**2*s - 10*D1*Dd*b1*f**2 + 80*D1*Dd*b1*f*fd*r*s - 10*D1*Dd*b1*f*fd*r + 80*D1*Dd*b1*f*fd*s**2 - 60*D1*Dd*b1*f*fd*s + 5*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r*s + 28*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 112*D1*Dd*b1*f*g2*s - 28*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r*s - 14*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 112*D1*Dd*b1*f*gd2*s + 14*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r*s - 14*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 56*D1*Dd*b1*fd*g2*s + 20*D1*Dd*f**3*r*s - 5*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 20*D1*Dd*f**3*s + 5*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r*s - 14*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 56*D1*Dd*f**2*g2*s + 14*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r*s + 7*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 28*D1*Ddd*K*b1**2*f*s - 7*D1*Ddd*K*b1**2*f + 20*D1*Ddd*b1*f**2*r*s - 5*D1*Ddd*b1*f**2*r + 20*D1*Ddd*b1*f**2*s**2 - 20*D1*Ddd*b1*f**2*s + 5*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r*s - 14*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 56*D1*Ddd*b1*f*g2*s + 14*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(20*C*(s - 1) - s*(7*K + 10) + 10) + f*(-fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(-14*r - 14*s + 14)) + 7*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(-7*K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - f*(10*C - 5)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 14*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 84*Dd**2*K*b1**2*f*r*s + 21*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 84*Dd**2*K*b1**2*f*s - 14*Dd**2*K*b1**2*f + 60*Dd**2*b1*f**2*r*s - 15*Dd**2*b1*f**2*r + 60*Dd**2*b1*f**2*s**2 - 60*Dd**2*b1*f**2*s + 10*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r*s - 42*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 168*Dd**2*b1*f*g2*s + 28*Dd**2*b1*f*g2)/(35*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**4*k2**3*st**2*(-9312*C*D1**2*f**2*fd*r*s + 3104*C*D1**2*f**2*fd*r - 2700*C*D1**2*f**2*fd*s**2 + 4904*C*D1**2*f**2*fd*s - 900*C*D1**2*f**2*fd + 5520*C*D1**2*f**2*fdd*r*s - 1840*C*D1**2*f**2*fdd*r + 1350*C*D1**2*f**2*fdd*s**2 - 2740*C*D1**2*f**2*fdd*s + 450*C*D1**2*f**2*fdd + 11040*C*D1**2*f*fd**2*r*s - 3680*C*D1**2*f*fd**2*r + 2700*C*D1**2*f*fd**2*s**2 - 5480*C*D1**2*f*fd**2*s + 1840*C*D1**2*f*fd**2 - 12416*C*D1*Dd*f**3*r*s + 3104*C*D1*Dd*f**3*r - 3600*C*D1*Dd*f**3*s**2 + 8008*C*D1*Dd*f**3*s - 900*C*D1*Dd*f**3 + 44160*C*D1*Dd*f**2*fd*r*s - 12880*C*D1*Dd*f**2*fd*r + 10800*C*D1*Dd*f**2*fd*s**2 - 24700*C*D1*Dd*f**2*fd*s + 6420*C*D1*Dd*f**2*fd + 7360*C*D1*Ddd*f**3*r*s - 1840*C*D1*Ddd*f**3*r + 1800*C*D1*Ddd*f**3*s**2 - 4580*C*D1*Ddd*f**3*s + 450*C*D1*Ddd*f**3 + 22080*C*Dd**2*f**3*r*s - 5520*C*Dd**2*f**3*r + 5400*C*Dd**2*f**3*s**2 - 13740*C*Dd**2*f**3*s + 3680*C*Dd**2*f**3 - 4320*D1**2*K*b1*f*fd*r*s + 2160*D1**2*K*b1*f*fd*r - 1620*D1**2*K*b1*f*fd*s**2 + 1620*D1**2*K*b1*f*fd*s - 810*D1**2*K*b1*f*fd + 2160*D1**2*K*b1*f*fdd*r*s - 1080*D1**2*K*b1*f*fdd*r + 810*D1**2*K*b1*f*fdd*s**2 - 810*D1**2*K*b1*f*fdd*s + 405*D1**2*K*b1*f*fdd + 2160*D1**2*K*b1*fd**2*r*s - 1080*D1**2*K*b1*fd**2*r + 810*D1**2*K*b1*fd**2*s**2 - 810*D1**2*K*b1*fd**2*s + 1080*D1**2*K*bdd1*f**2*r*s + 405*D1**2*K*bdd1*f**2*s**2 - 1080*D1**2*K*bdd1*f**2*s + 810*D1**2*b1*f**2*fd*r*s - 270*D1**2*b1*f**2*fd*r - 270*D1**2*b1*f**2*fd*s - 810*D1**2*b1*f**2*fdd*r*s + 270*D1**2*b1*f**2*fdd*r + 270*D1**2*b1*f**2*fdd*s - 1620*D1**2*b1*f*fd**2*r*s + 540*D1**2*b1*f*fd**2*r + 540*D1**2*b1*f*fd**2*s - 270*D1**2*b1*f*fd**2 + 1080*D1**2*b1*f*fd*r*s - 540*D1**2*b1*f*fd*r - 540*D1**2*b1*f*fdd*r*s + 270*D1**2*b1*f*fdd*r - 540*D1**2*b1*fd**2*r*s + 270*D1**2*b1*fd**2*r - 1080*D1**2*bd2*f**2*r*s - 1080*D1**2*bd2*f**2*s**2 + 1080*D1**2*bd2*f**2*s + 2160*D1**2*bd2*f*fd*r*s - 540*D1**2*bd2*f*fd*r + 2160*D1**2*bd2*f*fd*s**2 - 2160*D1**2*bd2*f*fd*s + 540*D1**2*bd2*f*fd - 270*D1**2*bdd1*f**3*r*s + 270*D1**2*bdd1*f**3*s - 270*D1**2*bdd1*f**2*r*s + 270*D1**2*bdd1*f**2*s + 540*D1**2*bdd2*f**2*r*s + 540*D1**2*bdd2*f**2*s**2 - 540*D1**2*bdd2*f**2*s + 6084*D1**2*f**2*fd*r*s - 2028*D1**2*f**2*fd*r + 1350*D1**2*f**2*fd*s**2 - 2928*D1**2*f**2*fd*s + 450*D1**2*f**2*fd - 3690*D1**2*f**2*fdd*r*s + 1230*D1**2*f**2*fdd*r - 675*D1**2*f**2*fdd*s**2 + 1680*D1**2*f**2*fdd*s - 225*D1**2*f**2*fdd + 4320*D1**2*f**2*gd2*r*s + 1620*D1**2*f**2*gd2*s**2 - 4320*D1**2*f**2*gd2*s - 2160*D1**2*f**2*gdd2*r*s - 810*D1**2*f**2*gdd2*s**2 + 2160*D1**2*f**2*gdd2*s - 7380*D1**2*f*fd**2*r*s + 2460*D1**2*f*fd**2*r - 1350*D1**2*f*fd**2*s**2 + 3360*D1**2*f*fd**2*s - 1230*D1**2*f*fd**2 + 8640*D1**2*f*fd*g2*r*s - 4320*D1**2*f*fd*g2*r + 3240*D1**2*f*fd*g2*s**2 - 3240*D1**2*f*fd*g2*s + 1620*D1**2*f*fd*g2 - 8640*D1**2*f*fd*gd2*r*s + 2160*D1**2*f*fd*gd2*r - 3240*D1**2*f*fd*gd2*s**2 + 5940*D1**2*f*fd*gd2*s - 2160*D1**2*f*fd*gd2 - 4320*D1**2*f*fdd*g2*r*s + 2160*D1**2*f*fdd*g2*r - 1620*D1**2*f*fdd*g2*s**2 + 1620*D1**2*f*fdd*g2*s - 810*D1**2*f*fdd*g2 - 4320*D1**2*fd**2*g2*r*s + 2160*D1**2*fd**2*g2*r - 1620*D1**2*fd**2*g2*s**2 + 1620*D1**2*fd**2*g2*s - 8640*D1*Dd*K*b1*f**2*r*s + 2160*D1*Dd*K*b1*f**2*r - 3240*D1*Dd*K*b1*f**2*s**2 + 5940*D1*Dd*K*b1*f**2*s - 810*D1*Dd*K*b1*f**2 + 17280*D1*Dd*K*b1*f*fd*r*s - 6480*D1*Dd*K*b1*f*fd*r + 6480*D1*Dd*K*b1*f*fd*s**2 - 9180*D1*Dd*K*b1*f*fd*s + 2970*D1*Dd*K*b1*f*fd + 1080*D1*Dd*b1*f**3*r*s - 270*D1*Dd*b1*f**3*r - 540*D1*Dd*b1*f**3*s - 6480*D1*Dd*b1*f**2*fd*r*s + 1890*D1*Dd*b1*f**2*fd*r + 2700*D1*Dd*b1*f**2*fd*s - 810*D1*Dd*b1*f**2*fd + 2160*D1*Dd*b1*f**2*r*s - 540*D1*Dd*b1*f**2*r - 1080*D1*Dd*b1*f**2*s - 4320*D1*Dd*b1*f*fd*r*s + 1620*D1*Dd*b1*f*fd*r + 1080*D1*Dd*b1*f*fd*s - 540*D1*Dd*b1*f*fd + 4320*D1*Dd*bd2*f**2*r*s - 540*D1*Dd*bd2*f**2*r + 4320*D1*Dd*bd2*f**2*s**2 - 4320*D1*Dd*bd2*f**2*s + 540*D1*Dd*bd2*f**2 + 8112*D1*Dd*f**3*r*s - 2028*D1*Dd*f**3*r + 1800*D1*Dd*f**3*s**2 - 4956*D1*Dd*f**3*s + 450*D1*Dd*f**3 - 29520*D1*Dd*f**2*fd*r*s + 8610*D1*Dd*f**2*fd*r - 5400*D1*Dd*f**2*fd*s**2 + 15450*D1*Dd*f**2*fd*s - 4140*D1*Dd*f**2*fd + 17280*D1*Dd*f**2*g2*r*s - 4320*D1*Dd*f**2*g2*r + 6480*D1*Dd*f**2*g2*s**2 - 11880*D1*Dd*f**2*g2*s + 1620*D1*Dd*f**2*g2 - 17280*D1*Dd*f**2*gd2*r*s + 2160*D1*Dd*f**2*gd2*r - 6480*D1*Dd*f**2*gd2*s**2 + 14580*D1*Dd*f**2*gd2*s - 2160*D1*Dd*f**2*gd2 - 34560*D1*Dd*f*fd*g2*r*s + 12960*D1*Dd*f*fd*g2*r - 12960*D1*Dd*f*fd*g2*s**2 + 18360*D1*Dd*f*fd*g2*s - 5940*D1*Dd*f*fd*g2 + 4320*D1*Ddd*K*b1*f**2*r*s - 1080*D1*Ddd*K*b1*f**2*r + 1620*D1*Ddd*K*b1*f**2*s**2 - 2970*D1*Ddd*K*b1*f**2*s + 405*D1*Ddd*K*b1*f**2 - 1080*D1*Ddd*b1*f**3*r*s + 270*D1*Ddd*b1*f**3*r + 540*D1*Ddd*b1*f**3*s - 1080*D1*Ddd*b1*f**2*r*s + 270*D1*Ddd*b1*f**2*r + 540*D1*Ddd*b1*f**2*s - 4920*D1*Ddd*f**3*r*s + 1230*D1*Ddd*f**3*r - 900*D1*Ddd*f**3*s**2 + 2910*D1*Ddd*f**3*s - 225*D1*Ddd*f**3 - 8640*D1*Ddd*f**2*g2*r*s + 2160*D1*Ddd*f**2*g2*r - 3240*D1*Ddd*f**2*g2*s**2 + 5940*D1*Ddd*f**2*g2*s - 810*D1*Ddd*f**2*g2 + 270*D1*bd1*f*(D1*(f*s*(K*(-8*r - 3*s + 8) + f*(r - 1) + 2*r - 2) + fd*(K*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + f*(-6*r*s + r + 4*s - 1) - 4*r*s + r + 2*s - 1)) + Dd*f*(K*(32*r*s - 4*r + 12*s**2 - 27*s + 4) + f*(-8*r*s + r + 6*s - 1) - 8*r*s + r + 6*s - 1)) + 12960*Dd**2*K*b1*f**2*r*s - 3240*Dd**2*K*b1*f**2*r + 4860*Dd**2*K*b1*f**2*s**2 - 8910*Dd**2*K*b1*f**2*s + 2160*Dd**2*K*b1*f**2 - 3240*Dd**2*b1*f**3*r*s + 810*Dd**2*b1*f**3*r + 1620*Dd**2*b1*f**3*s - 540*Dd**2*b1*f**3 - 3240*Dd**2*b1*f**2*r*s + 810*Dd**2*b1*f**2*r + 1620*Dd**2*b1*f**2*s - 540*Dd**2*b1*f**2 - 14760*Dd**2*f**3*r*s + 3690*Dd**2*f**3*r - 2700*Dd**2*f**3*s**2 + 8730*Dd**2*f**3*s - 2460*Dd**2*f**3 - 25920*Dd**2*f**2*g2*r*s + 6480*Dd**2*f**2*g2*r - 9720*Dd**2*f**2*g2*s**2 + 17820*Dd**2*f**2*g2*s - 4320*Dd**2*f**2*g2 - 540*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(630*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**4*k2**3*(-2592*C*D1**2*b1*f*fd*r*s - 720*C*D1**2*b1*f*fd*r - 1080*C*D1**2*b1*f*fd*s**2 - 144*C*D1**2*b1*f*fd*s + 720*C*D1**2*b1*f*fd + 1296*C*D1**2*b1*f*fdd*r*s + 360*C*D1**2*b1*f*fdd*r + 540*C*D1**2*b1*f*fdd*s**2 + 72*C*D1**2*b1*f*fdd*s - 360*C*D1**2*b1*f*fdd + 1296*C*D1**2*b1*fd**2*r*s + 360*C*D1**2*b1*fd**2*r + 540*C*D1**2*b1*fd**2*s**2 + 72*C*D1**2*b1*fd**2*s - 360*C*D1**2*b1*fd**2 + 648*C*D1**2*bdd1*f**2*r*s - 1008*C*D1**2*bdd1*f**2*r + 270*C*D1**2*bdd1*f**2*s**2 - 1260*C*D1**2*bdd1*f**2*s + 630*C*D1**2*bdd1*f**2 + 120*C*D1**2*f**2*fd*r*s - 40*C*D1**2*f**2*fd*r - 1080*C*D1**2*f**2*fd*s**2 + 680*C*D1**2*f**2*fd*s - 360*C*D1**2*f**2*fd + 1560*C*D1**2*f**2*fdd*r*s - 520*C*D1**2*f**2*fdd*r + 2430*C*D1**2*f**2*fdd*s**2 - 2140*C*D1**2*f**2*fdd*s + 810*C*D1**2*f**2*fdd + 3120*C*D1**2*f*fd**2*r*s - 1040*C*D1**2*f*fd**2*r + 4860*C*D1**2*f*fd**2*s**2 - 4280*C*D1**2*f*fd**2*s + 520*C*D1**2*f*fd**2 - 5184*C*D1*Dd*b1*f**2*r*s + 1296*C*D1*Dd*b1*f**2*r - 2160*C*D1*Dd*b1*f**2*s**2 + 3672*C*D1*Dd*b1*f**2*s - 540*C*D1*Dd*b1*f**2 + 10368*C*D1*Dd*b1*f*fd*r*s + 144*C*D1*Dd*b1*f*fd*r + 4320*C*D1*Dd*b1*f*fd*s**2 - 3384*C*D1*Dd*b1*f*fd*s - 792*C*D1*Dd*b1*f*fd + 160*C*D1*Dd*f**3*r*s - 40*C*D1*Dd*f**3*r - 1440*C*D1*Dd*f**3*s**2 + 640*C*D1*Dd*f**3*s - 360*C*D1*Dd*f**3 + 12480*C*D1*Dd*f**2*fd*r*s - 3640*C*D1*Dd*f**2*fd*r + 19440*C*D1*Dd*f**2*fd*s**2 - 16540*C*D1*Dd*f**2*fd*s + 3180*C*D1*Dd*f**2*fd + 2592*C*D1*Ddd*b1*f**2*r*s - 648*C*D1*Ddd*b1*f**2*r + 1080*C*D1*Ddd*b1*f**2*s**2 - 1836*C*D1*Ddd*b1*f**2*s + 270*C*D1*Ddd*b1*f**2 + 2080*C*D1*Ddd*f**3*r*s - 520*C*D1*Ddd*f**3*r + 3240*C*D1*Ddd*f**3*s**2 - 2660*C*D1*Ddd*f**3*s + 810*C*D1*Ddd*f**3 + 7776*C*Dd**2*b1*f**2*r*s - 1944*C*Dd**2*b1*f**2*r + 3240*C*Dd**2*b1*f**2*s**2 - 5508*C*Dd**2*b1*f**2*s + 1296*C*Dd**2*b1*f**2 + 6240*C*Dd**2*f**3*r*s - 1560*C*Dd**2*f**3*r + 9720*C*Dd**2*f**3*s**2 - 7980*C*Dd**2*f**3*s + 1040*C*Dd**2*f**3 - 504*D1**2*K*b1**2*fd*r*s - 504*D1**2*K*b1**2*fd*r - 378*D1**2*K*b1**2*fd*s**2 - 1008*D1**2*K*b1**2*fd*s + 504*D1**2*K*b1**2*fd + 252*D1**2*K*b1**2*fdd*r*s + 252*D1**2*K*b1**2*fdd*r + 189*D1**2*K*b1**2*fdd*s**2 + 504*D1**2*K*b1**2*fdd*s - 252*D1**2*K*b1**2*fdd + 504*D1**2*K*b1*bdd1*f*r*s - 504*D1**2*K*b1*bdd1*f*r + 378*D1**2*K*b1*bdd1*f*s**2 - 1134*D1**2*K*b1*bdd1*f*s + 441*D1**2*K*b1*bdd1*f + 504*D1**2*K*b1*f*fd*r*s - 252*D1**2*K*b1*f*fd*r - 504*D1**2*K*b1*f*fd*s**2 + 504*D1**2*K*b1*f*fd*s - 252*D1**2*K*b1*f*fd + 504*D1**2*K*b1*f*fdd*r*s - 252*D1**2*K*b1*f*fdd*r + 1134*D1**2*K*b1*f*fdd*s**2 - 1134*D1**2*K*b1*f*fdd*s + 567*D1**2*K*b1*f*fdd + 504*D1**2*K*b1*fd**2*r*s - 252*D1**2*K*b1*fd**2*r + 1134*D1**2*K*b1*fd**2*s**2 - 1134*D1**2*K*b1*fd**2*s + 252*D1**2*K*bdd1*f**2*r*s + 567*D1**2*K*bdd1*f**2*s**2 - 252*D1**2*K*bdd1*f**2*s + 252*D1**2*b1**2*f*fd*r*s - 126*D1**2*b1**2*f*fd*s - 252*D1**2*b1**2*f*fdd*r*s + 126*D1**2*b1**2*f*fdd*s - 252*D1**2*b1**2*fd**2*r*s + 126*D1**2*b1**2*fd**2*s + 252*D1**2*b1**2*fd*r*s - 126*D1**2*b1**2*fdd*r*s - 504*D1**2*b1*bd2*f*r*s - 504*D1**2*b1*bd2*f*s**2 + 504*D1**2*b1*bd2*f*s + 504*D1**2*b1*bd2*fd*r*s + 504*D1**2*b1*bd2*fd*s**2 - 252*D1**2*b1*bd2*fd*s - 252*D1**2*b1*bdd1*f**2*r*s + 126*D1**2*b1*bdd1*f**2*r + 126*D1**2*b1*bdd1*f**2*s - 252*D1**2*b1*bdd1*f*r*s + 126*D1**2*b1*bdd1*f*r + 126*D1**2*b1*bdd1*f*s + 252*D1**2*b1*bdd2*f*r*s + 252*D1**2*b1*bdd2*f*s**2 - 252*D1**2*b1*bdd2*f*s + 1692*D1**2*b1*f*fd*r*s + 486*D1**2*b1*f*fd*r + 540*D1**2*b1*f*fd*s**2 - 252*D1**2*b1*f*fd*s - 360*D1**2*b1*f*fd - 972*D1**2*b1*f*fdd*r*s - 180*D1**2*b1*f*fdd*r - 270*D1**2*b1*f*fdd*s**2 + 126*D1**2*b1*f*fdd*s + 180*D1**2*b1*f*fdd + 1008*D1**2*b1*f*gd2*r*s + 756*D1**2*b1*f*gd2*s**2 - 1008*D1**2*b1*f*gd2*s - 504*D1**2*b1*f*gdd2*r*s - 378*D1**2*b1*f*gdd2*s**2 + 504*D1**2*b1*f*gdd2*s - 972*D1**2*b1*fd**2*r*s - 180*D1**2*b1*fd**2*r - 270*D1**2*b1*fd**2*s**2 + 126*D1**2*b1*fd**2*s + 180*D1**2*b1*fd**2 + 1008*D1**2*b1*fd*g2*r*s + 1008*D1**2*b1*fd*g2*r + 756*D1**2*b1*fd*g2*s**2 + 2016*D1**2*b1*fd*g2*s - 1008*D1**2*b1*fd*g2 - 1008*D1**2*b1*fd*gd2*r*s - 504*D1**2*b1*fd*gd2*r - 756*D1**2*b1*fd*gd2*s**2 - 504*D1**2*b1*fd*gd2*s + 504*D1**2*b1*fd*gd2 - 504*D1**2*b1*fdd*g2*r*s - 504*D1**2*b1*fdd*g2*r - 378*D1**2*b1*fdd*g2*s**2 - 1008*D1**2*b1*fdd*g2*s + 504*D1**2*b1*fdd*g2 - 126*D1**2*bd1**2*f*(K*(-4*r*(s - 1) - 3*s**2 + 9*s - 4) + f*r*(2*s - 1) - f*s + f + 2*r*s - r - s + 1) + 252*D1**2*bd2*f**2*r*s + 252*D1**2*bd2*f**2*s**2 - 252*D1**2*bd2*f**2*s - 486*D1**2*bdd1*f**2*r*s + 666*D1**2*bdd1*f**2*r - 135*D1**2*bdd1*f**2*s**2 + 630*D1**2*bdd1*f**2*s - 315*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r*s + 1008*D1**2*bdd1*f*g2*r - 378*D1**2*bdd1*f*g2*s**2 + 1764*D1**2*bdd1*f*g2*s - 882*D1**2*bdd1*f*g2 - 330*D1**2*f**2*fd*r*s + 110*D1**2*f**2*fd*r + 540*D1**2*f**2*fd*s**2 - 250*D1**2*f**2*fd*s + 180*D1**2*f**2*fd - 780*D1**2*f**2*fdd*r*s + 260*D1**2*f**2*fdd*r - 1215*D1**2*f**2*fdd*s**2 + 1070*D1**2*f**2*fdd*s - 405*D1**2*f**2*fdd - 504*D1**2*f**2*gd2*r*s + 504*D1**2*f**2*gd2*s**2 + 504*D1**2*f**2*gd2*s - 504*D1**2*f**2*gdd2*r*s - 1134*D1**2*f**2*gdd2*s**2 + 504*D1**2*f**2*gdd2*s - 1560*D1**2*f*fd**2*r*s + 520*D1**2*f*fd**2*r - 2430*D1**2*f*fd**2*s**2 + 2140*D1**2*f*fd**2*s - 260*D1**2*f*fd**2 - 1008*D1**2*f*fd*g2*r*s + 504*D1**2*f*fd*g2*r + 1008*D1**2*f*fd*g2*s**2 - 1008*D1**2*f*fd*g2*s + 504*D1**2*f*fd*g2 - 2016*D1**2*f*fd*gd2*r*s + 504*D1**2*f*fd*gd2*r - 4536*D1**2*f*fd*gd2*s**2 + 3276*D1**2*f*fd*gd2*s - 504*D1**2*f*fd*gd2 - 1008*D1**2*f*fdd*g2*r*s + 504*D1**2*f*fdd*g2*r - 2268*D1**2*f*fdd*g2*s**2 + 2268*D1**2*f*fdd*g2*s - 1134*D1**2*f*fdd*g2 - 1008*D1**2*fd**2*g2*r*s + 504*D1**2*fd**2*g2*r - 2268*D1**2*fd**2*g2*s**2 + 2268*D1**2*fd**2*g2*s - 2016*D1*Dd*K*b1**2*f*r*s + 504*D1*Dd*K*b1**2*f*r - 1512*D1*Dd*K*b1**2*f*s**2 + 1764*D1*Dd*K*b1**2*f*s - 378*D1*Dd*K*b1**2*f + 2016*D1*Dd*K*b1**2*fd*r*s + 756*D1*Dd*K*b1**2*fd*r + 1512*D1*Dd*K*b1**2*fd*s**2 + 1134*D1*Dd*K*b1**2*fd*s - 1008*D1*Dd*K*b1**2*fd + 1008*D1*Dd*K*b1*f**2*r*s - 252*D1*Dd*K*b1*f**2*r - 1008*D1*Dd*K*b1*f**2*s**2 - 252*D1*Dd*K*b1*f**2 + 4032*D1*Dd*K*b1*f*fd*r*s - 1512*D1*Dd*K*b1*f*fd*r + 9072*D1*Dd*K*b1*f*fd*s**2 - 7812*D1*Dd*K*b1*f*fd*s + 1638*D1*Dd*K*b1*f*fd + 504*D1*Dd*b1**2*f**2*r*s - 126*D1*Dd*b1**2*f**2*r - 252*D1*Dd*b1**2*f**2*s - 2016*D1*Dd*b1**2*f*fd*r*s + 252*D1*Dd*b1**2*f*fd*r + 1008*D1*Dd*b1**2*f*fd*s - 126*D1*Dd*b1**2*f*fd + 1008*D1*Dd*b1**2*f*r*s - 252*D1*Dd*b1**2*f*r - 504*D1*Dd*b1**2*f*s - 1008*D1*Dd*b1**2*fd*r*s + 126*D1*Dd*b1**2*fd*r + 252*D1*Dd*b1**2*fd*s + 2016*D1*Dd*b1*bd2*f*r*s - 252*D1*Dd*b1*bd2*f*r + 2016*D1*Dd*b1*bd2*f*s**2 - 2016*D1*Dd*b1*bd2*f*s + 252*D1*Dd*b1*bd2*f + 3384*D1*Dd*b1*f**2*r*s - 846*D1*Dd*b1*f**2*r + 1080*D1*Dd*b1*f**2*s**2 - 2232*D1*Dd*b1*f**2*s + 270*D1*Dd*b1*f**2 - 7776*D1*Dd*b1*f*fd*r*s + 252*D1*Dd*b1*f*fd*r - 2160*D1*Dd*b1*f*fd*s**2 + 2988*D1*Dd*b1*f*fd*s + 234*D1*Dd*b1*f*fd + 4032*D1*Dd*b1*f*g2*r*s - 1008*D1*Dd*b1*f*g2*r + 3024*D1*Dd*b1*f*g2*s**2 - 3528*D1*Dd*b1*f*g2*s + 756*D1*Dd*b1*f*g2 - 4032*D1*Dd*b1*f*gd2*r*s + 504*D1*Dd*b1*f*gd2*r - 3024*D1*Dd*b1*f*gd2*s**2 + 3780*D1*Dd*b1*f*gd2*s - 504*D1*Dd*b1*f*gd2 - 4032*D1*Dd*b1*fd*g2*r*s - 1512*D1*Dd*b1*fd*g2*r - 3024*D1*Dd*b1*fd*g2*s**2 - 2268*D1*Dd*b1*fd*g2*s + 2016*D1*Dd*b1*fd*g2 - 440*D1*Dd*f**3*r*s + 110*D1*Dd*f**3*r + 720*D1*Dd*f**3*s**2 - 140*D1*Dd*f**3*s + 180*D1*Dd*f**3 - 6240*D1*Dd*f**2*fd*r*s + 1820*D1*Dd*f**2*fd*r - 9720*D1*Dd*f**2*fd*s**2 + 8270*D1*Dd*f**2*fd*s - 1590*D1*Dd*f**2*fd - 2016*D1*Dd*f**2*g2*r*s + 504*D1*Dd*f**2*g2*r + 2016*D1*Dd*f**2*g2*s**2 + 504*D1*Dd*f**2*g2 - 4032*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 9072*D1*Dd*f**2*gd2*s**2 + 5292*D1*Dd*f**2*gd2*s - 504*D1*Dd*f**2*gd2 - 8064*D1*Dd*f*fd*g2*r*s + 3024*D1*Dd*f*fd*g2*r - 18144*D1*Dd*f*fd*g2*s**2 + 15624*D1*Dd*f*fd*g2*s - 3276*D1*Dd*f*fd*g2 + 1008*D1*Ddd*K*b1**2*f*r*s - 252*D1*Ddd*K*b1**2*f*r + 756*D1*Ddd*K*b1**2*f*s**2 - 882*D1*Ddd*K*b1**2*f*s + 189*D1*Ddd*K*b1**2*f + 1008*D1*Ddd*K*b1*f**2*r*s - 252*D1*Ddd*K*b1*f**2*r + 2268*D1*Ddd*K*b1*f**2*s**2 - 1638*D1*Ddd*K*b1*f**2*s + 567*D1*Ddd*K*b1*f**2 - 504*D1*Ddd*b1**2*f**2*r*s + 126*D1*Ddd*b1**2*f**2*r + 252*D1*Ddd*b1**2*f**2*s - 504*D1*Ddd*b1**2*f*r*s + 126*D1*Ddd*b1**2*f*r + 252*D1*Ddd*b1**2*f*s - 1944*D1*Ddd*b1*f**2*r*s + 486*D1*Ddd*b1*f**2*r - 540*D1*Ddd*b1*f**2*s**2 + 1242*D1*Ddd*b1*f**2*s - 135*D1*Ddd*b1*f**2 - 2016*D1*Ddd*b1*f*g2*r*s + 504*D1*Ddd*b1*f*g2*r - 1512*D1*Ddd*b1*f*g2*s**2 + 1764*D1*Ddd*b1*f*g2*s - 378*D1*Ddd*b1*f*g2 - 1040*D1*Ddd*f**3*r*s + 260*D1*Ddd*f**3*r - 1620*D1*Ddd*f**3*s**2 + 1330*D1*Ddd*f**3*s - 405*D1*Ddd*f**3 - 2016*D1*Ddd*f**2*g2*r*s + 504*D1*Ddd*f**2*g2*r - 4536*D1*Ddd*f**2*g2*s**2 + 3276*D1*Ddd*f**2*g2*s - 1134*D1*Ddd*f**2*g2 + 18*D1*bd1*(-72*C*D1*f**2*r*s + 112*C*D1*f**2*r - 30*C*D1*f**2*s**2 + 140*C*D1*f**2*s - 70*C*D1*f**2 + 144*C*D1*f*fd*r*s - 92*C*D1*f*fd*r + 60*C*D1*f*fd*s**2 - 136*C*D1*f*fd*s + 56*C*D1*f*fd + 288*C*Dd*f**2*r*s - 260*C*Dd*f**2*r + 120*C*Dd*f**2*s**2 - 382*C*Dd*f**2*s + 182*C*Dd*f**2 + 14*D1*K*f**2*r*s - 14*D1*K*f**2*s**2 - 14*D1*K*f**2*s + 56*D1*K*f*fd*r*s - 14*D1*K*f*fd*r + 126*D1*K*f*fd*s**2 - 91*D1*K*f*fd*s + 14*D1*K*f*fd + 14*D1*bd2*f*(2*s - 1)*(r + s - 1) + 47*D1*f**2*r*s - 74*D1*f**2*r + 15*D1*f**2*s**2 - 63*D1*f**2*s + 35*D1*f**2 - 108*D1*f*fd*r*s + 64*D1*f*fd*r - 30*D1*f*fd*s**2 + 77*D1*f*fd*s - 37*D1*f*fd + 56*D1*f*g2*r*s - 112*D1*f*g2*r + 42*D1*f*g2*s**2 - 196*D1*f*g2*s + 98*D1*f*g2 - 56*D1*f*gd2*r*s + 56*D1*f*gd2*r - 42*D1*f*gd2*s**2 + 126*D1*f*gd2*s - 56*D1*f*gd2 - 56*D1*fd*g2*r*s + 28*D1*fd*g2*r - 42*D1*fd*g2*s**2 + 42*D1*fd*g2*s + 112*Dd*K*f**2*r*s - 14*Dd*K*f**2*r + 252*Dd*K*f**2*s**2 - 147*Dd*K*f**2*s + 14*Dd*K*f**2 - 216*Dd*f**2*r*s + 175*Dd*f**2*r - 60*Dd*f**2*s**2 + 209*Dd*f**2*s - 109*Dd*f**2 - 224*Dd*f*g2*r*s + 252*Dd*f*g2*r - 168*Dd*f*g2*s**2 + 490*Dd*f*g2*s - 210*Dd*f*g2 - 7*b1*(D1*(f**2*(-2*r*s + r + s) + f*(K*(8*r*(s - 1) + 6*s**2 - 18*s + 7) + fd*(2*r - 1)*(4*s - 1) - 4*r*s + 2*r + 2*s) - fd*(K*(6*s**2 + s*(8*r - 1) - 2) - 4*r*s + r + s)) + Dd*f*(K*(-32*r*s + 20*r - 24*s**2 + 50*s - 17) + f*(2*r - 1)*(8*s - 3) + (2*r - 1)*(8*s - 3)))) + 3024*Dd**2*K*b1**2*f*r*s - 756*Dd**2*K*b1**2*f*r + 2268*Dd**2*K*b1**2*f*s**2 - 2646*Dd**2*K*b1**2*f*s + 504*Dd**2*K*b1**2*f + 3024*Dd**2*K*b1*f**2*r*s - 756*Dd**2*K*b1*f**2*r + 6804*Dd**2*K*b1*f**2*s**2 - 4914*Dd**2*K*b1*f**2*s + 504*Dd**2*K*b1*f**2 - 1512*Dd**2*b1**2*f**2*r*s + 378*Dd**2*b1**2*f**2*r + 756*Dd**2*b1**2*f**2*s - 252*Dd**2*b1**2*f**2 - 1512*Dd**2*b1**2*f*r*s + 378*Dd**2*b1**2*f*r + 756*Dd**2*b1**2*f*s - 252*Dd**2*b1**2*f - 5832*Dd**2*b1*f**2*r*s + 1458*Dd**2*b1*f**2*r - 1620*Dd**2*b1*f**2*s**2 + 3726*Dd**2*b1*f**2*s - 972*Dd**2*b1*f**2 - 6048*Dd**2*b1*f*g2*r*s + 1512*Dd**2*b1*f*g2*r - 4536*Dd**2*b1*f*g2*s**2 + 5292*Dd**2*b1*f*g2*s - 1008*Dd**2*b1*f*g2 - 3120*Dd**2*f**3*r*s + 780*Dd**2*f**3*r - 4860*Dd**2*f**3*s**2 + 3990*Dd**2*f**3*s - 520*Dd**2*f**3 - 6048*Dd**2*f**2*g2*r*s + 1512*Dd**2*f**2*g2*r - 13608*Dd**2*f**2*g2*s**2 + 9828*Dd**2*f**2*g2*s - 1008*Dd**2*f**2*g2 - 252*b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(630*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**4*k2*st**2*(-4500*C*D1**2*f**2*fd*s**2 + 3000*C*D1**2*f**2*fd*s - 1500*C*D1**2*f**2*fd + 2250*C*D1**2*f**2*fdd*s**2 - 1500*C*D1**2*f**2*fdd*s + 750*C*D1**2*f**2*fdd + 4500*C*D1**2*f*fd**2*s**2 - 3000*C*D1**2*f*fd**2*s - 6000*C*D1*Dd*f**3*s**2 + 3000*C*D1*Dd*f**3*s - 1500*C*D1*Dd*f**3 + 18000*C*D1*Dd*f**2*fd*s**2 - 10500*C*D1*Dd*f**2*fd*s + 1500*C*D1*Dd*f**2*fd + 3000*C*D1*Ddd*f**3*s**2 - 1500*C*D1*Ddd*f**3*s + 750*C*D1*Ddd*f**3 + 9000*C*Dd**2*f**3*s**2 - 4500*C*Dd**2*f**3*s - 2700*D1**2*K*b1*f*fd*s**2 + 2700*D1**2*K*b1*f*fd*s - 1350*D1**2*K*b1*f*fd + 1350*D1**2*K*b1*f*fdd*s**2 - 1350*D1**2*K*b1*f*fdd*s + 675*D1**2*K*b1*f*fdd + 1350*D1**2*K*b1*fd**2*s**2 - 1350*D1**2*K*b1*fd**2*s + 675*D1**2*K*bdd1*f**2*s**2 - 810*D1**2*b1*f**2*fd*r*s + 270*D1**2*b1*f**2*fd*r + 270*D1**2*b1*f**2*fd*s + 810*D1**2*b1*f**2*fdd*r*s - 270*D1**2*b1*f**2*fdd*r - 270*D1**2*b1*f**2*fdd*s + 1620*D1**2*b1*f*fd**2*r*s - 540*D1**2*b1*f*fd**2*r - 540*D1**2*b1*f*fd**2*s + 270*D1**2*b1*f*fd**2 - 1080*D1**2*b1*f*fd*r*s + 540*D1**2*b1*f*fd*r + 540*D1**2*b1*f*fdd*r*s - 270*D1**2*b1*f*fdd*r + 540*D1**2*b1*fd**2*r*s - 270*D1**2*b1*fd**2*r - 1350*D1**2*bd2*f**2*s**2 + 2700*D1**2*bd2*f*fd*s**2 - 1350*D1**2*bd2*f*fd*s + 270*D1**2*bdd1*f**3*r*s - 270*D1**2*bdd1*f**3*s + 270*D1**2*bdd1*f**2*r*s - 270*D1**2*bdd1*f**2*s + 675*D1**2*bdd2*f**2*s**2 - 1428*D1**2*f**2*fd*r*s + 476*D1**2*f**2*fd*r + 2250*D1**2*f**2*fd*s**2 - 1024*D1**2*f**2*fd*s + 750*D1**2*f**2*fd + 930*D1**2*f**2*fdd*r*s - 310*D1**2*f**2*fdd*r - 1125*D1**2*f**2*fdd*s**2 + 440*D1**2*f**2*fdd*s - 375*D1**2*f**2*fdd + 2700*D1**2*f**2*gd2*s**2 - 1350*D1**2*f**2*gdd2*s**2 + 1860*D1**2*f*fd**2*r*s - 620*D1**2*f*fd**2*r - 2250*D1**2*f*fd**2*s**2 + 880*D1**2*f*fd**2*s + 310*D1**2*f*fd**2 + 5400*D1**2*f*fd*g2*s**2 - 5400*D1**2*f*fd*g2*s + 2700*D1**2*f*fd*g2 - 5400*D1**2*f*fd*gd2*s**2 + 2700*D1**2*f*fd*gd2*s - 2700*D1**2*f*fdd*g2*s**2 + 2700*D1**2*f*fdd*g2*s - 1350*D1**2*f*fdd*g2 - 2700*D1**2*fd**2*g2*s**2 + 2700*D1**2*fd**2*g2*s - 5400*D1*Dd*K*b1*f**2*s**2 + 2700*D1*Dd*K*b1*f**2*s - 1350*D1*Dd*K*b1*f**2 + 10800*D1*Dd*K*b1*f*fd*s**2 - 8100*D1*Dd*K*b1*f*fd*s + 1350*D1*Dd*K*b1*f*fd - 1080*D1*Dd*b1*f**3*r*s + 270*D1*Dd*b1*f**3*r + 540*D1*Dd*b1*f**3*s + 6480*D1*Dd*b1*f**2*fd*r*s - 1890*D1*Dd*b1*f**2*fd*r - 2700*D1*Dd*b1*f**2*fd*s + 810*D1*Dd*b1*f**2*fd - 2160*D1*Dd*b1*f**2*r*s + 540*D1*Dd*b1*f**2*r + 1080*D1*Dd*b1*f**2*s + 4320*D1*Dd*b1*f*fd*r*s - 1620*D1*Dd*b1*f*fd*r - 1080*D1*Dd*b1*f*fd*s + 540*D1*Dd*b1*f*fd + 5400*D1*Dd*bd2*f**2*s**2 - 1350*D1*Dd*bd2*f**2*s - 1904*D1*Dd*f**3*r*s + 476*D1*Dd*f**3*r + 3000*D1*Dd*f**3*s**2 - 548*D1*Dd*f**3*s + 750*D1*Dd*f**3 + 7440*D1*Dd*f**2*fd*r*s - 2170*D1*Dd*f**2*fd*r - 9000*D1*Dd*f**2*fd*s**2 + 2150*D1*Dd*f**2*fd*s + 180*D1*Dd*f**2*fd + 10800*D1*Dd*f**2*g2*s**2 - 5400*D1*Dd*f**2*g2*s + 2700*D1*Dd*f**2*g2 - 10800*D1*Dd*f**2*gd2*s**2 + 2700*D1*Dd*f**2*gd2*s - 21600*D1*Dd*f*fd*g2*s**2 + 16200*D1*Dd*f*fd*g2*s - 2700*D1*Dd*f*fd*g2 + 2700*D1*Ddd*K*b1*f**2*s**2 - 1350*D1*Ddd*K*b1*f**2*s + 675*D1*Ddd*K*b1*f**2 + 1080*D1*Ddd*b1*f**3*r*s - 270*D1*Ddd*b1*f**3*r - 540*D1*Ddd*b1*f**3*s + 1080*D1*Ddd*b1*f**2*r*s - 270*D1*Ddd*b1*f**2*r - 540*D1*Ddd*b1*f**2*s + 1240*D1*Ddd*f**3*r*s - 310*D1*Ddd*f**3*r - 1500*D1*Ddd*f**3*s**2 + 130*D1*Ddd*f**3*s - 375*D1*Ddd*f**3 - 5400*D1*Ddd*f**2*g2*s**2 + 2700*D1*Ddd*f**2*g2*s - 1350*D1*Ddd*f**2*g2 - 270*D1*bd1*f*(D1*(f*s*(5*K*s + f*(r - 1) + 2*r - 2) + fd*(f*(-6*r*s + r + 4*s - 1) - 4*r*s + r - (2*s - 1)*(5*K*s - 1))) - Dd*f*(20*K*s**2 - 5*K*s + f*r*(8*s - 1) - 6*f*s + f + r*(8*s - 1) - 6*s + 1)) + 8100*Dd**2*K*b1*f**2*s**2 - 4050*Dd**2*K*b1*f**2*s + 3240*Dd**2*b1*f**3*r*s - 810*Dd**2*b1*f**3*r - 1620*Dd**2*b1*f**3*s + 540*Dd**2*b1*f**3 + 3240*Dd**2*b1*f**2*r*s - 810*Dd**2*b1*f**2*r - 1620*Dd**2*b1*f**2*s + 540*Dd**2*b1*f**2 + 3720*Dd**2*f**3*r*s - 930*Dd**2*f**3*r - 4500*Dd**2*f**3*s**2 + 390*Dd**2*f**3*s + 620*Dd**2*f**3 - 16200*Dd**2*f**2*g2*s**2 + 8100*Dd**2*f**2*g2*s - 675*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(630*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**4*k2*(-2592*C*D1**2*b1*f*fd*r*s + 1296*C*D1**2*b1*f*fd*r + 936*C*D1**2*b1*f*fd*s + 180*C*D1**2*b1*f*fd + 1296*C*D1**2*b1*f*fdd*r*s - 648*C*D1**2*b1*f*fdd*r - 468*C*D1**2*b1*f*fdd*s - 90*C*D1**2*b1*f*fdd + 1296*C*D1**2*b1*fd**2*r*s - 648*C*D1**2*b1*fd**2*r - 468*C*D1**2*b1*fd**2*s + 648*C*D1**2*b1*fd**2 + 648*C*D1**2*bdd1*f**2*r*s - 180*C*D1**2*bdd1*f**2*s + 90*C*D1**2*bdd1*f**2 + 2040*C*D1**2*f**2*fd*r*s - 680*C*D1**2*f**2*fd*r + 3240*C*D1**2*f**2*fd*s**2 - 2840*C*D1**2*f**2*fd*s + 1080*C*D1**2*f**2*fd - 1560*C*D1**2*f**2*fdd*r*s + 520*C*D1**2*f**2*fdd*r - 2430*C*D1**2*f**2*fdd*s**2 + 2140*C*D1**2*f**2*fdd*s - 810*C*D1**2*f**2*fdd - 3120*C*D1**2*f*fd**2*r*s + 1040*C*D1**2*f*fd**2*r - 4860*C*D1**2*f*fd**2*s**2 + 4280*C*D1**2*f*fd**2*s - 520*C*D1**2*f*fd**2 - 5184*C*D1*Dd*b1*f**2*r*s + 1296*C*D1*Dd*b1*f**2*r + 2592*C*D1*Dd*b1*f**2*s + 10368*C*D1*Dd*b1*f*fd*r*s - 3888*C*D1*Dd*b1*f*fd*r - 4464*C*D1*Dd*b1*f*fd*s + 1764*C*D1*Dd*b1*f*fd + 2720*C*D1*Dd*f**3*r*s - 680*C*D1*Dd*f**3*r + 4320*C*D1*Dd*f**3*s**2 - 3520*C*D1*Dd*f**3*s + 1080*C*D1*Dd*f**3 - 12480*C*D1*Dd*f**2*fd*r*s + 3640*C*D1*Dd*f**2*fd*r - 19440*C*D1*Dd*f**2*fd*s**2 + 16540*C*D1*Dd*f**2*fd*s - 3180*C*D1*Dd*f**2*fd + 2592*C*D1*Ddd*b1*f**2*r*s - 648*C*D1*Ddd*b1*f**2*r - 1296*C*D1*Ddd*b1*f**2*s - 2080*C*D1*Ddd*f**3*r*s + 520*C*D1*Ddd*f**3*r - 3240*C*D1*Ddd*f**3*s**2 + 2660*C*D1*Ddd*f**3*s - 810*C*D1*Ddd*f**3 + 7776*C*Dd**2*b1*f**2*r*s - 1944*C*Dd**2*b1*f**2*r - 3888*C*Dd**2*b1*f**2*s + 1296*C*Dd**2*b1*f**2 - 6240*C*Dd**2*f**3*r*s + 1560*C*Dd**2*f**3*r - 9720*C*Dd**2*f**3*s**2 + 7980*C*Dd**2*f**3*s - 1040*C*Dd**2*f**3 - 504*D1**2*K*b1**2*fd*r*s + 504*D1**2*K*b1**2*fd*r - 252*D1**2*K*b1**2*fd*s + 126*D1**2*K*b1**2*fd + 252*D1**2*K*b1**2*fdd*r*s - 252*D1**2*K*b1**2*fdd*r + 126*D1**2*K*b1**2*fdd*s - 63*D1**2*K*b1**2*fdd + 504*D1**2*K*b1*bdd1*f*r*s - 378*D1**2*K*b1*bdd1*f*s + 63*D1**2*K*b1*bdd1*f + 504*D1**2*K*b1*f*fd*r*s - 252*D1**2*K*b1*f*fd*r + 1512*D1**2*K*b1*f*fd*s**2 - 1512*D1**2*K*b1*f*fd*s + 756*D1**2*K*b1*f*fd - 504*D1**2*K*b1*f*fdd*r*s + 252*D1**2*K*b1*f*fdd*r - 1134*D1**2*K*b1*f*fdd*s**2 + 1134*D1**2*K*b1*f*fdd*s - 567*D1**2*K*b1*f*fdd - 504*D1**2*K*b1*fd**2*r*s + 252*D1**2*K*b1*fd**2*r - 1134*D1**2*K*b1*fd**2*s**2 + 1134*D1**2*K*b1*fd**2*s - 252*D1**2*K*bdd1*f**2*r*s - 567*D1**2*K*bdd1*f**2*s**2 + 252*D1**2*K*bdd1*f**2*s - 126*D1**2*b1**2*f*fd*r + 126*D1**2*b1**2*f*fdd*r + 126*D1**2*b1**2*fd**2*r - 126*D1**2*b1**2*fd**2 - 252*D1**2*b1**2*fd*r + 126*D1**2*b1**2*fdd*r - 126*D1**2*b1*bd2*f*s**2 + 126*D1**2*b1*bd2*fd*s**2 - 126*D1**2*b1*bdd1*f**2*r - 126*D1**2*b1*bdd1*f*r + 63*D1**2*b1*bdd2*f*s**2 + 1548*D1**2*b1*f*fd*r*s - 1098*D1**2*b1*f*fd*r - 468*D1**2*b1*f*fd*s - 90*D1**2*b1*f*fd - 648*D1**2*b1*f*fdd*r*s + 486*D1**2*b1*f*fdd*r + 234*D1**2*b1*f*fdd*s + 45*D1**2*b1*f*fdd + 1008*D1**2*b1*f*gd2*r*s - 1008*D1**2*b1*f*gd2*s - 504*D1**2*b1*f*gdd2*r*s + 504*D1**2*b1*f*gdd2*s - 648*D1**2*b1*fd**2*r*s + 486*D1**2*b1*fd**2*r + 234*D1**2*b1*fd**2*s - 486*D1**2*b1*fd**2 + 1008*D1**2*b1*fd*g2*r*s - 1008*D1**2*b1*fd*g2*r + 504*D1**2*b1*fd*g2*s - 252*D1**2*b1*fd*g2 - 1008*D1**2*b1*fd*gd2*r*s + 504*D1**2*b1*fd*gd2*r + 252*D1**2*b1*fd*gd2*s - 504*D1**2*b1*fd*gd2 - 504*D1**2*b1*fdd*g2*r*s + 504*D1**2*b1*fdd*g2*r - 252*D1**2*b1*fdd*g2*s + 126*D1**2*b1*fdd*g2 - 126*D1**2*bd1**2*f*(-4*K*r*s + 3*K*s + f*(r - 1) + r - 1) + 252*D1**2*bd2*f**2*r*s + 756*D1**2*bd2*f**2*s**2 - 252*D1**2*bd2*f**2*s - 1008*D1**2*bd2*f*fd*r*s + 252*D1**2*bd2*f*fd*r - 2268*D1**2*bd2*f*fd*s**2 + 1638*D1**2*bd2*f*fd*s - 252*D1**2*bd2*f*fd - 324*D1**2*bdd1*f**2*r*s - 162*D1**2*bdd1*f**2*r + 90*D1**2*bdd1*f**2*s - 45*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r*s + 252*D1**2*bdd1*f*g2*s - 126*D1**2*bdd1*f*g2 - 252*D1**2*bdd2*f**2*r*s - 567*D1**2*bdd2*f**2*s**2 + 252*D1**2*bdd2*f**2*s - 750*D1**2*f**2*fd*r*s + 250*D1**2*f**2*fd*r - 1620*D1**2*f**2*fd*s**2 + 1330*D1**2*f**2*fd*s - 540*D1**2*f**2*fd + 780*D1**2*f**2*fdd*r*s - 260*D1**2*f**2*fdd*r + 1215*D1**2*f**2*fdd*s**2 - 1070*D1**2*f**2*fdd*s + 405*D1**2*f**2*fdd - 504*D1**2*f**2*gd2*r*s - 1512*D1**2*f**2*gd2*s**2 + 504*D1**2*f**2*gd2*s + 504*D1**2*f**2*gdd2*r*s + 1134*D1**2*f**2*gdd2*s**2 - 504*D1**2*f**2*gdd2*s + 1560*D1**2*f*fd**2*r*s - 520*D1**2*f*fd**2*r + 2430*D1**2*f*fd**2*s**2 - 2140*D1**2*f*fd**2*s + 260*D1**2*f*fd**2 - 1008*D1**2*f*fd*g2*r*s + 504*D1**2*f*fd*g2*r - 3024*D1**2*f*fd*g2*s**2 + 3024*D1**2*f*fd*g2*s - 1512*D1**2*f*fd*g2 + 2016*D1**2*f*fd*gd2*r*s - 504*D1**2*f*fd*gd2*r + 4536*D1**2*f*fd*gd2*s**2 - 3276*D1**2*f*fd*gd2*s + 504*D1**2*f*fd*gd2 + 1008*D1**2*f*fdd*g2*r*s - 504*D1**2*f*fdd*g2*r + 2268*D1**2*f*fdd*g2*s**2 - 2268*D1**2*f*fdd*g2*s + 1134*D1**2*f*fdd*g2 + 1008*D1**2*fd**2*g2*r*s - 504*D1**2*fd**2*g2*r + 2268*D1**2*fd**2*g2*s**2 - 2268*D1**2*fd**2*g2*s - 2016*D1*Dd*K*b1**2*f*r*s + 504*D1*Dd*K*b1**2*f*r + 1008*D1*Dd*K*b1**2*f*s + 2016*D1*Dd*K*b1**2*fd*r*s - 1260*D1*Dd*K*b1**2*fd*r + 378*D1*Dd*K*b1**2*fd + 1008*D1*Dd*K*b1*f**2*r*s - 252*D1*Dd*K*b1*f**2*r + 3024*D1*Dd*K*b1*f**2*s**2 - 2016*D1*Dd*K*b1*f**2*s + 756*D1*Dd*K*b1*f**2 - 4032*D1*Dd*K*b1*f*fd*r*s + 1512*D1*Dd*K*b1*f*fd*r - 9072*D1*Dd*K*b1*f*fd*s**2 + 7812*D1*Dd*K*b1*f*fd*s - 1638*D1*Dd*K*b1*f*fd + 504*D1*Dd*b1**2*f*fd*r - 252*D1*Dd*b1**2*f*fd + 504*D1*Dd*b1**2*fd*r - 252*D1*Dd*b1**2*fd + 504*D1*Dd*b1*bd2*f*s**2 - 126*D1*Dd*b1*bd2*f*s + 3096*D1*Dd*b1*f**2*r*s - 774*D1*Dd*b1*f**2*r - 1548*D1*Dd*b1*f**2*s - 5184*D1*Dd*b1*f*fd*r*s + 2592*D1*Dd*b1*f*fd*r + 2232*D1*Dd*b1*f*fd*s - 1206*D1*Dd*b1*f*fd + 4032*D1*Dd*b1*f*g2*r*s - 1008*D1*Dd*b1*f*g2*r - 2016*D1*Dd*b1*f*g2*s - 4032*D1*Dd*b1*f*gd2*r*s + 504*D1*Dd*b1*f*gd2*r + 3024*D1*Dd*b1*f*gd2*s - 504*D1*Dd*b1*f*gd2 - 4032*D1*Dd*b1*fd*g2*r*s + 2520*D1*Dd*b1*fd*g2*r - 756*D1*Dd*b1*fd*g2 - 2016*D1*Dd*bd2*f**2*r*s + 252*D1*Dd*bd2*f**2*r - 4536*D1*Dd*bd2*f**2*s**2 + 2646*D1*Dd*bd2*f**2*s - 252*D1*Dd*bd2*f**2 - 1000*D1*Dd*f**3*r*s + 250*D1*Dd*f**3*r - 2160*D1*Dd*f**3*s**2 + 1580*D1*Dd*f**3*s - 540*D1*Dd*f**3 + 6240*D1*Dd*f**2*fd*r*s - 1820*D1*Dd*f**2*fd*r + 9720*D1*Dd*f**2*fd*s**2 - 8270*D1*Dd*f**2*fd*s + 1590*D1*Dd*f**2*fd - 2016*D1*Dd*f**2*g2*r*s + 504*D1*Dd*f**2*g2*r - 6048*D1*Dd*f**2*g2*s**2 + 4032*D1*Dd*f**2*g2*s - 1512*D1*Dd*f**2*g2 + 4032*D1*Dd*f**2*gd2*r*s - 504*D1*Dd*f**2*gd2*r + 9072*D1*Dd*f**2*gd2*s**2 - 5292*D1*Dd*f**2*gd2*s + 504*D1*Dd*f**2*gd2 + 8064*D1*Dd*f*fd*g2*r*s - 3024*D1*Dd*f*fd*g2*r + 18144*D1*Dd*f*fd*g2*s**2 - 15624*D1*Dd*f*fd*g2*s + 3276*D1*Dd*f*fd*g2 + 1008*D1*Ddd*K*b1**2*f*r*s - 252*D1*Ddd*K*b1**2*f*r - 504*D1*Ddd*K*b1**2*f*s - 1008*D1*Ddd*K*b1*f**2*r*s + 252*D1*Ddd*K*b1*f**2*r - 2268*D1*Ddd*K*b1*f**2*s**2 + 1638*D1*Ddd*K*b1*f**2*s - 567*D1*Ddd*K*b1*f**2 - 1296*D1*Ddd*b1*f**2*r*s + 324*D1*Ddd*b1*f**2*r + 648*D1*Ddd*b1*f**2*s - 2016*D1*Ddd*b1*f*g2*r*s + 504*D1*Ddd*b1*f*g2*r + 1008*D1*Ddd*b1*f*g2*s + 1040*D1*Ddd*f**3*r*s - 260*D1*Ddd*f**3*r + 1620*D1*Ddd*f**3*s**2 - 1330*D1*Ddd*f**3*s + 405*D1*Ddd*f**3 + 2016*D1*Ddd*f**2*g2*r*s - 504*D1*Ddd*f**2*g2*r + 4536*D1*Ddd*f**2*g2*s**2 - 3276*D1*Ddd*f**2*g2*s + 1134*D1*Ddd*f**2*g2 + 18*D1*bd1*(D1*(f**2*(-2*C*(s*(36*r - 10) + 5) + 42*K*s**2 - 14*K*s + r*(14*K*s + 43*s + 18) - 17*s + 5) + f*(fd*(-46*C*s - 7*K*(r*(8*s - 2) + 18*s**2 - 13*s + 2) + 9*r*(16*C*s - 4*C - 8*s + 1) + 23*s + 9) + 7*g2*(s*(8*r - 4) + 2) + 7*s*(bd2*(s - 1) - 8*gd2*r + 6*gd2)) + 28*fd*g2*r*(1 - 2*s)) + Dd*f*(f*(2*C*(18*r*(8*s - 1) - 56*s + 5) - 7*K*(16*r*s - 2*r + 36*s**2 - 21*s + 2) - 144*r*s - 18*r + 56*s + 13) - 14*g2*(2*r - 1)*(8*s - 1)) - 7*b1*(D1*(f*(K*s*(8*r - 6) + K - r*(f + 2)) + fd*(K*(-8*r*s + 4*r + s - 2) - r + 1)) + Dd*f*(K*(-32*r*s + 4*r + 20*s - 3) + f*(4*r - 2) + 4*r - 2))) + 3024*Dd**2*K*b1**2*f*r*s - 756*Dd**2*K*b1**2*f*r - 1512*Dd**2*K*b1**2*f*s + 504*Dd**2*K*b1**2*f - 3024*Dd**2*K*b1*f**2*r*s + 756*Dd**2*K*b1*f**2*r - 6804*Dd**2*K*b1*f**2*s**2 + 4914*Dd**2*K*b1*f**2*s - 504*Dd**2*K*b1*f**2 - 3888*Dd**2*b1*f**2*r*s + 972*Dd**2*b1*f**2*r + 1944*Dd**2*b1*f**2*s - 648*Dd**2*b1*f**2 - 6048*Dd**2*b1*f*g2*r*s + 1512*Dd**2*b1*f*g2*r + 3024*Dd**2*b1*f*g2*s - 1008*Dd**2*b1*f*g2 + 3120*Dd**2*f**3*r*s - 780*Dd**2*f**3*r + 4860*Dd**2*f**3*s**2 - 3990*Dd**2*f**3*s + 520*Dd**2*f**3 + 6048*Dd**2*f**2*g2*r*s - 1512*Dd**2*f**2*g2*r + 13608*Dd**2*f**2*g2*s**2 - 9828*Dd**2*f**2*g2*s + 1008*Dd**2*f**2*g2 - 63*b2*(2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s + 8*D1*Dd*b1*f*s**2 - 4*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*s**2 + 2*D1*Dd*b1*fd*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 124*D1*Dd*f*fd*s + 26*D1*Dd*f*fd - 4*D1*Ddd*b1*f*s**2 + 2*D1*Ddd*b1*f*s - D1*Ddd*b1*f + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 26*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) - 12*Dd**2*b1*f*s**2 + 6*Dd**2*b1*f*s + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 78*Dd**2*f**2*s + 8*Dd**2*f**2))/(630*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**4*(D1*(14*D1*bd1**2*f*s*(5*K*s + f*(2*r - 1) + 2*r - 1) + D1*bdd1*f*s*(18*f*r + f*s*(50*C - 25) + s*(35*b2 - 70*g2)) + 2*bd1*(D1*(f**2*s*(-18*r + s*(25 - 50*C)) + f*(9*fd*r*(4*s - 1) + 2*fd*s*(25*C*(2*s - 1) - 25*s + 8) + s**2*(-35*b2 + 35*bd2 + 70*g2 - 70*gd2)) + 35*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(9*f*r*(8*s - 1) + f*s*(50*C*(4*s - 1) - 100*s + 7) + s*(35*b2 - 70*g2)*(4*s - 1)))) + 7*b1**2*(2*D1*Dd*(f*(-5*K*(4*s**2 - 2*s + 1) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(5*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(4*s - 2) - 2*s + 2) - 2*fd*(5*K*(s - 1)**2 - f*s + r*(2*f*s - f + 2*s - 2)) + fdd*(5*K*(s - 1)**2 - 2*f*s + 2*r*(2*f*s - f + s - 1))) + Ddd*f*(5*K*(4*s**2 - 2*s + 1) + (2*f + 2)*(r*(4*s - 1) - 2*s))) + 2*Dd**2*f*(30*K*s**2 - 15*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(-200*C*D1**2*f*fd*s**2 + 200*C*D1**2*f*fd*s - 100*C*D1**2*f*fd + 100*C*D1**2*f*fdd*s**2 - 100*C*D1**2*f*fdd*s + 50*C*D1**2*f*fdd + 100*C*D1**2*fd**2*s**2 - 100*C*D1**2*fd**2*s - 400*C*D1*Dd*f**2*s**2 + 200*C*D1*Dd*f**2*s - 100*C*D1*Dd*f**2 + 800*C*D1*Dd*f*fd*s**2 - 600*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*s**2 - 100*C*D1*Ddd*f**2*s + 50*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*s**2 - 300*C*Dd**2*f**2*s + 70*D1**2*K*bdd1*f*s**2 - 70*D1**2*bd2*f*s**2 + 70*D1**2*bd2*fd*s**2 - 70*D1**2*bd2*fd*s + 28*D1**2*bdd1*f**2*r*s - 14*D1**2*bdd1*f**2*s + 28*D1**2*bdd1*f*r*s - 14*D1**2*bdd1*f*s + 35*D1**2*bdd2*f*s**2 - 72*D1**2*f*fd*r*s + 36*D1**2*f*fd*r + 100*D1**2*f*fd*s**2 - 64*D1**2*f*fd*s + 50*D1**2*f*fd + 36*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r - 50*D1**2*f*fdd*s**2 + 32*D1**2*f*fdd*s - 25*D1**2*f*fdd + 140*D1**2*f*gd2*s**2 - 70*D1**2*f*gdd2*s**2 + 36*D1**2*fd**2*r*s - 18*D1**2*fd**2*r - 50*D1**2*fd**2*s**2 + 32*D1**2*fd**2*s + 18*D1**2*fd**2 + 140*D1**2*fd*g2*s**2 - 280*D1**2*fd*g2*s + 140*D1**2*fd*g2 - 140*D1**2*fd*gd2*s**2 + 140*D1**2*fd*gd2*s - 70*D1**2*fdd*g2*s**2 + 140*D1**2*fdd*g2*s - 70*D1**2*fdd*g2 + 280*D1*Dd*bd2*f*s**2 - 70*D1*Dd*bd2*f*s - 144*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r + 200*D1*Dd*f**2*s**2 - 28*D1*Dd*f**2*s + 50*D1*Dd*f**2 + 288*D1*Dd*f*fd*r*s - 108*D1*Dd*f*fd*r - 400*D1*Dd*f*fd*s**2 + 156*D1*Dd*f*fd*s + 4*D1*Dd*f*fd + 560*D1*Dd*f*g2*s**2 - 280*D1*Dd*f*g2*s + 140*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*s**2 + 140*D1*Dd*f*gd2*s - 560*D1*Dd*fd*g2*s**2 + 700*D1*Dd*fd*g2*s - 140*D1*Dd*fd*g2 + 72*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r - 100*D1*Ddd*f**2*s**2 + 14*D1*Ddd*f**2*s - 25*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*s**2 + 140*D1*Ddd*f*g2*s - 70*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(f*s*(-10*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(10*K*s - 1))) + Dd*f*(40*K*s**2 - 10*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) + 216*Dd**2*f**2*r*s - 54*Dd**2*f**2*r - 300*Dd**2*f**2*s**2 + 42*Dd**2*f**2*s + 36*Dd**2*f**2 - 840*Dd**2*f*g2*s**2 + 420*Dd**2*f*g2*s - 35*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(70*d**2*k2) + 5*D1**2*Pk3*Pkd2*ct**3*f**2*k1**5*st**2*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(11*d**2*k2**2*k3**4) + D1**2*Pk3*Pkd2*ct**3*f*k1**5*(30*D1**2*b1*f*fd*s**2 - 15*D1**2*b1*f*fdd*s**2 - 30*D1**2*b1*fd**2*s**2 - 5*D1**2*bdd1*f**2*(s - 1)**2 - 56*D1**2*f**2*fd*s**2 + 28*D1**2*f**2*fd*s - 14*D1**2*f**2*fd + 28*D1**2*f**2*fdd*s**2 - 14*D1**2*f**2*fdd*s + 7*D1**2*f**2*fdd + 84*D1**2*f*fd**2*s**2 - 42*D1**2*f*fd**2*s + 40*D1*Dd*b1*f**2*s**2 - 20*D1*Dd*b1*f**2*s + 10*D1*Dd*b1*f**2 - 120*D1*Dd*b1*f*fd*s**2 + 30*D1*Dd*b1*f*fd*s - 56*D1*Dd*f**3*s**2 + 28*D1*Dd*f**3*s - 14*D1*Dd*f**3 + 224*D1*Dd*f**2*fd*s**2 - 112*D1*Dd*f**2*fd*s + 14*D1*Dd*f**2*fd - 20*D1*Ddd*b1*f**2*s**2 + 10*D1*Ddd*b1*f**2*s - 5*D1*Ddd*b1*f**2 + 28*D1*Ddd*f**3*s**2 - 14*D1*Ddd*f**3*s + 7*D1*Ddd*f**3 + 10*D1*bd1*f*(s - 1)*(D1*f*(s - 1) - 3*D1*fd*s + Dd*f*(1 - 4*s)) - 60*Dd**2*b1*f**2*s**2 + 30*Dd**2*b1*f**2*s + 84*Dd**2*f**3*s**2 - 42*Dd**2*f**3*s)/(18*d**2*k2**2*k3**4) + D1**2*Pk3*Pkd2*ct**3*f*k2**4*st**2*(16*C - 8)*(D1*Dd*f*(11*f*(-4*r*s + r + 2*s) + 10*fd*(24*r*s - 7*r - 10*s + 3)) + D1*(D1*(11*f*fd*(-3*r*s + r + s) + 10*f*fdd*(3*r*s - r - s) + 10*fd**2*(6*r*s - 2*r - 2*s + 1)) + 10*Ddd*f**2*(r*(4*s - 1) - 2*s)) + 10*Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2))/(315*d**2*k1*k3**4) - D1**2*Pk3*Pkd2*ct**3*f*k2**2*st**2*(16*C - 8)*(D1*Dd*f*(11*f*(-4*r*s + r + 2*s) + 10*fd*(24*r*s - 7*r - 10*s + 3)) + D1*(D1*(11*f*fd*(-3*r*s + r + s) + 10*f*fdd*(3*r*s - r - s) + 10*fd**2*(6*r*s - 2*r - 2*s + 1)) + 10*Ddd*f**2*(r*(4*s - 1) - 2*s)) + 10*Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2))/(315*d**2*k1*k3**2) + 4*D1**2*Pk3*Pkd2*ct**3*k1**5*st**2*(1386*C*D1**2*f**2*fd*r*s - 462*C*D1**2*f**2*fd*r + 1386*C*D1**2*f**2*fd*s**2 - 1386*C*D1**2*f**2*fd*s + 462*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 1848*C*D1*Dd*f**3*r*s - 462*C*D1*Dd*f**3*r + 1848*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 462*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 7240*D1**2*f**3*fd*r*s - 1810*D1**2*f**3*fd*r + 7240*D1**2*f**3*fd*s**2 - 7240*D1**2*f**3*fd*s + 1810*D1**2*f**3*fd - 5600*D1**2*f**3*fdd*r*s + 1400*D1**2*f**3*fdd*r - 5600*D1**2*f**3*fdd*s**2 + 5600*D1**2*f**3*fdd*s - 1400*D1**2*f**3*fdd - 16800*D1**2*f**2*fd**2*r*s + 4200*D1**2*f**2*fd**2*r - 16800*D1**2*f**2*fd**2*s**2 + 16800*D1**2*f**2*fd**2*s - 2800*D1**2*f**2*fd**2 - 1386*D1**2*f**2*fd*r*s + 462*D1**2*f**2*fd*r - 1386*D1**2*f**2*fd*s**2 + 1386*D1**2*f**2*fd*s - 462*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*s**2 + 726*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 1452*D1**2*f*fd*g2*r*s + 726*D1**2*f*fd*g2*r - 1452*D1**2*f*fd*g2*s**2 + 1452*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 7240*D1*Dd*f**4*r*s - 1810*D1*Dd*f**4*r + 7240*D1*Dd*f**4*s**2 - 7240*D1*Dd*f**4*s + 1810*D1*Dd*f**4 - 44800*D1*Dd*f**3*fd*r*s + 11200*D1*Dd*f**3*fd*r - 44800*D1*Dd*f**3*fd*s**2 + 44800*D1*Dd*f**3*fd*s - 8400*D1*Dd*f**3*fd - 1848*D1*Dd*f**3*r*s + 462*D1*Dd*f**3*r - 1848*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 462*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 2904*D1*Dd*f**2*g2*r*s + 726*D1*Dd*f**2*g2*r - 2904*D1*Dd*f**2*g2*s**2 + 2904*D1*Dd*f**2*g2*s - 726*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 5600*D1*Ddd*f**4*r*s + 1400*D1*Ddd*f**4*r - 5600*D1*Ddd*f**4*s**2 + 5600*D1*Ddd*f**4*s - 1400*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 16800*Dd**2*f**4*r*s + 4200*Dd**2*f**4*r - 16800*Dd**2*f**4*s**2 + 16800*Dd**2*f**4*s - 2800*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**3*k1**5*(-D1*(63*D1*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + D1*bdd1*f*(r + s - 1)*(35*f**2*(3*s - 4) + f*(90*C - 90)*(s - 1) - 126*g2*(s - 1)) + bd1*(D1*(-5*f**3*(24*s - 29)*(r + s - 1) + f**2*(-54*C*(s - 1)*(r + s - 1) + 35*fd*(18*r*s - 11*r + 18*s**2 - 26*s + 7) + (54*s - 54)*(r + s - 1)) + 6*f*(fd*(15*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (7*g2*(s - 1) + 7*gd2*(3 - 6*s))*(r + s - 1)) - 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(35*f**2*(r*(24*s - 19) + 24*s**2 - 40*s + 15) + f*(90*C - 90)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 126*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 35*f**3*(D1*fd + Dd*f)*(r*(4*s - 1) + (1 - 2*s)**2)) + 21*b1**2*(K - 1)*(D1**2*s*(fd - 3*fdd)*(r + s) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*fd*(-8*r*s + r + s*(4 - 8*s))) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(108*C*D1**2*f*fd*r*s + 108*C*D1**2*f*fd*s**2 - 54*C*D1**2*f*fd*s - 180*C*D1**2*f*fdd*r*s - 180*C*D1**2*f*fdd*s**2 + 90*C*D1**2*f*fdd*s - 180*C*D1**2*fd**2*r*s - 180*C*D1**2*fd**2*s**2 + 90*C*D1**2*fd**2*s + 216*C*D1*Dd*f**2*r*s - 54*C*D1*Dd*f**2*r + 216*C*D1*Dd*f**2*s**2 - 216*C*D1*Dd*f**2*s + 54*C*D1*Dd*f**2 - 1440*C*D1*Dd*f*fd*r*s + 180*C*D1*Dd*f*fd*r - 1440*C*D1*Dd*f*fd*s**2 + 1080*C*D1*Dd*f*fd*s - 90*C*D1*Dd*f*fd - 360*C*D1*Ddd*f**2*r*s + 90*C*D1*Ddd*f**2*r - 360*C*D1*Ddd*f**2*s**2 + 360*C*D1*Ddd*f**2*s - 90*C*D1*Ddd*f**2 - 1080*C*Dd**2*f**2*r*s + 270*C*Dd**2*f**2*r - 1080*C*Dd**2*f**2*s**2 + 1080*C*Dd**2*f**2*s - 180*C*Dd**2*f**2 - 63*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 360*D1**2*f**2*fd*r*s + 25*D1**2*f**2*fd*r + 360*D1**2*f**2*fd*s**2 - 215*D1**2*f**2*fd*s - 25*D1**2*f**2*fd - 315*D1**2*f**2*fdd*r*s - 35*D1**2*f**2*fdd*r - 315*D1**2*f**2*fdd*s**2 + 175*D1**2*f**2*fdd*s + 35*D1**2*f**2*fdd - 630*D1**2*f*fd**2*r*s - 70*D1**2*f*fd**2*r - 630*D1**2*f*fd**2*s**2 + 350*D1**2*f*fd**2*s + 35*D1**2*f*fd**2 - 108*D1**2*f*fd*r*s - 108*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s + 180*D1**2*f*fdd*r*s + 180*D1**2*f*fdd*s**2 - 90*D1**2*f*fdd*s - 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*s**2 + 42*D1**2*f*gd2*s + 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*s**2 - 126*D1**2*f*gdd2*s + 180*D1**2*fd**2*r*s + 180*D1**2*fd**2*s**2 - 90*D1**2*fd**2*s - 42*D1**2*fd*g2*r*s - 42*D1**2*fd*g2*s**2 + 252*D1**2*fd*gd2*r*s + 252*D1**2*fd*gd2*s**2 - 126*D1**2*fd*gd2*s + 126*D1**2*fdd*g2*r*s + 126*D1**2*fdd*g2*s**2 + 480*D1*Dd*f**3*r*s - 120*D1*Dd*f**3*r + 480*D1*Dd*f**3*s**2 - 480*D1*Dd*f**3*s + 120*D1*Dd*f**3 - 2520*D1*Dd*f**2*fd*r*s + 175*D1*Dd*f**2*fd*r - 2520*D1*Dd*f**2*fd*s**2 + 1960*D1*Dd*f**2*fd*s - 105*D1*Dd*f**2*fd - 216*D1*Dd*f**2*r*s + 54*D1*Dd*f**2*r - 216*D1*Dd*f**2*s**2 + 216*D1*Dd*f**2*s - 54*D1*Dd*f**2 + 1440*D1*Dd*f*fd*r*s - 180*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 1080*D1*Dd*f*fd*s + 90*D1*Dd*f*fd - 168*D1*Dd*f*g2*r*s + 42*D1*Dd*f*g2*r - 168*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 42*D1*Dd*f*g2 + 1008*D1*Dd*f*gd2*r*s - 126*D1*Dd*f*gd2*r + 1008*D1*Dd*f*gd2*s**2 - 1008*D1*Dd*f*gd2*s + 126*D1*Dd*f*gd2 + 1008*D1*Dd*fd*g2*r*s - 126*D1*Dd*fd*g2*r + 1008*D1*Dd*fd*g2*s**2 - 504*D1*Dd*fd*g2*s - 420*D1*Ddd*f**3*r*s + 105*D1*Ddd*f**3*r - 420*D1*Ddd*f**3*s**2 + 420*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 + 360*D1*Ddd*f**2*r*s - 90*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 360*D1*Ddd*f**2*s + 90*D1*Ddd*f**2 + 504*D1*Ddd*f*g2*r*s - 126*D1*Ddd*f*g2*r + 504*D1*Ddd*f*g2*s**2 - 504*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 + 21*D1*bd1*(K - 1)*(D1*(f*(2*s - 1)*(r + s - 1) + 3*fd*(-4*r*s + r + s*(3 - 4*s))) - 3*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 1260*Dd**2*f**3*r*s + 315*Dd**2*f**3*r - 1260*Dd**2*f**3*s**2 + 1260*Dd**2*f**3*s - 210*Dd**2*f**3 + 1080*Dd**2*f**2*r*s - 270*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1080*Dd**2*f**2*s + 180*Dd**2*f**2 + 1512*Dd**2*f*g2*r*s - 378*Dd**2*f*g2*r + 1512*Dd**2*f*g2*s**2 - 1512*Dd**2*f*g2*s + 252*Dd**2*f*g2))/(315*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**3*k1**3*k2**2*st**4*(1782*C*D1**2*f**2*fd*r*s - 594*C*D1**2*f**2*fd*r + 1782*C*D1**2*f**2*fd*s**2 - 1782*C*D1**2*f**2*fd*s + 594*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 2376*C*D1*Dd*f**3*r*s - 594*C*D1*Dd*f**3*r + 2376*C*D1*Dd*f**3*s**2 - 2376*C*D1*Dd*f**3*s + 594*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 4940*D1**2*f**3*fd*r*s - 1235*D1**2*f**3*fd*r + 4940*D1**2*f**3*fd*s**2 - 4940*D1**2*f**3*fd*s + 1235*D1**2*f**3*fd - 2800*D1**2*f**3*fdd*r*s + 700*D1**2*f**3*fdd*r - 2800*D1**2*f**3*fdd*s**2 + 2800*D1**2*f**3*fdd*s - 700*D1**2*f**3*fdd - 8400*D1**2*f**2*fd**2*r*s + 2100*D1**2*f**2*fd**2*r - 8400*D1**2*f**2*fd**2*s**2 + 8400*D1**2*f**2*fd**2*s - 1400*D1**2*f**2*fd**2 - 1782*D1**2*f**2*fd*r*s + 594*D1**2*f**2*fd*r - 1782*D1**2*f**2*fd*s**2 + 1782*D1**2*f**2*fd*s - 594*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 1518*D1**2*f**2*gd2*r*s - 1518*D1**2*f**2*gd2*s**2 + 1518*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 3036*D1**2*f*fd*g2*r*s + 1518*D1**2*f*fd*g2*r - 3036*D1**2*f*fd*g2*s**2 + 3036*D1**2*f*fd*g2*s - 1518*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 4940*D1*Dd*f**4*r*s - 1235*D1*Dd*f**4*r + 4940*D1*Dd*f**4*s**2 - 4940*D1*Dd*f**4*s + 1235*D1*Dd*f**4 - 22400*D1*Dd*f**3*fd*r*s + 5600*D1*Dd*f**3*fd*r - 22400*D1*Dd*f**3*fd*s**2 + 22400*D1*Dd*f**3*fd*s - 4200*D1*Dd*f**3*fd - 2376*D1*Dd*f**3*r*s + 594*D1*Dd*f**3*r - 2376*D1*Dd*f**3*s**2 + 2376*D1*Dd*f**3*s - 594*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 6072*D1*Dd*f**2*g2*r*s + 1518*D1*Dd*f**2*g2*r - 6072*D1*Dd*f**2*g2*s**2 + 6072*D1*Dd*f**2*g2*s - 1518*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 2800*D1*Ddd*f**4*r*s + 700*D1*Ddd*f**4*r - 2800*D1*Ddd*f**4*s**2 + 2800*D1*Ddd*f**4*s - 700*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 8400*Dd**2*f**4*r*s + 2100*Dd**2*f**4*r - 8400*Dd**2*f**4*s**2 + 8400*Dd**2*f**4*s - 1400*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**3*k1**3*k2**2*st**2*(-189*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 2*D1**2*bdd1*f*(r + s - 1)*(50*f**2*(s + 2) - 81*f*(C*(s - 1) + s*(2*K - 2) + 1) + 189*g2*(s - 1)) + 6*D1**2*(-25*f**3*fd*(r*(4*s - 1) + (1 - 2*s)**2) + 3*f**2*(fd*(22*C - 15)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(20*C - 15)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-30*gd2 + 36*gdd2)*(r + s - 1)) - 3*f*(fd**2*(20*C - 15)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*fd*(5*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 6*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) - 36*fdd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 108*fd**2*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*D1*bd1*(D1*(f**3*(46*s + 173)*(r + s - 1) - f**2*(141*C*(s - 1)*(r + s - 1) + 50*fd*(r*(6*s + 3) + 6*s**2 - 2*s - 1) + (s*(45*K - 59) + 47)*(3*r + 3*s - 3)) + 3*f*(27*fd*(C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 8*r*s + 3*r - 8*s**2 + 9*s - 2) + (91*g2*(s - 1) + 63*gd2*(1 - 2*s))*(r + s - 1)) - 189*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(50*f**2*(r*(8*s + 7) + 8*s**2 - 5) - 81*f*(C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 16*r*s + 6*r - 16*s**2 + 20*s - 5) + 189*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 6*D1*f*(Dd*(-25*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(66*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2) - 3*f*(fd*(20*C - 15)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 30*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 36*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 216*fd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(f*(20*C - 15) - 36*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*Dd**2*f**2*(f*(20*C - 15) - 36*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 21*b1**2*(K - 1)*(D1**2*s*(13*fd - 9*fdd)*(r + s) + D1*Dd*(13*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(-8*r*s + r + s*(4 - 8*s))) - 9*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-189*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 2*D1**2*(f**2*(fd*(-3*r*(46*s - 73) - 138*s**2 + 311*s - 219) + 50*fdd*(3*r*(s - 1) + 3*s**2 - 5*s + 3)) + f*(50*fd**2*(6*r*(s - 1) + 6*s**2 - 10*s + 3) + 3*fd*(94*C*s**2 - 47*C*s + 45*K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*r*(47*C*s - 59*s + 6) - 118*s**2 + 71*s - 12) - 81*fdd*(2*C*r*s + 2*C*s**2 - C*s + K*(4*r*s - 2*r + 4*s**2 - 4*s + 2) - 4*r*s + r - 4*s**2 + 3*s - 1) - 3*s*(91*gd2 - 63*gdd2)*(r + s - 1)) - 81*fd**2*(r*(K*(4*s - 2) + s*(2*C - 4) + 1) + s*(C*(2*s - 1) + 4*K*(s - 1) - 4*s + 3)) + 21*fd*s*(-13*g2*(r + s) + 9*gd2*(2*r + 2*s - 1)) + 189*fdd*g2*s*(r + s)) + 21*D1*bd1*(K - 1)*(D1*(13*f*(2*s - 1)*(r + s - 1) + 9*fd*(-4*r*s + r + s*(3 - 4*s))) - 9*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 2*D1*(Dd*(-46*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(141*C*(r*(4*s - 1) + (1 - 2*s)**2) + 50*fd*(3*r*(8*s - 5) + 24*s**2 - 32*s + 11) + (135*K - 177)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*f*(27*fd*(C*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 4*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - (4*s - 1)*(8*r + 8*s - 5)) + 91*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 63*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 189*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(50*f**2 - 81*f*(C + 2*K - 2) + 189*g2)) + 2*Dd**2*f*(50*f**2 - 81*f*(C + 2*K - 2) + 189*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k3**6) - 4*D1**2*Pk3*Pkd2*ct**3*k1**3*k2**2*(540*C*D1**2*bdd1*f**2*r*s - 540*C*D1**2*bdd1*f**2*r + 540*C*D1**2*bdd1*f**2*s**2 - 1080*C*D1**2*bdd1*f**2*s + 540*C*D1**2*bdd1*f**2 + 390*C*D1**2*f**2*fd*r*s - 130*C*D1**2*f**2*fd*r + 390*C*D1**2*f**2*fd*s**2 - 390*C*D1**2*f**2*fd*s + 130*C*D1**2*f**2*fd + 210*C*D1**2*f**2*fdd*r*s - 70*C*D1**2*f**2*fdd*r + 210*C*D1**2*f**2*fdd*s**2 - 210*C*D1**2*f**2*fdd*s + 70*C*D1**2*f**2*fdd + 420*C*D1**2*f*fd**2*r*s - 140*C*D1**2*f*fd**2*r + 420*C*D1**2*f*fd**2*s**2 - 420*C*D1**2*f*fd**2*s + 70*C*D1**2*f*fd**2 + 520*C*D1*Dd*f**3*r*s - 130*C*D1*Dd*f**3*r + 520*C*D1*Dd*f**3*s**2 - 520*C*D1*Dd*f**3*s + 130*C*D1*Dd*f**3 + 1680*C*D1*Dd*f**2*fd*r*s - 490*C*D1*Dd*f**2*fd*r + 1680*C*D1*Dd*f**2*fd*s**2 - 1680*C*D1*Dd*f**2*fd*s + 350*C*D1*Dd*f**2*fd + 280*C*D1*Ddd*f**3*r*s - 70*C*D1*Ddd*f**3*r + 280*C*D1*Ddd*f**3*s**2 - 280*C*D1*Ddd*f**3*s + 70*C*D1*Ddd*f**3 + 840*C*Dd**2*f**3*r*s - 210*C*Dd**2*f**3*r + 840*C*Dd**2*f**3*s**2 - 840*C*Dd**2*f**3*s + 140*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*s**2 - 45*D1**2*K*bdd1*f**2*s - 27*D1**2*bd1**2*f*(2*s - 1)*(-14*K + 10*f + 7)*(r + s - 1) - 405*D1**2*bdd1*f**2*r*s + 405*D1**2*bdd1*f**2*r - 405*D1**2*bdd1*f**2*s**2 + 810*D1**2*bdd1*f**2*s - 405*D1**2*bdd1*f**2 - 756*D1**2*bdd1*f*g2*r*s + 756*D1**2*bdd1*f*g2*r - 756*D1**2*bdd1*f*g2*s**2 + 1512*D1**2*bdd1*f*g2*s - 756*D1**2*bdd1*f*g2 - 330*D1**2*f**2*fd*r*s + 110*D1**2*f**2*fd*r - 330*D1**2*f**2*fd*s**2 + 330*D1**2*f**2*fd*s - 110*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r*s + 35*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 105*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 198*D1**2*f**2*gd2*r*s - 198*D1**2*f**2*gd2*s**2 + 198*D1**2*f**2*gd2*s - 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*s**2 + 90*D1**2*f**2*gdd2*s - 210*D1**2*f*fd**2*r*s + 70*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 210*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 - 396*D1**2*f*fd*g2*r*s + 198*D1**2*f*fd*g2*r - 396*D1**2*f*fd*g2*s**2 + 396*D1**2*f*fd*g2*s - 198*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r*s + 90*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 90*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r*s + 90*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r*s + 90*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s - 440*D1*Dd*f**3*r*s + 110*D1*Dd*f**3*r - 440*D1*Dd*f**3*s**2 + 440*D1*Dd*f**3*s - 110*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r*s + 245*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 840*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 792*D1*Dd*f**2*g2*r*s + 198*D1*Dd*f**2*g2*r - 792*D1*Dd*f**2*g2*s**2 + 792*D1*Dd*f**2*g2*s - 198*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r*s + 90*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 720*D1*Dd*f**2*gd2*s - 90*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r*s + 540*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**3*r*s + 35*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 140*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r*s + 90*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 9*D1*bd1*(D1*(15*f**3*(r + s - 1) + f**2*(r + s - 1)*(36*C*(s - 1) - s*(11*K + 13) + 20) + f*(-5*fd*(12*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 9*r*(4*s - 2) - 36*s**2 + 45*s - 9) + (28*r + 28*s - 28)*(-g2*s + g2 + 6*gd2*s - 3*gd2)) + 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-5*f*(12*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 72*r*s + 45*r - 72*s**2 + 108*s - 36) + 84*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 420*Dd**2*f**3*r*s + 105*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 420*Dd**2*f**3*s - 70*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r*s + 270*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 + 3*b1**2*(-D1**2*s*(-9*f*(13*fd - 10*fdd)*(2*r + 2*s - 1) + 90*fd**2*(2*r + 2*s - 1) + 14*fd*(3*K + 1)*(r + s) - 63*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(117*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(45*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (21*K + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + 63*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 10*f + 7)) - 9*Dd**2*f*(-14*K + 10*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 3*b1*(-9*D1**2*bdd1*f*(2*s - 1)*(-14*K + 10*f + 7)*(r + s - 1) + 3*D1**2*(15*f**2*fd*(r + s - 1) + f*(fd*(-72*C*s**2 + 36*C*s + 11*K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + r*(-72*C*s + 26*s + 7) + 26*s**2 - 6*s - 7) + 5*fdd*(K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + s*(12*C - 9)*(2*r + 2*s - 1)) + s*(28*gd2 - 84*gdd2)*(r + s - 1)) + 5*fd**2*(K*r*(2*s - 1) + 2*K*s*(s - 1) + s*(12*C - 9)*(2*r + 2*s - 1)) + 28*fd*s*(g2*(r + s) + gd2*(-6*r - 6*s + 3)) - 84*fdd*g2*s*(r + s)) - 3*D1*Dd*(f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(36*C - 11*K - 13) + f*(-5*fd*(12*C*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 2*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 144*r*s + 18*r - 144*s**2 + 108*s - 9) - 28*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 84*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 84*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 3*D1*Ddd*f*(5*f*(12*C + K - 9) - 84*g2)*(r*(4*s - 1) + (1 - 2*s)**2) + D1*bd1*(D1*(117*f**2*(2*s - 1)*(r + s - 1) - 2*f*(45*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + (21*K + 7)*(2*s - 1)*(r + s - 1)) + 63*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 9*Dd*f*(-14*K + 10*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 3*Dd**2*f*(5*f*(12*C + K - 9) - 84*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k3**6) + 3*D1**2*Pk3*Pkd2*ct**3*k1**3*st**4*(D1**2*(105*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(315*fd**2*s*(2*s - 1) - fd*(44*C - 44)*(3*s**2 - 2*s + 1) + fdd*(22*C - 22)*(3*s**2 - 2*s + 1) + s**2*(33*K*bdd1 - 66*bd1*(K - 1) - 33*bdd1 + 132*gd2 - 66*gdd2)) - 44*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 3*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 3*fdd*g2*(2*s**2 - 2*s + 1)) + 264*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(105*f**3*(4*s**2 - 2*s + 1) + f**2*(44*C*(4*s**2 - 2*s + 1) - 105*fd*(1 - 4*s)**2 - 176*s**2 + 88*s - 44) - 22*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 6*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(3*K*bd1 - 3*bd1 - 6*gd2)) + 132*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(105*f**2 + f*(44*C - 44) - 132*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(105*f**2 + f*(44*C - 44) - 132*g2) + 66*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**3*k1**3*st**2*(108*C*D1**2*bdd1*f**2*r*s + 378*C*D1**2*bdd1*f**2*s**2 - 540*C*D1**2*bdd1*f**2*s + 270*C*D1**2*bdd1*f**2 + 1116*C*D1**2*f**2*fd*r*s - 372*C*D1**2*f**2*fd*r + 1260*C*D1**2*f**2*fd*s**2 - 1212*C*D1**2*f**2*fd*s + 420*C*D1**2*f**2*fd - 828*C*D1**2*f**2*fdd*r*s + 276*C*D1**2*f**2*fdd*r - 954*C*D1**2*f**2*fdd*s**2 + 912*C*D1**2*f**2*fdd*s - 318*C*D1**2*f**2*fdd - 1656*C*D1**2*f*fd**2*r*s + 552*C*D1**2*f*fd**2*r - 1908*C*D1**2*f*fd**2*s**2 + 1824*C*D1**2*f*fd**2*s - 276*C*D1**2*f*fd**2 + 1488*C*D1*Dd*f**3*r*s - 372*C*D1*Dd*f**3*r + 1680*C*D1*Dd*f**3*s**2 - 1584*C*D1*Dd*f**3*s + 420*C*D1*Dd*f**3 - 6624*C*D1*Dd*f**2*fd*r*s + 1932*C*D1*Dd*f**2*fd*r - 7632*C*D1*Dd*f**2*fd*s**2 + 7212*C*D1*Dd*f**2*fd*s - 1464*C*D1*Dd*f**2*fd - 1104*C*D1*Ddd*f**3*r*s + 276*C*D1*Ddd*f**3*r - 1272*C*D1*Ddd*f**3*s**2 + 1188*C*D1*Ddd*f**3*s - 318*C*D1*Ddd*f**3 - 3312*C*Dd**2*f**3*r*s + 828*C*Dd**2*f**3*r - 3816*C*Dd**2*f**3*s**2 + 3564*C*Dd**2*f**3*s - 552*C*Dd**2*f**3 - 234*D1**2*K*bdd1*f**2*r*s - 387*D1**2*K*bdd1*f**2*s**2 + 234*D1**2*K*bdd1*f**2*s + 126*D1**2*bd1**2*f*s*(K - 1)*(2*r + 7*s - 6) + 500*D1**2*bdd1*f**3*r*s + 500*D1**2*bdd1*f**3*s**2 - 1050*D1**2*bdd1*f**3*s + 375*D1**2*bdd1*f**3 + 450*D1**2*bdd1*f**2*r*s + 468*D1**2*bdd1*f**2*s**2 - 18*D1**2*bdd1*f**2*s - 270*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r*s - 882*D1**2*bdd1*f*g2*s**2 + 1260*D1**2*bdd1*f*g2*s - 630*D1**2*bdd1*f*g2 + 2400*D1**2*f**3*fd*r*s - 600*D1**2*f**3*fd*r + 5400*D1**2*f**3*fd*s**2 - 3900*D1**2*f**3*fd*s + 1350*D1**2*f**3*fd - 2400*D1**2*f**3*fdd*r*s + 600*D1**2*f**3*fdd*r - 3300*D1**2*f**3*fdd*s**2 + 2850*D1**2*f**3*fdd*s - 825*D1**2*f**3*fdd - 7200*D1**2*f**2*fd**2*r*s + 1800*D1**2*f**2*fd**2*r - 9900*D1**2*f**2*fd**2*s**2 + 8550*D1**2*f**2*fd**2*s - 1200*D1**2*f**2*fd**2 - 1872*D1**2*f**2*fd*r*s + 624*D1**2*f**2*fd*r - 2466*D1**2*f**2*fd*s**2 + 2268*D1**2*f**2*fd*s - 822*D1**2*f**2*fd + 1368*D1**2*f**2*fdd*r*s - 456*D1**2*f**2*fdd*r + 1719*D1**2*f**2*fdd*s**2 - 1602*D1**2*f**2*fdd*s + 573*D1**2*f**2*fdd - 684*D1**2*f**2*gd2*r*s - 1044*D1**2*f**2*gd2*s**2 + 684*D1**2*f**2*gd2*s + 468*D1**2*f**2*gdd2*r*s + 774*D1**2*f**2*gdd2*s**2 - 468*D1**2*f**2*gdd2*s + 2736*D1**2*f*fd**2*r*s - 912*D1**2*f*fd**2*r + 3438*D1**2*f*fd**2*s**2 - 3204*D1**2*f*fd**2*s + 456*D1**2*f*fd**2 - 1368*D1**2*f*fd*g2*r*s + 684*D1**2*f*fd*g2*r - 2088*D1**2*f*fd*g2*s**2 + 2088*D1**2*f*fd*g2*s - 1044*D1**2*f*fd*g2 + 1872*D1**2*f*fd*gd2*r*s - 468*D1**2*f*fd*gd2*r + 3096*D1**2*f*fd*gd2*s**2 - 2484*D1**2*f*fd*gd2*s + 468*D1**2*f*fd*gd2 + 936*D1**2*f*fdd*g2*r*s - 468*D1**2*f*fdd*g2*r + 1548*D1**2*f*fdd*g2*s**2 - 1548*D1**2*f*fdd*g2*s + 774*D1**2*f*fdd*g2 + 936*D1**2*fd**2*g2*r*s - 468*D1**2*fd**2*g2*r + 1548*D1**2*fd**2*g2*s**2 - 1548*D1**2*fd**2*g2*s + 2400*D1*Dd*f**4*r*s - 600*D1*Dd*f**4*r + 5400*D1*Dd*f**4*s**2 - 3900*D1*Dd*f**4*s + 1350*D1*Dd*f**4 - 19200*D1*Dd*f**3*fd*r*s + 4800*D1*Dd*f**3*fd*r - 26400*D1*Dd*f**3*fd*s**2 + 22800*D1*Dd*f**3*fd*s - 4050*D1*Dd*f**3*fd - 2496*D1*Dd*f**3*r*s + 624*D1*Dd*f**3*r - 3288*D1*Dd*f**3*s**2 + 2892*D1*Dd*f**3*s - 822*D1*Dd*f**3 + 10944*D1*Dd*f**2*fd*r*s - 3192*D1*Dd*f**2*fd*r + 13752*D1*Dd*f**2*fd*s**2 - 12582*D1*Dd*f**2*fd*s + 2514*D1*Dd*f**2*fd - 2736*D1*Dd*f**2*g2*r*s + 684*D1*Dd*f**2*g2*r - 4176*D1*Dd*f**2*g2*s**2 + 3456*D1*Dd*f**2*g2*s - 1044*D1*Dd*f**2*g2 + 3744*D1*Dd*f**2*gd2*r*s - 468*D1*Dd*f**2*gd2*r + 6192*D1*Dd*f**2*gd2*s**2 - 4356*D1*Dd*f**2*gd2*s + 468*D1*Dd*f**2*gd2 + 7488*D1*Dd*f*fd*g2*r*s - 2808*D1*Dd*f*fd*g2*r + 12384*D1*Dd*f*fd*g2*s**2 - 11160*D1*Dd*f*fd*g2*s + 2484*D1*Dd*f*fd*g2 - 2400*D1*Ddd*f**4*r*s + 600*D1*Ddd*f**4*r - 3300*D1*Ddd*f**4*s**2 + 2850*D1*Ddd*f**4*s - 825*D1*Ddd*f**4 + 1824*D1*Ddd*f**3*r*s - 456*D1*Ddd*f**3*r + 2292*D1*Ddd*f**3*s**2 - 2058*D1*Ddd*f**3*s + 573*D1*Ddd*f**3 + 1872*D1*Ddd*f**2*g2*r*s - 468*D1*Ddd*f**2*g2*r + 3096*D1*Ddd*f**2*g2*s**2 - 2484*D1*Ddd*f**2*g2*s + 774*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(f**3*(338*s**2 + s*(338*r - 942) + 375) + f**2*(6*C*(56*s**2 + s*(11*r - 90) + 45) - 50*fd*(5*r*(6*s - 1) + 30*s**2 - 41*s + 3) - 3*s**2*(87*K - 86) - 3*s*(57*K*(r - 1) - 101*r - 57) - 270) + 3*f*(3*fd*(-84*C*s**2 + 78*C*s + K*(13*r*(4*s - 1) + 86*s**2 - 69*s + 13) - r*(6*C + 25)*(4*s - 1) - 104*s**2 + 78*s - 31) - 14*g2*(16*s**2 + s*(r - 30) + 15) + 42*gd2*s*(2*r + 7*s - 6)) + 126*fd*g2*(r*(2*s - 1) + s*(7*s - 7))) + Dd*f*(-25*f**2*(10*r*(8*s - 1) + 80*s**2 - 124*s + 21) - 9*f*(6*C*(r*(8*s - 1) + 28*s**2 - 29*s + 5) + K*(-104*r*s + 13*r - 172*s**2 + 121*s - 13) + 200*r*s - 25*r + 208*s**2 - 106*s + 1) + 126*g2*(r*(8*s - 1) + 28*s**2 - 29*s + 5))) - 7200*Dd**2*f**4*r*s + 1800*Dd**2*f**4*r - 9900*Dd**2*f**4*s**2 + 8550*Dd**2*f**4*s - 1200*Dd**2*f**4 + 5472*Dd**2*f**3*r*s - 1368*Dd**2*f**3*r + 6876*Dd**2*f**3*s**2 - 6174*Dd**2*f**3*s + 912*Dd**2*f**3 + 5616*Dd**2*f**2*g2*r*s - 1404*Dd**2*f**2*g2*r + 9288*Dd**2*f**2*g2*s**2 - 7452*Dd**2*f**2*g2*s + 936*Dd**2*f**2*g2 - 21*b1**2*(K - 1)*(D1**2*(2*fd*(r*(s - 1) + 16*s**2 - 2*s + 1) - 3*fdd*(2*r*(s - 1) + 7*s**2 - 4*s + 2)) + D1*(2*Dd*(f*(4*r*s - r + 64*s**2 - 34*s + 16) - 3*fd*(8*r*s - 5*r + 28*s**2 - 17*s + 4)) - 3*Ddd*f*(r*(8*s - 2) + 28*s**2 - 18*s + 7)) - 6*Dd**2*f*(3*r*(4*s - 1) + 42*s**2 - 27*s + 2)) + b1*(-264*C*D1**2*f*fd*r*s + 132*C*D1**2*f*fd*r - 1344*C*D1**2*f*fd*s**2 + 396*C*D1**2*f*fd*s - 132*C*D1**2*f*fd + 216*C*D1**2*f*fdd*r*s - 108*C*D1**2*f*fdd*r + 756*C*D1**2*f*fdd*s**2 - 324*C*D1**2*f*fdd*s + 108*C*D1**2*f*fdd + 216*C*D1**2*fd**2*r*s - 108*C*D1**2*fd**2*r + 756*C*D1**2*fd**2*s**2 - 324*C*D1**2*fd**2*s + 108*C*D1**2*fd**2 - 528*C*D1*Dd*f**2*r*s + 132*C*D1*Dd*f**2*r - 2688*C*D1*Dd*f**2*s**2 + 1608*C*D1*Dd*f**2*s - 672*C*D1*Dd*f**2 + 1728*C*D1*Dd*f*fd*r*s - 648*C*D1*Dd*f*fd*r + 6048*C*D1*Dd*f*fd*s**2 - 3240*C*D1*Dd*f*fd*s + 540*C*D1*Dd*f*fd + 432*C*D1*Ddd*f**2*r*s - 108*C*D1*Ddd*f**2*r + 1512*C*D1*Ddd*f**2*s**2 - 972*C*D1*Ddd*f**2*s + 378*C*D1*Ddd*f**2 + 1296*C*Dd**2*f**2*r*s - 324*C*Dd**2*f**2*r + 4536*C*Dd**2*f**2*s**2 - 2916*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 + 684*D1**2*K*f*fd*r*s - 342*D1**2*K*f*fd*r + 1044*D1**2*K*f*fd*s**2 - 1044*D1**2*K*f*fd*s + 522*D1**2*K*f*fd - 468*D1**2*K*f*fdd*r*s + 234*D1**2*K*f*fdd*r - 774*D1**2*K*f*fdd*s**2 + 774*D1**2*K*f*fdd*s - 387*D1**2*K*f*fdd - 468*D1**2*K*fd**2*r*s + 234*D1**2*K*fd**2*r - 774*D1**2*K*fd**2*s**2 + 774*D1**2*K*fd**2*s + 63*D1**2*bdd1*f*(K - 1)*(14*s**2 + s*(4*r - 12) + 5) - 2028*D1**2*f**2*fd*r*s + 676*D1**2*f**2*fd*r - 2028*D1**2*f**2*fd*s**2 + 820*D1**2*f**2*fd*s + 74*D1**2*f**2*fd + 1500*D1**2*f**2*fdd*r*s - 500*D1**2*f**2*fdd*r + 1500*D1**2*f**2*fdd*s**2 - 950*D1**2*f**2*fdd*s + 125*D1**2*f**2*fdd + 3000*D1**2*f*fd**2*r*s - 1000*D1**2*f*fd**2*r + 3000*D1**2*f*fd**2*s**2 - 1900*D1**2*f*fd**2*s + 700*D1**2*f*fd**2 - 1212*D1**2*f*fd*r*s + 606*D1**2*f*fd*r - 1032*D1**2*f*fd*s**2 + 1980*D1**2*f*fd*s - 1056*D1**2*f*fd + 900*D1**2*f*fdd*r*s - 450*D1**2*f*fdd*r + 936*D1**2*f*fdd*s**2 - 1368*D1**2*f*fdd*s + 738*D1**2*f*fdd + 84*D1**2*f*gd2*r*s + 1344*D1**2*f*gd2*s**2 - 84*D1**2*f*gd2*s - 252*D1**2*f*gdd2*r*s - 882*D1**2*f*gdd2*s**2 + 252*D1**2*f*gdd2*s + 900*D1**2*fd**2*r*s - 450*D1**2*fd**2*r + 936*D1**2*fd**2*s**2 - 1368*D1**2*fd**2*s - 108*D1**2*fd**2 + 84*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*r + 1344*D1**2*fd*g2*s**2 - 168*D1**2*fd*g2*s + 84*D1**2*fd*g2 - 504*D1**2*fd*gd2*r*s + 252*D1**2*fd*gd2*r - 1764*D1**2*fd*gd2*s**2 + 756*D1**2*fd*gd2*s - 252*D1**2*fd*gd2 - 252*D1**2*fdd*g2*r*s + 252*D1**2*fdd*g2*r - 882*D1**2*fdd*g2*s**2 + 504*D1**2*fdd*g2*s - 252*D1**2*fdd*g2 + 1368*D1*Dd*K*f**2*r*s - 342*D1*Dd*K*f**2*r + 2088*D1*Dd*K*f**2*s**2 - 1728*D1*Dd*K*f**2*s + 522*D1*Dd*K*f**2 - 3744*D1*Dd*K*f*fd*r*s + 1404*D1*Dd*K*f*fd*r - 6192*D1*Dd*K*f*fd*s**2 + 5580*D1*Dd*K*f*fd*s - 1242*D1*Dd*K*f*fd - 2704*D1*Dd*f**3*r*s + 676*D1*Dd*f**3*r - 2704*D1*Dd*f**3*s**2 + 2704*D1*Dd*f**3*s - 676*D1*Dd*f**3 + 12000*D1*Dd*f**2*fd*r*s - 3500*D1*Dd*f**2*fd*r + 12000*D1*Dd*f**2*fd*s**2 - 9800*D1*Dd*f**2*fd*s + 1950*D1*Dd*f**2*fd - 2424*D1*Dd*f**2*r*s + 606*D1*Dd*f**2*r - 2064*D1*Dd*f**2*s**2 + 2244*D1*Dd*f**2*s - 516*D1*Dd*f**2 + 7200*D1*Dd*f*fd*r*s - 2700*D1*Dd*f*fd*r + 7488*D1*Dd*f*fd*s**2 - 9144*D1*Dd*f*fd*s + 2268*D1*Dd*f*fd + 336*D1*Dd*f*g2*r*s - 84*D1*Dd*f*g2*r + 5376*D1*Dd*f*g2*s**2 - 2856*D1*Dd*f*g2*s + 1344*D1*Dd*f*g2 - 2016*D1*Dd*f*gd2*r*s + 252*D1*Dd*f*gd2*r - 7056*D1*Dd*f*gd2*s**2 + 3276*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 2016*D1*Dd*fd*g2*r*s + 1260*D1*Dd*fd*g2*r - 7056*D1*Dd*fd*g2*s**2 + 4284*D1*Dd*fd*g2*s - 1008*D1*Dd*fd*g2 - 936*D1*Ddd*K*f**2*r*s + 234*D1*Ddd*K*f**2*r - 1548*D1*Ddd*K*f**2*s**2 + 1242*D1*Ddd*K*f**2*s - 387*D1*Ddd*K*f**2 + 2000*D1*Ddd*f**3*r*s - 500*D1*Ddd*f**3*r + 2000*D1*Ddd*f**3*s**2 - 2000*D1*Ddd*f**3*s + 500*D1*Ddd*f**3 + 1800*D1*Ddd*f**2*r*s - 450*D1*Ddd*f**2*r + 1872*D1*Ddd*f**2*s**2 - 1836*D1*Ddd*f**2*s + 468*D1*Ddd*f**2 - 1008*D1*Ddd*f*g2*r*s + 252*D1*Ddd*f*g2*r - 3528*D1*Ddd*f*g2*s**2 + 2268*D1*Ddd*f*g2*s - 882*D1*Ddd*f*g2 - 42*D1*bd1*(K - 1)*(D1*(f*(2*r*s + 32*s**2 - 31*s + 15) - 3*fd*(4*r*s - 2*r + 14*s**2 - 10*s + 1)) - 6*Dd*f*(r*(8*s - 1) + 28*s**2 - 21*s + 3)) - 2808*Dd**2*K*f**2*r*s + 702*Dd**2*K*f**2*r - 4644*Dd**2*K*f**2*s**2 + 3726*Dd**2*K*f**2*s - 468*Dd**2*K*f**2 + 6000*Dd**2*f**3*r*s - 1500*Dd**2*f**3*r + 6000*Dd**2*f**3*s**2 - 6000*Dd**2*f**3*s + 1000*Dd**2*f**3 + 5400*Dd**2*f**2*r*s - 1350*Dd**2*f**2*r + 5616*Dd**2*f**2*s**2 - 5508*Dd**2*f**2*s + 900*Dd**2*f**2 - 3024*Dd**2*f*g2*r*s + 756*Dd**2*f*g2*r - 10584*Dd**2*f*g2*s**2 + 6804*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(315*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**3*k1**3*(1008*C*D1**2*bdd1*f**2*r*s - 1008*C*D1**2*bdd1*f**2*r + 1296*C*D1**2*bdd1*f**2*s**2 - 2592*C*D1**2*bdd1*f**2*s + 1296*C*D1**2*bdd1*f**2 + 480*C*D1**2*f**2*fd*r*s - 160*C*D1**2*f**2*fd*r - 5520*C*D1**2*f**2*fd*s**2 + 3520*C*D1**2*f**2*fd*s - 1840*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 4380*C*D1**2*f**2*fdd*s**2 - 3200*C*D1**2*f**2*fdd*s + 1460*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 8760*C*D1**2*f*fd**2*s**2 - 6400*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 + 640*C*D1*Dd*f**3*r*s - 160*C*D1*Dd*f**3*r - 7360*C*D1*Dd*f**3*s**2 + 3360*C*D1*Dd*f**3*s - 1840*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 35040*C*D1*Dd*f**2*fd*s**2 - 23240*C*D1*Dd*f**2*fd*s + 3760*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 5840*C*D1*Ddd*f**3*s**2 - 3480*C*D1*Ddd*f**3*s + 1460*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 17520*C*Dd**2*f**3*s**2 - 10440*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r*s + 990*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s - 216*D1**2*b2*f*fd*r*s + 108*D1**2*b2*f*fd*r - 216*D1**2*b2*f*fd*s**2 + 216*D1**2*b2*f*fd*s - 108*D1**2*b2*f*fd + 360*D1**2*b2*f*fdd*r*s - 180*D1**2*b2*f*fdd*r + 360*D1**2*b2*f*fdd*s**2 - 360*D1**2*b2*f*fdd*s + 180*D1**2*b2*f*fdd + 360*D1**2*b2*fd**2*r*s - 180*D1**2*b2*fd**2*r + 360*D1**2*b2*fd**2*s**2 - 360*D1**2*b2*fd**2*s - 6*D1**2*bd1**2*(15*f**2*(2*r*(8*s - 5) + 13*s**2 - 21*s + 6) - 7*f*(16*K*(r*(2*s - 1) + 3*s**2 - 4*s + 1) + r*(-12*C - 22)*(2*s - 1) - (s - 1)*(24*C*s + 63*s - 34)) - 140*g2*(r*(2*s - 1) + s*(2*s - 2))) - 108*D1**2*bd2*f**2*r*s - 108*D1**2*bd2*f**2*s**2 + 108*D1**2*bd2*f**2*s + 720*D1**2*bd2*f*fd*r*s - 180*D1**2*bd2*f*fd*r + 720*D1**2*bd2*f*fd*s**2 - 720*D1**2*bd2*f*fd*s + 180*D1**2*bd2*f*fd + 720*D1**2*bdd1*f**3*r*s - 1080*D1**2*bdd1*f**3*r - 1530*D1**2*bdd1*f**3*s + 945*D1**2*bdd1*f**3 - 1548*D1**2*bdd1*f**2*r*s + 1548*D1**2*bdd1*f**2*r - 2286*D1**2*bdd1*f**2*s**2 + 3762*D1**2*bdd1*f**2*s - 1881*D1**2*bdd1*f**2 - 1344*D1**2*bdd1*f*g2*r*s + 1344*D1**2*bdd1*f*g2*r - 2016*D1**2*bdd1*f*g2*s**2 + 4032*D1**2*bdd1*f*g2*s - 2016*D1**2*bdd1*f*g2 + 180*D1**2*bdd2*f**2*r*s + 180*D1**2*bdd2*f**2*s**2 - 180*D1**2*bdd2*f**2*s - 1320*D1**2*f**2*fd*r*s + 440*D1**2*f**2*fd*r + 3450*D1**2*f**2*fd*s**2 - 1860*D1**2*f**2*fd*s + 1150*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 3075*D1**2*f**2*fdd*s**2 + 2190*D1**2*f**2*fdd*s - 1025*D1**2*f**2*fdd - 288*D1**2*f**2*gd2*r*s + 2448*D1**2*f**2*gd2*s**2 + 288*D1**2*f**2*gd2*s - 360*D1**2*f**2*gdd2*r*s - 1980*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s - 840*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 6150*D1**2*f*fd**2*s**2 + 4380*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 576*D1**2*f*fd*g2*r*s + 288*D1**2*f*fd*g2*r + 4896*D1**2*f*fd*g2*s**2 - 4896*D1**2*f*fd*g2*s + 2448*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r*s + 360*D1**2*f*fd*gd2*r - 7920*D1**2*f*fd*gd2*s**2 + 4680*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r - 3960*D1**2*f*fdd*g2*s**2 + 3960*D1**2*f*fdd*g2*s - 1980*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r - 3960*D1**2*fd**2*g2*s**2 + 3960*D1**2*fd**2*g2*s - 432*D1*Dd*b2*f**2*r*s + 108*D1*Dd*b2*f**2*r - 432*D1*Dd*b2*f**2*s**2 + 432*D1*Dd*b2*f**2*s - 108*D1*Dd*b2*f**2 + 2880*D1*Dd*b2*f*fd*r*s - 1080*D1*Dd*b2*f*fd*r + 2880*D1*Dd*b2*f*fd*s**2 - 2880*D1*Dd*b2*f*fd*s + 720*D1*Dd*b2*f*fd + 1440*D1*Dd*bd2*f**2*r*s - 180*D1*Dd*bd2*f**2*r + 1440*D1*Dd*bd2*f**2*s**2 - 1440*D1*Dd*bd2*f**2*s + 180*D1*Dd*bd2*f**2 - 1760*D1*Dd*f**3*r*s + 440*D1*Dd*f**3*r + 4600*D1*Dd*f**3*s**2 - 1420*D1*Dd*f**3*s + 1150*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 24600*D1*Dd*f**2*fd*s**2 + 15750*D1*Dd*f**2*fd*s - 2470*D1*Dd*f**2*fd - 1152*D1*Dd*f**2*g2*r*s + 288*D1*Dd*f**2*g2*r + 9792*D1*Dd*f**2*g2*s**2 - 4320*D1*Dd*f**2*g2*s + 2448*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r*s + 360*D1*Dd*f**2*gd2*r - 15840*D1*Dd*f**2*gd2*s**2 + 6120*D1*Dd*f**2*gd2*s - 360*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r*s + 2160*D1*Dd*f*fd*g2*r - 31680*D1*Dd*f*fd*g2*s**2 + 25200*D1*Dd*f*fd*g2*s - 4680*D1*Dd*f*fd*g2 + 720*D1*Ddd*b2*f**2*r*s - 180*D1*Ddd*b2*f**2*r + 720*D1*Ddd*b2*f**2*s**2 - 720*D1*Ddd*b2*f**2*s + 180*D1*Ddd*b2*f**2 - 560*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 4100*D1*Ddd*f**3*s**2 + 2330*D1*Ddd*f**3*s - 1025*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r*s + 360*D1*Ddd*f**2*g2*r - 7920*D1*Ddd*f**2*g2*s**2 + 4680*D1*Ddd*f**2*g2*s - 1980*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(15*f**3*(12*r*(s - 1) + 4*s**2 - 28*s + 15) + 3*f**2*(4*C*(s - 1)*(21*r + 22*s - 22) - 8*K*r*s + 68*K*s**2 + 8*K*s - 10*fd*(8*r*(3*s - 2) - 25*s + 10) - 88*r*s + 116*r - 142*s**2 + 222*s - 125) + f*(-3*fd*(8*C*(14*r*(2*s - 1) + 36*s**2 - 43*s + 7) + 10*K*(4*r*s - r + 22*s**2 - 13*s + 1) - 344*r*s + 172*r - 508*s**2 + 549*s - 86) - 28*g2*(s - 1)*(11*r + 14*s - 14) + 224*gd2*(r*(2*s - 1) + 3*s**2 - 4*s + 1)) + 224*fd*g2*(r*(2*s - 1) + s*(3*s - 3))) + Dd*f*(-15*f**2*(8*r*(8*s - 7) - 84*s + 41) - 3*f*(8*C*(7*r*(8*s - 5) + 72*s**2 - 104*s + 32) + 10*K*(8*r*s - r + 44*s**2 - 17*s + 1) - 688*r*s + 430*r - 1016*s**2 + 1262*s - 381) + 224*g2*(r*(8*s - 5) + 12*s**2 - 17*s + 5))) + 2160*Dd**2*b2*f**2*r*s - 540*Dd**2*b2*f**2*r + 2160*Dd**2*b2*f**2*s**2 - 2160*Dd**2*b2*f**2*s + 360*Dd**2*b2*f**2 - 1680*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 12300*Dd**2*f**3*s**2 + 6990*Dd**2*f**3*s - 280*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r*s + 1080*Dd**2*f**2*g2*r - 23760*Dd**2*f**2*g2*s**2 + 14040*Dd**2*f**2*g2*s - 720*Dd**2*f**2*g2 - 420*b1**3*(K - 1)*(D1*(Dd + Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 3*b1**2*(-56*C*D1**2*fd*r*s - 56*C*D1**2*fd*s**2 + 56*C*D1**2*fd*s + 168*C*D1**2*fdd*r*s + 168*C*D1**2*fdd*s**2 - 168*C*D1**2*fdd*s - 224*C*D1*Dd*f*r*s + 56*C*D1*Dd*f*r - 224*C*D1*Dd*f*s**2 + 224*C*D1*Dd*f*s - 56*C*D1*Dd*f + 1344*C*D1*Dd*fd*r*s - 168*C*D1*Dd*fd*r + 1344*C*D1*Dd*fd*s**2 - 1344*C*D1*Dd*fd*s + 168*C*D1*Dd*fd + 672*C*D1*Ddd*f*r*s - 168*C*D1*Ddd*f*r + 672*C*D1*Ddd*f*s**2 - 672*C*D1*Ddd*f*s + 168*C*D1*Ddd*f + 2016*C*Dd**2*f*r*s - 504*C*Dd**2*f*r + 2016*C*Dd**2*f*s**2 - 2016*C*Dd**2*f*s + 336*C*Dd**2*f + 308*D1**2*K*fd*r*s + 392*D1**2*K*fd*s**2 - 224*D1**2*K*fdd*r*s - 336*D1**2*K*fdd*s**2 + 140*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 624*D1**2*f*fd*r*s - 36*D1**2*f*fd*r - 444*D1**2*f*fd*s**2 + 396*D1**2*f*fd*s + 36*D1**2*f*fd + 480*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r + 390*D1**2*f*fdd*s**2 - 240*D1**2*f*fdd*s - 60*D1**2*f*fdd + 480*D1**2*fd**2*r*s + 60*D1**2*fd**2*r + 390*D1**2*fd**2*s**2 - 240*D1**2*fd**2*s - 60*D1**2*fd**2 - 476*D1**2*fd*r*s - 602*D1**2*fd*s**2 - 56*D1**2*fd*s + 308*D1**2*fdd*r*s + 441*D1**2*fdd*s**2 + 168*D1**2*fdd*s - 280*D1**2*gd2*r*s - 280*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 280*D1**2*gdd2*r*s - 280*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s + 1232*D1*Dd*K*f*r*s - 308*D1*Dd*K*f*r + 1568*D1*Dd*K*f*s**2 - 1400*D1*Dd*K*f*s + 392*D1*Dd*K*f - 1792*D1*Dd*K*fd*r*s + 224*D1*Dd*K*fd*r - 2688*D1*Dd*K*fd*s**2 + 1120*D1*Dd*K*fd*s - 1248*D1*Dd*f**2*r*s + 312*D1*Dd*f**2*r - 888*D1*Dd*f**2*s**2 + 1068*D1*Dd*f**2*s - 222*D1*Dd*f**2 + 3840*D1*Dd*f*fd*r*s - 240*D1*Dd*f*fd*r + 3120*D1*Dd*f*fd*s**2 - 2700*D1*Dd*f*fd*s + 120*D1*Dd*f*fd - 1904*D1*Dd*f*r*s + 476*D1*Dd*f*r - 2408*D1*Dd*f*s**2 + 2156*D1*Dd*f*s - 602*D1*Dd*f + 2464*D1*Dd*fd*r*s - 308*D1*Dd*fd*r + 3528*D1*Dd*fd*s**2 - 826*D1*Dd*fd*s - 168*D1*Dd*fd - 1120*D1*Dd*g2*r*s + 280*D1*Dd*g2*r - 1120*D1*Dd*g2*s**2 + 1120*D1*Dd*g2*s - 280*D1*Dd*g2 - 2240*D1*Dd*gd2*r*s + 280*D1*Dd*gd2*r - 2240*D1*Dd*gd2*s**2 + 2240*D1*Dd*gd2*s - 280*D1*Dd*gd2 - 896*D1*Ddd*K*f*r*s + 224*D1*Ddd*K*f*r - 1344*D1*Ddd*K*f*s**2 + 1120*D1*Ddd*K*f*s - 336*D1*Ddd*K*f + 960*D1*Ddd*f**2*r*s - 240*D1*Ddd*f**2*r + 780*D1*Ddd*f**2*s**2 - 870*D1*Ddd*f**2*s + 195*D1*Ddd*f**2 + 1232*D1*Ddd*f*r*s - 308*D1*Ddd*f*r + 1764*D1*Ddd*f*s**2 - 1498*D1*Ddd*f*s + 441*D1*Ddd*f - 1120*D1*Ddd*g2*r*s + 280*D1*Ddd*g2*r - 1120*D1*Ddd*g2*s**2 + 1120*D1*Ddd*g2*s - 280*D1*Ddd*g2 + 140*D1*bd1*(K - 1)*(D1*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*(24*r*s - 7*r + 24*s**2 - 24*s + 5)) - 2688*Dd**2*K*f*r*s + 672*Dd**2*K*f*r - 4032*Dd**2*K*f*s**2 + 3360*Dd**2*K*f*s - 448*Dd**2*K*f + 2880*Dd**2*f**2*r*s - 720*Dd**2*f**2*r + 2340*Dd**2*f**2*s**2 - 2610*Dd**2*f**2*s + 480*Dd**2*f**2 + 3696*Dd**2*f*r*s - 924*Dd**2*f*r + 5292*Dd**2*f*s**2 - 4494*Dd**2*f*s + 616*Dd**2*f - 3360*Dd**2*g2*r*s + 840*Dd**2*g2*r - 3360*Dd**2*g2*s**2 + 3360*Dd**2*g2*s - 560*Dd**2*g2) - 3*b1*(1008*C*D1**2*f*fd*r*s + 1056*C*D1**2*f*fd*s**2 - 504*C*D1**2*f*fd*s - 672*C*D1**2*f*fdd*r*s - 864*C*D1**2*f*fdd*s**2 + 336*C*D1**2*f*fdd*s - 672*C*D1**2*fd**2*r*s - 864*C*D1**2*fd**2*s**2 + 336*C*D1**2*fd**2*s + 2016*C*D1*Dd*f**2*r*s - 504*C*D1*Dd*f**2*r + 2112*C*D1*Dd*f**2*s**2 - 2064*C*D1*Dd*f**2*s + 528*C*D1*Dd*f**2 - 5376*C*D1*Dd*f*fd*r*s + 672*C*D1*Dd*f*fd*r - 6912*C*D1*Dd*f*fd*s**2 + 4416*C*D1*Dd*f*fd*s - 336*C*D1*Dd*f*fd - 1344*C*D1*Ddd*f**2*r*s + 336*C*D1*Ddd*f**2*r - 1728*C*D1*Ddd*f**2*s**2 + 1536*C*D1*Ddd*f**2*s - 432*C*D1*Ddd*f**2 - 4032*C*Dd**2*f**2*r*s + 1008*C*Dd**2*f**2*r - 5184*C*Dd**2*f**2*s**2 + 4608*C*Dd**2*f**2*s - 672*C*Dd**2*f**2 - 96*D1**2*K*f*fd*r*s + 48*D1**2*K*f*fd*r + 816*D1**2*K*f*fd*s**2 - 816*D1**2*K*f*fd*s + 408*D1**2*K*f*fd - 120*D1**2*K*f*fdd*r*s + 60*D1**2*K*f*fdd*r - 660*D1**2*K*f*fdd*s**2 + 660*D1**2*K*f*fdd*s - 330*D1**2*K*f*fdd - 120*D1**2*K*fd**2*r*s + 60*D1**2*K*fd**2*r - 660*D1**2*K*fd**2*s**2 + 660*D1**2*K*fd**2*s + 140*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(15*f**2*(4*r*(8*s - 5) + 26*s**2 - 42*s + 17) + 7*f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 16*K*(4*r*s - 2*r + 6*s**2 - 8*s + 3) + 88*r*s - 44*r + 126*s**2 - 194*s + 63) - 280*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 1080*D1**2*f**2*fd*r*s + 360*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s - 330*D1**2*f**2*fd - 720*D1**2*f**2*fdd*r*s - 120*D1**2*f**2*fdd*r - 30*D1**2*f**2*fdd*s + 315*D1**2*f**2*fdd - 1440*D1**2*f*fd**2*r*s - 240*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s + 120*D1**2*f*fd**2 - 1056*D1**2*f*fd*r*s - 168*D1**2*f*fd*r - 1704*D1**2*f*fd*s**2 + 900*D1**2*f*fd*s - 102*D1**2*f*fd + 1032*D1**2*f*fdd*r*s + 1524*D1**2*f*fdd*s**2 - 786*D1**2*f*fdd*s + 135*D1**2*f*fdd - 616*D1**2*f*gd2*r*s - 784*D1**2*f*gd2*s**2 + 616*D1**2*f*gd2*s + 448*D1**2*f*gdd2*r*s + 672*D1**2*f*gdd2*s**2 - 448*D1**2*f*gdd2*s + 1032*D1**2*fd**2*r*s + 1524*D1**2*fd**2*s**2 - 786*D1**2*fd**2*s - 616*D1**2*fd*g2*r*s - 784*D1**2*fd*g2*s**2 + 896*D1**2*fd*gd2*r*s + 1344*D1**2*fd*gd2*s**2 - 448*D1**2*fd*gd2*s + 448*D1**2*fdd*g2*r*s + 672*D1**2*fdd*g2*s**2 - 192*D1*Dd*K*f**2*r*s + 48*D1*Dd*K*f**2*r + 1632*D1*Dd*K*f**2*s**2 - 720*D1*Dd*K*f**2*s + 408*D1*Dd*K*f**2 - 960*D1*Dd*K*f*fd*r*s + 360*D1*Dd*K*f*fd*r - 5280*D1*Dd*K*f*fd*s**2 + 4200*D1*Dd*K*f*fd*s - 780*D1*Dd*K*f*fd + 1440*D1*Dd*f**3*r*s - 360*D1*Dd*f**3*r + 480*D1*Dd*f**3*s**2 - 960*D1*Dd*f**3*s + 120*D1*Dd*f**3 - 5760*D1*Dd*f**2*fd*r*s + 240*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s + 270*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*r*s + 528*D1*Dd*f**2*r - 3408*D1*Dd*f**2*s**2 + 2760*D1*Dd*f**2*s - 852*D1*Dd*f**2 + 8256*D1*Dd*f*fd*r*s - 1032*D1*Dd*f*fd*r + 12192*D1*Dd*f*fd*s**2 - 8256*D1*Dd*f*fd*s + 786*D1*Dd*f*fd - 2464*D1*Dd*f*g2*r*s + 616*D1*Dd*f*g2*r - 3136*D1*Dd*f*g2*s**2 + 2800*D1*Dd*f*g2*s - 784*D1*Dd*f*g2 + 3584*D1*Dd*f*gd2*r*s - 448*D1*Dd*f*gd2*r + 5376*D1*Dd*f*gd2*s**2 - 4032*D1*Dd*f*gd2*s + 448*D1*Dd*f*gd2 + 3584*D1*Dd*fd*g2*r*s - 448*D1*Dd*fd*g2*r + 5376*D1*Dd*fd*g2*s**2 - 2240*D1*Dd*fd*g2*s - 240*D1*Ddd*K*f**2*r*s + 60*D1*Ddd*K*f**2*r - 1320*D1*Ddd*K*f**2*s**2 + 780*D1*Ddd*K*f**2*s - 330*D1*Ddd*K*f**2 - 960*D1*Ddd*f**3*r*s + 240*D1*Ddd*f**3*r + 480*D1*Ddd*f**3*s + 2064*D1*Ddd*f**2*r*s - 516*D1*Ddd*f**2*r + 3048*D1*Ddd*f**2*s**2 - 2556*D1*Ddd*f**2*s + 762*D1*Ddd*f**2 + 1792*D1*Ddd*f*g2*r*s - 448*D1*Ddd*f*g2*r + 2688*D1*Ddd*f*g2*s**2 - 2240*D1*Ddd*f*g2*s + 672*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(3*f**2*(2*r*(52*s - 29) + 74*s**2 - 112*s + 43) + f*(28*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 7*K*(44*r*s - 22*r + 56*s**2 - 78*s + 28) - 30*fd*(8*r*(4*s - 1) + 26*s**2 - 29*s + 6) + 476*r*s - 238*r + 602*s**2 - 868*s + 301) - 7*fd*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) - 96*K*s**2 + 64*K*s - r*(16*K - 22)*(4*s - 1) + 126*s**2 - 73*s - 12) + 140*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 140*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*(-15*f**2*(8*r*(16*s - 7) + 104*s**2 - 142*s + 41) - 7*f*(24*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 32*K*(8*r*s - 3*r + 12*s**2 - 13*s + 3) + 352*r*s - 132*r + 504*s**2 - 602*s + 141) + 280*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 720*Dd**2*K*f**2*r*s + 180*Dd**2*K*f**2*r - 3960*Dd**2*K*f**2*s**2 + 2340*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 - 2880*Dd**2*f**3*r*s + 720*Dd**2*f**3*r + 1440*Dd**2*f**3*s - 480*Dd**2*f**3 + 6192*Dd**2*f**2*r*s - 1548*Dd**2*f**2*r + 9144*Dd**2*f**2*s**2 - 7668*Dd**2*f**2*s + 1032*Dd**2*f**2 + 5376*Dd**2*f*g2*r*s - 1344*Dd**2*f*g2*r + 8064*Dd**2*f*g2*s**2 - 6720*Dd**2*f*g2*s + 896*Dd**2*f*g2))/(630*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**3*k1**3*st**2*(b1*(D1**2*(50*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-100*fd**2*s*(3*s - 2) + 54*fd*(2*s**2 - 2*s + 1) - 27*fdd*(2*s**2 - 2*s + 1)) - 54*fd**2*s*(s - 1)) + D1*f*(2*Dd*(50*f**2*(4*s**2 - 2*s + 1) - 50*f*fd*(12*s**2 - 7*s + 1) + 27*f*(4*s**2 - 2*s + 1) - 27*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(50*f + 27)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(50*f + 27)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(100*bd1 - 50*bdd1) + f*(-10*fd*(s**2*(30*bd1 - 9) + s*(6 - 10*bd1) - 3) - 15*fdd*(3*s**2 - 2*s + 1) - 3*s**2*(-18*bd1 + 9*bdd1)) + 6*fd*s*(bd1*(9 - 18*s) + 5*fd*(2 - 3*s))) + D1*f*(-2*Dd*(5*f*(s**2*(40*bd1 - 12) + s*(6 - 10*bd1) - 3) + (12*s - 3)*(9*bd1*s + 5*fd*(3*s - 1))) - 15*Ddd*f*(4*s**2 - 2*s + 1)) + 90*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2**2*k3**2) + D1**2*Pk3*Pkd2*ct**3*k1**3*(9*b1**2*(D1**2*s**2*(-20*fd**2 + fd*(40*f + 14) - fdd*(20*f + 7)) + D1*(2*Dd*(10*f**2*(4*s**2 - 2*s + 1) + f*(s**2*(28 - 80*fd) + s*(20*fd - 14) + 7) + 7*fd*s*(1 - 4*s)) - Ddd*f*(10*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(10*f + 7)*(2*s - 1)) + 9*b1*(-D1**2*bdd1*f*(10*f + 7)*(2*s**2 - 2*s + 1) - 84*D1**2*f**2*fd*s**2 + 56*D1**2*f**2*fd*s - 28*D1**2*f**2*fd + 42*D1**2*f**2*fdd*s**2 - 28*D1**2*f**2*fdd*s + 14*D1**2*f**2*fdd + 84*D1**2*f*fd**2*s**2 - 56*D1**2*f*fd**2*s - 16*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 18*D1**2*f*fd + 8*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 112*D1*Dd*f**3*s**2 + 56*D1*Dd*f**3*s - 28*D1*Dd*f**3 + 336*D1*Dd*f**2*fd*s**2 - 196*D1*Dd*f**2*fd*s + 28*D1*Dd*f**2*fd - 32*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 64*D1*Dd*f*fd*s**2 - 88*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 56*D1*Ddd*f**3*s**2 - 28*D1*Ddd*f**3*s + 14*D1*Ddd*f**3 + 16*D1*Ddd*f**2*s**2 - 8*D1*Ddd*f**2*s + 4*D1*Ddd*f**2 + 2*D1*bd1*(D1*(10*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(14 - 40*fd) + s*(20*fd - 14) + 7) + 7*fd*s*(1 - 2*s)) - Dd*f*(10*f + 7)*(8*s**2 - 6*s + 1)) + 168*Dd**2*f**3*s**2 - 84*Dd**2*f**3*s + 48*Dd**2*f**2*s**2 - 24*Dd**2*f**2*s) + f*(-18*D1**2*bd1**2*s*(10*f + 7)*(s - 1) + 9*D1**2*bdd1*f*(s**2*(14*f + 4) + 10*s - 5) - 59*D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) - 18*D1*bd1*(D1*(14*f**2*s**2 + f*(s**2*(4 - 42*fd) + s*(14*fd + 10) - 5) - fd*s*(8*s + 1)) - Dd*f*(4*s - 1)*(s*(14*f + 4) + 5)) - 59*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 354*Dd**2*f**2*s*(1 - 2*s)))/(126*d**2*k2**2*k3**2) + 4*D1**2*Pk3*Pkd2*ct**3*k1*k2**4*st**4*(72*C*D1**2*f**2*fd*r*s - 24*C*D1**2*f**2*fd*r + 72*C*D1**2*f**2*fd*s**2 - 72*C*D1**2*f**2*fd*s + 24*C*D1**2*f**2*fd - 36*C*D1**2*f**2*fdd*r*s + 12*C*D1**2*f**2*fdd*r - 36*C*D1**2*f**2*fdd*s**2 + 36*C*D1**2*f**2*fdd*s - 12*C*D1**2*f**2*fdd - 72*C*D1**2*f*fd**2*r*s + 24*C*D1**2*f*fd**2*r - 72*C*D1**2*f*fd**2*s**2 + 72*C*D1**2*f*fd**2*s - 12*C*D1**2*f*fd**2 + 96*C*D1*Dd*f**3*r*s - 24*C*D1*Dd*f**3*r + 96*C*D1*Dd*f**3*s**2 - 96*C*D1*Dd*f**3*s + 24*C*D1*Dd*f**3 - 288*C*D1*Dd*f**2*fd*r*s + 84*C*D1*Dd*f**2*fd*r - 288*C*D1*Dd*f**2*fd*s**2 + 288*C*D1*Dd*f**2*fd*s - 60*C*D1*Dd*f**2*fd - 48*C*D1*Ddd*f**3*r*s + 12*C*D1*Ddd*f**3*r - 48*C*D1*Ddd*f**3*s**2 + 48*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 144*C*Dd**2*f**3*r*s + 36*C*Dd**2*f**3*r - 144*C*Dd**2*f**3*s**2 + 144*C*Dd**2*f**3*s - 24*C*Dd**2*f**3 - 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s + 7*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 - 7*D1**2*bdd1*f**3*s + 9*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 - 9*D1**2*bdd1*f**2*s - 54*D1**2*f**2*fd*r*s + 18*D1**2*f**2*fd*r - 54*D1**2*f**2*fd*s**2 + 54*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 27*D1**2*f**2*fdd*r*s - 9*D1**2*f**2*fdd*r + 27*D1**2*f**2*fdd*s**2 - 27*D1**2*f**2*fdd*s + 9*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 54*D1**2*f*fd**2*r*s - 18*D1**2*f*fd**2*r + 54*D1**2*f*fd**2*s**2 - 54*D1**2*f*fd**2*s + 9*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 72*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 72*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 216*D1*Dd*f**2*fd*r*s - 63*D1*Dd*f**2*fd*r + 216*D1*Dd*f**2*fd*s**2 - 216*D1*Dd*f**2*fd*s + 45*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r*s - 36*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 288*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r*s - 216*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 576*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 36*D1*Ddd*f**3*r*s - 9*D1*Ddd*f**3*r + 36*D1*Ddd*f**3*s**2 - 36*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-18*K + 7*f + 9)*(r + s - 1) - 9*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-18*K + 7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 108*Dd**2*f**3*r*s - 27*Dd**2*f**3*r + 108*Dd**2*f**3*s**2 - 108*Dd**2*f**3*s + 18*Dd**2*f**3 + 432*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1)) - 9*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (36*K - 18)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 7*f + 9)) + Dd**2*f**2*(-18*K + 7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**6) - 8*D1**2*Pk3*Pkd2*ct**3*k1*k2**4*st**2*(36*C*D1**2*bdd1*f**2*r*s - 36*C*D1**2*bdd1*f**2*r + 36*C*D1**2*bdd1*f**2*s**2 - 72*C*D1**2*bdd1*f**2*s + 36*C*D1**2*bdd1*f**2 - 138*C*D1**2*f**2*fd*r*s + 46*C*D1**2*f**2*fd*r - 138*C*D1**2*f**2*fd*s**2 + 138*C*D1**2*f**2*fd*s - 46*C*D1**2*f**2*fd + 150*C*D1**2*f**2*fdd*r*s - 50*C*D1**2*f**2*fdd*r + 150*C*D1**2*f**2*fdd*s**2 - 150*C*D1**2*f**2*fdd*s + 50*C*D1**2*f**2*fdd + 300*C*D1**2*f*fd**2*r*s - 100*C*D1**2*f*fd**2*r + 300*C*D1**2*f*fd**2*s**2 - 300*C*D1**2*f*fd**2*s + 50*C*D1**2*f*fd**2 - 184*C*D1*Dd*f**3*r*s + 46*C*D1*Dd*f**3*r - 184*C*D1*Dd*f**3*s**2 + 184*C*D1*Dd*f**3*s - 46*C*D1*Dd*f**3 + 1200*C*D1*Dd*f**2*fd*r*s - 350*C*D1*Dd*f**2*fd*r + 1200*C*D1*Dd*f**2*fd*s**2 - 1200*C*D1*Dd*f**2*fd*s + 250*C*D1*Dd*f**2*fd + 200*C*D1*Ddd*f**3*r*s - 50*C*D1*Ddd*f**3*r + 200*C*D1*Ddd*f**3*s**2 - 200*C*D1*Ddd*f**3*s + 50*C*D1*Ddd*f**3 + 600*C*Dd**2*f**3*r*s - 150*C*Dd**2*f**3*r + 600*C*Dd**2*f**3*s**2 - 600*C*Dd**2*f**3*s + 100*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*s**2 - 45*D1**2*K*bdd1*f**2*s - 3*D1**2*bd1**2*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 27*D1**2*bdd1*f**2*r*s + 27*D1**2*bdd1*f**2*r - 27*D1**2*bdd1*f**2*s**2 + 54*D1**2*bdd1*f**2*s - 27*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 + 42*D1**2*f**2*fd*r*s - 14*D1**2*f**2*fd*r + 42*D1**2*f**2*fd*s**2 - 42*D1**2*f**2*fd*s + 14*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r*s + 25*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 75*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd + 54*D1**2*f**2*gd2*r*s + 54*D1**2*f**2*gd2*s**2 - 54*D1**2*f**2*gd2*s - 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*s**2 + 90*D1**2*f**2*gdd2*s - 150*D1**2*f*fd**2*r*s + 50*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 150*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 108*D1**2*f*fd*g2*r*s - 54*D1**2*f*fd*g2*r + 108*D1**2*f*fd*g2*s**2 - 108*D1**2*f*fd*g2*s + 54*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r*s + 90*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 90*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r*s + 90*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r*s + 90*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s + 56*D1*Dd*f**3*r*s - 14*D1*Dd*f**3*r + 56*D1*Dd*f**3*s**2 - 56*D1*Dd*f**3*s + 14*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r*s + 175*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 600*D1*Dd*f**2*fd*s - 125*D1*Dd*f**2*fd + 216*D1*Dd*f**2*g2*r*s - 54*D1*Dd*f**2*g2*r + 216*D1*Dd*f**2*g2*s**2 - 216*D1*Dd*f**2*g2*s + 54*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r*s + 90*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 720*D1*Dd*f**2*gd2*s - 90*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r*s + 540*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 - 100*D1*Ddd*f**3*r*s + 25*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 100*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r*s + 90*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + f**2*(r + s - 1)*(24*C*(s - 1) + s*(9*K - 11) + 18) + f*(-3*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 5*K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + (-28*r - 28*s + 28)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 28*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-3*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 5*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) + 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 300*Dd**2*f**3*r*s + 75*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 300*Dd**2*f**3*s - 50*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r*s + 270*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 + 3*b1**2*(D1**2*s*(5*f*(2*fd - fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 14*fd*(2*K - 1)*(r + s) + 7*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (14 - 28*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 5*f + 7)) - Dd**2*f*(-14*K + 5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 3*b1*(-48*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s + 24*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*s**2 - 12*C*D1**2*f*fdd*s + 24*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*s**2 - 12*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r*s - 24*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 144*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 18*D1**2*K*f*fd*r*s + 9*D1**2*K*f*fd*r - 18*D1**2*K*f*fd*s**2 + 18*D1**2*K*f*fd*s - 9*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 22*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s - 7*D1**2*f*fd - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*s**2 + 28*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 36*D1*Dd*K*f**2*r*s + 9*D1*Dd*K*f**2*r - 36*D1*Dd*K*f**2*s**2 + 36*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 + 44*D1*Dd*f**2*r*s - 11*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 44*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 108*D1*Dd*f*fd*s - 9*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 224*D1*Dd*f*gd2*s - 28*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r*s + 28*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 112*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 112*D1*Ddd*f*g2*s - 28*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(2*s - 1)*(r + s - 1) + f*(-5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (14 - 28*K)*(2*s - 1)*(r + s - 1)) + 7*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-14*K + 5*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 336*Dd**2*f*g2*s - 56*Dd**2*f*g2))/(105*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**3*k1*k2**4*(-3*D1*(21*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + D1*bd1*(-2*f**2*(r + s - 1)*(9*C*(s - 1) - s*(7*K + 1) + 1) + f*(fd*(30*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (14*g2*(s - 1) + 14*gd2*(3 - 6*s))*(r + s - 1)) + 42*fd*g2*(-2*r*s + r - s*(2*s - 2))) + 3*D1*bdd1*f*(s - 1)*(f*(10*C - 5) - 14*g2)*(r + s - 1) + 3*Dd*bd1*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*f*(D1*(f*(fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 14*gd2*s*(r + s - 1)) - 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b1**2*(D1**2*s*(3*f*fd*(2*r + 2*s - 1) + (r + s)*(-9*K*fdd + fd*(3*K + 5))) + D1*(Dd*(9*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 3*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(3*K + 5)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(3*D1**2*(-21*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(-14*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(18*C - 2)*(2*r + 2*s - 1) - fdd*s*(30*C - 15)*(2*r + 2*s - 1) + s*(-14*gd2 + 42*gdd2)*(r + s - 1)) + s*(-fd**2*(30*C - 15)*(2*r + 2*s - 1) + 14*fd*(-g2*(r + s) + gd2*(6*r + 6*s - 3)) + 42*fdd*g2*(r + s))) + 7*D1*bd1*(D1*(9*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 3*f**2*(2*s - 1)*(r + s - 1) + f*(3*K + 5)*(2*s - 1)*(r + s - 1)) - 9*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 3*D1*(Dd*(2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(9*C - 7*K - 1) + f*(-fd*(30*C - 15)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 14*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 42*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 42*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f*(f*(10*C - 5) - 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**3*k1*k2**2*st**4*(-912*C*D1**2*f**2*fd*r*s + 304*C*D1**2*f**2*fd*r + 1800*C*D1**2*f**2*fd*s**2 - 896*C*D1**2*f**2*fd*s + 600*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r*s - 200*C*D1**2*f**2*fdd*r - 900*C*D1**2*f**2*fdd*s**2 + 400*C*D1**2*f**2*fdd*s - 300*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r*s - 400*C*D1**2*f*fd**2*r - 1800*C*D1**2*f*fd**2*s**2 + 800*C*D1**2*f*fd**2*s + 200*C*D1**2*f*fd**2 - 1216*C*D1*Dd*f**3*r*s + 304*C*D1*Dd*f**3*r + 2400*C*D1*Dd*f**3*s**2 - 592*C*D1*Dd*f**3*s + 600*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r*s - 1400*C*D1*Dd*f**2*fd*r - 7200*C*D1*Dd*f**2*fd*s**2 + 2200*C*D1*Dd*f**2*fd*s + 800*C*D1*Ddd*f**3*r*s - 200*C*D1*Ddd*f**3*r - 1200*C*D1*Ddd*f**3*s**2 + 200*C*D1*Ddd*f**3*s - 300*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r*s - 600*C*Dd**2*f**3*r - 3600*C*Dd**2*f**3*s**2 + 600*C*Dd**2*f**3*s + 400*C*Dd**2*f**3 + 180*D1**2*K*bdd1*f**2*r*s - 450*D1**2*K*bdd1*f**2*s**2 - 180*D1**2*K*bdd1*f**2*s - 140*D1**2*bdd1*f**3*r*s + 35*D1**2*bdd1*f**3*s**2 + 140*D1**2*bdd1*f**3*s - 360*D1**2*bdd1*f**2*r*s + 45*D1**2*bdd1*f**2*s**2 + 360*D1**2*bdd1*f**2*s - 560*D1**2*f**3*fd*r*s + 140*D1**2*f**3*fd*r + 280*D1**2*f**3*fd*s + 560*D1**2*f**3*fdd*r*s - 140*D1**2*f**3*fdd*r - 280*D1**2*f**3*fdd*s + 1680*D1**2*f**2*fd**2*r*s - 420*D1**2*f**2*fd**2*r - 840*D1**2*f**2*fd**2*s + 280*D1**2*f**2*fd**2 + 1272*D1**2*f**2*fd*r*s - 424*D1**2*f**2*fd*r - 990*D1**2*f**2*fd*s**2 + 236*D1**2*f**2*fd*s - 330*D1**2*f**2*fd - 780*D1**2*f**2*fdd*r*s + 260*D1**2*f**2*fdd*r + 495*D1**2*f**2*fdd*s**2 - 70*D1**2*f**2*fdd*s + 165*D1**2*f**2*fdd + 720*D1**2*f**2*gd2*r*s - 1800*D1**2*f**2*gd2*s**2 - 720*D1**2*f**2*gd2*s - 360*D1**2*f**2*gdd2*r*s + 900*D1**2*f**2*gdd2*s**2 + 360*D1**2*f**2*gdd2*s - 1560*D1**2*f*fd**2*r*s + 520*D1**2*f*fd**2*r + 990*D1**2*f*fd**2*s**2 - 140*D1**2*f*fd**2*s - 260*D1**2*f*fd**2 + 1440*D1**2*f*fd*g2*r*s - 720*D1**2*f*fd*g2*r - 3600*D1**2*f*fd*g2*s**2 + 3600*D1**2*f*fd*g2*s - 1800*D1**2*f*fd*g2 - 1440*D1**2*f*fd*gd2*r*s + 360*D1**2*f*fd*gd2*r + 3600*D1**2*f*fd*gd2*s**2 - 1080*D1**2*f*fd*gd2*s - 360*D1**2*f*fd*gd2 - 720*D1**2*f*fdd*g2*r*s + 360*D1**2*f*fdd*g2*r + 1800*D1**2*f*fdd*g2*s**2 - 1800*D1**2*f*fdd*g2*s + 900*D1**2*f*fdd*g2 - 720*D1**2*fd**2*g2*r*s + 360*D1**2*fd**2*g2*r + 1800*D1**2*fd**2*g2*s**2 - 1800*D1**2*fd**2*g2*s - 560*D1*Dd*f**4*r*s + 140*D1*Dd*f**4*r + 280*D1*Dd*f**4*s + 4480*D1*Dd*f**3*fd*r*s - 1120*D1*Dd*f**3*fd*r - 2240*D1*Dd*f**3*fd*s + 560*D1*Dd*f**3*fd + 1696*D1*Dd*f**3*r*s - 424*D1*Dd*f**3*r - 1320*D1*Dd*f**3*s**2 - 188*D1*Dd*f**3*s - 330*D1*Dd*f**3 - 6240*D1*Dd*f**2*fd*r*s + 1820*D1*Dd*f**2*fd*r + 3960*D1*Dd*f**2*fd*s**2 + 290*D1*Dd*f**2*fd*s - 450*D1*Dd*f**2*fd + 2880*D1*Dd*f**2*g2*r*s - 720*D1*Dd*f**2*g2*r - 7200*D1*Dd*f**2*g2*s**2 + 2160*D1*Dd*f**2*g2*s - 1800*D1*Dd*f**2*g2 - 2880*D1*Dd*f**2*gd2*r*s + 360*D1*Dd*f**2*gd2*r + 7200*D1*Dd*f**2*gd2*s**2 + 360*D1*Dd*f**2*gd2*s - 360*D1*Dd*f**2*gd2 - 5760*D1*Dd*f*fd*g2*r*s + 2160*D1*Dd*f*fd*g2*r + 14400*D1*Dd*f*fd*g2*s**2 - 9360*D1*Dd*f*fd*g2*s + 1080*D1*Dd*f*fd*g2 + 560*D1*Ddd*f**4*r*s - 140*D1*Ddd*f**4*r - 280*D1*Ddd*f**4*s - 1040*D1*Ddd*f**3*r*s + 260*D1*Ddd*f**3*r + 660*D1*Ddd*f**3*s**2 + 190*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 - 1440*D1*Ddd*f**2*g2*r*s + 360*D1*Ddd*f**2*g2*r + 3600*D1*Ddd*f**2*g2*s**2 - 1080*D1*Ddd*f**2*g2*s + 900*D1*Ddd*f**2*g2 + 10*D1*bd1*f*(D1*(f*s*(-18*K*(2*r - 5*s - 2) + 7*f*(4*r - s - 4) + 72*r - 9*s - 72) + fd*(9*K*(8*r*s - 2*r - 20*s**2 + 6*s + 2) + 7*f*(r*(2 - 12*s) + 3*s**2 + 7*s - 2) - 144*r*s + 36*r + 18*s**2 + 63*s - 36)) + Dd*f*(-18*K*(-8*r*s + r + 20*s**2 + s - 1) + 7*f*(r*(2 - 16*s) + 4*s**2 + 11*s - 2) - 288*r*s + 36*r + 36*s**2 + 207*s - 36)) + 1680*Dd**2*f**4*r*s - 420*Dd**2*f**4*r - 840*Dd**2*f**4*s + 280*Dd**2*f**4 - 3120*Dd**2*f**3*r*s + 780*Dd**2*f**3*r + 1980*Dd**2*f**3*s**2 + 570*Dd**2*f**3*s - 520*Dd**2*f**3 - 4320*Dd**2*f**2*g2*r*s + 1080*Dd**2*f**2*g2*r + 10800*Dd**2*f**2*g2*s**2 - 3240*Dd**2*f**2*g2*s - 720*Dd**2*f**2*g2 + 5*b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(4 - 12*s) + 3*s**2 + 2*s + 1) + f*(14*fd**2*(r*(4 - 12*s) + 3*s**2 + 2*s - 2) - 18*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1) + 9*fdd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1)) + 18*fd**2*(r*(2*K - 4)*(2*s - 1) - s*(10*K - 1)*(s - 1))) + D1*f*(2*Dd*(-7*f**2*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) + f*(-18*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + fd*(r*(98 - 336*s) + 84*s**2 + 91*s - 35) + 288*r*s - 72*r - 36*s**2 - 126*s - 9) + 9*fd*(2*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) - 64*r*s + 24*r + 8*s**2 + 10*s - 7)) + Ddd*f*(18*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + 7*f*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) - 288*r*s + 72*r + 36*s**2 + 126*s + 9)) + 2*Dd**2*f**2*(18*K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) + 7*f*(r*(6 - 24*s) + 6*s**2 + 9*s - 4) - 432*r*s + 108*r + 54*s**2 + 189*s - 72)))/(210*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**3*k1*k2**2*st**2*(-72*C*D1**2*bdd1*f**2*r*s - 360*C*D1**2*bdd1*f**2*r - 540*C*D1**2*bdd1*f**2*s**2 + 216*C*D1**2*bdd1*f**2*s - 108*C*D1**2*bdd1*f**2 - 7008*C*D1**2*f**2*fd*r*s + 2336*C*D1**2*f**2*fd*r - 6792*C*D1**2*f**2*fd*s**2 + 6864*C*D1**2*f**2*fd*s - 2264*C*D1**2*f**2*fd + 5448*C*D1**2*f**2*fdd*r*s - 1816*C*D1**2*f**2*fdd*r + 5016*C*D1**2*f**2*fdd*s**2 - 5160*C*D1**2*f**2*fdd*s + 1672*C*D1**2*f**2*fdd + 10896*C*D1**2*f*fd**2*r*s - 3632*C*D1**2*f*fd**2*r + 10032*C*D1**2*f*fd**2*s**2 - 10320*C*D1**2*f*fd**2*s + 1816*C*D1**2*f*fd**2 - 9344*C*D1*Dd*f**3*r*s + 2336*C*D1*Dd*f**3*r - 9056*C*D1*Dd*f**3*s**2 + 9200*C*D1*Dd*f**3*s - 2264*C*D1*Dd*f**3 + 43584*C*D1*Dd*f**2*fd*r*s - 12712*C*D1*Dd*f**2*fd*r + 40128*C*D1*Dd*f**2*fd*s**2 - 41568*C*D1*Dd*f**2*fd*s + 8792*C*D1*Dd*f**2*fd + 7264*C*D1*Ddd*f**3*r*s - 1816*C*D1*Ddd*f**3*r + 6688*C*D1*Ddd*f**3*s**2 - 6976*C*D1*Ddd*f**3*s + 1672*C*D1*Ddd*f**3 + 21792*C*Dd**2*f**3*r*s - 5448*C*Dd**2*f**3*r + 20064*C*Dd**2*f**3*s**2 - 20928*C*Dd**2*f**3*s + 3632*C*Dd**2*f**3 + 1404*D1**2*K*bdd1*f**2*r*s + 1764*D1**2*K*bdd1*f**2*s**2 - 1404*D1**2*K*bdd1*f**2*s - 1656*D1**2*b2*f*fd*r*s + 828*D1**2*b2*f*fd*r - 1656*D1**2*b2*f*fd*s**2 + 1656*D1**2*b2*f*fd*s - 828*D1**2*b2*f*fd + 1080*D1**2*b2*f*fdd*r*s - 540*D1**2*b2*f*fdd*r + 1080*D1**2*b2*f*fdd*s**2 - 1080*D1**2*b2*f*fdd*s + 540*D1**2*b2*f*fdd + 1080*D1**2*b2*fd**2*r*s - 540*D1**2*b2*fd**2*r + 1080*D1**2*b2*fd**2*s**2 - 1080*D1**2*b2*fd**2*s + 18*D1**2*bd1**2*f*(-14*K*(2*r*s + r + 5*s**2 - 2*s - 1) + 5*f*(2*r + s**2 + 3*s - 2) - 28*r*(s - 1) + 7*s**2 + 35*s - 28) - 828*D1**2*bd2*f**2*r*s - 828*D1**2*bd2*f**2*s**2 + 828*D1**2*bd2*f**2*s + 2160*D1**2*bd2*f*fd*r*s - 540*D1**2*bd2*f*fd*r + 2160*D1**2*bd2*f*fd*s**2 - 2160*D1**2*bd2*f*fd*s + 540*D1**2*bd2*f*fd - 360*D1**2*bdd1*f**3*r*s - 180*D1**2*bdd1*f**3*r - 495*D1**2*bdd1*f**3*s**2 + 540*D1**2*bdd1*f**3*s - 576*D1**2*bdd1*f**2*r*s + 468*D1**2*bdd1*f**2*r - 360*D1**2*bdd1*f**2*s**2 + 486*D1**2*bdd1*f**2*s - 27*D1**2*bdd1*f**2 + 504*D1**2*bdd1*f*g2*r*s + 504*D1**2*bdd1*f*g2*r + 1260*D1**2*bdd1*f*g2*s**2 - 504*D1**2*bdd1*f*g2*s + 252*D1**2*bdd1*f*g2 + 540*D1**2*bdd2*f**2*r*s + 540*D1**2*bdd2*f**2*s**2 - 540*D1**2*bdd2*f**2*s + 4032*D1**2*f**2*fd*r*s - 1344*D1**2*f**2*fd*r + 4182*D1**2*f**2*fd*s**2 - 4132*D1**2*f**2*fd*s + 1394*D1**2*f**2*fd - 3636*D1**2*f**2*fdd*r*s + 1212*D1**2*f**2*fdd*r - 3387*D1**2*f**2*fdd*s**2 + 3470*D1**2*f**2*fdd*s - 1129*D1**2*f**2*fdd + 3600*D1**2*f**2*gd2*r*s + 4536*D1**2*f**2*gd2*s**2 - 3600*D1**2*f**2*gd2*s - 2808*D1**2*f**2*gdd2*r*s - 3528*D1**2*f**2*gdd2*s**2 + 2808*D1**2*f**2*gdd2*s - 7272*D1**2*f*fd**2*r*s + 2424*D1**2*f*fd**2*r - 6774*D1**2*f*fd**2*s**2 + 6940*D1**2*f*fd**2*s - 1212*D1**2*f*fd**2 + 7200*D1**2*f*fd*g2*r*s - 3600*D1**2*f*fd*g2*r + 9072*D1**2*f*fd*g2*s**2 - 9072*D1**2*f*fd*g2*s + 4536*D1**2*f*fd*g2 - 11232*D1**2*f*fd*gd2*r*s + 2808*D1**2*f*fd*gd2*r - 14112*D1**2*f*fd*gd2*s**2 + 12672*D1**2*f*fd*gd2*s - 2808*D1**2*f*fd*gd2 - 5616*D1**2*f*fdd*g2*r*s + 2808*D1**2*f*fdd*g2*r - 7056*D1**2*f*fdd*g2*s**2 + 7056*D1**2*f*fdd*g2*s - 3528*D1**2*f*fdd*g2 - 5616*D1**2*fd**2*g2*r*s + 2808*D1**2*fd**2*g2*r - 7056*D1**2*fd**2*g2*s**2 + 7056*D1**2*fd**2*g2*s - 3312*D1*Dd*b2*f**2*r*s + 828*D1*Dd*b2*f**2*r - 3312*D1*Dd*b2*f**2*s**2 + 3312*D1*Dd*b2*f**2*s - 828*D1*Dd*b2*f**2 + 8640*D1*Dd*b2*f*fd*r*s - 3240*D1*Dd*b2*f*fd*r + 8640*D1*Dd*b2*f*fd*s**2 - 8640*D1*Dd*b2*f*fd*s + 2160*D1*Dd*b2*f*fd + 4320*D1*Dd*bd2*f**2*r*s - 540*D1*Dd*bd2*f**2*r + 4320*D1*Dd*bd2*f**2*s**2 - 4320*D1*Dd*bd2*f**2*s + 540*D1*Dd*bd2*f**2 + 5376*D1*Dd*f**3*r*s - 1344*D1*Dd*f**3*r + 5576*D1*Dd*f**3*s**2 - 5476*D1*Dd*f**3*s + 1394*D1*Dd*f**3 - 29088*D1*Dd*f**2*fd*r*s + 8484*D1*Dd*f**2*fd*r - 27096*D1*Dd*f**2*fd*s**2 + 27926*D1*Dd*f**2*fd*s - 5894*D1*Dd*f**2*fd + 14400*D1*Dd*f**2*g2*r*s - 3600*D1*Dd*f**2*g2*r + 18144*D1*Dd*f**2*g2*s**2 - 16272*D1*Dd*f**2*g2*s + 4536*D1*Dd*f**2*g2 - 22464*D1*Dd*f**2*gd2*r*s + 2808*D1*Dd*f**2*gd2*r - 28224*D1*Dd*f**2*gd2*s**2 + 23904*D1*Dd*f**2*gd2*s - 2808*D1*Dd*f**2*gd2 - 44928*D1*Dd*f*fd*g2*r*s + 16848*D1*Dd*f*fd*g2*r - 56448*D1*Dd*f*fd*g2*s**2 + 53568*D1*Dd*f*fd*g2*s - 12672*D1*Dd*f*fd*g2 + 2160*D1*Ddd*b2*f**2*r*s - 540*D1*Ddd*b2*f**2*r + 2160*D1*Ddd*b2*f**2*s**2 - 2160*D1*Ddd*b2*f**2*s + 540*D1*Ddd*b2*f**2 - 4848*D1*Ddd*f**3*r*s + 1212*D1*Ddd*f**3*r - 4516*D1*Ddd*f**3*s**2 + 4682*D1*Ddd*f**3*s - 1129*D1*Ddd*f**3 - 11232*D1*Ddd*f**2*g2*r*s + 2808*D1*Ddd*f**2*g2*r - 14112*D1*Ddd*f**2*g2*s**2 + 12672*D1*Ddd*f**2*g2*s - 3528*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(15*f**3*(2*r*(s + 1) + s*(5*s - 4)) + f**2*(4*C*(13*r*s + 23*r + 45*s**2 - 18*s + 9) - 300*K*r*s - 378*K*s**2 + 300*K*s - 15*fd*(24*r*s + 33*s**2 - 31*s + 2) + 38*r*s - 128*r - 6*s**2 - 36*s + 9) - 3*f*(fd*(4*C*(4*r*(s + 1) + 30*s**2 - 19*s - 5) + K*(-312*r*s + 78*r - 392*s**2 + 352*s - 78) + 128*r*s - 58*r + 80*s**2 - 99*s + 50) + 28*g2*(2*r*(s + 1) + 5*s**2 - 2*s + 1) - 28*gd2*(2*r*s + r + 5*s**2 - 2*s - 1)) + 84*fd*g2*(r*(2*s - 1) + s*(5*s - 5))) - 3*Dd*f*(5*f**2*(4*r*(8*s + 1) + 44*s**2 - 43*s + 2) + f*(4*C*(r*(8*s + 19) + 60*s**2 - 29*s - 7) + K*(-624*r*s + 78*r - 784*s**2 + 664*s - 78) + 256*r*s - 136*r + 160*s**2 - 212*s + 79) - 28*g2*(r*(8*s + 3) + 20*s**2 - 11*s - 1))) + 6480*Dd**2*b2*f**2*r*s - 1620*Dd**2*b2*f**2*r + 6480*Dd**2*b2*f**2*s**2 - 6480*Dd**2*b2*f**2*s + 1080*Dd**2*b2*f**2 - 14544*Dd**2*f**3*r*s + 3636*Dd**2*f**3*r - 13548*Dd**2*f**3*s**2 + 14046*Dd**2*f**3*s - 2424*Dd**2*f**3 - 33696*Dd**2*f**2*g2*r*s + 8424*Dd**2*f**2*g2*r - 42336*Dd**2*f**2*g2*s**2 + 38016*Dd**2*f**2*g2*s - 5616*Dd**2*f**2*g2 + 9*b1**2*(D1**2*(20*f*fd*(2*r - s**2 + 4*s - 2) - 10*f*fdd*(2*r - s**2 + 4*s - 2) - 10*fd**2*(2*r - s**2 + 4*s - 2) + 14*fd*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4) - 7*fdd*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4)) - 2*D1*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(-14*K*(r*(8*s - 2) + 20*s**2 - 14*s + 5) + 10*fd*(4*r - 4*s**2 + 9*s - 4) - 112*r*s + 28*r + 28*s**2 + 42*s + 7) + 7*fd*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8)) + D1*Ddd*f*(-14*K*(r*(8*s - 2) + 20*s**2 - 14*s + 5) + 5*f*(4*s**2 - 2*s + 1) - 112*r*s + 28*r + 28*s**2 + 42*s + 7) + 2*Dd**2*f*(-14*K*(3*r*(4*s - 1) + 30*s**2 - 21*s + 2) + 30*f*s**2 - 15*f*s - 42*r*(4*s - 1) + 42*s**2 + 63*s - 28)) - 3*b1*(-208*C*D1**2*f*fd*r*s + 288*C*D1**2*f*fd*r - 720*C*D1**2*f*fd*s**2 + 680*C*D1**2*f*fd*s - 288*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r*s - 144*C*D1**2*f*fdd*r + 360*C*D1**2*f*fdd*s**2 - 312*C*D1**2*f*fdd*s + 144*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r*s - 144*C*D1**2*fd**2*r + 360*C*D1**2*fd**2*s**2 - 312*C*D1**2*fd**2*s + 144*C*D1**2*fd**2 - 416*C*D1*Dd*f**2*r*s + 104*C*D1*Dd*f**2*r - 1440*C*D1*Dd*f**2*s**2 + 928*C*D1*Dd*f**2*s - 360*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r*s - 624*C*D1*Dd*f*fd*r + 2880*C*D1*Dd*f*fd*s**2 - 2064*C*D1*Dd*f*fd*s + 600*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 720*C*D1*Ddd*f**2*s**2 - 408*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 2160*C*Dd**2*f**2*s**2 - 1224*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 + 1200*D1**2*K*f*fd*r*s - 600*D1**2*K*f*fd*r + 1512*D1**2*K*f*fd*s**2 - 1512*D1**2*K*f*fd*s + 756*D1**2*K*f*fd - 936*D1**2*K*f*fdd*r*s + 468*D1**2*K*f*fdd*r - 1176*D1**2*K*f*fdd*s**2 + 1176*D1**2*K*f*fdd*s - 588*D1**2*K*f*fdd - 936*D1**2*K*fd**2*r*s + 468*D1**2*K*fd**2*r - 1176*D1**2*K*fd**2*s**2 + 1176*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(-7*K*(r*(8*s + 4) + 20*s**2 - 8*s + 2) + 5*f*(4*r + 2*s**2 + 6*s - 3) - 56*r*(s - 1) + 14*s**2 + 70*s - 21) - 180*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*r - 450*D1**2*f**2*fd*s**2 + 300*D1**2*f**2*fd*s - 150*D1**2*f**2*fd + 360*D1**2*f**2*fdd*r*s - 180*D1**2*f**2*fdd*r + 495*D1**2*f**2*fdd*s**2 - 390*D1**2*f**2*fdd*s + 165*D1**2*f**2*fdd + 720*D1**2*f*fd**2*r*s - 360*D1**2*f*fd**2*r + 990*D1**2*f*fd**2*s**2 - 780*D1**2*f*fd**2*s + 180*D1**2*f*fd**2 - 152*D1**2*f*fd*r*s - 180*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 - 20*D1**2*f*fd*s + 30*D1**2*f*fd + 384*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 240*D1**2*f*fdd*s**2 - 270*D1**2*f*fdd*s + 111*D1**2*f*fdd + 336*D1**2*f*gd2*r*s + 840*D1**2*f*gd2*s**2 - 336*D1**2*f*gd2*s - 168*D1**2*f*gdd2*r*s - 420*D1**2*f*gdd2*s**2 + 168*D1**2*f*gdd2*s + 384*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 240*D1**2*fd**2*s**2 - 270*D1**2*fd**2*s - 108*D1**2*fd**2 + 336*D1**2*fd*g2*r*s - 672*D1**2*fd*g2*r + 840*D1**2*fd*g2*s**2 - 1344*D1**2*fd*g2*s + 672*D1**2*fd*g2 - 336*D1**2*fd*gd2*r*s + 336*D1**2*fd*gd2*r - 840*D1**2*fd*gd2*s**2 + 840*D1**2*fd*gd2*s - 336*D1**2*fd*gd2 - 168*D1**2*fdd*g2*r*s + 336*D1**2*fdd*g2*r - 420*D1**2*fdd*g2*s**2 + 672*D1**2*fdd*g2*s - 336*D1**2*fdd*g2 + 2400*D1*Dd*K*f**2*r*s - 600*D1*Dd*K*f**2*r + 3024*D1*Dd*K*f**2*s**2 - 2712*D1*Dd*K*f**2*s + 756*D1*Dd*K*f**2 - 7488*D1*Dd*K*f*fd*r*s + 2808*D1*Dd*K*f*fd*r - 9408*D1*Dd*K*f*fd*s**2 + 8928*D1*Dd*K*f*fd*s - 2112*D1*Dd*K*f*fd - 240*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 600*D1*Dd*f**3*s**2 + 420*D1*Dd*f**3*s - 150*D1*Dd*f**3 + 2880*D1*Dd*f**2*fd*r*s - 1080*D1*Dd*f**2*fd*r + 3960*D1*Dd*f**2*fd*s**2 - 3270*D1*Dd*f**2*fd*s + 750*D1*Dd*f**2*fd - 304*D1*Dd*f**2*r*s + 76*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 + 128*D1*Dd*f**2*s + 12*D1*Dd*f**2 + 3072*D1*Dd*f*fd*r*s - 528*D1*Dd*f*fd*r + 1920*D1*Dd*f*fd*s**2 - 2328*D1*Dd*f*fd*s + 342*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 3360*D1*Dd*f*g2*s**2 - 2352*D1*Dd*f*g2*s + 840*D1*Dd*f*g2 - 1344*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 3360*D1*Dd*f*gd2*s**2 + 1848*D1*Dd*f*gd2*s - 168*D1*Dd*f*gd2 - 1344*D1*Dd*fd*g2*r*s + 1512*D1*Dd*fd*g2*r - 3360*D1*Dd*fd*g2*s**2 + 3864*D1*Dd*fd*g2*s - 1344*D1*Dd*fd*g2 - 1872*D1*Ddd*K*f**2*r*s + 468*D1*Ddd*K*f**2*r - 2352*D1*Ddd*K*f**2*s**2 + 2112*D1*Ddd*K*f**2*s - 588*D1*Ddd*K*f**2 + 480*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r + 660*D1*Ddd*f**3*s**2 - 570*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 768*D1*Ddd*f**2*r*s - 192*D1*Ddd*f**2*r + 480*D1*Ddd*f**2*s**2 - 624*D1*Ddd*f**2*s + 120*D1*Ddd*f**2 - 672*D1*Ddd*f*g2*r*s + 168*D1*Ddd*f*g2*r - 1680*D1*Ddd*f*g2*s**2 + 1176*D1*Ddd*f*g2*s - 420*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(5*f**2*(4*r + 2*s**2 + 6*s - 3) - f*(14*K*(r*(4*s + 2) + 10*s**2 - 4*s + 1) + 20*fd*s**2 - 10*fd*s + 56*r*(s - 1) - 14*s**2 - 70*s + 21) + 7*fd*(K*(8*r*s - 6*r + 20*s**2 - 20*s + 4) - 2*s**2 + s*(8*r + 3) - 2)) + Dd*f*(-5*f*(8*r + 8*s**2 + 10*s - 7) + 28*r*(8*K*s + K + 8*s - 5) + 7*s**2*(80*K - 8) - 7*s*(44*K + 26) + 91)) - 5616*Dd**2*K*f**2*r*s + 1404*Dd**2*K*f**2*r - 7056*Dd**2*K*f**2*s**2 + 6336*Dd**2*K*f**2*s - 936*Dd**2*K*f**2 + 1440*Dd**2*f**3*r*s - 360*Dd**2*f**3*r + 1980*Dd**2*f**3*s**2 - 1710*Dd**2*f**3*s + 240*Dd**2*f**3 + 2304*Dd**2*f**2*r*s - 576*Dd**2*f**2*r + 1440*Dd**2*f**2*s**2 - 1872*Dd**2*f**2*s + 384*Dd**2*f**2 - 2016*Dd**2*f*g2*r*s + 504*Dd**2*f*g2*r - 5040*Dd**2*f*g2*s**2 + 3528*Dd**2*f*g2*s - 336*Dd**2*f*g2))/(315*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**3*k1*k2**2*(-2016*C*D1**2*bd1**2*f*r*s + 1008*C*D1**2*bd1**2*f*r - 2016*C*D1**2*bd1**2*f*s**2 + 2016*C*D1**2*bd1**2*f*s - 5544*C*D1**2*bd1*f**2*r*s + 4752*C*D1**2*bd1*f**2*r - 4752*C*D1**2*bd1*f**2*s**2 + 7920*C*D1**2*bd1*f**2*s - 3960*C*D1**2*bd1*f**2 + 12096*C*D1**2*bd1*f*fd*r*s - 6408*C*D1**2*bd1*f*fd*r + 11520*C*D1**2*bd1*f*fd*s**2 - 15264*C*D1**2*bd1*f*fd*s + 3384*C*D1**2*bd1*f*fd + 3024*C*D1**2*bdd1*f**2*r*s - 3384*C*D1**2*bdd1*f**2*r + 2880*C*D1**2*bdd1*f**2*s**2 - 6480*C*D1**2*bdd1*f**2*s + 3240*C*D1**2*bdd1*f**2 + 2760*C*D1**2*f**2*fd*r*s - 920*C*D1**2*f**2*fd*r - 1080*C*D1**2*f**2*fd*s**2 - 200*C*D1**2*f**2*fd*s - 360*C*D1**2*f**2*fd + 1320*C*D1**2*f**2*fdd*r*s - 440*C*D1**2*f**2*fdd*r + 3780*C*D1**2*f**2*fdd*s**2 - 2960*C*D1**2*f**2*fdd*s + 1260*C*D1**2*f**2*fdd + 2640*C*D1**2*f*fd**2*r*s - 880*C*D1**2*f*fd**2*r + 7560*C*D1**2*f*fd**2*s**2 - 5920*C*D1**2*f*fd**2*s + 440*C*D1**2*f*fd**2 + 24192*C*D1*Dd*bd1*f**2*r*s - 16560*C*D1*Dd*bd1*f**2*r + 23040*C*D1*Dd*bd1*f**2*s**2 - 37728*C*D1*Dd*bd1*f**2*s + 13248*C*D1*Dd*bd1*f**2 + 3680*C*D1*Dd*f**3*r*s - 920*C*D1*Dd*f**3*r - 1440*C*D1*Dd*f**3*s**2 - 1120*C*D1*Dd*f**3*s - 360*C*D1*Dd*f**3 + 10560*C*D1*Dd*f**2*fd*r*s - 3080*C*D1*Dd*f**2*fd*r + 30240*C*D1*Dd*f**2*fd*s**2 - 22040*C*D1*Dd*f**2*fd*s + 3840*C*D1*Dd*f**2*fd + 1760*C*D1*Ddd*f**3*r*s - 440*C*D1*Ddd*f**3*r + 5040*C*D1*Ddd*f**3*s**2 - 3400*C*D1*Ddd*f**3*s + 1260*C*D1*Ddd*f**3 + 5280*C*Dd**2*f**3*r*s - 1320*C*Dd**2*f**3*r + 15120*C*Dd**2*f**3*s**2 - 10200*C*Dd**2*f**3*s + 880*C*Dd**2*f**3 + 3696*D1**2*K*bd1**2*f*r*s - 2100*D1**2*K*bd1**2*f*r + 4368*D1**2*K*bd1**2*f*s**2 - 6720*D1**2*K*bd1**2*f*s + 2100*D1**2*K*bd1**2*f + 756*D1**2*K*bd1*f**2*r*s - 252*D1**2*K*bd1*f**2*s**2 - 756*D1**2*K*bd1*f**2*s + 1008*D1**2*K*bd1*f*fd*r*s - 252*D1**2*K*bd1*f*fd*r + 3528*D1**2*K*bd1*f*fd*s**2 - 2268*D1**2*K*bd1*f*fd*s + 252*D1**2*K*bd1*f*fd + 252*D1**2*K*bdd1*f**2*r*s + 882*D1**2*K*bdd1*f**2*s**2 - 252*D1**2*K*bdd1*f**2*s - 1512*D1**2*bd1**2*f**2*r*s + 756*D1**2*bd1**2*f**2*r - 882*D1**2*bd1**2*f**2*s**2 + 1638*D1**2*bd1**2*f**2*s - 756*D1**2*bd1**2*f**2 + 168*D1**2*bd1**2*f*r*s - 84*D1**2*bd1**2*f*r + 210*D1**2*bd1**2*f*s**2 + 462*D1**2*bd1**2*f*s - 672*D1**2*bd1**2*f + 3360*D1**2*bd1**2*g2*r*s - 1680*D1**2*bd1**2*g2*r + 3360*D1**2*bd1**2*g2*s**2 - 3360*D1**2*bd1**2*g2*s + 1512*D1**2*bd1*bd2*f*r*s - 756*D1**2*bd1*bd2*f*r + 1512*D1**2*bd1*bd2*f*s**2 - 2268*D1**2*bd1*bd2*f*s + 756*D1**2*bd1*bd2*f + 3168*D1**2*bd1*f**2*r*s - 2772*D1**2*bd1*f**2*r + 2682*D1**2*bd1*f**2*s**2 - 3816*D1**2*bd1*f**2*s + 2034*D1**2*bd1*f**2 - 8352*D1**2*bd1*f*fd*r*s + 4356*D1**2*bd1*f*fd*r - 7380*D1**2*bd1*f*fd*s**2 + 9828*D1**2*bd1*f*fd*s - 2268*D1**2*bd1*f*fd + 6552*D1**2*bd1*f*g2*r*s - 5040*D1**2*bd1*f*g2*r + 7056*D1**2*bd1*f*g2*s**2 - 11088*D1**2*bd1*f*g2*s + 5544*D1**2*bd1*f*g2 - 7392*D1**2*bd1*f*gd2*r*s + 4200*D1**2*bd1*f*gd2*r - 8736*D1**2*bd1*f*gd2*s**2 + 13440*D1**2*bd1*f*gd2*s - 4200*D1**2*bd1*f*gd2 - 7392*D1**2*bd1*fd*g2*r*s + 3696*D1**2*bd1*fd*g2*r - 8736*D1**2*bd1*fd*g2*s**2 + 8736*D1**2*bd1*fd*g2*s + 504*D1**2*bd2*f**2*r*s + 504*D1**2*bd2*f**2*s**2 - 504*D1**2*bd2*f**2*s - 2088*D1**2*bdd1*f**2*r*s + 2268*D1**2*bdd1*f**2*r - 1845*D1**2*bdd1*f**2*s**2 + 4050*D1**2*bdd1*f**2*s - 2025*D1**2*bdd1*f**2 - 3696*D1**2*bdd1*f*g2*r*s + 4200*D1**2*bdd1*f*g2*r - 4368*D1**2*bdd1*f*g2*s**2 + 9744*D1**2*bdd1*f*g2*s - 4872*D1**2*bdd1*f*g2 - 1920*D1**2*f**2*fd*r*s + 640*D1**2*f**2*fd*r + 540*D1**2*f**2*fd*s**2 + 280*D1**2*f**2*fd*s + 180*D1**2*f**2*fd - 660*D1**2*f**2*fdd*r*s + 220*D1**2*f**2*fdd*r - 1890*D1**2*f**2*fdd*s**2 + 1480*D1**2*f**2*fdd*s - 630*D1**2*f**2*fdd - 1512*D1**2*f**2*gd2*r*s + 504*D1**2*f**2*gd2*s**2 + 1512*D1**2*f**2*gd2*s - 504*D1**2*f**2*gdd2*r*s - 1764*D1**2*f**2*gdd2*s**2 + 504*D1**2*f**2*gdd2*s - 1320*D1**2*f*fd**2*r*s + 440*D1**2*f*fd**2*r - 3780*D1**2*f*fd**2*s**2 + 2960*D1**2*f*fd**2*s - 220*D1**2*f*fd**2 - 3024*D1**2*f*fd*g2*r*s + 1512*D1**2*f*fd*g2*r + 1008*D1**2*f*fd*g2*s**2 - 1008*D1**2*f*fd*g2*s + 504*D1**2*f*fd*g2 - 2016*D1**2*f*fd*gd2*r*s + 504*D1**2*f*fd*gd2*r - 7056*D1**2*f*fd*gd2*s**2 + 4536*D1**2*f*fd*gd2*s - 504*D1**2*f*fd*gd2 - 1008*D1**2*f*fdd*g2*r*s + 504*D1**2*f*fdd*g2*r - 3528*D1**2*f*fdd*g2*s**2 + 3528*D1**2*f*fdd*g2*s - 1764*D1**2*f*fdd*g2 - 1008*D1**2*fd**2*g2*r*s + 504*D1**2*fd**2*g2*r - 3528*D1**2*fd**2*g2*s**2 + 3528*D1**2*fd**2*g2*s + 2016*D1*Dd*K*bd1*f**2*r*s - 252*D1*Dd*K*bd1*f**2*r + 7056*D1*Dd*K*bd1*f**2*s**2 - 3276*D1*Dd*K*bd1*f**2*s + 252*D1*Dd*K*bd1*f**2 - 16704*D1*Dd*bd1*f**2*r*s + 11160*D1*Dd*bd1*f**2*r - 14760*D1*Dd*bd1*f**2*s**2 + 24066*D1*Dd*bd1*f**2*s - 8586*D1*Dd*bd1*f**2 - 29568*D1*Dd*bd1*f*g2*r*s + 20496*D1*Dd*bd1*f*g2*r - 34944*D1*Dd*bd1*f*g2*s**2 + 55104*D1*Dd*bd1*f*g2*s - 18144*D1*Dd*bd1*f*g2 - 2560*D1*Dd*f**3*r*s + 640*D1*Dd*f**3*r + 720*D1*Dd*f**3*s**2 + 920*D1*Dd*f**3*s + 180*D1*Dd*f**3 - 5280*D1*Dd*f**2*fd*r*s + 1540*D1*Dd*f**2*fd*r - 15120*D1*Dd*f**2*fd*s**2 + 11020*D1*Dd*f**2*fd*s - 1920*D1*Dd*f**2*fd - 6048*D1*Dd*f**2*g2*r*s + 1512*D1*Dd*f**2*g2*r + 2016*D1*Dd*f**2*g2*s**2 + 2016*D1*Dd*f**2*g2*s + 504*D1*Dd*f**2*g2 - 4032*D1*Dd*f**2*gd2*r*s + 504*D1*Dd*f**2*gd2*r - 14112*D1*Dd*f**2*gd2*s**2 + 6552*D1*Dd*f**2*gd2*s - 504*D1*Dd*f**2*gd2 - 8064*D1*Dd*f*fd*g2*r*s + 3024*D1*Dd*f*fd*g2*r - 28224*D1*Dd*f*fd*g2*s**2 + 23184*D1*Dd*f*fd*g2*s - 4536*D1*Dd*f*fd*g2 - 880*D1*Ddd*f**3*r*s + 220*D1*Ddd*f**3*r - 2520*D1*Ddd*f**3*s**2 + 1700*D1*Ddd*f**3*s - 630*D1*Ddd*f**3 - 2016*D1*Ddd*f**2*g2*r*s + 504*D1*Ddd*f**2*g2*r - 7056*D1*Ddd*f**2*g2*s**2 + 4536*D1*Ddd*f**2*g2*s - 1764*D1*Ddd*f**2*g2 - 84*D1*b2*(bd1*(D1*(13*f*(s - 1)*(r + s - 1) + 9*fd*(-2*r*s + r - s*(2*s - 2))) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + 2*D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) - 2640*Dd**2*f**3*r*s + 660*Dd**2*f**3*r - 7560*Dd**2*f**3*s**2 + 5100*Dd**2*f**3*s - 440*Dd**2*f**3 - 6048*Dd**2*f**2*g2*r*s + 1512*Dd**2*f**2*g2*r - 21168*Dd**2*f**2*g2*s**2 + 13608*Dd**2*f**2*g2*s - 1008*Dd**2*f**2*g2 - 84*b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - (20*K - 10)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(-10*K + 3*f + 5) - Dd**2*(-10*K + 3*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 21*b1**2*(-96*C*D1**2*fd*r*s - 96*C*D1**2*fd*s**2 + 96*C*D1**2*fd*s + 48*C*D1**2*fdd*r*s + 48*C*D1**2*fdd*s**2 - 48*C*D1**2*fdd*s - 384*C*D1*Dd*f*r*s + 96*C*D1*Dd*f*r - 384*C*D1*Dd*f*s**2 + 384*C*D1*Dd*f*s - 96*C*D1*Dd*f + 384*C*D1*Dd*fd*r*s - 48*C*D1*Dd*fd*r + 384*C*D1*Dd*fd*s**2 - 384*C*D1*Dd*fd*s + 48*C*D1*Dd*fd + 192*C*D1*Ddd*f*r*s - 48*C*D1*Ddd*f*r + 192*C*D1*Ddd*f*s**2 - 192*C*D1*Ddd*f*s + 48*C*D1*Ddd*f + 576*C*Dd**2*f*r*s - 144*C*Dd**2*f*r + 576*C*Dd**2*f*s**2 - 576*C*Dd**2*f*s + 96*C*Dd**2*f + 156*D1**2*K*fd*r*s - 36*D1**2*K*fd*r + 168*D1**2*K*fd*s**2 - 72*D1**2*K*fd*s + 36*D1**2*K*fd - 88*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r - 104*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 4*D1**2*bdd1*(-10*K + 3*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 72*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 60*D1**2*f*fd*s - 12*D1**2*f*fd + 72*D1**2*f*fdd*r*s + 42*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 72*D1**2*fd**2*r*s + 42*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s + 48*D1**2*fd*r*s + 20*D1**2*fd*r + 50*D1**2*fd*s**2 - 32*D1**2*fd*s - 20*D1**2*fd - 4*D1**2*fdd*r*s - 5*D1**2*fdd*s**2 + 36*D1**2*fdd*s + 160*D1**2*gd2*r*s + 160*D1**2*gd2*s**2 - 160*D1**2*gd2*s - 80*D1**2*gdd2*r*s - 80*D1**2*gdd2*s**2 + 80*D1**2*gdd2*s + 624*D1*Dd*K*f*r*s - 156*D1*Dd*K*f*r + 672*D1*Dd*K*f*s**2 - 648*D1*Dd*K*f*s + 168*D1*Dd*K*f - 704*D1*Dd*K*fd*r*s + 40*D1*Dd*K*fd*r - 832*D1*Dd*K*fd*s**2 + 288*D1*Dd*K*fd*s + 48*D1*Dd*K*fd - 144*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 108*D1*Dd*f**2*s - 18*D1*Dd*f**2 + 576*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 372*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 192*D1*Dd*f*r*s - 48*D1*Dd*f*r + 200*D1*Dd*f*s**2 - 196*D1*Dd*f*s + 50*D1*Dd*f - 32*D1*Dd*fd*r*s + 4*D1*Dd*fd*r - 40*D1*Dd*fd*s**2 + 162*D1*Dd*fd*s - 36*D1*Dd*fd + 640*D1*Dd*g2*r*s - 160*D1*Dd*g2*r + 640*D1*Dd*g2*s**2 - 640*D1*Dd*g2*s + 160*D1*Dd*g2 - 640*D1*Dd*gd2*r*s + 80*D1*Dd*gd2*r - 640*D1*Dd*gd2*s**2 + 640*D1*Dd*gd2*s - 80*D1*Dd*gd2 - 352*D1*Ddd*K*f*r*s + 88*D1*Ddd*K*f*r - 416*D1*Ddd*K*f*s**2 + 384*D1*Ddd*K*f*s - 104*D1*Ddd*K*f + 144*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 114*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 - 16*D1*Ddd*f*r*s + 4*D1*Ddd*f*r - 20*D1*Ddd*f*s**2 + 18*D1*Ddd*f*s - 5*D1*Ddd*f - 320*D1*Ddd*g2*r*s + 80*D1*Ddd*g2*r - 320*D1*Ddd*g2*s**2 + 320*D1*Ddd*g2*s - 80*D1*Ddd*g2 + 4*D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + (10 - 20*K)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(-10*K + 3*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 1056*Dd**2*K*f*r*s + 264*Dd**2*K*f*r - 1248*Dd**2*K*f*s**2 + 1152*Dd**2*K*f*s - 176*Dd**2*K*f + 432*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 342*Dd**2*f**2*s + 72*Dd**2*f**2 - 48*Dd**2*f*r*s + 12*Dd**2*f*r - 60*Dd**2*f*s**2 + 54*Dd**2*f*s - 8*Dd**2*f - 960*Dd**2*g2*r*s + 240*Dd**2*g2*r - 960*Dd**2*g2*s**2 + 960*Dd**2*g2*s - 160*Dd**2*g2) + 3*b1*(-3696*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*r - 3168*C*D1**2*f*fd*s**2 + 2376*C*D1**2*f*fd*s - 264*C*D1**2*f*fd + 2016*C*D1**2*f*fdd*r*s + 120*C*D1**2*f*fdd*r + 1920*C*D1**2*f*fdd*s**2 - 768*C*D1**2*f*fdd*s - 120*C*D1**2*f*fdd + 2016*C*D1**2*fd**2*r*s + 120*C*D1**2*fd**2*r + 1920*C*D1**2*fd**2*s**2 - 768*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 - 7392*C*D1*Dd*f**2*r*s + 1848*C*D1*Dd*f**2*r - 6336*C*D1*Dd*f**2*s**2 + 6864*C*D1*Dd*f**2*s - 1584*C*D1*Dd*f**2 + 16128*C*D1*Dd*f*fd*r*s - 1536*C*D1*Dd*f*fd*r + 15360*C*D1*Dd*f*fd*s**2 - 10944*C*D1*Dd*f*fd*s + 528*C*D1*Dd*f*fd + 4032*C*D1*Ddd*f**2*r*s - 1008*C*D1*Ddd*f**2*r + 3840*C*D1*Ddd*f**2*s**2 - 3936*C*D1*Ddd*f**2*s + 960*C*D1*Ddd*f**2 + 12096*C*Dd**2*f**2*r*s - 3024*C*Dd**2*f**2*r + 11520*C*Dd**2*f**2*s**2 - 11808*C*Dd**2*f**2*s + 2016*C*Dd**2*f**2 + 504*D1**2*K*f*fd*r*s - 252*D1**2*K*f*fd*r - 168*D1**2*K*f*fd*s**2 + 168*D1**2*K*f*fd*s - 84*D1**2*K*f*fd + 168*D1**2*K*f*fdd*r*s - 84*D1**2*K*f*fdd*r + 588*D1**2*K*f*fdd*s**2 - 588*D1**2*K*f*fdd*s + 294*D1**2*K*f*fdd + 168*D1**2*K*fd**2*r*s - 84*D1**2*K*fd**2*r + 588*D1**2*K*fd**2*s**2 - 588*D1**2*K*fd**2*s - 364*D1**2*b2*fd*r*s - 364*D1**2*b2*fd*s**2 + 252*D1**2*b2*fdd*r*s + 252*D1**2*b2*fdd*s**2 + 28*D1**2*bd1**2*(-10*K + 3*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 364*D1**2*bd2*f*r*s - 364*D1**2*bd2*f*s**2 + 364*D1**2*bd2*f*s + 504*D1**2*bd2*fd*r*s + 504*D1**2*bd2*fd*s**2 - 252*D1**2*bd2*fd*s - 7*D1**2*bdd1*(3*f**2*(12*r*(2*s - 1) + 14*s**2 - 26*s + 7) + f*(48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 4*K*(44*r*s - 25*r + 52*s**2 - 80*s + 29) - 8*r*s + 4*r - 10*s**2 - 22*s - 5) - 80*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 252*D1**2*bdd2*f*r*s + 252*D1**2*bdd2*f*s**2 - 252*D1**2*bdd2*f*s + 2112*D1**2*f*fd*r*s - 132*D1**2*f*fd*r + 1788*D1**2*f*fd*s**2 - 1572*D1**2*f*fd*s + 216*D1**2*f*fd - 1392*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*r - 1230*D1**2*f*fdd*s**2 + 576*D1**2*f*fdd*s + 60*D1**2*f*fdd + 2184*D1**2*f*gd2*r*s + 2352*D1**2*f*gd2*s**2 - 2184*D1**2*f*gd2*s - 1232*D1**2*f*gdd2*r*s - 1456*D1**2*f*gdd2*s**2 + 1232*D1**2*f*gdd2*s - 1392*D1**2*fd**2*r*s - 60*D1**2*fd**2*r - 1230*D1**2*fd**2*s**2 + 576*D1**2*fd**2*s + 60*D1**2*fd**2 + 2184*D1**2*fd*g2*r*s - 504*D1**2*fd*g2*r + 2352*D1**2*fd*g2*s**2 - 1008*D1**2*fd*g2*s + 504*D1**2*fd*g2 - 2464*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*r - 2912*D1**2*fd*gd2*s**2 + 896*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 - 1232*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r - 1456*D1**2*fdd*g2*s**2 - 336*D1**2*fdd*g2*s + 168*D1**2*fdd*g2 + 1008*D1*Dd*K*f**2*r*s - 252*D1*Dd*K*f**2*r - 336*D1*Dd*K*f**2*s**2 - 336*D1*Dd*K*f**2*s - 84*D1*Dd*K*f**2 + 1344*D1*Dd*K*f*fd*r*s - 504*D1*Dd*K*f*fd*r + 4704*D1*Dd*K*f*fd*s**2 - 3864*D1*Dd*K*f*fd*s + 756*D1*Dd*K*f*fd - 1456*D1*Dd*b2*f*r*s + 364*D1*Dd*b2*f*r - 1456*D1*Dd*b2*f*s**2 + 1456*D1*Dd*b2*f*s - 364*D1*Dd*b2*f + 2016*D1*Dd*b2*fd*r*s - 252*D1*Dd*b2*fd*r + 2016*D1*Dd*b2*fd*s**2 - 1008*D1*Dd*b2*fd*s + 2016*D1*Dd*bd2*f*r*s - 252*D1*Dd*bd2*f*r + 2016*D1*Dd*bd2*f*s**2 - 2016*D1*Dd*bd2*f*s + 252*D1*Dd*bd2*f + 4224*D1*Dd*f**2*r*s - 1056*D1*Dd*f**2*r + 3576*D1*Dd*f**2*s**2 - 3900*D1*Dd*f**2*s + 894*D1*Dd*f**2 - 11136*D1*Dd*f*fd*r*s + 1152*D1*Dd*f*fd*r - 9840*D1*Dd*f*fd*s**2 + 7548*D1*Dd*f*fd*s - 456*D1*Dd*f*fd + 8736*D1*Dd*f*g2*r*s - 2184*D1*Dd*f*g2*r + 9408*D1*Dd*f*g2*s**2 - 9072*D1*Dd*f*g2*s + 2352*D1*Dd*f*g2 - 9856*D1*Dd*f*gd2*r*s + 1232*D1*Dd*f*gd2*r - 11648*D1*Dd*f*gd2*s**2 + 10304*D1*Dd*f*gd2*s - 1232*D1*Dd*f*gd2 - 9856*D1*Dd*fd*g2*r*s + 560*D1*Dd*fd*g2*r - 11648*D1*Dd*fd*g2*s**2 + 4032*D1*Dd*fd*g2*s + 672*D1*Dd*fd*g2 + 336*D1*Ddd*K*f**2*r*s - 84*D1*Ddd*K*f**2*r + 1176*D1*Ddd*K*f**2*s**2 - 756*D1*Ddd*K*f**2*s + 294*D1*Ddd*K*f**2 + 1008*D1*Ddd*b2*f*r*s - 252*D1*Ddd*b2*f*r + 1008*D1*Ddd*b2*f*s**2 - 1008*D1*Ddd*b2*f*s + 252*D1*Ddd*b2*f - 2784*D1*Ddd*f**2*r*s + 696*D1*Ddd*f**2*r - 2460*D1*Ddd*f**2*s**2 + 2622*D1*Ddd*f**2*s - 615*D1*Ddd*f**2 - 4928*D1*Ddd*f*g2*r*s + 1232*D1*Ddd*f*g2*r - 5824*D1*Ddd*f*g2*s**2 + 5376*D1*Ddd*f*g2*s - 1456*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(3*f**2*(4*r*(3*s - 1) + 6*s**2 - 8*s + 1) + f*(48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 156*K*r*s + 60*K*r - 168*K*s**2 + 210*K*s - 66*K - 6*fd*(24*r*s - 6*r + 14*s**2 - 19*s + 3) - 48*r*s + 34*r - 50*s**2 + 58*s - 35) + fd*(-24*C*(r*(4*s - 1) + (1 - 2*s)**2) + 2*K*(88*r*s - 19*r + 104*s**2 - 68*s - 3) + 8*r*s - 2*r + 10*s**2 - 25*s + 18) - 40*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 40*gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*(-3*f**2*(12*r*(8*s - 3) + 56*s**2 - 90*s + 25) + f*(-48*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 4*K*(8*r*(22*s - 9) + 208*s**2 - 256*s + 65) + 32*r*s - 12*r + 40*s**2 + 26*s - 7) + 80*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 1008*Dd**2*K*f**2*r*s - 252*Dd**2*K*f**2*r + 3528*Dd**2*K*f**2*s**2 - 2268*Dd**2*K*f**2*s + 168*Dd**2*K*f**2 + 3024*Dd**2*b2*f*r*s - 756*Dd**2*b2*f*r + 3024*Dd**2*b2*f*s**2 - 3024*Dd**2*b2*f*s + 504*Dd**2*b2*f - 8352*Dd**2*f**2*r*s + 2088*Dd**2*f**2*r - 7380*Dd**2*f**2*s**2 + 7866*Dd**2*f**2*s - 1392*Dd**2*f**2 - 14784*Dd**2*f*g2*r*s + 3696*Dd**2*f*g2*r - 17472*Dd**2*f*g2*s**2 + 16128*Dd**2*f*g2*s - 2464*Dd**2*f*g2))/(630*d**2*k3**4) + 3*D1**2*Pk3*Pkd2*ct**3*k1*st**4*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 18*fd*(2*s**2 - 2*s + 1) - 9*fdd*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) + f*(-2*fd*(s**2*(21*bd1 - 9) + s*(6 - 7*bd1) - 3) - 3*fdd*(3*s**2 - 2*s + 1) - 3*s**2*(-6*bd1 + 3*bdd1)) - 6*fd*s*(bd1*(6*s - 3) + fd*(3*s - 2))) + D1*f*(-2*Dd*(f*(s**2*(28*bd1 - 12) + s*(6 - 7*bd1) - 3) + (12*s - 3)*(3*bd1*s + fd*(3*s - 1))) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**3*k1*st**2*(360*C*D1**2*bdd1*f**2*r*s - 540*C*D1**2*bdd1*f**2*s**2 - 3000*C*D1**2*f**2*fd*s**2 + 2000*C*D1**2*f**2*fd*s - 1000*C*D1**2*f**2*fd + 1500*C*D1**2*f**2*fdd*s**2 - 1000*C*D1**2*f**2*fdd*s + 500*C*D1**2*f**2*fdd + 3000*C*D1**2*f*fd**2*s**2 - 2000*C*D1**2*f*fd**2*s - 4000*C*D1*Dd*f**3*s**2 + 2000*C*D1*Dd*f**3*s - 1000*C*D1*Dd*f**3 + 12000*C*D1*Dd*f**2*fd*s**2 - 7000*C*D1*Dd*f**2*fd*s + 1000*C*D1*Dd*f**2*fd + 2000*C*D1*Ddd*f**3*s**2 - 1000*C*D1*Ddd*f**3*s + 500*C*D1*Ddd*f**3 + 6000*C*Dd**2*f**3*s**2 - 3000*C*Dd**2*f**3*s + 450*D1**2*K*bdd1*f**2*s**2 - 1800*D1**2*b2*f*fd*s**2 + 1800*D1**2*b2*f*fd*s - 900*D1**2*b2*f*fd + 900*D1**2*b2*f*fdd*s**2 - 900*D1**2*b2*f*fdd*s + 450*D1**2*b2*f*fdd + 900*D1**2*b2*fd**2*s**2 - 900*D1**2*b2*fd**2*s + 18*D1**2*bd1**2*f*s*(14*K*(2*r - 5*s - 1) + 25*f - 28*r + 49) - 900*D1**2*bd2*f**2*s**2 + 1800*D1**2*bd2*f*fd*s**2 - 900*D1**2*bd2*f*fd*s + 540*D1**2*bdd1*f**3*r*s + 495*D1**2*bdd1*f**3*s**2 - 360*D1**2*bdd1*f**3*s + 72*D1**2*bdd1*f**2*r*s + 927*D1**2*bdd1*f**2*s**2 - 162*D1**2*bdd1*f**2*s - 135*D1**2*bdd1*f**2 - 504*D1**2*bdd1*f*g2*r*s + 1260*D1**2*bdd1*f*g2*s**2 + 450*D1**2*bdd2*f**2*s**2 - 1176*D1**2*f**2*fd*r*s + 392*D1**2*f**2*fd*r + 66*D1**2*f**2*fd*s**2 + 348*D1**2*f**2*fd*s + 22*D1**2*f**2*fd + 912*D1**2*f**2*fdd*r*s - 304*D1**2*f**2*fdd*r + 129*D1**2*f**2*fdd*s**2 - 390*D1**2*f**2*fdd*s + 43*D1**2*f**2*fdd + 1800*D1**2*f**2*gd2*s**2 - 900*D1**2*f**2*gdd2*s**2 + 1824*D1**2*f*fd**2*r*s - 608*D1**2*f*fd**2*r + 258*D1**2*f*fd**2*s**2 - 780*D1**2*f*fd**2*s + 304*D1**2*f*fd**2 + 3600*D1**2*f*fd*g2*s**2 - 3600*D1**2*f*fd*g2*s + 1800*D1**2*f*fd*g2 - 3600*D1**2*f*fd*gd2*s**2 + 1800*D1**2*f*fd*gd2*s - 1800*D1**2*f*fdd*g2*s**2 + 1800*D1**2*f*fdd*g2*s - 900*D1**2*f*fdd*g2 - 1800*D1**2*fd**2*g2*s**2 + 1800*D1**2*fd**2*g2*s - 3600*D1*Dd*b2*f**2*s**2 + 1800*D1*Dd*b2*f**2*s - 900*D1*Dd*b2*f**2 + 7200*D1*Dd*b2*f*fd*s**2 - 5400*D1*Dd*b2*f*fd*s + 900*D1*Dd*b2*f*fd + 3600*D1*Dd*bd2*f**2*s**2 - 900*D1*Dd*bd2*f**2*s - 1568*D1*Dd*f**3*r*s + 392*D1*Dd*f**3*r + 88*D1*Dd*f**3*s**2 + 740*D1*Dd*f**3*s + 22*D1*Dd*f**3 + 7296*D1*Dd*f**2*fd*r*s - 2128*D1*Dd*f**2*fd*r + 1032*D1*Dd*f**2*fd*s**2 - 3642*D1*Dd*f**2*fd*s + 998*D1*Dd*f**2*fd + 7200*D1*Dd*f**2*g2*s**2 - 3600*D1*Dd*f**2*g2*s + 1800*D1*Dd*f**2*g2 - 7200*D1*Dd*f**2*gd2*s**2 + 1800*D1*Dd*f**2*gd2*s - 14400*D1*Dd*f*fd*g2*s**2 + 10800*D1*Dd*f*fd*g2*s - 1800*D1*Dd*f*fd*g2 + 1800*D1*Ddd*b2*f**2*s**2 - 900*D1*Ddd*b2*f**2*s + 450*D1*Ddd*b2*f**2 + 1216*D1*Ddd*f**3*r*s - 304*D1*Ddd*f**3*r + 172*D1*Ddd*f**3*s**2 - 694*D1*Ddd*f**3*s + 43*D1*Ddd*f**3 - 3600*D1*Ddd*f**2*g2*s**2 + 1800*D1*Ddd*f**2*g2*s - 900*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(15*f**3*s*(6*r + 9*s - 4) + f**2*(-15*fd*(6*r*(6*s - 1) + 33*s**2 - 31*s + 4) - s**2*(180*C - 150*K - 267) + s*(92*C*r + 10*r - 12) - 45) - 6*f*(fd*(r*(10*C + 2)*(4*s - 1) + s**2*(-60*C + 50*K + 103) + s*(20*C - 25*K - 58) + 12) + 14*s*(2*g2*r - 5*g2*s - 2*gd2*r + 5*gd2*s + gd2)) - 84*fd*g2*(-2*r*s + r + s*(5*s - 5))) - 3*Dd*f*(5*f**2*(6*r*(8*s - 1) + 44*s**2 - 39*s + 4) + f*(r*(20*C + 4)*(8*s - 1) + s**2*(-240*C + 200*K + 412) + s*(20*C - 50*K - 147) + 9) + 28*g2*(-8*r*s + r + s*(20*s - 3)))) + 5400*Dd**2*b2*f**2*s**2 - 2700*Dd**2*b2*f**2*s + 3648*Dd**2*f**3*r*s - 912*Dd**2*f**3*r + 516*Dd**2*f**3*s**2 - 2082*Dd**2*f**3*s + 608*Dd**2*f**3 - 10800*Dd**2*f**2*g2*s**2 + 5400*Dd**2*f**2*g2*s + 9*b1**2*(-2*D1*Dd*(14*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s) + fd*(-14*K*(8*r*s - 5*r - 20*s**2 + 23*s - 3) + 25*f*(4*s - 1) + 112*r*s - 70*r + 112*s - 7)) + D1*(D1*(50*f*fd*(2*s - 1) + f*fdd*(25 - 50*s) - 50*fd**2*s - 14*fd*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + 7*fdd*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5)) + 14*Ddd*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s)) + 28*Dd**2*f*(K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) - 12*r*s + 3*r + 6*s - 2)) - 3*b1*(368*C*D1**2*f*fd*r*s - 184*C*D1**2*f*fd*r - 720*C*D1**2*f*fd*s**2 + 536*C*D1**2*f*fd*s - 360*C*D1**2*f*fd - 240*C*D1**2*f*fdd*r*s + 120*C*D1**2*f*fdd*r + 360*C*D1**2*f*fdd*s**2 - 240*C*D1**2*f*fdd*s + 180*C*D1**2*f*fdd - 240*C*D1**2*fd**2*r*s + 120*C*D1**2*fd**2*r + 360*C*D1**2*fd**2*s**2 - 240*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 + 736*C*D1*Dd*f**2*r*s - 184*C*D1*Dd*f**2*r - 1440*C*D1*Dd*f**2*s**2 + 352*C*D1*Dd*f**2*s - 360*C*D1*Dd*f**2 - 1920*C*D1*Dd*f*fd*r*s + 720*C*D1*Dd*f*fd*r + 2880*C*D1*Dd*f*fd*s**2 - 1200*C*D1*Dd*f*fd*s - 480*C*D1*Ddd*f**2*r*s + 120*C*D1*Ddd*f**2*r + 720*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 - 1440*C*Dd**2*f**2*r*s + 360*C*Dd**2*f**2*r + 2160*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s - 240*C*Dd**2*f**2 + 600*D1**2*K*f*fd*s**2 - 600*D1**2*K*f*fd*s + 300*D1**2*K*f*fd - 300*D1**2*K*f*fdd*s**2 + 300*D1**2*K*f*fdd*s - 150*D1**2*K*f*fdd - 300*D1**2*K*fd**2*s**2 + 300*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(-140*K*s**2 + 25*f*(2*s - 1) - 7*s*(-8*K*r + 4*K + 8*r - 14) - 35) + 540*D1**2*f**2*fd*r*s - 180*D1**2*f**2*fd*r + 810*D1**2*f**2*fd*s**2 - 780*D1**2*f**2*fd*s + 270*D1**2*f**2*fd - 540*D1**2*f**2*fdd*r*s + 180*D1**2*f**2*fdd*r - 495*D1**2*f**2*fdd*s**2 + 570*D1**2*f**2*fdd*s - 165*D1**2*f**2*fdd - 1080*D1**2*f*fd**2*r*s + 360*D1**2*f*fd**2*r - 990*D1**2*f*fd**2*s**2 + 1140*D1**2*f*fd**2*s - 240*D1**2*f*fd**2 + 40*D1**2*f*fd*r*s - 20*D1**2*f*fd*r + 1068*D1**2*f*fd*s**2 - 1064*D1**2*f*fd*s + 624*D1**2*f*fd - 48*D1**2*f*fdd*r*s + 24*D1**2*f*fdd*r - 618*D1**2*f*fdd*s**2 + 588*D1**2*f*fdd*s - 354*D1**2*f*fdd - 336*D1**2*f*gd2*r*s + 840*D1**2*f*gd2*s**2 + 336*D1**2*f*gd2*s + 168*D1**2*f*gdd2*r*s - 420*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s - 48*D1**2*fd**2*r*s + 24*D1**2*fd**2*r - 618*D1**2*fd**2*s**2 + 588*D1**2*fd**2*s + 120*D1**2*fd**2 - 336*D1**2*fd*g2*r*s + 336*D1**2*fd*g2*r + 840*D1**2*fd*g2*s**2 - 1680*D1**2*fd*g2*s + 840*D1**2*fd*g2 + 336*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*r - 840*D1**2*fd*gd2*s**2 + 672*D1**2*fd*gd2*s + 168*D1**2*fd*gd2 + 168*D1**2*fdd*g2*r*s - 168*D1**2*fdd*g2*r - 420*D1**2*fdd*g2*s**2 + 840*D1**2*fdd*g2*s - 420*D1**2*fdd*g2 + 1200*D1*Dd*K*f**2*s**2 - 600*D1*Dd*K*f**2*s + 300*D1*Dd*K*f**2 - 2400*D1*Dd*K*f*fd*s**2 + 1800*D1*Dd*K*f*fd*s - 300*D1*Dd*K*f*fd + 720*D1*Dd*f**3*r*s - 180*D1*Dd*f**3*r + 1080*D1*Dd*f**3*s**2 - 900*D1*Dd*f**3*s + 270*D1*Dd*f**3 - 4320*D1*Dd*f**2*fd*r*s + 1260*D1*Dd*f**2*fd*r - 3960*D1*Dd*f**2*fd*s**2 + 4350*D1*Dd*f**2*fd*s - 930*D1*Dd*f**2*fd + 80*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r + 2136*D1*Dd*f**2*s**2 - 1108*D1*Dd*f**2*s + 534*D1*Dd*f**2 - 384*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r - 4944*D1*Dd*f*fd*s**2 + 3684*D1*Dd*f*fd*s - 636*D1*Dd*f*fd - 1344*D1*Dd*f*g2*r*s + 336*D1*Dd*f*g2*r + 3360*D1*Dd*f*g2*s**2 - 1008*D1*Dd*f*g2*s + 840*D1*Dd*f*g2 + 1344*D1*Dd*f*gd2*r*s - 168*D1*Dd*f*gd2*r - 3360*D1*Dd*f*gd2*s**2 - 168*D1*Dd*f*gd2*s + 168*D1*Dd*f*gd2 + 1344*D1*Dd*fd*g2*r*s - 840*D1*Dd*fd*g2*r - 3360*D1*Dd*fd*g2*s**2 + 3864*D1*Dd*fd*g2*s - 504*D1*Dd*fd*g2 - 600*D1*Ddd*K*f**2*s**2 + 300*D1*Ddd*K*f**2*s - 150*D1*Ddd*K*f**2 - 720*D1*Ddd*f**3*r*s + 180*D1*Ddd*f**3*r - 660*D1*Ddd*f**3*s**2 + 690*D1*Ddd*f**3*s - 165*D1*Ddd*f**3 - 96*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r - 1236*D1*Ddd*f**2*s**2 + 666*D1*Ddd*f**2*s - 309*D1*Ddd*f**2 + 672*D1*Ddd*f*g2*r*s - 168*D1*Ddd*f*g2*r - 1680*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 420*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(25*f**2*(2*s - 1) - 7*f*(20*K*s**2 + s*(-8*K*r + 4*K + 8*r - 14) + 5) - 7*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) - 8*r*s + 4*r - 3*s - 2)) + Dd*f*(-7*K*(32*r*s - 4*r - 80*s**2 + 4*s + 2) - 25*f*(4*s - 1) + 224*r*s - 28*r - 252*s + 49)) - 1800*Dd**2*K*f**2*s**2 + 900*Dd**2*K*f**2*s - 2160*Dd**2*f**3*r*s + 540*Dd**2*f**3*r - 1980*Dd**2*f**3*s**2 + 2070*Dd**2*f**3*s - 360*Dd**2*f**3 - 288*Dd**2*f**2*r*s + 72*Dd**2*f**2*r - 3708*Dd**2*f**2*s**2 + 1998*Dd**2*f**2*s - 48*Dd**2*f**2 + 2016*Dd**2*f*g2*r*s - 504*Dd**2*f*g2*r - 5040*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s + 336*Dd**2*f*g2))/(315*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**3*k1*(1680*C*D1**2*bd1**2*f*r*s - 840*C*D1**2*bd1**2*f*r - 504*C*D1**2*bd1**2*f*s**2 + 504*C*D1**2*bd1**2*f*s + 504*C*D1**2*bd1*f**2*r*s - 2592*C*D1**2*bd1*f**2*s**2 + 720*C*D1**2*bd1*f**2*s - 360*C*D1**2*bd1*f**2 + 7200*C*D1**2*bd1*f*fd*s**2 - 3960*C*D1**2*bd1*f*fd*s + 1800*C*D1**2*bdd1*f**2*s**2 - 360*C*D1**2*bdd1*f**2*s + 180*C*D1**2*bdd1*f**2 + 1560*C*D1**2*f**2*fd*r*s - 520*C*D1**2*f**2*fd*r + 5400*C*D1**2*f**2*fd*s**2 - 4120*C*D1**2*f**2*fd*s + 1800*C*D1**2*f**2*fd - 1320*C*D1**2*f**2*fdd*r*s + 440*C*D1**2*f**2*fdd*r - 3780*C*D1**2*f**2*fdd*s**2 + 2960*C*D1**2*f**2*fdd*s - 1260*C*D1**2*f**2*fdd - 2640*C*D1**2*f*fd**2*r*s + 880*C*D1**2*f*fd**2*r - 7560*C*D1**2*f*fd**2*s**2 + 5920*C*D1**2*f*fd**2*s - 440*C*D1**2*f*fd**2 + 14400*C*D1*Dd*bd1*f**2*s**2 - 5040*C*D1*Dd*bd1*f**2*s + 360*C*D1*Dd*bd1*f**2 + 2080*C*D1*Dd*f**3*r*s - 520*C*D1*Dd*f**3*r + 7200*C*D1*Dd*f**3*s**2 - 4640*C*D1*Dd*f**3*s + 1800*C*D1*Dd*f**3 - 10560*C*D1*Dd*f**2*fd*r*s + 3080*C*D1*Dd*f**2*fd*r - 30240*C*D1*Dd*f**2*fd*s**2 + 22040*C*D1*Dd*f**2*fd*s - 3840*C*D1*Dd*f**2*fd - 1760*C*D1*Ddd*f**3*r*s + 440*C*D1*Ddd*f**3*r - 5040*C*D1*Ddd*f**3*s**2 + 3400*C*D1*Ddd*f**3*s - 1260*C*D1*Ddd*f**3 - 5280*C*Dd**2*f**3*r*s + 1320*C*Dd**2*f**3*r - 15120*C*Dd**2*f**3*s**2 + 10200*C*Dd**2*f**3*s - 880*C*Dd**2*f**3 + 2856*D1**2*K*bd1**2*f*s**2 - 252*D1**2*K*bd1**2*f*s + 252*D1**2*K*bd1*f**2*r*s + 1260*D1**2*K*bd1*f**2*s**2 - 252*D1**2*K*bd1*f**2*s - 1008*D1**2*K*bd1*f*fd*r*s + 252*D1**2*K*bd1*f*fd*r - 3528*D1**2*K*bd1*f*fd*s**2 + 2268*D1**2*K*bd1*f*fd*s - 252*D1**2*K*bd1*f*fd - 252*D1**2*K*bdd1*f**2*r*s - 882*D1**2*K*bdd1*f**2*s**2 + 252*D1**2*K*bdd1*f**2*s + 1008*D1**2*bd1**2*f**2*r*s - 756*D1**2*bd1**2*f**2*r - 1134*D1**2*bd1**2*f**2*s + 504*D1**2*bd1**2*f**2 - 336*D1**2*bd1**2*f*r*s + 168*D1**2*bd1**2*f*r + 378*D1**2*bd1**2*f*s**2 - 2352*D1**2*bd1**2*f*s + 672*D1**2*bd1**2*f - 1680*D1**2*bd1**2*g2*r*s + 840*D1**2*bd1**2*g2*r + 840*D1**2*bd1**2*g2*s**2 - 840*D1**2*bd1**2*g2*s + 252*D1**2*bd1*bd2*f*s**2 - 252*D1**2*bd1*bd2*f*s - 1152*D1**2*bd1*f**2*r*s + 900*D1**2*bd1*f**2*r + 1296*D1**2*bd1*f**2*s**2 + 504*D1**2*bd1*f**2*s - 378*D1**2*bd1*f**2 + 2304*D1**2*bd1*f*fd*r*s - 1152*D1**2*bd1*f*fd*r - 3600*D1**2*bd1*f*fd*s**2 + 594*D1**2*bd1*f*fd*s + 576*D1**2*bd1*f*fd - 840*D1**2*bd1*f*g2*r*s + 4032*D1**2*bd1*f*g2*s**2 - 1008*D1**2*bd1*f*g2*s + 504*D1**2*bd1*f*g2 - 5712*D1**2*bd1*f*gd2*s**2 + 504*D1**2*bd1*f*gd2*s - 5712*D1**2*bd1*fd*g2*s**2 + 5712*D1**2*bd1*fd*g2*s + 252*D1**2*bd2*f**2*r*s + 1260*D1**2*bd2*f**2*s**2 - 252*D1**2*bd2*f**2*s - 1008*D1**2*bd2*f*fd*r*s + 252*D1**2*bd2*f*fd*r - 3528*D1**2*bd2*f*fd*s**2 + 2268*D1**2*bd2*f*fd*s - 252*D1**2*bd2*f*fd + 576*D1**2*bdd1*f**2*r*s - 576*D1**2*bdd1*f**2*r - 900*D1**2*bdd1*f**2*s**2 - 630*D1**2*bdd1*f**2*s + 315*D1**2*bdd1*f**2 - 2856*D1**2*bdd1*f*g2*s**2 + 504*D1**2*bdd1*f*g2*s - 252*D1**2*bdd1*f*g2 - 252*D1**2*bdd2*f**2*r*s - 882*D1**2*bdd2*f**2*s**2 + 252*D1**2*bdd2*f**2*s - 240*D1**2*f**2*fd*r*s + 80*D1**2*f**2*fd*r - 2700*D1**2*f**2*fd*s**2 + 1880*D1**2*f**2*fd*s - 900*D1**2*f**2*fd + 660*D1**2*f**2*fdd*r*s - 220*D1**2*f**2*fdd*r + 1890*D1**2*f**2*fdd*s**2 - 1480*D1**2*f**2*fdd*s + 630*D1**2*f**2*fdd - 504*D1**2*f**2*gd2*r*s - 2520*D1**2*f**2*gd2*s**2 + 504*D1**2*f**2*gd2*s + 504*D1**2*f**2*gdd2*r*s + 1764*D1**2*f**2*gdd2*s**2 - 504*D1**2*f**2*gdd2*s + 1320*D1**2*f*fd**2*r*s - 440*D1**2*f*fd**2*r + 3780*D1**2*f*fd**2*s**2 - 2960*D1**2*f*fd**2*s + 220*D1**2*f*fd**2 - 1008*D1**2*f*fd*g2*r*s + 504*D1**2*f*fd*g2*r - 5040*D1**2*f*fd*g2*s**2 + 5040*D1**2*f*fd*g2*s - 2520*D1**2*f*fd*g2 + 2016*D1**2*f*fd*gd2*r*s - 504*D1**2*f*fd*gd2*r + 7056*D1**2*f*fd*gd2*s**2 - 4536*D1**2*f*fd*gd2*s + 504*D1**2*f*fd*gd2 + 1008*D1**2*f*fdd*g2*r*s - 504*D1**2*f*fdd*g2*r + 3528*D1**2*f*fdd*g2*s**2 - 3528*D1**2*f*fdd*g2*s + 1764*D1**2*f*fdd*g2 + 1008*D1**2*fd**2*g2*r*s - 504*D1**2*fd**2*g2*r + 3528*D1**2*fd**2*g2*s**2 - 3528*D1**2*fd**2*g2*s - 2016*D1*Dd*K*bd1*f**2*r*s + 252*D1*Dd*K*bd1*f**2*r - 7056*D1*Dd*K*bd1*f**2*s**2 + 3276*D1*Dd*K*bd1*f**2*s - 252*D1*Dd*K*bd1*f**2 + 4608*D1*Dd*bd1*f**2*r*s - 2880*D1*Dd*bd1*f**2*r - 7200*D1*Dd*bd1*f**2*s**2 - 1872*D1*Dd*bd1*f**2*s + 1782*D1*Dd*bd1*f**2 - 22848*D1*Dd*bd1*f*g2*s**2 + 7728*D1*Dd*bd1*f*g2*s - 504*D1*Dd*bd1*f*g2 - 2016*D1*Dd*bd2*f**2*r*s + 252*D1*Dd*bd2*f**2*r - 7056*D1*Dd*bd2*f**2*s**2 + 3276*D1*Dd*bd2*f**2*s - 252*D1*Dd*bd2*f**2 - 320*D1*Dd*f**3*r*s + 80*D1*Dd*f**3*r - 3600*D1*Dd*f**3*s**2 + 1960*D1*Dd*f**3*s - 900*D1*Dd*f**3 + 5280*D1*Dd*f**2*fd*r*s - 1540*D1*Dd*f**2*fd*r + 15120*D1*Dd*f**2*fd*s**2 - 11020*D1*Dd*f**2*fd*s + 1920*D1*Dd*f**2*fd - 2016*D1*Dd*f**2*g2*r*s + 504*D1*Dd*f**2*g2*r - 10080*D1*Dd*f**2*g2*s**2 + 6048*D1*Dd*f**2*g2*s - 2520*D1*Dd*f**2*g2 + 4032*D1*Dd*f**2*gd2*r*s - 504*D1*Dd*f**2*gd2*r + 14112*D1*Dd*f**2*gd2*s**2 - 6552*D1*Dd*f**2*gd2*s + 504*D1*Dd*f**2*gd2 + 8064*D1*Dd*f*fd*g2*r*s - 3024*D1*Dd*f*fd*g2*r + 28224*D1*Dd*f*fd*g2*s**2 - 23184*D1*Dd*f*fd*g2*s + 4536*D1*Dd*f*fd*g2 + 880*D1*Ddd*f**3*r*s - 220*D1*Ddd*f**3*r + 2520*D1*Ddd*f**3*s**2 - 1700*D1*Ddd*f**3*s + 630*D1*Ddd*f**3 + 2016*D1*Ddd*f**2*g2*r*s - 504*D1*Ddd*f**2*g2*r + 7056*D1*Ddd*f**2*g2*s**2 - 4536*D1*Ddd*f**2*g2*s + 1764*D1*Ddd*f**2*g2 + 2640*Dd**2*f**3*r*s - 660*Dd**2*f**3*r + 7560*Dd**2*f**3*s**2 - 5100*Dd**2*f**3*s + 440*Dd**2*f**3 + 6048*Dd**2*f**2*g2*r*s - 1512*Dd**2*f**2*g2*r + 21168*Dd**2*f**2*g2*s**2 - 13608*Dd**2*f**2*g2*s + 1008*Dd**2*f**2*g2 - 21*b1**3*(3*D1**2*s**2*(2*fd - fdd) + D1*(2*Dd*(-10*K*(r*(2 - 8*s) + 4*s**2 + 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s - 80*r*s + 20*r + 20*s**2 + 30*s + 5) + Ddd*(10*K*(r*(2 - 8*s) + 4*s**2 + 2*s + 1) - 3*f*(4*s**2 - 2*s + 1) + 80*r*s - 20*r - 20*s**2 - 30*s - 5)) + 2*Dd**2*(10*K*(r*(3 - 12*s) + 6*s**2 + 3*s - 2) - 18*f*s**2 + 9*f*s + 30*r*(4*s - 1) - 30*s**2 - 45*s + 20)) - 21*b1**2*(80*C*D1**2*fd*r*s - 24*C*D1**2*fd*s**2 - 80*C*D1**2*fd*s - 40*C*D1**2*fdd*r*s + 12*C*D1**2*fdd*s**2 + 40*C*D1**2*fdd*s + 320*C*D1*Dd*f*r*s - 80*C*D1*Dd*f*r - 96*C*D1*Dd*f*s**2 - 112*C*D1*Dd*f*s - 24*C*D1*Dd*f - 320*C*D1*Dd*fd*r*s + 40*C*D1*Dd*fd*r + 96*C*D1*Dd*fd*s**2 + 216*C*D1*Dd*fd*s - 40*C*D1*Dd*fd - 160*C*D1*Ddd*f*r*s + 40*C*D1*Ddd*f*r + 48*C*D1*Ddd*f*s**2 + 56*C*D1*Ddd*f*s + 12*C*D1*Ddd*f - 480*C*Dd**2*f*r*s + 120*C*Dd**2*f*r + 144*C*Dd**2*f*s**2 + 168*C*Dd**2*f*s - 80*C*Dd**2*f - 20*D1**2*K*fd*r*s + 20*D1**2*K*fd*r + 96*D1**2*K*fd*s**2 - 168*D1**2*K*fd*s + 84*D1**2*K*fd - 68*D1**2*K*fdd*s**2 + 124*D1**2*K*fdd*s - 62*D1**2*K*fdd - D1**2*bdd1*(-10*K*(r*(2 - 6*s) + 3*s**2 + 1) + f*(9*s**2 - 6*s + 3) - 60*r*s + 20*r + 15*s**2 + 10*s + 5) + 48*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 24*D1**2*f*fd*s - 30*D1**2*f*fd - 48*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r - 6*D1**2*f*fdd*s + 21*D1**2*f*fdd - 48*D1**2*fd**2*r*s - 12*D1**2*fd**2*r - 6*D1**2*fd**2*s + 12*D1**2*fd**2 - 16*D1**2*fd*r*s - 20*D1**2*fd*r + 18*D1**2*fd*s**2 + 164*D1**2*fd*s - 42*D1**2*fd + 8*D1**2*fdd*r*s - 9*D1**2*fdd*s**2 - 102*D1**2*fdd*s + 31*D1**2*fdd - 80*D1**2*gd2*r*s + 40*D1**2*gd2*s**2 + 80*D1**2*gd2*s + 40*D1**2*gdd2*r*s - 20*D1**2*gdd2*s**2 - 40*D1**2*gdd2*s - 80*D1*Dd*K*f*r*s + 20*D1*Dd*K*f*r + 384*D1*Dd*K*f*s**2 - 152*D1*Dd*K*f*s + 96*D1*Dd*K*f - 544*D1*Dd*K*fd*s**2 + 632*D1*Dd*K*fd*s - 124*D1*Dd*K*fd + 96*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r - 48*D1*Dd*f**2*s - 384*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*s + 30*D1*Dd*f*fd - 64*D1*Dd*f*r*s + 16*D1*Dd*f*r + 72*D1*Dd*f*s**2 - 4*D1*Dd*f*s + 18*D1*Dd*f + 64*D1*Dd*fd*r*s - 8*D1*Dd*fd*r - 72*D1*Dd*fd*s**2 - 406*D1*Dd*fd*s + 102*D1*Dd*fd - 320*D1*Dd*g2*r*s + 80*D1*Dd*g2*r + 160*D1*Dd*g2*s**2 + 80*D1*Dd*g2*s + 40*D1*Dd*g2 + 320*D1*Dd*gd2*r*s - 40*D1*Dd*gd2*r - 160*D1*Dd*gd2*s**2 - 200*D1*Dd*gd2*s + 40*D1*Dd*gd2 - 272*D1*Ddd*K*f*s**2 + 136*D1*Ddd*K*f*s - 68*D1*Ddd*K*f - 96*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r + 48*D1*Ddd*f**2*s + 32*D1*Ddd*f*r*s - 8*D1*Ddd*f*r - 36*D1*Ddd*f*s**2 + 2*D1*Ddd*f*s - 9*D1*Ddd*f + 160*D1*Ddd*g2*r*s - 40*D1*Ddd*g2*r - 80*D1*Ddd*g2*s**2 - 40*D1*Ddd*g2*s - 20*D1*Ddd*g2 + 2*D1*bd1*(D1*(-10*K*(r*(2 - 6*s) + 3*s**2 + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s - 60*r*s + 20*r + 15*s**2 + 10*s + 5) + Dd*(-10*K*(24*r*s - 7*r - 12*s**2 - 3*s + 2) - 3*f*(12*s**2 - 7*s + 1) + 240*r*s - 70*r - 60*s**2 - 65*s + 25)) - 816*Dd**2*K*f*s**2 + 408*Dd**2*K*f*s - 288*Dd**2*f**2*r*s + 72*Dd**2*f**2*r + 144*Dd**2*f**2*s - 48*Dd**2*f**2 + 96*Dd**2*f*r*s - 24*Dd**2*f*r - 108*Dd**2*f*s**2 + 6*Dd**2*f*s + 16*Dd**2*f + 480*Dd**2*g2*r*s - 120*Dd**2*g2*r - 240*Dd**2*g2*s**2 - 120*Dd**2*g2*s + 80*Dd**2*g2) + 3*b1*(336*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r - 1728*C*D1**2*f*fd*s**2 + 1320*C*D1**2*f*fd*s - 744*C*D1**2*f*fd + 1200*C*D1**2*f*fdd*s**2 - 1080*C*D1**2*f*fdd*s + 540*C*D1**2*f*fdd + 1200*C*D1**2*fd**2*s**2 - 1080*C*D1**2*fd**2*s + 672*C*D1*Dd*f**2*r*s - 168*C*D1*Dd*f**2*r - 3456*C*D1*Dd*f**2*s**2 + 1392*C*D1*Dd*f**2*s - 864*C*D1*Dd*f**2 + 9600*C*D1*Dd*f*fd*s**2 - 6720*C*D1*Dd*f*fd*s + 1080*C*D1*Dd*f*fd + 2400*C*D1*Ddd*f**2*s**2 - 1200*C*D1*Ddd*f**2*s + 600*C*D1*Ddd*f**2 + 7200*C*Dd**2*f**2*s**2 - 3600*C*Dd**2*f**2*s + 168*D1**2*K*f*fd*r*s - 84*D1**2*K*f*fd*r + 840*D1**2*K*f*fd*s**2 - 840*D1**2*K*f*fd*s + 420*D1**2*K*f*fd - 168*D1**2*K*f*fdd*r*s + 84*D1**2*K*f*fdd*r - 588*D1**2*K*f*fdd*s**2 + 588*D1**2*K*f*fdd*s - 294*D1**2*K*f*fdd - 168*D1**2*K*fd**2*r*s + 84*D1**2*K*fd**2*r - 588*D1**2*K*fd**2*s**2 + 588*D1**2*K*fd**2*s - 84*D1**2*b2*fd*s**2 + 42*D1**2*b2*fdd*s**2 + 14*D1**2*bd1**2*(10*K*(r*(6*s - 2) - 3*s**2 + 1) + 9*f*s**2 - 6*f*s + r*(20 - 60*s) + 15*s**2 + 10*s - 10) - 84*D1**2*bd2*f*s**2 + 84*D1**2*bd2*fd*s**2 + 7*D1**2*bdd1*(3*f**2*(4*r*(4*s - 3) - 18*s + 7) + 2*f*(2*C*(10*r*(2*s - 1) - 6*s**2 + 6*s - 3) + K*(68*s**2 - 6*s + 3) - 8*r*s + 4*r + 9*s**2 - 56*s + 20) + 20*g2*(r*(2 - 4*s) + 2*s**2 - 2*s + 1)) + 42*D1**2*bdd2*f*s**2 - 768*D1**2*f*fd*r*s + 84*D1**2*f*fd*r + 864*D1**2*f*fd*s**2 - 648*D1**2*f*fd*s + 558*D1**2*f*fd + 384*D1**2*f*fdd*r*s - 600*D1**2*f*fdd*s**2 + 618*D1**2*f*fdd*s - 405*D1**2*f*fdd - 280*D1**2*f*gd2*r*s + 1344*D1**2*f*gd2*s**2 + 280*D1**2*f*gd2*s - 952*D1**2*f*gdd2*s**2 + 384*D1**2*fd**2*r*s - 600*D1**2*fd**2*s**2 + 618*D1**2*fd**2*s - 280*D1**2*fd*g2*r*s + 280*D1**2*fd*g2*r + 1344*D1**2*fd*g2*s**2 - 2352*D1**2*fd*g2*s + 1176*D1**2*fd*g2 - 1904*D1**2*fd*gd2*s**2 + 1736*D1**2*fd*gd2*s - 952*D1**2*fdd*g2*s**2 + 1736*D1**2*fdd*g2*s - 868*D1**2*fdd*g2 + 336*D1*Dd*K*f**2*r*s - 84*D1*Dd*K*f**2*r + 1680*D1*Dd*K*f**2*s**2 - 1008*D1*Dd*K*f**2*s + 420*D1*Dd*K*f**2 - 1344*D1*Dd*K*f*fd*r*s + 504*D1*Dd*K*f*fd*r - 4704*D1*Dd*K*f*fd*s**2 + 3864*D1*Dd*K*f*fd*s - 756*D1*Dd*K*f*fd - 336*D1*Dd*b2*f*s**2 + 168*D1*Dd*b2*f*s - 84*D1*Dd*b2*f + 336*D1*Dd*b2*fd*s**2 - 84*D1*Dd*b2*fd*s + 336*D1*Dd*bd2*f*s**2 - 84*D1*Dd*bd2*f*s - 1536*D1*Dd*f**2*r*s + 384*D1*Dd*f**2*r + 1728*D1*Dd*f**2*s**2 - 96*D1*Dd*f**2*s + 432*D1*Dd*f**2 + 3072*D1*Dd*f*fd*r*s - 384*D1*Dd*f*fd*r - 4800*D1*Dd*f*fd*s**2 + 2904*D1*Dd*f*fd*s - 618*D1*Dd*f*fd - 1120*D1*Dd*f*g2*r*s + 280*D1*Dd*f*g2*r + 5376*D1*Dd*f*g2*s**2 - 2128*D1*Dd*f*g2*s + 1344*D1*Dd*f*g2 - 7616*D1*Dd*f*gd2*s**2 + 1904*D1*Dd*f*gd2*s - 7616*D1*Dd*fd*g2*s**2 + 8848*D1*Dd*fd*g2*s - 1736*D1*Dd*fd*g2 - 336*D1*Ddd*K*f**2*r*s + 84*D1*Ddd*K*f**2*r - 1176*D1*Ddd*K*f**2*s**2 + 756*D1*Ddd*K*f**2*s - 294*D1*Ddd*K*f**2 + 168*D1*Ddd*b2*f*s**2 - 84*D1*Ddd*b2*f*s + 42*D1*Ddd*b2*f + 768*D1*Ddd*f**2*r*s - 192*D1*Ddd*f**2*r - 1200*D1*Ddd*f**2*s**2 + 216*D1*Ddd*f**2*s - 300*D1*Ddd*f**2 - 3808*D1*Ddd*f*g2*s**2 + 1904*D1*Ddd*f*g2*s - 952*D1*Ddd*f*g2 - 14*D1*bd1*(D1*(3*f**2*(r*(8*s - 6) - 12*s + 5) + 2*f*(2*C*(10*r*(2*s - 1) - 6*s**2 + 6*s - 3) - 10*K*r*s + 48*K*s**2 - K*s + 3*K - 3*fd*(16*r*s - 4*r - 8*s + 3) - 8*r*s + 9*r + 9*s**2 - 46*s + 15) - 2*fd*(2*C*(20*r*s - 5*r - 6*s**2 - 7*s + 5) + 68*K*s**2 - 65*K*s - 8*r*s + 2*r + 9*s**2 + 23*s - 10) - 20*g2*(4*r*s - 2*r - 2*s**2 + 2*s - 1) - 20*gd2*(-4*r*s + r + 2*s**2 + s - 1)) + Dd*(-3*f**2*(32*r*(2*s - 1) - 52*s + 21) - 2*f*(2*C*(10*r*(8*s - 3) - 24*s**2 - 2*s + 7) + K*(272*s**2 - 80*s + 3) - 32*r*s + 12*r + 36*s**2 - 113*s + 24) + 20*g2*(2*r*(8*s - 3) - 8*s**2 + 2*s + 1))) - 1008*Dd**2*K*f**2*r*s + 252*Dd**2*K*f**2*r - 3528*Dd**2*K*f**2*s**2 + 2268*Dd**2*K*f**2*s - 168*Dd**2*K*f**2 + 504*Dd**2*b2*f*s**2 - 252*Dd**2*b2*f*s + 2304*Dd**2*f**2*r*s - 576*Dd**2*f**2*r - 3600*Dd**2*f**2*s**2 + 648*Dd**2*f**2*s + 384*Dd**2*f**2 - 11424*Dd**2*f*g2*s**2 + 5712*Dd**2*f*g2*s) - 126*b2*(-D1**2*bdd1*f*(s - 1)**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 20*D1**2*f*fd*s - 10*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r + 14*D1**2*f*fdd*s**2 - 14*D1**2*f*fdd*s + 7*D1**2*f*fdd + 4*D1**2*fd**2*r*s - 2*D1**2*fd**2*r + 14*D1**2*fd**2*s**2 - 14*D1**2*fd**2*s - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 112*D1*Dd*f*fd*s**2 - 92*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 28*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 84*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 4*Dd**2*f**2))/(630*d**2*k3**2) + 9*D1**2*Pk3*Pkd2*ct**3*k1*st**2*(-D1*f*s*(2*D1*bd1**2*s*(5*f + 7) - 6*D1*bd1*(f*s - 2*fd*s + fd) + 3*D1*bdd1*f*s + 6*Dd*bd1*f*(4*s - 1)) + b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) + f*(fd*(s**2*(12 - 40*bd1) + s*(20*bd1 - 12) + 6) + fdd*(-6*s**2 + 6*s - 3) + s**2*(28*bd1 - 14*bdd1)) - 2*fd*s*(14*bd1 + 3*fd)*(s - 1)) + D1*f*(-2*Dd*(f*(s**2*(40*bd1 - 12) + s*(6 - 10*bd1) - 3) + (4*s - 1)*(14*bd1*s + fd*(6*s - 3))) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(35*d**2*k2**2) + D1**2*Pk3*Pkd2*ct**3*k1*(D1*f*s*(14*D1*bd1**2*(s*(21*f + 16) + 15) + 135*D1*bdd1*f*s + 270*bd1*(-D1*(f*s - 2*fd*s + fd) + Dd*f*(4*s - 1))) + 35*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + 7*b1**2*(-5*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 84*D1**2*f*fd*s**2 + 84*D1**2*f*fd*s - 42*D1**2*f*fd + 42*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd + 42*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s - 32*D1**2*fd*s**2 + 124*D1**2*fd*s - 62*D1**2*fd + 16*D1**2*fdd*s**2 - 62*D1**2*fdd*s + 31*D1**2*fdd - 168*D1*Dd*f**2*s**2 + 84*D1*Dd*f**2*s - 42*D1*Dd*f**2 + 336*D1*Dd*f*fd*s**2 - 252*D1*Dd*f*fd*s + 42*D1*Dd*f*fd - 128*D1*Dd*f*s**2 + 64*D1*Dd*f*s - 32*D1*Dd*f + 128*D1*Dd*fd*s**2 - 280*D1*Dd*fd*s + 62*D1*Dd*fd + 84*D1*Ddd*f**2*s**2 - 42*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 + 64*D1*Ddd*f*s**2 - 32*D1*Ddd*f*s + 16*D1*Ddd*f + 10*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) + 252*Dd**2*f**2*s**2 - 126*Dd**2*f**2*s + 192*Dd**2*f*s**2 - 96*Dd**2*f*s) + b1*(-70*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) + 7*D1**2*bdd1*f*(s**2*(42*f + 32) + 30*s - 15) - 135*D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) - 14*D1*bd1*(D1*(42*f**2*s**2 + f*(s**2*(32 - 84*fd) + s*(42*fd + 30) - 15) + fd*s*(47 - 32*s)) - Dd*f*(4*s - 1)*(s*(42*f + 32) + 15)) - 135*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 810*Dd**2*f**2*s*(1 - 2*s)))/(210*d**2*k2**2) - D1**2*Pk3*Pkd2*ct**3*k2**4*(8*C - 4)*(-D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*f*(2*D1*f*r*(s - 1) + D1*fd*(r*(2 - 4*s) + s - 1) + Dd*f*(-8*r*s + 5*r + 2*s - 2)) + b1*(D1*Dd*f*(2*f*r*(4*s - 1) - 4*f*s - fd*(2*r - 1)*(8*s - 1)) + D1*(D1*s*(2*r - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + 2*s)) + Dd**2*f**2*(r*(3 - 12*s) + 6*s - 2)))/(35*d**2*k1*k3**4) + D1**2*Pk3*Pkd2*ct**3*(8*C - 4)*(D1*f*(-D1*bdd1*f*r*s + bd1*(2*D1*f*r*s + D1*fd*(-4*r*s + r + s) + Dd*f*(-8*r*s + r + 2*s))) + b1*(D1*Dd*f*(2*f*r*(4*s - 1) - 4*f*s - fd*(2*r - 1)*(8*s - 3)) + D1*(D1*(2*f*fd*(2*r*s - r - s) + f*fdd*(-2*r*s + r + s) + fd**2*(-2*r*s + r + s - 1)) + Ddd*f**2*(-4*r*s + r + 2*s)) + Dd**2*f**2*(r*(3 - 12*s) + 6*s - 2)))/(35*d**2*k1) + 4*D1**2*Pk3*Pkd2*ct**2*f**2*k1**6*st**2*(D1**2*(f*(17*fd - 14*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 14*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(17*f*(r*(4*s - 1) + (1 - 2*s)**2) - 28*fd*(4*s - 1)*(4*r + 4*s - 3)) - 14*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 14*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**2*f*k1**6*(-7*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(5*f*(s - 1)*(r + s - 1) - 7*fd*(6*r*s - 3*r + 6*s**2 - 8*s + 2)) - 7*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + b1*(D1**2*s*(3*r + 3*s - 2)*(5*f*fd - 7*f*fdd - 14*fd**2) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 7*fd*(3*r*(8*s - 1) + 24*s**2 - 20*s + 2)) - 7*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 7*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**2*k1**4*k2*st**4*(132*C*D1**2*f**2*fd*r*s - 44*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 132*C*D1**2*f**2*fd*s + 44*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r*s + 22*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 66*C*D1**2*f**2*fdd*s - 22*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r*s + 44*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 132*C*D1**2*f*fd**2*s - 22*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r*s - 44*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 176*C*D1*Dd*f**3*s + 44*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r*s + 154*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 528*C*D1*Dd*f**2*fd*s - 110*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r*s + 22*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 88*C*D1*Ddd*f**3*s - 22*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r*s + 66*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 264*C*Dd**2*f**3*s - 44*C*Dd**2*f**3 - 33*D1**2*K*bdd1*f**2*r*s - 33*D1**2*K*bdd1*f**2*s**2 + 33*D1**2*K*bdd1*f**2*s + 33*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s + 980*D1**2*f**3*fd*r*s - 245*D1**2*f**3*fd*r + 980*D1**2*f**3*fd*s**2 - 980*D1**2*f**3*fd*s + 245*D1**2*f**3*fd - 600*D1**2*f**3*fdd*r*s + 150*D1**2*f**3*fdd*r - 600*D1**2*f**3*fdd*s**2 + 600*D1**2*f**3*fdd*s - 150*D1**2*f**3*fdd - 1800*D1**2*f**2*fd**2*r*s + 450*D1**2*f**2*fd**2*r - 1800*D1**2*f**2*fd**2*s**2 + 1800*D1**2*f**2*fd**2*s - 300*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r*s + 44*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 132*D1**2*f**2*fd*s - 44*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r*s - 22*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 66*D1**2*f**2*fdd*s + 22*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s + 66*D1**2*f**2*gdd2*r*s + 66*D1**2*f**2*gdd2*s**2 - 66*D1**2*f**2*gdd2*s + 132*D1**2*f*fd**2*r*s - 44*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 132*D1**2*f*fd**2*s + 22*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r*s - 66*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 264*D1**2*f*fd*gd2*s + 66*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r*s - 66*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r*s - 66*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 980*D1*Dd*f**4*r*s - 245*D1*Dd*f**4*r + 980*D1*Dd*f**4*s**2 - 980*D1*Dd*f**4*s + 245*D1*Dd*f**4 - 4800*D1*Dd*f**3*fd*r*s + 1200*D1*Dd*f**3*fd*r - 4800*D1*Dd*f**3*fd*s**2 + 4800*D1*Dd*f**3*fd*s - 900*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 176*D1*Dd*f**3*s - 44*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r*s - 154*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 528*D1*Dd*f**2*fd*s + 110*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r*s + 132*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r*s - 66*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 528*D1*Dd*f**2*gd2*s + 66*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r*s - 396*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1056*D1*Dd*f*fd*g2*s + 264*D1*Dd*f*fd*g2 - 600*D1*Ddd*f**4*r*s + 150*D1*Ddd*f**4*r - 600*D1*Ddd*f**4*s**2 + 600*D1*Ddd*f**4*s - 150*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 88*D1*Ddd*f**3*s + 22*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r*s - 66*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 264*D1*Ddd*f**2*g2*s + 66*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 1800*Dd**2*f**4*r*s + 450*Dd**2*f**4*r - 1800*Dd**2*f**4*s**2 + 1800*Dd**2*f**4*s - 300*Dd**2*f**4 + 264*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 264*Dd**2*f**3*s + 44*Dd**2*f**3 + 792*Dd**2*f**2*g2*r*s - 198*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 792*Dd**2*f**2*g2*s + 132*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(385*d**2*k3**6) - 4*D1**2*Pk3*Pkd2*ct**2*k1**4*k2*st**2*(18*C*D1**2*bdd1*f**2*r*s - 18*C*D1**2*bdd1*f**2*r + 18*C*D1**2*bdd1*f**2*s**2 - 36*C*D1**2*bdd1*f**2*s + 18*C*D1**2*bdd1*f**2 - 66*C*D1**2*f**2*fd*r*s + 22*C*D1**2*f**2*fd*r - 66*C*D1**2*f**2*fd*s**2 + 66*C*D1**2*f**2*fd*s - 22*C*D1**2*f**2*fd + 60*C*D1**2*f**2*fdd*r*s - 20*C*D1**2*f**2*fdd*r + 60*C*D1**2*f**2*fdd*s**2 - 60*C*D1**2*f**2*fdd*s + 20*C*D1**2*f**2*fdd + 120*C*D1**2*f*fd**2*r*s - 40*C*D1**2*f*fd**2*r + 120*C*D1**2*f*fd**2*s**2 - 120*C*D1**2*f*fd**2*s + 20*C*D1**2*f*fd**2 - 88*C*D1*Dd*f**3*r*s + 22*C*D1*Dd*f**3*r - 88*C*D1*Dd*f**3*s**2 + 88*C*D1*Dd*f**3*s - 22*C*D1*Dd*f**3 + 480*C*D1*Dd*f**2*fd*r*s - 140*C*D1*Dd*f**2*fd*r + 480*C*D1*Dd*f**2*fd*s**2 - 480*C*D1*Dd*f**2*fd*s + 100*C*D1*Dd*f**2*fd + 80*C*D1*Ddd*f**3*r*s - 20*C*D1*Ddd*f**3*r + 80*C*D1*Ddd*f**3*s**2 - 80*C*D1*Ddd*f**3*s + 20*C*D1*Ddd*f**3 + 240*C*Dd**2*f**3*r*s - 60*C*Dd**2*f**3*r + 240*C*Dd**2*f**3*s**2 - 240*C*Dd**2*f**3*s + 40*C*Dd**2*f**3 + 18*D1**2*K*bdd1*f**2*r*s + 18*D1**2*K*bdd1*f**2*s**2 - 18*D1**2*K*bdd1*f**2*s + 21*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 20*D1**2*bdd1*f**3*r*s - 60*D1**2*bdd1*f**3*r + 20*D1**2*bdd1*f**3*s**2 - 80*D1**2*bdd1*f**3*s + 60*D1**2*bdd1*f**3 - 27*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*r - 27*D1**2*bdd1*f**2*s**2 + 45*D1**2*bdd1*f**2*s - 18*D1**2*bdd1*f**2 - 42*D1**2*bdd1*f*g2*r*s + 42*D1**2*bdd1*f*g2*r - 42*D1**2*bdd1*f*g2*s**2 + 84*D1**2*bdd1*f*g2*s - 42*D1**2*bdd1*f*g2 + 120*D1**2*f**3*fd*r*s - 30*D1**2*f**3*fd*r + 120*D1**2*f**3*fd*s**2 - 120*D1**2*f**3*fd*s + 30*D1**2*f**3*fd + 45*D1**2*f**2*fd*r*s - 15*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s**2 - 45*D1**2*f**2*fd*s + 15*D1**2*f**2*fd - 45*D1**2*f**2*fdd*r*s + 15*D1**2*f**2*fdd*r - 45*D1**2*f**2*fdd*s**2 + 45*D1**2*f**2*fdd*s - 15*D1**2*f**2*fdd + 30*D1**2*f**2*gd2*r*s + 30*D1**2*f**2*gd2*s**2 - 30*D1**2*f**2*gd2*s - 36*D1**2*f**2*gdd2*r*s - 36*D1**2*f**2*gdd2*s**2 + 36*D1**2*f**2*gdd2*s - 90*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r - 90*D1**2*f*fd**2*s**2 + 90*D1**2*f*fd**2*s - 15*D1**2*f*fd**2 + 60*D1**2*f*fd*g2*r*s - 30*D1**2*f*fd*g2*r + 60*D1**2*f*fd*g2*s**2 - 60*D1**2*f*fd*g2*s + 30*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r*s + 36*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 144*D1**2*f*fd*gd2*s - 36*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r*s + 36*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r*s + 36*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s + 120*D1*Dd*f**4*r*s - 30*D1*Dd*f**4*r + 120*D1*Dd*f**4*s**2 - 120*D1*Dd*f**4*s + 30*D1*Dd*f**4 + 60*D1*Dd*f**3*r*s - 15*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 15*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r*s + 105*D1*Dd*f**2*fd*r - 360*D1*Dd*f**2*fd*s**2 + 360*D1*Dd*f**2*fd*s - 75*D1*Dd*f**2*fd + 120*D1*Dd*f**2*g2*r*s - 30*D1*Dd*f**2*g2*r + 120*D1*Dd*f**2*g2*s**2 - 120*D1*Dd*f**2*g2*s + 30*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r*s + 36*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 288*D1*Dd*f**2*gd2*s - 36*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r*s + 216*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 576*D1*Dd*f*fd*g2*s - 144*D1*Dd*f*fd*g2 - 60*D1*Ddd*f**3*r*s + 15*D1*Ddd*f**3*r - 60*D1*Ddd*f**3*s**2 + 60*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r*s + 36*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 144*D1*Ddd*f**2*g2*s - 36*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-f**3*(40*s - 93)*(r + s - 1) + f**2*(-36*C*(s - 1)*(r + s - 1) + 20*fd*(r*(6*s - 7) + 6*s**2 - 12*s + 4) - (s*(15*K - 40) + 36)*(r + s - 1)) + 9*f*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 5*r - 12*s**2 + 14*s - 3) + 42*f*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 42*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(20*f**2*(r*(8*s - 13) + 8*s**2 - 20*s + 10) + 9*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 11*r - 24*s**2 + 32*s - 9) - 42*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 180*Dd**2*f**3*r*s + 45*Dd**2*f**3*r - 180*Dd**2*f**3*s**2 + 180*Dd**2*f**3*s - 30*Dd**2*f**3 - 432*Dd**2*f**2*g2*r*s + 108*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 432*Dd**2*f**2*g2*s - 72*Dd**2*f**2*g2 - 21*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(-72*C*D1**2*f*fd*r*s - 72*C*D1**2*f*fd*s**2 + 36*C*D1**2*f*fd*s + 36*C*D1**2*f*fdd*r*s + 36*C*D1**2*f*fdd*s**2 - 18*C*D1**2*f*fdd*s + 36*C*D1**2*fd**2*r*s + 36*C*D1**2*fd**2*s**2 - 18*C*D1**2*fd**2*s - 144*C*D1*Dd*f**2*r*s + 36*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 36*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r*s - 36*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 216*C*D1*Dd*f*fd*s + 18*C*D1*Dd*f*fd + 72*C*D1*Ddd*f**2*r*s - 18*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 18*C*D1*Ddd*f**2 + 216*C*Dd**2*f**2*r*s - 54*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 36*C*Dd**2*f**2 - 30*D1**2*K*f*fd*r*s + 15*D1**2*K*f*fd*r - 30*D1**2*K*f*fd*s**2 + 30*D1**2*K*f*fd*s - 15*D1**2*K*f*fd + 36*D1**2*K*f*fdd*r*s - 18*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r*s - 18*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s + 21*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 120*D1**2*f**2*fd*r*s - 53*D1**2*f**2*fd*r - 120*D1**2*f**2*fd*s**2 + 27*D1**2*f**2*fd*s + 53*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r*s + 40*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 40*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r*s + 80*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2 + 80*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 80*D1**2*f*fd*s**2 - 44*D1**2*f*fd*s + 4*D1**2*f*fd - 54*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 9*D1**2*f*fdd + 84*D1**2*f*gd2*r*s + 84*D1**2*f*gd2*s**2 - 84*D1**2*f*gd2*s - 42*D1**2*f*gdd2*r*s - 42*D1**2*f*gdd2*s**2 + 42*D1**2*f*gdd2*s - 54*D1**2*fd**2*r*s + 9*D1**2*fd**2*r - 54*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 84*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*s**2 - 84*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*s**2 + 42*D1**2*fd*gd2*s - 42*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*s**2 - 60*D1*Dd*K*f**2*r*s + 15*D1*Dd*K*f**2*r - 60*D1*Dd*K*f**2*s**2 + 60*D1*Dd*K*f**2*s - 15*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r*s - 108*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 288*D1*Dd*K*f*fd*s + 72*D1*Dd*K*f*fd - 160*D1*Dd*f**3*r*s + 40*D1*Dd*f**3*r - 160*D1*Dd*f**3*s**2 + 160*D1*Dd*f**3*s - 40*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r*s + 100*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 240*D1*Dd*f**2*fd*s - 80*D1*Dd*f**2*fd + 160*D1*Dd*f**2*r*s - 40*D1*Dd*f**2*r + 160*D1*Dd*f**2*s**2 - 160*D1*Dd*f**2*s + 40*D1*Dd*f**2 - 432*D1*Dd*f*fd*r*s + 90*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 336*D1*Dd*f*g2*r*s - 84*D1*Dd*f*g2*r + 336*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r*s + 42*D1*Dd*f*gd2*r - 336*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 42*D1*Dd*f*gd2 - 336*D1*Dd*fd*g2*r*s + 42*D1*Dd*fd*g2*r - 336*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 72*D1*Ddd*K*f**2*r*s - 18*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 72*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 80*D1*Ddd*f**3*s + 20*D1*Ddd*f**3 - 108*D1*Ddd*f**2*r*s + 27*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r*s + 42*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 42*D1*Ddd*f*g2 - 21*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) + 216*Dd**2*K*f**2*r*s - 54*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 216*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 + 240*Dd**2*f**3*r*s - 60*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 240*Dd**2*f**3*s + 40*Dd**2*f**3 - 324*Dd**2*f**2*r*s + 81*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 54*Dd**2*f**2 - 504*Dd**2*f*g2*r*s + 126*Dd**2*f*g2*r - 504*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 84*Dd**2*f*g2))/(105*d**2*k3**6) - 4*D1**2*Pk3*Pkd2*ct**2*k1**4*k2*(-3*D1*(D1*bd1**2*f*(2*s - 1)*(-14*K + 20*f + 7)*(r + s - 1) - D1*bdd1*f*(s - 1)*(f*(20*C - 15) - 28*g2)*(r + s - 1) + bd1*(D1*(-5*f**3*(2*s - 3)*(r + s - 1) - f**2*(2*C - 5)*(s - 1)*(r + s - 1) + f*(-fd*(20*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (g2*(s - 1) + 2*gd2*(2*s - 1))*(14*r + 14*s - 14)) + 28*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(f*(20*C - 15) - 28*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + b1**2*(D1**2*s*(3*f*(19*fd - 20*fdd)*(2*r + 2*s - 1) - 60*fd**2*(2*r + 2*s - 1) + 7*fd*(3*K - 4)*(r + s) + 21*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(57*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-60*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (21*K - 28)*(r*(4*s - 1) + (1 - 2*s)**2)) + 21*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 20*f + 7)) - 3*Dd**2*f*(-14*K + 20*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*bdd1*f*(2*s - 1)*(-14*K + 20*f + 7)*(r + s - 1) - 3*D1**2*(-5*f**2*fd*(6*r*s + r + 6*s**2 - 3*s - 1) + f*s*(-fd*(2*C - 5)*(2*r + 2*s - 1) - fdd*(20*C - 15)*(2*r + 2*s - 1) + (14*gd2 + 28*gdd2)*(r + s - 1)) + s*(-fd**2*(20*C - 15)*(2*r + 2*s - 1) + 14*fd*(g2*(r + s) + gd2*(4*r + 4*s - 2)) + 28*fdd*g2*(r + s))) + D1*bd1*(D1*(57*f**2*(2*s - 1)*(r + s - 1) + f*(-60*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + (21*K - 28)*(2*s - 1)*(r + s - 1)) + 21*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 3*Dd*f*(-14*K + 20*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*D1*(Dd*(-10*f**3*(r*(4*s - 1) + (1 - 2*s)**2) - f**2*(2*C - 5)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(15 - 20*C)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 14*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 28*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 28*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(f*(20*C - 15) - 28*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd**2*f*(f*(20*C - 15) - 28*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**6) + 3*D1**2*Pk3*Pkd2*ct**2*k1**4*st**4*(D1**2*(225*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-1350*fd**2*s*(2*s - 1) + fd*(44*C - 44)*(3*s**2 - 2*s + 1) - fdd*(22*C - 22)*(3*s**2 - 2*s + 1) + s**2*(-33*K*bdd1 + 66*bd1*(K - 1) + 33*bdd1 - 132*gd2 + 66*gdd2)) - 22*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 3*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 3*fdd*g2*(2*s**2 - 2*s + 1)) + 132*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(225*f**3*(4*s**2 - 2*s + 1) + f**2*(22*C*(4*s**2 - 2*s + 1) - 225*fd*(1 - 4*s)**2 - 88*s**2 + 44*s - 22) - 11*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 6*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(3*K*bd1 - 3*bd1 - 6*gd2)) + 66*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(225*f**2 + f*(22*C - 22) - 66*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(225*f**2 + f*(22*C - 22) - 66*g2) + 33*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(770*d**2*k2*k3**4) - D1**2*Pk3*Pkd2*ct**2*k1**4*st**2*(30*C*D1**2*bdd1*f**2*s**2 - 60*C*D1**2*bdd1*f**2*s + 30*C*D1**2*bdd1*f**2 + 384*C*D1**2*f**2*fd*s**2 - 256*C*D1**2*f**2*fd*s + 128*C*D1**2*f**2*fd - 210*C*D1**2*f**2*fdd*s**2 + 140*C*D1**2*f**2*fdd*s - 70*C*D1**2*f**2*fdd - 420*C*D1**2*f*fd**2*s**2 + 280*C*D1**2*f*fd**2*s + 512*C*D1*Dd*f**3*s**2 - 256*C*D1*Dd*f**3*s + 128*C*D1*Dd*f**3 - 1680*C*D1*Dd*f**2*fd*s**2 + 980*C*D1*Dd*f**2*fd*s - 140*C*D1*Dd*f**2*fd - 280*C*D1*Ddd*f**3*s**2 + 140*C*D1*Ddd*f**3*s - 70*C*D1*Ddd*f**3 - 840*C*Dd**2*f**3*s**2 + 420*C*Dd**2*f**3*s - 71*D1**2*K*bdd1*f**2*s**2 + 70*D1**2*bd1**2*f*s*(K - 1)*(s - 1) + 80*D1**2*bdd1*f**3*r*s + 180*D1**2*bdd1*f**3*s**2 - 340*D1**2*bdd1*f**3*s + 150*D1**2*bdd1*f**3 + 36*D1**2*bdd1*f**2*r*s + 77*D1**2*bdd1*f**2*s**2 + 24*D1**2*bdd1*f**2*s - 30*D1**2*bdd1*f**2 - 70*D1**2*bdd1*f*g2*s**2 + 140*D1**2*bdd1*f*g2*s - 70*D1**2*bdd1*f*g2 + 400*D1**2*f**3*fd*r*s - 100*D1**2*f**3*fd*r + 1920*D1**2*f**3*fd*s**2 - 1160*D1**2*f**3*fd*s + 480*D1**2*f**3*fd - 400*D1**2*f**3*fdd*r*s + 100*D1**2*f**3*fdd*r - 1080*D1**2*f**3*fdd*s**2 + 740*D1**2*f**3*fdd*s - 270*D1**2*f**3*fdd - 1200*D1**2*f**2*fd**2*r*s + 300*D1**2*f**2*fd**2*r - 3240*D1**2*f**2*fd**2*s**2 + 2220*D1**2*f**2*fd**2*s - 200*D1**2*f**2*fd**2 - 84*D1**2*f**2*fd*r*s + 28*D1**2*f**2*fd*r - 468*D1**2*f**2*fd*s**2 + 340*D1**2*f**2*fd*s - 156*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 270*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd - 256*D1**2*f**2*gd2*s**2 + 142*D1**2*f**2*gdd2*s**2 + 120*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 540*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 - 512*D1**2*f*fd*g2*s**2 + 512*D1**2*f*fd*g2*s - 256*D1**2*f*fd*g2 + 568*D1**2*f*fd*gd2*s**2 - 284*D1**2*f*fd*gd2*s + 284*D1**2*f*fdd*g2*s**2 - 284*D1**2*f*fdd*g2*s + 142*D1**2*f*fdd*g2 + 284*D1**2*fd**2*g2*s**2 - 284*D1**2*fd**2*g2*s + 400*D1*Dd*f**4*r*s - 100*D1*Dd*f**4*r + 1920*D1*Dd*f**4*s**2 - 1160*D1*Dd*f**4*s + 480*D1*Dd*f**4 - 3200*D1*Dd*f**3*fd*r*s + 800*D1*Dd*f**3*fd*r - 8640*D1*Dd*f**3*fd*s**2 + 5920*D1*Dd*f**3*fd*s - 940*D1*Dd*f**3*fd - 112*D1*Dd*f**3*r*s + 28*D1*Dd*f**3*r - 624*D1*Dd*f**3*s**2 + 368*D1*Dd*f**3*s - 156*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r*s - 140*D1*Dd*f**2*fd*r + 2160*D1*Dd*f**2*fd*s**2 - 1460*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd - 1024*D1*Dd*f**2*g2*s**2 + 512*D1*Dd*f**2*g2*s - 256*D1*Dd*f**2*g2 + 1136*D1*Dd*f**2*gd2*s**2 - 284*D1*Dd*f**2*gd2*s + 2272*D1*Dd*f*fd*g2*s**2 - 1704*D1*Dd*f*fd*g2*s + 284*D1*Dd*f*fd*g2 - 400*D1*Ddd*f**4*r*s + 100*D1*Ddd*f**4*r - 1080*D1*Ddd*f**4*s**2 + 740*D1*Ddd*f**4*s - 270*D1*Ddd*f**4 + 80*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r + 360*D1*Ddd*f**3*s**2 - 220*D1*Ddd*f**3*s + 90*D1*Ddd*f**3 + 568*D1*Ddd*f**2*g2*s**2 - 284*D1*Ddd*f**2*g2*s + 142*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(2*f**3*(72*s**2 + s*(22*r - 161) + 75) + f**2*(30*C*(s - 1)**2 - 64*K*s**2 - 20*fd*(12*r*s - 2*r + 27*s**2 - 30*s + 1) + 22*r*s + 56*s**2 + 38*s - 30) - f*(fd*(18*r*(4*s - 1) + s**2*(60*C - 142*K + 154) + s*(-60*C + 71*K - 83) + 18) + (70*s - 70)*(g2*(s - 1) - gd2*s)) + 70*fd*g2*s*(s - 1)) + Dd*f*(-10*f**2*(4*r*(8*s - 1) + 72*s**2 - 94*s + 17) + f*(-30*C*(4*s**2 - 5*s + 1) + 284*K*s**2 - 71*K*s - 144*r*s + 18*r - 308*s**2 + 65*s + 12) + 70*g2*(4*s**2 - 5*s + 1))) - 1200*Dd**2*f**4*r*s + 300*Dd**2*f**4*r - 3240*Dd**2*f**4*s**2 + 2220*Dd**2*f**4*s - 200*Dd**2*f**4 + 240*Dd**2*f**3*r*s - 60*Dd**2*f**3*r + 1080*Dd**2*f**3*s**2 - 660*Dd**2*f**3*s + 40*Dd**2*f**3 + 1704*Dd**2*f**2*g2*s**2 - 852*Dd**2*f**2*g2*s - 35*b1**2*(K - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-120*C*D1**2*f*fd*s**2 + 60*C*D1**2*f*fdd*s**2 + 60*C*D1**2*fd**2*s**2 - 240*C*D1*Dd*f**2*s**2 + 120*C*D1*Dd*f**2*s - 60*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*s**2 - 120*C*D1*Dd*f*fd*s + 120*C*D1*Ddd*f**2*s**2 - 60*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*s**2 - 180*C*Dd**2*f**2*s + 256*D1**2*K*f*fd*s**2 - 256*D1**2*K*f*fd*s + 128*D1**2*K*f*fd - 142*D1**2*K*f*fdd*s**2 + 142*D1**2*K*f*fdd*s - 71*D1**2*K*f*fdd - 142*D1**2*K*fd**2*s**2 + 142*D1**2*K*fd**2*s + 35*D1**2*bdd1*f*(K - 1)*(2*s**2 - 2*s + 1) - 264*D1**2*f**2*fd*r*s + 88*D1**2*f**2*fd*r - 864*D1**2*f**2*fd*s**2 + 108*D1**2*f**2*fd*s + 12*D1**2*f**2*fd + 240*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 540*D1**2*f**2*fdd*s**2 - 180*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 480*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 1080*D1**2*f*fd**2*s**2 - 360*D1**2*f*fd**2*s + 120*D1**2*f*fd**2 - 88*D1**2*f*fd*r*s + 44*D1**2*f*fd*r - 224*D1**2*f*fd*s**2 + 344*D1**2*f*fd*s - 172*D1**2*f*fd + 72*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 154*D1**2*f*fdd*s**2 - 214*D1**2*f*fdd*s + 107*D1**2*f*fdd + 140*D1**2*f*gd2*s**2 - 70*D1**2*f*gdd2*s**2 + 72*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 154*D1**2*fd**2*s**2 - 214*D1**2*fd**2*s + 140*D1**2*fd*g2*s**2 - 140*D1**2*fd*gd2*s**2 - 70*D1**2*fdd*g2*s**2 + 512*D1*Dd*K*f**2*s**2 - 256*D1*Dd*K*f**2*s + 128*D1*Dd*K*f**2 - 1136*D1*Dd*K*f*fd*s**2 + 852*D1*Dd*K*f*fd*s - 142*D1*Dd*K*f*fd - 352*D1*Dd*f**3*r*s + 88*D1*Dd*f**3*r - 1152*D1*Dd*f**3*s**2 + 752*D1*Dd*f**3*s - 288*D1*Dd*f**3 + 1920*D1*Dd*f**2*fd*r*s - 560*D1*Dd*f**2*fd*r + 4320*D1*Dd*f**2*fd*s**2 - 2280*D1*Dd*f**2*fd*s + 340*D1*Dd*f**2*fd - 176*D1*Dd*f**2*r*s + 44*D1*Dd*f**2*r - 448*D1*Dd*f**2*s**2 + 312*D1*Dd*f**2*s - 112*D1*Dd*f**2 + 576*D1*Dd*f*fd*r*s - 216*D1*Dd*f*fd*r + 1232*D1*Dd*f*fd*s**2 - 1308*D1*Dd*f*fd*s + 286*D1*Dd*f*fd + 560*D1*Dd*f*g2*s**2 - 280*D1*Dd*f*g2*s + 140*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*s**2 + 140*D1*Dd*f*gd2*s - 560*D1*Dd*fd*g2*s**2 + 140*D1*Dd*fd*g2*s - 284*D1*Ddd*K*f**2*s**2 + 142*D1*Ddd*K*f**2*s - 71*D1*Ddd*K*f**2 + 320*D1*Ddd*f**3*r*s - 80*D1*Ddd*f**3*r + 720*D1*Ddd*f**3*s**2 - 520*D1*Ddd*f**3*s + 180*D1*Ddd*f**3 + 144*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 308*D1*Ddd*f**2*s**2 - 226*D1*Ddd*f**2*s + 77*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*s**2 + 140*D1*Ddd*f*g2*s - 70*D1*Ddd*f*g2 - 70*D1*bd1*(K - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 852*Dd**2*K*f**2*s**2 + 426*Dd**2*K*f**2*s + 960*Dd**2*f**3*r*s - 240*Dd**2*f**3*r + 2160*Dd**2*f**3*s**2 - 1560*Dd**2*f**3*s + 160*Dd**2*f**3 + 432*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 924*Dd**2*f**2*s**2 - 678*Dd**2*f**2*s + 72*Dd**2*f**2 - 840*Dd**2*f*g2*s**2 + 420*Dd**2*f*g2*s))/(210*d**2*k2*k3**4) + D1**2*Pk3*Pkd2*ct**2*k1**4*(-D1*(2*D1*bd1**2*f*(15*f*(r*(8*s - 4) + 7*s**2 - 9*s + 2) + 42*r*(2*s - 1) - (7*s - 7)*(s*(17*K - 29) + 6)) + D1*bdd1*f*(-75*f**2*(2*r*(s - 1) + 2*s**2 - 6*s + 3) + 6*f*(s - 1)*(-27*C*(s - 1) + 10*r + 37*s - 37) + 238*g2*(s - 1)**2) + 2*bd1*(D1*(15*f**3*(5*r*(s - 1) + 8*s**2 - 24*s + 12) + 3*f**2*(40*C*(s - 1)**2 - 25*fd*(6*r*s - 3*r + 6*s**2 - 10*s + 2) - (2*s - 2)*(3*r + 23*s - 23)) + 2*f*(30*fd*r*(2*s - 1) - 3*fd*(s - 1)*(s*(54*C - 74) + 5) - (7*s - 7)*(12*g2*(s - 1) - 17*gd2*s)) + 238*fd*g2*s*(s - 1)) + Dd*f*(-75*f**2*(r*(8*s - 5) + 8*s**2 - 16*s + 5) - 6*f*(27*C*(4*s**2 - 5*s + 1) - 40*r*s + 25*r - 148*s**2 + 195*s - 47) + 238*g2*(4*s**2 - 5*s + 1)))) + b1**2*(D1**2*s*(6*f*(2*fd*(12*r + 7*s - 9) - 5*fdd*(8*r + 7*s - 6)) - 30*fd**2*(8*r + 7*s - 6) + 28*fd*(-6*K*s + r + 7*s) - 7*fdd*(-17*K*s + 12*r + 29*s)) + D1*(2*Dd*(3*f**2*(12*r*(4*s - 1) + 28*s**2 - 38*s + 7) - 2*f*(42*K*(4*s**2 - 2*s + 1) + 15*fd*(4*r*(8*s - 1) + 28*s**2 - 27*s + 3) - 28*r*s + 7*r - 196*s**2 + 112*s - 49) + 7*fd*(r*(6 - 48*s) + s*(68*K*s - 17*K - 116*s + 41))) + Ddd*f*(119*K*(4*s**2 - 2*s + 1) - 15*f*(8*r*(4*s - 1) + 28*s**2 - 30*s + 7) - 336*r*s + 84*r - 812*s**2 + 574*s - 203)) - 6*Dd**2*f*(5*f*(12*r*(4*s - 1) + 42*s**2 - 45*s + 8) + 42*r*(4*s - 1) + 7*s**2*(58 - 34*K) + 7*s*(17*K - 41) + 28)) + b1*(-480*C*D1**2*f*fd*s**2 + 324*C*D1**2*f*fdd*s**2 + 324*C*D1**2*fd**2*s**2 - 960*C*D1*Dd*f**2*s**2 + 480*C*D1*Dd*f**2*s - 240*C*D1*Dd*f**2 + 2592*C*D1*Dd*f*fd*s**2 - 648*C*D1*Dd*f*fd*s + 648*C*D1*Ddd*f**2*s**2 - 324*C*D1*Ddd*f**2*s + 162*C*D1*Ddd*f**2 + 1944*C*Dd**2*f**2*s**2 - 972*C*Dd**2*f**2*s + D1**2*bdd1*f*(119*K*(2*s**2 - 2*s + 1) - 15*f*(8*r*(2*s - 1) + 14*s**2 - 18*s + 7) - 168*r*s + 84*r - 406*s**2 + 490*s - 203) - 450*D1**2*f**2*fd*r*s - 720*D1**2*f**2*fd*s**2 + 60*D1**2*f**2*fd*s + 120*D1**2*f**2*fd + 450*D1**2*f**2*fdd*r*s + 450*D1**2*f**2*fdd*s**2 - 150*D1**2*f**2*fdd*s - 75*D1**2*f**2*fdd + 900*D1**2*f*fd**2*r*s + 900*D1**2*f*fd**2*s**2 - 300*D1**2*f*fd**2*s + 72*D1**2*f*fd*r*s + 552*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s - 120*D1**2*f*fdd*r*s - 444*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s + 336*D1**2*f*gd2*s**2 - 238*D1**2*f*gdd2*s**2 - 120*D1**2*fd**2*r*s - 444*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s + 336*D1**2*fd*g2*s**2 - 476*D1**2*fd*gd2*s**2 - 238*D1**2*fdd*g2*s**2 - 600*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 960*D1*Dd*f**3*s**2 + 780*D1*Dd*f**3*s - 240*D1*Dd*f**3 + 3600*D1*Dd*f**2*fd*r*s - 450*D1*Dd*f**2*fd*r + 3600*D1*Dd*f**2*fd*s**2 - 2400*D1*Dd*f**2*fd*s + 150*D1*Dd*f**2*fd + 144*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r + 1104*D1*Dd*f**2*s**2 - 624*D1*Dd*f**2*s + 276*D1*Dd*f**2 - 960*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 3552*D1*Dd*f*fd*s**2 + 1368*D1*Dd*f*fd*s - 60*D1*Dd*f*fd + 1344*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 336*D1*Dd*f*g2 - 1904*D1*Dd*f*gd2*s**2 + 476*D1*Dd*f*gd2*s - 1904*D1*Dd*fd*g2*s**2 + 476*D1*Dd*fd*g2*s + 600*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 600*D1*Ddd*f**3*s**2 - 600*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 - 240*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 888*D1*Ddd*f**2*s**2 + 564*D1*Ddd*f**2*s - 222*D1*Ddd*f**2 - 952*D1*Ddd*f*g2*s**2 + 476*D1*Ddd*f*g2*s - 238*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(3*f**2*(12*r*(2*s - 1) + 14*s**2 - 20*s + 7) - 2*f*(42*K*(2*s**2 - 2*s + 1) + 15*fd*(4*r*(4*s - 1) + 14*s**2 - 15*s + 3) - 14*r*s + 7*r - 98*s**2 + 105*s - 49) + 7*fd*(r*(6 - 24*s) + s*(34*K*s - 17*K - 58*s + 35))) + Dd*f*(119*K*(8*s**2 - 6*s + 1) - 15*f*(8*r*(8*s - 3) + 56*s**2 - 66*s + 17) - 672*r*s + 252*r - 1624*s**2 + 1554*s - 329)) + 1800*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 1800*Dd**2*f**3*s**2 - 1800*Dd**2*f**3*s + 300*Dd**2*f**3 - 720*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 2664*Dd**2*f**2*s**2 + 1692*Dd**2*f**2*s - 120*Dd**2*f**2 - 2856*Dd**2*f*g2*s**2 + 1428*Dd**2*f*g2*s))/(210*d**2*k2*k3**4) + 4*D1**2*Pk3*Pkd2*ct**2*k1**2*k2**3*st**6*(132*C*D1**2*f**2*fd*r*s - 44*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 132*C*D1**2*f**2*fd*s + 44*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r*s + 22*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 66*C*D1**2*f**2*fdd*s - 22*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r*s + 44*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 132*C*D1**2*f*fd**2*s - 22*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r*s - 44*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 176*C*D1*Dd*f**3*s + 44*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r*s + 154*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 528*C*D1*Dd*f**2*fd*s - 110*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r*s + 22*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 88*C*D1*Ddd*f**3*s - 22*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r*s + 66*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 264*C*Dd**2*f**3*s - 44*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 672*D1**2*f**3*fd*r*s - 168*D1**2*f**3*fd*r + 672*D1**2*f**3*fd*s**2 - 672*D1**2*f**3*fd*s + 168*D1**2*f**3*fd - 336*D1**2*f**3*fdd*r*s + 84*D1**2*f**3*fdd*r - 336*D1**2*f**3*fdd*s**2 + 336*D1**2*f**3*fdd*s - 84*D1**2*f**3*fdd - 1008*D1**2*f**2*fd**2*r*s + 252*D1**2*f**2*fd**2*r - 1008*D1**2*f**2*fd**2*s**2 + 1008*D1**2*f**2*fd**2*s - 168*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r*s + 44*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 132*D1**2*f**2*fd*s - 44*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r*s - 22*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 66*D1**2*f**2*fdd*s + 22*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 132*D1**2*f*fd**2*r*s - 44*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 132*D1**2*f*fd**2*s + 22*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 672*D1*Dd*f**4*r*s - 168*D1*Dd*f**4*r + 672*D1*Dd*f**4*s**2 - 672*D1*Dd*f**4*s + 168*D1*Dd*f**4 - 2688*D1*Dd*f**3*fd*r*s + 672*D1*Dd*f**3*fd*r - 2688*D1*Dd*f**3*fd*s**2 + 2688*D1*Dd*f**3*fd*s - 504*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 176*D1*Dd*f**3*s - 44*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r*s - 154*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 528*D1*Dd*f**2*fd*s + 110*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 336*D1*Ddd*f**4*r*s + 84*D1*Ddd*f**4*r - 336*D1*Ddd*f**4*s**2 + 336*D1*Ddd*f**4*s - 84*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 88*D1*Ddd*f**3*s + 22*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 1008*Dd**2*f**4*r*s + 252*Dd**2*f**4*r - 1008*Dd**2*f**4*s**2 + 1008*Dd**2*f**4*s - 168*Dd**2*f**4 + 264*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 264*Dd**2*f**3*s + 44*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**2*k1**2*k2**3*st**4*(-2*C*D1**2*bdd1*f**2*r*s + 2*C*D1**2*bdd1*f**2*r - 2*C*D1**2*bdd1*f**2*s**2 + 4*C*D1**2*bdd1*f**2*s - 2*C*D1**2*bdd1*f**2 + 102*C*D1**2*f**2*fd*r*s - 34*C*D1**2*f**2*fd*r + 102*C*D1**2*f**2*fd*s**2 - 102*C*D1**2*f**2*fd*s + 34*C*D1**2*f**2*fd - 60*C*D1**2*f**2*fdd*r*s + 20*C*D1**2*f**2*fdd*r - 60*C*D1**2*f**2*fdd*s**2 + 60*C*D1**2*f**2*fdd*s - 20*C*D1**2*f**2*fdd - 120*C*D1**2*f*fd**2*r*s + 40*C*D1**2*f*fd**2*r - 120*C*D1**2*f*fd**2*s**2 + 120*C*D1**2*f*fd**2*s - 20*C*D1**2*f*fd**2 + 136*C*D1*Dd*f**3*r*s - 34*C*D1*Dd*f**3*r + 136*C*D1*Dd*f**3*s**2 - 136*C*D1*Dd*f**3*s + 34*C*D1*Dd*f**3 - 480*C*D1*Dd*f**2*fd*r*s + 140*C*D1*Dd*f**2*fd*r - 480*C*D1*Dd*f**2*fd*s**2 + 480*C*D1*Dd*f**2*fd*s - 100*C*D1*Dd*f**2*fd - 80*C*D1*Ddd*f**3*r*s + 20*C*D1*Ddd*f**3*r - 80*C*D1*Ddd*f**3*s**2 + 80*C*D1*Ddd*f**3*s - 20*C*D1*Ddd*f**3 - 240*C*Dd**2*f**3*r*s + 60*C*Dd**2*f**3*r - 240*C*Dd**2*f**3*s**2 + 240*C*Dd**2*f**3*s - 40*C*Dd**2*f**3 - 30*D1**2*K*bdd1*f**2*r*s - 30*D1**2*K*bdd1*f**2*s**2 + 30*D1**2*K*bdd1*f**2*s - 7*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 15*D1**2*bdd1*f**3*r*s + 5*D1**2*bdd1*f**3*r + 15*D1**2*bdd1*f**3*s**2 - 10*D1**2*bdd1*f**3*s - 5*D1**2*bdd1*f**3 + 17*D1**2*bdd1*f**2*r*s - 2*D1**2*bdd1*f**2*r + 17*D1**2*bdd1*f**2*s**2 - 19*D1**2*bdd1*f**2*s + 2*D1**2*bdd1*f**2 + 14*D1**2*bdd1*f*g2*r*s - 14*D1**2*bdd1*f*g2*r + 14*D1**2*bdd1*f*g2*s**2 - 28*D1**2*bdd1*f*g2*s + 14*D1**2*bdd1*f*g2 - 20*D1**2*f**3*fd*r*s + 5*D1**2*f**3*fd*r - 20*D1**2*f**3*fd*s**2 + 20*D1**2*f**3*fd*s - 5*D1**2*f**3*fd - 75*D1**2*f**2*fd*r*s + 25*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 75*D1**2*f**2*fd*s - 25*D1**2*f**2*fd + 45*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 45*D1**2*f**2*fdd*s + 15*D1**2*f**2*fdd - 78*D1**2*f**2*gd2*r*s - 78*D1**2*f**2*gd2*s**2 + 78*D1**2*f**2*gd2*s + 60*D1**2*f**2*gdd2*r*s + 60*D1**2*f**2*gdd2*s**2 - 60*D1**2*f**2*gdd2*s + 90*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 90*D1**2*f*fd**2*s + 15*D1**2*f*fd**2 - 156*D1**2*f*fd*g2*r*s + 78*D1**2*f*fd*g2*r - 156*D1**2*f*fd*g2*s**2 + 156*D1**2*f*fd*g2*s - 78*D1**2*f*fd*g2 + 240*D1**2*f*fd*gd2*r*s - 60*D1**2*f*fd*gd2*r + 240*D1**2*f*fd*gd2*s**2 - 240*D1**2*f*fd*gd2*s + 60*D1**2*f*fd*gd2 + 120*D1**2*f*fdd*g2*r*s - 60*D1**2*f*fdd*g2*r + 120*D1**2*f*fdd*g2*s**2 - 120*D1**2*f*fdd*g2*s + 60*D1**2*f*fdd*g2 + 120*D1**2*fd**2*g2*r*s - 60*D1**2*fd**2*g2*r + 120*D1**2*fd**2*g2*s**2 - 120*D1**2*fd**2*g2*s - 20*D1*Dd*f**4*r*s + 5*D1*Dd*f**4*r - 20*D1*Dd*f**4*s**2 + 20*D1*Dd*f**4*s - 5*D1*Dd*f**4 - 100*D1*Dd*f**3*r*s + 25*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 100*D1*Dd*f**3*s - 25*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*r*s - 105*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 360*D1*Dd*f**2*fd*s + 75*D1*Dd*f**2*fd - 312*D1*Dd*f**2*g2*r*s + 78*D1*Dd*f**2*g2*r - 312*D1*Dd*f**2*g2*s**2 + 312*D1*Dd*f**2*g2*s - 78*D1*Dd*f**2*g2 + 480*D1*Dd*f**2*gd2*r*s - 60*D1*Dd*f**2*gd2*r + 480*D1*Dd*f**2*gd2*s**2 - 480*D1*Dd*f**2*gd2*s + 60*D1*Dd*f**2*gd2 + 960*D1*Dd*f*fd*g2*r*s - 360*D1*Dd*f*fd*g2*r + 960*D1*Dd*f*fd*g2*s**2 - 960*D1*Dd*f*fd*g2*s + 240*D1*Dd*f*fd*g2 + 60*D1*Ddd*f**3*r*s - 15*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 240*D1*Ddd*f**2*g2*r*s - 60*D1*Ddd*f**2*g2*r + 240*D1*Ddd*f**2*g2*s**2 - 240*D1*Ddd*f**2*g2*s + 60*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(5*s + 2)*(r + s - 1) + f**2*(4*C*(s - 1)*(r + s - 1) + 5*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + (r + s - 1)*(39*K*s - 20*s + 4)) + f*(fd*(-2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 30*K*(r*(4*s - 1) + (1 - 2*s)**2) + 68*r*s - 19*r + 68*s**2 - 70*s + 17) + (-14*r - 14*s + 14)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 14*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(5*f**2*(24*r*s + r + 4*s*(6*s - 5)) + f*(-2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 30*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 136*r*s - 25*r + 136*s**2 - 144*s + 23) + 14*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 180*Dd**2*f**3*r*s - 45*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 30*Dd**2*f**3 + 720*Dd**2*f**2*g2*r*s - 180*Dd**2*f**2*g2*r + 720*Dd**2*f**2*g2*s**2 - 720*Dd**2*f**2*g2*s + 120*Dd**2*f**2*g2 + 7*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(8*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*s**2 - 4*C*D1**2*f*fd*s - 4*C*D1**2*f*fdd*r*s - 4*C*D1**2*f*fdd*s**2 + 2*C*D1**2*f*fdd*s - 4*C*D1**2*fd**2*r*s - 4*C*D1**2*fd**2*s**2 + 2*C*D1**2*fd**2*s + 16*C*D1*Dd*f**2*r*s - 4*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 16*C*D1*Dd*f**2*s + 4*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r*s + 4*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 24*C*D1*Dd*f*fd*s - 2*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r*s + 2*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 8*C*D1*Ddd*f**2*s - 2*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r*s + 6*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 24*C*Dd**2*f**2*s - 4*C*Dd**2*f**2 + 78*D1**2*K*f*fd*r*s - 39*D1**2*K*f*fd*r + 78*D1**2*K*f*fd*s**2 - 78*D1**2*K*f*fd*s + 39*D1**2*K*f*fd - 60*D1**2*K*f*fdd*r*s + 30*D1**2*K*f*fdd*r - 60*D1**2*K*f*fdd*s**2 + 60*D1**2*K*f*fdd*s - 30*D1**2*K*f*fdd - 60*D1**2*K*fd**2*r*s + 30*D1**2*K*fd**2*r - 60*D1**2*K*fd**2*s**2 + 60*D1**2*K*fd**2*s - 7*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 75*D1**2*f**2*fd*r*s + 35*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 85*D1**2*f**2*fd*s - 35*D1**2*f**2*fd + 45*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 50*D1**2*f**2*fdd*s + 20*D1**2*f**2*fdd + 90*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 100*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 - 40*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 40*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 16*D1**2*f*fd + 34*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r + 34*D1**2*f*fdd*s**2 - 32*D1**2*f*fdd*s + 15*D1**2*f*fdd - 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*s**2 + 28*D1**2*f*gd2*s + 14*D1**2*f*gdd2*r*s + 14*D1**2*f*gdd2*s**2 - 14*D1**2*f*gdd2*s + 34*D1**2*fd**2*r*s - 15*D1**2*fd**2*r + 34*D1**2*fd**2*s**2 - 32*D1**2*fd**2*s - 28*D1**2*fd*g2*r*s - 28*D1**2*fd*g2*s**2 + 28*D1**2*fd*gd2*r*s + 28*D1**2*fd*gd2*s**2 - 14*D1**2*fd*gd2*s + 14*D1**2*fdd*g2*r*s + 14*D1**2*fdd*g2*s**2 + 156*D1*Dd*K*f**2*r*s - 39*D1*Dd*K*f**2*r + 156*D1*Dd*K*f**2*s**2 - 156*D1*Dd*K*f**2*s + 39*D1*Dd*K*f**2 - 480*D1*Dd*K*f*fd*r*s + 180*D1*Dd*K*f*fd*r - 480*D1*Dd*K*f*fd*s**2 + 480*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd - 100*D1*Dd*f**3*r*s + 25*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 100*D1*Dd*f**3*s - 25*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*r*s - 125*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 380*D1*Dd*f**2*fd*s + 90*D1*Dd*f**2*fd - 80*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r - 80*D1*Dd*f**2*s**2 + 80*D1*Dd*f**2*s - 20*D1*Dd*f**2 + 272*D1*Dd*f*fd*r*s - 94*D1*Dd*f*fd*r + 272*D1*Dd*f*fd*s**2 - 264*D1*Dd*f*fd*s + 62*D1*Dd*f*fd - 112*D1*Dd*f*g2*r*s + 28*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 112*D1*Dd*f*g2*s - 28*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r*s - 14*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 112*D1*Dd*f*gd2*s + 14*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r*s - 14*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 56*D1*Dd*fd*g2*s - 120*D1*Ddd*K*f**2*r*s + 30*D1*Ddd*K*f**2*r - 120*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 30*D1*Ddd*K*f**2 + 60*D1*Ddd*f**3*r*s - 15*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 68*D1*Ddd*f**2*r*s - 17*D1*Ddd*f**2*r + 68*D1*Ddd*f**2*s**2 - 68*D1*Ddd*f**2*s + 17*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r*s - 14*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 56*D1*Ddd*f*g2*s + 14*D1*Ddd*f*g2 + 7*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 360*Dd**2*K*f**2*r*s + 90*Dd**2*K*f**2*r - 360*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 60*Dd**2*K*f**2 + 180*Dd**2*f**3*r*s - 45*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 30*Dd**2*f**3 + 204*Dd**2*f**2*r*s - 51*Dd**2*f**2*r + 204*Dd**2*f**2*s**2 - 204*Dd**2*f**2*s + 34*Dd**2*f**2 + 168*Dd**2*f*g2*r*s - 42*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 168*Dd**2*f*g2*s + 28*Dd**2*f*g2))/(35*d**2*k3**6) - 4*D1**2*Pk3*Pkd2*ct**2*k1**2*k2**3*st**2*(-9*D1**2*bd1**2*f*(2*s - 1)*(-14*K + 8*f + 7)*(r + s - 1) + 9*D1**2*bdd1*f*(3*f*(4*C*(s - 1) + 2*K*s - 3*s + 3) - 28*g2*(s - 1))*(r + s - 1) - 6*D1**2*(f**2*(fd*(2*C + 2)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(6*gd2 + 18*gdd2)*(r + s - 1)) + f*(-fd**2*(10*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*fd*(g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) + 18*fdd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 18*fd**2*g2*(r*(2*s - 1) + s*(2*s - 2))) + D1*bd1*(D1*(-18*f**3*(2*s + 1)*(r + s - 1) - f**2*(r + s - 1)*(174*C*(s - 1) - s*(18*K + 85) + 127) + 3*f*(9*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 6*r - 12*s**2 + 15*s - 3) + (98*g2*(s - 1) + 84*gd2*(1 - 2*s))*(r + s - 1)) - 252*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 9*Dd*f*(3*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 6*D1*f*(Dd*(f**2*(2*C + 2)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(5 - 10*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 6*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 18*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 36*fd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(f*(10*C - 5) - 18*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*Dd**2*f**2*(f*(10*C - 5) - 18*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + b1**2*(D1**2*s*(3*f*(41*fd - 24*fdd)*(2*r + 2*s - 1) - 72*fd**2*(2*r + 2*s - 1) - 7*fd*(21*K - 8)*(r + s) + 63*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(123*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-72*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (56 - 147*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 63*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 8*f + 7)) - 9*Dd**2*f*(-14*K + 8*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-348*C*D1**2*f*fd*r*s - 348*C*D1**2*f*fd*s**2 + 174*C*D1**2*f*fd*s + 216*C*D1**2*f*fdd*r*s + 216*C*D1**2*f*fdd*s**2 - 108*C*D1**2*f*fdd*s + 216*C*D1**2*fd**2*r*s + 216*C*D1**2*fd**2*s**2 - 108*C*D1**2*fd**2*s - 696*C*D1*Dd*f**2*r*s + 174*C*D1*Dd*f**2*r - 696*C*D1*Dd*f**2*s**2 + 696*C*D1*Dd*f**2*s - 174*C*D1*Dd*f**2 + 1728*C*D1*Dd*f*fd*r*s - 216*C*D1*Dd*f*fd*r + 1728*C*D1*Dd*f*fd*s**2 - 1296*C*D1*Dd*f*fd*s + 108*C*D1*Dd*f*fd + 432*C*D1*Ddd*f**2*r*s - 108*C*D1*Ddd*f**2*r + 432*C*D1*Ddd*f**2*s**2 - 432*C*D1*Ddd*f**2*s + 108*C*D1*Ddd*f**2 + 1296*C*Dd**2*f**2*r*s - 324*C*Dd**2*f**2*r + 1296*C*Dd**2*f**2*s**2 - 1296*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 + 36*D1**2*K*f*fd*r*s - 18*D1**2*K*f*fd*r + 36*D1**2*K*f*fd*s**2 - 36*D1**2*K*f*fd*s + 18*D1**2*K*f*fd + 108*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r + 108*D1**2*K*f*fdd*s**2 - 108*D1**2*K*f*fdd*s + 54*D1**2*K*f*fdd + 108*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r + 108*D1**2*K*fd**2*s**2 - 108*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*s - 1)*(-14*K + 8*f + 7)*(r + s - 1) - 108*D1**2*f**2*fd*r*s + 54*D1**2*f**2*fd*r - 108*D1**2*f**2*fd*s**2 + 126*D1**2*f**2*fd*s - 54*D1**2*f**2*fd + 170*D1**2*f*fd*r*s + 42*D1**2*f*fd*r + 170*D1**2*f*fd*s**2 - 43*D1**2*f*fd*s - 42*D1**2*f*fd - 162*D1**2*f*fdd*r*s - 162*D1**2*f*fdd*s**2 + 81*D1**2*f*fdd*s + 294*D1**2*f*gd2*r*s + 294*D1**2*f*gd2*s**2 - 294*D1**2*f*gd2*s - 252*D1**2*f*gdd2*r*s - 252*D1**2*f*gdd2*s**2 + 252*D1**2*f*gdd2*s - 162*D1**2*fd**2*r*s - 162*D1**2*fd**2*s**2 + 81*D1**2*fd**2*s + 294*D1**2*fd*g2*r*s + 294*D1**2*fd*g2*s**2 - 504*D1**2*fd*gd2*r*s - 504*D1**2*fd*gd2*s**2 + 252*D1**2*fd*gd2*s - 252*D1**2*fdd*g2*r*s - 252*D1**2*fdd*g2*s**2 + 72*D1*Dd*K*f**2*r*s - 18*D1*Dd*K*f**2*r + 72*D1*Dd*K*f**2*s**2 - 72*D1*Dd*K*f**2*s + 18*D1*Dd*K*f**2 + 864*D1*Dd*K*f*fd*r*s - 324*D1*Dd*K*f*fd*r + 864*D1*Dd*K*f*fd*s**2 - 864*D1*Dd*K*f*fd*s + 216*D1*Dd*K*f*fd - 144*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 144*D1*Dd*f**3*s**2 + 144*D1*Dd*f**3*s - 36*D1*Dd*f**3 + 340*D1*Dd*f**2*r*s - 85*D1*Dd*f**2*r + 340*D1*Dd*f**2*s**2 - 340*D1*Dd*f**2*s + 85*D1*Dd*f**2 - 1296*D1*Dd*f*fd*r*s + 162*D1*Dd*f*fd*r - 1296*D1*Dd*f*fd*s**2 + 972*D1*Dd*f*fd*s - 81*D1*Dd*f*fd + 1176*D1*Dd*f*g2*r*s - 294*D1*Dd*f*g2*r + 1176*D1*Dd*f*g2*s**2 - 1176*D1*Dd*f*g2*s + 294*D1*Dd*f*g2 - 2016*D1*Dd*f*gd2*r*s + 252*D1*Dd*f*gd2*r - 2016*D1*Dd*f*gd2*s**2 + 2016*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 2016*D1*Dd*fd*g2*r*s + 252*D1*Dd*fd*g2*r - 2016*D1*Dd*fd*g2*s**2 + 1008*D1*Dd*fd*g2*s + 216*D1*Ddd*K*f**2*r*s - 54*D1*Ddd*K*f**2*r + 216*D1*Ddd*K*f**2*s**2 - 216*D1*Ddd*K*f**2*s + 54*D1*Ddd*K*f**2 - 324*D1*Ddd*f**2*r*s + 81*D1*Ddd*f**2*r - 324*D1*Ddd*f**2*s**2 + 324*D1*Ddd*f**2*s - 81*D1*Ddd*f**2 - 1008*D1*Ddd*f*g2*r*s + 252*D1*Ddd*f*g2*r - 1008*D1*Ddd*f*g2*s**2 + 1008*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + D1*bd1*(D1*(123*f**2*(2*s - 1)*(r + s - 1) + f*(-72*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + (56 - 147*K)*(2*s - 1)*(r + s - 1)) + 63*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 9*Dd*f*(-14*K + 8*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 648*Dd**2*K*f**2*r*s - 162*Dd**2*K*f**2*r + 648*Dd**2*K*f**2*s**2 - 648*Dd**2*K*f**2*s + 108*Dd**2*K*f**2 - 972*Dd**2*f**2*r*s + 243*Dd**2*f**2*r - 972*Dd**2*f**2*s**2 + 972*Dd**2*f**2*s - 162*Dd**2*f**2 - 3024*Dd**2*f*g2*r*s + 756*Dd**2*f*g2*r - 3024*Dd**2*f*g2*s**2 + 3024*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(105*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**2*k1**2*k2**3*(-3*D1*(21*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + bd1*(D1*(f**2*(r + s - 1)*(24*C*(s - 1) + s*(7*K - 26) + 26) + f*(fd*(30*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (4*g2*(s - 1) + 3*gd2*(2*s - 1))*(-14*r - 14*s + 14)) + 42*fd*g2*(-2*r*s + r - s*(2*s - 2))) + 3*Dd*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + f*(3*D1*bdd1*(s - 1)*(f*(10*C - 5) - 14*g2)*(r + s - 1) + D1*(f*(fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 14*gd2*s*(r + s - 1)) - 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b1**2*(D1**2*s*(9*f*fd*(2*r + 2*s - 1) - (r + s)*(9*K*fdd + 2*fd*(6*K - 5))) + D1*(Dd*(9*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 9*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(6*K - 5)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*(21*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(7*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(24*C - 26)*(2*r + 2*s - 1) + fdd*s*(30*C - 15)*(2*r + 2*s - 1) + s*(-56*gd2 - 42*gdd2)*(r + s - 1)) + s*(fd**2*(30*C - 15)*(2*r + 2*s - 1) - 14*fd*(4*g2*(r + s) + gd2*(6*r + 6*s - 3)) - 42*fdd*g2*(r + s))) + 7*D1*bd1*(D1*(9*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 9*f**2*(2*s - 1)*(r + s - 1) - 2*f*(6*K - 5)*(2*s - 1)*(r + s - 1)) - 9*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*D1*(Dd*(f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(24*C + 7*K - 26) + f*(fd*(30*C - 15)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 56*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 42*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 42*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 3*Ddd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f*(f*(10*C - 5) - 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**2*k1**2*k2*st**6*(D1**2*(84*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-504*fd**2*s*(2*s - 1) + fd*(44*C - 44)*(3*s**2 - 2*s + 1) - fdd*(22*C - 22)*(3*s**2 - 2*s + 1) + s**2*(-99*K*bdd1 + 198*bd1*(K - 1) + 99*bdd1 - 396*gd2 + 198*gdd2)) - 22*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) + 396*fd**2*g2*s*(s - 1)) + 2*D1*f*(Dd*(84*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(11*C*(4*s**2 - 2*s + 1) - 42*fd*(1 - 4*s)**2 - 44*s**2 + 22*s - 11) - 11*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(42*f**2 + f*(11*C - 11) - 99*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(2*s - 1)*(42*f**2 + f*(11*C - 11) - 99*g2) + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**2*k1**2*k2*st**4*(24*C*D1**2*bdd1*f**2*r*s + 54*C*D1**2*bdd1*f**2*s**2 - 60*C*D1**2*bdd1*f**2*s + 30*C*D1**2*bdd1*f**2 + 600*C*D1**2*f**2*fd*r*s - 200*C*D1**2*f**2*fd*r - 744*C*D1**2*f**2*fd*s**2 + 296*C*D1**2*f**2*fd*s - 248*C*D1**2*f**2*fd - 408*C*D1**2*f**2*fdd*r*s + 136*C*D1**2*f**2*fdd*r + 318*C*D1**2*f**2*fdd*s**2 - 76*C*D1**2*f**2*fdd*s + 106*C*D1**2*f**2*fdd - 816*C*D1**2*f*fd**2*r*s + 272*C*D1**2*f*fd**2*r + 636*C*D1**2*f*fd**2*s**2 - 152*C*D1**2*f*fd**2*s - 136*C*D1**2*f*fd**2 + 800*C*D1*Dd*f**3*r*s - 200*C*D1*Dd*f**3*r - 992*C*D1*Dd*f**3*s**2 + 96*C*D1*Dd*f**3*s - 248*C*D1*Dd*f**3 - 3264*C*D1*Dd*f**2*fd*r*s + 952*C*D1*Dd*f**2*fd*r + 2544*C*D1*Dd*f**2*fd*s**2 - 124*C*D1*Dd*f**2*fd*s - 196*C*D1*Dd*f**2*fd - 544*C*D1*Ddd*f**3*r*s + 136*C*D1*Ddd*f**3*r + 424*C*D1*Ddd*f**3*s**2 + 60*C*D1*Ddd*f**3*s + 106*C*D1*Ddd*f**3 - 1632*C*Dd**2*f**3*r*s + 408*C*Dd**2*f**3*r + 1272*C*Dd**2*f**3*s**2 + 180*C*Dd**2*f**3*s - 272*C*Dd**2*f**3 - 204*D1**2*K*bdd1*f**2*r*s + 51*D1**2*K*bdd1*f**2*s**2 + 204*D1**2*K*bdd1*f**2*s + 42*D1**2*bd1**2*f*s*(K - 1)*(4*r + 9*s - 7) + 240*D1**2*bdd1*f**3*r*s + 90*D1**2*bdd1*f**3*s**2 - 330*D1**2*bdd1*f**3*s + 75*D1**2*bdd1*f**3 + 360*D1**2*bdd1*f**2*r*s + 225*D1**2*bdd1*f**2*s**2 - 324*D1**2*bdd1*f**2*s - 30*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r*s - 378*D1**2*bdd1*f*g2*s**2 + 420*D1**2*bdd1*f*g2*s - 210*D1**2*bdd1*f*g2 + 1080*D1**2*f**3*fd*r*s - 270*D1**2*f**3*fd*r + 1200*D1**2*f**3*fd*s**2 - 1140*D1**2*f**3*fd*s + 300*D1**2*f**3*fd - 1080*D1**2*f**3*fdd*r*s + 270*D1**2*f**3*fdd*r - 780*D1**2*f**3*fdd*s**2 + 930*D1**2*f**3*fdd*s - 195*D1**2*f**3*fdd - 3240*D1**2*f**2*fd**2*r*s + 810*D1**2*f**2*fd**2*r - 2340*D1**2*f**2*fd**2*s**2 + 2790*D1**2*f**2*fd**2*s - 540*D1**2*f**2*fd**2 - 924*D1**2*f**2*fd*r*s + 308*D1**2*f**2*fd*r + 120*D1**2*f**2*fd*s**2 + 228*D1**2*f**2*fd*s + 40*D1**2*f**2*fd + 588*D1**2*f**2*fdd*r*s - 196*D1**2*f**2*fdd*r + 12*D1**2*f**2*fdd*s**2 - 204*D1**2*f**2*fdd*s + 4*D1**2*f**2*fdd - 648*D1**2*f**2*gd2*r*s + 456*D1**2*f**2*gd2*s**2 + 648*D1**2*f**2*gd2*s + 408*D1**2*f**2*gdd2*r*s - 102*D1**2*f**2*gdd2*s**2 - 408*D1**2*f**2*gdd2*s + 1176*D1**2*f*fd**2*r*s - 392*D1**2*f*fd**2*r + 24*D1**2*f*fd**2*s**2 - 408*D1**2*f*fd**2*s + 196*D1**2*f*fd**2 - 1296*D1**2*f*fd*g2*r*s + 648*D1**2*f*fd*g2*r + 912*D1**2*f*fd*g2*s**2 - 912*D1**2*f*fd*g2*s + 456*D1**2*f*fd*g2 + 1632*D1**2*f*fd*gd2*r*s - 408*D1**2*f*fd*gd2*r - 408*D1**2*f*fd*gd2*s**2 - 612*D1**2*f*fd*gd2*s + 408*D1**2*f*fd*gd2 + 816*D1**2*f*fdd*g2*r*s - 408*D1**2*f*fdd*g2*r - 204*D1**2*f*fdd*g2*s**2 + 204*D1**2*f*fdd*g2*s - 102*D1**2*f*fdd*g2 + 816*D1**2*fd**2*g2*r*s - 408*D1**2*fd**2*g2*r - 204*D1**2*fd**2*g2*s**2 + 204*D1**2*fd**2*g2*s + 1080*D1*Dd*f**4*r*s - 270*D1*Dd*f**4*r + 1200*D1*Dd*f**4*s**2 - 1140*D1*Dd*f**4*s + 300*D1*Dd*f**4 - 8640*D1*Dd*f**3*fd*r*s + 2160*D1*Dd*f**3*fd*r - 6240*D1*Dd*f**3*fd*s**2 + 7440*D1*Dd*f**3*fd*s - 1470*D1*Dd*f**3*fd - 1232*D1*Dd*f**3*r*s + 308*D1*Dd*f**3*r + 160*D1*Dd*f**3*s**2 + 536*D1*Dd*f**3*s + 40*D1*Dd*f**3 + 4704*D1*Dd*f**2*fd*r*s - 1372*D1*Dd*f**2*fd*r + 96*D1*Dd*f**2*fd*s**2 - 2016*D1*Dd*f**2*fd*s + 596*D1*Dd*f**2*fd - 2592*D1*Dd*f**2*g2*r*s + 648*D1*Dd*f**2*g2*r + 1824*D1*Dd*f**2*g2*s**2 + 384*D1*Dd*f**2*g2*s + 456*D1*Dd*f**2*g2 + 3264*D1*Dd*f**2*gd2*r*s - 408*D1*Dd*f**2*gd2*r - 816*D1*Dd*f**2*gd2*s**2 - 2244*D1*Dd*f**2*gd2*s + 408*D1*Dd*f**2*gd2 + 6528*D1*Dd*f*fd*g2*r*s - 2448*D1*Dd*f*fd*g2*r - 1632*D1*Dd*f*fd*g2*s**2 - 408*D1*Dd*f*fd*g2*s + 612*D1*Dd*f*fd*g2 - 1080*D1*Ddd*f**4*r*s + 270*D1*Ddd*f**4*r - 780*D1*Ddd*f**4*s**2 + 930*D1*Ddd*f**4*s - 195*D1*Ddd*f**4 + 784*D1*Ddd*f**3*r*s - 196*D1*Ddd*f**3*r + 16*D1*Ddd*f**3*s**2 - 400*D1*Ddd*f**3*s + 4*D1*Ddd*f**3 + 1632*D1*Ddd*f**2*g2*r*s - 408*D1*Ddd*f**2*g2*r - 408*D1*Ddd*f**2*g2*s**2 - 612*D1*Ddd*f**2*g2*s - 102*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(5*f**3*(4*s**2 + s*(14*r - 20) + 5) + 2*f**2*(C*(9*s**2 + s*(4*r - 10) + 5) - 27*K*r*s + 19*K*s**2 + 27*K*s - 5*fd*(24*r*s - 4*r + 9*s**2 - 22*s + 3) + 46*r*s + 20*s**2 - 40*s - 5) + f*(fd*(-36*C*s**2 + 32*C*s + 17*K*(r*(8*s - 2) - 2*s**2 - 3*s + 2) - r*(4*C + 60)*(4*s - 1) - 150*s**2 + 189*s - 64) - 14*g2*(9*s**2 + s*(4*r - 10) + 5) - 14*gd2*s*(-4*r - 9*s + 7)) + 14*fd*g2*(r*(4*s - 2) + s*(9*s - 9))) - Dd*f*(5*f**2*(8*r*(8*s - 1) + 24*s**2 - 66*s + 11) + f*(2*C*(2*r*(8*s - 1) + 36*s**2 - 33*s + 5) + 17*K*(r*(2 - 16*s) + 4*s**2 + 11*s - 2) + 480*r*s - 60*r + 300*s**2 - 411*s + 54) - 14*g2*(2*r*(8*s - 1) + 36*s**2 - 33*s + 5))) - 3240*Dd**2*f**4*r*s + 810*Dd**2*f**4*r - 2340*Dd**2*f**4*s**2 + 2790*Dd**2*f**4*s - 540*Dd**2*f**4 + 2352*Dd**2*f**3*r*s - 588*Dd**2*f**3*r + 48*Dd**2*f**3*s**2 - 1200*Dd**2*f**3*s + 392*Dd**2*f**3 + 4896*Dd**2*f**2*g2*r*s - 1224*Dd**2*f**2*g2*r - 1224*Dd**2*f**2*g2*s**2 - 1836*Dd**2*f**2*g2*s + 816*Dd**2*f**2*g2 - 21*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(4*r*(s - 1) + 9*s**2 - 8*s + 4) + D1*(2*Dd*(f*(16*r*s - 4*r + 36*s**2 - 26*s + 9) + fd*(-16*r*s + 10*r - 36*s**2 + 29*s - 8)) + Ddd*f*(r*(4 - 16*s) - 36*s**2 + 26*s - 9)) - 2*Dd**2*f*(6*r*(4*s - 1) + 54*s**2 - 39*s + 4)) - 3*b1*(32*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s**2 - 48*C*D1**2*f*fd*s + 16*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*r - 36*C*D1**2*f*fdd*s**2 + 24*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*r - 36*C*D1**2*fd**2*s**2 + 24*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 + 64*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*r + 144*C*D1*Dd*f**2*s**2 - 104*C*D1*Dd*f**2*s + 36*C*D1*Dd*f**2 - 128*C*D1*Dd*f*fd*r*s + 48*C*D1*Dd*f*fd*r - 288*C*D1*Dd*f*fd*s**2 + 200*C*D1*Dd*f*fd*s - 40*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r*s + 8*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 52*C*D1*Ddd*f**2*s - 18*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r*s + 24*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 156*C*Dd**2*f**2*s - 16*C*Dd**2*f**2 - 216*D1**2*K*f*fd*r*s + 108*D1**2*K*f*fd*r + 152*D1**2*K*f*fd*s**2 - 152*D1**2*K*f*fd*s + 76*D1**2*K*f*fd + 136*D1**2*K*f*fdd*r*s - 68*D1**2*K*f*fdd*r - 34*D1**2*K*f*fdd*s**2 + 34*D1**2*K*f*fdd*s - 17*D1**2*K*f*fdd + 136*D1**2*K*fd**2*r*s - 68*D1**2*K*fd**2*r - 34*D1**2*K*fd**2*s**2 + 34*D1**2*K*fd**2*s - 7*D1**2*bdd1*f*(K - 1)*(8*r*s + 18*s**2 - 14*s + 5) + 420*D1**2*f**2*fd*r*s - 140*D1**2*f**2*fd*r + 120*D1**2*f**2*fd*s**2 - 160*D1**2*f**2*fd*s - 10*D1**2*f**2*fd - 240*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 90*D1**2*f**2*fdd*s**2 + 110*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd - 480*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 180*D1**2*f*fd**2*s**2 + 220*D1**2*f*fd**2*s - 100*D1**2*f*fd**2 + 368*D1**2*f*fd*r*s - 184*D1**2*f*fd*r + 160*D1**2*f*fd*s**2 - 184*D1**2*f*fd*s + 100*D1**2*f*fd - 240*D1**2*f*fdd*r*s + 120*D1**2*f*fdd*r - 150*D1**2*f*fdd*s**2 + 162*D1**2*f*fdd*s - 85*D1**2*f*fdd - 112*D1**2*f*gd2*r*s - 252*D1**2*f*gd2*s**2 + 112*D1**2*f*gd2*s + 56*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*s**2 - 56*D1**2*f*gdd2*s - 240*D1**2*fd**2*r*s + 120*D1**2*fd**2*r - 150*D1**2*fd**2*s**2 + 162*D1**2*fd**2*s + 8*D1**2*fd**2 - 112*D1**2*fd*g2*r*s + 112*D1**2*fd*g2*r - 252*D1**2*fd*g2*s**2 + 224*D1**2*fd*g2*s - 112*D1**2*fd*g2 + 112*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*r + 252*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 + 56*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r + 126*D1**2*fdd*g2*s**2 - 112*D1**2*fdd*g2*s + 56*D1**2*fdd*g2 - 432*D1*Dd*K*f**2*r*s + 108*D1*Dd*K*f**2*r + 304*D1*Dd*K*f**2*s**2 + 64*D1*Dd*K*f**2*s + 76*D1*Dd*K*f**2 + 1088*D1*Dd*K*f*fd*r*s - 408*D1*Dd*K*f*fd*r - 272*D1*Dd*K*f*fd*s**2 - 68*D1*Dd*K*f*fd*s + 102*D1*Dd*K*f*fd + 560*D1*Dd*f**3*r*s - 140*D1*Dd*f**3*r + 160*D1*Dd*f**3*s**2 - 360*D1*Dd*f**3*s + 40*D1*Dd*f**3 - 1920*D1*Dd*f**2*fd*r*s + 560*D1*Dd*f**2*fd*r - 720*D1*Dd*f**2*fd*s**2 + 1100*D1*Dd*f**2*fd*s - 270*D1*Dd*f**2*fd + 736*D1*Dd*f**2*r*s - 184*D1*Dd*f**2*r + 320*D1*Dd*f**2*s**2 - 528*D1*Dd*f**2*s + 80*D1*Dd*f**2 - 1920*D1*Dd*f*fd*r*s + 720*D1*Dd*f*fd*r - 1200*D1*Dd*f*fd*s**2 + 1428*D1*Dd*f*fd*s - 402*D1*Dd*f*fd - 448*D1*Dd*f*g2*r*s + 112*D1*Dd*f*g2*r - 1008*D1*Dd*f*g2*s**2 + 728*D1*Dd*f*g2*s - 252*D1*Dd*f*g2 + 448*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r + 1008*D1*Dd*f*gd2*s**2 - 588*D1*Dd*f*gd2*s + 56*D1*Dd*f*gd2 + 448*D1*Dd*fd*g2*r*s - 280*D1*Dd*fd*g2*r + 1008*D1*Dd*fd*g2*s**2 - 812*D1*Dd*fd*g2*s + 224*D1*Dd*fd*g2 + 272*D1*Ddd*K*f**2*r*s - 68*D1*Ddd*K*f**2*r - 68*D1*Ddd*K*f**2*s**2 - 102*D1*Ddd*K*f**2*s - 17*D1*Ddd*K*f**2 - 320*D1*Ddd*f**3*r*s + 80*D1*Ddd*f**3*r - 120*D1*Ddd*f**3*s**2 + 220*D1*Ddd*f**3*s - 30*D1*Ddd*f**3 - 480*D1*Ddd*f**2*r*s + 120*D1*Ddd*f**2*r - 300*D1*Ddd*f**2*s**2 + 390*D1*Ddd*f**2*s - 75*D1*Ddd*f**2 + 224*D1*Ddd*f*g2*r*s - 56*D1*Ddd*f*g2*r + 504*D1*Ddd*f*g2*s**2 - 364*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 + 14*D1*bd1*(K - 1)*(D1*(f*(8*r*s + 18*s**2 - 14*s + 5) + fd*(-8*r*s + 4*r - 18*s**2 + 15*s - 2)) + Dd*f*(r*(4 - 32*s) - 72*s**2 + 54*s - 7)) + 816*Dd**2*K*f**2*r*s - 204*Dd**2*K*f**2*r - 204*Dd**2*K*f**2*s**2 - 306*Dd**2*K*f**2*s + 136*Dd**2*K*f**2 - 960*Dd**2*f**3*r*s + 240*Dd**2*f**3*r - 360*Dd**2*f**3*s**2 + 660*Dd**2*f**3*s - 160*Dd**2*f**3 - 1440*Dd**2*f**2*r*s + 360*Dd**2*f**2*r - 900*Dd**2*f**2*s**2 + 1170*Dd**2*f**2*s - 240*Dd**2*f**2 + 672*Dd**2*f*g2*r*s - 168*Dd**2*f*g2*r + 1512*Dd**2*f*g2*s**2 - 1092*Dd**2*f*g2*s + 112*Dd**2*f*g2))/(210*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**2*k1**2*k2*st**2*(1584*C*D1**2*f**2*fd*r*s - 528*C*D1**2*f**2*fd*r + 3576*C*D1**2*f**2*fd*s**2 - 2912*C*D1**2*f**2*fd*s + 1192*C*D1**2*f**2*fd - 1584*C*D1**2*f**2*fdd*r*s + 528*C*D1**2*f**2*fdd*r - 2652*C*D1**2*f**2*fdd*s**2 + 2296*C*D1**2*f**2*fdd*s - 884*C*D1**2*f**2*fdd - 3168*C*D1**2*f*fd**2*r*s + 1056*C*D1**2*f*fd**2*r - 5304*C*D1**2*f*fd**2*s**2 + 4592*C*D1**2*f*fd**2*s - 528*C*D1**2*f*fd**2 + 2112*C*D1*Dd*f**3*r*s - 528*C*D1*Dd*f**3*r + 4768*C*D1*Dd*f**3*s**2 - 3440*C*D1*Dd*f**3*s + 1192*C*D1*Dd*f**3 - 12672*C*D1*Dd*f**2*fd*r*s + 3696*C*D1*Dd*f**2*fd*r - 21216*C*D1*Dd*f**2*fd*s**2 + 17656*C*D1*Dd*f**2*fd*s - 3352*C*D1*Dd*f**2*fd - 2112*C*D1*Ddd*f**3*r*s + 528*C*D1*Ddd*f**3*r - 3536*C*D1*Ddd*f**3*s**2 + 2824*C*D1*Ddd*f**3*s - 884*C*D1*Ddd*f**3 - 6336*C*Dd**2*f**3*r*s + 1584*C*Dd**2*f**3*r - 10608*C*Dd**2*f**3*s**2 + 8472*C*Dd**2*f**3*s - 1056*C*Dd**2*f**3 + 2*D1**2*bd1**2*(18*f**2*(8*r*(s - 1) + 5*s**2 - 15*s + 6) - 7*f*(-8*C*s**2 + 8*C*s + K*(r*(20*s - 22) + s**2 - 35*s + 22) + 4*r*(-2*C*s + C - 15*s + 9) - 47*s**2 + 93*s - 40) - 140*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*D1**2*bdd1*f*(81*f**2*(2*r + 2*s**2 - 1) + f*(C*(r*(132 - 60*s) + 37*s**2 + 70*s - 35) - 465*K*s**2 + 228*K*s - 6*r*(38*K*s - 32*s + 31) + 227*s**2 - 256*s + 98) + 7*g2*(4*r*(5*s - 11) + s**2 - 50*s + 25)) - 216*D1**2*bdd2*f**2*r*s - 216*D1**2*bdd2*f**2*s**2 + 216*D1**2*bdd2*f**2*s - 612*D1**2*f**2*fd*r*s + 204*D1**2*f**2*fd*r - 2244*D1**2*f**2*fd*s**2 + 1700*D1**2*f**2*fd*s - 748*D1**2*f**2*fd + 1008*D1**2*f**2*fdd*r*s - 336*D1**2*f**2*fdd*r + 1824*D1**2*f**2*fdd*s**2 - 1552*D1**2*f**2*fdd*s + 608*D1**2*f**2*fdd - 816*D1**2*f**2*gd2*r*s - 2376*D1**2*f**2*gd2*s**2 + 816*D1**2*f**2*gd2*s + 912*D1**2*f**2*gdd2*r*s + 1860*D1**2*f**2*gdd2*s**2 - 912*D1**2*f**2*gdd2*s + 2016*D1**2*f*fd**2*r*s - 672*D1**2*f*fd**2*r + 3648*D1**2*f*fd**2*s**2 - 3104*D1**2*f*fd**2*s + 336*D1**2*f*fd**2 - 1632*D1**2*f*fd*g2*r*s + 816*D1**2*f*fd*g2*r - 4752*D1**2*f*fd*g2*s**2 + 4752*D1**2*f*fd*g2*s - 2376*D1**2*f*fd*g2 + 3648*D1**2*f*fd*gd2*r*s - 912*D1**2*f*fd*gd2*r + 7440*D1**2*f*fd*gd2*s**2 - 5544*D1**2*f*fd*gd2*s + 912*D1**2*f*fd*gd2 + 1824*D1**2*f*fdd*g2*r*s - 912*D1**2*f*fdd*g2*r + 3720*D1**2*f*fdd*g2*s**2 - 3720*D1**2*f*fdd*g2*s + 1860*D1**2*f*fdd*g2 + 1824*D1**2*fd**2*g2*r*s - 912*D1**2*fd**2*g2*r + 3720*D1**2*fd**2*g2*s**2 - 3720*D1**2*fd**2*g2*s - 816*D1*Dd*f**3*r*s + 204*D1*Dd*f**3*r - 2992*D1*Dd*f**3*s**2 + 1904*D1*Dd*f**3*s - 748*D1*Dd*f**3 + 8064*D1*Dd*f**2*fd*r*s - 2352*D1*Dd*f**2*fd*r + 14592*D1*Dd*f**2*fd*s**2 - 11872*D1*Dd*f**2*fd*s + 2224*D1*Dd*f**2*fd - 3264*D1*Dd*f**2*g2*r*s + 816*D1*Dd*f**2*g2*r - 9504*D1*Dd*f**2*g2*s**2 + 6384*D1*Dd*f**2*g2*s - 2376*D1*Dd*f**2*g2 + 7296*D1*Dd*f**2*gd2*r*s - 912*D1*Dd*f**2*gd2*r + 14880*D1*Dd*f**2*gd2*s**2 - 9192*D1*Dd*f**2*gd2*s + 912*D1*Dd*f**2*gd2 + 14592*D1*Dd*f*fd*g2*r*s - 5472*D1*Dd*f*fd*g2*r + 29760*D1*Dd*f*fd*g2*s**2 - 25968*D1*Dd*f*fd*g2*s + 5544*D1*Dd*f*fd*g2 + 1344*D1*Ddd*f**3*r*s - 336*D1*Ddd*f**3*r + 2432*D1*Ddd*f**3*s**2 - 1888*D1*Ddd*f**3*s + 608*D1*Ddd*f**3 + 3648*D1*Ddd*f**2*g2*r*s - 912*D1*Ddd*f**2*g2*r + 7440*D1*Ddd*f**2*g2*s**2 - 5544*D1*Ddd*f**2*g2*s + 1860*D1*Ddd*f**2*g2 + 4*D1*bd1*(D1*(9*f**3*(r*(6*s - 9) - 6*s**2 - 7*s + 6) + f**2*(2*C*(15*r*(2*s - 3) - 8*s**2 - 14*s + 7) + 102*K*r*s + 297*K*s**2 - 102*K*s + 81*fd*(2*r + 6*s**2 - 2*s - 1) - 73*r*s + 137*r - 129*s**2 + 95*s - 70) + f*(fd*(2*C*(r*(48 - 60*s) + 37*s**2 + 14*s - 33) - 3*K*(38*r*(4*s - 1) + 310*s**2 - 231*s + 38) + 384*r*s - 189*r + 454*s**2 - 451*s + 123) - 14*g2*(r*(20*s - 17) + 8*s**2 - 10*s + 5) + 7*gd2*(r*(20*s - 22) + s**2 - 35*s + 22)) + 7*fd*g2*(10*r*(2*s - 1) + s*(s - 1))) + Dd*f*(162*f**2*(2*r + 4*s**2 - s - 1) + f*(C*(-6*r*(40*s - 49) + 148*s**2 + 163*s - 167) - 3*K*(38*r*(8*s - 1) + 620*s**2 - 383*s + 38) + 768*r*s - 468*r + 908*s**2 - 931*s + 314) + 7*g2*(r*(80*s - 98) + 4*s**2 - 121*s + 69))) + 24*D1*bd2*f*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 4032*Dd**2*f**3*r*s - 1008*Dd**2*f**3*r + 7296*Dd**2*f**3*s**2 - 5664*Dd**2*f**3*s + 672*Dd**2*f**3 + 10944*Dd**2*f**2*g2*r*s - 2736*Dd**2*f**2*g2*r + 22320*Dd**2*f**2*g2*s**2 - 16632*Dd**2*f**2*g2*s + 1824*Dd**2*f**2*g2 - 140*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(-112*C*D1**2*fd*r*s - 112*C*D1**2*fd*s**2 + 112*C*D1**2*fd*s + 56*C*D1**2*fdd*r*s + 56*C*D1**2*fdd*s**2 - 56*C*D1**2*fdd*s - 448*C*D1*Dd*f*r*s + 112*C*D1*Dd*f*r - 448*C*D1*Dd*f*s**2 + 448*C*D1*Dd*f*s - 112*C*D1*Dd*f + 448*C*D1*Dd*fd*r*s - 56*C*D1*Dd*fd*r + 448*C*D1*Dd*fd*s**2 - 448*C*D1*Dd*fd*s + 56*C*D1*Dd*fd + 224*C*D1*Ddd*f*r*s - 56*C*D1*Ddd*f*r + 224*C*D1*Ddd*f*s**2 - 224*C*D1*Ddd*f*s + 56*C*D1*Ddd*f + 672*C*Dd**2*f*r*s - 168*C*Dd**2*f*r + 672*C*Dd**2*f*s**2 - 672*C*Dd**2*f*s + 112*C*Dd**2*f + 560*D1**2*K*fd*r*s - 84*D1**2*K*fd*r + 224*D1**2*K*fd*s**2 - 168*D1**2*K*fd*s + 84*D1**2*K*fd - 140*D1**2*K*fdd*r*s - 168*D1**2*K*fdd*r - 7*D1**2*K*fdd*s**2 - 336*D1**2*K*fdd*s + 168*D1**2*K*fdd + 140*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 576*D1**2*f*fd*r*s - 204*D1**2*f*fd*r - 360*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s + 204*D1**2*f*fd + 288*D1**2*f*fdd*r*s + 144*D1**2*f*fdd*r + 180*D1**2*f*fdd*s**2 + 72*D1**2*f*fdd*s - 144*D1**2*f*fdd + 288*D1**2*fd**2*r*s + 144*D1**2*fd**2*r + 180*D1**2*fd**2*s**2 + 72*D1**2*fd**2*s - 144*D1**2*fd**2 - 840*D1**2*fd*r*s + 112*D1**2*fd*r - 588*D1**2*fd*s**2 + 112*D1**2*fd*s - 112*D1**2*fd + 420*D1**2*fdd*r*s + 84*D1**2*fdd*r + 329*D1**2*fdd*s**2 + 224*D1**2*fdd*s - 84*D1**2*fdd + 560*D1**2*gd2*r*s + 560*D1**2*gd2*s**2 - 560*D1**2*gd2*s - 280*D1**2*gdd2*r*s - 280*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s + 2240*D1*Dd*K*f*r*s - 560*D1*Dd*K*f*r + 896*D1*Dd*K*f*s**2 - 1568*D1*Dd*K*f*s + 224*D1*Dd*K*f - 1120*D1*Dd*K*fd*r*s - 532*D1*Dd*K*fd*r - 56*D1*Dd*K*fd*s**2 - 1050*D1*Dd*K*fd*s + 672*D1*Dd*K*fd - 1152*D1*Dd*f**2*r*s + 288*D1*Dd*f**2*r - 720*D1*Dd*f**2*s**2 + 936*D1*Dd*f**2*s - 180*D1*Dd*f**2 + 2304*D1*Dd*f*fd*r*s + 288*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 648*D1*Dd*f*fd*s - 360*D1*Dd*f*fd - 3360*D1*Dd*f*r*s + 840*D1*Dd*f*r - 2352*D1*Dd*f*s**2 + 2856*D1*Dd*f*s - 588*D1*Dd*f + 3360*D1*Dd*fd*r*s - 84*D1*Dd*fd*r + 2632*D1*Dd*fd*s**2 - 602*D1*Dd*fd*s - 392*D1*Dd*fd + 2240*D1*Dd*g2*r*s - 560*D1*Dd*g2*r + 2240*D1*Dd*g2*s**2 - 2240*D1*Dd*g2*s + 560*D1*Dd*g2 - 2240*D1*Dd*gd2*r*s + 280*D1*Dd*gd2*r - 2240*D1*Dd*gd2*s**2 + 2240*D1*Dd*gd2*s - 280*D1*Dd*gd2 - 560*D1*Ddd*K*f*r*s + 140*D1*Ddd*K*f*r - 28*D1*Ddd*K*f*s**2 + 294*D1*Ddd*K*f*s - 7*D1*Ddd*K*f + 576*D1*Ddd*f**2*r*s - 144*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 468*D1*Ddd*f**2*s + 90*D1*Ddd*f**2 + 1680*D1*Ddd*f*r*s - 420*D1*Ddd*f*r + 1316*D1*Ddd*f*s**2 - 1498*D1*Ddd*f*s + 329*D1*Ddd*f - 1120*D1*Ddd*g2*r*s + 280*D1*Ddd*g2*r - 1120*D1*Ddd*g2*s**2 + 1120*D1*Ddd*g2*s - 280*D1*Ddd*g2 - 140*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) - 1680*Dd**2*K*f*r*s + 420*Dd**2*K*f*r - 84*Dd**2*K*f*s**2 + 882*Dd**2*K*f*s - 280*Dd**2*K*f + 1728*Dd**2*f**2*r*s - 432*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1404*Dd**2*f**2*s + 288*Dd**2*f**2 + 5040*Dd**2*f*r*s - 1260*Dd**2*f*r + 3948*Dd**2*f*s**2 - 4494*Dd**2*f*s + 840*Dd**2*f - 3360*Dd**2*g2*r*s + 840*Dd**2*g2*r - 3360*Dd**2*g2*s**2 + 3360*Dd**2*g2*s - 560*Dd**2*g2) + b1*(140*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(18*f**2*(16*r*(s - 1) + 10*s**2 - 30*s + 13) + 7*f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-40*r*s + 44*r - 2*s**2 + 70*s - 25) + 120*r*s - 72*r + 94*s**2 - 186*s + 59) - 280*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 2*D1**2*(9*f**2*(2*fd*(3*r*(6*s + 1) - 18*s**2 + 7*s - 12) - 9*fdd*(2*r - 6*s**2 + 4*s - 3)) - f*(162*fd**2*(2*r - 6*s**2 + 4*s - 1) - 2*fd*(2*C*(15*r*(4*s + 1) - 16*s**2 - 15) + 3*K*(34*r*(2*s - 1) + 198*s**2 - 198*s + 99) - 146*r*s - 64*r - 258*s**2 + 236*s - 59) + fdd*(2*C*(12*r*(5*s + 3) - 37*s**2 + 42*s - 36) + 228*K*r*(2*s - 1) + 465*K*(2*s**2 - 2*s + 1) - 384*r*s + 6*r - 454*s**2 + 390*s - 129) + 7*s*(16*gd2*(5*r + 2*s - 5) - gdd2*(20*r + s - 20))) - 2*fd**2*(C*(12*r*(5*s + 3) - 37*s**2 + 42*s - 36) + 465*K*s**2 - 465*K*s + 3*r*(76*K*s - 38*K - 64*s + 1) - 227*s**2 + 195*s + 27) + 14*fd*(-2*g2*(r*(20*s - 3) + 8*s**2 - 6*s + 3) + gd2*(4*r*(5*s + 3) + s**2 + 14*s - 12)) + 7*fdd*g2*(4*r*(5*s + 6) + s**2 + 48*s - 24)) - 2*D1*bd1*(D1*(6*f**2*(r*(48*s - 41) + 30*s**2 - 76*s + 32) + 2*f*(28*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 7*K*(40*r*s - 17*r + 16*s**2 - 30*s + 5) - 18*fd*(4*r*(4*s - 1) + 10*s**2 - 13*s + 3) + 420*r*s - 182*r + 294*s**2 - 476*s + 119) - 7*fd*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(40*r*s + 2*r + 2*s**2 + 13*s - 12) + 120*r*s - 24*r + 94*s**2 - 61*s - 10) - 140*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 140*gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*(-18*f**2*(8*r*(8*s - 5) + 40*s**2 - 86*s + 31) - 7*f*(8*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + K*(-160*r*s + 108*r - 8*s**2 + 182*s - 79) + 480*r*s - 204*r + 376*s**2 - 586*s + 165) + 280*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 2*D1*(2*Dd*(-54*f**3*(-4*r*s + r + 4*s**2 + 1) + f**2*(60*C*r*(4*s - 1) - 8*C*(8*s**2 + 11*s + 2) + 408*K*r*s - 102*K*r + 1188*K*s**2 - 798*K*s + 297*K - 162*fd*(2*r - 12*s**2 + 7*s - 2) - 292*r*s + 73*r - 516*s**2 + 404*s - 129) + f*(fd*(-2*C*(6*r*(40*s + 7) - 148*s**2 + 61*s - 57) - 3*K*(76*r*(8*s - 3) + 1240*s**2 - 1082*s + 231) + 1536*r*s - 204*r + 1816*s**2 - 1618*s + 201) - 56*g2*(5*r*(4*s - 1) + 8*s**2 - 14*s + 2) - 7*gd2*(r*(10 - 80*s) - 4*s**2 + 61*s - 10)) + 7*fd*g2*(r*(80*s + 38) + 4*s**2 + 75*s - 48)) + Ddd*f*(162*f**2*(4*s**2 - 2*s + 1) + f*(C*(-60*r*(4*s - 1) + 148*s**2 + 46*s + 37) - 3*K*(76*r*(4*s - 1) + 620*s**2 - 462*s + 155) + 768*r*s - 192*r + 908*s**2 - 838*s + 227) + 7*g2*(20*r*(4*s - 1) + 4*s**2 - 42*s + 1))) + 4*Dd**2*f*(486*f**2*s*(2*s - 1) - 3*f*(C*(30*r*(4*s - 1) - 74*s**2 - 23*s + 20) + K*(114*r*(4*s - 1) + 930*s**2 - 693*s + 76) - 384*r*s + 96*r - 454*s**2 + 419*s - 64) + 7*g2*(30*r*(4*s - 1) + 6*s**2 - 63*s + 20))) + 24*b2*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(210*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**2*k1**2*k2*(672*C*D1**2*bd1**2*f*r*s - 336*C*D1**2*bd1**2*f*r + 672*C*D1**2*bd1**2*f*s**2 - 672*C*D1**2*bd1**2*f*s + 816*C*D1**2*bd1*f**2*r*s - 816*C*D1**2*bd1*f**2*r + 1044*C*D1**2*bd1*f**2*s**2 - 2088*C*D1**2*bd1*f**2*s + 1044*C*D1**2*bd1*f**2 - 3648*C*D1**2*bd1*f*fd*r*s + 1824*C*D1**2*bd1*f*fd*r - 4776*C*D1**2*bd1*f*fd*s**2 + 5688*C*D1**2*bd1*f*fd*s - 912*C*D1**2*bd1*f*fd - 912*C*D1**2*bdd1*f**2*r*s + 912*C*D1**2*bdd1*f**2*r - 1194*C*D1**2*bdd1*f**2*s**2 + 2388*C*D1**2*bdd1*f**2*s - 1194*C*D1**2*bdd1*f**2 - 720*C*D1**2*f**2*fd*r*s + 240*C*D1**2*f**2*fd*r + 240*C*D1**2*f**2*fd*s - 450*C*D1**2*f**2*fdd*s**2 + 300*C*D1**2*f**2*fdd*s - 150*C*D1**2*f**2*fdd - 900*C*D1**2*f*fd**2*s**2 + 600*C*D1**2*f*fd**2*s - 7296*C*D1*Dd*bd1*f**2*r*s + 4560*C*D1*Dd*bd1*f**2*r - 9552*C*D1*Dd*bd1*f**2*s**2 + 13764*C*D1*Dd*bd1*f**2*s - 4212*C*D1*Dd*bd1*f**2 - 960*C*D1*Dd*f**3*r*s + 240*C*D1*Dd*f**3*r + 480*C*D1*Dd*f**3*s - 3600*C*D1*Dd*f**2*fd*s**2 + 2100*C*D1*Dd*f**2*fd*s - 300*C*D1*Dd*f**2*fd - 600*C*D1*Ddd*f**3*s**2 + 300*C*D1*Ddd*f**3*s - 150*C*D1*Ddd*f**3 - 1800*C*Dd**2*f**3*s**2 + 900*C*Dd**2*f**3*s - 1232*D1**2*K*bd1**2*f*r*s + 616*D1**2*K*bd1**2*f*r - 1806*D1**2*K*bd1**2*f*s**2 + 2422*D1**2*K*bd1**2*f*s - 616*D1**2*K*bd1**2*f - 168*D1**2*K*bd1*f**2*r*s + 168*D1**2*K*bd1*f**2*s - 420*D1**2*K*bd1*f*fd*s**2 + 210*D1**2*K*bd1*f*fd*s - 105*D1**2*K*bdd1*f**2*s**2 + 756*D1**2*bd1**2*f**2*r*s - 378*D1**2*bd1**2*f**2*r + 630*D1**2*bd1**2*f**2*s**2 - 1008*D1**2*bd1**2*f**2*s + 378*D1**2*bd1**2*f**2 - 140*D1**2*bd1**2*f*r*s + 70*D1**2*bd1**2*f*r + 84*D1**2*bd1**2*f*s**2 - 266*D1**2*bd1**2*f*s + 182*D1**2*bd1**2*f - 1120*D1**2*bd1**2*g2*r*s + 560*D1**2*bd1**2*g2*r - 1120*D1**2*bd1**2*g2*s**2 + 1120*D1**2*bd1**2*g2*s - 504*D1**2*bd1*bd2*f*r*s + 252*D1**2*bd1*bd2*f*r - 504*D1**2*bd1*bd2*f*s**2 + 756*D1**2*bd1*bd2*f*s - 252*D1**2*bd1*bd2*f - 222*D1**2*bd1*f**2*r*s + 264*D1**2*bd1*f**2*r - 474*D1**2*bd1*f**2*s**2 + 906*D1**2*bd1*f**2*s - 474*D1**2*bd1*f**2 + 2376*D1**2*bd1*f*fd*r*s - 1188*D1**2*bd1*f*fd*r + 3132*D1**2*bd1*f*fd*s**2 - 3726*D1**2*bd1*f*fd*s + 594*D1**2*bd1*f*fd - 784*D1**2*bd1*f*g2*r*s + 784*D1**2*bd1*f*g2*r - 1372*D1**2*bd1*f*g2*s**2 + 2744*D1**2*bd1*f*g2*s - 1372*D1**2*bd1*f*g2 + 2464*D1**2*bd1*f*gd2*r*s - 1232*D1**2*bd1*f*gd2*r + 3612*D1**2*bd1*f*gd2*s**2 - 4844*D1**2*bd1*f*gd2*s + 1232*D1**2*bd1*f*gd2 + 2464*D1**2*bd1*fd*g2*r*s - 1232*D1**2*bd1*fd*g2*r + 3612*D1**2*bd1*fd*g2*s**2 - 3612*D1**2*bd1*fd*g2*s - 84*D1**2*bd2*f**2*r*s - 84*D1**2*bd2*f**2*s**2 + 84*D1**2*bd2*f**2*s + 594*D1**2*bdd1*f**2*r*s - 594*D1**2*bdd1*f**2*r + 783*D1**2*bdd1*f**2*s**2 - 1566*D1**2*bdd1*f**2*s + 783*D1**2*bdd1*f**2 + 1232*D1**2*bdd1*f*g2*r*s - 1232*D1**2*bdd1*f*g2*r + 1806*D1**2*bdd1*f*g2*s**2 - 3612*D1**2*bdd1*f*g2*s + 1806*D1**2*bdd1*f*g2 + 450*D1**2*f**2*fd*r*s - 150*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s + 225*D1**2*f**2*fdd*s**2 - 150*D1**2*f**2*fdd*s + 75*D1**2*f**2*fdd + 336*D1**2*f**2*gd2*r*s - 336*D1**2*f**2*gd2*s + 210*D1**2*f**2*gdd2*s**2 + 450*D1**2*f*fd**2*s**2 - 300*D1**2*f*fd**2*s + 672*D1**2*f*fd*g2*r*s - 336*D1**2*f*fd*g2*r + 840*D1**2*f*fd*gd2*s**2 - 420*D1**2*f*fd*gd2*s + 420*D1**2*f*fdd*g2*s**2 - 420*D1**2*f*fdd*g2*s + 210*D1**2*f*fdd*g2 + 420*D1**2*fd**2*g2*s**2 - 420*D1**2*fd**2*g2*s - 840*D1*Dd*K*bd1*f**2*s**2 + 210*D1*Dd*K*bd1*f**2*s + 4752*D1*Dd*bd1*f**2*r*s - 2970*D1*Dd*bd1*f**2*r + 6264*D1*Dd*bd1*f**2*s**2 - 9018*D1*Dd*bd1*f**2*s + 2754*D1*Dd*bd1*f**2 + 9856*D1*Dd*bd1*f*g2*r*s - 6160*D1*Dd*bd1*f*g2*r + 14448*D1*Dd*bd1*f*g2*s**2 - 20524*D1*Dd*bd1*f*g2*s + 6076*D1*Dd*bd1*f*g2 + 600*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r - 300*D1*Dd*f**3*s + 1800*D1*Dd*f**2*fd*s**2 - 1050*D1*Dd*f**2*fd*s + 150*D1*Dd*f**2*fd + 1344*D1*Dd*f**2*g2*r*s - 336*D1*Dd*f**2*g2*r - 672*D1*Dd*f**2*g2*s + 1680*D1*Dd*f**2*gd2*s**2 - 420*D1*Dd*f**2*gd2*s + 3360*D1*Dd*f*fd*g2*s**2 - 2520*D1*Dd*f*fd*g2*s + 420*D1*Dd*f*fd*g2 + 300*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 840*D1*Ddd*f**2*g2*s**2 - 420*D1*Ddd*f**2*g2*s + 210*D1*Ddd*f**2*g2 + 28*D1*b2*(bd1*(D1*(8*f*(s - 1)*(r + s - 1) + 9*fd*(-2*r*s + r - s*(2*s - 2))) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + 900*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 2520*Dd**2*f**2*g2*s**2 - 1260*Dd**2*f**2*g2*s + 28*b1**3*(D1**2*s*(7*fd - 6*fdd)*(r + s - 1) + D1*Dd*(7*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + (25*K - 20)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(-10*K + 6*f + 5) - Dd**2*(-10*K + 6*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(24*C*D1**2*fd*r*s + 24*C*D1**2*fd*s**2 - 24*C*D1**2*fd*s + 48*C*D1**2*fdd*r*s + 48*C*D1**2*fdd*s**2 - 48*C*D1**2*fdd*s + 96*C*D1*Dd*f*r*s - 24*C*D1*Dd*f*r + 96*C*D1*Dd*f*s**2 - 96*C*D1*Dd*f*s + 24*C*D1*Dd*f + 384*C*D1*Dd*fd*r*s - 48*C*D1*Dd*fd*r + 384*C*D1*Dd*fd*s**2 - 384*C*D1*Dd*fd*s + 48*C*D1*Dd*fd + 192*C*D1*Ddd*f*r*s - 48*C*D1*Ddd*f*r + 192*C*D1*Ddd*f*s**2 - 192*C*D1*Ddd*f*s + 48*C*D1*Ddd*f + 576*C*Dd**2*f*r*s - 144*C*Dd**2*f*r + 576*C*Dd**2*f*s**2 - 576*C*Dd**2*f*s + 96*C*Dd**2*f + 56*D1**2*K*fd*r*s + 98*D1**2*K*fd*s**2 - 88*D1**2*K*fdd*r*s - 129*D1**2*K*fdd*s**2 - 4*D1**2*bdd1*(-10*K + 6*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 60*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 42*D1**2*f*fd*s - 12*D1**2*f*fd + 108*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 108*D1**2*fd**2*r*s + 90*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s + 20*D1**2*fd*r*s - 12*D1**2*fd*s**2 + 28*D1**2*fd*s - 10*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 + 36*D1**2*fdd*s - 200*D1**2*gd2*r*s - 200*D1**2*gd2*s**2 + 200*D1**2*gd2*s - 80*D1**2*gdd2*r*s - 80*D1**2*gdd2*s**2 + 80*D1**2*gdd2*s + 224*D1*Dd*K*f*r*s - 56*D1*Dd*K*f*r + 392*D1*Dd*K*f*s**2 - 308*D1*Dd*K*f*s + 98*D1*Dd*K*f - 704*D1*Dd*K*fd*r*s + 88*D1*Dd*K*fd*r - 1032*D1*Dd*K*fd*s**2 + 434*D1*Dd*K*fd*s - 120*D1*Dd*f**2*r*s + 30*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 84*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 864*D1*Dd*f*fd*r*s - 108*D1*Dd*f*fd*r + 720*D1*Dd*f*fd*s**2 - 612*D1*Dd*f*fd*s + 54*D1*Dd*f*fd + 80*D1*Dd*f*r*s - 20*D1*Dd*f*r - 48*D1*Dd*f*s**2 - 16*D1*Dd*f*s - 12*D1*Dd*f - 80*D1*Dd*fd*r*s + 10*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 + 152*D1*Dd*fd*s - 36*D1*Dd*fd - 800*D1*Dd*g2*r*s + 200*D1*Dd*g2*r - 800*D1*Dd*g2*s**2 + 800*D1*Dd*g2*s - 200*D1*Dd*g2 - 640*D1*Dd*gd2*r*s + 80*D1*Dd*gd2*r - 640*D1*Dd*gd2*s**2 + 640*D1*Dd*gd2*s - 80*D1*Dd*gd2 - 352*D1*Ddd*K*f*r*s + 88*D1*Ddd*K*f*r - 516*D1*Ddd*K*f*s**2 + 434*D1*Ddd*K*f*s - 129*D1*Ddd*K*f + 216*D1*Ddd*f**2*r*s - 54*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s**2 - 198*D1*Ddd*f**2*s + 45*D1*Ddd*f**2 - 40*D1*Ddd*f*r*s + 10*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 + 8*D1*Ddd*f*s + 6*D1*Ddd*f - 320*D1*Ddd*g2*r*s + 80*D1*Ddd*g2*r - 320*D1*Ddd*g2*s**2 + 320*D1*Ddd*g2*s - 80*D1*Ddd*g2 + 4*D1*bd1*(D1*(7*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 6*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + (25*K - 20)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(-10*K + 6*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 1056*Dd**2*K*f*r*s + 264*Dd**2*K*f*r - 1548*Dd**2*K*f*s**2 + 1302*Dd**2*K*f*s - 176*Dd**2*K*f + 648*Dd**2*f**2*r*s - 162*Dd**2*f**2*r + 540*Dd**2*f**2*s**2 - 594*Dd**2*f**2*s + 108*Dd**2*f**2 - 120*Dd**2*f*r*s + 30*Dd**2*f*r + 72*Dd**2*f*s**2 + 24*Dd**2*f*s - 20*Dd**2*f - 960*Dd**2*g2*r*s + 240*Dd**2*g2*r - 960*Dd**2*g2*s**2 + 960*Dd**2*g2*s - 160*Dd**2*g2) - b1*(-1632*C*D1**2*f*fd*r*s - 2088*C*D1**2*f*fd*s**2 + 816*C*D1**2*f*fd*s + 1824*C*D1**2*f*fdd*r*s + 2388*C*D1**2*f*fdd*s**2 - 912*C*D1**2*f*fdd*s + 1824*C*D1**2*fd**2*r*s + 2388*C*D1**2*fd**2*s**2 - 912*C*D1**2*fd**2*s - 3264*C*D1*Dd*f**2*r*s + 816*C*D1*Dd*f**2*r - 4176*C*D1*Dd*f**2*s**2 + 3720*C*D1*Dd*f**2*s - 1044*C*D1*Dd*f**2 + 14592*C*D1*Dd*f*fd*r*s - 1824*C*D1*Dd*f*fd*r + 19104*C*D1*Dd*f*fd*s**2 - 12072*C*D1*Dd*f*fd*s + 912*C*D1*Dd*f*fd + 3648*C*D1*Ddd*f**2*r*s - 912*C*D1*Ddd*f**2*r + 4776*C*D1*Ddd*f**2*s**2 - 4212*C*D1*Ddd*f**2*s + 1194*C*D1*Ddd*f**2 + 10944*C*Dd**2*f**2*r*s - 2736*C*Dd**2*f**2*r + 14328*C*Dd**2*f**2*s**2 - 12636*C*Dd**2*f**2*s + 1824*C*Dd**2*f**2 + 336*D1**2*K*f*fd*r*s - 168*D1**2*K*f*fd*r + 210*D1**2*K*f*fdd*s**2 - 210*D1**2*K*f*fdd*s + 105*D1**2*K*f*fdd + 210*D1**2*K*fd**2*s**2 - 210*D1**2*K*fd**2*s - 224*D1**2*b2*fd*r*s - 224*D1**2*b2*fd*s**2 + 252*D1**2*b2*fdd*r*s + 252*D1**2*b2*fdd*s**2 + 28*D1**2*bd1**2*(-10*K + 6*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 224*D1**2*bd2*f*r*s - 224*D1**2*bd2*f*s**2 + 224*D1**2*bd2*f*s + 504*D1**2*bd2*fd*r*s + 504*D1**2*bd2*fd*s**2 - 252*D1**2*bd2*fd*s - 7*D1**2*bdd1*(9*f**2*(6*r*(2*s - 1) + 10*s**2 - 16*s + 5) + f*(48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-176*r*s + 88*r - 258*s**2 + 346*s - 129) - 20*r*s + 10*r + 12*s**2 - 38*s + 6) - 80*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 252*D1**2*bdd2*f*r*s + 252*D1**2*bdd2*f*s**2 - 252*D1**2*bdd2*f*s + 444*D1**2*f*fd*r*s + 42*D1**2*f*fd*r + 948*D1**2*f*fd*s**2 - 264*D1**2*f*fd*s - 1188*D1**2*f*fdd*r*s - 1566*D1**2*f*fdd*s**2 + 594*D1**2*f*fdd*s + 784*D1**2*f*gd2*r*s + 1372*D1**2*f*gd2*s**2 - 784*D1**2*f*gd2*s - 1232*D1**2*f*gdd2*r*s - 1806*D1**2*f*gdd2*s**2 + 1232*D1**2*f*gdd2*s - 1188*D1**2*fd**2*r*s - 1566*D1**2*fd**2*s**2 + 594*D1**2*fd**2*s + 784*D1**2*fd*g2*r*s + 1372*D1**2*fd*g2*s**2 - 2464*D1**2*fd*gd2*r*s - 3612*D1**2*fd*gd2*s**2 + 1232*D1**2*fd*gd2*s - 1232*D1**2*fdd*g2*r*s - 1806*D1**2*fdd*g2*s**2 + 672*D1*Dd*K*f**2*r*s - 168*D1*Dd*K*f**2*r - 336*D1*Dd*K*f**2*s + 1680*D1*Dd*K*f*fd*s**2 - 1260*D1*Dd*K*f*fd*s + 210*D1*Dd*K*f*fd - 896*D1*Dd*b2*f*r*s + 224*D1*Dd*b2*f*r - 896*D1*Dd*b2*f*s**2 + 896*D1*Dd*b2*f*s - 224*D1*Dd*b2*f + 2016*D1*Dd*b2*fd*r*s - 252*D1*Dd*b2*fd*r + 2016*D1*Dd*b2*fd*s**2 - 1008*D1*Dd*b2*fd*s + 2016*D1*Dd*bd2*f*r*s - 252*D1*Dd*bd2*f*r + 2016*D1*Dd*bd2*f*s**2 - 2016*D1*Dd*bd2*f*s + 252*D1*Dd*bd2*f + 888*D1*Dd*f**2*r*s - 222*D1*Dd*f**2*r + 1896*D1*Dd*f**2*s**2 - 1392*D1*Dd*f**2*s + 474*D1*Dd*f**2 - 9504*D1*Dd*f*fd*r*s + 1188*D1*Dd*f*fd*r - 12528*D1*Dd*f*fd*s**2 + 7884*D1*Dd*f*fd*s - 594*D1*Dd*f*fd + 3136*D1*Dd*f*g2*r*s - 784*D1*Dd*f*g2*r + 5488*D1*Dd*f*g2*s**2 - 4312*D1*Dd*f*g2*s + 1372*D1*Dd*f*g2 - 9856*D1*Dd*f*gd2*r*s + 1232*D1*Dd*f*gd2*r - 14448*D1*Dd*f*gd2*s**2 + 11004*D1*Dd*f*gd2*s - 1232*D1*Dd*f*gd2 - 9856*D1*Dd*fd*g2*r*s + 1232*D1*Dd*fd*g2*r - 14448*D1*Dd*fd*g2*s**2 + 6076*D1*Dd*fd*g2*s + 420*D1*Ddd*K*f**2*s**2 - 210*D1*Ddd*K*f**2*s + 105*D1*Ddd*K*f**2 + 1008*D1*Ddd*b2*f*r*s - 252*D1*Ddd*b2*f*r + 1008*D1*Ddd*b2*f*s**2 - 1008*D1*Ddd*b2*f*s + 252*D1*Ddd*b2*f - 2376*D1*Ddd*f**2*r*s + 594*D1*Ddd*f**2*r - 3132*D1*Ddd*f**2*s**2 + 2754*D1*Ddd*f**2*s - 783*D1*Ddd*f**2 - 4928*D1*Ddd*f*g2*r*s + 1232*D1*Ddd*f*g2*r - 7224*D1*Ddd*f*g2*s**2 + 6076*D1*Ddd*f*g2*s - 1806*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(3*f**2*(r*(10*s - 3) + s*(4*s - 7)) + f*(-12*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 56*K*r*s + 28*K*r - 98*K*s**2 + 126*K*s - 49*K - 9*fd*(24*r*s - 6*r + 20*s**2 - 22*s + 3) - 20*r*s + 10*r + 12*s**2 + 12*s + 6) - fd*(24*C*(r*(4*s - 1) + (1 - 2*s)**2) - 258*K*s**2 + 173*K*s - r*(44*K + 5)*(4*s - 1) + 12*s**2 + 17*s - 18) + 100*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 40*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*(-18*f**2*(3*r*(8*s - 3) + 20*s**2 - 27*s + 7) + f*(-48*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + K*(88*r*(8*s - 3) + 1032*s**2 - 1126*s + 261) + 80*r*s - 30*r - 48*s**2 + 68*s - 9) + 80*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 1260*Dd**2*K*f**2*s**2 - 630*Dd**2*K*f**2*s + 3024*Dd**2*b2*f*r*s - 756*Dd**2*b2*f*r + 3024*Dd**2*b2*f*s**2 - 3024*Dd**2*b2*f*s + 504*Dd**2*b2*f - 7128*Dd**2*f**2*r*s + 1782*Dd**2*f**2*r - 9396*Dd**2*f**2*s**2 + 8262*Dd**2*f**2*s - 1188*Dd**2*f**2 - 14784*Dd**2*f*g2*r*s + 3696*Dd**2*f*g2*r - 21672*Dd**2*f*g2*s**2 + 18228*Dd**2*f*g2*s - 2464*Dd**2*f*g2))/(210*d**2*k3**4) + 3*D1**2*Pk3*Pkd2*ct**2*k1**2*st**4*(D1**2*(84*bd1*fd*g2*s*(s - 1) + f**3*s**2*(90*bd1 - 45*bdd1) - 2*f**2*(5*fd*(s**2*(27*bd1 - 6) + s*(4 - 9*bd1) - 2) + 5*fdd*(3*s**2 - 2*s + 1) + s**2*(C + 4)*(-6*bd1 + 3*bdd1)) + 2*f*s*(-21*bd1**2*s*(K - 1) - 6*bd1*(fd*(C + 4)*(2*s - 1) + s*(7*g2 - 7*gd2)) + 21*bdd1*g2*s + fd**2*(20 - 30*s))) - 2*D1*f*(Dd*(42*bd1*g2*s*(1 - 4*s) + 5*f**2*(s**2*(36*bd1 - 8) + s*(4 - 9*bd1) - 2) + 2*f*(4*s - 1)*(3*bd1*s*(C + 4) + 5*fd*(3*s - 1))) + 5*Ddd*f**2*(4*s**2 - 2*s + 1)) + 60*Dd**2*f**3*s*(1 - 2*s) + 21*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(D1**2*(15*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) - 2*f*(15*fd**2*s*(3*s - 2) - fd*(2*C + 8)*(2*s**2 - 2*s + 1) + fdd*(C + 4)*(2*s**2 - 2*s + 1) + s**2*(7*K*bdd1 - 14*bd1*(K - 1) - 7*bdd1 + 14*gd2 - 7*gdd2)) - (2*s - 2)*(fd**2*s*(2*C + 8) + 14*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(15*f**3*(4*s**2 - 2*s + 1) + f**2*(C*(8*s**2 - 4*s + 2) - 15*fd*(12*s**2 - 7*s + 1) + 32*s**2 - 16*s + 8) - 2*f*(fd*(C + 4)*(8*s**2 - 6*s + 1) + 7*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(7*K*bd1 - 7*bd1 - 7*gd2)) + 14*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(15*f**2 + f*(2*C + 8) - 14*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(15*f**2 + f*(2*C + 8) - 14*g2)))/(70*d**2*k2*k3**2) + D1**2*Pk3*Pkd2*ct**2*k1**2*st**2*(-600*C*D1**2*f**2*fd*s**2 + 400*C*D1**2*f**2*fd*s - 200*C*D1**2*f**2*fd + 300*C*D1**2*f**2*fdd*s**2 - 200*C*D1**2*f**2*fdd*s + 100*C*D1**2*f**2*fdd + 600*C*D1**2*f*fd**2*s**2 - 400*C*D1**2*f*fd**2*s - 800*C*D1*Dd*f**3*s**2 + 400*C*D1*Dd*f**3*s - 200*C*D1*Dd*f**3 + 2400*C*D1*Dd*f**2*fd*s**2 - 1400*C*D1*Dd*f**2*fd*s + 200*C*D1*Dd*f**2*fd + 400*C*D1*Ddd*f**3*s**2 - 200*C*D1*Ddd*f**3*s + 100*C*D1*Ddd*f**3 + 1200*C*Dd**2*f**3*s**2 - 600*C*Dd**2*f**3*s - 360*D1**2*b2*f*fd*s**2 + 360*D1**2*b2*f*fd*s - 180*D1**2*b2*f*fd + 180*D1**2*b2*f*fdd*s**2 - 180*D1**2*b2*f*fdd*s + 90*D1**2*b2*f*fdd + 180*D1**2*b2*fd**2*s**2 - 180*D1**2*b2*fd**2*s - 2*D1**2*bd1**2*s*(90*f**2*(2*s - 3) + 7*f*(10*C*(s - 1) - 37*K*s + 57*s - 20) - 350*g2*(s - 1)) - 180*D1**2*bd2*f**2*s**2 + 360*D1**2*bd2*f*fd*s**2 - 180*D1**2*bd2*f*fd*s + 2*D1**2*bdd1*f*(27*f**2*s*(4*r + 9*s - 2) + f*(s**2*(71*C + 45*K + 67) + s*(60*r + 30) - 45) - 259*g2*s**2) + 90*D1**2*bdd2*f**2*s**2 - 252*D1**2*f**2*fd*r*s + 84*D1**2*f**2*fd*r - 588*D1**2*f**2*fd*s**2 + 476*D1**2*f**2*fd*s - 196*D1**2*f**2*fd + 216*D1**2*f**2*fdd*r*s - 72*D1**2*f**2*fdd*r + 348*D1**2*f**2*fdd*s**2 - 304*D1**2*f**2*fdd*s + 116*D1**2*f**2*fdd + 360*D1**2*f**2*gd2*s**2 - 180*D1**2*f**2*gdd2*s**2 + 432*D1**2*f*fd**2*r*s - 144*D1**2*f*fd**2*r + 696*D1**2*f*fd**2*s**2 - 608*D1**2*f*fd**2*s + 72*D1**2*f*fd**2 + 720*D1**2*f*fd*g2*s**2 - 720*D1**2*f*fd*g2*s + 360*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 360*D1**2*f*fdd*g2*s**2 + 360*D1**2*f*fdd*g2*s - 180*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*s**2 + 360*D1**2*fd**2*g2*s - 720*D1*Dd*b2*f**2*s**2 + 360*D1*Dd*b2*f**2*s - 180*D1*Dd*b2*f**2 + 1440*D1*Dd*b2*f*fd*s**2 - 1080*D1*Dd*b2*f*fd*s + 180*D1*Dd*b2*f*fd + 720*D1*Dd*bd2*f**2*s**2 - 180*D1*Dd*bd2*f**2*s - 336*D1*Dd*f**3*r*s + 84*D1*Dd*f**3*r - 784*D1*Dd*f**3*s**2 + 560*D1*Dd*f**3*s - 196*D1*Dd*f**3 + 1728*D1*Dd*f**2*fd*r*s - 504*D1*Dd*f**2*fd*r + 2784*D1*Dd*f**2*fd*s**2 - 2344*D1*Dd*f**2*fd*s + 448*D1*Dd*f**2*fd + 1440*D1*Dd*f**2*g2*s**2 - 720*D1*Dd*f**2*g2*s + 360*D1*Dd*f**2*g2 - 1440*D1*Dd*f**2*gd2*s**2 + 360*D1*Dd*f**2*gd2*s - 2880*D1*Dd*f*fd*g2*s**2 + 2160*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 + 360*D1*Ddd*b2*f**2*s**2 - 180*D1*Ddd*b2*f**2*s + 90*D1*Ddd*b2*f**2 + 288*D1*Ddd*f**3*r*s - 72*D1*Ddd*f**3*r + 464*D1*Ddd*f**3*s**2 - 376*D1*Ddd*f**3*s + 116*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 180*D1*Ddd*f**2*g2 - 4*D1*bd1*(D1*(27*f**3*s*(2*r + 8*s - 1) + f**2*(-27*fd*(2*r*(6*s - 1) + 27*s**2 - 15*s + 1) + s**2*(64*C + 45*K + 53) + s*(39*r + 51) - 45) + f*(fd*(-30*r*(4*s - 1) - s**2*(142*C + 90*K + 134) + s*(71*C + 45*K + 82) - 30) + s**2*(-224*g2 + 259*gd2)) + 259*fd*g2*s*(s - 1)) + Dd*f*(-27*f**2*(2*r*(8*s - 1) + 36*s**2 - 17*s + 1) + f*(-30*r*(8*s - 1) - s**2*(284*C + 180*K + 268) + s*(71*C + 45*K + 67) + 15) + 259*g2*s*(4*s - 1))) + 1080*Dd**2*b2*f**2*s**2 - 540*Dd**2*b2*f**2*s + 864*Dd**2*f**3*r*s - 216*Dd**2*f**3*r + 1392*Dd**2*f**3*s**2 - 1128*Dd**2*f**3*s + 144*Dd**2*f**3 - 2160*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s + 175*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + b1**2*(140*C*D1**2*fd*s**2 - 70*C*D1**2*fdd*s**2 + 560*C*D1*Dd*f*s**2 - 280*C*D1*Dd*f*s + 140*C*D1*Dd*f - 560*C*D1*Dd*fd*s**2 + 140*C*D1*Dd*fd*s - 280*C*D1*Ddd*f*s**2 + 140*C*D1*Ddd*f*s - 70*C*D1*Ddd*f - 840*C*Dd**2*f*s**2 + 420*C*Dd**2*f*s - 448*D1**2*K*fd*s**2 + 896*D1**2*K*fd*s - 448*D1**2*K*fd + 259*D1**2*K*fdd*s**2 - 518*D1**2*K*fdd*s + 259*D1**2*K*fdd - 175*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) + 720*D1**2*f*fd*s**2 + 360*D1**2*f*fd*s - 180*D1**2*f*fd - 360*D1**2*f*fdd*s**2 - 180*D1**2*f*fdd*s + 90*D1**2*f*fdd - 360*D1**2*fd**2*s**2 - 180*D1**2*fd**2*s + 728*D1**2*fd*s**2 - 896*D1**2*fd*s + 448*D1**2*fd - 399*D1**2*fdd*s**2 + 518*D1**2*fdd*s - 259*D1**2*fdd - 700*D1**2*gd2*s**2 + 350*D1**2*gdd2*s**2 - 1792*D1*Dd*K*f*s**2 + 896*D1*Dd*K*f*s - 448*D1*Dd*K*f + 2072*D1*Dd*K*fd*s**2 - 2590*D1*Dd*K*fd*s + 518*D1*Dd*K*fd + 1440*D1*Dd*f**2*s**2 - 720*D1*Dd*f**2*s + 360*D1*Dd*f**2 - 2880*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd + 2912*D1*Dd*f*s**2 - 1456*D1*Dd*f*s + 728*D1*Dd*f - 3192*D1*Dd*fd*s**2 + 2870*D1*Dd*fd*s - 518*D1*Dd*fd - 2800*D1*Dd*g2*s**2 + 1400*D1*Dd*g2*s - 700*D1*Dd*g2 + 2800*D1*Dd*gd2*s**2 - 700*D1*Dd*gd2*s + 1036*D1*Ddd*K*f*s**2 - 518*D1*Ddd*K*f*s + 259*D1*Ddd*K*f - 720*D1*Ddd*f**2*s**2 + 360*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 1596*D1*Ddd*f*s**2 + 798*D1*Ddd*f*s - 399*D1*Ddd*f + 1400*D1*Ddd*g2*s**2 - 700*D1*Ddd*g2*s + 350*D1*Ddd*g2 + 350*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) + 3108*Dd**2*K*f*s**2 - 1554*Dd**2*K*f*s - 2160*Dd**2*f**2*s**2 + 1080*Dd**2*f**2*s - 4788*Dd**2*f*s**2 + 2394*Dd**2*f*s + 4200*Dd**2*g2*s**2 - 2100*Dd**2*g2*s) - 2*b1*(256*C*D1**2*f*fd*s**2 - 256*C*D1**2*f*fd*s + 128*C*D1**2*f*fd - 142*C*D1**2*f*fdd*s**2 + 142*C*D1**2*f*fdd*s - 71*C*D1**2*f*fdd - 142*C*D1**2*fd**2*s**2 + 142*C*D1**2*fd**2*s + 512*C*D1*Dd*f**2*s**2 - 256*C*D1*Dd*f**2*s + 128*C*D1*Dd*f**2 - 1136*C*D1*Dd*f*fd*s**2 + 852*C*D1*Dd*f*fd*s - 142*C*D1*Dd*f*fd - 284*C*D1*Ddd*f**2*s**2 + 142*C*D1*Ddd*f**2*s - 71*C*D1*Ddd*f**2 - 852*C*Dd**2*f**2*s**2 + 426*C*Dd**2*f**2*s + 180*D1**2*K*f*fd*s**2 - 180*D1**2*K*f*fd*s + 90*D1**2*K*f*fd - 90*D1**2*K*f*fdd*s**2 + 90*D1**2*K*f*fdd*s - 45*D1**2*K*f*fdd - 90*D1**2*K*fd**2*s**2 + 90*D1**2*K*fd**2*s + 175*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + D1**2*bdd1*(45*f**2*(4*s**2 - 6*s + 3) + 7*f*(5*C*(2*s**2 - 2*s + 1) + s**2*(57 - 37*K) - 20*s + 10) - 175*g2*(2*s**2 - 2*s + 1)) + 324*D1**2*f**2*fd*r*s - 108*D1**2*f**2*fd*r + 1296*D1**2*f**2*fd*s**2 - 1026*D1**2*f**2*fd*s + 432*D1**2*f**2*fd - 324*D1**2*f**2*fdd*r*s + 108*D1**2*f**2*fdd*r - 729*D1**2*f**2*fdd*s**2 + 648*D1**2*f**2*fdd*s - 243*D1**2*f**2*fdd - 648*D1**2*f*fd**2*r*s + 216*D1**2*f*fd**2*r - 1458*D1**2*f*fd**2*s**2 + 1296*D1**2*f*fd**2*s - 162*D1**2*f*fd**2 + 156*D1**2*f*fd*r*s - 78*D1**2*f*fd*r + 212*D1**2*f*fd*s**2 - 392*D1**2*f*fd*s + 196*D1**2*f*fd - 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 134*D1**2*f*fdd*s**2 + 224*D1**2*f*fdd*s - 112*D1**2*f*fdd - 448*D1**2*f*gd2*s**2 + 259*D1**2*f*gdd2*s**2 - 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 134*D1**2*fd**2*s**2 + 224*D1**2*fd**2*s - 448*D1**2*fd*g2*s**2 + 896*D1**2*fd*g2*s - 448*D1**2*fd*g2 + 518*D1**2*fd*gd2*s**2 - 518*D1**2*fd*gd2*s + 259*D1**2*fdd*g2*s**2 - 518*D1**2*fdd*g2*s + 259*D1**2*fdd*g2 + 360*D1*Dd*K*f**2*s**2 - 180*D1*Dd*K*f**2*s + 90*D1*Dd*K*f**2 - 720*D1*Dd*K*f*fd*s**2 + 540*D1*Dd*K*f*fd*s - 90*D1*Dd*K*f*fd + 432*D1*Dd*f**3*r*s - 108*D1*Dd*f**3*r + 1728*D1*Dd*f**3*s**2 - 1080*D1*Dd*f**3*s + 432*D1*Dd*f**3 - 2592*D1*Dd*f**2*fd*r*s + 756*D1*Dd*f**2*fd*r - 5832*D1*Dd*f**2*fd*s**2 + 4698*D1*Dd*f**2*fd*s - 864*D1*Dd*f**2*fd + 312*D1*Dd*f**2*r*s - 78*D1*Dd*f**2*r + 424*D1*Dd*f**2*s**2 - 368*D1*Dd*f**2*s + 106*D1*Dd*f**2 - 960*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 1072*D1*Dd*f*fd*s**2 + 1404*D1*Dd*f*fd*s - 344*D1*Dd*f*fd - 1792*D1*Dd*f*g2*s**2 + 896*D1*Dd*f*g2*s - 448*D1*Dd*f*g2 + 2072*D1*Dd*f*gd2*s**2 - 518*D1*Dd*f*gd2*s + 2072*D1*Dd*fd*g2*s**2 - 2590*D1*Dd*fd*g2*s + 518*D1*Dd*fd*g2 - 180*D1*Ddd*K*f**2*s**2 + 90*D1*Ddd*K*f**2*s - 45*D1*Ddd*K*f**2 - 432*D1*Ddd*f**3*r*s + 108*D1*Ddd*f**3*r - 972*D1*Ddd*f**3*s**2 + 702*D1*Ddd*f**3*s - 243*D1*Ddd*f**3 - 240*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 268*D1*Ddd*f**2*s**2 + 254*D1*Ddd*f**2*s - 67*D1*Ddd*f**2 + 1036*D1*Ddd*f*g2*s**2 - 518*D1*Ddd*f*g2*s + 259*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(45*f**2*(4*s**2 - 6*s + 3) + f*(35*C*(2*s**2 - 2*s + 1) - s**2*(224*K + 360*fd - 364) + s*(180*fd - 140) + 70) - 7*fd*s*(5*C*(2*s - 1) - 37*K*(s - 1) + 57*s - 47) - 175*g2*(2*s**2 - 2*s + 1) - 175*gd2*s*(1 - 2*s)) - Dd*(4*s - 1)*(45*f**2*(4*s - 3) + 7*f*(5*C*(2*s - 1) - 37*K*s + 57*s - 10) + 175*g2*(1 - 2*s))) - 540*Dd**2*K*f**2*s**2 + 270*Dd**2*K*f**2*s - 1296*Dd**2*f**3*r*s + 324*Dd**2*f**3*r - 2916*Dd**2*f**3*s**2 + 2106*Dd**2*f**3*s - 216*Dd**2*f**3 - 720*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 804*Dd**2*f**2*s**2 + 762*Dd**2*f**2*s - 120*Dd**2*f**2 + 3108*Dd**2*f*g2*s**2 - 1554*Dd**2*f*g2*s))/(210*d**2*k2*k3**2) + D1**2*Pk3*Pkd2*ct**2*k1**2*(476*C*D1**2*bd1**2*f*s**2 - 476*C*D1**2*bd1**2*f*s - 60*C*D1**2*bd1*f**2*s**2 + 120*C*D1**2*bd1*f**2*s - 60*C*D1**2*bd1*f**2 + 120*C*D1**2*bd1*f*fd*s**2 - 120*C*D1**2*bd1*f*fd*s + 30*C*D1**2*bdd1*f**2*s**2 - 60*C*D1**2*bdd1*f**2*s + 30*C*D1**2*bdd1*f**2 + 720*C*D1**2*f**2*fd*s**2 - 480*C*D1**2*f**2*fd*s + 240*C*D1**2*f**2*fd - 450*C*D1**2*f**2*fdd*s**2 + 300*C*D1**2*f**2*fdd*s - 150*C*D1**2*f**2*fdd - 900*C*D1**2*f*fd**2*s**2 + 600*C*D1**2*f*fd**2*s + 240*C*D1*Dd*bd1*f**2*s**2 - 300*C*D1*Dd*bd1*f**2*s + 60*C*D1*Dd*bd1*f**2 + 960*C*D1*Dd*f**3*s**2 - 480*C*D1*Dd*f**3*s + 240*C*D1*Dd*f**3 - 3600*C*D1*Dd*f**2*fd*s**2 + 2100*C*D1*Dd*f**2*fd*s - 300*C*D1*Dd*f**2*fd - 600*C*D1*Ddd*f**3*s**2 + 300*C*D1*Ddd*f**3*s - 150*C*D1*Ddd*f**3 - 1800*C*Dd**2*f**3*s**2 + 900*C*Dd**2*f**3*s + 42*D1**2*K*bd1**2*f*s**2 - 42*D1**2*K*bd1**2*f*s + 168*D1**2*K*bd1*f**2*s**2 - 420*D1**2*K*bd1*f*fd*s**2 + 210*D1**2*K*bd1*f*fd*s - 105*D1**2*K*bdd1*f**2*s**2 + 504*D1**2*bd1**2*f**2*r*s - 252*D1**2*bd1**2*f**2*r + 420*D1**2*bd1**2*f**2*s**2 - 756*D1**2*bd1**2*f**2*s + 126*D1**2*bd1**2*f**2 + 364*D1**2*bd1**2*f*r*s - 182*D1**2*bd1**2*f*r + 112*D1**2*bd1**2*f*s**2 - 294*D1**2*bd1**2*f*s + 182*D1**2*bd1**2*f - 980*D1**2*bd1**2*g2*s**2 + 980*D1**2*bd1**2*g2*s + 42*D1**2*bd1*bd2*f*s**2 - 42*D1**2*bd1*bd2*f*s - 150*D1**2*bd1*f**2*r*s + 192*D1**2*bd1*f**2*r - 258*D1**2*bd1*f**2*s**2 + 474*D1**2*bd1*f**2*s - 258*D1**2*bd1*f**2 + 552*D1**2*bd1*f*fd*r*s - 276*D1**2*bd1*f*fd*r + 684*D1**2*bd1*f*fd*s**2 - 822*D1**2*bd1*f*fd*s + 138*D1**2*bd1*f*fd + 84*D1**2*bd1*f*g2*s**2 - 168*D1**2*bd1*f*g2*s + 84*D1**2*bd1*f*g2 - 84*D1**2*bd1*f*gd2*s**2 + 84*D1**2*bd1*f*gd2*s - 84*D1**2*bd1*fd*g2*s**2 + 84*D1**2*bd1*fd*g2*s + 168*D1**2*bd2*f**2*s**2 - 420*D1**2*bd2*f*fd*s**2 + 210*D1**2*bd2*f*fd*s + 138*D1**2*bdd1*f**2*r*s - 138*D1**2*bdd1*f**2*r + 171*D1**2*bdd1*f**2*s**2 - 342*D1**2*bdd1*f**2*s + 171*D1**2*bdd1*f**2 - 42*D1**2*bdd1*f*g2*s**2 + 84*D1**2*bdd1*f*g2*s - 42*D1**2*bdd1*f*g2 - 105*D1**2*bdd2*f**2*s**2 + 90*D1**2*f**2*fd*r*s - 30*D1**2*f**2*fd*r - 360*D1**2*f**2*fd*s**2 + 210*D1**2*f**2*fd*s - 120*D1**2*f**2*fd + 225*D1**2*f**2*fdd*s**2 - 150*D1**2*f**2*fdd*s + 75*D1**2*f**2*fdd - 336*D1**2*f**2*gd2*s**2 + 210*D1**2*f**2*gdd2*s**2 + 450*D1**2*f*fd**2*s**2 - 300*D1**2*f*fd**2*s - 672*D1**2*f*fd*g2*s**2 + 672*D1**2*f*fd*g2*s - 336*D1**2*f*fd*g2 + 840*D1**2*f*fd*gd2*s**2 - 420*D1**2*f*fd*gd2*s + 420*D1**2*f*fdd*g2*s**2 - 420*D1**2*f*fdd*g2*s + 210*D1**2*f*fdd*g2 + 420*D1**2*fd**2*g2*s**2 - 420*D1**2*fd**2*g2*s - 840*D1*Dd*K*bd1*f**2*s**2 + 210*D1*Dd*K*bd1*f**2*s + 1104*D1*Dd*bd1*f**2*r*s - 690*D1*Dd*bd1*f**2*r + 1368*D1*Dd*bd1*f**2*s**2 - 1986*D1*Dd*bd1*f**2*s + 618*D1*Dd*bd1*f**2 - 336*D1*Dd*bd1*f*g2*s**2 + 420*D1*Dd*bd1*f*g2*s - 84*D1*Dd*bd1*f*g2 - 840*D1*Dd*bd2*f**2*s**2 + 210*D1*Dd*bd2*f**2*s + 120*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r - 480*D1*Dd*f**3*s**2 + 180*D1*Dd*f**3*s - 120*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*s**2 - 1050*D1*Dd*f**2*fd*s + 150*D1*Dd*f**2*fd - 1344*D1*Dd*f**2*g2*s**2 + 672*D1*Dd*f**2*g2*s - 336*D1*Dd*f**2*g2 + 1680*D1*Dd*f**2*gd2*s**2 - 420*D1*Dd*f**2*gd2*s + 3360*D1*Dd*f*fd*g2*s**2 - 2520*D1*Dd*f*fd*g2*s + 420*D1*Dd*f*fd*g2 + 300*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 840*D1*Ddd*f**2*g2*s**2 - 420*D1*Ddd*f**2*g2*s + 210*D1*Ddd*f**2*g2 + 900*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 2520*Dd**2*f**2*g2*s**2 - 1260*Dd**2*f**2*g2*s - 7*b1**3*(3*D1**2*s**2*(2*fd - fdd) + D1*(2*Dd*(20*K*(4*s**2 - 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s - 80*s**2 + 40*s - 20) - Ddd*(35*K + 3*f - 35)*(4*s**2 - 2*s + 1)) - 6*Dd**2*s*(2*s - 1)*(35*K + 3*f - 35)) - 7*b1**2*(48*C*D1**2*fd*s**2 - 34*C*D1**2*fdd*s**2 + 192*C*D1*Dd*f*s**2 - 96*C*D1*Dd*f*s + 48*C*D1*Dd*f - 272*C*D1*Dd*fd*s**2 + 68*C*D1*Dd*fd*s - 136*C*D1*Ddd*f*s**2 + 68*C*D1*Ddd*f*s - 34*C*D1*Ddd*f - 408*C*Dd**2*f*s**2 + 204*C*Dd**2*f*s + 6*D1**2*K*fd*s**2 - 3*D1**2*K*fdd*s**2 - D1**2*bdd1*(35*K + 3*f - 35)*(3*s**2 - 2*s + 1) + 72*D1**2*f*fd*r*s + 96*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s - 24*D1**2*f*fd - 72*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s + 15*D1**2*f*fdd - 72*D1**2*fd**2*r*s - 60*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s + 32*D1**2*fd*r*s + 16*D1**2*fd*s**2 - 26*D1**2*fdd*r*s - 8*D1**2*fdd*s**2 - 80*D1**2*gd2*s**2 + 70*D1**2*gdd2*s**2 + 24*D1*Dd*K*f*s**2 - 12*D1*Dd*K*f*s + 6*D1*Dd*K*f - 24*D1*Dd*K*fd*s**2 + 6*D1*Dd*K*fd*s + 144*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 168*D1*Dd*f**2*s + 48*D1*Dd*f**2 - 576*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 24*D1*Dd*f*fd + 128*D1*Dd*f*r*s - 32*D1*Dd*f*r + 64*D1*Dd*f*s**2 - 96*D1*Dd*f*s + 16*D1*Dd*f - 208*D1*Dd*fd*r*s + 26*D1*Dd*fd*r - 64*D1*Dd*fd*s**2 + 68*D1*Dd*fd*s - 320*D1*Dd*g2*s**2 + 160*D1*Dd*g2*s - 80*D1*Dd*g2 + 560*D1*Dd*gd2*s**2 - 140*D1*Dd*gd2*s - 12*D1*Ddd*K*f*s**2 + 6*D1*Ddd*K*f*s - 3*D1*Ddd*K*f - 144*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 132*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 - 104*D1*Ddd*f*r*s + 26*D1*Ddd*f*r - 32*D1*Ddd*f*s**2 + 68*D1*Ddd*f*s - 8*D1*Ddd*f + 280*D1*Ddd*g2*s**2 - 140*D1*Ddd*g2*s + 70*D1*Ddd*g2 + 2*D1*bd1*(D1*(20*K*(3*s**2 - 2*s + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s - 60*s**2 + 40*s - 20) - Dd*(35*K + 3*f - 35)*(12*s**2 - 7*s + 1)) - 36*Dd**2*K*f*s**2 + 18*Dd**2*K*f*s - 432*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 396*Dd**2*f**2*s - 72*Dd**2*f**2 - 312*Dd**2*f*r*s + 78*Dd**2*f*r - 96*Dd**2*f*s**2 + 204*Dd**2*f*s - 52*Dd**2*f + 840*Dd**2*g2*s**2 - 420*Dd**2*g2*s) + b1*(14*D1**2*bd1**2*s*(3*s - 2)*(35*K + 3*f - 35) + 7*D1**2*bdd1*(3*f**2*(12*r*(2*s - 1) + 20*s**2 - 36*s + 15) + f*(34*C*(2*s**2 - 2*s + 1) + K*(6*s**2 - 6*s + 3) + 52*r*s - 26*r + 16*s**2 - 42*s + 8) - 70*g2*(2*s**2 - 2*s + 1)) - 3*D1**2*(f*(35*K*fdd*(2*s**2 - 2*s + 1) + 2*fd*(-28*K*(2*s**2 - 2*s + 1) + r*(50*s + 7) + 2*s*(10*C*s + 43*s - 16)) - 2*fdd*s*(46*r + s*(10*C + 57) - 23) + s**2*(14*bd2 - 7*bdd2 - 28*gd2 + 14*gdd2)) - 2*s*(fd**2*(10*C*s - 35*K*(s - 1) + 46*r + 57*s - 23) + 7*fd*s*(bd2 + 2*g2 - 2*gd2) - 7*fdd*g2*s)) - 14*D1*bd1*(D1*(-68*C*fd*s**2 + 34*C*fd*s - 6*K*fd*s**2 + 3*K*fd*s + 3*f**2*(6*r*(2*s - 1) + 16*s**2 - 27*s + 12) + f*(24*C*(2*s**2 - 2*s + 1) + 6*K*s**2 - 6*K*s + 3*K - 3*fd*(48*r*s - 12*r + 40*s**2 - 44*s + 9) + 32*r*s - 16*r + 16*s**2 - 32*s + 8) - 52*fd*r*s + 13*fd*r - 16*fd*s**2 + 21*fd*s - 80*g2*s**2 + 80*g2*s - 40*g2 + 140*gd2*s**2 - 70*gd2*s) - Dd*(6*f**2*(6*r*(8*s - 3) + 40*s**2 - 58*s + 15) + f*(34*C*(8*s**2 - 6*s + 1) + 3*K*(8*s**2 - 6*s + 1) + 208*r*s - 78*r + 64*s**2 - 152*s + 47) - 70*g2*(8*s**2 - 6*s + 1))) - 3*D1*(2*Dd*(f**2*(10*C*(4*s**2 - 2*s + 1) - 28*K*(4*s**2 - 2*s + 1) + 100*r*s - 25*r + 172*s**2 - 136*s + 43) + f*(fd*(-80*C*s**2 + 20*C*s + 35*K*(8*s**2 - 6*s + 1) - 368*r*s + 46*r - 456*s**2 + 298*s - 23) - 7*g2*(8*s**2 - 4*s + 2) - 7*s*(bd2 - 2*gd2)*(4*s - 1)) + 14*fd*g2*s*(4*s - 1)) + Ddd*f*(f*(-10*C*(4*s**2 - 2*s + 1) + 35*K*(4*s**2 - 2*s + 1) - 184*r*s + 46*r - 228*s**2 + 206*s - 57) + 14*g2*(4*s**2 - 2*s + 1))) + 6*Dd**2*f*(f*(69*r*(4*s - 1) + s**2*(60*C - 210*K + 342) - s*(30*C - 105*K + 309) + 46) + 42*g2*s*(1 - 2*s)) - 21*b2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))) - 21*b2*(-D1**2*bdd1*f*(s - 1)**2 - 16*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 10*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s - 32*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 80*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 10*D1*Dd*f*fd + 20*D1*Ddd*f**2*s**2 - 10*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) + 60*Dd**2*f**2*s**2 - 30*Dd**2*f**2*s))/(210*d**2*k2*k3**2) + 4*D1**2*Pk3*Pkd2*ct**2*k2**5*st**4*(D1**2*(f**2*(fd*(4*C - 2)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(2*C - 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-3*K*(-2*bd1 + bdd1) - 12*gd2 + 6*gdd2)) + f*(-fd**2*(2*C - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 3*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) + 3*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 3*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(4*C - 2)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(3*K*(b1*r*(8*s - 2) + 2*b1*(1 - 2*s)**2 + bd1*(-8*r*s + r - 8*s**2 + 8*s - 1)) - fd*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 12*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 6*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 6*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(3*K*b1 + f*(2*C - 1) - 6*g2)) - Dd**2*f**2*(3*K*b1 + f*(2*C - 1) - 6*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(7*d**2*k3**6) + 8*D1**2*Pk3*Pkd2*ct**2*k2**5*st**2*(24*C*D1**2*b1*f*fd*r*s + 24*C*D1**2*b1*f*fd*s**2 - 12*C*D1**2*b1*f*fd*s - 12*C*D1**2*b1*f*fdd*r*s - 12*C*D1**2*b1*f*fdd*s**2 + 6*C*D1**2*b1*f*fdd*s - 12*C*D1**2*b1*fd**2*r*s - 12*C*D1**2*b1*fd**2*s**2 + 6*C*D1**2*b1*fd**2*s - 18*C*D1**2*f**2*fd*r*s + 6*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 18*C*D1**2*f**2*fd*s - 6*C*D1**2*f**2*fd + 48*C*D1*Dd*b1*f**2*r*s - 12*C*D1*Dd*b1*f**2*r + 48*C*D1*Dd*b1*f**2*s**2 - 48*C*D1*Dd*b1*f**2*s + 12*C*D1*Dd*b1*f**2 - 96*C*D1*Dd*b1*f*fd*r*s + 12*C*D1*Dd*b1*f*fd*r - 96*C*D1*Dd*b1*f*fd*s**2 + 72*C*D1*Dd*b1*f*fd*s - 6*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r*s + 6*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 24*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 24*C*D1*Ddd*b1*f**2*r*s + 6*C*D1*Ddd*b1*f**2*r - 24*C*D1*Ddd*b1*f**2*s**2 + 24*C*D1*Ddd*b1*f**2*s - 6*C*D1*Ddd*b1*f**2 - 72*C*Dd**2*b1*f**2*r*s + 18*C*Dd**2*b1*f**2*r - 72*C*Dd**2*b1*f**2*s**2 + 72*C*Dd**2*b1*f**2*s - 12*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r*s + 7*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 7*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 12*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*s**2 + 6*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*s**2 - 3*D1**2*b1*f*fdd*s - 28*D1**2*b1*f*gd2*r*s - 28*D1**2*b1*f*gd2*s**2 + 28*D1**2*b1*f*gd2*s + 14*D1**2*b1*f*gdd2*r*s + 14*D1**2*b1*f*gdd2*s**2 - 14*D1**2*b1*f*gdd2*s + 6*D1**2*b1*fd**2*r*s + 6*D1**2*b1*fd**2*s**2 - 3*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r*s + 28*D1**2*b1*fd*gd2*s**2 - 14*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(6*C - 3)*(s - 1) - 14*g2*(s - 1)) + 9*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 9*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r*s + 14*D1**2*f**2*gd2*s**2 - 14*D1**2*f**2*gd2*s + 28*D1**2*f*fd*g2*r*s - 14*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r*s - 14*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 56*D1*Dd*K*b1**2*f*s + 14*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r*s + 7*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 28*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r*s + 7*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 28*D1*Dd*K*b1*f**2*s - 7*D1*Dd*K*b1*f**2 - 24*D1*Dd*b1*f**2*r*s + 6*D1*Dd*b1*f**2*r - 24*D1*Dd*b1*f**2*s**2 + 24*D1*Dd*b1*f**2*s - 6*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r*s - 6*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 36*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r*s + 28*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 112*D1*Dd*b1*f*g2*s - 28*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r*s - 14*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 112*D1*Dd*b1*f*gd2*s + 14*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r*s - 14*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 56*D1*Dd*b1*fd*g2*s + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r*s - 14*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 56*D1*Dd*f**2*g2*s + 14*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r*s + 7*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 28*D1*Ddd*K*b1**2*f*s - 7*D1*Ddd*K*b1**2*f + 12*D1*Ddd*b1*f**2*r*s - 3*D1*Ddd*b1*f**2*r + 12*D1*Ddd*b1*f**2*s**2 - 12*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r*s - 14*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 56*D1*Ddd*b1*f*g2*s + 14*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(12*C*(s - 1) - s*(7*K + 6) + 6) + f*(-fd*(6*C - 3)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(-14*r - 14*s + 14)) + 7*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(-7*K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - f*(6*C - 3)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 14*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 84*Dd**2*K*b1**2*f*r*s + 21*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 84*Dd**2*K*b1**2*f*s - 14*Dd**2*K*b1**2*f + 36*Dd**2*b1*f**2*r*s - 9*Dd**2*b1*f**2*r + 36*Dd**2*b1*f**2*s**2 - 36*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r*s - 42*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 168*Dd**2*b1*f*g2*s + 28*Dd**2*b1*f*g2)/(35*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**2*k2**3*st**4*(-1824*C*D1**2*f**2*fd*r*s + 608*C*D1**2*f**2*fd*r - 540*C*D1**2*f**2*fd*s**2 + 968*C*D1**2*f**2*fd*s - 180*C*D1**2*f**2*fd + 1200*C*D1**2*f**2*fdd*r*s - 400*C*D1**2*f**2*fdd*r + 270*C*D1**2*f**2*fdd*s**2 - 580*C*D1**2*f**2*fdd*s + 90*C*D1**2*f**2*fdd + 2400*C*D1**2*f*fd**2*r*s - 800*C*D1**2*f*fd**2*r + 540*C*D1**2*f*fd**2*s**2 - 1160*C*D1**2*f*fd**2*s + 400*C*D1**2*f*fd**2 - 2432*C*D1*Dd*f**3*r*s + 608*C*D1*Dd*f**3*r - 720*C*D1*Dd*f**3*s**2 + 1576*C*D1*Dd*f**3*s - 180*C*D1*Dd*f**3 + 9600*C*D1*Dd*f**2*fd*r*s - 2800*C*D1*Dd*f**2*fd*r + 2160*C*D1*Dd*f**2*fd*s**2 - 5260*C*D1*Dd*f**2*fd*s + 1380*C*D1*Dd*f**2*fd + 1600*C*D1*Ddd*f**3*r*s - 400*C*D1*Ddd*f**3*r + 360*C*D1*Ddd*f**3*s**2 - 980*C*D1*Ddd*f**3*s + 90*C*D1*Ddd*f**3 + 4800*C*Dd**2*f**3*r*s - 1200*C*Dd**2*f**3*r + 1080*C*Dd**2*f**3*s**2 - 2940*C*Dd**2*f**3*s + 800*C*Dd**2*f**3 - 1440*D1**2*K*b1*f*fd*r*s + 720*D1**2*K*b1*f*fd*r - 540*D1**2*K*b1*f*fd*s**2 + 540*D1**2*K*b1*f*fd*s - 270*D1**2*K*b1*f*fd + 720*D1**2*K*b1*f*fdd*r*s - 360*D1**2*K*b1*f*fdd*r + 270*D1**2*K*b1*f*fdd*s**2 - 270*D1**2*K*b1*f*fdd*s + 135*D1**2*K*b1*f*fdd + 720*D1**2*K*b1*fd**2*r*s - 360*D1**2*K*b1*fd**2*r + 270*D1**2*K*b1*fd**2*s**2 - 270*D1**2*K*b1*fd**2*s + 360*D1**2*K*bdd1*f**2*r*s + 135*D1**2*K*bdd1*f**2*s**2 - 360*D1**2*K*bdd1*f**2*s + 270*D1**2*b1*f**2*fd*r*s - 90*D1**2*b1*f**2*fd*r - 90*D1**2*b1*f**2*fd*s - 270*D1**2*b1*f**2*fdd*r*s + 90*D1**2*b1*f**2*fdd*r + 90*D1**2*b1*f**2*fdd*s - 540*D1**2*b1*f*fd**2*r*s + 180*D1**2*b1*f*fd**2*r + 180*D1**2*b1*f*fd**2*s - 90*D1**2*b1*f*fd**2 + 360*D1**2*b1*f*fd*r*s - 180*D1**2*b1*f*fd*r - 180*D1**2*b1*f*fdd*r*s + 90*D1**2*b1*f*fdd*r - 180*D1**2*b1*fd**2*r*s + 90*D1**2*b1*fd**2*r - 360*D1**2*bd2*f**2*r*s - 360*D1**2*bd2*f**2*s**2 + 360*D1**2*bd2*f**2*s + 720*D1**2*bd2*f*fd*r*s - 180*D1**2*bd2*f*fd*r + 720*D1**2*bd2*f*fd*s**2 - 720*D1**2*bd2*f*fd*s + 180*D1**2*bd2*f*fd - 90*D1**2*bdd1*f**3*r*s + 90*D1**2*bdd1*f**3*s - 90*D1**2*bdd1*f**2*r*s + 90*D1**2*bdd1*f**2*s + 180*D1**2*bdd2*f**2*r*s + 180*D1**2*bdd2*f**2*s**2 - 180*D1**2*bdd2*f**2*s + 1188*D1**2*f**2*fd*r*s - 396*D1**2*f**2*fd*r + 270*D1**2*f**2*fd*s**2 - 576*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 810*D1**2*f**2*fdd*r*s + 270*D1**2*f**2*fdd*r - 135*D1**2*f**2*fdd*s**2 + 360*D1**2*f**2*fdd*s - 45*D1**2*f**2*fdd + 1440*D1**2*f**2*gd2*r*s + 540*D1**2*f**2*gd2*s**2 - 1440*D1**2*f**2*gd2*s - 720*D1**2*f**2*gdd2*r*s - 270*D1**2*f**2*gdd2*s**2 + 720*D1**2*f**2*gdd2*s - 1620*D1**2*f*fd**2*r*s + 540*D1**2*f*fd**2*r - 270*D1**2*f*fd**2*s**2 + 720*D1**2*f*fd**2*s - 270*D1**2*f*fd**2 + 2880*D1**2*f*fd*g2*r*s - 1440*D1**2*f*fd*g2*r + 1080*D1**2*f*fd*g2*s**2 - 1080*D1**2*f*fd*g2*s + 540*D1**2*f*fd*g2 - 2880*D1**2*f*fd*gd2*r*s + 720*D1**2*f*fd*gd2*r - 1080*D1**2*f*fd*gd2*s**2 + 1980*D1**2*f*fd*gd2*s - 720*D1**2*f*fd*gd2 - 1440*D1**2*f*fdd*g2*r*s + 720*D1**2*f*fdd*g2*r - 540*D1**2*f*fdd*g2*s**2 + 540*D1**2*f*fdd*g2*s - 270*D1**2*f*fdd*g2 - 1440*D1**2*fd**2*g2*r*s + 720*D1**2*fd**2*g2*r - 540*D1**2*fd**2*g2*s**2 + 540*D1**2*fd**2*g2*s - 2880*D1*Dd*K*b1*f**2*r*s + 720*D1*Dd*K*b1*f**2*r - 1080*D1*Dd*K*b1*f**2*s**2 + 1980*D1*Dd*K*b1*f**2*s - 270*D1*Dd*K*b1*f**2 + 5760*D1*Dd*K*b1*f*fd*r*s - 2160*D1*Dd*K*b1*f*fd*r + 2160*D1*Dd*K*b1*f*fd*s**2 - 3060*D1*Dd*K*b1*f*fd*s + 990*D1*Dd*K*b1*f*fd + 360*D1*Dd*b1*f**3*r*s - 90*D1*Dd*b1*f**3*r - 180*D1*Dd*b1*f**3*s - 2160*D1*Dd*b1*f**2*fd*r*s + 630*D1*Dd*b1*f**2*fd*r + 900*D1*Dd*b1*f**2*fd*s - 270*D1*Dd*b1*f**2*fd + 720*D1*Dd*b1*f**2*r*s - 180*D1*Dd*b1*f**2*r - 360*D1*Dd*b1*f**2*s - 1440*D1*Dd*b1*f*fd*r*s + 540*D1*Dd*b1*f*fd*r + 360*D1*Dd*b1*f*fd*s - 180*D1*Dd*b1*f*fd + 1440*D1*Dd*bd2*f**2*r*s - 180*D1*Dd*bd2*f**2*r + 1440*D1*Dd*bd2*f**2*s**2 - 1440*D1*Dd*bd2*f**2*s + 180*D1*Dd*bd2*f**2 + 1584*D1*Dd*f**3*r*s - 396*D1*Dd*f**3*r + 360*D1*Dd*f**3*s**2 - 972*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 6480*D1*Dd*f**2*fd*r*s + 1890*D1*Dd*f**2*fd*r - 1080*D1*Dd*f**2*fd*s**2 + 3330*D1*Dd*f**2*fd*s - 900*D1*Dd*f**2*fd + 5760*D1*Dd*f**2*g2*r*s - 1440*D1*Dd*f**2*g2*r + 2160*D1*Dd*f**2*g2*s**2 - 3960*D1*Dd*f**2*g2*s + 540*D1*Dd*f**2*g2 - 5760*D1*Dd*f**2*gd2*r*s + 720*D1*Dd*f**2*gd2*r - 2160*D1*Dd*f**2*gd2*s**2 + 4860*D1*Dd*f**2*gd2*s - 720*D1*Dd*f**2*gd2 - 11520*D1*Dd*f*fd*g2*r*s + 4320*D1*Dd*f*fd*g2*r - 4320*D1*Dd*f*fd*g2*s**2 + 6120*D1*Dd*f*fd*g2*s - 1980*D1*Dd*f*fd*g2 + 1440*D1*Ddd*K*b1*f**2*r*s - 360*D1*Ddd*K*b1*f**2*r + 540*D1*Ddd*K*b1*f**2*s**2 - 990*D1*Ddd*K*b1*f**2*s + 135*D1*Ddd*K*b1*f**2 - 360*D1*Ddd*b1*f**3*r*s + 90*D1*Ddd*b1*f**3*r + 180*D1*Ddd*b1*f**3*s - 360*D1*Ddd*b1*f**2*r*s + 90*D1*Ddd*b1*f**2*r + 180*D1*Ddd*b1*f**2*s - 1080*D1*Ddd*f**3*r*s + 270*D1*Ddd*f**3*r - 180*D1*Ddd*f**3*s**2 + 630*D1*Ddd*f**3*s - 45*D1*Ddd*f**3 - 2880*D1*Ddd*f**2*g2*r*s + 720*D1*Ddd*f**2*g2*r - 1080*D1*Ddd*f**2*g2*s**2 + 1980*D1*Ddd*f**2*g2*s - 270*D1*Ddd*f**2*g2 + 90*D1*bd1*f*(D1*(f*s*(K*(-8*r - 3*s + 8) + f*(r - 1) + 2*r - 2) + fd*(K*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + f*(-6*r*s + r + 4*s - 1) - 4*r*s + r + 2*s - 1)) + Dd*f*(K*(32*r*s - 4*r + 12*s**2 - 27*s + 4) + f*(-8*r*s + r + 6*s - 1) - 8*r*s + r + 6*s - 1)) + 4320*Dd**2*K*b1*f**2*r*s - 1080*Dd**2*K*b1*f**2*r + 1620*Dd**2*K*b1*f**2*s**2 - 2970*Dd**2*K*b1*f**2*s + 720*Dd**2*K*b1*f**2 - 1080*Dd**2*b1*f**3*r*s + 270*Dd**2*b1*f**3*r + 540*Dd**2*b1*f**3*s - 180*Dd**2*b1*f**3 - 1080*Dd**2*b1*f**2*r*s + 270*Dd**2*b1*f**2*r + 540*Dd**2*b1*f**2*s - 180*Dd**2*b1*f**2 - 3240*Dd**2*f**3*r*s + 810*Dd**2*f**3*r - 540*Dd**2*f**3*s**2 + 1890*Dd**2*f**3*s - 540*Dd**2*f**3 - 8640*Dd**2*f**2*g2*r*s + 2160*Dd**2*f**2*g2*r - 3240*Dd**2*f**2*g2*s**2 + 5940*Dd**2*f**2*g2*s - 1440*Dd**2*f**2*g2 - 180*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(210*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**2*k2**3*st**2*(-448*C*D1**2*b1*f*fd*r*s - 144*C*D1**2*b1*f*fd*r - 216*C*D1**2*b1*f*fd*s**2 - 64*C*D1**2*b1*f*fd*s + 144*C*D1**2*b1*f*fd + 336*C*D1**2*b1*f*fdd*r*s + 72*C*D1**2*b1*f*fdd*r + 108*C*D1**2*b1*f*fdd*s**2 - 24*C*D1**2*b1*f*fdd*s - 72*C*D1**2*b1*f*fdd + 336*C*D1**2*b1*fd**2*r*s + 72*C*D1**2*b1*fd**2*r + 108*C*D1**2*b1*fd**2*s**2 - 24*C*D1**2*b1*fd**2*s - 72*C*D1**2*b1*fd**2 + 168*C*D1**2*bdd1*f**2*r*s - 240*C*D1**2*bdd1*f**2*r + 54*C*D1**2*bdd1*f**2*s**2 - 252*C*D1**2*bdd1*f**2*s + 126*C*D1**2*bdd1*f**2 + 48*C*D1**2*f**2*fd*r*s - 16*C*D1**2*f**2*fd*r - 216*C*D1**2*f**2*fd*s**2 + 128*C*D1**2*f**2*fd*s - 72*C*D1**2*f**2*fd + 408*C*D1**2*f**2*fdd*r*s - 136*C*D1**2*f**2*fdd*r + 486*C*D1**2*f**2*fdd*s**2 - 460*C*D1**2*f**2*fdd*s + 162*C*D1**2*f**2*fdd + 816*C*D1**2*f*fd**2*r*s - 272*C*D1**2*f*fd**2*r + 972*C*D1**2*f*fd**2*s**2 - 920*C*D1**2*f*fd**2*s + 136*C*D1**2*f*fd**2 - 896*C*D1*Dd*b1*f**2*r*s + 224*C*D1*Dd*b1*f**2*r - 432*C*D1*Dd*b1*f**2*s**2 + 664*C*D1*Dd*b1*f**2*s - 108*C*D1*Dd*b1*f**2 + 2688*C*D1*Dd*b1*f*fd*r*s - 48*C*D1*Dd*b1*f*fd*r + 864*C*D1*Dd*b1*f*fd*s**2 - 984*C*D1*Dd*b1*f*fd*s - 120*C*D1*Dd*b1*f*fd + 64*C*D1*Dd*f**3*r*s - 16*C*D1*Dd*f**3*r - 288*C*D1*Dd*f**3*s**2 + 112*C*D1*Dd*f**3*s - 72*C*D1*Dd*f**3 + 3264*C*D1*Dd*f**2*fd*r*s - 952*C*D1*Dd*f**2*fd*r + 3888*C*D1*Dd*f**2*fd*s**2 - 3628*C*D1*Dd*f**2*fd*s + 732*C*D1*Dd*f**2*fd + 672*C*D1*Ddd*b1*f**2*r*s - 168*C*D1*Ddd*b1*f**2*r + 216*C*D1*Ddd*b1*f**2*s**2 - 444*C*D1*Ddd*b1*f**2*s + 54*C*D1*Ddd*b1*f**2 + 544*C*D1*Ddd*f**3*r*s - 136*C*D1*Ddd*f**3*r + 648*C*D1*Ddd*f**3*s**2 - 596*C*D1*Ddd*f**3*s + 162*C*D1*Ddd*f**3 + 2016*C*Dd**2*b1*f**2*r*s - 504*C*Dd**2*b1*f**2*r + 648*C*Dd**2*b1*f**2*s**2 - 1332*C*Dd**2*b1*f**2*s + 336*C*Dd**2*b1*f**2 + 1632*C*Dd**2*f**3*r*s - 408*C*Dd**2*f**3*r + 1944*C*Dd**2*f**3*s**2 - 1788*C*Dd**2*f**3*s + 272*C*Dd**2*f**3 - 168*D1**2*K*b1**2*fd*r*s - 168*D1**2*K*b1**2*fd*r - 126*D1**2*K*b1**2*fd*s**2 - 336*D1**2*K*b1**2*fd*s + 168*D1**2*K*b1**2*fd + 84*D1**2*K*b1**2*fdd*r*s + 84*D1**2*K*b1**2*fdd*r + 63*D1**2*K*b1**2*fdd*s**2 + 168*D1**2*K*b1**2*fdd*s - 84*D1**2*K*b1**2*fdd + 168*D1**2*K*b1*bdd1*f*r*s - 168*D1**2*K*b1*bdd1*f*r + 126*D1**2*K*b1*bdd1*f*s**2 - 378*D1**2*K*b1*bdd1*f*s + 147*D1**2*K*b1*bdd1*f + 168*D1**2*K*b1*f*fd*r*s - 84*D1**2*K*b1*f*fd*r - 168*D1**2*K*b1*f*fd*s**2 + 168*D1**2*K*b1*f*fd*s - 84*D1**2*K*b1*f*fd + 168*D1**2*K*b1*f*fdd*r*s - 84*D1**2*K*b1*f*fdd*r + 378*D1**2*K*b1*f*fdd*s**2 - 378*D1**2*K*b1*f*fdd*s + 189*D1**2*K*b1*f*fdd + 168*D1**2*K*b1*fd**2*r*s - 84*D1**2*K*b1*fd**2*r + 378*D1**2*K*b1*fd**2*s**2 - 378*D1**2*K*b1*fd**2*s + 84*D1**2*K*bdd1*f**2*r*s + 189*D1**2*K*bdd1*f**2*s**2 - 84*D1**2*K*bdd1*f**2*s + 84*D1**2*b1**2*f*fd*r*s - 42*D1**2*b1**2*f*fd*s - 84*D1**2*b1**2*f*fdd*r*s + 42*D1**2*b1**2*f*fdd*s - 84*D1**2*b1**2*fd**2*r*s + 42*D1**2*b1**2*fd**2*s + 84*D1**2*b1**2*fd*r*s - 42*D1**2*b1**2*fdd*r*s - 168*D1**2*b1*bd2*f*r*s - 168*D1**2*b1*bd2*f*s**2 + 168*D1**2*b1*bd2*f*s + 168*D1**2*b1*bd2*fd*r*s + 168*D1**2*b1*bd2*fd*s**2 - 84*D1**2*b1*bd2*fd*s - 84*D1**2*b1*bdd1*f**2*r*s + 42*D1**2*b1*bdd1*f**2*r + 42*D1**2*b1*bdd1*f**2*s - 84*D1**2*b1*bdd1*f*r*s + 42*D1**2*b1*bdd1*f*r + 42*D1**2*b1*bdd1*f*s + 84*D1**2*b1*bdd2*f*r*s + 84*D1**2*b1*bdd2*f*s**2 - 84*D1**2*b1*bdd2*f*s + 252*D1**2*b1*f*fd*r*s + 114*D1**2*b1*f*fd*r + 108*D1**2*b1*f*fd*s**2 - 24*D1**2*b1*f*fd*s - 72*D1**2*b1*f*fd - 252*D1**2*b1*f*fdd*r*s - 36*D1**2*b1*f*fdd*r - 54*D1**2*b1*f*fdd*s**2 + 54*D1**2*b1*f*fdd*s + 36*D1**2*b1*f*fdd + 336*D1**2*b1*f*gd2*r*s + 252*D1**2*b1*f*gd2*s**2 - 336*D1**2*b1*f*gd2*s - 168*D1**2*b1*f*gdd2*r*s - 126*D1**2*b1*f*gdd2*s**2 + 168*D1**2*b1*f*gdd2*s - 252*D1**2*b1*fd**2*r*s - 36*D1**2*b1*fd**2*r - 54*D1**2*b1*fd**2*s**2 + 54*D1**2*b1*fd**2*s + 36*D1**2*b1*fd**2 + 336*D1**2*b1*fd*g2*r*s + 336*D1**2*b1*fd*g2*r + 252*D1**2*b1*fd*g2*s**2 + 672*D1**2*b1*fd*g2*s - 336*D1**2*b1*fd*g2 - 336*D1**2*b1*fd*gd2*r*s - 168*D1**2*b1*fd*gd2*r - 252*D1**2*b1*fd*gd2*s**2 - 168*D1**2*b1*fd*gd2*s + 168*D1**2*b1*fd*gd2 - 168*D1**2*b1*fdd*g2*r*s - 168*D1**2*b1*fdd*g2*r - 126*D1**2*b1*fdd*g2*s**2 - 336*D1**2*b1*fdd*g2*s + 168*D1**2*b1*fdd*g2 - 42*D1**2*bd1**2*f*(K*(-4*r*(s - 1) - 3*s**2 + 9*s - 4) + f*r*(2*s - 1) - f*s + f + 2*r*s - r - s + 1) + 84*D1**2*bd2*f**2*r*s + 84*D1**2*bd2*f**2*s**2 - 84*D1**2*bd2*f**2*s - 126*D1**2*bdd1*f**2*r*s + 162*D1**2*bdd1*f**2*r - 27*D1**2*bdd1*f**2*s**2 + 126*D1**2*bdd1*f**2*s - 63*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r*s + 336*D1**2*bdd1*f*g2*r - 126*D1**2*bdd1*f*g2*s**2 + 588*D1**2*bdd1*f*g2*s - 294*D1**2*bdd1*f*g2 - 78*D1**2*f**2*fd*r*s + 26*D1**2*f**2*fd*r + 108*D1**2*f**2*fd*s**2 - 46*D1**2*f**2*fd*s + 36*D1**2*f**2*fd - 204*D1**2*f**2*fdd*r*s + 68*D1**2*f**2*fdd*r - 243*D1**2*f**2*fdd*s**2 + 230*D1**2*f**2*fdd*s - 81*D1**2*f**2*fdd - 168*D1**2*f**2*gd2*r*s + 168*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s - 168*D1**2*f**2*gdd2*r*s - 378*D1**2*f**2*gdd2*s**2 + 168*D1**2*f**2*gdd2*s - 408*D1**2*f*fd**2*r*s + 136*D1**2*f*fd**2*r - 486*D1**2*f*fd**2*s**2 + 460*D1**2*f*fd**2*s - 68*D1**2*f*fd**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r + 336*D1**2*f*fd*g2*s**2 - 336*D1**2*f*fd*g2*s + 168*D1**2*f*fd*g2 - 672*D1**2*f*fd*gd2*r*s + 168*D1**2*f*fd*gd2*r - 1512*D1**2*f*fd*gd2*s**2 + 1092*D1**2*f*fd*gd2*s - 168*D1**2*f*fd*gd2 - 336*D1**2*f*fdd*g2*r*s + 168*D1**2*f*fdd*g2*r - 756*D1**2*f*fdd*g2*s**2 + 756*D1**2*f*fdd*g2*s - 378*D1**2*f*fdd*g2 - 336*D1**2*fd**2*g2*r*s + 168*D1**2*fd**2*g2*r - 756*D1**2*fd**2*g2*s**2 + 756*D1**2*fd**2*g2*s - 672*D1*Dd*K*b1**2*f*r*s + 168*D1*Dd*K*b1**2*f*r - 504*D1*Dd*K*b1**2*f*s**2 + 588*D1*Dd*K*b1**2*f*s - 126*D1*Dd*K*b1**2*f + 672*D1*Dd*K*b1**2*fd*r*s + 252*D1*Dd*K*b1**2*fd*r + 504*D1*Dd*K*b1**2*fd*s**2 + 378*D1*Dd*K*b1**2*fd*s - 336*D1*Dd*K*b1**2*fd + 336*D1*Dd*K*b1*f**2*r*s - 84*D1*Dd*K*b1*f**2*r - 336*D1*Dd*K*b1*f**2*s**2 - 84*D1*Dd*K*b1*f**2 + 1344*D1*Dd*K*b1*f*fd*r*s - 504*D1*Dd*K*b1*f*fd*r + 3024*D1*Dd*K*b1*f*fd*s**2 - 2604*D1*Dd*K*b1*f*fd*s + 546*D1*Dd*K*b1*f*fd + 168*D1*Dd*b1**2*f**2*r*s - 42*D1*Dd*b1**2*f**2*r - 84*D1*Dd*b1**2*f**2*s - 672*D1*Dd*b1**2*f*fd*r*s + 84*D1*Dd*b1**2*f*fd*r + 336*D1*Dd*b1**2*f*fd*s - 42*D1*Dd*b1**2*f*fd + 336*D1*Dd*b1**2*f*r*s - 84*D1*Dd*b1**2*f*r - 168*D1*Dd*b1**2*f*s - 336*D1*Dd*b1**2*fd*r*s + 42*D1*Dd*b1**2*fd*r + 84*D1*Dd*b1**2*fd*s + 672*D1*Dd*b1*bd2*f*r*s - 84*D1*Dd*b1*bd2*f*r + 672*D1*Dd*b1*bd2*f*s**2 - 672*D1*Dd*b1*bd2*f*s + 84*D1*Dd*b1*bd2*f + 504*D1*Dd*b1*f**2*r*s - 126*D1*Dd*b1*f**2*r + 216*D1*Dd*b1*f**2*s**2 - 360*D1*Dd*b1*f**2*s + 54*D1*Dd*b1*f**2 - 2016*D1*Dd*b1*f*fd*r*s + 108*D1*Dd*b1*f*fd*r - 432*D1*Dd*b1*f*fd*s**2 + 828*D1*Dd*b1*f*fd*s + 18*D1*Dd*b1*f*fd + 1344*D1*Dd*b1*f*g2*r*s - 336*D1*Dd*b1*f*g2*r + 1008*D1*Dd*b1*f*g2*s**2 - 1176*D1*Dd*b1*f*g2*s + 252*D1*Dd*b1*f*g2 - 1344*D1*Dd*b1*f*gd2*r*s + 168*D1*Dd*b1*f*gd2*r - 1008*D1*Dd*b1*f*gd2*s**2 + 1260*D1*Dd*b1*f*gd2*s - 168*D1*Dd*b1*f*gd2 - 1344*D1*Dd*b1*fd*g2*r*s - 504*D1*Dd*b1*fd*g2*r - 1008*D1*Dd*b1*fd*g2*s**2 - 756*D1*Dd*b1*fd*g2*s + 672*D1*Dd*b1*fd*g2 - 104*D1*Dd*f**3*r*s + 26*D1*Dd*f**3*r + 144*D1*Dd*f**3*s**2 - 20*D1*Dd*f**3*s + 36*D1*Dd*f**3 - 1632*D1*Dd*f**2*fd*r*s + 476*D1*Dd*f**2*fd*r - 1944*D1*Dd*f**2*fd*s**2 + 1814*D1*Dd*f**2*fd*s - 366*D1*Dd*f**2*fd - 672*D1*Dd*f**2*g2*r*s + 168*D1*Dd*f**2*g2*r + 672*D1*Dd*f**2*g2*s**2 + 168*D1*Dd*f**2*g2 - 1344*D1*Dd*f**2*gd2*r*s + 168*D1*Dd*f**2*gd2*r - 3024*D1*Dd*f**2*gd2*s**2 + 1764*D1*Dd*f**2*gd2*s - 168*D1*Dd*f**2*gd2 - 2688*D1*Dd*f*fd*g2*r*s + 1008*D1*Dd*f*fd*g2*r - 6048*D1*Dd*f*fd*g2*s**2 + 5208*D1*Dd*f*fd*g2*s - 1092*D1*Dd*f*fd*g2 + 336*D1*Ddd*K*b1**2*f*r*s - 84*D1*Ddd*K*b1**2*f*r + 252*D1*Ddd*K*b1**2*f*s**2 - 294*D1*Ddd*K*b1**2*f*s + 63*D1*Ddd*K*b1**2*f + 336*D1*Ddd*K*b1*f**2*r*s - 84*D1*Ddd*K*b1*f**2*r + 756*D1*Ddd*K*b1*f**2*s**2 - 546*D1*Ddd*K*b1*f**2*s + 189*D1*Ddd*K*b1*f**2 - 168*D1*Ddd*b1**2*f**2*r*s + 42*D1*Ddd*b1**2*f**2*r + 84*D1*Ddd*b1**2*f**2*s - 168*D1*Ddd*b1**2*f*r*s + 42*D1*Ddd*b1**2*f*r + 84*D1*Ddd*b1**2*f*s - 504*D1*Ddd*b1*f**2*r*s + 126*D1*Ddd*b1*f**2*r - 108*D1*Ddd*b1*f**2*s**2 + 306*D1*Ddd*b1*f**2*s - 27*D1*Ddd*b1*f**2 - 672*D1*Ddd*b1*f*g2*r*s + 168*D1*Ddd*b1*f*g2*r - 504*D1*Ddd*b1*f*g2*s**2 + 588*D1*Ddd*b1*f*g2*s - 126*D1*Ddd*b1*f*g2 - 272*D1*Ddd*f**3*r*s + 68*D1*Ddd*f**3*r - 324*D1*Ddd*f**3*s**2 + 298*D1*Ddd*f**3*s - 81*D1*Ddd*f**3 - 672*D1*Ddd*f**2*g2*r*s + 168*D1*Ddd*f**2*g2*r - 1512*D1*Ddd*f**2*g2*s**2 + 1092*D1*Ddd*f**2*g2*s - 378*D1*Ddd*f**2*g2 + 2*D1*bd1*(-112*C*D1*f**2*r*s + 184*C*D1*f**2*r - 54*C*D1*f**2*s**2 + 252*C*D1*f**2*s - 126*C*D1*f**2 + 336*C*D1*f*fd*r*s - 204*C*D1*f*fd*r + 108*C*D1*f*fd*s**2 - 264*C*D1*f*fd*s + 120*C*D1*f*fd + 672*C*Dd*f**2*r*s - 564*C*Dd*f**2*r + 216*C*Dd*f**2*s**2 - 726*C*Dd*f**2*s + 366*C*Dd*f**2 + 42*D1*K*f**2*r*s - 42*D1*K*f**2*s**2 - 42*D1*K*f**2*s + 168*D1*K*f*fd*r*s - 42*D1*K*f*fd*r + 378*D1*K*f*fd*s**2 - 273*D1*K*f*fd*s + 42*D1*K*f*fd + 42*D1*bd2*f*(2*s - 1)*(r + s - 1) + 63*D1*f**2*r*s - 120*D1*f**2*r + 27*D1*f**2*s**2 - 105*D1*f**2*s + 63*D1*f**2 - 252*D1*f*fd*r*s + 144*D1*f*fd*r - 54*D1*f*fd*s**2 + 153*D1*f*fd*s - 81*D1*f*fd + 168*D1*f*g2*r*s - 336*D1*f*g2*r + 126*D1*f*g2*s**2 - 588*D1*f*g2*s + 294*D1*f*g2 - 168*D1*f*gd2*r*s + 168*D1*f*gd2*r - 126*D1*f*gd2*s**2 + 378*D1*f*gd2*s - 168*D1*f*gd2 - 168*D1*fd*g2*r*s + 84*D1*fd*g2*r - 126*D1*fd*g2*s**2 + 126*D1*fd*g2*s + 336*Dd*K*f**2*r*s - 42*Dd*K*f**2*r + 756*Dd*K*f**2*s**2 - 441*Dd*K*f**2*s + 42*Dd*K*f**2 - 504*Dd*f**2*r*s + 387*Dd*f**2*r - 108*Dd*f**2*s**2 + 405*Dd*f**2*s - 225*Dd*f**2 - 672*Dd*f*g2*r*s + 756*Dd*f*g2*r - 504*Dd*f*g2*s**2 + 1470*Dd*f*g2*s - 630*Dd*f*g2 - 21*b1*(D1*(f**2*(-2*r*s + r + s) + f*(K*(8*r*(s - 1) + 6*s**2 - 18*s + 7) + fd*(2*r - 1)*(4*s - 1) - 4*r*s + 2*r + 2*s) - fd*(K*(6*s**2 + s*(8*r - 1) - 2) - 4*r*s + r + s)) + Dd*f*(K*(-32*r*s + 20*r - 24*s**2 + 50*s - 17) + f*(2*r - 1)*(8*s - 3) + (2*r - 1)*(8*s - 3)))) + 1008*Dd**2*K*b1**2*f*r*s - 252*Dd**2*K*b1**2*f*r + 756*Dd**2*K*b1**2*f*s**2 - 882*Dd**2*K*b1**2*f*s + 168*Dd**2*K*b1**2*f + 1008*Dd**2*K*b1*f**2*r*s - 252*Dd**2*K*b1*f**2*r + 2268*Dd**2*K*b1*f**2*s**2 - 1638*Dd**2*K*b1*f**2*s + 168*Dd**2*K*b1*f**2 - 504*Dd**2*b1**2*f**2*r*s + 126*Dd**2*b1**2*f**2*r + 252*Dd**2*b1**2*f**2*s - 84*Dd**2*b1**2*f**2 - 504*Dd**2*b1**2*f*r*s + 126*Dd**2*b1**2*f*r + 252*Dd**2*b1**2*f*s - 84*Dd**2*b1**2*f - 1512*Dd**2*b1*f**2*r*s + 378*Dd**2*b1*f**2*r - 324*Dd**2*b1*f**2*s**2 + 918*Dd**2*b1*f**2*s - 252*Dd**2*b1*f**2 - 2016*Dd**2*b1*f*g2*r*s + 504*Dd**2*b1*f*g2*r - 1512*Dd**2*b1*f*g2*s**2 + 1764*Dd**2*b1*f*g2*s - 336*Dd**2*b1*f*g2 - 816*Dd**2*f**3*r*s + 204*Dd**2*f**3*r - 972*Dd**2*f**3*s**2 + 894*Dd**2*f**3*s - 136*Dd**2*f**3 - 2016*Dd**2*f**2*g2*r*s + 504*Dd**2*f**2*g2*r - 4536*Dd**2*f**2*g2*s**2 + 3276*Dd**2*f**2*g2*s - 336*Dd**2*f**2*g2 - 84*b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(105*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**2*k2**3*(D1*(140*D1*b2*bd1*f*(s - 1)*(r + s - 1) + 14*D1*bd1**2*(5*K*f*(r*(4*s - 2) + 5*s**2 - 7*s + 2) - f*(12*C - 6)*(r*(2*s - 1) + s*(2*s - 2)) + 20*g2*r*(2*s - 1) + 40*g2*s*(s - 1)) + D1*bdd1*f*(s - 1)*(f*(6*C - 3)*(44*r + 35*s - 35) - 70*g2*(4*r + 5*s - 5)) - 2*bd1*(D1*(3*f**2*(4*C*(8*r*s - r + 14*s - 7) - 9*r*s - 5*r - 28*s + 14) - 2*f*(fd*(6*C - 3)*(22*r*(2*s - 1) + 35*s**2 - 46*s + 11) + 70*g2*(r + 2*s - 1) + 35*gd2*(-4*r*s + 2*r - 5*s**2 + 7*s - 2)) + 70*fd*g2*(r*(4*s - 2) + s*(5*s - 5))) + Dd*f*(-f*(6*C - 3)*(22*r*(8*s - 5) + 140*s**2 - 219*s + 79) + 70*g2*(2*r*(8*s - 5) + 20*s**2 - 29*s + 9)))) + 140*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 7*b1**2*(D1**2*(48*C*fd*r*s + 48*C*fd*s**2 - 48*C*fd*s - 24*C*fdd*r*s - 24*C*fdd*s**2 + 24*C*fdd*s + 40*K*bd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 20*K*bdd1*(3*r*s - r + 3*s**2 - 3*s + 1) + 20*K*fd*r + 40*K*fd*s - 20*K*fd + 20*K*fdd*r*s + 25*K*fdd*s**2 - 34*fd*r*s - 24*fd*s**2 + 24*fd*s + 12*fdd*r*s + 12*fdd*s**2 - 12*fdd*s - 80*gd2*r*s - 80*gd2*s**2 + 80*gd2*s + 40*gdd2*r*s + 40*gdd2*s**2 - 40*gdd2*s) + D1*(2*Dd*(-10*K*bd1*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + f*(24*C*(r*(4*s - 1) + (1 - 2*s)**2) + r*(17 - 68*s) - 48*s**2 + 58*s - 12) + fd*(-12*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 100*K*s**2 - 45*K*s + r*(10*K + 6)*(8*s - 1) + 48*s**2 - 48*s + 6) - 40*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 20*gd2*(8*r*s - r + 8*s**2 - 8*s + 1)) + Ddd*(f*(-24*C*(r*(4*s - 1) + (1 - 2*s)**2) + 5*K*(4*r*(4*s - 1) + 20*s**2 - 18*s + 5) + 12*r*(4*s - 1) + 12*(1 - 2*s)**2) + 40*g2*(r*(4*s - 1) + (1 - 2*s)**2))) + 2*Dd**2*(f*(-12*C*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 5*K*(24*r*s - 6*r + 30*s**2 - 27*s + 4) + 72*r*s - 18*r + 72*s**2 - 72*s + 12) + 20*g2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))) - b1*(384*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r - 528*C*D1**2*f*fd*s + 168*C*D1**2*f*fd - 528*C*D1**2*f*fdd*r*s - 420*C*D1**2*f*fdd*s**2 + 264*C*D1**2*f*fdd*s - 528*C*D1**2*fd**2*r*s - 420*C*D1**2*fd**2*s**2 + 264*C*D1**2*fd**2*s + 768*C*D1*Dd*f**2*r*s - 192*C*D1*Dd*f**2*r - 384*C*D1*Dd*f**2*s - 4224*C*D1*Dd*f*fd*r*s + 528*C*D1*Dd*f*fd*r - 3360*C*D1*Dd*f*fd*s**2 + 2952*C*D1*Dd*f*fd*s - 264*C*D1*Dd*f*fd - 1056*C*D1*Ddd*f**2*r*s + 264*C*D1*Ddd*f**2*r - 840*C*D1*Ddd*f**2*s**2 + 948*C*D1*Ddd*f**2*s - 210*C*D1*Ddd*f**2 - 3168*C*Dd**2*f**2*r*s + 792*C*Dd**2*f**2*r - 2520*C*Dd**2*f**2*s**2 + 2844*C*Dd**2*f**2*s - 528*C*Dd**2*f**2 + 140*D1**2*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 140*D1**2*b2*fd*r*s - 140*D1**2*b2*fd*s**2 - 140*D1**2*bd2*f*r*s - 140*D1**2*bd2*f*s**2 + 140*D1**2*bd2*f*s + 7*D1**2*bdd1*(f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 5*K*(8*r*s - 4*r + 10*s**2 - 14*s + 5) - 24*r*s + 12*r - 24*s**2 + 24*s - 12) - 40*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 108*D1**2*f*fd*r*s + 84*D1**2*f*fd*r + 222*D1**2*f*fd*s - 84*D1**2*f*fd + 264*D1**2*f*fdd*r*s + 210*D1**2*f*fdd*s**2 - 132*D1**2*f*fdd*s + 280*D1**2*f*gdd2*r*s + 350*D1**2*f*gdd2*s**2 - 280*D1**2*f*gdd2*s + 264*D1**2*fd**2*r*s + 210*D1**2*fd**2*s**2 - 132*D1**2*fd**2*s + 280*D1**2*fd*g2*r + 560*D1**2*fd*g2*s - 280*D1**2*fd*g2 + 560*D1**2*fd*gd2*r*s + 700*D1**2*fd*gd2*s**2 - 280*D1**2*fd*gd2*s + 280*D1**2*fdd*g2*r*s + 350*D1**2*fdd*g2*s**2 - 560*D1*Dd*b2*f*r*s + 140*D1*Dd*b2*f*r - 560*D1*Dd*b2*f*s**2 + 560*D1*Dd*b2*f*s - 140*D1*Dd*b2*f - 216*D1*Dd*f**2*r*s + 54*D1*Dd*f**2*r + 108*D1*Dd*f**2*s + 2112*D1*Dd*f*fd*r*s - 264*D1*Dd*f*fd*r + 1680*D1*Dd*f*fd*s**2 - 1476*D1*Dd*f*fd*s + 132*D1*Dd*f*fd + 2240*D1*Dd*f*gd2*r*s - 280*D1*Dd*f*gd2*r + 2800*D1*Dd*f*gd2*s**2 - 2380*D1*Dd*f*gd2*s + 280*D1*Dd*f*gd2 + 2240*D1*Dd*fd*g2*r*s - 280*D1*Dd*fd*g2*r + 2800*D1*Dd*fd*g2*s**2 - 1260*D1*Dd*fd*g2*s + 528*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 420*D1*Ddd*f**2*s**2 - 474*D1*Ddd*f**2*s + 105*D1*Ddd*f**2 + 1120*D1*Ddd*f*g2*r*s - 280*D1*Ddd*f*g2*r + 1400*D1*Ddd*f*g2*s**2 - 1260*D1*Ddd*f*g2*s + 350*D1*Ddd*f*g2 - 14*D1*bd1*(D1*f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 10*K*(r + 2*s - 1) - 34*r*s + 17*r - 24*s**2 + 29*s - 12) + D1*fd*(-12*C*(r*(4*s - 1) + (1 - 2*s)**2) + 50*K*s**2 - 35*K*s + r*(10*K + 6)*(4*s - 1) + 24*s**2 - 24*s + 6) - 20*D1*(g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*f*(-24*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 5*K*(4*r*(8*s - 3) + 40*s**2 - 46*s + 11) + 12*r*(8*s - 3) + 24*(1 - 2*s)**2) + 40*Dd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + 1584*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 1260*Dd**2*f**2*s**2 - 1422*Dd**2*f**2*s + 264*Dd**2*f**2 + 3360*Dd**2*f*g2*r*s - 840*Dd**2*f*g2*r + 4200*Dd**2*f*g2*s**2 - 3780*Dd**2*f*g2*s + 560*Dd**2*f*g2))/(210*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**2*k2*st**4*(-900*C*D1**2*f**2*fd*s**2 + 600*C*D1**2*f**2*fd*s - 300*C*D1**2*f**2*fd + 450*C*D1**2*f**2*fdd*s**2 - 300*C*D1**2*f**2*fdd*s + 150*C*D1**2*f**2*fdd + 900*C*D1**2*f*fd**2*s**2 - 600*C*D1**2*f*fd**2*s - 1200*C*D1*Dd*f**3*s**2 + 600*C*D1*Dd*f**3*s - 300*C*D1*Dd*f**3 + 3600*C*D1*Dd*f**2*fd*s**2 - 2100*C*D1*Dd*f**2*fd*s + 300*C*D1*Dd*f**2*fd + 600*C*D1*Ddd*f**3*s**2 - 300*C*D1*Ddd*f**3*s + 150*C*D1*Ddd*f**3 + 1800*C*Dd**2*f**3*s**2 - 900*C*Dd**2*f**3*s - 900*D1**2*K*b1*f*fd*s**2 + 900*D1**2*K*b1*f*fd*s - 450*D1**2*K*b1*f*fd + 450*D1**2*K*b1*f*fdd*s**2 - 450*D1**2*K*b1*f*fdd*s + 225*D1**2*K*b1*f*fdd + 450*D1**2*K*b1*fd**2*s**2 - 450*D1**2*K*b1*fd**2*s + 225*D1**2*K*bdd1*f**2*s**2 - 270*D1**2*b1*f**2*fd*r*s + 90*D1**2*b1*f**2*fd*r + 90*D1**2*b1*f**2*fd*s + 270*D1**2*b1*f**2*fdd*r*s - 90*D1**2*b1*f**2*fdd*r - 90*D1**2*b1*f**2*fdd*s + 540*D1**2*b1*f*fd**2*r*s - 180*D1**2*b1*f*fd**2*r - 180*D1**2*b1*f*fd**2*s + 90*D1**2*b1*f*fd**2 - 360*D1**2*b1*f*fd*r*s + 180*D1**2*b1*f*fd*r + 180*D1**2*b1*f*fdd*r*s - 90*D1**2*b1*f*fdd*r + 180*D1**2*b1*fd**2*r*s - 90*D1**2*b1*fd**2*r - 450*D1**2*bd2*f**2*s**2 + 900*D1**2*bd2*f*fd*s**2 - 450*D1**2*bd2*f*fd*s + 90*D1**2*bdd1*f**3*r*s - 90*D1**2*bdd1*f**3*s + 90*D1**2*bdd1*f**2*r*s - 90*D1**2*bdd1*f**2*s + 225*D1**2*bdd2*f**2*s**2 - 276*D1**2*f**2*fd*r*s + 92*D1**2*f**2*fd*r + 450*D1**2*f**2*fd*s**2 - 208*D1**2*f**2*fd*s + 150*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r*s - 70*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 75*D1**2*f**2*fdd + 900*D1**2*f**2*gd2*s**2 - 450*D1**2*f**2*gdd2*s**2 + 420*D1**2*f*fd**2*r*s - 140*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s + 70*D1**2*f*fd**2 + 1800*D1**2*f*fd*g2*s**2 - 1800*D1**2*f*fd*g2*s + 900*D1**2*f*fd*g2 - 1800*D1**2*f*fd*gd2*s**2 + 900*D1**2*f*fd*gd2*s - 900*D1**2*f*fdd*g2*s**2 + 900*D1**2*f*fdd*g2*s - 450*D1**2*f*fdd*g2 - 900*D1**2*fd**2*g2*s**2 + 900*D1**2*fd**2*g2*s - 1800*D1*Dd*K*b1*f**2*s**2 + 900*D1*Dd*K*b1*f**2*s - 450*D1*Dd*K*b1*f**2 + 3600*D1*Dd*K*b1*f*fd*s**2 - 2700*D1*Dd*K*b1*f*fd*s + 450*D1*Dd*K*b1*f*fd - 360*D1*Dd*b1*f**3*r*s + 90*D1*Dd*b1*f**3*r + 180*D1*Dd*b1*f**3*s + 2160*D1*Dd*b1*f**2*fd*r*s - 630*D1*Dd*b1*f**2*fd*r - 900*D1*Dd*b1*f**2*fd*s + 270*D1*Dd*b1*f**2*fd - 720*D1*Dd*b1*f**2*r*s + 180*D1*Dd*b1*f**2*r + 360*D1*Dd*b1*f**2*s + 1440*D1*Dd*b1*f*fd*r*s - 540*D1*Dd*b1*f*fd*r - 360*D1*Dd*b1*f*fd*s + 180*D1*Dd*b1*f*fd + 1800*D1*Dd*bd2*f**2*s**2 - 450*D1*Dd*bd2*f**2*s - 368*D1*Dd*f**3*r*s + 92*D1*Dd*f**3*r + 600*D1*Dd*f**3*s**2 - 116*D1*Dd*f**3*s + 150*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r*s - 490*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 350*D1*Dd*f**2*fd*s + 60*D1*Dd*f**2*fd + 3600*D1*Dd*f**2*g2*s**2 - 1800*D1*Dd*f**2*g2*s + 900*D1*Dd*f**2*g2 - 3600*D1*Dd*f**2*gd2*s**2 + 900*D1*Dd*f**2*gd2*s - 7200*D1*Dd*f*fd*g2*s**2 + 5400*D1*Dd*f*fd*g2*s - 900*D1*Dd*f*fd*g2 + 900*D1*Ddd*K*b1*f**2*s**2 - 450*D1*Ddd*K*b1*f**2*s + 225*D1*Ddd*K*b1*f**2 + 360*D1*Ddd*b1*f**3*r*s - 90*D1*Ddd*b1*f**3*r - 180*D1*Ddd*b1*f**3*s + 360*D1*Ddd*b1*f**2*r*s - 90*D1*Ddd*b1*f**2*r - 180*D1*Ddd*b1*f**2*s + 280*D1*Ddd*f**3*r*s - 70*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 10*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 1800*D1*Ddd*f**2*g2*s**2 + 900*D1*Ddd*f**2*g2*s - 450*D1*Ddd*f**2*g2 - 90*D1*bd1*f*(D1*(f*s*(5*K*s + f*(r - 1) + 2*r - 2) + fd*(f*(-6*r*s + r + 4*s - 1) - 4*r*s + r - (2*s - 1)*(5*K*s - 1))) - Dd*f*(20*K*s**2 - 5*K*s + f*r*(8*s - 1) - 6*f*s + f + r*(8*s - 1) - 6*s + 1)) + 2700*Dd**2*K*b1*f**2*s**2 - 1350*Dd**2*K*b1*f**2*s + 1080*Dd**2*b1*f**3*r*s - 270*Dd**2*b1*f**3*r - 540*Dd**2*b1*f**3*s + 180*Dd**2*b1*f**3 + 1080*Dd**2*b1*f**2*r*s - 270*Dd**2*b1*f**2*r - 540*Dd**2*b1*f**2*s + 180*Dd**2*b1*f**2 + 840*Dd**2*f**3*r*s - 210*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 30*Dd**2*f**3*s + 140*Dd**2*f**3 - 5400*Dd**2*f**2*g2*s**2 + 2700*Dd**2*f**2*g2*s - 225*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(210*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**2*k2*st**2*(-448*C*D1**2*b1*f*fd*r*s + 224*C*D1**2*b1*f*fd*r + 152*C*D1**2*b1*f*fd*s + 36*C*D1**2*b1*f*fd + 336*C*D1**2*b1*f*fdd*r*s - 168*C*D1**2*b1*f*fdd*r - 132*C*D1**2*b1*f*fdd*s - 18*C*D1**2*b1*f*fdd + 336*C*D1**2*b1*fd**2*r*s - 168*C*D1**2*b1*fd**2*r - 132*C*D1**2*b1*fd**2*s + 168*C*D1**2*b1*fd**2 + 168*C*D1**2*bdd1*f**2*r*s - 36*C*D1**2*bdd1*f**2*s + 18*C*D1**2*bdd1*f**2 + 384*C*D1**2*f**2*fd*r*s - 128*C*D1**2*f**2*fd*r + 648*C*D1**2*f**2*fd*s**2 - 560*C*D1**2*f**2*fd*s + 216*C*D1**2*f**2*fd - 408*C*D1**2*f**2*fdd*r*s + 136*C*D1**2*f**2*fdd*r - 486*C*D1**2*f**2*fdd*s**2 + 460*C*D1**2*f**2*fdd*s - 162*C*D1**2*f**2*fdd - 816*C*D1**2*f*fd**2*r*s + 272*C*D1**2*f*fd**2*r - 972*C*D1**2*f*fd**2*s**2 + 920*C*D1**2*f*fd**2*s - 136*C*D1**2*f*fd**2 - 896*C*D1*Dd*b1*f**2*r*s + 224*C*D1*Dd*b1*f**2*r + 448*C*D1*Dd*b1*f**2*s + 2688*C*D1*Dd*b1*f*fd*r*s - 1008*C*D1*Dd*b1*f*fd*r - 1200*C*D1*Dd*b1*f*fd*s + 468*C*D1*Dd*b1*f*fd + 512*C*D1*Dd*f**3*r*s - 128*C*D1*Dd*f**3*r + 864*C*D1*Dd*f**3*s**2 - 688*C*D1*Dd*f**3*s + 216*C*D1*Dd*f**3 - 3264*C*D1*Dd*f**2*fd*r*s + 952*C*D1*Dd*f**2*fd*r - 3888*C*D1*Dd*f**2*fd*s**2 + 3628*C*D1*Dd*f**2*fd*s - 732*C*D1*Dd*f**2*fd + 672*C*D1*Ddd*b1*f**2*r*s - 168*C*D1*Ddd*b1*f**2*r - 336*C*D1*Ddd*b1*f**2*s - 544*C*D1*Ddd*f**3*r*s + 136*C*D1*Ddd*f**3*r - 648*C*D1*Ddd*f**3*s**2 + 596*C*D1*Ddd*f**3*s - 162*C*D1*Ddd*f**3 + 2016*C*Dd**2*b1*f**2*r*s - 504*C*Dd**2*b1*f**2*r - 1008*C*Dd**2*b1*f**2*s + 336*C*Dd**2*b1*f**2 - 1632*C*Dd**2*f**3*r*s + 408*C*Dd**2*f**3*r - 1944*C*Dd**2*f**3*s**2 + 1788*C*Dd**2*f**3*s - 272*C*Dd**2*f**3 - 168*D1**2*K*b1**2*fd*r*s + 168*D1**2*K*b1**2*fd*r - 84*D1**2*K*b1**2*fd*s + 42*D1**2*K*b1**2*fd + 84*D1**2*K*b1**2*fdd*r*s - 84*D1**2*K*b1**2*fdd*r + 42*D1**2*K*b1**2*fdd*s - 21*D1**2*K*b1**2*fdd + 168*D1**2*K*b1*bdd1*f*r*s - 126*D1**2*K*b1*bdd1*f*s + 21*D1**2*K*b1*bdd1*f + 168*D1**2*K*b1*f*fd*r*s - 84*D1**2*K*b1*f*fd*r + 504*D1**2*K*b1*f*fd*s**2 - 504*D1**2*K*b1*f*fd*s + 252*D1**2*K*b1*f*fd - 168*D1**2*K*b1*f*fdd*r*s + 84*D1**2*K*b1*f*fdd*r - 378*D1**2*K*b1*f*fdd*s**2 + 378*D1**2*K*b1*f*fdd*s - 189*D1**2*K*b1*f*fdd - 168*D1**2*K*b1*fd**2*r*s + 84*D1**2*K*b1*fd**2*r - 378*D1**2*K*b1*fd**2*s**2 + 378*D1**2*K*b1*fd**2*s - 84*D1**2*K*bdd1*f**2*r*s - 189*D1**2*K*bdd1*f**2*s**2 + 84*D1**2*K*bdd1*f**2*s - 42*D1**2*b1**2*f*fd*r + 42*D1**2*b1**2*f*fdd*r + 42*D1**2*b1**2*fd**2*r - 42*D1**2*b1**2*fd**2 - 84*D1**2*b1**2*fd*r + 42*D1**2*b1**2*fdd*r - 42*D1**2*b1*bd2*f*s**2 + 42*D1**2*b1*bd2*fd*s**2 - 42*D1**2*b1*bdd1*f**2*r - 42*D1**2*b1*bdd1*f*r + 21*D1**2*b1*bdd2*f*s**2 + 308*D1**2*b1*f*fd*r*s - 210*D1**2*b1*f*fd*r - 76*D1**2*b1*f*fd*s - 18*D1**2*b1*f*fd - 168*D1**2*b1*f*fdd*r*s + 126*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s + 9*D1**2*b1*f*fdd + 336*D1**2*b1*f*gd2*r*s - 336*D1**2*b1*f*gd2*s - 168*D1**2*b1*f*gdd2*r*s + 168*D1**2*b1*f*gdd2*s - 168*D1**2*b1*fd**2*r*s + 126*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s - 126*D1**2*b1*fd**2 + 336*D1**2*b1*fd*g2*r*s - 336*D1**2*b1*fd*g2*r + 168*D1**2*b1*fd*g2*s - 84*D1**2*b1*fd*g2 - 336*D1**2*b1*fd*gd2*r*s + 168*D1**2*b1*fd*gd2*r + 84*D1**2*b1*fd*gd2*s - 168*D1**2*b1*fd*gd2 - 168*D1**2*b1*fdd*g2*r*s + 168*D1**2*b1*fdd*g2*r - 84*D1**2*b1*fdd*g2*s + 42*D1**2*b1*fdd*g2 - 42*D1**2*bd1**2*f*(-4*K*r*s + 3*K*s + f*(r - 1) + r - 1) + 84*D1**2*bd2*f**2*r*s + 252*D1**2*bd2*f**2*s**2 - 84*D1**2*bd2*f**2*s - 336*D1**2*bd2*f*fd*r*s + 84*D1**2*bd2*f*fd*r - 756*D1**2*bd2*f*fd*s**2 + 546*D1**2*bd2*f*fd*s - 84*D1**2*bd2*f*fd - 84*D1**2*bdd1*f**2*r*s - 42*D1**2*bdd1*f**2*r + 18*D1**2*bdd1*f**2*s - 9*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*s - 42*D1**2*bdd1*f*g2 - 84*D1**2*bdd2*f**2*r*s - 189*D1**2*bdd2*f**2*s**2 + 84*D1**2*bdd2*f**2*s - 138*D1**2*f**2*fd*r*s + 46*D1**2*f**2*fd*r - 324*D1**2*f**2*fd*s**2 + 262*D1**2*f**2*fd*s - 108*D1**2*f**2*fd + 204*D1**2*f**2*fdd*r*s - 68*D1**2*f**2*fdd*r + 243*D1**2*f**2*fdd*s**2 - 230*D1**2*f**2*fdd*s + 81*D1**2*f**2*fdd - 168*D1**2*f**2*gd2*r*s - 504*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s + 168*D1**2*f**2*gdd2*r*s + 378*D1**2*f**2*gdd2*s**2 - 168*D1**2*f**2*gdd2*s + 408*D1**2*f*fd**2*r*s - 136*D1**2*f*fd**2*r + 486*D1**2*f*fd**2*s**2 - 460*D1**2*f*fd**2*s + 68*D1**2*f*fd**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r - 1008*D1**2*f*fd*g2*s**2 + 1008*D1**2*f*fd*g2*s - 504*D1**2*f*fd*g2 + 672*D1**2*f*fd*gd2*r*s - 168*D1**2*f*fd*gd2*r + 1512*D1**2*f*fd*gd2*s**2 - 1092*D1**2*f*fd*gd2*s + 168*D1**2*f*fd*gd2 + 336*D1**2*f*fdd*g2*r*s - 168*D1**2*f*fdd*g2*r + 756*D1**2*f*fdd*g2*s**2 - 756*D1**2*f*fdd*g2*s + 378*D1**2*f*fdd*g2 + 336*D1**2*fd**2*g2*r*s - 168*D1**2*fd**2*g2*r + 756*D1**2*fd**2*g2*s**2 - 756*D1**2*fd**2*g2*s - 672*D1*Dd*K*b1**2*f*r*s + 168*D1*Dd*K*b1**2*f*r + 336*D1*Dd*K*b1**2*f*s + 672*D1*Dd*K*b1**2*fd*r*s - 420*D1*Dd*K*b1**2*fd*r + 126*D1*Dd*K*b1**2*fd + 336*D1*Dd*K*b1*f**2*r*s - 84*D1*Dd*K*b1*f**2*r + 1008*D1*Dd*K*b1*f**2*s**2 - 672*D1*Dd*K*b1*f**2*s + 252*D1*Dd*K*b1*f**2 - 1344*D1*Dd*K*b1*f*fd*r*s + 504*D1*Dd*K*b1*f*fd*r - 3024*D1*Dd*K*b1*f*fd*s**2 + 2604*D1*Dd*K*b1*f*fd*s - 546*D1*Dd*K*b1*f*fd + 168*D1*Dd*b1**2*f*fd*r - 84*D1*Dd*b1**2*f*fd + 168*D1*Dd*b1**2*fd*r - 84*D1*Dd*b1**2*fd + 168*D1*Dd*b1*bd2*f*s**2 - 42*D1*Dd*b1*bd2*f*s + 616*D1*Dd*b1*f**2*r*s - 154*D1*Dd*b1*f**2*r - 308*D1*Dd*b1*f**2*s - 1344*D1*Dd*b1*f*fd*r*s + 672*D1*Dd*b1*f*fd*r + 600*D1*Dd*b1*f*fd*s - 318*D1*Dd*b1*f*fd + 1344*D1*Dd*b1*f*g2*r*s - 336*D1*Dd*b1*f*g2*r - 672*D1*Dd*b1*f*g2*s - 1344*D1*Dd*b1*f*gd2*r*s + 168*D1*Dd*b1*f*gd2*r + 1008*D1*Dd*b1*f*gd2*s - 168*D1*Dd*b1*f*gd2 - 1344*D1*Dd*b1*fd*g2*r*s + 840*D1*Dd*b1*fd*g2*r - 252*D1*Dd*b1*fd*g2 - 672*D1*Dd*bd2*f**2*r*s + 84*D1*Dd*bd2*f**2*r - 1512*D1*Dd*bd2*f**2*s**2 + 882*D1*Dd*bd2*f**2*s - 84*D1*Dd*bd2*f**2 - 184*D1*Dd*f**3*r*s + 46*D1*Dd*f**3*r - 432*D1*Dd*f**3*s**2 + 308*D1*Dd*f**3*s - 108*D1*Dd*f**3 + 1632*D1*Dd*f**2*fd*r*s - 476*D1*Dd*f**2*fd*r + 1944*D1*Dd*f**2*fd*s**2 - 1814*D1*Dd*f**2*fd*s + 366*D1*Dd*f**2*fd - 672*D1*Dd*f**2*g2*r*s + 168*D1*Dd*f**2*g2*r - 2016*D1*Dd*f**2*g2*s**2 + 1344*D1*Dd*f**2*g2*s - 504*D1*Dd*f**2*g2 + 1344*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 3024*D1*Dd*f**2*gd2*s**2 - 1764*D1*Dd*f**2*gd2*s + 168*D1*Dd*f**2*gd2 + 2688*D1*Dd*f*fd*g2*r*s - 1008*D1*Dd*f*fd*g2*r + 6048*D1*Dd*f*fd*g2*s**2 - 5208*D1*Dd*f*fd*g2*s + 1092*D1*Dd*f*fd*g2 + 336*D1*Ddd*K*b1**2*f*r*s - 84*D1*Ddd*K*b1**2*f*r - 168*D1*Ddd*K*b1**2*f*s - 336*D1*Ddd*K*b1*f**2*r*s + 84*D1*Ddd*K*b1*f**2*r - 756*D1*Ddd*K*b1*f**2*s**2 + 546*D1*Ddd*K*b1*f**2*s - 189*D1*Ddd*K*b1*f**2 - 336*D1*Ddd*b1*f**2*r*s + 84*D1*Ddd*b1*f**2*r + 168*D1*Ddd*b1*f**2*s - 672*D1*Ddd*b1*f*g2*r*s + 168*D1*Ddd*b1*f*g2*r + 336*D1*Ddd*b1*f*g2*s + 272*D1*Ddd*f**3*r*s - 68*D1*Ddd*f**3*r + 324*D1*Ddd*f**3*s**2 - 298*D1*Ddd*f**3*s + 81*D1*Ddd*f**3 + 672*D1*Ddd*f**2*g2*r*s - 168*D1*Ddd*f**2*g2*r + 1512*D1*Ddd*f**2*g2*s**2 - 1092*D1*Ddd*f**2*g2*s + 378*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(f**2*(-2*C*(s*(56*r - 18) + 9) + 126*K*s**2 - 42*K*s + 7*r*(6*K*s + 11*s + 4) - 39*s + 9) - 3*f*(fd*(34*C*s + 7*K*(r*(8*s - 2) + 18*s**2 - 13*s + 2) - 7*r*(16*C*s - 4*C - 8*s + 1) - 17*s - 7) - 7*g2*(s*(8*r - 4) + 2) - 7*s*(bd2*(s - 1) - 8*gd2*r + 6*gd2)) + 84*fd*g2*r*(1 - 2*s)) + 3*Dd*f*(f*(C*(28*r*(8*s - 1) - 80*s + 6) - 7*K*(16*r*s - 2*r + 36*s**2 - 21*s + 2) - 112*r*s - 14*r + 40*s + 11) - 14*g2*(2*r - 1)*(8*s - 1)) - 21*b1*(D1*(f*(K*s*(8*r - 6) + K - r*(f + 2)) + fd*(K*(-8*r*s + 4*r + s - 2) - r + 1)) + Dd*f*(K*(-32*r*s + 4*r + 20*s - 3) + f*(4*r - 2) + 4*r - 2))) + 1008*Dd**2*K*b1**2*f*r*s - 252*Dd**2*K*b1**2*f*r - 504*Dd**2*K*b1**2*f*s + 168*Dd**2*K*b1**2*f - 1008*Dd**2*K*b1*f**2*r*s + 252*Dd**2*K*b1*f**2*r - 2268*Dd**2*K*b1*f**2*s**2 + 1638*Dd**2*K*b1*f**2*s - 168*Dd**2*K*b1*f**2 - 1008*Dd**2*b1*f**2*r*s + 252*Dd**2*b1*f**2*r + 504*Dd**2*b1*f**2*s - 168*Dd**2*b1*f**2 - 2016*Dd**2*b1*f*g2*r*s + 504*Dd**2*b1*f*g2*r + 1008*Dd**2*b1*f*g2*s - 336*Dd**2*b1*f*g2 + 816*Dd**2*f**3*r*s - 204*Dd**2*f**3*r + 972*Dd**2*f**3*s**2 - 894*Dd**2*f**3*s + 136*Dd**2*f**3 + 2016*Dd**2*f**2*g2*r*s - 504*Dd**2*f**2*g2*r + 4536*Dd**2*f**2*g2*s**2 - 3276*Dd**2*f**2*g2*s + 336*Dd**2*f**2*g2 - 21*b2*(2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s + 8*D1*Dd*b1*f*s**2 - 4*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*s**2 + 2*D1*Dd*b1*fd*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 124*D1*Dd*f*fd*s + 26*D1*Dd*f*fd - 4*D1*Ddd*b1*f*s**2 + 2*D1*Ddd*b1*f*s - D1*Ddd*b1*f + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 26*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) - 12*Dd**2*b1*f*s**2 + 6*Dd**2*b1*f*s + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 78*Dd**2*f**2*s + 8*Dd**2*f**2))/(105*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**2*k2*(D1*(-14*D1*bd1**2*(f*(5*K*(r*(4*s - 2) - 7*s + 2) - r*(28*C - 21)*(2*s - 1) + s*(9 - 18*C)*(s - 1)) + 10*g2*(r*(4*s - 2) + s*(3*s - 3))) + D1*bdd1*f*(f*(3 - 6*C)*(44*r*(s - 1) - 70*s + 35) + 70*g2*(4*r*(s - 1) - 10*s + 5)) + 35*b2*(-D1*bdd1*f*(s - 1)*(4*r + 5*s - 5) + 2*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*r*(2 - 4*s) - 5*fd*s*(s - 1)) + Dd*f*(-2*r*(8*s - 5) - 20*s**2 + 29*s - 9))) - 2*bd1*(35*D1*bd2*f*(r*(4*s - 2) + 5*s**2 - 7*s + 2) + D1*(-3*f**2*(4*C*(22*r*s - 15*r - 14*s + 7) - 44*r*s + 23*r + 28*s - 14) + f*(fd*(6*C - 3)*(44*r*(2*s - 1) - 57*s + 22) + 140*g2*(r - 1)*(2*s - 1) + 70*gd2*(-4*r*s + 2*r + 7*s - 2)) + 140*fd*g2*r*(1 - 2*s)) + Dd*f*(f*(6*C - 3)*(22*r*(8*s - 5) - 184*s + 79) - 70*g2*(2*r*(8*s - 5) - 24*s + 9)))) - 35*b1**3*(2*D1*Dd*(K*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) + fd*r*(8*s - 1) - 6*fd*s + fd - (f + 2)*(r*(4*s - 1) - 2*s)) - D1*(2*D1*s*(fd - fdd)*(r - 1) + Ddd*K*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) - 2*Ddd*(f + 1)*(r*(4*s - 1) - 2*s)) + 2*Dd**2*(K*(-24*r*s + 6*r - 18*s**2 + 21*s - 4) + f*(3*r*(4*s - 1) - 6*s + 2) + 12*r*s - 3*r - 6*s + 2)) + 7*b1**2*(D1**2*(56*C*fdd*r*s + 18*C*fdd*s**2 - 56*C*fdd*s - 20*K*fdd*r*s - 50*K*fdd*s + 25*K*fdd + 5*bdd1*(K*(4*r*(3*s - 1) + 9*s**2 - 10*s + 3) + (-2*f - 2)*(r*(3*s - 1) - s)) + 2*fd*(10*K*(r + 1)*(2*s - 1) + r*(-56*C*s + 42*s + 5) + s*(-18*C*s + 56*C + 9*s - 42)) - 42*fdd*r*s - 9*fdd*s**2 + 42*fdd*s + 80*gd2*r*s + 60*gd2*s**2 - 80*gd2*s - 40*gdd2*r*s - 30*gdd2*s**2 + 40*gdd2*s) + 10*D1*bd1*(-D1*(K*(4*r*(3*s - 1) + 9*s**2 - 10*s + 3) + fd*r*(6*s - 1) - 4*fd*s + fd - (f + 2)*(r*(3*s - 1) - s)) + Dd*(K*(48*r*s - 14*r + 36*s**2 - 41*s + 9) + f*(r*(7 - 24*s) + 10*s - 3) - 24*r*s + 7*r + 10*s - 3)) + D1*(-2*Dd*(f*(2*C*(28*r*(4*s - 1) + 36*s**2 - 74*s + 9) + 40*K*s - r*(20*K + 42)*(4*s - 1) - 36*s**2 + 102*s - 9) + fd*(-2*C*(14*r*(8*s - 1) + 36*s**2 - 93*s + 14) + 5*K*(16*r*s - 2*r + 16*s - 5) + 168*r*s - 21*r + 36*s**2 - 135*s + 21) - 10*g2*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) - 10*gd2*(r*(2 - 16*s) - 12*s**2 + 15*s - 2)) + Ddd*(f*(2*C*(28*r*(4*s - 1) + 36*s**2 - 74*s + 9) + 40*K*s - r*(20*K + 42)*(4*s - 1) - 36*s**2 + 102*s - 9) - 10*g2*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3))) + 2*Dd**2*(f*(2*C*(42*r*(4*s - 1) + 54*s**2 - 111*s + 28) - 10*K*(12*r*s - 3*r - 6*s + 2) - 252*r*s + 63*r - 54*s**2 + 153*s - 42) - 10*g2*(6*r*(4*s - 1) + 18*s**2 - 21*s + 4))) - b1*(-1056*C*D1**2*f*fd*r*s + 168*C*D1**2*f*fd*r + 192*C*D1**2*f*fd*s + 168*C*D1**2*f*fd + 528*C*D1**2*f*fdd*r*s + 156*C*D1**2*f*fdd*s - 210*C*D1**2*f*fdd + 528*C*D1**2*fd**2*r*s + 156*C*D1**2*fd**2*s - 2112*C*D1*Dd*f**2*r*s + 528*C*D1*Dd*f**2*r + 1056*C*D1*Dd*f**2*s + 4224*C*D1*Dd*f*fd*r*s - 528*C*D1*Dd*f*fd*r - 432*C*D1*Dd*f*fd*s - 156*C*D1*Dd*f*fd + 1056*C*D1*Ddd*f**2*r*s - 264*C*D1*Ddd*f**2*r - 528*C*D1*Ddd*f**2*s + 3168*C*Dd**2*f**2*r*s - 792*C*Dd**2*f**2*r - 1584*C*Dd**2*f**2*s + 528*C*Dd**2*f**2 - 140*D1**2*b2*fd*r*s - 140*D1**2*b2*fd*s**2 + 140*D1**2*b2*fdd*r*s + 175*D1**2*b2*fdd*s**2 + 70*D1**2*bd1**2*(K*(r*(4 - 12*s) - 9*s**2 + 10*s - 2) + f*r*(6*s - 2) - 2*f*s + f + 6*r*s - 2*r - 2*s + 1) - 140*D1**2*bd2*f*r*s - 140*D1**2*bd2*f*s**2 + 140*D1**2*bd2*f*s + 280*D1**2*bd2*fd*r*s + 350*D1**2*bd2*fd*s**2 - 140*D1**2*bd2*fd*s - 7*D1**2*bdd1*(f*(2*C*(56*r*s - 28*r + 18*s**2 - 18*s + 9) - 5*K*(8*r*s - 4*r - 14*s + 5) - 84*r*s + 42*r - 18*s**2 + 18*s - 9) - 10*g2*(r*(8*s - 4) + 6*s**2 - 6*s + 3)) + 140*D1**2*bdd2*f*r*s + 175*D1**2*bdd2*f*s**2 - 140*D1**2*bdd2*f*s + 528*D1**2*f*fd*r*s - 126*D1**2*f*fd*r - 96*D1**2*f*fd*s - 84*D1**2*f*fd - 264*D1**2*f*fdd*r*s - 78*D1**2*f*fdd*s + 105*D1**2*f*fdd + 560*D1**2*f*gd2*r*s - 560*D1**2*f*gd2*s - 280*D1**2*f*gdd2*r*s + 280*D1**2*f*gdd2*s - 264*D1**2*fd**2*r*s - 78*D1**2*fd**2*s + 560*D1**2*fd*g2*r*s - 280*D1**2*fd*g2*r + 560*D1**2*fd*g2*s - 280*D1**2*fd*g2 - 560*D1**2*fd*gd2*r*s - 420*D1**2*fd*gd2*s - 280*D1**2*fdd*g2*r*s - 700*D1**2*fdd*g2*s + 350*D1**2*fdd*g2 - 560*D1*Dd*b2*f*r*s + 140*D1*Dd*b2*f*r - 560*D1*Dd*b2*f*s**2 + 560*D1*Dd*b2*f*s - 140*D1*Dd*b2*f + 1120*D1*Dd*b2*fd*r*s - 140*D1*Dd*b2*fd*r + 1400*D1*Dd*b2*fd*s**2 - 630*D1*Dd*b2*fd*s + 1120*D1*Dd*bd2*f*r*s - 140*D1*Dd*bd2*f*r + 1400*D1*Dd*bd2*f*s**2 - 1190*D1*Dd*bd2*f*s + 140*D1*Dd*bd2*f + 1056*D1*Dd*f**2*r*s - 264*D1*Dd*f**2*r - 528*D1*Dd*f**2*s - 2112*D1*Dd*f*fd*r*s + 264*D1*Dd*f*fd*r + 216*D1*Dd*f*fd*s + 78*D1*Dd*f*fd + 2240*D1*Dd*f*g2*r*s - 560*D1*Dd*f*g2*r - 1120*D1*Dd*f*g2*s - 2240*D1*Dd*f*gd2*r*s + 280*D1*Dd*f*gd2*r + 1680*D1*Dd*f*gd2*s - 280*D1*Dd*f*gd2 - 2240*D1*Dd*fd*g2*r*s + 280*D1*Dd*fd*g2*r - 2240*D1*Dd*fd*g2*s + 700*D1*Dd*fd*g2 + 560*D1*Ddd*b2*f*r*s - 140*D1*Ddd*b2*f*r + 700*D1*Ddd*b2*f*s**2 - 630*D1*Ddd*b2*f*s + 175*D1*Ddd*b2*f - 528*D1*Ddd*f**2*r*s + 132*D1*Ddd*f**2*r + 264*D1*Ddd*f**2*s - 1120*D1*Ddd*f*g2*r*s + 280*D1*Ddd*f*g2*r + 560*D1*Ddd*f*g2*s + 14*D1*bd1*(D1*f*(2*C*(56*r*s - 28*r + 18*s**2 - 18*s + 9) - 10*K*(r - 1)*(4*s - 1) - 84*r*s + 47*r - 18*s**2 + 18*s - 9) + D1*fd*(-2*C*(14*r*(4*s - 1) + 18*s**2 - 37*s + 14) + 15*K*s + r*(10*K + 21)*(4*s - 1) + 18*s**2 - 51*s + 21) - 10*D1*(g2*(r*(8*s - 4) + 6*s**2 - 6*s + 3) + gd2*(r*(2 - 8*s) - 6*s**2 + 7*s - 2)) + Dd*f*(-2*C*(28*r*(8*s - 3) + 72*s**2 - 110*s + 37) + 5*K*(4*r*(8*s - 3) - 36*s + 11) + 42*r*(8*s - 3) + 72*s**2 - 138*s + 51) + 10*Dd*g2*(4*r*(8*s - 3) + 24*s**2 - 26*s + 7)) + 1680*Dd**2*b2*f*r*s - 420*Dd**2*b2*f*r + 2100*Dd**2*b2*f*s**2 - 1890*Dd**2*b2*f*s + 280*Dd**2*b2*f - 1584*Dd**2*f**2*r*s + 396*Dd**2*f**2*r + 792*Dd**2*f**2*s - 264*Dd**2*f**2 - 3360*Dd**2*f*g2*r*s + 840*Dd**2*f*g2*r + 1680*Dd**2*f*g2*s - 560*Dd**2*f*g2))/(210*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**2*st**2*(D1*(42*D1*bd1**2*f*s*(5*K*s + f*(2*r - 1) + 2*r - 1) + 3*D1*bdd1*f*s*(14*f*r + f*s*(30*C - 15) + s*(35*b2 - 70*g2)) + 2*bd1*(D1*(f**2*s*(-28*r + s*(45 - 90*C)) + 3*f*(7*fd*r*(4*s - 1) + 2*fd*s*(15*C*(2*s - 1) - 15*s + 4) + s**2*(-35*b2 + 35*bd2 + 70*g2 - 70*gd2)) + 105*fd*s*(b2 - 2*g2)*(s - 1)) + 3*Dd*f*(7*f*r*(8*s - 1) + f*s*(30*C*(4*s - 1) - 60*s + 1) + s*(35*b2 - 70*g2)*(4*s - 1)))) + 21*b1**2*(2*D1*Dd*(f*(-5*K*(4*s**2 - 2*s + 1) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(5*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(4*s - 2) - 2*s + 2) - 2*fd*(5*K*(s - 1)**2 - f*s + r*(2*f*s - f + 2*s - 2)) + fdd*(5*K*(s - 1)**2 - 2*f*s + 2*r*(2*f*s - f + s - 1))) + Ddd*f*(5*K*(4*s**2 - 2*s + 1) + (2*f + 2)*(r*(4*s - 1) - 2*s))) + 2*Dd**2*f*(30*K*s**2 - 15*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(-360*C*D1**2*f*fd*s**2 + 360*C*D1**2*f*fd*s - 180*C*D1**2*f*fd + 180*C*D1**2*f*fdd*s**2 - 180*C*D1**2*f*fdd*s + 90*C*D1**2*f*fdd + 180*C*D1**2*fd**2*s**2 - 180*C*D1**2*fd**2*s - 720*C*D1*Dd*f**2*s**2 + 360*C*D1*Dd*f**2*s - 180*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*s**2 - 1080*C*D1*Dd*f*fd*s + 180*C*D1*Dd*f*fd + 360*C*D1*Ddd*f**2*s**2 - 180*C*D1*Ddd*f**2*s + 90*C*D1*Ddd*f**2 + 1080*C*Dd**2*f**2*s**2 - 540*C*Dd**2*f**2*s + 210*D1**2*K*bdd1*f*s**2 - 210*D1**2*bd2*f*s**2 + 210*D1**2*bd2*fd*s**2 - 210*D1**2*bd2*fd*s + 84*D1**2*bdd1*f**2*r*s - 42*D1**2*bdd1*f**2*s + 84*D1**2*bdd1*f*r*s - 42*D1**2*bdd1*f*s + 105*D1**2*bdd2*f*s**2 - 112*D1**2*f*fd*r*s + 56*D1**2*f*fd*r + 180*D1**2*f*fd*s**2 - 124*D1**2*f*fd*s + 90*D1**2*f*fd + 84*D1**2*f*fdd*r*s - 42*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 48*D1**2*f*fdd*s - 45*D1**2*f*fdd + 420*D1**2*f*gd2*s**2 - 210*D1**2*f*gdd2*s**2 + 84*D1**2*fd**2*r*s - 42*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 48*D1**2*fd**2*s + 42*D1**2*fd**2 + 420*D1**2*fd*g2*s**2 - 840*D1**2*fd*g2*s + 420*D1**2*fd*g2 - 420*D1**2*fd*gd2*s**2 + 420*D1**2*fd*gd2*s - 210*D1**2*fdd*g2*s**2 + 420*D1**2*fdd*g2*s - 210*D1**2*fdd*g2 + 840*D1*Dd*bd2*f*s**2 - 210*D1*Dd*bd2*f*s - 224*D1*Dd*f**2*r*s + 56*D1*Dd*f**2*r + 360*D1*Dd*f**2*s**2 - 68*D1*Dd*f**2*s + 90*D1*Dd*f**2 + 672*D1*Dd*f*fd*r*s - 252*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 204*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 1680*D1*Dd*f*g2*s**2 - 840*D1*Dd*f*g2*s + 420*D1*Dd*f*g2 - 1680*D1*Dd*f*gd2*s**2 + 420*D1*Dd*f*gd2*s - 1680*D1*Dd*fd*g2*s**2 + 2100*D1*Dd*fd*g2*s - 420*D1*Dd*fd*g2 + 168*D1*Ddd*f**2*r*s - 42*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 840*D1*Ddd*f*g2*s**2 + 420*D1*Ddd*f*g2*s - 210*D1*Ddd*f*g2 + 42*D1*bd1*(D1*(f*s*(-10*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(10*K*s - 1))) + Dd*f*(40*K*s**2 - 10*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) + 504*Dd**2*f**2*r*s - 126*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s + 84*Dd**2*f**2 - 2520*Dd**2*f*g2*s**2 + 1260*Dd**2*f*g2*s - 105*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(105*d**2*k2) - D1**2*Pk3*Pkd2*ct**2*(D1*(-2*D1*bd1**2*(7*f*r*(2*s - 1) + f*s*(6*C*(s - 1) - s*(25*K + 3) + 3) + s*(5*b2 - 10*g2)*(s - 1)) + 5*D1*bdd1*f*s**2*(5*b2 + f*(6*C - 3) - 10*g2) + 2*bd1*s*(D1*(-3*f**2*(8*C*s + r - 4*s) + 5*f*(fd*(6*C - 3)*(2*s - 1) + s*(5*bd2 + 8*g2 - 10*gd2)) - 50*fd*g2*(s - 1)) + 5*Dd*f*(4*s - 1)*(f*(6*C - 3) - 10*g2) + 5*b2*(-4*D1*f*s + 5*D1*fd*(s - 1) + 5*Dd*f*(4*s - 1)))) - 5*b1**3*(2*D1*Dd*(K*(-4*s**2 + 2*s - 1) + fd*r*(8*s - 1) - 6*fd*s + fd - (f + 2)*(r*(4*s - 1) - 2*s)) + D1*(-2*D1*s*(fd - fdd)*(r - 1) + Ddd*K*(4*s**2 - 2*s + 1) + 2*Ddd*(f + 1)*(r*(4*s - 1) - 2*s)) + 2*Dd**2*(6*K*s**2 - 3*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1**2*(12*C*D1**2*fd*s**2 - 6*C*D1**2*fdd*s**2 + 48*C*D1*Dd*f*s**2 - 24*C*D1*Dd*f*s + 12*C*D1*Dd*f - 48*C*D1*Dd*fd*s**2 + 12*C*D1*Dd*fd*s - 24*C*D1*Ddd*f*s**2 + 12*C*D1*Ddd*f*s - 6*C*D1*Ddd*f - 72*C*Dd**2*f*s**2 + 36*C*Dd**2*f*s - 15*D1**2*K*bdd1*s**2 + 10*D1**2*K*bdd1*s - 5*D1**2*K*bdd1 - 40*D1**2*K*fd*s**2 + 80*D1**2*K*fd*s - 40*D1**2*K*fd + 25*D1**2*K*fdd*s**2 - 50*D1**2*K*fdd*s + 25*D1**2*K*fdd + 10*D1**2*bd2*s**2 - 30*D1**2*bdd1*f*r*s + 10*D1**2*bdd1*f*r + 10*D1**2*bdd1*f*s - 30*D1**2*bdd1*r*s + 10*D1**2*bdd1*r + 10*D1**2*bdd1*s - 5*D1**2*bdd2*s**2 + 18*D1**2*fd*r*s + 10*D1**2*fd*r - 6*D1**2*fd*s**2 - 28*D1**2*fd*s - 14*D1**2*fdd*r*s + 3*D1**2*fdd*s**2 + 14*D1**2*fdd*s - 20*D1**2*gd2*s**2 + 10*D1**2*gdd2*s**2 - 160*D1*Dd*K*f*s**2 + 80*D1*Dd*K*f*s - 40*D1*Dd*K*f + 200*D1*Dd*K*fd*s**2 - 250*D1*Dd*K*fd*s + 50*D1*Dd*K*fd - 40*D1*Dd*bd2*s**2 + 10*D1*Dd*bd2*s + 72*D1*Dd*f*r*s - 18*D1*Dd*f*r - 24*D1*Dd*f*s**2 - 24*D1*Dd*f*s - 6*D1*Dd*f - 112*D1*Dd*fd*r*s + 14*D1*Dd*fd*r + 24*D1*Dd*fd*s**2 + 78*D1*Dd*fd*s - 14*D1*Dd*fd - 80*D1*Dd*g2*s**2 + 40*D1*Dd*g2*s - 20*D1*Dd*g2 + 80*D1*Dd*gd2*s**2 - 20*D1*Dd*gd2*s + 100*D1*Ddd*K*f*s**2 - 50*D1*Ddd*K*f*s + 25*D1*Ddd*K*f - 56*D1*Ddd*f*r*s + 14*D1*Ddd*f*r + 12*D1*Ddd*f*s**2 + 22*D1*Ddd*f*s + 3*D1*Ddd*f + 40*D1*Ddd*g2*s**2 - 20*D1*Ddd*g2*s + 10*D1*Ddd*g2 + 10*D1*bd1*(D1*(K*(3*s**2 - 2*s + 1) + fd*(-6*r*s + r + 4*s - 1) + (f + 2)*(3*r*s - r - s)) - Dd*(12*K*s**2 - 7*K*s + K + f*(r*(24*s - 7) - 10*s + 3) + 24*r*s - 7*r - 10*s + 3)) + 300*Dd**2*K*f*s**2 - 150*Dd**2*K*f*s - 168*Dd**2*f*r*s + 42*Dd**2*f*r + 36*Dd**2*f*s**2 + 66*Dd**2*f*s - 28*Dd**2*f + 120*Dd**2*g2*s**2 - 60*Dd**2*g2*s + 5*b2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s))) + b1*(-12*C*D1**2*bdd1*f*s**2 + 12*C*D1**2*bdd1*f*s - 6*C*D1**2*bdd1*f - 96*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 48*C*D1**2*f*fd + 60*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 30*C*D1**2*f*fdd + 60*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s - 192*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*s**2 - 360*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*s**2 - 60*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*s**2 - 180*C*Dd**2*f**2*s + 50*D1**2*K*bdd1*f*s**2 - 10*D1**2*bd1**2*(3*K*s**2 - 2*K*s + f*r*(6*s - 2) - 2*f*s + f + r*(6*s - 2) - 2*s + 1) - 40*D1**2*bd2*f*s**2 + 50*D1**2*bd2*fd*s**2 - 50*D1**2*bd2*fd*s - 28*D1**2*bdd1*f*r*s + 14*D1**2*bdd1*f*r + 6*D1**2*bdd1*f*s**2 - 6*D1**2*bdd1*f*s + 3*D1**2*bdd1*f + 20*D1**2*bdd1*g2*s**2 - 20*D1**2*bdd1*g2*s + 10*D1**2*bdd1*g2 + 25*D1**2*bdd2*f*s**2 - 12*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 42*D1**2*f*fd*s + 24*D1**2*f*fd - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 80*D1**2*f*gd2*s**2 - 50*D1**2*f*gdd2*s**2 - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 80*D1**2*fd*g2*s**2 - 160*D1**2*fd*g2*s + 80*D1**2*fd*g2 - 100*D1**2*fd*gd2*s**2 + 100*D1**2*fd*gd2*s - 50*D1**2*fdd*g2*s**2 + 100*D1**2*fdd*g2*s - 50*D1**2*fdd*g2 + 200*D1*Dd*bd2*f*s**2 - 50*D1*Dd*bd2*f*s - 24*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 36*D1*Dd*f**2*s + 24*D1*Dd*f**2 - 240*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 30*D1*Dd*f*fd + 320*D1*Dd*f*g2*s**2 - 160*D1*Dd*f*g2*s + 80*D1*Dd*f*g2 - 400*D1*Dd*f*gd2*s**2 + 100*D1*Dd*f*gd2*s - 400*D1*Dd*fd*g2*s**2 + 500*D1*Dd*fd*g2*s - 100*D1*Dd*fd*g2 - 60*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 200*D1*Ddd*f*g2*s**2 + 100*D1*Ddd*f*g2*s - 50*D1*Ddd*f*g2 + 2*D1*bd1*(D1*f*(6*C*(2*s**2 - 2*s + 1) - 40*K*s**2 + 2*r*(9*s - 7) - 6*s**2 + 11*s - 3) + D1*fd*(r*(7 - 28*s) + s**2*(-12*C + 50*K + 6) + s*(6*C - 50*K + 11) - 7) - 5*D1*(g2*(4*s**2 - 4*s + 2) + s*(bd2 - 2*gd2)*(2*s - 1)) + Dd*f*(-6*C*(8*s**2 - 6*s + 1) + 200*K*s**2 - 50*K*s - 14*r*(8*s - 3) + 24*s**2 + 10*s - 11) + 10*Dd*g2*(8*s**2 - 6*s + 1)) - 180*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 600*Dd**2*f*g2*s**2 + 300*Dd**2*f*g2*s + 5*b2*(-D1**2*bdd1*(2*s**2 - 2*s + 1) - 8*D1**2*fd*s**2 + 16*D1**2*fd*s - 8*D1**2*fd + 5*D1**2*fdd*s**2 - 10*D1**2*fdd*s + 5*D1**2*fdd - 32*D1*Dd*f*s**2 + 16*D1*Dd*f*s - 8*D1*Dd*f + 40*D1*Dd*fd*s**2 - 50*D1*Dd*fd*s + 10*D1*Dd*fd + 20*D1*Ddd*f*s**2 - 10*D1*Ddd*f*s + 5*D1*Ddd*f + 2*D1*bd1*(D1*(2*s**2 - 2*s + 1) + Dd*(-8*s**2 + 6*s - 1)) + 60*Dd**2*f*s**2 - 30*Dd**2*f*s)))/(30*d**2*k2) + 4*D1**2*Pk3*Pkd2*ct*f**2*k1**5*st**4*(D1**2*(f*(167*fd - 100*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 100*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(167*f*(r*(4*s - 1) + (1 - 2*s)**2) - 200*fd*(4*s - 1)*(4*r + 4*s - 3)) - 100*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 100*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1155*d**2*k3**6) + 15*D1**2*Pk3*Pkd2*ct*f**2*k1**5*st**4*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(154*d**2*k2**2*k3**4) + 4*D1**2*Pk3*Pkd2*ct*f**2*k1**3*k2**2*st**6*(D1**2*(f*(157*fd - 84*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 84*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(157*f*(r*(4*s - 1) + (1 - 2*s)**2) - 168*fd*(4*s - 1)*(4*r + 4*s - 3)) - 84*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 84*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(693*d**2*k3**6) + 9*D1**2*Pk3*Pkd2*ct*f**2*k1**3*st**6*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(22*d**2*k3**4) - 4*D1**2*Pk3*Pkd2*ct*f*k1**5*st**2*(-72*D1**2*b1*f*fd*r*s - 7*D1**2*b1*f*fd*r - 72*D1**2*b1*f*fd*s**2 + 41*D1**2*b1*f*fd*s + 7*D1**2*b1*f*fd + 45*D1**2*b1*f*fdd*r*s + 5*D1**2*b1*f*fdd*r + 45*D1**2*b1*f*fdd*s**2 - 25*D1**2*b1*f*fdd*s - 5*D1**2*b1*f*fdd + 90*D1**2*b1*fd**2*r*s + 10*D1**2*b1*fd**2*r + 90*D1**2*b1*fd**2*s**2 - 50*D1**2*b1*fd**2*s - 5*D1**2*b1*fd**2 + 5*D1**2*bdd1*f**2*(3*s - 4)*(r + s - 1) + 20*D1**2*f**2*fd*r*s - 5*D1**2*f**2*fd*r + 20*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 5*D1**2*f**2*fd - 96*D1*Dd*b1*f**2*r*s + 24*D1*Dd*b1*f**2*r - 96*D1*Dd*b1*f**2*s**2 + 96*D1*Dd*b1*f**2*s - 24*D1*Dd*b1*f**2 + 360*D1*Dd*b1*f*fd*r*s - 25*D1*Dd*b1*f*fd*r + 360*D1*Dd*b1*f*fd*s**2 - 280*D1*Dd*b1*f*fd*s + 15*D1*Dd*b1*f*fd + 20*D1*Dd*f**3*r*s - 5*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 20*D1*Dd*f**3*s + 5*D1*Dd*f**3 + 60*D1*Ddd*b1*f**2*r*s - 15*D1*Ddd*b1*f**2*r + 60*D1*Ddd*b1*f**2*s**2 - 60*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + D1*bd1*f*(D1*(-f*(24*s - 31)*(r + s - 1) + 5*fd*(18*r*s - 11*r + 18*s**2 - 26*s + 7)) + 5*Dd*f*(r*(24*s - 19) + 24*s**2 - 40*s + 15)) + 180*Dd**2*b1*f**2*r*s - 45*Dd**2*b1*f**2*r + 180*Dd**2*b1*f**2*s**2 - 180*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2)/(105*d**2*k3**6) + D1**2*Pk3*Pkd2*ct*f*k1**5*st**2*(30*D1**2*b1*f*fd*s**2 - 15*D1**2*b1*f*fdd*s**2 - 30*D1**2*b1*fd**2*s**2 - 5*D1**2*bdd1*f**2*(s - 1)**2 - 56*D1**2*f**2*fd*s**2 + 28*D1**2*f**2*fd*s - 14*D1**2*f**2*fd + 28*D1**2*f**2*fdd*s**2 - 14*D1**2*f**2*fdd*s + 7*D1**2*f**2*fdd + 84*D1**2*f*fd**2*s**2 - 42*D1**2*f*fd**2*s + 40*D1*Dd*b1*f**2*s**2 - 20*D1*Dd*b1*f**2*s + 10*D1*Dd*b1*f**2 - 120*D1*Dd*b1*f*fd*s**2 + 30*D1*Dd*b1*f*fd*s - 56*D1*Dd*f**3*s**2 + 28*D1*Dd*f**3*s - 14*D1*Dd*f**3 + 224*D1*Dd*f**2*fd*s**2 - 112*D1*Dd*f**2*fd*s + 14*D1*Dd*f**2*fd - 20*D1*Ddd*b1*f**2*s**2 + 10*D1*Ddd*b1*f**2*s - 5*D1*Ddd*b1*f**2 + 28*D1*Ddd*f**3*s**2 - 14*D1*Ddd*f**3*s + 7*D1*Ddd*f**3 + 10*D1*bd1*f*(s - 1)*(D1*f*(s - 1) - 3*D1*fd*s + Dd*f*(1 - 4*s)) - 60*Dd**2*b1*f**2*s**2 + 30*Dd**2*b1*f**2*s + 84*Dd**2*f**3*s**2 - 42*Dd**2*f**3*s)/(42*d**2*k2**2*k3**4) + 3*D1**2*Pk3*Pkd2*ct*f*k1**5*(D1**2*bdd1*f**2*(s - 1)**2 - 2*D1*bd1*f*(s - 1)*(D1*f*(s - 1) - 3*D1*fd*s + Dd*f*(1 - 4*s)) + b1*(3*D1**2*s**2*(f*(-2*fd + fdd) + 2*fd**2) + D1*f*(-2*Dd*(f*(4*s**2 - 2*s + 1) + 3*fd*s*(1 - 4*s)) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)))/(14*d**2*k2**2*k3**4) + D1**2*Pk3*Pkd2*ct*f*k2**4*st**4*(8*C - 4)*(D1*Dd*f*(4*f*(-4*r*s + r + 2*s) + 5*fd*(24*r*s - 7*r - 10*s + 3)) + D1*(D1*(4*f*fd*(-3*r*s + r + s) + 5*f*fdd*(3*r*s - r - s) + 5*fd**2*(6*r*s - 2*r - 2*s + 1)) + 5*Ddd*f**2*(r*(4*s - 1) - 2*s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2))/(105*d**2*k1*k3**4) - D1**2*Pk3*Pkd2*ct*f*k2**2*st**4*(8*C - 4)*(D1*Dd*f*(4*f*(-4*r*s + r + 2*s) + 5*fd*(24*r*s - 7*r - 10*s + 3)) + D1*(D1*(4*f*fd*(-3*r*s + r + s) + 5*f*fdd*(3*r*s - r - s) + 5*fd**2*(6*r*s - 2*r - 2*s + 1)) + 5*Ddd*f**2*(r*(4*s - 1) - 2*s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2))/(105*d**2*k1*k3**2) - 4*D1**2*Pk3*Pkd2*ct*k1**5*(-5*D1**2*bd1*f**2*(r + s - 1)*(bd1*(2*s - 1) - f*s + f) + D1*b1*f*(bd1*(D1*(3*f*(2*s - 1)*(r + s - 1) - 5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1)) - 5*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 5*f*(-D1*bdd1*(2*s - 1)*(r + s - 1) + D1*fd*s*(3*r + 3*s - 2) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**2*(D1**2*s*(2*r + 2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + D1*f*(Dd*(3*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct*k1**3*k2**2*st**4*(72*C*D1**2*f**2*fd*r*s - 24*C*D1**2*f**2*fd*r + 72*C*D1**2*f**2*fd*s**2 - 72*C*D1**2*f**2*fd*s + 24*C*D1**2*f**2*fd - 36*C*D1**2*f**2*fdd*r*s + 12*C*D1**2*f**2*fdd*r - 36*C*D1**2*f**2*fdd*s**2 + 36*C*D1**2*f**2*fdd*s - 12*C*D1**2*f**2*fdd - 72*C*D1**2*f*fd**2*r*s + 24*C*D1**2*f*fd**2*r - 72*C*D1**2*f*fd**2*s**2 + 72*C*D1**2*f*fd**2*s - 12*C*D1**2*f*fd**2 + 96*C*D1*Dd*f**3*r*s - 24*C*D1*Dd*f**3*r + 96*C*D1*Dd*f**3*s**2 - 96*C*D1*Dd*f**3*s + 24*C*D1*Dd*f**3 - 288*C*D1*Dd*f**2*fd*r*s + 84*C*D1*Dd*f**2*fd*r - 288*C*D1*Dd*f**2*fd*s**2 + 288*C*D1*Dd*f**2*fd*s - 60*C*D1*Dd*f**2*fd - 48*C*D1*Ddd*f**3*r*s + 12*C*D1*Ddd*f**3*r - 48*C*D1*Ddd*f**3*s**2 + 48*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 144*C*Dd**2*f**3*r*s + 36*C*Dd**2*f**3*r - 144*C*Dd**2*f**3*s**2 + 144*C*Dd**2*f**3*s - 24*C*Dd**2*f**3 - 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s + 10*D1**2*bdd1*f**3*r*s + 20*D1**2*bdd1*f**3*r + 10*D1**2*bdd1*f**3*s**2 + 10*D1**2*bdd1*f**3*s - 20*D1**2*bdd1*f**3 + 9*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 - 9*D1**2*bdd1*f**2*s - 60*D1**2*f**3*fd*r*s + 15*D1**2*f**3*fd*r - 60*D1**2*f**3*fd*s**2 + 60*D1**2*f**3*fd*s - 15*D1**2*f**3*fd - 54*D1**2*f**2*fd*r*s + 18*D1**2*f**2*fd*r - 54*D1**2*f**2*fd*s**2 + 54*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 27*D1**2*f**2*fdd*r*s - 9*D1**2*f**2*fdd*r + 27*D1**2*f**2*fdd*s**2 - 27*D1**2*f**2*fdd*s + 9*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 54*D1**2*f*fd**2*r*s - 18*D1**2*f*fd**2*r + 54*D1**2*f*fd**2*s**2 - 54*D1**2*f*fd**2*s + 9*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 60*D1*Dd*f**4*r*s + 15*D1*Dd*f**4*r - 60*D1*Dd*f**4*s**2 + 60*D1*Dd*f**4*s - 15*D1*Dd*f**4 - 72*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 72*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 216*D1*Dd*f**2*fd*r*s - 63*D1*Dd*f**2*fd*r + 216*D1*Dd*f**2*fd*s**2 - 216*D1*Dd*f**2*fd*s + 45*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r*s - 36*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 288*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r*s - 216*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 576*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 36*D1*Ddd*f**3*r*s - 9*D1*Ddd*f**3*r + 36*D1*Ddd*f**3*s**2 - 36*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(-D1*(f**2*(14*s + 37)*(r + s - 1) - 2*f*(5*fd*(6*r*s + 3*r + 6*s**2 - 2*s - 1) + s*(18*K - 9)*(r + s - 1)) + 9*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(10*f*(8*r*s + 7*r + 8*s**2 - 5) - (18*K - 9)*(8*r*s - r + 8*s**2 - 8*s + 1))) + 108*Dd**2*f**3*r*s - 27*Dd**2*f**3*r + 108*Dd**2*f**3*s**2 - 108*Dd**2*f**3*s + 18*Dd**2*f**3 + 432*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 + b1*(D1**2*(f**2*(fd*(r*(51 - 42*s) - 42*s**2 + 79*s - 51) + 10*fdd*(3*r*(s - 1) + 3*s**2 - 5*s + 3)) + f*(10*fd**2*(6*r*(s - 1) + 6*s**2 - 10*s + 3) + 18*fd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 9*fdd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 9*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(-2*Dd*(7*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(3*r*(8*s - 5) + 24*s**2 - 32*s + 11) + (9 - 18*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 10*f + 9)) + Dd**2*f**2*(-18*K + 10*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**6) - 4*D1**2*Pk3*Pkd2*ct*k1**3*k2**2*st**2*(36*C*D1**2*bdd1*f**2*r*s - 36*C*D1**2*bdd1*f**2*r + 36*C*D1**2*bdd1*f**2*s**2 - 72*C*D1**2*bdd1*f**2*s + 36*C*D1**2*bdd1*f**2 - 6*C*D1**2*f**2*fd*r*s + 2*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 6*C*D1**2*f**2*fd*s - 2*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r*s - 10*C*D1**2*f**2*fdd*r + 30*C*D1**2*f**2*fdd*s**2 - 30*C*D1**2*f**2*fdd*s + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r*s - 20*C*D1**2*f*fd**2*r + 60*C*D1**2*f*fd**2*s**2 - 60*C*D1**2*f*fd**2*s + 10*C*D1**2*f*fd**2 - 8*C*D1*Dd*f**3*r*s + 2*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 8*C*D1*Dd*f**3*s - 2*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r*s - 70*C*D1*Dd*f**2*fd*r + 240*C*D1*Dd*f**2*fd*s**2 - 240*C*D1*Dd*f**2*fd*s + 50*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*r*s - 10*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s**2 - 40*C*D1*Ddd*f**3*s + 10*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*r*s - 30*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s**2 - 120*C*Dd**2*f**3*s + 20*C*Dd**2*f**3 + 9*D1**2*K*bdd1*f**2*r*s + 9*D1**2*K*bdd1*f**2*s**2 - 9*D1**2*K*bdd1*f**2*s - 3*D1**2*bd1**2*f*(2*s - 1)*(-14*K + 18*f + 7)*(r + s - 1) - 27*D1**2*bdd1*f**2*r*s + 27*D1**2*bdd1*f**2*r - 27*D1**2*bdd1*f**2*s**2 + 54*D1**2*bdd1*f**2*s - 27*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 - 6*D1**2*f**2*fd*r*s + 2*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 2*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r*s + 5*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 15*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd - 6*D1**2*f**2*gd2*r*s - 6*D1**2*f**2*gd2*s**2 + 6*D1**2*f**2*gd2*s - 18*D1**2*f**2*gdd2*r*s - 18*D1**2*f**2*gdd2*s**2 + 18*D1**2*f**2*gdd2*s - 30*D1**2*f*fd**2*r*s + 10*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 30*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 - 12*D1**2*f*fd*g2*r*s + 6*D1**2*f*fd*g2*r - 12*D1**2*f*fd*g2*s**2 + 12*D1**2*f*fd*g2*s - 6*D1**2*f*fd*g2 - 72*D1**2*f*fd*gd2*r*s + 18*D1**2*f*fd*gd2*r - 72*D1**2*f*fd*gd2*s**2 + 72*D1**2*f*fd*gd2*s - 18*D1**2*f*fd*gd2 - 36*D1**2*f*fdd*g2*r*s + 18*D1**2*f*fdd*g2*r - 36*D1**2*f*fdd*g2*s**2 + 36*D1**2*f*fdd*g2*s - 18*D1**2*f*fdd*g2 - 36*D1**2*fd**2*g2*r*s + 18*D1**2*fd**2*g2*r - 36*D1**2*fd**2*g2*s**2 + 36*D1**2*fd**2*g2*s - 8*D1*Dd*f**3*r*s + 2*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 8*D1*Dd*f**3*s - 2*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r*s + 35*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 120*D1*Dd*f**2*fd*s - 25*D1*Dd*f**2*fd - 24*D1*Dd*f**2*g2*r*s + 6*D1*Dd*f**2*g2*r - 24*D1*Dd*f**2*g2*s**2 + 24*D1*Dd*f**2*g2*s - 6*D1*Dd*f**2*g2 - 144*D1*Dd*f**2*gd2*r*s + 18*D1*Dd*f**2*gd2*r - 144*D1*Dd*f**2*gd2*s**2 + 144*D1*Dd*f**2*gd2*s - 18*D1*Dd*f**2*gd2 - 288*D1*Dd*f*fd*g2*r*s + 108*D1*Dd*f*fd*g2*r - 288*D1*Dd*f*fd*g2*s**2 + 288*D1*Dd*f*fd*g2*s - 72*D1*Dd*f*fd*g2 - 20*D1*Ddd*f**3*r*s + 5*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 20*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 - 72*D1*Ddd*f**2*g2*r*s + 18*D1*Ddd*f**2*g2*r - 72*D1*Ddd*f**2*g2*s**2 + 72*D1*Ddd*f**2*g2*s - 18*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-27*f**3*(r + s - 1) - f**2*(r + s - 1)*(72*C*(s - 1) - s*(3*K + 47) + 54) + 9*f*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + 84*f*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) - 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 3*Dd*f*(3*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 60*Dd**2*f**3*r*s + 15*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 60*Dd**2*f**3*s - 10*Dd**2*f**3 - 216*Dd**2*f**2*g2*r*s + 54*Dd**2*f**2*g2*r - 216*Dd**2*f**2*g2*s**2 + 216*Dd**2*f**2*g2*s - 36*Dd**2*f**2*g2 + 3*b1**2*(D1**2*s*(f*(29*fd - 18*fdd)*(2*r + 2*s - 1) - 18*fd**2*(2*r + 2*s - 1) - 14*fd*(2*K - 1)*(r + s) + 7*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(29*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(9*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (14*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 18*f + 7)) - Dd**2*f*(-14*K + 18*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-144*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s + 72*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 72*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*s**2 - 36*C*D1**2*fd**2*s - 288*C*D1*Dd*f**2*r*s + 72*C*D1*Dd*f**2*r - 288*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r*s - 72*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 432*C*D1*Dd*f*fd*s + 36*C*D1*Dd*f*fd + 144*C*D1*Ddd*f**2*r*s - 36*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r*s - 108*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 + 6*D1**2*K*f*fd*r*s - 3*D1**2*K*f*fd*r + 6*D1**2*K*f*fd*s**2 - 6*D1**2*K*f*fd*s + 3*D1**2*K*f*fd + 18*D1**2*K*f*fdd*r*s - 9*D1**2*K*f*fdd*r + 18*D1**2*K*f*fdd*s**2 - 18*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 18*D1**2*K*fd**2*r*s - 9*D1**2*K*fd**2*r + 18*D1**2*K*fd**2*s**2 - 18*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(2*s - 1)*(-14*K + 18*f + 7)*(r + s - 1) + 27*D1**2*f**2*fd*r + 27*D1**2*f**2*fd*s - 27*D1**2*f**2*fd + 94*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 94*D1**2*f*fd*s**2 - 40*D1**2*f*fd*s - 7*D1**2*f*fd - 54*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*s**2 + 27*D1**2*f*fdd*s + 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s - 84*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s - 54*D1**2*fd**2*r*s - 54*D1**2*fd**2*s**2 + 27*D1**2*fd**2*s + 168*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 + 12*D1*Dd*K*f**2*r*s - 3*D1*Dd*K*f**2*r + 12*D1*Dd*K*f**2*s**2 - 12*D1*Dd*K*f**2*s + 3*D1*Dd*K*f**2 + 144*D1*Dd*K*f*fd*r*s - 54*D1*Dd*K*f*fd*r + 144*D1*Dd*K*f*fd*s**2 - 144*D1*Dd*K*f*fd*s + 36*D1*Dd*K*f*fd + 188*D1*Dd*f**2*r*s - 47*D1*Dd*f**2*r + 188*D1*Dd*f**2*s**2 - 188*D1*Dd*f**2*s + 47*D1*Dd*f**2 - 432*D1*Dd*f*fd*r*s + 54*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 324*D1*Dd*f*fd*s - 27*D1*Dd*f*fd + 672*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r*s + 84*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 672*D1*Dd*f*gd2*s - 84*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r*s + 84*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 336*D1*Dd*fd*g2*s + 36*D1*Ddd*K*f**2*r*s - 9*D1*Ddd*K*f**2*r + 36*D1*Ddd*K*f**2*s**2 - 36*D1*Ddd*K*f**2*s + 9*D1*Ddd*K*f**2 - 108*D1*Ddd*f**2*r*s + 27*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r*s + 84*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 336*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(29*f**2*(2*s - 1)*(r + s - 1) - 2*f*(9*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (14*K - 7)*(2*s - 1)*(r + s - 1)) + 7*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-14*K + 18*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 108*Dd**2*K*f**2*r*s - 27*Dd**2*K*f**2*r + 108*Dd**2*K*f**2*s**2 - 108*Dd**2*K*f**2*s + 18*Dd**2*K*f**2 - 324*Dd**2*f**2*r*s + 81*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 54*Dd**2*f**2 - 1008*Dd**2*f*g2*r*s + 252*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1008*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(105*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct*k1**3*k2**2*(-3*D1*(7*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + D1*bdd1*f*(s - 1)*(f*(10*C - 5) - 14*g2)*(r + s - 1) + bd1*(D1*(f**2*(22*C - 18)*(s - 1)*(r + s - 1) + f*(fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (3*g2*(s - 1) + gd2*(2*s - 1))*(-14*r - 14*s + 14)) + 14*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 7*b1**2*(D1**2*s*(9*f*fd*(2*r + 2*s - 1) - (r + s)*(3*K*fdd + fd*(9*K - 5))) + D1*(Dd*(3*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 9*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(9*K - 5)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*(7*K*bdd1*f*(2*s - 1)*(r + s - 1) + s*(f*(fd*(22*C - 18)*(2*r + 2*s - 1) + fdd*(10*C - 5)*(2*r + 2*s - 1) + (-42*gd2 - 14*gdd2)*(r + s - 1)) + fd**2*(10*C - 5)*(2*r + 2*s - 1) - 14*fd*(3*g2*(r + s) + gd2*(2*r + 2*s - 1)) - 14*fdd*g2*(r + s))) + 7*D1*bd1*(D1*(3*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 9*f**2*(2*s - 1)*(r + s - 1) - f*(9*K - 5)*(2*s - 1)*(r + s - 1)) - 3*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*D1*(Dd*(f**2*(22*C - 18)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(10*C - 5)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 42*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 14*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 14*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + Ddd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(f*(10*C - 5) - 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**6) - D1**2*Pk3*Pkd2*ct*k1**3*st**4*(48*C*D1**2*f**2*fd*r*s - 16*C*D1**2*f**2*fd*r - 24*C*D1**2*f**2*fd*s**2 - 8*C*D1**2*f**2*fd - 24*C*D1**2*f**2*fdd*r*s + 8*C*D1**2*f**2*fdd*r + 12*C*D1**2*f**2*fdd*s**2 + 4*C*D1**2*f**2*fdd - 48*C*D1**2*f*fd**2*r*s + 16*C*D1**2*f*fd**2*r + 24*C*D1**2*f*fd**2*s**2 - 8*C*D1**2*f*fd**2 + 64*C*D1*Dd*f**3*r*s - 16*C*D1*Dd*f**3*r - 32*C*D1*Dd*f**3*s**2 - 16*C*D1*Dd*f**3*s - 8*C*D1*Dd*f**3 - 192*C*D1*Dd*f**2*fd*r*s + 56*C*D1*Dd*f**2*fd*r + 96*C*D1*Dd*f**2*fd*s**2 + 24*C*D1*Dd*f**2*fd*s - 16*C*D1*Dd*f**2*fd - 32*C*D1*Ddd*f**3*r*s + 8*C*D1*Ddd*f**3*r + 16*C*D1*Ddd*f**3*s**2 + 8*C*D1*Ddd*f**3*s + 4*C*D1*Ddd*f**3 - 96*C*Dd**2*f**3*r*s + 24*C*Dd**2*f**3*r + 48*C*Dd**2*f**3*s**2 + 24*C*Dd**2*f**3*s - 16*C*Dd**2*f**3 - 12*D1**2*K*bdd1*f**2*r*s + 6*D1**2*K*bdd1*f**2*s**2 + 12*D1**2*K*bdd1*f**2*s + 100*D1**2*bdd1*f**3*r*s + 100*D1**2*bdd1*f**3*s**2 - 210*D1**2*bdd1*f**3*s + 75*D1**2*bdd1*f**3 + 48*D1**2*bdd1*f**2*r*s + 45*D1**2*bdd1*f**2*s**2 - 48*D1**2*bdd1*f**2*s + 480*D1**2*f**3*fd*r*s - 120*D1**2*f**3*fd*r + 1080*D1**2*f**3*fd*s**2 - 780*D1**2*f**3*fd*s + 270*D1**2*f**3*fd - 480*D1**2*f**3*fdd*r*s + 120*D1**2*f**3*fdd*r - 660*D1**2*f**3*fdd*s**2 + 570*D1**2*f**3*fdd*s - 165*D1**2*f**3*fdd - 1440*D1**2*f**2*fd**2*r*s + 360*D1**2*f**2*fd**2*r - 1980*D1**2*f**2*fd**2*s**2 + 1710*D1**2*f**2*fd**2*s - 240*D1**2*f**2*fd**2 - 120*D1**2*f**2*fd*r*s + 40*D1**2*f**2*fd*r - 78*D1**2*f**2*fd*s**2 + 92*D1**2*f**2*fd*s - 26*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 39*D1**2*f**2*fdd*s**2 - 46*D1**2*f**2*fdd*s + 13*D1**2*f**2*fdd - 48*D1**2*f**2*gd2*r*s + 24*D1**2*f**2*gd2*s**2 + 48*D1**2*f**2*gd2*s + 24*D1**2*f**2*gdd2*r*s - 12*D1**2*f**2*gdd2*s**2 - 24*D1**2*f**2*gdd2*s + 120*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 78*D1**2*f*fd**2*s**2 - 92*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 - 96*D1**2*f*fd*g2*r*s + 48*D1**2*f*fd*g2*r + 48*D1**2*f*fd*g2*s**2 - 48*D1**2*f*fd*g2*s + 24*D1**2*f*fd*g2 + 96*D1**2*f*fd*gd2*r*s - 24*D1**2*f*fd*gd2*r - 48*D1**2*f*fd*gd2*s**2 - 24*D1**2*f*fd*gd2*s + 24*D1**2*f*fd*gd2 + 48*D1**2*f*fdd*g2*r*s - 24*D1**2*f*fdd*g2*r - 24*D1**2*f*fdd*g2*s**2 + 24*D1**2*f*fdd*g2*s - 12*D1**2*f*fdd*g2 + 48*D1**2*fd**2*g2*r*s - 24*D1**2*fd**2*g2*r - 24*D1**2*fd**2*g2*s**2 + 24*D1**2*fd**2*g2*s + 480*D1*Dd*f**4*r*s - 120*D1*Dd*f**4*r + 1080*D1*Dd*f**4*s**2 - 780*D1*Dd*f**4*s + 270*D1*Dd*f**4 - 3840*D1*Dd*f**3*fd*r*s + 960*D1*Dd*f**3*fd*r - 5280*D1*Dd*f**3*fd*s**2 + 4560*D1*Dd*f**3*fd*s - 810*D1*Dd*f**3*fd - 160*D1*Dd*f**3*r*s + 40*D1*Dd*f**3*r - 104*D1*Dd*f**3*s**2 + 132*D1*Dd*f**3*s - 26*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r*s - 140*D1*Dd*f**2*fd*r + 312*D1*Dd*f**2*fd*s**2 - 382*D1*Dd*f**2*fd*s + 86*D1*Dd*f**2*fd - 192*D1*Dd*f**2*g2*r*s + 48*D1*Dd*f**2*g2*r + 96*D1*Dd*f**2*g2*s**2 + 48*D1*Dd*f**2*g2*s + 24*D1*Dd*f**2*g2 + 192*D1*Dd*f**2*gd2*r*s - 24*D1*Dd*f**2*gd2*r - 96*D1*Dd*f**2*gd2*s**2 - 120*D1*Dd*f**2*gd2*s + 24*D1*Dd*f**2*gd2 + 384*D1*Dd*f*fd*g2*r*s - 144*D1*Dd*f*fd*g2*r - 192*D1*Dd*f*fd*g2*s**2 + 48*D1*Dd*f*fd*g2*s + 24*D1*Dd*f*fd*g2 - 480*D1*Ddd*f**4*r*s + 120*D1*Ddd*f**4*r - 660*D1*Ddd*f**4*s**2 + 570*D1*Ddd*f**4*s - 165*D1*Ddd*f**4 + 80*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r + 52*D1*Ddd*f**3*s**2 - 66*D1*Ddd*f**3*s + 13*D1*Ddd*f**3 + 96*D1*Ddd*f**2*g2*r*s - 24*D1*Ddd*f**2*g2*r - 48*D1*Ddd*f**2*g2*s**2 - 24*D1*Ddd*f**2*g2*s - 12*D1*Ddd*f**2*g2 - 2*D1*bd1*f*(D1*f**2*(82*s**2 + s*(82*r - 198) + 75) + D1*f*(-10*fd*(5*r*(6*s - 1) + 30*s**2 - 41*s + 3) + 3*s*(K*(-4*r + 2*s + 4) + 16*r + 15*s - 16)) + 3*D1*fd*(K*(8*r*s - 2*r - 4*s**2 - 2*s + 2) - 32*r*s + 8*r - 30*s**2 + 31*s - 8) - 5*Dd*f**2*(10*r*(8*s - 1) + 80*s**2 - 124*s + 21) + 3*Dd*f*(-2*K*(-8*r*s + r + 4*s**2 + 5*s - 1) - 64*r*s + 8*r - 60*s**2 + 63*s - 8)) - 1440*Dd**2*f**4*r*s + 360*Dd**2*f**4*r - 1980*Dd**2*f**4*s**2 + 1710*Dd**2*f**4*s - 240*Dd**2*f**4 + 240*Dd**2*f**3*r*s - 60*Dd**2*f**3*r + 156*Dd**2*f**3*s**2 - 198*Dd**2*f**3*s + 40*Dd**2*f**3 + 288*Dd**2*f**2*g2*r*s - 72*Dd**2*f**2*g2*r - 144*Dd**2*f**2*g2*s**2 - 72*Dd**2*f**2*g2*s + 48*Dd**2*f**2*g2 + b1*(D1**2*(f**2*(-2*fd*(82*r*(3*s - 1) + 246*s**2 - 130*s + 7) + 5*fdd*(20*r*(3*s - 1) + 60*s**2 - 38*s + 5)) + f*(20*fd**2*(10*r*(3*s - 1) + 30*s**2 - 19*s + 7) + 6*fd*(K*(8*r*s - 4*r - 4*s**2 + 4*s - 2) - 32*r*s + 16*r - 30*s**2 + 30*s - 15) + 3*fdd*(K*(-8*r*s + 4*r + 4*s**2 - 4*s + 2) + 32*r*s - 16*r + 30*s**2 - 30*s + 15)) - 6*fd**2*(r*(2*K - 8)*(2*s - 1) - s*(2*K + 15)*(s - 1))) + D1*f*(-2*Dd*(82*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(3*K*(-16*r*s + 4*r + 8*s**2 + 4*s + 2) - 5*fd*(10*r*(24*s - 7) + 240*s**2 - 196*s + 39) + 192*r*s - 48*r + 180*s**2 - 186*s + 45) + 3*fd*(2*K*(16*r*s - 6*r - 8*s**2 + 2*s + 1) - 128*r*s + 48*r - 120*s**2 + 122*s - 31)) + Ddd*f*(3*K*(-16*r*s + 4*r + 8*s**2 + 4*s + 2) + 100*f*(r*(4*s - 1) + (1 - 2*s)**2) + 192*r*s - 48*r + 180*s**2 - 186*s + 45)) + 2*Dd**2*f**2*(6*K*(r*(3 - 12*s) + 6*s**2 + 3*s - 2) + 50*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 288*r*s - 72*r + 270*s**2 - 279*s + 48)))/(210*d**2*k3**4) + D1**2*Pk3*Pkd2*ct*k1**3*st**2*(24*C*D1**2*bdd1*f**2*r*s - 24*C*D1**2*bdd1*f**2*r + 36*C*D1**2*bdd1*f**2*s**2 - 72*C*D1**2*bdd1*f**2*s + 36*C*D1**2*bdd1*f**2 - 96*C*D1**2*f**2*fd*r*s + 32*C*D1**2*f**2*fd*r - 624*C*D1**2*f**2*fd*s**2 + 448*C*D1**2*f**2*fd*s - 208*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r*s - 40*C*D1**2*f**2*fdd*r + 420*C*D1**2*f**2*fdd*s**2 - 320*C*D1**2*f**2*fdd*s + 140*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r*s - 80*C*D1**2*f*fd**2*r + 840*C*D1**2*f*fd**2*s**2 - 640*C*D1**2*f*fd**2*s + 40*C*D1**2*f*fd**2 - 128*C*D1*Dd*f**3*r*s + 32*C*D1*Dd*f**3*r - 832*C*D1*Dd*f**3*s**2 + 480*C*D1*Dd*f**3*s - 208*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r*s - 280*C*D1*Dd*f**2*fd*r + 3360*C*D1*Dd*f**2*fd*s**2 - 2360*C*D1*Dd*f**2*fd*s + 400*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r*s - 40*C*D1*Ddd*f**3*r + 560*C*D1*Ddd*f**3*s**2 - 360*C*D1*Ddd*f**3*s + 140*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r*s - 120*C*Dd**2*f**3*r + 1680*C*Dd**2*f**3*s**2 - 1080*C*Dd**2*f**3*s + 80*C*Dd**2*f**3 + 36*D1**2*K*bdd1*f**2*r*s + 142*D1**2*K*bdd1*f**2*s**2 - 36*D1**2*K*bdd1*f**2*s - 88*D1**2*b2*f*fd*r*s + 44*D1**2*b2*f*fd*r - 88*D1**2*b2*f*fd*s**2 + 88*D1**2*b2*f*fd*s - 44*D1**2*b2*f*fd + 72*D1**2*b2*f*fdd*r*s - 36*D1**2*b2*f*fdd*r + 72*D1**2*b2*f*fdd*s**2 - 72*D1**2*b2*f*fdd*s + 36*D1**2*b2*f*fdd + 72*D1**2*b2*fd**2*r*s - 36*D1**2*b2*fd**2*r + 72*D1**2*b2*fd**2*s**2 - 72*D1**2*b2*fd**2*s - 2*D1**2*bd1**2*f*(-7*K*(4*r*s - 2*r + 6*s**2 - 8*s + 2) + 9*f*(2*r*(8*s - 5) + 13*s**2 - 21*s + 6) + 112*r*s - 56*r + 133*s**2 - 189*s + 56) - 44*D1**2*bd2*f**2*r*s - 44*D1**2*bd2*f**2*s**2 + 44*D1**2*bd2*f**2*s + 144*D1**2*bd2*f*fd*r*s - 36*D1**2*bd2*f*fd*r + 144*D1**2*bd2*f*fd*s**2 - 144*D1**2*bd2*f*fd*s + 36*D1**2*bd2*f*fd + 144*D1**2*bdd1*f**3*r*s - 216*D1**2*bdd1*f**3*r - 306*D1**2*bdd1*f**3*s + 189*D1**2*bdd1*f**3 - 60*D1**2*bdd1*f**2*r*s + 60*D1**2*bdd1*f**2*r - 128*D1**2*bdd1*f**2*s**2 + 150*D1**2*bdd1*f**2*s - 75*D1**2*bdd1*f**2 - 56*D1**2*bdd1*f*g2*r*s + 56*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 + 36*D1**2*bdd2*f**2*r*s + 36*D1**2*bdd2*f**2*s**2 - 36*D1**2*bdd2*f**2*s - 24*D1**2*f**2*fd*r*s + 8*D1**2*f**2*fd*r + 390*D1**2*f**2*fd*s**2 - 252*D1**2*f**2*fd*s + 130*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 285*D1**2*f**2*fdd*s**2 + 210*D1**2*f**2*fdd*s - 95*D1**2*f**2*fdd + 32*D1**2*f**2*gd2*r*s + 400*D1**2*f**2*gd2*s**2 - 32*D1**2*f**2*gd2*s - 72*D1**2*f**2*gdd2*r*s - 284*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 120*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 570*D1**2*f*fd**2*s**2 + 420*D1**2*f*fd**2*s - 20*D1**2*f*fd**2 + 64*D1**2*f*fd*g2*r*s - 32*D1**2*f*fd*g2*r + 800*D1**2*f*fd*g2*s**2 - 800*D1**2*f*fd*g2*s + 400*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r*s + 72*D1**2*f*fd*gd2*r - 1136*D1**2*f*fd*gd2*s**2 + 712*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r - 568*D1**2*f*fdd*g2*s**2 + 568*D1**2*f*fdd*g2*s - 284*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r - 568*D1**2*fd**2*g2*s**2 + 568*D1**2*fd**2*g2*s - 176*D1*Dd*b2*f**2*r*s + 44*D1*Dd*b2*f**2*r - 176*D1*Dd*b2*f**2*s**2 + 176*D1*Dd*b2*f**2*s - 44*D1*Dd*b2*f**2 + 576*D1*Dd*b2*f*fd*r*s - 216*D1*Dd*b2*f*fd*r + 576*D1*Dd*b2*f*fd*s**2 - 576*D1*Dd*b2*f*fd*s + 144*D1*Dd*b2*f*fd + 288*D1*Dd*bd2*f**2*r*s - 36*D1*Dd*bd2*f**2*r + 288*D1*Dd*bd2*f**2*s**2 - 288*D1*Dd*bd2*f**2*s + 36*D1*Dd*bd2*f**2 - 32*D1*Dd*f**3*r*s + 8*D1*Dd*f**3*r + 520*D1*Dd*f**3*s**2 - 244*D1*Dd*f**3*s + 130*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r*s + 140*D1*Dd*f**2*fd*r - 2280*D1*Dd*f**2*fd*s**2 + 1530*D1*Dd*f**2*fd*s - 250*D1*Dd*f**2*fd + 128*D1*Dd*f**2*g2*r*s - 32*D1*Dd*f**2*g2*r + 1600*D1*Dd*f**2*g2*s**2 - 864*D1*Dd*f**2*g2*s + 400*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r*s + 72*D1*Dd*f**2*gd2*r - 2272*D1*Dd*f**2*gd2*s**2 + 1000*D1*Dd*f**2*gd2*s - 72*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r*s + 432*D1*Dd*f*fd*g2*r - 4544*D1*Dd*f*fd*g2*s**2 + 3696*D1*Dd*f*fd*g2*s - 712*D1*Dd*f*fd*g2 + 144*D1*Ddd*b2*f**2*r*s - 36*D1*Ddd*b2*f**2*r + 144*D1*Ddd*b2*f**2*s**2 - 144*D1*Ddd*b2*f**2*s + 36*D1*Ddd*b2*f**2 - 80*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r - 380*D1*Ddd*f**3*s**2 + 230*D1*Ddd*f**3*s - 95*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r*s + 72*D1*Ddd*f**2*g2*r - 1136*D1*Ddd*f**2*g2*s**2 + 712*D1*Ddd*f**2*g2*s - 284*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(9*f**3*(12*r*(s - 1) + 4*s**2 - 28*s + 15) + f**2*(12*C*(s - 1)*(2*r + 3*s - 3) + 8*K*r*s + 100*K*s**2 - 8*K*s - 18*fd*(8*r*(3*s - 2) - 25*s + 10) - 32*r*s + 60*r - 100*s**2 + 122*s - 75) + f*(fd*(-12*C*(r*(4*s - 2) + 6*s**2 - 7*s + 1) - 2*K*(36*r*s - 9*r + 142*s**2 - 89*s + 9) + 120*r*s - 60*r + 256*s**2 - 233*s + 30) - 28*g2*(s - 1)*(2*r + 3*s - 3) - 28*gd2*(-2*r*s + r - 3*s**2 + 4*s - 1)) + 28*fd*g2*(r*(2*s - 1) + s*(3*s - 3))) + Dd*f*(-9*f**2*(8*r*(8*s - 7) - 84*s + 41) + f*(-12*C*(r*(8*s - 5) + 12*s**2 - 17*s + 5) - 2*K*(72*r*s - 9*r + 284*s**2 - 125*s + 9) + 240*r*s - 150*r + 512*s**2 - 488*s + 135) + 28*g2*(r*(8*s - 5) + 12*s**2 - 17*s + 5))) + 432*Dd**2*b2*f**2*r*s - 108*Dd**2*b2*f**2*r + 432*Dd**2*b2*f**2*s**2 - 432*Dd**2*b2*f**2*s + 72*Dd**2*b2*f**2 - 240*Dd**2*f**3*r*s + 60*Dd**2*f**3*r - 1140*Dd**2*f**3*s**2 + 690*Dd**2*f**3*s - 40*Dd**2*f**3 - 864*Dd**2*f**2*g2*r*s + 216*Dd**2*f**2*g2*r - 3408*Dd**2*f**2*g2*s**2 + 2136*Dd**2*f**2*g2*s - 144*Dd**2*f**2*g2 + b1**2*(D1**2*(2*f*(2*fd*(116*r*s + 11*r + 89*s**2 - 65*s - 11) - 9*fdd*(16*r*s + 2*r + 13*s**2 - 8*s - 2)) - 18*fd**2*(2*r*(8*s + 1) + 13*s**2 - 8*s - 2) - 14*fd*s*(r*(4*K - 16) + s*(6*K - 19)) + 7*fdd*s*(r*(4*K - 16) + s*(6*K - 19))) + D1*(2*Dd*(f**2*(116*r*(4*s - 1) + 356*s**2 - 410*s + 89) + f*(-14*K*(8*r*s - 2*r + 12*s**2 - 10*s + 3) - 18*fd*(r*(64*s - 4) + 52*s**2 - 45*s + 2) + 448*r*s - 112*r + 532*s**2 - 490*s + 133) + 7*fd*(r*(2*K - 8)*(8*s - 1) + s*(24*K*s - 10*K - 76*s + 35))) + Ddd*f*(14*K*(8*r*s - 2*r + 12*s**2 - 10*s + 3) - 9*f*(16*r*(4*s - 1) + 52*s**2 - 58*s + 13) - 448*r*s + 112*r - 532*s**2 + 490*s - 133)) - 2*Dd**2*f*(-7*K*(24*r*s - 6*r + 36*s**2 - 30*s + 4) + 9*f*(24*r*(4*s - 1) + 78*s**2 - 87*s + 16) + 672*r*s - 168*r + 798*s**2 - 735*s + 112)) + b1*(-96*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s + 48*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 48*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 192*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 288*C*D1*Dd*f**2*s**2 + 240*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r*s - 48*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 336*C*D1*Dd*f*fd*s + 24*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 - 32*D1**2*K*f*fd*r*s + 16*D1**2*K*f*fd*r - 400*D1**2*K*f*fd*s**2 + 400*D1**2*K*f*fd*s - 200*D1**2*K*f*fd + 72*D1**2*K*f*fdd*r*s - 36*D1**2*K*f*fdd*r + 284*D1**2*K*f*fdd*s**2 - 284*D1**2*K*f*fdd*s + 142*D1**2*K*f*fdd + 72*D1**2*K*fd**2*r*s - 36*D1**2*K*fd**2*r + 284*D1**2*K*fd**2*s**2 - 284*D1**2*K*fd**2*s + D1**2*bdd1*f*(14*K*(4*r*s - 2*r + 6*s**2 - 8*s + 3) - 9*f*(4*r*(8*s - 5) + 26*s**2 - 42*s + 17) - 224*r*s + 112*r - 266*s**2 + 378*s - 133) - 648*D1**2*f**2*fd*r*s - 216*D1**2*f**2*fd*s**2 + 72*D1**2*f**2*fd*s + 198*D1**2*f**2*fd + 432*D1**2*f**2*fdd*r*s + 72*D1**2*f**2*fdd*r + 18*D1**2*f**2*fdd*s - 189*D1**2*f**2*fdd + 864*D1**2*f*fd**2*r*s + 144*D1**2*f*fd**2*r + 36*D1**2*f*fd**2*s - 72*D1**2*f*fd**2 + 128*D1**2*f*fd*r*s + 56*D1**2*f*fd*r + 400*D1**2*f*fd*s**2 - 220*D1**2*f*fd*s + 50*D1**2*f*fd - 120*D1**2*f*fdd*r*s - 256*D1**2*f*fdd*s**2 + 166*D1**2*f*fdd*s - 53*D1**2*f*fdd + 112*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s - 56*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 120*D1**2*fd**2*r*s - 256*D1**2*fd**2*s**2 + 166*D1**2*fd**2*s + 112*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*s**2 - 112*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 56*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 - 64*D1*Dd*K*f**2*r*s + 16*D1*Dd*K*f**2*r - 800*D1*Dd*K*f**2*s**2 + 432*D1*Dd*K*f**2*s - 200*D1*Dd*K*f**2 + 576*D1*Dd*K*f*fd*r*s - 216*D1*Dd*K*f*fd*r + 2272*D1*Dd*K*f*fd*s**2 - 1848*D1*Dd*K*f*fd*s + 356*D1*Dd*K*f*fd - 864*D1*Dd*f**3*r*s + 216*D1*Dd*f**3*r - 288*D1*Dd*f**3*s**2 + 576*D1*Dd*f**3*s - 72*D1*Dd*f**3 + 3456*D1*Dd*f**2*fd*r*s - 144*D1*Dd*f**2*fd*r - 792*D1*Dd*f**2*fd*s - 162*D1*Dd*f**2*fd + 256*D1*Dd*f**2*r*s - 64*D1*Dd*f**2*r + 800*D1*Dd*f**2*s**2 - 528*D1*Dd*f**2*s + 200*D1*Dd*f**2 - 960*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 2048*D1*Dd*f*fd*s**2 + 1416*D1*Dd*f*fd*s - 166*D1*Dd*f*fd + 448*D1*Dd*f*g2*r*s - 112*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 560*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r*s + 56*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 504*D1*Dd*f*gd2*s - 56*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r*s + 56*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 280*D1*Dd*fd*g2*s + 144*D1*Ddd*K*f**2*r*s - 36*D1*Ddd*K*f**2*r + 568*D1*Ddd*K*f**2*s**2 - 356*D1*Ddd*K*f**2*s + 142*D1*Ddd*K*f**2 + 576*D1*Ddd*f**3*r*s - 144*D1*Ddd*f**3*r - 288*D1*Ddd*f**3*s - 240*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 512*D1*Ddd*f**2*s**2 + 376*D1*Ddd*f**2*s - 128*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r*s + 56*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 280*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*(2*r*(116*s - 69) + 178*s**2 - 280*s + 111) + f*(-14*K*(4*r*s - 2*r + 6*s**2 - 8*s + 3) - 18*fd*(8*r*(4*s - 1) + 26*s**2 - 29*s + 6) + 224*r*s - 112*r + 266*s**2 - 378*s + 133) + 7*fd*(r*(2*K - 8)*(4*s - 1) + s*(12*K*s - 8*K - 38*s + 27))) + Dd*f*(28*K*(8*r*s - 3*r + 12*s**2 - 13*s + 3) - 9*f*(8*r*(16*s - 7) + 104*s**2 - 142*s + 41) - 896*r*s + 336*r - 1064*s**2 + 1246*s - 301)) + 432*Dd**2*K*f**2*r*s - 108*Dd**2*K*f**2*r + 1704*Dd**2*K*f**2*s**2 - 1068*Dd**2*K*f**2*s + 72*Dd**2*K*f**2 + 1728*Dd**2*f**3*r*s - 432*Dd**2*f**3*r - 864*Dd**2*f**3*s + 288*Dd**2*f**3 - 720*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 1536*Dd**2*f**2*s**2 + 1128*Dd**2*f**2*s - 120*Dd**2*f**2 - 672*Dd**2*f*g2*r*s + 168*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 840*Dd**2*f*g2*s - 112*Dd**2*f*g2))/(210*d**2*k3**4) - D1**2*Pk3*Pkd2*ct*k1**3*(D1*(14*D1*bd1**2*f*(-2*K*(6*r*s - 3*r + 17*s**2 - 20*s + 3) + 3*f*(r*(8*s - 4) + 9*s**2 - 13*s + 4) + s*(11*s - 11)) - D1*bdd1*f*(s - 1)*(3*f*(40*C*r + 108*C*(s - 1) - 20*r - 71*s + 71) - 28*g2*(6*r + 17*s - 17)) + 28*b2*(D1*bd1*(f*(s - 1)*(r + s - 1) + 3*fd*(-2*r*s + r - s*(2*s - 2))) - 3*D1*bdd1*f*(s - 1)*(r + s - 1) - 3*Dd*bd1*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 2*bd1*(42*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(3*f**2*(s - 1)*(8*C*(2*r - 3*s + 3) - 36*r + s - 1) + 6*f*fd*(2*C*(20*r*s - 10*r + 54*s**2 - 59*s + 5) - 20*r*s + 10*r - 71*s**2 + 76*s - 5) - 28*f*(2*g2*(s - 1)*(2*r - s + 1) + gd2*(6*r*s - 3*r + 17*s**2 - 20*s + 3)) - 28*fd*g2*(r*(6*s - 3) + s*(17*s - 17))) + Dd*f*(3*f*(4*C*(5*r*(8*s - 5) + 108*s**2 - 145*s + 37) - 80*r*s + 50*r - 284*s**2 + 375*s - 91) - 28*g2*(3*r*(8*s - 5) + 68*s**2 - 91*s + 23)))) + 28*b1**3*(D1**2*s*(fd - 3*fdd)*(r + s - 1) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(-16*D1**2*K*fd*r*s + 8*D1**2*K*fd*s**2 - 12*D1**2*K*fdd*r*s - 34*D1**2*K*fdd*s**2 - 12*D1**2*bdd1*f*(3*r*s - r + 3*s**2 - 3*s + 1) + 12*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s + 48*D1**2*f*fdd*r*s + 54*D1**2*f*fdd*s**2 - 24*D1**2*f*fdd*s + 48*D1**2*fd**2*r*s + 54*D1**2*fd**2*s**2 - 24*D1**2*fd**2*s + 40*D1**2*fd*r*s + 18*D1**2*fd*s**2 + 11*D1**2*fdd*s**2 - 64*D1*Dd*K*f*r*s + 16*D1*Dd*K*f*r + 32*D1*Dd*K*f*s**2 + 16*D1*Dd*K*f*s + 8*D1*Dd*K*f - 96*D1*Dd*K*fd*r*s + 12*D1*Dd*K*fd*r - 272*D1*Dd*K*fd*s**2 + 92*D1*Dd*K*fd*s + 24*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 + 384*D1*Dd*f*fd*r*s - 48*D1*Dd*f*fd*r + 432*D1*Dd*f*fd*s**2 - 300*D1*Dd*f*fd*s + 24*D1*Dd*f*fd + 160*D1*Dd*f*r*s - 40*D1*Dd*f*r + 72*D1*Dd*f*s**2 - 116*D1*Dd*f*s + 18*D1*Dd*f + 88*D1*Dd*fd*s**2 - 22*D1*Dd*fd*s - 48*D1*Ddd*K*f*r*s + 12*D1*Ddd*K*f*r - 136*D1*Ddd*K*f*s**2 + 92*D1*Ddd*K*f*s - 34*D1*Ddd*K*f + 96*D1*Ddd*f**2*r*s - 24*D1*Ddd*f**2*r + 108*D1*Ddd*f**2*s**2 - 102*D1*Ddd*f**2*s + 27*D1*Ddd*f**2 + 44*D1*Ddd*f*s**2 - 22*D1*Ddd*f*s + 11*D1*Ddd*f + 4*D1*bd1*(D1*(f*(3*r*s - r + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1)) - 3*Dd*f*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 144*Dd**2*K*f*r*s + 36*Dd**2*K*f*r - 408*Dd**2*K*f*s**2 + 276*Dd**2*K*f*s - 24*Dd**2*K*f + 288*Dd**2*f**2*r*s - 72*Dd**2*f**2*r + 324*Dd**2*f**2*s**2 - 306*Dd**2*f**2*s + 48*Dd**2*f**2 + 132*Dd**2*f*s**2 - 66*Dd**2*f*s) + b1*(-192*C*D1**2*f*fd*r*s + 288*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 240*C*D1**2*f*fdd*r*s - 648*C*D1**2*f*fdd*s**2 + 120*C*D1**2*f*fdd*s - 240*C*D1**2*fd**2*r*s - 648*C*D1**2*fd**2*s**2 + 120*C*D1**2*fd**2*s - 384*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r + 576*C*D1*Dd*f**2*s**2 - 96*C*D1*Dd*f**2*s + 144*C*D1*Dd*f**2 - 1920*C*D1*Dd*f*fd*r*s + 240*C*D1*Dd*f*fd*r - 5184*C*D1*Dd*f*fd*s**2 + 2256*C*D1*Dd*f*fd*s - 120*C*D1*Dd*f*fd - 480*C*D1*Ddd*f**2*r*s + 120*C*D1*Ddd*f**2*r - 1296*C*D1*Ddd*f**2*s**2 + 888*C*D1*Ddd*f**2*s - 324*C*D1*Ddd*f**2 - 1440*C*Dd**2*f**2*r*s + 360*C*Dd**2*f**2*r - 3888*C*Dd**2*f**2*s**2 + 2664*C*Dd**2*f**2*s - 240*C*Dd**2*f**2 + 28*D1**2*b2*fd*r*s + 28*D1**2*b2*fd*s**2 - 84*D1**2*b2*fdd*r*s - 84*D1**2*b2*fdd*s**2 - 84*D1**2*bd1**2*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 28*D1**2*bd2*f*r*s + 28*D1**2*bd2*f*s**2 - 28*D1**2*bd2*f*s - 168*D1**2*bd2*fd*r*s - 168*D1**2*bd2*fd*s**2 + 84*D1**2*bd2*fd*s + 7*D1**2*bdd1*f*(-2*K*(12*r*s - 6*r + 34*s**2 - 40*s + 17) + 3*f*(8*r*(2*s - 1) + 18*s**2 - 26*s + 9) + 22*s**2 - 22*s + 11) - 84*D1**2*bdd2*f*r*s - 84*D1**2*bdd2*f*s**2 + 84*D1**2*bdd2*f*s + 432*D1**2*f*fd*r*s - 12*D1**2*f*fd*s**2 - 216*D1**2*f*fd*s + 120*D1**2*f*fdd*r*s + 426*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s + 224*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*s**2 - 224*D1**2*f*gd2*s + 168*D1**2*f*gdd2*r*s + 476*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s + 120*D1**2*fd**2*r*s + 426*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s + 224*D1**2*fd*g2*r*s - 112*D1**2*fd*g2*s**2 + 336*D1**2*fd*gd2*r*s + 952*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 168*D1**2*fdd*g2*r*s + 476*D1**2*fdd*g2*s**2 + 112*D1*Dd*b2*f*r*s - 28*D1*Dd*b2*f*r + 112*D1*Dd*b2*f*s**2 - 112*D1*Dd*b2*f*s + 28*D1*Dd*b2*f - 672*D1*Dd*b2*fd*r*s + 84*D1*Dd*b2*fd*r - 672*D1*Dd*b2*fd*s**2 + 336*D1*Dd*b2*fd*s - 672*D1*Dd*bd2*f*r*s + 84*D1*Dd*bd2*f*r - 672*D1*Dd*bd2*f*s**2 + 672*D1*Dd*bd2*f*s - 84*D1*Dd*bd2*f + 864*D1*Dd*f**2*r*s - 216*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 - 420*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 960*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 3408*D1*Dd*f*fd*s**2 - 1332*D1*Dd*f*fd*s + 60*D1*Dd*f*fd + 896*D1*Dd*f*g2*r*s - 224*D1*Dd*f*g2*r - 448*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s - 112*D1*Dd*f*g2 + 1344*D1*Dd*f*gd2*r*s - 168*D1*Dd*f*gd2*r + 3808*D1*Dd*f*gd2*s**2 - 1960*D1*Dd*f*gd2*s + 168*D1*Dd*f*gd2 + 1344*D1*Dd*fd*g2*r*s - 168*D1*Dd*fd*g2*r + 3808*D1*Dd*fd*g2*s**2 - 1288*D1*Dd*fd*g2*s - 336*D1*Ddd*b2*f*r*s + 84*D1*Ddd*b2*f*r - 336*D1*Ddd*b2*f*s**2 + 336*D1*Ddd*b2*f*s - 84*D1*Ddd*b2*f + 240*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 852*D1*Ddd*f**2*s**2 - 546*D1*Ddd*f**2*s + 213*D1*Ddd*f**2 + 672*D1*Ddd*f*g2*r*s - 168*D1*Ddd*f*g2*r + 1904*D1*Ddd*f*g2*s**2 - 1288*D1*Ddd*f*g2*s + 476*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(f**2*(6*s**2 + 3) + f*(K*(-16*r*s + 8*r + 8*s**2 + 4) + 6*fd*(4*r*(4*s - 1) + 18*s**2 - 17*s + 2) + 40*r*s - 20*r + 18*s**2 - 38*s + 9) + fd*(K*r*(6 - 24*s) + 4*K*s*(10 - 17*s) + 11*s*(2*s - 1))) + Dd*f*(-4*K*(24*r*s - 9*r + 68*s**2 - 63*s + 13) + 3*f*(8*r*(8*s - 3) + 72*s**2 - 86*s + 21) + 88*s**2 - 66*s + 11)) - 1008*Dd**2*b2*f*r*s + 252*Dd**2*b2*f*r - 1008*Dd**2*b2*f*s**2 + 1008*Dd**2*b2*f*s - 168*Dd**2*b2*f + 720*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 2556*Dd**2*f**2*s**2 - 1638*Dd**2*f**2*s + 120*Dd**2*f**2 + 2016*Dd**2*f*g2*r*s - 504*Dd**2*f*g2*r + 5712*Dd**2*f*g2*s**2 - 3864*Dd**2*f*g2*s + 336*Dd**2*f*g2))/(210*d**2*k3**4) + 3*D1**2*Pk3*Pkd2*ct*k1**3*st**4*(b1*(D1**2*(10*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(20*fd**2*s*(2 - 3*s) + 6*fd*(2*s**2 - 2*s + 1) - 3*fdd*(2*s**2 - 2*s + 1)) - 6*fd**2*s*(s - 1)) + D1*f*(2*Dd*(10*f**2*(4*s**2 - 2*s + 1) + f*(-10*fd*(12*s**2 - 7*s + 1) + 12*s**2 - 6*s + 3) - 3*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(10*f + 3)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(10*f + 3)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) - f*(fd*(s**2*(60*bd1 - 6) + s*(4 - 20*bd1) - 2) + fdd*(3*s**2 - 2*s + 1) + s**2*(-6*bd1 + 3*bdd1)) + 2*fd*s*(bd1*(3 - 6*s) + fd*(2 - 3*s))) - D1*f*(2*Dd*(f*(s**2*(40*bd1 - 4) + s*(2 - 10*bd1) - 1) + (4*s - 1)*(3*bd1*s + fd*(3*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(70*d**2*k2**2*k3**2) + D1**2*Pk3*Pkd2*ct*k1**3*st**2*(5*b1**2*(D1**2*s**2*(-36*fd**2 + fd*(72*f + 14) - fdd*(36*f + 7)) + D1*(2*Dd*(18*f**2*(4*s**2 - 2*s + 1) + f*(-s**2*(144*fd - 28) + s*(36*fd - 14) + 7) + 7*fd*s*(1 - 4*s)) - Ddd*f*(18*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(18*f + 7)*(2*s - 1)) + b1*(-5*D1**2*bdd1*f*(18*f + 7)*(2*s**2 - 2*s + 1) - 756*D1**2*f**2*fd*s**2 + 504*D1**2*f**2*fd*s - 252*D1**2*f**2*fd + 378*D1**2*f**2*fdd*s**2 - 252*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd + 756*D1**2*f*fd**2*s**2 - 504*D1**2*f*fd**2*s - 152*D1**2*f*fd*s**2 + 212*D1**2*f*fd*s - 106*D1**2*f*fd + 76*D1**2*f*fdd*s**2 - 106*D1**2*f*fdd*s + 53*D1**2*f*fdd + 76*D1**2*fd**2*s**2 - 106*D1**2*fd**2*s - 1008*D1*Dd*f**3*s**2 + 504*D1*Dd*f**3*s - 252*D1*Dd*f**3 + 3024*D1*Dd*f**2*fd*s**2 - 1764*D1*Dd*f**2*fd*s + 252*D1*Dd*f**2*fd - 304*D1*Dd*f**2*s**2 + 152*D1*Dd*f**2*s - 76*D1*Dd*f**2 + 608*D1*Dd*f*fd*s**2 - 576*D1*Dd*f*fd*s + 106*D1*Dd*f*fd + 504*D1*Ddd*f**3*s**2 - 252*D1*Ddd*f**3*s + 126*D1*Ddd*f**3 + 152*D1*Ddd*f**2*s**2 - 76*D1*Ddd*f**2*s + 38*D1*Ddd*f**2 + 10*D1*bd1*(D1*(18*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(14 - 72*fd) + s*(36*fd - 14) + 7) + 7*fd*s*(1 - 2*s)) - Dd*f*(18*f + 7)*(8*s**2 - 6*s + 1)) + 1512*Dd**2*f**3*s**2 - 756*Dd**2*f**3*s + 456*Dd**2*f**2*s**2 - 228*Dd**2*f**2*s) + f*(-10*D1**2*bd1**2*s*(18*f + 7)*(s - 1) + D1**2*bdd1*f*(s**2*(126*f + 38) + 30*s - 15) - 25*D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) - 2*D1*bd1*(D1*(126*f**2*s**2 + f*(s**2*(38 - 378*fd) + s*(126*fd + 30) - 15) + fd*s*(23 - 76*s)) - Dd*f*(4*s - 1)*(s*(126*f + 38) + 15)) - 25*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 150*Dd**2*f**2*s*(1 - 2*s)))/(210*d**2*k2**2*k3**2) + D1**2*Pk3*Pkd2*ct*k1**3*(D1*f*(s - 1)*(14*D1*bd1**2*s*(18*f + 11) + 51*D1*bdd1*f*(s - 1) + 102*bd1*(D1*(-f*s + f + 2*fd*s) + Dd*f*(4*s - 1))) - 7*b1**2*(D1**2*s**2*(-36*fd**2 + fd*(72*f + 22) - fdd*(36*f + 11)) + D1*(2*Dd*(18*f**2*(4*s**2 - 2*s + 1) + f*(s**2*(44 - 144*fd) + s*(36*fd - 22) + 11) + 11*fd*s*(1 - 4*s)) - Ddd*f*(18*f + 11)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(18*f + 11)*(2*s - 1)) + b1*(7*D1**2*bdd1*f*(18*f + 11)*(2*s**2 - 2*s + 1) - 102*D1**2*s**2*(2*f*fd - f*fdd - fd**2) - 14*D1*bd1*(D1*(18*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(22 - 72*fd) + s*(36*fd - 22) + 11) + 11*fd*s*(1 - 2*s)) - Dd*f*(18*f + 11)*(8*s**2 - 6*s + 1)) - 51*D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) + 4*Dd*fd*s*(1 - 4*s) + Ddd*f*(-4*s**2 + 2*s - 1)) - 306*Dd**2*f**2*s*(1 - 2*s)))/(210*d**2*k2**2*k3**2) + 4*D1**2*Pk3*Pkd2*ct*k1*k2**4*st**6*(24*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r + 24*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r*s + 4*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r*s + 8*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 32*C*D1*Dd*f**3*r*s - 8*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s**2 - 32*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r*s + 28*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 96*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 16*C*D1*Ddd*f**3*r*s + 4*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 16*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 48*C*Dd**2*f**3*r*s + 12*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 48*C*Dd**2*f**3*s - 8*C*Dd**2*f**3 - 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s + 7*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 - 7*D1**2*bdd1*f**3*s + 9*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 - 9*D1**2*bdd1*f**2*s - 18*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 18*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 9*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r + 9*D1**2*f**2*fdd*s**2 - 9*D1**2*f**2*fdd*s + 3*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 18*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r + 18*D1**2*f*fd**2*s**2 - 18*D1**2*f*fd**2*s + 3*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 24*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 24*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 72*D1*Dd*f**2*fd*r*s - 21*D1*Dd*f**2*fd*r + 72*D1*Dd*f**2*fd*s**2 - 72*D1*Dd*f**2*fd*s + 15*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r*s - 36*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 288*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r*s - 216*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 576*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 12*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-18*K + 7*f + 9)*(r + s - 1) - 9*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-18*K + 7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 36*Dd**2*f**3*r*s - 9*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 6*Dd**2*f**3 + 432*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1)) - 9*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (36*K - 18)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 7*f + 9)) + Dd**2*f**2*(-18*K + 7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k3**6) - 4*D1**2*Pk3*Pkd2*ct*k1*k2**4*st**4*(4*C*D1**2*bdd1*f**2*r*s - 4*C*D1**2*bdd1*f**2*r + 4*C*D1**2*bdd1*f**2*s**2 - 8*C*D1**2*bdd1*f**2*s + 4*C*D1**2*bdd1*f**2 - 42*C*D1**2*f**2*fd*r*s + 14*C*D1**2*f**2*fd*r - 42*C*D1**2*f**2*fd*s**2 + 42*C*D1**2*f**2*fd*s - 14*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r*s - 10*C*D1**2*f**2*fdd*r + 30*C*D1**2*f**2*fdd*s**2 - 30*C*D1**2*f**2*fdd*s + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r*s - 20*C*D1**2*f*fd**2*r + 60*C*D1**2*f*fd**2*s**2 - 60*C*D1**2*f*fd**2*s + 10*C*D1**2*f*fd**2 - 56*C*D1*Dd*f**3*r*s + 14*C*D1*Dd*f**3*r - 56*C*D1*Dd*f**3*s**2 + 56*C*D1*Dd*f**3*s - 14*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r*s - 70*C*D1*Dd*f**2*fd*r + 240*C*D1*Dd*f**2*fd*s**2 - 240*C*D1*Dd*f**2*fd*s + 50*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*r*s - 10*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s**2 - 40*C*D1*Ddd*f**3*s + 10*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*r*s - 30*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s**2 - 120*C*Dd**2*f**3*s + 20*C*Dd**2*f**3 + 15*D1**2*K*bdd1*f**2*r*s + 15*D1**2*K*bdd1*f**2*s**2 - 15*D1**2*K*bdd1*f**2*s - D1**2*bd1**2*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 3*D1**2*bdd1*f**2*r*s + 3*D1**2*bdd1*f**2*r - 3*D1**2*bdd1*f**2*s**2 + 6*D1**2*bdd1*f**2*s - 3*D1**2*bdd1*f**2 - 28*D1**2*bdd1*f*g2*r*s + 28*D1**2*bdd1*f*g2*r - 28*D1**2*bdd1*f*g2*s**2 + 56*D1**2*bdd1*f*g2*s - 28*D1**2*bdd1*f*g2 + 18*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 18*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r*s + 5*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 15*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd + 18*D1**2*f**2*gd2*r*s + 18*D1**2*f**2*gd2*s**2 - 18*D1**2*f**2*gd2*s - 30*D1**2*f**2*gdd2*r*s - 30*D1**2*f**2*gdd2*s**2 + 30*D1**2*f**2*gdd2*s - 30*D1**2*f*fd**2*r*s + 10*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 30*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 + 36*D1**2*f*fd*g2*r*s - 18*D1**2*f*fd*g2*r + 36*D1**2*f*fd*g2*s**2 - 36*D1**2*f*fd*g2*s + 18*D1**2*f*fd*g2 - 120*D1**2*f*fd*gd2*r*s + 30*D1**2*f*fd*gd2*r - 120*D1**2*f*fd*gd2*s**2 + 120*D1**2*f*fd*gd2*s - 30*D1**2*f*fd*gd2 - 60*D1**2*f*fdd*g2*r*s + 30*D1**2*f*fdd*g2*r - 60*D1**2*f*fdd*g2*s**2 + 60*D1**2*f*fdd*g2*s - 30*D1**2*f*fdd*g2 - 60*D1**2*fd**2*g2*r*s + 30*D1**2*fd**2*g2*r - 60*D1**2*fd**2*g2*s**2 + 60*D1**2*fd**2*g2*s + 24*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 24*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r*s + 35*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 120*D1*Dd*f**2*fd*s - 25*D1*Dd*f**2*fd + 72*D1*Dd*f**2*g2*r*s - 18*D1*Dd*f**2*g2*r + 72*D1*Dd*f**2*g2*s**2 - 72*D1*Dd*f**2*g2*s + 18*D1*Dd*f**2*g2 - 240*D1*Dd*f**2*gd2*r*s + 30*D1*Dd*f**2*gd2*r - 240*D1*Dd*f**2*gd2*s**2 + 240*D1*Dd*f**2*gd2*s - 30*D1*Dd*f**2*gd2 - 480*D1*Dd*f*fd*g2*r*s + 180*D1*Dd*f*fd*g2*r - 480*D1*Dd*f*fd*g2*s**2 + 480*D1*Dd*f*fd*g2*s - 120*D1*Dd*f*fd*g2 - 20*D1*Ddd*f**3*r*s + 5*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 20*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 - 120*D1*Ddd*f**2*g2*r*s + 30*D1*Ddd*f**2*g2*r - 120*D1*Ddd*f**2*g2*s**2 + 120*D1*Ddd*f**2*g2*s - 30*D1*Ddd*f**2*g2 - D1*bd1*(D1*(5*f**3*s*(r + s - 1) + f**2*(r + s - 1)*(8*C*(s - 1) + 9*K*s + s + 6) + f*(fd*(-4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 15*K*(r*(4*s - 1) + (1 - 2*s)**2) + 12*r*s - 6*r + 12*s**2 - 15*s + 3) + (-28*r - 28*s + 28)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 28*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(f*(-4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 15*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 24*r*s - 15*r + 24*s**2 - 36*s + 12) + 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 60*Dd**2*f**3*r*s + 15*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 60*Dd**2*f**3*s - 10*Dd**2*f**3 - 360*Dd**2*f**2*g2*r*s + 90*Dd**2*f**2*g2*r - 360*Dd**2*f**2*g2*s**2 + 360*Dd**2*f**2*g2*s - 60*Dd**2*f**2*g2 + b1**2*(D1**2*s*(5*f*(2*fd - fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 14*fd*(2*K - 1)*(r + s) + 7*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (14 - 28*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 5*f + 7)) - Dd**2*f*(-14*K + 5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-16*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*s**2 + 8*C*D1**2*f*fd*s + 8*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*s**2 - 4*C*D1**2*f*fdd*s + 8*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*s**2 - 4*C*D1**2*fd**2*s - 32*C*D1*Dd*f**2*r*s + 8*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 32*C*D1*Dd*f**2*s - 8*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r*s - 8*C*D1*Dd*f*fd*r + 64*C*D1*Dd*f*fd*s**2 - 48*C*D1*Dd*f*fd*s + 4*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r*s - 4*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s**2 - 16*C*D1*Ddd*f**2*s + 4*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r*s - 12*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s**2 - 48*C*Dd**2*f**2*s + 8*C*Dd**2*f**2 - 18*D1**2*K*f*fd*r*s + 9*D1**2*K*f*fd*r - 18*D1**2*K*f*fd*s**2 + 18*D1**2*K*f*fd*s - 9*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd - 2*D1**2*f*fd*r*s + 7*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 7*D1**2*f*fd - 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s + 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*s**2 + 28*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 36*D1*Dd*K*f**2*r*s + 9*D1*Dd*K*f**2*r - 36*D1*Dd*K*f**2*s**2 + 36*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 36*D1*Dd*f*fd*s - 3*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 224*D1*Dd*f*gd2*s - 28*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r*s + 28*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 112*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 112*D1*Ddd*f*g2*s - 28*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(2*s - 1)*(r + s - 1) + f*(-5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (14 - 28*K)*(2*s - 1)*(r + s - 1)) + 7*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-14*K + 5*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s - 6*Dd**2*f**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 336*Dd**2*f*g2*s - 56*Dd**2*f*g2))/(35*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct*k1*k2**4*st**2*(D1*(-63*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + D1*bd1*(2*f**2*(r + s - 1)*(33*C*(s - 1) - s*(21*K + 13) + 13) - 3*f*(fd*(18*C - 9)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (14*g2*(s - 1) + 14*gd2*(3 - 6*s))*(r + s - 1)) + 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 9*D1*bdd1*f*(s - 1)*(f*(6*C - 3) - 14*g2)*(r + s - 1) - 9*Dd*bd1*f*(f*(6*C - 3) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 6*f*(D1*(f*(fd*(6*C - 3)*(3*r*s - r + 3*s**2 - 3*s + 1) - 14*gd2*s*(r + s - 1)) - 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(6*C - 3) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b1**2*(D1**2*s*(3*f*fd*(2*r + 2*s - 1) + (r + s)*(-9*K*fdd + fd*(3*K + 5))) + D1*(Dd*(9*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 3*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(3*K + 5)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(-63*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(-42*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(66*C - 26)*(2*r + 2*s - 1) - 3*s*(fdd*(18*C - 9)*(2*r + 2*s - 1) + (14*gd2 - 42*gdd2)*(r + s - 1))) - 3*s*(fd**2*(18*C - 9)*(2*r + 2*s - 1) + 14*fd*(g2*(r + s) + gd2*(-6*r - 6*s + 3)) - 42*fdd*g2*(r + s))) + 7*D1*bd1*(D1*(9*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 3*f**2*(2*s - 1)*(r + s - 1) + f*(3*K + 5)*(2*s - 1)*(r + s - 1)) - 9*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + D1*(Dd*(2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(33*C - 21*K - 13) - 3*f*(fd*(18*C - 9)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 14*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 42*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 126*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - 9*Ddd*f*(f*(6*C - 3) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f*(f*(6*C - 3) - 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**6) + D1**2*Pk3*Pkd2*ct*k1*k2**2*st**6*(-48*C*D1**2*f**2*fd*r*s + 16*C*D1**2*f**2*fd*r + 120*C*D1**2*f**2*fd*s**2 - 64*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd + 24*C*D1**2*f**2*fdd*r*s - 8*C*D1**2*f**2*fdd*r - 60*C*D1**2*f**2*fdd*s**2 + 32*C*D1**2*f**2*fdd*s - 20*C*D1**2*f**2*fdd + 48*C*D1**2*f*fd**2*r*s - 16*C*D1**2*f*fd**2*r - 120*C*D1**2*f*fd**2*s**2 + 64*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 64*C*D1*Dd*f**3*r*s + 16*C*D1*Dd*f**3*r + 160*C*D1*Dd*f**3*s**2 - 48*C*D1*Dd*f**3*s + 40*C*D1*Dd*f**3 + 192*C*D1*Dd*f**2*fd*r*s - 56*C*D1*Dd*f**2*fd*r - 480*C*D1*Dd*f**2*fd*s**2 + 200*C*D1*Dd*f**2*fd*s - 16*C*D1*Dd*f**2*fd + 32*C*D1*Ddd*f**3*r*s - 8*C*D1*Ddd*f**3*r - 80*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s - 20*C*D1*Ddd*f**3 + 96*C*Dd**2*f**3*r*s - 24*C*Dd**2*f**3*r - 240*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s + 16*C*Dd**2*f**3 + 36*D1**2*K*bdd1*f**2*r*s - 90*D1**2*K*bdd1*f**2*s**2 - 36*D1**2*K*bdd1*f**2*s - 28*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 + 28*D1**2*bdd1*f**3*s - 72*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 + 72*D1**2*bdd1*f**2*s - 112*D1**2*f**3*fd*r*s + 28*D1**2*f**3*fd*r + 56*D1**2*f**3*fd*s + 112*D1**2*f**3*fdd*r*s - 28*D1**2*f**3*fdd*r - 56*D1**2*f**3*fdd*s + 336*D1**2*f**2*fd**2*r*s - 84*D1**2*f**2*fd**2*r - 168*D1**2*f**2*fd**2*s + 56*D1**2*f**2*fd**2 + 72*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r - 66*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 22*D1**2*f**2*fd - 36*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r + 33*D1**2*f**2*fdd*s**2 - 10*D1**2*f**2*fdd*s + 11*D1**2*f**2*fdd + 144*D1**2*f**2*gd2*r*s - 360*D1**2*f**2*gd2*s**2 - 144*D1**2*f**2*gd2*s - 72*D1**2*f**2*gdd2*r*s + 180*D1**2*f**2*gdd2*s**2 + 72*D1**2*f**2*gdd2*s - 72*D1**2*f*fd**2*r*s + 24*D1**2*f*fd**2*r + 66*D1**2*f*fd**2*s**2 - 20*D1**2*f*fd**2*s - 12*D1**2*f*fd**2 + 288*D1**2*f*fd*g2*r*s - 144*D1**2*f*fd*g2*r - 720*D1**2*f*fd*g2*s**2 + 720*D1**2*f*fd*g2*s - 360*D1**2*f*fd*g2 - 288*D1**2*f*fd*gd2*r*s + 72*D1**2*f*fd*gd2*r + 720*D1**2*f*fd*gd2*s**2 - 216*D1**2*f*fd*gd2*s - 72*D1**2*f*fd*gd2 - 144*D1**2*f*fdd*g2*r*s + 72*D1**2*f*fdd*g2*r + 360*D1**2*f*fdd*g2*s**2 - 360*D1**2*f*fdd*g2*s + 180*D1**2*f*fdd*g2 - 144*D1**2*fd**2*g2*r*s + 72*D1**2*fd**2*g2*r + 360*D1**2*fd**2*g2*s**2 - 360*D1**2*fd**2*g2*s - 112*D1*Dd*f**4*r*s + 28*D1*Dd*f**4*r + 56*D1*Dd*f**4*s + 896*D1*Dd*f**3*fd*r*s - 224*D1*Dd*f**3*fd*r - 448*D1*Dd*f**3*fd*s + 112*D1*Dd*f**3*fd + 96*D1*Dd*f**3*r*s - 24*D1*Dd*f**3*r - 88*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s - 22*D1*Dd*f**3 - 288*D1*Dd*f**2*fd*r*s + 84*D1*Dd*f**2*fd*r + 264*D1*Dd*f**2*fd*s**2 - 34*D1*Dd*f**2*fd*s - 14*D1*Dd*f**2*fd + 576*D1*Dd*f**2*g2*r*s - 144*D1*Dd*f**2*g2*r - 1440*D1*Dd*f**2*g2*s**2 + 432*D1*Dd*f**2*g2*s - 360*D1*Dd*f**2*g2 - 576*D1*Dd*f**2*gd2*r*s + 72*D1*Dd*f**2*gd2*r + 1440*D1*Dd*f**2*gd2*s**2 + 72*D1*Dd*f**2*gd2*s - 72*D1*Dd*f**2*gd2 - 1152*D1*Dd*f*fd*g2*r*s + 432*D1*Dd*f*fd*g2*r + 2880*D1*Dd*f*fd*g2*s**2 - 1872*D1*Dd*f*fd*g2*s + 216*D1*Dd*f*fd*g2 + 112*D1*Ddd*f**4*r*s - 28*D1*Ddd*f**4*r - 56*D1*Ddd*f**4*s - 48*D1*Ddd*f**3*r*s + 12*D1*Ddd*f**3*r + 44*D1*Ddd*f**3*s**2 + 2*D1*Ddd*f**3*s + 11*D1*Ddd*f**3 - 288*D1*Ddd*f**2*g2*r*s + 72*D1*Ddd*f**2*g2*r + 720*D1*Ddd*f**2*g2*s**2 - 216*D1*Ddd*f**2*g2*s + 180*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(f*s*(-18*K*(2*r - 5*s - 2) + 7*f*(4*r - s - 4) + 72*r - 9*s - 72) + fd*(9*K*(8*r*s - 2*r - 20*s**2 + 6*s + 2) + 7*f*(r*(2 - 12*s) + 3*s**2 + 7*s - 2) - 144*r*s + 36*r + 18*s**2 + 63*s - 36)) + Dd*f*(-18*K*(-8*r*s + r + 20*s**2 + s - 1) + 7*f*(r*(2 - 16*s) + 4*s**2 + 11*s - 2) - 288*r*s + 36*r + 36*s**2 + 207*s - 36)) + 336*Dd**2*f**4*r*s - 84*Dd**2*f**4*r - 168*Dd**2*f**4*s + 56*Dd**2*f**4 - 144*Dd**2*f**3*r*s + 36*Dd**2*f**3*r + 132*Dd**2*f**3*s**2 + 6*Dd**2*f**3*s - 24*Dd**2*f**3 - 864*Dd**2*f**2*g2*r*s + 216*Dd**2*f**2*g2*r + 2160*Dd**2*f**2*g2*s**2 - 648*Dd**2*f**2*g2*s - 144*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(4 - 12*s) + 3*s**2 + 2*s + 1) + f*(14*fd**2*(r*(4 - 12*s) + 3*s**2 + 2*s - 2) - 18*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1) + 9*fdd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1)) + 18*fd**2*(r*(2*K - 4)*(2*s - 1) - s*(10*K - 1)*(s - 1))) + D1*f*(2*Dd*(-7*f**2*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) + f*(-18*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + fd*(r*(98 - 336*s) + 84*s**2 + 91*s - 35) + 288*r*s - 72*r - 36*s**2 - 126*s - 9) + 9*fd*(2*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) - 64*r*s + 24*r + 8*s**2 + 10*s - 7)) + Ddd*f*(18*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + 7*f*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) - 288*r*s + 72*r + 36*s**2 + 126*s + 9)) + 2*Dd**2*f**2*(18*K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) + 7*f*(r*(6 - 24*s) + 6*s**2 + 9*s - 4) - 432*r*s + 108*r + 54*s**2 + 189*s - 72)))/(126*d**2*k3**4) + D1**2*Pk3*Pkd2*ct*k1*k2**2*st**4*(-24*C*D1**2*bdd1*f**2*r*s - 24*C*D1**2*bdd1*f**2*r - 60*C*D1**2*bdd1*f**2*s**2 + 24*C*D1**2*bdd1*f**2*s - 12*C*D1**2*bdd1*f**2 - 1296*C*D1**2*f**2*fd*r*s + 432*C*D1**2*f**2*fd*r - 1128*C*D1**2*f**2*fd*s**2 + 1184*C*D1**2*f**2*fd*s - 376*C*D1**2*f**2*fd + 936*C*D1**2*f**2*fdd*r*s - 312*C*D1**2*f**2*fdd*r + 744*C*D1**2*f**2*fdd*s**2 - 808*C*D1**2*f**2*fdd*s + 248*C*D1**2*f**2*fdd + 1872*C*D1**2*f*fd**2*r*s - 624*C*D1**2*f*fd**2*r + 1488*C*D1**2*f*fd**2*s**2 - 1616*C*D1**2*f*fd**2*s + 312*C*D1**2*f*fd**2 - 1728*C*D1*Dd*f**3*r*s + 432*C*D1*Dd*f**3*r - 1504*C*D1*Dd*f**3*s**2 + 1616*C*D1*Dd*f**3*s - 376*C*D1*Dd*f**3 + 7488*C*D1*Dd*f**2*fd*r*s - 2184*C*D1*Dd*f**2*fd*r + 5952*C*D1*Dd*f**2*fd*s**2 - 6592*C*D1*Dd*f**2*fd*s + 1432*C*D1*Dd*f**2*fd + 1248*C*D1*Ddd*f**3*r*s - 312*C*D1*Ddd*f**3*r + 992*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 248*C*D1*Ddd*f**3 + 3744*C*Dd**2*f**3*r*s - 936*C*Dd**2*f**3*r + 2976*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 624*C*Dd**2*f**3 + 468*D1**2*K*bdd1*f**2*r*s + 588*D1**2*K*bdd1*f**2*s**2 - 468*D1**2*K*bdd1*f**2*s - 552*D1**2*b2*f*fd*r*s + 276*D1**2*b2*f*fd*r - 552*D1**2*b2*f*fd*s**2 + 552*D1**2*b2*f*fd*s - 276*D1**2*b2*f*fd + 360*D1**2*b2*f*fdd*r*s - 180*D1**2*b2*f*fdd*r + 360*D1**2*b2*f*fdd*s**2 - 360*D1**2*b2*f*fdd*s + 180*D1**2*b2*f*fdd + 360*D1**2*b2*fd**2*r*s - 180*D1**2*b2*fd**2*r + 360*D1**2*b2*fd**2*s**2 - 360*D1**2*b2*fd**2*s + 6*D1**2*bd1**2*f*(-14*K*(2*r*s + r + 5*s**2 - 2*s - 1) + 5*f*(2*r + s**2 + 3*s - 2) - 28*r*(s - 1) + 7*s**2 + 35*s - 28) - 276*D1**2*bd2*f**2*r*s - 276*D1**2*bd2*f**2*s**2 + 276*D1**2*bd2*f**2*s + 720*D1**2*bd2*f*fd*r*s - 180*D1**2*bd2*f*fd*r + 720*D1**2*bd2*f*fd*s**2 - 720*D1**2*bd2*f*fd*s + 180*D1**2*bd2*f*fd - 120*D1**2*bdd1*f**3*r*s - 60*D1**2*bdd1*f**3*r - 165*D1**2*bdd1*f**3*s**2 + 180*D1**2*bdd1*f**3*s - 144*D1**2*bdd1*f**2*r*s + 36*D1**2*bdd1*f**2*r - 186*D1**2*bdd1*f**2*s**2 + 150*D1**2*bdd1*f**2*s - 3*D1**2*bdd1*f**2 + 168*D1**2*bdd1*f*g2*r*s + 168*D1**2*bdd1*f*g2*r + 420*D1**2*bdd1*f*g2*s**2 - 168*D1**2*bdd1*f*g2*s + 84*D1**2*bdd1*f*g2 + 180*D1**2*bdd2*f**2*r*s + 180*D1**2*bdd2*f**2*s**2 - 180*D1**2*bdd2*f**2*s + 756*D1**2*f**2*fd*r*s - 252*D1**2*f**2*fd*r + 678*D1**2*f**2*fd*s**2 - 704*D1**2*f**2*fd*s + 226*D1**2*f**2*fd - 612*D1**2*f**2*fdd*r*s + 204*D1**2*f**2*fdd*r - 483*D1**2*f**2*fdd*s**2 + 526*D1**2*f**2*fdd*s - 161*D1**2*f**2*fdd + 1200*D1**2*f**2*gd2*r*s + 1512*D1**2*f**2*gd2*s**2 - 1200*D1**2*f**2*gd2*s - 936*D1**2*f**2*gdd2*r*s - 1176*D1**2*f**2*gdd2*s**2 + 936*D1**2*f**2*gdd2*s - 1224*D1**2*f*fd**2*r*s + 408*D1**2*f*fd**2*r - 966*D1**2*f*fd**2*s**2 + 1052*D1**2*f*fd**2*s - 204*D1**2*f*fd**2 + 2400*D1**2*f*fd*g2*r*s - 1200*D1**2*f*fd*g2*r + 3024*D1**2*f*fd*g2*s**2 - 3024*D1**2*f*fd*g2*s + 1512*D1**2*f*fd*g2 - 3744*D1**2*f*fd*gd2*r*s + 936*D1**2*f*fd*gd2*r - 4704*D1**2*f*fd*gd2*s**2 + 4224*D1**2*f*fd*gd2*s - 936*D1**2*f*fd*gd2 - 1872*D1**2*f*fdd*g2*r*s + 936*D1**2*f*fdd*g2*r - 2352*D1**2*f*fdd*g2*s**2 + 2352*D1**2*f*fdd*g2*s - 1176*D1**2*f*fdd*g2 - 1872*D1**2*fd**2*g2*r*s + 936*D1**2*fd**2*g2*r - 2352*D1**2*fd**2*g2*s**2 + 2352*D1**2*fd**2*g2*s - 1104*D1*Dd*b2*f**2*r*s + 276*D1*Dd*b2*f**2*r - 1104*D1*Dd*b2*f**2*s**2 + 1104*D1*Dd*b2*f**2*s - 276*D1*Dd*b2*f**2 + 2880*D1*Dd*b2*f*fd*r*s - 1080*D1*Dd*b2*f*fd*r + 2880*D1*Dd*b2*f*fd*s**2 - 2880*D1*Dd*b2*f*fd*s + 720*D1*Dd*b2*f*fd + 1440*D1*Dd*bd2*f**2*r*s - 180*D1*Dd*bd2*f**2*r + 1440*D1*Dd*bd2*f**2*s**2 - 1440*D1*Dd*bd2*f**2*s + 180*D1*Dd*bd2*f**2 + 1008*D1*Dd*f**3*r*s - 252*D1*Dd*f**3*r + 904*D1*Dd*f**3*s**2 - 956*D1*Dd*f**3*s + 226*D1*Dd*f**3 - 4896*D1*Dd*f**2*fd*r*s + 1428*D1*Dd*f**2*fd*r - 3864*D1*Dd*f**2*fd*s**2 + 4294*D1*Dd*f**2*fd*s - 934*D1*Dd*f**2*fd + 4800*D1*Dd*f**2*g2*r*s - 1200*D1*Dd*f**2*g2*r + 6048*D1*Dd*f**2*g2*s**2 - 5424*D1*Dd*f**2*g2*s + 1512*D1*Dd*f**2*g2 - 7488*D1*Dd*f**2*gd2*r*s + 936*D1*Dd*f**2*gd2*r - 9408*D1*Dd*f**2*gd2*s**2 + 7968*D1*Dd*f**2*gd2*s - 936*D1*Dd*f**2*gd2 - 14976*D1*Dd*f*fd*g2*r*s + 5616*D1*Dd*f*fd*g2*r - 18816*D1*Dd*f*fd*g2*s**2 + 17856*D1*Dd*f*fd*g2*s - 4224*D1*Dd*f*fd*g2 + 720*D1*Ddd*b2*f**2*r*s - 180*D1*Ddd*b2*f**2*r + 720*D1*Ddd*b2*f**2*s**2 - 720*D1*Ddd*b2*f**2*s + 180*D1*Ddd*b2*f**2 - 816*D1*Ddd*f**3*r*s + 204*D1*Ddd*f**3*r - 644*D1*Ddd*f**3*s**2 + 730*D1*Ddd*f**3*s - 161*D1*Ddd*f**3 - 3744*D1*Ddd*f**2*g2*r*s + 936*D1*Ddd*f**2*g2*r - 4704*D1*Ddd*f**2*g2*s**2 + 4224*D1*Ddd*f**2*g2*s - 1176*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(5*f**3*(2*r*(s + 1) + s*(5*s - 4)) + f**2*(4*C*(2*r*(s + 1) + 5*s**2 - 2*s + 1) - 100*K*r*s - 126*K*s**2 + 100*K*s - 5*fd*(24*r*s + 33*s**2 - 31*s + 2) + 6*r*s - 12*r + 20*s**2 - 8*s + 1) - f*(fd*(4*C*(10*s**2 + s*(4*r - 7) - 1) + K*(-312*r*s + 78*r - 392*s**2 + 352*s - 78) + 96*r*s - 30*r + 124*s**2 - 111*s + 30) + 28*g2*(2*r*(s + 1) + 5*s**2 - 2*s + 1) - 28*gd2*(2*r*s + r + 5*s**2 - 2*s - 1)) + 28*fd*g2*(r*(2*s - 1) + s*(5*s - 5))) - Dd*f*(5*f**2*(4*r*(8*s + 1) + 44*s**2 - 43*s + 2) + f*(4*C*(r*(8*s + 3) + 20*s**2 - 11*s - 1) + K*(-624*r*s + 78*r - 784*s**2 + 664*s - 78) + (4*s - 1)*(48*r + 62*s - 37)) - 28*g2*(r*(8*s + 3) + 20*s**2 - 11*s - 1))) + 2160*Dd**2*b2*f**2*r*s - 540*Dd**2*b2*f**2*r + 2160*Dd**2*b2*f**2*s**2 - 2160*Dd**2*b2*f**2*s + 360*Dd**2*b2*f**2 - 2448*Dd**2*f**3*r*s + 612*Dd**2*f**3*r - 1932*Dd**2*f**3*s**2 + 2190*Dd**2*f**3*s - 408*Dd**2*f**3 - 11232*Dd**2*f**2*g2*r*s + 2808*Dd**2*f**2*g2*r - 14112*Dd**2*f**2*g2*s**2 + 12672*Dd**2*f**2*g2*s - 1872*Dd**2*f**2*g2 + 3*b1**2*(D1**2*(20*f*fd*(2*r - s**2 + 4*s - 2) - 10*f*fdd*(2*r - s**2 + 4*s - 2) - 10*fd**2*(2*r - s**2 + 4*s - 2) + 14*fd*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4) - 7*fdd*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4)) - 2*D1*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(-14*K*(r*(8*s - 2) + 20*s**2 - 14*s + 5) + 10*fd*(4*r - 4*s**2 + 9*s - 4) - 112*r*s + 28*r + 28*s**2 + 42*s + 7) + 7*fd*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8)) + D1*Ddd*f*(-14*K*(r*(8*s - 2) + 20*s**2 - 14*s + 5) + 5*f*(4*s**2 - 2*s + 1) - 112*r*s + 28*r + 28*s**2 + 42*s + 7) + 2*Dd**2*f*(-14*K*(3*r*(4*s - 1) + 30*s**2 - 21*s + 2) + 30*f*s**2 - 15*f*s - 42*r*(4*s - 1) + 42*s**2 + 63*s - 28)) - 3*b1*(-32*C*D1**2*f*fd*r*s + 32*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 80*C*D1**2*f*fd*s - 32*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r*s - 16*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 16*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r*s - 16*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s + 16*C*D1**2*fd**2 - 64*C*D1*Dd*f**2*r*s + 16*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 112*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 272*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r*s - 8*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 56*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r*s - 24*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 168*C*Dd**2*f**2*s + 16*C*Dd**2*f**2 + 400*D1**2*K*f*fd*r*s - 200*D1**2*K*f*fd*r + 504*D1**2*K*f*fd*s**2 - 504*D1**2*K*f*fd*s + 252*D1**2*K*f*fd - 312*D1**2*K*f*fdd*r*s + 156*D1**2*K*f*fdd*r - 392*D1**2*K*f*fdd*s**2 + 392*D1**2*K*f*fdd*s - 196*D1**2*K*f*fdd - 312*D1**2*K*fd**2*r*s + 156*D1**2*K*fd**2*r - 392*D1**2*K*fd**2*s**2 + 392*D1**2*K*fd**2*s + D1**2*bdd1*f*(7*K*(r*(8*s + 4) + 20*s**2 - 8*s + 2) - 5*f*(4*r + 2*s**2 + 6*s - 3) + 56*r*(s - 1) - 14*s**2 - 70*s + 21) - 60*D1**2*f**2*fd*r*s + 40*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 120*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 130*D1**2*f**2*fdd*s + 55*D1**2*f**2*fdd + 240*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 260*D1**2*f*fd**2*s + 60*D1**2*f*fd**2 - 24*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 80*D1**2*f*fd*s**2 + 76*D1**2*f*fd*s - 38*D1**2*f*fd + 96*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 124*D1**2*f*fdd*s**2 - 122*D1**2*f*fdd*s + 61*D1**2*f*fdd + 112*D1**2*f*gd2*r*s + 280*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s - 56*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s + 96*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 124*D1**2*fd**2*s**2 - 122*D1**2*fd**2*s - 12*D1**2*fd**2 + 112*D1**2*fd*g2*r*s - 224*D1**2*fd*g2*r + 280*D1**2*fd*g2*s**2 - 448*D1**2*fd*g2*s + 224*D1**2*fd*g2 - 112*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 280*D1**2*fd*gd2*s**2 + 280*D1**2*fd*gd2*s - 112*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r*s + 112*D1**2*fdd*g2*r - 140*D1**2*fdd*g2*s**2 + 224*D1**2*fdd*g2*s - 112*D1**2*fdd*g2 + 800*D1*Dd*K*f**2*r*s - 200*D1*Dd*K*f**2*r + 1008*D1*Dd*K*f**2*s**2 - 904*D1*Dd*K*f**2*s + 252*D1*Dd*K*f**2 - 2496*D1*Dd*K*f*fd*r*s + 936*D1*Dd*K*f*fd*r - 3136*D1*Dd*K*f*fd*s**2 + 2976*D1*Dd*K*f*fd*s - 704*D1*Dd*K*f*fd - 80*D1*Dd*f**3*r*s + 20*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 140*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 960*D1*Dd*f**2*fd*r*s - 360*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1090*D1*Dd*f**2*fd*s + 250*D1*Dd*f**2*fd - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 160*D1*Dd*f**2*s**2 + 104*D1*Dd*f**2*s - 40*D1*Dd*f**2 + 768*D1*Dd*f*fd*r*s - 240*D1*Dd*f*fd*r + 992*D1*Dd*f*fd*s**2 - 928*D1*Dd*f*fd*s + 194*D1*Dd*f*fd + 448*D1*Dd*f*g2*r*s - 112*D1*Dd*f*g2*r + 1120*D1*Dd*f*g2*s**2 - 784*D1*Dd*f*g2*s + 280*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r*s + 56*D1*Dd*f*gd2*r - 1120*D1*Dd*f*gd2*s**2 + 616*D1*Dd*f*gd2*s - 56*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 1120*D1*Dd*fd*g2*s**2 + 1288*D1*Dd*fd*g2*s - 448*D1*Dd*fd*g2 - 624*D1*Ddd*K*f**2*r*s + 156*D1*Ddd*K*f**2*r - 784*D1*Ddd*K*f**2*s**2 + 704*D1*Ddd*K*f**2*s - 196*D1*Ddd*K*f**2 + 160*D1*Ddd*f**3*r*s - 40*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 190*D1*Ddd*f**3*s + 55*D1*Ddd*f**3 + 192*D1*Ddd*f**2*r*s - 48*D1*Ddd*f**2*r + 248*D1*Ddd*f**2*s**2 - 220*D1*Ddd*f**2*s + 62*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r*s + 56*D1*Ddd*f*g2*r - 560*D1*Ddd*f*g2*s**2 + 392*D1*Ddd*f*g2*s - 140*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*f**2*(4*r + 2*s**2 + 6*s - 3) - f*(14*K*(r*(4*s + 2) + 10*s**2 - 4*s + 1) + 20*fd*s**2 - 10*fd*s + 56*r*(s - 1) - 14*s**2 - 70*s + 21) + 7*fd*(K*(8*r*s - 6*r + 20*s**2 - 20*s + 4) - 2*s**2 + s*(8*r + 3) - 2)) + Dd*f*(-5*f*(8*r + 8*s**2 + 10*s - 7) + 28*r*(8*K*s + K + 8*s - 5) + 7*s**2*(80*K - 8) - 7*s*(44*K + 26) + 91)) - 1872*Dd**2*K*f**2*r*s + 468*Dd**2*K*f**2*r - 2352*Dd**2*K*f**2*s**2 + 2112*Dd**2*K*f**2*s - 312*Dd**2*K*f**2 + 480*Dd**2*f**3*r*s - 120*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 570*Dd**2*f**3*s + 80*Dd**2*f**3 + 576*Dd**2*f**2*r*s - 144*Dd**2*f**2*r + 744*Dd**2*f**2*s**2 - 660*Dd**2*f**2*s + 96*Dd**2*f**2 - 672*Dd**2*f*g2*r*s + 168*Dd**2*f*g2*r - 1680*Dd**2*f*g2*s**2 + 1176*Dd**2*f*g2*s - 112*Dd**2*f*g2))/(210*d**2*k3**4) - D1**2*Pk3*Pkd2*ct*k1*k2**2*st**2*(224*C*D1**2*bd1**2*f*r*s - 112*C*D1**2*bd1**2*f*r + 224*C*D1**2*bd1**2*f*s**2 - 224*C*D1**2*bd1**2*f*s + 776*C*D1**2*bd1*f**2*r*s - 752*C*D1**2*bd1*f**2*r + 816*C*D1**2*bd1*f**2*s**2 - 1584*C*D1**2*bd1*f**2*s + 792*C*D1**2*bd1*f**2 - 2112*C*D1**2*bd1*f*fd*r*s + 1128*C*D1**2*bd1*f*fd*r - 1856*C*D1**2*bd1*f*fd*s**2 + 2528*C*D1**2*bd1*f*fd*s - 600*C*D1**2*bd1*f*fd - 528*C*D1**2*bdd1*f**2*r*s + 600*C*D1**2*bdd1*f**2*r - 464*C*D1**2*bdd1*f**2*s**2 + 1072*C*D1**2*bdd1*f**2*s - 536*C*D1**2*bdd1*f**2 - 600*C*D1**2*f**2*fd*r*s + 200*C*D1**2*f**2*fd*r + 216*C*D1**2*f**2*fd*s**2 + 56*C*D1**2*f**2*fd*s + 72*C*D1**2*f**2*fd - 312*C*D1**2*f**2*fdd*r*s + 104*C*D1**2*f**2*fdd*r - 756*C*D1**2*f**2*fdd*s**2 + 608*C*D1**2*f**2*fdd*s - 252*C*D1**2*f**2*fdd - 624*C*D1**2*f*fd**2*r*s + 208*C*D1**2*f*fd**2*r - 1512*C*D1**2*f*fd**2*s**2 + 1216*C*D1**2*f*fd**2*s - 104*C*D1**2*f*fd**2 - 4224*C*D1*Dd*bd1*f**2*r*s + 2928*C*D1*Dd*bd1*f**2*r - 3712*C*D1*Dd*bd1*f**2*s**2 + 6272*C*D1*Dd*bd1*f**2*s - 2272*C*D1*Dd*bd1*f**2 - 800*C*D1*Dd*f**3*r*s + 200*C*D1*Dd*f**3*r + 288*C*D1*Dd*f**3*s**2 + 256*C*D1*Dd*f**3*s + 72*C*D1*Dd*f**3 - 2496*C*D1*Dd*f**2*fd*r*s + 728*C*D1*Dd*f**2*fd*r - 6048*C*D1*Dd*f**2*fd*s**2 + 4568*C*D1*Dd*f**2*fd*s - 816*C*D1*Dd*f**2*fd - 416*C*D1*Ddd*f**3*r*s + 104*C*D1*Ddd*f**3*r - 1008*C*D1*Ddd*f**3*s**2 + 712*C*D1*Ddd*f**3*s - 252*C*D1*Ddd*f**3 - 1248*C*Dd**2*f**3*r*s + 312*C*Dd**2*f**3*r - 3024*C*Dd**2*f**3*s**2 + 2136*C*Dd**2*f**3*s - 208*C*Dd**2*f**3 - 1232*D1**2*K*bd1**2*f*r*s + 700*D1**2*K*bd1**2*f*r - 1456*D1**2*K*bd1**2*f*s**2 + 2240*D1**2*K*bd1**2*f*s - 700*D1**2*K*bd1**2*f - 252*D1**2*K*bd1*f**2*r*s + 84*D1**2*K*bd1*f**2*s**2 + 252*D1**2*K*bd1*f**2*s - 336*D1**2*K*bd1*f*fd*r*s + 84*D1**2*K*bd1*f*fd*r - 1176*D1**2*K*bd1*f*fd*s**2 + 756*D1**2*K*bd1*f*fd*s - 84*D1**2*K*bd1*f*fd - 84*D1**2*K*bdd1*f**2*r*s - 294*D1**2*K*bdd1*f**2*s**2 + 84*D1**2*K*bdd1*f**2*s + 504*D1**2*bd1**2*f**2*r*s - 252*D1**2*bd1**2*f**2*r + 294*D1**2*bd1**2*f**2*s**2 - 546*D1**2*bd1**2*f**2*s + 252*D1**2*bd1**2*f**2 + 280*D1**2*bd1**2*f*r*s - 140*D1**2*bd1**2*f*r + 266*D1**2*bd1**2*f*s**2 - 490*D1**2*bd1**2*f*s + 224*D1**2*bd1**2*f - 1120*D1**2*bd1**2*g2*r*s + 560*D1**2*bd1**2*g2*r - 1120*D1**2*bd1**2*g2*s**2 + 1120*D1**2*bd1**2*g2*s - 504*D1**2*bd1*bd2*f*r*s + 252*D1**2*bd1*bd2*f*r - 504*D1**2*bd1*bd2*f*s**2 + 756*D1**2*bd1*bd2*f*s - 252*D1**2*bd1*bd2*f - 384*D1**2*bd1*f**2*r*s + 428*D1**2*bd1*f**2*r - 458*D1**2*bd1*f**2*s**2 + 752*D1**2*bd1*f**2*s - 418*D1**2*bd1*f**2 + 1440*D1**2*bd1*f*fd*r*s - 756*D1**2*bd1*f*fd*r + 1140*D1**2*bd1*f*fd*s**2 - 1572*D1**2*bd1*f*fd*s + 396*D1**2*bd1*f*fd - 2184*D1**2*bd1*f*g2*r*s + 1680*D1**2*bd1*f*g2*r - 2352*D1**2*bd1*f*g2*s**2 + 3696*D1**2*bd1*f*g2*s - 1848*D1**2*bd1*f*g2 + 2464*D1**2*bd1*f*gd2*r*s - 1400*D1**2*bd1*f*gd2*r + 2912*D1**2*bd1*f*gd2*s**2 - 4480*D1**2*bd1*f*gd2*s + 1400*D1**2*bd1*f*gd2 + 2464*D1**2*bd1*fd*g2*r*s - 1232*D1**2*bd1*fd*g2*r + 2912*D1**2*bd1*fd*g2*s**2 - 2912*D1**2*bd1*fd*g2*s - 168*D1**2*bd2*f**2*r*s - 168*D1**2*bd2*f**2*s**2 + 168*D1**2*bd2*f**2*s + 360*D1**2*bdd1*f**2*r*s - 396*D1**2*bdd1*f**2*r + 285*D1**2*bdd1*f**2*s**2 - 642*D1**2*bdd1*f**2*s + 321*D1**2*bdd1*f**2 + 1232*D1**2*bdd1*f*g2*r*s - 1400*D1**2*bdd1*f*g2*r + 1456*D1**2*bdd1*f*g2*s**2 - 3248*D1**2*bdd1*f*g2*s + 1624*D1**2*bdd1*f*g2 + 408*D1**2*f**2*fd*r*s - 136*D1**2*f**2*fd*r - 108*D1**2*f**2*fd*s**2 - 64*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 156*D1**2*f**2*fdd*r*s - 52*D1**2*f**2*fdd*r + 378*D1**2*f**2*fdd*s**2 - 304*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd + 504*D1**2*f**2*gd2*r*s - 168*D1**2*f**2*gd2*s**2 - 504*D1**2*f**2*gd2*s + 168*D1**2*f**2*gdd2*r*s + 588*D1**2*f**2*gdd2*s**2 - 168*D1**2*f**2*gdd2*s + 312*D1**2*f*fd**2*r*s - 104*D1**2*f*fd**2*r + 756*D1**2*f*fd**2*s**2 - 608*D1**2*f*fd**2*s + 52*D1**2*f*fd**2 + 1008*D1**2*f*fd*g2*r*s - 504*D1**2*f*fd*g2*r - 336*D1**2*f*fd*g2*s**2 + 336*D1**2*f*fd*g2*s - 168*D1**2*f*fd*g2 + 672*D1**2*f*fd*gd2*r*s - 168*D1**2*f*fd*gd2*r + 2352*D1**2*f*fd*gd2*s**2 - 1512*D1**2*f*fd*gd2*s + 168*D1**2*f*fd*gd2 + 336*D1**2*f*fdd*g2*r*s - 168*D1**2*f*fdd*g2*r + 1176*D1**2*f*fdd*g2*s**2 - 1176*D1**2*f*fdd*g2*s + 588*D1**2*f*fdd*g2 + 336*D1**2*fd**2*g2*r*s - 168*D1**2*fd**2*g2*r + 1176*D1**2*fd**2*g2*s**2 - 1176*D1**2*fd**2*g2*s - 672*D1*Dd*K*bd1*f**2*r*s + 84*D1*Dd*K*bd1*f**2*r - 2352*D1*Dd*K*bd1*f**2*s**2 + 1092*D1*Dd*K*bd1*f**2*s - 84*D1*Dd*K*bd1*f**2 + 2880*D1*Dd*bd1*f**2*r*s - 1944*D1*Dd*bd1*f**2*r + 2280*D1*Dd*bd1*f**2*s**2 - 3858*D1*Dd*bd1*f**2*s + 1434*D1*Dd*bd1*f**2 + 9856*D1*Dd*bd1*f*g2*r*s - 6832*D1*Dd*bd1*f*g2*r + 11648*D1*Dd*bd1*f*g2*s**2 - 18368*D1*Dd*bd1*f*g2*s + 6048*D1*Dd*bd1*f*g2 + 544*D1*Dd*f**3*r*s - 136*D1*Dd*f**3*r - 144*D1*Dd*f**3*s**2 - 200*D1*Dd*f**3*s - 36*D1*Dd*f**3 + 1248*D1*Dd*f**2*fd*r*s - 364*D1*Dd*f**2*fd*r + 3024*D1*Dd*f**2*fd*s**2 - 2284*D1*Dd*f**2*fd*s + 408*D1*Dd*f**2*fd + 2016*D1*Dd*f**2*g2*r*s - 504*D1*Dd*f**2*g2*r - 672*D1*Dd*f**2*g2*s**2 - 672*D1*Dd*f**2*g2*s - 168*D1*Dd*f**2*g2 + 1344*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 4704*D1*Dd*f**2*gd2*s**2 - 2184*D1*Dd*f**2*gd2*s + 168*D1*Dd*f**2*gd2 + 2688*D1*Dd*f*fd*g2*r*s - 1008*D1*Dd*f*fd*g2*r + 9408*D1*Dd*f*fd*g2*s**2 - 7728*D1*Dd*f*fd*g2*s + 1512*D1*Dd*f*fd*g2 + 208*D1*Ddd*f**3*r*s - 52*D1*Ddd*f**3*r + 504*D1*Ddd*f**3*s**2 - 356*D1*Ddd*f**3*s + 126*D1*Ddd*f**3 + 672*D1*Ddd*f**2*g2*r*s - 168*D1*Ddd*f**2*g2*r + 2352*D1*Ddd*f**2*g2*s**2 - 1512*D1*Ddd*f**2*g2*s + 588*D1*Ddd*f**2*g2 + 28*D1*b2*(bd1*(D1*(13*f*(s - 1)*(r + s - 1) + 9*fd*(-2*r*s + r - s*(2*s - 2))) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + 2*D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + 624*Dd**2*f**3*r*s - 156*Dd**2*f**3*r + 1512*Dd**2*f**3*s**2 - 1068*Dd**2*f**3*s + 104*Dd**2*f**3 + 2016*Dd**2*f**2*g2*r*s - 504*Dd**2*f**2*g2*r + 7056*Dd**2*f**2*g2*s**2 - 4536*Dd**2*f**2*g2*s + 336*Dd**2*f**2*g2 + 28*b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - (20*K - 10)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(-10*K + 3*f + 5) - Dd**2*(-10*K + 3*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(-32*C*D1**2*fd*r*s - 32*C*D1**2*fd*s**2 + 32*C*D1**2*fd*s + 16*C*D1**2*fdd*r*s + 16*C*D1**2*fdd*s**2 - 16*C*D1**2*fdd*s - 128*C*D1*Dd*f*r*s + 32*C*D1*Dd*f*r - 128*C*D1*Dd*f*s**2 + 128*C*D1*Dd*f*s - 32*C*D1*Dd*f + 128*C*D1*Dd*fd*r*s - 16*C*D1*Dd*fd*r + 128*C*D1*Dd*fd*s**2 - 128*C*D1*Dd*fd*s + 16*C*D1*Dd*fd + 64*C*D1*Ddd*f*r*s - 16*C*D1*Ddd*f*r + 64*C*D1*Ddd*f*s**2 - 64*C*D1*Ddd*f*s + 16*C*D1*Ddd*f + 192*C*Dd**2*f*r*s - 48*C*Dd**2*f*r + 192*C*Dd**2*f*s**2 - 192*C*Dd**2*f*s + 32*C*Dd**2*f + 156*D1**2*K*fd*r*s - 36*D1**2*K*fd*r + 168*D1**2*K*fd*s**2 - 72*D1**2*K*fd*s + 36*D1**2*K*fd - 88*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r - 104*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 4*D1**2*bdd1*(-10*K + 3*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 72*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 60*D1**2*f*fd*s - 12*D1**2*f*fd + 72*D1**2*f*fdd*r*s + 42*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 72*D1**2*fd**2*r*s + 42*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s + 20*D1**2*fd*r + 2*D1**2*fd*s**2 + 16*D1**2*fd*s - 20*D1**2*fd + 20*D1**2*fdd*r*s + 19*D1**2*fdd*s**2 + 12*D1**2*fdd*s + 160*D1**2*gd2*r*s + 160*D1**2*gd2*s**2 - 160*D1**2*gd2*s - 80*D1**2*gdd2*r*s - 80*D1**2*gdd2*s**2 + 80*D1**2*gdd2*s + 624*D1*Dd*K*f*r*s - 156*D1*Dd*K*f*r + 672*D1*Dd*K*f*s**2 - 648*D1*Dd*K*f*s + 168*D1*Dd*K*f - 704*D1*Dd*K*fd*r*s + 40*D1*Dd*K*fd*r - 832*D1*Dd*K*fd*s**2 + 288*D1*Dd*K*fd*s + 48*D1*Dd*K*fd - 144*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 108*D1*Dd*f**2*s - 18*D1*Dd*f**2 + 576*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 372*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 8*D1*Dd*f*s**2 - 4*D1*Dd*f*s + 2*D1*Dd*f + 160*D1*Dd*fd*r*s - 20*D1*Dd*fd*r + 152*D1*Dd*fd*s**2 - 30*D1*Dd*fd*s - 12*D1*Dd*fd + 640*D1*Dd*g2*r*s - 160*D1*Dd*g2*r + 640*D1*Dd*g2*s**2 - 640*D1*Dd*g2*s + 160*D1*Dd*g2 - 640*D1*Dd*gd2*r*s + 80*D1*Dd*gd2*r - 640*D1*Dd*gd2*s**2 + 640*D1*Dd*gd2*s - 80*D1*Dd*gd2 - 352*D1*Ddd*K*f*r*s + 88*D1*Ddd*K*f*r - 416*D1*Ddd*K*f*s**2 + 384*D1*Ddd*K*f*s - 104*D1*Ddd*K*f + 144*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 114*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 + 80*D1*Ddd*f*r*s - 20*D1*Ddd*f*r + 76*D1*Ddd*f*s**2 - 78*D1*Ddd*f*s + 19*D1*Ddd*f - 320*D1*Ddd*g2*r*s + 80*D1*Ddd*g2*r - 320*D1*Ddd*g2*s**2 + 320*D1*Ddd*g2*s - 80*D1*Ddd*g2 + 4*D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + (10 - 20*K)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(-10*K + 3*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 1056*Dd**2*K*f*r*s + 264*Dd**2*K*f*r - 1248*Dd**2*K*f*s**2 + 1152*Dd**2*K*f*s - 176*Dd**2*K*f + 432*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 342*Dd**2*f**2*s + 72*Dd**2*f**2 + 240*Dd**2*f*r*s - 60*Dd**2*f*r + 228*Dd**2*f*s**2 - 234*Dd**2*f*s + 40*Dd**2*f - 960*Dd**2*g2*r*s + 240*Dd**2*g2*r - 960*Dd**2*g2*s**2 + 960*Dd**2*g2*s - 160*Dd**2*g2) + b1*(1552*C*D1**2*f*fd*r*s - 24*C*D1**2*f*fd*r + 1632*C*D1**2*f*fd*s**2 - 824*C*D1**2*f*fd*s + 24*C*D1**2*f*fd - 1056*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*r - 928*C*D1**2*f*fdd*s**2 + 384*C*D1**2*f*fdd*s + 72*C*D1**2*f*fdd - 1056*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*r - 928*C*D1**2*fd**2*s**2 + 384*C*D1**2*fd**2*s + 72*C*D1**2*fd**2 + 3104*C*D1*Dd*f**2*r*s - 776*C*D1*Dd*f**2*r + 3264*C*D1*Dd*f**2*s**2 - 3184*C*D1*Dd*f**2*s + 816*C*D1*Dd*f**2 - 8448*C*D1*Dd*f*fd*r*s + 768*C*D1*Dd*f*fd*r - 7424*C*D1*Dd*f*fd*s**2 + 5504*C*D1*Dd*f*fd*s - 240*C*D1*Dd*f*fd - 2112*C*D1*Ddd*f**2*r*s + 528*C*D1*Ddd*f**2*r - 1856*C*D1*Ddd*f**2*s**2 + 1984*C*D1*Ddd*f**2*s - 464*C*D1*Ddd*f**2 - 6336*C*Dd**2*f**2*r*s + 1584*C*Dd**2*f**2*r - 5568*C*Dd**2*f**2*s**2 + 5952*C*Dd**2*f**2*s - 1056*C*Dd**2*f**2 - 504*D1**2*K*f*fd*r*s + 252*D1**2*K*f*fd*r + 168*D1**2*K*f*fd*s**2 - 168*D1**2*K*f*fd*s + 84*D1**2*K*f*fd - 168*D1**2*K*f*fdd*r*s + 84*D1**2*K*f*fdd*r - 588*D1**2*K*f*fdd*s**2 + 588*D1**2*K*f*fdd*s - 294*D1**2*K*f*fdd - 168*D1**2*K*fd**2*r*s + 84*D1**2*K*fd**2*r - 588*D1**2*K*fd**2*s**2 + 588*D1**2*K*fd**2*s + 364*D1**2*b2*fd*r*s + 364*D1**2*b2*fd*s**2 - 252*D1**2*b2*fdd*r*s - 252*D1**2*b2*fdd*s**2 - 28*D1**2*bd1**2*(-10*K + 3*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 364*D1**2*bd2*f*r*s + 364*D1**2*bd2*f*s**2 - 364*D1**2*bd2*f*s - 504*D1**2*bd2*fd*r*s - 504*D1**2*bd2*fd*s**2 + 252*D1**2*bd2*fd*s + 7*D1**2*bdd1*(3*f**2*(12*r*(2*s - 1) + 14*s**2 - 26*s + 7) + f*(16*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 4*K*(44*r*s - 25*r + 52*s**2 - 80*s + 29) + 40*r*s - 20*r + 38*s**2 - 70*s + 19) - 80*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 252*D1**2*bdd2*f*r*s - 252*D1**2*bdd2*f*s**2 + 252*D1**2*bdd2*f*s - 768*D1**2*f*fd*r*s - 44*D1**2*f*fd*r - 916*D1**2*f*fd*s**2 + 548*D1**2*f*fd*s - 40*D1**2*f*fd + 720*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r + 570*D1**2*f*fdd*s**2 - 288*D1**2*f*fdd*s - 36*D1**2*f*fdd - 2184*D1**2*f*gd2*r*s - 2352*D1**2*f*gd2*s**2 + 2184*D1**2*f*gd2*s + 1232*D1**2*f*gdd2*r*s + 1456*D1**2*f*gdd2*s**2 - 1232*D1**2*f*gdd2*s + 720*D1**2*fd**2*r*s + 36*D1**2*fd**2*r + 570*D1**2*fd**2*s**2 - 288*D1**2*fd**2*s - 36*D1**2*fd**2 - 2184*D1**2*fd*g2*r*s + 504*D1**2*fd*g2*r - 2352*D1**2*fd*g2*s**2 + 1008*D1**2*fd*g2*s - 504*D1**2*fd*g2 + 2464*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*r + 2912*D1**2*fd*gd2*s**2 - 896*D1**2*fd*gd2*s - 168*D1**2*fd*gd2 + 1232*D1**2*fdd*g2*r*s + 168*D1**2*fdd*g2*r + 1456*D1**2*fdd*g2*s**2 + 336*D1**2*fdd*g2*s - 168*D1**2*fdd*g2 - 1008*D1*Dd*K*f**2*r*s + 252*D1*Dd*K*f**2*r + 336*D1*Dd*K*f**2*s**2 + 336*D1*Dd*K*f**2*s + 84*D1*Dd*K*f**2 - 1344*D1*Dd*K*f*fd*r*s + 504*D1*Dd*K*f*fd*r - 4704*D1*Dd*K*f*fd*s**2 + 3864*D1*Dd*K*f*fd*s - 756*D1*Dd*K*f*fd + 1456*D1*Dd*b2*f*r*s - 364*D1*Dd*b2*f*r + 1456*D1*Dd*b2*f*s**2 - 1456*D1*Dd*b2*f*s + 364*D1*Dd*b2*f - 2016*D1*Dd*b2*fd*r*s + 252*D1*Dd*b2*fd*r - 2016*D1*Dd*b2*fd*s**2 + 1008*D1*Dd*b2*fd*s - 2016*D1*Dd*bd2*f*r*s + 252*D1*Dd*bd2*f*r - 2016*D1*Dd*bd2*f*s**2 + 2016*D1*Dd*bd2*f*s - 252*D1*Dd*bd2*f - 1536*D1*Dd*f**2*r*s + 384*D1*Dd*f**2*r - 1832*D1*Dd*f**2*s**2 + 1684*D1*Dd*f**2*s - 458*D1*Dd*f**2 + 5760*D1*Dd*f*fd*r*s - 576*D1*Dd*f*fd*r + 4560*D1*Dd*f*fd*s**2 - 3732*D1*Dd*f*fd*s + 216*D1*Dd*f*fd - 8736*D1*Dd*f*g2*r*s + 2184*D1*Dd*f*g2*r - 9408*D1*Dd*f*g2*s**2 + 9072*D1*Dd*f*g2*s - 2352*D1*Dd*f*g2 + 9856*D1*Dd*f*gd2*r*s - 1232*D1*Dd*f*gd2*r + 11648*D1*Dd*f*gd2*s**2 - 10304*D1*Dd*f*gd2*s + 1232*D1*Dd*f*gd2 + 9856*D1*Dd*fd*g2*r*s - 560*D1*Dd*fd*g2*r + 11648*D1*Dd*fd*g2*s**2 - 4032*D1*Dd*fd*g2*s - 672*D1*Dd*fd*g2 - 336*D1*Ddd*K*f**2*r*s + 84*D1*Ddd*K*f**2*r - 1176*D1*Ddd*K*f**2*s**2 + 756*D1*Ddd*K*f**2*s - 294*D1*Ddd*K*f**2 - 1008*D1*Ddd*b2*f*r*s + 252*D1*Ddd*b2*f*r - 1008*D1*Ddd*b2*f*s**2 + 1008*D1*Ddd*b2*f*s - 252*D1*Ddd*b2*f + 1440*D1*Ddd*f**2*r*s - 360*D1*Ddd*f**2*r + 1140*D1*Ddd*f**2*s**2 - 1290*D1*Ddd*f**2*s + 285*D1*Ddd*f**2 + 4928*D1*Ddd*f*g2*r*s - 1232*D1*Ddd*f*g2*r + 5824*D1*Ddd*f*g2*s**2 - 5376*D1*Ddd*f*g2*s + 1456*D1*Ddd*f*g2 - 14*D1*bd1*(D1*(3*f**2*(4*r*(3*s - 1) + 6*s**2 - 8*s + 1) + f*(16*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 156*K*r*s + 60*K*r - 168*K*s**2 + 210*K*s - 66*K - 6*fd*(24*r*s - 6*r + 14*s**2 - 19*s + 3) + 10*r - 2*s**2 + 10*s - 11) + fd*(-8*C*(r*(4*s - 1) + (1 - 2*s)**2) + 2*K*(88*r*s - 19*r + 104*s**2 - 68*s - 3) - 40*r*s + 10*r - 38*s**2 + 23*s + 6) - 40*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 40*gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*(-3*f**2*(12*r*(8*s - 3) + 56*s**2 - 90*s + 25) + f*(-16*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 4*K*(8*r*(22*s - 9) + 208*s**2 - 256*s + 65) - 160*r*s + 60*r - 152*s**2 + 218*s - 55) + 80*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 1008*Dd**2*K*f**2*r*s + 252*Dd**2*K*f**2*r - 3528*Dd**2*K*f**2*s**2 + 2268*Dd**2*K*f**2*s - 168*Dd**2*K*f**2 - 3024*Dd**2*b2*f*r*s + 756*Dd**2*b2*f*r - 3024*Dd**2*b2*f*s**2 + 3024*Dd**2*b2*f*s - 504*Dd**2*b2*f + 4320*Dd**2*f**2*r*s - 1080*Dd**2*f**2*r + 3420*Dd**2*f**2*s**2 - 3870*Dd**2*f**2*s + 720*Dd**2*f**2 + 14784*Dd**2*f*g2*r*s - 3696*Dd**2*f*g2*r + 17472*Dd**2*f*g2*s**2 - 16128*Dd**2*f*g2*s + 2464*Dd**2*f*g2))/(210*d**2*k3**4) + D1**2*Pk3*Pkd2*ct*k1*k2**2*(D1*(140*D1*b2*bd1*f*(s - 1)*(r + s - 1) + 14*D1*bd1**2*(5*K*f*(r*(2*s - 1) + 3*s**2 - 4*s + 1) - f*(6*C - 3)*(r*(2*s - 1) + s*(2*s - 2)) + 10*g2*r*(2*s - 1) + 20*g2*s*(s - 1)) + D1*bdd1*f*(s - 1)*(f*(18*C - 9)*(6*r + 7*s - 7) - 70*g2*(2*r + 3*s - 3)) + 2*bd1*(D1*(3*f**2*(s - 1)*(34*C*r + 42*C*(s - 1) - 24*r - 21*s + 21) + f*(fd*(18*C - 9)*(6*r*(2*s - 1) + 14*s**2 - 17*s + 3) - 210*g2*(s - 1)*(r + s - 1) - 70*gd2*(2*r*s - r + 3*s**2 - 4*s + 1)) - 70*fd*g2*(r*(2*s - 1) + s*(3*s - 3))) + Dd*f*(f*(18*C - 9)*(3*r*(8*s - 5) + 28*s**2 - 41*s + 13) - 70*g2*(r*(8*s - 5) + 12*s**2 - 17*s + 5)))) + 70*b1**3*(D1**2*fd*s*(r + s - 1) + D1*(Dd*(-7*K + f + 3) - Ddd*K)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*K*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 7*b1**2*(D1**2*(-10*K*bdd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(fd*(-36*C*(r + s - 1) + 30*K*s + r*(30*K + 18) + 28*s - 28) + fdd*(-12*C*(r + s - 1) + 15*K*s + r*(10*K + 6) + 6*s - 6) + (140*gd2 + 20*gdd2)*(r + s - 1))) + 10*D1*bd1*(D1*(-7*K + f + 3)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*K*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) + D1*(-2*Dd*(f*(18*C*(r*(4*s - 1) + (1 - 2*s)**2) - 15*K*(r*(4*s - 1) + (1 - 2*s)**2) - 36*r*s + 9*r - 56*s**2 + 46*s - 14) + fd*(6*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 60*K*s**2 + 25*K*s - r*(5*K + 3)*(8*s - 1) - 24*s**2 + 24*s - 3) - 70*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 10*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + Ddd*(f*(-12*C*(r*(4*s - 1) + (1 - 2*s)**2) + 5*K*(r*(8*s - 2) + 12*s**2 - 10*s + 3) + 6*r*(4*s - 1) + 6*(1 - 2*s)**2) + 20*g2*(r*(4*s - 1) + (1 - 2*s)**2))) - 2*Dd**2*(f*(6*C*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - 5*K*(12*r*s - 3*r + 18*s**2 - 15*s + 2) - 36*r*s + 9*r - 36*s**2 + 36*s - 6) - 10*g2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))) + b1*(408*C*D1**2*f*fd*r*s + 504*C*D1**2*f*fd*s**2 - 204*C*D1**2*f*fd*s + 216*C*D1**2*f*fdd*r*s + 252*C*D1**2*f*fdd*s**2 - 108*C*D1**2*f*fdd*s + 216*C*D1**2*fd**2*r*s + 252*C*D1**2*fd**2*s**2 - 108*C*D1**2*fd**2*s + 816*C*D1*Dd*f**2*r*s - 204*C*D1*Dd*f**2*r + 1008*C*D1*Dd*f**2*s**2 - 912*C*D1*Dd*f**2*s + 252*C*D1*Dd*f**2 + 1728*C*D1*Dd*f*fd*r*s - 216*C*D1*Dd*f*fd*r + 2016*C*D1*Dd*f*fd*s**2 - 1368*C*D1*Dd*f*fd*s + 108*C*D1*Dd*f*fd + 432*C*D1*Ddd*f**2*r*s - 108*C*D1*Ddd*f**2*r + 504*C*D1*Ddd*f**2*s**2 - 468*C*D1*Ddd*f**2*s + 126*C*D1*Ddd*f**2 + 1296*C*Dd**2*f**2*r*s - 324*C*Dd**2*f**2*r + 1512*C*Dd**2*f**2*s**2 - 1404*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 - 70*D1**2*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 140*D1**2*b2*fd*r*s + 140*D1**2*b2*fd*s**2 + 140*D1**2*bd2*f*r*s + 140*D1**2*bd2*f*s**2 - 140*D1**2*bd2*f*s - 7*D1**2*bdd1*(f*(12*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 5*K*(4*r*s - 2*r + 6*s**2 - 8*s + 3) - 12*r*s + 6*r - 12*s**2 + 12*s - 6) - 20*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 288*D1**2*f*fd*r*s - 252*D1**2*f*fd*s**2 + 144*D1**2*f*fd*s - 108*D1**2*f*fdd*r*s - 126*D1**2*f*fdd*s**2 + 54*D1**2*f*fdd*s - 420*D1**2*f*gd2*r*s - 420*D1**2*f*gd2*s**2 + 420*D1**2*f*gd2*s - 140*D1**2*f*gdd2*r*s - 210*D1**2*f*gdd2*s**2 + 140*D1**2*f*gdd2*s - 108*D1**2*fd**2*r*s - 126*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s - 420*D1**2*fd*g2*r*s - 420*D1**2*fd*g2*s**2 - 280*D1**2*fd*gd2*r*s - 420*D1**2*fd*gd2*s**2 + 140*D1**2*fd*gd2*s - 140*D1**2*fdd*g2*r*s - 210*D1**2*fdd*g2*s**2 + 560*D1*Dd*b2*f*r*s - 140*D1*Dd*b2*f*r + 560*D1*Dd*b2*f*s**2 - 560*D1*Dd*b2*f*s + 140*D1*Dd*b2*f - 576*D1*Dd*f**2*r*s + 144*D1*Dd*f**2*r - 504*D1*Dd*f**2*s**2 + 540*D1*Dd*f**2*s - 126*D1*Dd*f**2 - 864*D1*Dd*f*fd*r*s + 108*D1*Dd*f*fd*r - 1008*D1*Dd*f*fd*s**2 + 684*D1*Dd*f*fd*s - 54*D1*Dd*f*fd - 1680*D1*Dd*f*g2*r*s + 420*D1*Dd*f*g2*r - 1680*D1*Dd*f*g2*s**2 + 1680*D1*Dd*f*g2*s - 420*D1*Dd*f*g2 - 1120*D1*Dd*f*gd2*r*s + 140*D1*Dd*f*gd2*r - 1680*D1*Dd*f*gd2*s**2 + 1260*D1*Dd*f*gd2*s - 140*D1*Dd*f*gd2 - 1120*D1*Dd*fd*g2*r*s + 140*D1*Dd*fd*g2*r - 1680*D1*Dd*fd*g2*s**2 + 700*D1*Dd*fd*g2*s - 216*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 252*D1*Ddd*f**2*s**2 + 234*D1*Ddd*f**2*s - 63*D1*Ddd*f**2 - 560*D1*Ddd*f*g2*r*s + 140*D1*Ddd*f*g2*r - 840*D1*Ddd*f*g2*s**2 + 700*D1*Ddd*f*g2*s - 210*D1*Ddd*f*g2 - 14*D1*bd1*(D1*f*(18*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 15*K*(2*s - 1)*(r + s - 1) - 18*r*s + 9*r - 28*s**2 + 23*s - 14) + D1*fd*(6*C*(r*(4*s - 1) + (1 - 2*s)**2) - 30*K*s**2 + 20*K*s - r*(5*K + 3)*(4*s - 1) - 12*s**2 + 12*s - 3) - 10*D1*(7*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + gd2*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd*f*(6*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 5*K*(8*r*s - 3*r + 12*s**2 - 13*s + 3) - 24*r*s + 9*r - 24*s**2 + 24*s - 6) - 20*Dd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 648*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 756*Dd**2*f**2*s**2 + 702*Dd**2*f**2*s - 108*Dd**2*f**2 - 1680*Dd**2*f*g2*r*s + 420*Dd**2*f*g2*r - 2520*Dd**2*f*g2*s**2 + 2100*Dd**2*f*g2*s - 280*Dd**2*f*g2))/(105*d**2*k3**4) + D1**2*Pk3*Pkd2*ct*k1*st**6*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 18*fd*(2*s**2 - 2*s + 1) - 9*fdd*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) - f*(2*fd*(s**2*(21*bd1 - 3) + s*(2 - 7*bd1) - 1) + fdd*(3*s**2 - 2*s + 1) + s**2*(-18*bd1 + 9*bdd1)) + 2*fd*s*(bd1*(9 - 18*s) + fd*(2 - 3*s))) - D1*f*(2*Dd*(f*(s**2*(28*bd1 - 4) + s*(2 - 7*bd1) - 1) + (4*s - 1)*(9*bd1*s + fd*(3*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k3**2) + D1**2*Pk3*Pkd2*ct*k1*st**4*(24*C*D1**2*bdd1*f**2*r*s - 60*C*D1**2*bdd1*f**2*s**2 - 600*C*D1**2*f**2*fd*s**2 + 400*C*D1**2*f**2*fd*s - 200*C*D1**2*f**2*fd + 300*C*D1**2*f**2*fdd*s**2 - 200*C*D1**2*f**2*fdd*s + 100*C*D1**2*f**2*fdd + 600*C*D1**2*f*fd**2*s**2 - 400*C*D1**2*f*fd**2*s - 800*C*D1*Dd*f**3*s**2 + 400*C*D1*Dd*f**3*s - 200*C*D1*Dd*f**3 + 2400*C*D1*Dd*f**2*fd*s**2 - 1400*C*D1*Dd*f**2*fd*s + 200*C*D1*Dd*f**2*fd + 400*C*D1*Ddd*f**3*s**2 - 200*C*D1*Ddd*f**3*s + 100*C*D1*Ddd*f**3 + 1200*C*Dd**2*f**3*s**2 - 600*C*Dd**2*f**3*s + 150*D1**2*K*bdd1*f**2*s**2 - 600*D1**2*b2*f*fd*s**2 + 600*D1**2*b2*f*fd*s - 300*D1**2*b2*f*fd + 300*D1**2*b2*f*fdd*s**2 - 300*D1**2*b2*f*fdd*s + 150*D1**2*b2*f*fdd + 300*D1**2*b2*fd**2*s**2 - 300*D1**2*b2*fd**2*s + 6*D1**2*bd1**2*f*s*(14*K*(2*r - 5*s - 1) + 25*f - 28*r + 49) - 300*D1**2*bd2*f**2*s**2 + 600*D1**2*bd2*f*fd*s**2 - 300*D1**2*bd2*f*fd*s + 180*D1**2*bdd1*f**3*r*s + 165*D1**2*bdd1*f**3*s**2 - 120*D1**2*bdd1*f**3*s + 120*D1**2*bdd1*f**2*r*s + 249*D1**2*bdd1*f**2*s**2 - 114*D1**2*bdd1*f**2*s - 15*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r*s + 420*D1**2*bdd1*f*g2*s**2 + 150*D1**2*bdd2*f**2*s**2 - 180*D1**2*f**2*fd*r*s + 60*D1**2*f**2*fd*r + 114*D1**2*f**2*fd*s**2 - 16*D1**2*f**2*fd*s + 38*D1**2*f**2*fd + 144*D1**2*f**2*fdd*r*s - 48*D1**2*f**2*fdd*r - 39*D1**2*f**2*fdd*s**2 - 22*D1**2*f**2*fdd*s - 13*D1**2*f**2*fdd + 600*D1**2*f**2*gd2*s**2 - 300*D1**2*f**2*gdd2*s**2 + 288*D1**2*f*fd**2*r*s - 96*D1**2*f*fd**2*r - 78*D1**2*f*fd**2*s**2 - 44*D1**2*f*fd**2*s + 48*D1**2*f*fd**2 + 1200*D1**2*f*fd*g2*s**2 - 1200*D1**2*f*fd*g2*s + 600*D1**2*f*fd*g2 - 1200*D1**2*f*fd*gd2*s**2 + 600*D1**2*f*fd*gd2*s - 600*D1**2*f*fdd*g2*s**2 + 600*D1**2*f*fdd*g2*s - 300*D1**2*f*fdd*g2 - 600*D1**2*fd**2*g2*s**2 + 600*D1**2*fd**2*g2*s - 1200*D1*Dd*b2*f**2*s**2 + 600*D1*Dd*b2*f**2*s - 300*D1*Dd*b2*f**2 + 2400*D1*Dd*b2*f*fd*s**2 - 1800*D1*Dd*b2*f*fd*s + 300*D1*Dd*b2*f*fd + 1200*D1*Dd*bd2*f**2*s**2 - 300*D1*Dd*bd2*f**2*s - 240*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r + 152*D1*Dd*f**3*s**2 + 44*D1*Dd*f**3*s + 38*D1*Dd*f**3 + 1152*D1*Dd*f**2*fd*r*s - 336*D1*Dd*f**2*fd*r - 312*D1*Dd*f**2*fd*s**2 - 298*D1*Dd*f**2*fd*s + 118*D1*Dd*f**2*fd + 2400*D1*Dd*f**2*g2*s**2 - 1200*D1*Dd*f**2*g2*s + 600*D1*Dd*f**2*g2 - 2400*D1*Dd*f**2*gd2*s**2 + 600*D1*Dd*f**2*gd2*s - 4800*D1*Dd*f*fd*g2*s**2 + 3600*D1*Dd*f*fd*g2*s - 600*D1*Dd*f*fd*g2 + 600*D1*Ddd*b2*f**2*s**2 - 300*D1*Ddd*b2*f**2*s + 150*D1*Ddd*b2*f**2 + 192*D1*Ddd*f**3*r*s - 48*D1*Ddd*f**3*r - 52*D1*Ddd*f**3*s**2 - 70*D1*Ddd*f**3*s - 13*D1*Ddd*f**3 - 1200*D1*Ddd*f**2*g2*s**2 + 600*D1*Ddd*f**2*g2*s - 300*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(5*f**3*s*(6*r + 9*s - 4) + f**2*(-5*fd*(6*r*(6*s - 1) + 33*s**2 - 31*s + 4) + s**2*(-20*C + 50*K + 69) + s*(8*C*r + 26*r - 24) - 5) - 2*f*(fd*(r*(2*C + 10)*(4*s - 1) + s**2*(-20*C + 50*K + 83) + s*(8*C - 25*K - 61) + 12) + 14*s*(2*g2*r - 5*g2*s - 2*gd2*r + 5*gd2*s + gd2)) - 28*fd*g2*(-2*r*s + r + s*(5*s - 5))) - Dd*f*(5*f**2*(6*r*(8*s - 1) + 44*s**2 - 39*s + 4) + f*(r*(4*C + 20)*(8*s - 1) + s**2*(-80*C + 200*K + 332) + s*(12*C - 50*K - 199) + 19) + 28*g2*(-8*r*s + r + s*(20*s - 3)))) + 1800*Dd**2*b2*f**2*s**2 - 900*Dd**2*b2*f**2*s + 576*Dd**2*f**3*r*s - 144*Dd**2*f**3*r - 156*Dd**2*f**3*s**2 - 210*Dd**2*f**3*s + 96*Dd**2*f**3 - 3600*Dd**2*f**2*g2*s**2 + 1800*Dd**2*f**2*g2*s + 3*b1**2*(-2*D1*Dd*(14*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s) + fd*(-14*K*(8*r*s - 5*r - 20*s**2 + 23*s - 3) + 25*f*(4*s - 1) + 112*r*s - 70*r + 112*s - 7)) + D1*(D1*(50*f*fd*(2*s - 1) + f*fdd*(25 - 50*s) - 50*fd**2*s - 14*fd*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + 7*fdd*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5)) + 14*Ddd*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s)) + 28*Dd**2*f*(K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) - 12*r*s + 3*r + 6*s - 2)) - 3*b1*(32*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 64*C*D1**2*f*fd*s - 40*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 32*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 32*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 + 64*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 - 128*C*D1*Dd*f*fd*r*s + 48*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 176*C*D1*Dd*f*fd*s + 16*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r*s + 8*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 24*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r*s + 24*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 72*C*Dd**2*f**2*s - 16*C*Dd**2*f**2 + 200*D1**2*K*f*fd*s**2 - 200*D1**2*K*f*fd*s + 100*D1**2*K*f*fd - 100*D1**2*K*f*fdd*s**2 + 100*D1**2*K*f*fdd*s - 50*D1**2*K*f*fdd - 100*D1**2*K*fd**2*s**2 + 100*D1**2*K*fd**2*s + D1**2*bdd1*f*(140*K*s**2 + f*(25 - 50*s) + 7*s*(-8*K*r + 4*K + 8*r - 14) + 35) + 180*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 270*D1**2*f**2*fd*s**2 - 260*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 165*D1**2*f**2*fdd*s**2 + 190*D1**2*f**2*fdd*s - 55*D1**2*f**2*fdd - 360*D1**2*f*fd**2*r*s + 120*D1**2*f*fd**2*r - 330*D1**2*f*fd**2*s**2 + 380*D1**2*f*fd**2*s - 80*D1**2*f*fd**2 + 104*D1**2*f*fd*r*s - 52*D1**2*f*fd*r + 276*D1**2*f*fd*s**2 - 280*D1**2*f*fd*s + 148*D1**2*f*fd - 80*D1**2*f*fdd*r*s + 40*D1**2*f*fdd*r - 166*D1**2*f*fdd*s**2 + 168*D1**2*f*fdd*s - 88*D1**2*f*fdd - 112*D1**2*f*gd2*r*s + 280*D1**2*f*gd2*s**2 + 112*D1**2*f*gd2*s + 56*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*s**2 - 56*D1**2*f*gdd2*s - 80*D1**2*fd**2*r*s + 40*D1**2*fd**2*r - 166*D1**2*fd**2*s**2 + 168*D1**2*fd**2*s + 8*D1**2*fd**2 - 112*D1**2*fd*g2*r*s + 112*D1**2*fd*g2*r + 280*D1**2*fd*g2*s**2 - 560*D1**2*fd*g2*s + 280*D1**2*fd*g2 + 112*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*r - 280*D1**2*fd*gd2*s**2 + 224*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 + 56*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r - 140*D1**2*fdd*g2*s**2 + 280*D1**2*fdd*g2*s - 140*D1**2*fdd*g2 + 400*D1*Dd*K*f**2*s**2 - 200*D1*Dd*K*f**2*s + 100*D1*Dd*K*f**2 - 800*D1*Dd*K*f*fd*s**2 + 600*D1*Dd*K*f*fd*s - 100*D1*Dd*K*f*fd + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 360*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r*s + 420*D1*Dd*f**2*fd*r - 1320*D1*Dd*f**2*fd*s**2 + 1450*D1*Dd*f**2*fd*s - 310*D1*Dd*f**2*fd + 208*D1*Dd*f**2*r*s - 52*D1*Dd*f**2*r + 552*D1*Dd*f**2*s**2 - 380*D1*Dd*f**2*s + 138*D1*Dd*f**2 - 640*D1*Dd*f*fd*r*s + 240*D1*Dd*f*fd*r - 1328*D1*Dd*f*fd*s**2 + 1164*D1*Dd*f*fd*s - 248*D1*Dd*f*fd - 448*D1*Dd*f*g2*r*s + 112*D1*Dd*f*g2*r + 1120*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 280*D1*Dd*f*g2 + 448*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r - 1120*D1*Dd*f*gd2*s**2 - 56*D1*Dd*f*gd2*s + 56*D1*Dd*f*gd2 + 448*D1*Dd*fd*g2*r*s - 280*D1*Dd*fd*g2*r - 1120*D1*Dd*fd*g2*s**2 + 1288*D1*Dd*fd*g2*s - 168*D1*Dd*fd*g2 - 200*D1*Ddd*K*f**2*s**2 + 100*D1*Ddd*K*f**2*s - 50*D1*Ddd*K*f**2 - 240*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 220*D1*Ddd*f**3*s**2 + 230*D1*Ddd*f**3*s - 55*D1*Ddd*f**3 - 160*D1*Ddd*f**2*r*s + 40*D1*Ddd*f**2*r - 332*D1*Ddd*f**2*s**2 + 246*D1*Ddd*f**2*s - 83*D1*Ddd*f**2 + 224*D1*Ddd*f*g2*r*s - 56*D1*Ddd*f*g2*r - 560*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 140*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(25*f**2*(2*s - 1) - 7*f*(20*K*s**2 + s*(-8*K*r + 4*K + 8*r - 14) + 5) - 7*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) - 8*r*s + 4*r - 3*s - 2)) + Dd*f*(-7*K*(32*r*s - 4*r - 80*s**2 + 4*s + 2) - 25*f*(4*s - 1) + 224*r*s - 28*r - 252*s + 49)) - 600*Dd**2*K*f**2*s**2 + 300*Dd**2*K*f**2*s - 720*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 660*Dd**2*f**3*s**2 + 690*Dd**2*f**3*s - 120*Dd**2*f**3 - 480*Dd**2*f**2*r*s + 120*Dd**2*f**2*r - 996*Dd**2*f**2*s**2 + 738*Dd**2*f**2*s - 80*Dd**2*f**2 + 672*Dd**2*f*g2*r*s - 168*Dd**2*f*g2*r - 1680*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s + 112*Dd**2*f*g2))/(210*d**2*k3**2) + D1**2*Pk3*Pkd2*ct*k1*st**2*(112*C*D1**2*bd1**2*f*r*s - 56*C*D1**2*bd1**2*f*r - 56*C*D1**2*bd1**2*f*s**2 + 56*C*D1**2*bd1**2*f*s + 56*C*D1**2*bd1*f**2*r*s - 384*C*D1**2*bd1*f**2*s**2 + 144*C*D1**2*bd1*f**2*s - 72*C*D1**2*bd1*f**2 + 992*C*D1**2*bd1*f*fd*s**2 - 568*C*D1**2*bd1*f*fd*s + 248*C*D1**2*bdd1*f**2*s**2 - 72*C*D1**2*bdd1*f**2*s + 36*C*D1**2*bdd1*f**2 + 264*C*D1**2*f**2*fd*r*s - 88*C*D1**2*f**2*fd*r + 1080*C*D1**2*f**2*fd*s**2 - 808*C*D1**2*f**2*fd*s + 360*C*D1**2*f**2*fd - 312*C*D1**2*f**2*fdd*r*s + 104*C*D1**2*f**2*fdd*r - 756*C*D1**2*f**2*fdd*s**2 + 608*C*D1**2*f**2*fdd*s - 252*C*D1**2*f**2*fdd - 624*C*D1**2*f*fd**2*r*s + 208*C*D1**2*f*fd**2*r - 1512*C*D1**2*f*fd**2*s**2 + 1216*C*D1**2*f*fd**2*s - 104*C*D1**2*f*fd**2 + 1984*C*D1*Dd*bd1*f**2*s**2 - 784*C*D1*Dd*bd1*f**2*s + 72*C*D1*Dd*bd1*f**2 + 352*C*D1*Dd*f**3*r*s - 88*C*D1*Dd*f**3*r + 1440*C*D1*Dd*f**3*s**2 - 896*C*D1*Dd*f**3*s + 360*C*D1*Dd*f**3 - 2496*C*D1*Dd*f**2*fd*r*s + 728*C*D1*Dd*f**2*fd*r - 6048*C*D1*Dd*f**2*fd*s**2 + 4568*C*D1*Dd*f**2*fd*s - 816*C*D1*Dd*f**2*fd - 416*C*D1*Ddd*f**3*r*s + 104*C*D1*Ddd*f**3*r - 1008*C*D1*Ddd*f**3*s**2 + 712*C*D1*Ddd*f**3*s - 252*C*D1*Ddd*f**3 - 1248*C*Dd**2*f**3*r*s + 312*C*Dd**2*f**3*r - 3024*C*Dd**2*f**3*s**2 + 2136*C*Dd**2*f**3*s - 208*C*Dd**2*f**3 + 952*D1**2*K*bd1**2*f*s**2 - 84*D1**2*K*bd1**2*f*s + 84*D1**2*K*bd1*f**2*r*s + 420*D1**2*K*bd1*f**2*s**2 - 84*D1**2*K*bd1*f**2*s - 336*D1**2*K*bd1*f*fd*r*s + 84*D1**2*K*bd1*f*fd*r - 1176*D1**2*K*bd1*f*fd*s**2 + 756*D1**2*K*bd1*f*fd*s - 84*D1**2*K*bd1*f*fd - 84*D1**2*K*bdd1*f**2*r*s - 294*D1**2*K*bdd1*f**2*s**2 + 84*D1**2*K*bdd1*f**2*s + 336*D1**2*bd1**2*f**2*r*s - 252*D1**2*bd1**2*f**2*r - 378*D1**2*bd1**2*f**2*s + 168*D1**2*bd1**2*f**2 + 336*D1**2*bd1**2*f*r*s - 168*D1**2*bd1**2*f*r + 42*D1**2*bd1**2*f*s**2 - 700*D1**2*bd1**2*f*s + 224*D1**2*bd1**2*f - 560*D1**2*bd1**2*g2*r*s + 280*D1**2*bd1**2*g2*r + 280*D1**2*bd1**2*g2*s**2 - 280*D1**2*bd1**2*g2*s + 84*D1**2*bd1*bd2*f*s**2 - 84*D1**2*bd1*bd2*f*s - 80*D1**2*bd1*f**2*r*s + 108*D1**2*bd1*f**2*r + 192*D1**2*bd1*f**2*s**2 - 42*D1**2*bd1*f**2 + 384*D1**2*bd1*f*fd*r*s - 192*D1**2*bd1*f*fd*r - 496*D1**2*bd1*f*fd*s**2 + 82*D1**2*bd1*f*fd*s + 96*D1**2*bd1*f*fd - 280*D1**2*bd1*f*g2*r*s + 1344*D1**2*bd1*f*g2*s**2 - 336*D1**2*bd1*f*g2*s + 168*D1**2*bd1*f*g2 - 1904*D1**2*bd1*f*gd2*s**2 + 168*D1**2*bd1*f*gd2*s - 1904*D1**2*bd1*fd*g2*s**2 + 1904*D1**2*bd1*fd*g2*s + 84*D1**2*bd2*f**2*r*s + 420*D1**2*bd2*f**2*s**2 - 84*D1**2*bd2*f**2*s - 336*D1**2*bd2*f*fd*r*s + 84*D1**2*bd2*f*fd*r - 1176*D1**2*bd2*f*fd*s**2 + 756*D1**2*bd2*f*fd*s - 84*D1**2*bd2*f*fd + 96*D1**2*bdd1*f**2*r*s - 96*D1**2*bdd1*f**2*r - 124*D1**2*bdd1*f**2*s**2 - 70*D1**2*bdd1*f**2*s + 35*D1**2*bdd1*f**2 - 952*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 - 84*D1**2*bdd2*f**2*r*s - 294*D1**2*bdd2*f**2*s**2 + 84*D1**2*bdd2*f**2*s - 24*D1**2*f**2*fd*r*s + 8*D1**2*f**2*fd*r - 540*D1**2*f**2*fd*s**2 + 368*D1**2*f**2*fd*s - 180*D1**2*f**2*fd + 156*D1**2*f**2*fdd*r*s - 52*D1**2*f**2*fdd*r + 378*D1**2*f**2*fdd*s**2 - 304*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd - 168*D1**2*f**2*gd2*r*s - 840*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s + 168*D1**2*f**2*gdd2*r*s + 588*D1**2*f**2*gdd2*s**2 - 168*D1**2*f**2*gdd2*s + 312*D1**2*f*fd**2*r*s - 104*D1**2*f*fd**2*r + 756*D1**2*f*fd**2*s**2 - 608*D1**2*f*fd**2*s + 52*D1**2*f*fd**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r - 1680*D1**2*f*fd*g2*s**2 + 1680*D1**2*f*fd*g2*s - 840*D1**2*f*fd*g2 + 672*D1**2*f*fd*gd2*r*s - 168*D1**2*f*fd*gd2*r + 2352*D1**2*f*fd*gd2*s**2 - 1512*D1**2*f*fd*gd2*s + 168*D1**2*f*fd*gd2 + 336*D1**2*f*fdd*g2*r*s - 168*D1**2*f*fdd*g2*r + 1176*D1**2*f*fdd*g2*s**2 - 1176*D1**2*f*fdd*g2*s + 588*D1**2*f*fdd*g2 + 336*D1**2*fd**2*g2*r*s - 168*D1**2*fd**2*g2*r + 1176*D1**2*fd**2*g2*s**2 - 1176*D1**2*fd**2*g2*s - 672*D1*Dd*K*bd1*f**2*r*s + 84*D1*Dd*K*bd1*f**2*r - 2352*D1*Dd*K*bd1*f**2*s**2 + 1092*D1*Dd*K*bd1*f**2*s - 84*D1*Dd*K*bd1*f**2 + 768*D1*Dd*bd1*f**2*r*s - 480*D1*Dd*bd1*f**2*r - 992*D1*Dd*bd1*f**2*s**2 - 224*D1*Dd*bd1*f**2*s + 262*D1*Dd*bd1*f**2 - 7616*D1*Dd*bd1*f*g2*s**2 + 2576*D1*Dd*bd1*f*g2*s - 168*D1*Dd*bd1*f*g2 - 672*D1*Dd*bd2*f**2*r*s + 84*D1*Dd*bd2*f**2*r - 2352*D1*Dd*bd2*f**2*s**2 + 1092*D1*Dd*bd2*f**2*s - 84*D1*Dd*bd2*f**2 - 32*D1*Dd*f**3*r*s + 8*D1*Dd*f**3*r - 720*D1*Dd*f**3*s**2 + 376*D1*Dd*f**3*s - 180*D1*Dd*f**3 + 1248*D1*Dd*f**2*fd*r*s - 364*D1*Dd*f**2*fd*r + 3024*D1*Dd*f**2*fd*s**2 - 2284*D1*Dd*f**2*fd*s + 408*D1*Dd*f**2*fd - 672*D1*Dd*f**2*g2*r*s + 168*D1*Dd*f**2*g2*r - 3360*D1*Dd*f**2*g2*s**2 + 2016*D1*Dd*f**2*g2*s - 840*D1*Dd*f**2*g2 + 1344*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 4704*D1*Dd*f**2*gd2*s**2 - 2184*D1*Dd*f**2*gd2*s + 168*D1*Dd*f**2*gd2 + 2688*D1*Dd*f*fd*g2*r*s - 1008*D1*Dd*f*fd*g2*r + 9408*D1*Dd*f*fd*g2*s**2 - 7728*D1*Dd*f*fd*g2*s + 1512*D1*Dd*f*fd*g2 + 208*D1*Ddd*f**3*r*s - 52*D1*Ddd*f**3*r + 504*D1*Ddd*f**3*s**2 - 356*D1*Ddd*f**3*s + 126*D1*Ddd*f**3 + 672*D1*Ddd*f**2*g2*r*s - 168*D1*Ddd*f**2*g2*r + 2352*D1*Ddd*f**2*g2*s**2 - 1512*D1*Ddd*f**2*g2*s + 588*D1*Ddd*f**2*g2 + 624*Dd**2*f**3*r*s - 156*Dd**2*f**3*r + 1512*Dd**2*f**3*s**2 - 1068*Dd**2*f**3*s + 104*Dd**2*f**3 + 2016*Dd**2*f**2*g2*r*s - 504*Dd**2*f**2*g2*r + 7056*Dd**2*f**2*g2*s**2 - 4536*Dd**2*f**2*g2*s + 336*Dd**2*f**2*g2 - 7*b1**3*(3*D1**2*s**2*(2*fd - fdd) + D1*(2*Dd*(-10*K*(r*(2 - 8*s) + 4*s**2 + 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s - 80*r*s + 20*r + 20*s**2 + 30*s + 5) + Ddd*(10*K*(r*(2 - 8*s) + 4*s**2 + 2*s + 1) - 3*f*(4*s**2 - 2*s + 1) + 80*r*s - 20*r - 20*s**2 - 30*s - 5)) + 2*Dd**2*(10*K*(r*(3 - 12*s) + 6*s**2 + 3*s - 2) - 18*f*s**2 + 9*f*s + 30*r*(4*s - 1) - 30*s**2 - 45*s + 20)) - 7*b1**2*(16*C*D1**2*fd*r*s - 8*C*D1**2*fd*s**2 - 16*C*D1**2*fd*s - 8*C*D1**2*fdd*r*s + 4*C*D1**2*fdd*s**2 + 8*C*D1**2*fdd*s + 64*C*D1*Dd*f*r*s - 16*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 - 16*C*D1*Dd*f*s - 8*C*D1*Dd*f - 64*C*D1*Dd*fd*r*s + 8*C*D1*Dd*fd*r + 32*C*D1*Dd*fd*s**2 + 40*C*D1*Dd*fd*s - 8*C*D1*Dd*fd - 32*C*D1*Ddd*f*r*s + 8*C*D1*Ddd*f*r + 16*C*D1*Ddd*f*s**2 + 8*C*D1*Ddd*f*s + 4*C*D1*Ddd*f - 96*C*Dd**2*f*r*s + 24*C*Dd**2*f*r + 48*C*Dd**2*f*s**2 + 24*C*Dd**2*f*s - 16*C*Dd**2*f - 20*D1**2*K*fd*r*s + 20*D1**2*K*fd*r + 96*D1**2*K*fd*s**2 - 168*D1**2*K*fd*s + 84*D1**2*K*fd - 68*D1**2*K*fdd*s**2 + 124*D1**2*K*fdd*s - 62*D1**2*K*fdd - D1**2*bdd1*(-10*K*(r*(2 - 6*s) + 3*s**2 + 1) + f*(9*s**2 - 6*s + 3) - 60*r*s + 20*r + 15*s**2 + 10*s + 5) + 48*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 24*D1**2*f*fd*s - 30*D1**2*f*fd - 48*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r - 6*D1**2*f*fdd*s + 21*D1**2*f*fdd - 48*D1**2*fd**2*r*s - 12*D1**2*fd**2*r - 6*D1**2*fd**2*s + 12*D1**2*fd**2 + 48*D1**2*fd*r*s - 20*D1**2*fd*r + 6*D1**2*fd*s**2 + 100*D1**2*fd*s - 42*D1**2*fd - 24*D1**2*fdd*r*s - 3*D1**2*fdd*s**2 - 70*D1**2*fdd*s + 31*D1**2*fdd - 80*D1**2*gd2*r*s + 40*D1**2*gd2*s**2 + 80*D1**2*gd2*s + 40*D1**2*gdd2*r*s - 20*D1**2*gdd2*s**2 - 40*D1**2*gdd2*s - 80*D1*Dd*K*f*r*s + 20*D1*Dd*K*f*r + 384*D1*Dd*K*f*s**2 - 152*D1*Dd*K*f*s + 96*D1*Dd*K*f - 544*D1*Dd*K*fd*s**2 + 632*D1*Dd*K*fd*s - 124*D1*Dd*K*fd + 96*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r - 48*D1*Dd*f**2*s - 384*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*s + 30*D1*Dd*f*fd + 192*D1*Dd*f*r*s - 48*D1*Dd*f*r + 24*D1*Dd*f*s**2 - 108*D1*Dd*f*s + 6*D1*Dd*f - 192*D1*Dd*fd*r*s + 24*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 - 226*D1*Dd*fd*s + 70*D1*Dd*fd - 320*D1*Dd*g2*r*s + 80*D1*Dd*g2*r + 160*D1*Dd*g2*s**2 + 80*D1*Dd*g2*s + 40*D1*Dd*g2 + 320*D1*Dd*gd2*r*s - 40*D1*Dd*gd2*r - 160*D1*Dd*gd2*s**2 - 200*D1*Dd*gd2*s + 40*D1*Dd*gd2 - 272*D1*Ddd*K*f*s**2 + 136*D1*Ddd*K*f*s - 68*D1*Ddd*K*f - 96*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r + 48*D1*Ddd*f**2*s - 96*D1*Ddd*f*r*s + 24*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 54*D1*Ddd*f*s - 3*D1*Ddd*f + 160*D1*Ddd*g2*r*s - 40*D1*Ddd*g2*r - 80*D1*Ddd*g2*s**2 - 40*D1*Ddd*g2*s - 20*D1*Ddd*g2 + 2*D1*bd1*(D1*(-10*K*(r*(2 - 6*s) + 3*s**2 + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s - 60*r*s + 20*r + 15*s**2 + 10*s + 5) + Dd*(-10*K*(24*r*s - 7*r - 12*s**2 - 3*s + 2) - 3*f*(12*s**2 - 7*s + 1) + 240*r*s - 70*r - 60*s**2 - 65*s + 25)) - 816*Dd**2*K*f*s**2 + 408*Dd**2*K*f*s - 288*Dd**2*f**2*r*s + 72*Dd**2*f**2*r + 144*Dd**2*f**2*s - 48*Dd**2*f**2 - 288*Dd**2*f*r*s + 72*Dd**2*f*r - 36*Dd**2*f*s**2 + 162*Dd**2*f*s - 48*Dd**2*f + 480*Dd**2*g2*r*s - 120*Dd**2*g2*r - 240*Dd**2*g2*s**2 - 120*Dd**2*g2*s + 80*Dd**2*g2) + b1*(112*C*D1**2*f*fd*r*s - 56*C*D1**2*f*fd*r - 768*C*D1**2*f*fd*s**2 + 568*C*D1**2*f*fd*s - 312*C*D1**2*f*fd + 496*C*D1**2*f*fdd*s**2 - 424*C*D1**2*f*fdd*s + 212*C*D1**2*f*fdd + 496*C*D1**2*fd**2*s**2 - 424*C*D1**2*fd**2*s + 224*C*D1*Dd*f**2*r*s - 56*C*D1*Dd*f**2*r - 1536*C*D1*Dd*f**2*s**2 + 656*C*D1*Dd*f**2*s - 384*C*D1*Dd*f**2 + 3968*C*D1*Dd*f*fd*s**2 - 2688*C*D1*Dd*f*fd*s + 424*C*D1*Dd*f*fd + 992*C*D1*Ddd*f**2*s**2 - 496*C*D1*Ddd*f**2*s + 248*C*D1*Ddd*f**2 + 2976*C*Dd**2*f**2*s**2 - 1488*C*Dd**2*f**2*s + 168*D1**2*K*f*fd*r*s - 84*D1**2*K*f*fd*r + 840*D1**2*K*f*fd*s**2 - 840*D1**2*K*f*fd*s + 420*D1**2*K*f*fd - 168*D1**2*K*f*fdd*r*s + 84*D1**2*K*f*fdd*r - 588*D1**2*K*f*fdd*s**2 + 588*D1**2*K*f*fdd*s - 294*D1**2*K*f*fdd - 168*D1**2*K*fd**2*r*s + 84*D1**2*K*fd**2*r - 588*D1**2*K*fd**2*s**2 + 588*D1**2*K*fd**2*s - 84*D1**2*b2*fd*s**2 + 42*D1**2*b2*fdd*s**2 + 14*D1**2*bd1**2*(10*K*(r*(6*s - 2) - 3*s**2 + 1) + 9*f*s**2 - 6*f*s + r*(20 - 60*s) + 15*s**2 + 10*s - 10) - 84*D1**2*bd2*f*s**2 + 84*D1**2*bd2*fd*s**2 + 7*D1**2*bdd1*(3*f**2*(4*r*(4*s - 3) - 18*s + 7) + 2*f*(C*(r*(8*s - 4) - 4*s**2 + 4*s - 2) + K*(68*s**2 - 6*s + 3) + 24*r*s - 12*r + 3*s**2 - 50*s + 17) + 20*g2*(r*(2 - 4*s) + 2*s**2 - 2*s + 1)) + 42*D1**2*bdd2*f*s**2 - 160*D1**2*f*fd*r*s - 28*D1**2*f*fd*r + 384*D1**2*f*fd*s**2 - 304*D1**2*f*fd*s + 234*D1**2*f*fd + 192*D1**2*f*fdd*r*s - 248*D1**2*f*fdd*s**2 + 222*D1**2*f*fdd*s - 159*D1**2*f*fdd - 280*D1**2*f*gd2*r*s + 1344*D1**2*f*gd2*s**2 + 280*D1**2*f*gd2*s - 952*D1**2*f*gdd2*s**2 + 192*D1**2*fd**2*r*s - 248*D1**2*fd**2*s**2 + 222*D1**2*fd**2*s - 280*D1**2*fd*g2*r*s + 280*D1**2*fd*g2*r + 1344*D1**2*fd*g2*s**2 - 2352*D1**2*fd*g2*s + 1176*D1**2*fd*g2 - 1904*D1**2*fd*gd2*s**2 + 1736*D1**2*fd*gd2*s - 952*D1**2*fdd*g2*s**2 + 1736*D1**2*fdd*g2*s - 868*D1**2*fdd*g2 + 336*D1*Dd*K*f**2*r*s - 84*D1*Dd*K*f**2*r + 1680*D1*Dd*K*f**2*s**2 - 1008*D1*Dd*K*f**2*s + 420*D1*Dd*K*f**2 - 1344*D1*Dd*K*f*fd*r*s + 504*D1*Dd*K*f*fd*r - 4704*D1*Dd*K*f*fd*s**2 + 3864*D1*Dd*K*f*fd*s - 756*D1*Dd*K*f*fd - 336*D1*Dd*b2*f*s**2 + 168*D1*Dd*b2*f*s - 84*D1*Dd*b2*f + 336*D1*Dd*b2*fd*s**2 - 84*D1*Dd*b2*fd*s + 336*D1*Dd*bd2*f*s**2 - 84*D1*Dd*bd2*f*s - 320*D1*Dd*f**2*r*s + 80*D1*Dd*f**2*r + 768*D1*Dd*f**2*s**2 - 224*D1*Dd*f**2*s + 192*D1*Dd*f**2 + 1536*D1*Dd*f*fd*r*s - 192*D1*Dd*f*fd*r - 1984*D1*Dd*f*fd*s**2 + 1000*D1*Dd*f*fd*s - 222*D1*Dd*f*fd - 1120*D1*Dd*f*g2*r*s + 280*D1*Dd*f*g2*r + 5376*D1*Dd*f*g2*s**2 - 2128*D1*Dd*f*g2*s + 1344*D1*Dd*f*g2 - 7616*D1*Dd*f*gd2*s**2 + 1904*D1*Dd*f*gd2*s - 7616*D1*Dd*fd*g2*s**2 + 8848*D1*Dd*fd*g2*s - 1736*D1*Dd*fd*g2 - 336*D1*Ddd*K*f**2*r*s + 84*D1*Ddd*K*f**2*r - 1176*D1*Ddd*K*f**2*s**2 + 756*D1*Ddd*K*f**2*s - 294*D1*Ddd*K*f**2 + 168*D1*Ddd*b2*f*s**2 - 84*D1*Ddd*b2*f*s + 42*D1*Ddd*b2*f + 384*D1*Ddd*f**2*r*s - 96*D1*Ddd*f**2*r - 496*D1*Ddd*f**2*s**2 + 56*D1*Ddd*f**2*s - 124*D1*Ddd*f**2 - 3808*D1*Ddd*f*g2*s**2 + 1904*D1*Ddd*f*g2*s - 952*D1*Ddd*f*g2 - 14*D1*bd1*(3*D1*f**2*(r*(8*s - 6) - 12*s + 5) + 2*D1*f*(C*(r*(8*s - 4) - 4*s**2 + 4*s - 2) - 10*K*r*s + 48*K*s**2 - K*s + 3*K - 3*fd*(16*r*s - 4*r - 8*s + 3) + 24*r*s - 7*r + 3*s**2 - 40*s + 12) - 2*D1*(fd*(C*(8*r*s - 2*r - 4*s**2 - 2*s + 2) + 68*K*s**2 - 65*K*s + 24*r*s - 6*r + 3*s**2 + 10*s - 2) + 10*g2*(4*r*s - 2*r - 2*s**2 + 2*s - 1) + 10*gd2*(-4*r*s + r + 2*s**2 + s - 1)) - 3*Dd*f**2*(32*r*(2*s - 1) - 52*s + 21) - 2*Dd*f*(2*C*(2*r*(8*s - 3) - 8*s**2 + 2*s + 1) + K*(272*s**2 - 80*s + 3) + 96*r*s - 36*r + 12*s**2 - 127*s + 37) + 20*Dd*g2*(2*r*(8*s - 3) - 8*s**2 + 2*s + 1)) - 1008*Dd**2*K*f**2*r*s + 252*Dd**2*K*f**2*r - 3528*Dd**2*K*f**2*s**2 + 2268*Dd**2*K*f**2*s - 168*Dd**2*K*f**2 + 504*Dd**2*b2*f*s**2 - 252*Dd**2*b2*f*s + 1152*Dd**2*f**2*r*s - 288*Dd**2*f**2*r - 1488*Dd**2*f**2*s**2 + 168*Dd**2*f**2*s + 192*Dd**2*f**2 - 11424*Dd**2*f*g2*s**2 + 5712*Dd**2*f*g2*s) - 42*b2*(-D1**2*bdd1*f*(s - 1)**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 20*D1**2*f*fd*s - 10*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r + 14*D1**2*f*fdd*s**2 - 14*D1**2*f*fdd*s + 7*D1**2*f*fdd + 4*D1**2*fd**2*r*s - 2*D1**2*fd**2*r + 14*D1**2*fd**2*s**2 - 14*D1**2*fd**2*s - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 112*D1*Dd*f*fd*s**2 - 92*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 28*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 84*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 4*Dd**2*f**2))/(210*d**2*k3**2) + D1**2*Pk3*Pkd2*ct*k1*(2*D1*(-7*D1*bd1**2*(10*K*f*(r*(2*s - 1) + 3*s**2 - 4*s + 1) + f*s*(33 - 44*C)*(s - 1) + 100*g2*s*(s - 1)) - D1*bdd1*f*(s - 1)*(f*(18*C - 9)*(6*r + 7*s - 7) - 70*g2*(2*r + 3*s - 3)) + 35*b2*(-D1*bdd1*f*(s - 1)*(2*r + 3*s - 3) + 2*bd1*(D1*(f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(3*s - 3))) + Dd*f*(r*(5 - 8*s) - 12*s**2 + 17*s - 5))) - 2*bd1*(35*D1*bd2*f*(r*(2*s - 1) + 3*s**2 - 4*s + 1) + D1*(-3*f**2*(s - 1)*(2*C*(11*r + 7*s - 7) - 4*r - 7*s + 7) + f*(fd*(18*C - 9)*(6*r*(2*s - 1) + 14*s**2 - 17*s + 3) + 70*g2*(s - 1)*(r + s - 1) + 70*gd2*(-2*r*s + r - 3*s**2 + 4*s - 1)) - 70*fd*g2*(r*(2*s - 1) + s*(3*s - 3))) + Dd*f*(f*(18*C - 9)*(3*r*(8*s - 5) + 28*s**2 - 41*s + 13) - 70*g2*(r*(8*s - 5) + 12*s**2 - 17*s + 5)))) + 35*b1**3*(D1**2*s*(2*fd*(2*r + s - 2) + fdd*(-4*r - 3*s + 4)) + D1*(2*Dd*(24*K*r*s - 6*K*r + 8*K*s**2 - 16*K*s + 2*K + f*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + fd*(-16*r*s + 2*r - 12*s**2 + 15*s - 2) - 24*r*s + 6*r - 4*s**2 + 14*s - 1) + Ddd*(f*(r*(4 - 16*s) - 12*s**2 + 14*s - 3) + (10*K - 5)*(4*s**2 - 2*s + 1))) - 2*Dd**2*(f*(6*r*(4*s - 1) + 18*s**2 - 21*s + 4) + s*(15 - 30*K)*(2*s - 1))) + 7*b1**2*(40*C*D1**2*fd*r*s - 8*C*D1**2*fd*s**2 - 40*C*D1**2*fd*s + 44*C*D1**2*fdd*s**2 + 160*C*D1*Dd*f*r*s - 40*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 - 64*C*D1*Dd*f*s - 8*C*D1*Dd*f + 352*C*D1*Dd*fd*s**2 - 88*C*D1*Dd*fd*s + 176*C*D1*Ddd*f*s**2 - 88*C*D1*Ddd*f*s + 44*C*D1*Ddd*f + 528*C*Dd**2*f*s**2 - 264*C*Dd**2*f*s + 20*D1**2*K*fd*r*s + 20*D1**2*K*fd*s**2 - 20*D1**2*K*fdd*r*s - 30*D1**2*K*fdd*s**2 - 5*D1**2*bdd1*(f*(4*r*(3*s - 1) + 9*s**2 - 10*s + 3) + (5 - 10*K)*(3*s**2 - 2*s + 1)) - 20*D1**2*fd*r*s + 6*D1**2*fd*s**2 + 40*D1**2*fd*s - 33*D1**2*fdd*s**2 - 120*D1**2*gd2*r*s - 40*D1**2*gd2*s**2 + 120*D1**2*gd2*s - 100*D1**2*gdd2*s**2 + 80*D1*Dd*K*f*r*s - 20*D1*Dd*K*f*r + 80*D1*Dd*K*f*s**2 - 80*D1*Dd*K*f*s + 20*D1*Dd*K*f - 160*D1*Dd*K*fd*r*s + 20*D1*Dd*K*fd*r - 240*D1*Dd*K*fd*s**2 + 100*D1*Dd*K*fd*s - 80*D1*Dd*f*r*s + 20*D1*Dd*f*r + 24*D1*Dd*f*s**2 + 28*D1*Dd*f*s + 6*D1*Dd*f - 264*D1*Dd*fd*s**2 + 66*D1*Dd*fd*s - 480*D1*Dd*g2*r*s + 120*D1*Dd*g2*r - 160*D1*Dd*g2*s**2 + 320*D1*Dd*g2*s - 40*D1*Dd*g2 - 800*D1*Dd*gd2*s**2 + 200*D1*Dd*gd2*s - 80*D1*Ddd*K*f*r*s + 20*D1*Ddd*K*f*r - 120*D1*Ddd*K*f*s**2 + 100*D1*Ddd*K*f*s - 30*D1*Ddd*K*f - 132*D1*Ddd*f*s**2 + 66*D1*Ddd*f*s - 33*D1*Ddd*f - 400*D1*Ddd*g2*s**2 + 200*D1*Ddd*g2*s - 100*D1*Ddd*g2 + 10*D1*bd1*(D1*(18*K*r*s - 6*K*r + 6*K*s**2 - 10*K*s + 2*K + f*(3*s - 1)*(2*r + s - 1) + fd*(-12*r*s + 2*r - 9*s**2 + 11*s - 2) - 18*r*s + 6*r - 3*s**2 + 8*s - 1) + Dd*(f*(r*(14 - 48*s) - 36*s**2 + 41*s - 9) + (10*K - 5)*(12*s**2 - 7*s + 1))) - 240*Dd**2*K*f*r*s + 60*Dd**2*K*f*r - 360*Dd**2*K*f*s**2 + 300*Dd**2*K*f*s - 40*Dd**2*K*f - 396*Dd**2*f*s**2 + 198*Dd**2*f*s - 1200*Dd**2*g2*s**2 + 600*Dd**2*g2*s) + b1*(528*C*D1**2*f*fd*r*s + 336*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s - 432*C*D1**2*f*fdd*r*s - 504*C*D1**2*f*fdd*s**2 + 216*C*D1**2*f*fdd*s - 432*C*D1**2*fd**2*r*s - 504*C*D1**2*fd**2*s**2 + 216*C*D1**2*fd**2*s + 1056*C*D1*Dd*f**2*r*s - 264*C*D1*Dd*f**2*r + 672*C*D1*Dd*f**2*s**2 - 864*C*D1*Dd*f**2*s + 168*C*D1*Dd*f**2 - 3456*C*D1*Dd*f*fd*r*s + 432*C*D1*Dd*f*fd*r - 4032*C*D1*Dd*f*fd*s**2 + 2736*C*D1*Dd*f*fd*s - 216*C*D1*Dd*f*fd - 864*C*D1*Ddd*f**2*r*s + 216*C*D1*Ddd*f**2*r - 1008*C*D1*Ddd*f**2*s**2 + 936*C*D1*Ddd*f**2*s - 252*C*D1*Ddd*f**2 - 2592*C*Dd**2*f**2*r*s + 648*C*Dd**2*f**2*r - 3024*C*Dd**2*f**2*s**2 + 2808*C*Dd**2*f**2*s - 432*C*Dd**2*f**2 - 70*D1**2*bd1**2*(f*(4*r*(3*s - 1) + 9*s**2 - 10*s + 2) + s*(5 - 10*K)*(3*s - 2)) + 7*D1**2*bdd1*(f*(44*C*(2*s**2 - 2*s + 1) - 10*K*(4*r*s - 2*r + 6*s**2 - 8*s + 3) - 66*s**2 + 66*s - 33) - 100*g2*(2*s**2 - 2*s + 1)) - 140*D1**2*bdd2*f*r*s - 210*D1**2*bdd2*f*s**2 + 140*D1**2*bdd2*f*s - 96*D1**2*f*fd*r*s - 168*D1**2*f*fd*s**2 + 48*D1**2*f*fd*s + 216*D1**2*f*fdd*r*s + 252*D1**2*f*fdd*s**2 - 108*D1**2*f*fdd*s - 280*D1**2*f*gd2*r*s - 280*D1**2*f*gd2*s**2 + 280*D1**2*f*gd2*s + 280*D1**2*f*gdd2*r*s + 420*D1**2*f*gdd2*s**2 - 280*D1**2*f*gdd2*s + 216*D1**2*fd**2*r*s + 252*D1**2*fd**2*s**2 - 108*D1**2*fd**2*s - 280*D1**2*fd*g2*r*s - 280*D1**2*fd*g2*s**2 + 560*D1**2*fd*gd2*r*s + 840*D1**2*fd*gd2*s**2 - 280*D1**2*fd*gd2*s + 280*D1**2*fdd*g2*r*s + 420*D1**2*fdd*g2*s**2 - 192*D1*Dd*f**2*r*s + 48*D1*Dd*f**2*r - 336*D1*Dd*f**2*s**2 + 264*D1*Dd*f**2*s - 84*D1*Dd*f**2 + 1728*D1*Dd*f*fd*r*s - 216*D1*Dd*f*fd*r + 2016*D1*Dd*f*fd*s**2 - 1368*D1*Dd*f*fd*s + 108*D1*Dd*f*fd - 1120*D1*Dd*f*g2*r*s + 280*D1*Dd*f*g2*r - 1120*D1*Dd*f*g2*s**2 + 1120*D1*Dd*f*g2*s - 280*D1*Dd*f*g2 + 2240*D1*Dd*f*gd2*r*s - 280*D1*Dd*f*gd2*r + 3360*D1*Dd*f*gd2*s**2 - 2520*D1*Dd*f*gd2*s + 280*D1*Dd*f*gd2 + 2240*D1*Dd*fd*g2*r*s - 280*D1*Dd*fd*g2*r + 3360*D1*Dd*fd*g2*s**2 - 1400*D1*Dd*fd*g2*s + 432*D1*Ddd*f**2*r*s - 108*D1*Ddd*f**2*r + 504*D1*Ddd*f**2*s**2 - 468*D1*Ddd*f**2*s + 126*D1*Ddd*f**2 + 1120*D1*Ddd*f*g2*r*s - 280*D1*Ddd*f*g2*r + 1680*D1*Ddd*f*g2*s**2 - 1400*D1*Ddd*f*g2*s + 420*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(88*C*fd*s**2 - 44*C*fd*s - 40*K*fd*r*s + 10*K*fd*r - 60*K*fd*s**2 + 40*K*fd*s + f*(4*C*(5*r*(2*s - 1) - 2*s**2 + 2*s - 1) + 10*K*(2*s - 1)*(r + s - 1) - 20*r*s + 10*r + 6*s**2 - 16*s + 3) - 66*fd*s**2 + 33*fd*s - 120*g2*r*s + 60*g2*r - 40*g2*s**2 + 40*g2*s - 20*g2 - 200*gd2*s**2 + 100*gd2*s) + Dd*(f*(44*C*(8*s**2 - 6*s + 1) - 20*K*(8*r*s - 3*r + 12*s**2 - 13*s + 3) - 264*s**2 + 198*s - 33) - 100*g2*(8*s**2 - 6*s + 1))) + 140*D1*bd2*(D1*s*(f*(r + s - 1) - 2*fd*r - 3*fd*s + fd) - Dd*f*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) + 1296*Dd**2*f**2*r*s - 324*Dd**2*f**2*r + 1512*Dd**2*f**2*s**2 - 1404*Dd**2*f**2*s + 216*Dd**2*f**2 + 3360*Dd**2*f*g2*r*s - 840*Dd**2*f*g2*r + 5040*Dd**2*f*g2*s**2 - 4200*Dd**2*f*g2*s + 560*Dd**2*f*g2 + 70*b2*(D1**2*s*(2*fd*(r + s) - fdd*(2*r + 3*s)) + D1*(2*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(-8*r*s + r + s*(5 - 12*s))) + Ddd*f*(r*(2 - 8*s) - 12*s**2 + 10*s - 3)) - 2*Dd**2*f*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2))))/(210*d**2*k3**2) + 9*D1**2*Pk3*Pkd2*ct*k1*st**4*(-D1*f*s*(2*D1*bd1**2*s*(5*f + 7) + D1*bdd1*f*s - 2*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*(-4*f*s + f))) + b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 14*fd*(s - 1)**2 - 7*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) - f*(fd*(s**2*(40*bd1 - 4) + s*(4 - 20*bd1) - 2) + fdd*(2*s**2 - 2*s + 1) + s**2*(-28*bd1 + 14*bdd1)) - 2*fd*s*(14*bd1 + fd)*(s - 1)) - D1*f*(2*Dd*(f*(s**2*(40*bd1 - 4) + s*(2 - 10*bd1) - 1) + (4*s - 1)*(14*bd1*s + fd*(2*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(70*d**2*k2**2) + D1**2*Pk3*Pkd2*ct*k1*st**2*(D1*f*s*(14*D1*bd1**2*(s*(21*f + 26) + 5) + 53*D1*bdd1*f*s + 106*bd1*(-D1*(f*s - 2*fd*s + fd) + Dd*f*(4*s - 1))) + 35*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + 7*b1**2*(-5*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 84*D1**2*f*fd*s**2 + 84*D1**2*f*fd*s - 42*D1**2*f*fd + 42*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd + 42*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s - 52*D1**2*fd*s**2 + 124*D1**2*fd*s - 62*D1**2*fd + 26*D1**2*fdd*s**2 - 62*D1**2*fdd*s + 31*D1**2*fdd - 168*D1*Dd*f**2*s**2 + 84*D1*Dd*f**2*s - 42*D1*Dd*f**2 + 336*D1*Dd*f*fd*s**2 - 252*D1*Dd*f*fd*s + 42*D1*Dd*f*fd - 208*D1*Dd*f*s**2 + 104*D1*Dd*f*s - 52*D1*Dd*f + 208*D1*Dd*fd*s**2 - 300*D1*Dd*fd*s + 62*D1*Dd*fd + 84*D1*Ddd*f**2*s**2 - 42*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 + 104*D1*Ddd*f*s**2 - 52*D1*Ddd*f*s + 26*D1*Ddd*f + 10*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) + 252*Dd**2*f**2*s**2 - 126*Dd**2*f**2*s + 312*Dd**2*f*s**2 - 156*Dd**2*f*s) + b1*(-70*D1**2*bd1**2*s*(3*f + 5)*(3*s - 2) + 7*D1**2*bdd1*f*(s**2*(42*f + 52) + 10*s - 5) - 53*D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) - 14*D1*bd1*(D1*(42*f**2*s**2 + f*(s**2*(52 - 84*fd) + s*(42*fd + 10) - 5) + fd*s*(57 - 52*s)) - Dd*f*(4*s - 1)*(s*(42*f + 52) + 5)) - 53*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 318*Dd**2*f**2*s*(1 - 2*s)))/(210*d**2*k2**2) + D1**2*Pk3*Pkd2*ct*k1*(22*D1**2*bd1**2*f*s*(s - 1) + D1*b1*(10*D1*bd1**2*s*(3*f + 5)*(3*s - 2) + 11*D1*bdd1*f*(2*s**2 - 2*s + 1) - 22*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1))) - 5*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) + b1**2*(5*D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 11*D1**2*s**2*(2*fd - fdd) - 22*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) - 11*D1*Ddd*f*(-4*s**2 + 2*s - 1) - 10*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) - 66*Dd**2*f*s*(1 - 2*s)))/(30*d**2*k2**2) + D1**2*Pk3*Pkd2*ct*k2**4*st**2*(8*C - 4)*(6*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*f*(D1*(-5*f*r*(s - 1) + 6*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 5) - 2*s + 2)) + b1*(D1*Dd*f*(5*f*(-4*r*s + r + 2*s) + 6*fd*(2*r - 1)*(8*s - 1)) + D1*(-D1*s*(2*r - 1)*(5*f*fd - 6*f*fdd - 6*fd**2) + 6*Ddd*f**2*(4*r*s - r - 2*s)) + 6*Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2)))/(105*d**2*k1*k3**4) - D1**2*Pk3*Pkd2*ct*k2**2*(8*C - 4)*(D1**2*bd1**2*f*r*(1 - 2*s) + D1*b1*(D1*bd1*(2*f*r*(2*s - 1) + fd*(-4*r*s + r + 2*s - 1)) + D1*bdd1*f*r*(1 - 2*s) - 2*Dd*bd1*f*(r*(8*s - 3) - 2*s + 1)) + b1**2*(-D1*Dd*(2*f*(-4*r*s + r + 2*s) + fd*r*(8*s - 1) - 6*fd*s + fd) + D1*(D1*s*(2*fd - fdd)*(r - 1) + Ddd*f*(-4*r*s + r + 2*s)) + Dd**2*f*(r*(3 - 12*s) + 6*s - 2)))/(15*d**2*k1*k3**2) + D1**2*Pk3*Pkd2*ct*st**2*(8*C - 4)*(D1*f*(-6*D1*bdd1*f*r*s + bd1*(5*D1*f*r*s + 6*D1*fd*(-4*r*s + r + s) + 6*Dd*f*(-8*r*s + r + 2*s))) + b1*(D1*Dd*f*(5*f*(4*r*s - r - 2*s) - 6*fd*(2*r - 1)*(8*s - 3)) + D1*(D1*(5*f*fd*(2*r*s - r - s) + 6*f*fdd*(-2*r*s + r + s) + 6*fd**2*(-2*r*s + r + s - 1)) + 6*Ddd*f**2*(-4*r*s + r + 2*s)) - 6*Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2)))/(105*d**2*k1) + D1**2*Pk3*Pkd2*ct*(8*C - 4)*(D1**2*bd1**2*f*r*(1 - 2*s) + D1*b1*(D1*bd1*(2*f*r*(2*s - 1) + fd*(-4*r*s + r + 2*s - 1)) + D1*bdd1*f*r*(1 - 2*s) - 2*Dd*bd1*f*(r*(8*s - 3) - 2*s + 1)) + b1**2*(-D1*Dd*(2*f*(-4*r*s + r + 2*s) + fd*r*(8*s - 1) - 6*fd*s + fd) + D1*(D1*s*(2*fd - fdd)*(r - 1) + Ddd*f*(-4*r*s + r + 2*s)) + Dd**2*f*(r*(3 - 12*s) + 6*s - 2)))/(15*d**2*k1) + 4*D1**2*Pk3*Pkd2*f**2*k1**6*st**4*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(231*d**2*k2*k3**6) + 8*D1**2*Pk3*Pkd2*f**2*k1**4*k2*st**6*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(77*d**2*k3**6) + 9*D1**2*Pk3*Pkd2*f**2*k1**4*st**6*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(154*d**2*k2*k3**4) + 4*D1**2*Pk3*Pkd2*f**2*k1**2*k2**3*st**8*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(99*d**2*k3**6) + D1**2*Pk3*Pkd2*f**2*k1**2*k2*st**8*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(22*d**2*k3**4) + 4*D1**2*Pk3*Pkd2*f*k1**6*st**2*(-D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) + b1*(D1**2*s*(3*r + 3*s - 2)*(2*f*fd - f*fdd - 2*fd**2) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(3 - 24*s) - 24*s**2 + 20*s - 2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(63*d**2*k2*k3**6) - 4*D1**2*Pk3*Pkd2*f*k1**4*k2*st**4*(-12*D1**2*b1*f*fd*r*s - 8*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s**2 + 8*D1**2*b1*f*fd + 6*D1**2*b1*f*fdd*r*s + 4*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 - 4*D1**2*b1*f*fdd + 12*D1**2*b1*fd**2*r*s + 8*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 - 4*D1**2*b1*fd**2 + 2*D1**2*bdd1*f**2*(s - 3)*(r + s - 1) + 12*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 12*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 3*D1**2*f**2*fd - 16*D1*Dd*b1*f**2*r*s + 4*D1*Dd*b1*f**2*r - 16*D1*Dd*b1*f**2*s**2 + 16*D1*Dd*b1*f**2*s - 4*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r*s + 10*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 24*D1*Dd*b1*f*fd*s - 8*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 8*D1*Ddd*b1*f**2*r*s - 2*D1*Ddd*b1*f**2*r + 8*D1*Ddd*b1*f**2*s**2 - 8*D1*Ddd*b1*f**2*s + 2*D1*Ddd*b1*f**2 - 2*D1*bd1*f*(D1*(2*f*(s - 3)*(r + s - 1) + fd*(-6*r*s + 7*r - 6*s**2 + 12*s - 4)) + Dd*f*(r*(13 - 8*s) - 8*s**2 + 20*s - 10)) + 24*Dd**2*b1*f**2*r*s - 6*Dd**2*b1*f**2*r + 24*Dd**2*b1*f**2*s**2 - 24*Dd**2*b1*f**2*s + 4*Dd**2*b1*f**2)/(105*d**2*k3**6) + D1**2*Pk3*Pkd2*f*k1**4*st**4*(48*D1**2*b1*f*fd*r*s - 16*D1**2*b1*f*fd*r + 108*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fd - 24*D1**2*b1*f*fdd*r*s + 8*D1**2*b1*f*fdd*r - 54*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 3*D1**2*b1*f*fdd - 48*D1**2*b1*fd**2*r*s + 16*D1**2*b1*fd**2*r - 108*D1**2*b1*fd**2*s**2 + 36*D1**2*b1*fd**2*s - 12*D1**2*b1*fd**2 - D1**2*bdd1*f**2*(8*r*s + 18*s**2 - 34*s + 15) - 40*D1**2*f**2*fd*r*s + 10*D1**2*f**2*fd*r - 192*D1**2*f**2*fd*s**2 + 116*D1**2*f**2*fd*s - 48*D1**2*f**2*fd + 40*D1**2*f**2*fdd*r*s - 10*D1**2*f**2*fdd*r + 108*D1**2*f**2*fdd*s**2 - 74*D1**2*f**2*fdd*s + 27*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r + 324*D1**2*f*fd**2*s**2 - 222*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 + 64*D1*Dd*b1*f**2*r*s - 16*D1*Dd*b1*f**2*r + 144*D1*Dd*b1*f**2*s**2 - 104*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 192*D1*Dd*b1*f*fd*r*s + 56*D1*Dd*b1*f*fd*r - 432*D1*Dd*b1*f*fd*s**2 + 228*D1*Dd*b1*f*fd*s - 34*D1*Dd*b1*f*fd - 40*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r - 192*D1*Dd*f**3*s**2 + 116*D1*Dd*f**3*s - 48*D1*Dd*f**3 + 320*D1*Dd*f**2*fd*r*s - 80*D1*Dd*f**2*fd*r + 864*D1*Dd*f**2*fd*s**2 - 592*D1*Dd*f**2*fd*s + 94*D1*Dd*f**2*fd - 32*D1*Ddd*b1*f**2*r*s + 8*D1*Ddd*b1*f**2*r - 72*D1*Ddd*b1*f**2*s**2 + 52*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 + 40*D1*Ddd*f**3*r*s - 10*D1*Ddd*f**3*r + 108*D1*Ddd*f**3*s**2 - 74*D1*Ddd*f**3*s + 27*D1*Ddd*f**3 + 2*D1*bd1*f*(D1*(f*(8*r*s + 18*s**2 - 34*s + 15) - 2*fd*(12*r*s - 2*r + 27*s**2 - 30*s + 1)) + Dd*f*(r*(4 - 32*s) - 72*s**2 + 94*s - 17)) - 96*Dd**2*b1*f**2*r*s + 24*Dd**2*b1*f**2*r - 216*Dd**2*b1*f**2*s**2 + 156*Dd**2*b1*f**2*s - 16*Dd**2*b1*f**2 + 120*Dd**2*f**3*r*s - 30*Dd**2*f**3*r + 324*Dd**2*f**3*s**2 - 222*Dd**2*f**3*s + 20*Dd**2*f**3)/(210*d**2*k2*k3**4) - 4*D1**2*Pk3*Pkd2*f*k1**2*k2**3*st**6*(18*D1**2*b1*f*fd*r*s - 8*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fd*s**2 - 20*D1**2*b1*f*fd*s + 8*D1**2*b1*f*fd - 9*D1**2*b1*f*fdd*r*s + 4*D1**2*b1*f*fdd*r - 9*D1**2*b1*f*fdd*s**2 + 10*D1**2*b1*f*fdd*s - 4*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r*s + 8*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 20*D1**2*b1*fd**2*s - 4*D1**2*b1*fd**2 - D1**2*bdd1*f**2*(3*s + 1)*(r + s - 1) + 4*D1**2*f**2*fd*r*s - D1**2*f**2*fd*r + 4*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + D1**2*f**2*fd + 24*D1*Dd*b1*f**2*r*s - 6*D1*Dd*b1*f**2*r + 24*D1*Dd*b1*f**2*s**2 - 24*D1*Dd*b1*f**2*s + 6*D1*Dd*b1*f**2 - 72*D1*Dd*b1*f*fd*r*s + 25*D1*Dd*b1*f*fd*r - 72*D1*Dd*b1*f*fd*s**2 + 76*D1*Dd*b1*f*fd*s - 18*D1*Dd*b1*f*fd + 4*D1*Dd*f**3*r*s - D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s + D1*Dd*f**3 - 12*D1*Ddd*b1*f**2*r*s + 3*D1*Ddd*b1*f**2*r - 12*D1*Ddd*b1*f**2*s**2 + 12*D1*Ddd*b1*f**2*s - 3*D1*Ddd*b1*f**2 + D1*bd1*f*(D1*(2*f*(3*s + 1)*(r + s - 1) + fd*(-18*r*s + r - 18*s**2 + 16*s - 2)) - Dd*f*(24*r*s + r + 4*s*(6*s - 5))) - 36*Dd**2*b1*f**2*r*s + 9*Dd**2*b1*f**2*r - 36*Dd**2*b1*f**2*s**2 + 36*Dd**2*b1*f**2*s - 6*Dd**2*b1*f**2)/(63*d**2*k3**6) - D1**2*Pk3*Pkd2*f*k1**2*k2*st**6*(-96*D1**2*b1*f*fd*r*s + 32*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 44*D1**2*b1*f*fd*s - 2*D1**2*b1*f*fd + 48*D1**2*b1*f*fdd*r*s - 16*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 22*D1**2*b1*f*fdd*s + D1**2*b1*f*fdd + 96*D1**2*b1*fd**2*r*s - 32*D1**2*b1*fd**2*r + 36*D1**2*b1*fd**2*s**2 - 44*D1**2*b1*fd**2*s + 20*D1**2*b1*fd**2 + D1**2*bdd1*f**2*(16*r*s + 6*s**2 - 22*s + 5) + 72*D1**2*f**2*fd*r*s - 18*D1**2*f**2*fd*r + 80*D1**2*f**2*fd*s**2 - 76*D1**2*f**2*fd*s + 20*D1**2*f**2*fd - 72*D1**2*f**2*fdd*r*s + 18*D1**2*f**2*fdd*r - 52*D1**2*f**2*fdd*s**2 + 62*D1**2*f**2*fdd*s - 13*D1**2*f**2*fdd - 216*D1**2*f*fd**2*r*s + 54*D1**2*f*fd**2*r - 156*D1**2*f*fd**2*s**2 + 186*D1**2*f*fd**2*s - 36*D1**2*f*fd**2 - 128*D1*Dd*b1*f**2*r*s + 32*D1*Dd*b1*f**2*r - 48*D1*Dd*b1*f**2*s**2 + 88*D1*Dd*b1*f**2*s - 12*D1*Dd*b1*f**2 + 384*D1*Dd*b1*f*fd*r*s - 112*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 220*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd + 72*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 80*D1*Dd*f**3*s**2 - 76*D1*Dd*f**3*s + 20*D1*Dd*f**3 - 576*D1*Dd*f**2*fd*r*s + 144*D1*Dd*f**2*fd*r - 416*D1*Dd*f**2*fd*s**2 + 496*D1*Dd*f**2*fd*s - 98*D1*Dd*f**2*fd + 64*D1*Ddd*b1*f**2*r*s - 16*D1*Ddd*b1*f**2*r + 24*D1*Ddd*b1*f**2*s**2 - 44*D1*Ddd*b1*f**2*s + 6*D1*Ddd*b1*f**2 - 72*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 52*D1*Ddd*f**3*s**2 + 62*D1*Ddd*f**3*s - 13*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(f*(16*r*s + 6*s**2 - 22*s + 5) - 2*fd*(24*r*s - 4*r + 9*s**2 - 22*s + 3)) + Dd*f*(r*(8 - 64*s) - 24*s**2 + 66*s - 11)) + 192*Dd**2*b1*f**2*r*s - 48*Dd**2*b1*f**2*r + 72*Dd**2*b1*f**2*s**2 - 132*Dd**2*b1*f**2*s + 32*Dd**2*b1*f**2 - 216*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 156*Dd**2*f**3*s**2 + 186*Dd**2*f**3*s - 36*Dd**2*f**3)/(126*d**2*k3**4) + 3*D1**2*Pk3*Pkd2*f*k1**2*st**6*(D1*f*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - 3*fd*s + fd) + Dd*(-4*f*s + f))) + b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k2*k3**2) - 4*D1**2*Pk3*Pkd2*k1**4*k2*st**2*(D1**2*bd1*f**2*(bd1*(4 - 8*s) + f*(2*s - 3))*(r + s - 1) + D1*b1*f*(4*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-8*r*s + 2*r - 8*s**2 + 8*s - 1)) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) + f*(-4*D1*bdd1*(2*s - 1)*(r + s - 1) + D1*fd*(6*r*s + r + 6*s**2 - 3*s - 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + 4*b1**2*(D1**2*s*(2*r + 2*s - 1)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(2 - 16*s) - 16*s**2 + 12*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(35*d**2*k3**6) + D1**2*Pk3*Pkd2*k1**4*st**2*(D1*f**2*(-2*D1*bd1**2*(r*(8*s - 4) + 7*s**2 - 9*s + 2) + 5*D1*bdd1*f*(2*r*(s - 1) + 2*s**2 - 6*s + 3) - 2*bd1*(D1*(f*(5*r*s - 5*r + 8*s**2 - 24*s + 12) - 5*fd*(6*r*s - 3*r + 6*s**2 - 10*s + 2)) - 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 16*s + 5))) + b1**2*(2*D1**2*s*(8*r + 7*s - 6)*(2*f*fd - f*fdd - fd**2) + D1*f*(2*Dd*(f*(32*r*s - 8*r + 28*s**2 - 30*s + 7) - 2*fd*(32*r*s - 4*r + 28*s**2 - 27*s + 3)) + Ddd*f*(r*(8 - 32*s) - 28*s**2 + 30*s - 7)) - 2*Dd**2*f**2*(12*r*(4*s - 1) + 42*s**2 - 45*s + 8)) + b1*f*(D1**2*bdd1*f*(-16*r*s + 8*r - 14*s**2 + 18*s - 7) - 30*D1**2*f*fd*r*s - 48*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s + 8*D1**2*f*fd + 30*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s - 5*D1**2*f*fdd + 60*D1**2*fd**2*r*s + 60*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s - 40*D1*Dd*f**2*r*s + 10*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 + 52*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 240*D1*Dd*f*fd*r*s - 30*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 160*D1*Dd*f*fd*s + 10*D1*Dd*f*fd + 40*D1*Ddd*f**2*r*s - 10*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 40*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(16*r*s - 8*r + 14*s**2 - 18*s + 7) - 2*fd*(16*r*s - 4*r + 14*s**2 - 15*s + 3)) + Dd*f*(-8*r*(8*s - 3) - 56*s**2 + 66*s - 17)) + 120*Dd**2*f**2*r*s - 30*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 120*Dd**2*f**2*s + 20*Dd**2*f**2))/(70*d**2*k2*k3**4) - D1**2*Pk3*Pkd2*k1**4*(2*D1**2*bd1**2*f**2*s*(s - 1) + D1*b1*f*(D1*bdd1*f*(2*s**2 - 2*s + 1) + 2*bd1*(2*s - 1)*(2*D1*fd*s + Dd*f*(4*s - 1))) + b1**2*(2*D1**2*s**2*(f*fdd + fd**2) + D1*f*(4*Dd*fd*s*(4*s - 1) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)))/(10*d**2*k2*k3**4) + 4*D1**2*Pk3*Pkd2*k1**2*k2**3*st**4*(12*C*D1**2*f**2*fd*r*s - 4*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 12*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r*s + 2*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 6*C*D1**2*f**2*fdd*s - 2*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r*s + 4*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 12*C*D1**2*f*fd**2*s - 2*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r*s - 4*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 16*C*D1*Dd*f**3*s + 4*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r*s + 14*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 48*C*D1*Dd*f**2*fd*s - 10*C*D1*Dd*f**2*fd - 8*C*D1*Ddd*f**3*r*s + 2*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 8*C*D1*Ddd*f**3*s - 2*C*D1*Ddd*f**3 - 24*C*Dd**2*f**3*r*s + 6*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 24*C*Dd**2*f**3*s - 4*C*Dd**2*f**3 - 3*D1**2*K*bdd1*f**2*r*s - 3*D1**2*K*bdd1*f**2*s**2 + 3*D1**2*K*bdd1*f**2*s + 4*D1**2*bd1**2*f**2*(2*s - 1)*(r + s - 1) - 6*D1**2*f**2*fd*r*s + 2*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r*s - D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 3*D1**2*f**2*fdd*s + D1**2*f**2*fdd - 12*D1**2*f**2*gd2*r*s - 12*D1**2*f**2*gd2*s**2 + 12*D1**2*f**2*gd2*s + 6*D1**2*f**2*gdd2*r*s + 6*D1**2*f**2*gdd2*s**2 - 6*D1**2*f**2*gdd2*s + 6*D1**2*f*fd**2*r*s - 2*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 6*D1**2*f*fd**2*s + D1**2*f*fd**2 - 24*D1**2*f*fd*g2*r*s + 12*D1**2*f*fd*g2*r - 24*D1**2*f*fd*g2*s**2 + 24*D1**2*f*fd*g2*s - 12*D1**2*f*fd*g2 + 24*D1**2*f*fd*gd2*r*s - 6*D1**2*f*fd*gd2*r + 24*D1**2*f*fd*gd2*s**2 - 24*D1**2*f*fd*gd2*s + 6*D1**2*f*fd*gd2 + 12*D1**2*f*fdd*g2*r*s - 6*D1**2*f*fdd*g2*r + 12*D1**2*f*fdd*g2*s**2 - 12*D1**2*f*fdd*g2*s + 6*D1**2*f*fdd*g2 + 12*D1**2*fd**2*g2*r*s - 6*D1**2*fd**2*g2*r + 12*D1**2*fd**2*g2*s**2 - 12*D1**2*fd**2*g2*s - 8*D1*Dd*f**3*r*s + 2*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 8*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r*s - 7*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 24*D1*Dd*f**2*fd*s + 5*D1*Dd*f**2*fd - 48*D1*Dd*f**2*g2*r*s + 12*D1*Dd*f**2*g2*r - 48*D1*Dd*f**2*g2*s**2 + 48*D1*Dd*f**2*g2*s - 12*D1*Dd*f**2*g2 + 48*D1*Dd*f**2*gd2*r*s - 6*D1*Dd*f**2*gd2*r + 48*D1*Dd*f**2*gd2*s**2 - 48*D1*Dd*f**2*gd2*s + 6*D1*Dd*f**2*gd2 + 96*D1*Dd*f*fd*g2*r*s - 36*D1*Dd*f*fd*g2*r + 96*D1*Dd*f*fd*g2*s**2 - 96*D1*Dd*f*fd*g2*s + 24*D1*Dd*f*fd*g2 + 4*D1*Ddd*f**3*r*s - D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 4*D1*Ddd*f**3*s + D1*Ddd*f**3 + 24*D1*Ddd*f**2*g2*r*s - 6*D1*Ddd*f**2*g2*r + 24*D1*Ddd*f**2*g2*s**2 - 24*D1*Ddd*f**2*g2*s + 6*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(6*K*f*s*(r + s - 1) - 3*K*fd*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(2*s + 1)*(r + s - 1)) - 3*Dd*K*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 12*Dd**2*f**3*r*s - 3*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 12*Dd**2*f**3*s + 2*Dd**2*f**3 + 72*Dd**2*f**2*g2*r*s - 18*Dd**2*f**2*g2*r + 72*Dd**2*f**2*g2*s**2 - 72*Dd**2*f**2*g2*s + 12*Dd**2*f**2*g2 - 4*b1**2*(D1**2*s*(2*r + 2*s - 1)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(2 - 16*s) - 16*s**2 + 12*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(12*D1**2*K*f*fd*r*s - 6*D1**2*K*f*fd*r + 12*D1**2*K*f*fd*s**2 - 12*D1**2*K*f*fd*s + 6*D1**2*K*f*fd - 6*D1**2*K*f*fdd*r*s + 3*D1**2*K*f*fdd*r - 6*D1**2*K*f*fdd*s**2 + 6*D1**2*K*f*fdd*s - 3*D1**2*K*f*fdd - 6*D1**2*K*fd**2*r*s + 3*D1**2*K*fd**2*r - 6*D1**2*K*fd**2*s**2 + 6*D1**2*K*fd**2*s + 4*D1**2*bdd1*f**2*(2*s - 1)*(r + s - 1) + 6*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 7*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 24*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s**2 - 24*D1*Dd*K*f**2*s + 6*D1*Dd*K*f**2 - 48*D1*Dd*K*f*fd*r*s + 18*D1*Dd*K*f*fd*r - 48*D1*Dd*K*f*fd*s**2 + 48*D1*Dd*K*f*fd*s - 12*D1*Dd*K*f*fd + 8*D1*Dd*f**3*r*s - 2*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 2*D1*Dd*f**3 - 12*D1*Ddd*K*f**2*r*s + 3*D1*Ddd*K*f**2*r - 12*D1*Ddd*K*f**2*s**2 + 12*D1*Ddd*K*f**2*s - 3*D1*Ddd*K*f**2 - 4*D1*bd1*f*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-8*r*s + 2*r - 8*s**2 + 8*s - 1)) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 36*Dd**2*K*f**2*r*s + 9*Dd**2*K*f**2*r - 36*Dd**2*K*f**2*s**2 + 36*Dd**2*K*f**2*s - 6*Dd**2*K*f**2))/(35*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*k1**2*k2**3*st**2*(72*C*D1**2*b1*f*fd*r*s + 72*C*D1**2*b1*f*fd*s**2 - 36*C*D1**2*b1*f*fd*s - 36*C*D1**2*b1*f*fdd*r*s - 36*C*D1**2*b1*f*fdd*s**2 + 18*C*D1**2*b1*f*fdd*s - 36*C*D1**2*b1*fd**2*r*s - 36*C*D1**2*b1*fd**2*s**2 + 18*C*D1**2*b1*fd**2*s - 18*C*D1**2*f**2*fd*r*s + 6*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 18*C*D1**2*f**2*fd*s - 6*C*D1**2*f**2*fd + 144*C*D1*Dd*b1*f**2*r*s - 36*C*D1*Dd*b1*f**2*r + 144*C*D1*Dd*b1*f**2*s**2 - 144*C*D1*Dd*b1*f**2*s + 36*C*D1*Dd*b1*f**2 - 288*C*D1*Dd*b1*f*fd*r*s + 36*C*D1*Dd*b1*f*fd*r - 288*C*D1*Dd*b1*f*fd*s**2 + 216*C*D1*Dd*b1*f*fd*s - 18*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r*s + 6*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 24*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 72*C*D1*Ddd*b1*f**2*r*s + 18*C*D1*Ddd*b1*f**2*r - 72*C*D1*Ddd*b1*f**2*s**2 + 72*C*D1*Ddd*b1*f**2*s - 18*C*D1*Ddd*b1*f**2 - 216*C*Dd**2*b1*f**2*r*s + 54*C*Dd**2*b1*f**2*r - 216*C*Dd**2*b1*f**2*s**2 + 216*C*Dd**2*b1*f**2*s - 36*C*Dd**2*b1*f**2 + 42*D1**2*K*b1**2*fd*r*s + 42*D1**2*K*b1**2*fd*s**2 - 21*D1**2*K*b1**2*fdd*r*s - 21*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r*s + 7*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 21*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 42*D1**2*b1**2*f*fd*r*s + 42*D1**2*b1**2*f*fd*s**2 - 21*D1**2*b1**2*f*fd*s - 36*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*s**2 + 18*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*s**2 - 9*D1**2*b1*f*fdd*s - 84*D1**2*b1*f*gd2*r*s - 84*D1**2*b1*f*gd2*s**2 + 84*D1**2*b1*f*gd2*s + 42*D1**2*b1*f*gdd2*r*s + 42*D1**2*b1*f*gdd2*s**2 - 42*D1**2*b1*f*gdd2*s + 18*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*s**2 - 9*D1**2*b1*fd**2*s - 84*D1**2*b1*fd*g2*r*s - 84*D1**2*b1*fd*g2*s**2 + 84*D1**2*b1*fd*gd2*r*s + 84*D1**2*b1*fd*gd2*s**2 - 42*D1**2*b1*fd*gd2*s + 42*D1**2*b1*fdd*g2*r*s + 42*D1**2*b1*fdd*g2*s**2 - 3*D1**2*bdd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(6*C - 3)*(s - 1) - 14*g2*(s - 1)) + 9*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 9*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r*s + 14*D1**2*f**2*gd2*s**2 - 14*D1**2*f**2*gd2*s + 28*D1**2*f*fd*g2*r*s - 14*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 168*D1*Dd*K*b1**2*f*r*s - 42*D1*Dd*K*b1**2*f*r + 168*D1*Dd*K*b1**2*f*s**2 - 168*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 168*D1*Dd*K*b1**2*fd*r*s + 21*D1*Dd*K*b1**2*fd*r - 168*D1*Dd*K*b1**2*fd*s**2 + 84*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r*s + 7*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 28*D1*Dd*K*b1*f**2*s - 7*D1*Dd*K*b1*f**2 + 84*D1*Dd*b1**2*f**2*r*s - 21*D1*Dd*b1**2*f**2*r + 84*D1*Dd*b1**2*f**2*s**2 - 84*D1*Dd*b1**2*f**2*s + 21*D1*Dd*b1**2*f**2 - 72*D1*Dd*b1*f**2*r*s + 18*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 72*D1*Dd*b1*f**2*s - 18*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r*s - 18*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 108*D1*Dd*b1*f*fd*s + 9*D1*Dd*b1*f*fd - 336*D1*Dd*b1*f*g2*r*s + 84*D1*Dd*b1*f*g2*r - 336*D1*Dd*b1*f*g2*s**2 + 336*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 336*D1*Dd*b1*f*gd2*r*s - 42*D1*Dd*b1*f*gd2*r + 336*D1*Dd*b1*f*gd2*s**2 - 336*D1*Dd*b1*f*gd2*s + 42*D1*Dd*b1*f*gd2 + 336*D1*Dd*b1*fd*g2*r*s - 42*D1*Dd*b1*fd*g2*r + 336*D1*Dd*b1*fd*g2*s**2 - 168*D1*Dd*b1*fd*g2*s + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r*s - 14*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 56*D1*Dd*f**2*g2*s + 14*D1*Dd*f**2*g2 - 84*D1*Ddd*K*b1**2*f*r*s + 21*D1*Ddd*K*b1**2*f*r - 84*D1*Ddd*K*b1**2*f*s**2 + 84*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 36*D1*Ddd*b1*f**2*r*s - 9*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 36*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 168*D1*Ddd*b1*f*g2*r*s - 42*D1*Ddd*b1*f*g2*r + 168*D1*Ddd*b1*f*g2*s**2 - 168*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(36*C*(s - 1) - 7*K*s + 21*b1*(2*s - 1) - 18*s + 18) - 3*f*(fd*(6*C - 3)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(14*r + 14*s - 14)) + 21*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) - 3*Dd*f*(7*K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + f*(6*C - 3)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 14*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 252*Dd**2*K*b1**2*f*r*s + 63*Dd**2*K*b1**2*f*r - 252*Dd**2*K*b1**2*f*s**2 + 252*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 108*Dd**2*b1*f**2*r*s - 27*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 108*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 504*Dd**2*b1*f*g2*r*s - 126*Dd**2*b1*f*g2*r + 504*Dd**2*b1*f*g2*s**2 - 504*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(105*d**2*k3**6) + D1**2*Pk3*Pkd2*k1**2*k2*st**4*(-192*C*D1**2*f**2*fd*r*s + 64*C*D1**2*f**2*fd*r - 228*C*D1**2*f**2*fd*s**2 + 216*C*D1**2*f**2*fd*s - 76*C*D1**2*f**2*fd + 96*C*D1**2*f**2*fdd*r*s - 32*C*D1**2*f**2*fdd*r + 114*C*D1**2*f**2*fdd*s**2 - 108*C*D1**2*f**2*fdd*s + 38*C*D1**2*f**2*fdd + 192*C*D1**2*f*fd**2*r*s - 64*C*D1**2*f*fd**2*r + 228*C*D1**2*f*fd**2*s**2 - 216*C*D1**2*f*fd**2*s + 32*C*D1**2*f*fd**2 - 256*C*D1*Dd*f**3*r*s + 64*C*D1*Dd*f**3*r - 304*C*D1*Dd*f**3*s**2 + 280*C*D1*Dd*f**3*s - 76*C*D1*Dd*f**3 + 768*C*D1*Dd*f**2*fd*r*s - 224*C*D1*Dd*f**2*fd*r + 912*C*D1*Dd*f**2*fd*s**2 - 852*C*D1*Dd*f**2*fd*s + 172*C*D1*Dd*f**2*fd + 128*C*D1*Ddd*f**3*r*s - 32*C*D1*Ddd*f**3*r + 152*C*D1*Ddd*f**3*s**2 - 140*C*D1*Ddd*f**3*s + 38*C*D1*Ddd*f**3 + 384*C*Dd**2*f**3*r*s - 96*C*Dd**2*f**3*r + 456*C*Dd**2*f**3*s**2 - 420*C*Dd**2*f**3*s + 64*C*Dd**2*f**3 + 48*D1**2*K*bdd1*f**2*r*s + 57*D1**2*K*bdd1*f**2*s**2 - 48*D1**2*K*bdd1*f**2*s - 144*D1**2*b2*f*fd*r*s + 72*D1**2*b2*f*fd*r - 144*D1**2*b2*f*fd*s**2 + 144*D1**2*b2*f*fd*s - 72*D1**2*b2*f*fd + 72*D1**2*b2*f*fdd*r*s - 36*D1**2*b2*f*fdd*r + 72*D1**2*b2*f*fdd*s**2 - 72*D1**2*b2*f*fdd*s + 36*D1**2*b2*f*fdd + 72*D1**2*b2*fd**2*r*s - 36*D1**2*b2*fd**2*r + 72*D1**2*b2*fd**2*s**2 - 72*D1**2*b2*fd**2*s - 6*D1**2*bd1**2*f**2*(8*r*(s - 1) + 5*s**2 - 15*s + 6) - 72*D1**2*bd2*f**2*r*s - 72*D1**2*bd2*f**2*s**2 + 72*D1**2*bd2*f**2*s + 144*D1**2*bd2*f*fd*r*s - 36*D1**2*bd2*f*fd*r + 144*D1**2*bd2*f*fd*s**2 - 144*D1**2*bd2*f*fd*s + 36*D1**2*bd2*f*fd - 54*D1**2*bdd1*f**3*r - 54*D1**2*bdd1*f**3*s**2 + 27*D1**2*bdd1*f**3 - 6*D1**2*bdd1*f**2*r*s - 12*D1**2*bdd1*f**2*s**2 + 6*D1**2*bdd1*f**2*s + 36*D1**2*bdd2*f**2*r*s + 36*D1**2*bdd2*f**2*s**2 - 36*D1**2*bdd2*f**2*s + 108*D1**2*f**2*fd*r*s - 36*D1**2*f**2*fd*r + 138*D1**2*f**2*fd*s**2 - 128*D1**2*f**2*fd*s + 46*D1**2*f**2*fd - 54*D1**2*f**2*fdd*r*s + 18*D1**2*f**2*fdd*r - 69*D1**2*f**2*fdd*s**2 + 64*D1**2*f**2*fdd*s - 23*D1**2*f**2*fdd + 192*D1**2*f**2*gd2*r*s + 228*D1**2*f**2*gd2*s**2 - 192*D1**2*f**2*gd2*s - 96*D1**2*f**2*gdd2*r*s - 114*D1**2*f**2*gdd2*s**2 + 96*D1**2*f**2*gdd2*s - 108*D1**2*f*fd**2*r*s + 36*D1**2*f*fd**2*r - 138*D1**2*f*fd**2*s**2 + 128*D1**2*f*fd**2*s - 18*D1**2*f*fd**2 + 384*D1**2*f*fd*g2*r*s - 192*D1**2*f*fd*g2*r + 456*D1**2*f*fd*g2*s**2 - 456*D1**2*f*fd*g2*s + 228*D1**2*f*fd*g2 - 384*D1**2*f*fd*gd2*r*s + 96*D1**2*f*fd*gd2*r - 456*D1**2*f*fd*gd2*s**2 + 420*D1**2*f*fd*gd2*s - 96*D1**2*f*fd*gd2 - 192*D1**2*f*fdd*g2*r*s + 96*D1**2*f*fdd*g2*r - 228*D1**2*f*fdd*g2*s**2 + 228*D1**2*f*fdd*g2*s - 114*D1**2*f*fdd*g2 - 192*D1**2*fd**2*g2*r*s + 96*D1**2*fd**2*g2*r - 228*D1**2*fd**2*g2*s**2 + 228*D1**2*fd**2*g2*s - 288*D1*Dd*b2*f**2*r*s + 72*D1*Dd*b2*f**2*r - 288*D1*Dd*b2*f**2*s**2 + 288*D1*Dd*b2*f**2*s - 72*D1*Dd*b2*f**2 + 576*D1*Dd*b2*f*fd*r*s - 216*D1*Dd*b2*f*fd*r + 576*D1*Dd*b2*f*fd*s**2 - 576*D1*Dd*b2*f*fd*s + 144*D1*Dd*b2*f*fd + 288*D1*Dd*bd2*f**2*r*s - 36*D1*Dd*bd2*f**2*r + 288*D1*Dd*bd2*f**2*s**2 - 288*D1*Dd*bd2*f**2*s + 36*D1*Dd*bd2*f**2 + 144*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 184*D1*Dd*f**3*s**2 - 164*D1*Dd*f**3*s + 46*D1*Dd*f**3 - 432*D1*Dd*f**2*fd*r*s + 126*D1*Dd*f**2*fd*r - 552*D1*Dd*f**2*fd*s**2 + 502*D1*Dd*f**2*fd*s - 100*D1*Dd*f**2*fd + 768*D1*Dd*f**2*g2*r*s - 192*D1*Dd*f**2*g2*r + 912*D1*Dd*f**2*g2*s**2 - 840*D1*Dd*f**2*g2*s + 228*D1*Dd*f**2*g2 - 768*D1*Dd*f**2*gd2*r*s + 96*D1*Dd*f**2*gd2*r - 912*D1*Dd*f**2*gd2*s**2 + 804*D1*Dd*f**2*gd2*s - 96*D1*Dd*f**2*gd2 - 1536*D1*Dd*f*fd*g2*r*s + 576*D1*Dd*f*fd*g2*r - 1824*D1*Dd*f*fd*g2*s**2 + 1752*D1*Dd*f*fd*g2*s - 420*D1*Dd*f*fd*g2 + 144*D1*Ddd*b2*f**2*r*s - 36*D1*Ddd*b2*f**2*r + 144*D1*Ddd*b2*f**2*s**2 - 144*D1*Ddd*b2*f**2*s + 36*D1*Ddd*b2*f**2 - 72*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 92*D1*Ddd*f**3*s**2 + 82*D1*Ddd*f**3*s - 23*D1*Ddd*f**3 - 384*D1*Ddd*f**2*g2*r*s + 96*D1*Ddd*f**2*g2*r - 456*D1*Ddd*f**2*g2*s**2 + 420*D1*Ddd*f**2*g2*s - 114*D1*Ddd*f**2*g2 - 6*D1*bd1*f*(D1*(-K*fd*(8*r*(4*s - 1) + 38*s**2 - 35*s + 8) + f**2*(r*(6*s - 9) - 6*s**2 - 7*s + 6) + f*(K*s*(16*r + 19*s - 16) + 9*fd*(2*r + 6*s**2 - 2*s - 1) - 2*s*(r + 2*s - 1)) + fd*(4*s - 1)*(r + 2*s - 1)) + Dd*f*(K*(-64*r*s + 8*r - 76*s**2 + 67*s - 8) + 18*f*(2*r + 4*s**2 - s - 1) + (8*s - 1)*(r + 2*s - 1))) + 432*Dd**2*b2*f**2*r*s - 108*Dd**2*b2*f**2*r + 432*Dd**2*b2*f**2*s**2 - 432*Dd**2*b2*f**2*s + 72*Dd**2*b2*f**2 - 216*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 276*Dd**2*f**3*s**2 + 246*Dd**2*f**3*s - 36*Dd**2*f**3 - 1152*Dd**2*f**2*g2*r*s + 288*Dd**2*f**2*g2*r - 1368*Dd**2*f**2*g2*s**2 + 1260*Dd**2*f**2*g2*s - 192*Dd**2*f**2*g2 + 3*b1**2*(2*D1**2*(2*f*fd - f*fdd - fd**2)*(r*(8*s + 4) + 5*s**2 + 2*s - 4) + D1*f*(2*Dd*(f*(32*r*s - 8*r + 20*s**2 - 26*s + 5) - 2*fd*(32*r*s + 4*r + 20*s**2 - 9*s - 5)) + Ddd*f*(r*(8 - 32*s) - 20*s**2 + 26*s - 5)) - 2*Dd**2*f**2*(12*r*(4*s - 1) + 30*s**2 - 39*s + 8)) + 3*b1*(-64*D1**2*K*f*fd*r*s + 32*D1**2*K*f*fd*r - 76*D1**2*K*f*fd*s**2 + 76*D1**2*K*f*fd*s - 38*D1**2*K*f*fd + 32*D1**2*K*f*fdd*r*s - 16*D1**2*K*f*fdd*r + 38*D1**2*K*f*fdd*s**2 - 38*D1**2*K*f*fdd*s + 19*D1**2*K*f*fdd + 32*D1**2*K*fd**2*r*s - 16*D1**2*K*fd**2*r + 38*D1**2*K*fd**2*s**2 - 38*D1**2*K*fd**2*s + D1**2*bdd1*f**2*(-16*r*(s - 1) - 10*s**2 + 30*s - 13) - 36*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r + 36*D1**2*f**2*fd*s**2 - 14*D1**2*f**2*fd*s + 24*D1**2*f**2*fd + 18*D1**2*f**2*fdd*r - 54*D1**2*f**2*fdd*s**2 + 36*D1**2*f**2*fdd*s - 27*D1**2*f**2*fdd + 36*D1**2*f*fd**2*r - 108*D1**2*f*fd**2*s**2 + 72*D1**2*f*fd**2*s - 18*D1**2*f*fd**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 16*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 8*D1**2*f*fd - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 8*D1**2*f*fdd*s**2 + 8*D1**2*f*fdd*s - 4*D1**2*f*fdd - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 8*D1**2*fd**2*s**2 + 8*D1**2*fd**2*s - 128*D1*Dd*K*f**2*r*s + 32*D1*Dd*K*f**2*r - 152*D1*Dd*K*f**2*s**2 + 140*D1*Dd*K*f**2*s - 38*D1*Dd*K*f**2 + 256*D1*Dd*K*f*fd*r*s - 96*D1*Dd*K*f*fd*r + 304*D1*Dd*K*f*fd*s**2 - 292*D1*Dd*K*f*fd*s + 70*D1*Dd*K*f*fd - 48*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r + 48*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3 + 72*D1*Dd*f**2*fd*r - 432*D1*Dd*f**2*fd*s**2 + 252*D1*Dd*f**2*fd*s - 72*D1*Dd*f**2*fd + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r + 32*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 8*D1*Dd*f**2 - 32*D1*Dd*f*fd*r*s + 12*D1*Dd*f*fd*r - 64*D1*Dd*f*fd*s**2 + 56*D1*Dd*f*fd*s - 12*D1*Dd*f*fd + 64*D1*Ddd*K*f**2*r*s - 16*D1*Ddd*K*f**2*r + 76*D1*Ddd*K*f**2*s**2 - 70*D1*Ddd*K*f**2*s + 19*D1*Ddd*K*f**2 - 72*D1*Ddd*f**3*s**2 + 36*D1*Ddd*f**3*s - 18*D1*Ddd*f**3 - 8*D1*Ddd*f**2*r*s + 2*D1*Ddd*f**2*r - 16*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 4*D1*Ddd*f**2 + 2*D1*bd1*f*(D1*(f*(16*r*(s - 1) + 10*s**2 - 30*s + 13) - 2*fd*(4*r*(4*s - 1) + 10*s**2 - 13*s + 3)) + Dd*f*(-8*r*(8*s - 5) - 40*s**2 + 86*s - 31)) + 192*Dd**2*K*f**2*r*s - 48*Dd**2*K*f**2*r + 228*Dd**2*K*f**2*s**2 - 210*Dd**2*K*f**2*s + 32*Dd**2*K*f**2 - 216*Dd**2*f**3*s**2 + 108*Dd**2*f**3*s - 24*Dd**2*f**2*r*s + 6*Dd**2*f**2*r - 48*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s - 4*Dd**2*f**2))/(210*d**2*k3**4) + D1**2*Pk3*Pkd2*k1**2*k2*st**2*(-192*C*D1**2*bd1*f**2*r*s + 192*C*D1**2*bd1*f**2*r - 276*C*D1**2*bd1*f**2*s**2 + 552*C*D1**2*bd1*f**2*s - 276*C*D1**2*bd1*f**2 + 384*C*D1**2*bd1*f*fd*r*s - 192*C*D1**2*bd1*f*fd*r + 552*C*D1**2*bd1*f*fd*s**2 - 648*C*D1**2*bd1*f*fd*s + 96*C*D1**2*bd1*f*fd + 96*C*D1**2*bdd1*f**2*r*s - 96*C*D1**2*bdd1*f**2*r + 138*C*D1**2*bdd1*f**2*s**2 - 276*C*D1**2*bdd1*f**2*s + 138*C*D1**2*bdd1*f**2 + 144*C*D1**2*f**2*fd*r*s - 48*C*D1**2*f**2*fd*r - 48*C*D1**2*f**2*fd*s + 90*C*D1**2*f**2*fdd*s**2 - 60*C*D1**2*f**2*fdd*s + 30*C*D1**2*f**2*fdd + 180*C*D1**2*f*fd**2*s**2 - 120*C*D1**2*f*fd**2*s + 768*C*D1*Dd*bd1*f**2*r*s - 480*C*D1*Dd*bd1*f**2*r + 1104*C*D1*Dd*bd1*f**2*s**2 - 1572*C*D1*Dd*bd1*f**2*s + 468*C*D1*Dd*bd1*f**2 + 192*C*D1*Dd*f**3*r*s - 48*C*D1*Dd*f**3*r - 96*C*D1*Dd*f**3*s + 720*C*D1*Dd*f**2*fd*s**2 - 420*C*D1*Dd*f**2*fd*s + 60*C*D1*Dd*f**2*fd + 120*C*D1*Ddd*f**3*s**2 - 60*C*D1*Ddd*f**3*s + 30*C*D1*Ddd*f**3 + 360*C*Dd**2*f**3*s**2 - 180*C*Dd**2*f**3*s + 224*D1**2*K*bd1**2*f*r*s - 112*D1**2*K*bd1**2*f*r + 322*D1**2*K*bd1**2*f*s**2 - 434*D1**2*K*bd1**2*f*s + 112*D1**2*K*bd1**2*f + 56*D1**2*K*bd1*f**2*r*s - 56*D1**2*K*bd1*f**2*s + 140*D1**2*K*bd1*f*fd*s**2 - 70*D1**2*K*bd1*f*fd*s + 35*D1**2*K*bdd1*f**2*s**2 - 252*D1**2*bd1**2*f**2*r*s + 126*D1**2*bd1**2*f**2*r - 210*D1**2*bd1**2*f**2*s**2 + 336*D1**2*bd1**2*f**2*s - 126*D1**2*bd1**2*f**2 - 28*D1**2*bd1**2*f*r*s + 14*D1**2*bd1**2*f*r - 56*D1**2*bd1**2*f*s**2 + 70*D1**2*bd1**2*f*s - 14*D1**2*bd1**2*f + 168*D1**2*bd1*bd2*f*r*s - 84*D1**2*bd1*bd2*f*r + 168*D1**2*bd1*bd2*f*s**2 - 252*D1**2*bd1*bd2*f*s + 84*D1**2*bd1*bd2*f + 94*D1**2*bd1*f**2*r*s - 108*D1**2*bd1*f**2*r + 162*D1**2*bd1*f**2*s**2 - 310*D1**2*bd1*f**2*s + 162*D1**2*bd1*f**2 - 216*D1**2*bd1*f*fd*r*s + 108*D1**2*bd1*f*fd*r - 324*D1**2*bd1*f*fd*s**2 + 378*D1**2*bd1*f*fd*s - 54*D1**2*bd1*f*fd + 448*D1**2*bd1*f*g2*r*s - 448*D1**2*bd1*f*g2*r + 644*D1**2*bd1*f*g2*s**2 - 1288*D1**2*bd1*f*g2*s + 644*D1**2*bd1*f*g2 - 448*D1**2*bd1*f*gd2*r*s + 224*D1**2*bd1*f*gd2*r - 644*D1**2*bd1*f*gd2*s**2 + 868*D1**2*bd1*f*gd2*s - 224*D1**2*bd1*f*gd2 - 448*D1**2*bd1*fd*g2*r*s + 224*D1**2*bd1*fd*g2*r - 644*D1**2*bd1*fd*g2*s**2 + 644*D1**2*bd1*fd*g2*s + 28*D1**2*bd2*f**2*r*s + 28*D1**2*bd2*f**2*s**2 - 28*D1**2*bd2*f**2*s - 54*D1**2*bdd1*f**2*r*s + 54*D1**2*bdd1*f**2*r - 81*D1**2*bdd1*f**2*s**2 + 162*D1**2*bdd1*f**2*s - 81*D1**2*bdd1*f**2 - 224*D1**2*bdd1*f*g2*r*s + 224*D1**2*bdd1*f*g2*r - 322*D1**2*bdd1*f*g2*s**2 + 644*D1**2*bdd1*f*g2*s - 322*D1**2*bdd1*f*g2 - 90*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s - 45*D1**2*f**2*fdd*s**2 + 30*D1**2*f**2*fdd*s - 15*D1**2*f**2*fdd - 112*D1**2*f**2*gd2*r*s + 112*D1**2*f**2*gd2*s - 70*D1**2*f**2*gdd2*s**2 - 90*D1**2*f*fd**2*s**2 + 60*D1**2*f*fd**2*s - 224*D1**2*f*fd*g2*r*s + 112*D1**2*f*fd*g2*r - 280*D1**2*f*fd*gd2*s**2 + 140*D1**2*f*fd*gd2*s - 140*D1**2*f*fdd*g2*s**2 + 140*D1**2*f*fdd*g2*s - 70*D1**2*f*fdd*g2 - 140*D1**2*fd**2*g2*s**2 + 140*D1**2*fd**2*g2*s + 280*D1*Dd*K*bd1*f**2*s**2 - 70*D1*Dd*K*bd1*f**2*s - 432*D1*Dd*bd1*f**2*r*s + 270*D1*Dd*bd1*f**2*r - 648*D1*Dd*bd1*f**2*s**2 + 918*D1*Dd*bd1*f**2*s - 270*D1*Dd*bd1*f**2 - 1792*D1*Dd*bd1*f*g2*r*s + 1120*D1*Dd*bd1*f*g2*r - 2576*D1*Dd*bd1*f*g2*s**2 + 3668*D1*Dd*bd1*f*g2*s - 1092*D1*Dd*bd1*f*g2 - 120*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r + 60*D1*Dd*f**3*s - 360*D1*Dd*f**2*fd*s**2 + 210*D1*Dd*f**2*fd*s - 30*D1*Dd*f**2*fd - 448*D1*Dd*f**2*g2*r*s + 112*D1*Dd*f**2*g2*r + 224*D1*Dd*f**2*g2*s - 560*D1*Dd*f**2*gd2*s**2 + 140*D1*Dd*f**2*gd2*s - 1120*D1*Dd*f*fd*g2*s**2 + 840*D1*Dd*f*fd*g2*s - 140*D1*Dd*f*fd*g2 - 60*D1*Ddd*f**3*s**2 + 30*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 - 280*D1*Ddd*f**2*g2*s**2 + 140*D1*Ddd*f**2*g2*s - 70*D1*Ddd*f**2*g2 - 84*D1*b2*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) + 28*D1*b2*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 180*Dd**2*f**3*s**2 + 90*Dd**2*f**3*s - 840*Dd**2*f**2*g2*s**2 + 420*Dd**2*f**2*g2*s - 56*b1**3*(D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r - 8*s**2 + 8*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) - 7*b1**2*(32*D1**2*K*fd*r*s + 46*D1**2*K*fd*s**2 - 16*D1**2*K*fdd*r*s - 23*D1**2*K*fdd*s**2 - 8*D1**2*bdd1*f*(3*r*s - r + 3*s**2 - 3*s + 1) - 20*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + 14*D1**2*f*fd*s - 4*D1**2*f*fd + 36*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 36*D1**2*fd**2*r*s + 30*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 4*D1**2*fd*r*s - 8*D1**2*fd*s**2 + 2*D1**2*fdd*r*s + 4*D1**2*fdd*s**2 + 128*D1*Dd*K*f*r*s - 32*D1*Dd*K*f*r + 184*D1*Dd*K*f*s**2 - 156*D1*Dd*K*f*s + 46*D1*Dd*K*f - 128*D1*Dd*K*fd*r*s + 16*D1*Dd*K*fd*r - 184*D1*Dd*K*fd*s**2 + 78*D1*Dd*K*fd*s - 40*D1*Dd*f**2*r*s + 10*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 28*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 288*D1*Dd*f*fd*r*s - 36*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 204*D1*Dd*f*fd*s + 18*D1*Dd*f*fd - 16*D1*Dd*f*r*s + 4*D1*Dd*f*r - 32*D1*Dd*f*s**2 + 24*D1*Dd*f*s - 8*D1*Dd*f + 16*D1*Dd*fd*r*s - 2*D1*Dd*fd*r + 32*D1*Dd*fd*s**2 - 12*D1*Dd*fd*s - 64*D1*Ddd*K*f*r*s + 16*D1*Ddd*K*f*r - 92*D1*Ddd*K*f*s**2 + 78*D1*Ddd*K*f*s - 23*D1*Ddd*K*f + 72*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 66*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 8*D1*Ddd*f*r*s - 2*D1*Ddd*f*r + 16*D1*Ddd*f*s**2 - 12*D1*Ddd*f*s + 4*D1*Ddd*f + 8*D1*bd1*(D1*(f*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + fd*(-6*r*s + r - 6*s**2 + 6*s - 1)) + Dd*f*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) - 192*Dd**2*K*f*r*s + 48*Dd**2*K*f*r - 276*Dd**2*K*f*s**2 + 234*Dd**2*K*f*s - 32*Dd**2*K*f + 216*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 198*Dd**2*f**2*s + 36*Dd**2*f**2 + 24*Dd**2*f*r*s - 6*Dd**2*f*r + 48*Dd**2*f*s**2 - 36*Dd**2*f*s + 4*Dd**2*f) + b1*(-384*C*D1**2*f*fd*r*s - 552*C*D1**2*f*fd*s**2 + 192*C*D1**2*f*fd*s + 192*C*D1**2*f*fdd*r*s + 276*C*D1**2*f*fdd*s**2 - 96*C*D1**2*f*fdd*s + 192*C*D1**2*fd**2*r*s + 276*C*D1**2*fd**2*s**2 - 96*C*D1**2*fd**2*s - 768*C*D1*Dd*f**2*r*s + 192*C*D1*Dd*f**2*r - 1104*C*D1*Dd*f**2*s**2 + 936*C*D1*Dd*f**2*s - 276*C*D1*Dd*f**2 + 1536*C*D1*Dd*f*fd*r*s - 192*C*D1*Dd*f*fd*r + 2208*C*D1*Dd*f*fd*s**2 - 1320*C*D1*Dd*f*fd*s + 96*C*D1*Dd*f*fd + 384*C*D1*Ddd*f**2*r*s - 96*C*D1*Ddd*f**2*r + 552*C*D1*Ddd*f**2*s**2 - 468*C*D1*Ddd*f**2*s + 138*C*D1*Ddd*f**2 + 1152*C*Dd**2*f**2*r*s - 288*C*Dd**2*f**2*r + 1656*C*Dd**2*f**2*s**2 - 1404*C*Dd**2*f**2*s + 192*C*Dd**2*f**2 + 112*D1**2*K*f*fd*r*s - 56*D1**2*K*f*fd*r + 70*D1**2*K*f*fdd*s**2 - 70*D1**2*K*f*fdd*s + 35*D1**2*K*f*fdd + 70*D1**2*K*fd**2*s**2 - 70*D1**2*K*fd**2*s - 168*D1**2*b2*fd*r*s - 168*D1**2*b2*fd*s**2 + 84*D1**2*b2*fdd*r*s + 84*D1**2*b2*fdd*s**2 + 56*D1**2*bd1**2*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 168*D1**2*bd2*f*r*s - 168*D1**2*bd2*f*s**2 + 168*D1**2*bd2*f*s + 168*D1**2*bd2*fd*r*s + 168*D1**2*bd2*fd*s**2 - 84*D1**2*bd2*fd*s - 7*D1**2*bdd1*f*(K*(-32*r*s + 16*r - 46*s**2 + 62*s - 23) + 3*f*(6*r*(2*s - 1) + 10*s**2 - 16*s + 5) + 4*r*s - 2*r + 8*s**2 - 10*s + 4) + 84*D1**2*bdd2*f*r*s + 84*D1**2*bdd2*f*s**2 - 84*D1**2*bdd2*f*s + 188*D1**2*f*fd*r*s + 14*D1**2*f*fd*r + 324*D1**2*f*fd*s**2 - 108*D1**2*f*fd*s - 108*D1**2*f*fdd*r*s - 162*D1**2*f*fdd*s**2 + 54*D1**2*f*fdd*s + 448*D1**2*f*gd2*r*s + 644*D1**2*f*gd2*s**2 - 448*D1**2*f*gd2*s - 224*D1**2*f*gdd2*r*s - 322*D1**2*f*gdd2*s**2 + 224*D1**2*f*gdd2*s - 108*D1**2*fd**2*r*s - 162*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s + 448*D1**2*fd*g2*r*s + 644*D1**2*fd*g2*s**2 - 448*D1**2*fd*gd2*r*s - 644*D1**2*fd*gd2*s**2 + 224*D1**2*fd*gd2*s - 224*D1**2*fdd*g2*r*s - 322*D1**2*fdd*g2*s**2 + 224*D1*Dd*K*f**2*r*s - 56*D1*Dd*K*f**2*r - 112*D1*Dd*K*f**2*s + 560*D1*Dd*K*f*fd*s**2 - 420*D1*Dd*K*f*fd*s + 70*D1*Dd*K*f*fd - 672*D1*Dd*b2*f*r*s + 168*D1*Dd*b2*f*r - 672*D1*Dd*b2*f*s**2 + 672*D1*Dd*b2*f*s - 168*D1*Dd*b2*f + 672*D1*Dd*b2*fd*r*s - 84*D1*Dd*b2*fd*r + 672*D1*Dd*b2*fd*s**2 - 336*D1*Dd*b2*fd*s + 672*D1*Dd*bd2*f*r*s - 84*D1*Dd*bd2*f*r + 672*D1*Dd*bd2*f*s**2 - 672*D1*Dd*bd2*f*s + 84*D1*Dd*bd2*f + 376*D1*Dd*f**2*r*s - 94*D1*Dd*f**2*r + 648*D1*Dd*f**2*s**2 - 512*D1*Dd*f**2*s + 162*D1*Dd*f**2 - 864*D1*Dd*f*fd*r*s + 108*D1*Dd*f*fd*r - 1296*D1*Dd*f*fd*s**2 + 756*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 1792*D1*Dd*f*g2*r*s - 448*D1*Dd*f*g2*r + 2576*D1*Dd*f*g2*s**2 - 2184*D1*Dd*f*g2*s + 644*D1*Dd*f*g2 - 1792*D1*Dd*f*gd2*r*s + 224*D1*Dd*f*gd2*r - 2576*D1*Dd*f*gd2*s**2 + 1988*D1*Dd*f*gd2*s - 224*D1*Dd*f*gd2 - 1792*D1*Dd*fd*g2*r*s + 224*D1*Dd*fd*g2*r - 2576*D1*Dd*fd*g2*s**2 + 1092*D1*Dd*fd*g2*s + 140*D1*Ddd*K*f**2*s**2 - 70*D1*Ddd*K*f**2*s + 35*D1*Ddd*K*f**2 + 336*D1*Ddd*b2*f*r*s - 84*D1*Ddd*b2*f*r + 336*D1*Ddd*b2*f*s**2 - 336*D1*Ddd*b2*f*s + 84*D1*Ddd*b2*f - 216*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 324*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 81*D1*Ddd*f**2 - 896*D1*Ddd*f*g2*r*s + 224*D1*Ddd*f*g2*r - 1288*D1*Ddd*f*g2*s**2 + 1092*D1*Ddd*f*g2*s - 322*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(f**2*(r*(10*s - 3) + s*(4*s - 7)) + f*(K*(-32*r*s + 16*r - 46*s**2 + 62*s - 23) - 3*fd*(6*r*(4*s - 1) + 20*s**2 - 22*s + 3) + 4*r*s - 2*r + 8*s**2 - 10*s + 4) + fd*(r*(8*K - 1)*(4*s - 1) + s*(K*(46*s - 31) - 8*s + 5))) + Dd*f*(K*(16*r*(8*s - 3) + 184*s**2 - 202*s + 47) - 6*f*(3*r*(8*s - 3) + 20*s**2 - 27*s + 7) - 16*r*s + 6*r - 32*s**2 + 32*s - 7)) + 420*Dd**2*K*f**2*s**2 - 210*Dd**2*K*f**2*s + 1008*Dd**2*b2*f*r*s - 252*Dd**2*b2*f*r + 1008*Dd**2*b2*f*s**2 - 1008*Dd**2*b2*f*s + 168*Dd**2*b2*f - 648*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 972*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 108*Dd**2*f**2 - 2688*Dd**2*f*g2*r*s + 672*Dd**2*f*g2*r - 3864*Dd**2*f*g2*s**2 + 3276*Dd**2*f*g2*s - 448*Dd**2*f*g2))/(210*d**2*k3**4) + D1**2*Pk3*Pkd2*k1**2*k2*(20*D1*b1**3*(D1*fd*s*(r + s - 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*(s - 1)*(10*D1*K*bd1**2*f*s + 20*D1*b2*bd1*f*(r + s - 1) + D1*bdd1*f*(s - 1)*(f*(6*C - 3) - 10*g2) + 2*bd1*(D1*(3*f**2*(8*C*(r + s - 1) - 5*r - 4*s + 4) - 2*f*(fd*s*(3 - 6*C) + 20*g2*(r + s - 1) + 5*gd2*s) - 10*fd*g2*s) + Dd*f*(4*s - 1)*(f*(6*C - 3) - 10*g2))) + 5*b1**2*(4*D1**2*bd1*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + D1**2*s*(8*K*fd*s + K*fdd*s + fd*r*(8*K - 2)) + D1*(2*Dd*(K*fd*s*(4*s - 1) + f*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - 4*r*s + r + 2*s)) + Ddd*K*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*K*f*s*(2*s - 1)) + b1*(D1**2*(5*K*bdd1*f*(2*s**2 - 2*s + 1) + 10*bd1*(K*fd*s*(2*s - 1) + f*(4*K*(2*s - 1)*(r + s - 1) - 2*r*s + r + s)) + 2*s*(6*C*fd**2*s + 10*bd2*f*(r + s - 1) + f*(3*fd*(8*C*(2*r + 2*s - 1) - 10*r - 8*s + 5) - 40*gd2*(r + s - 1) + s*(6*C*fdd - 3*fdd - 5*gdd2)) - 3*fd**2*s - 40*fd*g2*r - 40*fd*g2*s - 10*fd*gd2*s - 5*fdd*g2*s)) + 20*D1*b2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*(2*Dd*(3*f**2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 5*r - 16*s**2 + 18*s - 4) + f*(-40*g2*(r*(4*s - 1) + (1 - 2*s)**2) + (4*s - 1)*(5*K*bd1*(2*s - 1) + s*(12*C*fd - 6*fd - 10*gd2))) + 10*fd*g2*s*(1 - 4*s)) + Ddd*f*(f*(6*C - 3) - 10*g2)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f*s*(2*s - 1)*(f*(6*C - 3) - 10*g2)))/(30*d**2*k3**4) + D1**2*Pk3*Pkd2*k1**2*st**4*(-60*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*s**2 - 20*C*D1**2*f**2*fdd*s + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*s**2 - 40*C*D1**2*f*fd**2*s - 80*C*D1*Dd*f**3*s**2 + 40*C*D1*Dd*f**3*s - 20*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*s**2 - 140*C*D1*Dd*f**2*fd*s + 20*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*s**2 - 20*C*D1*Ddd*f**3*s + 10*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*s**2 - 60*C*Dd**2*f**3*s - 30*D1**2*K*bd1*f**2*s**2 + 60*D1**2*K*bd1*f*fd*s**2 - 30*D1**2*K*bd1*f*fd*s + 15*D1**2*K*bdd1*f**2*s**2 - 60*D1**2*bd1**2*f**2*s**2 + 90*D1**2*bd1**2*f**2*s - 36*D1**2*bd1*f**3*r*s - 144*D1**2*bd1*f**3*s**2 + 18*D1**2*bd1*f**3*s + 216*D1**2*bd1*f**2*fd*r*s - 36*D1**2*bd1*f**2*fd*r + 486*D1**2*bd1*f**2*fd*s**2 - 270*D1**2*bd1*f**2*fd*s + 18*D1**2*bd1*f**2*fd - 12*D1**2*bd1*f**2*r*s - 24*D1**2*bd1*f**2*s**2 + 12*D1**2*bd1*f**2*s + 24*D1**2*bd1*f*fd*r*s - 6*D1**2*bd1*f*fd*r + 48*D1**2*bd1*f*fd*s**2 - 36*D1**2*bd1*f*fd*s + 6*D1**2*bd1*f*fd - 30*D1**2*bd2*f**2*s**2 + 60*D1**2*bd2*f*fd*s**2 - 30*D1**2*bd2*f*fd*s + 36*D1**2*bdd1*f**3*r*s + 81*D1**2*bdd1*f**3*s**2 - 18*D1**2*bdd1*f**3*s + 6*D1**2*bdd1*f**2*r*s + 12*D1**2*bdd1*f**2*s**2 - 6*D1**2*bdd1*f**2*s + 15*D1**2*bdd2*f**2*s**2 - 12*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 + 2*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r*s - 2*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 - D1**2*f**2*fdd + 60*D1**2*f**2*gd2*s**2 - 30*D1**2*f**2*gdd2*s**2 + 12*D1**2*f*fd**2*r*s - 4*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 2*D1**2*f*fd**2 + 120*D1**2*f*fd*g2*s**2 - 120*D1**2*f*fd*g2*s + 60*D1**2*f*fd*g2 - 120*D1**2*f*fd*gd2*s**2 + 60*D1**2*f*fd*gd2*s - 60*D1**2*f*fdd*g2*s**2 + 60*D1**2*f*fdd*g2*s - 30*D1**2*f*fdd*g2 - 60*D1**2*fd**2*g2*s**2 + 60*D1**2*fd**2*g2*s + 120*D1*Dd*K*bd1*f**2*s**2 - 30*D1*Dd*K*bd1*f**2*s + 288*D1*Dd*bd1*f**3*r*s - 36*D1*Dd*bd1*f**3*r + 648*D1*Dd*bd1*f**3*s**2 - 306*D1*Dd*bd1*f**3*s + 18*D1*Dd*bd1*f**3 + 48*D1*Dd*bd1*f**2*r*s - 6*D1*Dd*bd1*f**2*r + 96*D1*Dd*bd1*f**2*s**2 - 60*D1*Dd*bd1*f**2*s + 6*D1*Dd*bd1*f**2 + 120*D1*Dd*bd2*f**2*s**2 - 30*D1*Dd*bd2*f**2*s - 16*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 + 4*D1*Dd*f**3*s + 2*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r*s - 14*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 - 6*D1*Dd*f**2*fd*s + 4*D1*Dd*f**2*fd + 240*D1*Dd*f**2*g2*s**2 - 120*D1*Dd*f**2*g2*s + 60*D1*Dd*f**2*g2 - 240*D1*Dd*f**2*gd2*s**2 + 60*D1*Dd*f**2*gd2*s - 480*D1*Dd*f*fd*g2*s**2 + 360*D1*Dd*f*fd*g2*s - 60*D1*Dd*f*fd*g2 + 8*D1*Ddd*f**3*r*s - 2*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 - 2*D1*Ddd*f**3*s - D1*Ddd*f**3 - 120*D1*Ddd*f**2*g2*s**2 + 60*D1*Ddd*f**2*g2*s - 30*D1*Ddd*f**2*g2 + 24*Dd**2*f**3*r*s - 6*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 - 6*Dd**2*f**3*s + 4*Dd**2*f**3 - 360*Dd**2*f**2*g2*s**2 + 180*Dd**2*f**2*g2*s + 15*b1**2*(D1**2*(f*(2*fd - fdd)*(4*s**2 + 2*s - 1) - 2*fd**2*s*(2*s + 1)) + 2*D1*f*(Dd*(f*(8*s**2 - 4*s + 2) - 16*fd*s**2 + fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 12*Dd**2*f**2*s*(1 - 2*s)) + 3*b1*(-20*D1**2*K*f*fd*s**2 + 20*D1**2*K*f*fd*s - 10*D1**2*K*f*fd + 10*D1**2*K*f*fdd*s**2 - 10*D1**2*K*f*fdd*s + 5*D1**2*K*f*fdd + 10*D1**2*K*fd**2*s**2 - 10*D1**2*K*fd**2*s - 5*D1**2*bdd1*f**2*(4*s**2 - 6*s + 3) - 36*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 144*D1**2*f**2*fd*s**2 + 114*D1**2*f**2*fd*s - 48*D1**2*f**2*fd + 36*D1**2*f**2*fdd*r*s - 12*D1**2*f**2*fdd*r + 81*D1**2*f**2*fdd*s**2 - 72*D1**2*f**2*fdd*s + 27*D1**2*f**2*fdd + 72*D1**2*f*fd**2*r*s - 24*D1**2*f*fd**2*r + 162*D1**2*f*fd**2*s**2 - 144*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 16*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r + 8*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s + 4*D1**2*f*fdd + 4*D1**2*fd**2*r*s - 2*D1**2*fd**2*r + 8*D1**2*fd**2*s**2 - 8*D1**2*fd**2*s - 40*D1*Dd*K*f**2*s**2 + 20*D1*Dd*K*f**2*s - 10*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*s**2 - 60*D1*Dd*K*f*fd*s + 10*D1*Dd*K*f*fd - 48*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r - 192*D1*Dd*f**3*s**2 + 120*D1*Dd*f**3*s - 48*D1*Dd*f**3 + 288*D1*Dd*f**2*fd*r*s - 84*D1*Dd*f**2*fd*r + 648*D1*Dd*f**2*fd*s**2 - 522*D1*Dd*f**2*fd*s + 96*D1*Dd*f**2*fd - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 32*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 64*D1*Dd*f*fd*s**2 - 56*D1*Dd*f*fd*s + 12*D1*Dd*f*fd + 20*D1*Ddd*K*f**2*s**2 - 10*D1*Ddd*K*f**2*s + 5*D1*Ddd*K*f**2 + 48*D1*Ddd*f**3*r*s - 12*D1*Ddd*f**3*r + 108*D1*Ddd*f**3*s**2 - 78*D1*Ddd*f**3*s + 27*D1*Ddd*f**3 + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 16*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 4*D1*Ddd*f**2 + 10*D1*bd1*f*(D1*f*(4*s**2 - 6*s + 3) + 4*D1*fd*s*(1 - 2*s) + Dd*f*(-16*s**2 + 16*s - 3)) + 60*Dd**2*K*f**2*s**2 - 30*Dd**2*K*f**2*s + 144*Dd**2*f**3*r*s - 36*Dd**2*f**3*r + 324*Dd**2*f**3*s**2 - 234*Dd**2*f**3*s + 24*Dd**2*f**3 + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 48*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 4*Dd**2*f**2) - 15*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(210*d**2*k2*k3**2) + D1**2*Pk3*Pkd2*k1**2*st**2*(-12*C*D1**2*bd1*f**2*s**2 + 24*C*D1**2*bd1*f**2*s - 12*C*D1**2*bd1*f**2 + 24*C*D1**2*bd1*f*fd*s**2 - 24*C*D1**2*bd1*f*fd*s + 6*C*D1**2*bdd1*f**2*s**2 - 12*C*D1**2*bdd1*f**2*s + 6*C*D1**2*bdd1*f**2 + 144*C*D1**2*f**2*fd*s**2 - 96*C*D1**2*f**2*fd*s + 48*C*D1**2*f**2*fd - 90*C*D1**2*f**2*fdd*s**2 + 60*C*D1**2*f**2*fdd*s - 30*C*D1**2*f**2*fdd - 180*C*D1**2*f*fd**2*s**2 + 120*C*D1**2*f*fd**2*s + 48*C*D1*Dd*bd1*f**2*s**2 - 60*C*D1*Dd*bd1*f**2*s + 12*C*D1*Dd*bd1*f**2 + 192*C*D1*Dd*f**3*s**2 - 96*C*D1*Dd*f**3*s + 48*C*D1*Dd*f**3 - 720*C*D1*Dd*f**2*fd*s**2 + 420*C*D1*Dd*f**2*fd*s - 60*C*D1*Dd*f**2*fd - 120*C*D1*Ddd*f**3*s**2 + 60*C*D1*Ddd*f**3*s - 30*C*D1*Ddd*f**3 - 360*C*Dd**2*f**3*s**2 + 180*C*Dd**2*f**3*s + 14*D1**2*K*bd1**2*f*s**2 - 14*D1**2*K*bd1**2*f*s + 56*D1**2*K*bd1*f**2*s**2 - 140*D1**2*K*bd1*f*fd*s**2 + 70*D1**2*K*bd1*f*fd*s - 35*D1**2*K*bdd1*f**2*s**2 + 168*D1**2*bd1**2*f**2*r*s - 84*D1**2*bd1**2*f**2*r + 140*D1**2*bd1**2*f**2*s**2 - 252*D1**2*bd1**2*f**2*s + 42*D1**2*bd1**2*f**2 + 28*D1**2*bd1**2*f*r*s - 14*D1**2*bd1**2*f*r + 56*D1**2*bd1**2*f*s**2 - 70*D1**2*bd1**2*f*s + 14*D1**2*bd1**2*f + 14*D1**2*bd1*bd2*f*s**2 - 14*D1**2*bd1*bd2*f*s + 2*D1**2*bd1*f**2*r*s + 12*D1**2*bd1*f**2*r - 18*D1**2*bd1*f**2*s**2 + 22*D1**2*bd1*f**2*s - 18*D1**2*bd1*f**2 + 24*D1**2*bd1*f*fd*r*s - 12*D1**2*bd1*f*fd*r + 36*D1**2*bd1*f*fd*s**2 - 42*D1**2*bd1*f*fd*s + 6*D1**2*bd1*f*fd + 28*D1**2*bd1*f*g2*s**2 - 56*D1**2*bd1*f*g2*s + 28*D1**2*bd1*f*g2 - 28*D1**2*bd1*f*gd2*s**2 + 28*D1**2*bd1*f*gd2*s - 28*D1**2*bd1*fd*g2*s**2 + 28*D1**2*bd1*fd*g2*s + 56*D1**2*bd2*f**2*s**2 - 140*D1**2*bd2*f*fd*s**2 + 70*D1**2*bd2*f*fd*s + 6*D1**2*bdd1*f**2*r*s - 6*D1**2*bdd1*f**2*r + 9*D1**2*bdd1*f**2*s**2 - 18*D1**2*bdd1*f**2*s + 9*D1**2*bdd1*f**2 - 14*D1**2*bdd1*f*g2*s**2 + 28*D1**2*bdd1*f*g2*s - 14*D1**2*bdd1*f*g2 - 35*D1**2*bdd2*f**2*s**2 + 18*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r - 72*D1**2*f**2*fd*s**2 + 42*D1**2*f**2*fd*s - 24*D1**2*f**2*fd + 45*D1**2*f**2*fdd*s**2 - 30*D1**2*f**2*fdd*s + 15*D1**2*f**2*fdd - 112*D1**2*f**2*gd2*s**2 + 70*D1**2*f**2*gdd2*s**2 + 90*D1**2*f*fd**2*s**2 - 60*D1**2*f*fd**2*s - 224*D1**2*f*fd*g2*s**2 + 224*D1**2*f*fd*g2*s - 112*D1**2*f*fd*g2 + 280*D1**2*f*fd*gd2*s**2 - 140*D1**2*f*fd*gd2*s + 140*D1**2*f*fdd*g2*s**2 - 140*D1**2*f*fdd*g2*s + 70*D1**2*f*fdd*g2 + 140*D1**2*fd**2*g2*s**2 - 140*D1**2*fd**2*g2*s - 280*D1*Dd*K*bd1*f**2*s**2 + 70*D1*Dd*K*bd1*f**2*s + 48*D1*Dd*bd1*f**2*r*s - 30*D1*Dd*bd1*f**2*r + 72*D1*Dd*bd1*f**2*s**2 - 102*D1*Dd*bd1*f**2*s + 30*D1*Dd*bd1*f**2 - 112*D1*Dd*bd1*f*g2*s**2 + 140*D1*Dd*bd1*f*g2*s - 28*D1*Dd*bd1*f*g2 - 280*D1*Dd*bd2*f**2*s**2 + 70*D1*Dd*bd2*f**2*s + 24*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r - 96*D1*Dd*f**3*s**2 + 36*D1*Dd*f**3*s - 24*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*s**2 - 210*D1*Dd*f**2*fd*s + 30*D1*Dd*f**2*fd - 448*D1*Dd*f**2*g2*s**2 + 224*D1*Dd*f**2*g2*s - 112*D1*Dd*f**2*g2 + 560*D1*Dd*f**2*gd2*s**2 - 140*D1*Dd*f**2*gd2*s + 1120*D1*Dd*f*fd*g2*s**2 - 840*D1*Dd*f*fd*g2*s + 140*D1*Dd*f*fd*g2 + 60*D1*Ddd*f**3*s**2 - 30*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 280*D1*Ddd*f**2*g2*s**2 - 140*D1*Ddd*f**2*g2*s + 70*D1*Ddd*f**2*g2 + 180*Dd**2*f**3*s**2 - 90*Dd**2*f**3*s + 840*Dd**2*f**2*g2*s**2 - 420*Dd**2*f**2*g2*s - 7*b1**3*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 7*b1**2*(2*D1**2*K*fd*s**2 - D1**2*K*fdd*s**2 - D1**2*bdd1*f*(3*s**2 - 2*s + 1) + 24*D1**2*f*fd*r*s + 32*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s - 8*D1**2*f*fd - 24*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*s**2 + 8*D1**2*f*fdd*s + 5*D1**2*f*fdd - 24*D1**2*fd**2*r*s - 20*D1**2*fd**2*s**2 + 8*D1**2*fd**2*s + 4*D1**2*fd*r*s + 8*D1**2*fd*s**2 - 2*D1**2*fdd*r*s - 4*D1**2*fdd*s**2 + 8*D1*Dd*K*f*s**2 - 4*D1*Dd*K*f*s + 2*D1*Dd*K*f - 8*D1*Dd*K*fd*s**2 + 2*D1*Dd*K*fd*s + 48*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 64*D1*Dd*f**2*s**2 - 56*D1*Dd*f**2*s + 16*D1*Dd*f**2 - 192*D1*Dd*f*fd*r*s + 24*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 120*D1*Dd*f*fd*s - 8*D1*Dd*f*fd + 16*D1*Dd*f*r*s - 4*D1*Dd*f*r + 32*D1*Dd*f*s**2 - 24*D1*Dd*f*s + 8*D1*Dd*f - 16*D1*Dd*fd*r*s + 2*D1*Dd*fd*r - 32*D1*Dd*fd*s**2 + 12*D1*Dd*fd*s - 4*D1*Ddd*K*f*s**2 + 2*D1*Ddd*K*f*s - D1*Ddd*K*f - 48*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 44*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 - 8*D1*Ddd*f*r*s + 2*D1*Ddd*f*r - 16*D1*Ddd*f*s**2 + 12*D1*Ddd*f*s - 4*D1*Ddd*f + 2*D1*bd1*(D1*f*(3*s**2 - 2*s + 1) + D1*fd*s*(1 - 3*s) + Dd*f*(-12*s**2 + 7*s - 1)) - 12*Dd**2*K*f*s**2 + 6*Dd**2*K*f*s - 144*Dd**2*f**2*r*s + 36*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 132*Dd**2*f**2*s - 24*Dd**2*f**2 - 24*Dd**2*f*r*s + 6*Dd**2*f*r - 48*Dd**2*f*s**2 + 36*Dd**2*f*s - 4*Dd**2*f) + b1*(-24*C*D1**2*f*fd*s**2 + 12*C*D1**2*f*fdd*s**2 + 12*C*D1**2*fd**2*s**2 - 48*C*D1*Dd*f**2*s**2 + 24*C*D1*Dd*f**2*s - 12*C*D1*Dd*f**2 + 96*C*D1*Dd*f*fd*s**2 - 24*C*D1*Dd*f*fd*s + 24*C*D1*Ddd*f**2*s**2 - 12*C*D1*Ddd*f**2*s + 6*C*D1*Ddd*f**2 + 72*C*Dd**2*f**2*s**2 - 36*C*Dd**2*f**2*s + 112*D1**2*K*f*fd*s**2 - 112*D1**2*K*f*fd*s + 56*D1**2*K*f*fd - 70*D1**2*K*f*fdd*s**2 + 70*D1**2*K*f*fdd*s - 35*D1**2*K*f*fdd - 70*D1**2*K*fd**2*s**2 + 70*D1**2*K*fd**2*s - 14*D1**2*b2*fd*s**2 + 7*D1**2*b2*fdd*s**2 + 14*D1**2*bd1**2*f*s*(3*s - 2) - 14*D1**2*bd2*f*s**2 + 14*D1**2*bd2*fd*s**2 + 7*D1**2*bdd1*f*(2*K*s**2 - 2*K*s + K + f*(24*r*s - 12*r + 20*s**2 - 36*s + 15) + 4*r*s - 2*r + 8*s**2 - 10*s + 4) + 7*D1**2*bdd2*f*s**2 + 4*D1**2*f*fd*r*s - 14*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s + 12*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*s**2 - 6*D1**2*f*fdd*s + 28*D1**2*f*gd2*s**2 - 14*D1**2*f*gdd2*s**2 + 12*D1**2*fd**2*r*s + 18*D1**2*fd**2*s**2 - 6*D1**2*fd**2*s + 28*D1**2*fd*g2*s**2 - 28*D1**2*fd*gd2*s**2 - 14*D1**2*fdd*g2*s**2 + 224*D1*Dd*K*f**2*s**2 - 112*D1*Dd*K*f**2*s + 56*D1*Dd*K*f**2 - 560*D1*Dd*K*f*fd*s**2 + 420*D1*Dd*K*f*fd*s - 70*D1*Dd*K*f*fd - 56*D1*Dd*b2*f*s**2 + 28*D1*Dd*b2*f*s - 14*D1*Dd*b2*f + 56*D1*Dd*b2*fd*s**2 - 14*D1*Dd*b2*fd*s + 56*D1*Dd*bd2*f*s**2 - 14*D1*Dd*bd2*f*s + 8*D1*Dd*f**2*r*s - 2*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 18*D1*Dd*f**2 + 96*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 84*D1*Dd*f*fd*s + 6*D1*Dd*f*fd + 112*D1*Dd*f*g2*s**2 - 56*D1*Dd*f*g2*s + 28*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*s**2 + 28*D1*Dd*f*gd2*s - 112*D1*Dd*fd*g2*s**2 + 28*D1*Dd*fd*g2*s - 140*D1*Ddd*K*f**2*s**2 + 70*D1*Ddd*K*f**2*s - 35*D1*Ddd*K*f**2 + 28*D1*Ddd*b2*f*s**2 - 14*D1*Ddd*b2*f*s + 7*D1*Ddd*b2*f + 24*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 - 56*D1*Ddd*f*g2*s**2 + 28*D1*Ddd*f*g2*s - 14*D1*Ddd*f*g2 - 14*D1*bd1*(D1*(f**2*(6*r*(2*s - 1) + 16*s**2 - 27*s + 12) + f*(2*K*s**2 - 2*K*s + K + fd*(-48*r*s + 12*r - 40*s**2 + 44*s - 9) + 4*r*s - 2*r + 8*s**2 - 10*s + 4) + fd*(-4*r*s + r + s*(-2*K*s + K - 8*s + 5))) - Dd*f*(8*K*s**2 - 6*K*s + K + 2*f*(6*r*(8*s - 3) + 40*s**2 - 58*s + 15) + 16*r*s - 6*r + 32*s**2 - 32*s + 7)) - 420*Dd**2*K*f**2*s**2 + 210*Dd**2*K*f**2*s + 84*Dd**2*b2*f*s**2 - 42*Dd**2*b2*f*s + 72*Dd**2*f**2*r*s - 18*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 12*Dd**2*f**2 - 168*Dd**2*f*g2*s**2 + 84*Dd**2*f*g2*s) - 7*b2*(-D1**2*bdd1*f*(s - 1)**2 - 16*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 10*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s - 32*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 80*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 10*D1*Dd*f*fd + 20*D1*Ddd*f**2*s**2 - 10*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) + 60*Dd**2*f**2*s**2 - 30*Dd**2*f**2*s))/(210*d**2*k2*k3**2) - D1**2*Pk3*Pkd2*k1**2*(D1*(s - 1)*(D1*bdd1*f*(s - 1)*(f*(6*C - 3) - 10*g2) + 5*b2*(D1*bdd1*f*(s - 1) + 2*bd1*(D1*fd*s + Dd*f*(4*s - 1))) + 2*bd1*(D1*(-3*f**2*r + f*s*(12*C*fd + 5*K*bd1 + 5*bd2 - 6*fd - 10*gd2) - 10*fd*g2*s) + Dd*f*(4*s - 1)*(f*(6*C - 3) - 10*g2))) + 5*b1**3*(D1**2*fdd*s**2 + 2*D1*Dd*fd*s*(4*s - 1) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1)) + 5*b1**2*(D1**2*K*fdd*s**2 + D1**2*bdd1*f*(3*s**2 - 2*s + 1) - 2*D1**2*fd*r*s + 8*D1*Dd*K*fd*s**2 - 2*D1*Dd*K*fd*s - 8*D1*Dd*f*r*s + 2*D1*Dd*f*r + 4*D1*Dd*f*s + 4*D1*Ddd*K*f*s**2 - 2*D1*Ddd*K*f*s + D1*Ddd*K*f + 2*D1*bd1*(3*s - 1)*(D1*fd*s + Dd*f*(4*s - 1)) + 12*Dd**2*K*f*s**2 - 6*Dd**2*K*f*s) + b1*(D1**2*(5*K*bdd1*f*(2*s**2 - 2*s + 1) + 10*bd1**2*f*s*(3*s - 2) + 10*bd1*(K*fd*s*(2*s - 1) + f*(-2*r*s + r + s)) + s*(f*fd*(6 - 12*r) + f*s*(12*C*fdd + 5*bdd2 - 6*fdd - 10*gdd2) + s*(10*bd2*fd + 2*fd**2*(6*C - 3) - 20*fd*gd2 - 10*fdd*g2))) + D1*(2*Dd*(5*K*bd1*f*(8*s**2 - 6*s + 1) + 3*f**2*(-4*r*s + r + 2*s) + f*s*(4*s - 1)*(12*C*fd + 5*bd2 - 6*fd - 10*gd2) + 10*fd*g2*s*(1 - 4*s)) + Ddd*f*(f*(6*C - 3) - 10*g2)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f*s*(2*s - 1)*(f*(6*C - 3) - 10*g2) + 5*b2*(D1**2*fdd*s**2 + 2*D1*Dd*fd*s*(4*s - 1) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1))))/(30*d**2*k2*k3**2) + 4*D1**2*Pk3*Pkd2*k2**5*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(2*C - 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-9*K*(-2*bd1 + bdd1) - 36*gd2 + 18*gdd2)) + f*(-fd**2*(2*C - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 9*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) + 9*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 9*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(4*C - 2)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(9*K*(b1*r*(8*s - 2) + 2*b1*(1 - 2*s)**2 + bd1*(-8*r*s + r - 8*s**2 + 8*s - 1)) - fd*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 36*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 18*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 18*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(2*C*f + 9*K*b1 - f - 18*g2)) - Dd**2*f**2*(2*C*f + 9*K*b1 - f - 18*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(63*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*k2**5*st**4*(8*C*D1**2*b1*f*fd*r*s + 8*C*D1**2*b1*f*fd*s**2 - 4*C*D1**2*b1*f*fd*s - 4*C*D1**2*b1*f*fdd*r*s - 4*C*D1**2*b1*f*fdd*s**2 + 2*C*D1**2*b1*f*fdd*s - 4*C*D1**2*b1*fd**2*r*s - 4*C*D1**2*b1*fd**2*s**2 + 2*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r*s + 2*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 6*C*D1**2*f**2*fd*s - 2*C*D1**2*f**2*fd + 16*C*D1*Dd*b1*f**2*r*s - 4*C*D1*Dd*b1*f**2*r + 16*C*D1*Dd*b1*f**2*s**2 - 16*C*D1*Dd*b1*f**2*s + 4*C*D1*Dd*b1*f**2 - 32*C*D1*Dd*b1*f*fd*r*s + 4*C*D1*Dd*b1*f*fd*r - 32*C*D1*Dd*b1*f*fd*s**2 + 24*C*D1*Dd*b1*f*fd*s - 2*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r*s + 2*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 8*C*D1*Dd*f**3*s - 2*C*D1*Dd*f**3 - 8*C*D1*Ddd*b1*f**2*r*s + 2*C*D1*Ddd*b1*f**2*r - 8*C*D1*Ddd*b1*f**2*s**2 + 8*C*D1*Ddd*b1*f**2*s - 2*C*D1*Ddd*b1*f**2 - 24*C*Dd**2*b1*f**2*r*s + 6*C*Dd**2*b1*f**2*r - 24*C*Dd**2*b1*f**2*s**2 + 24*C*Dd**2*b1*f**2*s - 4*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r*s + 7*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 7*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 4*D1**2*b1*f*fd*r*s - 4*D1**2*b1*f*fd*s**2 + 2*D1**2*b1*f*fd*s + 2*D1**2*b1*f*fdd*r*s + 2*D1**2*b1*f*fdd*s**2 - D1**2*b1*f*fdd*s - 28*D1**2*b1*f*gd2*r*s - 28*D1**2*b1*f*gd2*s**2 + 28*D1**2*b1*f*gd2*s + 14*D1**2*b1*f*gdd2*r*s + 14*D1**2*b1*f*gdd2*s**2 - 14*D1**2*b1*f*gdd2*s + 2*D1**2*b1*fd**2*r*s + 2*D1**2*b1*fd**2*s**2 - D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r*s + 28*D1**2*b1*fd*gd2*s**2 - 14*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(2*C - 1)*(s - 1) - 14*g2*(s - 1)) + 3*D1**2*f**2*fd*r*s - D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 3*D1**2*f**2*fd*s + D1**2*f**2*fd + 14*D1**2*f**2*gd2*r*s + 14*D1**2*f**2*gd2*s**2 - 14*D1**2*f**2*gd2*s + 28*D1**2*f*fd*g2*r*s - 14*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r*s - 14*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 56*D1*Dd*K*b1**2*f*s + 14*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r*s + 7*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 28*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r*s + 7*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 28*D1*Dd*K*b1*f**2*s - 7*D1*Dd*K*b1*f**2 - 8*D1*Dd*b1*f**2*r*s + 2*D1*Dd*b1*f**2*r - 8*D1*Dd*b1*f**2*s**2 + 8*D1*Dd*b1*f**2*s - 2*D1*Dd*b1*f**2 + 16*D1*Dd*b1*f*fd*r*s - 2*D1*Dd*b1*f*fd*r + 16*D1*Dd*b1*f*fd*s**2 - 12*D1*Dd*b1*f*fd*s + D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r*s + 28*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 112*D1*Dd*b1*f*g2*s - 28*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r*s - 14*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 112*D1*Dd*b1*f*gd2*s + 14*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r*s - 14*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 56*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r*s - D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s + D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r*s - 14*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 56*D1*Dd*f**2*g2*s + 14*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r*s + 7*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 28*D1*Ddd*K*b1**2*f*s - 7*D1*Ddd*K*b1**2*f + 4*D1*Ddd*b1*f**2*r*s - D1*Ddd*b1*f**2*r + 4*D1*Ddd*b1*f**2*s**2 - 4*D1*Ddd*b1*f**2*s + D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r*s - 14*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 56*D1*Ddd*b1*f*g2*s + 14*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(4*C*(s - 1) - s*(7*K + 2) + 2) + f*(-fd*(2*C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(-14*r - 14*s + 14)) + 7*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(-7*K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - f*(2*C - 1)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 14*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 84*Dd**2*K*b1**2*f*r*s + 21*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 84*Dd**2*K*b1**2*f*s - 14*Dd**2*K*b1**2*f + 12*Dd**2*b1*f**2*r*s - 3*Dd**2*b1*f**2*r + 12*Dd**2*b1*f**2*s**2 - 12*Dd**2*b1*f**2*s + 2*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r*s - 42*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 168*Dd**2*b1*f*g2*s + 28*Dd**2*b1*f*g2)/(35*d**2*k3**6) + D1**2*Pk3*Pkd2*k2**3*st**6*(-96*C*D1**2*f**2*fd*r*s + 32*C*D1**2*f**2*fd*r - 36*C*D1**2*f**2*fd*s**2 + 56*C*D1**2*f**2*fd*s - 12*C*D1**2*f**2*fd + 48*C*D1**2*f**2*fdd*r*s - 16*C*D1**2*f**2*fdd*r + 18*C*D1**2*f**2*fdd*s**2 - 28*C*D1**2*f**2*fdd*s + 6*C*D1**2*f**2*fdd + 96*C*D1**2*f*fd**2*r*s - 32*C*D1**2*f*fd**2*r + 36*C*D1**2*f*fd**2*s**2 - 56*C*D1**2*f*fd**2*s + 16*C*D1**2*f*fd**2 - 128*C*D1*Dd*f**3*r*s + 32*C*D1*Dd*f**3*r - 48*C*D1*Dd*f**3*s**2 + 88*C*D1*Dd*f**3*s - 12*C*D1*Dd*f**3 + 384*C*D1*Dd*f**2*fd*r*s - 112*C*D1*Dd*f**2*fd*r + 144*C*D1*Dd*f**2*fd*s**2 - 244*C*D1*Dd*f**2*fd*s + 60*C*D1*Dd*f**2*fd + 64*C*D1*Ddd*f**3*r*s - 16*C*D1*Ddd*f**3*r + 24*C*D1*Ddd*f**3*s**2 - 44*C*D1*Ddd*f**3*s + 6*C*D1*Ddd*f**3 + 192*C*Dd**2*f**3*r*s - 48*C*Dd**2*f**3*r + 72*C*Dd**2*f**3*s**2 - 132*C*Dd**2*f**3*s + 32*C*Dd**2*f**3 - 288*D1**2*K*b1*f*fd*r*s + 144*D1**2*K*b1*f*fd*r - 108*D1**2*K*b1*f*fd*s**2 + 108*D1**2*K*b1*f*fd*s - 54*D1**2*K*b1*f*fd + 144*D1**2*K*b1*f*fdd*r*s - 72*D1**2*K*b1*f*fdd*r + 54*D1**2*K*b1*f*fdd*s**2 - 54*D1**2*K*b1*f*fdd*s + 27*D1**2*K*b1*f*fdd + 144*D1**2*K*b1*fd**2*r*s - 72*D1**2*K*b1*fd**2*r + 54*D1**2*K*b1*fd**2*s**2 - 54*D1**2*K*b1*fd**2*s + 72*D1**2*K*bdd1*f**2*r*s + 27*D1**2*K*bdd1*f**2*s**2 - 72*D1**2*K*bdd1*f**2*s + 54*D1**2*b1*f**2*fd*r*s - 18*D1**2*b1*f**2*fd*r - 18*D1**2*b1*f**2*fd*s - 54*D1**2*b1*f**2*fdd*r*s + 18*D1**2*b1*f**2*fdd*r + 18*D1**2*b1*f**2*fdd*s - 108*D1**2*b1*f*fd**2*r*s + 36*D1**2*b1*f*fd**2*r + 36*D1**2*b1*f*fd**2*s - 18*D1**2*b1*f*fd**2 + 72*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r - 36*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r - 72*D1**2*bd2*f**2*r*s - 72*D1**2*bd2*f**2*s**2 + 72*D1**2*bd2*f**2*s + 144*D1**2*bd2*f*fd*r*s - 36*D1**2*bd2*f*fd*r + 144*D1**2*bd2*f*fd*s**2 - 144*D1**2*bd2*f*fd*s + 36*D1**2*bd2*f*fd - 18*D1**2*bdd1*f**3*r*s + 18*D1**2*bdd1*f**3*s - 18*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*s + 36*D1**2*bdd2*f**2*r*s + 36*D1**2*bdd2*f**2*s**2 - 36*D1**2*bdd2*f**2*s + 60*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 32*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 30*D1**2*f**2*fdd*r*s + 10*D1**2*f**2*fdd*r - 9*D1**2*f**2*fdd*s**2 + 16*D1**2*f**2*fdd*s - 3*D1**2*f**2*fdd + 288*D1**2*f**2*gd2*r*s + 108*D1**2*f**2*gd2*s**2 - 288*D1**2*f**2*gd2*s - 144*D1**2*f**2*gdd2*r*s - 54*D1**2*f**2*gdd2*s**2 + 144*D1**2*f**2*gdd2*s - 60*D1**2*f*fd**2*r*s + 20*D1**2*f*fd**2*r - 18*D1**2*f*fd**2*s**2 + 32*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 576*D1**2*f*fd*g2*r*s - 288*D1**2*f*fd*g2*r + 216*D1**2*f*fd*g2*s**2 - 216*D1**2*f*fd*g2*s + 108*D1**2*f*fd*g2 - 576*D1**2*f*fd*gd2*r*s + 144*D1**2*f*fd*gd2*r - 216*D1**2*f*fd*gd2*s**2 + 396*D1**2*f*fd*gd2*s - 144*D1**2*f*fd*gd2 - 288*D1**2*f*fdd*g2*r*s + 144*D1**2*f*fdd*g2*r - 108*D1**2*f*fdd*g2*s**2 + 108*D1**2*f*fdd*g2*s - 54*D1**2*f*fdd*g2 - 288*D1**2*fd**2*g2*r*s + 144*D1**2*fd**2*g2*r - 108*D1**2*fd**2*g2*s**2 + 108*D1**2*fd**2*g2*s - 576*D1*Dd*K*b1*f**2*r*s + 144*D1*Dd*K*b1*f**2*r - 216*D1*Dd*K*b1*f**2*s**2 + 396*D1*Dd*K*b1*f**2*s - 54*D1*Dd*K*b1*f**2 + 1152*D1*Dd*K*b1*f*fd*r*s - 432*D1*Dd*K*b1*f*fd*r + 432*D1*Dd*K*b1*f*fd*s**2 - 612*D1*Dd*K*b1*f*fd*s + 198*D1*Dd*K*b1*f*fd + 72*D1*Dd*b1*f**3*r*s - 18*D1*Dd*b1*f**3*r - 36*D1*Dd*b1*f**3*s - 432*D1*Dd*b1*f**2*fd*r*s + 126*D1*Dd*b1*f**2*fd*r + 180*D1*Dd*b1*f**2*fd*s - 54*D1*Dd*b1*f**2*fd + 144*D1*Dd*b1*f**2*r*s - 36*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s - 288*D1*Dd*b1*f*fd*r*s + 108*D1*Dd*b1*f*fd*r + 72*D1*Dd*b1*f*fd*s - 36*D1*Dd*b1*f*fd + 288*D1*Dd*bd2*f**2*r*s - 36*D1*Dd*bd2*f**2*r + 288*D1*Dd*bd2*f**2*s**2 - 288*D1*Dd*bd2*f**2*s + 36*D1*Dd*bd2*f**2 + 80*D1*Dd*f**3*r*s - 20*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 52*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 240*D1*Dd*f**2*fd*r*s + 70*D1*Dd*f**2*fd*r - 72*D1*Dd*f**2*fd*s**2 + 142*D1*Dd*f**2*fd*s - 36*D1*Dd*f**2*fd + 1152*D1*Dd*f**2*g2*r*s - 288*D1*Dd*f**2*g2*r + 432*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 108*D1*Dd*f**2*g2 - 1152*D1*Dd*f**2*gd2*r*s + 144*D1*Dd*f**2*gd2*r - 432*D1*Dd*f**2*gd2*s**2 + 972*D1*Dd*f**2*gd2*s - 144*D1*Dd*f**2*gd2 - 2304*D1*Dd*f*fd*g2*r*s + 864*D1*Dd*f*fd*g2*r - 864*D1*Dd*f*fd*g2*s**2 + 1224*D1*Dd*f*fd*g2*s - 396*D1*Dd*f*fd*g2 + 288*D1*Ddd*K*b1*f**2*r*s - 72*D1*Ddd*K*b1*f**2*r + 108*D1*Ddd*K*b1*f**2*s**2 - 198*D1*Ddd*K*b1*f**2*s + 27*D1*Ddd*K*b1*f**2 - 72*D1*Ddd*b1*f**3*r*s + 18*D1*Ddd*b1*f**3*r + 36*D1*Ddd*b1*f**3*s - 72*D1*Ddd*b1*f**2*r*s + 18*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s - 40*D1*Ddd*f**3*r*s + 10*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 26*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 - 576*D1*Ddd*f**2*g2*r*s + 144*D1*Ddd*f**2*g2*r - 216*D1*Ddd*f**2*g2*s**2 + 396*D1*Ddd*f**2*g2*s - 54*D1*Ddd*f**2*g2 + 18*D1*bd1*f*(D1*(f*s*(K*(-8*r - 3*s + 8) + f*(r - 1) + 2*r - 2) + fd*(K*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + f*(-6*r*s + r + 4*s - 1) - 4*r*s + r + 2*s - 1)) + Dd*f*(K*(32*r*s - 4*r + 12*s**2 - 27*s + 4) + f*(-8*r*s + r + 6*s - 1) - 8*r*s + r + 6*s - 1)) + 864*Dd**2*K*b1*f**2*r*s - 216*Dd**2*K*b1*f**2*r + 324*Dd**2*K*b1*f**2*s**2 - 594*Dd**2*K*b1*f**2*s + 144*Dd**2*K*b1*f**2 - 216*Dd**2*b1*f**3*r*s + 54*Dd**2*b1*f**3*r + 108*Dd**2*b1*f**3*s - 36*Dd**2*b1*f**3 - 216*Dd**2*b1*f**2*r*s + 54*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s - 36*Dd**2*b1*f**2 - 120*Dd**2*f**3*r*s + 30*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 78*Dd**2*f**3*s - 20*Dd**2*f**3 - 1728*Dd**2*f**2*g2*r*s + 432*Dd**2*f**2*g2*r - 648*Dd**2*f**2*g2*s**2 + 1188*Dd**2*f**2*g2*s - 288*Dd**2*f**2*g2 - 36*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(126*d**2*k3**4) + D1**2*Pk3*Pkd2*k2**3*st**4*(-96*C*D1**2*b1*f*fd*r*s - 48*C*D1**2*b1*f*fd*r - 72*C*D1**2*b1*f*fd*s**2 - 48*C*D1**2*b1*f*fd*s + 48*C*D1**2*b1*f*fd + 48*C*D1**2*b1*f*fdd*r*s + 24*C*D1**2*b1*f*fdd*r + 36*C*D1**2*b1*f*fdd*s**2 + 24*C*D1**2*b1*f*fdd*s - 24*C*D1**2*b1*f*fdd + 48*C*D1**2*b1*fd**2*r*s + 24*C*D1**2*b1*fd**2*r + 36*C*D1**2*b1*fd**2*s**2 + 24*C*D1**2*b1*fd**2*s - 24*C*D1**2*b1*fd**2 + 24*C*D1**2*bdd1*f**2*r*s - 48*C*D1**2*bdd1*f**2*r + 18*C*D1**2*bdd1*f**2*s**2 - 84*C*D1**2*bdd1*f**2*s + 42*C*D1**2*bdd1*f**2 + 24*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r - 72*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 24*C*D1**2*f**2*fd + 168*C*D1**2*f**2*fdd*r*s - 56*C*D1**2*f**2*fdd*r + 162*C*D1**2*f**2*fdd*s**2 - 164*C*D1**2*f**2*fdd*s + 54*C*D1**2*f**2*fdd + 336*C*D1**2*f*fd**2*r*s - 112*C*D1**2*f*fd**2*r + 324*C*D1**2*f*fd**2*s**2 - 328*C*D1**2*f*fd**2*s + 56*C*D1**2*f*fd**2 - 192*C*D1*Dd*b1*f**2*r*s + 48*C*D1*Dd*b1*f**2*r - 144*C*D1*Dd*b1*f**2*s**2 + 168*C*D1*Dd*b1*f**2*s - 36*C*D1*Dd*b1*f**2 + 384*C*D1*Dd*b1*f*fd*r*s + 48*C*D1*Dd*b1*f*fd*r + 288*C*D1*Dd*b1*f*fd*s**2 - 72*C*D1*Dd*b1*f*fd*s - 72*C*D1*Dd*b1*f*fd + 32*C*D1*Dd*f**3*r*s - 8*C*D1*Dd*f**3*r - 96*C*D1*Dd*f**3*s**2 + 32*C*D1*Dd*f**3*s - 24*C*D1*Dd*f**3 + 1344*C*D1*Dd*f**2*fd*r*s - 392*C*D1*Dd*f**2*fd*r + 1296*C*D1*Dd*f**2*fd*s**2 - 1316*C*D1*Dd*f**2*fd*s + 276*C*D1*Dd*f**2*fd + 96*C*D1*Ddd*b1*f**2*r*s - 24*C*D1*Ddd*b1*f**2*r + 72*C*D1*Ddd*b1*f**2*s**2 - 84*C*D1*Ddd*b1*f**2*s + 18*C*D1*Ddd*b1*f**2 + 224*C*D1*Ddd*f**3*r*s - 56*C*D1*Ddd*f**3*r + 216*C*D1*Ddd*f**3*s**2 - 220*C*D1*Ddd*f**3*s + 54*C*D1*Ddd*f**3 + 288*C*Dd**2*b1*f**2*r*s - 72*C*Dd**2*b1*f**2*r + 216*C*Dd**2*b1*f**2*s**2 - 252*C*Dd**2*b1*f**2*s + 48*C*Dd**2*b1*f**2 + 672*C*Dd**2*f**3*r*s - 168*C*Dd**2*f**3*r + 648*C*Dd**2*f**3*s**2 - 660*C*Dd**2*f**3*s + 112*C*Dd**2*f**3 - 168*D1**2*K*b1**2*fd*r*s - 168*D1**2*K*b1**2*fd*r - 126*D1**2*K*b1**2*fd*s**2 - 336*D1**2*K*b1**2*fd*s + 168*D1**2*K*b1**2*fd + 84*D1**2*K*b1**2*fdd*r*s + 84*D1**2*K*b1**2*fdd*r + 63*D1**2*K*b1**2*fdd*s**2 + 168*D1**2*K*b1**2*fdd*s - 84*D1**2*K*b1**2*fdd + 168*D1**2*K*b1*bdd1*f*r*s - 168*D1**2*K*b1*bdd1*f*r + 126*D1**2*K*b1*bdd1*f*s**2 - 378*D1**2*K*b1*bdd1*f*s + 147*D1**2*K*b1*bdd1*f + 168*D1**2*K*b1*f*fd*r*s - 84*D1**2*K*b1*f*fd*r - 168*D1**2*K*b1*f*fd*s**2 + 168*D1**2*K*b1*f*fd*s - 84*D1**2*K*b1*f*fd + 168*D1**2*K*b1*f*fdd*r*s - 84*D1**2*K*b1*f*fdd*r + 378*D1**2*K*b1*f*fdd*s**2 - 378*D1**2*K*b1*f*fdd*s + 189*D1**2*K*b1*f*fdd + 168*D1**2*K*b1*fd**2*r*s - 84*D1**2*K*b1*fd**2*r + 378*D1**2*K*b1*fd**2*s**2 - 378*D1**2*K*b1*fd**2*s + 84*D1**2*K*bdd1*f**2*r*s + 189*D1**2*K*bdd1*f**2*s**2 - 84*D1**2*K*bdd1*f**2*s + 84*D1**2*b1**2*f*fd*r*s - 42*D1**2*b1**2*f*fd*s - 84*D1**2*b1**2*f*fdd*r*s + 42*D1**2*b1**2*f*fdd*s - 84*D1**2*b1**2*fd**2*r*s + 42*D1**2*b1**2*fd**2*s + 84*D1**2*b1**2*fd*r*s - 42*D1**2*b1**2*fdd*r*s - 168*D1**2*b1*bd2*f*r*s - 168*D1**2*b1*bd2*f*s**2 + 168*D1**2*b1*bd2*f*s + 168*D1**2*b1*bd2*fd*r*s + 168*D1**2*b1*bd2*fd*s**2 - 84*D1**2*b1*bd2*fd*s - 84*D1**2*b1*bdd1*f**2*r*s + 42*D1**2*b1*bdd1*f**2*r + 42*D1**2*b1*bdd1*f**2*s - 84*D1**2*b1*bdd1*f*r*s + 42*D1**2*b1*bdd1*f*r + 42*D1**2*b1*bdd1*f*s + 84*D1**2*b1*bdd2*f*r*s + 84*D1**2*b1*bdd2*f*s**2 - 84*D1**2*b1*bdd2*f*s - 12*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fd*s**2 + 12*D1**2*b1*f*fd*s - 24*D1**2*b1*f*fd - 36*D1**2*b1*f*fdd*r*s - 12*D1**2*b1*f*fdd*r - 18*D1**2*b1*f*fdd*s**2 - 6*D1**2*b1*f*fdd*s + 12*D1**2*b1*f*fdd + 336*D1**2*b1*f*gd2*r*s + 252*D1**2*b1*f*gd2*s**2 - 336*D1**2*b1*f*gd2*s - 168*D1**2*b1*f*gdd2*r*s - 126*D1**2*b1*f*gdd2*s**2 + 168*D1**2*b1*f*gdd2*s - 36*D1**2*b1*fd**2*r*s - 12*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 - 6*D1**2*b1*fd**2*s + 12*D1**2*b1*fd**2 + 336*D1**2*b1*fd*g2*r*s + 336*D1**2*b1*fd*g2*r + 252*D1**2*b1*fd*g2*s**2 + 672*D1**2*b1*fd*g2*s - 336*D1**2*b1*fd*g2 - 336*D1**2*b1*fd*gd2*r*s - 168*D1**2*b1*fd*gd2*r - 252*D1**2*b1*fd*gd2*s**2 - 168*D1**2*b1*fd*gd2*s + 168*D1**2*b1*fd*gd2 - 168*D1**2*b1*fdd*g2*r*s - 168*D1**2*b1*fdd*g2*r - 126*D1**2*b1*fdd*g2*s**2 - 336*D1**2*b1*fdd*g2*s + 168*D1**2*b1*fdd*g2 - 42*D1**2*bd1**2*f*(K*(-4*r*(s - 1) - 3*s**2 + 9*s - 4) + f*r*(2*s - 1) - f*s + f + 2*r*s - r - s + 1) + 84*D1**2*bd2*f**2*r*s + 84*D1**2*bd2*f**2*s**2 - 84*D1**2*bd2*f**2*s - 18*D1**2*bdd1*f**2*r*s + 30*D1**2*bdd1*f**2*r - 9*D1**2*bdd1*f**2*s**2 + 42*D1**2*bdd1*f**2*s - 21*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r*s + 336*D1**2*bdd1*f*g2*r - 126*D1**2*bdd1*f*g2*s**2 + 588*D1**2*bdd1*f*g2*s - 294*D1**2*bdd1*f*g2 - 30*D1**2*f**2*fd*r*s + 10*D1**2*f**2*fd*r + 36*D1**2*f**2*fd*s**2 - 14*D1**2*f**2*fd*s + 12*D1**2*f**2*fd - 84*D1**2*f**2*fdd*r*s + 28*D1**2*f**2*fdd*r - 81*D1**2*f**2*fdd*s**2 + 82*D1**2*f**2*fdd*s - 27*D1**2*f**2*fdd - 168*D1**2*f**2*gd2*r*s + 168*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s - 168*D1**2*f**2*gdd2*r*s - 378*D1**2*f**2*gdd2*s**2 + 168*D1**2*f**2*gdd2*s - 168*D1**2*f*fd**2*r*s + 56*D1**2*f*fd**2*r - 162*D1**2*f*fd**2*s**2 + 164*D1**2*f*fd**2*s - 28*D1**2*f*fd**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r + 336*D1**2*f*fd*g2*s**2 - 336*D1**2*f*fd*g2*s + 168*D1**2*f*fd*g2 - 672*D1**2*f*fd*gd2*r*s + 168*D1**2*f*fd*gd2*r - 1512*D1**2*f*fd*gd2*s**2 + 1092*D1**2*f*fd*gd2*s - 168*D1**2*f*fd*gd2 - 336*D1**2*f*fdd*g2*r*s + 168*D1**2*f*fdd*g2*r - 756*D1**2*f*fdd*g2*s**2 + 756*D1**2*f*fdd*g2*s - 378*D1**2*f*fdd*g2 - 336*D1**2*fd**2*g2*r*s + 168*D1**2*fd**2*g2*r - 756*D1**2*fd**2*g2*s**2 + 756*D1**2*fd**2*g2*s - 672*D1*Dd*K*b1**2*f*r*s + 168*D1*Dd*K*b1**2*f*r - 504*D1*Dd*K*b1**2*f*s**2 + 588*D1*Dd*K*b1**2*f*s - 126*D1*Dd*K*b1**2*f + 672*D1*Dd*K*b1**2*fd*r*s + 252*D1*Dd*K*b1**2*fd*r + 504*D1*Dd*K*b1**2*fd*s**2 + 378*D1*Dd*K*b1**2*fd*s - 336*D1*Dd*K*b1**2*fd + 336*D1*Dd*K*b1*f**2*r*s - 84*D1*Dd*K*b1*f**2*r - 336*D1*Dd*K*b1*f**2*s**2 - 84*D1*Dd*K*b1*f**2 + 1344*D1*Dd*K*b1*f*fd*r*s - 504*D1*Dd*K*b1*f*fd*r + 3024*D1*Dd*K*b1*f*fd*s**2 - 2604*D1*Dd*K*b1*f*fd*s + 546*D1*Dd*K*b1*f*fd + 168*D1*Dd*b1**2*f**2*r*s - 42*D1*Dd*b1**2*f**2*r - 84*D1*Dd*b1**2*f**2*s - 672*D1*Dd*b1**2*f*fd*r*s + 84*D1*Dd*b1**2*f*fd*r + 336*D1*Dd*b1**2*f*fd*s - 42*D1*Dd*b1**2*f*fd + 336*D1*Dd*b1**2*f*r*s - 84*D1*Dd*b1**2*f*r - 168*D1*Dd*b1**2*f*s - 336*D1*Dd*b1**2*fd*r*s + 42*D1*Dd*b1**2*fd*r + 84*D1*Dd*b1**2*fd*s + 672*D1*Dd*b1*bd2*f*r*s - 84*D1*Dd*b1*bd2*f*r + 672*D1*Dd*b1*bd2*f*s**2 - 672*D1*Dd*b1*bd2*f*s + 84*D1*Dd*b1*bd2*f - 24*D1*Dd*b1*f**2*r*s + 6*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s**2 - 24*D1*Dd*b1*f**2*s + 18*D1*Dd*b1*f**2 - 288*D1*Dd*b1*f*fd*r*s - 12*D1*Dd*b1*f*fd*r - 144*D1*Dd*b1*f*fd*s**2 + 84*D1*Dd*b1*f*fd*s + 30*D1*Dd*b1*f*fd + 1344*D1*Dd*b1*f*g2*r*s - 336*D1*Dd*b1*f*g2*r + 1008*D1*Dd*b1*f*g2*s**2 - 1176*D1*Dd*b1*f*g2*s + 252*D1*Dd*b1*f*g2 - 1344*D1*Dd*b1*f*gd2*r*s + 168*D1*Dd*b1*f*gd2*r - 1008*D1*Dd*b1*f*gd2*s**2 + 1260*D1*Dd*b1*f*gd2*s - 168*D1*Dd*b1*f*gd2 - 1344*D1*Dd*b1*fd*g2*r*s - 504*D1*Dd*b1*fd*g2*r - 1008*D1*Dd*b1*fd*g2*s**2 - 756*D1*Dd*b1*fd*g2*s + 672*D1*Dd*b1*fd*g2 - 40*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r + 48*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s + 12*D1*Dd*f**3 - 672*D1*Dd*f**2*fd*r*s + 196*D1*Dd*f**2*fd*r - 648*D1*Dd*f**2*fd*s**2 + 658*D1*Dd*f**2*fd*s - 138*D1*Dd*f**2*fd - 672*D1*Dd*f**2*g2*r*s + 168*D1*Dd*f**2*g2*r + 672*D1*Dd*f**2*g2*s**2 + 168*D1*Dd*f**2*g2 - 1344*D1*Dd*f**2*gd2*r*s + 168*D1*Dd*f**2*gd2*r - 3024*D1*Dd*f**2*gd2*s**2 + 1764*D1*Dd*f**2*gd2*s - 168*D1*Dd*f**2*gd2 - 2688*D1*Dd*f*fd*g2*r*s + 1008*D1*Dd*f*fd*g2*r - 6048*D1*Dd*f*fd*g2*s**2 + 5208*D1*Dd*f*fd*g2*s - 1092*D1*Dd*f*fd*g2 + 336*D1*Ddd*K*b1**2*f*r*s - 84*D1*Ddd*K*b1**2*f*r + 252*D1*Ddd*K*b1**2*f*s**2 - 294*D1*Ddd*K*b1**2*f*s + 63*D1*Ddd*K*b1**2*f + 336*D1*Ddd*K*b1*f**2*r*s - 84*D1*Ddd*K*b1*f**2*r + 756*D1*Ddd*K*b1*f**2*s**2 - 546*D1*Ddd*K*b1*f**2*s + 189*D1*Ddd*K*b1*f**2 - 168*D1*Ddd*b1**2*f**2*r*s + 42*D1*Ddd*b1**2*f**2*r + 84*D1*Ddd*b1**2*f**2*s - 168*D1*Ddd*b1**2*f*r*s + 42*D1*Ddd*b1**2*f*r + 84*D1*Ddd*b1**2*f*s - 72*D1*Ddd*b1*f**2*r*s + 18*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s**2 + 54*D1*Ddd*b1*f**2*s - 9*D1*Ddd*b1*f**2 - 672*D1*Ddd*b1*f*g2*r*s + 168*D1*Ddd*b1*f*g2*r - 504*D1*Ddd*b1*f*g2*s**2 + 588*D1*Ddd*b1*f*g2*s - 126*D1*Ddd*b1*f*g2 - 112*D1*Ddd*f**3*r*s + 28*D1*Ddd*f**3*r - 108*D1*Ddd*f**3*s**2 + 110*D1*Ddd*f**3*s - 27*D1*Ddd*f**3 - 672*D1*Ddd*f**2*g2*r*s + 168*D1*Ddd*f**2*g2*r - 1512*D1*Ddd*f**2*g2*s**2 + 1092*D1*Ddd*f**2*g2*s - 378*D1*Ddd*f**2*g2 + 6*D1*bd1*(-8*C*D1*f**2*r*s + 16*C*D1*f**2*r - 6*C*D1*f**2*s**2 + 28*C*D1*f**2*s - 14*C*D1*f**2 + 16*C*D1*f*fd*r*s - 12*C*D1*f*fd*r + 12*C*D1*f*fd*s**2 - 24*C*D1*f*fd*s + 8*C*D1*f*fd + 32*C*Dd*f**2*r*s - 36*C*Dd*f**2*r + 24*C*Dd*f**2*s**2 - 70*C*Dd*f**2*s + 30*C*Dd*f**2 + 14*D1*K*f**2*r*s - 14*D1*K*f**2*s**2 - 14*D1*K*f**2*s + 56*D1*K*f*fd*r*s - 14*D1*K*f*fd*r + 126*D1*K*f*fd*s**2 - 91*D1*K*f*fd*s + 14*D1*K*f*fd + 14*D1*bd2*f*(2*s - 1)*(r + s - 1) - D1*f**2*r*s - 10*D1*f**2*r + 3*D1*f**2*s**2 - 7*D1*f**2*s + 7*D1*f**2 - 12*D1*f*fd*r*s + 8*D1*f*fd*r - 6*D1*f*fd*s**2 + 13*D1*f*fd*s - 5*D1*f*fd + 56*D1*f*g2*r*s - 112*D1*f*g2*r + 42*D1*f*g2*s**2 - 196*D1*f*g2*s + 98*D1*f*g2 - 56*D1*f*gd2*r*s + 56*D1*f*gd2*r - 42*D1*f*gd2*s**2 + 126*D1*f*gd2*s - 56*D1*f*gd2 - 56*D1*fd*g2*r*s + 28*D1*fd*g2*r - 42*D1*fd*g2*s**2 + 42*D1*fd*g2*s + 112*Dd*K*f**2*r*s - 14*Dd*K*f**2*r + 252*Dd*K*f**2*s**2 - 147*Dd*K*f**2*s + 14*Dd*K*f**2 - 24*Dd*f**2*r*s + 23*Dd*f**2*r - 12*Dd*f**2*s**2 + 37*Dd*f**2*s - 17*Dd*f**2 - 224*Dd*f*g2*r*s + 252*Dd*f*g2*r - 168*Dd*f*g2*s**2 + 490*Dd*f*g2*s - 210*Dd*f*g2 - 7*b1*(D1*(f**2*(-2*r*s + r + s) + f*(K*(8*r*(s - 1) + 6*s**2 - 18*s + 7) + fd*(2*r - 1)*(4*s - 1) - 4*r*s + 2*r + 2*s) - fd*(K*(6*s**2 + s*(8*r - 1) - 2) - 4*r*s + r + s)) + Dd*f*(K*(-32*r*s + 20*r - 24*s**2 + 50*s - 17) + f*(2*r - 1)*(8*s - 3) + (2*r - 1)*(8*s - 3)))) + 1008*Dd**2*K*b1**2*f*r*s - 252*Dd**2*K*b1**2*f*r + 756*Dd**2*K*b1**2*f*s**2 - 882*Dd**2*K*b1**2*f*s + 168*Dd**2*K*b1**2*f + 1008*Dd**2*K*b1*f**2*r*s - 252*Dd**2*K*b1*f**2*r + 2268*Dd**2*K*b1*f**2*s**2 - 1638*Dd**2*K*b1*f**2*s + 168*Dd**2*K*b1*f**2 - 504*Dd**2*b1**2*f**2*r*s + 126*Dd**2*b1**2*f**2*r + 252*Dd**2*b1**2*f**2*s - 84*Dd**2*b1**2*f**2 - 504*Dd**2*b1**2*f*r*s + 126*Dd**2*b1**2*f*r + 252*Dd**2*b1**2*f*s - 84*Dd**2*b1**2*f - 216*Dd**2*b1*f**2*r*s + 54*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s**2 + 162*Dd**2*b1*f**2*s - 36*Dd**2*b1*f**2 - 2016*Dd**2*b1*f*g2*r*s + 504*Dd**2*b1*f*g2*r - 1512*Dd**2*b1*f*g2*s**2 + 1764*Dd**2*b1*f*g2*s - 336*Dd**2*b1*f*g2 - 336*Dd**2*f**3*r*s + 84*Dd**2*f**3*r - 324*Dd**2*f**3*s**2 + 330*Dd**2*f**3*s - 56*Dd**2*f**3 - 2016*Dd**2*f**2*g2*r*s + 504*Dd**2*f**2*g2*r - 4536*Dd**2*f**2*g2*s**2 + 3276*Dd**2*f**2*g2*s - 336*Dd**2*f**2*g2 - 84*b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(210*d**2*k3**4) + D1**2*Pk3*Pkd2*k2**3*st**2*(D1*(140*D1*b2*bd1*f*(s - 1)*(r + s - 1) + 14*D1*bd1**2*(5*K*f*(r*(4*s - 2) + 5*s**2 - 7*s + 2) - f*(4*C - 2)*(r*(2*s - 1) + s*(2*s - 2)) + 20*g2*r*(2*s - 1) + 40*g2*s*(s - 1)) + 5*D1*bdd1*f*(s - 1)*(f*(2*C - 1)*(12*r + 7*s - 7) - 14*g2*(4*r + 5*s - 5)) - 2*bd1*(D1*(f**2*(4*C*(2*r*s + 5*r + 14*s - 7) + 3*r*s - 17*r - 28*s + 14) - 10*f*(fd*(2*C - 1)*(6*r*(2*s - 1) + 7*s**2 - 10*s + 3) + 14*g2*(r + 2*s - 1) + 7*gd2*(-4*r*s + 2*r - 5*s**2 + 7*s - 2)) + 70*fd*g2*(r*(4*s - 2) + s*(5*s - 5))) - 5*Dd*f*(f*(2*C - 1)*(6*r*(8*s - 5) + 28*s**2 - 47*s + 19) - 14*g2*(2*r*(8*s - 5) + 20*s**2 - 29*s + 9)))) + 140*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 7*b1**2*(D1**2*(16*C*fd*r*s + 16*C*fd*s**2 - 16*C*fd*s - 8*C*fdd*r*s - 8*C*fdd*s**2 + 8*C*fdd*s + 40*K*bd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 20*K*bdd1*(3*r*s - r + 3*s**2 - 3*s + 1) + 20*K*fd*r + 40*K*fd*s - 20*K*fd + 20*K*fdd*r*s + 25*K*fdd*s**2 - 18*fd*r*s - 8*fd*s**2 + 8*fd*s + 4*fdd*r*s + 4*fdd*s**2 - 4*fdd*s - 80*gd2*r*s - 80*gd2*s**2 + 80*gd2*s + 40*gdd2*r*s + 40*gdd2*s**2 - 40*gdd2*s) + D1*(2*Dd*(-10*K*bd1*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + f*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) + r*(9 - 36*s) - 16*s**2 + 26*s - 4) + fd*(-4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 100*K*s**2 - 45*K*s + r*(10*K + 2)*(8*s - 1) + 16*s**2 - 16*s + 2) - 40*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 20*gd2*(8*r*s - r + 8*s**2 - 8*s + 1)) + Ddd*(f*(-8*C*(r*(4*s - 1) + (1 - 2*s)**2) + 5*K*(4*r*(4*s - 1) + 20*s**2 - 18*s + 5) + 4*r*(4*s - 1) + 4*(1 - 2*s)**2) + 40*g2*(r*(4*s - 1) + (1 - 2*s)**2))) + 2*Dd**2*(f*(-4*C*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 5*K*(24*r*s - 6*r + 30*s**2 - 27*s + 4) + 24*r*s - 6*r + 24*s**2 - 24*s + 4) + 20*g2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))) - b1*(32*C*D1**2*f*fd*r*s - 56*C*D1**2*f*fd*r - 128*C*D1**2*f*fd*s + 56*C*D1**2*f*fd - 240*C*D1**2*f*fdd*r*s - 140*C*D1**2*f*fdd*s**2 + 120*C*D1**2*f*fdd*s - 240*C*D1**2*fd**2*r*s - 140*C*D1**2*fd**2*s**2 + 120*C*D1**2*fd**2*s + 64*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s - 1920*C*D1*Dd*f*fd*r*s + 240*C*D1*Dd*f*fd*r - 1120*C*D1*Dd*f*fd*s**2 + 1240*C*D1*Dd*f*fd*s - 120*C*D1*Dd*f*fd - 480*C*D1*Ddd*f**2*r*s + 120*C*D1*Ddd*f**2*r - 280*C*D1*Ddd*f**2*s**2 + 380*C*D1*Ddd*f**2*s - 70*C*D1*Ddd*f**2 - 1440*C*Dd**2*f**2*r*s + 360*C*Dd**2*f**2*r - 840*C*Dd**2*f**2*s**2 + 1140*C*Dd**2*f**2*s - 240*C*Dd**2*f**2 + 140*D1**2*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 140*D1**2*b2*fd*r*s - 140*D1**2*b2*fd*s**2 - 140*D1**2*bd2*f*r*s - 140*D1**2*bd2*f*s**2 + 140*D1**2*bd2*f*s + 7*D1**2*bdd1*(f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 5*K*(8*r*s - 4*r + 10*s**2 - 14*s + 5) - 8*r*s + 4*r - 8*s**2 + 8*s - 4) - 40*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 12*D1**2*f*fd*r*s + 28*D1**2*f*fd*r + 50*D1**2*f*fd*s - 28*D1**2*f*fd + 120*D1**2*f*fdd*r*s + 70*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s + 280*D1**2*f*gdd2*r*s + 350*D1**2*f*gdd2*s**2 - 280*D1**2*f*gdd2*s + 120*D1**2*fd**2*r*s + 70*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s + 280*D1**2*fd*g2*r + 560*D1**2*fd*g2*s - 280*D1**2*fd*g2 + 560*D1**2*fd*gd2*r*s + 700*D1**2*fd*gd2*s**2 - 280*D1**2*fd*gd2*s + 280*D1**2*fdd*g2*r*s + 350*D1**2*fdd*g2*s**2 - 560*D1*Dd*b2*f*r*s + 140*D1*Dd*b2*f*r - 560*D1*Dd*b2*f*s**2 + 560*D1*Dd*b2*f*s - 140*D1*Dd*b2*f + 24*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r - 12*D1*Dd*f**2*s + 960*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 560*D1*Dd*f*fd*s**2 - 620*D1*Dd*f*fd*s + 60*D1*Dd*f*fd + 2240*D1*Dd*f*gd2*r*s - 280*D1*Dd*f*gd2*r + 2800*D1*Dd*f*gd2*s**2 - 2380*D1*Dd*f*gd2*s + 280*D1*Dd*f*gd2 + 2240*D1*Dd*fd*g2*r*s - 280*D1*Dd*fd*g2*r + 2800*D1*Dd*fd*g2*s**2 - 1260*D1*Dd*fd*g2*s + 240*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 140*D1*Ddd*f**2*s**2 - 190*D1*Ddd*f**2*s + 35*D1*Ddd*f**2 + 1120*D1*Ddd*f*g2*r*s - 280*D1*Ddd*f*g2*r + 1400*D1*Ddd*f*g2*s**2 - 1260*D1*Ddd*f*g2*s + 350*D1*Ddd*f*g2 - 14*D1*bd1*(D1*f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 10*K*(r + 2*s - 1) - 18*r*s + 9*r - 8*s**2 + 13*s - 4) + D1*fd*(-4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 50*K*s**2 - 35*K*s + r*(10*K + 2)*(4*s - 1) + 8*s**2 - 8*s + 2) - 20*D1*(g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*f*(-8*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 5*K*(4*r*(8*s - 3) + 40*s**2 - 46*s + 11) + 4*r*(8*s - 3) + 8*(1 - 2*s)**2) + 40*Dd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + 720*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 420*Dd**2*f**2*s**2 - 570*Dd**2*f**2*s + 120*Dd**2*f**2 + 3360*Dd**2*f*g2*r*s - 840*Dd**2*f*g2*r + 4200*Dd**2*f*g2*s**2 - 3780*Dd**2*f*g2*s + 560*Dd**2*f*g2))/(210*d**2*k3**4) + D1**2*Pk3*Pkd2*k2*st**6*(-60*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*s**2 - 20*C*D1**2*f**2*fdd*s + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*s**2 - 40*C*D1**2*f*fd**2*s - 80*C*D1*Dd*f**3*s**2 + 40*C*D1*Dd*f**3*s - 20*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*s**2 - 140*C*D1*Dd*f**2*fd*s + 20*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*s**2 - 20*C*D1*Ddd*f**3*s + 10*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*s**2 - 60*C*Dd**2*f**3*s - 180*D1**2*K*b1*f*fd*s**2 + 180*D1**2*K*b1*f*fd*s - 90*D1**2*K*b1*f*fd + 90*D1**2*K*b1*f*fdd*s**2 - 90*D1**2*K*b1*f*fdd*s + 45*D1**2*K*b1*f*fdd + 90*D1**2*K*b1*fd**2*s**2 - 90*D1**2*K*b1*fd**2*s + 45*D1**2*K*bdd1*f**2*s**2 - 54*D1**2*b1*f**2*fd*r*s + 18*D1**2*b1*f**2*fd*r + 18*D1**2*b1*f**2*fd*s + 54*D1**2*b1*f**2*fdd*r*s - 18*D1**2*b1*f**2*fdd*r - 18*D1**2*b1*f**2*fdd*s + 108*D1**2*b1*f*fd**2*r*s - 36*D1**2*b1*f*fd**2*r - 36*D1**2*b1*f*fd**2*s + 18*D1**2*b1*f*fd**2 - 72*D1**2*b1*f*fd*r*s + 36*D1**2*b1*f*fd*r + 36*D1**2*b1*f*fdd*r*s - 18*D1**2*b1*f*fdd*r + 36*D1**2*b1*fd**2*r*s - 18*D1**2*b1*fd**2*r - 90*D1**2*bd2*f**2*s**2 + 180*D1**2*bd2*f*fd*s**2 - 90*D1**2*bd2*f*fd*s + 18*D1**2*bdd1*f**3*r*s - 18*D1**2*bdd1*f**3*s + 18*D1**2*bdd1*f**2*r*s - 18*D1**2*bdd1*f**2*s + 45*D1**2*bdd2*f**2*s**2 - 12*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 16*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r*s - 2*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 8*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd + 180*D1**2*f**2*gd2*s**2 - 90*D1**2*f**2*gdd2*s**2 + 12*D1**2*f*fd**2*r*s - 4*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 16*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 + 360*D1**2*f*fd*g2*s**2 - 360*D1**2*f*fd*g2*s + 180*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*s**2 + 180*D1**2*f*fd*gd2*s - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s - 360*D1*Dd*K*b1*f**2*s**2 + 180*D1*Dd*K*b1*f**2*s - 90*D1*Dd*K*b1*f**2 + 720*D1*Dd*K*b1*f*fd*s**2 - 540*D1*Dd*K*b1*f*fd*s + 90*D1*Dd*K*b1*f*fd - 72*D1*Dd*b1*f**3*r*s + 18*D1*Dd*b1*f**3*r + 36*D1*Dd*b1*f**3*s + 432*D1*Dd*b1*f**2*fd*r*s - 126*D1*Dd*b1*f**2*fd*r - 180*D1*Dd*b1*f**2*fd*s + 54*D1*Dd*b1*f**2*fd - 144*D1*Dd*b1*f**2*r*s + 36*D1*Dd*b1*f**2*r + 72*D1*Dd*b1*f**2*s + 288*D1*Dd*b1*f*fd*r*s - 108*D1*Dd*b1*f*fd*r - 72*D1*Dd*b1*f*fd*s + 36*D1*Dd*b1*f*fd + 360*D1*Dd*bd2*f**2*s**2 - 90*D1*Dd*bd2*f**2*s - 16*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 10*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r*s - 14*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 50*D1*Dd*f**2*fd*s - 4*D1*Dd*f**2*fd + 720*D1*Dd*f**2*g2*s**2 - 360*D1*Dd*f**2*g2*s + 180*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*s**2 + 180*D1*Dd*f**2*gd2*s - 1440*D1*Dd*f*fd*g2*s**2 + 1080*D1*Dd*f*fd*g2*s - 180*D1*Dd*f*fd*g2 + 180*D1*Ddd*K*b1*f**2*s**2 - 90*D1*Ddd*K*b1*f**2*s + 45*D1*Ddd*K*b1*f**2 + 72*D1*Ddd*b1*f**3*r*s - 18*D1*Ddd*b1*f**3*r - 36*D1*Ddd*b1*f**3*s + 72*D1*Ddd*b1*f**2*r*s - 18*D1*Ddd*b1*f**2*r - 36*D1*Ddd*b1*f**2*s + 8*D1*Ddd*f**3*r*s - 2*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*s**2 + 180*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 18*D1*bd1*f*(D1*(f*s*(5*K*s + f*(r - 1) + 2*r - 2) + fd*(f*(-6*r*s + r + 4*s - 1) - 4*r*s + r - (2*s - 1)*(5*K*s - 1))) - Dd*f*(20*K*s**2 - 5*K*s + f*r*(8*s - 1) - 6*f*s + f + r*(8*s - 1) - 6*s + 1)) + 540*Dd**2*K*b1*f**2*s**2 - 270*Dd**2*K*b1*f**2*s + 216*Dd**2*b1*f**3*r*s - 54*Dd**2*b1*f**3*r - 108*Dd**2*b1*f**3*s + 36*Dd**2*b1*f**3 + 216*Dd**2*b1*f**2*r*s - 54*Dd**2*b1*f**2*r - 108*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 + 24*Dd**2*f**3*r*s - 6*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s + 4*Dd**2*f**3 - 1080*Dd**2*f**2*g2*s**2 + 540*Dd**2*f**2*g2*s - 45*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(126*d**2*k3**2) + D1**2*Pk3*Pkd2*k2*st**4*(-96*C*D1**2*b1*f*fd*r*s + 48*C*D1**2*b1*f*fd*r + 24*C*D1**2*b1*f*fd*s + 12*C*D1**2*b1*f*fd + 48*C*D1**2*b1*f*fdd*r*s - 24*C*D1**2*b1*f*fdd*r - 12*C*D1**2*b1*f*fdd*s - 6*C*D1**2*b1*f*fdd + 48*C*D1**2*b1*fd**2*r*s - 24*C*D1**2*b1*fd**2*r - 12*C*D1**2*b1*fd**2*s + 24*C*D1**2*b1*fd**2 + 24*C*D1**2*bdd1*f**2*r*s - 12*C*D1**2*bdd1*f**2*s + 6*C*D1**2*bdd1*f**2 + 120*C*D1**2*f**2*fd*r*s - 40*C*D1**2*f**2*fd*r + 216*C*D1**2*f**2*fd*s**2 - 184*C*D1**2*f**2*fd*s + 72*C*D1**2*f**2*fd - 168*C*D1**2*f**2*fdd*r*s + 56*C*D1**2*f**2*fdd*r - 162*C*D1**2*f**2*fdd*s**2 + 164*C*D1**2*f**2*fdd*s - 54*C*D1**2*f**2*fdd - 336*C*D1**2*f*fd**2*r*s + 112*C*D1**2*f*fd**2*r - 324*C*D1**2*f*fd**2*s**2 + 328*C*D1**2*f*fd**2*s - 56*C*D1**2*f*fd**2 - 192*C*D1*Dd*b1*f**2*r*s + 48*C*D1*Dd*b1*f**2*r + 96*C*D1*Dd*b1*f**2*s + 384*C*D1*Dd*b1*f*fd*r*s - 144*C*D1*Dd*b1*f*fd*r - 144*C*D1*Dd*b1*f*fd*s + 60*C*D1*Dd*b1*f*fd + 160*C*D1*Dd*f**3*r*s - 40*C*D1*Dd*f**3*r + 288*C*D1*Dd*f**3*s**2 - 224*C*D1*Dd*f**3*s + 72*C*D1*Dd*f**3 - 1344*C*D1*Dd*f**2*fd*r*s + 392*C*D1*Dd*f**2*fd*r - 1296*C*D1*Dd*f**2*fd*s**2 + 1316*C*D1*Dd*f**2*fd*s - 276*C*D1*Dd*f**2*fd + 96*C*D1*Ddd*b1*f**2*r*s - 24*C*D1*Ddd*b1*f**2*r - 48*C*D1*Ddd*b1*f**2*s - 224*C*D1*Ddd*f**3*r*s + 56*C*D1*Ddd*f**3*r - 216*C*D1*Ddd*f**3*s**2 + 220*C*D1*Ddd*f**3*s - 54*C*D1*Ddd*f**3 + 288*C*Dd**2*b1*f**2*r*s - 72*C*Dd**2*b1*f**2*r - 144*C*Dd**2*b1*f**2*s + 48*C*Dd**2*b1*f**2 - 672*C*Dd**2*f**3*r*s + 168*C*Dd**2*f**3*r - 648*C*Dd**2*f**3*s**2 + 660*C*Dd**2*f**3*s - 112*C*Dd**2*f**3 - 168*D1**2*K*b1**2*fd*r*s + 168*D1**2*K*b1**2*fd*r - 84*D1**2*K*b1**2*fd*s + 42*D1**2*K*b1**2*fd + 84*D1**2*K*b1**2*fdd*r*s - 84*D1**2*K*b1**2*fdd*r + 42*D1**2*K*b1**2*fdd*s - 21*D1**2*K*b1**2*fdd + 168*D1**2*K*b1*bdd1*f*r*s - 126*D1**2*K*b1*bdd1*f*s + 21*D1**2*K*b1*bdd1*f + 168*D1**2*K*b1*f*fd*r*s - 84*D1**2*K*b1*f*fd*r + 504*D1**2*K*b1*f*fd*s**2 - 504*D1**2*K*b1*f*fd*s + 252*D1**2*K*b1*f*fd - 168*D1**2*K*b1*f*fdd*r*s + 84*D1**2*K*b1*f*fdd*r - 378*D1**2*K*b1*f*fdd*s**2 + 378*D1**2*K*b1*f*fdd*s - 189*D1**2*K*b1*f*fdd - 168*D1**2*K*b1*fd**2*r*s + 84*D1**2*K*b1*fd**2*r - 378*D1**2*K*b1*fd**2*s**2 + 378*D1**2*K*b1*fd**2*s - 84*D1**2*K*bdd1*f**2*r*s - 189*D1**2*K*bdd1*f**2*s**2 + 84*D1**2*K*bdd1*f**2*s - 42*D1**2*b1**2*f*fd*r + 42*D1**2*b1**2*f*fdd*r + 42*D1**2*b1**2*fd**2*r - 42*D1**2*b1**2*fd**2 - 84*D1**2*b1**2*fd*r + 42*D1**2*b1**2*fdd*r - 42*D1**2*b1*bd2*f*s**2 + 42*D1**2*b1*bd2*fd*s**2 - 42*D1**2*b1*bdd1*f**2*r - 42*D1**2*b1*bdd1*f*r + 21*D1**2*b1*bdd2*f*s**2 + 132*D1**2*b1*f*fd*r*s - 78*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s - 6*D1**2*b1*f*fd - 24*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s + 3*D1**2*b1*f*fdd + 336*D1**2*b1*f*gd2*r*s - 336*D1**2*b1*f*gd2*s - 168*D1**2*b1*f*gdd2*r*s + 168*D1**2*b1*f*gdd2*s - 24*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*r + 6*D1**2*b1*fd**2*s - 18*D1**2*b1*fd**2 + 336*D1**2*b1*fd*g2*r*s - 336*D1**2*b1*fd*g2*r + 168*D1**2*b1*fd*g2*s - 84*D1**2*b1*fd*g2 - 336*D1**2*b1*fd*gd2*r*s + 168*D1**2*b1*fd*gd2*r + 84*D1**2*b1*fd*gd2*s - 168*D1**2*b1*fd*gd2 - 168*D1**2*b1*fdd*g2*r*s + 168*D1**2*b1*fdd*g2*r - 84*D1**2*b1*fdd*g2*s + 42*D1**2*b1*fdd*g2 - 42*D1**2*bd1**2*f*(-4*K*r*s + 3*K*s + f*(r - 1) + r - 1) + 84*D1**2*bd2*f**2*r*s + 252*D1**2*bd2*f**2*s**2 - 84*D1**2*bd2*f**2*s - 336*D1**2*bd2*f*fd*r*s + 84*D1**2*bd2*f*fd*r - 756*D1**2*bd2*f*fd*s**2 + 546*D1**2*bd2*f*fd*s - 84*D1**2*bd2*f*fd - 12*D1**2*bdd1*f**2*r*s - 6*D1**2*bdd1*f**2*r + 6*D1**2*bdd1*f**2*s - 3*D1**2*bdd1*f**2 - 168*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*s - 42*D1**2*bdd1*f*g2 - 84*D1**2*bdd2*f**2*r*s - 189*D1**2*bdd2*f**2*s**2 + 84*D1**2*bdd2*f**2*s - 42*D1**2*f**2*fd*r*s + 14*D1**2*f**2*fd*r - 108*D1**2*f**2*fd*s**2 + 86*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r*s - 28*D1**2*f**2*fdd*r + 81*D1**2*f**2*fdd*s**2 - 82*D1**2*f**2*fdd*s + 27*D1**2*f**2*fdd - 168*D1**2*f**2*gd2*r*s - 504*D1**2*f**2*gd2*s**2 + 168*D1**2*f**2*gd2*s + 168*D1**2*f**2*gdd2*r*s + 378*D1**2*f**2*gdd2*s**2 - 168*D1**2*f**2*gdd2*s + 168*D1**2*f*fd**2*r*s - 56*D1**2*f*fd**2*r + 162*D1**2*f*fd**2*s**2 - 164*D1**2*f*fd**2*s + 28*D1**2*f*fd**2 - 336*D1**2*f*fd*g2*r*s + 168*D1**2*f*fd*g2*r - 1008*D1**2*f*fd*g2*s**2 + 1008*D1**2*f*fd*g2*s - 504*D1**2*f*fd*g2 + 672*D1**2*f*fd*gd2*r*s - 168*D1**2*f*fd*gd2*r + 1512*D1**2*f*fd*gd2*s**2 - 1092*D1**2*f*fd*gd2*s + 168*D1**2*f*fd*gd2 + 336*D1**2*f*fdd*g2*r*s - 168*D1**2*f*fdd*g2*r + 756*D1**2*f*fdd*g2*s**2 - 756*D1**2*f*fdd*g2*s + 378*D1**2*f*fdd*g2 + 336*D1**2*fd**2*g2*r*s - 168*D1**2*fd**2*g2*r + 756*D1**2*fd**2*g2*s**2 - 756*D1**2*fd**2*g2*s - 672*D1*Dd*K*b1**2*f*r*s + 168*D1*Dd*K*b1**2*f*r + 336*D1*Dd*K*b1**2*f*s + 672*D1*Dd*K*b1**2*fd*r*s - 420*D1*Dd*K*b1**2*fd*r + 126*D1*Dd*K*b1**2*fd + 336*D1*Dd*K*b1*f**2*r*s - 84*D1*Dd*K*b1*f**2*r + 1008*D1*Dd*K*b1*f**2*s**2 - 672*D1*Dd*K*b1*f**2*s + 252*D1*Dd*K*b1*f**2 - 1344*D1*Dd*K*b1*f*fd*r*s + 504*D1*Dd*K*b1*f*fd*r - 3024*D1*Dd*K*b1*f*fd*s**2 + 2604*D1*Dd*K*b1*f*fd*s - 546*D1*Dd*K*b1*f*fd + 168*D1*Dd*b1**2*f*fd*r - 84*D1*Dd*b1**2*f*fd + 168*D1*Dd*b1**2*fd*r - 84*D1*Dd*b1**2*fd + 168*D1*Dd*b1*bd2*f*s**2 - 42*D1*Dd*b1*bd2*f*s + 264*D1*Dd*b1*f**2*r*s - 66*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s - 192*D1*Dd*b1*f*fd*r*s + 96*D1*Dd*b1*f*fd*r + 72*D1*Dd*b1*f*fd*s - 42*D1*Dd*b1*f*fd + 1344*D1*Dd*b1*f*g2*r*s - 336*D1*Dd*b1*f*g2*r - 672*D1*Dd*b1*f*g2*s - 1344*D1*Dd*b1*f*gd2*r*s + 168*D1*Dd*b1*f*gd2*r + 1008*D1*Dd*b1*f*gd2*s - 168*D1*Dd*b1*f*gd2 - 1344*D1*Dd*b1*fd*g2*r*s + 840*D1*Dd*b1*fd*g2*r - 252*D1*Dd*b1*fd*g2 - 672*D1*Dd*bd2*f**2*r*s + 84*D1*Dd*bd2*f**2*r - 1512*D1*Dd*bd2*f**2*s**2 + 882*D1*Dd*bd2*f**2*s - 84*D1*Dd*bd2*f**2 - 56*D1*Dd*f**3*r*s + 14*D1*Dd*f**3*r - 144*D1*Dd*f**3*s**2 + 100*D1*Dd*f**3*s - 36*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r*s - 196*D1*Dd*f**2*fd*r + 648*D1*Dd*f**2*fd*s**2 - 658*D1*Dd*f**2*fd*s + 138*D1*Dd*f**2*fd - 672*D1*Dd*f**2*g2*r*s + 168*D1*Dd*f**2*g2*r - 2016*D1*Dd*f**2*g2*s**2 + 1344*D1*Dd*f**2*g2*s - 504*D1*Dd*f**2*g2 + 1344*D1*Dd*f**2*gd2*r*s - 168*D1*Dd*f**2*gd2*r + 3024*D1*Dd*f**2*gd2*s**2 - 1764*D1*Dd*f**2*gd2*s + 168*D1*Dd*f**2*gd2 + 2688*D1*Dd*f*fd*g2*r*s - 1008*D1*Dd*f*fd*g2*r + 6048*D1*Dd*f*fd*g2*s**2 - 5208*D1*Dd*f*fd*g2*s + 1092*D1*Dd*f*fd*g2 + 336*D1*Ddd*K*b1**2*f*r*s - 84*D1*Ddd*K*b1**2*f*r - 168*D1*Ddd*K*b1**2*f*s - 336*D1*Ddd*K*b1*f**2*r*s + 84*D1*Ddd*K*b1*f**2*r - 756*D1*Ddd*K*b1*f**2*s**2 + 546*D1*Ddd*K*b1*f**2*s - 189*D1*Ddd*K*b1*f**2 - 48*D1*Ddd*b1*f**2*r*s + 12*D1*Ddd*b1*f**2*r + 24*D1*Ddd*b1*f**2*s - 672*D1*Ddd*b1*f*g2*r*s + 168*D1*Ddd*b1*f*g2*r + 336*D1*Ddd*b1*f*g2*s + 112*D1*Ddd*f**3*r*s - 28*D1*Ddd*f**3*r + 108*D1*Ddd*f**3*s**2 - 110*D1*Ddd*f**3*s + 27*D1*Ddd*f**3 + 672*D1*Ddd*f**2*g2*r*s - 168*D1*Ddd*f**2*g2*r + 1512*D1*Ddd*f**2*g2*s**2 - 1092*D1*Ddd*f**2*g2*s + 378*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(f**2*(C*(s*(4 - 8*r) - 2) + 42*K*s**2 - 14*K*s + r*(14*K*s + 11*s + 2) - 9*s + 1) + f*(fd*(16*C*r*s - 4*C*r - 6*C*s - 7*K*(8*r*s - 2*r + 18*s**2 - 13*s + 2) - 8*r*s + r + 3*s + 1) + 7*g2*(s*(8*r - 4) + 2) + 7*s*(bd2*(s - 1) - 8*gd2*r + 6*gd2)) + 28*fd*g2*r*(1 - 2*s)) + Dd*f*(f*(2*C*(2*r - 1)*(8*s - 1) - 7*K*(16*r*s - 2*r + 36*s**2 - 21*s + 2) - (2*r - 1)*(8*s + 1)) - 14*g2*(2*r - 1)*(8*s - 1)) - 7*b1*(D1*(f*(K*s*(8*r - 6) + K - r*(f + 2)) + fd*(K*(-8*r*s + 4*r + s - 2) - r + 1)) + Dd*f*(K*(-32*r*s + 4*r + 20*s - 3) + f*(4*r - 2) + 4*r - 2))) + 1008*Dd**2*K*b1**2*f*r*s - 252*Dd**2*K*b1**2*f*r - 504*Dd**2*K*b1**2*f*s + 168*Dd**2*K*b1**2*f - 1008*Dd**2*K*b1*f**2*r*s + 252*Dd**2*K*b1*f**2*r - 2268*Dd**2*K*b1*f**2*s**2 + 1638*Dd**2*K*b1*f**2*s - 168*Dd**2*K*b1*f**2 - 144*Dd**2*b1*f**2*r*s + 36*Dd**2*b1*f**2*r + 72*Dd**2*b1*f**2*s - 24*Dd**2*b1*f**2 - 2016*Dd**2*b1*f*g2*r*s + 504*Dd**2*b1*f*g2*r + 1008*Dd**2*b1*f*g2*s - 336*Dd**2*b1*f*g2 + 336*Dd**2*f**3*r*s - 84*Dd**2*f**3*r + 324*Dd**2*f**3*s**2 - 330*Dd**2*f**3*s + 56*Dd**2*f**3 + 2016*Dd**2*f**2*g2*r*s - 504*Dd**2*f**2*g2*r + 4536*Dd**2*f**2*g2*s**2 - 3276*Dd**2*f**2*g2*s + 336*Dd**2*f**2*g2 - 21*b2*(2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s + 8*D1*Dd*b1*f*s**2 - 4*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*s**2 + 2*D1*Dd*b1*fd*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 124*D1*Dd*f*fd*s + 26*D1*Dd*f*fd - 4*D1*Ddd*b1*f*s**2 + 2*D1*Ddd*b1*f*s - D1*Ddd*b1*f + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 26*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) - 12*Dd**2*b1*f*s**2 + 6*Dd**2*b1*f*s + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 78*Dd**2*f**2*s + 8*Dd**2*f**2))/(210*d**2*k3**2) + D1**2*Pk3*Pkd2*k2*st**2*(D1*(-14*D1*bd1**2*(f*(5*K*(r*(4*s - 2) - 7*s + 2) + r*(-8*C*s + 4*C + 6*s - 3) + 3*s*(-2*C*s + 2*C + s - 1)) + 10*g2*(r*(4*s - 2) + s*(3*s - 3))) - 5*D1*bdd1*f*(f*(2*C - 1)*(12*r*(s - 1) - 14*s + 7) + 14*g2*(-4*r*(s - 1) + 10*s - 5)) + 35*b2*(-D1*bdd1*f*(s - 1)*(4*r + 5*s - 5) + 2*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*r*(2 - 4*s) - 5*fd*s*(s - 1)) + Dd*f*(-2*r*(8*s - 5) - 20*s**2 + 29*s - 9))) - 2*bd1*(35*D1*bd2*f*(r*(4*s - 2) + 5*s**2 - 7*s + 2) + D1*(f**2*(-4*C*(16*r*s - 9*r - 14*s + 7) + 32*r*s - 11*r - 28*s + 14) + 5*f*(fd*(2*C - 1)*(12*r*(2*s - 1) - 13*s + 6) + 28*g2*(r - 1)*(2*s - 1) + 14*gd2*(-4*r*s + 2*r + 7*s - 2)) + 140*fd*g2*r*(1 - 2*s)) + 5*Dd*f*(f*(2*C - 1)*(6*r*(8*s - 5) - 40*s + 19) - 14*g2*(2*r*(8*s - 5) - 24*s + 9)))) - 35*b1**3*(2*D1*Dd*(K*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) + fd*r*(8*s - 1) - 6*fd*s + fd - (f + 2)*(r*(4*s - 1) - 2*s)) - D1*(2*D1*s*(fd - fdd)*(r - 1) + Ddd*K*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) - 2*Ddd*(f + 1)*(r*(4*s - 1) - 2*s)) + 2*Dd**2*(K*(-24*r*s + 6*r - 18*s**2 + 21*s - 4) + f*(3*r*(4*s - 1) - 6*s + 2) + 12*r*s - 3*r - 6*s + 2)) + 7*b1**2*(D1**2*(8*C*fdd*r*s + 6*C*fdd*s**2 - 8*C*fdd*s - 20*K*fdd*r*s - 50*K*fdd*s + 25*K*fdd + 5*bdd1*(K*(4*r*(3*s - 1) + 9*s**2 - 10*s + 3) + (-2*f - 2)*(r*(3*s - 1) - s)) + 2*fd*(10*K*(r + 1)*(2*s - 1) + r*(-8*C*s + 6*s + 5) + s*(-6*C*s + 8*C + 3*s - 6)) - 6*fdd*r*s - 3*fdd*s**2 + 6*fdd*s + 80*gd2*r*s + 60*gd2*s**2 - 80*gd2*s - 40*gdd2*r*s - 30*gdd2*s**2 + 40*gdd2*s) + 10*D1*bd1*(-D1*(K*(4*r*(3*s - 1) + 9*s**2 - 10*s + 3) + fd*r*(6*s - 1) - 4*fd*s + fd - (f + 2)*(r*(3*s - 1) - s)) + Dd*(K*(48*r*s - 14*r + 36*s**2 - 41*s + 9) + f*(r*(7 - 24*s) + 10*s - 3) - 24*r*s + 7*r + 10*s - 3)) + D1*(-2*Dd*(f*(C*(8*r*(4*s - 1) + 24*s**2 - 28*s + 6) + 40*K*s - r*(20*K + 6)*(4*s - 1) - 12*s**2 + 18*s - 3) + fd*(C*(r*(4 - 32*s) - 24*s**2 + 30*s - 4) + 5*K*(16*r*s - 2*r + 16*s - 5) + 24*r*s - 3*r + 12*s**2 - 21*s + 3) - 10*g2*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) - 10*gd2*(r*(2 - 16*s) - 12*s**2 + 15*s - 2)) + Ddd*(f*(C*(8*r*(4*s - 1) + 24*s**2 - 28*s + 6) + 40*K*s - r*(20*K + 6)*(4*s - 1) - 12*s**2 + 18*s - 3) - 10*g2*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3))) + 2*Dd**2*(f*(2*C*(6*r*(4*s - 1) + 18*s**2 - 21*s + 4) - 10*K*(12*r*s - 3*r - 6*s + 2) - 36*r*s + 9*r - 18*s**2 + 27*s - 6) - 10*g2*(6*r*(4*s - 1) + 18*s**2 - 21*s + 4))) - b1*(-256*C*D1**2*f*fd*r*s + 56*C*D1**2*f*fd*r + 16*C*D1**2*f*fd*s + 56*C*D1**2*f*fd + 240*C*D1**2*f*fdd*r*s + 20*C*D1**2*f*fdd*s - 70*C*D1**2*f*fdd + 240*C*D1**2*fd**2*r*s + 20*C*D1**2*fd**2*s - 512*C*D1*Dd*f**2*r*s + 128*C*D1*Dd*f**2*r + 256*C*D1*Dd*f**2*s + 1920*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r - 400*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd + 480*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r - 240*C*D1*Ddd*f**2*s + 1440*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r - 720*C*Dd**2*f**2*s + 240*C*Dd**2*f**2 - 140*D1**2*b2*fd*r*s - 140*D1**2*b2*fd*s**2 + 140*D1**2*b2*fdd*r*s + 175*D1**2*b2*fdd*s**2 + 70*D1**2*bd1**2*(K*(r*(4 - 12*s) - 9*s**2 + 10*s - 2) + f*r*(6*s - 2) - 2*f*s + f + 6*r*s - 2*r - 2*s + 1) - 140*D1**2*bd2*f*r*s - 140*D1**2*bd2*f*s**2 + 140*D1**2*bd2*f*s + 280*D1**2*bd2*fd*r*s + 350*D1**2*bd2*fd*s**2 - 140*D1**2*bd2*fd*s - 7*D1**2*bdd1*(f*(2*C*(r*(8*s - 4) + 6*s**2 - 6*s + 3) - 5*K*(8*r*s - 4*r - 14*s + 5) - 12*r*s + 6*r - 6*s**2 + 6*s - 3) - 10*g2*(r*(8*s - 4) + 6*s**2 - 6*s + 3)) + 140*D1**2*bdd2*f*r*s + 175*D1**2*bdd2*f*s**2 - 140*D1**2*bdd2*f*s + 128*D1**2*f*fd*r*s - 42*D1**2*f*fd*r - 8*D1**2*f*fd*s - 28*D1**2*f*fd - 120*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*s + 35*D1**2*f*fdd + 560*D1**2*f*gd2*r*s - 560*D1**2*f*gd2*s - 280*D1**2*f*gdd2*r*s + 280*D1**2*f*gdd2*s - 120*D1**2*fd**2*r*s - 10*D1**2*fd**2*s + 560*D1**2*fd*g2*r*s - 280*D1**2*fd*g2*r + 560*D1**2*fd*g2*s - 280*D1**2*fd*g2 - 560*D1**2*fd*gd2*r*s - 420*D1**2*fd*gd2*s - 280*D1**2*fdd*g2*r*s - 700*D1**2*fdd*g2*s + 350*D1**2*fdd*g2 - 560*D1*Dd*b2*f*r*s + 140*D1*Dd*b2*f*r - 560*D1*Dd*b2*f*s**2 + 560*D1*Dd*b2*f*s - 140*D1*Dd*b2*f + 1120*D1*Dd*b2*fd*r*s - 140*D1*Dd*b2*fd*r + 1400*D1*Dd*b2*fd*s**2 - 630*D1*Dd*b2*fd*s + 1120*D1*Dd*bd2*f*r*s - 140*D1*Dd*bd2*f*r + 1400*D1*Dd*bd2*f*s**2 - 1190*D1*Dd*bd2*f*s + 140*D1*Dd*bd2*f + 256*D1*Dd*f**2*r*s - 64*D1*Dd*f**2*r - 128*D1*Dd*f**2*s - 960*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r + 200*D1*Dd*f*fd*s + 10*D1*Dd*f*fd + 2240*D1*Dd*f*g2*r*s - 560*D1*Dd*f*g2*r - 1120*D1*Dd*f*g2*s - 2240*D1*Dd*f*gd2*r*s + 280*D1*Dd*f*gd2*r + 1680*D1*Dd*f*gd2*s - 280*D1*Dd*f*gd2 - 2240*D1*Dd*fd*g2*r*s + 280*D1*Dd*fd*g2*r - 2240*D1*Dd*fd*g2*s + 700*D1*Dd*fd*g2 + 560*D1*Ddd*b2*f*r*s - 140*D1*Ddd*b2*f*r + 700*D1*Ddd*b2*f*s**2 - 630*D1*Ddd*b2*f*s + 175*D1*Ddd*b2*f - 240*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s - 1120*D1*Ddd*f*g2*r*s + 280*D1*Ddd*f*g2*r + 560*D1*Ddd*f*g2*s + 14*D1*bd1*(D1*f*(2*C*(r*(8*s - 4) + 6*s**2 - 6*s + 3) - 10*K*(r - 1)*(4*s - 1) - 12*r*s + 11*r - 6*s**2 + 6*s - 3) + D1*fd*(-2*C*(r*(8*s - 2) + 6*s**2 - 7*s + 2) + 15*K*s + r*(10*K + 3)*(4*s - 1) + 6*s**2 - 9*s + 3) - 10*D1*(g2*(r*(8*s - 4) + 6*s**2 - 6*s + 3) + gd2*(r*(2 - 8*s) - 6*s**2 + 7*s - 2)) + Dd*f*(-2*C*(4*r*(8*s - 3) + 24*s**2 - 26*s + 7) + 5*K*(4*r*(8*s - 3) - 36*s + 11) + 6*r*(8*s - 3) + 24*s**2 - 30*s + 9) + 10*Dd*g2*(4*r*(8*s - 3) + 24*s**2 - 26*s + 7)) + 1680*Dd**2*b2*f*r*s - 420*Dd**2*b2*f*r + 2100*Dd**2*b2*f*s**2 - 1890*Dd**2*b2*f*s + 280*Dd**2*b2*f - 720*Dd**2*f**2*r*s + 180*Dd**2*f**2*r + 360*Dd**2*f**2*s - 120*Dd**2*f**2 - 3360*Dd**2*f*g2*r*s + 840*Dd**2*f*g2*r + 1680*Dd**2*f*g2*s - 560*Dd**2*f*g2))/(210*d**2*k3**2) + D1**2*Pk3*Pkd2*k2*(2*D1**2*bd1**2*s*(s - 1)*(f*(2*C - 1) - 6*g2) + D1*b1*(6*D1*K*bd1**2*s*(3*s - 2) + D1*bdd1*(f*(2*C - 1) - 6*g2)*(2*s**2 - 2*s + 1) + 2*bd1*(D1*(f*(C*(8*r*s - 4*r + 8*s**2 - 8*s + 4) - 6*r*s + 3*r - 4*s**2 + 4*s - 2) - 12*g2*(2*r*s - r + 2*s**2 - 2*s + 1) + s*(2*s - 1)*(2*C*fd - fd - 6*gd2)) + Dd*(f*(2*C - 1) - 6*g2)*(8*s**2 - 6*s + 1))) + 3*b1**3*(2*D1*Dd*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 - 4*r*s + r + 2*s) + D1*Ddd*K*(4*s**2 - 2*s + 1) + 6*Dd**2*K*s*(2*s - 1)) + b1**2*(D1**2*(3*K*bdd1*(3*s**2 - 2*s + 1) + 6*bd1*(K*(r*(6*s - 2) + 6*s**2 - 6*s + 2) - 3*r*s + r + s) + s*(fd*(8*C*(r + s - 1) - 6*r - 4*s + 6) - 24*gd2*(r + s - 1) + s*(2*C*fdd - fdd - 6*gdd2))) + D1*(2*Dd*(f*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) - (4*s - 1)*(3*r + 2*s - 2)) - 12*g2*(r*(4*s - 1) + (1 - 2*s)**2) + (4*s - 1)*(3*K*bd1*(3*s - 1) + fd*s*(2*C - 1) - 6*gd2*s)) + Ddd*(f*(2*C - 1) - 6*g2)*(4*s**2 - 2*s + 1)) + 6*Dd**2*s*(2*s - 1)*(f*(2*C - 1) - 6*g2)))/(6*d**2*k3**2) + D1**2*Pk3*Pkd2*st**4*(D1*(14*D1*bd1**2*f*s*(5*K*s + f*(2*r - 1) + 2*r - 1) + D1*bdd1*f*s*(2*f*r + f*s*(10*C - 5) + s*(35*b2 - 70*g2)) + 2*bd1*(-D1*(f**2*s*(2*r + s*(10*C - 5)) + f*(fd*(-4*r*s + r + 2*s*(-10*C*s + 5*C + 5*s - 2)) + s**2*(35*b2 - 35*bd2 - 70*g2 + 70*gd2)) - 35*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(f*r*(8*s - 1) + f*s*(10*C*(4*s - 1) - 20*s + 3) + s*(35*b2 - 70*g2)*(4*s - 1)))) + 7*b1**2*(2*D1*Dd*(f*(-5*K*(4*s**2 - 2*s + 1) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(5*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(4*s - 2) - 2*s + 2) - 2*fd*(5*K*(s - 1)**2 - f*s + r*(2*f*s - f + 2*s - 2)) + fdd*(5*K*(s - 1)**2 - 2*f*s + 2*r*(2*f*s - f + s - 1))) + Ddd*f*(5*K*(4*s**2 - 2*s + 1) + (2*f + 2)*(r*(4*s - 1) - 2*s))) + 2*Dd**2*f*(30*K*s**2 - 15*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(-40*C*D1**2*f*fd*s**2 + 40*C*D1**2*f*fd*s - 20*C*D1**2*f*fd + 20*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd + 20*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 80*C*D1*Dd*f**2*s**2 + 40*C*D1*Dd*f**2*s - 20*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*s**2 - 120*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*s**2 - 20*C*D1*Ddd*f**2*s + 10*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*s**2 - 60*C*Dd**2*f**2*s + 70*D1**2*K*bdd1*f*s**2 - 70*D1**2*bd2*f*s**2 + 70*D1**2*bd2*fd*s**2 - 70*D1**2*bd2*fd*s + 28*D1**2*bdd1*f**2*r*s - 14*D1**2*bdd1*f**2*s + 28*D1**2*bdd1*f*r*s - 14*D1**2*bdd1*f*s + 35*D1**2*bdd2*f*s**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r + 20*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 10*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 8*D1**2*f*fdd*s - 5*D1**2*f*fdd + 140*D1**2*f*gd2*s**2 - 70*D1**2*f*gdd2*s**2 + 4*D1**2*fd**2*r*s - 2*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 8*D1**2*fd**2*s + 2*D1**2*fd**2 + 140*D1**2*fd*g2*s**2 - 280*D1**2*fd*g2*s + 140*D1**2*fd*g2 - 140*D1**2*fd*gd2*s**2 + 140*D1**2*fd*gd2*s - 70*D1**2*fdd*g2*s**2 + 140*D1**2*fdd*g2*s - 70*D1**2*fdd*g2 + 280*D1*Dd*bd2*f*s**2 - 70*D1*Dd*bd2*f*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r + 40*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 10*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 44*D1*Dd*f*fd*s - 4*D1*Dd*f*fd + 560*D1*Dd*f*g2*s**2 - 280*D1*Dd*f*g2*s + 140*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*s**2 + 140*D1*Dd*f*gd2*s - 560*D1*Dd*fd*g2*s**2 + 700*D1*Dd*fd*g2*s - 140*D1*Dd*fd*g2 + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*s**2 + 140*D1*Ddd*f*g2*s - 70*D1*Ddd*f*g2 + 14*D1*bd1*(D1*(f*s*(-10*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(10*K*s - 1))) + Dd*f*(40*K*s**2 - 10*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s + 4*Dd**2*f**2 - 840*Dd**2*f*g2*s**2 + 420*Dd**2*f*g2*s - 35*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(70*d**2*k2) - D1**2*Pk3*Pkd2*st**2*(D1*(-2*D1*bd1**2*(f*r*(2*s - 1) + f*s*(2*C*(s - 1) - s*(25*K + 1) + 1) + s*(5*b2 - 10*g2)*(s - 1)) + 5*D1*bdd1*f*s**2*(5*b2 + f*(2*C - 1) - 10*g2) + 2*bd1*s*(D1*(-f**2*(8*C*s + r - 4*s) + 5*f*(fd*(2*C - 1)*(2*s - 1) + s*(5*bd2 + 8*g2 - 10*gd2)) - 50*fd*g2*(s - 1)) + 5*Dd*f*(4*s - 1)*(f*(2*C - 1) - 10*g2) + 5*b2*(-4*D1*f*s + 5*D1*fd*(s - 1) + 5*Dd*f*(4*s - 1)))) - 5*b1**3*(2*D1*Dd*(K*(-4*s**2 + 2*s - 1) + fd*r*(8*s - 1) - 6*fd*s + fd - (f + 2)*(r*(4*s - 1) - 2*s)) + D1*(-2*D1*s*(fd - fdd)*(r - 1) + Ddd*K*(4*s**2 - 2*s + 1) + 2*Ddd*(f + 1)*(r*(4*s - 1) - 2*s)) + 2*Dd**2*(6*K*s**2 - 3*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1**2*(4*C*D1**2*fd*s**2 - 2*C*D1**2*fdd*s**2 + 16*C*D1*Dd*f*s**2 - 8*C*D1*Dd*f*s + 4*C*D1*Dd*f - 16*C*D1*Dd*fd*s**2 + 4*C*D1*Dd*fd*s - 8*C*D1*Ddd*f*s**2 + 4*C*D1*Ddd*f*s - 2*C*D1*Ddd*f - 24*C*Dd**2*f*s**2 + 12*C*Dd**2*f*s - 15*D1**2*K*bdd1*s**2 + 10*D1**2*K*bdd1*s - 5*D1**2*K*bdd1 - 40*D1**2*K*fd*s**2 + 80*D1**2*K*fd*s - 40*D1**2*K*fd + 25*D1**2*K*fdd*s**2 - 50*D1**2*K*fdd*s + 25*D1**2*K*fdd + 10*D1**2*bd2*s**2 - 30*D1**2*bdd1*f*r*s + 10*D1**2*bdd1*f*r + 10*D1**2*bdd1*f*s - 30*D1**2*bdd1*r*s + 10*D1**2*bdd1*r + 10*D1**2*bdd1*s - 5*D1**2*bdd2*s**2 - 6*D1**2*fd*r*s + 10*D1**2*fd*r - 2*D1**2*fd*s**2 - 4*D1**2*fd*s - 2*D1**2*fdd*r*s + D1**2*fdd*s**2 + 2*D1**2*fdd*s - 20*D1**2*gd2*s**2 + 10*D1**2*gdd2*s**2 - 160*D1*Dd*K*f*s**2 + 80*D1*Dd*K*f*s - 40*D1*Dd*K*f + 200*D1*Dd*K*fd*s**2 - 250*D1*Dd*K*fd*s + 50*D1*Dd*K*fd - 40*D1*Dd*bd2*s**2 + 10*D1*Dd*bd2*s - 24*D1*Dd*f*r*s + 6*D1*Dd*f*r - 8*D1*Dd*f*s**2 + 16*D1*Dd*f*s - 2*D1*Dd*f - 16*D1*Dd*fd*r*s + 2*D1*Dd*fd*r + 8*D1*Dd*fd*s**2 + 10*D1*Dd*fd*s - 2*D1*Dd*fd - 80*D1*Dd*g2*s**2 + 40*D1*Dd*g2*s - 20*D1*Dd*g2 + 80*D1*Dd*gd2*s**2 - 20*D1*Dd*gd2*s + 100*D1*Ddd*K*f*s**2 - 50*D1*Ddd*K*f*s + 25*D1*Ddd*K*f - 8*D1*Ddd*f*r*s + 2*D1*Ddd*f*r + 4*D1*Ddd*f*s**2 + 2*D1*Ddd*f*s + D1*Ddd*f + 40*D1*Ddd*g2*s**2 - 20*D1*Ddd*g2*s + 10*D1*Ddd*g2 + 10*D1*bd1*(D1*(K*(3*s**2 - 2*s + 1) + fd*(-6*r*s + r + 4*s - 1) + (f + 2)*(3*r*s - r - s)) - Dd*(12*K*s**2 - 7*K*s + K + f*(r*(24*s - 7) - 10*s + 3) + 24*r*s - 7*r - 10*s + 3)) + 300*Dd**2*K*f*s**2 - 150*Dd**2*K*f*s - 24*Dd**2*f*r*s + 6*Dd**2*f*r + 12*Dd**2*f*s**2 + 6*Dd**2*f*s - 4*Dd**2*f + 120*Dd**2*g2*s**2 - 60*Dd**2*g2*s + 5*b2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s))) + b1*(-4*C*D1**2*bdd1*f*s**2 + 4*C*D1**2*bdd1*f*s - 2*C*D1**2*bdd1*f - 32*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s - 16*C*D1**2*f*fd + 20*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd + 20*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 64*C*D1*Dd*f**2*s**2 + 32*C*D1*Dd*f**2*s - 16*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*s**2 - 120*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*s**2 - 20*C*D1*Ddd*f**2*s + 10*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*s**2 - 60*C*Dd**2*f**2*s + 50*D1**2*K*bdd1*f*s**2 - 10*D1**2*bd1**2*(3*K*s**2 - 2*K*s + f*r*(6*s - 2) - 2*f*s + f + r*(6*s - 2) - 2*s + 1) - 40*D1**2*bd2*f*s**2 + 50*D1**2*bd2*fd*s**2 - 50*D1**2*bd2*fd*s - 4*D1**2*bdd1*f*r*s + 2*D1**2*bdd1*f*r + 2*D1**2*bdd1*f*s**2 - 2*D1**2*bdd1*f*s + D1**2*bdd1*f + 20*D1**2*bdd1*g2*s**2 - 20*D1**2*bdd1*g2*s + 10*D1**2*bdd1*g2 + 25*D1**2*bdd2*f*s**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r + 16*D1**2*f*fd*s**2 - 14*D1**2*f*fd*s + 8*D1**2*f*fd - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd + 80*D1**2*f*gd2*s**2 - 50*D1**2*f*gdd2*s**2 - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 80*D1**2*fd*g2*s**2 - 160*D1**2*fd*g2*s + 80*D1**2*fd*g2 - 100*D1**2*fd*gd2*s**2 + 100*D1**2*fd*gd2*s - 50*D1**2*fdd*g2*s**2 + 100*D1**2*fdd*g2*s - 50*D1**2*fdd*g2 + 200*D1*Dd*bd2*f*s**2 - 50*D1*Dd*bd2*f*s - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r + 32*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 8*D1*Dd*f**2 - 80*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 10*D1*Dd*f*fd + 320*D1*Dd*f*g2*s**2 - 160*D1*Dd*f*g2*s + 80*D1*Dd*f*g2 - 400*D1*Dd*f*gd2*s**2 + 100*D1*Dd*f*gd2*s - 400*D1*Dd*fd*g2*s**2 + 500*D1*Dd*fd*g2*s - 100*D1*Dd*fd*g2 - 20*D1*Ddd*f**2*s**2 + 10*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 - 200*D1*Ddd*f*g2*s**2 + 100*D1*Ddd*f*g2*s - 50*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(-f*(C*(-4*s**2 + 4*s - 2) + 40*K*s**2 + r*(6*s + 2) + 2*s**2 - 7*s + 1) + fd*(-4*r*s + r + s**2*(-4*C + 50*K + 2) + s*(2*C - 50*K + 1) - 1) - 5*g2*(4*s**2 - 4*s + 2) - 5*s*(bd2 - 2*gd2)*(2*s - 1)) - Dd*f*(2*C*(8*s**2 - 6*s + 1) - 200*K*s**2 + 50*K*s + 2*r*(8*s - 3) - 8*s**2 + 2*s + 1) + 10*Dd*g2*(8*s**2 - 6*s + 1)) - 60*Dd**2*f**2*s**2 + 30*Dd**2*f**2*s - 600*Dd**2*f*g2*s**2 + 300*Dd**2*f*g2*s + 5*b2*(-D1**2*bdd1*(2*s**2 - 2*s + 1) - 8*D1**2*fd*s**2 + 16*D1**2*fd*s - 8*D1**2*fd + 5*D1**2*fdd*s**2 - 10*D1**2*fdd*s + 5*D1**2*fdd - 32*D1*Dd*f*s**2 + 16*D1*Dd*f*s - 8*D1*Dd*f + 40*D1*Dd*fd*s**2 - 50*D1*Dd*fd*s + 10*D1*Dd*fd + 20*D1*Ddd*f*s**2 - 10*D1*Ddd*f*s + 5*D1*Ddd*f + 2*D1*bd1*(D1*(2*s**2 - 2*s + 1) + Dd*(-8*s**2 + 6*s - 1)) + 60*Dd**2*f*s**2 - 30*Dd**2*f*s)))/(30*d**2*k2) - D1**2*Pk3*Pkd2*(2*D1**2*bd1**2*s*(s - 1)*(3*b2 + f*(2*C - 1) - 6*g2) + D1*b1*(D1*bdd1*(f*(2*C - 1) - 6*g2)*(2*s**2 - 2*s + 1) + 3*b2*(D1*bdd1*(2*s**2 - 2*s + 1) + 2*Dd*bd1*(8*s**2 - 6*s + 1)) + 2*bd1*(D1*(f*(-2*r*s + r) + s*(9*K*bd1*s - 6*K*bd1 + bd2*(6*s - 3) + fd*(2*C - 1)*(2*s - 1) - 12*gd2*s + 6*gd2)) + Dd*(f*(2*C - 1) - 6*g2)*(8*s**2 - 6*s + 1))) + 3*b1**3*(2*D1*Dd*(-4*r*s + r + 2*s) + D1*Ddd*K*(4*s**2 - 2*s + 1) + 6*Dd**2*K*s*(2*s - 1)) + b1**2*(D1**2*(3*K*bdd1*(3*s**2 - 2*s + 1) + 6*bd1*(-3*r*s + r + s) + s*(-2*fd*(r - 1) + s*(2*C*fdd + 3*bdd2 - fdd - 6*gdd2))) + D1*(2*Dd*(3*K*bd1*(12*s**2 - 7*s + 1) + f*(-4*r*s + r + 2*s) + s*(4*s - 1)*(2*C*fd + 3*bd2 - fd - 6*gd2)) + Ddd*(f*(2*C - 1) - 6*g2)*(4*s**2 - 2*s + 1)) + 6*Dd**2*s*(2*s - 1)*(f*(2*C - 1) - 6*g2) + 3*b2*(D1*Ddd*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(2*s - 1))))/(6*d**2*k2) + D1**2*Pk3*Pkdd2*ct**8*k1**2*k2**2*(D1**2*(-63*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(378*fd**2*s*(2*s - 1) - fd*(308*C - 308)*(3*s**2 - 2*s + 1) + fdd*(154*C - 154)*(3*s**2 - 2*s + 1) + s**2*(99*K*bdd1 - 198*bd1*(K - 1) - 99*bdd1 + 396*gd2 - 198*gdd2)) + 22*f*(fd**2*s*(14*C - 14)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) - 396*fd**2*g2*s*(s - 1)) + D1*f*(-2*Dd*(63*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(22*C*(4*s**2 - 2*s + 1) - 9*fd*(1 - 4*s)**2 - 88*s**2 + 44*s - 22) - 11*f*(fd*(14*C - 14)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) + Ddd*f*(63*f**2 + f*(154*C - 154) - 198*g2)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)*(63*f**2 + f*(154*C - 154) - 198*g2) - 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1386*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct**7*k1*k2**3*(D1**2*(f**3*s**2*(14*bd1 - 7*bdd1) + f**2*(-14*fd*(4*C*(3*s**2 - 2*s + 1) + s**2*(3*bd1 - 9) - s*(bd1 - 6) - 3) + fdd*(28*C - 21)*(3*s**2 - 2*s + 1) + s**2*(18*K*bdd1 - 9*bd1*(4*K - 2) - 9*bdd1 + 72*gd2 - 36*gdd2)) + 2*f*(fd**2*s*(28*C - 21)*(3*s - 2) + 9*fd*g2*(8*s**2 - 8*s + 4) - 9*fd*s*(2*s - 1)*(-2*K*bd1 + bd1 + 4*gd2) - 18*fdd*g2*(2*s**2 - 2*s + 1)) - 72*fd**2*g2*s*(s - 1)) + D1*f*(-2*Dd*(7*f**2*(4*C*(4*s**2 - 2*s + 1) + s**2*(4*bd1 - 12) - s*(bd1 - 6) - 3) + f*(-fd*(28*C - 21)*(12*s**2 - 7*s + 1) - 36*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(-18*K*bd1 + 9*bd1 + 36*gd2)) + 36*fd*g2*(8*s**2 - 6*s + 1)) + Ddd*f*(f*(28*C - 21) - 36*g2)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)*(f*(28*C - 21) - 36*g2) + b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) - 18*fd*(2*K - 1)*(2*s**2 - 2*s + 1) + 9*fdd*(2*K - 1)*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(2*K - 1)*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) - 9*f*(2*K - 1)*(4*s**2 - 2*s + 1) + 9*fd*(2*K - 1)*(8*s**2 - 6*s + 1)) - Ddd*f*(-18*K + 7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(-18*K + 7*f + 9)))/(126*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct**7*k1*k2*(b1*(D1**2*(-7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(3*s - 2) - 18*fd*(2*s**2 - 2*s + 1) + 9*fdd*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(s - 1)) + D1*f*(-2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) + Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(-14*bd1 + 7*bdd1) + f*(14*fd*(s**2*(3*bd1 - 3) - s*(bd1 - 2) - 1) + 7*fdd*(3*s**2 - 2*s + 1) + s**2*(-18*bd1 + 9*bdd1)) + 2*fd*s*(9*bd1*(2*s - 1) + 7*fd*(3*s - 2))) + D1*f*(2*Dd*(7*f*(s**2*(4*bd1 - 4) - s*(bd1 - 2) - 1) + (4*s - 1)*(9*bd1*s + 7*fd*(3*s - 1))) + 7*Ddd*f*(4*s**2 - 2*s + 1)) + 42*Dd**2*f**2*s*(2*s - 1)))/(126*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct**6*k1**2*k2**2*st**2*(D1**2*(-196*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 3*f**2*(392*fd**2*s*(2*s - 1) - fd*(220*C - 220)*(3*s**2 - 2*s + 1) + fdd*(110*C - 110)*(3*s**2 - 2*s + 1) + s**2*(99*K*bdd1 - 198*bd1*(K - 1) - 99*bdd1 + 396*gd2 - 198*gdd2)) + 66*f*(fd**2*s*(10*C - 10)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) - 1188*fd**2*g2*s*(s - 1)) - 2*D1*f*(Dd*(196*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(165*C*(4*s**2 - 2*s + 1) - 98*fd*(1 - 4*s)**2 - 660*s**2 + 330*s - 165) - 33*f*(fd*(10*C - 10)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 594*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(98*f**2 + f*(165*C - 165) - 297*g2)*(4*s**2 - 2*s + 1)) + 12*Dd**2*f**2*s*(2*s - 1)*(98*f**2 + f*(165*C - 165) - 297*g2) - 297*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1386*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct**6*k2**4*(D1**2*(f**2*(-fd*(28*C - 14)*(3*s**2 - 2*s + 1) + fdd*(14*C - 7)*(3*s**2 - 2*s + 1) + s**2*(-18*K*bd1 + 9*K*bdd1 + 36*gd2 - 18*gdd2)) + f*(fd**2*s*(28*C - 14)*(3*s - 2) - 18*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) + s*(2*s - 1)*(-K*bd1 + 2*gd2)) - 9*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(-2*Dd*(f**2*(14*C - 7)*(4*s**2 - 2*s + 1) - f*fd*(14*C - 7)*(12*s**2 - 7*s + 1) + 9*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) + s*(4*s - 1)*(-K*bd1 + 2*gd2)) + 9*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) + Ddd*f*(4*s**2 - 2*s + 1)*(14*C*f + 9*K*b1 - 7*f - 18*g2)) + 6*Dd**2*f**2*s*(2*s - 1)*(14*C*f + 9*K*b1 - 7*f - 18*g2))/(126*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct**6*k2**2*(D1**2*(f**2*(fd*(28*C - 14)*(3*s**2 - 2*s + 1) - fdd*(14*C - 7)*(3*s**2 - 2*s + 1) + s**2*(18*K*bd1 - 9*K*bdd1 + 18*bd2 - 9*bdd2 - 36*gd2 + 18*gdd2)) + f*(fd**2*s*(14 - 28*C)*(3*s - 2) + 18*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) - s*(2*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 9*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(14*C - 7)*(4*s**2 - 2*s + 1) - f*fd*(14*C - 7)*(12*s**2 - 7*s + 1) + 9*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) - s*(4*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 9*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(14*C*f + 9*K*b1 - 7*f - 18*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(14*C*f + 9*K*b1 - 7*f - 18*g2) + 9*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(126*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct**5*k1*k2**3*st**2*(D1**2*(f**3*s**2*(14*bd1 - 7*bdd1) + f**2*(-2*fd*(20*C*(3*s**2 - 2*s + 1) + s**2*(21*bd1 - 45) + s*(30 - 7*bd1) - 15) + fdd*(20*C - 15)*(3*s**2 - 2*s + 1) + s**2*(18*K*bdd1 - 9*bd1*(4*K - 2) - 9*bdd1 + 72*gd2 - 36*gdd2)) + 2*f*(fd**2*s*(20*C - 15)*(3*s - 2) + 9*fd*g2*(8*s**2 - 8*s + 4) - 9*fd*s*(2*s - 1)*(-2*K*bd1 + bd1 + 4*gd2) - 18*fdd*g2*(2*s**2 - 2*s + 1)) - 72*fd**2*g2*s*(s - 1)) + D1*f*(-2*Dd*(f**2*(20*C*(4*s**2 - 2*s + 1) + s**2*(28*bd1 - 60) + s*(30 - 7*bd1) - 15) + f*(-fd*(20*C - 15)*(12*s**2 - 7*s + 1) - 36*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(-18*K*bd1 + 9*bd1 + 36*gd2)) + 36*fd*g2*(8*s**2 - 6*s + 1)) + Ddd*f*(f*(20*C - 15) - 36*g2)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)*(f*(20*C - 15) - 36*g2) + b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) - 18*fd*(2*K - 1)*(2*s**2 - 2*s + 1) + 9*fdd*(2*K - 1)*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(2*K - 1)*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) - 9*f*(2*K - 1)*(4*s**2 - 2*s + 1) + 9*fd*(2*K - 1)*(8*s**2 - 6*s + 1)) - Ddd*f*(-18*K + 7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(-18*K + 7*f + 9)))/(42*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct**5*k1*k2*st**2*(b1*(D1**2*(-7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(3*s - 2) - 18*fd*(2*s**2 - 2*s + 1) + 9*fdd*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(s - 1)) + D1*f*(-2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) + Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(-14*bd1 + 7*bdd1) + f*(2*fd*(s**2*(21*bd1 - 15) + s*(10 - 7*bd1) - 5) + 5*fdd*(3*s**2 - 2*s + 1) + s**2*(-18*bd1 + 9*bdd1)) + 2*fd*s*(9*bd1*(2*s - 1) + 5*fd*(3*s - 2))) + D1*f*(2*Dd*(f*(s**2*(28*bd1 - 20) + s*(10 - 7*bd1) - 5) + (4*s - 1)*(9*bd1*s + 5*fd*(3*s - 1))) + 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(2*s - 1)))/(42*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct**5*k1*(D1*f*s*(2*D1*bd1**2*s*(5*f + 7) + 5*D1*bdd1*f*s + 10*bd1*(-D1*(f*s - 2*fd*s + fd) + Dd*f*(4*s - 1))) + b1**2*(D1**2*(10*fd**2*s*(s - 1) - 2*fd*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2) + fdd*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2)) + D1*(-2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) + Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(-20*bd1 + 10*bdd1) + f*(10*fd*(s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) + 5*fdd*(2*s**2 - 2*s + 1) + s**2*(-28*bd1 + 14*bdd1)) + 2*fd*s*(14*bd1 + 5*fd)*(s - 1)) + D1*f*(2*Dd*(5*f*(s**2*(8*bd1 - 4) - s*(2*bd1 - 2) - 1) + (4*s - 1)*(14*bd1*s + 5*fd*(2*s - 1))) + 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(2*s - 1)))/(70*d**2*k2) + D1**2*Pk3*Pkdd2*ct**4*k1**2*k2**2*st**4*(D1**2*(-70*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 3*f**2*(140*fd**2*s*(2*s - 1) - fd*(44*C - 44)*(3*s**2 - 2*s + 1) + fdd*(22*C - 22)*(3*s**2 - 2*s + 1) + s**2*(33*K*bdd1 - 66*bd1*(K - 1) - 33*bdd1 + 132*gd2 - 66*gdd2)) + 66*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 3*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 3*fdd*g2*(2*s**2 - 2*s + 1)) - 396*fd**2*g2*s*(s - 1)) - 2*D1*f*(Dd*(70*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(33*C*(4*s**2 - 2*s + 1) - 35*fd*(1 - 4*s)**2 - 132*s**2 + 66*s - 33) - 33*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 6*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(3*K*bd1 - 3*bd1 - 6*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(35*f**2 + f*(33*C - 33) - 99*g2)*(4*s**2 - 2*s + 1)) + 12*Dd**2*f**2*s*(2*s - 1)*(35*f**2 + f*(33*C - 33) - 99*g2) - 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(462*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct**4*k2**4*st**2*(D1**2*(f**2*(-fd*(20*C - 10)*(3*s**2 - 2*s + 1) + fdd*(10*C - 5)*(3*s**2 - 2*s + 1) + s**2*(-18*K*bd1 + 9*K*bdd1 + 36*gd2 - 18*gdd2)) + f*(fd**2*s*(20*C - 10)*(3*s - 2) - 18*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) + s*(2*s - 1)*(-K*bd1 + 2*gd2)) - 9*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) - 18*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(-2*Dd*(f**2*(10*C - 5)*(4*s**2 - 2*s + 1) - f*fd*(10*C - 5)*(12*s**2 - 7*s + 1) + 9*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) + s*(4*s - 1)*(-K*bd1 + 2*gd2)) + 9*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) + Ddd*f*(4*s**2 - 2*s + 1)*(10*C*f + 9*K*b1 - 5*f - 18*g2)) + 6*Dd**2*f**2*s*(2*s - 1)*(10*C*f + 9*K*b1 - 5*f - 18*g2))/(42*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct**4*k2**2*st**2*(D1**2*(f**2*(fd*(20*C - 10)*(3*s**2 - 2*s + 1) - fdd*(10*C - 5)*(3*s**2 - 2*s + 1) + s**2*(18*K*bd1 - 9*K*bdd1 + 18*bd2 - 9*bdd2 - 36*gd2 + 18*gdd2)) + f*(fd**2*s*(10 - 20*C)*(3*s - 2) + 18*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) - s*(2*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 9*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(10*C - 5)*(4*s**2 - 2*s + 1) - f*fd*(10*C - 5)*(12*s**2 - 7*s + 1) + 9*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) - s*(4*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 9*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(10*C*f + 9*K*b1 - 5*f - 18*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(10*C*f + 9*K*b1 - 5*f - 18*g2) + 9*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(42*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct**4*(D1*s*(-14*D1*K*bd1**2*f*s + D1*bdd1*f*s*(f*(5 - 10*C) + 14*g2) - 7*b2*(D1*bdd1*f*s + 2*bd1*(-D1*f*s + D1*fd*(s - 1) + Dd*f*(4*s - 1))) - 2*bd1*(D1*(f**2*s*(5 - 10*C) + f*fd*(10*C - 5)*(2*s - 1) + 7*f*s*(bd2 + 2*g2 - 2*gd2) - 14*fd*g2*(s - 1)) + Dd*f*(4*s - 1)*(f*(10*C - 5) - 14*g2))) + 7*K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(D1**2*(f*(fd*(20*C - 10)*(2*s**2 - 2*s + 1) - fdd*(10*C - 5)*(2*s**2 - 2*s + 1) + s**2*(28*K*bd1 - 14*K*bdd1 + 14*bd2 - 7*bdd2 - 28*gd2 + 14*gdd2)) + (2 - 2*s)*(fd**2*s*(10*C - 5) + 7*fd*(2*g2*(s - 1) + s*(2*K*bd1 + bd2 - 2*gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(f**2*(10*C - 5)*(4*s**2 - 2*s + 1) - f*fd*(10*C - 5)*(8*s**2 - 6*s + 1) - 7*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(2*K*bd1 + bd2 - 2*gd2)) + 14*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(f*(10*C - 5) - 14*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(f*(10*C - 5) - 14*g2) + 7*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(70*d**2) + D1**2*Pk3*Pkdd2*ct**3*k1*k2**3*st**4*(D1**2*(f**3*s**2*(14*bd1 - 7*bdd1) + f**2*(-2*fd*(12*C*(3*s**2 - 2*s + 1) + s**2*(21*bd1 - 27) + s*(18 - 7*bd1) - 9) + fdd*(12*C - 9)*(3*s**2 - 2*s + 1) + s**2*(18*K*bdd1 - 9*bd1*(4*K - 2) - 9*bdd1 + 72*gd2 - 36*gdd2)) + 6*f*(fd**2*s*(4*C - 3)*(3*s - 2) + 3*fd*g2*(8*s**2 - 8*s + 4) - 3*fd*s*(2*s - 1)*(-2*K*bd1 + bd1 + 4*gd2) - 6*fdd*g2*(2*s**2 - 2*s + 1)) - 72*fd**2*g2*s*(s - 1)) + D1*f*(-2*Dd*(f**2*(12*C*(4*s**2 - 2*s + 1) + s**2*(28*bd1 - 36) + s*(18 - 7*bd1) - 9) - 3*f*(fd*(4*C - 3)*(12*s**2 - 7*s + 1) + 12*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(6*K*bd1 - 3*bd1 - 12*gd2)) + 36*fd*g2*(8*s**2 - 6*s + 1)) + 3*Ddd*f*(f*(4*C - 3) - 12*g2)*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(2*s - 1)*(f*(4*C - 3) - 12*g2) + b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) - 18*fd*(2*K - 1)*(2*s**2 - 2*s + 1) + 9*fdd*(2*K - 1)*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(2*K - 1)*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) - 9*f*(2*K - 1)*(4*s**2 - 2*s + 1) + 9*fd*(2*K - 1)*(8*s**2 - 6*s + 1)) - Ddd*f*(-18*K + 7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(-18*K + 7*f + 9)))/(42*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct**3*k1*k2*st**4*(b1*(D1**2*(-7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(3*s - 2) - 18*fd*(2*s**2 - 2*s + 1) + 9*fdd*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(s - 1)) + D1*f*(-2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) + Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(-14*bd1 + 7*bdd1) + f*(2*fd*(s**2*(21*bd1 - 9) + s*(6 - 7*bd1) - 3) + fdd*(9*s**2 - 6*s + 3) + s**2*(-18*bd1 + 9*bdd1)) + 6*fd*s*(bd1*(6*s - 3) + fd*(3*s - 2))) + D1*f*(2*Dd*f*(s**2*(28*bd1 - 12) + s*(6 - 7*bd1) - 3) + 6*Dd*(4*s - 1)*(3*bd1*s + fd*(3*s - 1)) + 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(2*s - 1)))/(42*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct**3*k1*st**2*(D1*f*s*(2*D1*bd1**2*s*(5*f + 7) - 6*D1*bd1*(f*s - 2*fd*s + fd) + 3*D1*bdd1*f*s + 6*Dd*bd1*f*(4*s - 1)) + b1**2*(D1**2*(10*fd**2*s*(s - 1) - 2*fd*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2) + fdd*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2)) + D1*(-2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) + Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(-20*bd1 + 10*bdd1) + f*(2*fd*(s**2*(20*bd1 - 6) + s*(6 - 10*bd1) - 3) + fdd*(6*s**2 - 6*s + 3) + s**2*(-28*bd1 + 14*bdd1)) + 2*fd*s*(14*bd1 + 3*fd)*(s - 1)) + D1*f*(2*Dd*(f*(s**2*(40*bd1 - 12) + s*(6 - 10*bd1) - 3) + (4*s - 1)*(14*bd1*s + fd*(6*s - 3))) + 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(2*s - 1)))/(35*d**2*k2) + D1**2*Pk3*Pkdd2*ct**2*k1**2*k2**2*st**6*(D1**2*(-84*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(504*fd**2*s*(2*s - 1) - fd*(44*C - 44)*(3*s**2 - 2*s + 1) + fdd*(22*C - 22)*(3*s**2 - 2*s + 1) + s**2*(99*K*bdd1 - 198*bd1*(K - 1) - 99*bdd1 + 396*gd2 - 198*gdd2)) + 22*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 9*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 9*fdd*g2*(2*s**2 - 2*s + 1)) - 396*fd**2*g2*s*(s - 1)) - 2*D1*f*(Dd*(84*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(11*C*(4*s**2 - 2*s + 1) - 42*fd*(1 - 4*s)**2 - 44*s**2 + 22*s - 11) - 11*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 9*g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(9*K*bd1 - 9*bd1 - 18*gd2)) + 198*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(42*f**2 + f*(11*C - 11) - 99*g2)*(4*s**2 - 2*s + 1)) + 12*Dd**2*f**2*s*(2*s - 1)*(42*f**2 + f*(11*C - 11) - 99*g2) - 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1386*d**2*k3**4) - D1**2*Pk3*Pkdd2*ct**2*k2**4*st**4*(D1**2*(f**2*(fd*(4*C - 2)*(3*s**2 - 2*s + 1) - fdd*(2*C - 1)*(3*s**2 - 2*s + 1) + s**2*(6*K*bd1 - 3*K*bdd1 - 12*gd2 + 6*gdd2)) + f*(2*fd**2*s*(C*(4 - 6*s) + 3*s - 2) + 6*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) + s*(2*s - 1)*(-K*bd1 + 2*gd2)) + 3*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 6*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*s**2 - 2*s + 1) - f*fd*(2*C - 1)*(12*s**2 - 7*s + 1) + 3*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) + s*(4*s - 1)*(-K*bd1 + 2*gd2)) + 3*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(3*K*b1 + f*(2*C - 1) - 6*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(3*K*b1 + f*(2*C - 1) - 6*g2))/(14*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct**2*k2**2*st**4*(D1**2*(f**2*(fd*(4*C - 2)*(3*s**2 - 2*s + 1) - fdd*(2*C - 1)*(3*s**2 - 2*s + 1) + s**2*(6*K*bd1 - 3*K*bdd1 + 6*bd2 - 3*bdd2 - 12*gd2 + 6*gdd2)) + f*(2*fd**2*s*(C*(4 - 6*s) + 3*s - 2) + 6*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) - s*(2*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 3*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 6*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*s**2 - 2*s + 1) - f*fd*(2*C - 1)*(12*s**2 - 7*s + 1) + 3*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) - s*(4*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 3*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(3*K*b1 + f*(2*C - 1) - 6*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(3*K*b1 + f*(2*C - 1) - 6*g2) + 3*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(14*d**2*k3**2) - D1**2*Pk3*Pkdd2*ct**2*k2**2*(D1**2*bd1*(5*b2*f*(s - 1)**2 - (f*(6*C - 3) - 10*g2)*(2*bd1*s*(s - 1) + f*(2*s - 1))) + D1*b1*(12*C*D1*f*fd*s - 6*C*D1*f*fd + 10*D1*K*bd1**2*s*(2 - 3*s) + 5*D1*b2*fd*s**2 + D1*bd1*(f*(12*C*(2*s**2 - 2*s + 1) - 10*K*s + 5*K - 12*s**2 + 12*s - 6) - 20*g2*(2*s**2 - 2*s + 1) - 2*s*(2*s - 1)*(6*C*fd - 3*fd - 10*gd2)) + 5*D1*bd2*f*s**2 - D1*bdd1*(f*(6*C - 3) - 10*g2)*(2*s**2 - 2*s + 1) - 6*D1*f*fd*s + 3*D1*f*fd - 20*D1*fd*g2*s + 10*D1*fd*g2 + 20*Dd*b2*f*s**2 - 10*Dd*b2*f*s + 5*Dd*b2*f - 2*Dd*bd1*(f*(6*C - 3) - 10*g2)*(8*s**2 - 6*s + 1)) + 5*K*b1**3*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + b1**2*(D1**2*(12*C*fd*s**2 - 6*C*fdd*s**2 + 10*K*bd1*(3*s**2 - 2*s + 1) - 5*K*bdd1*(3*s**2 - 2*s + 1) + 10*K*fd*s - 5*K*fd - 6*fd*s**2 + 3*fdd*s**2 - 20*gd2*s**2 + 10*gdd2*s**2) + D1*(2*Dd*(f*(6*C - 3)*(4*s**2 - 2*s + 1) - 10*g2*(4*s**2 - 2*s + 1) - (4*s - 1)*(5*K*bd1*(3*s - 1) + fd*s*(6*C - 3) - 10*gd2*s)) - Ddd*(f*(6*C - 3) - 10*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*s*(2*s - 1)*(f*(6*C - 3) - 10*g2)))/(30*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct**2*st**2*(D1*s*(-14*D1*K*bd1**2*f*s + D1*bdd1*f*s*(f*(3 - 6*C) + 14*g2) - 7*b2*(D1*bdd1*f*s + 2*bd1*(-D1*f*s + D1*fd*(s - 1) + Dd*f*(4*s - 1))) - 2*bd1*(D1*(f**2*s*(3 - 6*C) + f*fd*(6*C - 3)*(2*s - 1) + 7*f*s*(bd2 + 2*g2 - 2*gd2) - 14*fd*g2*(s - 1)) + Dd*f*(4*s - 1)*(f*(6*C - 3) - 14*g2))) + 7*K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(D1**2*(f*(fd*(12*C - 6)*(2*s**2 - 2*s + 1) - fdd*(6*C - 3)*(2*s**2 - 2*s + 1) + s**2*(28*K*bd1 - 14*K*bdd1 + 14*bd2 - 7*bdd2 - 28*gd2 + 14*gdd2)) + (2 - 2*s)*(fd**2*s*(6*C - 3) + 7*fd*(2*g2*(s - 1) + s*(2*K*bd1 + bd2 - 2*gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(f**2*(6*C - 3)*(4*s**2 - 2*s + 1) - f*fd*(6*C - 3)*(8*s**2 - 6*s + 1) - 7*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(2*K*bd1 + bd2 - 2*gd2)) + 14*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(f*(6*C - 3) - 14*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(f*(6*C - 3) - 14*g2) + 7*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(35*d**2) + D1**2*Pk3*Pkdd2*ct*k1*k2**3*st**6*(D1**2*(f**3*s**2*(14*bd1 - 7*bdd1) + f**2*(-2*fd*(4*C*(3*s**2 - 2*s + 1) + s**2*(21*bd1 - 9) + s*(6 - 7*bd1) - 3) + fdd*(4*C - 3)*(3*s**2 - 2*s + 1) + s**2*(18*K*bdd1 - 9*bd1*(4*K - 2) - 9*bdd1 + 72*gd2 - 36*gdd2)) + 2*f*(fd**2*s*(4*C - 3)*(3*s - 2) + 9*fd*g2*(8*s**2 - 8*s + 4) - 9*fd*s*(2*s - 1)*(-2*K*bd1 + bd1 + 4*gd2) - 18*fdd*g2*(2*s**2 - 2*s + 1)) - 72*fd**2*g2*s*(s - 1)) + D1*f*(-2*Dd*(f**2*(4*C*(4*s**2 - 2*s + 1) + s**2*(28*bd1 - 12) + s*(6 - 7*bd1) - 3) + f*(-fd*(4*C - 3)*(12*s**2 - 7*s + 1) - 36*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(-18*K*bd1 + 9*bd1 + 36*gd2)) + 36*fd*g2*(8*s**2 - 6*s + 1)) + Ddd*f*(f*(4*C - 3) - 36*g2)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)*(f*(4*C - 3) - 36*g2) + b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) - 18*fd*(2*K - 1)*(2*s**2 - 2*s + 1) + 9*fdd*(2*K - 1)*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(2*K - 1)*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) - 9*f*(2*K - 1)*(4*s**2 - 2*s + 1) + 9*fd*(2*K - 1)*(8*s**2 - 6*s + 1)) - Ddd*f*(-18*K + 7*f + 9)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(-18*K + 7*f + 9)))/(126*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct*k1*k2*st**6*(b1*(D1**2*(-7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(3*s - 2) - 18*fd*(2*s**2 - 2*s + 1) + 9*fdd*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(s - 1)) + D1*f*(-2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 9*fd*(8*s**2 - 6*s + 1)) + Ddd*f*(7*f + 9)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(7*f + 9)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(-14*bd1 + 7*bdd1) + f*(2*fd*(s**2*(21*bd1 - 3) + s*(2 - 7*bd1) - 1) + fdd*(3*s**2 - 2*s + 1) + s**2*(-18*bd1 + 9*bdd1)) + 2*fd*s*(9*bd1*(2*s - 1) + fd*(3*s - 2))) + D1*f*(2*Dd*(f*(s**2*(28*bd1 - 4) + s*(2 - 7*bd1) - 1) + (4*s - 1)*(9*bd1*s + fd*(3*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)))/(126*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct*k1*st**4*(D1*f*s*(2*D1*bd1**2*s*(5*f + 7) + D1*bdd1*f*s - 2*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*(-4*f*s + f))) + b1**2*(D1**2*(10*fd**2*s*(s - 1) - 2*fd*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2) + fdd*(5*f*(2*s**2 - 2*s + 1) + 7*(s - 1)**2)) + D1*(-2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 7*f*(4*s**2 - 2*s + 1) - 7*fd*(4*s**2 - 5*s + 1)) + Ddd*f*(5*f + 7)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f*s*(5*f + 7)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(-20*bd1 + 10*bdd1) + f*(fd*(s**2*(40*bd1 - 4) + s*(4 - 20*bd1) - 2) + fdd*(2*s**2 - 2*s + 1) + s**2*(-28*bd1 + 14*bdd1)) + 2*fd*s*(14*bd1 + fd)*(s - 1)) + D1*f*(2*Dd*(f*(s**2*(40*bd1 - 4) + s*(2 - 10*bd1) - 1) + (4*s - 1)*(14*bd1*s + fd*(2*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)))/(70*d**2*k2) + D1**2*Pk3*Pkdd2*f**2*k1**2*k2**2*st**8*(D1**2*(-f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(2*s - 1)) + D1*f*(-2*Dd*f*(4*s**2 - 2*s + 1) + 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1))/(198*d**2*k3**4) - D1**2*Pk3*Pkdd2*k2**4*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(3*s**2 - 2*s + 1) - fdd*(2*C - 1)*(3*s**2 - 2*s + 1) + s**2*(18*K*bd1 - 9*K*bdd1 - 36*gd2 + 18*gdd2)) + f*(2*fd**2*s*(C*(4 - 6*s) + 3*s - 2) + 18*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) + s*(2*s - 1)*(-K*bd1 + 2*gd2)) + 9*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*s**2 - 2*s + 1) - f*fd*(2*C - 1)*(12*s**2 - 7*s + 1) + 9*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) + s*(4*s - 1)*(-K*bd1 + 2*gd2)) + 9*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(2*C*f + 9*K*b1 - f - 18*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(2*C*f + 9*K*b1 - f - 18*g2))/(126*d**2*k3**4) + D1**2*Pk3*Pkdd2*k2**2*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(3*s**2 - 2*s + 1) - fdd*(2*C - 1)*(3*s**2 - 2*s + 1) + s**2*(18*K*bd1 - 9*K*bdd1 + 18*bd2 - 9*bdd2 - 36*gd2 + 18*gdd2)) + f*(2*fd**2*s*(C*(4 - 6*s) + 3*s - 2) + 18*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) - s*(2*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 9*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 18*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*s**2 - 2*s + 1) - f*fd*(2*C - 1)*(12*s**2 - 7*s + 1) + 9*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) - s*(4*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 9*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(2*C*f + 9*K*b1 - f - 18*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(2*C*f + 9*K*b1 - f - 18*g2) + 9*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(126*d**2*k3**2) - D1**2*Pk3*Pkdd2*k2**2*st**2*(D1**2*bd1*(5*b2*f*(s - 1)**2 - (f*(2*C - 1) - 10*g2)*(2*bd1*s*(s - 1) + f*(2*s - 1))) + D1*b1*(4*C*D1*f*fd*s - 2*C*D1*f*fd + 10*D1*K*bd1**2*s*(2 - 3*s) + 5*D1*b2*fd*s**2 + D1*bd1*(f*(C*(8*s**2 - 8*s + 4) - 10*K*s + 5*K - 4*s**2 + 4*s - 2) - 20*g2*(2*s**2 - 2*s + 1) + s*(2*s - 1)*(-4*C*fd + 2*fd + 20*gd2)) + 5*D1*bd2*f*s**2 - D1*bdd1*(f*(2*C - 1) - 10*g2)*(2*s**2 - 2*s + 1) - 2*D1*f*fd*s + D1*f*fd - 20*D1*fd*g2*s + 10*D1*fd*g2 + 20*Dd*b2*f*s**2 - 10*Dd*b2*f*s + 5*Dd*b2*f - 2*Dd*bd1*(f*(2*C - 1) - 10*g2)*(8*s**2 - 6*s + 1)) + 5*K*b1**3*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + b1**2*(D1**2*(4*C*fd*s**2 - 2*C*fdd*s**2 + 10*K*bd1*(3*s**2 - 2*s + 1) - 5*K*bdd1*(3*s**2 - 2*s + 1) + 10*K*fd*s - 5*K*fd - 2*fd*s**2 + fdd*s**2 - 20*gd2*s**2 + 10*gdd2*s**2) + D1*(2*Dd*(f*(2*C - 1)*(4*s**2 - 2*s + 1) - 10*g2*(4*s**2 - 2*s + 1) - (4*s - 1)*(5*K*bd1*(3*s - 1) + fd*s*(2*C - 1) - 10*gd2*s)) - Ddd*(f*(2*C - 1) - 10*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*s*(2*s - 1)*(f*(2*C - 1) - 10*g2)))/(30*d**2*k3**2) + D1**2*Pk3*Pkdd2*st**4*(D1*s*(-14*D1*K*bd1**2*f*s + D1*bdd1*f*s*(-2*C*f + f + 14*g2) - 7*b2*(D1*bdd1*f*s + 2*bd1*(-D1*f*s + D1*fd*(s - 1) + Dd*f*(4*s - 1))) - 2*bd1*(D1*(f**2*(-2*C*s + s) + f*fd*(2*C - 1)*(2*s - 1) + 7*f*s*(bd2 + 2*g2 - 2*gd2) - 14*fd*g2*(s - 1)) + Dd*f*(4*s - 1)*(f*(2*C - 1) - 14*g2))) + 7*K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(D1**2*(f*(fd*(4*C - 2)*(2*s**2 - 2*s + 1) - fdd*(2*C - 1)*(2*s**2 - 2*s + 1) + s**2*(28*K*bd1 - 14*K*bdd1 + 14*bd2 - 7*bdd2 - 28*gd2 + 14*gdd2)) + (2 - 2*s)*(fd**2*s*(2*C - 1) + 7*fd*(2*g2*(s - 1) + s*(2*K*bd1 + bd2 - 2*gd2)) - 7*fdd*g2*(s - 1))) + D1*(2*Dd*(f**2*(2*C - 1)*(4*s**2 - 2*s + 1) - f*fd*(2*C - 1)*(8*s**2 - 6*s + 1) - 7*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(2*K*bd1 + bd2 - 2*gd2)) + 14*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(f*(2*C - 1) - 14*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(f*(2*C - 1) - 14*g2) + 7*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(70*d**2) - D1**2*Pk3*ct**7*k1*k2*(-19008*C*D1**2*Pk2*f**2*fd*r*s + 6336*C*D1**2*Pk2*f**2*fd*r + 14784*C*D1**2*Pk2*f**2*fd*s**2 - 3520*C*D1**2*Pk2*f**2*fd*s + 4928*C*D1**2*Pk2*f**2*fd + 9504*C*D1**2*Pk2*f**2*fdd*r*s - 3168*C*D1**2*Pk2*f**2*fdd*r - 7392*C*D1**2*Pk2*f**2*fdd*s**2 + 1760*C*D1**2*Pk2*f**2*fdd*s - 2464*C*D1**2*Pk2*f**2*fdd + 19008*C*D1**2*Pk2*f*fd**2*r*s - 6336*C*D1**2*Pk2*f*fd**2*r - 14784*C*D1**2*Pk2*f*fd**2*s**2 + 3520*C*D1**2*Pk2*f*fd**2*s + 3168*C*D1**2*Pk2*f*fd**2 + 1848*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 1232*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 616*C*D1**2*Pkdd2*f**2*fd*k1**2 - 924*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 616*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 308*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 1848*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 1232*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 25344*C*D1*Dd*Pk2*f**3*r*s + 6336*C*D1*Dd*Pk2*f**3*r + 19712*C*D1*Dd*Pk2*f**3*s**2 + 2816*C*D1*Dd*Pk2*f**3*s + 4928*C*D1*Dd*Pk2*f**3 + 76032*C*D1*Dd*Pk2*f**2*fd*r*s - 22176*C*D1*Dd*Pk2*f**2*fd*r - 59136*C*D1*Dd*Pk2*f**2*fd*s**2 + 2816*C*D1*Dd*Pk2*f**2*fd*s + 4576*C*D1*Dd*Pk2*f**2*fd + 2464*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 1232*C*D1*Dd*Pkdd2*f**3*k1**2*s + 616*C*D1*Dd*Pkdd2*f**3*k1**2 - 7392*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 4312*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 616*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 12672*C*D1*Ddd*Pk2*f**3*r*s - 3168*C*D1*Ddd*Pk2*f**3*r - 9856*C*D1*Ddd*Pk2*f**3*s**2 - 1408*C*D1*Ddd*Pk2*f**3*s - 2464*C*D1*Ddd*Pk2*f**3 - 1232*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 616*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 308*C*D1*Ddd*Pkdd2*f**3*k1**2 + 38016*C*Dd**2*Pk2*f**3*r*s - 9504*C*Dd**2*Pk2*f**3*r - 29568*C*Dd**2*Pk2*f**3*s**2 - 4224*C*Dd**2*Pk2*f**3*s + 6336*C*Dd**2*Pk2*f**3 - 3696*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1848*C*Dd**2*Pkdd2*f**3*k1**2*s + 1584*D1**2*K*Pk2*bdd1*f**2*r*s - 1584*D1**2*K*Pk2*bdd1*f**2*s**2 - 1584*D1**2*K*Pk2*bdd1*f**2*s - 198*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 1232*D1**2*Pk2*bdd1*f**3*r*s - 616*D1**2*Pk2*bdd1*f**3*s**2 + 1232*D1**2*Pk2*bdd1*f**3*s - 3168*D1**2*Pk2*bdd1*f**2*r*s - 792*D1**2*Pk2*bdd1*f**2*s**2 + 3168*D1**2*Pk2*bdd1*f**2*s - 4928*D1**2*Pk2*f**3*fd*r*s + 1232*D1**2*Pk2*f**3*fd*r + 2464*D1**2*Pk2*f**3*fd*s + 4928*D1**2*Pk2*f**3*fdd*r*s - 1232*D1**2*Pk2*f**3*fdd*r - 2464*D1**2*Pk2*f**3*fdd*s + 14784*D1**2*Pk2*f**2*fd**2*r*s - 3696*D1**2*Pk2*f**2*fd**2*r - 7392*D1**2*Pk2*f**2*fd**2*s + 2464*D1**2*Pk2*f**2*fd**2 + 26400*D1**2*Pk2*f**2*fd*r*s - 8800*D1**2*Pk2*f**2*fd*r - 3696*D1**2*Pk2*f**2*fd*s**2 - 6336*D1**2*Pk2*f**2*fd*s - 1232*D1**2*Pk2*f**2*fd - 13200*D1**2*Pk2*f**2*fdd*r*s + 4400*D1**2*Pk2*f**2*fdd*r + 1848*D1**2*Pk2*f**2*fdd*s**2 + 3168*D1**2*Pk2*f**2*fdd*s + 616*D1**2*Pk2*f**2*fdd + 6336*D1**2*Pk2*f**2*gd2*r*s - 6336*D1**2*Pk2*f**2*gd2*s**2 - 6336*D1**2*Pk2*f**2*gd2*s - 3168*D1**2*Pk2*f**2*gdd2*r*s + 3168*D1**2*Pk2*f**2*gdd2*s**2 + 3168*D1**2*Pk2*f**2*gdd2*s - 26400*D1**2*Pk2*f*fd**2*r*s + 8800*D1**2*Pk2*f*fd**2*r + 3696*D1**2*Pk2*f*fd**2*s**2 + 6336*D1**2*Pk2*f*fd**2*s - 4400*D1**2*Pk2*f*fd**2 + 12672*D1**2*Pk2*f*fd*g2*r*s - 6336*D1**2*Pk2*f*fd*g2*r - 12672*D1**2*Pk2*f*fd*g2*s**2 + 12672*D1**2*Pk2*f*fd*g2*s - 6336*D1**2*Pk2*f*fd*g2 - 12672*D1**2*Pk2*f*fd*gd2*r*s + 3168*D1**2*Pk2*f*fd*gd2*r + 12672*D1**2*Pk2*f*fd*gd2*s**2 - 3168*D1**2*Pk2*f*fd*gd2 - 6336*D1**2*Pk2*f*fdd*g2*r*s + 3168*D1**2*Pk2*f*fdd*g2*r + 6336*D1**2*Pk2*f*fdd*g2*s**2 - 6336*D1**2*Pk2*f*fdd*g2*s + 3168*D1**2*Pk2*f*fdd*g2 - 6336*D1**2*Pk2*fd**2*g2*r*s + 3168*D1**2*Pk2*fd**2*g2*r + 6336*D1**2*Pk2*fd**2*g2*s**2 - 6336*D1**2*Pk2*fd**2*g2*s + 198*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 1512*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 756*D1**2*Pkdd2*f**3*fd*k1**2*s + 378*D1**2*Pkdd2*f**3*fd*k1**2 - 756*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 378*D1**2*Pkdd2*f**3*fdd*k1**2*s - 189*D1**2*Pkdd2*f**3*fdd*k1**2 - 2268*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 1134*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 1848*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 1232*D1**2*Pkdd2*f**2*fd*k1**2*s - 616*D1**2*Pkdd2*f**2*fd*k1**2 + 924*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 616*D1**2*Pkdd2*f**2*fdd*k1**2*s + 308*D1**2*Pkdd2*f**2*fdd*k1**2 - 792*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 396*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 1848*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 1232*D1**2*Pkdd2*f*fd**2*k1**2*s - 1584*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 1584*D1**2*Pkdd2*f*fd*g2*k1**2*s - 792*D1**2*Pkdd2*f*fd*g2*k1**2 + 1584*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 792*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 792*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 792*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 396*D1**2*Pkdd2*f*fdd*g2*k1**2 + 792*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 792*D1**2*Pkdd2*fd**2*g2*k1**2*s - 4928*D1*Dd*Pk2*f**4*r*s + 1232*D1*Dd*Pk2*f**4*r + 2464*D1*Dd*Pk2*f**4*s + 39424*D1*Dd*Pk2*f**3*fd*r*s - 9856*D1*Dd*Pk2*f**3*fd*r - 19712*D1*Dd*Pk2*f**3*fd*s + 4928*D1*Dd*Pk2*f**3*fd + 35200*D1*Dd*Pk2*f**3*r*s - 8800*D1*Dd*Pk2*f**3*r - 4928*D1*Dd*Pk2*f**3*s**2 - 15136*D1*Dd*Pk2*f**3*s - 1232*D1*Dd*Pk2*f**3 - 105600*D1*Dd*Pk2*f**2*fd*r*s + 30800*D1*Dd*Pk2*f**2*fd*r + 14784*D1*Dd*Pk2*f**2*fd*s**2 + 35376*D1*Dd*Pk2*f**2*fd*s - 11968*D1*Dd*Pk2*f**2*fd + 25344*D1*Dd*Pk2*f**2*g2*r*s - 6336*D1*Dd*Pk2*f**2*g2*r - 25344*D1*Dd*Pk2*f**2*g2*s**2 - 6336*D1*Dd*Pk2*f**2*g2 - 25344*D1*Dd*Pk2*f**2*gd2*r*s + 3168*D1*Dd*Pk2*f**2*gd2*r + 25344*D1*Dd*Pk2*f**2*gd2*s**2 + 12672*D1*Dd*Pk2*f**2*gd2*s - 3168*D1*Dd*Pk2*f**2*gd2 - 50688*D1*Dd*Pk2*f*fd*g2*r*s + 19008*D1*Dd*Pk2*f*fd*g2*r + 50688*D1*Dd*Pk2*f*fd*g2*s**2 - 25344*D1*Dd*Pk2*f*fd*g2*s + 1512*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 756*D1*Dd*Pkdd2*f**4*k1**2*s + 378*D1*Dd*Pkdd2*f**4*k1**2 - 6048*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 3024*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 378*D1*Dd*Pkdd2*f**3*fd*k1**2 - 2464*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 1232*D1*Dd*Pkdd2*f**3*k1**2*s - 616*D1*Dd*Pkdd2*f**3*k1**2 + 7392*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 4312*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 616*D1*Dd*Pkdd2*f**2*fd*k1**2 - 3168*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 1584*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 792*D1*Dd*Pkdd2*f**2*g2*k1**2 + 3168*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 792*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 6336*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 4752*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 792*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 4928*D1*Ddd*Pk2*f**4*r*s - 1232*D1*Ddd*Pk2*f**4*r - 2464*D1*Ddd*Pk2*f**4*s - 17600*D1*Ddd*Pk2*f**3*r*s + 4400*D1*Ddd*Pk2*f**3*r + 2464*D1*Ddd*Pk2*f**3*s**2 + 7568*D1*Ddd*Pk2*f**3*s + 616*D1*Ddd*Pk2*f**3 - 12672*D1*Ddd*Pk2*f**2*g2*r*s + 3168*D1*Ddd*Pk2*f**2*g2*r + 12672*D1*Ddd*Pk2*f**2*g2*s**2 + 3168*D1*Ddd*Pk2*f**2*g2 - 756*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 378*D1*Ddd*Pkdd2*f**4*k1**2*s - 189*D1*Ddd*Pkdd2*f**4*k1**2 + 1232*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 616*D1*Ddd*Pkdd2*f**3*k1**2*s + 308*D1*Ddd*Pkdd2*f**3*k1**2 + 1584*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 792*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 396*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 44*D1*bd1*f*(D1*f*s*(4*Pk2*(9*K*(-2*r + 2*s + 2) + 7*f*(2*r + s - 2) + 36*r + 9*s - 36) + Pkdd2*k1**2*s*(9*K - 9)) - D1*fd*(4*Pk2*(-9*K*r*(4*s - 1) + 36*K*s**2 - 9*K + 7*f*(r*(6*s - 1) + 3*s**2 - 5*s + 1) - 9*r*(2 - 8*s) + 18*s**2 - 45*s + 18) + Pkdd2*k1**2*s*(9*K - 9)*(2*s - 1)) - 4*Dd*Pk2*f*(9*K*(-8*r*s + r + 8*s**2 + 4*s - 1) + 7*f*(r*(8*s - 1) + 4*s**2 - 7*s + 1) + 144*r*s - 18*r + 36*s**2 - 117*s + 18) - 9*Dd*Pkdd2*f*k1**2*s*(K - 1)*(4*s - 1)) + 14784*Dd**2*Pk2*f**4*r*s - 3696*Dd**2*Pk2*f**4*r - 7392*Dd**2*Pk2*f**4*s + 2464*Dd**2*Pk2*f**4 - 52800*Dd**2*Pk2*f**3*r*s + 13200*Dd**2*Pk2*f**3*r + 7392*Dd**2*Pk2*f**3*s**2 + 22704*Dd**2*Pk2*f**3*s - 8800*Dd**2*Pk2*f**3 - 38016*Dd**2*Pk2*f**2*g2*r*s + 9504*Dd**2*Pk2*f**2*g2*r + 38016*Dd**2*Pk2*f**2*g2*s**2 - 6336*Dd**2*Pk2*f**2*g2 - 2268*Dd**2*Pkdd2*f**4*k1**2*s**2 + 1134*Dd**2*Pkdd2*f**4*k1**2*s + 3696*Dd**2*Pkdd2*f**3*k1**2*s**2 - 1848*Dd**2*Pkdd2*f**3*k1**2*s + 4752*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 2376*Dd**2*Pkdd2*f**2*g2*k1**2*s + 22*b1*(D1**2*(28*Pk2*f**2*(2*fd - fdd)*(3*s - 1)*(2*r + s - 1) + f*(-56*Pk2*fd**2*(3*s - 1)*(2*r + s - 1) - 72*Pk2*fd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) + r*(4 - 8*s) - 2*s**2 + 2*s - 1) + 36*Pk2*fdd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) + r*(4 - 8*s) - 2*s**2 + 2*s - 1) + 18*Pkdd2*fd*k1**2*(K - 1)*(2*s**2 - 2*s + 1) - 9*Pkdd2*fdd*k1**2*(K - 1)*(2*s**2 - 2*s + 1)) + 18*fd**2*(Pk2*r*(4*K - 8)*(2*s - 1) + Pk2*s*(-8*K - 4)*(s - 1) + Pkdd2*k1**2*s*(-K*s + K + s - 1))) + D1*f*(2*Dd*(28*Pk2*f**2*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + f*(-4*Pk2*(-18*K*(-4*r*s + r + 4*s**2 + 1) + 7*fd*(r*(24*s - 7) + 12*s**2 - 17*s + 4) - 144*r*s + 36*r - 36*s**2 + 90*s - 9) + Pkdd2*k1**2*(9*K - 9)*(4*s**2 - 2*s + 1)) - 9*fd*(Pk2*r*(16 - 8*K)*(8*s - 3) + 4*Pk2*(2*s - 1)*(s*(8*K + 4) - 5) + Pkdd2*k1**2*(K - 1)*(8*s**2 - 6*s + 1))) - Ddd*f*(4*Pk2*(18*K*(-4*r*s + r + 4*s**2 + 1) + 7*f*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + 144*r*s - 36*r + 36*s**2 - 90*s + 9) + Pkdd2*k1**2*(9*K - 9)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(4*Pk2*(-9*K*(12*r*s - 3*r - 12*s**2 + 2) + 7*f*(3*r*(4*s - 1) + 6*s**2 - 9*s + 2) + 216*r*s - 54*r + 54*s**2 - 135*s + 36) + Pkdd2*k1**2*s*(27*K - 27)*(2*s - 1))))/(1386*d**2*k3**4) + D1**2*Pk3*ct**6*k1**2*(15840*C*D1**2*Pk2*bdd1*f**2*r*s + 23760*C*D1**2*Pk2*bdd1*f**2*s**2 - 15840*C*D1**2*Pk2*bdd1*f**2*s + 7920*C*D1**2*Pk2*bdd1*f**2 + 237600*C*D1**2*Pk2*f**2*fd*r*s - 79200*C*D1**2*Pk2*f**2*fd*r + 33000*C*D1**2*Pk2*f**2*fd*s**2 - 101200*C*D1**2*Pk2*f**2*fd*s + 11000*C*D1**2*Pk2*f**2*fd - 142560*C*D1**2*Pk2*f**2*fdd*r*s + 47520*C*D1**2*Pk2*f**2*fdd*r - 69960*C*D1**2*Pk2*f**2*fdd*s**2 + 94160*C*D1**2*Pk2*f**2*fdd*s - 23320*C*D1**2*Pk2*f**2*fdd - 285120*C*D1**2*Pk2*f*fd**2*r*s + 95040*C*D1**2*Pk2*f*fd**2*r - 139920*C*D1**2*Pk2*f*fd**2*s**2 + 188320*C*D1**2*Pk2*f*fd**2*s - 47520*C*D1**2*Pk2*f*fd**2 - 4620*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 3080*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 1540*C*D1**2*Pkdd2*f**2*fd*k1**2 + 2310*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 1540*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 770*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 4620*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 3080*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 316800*C*D1*Dd*Pk2*f**3*r*s - 79200*C*D1*Dd*Pk2*f**3*r + 44000*C*D1*Dd*Pk2*f**3*s**2 - 180400*C*D1*Dd*Pk2*f**3*s + 11000*C*D1*Dd*Pk2*f**3 - 1140480*C*D1*Dd*Pk2*f**2*fd*r*s + 332640*C*D1*Dd*Pk2*f**2*fd*r - 559680*C*D1*Dd*Pk2*f**2*fd*s**2 + 801680*C*D1*Dd*Pk2*f**2*fd*s - 189200*C*D1*Dd*Pk2*f**2*fd - 6160*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 3080*C*D1*Dd*Pkdd2*f**3*k1**2*s - 1540*C*D1*Dd*Pkdd2*f**3*k1**2 + 18480*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 10780*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 1540*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 190080*C*D1*Ddd*Pk2*f**3*r*s + 47520*C*D1*Ddd*Pk2*f**3*r - 93280*C*D1*Ddd*Pk2*f**3*s**2 + 141680*C*D1*Ddd*Pk2*f**3*s - 23320*C*D1*Ddd*Pk2*f**3 + 3080*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 1540*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 770*C*D1*Ddd*Pkdd2*f**3*k1**2 - 570240*C*Dd**2*Pk2*f**3*r*s + 142560*C*Dd**2*Pk2*f**3*r - 279840*C*Dd**2*Pk2*f**3*s**2 + 425040*C*Dd**2*Pk2*f**3*s - 95040*C*Dd**2*Pk2*f**3 + 9240*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 4620*C*Dd**2*Pkdd2*f**3*k1**2*s - 26928*D1**2*K*Pk2*bdd1*f**2*r*s - 17028*D1**2*K*Pk2*bdd1*f**2*s**2 + 26928*D1**2*K*Pk2*bdd1*f**2*s + 495*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 11088*D1**2*Pk2*bd1**2*f*s*(K - 1)*(2*r + 3*s - 2) + 24640*D1**2*Pk2*bdd1*f**3*r*s + 18480*D1**2*Pk2*bdd1*f**3*s**2 - 24640*D1**2*Pk2*bdd1*f**3*s + 3080*D1**2*Pk2*bdd1*f**3 + 34848*D1**2*Pk2*bdd1*f**2*r*s + 24948*D1**2*Pk2*bdd1*f**2*s**2 - 34848*D1**2*Pk2*bdd1*f**2*s - 7920*D1**2*Pk2*bdd1*f**2 - 22176*D1**2*Pk2*bdd1*f*g2*r*s - 33264*D1**2*Pk2*bdd1*f*g2*s**2 + 22176*D1**2*Pk2*bdd1*f*g2*s - 11088*D1**2*Pk2*bdd1*f*g2 + 110880*D1**2*Pk2*f**3*fd*r*s - 27720*D1**2*Pk2*f**3*fd*r + 104720*D1**2*Pk2*f**3*fd*s**2 - 107800*D1**2*Pk2*f**3*fd*s + 26180*D1**2*Pk2*f**3*fd - 110880*D1**2*Pk2*f**3*fdd*r*s + 27720*D1**2*Pk2*f**3*fdd*r - 80080*D1**2*Pk2*f**3*fdd*s**2 + 95480*D1**2*Pk2*f**3*fdd*s - 20020*D1**2*Pk2*f**3*fdd - 332640*D1**2*Pk2*f**2*fd**2*r*s + 83160*D1**2*Pk2*f**2*fd**2*r - 240240*D1**2*Pk2*f**2*fd**2*s**2 + 286440*D1**2*Pk2*f**2*fd**2*s - 55440*D1**2*Pk2*f**2*fd**2 - 324720*D1**2*Pk2*f**2*fd*r*s + 108240*D1**2*Pk2*f**2*fd*r - 157080*D1**2*Pk2*f**2*fd*s**2 + 212960*D1**2*Pk2*f**2*fd*s - 52360*D1**2*Pk2*f**2*fd + 198000*D1**2*Pk2*f**2*fdd*r*s - 66000*D1**2*Pk2*f**2*fdd*r + 143880*D1**2*Pk2*f**2*fdd*s**2 - 161920*D1**2*Pk2*f**2*fdd*s + 47960*D1**2*Pk2*f**2*fdd - 85536*D1**2*Pk2*f**2*gd2*r*s - 18216*D1**2*Pk2*f**2*gd2*s**2 + 85536*D1**2*Pk2*f**2*gd2*s + 53856*D1**2*Pk2*f**2*gdd2*r*s + 34056*D1**2*Pk2*f**2*gdd2*s**2 - 53856*D1**2*Pk2*f**2*gdd2*s + 396000*D1**2*Pk2*f*fd**2*r*s - 132000*D1**2*Pk2*f*fd**2*r + 287760*D1**2*Pk2*f*fd**2*s**2 - 323840*D1**2*Pk2*f*fd**2*s + 66000*D1**2*Pk2*f*fd**2 - 171072*D1**2*Pk2*f*fd*g2*r*s + 85536*D1**2*Pk2*f*fd*g2*r - 36432*D1**2*Pk2*f*fd*g2*s**2 + 36432*D1**2*Pk2*f*fd*g2*s - 18216*D1**2*Pk2*f*fd*g2 + 215424*D1**2*Pk2*f*fd*gd2*r*s - 53856*D1**2*Pk2*f*fd*gd2*r + 136224*D1**2*Pk2*f*fd*gd2*s**2 - 175824*D1**2*Pk2*f*fd*gd2*s + 53856*D1**2*Pk2*f*fd*gd2 + 107712*D1**2*Pk2*f*fdd*g2*r*s - 53856*D1**2*Pk2*f*fdd*g2*r + 68112*D1**2*Pk2*f*fdd*g2*s**2 - 68112*D1**2*Pk2*f*fdd*g2*s + 34056*D1**2*Pk2*f*fdd*g2 + 107712*D1**2*Pk2*fd**2*g2*r*s - 53856*D1**2*Pk2*fd**2*g2*r + 68112*D1**2*Pk2*fd**2*g2*s**2 - 68112*D1**2*Pk2*fd**2*g2*s - 495*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 7560*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 3780*D1**2*Pkdd2*f**3*fd*k1**2*s - 1890*D1**2*Pkdd2*f**3*fd*k1**2 + 3780*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 1890*D1**2*Pkdd2*f**3*fdd*k1**2*s + 945*D1**2*Pkdd2*f**3*fdd*k1**2 + 11340*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 5670*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 4620*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 3080*D1**2*Pkdd2*f**2*fd*k1**2*s + 1540*D1**2*Pkdd2*f**2*fd*k1**2 - 2310*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 1540*D1**2*Pkdd2*f**2*fdd*k1**2*s - 770*D1**2*Pkdd2*f**2*fdd*k1**2 + 1980*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 990*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 4620*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 3080*D1**2*Pkdd2*f*fd**2*k1**2*s + 3960*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 3960*D1**2*Pkdd2*f*fd*g2*k1**2*s + 1980*D1**2*Pkdd2*f*fd*g2*k1**2 - 3960*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 1980*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 1980*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 1980*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 990*D1**2*Pkdd2*f*fdd*g2*k1**2 - 1980*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 1980*D1**2*Pkdd2*fd**2*g2*k1**2*s + 110880*D1*Dd*Pk2*f**4*r*s - 27720*D1*Dd*Pk2*f**4*r + 104720*D1*Dd*Pk2*f**4*s**2 - 107800*D1*Dd*Pk2*f**4*s + 26180*D1*Dd*Pk2*f**4 - 887040*D1*Dd*Pk2*f**3*fd*r*s + 221760*D1*Dd*Pk2*f**3*fd*r - 640640*D1*Dd*Pk2*f**3*fd*s**2 + 763840*D1*Dd*Pk2*f**3*fd*s - 150920*D1*Dd*Pk2*f**3*fd - 432960*D1*Dd*Pk2*f**3*r*s + 108240*D1*Dd*Pk2*f**3*r - 209440*D1*Dd*Pk2*f**3*s**2 + 321200*D1*Dd*Pk2*f**3*s - 52360*D1*Dd*Pk2*f**3 + 1584000*D1*Dd*Pk2*f**2*fd*r*s - 462000*D1*Dd*Pk2*f**2*fd*r + 1151040*D1*Dd*Pk2*f**2*fd*s**2 - 1331440*D1*Dd*Pk2*f**2*fd*s + 293920*D1*Dd*Pk2*f**2*fd - 342144*D1*Dd*Pk2*f**2*g2*r*s + 85536*D1*Dd*Pk2*f**2*g2*r - 72864*D1*Dd*Pk2*f**2*g2*s**2 + 207504*D1*Dd*Pk2*f**2*g2*s - 18216*D1*Dd*Pk2*f**2*g2 + 430848*D1*Dd*Pk2*f**2*gd2*r*s - 53856*D1*Dd*Pk2*f**2*gd2*r + 272448*D1*Dd*Pk2*f**2*gd2*s**2 - 391248*D1*Dd*Pk2*f**2*gd2*s + 53856*D1*Dd*Pk2*f**2*gd2 + 861696*D1*Dd*Pk2*f*fd*g2*r*s - 323136*D1*Dd*Pk2*f*fd*g2*r + 544896*D1*Dd*Pk2*f*fd*g2*s**2 - 624096*D1*Dd*Pk2*f*fd*g2*s + 175824*D1*Dd*Pk2*f*fd*g2 - 7560*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 3780*D1*Dd*Pkdd2*f**4*k1**2*s - 1890*D1*Dd*Pkdd2*f**4*k1**2 + 30240*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 15120*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 1890*D1*Dd*Pkdd2*f**3*fd*k1**2 + 6160*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 3080*D1*Dd*Pkdd2*f**3*k1**2*s + 1540*D1*Dd*Pkdd2*f**3*k1**2 - 18480*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 10780*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 1540*D1*Dd*Pkdd2*f**2*fd*k1**2 + 7920*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 3960*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 1980*D1*Dd*Pkdd2*f**2*g2*k1**2 - 7920*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 1980*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 15840*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 11880*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 1980*D1*Dd*Pkdd2*f*fd*g2*k1**2 - 110880*D1*Ddd*Pk2*f**4*r*s + 27720*D1*Ddd*Pk2*f**4*r - 80080*D1*Ddd*Pk2*f**4*s**2 + 95480*D1*Ddd*Pk2*f**4*s - 20020*D1*Ddd*Pk2*f**4 + 264000*D1*Ddd*Pk2*f**3*r*s - 66000*D1*Ddd*Pk2*f**3*r + 191840*D1*Ddd*Pk2*f**3*s**2 - 227920*D1*Ddd*Pk2*f**3*s + 47960*D1*Ddd*Pk2*f**3 + 215424*D1*Ddd*Pk2*f**2*g2*r*s - 53856*D1*Ddd*Pk2*f**2*g2*r + 136224*D1*Ddd*Pk2*f**2*g2*s**2 - 175824*D1*Ddd*Pk2*f**2*g2*s + 34056*D1*Ddd*Pk2*f**2*g2 + 3780*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 1890*D1*Ddd*Pkdd2*f**4*k1**2*s + 945*D1*Ddd*Pkdd2*f**4*k1**2 - 3080*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 1540*D1*Ddd*Pkdd2*f**3*k1**2*s - 770*D1*Ddd*Pkdd2*f**3*k1**2 - 3960*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 1980*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 990*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 22*D1*bd1*(D1*(40*Pk2*f**3*(33*s**2 + s*(47*r - 47) + 7) + 1008*Pk2*fd*g2*(r*(2*s - 1) + s*(3*s - 3)) + f**2*(2*Pk2*(360*C*(3*s**2 + s*(2*r - 2) + 1) - 140*fd*(4*r*(6*s - 1) + 18*s**2 - 22*s + 3) - 9*s**2*(23*K - 35) - 9*s*(108*K - 120)*(r - 1) - 360) + Pkdd2*k1**2*s**2*(45*K - 45)) + 9*f*(-112*Pk2*(3*g2*s**2 + 2*g2*s*(r - 1) + g2 + gd2*s*(-2*r - 3*s + 2)) + fd*(4*Pk2*(-120*C*s**2 + 100*C*s + K*(34*r*(4*s - 1) + 86*s**2 - 111*s + 34) - r*(20*C + 44)*(4*s - 1) - 126*s**2 + 151*s - 64) + 5*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1)))) + Dd*f*(-560*Pk2*f**2*(2*r*(8*s - 1) + 12*s**2 - 15*s + 2) + 1008*Pk2*g2*(r*(8*s - 1) + 12*s**2 - 9*s + 1) - 9*f*(4*Pk2*(20*C*(r*(8*s - 1) + 12*s**2 - 9*s + 1) + K*(-272*r*s + 34*r - 172*s**2 + 247*s - 34) + 352*r*s - 44*r + 252*s**2 - 327*s + 44) + Pkdd2*k1**2*s*(5*K - 5)*(4*s - 1)))) - 332640*Dd**2*Pk2*f**4*r*s + 83160*Dd**2*Pk2*f**4*r - 240240*Dd**2*Pk2*f**4*s**2 + 286440*Dd**2*Pk2*f**4*s - 55440*Dd**2*Pk2*f**4 + 792000*Dd**2*Pk2*f**3*r*s - 198000*Dd**2*Pk2*f**3*r + 575520*Dd**2*Pk2*f**3*s**2 - 683760*Dd**2*Pk2*f**3*s + 132000*Dd**2*Pk2*f**3 + 646272*Dd**2*Pk2*f**2*g2*r*s - 161568*Dd**2*Pk2*f**2*g2*r + 408672*Dd**2*Pk2*f**2*g2*s**2 - 527472*Dd**2*Pk2*f**2*g2*s + 107712*Dd**2*Pk2*f**2*g2 + 11340*Dd**2*Pkdd2*f**4*k1**2*s**2 - 5670*Dd**2*Pkdd2*f**4*k1**2*s - 9240*Dd**2*Pkdd2*f**3*k1**2*s**2 + 4620*Dd**2*Pkdd2*f**3*k1**2*s - 11880*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 5940*Dd**2*Pkdd2*f**2*g2*k1**2*s - 5544*Pk2*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + D1*(2*Dd*(f*(8*r*s - 2*r + 12*s**2 - 10*s + 3) + fd*(-8*r*s + 5*r - 12*s**2 + 13*s - 4)) + Ddd*f*(r*(2 - 8*s) - 12*s**2 + 10*s - 3)) - 2*Dd**2*f*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2)) - 11*b1*(5760*C*D1**2*Pk2*f*fd*r*s - 2880*C*D1**2*Pk2*f*fd*r + 8640*C*D1**2*Pk2*f*fd*s**2 - 8640*C*D1**2*Pk2*f*fd*s + 2880*C*D1**2*Pk2*f*fd - 2880*C*D1**2*Pk2*f*fdd*r*s + 1440*C*D1**2*Pk2*f*fdd*r - 4320*C*D1**2*Pk2*f*fdd*s**2 + 4320*C*D1**2*Pk2*f*fdd*s - 1440*C*D1**2*Pk2*f*fdd - 2880*C*D1**2*Pk2*fd**2*r*s + 1440*C*D1**2*Pk2*fd**2*r - 4320*C*D1**2*Pk2*fd**2*s**2 + 4320*C*D1**2*Pk2*fd**2*s - 1440*C*D1**2*Pk2*fd**2 + 11520*C*D1*Dd*Pk2*f**2*r*s - 2880*C*D1*Dd*Pk2*f**2*r + 17280*C*D1*Dd*Pk2*f**2*s**2 - 14400*C*D1*Dd*Pk2*f**2*s + 4320*C*D1*Dd*Pk2*f**2 - 23040*C*D1*Dd*Pk2*f*fd*r*s + 8640*C*D1*Dd*Pk2*f*fd*r - 34560*C*D1*Dd*Pk2*f*fd*s**2 + 31680*C*D1*Dd*Pk2*f*fd*s - 7200*C*D1*Dd*Pk2*f*fd - 5760*C*D1*Ddd*Pk2*f**2*r*s + 1440*C*D1*Ddd*Pk2*f**2*r - 8640*C*D1*Ddd*Pk2*f**2*s**2 + 7200*C*D1*Ddd*Pk2*f**2*s - 2160*C*D1*Ddd*Pk2*f**2 - 17280*C*Dd**2*Pk2*f**2*r*s + 4320*C*Dd**2*Pk2*f**2*r - 25920*C*Dd**2*Pk2*f**2*s**2 + 21600*C*Dd**2*Pk2*f**2*s - 2880*C*Dd**2*Pk2*f**2 - 7776*D1**2*K*Pk2*f*fd*r*s + 3888*D1**2*K*Pk2*f*fd*r - 1656*D1**2*K*Pk2*f*fd*s**2 + 1656*D1**2*K*Pk2*f*fd*s - 828*D1**2*K*Pk2*f*fd + 4896*D1**2*K*Pk2*f*fdd*r*s - 2448*D1**2*K*Pk2*f*fdd*r + 3096*D1**2*K*Pk2*f*fdd*s**2 - 3096*D1**2*K*Pk2*f*fdd*s + 1548*D1**2*K*Pk2*f*fdd + 4896*D1**2*K*Pk2*fd**2*r*s - 2448*D1**2*K*Pk2*fd**2*r + 3096*D1**2*K*Pk2*fd**2*s**2 - 3096*D1**2*K*Pk2*fd**2*s + 180*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 180*D1**2*K*Pkdd2*f*fd*k1**2*s + 90*D1**2*K*Pkdd2*f*fd*k1**2 - 90*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 90*D1**2*K*Pkdd2*f*fdd*k1**2*s - 45*D1**2*K*Pkdd2*f*fdd*k1**2 - 90*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 90*D1**2*K*Pkdd2*fd**2*k1**2*s - 504*D1**2*Pk2*bdd1*f*(K - 1)*(6*s**2 + s*(4*r - 4) + 1) + 11280*D1**2*Pk2*f**2*fd*r*s - 3760*D1**2*Pk2*f**2*fd*r + 7920*D1**2*Pk2*f**2*fd*s**2 - 9040*D1**2*Pk2*f**2*fd*s + 2080*D1**2*Pk2*f**2*fd - 6720*D1**2*Pk2*f**2*fdd*r*s + 2240*D1**2*Pk2*f**2*fdd*r - 5040*D1**2*Pk2*f**2*fdd*s**2 + 5600*D1**2*Pk2*f**2*fdd*s - 1400*D1**2*Pk2*f**2*fdd - 13440*D1**2*Pk2*f*fd**2*r*s + 4480*D1**2*Pk2*f*fd**2*r - 10080*D1**2*Pk2*f*fd**2*s**2 + 11200*D1**2*Pk2*f*fd**2*s - 2800*D1**2*Pk2*f*fd**2 + 8640*D1**2*Pk2*f*fd*r*s - 4320*D1**2*Pk2*f*fd*r + 2520*D1**2*Pk2*f*fd*s**2 - 2520*D1**2*Pk2*f*fd*s + 2700*D1**2*Pk2*f*fd - 6336*D1**2*Pk2*f*fdd*r*s + 3168*D1**2*Pk2*f*fdd*r - 4536*D1**2*Pk2*f*fdd*s**2 + 4536*D1**2*Pk2*f*fdd*s - 2988*D1**2*Pk2*f*fdd - 4032*D1**2*Pk2*f*gd2*r*s - 6048*D1**2*Pk2*f*gd2*s**2 + 4032*D1**2*Pk2*f*gd2*s + 2016*D1**2*Pk2*f*gdd2*r*s + 3024*D1**2*Pk2*f*gdd2*s**2 - 2016*D1**2*Pk2*f*gdd2*s - 6336*D1**2*Pk2*fd**2*r*s + 3168*D1**2*Pk2*fd**2*r - 4536*D1**2*Pk2*fd**2*s**2 + 4536*D1**2*Pk2*fd**2*s + 1440*D1**2*Pk2*fd**2 - 4032*D1**2*Pk2*fd*g2*r*s + 4032*D1**2*Pk2*fd*g2*r - 6048*D1**2*Pk2*fd*g2*s**2 + 8064*D1**2*Pk2*fd*g2*s - 4032*D1**2*Pk2*fd*g2 + 4032*D1**2*Pk2*fd*gd2*r*s - 2016*D1**2*Pk2*fd*gd2*r + 6048*D1**2*Pk2*fd*gd2*s**2 - 6048*D1**2*Pk2*fd*gd2*s + 2016*D1**2*Pk2*fd*gd2 + 2016*D1**2*Pk2*fdd*g2*r*s - 2016*D1**2*Pk2*fdd*g2*r + 3024*D1**2*Pk2*fdd*g2*s**2 - 4032*D1**2*Pk2*fdd*g2*s + 2016*D1**2*Pk2*fdd*g2 - 180*D1**2*Pkdd2*f*fd*k1**2*s**2 + 180*D1**2*Pkdd2*f*fd*k1**2*s - 90*D1**2*Pkdd2*f*fd*k1**2 + 90*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 90*D1**2*Pkdd2*f*fdd*k1**2*s + 45*D1**2*Pkdd2*f*fdd*k1**2 + 90*D1**2*Pkdd2*fd**2*k1**2*s**2 - 90*D1**2*Pkdd2*fd**2*k1**2*s - 15552*D1*Dd*K*Pk2*f**2*r*s + 3888*D1*Dd*K*Pk2*f**2*r - 3312*D1*Dd*K*Pk2*f**2*s**2 + 9432*D1*Dd*K*Pk2*f**2*s - 828*D1*Dd*K*Pk2*f**2 + 39168*D1*Dd*K*Pk2*f*fd*r*s - 14688*D1*Dd*K*Pk2*f*fd*r + 24768*D1*Dd*K*Pk2*f*fd*s**2 - 28368*D1*Dd*K*Pk2*f*fd*s + 7992*D1*Dd*K*Pk2*f*fd + 360*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 180*D1*Dd*K*Pkdd2*f**2*k1**2*s + 90*D1*Dd*K*Pkdd2*f**2*k1**2 - 720*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 540*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 90*D1*Dd*K*Pkdd2*f*fd*k1**2 + 15040*D1*Dd*Pk2*f**3*r*s - 3760*D1*Dd*Pk2*f**3*r + 10560*D1*Dd*Pk2*f**3*s**2 - 12800*D1*Dd*Pk2*f**3*s + 2640*D1*Dd*Pk2*f**3 - 53760*D1*Dd*Pk2*f**2*fd*r*s + 15680*D1*Dd*Pk2*f**2*fd*r - 40320*D1*Dd*Pk2*f**2*fd*s**2 + 45920*D1*Dd*Pk2*f**2*fd*s - 10080*D1*Dd*Pk2*f**2*fd + 17280*D1*Dd*Pk2*f**2*r*s - 4320*D1*Dd*Pk2*f**2*r + 5040*D1*Dd*Pk2*f**2*s**2 - 11160*D1*Dd*Pk2*f**2*s + 1260*D1*Dd*Pk2*f**2 - 50688*D1*Dd*Pk2*f*fd*r*s + 19008*D1*Dd*Pk2*f*fd*r - 36288*D1*Dd*Pk2*f*fd*s**2 + 39888*D1*Dd*Pk2*f*fd*s - 10872*D1*Dd*Pk2*f*fd - 16128*D1*Dd*Pk2*f*g2*r*s + 4032*D1*Dd*Pk2*f*g2*r - 24192*D1*Dd*Pk2*f*g2*s**2 + 20160*D1*Dd*Pk2*f*g2*s - 6048*D1*Dd*Pk2*f*g2 + 16128*D1*Dd*Pk2*f*gd2*r*s - 2016*D1*Dd*Pk2*f*gd2*r + 24192*D1*Dd*Pk2*f*gd2*s**2 - 18144*D1*Dd*Pk2*f*gd2*s + 2016*D1*Dd*Pk2*f*gd2 + 16128*D1*Dd*Pk2*fd*g2*r*s - 10080*D1*Dd*Pk2*fd*g2*r + 24192*D1*Dd*Pk2*fd*g2*s**2 - 26208*D1*Dd*Pk2*fd*g2*s + 8064*D1*Dd*Pk2*fd*g2 - 360*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 180*D1*Dd*Pkdd2*f**2*k1**2*s - 90*D1*Dd*Pkdd2*f**2*k1**2 + 720*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 540*D1*Dd*Pkdd2*f*fd*k1**2*s + 90*D1*Dd*Pkdd2*f*fd*k1**2 + 9792*D1*Ddd*K*Pk2*f**2*r*s - 2448*D1*Ddd*K*Pk2*f**2*r + 6192*D1*Ddd*K*Pk2*f**2*s**2 - 7992*D1*Ddd*K*Pk2*f**2*s + 1548*D1*Ddd*K*Pk2*f**2 - 180*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 90*D1*Ddd*K*Pkdd2*f**2*k1**2*s - 45*D1*Ddd*K*Pkdd2*f**2*k1**2 - 8960*D1*Ddd*Pk2*f**3*r*s + 2240*D1*Ddd*Pk2*f**3*r - 6720*D1*Ddd*Pk2*f**3*s**2 + 7840*D1*Ddd*Pk2*f**3*s - 1680*D1*Ddd*Pk2*f**3 - 12672*D1*Ddd*Pk2*f**2*r*s + 3168*D1*Ddd*Pk2*f**2*r - 9072*D1*Ddd*Pk2*f**2*s**2 + 10872*D1*Ddd*Pk2*f**2*s - 2268*D1*Ddd*Pk2*f**2 + 8064*D1*Ddd*Pk2*f*g2*r*s - 2016*D1*Ddd*Pk2*f*g2*r + 12096*D1*Ddd*Pk2*f*g2*s**2 - 10080*D1*Ddd*Pk2*f*g2*s + 3024*D1*Ddd*Pk2*f*g2 + 180*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 90*D1*Ddd*Pkdd2*f**2*k1**2*s + 45*D1*Ddd*Pkdd2*f**2*k1**2 + 1008*D1*Pk2*bd1*(K - 1)*(D1*(f*(6*s**2 + s*(4*r - 4) + 1) + fd*(r*(2 - 4*s) - 6*s**2 + 6*s - 1)) - 2*Dd*f*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) + 29376*Dd**2*K*Pk2*f**2*r*s - 7344*Dd**2*K*Pk2*f**2*r + 18576*Dd**2*K*Pk2*f**2*s**2 - 23976*Dd**2*K*Pk2*f**2*s + 4896*Dd**2*K*Pk2*f**2 - 540*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 270*Dd**2*K*Pkdd2*f**2*k1**2*s - 26880*Dd**2*Pk2*f**3*r*s + 6720*Dd**2*Pk2*f**3*r - 20160*Dd**2*Pk2*f**3*s**2 + 23520*Dd**2*Pk2*f**3*s - 4480*Dd**2*Pk2*f**3 - 38016*Dd**2*Pk2*f**2*r*s + 9504*Dd**2*Pk2*f**2*r - 27216*Dd**2*Pk2*f**2*s**2 + 32616*Dd**2*Pk2*f**2*s - 6336*Dd**2*Pk2*f**2 + 24192*Dd**2*Pk2*f*g2*r*s - 6048*Dd**2*Pk2*f*g2*r + 36288*Dd**2*Pk2*f*g2*s**2 - 30240*Dd**2*Pk2*f*g2*s + 4032*Dd**2*Pk2*f*g2 + 540*Dd**2*Pkdd2*f**2*k1**2*s**2 - 270*Dd**2*Pkdd2*f**2*k1**2*s))/(6930*d**2*k3**4) + D1**2*Pk3*ct**6*k2**2*(-2136*C*D1**2*Pk2*f**2*fd*r**2 + 8640*C*D1**2*Pk2*f**2*fd*r*s - 1456*C*D1**2*Pk2*f**2*fd*r + 3360*C*D1**2*Pk2*f**2*fd*s**2 - 5120*C*D1**2*Pk2*f**2*fd*s + 408*C*D1**2*Pk2*f**2*fd + 636*C*D1**2*Pk2*f**2*fdd*r**2 - 4320*C*D1**2*Pk2*f**2*fdd*r*s + 1016*C*D1**2*Pk2*f**2*fdd*r - 1680*C*D1**2*Pk2*f**2*fdd*s**2 + 2560*C*D1**2*Pk2*f**2*fdd*s - 348*C*D1**2*Pk2*f**2*fdd + 1272*C*D1**2*Pk2*f*fd**2*r**2 - 8640*C*D1**2*Pk2*f*fd**2*r*s + 2032*C*D1**2*Pk2*f*fd**2*r - 3360*C*D1**2*Pk2*f*fd**2*s**2 + 5120*C*D1**2*Pk2*f*fd**2*s - 1440*C*D1**2*Pk2*f*fd**2 - 360*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 180*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 180*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 1410*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 940*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 470*C*D1**2*Pkdd2*f**2*fd*k1**2 + 840*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 560*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 280*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 1680*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 1120*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 2848*C*D1*Dd*Pk2*f**3*r**2 + 11520*C*D1*Dd*Pk2*f**3*r*s - 32*C*D1*Dd*Pk2*f**3*r + 4480*C*D1*Dd*Pk2*f**3*s**2 - 8000*C*D1*Dd*Pk2*f**3*s - 304*C*D1*Dd*Pk2*f**3 + 5088*C*D1*Dd*Pk2*f**2*fd*r**2 - 34560*C*D1*Dd*Pk2*f**2*fd*r*s + 5840*C*D1*Dd*Pk2*f**2*fd*r - 13440*C*D1*Dd*Pk2*f**2*fd*s**2 + 22240*C*D1*Dd*Pk2*f**2*fd*s - 4592*C*D1*Dd*Pk2*f**2*fd - 720*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 360*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 180*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 1440*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 360*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 1880*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 940*C*D1*Dd*Pkdd2*f**3*k1**2*s - 470*C*D1*Dd*Pkdd2*f**3*k1**2 + 6720*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 3920*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 560*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 848*C*D1*Ddd*Pk2*f**3*r**2 - 5760*C*D1*Ddd*Pk2*f**3*r*s + 592*C*D1*Ddd*Pk2*f**3*r - 2240*C*D1*Ddd*Pk2*f**3*s**2 + 4000*C*D1*Ddd*Pk2*f**3*s - 136*C*D1*Ddd*Pk2*f**3 + 360*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 180*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 90*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 1120*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 560*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 280*C*D1*Ddd*Pkdd2*f**3*k1**2 + 2544*C*Dd**2*Pk2*f**3*r**2 - 17280*C*Dd**2*Pk2*f**3*r*s + 1776*C*Dd**2*Pk2*f**3*r - 6720*C*Dd**2*Pk2*f**3*s**2 + 12000*C*Dd**2*Pk2*f**3*s - 2456*C*Dd**2*Pk2*f**3 + 1080*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 540*C*Dd**2*Pkdd2*b1*f**2*k1**2*s + 3360*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 1680*C*Dd**2*Pkdd2*f**3*k1**2*s - 360*D1**2*K*Pk2*b1*f*fd*r**2 + 2880*D1**2*K*Pk2*b1*f*fd*r*s - 1440*D1**2*K*Pk2*b1*f*fd*r + 1440*D1**2*K*Pk2*b1*f*fd*s**2 - 1440*D1**2*K*Pk2*b1*f*fd*s + 720*D1**2*K*Pk2*b1*f*fd + 180*D1**2*K*Pk2*b1*f*fdd*r**2 - 1440*D1**2*K*Pk2*b1*f*fdd*r*s + 720*D1**2*K*Pk2*b1*f*fdd*r - 720*D1**2*K*Pk2*b1*f*fdd*s**2 + 720*D1**2*K*Pk2*b1*f*fdd*s - 360*D1**2*K*Pk2*b1*f*fdd + 180*D1**2*K*Pk2*b1*fd**2*r**2 - 1440*D1**2*K*Pk2*b1*fd**2*r*s + 720*D1**2*K*Pk2*b1*fd**2*r - 720*D1**2*K*Pk2*b1*fd**2*s**2 + 720*D1**2*K*Pk2*b1*fd**2*s - 126*D1**2*K*Pkdd2*b1**2*fd*k1**2*s**2 + 63*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s**2 - 594*D1**2*K*Pkdd2*b1*f*fd*k1**2*s**2 + 594*D1**2*K*Pkdd2*b1*f*fd*k1**2*s - 297*D1**2*K*Pkdd2*b1*f*fd*k1**2 + 360*D1**2*K*Pkdd2*b1*f*fdd*k1**2*s**2 - 360*D1**2*K*Pkdd2*b1*f*fdd*k1**2*s + 180*D1**2*K*Pkdd2*b1*f*fdd*k1**2 + 360*D1**2*K*Pkdd2*b1*fd**2*k1**2*s**2 - 360*D1**2*K*Pkdd2*b1*fd**2*k1**2*s + 540*D1**2*Pk2*b1*f**2*fd*r**2 - 360*D1**2*Pk2*b1*f**2*fd*r + 180*D1**2*Pk2*b1*f**2*fd - 540*D1**2*Pk2*b1*f**2*fdd*r**2 + 360*D1**2*Pk2*b1*f**2*fdd*r - 180*D1**2*Pk2*b1*f**2*fdd - 1080*D1**2*Pk2*b1*f*fd**2*r**2 + 720*D1**2*Pk2*b1*f*fd**2*r + 1080*D1**2*Pk2*b1*f*fd*r**2 - 540*D1**2*Pk2*b1*f*fdd*r**2 - 540*D1**2*Pk2*b1*fd**2*r**2 + 1440*D1**2*Pk2*b2*f*fd*r*s - 720*D1**2*Pk2*b2*f*fd*r + 1440*D1**2*Pk2*b2*f*fd*s**2 - 1440*D1**2*Pk2*b2*f*fd*s + 720*D1**2*Pk2*b2*f*fd - 720*D1**2*Pk2*b2*f*fdd*r*s + 360*D1**2*Pk2*b2*f*fdd*r - 720*D1**2*Pk2*b2*f*fdd*s**2 + 720*D1**2*Pk2*b2*f*fdd*s - 360*D1**2*Pk2*b2*f*fdd - 720*D1**2*Pk2*b2*fd**2*r*s + 360*D1**2*Pk2*b2*fd**2*r - 720*D1**2*Pk2*b2*fd**2*s**2 + 720*D1**2*Pk2*b2*fd**2*s + 720*D1**2*Pk2*bd2*f**2*r*s + 720*D1**2*Pk2*bd2*f**2*s**2 - 720*D1**2*Pk2*bd2*f**2*s - 1440*D1**2*Pk2*bd2*f*fd*r*s + 360*D1**2*Pk2*bd2*f*fd*r - 1440*D1**2*Pk2*bd2*f*fd*s**2 + 1440*D1**2*Pk2*bd2*f*fd*s - 360*D1**2*Pk2*bd2*f*fd - 360*D1**2*Pk2*bdd2*f**2*r*s - 360*D1**2*Pk2*bdd2*f**2*s**2 + 360*D1**2*Pk2*bdd2*f**2*s - 360*D1**2*Pk2*f**3*fd*r**2 + 360*D1**2*Pk2*f**3*fd*r - 180*D1**2*Pk2*f**3*fd + 360*D1**2*Pk2*f**3*fdd*r**2 - 360*D1**2*Pk2*f**3*fdd*r + 180*D1**2*Pk2*f**3*fdd + 1080*D1**2*Pk2*f**2*fd**2*r**2 - 1080*D1**2*Pk2*f**2*fd**2*r + 180*D1**2*Pk2*f**2*fd**2 + 3456*D1**2*Pk2*f**2*fd*r**2 - 4320*D1**2*Pk2*f**2*fd*r*s - 864*D1**2*Pk2*f**2*fd*r - 1680*D1**2*Pk2*f**2*fd*s**2 + 2560*D1**2*Pk2*f**2*fd*s + 592*D1**2*Pk2*f**2*fd - 1296*D1**2*Pk2*f**2*fdd*r**2 + 2160*D1**2*Pk2*f**2*fdd*r*s + 144*D1**2*Pk2*f**2*fdd*r + 840*D1**2*Pk2*f**2*fdd*s**2 - 1280*D1**2*Pk2*f**2*fdd*s - 152*D1**2*Pk2*f**2*fdd + 360*D1**2*Pk2*f**2*gd2*r**2 - 2880*D1**2*Pk2*f**2*gd2*r*s - 720*D1**2*Pk2*f**2*gd2*r - 1440*D1**2*Pk2*f**2*gd2*s**2 + 2880*D1**2*Pk2*f**2*gd2*s + 360*D1**2*Pk2*f**2*gd2 - 180*D1**2*Pk2*f**2*gdd2*r**2 + 1440*D1**2*Pk2*f**2*gdd2*r*s + 360*D1**2*Pk2*f**2*gdd2*r + 720*D1**2*Pk2*f**2*gdd2*s**2 - 1440*D1**2*Pk2*f**2*gdd2*s - 180*D1**2*Pk2*f**2*gdd2 - 2592*D1**2*Pk2*f*fd**2*r**2 + 4320*D1**2*Pk2*f*fd**2*r*s + 288*D1**2*Pk2*f*fd**2*r + 1680*D1**2*Pk2*f*fd**2*s**2 - 2560*D1**2*Pk2*f*fd**2*s + 720*D1**2*Pk2*f*fd**2 + 720*D1**2*Pk2*f*fd*g2*r**2 - 5760*D1**2*Pk2*f*fd*g2*r*s + 2880*D1**2*Pk2*f*fd*g2*r - 2880*D1**2*Pk2*f*fd*g2*s**2 + 2880*D1**2*Pk2*f*fd*g2*s - 1440*D1**2*Pk2*f*fd*g2 - 720*D1**2*Pk2*f*fd*gd2*r**2 + 5760*D1**2*Pk2*f*fd*gd2*r*s - 720*D1**2*Pk2*f*fd*gd2*r + 2880*D1**2*Pk2*f*fd*gd2*s**2 - 4320*D1**2*Pk2*f*fd*gd2*s + 1440*D1**2*Pk2*f*fd*gd2 - 360*D1**2*Pk2*f*fdd*g2*r**2 + 2880*D1**2*Pk2*f*fdd*g2*r*s - 1440*D1**2*Pk2*f*fdd*g2*r + 1440*D1**2*Pk2*f*fdd*g2*s**2 - 1440*D1**2*Pk2*f*fdd*g2*s + 720*D1**2*Pk2*f*fdd*g2 - 360*D1**2*Pk2*fd**2*g2*r**2 + 2880*D1**2*Pk2*fd**2*g2*r*s - 1440*D1**2*Pk2*fd**2*g2*r + 1440*D1**2*Pk2*fd**2*g2*s**2 - 1440*D1**2*Pk2*fd**2*g2*s + 126*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 63*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 420*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 - 420*D1**2*Pkdd2*b1*f**2*fd*k1**2*s + 210*D1**2*Pkdd2*b1*f**2*fd*k1**2 - 210*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 + 210*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s - 105*D1**2*Pkdd2*b1*f**2*fdd*k1**2 - 420*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 + 420*D1**2*Pkdd2*b1*f*fd**2*k1**2*s + 594*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 234*D1**2*Pkdd2*b1*f*fd*k1**2*s + 117*D1**2*Pkdd2*b1*f*fd*k1**2 - 360*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 180*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 90*D1**2*Pkdd2*b1*f*fdd*k1**2 + 252*D1**2*Pkdd2*b1*f*gd2*k1**2*s**2 - 126*D1**2*Pkdd2*b1*f*gdd2*k1**2*s**2 - 360*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 180*D1**2*Pkdd2*b1*fd**2*k1**2*s + 252*D1**2*Pkdd2*b1*fd*g2*k1**2*s**2 - 252*D1**2*Pkdd2*b1*fd*gd2*k1**2*s**2 - 126*D1**2*Pkdd2*b1*fdd*g2*k1**2*s**2 + 126*D1**2*Pkdd2*bd1**2*f*k1**2*s*(K - 1)*(s - 1) + 140*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 70*D1**2*Pkdd2*f**3*fd*k1**2*s + 35*D1**2*Pkdd2*f**3*fd*k1**2 + 990*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 660*D1**2*Pkdd2*f**2*fd*k1**2*s + 330*D1**2*Pkdd2*f**2*fd*k1**2 - 630*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 420*D1**2*Pkdd2*f**2*fdd*k1**2*s - 210*D1**2*Pkdd2*f**2*fdd*k1**2 + 594*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 360*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 1260*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 840*D1**2*Pkdd2*f*fd**2*k1**2*s + 1188*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 1188*D1**2*Pkdd2*f*fd*g2*k1**2*s + 594*D1**2*Pkdd2*f*fd*g2*k1**2 - 1440*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 720*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 720*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 720*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 360*D1**2*Pkdd2*f*fdd*g2*k1**2 - 720*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 720*D1**2*Pkdd2*fd**2*g2*k1**2*s - D1**2*bdd1*f*(-63*Pkdd2*k1**2*(b1*(K - 1)*(2*s**2 - 2*s + 1) - 2*g2*(s - 1)**2) + 5*f**2*(36*Pk2*(r - 1)**2 + 7*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 90*f*(K*Pk2*(r**2 - 2*r*(4*s + 1) - 4*s**2 + 8*s + 1) - 3*Pk2*(r - 1)**2 + Pkdd2*k1**2*(C*(s - 1)**2 + s**2*(2*K - 2) + 2*s - 1))) - 720*D1*Dd*K*Pk2*b1*f**2*r**2 + 5760*D1*Dd*K*Pk2*b1*f**2*r*s - 720*D1*Dd*K*Pk2*b1*f**2*r + 2880*D1*Dd*K*Pk2*b1*f**2*s**2 - 4320*D1*Dd*K*Pk2*b1*f**2*s + 360*D1*Dd*K*Pk2*b1*f**2 + 1440*D1*Dd*K*Pk2*b1*f*fd*r**2 - 11520*D1*Dd*K*Pk2*b1*f*fd*r*s + 3600*D1*Dd*K*Pk2*b1*f*fd*r - 5760*D1*Dd*K*Pk2*b1*f*fd*s**2 + 7200*D1*Dd*K*Pk2*b1*f*fd*s - 2160*D1*Dd*K*Pk2*b1*f*fd - 504*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s**2 + 252*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s - 126*D1*Dd*K*Pkdd2*b1**2*f*k1**2 + 504*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s**2 - 126*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s - 1188*D1*Dd*K*Pkdd2*b1*f**2*k1**2*s**2 + 594*D1*Dd*K*Pkdd2*b1*f**2*k1**2*s - 297*D1*Dd*K*Pkdd2*b1*f**2*k1**2 + 2880*D1*Dd*K*Pkdd2*b1*f*fd*k1**2*s**2 - 2160*D1*Dd*K*Pkdd2*b1*f*fd*k1**2*s + 360*D1*Dd*K*Pkdd2*b1*f*fd*k1**2 + 720*D1*Dd*Pk2*b1*f**3*r**2 - 720*D1*Dd*Pk2*b1*f**3*r + 360*D1*Dd*Pk2*b1*f**3 - 4320*D1*Dd*Pk2*b1*f**2*fd*r**2 + 3600*D1*Dd*Pk2*b1*f**2*fd*r - 720*D1*Dd*Pk2*b1*f**2*fd + 2160*D1*Dd*Pk2*b1*f**2*r**2 - 2160*D1*Dd*Pk2*b1*f**2*r + 1080*D1*Dd*Pk2*b1*f**2 - 4320*D1*Dd*Pk2*b1*f*fd*r**2 + 2160*D1*Dd*Pk2*b1*f*fd*r + 2880*D1*Dd*Pk2*b2*f**2*r*s - 720*D1*Dd*Pk2*b2*f**2*r + 2880*D1*Dd*Pk2*b2*f**2*s**2 - 2880*D1*Dd*Pk2*b2*f**2*s + 720*D1*Dd*Pk2*b2*f**2 - 5760*D1*Dd*Pk2*b2*f*fd*r*s + 2160*D1*Dd*Pk2*b2*f*fd*r - 5760*D1*Dd*Pk2*b2*f*fd*s**2 + 5760*D1*Dd*Pk2*b2*f*fd*s - 1440*D1*Dd*Pk2*b2*f*fd - 2880*D1*Dd*Pk2*bd2*f**2*r*s + 360*D1*Dd*Pk2*bd2*f**2*r - 2880*D1*Dd*Pk2*bd2*f**2*s**2 + 2880*D1*Dd*Pk2*bd2*f**2*s - 360*D1*Dd*Pk2*bd2*f**2 - 360*D1*Dd*Pk2*f**4*r**2 + 360*D1*Dd*Pk2*f**4*r - 180*D1*Dd*Pk2*f**4 + 2880*D1*Dd*Pk2*f**3*fd*r**2 - 2880*D1*Dd*Pk2*f**3*fd*r + 720*D1*Dd*Pk2*f**3*fd + 4608*D1*Dd*Pk2*f**3*r**2 - 5760*D1*Dd*Pk2*f**3*r*s - 3168*D1*Dd*Pk2*f**3*r - 2240*D1*Dd*Pk2*f**3*s**2 + 4000*D1*Dd*Pk2*f**3*s + 1744*D1*Dd*Pk2*f**3 - 10368*D1*Dd*Pk2*f**2*fd*r**2 + 17280*D1*Dd*Pk2*f**2*fd*r*s + 3600*D1*Dd*Pk2*f**2*fd*r + 6720*D1*Dd*Pk2*f**2*fd*s**2 - 11120*D1*Dd*Pk2*f**2*fd*s + 992*D1*Dd*Pk2*f**2*fd + 1440*D1*Dd*Pk2*f**2*g2*r**2 - 11520*D1*Dd*Pk2*f**2*g2*r*s + 1440*D1*Dd*Pk2*f**2*g2*r - 5760*D1*Dd*Pk2*f**2*g2*s**2 + 8640*D1*Dd*Pk2*f**2*g2*s - 720*D1*Dd*Pk2*f**2*g2 - 1440*D1*Dd*Pk2*f**2*gd2*r**2 + 11520*D1*Dd*Pk2*f**2*gd2*r*s + 720*D1*Dd*Pk2*f**2*gd2*r + 5760*D1*Dd*Pk2*f**2*gd2*s**2 - 10080*D1*Dd*Pk2*f**2*gd2*s + 720*D1*Dd*Pk2*f**2*gd2 - 2880*D1*Dd*Pk2*f*fd*g2*r**2 + 23040*D1*Dd*Pk2*f*fd*g2*r*s - 7200*D1*Dd*Pk2*f*fd*g2*r + 11520*D1*Dd*Pk2*f*fd*g2*s**2 - 14400*D1*Dd*Pk2*f*fd*g2*s + 4320*D1*Dd*Pk2*f*fd*g2 + 504*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 252*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 126*D1*Dd*Pkdd2*b1**2*f*k1**2 - 504*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 126*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 560*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 - 280*D1*Dd*Pkdd2*b1*f**3*k1**2*s + 140*D1*Dd*Pkdd2*b1*f**3*k1**2 - 1680*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 + 1260*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s - 210*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 + 1188*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 594*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 297*D1*Dd*Pkdd2*b1*f**2*k1**2 - 2880*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 1440*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 180*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 1008*D1*Dd*Pkdd2*b1*f*g2*k1**2*s**2 - 504*D1*Dd*Pkdd2*b1*f*g2*k1**2*s + 252*D1*Dd*Pkdd2*b1*f*g2*k1**2 - 1008*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s**2 + 252*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s - 1008*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s**2 + 252*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s + 140*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 70*D1*Dd*Pkdd2*f**4*k1**2*s + 35*D1*Dd*Pkdd2*f**4*k1**2 + 1320*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 660*D1*Dd*Pkdd2*f**3*k1**2*s + 330*D1*Dd*Pkdd2*f**3*k1**2 - 5040*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 2940*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 420*D1*Dd*Pkdd2*f**2*fd*k1**2 + 2376*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 1188*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 594*D1*Dd*Pkdd2*f**2*g2*k1**2 - 2880*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 720*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 5760*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 4320*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 720*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 360*D1*Ddd*K*Pk2*b1*f**2*r**2 - 2880*D1*Ddd*K*Pk2*b1*f**2*r*s + 360*D1*Ddd*K*Pk2*b1*f**2*r - 1440*D1*Ddd*K*Pk2*b1*f**2*s**2 + 2160*D1*Ddd*K*Pk2*b1*f**2*s - 180*D1*Ddd*K*Pk2*b1*f**2 + 252*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s**2 - 126*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s + 63*D1*Ddd*K*Pkdd2*b1**2*f*k1**2 + 720*D1*Ddd*K*Pkdd2*b1*f**2*k1**2*s**2 - 360*D1*Ddd*K*Pkdd2*b1*f**2*k1**2*s + 180*D1*Ddd*K*Pkdd2*b1*f**2*k1**2 - 720*D1*Ddd*Pk2*b1*f**3*r**2 + 720*D1*Ddd*Pk2*b1*f**3*r - 360*D1*Ddd*Pk2*b1*f**3 - 1080*D1*Ddd*Pk2*b1*f**2*r**2 + 1080*D1*Ddd*Pk2*b1*f**2*r - 540*D1*Ddd*Pk2*b1*f**2 - 1440*D1*Ddd*Pk2*b2*f**2*r*s + 360*D1*Ddd*Pk2*b2*f**2*r - 1440*D1*Ddd*Pk2*b2*f**2*s**2 + 1440*D1*Ddd*Pk2*b2*f**2*s - 360*D1*Ddd*Pk2*b2*f**2 + 360*D1*Ddd*Pk2*f**4*r**2 - 360*D1*Ddd*Pk2*f**4*r + 180*D1*Ddd*Pk2*f**4 - 1728*D1*Ddd*Pk2*f**3*r**2 + 2880*D1*Ddd*Pk2*f**3*r*s + 1008*D1*Ddd*Pk2*f**3*r + 1120*D1*Ddd*Pk2*f**3*s**2 - 2000*D1*Ddd*Pk2*f**3*s - 584*D1*Ddd*Pk2*f**3 - 720*D1*Ddd*Pk2*f**2*g2*r**2 + 5760*D1*Ddd*Pk2*f**2*g2*r*s - 720*D1*Ddd*Pk2*f**2*g2*r + 2880*D1*Ddd*Pk2*f**2*g2*s**2 - 4320*D1*Ddd*Pk2*f**2*g2*s + 360*D1*Ddd*Pk2*f**2*g2 - 252*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 126*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 63*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 280*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 + 140*D1*Ddd*Pkdd2*b1*f**3*k1**2*s - 70*D1*Ddd*Pkdd2*b1*f**3*k1**2 - 720*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 360*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 180*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 504*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s**2 + 252*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s - 126*D1*Ddd*Pkdd2*b1*f*g2*k1**2 - 840*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 420*D1*Ddd*Pkdd2*f**3*k1**2*s - 210*D1*Ddd*Pkdd2*f**3*k1**2 - 1440*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 720*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 360*D1*Ddd*Pkdd2*f**2*g2*k1**2 + D1*bd1*(D1*(126*Pkdd2*fd*k1**2*s*(b1*(K - 1)*(2*s - 1) - 2*g2*(s - 1)) + 10*f**3*(18*Pk2*(r - 1)**2 + 7*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 3*f**2*(60*Pk2*(K*(r**2 - 8*r*s - 2*r - 4*s**2 + 8*s + 1) + fd*(6*r**2 - 8*r + 2) - 3*(r - 1)**2) + Pkdd2*k1**2*(60*C*(s - 1)**2 + s**2*(99*K + 140*fd - 99) + 120*s - 60)) + 18*f*(-7*Pkdd2*k1**2*(b1*(K - 1)*(2*s**2 - 2*s + 1) + (2 - 2*s)*(g2*(s - 1) - gd2*s)) + 10*fd*(2*K*(Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + Pkdd2*k1**2*s*(2*s - 1)) - 6*Pk2*r*(r - 1) + Pkdd2*k1**2*s*(2*C*(s - 1) - 4*s + 3)))) - 2*Dd*f*(-63*Pkdd2*k1**2*(4*s - 1)*(b1*(K - 1)*(2*s - 1) - 2*g2*(s - 1)) + 5*f**2*(72*Pk2*(2*r**2 - 3*r + 1) + 7*Pkdd2*k1**2*(8*s**2 + 2*s - 1)) - 90*f*(2*Pk2*(K*(2*r**2 - r*(16*s + 1) - 8*s**2 + 14*s - 1) - 6*r**2 + 9*r - 3) + Pkdd2*k1**2*(4*s - 1)*(C*(s - 1) + s*(2*K - 2) + 1)))) + 1080*Dd**2*K*Pk2*b1*f**2*r**2 - 8640*Dd**2*K*Pk2*b1*f**2*r*s + 1080*Dd**2*K*Pk2*b1*f**2*r - 4320*Dd**2*K*Pk2*b1*f**2*s**2 + 6480*Dd**2*K*Pk2*b1*f**2*s - 1260*Dd**2*K*Pk2*b1*f**2 + 756*Dd**2*K*Pkdd2*b1**2*f*k1**2*s**2 - 378*Dd**2*K*Pkdd2*b1**2*f*k1**2*s + 2160*Dd**2*K*Pkdd2*b1*f**2*k1**2*s**2 - 1080*Dd**2*K*Pkdd2*b1*f**2*k1**2*s - 2160*Dd**2*Pk2*b1*f**3*r**2 + 2160*Dd**2*Pk2*b1*f**3*r - 360*Dd**2*Pk2*b1*f**3 - 3240*Dd**2*Pk2*b1*f**2*r**2 + 3240*Dd**2*Pk2*b1*f**2*r - 540*Dd**2*Pk2*b1*f**2 - 4320*Dd**2*Pk2*b2*f**2*r*s + 1080*Dd**2*Pk2*b2*f**2*r - 4320*Dd**2*Pk2*b2*f**2*s**2 + 4320*Dd**2*Pk2*b2*f**2*s - 720*Dd**2*Pk2*b2*f**2 + 1080*Dd**2*Pk2*f**4*r**2 - 1080*Dd**2*Pk2*f**4*r + 180*Dd**2*Pk2*f**4 - 5184*Dd**2*Pk2*f**3*r**2 + 8640*Dd**2*Pk2*f**3*r*s + 3024*Dd**2*Pk2*f**3*r + 3360*Dd**2*Pk2*f**3*s**2 - 6000*Dd**2*Pk2*f**3*s + 576*Dd**2*Pk2*f**3 - 2160*Dd**2*Pk2*f**2*g2*r**2 + 17280*Dd**2*Pk2*f**2*g2*r*s - 2160*Dd**2*Pk2*f**2*g2*r + 8640*Dd**2*Pk2*f**2*g2*s**2 - 12960*Dd**2*Pk2*f**2*g2*s + 2520*Dd**2*Pk2*f**2*g2 - 756*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 378*Dd**2*Pkdd2*b1**2*f*k1**2*s - 840*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 + 420*Dd**2*Pkdd2*b1*f**3*k1**2*s - 2160*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 1080*Dd**2*Pkdd2*b1*f**2*k1**2*s - 1512*Dd**2*Pkdd2*b1*f*g2*k1**2*s**2 + 756*Dd**2*Pkdd2*b1*f*g2*k1**2*s - 2520*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1260*Dd**2*Pkdd2*f**3*k1**2*s - 4320*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 2160*Dd**2*Pkdd2*f**2*g2*k1**2*s)/(630*d**2*k3**4) + D1**2*Pk3*ct**6*(3360*C*D1**2*Pk2*f**2*fd*s**2 - 2240*C*D1**2*Pk2*f**2*fd*s + 1120*C*D1**2*Pk2*f**2*fd - 1680*C*D1**2*Pk2*f**2*fdd*s**2 + 1120*C*D1**2*Pk2*f**2*fdd*s - 560*C*D1**2*Pk2*f**2*fdd - 3360*C*D1**2*Pk2*f*fd**2*s**2 + 2240*C*D1**2*Pk2*f*fd**2*s - 360*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 360*C*D1**2*Pkdd2*b1*f*fd*k1**2*s - 180*C*D1**2*Pkdd2*b1*f*fd*k1**2 + 180*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 180*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 90*C*D1**2*Pkdd2*b1*f*fdd*k1**2 + 180*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 180*C*D1**2*Pkdd2*b1*fd**2*k1**2*s + 90*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 4480*C*D1*Dd*Pk2*f**3*s**2 - 2240*C*D1*Dd*Pk2*f**3*s + 1120*C*D1*Dd*Pk2*f**3 - 13440*C*D1*Dd*Pk2*f**2*fd*s**2 + 7840*C*D1*Dd*Pk2*f**2*fd*s - 1120*C*D1*Dd*Pk2*f**2*fd - 720*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 360*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 180*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 1440*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 1080*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 180*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 - 2240*C*D1*Ddd*Pk2*f**3*s**2 + 1120*C*D1*Ddd*Pk2*f**3*s - 560*C*D1*Ddd*Pk2*f**3 + 360*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 180*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 90*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 6720*C*Dd**2*Pk2*f**3*s**2 + 3360*C*Dd**2*Pk2*f**3*s + 1080*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 540*C*Dd**2*Pkdd2*b1*f**2*k1**2*s + 1440*D1**2*K*Pk2*b1*f*fd*s**2 - 1440*D1**2*K*Pk2*b1*f*fd*s + 720*D1**2*K*Pk2*b1*f*fd - 720*D1**2*K*Pk2*b1*f*fdd*s**2 + 720*D1**2*K*Pk2*b1*f*fdd*s - 360*D1**2*K*Pk2*b1*f*fdd - 720*D1**2*K*Pk2*b1*fd**2*s**2 + 720*D1**2*K*Pk2*b1*fd**2*s - 360*D1**2*K*Pk2*bdd1*f**2*s**2 - 126*D1**2*K*Pkdd2*b1**2*fd*k1**2*s**2 + 252*D1**2*K*Pkdd2*b1**2*fd*k1**2*s - 126*D1**2*K*Pkdd2*b1**2*fd*k1**2 + 63*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s**2 - 126*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s + 63*D1**2*K*Pkdd2*b1**2*fdd*k1**2 + 126*D1**2*K*Pkdd2*b1*bdd1*f*k1**2*s**2 + 1080*D1**2*Pk2*b1*f**2*fd*r*s - 360*D1**2*Pk2*b1*f**2*fd*r - 360*D1**2*Pk2*b1*f**2*fd*s - 1080*D1**2*Pk2*b1*f**2*fdd*r*s + 360*D1**2*Pk2*b1*f**2*fdd*r + 360*D1**2*Pk2*b1*f**2*fdd*s - 2160*D1**2*Pk2*b1*f*fd**2*r*s + 720*D1**2*Pk2*b1*f*fd**2*r + 720*D1**2*Pk2*b1*f*fd**2*s - 360*D1**2*Pk2*b1*f*fd**2 + 1440*D1**2*Pk2*b1*f*fd*r*s - 720*D1**2*Pk2*b1*f*fd*r - 720*D1**2*Pk2*b1*f*fdd*r*s + 360*D1**2*Pk2*b1*f*fdd*r - 720*D1**2*Pk2*b1*fd**2*r*s + 360*D1**2*Pk2*b1*fd**2*r + 720*D1**2*Pk2*bd2*f**2*s**2 - 1440*D1**2*Pk2*bd2*f*fd*s**2 + 720*D1**2*Pk2*bd2*f*fd*s - 360*D1**2*Pk2*bdd1*f**3*r*s + 360*D1**2*Pk2*bdd1*f**3*s - 360*D1**2*Pk2*bdd1*f**2*r*s + 360*D1**2*Pk2*bdd1*f**2*s - 360*D1**2*Pk2*bdd2*f**2*s**2 + 2640*D1**2*Pk2*f**2*fd*r*s - 880*D1**2*Pk2*f**2*fd*r - 1680*D1**2*Pk2*f**2*fd*s**2 + 240*D1**2*Pk2*f**2*fd*s - 560*D1**2*Pk2*f**2*fd - 1320*D1**2*Pk2*f**2*fdd*r*s + 440*D1**2*Pk2*f**2*fdd*r + 840*D1**2*Pk2*f**2*fdd*s**2 - 120*D1**2*Pk2*f**2*fdd*s + 280*D1**2*Pk2*f**2*fdd - 1440*D1**2*Pk2*f**2*gd2*s**2 + 720*D1**2*Pk2*f**2*gdd2*s**2 - 2640*D1**2*Pk2*f*fd**2*r*s + 880*D1**2*Pk2*f*fd**2*r + 1680*D1**2*Pk2*f*fd**2*s**2 - 240*D1**2*Pk2*f*fd**2*s - 440*D1**2*Pk2*f*fd**2 - 2880*D1**2*Pk2*f*fd*g2*s**2 + 2880*D1**2*Pk2*f*fd*g2*s - 1440*D1**2*Pk2*f*fd*g2 + 2880*D1**2*Pk2*f*fd*gd2*s**2 - 1440*D1**2*Pk2*f*fd*gd2*s + 1440*D1**2*Pk2*f*fdd*g2*s**2 - 1440*D1**2*Pk2*f*fdd*g2*s + 720*D1**2*Pk2*f*fdd*g2 + 1440*D1**2*Pk2*fd**2*g2*s**2 - 1440*D1**2*Pk2*fd**2*g2*s + 126*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 252*D1**2*Pkdd2*b1**2*fd*k1**2*s + 126*D1**2*Pkdd2*b1**2*fd*k1**2 - 63*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 126*D1**2*Pkdd2*b1**2*fdd*k1**2*s - 63*D1**2*Pkdd2*b1**2*fdd*k1**2 - 126*D1**2*Pkdd2*b1*bdd1*f*k1**2*s**2 - 630*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 420*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 210*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 315*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 210*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 105*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 630*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 420*D1**2*Pkdd2*b1*f*fd**2*k1**2*s + 252*D1**2*Pkdd2*b1*f*gd2*k1**2*s**2 - 126*D1**2*Pkdd2*b1*f*gdd2*k1**2*s**2 + 252*D1**2*Pkdd2*b1*fd*g2*k1**2*s**2 - 504*D1**2*Pkdd2*b1*fd*g2*k1**2*s + 252*D1**2*Pkdd2*b1*fd*g2*k1**2 - 252*D1**2*Pkdd2*b1*fd*gd2*k1**2*s**2 + 252*D1**2*Pkdd2*b1*fd*gd2*k1**2*s - 126*D1**2*Pkdd2*b1*fdd*g2*k1**2*s**2 + 252*D1**2*Pkdd2*b1*fdd*g2*k1**2*s - 126*D1**2*Pkdd2*b1*fdd*g2*k1**2 + 126*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(K - 1) + 105*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 126*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 420*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 280*D1**2*Pkdd2*f**2*fd*k1**2*s - 140*D1**2*Pkdd2*f**2*fd*k1**2 + 210*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 140*D1**2*Pkdd2*f**2*fdd*k1**2*s + 70*D1**2*Pkdd2*f**2*fdd*k1**2 + 420*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 280*D1**2*Pkdd2*f*fd**2*k1**2*s + 2880*D1*Dd*K*Pk2*b1*f**2*s**2 - 1440*D1*Dd*K*Pk2*b1*f**2*s + 720*D1*Dd*K*Pk2*b1*f**2 - 5760*D1*Dd*K*Pk2*b1*f*fd*s**2 + 4320*D1*Dd*K*Pk2*b1*f*fd*s - 720*D1*Dd*K*Pk2*b1*f*fd - 504*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s**2 + 252*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s - 126*D1*Dd*K*Pkdd2*b1**2*f*k1**2 + 504*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s**2 - 630*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s + 126*D1*Dd*K*Pkdd2*b1**2*fd*k1**2 + 1440*D1*Dd*Pk2*b1*f**3*r*s - 360*D1*Dd*Pk2*b1*f**3*r - 720*D1*Dd*Pk2*b1*f**3*s - 8640*D1*Dd*Pk2*b1*f**2*fd*r*s + 2520*D1*Dd*Pk2*b1*f**2*fd*r + 3600*D1*Dd*Pk2*b1*f**2*fd*s - 1080*D1*Dd*Pk2*b1*f**2*fd + 2880*D1*Dd*Pk2*b1*f**2*r*s - 720*D1*Dd*Pk2*b1*f**2*r - 1440*D1*Dd*Pk2*b1*f**2*s - 5760*D1*Dd*Pk2*b1*f*fd*r*s + 2160*D1*Dd*Pk2*b1*f*fd*r + 1440*D1*Dd*Pk2*b1*f*fd*s - 720*D1*Dd*Pk2*b1*f*fd - 2880*D1*Dd*Pk2*bd2*f**2*s**2 + 720*D1*Dd*Pk2*bd2*f**2*s + 3520*D1*Dd*Pk2*f**3*r*s - 880*D1*Dd*Pk2*f**3*r - 2240*D1*Dd*Pk2*f**3*s**2 - 640*D1*Dd*Pk2*f**3*s - 560*D1*Dd*Pk2*f**3 - 10560*D1*Dd*Pk2*f**2*fd*r*s + 3080*D1*Dd*Pk2*f**2*fd*r + 6720*D1*Dd*Pk2*f**2*fd*s**2 + 480*D1*Dd*Pk2*f**2*fd*s - 760*D1*Dd*Pk2*f**2*fd - 5760*D1*Dd*Pk2*f**2*g2*s**2 + 2880*D1*Dd*Pk2*f**2*g2*s - 1440*D1*Dd*Pk2*f**2*g2 + 5760*D1*Dd*Pk2*f**2*gd2*s**2 - 1440*D1*Dd*Pk2*f**2*gd2*s + 11520*D1*Dd*Pk2*f*fd*g2*s**2 - 8640*D1*Dd*Pk2*f*fd*g2*s + 1440*D1*Dd*Pk2*f*fd*g2 + 504*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 252*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 126*D1*Dd*Pkdd2*b1**2*f*k1**2 - 504*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 630*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 126*D1*Dd*Pkdd2*b1**2*fd*k1**2 - 840*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 420*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 210*D1*Dd*Pkdd2*b1*f**3*k1**2 + 2520*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 1470*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 210*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 + 1008*D1*Dd*Pkdd2*b1*f*g2*k1**2*s**2 - 504*D1*Dd*Pkdd2*b1*f*g2*k1**2*s + 252*D1*Dd*Pkdd2*b1*f*g2*k1**2 - 1008*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s**2 + 252*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s - 1008*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s**2 + 1260*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s - 252*D1*Dd*Pkdd2*b1*fd*g2*k1**2 - 560*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 280*D1*Dd*Pkdd2*f**3*k1**2*s - 140*D1*Dd*Pkdd2*f**3*k1**2 + 1680*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 980*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 140*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1440*D1*Ddd*K*Pk2*b1*f**2*s**2 + 720*D1*Ddd*K*Pk2*b1*f**2*s - 360*D1*Ddd*K*Pk2*b1*f**2 + 252*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s**2 - 126*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s + 63*D1*Ddd*K*Pkdd2*b1**2*f*k1**2 - 1440*D1*Ddd*Pk2*b1*f**3*r*s + 360*D1*Ddd*Pk2*b1*f**3*r + 720*D1*Ddd*Pk2*b1*f**3*s - 1440*D1*Ddd*Pk2*b1*f**2*r*s + 360*D1*Ddd*Pk2*b1*f**2*r + 720*D1*Ddd*Pk2*b1*f**2*s - 1760*D1*Ddd*Pk2*f**3*r*s + 440*D1*Ddd*Pk2*f**3*r + 1120*D1*Ddd*Pk2*f**3*s**2 + 320*D1*Ddd*Pk2*f**3*s + 280*D1*Ddd*Pk2*f**3 + 2880*D1*Ddd*Pk2*f**2*g2*s**2 - 1440*D1*Ddd*Pk2*f**2*g2*s + 720*D1*Ddd*Pk2*f**2*g2 - 252*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 126*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 63*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 420*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 210*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 105*D1*Ddd*Pkdd2*b1*f**3*k1**2 - 504*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s**2 + 252*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s - 126*D1*Ddd*Pkdd2*b1*f*g2*k1**2 + 280*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 140*D1*Ddd*Pkdd2*f**3*k1**2*s + 70*D1*Ddd*Pkdd2*f**3*k1**2 + 6*D1*bd1*(D1*(-42*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) + 5*f**3*s*(12*Pk2*(r - 1) - 7*Pkdd2*k1**2*s) - 5*f**2*(fd*(12*Pk2*(6*r*s - r - 4*s + 1) + 7*Pkdd2*k1**2*s*(1 - 3*s)) + 6*s*(C*Pkdd2*k1**2*s - 4*Pk2*(K*s + r - 1))) - 6*f*(Pkdd2*k1**2*s**2*(7*b1*(K - 1) - 7*g2 + 7*gd2) + 5*fd*(C*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*r*(8*s - 2) + 2*Pk2*(2*s - 1)*(2*K*s - 1)))) + Dd*f*(Pkdd2*k1**2*s*(4*s - 1)*(42*K*b1 - 42*b1 - 42*g2) - 5*f**2*(12*Pk2*(r*(8*s - 1) - 6*s + 1) + 7*Pkdd2*k1**2*s*(1 - 4*s)) - 30*f*(C*Pkdd2*k1**2*s*(1 - 4*s) + 2*Pk2*(8*K*s**2 + r*(8*s - 1) - s*(2*K + 6) + 1)))) - 4320*Dd**2*K*Pk2*b1*f**2*s**2 + 2160*Dd**2*K*Pk2*b1*f**2*s + 756*Dd**2*K*Pkdd2*b1**2*f*k1**2*s**2 - 378*Dd**2*K*Pkdd2*b1**2*f*k1**2*s - 4320*Dd**2*Pk2*b1*f**3*r*s + 1080*Dd**2*Pk2*b1*f**3*r + 2160*Dd**2*Pk2*b1*f**3*s - 720*Dd**2*Pk2*b1*f**3 - 4320*Dd**2*Pk2*b1*f**2*r*s + 1080*Dd**2*Pk2*b1*f**2*r + 2160*Dd**2*Pk2*b1*f**2*s - 720*Dd**2*Pk2*b1*f**2 - 5280*Dd**2*Pk2*f**3*r*s + 1320*Dd**2*Pk2*f**3*r + 3360*Dd**2*Pk2*f**3*s**2 + 960*Dd**2*Pk2*f**3*s - 880*Dd**2*Pk2*f**3 + 8640*Dd**2*Pk2*f**2*g2*s**2 - 4320*Dd**2*Pk2*f**2*g2*s - 756*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 378*Dd**2*Pkdd2*b1**2*f*k1**2*s + 1260*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 630*Dd**2*Pkdd2*b1*f**3*k1**2*s - 1512*Dd**2*Pkdd2*b1*f*g2*k1**2*s**2 + 756*Dd**2*Pkdd2*b1*f*g2*k1**2*s + 840*Dd**2*Pkdd2*f**3*k1**2*s**2 - 420*Dd**2*Pkdd2*f**3*k1**2*s + 360*Pk2*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(630*d**2*k3**2) + D1**2*Pk3*ct**5*k1**3*(15840*C*D1**2*Pk2*bdd1*f**2*r*s + 31680*C*D1**2*Pk2*bdd1*f**2*s**2 - 31680*C*D1**2*Pk2*bdd1*f**2*s + 15840*C*D1**2*Pk2*bdd1*f**2 + 142560*C*D1**2*Pk2*f**2*fd*r*s - 47520*C*D1**2*Pk2*f**2*fd*r + 240240*C*D1**2*Pk2*f**2*fd*s**2 - 207680*C*D1**2*Pk2*f**2*fd*s + 80080*C*D1**2*Pk2*f**2*fd - 95040*C*D1**2*Pk2*f**2*fdd*r*s + 31680*C*D1**2*Pk2*f**2*fdd*r - 203280*C*D1**2*Pk2*f**2*fdd*s**2 + 167200*C*D1**2*Pk2*f**2*fdd*s - 67760*C*D1**2*Pk2*f**2*fdd - 190080*C*D1**2*Pk2*f*fd**2*r*s + 63360*C*D1**2*Pk2*f*fd**2*r - 406560*C*D1**2*Pk2*f*fd**2*s**2 + 334400*C*D1**2*Pk2*f*fd**2*s - 31680*C*D1**2*Pk2*f*fd**2 + 190080*C*D1*Dd*Pk2*f**3*r*s - 47520*C*D1*Dd*Pk2*f**3*r + 320320*C*D1*Dd*Pk2*f**3*s**2 - 255200*C*D1*Dd*Pk2*f**3*s + 80080*C*D1*Dd*Pk2*f**3 - 760320*C*D1*Dd*Pk2*f**2*fd*r*s + 221760*C*D1*Dd*Pk2*f**2*fd*r - 1626240*C*D1*Dd*Pk2*f**2*fd*s**2 + 1265440*C*D1*Dd*Pk2*f**2*fd*s - 230560*C*D1*Dd*Pk2*f**2*fd - 126720*C*D1*Ddd*Pk2*f**3*r*s + 31680*C*D1*Ddd*Pk2*f**3*r - 271040*C*D1*Ddd*Pk2*f**3*s**2 + 198880*C*D1*Ddd*Pk2*f**3*s - 67760*C*D1*Ddd*Pk2*f**3 - 380160*C*Dd**2*Pk2*f**3*r*s + 95040*C*Dd**2*Pk2*f**3*r - 813120*C*Dd**2*Pk2*f**3*s**2 + 596640*C*Dd**2*Pk2*f**3*s - 63360*C*Dd**2*Pk2*f**3 - 19008*D1**2*K*Pk2*bdd1*f**2*r*s - 46728*D1**2*K*Pk2*bdd1*f**2*s**2 + 19008*D1**2*K*Pk2*bdd1*f**2*s + 11088*D1**2*Pk2*bd1**2*f*s*(K - 1)*(2*r + 4*s - 3) + 30800*D1**2*Pk2*bdd1*f**3*r*s + 30800*D1**2*Pk2*bdd1*f**3*s**2 - 36960*D1**2*Pk2*bdd1*f**3*s + 9240*D1**2*Pk2*bdd1*f**3 + 26928*D1**2*Pk2*bdd1*f**2*r*s + 42768*D1**2*Pk2*bdd1*f**2*s**2 - 11088*D1**2*Pk2*bdd1*f**2*s - 15840*D1**2*Pk2*bdd1*f**2 - 22176*D1**2*Pk2*bdd1*f*g2*r*s - 44352*D1**2*Pk2*bdd1*f*g2*s**2 + 44352*D1**2*Pk2*bdd1*f*g2*s - 22176*D1**2*Pk2*bdd1*f*g2 + 147840*D1**2*Pk2*f**3*fd*r*s - 36960*D1**2*Pk2*f**3*fd*r + 277200*D1**2*Pk2*f**3*fd*s**2 - 212520*D1**2*Pk2*f**3*fd*s + 69300*D1**2*Pk2*f**3*fd - 147840*D1**2*Pk2*f**3*fdd*r*s + 36960*D1**2*Pk2*f**3*fdd*r - 203280*D1**2*Pk2*f**3*fdd*s**2 + 175560*D1**2*Pk2*f**3*fdd*s - 50820*D1**2*Pk2*f**3*fdd - 443520*D1**2*Pk2*f**2*fd**2*r*s + 110880*D1**2*Pk2*f**2*fd**2*r - 609840*D1**2*Pk2*f**2*fd**2*s**2 + 526680*D1**2*Pk2*f**2*fd**2*s - 73920*D1**2*Pk2*f**2*fd**2 - 205920*D1**2*Pk2*f**2*fd*r*s + 68640*D1**2*Pk2*f**2*fd*r - 322080*D1**2*Pk2*f**2*fd*s**2 + 283360*D1**2*Pk2*f**2*fd*s - 107360*D1**2*Pk2*f**2*fd + 150480*D1**2*Pk2*f**2*fdd*r*s - 50160*D1**2*Pk2*f**2*fdd*r + 267960*D1**2*Pk2*f**2*fdd*s**2 - 228800*D1**2*Pk2*f**2*fdd*s + 89320*D1**2*Pk2*f**2*fdd - 53856*D1**2*Pk2*f**2*gd2*r*s - 109296*D1**2*Pk2*f**2*gd2*s**2 + 53856*D1**2*Pk2*f**2*gd2*s + 38016*D1**2*Pk2*f**2*gdd2*r*s + 93456*D1**2*Pk2*f**2*gdd2*s**2 - 38016*D1**2*Pk2*f**2*gdd2*s + 300960*D1**2*Pk2*f*fd**2*r*s - 100320*D1**2*Pk2*f*fd**2*r + 535920*D1**2*Pk2*f*fd**2*s**2 - 457600*D1**2*Pk2*f*fd**2*s + 50160*D1**2*Pk2*f*fd**2 - 107712*D1**2*Pk2*f*fd*g2*r*s + 53856*D1**2*Pk2*f*fd*g2*r - 218592*D1**2*Pk2*f*fd*g2*s**2 + 218592*D1**2*Pk2*f*fd*g2*s - 109296*D1**2*Pk2*f*fd*g2 + 152064*D1**2*Pk2*f*fd*gd2*r*s - 38016*D1**2*Pk2*f*fd*gd2*r + 373824*D1**2*Pk2*f*fd*gd2*s**2 - 262944*D1**2*Pk2*f*fd*gd2*s + 38016*D1**2*Pk2*f*fd*gd2 + 76032*D1**2*Pk2*f*fdd*g2*r*s - 38016*D1**2*Pk2*f*fdd*g2*r + 186912*D1**2*Pk2*f*fdd*g2*s**2 - 186912*D1**2*Pk2*f*fdd*g2*s + 93456*D1**2*Pk2*f*fdd*g2 + 76032*D1**2*Pk2*fd**2*g2*r*s - 38016*D1**2*Pk2*fd**2*g2*r + 186912*D1**2*Pk2*fd**2*g2*s**2 - 186912*D1**2*Pk2*fd**2*g2*s - 2520*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 1260*D1**2*Pkdd2*f**3*fd*k1**2*s - 630*D1**2*Pkdd2*f**3*fd*k1**2 + 1260*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 630*D1**2*Pkdd2*f**3*fdd*k1**2*s + 315*D1**2*Pkdd2*f**3*fdd*k1**2 + 3780*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 1890*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 147840*D1*Dd*Pk2*f**4*r*s - 36960*D1*Dd*Pk2*f**4*r + 277200*D1*Dd*Pk2*f**4*s**2 - 212520*D1*Dd*Pk2*f**4*s + 69300*D1*Dd*Pk2*f**4 - 1182720*D1*Dd*Pk2*f**3*fd*r*s + 295680*D1*Dd*Pk2*f**3*fd*r - 1626240*D1*Dd*Pk2*f**3*fd*s**2 + 1404480*D1*Dd*Pk2*f**3*fd*s - 249480*D1*Dd*Pk2*f**3*fd - 274560*D1*Dd*Pk2*f**3*r*s + 68640*D1*Dd*Pk2*f**3*r - 429440*D1*Dd*Pk2*f**3*s**2 + 352000*D1*Dd*Pk2*f**3*s - 107360*D1*Dd*Pk2*f**3 + 1203840*D1*Dd*Pk2*f**2*fd*r*s - 351120*D1*Dd*Pk2*f**2*fd*r + 2143680*D1*Dd*Pk2*f**2*fd*s**2 - 1752080*D1*Dd*Pk2*f**2*fd*s + 329120*D1*Dd*Pk2*f**2*fd - 215424*D1*Dd*Pk2*f**2*g2*r*s + 53856*D1*Dd*Pk2*f**2*g2*r - 437184*D1*Dd*Pk2*f**2*g2*s**2 + 326304*D1*Dd*Pk2*f**2*g2*s - 109296*D1*Dd*Pk2*f**2*g2 + 304128*D1*Dd*Pk2*f**2*gd2*r*s - 38016*D1*Dd*Pk2*f**2*gd2*r + 747648*D1*Dd*Pk2*f**2*gd2*s**2 - 415008*D1*Dd*Pk2*f**2*gd2*s + 38016*D1*Dd*Pk2*f**2*gd2 + 608256*D1*Dd*Pk2*f*fd*g2*r*s - 228096*D1*Dd*Pk2*f*fd*g2*r + 1495296*D1*Dd*Pk2*f*fd*g2*s**2 - 1273536*D1*Dd*Pk2*f*fd*g2*s + 262944*D1*Dd*Pk2*f*fd*g2 - 2520*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 1260*D1*Dd*Pkdd2*f**4*k1**2*s - 630*D1*Dd*Pkdd2*f**4*k1**2 + 10080*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 5040*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 630*D1*Dd*Pkdd2*f**3*fd*k1**2 - 147840*D1*Ddd*Pk2*f**4*r*s + 36960*D1*Ddd*Pk2*f**4*r - 203280*D1*Ddd*Pk2*f**4*s**2 + 175560*D1*Ddd*Pk2*f**4*s - 50820*D1*Ddd*Pk2*f**4 + 200640*D1*Ddd*Pk2*f**3*r*s - 50160*D1*Ddd*Pk2*f**3*r + 357280*D1*Ddd*Pk2*f**3*s**2 - 278960*D1*Ddd*Pk2*f**3*s + 89320*D1*Ddd*Pk2*f**3 + 152064*D1*Ddd*Pk2*f**2*g2*r*s - 38016*D1*Ddd*Pk2*f**2*g2*r + 373824*D1*Ddd*Pk2*f**2*g2*s**2 - 262944*D1*Ddd*Pk2*f**2*g2*s + 93456*D1*Ddd*Pk2*f**2*g2 + 1260*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 630*D1*Ddd*Pkdd2*f**4*k1**2*s + 315*D1*Ddd*Pkdd2*f**4*k1**2 - 88*D1*Pk2*bd1*(D1*(10*f**3*(43*s**2 + s*(43*r - 66) + 21) + f**2*(36*C*(13*s**2 + s*(3*r - 20) + 10) - 70*fd*(5*r*(6*s - 1) + 30*s**2 - 32*s + 3) - 9*s**2*(69*K - 59) - 9*s*(34*K*(r - 1) - 54*r - 14) - 360) + 6*f*(3*fd*(-80*C*s**2 + 70*C*s + K*(12*r*(4*s - 1) + 118*s**2 - 83*s + 12) - r*(10*C + 17)*(4*s - 1) - 108*s**2 + 78*s - 27) - 14*g2*(7*s**2 + s*(r - 12) + 6) + 42*gd2*s*(2*r + 4*s - 3)) + 252*fd*g2*(r*(2*s - 1) + s*(4*s - 4))) - 2*Dd*f*(35*f**2*(5*r*(8*s - 1) + 40*s**2 - 44*s + 6) + 9*f*(10*C*(8*r*s - r + 16*s**2 - 14*s + 2) + K*(-96*r*s + 12*r - 236*s**2 + 131*s - 12) + 136*r*s - 17*r + 216*s**2 - 116*s + 7) - 126*g2*(8*r*s - r + 16*s**2 - 14*s + 2))) - 443520*Dd**2*Pk2*f**4*r*s + 110880*Dd**2*Pk2*f**4*r - 609840*Dd**2*Pk2*f**4*s**2 + 526680*Dd**2*Pk2*f**4*s - 73920*Dd**2*Pk2*f**4 + 601920*Dd**2*Pk2*f**3*r*s - 150480*Dd**2*Pk2*f**3*r + 1071840*Dd**2*Pk2*f**3*s**2 - 836880*Dd**2*Pk2*f**3*s + 100320*Dd**2*Pk2*f**3 + 456192*Dd**2*Pk2*f**2*g2*r*s - 114048*Dd**2*Pk2*f**2*g2*r + 1121472*Dd**2*Pk2*f**2*g2*s**2 - 788832*Dd**2*Pk2*f**2*g2*s + 76032*Dd**2*Pk2*f**2*g2 + 3780*Dd**2*Pkdd2*f**4*k1**2*s**2 - 1890*Dd**2*Pkdd2*f**4*k1**2*s - 3696*Pk2*b1**2*(K - 1)*(D1**2*(fd*(r*(s - 1) + 7*s**2 - 2*s + 1) - 3*fdd*(r*(s - 1) + 2*s**2 - 2*s + 1)) + D1*(Dd*(f*(4*r*s - r + 28*s**2 - 16*s + 7) - 3*fd*(8*r*s - 5*r + 16*s**2 - 14*s + 4)) - 3*Ddd*f*(r*(4*s - 1) + 8*s**2 - 6*s + 2)) - 3*Dd**2*f*(3*r*(4*s - 1) + 24*s**2 - 18*s + 2)) - 88*Pk2*b1*(216*C*D1**2*f*fd*r*s - 108*C*D1**2*f*fd*r + 936*C*D1**2*f*fd*s**2 - 324*C*D1**2*f*fd*s + 108*C*D1**2*f*fd - 360*C*D1**2*f*fdd*r*s + 180*C*D1**2*f*fdd*r - 720*C*D1**2*f*fdd*s**2 + 540*C*D1**2*f*fdd*s - 180*C*D1**2*f*fdd - 360*C*D1**2*fd**2*r*s + 180*C*D1**2*fd**2*r - 720*C*D1**2*fd**2*s**2 + 540*C*D1**2*fd**2*s - 180*C*D1**2*fd**2 + 432*C*D1*Dd*f**2*r*s - 108*C*D1*Dd*f**2*r + 1872*C*D1*Dd*f**2*s**2 - 1152*C*D1*Dd*f**2*s + 468*C*D1*Dd*f**2 - 2880*C*D1*Dd*f*fd*r*s + 1080*C*D1*Dd*f*fd*r - 5760*C*D1*Dd*f*fd*s**2 + 4320*C*D1*Dd*f*fd*s - 900*C*D1*Dd*f*fd - 720*C*D1*Ddd*f**2*r*s + 180*C*D1*Ddd*f**2*r - 1440*C*D1*Ddd*f**2*s**2 + 1080*C*D1*Ddd*f**2*s - 360*C*D1*Ddd*f**2 - 2160*C*Dd**2*f**2*r*s + 540*C*Dd**2*f**2*r - 4320*C*Dd**2*f**2*s**2 + 3240*C*Dd**2*f**2*s - 360*C*Dd**2*f**2 - 612*D1**2*K*f*fd*r*s + 306*D1**2*K*f*fd*r - 1242*D1**2*K*f*fd*s**2 + 1242*D1**2*K*f*fd*s - 621*D1**2*K*f*fd + 432*D1**2*K*f*fdd*r*s - 216*D1**2*K*f*fdd*r + 1062*D1**2*K*f*fdd*s**2 - 1062*D1**2*K*f*fdd*s + 531*D1**2*K*f*fdd + 432*D1**2*K*fd**2*r*s - 216*D1**2*K*fd**2*r + 1062*D1**2*K*fd**2*s**2 - 1062*D1**2*K*fd**2*s - 126*D1**2*bdd1*f*(K - 1)*(2*r*s + 4*s**2 - 3*s + 1) + 1290*D1**2*f**2*fd*r*s - 430*D1**2*f**2*fd*r + 1290*D1**2*f**2*fd*s**2 - 1060*D1**2*f**2*fd*s + 220*D1**2*f**2*fd - 1050*D1**2*f**2*fdd*r*s + 350*D1**2*f**2*fdd*r - 1050*D1**2*f**2*fdd*s**2 + 980*D1**2*f**2*fdd*s - 245*D1**2*f**2*fdd - 2100*D1**2*f*fd**2*r*s + 700*D1**2*f*fd**2*r - 2100*D1**2*f*fd**2*s**2 + 1960*D1**2*f*fd**2*s - 490*D1**2*f*fd**2 + 972*D1**2*f*fd*r*s - 486*D1**2*f*fd*r + 1062*D1**2*f*fd*s**2 - 1674*D1**2*f*fd*s + 891*D1**2*f*fd - 612*D1**2*f*fdd*r*s + 306*D1**2*f*fdd*r - 972*D1**2*f*fdd*s**2 + 1152*D1**2*f*fdd*s - 666*D1**2*f*fdd - 84*D1**2*f*gd2*r*s - 588*D1**2*f*gd2*s**2 + 84*D1**2*f*gd2*s + 252*D1**2*f*gdd2*r*s + 504*D1**2*f*gdd2*s**2 - 252*D1**2*f*gdd2*s - 612*D1**2*fd**2*r*s + 306*D1**2*fd**2*r - 972*D1**2*fd**2*s**2 + 1152*D1**2*fd**2*s + 180*D1**2*fd**2 - 84*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*r - 588*D1**2*fd*g2*s**2 + 168*D1**2*fd*g2*s - 84*D1**2*fd*g2 + 504*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*r + 1008*D1**2*fd*gd2*s**2 - 756*D1**2*fd*gd2*s + 252*D1**2*fd*gd2 + 252*D1**2*fdd*g2*r*s - 252*D1**2*fdd*g2*r + 504*D1**2*fdd*g2*s**2 - 504*D1**2*fdd*g2*s + 252*D1**2*fdd*g2 - 1224*D1*Dd*K*f**2*r*s + 306*D1*Dd*K*f**2*r - 2484*D1*Dd*K*f**2*s**2 + 1854*D1*Dd*K*f**2*s - 621*D1*Dd*K*f**2 + 3456*D1*Dd*K*f*fd*r*s - 1296*D1*Dd*K*f*fd*r + 8496*D1*Dd*K*f*fd*s**2 - 7236*D1*Dd*K*f*fd*s + 1494*D1*Dd*K*f*fd + 1720*D1*Dd*f**3*r*s - 430*D1*Dd*f**3*r + 1720*D1*Dd*f**3*s**2 - 1720*D1*Dd*f**3*s + 430*D1*Dd*f**3 - 8400*D1*Dd*f**2*fd*r*s + 2450*D1*Dd*f**2*fd*r - 8400*D1*Dd*f**2*fd*s**2 + 8120*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd + 1944*D1*Dd*f**2*r*s - 486*D1*Dd*f**2*r + 2124*D1*Dd*f**2*s**2 - 2034*D1*Dd*f**2*s + 531*D1*Dd*f**2 - 4896*D1*Dd*f*fd*r*s + 1836*D1*Dd*f*fd*r - 7776*D1*Dd*f*fd*s**2 + 7776*D1*Dd*f*fd*s - 1764*D1*Dd*f*fd - 336*D1*Dd*f*g2*r*s + 84*D1*Dd*f*g2*r - 2352*D1*Dd*f*g2*s**2 + 1344*D1*Dd*f*g2*s - 588*D1*Dd*f*g2 + 2016*D1*Dd*f*gd2*r*s - 252*D1*Dd*f*gd2*r + 4032*D1*Dd*f*gd2*s**2 - 2520*D1*Dd*f*gd2*s + 252*D1*Dd*f*gd2 + 2016*D1*Dd*fd*g2*r*s - 1260*D1*Dd*fd*g2*r + 4032*D1*Dd*fd*g2*s**2 - 3528*D1*Dd*fd*g2*s + 1008*D1*Dd*fd*g2 + 864*D1*Ddd*K*f**2*r*s - 216*D1*Ddd*K*f**2*r + 2124*D1*Ddd*K*f**2*s**2 - 1494*D1*Ddd*K*f**2*s + 531*D1*Ddd*K*f**2 - 1400*D1*Ddd*f**3*r*s + 350*D1*Ddd*f**3*r - 1400*D1*Ddd*f**3*s**2 + 1400*D1*Ddd*f**3*s - 350*D1*Ddd*f**3 - 1224*D1*Ddd*f**2*r*s + 306*D1*Ddd*f**2*r - 1944*D1*Ddd*f**2*s**2 + 1584*D1*Ddd*f**2*s - 486*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r*s - 252*D1*Ddd*f*g2*r + 2016*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 504*D1*Ddd*f*g2 + 42*D1*bd1*(K - 1)*(D1*(f*(2*r*s + 14*s**2 - 13*s + 6) - 3*fd*(4*r*s - 2*r + 8*s**2 - 7*s + 1)) - 3*Dd*f*(2*r*(8*s - 1) + 32*s**2 - 24*s + 3)) + 2592*Dd**2*K*f**2*r*s - 648*Dd**2*K*f**2*r + 6372*Dd**2*K*f**2*s**2 - 4482*Dd**2*K*f**2*s + 432*Dd**2*K*f**2 - 4200*Dd**2*f**3*r*s + 1050*Dd**2*f**3*r - 4200*Dd**2*f**3*s**2 + 4200*Dd**2*f**3*s - 700*Dd**2*f**3 - 3672*Dd**2*f**2*r*s + 918*Dd**2*f**2*r - 5832*Dd**2*f**2*s**2 + 4752*Dd**2*f**2*s - 612*Dd**2*f**2 + 3024*Dd**2*f*g2*r*s - 756*Dd**2*f*g2*r + 6048*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 504*Dd**2*f*g2))/(6930*d**2*k2*k3**4) - D1**2*Pk3*ct**5*k1*k2*st**2*(-204864*C*D1**2*Pk2*f**2*fd*r*s + 68288*C*D1**2*Pk2*f**2*fd*r + 158400*C*D1**2*Pk2*f**2*fd*s**2 - 37312*C*D1**2*Pk2*f**2*fd*s + 52800*C*D1**2*Pk2*f**2*fd + 121440*C*D1**2*Pk2*f**2*fdd*r*s - 40480*C*D1**2*Pk2*f**2*fdd*r - 79200*C*D1**2*Pk2*f**2*fdd*s**2 + 12320*C*D1**2*Pk2*f**2*fdd*s - 26400*C*D1**2*Pk2*f**2*fdd + 242880*C*D1**2*Pk2*f*fd**2*r*s - 80960*C*D1**2*Pk2*f*fd**2*r - 158400*C*D1**2*Pk2*f*fd**2*s**2 + 24640*C*D1**2*Pk2*f*fd**2*s + 40480*C*D1**2*Pk2*f*fd**2 + 13200*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 8800*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 4400*C*D1**2*Pkdd2*f**2*fd*k1**2 - 6600*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 4400*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 2200*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 13200*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 8800*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 273152*C*D1*Dd*Pk2*f**3*r*s + 68288*C*D1*Dd*Pk2*f**3*r + 211200*C*D1*Dd*Pk2*f**3*s**2 + 30976*C*D1*Dd*Pk2*f**3*s + 52800*C*D1*Dd*Pk2*f**3 + 971520*C*D1*Dd*Pk2*f**2*fd*r*s - 283360*C*D1*Dd*Pk2*f**2*fd*r - 633600*C*D1*Dd*Pk2*f**2*fd*s**2 - 35200*C*D1*Dd*Pk2*f**2*fd*s + 68640*C*D1*Dd*Pk2*f**2*fd + 17600*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 8800*C*D1*Dd*Pkdd2*f**3*k1**2*s + 4400*C*D1*Dd*Pkdd2*f**3*k1**2 - 52800*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 30800*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 4400*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 161920*C*D1*Ddd*Pk2*f**3*r*s - 40480*C*D1*Ddd*Pk2*f**3*r - 105600*C*D1*Ddd*Pk2*f**3*s**2 - 28160*C*D1*Ddd*Pk2*f**3*s - 26400*C*D1*Ddd*Pk2*f**3 - 8800*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 4400*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 2200*C*D1*Ddd*Pkdd2*f**3*k1**2 + 485760*C*Dd**2*Pk2*f**3*r*s - 121440*C*Dd**2*Pk2*f**3*r - 316800*C*Dd**2*Pk2*f**3*s**2 - 84480*C*Dd**2*Pk2*f**3*s + 80960*C*Dd**2*Pk2*f**3 - 26400*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 13200*C*Dd**2*Pkdd2*f**3*k1**2*s + 23760*D1**2*K*Pk2*bdd1*f**2*r*s - 23760*D1**2*K*Pk2*bdd1*f**2*s**2 - 23760*D1**2*K*Pk2*bdd1*f**2*s - 1980*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 18480*D1**2*Pk2*bdd1*f**3*r*s - 9240*D1**2*Pk2*bdd1*f**3*s**2 + 18480*D1**2*Pk2*bdd1*f**3*s - 47520*D1**2*Pk2*bdd1*f**2*r*s - 11880*D1**2*Pk2*bdd1*f**2*s**2 + 47520*D1**2*Pk2*bdd1*f**2*s - 73920*D1**2*Pk2*f**3*fd*r*s + 18480*D1**2*Pk2*f**3*fd*r + 36960*D1**2*Pk2*f**3*fd*s + 73920*D1**2*Pk2*f**3*fdd*r*s - 18480*D1**2*Pk2*f**3*fdd*r - 36960*D1**2*Pk2*f**3*fdd*s + 221760*D1**2*Pk2*f**2*fd**2*r*s - 55440*D1**2*Pk2*f**2*fd**2*r - 110880*D1**2*Pk2*f**2*fd**2*s + 36960*D1**2*Pk2*f**2*fd**2 + 284064*D1**2*Pk2*f**2*fd*r*s - 94688*D1**2*Pk2*f**2*fd*r - 39600*D1**2*Pk2*f**2*fd*s**2 - 68288*D1**2*Pk2*f**2*fd*s - 13200*D1**2*Pk2*f**2*fd - 161040*D1**2*Pk2*f**2*fdd*r*s + 53680*D1**2*Pk2*f**2*fdd*r + 19800*D1**2*Pk2*f**2*fdd*s**2 + 40480*D1**2*Pk2*f**2*fdd*s + 6600*D1**2*Pk2*f**2*fdd + 95040*D1**2*Pk2*f**2*gd2*r*s - 95040*D1**2*Pk2*f**2*gd2*s**2 - 95040*D1**2*Pk2*f**2*gd2*s - 47520*D1**2*Pk2*f**2*gdd2*r*s + 47520*D1**2*Pk2*f**2*gdd2*s**2 + 47520*D1**2*Pk2*f**2*gdd2*s - 322080*D1**2*Pk2*f*fd**2*r*s + 107360*D1**2*Pk2*f*fd**2*r + 39600*D1**2*Pk2*f*fd**2*s**2 + 80960*D1**2*Pk2*f*fd**2*s - 53680*D1**2*Pk2*f*fd**2 + 190080*D1**2*Pk2*f*fd*g2*r*s - 95040*D1**2*Pk2*f*fd*g2*r - 190080*D1**2*Pk2*f*fd*g2*s**2 + 190080*D1**2*Pk2*f*fd*g2*s - 95040*D1**2*Pk2*f*fd*g2 - 190080*D1**2*Pk2*f*fd*gd2*r*s + 47520*D1**2*Pk2*f*fd*gd2*r + 190080*D1**2*Pk2*f*fd*gd2*s**2 - 47520*D1**2*Pk2*f*fd*gd2 - 95040*D1**2*Pk2*f*fdd*g2*r*s + 47520*D1**2*Pk2*f*fdd*g2*r + 95040*D1**2*Pk2*f*fdd*g2*s**2 - 95040*D1**2*Pk2*f*fdd*g2*s + 47520*D1**2*Pk2*f*fdd*g2 - 95040*D1**2*Pk2*fd**2*g2*r*s + 47520*D1**2*Pk2*fd**2*g2*r + 95040*D1**2*Pk2*fd**2*g2*s**2 - 95040*D1**2*Pk2*fd**2*g2*s + 1980*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 17640*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 8820*D1**2*Pkdd2*f**3*fd*k1**2*s + 4410*D1**2*Pkdd2*f**3*fd*k1**2 - 8820*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 4410*D1**2*Pkdd2*f**3*fdd*k1**2*s - 2205*D1**2*Pkdd2*f**3*fdd*k1**2 - 26460*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 13230*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 13200*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 8800*D1**2*Pkdd2*f**2*fd*k1**2*s - 4400*D1**2*Pkdd2*f**2*fd*k1**2 + 6600*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 4400*D1**2*Pkdd2*f**2*fdd*k1**2*s + 2200*D1**2*Pkdd2*f**2*fdd*k1**2 - 7920*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 3960*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 13200*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 8800*D1**2*Pkdd2*f*fd**2*k1**2*s - 15840*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 15840*D1**2*Pkdd2*f*fd*g2*k1**2*s - 7920*D1**2*Pkdd2*f*fd*g2*k1**2 + 15840*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 7920*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 7920*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 7920*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 3960*D1**2*Pkdd2*f*fdd*g2*k1**2 + 7920*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 7920*D1**2*Pkdd2*fd**2*g2*k1**2*s - 73920*D1*Dd*Pk2*f**4*r*s + 18480*D1*Dd*Pk2*f**4*r + 36960*D1*Dd*Pk2*f**4*s + 591360*D1*Dd*Pk2*f**3*fd*r*s - 147840*D1*Dd*Pk2*f**3*fd*r - 295680*D1*Dd*Pk2*f**3*fd*s + 73920*D1*Dd*Pk2*f**3*fd + 378752*D1*Dd*Pk2*f**3*r*s - 94688*D1*Dd*Pk2*f**3*r - 52800*D1*Dd*Pk2*f**3*s**2 - 162976*D1*Dd*Pk2*f**3*s - 13200*D1*Dd*Pk2*f**3 - 1288320*D1*Dd*Pk2*f**2*fd*r*s + 375760*D1*Dd*Pk2*f**2*fd*r + 158400*D1*Dd*Pk2*f**2*fd*s**2 + 444400*D1*Dd*Pk2*f**2*fd*s - 147840*D1*Dd*Pk2*f**2*fd + 380160*D1*Dd*Pk2*f**2*g2*r*s - 95040*D1*Dd*Pk2*f**2*g2*r - 380160*D1*Dd*Pk2*f**2*g2*s**2 - 95040*D1*Dd*Pk2*f**2*g2 - 380160*D1*Dd*Pk2*f**2*gd2*r*s + 47520*D1*Dd*Pk2*f**2*gd2*r + 380160*D1*Dd*Pk2*f**2*gd2*s**2 + 190080*D1*Dd*Pk2*f**2*gd2*s - 47520*D1*Dd*Pk2*f**2*gd2 - 760320*D1*Dd*Pk2*f*fd*g2*r*s + 285120*D1*Dd*Pk2*f*fd*g2*r + 760320*D1*Dd*Pk2*f*fd*g2*s**2 - 380160*D1*Dd*Pk2*f*fd*g2*s + 17640*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 8820*D1*Dd*Pkdd2*f**4*k1**2*s + 4410*D1*Dd*Pkdd2*f**4*k1**2 - 70560*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 35280*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 4410*D1*Dd*Pkdd2*f**3*fd*k1**2 - 17600*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 8800*D1*Dd*Pkdd2*f**3*k1**2*s - 4400*D1*Dd*Pkdd2*f**3*k1**2 + 52800*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 30800*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 4400*D1*Dd*Pkdd2*f**2*fd*k1**2 - 31680*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 15840*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 7920*D1*Dd*Pkdd2*f**2*g2*k1**2 + 31680*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 7920*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 63360*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 47520*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 7920*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 73920*D1*Ddd*Pk2*f**4*r*s - 18480*D1*Ddd*Pk2*f**4*r - 36960*D1*Ddd*Pk2*f**4*s - 214720*D1*Ddd*Pk2*f**3*r*s + 53680*D1*Ddd*Pk2*f**3*r + 26400*D1*Ddd*Pk2*f**3*s**2 + 94160*D1*Ddd*Pk2*f**3*s + 6600*D1*Ddd*Pk2*f**3 - 190080*D1*Ddd*Pk2*f**2*g2*r*s + 47520*D1*Ddd*Pk2*f**2*g2*r + 190080*D1*Ddd*Pk2*f**2*g2*s**2 + 47520*D1*Ddd*Pk2*f**2*g2 - 8820*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 4410*D1*Ddd*Pkdd2*f**4*k1**2*s - 2205*D1*Ddd*Pkdd2*f**4*k1**2 + 8800*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 4400*D1*Ddd*Pkdd2*f**3*k1**2*s + 2200*D1*Ddd*Pkdd2*f**3*k1**2 + 15840*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 7920*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 3960*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 1320*D1*bd1*f*(D1*f*s*(2*Pk2*(9*K*(-2*r + 2*s + 2) + 7*f*(2*r + s - 2) + 36*r + 9*s - 36) + Pkdd2*k1**2*s*(3*K - 3)) - D1*fd*(2*Pk2*(-9*K*r*(4*s - 1) + 36*K*s**2 - 9*K + 7*f*(r*(6*s - 1) + 3*s**2 - 5*s + 1) - 9*r*(2 - 8*s) + 18*s**2 - 45*s + 18) + Pkdd2*k1**2*s*(3*K - 3)*(2*s - 1)) - 2*Dd*Pk2*f*(9*K*(-8*r*s + r + 8*s**2 + 4*s - 1) + 7*f*(r*(8*s - 1) + 4*s**2 - 7*s + 1) + 144*r*s - 18*r + 36*s**2 - 117*s + 18) - 3*Dd*Pkdd2*f*k1**2*s*(K - 1)*(4*s - 1)) + 221760*Dd**2*Pk2*f**4*r*s - 55440*Dd**2*Pk2*f**4*r - 110880*Dd**2*Pk2*f**4*s + 36960*Dd**2*Pk2*f**4 - 644160*Dd**2*Pk2*f**3*r*s + 161040*Dd**2*Pk2*f**3*r + 79200*Dd**2*Pk2*f**3*s**2 + 282480*Dd**2*Pk2*f**3*s - 107360*Dd**2*Pk2*f**3 - 570240*Dd**2*Pk2*f**2*g2*r*s + 142560*Dd**2*Pk2*f**2*g2*r + 570240*Dd**2*Pk2*f**2*g2*s**2 - 95040*Dd**2*Pk2*f**2*g2 - 26460*Dd**2*Pkdd2*f**4*k1**2*s**2 + 13230*Dd**2*Pkdd2*f**4*k1**2*s + 26400*Dd**2*Pkdd2*f**3*k1**2*s**2 - 13200*Dd**2*Pkdd2*f**3*k1**2*s + 47520*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 23760*Dd**2*Pkdd2*f**2*g2*k1**2*s + 660*b1*(D1**2*(14*Pk2*f**2*(2*fd - fdd)*(3*s - 1)*(2*r + s - 1) + f*(-28*Pk2*fd**2*(3*s - 1)*(2*r + s - 1) - 36*Pk2*fd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) + r*(4 - 8*s) - 2*s**2 + 2*s - 1) + 18*Pk2*fdd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) + r*(4 - 8*s) - 2*s**2 + 2*s - 1) + 6*Pkdd2*fd*k1**2*(K - 1)*(2*s**2 - 2*s + 1) - 3*Pkdd2*fdd*k1**2*(K - 1)*(2*s**2 - 2*s + 1)) + 6*fd**2*(Pk2*r*(6*K - 12)*(2*s - 1) + Pk2*s*(-12*K - 6)*(s - 1) + Pkdd2*k1**2*s*(-K*s + K + s - 1))) + D1*f*(2*Dd*(14*Pk2*f**2*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + f*(-2*Pk2*(-18*K*(-4*r*s + r + 4*s**2 + 1) + 7*fd*(r*(24*s - 7) + 12*s**2 - 17*s + 4) - 144*r*s + 36*r - 36*s**2 + 90*s - 9) + Pkdd2*k1**2*(3*K - 3)*(4*s**2 - 2*s + 1)) - 3*fd*(6*Pk2*(r*(4 - 2*K)*(8*s - 3) + (2*s - 1)*(8*K*s + 4*s - 5)) + Pkdd2*k1**2*(K - 1)*(8*s**2 - 6*s + 1))) - Ddd*f*(2*Pk2*(18*K*(-4*r*s + r + 4*s**2 + 1) + 7*f*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + 144*r*s - 36*r + 36*s**2 - 90*s + 9) + Pkdd2*k1**2*(3*K - 3)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(2*Pk2*(-9*K*(12*r*s - 3*r - 12*s**2 + 2) + 7*f*(3*r*(4*s - 1) + 6*s**2 - 9*s + 2) + 216*r*s - 54*r + 54*s**2 - 135*s + 36) + Pkdd2*k1**2*s*(9*K - 9)*(2*s - 1))))/(6930*d**2*k3**4) - D1**2*Pk3*ct**5*k1*k2*(1008*C*D1**2*Pk2*bdd1*f**2*r**2 + 576*C*D1**2*Pk2*bdd1*f**2*r*s - 1008*C*D1**2*Pk2*bdd1*f**2*r - 1440*C*D1**2*Pk2*bdd1*f**2*s**2 + 7296*C*D1**2*Pk2*f**2*fd*r**2 - 11952*C*D1**2*Pk2*f**2*fd*r*s - 880*C*D1**2*Pk2*f**2*fd*r - 21000*C*D1**2*Pk2*f**2*fd*s**2 + 17984*C*D1**2*Pk2*f**2*fd*s - 4568*C*D1**2*Pk2*f**2*fd - 4296*C*D1**2*Pk2*f**2*fdd*r**2 + 6192*C*D1**2*Pk2*f**2*fdd*r*s + 800*C*D1**2*Pk2*f**2*fdd*r + 16440*C*D1**2*Pk2*f**2*fdd*s**2 - 13024*C*D1**2*Pk2*f**2*fdd*s + 4048*C*D1**2*Pk2*f**2*fdd - 8592*C*D1**2*Pk2*f*fd**2*r**2 + 12384*C*D1**2*Pk2*f*fd**2*r*s + 1600*C*D1**2*Pk2*f*fd**2*r + 32880*C*D1**2*Pk2*f*fd**2*s**2 - 26048*C*D1**2*Pk2*f*fd**2*s + 2064*C*D1**2*Pk2*f*fd**2 - 180*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 360*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 180*C*D1**2*Pkdd2*bdd1*f**2*k1**2 + 300*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 200*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 100*C*D1**2*Pkdd2*f**2*fd*k1**2 - 420*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 280*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 140*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 840*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 560*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 9728*C*D1*Dd*Pk2*f**3*r**2 - 15936*C*D1*Dd*Pk2*f**3*r*s - 5744*C*D1*Dd*Pk2*f**3*r - 28000*C*D1*Dd*Pk2*f**3*s**2 + 21968*C*D1*Dd*Pk2*f**3*s - 2136*C*D1*Dd*Pk2*f**3 - 34368*C*D1*Dd*Pk2*f**2*fd*r**2 + 49536*C*D1*Dd*Pk2*f**2*fd*r*s + 14192*C*D1*Dd*Pk2*f**2*fd*r + 131520*C*D1*Dd*Pk2*f**2*fd*s**2 - 97360*C*D1*Dd*Pk2*f**2*fd*s + 11424*C*D1*Dd*Pk2*f**2*fd + 400*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 200*C*D1*Dd*Pkdd2*f**3*k1**2*s + 100*C*D1*Dd*Pkdd2*f**3*k1**2 - 3360*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 1960*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 280*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 5728*C*D1*Ddd*Pk2*f**3*r**2 + 8256*C*D1*Ddd*Pk2*f**3*r*s + 3664*C*D1*Ddd*Pk2*f**3*r + 21920*C*D1*Ddd*Pk2*f**3*s**2 - 15088*C*D1*Ddd*Pk2*f**3*s + 2616*C*D1*Ddd*Pk2*f**3 - 560*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 280*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 140*C*D1*Ddd*Pkdd2*f**3*k1**2 - 17184*C*Dd**2*Pk2*f**3*r**2 + 24768*C*Dd**2*Pk2*f**3*r*s + 10992*C*Dd**2*Pk2*f**3*r + 65760*C*Dd**2*Pk2*f**3*s**2 - 45264*C*Dd**2*Pk2*f**3*s + 1264*C*Dd**2*Pk2*f**3 - 1680*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 840*C*Dd**2*Pkdd2*f**3*k1**2*s - 684*D1**2*K*Pk2*bdd1*f**2*r**2 + 1368*D1**2*K*Pk2*bdd1*f**2*r*s + 1368*D1**2*K*Pk2*bdd1*f**2*r + 3708*D1**2*K*Pk2*bdd1*f**2*s**2 - 1368*D1**2*K*Pk2*bdd1*f**2*s - 684*D1**2*K*Pk2*bdd1*f**2 - 90*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 3312*D1**2*Pk2*b2*f*fd*r*s + 1656*D1**2*Pk2*b2*f*fd*r - 3312*D1**2*Pk2*b2*f*fd*s**2 + 3312*D1**2*Pk2*b2*f*fd*s - 1656*D1**2*Pk2*b2*f*fd + 2160*D1**2*Pk2*b2*f*fdd*r*s - 1080*D1**2*Pk2*b2*f*fdd*r + 2160*D1**2*Pk2*b2*f*fdd*s**2 - 2160*D1**2*Pk2*b2*f*fdd*s + 1080*D1**2*Pk2*b2*f*fdd + 2160*D1**2*Pk2*b2*fd**2*r*s - 1080*D1**2*Pk2*b2*fd**2*r + 2160*D1**2*Pk2*b2*fd**2*s**2 - 2160*D1**2*Pk2*b2*fd**2*s - 1656*D1**2*Pk2*bd2*f**2*r*s - 1656*D1**2*Pk2*bd2*f**2*s**2 + 1656*D1**2*Pk2*bd2*f**2*s + 4320*D1**2*Pk2*bd2*f*fd*r*s - 1080*D1**2*Pk2*bd2*f*fd*r + 4320*D1**2*Pk2*bd2*f*fd*s**2 - 4320*D1**2*Pk2*bd2*f*fd*s + 1080*D1**2*Pk2*bd2*f*fd + 1350*D1**2*Pk2*bdd1*f**3*r**2 + 1620*D1**2*Pk2*bdd1*f**3*r*s - 2340*D1**2*Pk2*bdd1*f**3*r - 900*D1**2*Pk2*bdd1*f**3*s + 990*D1**2*Pk2*bdd1*f**3 + 846*D1**2*Pk2*bdd1*f**2*r**2 + 1764*D1**2*Pk2*bdd1*f**2*r*s - 2340*D1**2*Pk2*bdd1*f**2*r + 720*D1**2*Pk2*bdd1*f**2*s**2 - 2340*D1**2*Pk2*bdd1*f**2*s + 1494*D1**2*Pk2*bdd1*f**2 - 1008*D1**2*Pk2*bdd1*f*g2*r**2 + 1008*D1**2*Pk2*bdd1*f*g2*r + 2016*D1**2*Pk2*bdd1*f*g2*s**2 + 1080*D1**2*Pk2*bdd2*f**2*r*s + 1080*D1**2*Pk2*bdd2*f**2*s**2 - 1080*D1**2*Pk2*bdd2*f**2*s + 3240*D1**2*Pk2*f**3*fd*r**2 + 4320*D1**2*Pk2*f**3*fd*r*s - 4320*D1**2*Pk2*f**3*fd*r - 2160*D1**2*Pk2*f**3*fd*s + 1620*D1**2*Pk2*f**3*fd - 3240*D1**2*Pk2*f**3*fdd*r**2 - 4320*D1**2*Pk2*f**3*fdd*r*s + 4320*D1**2*Pk2*f**3*fdd*r + 2160*D1**2*Pk2*f**3*fdd*s - 1620*D1**2*Pk2*f**3*fdd - 9720*D1**2*Pk2*f**2*fd**2*r**2 - 12960*D1**2*Pk2*f**2*fd**2*r*s + 12960*D1**2*Pk2*f**2*fd**2*r + 6480*D1**2*Pk2*f**2*fd**2*s - 3780*D1**2*Pk2*f**2*fd**2 - 11526*D1**2*Pk2*f**2*fd*r**2 - 4308*D1**2*Pk2*f**2*fd*r*s + 9120*D1**2*Pk2*f**2*fd*r + 9420*D1**2*Pk2*f**2*fd*s**2 - 4844*D1**2*Pk2*f**2*fd*s - 702*D1**2*Pk2*f**2*fd + 7626*D1**2*Pk2*f**2*fdd*r**2 + 4908*D1**2*Pk2*f**2*fdd*r*s - 6720*D1**2*Pk2*f**2*fdd*r - 8220*D1**2*Pk2*f**2*fdd*s**2 + 3844*D1**2*Pk2*f**2*fdd*s - 198*D1**2*Pk2*f**2*fdd - 1728*D1**2*Pk2*f**2*gd2*r**2 + 4464*D1**2*Pk2*f**2*gd2*r*s + 3456*D1**2*Pk2*f**2*gd2*r + 9288*D1**2*Pk2*f**2*gd2*s**2 - 4464*D1**2*Pk2*f**2*gd2*s - 1728*D1**2*Pk2*f**2*gd2 + 1368*D1**2*Pk2*f**2*gdd2*r**2 - 2736*D1**2*Pk2*f**2*gdd2*r*s - 2736*D1**2*Pk2*f**2*gdd2*r - 7416*D1**2*Pk2*f**2*gdd2*s**2 + 2736*D1**2*Pk2*f**2*gdd2*s + 1368*D1**2*Pk2*f**2*gdd2 + 15252*D1**2*Pk2*f*fd**2*r**2 + 9816*D1**2*Pk2*f*fd**2*r*s - 13440*D1**2*Pk2*f*fd**2*r - 16440*D1**2*Pk2*f*fd**2*s**2 + 7688*D1**2*Pk2*f*fd**2*s + 1636*D1**2*Pk2*f*fd**2 - 3456*D1**2*Pk2*f*fd*g2*r**2 + 8928*D1**2*Pk2*f*fd*g2*r*s - 4464*D1**2*Pk2*f*fd*g2*r + 18576*D1**2*Pk2*f*fd*g2*s**2 - 18576*D1**2*Pk2*f*fd*g2*s + 9288*D1**2*Pk2*f*fd*g2 + 5472*D1**2*Pk2*f*fd*gd2*r**2 - 10944*D1**2*Pk2*f*fd*gd2*r*s - 2736*D1**2*Pk2*f*fd*gd2*r - 29664*D1**2*Pk2*f*fd*gd2*s**2 + 20304*D1**2*Pk2*f*fd*gd2*s - 2736*D1**2*Pk2*f*fd*gd2 + 2736*D1**2*Pk2*f*fdd*g2*r**2 - 5472*D1**2*Pk2*f*fdd*g2*r*s + 2736*D1**2*Pk2*f*fdd*g2*r - 14832*D1**2*Pk2*f*fdd*g2*s**2 + 14832*D1**2*Pk2*f*fdd*g2*s - 7416*D1**2*Pk2*f*fdd*g2 + 2736*D1**2*Pk2*fd**2*g2*r**2 - 5472*D1**2*Pk2*fd**2*g2*r*s + 2736*D1**2*Pk2*fd**2*g2*r - 14832*D1**2*Pk2*fd**2*g2*s**2 + 14832*D1**2*Pk2*fd**2*g2*s + 210*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 105*D1**2*Pkdd2*bdd1*f**3*k1**2 + 225*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 360*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 180*D1**2*Pkdd2*bdd1*f**2*k1**2 + 252*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 504*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 252*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 420*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 210*D1**2*Pkdd2*f**3*fd*k1**2*s - 105*D1**2*Pkdd2*f**3*fd*k1**2 - 90*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 60*D1**2*Pkdd2*f**2*fd*k1**2*s - 30*D1**2*Pkdd2*f**2*fd*k1**2 + 315*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 210*D1**2*Pkdd2*f**2*fdd*k1**2*s + 105*D1**2*Pkdd2*f**2*fdd*k1**2 - 108*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 180*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 630*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 420*D1**2*Pkdd2*f*fd**2*k1**2*s - 216*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 216*D1**2*Pkdd2*f*fd*g2*k1**2*s - 108*D1**2*Pkdd2*f*fd*g2*k1**2 + 720*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 360*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 360*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 360*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 180*D1**2*Pkdd2*f*fdd*g2*k1**2 + 360*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 360*D1**2*Pkdd2*fd**2*g2*k1**2*s + 36*D1**2*bd1**2*f*(2*Pk2*(7*K*(2*r**2 - 3*r - 4*s**2 + 1) + 5*f*(r + 2*s - 1) - (14*r - 14)*(r + 2*s - 1)) + 7*Pkdd2*k1**2*s*(-K*s + K + s - 1)) - 6624*D1*Dd*Pk2*b2*f**2*r*s + 1656*D1*Dd*Pk2*b2*f**2*r - 6624*D1*Dd*Pk2*b2*f**2*s**2 + 6624*D1*Dd*Pk2*b2*f**2*s - 1656*D1*Dd*Pk2*b2*f**2 + 17280*D1*Dd*Pk2*b2*f*fd*r*s - 6480*D1*Dd*Pk2*b2*f*fd*r + 17280*D1*Dd*Pk2*b2*f*fd*s**2 - 17280*D1*Dd*Pk2*b2*f*fd*s + 4320*D1*Dd*Pk2*b2*f*fd + 8640*D1*Dd*Pk2*bd2*f**2*r*s - 1080*D1*Dd*Pk2*bd2*f**2*r + 8640*D1*Dd*Pk2*bd2*f**2*s**2 - 8640*D1*Dd*Pk2*bd2*f**2*s + 1080*D1*Dd*Pk2*bd2*f**2 + 3240*D1*Dd*Pk2*f**4*r**2 + 4320*D1*Dd*Pk2*f**4*r*s - 4320*D1*Dd*Pk2*f**4*r - 2160*D1*Dd*Pk2*f**4*s + 1620*D1*Dd*Pk2*f**4 - 25920*D1*Dd*Pk2*f**3*fd*r**2 - 34560*D1*Dd*Pk2*f**3*fd*r*s + 34560*D1*Dd*Pk2*f**3*fd*r + 17280*D1*Dd*Pk2*f**3*fd*s - 10800*D1*Dd*Pk2*f**3*fd - 15368*D1*Dd*Pk2*f**3*r**2 - 5744*D1*Dd*Pk2*f**3*r*s + 16804*D1*Dd*Pk2*f**3*r + 12560*D1*Dd*Pk2*f**3*s**2 - 3408*D1*Dd*Pk2*f**3*s - 4544*D1*Dd*Pk2*f**3 + 61008*D1*Dd*Pk2*f**2*fd*r**2 + 39264*D1*Dd*Pk2*f**2*fd*r*s - 62292*D1*Dd*Pk2*f**2*fd*r - 65760*D1*Dd*Pk2*f**2*fd*s**2 + 22000*D1*Dd*Pk2*f**2*fd*s + 9596*D1*Dd*Pk2*f**2*fd - 6912*D1*Dd*Pk2*f**2*g2*r**2 + 17856*D1*Dd*Pk2*f**2*g2*r*s + 2448*D1*Dd*Pk2*f**2*g2*r + 37152*D1*Dd*Pk2*f**2*g2*s**2 - 27504*D1*Dd*Pk2*f**2*g2*s + 5832*D1*Dd*Pk2*f**2*g2 + 10944*D1*Dd*Pk2*f**2*gd2*r**2 - 21888*D1*Dd*Pk2*f**2*gd2*r*s - 13680*D1*Dd*Pk2*f**2*gd2*r - 59328*D1*Dd*Pk2*f**2*gd2*s**2 + 31248*D1*Dd*Pk2*f**2*gd2*s + 2736*D1*Dd*Pk2*f**2*gd2 + 21888*D1*Dd*Pk2*f*fd*g2*r**2 - 43776*D1*Dd*Pk2*f*fd*g2*r*s + 5472*D1*Dd*Pk2*f*fd*g2*r - 118656*D1*Dd*Pk2*f*fd*g2*s**2 + 99936*D1*Dd*Pk2*f*fd*g2*s - 20304*D1*Dd*Pk2*f*fd*g2 - 420*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 210*D1*Dd*Pkdd2*f**4*k1**2*s - 105*D1*Dd*Pkdd2*f**4*k1**2 - 120*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 60*D1*Dd*Pkdd2*f**3*k1**2*s - 30*D1*Dd*Pkdd2*f**3*k1**2 + 2520*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 1470*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 210*D1*Dd*Pkdd2*f**2*fd*k1**2 - 432*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 216*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 108*D1*Dd*Pkdd2*f**2*g2*k1**2 + 1440*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 360*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 2880*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 2160*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 360*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 4320*D1*Ddd*Pk2*b2*f**2*r*s - 1080*D1*Ddd*Pk2*b2*f**2*r + 4320*D1*Ddd*Pk2*b2*f**2*s**2 - 4320*D1*Ddd*Pk2*b2*f**2*s + 1080*D1*Ddd*Pk2*b2*f**2 - 3240*D1*Ddd*Pk2*f**4*r**2 - 4320*D1*Ddd*Pk2*f**4*r*s + 4320*D1*Ddd*Pk2*f**4*r + 2160*D1*Ddd*Pk2*f**4*s - 1620*D1*Ddd*Pk2*f**4 + 10168*D1*Ddd*Pk2*f**3*r**2 + 6544*D1*Ddd*Pk2*f**3*r*s - 11804*D1*Ddd*Pk2*f**3*r - 10960*D1*Ddd*Pk2*f**3*s**2 + 2208*D1*Ddd*Pk2*f**3*s + 2344*D1*Ddd*Pk2*f**3 + 5472*D1*Ddd*Pk2*f**2*g2*r**2 - 10944*D1*Ddd*Pk2*f**2*g2*r*s - 2736*D1*Ddd*Pk2*f**2*g2*r - 29664*D1*Ddd*Pk2*f**2*g2*s**2 + 20304*D1*Ddd*Pk2*f**2*g2*s - 4680*D1*Ddd*Pk2*f**2*g2 + 420*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 210*D1*Ddd*Pkdd2*f**3*k1**2*s + 105*D1*Ddd*Pkdd2*f**3*k1**2 + 720*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 360*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 180*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 6*D1*bd1*(D1*(5*f**3*(3*Pk2*(13*r**2 + 22*r*(s - 1) + 4*s**2 - 14*s + 9) + 7*Pkdd2*k1**2*(2*s - 1)) + f**2*(-3*Pk2*(-112*C*r**2 - 64*C*r*s + 112*C*r + 160*C*s**2 + 2*K*(24*r**2 - 62*r*s - 48*r - 129*s**2 + 62*s + 24) + 10*fd*(45*r**2 + r*(54*s - 65) - 28*s + 20) - 3*r**2 - 70*r*s + 78*r - 108*s**2 + 134*s - 75) - Pkdd2*k1**2*(60*C*(s - 1)**2 + s**2*(9*K - 54) + s*(70*fd + 120) - 60)) - 3*f*fd*(2*Pk2*(4*C*(28*r**2 + r*(16*s - 25) - 40*s**2 + 16*s + 7) + K*(-76*r**2 + 38*r*(4*s + 1) + 412*s**2 - 282*s + 38) + 94*r**2 + 196*r*s - 161*r + 80*s**2 - 154*s + 47) - 5*Pkdd2*k1**2*s*(8*C*(s - 1) + K*(4*s - 2) - 10*s + 9)) + 84*f*(4*Pk2*g2*(-r**2 + r + 2*s**2) + Pk2*gd2*(4*r**2 - 6*r - 8*s**2 + 2) + Pkdd2*g2*k1**2*(s - 1)**2 - Pkdd2*gd2*k1**2*s*(s - 1)) + 84*fd*g2*(4*Pk2*(r**2 - s*(2*s - 2)) - Pkdd2*k1**2*s*(s - 1))) - Dd*f*(5*f**2*(6*Pk2*(60*r**2 + r*(72*s - 91) - 38*s + 31) + 7*Pkdd2*k1**2*(4*s - 1)) + 3*f*(2*Pk2*(8*C*(28*r**2 + 2*r*(8*s - 15) - 40*s**2 + 6*s + 7) - 2*K*(76*r**2 - 19*r*(8*s + 5) - 412*s**2 + 217*s + 19) + 188*r**2 + 392*r*s - 403*r + 160*s**2 - 398*s + 195) - 5*Pkdd2*k1**2*(4*s - 1)*(4*C*(s - 1) + s*(2*K - 5) + 4)) + 84*g2*(-4*Pk2*(4*r**2 - 4*r - 8*s**2 + 2*s + 1) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 12960*Dd**2*Pk2*b2*f**2*r*s - 3240*Dd**2*Pk2*b2*f**2*r + 12960*Dd**2*Pk2*b2*f**2*s**2 - 12960*Dd**2*Pk2*b2*f**2*s + 2160*Dd**2*Pk2*b2*f**2 - 9720*Dd**2*Pk2*f**4*r**2 - 12960*Dd**2*Pk2*f**4*r*s + 12960*Dd**2*Pk2*f**4*r + 6480*Dd**2*Pk2*f**4*s - 3780*Dd**2*Pk2*f**4 + 30504*Dd**2*Pk2*f**3*r**2 + 19632*Dd**2*Pk2*f**3*r*s - 35412*Dd**2*Pk2*f**3*r - 32880*Dd**2*Pk2*f**3*s**2 + 6624*Dd**2*Pk2*f**3*s + 8356*Dd**2*Pk2*f**3 + 16416*Dd**2*Pk2*f**2*g2*r**2 - 32832*Dd**2*Pk2*f**2*g2*r*s - 8208*Dd**2*Pk2*f**2*g2*r - 88992*Dd**2*Pk2*f**2*g2*s**2 + 60912*Dd**2*Pk2*f**2*g2*s - 2736*Dd**2*Pk2*f**2*g2 + 1260*Dd**2*Pkdd2*f**3*k1**2*s**2 - 630*Dd**2*Pkdd2*f**3*k1**2*s + 2160*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 1080*Dd**2*Pkdd2*f**2*g2*k1**2*s + 18*b1**2*(D1**2*(-20*Pk2*fd**2*(r + 2*s - 1) + 8*Pk2*fd*(-7*K*(r**2 + r - 2*(s - 1)**2) + 5*f*(r + 2*s - 1) + (7*r + 7)*(r + 2*s - 1)) - 4*Pk2*fdd*(-7*K*(r**2 + r - 2*(s - 1)**2) + 5*f*(r + 2*s - 1) + (7*r + 7)*(r + 2*s - 1)) + 14*Pkdd2*fd*k1**2*s**2*(K - 1) - 7*Pkdd2*fdd*k1**2*s**2*(K - 1)) - D1*(2*Dd*(f*(8*Pk2*(5*fd*(r + 2*s - 1) + r**2*(14*K - 14) - 7*r*(2*K + 4*s - 3) - (14*s - 7)*(2*K*s - 1)) + Pkdd2*k1**2*(7 - 7*K)*(4*s**2 - 2*s + 1)) + 7*fd*(-4*K*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + 4*Pk2*(4*r + 1)*(r + 2*s - 1) + Pkdd2*k1**2*s*(K - 1)*(4*s - 1))) + 7*Ddd*f*(-8*Pk2*(r**2*(2*K - 2) + r*(-2*K - 4*s + 3) - (2*s - 1)*(2*K*s - 1)) + Pkdd2*k1**2*(K - 1)*(4*s**2 - 2*s + 1))) + 14*Dd**2*f*(4*Pk2*(K*(6*r**2 - 6*r - 12*s**2 + 6*s + 1) + (3 - 6*r)*(r + 2*s - 1)) + 3*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1))) - 3*b1*(1344*C*D1**2*Pk2*f*fd*r**2 + 768*C*D1**2*Pk2*f*fd*r*s - 1056*C*D1**2*Pk2*f*fd*r - 1920*C*D1**2*Pk2*f*fd*s**2 + 1536*C*D1**2*Pk2*f*fd*s - 288*C*D1**2*Pk2*f*fd - 672*C*D1**2*Pk2*f*fdd*r**2 - 384*C*D1**2*Pk2*f*fdd*r*s + 528*C*D1**2*Pk2*f*fdd*r + 960*C*D1**2*Pk2*f*fdd*s**2 - 768*C*D1**2*Pk2*f*fdd*s + 144*C*D1**2*Pk2*f*fdd - 672*C*D1**2*Pk2*fd**2*r**2 - 384*C*D1**2*Pk2*fd**2*r*s + 528*C*D1**2*Pk2*fd**2*r + 960*C*D1**2*Pk2*fd**2*s**2 - 768*C*D1**2*Pk2*fd**2*s + 144*C*D1**2*Pk2*fd**2 - 240*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 120*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 120*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 2688*C*D1*Dd*Pk2*f**2*r**2 + 1536*C*D1*Dd*Pk2*f**2*r*s - 3072*C*D1*Dd*Pk2*f**2*r - 3840*C*D1*Dd*Pk2*f**2*s**2 + 1152*C*D1*Dd*Pk2*f**2*s + 384*C*D1*Dd*Pk2*f**2 - 5376*C*D1*Dd*Pk2*f*fd*r**2 - 3072*C*D1*Dd*Pk2*f*fd*r*s + 5184*C*D1*Dd*Pk2*f*fd*r + 7680*C*D1*Dd*Pk2*f*fd*s**2 - 4224*C*D1*Dd*Pk2*f*fd*s - 288*C*D1*Dd*Pk2*f*fd - 480*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 240*C*D1*Dd*Pkdd2*f**2*k1**2*s - 120*C*D1*Dd*Pkdd2*f**2*k1**2 + 960*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 240*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 1344*C*D1*Ddd*Pk2*f**2*r**2 - 768*C*D1*Ddd*Pk2*f**2*r*s + 1536*C*D1*Ddd*Pk2*f**2*r + 1920*C*D1*Ddd*Pk2*f**2*s**2 - 576*C*D1*Ddd*Pk2*f**2*s - 192*C*D1*Ddd*Pk2*f**2 + 240*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 120*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 60*C*D1*Ddd*Pkdd2*f**2*k1**2 - 4032*C*Dd**2*Pk2*f**2*r**2 - 2304*C*Dd**2*Pk2*f**2*r*s + 4608*C*Dd**2*Pk2*f**2*r + 5760*C*Dd**2*Pk2*f**2*s**2 - 1728*C*Dd**2*Pk2*f**2*s - 1056*C*Dd**2*Pk2*f**2 + 720*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 360*C*Dd**2*Pkdd2*f**2*k1**2*s - 576*D1**2*K*Pk2*f*fd*r**2 + 1488*D1**2*K*Pk2*f*fd*r*s - 744*D1**2*K*Pk2*f*fd*r + 3096*D1**2*K*Pk2*f*fd*s**2 - 3096*D1**2*K*Pk2*f*fd*s + 1548*D1**2*K*Pk2*f*fd + 456*D1**2*K*Pk2*f*fdd*r**2 - 912*D1**2*K*Pk2*f*fdd*r*s + 456*D1**2*K*Pk2*f*fdd*r - 2472*D1**2*K*Pk2*f*fdd*s**2 + 2472*D1**2*K*Pk2*f*fdd*s - 1236*D1**2*K*Pk2*f*fdd + 456*D1**2*K*Pk2*fd**2*r**2 - 912*D1**2*K*Pk2*fd**2*r*s + 456*D1**2*K*Pk2*fd**2*r - 2472*D1**2*K*Pk2*fd**2*s**2 + 2472*D1**2*K*Pk2*fd**2*s - 36*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 36*D1**2*K*Pkdd2*f*fd*k1**2*s - 18*D1**2*K*Pkdd2*f*fd*k1**2 + 60*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 60*D1**2*K*Pkdd2*f*fdd*k1**2*s + 30*D1**2*K*Pkdd2*f*fdd*k1**2 + 60*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 60*D1**2*K*Pkdd2*fd**2*k1**2*s + 1170*D1**2*Pk2*f**2*fd*r**2 + 1980*D1**2*Pk2*f**2*fd*r*s - 1560*D1**2*Pk2*f**2*fd*r + 360*D1**2*Pk2*f**2*fd*s**2 - 1140*D1**2*Pk2*f**2*fd*s + 630*D1**2*Pk2*f**2*fd - 1350*D1**2*Pk2*f**2*fdd*r**2 - 1620*D1**2*Pk2*f**2*fdd*r*s + 1560*D1**2*Pk2*f**2*fdd*r + 780*D1**2*Pk2*f**2*fdd*s - 570*D1**2*Pk2*f**2*fdd - 2700*D1**2*Pk2*f*fd**2*r**2 - 3240*D1**2*Pk2*f*fd**2*r*s + 3120*D1**2*Pk2*f*fd**2*r + 1560*D1**2*Pk2*f*fd**2*s - 780*D1**2*Pk2*f*fd**2 + 36*D1**2*Pk2*f*fd*r**2 + 840*D1**2*Pk2*f*fd*r*s + 12*D1**2*Pk2*f*fd*r + 1296*D1**2*Pk2*f*fd*s**2 - 912*D1**2*Pk2*f*fd*s + 216*D1**2*Pk2*f*fd - 564*D1**2*Pk2*f*fdd*r**2 - 1176*D1**2*Pk2*f*fdd*r*s + 372*D1**2*Pk2*f*fdd*r - 480*D1**2*Pk2*f*fdd*s**2 + 288*D1**2*Pk2*f*fdd*s - 24*D1**2*Pk2*f*fdd - 672*D1**2*Pk2*f*gd2*r**2 + 1344*D1**2*Pk2*f*gd2*r + 1344*D1**2*Pk2*f*gd2*s**2 - 672*D1**2*Pk2*f*gd2 + 336*D1**2*Pk2*f*gdd2*r**2 - 672*D1**2*Pk2*f*gdd2*r - 672*D1**2*Pk2*f*gdd2*s**2 + 336*D1**2*Pk2*f*gdd2 - 564*D1**2*Pk2*fd**2*r**2 - 1176*D1**2*Pk2*fd**2*r*s + 372*D1**2*Pk2*fd**2*r - 480*D1**2*Pk2*fd**2*s**2 + 288*D1**2*Pk2*fd**2*s - 24*D1**2*Pk2*fd**2 - 672*D1**2*Pk2*fd*g2*r**2 - 672*D1**2*Pk2*fd*g2*r + 1344*D1**2*Pk2*fd*g2*s**2 - 2688*D1**2*Pk2*fd*g2*s + 1344*D1**2*Pk2*fd*g2 + 672*D1**2*Pk2*fd*gd2*r**2 - 336*D1**2*Pk2*fd*gd2*r - 1344*D1**2*Pk2*fd*gd2*s**2 + 1344*D1**2*Pk2*fd*gd2*s - 336*D1**2*Pk2*fd*gd2 + 336*D1**2*Pk2*fdd*g2*r**2 + 336*D1**2*Pk2*fdd*g2*r - 672*D1**2*Pk2*fdd*g2*s**2 + 1344*D1**2*Pk2*fdd*g2*s - 672*D1**2*Pk2*fdd*g2 - 140*D1**2*Pkdd2*f**2*fd*k1**2*s + 70*D1**2*Pkdd2*f**2*fd*k1**2 + 70*D1**2*Pkdd2*f**2*fdd*k1**2*s - 35*D1**2*Pkdd2*f**2*fdd*k1**2 + 140*D1**2*Pkdd2*f*fd**2*k1**2*s + 216*D1**2*Pkdd2*f*fd*k1**2*s**2 + 24*D1**2*Pkdd2*f*fd*k1**2*s - 12*D1**2*Pkdd2*f*fd*k1**2 - 150*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*f*fdd*k1**2*s - 15*D1**2*Pkdd2*f*fdd*k1**2 + 168*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 84*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 150*D1**2*Pkdd2*fd**2*k1**2*s**2 + 30*D1**2*Pkdd2*fd**2*k1**2*s + 168*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 168*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 84*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 6*D1**2*bdd1*f*(4*Pk2*(7*K*(2*r**2 - 3*r - 4*s**2 + 1) + 5*f*(r + 2*s - 1) - (14*r - 14)*(r + 2*s - 1)) + Pkdd2*k1**2*(7 - 7*K)*(2*s**2 - 2*s + 1)) - 1152*D1*Dd*K*Pk2*f**2*r**2 + 2976*D1*Dd*K*Pk2*f**2*r*s + 408*D1*Dd*K*Pk2*f**2*r + 6192*D1*Dd*K*Pk2*f**2*s**2 - 4584*D1*Dd*K*Pk2*f**2*s + 972*D1*Dd*K*Pk2*f**2 + 3648*D1*Dd*K*Pk2*f*fd*r**2 - 7296*D1*Dd*K*Pk2*f*fd*r*s + 912*D1*Dd*K*Pk2*f*fd*r - 19776*D1*Dd*K*Pk2*f*fd*s**2 + 16656*D1*Dd*K*Pk2*f*fd*s - 3384*D1*Dd*K*Pk2*f*fd - 72*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 36*D1*Dd*K*Pkdd2*f**2*k1**2*s - 18*D1*Dd*K*Pkdd2*f**2*k1**2 + 480*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 360*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 60*D1*Dd*K*Pkdd2*f*fd*k1**2 + 1560*D1*Dd*Pk2*f**3*r**2 + 2640*D1*Dd*Pk2*f**3*r*s - 2220*D1*Dd*Pk2*f**3*r + 480*D1*Dd*Pk2*f**3*s**2 - 1560*D1*Dd*Pk2*f**3*s + 900*D1*Dd*Pk2*f**3 - 10800*D1*Dd*Pk2*f**2*fd*r**2 - 12960*D1*Dd*Pk2*f**2*fd*r*s + 13260*D1*Dd*Pk2*f**2*fd*r + 6360*D1*Dd*Pk2*f**2*fd*s - 3900*D1*Dd*Pk2*f**2*fd + 72*D1*Dd*Pk2*f**2*r**2 + 1680*D1*Dd*Pk2*f**2*r*s - 492*D1*Dd*Pk2*f**2*r + 2592*D1*Dd*Pk2*f**2*s**2 - 2136*D1*Dd*Pk2*f**2*s + 684*D1*Dd*Pk2*f**2 - 4512*D1*Dd*Pk2*f*fd*r**2 - 9408*D1*Dd*Pk2*f*fd*r*s + 4920*D1*Dd*Pk2*f*fd*r - 3840*D1*Dd*Pk2*f*fd*s**2 + 4464*D1*Dd*Pk2*f*fd*s - 1032*D1*Dd*Pk2*f*fd - 2688*D1*Dd*Pk2*f*g2*r**2 + 2688*D1*Dd*Pk2*f*g2*r + 5376*D1*Dd*Pk2*f*g2*s**2 - 2688*D1*Dd*Pk2*f*g2*s + 2688*D1*Dd*Pk2*f*gd2*r**2 - 4032*D1*Dd*Pk2*f*gd2*r - 5376*D1*Dd*Pk2*f*gd2*s**2 + 1344*D1*Dd*Pk2*f*gd2*s + 1344*D1*Dd*Pk2*f*gd2 + 2688*D1*Dd*Pk2*fd*g2*r**2 - 5376*D1*Dd*Pk2*fd*g2*s**2 + 6720*D1*Dd*Pk2*fd*g2*s - 2016*D1*Dd*Pk2*fd*g2 + 280*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 70*D1*Dd*Pkdd2*f**2*fd*k1**2 + 432*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 216*D1*Dd*Pkdd2*f**2*k1**2*s + 108*D1*Dd*Pkdd2*f**2*k1**2 - 1200*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 420*D1*Dd*Pkdd2*f*fd*k1**2*s - 30*D1*Dd*Pkdd2*f*fd*k1**2 + 672*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 336*D1*Dd*Pkdd2*f*g2*k1**2*s + 168*D1*Dd*Pkdd2*f*g2*k1**2 - 672*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 168*D1*Dd*Pkdd2*f*gd2*k1**2*s - 672*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 168*D1*Dd*Pkdd2*fd*g2*k1**2*s + 912*D1*Ddd*K*Pk2*f**2*r**2 - 1824*D1*Ddd*K*Pk2*f**2*r*s - 456*D1*Ddd*K*Pk2*f**2*r - 4944*D1*Ddd*K*Pk2*f**2*s**2 + 3384*D1*Ddd*K*Pk2*f**2*s - 780*D1*Ddd*K*Pk2*f**2 + 120*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 60*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 30*D1*Ddd*K*Pkdd2*f**2*k1**2 - 1800*D1*Ddd*Pk2*f**3*r**2 - 2160*D1*Ddd*Pk2*f**3*r*s + 2340*D1*Ddd*Pk2*f**3*r + 1080*D1*Ddd*Pk2*f**3*s - 900*D1*Ddd*Pk2*f**3 - 1128*D1*Ddd*Pk2*f**2*r**2 - 2352*D1*Ddd*Pk2*f**2*r*s + 1716*D1*Ddd*Pk2*f**2*r - 960*D1*Ddd*Pk2*f**2*s**2 + 1656*D1*Ddd*Pk2*f**2*s - 804*D1*Ddd*Pk2*f**2 + 1344*D1*Ddd*Pk2*f*g2*r**2 - 1344*D1*Ddd*Pk2*f*g2*r - 2688*D1*Ddd*Pk2*f*g2*s**2 + 1344*D1*Ddd*Pk2*f*g2*s - 300*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 150*D1*Ddd*Pkdd2*f**2*k1**2*s - 75*D1*Ddd*Pkdd2*f**2*k1**2 - 336*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 168*D1*Ddd*Pkdd2*f*g2*k1**2*s - 84*D1*Ddd*Pkdd2*f*g2*k1**2 + 12*D1*bd1*(D1*(20*Pk2*f**2*(r + 2*s - 1) + 7*f*(4*K*Pk2*(2*r**2 - 3*r - 4*s**2 + 1) - 8*Pk2*(r - 1)*(r + 2*s - 1) - Pkdd2*k1**2*(K - 1)*(2*s**2 - 2*s + 1)) + 7*fd*(2*K*Pk2*(-4*r**2 + r + 8*s**2 - 8*s + 1) + K*Pkdd2*k1**2*s*(2*s - 1) + 8*Pk2*r*(r + 2*s - 1) + Pkdd2*k1**2*s*(1 - 2*s))) + Dd*f*(-4*Pk2*(7*K*(8*r**2 - 10*r - 16*s**2 + 4*s + 3) + 10*f*(r + 2*s - 1) - (56*r - 42)*(r + 2*s - 1)) + Pkdd2*k1**2*(7*K - 7)*(8*s**2 - 6*s + 1))) + 2736*Dd**2*K*Pk2*f**2*r**2 - 5472*Dd**2*K*Pk2*f**2*r*s - 1368*Dd**2*K*Pk2*f**2*r - 14832*Dd**2*K*Pk2*f**2*s**2 + 10152*Dd**2*K*Pk2*f**2*s - 456*Dd**2*K*Pk2*f**2 + 360*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 180*Dd**2*K*Pkdd2*f**2*k1**2*s - 5400*Dd**2*Pk2*f**3*r**2 - 6480*Dd**2*Pk2*f**3*r*s + 7020*Dd**2*Pk2*f**3*r + 3240*Dd**2*Pk2*f**3*s - 1980*Dd**2*Pk2*f**3 - 3384*Dd**2*Pk2*f**2*r**2 - 7056*Dd**2*Pk2*f**2*r*s + 5148*Dd**2*Pk2*f**2*r - 2880*Dd**2*Pk2*f**2*s**2 + 4968*Dd**2*Pk2*f**2*s - 1740*Dd**2*Pk2*f**2 + 4032*Dd**2*Pk2*f*g2*r**2 - 4032*Dd**2*Pk2*f*g2*r - 8064*Dd**2*Pk2*f*g2*s**2 + 4032*Dd**2*Pk2*f*g2*s + 672*Dd**2*Pk2*f*g2 - 900*Dd**2*Pkdd2*f**2*k1**2*s**2 + 450*Dd**2*Pkdd2*f**2*k1**2*s - 1008*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 504*Dd**2*Pkdd2*f*g2*k1**2*s))/(630*d**2*k3**4) - D1**2*Pk3*ct**5*k1*(2016*C*D1**2*Pk2*bdd1*f**2*r*s - 1440*C*D1**2*Pk2*bdd1*f**2*s**2 - 6720*C*D1**2*Pk2*f**2*fd*s**2 + 4480*C*D1**2*Pk2*f**2*fd*s - 2240*C*D1**2*Pk2*f**2*fd + 3360*C*D1**2*Pk2*f**2*fdd*s**2 - 2240*C*D1**2*Pk2*f**2*fdd*s + 1120*C*D1**2*Pk2*f**2*fdd + 6720*C*D1**2*Pk2*f*fd**2*s**2 - 4480*C*D1**2*Pk2*f*fd**2*s - 8960*C*D1*Dd*Pk2*f**3*s**2 + 4480*C*D1*Dd*Pk2*f**3*s - 2240*C*D1*Dd*Pk2*f**3 + 26880*C*D1*Dd*Pk2*f**2*fd*s**2 - 15680*C*D1*Dd*Pk2*f**2*fd*s + 2240*C*D1*Dd*Pk2*f**2*fd + 4480*C*D1*Ddd*Pk2*f**3*s**2 - 2240*C*D1*Ddd*Pk2*f**3*s + 1120*C*D1*Ddd*Pk2*f**3 + 13440*C*Dd**2*Pk2*f**3*s**2 - 6720*C*Dd**2*Pk2*f**3*s + 720*D1**2*K*Pk2*bdd1*f**2*s**2 - 2880*D1**2*Pk2*b2*f*fd*s**2 + 2880*D1**2*Pk2*b2*f*fd*s - 1440*D1**2*Pk2*b2*f*fd + 1440*D1**2*Pk2*b2*f*fdd*s**2 - 1440*D1**2*Pk2*b2*f*fdd*s + 720*D1**2*Pk2*b2*f*fdd + 1440*D1**2*Pk2*b2*fd**2*s**2 - 1440*D1**2*Pk2*b2*fd**2*s + 144*D1**2*Pk2*bd1**2*f*s*(7*K*(2*r - 2*s - 1) + 5*f - 14*r + 14) - 1440*D1**2*Pk2*bd2*f**2*s**2 + 2880*D1**2*Pk2*bd2*f*fd*s**2 - 1440*D1**2*Pk2*bd2*f*fd*s + 2160*D1**2*Pk2*bdd1*f**3*r*s + 1980*D1**2*Pk2*bdd1*f**3*s**2 - 1440*D1**2*Pk2*bdd1*f**3*s - 288*D1**2*Pk2*bdd1*f**2*r*s + 3348*D1**2*Pk2*bdd1*f**2*s**2 - 1008*D1**2*Pk2*bdd1*f**2*s - 360*D1**2*Pk2*bdd1*f**2 - 2016*D1**2*Pk2*bdd1*f*g2*r*s + 2016*D1**2*Pk2*bdd1*f*g2*s**2 + 720*D1**2*Pk2*bdd2*f**2*s**2 - 7440*D1**2*Pk2*f**2*fd*r*s + 2480*D1**2*Pk2*f**2*fd*r - 4260*D1**2*Pk2*f**2*fd*s**2 + 5320*D1**2*Pk2*f**2*fd*s - 1420*D1**2*Pk2*f**2*fd + 4800*D1**2*Pk2*f**2*fdd*r*s - 1600*D1**2*Pk2*f**2*fdd*r + 4020*D1**2*Pk2*f**2*fdd*s**2 - 4280*D1**2*Pk2*f**2*fdd*s + 1340*D1**2*Pk2*f**2*fdd + 2880*D1**2*Pk2*f**2*gd2*s**2 - 1440*D1**2*Pk2*f**2*gdd2*s**2 + 9600*D1**2*Pk2*f*fd**2*r*s - 3200*D1**2*Pk2*f*fd**2*r + 8040*D1**2*Pk2*f*fd**2*s**2 - 8560*D1**2*Pk2*f*fd**2*s + 1600*D1**2*Pk2*f*fd**2 + 5760*D1**2*Pk2*f*fd*g2*s**2 - 5760*D1**2*Pk2*f*fd*g2*s + 2880*D1**2*Pk2*f*fd*g2 - 5760*D1**2*Pk2*f*fd*gd2*s**2 + 2880*D1**2*Pk2*f*fd*gd2*s - 2880*D1**2*Pk2*f*fdd*g2*s**2 + 2880*D1**2*Pk2*f*fdd*g2*s - 1440*D1**2*Pk2*f*fdd*g2 - 2880*D1**2*Pk2*fd**2*g2*s**2 + 2880*D1**2*Pk2*fd**2*g2*s - 70*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 45*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 210*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 140*D1**2*Pkdd2*f**2*fd*k1**2*s + 70*D1**2*Pkdd2*f**2*fd*k1**2 - 105*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 70*D1**2*Pkdd2*f**2*fdd*k1**2*s - 35*D1**2*Pkdd2*f**2*fdd*k1**2 - 210*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 140*D1**2*Pkdd2*f*fd**2*k1**2*s - 5760*D1*Dd*Pk2*b2*f**2*s**2 + 2880*D1*Dd*Pk2*b2*f**2*s - 1440*D1*Dd*Pk2*b2*f**2 + 11520*D1*Dd*Pk2*b2*f*fd*s**2 - 8640*D1*Dd*Pk2*b2*f*fd*s + 1440*D1*Dd*Pk2*b2*f*fd + 5760*D1*Dd*Pk2*bd2*f**2*s**2 - 1440*D1*Dd*Pk2*bd2*f**2*s - 9920*D1*Dd*Pk2*f**3*r*s + 2480*D1*Dd*Pk2*f**3*r - 5680*D1*Dd*Pk2*f**3*s**2 + 7800*D1*Dd*Pk2*f**3*s - 1420*D1*Dd*Pk2*f**3 + 38400*D1*Dd*Pk2*f**2*fd*r*s - 11200*D1*Dd*Pk2*f**2*fd*r + 32160*D1*Dd*Pk2*f**2*fd*s**2 - 34760*D1*Dd*Pk2*f**2*fd*s + 7480*D1*Dd*Pk2*f**2*fd + 11520*D1*Dd*Pk2*f**2*g2*s**2 - 5760*D1*Dd*Pk2*f**2*g2*s + 2880*D1*Dd*Pk2*f**2*g2 - 11520*D1*Dd*Pk2*f**2*gd2*s**2 + 2880*D1*Dd*Pk2*f**2*gd2*s - 23040*D1*Dd*Pk2*f*fd*g2*s**2 + 17280*D1*Dd*Pk2*f*fd*g2*s - 2880*D1*Dd*Pk2*f*fd*g2 + 280*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 140*D1*Dd*Pkdd2*f**3*k1**2*s + 70*D1*Dd*Pkdd2*f**3*k1**2 - 840*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 490*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 70*D1*Dd*Pkdd2*f**2*fd*k1**2 + 2880*D1*Ddd*Pk2*b2*f**2*s**2 - 1440*D1*Ddd*Pk2*b2*f**2*s + 720*D1*Ddd*Pk2*b2*f**2 + 6400*D1*Ddd*Pk2*f**3*r*s - 1600*D1*Ddd*Pk2*f**3*r + 5360*D1*Ddd*Pk2*f**3*s**2 - 5880*D1*Ddd*Pk2*f**3*s + 1340*D1*Ddd*Pk2*f**3 - 5760*D1*Ddd*Pk2*f**2*g2*s**2 + 2880*D1*Ddd*Pk2*f**2*g2*s - 1440*D1*Ddd*Pk2*f**2*g2 - 140*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 70*D1*Ddd*Pkdd2*f**3*k1**2*s - 35*D1*Ddd*Pkdd2*f**3*k1**2 - 2*D1*bd1*(D1*(-1008*Pk2*fd*g2*(-2*r*s + r + s*(2*s - 2)) + 10*f**3*s*(9*Pk2*(12*r + 15*s - 8) - 7*Pkdd2*k1**2*s) - f**2*(18*Pk2*(10*fd*(6*r*(6*s - 1) + 33*s**2 - 31*s + 4) + s**2*(80*C - 40*K - 137) + s*(-112*C*r + 44*r + 28) + 20) + 5*Pkdd2*k1**2*s*(fd*(14 - 42*s) + 9*s)) - 9*f*(4*Pk2*fd*(r*(28*C - 4)*(4*s - 1) + s**2*(-80*C + 40*K + 186) + s*(12*C - 20*K - 103) + 24) + 112*Pk2*s*(2*g2*r - 2*g2*s - 2*gd2*r + 2*gd2*s + gd2) + 5*Pkdd2*fd*k1**2*s*(1 - 2*s))) + Dd*f*(-1008*Pk2*g2*(-8*r*s + r + 8*s**2) - 10*f**2*(18*Pk2*(6*r*(8*s - 1) + 44*s**2 - 39*s + 4) + 7*Pkdd2*k1**2*s*(1 - 4*s)) - 9*f*(4*Pk2*(r*(28*C - 4)*(8*s - 1) + s**2*(-160*C + 80*K + 372) - s*(16*C + 20*K + 141) + 14) + 5*Pkdd2*k1**2*s*(1 - 4*s)))) + 8640*Dd**2*Pk2*b2*f**2*s**2 - 4320*Dd**2*Pk2*b2*f**2*s + 19200*Dd**2*Pk2*f**3*r*s - 4800*Dd**2*Pk2*f**3*r + 16080*Dd**2*Pk2*f**3*s**2 - 17640*Dd**2*Pk2*f**3*s + 3200*Dd**2*Pk2*f**3 - 17280*Dd**2*Pk2*f**2*g2*s**2 + 8640*Dd**2*Pk2*f**2*g2*s - 420*Dd**2*Pkdd2*f**3*k1**2*s**2 + 210*Dd**2*Pkdd2*f**3*k1**2*s + 72*Pk2*b1**2*(-2*D1*Dd*(14*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s) + fd*(56*K*s**2 - 56*K*s + 5*f*(4*s - 1) - r*(7*K - 7)*(8*s - 5) + 14*s + 7)) - D1*(D1*(-10*f*fd*(2*s - 1) + 5*f*fdd*(2*s - 1) + 10*fd**2*s + 14*fd*(2*K*(s - 1)*(r - s + 1) - 2*r*s + 2*r - 2*s + 1) - 7*fdd*(2*K*(s - 1)*(r - s + 1) - 2*r*s + 2*r - 2*s + 1)) - 14*Ddd*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s)) + 14*Dd**2*f*(K*(12*r*s - 3*r - 12*s**2 + 2) - 12*r*s + 3*r + 6*s - 2)) + b1*(-8064*C*D1**2*Pk2*f*fd*r*s + 4032*C*D1**2*Pk2*f*fd*r + 5760*C*D1**2*Pk2*f*fd*s**2 - 1728*C*D1**2*Pk2*f*fd*s + 2880*C*D1**2*Pk2*f*fd + 4032*C*D1**2*Pk2*f*fdd*r*s - 2016*C*D1**2*Pk2*f*fdd*r - 2880*C*D1**2*Pk2*f*fdd*s**2 + 864*C*D1**2*Pk2*f*fdd*s - 1440*C*D1**2*Pk2*f*fdd + 4032*C*D1**2*Pk2*fd**2*r*s - 2016*C*D1**2*Pk2*fd**2*r - 2880*C*D1**2*Pk2*fd**2*s**2 + 864*C*D1**2*Pk2*fd**2*s + 2016*C*D1**2*Pk2*fd**2 - 16128*C*D1*Dd*Pk2*f**2*r*s + 4032*C*D1*Dd*Pk2*f**2*r + 11520*C*D1*Dd*Pk2*f**2*s**2 + 2304*C*D1*Dd*Pk2*f**2*s + 2880*C*D1*Dd*Pk2*f**2 + 32256*C*D1*Dd*Pk2*f*fd*r*s - 12096*C*D1*Dd*Pk2*f*fd*r - 23040*C*D1*Dd*Pk2*f*fd*s**2 + 1152*C*D1*Dd*Pk2*f*fd*s + 3168*C*D1*Dd*Pk2*f*fd + 8064*C*D1*Ddd*Pk2*f**2*r*s - 2016*C*D1*Ddd*Pk2*f**2*r - 5760*C*D1*Ddd*Pk2*f**2*s**2 - 1152*C*D1*Ddd*Pk2*f**2*s - 1440*C*D1*Ddd*Pk2*f**2 + 24192*C*Dd**2*Pk2*f**2*r*s - 6048*C*Dd**2*Pk2*f**2*r - 17280*C*Dd**2*Pk2*f**2*s**2 - 3456*C*Dd**2*Pk2*f**2*s + 4032*C*Dd**2*Pk2*f**2 - 2880*D1**2*K*Pk2*f*fd*s**2 + 2880*D1**2*K*Pk2*f*fd*s - 1440*D1**2*K*Pk2*f*fd + 1440*D1**2*K*Pk2*f*fdd*s**2 - 1440*D1**2*K*Pk2*f*fdd*s + 720*D1**2*K*Pk2*f*fdd + 1440*D1**2*K*Pk2*fd**2*s**2 - 1440*D1**2*K*Pk2*fd**2*s + 72*D1**2*Pk2*bdd1*f*(-28*K*s**2 + 5*f*(2*s - 1) - 7*s*(-4*K*r + 2*K + 4*r - 4) - 7) - 6480*D1**2*Pk2*f**2*fd*r*s + 2160*D1**2*Pk2*f**2*fd*r - 8100*D1**2*Pk2*f**2*fd*s**2 + 8280*D1**2*Pk2*f**2*fd*s - 2700*D1**2*Pk2*f**2*fd + 6480*D1**2*Pk2*f**2*fdd*r*s - 2160*D1**2*Pk2*f**2*fdd*r + 5940*D1**2*Pk2*f**2*fdd*s**2 - 6840*D1**2*Pk2*f**2*fdd*s + 1980*D1**2*Pk2*f**2*fdd + 12960*D1**2*Pk2*f*fd**2*r*s - 4320*D1**2*Pk2*f*fd**2*r + 11880*D1**2*Pk2*f*fd**2*s**2 - 13680*D1**2*Pk2*f*fd**2*s + 2880*D1**2*Pk2*f*fd**2 + 3168*D1**2*Pk2*f*fd*r*s - 1584*D1**2*Pk2*f*fd*r - 9864*D1**2*Pk2*f*fd*s**2 + 7272*D1**2*Pk2*f*fd*s - 5652*D1**2*Pk2*f*fd - 576*D1**2*Pk2*f*fdd*r*s + 288*D1**2*Pk2*f*fdd*r + 6696*D1**2*Pk2*f*fdd*s**2 - 5400*D1**2*Pk2*f*fdd*s + 3708*D1**2*Pk2*f*fdd + 4032*D1**2*Pk2*f*gd2*r*s - 4032*D1**2*Pk2*f*gd2*s**2 - 4032*D1**2*Pk2*f*gd2*s - 2016*D1**2*Pk2*f*gdd2*r*s + 2016*D1**2*Pk2*f*gdd2*s**2 + 2016*D1**2*Pk2*f*gdd2*s - 576*D1**2*Pk2*fd**2*r*s + 288*D1**2*Pk2*fd**2*r + 6696*D1**2*Pk2*fd**2*s**2 - 5400*D1**2*Pk2*fd**2*s - 2016*D1**2*Pk2*fd**2 + 4032*D1**2*Pk2*fd*g2*r*s - 4032*D1**2*Pk2*fd*g2*r - 4032*D1**2*Pk2*fd*g2*s**2 + 8064*D1**2*Pk2*fd*g2*s - 4032*D1**2*Pk2*fd*g2 - 4032*D1**2*Pk2*fd*gd2*r*s + 2016*D1**2*Pk2*fd*gd2*r + 4032*D1**2*Pk2*fd*gd2*s**2 - 2016*D1**2*Pk2*fd*gd2*s - 2016*D1**2*Pk2*fd*gd2 - 2016*D1**2*Pk2*fdd*g2*r*s + 2016*D1**2*Pk2*fdd*g2*r + 2016*D1**2*Pk2*fdd*g2*s**2 - 4032*D1**2*Pk2*fdd*g2*s + 2016*D1**2*Pk2*fdd*g2 + 420*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 280*D1**2*Pkdd2*f**2*fd*k1**2*s + 140*D1**2*Pkdd2*f**2*fd*k1**2 - 210*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 140*D1**2*Pkdd2*f**2*fdd*k1**2*s - 70*D1**2*Pkdd2*f**2*fdd*k1**2 - 420*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 280*D1**2*Pkdd2*f*fd**2*k1**2*s + 180*D1**2*Pkdd2*f*fd*k1**2*s**2 - 180*D1**2*Pkdd2*f*fd*k1**2*s + 90*D1**2*Pkdd2*f*fd*k1**2 - 90*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 90*D1**2*Pkdd2*f*fdd*k1**2*s - 45*D1**2*Pkdd2*f*fdd*k1**2 - 90*D1**2*Pkdd2*fd**2*k1**2*s**2 + 90*D1**2*Pkdd2*fd**2*k1**2*s - 5760*D1*Dd*K*Pk2*f**2*s**2 + 2880*D1*Dd*K*Pk2*f**2*s - 1440*D1*Dd*K*Pk2*f**2 + 11520*D1*Dd*K*Pk2*f*fd*s**2 - 8640*D1*Dd*K*Pk2*f*fd*s + 1440*D1*Dd*K*Pk2*f*fd - 8640*D1*Dd*Pk2*f**3*r*s + 2160*D1*Dd*Pk2*f**3*r - 10800*D1*Dd*Pk2*f**3*s**2 + 9720*D1*Dd*Pk2*f**3*s - 2700*D1*Dd*Pk2*f**3 + 51840*D1*Dd*Pk2*f**2*fd*r*s - 15120*D1*Dd*Pk2*f**2*fd*r + 47520*D1*Dd*Pk2*f**2*fd*s**2 - 52200*D1*Dd*Pk2*f**2*fd*s + 11160*D1*Dd*Pk2*f**2*fd + 6336*D1*Dd*Pk2*f**2*r*s - 1584*D1*Dd*Pk2*f**2*r - 19728*D1*Dd*Pk2*f**2*s**2 + 6696*D1*Dd*Pk2*f**2*s - 4932*D1*Dd*Pk2*f**2 - 4608*D1*Dd*Pk2*f*fd*r*s + 1728*D1*Dd*Pk2*f*fd*r + 53568*D1*Dd*Pk2*f*fd*s**2 - 33840*D1*Dd*Pk2*f*fd*s + 4824*D1*Dd*Pk2*f*fd + 16128*D1*Dd*Pk2*f*g2*r*s - 4032*D1*Dd*Pk2*f*g2*r - 16128*D1*Dd*Pk2*f*g2*s**2 - 4032*D1*Dd*Pk2*f*g2 - 16128*D1*Dd*Pk2*f*gd2*r*s + 2016*D1*Dd*Pk2*f*gd2*r + 16128*D1*Dd*Pk2*f*gd2*s**2 + 8064*D1*Dd*Pk2*f*gd2*s - 2016*D1*Dd*Pk2*f*gd2 - 16128*D1*Dd*Pk2*fd*g2*r*s + 10080*D1*Dd*Pk2*fd*g2*r + 16128*D1*Dd*Pk2*fd*g2*s**2 - 16128*D1*Dd*Pk2*fd*g2*s + 560*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 280*D1*Dd*Pkdd2*f**3*k1**2*s + 140*D1*Dd*Pkdd2*f**3*k1**2 - 1680*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 980*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 140*D1*Dd*Pkdd2*f**2*fd*k1**2 + 360*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 180*D1*Dd*Pkdd2*f**2*k1**2*s + 90*D1*Dd*Pkdd2*f**2*k1**2 - 720*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 540*D1*Dd*Pkdd2*f*fd*k1**2*s - 90*D1*Dd*Pkdd2*f*fd*k1**2 + 2880*D1*Ddd*K*Pk2*f**2*s**2 - 1440*D1*Ddd*K*Pk2*f**2*s + 720*D1*Ddd*K*Pk2*f**2 + 8640*D1*Ddd*Pk2*f**3*r*s - 2160*D1*Ddd*Pk2*f**3*r + 7920*D1*Ddd*Pk2*f**3*s**2 - 8280*D1*Ddd*Pk2*f**3*s + 1980*D1*Ddd*Pk2*f**3 - 1152*D1*Ddd*Pk2*f**2*r*s + 288*D1*Ddd*Pk2*f**2*r + 13392*D1*Ddd*Pk2*f**2*s**2 - 6120*D1*Ddd*Pk2*f**2*s + 3348*D1*Ddd*Pk2*f**2 - 8064*D1*Ddd*Pk2*f*g2*r*s + 2016*D1*Ddd*Pk2*f*g2*r + 8064*D1*Ddd*Pk2*f*g2*s**2 + 2016*D1*Ddd*Pk2*f*g2 - 280*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 140*D1*Ddd*Pkdd2*f**3*k1**2*s - 70*D1*Ddd*Pkdd2*f**3*k1**2 - 180*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 90*D1*Ddd*Pkdd2*f**2*k1**2*s - 45*D1*Ddd*Pkdd2*f**2*k1**2 - 144*D1*Pk2*bd1*(D1*(5*f**2*(2*s - 1) - 7*f*(4*K*s**2 + s*(-4*K*r + 2*K + 4*r - 4) + 1) - 7*fd*(K*(4*r*s - 2*r - 4*s**2 + 3*s + 1) - 4*r*s + 2*r - 1)) + Dd*f*(-7*K*(16*r*s - 2*r - 16*s**2 - 4*s + 1) + f*(5 - 20*s) + 112*r*s - 14*r - 84*s + 14)) + 8640*Dd**2*K*Pk2*f**2*s**2 - 4320*Dd**2*K*Pk2*f**2*s + 25920*Dd**2*Pk2*f**3*r*s - 6480*Dd**2*Pk2*f**3*r + 23760*Dd**2*Pk2*f**3*s**2 - 24840*Dd**2*Pk2*f**3*s + 4320*Dd**2*Pk2*f**3 - 3456*Dd**2*Pk2*f**2*r*s + 864*Dd**2*Pk2*f**2*r + 40176*Dd**2*Pk2*f**2*s**2 - 18360*Dd**2*Pk2*f**2*s - 576*Dd**2*Pk2*f**2 - 24192*Dd**2*Pk2*f*g2*r*s + 6048*Dd**2*Pk2*f*g2*r + 24192*Dd**2*Pk2*f*g2*s**2 - 4032*Dd**2*Pk2*f*g2 - 840*Dd**2*Pkdd2*f**3*k1**2*s**2 + 420*Dd**2*Pkdd2*f**3*k1**2*s - 540*Dd**2*Pkdd2*f**2*k1**2*s**2 + 270*Dd**2*Pkdd2*f**2*k1**2*s))/(630*d**2*k2*k3**2) - D1**2*Pk3*ct**5*k2**3*(D1**2*(45*Pkdd2*bd1*f**3*k1**2*s**2 + 9*Pkdd2*k1**2*s*(b1**2*s*(10*fd**2 + 14*fd*(2*K - 1) + 7*fdd*(1 - 2*K)) + b1*(-14*bd1*fd*(2*K - 1)*(2*s - 1) - 10*fd**2*(2*K*(s - 1) + s*(4*C - 3)) - 56*fd*s*(g2 - gd2) + 28*fdd*g2*s) + 8*fd*g2*(7*bd1 + 5*fd)*(s - 1)) + f**2*(9*Pkdd2*k1**2*(10*bd1**2*s*(s - 1) + bd1*(40*C*(s - 1)**2 + 6*K*s**2 - 10*b1*(2*s**2 - 2*s + 1) - 23*s**2 + 60*s - 30) + 5*bdd1*(-4*C*(s - 1)**2 - 2*K*s**2 + b1*(2*s**2 - 2*s + 1) + 3*s**2 - 6*s + 3) + s**2*(-12*gd2 + 20*gdd2)) + fd*(8*Pk2*(4*C*(81*r**2 + 30*r*s - 64*r - 10*s + 27) - 213*r**2 - 60*r*s + 162*r + 20*s - 71) + Pkdd2*k1**2*(100*C + 45*b1 - 5)*(3*s**2 - 2*s + 1)) - 2*fdd*(2*Pk2*(4*C*(27*r**2 + 30*r*s - 28*r - 10*s + 9) - 51*r**2 - 60*r*s + 54*r + 20*s - 17) + Pkdd2*k1**2*(70*C - 35)*(3*s**2 - 2*s + 1))) + f*(-9*Pkdd2*fd*k1**2*(20*b1**2*s**2 + b1*(-6*K*(2*s**2 - 2*s + 1) + s**2*(-80*C - 40*bd1 + 46) + s*(20*bd1 + 14) - 7) + 4*g2*(6*s**2 - 6*s + 3) + 20*s*(bd1*(4*C*(s - 1) + 2*K*s - K - 3*s + 3) - 4*gd2*s + 2*gd2)) + 9*Pkdd2*k1**2*(10*b1**2*fdd*s**2 + b1*(-40*C*fdd*s**2 - 20*K*fdd*s**2 + 20*K*fdd*s - 10*K*fdd + 14*bd1*(2*K - 1)*(2*s**2 - 2*s + 1) - 7*bdd1*(2*K - 1)*(2*s**2 - 2*s + 1) + 30*fdd*s**2 - 56*gd2*s**2 + 28*gdd2*s**2) - 14*bd1**2*s*(2*K - 1)*(s - 1) - 56*bd1*(s - 1)*(g2*(s - 1) - gd2*s) + 4*g2*(7*bdd1*(s - 1)**2 + 5*fdd*(2*s**2 - 2*s + 1))) - 4*fd**2*(2*Pk2*(4*C*(27*r**2 + 30*r*s - 28*r - 10*s + 5) - 51*r**2 - 60*r*s + 54*r + 20*s - 10) + Pkdd2*k1**2*s*(70*C - 35)*(3*s - 2)))) + D1*(Dd*(-126*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(b1*(2*K - 1) - 4*g2) + 18*Pkdd2*f*k1**2*(b1**2*(14*K*(4*s**2 - 2*s + 1) + s**2*(40*fd - 28) - s*(10*fd - 14) - 7) - b1*(7*bd1*(2*K - 1)*(8*s**2 - 6*s + 1) + 28*g2*(4*s**2 - 2*s + 1) + (8*s - 2)*(5*fd*(4*C*s + 2*K*s - K - 3*s) - 14*gd2*s)) + 4*g2*(4*s - 1)*(7*bd1*(s - 1) + 5*fd*(2*s - 1))) + f**3*(16*Pk2*(4*C*(54*r**2 + 20*r*s - 59*r - 10*s + 27) - 142*r**2 - 40*r*s + 152*r + 20*s - 71) + Pkdd2*k1**2*(100*C + 45*b1 - 5)*(4*s**2 - 2*s + 1)) + f**2*(-9*Pkdd2*k1**2*(10*b1**2*(4*s**2 - 2*s + 1) - 10*b1*bd1*(8*s**2 - 6*s + 1) - b1*(40*C + 6*K - 23)*(4*s**2 - 2*s + 1) + 10*bd1*(4*s - 1)*(4*C*(s - 1) + s*(2*K - 3) + 3) + 12*g2*(4*s**2 - 2*s + 1) + 40*gd2*s*(1 - 4*s)) - 4*fd*(8*Pk2*(C*(108*r**2 + 5*r*(24*s - 25) - 50*s + 33) - 51*r**2 - 60*r*(s - 1) + 25*s - 16) + Pkdd2*k1**2*(70*C - 35)*(12*s**2 - 7*s + 1)))) + Ddd*f*(-63*Pkdd2*b1*k1**2*(b1*(2*K - 1) - 4*g2)*(4*s**2 - 2*s + 1) + 45*Pkdd2*f*k1**2*(b1**2 + b1*(-4*C - 2*K + 3) + 4*g2)*(4*s**2 - 2*s + 1) - 2*f**2*(4*Pk2*(4*C*(18*r**2 + 20*r*s - 23*r - 10*s + 9) - 34*r**2 - 40*r*s + 44*r + 20*s - 17) + Pkdd2*k1**2*(70*C - 35)*(4*s**2 - 2*s + 1)))) + 2*Dd**2*f*(-189*Pkdd2*b1*k1**2*s*(2*s - 1)*(b1*(2*K - 1) - 4*g2) + 135*Pkdd2*f*k1**2*s*(2*s - 1)*(b1**2 + b1*(-4*C - 2*K + 3) + 4*g2) - 2*f**2*(2*Pk2*(4*C*(54*r**2 + 60*r*s - 69*r - 30*s + 19) - 102*r**2 - 120*r*s + 132*r + 60*s - 37) + Pkdd2*k1**2*s*(210*C - 105)*(2*s - 1))))/(630*d**2*k1*k3**4) + D1**2*Pk3*ct**5*k2*(D1**2*(45*Pkdd2*bd1*f**3*k1**2*s**2 + 9*Pkdd2*k1**2*(b1**2*(10*fd**2*s - 14*fd*(2*K*(s - 1)**2 + 2*s - 1) + 7*fdd*(2*K*(s - 1)**2 + 2*s - 1)) + 2*b1*(5*fd**2*s*(4*C*(s - 1) - 2*K*(s - 1) - 2*s + 3) + 7*fd*(4*g2*(s - 1)**2 + s*(4*K*bd1*(s - 1) + bd1 - 4*gd2*(s - 1))) - 14*fdd*g2*(s - 1)**2) - 4*fd*s*(s - 1)*(5*b2*fd + g2*(14*bd1 - 10*fd))) - f**2*(4*Pk2*fdd*(3*r**2 + r*(-40*C*(3*s - 1) + 60*s - 22) + s*(40*C - 20) + 1) + Pkdd2*fdd*k1**2*(140*C - 70)*(3*s**2 - 2*s + 1) + 9*Pkdd2*k1**2*(10*bd1**2*s + bd1*(b1*(10 - 20*s) + s**2*(40*C - 20*K - 27) - 20*s + 10) + 5*bdd1*(b1*(2*s - 1) + s**2*(-4*C + 2*K + 2) + 2*s - 1) + 5*s**2*(-4*bd2 + 2*bdd2 + 8*gd2 - 4*gdd2)) + fd*(8*Pk2*(51*r**2 + 2*r*(20*C*(3*s - 1) - 30*s - 7) + s*(20 - 40*C) + 17) + Pkdd2*k1**2*(-280*C - 45*b1 + 95)*(3*s**2 - 2*s + 1))) + f*(-9*Pkdd2*fd*k1**2*(10*b1**2*(2*s - 1) + b1*(40*C*(2*s**2 - 2*s + 1) - 20*K*(2*s**2 - 2*s + 1) - 54*s**2 + 74*s - 37) - 10*b2*(4*s**2 - 4*s + 2) - 10*bd1*s*(C*(8*s - 4) - 4*K*s + 2*K - 4*s + 1) - 10*g2*(-8*s**2 + 8*s - 4) - 10*s*(-2*bd2 + 4*gd2)*(2*s - 1)) + 9*Pkdd2*k1**2*(5*b1**2*fdd*(2*s - 1) + b1*(40*C*fdd*s**2 - 40*C*fdd*s + 20*C*fdd - 20*K*fdd*s**2 + 20*K*fdd*s - 10*K*fdd - 14*bd1*(4*K*s**2 - 2*s + 1) + 7*bdd1*(4*K*s**2 - 2*s + 1) - 20*fdd*s**2 + 30*fdd*s - 15*fdd + 56*gd2*s**2 - 28*gdd2*s**2) - 10*b2*fdd*(2*s**2 - 2*s + 1) + 20*fdd*g2*(2*s**2 - 2*s + 1) - 14*s*(bd1**2*(-2*K*s + 1) + 4*bd1*s*(-g2 + gd2) + 2*bdd1*g2*s)) + 4*fd**2*(2*Pk2*(20*C*(6*r*s - 2*r - 2*s + 1) - 3*r**2 - 60*r*s + 22*r + 20*s - 10) + Pkdd2*k1**2*s*(35 - 70*C)*(3*s - 2)))) - D1*Dd*(-126*Pkdd2*b1*fd*k1**2*(4*s - 1)*(2*K*b1*(s - 1) + b1 - 4*g2*(s - 1)) - 18*Pkdd2*f*k1**2*(b1**2*(-14*K*(4*s**2 - 2*s + 1) + 5*fd*(4*s - 1)) + b1*(7*bd1*(4*s - 1)*(4*K*s - 1) + 5*fd*(4*s - 1)*(8*C*s - 4*C - 4*K*s + 2*K - 4*s + 3) + 112*g2*s**2 - 56*g2*s + 28*g2 - 112*gd2*s**2 + 28*gd2*s) + (2 - 8*s)*(5*b2*fd*(2*s - 1) + 2*g2*(7*bd1*s + fd*(5 - 10*s)))) + f**3*(16*Pk2*(34*r**2 + 4*r*(20*C*s - 5*C - 10*s - 6) + s*(20 - 40*C) + 17) + Pkdd2*k1**2*(-280*C - 45*b1 + 95)*(4*s**2 - 2*s + 1)) + f**2*(9*Pkdd2*k1**2*(b1*(10*bd1*(4*s - 1) + (40*C - 20*K - 27)*(4*s**2 - 2*s + 1)) - 10*b2*(8*s**2 - 4*s + 2) - 10*bd1*(4*s - 1)*(4*C*s - s*(2*K + 2) - 1) + 40*g2*(4*s**2 - 2*s + 1) - 10*s*(-2*bd2 + 4*gd2)*(4*s - 1)) - 4*fd*(8*Pk2*(5*C*(24*r*s - 7*r - 10*s + 3) - 3*r**2 - 60*r*s + 20*r + 25*s - 8) + Pkdd2*k1**2*(35 - 70*C)*(12*s**2 - 7*s + 1)))) + 2*D1*Ddd*f*(63*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1) - 45*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)*(b1*(-2*C + K + 1) + b2 - 2*g2) + f**2*(-4*Pk2*(40*C*s + 2*r**2 - 4*r*(20*C*s - 5*C - 10*s + 3) - 20*s + 1) + Pkdd2*k1**2*(35 - 70*C)*(4*s**2 - 2*s + 1))) + 4*Dd**2*f*(189*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2) - 135*Pkdd2*f*k1**2*s*(2*s - 1)*(b1*(-2*C + K + 1) + b2 - 2*g2) + f**2*(40*C*Pk2*(3*r*(4*s - 1) - 6*s + 2) - 6*Pk2*(2*r**2 + 4*r*(10*s - 3) - 20*s + 7) + Pkdd2*k1**2*s*(105 - 210*C)*(2*s - 1))))/(630*d**2*k1*k3**2) + D1**2*Pk3*ct**4*k1**2*st**2*(19008*C*D1**2*Pk2*bdd1*f**2*r*s + 28512*C*D1**2*Pk2*bdd1*f**2*s**2 - 19008*C*D1**2*Pk2*bdd1*f**2*s + 9504*C*D1**2*Pk2*bdd1*f**2 + 312576*C*D1**2*Pk2*f**2*fd*r*s - 104192*C*D1**2*Pk2*f**2*fd*r + 22704*C*D1**2*Pk2*f**2*fd*s**2 - 119328*C*D1**2*Pk2*f**2*fd*s + 7568*C*D1**2*Pk2*f**2*fd - 213312*C*D1**2*Pk2*f**2*fdd*r*s + 71104*C*D1**2*Pk2*f**2*fdd*r - 75504*C*D1**2*Pk2*f**2*fdd*s**2 + 121440*C*D1**2*Pk2*f**2*fdd*s - 25168*C*D1**2*Pk2*f**2*fdd - 426624*C*D1**2*Pk2*f*fd**2*r*s + 142208*C*D1**2*Pk2*f*fd**2*r - 151008*C*D1**2*Pk2*f*fd**2*s**2 + 242880*C*D1**2*Pk2*f*fd**2*s - 71104*C*D1**2*Pk2*f*fd**2 - 3960*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 2640*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 1320*C*D1**2*Pkdd2*f**2*fd*k1**2 + 1980*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 1320*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 660*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 3960*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 2640*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 416768*C*D1*Dd*Pk2*f**3*r*s - 104192*C*D1*Dd*Pk2*f**3*r + 30272*C*D1*Dd*Pk2*f**3*s**2 - 223520*C*D1*Dd*Pk2*f**3*s + 7568*C*D1*Dd*Pk2*f**3 - 1706496*C*D1*Dd*Pk2*f**2*fd*r*s + 497728*C*D1*Dd*Pk2*f**2*fd*r - 604032*C*D1*Dd*Pk2*f**2*fd*s**2 + 1063392*C*D1*Dd*Pk2*f**2*fd*s - 263648*C*D1*Dd*Pk2*f**2*fd - 5280*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 2640*C*D1*Dd*Pkdd2*f**3*k1**2*s - 1320*C*D1*Dd*Pkdd2*f**3*k1**2 + 15840*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 9240*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 1320*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 284416*C*D1*Ddd*Pk2*f**3*r*s + 71104*C*D1*Ddd*Pk2*f**3*r - 100672*C*D1*Ddd*Pk2*f**3*s**2 + 192544*C*D1*Ddd*Pk2*f**3*s - 25168*C*D1*Ddd*Pk2*f**3 + 2640*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 1320*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 660*C*D1*Ddd*Pkdd2*f**3*k1**2 - 853248*C*Dd**2*Pk2*f**3*r*s + 213312*C*Dd**2*Pk2*f**3*r - 302016*C*Dd**2*Pk2*f**3*s**2 + 577632*C*Dd**2*Pk2*f**3*s - 142208*C*Dd**2*Pk2*f**3 + 7920*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 3960*C*Dd**2*Pkdd2*f**3*k1**2*s - 53856*D1**2*K*Pk2*bdd1*f**2*r*s - 34056*D1**2*K*Pk2*bdd1*f**2*s**2 + 53856*D1**2*K*Pk2*bdd1*f**2*s + 594*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 22176*D1**2*Pk2*bd1**2*f*s*(K - 1)*(2*r + 3*s - 2) + 52800*D1**2*Pk2*bdd1*f**3*r*s + 39600*D1**2*Pk2*bdd1*f**3*s**2 - 52800*D1**2*Pk2*bdd1*f**3*s + 6600*D1**2*Pk2*bdd1*f**3 + 82368*D1**2*Pk2*bdd1*f**2*r*s + 68904*D1**2*Pk2*bdd1*f**2*s**2 - 82368*D1**2*Pk2*bdd1*f**2*s - 9504*D1**2*Pk2*bdd1*f**2 - 44352*D1**2*Pk2*bdd1*f*g2*r*s - 66528*D1**2*Pk2*bdd1*f*g2*s**2 + 44352*D1**2*Pk2*bdd1*f*g2*s - 22176*D1**2*Pk2*bdd1*f*g2 + 237600*D1**2*Pk2*f**3*fd*r*s - 59400*D1**2*Pk2*f**3*fd*r + 224400*D1**2*Pk2*f**3*fd*s**2 - 231000*D1**2*Pk2*f**3*fd*s + 56100*D1**2*Pk2*f**3*fd - 237600*D1**2*Pk2*f**3*fdd*r*s + 59400*D1**2*Pk2*f**3*fdd*r - 171600*D1**2*Pk2*f**3*fdd*s**2 + 204600*D1**2*Pk2*f**3*fdd*s - 42900*D1**2*Pk2*f**3*fdd - 712800*D1**2*Pk2*f**2*fd**2*r*s + 178200*D1**2*Pk2*f**2*fd**2*r - 514800*D1**2*Pk2*f**2*fd**2*s**2 + 613800*D1**2*Pk2*f**2*fd**2*s - 118800*D1**2*Pk2*f**2*fd**2 - 442464*D1**2*Pk2*f**2*fd*r*s + 147488*D1**2*Pk2*f**2*fd*r - 205392*D1**2*Pk2*f**2*fd*s**2 + 284416*D1**2*Pk2*f**2*fd*s - 68464*D1**2*Pk2*f**2*fd + 292512*D1**2*Pk2*f**2*fdd*r*s - 97504*D1**2*Pk2*f**2*fdd*r + 181104*D1**2*Pk2*f**2*fdd*s**2 - 218240*D1**2*Pk2*f**2*fdd*s + 60368*D1**2*Pk2*f**2*fdd - 171072*D1**2*Pk2*f**2*gd2*r*s - 36432*D1**2*Pk2*f**2*gd2*s**2 + 171072*D1**2*Pk2*f**2*gd2*s + 107712*D1**2*Pk2*f**2*gdd2*r*s + 68112*D1**2*Pk2*f**2*gdd2*s**2 - 107712*D1**2*Pk2*f**2*gdd2*s + 585024*D1**2*Pk2*f*fd**2*r*s - 195008*D1**2*Pk2*f*fd**2*r + 362208*D1**2*Pk2*f*fd**2*s**2 - 436480*D1**2*Pk2*f*fd**2*s + 97504*D1**2*Pk2*f*fd**2 - 342144*D1**2*Pk2*f*fd*g2*r*s + 171072*D1**2*Pk2*f*fd*g2*r - 72864*D1**2*Pk2*f*fd*g2*s**2 + 72864*D1**2*Pk2*f*fd*g2*s - 36432*D1**2*Pk2*f*fd*g2 + 430848*D1**2*Pk2*f*fd*gd2*r*s - 107712*D1**2*Pk2*f*fd*gd2*r + 272448*D1**2*Pk2*f*fd*gd2*s**2 - 351648*D1**2*Pk2*f*fd*gd2*s + 107712*D1**2*Pk2*f*fd*gd2 + 215424*D1**2*Pk2*f*fdd*g2*r*s - 107712*D1**2*Pk2*f*fdd*g2*r + 136224*D1**2*Pk2*f*fdd*g2*s**2 - 136224*D1**2*Pk2*f*fdd*g2*s + 68112*D1**2*Pk2*f*fdd*g2 + 215424*D1**2*Pk2*fd**2*g2*r*s - 107712*D1**2*Pk2*fd**2*g2*r + 136224*D1**2*Pk2*fd**2*g2*s**2 - 136224*D1**2*Pk2*fd**2*g2*s - 594*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 12600*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 6300*D1**2*Pkdd2*f**3*fd*k1**2*s - 3150*D1**2*Pkdd2*f**3*fd*k1**2 + 6300*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 3150*D1**2*Pkdd2*f**3*fdd*k1**2*s + 1575*D1**2*Pkdd2*f**3*fdd*k1**2 + 18900*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 9450*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 3960*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 2640*D1**2*Pkdd2*f**2*fd*k1**2*s + 1320*D1**2*Pkdd2*f**2*fd*k1**2 - 1980*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 1320*D1**2*Pkdd2*f**2*fdd*k1**2*s - 660*D1**2*Pkdd2*f**2*fdd*k1**2 + 2376*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 1188*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 3960*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 2640*D1**2*Pkdd2*f*fd**2*k1**2*s + 4752*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 4752*D1**2*Pkdd2*f*fd*g2*k1**2*s + 2376*D1**2*Pkdd2*f*fd*g2*k1**2 - 4752*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 2376*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 2376*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 2376*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 1188*D1**2*Pkdd2*f*fdd*g2*k1**2 - 2376*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 2376*D1**2*Pkdd2*fd**2*g2*k1**2*s + 237600*D1*Dd*Pk2*f**4*r*s - 59400*D1*Dd*Pk2*f**4*r + 224400*D1*Dd*Pk2*f**4*s**2 - 231000*D1*Dd*Pk2*f**4*s + 56100*D1*Dd*Pk2*f**4 - 1900800*D1*Dd*Pk2*f**3*fd*r*s + 475200*D1*Dd*Pk2*f**3*fd*r - 1372800*D1*Dd*Pk2*f**3*fd*s**2 + 1636800*D1*Dd*Pk2*f**3*fd*s - 323400*D1*Dd*Pk2*f**3*fd - 589952*D1*Dd*Pk2*f**3*r*s + 147488*D1*Dd*Pk2*f**3*r - 273856*D1*Dd*Pk2*f**3*s**2 + 431904*D1*Dd*Pk2*f**3*s - 68464*D1*Dd*Pk2*f**3 + 2340096*D1*Dd*Pk2*f**2*fd*r*s - 682528*D1*Dd*Pk2*f**2*fd*r + 1448832*D1*Dd*Pk2*f**2*fd*s**2 - 1820192*D1*Dd*Pk2*f**2*fd*s + 413248*D1*Dd*Pk2*f**2*fd - 684288*D1*Dd*Pk2*f**2*g2*r*s + 171072*D1*Dd*Pk2*f**2*g2*r - 145728*D1*Dd*Pk2*f**2*g2*s**2 + 415008*D1*Dd*Pk2*f**2*g2*s - 36432*D1*Dd*Pk2*f**2*g2 + 861696*D1*Dd*Pk2*f**2*gd2*r*s - 107712*D1*Dd*Pk2*f**2*gd2*r + 544896*D1*Dd*Pk2*f**2*gd2*s**2 - 782496*D1*Dd*Pk2*f**2*gd2*s + 107712*D1*Dd*Pk2*f**2*gd2 + 1723392*D1*Dd*Pk2*f*fd*g2*r*s - 646272*D1*Dd*Pk2*f*fd*g2*r + 1089792*D1*Dd*Pk2*f*fd*g2*s**2 - 1248192*D1*Dd*Pk2*f*fd*g2*s + 351648*D1*Dd*Pk2*f*fd*g2 - 12600*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 6300*D1*Dd*Pkdd2*f**4*k1**2*s - 3150*D1*Dd*Pkdd2*f**4*k1**2 + 50400*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 25200*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 3150*D1*Dd*Pkdd2*f**3*fd*k1**2 + 5280*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 2640*D1*Dd*Pkdd2*f**3*k1**2*s + 1320*D1*Dd*Pkdd2*f**3*k1**2 - 15840*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 9240*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 1320*D1*Dd*Pkdd2*f**2*fd*k1**2 + 9504*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 4752*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 2376*D1*Dd*Pkdd2*f**2*g2*k1**2 - 9504*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 2376*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 19008*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 14256*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 2376*D1*Dd*Pkdd2*f*fd*g2*k1**2 - 237600*D1*Ddd*Pk2*f**4*r*s + 59400*D1*Ddd*Pk2*f**4*r - 171600*D1*Ddd*Pk2*f**4*s**2 + 204600*D1*Ddd*Pk2*f**4*s - 42900*D1*Ddd*Pk2*f**4 + 390016*D1*Ddd*Pk2*f**3*r*s - 97504*D1*Ddd*Pk2*f**3*r + 241472*D1*Ddd*Pk2*f**3*s**2 - 315744*D1*Ddd*Pk2*f**3*s + 60368*D1*Ddd*Pk2*f**3 + 430848*D1*Ddd*Pk2*f**2*g2*r*s - 107712*D1*Ddd*Pk2*f**2*g2*r + 272448*D1*Ddd*Pk2*f**2*g2*s**2 - 351648*D1*Ddd*Pk2*f**2*g2*s + 68112*D1*Ddd*Pk2*f**2*g2 + 6300*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 3150*D1*Ddd*Pkdd2*f**4*k1**2*s + 1575*D1*Ddd*Pkdd2*f**4*k1**2 - 2640*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 1320*D1*Ddd*Pkdd2*f**3*k1**2*s - 660*D1*Ddd*Pkdd2*f**3*k1**2 - 4752*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 2376*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 1188*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 132*D1*bd1*(D1*(20*Pk2*f**3*(24*s**2 + s*(34*r - 34) + 5) + 336*Pk2*fd*g2*(r*(2*s - 1) + s*(3*s - 3)) + f**2*(2*Pk2*(72*C*(3*s**2 + s*(2*r - 2) + 1) - 324*K*r*s - 69*K*s**2 + 324*K*s - 50*fd*(24*r*s - 4*r + 18*s**2 - 22*s + 3) + 456*r*s + 249*s**2 - 456*s - 72) + Pkdd2*k1**2*s**2*(9*K - 9)) + 3*f*(-112*Pk2*(3*g2*s**2 + 2*g2*s*(r - 1) + g2 + gd2*s*(-2*r - 3*s + 2)) + fd*(4*Pk2*(-72*C*s**2 + 60*C*s + K*(34*r*(4*s - 1) + 86*s**2 - 111*s + 34) - r*(12*C + 52)*(4*s - 1) - 174*s**2 + 191*s - 64) + 3*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1)))) + Dd*f*(-200*Pk2*f**2*(2*r*(8*s - 1) + 12*s**2 - 15*s + 2) + 336*Pk2*g2*(r*(8*s - 1) + 12*s**2 - 9*s + 1) - 3*f*(4*Pk2*(12*C*(r*(8*s - 1) + 12*s**2 - 9*s + 1) + K*(-272*r*s + 34*r - 172*s**2 + 247*s - 34) + 416*r*s - 52*r + 348*s**2 - 399*s + 52) + Pkdd2*k1**2*s*(3*K - 3)*(4*s - 1)))) - 712800*Dd**2*Pk2*f**4*r*s + 178200*Dd**2*Pk2*f**4*r - 514800*Dd**2*Pk2*f**4*s**2 + 613800*Dd**2*Pk2*f**4*s - 118800*Dd**2*Pk2*f**4 + 1170048*Dd**2*Pk2*f**3*r*s - 292512*Dd**2*Pk2*f**3*r + 724416*Dd**2*Pk2*f**3*s**2 - 947232*Dd**2*Pk2*f**3*s + 195008*Dd**2*Pk2*f**3 + 1292544*Dd**2*Pk2*f**2*g2*r*s - 323136*Dd**2*Pk2*f**2*g2*r + 817344*Dd**2*Pk2*f**2*g2*s**2 - 1054944*Dd**2*Pk2*f**2*g2*s + 215424*Dd**2*Pk2*f**2*g2 + 18900*Dd**2*Pkdd2*f**4*k1**2*s**2 - 9450*Dd**2*Pkdd2*f**4*k1**2*s - 7920*Dd**2*Pkdd2*f**3*k1**2*s**2 + 3960*Dd**2*Pkdd2*f**3*k1**2*s - 14256*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 7128*Dd**2*Pkdd2*f**2*g2*k1**2*s - 11088*Pk2*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + D1*(2*Dd*(f*(8*r*s - 2*r + 12*s**2 - 10*s + 3) + fd*(-8*r*s + 5*r - 12*s**2 + 13*s - 4)) + Ddd*f*(r*(2 - 8*s) - 12*s**2 + 10*s - 3)) - 2*Dd**2*f*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2)) - 66*b1*(1152*C*D1**2*Pk2*f*fd*r*s - 576*C*D1**2*Pk2*f*fd*r + 1728*C*D1**2*Pk2*f*fd*s**2 - 1728*C*D1**2*Pk2*f*fd*s + 576*C*D1**2*Pk2*f*fd - 576*C*D1**2*Pk2*f*fdd*r*s + 288*C*D1**2*Pk2*f*fdd*r - 864*C*D1**2*Pk2*f*fdd*s**2 + 864*C*D1**2*Pk2*f*fdd*s - 288*C*D1**2*Pk2*f*fdd - 576*C*D1**2*Pk2*fd**2*r*s + 288*C*D1**2*Pk2*fd**2*r - 864*C*D1**2*Pk2*fd**2*s**2 + 864*C*D1**2*Pk2*fd**2*s - 288*C*D1**2*Pk2*fd**2 + 2304*C*D1*Dd*Pk2*f**2*r*s - 576*C*D1*Dd*Pk2*f**2*r + 3456*C*D1*Dd*Pk2*f**2*s**2 - 2880*C*D1*Dd*Pk2*f**2*s + 864*C*D1*Dd*Pk2*f**2 - 4608*C*D1*Dd*Pk2*f*fd*r*s + 1728*C*D1*Dd*Pk2*f*fd*r - 6912*C*D1*Dd*Pk2*f*fd*s**2 + 6336*C*D1*Dd*Pk2*f*fd*s - 1440*C*D1*Dd*Pk2*f*fd - 1152*C*D1*Ddd*Pk2*f**2*r*s + 288*C*D1*Ddd*Pk2*f**2*r - 1728*C*D1*Ddd*Pk2*f**2*s**2 + 1440*C*D1*Ddd*Pk2*f**2*s - 432*C*D1*Ddd*Pk2*f**2 - 3456*C*Dd**2*Pk2*f**2*r*s + 864*C*Dd**2*Pk2*f**2*r - 5184*C*Dd**2*Pk2*f**2*s**2 + 4320*C*Dd**2*Pk2*f**2*s - 576*C*Dd**2*Pk2*f**2 - 2592*D1**2*K*Pk2*f*fd*r*s + 1296*D1**2*K*Pk2*f*fd*r - 552*D1**2*K*Pk2*f*fd*s**2 + 552*D1**2*K*Pk2*f*fd*s - 276*D1**2*K*Pk2*f*fd + 1632*D1**2*K*Pk2*f*fdd*r*s - 816*D1**2*K*Pk2*f*fdd*r + 1032*D1**2*K*Pk2*f*fdd*s**2 - 1032*D1**2*K*Pk2*f*fdd*s + 516*D1**2*K*Pk2*f*fdd + 1632*D1**2*K*Pk2*fd**2*r*s - 816*D1**2*K*Pk2*fd**2*r + 1032*D1**2*K*Pk2*fd**2*s**2 - 1032*D1**2*K*Pk2*fd**2*s + 36*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 36*D1**2*K*Pkdd2*f*fd*k1**2*s + 18*D1**2*K*Pkdd2*f*fd*k1**2 - 18*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 18*D1**2*K*Pkdd2*f*fdd*k1**2*s - 9*D1**2*K*Pkdd2*f*fdd*k1**2 - 18*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 18*D1**2*K*Pkdd2*fd**2*k1**2*s - 168*D1**2*Pk2*bdd1*f*(K - 1)*(6*s**2 + s*(4*r - 4) + 1) + 4080*D1**2*Pk2*f**2*fd*r*s - 1360*D1**2*Pk2*f**2*fd*r + 2880*D1**2*Pk2*f**2*fd*s**2 - 3280*D1**2*Pk2*f**2*fd*s + 760*D1**2*Pk2*f**2*fd - 2400*D1**2*Pk2*f**2*fdd*r*s + 800*D1**2*Pk2*f**2*fdd*r - 1800*D1**2*Pk2*f**2*fdd*s**2 + 2000*D1**2*Pk2*f**2*fdd*s - 500*D1**2*Pk2*f**2*fdd - 4800*D1**2*Pk2*f*fd**2*r*s + 1600*D1**2*Pk2*f*fd**2*r - 3600*D1**2*Pk2*f*fd**2*s**2 + 4000*D1**2*Pk2*f*fd**2*s - 1000*D1**2*Pk2*f*fd**2 + 3648*D1**2*Pk2*f*fd*r*s - 1824*D1**2*Pk2*f*fd*r + 1992*D1**2*Pk2*f*fd*s**2 - 1992*D1**2*Pk2*f*fd*s + 1284*D1**2*Pk2*f*fd - 2496*D1**2*Pk2*f*fdd*r*s + 1248*D1**2*Pk2*f*fdd*r - 2088*D1**2*Pk2*f*fdd*s**2 + 2088*D1**2*Pk2*f*fdd*s - 1188*D1**2*Pk2*f*fdd - 1344*D1**2*Pk2*f*gd2*r*s - 2016*D1**2*Pk2*f*gd2*s**2 + 1344*D1**2*Pk2*f*gd2*s + 672*D1**2*Pk2*f*gdd2*r*s + 1008*D1**2*Pk2*f*gdd2*s**2 - 672*D1**2*Pk2*f*gdd2*s - 2496*D1**2*Pk2*fd**2*r*s + 1248*D1**2*Pk2*fd**2*r - 2088*D1**2*Pk2*fd**2*s**2 + 2088*D1**2*Pk2*fd**2*s + 288*D1**2*Pk2*fd**2 - 1344*D1**2*Pk2*fd*g2*r*s + 1344*D1**2*Pk2*fd*g2*r - 2016*D1**2*Pk2*fd*g2*s**2 + 2688*D1**2*Pk2*fd*g2*s - 1344*D1**2*Pk2*fd*g2 + 1344*D1**2*Pk2*fd*gd2*r*s - 672*D1**2*Pk2*fd*gd2*r + 2016*D1**2*Pk2*fd*gd2*s**2 - 2016*D1**2*Pk2*fd*gd2*s + 672*D1**2*Pk2*fd*gd2 + 672*D1**2*Pk2*fdd*g2*r*s - 672*D1**2*Pk2*fdd*g2*r + 1008*D1**2*Pk2*fdd*g2*s**2 - 1344*D1**2*Pk2*fdd*g2*s + 672*D1**2*Pk2*fdd*g2 - 36*D1**2*Pkdd2*f*fd*k1**2*s**2 + 36*D1**2*Pkdd2*f*fd*k1**2*s - 18*D1**2*Pkdd2*f*fd*k1**2 + 18*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 18*D1**2*Pkdd2*f*fdd*k1**2*s + 9*D1**2*Pkdd2*f*fdd*k1**2 + 18*D1**2*Pkdd2*fd**2*k1**2*s**2 - 18*D1**2*Pkdd2*fd**2*k1**2*s - 5184*D1*Dd*K*Pk2*f**2*r*s + 1296*D1*Dd*K*Pk2*f**2*r - 1104*D1*Dd*K*Pk2*f**2*s**2 + 3144*D1*Dd*K*Pk2*f**2*s - 276*D1*Dd*K*Pk2*f**2 + 13056*D1*Dd*K*Pk2*f*fd*r*s - 4896*D1*Dd*K*Pk2*f*fd*r + 8256*D1*Dd*K*Pk2*f*fd*s**2 - 9456*D1*Dd*K*Pk2*f*fd*s + 2664*D1*Dd*K*Pk2*f*fd + 72*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 36*D1*Dd*K*Pkdd2*f**2*k1**2*s + 18*D1*Dd*K*Pkdd2*f**2*k1**2 - 144*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 108*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 18*D1*Dd*K*Pkdd2*f*fd*k1**2 + 5440*D1*Dd*Pk2*f**3*r*s - 1360*D1*Dd*Pk2*f**3*r + 3840*D1*Dd*Pk2*f**3*s**2 - 4640*D1*Dd*Pk2*f**3*s + 960*D1*Dd*Pk2*f**3 - 19200*D1*Dd*Pk2*f**2*fd*r*s + 5600*D1*Dd*Pk2*f**2*fd*r - 14400*D1*Dd*Pk2*f**2*fd*s**2 + 16400*D1*Dd*Pk2*f**2*fd*s - 3600*D1*Dd*Pk2*f**2*fd + 7296*D1*Dd*Pk2*f**2*r*s - 1824*D1*Dd*Pk2*f**2*r + 3984*D1*Dd*Pk2*f**2*s**2 - 5640*D1*Dd*Pk2*f**2*s + 996*D1*Dd*Pk2*f**2 - 19968*D1*Dd*Pk2*f*fd*r*s + 7488*D1*Dd*Pk2*f*fd*r - 16704*D1*Dd*Pk2*f*fd*s**2 + 17520*D1*Dd*Pk2*f*fd*s - 4584*D1*Dd*Pk2*f*fd - 5376*D1*Dd*Pk2*f*g2*r*s + 1344*D1*Dd*Pk2*f*g2*r - 8064*D1*Dd*Pk2*f*g2*s**2 + 6720*D1*Dd*Pk2*f*g2*s - 2016*D1*Dd*Pk2*f*g2 + 5376*D1*Dd*Pk2*f*gd2*r*s - 672*D1*Dd*Pk2*f*gd2*r + 8064*D1*Dd*Pk2*f*gd2*s**2 - 6048*D1*Dd*Pk2*f*gd2*s + 672*D1*Dd*Pk2*f*gd2 + 5376*D1*Dd*Pk2*fd*g2*r*s - 3360*D1*Dd*Pk2*fd*g2*r + 8064*D1*Dd*Pk2*fd*g2*s**2 - 8736*D1*Dd*Pk2*fd*g2*s + 2688*D1*Dd*Pk2*fd*g2 - 72*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 36*D1*Dd*Pkdd2*f**2*k1**2*s - 18*D1*Dd*Pkdd2*f**2*k1**2 + 144*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 108*D1*Dd*Pkdd2*f*fd*k1**2*s + 18*D1*Dd*Pkdd2*f*fd*k1**2 + 3264*D1*Ddd*K*Pk2*f**2*r*s - 816*D1*Ddd*K*Pk2*f**2*r + 2064*D1*Ddd*K*Pk2*f**2*s**2 - 2664*D1*Ddd*K*Pk2*f**2*s + 516*D1*Ddd*K*Pk2*f**2 - 36*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 18*D1*Ddd*K*Pkdd2*f**2*k1**2*s - 9*D1*Ddd*K*Pkdd2*f**2*k1**2 - 3200*D1*Ddd*Pk2*f**3*r*s + 800*D1*Ddd*Pk2*f**3*r - 2400*D1*Ddd*Pk2*f**3*s**2 + 2800*D1*Ddd*Pk2*f**3*s - 600*D1*Ddd*Pk2*f**3 - 4992*D1*Ddd*Pk2*f**2*r*s + 1248*D1*Ddd*Pk2*f**2*r - 4176*D1*Ddd*Pk2*f**2*s**2 + 4584*D1*Ddd*Pk2*f**2*s - 1044*D1*Ddd*Pk2*f**2 + 2688*D1*Ddd*Pk2*f*g2*r*s - 672*D1*Ddd*Pk2*f*g2*r + 4032*D1*Ddd*Pk2*f*g2*s**2 - 3360*D1*Ddd*Pk2*f*g2*s + 1008*D1*Ddd*Pk2*f*g2 + 36*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Ddd*Pkdd2*f**2*k1**2*s + 9*D1*Ddd*Pkdd2*f**2*k1**2 + 336*D1*Pk2*bd1*(K - 1)*(D1*(f*(6*s**2 + s*(4*r - 4) + 1) + fd*(r*(2 - 4*s) - 6*s**2 + 6*s - 1)) - 2*Dd*f*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) + 9792*Dd**2*K*Pk2*f**2*r*s - 2448*Dd**2*K*Pk2*f**2*r + 6192*Dd**2*K*Pk2*f**2*s**2 - 7992*Dd**2*K*Pk2*f**2*s + 1632*Dd**2*K*Pk2*f**2 - 108*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 54*Dd**2*K*Pkdd2*f**2*k1**2*s - 9600*Dd**2*Pk2*f**3*r*s + 2400*Dd**2*Pk2*f**3*r - 7200*Dd**2*Pk2*f**3*s**2 + 8400*Dd**2*Pk2*f**3*s - 1600*Dd**2*Pk2*f**3 - 14976*Dd**2*Pk2*f**2*r*s + 3744*Dd**2*Pk2*f**2*r - 12528*Dd**2*Pk2*f**2*s**2 + 13752*Dd**2*Pk2*f**2*s - 2496*Dd**2*Pk2*f**2 + 8064*Dd**2*Pk2*f*g2*r*s - 2016*Dd**2*Pk2*f*g2*r + 12096*Dd**2*Pk2*f*g2*s**2 - 10080*Dd**2*Pk2*f*g2*s + 1344*Dd**2*Pk2*f*g2 + 108*Dd**2*Pkdd2*f**2*k1**2*s**2 - 54*Dd**2*Pkdd2*f**2*k1**2*s))/(6930*d**2*k3**4) + D1**2*Pk3*ct**4*k1**2*(-1260*C*D1**2*Pk2*bdd1*f**2*r**2 - 4824*C*D1**2*Pk2*bdd1*f**2*r*s + 3024*C*D1**2*Pk2*bdd1*f**2*r - 2520*C*D1**2*Pk2*bdd1*f**2*s**2 + 3960*C*D1**2*Pk2*bdd1*f**2*s - 1980*C*D1**2*Pk2*bdd1*f**2 - 5916*C*D1**2*Pk2*f**2*fd*r**2 - 10008*C*D1**2*Pk2*f**2*fd*r*s + 7280*C*D1**2*Pk2*f**2*fd*r + 18444*C*D1**2*Pk2*f**2*fd*s**2 - 8960*C*D1**2*Pk2*f**2*fd*s + 4176*C*D1**2*Pk2*f**2*fd + 4416*C*D1**2*Pk2*f**2*fdd*r**2 + 8568*C*D1**2*Pk2*f**2*fdd*r*s - 5800*C*D1**2*Pk2*f**2*fdd*r - 14244*C*D1**2*Pk2*f**2*fdd*s**2 + 6640*C*D1**2*Pk2*f**2*fdd*s - 3276*C*D1**2*Pk2*f**2*fdd + 8832*C*D1**2*Pk2*f*fd**2*r**2 + 17136*C*D1**2*Pk2*f*fd**2*r*s - 11600*C*D1**2*Pk2*f*fd**2*r - 28488*C*D1**2*Pk2*f*fd**2*s**2 + 13280*C*D1**2*Pk2*f*fd**2*s + 2856*C*D1**2*Pk2*f*fd**2 + 90*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 180*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 90*C*D1**2*Pkdd2*bdd1*f**2*k1**2 + 270*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 180*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 90*C*D1**2*Pkdd2*f**2*fd*k1**2 - 7888*C*D1*Dd*Pk2*f**3*r**2 - 13344*C*D1*Dd*Pk2*f**3*r*s + 11224*C*D1*Dd*Pk2*f**3*r + 24592*C*D1*Dd*Pk2*f**3*s**2 - 5624*C*D1*Dd*Pk2*f**3*s + 2204*C*D1*Dd*Pk2*f**3 + 35328*C*D1*Dd*Pk2*f**2*fd*r**2 + 68544*C*D1*Dd*Pk2*f**2*fd*r*s - 49432*C*D1*Dd*Pk2*f**2*fd*r - 113952*C*D1*Dd*Pk2*f**2*fd*s**2 + 37912*C*D1*Dd*Pk2*f**2*fd*s + 4960*C*D1*Dd*Pk2*f**2*fd + 360*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 180*C*D1*Dd*Pkdd2*f**3*k1**2*s + 90*C*D1*Dd*Pkdd2*f**3*k1**2 + 5888*C*D1*Ddd*Pk2*f**3*r**2 + 11424*C*D1*Ddd*Pk2*f**3*r*s - 8744*C*D1*Ddd*Pk2*f**3*r - 18992*C*D1*Ddd*Pk2*f**3*s**2 + 3784*C*D1*Ddd*Pk2*f**3*s - 1804*C*D1*Ddd*Pk2*f**3 + 17664*C*Dd**2*Pk2*f**3*r**2 + 34272*C*Dd**2*Pk2*f**3*r*s - 26232*C*Dd**2*Pk2*f**3*r - 56976*C*Dd**2*Pk2*f**3*s**2 + 11352*C*Dd**2*Pk2*f**3*s + 8656*C*Dd**2*Pk2*f**3 + 804*D1**2*K*Pk2*bdd1*f**2*r**2 + 1692*D1**2*K*Pk2*bdd1*f**2*r*s - 1608*D1**2*K*Pk2*bdd1*f**2*r - 2970*D1**2*K*Pk2*bdd1*f**2*s**2 - 1692*D1**2*K*Pk2*bdd1*f**2*s + 804*D1**2*K*Pk2*bdd1*f**2 + 2304*D1**2*Pk2*b2*f*fd*r*s - 1152*D1**2*Pk2*b2*f*fd*r + 2304*D1**2*Pk2*b2*f*fd*s**2 - 2304*D1**2*Pk2*b2*f*fd*s + 1152*D1**2*Pk2*b2*f*fd - 2160*D1**2*Pk2*b2*f*fdd*r*s + 1080*D1**2*Pk2*b2*f*fdd*r - 2160*D1**2*Pk2*b2*f*fdd*s**2 + 2160*D1**2*Pk2*b2*f*fdd*s - 1080*D1**2*Pk2*b2*f*fdd - 2160*D1**2*Pk2*b2*fd**2*r*s + 1080*D1**2*Pk2*b2*fd**2*r - 2160*D1**2*Pk2*b2*fd**2*s**2 + 2160*D1**2*Pk2*b2*fd**2*s + 1152*D1**2*Pk2*bd2*f**2*r*s + 1152*D1**2*Pk2*bd2*f**2*s**2 - 1152*D1**2*Pk2*bd2*f**2*s - 4320*D1**2*Pk2*bd2*f*fd*r*s + 1080*D1**2*Pk2*bd2*f*fd*r - 4320*D1**2*Pk2*bd2*f*fd*s**2 + 4320*D1**2*Pk2*bd2*f*fd*s - 1080*D1**2*Pk2*bd2*f*fd - 2430*D1**2*Pk2*bdd1*f**3*r**2 - 5760*D1**2*Pk2*bdd1*f**3*r*s + 4500*D1**2*Pk2*bdd1*f**3*r - 1710*D1**2*Pk2*bdd1*f**3*s**2 + 3960*D1**2*Pk2*bdd1*f**3*s - 2250*D1**2*Pk2*bdd1*f**3 - 1344*D1**2*Pk2*bdd1*f**2*r**2 - 2304*D1**2*Pk2*bdd1*f**2*r*s + 1104*D1**2*Pk2*bdd1*f**2*r + 414*D1**2*Pk2*bdd1*f**2*s**2 + 2448*D1**2*Pk2*bdd1*f**2*s + 456*D1**2*Pk2*bdd1*f**2 + 1428*D1**2*Pk2*bdd1*f*g2*r**2 + 6216*D1**2*Pk2*bdd1*f*g2*r*s - 3696*D1**2*Pk2*bdd1*f*g2*r + 4200*D1**2*Pk2*bdd1*f*g2*s**2 - 6216*D1**2*Pk2*bdd1*f*g2*s + 3108*D1**2*Pk2*bdd1*f*g2 - 1080*D1**2*Pk2*bdd2*f**2*r*s - 1080*D1**2*Pk2*bdd2*f**2*s**2 + 1080*D1**2*Pk2*bdd2*f**2*s - 6480*D1**2*Pk2*f**3*fd*r**2 - 16200*D1**2*Pk2*f**3*fd*r*s + 10530*D1**2*Pk2*f**3*fd*r - 5400*D1**2*Pk2*f**3*fd*s**2 + 10800*D1**2*Pk2*f**3*fd*s - 4590*D1**2*Pk2*f**3*fd + 6480*D1**2*Pk2*f**3*fdd*r**2 + 16200*D1**2*Pk2*f**3*fdd*r*s - 10530*D1**2*Pk2*f**3*fdd*r + 5400*D1**2*Pk2*f**3*fdd*s**2 - 10800*D1**2*Pk2*f**3*fdd*s + 4590*D1**2*Pk2*f**3*fdd + 19440*D1**2*Pk2*f**2*fd**2*r**2 + 48600*D1**2*Pk2*f**2*fd**2*r*s - 31590*D1**2*Pk2*f**2*fd**2*r + 16200*D1**2*Pk2*f**2*fd**2*s**2 - 32400*D1**2*Pk2*f**2*fd**2*s + 11340*D1**2*Pk2*f**2*fd**2 + 10416*D1**2*Pk2*f**2*fd*r**2 + 29868*D1**2*Pk2*f**2*fd*r*s - 16900*D1**2*Pk2*f**2*fd*r - 24*D1**2*Pk2*f**2*fd*s**2 - 9940*D1**2*Pk2*f**2*fd*s + 3464*D1**2*Pk2*f**2*fd - 9096*D1**2*Pk2*f**2*fdd*r**2 - 24708*D1**2*Pk2*f**2*fdd*r*s + 14300*D1**2*Pk2*f**2*fdd*r - 96*D1**2*Pk2*f**2*fdd*s**2 + 8300*D1**2*Pk2*f**2*fdd*s - 3064*D1**2*Pk2*f**2*fdd + 1788*D1**2*Pk2*f**2*gd2*r**2 + 4248*D1**2*Pk2*f**2*gd2*r*s - 3576*D1**2*Pk2*f**2*gd2*r - 7596*D1**2*Pk2*f**2*gd2*s**2 - 4248*D1**2*Pk2*f**2*gd2*s + 1788*D1**2*Pk2*f**2*gd2 - 1608*D1**2*Pk2*f**2*gdd2*r**2 - 3384*D1**2*Pk2*f**2*gdd2*r*s + 3216*D1**2*Pk2*f**2*gdd2*r + 5940*D1**2*Pk2*f**2*gdd2*s**2 + 3384*D1**2*Pk2*f**2*gdd2*s - 1608*D1**2*Pk2*f**2*gdd2 - 18192*D1**2*Pk2*f*fd**2*r**2 - 49416*D1**2*Pk2*f*fd**2*r*s + 28600*D1**2*Pk2*f*fd**2*r - 192*D1**2*Pk2*f*fd**2*s**2 + 16600*D1**2*Pk2*f*fd**2*s - 8236*D1**2*Pk2*f*fd**2 + 3576*D1**2*Pk2*f*fd*g2*r**2 + 8496*D1**2*Pk2*f*fd*g2*r*s - 4248*D1**2*Pk2*f*fd*g2*r - 15192*D1**2*Pk2*f*fd*g2*s**2 + 15192*D1**2*Pk2*f*fd*g2*s - 7596*D1**2*Pk2*f*fd*g2 - 6432*D1**2*Pk2*f*fd*gd2*r**2 - 13536*D1**2*Pk2*f*fd*gd2*r*s + 9816*D1**2*Pk2*f*fd*gd2*r + 23760*D1**2*Pk2*f*fd*gd2*s**2 - 5112*D1**2*Pk2*f*fd*gd2*s - 3384*D1**2*Pk2*f*fd*gd2 - 3216*D1**2*Pk2*f*fdd*g2*r**2 - 6768*D1**2*Pk2*f*fdd*g2*r*s + 3384*D1**2*Pk2*f*fdd*g2*r + 11880*D1**2*Pk2*f*fdd*g2*s**2 - 11880*D1**2*Pk2*f*fdd*g2*s + 5940*D1**2*Pk2*f*fdd*g2 - 3216*D1**2*Pk2*fd**2*g2*r**2 - 6768*D1**2*Pk2*fd**2*g2*r*s + 3384*D1**2*Pk2*fd**2*g2*r + 11880*D1**2*Pk2*fd**2*g2*s**2 - 11880*D1**2*Pk2*fd**2*g2*s + 70*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 210*D1**2*Pkdd2*bdd1*f**3*k1**2*s + 105*D1**2*Pkdd2*bdd1*f**3*k1**2 - 90*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 180*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 90*D1**2*Pkdd2*bdd1*f**2*k1**2 - 126*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 + 252*D1**2*Pkdd2*bdd1*f*g2*k1**2*s - 126*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 420*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 210*D1**2*Pkdd2*f**3*fd*k1**2*s + 105*D1**2*Pkdd2*f**3*fd*k1**2 - 270*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 180*D1**2*Pkdd2*f**2*fd*k1**2*s - 90*D1**2*Pkdd2*f**2*fd*k1**2 - 126*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 252*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 252*D1**2*Pkdd2*f*fd*g2*k1**2*s - 126*D1**2*Pkdd2*f*fd*g2*k1**2 + 6*D1**2*bd1**2*(60*Pk2*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 3) - 280*Pk2*g2*(r*(2*s - 1) + s*(2*s - 2)) - 7*f*(2*Pk2*(-24*C*s**2 + 24*C*s + K*(17*r**2 + r*(74*s - 39) + 50*s**2 - 74*s + 22) - 17*r**2 + r*(-24*C*s + 12*C - 98*s + 45) - 74*s**2 + 110*s - 40) + 3*Pkdd2*k1**2*s*(-K*s + K + s - 1))) + 4608*D1*Dd*Pk2*b2*f**2*r*s - 1152*D1*Dd*Pk2*b2*f**2*r + 4608*D1*Dd*Pk2*b2*f**2*s**2 - 4608*D1*Dd*Pk2*b2*f**2*s + 1152*D1*Dd*Pk2*b2*f**2 - 17280*D1*Dd*Pk2*b2*f*fd*r*s + 6480*D1*Dd*Pk2*b2*f*fd*r - 17280*D1*Dd*Pk2*b2*f*fd*s**2 + 17280*D1*Dd*Pk2*b2*f*fd*s - 4320*D1*Dd*Pk2*b2*f*fd - 8640*D1*Dd*Pk2*bd2*f**2*r*s + 1080*D1*Dd*Pk2*bd2*f**2*r - 8640*D1*Dd*Pk2*bd2*f**2*s**2 + 8640*D1*Dd*Pk2*bd2*f**2*s - 1080*D1*Dd*Pk2*bd2*f**2 - 6480*D1*Dd*Pk2*f**4*r**2 - 16200*D1*Dd*Pk2*f**4*r*s + 10530*D1*Dd*Pk2*f**4*r - 5400*D1*Dd*Pk2*f**4*s**2 + 10800*D1*Dd*Pk2*f**4*s - 4590*D1*Dd*Pk2*f**4 + 51840*D1*Dd*Pk2*f**3*fd*r**2 + 129600*D1*Dd*Pk2*f**3*fd*r*s - 84240*D1*Dd*Pk2*f**3*fd*r + 43200*D1*Dd*Pk2*f**3*fd*s**2 - 86400*D1*Dd*Pk2*f**3*fd*s + 31860*D1*Dd*Pk2*f**3*fd + 13888*D1*Dd*Pk2*f**3*r**2 + 39824*D1*Dd*Pk2*f**3*r*s - 23844*D1*Dd*Pk2*f**3*r - 32*D1*Dd*Pk2*f**3*s**2 - 19896*D1*Dd*Pk2*f**3*s + 6936*D1*Dd*Pk2*f**3 - 72768*D1*Dd*Pk2*f**2*fd*r**2 - 197664*D1*Dd*Pk2*f**2*fd*r*s + 118292*D1*Dd*Pk2*f**2*fd*r - 768*D1*Dd*Pk2*f**2*fd*s**2 + 82808*D1*Dd*Pk2*f**2*fd*s - 36900*D1*Dd*Pk2*f**2*fd + 7152*D1*Dd*Pk2*f**2*g2*r**2 + 16992*D1*Dd*Pk2*f**2*g2*r*s - 11400*D1*Dd*Pk2*f**2*g2*r - 30384*D1*Dd*Pk2*f**2*g2*s**2 + 6696*D1*Dd*Pk2*f**2*g2*s - 4020*D1*Dd*Pk2*f**2*g2 - 12864*D1*Dd*Pk2*f**2*gd2*r**2 - 27072*D1*Dd*Pk2*f**2*gd2*r*s + 22680*D1*Dd*Pk2*f**2*gd2*r + 47520*D1*Dd*Pk2*f**2*gd2*s**2 + 8424*D1*Dd*Pk2*f**2*gd2*s - 9816*D1*Dd*Pk2*f**2*gd2 - 25728*D1*Dd*Pk2*f*fd*g2*r**2 - 54144*D1*Dd*Pk2*f*fd*g2*r*s + 33168*D1*Dd*Pk2*f*fd*g2*r + 95040*D1*Dd*Pk2*f*fd*g2*s**2 - 57744*D1*Dd*Pk2*f*fd*g2*s + 5112*D1*Dd*Pk2*f*fd*g2 + 420*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 210*D1*Dd*Pkdd2*f**4*k1**2*s + 105*D1*Dd*Pkdd2*f**4*k1**2 - 360*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 180*D1*Dd*Pkdd2*f**3*k1**2*s - 90*D1*Dd*Pkdd2*f**3*k1**2 - 504*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 252*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 126*D1*Dd*Pkdd2*f**2*g2*k1**2 - 4320*D1*Ddd*Pk2*b2*f**2*r*s + 1080*D1*Ddd*Pk2*b2*f**2*r - 4320*D1*Ddd*Pk2*b2*f**2*s**2 + 4320*D1*Ddd*Pk2*b2*f**2*s - 1080*D1*Ddd*Pk2*b2*f**2 + 6480*D1*Ddd*Pk2*f**4*r**2 + 16200*D1*Ddd*Pk2*f**4*r*s - 10530*D1*Ddd*Pk2*f**4*r + 5400*D1*Ddd*Pk2*f**4*s**2 - 10800*D1*Ddd*Pk2*f**4*s + 4590*D1*Ddd*Pk2*f**4 - 12128*D1*Ddd*Pk2*f**3*r**2 - 32944*D1*Ddd*Pk2*f**3*r*s + 20364*D1*Ddd*Pk2*f**3*r - 128*D1*Ddd*Pk2*f**3*s**2 + 16536*D1*Ddd*Pk2*f**3*s - 6096*D1*Ddd*Pk2*f**3 - 6432*D1*Ddd*Pk2*f**2*g2*r**2 - 13536*D1*Ddd*Pk2*f**2*g2*r*s + 9816*D1*Ddd*Pk2*f**2*g2*r + 23760*D1*Ddd*Pk2*f**2*g2*s**2 - 5112*D1*Ddd*Pk2*f**2*g2*s + 2724*D1*Ddd*Pk2*f**2*g2 + D1*bd1*(D1*(10*f**3*(9*Pk2*(21*r**2 + r*(76*s - 42) + 33*s**2 - 56*s + 23) - 7*Pkdd2*k1**2*(2*s**2 - 6*s + 3)) + f**2*(6*Pk2*(6*C*(21*r**2 + 2*r*(113*s - 70) + 126*s**2 - 122*s + 61) - 149*K*r**2 - 354*K*r*s + 298*K*r + 633*K*s**2 + 354*K*s - 149*K - 30*fd*(81*r**2 + 8*r*(24*s - 17) + 57*s**2 - 127*s + 47) + 245*r**2 + 12*r*s + 374*r - 327*s**2 - 396*s - 271) + Pkdd2*k1**2*(-180*C*(s - 1)**2 + s**2*(63*K + 420*fd + 117) - s*(560*fd + 360) + 180)) - 12*f*(-7*Pk2*g2*(r**2 + r*(68 - 118*s) - 90*s**2 + 78*s - 39) - 14*Pk2*gd2*(17*r**2 + r*(74*s - 39) + 50*s**2 - 74*s + 22) - 21*Pkdd2*g2*k1**2*(s - 1)**2 + 21*Pkdd2*gd2*k1**2*s*(s - 1) + fd*(Pk2*(12*C*(35*r**2 + 2*r*(67*s - 36) + 70*s**2 - 96*s + 21) - K*(268*r**2 + 564*r*s - 409*r - 990*s**2 + 213*s + 141) + 448*r**2 + 768*r*s - 508*r - 138*s**2 - 327*s + 372) + Pkdd2*k1**2*s*(30 - 30*C)*(s - 1))) + 84*fd*g2*(2*Pk2*(17*r**2 + 37*r*(2*s - 1) + s*(50*s - 50)) - 3*Pkdd2*k1**2*s*(s - 1))) - 2*Dd*f*(90*Pk2*f**2*(108*r**2 + 2*r*(128*s - 93) + 76*s**2 - 171*s + 72) + 6*Pk2*f*(6*C*(140*r**2 + r*(536*s - 305) + 280*s**2 - 424*s + 139) + K*(-536*r**2 - 1128*r*s + 945*r + 1980*s**2 + 351*s - 409) + 896*r**2 + 1536*r*s - 1008*r - 276*s**2 - 1131*s + 388) - 84*Pk2*g2*(68*r**2 + r*(296*s - 159) + 200*s**2 - 272*s + 81) - 35*Pkdd2*f**2*k1**2*(8*s**2 - 14*s + 3) + Pkdd2*f*k1**2*(90 - 90*C)*(4*s**2 - 5*s + 1) + 126*Pkdd2*g2*k1**2*(4*s**2 - 5*s + 1))) - 12960*Dd**2*Pk2*b2*f**2*r*s + 3240*Dd**2*Pk2*b2*f**2*r - 12960*Dd**2*Pk2*b2*f**2*s**2 + 12960*Dd**2*Pk2*b2*f**2*s - 2160*Dd**2*Pk2*b2*f**2 + 19440*Dd**2*Pk2*f**4*r**2 + 48600*Dd**2*Pk2*f**4*r*s - 31590*Dd**2*Pk2*f**4*r + 16200*Dd**2*Pk2*f**4*s**2 - 32400*Dd**2*Pk2*f**4*s + 11340*Dd**2*Pk2*f**4 - 36384*Dd**2*Pk2*f**3*r**2 - 98832*Dd**2*Pk2*f**3*r*s + 61092*Dd**2*Pk2*f**3*r - 384*Dd**2*Pk2*f**3*s**2 + 49608*Dd**2*Pk2*f**3*s - 22536*Dd**2*Pk2*f**3 - 19296*Dd**2*Pk2*f**2*g2*r**2 - 40608*Dd**2*Pk2*f**2*g2*r*s + 29448*Dd**2*Pk2*f**2*g2*r + 71280*Dd**2*Pk2*f**2*g2*s**2 - 15336*Dd**2*Pk2*f**2*g2*s - 9984*Dd**2*Pk2*f**2*g2 - 840*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) - 3*b1**2*(672*C*D1**2*Pk2*fd*r*s + 672*C*D1**2*Pk2*fd*s**2 - 672*C*D1**2*Pk2*fd*s - 336*C*D1**2*Pk2*fdd*r*s - 336*C*D1**2*Pk2*fdd*s**2 + 336*C*D1**2*Pk2*fdd*s + 2688*C*D1*Dd*Pk2*f*r*s - 672*C*D1*Dd*Pk2*f*r + 2688*C*D1*Dd*Pk2*f*s**2 - 2688*C*D1*Dd*Pk2*f*s + 672*C*D1*Dd*Pk2*f - 2688*C*D1*Dd*Pk2*fd*r*s + 336*C*D1*Dd*Pk2*fd*r - 2688*C*D1*Dd*Pk2*fd*s**2 + 2688*C*D1*Dd*Pk2*fd*s - 336*C*D1*Dd*Pk2*fd - 1344*C*D1*Ddd*Pk2*f*r*s + 336*C*D1*Ddd*Pk2*f*r - 1344*C*D1*Ddd*Pk2*f*s**2 + 1344*C*D1*Ddd*Pk2*f*s - 336*C*D1*Ddd*Pk2*f - 4032*C*Dd**2*Pk2*f*r*s + 1008*C*Dd**2*Pk2*f*r - 4032*C*Dd**2*Pk2*f*s**2 + 4032*C*Dd**2*Pk2*f*s - 672*C*Dd**2*Pk2*f + 14*D1**2*K*Pk2*fd*r**2 - 1652*D1**2*K*Pk2*fd*r*s + 700*D1**2*K*Pk2*fd*r - 1260*D1**2*K*Pk2*fd*s**2 + 1428*D1**2*K*Pk2*fd*s - 714*D1**2*K*Pk2*fd + 238*D1**2*K*Pk2*fdd*r**2 + 1036*D1**2*K*Pk2*fdd*r*s - 420*D1**2*K*Pk2*fdd*r + 700*D1**2*K*Pk2*fdd*s**2 - 364*D1**2*K*Pk2*fdd*s + 182*D1**2*K*Pk2*fdd + 42*D1**2*K*Pkdd2*fd*k1**2*s**2 - 21*D1**2*K*Pkdd2*fdd*k1**2*s**2 - 280*D1**2*Pk2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 960*D1**2*Pk2*f*fd*r*s + 312*D1**2*Pk2*f*fd*r + 960*D1**2*Pk2*f*fd*s**2 - 96*D1**2*Pk2*f*fd*s - 312*D1**2*Pk2*f*fd - 480*D1**2*Pk2*f*fdd*r*s - 240*D1**2*Pk2*f*fdd*r - 480*D1**2*Pk2*f*fdd*s**2 - 120*D1**2*Pk2*f*fdd*s + 240*D1**2*Pk2*f*fdd - 480*D1**2*Pk2*fd**2*r*s - 240*D1**2*Pk2*fd**2*r - 480*D1**2*Pk2*fd**2*s**2 - 120*D1**2*Pk2*fd**2*s + 240*D1**2*Pk2*fd**2 - 14*D1**2*Pk2*fd*r**2 + 1764*D1**2*Pk2*fd*r*s - 756*D1**2*Pk2*fd*r + 1372*D1**2*Pk2*fd*s**2 - 868*D1**2*Pk2*fd*s + 770*D1**2*Pk2*fd - 238*D1**2*Pk2*fdd*r**2 - 1372*D1**2*Pk2*fdd*r*s + 588*D1**2*Pk2*fdd*r - 1036*D1**2*Pk2*fdd*s**2 + 364*D1**2*Pk2*fdd*s - 350*D1**2*Pk2*fdd - 1120*D1**2*Pk2*gd2*r*s - 1120*D1**2*Pk2*gd2*s**2 + 1120*D1**2*Pk2*gd2*s + 560*D1**2*Pk2*gdd2*r*s + 560*D1**2*Pk2*gdd2*s**2 - 560*D1**2*Pk2*gdd2*s - 42*D1**2*Pkdd2*fd*k1**2*s**2 + 21*D1**2*Pkdd2*fdd*k1**2*s**2 + 56*D1*Dd*K*Pk2*f*r**2 - 6608*D1*Dd*K*Pk2*f*r*s + 1596*D1*Dd*K*Pk2*f*r - 5040*D1*Dd*K*Pk2*f*s**2 + 5824*D1*Dd*K*Pk2*f*s - 1232*D1*Dd*K*Pk2*f + 1904*D1*Dd*K*Pk2*fd*r**2 + 8288*D1*Dd*K*Pk2*fd*r*s - 3668*D1*Dd*K*Pk2*fd*r + 5600*D1*Dd*K*Pk2*fd*s**2 - 4928*D1*Dd*K*Pk2*fd*s + 1204*D1*Dd*K*Pk2*fd + 168*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 84*D1*Dd*K*Pkdd2*f*k1**2*s + 42*D1*Dd*K*Pkdd2*f*k1**2 - 168*D1*Dd*K*Pkdd2*fd*k1**2*s**2 + 42*D1*Dd*K*Pkdd2*fd*k1**2*s + 1920*D1*Dd*Pk2*f**2*r*s - 480*D1*Dd*Pk2*f**2*r + 1920*D1*Dd*Pk2*f**2*s**2 - 1920*D1*Dd*Pk2*f**2*s + 480*D1*Dd*Pk2*f**2 - 3840*D1*Dd*Pk2*f*fd*r*s - 480*D1*Dd*Pk2*f*fd*r - 3840*D1*Dd*Pk2*f*fd*s**2 + 1440*D1*Dd*Pk2*f*fd*s + 600*D1*Dd*Pk2*f*fd - 56*D1*Dd*Pk2*f*r**2 + 7056*D1*Dd*Pk2*f*r*s - 1708*D1*Dd*Pk2*f*r + 5488*D1*Dd*Pk2*f*s**2 - 6272*D1*Dd*Pk2*f*s + 1344*D1*Dd*Pk2*f - 1904*D1*Dd*Pk2*fd*r**2 - 10976*D1*Dd*Pk2*fd*r*s + 4676*D1*Dd*Pk2*fd*r - 8288*D1*Dd*Pk2*fd*s**2 + 6272*D1*Dd*Pk2*fd*s - 1540*D1*Dd*Pk2*fd - 4480*D1*Dd*Pk2*g2*r*s + 1120*D1*Dd*Pk2*g2*r - 4480*D1*Dd*Pk2*g2*s**2 + 4480*D1*Dd*Pk2*g2*s - 1120*D1*Dd*Pk2*g2 + 4480*D1*Dd*Pk2*gd2*r*s - 560*D1*Dd*Pk2*gd2*r + 4480*D1*Dd*Pk2*gd2*s**2 - 4480*D1*Dd*Pk2*gd2*s + 560*D1*Dd*Pk2*gd2 - 168*D1*Dd*Pkdd2*f*k1**2*s**2 + 84*D1*Dd*Pkdd2*f*k1**2*s - 42*D1*Dd*Pkdd2*f*k1**2 + 168*D1*Dd*Pkdd2*fd*k1**2*s**2 - 42*D1*Dd*Pkdd2*fd*k1**2*s + 952*D1*Ddd*K*Pk2*f*r**2 + 4144*D1*Ddd*K*Pk2*f*r*s - 1988*D1*Ddd*K*Pk2*f*r + 2800*D1*Ddd*K*Pk2*f*s**2 - 3472*D1*Ddd*K*Pk2*f*s + 1176*D1*Ddd*K*Pk2*f - 84*D1*Ddd*K*Pkdd2*f*k1**2*s**2 + 42*D1*Ddd*K*Pkdd2*f*k1**2*s - 21*D1*Ddd*K*Pkdd2*f*k1**2 - 960*D1*Ddd*Pk2*f**2*r*s + 240*D1*Ddd*Pk2*f**2*r - 960*D1*Ddd*Pk2*f**2*s**2 + 960*D1*Ddd*Pk2*f**2*s - 240*D1*Ddd*Pk2*f**2 - 952*D1*Ddd*Pk2*f*r**2 - 5488*D1*Ddd*Pk2*f*r*s + 2324*D1*Ddd*Pk2*f*r - 4144*D1*Ddd*Pk2*f*s**2 + 4816*D1*Ddd*Pk2*f*s - 1512*D1*Ddd*Pk2*f + 2240*D1*Ddd*Pk2*g2*r*s - 560*D1*Ddd*Pk2*g2*r + 2240*D1*Ddd*Pk2*g2*s**2 - 2240*D1*Ddd*Pk2*g2*s + 560*D1*Ddd*Pk2*g2 + 84*D1*Ddd*Pkdd2*f*k1**2*s**2 - 42*D1*Ddd*Pkdd2*f*k1**2*s + 21*D1*Ddd*Pkdd2*f*k1**2 + 280*D1*Pk2*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 2856*Dd**2*K*Pk2*f*r**2 + 12432*Dd**2*K*Pk2*f*r*s - 5964*Dd**2*K*Pk2*f*r + 8400*Dd**2*K*Pk2*f*s**2 - 10416*Dd**2*K*Pk2*f*s + 2548*Dd**2*K*Pk2*f - 252*Dd**2*K*Pkdd2*f*k1**2*s**2 + 126*Dd**2*K*Pkdd2*f*k1**2*s - 2880*Dd**2*Pk2*f**2*r*s + 720*Dd**2*Pk2*f**2*r - 2880*Dd**2*Pk2*f**2*s**2 + 2880*Dd**2*Pk2*f**2*s - 480*Dd**2*Pk2*f**2 - 2856*Dd**2*Pk2*f*r**2 - 16464*Dd**2*Pk2*f*r*s + 6972*Dd**2*Pk2*f*r - 12432*Dd**2*Pk2*f*s**2 + 14448*Dd**2*Pk2*f*s - 3220*Dd**2*Pk2*f + 6720*Dd**2*Pk2*g2*r*s - 1680*Dd**2*Pk2*g2*r + 6720*Dd**2*Pk2*g2*s**2 - 6720*Dd**2*Pk2*g2*s + 1120*Dd**2*Pk2*g2 + 252*Dd**2*Pkdd2*f*k1**2*s**2 - 126*Dd**2*Pkdd2*f*k1**2*s) + b1*(1512*C*D1**2*Pk2*f*fd*r**2 + 16272*C*D1**2*Pk2*f*fd*r*s - 4608*C*D1**2*Pk2*f*fd*r + 9072*C*D1**2*Pk2*f*fd*s**2 - 12816*C*D1**2*Pk2*f*fd*s + 3096*C*D1**2*Pk2*f*fd - 2520*C*D1**2*Pk2*f*fdd*r**2 - 9648*C*D1**2*Pk2*f*fdd*r*s + 4320*C*D1**2*Pk2*f*fdd*r - 5040*C*D1**2*Pk2*f*fdd*s**2 + 5904*C*D1**2*Pk2*f*fdd*s - 1800*C*D1**2*Pk2*f*fdd - 2520*C*D1**2*Pk2*fd**2*r**2 - 9648*C*D1**2*Pk2*fd**2*r*s + 4320*C*D1**2*Pk2*fd**2*r - 5040*C*D1**2*Pk2*fd**2*s**2 + 5904*C*D1**2*Pk2*fd**2*s - 1800*C*D1**2*Pk2*fd**2 - 360*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 180*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 180*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 3024*C*D1*Dd*Pk2*f**2*r**2 + 32544*C*D1*Dd*Pk2*f**2*r*s - 11160*C*D1*Dd*Pk2*f**2*r + 18144*C*D1*Dd*Pk2*f**2*s**2 - 25344*C*D1*Dd*Pk2*f**2*s + 6048*C*D1*Dd*Pk2*f**2 - 20160*C*D1*Dd*Pk2*f*fd*r**2 - 77184*C*D1*Dd*Pk2*f*fd*r*s + 37008*C*D1*Dd*Pk2*f*fd*r - 40320*C*D1*Dd*Pk2*f*fd*s**2 + 52992*C*D1*Dd*Pk2*f*fd*s - 14544*C*D1*Dd*Pk2*f*fd - 720*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 360*C*D1*Dd*Pkdd2*f**2*k1**2*s - 180*C*D1*Dd*Pkdd2*f**2*k1**2 + 1440*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 360*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 5040*C*D1*Ddd*Pk2*f**2*r**2 - 19296*C*D1*Ddd*Pk2*f**2*r*s + 9864*C*D1*Ddd*Pk2*f**2*r - 10080*C*D1*Ddd*Pk2*f**2*s**2 + 14688*C*D1*Ddd*Pk2*f**2*s - 5040*C*D1*Ddd*Pk2*f**2 + 360*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 180*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 90*C*D1*Ddd*Pkdd2*f**2*k1**2 - 15120*C*Dd**2*Pk2*f**2*r**2 - 57888*C*Dd**2*Pk2*f**2*r*s + 29592*C*Dd**2*Pk2*f**2*r - 30240*C*Dd**2*Pk2*f**2*s**2 + 44064*C*Dd**2*Pk2*f**2*s - 12168*C*Dd**2*Pk2*f**2 + 1080*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 540*C*Dd**2*Pkdd2*f**2*k1**2*s - 1788*D1**2*K*Pk2*f*fd*r**2 - 4248*D1**2*K*Pk2*f*fd*r*s + 2124*D1**2*K*Pk2*f*fd*r + 7596*D1**2*K*Pk2*f*fd*s**2 - 7596*D1**2*K*Pk2*f*fd*s + 3798*D1**2*K*Pk2*f*fd + 1608*D1**2*K*Pk2*f*fdd*r**2 + 3384*D1**2*K*Pk2*f*fdd*r*s - 1692*D1**2*K*Pk2*f*fdd*r - 5940*D1**2*K*Pk2*f*fdd*s**2 + 5940*D1**2*K*Pk2*f*fdd*s - 2970*D1**2*K*Pk2*f*fdd + 1608*D1**2*K*Pk2*fd**2*r**2 + 3384*D1**2*K*Pk2*fd**2*r*s - 1692*D1**2*K*Pk2*fd**2*r - 5940*D1**2*K*Pk2*fd**2*s**2 + 5940*D1**2*K*Pk2*fd**2*s + 126*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 126*D1**2*K*Pkdd2*f*fd*k1**2*s + 63*D1**2*K*Pkdd2*f*fd*k1**2 + 840*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 5670*D1**2*Pk2*f**2*fd*r**2 + 20520*D1**2*Pk2*f**2*fd*r*s - 10620*D1**2*Pk2*f**2*fd*r + 8910*D1**2*Pk2*f**2*fd*s**2 - 14580*D1**2*Pk2*f**2*fd*s + 4680*D1**2*Pk2*f**2*fd - 7290*D1**2*Pk2*f**2*fdd*r**2 - 17280*D1**2*Pk2*f**2*fdd*r*s + 10980*D1**2*Pk2*f**2*fdd*r - 5130*D1**2*Pk2*f**2*fdd*s**2 + 10980*D1**2*Pk2*f**2*fdd*s - 4320*D1**2*Pk2*f**2*fdd - 14580*D1**2*Pk2*f*fd**2*r**2 - 34560*D1**2*Pk2*f*fd**2*r*s + 21960*D1**2*Pk2*f*fd**2*r - 10260*D1**2*Pk2*f*fd**2*s**2 + 21960*D1**2*Pk2*f*fd**2*s - 7920*D1**2*Pk2*f*fd**2 + 2940*D1**2*Pk2*f*fd*r**2 + 144*D1**2*Pk2*f*fd*r*s - 5256*D1**2*Pk2*f*fd*r - 3924*D1**2*Pk2*f*fd*s**2 + 6228*D1**2*Pk2*f*fd*s + 1134*D1**2*Pk2*f*fd - 2688*D1**2*Pk2*f*fdd*r**2 - 4608*D1**2*Pk2*f*fdd*r*s + 3888*D1**2*Pk2*f*fdd*r + 828*D1**2*Pk2*f*fdd*s**2 - 972*D1**2*Pk2*f*fdd*s - 1386*D1**2*Pk2*f*fdd + 84*D1**2*Pk2*f*gd2*r**2 - 9912*D1**2*Pk2*f*gd2*r*s - 168*D1**2*Pk2*f*gd2*r - 7560*D1**2*Pk2*f*gd2*s**2 + 9912*D1**2*Pk2*f*gd2*s + 84*D1**2*Pk2*f*gd2 + 1428*D1**2*Pk2*f*gdd2*r**2 + 6216*D1**2*Pk2*f*gdd2*r*s - 2856*D1**2*Pk2*f*gdd2*r + 4200*D1**2*Pk2*f*gdd2*s**2 - 6216*D1**2*Pk2*f*gdd2*s + 1428*D1**2*Pk2*f*gdd2 - 2688*D1**2*Pk2*fd**2*r**2 - 4608*D1**2*Pk2*fd**2*r*s + 3888*D1**2*Pk2*fd**2*r + 828*D1**2*Pk2*fd**2*s**2 - 972*D1**2*Pk2*fd**2*s + 2160*D1**2*Pk2*fd**2 + 84*D1**2*Pk2*fd*g2*r**2 - 9912*D1**2*Pk2*fd*g2*r*s + 4200*D1**2*Pk2*fd*g2*r - 7560*D1**2*Pk2*fd*g2*s**2 + 8568*D1**2*Pk2*fd*g2*s - 4284*D1**2*Pk2*fd*g2 + 2856*D1**2*Pk2*fd*gd2*r**2 + 12432*D1**2*Pk2*fd*gd2*r*s - 5376*D1**2*Pk2*fd*gd2*r + 8400*D1**2*Pk2*fd*gd2*s**2 - 8400*D1**2*Pk2*fd*gd2*s + 2520*D1**2*Pk2*fd*gd2 + 1428*D1**2*Pk2*fdd*g2*r**2 + 6216*D1**2*Pk2*fdd*g2*r*s - 2520*D1**2*Pk2*fdd*g2*r + 4200*D1**2*Pk2*fdd*g2*s**2 - 2184*D1**2*Pk2*fdd*g2*s + 1092*D1**2*Pk2*fdd*g2 - 420*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 140*D1**2*Pkdd2*f**2*fd*k1**2*s + 70*D1**2*Pkdd2*f**2*fd*k1**2 + 210*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 70*D1**2*Pkdd2*f**2*fdd*k1**2*s - 35*D1**2*Pkdd2*f**2*fdd*k1**2 + 420*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 140*D1**2*Pkdd2*f*fd**2*k1**2*s + 234*D1**2*Pkdd2*f*fd*k1**2*s**2 + 126*D1**2*Pkdd2*f*fd*k1**2*s - 63*D1**2*Pkdd2*f*fd*k1**2 - 180*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 252*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 126*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 180*D1**2*Pkdd2*fd**2*k1**2*s**2 + 252*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 252*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 126*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + 3*D1**2*bdd1*(120*Pk2*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 4) - 560*Pk2*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 7*f*(4*Pk2*(12*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - K*(17*r**2 + 74*r*s - 39*r + 50*s**2 - 74*s + 27) + 17*r**2 + 98*r*s - 45*r + 74*s**2 - 110*s + 33) + Pkdd2*k1**2*(3*K - 3)*(2*s**2 - 2*s + 1))) - 3576*D1*Dd*K*Pk2*f**2*r**2 - 8496*D1*Dd*K*Pk2*f**2*r*s + 5700*D1*Dd*K*Pk2*f**2*r + 15192*D1*Dd*K*Pk2*f**2*s**2 - 3348*D1*Dd*K*Pk2*f**2*s + 2010*D1*Dd*K*Pk2*f**2 + 12864*D1*Dd*K*Pk2*f*fd*r**2 + 27072*D1*Dd*K*Pk2*f*fd*r*s - 16584*D1*Dd*K*Pk2*f*fd*r - 47520*D1*Dd*K*Pk2*f*fd*s**2 + 28872*D1*Dd*K*Pk2*f*fd*s - 2556*D1*Dd*K*Pk2*f*fd + 252*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 126*D1*Dd*K*Pkdd2*f**2*k1**2*s + 63*D1*Dd*K*Pkdd2*f**2*k1**2 + 7560*D1*Dd*Pk2*f**3*r**2 + 27360*D1*Dd*Pk2*f**3*r*s - 14400*D1*Dd*Pk2*f**3*r + 11880*D1*Dd*Pk2*f**3*s**2 - 19620*D1*Dd*Pk2*f**3*s + 6750*D1*Dd*Pk2*f**3 - 58320*D1*Dd*Pk2*f**2*fd*r**2 - 138240*D1*Dd*Pk2*f**2*fd*r*s + 90360*D1*Dd*Pk2*f**2*fd*r - 41040*D1*Dd*Pk2*f**2*fd*s**2 + 88740*D1*Dd*Pk2*f**2*fd*s - 32940*D1*Dd*Pk2*f**2*fd + 5880*D1*Dd*Pk2*f**2*r**2 + 288*D1*Dd*Pk2*f**2*r*s - 5952*D1*Dd*Pk2*f**2*r - 7848*D1*Dd*Pk2*f**2*s**2 + 3780*D1*Dd*Pk2*f**2*s + 978*D1*Dd*Pk2*f**2 - 21504*D1*Dd*Pk2*f*fd*r**2 - 36864*D1*Dd*Pk2*f*fd*r*s + 30912*D1*Dd*Pk2*f*fd*r + 6624*D1*Dd*Pk2*f*fd*s**2 + 3672*D1*Dd*Pk2*f*fd*s - 6804*D1*Dd*Pk2*f*fd + 336*D1*Dd*Pk2*f*g2*r**2 - 39648*D1*Dd*Pk2*f*g2*r*s + 9576*D1*Dd*Pk2*f*g2*r - 30240*D1*Dd*Pk2*f*g2*s**2 + 34944*D1*Dd*Pk2*f*g2*s - 7392*D1*Dd*Pk2*f*g2 + 11424*D1*Dd*Pk2*f*gd2*r**2 + 49728*D1*Dd*Pk2*f*gd2*r*s - 23352*D1*Dd*Pk2*f*gd2*r + 33600*D1*Dd*Pk2*f*gd2*s**2 - 45696*D1*Dd*Pk2*f*gd2*s + 11928*D1*Dd*Pk2*f*gd2 + 11424*D1*Dd*Pk2*fd*g2*r**2 + 49728*D1*Dd*Pk2*fd*g2*r*s - 22008*D1*Dd*Pk2*fd*g2*r + 33600*D1*Dd*Pk2*fd*g2*s**2 - 29568*D1*Dd*Pk2*fd*g2*s + 7224*D1*Dd*Pk2*fd*g2 - 560*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 280*D1*Dd*Pkdd2*f**3*k1**2*s - 140*D1*Dd*Pkdd2*f**3*k1**2 + 1680*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 140*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 70*D1*Dd*Pkdd2*f**2*fd*k1**2 + 468*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 234*D1*Dd*Pkdd2*f**2*k1**2*s + 117*D1*Dd*Pkdd2*f**2*k1**2 - 1440*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 360*D1*Dd*Pkdd2*f*fd*k1**2*s + 1008*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 504*D1*Dd*Pkdd2*f*g2*k1**2*s + 252*D1*Dd*Pkdd2*f*g2*k1**2 - 1008*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 252*D1*Dd*Pkdd2*f*gd2*k1**2*s - 1008*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 252*D1*Dd*Pkdd2*fd*g2*k1**2*s + 3216*D1*Ddd*K*Pk2*f**2*r**2 + 6768*D1*Ddd*K*Pk2*f**2*r*s - 4908*D1*Ddd*K*Pk2*f**2*r - 11880*D1*Ddd*K*Pk2*f**2*s**2 + 2556*D1*Ddd*K*Pk2*f**2*s - 1362*D1*Ddd*K*Pk2*f**2 - 9720*D1*Ddd*Pk2*f**3*r**2 - 23040*D1*Ddd*Pk2*f**3*r*s + 15480*D1*Ddd*Pk2*f**3*r - 6840*D1*Ddd*Pk2*f**3*s**2 + 14940*D1*Ddd*Pk2*f**3*s - 6570*D1*Ddd*Pk2*f**3 - 5376*D1*Ddd*Pk2*f**2*r**2 - 9216*D1*Ddd*Pk2*f**2*r*s + 7680*D1*Ddd*Pk2*f**2*r + 1656*D1*Ddd*Pk2*f**2*s**2 + 3780*D1*Ddd*Pk2*f**2*s - 2274*D1*Ddd*Pk2*f**2 + 5712*D1*Ddd*Pk2*f*g2*r**2 + 24864*D1*Ddd*Pk2*f*g2*r*s - 11928*D1*Ddd*Pk2*f*g2*r + 16800*D1*Ddd*Pk2*f*g2*s**2 - 20832*D1*Ddd*Pk2*f*g2*s + 7056*D1*Ddd*Pk2*f*g2 + 280*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 140*D1*Ddd*Pkdd2*f**3*k1**2*s + 70*D1*Ddd*Pkdd2*f**3*k1**2 - 360*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 180*D1*Ddd*Pkdd2*f**2*k1**2*s - 90*D1*Ddd*Pkdd2*f**2*k1**2 - 504*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 252*D1*Ddd*Pkdd2*f*g2*k1**2*s - 126*D1*Ddd*Pkdd2*f*g2*k1**2 - 6*D1*bd1*(D1*(12*Pk2*f**2*(r*(40*s - 33) + 40*s**2 - 76*s + 33) - 280*Pk2*(g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + gd2*(-4*r*s + r - (1 - 2*s)**2)) + f*(2*Pk2*(168*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 7*K*(r**2 + r*(33 - 118*s) - 90*s**2 + 98*s - 19) - 30*fd*(4*s - 1)*(4*r + 4*s - 3) - 7*r**2 + 49*r*(18*s - 5) + 686*s**2 - 910*s + 147) + Pkdd2*k1**2*(21*K - 21)*(2*s**2 - 2*s + 1)) - 7*fd*(2*Pk2*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(34*r**2 + 148*r*s - 69*r + 100*s**2 - 100*s + 15) + 34*r**2 + 196*r*s - 87*r + 148*s**2 - 136*s + 9) + Pkdd2*k1**2*s*(3*K - 3)*(2*s - 1))) + Dd*(-60*Pk2*f**2*(4*r*(8*s - 5) + 32*s**2 - 52*s + 17) + 560*Pk2*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 7*f*(4*Pk2*(12*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - K*(68*r**2 + 296*r*s - 149*r + 200*s**2 - 272*s + 76) + 68*r**2 + 392*r*s - 173*r + 296*s**2 - 392*s + 100) + Pkdd2*k1**2*(3*K - 3)*(8*s**2 - 6*s + 1)))) + 9648*Dd**2*K*Pk2*f**2*r**2 + 20304*Dd**2*K*Pk2*f**2*r*s - 14724*Dd**2*K*Pk2*f**2*r - 35640*Dd**2*K*Pk2*f**2*s**2 + 7668*Dd**2*K*Pk2*f**2*s + 4992*Dd**2*K*Pk2*f**2 - 29160*Dd**2*Pk2*f**3*r**2 - 69120*Dd**2*Pk2*f**3*r*s + 46440*Dd**2*Pk2*f**3*r - 20520*Dd**2*Pk2*f**3*s**2 + 44820*Dd**2*Pk2*f**3*s - 16380*Dd**2*Pk2*f**3 - 16128*Dd**2*Pk2*f**2*r**2 - 27648*Dd**2*Pk2*f**2*r*s + 23040*Dd**2*Pk2*f**2*r + 4968*Dd**2*Pk2*f**2*s**2 + 11340*Dd**2*Pk2*f**2*s - 7296*Dd**2*Pk2*f**2 + 17136*Dd**2*Pk2*f*g2*r**2 + 74592*Dd**2*Pk2*f*g2*r*s - 35784*Dd**2*Pk2*f*g2*r + 50400*Dd**2*Pk2*f*g2*s**2 - 62496*Dd**2*Pk2*f*g2*s + 15288*Dd**2*Pk2*f*g2 + 840*Dd**2*Pkdd2*f**3*k1**2*s**2 - 420*Dd**2*Pkdd2*f**3*k1**2*s - 1080*Dd**2*Pkdd2*f**2*k1**2*s**2 + 540*Dd**2*Pkdd2*f**2*k1**2*s - 1512*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 756*Dd**2*Pkdd2*f*g2*k1**2*s))/(630*d**2*k3**4) + D1**2*Pk3*ct**4*k2**2*st**2*(-3768*C*D1**2*Pk2*f**2*fd*r**2 + 18624*C*D1**2*Pk2*f**2*fd*r*s - 3696*C*D1**2*Pk2*f**2*fd*r + 7200*C*D1**2*Pk2*f**2*fd*s**2 - 11008*C*D1**2*Pk2*f**2*fd*s + 1144*C*D1**2*Pk2*f**2*fd + 2532*C*D1**2*Pk2*f**2*fdd*r**2 - 11040*C*D1**2*Pk2*f**2*fdd*r*s + 1992*C*D1**2*Pk2*f**2*fdd*r - 3600*C*D1**2*Pk2*f**2*fdd*s**2 + 6080*C*D1**2*Pk2*f**2*fdd*s - 356*C*D1**2*Pk2*f**2*fdd + 5064*C*D1**2*Pk2*f*fd**2*r**2 - 22080*C*D1**2*Pk2*f*fd**2*r*s + 3984*C*D1**2*Pk2*f*fd**2*r - 7200*C*D1**2*Pk2*f*fd**2*s**2 + 12160*C*D1**2*Pk2*f*fd**2*s - 3680*C*D1**2*Pk2*f*fd**2 - 432*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 216*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 216*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 2076*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 1384*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 692*C*D1**2*Pkdd2*f**2*fd*k1**2 + 1200*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 800*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 400*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 2400*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 1600*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 5024*C*D1*Dd*Pk2*f**3*r**2 + 24832*C*D1*Dd*Pk2*f**3*r*s - 1184*C*D1*Dd*Pk2*f**3*r + 9600*C*D1*Dd*Pk2*f**3*s**2 - 17216*C*D1*Dd*Pk2*f**3*s - 112*C*D1*Dd*Pk2*f**3 + 20256*C*D1*Dd*Pk2*f**2*fd*r**2 - 88320*C*D1*Dd*Pk2*f**2*fd*r*s + 8880*C*D1*Dd*Pk2*f**2*fd*r - 28800*C*D1*Dd*Pk2*f**2*fd*s**2 + 53600*C*D1*Dd*Pk2*f**2*fd*s - 10064*C*D1*Dd*Pk2*f**2*fd - 864*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 432*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 216*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 1728*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 432*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 2768*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 1384*C*D1*Dd*Pkdd2*f**3*k1**2*s - 692*C*D1*Dd*Pkdd2*f**3*k1**2 + 9600*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 5600*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 800*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 3376*C*D1*Ddd*Pk2*f**3*r**2 - 14720*C*D1*Ddd*Pk2*f**3*r*s + 304*C*D1*Ddd*Pk2*f**3*r - 4800*C*D1*Ddd*Pk2*f**3*s**2 + 9760*C*D1*Ddd*Pk2*f**3*s + 488*C*D1*Ddd*Pk2*f**3 + 432*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 216*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 108*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 1600*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 800*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 400*C*D1*Ddd*Pkdd2*f**3*k1**2 + 10128*C*Dd**2*Pk2*f**3*r**2 - 44160*C*Dd**2*Pk2*f**3*r*s + 912*C*Dd**2*Pk2*f**3*r - 14400*C*Dd**2*Pk2*f**3*s**2 + 29280*C*Dd**2*Pk2*f**3*s - 5672*C*Dd**2*Pk2*f**3 + 1296*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 648*C*Dd**2*Pkdd2*b1*f**2*k1**2*s + 4800*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 2400*C*Dd**2*Pkdd2*f**3*k1**2*s - 1080*D1**2*K*Pk2*b1*f*fd*r**2 + 8640*D1**2*K*Pk2*b1*f*fd*r*s - 4320*D1**2*K*Pk2*b1*f*fd*r + 4320*D1**2*K*Pk2*b1*f*fd*s**2 - 4320*D1**2*K*Pk2*b1*f*fd*s + 2160*D1**2*K*Pk2*b1*f*fd + 540*D1**2*K*Pk2*b1*f*fdd*r**2 - 4320*D1**2*K*Pk2*b1*f*fdd*r*s + 2160*D1**2*K*Pk2*b1*f*fdd*r - 2160*D1**2*K*Pk2*b1*f*fdd*s**2 + 2160*D1**2*K*Pk2*b1*f*fdd*s - 1080*D1**2*K*Pk2*b1*f*fdd + 540*D1**2*K*Pk2*b1*fd**2*r**2 - 4320*D1**2*K*Pk2*b1*fd**2*r*s + 2160*D1**2*K*Pk2*b1*fd**2*r - 2160*D1**2*K*Pk2*b1*fd**2*s**2 + 2160*D1**2*K*Pk2*b1*fd**2*s - 252*D1**2*K*Pkdd2*b1**2*fd*k1**2*s**2 + 126*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s**2 - 1188*D1**2*K*Pkdd2*b1*f*fd*k1**2*s**2 + 1188*D1**2*K*Pkdd2*b1*f*fd*k1**2*s - 594*D1**2*K*Pkdd2*b1*f*fd*k1**2 + 720*D1**2*K*Pkdd2*b1*f*fdd*k1**2*s**2 - 720*D1**2*K*Pkdd2*b1*f*fdd*k1**2*s + 360*D1**2*K*Pkdd2*b1*f*fdd*k1**2 + 720*D1**2*K*Pkdd2*b1*fd**2*k1**2*s**2 - 720*D1**2*K*Pkdd2*b1*fd**2*k1**2*s + 1620*D1**2*Pk2*b1*f**2*fd*r**2 - 1080*D1**2*Pk2*b1*f**2*fd*r + 540*D1**2*Pk2*b1*f**2*fd - 1620*D1**2*Pk2*b1*f**2*fdd*r**2 + 1080*D1**2*Pk2*b1*f**2*fdd*r - 540*D1**2*Pk2*b1*f**2*fdd - 3240*D1**2*Pk2*b1*f*fd**2*r**2 + 2160*D1**2*Pk2*b1*f*fd**2*r + 3240*D1**2*Pk2*b1*f*fd*r**2 - 1620*D1**2*Pk2*b1*f*fdd*r**2 - 1620*D1**2*Pk2*b1*fd**2*r**2 + 4320*D1**2*Pk2*b2*f*fd*r*s - 2160*D1**2*Pk2*b2*f*fd*r + 4320*D1**2*Pk2*b2*f*fd*s**2 - 4320*D1**2*Pk2*b2*f*fd*s + 2160*D1**2*Pk2*b2*f*fd - 2160*D1**2*Pk2*b2*f*fdd*r*s + 1080*D1**2*Pk2*b2*f*fdd*r - 2160*D1**2*Pk2*b2*f*fdd*s**2 + 2160*D1**2*Pk2*b2*f*fdd*s - 1080*D1**2*Pk2*b2*f*fdd - 2160*D1**2*Pk2*b2*fd**2*r*s + 1080*D1**2*Pk2*b2*fd**2*r - 2160*D1**2*Pk2*b2*fd**2*s**2 + 2160*D1**2*Pk2*b2*fd**2*s + 2160*D1**2*Pk2*bd2*f**2*r*s + 2160*D1**2*Pk2*bd2*f**2*s**2 - 2160*D1**2*Pk2*bd2*f**2*s - 4320*D1**2*Pk2*bd2*f*fd*r*s + 1080*D1**2*Pk2*bd2*f*fd*r - 4320*D1**2*Pk2*bd2*f*fd*s**2 + 4320*D1**2*Pk2*bd2*f*fd*s - 1080*D1**2*Pk2*bd2*f*fd - 1080*D1**2*Pk2*bdd2*f**2*r*s - 1080*D1**2*Pk2*bdd2*f**2*s**2 + 1080*D1**2*Pk2*bdd2*f**2*s - 1080*D1**2*Pk2*f**3*fd*r**2 + 1080*D1**2*Pk2*f**3*fd*r - 540*D1**2*Pk2*f**3*fd + 1080*D1**2*Pk2*f**3*fdd*r**2 - 1080*D1**2*Pk2*f**3*fdd*r + 540*D1**2*Pk2*f**3*fdd + 3240*D1**2*Pk2*f**2*fd**2*r**2 - 3240*D1**2*Pk2*f**2*fd**2*r + 540*D1**2*Pk2*f**2*fd**2 + 6624*D1**2*Pk2*f**2*fd*r**2 - 9312*D1**2*Pk2*f**2*fd*r*s - 1312*D1**2*Pk2*f**2*fd*r - 3600*D1**2*Pk2*f**2*fd*s**2 + 5504*D1**2*Pk2*f**2*fd*s + 1008*D1**2*Pk2*f**2*fd - 4392*D1**2*Pk2*f**2*fdd*r**2 + 5520*D1**2*Pk2*f**2*fdd*r*s + 1088*D1**2*Pk2*f**2*fdd*r + 1800*D1**2*Pk2*f**2*fdd*s**2 - 3040*D1**2*Pk2*f**2*fdd*s - 864*D1**2*Pk2*f**2*fdd + 1080*D1**2*Pk2*f**2*gd2*r**2 - 8640*D1**2*Pk2*f**2*gd2*r*s - 2160*D1**2*Pk2*f**2*gd2*r - 4320*D1**2*Pk2*f**2*gd2*s**2 + 8640*D1**2*Pk2*f**2*gd2*s + 1080*D1**2*Pk2*f**2*gd2 - 540*D1**2*Pk2*f**2*gdd2*r**2 + 4320*D1**2*Pk2*f**2*gdd2*r*s + 1080*D1**2*Pk2*f**2*gdd2*r + 2160*D1**2*Pk2*f**2*gdd2*s**2 - 4320*D1**2*Pk2*f**2*gdd2*s - 540*D1**2*Pk2*f**2*gdd2 - 8784*D1**2*Pk2*f*fd**2*r**2 + 11040*D1**2*Pk2*f*fd**2*r*s + 2176*D1**2*Pk2*f*fd**2*r + 3600*D1**2*Pk2*f*fd**2*s**2 - 6080*D1**2*Pk2*f*fd**2*s + 1840*D1**2*Pk2*f*fd**2 + 2160*D1**2*Pk2*f*fd*g2*r**2 - 17280*D1**2*Pk2*f*fd*g2*r*s + 8640*D1**2*Pk2*f*fd*g2*r - 8640*D1**2*Pk2*f*fd*g2*s**2 + 8640*D1**2*Pk2*f*fd*g2*s - 4320*D1**2*Pk2*f*fd*g2 - 2160*D1**2*Pk2*f*fd*gd2*r**2 + 17280*D1**2*Pk2*f*fd*gd2*r*s - 2160*D1**2*Pk2*f*fd*gd2*r + 8640*D1**2*Pk2*f*fd*gd2*s**2 - 12960*D1**2*Pk2*f*fd*gd2*s + 4320*D1**2*Pk2*f*fd*gd2 - 1080*D1**2*Pk2*f*fdd*g2*r**2 + 8640*D1**2*Pk2*f*fdd*g2*r*s - 4320*D1**2*Pk2*f*fdd*g2*r + 4320*D1**2*Pk2*f*fdd*g2*s**2 - 4320*D1**2*Pk2*f*fdd*g2*s + 2160*D1**2*Pk2*f*fdd*g2 - 1080*D1**2*Pk2*fd**2*g2*r**2 + 8640*D1**2*Pk2*fd**2*g2*r*s - 4320*D1**2*Pk2*fd**2*g2*r + 4320*D1**2*Pk2*fd**2*g2*s**2 - 4320*D1**2*Pk2*fd**2*g2*s + 252*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 126*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 900*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 - 900*D1**2*Pkdd2*b1*f**2*fd*k1**2*s + 450*D1**2*Pkdd2*b1*f**2*fd*k1**2 - 450*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 + 450*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s - 225*D1**2*Pkdd2*b1*f**2*fdd*k1**2 - 900*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 + 900*D1**2*Pkdd2*b1*f*fd**2*k1**2*s + 900*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 468*D1**2*Pkdd2*b1*f*fd*k1**2*s + 234*D1**2*Pkdd2*b1*f*fd*k1**2 - 576*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 360*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 180*D1**2*Pkdd2*b1*f*fdd*k1**2 + 504*D1**2*Pkdd2*b1*f*gd2*k1**2*s**2 - 252*D1**2*Pkdd2*b1*f*gdd2*k1**2*s**2 - 576*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 360*D1**2*Pkdd2*b1*fd**2*k1**2*s + 504*D1**2*Pkdd2*b1*fd*g2*k1**2*s**2 - 504*D1**2*Pkdd2*b1*fd*gd2*k1**2*s**2 - 252*D1**2*Pkdd2*b1*fdd*g2*k1**2*s**2 + 252*D1**2*Pkdd2*bd1**2*f*k1**2*s*(K - 1)*(s - 1) + 300*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 150*D1**2*Pkdd2*f**3*fd*k1**2*s + 75*D1**2*Pkdd2*f**3*fd*k1**2 + 1476*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 984*D1**2*Pkdd2*f**2*fd*k1**2*s + 492*D1**2*Pkdd2*f**2*fd*k1**2 - 900*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 600*D1**2*Pkdd2*f**2*fdd*k1**2*s - 300*D1**2*Pkdd2*f**2*fdd*k1**2 + 1188*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 720*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 1800*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 1200*D1**2*Pkdd2*f*fd**2*k1**2*s + 2376*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 2376*D1**2*Pkdd2*f*fd*g2*k1**2*s + 1188*D1**2*Pkdd2*f*fd*g2*k1**2 - 2880*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 1440*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 1440*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 1440*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 720*D1**2*Pkdd2*f*fdd*g2*k1**2 - 1440*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 1440*D1**2*Pkdd2*fd**2*g2*k1**2*s - 3*D1**2*bdd1*f*(-42*Pkdd2*k1**2*(b1*(K - 1)*(2*s**2 - 2*s + 1) - 2*g2*(s - 1)**2) + 5*f**2*(36*Pk2*(r - 1)**2 + 5*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 6*f*(15*Pk2*(K*(r**2 - 2*r*(4*s + 1) - 4*s**2 + 8*s + 1) - 3*(r - 1)**2) + 2*Pkdd2*k1**2*(3*C*(s - 1)**2 + s**2*(10*K - 8) + 6*s - 3))) - 2160*D1*Dd*K*Pk2*b1*f**2*r**2 + 17280*D1*Dd*K*Pk2*b1*f**2*r*s - 2160*D1*Dd*K*Pk2*b1*f**2*r + 8640*D1*Dd*K*Pk2*b1*f**2*s**2 - 12960*D1*Dd*K*Pk2*b1*f**2*s + 1080*D1*Dd*K*Pk2*b1*f**2 + 4320*D1*Dd*K*Pk2*b1*f*fd*r**2 - 34560*D1*Dd*K*Pk2*b1*f*fd*r*s + 10800*D1*Dd*K*Pk2*b1*f*fd*r - 17280*D1*Dd*K*Pk2*b1*f*fd*s**2 + 21600*D1*Dd*K*Pk2*b1*f*fd*s - 6480*D1*Dd*K*Pk2*b1*f*fd - 1008*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s**2 + 504*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s - 252*D1*Dd*K*Pkdd2*b1**2*f*k1**2 + 1008*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s**2 - 252*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s - 2376*D1*Dd*K*Pkdd2*b1*f**2*k1**2*s**2 + 1188*D1*Dd*K*Pkdd2*b1*f**2*k1**2*s - 594*D1*Dd*K*Pkdd2*b1*f**2*k1**2 + 5760*D1*Dd*K*Pkdd2*b1*f*fd*k1**2*s**2 - 4320*D1*Dd*K*Pkdd2*b1*f*fd*k1**2*s + 720*D1*Dd*K*Pkdd2*b1*f*fd*k1**2 + 2160*D1*Dd*Pk2*b1*f**3*r**2 - 2160*D1*Dd*Pk2*b1*f**3*r + 1080*D1*Dd*Pk2*b1*f**3 - 12960*D1*Dd*Pk2*b1*f**2*fd*r**2 + 10800*D1*Dd*Pk2*b1*f**2*fd*r - 2160*D1*Dd*Pk2*b1*f**2*fd + 6480*D1*Dd*Pk2*b1*f**2*r**2 - 6480*D1*Dd*Pk2*b1*f**2*r + 3240*D1*Dd*Pk2*b1*f**2 - 12960*D1*Dd*Pk2*b1*f*fd*r**2 + 6480*D1*Dd*Pk2*b1*f*fd*r + 8640*D1*Dd*Pk2*b2*f**2*r*s - 2160*D1*Dd*Pk2*b2*f**2*r + 8640*D1*Dd*Pk2*b2*f**2*s**2 - 8640*D1*Dd*Pk2*b2*f**2*s + 2160*D1*Dd*Pk2*b2*f**2 - 17280*D1*Dd*Pk2*b2*f*fd*r*s + 6480*D1*Dd*Pk2*b2*f*fd*r - 17280*D1*Dd*Pk2*b2*f*fd*s**2 + 17280*D1*Dd*Pk2*b2*f*fd*s - 4320*D1*Dd*Pk2*b2*f*fd - 8640*D1*Dd*Pk2*bd2*f**2*r*s + 1080*D1*Dd*Pk2*bd2*f**2*r - 8640*D1*Dd*Pk2*bd2*f**2*s**2 + 8640*D1*Dd*Pk2*bd2*f**2*s - 1080*D1*Dd*Pk2*bd2*f**2 - 1080*D1*Dd*Pk2*f**4*r**2 + 1080*D1*Dd*Pk2*f**4*r - 540*D1*Dd*Pk2*f**4 + 8640*D1*Dd*Pk2*f**3*fd*r**2 - 8640*D1*Dd*Pk2*f**3*fd*r + 2160*D1*Dd*Pk2*f**3*fd + 8832*D1*Dd*Pk2*f**3*r**2 - 12416*D1*Dd*Pk2*f**3*r*s - 5728*D1*Dd*Pk2*f**3*r - 4800*D1*Dd*Pk2*f**3*s**2 + 8608*D1*Dd*Pk2*f**3*s + 3216*D1*Dd*Pk2*f**3 - 35136*D1*Dd*Pk2*f**2*fd*r**2 + 44160*D1*Dd*Pk2*f**2*fd*r*s + 16400*D1*Dd*Pk2*f**2*fd*r + 14400*D1*Dd*Pk2*f**2*fd*s**2 - 26800*D1*Dd*Pk2*f**2*fd*s + 864*D1*Dd*Pk2*f**2*fd + 4320*D1*Dd*Pk2*f**2*g2*r**2 - 34560*D1*Dd*Pk2*f**2*g2*r*s + 4320*D1*Dd*Pk2*f**2*g2*r - 17280*D1*Dd*Pk2*f**2*g2*s**2 + 25920*D1*Dd*Pk2*f**2*g2*s - 2160*D1*Dd*Pk2*f**2*g2 - 4320*D1*Dd*Pk2*f**2*gd2*r**2 + 34560*D1*Dd*Pk2*f**2*gd2*r*s + 2160*D1*Dd*Pk2*f**2*gd2*r + 17280*D1*Dd*Pk2*f**2*gd2*s**2 - 30240*D1*Dd*Pk2*f**2*gd2*s + 2160*D1*Dd*Pk2*f**2*gd2 - 8640*D1*Dd*Pk2*f*fd*g2*r**2 + 69120*D1*Dd*Pk2*f*fd*g2*r*s - 21600*D1*Dd*Pk2*f*fd*g2*r + 34560*D1*Dd*Pk2*f*fd*g2*s**2 - 43200*D1*Dd*Pk2*f*fd*g2*s + 12960*D1*Dd*Pk2*f*fd*g2 + 1008*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 504*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 252*D1*Dd*Pkdd2*b1**2*f*k1**2 - 1008*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 252*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 1200*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 - 600*D1*Dd*Pkdd2*b1*f**3*k1**2*s + 300*D1*Dd*Pkdd2*b1*f**3*k1**2 - 3600*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 + 2700*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s - 450*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 + 1800*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 900*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 450*D1*Dd*Pkdd2*b1*f**2*k1**2 - 4608*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 2592*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 360*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 2016*D1*Dd*Pkdd2*b1*f*g2*k1**2*s**2 - 1008*D1*Dd*Pkdd2*b1*f*g2*k1**2*s + 504*D1*Dd*Pkdd2*b1*f*g2*k1**2 - 2016*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s**2 + 504*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s - 2016*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s**2 + 504*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s + 300*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 150*D1*Dd*Pkdd2*f**4*k1**2*s + 75*D1*Dd*Pkdd2*f**4*k1**2 + 1968*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 984*D1*Dd*Pkdd2*f**3*k1**2*s + 492*D1*Dd*Pkdd2*f**3*k1**2 - 7200*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 4200*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 600*D1*Dd*Pkdd2*f**2*fd*k1**2 + 4752*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 2376*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 1188*D1*Dd*Pkdd2*f**2*g2*k1**2 - 5760*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 1440*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 11520*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 8640*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 1440*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 1080*D1*Ddd*K*Pk2*b1*f**2*r**2 - 8640*D1*Ddd*K*Pk2*b1*f**2*r*s + 1080*D1*Ddd*K*Pk2*b1*f**2*r - 4320*D1*Ddd*K*Pk2*b1*f**2*s**2 + 6480*D1*Ddd*K*Pk2*b1*f**2*s - 540*D1*Ddd*K*Pk2*b1*f**2 + 504*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s**2 - 252*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s + 126*D1*Ddd*K*Pkdd2*b1**2*f*k1**2 + 1440*D1*Ddd*K*Pkdd2*b1*f**2*k1**2*s**2 - 720*D1*Ddd*K*Pkdd2*b1*f**2*k1**2*s + 360*D1*Ddd*K*Pkdd2*b1*f**2*k1**2 - 2160*D1*Ddd*Pk2*b1*f**3*r**2 + 2160*D1*Ddd*Pk2*b1*f**3*r - 1080*D1*Ddd*Pk2*b1*f**3 - 3240*D1*Ddd*Pk2*b1*f**2*r**2 + 3240*D1*Ddd*Pk2*b1*f**2*r - 1620*D1*Ddd*Pk2*b1*f**2 - 4320*D1*Ddd*Pk2*b2*f**2*r*s + 1080*D1*Ddd*Pk2*b2*f**2*r - 4320*D1*Ddd*Pk2*b2*f**2*s**2 + 4320*D1*Ddd*Pk2*b2*f**2*s - 1080*D1*Ddd*Pk2*b2*f**2 + 1080*D1*Ddd*Pk2*f**4*r**2 - 1080*D1*Ddd*Pk2*f**4*r + 540*D1*Ddd*Pk2*f**4 - 5856*D1*Ddd*Pk2*f**3*r**2 + 7360*D1*Ddd*Pk2*f**3*r*s + 4016*D1*Ddd*Pk2*f**3*r + 2400*D1*Ddd*Pk2*f**3*s**2 - 4880*D1*Ddd*Pk2*f**3*s - 2328*D1*Ddd*Pk2*f**3 - 2160*D1*Ddd*Pk2*f**2*g2*r**2 + 17280*D1*Ddd*Pk2*f**2*g2*r*s - 2160*D1*Ddd*Pk2*f**2*g2*r + 8640*D1*Ddd*Pk2*f**2*g2*s**2 - 12960*D1*Ddd*Pk2*f**2*g2*s + 1080*D1*Ddd*Pk2*f**2*g2 - 504*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 252*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 126*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 600*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 + 300*D1*Ddd*Pkdd2*b1*f**3*k1**2*s - 150*D1*Ddd*Pkdd2*b1*f**3*k1**2 - 1152*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 576*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 288*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 1008*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s**2 + 504*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s - 252*D1*Ddd*Pkdd2*b1*f*g2*k1**2 - 1200*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 600*D1*Ddd*Pkdd2*f**3*k1**2*s - 300*D1*Ddd*Pkdd2*f**3*k1**2 - 2880*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 1440*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 720*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 6*D1*bd1*(D1*(42*Pkdd2*fd*k1**2*s*(b1*(K - 1)*(2*s - 1) - 2*g2*(s - 1)) + 5*f**3*(18*Pk2*(r - 1)**2 + 5*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 3*f**2*(30*Pk2*(K*(r**2 - 8*r*s - 2*r - 4*s**2 + 8*s + 1) + fd*(6*r**2 - 8*r + 2) - 3*(r - 1)**2) + Pkdd2*k1**2*(12*C*(s - 1)**2 + s**2*(33*K + 50*fd - 25) + 24*s - 12)) + 6*f*(-7*Pkdd2*k1**2*(b1*(K - 1)*(2*s**2 - 2*s + 1) + (2 - 2*s)*(g2*(s - 1) - gd2*s)) + 2*fd*(5*K*(3*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + 2*Pkdd2*k1**2*s*(2*s - 1)) - 45*Pk2*r*(r - 1) + Pkdd2*k1**2*s*(6*C*(s - 1) - 16*s + 11)))) - Dd*f*(-42*Pkdd2*k1**2*(4*s - 1)*(b1*(K - 1)*(2*s - 1) - 2*g2*(s - 1)) + 5*f**2*(72*Pk2*(2*r**2 - 3*r + 1) + 5*Pkdd2*k1**2*(8*s**2 + 2*s - 1)) - 12*f*(15*Pk2*(K*(2*r**2 - 16*r*s - r - 8*s**2 + 14*s - 1) - 6*r**2 + 9*r - 3) + Pkdd2*k1**2*(4*s - 1)*(3*C*(s - 1) + 10*K*s - 8*s + 3)))) + 3240*Dd**2*K*Pk2*b1*f**2*r**2 - 25920*Dd**2*K*Pk2*b1*f**2*r*s + 3240*Dd**2*K*Pk2*b1*f**2*r - 12960*Dd**2*K*Pk2*b1*f**2*s**2 + 19440*Dd**2*K*Pk2*b1*f**2*s - 3780*Dd**2*K*Pk2*b1*f**2 + 1512*Dd**2*K*Pkdd2*b1**2*f*k1**2*s**2 - 756*Dd**2*K*Pkdd2*b1**2*f*k1**2*s + 4320*Dd**2*K*Pkdd2*b1*f**2*k1**2*s**2 - 2160*Dd**2*K*Pkdd2*b1*f**2*k1**2*s - 6480*Dd**2*Pk2*b1*f**3*r**2 + 6480*Dd**2*Pk2*b1*f**3*r - 1080*Dd**2*Pk2*b1*f**3 - 9720*Dd**2*Pk2*b1*f**2*r**2 + 9720*Dd**2*Pk2*b1*f**2*r - 1620*Dd**2*Pk2*b1*f**2 - 12960*Dd**2*Pk2*b2*f**2*r*s + 3240*Dd**2*Pk2*b2*f**2*r - 12960*Dd**2*Pk2*b2*f**2*s**2 + 12960*Dd**2*Pk2*b2*f**2*s - 2160*Dd**2*Pk2*b2*f**2 + 3240*Dd**2*Pk2*f**4*r**2 - 3240*Dd**2*Pk2*f**4*r + 540*Dd**2*Pk2*f**4 - 17568*Dd**2*Pk2*f**3*r**2 + 22080*Dd**2*Pk2*f**3*r*s + 12048*Dd**2*Pk2*f**3*r + 7200*Dd**2*Pk2*f**3*s**2 - 14640*Dd**2*Pk2*f**3*s + 752*Dd**2*Pk2*f**3 - 6480*Dd**2*Pk2*f**2*g2*r**2 + 51840*Dd**2*Pk2*f**2*g2*r*s - 6480*Dd**2*Pk2*f**2*g2*r + 25920*Dd**2*Pk2*f**2*g2*s**2 - 38880*Dd**2*Pk2*f**2*g2*s + 7560*Dd**2*Pk2*f**2*g2 - 1512*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 756*Dd**2*Pkdd2*b1**2*f*k1**2*s - 1800*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 + 900*Dd**2*Pkdd2*b1*f**3*k1**2*s - 3456*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 1728*Dd**2*Pkdd2*b1*f**2*k1**2*s - 3024*Dd**2*Pkdd2*b1*f*g2*k1**2*s**2 + 1512*Dd**2*Pkdd2*b1*f*g2*k1**2*s - 3600*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1800*Dd**2*Pkdd2*f**3*k1**2*s - 8640*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 4320*Dd**2*Pkdd2*f**2*g2*k1**2*s)/(630*d**2*k3**4) + D1**2*Pk3*ct**4*k2**2*(-948*C*D1**2*Pk2*bdd1*f**2*r**2 - 1296*C*D1**2*Pk2*bdd1*f**2*r*s - 11112*C*D1**2*Pk2*f**2*fd*r**2 - 20256*C*D1**2*Pk2*f**2*fd*r*s + 14160*C*D1**2*Pk2*f**2*fd*r - 5940*C*D1**2*Pk2*f**2*fd*s**2 + 10712*C*D1**2*Pk2*f**2*fd*s - 5684*C*D1**2*Pk2*f**2*fd + 7932*C*D1**2*Pk2*f**2*fdd*r**2 + 18336*C*D1**2*Pk2*f**2*fdd*r*s - 11400*C*D1**2*Pk2*f**2*fdd*r + 4860*C*D1**2*Pk2*f**2*fdd*s**2 - 9352*C*D1**2*Pk2*f**2*fdd*s + 4264*C*D1**2*Pk2*f**2*fdd + 15864*C*D1**2*Pk2*f*fd**2*r**2 + 36672*C*D1**2*Pk2*f*fd**2*r*s - 22800*C*D1**2*Pk2*f*fd**2*r + 9720*C*D1**2*Pk2*f*fd**2*s**2 - 18704*C*D1**2*Pk2*f*fd**2*s + 6112*C*D1**2*Pk2*f*fd**2 + 360*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 720*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 360*C*D1**2*Pkdd2*bdd1*f**2*k1**2 + 660*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 440*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 220*C*D1**2*Pkdd2*f**2*fd*k1**2 + 210*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 140*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 70*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 420*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 280*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 14816*C*D1*Dd*Pk2*f**3*r**2 - 27008*C*D1*Dd*Pk2*f**3*r*s + 21568*C*D1*Dd*Pk2*f**3*r - 7920*C*D1*Dd*Pk2*f**3*s**2 + 17464*C*D1*Dd*Pk2*f**3*s - 9388*C*D1*Dd*Pk2*f**3 + 63456*C*D1*Dd*Pk2*f**2*fd*r**2 + 146688*C*D1*Dd*Pk2*f**2*fd*r*s - 95664*C*D1*Dd*Pk2*f**2*fd*r + 38880*C*D1*Dd*Pk2*f**2*fd*s**2 - 83800*C*D1*Dd*Pk2*f**2*fd*s + 32152*C*D1*Dd*Pk2*f**2*fd + 880*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 440*C*D1*Dd*Pkdd2*f**3*k1**2*s + 220*C*D1*Dd*Pkdd2*f**3*k1**2 + 1680*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 980*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 140*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 10576*C*D1*Ddd*Pk2*f**3*r**2 + 24448*C*D1*Ddd*Pk2*f**3*r*s - 16688*C*D1*Ddd*Pk2*f**3*r + 6480*C*D1*Ddd*Pk2*f**3*s**2 - 15464*C*D1*Ddd*Pk2*f**3*s + 6908*C*D1*Ddd*Pk2*f**3 + 280*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 140*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 70*C*D1*Ddd*Pkdd2*f**3*k1**2 + 31728*C*Dd**2*Pk2*f**3*r**2 + 73344*C*Dd**2*Pk2*f**3*r*s - 50064*C*Dd**2*Pk2*f**3*r + 19440*C*Dd**2*Pk2*f**3*s**2 - 46392*C*Dd**2*Pk2*f**3*s + 17512*C*Dd**2*Pk2*f**3 + 840*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 420*C*Dd**2*Pkdd2*f**3*k1**2*s + 1134*D1**2*K*Pk2*bdd1*f**2*r**2 + 3024*D1**2*K*Pk2*bdd1*f**2*r*s - 2268*D1**2*K*Pk2*bdd1*f**2*r + 1134*D1**2*K*Pk2*bdd1*f**2*s**2 - 3024*D1**2*K*Pk2*bdd1*f**2*s + 1134*D1**2*K*Pk2*bdd1*f**2 + 45*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 756*D1**2*Pk2*b2*f*fd*r**2 - 3528*D1**2*Pk2*b2*f*fd*r*s + 1764*D1**2*Pk2*b2*f*fd*r - 2772*D1**2*Pk2*b2*f*fd*s**2 + 2772*D1**2*Pk2*b2*f*fd*s - 1386*D1**2*Pk2*b2*f*fd + 1260*D1**2*Pk2*b2*f*fdd*r**2 + 3528*D1**2*Pk2*b2*f*fdd*r*s - 1764*D1**2*Pk2*b2*f*fdd*r + 2268*D1**2*Pk2*b2*f*fdd*s**2 - 2268*D1**2*Pk2*b2*f*fdd*s + 1134*D1**2*Pk2*b2*f*fdd + 1260*D1**2*Pk2*b2*fd**2*r**2 + 3528*D1**2*Pk2*b2*fd**2*r*s - 1764*D1**2*Pk2*b2*fd**2*r + 2268*D1**2*Pk2*b2*fd**2*s**2 - 2268*D1**2*Pk2*b2*fd**2*s - 378*D1**2*Pk2*bd2*f**2*r**2 - 1764*D1**2*Pk2*bd2*f**2*r*s + 756*D1**2*Pk2*bd2*f**2*r - 1386*D1**2*Pk2*bd2*f**2*s**2 + 1764*D1**2*Pk2*bd2*f**2*s - 378*D1**2*Pk2*bd2*f**2 + 2520*D1**2*Pk2*bd2*f*fd*r**2 + 7056*D1**2*Pk2*bd2*f*fd*r*s - 4284*D1**2*Pk2*bd2*f*fd*r + 4536*D1**2*Pk2*bd2*f*fd*s**2 - 5796*D1**2*Pk2*bd2*f*fd*s + 1764*D1**2*Pk2*bd2*f*fd - 252*D1**2*Pk2*bdd1*f**3*r**2 - 630*D1**2*Pk2*bdd1*f**3*r*s + 756*D1**2*Pk2*bdd1*f**3*r + 630*D1**2*Pk2*bdd1*f**3*s - 378*D1**2*Pk2*bdd1*f**3 + 48*D1**2*Pk2*bdd1*f**2*r**2 + 18*D1**2*Pk2*bdd1*f**2*r*s + 828*D1**2*Pk2*bdd1*f**2*r + 630*D1**2*Pk2*bdd1*f**2*s - 252*D1**2*Pk2*bdd1*f**2 + 756*D1**2*Pk2*bdd1*f*g2*r**2 + 1008*D1**2*Pk2*bdd1*f*g2*r*s + 630*D1**2*Pk2*bdd2*f**2*r**2 + 1764*D1**2*Pk2*bdd2*f**2*r*s - 1260*D1**2*Pk2*bdd2*f**2*r + 1134*D1**2*Pk2*bdd2*f**2*s**2 - 1764*D1**2*Pk2*bdd2*f**2*s + 630*D1**2*Pk2*bdd2*f**2 + 6534*D1**2*Pk2*f**2*fd*r**2 + 12042*D1**2*Pk2*f**2*fd*r*s - 8370*D1**2*Pk2*f**2*fd*r + 2970*D1**2*Pk2*f**2*fd*s**2 - 5994*D1**2*Pk2*f**2*fd*s + 3168*D1**2*Pk2*f**2*fd - 4914*D1**2*Pk2*f**2*fdd*r**2 - 11502*D1**2*Pk2*f**2*fdd*r*s + 7110*D1**2*Pk2*f**2*fdd*r - 2430*D1**2*Pk2*f**2*fdd*s**2 + 5454*D1**2*Pk2*f**2*fdd*s - 2448*D1**2*Pk2*f**2*fdd + 1512*D1**2*Pk2*f**2*gd2*r**2 + 6048*D1**2*Pk2*f**2*gd2*r*s - 3024*D1**2*Pk2*f**2*gd2*r + 2772*D1**2*Pk2*f**2*gd2*s**2 - 6048*D1**2*Pk2*f**2*gd2*s + 1512*D1**2*Pk2*f**2*gd2 - 2268*D1**2*Pk2*f**2*gdd2*r**2 - 6048*D1**2*Pk2*f**2*gdd2*r*s + 4536*D1**2*Pk2*f**2*gdd2*r - 2268*D1**2*Pk2*f**2*gdd2*s**2 + 6048*D1**2*Pk2*f**2*gdd2*s - 2268*D1**2*Pk2*f**2*gdd2 - 9828*D1**2*Pk2*f*fd**2*r**2 - 23004*D1**2*Pk2*f*fd**2*r*s + 14220*D1**2*Pk2*f*fd**2*r - 4860*D1**2*Pk2*f*fd**2*s**2 + 10908*D1**2*Pk2*f*fd**2*s - 3834*D1**2*Pk2*f*fd**2 + 3024*D1**2*Pk2*f*fd*g2*r**2 + 12096*D1**2*Pk2*f*fd*g2*r*s - 6048*D1**2*Pk2*f*fd*g2*r + 5544*D1**2*Pk2*f*fd*g2*s**2 - 5544*D1**2*Pk2*f*fd*g2*s + 2772*D1**2*Pk2*f*fd*g2 - 9072*D1**2*Pk2*f*fd*gd2*r**2 - 24192*D1**2*Pk2*f*fd*gd2*r*s + 15120*D1**2*Pk2*f*fd*gd2*r - 9072*D1**2*Pk2*f*fd*gd2*s**2 + 16632*D1**2*Pk2*f*fd*gd2*s - 6048*D1**2*Pk2*f*fd*gd2 - 4536*D1**2*Pk2*f*fdd*g2*r**2 - 12096*D1**2*Pk2*f*fdd*g2*r*s + 6048*D1**2*Pk2*f*fdd*g2*r - 4536*D1**2*Pk2*f*fdd*g2*s**2 + 4536*D1**2*Pk2*f*fdd*g2*s - 2268*D1**2*Pk2*f*fdd*g2 - 4536*D1**2*Pk2*fd**2*g2*r**2 - 12096*D1**2*Pk2*fd**2*g2*r*s + 6048*D1**2*Pk2*fd**2*g2*r - 4536*D1**2*Pk2*fd**2*g2*s**2 + 4536*D1**2*Pk2*fd**2*g2*s - 270*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 540*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 270*D1**2*Pkdd2*bdd1*f**2*k1**2 - 504*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 + 1008*D1**2*Pkdd2*bdd1*f*g2*k1**2*s - 504*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 600*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 400*D1**2*Pkdd2*f**2*fd*k1**2*s - 200*D1**2*Pkdd2*f**2*fd*k1**2 - 105*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 70*D1**2*Pkdd2*f**2*fdd*k1**2*s - 35*D1**2*Pkdd2*f**2*fdd*k1**2 - 324*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 90*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 210*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 140*D1**2*Pkdd2*f*fd**2*k1**2*s - 648*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 648*D1**2*Pkdd2*f*fd*g2*k1**2*s - 324*D1**2*Pkdd2*f*fd*g2*k1**2 - 360*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 180*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 180*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 180*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 90*D1**2*Pkdd2*f*fdd*g2*k1**2 - 180*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 180*D1**2*Pkdd2*fd**2*g2*k1**2*s + 18*D1**2*bd1**2*f*(14*Pk2*(2*K*s + f*(r - 1) - r**2*(3*K + 1) + r*(-4*K*s + 3*K + 2) - 1) - Pkdd2*k1**2*s*(s - 1)*(-28*K + 15*f + 14)) - 1512*D1*Dd*Pk2*b2*f**2*r**2 - 7056*D1*Dd*Pk2*b2*f**2*r*s + 3276*D1*Dd*Pk2*b2*f**2*r - 5544*D1*Dd*Pk2*b2*f**2*s**2 + 6300*D1*Dd*Pk2*b2*f**2*s - 2142*D1*Dd*Pk2*b2*f**2 + 10080*D1*Dd*Pk2*b2*f*fd*r**2 + 28224*D1*Dd*Pk2*b2*f*fd*r*s - 15624*D1*Dd*Pk2*b2*f*fd*r + 18144*D1*Dd*Pk2*b2*f*fd*s**2 - 20664*D1*Dd*Pk2*b2*f*fd*s + 5796*D1*Dd*Pk2*b2*f*fd + 5040*D1*Dd*Pk2*bd2*f**2*r**2 + 14112*D1*Dd*Pk2*bd2*f**2*r*s - 9324*D1*Dd*Pk2*bd2*f**2*r + 9072*D1*Dd*Pk2*bd2*f**2*s**2 - 12852*D1*Dd*Pk2*bd2*f**2*s + 4284*D1*Dd*Pk2*bd2*f**2 + 8712*D1*Dd*Pk2*f**3*r**2 + 16056*D1*Dd*Pk2*f**3*r*s - 12726*D1*Dd*Pk2*f**3*r + 3960*D1*Dd*Pk2*f**3*s**2 - 10008*D1*Dd*Pk2*f**3*s + 5346*D1*Dd*Pk2*f**3 - 39312*D1*Dd*Pk2*f**2*fd*r**2 - 92016*D1*Dd*Pk2*f**2*fd*r*s + 59598*D1*Dd*Pk2*f**2*fd*r - 19440*D1*Dd*Pk2*f**2*fd*s**2 + 49680*D1*Dd*Pk2*f**2*fd*s - 19674*D1*Dd*Pk2*f**2*fd + 6048*D1*Dd*Pk2*f**2*g2*r**2 + 24192*D1*Dd*Pk2*f**2*g2*r*s - 12096*D1*Dd*Pk2*f**2*g2*r + 11088*D1*Dd*Pk2*f**2*g2*s**2 - 17640*D1*Dd*Pk2*f**2*g2*s + 5796*D1*Dd*Pk2*f**2*g2 - 18144*D1*Dd*Pk2*f**2*gd2*r**2 - 48384*D1*Dd*Pk2*f**2*gd2*r*s + 33264*D1*Dd*Pk2*f**2*gd2*r - 18144*D1*Dd*Pk2*f**2*gd2*s**2 + 40824*D1*Dd*Pk2*f**2*gd2*s - 15120*D1*Dd*Pk2*f**2*gd2 - 36288*D1*Dd*Pk2*f*fd*g2*r**2 - 96768*D1*Dd*Pk2*f*fd*g2*r*s + 54432*D1*Dd*Pk2*f*fd*g2*r - 36288*D1*Dd*Pk2*f*fd*g2*s**2 + 51408*D1*Dd*Pk2*f*fd*g2*s - 16632*D1*Dd*Pk2*f*fd*g2 - 800*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 400*D1*Dd*Pkdd2*f**3*k1**2*s - 200*D1*Dd*Pkdd2*f**3*k1**2 - 840*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 490*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 70*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1296*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 648*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 324*D1*Dd*Pkdd2*f**2*g2*k1**2 - 720*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 180*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 1440*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 1080*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 180*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 2520*D1*Ddd*Pk2*b2*f**2*r**2 + 7056*D1*Ddd*Pk2*b2*f**2*r*s - 4284*D1*Ddd*Pk2*b2*f**2*r + 4536*D1*Ddd*Pk2*b2*f**2*s**2 - 5796*D1*Ddd*Pk2*b2*f**2*s + 2394*D1*Ddd*Pk2*b2*f**2 - 6552*D1*Ddd*Pk2*f**3*r**2 - 15336*D1*Ddd*Pk2*f**3*r*s + 10386*D1*Ddd*Pk2*f**3*r - 3240*D1*Ddd*Pk2*f**3*s**2 + 9288*D1*Ddd*Pk2*f**3*s - 4086*D1*Ddd*Pk2*f**3 - 9072*D1*Ddd*Pk2*f**2*g2*r**2 - 24192*D1*Ddd*Pk2*f**2*g2*r*s + 15120*D1*Ddd*Pk2*f**2*g2*r - 9072*D1*Ddd*Pk2*f**2*g2*s**2 + 16632*D1*Ddd*Pk2*f**2*g2*s - 6804*D1*Ddd*Pk2*f**2*g2 - 140*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 70*D1*Ddd*Pkdd2*f**3*k1**2*s - 35*D1*Ddd*Pkdd2*f**3*k1**2 - 360*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 180*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 90*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 3*D1*bd1*(D1*(3*f**3*(14*Pk2*(2*r**2 + r*(5*s - 6) - 5*s + 3) - 5*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 2*f**2*(Pk2*(-260*C*r**2 - 432*C*r*s + 21*K*(6*r**2 + 24*r*s - 12*r + 11*s**2 - 24*s + 6) + 21*fd*(12*r**2 + 5*r*(6*s - 5) - 20*s + 11) + 65*r**2 + 153*r*s + 66*r + 63*s + 21) + 3*Pkdd2*k1**2*(33*C*(s - 1)**2 - s**2*(9*K + 16) + 46*s - 23)) + 2*f*(Pk2*fd*(216*C*s + 126*K*(6*r**2 + 2*r*(8*s - 5) + 6*s**2 - 11*s + 4) + r**2*(32 - 632*C) + r*(-864*C*s + 532*C + 12*s + 119) + 102*s - 159) - 84*Pk2*g2*r*(3*r + 4*s) + 84*Pk2*gd2*(3*r**2 + r*(4*s - 3) - 2*s) + 15*Pkdd2*fd*k1**2*s*(16*C*(s - 1) + 2*K*s - K - 12*s + 12) + 133*Pkdd2*g2*k1**2*(s - 1)**2 - 168*Pkdd2*gd2*k1**2*s*(s - 1)) + 168*fd*g2*(Pk2*r*(3*r + 4*s - 2) - 2*Pkdd2*k1**2*s*(s - 1))) + 2*Dd*f*(-21*Pk2*f**2*(16*r**2 + r*(40*s - 37) - 30*s + 17) + f*(Pk2*(432*C*s + 126*K*(12*r**2 + r*(32*s - 22) + 12*s**2 - 27*s + 10) - r**2*(1264*C - 64) + r*(-1728*C*s + 848*C + 24*s + 517) + 414*s - 381) + 15*Pkdd2*k1**2*(4*s - 1)*(8*C*(s - 1) + s*(K - 6) + 6)) - 168*g2*(2*Pk2*(-3*r**2 + r*(2 - 4*s) + s) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 7560*Dd**2*Pk2*b2*f**2*r**2 + 21168*Dd**2*Pk2*b2*f**2*r*s - 12852*Dd**2*Pk2*b2*f**2*r + 13608*Dd**2*Pk2*b2*f**2*s**2 - 17388*Dd**2*Pk2*b2*f**2*s + 4788*Dd**2*Pk2*b2*f**2 - 19656*Dd**2*Pk2*f**3*r**2 - 46008*Dd**2*Pk2*f**3*r*s + 31158*Dd**2*Pk2*f**3*r - 9720*Dd**2*Pk2*f**3*s**2 + 27864*Dd**2*Pk2*f**3*s - 10944*Dd**2*Pk2*f**3 - 27216*Dd**2*Pk2*f**2*g2*r**2 - 72576*Dd**2*Pk2*f**2*g2*r*s + 45360*Dd**2*Pk2*f**2*g2*r - 27216*Dd**2*Pk2*f**2*g2*s**2 + 49896*Dd**2*Pk2*f**2*g2*s - 16632*Dd**2*Pk2*f**2*g2 - 420*Dd**2*Pkdd2*f**3*k1**2*s**2 + 210*Dd**2*Pkdd2*f**3*k1**2*s - 1080*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 540*Dd**2*Pkdd2*f**2*g2*k1**2*s + 3*b1**2*(D1**2*(fd**2*(-84*Pk2*(r - 1) - 90*Pkdd2*k1**2*s**2) + fd*(84*Pk2*r*(K*(3*r + 4*s - 4) + f + r + 2) + Pkdd2*k1**2*s**2*(-133*K + 180*f + 49)) - 6*fdd*(7*Pk2*r*(K*(3*r + 4*s - 4) + 2*f + r + 2) + Pkdd2*k1**2*s**2*(-14*K + 15*f + 7))) + D1*(Dd*(90*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + f*(168*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) - 2*fd*r + fd + 2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-133*K*(4*s**2 - 2*s + 1) + s**2*(196 - 720*fd) + s*(180*fd - 98) + 49)) - 84*fd*(2*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) + 2*r**2 + r - 1) + Pkdd2*k1**2*s*(K*(2 - 8*s) + 4*s - 1))) - 3*Ddd*f*(28*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + 2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-28*K + 15*f + 14)*(4*s**2 - 2*s + 1))) - 6*Dd**2*f*(14*Pk2*(K*(18*r**2 + 24*r*(s - 1) - 12*s + 7) + 6*r**2 - 6*r + 1) + Pkdd2*k1**2*s*(2*s - 1)*(-84*K + 45*f + 42))) - 3*b1*(-1040*C*D1**2*Pk2*f*fd*r**2 - 1728*C*D1**2*Pk2*f*fd*r*s + 1904*C*D1**2*Pk2*f*fd*r + 864*C*D1**2*Pk2*f*fd*s - 520*C*D1**2*Pk2*f*fd + 632*C*D1**2*Pk2*f*fdd*r**2 + 864*C*D1**2*Pk2*f*fdd*r*s - 1064*C*D1**2*Pk2*f*fdd*r - 432*C*D1**2*Pk2*f*fdd*s + 316*C*D1**2*Pk2*f*fdd + 632*C*D1**2*Pk2*fd**2*r**2 + 864*C*D1**2*Pk2*fd**2*r*s - 1064*C*D1**2*Pk2*fd**2*r - 432*C*D1**2*Pk2*fd**2*s + 432*C*D1**2*Pk2*fd**2 + 396*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 240*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 240*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 2080*C*D1*Dd*Pk2*f**2*r**2 - 3456*C*D1*Dd*Pk2*f**2*r*s + 2944*C*D1*Dd*Pk2*f**2*r + 1728*C*D1*Dd*Pk2*f**2*s - 1040*C*D1*Dd*Pk2*f**2 + 5056*C*D1*Dd*Pk2*f*fd*r**2 + 6912*C*D1*Dd*Pk2*f*fd*r*s - 7648*C*D1*Dd*Pk2*f*fd*r - 3456*C*D1*Dd*Pk2*f*fd*s + 2560*C*D1*Dd*Pk2*f*fd + 792*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 396*C*D1*Dd*Pkdd2*f**2*k1**2*s + 198*C*D1*Dd*Pkdd2*f**2*k1**2 - 1920*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 480*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 1264*C*D1*Ddd*Pk2*f**2*r**2 + 1728*C*D1*Ddd*Pk2*f**2*r*s - 1696*C*D1*Ddd*Pk2*f**2*r - 864*C*D1*Ddd*Pk2*f**2*s + 632*C*D1*Ddd*Pk2*f**2 - 480*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 240*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 120*C*D1*Ddd*Pkdd2*f**2*k1**2 + 3792*C*Dd**2*Pk2*f**2*r**2 + 5184*C*Dd**2*Pk2*f**2*r*s - 5088*C*Dd**2*Pk2*f**2*r - 2592*C*Dd**2*Pk2*f**2*s + 1496*C*Dd**2*Pk2*f**2 - 1440*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 720*C*Dd**2*Pkdd2*f**2*k1**2*s + 504*D1**2*K*Pk2*f*fd*r**2 + 2016*D1**2*K*Pk2*f*fd*r*s - 1008*D1**2*K*Pk2*f*fd*r + 924*D1**2*K*Pk2*f*fd*s**2 - 924*D1**2*K*Pk2*f*fd*s + 462*D1**2*K*Pk2*f*fd - 756*D1**2*K*Pk2*f*fdd*r**2 - 2016*D1**2*K*Pk2*f*fdd*r*s + 1008*D1**2*K*Pk2*f*fdd*r - 756*D1**2*K*Pk2*f*fdd*s**2 + 756*D1**2*K*Pk2*f*fdd*s - 378*D1**2*K*Pk2*f*fdd - 756*D1**2*K*Pk2*fd**2*r**2 - 2016*D1**2*K*Pk2*fd**2*r*s + 1008*D1**2*K*Pk2*fd**2*r - 756*D1**2*K*Pk2*fd**2*s**2 + 756*D1**2*K*Pk2*fd**2*s - 108*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 108*D1**2*K*Pkdd2*f*fd*k1**2*s - 54*D1**2*K*Pkdd2*f*fd*k1**2 - 30*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 30*D1**2*K*Pkdd2*f*fdd*k1**2*s - 15*D1**2*K*Pkdd2*f*fdd*k1**2 - 30*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 30*D1**2*K*Pkdd2*fd**2*k1**2*s + 42*D1**2*Pk2*bdd1*f*(K*(6*r**2 + r*(8*s - 6) - 4*s + 3) + 2*r**2 - r*(2*f + 4) + 1) - 252*D1**2*Pk2*f**2*fd*r**2 - 630*D1**2*Pk2*f**2*fd*r*s + 294*D1**2*Pk2*f**2*fd*r + 210*D1**2*Pk2*f**2*fd*s - 42*D1**2*Pk2*f**2*fd + 252*D1**2*Pk2*f**2*fdd*r**2 + 630*D1**2*Pk2*f**2*fdd*r*s - 294*D1**2*Pk2*f**2*fdd*r - 210*D1**2*Pk2*f**2*fdd*s + 42*D1**2*Pk2*f**2*fdd + 504*D1**2*Pk2*f*fd**2*r**2 + 1260*D1**2*Pk2*f*fd**2*r*s - 588*D1**2*Pk2*f*fd**2*r - 420*D1**2*Pk2*f*fd**2*s + 126*D1**2*Pk2*f*fd**2 + 260*D1**2*Pk2*f*fd*r**2 + 612*D1**2*Pk2*f*fd*r*s - 698*D1**2*Pk2*f*fd*r - 432*D1**2*Pk2*f*fd*s + 88*D1**2*Pk2*f*fd - 32*D1**2*Pk2*f*fdd*r**2 - 12*D1**2*Pk2*f*fdd*r*s + 314*D1**2*Pk2*f*fdd*r + 216*D1**2*Pk2*f*fdd*s - 100*D1**2*Pk2*f*fdd + 504*D1**2*Pk2*f*gd2*r**2 + 672*D1**2*Pk2*f*gd2*r*s - 1008*D1**2*Pk2*f*gd2*r - 672*D1**2*Pk2*f*gd2*s + 504*D1**2*Pk2*f*gd2 - 252*D1**2*Pk2*f*gdd2*r**2 - 336*D1**2*Pk2*f*gdd2*r*s + 504*D1**2*Pk2*f*gdd2*r + 336*D1**2*Pk2*f*gdd2*s - 252*D1**2*Pk2*f*gdd2 - 32*D1**2*Pk2*fd**2*r**2 - 12*D1**2*Pk2*fd**2*r*s + 314*D1**2*Pk2*fd**2*r + 216*D1**2*Pk2*fd**2*s - 324*D1**2*Pk2*fd**2 + 504*D1**2*Pk2*fd*g2*r**2 + 672*D1**2*Pk2*fd*g2*r*s - 672*D1**2*Pk2*fd*g2*r - 504*D1**2*Pk2*fd*gd2*r**2 - 672*D1**2*Pk2*fd*gd2*r*s + 840*D1**2*Pk2*fd*gd2*r + 336*D1**2*Pk2*fd*gd2*s - 336*D1**2*Pk2*fd*gd2 - 252*D1**2*Pk2*fdd*g2*r**2 - 336*D1**2*Pk2*fdd*g2*r*s + 336*D1**2*Pk2*fdd*g2*r + 3*D1**2*Pkdd2*bdd1*f*k1**2*(-28*K + 15*f + 14)*(2*s**2 - 2*s + 1) + 90*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 90*D1**2*Pkdd2*f**2*fd*k1**2*s + 45*D1**2*Pkdd2*f**2*fd*k1**2 - 192*D1**2*Pkdd2*f*fd*k1**2*s**2 - 84*D1**2*Pkdd2*f*fd*k1**2*s + 42*D1**2*Pkdd2*f*fd*k1**2 + 180*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 266*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 168*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 180*D1**2*Pkdd2*fd**2*k1**2*s**2 - 266*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 336*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 168*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + 1008*D1*Dd*K*Pk2*f**2*r**2 + 4032*D1*Dd*K*Pk2*f**2*r*s - 2016*D1*Dd*K*Pk2*f**2*r + 1848*D1*Dd*K*Pk2*f**2*s**2 - 2940*D1*Dd*K*Pk2*f**2*s + 966*D1*Dd*K*Pk2*f**2 - 6048*D1*Dd*K*Pk2*f*fd*r**2 - 16128*D1*Dd*K*Pk2*f*fd*r*s + 9072*D1*Dd*K*Pk2*f*fd*r - 6048*D1*Dd*K*Pk2*f*fd*s**2 + 8568*D1*Dd*K*Pk2*f*fd*s - 2772*D1*Dd*K*Pk2*f*fd - 216*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 108*D1*Dd*K*Pkdd2*f**2*k1**2*s - 54*D1*Dd*K*Pkdd2*f**2*k1**2 - 240*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 180*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 30*D1*Dd*K*Pkdd2*f*fd*k1**2 - 336*D1*Dd*Pk2*f**3*r**2 - 840*D1*Dd*Pk2*f**3*r*s + 546*D1*Dd*Pk2*f**3*r + 420*D1*Dd*Pk2*f**3*s - 168*D1*Dd*Pk2*f**3 + 2016*D1*Dd*Pk2*f**2*fd*r**2 + 5040*D1*Dd*Pk2*f**2*fd*r*s - 2814*D1*Dd*Pk2*f**2*fd*r - 2100*D1*Dd*Pk2*f**2*fd*s + 798*D1*Dd*Pk2*f**2*fd + 520*D1*Dd*Pk2*f**2*r**2 + 1224*D1*Dd*Pk2*f**2*r*s - 826*D1*Dd*Pk2*f**2*r - 612*D1*Dd*Pk2*f**2*s + 260*D1*Dd*Pk2*f**2 - 256*D1*Dd*Pk2*f*fd*r**2 - 96*D1*Dd*Pk2*f*fd*r*s + 1396*D1*Dd*Pk2*f*fd*r + 888*D1*Dd*Pk2*f*fd*s - 844*D1*Dd*Pk2*f*fd + 2016*D1*Dd*Pk2*f*g2*r**2 + 2688*D1*Dd*Pk2*f*g2*r*s - 2688*D1*Dd*Pk2*f*g2*r - 1344*D1*Dd*Pk2*f*g2*s + 1008*D1*Dd*Pk2*f*g2 - 2016*D1*Dd*Pk2*f*gd2*r**2 - 2688*D1*Dd*Pk2*f*gd2*r*s + 3360*D1*Dd*Pk2*f*gd2*r + 2016*D1*Dd*Pk2*f*gd2*s - 1344*D1*Dd*Pk2*f*gd2 - 2016*D1*Dd*Pk2*fd*g2*r**2 - 2688*D1*Dd*Pk2*fd*g2*r*s + 2688*D1*Dd*Pk2*fd*g2*r + 672*D1*Dd*Pk2*fd*g2*s - 672*D1*Dd*Pk2*fd*g2 + 120*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 60*D1*Dd*Pkdd2*f**3*k1**2*s + 30*D1*Dd*Pkdd2*f**3*k1**2 - 384*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 192*D1*Dd*Pkdd2*f**2*k1**2*s - 96*D1*Dd*Pkdd2*f**2*k1**2 + 1440*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 360*D1*Dd*Pkdd2*f*fd*k1**2*s - 1064*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 532*D1*Dd*Pkdd2*f*g2*k1**2*s - 266*D1*Dd*Pkdd2*f*g2*k1**2 + 1344*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 - 336*D1*Dd*Pkdd2*f*gd2*k1**2*s + 1344*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 - 336*D1*Dd*Pkdd2*fd*g2*k1**2*s - 1512*D1*Ddd*K*Pk2*f**2*r**2 - 4032*D1*Ddd*K*Pk2*f**2*r*s + 2520*D1*Ddd*K*Pk2*f**2*r - 1512*D1*Ddd*K*Pk2*f**2*s**2 + 2772*D1*Ddd*K*Pk2*f**2*s - 1134*D1*Ddd*K*Pk2*f**2 - 60*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 30*D1*Ddd*K*Pkdd2*f**2*k1**2*s - 15*D1*Ddd*K*Pkdd2*f**2*k1**2 + 336*D1*Ddd*Pk2*f**3*r**2 + 840*D1*Ddd*Pk2*f**3*r*s - 546*D1*Ddd*Pk2*f**3*r - 420*D1*Ddd*Pk2*f**3*s + 168*D1*Ddd*Pk2*f**3 - 64*D1*Ddd*Pk2*f**2*r**2 - 24*D1*Ddd*Pk2*f**2*r*s + 70*D1*Ddd*Pk2*f**2*r + 12*D1*Ddd*Pk2*f**2*s - 32*D1*Ddd*Pk2*f**2 - 1008*D1*Ddd*Pk2*f*g2*r**2 - 1344*D1*Ddd*Pk2*f*g2*r*s + 1344*D1*Ddd*Pk2*f*g2*r + 672*D1*Ddd*Pk2*f*g2*s - 504*D1*Ddd*Pk2*f*g2 + 360*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 180*D1*Ddd*Pkdd2*f**2*k1**2*s + 90*D1*Ddd*Pkdd2*f**2*k1**2 + 672*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 - 336*D1*Ddd*Pkdd2*f*g2*k1**2*s + 168*D1*Ddd*Pkdd2*f*g2*k1**2 + D1*bd1*(D1*(-6*f**2*(-14*Pk2*r + 15*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - f*(84*Pk2*(K*(6*r**2 + r*(8*s - 6) - 4*s + 3) + 2*r**2 - 4*r + 1) + Pkdd2*k1**2*(-133*K*(2*s**2 - 2*s + 1) + s**2*(98 - 360*fd) + s*(180*fd - 98) + 49)) - 84*fd*(K*Pk2*(-6*r**2 - 8*r*s + 7*r + 2*s - 2) - 2*Pk2*r**2 + Pk2 + Pkdd2*k1**2*s*(2*K - 1)*(2*s - 1))) + 6*Dd*f*(-28*Pk2*(2*r - 1)*(-2*K*(3*r + 4*s - 2) + f - 2*r + 2) + Pkdd2*k1**2*(-28*K + 15*f + 14)*(8*s**2 - 6*s + 1))) - 4536*Dd**2*K*Pk2*f**2*r**2 - 12096*Dd**2*K*Pk2*f**2*r*s + 7560*Dd**2*K*Pk2*f**2*r - 4536*Dd**2*K*Pk2*f**2*s**2 + 8316*Dd**2*K*Pk2*f**2*s - 2772*Dd**2*K*Pk2*f**2 - 180*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 90*Dd**2*K*Pkdd2*f**2*k1**2*s + 1008*Dd**2*Pk2*f**3*r**2 + 2520*Dd**2*Pk2*f**3*r*s - 1638*Dd**2*Pk2*f**3*r - 1260*Dd**2*Pk2*f**3*s + 588*Dd**2*Pk2*f**3 - 192*Dd**2*Pk2*f**2*r**2 - 72*Dd**2*Pk2*f**2*r*s + 210*Dd**2*Pk2*f**2*r + 36*Dd**2*Pk2*f**2*s - 44*Dd**2*Pk2*f**2 - 3024*Dd**2*Pk2*f*g2*r**2 - 4032*Dd**2*Pk2*f*g2*r*s + 4032*Dd**2*Pk2*f*g2*r + 2016*Dd**2*Pk2*f*g2*s - 1176*Dd**2*Pk2*f*g2 + 1080*Dd**2*Pkdd2*f**2*k1**2*s**2 - 540*Dd**2*Pkdd2*f**2*k1**2*s + 2016*Dd**2*Pkdd2*f*g2*k1**2*s**2 - 1008*Dd**2*Pkdd2*f*g2*k1**2*s))/(630*d**2*k3**4) + D1**2*Pk3*ct**4*st**2*(7200*C*D1**2*Pk2*f**2*fd*s**2 - 4800*C*D1**2*Pk2*f**2*fd*s + 2400*C*D1**2*Pk2*f**2*fd - 3600*C*D1**2*Pk2*f**2*fdd*s**2 + 2400*C*D1**2*Pk2*f**2*fdd*s - 1200*C*D1**2*Pk2*f**2*fdd - 7200*C*D1**2*Pk2*f*fd**2*s**2 + 4800*C*D1**2*Pk2*f*fd**2*s - 432*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 432*C*D1**2*Pkdd2*b1*f*fd*k1**2*s - 216*C*D1**2*Pkdd2*b1*f*fd*k1**2 + 216*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 216*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 108*C*D1**2*Pkdd2*b1*f*fdd*k1**2 + 216*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 216*C*D1**2*Pkdd2*b1*fd**2*k1**2*s + 108*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 9600*C*D1*Dd*Pk2*f**3*s**2 - 4800*C*D1*Dd*Pk2*f**3*s + 2400*C*D1*Dd*Pk2*f**3 - 28800*C*D1*Dd*Pk2*f**2*fd*s**2 + 16800*C*D1*Dd*Pk2*f**2*fd*s - 2400*C*D1*Dd*Pk2*f**2*fd - 864*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 432*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 216*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 1728*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 1296*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 216*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 - 4800*C*D1*Ddd*Pk2*f**3*s**2 + 2400*C*D1*Ddd*Pk2*f**3*s - 1200*C*D1*Ddd*Pk2*f**3 + 432*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 216*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 108*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 14400*C*Dd**2*Pk2*f**3*s**2 + 7200*C*Dd**2*Pk2*f**3*s + 1296*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 648*C*Dd**2*Pkdd2*b1*f**2*k1**2*s + 4320*D1**2*K*Pk2*b1*f*fd*s**2 - 4320*D1**2*K*Pk2*b1*f*fd*s + 2160*D1**2*K*Pk2*b1*f*fd - 2160*D1**2*K*Pk2*b1*f*fdd*s**2 + 2160*D1**2*K*Pk2*b1*f*fdd*s - 1080*D1**2*K*Pk2*b1*f*fdd - 2160*D1**2*K*Pk2*b1*fd**2*s**2 + 2160*D1**2*K*Pk2*b1*fd**2*s - 1080*D1**2*K*Pk2*bdd1*f**2*s**2 - 252*D1**2*K*Pkdd2*b1**2*fd*k1**2*s**2 + 504*D1**2*K*Pkdd2*b1**2*fd*k1**2*s - 252*D1**2*K*Pkdd2*b1**2*fd*k1**2 + 126*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s**2 - 252*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s + 126*D1**2*K*Pkdd2*b1**2*fdd*k1**2 + 252*D1**2*K*Pkdd2*b1*bdd1*f*k1**2*s**2 + 3240*D1**2*Pk2*b1*f**2*fd*r*s - 1080*D1**2*Pk2*b1*f**2*fd*r - 1080*D1**2*Pk2*b1*f**2*fd*s - 3240*D1**2*Pk2*b1*f**2*fdd*r*s + 1080*D1**2*Pk2*b1*f**2*fdd*r + 1080*D1**2*Pk2*b1*f**2*fdd*s - 6480*D1**2*Pk2*b1*f*fd**2*r*s + 2160*D1**2*Pk2*b1*f*fd**2*r + 2160*D1**2*Pk2*b1*f*fd**2*s - 1080*D1**2*Pk2*b1*f*fd**2 + 4320*D1**2*Pk2*b1*f*fd*r*s - 2160*D1**2*Pk2*b1*f*fd*r - 2160*D1**2*Pk2*b1*f*fdd*r*s + 1080*D1**2*Pk2*b1*f*fdd*r - 2160*D1**2*Pk2*b1*fd**2*r*s + 1080*D1**2*Pk2*b1*fd**2*r + 2160*D1**2*Pk2*bd2*f**2*s**2 - 4320*D1**2*Pk2*bd2*f*fd*s**2 + 2160*D1**2*Pk2*bd2*f*fd*s - 1080*D1**2*Pk2*bdd1*f**3*r*s + 1080*D1**2*Pk2*bdd1*f**3*s - 1080*D1**2*Pk2*bdd1*f**2*r*s + 1080*D1**2*Pk2*bdd1*f**2*s - 1080*D1**2*Pk2*bdd2*f**2*s**2 + 5712*D1**2*Pk2*f**2*fd*r*s - 1904*D1**2*Pk2*f**2*fd*r - 3600*D1**2*Pk2*f**2*fd*s**2 + 496*D1**2*Pk2*f**2*fd*s - 1200*D1**2*Pk2*f**2*fd - 3720*D1**2*Pk2*f**2*fdd*r*s + 1240*D1**2*Pk2*f**2*fdd*r + 1800*D1**2*Pk2*f**2*fdd*s**2 + 40*D1**2*Pk2*f**2*fdd*s + 600*D1**2*Pk2*f**2*fdd - 4320*D1**2*Pk2*f**2*gd2*s**2 + 2160*D1**2*Pk2*f**2*gdd2*s**2 - 7440*D1**2*Pk2*f*fd**2*r*s + 2480*D1**2*Pk2*f*fd**2*r + 3600*D1**2*Pk2*f*fd**2*s**2 + 80*D1**2*Pk2*f*fd**2*s - 1240*D1**2*Pk2*f*fd**2 - 8640*D1**2*Pk2*f*fd*g2*s**2 + 8640*D1**2*Pk2*f*fd*g2*s - 4320*D1**2*Pk2*f*fd*g2 + 8640*D1**2*Pk2*f*fd*gd2*s**2 - 4320*D1**2*Pk2*f*fd*gd2*s + 4320*D1**2*Pk2*f*fdd*g2*s**2 - 4320*D1**2*Pk2*f*fdd*g2*s + 2160*D1**2*Pk2*f*fdd*g2 + 4320*D1**2*Pk2*fd**2*g2*s**2 - 4320*D1**2*Pk2*fd**2*g2*s + 252*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 504*D1**2*Pkdd2*b1**2*fd*k1**2*s + 252*D1**2*Pkdd2*b1**2*fd*k1**2 - 126*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 252*D1**2*Pkdd2*b1**2*fdd*k1**2*s - 126*D1**2*Pkdd2*b1**2*fdd*k1**2 - 252*D1**2*Pkdd2*b1*bdd1*f*k1**2*s**2 - 1350*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 900*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 450*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 675*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 450*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 225*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 1350*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 900*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 288*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 288*D1**2*Pkdd2*b1*f*fd*k1**2*s - 144*D1**2*Pkdd2*b1*f*fd*k1**2 + 144*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 144*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 72*D1**2*Pkdd2*b1*f*fdd*k1**2 + 504*D1**2*Pkdd2*b1*f*gd2*k1**2*s**2 - 252*D1**2*Pkdd2*b1*f*gdd2*k1**2*s**2 + 144*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 144*D1**2*Pkdd2*b1*fd**2*k1**2*s + 504*D1**2*Pkdd2*b1*fd*g2*k1**2*s**2 - 1008*D1**2*Pkdd2*b1*fd*g2*k1**2*s + 504*D1**2*Pkdd2*b1*fd*g2*k1**2 - 504*D1**2*Pkdd2*b1*fd*gd2*k1**2*s**2 + 504*D1**2*Pkdd2*b1*fd*gd2*k1**2*s - 252*D1**2*Pkdd2*b1*fdd*g2*k1**2*s**2 + 504*D1**2*Pkdd2*b1*fdd*g2*k1**2*s - 252*D1**2*Pkdd2*b1*fdd*g2*k1**2 + 252*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(K - 1) + 225*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 72*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 252*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 600*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 400*D1**2*Pkdd2*f**2*fd*k1**2*s - 200*D1**2*Pkdd2*f**2*fd*k1**2 + 300*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 200*D1**2*Pkdd2*f**2*fdd*k1**2*s + 100*D1**2*Pkdd2*f**2*fdd*k1**2 + 600*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 400*D1**2*Pkdd2*f*fd**2*k1**2*s + 8640*D1*Dd*K*Pk2*b1*f**2*s**2 - 4320*D1*Dd*K*Pk2*b1*f**2*s + 2160*D1*Dd*K*Pk2*b1*f**2 - 17280*D1*Dd*K*Pk2*b1*f*fd*s**2 + 12960*D1*Dd*K*Pk2*b1*f*fd*s - 2160*D1*Dd*K*Pk2*b1*f*fd - 1008*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s**2 + 504*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s - 252*D1*Dd*K*Pkdd2*b1**2*f*k1**2 + 1008*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s**2 - 1260*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s + 252*D1*Dd*K*Pkdd2*b1**2*fd*k1**2 + 4320*D1*Dd*Pk2*b1*f**3*r*s - 1080*D1*Dd*Pk2*b1*f**3*r - 2160*D1*Dd*Pk2*b1*f**3*s - 25920*D1*Dd*Pk2*b1*f**2*fd*r*s + 7560*D1*Dd*Pk2*b1*f**2*fd*r + 10800*D1*Dd*Pk2*b1*f**2*fd*s - 3240*D1*Dd*Pk2*b1*f**2*fd + 8640*D1*Dd*Pk2*b1*f**2*r*s - 2160*D1*Dd*Pk2*b1*f**2*r - 4320*D1*Dd*Pk2*b1*f**2*s - 17280*D1*Dd*Pk2*b1*f*fd*r*s + 6480*D1*Dd*Pk2*b1*f*fd*r + 4320*D1*Dd*Pk2*b1*f*fd*s - 2160*D1*Dd*Pk2*b1*f*fd - 8640*D1*Dd*Pk2*bd2*f**2*s**2 + 2160*D1*Dd*Pk2*bd2*f**2*s + 7616*D1*Dd*Pk2*f**3*r*s - 1904*D1*Dd*Pk2*f**3*r - 4800*D1*Dd*Pk2*f**3*s**2 - 1408*D1*Dd*Pk2*f**3*s - 1200*D1*Dd*Pk2*f**3 - 29760*D1*Dd*Pk2*f**2*fd*r*s + 8680*D1*Dd*Pk2*f**2*fd*r + 14400*D1*Dd*Pk2*f**2*fd*s**2 + 4000*D1*Dd*Pk2*f**2*fd*s - 2520*D1*Dd*Pk2*f**2*fd - 17280*D1*Dd*Pk2*f**2*g2*s**2 + 8640*D1*Dd*Pk2*f**2*g2*s - 4320*D1*Dd*Pk2*f**2*g2 + 17280*D1*Dd*Pk2*f**2*gd2*s**2 - 4320*D1*Dd*Pk2*f**2*gd2*s + 34560*D1*Dd*Pk2*f*fd*g2*s**2 - 25920*D1*Dd*Pk2*f*fd*g2*s + 4320*D1*Dd*Pk2*f*fd*g2 + 1008*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 504*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 252*D1*Dd*Pkdd2*b1**2*f*k1**2 - 1008*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 1260*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 252*D1*Dd*Pkdd2*b1**2*fd*k1**2 - 1800*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 900*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 450*D1*Dd*Pkdd2*b1*f**3*k1**2 + 5400*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 3150*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 450*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 576*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 288*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 144*D1*Dd*Pkdd2*b1*f**2*k1**2 + 1152*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 864*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 144*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 2016*D1*Dd*Pkdd2*b1*f*g2*k1**2*s**2 - 1008*D1*Dd*Pkdd2*b1*f*g2*k1**2*s + 504*D1*Dd*Pkdd2*b1*f*g2*k1**2 - 2016*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s**2 + 504*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s - 2016*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s**2 + 2520*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s - 504*D1*Dd*Pkdd2*b1*fd*g2*k1**2 - 800*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 400*D1*Dd*Pkdd2*f**3*k1**2*s - 200*D1*Dd*Pkdd2*f**3*k1**2 + 2400*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 1400*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 200*D1*Dd*Pkdd2*f**2*fd*k1**2 - 4320*D1*Ddd*K*Pk2*b1*f**2*s**2 + 2160*D1*Ddd*K*Pk2*b1*f**2*s - 1080*D1*Ddd*K*Pk2*b1*f**2 + 504*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s**2 - 252*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s + 126*D1*Ddd*K*Pkdd2*b1**2*f*k1**2 - 4320*D1*Ddd*Pk2*b1*f**3*r*s + 1080*D1*Ddd*Pk2*b1*f**3*r + 2160*D1*Ddd*Pk2*b1*f**3*s - 4320*D1*Ddd*Pk2*b1*f**2*r*s + 1080*D1*Ddd*Pk2*b1*f**2*r + 2160*D1*Ddd*Pk2*b1*f**2*s - 4960*D1*Ddd*Pk2*f**3*r*s + 1240*D1*Ddd*Pk2*f**3*r + 2400*D1*Ddd*Pk2*f**3*s**2 + 1280*D1*Ddd*Pk2*f**3*s + 600*D1*Ddd*Pk2*f**3 + 8640*D1*Ddd*Pk2*f**2*g2*s**2 - 4320*D1*Ddd*Pk2*f**2*g2*s + 2160*D1*Ddd*Pk2*f**2*g2 - 504*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 252*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 126*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 900*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 450*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 225*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 288*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 144*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 72*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 1008*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s**2 + 504*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s - 252*D1*Ddd*Pkdd2*b1*f*g2*k1**2 + 400*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 200*D1*Ddd*Pkdd2*f**3*k1**2*s + 100*D1*Ddd*Pkdd2*f**3*k1**2 + 18*D1*bd1*(D1*(-28*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) + 5*f**3*s*(12*Pk2*(r - 1) - 5*Pkdd2*k1**2*s) + f**2*(-5*fd*(12*Pk2*(6*r*s - r - 4*s + 1) + 5*Pkdd2*k1**2*s*(1 - 3*s)) - 4*s*(-30*Pk2*(K*s + r - 1) + Pkdd2*k1**2*s*(3*C + 2))) - 4*f*(Pkdd2*k1**2*s**2*(7*b1*(K - 1) - 7*g2 + 7*gd2) + fd*(15*Pk2*(r*(4*s - 1) + (2*s - 1)*(2*K*s - 1)) - Pkdd2*k1**2*s*(3*C + 2)*(2*s - 1)))) + Dd*f*(-60*Pk2*f*(8*K*s**2 + r*(8*s - 1) - s*(2*K + 6) + 1) + Pkdd2*f*k1**2*s*(12*C + 8)*(4*s - 1) - Pkdd2*k1**2*s*(4*s - 1)*(-28*K*b1 + 28*b1 + 28*g2) - 5*f**2*(12*Pk2*(r*(8*s - 1) - 6*s + 1) + 5*Pkdd2*k1**2*s*(1 - 4*s)))) - 12960*Dd**2*K*Pk2*b1*f**2*s**2 + 6480*Dd**2*K*Pk2*b1*f**2*s + 1512*Dd**2*K*Pkdd2*b1**2*f*k1**2*s**2 - 756*Dd**2*K*Pkdd2*b1**2*f*k1**2*s - 12960*Dd**2*Pk2*b1*f**3*r*s + 3240*Dd**2*Pk2*b1*f**3*r + 6480*Dd**2*Pk2*b1*f**3*s - 2160*Dd**2*Pk2*b1*f**3 - 12960*Dd**2*Pk2*b1*f**2*r*s + 3240*Dd**2*Pk2*b1*f**2*r + 6480*Dd**2*Pk2*b1*f**2*s - 2160*Dd**2*Pk2*b1*f**2 - 14880*Dd**2*Pk2*f**3*r*s + 3720*Dd**2*Pk2*f**3*r + 7200*Dd**2*Pk2*f**3*s**2 + 3840*Dd**2*Pk2*f**3*s - 2480*Dd**2*Pk2*f**3 + 25920*Dd**2*Pk2*f**2*g2*s**2 - 12960*Dd**2*Pk2*f**2*g2*s - 1512*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 756*Dd**2*Pkdd2*b1**2*f*k1**2*s + 2700*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 1350*Dd**2*Pkdd2*b1*f**3*k1**2*s + 864*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 432*Dd**2*Pkdd2*b1*f**2*k1**2*s - 3024*Dd**2*Pkdd2*b1*f*g2*k1**2*s**2 + 1512*Dd**2*Pkdd2*b1*f*g2*k1**2*s + 1200*Dd**2*Pkdd2*f**3*k1**2*s**2 - 600*Dd**2*Pkdd2*f**3*k1**2*s + 1080*Pk2*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(630*d**2*k3**2) + D1**2*Pk3*ct**4*(348*C*D1**2*Pk2*bdd1*f**2*r**2 - 1296*C*D1**2*Pk2*bdd1*f**2*r*s - 4080*C*D1**2*Pk2*f**2*fd*r*s + 1360*C*D1**2*Pk2*f**2*fd*r - 5940*C*D1**2*Pk2*f**2*fd*s**2 + 5320*C*D1**2*Pk2*f**2*fd*s - 1980*C*D1**2*Pk2*f**2*fd + 3120*C*D1**2*Pk2*f**2*fdd*r*s - 1040*C*D1**2*Pk2*f**2*fdd*r + 4860*C*D1**2*Pk2*f**2*fdd*s**2 - 4280*C*D1**2*Pk2*f**2*fdd*s + 1620*C*D1**2*Pk2*f**2*fdd + 6240*C*D1**2*Pk2*f*fd**2*r*s - 2080*C*D1**2*Pk2*f*fd**2*r + 9720*C*D1**2*Pk2*f*fd**2*s**2 - 8560*C*D1**2*Pk2*f*fd**2*s + 1040*C*D1**2*Pk2*f*fd**2 + 420*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 280*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 140*C*D1**2*Pkdd2*f**2*fd*k1**2 - 210*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 140*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 70*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 420*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 280*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 5440*C*D1*Dd*Pk2*f**3*r*s + 1360*C*D1*Dd*Pk2*f**3*r - 7920*C*D1*Dd*Pk2*f**3*s**2 + 6680*C*D1*Dd*Pk2*f**3*s - 1980*C*D1*Dd*Pk2*f**3 + 24960*C*D1*Dd*Pk2*f**2*fd*r*s - 7280*C*D1*Dd*Pk2*f**2*fd*r + 38880*C*D1*Dd*Pk2*f**2*fd*s**2 - 33080*C*D1*Dd*Pk2*f**2*fd*s + 6360*C*D1*Dd*Pk2*f**2*fd + 560*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 280*C*D1*Dd*Pkdd2*f**3*k1**2*s + 140*C*D1*Dd*Pkdd2*f**3*k1**2 - 1680*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 980*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 140*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 4160*C*D1*Ddd*Pk2*f**3*r*s - 1040*C*D1*Ddd*Pk2*f**3*r + 6480*C*D1*Ddd*Pk2*f**3*s**2 - 5320*C*D1*Ddd*Pk2*f**3*s + 1620*C*D1*Ddd*Pk2*f**3 - 280*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 140*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 70*C*D1*Ddd*Pkdd2*f**3*k1**2 + 12480*C*Dd**2*Pk2*f**3*r*s - 3120*C*Dd**2*Pk2*f**3*r + 19440*C*Dd**2*Pk2*f**3*s**2 - 15960*C*Dd**2*Pk2*f**3*s + 2080*C*Dd**2*Pk2*f**3 - 840*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 420*C*Dd**2*Pkdd2*f**3*k1**2*s + 504*D1**2*K*Pk2*bdd1*f**2*r*s + 1134*D1**2*K*Pk2*bdd1*f**2*s**2 - 504*D1**2*K*Pk2*bdd1*f**2*s - 45*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 1008*D1**2*Pk2*b2*f*fd*r*s + 504*D1**2*Pk2*b2*f*fd*r - 2772*D1**2*Pk2*b2*f*fd*s**2 + 2772*D1**2*Pk2*b2*f*fd*s - 1386*D1**2*Pk2*b2*f*fd + 1008*D1**2*Pk2*b2*f*fdd*r*s - 504*D1**2*Pk2*b2*f*fdd*r + 2268*D1**2*Pk2*b2*f*fdd*s**2 - 2268*D1**2*Pk2*b2*f*fdd*s + 1134*D1**2*Pk2*b2*f*fdd + 1008*D1**2*Pk2*b2*fd**2*r*s - 504*D1**2*Pk2*b2*fd**2*r + 2268*D1**2*Pk2*b2*fd**2*s**2 - 2268*D1**2*Pk2*b2*fd**2*s - 504*D1**2*Pk2*bd2*f**2*r*s - 1386*D1**2*Pk2*bd2*f**2*s**2 + 504*D1**2*Pk2*bd2*f**2*s + 2016*D1**2*Pk2*bd2*f*fd*r*s - 504*D1**2*Pk2*bd2*f*fd*r + 4536*D1**2*Pk2*bd2*f*fd*s**2 - 3276*D1**2*Pk2*bd2*f*fd*s + 504*D1**2*Pk2*bd2*f*fd + 378*D1**2*Pk2*bdd1*f**3*r**2 + 630*D1**2*Pk2*bdd1*f**3*r*s - 504*D1**2*Pk2*bdd1*f**3*r - 630*D1**2*Pk2*bdd1*f**3*s + 252*D1**2*Pk2*bdd1*f**3 - 96*D1**2*Pk2*bdd1*f**2*r**2 + 1278*D1**2*Pk2*bdd1*f**2*r*s - 180*D1**2*Pk2*bdd1*f**2*r - 630*D1**2*Pk2*bdd1*f**2*s + 252*D1**2*Pk2*bdd1*f**2 - 252*D1**2*Pk2*bdd1*f*g2*r**2 + 1008*D1**2*Pk2*bdd1*f*g2*r*s + 504*D1**2*Pk2*bdd2*f**2*r*s + 1134*D1**2*Pk2*bdd2*f**2*s**2 - 504*D1**2*Pk2*bdd2*f**2*s - 1788*D1**2*Pk2*f**2*fd*r**2 - 954*D1**2*Pk2*f**2*fd*r*s + 1510*D1**2*Pk2*f**2*fd*r + 2970*D1**2*Pk2*f**2*fd*s**2 - 1662*D1**2*Pk2*f**2*fd*s + 394*D1**2*Pk2*f**2*fd + 948*D1**2*Pk2*f**2*fdd*r**2 + 774*D1**2*Pk2*f**2*fdd*r*s - 890*D1**2*Pk2*f**2*fdd*r - 2430*D1**2*Pk2*f**2*fdd*s**2 + 1362*D1**2*Pk2*f**2*fdd*s - 494*D1**2*Pk2*f**2*fdd + 1008*D1**2*Pk2*f**2*gd2*r*s + 2772*D1**2*Pk2*f**2*gd2*s**2 - 1008*D1**2*Pk2*f**2*gd2*s - 1008*D1**2*Pk2*f**2*gdd2*r*s - 2268*D1**2*Pk2*f**2*gdd2*s**2 + 1008*D1**2*Pk2*f**2*gdd2*s + 1896*D1**2*Pk2*f*fd**2*r**2 + 1548*D1**2*Pk2*f*fd**2*r*s - 1780*D1**2*Pk2*f*fd**2*r - 4860*D1**2*Pk2*f*fd**2*s**2 + 2724*D1**2*Pk2*f*fd**2*s + 258*D1**2*Pk2*f*fd**2 + 2016*D1**2*Pk2*f*fd*g2*r*s - 1008*D1**2*Pk2*f*fd*g2*r + 5544*D1**2*Pk2*f*fd*g2*s**2 - 5544*D1**2*Pk2*f*fd*g2*s + 2772*D1**2*Pk2*f*fd*g2 - 4032*D1**2*Pk2*f*fd*gd2*r*s + 1008*D1**2*Pk2*f*fd*gd2*r - 9072*D1**2*Pk2*f*fd*gd2*s**2 + 6552*D1**2*Pk2*f*fd*gd2*s - 1008*D1**2*Pk2*f*fd*gd2 - 2016*D1**2*Pk2*f*fdd*g2*r*s + 1008*D1**2*Pk2*f*fdd*g2*r - 4536*D1**2*Pk2*f*fdd*g2*s**2 + 4536*D1**2*Pk2*f*fdd*g2*s - 2268*D1**2*Pk2*f*fdd*g2 - 2016*D1**2*Pk2*fd**2*g2*r*s + 1008*D1**2*Pk2*fd**2*g2*r - 4536*D1**2*Pk2*fd**2*g2*s**2 + 4536*D1**2*Pk2*fd**2*g2*s + 180*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 - 180*D1**2*Pkdd2*b2*f*fd*k1**2*s + 90*D1**2*Pkdd2*b2*f*fd*k1**2 - 90*D1**2*Pkdd2*b2*f*fdd*k1**2*s**2 + 90*D1**2*Pkdd2*b2*f*fdd*k1**2*s - 45*D1**2*Pkdd2*b2*f*fdd*k1**2 - 90*D1**2*Pkdd2*b2*fd**2*k1**2*s**2 + 90*D1**2*Pkdd2*b2*fd**2*k1**2*s + 90*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 - 180*D1**2*Pkdd2*bd2*f*fd*k1**2*s**2 + 90*D1**2*Pkdd2*bd2*f*fd*k1**2*s + 90*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 180*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 90*D1**2*Pkdd2*bdd1*f**2*k1**2 - 45*D1**2*Pkdd2*bdd2*f**2*k1**2*s**2 + 60*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 40*D1**2*Pkdd2*f**2*fd*k1**2*s + 20*D1**2*Pkdd2*f**2*fd*k1**2 + 105*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 70*D1**2*Pkdd2*f**2*fdd*k1**2*s + 35*D1**2*Pkdd2*f**2*fdd*k1**2 - 180*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 90*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 210*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 140*D1**2*Pkdd2*f*fd**2*k1**2*s - 360*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 360*D1**2*Pkdd2*f*fd*g2*k1**2*s - 180*D1**2*Pkdd2*f*fd*g2*k1**2 + 360*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 180*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 180*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 180*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 90*D1**2*Pkdd2*f*fdd*g2*k1**2 + 180*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 180*D1**2*Pkdd2*fd**2*g2*k1**2*s + 6*D1**2*bd1**2*(-70*Pkdd2*g2*k1**2*s*(s - 1) + f**2*(42*Pk2*(r - 1) + 15*Pkdd2*k1**2*s*(2*s - 3)) + 42*f*(C*Pkdd2*k1**2*s*(s - 1) + Pk2*(2*K*s + r**2*(K - 1) - r*(4*K*s + K - 2) - 1))) - 2016*D1*Dd*Pk2*b2*f**2*r*s + 504*D1*Dd*Pk2*b2*f**2*r - 5544*D1*Dd*Pk2*b2*f**2*s**2 + 3780*D1*Dd*Pk2*b2*f**2*s - 1386*D1*Dd*Pk2*b2*f**2 + 8064*D1*Dd*Pk2*b2*f*fd*r*s - 3024*D1*Dd*Pk2*b2*f*fd*r + 18144*D1*Dd*Pk2*b2*f*fd*s**2 - 15624*D1*Dd*Pk2*b2*f*fd*s + 3276*D1*Dd*Pk2*b2*f*fd + 4032*D1*Dd*Pk2*bd2*f**2*r*s - 504*D1*Dd*Pk2*bd2*f**2*r + 9072*D1*Dd*Pk2*bd2*f**2*s**2 - 5292*D1*Dd*Pk2*bd2*f**2*s + 504*D1*Dd*Pk2*bd2*f**2 - 2384*D1*Dd*Pk2*f**3*r**2 - 1272*D1*Dd*Pk2*f**3*r*s + 2702*D1*Dd*Pk2*f**3*r + 3960*D1*Dd*Pk2*f**3*s**2 - 1344*D1*Dd*Pk2*f**3*s - 202*D1*Dd*Pk2*f**3 + 7584*D1*Dd*Pk2*f**2*fd*r**2 + 6192*D1*Dd*Pk2*f**2*fd*r*s - 8126*D1*Dd*Pk2*f**2*fd*r - 19440*D1*Dd*Pk2*f**2*fd*s**2 + 8760*D1*Dd*Pk2*f**2*fd*s + 418*D1*Dd*Pk2*f**2*fd + 4032*D1*Dd*Pk2*f**2*g2*r*s - 1008*D1*Dd*Pk2*f**2*g2*r + 11088*D1*Dd*Pk2*f**2*g2*s**2 - 7560*D1*Dd*Pk2*f**2*g2*s + 2772*D1*Dd*Pk2*f**2*g2 - 8064*D1*Dd*Pk2*f**2*gd2*r*s + 1008*D1*Dd*Pk2*f**2*gd2*r - 18144*D1*Dd*Pk2*f**2*gd2*s**2 + 10584*D1*Dd*Pk2*f**2*gd2*s - 1008*D1*Dd*Pk2*f**2*gd2 - 16128*D1*Dd*Pk2*f*fd*g2*r*s + 6048*D1*Dd*Pk2*f*fd*g2*r - 36288*D1*Dd*Pk2*f*fd*g2*s**2 + 31248*D1*Dd*Pk2*f*fd*g2*s - 6552*D1*Dd*Pk2*f*fd*g2 + 360*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 - 180*D1*Dd*Pkdd2*b2*f**2*k1**2*s + 90*D1*Dd*Pkdd2*b2*f**2*k1**2 - 720*D1*Dd*Pkdd2*b2*f*fd*k1**2*s**2 + 540*D1*Dd*Pkdd2*b2*f*fd*k1**2*s - 90*D1*Dd*Pkdd2*b2*f*fd*k1**2 - 360*D1*Dd*Pkdd2*bd2*f**2*k1**2*s**2 + 90*D1*Dd*Pkdd2*bd2*f**2*k1**2*s + 80*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 40*D1*Dd*Pkdd2*f**3*k1**2*s + 20*D1*Dd*Pkdd2*f**3*k1**2 + 840*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 490*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 70*D1*Dd*Pkdd2*f**2*fd*k1**2 - 720*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 360*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 180*D1*Dd*Pkdd2*f**2*g2*k1**2 + 720*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 180*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 1440*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 1080*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 180*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 2016*D1*Ddd*Pk2*b2*f**2*r*s - 504*D1*Ddd*Pk2*b2*f**2*r + 4536*D1*Ddd*Pk2*b2*f**2*s**2 - 3276*D1*Ddd*Pk2*b2*f**2*s + 1134*D1*Ddd*Pk2*b2*f**2 + 1264*D1*Ddd*Pk2*f**3*r**2 + 1032*D1*Ddd*Pk2*f**3*r*s - 1522*D1*Ddd*Pk2*f**3*r - 3240*D1*Ddd*Pk2*f**3*s**2 + 1104*D1*Ddd*Pk2*f**3*s - 178*D1*Ddd*Pk2*f**3 - 4032*D1*Ddd*Pk2*f**2*g2*r*s + 1008*D1*Ddd*Pk2*f**2*g2*r - 9072*D1*Ddd*Pk2*f**2*g2*s**2 + 6552*D1*Ddd*Pk2*f**2*g2*s - 2268*D1*Ddd*Pk2*f**2*g2 - 180*D1*Ddd*Pkdd2*b2*f**2*k1**2*s**2 + 90*D1*Ddd*Pkdd2*b2*f**2*k1**2*s - 45*D1*Ddd*Pkdd2*b2*f**2*k1**2 + 140*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 70*D1*Ddd*Pkdd2*f**3*k1**2*s + 35*D1*Ddd*Pkdd2*f**3*k1**2 + 360*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 180*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 90*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 3*D1*bd1*(D1*(168*Pk2*fd*g2*r*(r - 4*s + 2) + 3*f**3*(14*Pk2*(3*r**2 + r*(5*s - 4) - 5*s + 2) - 15*Pkdd2*k1**2*s**2) - 2*f**2*(Pk2*(-231*K*s**2 + 21*fd*(18*r**2 + 5*r*(6*s - 5) - 20*s + 9) + r**2*(130 - 172*C) + 3*r*(s*(144*C - 28*K - 121) - 8) + 21*s*(4*K + 7) - 42) + 3*Pkdd2*k1**2*(s**2*(7*C + 5*K - 10) + 20*s - 10)) - 2*f*(Pk2*fd*(216*C*s + 42*K*(r*(8*s - 2) + 18*s**2 - 13*s + 2) + r**2*(232*C - 64) + r*(-864*C*s + 100*C + 852*s - 211) - 318*s + 51) + 84*Pk2*g2*r*(r - 4*s) - 84*Pk2*gd2*(r**2 - r*(4*s + 1) + 2*s) + 15*Pkdd2*fd*k1**2*s*(-2*K*s + K + 4*s - 4) - 35*Pkdd2*g2*k1**2*s**2)) - 2*Dd*f*(21*Pk2*f**2*(24*r**2 + r*(40*s - 33) - 30*s + 13) - 336*Pk2*g2*(r**2 - 4*r*s + s) + f*(Pk2*(432*C*s + 42*K*(2*r*(8*s - 1) + 36*s**2 - 21*s + 2) + r**2*(464*C - 128) - r*(1728*C*s + 16*C - 1704*s + 269) - 846*s + 165) - 15*Pkdd2*k1**2*(4*s - 1)*(s*(K - 2) + 2)))) + 6048*Dd**2*Pk2*b2*f**2*r*s - 1512*Dd**2*Pk2*b2*f**2*r + 13608*Dd**2*Pk2*b2*f**2*s**2 - 9828*Dd**2*Pk2*b2*f**2*s + 1008*Dd**2*Pk2*b2*f**2 + 3792*Dd**2*Pk2*f**3*r**2 + 3096*Dd**2*Pk2*f**3*r*s - 4566*Dd**2*Pk2*f**3*r - 9720*Dd**2*Pk2*f**3*s**2 + 3312*Dd**2*Pk2*f**3*s + 1148*Dd**2*Pk2*f**3 - 12096*Dd**2*Pk2*f**2*g2*r*s + 3024*Dd**2*Pk2*f**2*g2*r - 27216*Dd**2*Pk2*f**2*g2*s**2 + 19656*Dd**2*Pk2*f**2*g2*s - 2016*Dd**2*Pk2*f**2*g2 - 540*Dd**2*Pkdd2*b2*f**2*k1**2*s**2 + 270*Dd**2*Pkdd2*b2*f**2*k1**2*s + 420*Dd**2*Pkdd2*f**3*k1**2*s**2 - 210*Dd**2*Pkdd2*f**3*k1**2*s + 1080*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 540*Dd**2*Pkdd2*f**2*g2*k1**2*s - 105*Pkdd2*b1**3*k1**2*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 3*b1**2*(D1**2*(42*C*Pkdd2*fdd*k1**2*s**2 + 42*K*Pk2*fdd*r**2 - 168*K*Pk2*fdd*r*s + 168*K*Pk2*fdd*r + 105*K*Pkdd2*bdd1*k1**2*s**2 - 70*K*Pkdd2*bdd1*k1**2*s + 35*K*Pkdd2*bdd1*k1**2 - 84*Pk2*f*fdd*r - 42*Pk2*fdd*r**2 - 84*Pk2*fdd*r - 70*Pkdd2*bd1*k1**2*(K - 1)*(3*s**2 - 2*s + 1) - 105*Pkdd2*bdd1*k1**2*s**2 + 70*Pkdd2*bdd1*k1**2*s - 35*Pkdd2*bdd1*k1**2 + 60*Pkdd2*f*fdd*k1**2*s**2 + 30*Pkdd2*f*fdd*k1**2*s - 15*Pkdd2*f*fdd*k1**2 + 140*Pkdd2*gd2*k1**2*s**2 - 70*Pkdd2*gdd2*k1**2*s**2 + fd**2*(-84*Pk2*(r - 1) + 30*Pkdd2*k1**2*s*(2*s + 1)) + fd*(84*Pk2*r*(-K*(r - 4*s + 4) + f + r + 2) - Pkdd2*k1**2*(-35*K*(s - 1)**2 + 30*f*(4*s**2 + 2*s - 1) + 7*s**2*(12*C + 5) - 70*s + 35))) + D1*(-Dd*(168*Pk2*f*(K*(2*r**2 - 8*r*s + 4*s + 1) + fd*(2*r - 1) - 2*r**2 + 2*r - 1) + 60*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*f*k1**2*(84*C*(4*s**2 - 2*s + 1) - 5*fd*(96*s**2 - 6) - 5*(7*K - 7)*(4*s**2 - 2*s + 1)) - 70*Pkdd2*k1**2*(bd1*(K - 1)*(12*s**2 - 7*s + 1) + 2*g2*(4*s**2 - 2*s + 1) + 2*gd2*s*(1 - 4*s)) - 84*fd*(C*Pkdd2*k1**2*s*(4*s - 1) + 2*Pk2*(2*K*(r**2 - 4*r*s + 2*r + s - 1) - 2*r**2 - r + 1))) + 2*Ddd*(15*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) - 35*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 21*f*(C*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + 2*Pk2*(2*K*r**2 - 8*K*r*s + 4*K*s + K - 2*r**2 + 2*r - 1)))) + 12*Dd**2*(15*Pkdd2*f**2*k1**2*s*(2*s - 1) + 35*Pkdd2*g2*k1**2*s*(1 - 2*s) + 7*f*(3*C*Pkdd2*k1**2*s*(2*s - 1) + Pk2*(3*K*(2*r**2 - 8*r*s + 4*s - 1) - 6*r**2 + 6*r - 1)))) + 3*b1*(-688*C*D1**2*Pk2*f*fd*r**2 + 1728*C*D1**2*Pk2*f*fd*r*s - 176*C*D1**2*Pk2*f*fd*r - 864*C*D1**2*Pk2*f*fd*s - 344*C*D1**2*Pk2*f*fd + 232*C*D1**2*Pk2*f*fdd*r**2 - 864*C*D1**2*Pk2*f*fdd*r*s + 200*C*D1**2*Pk2*f*fdd*r + 432*C*D1**2*Pk2*f*fdd*s + 116*C*D1**2*Pk2*f*fdd + 232*C*D1**2*Pk2*fd**2*r**2 - 864*C*D1**2*Pk2*fd**2*r*s + 200*C*D1**2*Pk2*fd**2*r + 432*C*D1**2*Pk2*fd**2*s - 432*C*D1**2*Pk2*fd**2 + 84*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 84*C*D1**2*Pkdd2*f*fd*k1**2*s + 42*C*D1**2*Pkdd2*f*fd*k1**2 - 1376*C*D1*Dd*Pk2*f**2*r**2 + 3456*C*D1*Dd*Pk2*f**2*r*s + 512*C*D1*Dd*Pk2*f**2*r - 1728*C*D1*Dd*Pk2*f**2*s - 688*C*D1*Dd*Pk2*f**2 + 1856*C*D1*Dd*Pk2*f*fd*r**2 - 6912*C*D1*Dd*Pk2*f*fd*r*s + 736*C*D1*Dd*Pk2*f*fd*r + 3456*C*D1*Dd*Pk2*f*fd*s - 832*C*D1*Dd*Pk2*f*fd + 168*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 84*C*D1*Dd*Pkdd2*f**2*k1**2*s + 42*C*D1*Dd*Pkdd2*f**2*k1**2 + 464*C*D1*Ddd*Pk2*f**2*r**2 - 1728*C*D1*Ddd*Pk2*f**2*r*s - 32*C*D1*Ddd*Pk2*f**2*r + 864*C*D1*Ddd*Pk2*f**2*s + 232*C*D1*Ddd*Pk2*f**2 + 1392*C*Dd**2*Pk2*f**2*r**2 - 5184*C*Dd**2*Pk2*f**2*r*s - 96*C*Dd**2*Pk2*f**2*r + 2592*C*Dd**2*Pk2*f**2*s - 632*C*Dd**2*Pk2*f**2 - 336*D1**2*K*Pk2*f*fd*r*s + 168*D1**2*K*Pk2*f*fd*r - 924*D1**2*K*Pk2*f*fd*s**2 + 924*D1**2*K*Pk2*f*fd*s - 462*D1**2*K*Pk2*f*fd + 336*D1**2*K*Pk2*f*fdd*r*s - 168*D1**2*K*Pk2*f*fdd*r + 756*D1**2*K*Pk2*f*fdd*s**2 - 756*D1**2*K*Pk2*f*fdd*s + 378*D1**2*K*Pk2*f*fdd + 336*D1**2*K*Pk2*fd**2*r*s - 168*D1**2*K*Pk2*fd**2*r + 756*D1**2*K*Pk2*fd**2*s**2 - 756*D1**2*K*Pk2*fd**2*s + 60*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 60*D1**2*K*Pkdd2*f*fd*k1**2*s + 30*D1**2*K*Pkdd2*f*fd*k1**2 - 30*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 30*D1**2*K*Pkdd2*f*fdd*k1**2*s - 15*D1**2*K*Pkdd2*f*fdd*k1**2 - 30*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 30*D1**2*K*Pkdd2*fd**2*k1**2*s - 378*D1**2*Pk2*f**2*fd*r**2 - 630*D1**2*Pk2*f**2*fd*r*s + 546*D1**2*Pk2*f**2*fd*r + 210*D1**2*Pk2*f**2*fd*s - 168*D1**2*Pk2*f**2*fd + 378*D1**2*Pk2*f**2*fdd*r**2 + 630*D1**2*Pk2*f**2*fdd*r*s - 546*D1**2*Pk2*f**2*fdd*r - 210*D1**2*Pk2*f**2*fdd*s + 168*D1**2*Pk2*f**2*fdd + 756*D1**2*Pk2*f*fd**2*r**2 + 1260*D1**2*Pk2*f*fd**2*r*s - 1092*D1**2*Pk2*f*fd**2*r - 420*D1**2*Pk2*f*fd**2*s + 294*D1**2*Pk2*f*fd**2 + 520*D1**2*Pk2*f*fd*r**2 - 1452*D1**2*Pk2*f*fd*r*s + 254*D1**2*Pk2*f*fd*r + 432*D1**2*Pk2*f*fd*s + 344*D1**2*Pk2*f*fd - 64*D1**2*Pk2*f*fdd*r**2 + 852*D1**2*Pk2*f*fdd*r*s - 302*D1**2*Pk2*f*fdd*r - 216*D1**2*Pk2*f*fdd*s - 116*D1**2*Pk2*f*fdd + 168*D1**2*Pk2*f*gd2*r**2 - 672*D1**2*Pk2*f*gd2*r*s - 336*D1**2*Pk2*f*gd2*r + 672*D1**2*Pk2*f*gd2*s + 168*D1**2*Pk2*f*gd2 - 84*D1**2*Pk2*f*gdd2*r**2 + 336*D1**2*Pk2*f*gdd2*r*s + 168*D1**2*Pk2*f*gdd2*r - 336*D1**2*Pk2*f*gdd2*s - 84*D1**2*Pk2*f*gdd2 - 64*D1**2*Pk2*fd**2*r**2 + 852*D1**2*Pk2*fd**2*r*s - 302*D1**2*Pk2*fd**2*r - 216*D1**2*Pk2*fd**2*s + 324*D1**2*Pk2*fd**2 + 168*D1**2*Pk2*fd*g2*r**2 - 672*D1**2*Pk2*fd*g2*r*s + 672*D1**2*Pk2*fd*g2*r - 168*D1**2*Pk2*fd*gd2*r**2 + 672*D1**2*Pk2*fd*gd2*r*s - 168*D1**2*Pk2*fd*gd2*r - 336*D1**2*Pk2*fd*gd2*s + 336*D1**2*Pk2*fd*gd2 - 84*D1**2*Pk2*fdd*g2*r**2 + 336*D1**2*Pk2*fdd*g2*r*s - 336*D1**2*Pk2*fdd*g2*r + 70*D1**2*Pkdd2*bd1**2*k1**2*s*(K - 1)*(3*s - 2) + 135*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 90*D1**2*Pkdd2*f**2*fd*k1**2*s + 45*D1**2*Pkdd2*f**2*fd*k1**2 - 120*D1**2*Pkdd2*f*fd*k1**2*s**2 + 60*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 70*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 60*D1**2*Pkdd2*fd**2*k1**2*s**2 - 70*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 140*D1**2*Pkdd2*fd*g2*k1**2*s - 70*D1**2*Pkdd2*fd*g2*k1**2 + D1**2*bdd1*(-70*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + f**2*(84*Pk2*r + 15*Pkdd2*k1**2*(4*s**2 - 6*s + 3)) + 42*f*(C*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + Pk2*(K*(2*r**2 - 8*r*s - 2*r + 4*s + 1) - 2*r**2 + 4*r - 1))) - 672*D1*Dd*K*Pk2*f**2*r*s + 168*D1*Dd*K*Pk2*f**2*r - 1848*D1*Dd*K*Pk2*f**2*s**2 + 1260*D1*Dd*K*Pk2*f**2*s - 462*D1*Dd*K*Pk2*f**2 + 2688*D1*Dd*K*Pk2*f*fd*r*s - 1008*D1*Dd*K*Pk2*f*fd*r + 6048*D1*Dd*K*Pk2*f*fd*s**2 - 5208*D1*Dd*K*Pk2*f*fd*s + 1092*D1*Dd*K*Pk2*f*fd + 120*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 60*D1*Dd*K*Pkdd2*f**2*k1**2*s + 30*D1*Dd*K*Pkdd2*f**2*k1**2 - 240*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 180*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 30*D1*Dd*K*Pkdd2*f*fd*k1**2 - 504*D1*Dd*Pk2*f**3*r**2 - 840*D1*Dd*Pk2*f**3*r*s + 714*D1*Dd*Pk2*f**3*r + 420*D1*Dd*Pk2*f**3*s - 252*D1*Dd*Pk2*f**3 + 3024*D1*Dd*Pk2*f**2*fd*r**2 + 5040*D1*Dd*Pk2*f**2*fd*r*s - 4326*D1*Dd*Pk2*f**2*fd*r - 2100*D1*Dd*Pk2*f**2*fd*s + 1302*D1*Dd*Pk2*f**2*fd + 1040*D1*Dd*Pk2*f**2*r**2 - 2904*D1*Dd*Pk2*f**2*r*s - 314*D1*Dd*Pk2*f**2*r + 1452*D1*Dd*Pk2*f**2*s + 520*D1*Dd*Pk2*f**2 - 512*D1*Dd*Pk2*f*fd*r**2 + 6816*D1*Dd*Pk2*f*fd*r*s - 1804*D1*Dd*Pk2*f*fd*r - 2568*D1*Dd*Pk2*f*fd*s + 820*D1*Dd*Pk2*f*fd + 672*D1*Dd*Pk2*f*g2*r**2 - 2688*D1*Dd*Pk2*f*g2*r*s + 1344*D1*Dd*Pk2*f*g2*s + 336*D1*Dd*Pk2*f*g2 - 672*D1*Dd*Pk2*f*gd2*r**2 + 2688*D1*Dd*Pk2*f*gd2*r*s + 672*D1*Dd*Pk2*f*gd2*r - 2016*D1*Dd*Pk2*f*gd2*s - 672*D1*Dd*Pk2*fd*g2*r**2 + 2688*D1*Dd*Pk2*fd*g2*r*s - 1344*D1*Dd*Pk2*fd*g2*r - 672*D1*Dd*Pk2*fd*g2*s + 672*D1*Dd*Pk2*fd*g2 + 180*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 90*D1*Dd*Pkdd2*f**3*k1**2*s + 45*D1*Dd*Pkdd2*f**3*k1**2 - 240*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 120*D1*Dd*Pkdd2*f**2*k1**2*s - 60*D1*Dd*Pkdd2*f**2*k1**2 + 480*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 120*D1*Dd*Pkdd2*f*fd*k1**2*s - 280*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 140*D1*Dd*Pkdd2*f*g2*k1**2*s - 70*D1*Dd*Pkdd2*f*g2*k1**2 + 672*D1*Ddd*K*Pk2*f**2*r*s - 168*D1*Ddd*K*Pk2*f**2*r + 1512*D1*Ddd*K*Pk2*f**2*s**2 - 1092*D1*Ddd*K*Pk2*f**2*s + 378*D1*Ddd*K*Pk2*f**2 - 60*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 30*D1*Ddd*K*Pkdd2*f**2*k1**2*s - 15*D1*Ddd*K*Pkdd2*f**2*k1**2 + 504*D1*Ddd*Pk2*f**3*r**2 + 840*D1*Ddd*Pk2*f**3*r*s - 714*D1*Ddd*Pk2*f**3*r - 420*D1*Ddd*Pk2*f**3*s + 252*D1*Ddd*Pk2*f**3 - 128*D1*Ddd*Pk2*f**2*r**2 + 1704*D1*Ddd*Pk2*f**2*r*s - 298*D1*Ddd*Pk2*f**2*r - 852*D1*Ddd*Pk2*f**2*s - 64*D1*Ddd*Pk2*f**2 - 336*D1*Ddd*Pk2*f*g2*r**2 + 1344*D1*Ddd*Pk2*f*g2*r*s - 672*D1*Ddd*Pk2*f*g2*s - 168*D1*Ddd*Pk2*f*g2 + 120*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 60*D1*Ddd*Pkdd2*f**2*k1**2*s + 30*D1*Ddd*Pkdd2*f**2*k1**2 - 2*D1*bd1*(D1*(42*Pk2*f**2*r + 42*Pk2*f*(K*(2*r**2 - 8*r*s - 2*r + 4*s + 1) - 2*r**2 + 4*r - 1) + 15*Pkdd2*f**2*k1**2*(4*s**2 - 6*s + 3) + Pkdd2*f*k1**2*(42*C*(2*s**2 - 2*s + 1) + 5*s*(-7*K*s - 24*fd*s + 12*fd + 7*s)) - 70*Pkdd2*k1**2*(g2*(2*s**2 - 2*s + 1) + gd2*s*(1 - 2*s)) - 42*fd*(C*Pkdd2*k1**2*s*(2*s - 1) + K*Pk2*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*Pk2*r**2 + Pk2)) + Dd*(70*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) - 3*f**2*(28*Pk2*(2*r - 1) + 5*Pkdd2*k1**2*(16*s**2 - 16*s + 3)) - 42*f*(C*Pkdd2*k1**2*(8*s**2 - 6*s + 1) + 4*Pk2*(2*r - 1)*(-4*K*s + r*(K - 1) + 1)))) + 2016*Dd**2*K*Pk2*f**2*r*s - 504*Dd**2*K*Pk2*f**2*r + 4536*Dd**2*K*Pk2*f**2*s**2 - 3276*Dd**2*K*Pk2*f**2*s + 336*Dd**2*K*Pk2*f**2 - 180*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 90*Dd**2*K*Pkdd2*f**2*k1**2*s + 1512*Dd**2*Pk2*f**3*r**2 + 2520*Dd**2*Pk2*f**3*r*s - 2142*Dd**2*Pk2*f**3*r - 1260*Dd**2*Pk2*f**3*s + 672*Dd**2*Pk2*f**3 - 384*Dd**2*Pk2*f**2*r**2 + 5112*Dd**2*Pk2*f**2*r*s - 894*Dd**2*Pk2*f**2*r - 2556*Dd**2*Pk2*f**2*s + 788*Dd**2*Pk2*f**2 - 1008*Dd**2*Pk2*f*g2*r**2 + 4032*Dd**2*Pk2*f*g2*r*s - 2016*Dd**2*Pk2*f*g2*s + 504*Dd**2*Pk2*f*g2 + 360*Dd**2*Pkdd2*f**2*k1**2*s**2 - 180*Dd**2*Pkdd2*f**2*k1**2*s))/(630*d**2*k3**2) + D1**2*Pk3*ct**4*k2**4*(D1**2*(-9*Pkdd2*k1**2*s*(b1*s*(fd**2*(10 - 20*C) + 14*fd*(K*b1 - 2*g2 + 2*gd2) + 7*fdd*(-K*b1 + 2*g2)) + 14*bd1*fd*(K*b1*(1 - 2*s) + 2*g2*(s - 1))) + f**2*(Pk2*fdd*(44 - 88*C)*(3*r**2 - 2*r + 1) - 9*Pkdd2*k1**2*(bd1*(20*C*(s - 1)**2 - s**2*(7*K + 10) + 20*s - 10) - 5*bdd1*(2*C - 1)*(s - 1)**2 + 14*gd2*s**2) - fd*(2*C - 1)*(56*Pk2*(3*r**2 - 2*r + 1) - 45*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + f*(-528*C*Pk2*fd**2*r**2 + 352*C*Pk2*fd**2*r - 360*C*Pkdd2*b1*fd*k1**2*s**2 + 180*C*Pkdd2*b1*fdd*k1**2*s**2 + 126*K*Pkdd2*b1*fd*k1**2*s**2 - 126*K*Pkdd2*b1*fd*k1**2*s + 63*K*Pkdd2*b1*fd*k1**2 + 126*K*Pkdd2*bd1**2*k1**2*s*(s - 1) + 264*Pk2*fd**2*r**2 - 176*Pk2*fd**2*r + 180*Pkdd2*b1*fd*k1**2*s**2 - 90*Pkdd2*b1*fdd*k1**2*s**2 + 252*Pkdd2*b1*gd2*k1**2*s**2 - 126*Pkdd2*b1*gdd2*k1**2*s**2 + 18*Pkdd2*bd1*k1**2*(-7*K*b1*(2*s**2 - 2*s + 1) + 14*g2*(s - 1)**2 + s*(s - 1)*(20*C*fd - 10*fd - 14*gd2)) - 63*Pkdd2*bdd1*k1**2*(K*b1*(-2*s**2 + 2*s - 1) + 2*g2*(s - 1)**2) - 252*Pkdd2*fd*g2*k1**2*s**2 + 252*Pkdd2*fd*g2*k1**2*s - 126*Pkdd2*fd*g2*k1**2)) + D1*(Dd*(126*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(K*b1 - 2*g2) - 18*Pkdd2*f*k1**2*(7*K*b1**2*(4*s**2 - 2*s + 1) - b1*(14*g2*(4*s**2 - 2*s + 1) + (4*s - 1)*(7*K*bd1*(2*s - 1) + s*(20*C*fd - 10*fd - 14*gd2))) + 14*bd1*g2*(4*s**2 - 5*s + 1)) - f**3*(2*C - 1)*(112*Pk2*(2*r**2 - 2*r + 1) - 45*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(Pk2*fd*(176 - 352*C)*(6*r**2 - 5*r + 1) - 9*Pkdd2*k1**2*(b1*(20*C - 7*K - 10)*(4*s**2 - 2*s + 1) - 10*bd1*(2*C - 1)*(4*s**2 - 5*s + 1) + 14*g2*(4*s**2 - 2*s + 1)))) + Ddd*f*(Pk2*f**2*(88 - 176*C)*(2*r**2 - 2*r + 1) + 45*Pkdd2*b1*f*k1**2*(2*C - 1)*(4*s**2 - 2*s + 1) + 63*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*f**2*(44 - 88*C)*(6*r**2 - 6*r + 1) + 135*Pkdd2*b1*f*k1**2*s*(2*C - 1)*(2*s - 1) + 189*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2)))/(630*d**2*k1**2*k3**4) + D1**2*Pk3*ct**4*k2**2*(D1**2*(9*Pkdd2*k1**2*(7*K*b1**2*(2*fd - fdd)*(2*s - 1) + b1*(fd**2*s*(10 - 20*C) - 14*fd*(g2*(4*s - 2) + s*(K*bd1 - b2*s + bd2*s - 2*gd2)) - 7*fdd*(b2*s**2 + g2*(2 - 4*s))) - 14*b2*bd1*fd*s*(s - 1)) + f**2*(Pk2*fdd*(88*C - 44)*(3*r**2 - 2*r + 1) - 9*Pkdd2*k1**2*(bd1*(20*C*(2*s - 1) + 7*K*s**2 - 20*s + 10) - 5*bdd1*(2*C - 1)*(2*s - 1) + s**2*(7*bd2 - 14*gd2)) + fd*(2*C - 1)*(56*Pk2*(3*r**2 - 2*r + 1) - 45*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + f*(126*K*Pkdd2*bd1**2*k1**2*s + 9*Pkdd2*b1*k1**2*(-14*K*bd1*(2*s - 1) - 7*bdd1*(-2*K*s + K) + fd*(20*C*(2*s - 1) - 7*K*(2*s**2 - 2*s + 1) - 20*s + 10) + fdd*(5 - 10*C)*(2*s - 1) - 7*s**2*(-2*bd2 + bdd2)) - 63*Pkdd2*b2*k1**2*(-2*bd1*(s - 1)**2 + bdd1*(s - 1)**2 + fd*(2*s**2 - 2*s + 1)) + 18*Pkdd2*bd1*k1**2*(14*g2*(2*s - 1) + s*(10*C*fd - 7*bd2*s + 7*bd2 - 5*fd - 14*gd2)) - 126*Pkdd2*bdd1*g2*k1**2*(2*s - 1) + 2*fd*(Pk2*fd*r*(88*C - 44)*(3*r - 2) + 63*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1)))) + D1*(Dd*(-126*Pkdd2*b1*fd*k1**2*(4*s - 1)*(K*b1 + b2*s - 2*g2) + 18*Pkdd2*f*k1**2*(b1*(7*b2*(4*s**2 - 2*s + 1) - (4*s - 1)*(10*C*fd - 7*K*bd1 + 7*bd2*s - 5*fd)) - 7*bd1*(4*s - 1)*(b2*(s - 1) + 2*g2)) + f**3*(2*C - 1)*(112*Pk2*(2*r**2 - 2*r + 1) - 45*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(Pk2*fd*(352*C - 176)*(6*r**2 - 5*r + 1) - 9*Pkdd2*k1**2*(7*b2*(4*s**2 - 2*s + 1) - 10*bd1*(2*C - 1)*(4*s - 1) - (-7*K*b1 + 14*g2)*(4*s**2 - 2*s + 1)))) + Ddd*f*(Pk2*f**2*(176*C - 88)*(2*r**2 - 2*r + 1) - 63*Pkdd2*b1*b2*k1**2*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*f**2*(88*C - 44)*(6*r**2 - 6*r + 1) + 189*Pkdd2*b1*b2*k1**2*s*(1 - 2*s)))/(630*d**2*k1**2*k3**2) + D1**2*Pk3*ct**3*k1**3*st**2*(4752*C*D1**2*Pk2*bdd1*f**2*r*s + 9504*C*D1**2*Pk2*bdd1*f**2*s**2 - 9504*C*D1**2*Pk2*bdd1*f**2*s + 4752*C*D1**2*Pk2*bdd1*f**2 + 49104*C*D1**2*Pk2*f**2*fd*r*s - 16368*C*D1**2*Pk2*f**2*fd*r + 81576*C*D1**2*Pk2*f**2*fd*s**2 - 70752*C*D1**2*Pk2*f**2*fd*s + 27192*C*D1**2*Pk2*f**2*fd - 36432*C*D1**2*Pk2*f**2*fdd*r*s + 12144*C*D1**2*Pk2*f**2*fdd*r - 65736*C*D1**2*Pk2*f**2*fdd*s**2 + 55968*C*D1**2*Pk2*f**2*fdd*s - 21912*C*D1**2*Pk2*f**2*fdd - 72864*C*D1**2*Pk2*f*fd**2*r*s + 24288*C*D1**2*Pk2*f*fd**2*r - 131472*C*D1**2*Pk2*f*fd**2*s**2 + 111936*C*D1**2*Pk2*f*fd**2*s - 12144*C*D1**2*Pk2*f*fd**2 + 65472*C*D1*Dd*Pk2*f**3*r*s - 16368*C*D1*Dd*Pk2*f**3*r + 108768*C*D1*Dd*Pk2*f**3*s**2 - 87120*C*D1*Dd*Pk2*f**3*s + 27192*C*D1*Dd*Pk2*f**3 - 291456*C*D1*Dd*Pk2*f**2*fd*r*s + 85008*C*D1*Dd*Pk2*f**2*fd*r - 525888*C*D1*Dd*Pk2*f**2*fd*s**2 + 428208*C*D1*Dd*Pk2*f**2*fd*s - 80256*C*D1*Dd*Pk2*f**2*fd - 48576*C*D1*Ddd*Pk2*f**3*r*s + 12144*C*D1*Ddd*Pk2*f**3*r - 87648*C*D1*Ddd*Pk2*f**3*s**2 + 68112*C*D1*Ddd*Pk2*f**3*s - 21912*C*D1*Ddd*Pk2*f**3 - 145728*C*Dd**2*Pk2*f**3*r*s + 36432*C*Dd**2*Pk2*f**3*r - 262944*C*Dd**2*Pk2*f**3*s**2 + 204336*C*Dd**2*Pk2*f**3*s - 24288*C*Dd**2*Pk2*f**3 - 10296*D1**2*K*Pk2*bdd1*f**2*r*s - 24156*D1**2*K*Pk2*bdd1*f**2*s**2 + 10296*D1**2*K*Pk2*bdd1*f**2*s + 5544*D1**2*Pk2*bd1**2*f*s*(K - 1)*(2*r + 4*s - 3) + 22000*D1**2*Pk2*bdd1*f**3*r*s + 22000*D1**2*Pk2*bdd1*f**3*s**2 - 26400*D1**2*Pk2*bdd1*f**3*s + 6600*D1**2*Pk2*bdd1*f**3 + 19800*D1**2*Pk2*bdd1*f**2*r*s + 31284*D1**2*Pk2*bdd1*f**2*s**2 - 15048*D1**2*Pk2*bdd1*f**2*s - 4752*D1**2*Pk2*bdd1*f**2 - 11088*D1**2*Pk2*bdd1*f*g2*r*s - 22176*D1**2*Pk2*bdd1*f*g2*s**2 + 22176*D1**2*Pk2*bdd1*f*g2*s - 11088*D1**2*Pk2*bdd1*f*g2 + 105600*D1**2*Pk2*f**3*fd*r*s - 26400*D1**2*Pk2*f**3*fd*r + 198000*D1**2*Pk2*f**3*fd*s**2 - 151800*D1**2*Pk2*f**3*fd*s + 49500*D1**2*Pk2*f**3*fd - 105600*D1**2*Pk2*f**3*fdd*r*s + 26400*D1**2*Pk2*f**3*fdd*r - 145200*D1**2*Pk2*f**3*fdd*s**2 + 125400*D1**2*Pk2*f**3*fdd*s - 36300*D1**2*Pk2*f**3*fdd - 316800*D1**2*Pk2*f**2*fd**2*r*s + 79200*D1**2*Pk2*f**2*fd**2*r - 435600*D1**2*Pk2*f**2*fd**2*s**2 + 376200*D1**2*Pk2*f**2*fd**2*s - 52800*D1**2*Pk2*f**2*fd**2 - 82368*D1**2*Pk2*f**2*fd*r*s + 27456*D1**2*Pk2*f**2*fd*r - 122760*D1**2*Pk2*f**2*fd*s**2 + 109296*D1**2*Pk2*f**2*fd*s - 40920*D1**2*Pk2*f**2*fd + 60192*D1**2*Pk2*f**2*fdd*r*s - 20064*D1**2*Pk2*f**2*fdd*r + 93456*D1**2*Pk2*f**2*fdd*s**2 - 82368*D1**2*Pk2*f**2*fdd*s + 31152*D1**2*Pk2*f**2*fdd - 30096*D1**2*Pk2*f**2*gd2*r*s - 57816*D1**2*Pk2*f**2*gd2*s**2 + 30096*D1**2*Pk2*f**2*gd2*s + 20592*D1**2*Pk2*f**2*gdd2*r*s + 48312*D1**2*Pk2*f**2*gdd2*s**2 - 20592*D1**2*Pk2*f**2*gdd2*s + 120384*D1**2*Pk2*f*fd**2*r*s - 40128*D1**2*Pk2*f*fd**2*r + 186912*D1**2*Pk2*f*fd**2*s**2 - 164736*D1**2*Pk2*f*fd**2*s + 20064*D1**2*Pk2*f*fd**2 - 60192*D1**2*Pk2*f*fd*g2*r*s + 30096*D1**2*Pk2*f*fd*g2*r - 115632*D1**2*Pk2*f*fd*g2*s**2 + 115632*D1**2*Pk2*f*fd*g2*s - 57816*D1**2*Pk2*f*fd*g2 + 82368*D1**2*Pk2*f*fd*gd2*r*s - 20592*D1**2*Pk2*f*fd*gd2*r + 193248*D1**2*Pk2*f*fd*gd2*s**2 - 137808*D1**2*Pk2*f*fd*gd2*s + 20592*D1**2*Pk2*f*fd*gd2 + 41184*D1**2*Pk2*f*fdd*g2*r*s - 20592*D1**2*Pk2*f*fdd*g2*r + 96624*D1**2*Pk2*f*fdd*g2*s**2 - 96624*D1**2*Pk2*f*fdd*g2*s + 48312*D1**2*Pk2*f*fdd*g2 + 41184*D1**2*Pk2*fd**2*g2*r*s - 20592*D1**2*Pk2*fd**2*g2*r + 96624*D1**2*Pk2*fd**2*g2*s**2 - 96624*D1**2*Pk2*fd**2*g2*s - 1400*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 700*D1**2*Pkdd2*f**3*fd*k1**2*s - 350*D1**2*Pkdd2*f**3*fd*k1**2 + 700*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 350*D1**2*Pkdd2*f**3*fdd*k1**2*s + 175*D1**2*Pkdd2*f**3*fdd*k1**2 + 2100*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 1050*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 105600*D1*Dd*Pk2*f**4*r*s - 26400*D1*Dd*Pk2*f**4*r + 198000*D1*Dd*Pk2*f**4*s**2 - 151800*D1*Dd*Pk2*f**4*s + 49500*D1*Dd*Pk2*f**4 - 844800*D1*Dd*Pk2*f**3*fd*r*s + 211200*D1*Dd*Pk2*f**3*fd*r - 1161600*D1*Dd*Pk2*f**3*fd*s**2 + 1003200*D1*Dd*Pk2*f**3*fd*s - 178200*D1*Dd*Pk2*f**3*fd - 109824*D1*Dd*Pk2*f**3*r*s + 27456*D1*Dd*Pk2*f**3*r - 163680*D1*Dd*Pk2*f**3*s**2 + 136752*D1*Dd*Pk2*f**3*s - 40920*D1*Dd*Pk2*f**3 + 481536*D1*Dd*Pk2*f**2*fd*r*s - 140448*D1*Dd*Pk2*f**2*fd*r + 747648*D1*Dd*Pk2*f**2*fd*s**2 - 636768*D1*Dd*Pk2*f**2*fd*s + 122496*D1*Dd*Pk2*f**2*fd - 120384*D1*Dd*Pk2*f**2*g2*r*s + 30096*D1*Dd*Pk2*f**2*g2*r - 231264*D1*Dd*Pk2*f**2*g2*s**2 + 175824*D1*Dd*Pk2*f**2*g2*s - 57816*D1*Dd*Pk2*f**2*g2 + 164736*D1*Dd*Pk2*f**2*gd2*r*s - 20592*D1*Dd*Pk2*f**2*gd2*r + 386496*D1*Dd*Pk2*f**2*gd2*s**2 - 220176*D1*Dd*Pk2*f**2*gd2*s + 20592*D1*Dd*Pk2*f**2*gd2 + 329472*D1*Dd*Pk2*f*fd*g2*r*s - 123552*D1*Dd*Pk2*f*fd*g2*r + 772992*D1*Dd*Pk2*f*fd*g2*s**2 - 662112*D1*Dd*Pk2*f*fd*g2*s + 137808*D1*Dd*Pk2*f*fd*g2 - 1400*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 700*D1*Dd*Pkdd2*f**4*k1**2*s - 350*D1*Dd*Pkdd2*f**4*k1**2 + 5600*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 2800*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 350*D1*Dd*Pkdd2*f**3*fd*k1**2 - 105600*D1*Ddd*Pk2*f**4*r*s + 26400*D1*Ddd*Pk2*f**4*r - 145200*D1*Ddd*Pk2*f**4*s**2 + 125400*D1*Ddd*Pk2*f**4*s - 36300*D1*Ddd*Pk2*f**4 + 80256*D1*Ddd*Pk2*f**3*r*s - 20064*D1*Ddd*Pk2*f**3*r + 124608*D1*Ddd*Pk2*f**3*s**2 - 102432*D1*Ddd*Pk2*f**3*s + 31152*D1*Ddd*Pk2*f**3 + 82368*D1*Ddd*Pk2*f**2*g2*r*s - 20592*D1*Ddd*Pk2*f**2*g2*r + 193248*D1*Ddd*Pk2*f**2*g2*s**2 - 137808*D1*Ddd*Pk2*f**2*g2*s + 48312*D1*Ddd*Pk2*f**2*g2 + 700*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 350*D1*Ddd*Pkdd2*f**4*k1**2*s + 175*D1*Ddd*Pkdd2*f**4*k1**2 - 44*D1*Pk2*bd1*(D1*(4*f**3*(169*s**2 + s*(169*r - 246) + 75) + f**2*(12*C*(29*s**2 + s*(11*r - 36) + 18) - 342*K*r*s - 657*K*s**2 + 342*K*s - 100*fd*(30*r*s - 5*r + 30*s**2 - 32*s + 3) + 606*r*s + 813*s**2 - 306*s - 216) + 6*f*(3*fd*(-48*C*s**2 + 42*C*s + K*(13*r*(4*s - 1) + 122*s**2 - 87*s + 13) - r*(6*C + 25)*(4*s - 1) - 158*s**2 + 123*s - 31) - 14*g2*(7*s**2 + s*(r - 12) + 6) + 42*gd2*s*(2*r + 4*s - 3)) + 252*fd*g2*(r*(2*s - 1) + s*(4*s - 4))) - 2*Dd*f*(50*f**2*(5*r*(8*s - 1) + 40*s**2 - 44*s + 6) + 9*f*(6*C*(8*r*s - r + 16*s**2 - 14*s + 2) + K*(-104*r*s + 13*r - 244*s**2 + 139*s - 13) + 200*r*s - 25*r + 316*s**2 - 205*s + 19) - 126*g2*(8*r*s - r + 16*s**2 - 14*s + 2))) - 316800*Dd**2*Pk2*f**4*r*s + 79200*Dd**2*Pk2*f**4*r - 435600*Dd**2*Pk2*f**4*s**2 + 376200*Dd**2*Pk2*f**4*s - 52800*Dd**2*Pk2*f**4 + 240768*Dd**2*Pk2*f**3*r*s - 60192*Dd**2*Pk2*f**3*r + 373824*Dd**2*Pk2*f**3*s**2 - 307296*Dd**2*Pk2*f**3*s + 40128*Dd**2*Pk2*f**3 + 247104*Dd**2*Pk2*f**2*g2*r*s - 61776*Dd**2*Pk2*f**2*g2*r + 579744*Dd**2*Pk2*f**2*g2*s**2 - 413424*Dd**2*Pk2*f**2*g2*s + 41184*Dd**2*Pk2*f**2*g2 + 2100*Dd**2*Pkdd2*f**4*k1**2*s**2 - 1050*Dd**2*Pkdd2*f**4*k1**2*s - 1848*Pk2*b1**2*(K - 1)*(D1**2*(fd*(r*(s - 1) + 7*s**2 - 2*s + 1) - 3*fdd*(r*(s - 1) + 2*s**2 - 2*s + 1)) + D1*(Dd*(f*(4*r*s - r + 28*s**2 - 16*s + 7) - 3*fd*(8*r*s - 5*r + 16*s**2 - 14*s + 4)) - 3*Ddd*f*(r*(4*s - 1) + 8*s**2 - 6*s + 2)) - 3*Dd**2*f*(3*r*(4*s - 1) + 24*s**2 - 18*s + 2)) - 44*Pk2*b1*(264*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*r + 696*C*D1**2*f*fd*s**2 - 396*C*D1**2*f*fd*s + 132*C*D1**2*f*fd - 216*C*D1**2*f*fdd*r*s + 108*C*D1**2*f*fdd*r - 432*C*D1**2*f*fdd*s**2 + 324*C*D1**2*f*fdd*s - 108*C*D1**2*f*fdd - 216*C*D1**2*fd**2*r*s + 108*C*D1**2*fd**2*r - 432*C*D1**2*fd**2*s**2 + 324*C*D1**2*fd**2*s - 108*C*D1**2*fd**2 + 528*C*D1*Dd*f**2*r*s - 132*C*D1*Dd*f**2*r + 1392*C*D1*Dd*f**2*s**2 - 960*C*D1*Dd*f**2*s + 348*C*D1*Dd*f**2 - 1728*C*D1*Dd*f*fd*r*s + 648*C*D1*Dd*f*fd*r - 3456*C*D1*Dd*f*fd*s**2 + 2592*C*D1*Dd*f*fd*s - 540*C*D1*Dd*f*fd - 432*C*D1*Ddd*f**2*r*s + 108*C*D1*Ddd*f**2*r - 864*C*D1*Ddd*f**2*s**2 + 648*C*D1*Ddd*f**2*s - 216*C*D1*Ddd*f**2 - 1296*C*Dd**2*f**2*r*s + 324*C*Dd**2*f**2*r - 2592*C*Dd**2*f**2*s**2 + 1944*C*Dd**2*f**2*s - 216*C*Dd**2*f**2 - 684*D1**2*K*f*fd*r*s + 342*D1**2*K*f*fd*r - 1314*D1**2*K*f*fd*s**2 + 1314*D1**2*K*f*fd*s - 657*D1**2*K*f*fd + 468*D1**2*K*f*fdd*r*s - 234*D1**2*K*f*fdd*r + 1098*D1**2*K*f*fdd*s**2 - 1098*D1**2*K*f*fdd*s + 549*D1**2*K*f*fdd + 468*D1**2*K*fd**2*r*s - 234*D1**2*K*fd**2*r + 1098*D1**2*K*fd**2*s**2 - 1098*D1**2*K*fd**2*s - 126*D1**2*bdd1*f*(K - 1)*(2*r*s + 4*s**2 - 3*s + 1) + 2028*D1**2*f**2*fd*r*s - 676*D1**2*f**2*fd*r + 2028*D1**2*f**2*fd*s**2 - 1720*D1**2*f**2*fd*s + 376*D1**2*f**2*fd - 1500*D1**2*f**2*fdd*r*s + 500*D1**2*f**2*fdd*r - 1500*D1**2*f**2*fdd*s**2 + 1400*D1**2*f**2*fdd*s - 350*D1**2*f**2*fdd - 3000*D1**2*f*fd**2*r*s + 1000*D1**2*f*fd**2*r - 3000*D1**2*f*fd**2*s**2 + 2800*D1**2*f*fd**2*s - 700*D1**2*f*fd**2 + 1212*D1**2*f*fd*r*s - 606*D1**2*f*fd*r + 1626*D1**2*f*fd*s**2 - 1926*D1**2*f*fd*s + 1029*D1**2*f*fd - 900*D1**2*f*fdd*r*s + 450*D1**2*f*fdd*r - 1422*D1**2*f*fdd*s**2 + 1530*D1**2*f*fdd*s - 819*D1**2*f*fdd - 84*D1**2*f*gd2*r*s - 588*D1**2*f*gd2*s**2 + 84*D1**2*f*gd2*s + 252*D1**2*f*gdd2*r*s + 504*D1**2*f*gdd2*s**2 - 252*D1**2*f*gdd2*s - 900*D1**2*fd**2*r*s + 450*D1**2*fd**2*r - 1422*D1**2*fd**2*s**2 + 1530*D1**2*fd**2*s + 108*D1**2*fd**2 - 84*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*r - 588*D1**2*fd*g2*s**2 + 168*D1**2*fd*g2*s - 84*D1**2*fd*g2 + 504*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*r + 1008*D1**2*fd*gd2*s**2 - 756*D1**2*fd*gd2*s + 252*D1**2*fd*gd2 + 252*D1**2*fdd*g2*r*s - 252*D1**2*fdd*g2*r + 504*D1**2*fdd*g2*s**2 - 504*D1**2*fdd*g2*s + 252*D1**2*fdd*g2 - 1368*D1*Dd*K*f**2*r*s + 342*D1*Dd*K*f**2*r - 2628*D1*Dd*K*f**2*s**2 + 1998*D1*Dd*K*f**2*s - 657*D1*Dd*K*f**2 + 3744*D1*Dd*K*f*fd*r*s - 1404*D1*Dd*K*f*fd*r + 8784*D1*Dd*K*f*fd*s**2 - 7524*D1*Dd*K*f*fd*s + 1566*D1*Dd*K*f*fd + 2704*D1*Dd*f**3*r*s - 676*D1*Dd*f**3*r + 2704*D1*Dd*f**3*s**2 - 2704*D1*Dd*f**3*s + 676*D1*Dd*f**3 - 12000*D1*Dd*f**2*fd*r*s + 3500*D1*Dd*f**2*fd*r - 12000*D1*Dd*f**2*fd*s**2 + 11600*D1*Dd*f**2*fd*s - 2400*D1*Dd*f**2*fd + 2424*D1*Dd*f**2*r*s - 606*D1*Dd*f**2*r + 3252*D1*Dd*f**2*s**2 - 2838*D1*Dd*f**2*s + 813*D1*Dd*f**2 - 7200*D1*Dd*f*fd*r*s + 2700*D1*Dd*f*fd*r - 11376*D1*Dd*f*fd*s**2 + 10764*D1*Dd*f*fd*s - 2430*D1*Dd*f*fd - 336*D1*Dd*f*g2*r*s + 84*D1*Dd*f*g2*r - 2352*D1*Dd*f*g2*s**2 + 1344*D1*Dd*f*g2*s - 588*D1*Dd*f*g2 + 2016*D1*Dd*f*gd2*r*s - 252*D1*Dd*f*gd2*r + 4032*D1*Dd*f*gd2*s**2 - 2520*D1*Dd*f*gd2*s + 252*D1*Dd*f*gd2 + 2016*D1*Dd*fd*g2*r*s - 1260*D1*Dd*fd*g2*r + 4032*D1*Dd*fd*g2*s**2 - 3528*D1*Dd*fd*g2*s + 1008*D1*Dd*fd*g2 + 936*D1*Ddd*K*f**2*r*s - 234*D1*Ddd*K*f**2*r + 2196*D1*Ddd*K*f**2*s**2 - 1566*D1*Ddd*K*f**2*s + 549*D1*Ddd*K*f**2 - 2000*D1*Ddd*f**3*r*s + 500*D1*Ddd*f**3*r - 2000*D1*Ddd*f**3*s**2 + 2000*D1*Ddd*f**3*s - 500*D1*Ddd*f**3 - 1800*D1*Ddd*f**2*r*s + 450*D1*Ddd*f**2*r - 2844*D1*Ddd*f**2*s**2 + 2322*D1*Ddd*f**2*s - 711*D1*Ddd*f**2 + 1008*D1*Ddd*f*g2*r*s - 252*D1*Ddd*f*g2*r + 2016*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 504*D1*Ddd*f*g2 + 42*D1*bd1*(K - 1)*(D1*(f*(2*r*s + 14*s**2 - 13*s + 6) - 3*fd*(4*r*s - 2*r + 8*s**2 - 7*s + 1)) - 3*Dd*f*(2*r*(8*s - 1) + 32*s**2 - 24*s + 3)) + 2808*Dd**2*K*f**2*r*s - 702*Dd**2*K*f**2*r + 6588*Dd**2*K*f**2*s**2 - 4698*Dd**2*K*f**2*s + 468*Dd**2*K*f**2 - 6000*Dd**2*f**3*r*s + 1500*Dd**2*f**3*r - 6000*Dd**2*f**3*s**2 + 6000*Dd**2*f**3*s - 1000*Dd**2*f**3 - 5400*Dd**2*f**2*r*s + 1350*Dd**2*f**2*r - 8532*Dd**2*f**2*s**2 + 6966*Dd**2*f**2*s - 900*Dd**2*f**2 + 3024*Dd**2*f*g2*r*s - 756*Dd**2*f*g2*r + 6048*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 504*Dd**2*f*g2))/(3465*d**2*k2*k3**4) - D1**2*Pk3*ct**3*k1**3*(3744*C*D1**2*Pk2*bdd1*f**2*r*s - 2016*C*D1**2*Pk2*bdd1*f**2*r + 4680*C*D1**2*Pk2*bdd1*f**2*s**2 - 5904*C*D1**2*Pk2*bdd1*f**2*s + 2952*C*D1**2*Pk2*bdd1*f**2 + 11808*C*D1**2*Pk2*f**2*fd*r*s - 3936*C*D1**2*Pk2*f**2*fd*r + 1656*C*D1**2*Pk2*f**2*fd*s**2 - 5040*C*D1**2*Pk2*f**2*fd*s + 552*C*D1**2*Pk2*f**2*fd - 8928*C*D1**2*Pk2*f**2*fdd*r*s + 2976*C*D1**2*Pk2*f**2*fdd*r - 3096*C*D1**2*Pk2*f**2*fdd*s**2 + 5040*C*D1**2*Pk2*f**2*fdd*s - 1032*C*D1**2*Pk2*f**2*fdd - 17856*C*D1**2*Pk2*f*fd**2*r*s + 5952*C*D1**2*Pk2*f*fd**2*r - 6192*C*D1**2*Pk2*f*fd**2*s**2 + 10080*C*D1**2*Pk2*f*fd**2*s - 2976*C*D1**2*Pk2*f*fd**2 + 15744*C*D1*Dd*Pk2*f**3*r*s - 3936*C*D1*Dd*Pk2*f**3*r + 2208*C*D1*Dd*Pk2*f**3*s**2 - 8976*C*D1*Dd*Pk2*f**3*s + 552*C*D1*Dd*Pk2*f**3 - 71424*C*D1*Dd*Pk2*f**2*fd*r*s + 20832*C*D1*Dd*Pk2*f**2*fd*r - 24768*C*D1*Dd*Pk2*f**2*fd*s**2 + 44208*C*D1*Dd*Pk2*f**2*fd*s - 10992*C*D1*Dd*Pk2*f**2*fd - 11904*C*D1*Ddd*Pk2*f**3*r*s + 2976*C*D1*Ddd*Pk2*f**3*r - 4128*C*D1*Ddd*Pk2*f**3*s**2 + 8016*C*D1*Ddd*Pk2*f**3*s - 1032*C*D1*Ddd*Pk2*f**3 - 35712*C*Dd**2*Pk2*f**3*r*s + 8928*C*Dd**2*Pk2*f**3*r - 12384*C*Dd**2*Pk2*f**3*s**2 + 24048*C*Dd**2*Pk2*f**3*s - 5952*C*Dd**2*Pk2*f**3 - 1920*D1**2*K*Pk2*bdd1*f**2*r*s - 972*D1**2*K*Pk2*bdd1*f**2*s**2 + 1920*D1**2*K*Pk2*bdd1*f**2*s - 432*D1**2*Pk2*b2*f*fd*r*s + 216*D1**2*Pk2*b2*f*fd*r - 432*D1**2*Pk2*b2*f*fd*s**2 + 432*D1**2*Pk2*b2*f*fd*s - 216*D1**2*Pk2*b2*f*fd + 720*D1**2*Pk2*b2*f*fdd*r*s - 360*D1**2*Pk2*b2*f*fdd*r + 720*D1**2*Pk2*b2*f*fdd*s**2 - 720*D1**2*Pk2*b2*f*fdd*s + 360*D1**2*Pk2*b2*f*fdd + 720*D1**2*Pk2*b2*fd**2*r*s - 360*D1**2*Pk2*b2*fd**2*r + 720*D1**2*Pk2*b2*fd**2*s**2 - 720*D1**2*Pk2*b2*fd**2*s - 24*D1**2*Pk2*bd1**2*(15*f**2*(r*(8*s - 5) + 8*s**2 - 12*s + 3) - 7*f*(-12*C*s**2 + 12*C*s + K*(8*r*(4*s - 1) + 43*s**2 - 43*s + 8) + r*(-12*C*s + 6*C - 38*s + 11) - 49*s**2 + 58*s - 17) - 70*g2*(r*(2*s - 1) + s*(2*s - 2))) - 216*D1**2*Pk2*bd2*f**2*r*s - 216*D1**2*Pk2*bd2*f**2*s**2 + 216*D1**2*Pk2*bd2*f**2*s + 1440*D1**2*Pk2*bd2*f*fd*r*s - 360*D1**2*Pk2*bd2*f*fd*r + 1440*D1**2*Pk2*bd2*f*fd*s**2 - 1440*D1**2*Pk2*bd2*f*fd*s + 360*D1**2*Pk2*bd2*f*fd + 1260*D1**2*Pk2*bdd1*f**3*r**2 + 6120*D1**2*Pk2*bdd1*f**3*r*s - 3420*D1**2*Pk2*bdd1*f**3*r + 3420*D1**2*Pk2*bdd1*f**3*s**2 - 5760*D1**2*Pk2*bdd1*f**3*s + 2520*D1**2*Pk2*bdd1*f**3 + 810*D1**2*Pk2*bdd1*f**2*r**2 + 948*D1**2*Pk2*bdd1*f**2*r*s + 1476*D1**2*Pk2*bdd1*f**2*r - 936*D1**2*Pk2*bdd1*f**2*s**2 + 2292*D1**2*Pk2*bdd1*f**2*s - 3222*D1**2*Pk2*bdd1*f**2 - 5376*D1**2*Pk2*bdd1*f*g2*r*s + 2688*D1**2*Pk2*bdd1*f*g2*r - 7224*D1**2*Pk2*bdd1*f*g2*s**2 + 9072*D1**2*Pk2*bdd1*f*g2*s - 4536*D1**2*Pk2*bdd1*f*g2 + 360*D1**2*Pk2*bdd2*f**2*r*s + 360*D1**2*Pk2*bdd2*f**2*s**2 - 360*D1**2*Pk2*bdd2*f**2*s + 3600*D1**2*Pk2*f**3*fd*r**2 + 17280*D1**2*Pk2*f**3*fd*r*s - 7920*D1**2*Pk2*f**3*fd*r + 10800*D1**2*Pk2*f**3*fd*s**2 - 14040*D1**2*Pk2*f**3*fd*s + 4500*D1**2*Pk2*f**3*fd - 3600*D1**2*Pk2*f**3*fdd*r**2 - 17280*D1**2*Pk2*f**3*fdd*r*s + 7920*D1**2*Pk2*f**3*fdd*r - 10800*D1**2*Pk2*f**3*fdd*s**2 + 14040*D1**2*Pk2*f**3*fdd*s - 4500*D1**2*Pk2*f**3*fdd - 10800*D1**2*Pk2*f**2*fd**2*r**2 - 51840*D1**2*Pk2*f**2*fd**2*r*s + 23760*D1**2*Pk2*f**2*fd**2*r - 32400*D1**2*Pk2*f**2*fd**2*s**2 + 42120*D1**2*Pk2*f**2*fd**2*s - 10440*D1**2*Pk2*f**2*fd**2 - 1590*D1**2*Pk2*f**2*fd*r**2 - 21108*D1**2*Pk2*f**2*fd*r*s + 8096*D1**2*Pk2*f**2*fd*r - 11556*D1**2*Pk2*f**2*fd*s**2 + 14740*D1**2*Pk2*f**2*fd*s - 4382*D1**2*Pk2*f**2*fd + 2010*D1**2*Pk2*f**2*fdd*r**2 + 17628*D1**2*Pk2*f**2*fdd*r*s - 7216*D1**2*Pk2*f**2*fdd*r + 11556*D1**2*Pk2*f**2*fdd*s**2 - 13580*D1**2*Pk2*f**2*fdd*s + 4522*D1**2*Pk2*f**2*fdd - 4992*D1**2*Pk2*f**2*gd2*r*s - 1368*D1**2*Pk2*f**2*gd2*s**2 + 4992*D1**2*Pk2*f**2*gd2*s + 3840*D1**2*Pk2*f**2*gdd2*r*s + 1944*D1**2*Pk2*f**2*gdd2*s**2 - 3840*D1**2*Pk2*f**2*gdd2*s + 4020*D1**2*Pk2*f*fd**2*r**2 + 35256*D1**2*Pk2*f*fd**2*r*s - 14432*D1**2*Pk2*f*fd**2*r + 23112*D1**2*Pk2*f*fd**2*s**2 - 27160*D1**2*Pk2*f*fd**2*s + 5876*D1**2*Pk2*f*fd**2 - 9984*D1**2*Pk2*f*fd*g2*r*s + 4992*D1**2*Pk2*f*fd*g2*r - 2736*D1**2*Pk2*f*fd*g2*s**2 + 2736*D1**2*Pk2*f*fd*g2*s - 1368*D1**2*Pk2*f*fd*g2 + 15360*D1**2*Pk2*f*fd*gd2*r*s - 3840*D1**2*Pk2*f*fd*gd2*r + 7776*D1**2*Pk2*f*fd*gd2*s**2 - 11568*D1**2*Pk2*f*fd*gd2*s + 3840*D1**2*Pk2*f*fd*gd2 + 7680*D1**2*Pk2*f*fdd*g2*r*s - 3840*D1**2*Pk2*f*fdd*g2*r + 3888*D1**2*Pk2*f*fdd*g2*s**2 - 3888*D1**2*Pk2*f*fdd*g2*s + 1944*D1**2*Pk2*f*fdd*g2 + 7680*D1**2*Pk2*fd**2*g2*r*s - 3840*D1**2*Pk2*fd**2*g2*r + 3888*D1**2*Pk2*fd**2*g2*s**2 - 3888*D1**2*Pk2*fd**2*g2*s - 35*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 70*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 35*D1**2*Pkdd2*bdd1*f**3*k1**2 - 140*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 70*D1**2*Pkdd2*f**3*fd*k1**2*s - 35*D1**2*Pkdd2*f**3*fd*k1**2 - 864*D1*Dd*Pk2*b2*f**2*r*s + 216*D1*Dd*Pk2*b2*f**2*r - 864*D1*Dd*Pk2*b2*f**2*s**2 + 864*D1*Dd*Pk2*b2*f**2*s - 216*D1*Dd*Pk2*b2*f**2 + 5760*D1*Dd*Pk2*b2*f*fd*r*s - 2160*D1*Dd*Pk2*b2*f*fd*r + 5760*D1*Dd*Pk2*b2*f*fd*s**2 - 5760*D1*Dd*Pk2*b2*f*fd*s + 1440*D1*Dd*Pk2*b2*f*fd + 2880*D1*Dd*Pk2*bd2*f**2*r*s - 360*D1*Dd*Pk2*bd2*f**2*r + 2880*D1*Dd*Pk2*bd2*f**2*s**2 - 2880*D1*Dd*Pk2*bd2*f**2*s + 360*D1*Dd*Pk2*bd2*f**2 + 3600*D1*Dd*Pk2*f**4*r**2 + 17280*D1*Dd*Pk2*f**4*r*s - 7920*D1*Dd*Pk2*f**4*r + 10800*D1*Dd*Pk2*f**4*s**2 - 14040*D1*Dd*Pk2*f**4*s + 4500*D1*Dd*Pk2*f**4 - 28800*D1*Dd*Pk2*f**3*fd*r**2 - 138240*D1*Dd*Pk2*f**3*fd*r*s + 63360*D1*Dd*Pk2*f**3*fd*r - 86400*D1*Dd*Pk2*f**3*fd*s**2 + 112320*D1*Dd*Pk2*f**3*fd*s - 29880*D1*Dd*Pk2*f**3*fd - 2120*D1*Dd*Pk2*f**3*r**2 - 28144*D1*Dd*Pk2*f**3*r*s + 9156*D1*Dd*Pk2*f**3*r - 15408*D1*Dd*Pk2*f**3*s**2 + 21776*D1*Dd*Pk2*f**3*s - 4912*D1*Dd*Pk2*f**3 + 16080*D1*Dd*Pk2*f**2*fd*r**2 + 141024*D1*Dd*Pk2*f**2*fd*r*s - 54532*D1*Dd*Pk2*f**2*fd*r + 92448*D1*Dd*Pk2*f**2*fd*s**2 - 112688*D1*Dd*Pk2*f**2*fd*s + 28012*D1*Dd*Pk2*f**2*fd - 19968*D1*Dd*Pk2*f**2*g2*r*s + 4992*D1*Dd*Pk2*f**2*g2*r - 5472*D1*Dd*Pk2*f**2*g2*s**2 + 12720*D1*Dd*Pk2*f**2*g2*s - 1368*D1*Dd*Pk2*f**2*g2 + 30720*D1*Dd*Pk2*f**2*gd2*r*s - 3840*D1*Dd*Pk2*f**2*gd2*r + 15552*D1*Dd*Pk2*f**2*gd2*s**2 - 26928*D1*Dd*Pk2*f**2*gd2*s + 3840*D1*Dd*Pk2*f**2*gd2 + 61440*D1*Dd*Pk2*f*fd*g2*r*s - 23040*D1*Dd*Pk2*f*fd*g2*r + 31104*D1*Dd*Pk2*f*fd*g2*s**2 - 38688*D1*Dd*Pk2*f*fd*g2*s + 11568*D1*Dd*Pk2*f*fd*g2 - 140*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 70*D1*Dd*Pkdd2*f**4*k1**2*s - 35*D1*Dd*Pkdd2*f**4*k1**2 + 1440*D1*Ddd*Pk2*b2*f**2*r*s - 360*D1*Ddd*Pk2*b2*f**2*r + 1440*D1*Ddd*Pk2*b2*f**2*s**2 - 1440*D1*Ddd*Pk2*b2*f**2*s + 360*D1*Ddd*Pk2*b2*f**2 - 3600*D1*Ddd*Pk2*f**4*r**2 - 17280*D1*Ddd*Pk2*f**4*r*s + 7920*D1*Ddd*Pk2*f**4*r - 10800*D1*Ddd*Pk2*f**4*s**2 + 14040*D1*Ddd*Pk2*f**4*s - 4500*D1*Ddd*Pk2*f**4 + 2680*D1*Ddd*Pk2*f**3*r**2 + 23504*D1*Ddd*Pk2*f**3*r*s - 8556*D1*Ddd*Pk2*f**3*r + 15408*D1*Ddd*Pk2*f**3*s**2 - 19456*D1*Ddd*Pk2*f**3*s + 5192*D1*Ddd*Pk2*f**3 + 15360*D1*Ddd*Pk2*f**2*g2*r*s - 3840*D1*Ddd*Pk2*f**2*g2*r + 7776*D1*Ddd*Pk2*f**2*g2*s**2 - 11568*D1*Ddd*Pk2*f**2*g2*s + 1944*D1*Ddd*Pk2*f**2*g2 - 2*D1*bd1*(D1*(-6*Pk2*f*(fd*(24*C*(4*r*(13*s - 5) + 65*s**2 - 66*s + 7) - 2*K*(80*r*(4*s - 1) + 162*s**2 - 241*s + 80) + 270*r**2 + 316*r*s - 91*r - 312*s**2 + 268*s + 223) + 14*g2*(r*(34*s - 22) + 41*s**2 - 58*s + 29) - 28*gd2*(8*r*(4*s - 1) + 43*s**2 - 43*s + 8)) + 168*Pk2*fd*g2*(16*r*(2*s - 1) + s*(43*s - 43)) + 5*f**3*(18*Pk2*(5*r**2 + r*(38*s - 17) + (4 - 5*s)**2) - 7*Pkdd2*k1**2*(s - 1)**2) + 3*f**2*(Pk2*(12*C*(r*(62*s - 42) + 67*s**2 - 94*s + 47) - 416*K*r*s - 114*K*s**2 + 416*K*s - 60*fd*(21*r**2 + 102*r*s - 50*r + 57*s**2 - 85*s + 21) + 81*r**2 + 134*r*s + 534*r - 144*s**2 + 442*s - 675) + 35*Pkdd2*fd*k1**2*s*(s - 1))) - Dd*f*(6*Pk2*f*(12*C*(r*(208*s - 82) + 260*s**2 - 281*s + 69) - 2*K*(80*r*(8*s - 1) + 324*s**2 - 561*s + 80) + 540*r**2 + 632*r*s + 143*r - 624*s**2 + 762*s - 437) - 168*Pk2*g2*(16*r*(8*s - 3) + 172*s**2 - 183*s + 43) + 5*f**2*(36*Pk2*(28*r**2 + r*(136*s - 69) + 76*s**2 - 117*s + 35) - 7*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 4320*Dd**2*Pk2*b2*f**2*r*s - 1080*Dd**2*Pk2*b2*f**2*r + 4320*Dd**2*Pk2*b2*f**2*s**2 - 4320*Dd**2*Pk2*b2*f**2*s + 720*Dd**2*Pk2*b2*f**2 - 10800*Dd**2*Pk2*f**4*r**2 - 51840*Dd**2*Pk2*f**4*r*s + 23760*Dd**2*Pk2*f**4*r - 32400*Dd**2*Pk2*f**4*s**2 + 42120*Dd**2*Pk2*f**4*s - 10440*Dd**2*Pk2*f**4 + 8040*Dd**2*Pk2*f**3*r**2 + 70512*Dd**2*Pk2*f**3*r*s - 25668*Dd**2*Pk2*f**3*r + 46224*Dd**2*Pk2*f**3*s**2 - 58368*Dd**2*Pk2*f**3*s + 13092*Dd**2*Pk2*f**3 + 46080*Dd**2*Pk2*f**2*g2*r*s - 11520*Dd**2*Pk2*f**2*g2*r + 23328*Dd**2*Pk2*f**2*g2*s**2 - 34704*Dd**2*Pk2*f**2*g2*s + 7680*Dd**2*Pk2*f**2*g2 - 840*Pk2*b1**3*(K - 1)*(D1*(Dd + Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 12*Pk2*b1**2*(-28*C*D1**2*fd*r*s - 28*C*D1**2*fd*s**2 + 28*C*D1**2*fd*s + 84*C*D1**2*fdd*r*s + 84*C*D1**2*fdd*s**2 - 84*C*D1**2*fdd*s - 112*C*D1*Dd*f*r*s + 28*C*D1*Dd*f*r - 112*C*D1*Dd*f*s**2 + 112*C*D1*Dd*f*s - 28*C*D1*Dd*f + 672*C*D1*Dd*fd*r*s - 84*C*D1*Dd*fd*r + 672*C*D1*Dd*fd*s**2 - 672*C*D1*Dd*fd*s + 84*C*D1*Dd*fd + 336*C*D1*Ddd*f*r*s - 84*C*D1*Ddd*f*r + 336*C*D1*Ddd*f*s**2 - 336*C*D1*Ddd*f*s + 84*C*D1*Ddd*f + 1008*C*Dd**2*f*r*s - 252*C*Dd**2*f*r + 1008*C*Dd**2*f*s**2 - 1008*C*Dd**2*f*s + 168*C*Dd**2*f + 238*D1**2*K*fd*r*s - 84*D1**2*K*fd*r + 287*D1**2*K*fd*s**2 - 168*D1**2*K*fd*s + 84*D1**2*K*fd - 224*D1**2*K*fdd*r*s + 112*D1**2*K*fdd*r - 301*D1**2*K*fdd*s**2 + 224*D1**2*K*fdd*s - 112*D1**2*K*fdd + 70*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 312*D1**2*f*fd*r*s - 18*D1**2*f*fd*r - 312*D1**2*f*fd*s**2 + 198*D1**2*f*fd*s + 18*D1**2*f*fd + 240*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r + 240*D1**2*f*fdd*s**2 - 120*D1**2*f*fdd*s - 30*D1**2*f*fdd + 240*D1**2*fd**2*r*s + 30*D1**2*fd**2*r + 240*D1**2*fd**2*s**2 - 120*D1**2*fd**2*s - 30*D1**2*fd**2 - 322*D1**2*fd*r*s + 84*D1**2*fd*r - 371*D1**2*fd*s**2 + 140*D1**2*fd*s - 84*D1**2*fd + 266*D1**2*fdd*r*s - 112*D1**2*fdd*r + 343*D1**2*fdd*s**2 - 140*D1**2*fdd*s + 112*D1**2*fdd - 140*D1**2*gd2*r*s - 140*D1**2*gd2*s**2 + 140*D1**2*gd2*s - 140*D1**2*gdd2*r*s - 140*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s + 952*D1*Dd*K*f*r*s - 238*D1*Dd*K*f*r + 1148*D1*Dd*K*f*s**2 - 1050*D1*Dd*K*f*s + 287*D1*Dd*K*f - 1792*D1*Dd*K*fd*r*s + 672*D1*Dd*K*fd*r - 2408*D1*Dd*K*fd*s**2 + 1946*D1*Dd*K*fd*s - 448*D1*Dd*K*fd - 624*D1*Dd*f**2*r*s + 156*D1*Dd*f**2*r - 624*D1*Dd*f**2*s**2 + 624*D1*Dd*f**2*s - 156*D1*Dd*f**2 + 1920*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 1920*D1*Dd*f*fd*s**2 - 1440*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 1288*D1*Dd*f*r*s + 322*D1*Dd*f*r - 1484*D1*Dd*f*s**2 + 1386*D1*Dd*f*s - 371*D1*Dd*f + 2128*D1*Dd*fd*r*s - 714*D1*Dd*fd*r + 2744*D1*Dd*fd*s**2 - 1778*D1*Dd*fd*s + 364*D1*Dd*fd - 560*D1*Dd*g2*r*s + 140*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 560*D1*Dd*g2*s - 140*D1*Dd*g2 - 1120*D1*Dd*gd2*r*s + 140*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1120*D1*Dd*gd2*s - 140*D1*Dd*gd2 - 896*D1*Ddd*K*f*r*s + 224*D1*Ddd*K*f*r - 1204*D1*Ddd*K*f*s**2 + 1050*D1*Ddd*K*f*s - 301*D1*Ddd*K*f + 480*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r + 480*D1*Ddd*f**2*s**2 - 480*D1*Ddd*f**2*s + 120*D1*Ddd*f**2 + 1064*D1*Ddd*f*r*s - 266*D1*Ddd*f*r + 1372*D1*Ddd*f*s**2 - 1218*D1*Ddd*f*s + 343*D1*Ddd*f - 560*D1*Ddd*g2*r*s + 140*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 560*D1*Ddd*g2*s - 140*D1*Ddd*g2 + 70*D1*bd1*(K - 1)*(D1*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*(24*r*s - 7*r + 24*s**2 - 24*s + 5)) - 2688*Dd**2*K*f*r*s + 672*Dd**2*K*f*r - 3612*Dd**2*K*f*s**2 + 3150*Dd**2*K*f*s - 448*Dd**2*K*f + 1440*Dd**2*f**2*r*s - 360*Dd**2*f**2*r + 1440*Dd**2*f**2*s**2 - 1440*Dd**2*f**2*s + 240*Dd**2*f**2 + 3192*Dd**2*f*r*s - 798*Dd**2*f*r + 4116*Dd**2*f*s**2 - 3654*Dd**2*f*s + 532*Dd**2*f - 1680*Dd**2*g2*r*s + 420*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 1680*Dd**2*g2*s - 280*Dd**2*g2) - b1*(8928*C*D1**2*Pk2*f*fd*r*s - 1440*C*D1**2*Pk2*f*fd*r + 9648*C*D1**2*Pk2*f*fd*s**2 - 7344*C*D1**2*Pk2*f*fd*s + 1440*C*D1**2*Pk2*f*fd - 7488*C*D1**2*Pk2*f*fdd*r*s + 1728*C*D1**2*Pk2*f*fdd*r - 9360*C*D1**2*Pk2*f*fdd*s**2 + 7200*C*D1**2*Pk2*f*fdd*s - 1728*C*D1**2*Pk2*f*fdd - 7488*C*D1**2*Pk2*fd**2*r*s + 1728*C*D1**2*Pk2*fd**2*r - 9360*C*D1**2*Pk2*fd**2*s**2 + 7200*C*D1**2*Pk2*fd**2*s - 1728*C*D1**2*Pk2*fd**2 + 17856*C*D1*Dd*Pk2*f**2*r*s - 4464*C*D1*Dd*Pk2*f**2*r + 19296*C*D1*Dd*Pk2*f**2*s**2 - 18576*C*D1*Dd*Pk2*f**2*s + 4824*C*D1*Dd*Pk2*f**2 - 59904*C*D1*Dd*Pk2*f*fd*r*s + 14400*C*D1*Dd*Pk2*f*fd*r - 74880*C*D1*Dd*Pk2*f*fd*s**2 + 62496*C*D1*Dd*Pk2*f*fd*s - 10656*C*D1*Dd*Pk2*f*fd - 14976*C*D1*Ddd*Pk2*f**2*r*s + 3744*C*D1*Ddd*Pk2*f**2*r - 18720*C*D1*Ddd*Pk2*f**2*s**2 + 16848*C*D1*Ddd*Pk2*f**2*s - 4680*C*D1*Ddd*Pk2*f**2 - 44928*C*Dd**2*Pk2*f**2*r*s + 11232*C*Dd**2*Pk2*f**2*r - 56160*C*Dd**2*Pk2*f**2*s**2 + 50544*C*Dd**2*Pk2*f**2*s - 7488*C*Dd**2*Pk2*f**2 - 4992*D1**2*K*Pk2*f*fd*r*s + 2496*D1**2*K*Pk2*f*fd*r - 1368*D1**2*K*Pk2*f*fd*s**2 + 1368*D1**2*K*Pk2*f*fd*s - 684*D1**2*K*Pk2*f*fd + 3840*D1**2*K*Pk2*f*fdd*r*s - 1920*D1**2*K*Pk2*f*fdd*r + 1944*D1**2*K*Pk2*f*fdd*s**2 - 1944*D1**2*K*Pk2*f*fdd*s + 972*D1**2*K*Pk2*f*fdd + 3840*D1**2*K*Pk2*fd**2*r*s - 1920*D1**2*K*Pk2*fd**2*r + 1944*D1**2*K*Pk2*fd**2*s**2 - 1944*D1**2*K*Pk2*fd**2*s + 840*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 12*D1**2*Pk2*bdd1*(30*f**2*(r*(8*s - 5) + 8*s**2 - 12*s + 5) + 7*f*(12*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-64*r*s + 16*r - 86*s**2 + 86*s - 27) + 76*r*s - 22*r + 98*s**2 - 116*s + 33) - 140*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 2700*D1**2*Pk2*f**2*fd*r**2 + 20520*D1**2*Pk2*f**2*fd*r*s - 7380*D1**2*Pk2*f**2*fd*r + 13500*D1**2*Pk2*f**2*fd*s**2 - 15480*D1**2*Pk2*f**2*fd*s + 3420*D1**2*Pk2*f**2*fd - 3780*D1**2*Pk2*f**2*fdd*r**2 - 18360*D1**2*Pk2*f**2*fdd*r*s + 7740*D1**2*Pk2*f**2*fdd*r - 10260*D1**2*Pk2*f**2*fdd*s**2 + 13320*D1**2*Pk2*f**2*fdd*s - 3420*D1**2*Pk2*f**2*fdd - 7560*D1**2*Pk2*f*fd**2*r**2 - 36720*D1**2*Pk2*f*fd**2*r*s + 15480*D1**2*Pk2*f*fd**2*r - 20520*D1**2*Pk2*f*fd**2*s**2 + 26640*D1**2*Pk2*f*fd**2*s - 7200*D1**2*Pk2*f*fd**2 + 972*D1**2*Pk2*f*fd*r**2 + 1608*D1**2*Pk2*f*fd*r*s - 4980*D1**2*Pk2*f*fd*r - 1728*D1**2*Pk2*f*fd*s**2 - 1728*D1**2*Pk2*f*fd*s + 3672*D1**2*Pk2*f*fd - 1620*D1**2*Pk2*f*fdd*r**2 - 1896*D1**2*Pk2*f*fdd*r*s + 4044*D1**2*Pk2*f*fdd*r + 1872*D1**2*Pk2*f*fdd*s**2 + 1368*D1**2*Pk2*f*fdd*s - 3096*D1**2*Pk2*f*fdd - 5712*D1**2*Pk2*f*gd2*r*s - 6888*D1**2*Pk2*f*gd2*s**2 + 5712*D1**2*Pk2*f*gd2*s + 5376*D1**2*Pk2*f*gdd2*r*s + 7224*D1**2*Pk2*f*gdd2*s**2 - 5376*D1**2*Pk2*f*gdd2*s - 1620*D1**2*Pk2*fd**2*r**2 - 1896*D1**2*Pk2*fd**2*r*s + 4044*D1**2*Pk2*fd**2*r + 1872*D1**2*Pk2*fd**2*s**2 + 1368*D1**2*Pk2*fd**2*s + 1728*D1**2*Pk2*fd**2 - 5712*D1**2*Pk2*fd*g2*r*s + 2016*D1**2*Pk2*fd*g2*r - 6888*D1**2*Pk2*fd*g2*s**2 + 4032*D1**2*Pk2*fd*g2*s - 2016*D1**2*Pk2*fd*g2 + 10752*D1**2*Pk2*fd*gd2*r*s - 2688*D1**2*Pk2*fd*gd2*r + 14448*D1**2*Pk2*fd*gd2*s**2 - 10752*D1**2*Pk2*fd*gd2*s + 2688*D1**2*Pk2*fd*gd2 + 5376*D1**2*Pk2*fdd*g2*r*s - 2688*D1**2*Pk2*fdd*g2*r + 7224*D1**2*Pk2*fdd*g2*s**2 - 5376*D1**2*Pk2*fdd*g2*s + 2688*D1**2*Pk2*fdd*g2 - 210*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 105*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 210*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 9984*D1*Dd*K*Pk2*f**2*r*s + 2496*D1*Dd*K*Pk2*f**2*r - 2736*D1*Dd*K*Pk2*f**2*s**2 + 6360*D1*Dd*K*Pk2*f**2*s - 684*D1*Dd*K*Pk2*f**2 + 30720*D1*Dd*K*Pk2*f*fd*r*s - 11520*D1*Dd*K*Pk2*f*fd*r + 15552*D1*Dd*K*Pk2*f*fd*s**2 - 19344*D1*Dd*K*Pk2*f*fd*s + 5784*D1*Dd*K*Pk2*f*fd + 3600*D1*Dd*Pk2*f**3*r**2 + 27360*D1*Dd*Pk2*f**3*r*s - 10440*D1*Dd*Pk2*f**3*r + 18000*D1*Dd*Pk2*f**3*s**2 - 22680*D1*Dd*Pk2*f**3*s + 6300*D1*Dd*Pk2*f**3 - 30240*D1*Dd*Pk2*f**2*fd*r**2 - 146880*D1*Dd*Pk2*f**2*fd*r*s + 64440*D1*Dd*Pk2*f**2*fd*r - 82080*D1*Dd*Pk2*f**2*fd*s**2 + 110520*D1*Dd*Pk2*f**2*fd*s - 28800*D1*Dd*Pk2*f**2*fd + 1944*D1*Dd*Pk2*f**2*r**2 + 3216*D1*Dd*Pk2*f**2*r*s - 2748*D1*Dd*Pk2*f**2*r - 3456*D1*Dd*Pk2*f**2*s**2 + 120*D1*Dd*Pk2*f**2*s + 108*D1*Dd*Pk2*f**2 - 12960*D1*Dd*Pk2*f*fd*r**2 - 15168*D1*Dd*Pk2*f*fd*r*s + 24552*D1*Dd*Pk2*f*fd*r + 14976*D1*Dd*Pk2*f*fd*s**2 + 5520*D1*Dd*Pk2*f*fd*s - 9456*D1*Dd*Pk2*f*fd - 22848*D1*Dd*Pk2*f*g2*r*s + 5712*D1*Dd*Pk2*f*g2*r - 27552*D1*Dd*Pk2*f*g2*s**2 + 25200*D1*Dd*Pk2*f*g2*s - 6888*D1*Dd*Pk2*f*g2 + 43008*D1*Dd*Pk2*f*gd2*r*s - 5376*D1*Dd*Pk2*f*gd2*r + 57792*D1*Dd*Pk2*f*gd2*s**2 - 46704*D1*Dd*Pk2*f*gd2*s + 5376*D1*Dd*Pk2*f*gd2 + 43008*D1*Dd*Pk2*fd*g2*r*s - 16128*D1*Dd*Pk2*fd*g2*r + 57792*D1*Dd*Pk2*fd*g2*s**2 - 46704*D1*Dd*Pk2*fd*g2*s + 10752*D1*Dd*Pk2*fd*g2 - 280*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 140*D1*Dd*Pkdd2*f**3*k1**2*s - 70*D1*Dd*Pkdd2*f**3*k1**2 + 840*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 210*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 7680*D1*Ddd*K*Pk2*f**2*r*s - 1920*D1*Ddd*K*Pk2*f**2*r + 3888*D1*Ddd*K*Pk2*f**2*s**2 - 5784*D1*Ddd*K*Pk2*f**2*s + 972*D1*Ddd*K*Pk2*f**2 - 5040*D1*Ddd*Pk2*f**3*r**2 - 24480*D1*Ddd*Pk2*f**3*r*s + 11160*D1*Ddd*Pk2*f**3*r - 13680*D1*Ddd*Pk2*f**3*s**2 + 19080*D1*Ddd*Pk2*f**3*s - 5940*D1*Ddd*Pk2*f**3 - 3240*D1*Ddd*Pk2*f**2*r**2 - 3792*D1*Ddd*Pk2*f**2*r*s + 4188*D1*Ddd*Pk2*f**2*r + 3744*D1*Ddd*Pk2*f**2*s**2 + 24*D1*Ddd*Pk2*f**2*s - 684*D1*Ddd*Pk2*f**2 + 21504*D1*Ddd*Pk2*f*g2*r*s - 5376*D1*Ddd*Pk2*f*g2*r + 28896*D1*Ddd*Pk2*f*g2*s**2 - 25200*D1*Ddd*Pk2*f*g2*s + 7224*D1*Ddd*Pk2*f*g2 + 140*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 70*D1*Ddd*Pkdd2*f**3*k1**2*s + 35*D1*Ddd*Pkdd2*f**3*k1**2 - 12*D1*Pk2*bd1*(D1*(6*f**2*(r*(52*s - 29) + 52*s**2 - 71*s + 29) + f*(28*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 7*K*(68*r*s - 22*r + 82*s**2 - 92*s + 29) - 60*fd*(4*s - 1)*(4*r + 4*s - 3) + 644*r*s - 238*r + 742*s**2 - 924*s + 287) - 14*fd*(6*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(-64*r*s + 24*r - 86*s**2 + 75*s - 8) + 76*r*s - 27*r + 98*s**2 - 78*s + 2) + 140*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 140*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd*(30*f**2*(2*r*(16*s - 7) + 32*s**2 - 40*s + 11) + 7*f*(12*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - K*(4*s - 1)*(64*r + 86*s - 59) + 304*r*s - 82*r + 392*s**2 - 406*s + 80) - 140*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 23040*Dd**2*K*Pk2*f**2*r*s - 5760*Dd**2*K*Pk2*f**2*r + 11664*Dd**2*K*Pk2*f**2*s**2 - 17352*Dd**2*K*Pk2*f**2*s + 3840*Dd**2*K*Pk2*f**2 - 15120*Dd**2*Pk2*f**3*r**2 - 73440*Dd**2*Pk2*f**3*r*s + 33480*Dd**2*Pk2*f**3*r - 41040*Dd**2*Pk2*f**3*s**2 + 57240*Dd**2*Pk2*f**3*s - 14760*Dd**2*Pk2*f**3 - 9720*Dd**2*Pk2*f**2*r**2 - 11376*Dd**2*Pk2*f**2*r*s + 12564*Dd**2*Pk2*f**2*r + 11232*Dd**2*Pk2*f**2*s**2 + 72*Dd**2*Pk2*f**2*s - 3516*Dd**2*Pk2*f**2 + 64512*Dd**2*Pk2*f*g2*r*s - 16128*Dd**2*Pk2*f*g2*r + 86688*Dd**2*Pk2*f*g2*s**2 - 75600*Dd**2*Pk2*f*g2*s + 10752*Dd**2*Pk2*f*g2 + 420*Dd**2*Pkdd2*f**3*k1**2*s**2 - 210*Dd**2*Pkdd2*f**3*k1**2*s))/(630*d**2*k2*k3**4) - D1**2*Pk3*ct**3*k1*k2*st**4*(-40128*C*D1**2*Pk2*f**2*fd*r*s + 13376*C*D1**2*Pk2*f**2*fd*r + 31680*C*D1**2*Pk2*f**2*fd*s**2 - 7744*C*D1**2*Pk2*f**2*fd*s + 10560*C*D1**2*Pk2*f**2*fd + 26400*C*D1**2*Pk2*f**2*fdd*r*s - 8800*C*D1**2*Pk2*f**2*fdd*r - 15840*C*D1**2*Pk2*f**2*fdd*s**2 + 1760*C*D1**2*Pk2*f**2*fdd*s - 5280*C*D1**2*Pk2*f**2*fdd + 52800*C*D1**2*Pk2*f*fd**2*r*s - 17600*C*D1**2*Pk2*f*fd**2*r - 31680*C*D1**2*Pk2*f*fd**2*s**2 + 3520*C*D1**2*Pk2*f*fd**2*s + 8800*C*D1**2*Pk2*f*fd**2 + 1320*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 880*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 440*C*D1**2*Pkdd2*f**2*fd*k1**2 - 660*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 440*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 220*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 1320*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 880*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 53504*C*D1*Dd*Pk2*f**3*r*s + 13376*C*D1*Dd*Pk2*f**3*r + 42240*C*D1*Dd*Pk2*f**3*s**2 + 5632*C*D1*Dd*Pk2*f**3*s + 10560*C*D1*Dd*Pk2*f**3 + 211200*C*D1*Dd*Pk2*f**2*fd*r*s - 61600*C*D1*Dd*Pk2*f**2*fd*r - 126720*C*D1*Dd*Pk2*f**2*fd*s**2 - 14080*C*D1*Dd*Pk2*f**2*fd*s + 15840*C*D1*Dd*Pk2*f**2*fd + 1760*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 880*C*D1*Dd*Pkdd2*f**3*k1**2*s + 440*C*D1*Dd*Pkdd2*f**3*k1**2 - 5280*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 3080*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 440*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 35200*C*D1*Ddd*Pk2*f**3*r*s - 8800*C*D1*Ddd*Pk2*f**3*r - 21120*C*D1*Ddd*Pk2*f**3*s**2 - 7040*C*D1*Ddd*Pk2*f**3*s - 5280*C*D1*Ddd*Pk2*f**3 - 880*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 440*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 220*C*D1*Ddd*Pkdd2*f**3*k1**2 + 105600*C*Dd**2*Pk2*f**3*r*s - 26400*C*Dd**2*Pk2*f**3*r - 63360*C*Dd**2*Pk2*f**3*s**2 - 21120*C*Dd**2*Pk2*f**3*s + 17600*C*Dd**2*Pk2*f**3 - 2640*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1320*C*Dd**2*Pkdd2*f**3*k1**2*s + 7920*D1**2*K*Pk2*bdd1*f**2*r*s - 7920*D1**2*K*Pk2*bdd1*f**2*s**2 - 7920*D1**2*K*Pk2*bdd1*f**2*s - 330*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 6160*D1**2*Pk2*bdd1*f**3*r*s - 3080*D1**2*Pk2*bdd1*f**3*s**2 + 6160*D1**2*Pk2*bdd1*f**3*s - 15840*D1**2*Pk2*bdd1*f**2*r*s - 3960*D1**2*Pk2*bdd1*f**2*s**2 + 15840*D1**2*Pk2*bdd1*f**2*s - 24640*D1**2*Pk2*f**3*fd*r*s + 6160*D1**2*Pk2*f**3*fd*r + 12320*D1**2*Pk2*f**3*fd*s + 24640*D1**2*Pk2*f**3*fdd*r*s - 6160*D1**2*Pk2*f**3*fdd*r - 12320*D1**2*Pk2*f**3*fdd*s + 73920*D1**2*Pk2*f**2*fd**2*r*s - 18480*D1**2*Pk2*f**2*fd**2*r - 36960*D1**2*Pk2*f**2*fd**2*s + 12320*D1**2*Pk2*f**2*fd**2 + 55968*D1**2*Pk2*f**2*fd*r*s - 18656*D1**2*Pk2*f**2*fd*r - 7920*D1**2*Pk2*f**2*fd*s**2 - 13376*D1**2*Pk2*f**2*fd*s - 2640*D1**2*Pk2*f**2*fd - 34320*D1**2*Pk2*f**2*fdd*r*s + 11440*D1**2*Pk2*f**2*fdd*r + 3960*D1**2*Pk2*f**2*fdd*s**2 + 8800*D1**2*Pk2*f**2*fdd*s + 1320*D1**2*Pk2*f**2*fdd + 31680*D1**2*Pk2*f**2*gd2*r*s - 31680*D1**2*Pk2*f**2*gd2*s**2 - 31680*D1**2*Pk2*f**2*gd2*s - 15840*D1**2*Pk2*f**2*gdd2*r*s + 15840*D1**2*Pk2*f**2*gdd2*s**2 + 15840*D1**2*Pk2*f**2*gdd2*s - 68640*D1**2*Pk2*f*fd**2*r*s + 22880*D1**2*Pk2*f*fd**2*r + 7920*D1**2*Pk2*f*fd**2*s**2 + 17600*D1**2*Pk2*f*fd**2*s - 11440*D1**2*Pk2*f*fd**2 + 63360*D1**2*Pk2*f*fd*g2*r*s - 31680*D1**2*Pk2*f*fd*g2*r - 63360*D1**2*Pk2*f*fd*g2*s**2 + 63360*D1**2*Pk2*f*fd*g2*s - 31680*D1**2*Pk2*f*fd*g2 - 63360*D1**2*Pk2*f*fd*gd2*r*s + 15840*D1**2*Pk2*f*fd*gd2*r + 63360*D1**2*Pk2*f*fd*gd2*s**2 - 15840*D1**2*Pk2*f*fd*gd2 - 31680*D1**2*Pk2*f*fdd*g2*r*s + 15840*D1**2*Pk2*f*fdd*g2*r + 31680*D1**2*Pk2*f*fdd*g2*s**2 - 31680*D1**2*Pk2*f*fdd*g2*s + 15840*D1**2*Pk2*f*fdd*g2 - 31680*D1**2*Pk2*fd**2*g2*r*s + 15840*D1**2*Pk2*fd**2*g2*r + 31680*D1**2*Pk2*fd**2*g2*s**2 - 31680*D1**2*Pk2*fd**2*g2*s + 330*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 4200*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 2100*D1**2*Pkdd2*f**3*fd*k1**2*s + 1050*D1**2*Pkdd2*f**3*fd*k1**2 - 2100*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 1050*D1**2*Pkdd2*f**3*fdd*k1**2*s - 525*D1**2*Pkdd2*f**3*fdd*k1**2 - 6300*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 3150*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 1320*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 880*D1**2*Pkdd2*f**2*fd*k1**2*s - 440*D1**2*Pkdd2*f**2*fd*k1**2 + 660*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 440*D1**2*Pkdd2*f**2*fdd*k1**2*s + 220*D1**2*Pkdd2*f**2*fdd*k1**2 - 1320*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 660*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 1320*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 880*D1**2*Pkdd2*f*fd**2*k1**2*s - 2640*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 2640*D1**2*Pkdd2*f*fd*g2*k1**2*s - 1320*D1**2*Pkdd2*f*fd*g2*k1**2 + 2640*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 1320*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 1320*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 1320*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 660*D1**2*Pkdd2*f*fdd*g2*k1**2 + 1320*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 1320*D1**2*Pkdd2*fd**2*g2*k1**2*s - 24640*D1*Dd*Pk2*f**4*r*s + 6160*D1*Dd*Pk2*f**4*r + 12320*D1*Dd*Pk2*f**4*s + 197120*D1*Dd*Pk2*f**3*fd*r*s - 49280*D1*Dd*Pk2*f**3*fd*r - 98560*D1*Dd*Pk2*f**3*fd*s + 24640*D1*Dd*Pk2*f**3*fd + 74624*D1*Dd*Pk2*f**3*r*s - 18656*D1*Dd*Pk2*f**3*r - 10560*D1*Dd*Pk2*f**3*s**2 - 32032*D1*Dd*Pk2*f**3*s - 2640*D1*Dd*Pk2*f**3 - 274560*D1*Dd*Pk2*f**2*fd*r*s + 80080*D1*Dd*Pk2*f**2*fd*r + 31680*D1*Dd*Pk2*f**2*fd*s**2 + 95920*D1*Dd*Pk2*f**2*fd*s - 31680*D1*Dd*Pk2*f**2*fd + 126720*D1*Dd*Pk2*f**2*g2*r*s - 31680*D1*Dd*Pk2*f**2*g2*r - 126720*D1*Dd*Pk2*f**2*g2*s**2 - 31680*D1*Dd*Pk2*f**2*g2 - 126720*D1*Dd*Pk2*f**2*gd2*r*s + 15840*D1*Dd*Pk2*f**2*gd2*r + 126720*D1*Dd*Pk2*f**2*gd2*s**2 + 63360*D1*Dd*Pk2*f**2*gd2*s - 15840*D1*Dd*Pk2*f**2*gd2 - 253440*D1*Dd*Pk2*f*fd*g2*r*s + 95040*D1*Dd*Pk2*f*fd*g2*r + 253440*D1*Dd*Pk2*f*fd*g2*s**2 - 126720*D1*Dd*Pk2*f*fd*g2*s + 4200*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 2100*D1*Dd*Pkdd2*f**4*k1**2*s + 1050*D1*Dd*Pkdd2*f**4*k1**2 - 16800*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 8400*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 1050*D1*Dd*Pkdd2*f**3*fd*k1**2 - 1760*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 880*D1*Dd*Pkdd2*f**3*k1**2*s - 440*D1*Dd*Pkdd2*f**3*k1**2 + 5280*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 3080*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 440*D1*Dd*Pkdd2*f**2*fd*k1**2 - 5280*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 2640*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 1320*D1*Dd*Pkdd2*f**2*g2*k1**2 + 5280*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 1320*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 10560*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 7920*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 1320*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 24640*D1*Ddd*Pk2*f**4*r*s - 6160*D1*Ddd*Pk2*f**4*r - 12320*D1*Ddd*Pk2*f**4*s - 45760*D1*Ddd*Pk2*f**3*r*s + 11440*D1*Ddd*Pk2*f**3*r + 5280*D1*Ddd*Pk2*f**3*s**2 + 20240*D1*Ddd*Pk2*f**3*s + 1320*D1*Ddd*Pk2*f**3 - 63360*D1*Ddd*Pk2*f**2*g2*r*s + 15840*D1*Ddd*Pk2*f**2*g2*r + 63360*D1*Ddd*Pk2*f**2*g2*s**2 + 15840*D1*Ddd*Pk2*f**2*g2 - 2100*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 1050*D1*Ddd*Pkdd2*f**4*k1**2*s - 525*D1*Ddd*Pkdd2*f**4*k1**2 + 880*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 440*D1*Ddd*Pkdd2*f**3*k1**2*s + 220*D1*Ddd*Pkdd2*f**3*k1**2 + 2640*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 1320*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 660*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 220*D1*bd1*f*(D1*f*s*(4*Pk2*(9*K*(-2*r + 2*s + 2) + 7*f*(2*r + s - 2) + 36*r + 9*s - 36) + Pkdd2*k1**2*s*(3*K - 3)) - D1*fd*(4*Pk2*(-9*K*r*(4*s - 1) + 36*K*s**2 - 9*K + 7*f*(r*(6*s - 1) + 3*s**2 - 5*s + 1) - 9*r*(2 - 8*s) + 18*s**2 - 45*s + 18) + Pkdd2*k1**2*s*(3*K - 3)*(2*s - 1)) - 4*Dd*Pk2*f*(9*K*(-8*r*s + r + 8*s**2 + 4*s - 1) + 7*f*(r*(8*s - 1) + 4*s**2 - 7*s + 1) + 144*r*s - 18*r + 36*s**2 - 117*s + 18) - 3*Dd*Pkdd2*f*k1**2*s*(K - 1)*(4*s - 1)) + 73920*Dd**2*Pk2*f**4*r*s - 18480*Dd**2*Pk2*f**4*r - 36960*Dd**2*Pk2*f**4*s + 12320*Dd**2*Pk2*f**4 - 137280*Dd**2*Pk2*f**3*r*s + 34320*Dd**2*Pk2*f**3*r + 15840*Dd**2*Pk2*f**3*s**2 + 60720*Dd**2*Pk2*f**3*s - 22880*Dd**2*Pk2*f**3 - 190080*Dd**2*Pk2*f**2*g2*r*s + 47520*Dd**2*Pk2*f**2*g2*r + 190080*Dd**2*Pk2*f**2*g2*s**2 - 31680*Dd**2*Pk2*f**2*g2 - 6300*Dd**2*Pkdd2*f**4*k1**2*s**2 + 3150*Dd**2*Pkdd2*f**4*k1**2*s + 2640*Dd**2*Pkdd2*f**3*k1**2*s**2 - 1320*Dd**2*Pkdd2*f**3*k1**2*s + 7920*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 3960*Dd**2*Pkdd2*f**2*g2*k1**2*s + 110*b1*(D1**2*(28*Pk2*f**2*(2*fd - fdd)*(3*s - 1)*(2*r + s - 1) + f*(-56*Pk2*fd**2*(3*s - 1)*(2*r + s - 1) - 72*Pk2*fd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) + r*(4 - 8*s) - 2*s**2 + 2*s - 1) + 36*Pk2*fdd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) + r*(4 - 8*s) - 2*s**2 + 2*s - 1) + 6*Pkdd2*fd*k1**2*(K - 1)*(2*s**2 - 2*s + 1) - 3*Pkdd2*fdd*k1**2*(K - 1)*(2*s**2 - 2*s + 1)) + 6*fd**2*(12*Pk2*(r*(K - 2)*(2*s - 1) - s*(2*K + 1)*(s - 1)) + Pkdd2*k1**2*s*(-K*s + K + s - 1))) + D1*f*(2*Dd*(28*Pk2*f**2*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + f*(-4*Pk2*(-18*K*(-4*r*s + r + 4*s**2 + 1) + 7*fd*(r*(24*s - 7) + 12*s**2 - 17*s + 4) - 144*r*s + 36*r - 36*s**2 + 90*s - 9) + Pkdd2*k1**2*(3*K - 3)*(4*s**2 - 2*s + 1)) - 3*fd*(12*Pk2*(r*(4 - 2*K)*(8*s - 3) + (2*s - 1)*(8*K*s + 4*s - 5)) + Pkdd2*k1**2*(K - 1)*(8*s**2 - 6*s + 1))) - Ddd*f*(4*Pk2*(18*K*(-4*r*s + r + 4*s**2 + 1) + 7*f*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + 144*r*s - 36*r + 36*s**2 - 90*s + 9) + Pkdd2*k1**2*(3*K - 3)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(4*Pk2*(-9*K*(12*r*s - 3*r - 12*s**2 + 2) + 7*f*(3*r*(4*s - 1) + 6*s**2 - 9*s + 2) + 216*r*s - 54*r + 54*s**2 - 135*s + 36) + Pkdd2*k1**2*s*(9*K - 9)*(2*s - 1))))/(2310*d**2*k3**4) - D1**2*Pk3*ct**3*k1*k2*st**2*(720*C*D1**2*Pk2*bdd1*f**2*r**2 + 576*C*D1**2*Pk2*bdd1*f**2*r*s - 720*C*D1**2*Pk2*bdd1*f**2*r - 864*C*D1**2*Pk2*bdd1*f**2*s**2 + 4296*C*D1**2*Pk2*f**2*fd*r**2 - 7344*C*D1**2*Pk2*f**2*fd*r*s - 416*C*D1**2*Pk2*f**2*fd*r - 14136*C*D1**2*Pk2*f**2*fd*s**2 + 11872*C*D1**2*Pk2*f**2*fd*s - 3280*C*D1**2*Pk2*f**2*fd - 3768*C*D1**2*Pk2*f**2*fdd*r**2 + 4752*C*D1**2*Pk2*f**2*fdd*r*s + 928*C*D1**2*Pk2*f**2*fdd*r + 10632*C*D1**2*Pk2*f**2*fdd*s**2 - 8672*C*D1**2*Pk2*f**2*fdd*s + 2288*C*D1**2*Pk2*f**2*fdd - 7536*C*D1**2*Pk2*f*fd**2*r**2 + 9504*C*D1**2*Pk2*f*fd**2*r*s + 1856*C*D1**2*Pk2*f*fd**2*r + 21264*C*D1**2*Pk2*f*fd**2*s**2 - 17344*C*D1**2*Pk2*f*fd**2*s + 1584*C*D1**2*Pk2*f*fd**2 - 54*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 108*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 54*C*D1**2*Pkdd2*bdd1*f**2*k1**2 + 198*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 132*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 66*C*D1**2*Pkdd2*f**2*fd*k1**2 - 180*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 120*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 60*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 360*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 240*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 5728*C*D1*Dd*Pk2*f**3*r**2 - 9792*C*D1*Dd*Pk2*f**3*r*s - 3280*C*D1*Dd*Pk2*f**3*r - 18848*C*D1*Dd*Pk2*f**3*s**2 + 14320*C*D1*Dd*Pk2*f**3*s - 1848*C*D1*Dd*Pk2*f**3 - 30144*C*D1*Dd*Pk2*f**2*fd*r**2 + 38016*C*D1*Dd*Pk2*f**2*fd*r*s + 14032*C*D1*Dd*Pk2*f**2*fd*r + 85056*C*D1*Dd*Pk2*f**2*fd*s**2 - 65456*C*D1*Dd*Pk2*f**2*fd*s + 6816*C*D1*Dd*Pk2*f**2*fd + 264*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 132*C*D1*Dd*Pkdd2*f**3*k1**2*s + 66*C*D1*Dd*Pkdd2*f**3*k1**2 - 1440*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 840*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 120*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 5024*C*D1*Ddd*Pk2*f**3*r**2 + 6336*C*D1*Ddd*Pk2*f**3*r*s + 3440*C*D1*Ddd*Pk2*f**3*r + 14176*C*D1*Ddd*Pk2*f**3*s**2 - 10256*C*D1*Ddd*Pk2*f**3*s + 1032*C*D1*Ddd*Pk2*f**3 - 240*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 120*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 60*C*D1*Ddd*Pkdd2*f**3*k1**2 - 15072*C*Dd**2*Pk2*f**3*r**2 + 19008*C*Dd**2*Pk2*f**3*r*s + 10320*C*Dd**2*Pk2*f**3*r + 42528*C*Dd**2*Pk2*f**3*s**2 - 30768*C*Dd**2*Pk2*f**3*s + 656*C*Dd**2*Pk2*f**3 - 720*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 360*C*Dd**2*Pkdd2*f**3*k1**2*s - 684*D1**2*K*Pk2*bdd1*f**2*r**2 + 1368*D1**2*K*Pk2*bdd1*f**2*r*s + 1368*D1**2*K*Pk2*bdd1*f**2*r + 3708*D1**2*K*Pk2*bdd1*f**2*s**2 - 1368*D1**2*K*Pk2*bdd1*f**2*s - 684*D1**2*K*Pk2*bdd1*f**2 - 54*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 3312*D1**2*Pk2*b2*f*fd*r*s + 1656*D1**2*Pk2*b2*f*fd*r - 3312*D1**2*Pk2*b2*f*fd*s**2 + 3312*D1**2*Pk2*b2*f*fd*s - 1656*D1**2*Pk2*b2*f*fd + 2160*D1**2*Pk2*b2*f*fdd*r*s - 1080*D1**2*Pk2*b2*f*fdd*r + 2160*D1**2*Pk2*b2*f*fdd*s**2 - 2160*D1**2*Pk2*b2*f*fdd*s + 1080*D1**2*Pk2*b2*f*fdd + 2160*D1**2*Pk2*b2*fd**2*r*s - 1080*D1**2*Pk2*b2*fd**2*r + 2160*D1**2*Pk2*b2*fd**2*s**2 - 2160*D1**2*Pk2*b2*fd**2*s - 1656*D1**2*Pk2*bd2*f**2*r*s - 1656*D1**2*Pk2*bd2*f**2*s**2 + 1656*D1**2*Pk2*bd2*f**2*s + 4320*D1**2*Pk2*bd2*f*fd*r*s - 1080*D1**2*Pk2*bd2*f*fd*r + 4320*D1**2*Pk2*bd2*f*fd*s**2 - 4320*D1**2*Pk2*bd2*f*fd*s + 1080*D1**2*Pk2*bd2*f*fd + 1350*D1**2*Pk2*bdd1*f**3*r**2 + 1620*D1**2*Pk2*bdd1*f**3*r*s - 2340*D1**2*Pk2*bdd1*f**3*r - 900*D1**2*Pk2*bdd1*f**3*s + 990*D1**2*Pk2*bdd1*f**3 + 1134*D1**2*Pk2*bdd1*f**2*r**2 + 2052*D1**2*Pk2*bdd1*f**2*r*s - 2772*D1**2*Pk2*bdd1*f**2*r + 432*D1**2*Pk2*bdd1*f**2*s**2 - 2628*D1**2*Pk2*bdd1*f**2*s + 1638*D1**2*Pk2*bdd1*f**2 - 1008*D1**2*Pk2*bdd1*f*g2*r**2 + 1008*D1**2*Pk2*bdd1*f*g2*r + 2016*D1**2*Pk2*bdd1*f*g2*s**2 + 1080*D1**2*Pk2*bdd2*f**2*r*s + 1080*D1**2*Pk2*bdd2*f**2*s**2 - 1080*D1**2*Pk2*bdd2*f**2*s + 3240*D1**2*Pk2*f**3*fd*r**2 + 4320*D1**2*Pk2*f**3*fd*r*s - 4320*D1**2*Pk2*f**3*fd*r - 2160*D1**2*Pk2*f**3*fd*s + 1620*D1**2*Pk2*f**3*fd - 3240*D1**2*Pk2*f**3*fdd*r**2 - 4320*D1**2*Pk2*f**3*fdd*r*s + 4320*D1**2*Pk2*f**3*fdd*r + 2160*D1**2*Pk2*f**3*fdd*s - 1620*D1**2*Pk2*f**3*fdd - 9720*D1**2*Pk2*f**2*fd**2*r**2 - 12960*D1**2*Pk2*f**2*fd**2*r*s + 12960*D1**2*Pk2*f**2*fd**2*r + 6480*D1**2*Pk2*f**2*fd**2*s - 3780*D1**2*Pk2*f**2*fd**2 - 7338*D1**2*Pk2*f**2*fd*r**2 - 3708*D1**2*Pk2*f**2*fd*r*s + 6128*D1**2*Pk2*f**2*fd*r + 6420*D1**2*Pk2*f**2*fd*s**2 - 3044*D1**2*Pk2*f**2*fd*s - 306*D1**2*Pk2*f**2*fd + 6342*D1**2*Pk2*f**2*fdd*r**2 + 3204*D1**2*Pk2*f**2*fdd*r*s - 5296*D1**2*Pk2*f**2*fdd*r - 5316*D1**2*Pk2*f**2*fdd*s**2 + 2476*D1**2*Pk2*f**2*fdd*s + 342*D1**2*Pk2*f**2*fdd - 1728*D1**2*Pk2*f**2*gd2*r**2 + 4464*D1**2*Pk2*f**2*gd2*r*s + 3456*D1**2*Pk2*f**2*gd2*r + 9288*D1**2*Pk2*f**2*gd2*s**2 - 4464*D1**2*Pk2*f**2*gd2*s - 1728*D1**2*Pk2*f**2*gd2 + 1368*D1**2*Pk2*f**2*gdd2*r**2 - 2736*D1**2*Pk2*f**2*gdd2*r*s - 2736*D1**2*Pk2*f**2*gdd2*r - 7416*D1**2*Pk2*f**2*gdd2*s**2 + 2736*D1**2*Pk2*f**2*gdd2*s + 1368*D1**2*Pk2*f**2*gdd2 + 12684*D1**2*Pk2*f*fd**2*r**2 + 6408*D1**2*Pk2*f*fd**2*r*s - 10592*D1**2*Pk2*f*fd**2*r - 10632*D1**2*Pk2*f*fd**2*s**2 + 4952*D1**2*Pk2*f*fd**2*s + 1068*D1**2*Pk2*f*fd**2 - 3456*D1**2*Pk2*f*fd*g2*r**2 + 8928*D1**2*Pk2*f*fd*g2*r*s - 4464*D1**2*Pk2*f*fd*g2*r + 18576*D1**2*Pk2*f*fd*g2*s**2 - 18576*D1**2*Pk2*f*fd*g2*s + 9288*D1**2*Pk2*f*fd*g2 + 5472*D1**2*Pk2*f*fd*gd2*r**2 - 10944*D1**2*Pk2*f*fd*gd2*r*s - 2736*D1**2*Pk2*f*fd*gd2*r - 29664*D1**2*Pk2*f*fd*gd2*s**2 + 20304*D1**2*Pk2*f*fd*gd2*s - 2736*D1**2*Pk2*f*fd*gd2 + 2736*D1**2*Pk2*f*fdd*g2*r**2 - 5472*D1**2*Pk2*f*fdd*g2*r*s + 2736*D1**2*Pk2*f*fdd*g2*r - 14832*D1**2*Pk2*f*fdd*g2*s**2 + 14832*D1**2*Pk2*f*fdd*g2*s - 7416*D1**2*Pk2*f*fdd*g2 + 2736*D1**2*Pk2*fd**2*g2*r**2 - 5472*D1**2*Pk2*fd**2*g2*r*s + 2736*D1**2*Pk2*fd**2*g2*r - 14832*D1**2*Pk2*fd**2*g2*s**2 + 14832*D1**2*Pk2*fd**2*g2*s + 150*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 75*D1**2*Pkdd2*bdd1*f**3*k1**2 + 81*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 108*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 54*D1**2*Pkdd2*bdd1*f**2*k1**2 + 126*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 252*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 126*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 300*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 150*D1**2*Pkdd2*f**3*fd*k1**2*s - 75*D1**2*Pkdd2*f**3*fd*k1**2 - 108*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 72*D1**2*Pkdd2*f**2*fd*k1**2*s - 36*D1**2*Pkdd2*f**2*fd*k1**2 + 135*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 90*D1**2*Pkdd2*f**2*fdd*k1**2*s + 45*D1**2*Pkdd2*f**2*fdd*k1**2 - 90*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 108*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 270*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 180*D1**2*Pkdd2*f*fd**2*k1**2*s - 180*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 180*D1**2*Pkdd2*f*fd*g2*k1**2*s - 90*D1**2*Pkdd2*f*fd*g2*k1**2 + 432*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 216*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 216*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 216*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 108*D1**2*Pkdd2*f*fdd*g2*k1**2 + 216*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 216*D1**2*Pkdd2*fd**2*g2*k1**2*s + 18*D1**2*bd1**2*f*(4*Pk2*(7*K*(2*r**2 - 3*r - 4*s**2 + 1) + 5*f*(r + 2*s - 1) - (14*r - 14)*(r + 2*s - 1)) + 7*Pkdd2*k1**2*s*(-K*s + K + s - 1)) - 6624*D1*Dd*Pk2*b2*f**2*r*s + 1656*D1*Dd*Pk2*b2*f**2*r - 6624*D1*Dd*Pk2*b2*f**2*s**2 + 6624*D1*Dd*Pk2*b2*f**2*s - 1656*D1*Dd*Pk2*b2*f**2 + 17280*D1*Dd*Pk2*b2*f*fd*r*s - 6480*D1*Dd*Pk2*b2*f*fd*r + 17280*D1*Dd*Pk2*b2*f*fd*s**2 - 17280*D1*Dd*Pk2*b2*f*fd*s + 4320*D1*Dd*Pk2*b2*f*fd + 8640*D1*Dd*Pk2*bd2*f**2*r*s - 1080*D1*Dd*Pk2*bd2*f**2*r + 8640*D1*Dd*Pk2*bd2*f**2*s**2 - 8640*D1*Dd*Pk2*bd2*f**2*s + 1080*D1*Dd*Pk2*bd2*f**2 + 3240*D1*Dd*Pk2*f**4*r**2 + 4320*D1*Dd*Pk2*f**4*r*s - 4320*D1*Dd*Pk2*f**4*r - 2160*D1*Dd*Pk2*f**4*s + 1620*D1*Dd*Pk2*f**4 - 25920*D1*Dd*Pk2*f**3*fd*r**2 - 34560*D1*Dd*Pk2*f**3*fd*r*s + 34560*D1*Dd*Pk2*f**3*fd*r + 17280*D1*Dd*Pk2*f**3*fd*s - 10800*D1*Dd*Pk2*f**3*fd - 9784*D1*Dd*Pk2*f**3*r**2 - 4944*D1*Dd*Pk2*f**3*r*s + 11020*D1*Dd*Pk2*f**3*r + 8560*D1*Dd*Pk2*f**3*s**2 - 1808*D1*Dd*Pk2*f**3*s - 2752*D1*Dd*Pk2*f**3 + 50736*D1*Dd*Pk2*f**2*fd*r**2 + 25632*D1*Dd*Pk2*f**2*fd*r*s - 49756*D1*Dd*Pk2*f**2*fd*r - 42528*D1*Dd*Pk2*f**2*fd*s**2 + 14128*D1*Dd*Pk2*f**2*fd*s + 8116*D1*Dd*Pk2*f**2*fd - 6912*D1*Dd*Pk2*f**2*g2*r**2 + 17856*D1*Dd*Pk2*f**2*g2*r*s + 2448*D1*Dd*Pk2*f**2*g2*r + 37152*D1*Dd*Pk2*f**2*g2*s**2 - 27504*D1*Dd*Pk2*f**2*g2*s + 5832*D1*Dd*Pk2*f**2*g2 + 10944*D1*Dd*Pk2*f**2*gd2*r**2 - 21888*D1*Dd*Pk2*f**2*gd2*r*s - 13680*D1*Dd*Pk2*f**2*gd2*r - 59328*D1*Dd*Pk2*f**2*gd2*s**2 + 31248*D1*Dd*Pk2*f**2*gd2*s + 2736*D1*Dd*Pk2*f**2*gd2 + 21888*D1*Dd*Pk2*f*fd*g2*r**2 - 43776*D1*Dd*Pk2*f*fd*g2*r*s + 5472*D1*Dd*Pk2*f*fd*g2*r - 118656*D1*Dd*Pk2*f*fd*g2*s**2 + 99936*D1*Dd*Pk2*f*fd*g2*s - 20304*D1*Dd*Pk2*f*fd*g2 - 300*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 150*D1*Dd*Pkdd2*f**4*k1**2*s - 75*D1*Dd*Pkdd2*f**4*k1**2 - 144*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 72*D1*Dd*Pkdd2*f**3*k1**2*s - 36*D1*Dd*Pkdd2*f**3*k1**2 + 1080*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 630*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 90*D1*Dd*Pkdd2*f**2*fd*k1**2 - 360*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 180*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 90*D1*Dd*Pkdd2*f**2*g2*k1**2 + 864*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 216*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 1728*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 1296*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 216*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 4320*D1*Ddd*Pk2*b2*f**2*r*s - 1080*D1*Ddd*Pk2*b2*f**2*r + 4320*D1*Ddd*Pk2*b2*f**2*s**2 - 4320*D1*Ddd*Pk2*b2*f**2*s + 1080*D1*Ddd*Pk2*b2*f**2 - 3240*D1*Ddd*Pk2*f**4*r**2 - 4320*D1*Ddd*Pk2*f**4*r*s + 4320*D1*Ddd*Pk2*f**4*r + 2160*D1*Ddd*Pk2*f**4*s - 1620*D1*Ddd*Pk2*f**4 + 8456*D1*Ddd*Pk2*f**3*r**2 + 4272*D1*Ddd*Pk2*f**3*r*s - 9524*D1*Ddd*Pk2*f**3*r - 7088*D1*Ddd*Pk2*f**3*s**2 + 1408*D1*Ddd*Pk2*f**3*s + 2456*D1*Ddd*Pk2*f**3 + 5472*D1*Ddd*Pk2*f**2*g2*r**2 - 10944*D1*Ddd*Pk2*f**2*g2*r*s - 2736*D1*Ddd*Pk2*f**2*g2*r - 29664*D1*Ddd*Pk2*f**2*g2*s**2 + 20304*D1*Ddd*Pk2*f**2*g2*s - 4680*D1*Ddd*Pk2*f**2*g2 + 180*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 90*D1*Ddd*Pkdd2*f**3*k1**2*s + 45*D1*Ddd*Pkdd2*f**3*k1**2 + 432*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 216*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 108*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 3*D1*bd1*(D1*(10*f**3*(3*Pk2*(13*r**2 + 22*r*(s - 1) + 4*s**2 - 14*s + 9) + 5*Pkdd2*k1**2*(2*s - 1)) + f**2*(-2*Pk2*(-184*C*r**2 - 80*C*r*s + 184*C*r + 288*C*s**2 + 6*K*(24*r**2 - 62*r*s - 48*r - 129*s**2 + 62*s + 24) + 30*fd*(45*r**2 + r*(54*s - 65) - 28*s + 20) - 161*r**2 - 418*r*s + 434*r - 228*s**2 + 498*s - 273) - Pkdd2*k1**2*(36*C*(s - 1)**2 + s**2*(15*K - 33) + s*(100*fd + 72) - 36)) - 6*f*fd*(2*Pk2*(4*C*(20*r**2 + r*(16*s - 19) - 24*s**2 + 8*s + 5) + K*(-76*r**2 + 38*r*(4*s + 1) + 412*s**2 - 282*s + 38) + 126*r**2 + 228*r*s - 197*r + 48*s**2 - 154*s + 59) - 3*Pkdd2*k1**2*s*(4*C*(s - 1) + K*(4*s - 2) - 6*s + 5)) + 84*f*(8*Pk2*g2*(-r**2 + r + 2*s**2) + 4*Pk2*gd2*(2*r**2 - 3*r - 4*s**2 + 1) + Pkdd2*g2*k1**2*(s - 1)**2 - Pkdd2*gd2*k1**2*s*(s - 1)) + 84*fd*g2*(8*Pk2*(r**2 - s*(2*s - 2)) - Pkdd2*k1**2*s*(s - 1))) - 2*Dd*f*(6*Pk2*f*(8*C*(20*r**2 + 2*r*(8*s - 11) - 24*s**2 + 2*s + 5) - 2*K*(76*r**2 - 19*r*(8*s + 5) - 412*s**2 + 217*s + 19) + 252*r**2 + 456*r*s - 491*r + 96*s**2 - 430*s + 227) - 9*Pkdd2*f*k1**2*(4*s - 1)*(2*C*(s - 1) + s*(2*K - 3) + 2) + 5*f**2*(6*Pk2*(60*r**2 + r*(72*s - 91) - 38*s + 31) + 5*Pkdd2*k1**2*(4*s - 1)) + 42*g2*(-8*Pk2*(4*r**2 - 4*r - 8*s**2 + 2*s + 1) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 12960*Dd**2*Pk2*b2*f**2*r*s - 3240*Dd**2*Pk2*b2*f**2*r + 12960*Dd**2*Pk2*b2*f**2*s**2 - 12960*Dd**2*Pk2*b2*f**2*s + 2160*Dd**2*Pk2*b2*f**2 - 9720*Dd**2*Pk2*f**4*r**2 - 12960*Dd**2*Pk2*f**4*r*s + 12960*Dd**2*Pk2*f**4*r + 6480*Dd**2*Pk2*f**4*s - 3780*Dd**2*Pk2*f**4 + 25368*Dd**2*Pk2*f**3*r**2 + 12816*Dd**2*Pk2*f**3*r*s - 28572*Dd**2*Pk2*f**3*r - 21264*Dd**2*Pk2*f**3*s**2 + 4224*Dd**2*Pk2*f**3*s + 6364*Dd**2*Pk2*f**3 + 16416*Dd**2*Pk2*f**2*g2*r**2 - 32832*Dd**2*Pk2*f**2*g2*r*s - 8208*Dd**2*Pk2*f**2*g2*r - 88992*Dd**2*Pk2*f**2*g2*s**2 + 60912*Dd**2*Pk2*f**2*g2*s - 2736*Dd**2*Pk2*f**2*g2 + 540*Dd**2*Pkdd2*f**3*k1**2*s**2 - 270*Dd**2*Pkdd2*f**3*k1**2*s + 1296*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 648*Dd**2*Pkdd2*f**2*g2*k1**2*s + 9*b1**2*(D1**2*(-40*Pk2*fd**2*(r + 2*s - 1) + 16*Pk2*fd*(-7*K*(r**2 + r - 2*(s - 1)**2) + 5*f*(r + 2*s - 1) + (7*r + 7)*(r + 2*s - 1)) - 8*Pk2*fdd*(-7*K*(r**2 + r - 2*(s - 1)**2) + 5*f*(r + 2*s - 1) + (7*r + 7)*(r + 2*s - 1)) + 14*Pkdd2*fd*k1**2*s**2*(K - 1) - 7*Pkdd2*fdd*k1**2*s**2*(K - 1)) - D1*(2*Dd*(f*(16*Pk2*(5*fd*(r + 2*s - 1) + r**2*(14*K - 14) - 7*r*(2*K + 4*s - 3) - (14*s - 7)*(2*K*s - 1)) + Pkdd2*k1**2*(7 - 7*K)*(4*s**2 - 2*s + 1)) + 7*fd*(-8*K*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + 8*Pk2*(4*r + 1)*(r + 2*s - 1) + Pkdd2*k1**2*s*(K - 1)*(4*s - 1))) + 7*Ddd*f*(-16*Pk2*(r**2*(2*K - 2) + r*(-2*K - 4*s + 3) - (2*s - 1)*(2*K*s - 1)) + Pkdd2*k1**2*(K - 1)*(4*s**2 - 2*s + 1))) + 14*Dd**2*f*(8*Pk2*(K*(6*r**2 - 6*r - 12*s**2 + 6*s + 1) + (3 - 6*r)*(r + 2*s - 1)) + 3*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1))) - 3*b1*(736*C*D1**2*Pk2*f*fd*r**2 + 320*C*D1**2*Pk2*f*fd*r*s - 528*C*D1**2*Pk2*f*fd*r - 1152*C*D1**2*Pk2*f*fd*s**2 + 992*C*D1**2*Pk2*f*fd*s - 208*C*D1**2*Pk2*f*fd - 480*C*D1**2*Pk2*f*fdd*r**2 - 384*C*D1**2*Pk2*f*fdd*r*s + 432*C*D1**2*Pk2*f*fdd*r + 576*C*D1**2*Pk2*f*fdd*s**2 - 384*C*D1**2*Pk2*f*fdd*s + 48*C*D1**2*Pk2*f*fdd - 480*C*D1**2*Pk2*fd**2*r**2 - 384*C*D1**2*Pk2*fd**2*r*s + 432*C*D1**2*Pk2*fd**2*r + 576*C*D1**2*Pk2*fd**2*s**2 - 384*C*D1**2*Pk2*fd**2*s + 48*C*D1**2*Pk2*fd**2 - 72*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 36*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 36*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 1472*C*D1*Dd*Pk2*f**2*r**2 + 640*C*D1*Dd*Pk2*f**2*r*s - 1632*C*D1*Dd*Pk2*f**2*r - 2304*C*D1*Dd*Pk2*f**2*s**2 + 832*C*D1*Dd*Pk2*f**2*s + 160*C*D1*Dd*Pk2*f**2 - 3840*C*D1*Dd*Pk2*f*fd*r**2 - 3072*C*D1*Dd*Pk2*f*fd*r*s + 4032*C*D1*Dd*Pk2*f*fd*r + 4608*C*D1*Dd*Pk2*f*fd*s**2 - 1920*C*D1*Dd*Pk2*f*fd*s - 480*C*D1*Dd*Pk2*f*fd - 144*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 72*C*D1*Dd*Pkdd2*f**2*k1**2*s - 36*C*D1*Dd*Pkdd2*f**2*k1**2 + 288*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 72*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 960*C*D1*Ddd*Pk2*f**2*r**2 - 768*C*D1*Ddd*Pk2*f**2*r*s + 1152*C*D1*Ddd*Pk2*f**2*r + 1152*C*D1*Ddd*Pk2*f**2*s**2 - 192*C*D1*Ddd*Pk2*f**2*s - 192*C*D1*Ddd*Pk2*f**2 + 72*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 36*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 18*C*D1*Ddd*Pkdd2*f**2*k1**2 - 2880*C*Dd**2*Pk2*f**2*r**2 - 2304*C*Dd**2*Pk2*f**2*r*s + 3456*C*Dd**2*Pk2*f**2*r + 3456*C*Dd**2*Pk2*f**2*s**2 - 576*C*Dd**2*Pk2*f**2*s - 864*C*Dd**2*Pk2*f**2 + 216*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 108*C*Dd**2*Pkdd2*f**2*k1**2*s - 576*D1**2*K*Pk2*f*fd*r**2 + 1488*D1**2*K*Pk2*f*fd*r*s - 744*D1**2*K*Pk2*f*fd*r + 3096*D1**2*K*Pk2*f*fd*s**2 - 3096*D1**2*K*Pk2*f*fd*s + 1548*D1**2*K*Pk2*f*fd + 456*D1**2*K*Pk2*f*fdd*r**2 - 912*D1**2*K*Pk2*f*fdd*r*s + 456*D1**2*K*Pk2*f*fdd*r - 2472*D1**2*K*Pk2*f*fdd*s**2 + 2472*D1**2*K*Pk2*f*fdd*s - 1236*D1**2*K*Pk2*f*fdd + 456*D1**2*K*Pk2*fd**2*r**2 - 912*D1**2*K*Pk2*fd**2*r*s + 456*D1**2*K*Pk2*fd**2*r - 2472*D1**2*K*Pk2*fd**2*s**2 + 2472*D1**2*K*Pk2*fd**2*s - 30*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 30*D1**2*K*Pkdd2*f*fd*k1**2*s - 15*D1**2*K*Pkdd2*f*fd*k1**2 + 36*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 36*D1**2*K*Pkdd2*f*fdd*k1**2*s + 18*D1**2*K*Pkdd2*f*fdd*k1**2 + 36*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 36*D1**2*K*Pkdd2*fd**2*k1**2*s + 1170*D1**2*Pk2*f**2*fd*r**2 + 1980*D1**2*Pk2*f**2*fd*r*s - 1560*D1**2*Pk2*f**2*fd*r + 360*D1**2*Pk2*f**2*fd*s**2 - 1140*D1**2*Pk2*f**2*fd*s + 630*D1**2*Pk2*f**2*fd - 1350*D1**2*Pk2*f**2*fdd*r**2 - 1620*D1**2*Pk2*f**2*fdd*r*s + 1560*D1**2*Pk2*f**2*fdd*r + 780*D1**2*Pk2*f**2*fdd*s - 570*D1**2*Pk2*f**2*fdd - 2700*D1**2*Pk2*f*fd**2*r**2 - 3240*D1**2*Pk2*f*fd**2*r*s + 3120*D1**2*Pk2*f*fd**2*r + 1560*D1**2*Pk2*f*fd**2*s - 780*D1**2*Pk2*f*fd**2 + 644*D1**2*Pk2*f*fd*r**2 + 1672*D1**2*Pk2*f*fd*r*s - 612*D1**2*Pk2*f*fd*r + 912*D1**2*Pk2*f*fd*s**2 - 752*D1**2*Pk2*f*fd*s + 232*D1**2*Pk2*f*fd - 756*D1**2*Pk2*f*fdd*r**2 - 1368*D1**2*Pk2*f*fdd*r*s + 516*D1**2*Pk2*f*fdd*r - 288*D1**2*Pk2*f*fdd*s**2 + 96*D1**2*Pk2*f*fdd*s + 24*D1**2*Pk2*f*fdd - 672*D1**2*Pk2*f*gd2*r**2 + 1344*D1**2*Pk2*f*gd2*r + 1344*D1**2*Pk2*f*gd2*s**2 - 672*D1**2*Pk2*f*gd2 + 336*D1**2*Pk2*f*gdd2*r**2 - 672*D1**2*Pk2*f*gdd2*r - 672*D1**2*Pk2*f*gdd2*s**2 + 336*D1**2*Pk2*f*gdd2 - 756*D1**2*Pk2*fd**2*r**2 - 1368*D1**2*Pk2*fd**2*r*s + 516*D1**2*Pk2*fd**2*r - 288*D1**2*Pk2*fd**2*s**2 + 96*D1**2*Pk2*fd**2*s + 24*D1**2*Pk2*fd**2 - 672*D1**2*Pk2*fd*g2*r**2 - 672*D1**2*Pk2*fd*g2*r + 1344*D1**2*Pk2*fd*g2*s**2 - 2688*D1**2*Pk2*fd*g2*s + 1344*D1**2*Pk2*fd*g2 + 672*D1**2*Pk2*fd*gd2*r**2 - 336*D1**2*Pk2*fd*gd2*r - 1344*D1**2*Pk2*fd*gd2*s**2 + 1344*D1**2*Pk2*fd*gd2*s - 336*D1**2*Pk2*fd*gd2 + 336*D1**2*Pk2*fdd*g2*r**2 + 336*D1**2*Pk2*fdd*g2*r - 672*D1**2*Pk2*fdd*g2*s**2 + 1344*D1**2*Pk2*fdd*g2*s - 672*D1**2*Pk2*fdd*g2 - 100*D1**2*Pkdd2*f**2*fd*k1**2*s + 50*D1**2*Pkdd2*f**2*fd*k1**2 + 50*D1**2*Pkdd2*f**2*fdd*k1**2*s - 25*D1**2*Pkdd2*f**2*fdd*k1**2 + 100*D1**2*Pkdd2*f*fd**2*k1**2*s + 66*D1**2*Pkdd2*f*fd*k1**2*s**2 + 6*D1**2*Pkdd2*f*fd*k1**2*s - 3*D1**2*Pkdd2*f*fd*k1**2 - 54*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 18*D1**2*Pkdd2*f*fdd*k1**2*s - 9*D1**2*Pkdd2*f*fdd*k1**2 + 84*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 54*D1**2*Pkdd2*fd**2*k1**2*s**2 + 18*D1**2*Pkdd2*fd**2*k1**2*s + 84*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 84*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 3*D1**2*bdd1*f*(8*Pk2*(7*K*(2*r**2 - 3*r - 4*s**2 + 1) + 5*f*(r + 2*s - 1) - (14*r - 14)*(r + 2*s - 1)) + Pkdd2*k1**2*(7 - 7*K)*(2*s**2 - 2*s + 1)) - 1152*D1*Dd*K*Pk2*f**2*r**2 + 2976*D1*Dd*K*Pk2*f**2*r*s + 408*D1*Dd*K*Pk2*f**2*r + 6192*D1*Dd*K*Pk2*f**2*s**2 - 4584*D1*Dd*K*Pk2*f**2*s + 972*D1*Dd*K*Pk2*f**2 + 3648*D1*Dd*K*Pk2*f*fd*r**2 - 7296*D1*Dd*K*Pk2*f*fd*r*s + 912*D1*Dd*K*Pk2*f*fd*r - 19776*D1*Dd*K*Pk2*f*fd*s**2 + 16656*D1*Dd*K*Pk2*f*fd*s - 3384*D1*Dd*K*Pk2*f*fd - 60*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 30*D1*Dd*K*Pkdd2*f**2*k1**2*s - 15*D1*Dd*K*Pkdd2*f**2*k1**2 + 288*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 216*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 36*D1*Dd*K*Pkdd2*f*fd*k1**2 + 1560*D1*Dd*Pk2*f**3*r**2 + 2640*D1*Dd*Pk2*f**3*r*s - 2220*D1*Dd*Pk2*f**3*r + 480*D1*Dd*Pk2*f**3*s**2 - 1560*D1*Dd*Pk2*f**3*s + 900*D1*Dd*Pk2*f**3 - 10800*D1*Dd*Pk2*f**2*fd*r**2 - 12960*D1*Dd*Pk2*f**2*fd*r*s + 13260*D1*Dd*Pk2*f**2*fd*r + 6360*D1*Dd*Pk2*f**2*fd*s - 3900*D1*Dd*Pk2*f**2*fd + 1288*D1*Dd*Pk2*f**2*r**2 + 3344*D1*Dd*Pk2*f**2*r*s - 2124*D1*Dd*Pk2*f**2*r + 1824*D1*Dd*Pk2*f**2*s**2 - 2584*D1*Dd*Pk2*f**2*s + 1100*D1*Dd*Pk2*f**2 - 6048*D1*Dd*Pk2*f*fd*r**2 - 10944*D1*Dd*Pk2*f*fd*r*s + 6456*D1*Dd*Pk2*f*fd*r - 2304*D1*Dd*Pk2*f*fd*s**2 + 3696*D1*Dd*Pk2*f*fd*s - 1128*D1*Dd*Pk2*f*fd - 2688*D1*Dd*Pk2*f*g2*r**2 + 2688*D1*Dd*Pk2*f*g2*r + 5376*D1*Dd*Pk2*f*g2*s**2 - 2688*D1*Dd*Pk2*f*g2*s + 2688*D1*Dd*Pk2*f*gd2*r**2 - 4032*D1*Dd*Pk2*f*gd2*r - 5376*D1*Dd*Pk2*f*gd2*s**2 + 1344*D1*Dd*Pk2*f*gd2*s + 1344*D1*Dd*Pk2*f*gd2 + 2688*D1*Dd*Pk2*fd*g2*r**2 - 5376*D1*Dd*Pk2*fd*g2*s**2 + 6720*D1*Dd*Pk2*fd*g2*s - 2016*D1*Dd*Pk2*fd*g2 + 200*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 50*D1*Dd*Pkdd2*f**2*fd*k1**2 + 132*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 66*D1*Dd*Pkdd2*f**2*k1**2*s + 33*D1*Dd*Pkdd2*f**2*k1**2 - 432*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 180*D1*Dd*Pkdd2*f*fd*k1**2*s - 18*D1*Dd*Pkdd2*f*fd*k1**2 + 336*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 168*D1*Dd*Pkdd2*f*g2*k1**2*s + 84*D1*Dd*Pkdd2*f*g2*k1**2 - 336*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 84*D1*Dd*Pkdd2*f*gd2*k1**2*s - 336*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 84*D1*Dd*Pkdd2*fd*g2*k1**2*s + 912*D1*Ddd*K*Pk2*f**2*r**2 - 1824*D1*Ddd*K*Pk2*f**2*r*s - 456*D1*Ddd*K*Pk2*f**2*r - 4944*D1*Ddd*K*Pk2*f**2*s**2 + 3384*D1*Ddd*K*Pk2*f**2*s - 780*D1*Ddd*K*Pk2*f**2 + 72*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 36*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 18*D1*Ddd*K*Pkdd2*f**2*k1**2 - 1800*D1*Ddd*Pk2*f**3*r**2 - 2160*D1*Ddd*Pk2*f**3*r*s + 2340*D1*Ddd*Pk2*f**3*r + 1080*D1*Ddd*Pk2*f**3*s - 900*D1*Ddd*Pk2*f**3 - 1512*D1*Ddd*Pk2*f**2*r**2 - 2736*D1*Ddd*Pk2*f**2*r*s + 2196*D1*Ddd*Pk2*f**2*r - 576*D1*Ddd*Pk2*f**2*s**2 + 1656*D1*Ddd*Pk2*f**2*s - 900*D1*Ddd*Pk2*f**2 + 1344*D1*Ddd*Pk2*f*g2*r**2 - 1344*D1*Ddd*Pk2*f*g2*r - 2688*D1*Ddd*Pk2*f*g2*s**2 + 1344*D1*Ddd*Pk2*f*g2*s - 108*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 54*D1*Ddd*Pkdd2*f**2*k1**2*s - 27*D1*Ddd*Pkdd2*f**2*k1**2 - 168*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 84*D1*Ddd*Pkdd2*f*g2*k1**2*s - 42*D1*Ddd*Pkdd2*f*g2*k1**2 + 6*D1*bd1*(D1*(40*Pk2*f**2*(r + 2*s - 1) + 7*f*(8*Pk2*(K*(2*r**2 - 3*r - 4*s**2 + 1) + (2 - 2*r)*(r + 2*s - 1)) - Pkdd2*k1**2*(K - 1)*(2*s**2 - 2*s + 1)) + 7*fd*(-4*K*Pk2*(4*r**2 - r - 8*s**2 + 8*s - 1) + K*Pkdd2*k1**2*s*(2*s - 1) + 16*Pk2*r*(r + 2*s - 1) + Pkdd2*k1**2*s*(1 - 2*s))) + Dd*f*(-8*Pk2*(7*K*(8*r**2 - 10*r - 16*s**2 + 4*s + 3) + 10*f*(r + 2*s - 1) - (56*r - 42)*(r + 2*s - 1)) + Pkdd2*k1**2*(7*K - 7)*(8*s**2 - 6*s + 1))) + 2736*Dd**2*K*Pk2*f**2*r**2 - 5472*Dd**2*K*Pk2*f**2*r*s - 1368*Dd**2*K*Pk2*f**2*r - 14832*Dd**2*K*Pk2*f**2*s**2 + 10152*Dd**2*K*Pk2*f**2*s - 456*Dd**2*K*Pk2*f**2 + 216*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 108*Dd**2*K*Pkdd2*f**2*k1**2*s - 5400*Dd**2*Pk2*f**3*r**2 - 6480*Dd**2*Pk2*f**3*r*s + 7020*Dd**2*Pk2*f**3*r + 3240*Dd**2*Pk2*f**3*s - 1980*Dd**2*Pk2*f**3 - 4536*Dd**2*Pk2*f**2*r**2 - 8208*Dd**2*Pk2*f**2*r*s + 6588*Dd**2*Pk2*f**2*r - 1728*Dd**2*Pk2*f**2*s**2 + 4968*Dd**2*Pk2*f**2*s - 2124*Dd**2*Pk2*f**2 + 4032*Dd**2*Pk2*f*g2*r**2 - 4032*Dd**2*Pk2*f*g2*r - 8064*Dd**2*Pk2*f*g2*s**2 + 4032*Dd**2*Pk2*f*g2*s + 672*Dd**2*Pk2*f*g2 - 324*Dd**2*Pkdd2*f**2*k1**2*s**2 + 162*Dd**2*Pkdd2*f**2*k1**2*s - 504*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 252*Dd**2*Pkdd2*f*g2*k1**2*s))/(315*d**2*k3**4) - D1**2*Pk3*ct**3*k1*k2*(-576*C*D1**2*Pk2*bdd1*f**2*r**2 + 2208*C*D1**2*Pk2*bdd1*f**2*r*s + 2832*C*D1**2*Pk2*bdd1*f**2*r + 3240*C*D1**2*Pk2*bdd1*f**2*s**2 + 12072*C*D1**2*Pk2*f**2*fd*r**2 + 47136*C*D1**2*Pk2*f**2*fd*r*s - 23760*C*D1**2*Pk2*f**2*fd*r + 27432*C*D1**2*Pk2*f**2*fd*s**2 - 34000*C*D1**2*Pk2*f**2*fd*s + 13168*C*D1**2*Pk2*f**2*fd - 12192*C*D1**2*Pk2*f**2*fdd*r**2 - 44736*C*D1**2*Pk2*f**2*fdd*r*s + 23040*C*D1**2*Pk2*f**2*fdd*r - 25272*C*D1**2*Pk2*f**2*fdd*s**2 + 31760*C*D1**2*Pk2*f**2*fdd*s - 12488*C*D1**2*Pk2*f**2*fdd - 24384*C*D1**2*Pk2*f*fd**2*r**2 - 89472*C*D1**2*Pk2*f*fd**2*r*s + 46080*C*D1**2*Pk2*f*fd**2*r - 50544*C*D1**2*Pk2*f*fd**2*s**2 + 63520*C*D1**2*Pk2*f*fd**2*s - 14912*C*D1**2*Pk2*f*fd**2 - 180*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 360*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 180*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 540*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 360*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 180*C*D1**2*Pkdd2*f**2*fd*k1**2 + 16096*C*D1*Dd*Pk2*f**3*r**2 + 62848*C*D1*Dd*Pk2*f**3*r*s - 31808*C*D1*Dd*Pk2*f**3*r + 36576*C*D1*Dd*Pk2*f**3*s**2 - 49712*C*D1*Dd*Pk2*f**3*s + 17192*C*D1*Dd*Pk2*f**3 - 97536*C*D1*Dd*Pk2*f**2*fd*r**2 - 357888*C*D1*Dd*Pk2*f**2*fd*r*s + 185664*C*D1*Dd*Pk2*f**2*fd*r - 202176*C*D1*Dd*Pk2*f**2*fd*s**2 + 267056*C*D1*Dd*Pk2*f**2*fd*s - 77840*C*D1*Dd*Pk2*f**2*fd - 720*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 360*C*D1*Dd*Pkdd2*f**3*k1**2*s - 180*C*D1*Dd*Pkdd2*f**3*k1**2 - 16256*C*D1*Ddd*Pk2*f**3*r**2 - 59648*C*D1*Ddd*Pk2*f**3*r*s + 31168*C*D1*Ddd*Pk2*f**3*r - 33696*C*D1*Ddd*Pk2*f**3*s**2 + 46672*C*D1*Ddd*Pk2*f**3*s - 16552*C*D1*Ddd*Pk2*f**3 - 48768*C*Dd**2*Pk2*f**3*r**2 - 178944*C*Dd**2*Pk2*f**3*r*s + 93504*C*Dd**2*Pk2*f**3*r - 101088*C*Dd**2*Pk2*f**3*s**2 + 140016*C*Dd**2*Pk2*f**3*s - 37952*C*Dd**2*Pk2*f**3 - 2184*D1**2*K*Pk2*bdd1*f**2*r**2 - 9072*D1**2*K*Pk2*bdd1*f**2*r*s + 4368*D1**2*K*Pk2*bdd1*f**2*r - 6300*D1**2*K*Pk2*bdd1*f**2*s**2 + 9072*D1**2*K*Pk2*bdd1*f**2*s - 2184*D1**2*K*Pk2*bdd1*f**2 + 1512*D1**2*Pk2*b2*f*fd*r**2 + 8064*D1**2*Pk2*b2*f*fd*r*s - 4032*D1**2*Pk2*b2*f*fd*r + 6552*D1**2*Pk2*b2*f*fd*s**2 - 6552*D1**2*Pk2*b2*f*fd*s + 3276*D1**2*Pk2*b2*f*fd - 2520*D1**2*Pk2*b2*f*fdd*r**2 - 8064*D1**2*Pk2*b2*f*fdd*r*s + 4032*D1**2*Pk2*b2*f*fdd*r - 5544*D1**2*Pk2*b2*f*fdd*s**2 + 5544*D1**2*Pk2*b2*f*fdd*s - 2772*D1**2*Pk2*b2*f*fdd - 2520*D1**2*Pk2*b2*fd**2*r**2 - 8064*D1**2*Pk2*b2*fd**2*r*s + 4032*D1**2*Pk2*b2*fd**2*r - 5544*D1**2*Pk2*b2*fd**2*s**2 + 5544*D1**2*Pk2*b2*fd**2*s + 756*D1**2*Pk2*bd2*f**2*r**2 + 4032*D1**2*Pk2*bd2*f**2*r*s - 1512*D1**2*Pk2*bd2*f**2*r + 3276*D1**2*Pk2*bd2*f**2*s**2 - 4032*D1**2*Pk2*bd2*f**2*s + 756*D1**2*Pk2*bd2*f**2 - 5040*D1**2*Pk2*bd2*f*fd*r**2 - 16128*D1**2*Pk2*bd2*f*fd*r*s + 9072*D1**2*Pk2*bd2*f*fd*r - 11088*D1**2*Pk2*bd2*f*fd*s**2 + 13608*D1**2*Pk2*bd2*f*fd*s - 4032*D1**2*Pk2*bd2*f*fd + 2016*D1**2*Pk2*bdd1*f**3*r*s - 1260*D1**2*Pk2*bdd1*f**3*r + 1260*D1**2*Pk2*bdd1*f**3*s**2 - 3024*D1**2*Pk2*bdd1*f**3*s + 1134*D1**2*Pk2*bdd1*f**3 + 3090*D1**2*Pk2*bdd1*f**2*r**2 + 3984*D1**2*Pk2*bdd1*f**2*r*s - 6168*D1**2*Pk2*bdd1*f**2*r + 144*D1**2*Pk2*bdd1*f**2*s**2 - 4140*D1**2*Pk2*bdd1*f**2*s + 1272*D1**2*Pk2*bdd1*f**2 + 336*D1**2*Pk2*bdd1*f*g2*r**2 - 4032*D1**2*Pk2*bdd1*f*g2*r*s - 3024*D1**2*Pk2*bdd1*f*g2*r - 5208*D1**2*Pk2*bdd1*f*g2*s**2 - 1260*D1**2*Pk2*bdd2*f**2*r**2 - 4032*D1**2*Pk2*bdd2*f**2*r*s + 2520*D1**2*Pk2*bdd2*f**2*r - 2772*D1**2*Pk2*bdd2*f**2*s**2 + 4032*D1**2*Pk2*bdd2*f**2*s - 1260*D1**2*Pk2*bdd2*f**2 - 6174*D1**2*Pk2*f**2*fd*r**2 - 29232*D1**2*Pk2*f**2*fd*r*s + 13860*D1**2*Pk2*f**2*fd*r - 17064*D1**2*Pk2*f**2*fd*s**2 + 21120*D1**2*Pk2*f**2*fd*s - 7746*D1**2*Pk2*f**2*fd + 7434*D1**2*Pk2*f**2*fdd*r**2 + 28872*D1**2*Pk2*f**2*fdd*r*s - 14580*D1**2*Pk2*f**2*fdd*r + 15984*D1**2*Pk2*f**2*fdd*s**2 - 20280*D1**2*Pk2*f**2*fdd*s + 7806*D1**2*Pk2*f**2*fdd - 2856*D1**2*Pk2*f**2*gd2*r**2 - 18144*D1**2*Pk2*f**2*gd2*r*s + 5712*D1**2*Pk2*f**2*gd2*r - 13608*D1**2*Pk2*f**2*gd2*s**2 + 18144*D1**2*Pk2*f**2*gd2*s - 2856*D1**2*Pk2*f**2*gd2 + 4368*D1**2*Pk2*f**2*gdd2*r**2 + 18144*D1**2*Pk2*f**2*gdd2*r*s - 8736*D1**2*Pk2*f**2*gdd2*r + 12600*D1**2*Pk2*f**2*gdd2*s**2 - 18144*D1**2*Pk2*f**2*gdd2*s + 4368*D1**2*Pk2*f**2*gdd2 + 14868*D1**2*Pk2*f*fd**2*r**2 + 57744*D1**2*Pk2*f*fd**2*r*s - 29160*D1**2*Pk2*f*fd**2*r + 31968*D1**2*Pk2*f*fd**2*s**2 - 40560*D1**2*Pk2*f*fd**2*s + 9624*D1**2*Pk2*f*fd**2 - 5712*D1**2*Pk2*f*fd*g2*r**2 - 36288*D1**2*Pk2*f*fd*g2*r*s + 18144*D1**2*Pk2*f*fd*g2*r - 27216*D1**2*Pk2*f*fd*g2*s**2 + 27216*D1**2*Pk2*f*fd*g2*s - 13608*D1**2*Pk2*f*fd*g2 + 17472*D1**2*Pk2*f*fd*gd2*r**2 + 72576*D1**2*Pk2*f*fd*gd2*r*s - 35616*D1**2*Pk2*f*fd*gd2*r + 50400*D1**2*Pk2*f*fd*gd2*s**2 - 61488*D1**2*Pk2*f*fd*gd2*s + 18144*D1**2*Pk2*f*fd*gd2 + 8736*D1**2*Pk2*f*fdd*g2*r**2 + 36288*D1**2*Pk2*f*fdd*g2*r*s - 18144*D1**2*Pk2*f*fdd*g2*r + 25200*D1**2*Pk2*f*fdd*g2*s**2 - 25200*D1**2*Pk2*f*fdd*g2*s + 12600*D1**2*Pk2*f*fdd*g2 + 8736*D1**2*Pk2*fd**2*g2*r**2 + 36288*D1**2*Pk2*fd**2*g2*r*s - 18144*D1**2*Pk2*fd**2*g2*r + 25200*D1**2*Pk2*fd**2*g2*s**2 - 25200*D1**2*Pk2*fd**2*g2*s + 135*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 270*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 135*D1**2*Pkdd2*bdd1*f**2*k1**2 + 252*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 504*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 252*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 405*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 270*D1**2*Pkdd2*f**2*fd*k1**2*s + 135*D1**2*Pkdd2*f**2*fd*k1**2 + 252*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 504*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 504*D1**2*Pkdd2*f*fd*g2*k1**2*s + 252*D1**2*Pkdd2*f*fd*g2*k1**2 + 6*D1**2*bd1**2*(-280*Pk2*g2*r*(2*r + 2*s - 1) + f**2*(42*Pk2*(8*r**2 + r*(8*s - 15) - 9*s + 9) + 45*Pkdd2*k1**2*s*(s - 1)) - 7*f*(2*Pk2*(2*K*(2*r**2 - r*(24*s + 11) - 31*s**2 + 12*s + 9) - r**2*(40*C + 18) + r*(-40*C*s + 20*C - 28*s + 93) + 65*s - 55) + Pkdd2*k1**2*s*(6*K - 3)*(s - 1))) + 3024*D1*Dd*Pk2*b2*f**2*r**2 + 16128*D1*Dd*Pk2*b2*f**2*r*s - 7056*D1*Dd*Pk2*b2*f**2*r + 13104*D1*Dd*Pk2*b2*f**2*s**2 - 14616*D1*Dd*Pk2*b2*f**2*s + 4788*D1*Dd*Pk2*b2*f**2 - 20160*D1*Dd*Pk2*b2*f*fd*r**2 - 64512*D1*Dd*Pk2*b2*f*fd*r*s + 34272*D1*Dd*Pk2*b2*f*fd*r - 44352*D1*Dd*Pk2*b2*f*fd*s**2 + 49392*D1*Dd*Pk2*b2*f*fd*s - 13608*D1*Dd*Pk2*b2*f*fd - 10080*D1*Dd*Pk2*bd2*f**2*r**2 - 32256*D1*Dd*Pk2*bd2*f**2*r*s + 19152*D1*Dd*Pk2*bd2*f**2*r - 22176*D1*Dd*Pk2*bd2*f**2*s**2 + 29736*D1*Dd*Pk2*bd2*f**2*s - 9072*D1*Dd*Pk2*bd2*f**2 - 8232*D1*Dd*Pk2*f**3*r**2 - 38976*D1*Dd*Pk2*f**3*r*s + 17976*D1*Dd*Pk2*f**3*r - 22752*D1*Dd*Pk2*f**3*s**2 + 30864*D1*Dd*Pk2*f**3*s - 9804*D1*Dd*Pk2*f**3 + 59472*D1*Dd*Pk2*f**2*fd*r**2 + 230976*D1*Dd*Pk2*f**2*fd*r*s - 116928*D1*Dd*Pk2*f**2*fd*r + 127872*D1*Dd*Pk2*f**2*fd*s**2 - 170832*D1*Dd*Pk2*f**2*fd*s + 49440*D1*Dd*Pk2*f**2*fd - 11424*D1*Dd*Pk2*f**2*g2*r**2 - 72576*D1*Dd*Pk2*f**2*g2*r*s + 29568*D1*Dd*Pk2*f**2*g2*r - 54432*D1*Dd*Pk2*f**2*g2*s**2 + 63504*D1*Dd*Pk2*f**2*g2*s - 19320*D1*Dd*Pk2*f**2*g2 + 34944*D1*Dd*Pk2*f**2*gd2*r**2 + 145152*D1*Dd*Pk2*f**2*gd2*r*s - 70560*D1*Dd*Pk2*f**2*gd2*r + 100800*D1*Dd*Pk2*f**2*gd2*s**2 - 134064*D1*Dd*Pk2*f**2*gd2*s + 35616*D1*Dd*Pk2*f**2*gd2 + 69888*D1*Dd*Pk2*f*fd*g2*r**2 + 290304*D1*Dd*Pk2*f*fd*g2*r*s - 143808*D1*Dd*Pk2*f*fd*g2*r + 201600*D1*Dd*Pk2*f*fd*g2*s**2 - 223776*D1*Dd*Pk2*f*fd*g2*s + 61488*D1*Dd*Pk2*f*fd*g2 + 540*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 270*D1*Dd*Pkdd2*f**3*k1**2*s + 135*D1*Dd*Pkdd2*f**3*k1**2 + 1008*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 504*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 252*D1*Dd*Pkdd2*f**2*g2*k1**2 - 5040*D1*Ddd*Pk2*b2*f**2*r**2 - 16128*D1*Ddd*Pk2*b2*f**2*r*s + 9072*D1*Ddd*Pk2*b2*f**2*r - 11088*D1*Ddd*Pk2*b2*f**2*s**2 + 13608*D1*Ddd*Pk2*b2*f**2*s - 5292*D1*Ddd*Pk2*b2*f**2 + 9912*D1*Ddd*Pk2*f**3*r**2 + 38496*D1*Ddd*Pk2*f**3*r*s - 19536*D1*Ddd*Pk2*f**3*r + 21312*D1*Ddd*Pk2*f**3*s**2 - 29904*D1*Ddd*Pk2*f**3*s + 10284*D1*Ddd*Pk2*f**3 + 17472*D1*Ddd*Pk2*f**2*g2*r**2 + 72576*D1*Ddd*Pk2*f**2*g2*r*s - 35616*D1*Ddd*Pk2*f**2*g2*r + 50400*D1*Ddd*Pk2*f**2*g2*s**2 - 61488*D1*Ddd*Pk2*f**2*g2*s + 21336*D1*Ddd*Pk2*f**2*g2 - 3*D1*bd1*(D1*(3*f**3*(14*Pk2*(2*r*(8*s - 5) + 10*s**2 - 24*s + 9) + 15*Pkdd2*k1**2*(1 - 2*s)) - f**2*(2*Pk2*(612*C*r**2 - 176*C*r*s - 496*C*r - 660*C*s**2 + 14*K*(17*r**2 + 108*r*s - 34*r + 81*s**2 - 108*s + 17) + 42*fd*(6*r*(8*s - 3) + 30*s**2 - 50*s + 13) - 953*r**2 - 880*r*s + 908*r + 36*s**2 + 666*s - 116) + 3*Pkdd2*k1**2*(12*C*(s - 1)**2 + s**2*(5 - 14*K) + 4*s - 2)) + 4*f*(14*Pk2*g2*(29*r**2 - 8*r*(s + 2) - 37*s**2) - 28*Pk2*gd2*(2*r**2 - r*(24*s + 11) - 31*s**2 + 12*s + 9) + 7*Pkdd2*g2*k1**2*(s - 1)**2 - 42*Pkdd2*gd2*k1**2*s*(s - 1) + fd*(Pk2*(4*C*(48*r**2 - r*(184*s + 37) - 270*s**2 + 181*s + 59) + 14*K*(52*r**2 + 216*r*s - 106*r + 150*s**2 - 183*s + 54) - 1030*r**2 - 1328*r*s + 1361*r - 48*s**2 + 701*s - 647) + Pkdd2*k1**2*s*(60*C - 45)*(s - 1))) - 56*fd*g2*(Pk2*(4*r**2 + r*(24 - 48*s) - s*(62*s - 62)) + 3*Pkdd2*k1**2*s*(s - 1))) - 2*Dd*f*(84*Pk2*f**2*(2*r*(16*s - 7) + 20*s**2 - 37*s + 11) + f*(-2*Pk2*(4*C*(96*r**2 - 2*r*(184*s + 119) - 540*s**2 + 227*s + 118) + 14*K*(104*r**2 + 6*r*(72*s - 35) + 300*s**2 - 399*s + 106) - 2060*r**2 - 2656*r*s + 3418*r - 96*s**2 + 2068*s - 1373) + Pkdd2*k1**2*(45 - 60*C)*(4*s**2 - 5*s + 1)) + 28*g2*(2*Pk2*(8*r**2 - 4*r*(24*s + 7) - 124*s**2 + 55*s + 18) + 3*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 15120*Dd**2*Pk2*b2*f**2*r**2 - 48384*Dd**2*Pk2*b2*f**2*r*s + 27216*Dd**2*Pk2*b2*f**2*r - 33264*Dd**2*Pk2*b2*f**2*s**2 + 40824*Dd**2*Pk2*b2*f**2*s - 10584*Dd**2*Pk2*b2*f**2 + 29736*Dd**2*Pk2*f**3*r**2 + 115488*Dd**2*Pk2*f**3*r*s - 58608*Dd**2*Pk2*f**3*r + 63936*Dd**2*Pk2*f**3*s**2 - 89712*Dd**2*Pk2*f**3*s + 24204*Dd**2*Pk2*f**3 + 52416*Dd**2*Pk2*f**2*g2*r**2 + 217728*Dd**2*Pk2*f**2*g2*r*s - 106848*Dd**2*Pk2*f**2*g2*r + 151200*Dd**2*Pk2*f**2*g2*s**2 - 184464*Dd**2*Pk2*f**2*g2*s + 45024*Dd**2*Pk2*f**2*g2 - 840*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)) - 3*b1**2*(1120*C*D1**2*Pk2*fd*r**2 + 1120*C*D1**2*Pk2*fd*r*s - 2240*C*D1**2*Pk2*fd*r - 1120*C*D1**2*Pk2*fd*s + 1120*C*D1**2*Pk2*fd - 560*C*D1**2*Pk2*fdd*r**2 - 560*C*D1**2*Pk2*fdd*r*s + 1120*C*D1**2*Pk2*fdd*r + 560*C*D1**2*Pk2*fdd*s - 560*C*D1**2*Pk2*fdd + 4480*C*D1*Dd*Pk2*f*r**2 + 4480*C*D1*Dd*Pk2*f*r*s - 5600*C*D1*Dd*Pk2*f*r - 2240*C*D1*Dd*Pk2*f*s + 2240*C*D1*Dd*Pk2*f - 4480*C*D1*Dd*Pk2*fd*r**2 - 4480*C*D1*Dd*Pk2*fd*r*s + 7280*C*D1*Dd*Pk2*fd*r + 3360*C*D1*Dd*Pk2*fd*s - 2800*C*D1*Dd*Pk2*fd - 2240*C*D1*Ddd*Pk2*f*r**2 - 2240*C*D1*Ddd*Pk2*f*r*s + 2800*C*D1*Ddd*Pk2*f*r + 1120*C*D1*Ddd*Pk2*f*s - 1120*C*D1*Ddd*Pk2*f - 6720*C*Dd**2*Pk2*f*r**2 - 6720*C*Dd**2*Pk2*f*r*s + 8400*C*Dd**2*Pk2*f*r + 3360*C*Dd**2*Pk2*f*s - 2240*C*Dd**2*Pk2*f - 812*D1**2*K*Pk2*fd*r**2 + 224*D1**2*K*Pk2*fd*r*s - 672*D1**2*K*Pk2*fd*r + 1036*D1**2*K*Pk2*fd*s**2 - 2072*D1**2*K*Pk2*fd*s + 1036*D1**2*K*Pk2*fd + 56*D1**2*K*Pk2*fdd*r**2 - 672*D1**2*K*Pk2*fdd*r*s + 1176*D1**2*K*Pk2*fdd*r - 868*D1**2*K*Pk2*fdd*s**2 + 1736*D1**2*K*Pk2*fdd*s - 868*D1**2*K*Pk2*fdd - 14*D1**2*K*Pkdd2*fd*k1**2*s**2 + 42*D1**2*K*Pkdd2*fdd*k1**2*s**2 - 280*D1**2*Pk2*bdd1*(K - 1)*(3*r**2 + 3*r*(s - 1) - s + 1) + 672*D1**2*Pk2*f*fd*r**2 + 672*D1**2*Pk2*f*fd*r*s - 420*D1**2*Pk2*f*fd*r + 252*D1**2*Pk2*f*fd*s + 126*D1**2*Pk2*f*fd - 672*D1**2*Pk2*f*fdd*r**2 - 672*D1**2*Pk2*f*fdd*r*s + 420*D1**2*Pk2*f*fdd*r - 84*D1**2*Pk2*f*fdd*s - 210*D1**2*Pk2*f*fdd - 672*D1**2*Pk2*fd**2*r**2 - 672*D1**2*Pk2*fd**2*r*s + 420*D1**2*Pk2*fd**2*r - 84*D1**2*Pk2*fd**2*s + 252*D1**2*Pk2*fd**2 + 224*D1**2*Pk2*fd*r**2 + 224*D1**2*Pk2*fd*r*s + 2436*D1**2*Pk2*fd*r + 2156*D1**2*Pk2*fd*s - 1638*D1**2*Pk2*fd - 252*D1**2*Pk2*fdd*r**2 - 392*D1**2*Pk2*fdd*r*s - 1708*D1**2*Pk2*fdd*r - 1428*D1**2*Pk2*fdd*s + 994*D1**2*Pk2*fdd - 1120*D1**2*Pk2*gd2*r**2 - 1120*D1**2*Pk2*gd2*r*s + 2240*D1**2*Pk2*gd2*r + 1120*D1**2*Pk2*gd2*s - 1120*D1**2*Pk2*gd2 + 560*D1**2*Pk2*gdd2*r**2 + 560*D1**2*Pk2*gdd2*r*s - 1120*D1**2*Pk2*gdd2*r - 560*D1**2*Pk2*gdd2*s + 560*D1**2*Pk2*gdd2 + 180*D1**2*Pkdd2*f*fd*k1**2*s**2 - 90*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 90*D1**2*Pkdd2*fd**2*k1**2*s**2 - 28*D1**2*Pkdd2*fd*k1**2*s**2 - 21*D1**2*Pkdd2*fdd*k1**2*s**2 - 3248*D1*Dd*K*Pk2*f*r**2 + 896*D1*Dd*K*Pk2*f*r*s + 3024*D1*Dd*K*Pk2*f*r + 4144*D1*Dd*K*Pk2*f*s**2 - 2520*D1*Dd*K*Pk2*f*s - 588*D1*Dd*K*Pk2*f + 448*D1*Dd*K*Pk2*fd*r**2 - 5376*D1*Dd*K*Pk2*fd*r*s + 5152*D1*Dd*K*Pk2*fd*r - 6944*D1*Dd*K*Pk2*fd*s**2 + 10024*D1*Dd*K*Pk2*fd*s - 4088*D1*Dd*K*Pk2*fd - 56*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 28*D1*Dd*K*Pkdd2*f*k1**2*s - 14*D1*Dd*K*Pkdd2*f*k1**2 + 336*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 84*D1*Dd*K*Pkdd2*fd*k1**2*s + 1344*D1*Dd*Pk2*f**2*r**2 + 1344*D1*Dd*Pk2*f**2*r*s - 1680*D1*Dd*Pk2*f**2*r - 672*D1*Dd*Pk2*f**2*s + 672*D1*Dd*Pk2*f**2 - 5376*D1*Dd*Pk2*f*fd*r**2 - 5376*D1*Dd*Pk2*f*fd*r*s + 5040*D1*Dd*Pk2*f*fd*r + 1008*D1*Dd*Pk2*f*fd*s - 756*D1*Dd*Pk2*f*fd + 896*D1*Dd*Pk2*f*r**2 + 896*D1*Dd*Pk2*f*r*s - 1120*D1*Dd*Pk2*f*r - 448*D1*Dd*Pk2*f*s + 448*D1*Dd*Pk2*f - 2016*D1*Dd*Pk2*fd*r**2 - 3136*D1*Dd*Pk2*fd*r*s - 5432*D1*Dd*Pk2*fd*r - 4928*D1*Dd*Pk2*fd*s + 4844*D1*Dd*Pk2*fd - 4480*D1*Dd*Pk2*g2*r**2 - 4480*D1*Dd*Pk2*g2*r*s + 5600*D1*Dd*Pk2*g2*r + 2240*D1*Dd*Pk2*g2*s - 2240*D1*Dd*Pk2*g2 + 4480*D1*Dd*Pk2*gd2*r**2 + 4480*D1*Dd*Pk2*gd2*r*s - 7280*D1*Dd*Pk2*gd2*r - 3360*D1*Dd*Pk2*gd2*s + 2800*D1*Dd*Pk2*gd2 + 360*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 180*D1*Dd*Pkdd2*f**2*k1**2*s + 90*D1*Dd*Pkdd2*f**2*k1**2 - 720*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 180*D1*Dd*Pkdd2*f*fd*k1**2*s - 112*D1*Dd*Pkdd2*f*k1**2*s**2 + 56*D1*Dd*Pkdd2*f*k1**2*s - 28*D1*Dd*Pkdd2*f*k1**2 - 168*D1*Dd*Pkdd2*fd*k1**2*s**2 + 42*D1*Dd*Pkdd2*fd*k1**2*s + 224*D1*Ddd*K*Pk2*f*r**2 - 2688*D1*Ddd*K*Pk2*f*r*s + 448*D1*Ddd*K*Pk2*f*r - 3472*D1*Ddd*K*Pk2*f*s**2 + 3080*D1*Ddd*K*Pk2*f*s - 756*D1*Ddd*K*Pk2*f + 168*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 84*D1*Ddd*K*Pkdd2*f*k1**2*s + 42*D1*Ddd*K*Pkdd2*f*k1**2 - 1344*D1*Ddd*Pk2*f**2*r**2 - 1344*D1*Ddd*Pk2*f**2*r*s + 1680*D1*Ddd*Pk2*f**2*r + 672*D1*Ddd*Pk2*f**2*s - 672*D1*Ddd*Pk2*f**2 - 1008*D1*Ddd*Pk2*f*r**2 - 1568*D1*Ddd*Pk2*f*r*s + 1400*D1*Ddd*Pk2*f*r + 784*D1*Ddd*Pk2*f*s - 504*D1*Ddd*Pk2*f + 2240*D1*Ddd*Pk2*g2*r**2 + 2240*D1*Ddd*Pk2*g2*r*s - 2800*D1*Ddd*Pk2*g2*r - 1120*D1*Ddd*Pk2*g2*s + 1120*D1*Ddd*Pk2*g2 - 180*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 90*D1*Ddd*Pkdd2*f**2*k1**2*s - 45*D1*Ddd*Pkdd2*f**2*k1**2 - 84*D1*Ddd*Pkdd2*f*k1**2*s**2 + 42*D1*Ddd*Pkdd2*f*k1**2*s - 21*D1*Ddd*Pkdd2*f*k1**2 + 280*D1*Pk2*bd1*(K - 1)*(D1*(6*r**2 + 6*r*(s - 1) - 2*s + 2) + Dd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7)) + 672*Dd**2*K*Pk2*f*r**2 - 8064*Dd**2*K*Pk2*f*r*s + 1344*Dd**2*K*Pk2*f*r - 10416*Dd**2*K*Pk2*f*s**2 + 9240*Dd**2*K*Pk2*f*s - 1232*Dd**2*K*Pk2*f + 504*Dd**2*K*Pkdd2*f*k1**2*s**2 - 252*Dd**2*K*Pkdd2*f*k1**2*s - 4032*Dd**2*Pk2*f**2*r**2 - 4032*Dd**2*Pk2*f**2*r*s + 5040*Dd**2*Pk2*f**2*r + 2016*Dd**2*Pk2*f**2*s - 1344*Dd**2*Pk2*f**2 - 3024*Dd**2*Pk2*f*r**2 - 4704*Dd**2*Pk2*f*r*s + 4200*Dd**2*Pk2*f*r + 2352*Dd**2*Pk2*f*s - 1288*Dd**2*Pk2*f + 6720*Dd**2*Pk2*g2*r**2 + 6720*Dd**2*Pk2*g2*r*s - 8400*Dd**2*Pk2*g2*r - 3360*Dd**2*Pk2*g2*s + 2240*Dd**2*Pk2*g2 - 540*Dd**2*Pkdd2*f**2*k1**2*s**2 + 270*Dd**2*Pkdd2*f**2*k1**2*s - 252*Dd**2*Pkdd2*f*k1**2*s**2 + 126*Dd**2*Pkdd2*f*k1**2*s) + 3*b1*(2448*C*D1**2*Pk2*f*fd*r**2 - 704*C*D1**2*Pk2*f*fd*r*s - 1104*C*D1**2*Pk2*f*fd*r - 2640*C*D1**2*Pk2*f*fd*s**2 + 2992*C*D1**2*Pk2*f*fd*s - 96*C*D1**2*Pk2*f*fd - 384*C*D1**2*Pk2*f*fdd*r**2 + 1472*C*D1**2*Pk2*f*fdd*r*s - 1296*C*D1**2*Pk2*f*fdd*r + 2160*C*D1**2*Pk2*f*fdd*s**2 - 2896*C*D1**2*Pk2*f*fdd*s + 888*C*D1**2*Pk2*f*fdd - 384*C*D1**2*Pk2*fd**2*r**2 + 1472*C*D1**2*Pk2*fd**2*r*s - 1296*C*D1**2*Pk2*fd**2*r + 2160*C*D1**2*Pk2*fd**2*s**2 - 2896*C*D1**2*Pk2*fd**2*s + 1680*C*D1**2*Pk2*fd**2 + 72*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 120*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 120*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 4896*C*D1*Dd*Pk2*f**2*r**2 - 1408*C*D1*Dd*Pk2*f**2*r*s - 4544*C*D1*Dd*Pk2*f**2*r - 5280*C*D1*Dd*Pk2*f**2*s**2 + 3344*C*D1*Dd*Pk2*f**2*s + 1128*C*D1*Dd*Pk2*f**2 - 3072*C*D1*Dd*Pk2*f*fd*r**2 + 11776*C*D1*Dd*Pk2*f*fd*r*s - 5120*C*D1*Dd*Pk2*f*fd*r + 17280*C*D1*Dd*Pk2*f*fd*s**2 - 18848*C*D1*Dd*Pk2*f*fd*s + 5488*C*D1*Dd*Pk2*f*fd + 144*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 72*C*D1*Dd*Pkdd2*f**2*k1**2*s + 36*C*D1*Dd*Pkdd2*f**2*k1**2 - 960*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 240*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 768*C*D1*Ddd*Pk2*f**2*r**2 + 2944*C*D1*Ddd*Pk2*f**2*r*s + 32*C*D1*Ddd*Pk2*f**2*r + 4320*C*D1*Ddd*Pk2*f**2*s**2 - 3632*C*D1*Ddd*Pk2*f**2*s + 696*C*D1*Ddd*Pk2*f**2 - 240*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 120*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 60*C*D1*Ddd*Pkdd2*f**2*k1**2 - 2304*C*Dd**2*Pk2*f**2*r**2 + 8832*C*Dd**2*Pk2*f**2*r*s + 96*C*Dd**2*Pk2*f**2*r + 12960*C*Dd**2*Pk2*f**2*s**2 - 10896*C*Dd**2*Pk2*f**2*s + 1088*C*Dd**2*Pk2*f**2 - 720*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 360*C*Dd**2*Pkdd2*f**2*k1**2*s + 952*D1**2*K*Pk2*f*fd*r**2 + 6048*D1**2*K*Pk2*f*fd*r*s - 3024*D1**2*K*Pk2*f*fd*r + 4536*D1**2*K*Pk2*f*fd*s**2 - 4536*D1**2*K*Pk2*f*fd*s + 2268*D1**2*K*Pk2*f*fd - 1456*D1**2*K*Pk2*f*fdd*r**2 - 6048*D1**2*K*Pk2*f*fdd*r*s + 3024*D1**2*K*Pk2*f*fdd*r - 4200*D1**2*K*Pk2*f*fdd*s**2 + 4200*D1**2*K*Pk2*f*fdd*s - 2100*D1**2*K*Pk2*f*fdd - 1456*D1**2*K*Pk2*fd**2*r**2 - 6048*D1**2*K*Pk2*fd**2*r*s + 3024*D1**2*K*Pk2*fd**2*r - 4200*D1**2*K*Pk2*fd**2*s**2 + 4200*D1**2*K*Pk2*fd**2*s - 84*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 84*D1**2*K*Pkdd2*f*fd*k1**2*s - 42*D1**2*K*Pkdd2*f*fd*k1**2 + 280*D1**2*Pk2*bd1**2*(K - 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 2016*D1**2*Pk2*f**2*fd*r*s + 252*D1**2*Pk2*f**2*fd*r - 1260*D1**2*Pk2*f**2*fd*s**2 + 1176*D1**2*Pk2*f**2*fd*s - 42*D1**2*Pk2*f**2*fd + 2016*D1**2*Pk2*f**2*fdd*r*s - 252*D1**2*Pk2*f**2*fdd*r + 1260*D1**2*Pk2*f**2*fdd*s**2 - 1176*D1**2*Pk2*f**2*fdd*s + 42*D1**2*Pk2*f**2*fdd + 4032*D1**2*Pk2*f*fd**2*r*s - 504*D1**2*Pk2*f*fd**2*r + 2520*D1**2*Pk2*f*fd**2*s**2 - 2352*D1**2*Pk2*f*fd**2*s + 252*D1**2*Pk2*f*fd**2 - 3812*D1**2*Pk2*f*fd*r**2 - 3520*D1**2*Pk2*f*fd*r*s + 3756*D1**2*Pk2*f*fd*r + 144*D1**2*Pk2*f*fd*s**2 + 284*D1**2*Pk2*f*fd*s - 1602*D1**2*Pk2*f*fd + 2060*D1**2*Pk2*f*fdd*r**2 + 2656*D1**2*Pk2*f*fdd*r*s - 1332*D1**2*Pk2*f*fdd*r + 96*D1**2*Pk2*f*fdd*s**2 - 44*D1**2*Pk2*f*fdd*s + 654*D1**2*Pk2*f*fdd - 1624*D1**2*Pk2*f*gd2*r**2 + 448*D1**2*Pk2*f*gd2*r*s + 3248*D1**2*Pk2*f*gd2*r + 2072*D1**2*Pk2*f*gd2*s**2 - 448*D1**2*Pk2*f*gd2*s - 1624*D1**2*Pk2*f*gd2 + 112*D1**2*Pk2*f*gdd2*r**2 - 1344*D1**2*Pk2*f*gdd2*r*s - 224*D1**2*Pk2*f*gdd2*r - 1736*D1**2*Pk2*f*gdd2*s**2 + 1344*D1**2*Pk2*f*gdd2*s + 112*D1**2*Pk2*f*gdd2 + 2060*D1**2*Pk2*fd**2*r**2 + 2656*D1**2*Pk2*fd**2*r*s - 1332*D1**2*Pk2*fd**2*r + 96*D1**2*Pk2*fd**2*s**2 - 44*D1**2*Pk2*fd**2*s - 1260*D1**2*Pk2*fd**2 - 1624*D1**2*Pk2*fd*g2*r**2 + 448*D1**2*Pk2*fd*g2*r*s - 1344*D1**2*Pk2*fd*g2*r + 2072*D1**2*Pk2*fd*g2*s**2 - 4144*D1**2*Pk2*fd*g2*s + 2072*D1**2*Pk2*fd*g2 + 224*D1**2*Pk2*fd*gd2*r**2 - 2688*D1**2*Pk2*fd*gd2*r*s + 2128*D1**2*Pk2*fd*gd2*r - 3472*D1**2*Pk2*fd*gd2*s**2 + 4816*D1**2*Pk2*fd*gd2*s - 2352*D1**2*Pk2*fd*gd2 + 112*D1**2*Pk2*fdd*g2*r**2 - 1344*D1**2*Pk2*fdd*g2*r*s + 2352*D1**2*Pk2*fdd*g2*r - 1736*D1**2*Pk2*fdd*g2*s**2 + 3472*D1**2*Pk2*fdd*g2*s - 1736*D1**2*Pk2*fdd*g2 - 90*D1**2*Pkdd2*f**2*fd*k1**2*s + 45*D1**2*Pkdd2*f**2*fd*k1**2 + 30*D1**2*Pkdd2*f*fd*k1**2*s**2 - 42*D1**2*Pkdd2*f*fd*k1**2*s + 21*D1**2*Pkdd2*f*fd*k1**2 + 90*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 28*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 84*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 90*D1**2*Pkdd2*fd**2*k1**2*s**2 - 28*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 168*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 84*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + D1**2*bdd1*(-560*Pk2*g2*r*(2*r + 2*s - 1) + 3*f**2*(14*Pk2*(16*r**2 + 2*r*(8*s - 15) - 18*s + 11) + 15*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - 7*f*(2*Pk2*(4*K*(2*r**2 - r*(24*s + 11) - 31*s**2 + 12*s + 1) - r**2*(80*C + 36) + r*(-80*C*s + 40*C - 56*s + 186) + 130*s - 89) + Pkdd2*k1**2*(6*K - 3)*(2*s**2 - 2*s + 1))) + 1904*D1*Dd*K*Pk2*f**2*r**2 + 12096*D1*Dd*K*Pk2*f**2*r*s - 4928*D1*Dd*K*Pk2*f**2*r + 9072*D1*Dd*K*Pk2*f**2*s**2 - 10584*D1*Dd*K*Pk2*f**2*s + 3220*D1*Dd*K*Pk2*f**2 - 11648*D1*Dd*K*Pk2*f*fd*r**2 - 48384*D1*Dd*K*Pk2*f*fd*r*s + 23968*D1*Dd*K*Pk2*f*fd*r - 33600*D1*Dd*K*Pk2*f*fd*s**2 + 37296*D1*Dd*K*Pk2*f*fd*s - 10248*D1*Dd*K*Pk2*f*fd - 168*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 84*D1*Dd*K*Pkdd2*f**2*k1**2*s - 42*D1*Dd*K*Pkdd2*f**2*k1**2 - 2688*D1*Dd*Pk2*f**3*r*s + 672*D1*Dd*Pk2*f**3*r - 1680*D1*Dd*Pk2*f**3*s**2 + 2184*D1*Dd*Pk2*f**3*s - 420*D1*Dd*Pk2*f**3 + 16128*D1*Dd*Pk2*f**2*fd*r*s - 3024*D1*Dd*Pk2*f**2*fd*r + 10080*D1*Dd*Pk2*f**2*fd*s**2 - 11256*D1*Dd*Pk2*f**2*fd*s + 1680*D1*Dd*Pk2*f**2*fd - 7624*D1*Dd*Pk2*f**2*r**2 - 7040*D1*Dd*Pk2*f**2*r*s + 9384*D1*Dd*Pk2*f**2*r + 288*D1*Dd*Pk2*f**2*s**2 + 3376*D1*Dd*Pk2*f**2*s - 3740*D1*Dd*Pk2*f**2 + 16480*D1*Dd*Pk2*f*fd*r**2 + 21248*D1*Dd*Pk2*f*fd*r*s - 16224*D1*Dd*Pk2*f*fd*r + 768*D1*Dd*Pk2*f*fd*s**2 - 5680*D1*Dd*Pk2*f*fd*s + 2708*D1*Dd*Pk2*f*fd - 6496*D1*Dd*Pk2*f*g2*r**2 + 1792*D1*Dd*Pk2*f*g2*r*s + 6048*D1*Dd*Pk2*f*g2*r + 8288*D1*Dd*Pk2*f*g2*s**2 - 5040*D1*Dd*Pk2*f*g2*s - 1176*D1*Dd*Pk2*f*g2 + 896*D1*Dd*Pk2*f*gd2*r**2 - 10752*D1*Dd*Pk2*f*gd2*r*s - 13888*D1*Dd*Pk2*f*gd2*s**2 + 11536*D1*Dd*Pk2*f*gd2*s - 896*D1*Dd*Pk2*f*gd2 + 896*D1*Dd*Pk2*fd*g2*r**2 - 10752*D1*Dd*Pk2*fd*g2*r*s + 10304*D1*Dd*Pk2*fd*g2*r - 13888*D1*Dd*Pk2*fd*g2*s**2 + 20048*D1*Dd*Pk2*fd*g2*s - 8176*D1*Dd*Pk2*fd*g2 + 60*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 30*D1*Dd*Pkdd2*f**2*k1**2*s + 15*D1*Dd*Pkdd2*f**2*k1**2 + 720*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 180*D1*Dd*Pkdd2*f*fd*k1**2*s - 112*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 56*D1*Dd*Pkdd2*f*g2*k1**2*s - 28*D1*Dd*Pkdd2*f*g2*k1**2 + 672*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 - 168*D1*Dd*Pkdd2*f*gd2*k1**2*s + 672*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 - 168*D1*Dd*Pkdd2*fd*g2*k1**2*s - 2912*D1*Ddd*K*Pk2*f**2*r**2 - 12096*D1*Ddd*K*Pk2*f**2*r*s + 5936*D1*Ddd*K*Pk2*f**2*r - 8400*D1*Ddd*K*Pk2*f**2*s**2 + 10248*D1*Ddd*K*Pk2*f**2*s - 3556*D1*Ddd*K*Pk2*f**2 + 2688*D1*Ddd*Pk2*f**3*r*s - 672*D1*Ddd*Pk2*f**3*r + 1680*D1*Ddd*Pk2*f**3*s**2 - 2184*D1*Ddd*Pk2*f**3*s + 420*D1*Ddd*Pk2*f**3 + 4120*D1*Ddd*Pk2*f**2*r**2 + 5312*D1*Ddd*Pk2*f**2*r*s - 5448*D1*Ddd*Pk2*f**2*r + 192*D1*Ddd*Pk2*f**2*s**2 - 2752*D1*Ddd*Pk2*f**2*s + 2108*D1*Ddd*Pk2*f**2 + 448*D1*Ddd*Pk2*f*g2*r**2 - 5376*D1*Ddd*Pk2*f*g2*r*s + 896*D1*Ddd*Pk2*f*g2*r - 6944*D1*Ddd*Pk2*f*g2*s**2 + 6160*D1*Ddd*Pk2*f*g2*s - 1512*D1*Ddd*Pk2*f*g2 + 180*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 90*D1*Ddd*Pkdd2*f**2*k1**2*s + 45*D1*Ddd*Pkdd2*f**2*k1**2 + 336*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 - 168*D1*Ddd*Pkdd2*f*g2*k1**2*s + 84*D1*Ddd*Pkdd2*f*g2*k1**2 - 2*D1*bd1*(3*D1*f**2*(7*Pk2*(16*r**2 + 2*r*(8*s - 15) - 22*s + 13) + 15*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + D1*f*(-7*Pk2*(-160*C*r**2 - 160*C*r*s + 80*C*r + 2*K*(58*r**2 - 2*r*(8*s + 37) - 74*s**2 + 8*s + 29) + 12*fd*(16*r**2 + 4*r*(4*s - 5) - 8*s + 5) - 32*r**2 - 32*r*s + 222*r + 170*s - 133) - Pkdd2*k1**2*(7*K*(2*s**2 - 2*s + 1) + s**2*(180*fd + 28) - s*(90*fd + 28) + 14)) - 7*D1*(2*Pk2*fd*(20*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 2*K*(4*r**2 - 48*r*s + 31*r - 62*s**2 + 74*s - 21) + 36*r**2 + 56*r*s + 29*r + 37*s - 41) + 80*Pk2*g2*r*(2*r + 2*s - 1) - 40*Pk2*gd2*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 3*Pkdd2*fd*k1**2*s*(K*(2 - 4*s) + 2*s - 1)) + 560*Dd*Pk2*g2*(8*r**2 + r*(8*s - 7) - 2*s + 1) - 3*Dd*f**2*(14*Pk2*(16*r - 13)*(4*r + 4*s - 3) + 15*Pkdd2*k1**2*(8*s**2 - 6*s + 1)) - 7*Dd*f*(2*Pk2*(40*C*(8*r**2 + r*(8*s - 7) - 2*s + 1) - 4*K*(8*r**2 - 2*r*(48*s + 7) - 124*s**2 + 79*s + 5) + 144*r**2 + 224*r*s - 472*r - 316*s + 251) + Pkdd2*k1**2*(3 - 6*K)*(8*s**2 - 6*s + 1))) - 8736*Dd**2*K*Pk2*f**2*r**2 - 36288*Dd**2*K*Pk2*f**2*r*s + 17808*Dd**2*K*Pk2*f**2*r - 25200*Dd**2*K*Pk2*f**2*s**2 + 30744*Dd**2*K*Pk2*f**2*s - 7504*Dd**2*K*Pk2*f**2 + 8064*Dd**2*Pk2*f**3*r*s - 2016*Dd**2*Pk2*f**3*r + 5040*Dd**2*Pk2*f**3*s**2 - 6552*Dd**2*Pk2*f**3*s + 1344*Dd**2*Pk2*f**3 + 12360*Dd**2*Pk2*f**2*r**2 + 15936*Dd**2*Pk2*f**2*r*s - 16344*Dd**2*Pk2*f**2*r + 576*Dd**2*Pk2*f**2*s**2 - 8256*Dd**2*Pk2*f**2*s + 4716*Dd**2*Pk2*f**2 + 1344*Dd**2*Pk2*f*g2*r**2 - 16128*Dd**2*Pk2*f*g2*r*s + 2688*Dd**2*Pk2*f*g2*r - 20832*Dd**2*Pk2*f*g2*s**2 + 18480*Dd**2*Pk2*f*g2*s - 2464*Dd**2*Pk2*f*g2 + 540*Dd**2*Pkdd2*f**2*k1**2*s**2 - 270*Dd**2*Pkdd2*f**2*k1**2*s + 1008*Dd**2*Pkdd2*f*g2*k1**2*s**2 - 504*Dd**2*Pkdd2*f*g2*k1**2*s))/(630*d**2*k3**4) - D1**2*Pk3*ct**3*k1*st**2*(1440*C*D1**2*Pk2*bdd1*f**2*r*s - 864*C*D1**2*Pk2*bdd1*f**2*s**2 - 4800*C*D1**2*Pk2*f**2*fd*s**2 + 3200*C*D1**2*Pk2*f**2*fd*s - 1600*C*D1**2*Pk2*f**2*fd + 2400*C*D1**2*Pk2*f**2*fdd*s**2 - 1600*C*D1**2*Pk2*f**2*fdd*s + 800*C*D1**2*Pk2*f**2*fdd + 4800*C*D1**2*Pk2*f*fd**2*s**2 - 3200*C*D1**2*Pk2*f*fd**2*s - 6400*C*D1*Dd*Pk2*f**3*s**2 + 3200*C*D1*Dd*Pk2*f**3*s - 1600*C*D1*Dd*Pk2*f**3 + 19200*C*D1*Dd*Pk2*f**2*fd*s**2 - 11200*C*D1*Dd*Pk2*f**2*fd*s + 1600*C*D1*Dd*Pk2*f**2*fd + 3200*C*D1*Ddd*Pk2*f**3*s**2 - 1600*C*D1*Ddd*Pk2*f**3*s + 800*C*D1*Ddd*Pk2*f**3 + 9600*C*Dd**2*Pk2*f**3*s**2 - 4800*C*Dd**2*Pk2*f**3*s + 720*D1**2*K*Pk2*bdd1*f**2*s**2 - 2880*D1**2*Pk2*b2*f*fd*s**2 + 2880*D1**2*Pk2*b2*f*fd*s - 1440*D1**2*Pk2*b2*f*fd + 1440*D1**2*Pk2*b2*f*fdd*s**2 - 1440*D1**2*Pk2*b2*f*fdd*s + 720*D1**2*Pk2*b2*f*fdd + 1440*D1**2*Pk2*b2*fd**2*s**2 - 1440*D1**2*Pk2*b2*fd**2*s + 144*D1**2*Pk2*bd1**2*f*s*(7*K*(2*r - 2*s - 1) + 5*f - 14*r + 14) - 1440*D1**2*Pk2*bd2*f**2*s**2 + 2880*D1**2*Pk2*bd2*f*fd*s**2 - 1440*D1**2*Pk2*bd2*f*fd*s + 2160*D1**2*Pk2*bdd1*f**3*r*s + 1980*D1**2*Pk2*bdd1*f**3*s**2 - 1440*D1**2*Pk2*bdd1*f**3*s + 288*D1**2*Pk2*bdd1*f**2*r*s + 3060*D1**2*Pk2*bdd1*f**2*s**2 - 1296*D1**2*Pk2*bdd1*f**2*s - 216*D1**2*Pk2*bdd1*f**2 - 2016*D1**2*Pk2*bdd1*f*g2*r*s + 2016*D1**2*Pk2*bdd1*f*g2*s**2 + 720*D1**2*Pk2*bdd2*f**2*s**2 - 4704*D1**2*Pk2*f**2*fd*r*s + 1568*D1**2*Pk2*f**2*fd*r - 2364*D1**2*Pk2*f**2*fd*s**2 + 3144*D1**2*Pk2*f**2*fd*s - 788*D1**2*Pk2*f**2*fd + 3648*D1**2*Pk2*f**2*fdd*r*s - 1216*D1**2*Pk2*f**2*fdd*r + 2316*D1**2*Pk2*f**2*fdd*s**2 - 2760*D1**2*Pk2*f**2*fdd*s + 772*D1**2*Pk2*f**2*fdd + 2880*D1**2*Pk2*f**2*gd2*s**2 - 1440*D1**2*Pk2*f**2*gdd2*s**2 + 7296*D1**2*Pk2*f*fd**2*r*s - 2432*D1**2*Pk2*f*fd**2*r + 4632*D1**2*Pk2*f*fd**2*s**2 - 5520*D1**2*Pk2*f*fd**2*s + 1216*D1**2*Pk2*f*fd**2 + 5760*D1**2*Pk2*f*fd*g2*s**2 - 5760*D1**2*Pk2*f*fd*g2*s + 2880*D1**2*Pk2*f*fd*g2 - 5760*D1**2*Pk2*f*fd*gd2*s**2 + 2880*D1**2*Pk2*f*fd*gd2*s - 2880*D1**2*Pk2*f*fdd*g2*s**2 + 2880*D1**2*Pk2*f*fdd*g2*s - 1440*D1**2*Pk2*f*fdd*g2 - 2880*D1**2*Pk2*fd**2*g2*s**2 + 2880*D1**2*Pk2*fd**2*g2*s - 50*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 27*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 90*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 60*D1**2*Pkdd2*f**2*fd*k1**2*s + 30*D1**2*Pkdd2*f**2*fd*k1**2 - 45*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*f**2*fdd*k1**2*s - 15*D1**2*Pkdd2*f**2*fdd*k1**2 - 90*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 60*D1**2*Pkdd2*f*fd**2*k1**2*s - 5760*D1*Dd*Pk2*b2*f**2*s**2 + 2880*D1*Dd*Pk2*b2*f**2*s - 1440*D1*Dd*Pk2*b2*f**2 + 11520*D1*Dd*Pk2*b2*f*fd*s**2 - 8640*D1*Dd*Pk2*b2*f*fd*s + 1440*D1*Dd*Pk2*b2*f*fd + 5760*D1*Dd*Pk2*bd2*f**2*s**2 - 1440*D1*Dd*Pk2*bd2*f**2*s - 6272*D1*Dd*Pk2*f**3*r*s + 1568*D1*Dd*Pk2*f**3*r - 3152*D1*Dd*Pk2*f**3*s**2 + 4712*D1*Dd*Pk2*f**3*s - 788*D1*Dd*Pk2*f**3 + 29184*D1*Dd*Pk2*f**2*fd*r*s - 8512*D1*Dd*Pk2*f**2*fd*r + 18528*D1*Dd*Pk2*f**2*fd*s**2 - 22968*D1*Dd*Pk2*f**2*fd*s + 5192*D1*Dd*Pk2*f**2*fd + 11520*D1*Dd*Pk2*f**2*g2*s**2 - 5760*D1*Dd*Pk2*f**2*g2*s + 2880*D1*Dd*Pk2*f**2*g2 - 11520*D1*Dd*Pk2*f**2*gd2*s**2 + 2880*D1*Dd*Pk2*f**2*gd2*s - 23040*D1*Dd*Pk2*f*fd*g2*s**2 + 17280*D1*Dd*Pk2*f*fd*g2*s - 2880*D1*Dd*Pk2*f*fd*g2 + 120*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 60*D1*Dd*Pkdd2*f**3*k1**2*s + 30*D1*Dd*Pkdd2*f**3*k1**2 - 360*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 210*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 30*D1*Dd*Pkdd2*f**2*fd*k1**2 + 2880*D1*Ddd*Pk2*b2*f**2*s**2 - 1440*D1*Ddd*Pk2*b2*f**2*s + 720*D1*Ddd*Pk2*b2*f**2 + 4864*D1*Ddd*Pk2*f**3*r*s - 1216*D1*Ddd*Pk2*f**3*r + 3088*D1*Ddd*Pk2*f**3*s**2 - 3976*D1*Ddd*Pk2*f**3*s + 772*D1*Ddd*Pk2*f**3 - 5760*D1*Ddd*Pk2*f**2*g2*s**2 + 2880*D1*Ddd*Pk2*f**2*g2*s - 1440*D1*Ddd*Pk2*f**2*g2 - 60*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 30*D1*Ddd*Pkdd2*f**3*k1**2*s - 15*D1*Ddd*Pkdd2*f**3*k1**2 - 2*D1*bd1*(D1*(-1008*Pk2*fd*g2*(-2*r*s + r + s*(2*s - 2)) + 10*f**3*s*(9*Pk2*(12*r + 15*s - 8) - 5*Pkdd2*k1**2*s) + f**2*(-6*Pk2*(30*fd*(6*r*(6*s - 1) + 33*s**2 - 31*s + 4) + s**2*(144*C - 120*K - 363) - s*(184*C*r + 20*r - 132) + 36) + Pkdd2*k1**2*s*(50*fd*(3*s - 1) - 27*s)) - 9*f*(4*Pk2*fd*(r*(20*C + 4)*(4*s - 1) + s**2*(-48*C + 40*K + 170) + s*(4*C - 20*K - 107) + 24) + 112*Pk2*s*(2*g2*r - 2*g2*s - 2*gd2*r + 2*gd2*s + gd2) + 3*Pkdd2*fd*k1**2*s*(1 - 2*s))) + Dd*f*(-1008*Pk2*g2*(-8*r*s + r + 8*s**2) - 10*f**2*(18*Pk2*(6*r*(8*s - 1) + 44*s**2 - 39*s + 4) + 5*Pkdd2*k1**2*s*(1 - 4*s)) - 9*f*(4*Pk2*(r*(20*C + 4)*(8*s - 1) + s**2*(-96*C + 80*K + 340) - s*(16*C + 20*K + 165) + 18) + 3*Pkdd2*k1**2*s*(1 - 4*s)))) + 8640*Dd**2*Pk2*b2*f**2*s**2 - 4320*Dd**2*Pk2*b2*f**2*s + 14592*Dd**2*Pk2*f**3*r*s - 3648*Dd**2*Pk2*f**3*r + 9264*Dd**2*Pk2*f**3*s**2 - 11928*Dd**2*Pk2*f**3*s + 2432*Dd**2*Pk2*f**3 - 17280*Dd**2*Pk2*f**2*g2*s**2 + 8640*Dd**2*Pk2*f**2*g2*s - 180*Dd**2*Pkdd2*f**3*k1**2*s**2 + 90*Dd**2*Pkdd2*f**3*k1**2*s + 72*Pk2*b1**2*(-2*D1*Dd*(14*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s) + fd*(56*K*s**2 - 56*K*s + 5*f*(4*s - 1) - r*(7*K - 7)*(8*s - 5) + 14*s + 7)) - D1*(D1*(-10*f*fd*(2*s - 1) + 5*f*fdd*(2*s - 1) + 10*fd**2*s + 14*fd*(2*K*(s - 1)*(r - s + 1) - 2*r*s + 2*r - 2*s + 1) - 7*fdd*(2*K*(s - 1)*(r - s + 1) - 2*r*s + 2*r - 2*s + 1)) - 14*Ddd*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s)) + 14*Dd**2*f*(K*(12*r*s - 3*r - 12*s**2 + 2) - 12*r*s + 3*r + 6*s - 2)) + b1*(-4416*C*D1**2*Pk2*f*fd*r*s + 2208*C*D1**2*Pk2*f*fd*r + 3456*C*D1**2*Pk2*f*fd*s**2 - 1248*C*D1**2*Pk2*f*fd*s + 1728*C*D1**2*Pk2*f*fd + 2880*C*D1**2*Pk2*f*fdd*r*s - 1440*C*D1**2*Pk2*f*fdd*r - 1728*C*D1**2*Pk2*f*fdd*s**2 + 288*C*D1**2*Pk2*f*fdd*s - 864*C*D1**2*Pk2*f*fdd + 2880*C*D1**2*Pk2*fd**2*r*s - 1440*C*D1**2*Pk2*fd**2*r - 1728*C*D1**2*Pk2*fd**2*s**2 + 288*C*D1**2*Pk2*fd**2*s + 1440*C*D1**2*Pk2*fd**2 - 8832*C*D1*Dd*Pk2*f**2*r*s + 2208*C*D1*Dd*Pk2*f**2*r + 6912*C*D1*Dd*Pk2*f**2*s**2 + 960*C*D1*Dd*Pk2*f**2*s + 1728*C*D1*Dd*Pk2*f**2 + 23040*C*D1*Dd*Pk2*f*fd*r*s - 8640*C*D1*Dd*Pk2*f*fd*r - 13824*C*D1*Dd*Pk2*f*fd*s**2 - 1152*C*D1*Dd*Pk2*f*fd*s + 2592*C*D1*Dd*Pk2*f*fd + 5760*C*D1*Ddd*Pk2*f**2*r*s - 1440*C*D1*Ddd*Pk2*f**2*r - 3456*C*D1*Ddd*Pk2*f**2*s**2 - 1152*C*D1*Ddd*Pk2*f**2*s - 864*C*D1*Ddd*Pk2*f**2 + 17280*C*Dd**2*Pk2*f**2*r*s - 4320*C*Dd**2*Pk2*f**2*r - 10368*C*Dd**2*Pk2*f**2*s**2 - 3456*C*Dd**2*Pk2*f**2*s + 2880*C*Dd**2*Pk2*f**2 - 2880*D1**2*K*Pk2*f*fd*s**2 + 2880*D1**2*K*Pk2*f*fd*s - 1440*D1**2*K*Pk2*f*fd + 1440*D1**2*K*Pk2*f*fdd*s**2 - 1440*D1**2*K*Pk2*f*fdd*s + 720*D1**2*K*Pk2*f*fdd + 1440*D1**2*K*Pk2*fd**2*s**2 - 1440*D1**2*K*Pk2*fd**2*s + 72*D1**2*Pk2*bdd1*f*(-28*K*s**2 + 5*f*(2*s - 1) - 7*s*(-4*K*r + 2*K + 4*r - 4) - 7) - 6480*D1**2*Pk2*f**2*fd*r*s + 2160*D1**2*Pk2*f**2*fd*r - 8100*D1**2*Pk2*f**2*fd*s**2 + 8280*D1**2*Pk2*f**2*fd*s - 2700*D1**2*Pk2*f**2*fd + 6480*D1**2*Pk2*f**2*fdd*r*s - 2160*D1**2*Pk2*f**2*fdd*r + 5940*D1**2*Pk2*f**2*fdd*s**2 - 6840*D1**2*Pk2*f**2*fdd*s + 1980*D1**2*Pk2*f**2*fdd + 12960*D1**2*Pk2*f*fd**2*r*s - 4320*D1**2*Pk2*f*fd**2*r + 11880*D1**2*Pk2*f*fd**2*s**2 - 13680*D1**2*Pk2*f*fd**2*s + 2880*D1**2*Pk2*f*fd**2 - 480*D1**2*Pk2*f*fd*r*s + 240*D1**2*Pk2*f*fd*r - 8712*D1**2*Pk2*f*fd*s**2 + 7368*D1**2*Pk2*f*fd*s - 4788*D1**2*Pk2*f*fd + 576*D1**2*Pk2*f*fdd*r*s - 288*D1**2*Pk2*f*fdd*r + 6120*D1**2*Pk2*f*fdd*s**2 - 5112*D1**2*Pk2*f*fdd*s + 3276*D1**2*Pk2*f*fdd + 4032*D1**2*Pk2*f*gd2*r*s - 4032*D1**2*Pk2*f*gd2*s**2 - 4032*D1**2*Pk2*f*gd2*s - 2016*D1**2*Pk2*f*gdd2*r*s + 2016*D1**2*Pk2*f*gdd2*s**2 + 2016*D1**2*Pk2*f*gdd2*s + 576*D1**2*Pk2*fd**2*r*s - 288*D1**2*Pk2*fd**2*r + 6120*D1**2*Pk2*fd**2*s**2 - 5112*D1**2*Pk2*fd**2*s - 1440*D1**2*Pk2*fd**2 + 4032*D1**2*Pk2*fd*g2*r*s - 4032*D1**2*Pk2*fd*g2*r - 4032*D1**2*Pk2*fd*g2*s**2 + 8064*D1**2*Pk2*fd*g2*s - 4032*D1**2*Pk2*fd*g2 - 4032*D1**2*Pk2*fd*gd2*r*s + 2016*D1**2*Pk2*fd*gd2*r + 4032*D1**2*Pk2*fd*gd2*s**2 - 2016*D1**2*Pk2*fd*gd2*s - 2016*D1**2*Pk2*fd*gd2 - 2016*D1**2*Pk2*fdd*g2*r*s + 2016*D1**2*Pk2*fdd*g2*r + 2016*D1**2*Pk2*fdd*g2*s**2 - 4032*D1**2*Pk2*fdd*g2*s + 2016*D1**2*Pk2*fdd*g2 + 300*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 200*D1**2*Pkdd2*f**2*fd*k1**2*s + 100*D1**2*Pkdd2*f**2*fd*k1**2 - 150*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 100*D1**2*Pkdd2*f**2*fdd*k1**2*s - 50*D1**2*Pkdd2*f**2*fdd*k1**2 - 300*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 200*D1**2*Pkdd2*f*fd**2*k1**2*s + 108*D1**2*Pkdd2*f*fd*k1**2*s**2 - 108*D1**2*Pkdd2*f*fd*k1**2*s + 54*D1**2*Pkdd2*f*fd*k1**2 - 54*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 54*D1**2*Pkdd2*f*fdd*k1**2*s - 27*D1**2*Pkdd2*f*fdd*k1**2 - 54*D1**2*Pkdd2*fd**2*k1**2*s**2 + 54*D1**2*Pkdd2*fd**2*k1**2*s - 5760*D1*Dd*K*Pk2*f**2*s**2 + 2880*D1*Dd*K*Pk2*f**2*s - 1440*D1*Dd*K*Pk2*f**2 + 11520*D1*Dd*K*Pk2*f*fd*s**2 - 8640*D1*Dd*K*Pk2*f*fd*s + 1440*D1*Dd*K*Pk2*f*fd - 8640*D1*Dd*Pk2*f**3*r*s + 2160*D1*Dd*Pk2*f**3*r - 10800*D1*Dd*Pk2*f**3*s**2 + 9720*D1*Dd*Pk2*f**3*s - 2700*D1*Dd*Pk2*f**3 + 51840*D1*Dd*Pk2*f**2*fd*r*s - 15120*D1*Dd*Pk2*f**2*fd*r + 47520*D1*Dd*Pk2*f**2*fd*s**2 - 52200*D1*Dd*Pk2*f**2*fd*s + 11160*D1*Dd*Pk2*f**2*fd - 960*D1*Dd*Pk2*f**2*r*s + 240*D1*Dd*Pk2*f**2*r - 17424*D1*Dd*Pk2*f**2*s**2 + 9192*D1*Dd*Pk2*f**2*s - 4356*D1*Dd*Pk2*f**2 + 4608*D1*Dd*Pk2*f*fd*r*s - 1728*D1*Dd*Pk2*f*fd*r + 48960*D1*Dd*Pk2*f*fd*s**2 - 33840*D1*Dd*Pk2*f*fd*s + 5688*D1*Dd*Pk2*f*fd + 16128*D1*Dd*Pk2*f*g2*r*s - 4032*D1*Dd*Pk2*f*g2*r - 16128*D1*Dd*Pk2*f*g2*s**2 - 4032*D1*Dd*Pk2*f*g2 - 16128*D1*Dd*Pk2*f*gd2*r*s + 2016*D1*Dd*Pk2*f*gd2*r + 16128*D1*Dd*Pk2*f*gd2*s**2 + 8064*D1*Dd*Pk2*f*gd2*s - 2016*D1*Dd*Pk2*f*gd2 - 16128*D1*Dd*Pk2*fd*g2*r*s + 10080*D1*Dd*Pk2*fd*g2*r + 16128*D1*Dd*Pk2*fd*g2*s**2 - 16128*D1*Dd*Pk2*fd*g2*s + 400*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 200*D1*Dd*Pkdd2*f**3*k1**2*s + 100*D1*Dd*Pkdd2*f**3*k1**2 - 1200*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 700*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 100*D1*Dd*Pkdd2*f**2*fd*k1**2 + 216*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 108*D1*Dd*Pkdd2*f**2*k1**2*s + 54*D1*Dd*Pkdd2*f**2*k1**2 - 432*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 324*D1*Dd*Pkdd2*f*fd*k1**2*s - 54*D1*Dd*Pkdd2*f*fd*k1**2 + 2880*D1*Ddd*K*Pk2*f**2*s**2 - 1440*D1*Ddd*K*Pk2*f**2*s + 720*D1*Ddd*K*Pk2*f**2 + 8640*D1*Ddd*Pk2*f**3*r*s - 2160*D1*Ddd*Pk2*f**3*r + 7920*D1*Ddd*Pk2*f**3*s**2 - 8280*D1*Ddd*Pk2*f**3*s + 1980*D1*Ddd*Pk2*f**3 + 1152*D1*Ddd*Pk2*f**2*r*s - 288*D1*Ddd*Pk2*f**2*r + 12240*D1*Ddd*Pk2*f**2*s**2 - 6696*D1*Ddd*Pk2*f**2*s + 3060*D1*Ddd*Pk2*f**2 - 8064*D1*Ddd*Pk2*f*g2*r*s + 2016*D1*Ddd*Pk2*f*g2*r + 8064*D1*Ddd*Pk2*f*g2*s**2 + 2016*D1*Ddd*Pk2*f*g2 - 200*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 100*D1*Ddd*Pkdd2*f**3*k1**2*s - 50*D1*Ddd*Pkdd2*f**3*k1**2 - 108*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 54*D1*Ddd*Pkdd2*f**2*k1**2*s - 27*D1*Ddd*Pkdd2*f**2*k1**2 - 144*D1*Pk2*bd1*(D1*(5*f**2*(2*s - 1) - 7*f*(4*K*s**2 + s*(-4*K*r + 2*K + 4*r - 4) + 1) - 7*fd*(K*(4*r*s - 2*r - 4*s**2 + 3*s + 1) - 4*r*s + 2*r - 1)) + Dd*f*(-7*K*(16*r*s - 2*r - 16*s**2 - 4*s + 1) + f*(5 - 20*s) + 112*r*s - 14*r - 84*s + 14)) + 8640*Dd**2*K*Pk2*f**2*s**2 - 4320*Dd**2*K*Pk2*f**2*s + 25920*Dd**2*Pk2*f**3*r*s - 6480*Dd**2*Pk2*f**3*r + 23760*Dd**2*Pk2*f**3*s**2 - 24840*Dd**2*Pk2*f**3*s + 4320*Dd**2*Pk2*f**3 + 3456*Dd**2*Pk2*f**2*r*s - 864*Dd**2*Pk2*f**2*r + 36720*Dd**2*Pk2*f**2*s**2 - 20088*Dd**2*Pk2*f**2*s + 576*Dd**2*Pk2*f**2 - 24192*Dd**2*Pk2*f*g2*r*s + 6048*Dd**2*Pk2*f*g2*r + 24192*Dd**2*Pk2*f*g2*s**2 - 4032*Dd**2*Pk2*f*g2 - 600*Dd**2*Pkdd2*f**3*k1**2*s**2 + 300*Dd**2*Pkdd2*f**3*k1**2*s - 324*Dd**2*Pkdd2*f**2*k1**2*s**2 + 162*Dd**2*Pkdd2*f**2*k1**2*s))/(315*d**2*k2*k3**2) + D1**2*Pk3*ct**3*k1*(2832*C*D1**2*Pk2*bdd1*f**2*r*s - 3240*C*D1**2*Pk2*bdd1*f**2*s**2 - 3120*C*D1**2*Pk2*f**2*fd*r*s + 1040*C*D1**2*Pk2*f**2*fd*r - 9720*C*D1**2*Pk2*f**2*fd*s**2 + 7520*C*D1**2*Pk2*f**2*fd*s - 3240*C*D1**2*Pk2*f**2*fd + 2640*C*D1**2*Pk2*f**2*fdd*r*s - 880*C*D1**2*Pk2*f**2*fdd*r + 7560*C*D1**2*Pk2*f**2*fdd*s**2 - 5920*C*D1**2*Pk2*f**2*fdd*s + 2520*C*D1**2*Pk2*f**2*fdd + 5280*C*D1**2*Pk2*f*fd**2*r*s - 1760*C*D1**2*Pk2*f*fd**2*r + 15120*C*D1**2*Pk2*f*fd**2*s**2 - 11840*C*D1**2*Pk2*f*fd**2*s + 880*C*D1**2*Pk2*f*fd**2 - 4160*C*D1*Dd*Pk2*f**3*r*s + 1040*C*D1*Dd*Pk2*f**3*r - 12960*C*D1*Dd*Pk2*f**3*s**2 + 8560*C*D1*Dd*Pk2*f**3*s - 3240*C*D1*Dd*Pk2*f**3 + 21120*C*D1*Dd*Pk2*f**2*fd*r*s - 6160*C*D1*Dd*Pk2*f**2*fd*r + 60480*C*D1*Dd*Pk2*f**2*fd*s**2 - 44080*C*D1*Dd*Pk2*f**2*fd*s + 7680*C*D1*Dd*Pk2*f**2*fd + 3520*C*D1*Ddd*Pk2*f**3*r*s - 880*C*D1*Ddd*Pk2*f**3*r + 10080*C*D1*Ddd*Pk2*f**3*s**2 - 6800*C*D1*Ddd*Pk2*f**3*s + 2520*C*D1*Ddd*Pk2*f**3 + 10560*C*Dd**2*Pk2*f**3*r*s - 2640*C*Dd**2*Pk2*f**3*r + 30240*C*Dd**2*Pk2*f**3*s**2 - 20400*C*Dd**2*Pk2*f**3*s + 1760*C*Dd**2*Pk2*f**3 + 504*D1**2*K*Pk2*bdd1*f**2*r*s + 1764*D1**2*K*Pk2*bdd1*f**2*s**2 - 504*D1**2*K*Pk2*bdd1*f**2*s - 1008*D1**2*Pk2*b2*f*fd*r*s + 504*D1**2*Pk2*b2*f*fd*r - 4536*D1**2*Pk2*b2*f*fd*s**2 + 4536*D1**2*Pk2*b2*f*fd*s - 2268*D1**2*Pk2*b2*f*fd + 1008*D1**2*Pk2*b2*f*fdd*r*s - 504*D1**2*Pk2*b2*f*fdd*r + 3528*D1**2*Pk2*b2*f*fdd*s**2 - 3528*D1**2*Pk2*b2*f*fdd*s + 1764*D1**2*Pk2*b2*f*fdd + 1008*D1**2*Pk2*b2*fd**2*r*s - 504*D1**2*Pk2*b2*fd**2*r + 3528*D1**2*Pk2*b2*fd**2*s**2 - 3528*D1**2*Pk2*b2*fd**2*s - 504*D1**2*Pk2*bd2*f**2*r*s - 2268*D1**2*Pk2*bd2*f**2*s**2 + 504*D1**2*Pk2*bd2*f**2*s + 2016*D1**2*Pk2*bd2*f*fd*r*s - 504*D1**2*Pk2*bd2*f*fd*r + 7056*D1**2*Pk2*bd2*f*fd*s**2 - 4536*D1**2*Pk2*bd2*f*fd*s + 504*D1**2*Pk2*bd2*f*fd + 756*D1**2*Pk2*bdd1*f**3*r**2 + 3024*D1**2*Pk2*bdd1*f**3*r*s - 756*D1**2*Pk2*bdd1*f**3*r + 1260*D1**2*Pk2*bdd1*f**3*s**2 - 2016*D1**2*Pk2*bdd1*f**3*s + 378*D1**2*Pk2*bdd1*f**3 + 462*D1**2*Pk2*bdd1*f**2*r**2 - 1464*D1**2*Pk2*bdd1*f**2*r*s + 228*D1**2*Pk2*bdd1*f**2*r + 3384*D1**2*Pk2*bdd1*f**2*s**2 - 900*D1**2*Pk2*bdd1*f**2*s - 348*D1**2*Pk2*bdd1*f**2 - 3024*D1**2*Pk2*bdd1*f*g2*r*s + 5208*D1**2*Pk2*bdd1*f*g2*s**2 + 504*D1**2*Pk2*bdd2*f**2*r*s + 1764*D1**2*Pk2*bdd2*f**2*s**2 - 504*D1**2*Pk2*bdd2*f**2*s - 1758*D1**2*Pk2*f**2*fd*r**2 - 6264*D1**2*Pk2*f**2*fd*r*s + 3260*D1**2*Pk2*f**2*fd*r + 1512*D1**2*Pk2*f**2*fd*s**2 + 1080*D1**2*Pk2*f**2*fd*s - 82*D1**2*Pk2*f**2*fd + 1338*D1**2*Pk2*f**2*fdd*r**2 + 5184*D1**2*Pk2*f**2*fdd*r*s - 2620*D1**2*Pk2*f**2*fdd*r - 432*D1**2*Pk2*f**2*fdd*s**2 - 1440*D1**2*Pk2*f**2*fdd*s + 302*D1**2*Pk2*f**2*fdd + 1008*D1**2*Pk2*f**2*gd2*r*s + 4536*D1**2*Pk2*f**2*gd2*s**2 - 1008*D1**2*Pk2*f**2*gd2*s - 1008*D1**2*Pk2*f**2*gdd2*r*s - 3528*D1**2*Pk2*f**2*gdd2*s**2 + 1008*D1**2*Pk2*f**2*gdd2*s + 2676*D1**2*Pk2*f*fd**2*r**2 + 10368*D1**2*Pk2*f*fd**2*r*s - 5240*D1**2*Pk2*f*fd**2*r - 864*D1**2*Pk2*f*fd**2*s**2 - 2880*D1**2*Pk2*f*fd**2*s + 1728*D1**2*Pk2*f*fd**2 + 2016*D1**2*Pk2*f*fd*g2*r*s - 1008*D1**2*Pk2*f*fd*g2*r + 9072*D1**2*Pk2*f*fd*g2*s**2 - 9072*D1**2*Pk2*f*fd*g2*s + 4536*D1**2*Pk2*f*fd*g2 - 4032*D1**2*Pk2*f*fd*gd2*r*s + 1008*D1**2*Pk2*f*fd*gd2*r - 14112*D1**2*Pk2*f*fd*gd2*s**2 + 9072*D1**2*Pk2*f*fd*gd2*s - 1008*D1**2*Pk2*f*fd*gd2 - 2016*D1**2*Pk2*f*fdd*g2*r*s + 1008*D1**2*Pk2*f*fdd*g2*r - 7056*D1**2*Pk2*f*fdd*g2*s**2 + 7056*D1**2*Pk2*f*fdd*g2*s - 3528*D1**2*Pk2*f*fdd*g2 - 2016*D1**2*Pk2*fd**2*g2*r*s + 1008*D1**2*Pk2*fd**2*g2*r - 7056*D1**2*Pk2*fd**2*g2*s**2 + 7056*D1**2*Pk2*fd**2*g2*s + 45*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 90*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 45*D1**2*Pkdd2*bdd1*f**2*k1**2 + 135*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 90*D1**2*Pkdd2*f**2*fd*k1**2*s + 45*D1**2*Pkdd2*f**2*fd*k1**2 - 6*D1**2*bd1**2*(280*Pk2*g2*r*(1 - 2*s) + 6*f**2*(7*Pk2*(8*r*s - 6*r - 9*s + 4) - 5*Pkdd2*k1**2*s*(s - 1)) + 7*f*(2*Pk2*(62*K*s**2 + 18*K*s + 4*r*(10*C*s - 5*C - 9*K*s + 7*s + 1) - 65*s + 16) - 3*Pkdd2*k1**2*s*(s - 1))) - 2016*D1*Dd*Pk2*b2*f**2*r*s + 504*D1*Dd*Pk2*b2*f**2*r - 9072*D1*Dd*Pk2*b2*f**2*s**2 + 5544*D1*Dd*Pk2*b2*f**2*s - 2268*D1*Dd*Pk2*b2*f**2 + 8064*D1*Dd*Pk2*b2*f*fd*r*s - 3024*D1*Dd*Pk2*b2*f*fd*r + 28224*D1*Dd*Pk2*b2*f*fd*s**2 - 23184*D1*Dd*Pk2*b2*f*fd*s + 4536*D1*Dd*Pk2*b2*f*fd + 4032*D1*Dd*Pk2*bd2*f**2*r*s - 504*D1*Dd*Pk2*bd2*f**2*r + 14112*D1*Dd*Pk2*bd2*f**2*s**2 - 6552*D1*Dd*Pk2*bd2*f**2*s + 504*D1*Dd*Pk2*bd2*f**2 - 2344*D1*Dd*Pk2*f**3*r**2 - 8352*D1*Dd*Pk2*f**3*r*s + 4432*D1*Dd*Pk2*f**3*r + 2016*D1*Dd*Pk2*f**3*s**2 + 3168*D1*Dd*Pk2*f**3*s - 668*D1*Dd*Pk2*f**3 + 10704*D1*Dd*Pk2*f**2*fd*r**2 + 41472*D1*Dd*Pk2*f**2*fd*r*s - 21016*D1*Dd*Pk2*f**2*fd*r - 3456*D1*Dd*Pk2*f**2*fd*s**2 - 15264*D1*Dd*Pk2*f**2*fd*s + 6680*D1*Dd*Pk2*f**2*fd + 4032*D1*Dd*Pk2*f**2*g2*r*s - 1008*D1*Dd*Pk2*f**2*g2*r + 18144*D1*Dd*Pk2*f**2*g2*s**2 - 11088*D1*Dd*Pk2*f**2*g2*s + 4536*D1*Dd*Pk2*f**2*g2 - 8064*D1*Dd*Pk2*f**2*gd2*r*s + 1008*D1*Dd*Pk2*f**2*gd2*r - 28224*D1*Dd*Pk2*f**2*gd2*s**2 + 13104*D1*Dd*Pk2*f**2*gd2*s - 1008*D1*Dd*Pk2*f**2*gd2 - 16128*D1*Dd*Pk2*f*fd*g2*r*s + 6048*D1*Dd*Pk2*f*fd*g2*r - 56448*D1*Dd*Pk2*f*fd*g2*s**2 + 46368*D1*Dd*Pk2*f*fd*g2*s - 9072*D1*Dd*Pk2*f*fd*g2 + 180*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 90*D1*Dd*Pkdd2*f**3*k1**2*s + 45*D1*Dd*Pkdd2*f**3*k1**2 + 2016*D1*Ddd*Pk2*b2*f**2*r*s - 504*D1*Ddd*Pk2*b2*f**2*r + 7056*D1*Ddd*Pk2*b2*f**2*s**2 - 4536*D1*Ddd*Pk2*b2*f**2*s + 1764*D1*Ddd*Pk2*b2*f**2 + 1784*D1*Ddd*Pk2*f**3*r**2 + 6912*D1*Ddd*Pk2*f**3*r*s - 3512*D1*Ddd*Pk2*f**3*r - 576*D1*Ddd*Pk2*f**3*s**2 - 3168*D1*Ddd*Pk2*f**3*s + 748*D1*Ddd*Pk2*f**3 - 4032*D1*Ddd*Pk2*f**2*g2*r*s + 1008*D1*Ddd*Pk2*f**2*g2*r - 14112*D1*Ddd*Pk2*f**2*g2*s**2 + 9072*D1*Ddd*Pk2*f**2*g2*s - 3528*D1*Ddd*Pk2*f**2*g2 - 3*D1*bd1*(D1*(112*Pk2*fd*g2*(9*r*(2*s - 1) + s*(31 - 31*s)) + 6*f**3*(7*Pk2*(6*r**2 + 6*r*(4*s - 1) + 10*s**2 - 16*s + 3) - 5*Pkdd2*k1**2*s**2) + f**2*(-2*Pk2*(660*C*s**2 - 378*K*s**2 + 84*K*s + 42*fd*(18*r**2 + 6*r*(12*s - 5) + 30*s**2 - 50*s + 11) - 77*r**2 - 2*r*(s*(332*C + 42*K - 230) + 73) - 624*s**2 + 174*s + 88) + 3*Pkdd2*k1**2*(3*s**2 - 20*s + 10)) - 4*f*(14*Pk2*s*(g2*(26*r - 37*s) + gd2*(-36*r + 62*s + 18)) + fd*(Pk2*(-1080*C*s**2 + 304*C*s + 42*K*(r*(4*s - 1) + 14*s**2 - 9*s + 1) + 154*r**2 + 4*r*(59*C*(4*s - 1) - 122*s + 16) + 1128*s**2 - 517*s + 114) + 15*Pkdd2*k1**2*s*(s - 1)))) - 2*Dd*f*(84*Pk2*f**2*(12*r**2 + 6*r*(8*s - 3) + 20*s**2 - 33*s + 7) + 56*Pk2*g2*(r*(9 - 72*s) + s*(124*s - 13)) + f*(2*Pk2*(-2160*C*s**2 + 68*C*s + 42*K*(r*(8*s - 1) + 28*s**2 - 13*s + 1) + 308*r**2 + 4*r*(59*C*(8*s - 1) - 244*s + 11) + 2256*s**2 - 620*s + 37) + 15*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 6048*Dd**2*Pk2*b2*f**2*r*s - 1512*Dd**2*Pk2*b2*f**2*r + 21168*Dd**2*Pk2*b2*f**2*s**2 - 13608*Dd**2*Pk2*b2*f**2*s + 1008*Dd**2*Pk2*b2*f**2 + 5352*Dd**2*Pk2*f**3*r**2 + 20736*Dd**2*Pk2*f**3*r*s - 10536*Dd**2*Pk2*f**3*r - 1728*Dd**2*Pk2*f**3*s**2 - 9504*Dd**2*Pk2*f**3*s + 4348*Dd**2*Pk2*f**3 - 12096*Dd**2*Pk2*f**2*g2*r*s + 3024*Dd**2*Pk2*f**2*g2*r - 42336*Dd**2*Pk2*f**2*g2*s**2 + 27216*Dd**2*Pk2*f**2*g2*s - 2016*Dd**2*Pk2*f**2*g2 - 840*Pk2*b1**3*(K - 1)*(2*D1*Dd*(-4*r*s + r + 2*s) + D1*Ddd*(r*(4*s - 1) - 2*s) + Dd**2*(3*r*(4*s - 1) - 6*s + 2)) + 3*b1**2*(-2*D1*Dd*(-2240*C*Pk2*f*r*s + 560*C*Pk2*f*r + 1120*C*Pk2*f*s + 1456*K*Pk2*f*r*s - 364*K*Pk2*f*r - 2072*K*Pk2*f*s**2 + 308*K*Pk2*f*s - 518*K*Pk2*f - 672*Pk2*f**2*r*s + 168*Pk2*f**2*r + 336*Pk2*f**2*s - 448*Pk2*f*r*s + 112*Pk2*f*r + 224*Pk2*f*s + 14*Pk2*fd*(20*C*(r*(8*s - 1) - 6*s + 1) - 144*K*r*s + 90*K*r + 248*K*s**2 - 274*K*s + 26*K + 3*f*(64*r*s - 12*s - 5) + 112*r*s - 86*r + 176*s - 15) + 2240*Pk2*g2*r*s - 560*Pk2*g2*r - 1120*Pk2*g2*s - 280*Pk2*gd2*(r*(8*s - 1) - 6*s + 1) + 120*Pkdd2*f**2*k1**2*s**2 - 60*Pkdd2*f**2*k1**2*s + 30*Pkdd2*f**2*k1**2 + 84*Pkdd2*f*k1**2*s**2 - 42*Pkdd2*f*k1**2*s + 21*Pkdd2*f*k1**2 - Pkdd2*fd*k1**2*s*(60*f + 21)*(4*s - 1)) - 280*D1*Pk2*bd1*(K - 1)*(2*D1*(-3*r*s + r + s) + Dd*(r*(24*s - 7) - 10*s + 3)) + D1*(D1*(-280*Pk2*(bdd1*(K - 1)*(r*(3*s - 1) - s) + s*(4*gd2 - 2*gdd2)*(r - 1)) - 12*fd**2*(7*Pk2*(r*(8*s + 2) + s - 2) - 5*Pkdd2*k1**2*s**2) + 2*fd*(7*Pk2*(80*C*r*s - 80*C*s - 2*K*(s - 1)*(26*r - 37*s + 37) + 3*f*(4*r*(4*s + 1) + 6*s - 9) + 16*r*s - 52*r + 154*s - 37) + Pkdd2*k1**2*s**2*(-60*f - 21)) + fdd*(-14*Pk2*(40*C*r*s - 40*C*s - 2*K*(s - 1)*(18*r - 31*s + 31) + 3*f*(4*r*(4*s + 1) + 2*s - 7) + 28*r*s - 36*r + 102*s - 31) + Pkdd2*k1**2*s**2*(60*f + 21))) + Ddd*(560*Pk2*g2*(r*(4*s - 1) - 2*s) + 6*f**2*(56*Pk2*(-4*r*s + r + 2*s) + 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 7*f*(-4*K*Pk2*(r*(18 - 72*s) + 124*s**2 - 26*s + 31) + Pk2*(-80*C - 56)*(4*r*s - r - 2*s) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) - 2*Dd**2*(-280*Pk2*g2*(3*r*(4*s - 1) - 6*s + 2) + 6*f**2*(28*Pk2*(3*r*(4*s - 1) - 6*s + 2) + 15*Pkdd2*k1**2*s*(1 - 2*s)) + 7*f*(4*Pk2*(10*C*(3*r*(4*s - 1) - 6*s + 2) - 3*K*(36*r*s - 9*r - 62*s**2 + 13*s + 6) + 84*r*s - 21*r - 42*s + 14) + 9*Pkdd2*k1**2*s*(1 - 2*s)))) - 3*b1*(2656*C*D1**2*Pk2*f*fd*r*s - 1328*C*D1**2*Pk2*f*fd*r - 2640*C*D1**2*Pk2*f*fd*s**2 + 1312*C*D1**2*Pk2*f*fd*s - 1320*C*D1**2*Pk2*f*fd - 1888*C*D1**2*Pk2*f*fdd*r*s + 944*C*D1**2*Pk2*f*fdd*r + 2160*C*D1**2*Pk2*f*fdd*s**2 - 1216*C*D1**2*Pk2*f*fdd*s + 1080*C*D1**2*Pk2*f*fdd - 1888*C*D1**2*Pk2*fd**2*r*s + 944*C*D1**2*Pk2*fd**2*r + 2160*C*D1**2*Pk2*fd**2*s**2 - 1216*C*D1**2*Pk2*fd**2*s - 944*C*D1**2*Pk2*fd**2 + 5312*C*D1*Dd*Pk2*f**2*r*s - 1328*C*D1*Dd*Pk2*f**2*r - 5280*C*D1*Dd*Pk2*f**2*s**2 - 16*C*D1*Dd*Pk2*f**2*s - 1320*C*D1*Dd*Pk2*f**2 - 15104*C*D1*Dd*Pk2*f*fd*r*s + 5664*C*D1*Dd*Pk2*f*fd*r + 17280*C*D1*Dd*Pk2*f*fd*s**2 - 5408*C*D1*Dd*Pk2*f*fd*s - 672*C*D1*Dd*Pk2*f*fd - 3776*C*D1*Ddd*Pk2*f**2*r*s + 944*C*D1*Ddd*Pk2*f**2*r + 4320*C*D1*Ddd*Pk2*f**2*s**2 - 272*C*D1*Ddd*Pk2*f**2*s + 1080*C*D1*Ddd*Pk2*f**2 - 11328*C*Dd**2*Pk2*f**2*r*s + 2832*C*Dd**2*Pk2*f**2*r + 12960*C*Dd**2*Pk2*f**2*s**2 - 816*C*Dd**2*Pk2*f**2*s - 1888*C*Dd**2*Pk2*f**2 + 336*D1**2*K*Pk2*f*fd*r*s - 168*D1**2*K*Pk2*f*fd*r + 1512*D1**2*K*Pk2*f*fd*s**2 - 1512*D1**2*K*Pk2*f*fd*s + 756*D1**2*K*Pk2*f*fd - 336*D1**2*K*Pk2*f*fdd*r*s + 168*D1**2*K*Pk2*f*fdd*r - 1176*D1**2*K*Pk2*f*fdd*s**2 + 1176*D1**2*K*Pk2*f*fdd*s - 588*D1**2*K*Pk2*f*fdd - 336*D1**2*K*Pk2*fd**2*r*s + 168*D1**2*K*Pk2*fd**2*r - 1176*D1**2*K*Pk2*fd**2*s**2 + 1176*D1**2*K*Pk2*fd**2*s + 280*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) - 2*s + 1) + 756*D1**2*Pk2*f**2*fd*r**2 + 3024*D1**2*Pk2*f**2*fd*r*s - 1764*D1**2*Pk2*f**2*fd*r + 1260*D1**2*Pk2*f**2*fd*s**2 - 2184*D1**2*Pk2*f**2*fd*s + 798*D1**2*Pk2*f**2*fd - 756*D1**2*Pk2*f**2*fdd*r**2 - 3024*D1**2*Pk2*f**2*fdd*r*s + 1764*D1**2*Pk2*f**2*fdd*r - 1260*D1**2*Pk2*f**2*fdd*s**2 + 2184*D1**2*Pk2*f**2*fdd*s - 798*D1**2*Pk2*f**2*fdd - 1512*D1**2*Pk2*f*fd**2*r**2 - 6048*D1**2*Pk2*f*fd**2*r*s + 3528*D1**2*Pk2*f*fd**2*r - 2520*D1**2*Pk2*f*fd**2*s**2 + 4368*D1**2*Pk2*f*fd**2*s - 1596*D1**2*Pk2*f*fd**2 + 308*D1**2*Pk2*f*fd*r**2 - 1840*D1**2*Pk2*f*fd*r*s + 320*D1**2*Pk2*f*fd*r + 2496*D1**2*Pk2*f*fd*s**2 - 1228*D1**2*Pk2*f*fd*s + 1578*D1**2*Pk2*f*fd - 308*D1**2*Pk2*f*fdd*r**2 + 976*D1**2*Pk2*f*fdd*r*s - 104*D1**2*Pk2*f*fdd*r - 2256*D1**2*Pk2*f*fdd*s**2 + 1468*D1**2*Pk2*f*fdd*s - 1398*D1**2*Pk2*f*fdd - 1456*D1**2*Pk2*f*gd2*r*s + 2072*D1**2*Pk2*f*gd2*s**2 + 1456*D1**2*Pk2*f*gd2*s + 1008*D1**2*Pk2*f*gdd2*r*s - 1736*D1**2*Pk2*f*gdd2*s**2 - 1008*D1**2*Pk2*f*gdd2*s - 308*D1**2*Pk2*fd**2*r**2 + 976*D1**2*Pk2*fd**2*r*s - 104*D1**2*Pk2*fd**2*r - 2256*D1**2*Pk2*fd**2*s**2 + 1468*D1**2*Pk2*fd**2*s + 944*D1**2*Pk2*fd**2 - 1456*D1**2*Pk2*fd*g2*r*s + 1456*D1**2*Pk2*fd*g2*r + 2072*D1**2*Pk2*fd*g2*s**2 - 4144*D1**2*Pk2*fd*g2*s + 2072*D1**2*Pk2*fd*g2 + 2016*D1**2*Pk2*fd*gd2*r*s - 1008*D1**2*Pk2*fd*gd2*r - 3472*D1**2*Pk2*fd*gd2*s**2 + 2464*D1**2*Pk2*fd*gd2*s + 1008*D1**2*Pk2*fd*gd2 + 1008*D1**2*Pk2*fdd*g2*r*s - 1008*D1**2*Pk2*fdd*g2*r - 1736*D1**2*Pk2*fdd*g2*s**2 + 3472*D1**2*Pk2*fdd*g2*s - 1736*D1**2*Pk2*fdd*g2 - 90*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 60*D1**2*Pkdd2*f**2*fd*k1**2*s - 30*D1**2*Pkdd2*f**2*fd*k1**2 + 18*D1**2*Pkdd2*f*fd*k1**2*s**2 + 42*D1**2*Pkdd2*f*fd*k1**2*s - 21*D1**2*Pkdd2*f*fd*k1**2 - 30*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 30*D1**2*Pkdd2*fd**2*k1**2*s**2 + D1**2*bdd1*(560*Pk2*g2*r*(1 - 2*s) + 6*f**2*(7*Pk2*(4*r*(4*s - 3) - 18*s + 7) - 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 7*f*(2*Pk2*(124*K*s**2 + 36*K*s + 8*r*(10*C*s - 5*C - 9*K*s + 7*s + 1) - 130*s + 31) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 672*D1*Dd*K*Pk2*f**2*r*s - 168*D1*Dd*K*Pk2*f**2*r + 3024*D1*Dd*K*Pk2*f**2*s**2 - 1848*D1*Dd*K*Pk2*f**2*s + 756*D1*Dd*K*Pk2*f**2 - 2688*D1*Dd*K*Pk2*f*fd*r*s + 1008*D1*Dd*K*Pk2*f*fd*r - 9408*D1*Dd*K*Pk2*f*fd*s**2 + 7728*D1*Dd*K*Pk2*f*fd*s - 1512*D1*Dd*K*Pk2*f*fd + 1008*D1*Dd*Pk2*f**3*r**2 + 4032*D1*Dd*Pk2*f**3*r*s - 2016*D1*Dd*Pk2*f**3*r + 1680*D1*Dd*Pk2*f**3*s**2 - 2856*D1*Dd*Pk2*f**3*s + 924*D1*Dd*Pk2*f**3 - 6048*D1*Dd*Pk2*f**2*fd*r**2 - 24192*D1*Dd*Pk2*f**2*fd*r*s + 13104*D1*Dd*Pk2*f**2*fd*r - 10080*D1*Dd*Pk2*f**2*fd*s**2 + 17304*D1*Dd*Pk2*f**2*fd*s - 5712*D1*Dd*Pk2*f**2*fd + 616*D1*Dd*Pk2*f**2*r**2 - 3680*D1*Dd*Pk2*f**2*r*s + 304*D1*Dd*Pk2*f**2*r + 4992*D1*Dd*Pk2*f**2*s**2 - 656*D1*Dd*Pk2*f**2*s + 1556*D1*Dd*Pk2*f**2 - 2464*D1*Dd*Pk2*f*fd*r**2 + 7808*D1*Dd*Pk2*f*fd*r*s - 160*D1*Dd*Pk2*f*fd*r - 18048*D1*Dd*Pk2*f*fd*s**2 + 8432*D1*Dd*Pk2*f*fd*s - 1260*D1*Dd*Pk2*f*fd - 5824*D1*Dd*Pk2*f*g2*r*s + 1456*D1*Dd*Pk2*f*g2*r + 8288*D1*Dd*Pk2*f*g2*s**2 - 1232*D1*Dd*Pk2*f*g2*s + 2072*D1*Dd*Pk2*f*g2 + 8064*D1*Dd*Pk2*f*gd2*r*s - 1008*D1*Dd*Pk2*f*gd2*r - 13888*D1*Dd*Pk2*f*gd2*s**2 - 2576*D1*Dd*Pk2*f*gd2*s + 1008*D1*Dd*Pk2*f*gd2 + 8064*D1*Dd*Pk2*fd*g2*r*s - 5040*D1*Dd*Pk2*fd*g2*r - 13888*D1*Dd*Pk2*fd*g2*s**2 + 15344*D1*Dd*Pk2*fd*g2*s - 1456*D1*Dd*Pk2*fd*g2 - 120*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 60*D1*Dd*Pkdd2*f**3*k1**2*s - 30*D1*Dd*Pkdd2*f**3*k1**2 + 36*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**2*k1**2*s + 9*D1*Dd*Pkdd2*f**2*k1**2 - 240*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 60*D1*Dd*Pkdd2*f*fd*k1**2*s - 672*D1*Ddd*K*Pk2*f**2*r*s + 168*D1*Ddd*K*Pk2*f**2*r - 2352*D1*Ddd*K*Pk2*f**2*s**2 + 1512*D1*Ddd*K*Pk2*f**2*s - 588*D1*Ddd*K*Pk2*f**2 - 1008*D1*Ddd*Pk2*f**3*r**2 - 4032*D1*Ddd*Pk2*f**3*r*s + 2016*D1*Ddd*Pk2*f**3*r - 1680*D1*Ddd*Pk2*f**3*s**2 + 2856*D1*Ddd*Pk2*f**3*s - 924*D1*Ddd*Pk2*f**3 - 616*D1*Ddd*Pk2*f**2*r**2 + 1952*D1*Ddd*Pk2*f**2*r*s + 128*D1*Ddd*Pk2*f**2*r - 4512*D1*Ddd*Pk2*f**2*s**2 + 1280*D1*Ddd*Pk2*f**2*s - 1436*D1*Ddd*Pk2*f**2 + 4032*D1*Ddd*Pk2*f*g2*r*s - 1008*D1*Ddd*Pk2*f*g2*r - 6944*D1*Ddd*Pk2*f*g2*s**2 + 1456*D1*Ddd*Pk2*f*g2*s - 1736*D1*Ddd*Pk2*f*g2 - 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 30*D1*Ddd*Pkdd2*f**2*k1**2*s - 15*D1*Ddd*Pkdd2*f**2*k1**2 - 2*D1*bd1*(D1*(-14*Pk2*fd*(20*C*(r*(4*s - 1) - 2*s + 1) - 2*K*(36*r*s - 18*r - 62*s**2 + 53*s + 9) + 56*r*s - 32*r + 37*s - 2) - 560*Pk2*g2*r*(2*s - 1) - 280*Pk2*gd2*(-4*r*s + r + 2*s - 1) - 21*Pkdd2*fd*k1**2*s*(1 - 2*s) + 3*f**2*(7*Pk2*(4*r*(4*s - 3) - 22*s + 9) - 10*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(7*Pk2*(148*K*s**2 + 52*K*s - 12*fd*(4*r*(4*s - 1) - 8*s + 3) + 4*r*(40*C*s - 20*C - 26*K*s + 8*s + 9) - 170*s + 37) + 3*Pkdd2*k1**2*(s**2*(40*fd - 14) + s*(14 - 20*fd) - 7))) + Dd*(560*Pk2*g2*(r*(8*s - 3) - 2*s + 1) - 6*f**2*(7*Pk2*(32*r*(2*s - 1) - 52*s + 21) - 5*Pkdd2*k1**2*(8*s**2 - 6*s + 1)) - 7*f*(2*Pk2*(40*C*(r*(8*s - 3) - 2*s + 1) + K*(-288*r*s + 36*r + 496*s**2 + 20*s - 18) + 224*r*s - 12*r - 316*s + 57) - 3*Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) - 2016*Dd**2*K*Pk2*f**2*r*s + 504*Dd**2*K*Pk2*f**2*r - 7056*Dd**2*K*Pk2*f**2*s**2 + 4536*Dd**2*K*Pk2*f**2*s - 336*Dd**2*K*Pk2*f**2 - 3024*Dd**2*Pk2*f**3*r**2 - 12096*Dd**2*Pk2*f**3*r*s + 6048*Dd**2*Pk2*f**3*r - 5040*Dd**2*Pk2*f**3*s**2 + 8568*Dd**2*Pk2*f**3*s - 2520*Dd**2*Pk2*f**3 - 1848*Dd**2*Pk2*f**2*r**2 + 5856*Dd**2*Pk2*f**2*r*s + 384*Dd**2*Pk2*f**2*r - 13536*Dd**2*Pk2*f**2*s**2 + 3840*Dd**2*Pk2*f**2*s + 668*Dd**2*Pk2*f**2 + 12096*Dd**2*Pk2*f*g2*r*s - 3024*Dd**2*Pk2*f*g2*r - 20832*Dd**2*Pk2*f*g2*s**2 + 4368*Dd**2*Pk2*f*g2*s + 2016*Dd**2*Pk2*f*g2 - 180*Dd**2*Pkdd2*f**2*k1**2*s**2 + 90*Dd**2*Pkdd2*f**2*k1**2*s))/(630*d**2*k2*k3**2) - D1**2*Pk3*ct**3*k2**3*st**2*(D1**2*(45*Pkdd2*bd1*f**3*k1**2*s**2 + 9*Pkdd2*k1**2*s*(b1**2*s*(10*fd**2 + 14*fd*(2*K - 1) + 7*fdd*(1 - 2*K)) + b1*(-14*bd1*fd*(2*K - 1)*(2*s - 1) + fd**2*(-20*K*(s - 1) + s*(18 - 24*C)) - 56*fd*s*(g2 - gd2) + 28*fdd*g2*s) + 8*fd*g2*(7*bd1 + 5*fd)*(s - 1)) + f**2*(9*Pkdd2*k1**2*(10*bd1**2*s*(s - 1) + bd1*(24*C*(s - 1)**2 + 6*K*s**2 - 10*b1*(2*s**2 - 2*s + 1) - 11*s**2 + 36*s - 18) + bdd1*(-12*C*(s - 1)**2 - 10*K*s**2 + 5*b1*(2*s**2 - 2*s + 1) + 9*s**2 - 18*s + 9) + s**2*(-12*gd2 + 20*gdd2)) + fd*(4*Pk2*(4*C*(123*r**2 + 66*r*s - 104*r - 22*s + 41) - 303*r**2 - 132*r*s + 246*r + 44*s - 101) + Pkdd2*k1**2*(92*C + 45*b1 - 19)*(3*s**2 - 2*s + 1)) - 2*fdd*(4*Pk2*(4*C*(51*r**2 + 30*r*s - 44*r - 10*s + 17) - 123*r**2 - 60*r*s + 102*r + 20*s - 41) + Pkdd2*k1**2*(50*C - 25)*(3*s**2 - 2*s + 1))) + f*(-9*Pkdd2*fd*k1**2*(20*b1**2*s**2 + b1*(-6*K*(2*s**2 - 2*s + 1) + s**2*(-48*C - 40*bd1 + 22) + s*(20*bd1 + 14) - 7) + 4*bd1*s*(12*C*(s - 1) + 5*K*(2*s - 1) - 9*s + 9) + 4*g2*(6*s**2 - 6*s + 3) + 40*gd2*s*(1 - 2*s)) + 9*Pkdd2*k1**2*(10*b1**2*fdd*s**2 + b1*(-10*K*fdd*(2*s**2 - 2*s + 1) + 14*bd1*(2*K - 1)*(2*s**2 - 2*s + 1) - 7*bdd1*(2*K - 1)*(2*s**2 - 2*s + 1) - 2*fdd*s**2*(12*C - 9) - 2*s**2*(28*gd2 - 14*gdd2)) - 14*bd1**2*s*(2*K - 1)*(s - 1) - 56*bd1*(s - 1)*(g2*(s - 1) - gd2*s) + 4*g2*(7*bdd1*(s - 1)**2 + 5*fdd*(2*s**2 - 2*s + 1))) - 4*fd**2*(4*Pk2*(4*C*(51*r**2 + 30*r*s - 44*r - 10*s + 5) - 123*r**2 - 60*r*s + 102*r + 20*s - 10) + Pkdd2*k1**2*s*(50*C - 25)*(3*s - 2)))) + D1*(Dd*(-126*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(b1*(2*K - 1) - 4*g2) + 18*Pkdd2*f*k1**2*(b1**2*(14*K*(4*s**2 - 2*s + 1) + s**2*(40*fd - 28) - s*(10*fd - 14) - 7) - b1*(7*bd1*(2*K - 1)*(8*s**2 - 6*s + 1) + 28*g2*(4*s**2 - 2*s + 1) + (8*s - 2)*(5*K*fd*(2*s - 1) + fd*s*(12*C - 9) - 14*gd2*s)) + 4*g2*(4*s - 1)*(7*bd1*(s - 1) + 5*fd*(2*s - 1))) + f**3*(8*Pk2*(4*C*(82*r**2 + 44*r*s - 93*r - 22*s + 41) - 202*r**2 - 88*r*s + 224*r + 44*s - 101) + Pkdd2*k1**2*(92*C + 45*b1 - 19)*(4*s**2 - 2*s + 1)) + f**2*(-9*Pkdd2*k1**2*(10*b1**2*(4*s**2 - 2*s + 1) - 10*b1*bd1*(8*s**2 - 6*s + 1) - b1*(24*C + 6*K - 11)*(4*s**2 - 2*s + 1) + 2*bd1*(4*s - 1)*(12*C*(s - 1) + s*(10*K - 9) + 9) + 12*g2*(4*s**2 - 2*s + 1) + 40*gd2*s*(1 - 4*s)) - 4*fd*(16*Pk2*(C*(204*r**2 + 5*r*(24*s - 41) - 50*s + 49) - 123*r**2 - 60*r*(s - 2) + 25*s - 28) + Pkdd2*k1**2*(50*C - 25)*(12*s**2 - 7*s + 1)))) + Ddd*f*(-63*Pkdd2*b1*k1**2*(b1*(2*K - 1) - 4*g2)*(4*s**2 - 2*s + 1) + 9*Pkdd2*f*k1**2*(5*b1**2 + b1*(-12*C - 10*K + 9) + 20*g2)*(4*s**2 - 2*s + 1) - 2*f**2*(8*Pk2*(4*C*(34*r**2 + 20*r*s - 39*r - 10*s + 17) - 82*r**2 - 40*r*s + 92*r + 20*s - 41) + Pkdd2*k1**2*(50*C - 25)*(4*s**2 - 2*s + 1)))) + 2*Dd**2*f*(-189*Pkdd2*b1*k1**2*s*(2*s - 1)*(b1*(2*K - 1) - 4*g2) + 27*Pkdd2*f*k1**2*s*(2*s - 1)*(5*b1**2 + b1*(-12*C - 10*K + 9) + 20*g2) - 2*f**2*(4*Pk2*(12*C*(34*r**2 + 20*r*s - 39*r - 10*s + 9) - 246*r**2 - 120*r*s + 276*r + 60*s - 61) + Pkdd2*k1**2*s*(150*C - 75)*(2*s - 1))))/(315*d**2*k1*k3**4) - D1**2*Pk3*ct**3*k2**3*(-252*D1**2*K*Pkdd2*bd1**2*f*k1**2*s*(s - 1) + 3*D1*bd1*(D1*(168*Pkdd2*fd*g2*k1**2*s*(s - 1) + f**2*(32*Pk2*r*(2*C*(4*r + 3*s - 6) - 6*r - 3*s + 6) + 3*Pkdd2*k1**2*(12*C*(s - 1)**2 - 14*K*s**2 + s**2 - 2*s + 1)) - 4*f*(7*Pkdd2*k1**2*(s - 1)*(g2*(s - 1) - 6*gd2*s) + 2*fd*(4*C*Pk2*(2*r**2 + 2*r*(6*s - 5) - 3*s + 6) - 3*Pk2*(2*r**2 + r*(8*s - 7) - 2*s + 4) + Pkdd2*k1**2*s*(30*C - 15)*(s - 1)))) - 4*Dd*f*(8*Pk2*f*(C*(4*r**2 + 24*r*s - 29*r - 6*s + 12) - 3*r**2 - 3*r*(4*s - 5) + 3*s - 6) + Pkdd2*f*k1**2*(30*C - 15)*(4*s**2 - 5*s + 1) - 42*Pkdd2*g2*k1**2*(4*s**2 - 5*s + 1))) + 21*Pkdd2*b1**2*k1**2*(D1**2*s**2*(-6*K*fdd + fd*(2*K + 6*f + 5)) + D1*(Dd*(12*K*fd*s*(1 - 4*s) + 3*f**2*(4*s**2 - 2*s + 1) + f*(2*K + 5)*(4*s**2 - 2*s + 1)) - 6*Ddd*K*f*(4*s**2 - 2*s + 1)) + 36*Dd**2*K*f*s*(1 - 2*s)) + 3*b1*(D1**2*(21*Pkdd2*bd1*f**2*k1**2*(2*s**2 - 2*s + 1) - 28*Pkdd2*fd*k1**2*s*(3*K*bd1*(2*s - 1) + s*(g2 - 6*gd2)) + 84*Pkdd2*fdd*g2*k1**2*s**2 + f*(32*Pk2*fd*(2*C*(8*r**2 + 6*r*s - 5*r - 3*s + 4) - 12*r**2 - 6*r*s + 9*r + 3*s - 6) + 6*Pkdd2*fd*k1**2*(-7*K*(2*s**2 - 2*s + 1) + s**2*(12*C + 1)) + 7*Pkdd2*k1**2*(-6*K*bdd1*(2*s**2 - 2*s + 1) + bd1*(2*K + 5)*(2*s**2 - 2*s + 1) + s**2*(-4*gd2 + 12*gdd2)) - 4*fdd*(4*C*Pk2*(2*r**2 + 4*r*(3*s + 1) - 6*s + 1) - 3*Pk2*(2*r**2 + r*(8*s + 2) - 4*s + 1) + Pkdd2*k1**2*s**2*(30*C - 15))) - 4*fd**2*(8*C*Pk2*(r**2 + r*(6*s + 2) - 3*s - 3) - 6*Pk2*(r**2 + 4*r*s + r - 2*s - 2) + Pkdd2*k1**2*s**2*(30*C - 15))) + D1*(Dd*(168*Pkdd2*fd*g2*k1**2*s*(4*s - 1) + f**2*(64*C*Pk2*(16*r**2 + r*(12*s - 19) - 6*s + 8) - 96*Pk2*(8*r**2 + r*(4*s - 9) - 2*s + 4) + Pkdd2*k1**2*(36*C - 42*K + 3)*(4*s**2 - 2*s + 1)) - 4*f*(8*C*Pk2*fd*(2*r - 1)*(4*r + 24*s + 1) + 60*C*Pkdd2*fd*k1**2*s*(4*s - 1) + 21*K*Pkdd2*bd1*k1**2*(8*s**2 - 6*s + 1) - 24*Pk2*fd*(r + 4*s)*(2*r - 1) + 30*Pkdd2*fd*k1**2*s*(1 - 4*s) + 7*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 42*Pkdd2*gd2*k1**2*s*(1 - 4*s))) - 2*Ddd*f*(4*Pk2*f*(4*C*(2*r**2 + r*(12*s - 5) - 6*s + 1) - 6*r**2 - 3*r*(8*s - 4) + 12*s - 3) + Pkdd2*f*k1**2*(30*C - 15)*(4*s**2 - 2*s + 1) - 42*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1))) - 4*Dd**2*f*(126*Pkdd2*g2*k1**2*s*(1 - 2*s) + f*(8*C*Pk2*(6*r**2 + 3*r*(12*s - 5) - 18*s + 7) - 6*Pk2*(6*r**2 + 12*r*(2*s - 1) - 12*s + 5) + Pkdd2*k1**2*s*(90*C - 45)*(2*s - 1)))) + 2*f*(D1**2*(-2*Pk2*fd**2*(8*C - 4)*(21*r**2 + 2*r*(54*s - 25) - 36*s + 18) + 126*Pkdd2*bdd1*g2*k1**2*(s - 1)**2 + 126*Pkdd2*fd*g2*k1**2*(2*s**2 - 2*s + 1) + f*(-Pk2*fdd*(8*C - 4)*(21*r**2 + 2*r*(54*s - 25) - 36*s + 7) + 126*Pkdd2*gd2*k1**2*s**2 - 3*bdd1*(8*C*Pk2*r*(r + 6*s - 12) - 6*Pk2*r*(r + 4*s - 8) + Pkdd2*k1**2*(30*C - 15)*(s - 1)**2) + fd*(2*C - 1)*(16*Pk2*(24*r**2 + r*(27*s - 25) - 9*s + 8) - 45*Pkdd2*k1**2*(3*s**2 - 2*s + 1)))) + D1*f*(Dd*(-Pk2*fd*(64*C - 32)*(21*r**2 + r*(108*s - 49) - 45*s + 17) + 126*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + f*(2*C - 1)*(16*Pk2*(32*r**2 + r*(36*s - 41) - 18*s + 16) - 45*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(8 - 16*C)*(14*r**2 + 8*r*(9*s - 4) - 36*s + 7)) + Dd**2*Pk2*f**2*(8 - 16*C)*(42*r**2 + 24*r*(9*s - 4) - 108*s + 43)))/(630*d**2*k1*k3**4) + D1**2*Pk3*ct**3*k2*st**2*(D1**2*(45*Pkdd2*bd1*f**3*k1**2*s**2 + 9*Pkdd2*k1**2*(b1**2*(10*fd**2*s - 14*fd*(2*K*(s - 1)**2 + 2*s - 1) + 7*fdd*(2*K*(s - 1)**2 + 2*s - 1)) + 2*b1*(fd**2*s*(12*C*(s - 1) - 10*K*(s - 1) - 6*s + 9) + 7*fd*(4*g2*(s - 1)**2 + s*(4*K*bd1*(s - 1) + bd1 - 4*gd2*(s - 1))) - 14*fdd*g2*(s - 1)**2) - 4*fd*s*(s - 1)*(5*b2*fd + g2*(14*bd1 - 10*fd))) + f**2*(8*Pk2*fdd*(21*r**2 + 2*r*(20*C*(3*s - 1) - 30*s + 3) + s*(20 - 40*C) + 7) + Pkdd2*fdd*k1**2*(50 - 100*C)*(3*s**2 - 2*s + 1) - 9*Pkdd2*k1**2*(10*bd1**2*s + bd1*(b1*(10 - 20*s) + s**2*(24*C - 20*K - 19) - 12*s + 6) + bdd1*(5*b1*(2*s - 1) + s**2*(-12*C + 10*K + 6) + 6*s - 3) + s**2*(-20*bd2 + 10*bdd2 + 40*gd2 - 20*gdd2)) + fd*(-4*Pk2*(57*r**2 + 2*r*(44*C*(3*s - 1) - 66*s + 3) + s*(44 - 88*C) + 19) + Pkdd2*k1**2*(200*C + 45*b1 - 73)*(3*s**2 - 2*s + 1))) + f*(-9*Pkdd2*fd*k1**2*(-48*C*bd1*s**2 + 24*C*bd1*s + 40*K*bd1*s**2 - 20*K*bd1*s + 10*b1**2*(2*s - 1) + b1*(24*C*(2*s**2 - 2*s + 1) - 20*K*(2*s**2 - 2*s + 1) - 38*s**2 + 50*s - 25) - 20*b2*(2*s**2 - 2*s + 1) + 24*bd1*s**2 - 6*bd1*s + 40*bd2*s**2 - 20*bd2*s + 80*g2*s**2 - 80*g2*s + 40*g2 - 80*gd2*s**2 + 40*gd2*s) + 9*Pkdd2*k1**2*(5*b1**2*fdd*(2*s - 1) + b1*(24*C*fdd*s**2 - 24*C*fdd*s + 12*C*fdd - 20*K*fdd*s**2 + 20*K*fdd*s - 10*K*fdd - 14*bd1*(4*K*s**2 - 2*s + 1) + 7*bdd1*(4*K*s**2 - 2*s + 1) - 12*fdd*s**2 + 18*fdd*s - 9*fdd + 56*gd2*s**2 - 28*gdd2*s**2) - 10*b2*fdd*(2*s**2 - 2*s + 1) + 20*fdd*g2*(2*s**2 - 2*s + 1) - 14*s*(bd1**2*(-2*K*s + 1) + 4*bd1*s*(-g2 + gd2) + 2*bdd1*g2*s)) + 4*fd**2*(4*Pk2*(20*C*(6*r*s - 2*r - 2*s + 1) + 21*r**2 - 60*r*s + 6*r + 20*s - 10) + Pkdd2*k1**2*s*(25 - 50*C)*(3*s - 2)))) + D1*(Dd*(126*Pkdd2*b1*fd*k1**2*(4*s - 1)*(2*K*b1*(s - 1) + b1 - 4*g2*(s - 1)) + 18*Pkdd2*f*k1**2*(b1**2*(-14*K*(4*s**2 - 2*s + 1) + 5*fd*(4*s - 1)) + b1*(7*bd1*(4*s - 1)*(4*K*s - 1) + fd*(4*s - 1)*(24*C*s - 12*C - 20*K*s + 10*K - 12*s + 9) + 112*g2*s**2 - 56*g2*s + 28*g2 - 112*gd2*s**2 + 28*gd2*s) + (2 - 8*s)*(5*b2*fd*(2*s - 1) + 2*g2*(7*bd1*s + fd*(5 - 10*s)))) + f**3*(-8*Pk2*(38*r**2 + 4*r*(11*C*(4*s - 1) - 22*s - 4) + s*(44 - 88*C) + 19) + Pkdd2*k1**2*(200*C + 45*b1 - 73)*(4*s**2 - 2*s + 1)) + f**2*(-9*Pkdd2*k1**2*(-96*C*bd1*s**2 + 24*C*bd1*s + 80*K*bd1*s**2 - 20*K*bd1*s + 10*b1*bd1*(4*s - 1) + b1*(24*C - 20*K - 19)*(4*s**2 - 2*s + 1) - 20*b2*(4*s**2 - 2*s + 1) + 48*bd1*s**2 + 12*bd1*s - 6*bd1 + 80*bd2*s**2 - 20*bd2*s + 160*g2*s**2 - 80*g2*s + 40*g2 - 160*gd2*s**2 + 40*gd2*s) + 4*fd*(16*Pk2*(5*C*(24*r*s - 7*r - 10*s + 3) + 21*r**2 - 60*r*s + 25*s - 4) + Pkdd2*k1**2*(25 - 50*C)*(12*s**2 - 7*s + 1)))) + 2*Ddd*f*(63*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1) - 9*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)*(b1*(-6*C + 5*K + 3) + 5*b2 - 10*g2) + f**2*(8*Pk2*(-40*C*s + 14*r**2 + 4*r*(20*C*s - 5*C - 10*s - 1) + 20*s + 7) + Pkdd2*k1**2*(25 - 50*C)*(4*s**2 - 2*s + 1)))) + 4*Dd**2*f*(189*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2) - 27*Pkdd2*f*k1**2*s*(2*s - 1)*(b1*(-6*C + 5*K + 3) + 5*b2 - 10*g2) + f**2*(4*Pk2*(20*C*(3*r*(4*s - 1) - 6*s + 2) + 42*r**2 - 12*r*(10*s + 1) + 60*s - 13) + Pkdd2*k1**2*s*(75 - 150*C)*(2*s - 1))))/(315*d**2*k1*k3**2) + D1**2*Pk3*ct**3*k2*(D1**2*(-84*Pkdd2*bd1*k1**2*s*(s - 1)*(3*b2*fd + 10*bd1*g2 - 6*fd*g2) + f**2*(384*Pk2*bd1*r**2*(1 - 2*C) - Pk2*fdd*(16*C - 8)*(21*r**2 + 2*r*(54*s - 25) - 36*s + 7) + 9*Pkdd2*bd1*k1**2*(C*(68*s**2 - 80*s + 40) - s**2*(14*K + 34) + 26*s - 13) - Pkdd2*k1**2*s**2*(126*bd2 - 252*gd2) - 6*bdd1*(2*C - 1)*(-4*Pk2*r**2 + 15*Pkdd2*k1**2*(s - 1)**2) + fd*(4*C - 2)*(16*Pk2*(24*r**2 + r*(27*s - 25) - 9*s + 8) - 45*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) - 2*f*(Pk2*fd**2*(16*C - 8)*(21*r**2 + 2*r*(54*s - 25) - 36*s + 18) - 21*Pkdd2*k1**2*(3*b2*(2*bd1 - bdd1)*(s - 1)**2 + 3*bd1**2*s*(s - 1)*(4*C - 2*K - 3) - 2*bd1*(g2*(11*s**2 - 12*s + 6) + s*(3*bd2 - 6*gd2)*(s - 1)) + 6*bdd1*g2*(s - 1)**2) + 3*fd*(21*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) - 42*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) - 4*bd1*(2*C - 1)*(2*Pk2*r*(2*r - 1) - 15*Pkdd2*k1**2*s*(s - 1))))) + 2*D1*f*(Dd*(-126*Pkdd2*bd1*k1**2*(b2 - 2*g2)*(4*s**2 - 5*s + 1) + f**2*(2*C - 1)*(16*Pk2*(32*r**2 + r*(36*s - 41) - 18*s + 16) - 45*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(-Pk2*fd*(64*C - 32)*(21*r**2 + r*(108*s - 49) - 45*s + 17) - 63*Pkdd2*b2*k1**2*(4*s**2 - 2*s + 1) + 126*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) - 6*bd1*(2*C - 1)*(8*Pk2*r*(1 - 2*r) + 15*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + Ddd*Pk2*f**2*(8 - 16*C)*(14*r**2 + 8*r*(9*s - 4) - 36*s + 7)) + Dd**2*Pk2*f**3*(16 - 32*C)*(42*r**2 + 24*r*(9*s - 4) - 108*s + 43) + 21*Pkdd2*b1**3*k1**2*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-10*K*(4*s**2 - 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s + 20*s**2 - 10*s + 5) - D1*Ddd*(-10*K + 3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-10*K + 3*f + 5)) + 21*Pkdd2*b1**2*k1**2*(-24*C*D1**2*fd*s**2 + 12*C*D1**2*fdd*s**2 - 96*C*D1*Dd*f*s**2 + 48*C*D1*Dd*f*s - 24*C*D1*Dd*f + 96*C*D1*Dd*fd*s**2 - 24*C*D1*Dd*fd*s + 48*C*D1*Ddd*f*s**2 - 24*C*D1*Ddd*f*s + 12*C*D1*Ddd*f + 144*C*Dd**2*f*s**2 - 72*C*Dd**2*f*s + 22*D1**2*K*fd*s**2 - 20*D1**2*K*fd*s + 10*D1**2*K*fd - 6*D1**2*K*fdd*s**2 - D1**2*bdd1*(-10*K + 3*f + 5)*(3*s**2 - 2*s + 1) + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 18*D1**2*fd*s**2 + 10*D1**2*fd*s - 5*D1**2*fd - 9*D1**2*fdd*s**2 + 40*D1**2*gd2*s**2 - 20*D1**2*gdd2*s**2 + 88*D1*Dd*K*f*s**2 - 44*D1*Dd*K*f*s + 22*D1*Dd*K*f - 48*D1*Dd*K*fd*s**2 + 12*D1*Dd*K*fd*s + 72*D1*Dd*f*s**2 - 36*D1*Dd*f*s + 18*D1*Dd*f - 72*D1*Dd*fd*s**2 + 18*D1*Dd*fd*s + 160*D1*Dd*g2*s**2 - 80*D1*Dd*g2*s + 40*D1*Dd*g2 - 160*D1*Dd*gd2*s**2 + 40*D1*Dd*gd2*s - 24*D1*Ddd*K*f*s**2 + 12*D1*Ddd*K*f*s - 6*D1*Ddd*K*f - 36*D1*Ddd*f*s**2 + 18*D1*Ddd*f*s - 9*D1*Ddd*f - 80*D1*Ddd*g2*s**2 + 40*D1*Ddd*g2*s - 20*D1*Ddd*g2 + 2*D1*bd1*(D1*(-10*K*(3*s**2 - 2*s + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s + 15*s**2 - 10*s + 5) - Dd*(-10*K + 3*f + 5)*(12*s**2 - 7*s + 1)) - 72*Dd**2*K*f*s**2 + 36*Dd**2*K*f*s - 108*Dd**2*f*s**2 + 54*Dd**2*f*s - 240*Dd**2*g2*s**2 + 120*Dd**2*g2*s) - 3*b1*(D1**2*(-32*C*Pk2*fd**2*r**2 + 32*C*Pk2*fd**2*r + 120*C*Pkdd2*fd**2*k1**2*s**2 + 16*Pk2*fd**2*r**2 - 16*Pk2*fd**2*r - 84*Pkdd2*b2*fd*k1**2*s**2 + 42*Pkdd2*b2*fdd*k1**2*s**2 - 70*Pkdd2*bd1**2*k1**2*s*(2*K - 1)*(3*s - 2) + 21*Pkdd2*bd1*f**2*k1**2*(2*s - 1) - 14*Pkdd2*bd1*k1**2*(20*g2*(2*s**2 - 2*s + 1) + s*(2*s - 1)*(3*fd*(4*C - 2*K - 3) - 20*gd2)) + 84*Pkdd2*bd2*fd*k1**2*s**2 + 140*Pkdd2*bdd1*g2*k1**2*(2*s**2 - 2*s + 1) - 60*Pkdd2*fd**2*k1**2*s**2 + 308*Pkdd2*fd*g2*k1**2*s**2 - 280*Pkdd2*fd*g2*k1**2*s + 140*Pkdd2*fd*g2*k1**2 - 168*Pkdd2*fd*gd2*k1**2*s**2 - 84*Pkdd2*fdd*g2*k1**2*s**2 + f*(7*Pkdd2*k1**2*(6*bd1**2*s*(3*s - 2) + bd1*(24*C*(2*s**2 - 2*s + 1) - 4*K*(11*s**2 - 6*s + 3) - 36*s**2 + 46*s - 23) - 3*bdd1*(4*C - 2*K - 3)*(2*s**2 - 2*s + 1) + s**2*(-12*bd2 + 6*bdd2 + 44*gd2 - 12*gdd2)) + fd*(Pk2*(256*C - 128)*(2*r**2 - 2*r + 1) + 3*Pkdd2*k1**2*(-4*C*(34*s**2 - 14*s + 7) + 14*K*(2*s**2 - 2*s + 1) + 68*s**2 - 42*s + 21)) + fdd*(4 - 8*C)*(Pk2*(4*r**2 - 4*r + 2) - 15*Pkdd2*k1**2*s**2))) + 2*D1*(Dd*(14*Pkdd2*k1**2*(4*s - 1)*(10*bd1*g2*(2*s - 1) + 3*fd*s*(b2 - 2*g2)) + f**2*(Pk2*(256*C - 128)*(2*r**2 - 2*r + 1) - Pkdd2*k1**2*(102*C - 21*K - 51)*(4*s**2 - 2*s + 1)) + f*(-7*Pkdd2*k1**2*(6*b2*(4*s**2 - 2*s + 1) + 3*bd1*(4*C - 2*K - 3)*(8*s**2 - 6*s + 1) - 24*bd2*s**2 + 6*bd2*s - 88*g2*s**2 + 44*g2*s - 22*g2 + 48*gd2*s**2 - 12*gd2*s) + fd*(4 - 8*C)*(4*Pk2*(1 - 2*r)**2 + 15*Pkdd2*k1**2*s*(1 - 4*s)))) + Ddd*f*(Pkdd2*k1**2*(21*b2 - 42*g2)*(4*s**2 - 2*s + 1) - f*(2*C - 1)*(8*Pk2*(2*r**2 - 2*r + 1) - 15*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 4*Dd**2*f*(Pkdd2*k1**2*s*(63*b2 - 126*g2)*(2*s - 1) - f*(2*C - 1)*(4*Pk2*(6*r**2 - 6*r + 1) + 45*Pkdd2*k1**2*s*(1 - 2*s)))))/(630*d**2*k1*k3**2) + D1**2*Pk3*ct**3*(D1*f*(4*D1*Pk2*bdd1*f*r*(r + s*(24*C - 12)) + 42*D1*Pkdd2*bd1**2*k1**2*s*(s - 1) + bd1*(D1*(8*Pk2*fd*(2*r**2 + r*(48*C*s - 12*C - 24*s + 5) + s*(6 - 12*C)) + f*(-32*Pk2*r*(6*C*s + 2*r - 3*s) + 21*Pkdd2*k1**2*s**2)) + 32*Dd*Pk2*f*(3*C*r*(8*s - 1) + r**2 - 12*r*s + r + s*(3 - 6*C)))) - 7*Pkdd2*b1**3*k1**2*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) - 7*Pkdd2*b1**2*k1**2*(-D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 6*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s - 3*D1**2*f*fd + D1**2*fd*s**2 + 10*D1**2*fd*s - 5*D1**2*fd - 3*D1**2*fdd*s**2 - 12*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 4*D1*Dd*f*s**2 - 2*D1*Dd*f*s + D1*Dd*f - 24*D1*Dd*fd*s**2 + 6*D1*Dd*fd*s - 12*D1*Ddd*f*s**2 + 6*D1*Ddd*f*s - 3*D1*Ddd*f + 2*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) - 36*Dd**2*f*s**2 + 18*Dd**2*f*s) + b1*(D1**2*(8*Pk2*fd**2*(12*C*(r*(2*s - 1) - s + 1) + r**2 - 12*r*s + 5*r + 6*s - 6) + 70*Pkdd2*bd1**2*k1**2*s*(3*s - 2) + 42*Pkdd2*bd1*f**2*k1**2*s**2 + 42*Pkdd2*bd1*fd*k1**2*s*(2*s - 1) + f*(4*Pk2*fdd*(-24*C*s + 2*r**2 + 2*r*(24*C*s - 12*C - 12*s + 5) + 12*s + 1) + 7*Pkdd2*k1**2*(6*bd1**2*s*(3*s - 2) - 2*bd1*(s**2 - 6*s + 3) + 3*bdd1*(2*s**2 - 2*s + 1)) + fd*(-32*Pk2*(-6*C*s + 4*r**2 + r*(12*C*s - 6*C - 6*s - 1) + 3*s + 2) + 21*Pkdd2*k1**2*(2*s**2 - 2*s + 1)))) + D1*f*(Dd*(32*Pk2*fd*(2*r - 1)*(3*C*(8*s - 3) + r - 12*s + 4) + 42*Pkdd2*bd1*k1**2*(8*s**2 - 6*s + 1) + f*(-32*Pk2*(-12*C*s + 8*r**2 + r*(24*C*s - 6*C - 12*s - 5) + 6*s + 4) + 21*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 8*Ddd*Pk2*f*(-24*C*s + 2*r**2 + 4*r*(12*C*s - 3*C - 6*s + 1) + 12*s + 1)) + 8*Dd**2*Pk2*f**2*(12*C*(3*r*(4*s - 1) - 6*s + 2) + 6*r**2 + r*(12 - 72*s) + 36*s - 11)))/(210*d**2*k1*k2) - D1**2*Pk3*ct**2*k1**2*st**4*(-1056*C*D1**2*Pk2*bdd1*f**2*r*s - 1584*C*D1**2*Pk2*bdd1*f**2*s**2 + 1056*C*D1**2*Pk2*bdd1*f**2*s - 528*C*D1**2*Pk2*bdd1*f**2 - 26400*C*D1**2*Pk2*f**2*fd*r*s + 8800*C*D1**2*Pk2*f**2*fd*r + 3432*C*D1**2*Pk2*f**2*fd*s**2 + 6512*C*D1**2*Pk2*f**2*fd*s + 1144*C*D1**2*Pk2*f**2*fd + 17952*C*D1**2*Pk2*f**2*fdd*r*s - 5984*C*D1**2*Pk2*f**2*fdd*r + 1848*C*D1**2*Pk2*f**2*fdd*s**2 - 7216*C*D1**2*Pk2*f**2*fdd*s + 616*C*D1**2*Pk2*f**2*fdd + 35904*C*D1**2*Pk2*f*fd**2*r*s - 11968*C*D1**2*Pk2*f*fd**2*r + 3696*C*D1**2*Pk2*f*fd**2*s**2 - 14432*C*D1**2*Pk2*f*fd**2*s + 5984*C*D1**2*Pk2*f*fd**2 + 132*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 88*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 44*C*D1**2*Pkdd2*f**2*fd*k1**2 - 66*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 44*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 22*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 132*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 88*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 35200*C*D1*Dd*Pk2*f**3*r*s + 8800*C*D1*Dd*Pk2*f**3*r + 4576*C*D1*Dd*Pk2*f**3*s**2 + 15312*C*D1*Dd*Pk2*f**3*s + 1144*C*D1*Dd*Pk2*f**3 + 143616*C*D1*Dd*Pk2*f**2*fd*r*s - 41888*C*D1*Dd*Pk2*f**2*fd*r + 14784*C*D1*Dd*Pk2*f**2*fd*s**2 - 68464*C*D1*Dd*Pk2*f**2*fd*s + 19184*C*D1*Dd*Pk2*f**2*fd + 176*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 88*C*D1*Dd*Pkdd2*f**3*k1**2*s + 44*C*D1*Dd*Pkdd2*f**3*k1**2 - 528*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 308*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 44*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 23936*C*D1*Ddd*Pk2*f**3*r*s - 5984*C*D1*Ddd*Pk2*f**3*r + 2464*C*D1*Ddd*Pk2*f**3*s**2 - 13200*C*D1*Ddd*Pk2*f**3*s + 616*C*D1*Ddd*Pk2*f**3 - 88*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 44*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 22*C*D1*Ddd*Pkdd2*f**3*k1**2 + 71808*C*Dd**2*Pk2*f**3*r*s - 17952*C*Dd**2*Pk2*f**3*r + 7392*C*Dd**2*Pk2*f**3*s**2 - 39600*C*Dd**2*Pk2*f**3*s + 11968*C*Dd**2*Pk2*f**3 - 264*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 132*C*Dd**2*Pkdd2*f**3*k1**2*s + 8976*D1**2*K*Pk2*bdd1*f**2*r*s + 5676*D1**2*K*Pk2*bdd1*f**2*s**2 - 8976*D1**2*K*Pk2*bdd1*f**2*s - 33*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 3696*D1**2*Pk2*bd1**2*f*s*(K - 1)*(2*r + 3*s - 2) - 10560*D1**2*Pk2*bdd1*f**3*r*s - 7920*D1**2*Pk2*bdd1*f**3*s**2 + 10560*D1**2*Pk2*bdd1*f**3*s - 1320*D1**2*Pk2*bdd1*f**3 - 15840*D1**2*Pk2*bdd1*f**2*r*s - 14652*D1**2*Pk2*bdd1*f**2*s**2 + 15840*D1**2*Pk2*bdd1*f**2*s + 528*D1**2*Pk2*bdd1*f**2 + 7392*D1**2*Pk2*bdd1*f*g2*r*s + 11088*D1**2*Pk2*bdd1*f*g2*s**2 - 7392*D1**2*Pk2*bdd1*f*g2*s + 3696*D1**2*Pk2*bdd1*f*g2 - 47520*D1**2*Pk2*f**3*fd*r*s + 11880*D1**2*Pk2*f**3*fd*r - 44880*D1**2*Pk2*f**3*fd*s**2 + 46200*D1**2*Pk2*f**3*fd*s - 11220*D1**2*Pk2*f**3*fd + 47520*D1**2*Pk2*f**3*fdd*r*s - 11880*D1**2*Pk2*f**3*fdd*r + 34320*D1**2*Pk2*f**3*fdd*s**2 - 40920*D1**2*Pk2*f**3*fdd*s + 8580*D1**2*Pk2*f**3*fdd + 142560*D1**2*Pk2*f**2*fd**2*r*s - 35640*D1**2*Pk2*f**2*fd**2*r + 102960*D1**2*Pk2*f**2*fd**2*s**2 - 122760*D1**2*Pk2*f**2*fd**2*s + 23760*D1**2*Pk2*f**2*fd**2 + 40656*D1**2*Pk2*f**2*fd*r*s - 13552*D1**2*Pk2*f**2*fd*r + 16104*D1**2*Pk2*f**2*fd*s**2 - 24288*D1**2*Pk2*f**2*fd*s + 5368*D1**2*Pk2*f**2*fd - 25872*D1**2*Pk2*f**2*fdd*r*s + 8624*D1**2*Pk2*f**2*fdd*r - 12408*D1**2*Pk2*f**2*fdd*s**2 + 16896*D1**2*Pk2*f**2*fdd*s - 4136*D1**2*Pk2*f**2*fdd + 28512*D1**2*Pk2*f**2*gd2*r*s + 6072*D1**2*Pk2*f**2*gd2*s**2 - 28512*D1**2*Pk2*f**2*gd2*s - 17952*D1**2*Pk2*f**2*gdd2*r*s - 11352*D1**2*Pk2*f**2*gdd2*s**2 + 17952*D1**2*Pk2*f**2*gdd2*s - 51744*D1**2*Pk2*f*fd**2*r*s + 17248*D1**2*Pk2*f*fd**2*r - 24816*D1**2*Pk2*f*fd**2*s**2 + 33792*D1**2*Pk2*f*fd**2*s - 8624*D1**2*Pk2*f*fd**2 + 57024*D1**2*Pk2*f*fd*g2*r*s - 28512*D1**2*Pk2*f*fd*g2*r + 12144*D1**2*Pk2*f*fd*g2*s**2 - 12144*D1**2*Pk2*f*fd*g2*s + 6072*D1**2*Pk2*f*fd*g2 - 71808*D1**2*Pk2*f*fd*gd2*r*s + 17952*D1**2*Pk2*f*fd*gd2*r - 45408*D1**2*Pk2*f*fd*gd2*s**2 + 58608*D1**2*Pk2*f*fd*gd2*s - 17952*D1**2*Pk2*f*fd*gd2 - 35904*D1**2*Pk2*f*fdd*g2*r*s + 17952*D1**2*Pk2*f*fdd*g2*r - 22704*D1**2*Pk2*f*fdd*g2*s**2 + 22704*D1**2*Pk2*f*fdd*g2*s - 11352*D1**2*Pk2*f*fdd*g2 - 35904*D1**2*Pk2*fd**2*g2*r*s + 17952*D1**2*Pk2*fd**2*g2*r - 22704*D1**2*Pk2*fd**2*g2*s**2 + 22704*D1**2*Pk2*fd**2*g2*s + 33*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 1800*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 900*D1**2*Pkdd2*f**3*fd*k1**2*s + 450*D1**2*Pkdd2*f**3*fd*k1**2 - 900*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 450*D1**2*Pkdd2*f**3*fdd*k1**2*s - 225*D1**2*Pkdd2*f**3*fdd*k1**2 - 2700*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 1350*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 132*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 88*D1**2*Pkdd2*f**2*fd*k1**2*s - 44*D1**2*Pkdd2*f**2*fd*k1**2 + 66*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 44*D1**2*Pkdd2*f**2*fdd*k1**2*s + 22*D1**2*Pkdd2*f**2*fdd*k1**2 - 132*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 66*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 132*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 88*D1**2*Pkdd2*f*fd**2*k1**2*s - 264*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 264*D1**2*Pkdd2*f*fd*g2*k1**2*s - 132*D1**2*Pkdd2*f*fd*g2*k1**2 + 264*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 132*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 132*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 132*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 66*D1**2*Pkdd2*f*fdd*g2*k1**2 + 132*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 132*D1**2*Pkdd2*fd**2*g2*k1**2*s - 47520*D1*Dd*Pk2*f**4*r*s + 11880*D1*Dd*Pk2*f**4*r - 44880*D1*Dd*Pk2*f**4*s**2 + 46200*D1*Dd*Pk2*f**4*s - 11220*D1*Dd*Pk2*f**4 + 380160*D1*Dd*Pk2*f**3*fd*r*s - 95040*D1*Dd*Pk2*f**3*fd*r + 274560*D1*Dd*Pk2*f**3*fd*s**2 - 327360*D1*Dd*Pk2*f**3*fd*s + 64680*D1*Dd*Pk2*f**3*fd + 54208*D1*Dd*Pk2*f**3*r*s - 13552*D1*Dd*Pk2*f**3*r + 21472*D1*Dd*Pk2*f**3*s**2 - 37840*D1*Dd*Pk2*f**3*s + 5368*D1*Dd*Pk2*f**3 - 206976*D1*Dd*Pk2*f**2*fd*r*s + 60368*D1*Dd*Pk2*f**2*fd*r - 99264*D1*Dd*Pk2*f**2*fd*s**2 + 144144*D1*Dd*Pk2*f**2*fd*s - 34144*D1*Dd*Pk2*f**2*fd + 114048*D1*Dd*Pk2*f**2*g2*r*s - 28512*D1*Dd*Pk2*f**2*g2*r + 24288*D1*Dd*Pk2*f**2*g2*s**2 - 69168*D1*Dd*Pk2*f**2*g2*s + 6072*D1*Dd*Pk2*f**2*g2 - 143616*D1*Dd*Pk2*f**2*gd2*r*s + 17952*D1*Dd*Pk2*f**2*gd2*r - 90816*D1*Dd*Pk2*f**2*gd2*s**2 + 130416*D1*Dd*Pk2*f**2*gd2*s - 17952*D1*Dd*Pk2*f**2*gd2 - 287232*D1*Dd*Pk2*f*fd*g2*r*s + 107712*D1*Dd*Pk2*f*fd*g2*r - 181632*D1*Dd*Pk2*f*fd*g2*s**2 + 208032*D1*Dd*Pk2*f*fd*g2*s - 58608*D1*Dd*Pk2*f*fd*g2 + 1800*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 900*D1*Dd*Pkdd2*f**4*k1**2*s + 450*D1*Dd*Pkdd2*f**4*k1**2 - 7200*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 3600*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 450*D1*Dd*Pkdd2*f**3*fd*k1**2 - 176*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 88*D1*Dd*Pkdd2*f**3*k1**2*s - 44*D1*Dd*Pkdd2*f**3*k1**2 + 528*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 308*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 44*D1*Dd*Pkdd2*f**2*fd*k1**2 - 528*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 264*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 132*D1*Dd*Pkdd2*f**2*g2*k1**2 + 528*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 132*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 1056*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 792*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 132*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 47520*D1*Ddd*Pk2*f**4*r*s - 11880*D1*Ddd*Pk2*f**4*r + 34320*D1*Ddd*Pk2*f**4*s**2 - 40920*D1*Ddd*Pk2*f**4*s + 8580*D1*Ddd*Pk2*f**4 - 34496*D1*Ddd*Pk2*f**3*r*s + 8624*D1*Ddd*Pk2*f**3*r - 16544*D1*Ddd*Pk2*f**3*s**2 + 25520*D1*Ddd*Pk2*f**3*s - 4136*D1*Ddd*Pk2*f**3 - 71808*D1*Ddd*Pk2*f**2*g2*r*s + 17952*D1*Ddd*Pk2*f**2*g2*r - 45408*D1*Ddd*Pk2*f**2*g2*s**2 + 58608*D1*Ddd*Pk2*f**2*g2*s - 11352*D1*Ddd*Pk2*f**2*g2 - 900*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 450*D1*Ddd*Pkdd2*f**4*k1**2*s - 225*D1*Ddd*Pkdd2*f**4*k1**2 + 88*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 44*D1*Ddd*Pkdd2*f**3*k1**2*s + 22*D1*Ddd*Pkdd2*f**3*k1**2 + 264*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 132*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 66*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 66*D1*bd1*(D1*(40*Pk2*f**3*(5*s**2 + s*(7*r - 7) + 1) + 112*Pk2*fd*g2*(r*(2*s - 1) + s*(3*s - 3)) + f**2*(2*Pk2*(8*C*(3*s**2 + s*(2*r - 2) + 1) - 108*K*r*s - 23*K*s**2 + 108*K*s - 20*fd*(24*r*s - 4*r + 18*s**2 - 22*s + 3) + 184*r*s + 131*s**2 - 184*s - 8) + Pkdd2*k1**2*s**2*(K - 1)) + f*(-112*Pk2*(3*g2*s**2 + 2*g2*s*(r - 1) + g2 + gd2*s*(-2*r - 3*s + 2)) + fd*(4*Pk2*(-24*C*s**2 + 20*C*s + K*(34*r*(4*s - 1) + 86*s**2 - 111*s + 34) - r*(4*C + 60)*(4*s - 1) - 222*s**2 + 231*s - 64) + Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1)))) + Dd*f*(-80*Pk2*f**2*(2*r*(8*s - 1) + 12*s**2 - 15*s + 2) + 112*Pk2*g2*(r*(8*s - 1) + 12*s**2 - 9*s + 1) + f*(-4*Pk2*(4*C*(r*(8*s - 1) + 12*s**2 - 9*s + 1) + K*(-272*r*s + 34*r - 172*s**2 + 247*s - 34) + 480*r*s - 60*r + 444*s**2 - 471*s + 60) + Pkdd2*k1**2*s*(-4*K*s + K + 4*s - 1)))) + 142560*Dd**2*Pk2*f**4*r*s - 35640*Dd**2*Pk2*f**4*r + 102960*Dd**2*Pk2*f**4*s**2 - 122760*Dd**2*Pk2*f**4*s + 23760*Dd**2*Pk2*f**4 - 103488*Dd**2*Pk2*f**3*r*s + 25872*Dd**2*Pk2*f**3*r - 49632*Dd**2*Pk2*f**3*s**2 + 76560*Dd**2*Pk2*f**3*s - 17248*Dd**2*Pk2*f**3 - 215424*Dd**2*Pk2*f**2*g2*r*s + 53856*Dd**2*Pk2*f**2*g2*r - 136224*Dd**2*Pk2*f**2*g2*s**2 + 175824*Dd**2*Pk2*f**2*g2*s - 35904*Dd**2*Pk2*f**2*g2 - 2700*Dd**2*Pkdd2*f**4*k1**2*s**2 + 1350*Dd**2*Pkdd2*f**4*k1**2*s + 264*Dd**2*Pkdd2*f**3*k1**2*s**2 - 132*Dd**2*Pkdd2*f**3*k1**2*s + 792*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 396*Dd**2*Pkdd2*f**2*g2*k1**2*s + 1848*Pk2*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + D1*(2*Dd*(f*(8*r*s - 2*r + 12*s**2 - 10*s + 3) + fd*(-8*r*s + 5*r - 12*s**2 + 13*s - 4)) + Ddd*f*(r*(2 - 8*s) - 12*s**2 + 10*s - 3)) - 2*Dd**2*f*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2)) + 33*b1*(128*C*D1**2*Pk2*f*fd*r*s - 64*C*D1**2*Pk2*f*fd*r + 192*C*D1**2*Pk2*f*fd*s**2 - 192*C*D1**2*Pk2*f*fd*s + 64*C*D1**2*Pk2*f*fd - 64*C*D1**2*Pk2*f*fdd*r*s + 32*C*D1**2*Pk2*f*fdd*r - 96*C*D1**2*Pk2*f*fdd*s**2 + 96*C*D1**2*Pk2*f*fdd*s - 32*C*D1**2*Pk2*f*fdd - 64*C*D1**2*Pk2*fd**2*r*s + 32*C*D1**2*Pk2*fd**2*r - 96*C*D1**2*Pk2*fd**2*s**2 + 96*C*D1**2*Pk2*fd**2*s - 32*C*D1**2*Pk2*fd**2 + 256*C*D1*Dd*Pk2*f**2*r*s - 64*C*D1*Dd*Pk2*f**2*r + 384*C*D1*Dd*Pk2*f**2*s**2 - 320*C*D1*Dd*Pk2*f**2*s + 96*C*D1*Dd*Pk2*f**2 - 512*C*D1*Dd*Pk2*f*fd*r*s + 192*C*D1*Dd*Pk2*f*fd*r - 768*C*D1*Dd*Pk2*f*fd*s**2 + 704*C*D1*Dd*Pk2*f*fd*s - 160*C*D1*Dd*Pk2*f*fd - 128*C*D1*Ddd*Pk2*f**2*r*s + 32*C*D1*Ddd*Pk2*f**2*r - 192*C*D1*Ddd*Pk2*f**2*s**2 + 160*C*D1*Ddd*Pk2*f**2*s - 48*C*D1*Ddd*Pk2*f**2 - 384*C*Dd**2*Pk2*f**2*r*s + 96*C*Dd**2*Pk2*f**2*r - 576*C*Dd**2*Pk2*f**2*s**2 + 480*C*Dd**2*Pk2*f**2*s - 64*C*Dd**2*Pk2*f**2 - 864*D1**2*K*Pk2*f*fd*r*s + 432*D1**2*K*Pk2*f*fd*r - 184*D1**2*K*Pk2*f*fd*s**2 + 184*D1**2*K*Pk2*f*fd*s - 92*D1**2*K*Pk2*f*fd + 544*D1**2*K*Pk2*f*fdd*r*s - 272*D1**2*K*Pk2*f*fdd*r + 344*D1**2*K*Pk2*f*fdd*s**2 - 344*D1**2*K*Pk2*f*fdd*s + 172*D1**2*K*Pk2*f*fdd + 544*D1**2*K*Pk2*fd**2*r*s - 272*D1**2*K*Pk2*fd**2*r + 344*D1**2*K*Pk2*fd**2*s**2 - 344*D1**2*K*Pk2*fd**2*s + 4*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 4*D1**2*K*Pkdd2*f*fd*k1**2*s + 2*D1**2*K*Pkdd2*f*fd*k1**2 - 2*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 2*D1**2*K*Pkdd2*f*fdd*k1**2*s - D1**2*K*Pkdd2*f*fdd*k1**2 - 2*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 2*D1**2*K*Pkdd2*fd**2*k1**2*s - 56*D1**2*Pk2*bdd1*f*(K - 1)*(6*s**2 + s*(4*r - 4) + 1) + 1680*D1**2*Pk2*f**2*fd*r*s - 560*D1**2*Pk2*f**2*fd*r + 1200*D1**2*Pk2*f**2*fd*s**2 - 1360*D1**2*Pk2*f**2*fd*s + 320*D1**2*Pk2*f**2*fd - 960*D1**2*Pk2*f**2*fdd*r*s + 320*D1**2*Pk2*f**2*fdd*r - 720*D1**2*Pk2*f**2*fdd*s**2 + 800*D1**2*Pk2*f**2*fdd*s - 200*D1**2*Pk2*f**2*fdd - 1920*D1**2*Pk2*f*fd**2*r*s + 640*D1**2*Pk2*f*fd**2*r - 1440*D1**2*Pk2*f*fd**2*s**2 + 1600*D1**2*Pk2*f*fd**2*s - 400*D1**2*Pk2*f*fd**2 + 1472*D1**2*Pk2*f*fd*r*s - 736*D1**2*Pk2*f*fd*r + 1048*D1**2*Pk2*f*fd*s**2 - 1048*D1**2*Pk2*f*fd*s + 556*D1**2*Pk2*f*fd - 960*D1**2*Pk2*f*fdd*r*s + 480*D1**2*Pk2*f*fdd*r - 888*D1**2*Pk2*f*fdd*s**2 + 888*D1**2*Pk2*f*fdd*s - 460*D1**2*Pk2*f*fdd - 448*D1**2*Pk2*f*gd2*r*s - 672*D1**2*Pk2*f*gd2*s**2 + 448*D1**2*Pk2*f*gd2*s + 224*D1**2*Pk2*f*gdd2*r*s + 336*D1**2*Pk2*f*gdd2*s**2 - 224*D1**2*Pk2*f*gdd2*s - 960*D1**2*Pk2*fd**2*r*s + 480*D1**2*Pk2*fd**2*r - 888*D1**2*Pk2*fd**2*s**2 + 888*D1**2*Pk2*fd**2*s + 32*D1**2*Pk2*fd**2 - 448*D1**2*Pk2*fd*g2*r*s + 448*D1**2*Pk2*fd*g2*r - 672*D1**2*Pk2*fd*g2*s**2 + 896*D1**2*Pk2*fd*g2*s - 448*D1**2*Pk2*fd*g2 + 448*D1**2*Pk2*fd*gd2*r*s - 224*D1**2*Pk2*fd*gd2*r + 672*D1**2*Pk2*fd*gd2*s**2 - 672*D1**2*Pk2*fd*gd2*s + 224*D1**2*Pk2*fd*gd2 + 224*D1**2*Pk2*fdd*g2*r*s - 224*D1**2*Pk2*fdd*g2*r + 336*D1**2*Pk2*fdd*g2*s**2 - 448*D1**2*Pk2*fdd*g2*s + 224*D1**2*Pk2*fdd*g2 - 4*D1**2*Pkdd2*f*fd*k1**2*s**2 + 4*D1**2*Pkdd2*f*fd*k1**2*s - 2*D1**2*Pkdd2*f*fd*k1**2 + 2*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 2*D1**2*Pkdd2*f*fdd*k1**2*s + D1**2*Pkdd2*f*fdd*k1**2 + 2*D1**2*Pkdd2*fd**2*k1**2*s**2 - 2*D1**2*Pkdd2*fd**2*k1**2*s - 1728*D1*Dd*K*Pk2*f**2*r*s + 432*D1*Dd*K*Pk2*f**2*r - 368*D1*Dd*K*Pk2*f**2*s**2 + 1048*D1*Dd*K*Pk2*f**2*s - 92*D1*Dd*K*Pk2*f**2 + 4352*D1*Dd*K*Pk2*f*fd*r*s - 1632*D1*Dd*K*Pk2*f*fd*r + 2752*D1*Dd*K*Pk2*f*fd*s**2 - 3152*D1*Dd*K*Pk2*f*fd*s + 888*D1*Dd*K*Pk2*f*fd + 8*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 4*D1*Dd*K*Pkdd2*f**2*k1**2*s + 2*D1*Dd*K*Pkdd2*f**2*k1**2 - 16*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 2*D1*Dd*K*Pkdd2*f*fd*k1**2 + 2240*D1*Dd*Pk2*f**3*r*s - 560*D1*Dd*Pk2*f**3*r + 1600*D1*Dd*Pk2*f**3*s**2 - 1920*D1*Dd*Pk2*f**3*s + 400*D1*Dd*Pk2*f**3 - 7680*D1*Dd*Pk2*f**2*fd*r*s + 2240*D1*Dd*Pk2*f**2*fd*r - 5760*D1*Dd*Pk2*f**2*fd*s**2 + 6560*D1*Dd*Pk2*f**2*fd*s - 1440*D1*Dd*Pk2*f**2*fd + 2944*D1*Dd*Pk2*f**2*r*s - 736*D1*Dd*Pk2*f**2*r + 2096*D1*Dd*Pk2*f**2*s**2 - 2520*D1*Dd*Pk2*f**2*s + 524*D1*Dd*Pk2*f**2 - 7680*D1*Dd*Pk2*f*fd*r*s + 2880*D1*Dd*Pk2*f*fd*r - 7104*D1*Dd*Pk2*f*fd*s**2 + 7248*D1*Dd*Pk2*f*fd*s - 1848*D1*Dd*Pk2*f*fd - 1792*D1*Dd*Pk2*f*g2*r*s + 448*D1*Dd*Pk2*f*g2*r - 2688*D1*Dd*Pk2*f*g2*s**2 + 2240*D1*Dd*Pk2*f*g2*s - 672*D1*Dd*Pk2*f*g2 + 1792*D1*Dd*Pk2*f*gd2*r*s - 224*D1*Dd*Pk2*f*gd2*r + 2688*D1*Dd*Pk2*f*gd2*s**2 - 2016*D1*Dd*Pk2*f*gd2*s + 224*D1*Dd*Pk2*f*gd2 + 1792*D1*Dd*Pk2*fd*g2*r*s - 1120*D1*Dd*Pk2*fd*g2*r + 2688*D1*Dd*Pk2*fd*g2*s**2 - 2912*D1*Dd*Pk2*fd*g2*s + 896*D1*Dd*Pk2*fd*g2 - 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 4*D1*Dd*Pkdd2*f**2*k1**2*s - 2*D1*Dd*Pkdd2*f**2*k1**2 + 16*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 12*D1*Dd*Pkdd2*f*fd*k1**2*s + 2*D1*Dd*Pkdd2*f*fd*k1**2 + 1088*D1*Ddd*K*Pk2*f**2*r*s - 272*D1*Ddd*K*Pk2*f**2*r + 688*D1*Ddd*K*Pk2*f**2*s**2 - 888*D1*Ddd*K*Pk2*f**2*s + 172*D1*Ddd*K*Pk2*f**2 - 4*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 2*D1*Ddd*K*Pkdd2*f**2*k1**2*s - D1*Ddd*K*Pkdd2*f**2*k1**2 - 1280*D1*Ddd*Pk2*f**3*r*s + 320*D1*Ddd*Pk2*f**3*r - 960*D1*Ddd*Pk2*f**3*s**2 + 1120*D1*Ddd*Pk2*f**3*s - 240*D1*Ddd*Pk2*f**3 - 1920*D1*Ddd*Pk2*f**2*r*s + 480*D1*Ddd*Pk2*f**2*r - 1776*D1*Ddd*Pk2*f**2*s**2 + 1848*D1*Ddd*Pk2*f**2*s - 444*D1*Ddd*Pk2*f**2 + 896*D1*Ddd*Pk2*f*g2*r*s - 224*D1*Ddd*Pk2*f*g2*r + 1344*D1*Ddd*Pk2*f*g2*s**2 - 1120*D1*Ddd*Pk2*f*g2*s + 336*D1*Ddd*Pk2*f*g2 + 4*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 2*D1*Ddd*Pkdd2*f**2*k1**2*s + D1*Ddd*Pkdd2*f**2*k1**2 + 112*D1*Pk2*bd1*(K - 1)*(D1*(f*(6*s**2 + s*(4*r - 4) + 1) + fd*(r*(2 - 4*s) - 6*s**2 + 6*s - 1)) - 2*Dd*f*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) + 3264*Dd**2*K*Pk2*f**2*r*s - 816*Dd**2*K*Pk2*f**2*r + 2064*Dd**2*K*Pk2*f**2*s**2 - 2664*Dd**2*K*Pk2*f**2*s + 544*Dd**2*K*Pk2*f**2 - 12*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 6*Dd**2*K*Pkdd2*f**2*k1**2*s - 3840*Dd**2*Pk2*f**3*r*s + 960*Dd**2*Pk2*f**3*r - 2880*Dd**2*Pk2*f**3*s**2 + 3360*Dd**2*Pk2*f**3*s - 640*Dd**2*Pk2*f**3 - 5760*Dd**2*Pk2*f**2*r*s + 1440*Dd**2*Pk2*f**2*r - 5328*Dd**2*Pk2*f**2*s**2 + 5544*Dd**2*Pk2*f**2*s - 960*Dd**2*Pk2*f**2 + 2688*Dd**2*Pk2*f*g2*r*s - 672*Dd**2*Pk2*f*g2*r + 4032*Dd**2*Pk2*f*g2*s**2 - 3360*Dd**2*Pk2*f*g2*s + 448*Dd**2*Pk2*f*g2 + 12*Dd**2*Pkdd2*f**2*k1**2*s**2 - 6*Dd**2*Pkdd2*f**2*k1**2*s))/(2310*d**2*k3**4) + D1**2*Pk3*ct**2*k1**2*st**2*(-3108*C*D1**2*Pk2*f**2*fd*r**2 - 4104*C*D1**2*Pk2*f**2*fd*r*s + 3440*C*D1**2*Pk2*f**2*fd*r + 16704*C*D1**2*Pk2*f**2*fd*s**2 - 9768*C*D1**2*Pk2*f**2*fd*s + 4532*C*D1**2*Pk2*f**2*fd + 3012*C*D1**2*Pk2*f**2*fdd*r**2 + 2808*C*D1**2*Pk2*f**2*fdd*r*s - 2944*C*D1**2*Pk2*f**2*fdd*r - 11808*C*D1**2*Pk2*f**2*fdd*s**2 + 6936*C*D1**2*Pk2*f**2*fdd*s - 2932*C*D1**2*Pk2*f**2*fdd + 6024*C*D1**2*Pk2*f*fd**2*r**2 + 5616*C*D1**2*Pk2*f*fd**2*r*s - 5888*C*D1**2*Pk2*f*fd**2*r - 23616*C*D1**2*Pk2*f*fd**2*s**2 + 13872*C*D1**2*Pk2*f*fd**2*s + 936*C*D1**2*Pk2*f*fd**2 + 54*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 36*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 18*C*D1**2*Pkdd2*f**2*fd*k1**2 - 4144*C*D1*Dd*Pk2*f**3*r**2 - 5472*C*D1*Dd*Pk2*f**3*r*s + 5512*C*D1*Dd*Pk2*f**3*r + 22272*C*D1*Dd*Pk2*f**3*s**2 - 8400*C*D1*Dd*Pk2*f**3*s + 3496*C*D1*Dd*Pk2*f**3 + 24096*C*D1*Dd*Pk2*f**2*fd*r**2 + 22464*C*D1*Dd*Pk2*f**2*fd*r*s - 26632*C*D1*Dd*Pk2*f**2*fd*r - 94464*C*D1*Dd*Pk2*f**2*fd*s**2 + 45744*C*D1*Dd*Pk2*f**2*fd*s - 1048*C*D1*Dd*Pk2*f**2*fd + 72*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 36*C*D1*Dd*Pkdd2*f**3*k1**2*s + 18*C*D1*Dd*Pkdd2*f**3*k1**2 + 4016*C*D1*Ddd*Pk2*f**3*r**2 + 3744*C*D1*Ddd*Pk2*f**3*r*s - 4952*C*D1*Ddd*Pk2*f**3*r - 15744*C*D1*Ddd*Pk2*f**3*s**2 + 6000*C*D1*Ddd*Pk2*f**3*s - 1928*C*D1*Ddd*Pk2*f**3 + 12048*C*Dd**2*Pk2*f**3*r**2 + 11232*C*Dd**2*Pk2*f**3*r*s - 14856*C*Dd**2*Pk2*f**3*r - 47232*C*Dd**2*Pk2*f**3*s**2 + 18000*C*Dd**2*Pk2*f**3*s + 3880*C*Dd**2*Pk2*f**3 + 1584*D1**2*Pk2*bd2*f**2*r*s + 1584*D1**2*Pk2*bd2*f**2*s**2 - 1584*D1**2*Pk2*bd2*f**2*s - 5184*D1**2*Pk2*bd2*f*fd*r*s + 1296*D1**2*Pk2*bd2*f*fd*r - 5184*D1**2*Pk2*bd2*f*fd*s**2 + 5184*D1**2*Pk2*bd2*f*fd*s - 1296*D1**2*Pk2*bd2*f*fd - 1296*D1**2*Pk2*bdd2*f**2*r*s - 1296*D1**2*Pk2*bdd2*f**2*s**2 + 1296*D1**2*Pk2*bdd2*f**2*s - 7776*D1**2*Pk2*f**3*fd*r**2 - 19440*D1**2*Pk2*f**3*fd*r*s + 12636*D1**2*Pk2*f**3*fd*r - 6480*D1**2*Pk2*f**3*fd*s**2 + 12960*D1**2*Pk2*f**3*fd*s - 5508*D1**2*Pk2*f**3*fd + 7776*D1**2*Pk2*f**3*fdd*r**2 + 19440*D1**2*Pk2*f**3*fdd*r*s - 12636*D1**2*Pk2*f**3*fdd*r + 6480*D1**2*Pk2*f**3*fdd*s**2 - 12960*D1**2*Pk2*f**3*fdd*s + 5508*D1**2*Pk2*f**3*fdd + 23328*D1**2*Pk2*f**2*fd**2*r**2 + 58320*D1**2*Pk2*f**2*fd**2*r*s - 37908*D1**2*Pk2*f**2*fd**2*r + 19440*D1**2*Pk2*f**2*fd**2*s**2 - 38880*D1**2*Pk2*f**2*fd**2*s + 13608*D1**2*Pk2*f**2*fd**2 + 6888*D1**2*Pk2*f**2*fd*r**2 + 18792*D1**2*Pk2*f**2*fd*r*s - 10856*D1**2*Pk2*f**2*fd*r - 3600*D1**2*Pk2*f**2*fd*s**2 - 3864*D1**2*Pk2*f**2*fd*s + 1096*D1**2*Pk2*f**2*fd - 6576*D1**2*Pk2*f**2*fdd*r**2 - 14472*D1**2*Pk2*f**2*fdd*r*s + 9208*D1**2*Pk2*f**2*fdd*r + 2016*D1**2*Pk2*f**2*fdd*s**2 + 3480*D1**2*Pk2*f**2*fdd*s - 1520*D1**2*Pk2*f**2*fdd + 1860*D1**2*Pk2*f**2*gd2*r**2 + 3384*D1**2*Pk2*f**2*gd2*r*s - 3720*D1**2*Pk2*f**2*gd2*r - 9216*D1**2*Pk2*f**2*gd2*s**2 - 3384*D1**2*Pk2*f**2*gd2*s + 1860*D1**2*Pk2*f**2*gd2 - 1644*D1**2*Pk2*f**2*gdd2*r**2 - 2952*D1**2*Pk2*f**2*gdd2*r*s + 3288*D1**2*Pk2*f**2*gdd2*r + 6624*D1**2*Pk2*f**2*gdd2*s**2 + 2952*D1**2*Pk2*f**2*gdd2*s - 1644*D1**2*Pk2*f**2*gdd2 - 13152*D1**2*Pk2*f*fd**2*r**2 - 28944*D1**2*Pk2*f*fd**2*r*s + 18416*D1**2*Pk2*f*fd**2*r + 4032*D1**2*Pk2*f*fd**2*s**2 + 6960*D1**2*Pk2*f*fd**2*s - 4824*D1**2*Pk2*f*fd**2 + 3720*D1**2*Pk2*f*fd*g2*r**2 + 6768*D1**2*Pk2*f*fd*g2*r*s - 3384*D1**2*Pk2*f*fd*g2*r - 18432*D1**2*Pk2*f*fd*g2*s**2 + 18432*D1**2*Pk2*f*fd*g2*s - 9216*D1**2*Pk2*f*fd*g2 - 6576*D1**2*Pk2*f*fd*gd2*r**2 - 11808*D1**2*Pk2*f*fd*gd2*r*s + 9528*D1**2*Pk2*f*fd*gd2*r + 26496*D1**2*Pk2*f*fd*gd2*s**2 - 7344*D1**2*Pk2*f*fd*gd2*s - 2952*D1**2*Pk2*f*fd*gd2 - 3288*D1**2*Pk2*f*fdd*g2*r**2 - 5904*D1**2*Pk2*f*fdd*g2*r*s + 2952*D1**2*Pk2*f*fdd*g2*r + 13248*D1**2*Pk2*f*fdd*g2*s**2 - 13248*D1**2*Pk2*f*fdd*g2*s + 6624*D1**2*Pk2*f*fdd*g2 - 3288*D1**2*Pk2*fd**2*g2*r**2 - 5904*D1**2*Pk2*fd**2*g2*r*s + 2952*D1**2*Pk2*fd**2*g2*r + 13248*D1**2*Pk2*fd**2*g2*s**2 - 13248*D1**2*Pk2*fd**2*g2*s + 360*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 180*D1**2*Pkdd2*f**3*fd*k1**2*s + 90*D1**2*Pkdd2*f**3*fd*k1**2 - 54*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 36*D1**2*Pkdd2*f**2*fd*k1**2*s - 18*D1**2*Pkdd2*f**2*fd*k1**2 - 42*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 84*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 84*D1**2*Pkdd2*f*fd*g2*k1**2*s - 42*D1**2*Pkdd2*f*fd*g2*k1**2 + 6*D1**2*bd1**2*(72*Pk2*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 3) - 280*Pk2*g2*(r*(2*s - 1) + s*(2*s - 2)) - 7*f*(2*Pk2*(-8*C*s**2 + 8*C*s + K*(17*r**2 + r*(74*s - 39) + 50*s**2 - 74*s + 22) - 17*r**2 + r*(-8*C*s + 4*C - 114*s + 53) - 90*s**2 + 126*s - 40) + Pkdd2*k1**2*s*(-K*s + K + s - 1))) - 6*D1**2*bdd1*f*(f**2*(18*Pk2*(27*r**2 + r*(64*s - 50) + 19*s**2 - 44*s + 25) - 5*Pkdd2*k1**2*(2*s**2 - 6*s + 3)) + f*(Pk2*(2*C*(59*r**2 + 2*r*(95*s - 66) + 70*s**2 - 142*s + 71) + K*(-137*r**2 - 246*r*s + 274*r + 552*s**2 + 246*s - 137) + 337*r**2 + 946*r*s - 538*r + 316*s**2 - 970*s + 205) + Pkdd2*k1**2*(3 - 3*C)*(s - 1)**2) + 7*g2*(-2*Pk2*(17*r**2 + r*(74*s - 44) + 50*s**2 - 74*s + 37) + Pkdd2*k1**2*(s - 1)**2)) - 10368*D1*Dd*Pk2*bd2*f**2*r*s + 1296*D1*Dd*Pk2*bd2*f**2*r - 10368*D1*Dd*Pk2*bd2*f**2*s**2 + 10368*D1*Dd*Pk2*bd2*f**2*s - 1296*D1*Dd*Pk2*bd2*f**2 - 7776*D1*Dd*Pk2*f**4*r**2 - 19440*D1*Dd*Pk2*f**4*r*s + 12636*D1*Dd*Pk2*f**4*r - 6480*D1*Dd*Pk2*f**4*s**2 + 12960*D1*Dd*Pk2*f**4*s - 5508*D1*Dd*Pk2*f**4 + 62208*D1*Dd*Pk2*f**3*fd*r**2 + 155520*D1*Dd*Pk2*f**3*fd*r*s - 101088*D1*Dd*Pk2*f**3*fd*r + 51840*D1*Dd*Pk2*f**3*fd*s**2 - 103680*D1*Dd*Pk2*f**3*fd*s + 38232*D1*Dd*Pk2*f**3*fd + 9184*D1*Dd*Pk2*f**3*r**2 + 25056*D1*Dd*Pk2*f**3*r*s - 15448*D1*Dd*Pk2*f**3*r - 4800*D1*Dd*Pk2*f**3*s**2 - 10128*D1*Dd*Pk2*f**3*s + 3392*D1*Dd*Pk2*f**3 - 52608*D1*Dd*Pk2*f**2*fd*r**2 - 115776*D1*Dd*Pk2*f**2*fd*r*s + 77608*D1*Dd*Pk2*f**2*fd*r + 16128*D1*Dd*Pk2*f**2*fd*s**2 + 38832*D1*Dd*Pk2*f**2*fd*s - 21896*D1*Dd*Pk2*f**2*fd + 7440*D1*Dd*Pk2*f**2*g2*r**2 + 13536*D1*Dd*Pk2*f**2*g2*r*s - 10824*D1*Dd*Pk2*f**2*g2*r - 36864*D1*Dd*Pk2*f**2*g2*s**2 + 11664*D1*Dd*Pk2*f**2*g2*s - 5496*D1*Dd*Pk2*f**2*g2 - 13152*D1*Dd*Pk2*f**2*gd2*r**2 - 23616*D1*Dd*Pk2*f**2*gd2*r*s + 22680*D1*Dd*Pk2*f**2*gd2*r + 52992*D1*Dd*Pk2*f**2*gd2*s**2 + 4464*D1*Dd*Pk2*f**2*gd2*s - 9528*D1*Dd*Pk2*f**2*gd2 - 26304*D1*Dd*Pk2*f*fd*g2*r**2 - 47232*D1*Dd*Pk2*f*fd*g2*r*s + 30864*D1*Dd*Pk2*f*fd*g2*r + 105984*D1*Dd*Pk2*f*fd*g2*s**2 - 67680*D1*Dd*Pk2*f*fd*g2*s + 7344*D1*Dd*Pk2*f*fd*g2 + 360*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 180*D1*Dd*Pkdd2*f**4*k1**2*s + 90*D1*Dd*Pkdd2*f**4*k1**2 - 72*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 36*D1*Dd*Pkdd2*f**3*k1**2*s - 18*D1*Dd*Pkdd2*f**3*k1**2 - 168*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 84*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 42*D1*Dd*Pkdd2*f**2*g2*k1**2 + 7776*D1*Ddd*Pk2*f**4*r**2 + 19440*D1*Ddd*Pk2*f**4*r*s - 12636*D1*Ddd*Pk2*f**4*r + 6480*D1*Ddd*Pk2*f**4*s**2 - 12960*D1*Ddd*Pk2*f**4*s + 5508*D1*Ddd*Pk2*f**4 - 8768*D1*Ddd*Pk2*f**3*r**2 - 19296*D1*Ddd*Pk2*f**3*r*s + 13592*D1*Ddd*Pk2*f**3*r + 2688*D1*Ddd*Pk2*f**3*s**2 + 8304*D1*Ddd*Pk2*f**3*s - 3712*D1*Ddd*Pk2*f**3 - 6576*D1*Ddd*Pk2*f**2*g2*r**2 - 11808*D1*Ddd*Pk2*f**2*g2*r*s + 9528*D1*Ddd*Pk2*f**2*g2*r + 26496*D1*Ddd*Pk2*f**2*g2*s**2 - 7344*D1*Ddd*Pk2*f**2*g2*s + 3336*D1*Ddd*Pk2*f**2*g2 + 3*D1*bd1*(D1*(4*f**3*(9*Pk2*(21*r**2 + r*(76*s - 42) + 33*s**2 - 56*s + 23) - 5*Pkdd2*k1**2*(2*s**2 - 6*s + 3)) + f**2*(2*Pk2*(6*C*(23*r**2 + r*(94*s - 60) + 42*s**2 - 62*s + 31) - 155*K*r**2 - 282*K*r*s + 310*K*r + 768*K*s**2 + 282*K*s - 155*K - 36*fd*(81*r**2 + 8*r*(24*s - 17) + 57*s**2 - 127*s + 47) + 275*r**2 + 926*r*s - 278*r + 212*s**2 - 974*s + 39) + Pkdd2*k1**2*(-12*C*(s - 1)**2 + s**2*(7*K + 120*fd + 5) - s*(160*fd + 24) + 12)) - 4*f*(-7*Pk2*g2*(r**2 + r*(68 - 118*s) - 90*s**2 + 78*s - 39) - 14*Pk2*gd2*(17*r**2 + r*(74*s - 39) + 50*s**2 - 74*s + 22) - 7*Pkdd2*g2*k1**2*(s - 1)**2 + 7*Pkdd2*gd2*k1**2*s*(s - 1) + fd*(Pk2*(4*C*(59*r**2 + 10*r*(19*s - 11) + 70*s**2 - 118*s + 33) - K*(274*r**2 + 492*r*s - 397*r - 1104*s**2 + 306*s + 123) + 674*r**2 + 1892*r*s - 1079*r + 632*s**2 - 1274*s + 549) + 6*Pkdd2*k1**2*s*(-C*s + C + s - 1))) + 28*fd*g2*(2*Pk2*(17*r**2 + 37*r*(2*s - 1) + s*(50*s - 50)) - Pkdd2*k1**2*s*(s - 1))) - 4*Dd*f*(f**2*(18*Pk2*(108*r**2 + 2*r*(128*s - 93) + 76*s**2 - 171*s + 72) - 5*Pkdd2*k1**2*(8*s**2 - 14*s + 3)) + f*(Pk2*(2*C*(236*r**2 + r*(760*s - 477) + 280*s**2 - 544*s + 203) + K*(-548*r**2 - 984*r*s + 945*r + 2208*s**2 + 186*s - 397) + 1348*r**2 + 3784*r*s - 2223*r + 1264*s**2 - 3202*s + 1023) + Pkdd2*k1**2*(3 - 3*C)*(4*s**2 - 5*s + 1)) + 7*g2*(-2*Pk2*(68*r**2 + r*(296*s - 159) + 200*s**2 - 272*s + 81) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 23328*Dd**2*Pk2*f**4*r**2 + 58320*Dd**2*Pk2*f**4*r*s - 37908*Dd**2*Pk2*f**4*r + 19440*Dd**2*Pk2*f**4*s**2 - 38880*Dd**2*Pk2*f**4*s + 13608*Dd**2*Pk2*f**4 - 26304*Dd**2*Pk2*f**3*r**2 - 57888*Dd**2*Pk2*f**3*r*s + 40776*Dd**2*Pk2*f**3*r + 8064*Dd**2*Pk2*f**3*s**2 + 24912*Dd**2*Pk2*f**3*s - 14032*Dd**2*Pk2*f**3 - 19728*Dd**2*Pk2*f**2*g2*r**2 - 35424*Dd**2*Pk2*f**2*g2*r*s + 28584*Dd**2*Pk2*f**2*g2*r + 79488*Dd**2*Pk2*f**2*g2*s**2 - 22032*Dd**2*Pk2*f**2*g2*s - 9192*Dd**2*Pk2*f**2*g2 - 840*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 144*Pk2*b2*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 3*b1**2*(224*C*D1**2*Pk2*fd*r*s + 224*C*D1**2*Pk2*fd*s**2 - 224*C*D1**2*Pk2*fd*s - 112*C*D1**2*Pk2*fdd*r*s - 112*C*D1**2*Pk2*fdd*s**2 + 112*C*D1**2*Pk2*fdd*s + 896*C*D1*Dd*Pk2*f*r*s - 224*C*D1*Dd*Pk2*f*r + 896*C*D1*Dd*Pk2*f*s**2 - 896*C*D1*Dd*Pk2*f*s + 224*C*D1*Dd*Pk2*f - 896*C*D1*Dd*Pk2*fd*r*s + 112*C*D1*Dd*Pk2*fd*r - 896*C*D1*Dd*Pk2*fd*s**2 + 896*C*D1*Dd*Pk2*fd*s - 112*C*D1*Dd*Pk2*fd - 448*C*D1*Ddd*Pk2*f*r*s + 112*C*D1*Ddd*Pk2*f*r - 448*C*D1*Ddd*Pk2*f*s**2 + 448*C*D1*Ddd*Pk2*f*s - 112*C*D1*Ddd*Pk2*f - 1344*C*Dd**2*Pk2*f*r*s + 336*C*Dd**2*Pk2*f*r - 1344*C*Dd**2*Pk2*f*s**2 + 1344*C*Dd**2*Pk2*f*s - 224*C*Dd**2*Pk2*f + 14*D1**2*K*Pk2*fd*r**2 - 1652*D1**2*K*Pk2*fd*r*s + 700*D1**2*K*Pk2*fd*r - 1260*D1**2*K*Pk2*fd*s**2 + 1428*D1**2*K*Pk2*fd*s - 714*D1**2*K*Pk2*fd + 238*D1**2*K*Pk2*fdd*r**2 + 1036*D1**2*K*Pk2*fdd*r*s - 420*D1**2*K*Pk2*fdd*r + 700*D1**2*K*Pk2*fdd*s**2 - 364*D1**2*K*Pk2*fdd*s + 182*D1**2*K*Pk2*fdd + 14*D1**2*K*Pkdd2*fd*k1**2*s**2 - 7*D1**2*K*Pkdd2*fdd*k1**2*s**2 - 280*D1**2*Pk2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 1152*D1**2*Pk2*f*fd*r*s + 408*D1**2*Pk2*f*fd*r + 1152*D1**2*Pk2*f*fd*s**2 - 48*D1**2*Pk2*f*fd*s - 408*D1**2*Pk2*f*fd - 576*D1**2*Pk2*f*fdd*r*s - 288*D1**2*Pk2*f*fdd*r - 576*D1**2*Pk2*f*fdd*s**2 - 144*D1**2*Pk2*f*fdd*s + 288*D1**2*Pk2*f*fdd - 576*D1**2*Pk2*fd**2*r*s - 288*D1**2*Pk2*fd**2*r - 576*D1**2*Pk2*fd**2*s**2 - 144*D1**2*Pk2*fd**2*s + 288*D1**2*Pk2*fd**2 - 14*D1**2*Pk2*fd*r**2 + 2212*D1**2*Pk2*fd*r*s - 756*D1**2*Pk2*fd*r + 1820*D1**2*Pk2*fd*s**2 - 1316*D1**2*Pk2*fd*s + 770*D1**2*Pk2*fd - 238*D1**2*Pk2*fdd*r**2 - 1596*D1**2*Pk2*fdd*r*s + 588*D1**2*Pk2*fdd*r - 1260*D1**2*Pk2*fdd*s**2 + 588*D1**2*Pk2*fdd*s - 350*D1**2*Pk2*fdd - 1120*D1**2*Pk2*gd2*r*s - 1120*D1**2*Pk2*gd2*s**2 + 1120*D1**2*Pk2*gd2*s + 560*D1**2*Pk2*gdd2*r*s + 560*D1**2*Pk2*gdd2*s**2 - 560*D1**2*Pk2*gdd2*s - 14*D1**2*Pkdd2*fd*k1**2*s**2 + 7*D1**2*Pkdd2*fdd*k1**2*s**2 + 56*D1*Dd*K*Pk2*f*r**2 - 6608*D1*Dd*K*Pk2*f*r*s + 1596*D1*Dd*K*Pk2*f*r - 5040*D1*Dd*K*Pk2*f*s**2 + 5824*D1*Dd*K*Pk2*f*s - 1232*D1*Dd*K*Pk2*f + 1904*D1*Dd*K*Pk2*fd*r**2 + 8288*D1*Dd*K*Pk2*fd*r*s - 3668*D1*Dd*K*Pk2*fd*r + 5600*D1*Dd*K*Pk2*fd*s**2 - 4928*D1*Dd*K*Pk2*fd*s + 1204*D1*Dd*K*Pk2*fd + 56*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 28*D1*Dd*K*Pkdd2*f*k1**2*s + 14*D1*Dd*K*Pkdd2*f*k1**2 - 56*D1*Dd*K*Pkdd2*fd*k1**2*s**2 + 14*D1*Dd*K*Pkdd2*fd*k1**2*s + 2304*D1*Dd*Pk2*f**2*r*s - 576*D1*Dd*Pk2*f**2*r + 2304*D1*Dd*Pk2*f**2*s**2 - 2304*D1*Dd*Pk2*f**2*s + 576*D1*Dd*Pk2*f**2 - 4608*D1*Dd*Pk2*f*fd*r*s - 576*D1*Dd*Pk2*f*fd*r - 4608*D1*Dd*Pk2*f*fd*s**2 + 1728*D1*Dd*Pk2*f*fd*s + 720*D1*Dd*Pk2*f*fd - 56*D1*Dd*Pk2*f*r**2 + 8848*D1*Dd*Pk2*f*r*s - 2156*D1*Dd*Pk2*f*r + 7280*D1*Dd*Pk2*f*s**2 - 8064*D1*Dd*Pk2*f*s + 1792*D1*Dd*Pk2*f - 1904*D1*Dd*Pk2*fd*r**2 - 12768*D1*Dd*Pk2*fd*r*s + 4900*D1*Dd*Pk2*fd*r - 10080*D1*Dd*Pk2*fd*s**2 + 8064*D1*Dd*Pk2*fd*s - 1764*D1*Dd*Pk2*fd - 4480*D1*Dd*Pk2*g2*r*s + 1120*D1*Dd*Pk2*g2*r - 4480*D1*Dd*Pk2*g2*s**2 + 4480*D1*Dd*Pk2*g2*s - 1120*D1*Dd*Pk2*g2 + 4480*D1*Dd*Pk2*gd2*r*s - 560*D1*Dd*Pk2*gd2*r + 4480*D1*Dd*Pk2*gd2*s**2 - 4480*D1*Dd*Pk2*gd2*s + 560*D1*Dd*Pk2*gd2 - 56*D1*Dd*Pkdd2*f*k1**2*s**2 + 28*D1*Dd*Pkdd2*f*k1**2*s - 14*D1*Dd*Pkdd2*f*k1**2 + 56*D1*Dd*Pkdd2*fd*k1**2*s**2 - 14*D1*Dd*Pkdd2*fd*k1**2*s + 952*D1*Ddd*K*Pk2*f*r**2 + 4144*D1*Ddd*K*Pk2*f*r*s - 1988*D1*Ddd*K*Pk2*f*r + 2800*D1*Ddd*K*Pk2*f*s**2 - 3472*D1*Ddd*K*Pk2*f*s + 1176*D1*Ddd*K*Pk2*f - 28*D1*Ddd*K*Pkdd2*f*k1**2*s**2 + 14*D1*Ddd*K*Pkdd2*f*k1**2*s - 7*D1*Ddd*K*Pkdd2*f*k1**2 - 1152*D1*Ddd*Pk2*f**2*r*s + 288*D1*Ddd*Pk2*f**2*r - 1152*D1*Ddd*Pk2*f**2*s**2 + 1152*D1*Ddd*Pk2*f**2*s - 288*D1*Ddd*Pk2*f**2 - 952*D1*Ddd*Pk2*f*r**2 - 6384*D1*Ddd*Pk2*f*r*s + 2548*D1*Ddd*Pk2*f*r - 5040*D1*Ddd*Pk2*f*s**2 + 5712*D1*Ddd*Pk2*f*s - 1736*D1*Ddd*Pk2*f + 2240*D1*Ddd*Pk2*g2*r*s - 560*D1*Ddd*Pk2*g2*r + 2240*D1*Ddd*Pk2*g2*s**2 - 2240*D1*Ddd*Pk2*g2*s + 560*D1*Ddd*Pk2*g2 + 28*D1*Ddd*Pkdd2*f*k1**2*s**2 - 14*D1*Ddd*Pkdd2*f*k1**2*s + 7*D1*Ddd*Pkdd2*f*k1**2 + 280*D1*Pk2*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 2856*Dd**2*K*Pk2*f*r**2 + 12432*Dd**2*K*Pk2*f*r*s - 5964*Dd**2*K*Pk2*f*r + 8400*Dd**2*K*Pk2*f*s**2 - 10416*Dd**2*K*Pk2*f*s + 2548*Dd**2*K*Pk2*f - 84*Dd**2*K*Pkdd2*f*k1**2*s**2 + 42*Dd**2*K*Pkdd2*f*k1**2*s - 3456*Dd**2*Pk2*f**2*r*s + 864*Dd**2*Pk2*f**2*r - 3456*Dd**2*Pk2*f**2*s**2 + 3456*Dd**2*Pk2*f**2*s - 576*Dd**2*Pk2*f**2 - 2856*Dd**2*Pk2*f*r**2 - 19152*Dd**2*Pk2*f*r*s + 7644*Dd**2*Pk2*f*r - 15120*Dd**2*Pk2*f*s**2 + 17136*Dd**2*Pk2*f*s - 3668*Dd**2*Pk2*f + 6720*Dd**2*Pk2*g2*r*s - 1680*Dd**2*Pk2*g2*r + 6720*Dd**2*Pk2*g2*s**2 - 6720*Dd**2*Pk2*g2*s + 1120*Dd**2*Pk2*g2 + 84*Dd**2*Pkdd2*f*k1**2*s**2 - 42*Dd**2*Pkdd2*f*k1**2*s) + 3*b1*(552*C*D1**2*Pk2*f*fd*r**2 + 2256*C*D1**2*Pk2*f*fd*r*s - 960*C*D1**2*Pk2*f*fd*r + 1008*C*D1**2*Pk2*f*fd*s**2 - 1392*C*D1**2*Pk2*f*fd*s + 408*C*D1**2*Pk2*f*fd - 472*C*D1**2*Pk2*f*fdd*r**2 - 1520*C*D1**2*Pk2*f*fdd*r*s + 704*C*D1**2*Pk2*f*fdd*r - 560*C*D1**2*Pk2*f*fdd*s**2 + 752*C*D1**2*Pk2*f*fdd*s - 232*C*D1**2*Pk2*f*fdd - 472*C*D1**2*Pk2*fd**2*r**2 - 1520*C*D1**2*Pk2*fd**2*r*s + 704*C*D1**2*Pk2*fd**2*r - 560*C*D1**2*Pk2*fd**2*s**2 + 752*C*D1**2*Pk2*fd**2*s - 232*C*D1**2*Pk2*fd**2 - 24*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 12*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 12*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 1104*C*D1*Dd*Pk2*f**2*r**2 + 4512*C*D1*Dd*Pk2*f**2*r*s - 2232*C*D1*Dd*Pk2*f**2*r + 2016*C*D1*Dd*Pk2*f**2*s**2 - 3264*C*D1*Dd*Pk2*f**2*s + 1056*C*D1*Dd*Pk2*f**2 - 3776*C*D1*Dd*Pk2*f*fd*r**2 - 12160*C*D1*Dd*Pk2*f*fd*r*s + 6224*C*D1*Dd*Pk2*f*fd*r - 4480*C*D1*Dd*Pk2*f*fd*s**2 + 7168*C*D1*Dd*Pk2*f*fd*s - 2160*C*D1*Dd*Pk2*f*fd - 48*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 24*C*D1*Dd*Pkdd2*f**2*k1**2*s - 12*C*D1*Dd*Pkdd2*f**2*k1**2 + 96*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 24*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 944*C*D1*Ddd*Pk2*f**2*r**2 - 3040*C*D1*Ddd*Pk2*f**2*r*s + 1704*C*D1*Ddd*Pk2*f**2*r - 1120*C*D1*Ddd*Pk2*f**2*s**2 + 2080*C*D1*Ddd*Pk2*f**2*s - 752*C*D1*Ddd*Pk2*f**2 + 24*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 12*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 6*C*D1*Ddd*Pkdd2*f**2*k1**2 - 2832*C*Dd**2*Pk2*f**2*r**2 - 9120*C*Dd**2*Pk2*f**2*r*s + 5112*C*Dd**2*Pk2*f**2*r - 3360*C*Dd**2*Pk2*f**2*s**2 + 6240*C*Dd**2*Pk2*f**2*s - 1992*C*Dd**2*Pk2*f**2 + 72*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 36*C*Dd**2*Pkdd2*f**2*k1**2*s - 620*D1**2*K*Pk2*f*fd*r**2 - 1128*D1**2*K*Pk2*f*fd*r*s + 564*D1**2*K*Pk2*f*fd*r + 3072*D1**2*K*Pk2*f*fd*s**2 - 3072*D1**2*K*Pk2*f*fd*s + 1536*D1**2*K*Pk2*f*fd + 548*D1**2*K*Pk2*f*fdd*r**2 + 984*D1**2*K*Pk2*f*fdd*r*s - 492*D1**2*K*Pk2*f*fdd*r - 2208*D1**2*K*Pk2*f*fdd*s**2 + 2208*D1**2*K*Pk2*f*fdd*s - 1104*D1**2*K*Pk2*f*fdd + 548*D1**2*K*Pk2*fd**2*r**2 + 984*D1**2*K*Pk2*fd**2*r*s - 492*D1**2*K*Pk2*fd**2*r - 2208*D1**2*K*Pk2*fd**2*s**2 + 2208*D1**2*K*Pk2*fd**2*s + 14*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*K*Pkdd2*f*fd*k1**2*s + 7*D1**2*K*Pkdd2*f*fd*k1**2 + 280*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 2268*D1**2*Pk2*f**2*fd*r**2 + 8208*D1**2*Pk2*f**2*fd*r*s - 4248*D1**2*Pk2*f**2*fd*r + 3564*D1**2*Pk2*f**2*fd*s**2 - 5832*D1**2*Pk2*f**2*fd*s + 1872*D1**2*Pk2*f**2*fd - 2916*D1**2*Pk2*f**2*fdd*r**2 - 6912*D1**2*Pk2*f**2*fdd*r*s + 4392*D1**2*Pk2*f**2*fdd*r - 2052*D1**2*Pk2*f**2*fdd*s**2 + 4392*D1**2*Pk2*f**2*fdd*s - 1728*D1**2*Pk2*f**2*fdd - 5832*D1**2*Pk2*f*fd**2*r**2 - 13824*D1**2*Pk2*f*fd**2*r*s + 8784*D1**2*Pk2*f*fd**2*r - 4104*D1**2*Pk2*f*fd**2*s**2 + 8784*D1**2*Pk2*f*fd**2*s - 3168*D1**2*Pk2*f*fd**2 + 1100*D1**2*Pk2*f*fd*r**2 + 3704*D1**2*Pk2*f*fd*r*s - 2396*D1**2*Pk2*f*fd*r + 848*D1**2*Pk2*f*fd*s**2 - 752*D1**2*Pk2*f*fd*s + 896*D1**2*Pk2*f*fd - 1348*D1**2*Pk2*f*fdd*r**2 - 3784*D1**2*Pk2*f*fdd*r*s + 2164*D1**2*Pk2*f*fdd*r - 1264*D1**2*Pk2*f*fdd*s**2 + 1216*D1**2*Pk2*f*fdd*s - 896*D1**2*Pk2*f*fdd + 28*D1**2*Pk2*f*gd2*r**2 - 3304*D1**2*Pk2*f*gd2*r*s - 56*D1**2*Pk2*f*gd2*r - 2520*D1**2*Pk2*f*gd2*s**2 + 3304*D1**2*Pk2*f*gd2*s + 28*D1**2*Pk2*f*gd2 + 476*D1**2*Pk2*f*gdd2*r**2 + 2072*D1**2*Pk2*f*gdd2*r*s - 952*D1**2*Pk2*f*gdd2*r + 1400*D1**2*Pk2*f*gdd2*s**2 - 2072*D1**2*Pk2*f*gdd2*s + 476*D1**2*Pk2*f*gdd2 - 1348*D1**2*Pk2*fd**2*r**2 - 3784*D1**2*Pk2*fd**2*r*s + 2164*D1**2*Pk2*fd**2*r - 1264*D1**2*Pk2*fd**2*s**2 + 1216*D1**2*Pk2*fd**2*s + 304*D1**2*Pk2*fd**2 + 28*D1**2*Pk2*fd*g2*r**2 - 3304*D1**2*Pk2*fd*g2*r*s + 1400*D1**2*Pk2*fd*g2*r - 2520*D1**2*Pk2*fd*g2*s**2 + 2856*D1**2*Pk2*fd*g2*s - 1428*D1**2*Pk2*fd*g2 + 952*D1**2*Pk2*fd*gd2*r**2 + 4144*D1**2*Pk2*fd*gd2*r*s - 1792*D1**2*Pk2*fd*gd2*r + 2800*D1**2*Pk2*fd*gd2*s**2 - 2800*D1**2*Pk2*fd*gd2*s + 840*D1**2*Pk2*fd*gd2 + 476*D1**2*Pk2*fdd*g2*r**2 + 2072*D1**2*Pk2*fdd*g2*r*s - 840*D1**2*Pk2*fdd*g2*r + 1400*D1**2*Pk2*fdd*g2*s**2 - 728*D1**2*Pk2*fdd*g2*s + 364*D1**2*Pk2*fdd*g2 - 120*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 40*D1**2*Pkdd2*f**2*fd*k1**2*s + 20*D1**2*Pkdd2*f**2*fd*k1**2 + 60*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 20*D1**2*Pkdd2*f**2*fdd*k1**2*s - 10*D1**2*Pkdd2*f**2*fdd*k1**2 + 120*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 40*D1**2*Pkdd2*f*fd**2*k1**2*s + 10*D1**2*Pkdd2*f*fd*k1**2*s**2 + 14*D1**2*Pkdd2*f*fd*k1**2*s - 7*D1**2*Pkdd2*f*fd*k1**2 - 12*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 28*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 12*D1**2*Pkdd2*fd**2*k1**2*s**2 + 28*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 28*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + D1**2*bdd1*(144*Pk2*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 4) - 560*Pk2*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 7*f*(4*Pk2*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) - K*(17*r**2 + 74*r*s - 39*r + 50*s**2 - 74*s + 27) + 17*r**2 + 114*r*s - 53*r + 90*s**2 - 126*s + 41) + Pkdd2*k1**2*(K - 1)*(2*s**2 - 2*s + 1))) - 1240*D1*Dd*K*Pk2*f**2*r**2 - 2256*D1*Dd*K*Pk2*f**2*r*s + 1804*D1*Dd*K*Pk2*f**2*r + 6144*D1*Dd*K*Pk2*f**2*s**2 - 1944*D1*Dd*K*Pk2*f**2*s + 916*D1*Dd*K*Pk2*f**2 + 4384*D1*Dd*K*Pk2*f*fd*r**2 + 7872*D1*Dd*K*Pk2*f*fd*r*s - 5144*D1*Dd*K*Pk2*f*fd*r - 17664*D1*Dd*K*Pk2*f*fd*s**2 + 11280*D1*Dd*K*Pk2*f*fd*s - 1224*D1*Dd*K*Pk2*f*fd + 28*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 14*D1*Dd*K*Pkdd2*f**2*k1**2*s + 7*D1*Dd*K*Pkdd2*f**2*k1**2 + 3024*D1*Dd*Pk2*f**3*r**2 + 10944*D1*Dd*Pk2*f**3*r*s - 5760*D1*Dd*Pk2*f**3*r + 4752*D1*Dd*Pk2*f**3*s**2 - 7848*D1*Dd*Pk2*f**3*s + 2700*D1*Dd*Pk2*f**3 - 23328*D1*Dd*Pk2*f**2*fd*r**2 - 55296*D1*Dd*Pk2*f**2*fd*r*s + 36144*D1*Dd*Pk2*f**2*fd*r - 16416*D1*Dd*Pk2*f**2*fd*s**2 + 35496*D1*Dd*Pk2*f**2*fd*s - 13176*D1*Dd*Pk2*f**2*fd + 2200*D1*Dd*Pk2*f**2*r**2 + 7408*D1*Dd*Pk2*f**2*r*s - 4052*D1*Dd*Pk2*f**2*r + 1696*D1*Dd*Pk2*f**2*s**2 - 4552*D1*Dd*Pk2*f**2*s + 1524*D1*Dd*Pk2*f**2 - 10784*D1*Dd*Pk2*f*fd*r**2 - 30272*D1*Dd*Pk2*f*fd*r*s + 17832*D1*Dd*Pk2*f*fd*r - 10112*D1*Dd*Pk2*f*fd*s**2 + 14960*D1*Dd*Pk2*f*fd*s - 5544*D1*Dd*Pk2*f*fd + 112*D1*Dd*Pk2*f*g2*r**2 - 13216*D1*Dd*Pk2*f*g2*r*s + 3192*D1*Dd*Pk2*f*g2*r - 10080*D1*Dd*Pk2*f*g2*s**2 + 11648*D1*Dd*Pk2*f*g2*s - 2464*D1*Dd*Pk2*f*g2 + 3808*D1*Dd*Pk2*f*gd2*r**2 + 16576*D1*Dd*Pk2*f*gd2*r*s - 7784*D1*Dd*Pk2*f*gd2*r + 11200*D1*Dd*Pk2*f*gd2*s**2 - 15232*D1*Dd*Pk2*f*gd2*s + 3976*D1*Dd*Pk2*f*gd2 + 3808*D1*Dd*Pk2*fd*g2*r**2 + 16576*D1*Dd*Pk2*fd*g2*r*s - 7336*D1*Dd*Pk2*fd*g2*r + 11200*D1*Dd*Pk2*fd*g2*s**2 - 9856*D1*Dd*Pk2*fd*g2*s + 2408*D1*Dd*Pk2*fd*g2 - 160*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 80*D1*Dd*Pkdd2*f**3*k1**2*s - 40*D1*Dd*Pkdd2*f**3*k1**2 + 480*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 40*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 20*D1*Dd*Pkdd2*f**2*fd*k1**2 + 20*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 10*D1*Dd*Pkdd2*f**2*k1**2*s + 5*D1*Dd*Pkdd2*f**2*k1**2 - 96*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 24*D1*Dd*Pkdd2*f*fd*k1**2*s + 112*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 56*D1*Dd*Pkdd2*f*g2*k1**2*s + 28*D1*Dd*Pkdd2*f*g2*k1**2 - 112*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 28*D1*Dd*Pkdd2*f*gd2*k1**2*s - 112*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 28*D1*Dd*Pkdd2*fd*g2*k1**2*s + 1096*D1*Ddd*K*Pk2*f**2*r**2 + 1968*D1*Ddd*K*Pk2*f**2*r*s - 1588*D1*Ddd*K*Pk2*f**2*r - 4416*D1*Ddd*K*Pk2*f**2*s**2 + 1224*D1*Ddd*K*Pk2*f**2*s - 556*D1*Ddd*K*Pk2*f**2 - 3888*D1*Ddd*Pk2*f**3*r**2 - 9216*D1*Ddd*Pk2*f**3*r*s + 6192*D1*Ddd*Pk2*f**3*r - 2736*D1*Ddd*Pk2*f**3*s**2 + 5976*D1*Ddd*Pk2*f**3*s - 2628*D1*Ddd*Pk2*f**3 - 2696*D1*Ddd*Pk2*f**2*r**2 - 7568*D1*Ddd*Pk2*f**2*r*s + 4588*D1*Ddd*Pk2*f**2*r - 2528*D1*Ddd*Pk2*f**2*s**2 + 5048*D1*Ddd*Pk2*f**2*s - 1980*D1*Ddd*Pk2*f**2 + 1904*D1*Ddd*Pk2*f*g2*r**2 + 8288*D1*Ddd*Pk2*f*g2*r*s - 3976*D1*Ddd*Pk2*f*g2*r + 5600*D1*Ddd*Pk2*f*g2*s**2 - 6944*D1*Ddd*Pk2*f*g2*s + 2352*D1*Ddd*Pk2*f*g2 + 80*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 40*D1*Ddd*Pkdd2*f**3*k1**2*s + 20*D1*Ddd*Pkdd2*f**3*k1**2 - 24*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 12*D1*Ddd*Pkdd2*f**2*k1**2*s - 6*D1*Ddd*Pkdd2*f**2*k1**2 - 56*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 28*D1*Ddd*Pkdd2*f*g2*k1**2*s - 14*D1*Ddd*Pkdd2*f*g2*k1**2 - 2*D1*bd1*(D1*(12*Pk2*f**2*(r*(48*s - 41) + 48*s**2 - 94*s + 41) - 280*Pk2*(g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + gd2*(-4*r*s + r - (1 - 2*s)**2)) + f*(2*Pk2*(56*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 7*K*(r**2 - 118*r*s + 33*r - 90*s**2 + 98*s - 19) - 36*fd*(4*s - 1)*(4*r + 4*s - 3) - 7*r**2 + 1106*r*s - 357*r + 910*s**2 - 1134*s + 259) + Pkdd2*k1**2*(7*K - 7)*(2*s**2 - 2*s + 1)) - 7*fd*(2*Pk2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(34*r**2 + 148*r*s - 69*r + 100*s**2 - 100*s + 15) + 34*r**2 + 228*r*s - 95*r + 180*s**2 - 168*s + 17) + Pkdd2*k1**2*s*(K - 1)*(2*s - 1))) + Dd*(-72*Pk2*f**2*(4*r*(8*s - 5) + 32*s**2 - 52*s + 17) + 560*Pk2*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 7*f*(4*Pk2*(4*C*r*(8*s - 3) + 8*C*(1 - 2*s)**2 - K*(68*r**2 + 296*r*s - 149*r + 200*s**2 - 272*s + 76) + 68*r**2 + 456*r*s - 197*r + 360*s**2 - 456*s + 116) + Pkdd2*k1**2*(K - 1)*(8*s**2 - 6*s + 1)))) + 3288*Dd**2*K*Pk2*f**2*r**2 + 5904*Dd**2*K*Pk2*f**2*r*s - 4764*Dd**2*K*Pk2*f**2*r - 13248*Dd**2*K*Pk2*f**2*s**2 + 3672*Dd**2*K*Pk2*f**2*s + 1532*Dd**2*K*Pk2*f**2 - 11664*Dd**2*Pk2*f**3*r**2 - 27648*Dd**2*Pk2*f**3*r*s + 18576*Dd**2*Pk2*f**3*r - 8208*Dd**2*Pk2*f**3*s**2 + 17928*Dd**2*Pk2*f**3*s - 6552*Dd**2*Pk2*f**3 - 8088*Dd**2*Pk2*f**2*r**2 - 22704*Dd**2*Pk2*f**2*r*s + 13764*Dd**2*Pk2*f**2*r - 7584*Dd**2*Pk2*f**2*s**2 + 15144*Dd**2*Pk2*f**2*s - 5132*Dd**2*Pk2*f**2 + 5712*Dd**2*Pk2*f*g2*r**2 + 24864*Dd**2*Pk2*f*g2*r*s - 11928*Dd**2*Pk2*f*g2*r + 16800*Dd**2*Pk2*f*g2*s**2 - 20832*Dd**2*Pk2*f*g2*s + 5096*Dd**2*Pk2*f*g2 + 240*Dd**2*Pkdd2*f**3*k1**2*s**2 - 120*Dd**2*Pkdd2*f**3*k1**2*s - 72*Dd**2*Pkdd2*f**2*k1**2*s**2 + 36*Dd**2*Pkdd2*f**2*k1**2*s - 168*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 84*Dd**2*Pkdd2*f*g2*k1**2*s))/(630*d**2*k3**4) + D1**2*Pk3*ct**2*k1**2*(-6*D1**2*bd1**2*(14*Pk2*f*(34*C*s**2 - 34*C*s + K*(-38*r**2 + r*(89 - 50*s) + 14*s**2 + 63*s - 51) + r**2*(50*C + 56) + r*(84*C*s - 42*C + 128*s - 183) + 46*s**2 - 178*s + 119) - 980*Pk2*g2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 3*f**2*(14*Pk2*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + 5*Pkdd2*k1**2*s*(s - 1))) - 3*D1*bd1*(D1*(56*Pk2*fd*g2*(38*r**2 + 25*r*(2*s - 1) - s*(14*s - 14)) + f**3*(126*Pk2*(4*r**2 - 5*r + s*(5 - 4*s)) - 15*Pkdd2*k1**2*(2*s**2 - 6*s + 3)) + 2*f**2*(Pk2*(522*C*r**2 + 204*C*r*(3*s - 5) - 8*C*(19*s**2 + 64*s - 32) + 42*K*r**2 + 952*K*r*s - 84*K*r + 1071*K*s**2 - 952*K*s + 42*K - 63*fd*(24*r**2 - 26*r - 24*s**2 + 18*s + 5) - 825*r**2 - 1631*r*s + 1608*r - 634*s**2 + 1411*s - 541) + Pkdd2*k1**2*(21 - 21*C)*(s - 1)**2) - 2*f*(Pk2*fd*(4*C*(408*r**2 + 12*r*(43*s - 48) - 188*s**2 - 169*s + 243) + 14*K*(30*r**2 + 272*r*s - 98*r + 294*s**2 - 283*s + 68) - 3120*r**2 - 6188*r*s + 4751*r - 2248*s**2 + 4052*s - 1889) - 28*Pk2*gd2*(38*r**2 + r*(50*s - 89) - 14*s**2 - 63*s + 51) - 7*g2*(-2*Pk2*(41*r**2 + 50*r*s - 94*r - 8*s**2 - 72*s + 36) + 5*Pkdd2*k1**2*(s - 1)**2))) - 2*Dd*Pk2*f*(63*f**2*(32*r**2 - 36*r - 32*s**2 + 28*s + 5) + f*(4*C*(816*r**2 + 3*r*(344*s - 503) - 376*s**2 - 700*s + 620) + 14*K*(60*r**2 + 544*r*s - 158*r + 588*s**2 - 555*s + 98) - 6240*r**2 - 12376*r*s + 11243*r - 4496*s**2 + 9742*s - 4669) - 28*g2*(152*r**2 + 5*r*(40*s - 61) - 56*s**2 - 188*s + 140))) - 210*Pk2*b1**3*(K - 1)*(D1*(Dd*(28*r**2 + 8*r*s - 30*r - 20*s**2 + 6*s + 9) + 7*Ddd*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + 42*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Pk2*(1020*C*D1**2*f**2*fd*r**2 + 13488*C*D1**2*f**2*fd*r*s - 5176*C*D1**2*f**2*fd*r + 12906*C*D1**2*f**2*fd*s**2 - 13100*C*D1**2*f**2*fd*s + 4642*C*D1**2*f**2*fd - 1590*C*D1**2*f**2*fdd*r**2 - 13008*C*D1**2*f**2*fdd*r*s + 5396*C*D1**2*f**2*fdd*r - 12366*C*D1**2*f**2*fdd*s**2 + 12580*C*D1**2*f**2*fdd*s - 4652*C*D1**2*f**2*fdd - 3180*C*D1**2*f*fd**2*r**2 - 26016*C*D1**2*f*fd**2*r*s + 10792*C*D1**2*f*fd**2*r - 24732*C*D1**2*f*fd**2*s**2 + 25160*C*D1**2*f*fd**2*s - 4336*C*D1**2*f*fd**2 + 1360*C*D1*Dd*f**3*r**2 + 17984*C*D1*Dd*f**3*r*s - 5856*C*D1*Dd*f**3*r + 17208*C*D1*Dd*f**3*s**2 - 17596*C*D1*Dd*f**3*s + 4982*C*D1*Dd*f**3 - 12720*C*D1*Dd*f**2*fd*r**2 - 104064*C*D1*Dd*f**2*fd*r*s + 40952*C*D1*Dd*f**2*fd*r - 98928*C*D1*Dd*f**2*fd*s**2 + 101068*C*D1*Dd*f**2*fd*s - 23372*C*D1*Dd*f**2*fd - 2120*C*D1*Ddd*f**3*r**2 - 17344*C*D1*Ddd*f**3*r*s + 6456*C*D1*Ddd*f**3*r - 16488*C*D1*Ddd*f**3*s**2 + 16916*C*D1*Ddd*f**3*s - 5182*C*D1*Ddd*f**3 - 6360*C*Dd**2*f**3*r**2 - 52032*C*Dd**2*f**3*r*s + 19368*C*Dd**2*f**3*r - 49464*C*Dd**2*f**3*s**2 + 50748*C*Dd**2*f**3*s - 9732*C*Dd**2*f**3 + 378*D1**2*b2*f*fd*r**2 + 2772*D1**2*b2*f*fd*r*s - 1386*D1**2*b2*f*fd*r + 2394*D1**2*b2*f*fd*s**2 - 2394*D1**2*b2*f*fd*s + 1197*D1**2*b2*f*fd - 630*D1**2*b2*f*fdd*r**2 - 2772*D1**2*b2*f*fdd*r*s + 1386*D1**2*b2*f*fdd*r - 2142*D1**2*b2*f*fdd*s**2 + 2142*D1**2*b2*f*fdd*s - 1071*D1**2*b2*f*fdd - 630*D1**2*b2*fd**2*r**2 - 2772*D1**2*b2*fd**2*r*s + 1386*D1**2*b2*fd**2*r - 2142*D1**2*b2*fd**2*s**2 + 2142*D1**2*b2*fd**2*s - 3*D1**2*bdd1*f*(63*f**2*(4*r**2 - 5*r + s*(5 - 4*s)) + f*(4*C*(102*r**2 + 3*r*(43*s - 81) - 47*s**2 - 134*s + 67) + 7*K*(15*r**2 + 136*r*s - 30*r + 147*s**2 - 136*s + 15) - 780*r**2 - 1547*r*s + 1644*r - 562*s**2 + 1381*s - 568) - 28*g2*(19*r**2 + r*(25*s - 51) - 7*s**2 - 38*s + 19)) - 315*D1**2*bdd2*f**2*r**2 - 1386*D1**2*bdd2*f**2*r*s + 630*D1**2*bdd2*f**2*r - 1071*D1**2*bdd2*f**2*s**2 + 1386*D1**2*bdd2*f**2*s - 315*D1**2*bdd2*f**2 - 105*D1**2*f**2*fd*r**2 - 8241*D1**2*f**2*fd*r*s + 2817*D1**2*f**2*fd*r - 8397*D1**2*f**2*fd*s**2 + 8345*D1**2*f**2*fd*s - 2834*D1**2*f**2*fd + 795*D1**2*f**2*fdd*r**2 + 8211*D1**2*f**2*fdd*r*s - 3267*D1**2*f**2*fdd*r + 8127*D1**2*f**2*fdd*s**2 - 8155*D1**2*f**2*fdd*s + 2974*D1**2*f**2*fdd - 252*D1**2*f**2*gd2*r**2 - 5712*D1**2*f**2*gd2*r*s + 504*D1**2*f**2*gd2*r - 6426*D1**2*f**2*gd2*s**2 + 5712*D1**2*f**2*gd2*s - 252*D1**2*f**2*gd2 + 630*D1**2*f**2*gdd2*r**2 + 5712*D1**2*f**2*gdd2*r*s - 1260*D1**2*f**2*gdd2*r + 6174*D1**2*f**2*gdd2*s**2 - 5712*D1**2*f**2*gdd2*s + 630*D1**2*f**2*gdd2 + 1590*D1**2*f*fd**2*r**2 + 16422*D1**2*f*fd**2*r*s - 6534*D1**2*f*fd**2*r + 16254*D1**2*f*fd**2*s**2 - 16310*D1**2*f*fd**2*s + 2737*D1**2*f*fd**2 - 504*D1**2*f*fd*g2*r**2 - 11424*D1**2*f*fd*g2*r*s + 5712*D1**2*f*fd*g2*r - 12852*D1**2*f*fd*g2*s**2 + 12852*D1**2*f*fd*g2*s - 6426*D1**2*f*fd*g2 + 2520*D1**2*f*fd*gd2*r**2 + 22848*D1**2*f*fd*gd2*r*s - 8232*D1**2*f*fd*gd2*r + 24696*D1**2*f*fd*gd2*s**2 - 23772*D1**2*f*fd*gd2*s + 5712*D1**2*f*fd*gd2 + 1260*D1**2*f*fdd*g2*r**2 + 11424*D1**2*f*fdd*g2*r*s - 5712*D1**2*f*fdd*g2*r + 12348*D1**2*f*fdd*g2*s**2 - 12348*D1**2*f*fdd*g2*s + 6174*D1**2*f*fdd*g2 + 1260*D1**2*fd**2*g2*r**2 + 11424*D1**2*fd**2*g2*r*s - 5712*D1**2*fd**2*g2*r + 12348*D1**2*fd**2*g2*s**2 - 12348*D1**2*fd**2*g2*s + 756*D1*Dd*b2*f**2*r**2 + 5544*D1*Dd*b2*f**2*r*s - 2142*D1*Dd*b2*f**2*r + 4788*D1*Dd*b2*f**2*s**2 - 5166*D1*Dd*b2*f**2*s + 1575*D1*Dd*b2*f**2 - 5040*D1*Dd*b2*f*fd*r**2 - 22176*D1*Dd*b2*f*fd*r*s + 10836*D1*Dd*b2*f*fd*r - 17136*D1*Dd*b2*f*fd*s**2 + 18396*D1*Dd*b2*f*fd*s - 4914*D1*Dd*b2*f*fd - 140*D1*Dd*f**3*r**2 - 10988*D1*Dd*f**3*r*s + 2887*D1*Dd*f**3*r - 11196*D1*Dd*f**3*s**2 + 11092*D1*Dd*f**3*s - 2869*D1*Dd*f**3 + 6360*D1*Dd*f**2*fd*r**2 + 65688*D1*Dd*f**2*fd*r*s - 24459*D1*Dd*f**2*fd*r + 65016*D1*Dd*f**2*fd*s**2 - 65296*D1*Dd*f**2*fd*s + 14689*D1*Dd*f**2*fd - 1008*D1*Dd*f**2*g2*r**2 - 22848*D1*Dd*f**2*g2*r*s + 6720*D1*Dd*f**2*g2*r - 25704*D1*Dd*f**2*g2*s**2 + 24276*D1*Dd*f**2*g2*s - 6930*D1*Dd*f**2*g2 + 5040*D1*Dd*f**2*gd2*r**2 + 45696*D1*Dd*f**2*gd2*r*s - 13272*D1*Dd*f**2*gd2*r + 49392*D1*Dd*f**2*gd2*s**2 - 46620*D1*Dd*f**2*gd2*s + 8232*D1*Dd*f**2*gd2 + 10080*D1*Dd*f*fd*g2*r**2 + 91392*D1*Dd*f*fd*g2*r*s - 39312*D1*Dd*f*fd*g2*r + 98784*D1*Dd*f*fd*g2*s**2 - 96936*D1*Dd*f*fd*g2*s + 23772*D1*Dd*f*fd*g2 - 1260*D1*Ddd*b2*f**2*r**2 - 5544*D1*Ddd*b2*f**2*r*s + 2646*D1*Ddd*b2*f**2*r - 4284*D1*Ddd*b2*f**2*s**2 + 4914*D1*Ddd*b2*f**2*s - 1701*D1*Ddd*b2*f**2 + 1060*D1*Ddd*f**3*r**2 + 10948*D1*Ddd*f**3*r*s - 3797*D1*Ddd*f**3*r + 10836*D1*Ddd*f**3*s**2 - 10892*D1*Ddd*f**3*s + 3239*D1*Ddd*f**3 + 2520*D1*Ddd*f**2*g2*r**2 + 22848*D1*Ddd*f**2*g2*r*s - 8232*D1*Ddd*f**2*g2*r + 24696*D1*Ddd*f**2*g2*s**2 - 23772*D1*Ddd*f**2*g2*s + 7434*D1*Ddd*f**2*g2 + 63*D1*bd2*f*(D1*(f*(3*r**2 + 22*r*s - 6*r + 19*s**2 - 22*s + 3) - 2*fd*(10*r**2 + 44*r*s - 21*r + 34*s**2 - 39*s + 11)) - 2*Dd*f*(20*r**2 + r*(88*s - 41) + 68*s**2 - 83*s + 21)) - 3780*Dd**2*b2*f**2*r**2 - 16632*Dd**2*b2*f**2*r*s + 7938*Dd**2*b2*f**2*r - 12852*Dd**2*b2*f**2*s**2 + 14742*Dd**2*b2*f**2*s - 3402*Dd**2*b2*f**2 + 3180*Dd**2*f**3*r**2 + 32844*Dd**2*f**3*r*s - 11391*Dd**2*f**3*r + 32508*Dd**2*f**3*s**2 - 32676*Dd**2*f**3*s + 6004*Dd**2*f**3 + 7560*Dd**2*f**2*g2*r**2 + 68544*Dd**2*f**2*g2*r*s - 24696*Dd**2*f**2*g2*r + 74088*Dd**2*f**2*g2*s**2 - 71316*Dd**2*f**2*g2*s + 12684*Dd**2*f**2*g2) - 3*b1**2*(-420*C*D1**2*Pk2*fd*r**2 - 952*C*D1**2*Pk2*fd*r*s + 840*C*D1**2*Pk2*fd*r - 532*C*D1**2*Pk2*fd*s**2 + 952*C*D1**2*Pk2*fd*s - 420*C*D1**2*Pk2*fd + 700*C*D1**2*Pk2*fdd*r**2 + 1176*C*D1**2*Pk2*fdd*r*s - 1400*C*D1**2*Pk2*fdd*r + 476*C*D1**2*Pk2*fdd*s**2 - 1176*C*D1**2*Pk2*fdd*s + 700*C*D1**2*Pk2*fdd - 1680*C*D1*Dd*Pk2*f*r**2 - 3808*C*D1*Dd*Pk2*f*r*s + 2632*C*D1*Dd*Pk2*f*r - 2128*C*D1*Dd*Pk2*f*s**2 + 2968*C*D1*Dd*Pk2*f*s - 1372*C*D1*Dd*Pk2*f + 5600*C*D1*Dd*Pk2*fd*r**2 + 9408*C*D1*Dd*Pk2*fd*r*s - 9576*C*D1*Dd*Pk2*fd*r + 3808*C*D1*Dd*Pk2*fd*s**2 - 8008*C*D1*Dd*Pk2*fd*s + 3976*C*D1*Dd*Pk2*fd + 2800*C*D1*Ddd*Pk2*f*r**2 + 4704*C*D1*Ddd*Pk2*f*r*s - 3976*C*D1*Ddd*Pk2*f*r + 1904*C*D1*Ddd*Pk2*f*s**2 - 3304*C*D1*Ddd*Pk2*f*s + 1876*C*D1*Ddd*Pk2*f + 8400*C*Dd**2*Pk2*f*r**2 + 14112*C*Dd**2*Pk2*f*r*s - 11928*C*Dd**2*Pk2*f*r + 5712*C*Dd**2*Pk2*f*s**2 - 9912*C*Dd**2*Pk2*f*s + 3752*C*Dd**2*Pk2*f + 574*D1**2*K*Pk2*fd*r**2 + 700*D1**2*K*Pk2*fd*r*s + 616*D1**2*K*Pk2*fd*r - 112*D1**2*K*Pk2*fd*s**2 + 1232*D1**2*K*Pk2*fd*s - 616*D1**2*K*Pk2*fd - 532*D1**2*K*Pk2*fdd*r**2 - 700*D1**2*K*Pk2*fdd*r*s - 728*D1**2*K*Pk2*fdd*r + 196*D1**2*K*Pk2*fdd*s**2 - 1456*D1**2*K*Pk2*fdd*s + 728*D1**2*K*Pk2*fdd - 35*D1**2*K*Pkdd2*fd*k1**2*s**2 + 490*D1**2*Pk2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 1512*D1**2*Pk2*f*fd*r**2 - 2688*D1**2*Pk2*f*fd*r*s + 1596*D1**2*Pk2*f*fd*r - 1176*D1**2*Pk2*f*fd*s**2 + 924*D1**2*Pk2*f*fd*s - 588*D1**2*Pk2*f*fd + 1848*D1**2*Pk2*f*fdd*r**2 + 2688*D1**2*Pk2*f*fdd*r*s - 2100*D1**2*Pk2*f*fdd*r + 840*D1**2*Pk2*f*fdd*s**2 - 1092*D1**2*Pk2*f*fdd*s + 924*D1**2*Pk2*f*fdd + 1848*D1**2*Pk2*fd**2*r**2 + 2688*D1**2*Pk2*fd**2*r*s - 2100*D1**2*Pk2*fd**2*r + 840*D1**2*Pk2*fd**2*s**2 - 1092*D1**2*Pk2*fd**2*s + 252*D1**2*Pk2*fd**2 - 798*D1**2*Pk2*fd*r**2 - 1764*D1**2*Pk2*fd*r*s - 1148*D1**2*Pk2*fd*r - 728*D1**2*Pk2*fd*s**2 - 1568*D1**2*Pk2*fd*s + 728*D1**2*Pk2*fd + 784*D1**2*Pk2*fdd*r**2 + 1792*D1**2*Pk2*fdd*r*s + 1764*D1**2*Pk2*fdd*r + 644*D1**2*Pk2*fdd*s**2 + 1904*D1**2*Pk2*fdd*s - 1064*D1**2*Pk2*fdd - 980*D1**2*Pk2*gd2*r**2 - 280*D1**2*Pk2*gd2*r*s + 1960*D1**2*Pk2*gd2*r + 700*D1**2*Pk2*gd2*s**2 + 280*D1**2*Pk2*gd2*s - 980*D1**2*Pk2*gd2 - 980*D1**2*Pk2*gdd2*r**2 - 1960*D1**2*Pk2*gdd2*r*s + 1960*D1**2*Pk2*gdd2*r - 980*D1**2*Pk2*gdd2*s**2 + 1960*D1**2*Pk2*gdd2*s - 980*D1**2*Pk2*gdd2 - 60*D1**2*Pkdd2*f*fd*k1**2*s**2 + 30*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 30*D1**2*Pkdd2*fd**2*k1**2*s**2 + 35*D1**2*Pkdd2*fd*k1**2*s**2 + 2296*D1*Dd*K*Pk2*f*r**2 + 2800*D1*Dd*K*Pk2*f*r*s - 2996*D1*Dd*K*Pk2*f*r - 448*D1*Dd*K*Pk2*f*s**2 - 1176*D1*Dd*K*Pk2*f*s + 1036*D1*Dd*K*Pk2*f - 4256*D1*Dd*K*Pk2*fd*r**2 - 5600*D1*Dd*K*Pk2*fd*r*s - 84*D1*Dd*K*Pk2*fd*r + 1568*D1*Dd*K*Pk2*fd*s**2 - 4816*D1*Dd*K*Pk2*fd*s + 2912*D1*Dd*K*Pk2*fd - 140*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 70*D1*Dd*K*Pkdd2*f*k1**2*s - 35*D1*Dd*K*Pkdd2*f*k1**2 - 3024*D1*Dd*Pk2*f**2*r**2 - 5376*D1*Dd*Pk2*f**2*r*s + 4368*D1*Dd*Pk2*f**2*r - 2352*D1*Dd*Pk2*f**2*s**2 + 3864*D1*Dd*Pk2*f**2*s - 2100*D1*Dd*Pk2*f**2 + 14784*D1*Dd*Pk2*f*fd*r**2 + 21504*D1*Dd*Pk2*f*fd*r*s - 18480*D1*Dd*Pk2*f*fd*r + 6720*D1*Dd*Pk2*f*fd*s**2 - 11424*D1*Dd*Pk2*f*fd*s + 5292*D1*Dd*Pk2*f*fd - 3192*D1*Dd*Pk2*f*r**2 - 7056*D1*Dd*Pk2*f*r*s + 4956*D1*Dd*Pk2*f*r - 2912*D1*Dd*Pk2*f*s**2 + 4984*D1*Dd*Pk2*f*s - 2324*D1*Dd*Pk2*f + 6272*D1*Dd*Pk2*fd*r**2 + 14336*D1*Dd*Pk2*fd*r*s + 2128*D1*Dd*Pk2*fd*r + 5152*D1*Dd*Pk2*fd*s**2 + 2744*D1*Dd*Pk2*fd*s - 5432*D1*Dd*Pk2*fd - 3920*D1*Dd*Pk2*g2*r**2 - 1120*D1*Dd*Pk2*g2*r*s + 4200*D1*Dd*Pk2*g2*r + 2800*D1*Dd*Pk2*g2*s**2 - 840*D1*Dd*Pk2*g2*s - 1260*D1*Dd*Pk2*g2 - 7840*D1*Dd*Pk2*gd2*r**2 - 15680*D1*Dd*Pk2*gd2*r*s + 13720*D1*Dd*Pk2*gd2*r - 7840*D1*Dd*Pk2*gd2*s**2 + 13720*D1*Dd*Pk2*gd2*s - 5880*D1*Dd*Pk2*gd2 - 120*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 60*D1*Dd*Pkdd2*f**2*k1**2*s - 30*D1*Dd*Pkdd2*f**2*k1**2 + 240*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 60*D1*Dd*Pkdd2*f*fd*k1**2*s + 140*D1*Dd*Pkdd2*f*k1**2*s**2 - 70*D1*Dd*Pkdd2*f*k1**2*s + 35*D1*Dd*Pkdd2*f*k1**2 - 2128*D1*Ddd*K*Pk2*f*r**2 - 2800*D1*Ddd*K*Pk2*f*r*s + 2828*D1*Ddd*K*Pk2*f*r + 784*D1*Ddd*K*Pk2*f*s**2 + 1008*D1*Ddd*K*Pk2*f*s - 868*D1*Ddd*K*Pk2*f + 3696*D1*Ddd*Pk2*f**2*r**2 + 5376*D1*Ddd*Pk2*f**2*r*s - 5040*D1*Ddd*Pk2*f**2*r + 1680*D1*Ddd*Pk2*f**2*s**2 - 3528*D1*Ddd*Pk2*f**2*s + 2268*D1*Ddd*Pk2*f**2 + 3136*D1*Ddd*Pk2*f*r**2 + 7168*D1*Ddd*Pk2*f*r*s - 4928*D1*Ddd*Pk2*f*r + 2576*D1*Ddd*Pk2*f*s**2 - 4872*D1*Ddd*Pk2*f*s + 2212*D1*Ddd*Pk2*f - 3920*D1*Ddd*Pk2*g2*r**2 - 7840*D1*Ddd*Pk2*g2*r*s + 5880*D1*Ddd*Pk2*g2*r - 3920*D1*Ddd*Pk2*g2*s**2 + 5880*D1*Ddd*Pk2*g2*s - 2940*D1*Ddd*Pk2*g2 + 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 30*D1*Ddd*Pkdd2*f**2*k1**2*s + 15*D1*Ddd*Pkdd2*f**2*k1**2 + 70*D1*Pk2*bd1*(K - 1)*(D1*(21*r**2 + 6*r*s - 16*r - 15*s**2 + 8*s + 2) + 14*Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 6384*Dd**2*K*Pk2*f*r**2 - 8400*Dd**2*K*Pk2*f*r*s + 8484*Dd**2*K*Pk2*f*r + 2352*Dd**2*K*Pk2*f*s**2 + 3024*Dd**2*K*Pk2*f*s - 2464*Dd**2*K*Pk2*f + 11088*Dd**2*Pk2*f**2*r**2 + 16128*Dd**2*Pk2*f**2*r*s - 15120*Dd**2*Pk2*f**2*r + 5040*Dd**2*Pk2*f**2*s**2 - 10584*Dd**2*Pk2*f**2*s + 4536*Dd**2*Pk2*f**2 + 9408*Dd**2*Pk2*f*r**2 + 21504*Dd**2*Pk2*f*r*s - 14784*Dd**2*Pk2*f*r + 7728*Dd**2*Pk2*f*s**2 - 14616*Dd**2*Pk2*f*s + 5152*Dd**2*Pk2*f - 11760*Dd**2*Pk2*g2*r**2 - 23520*Dd**2*Pk2*g2*r*s + 17640*Dd**2*Pk2*g2*r - 11760*Dd**2*Pk2*g2*s**2 + 17640*Dd**2*Pk2*g2*s - 5880*Dd**2*Pk2*g2 + 180*Dd**2*Pkdd2*f**2*k1**2*s**2 - 90*Dd**2*Pkdd2*f**2*k1**2*s) - 3*b1*(2088*C*D1**2*Pk2*f*fd*r**2 + 2448*C*D1**2*Pk2*f*fd*r*s - 1272*C*D1**2*Pk2*f*fd*r - 608*C*D1**2*Pk2*f*fd*s**2 + 408*C*D1**2*Pk2*f*fd*s + 228*C*D1**2*Pk2*f*fd - 1632*C*D1**2*Pk2*f*fdd*r**2 - 2064*C*D1**2*Pk2*f*fdd*r*s + 720*C*D1**2*Pk2*f*fdd*r + 752*C*D1**2*Pk2*f*fdd*s**2 - 792*C*D1**2*Pk2*f*fdd*s + 96*C*D1**2*Pk2*f*fdd - 1632*C*D1**2*Pk2*fd**2*r**2 - 2064*C*D1**2*Pk2*fd**2*r*s + 720*C*D1**2*Pk2*fd**2*r + 752*C*D1**2*Pk2*fd**2*s**2 - 792*C*D1**2*Pk2*fd**2*s + 912*C*D1**2*Pk2*fd**2 - 84*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 4176*C*D1*Dd*Pk2*f**2*r**2 + 4896*C*D1*Dd*Pk2*f**2*r*s - 5400*C*D1*Dd*Pk2*f**2*r - 1216*C*D1*Dd*Pk2*f**2*s**2 - 1840*C*D1*Dd*Pk2*f**2*s + 1784*C*D1*Dd*Pk2*f**2 - 13056*C*D1*Dd*Pk2*f*fd*r**2 - 16512*C*D1*Dd*Pk2*f*fd*r*s + 11472*C*D1*Dd*Pk2*f*fd*r + 6016*C*D1*Dd*Pk2*f*fd*s**2 - 544*C*D1*Dd*Pk2*f*fd*s - 648*C*D1*Dd*Pk2*f*fd - 168*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 84*C*D1*Dd*Pkdd2*f**2*k1**2*s - 42*C*D1*Dd*Pkdd2*f**2*k1**2 - 3264*C*D1*Ddd*Pk2*f**2*r**2 - 4128*C*D1*Ddd*Pk2*f**2*r*s + 4296*C*D1*Ddd*Pk2*f**2*r + 1504*C*D1*Ddd*Pk2*f**2*s**2 + 1312*C*D1*Ddd*Pk2*f**2*s - 1256*C*D1*Ddd*Pk2*f**2 - 9792*C*Dd**2*Pk2*f**2*r**2 - 12384*C*Dd**2*Pk2*f**2*r*s + 12888*C*Dd**2*Pk2*f**2*r + 4512*C*Dd**2*Pk2*f**2*s**2 + 3936*C*Dd**2*Pk2*f**2*s - 3696*C*Dd**2*Pk2*f**2 + 168*D1**2*K*Pk2*f*fd*r**2 + 3808*D1**2*K*Pk2*f*fd*r*s - 1904*D1**2*K*Pk2*f*fd*r + 4284*D1**2*K*Pk2*f*fd*s**2 - 4284*D1**2*K*Pk2*f*fd*s + 2142*D1**2*K*Pk2*f*fd - 420*D1**2*K*Pk2*f*fdd*r**2 - 3808*D1**2*K*Pk2*f*fdd*r*s + 1904*D1**2*K*Pk2*f*fdd*r - 4116*D1**2*K*Pk2*f*fdd*s**2 + 4116*D1**2*K*Pk2*f*fdd*s - 2058*D1**2*K*Pk2*f*fdd - 420*D1**2*K*Pk2*fd**2*r**2 - 3808*D1**2*K*Pk2*fd**2*r*s + 1904*D1**2*K*Pk2*fd**2*r - 4116*D1**2*K*Pk2*fd**2*s**2 + 4116*D1**2*K*Pk2*fd**2*s + 980*D1**2*Pk2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 1512*D1**2*Pk2*f**2*fd*r**2 - 1386*D1**2*Pk2*f**2*fd*r - 1512*D1**2*Pk2*f**2*fd*s**2 + 378*D1**2*Pk2*f**2*fd*s + 504*D1**2*Pk2*f**2*fd - 1512*D1**2*Pk2*f**2*fdd*r**2 + 1386*D1**2*Pk2*f**2*fdd*r + 1512*D1**2*Pk2*f**2*fdd*s**2 - 378*D1**2*Pk2*f**2*fdd*s - 504*D1**2*Pk2*f**2*fdd - 3024*D1**2*Pk2*f*fd**2*r**2 + 2772*D1**2*Pk2*f*fd**2*r + 3024*D1**2*Pk2*f*fd**2*s**2 - 756*D1**2*Pk2*f*fd**2*s - 378*D1**2*Pk2*f*fd**2 - 3300*D1**2*Pk2*f*fd*r**2 - 6524*D1**2*Pk2*f*fd*r*s + 3346*D1**2*Pk2*f*fd*r - 2536*D1**2*Pk2*f*fd*s**2 + 2976*D1**2*Pk2*f*fd*s - 1836*D1**2*Pk2*f*fd + 3120*D1**2*Pk2*f*fdd*r**2 + 6188*D1**2*Pk2*f*fdd*r*s - 2926*D1**2*Pk2*f*fdd*r + 2248*D1**2*Pk2*f*fdd*s**2 - 2580*D1**2*Pk2*f*fdd*s + 1548*D1**2*Pk2*f*fdd - 1148*D1**2*Pk2*f*gd2*r**2 - 1400*D1**2*Pk2*f*gd2*r*s + 2296*D1**2*Pk2*f*gd2*r + 224*D1**2*Pk2*f*gd2*s**2 + 1400*D1**2*Pk2*f*gd2*s - 1148*D1**2*Pk2*f*gd2 + 1064*D1**2*Pk2*f*gdd2*r**2 + 1400*D1**2*Pk2*f*gdd2*r*s - 2128*D1**2*Pk2*f*gdd2*r - 392*D1**2*Pk2*f*gdd2*s**2 - 1400*D1**2*Pk2*f*gdd2*s + 1064*D1**2*Pk2*f*gdd2 + 3120*D1**2*Pk2*fd**2*r**2 + 6188*D1**2*Pk2*fd**2*r*s - 2926*D1**2*Pk2*fd**2*r + 2248*D1**2*Pk2*fd**2*s**2 - 2580*D1**2*Pk2*fd**2*s - 684*D1**2*Pk2*fd**2 - 1148*D1**2*Pk2*fd*g2*r**2 - 1400*D1**2*Pk2*fd*g2*r*s - 1232*D1**2*Pk2*fd*g2*r + 224*D1**2*Pk2*fd*g2*s**2 - 2464*D1**2*Pk2*fd*g2*s + 1232*D1**2*Pk2*fd*g2 + 2128*D1**2*Pk2*fd*gd2*r**2 + 2800*D1**2*Pk2*fd*gd2*r*s - 672*D1**2*Pk2*fd*gd2*r - 784*D1**2*Pk2*fd*gd2*s**2 + 1512*D1**2*Pk2*fd*gd2*s - 1456*D1**2*Pk2*fd*gd2 + 1064*D1**2*Pk2*fdd*g2*r**2 + 1400*D1**2*Pk2*fdd*g2*r*s + 1456*D1**2*Pk2*fdd*g2*r - 392*D1**2*Pk2*fdd*g2*s**2 + 2912*D1**2*Pk2*fdd*g2*s - 1456*D1**2*Pk2*fdd*g2 - 90*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 30*D1**2*Pkdd2*f**2*fd*k1**2*s + 15*D1**2*Pkdd2*f**2*fd*k1**2 + 84*D1**2*Pkdd2*f*fd*k1**2*s**2 + 70*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 70*D1**2*Pkdd2*fd*g2*k1**2*s**2 + D1**2*bdd1*(28*Pk2*f*(C*(50*r**2 + 84*r*s - 42*r + 34*s**2 - 34*s + 17) + K*(-38*r**2 - 50*r*s + 89*r + 14*s**2 + 63*s - 38) + 56*r**2 + 128*r*s - 183*r + 46*s**2 - 178*s + 89) - 980*Pk2*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*f**2*(28*Pk2*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 336*D1*Dd*K*Pk2*f**2*r**2 + 7616*D1*Dd*K*Pk2*f**2*r*s - 2240*D1*Dd*K*Pk2*f**2*r + 8568*D1*Dd*K*Pk2*f**2*s**2 - 8092*D1*Dd*K*Pk2*f**2*s + 2310*D1*Dd*K*Pk2*f**2 - 3360*D1*Dd*K*Pk2*f*fd*r**2 - 30464*D1*Dd*K*Pk2*f*fd*r*s + 13104*D1*Dd*K*Pk2*f*fd*r - 32928*D1*Dd*K*Pk2*f*fd*s**2 + 32312*D1*Dd*K*Pk2*f*fd*s - 7924*D1*Dd*K*Pk2*f*fd + 2016*D1*Dd*Pk2*f**3*r**2 - 2016*D1*Dd*Pk2*f**3*r - 2016*D1*Dd*Pk2*f**3*s**2 + 1008*D1*Dd*Pk2*f**3*s + 504*D1*Dd*Pk2*f**3 - 12096*D1*Dd*Pk2*f**2*fd*r**2 + 11592*D1*Dd*Pk2*f**2*fd*r + 12096*D1*Dd*Pk2*f**2*fd*s**2 - 4536*D1*Dd*Pk2*f**2*fd*s - 2394*D1*Dd*Pk2*f**2*fd - 6600*D1*Dd*Pk2*f**2*r**2 - 13048*D1*Dd*Pk2*f**2*r*s + 9862*D1*Dd*Pk2*f**2*r - 5072*D1*Dd*Pk2*f**2*s**2 + 9060*D1*Dd*Pk2*f**2*s - 4568*D1*Dd*Pk2*f**2 + 24960*D1*Dd*Pk2*f*fd*r**2 + 49504*D1*Dd*Pk2*f*fd*r*s - 30372*D1*Dd*Pk2*f*fd*r + 17984*D1*Dd*Pk2*f*fd*s**2 - 27192*D1*Dd*Pk2*f*fd*s + 8432*D1*Dd*Pk2*f*fd - 4592*D1*Dd*Pk2*f*g2*r**2 - 5600*D1*Dd*Pk2*f*g2*r*s + 5992*D1*Dd*Pk2*f*g2*r + 896*D1*Dd*Pk2*f*g2*s**2 + 2352*D1*Dd*Pk2*f*g2*s - 2072*D1*Dd*Pk2*f*g2 + 8512*D1*Dd*Pk2*f*gd2*r**2 + 11200*D1*Dd*Pk2*f*gd2*r*s - 14168*D1*Dd*Pk2*f*gd2*r - 3136*D1*Dd*Pk2*f*gd2*s**2 - 7616*D1*Dd*Pk2*f*gd2*s + 5656*D1*Dd*Pk2*f*gd2 + 8512*D1*Dd*Pk2*fd*g2*r**2 + 11200*D1*Dd*Pk2*fd*g2*r*s + 168*D1*Dd*Pk2*fd*g2*r - 3136*D1*Dd*Pk2*fd*g2*s**2 + 9632*D1*Dd*Pk2*fd*g2*s - 5824*D1*Dd*Pk2*fd*g2 - 120*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 60*D1*Dd*Pkdd2*f**3*k1**2*s - 30*D1*Dd*Pkdd2*f**3*k1**2 + 168*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 84*D1*Dd*Pkdd2*f**2*k1**2*s + 42*D1*Dd*Pkdd2*f**2*k1**2 + 280*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 140*D1*Dd*Pkdd2*f*g2*k1**2*s + 70*D1*Dd*Pkdd2*f*g2*k1**2 - 840*D1*Ddd*K*Pk2*f**2*r**2 - 7616*D1*Ddd*K*Pk2*f**2*r*s + 2744*D1*Ddd*K*Pk2*f**2*r - 8232*D1*Ddd*K*Pk2*f**2*s**2 + 7924*D1*Ddd*K*Pk2*f**2*s - 2478*D1*Ddd*K*Pk2*f**2 - 2016*D1*Ddd*Pk2*f**3*r**2 + 2016*D1*Ddd*Pk2*f**3*r + 2016*D1*Ddd*Pk2*f**3*s**2 - 1008*D1*Ddd*Pk2*f**3*s - 504*D1*Ddd*Pk2*f**3 + 6240*D1*Ddd*Pk2*f**2*r**2 + 12376*D1*Ddd*Pk2*f**2*r*s - 9334*D1*Ddd*Pk2*f**2*r + 4496*D1*Ddd*Pk2*f**2*s**2 - 8436*D1*Ddd*Pk2*f**2*s + 4244*D1*Ddd*Pk2*f**2 + 4256*D1*Ddd*Pk2*f*g2*r**2 + 5600*D1*Ddd*Pk2*f*g2*r*s - 5656*D1*Ddd*Pk2*f*g2*r - 1568*D1*Ddd*Pk2*f*g2*s**2 - 2016*D1*Ddd*Pk2*f*g2*s + 1736*D1*Ddd*Pk2*f*g2 + D1*bd1*(-D1*(-28*Pk2*(fd*(2*C*(50*r**2 + r*(84*s - 71) + 34*s**2 - 59*s + 21) + K*(-76*r**2 - 100*r*s + 37*r + 28*s**2 - 41*s + 26) + 112*r**2 + 256*r*s - 57*r + 92*s**2 - 42*s - 55) - 5*g2*(14*r**2 + 4*r*s - 2*r - 10*s**2 + 10*s - 5) - 70*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*f**2*(14*Pk2*(18*r**2 + r*(32*s - 33) + 14*s**2 - 35*s + 18) + 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(14*Pk2*(2*C*(30*r**2 + 68*r*s - 34*r + 38*s**2 - 38*s + 19) - 82*K*r**2 - 100*K*r*s + 176*K*r + 16*K*s**2 + 122*K*s - 77*K - 6*fd*(88*r**2 + 8*r*(16*s - 15) + 40*s**2 - 84*s + 35) + 114*r**2 + 252*r*s - 322*r + 104*s**2 - 342*s + 161) + 5*Pkdd2*k1**2*(7*K*(2*s**2 - 2*s + 1) - s**2*(24*fd + 14) + s*(12*fd + 14) - 7))) + 2*Dd*(14*Pk2*f*(2*C*(200*r**2 + r*(336*s - 226) + 136*s**2 - 186*s + 59) + K*(-304*r**2 - 400*r*s + 558*r + 112*s**2 + 324*s - 241) + 448*r**2 + 1024*r*s - 1084*r + 368*s**2 - 1060*s + 544) - 980*Pk2*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 3*f**2*(14*Pk2*(176*r**2 + 4*r*(64*s - 65) + 80*s**2 - 200*s + 99) + 5*Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) - 2520*Dd**2*K*Pk2*f**2*r**2 - 22848*Dd**2*K*Pk2*f**2*r*s + 8232*Dd**2*K*Pk2*f**2*r - 24696*Dd**2*K*Pk2*f**2*s**2 + 23772*Dd**2*K*Pk2*f**2*s - 4228*Dd**2*K*Pk2*f**2 - 6048*Dd**2*Pk2*f**3*r**2 + 6048*Dd**2*Pk2*f**3*r + 6048*Dd**2*Pk2*f**3*s**2 - 3024*Dd**2*Pk2*f**3*s - 1008*Dd**2*Pk2*f**3 + 18720*Dd**2*Pk2*f**2*r**2 + 37128*Dd**2*Pk2*f**2*r*s - 28002*Dd**2*Pk2*f**2*r + 13488*Dd**2*Pk2*f**2*s**2 - 25308*Dd**2*Pk2*f**2*s + 9308*Dd**2*Pk2*f**2 + 12768*Dd**2*Pk2*f*g2*r**2 + 16800*Dd**2*Pk2*f*g2*r*s - 16968*Dd**2*Pk2*f*g2*r - 4704*Dd**2*Pk2*f*g2*s**2 - 6048*Dd**2*Pk2*f*g2*s + 4928*Dd**2*Pk2*f*g2))/(630*d**2*k3**4) + D1**2*Pk3*ct**2*k2**2*st**4*(-840*C*D1**2*Pk2*f**2*fd*r**2 + 3648*C*D1**2*Pk2*f**2*fd*r*s - 656*C*D1**2*Pk2*f**2*fd*r + 1440*C*D1**2*Pk2*f**2*fd*s**2 - 2176*C*D1**2*Pk2*f**2*fd*s + 200*C*D1**2*Pk2*f**2*fd + 780*C*D1**2*Pk2*f**2*fdd*r**2 - 2400*C*D1**2*Pk2*f**2*fdd*r*s + 280*C*D1**2*Pk2*f**2*fdd*r - 720*C*D1**2*Pk2*f**2*fdd*s**2 + 1280*C*D1**2*Pk2*f**2*fdd*s + 20*C*D1**2*Pk2*f**2*fdd + 1560*C*D1**2*Pk2*f*fd**2*r**2 - 4800*C*D1**2*Pk2*f*fd**2*r*s + 560*C*D1**2*Pk2*f*fd**2*r - 1440*C*D1**2*Pk2*f*fd**2*s**2 + 2560*C*D1**2*Pk2*f*fd**2*s - 800*C*D1**2*Pk2*f*fd**2 - 24*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 12*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 12*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 222*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 148*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 74*C*D1**2*Pkdd2*f**2*fd*k1**2 + 120*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 80*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 40*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 240*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 160*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 1120*C*D1*Dd*Pk2*f**3*r**2 + 4864*C*D1*Dd*Pk2*f**3*r*s - 96*C*D1*Dd*Pk2*f**3*r + 1920*C*D1*Dd*Pk2*f**3*s**2 - 3392*C*D1*Dd*Pk2*f**3*s - 80*C*D1*Dd*Pk2*f**3 + 6240*C*D1*Dd*Pk2*f**2*fd*r**2 - 19200*C*D1*Dd*Pk2*f**2*fd*r*s + 400*C*D1*Dd*Pk2*f**2*fd*r - 5760*C*D1*Dd*Pk2*f**2*fd*s**2 + 11360*C*D1*Dd*Pk2*f**2*fd*s - 1840*C*D1*Dd*Pk2*f**2*fd - 48*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 24*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 12*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 96*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 24*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 296*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 148*C*D1*Dd*Pkdd2*f**3*k1**2*s - 74*C*D1*Dd*Pkdd2*f**3*k1**2 + 960*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 560*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 80*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 1040*C*D1*Ddd*Pk2*f**3*r**2 - 3200*C*D1*Ddd*Pk2*f**3*r*s - 240*C*D1*Ddd*Pk2*f**3*r - 960*C*D1*Ddd*Pk2*f**3*s**2 + 2080*C*D1*Ddd*Pk2*f**3*s + 280*C*D1*Ddd*Pk2*f**3 + 24*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 12*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 6*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 160*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 80*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 40*C*D1*Ddd*Pkdd2*f**3*k1**2 + 3120*C*Dd**2*Pk2*f**3*r**2 - 9600*C*Dd**2*Pk2*f**3*r*s - 720*C*Dd**2*Pk2*f**3*r - 2880*C*Dd**2*Pk2*f**3*s**2 + 6240*C*Dd**2*Pk2*f**3*s - 1080*C*Dd**2*Pk2*f**3 + 72*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 36*C*Dd**2*Pkdd2*b1*f**2*k1**2*s + 480*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 240*C*Dd**2*Pkdd2*f**3*k1**2*s - 360*D1**2*K*Pk2*b1*f*fd*r**2 + 2880*D1**2*K*Pk2*b1*f*fd*r*s - 1440*D1**2*K*Pk2*b1*f*fd*r + 1440*D1**2*K*Pk2*b1*f*fd*s**2 - 1440*D1**2*K*Pk2*b1*f*fd*s + 720*D1**2*K*Pk2*b1*f*fd + 180*D1**2*K*Pk2*b1*f*fdd*r**2 - 1440*D1**2*K*Pk2*b1*f*fdd*r*s + 720*D1**2*K*Pk2*b1*f*fdd*r - 720*D1**2*K*Pk2*b1*f*fdd*s**2 + 720*D1**2*K*Pk2*b1*f*fdd*s - 360*D1**2*K*Pk2*b1*f*fdd + 180*D1**2*K*Pk2*b1*fd**2*r**2 - 1440*D1**2*K*Pk2*b1*fd**2*r*s + 720*D1**2*K*Pk2*b1*fd**2*r - 720*D1**2*K*Pk2*b1*fd**2*s**2 + 720*D1**2*K*Pk2*b1*fd**2*s - 42*D1**2*K*Pkdd2*b1**2*fd*k1**2*s**2 + 21*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s**2 - 198*D1**2*K*Pkdd2*b1*f*fd*k1**2*s**2 + 198*D1**2*K*Pkdd2*b1*f*fd*k1**2*s - 99*D1**2*K*Pkdd2*b1*f*fd*k1**2 + 120*D1**2*K*Pkdd2*b1*f*fdd*k1**2*s**2 - 120*D1**2*K*Pkdd2*b1*f*fdd*k1**2*s + 60*D1**2*K*Pkdd2*b1*f*fdd*k1**2 + 120*D1**2*K*Pkdd2*b1*fd**2*k1**2*s**2 - 120*D1**2*K*Pkdd2*b1*fd**2*k1**2*s + 540*D1**2*Pk2*b1*f**2*fd*r**2 - 360*D1**2*Pk2*b1*f**2*fd*r + 180*D1**2*Pk2*b1*f**2*fd - 540*D1**2*Pk2*b1*f**2*fdd*r**2 + 360*D1**2*Pk2*b1*f**2*fdd*r - 180*D1**2*Pk2*b1*f**2*fdd - 1080*D1**2*Pk2*b1*f*fd**2*r**2 + 720*D1**2*Pk2*b1*f*fd**2*r + 1080*D1**2*Pk2*b1*f*fd*r**2 - 540*D1**2*Pk2*b1*f*fdd*r**2 - 540*D1**2*Pk2*b1*fd**2*r**2 + 1440*D1**2*Pk2*b2*f*fd*r*s - 720*D1**2*Pk2*b2*f*fd*r + 1440*D1**2*Pk2*b2*f*fd*s**2 - 1440*D1**2*Pk2*b2*f*fd*s + 720*D1**2*Pk2*b2*f*fd - 720*D1**2*Pk2*b2*f*fdd*r*s + 360*D1**2*Pk2*b2*f*fdd*r - 720*D1**2*Pk2*b2*f*fdd*s**2 + 720*D1**2*Pk2*b2*f*fdd*s - 360*D1**2*Pk2*b2*f*fdd - 720*D1**2*Pk2*b2*fd**2*r*s + 360*D1**2*Pk2*b2*fd**2*r - 720*D1**2*Pk2*b2*fd**2*s**2 + 720*D1**2*Pk2*b2*fd**2*s + 720*D1**2*Pk2*bd2*f**2*r*s + 720*D1**2*Pk2*bd2*f**2*s**2 - 720*D1**2*Pk2*bd2*f**2*s - 1440*D1**2*Pk2*bd2*f*fd*r*s + 360*D1**2*Pk2*bd2*f*fd*r - 1440*D1**2*Pk2*bd2*f*fd*s**2 + 1440*D1**2*Pk2*bd2*f*fd*s - 360*D1**2*Pk2*bd2*f*fd - 360*D1**2*Pk2*bdd2*f**2*r*s - 360*D1**2*Pk2*bdd2*f**2*s**2 + 360*D1**2*Pk2*bdd2*f**2*s - 360*D1**2*Pk2*f**3*fd*r**2 + 360*D1**2*Pk2*f**3*fd*r - 180*D1**2*Pk2*f**3*fd + 360*D1**2*Pk2*f**3*fdd*r**2 - 360*D1**2*Pk2*f**3*fdd*r + 180*D1**2*Pk2*f**3*fdd + 1080*D1**2*Pk2*f**2*fd**2*r**2 - 1080*D1**2*Pk2*f**2*fd**2*r + 180*D1**2*Pk2*f**2*fd**2 + 1392*D1**2*Pk2*f**2*fd*r**2 - 1824*D1**2*Pk2*f**2*fd*r*s - 320*D1**2*Pk2*f**2*fd*r - 720*D1**2*Pk2*f**2*fd*s**2 + 1088*D1**2*Pk2*f**2*fd*s + 224*D1**2*Pk2*f**2*fd - 1200*D1**2*Pk2*f**2*fdd*r**2 + 1200*D1**2*Pk2*f**2*fdd*r*s + 400*D1**2*Pk2*f**2*fdd*r + 360*D1**2*Pk2*f**2*fdd*s**2 - 640*D1**2*Pk2*f**2*fdd*s - 280*D1**2*Pk2*f**2*fdd + 360*D1**2*Pk2*f**2*gd2*r**2 - 2880*D1**2*Pk2*f**2*gd2*r*s - 720*D1**2*Pk2*f**2*gd2*r - 1440*D1**2*Pk2*f**2*gd2*s**2 + 2880*D1**2*Pk2*f**2*gd2*s + 360*D1**2*Pk2*f**2*gd2 - 180*D1**2*Pk2*f**2*gdd2*r**2 + 1440*D1**2*Pk2*f**2*gdd2*r*s + 360*D1**2*Pk2*f**2*gdd2*r + 720*D1**2*Pk2*f**2*gdd2*s**2 - 1440*D1**2*Pk2*f**2*gdd2*s - 180*D1**2*Pk2*f**2*gdd2 - 2400*D1**2*Pk2*f*fd**2*r**2 + 2400*D1**2*Pk2*f*fd**2*r*s + 800*D1**2*Pk2*f*fd**2*r + 720*D1**2*Pk2*f*fd**2*s**2 - 1280*D1**2*Pk2*f*fd**2*s + 400*D1**2*Pk2*f*fd**2 + 720*D1**2*Pk2*f*fd*g2*r**2 - 5760*D1**2*Pk2*f*fd*g2*r*s + 2880*D1**2*Pk2*f*fd*g2*r - 2880*D1**2*Pk2*f*fd*g2*s**2 + 2880*D1**2*Pk2*f*fd*g2*s - 1440*D1**2*Pk2*f*fd*g2 - 720*D1**2*Pk2*f*fd*gd2*r**2 + 5760*D1**2*Pk2*f*fd*gd2*r*s - 720*D1**2*Pk2*f*fd*gd2*r + 2880*D1**2*Pk2*f*fd*gd2*s**2 - 4320*D1**2*Pk2*f*fd*gd2*s + 1440*D1**2*Pk2*f*fd*gd2 - 360*D1**2*Pk2*f*fdd*g2*r**2 + 2880*D1**2*Pk2*f*fdd*g2*r*s - 1440*D1**2*Pk2*f*fdd*g2*r + 1440*D1**2*Pk2*f*fdd*g2*s**2 - 1440*D1**2*Pk2*f*fdd*g2*s + 720*D1**2*Pk2*f*fdd*g2 - 360*D1**2*Pk2*fd**2*g2*r**2 + 2880*D1**2*Pk2*fd**2*g2*r*s - 1440*D1**2*Pk2*fd**2*g2*r + 1440*D1**2*Pk2*fd**2*g2*s**2 - 1440*D1**2*Pk2*fd**2*g2*s + 42*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 21*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 180*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 - 180*D1**2*Pkdd2*b1*f**2*fd*k1**2*s + 90*D1**2*Pkdd2*b1*f**2*fd*k1**2 - 90*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 + 90*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s - 45*D1**2*Pkdd2*b1*f**2*fdd*k1**2 - 180*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 + 180*D1**2*Pkdd2*b1*f*fd**2*k1**2*s + 102*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 78*D1**2*Pkdd2*b1*f*fd*k1**2*s + 39*D1**2*Pkdd2*b1*f*fd*k1**2 - 72*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 60*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 30*D1**2*Pkdd2*b1*f*fdd*k1**2 + 84*D1**2*Pkdd2*b1*f*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*b1*f*gdd2*k1**2*s**2 - 72*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 60*D1**2*Pkdd2*b1*fd**2*k1**2*s + 84*D1**2*Pkdd2*b1*fd*g2*k1**2*s**2 - 84*D1**2*Pkdd2*b1*fd*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*b1*fdd*g2*k1**2*s**2 + 42*D1**2*Pkdd2*bd1**2*f*k1**2*s*(K - 1)*(s - 1) + 60*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 30*D1**2*Pkdd2*f**3*fd*k1**2*s + 15*D1**2*Pkdd2*f**3*fd*k1**2 + 162*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 108*D1**2*Pkdd2*f**2*fd*k1**2*s + 54*D1**2*Pkdd2*f**2*fd*k1**2 - 90*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 60*D1**2*Pkdd2*f**2*fdd*k1**2*s - 30*D1**2*Pkdd2*f**2*fdd*k1**2 + 198*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 120*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 180*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 120*D1**2*Pkdd2*f*fd**2*k1**2*s + 396*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 396*D1**2*Pkdd2*f*fd*g2*k1**2*s + 198*D1**2*Pkdd2*f*fd*g2*k1**2 - 480*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 240*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 240*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 240*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 120*D1**2*Pkdd2*f*fdd*g2*k1**2 - 240*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 240*D1**2*Pkdd2*fd**2*g2*k1**2*s - 3*D1**2*bdd1*f*(-7*Pkdd2*k1**2*(b1*(K - 1)*(2*s**2 - 2*s + 1) - 2*g2*(s - 1)**2) + 5*f**2*(12*Pk2*(r - 1)**2 + Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 2*f*(15*Pk2*(K*(r**2 - 2*r*(4*s + 1) - 4*s**2 + 8*s + 1) - 3*(r - 1)**2) + Pkdd2*k1**2*(C*(s - 1)**2 + s**2*(10*K - 6) + 2*s - 1))) - 720*D1*Dd*K*Pk2*b1*f**2*r**2 + 5760*D1*Dd*K*Pk2*b1*f**2*r*s - 720*D1*Dd*K*Pk2*b1*f**2*r + 2880*D1*Dd*K*Pk2*b1*f**2*s**2 - 4320*D1*Dd*K*Pk2*b1*f**2*s + 360*D1*Dd*K*Pk2*b1*f**2 + 1440*D1*Dd*K*Pk2*b1*f*fd*r**2 - 11520*D1*Dd*K*Pk2*b1*f*fd*r*s + 3600*D1*Dd*K*Pk2*b1*f*fd*r - 5760*D1*Dd*K*Pk2*b1*f*fd*s**2 + 7200*D1*Dd*K*Pk2*b1*f*fd*s - 2160*D1*Dd*K*Pk2*b1*f*fd - 168*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s**2 + 84*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s - 42*D1*Dd*K*Pkdd2*b1**2*f*k1**2 + 168*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s**2 - 42*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s - 396*D1*Dd*K*Pkdd2*b1*f**2*k1**2*s**2 + 198*D1*Dd*K*Pkdd2*b1*f**2*k1**2*s - 99*D1*Dd*K*Pkdd2*b1*f**2*k1**2 + 960*D1*Dd*K*Pkdd2*b1*f*fd*k1**2*s**2 - 720*D1*Dd*K*Pkdd2*b1*f*fd*k1**2*s + 120*D1*Dd*K*Pkdd2*b1*f*fd*k1**2 + 720*D1*Dd*Pk2*b1*f**3*r**2 - 720*D1*Dd*Pk2*b1*f**3*r + 360*D1*Dd*Pk2*b1*f**3 - 4320*D1*Dd*Pk2*b1*f**2*fd*r**2 + 3600*D1*Dd*Pk2*b1*f**2*fd*r - 720*D1*Dd*Pk2*b1*f**2*fd + 2160*D1*Dd*Pk2*b1*f**2*r**2 - 2160*D1*Dd*Pk2*b1*f**2*r + 1080*D1*Dd*Pk2*b1*f**2 - 4320*D1*Dd*Pk2*b1*f*fd*r**2 + 2160*D1*Dd*Pk2*b1*f*fd*r + 2880*D1*Dd*Pk2*b2*f**2*r*s - 720*D1*Dd*Pk2*b2*f**2*r + 2880*D1*Dd*Pk2*b2*f**2*s**2 - 2880*D1*Dd*Pk2*b2*f**2*s + 720*D1*Dd*Pk2*b2*f**2 - 5760*D1*Dd*Pk2*b2*f*fd*r*s + 2160*D1*Dd*Pk2*b2*f*fd*r - 5760*D1*Dd*Pk2*b2*f*fd*s**2 + 5760*D1*Dd*Pk2*b2*f*fd*s - 1440*D1*Dd*Pk2*b2*f*fd - 2880*D1*Dd*Pk2*bd2*f**2*r*s + 360*D1*Dd*Pk2*bd2*f**2*r - 2880*D1*Dd*Pk2*bd2*f**2*s**2 + 2880*D1*Dd*Pk2*bd2*f**2*s - 360*D1*Dd*Pk2*bd2*f**2 - 360*D1*Dd*Pk2*f**4*r**2 + 360*D1*Dd*Pk2*f**4*r - 180*D1*Dd*Pk2*f**4 + 2880*D1*Dd*Pk2*f**3*fd*r**2 - 2880*D1*Dd*Pk2*f**3*fd*r + 720*D1*Dd*Pk2*f**3*fd + 1856*D1*Dd*Pk2*f**3*r**2 - 2432*D1*Dd*Pk2*f**3*r*s - 1248*D1*Dd*Pk2*f**3*r - 960*D1*Dd*Pk2*f**3*s**2 + 1696*D1*Dd*Pk2*f**3*s + 688*D1*Dd*Pk2*f**3 - 9600*D1*Dd*Pk2*f**2*fd*r**2 + 9600*D1*Dd*Pk2*f**2*fd*r*s + 5200*D1*Dd*Pk2*f**2*fd*r + 2880*D1*Dd*Pk2*f**2*fd*s**2 - 5680*D1*Dd*Pk2*f**2*fd*s - 160*D1*Dd*Pk2*f**2*fd + 1440*D1*Dd*Pk2*f**2*g2*r**2 - 11520*D1*Dd*Pk2*f**2*g2*r*s + 1440*D1*Dd*Pk2*f**2*g2*r - 5760*D1*Dd*Pk2*f**2*g2*s**2 + 8640*D1*Dd*Pk2*f**2*g2*s - 720*D1*Dd*Pk2*f**2*g2 - 1440*D1*Dd*Pk2*f**2*gd2*r**2 + 11520*D1*Dd*Pk2*f**2*gd2*r*s + 720*D1*Dd*Pk2*f**2*gd2*r + 5760*D1*Dd*Pk2*f**2*gd2*s**2 - 10080*D1*Dd*Pk2*f**2*gd2*s + 720*D1*Dd*Pk2*f**2*gd2 - 2880*D1*Dd*Pk2*f*fd*g2*r**2 + 23040*D1*Dd*Pk2*f*fd*g2*r*s - 7200*D1*Dd*Pk2*f*fd*g2*r + 11520*D1*Dd*Pk2*f*fd*g2*s**2 - 14400*D1*Dd*Pk2*f*fd*g2*s + 4320*D1*Dd*Pk2*f*fd*g2 + 168*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 84*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 42*D1*Dd*Pkdd2*b1**2*f*k1**2 - 168*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 42*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 240*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 - 120*D1*Dd*Pkdd2*b1*f**3*k1**2*s + 60*D1*Dd*Pkdd2*b1*f**3*k1**2 - 720*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 + 540*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s - 90*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 + 204*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 102*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 51*D1*Dd*Pkdd2*b1*f**2*k1**2 - 576*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 384*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 60*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 336*D1*Dd*Pkdd2*b1*f*g2*k1**2*s**2 - 168*D1*Dd*Pkdd2*b1*f*g2*k1**2*s + 84*D1*Dd*Pkdd2*b1*f*g2*k1**2 - 336*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s**2 + 84*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s - 336*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s**2 + 84*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s + 60*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 30*D1*Dd*Pkdd2*f**4*k1**2*s + 15*D1*Dd*Pkdd2*f**4*k1**2 + 216*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 108*D1*Dd*Pkdd2*f**3*k1**2*s + 54*D1*Dd*Pkdd2*f**3*k1**2 - 720*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 420*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 60*D1*Dd*Pkdd2*f**2*fd*k1**2 + 792*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 396*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 198*D1*Dd*Pkdd2*f**2*g2*k1**2 - 960*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 240*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 1920*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 1440*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 240*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 360*D1*Ddd*K*Pk2*b1*f**2*r**2 - 2880*D1*Ddd*K*Pk2*b1*f**2*r*s + 360*D1*Ddd*K*Pk2*b1*f**2*r - 1440*D1*Ddd*K*Pk2*b1*f**2*s**2 + 2160*D1*Ddd*K*Pk2*b1*f**2*s - 180*D1*Ddd*K*Pk2*b1*f**2 + 84*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s**2 - 42*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s + 21*D1*Ddd*K*Pkdd2*b1**2*f*k1**2 + 240*D1*Ddd*K*Pkdd2*b1*f**2*k1**2*s**2 - 120*D1*Ddd*K*Pkdd2*b1*f**2*k1**2*s + 60*D1*Ddd*K*Pkdd2*b1*f**2*k1**2 - 720*D1*Ddd*Pk2*b1*f**3*r**2 + 720*D1*Ddd*Pk2*b1*f**3*r - 360*D1*Ddd*Pk2*b1*f**3 - 1080*D1*Ddd*Pk2*b1*f**2*r**2 + 1080*D1*Ddd*Pk2*b1*f**2*r - 540*D1*Ddd*Pk2*b1*f**2 - 1440*D1*Ddd*Pk2*b2*f**2*r*s + 360*D1*Ddd*Pk2*b2*f**2*r - 1440*D1*Ddd*Pk2*b2*f**2*s**2 + 1440*D1*Ddd*Pk2*b2*f**2*s - 360*D1*Ddd*Pk2*b2*f**2 + 360*D1*Ddd*Pk2*f**4*r**2 - 360*D1*Ddd*Pk2*f**4*r + 180*D1*Ddd*Pk2*f**4 - 1600*D1*Ddd*Pk2*f**3*r**2 + 1600*D1*Ddd*Pk2*f**3*r*s + 1200*D1*Ddd*Pk2*f**3*r + 480*D1*Ddd*Pk2*f**3*s**2 - 1040*D1*Ddd*Pk2*f**3*s - 680*D1*Ddd*Pk2*f**3 - 720*D1*Ddd*Pk2*f**2*g2*r**2 + 5760*D1*Ddd*Pk2*f**2*g2*r*s - 720*D1*Ddd*Pk2*f**2*g2*r + 2880*D1*Ddd*Pk2*f**2*g2*s**2 - 4320*D1*Ddd*Pk2*f**2*g2*s + 360*D1*Ddd*Pk2*f**2*g2 - 84*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 42*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 21*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 120*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 + 60*D1*Ddd*Pkdd2*b1*f**3*k1**2*s - 30*D1*Ddd*Pkdd2*b1*f**3*k1**2 - 144*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 72*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 36*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 168*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s**2 + 84*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s - 42*D1*Ddd*Pkdd2*b1*f*g2*k1**2 - 120*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 60*D1*Ddd*Pkdd2*f**3*k1**2*s - 30*D1*Ddd*Pkdd2*f**3*k1**2 - 480*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 240*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 120*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 3*D1*bd1*(D1*(14*Pkdd2*fd*k1**2*s*(b1*(K - 1)*(2*s - 1) - 2*g2*(s - 1)) + 10*f**3*(6*Pk2*(r - 1)**2 + Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - f**2*(60*Pk2*(K*(r**2 - 8*r*s - 2*r - 4*s**2 + 8*s + 1) + fd*(6*r**2 - 8*r + 2) - 3*(r - 1)**2) + Pkdd2*k1**2*(4*C*(s - 1)**2 + s**2*(33*K + 60*fd - 17) + 8*s - 4)) + 2*f*(-7*Pkdd2*k1**2*(b1*(K - 1)*(2*s**2 - 2*s + 1) + (2 - 2*s)*(g2*(s - 1) - gd2*s)) + 2*fd*(10*K*(3*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + Pkdd2*k1**2*s*(2*s - 1)) - 90*Pk2*r*(r - 1) + Pkdd2*k1**2*s*(2*C*(s - 1) - 12*s + 7)))) - 2*Dd*f*(-60*Pk2*f*(K*(2*r**2 - r*(16*s + 1) - 8*s**2 + 14*s - 1) - 6*r**2 + 9*r - 3) - 2*Pkdd2*f*k1**2*(4*s - 1)*(C*(s - 1) + s*(10*K - 6) + 1) - 7*Pkdd2*k1**2*(4*s - 1)*(b1*(K - 1)*(2*s - 1) - 2*g2*(s - 1)) + 5*f**2*(24*Pk2*(2*r**2 - 3*r + 1) + Pkdd2*k1**2*(8*s**2 + 2*s - 1)))) + 1080*Dd**2*K*Pk2*b1*f**2*r**2 - 8640*Dd**2*K*Pk2*b1*f**2*r*s + 1080*Dd**2*K*Pk2*b1*f**2*r - 4320*Dd**2*K*Pk2*b1*f**2*s**2 + 6480*Dd**2*K*Pk2*b1*f**2*s - 1260*Dd**2*K*Pk2*b1*f**2 + 252*Dd**2*K*Pkdd2*b1**2*f*k1**2*s**2 - 126*Dd**2*K*Pkdd2*b1**2*f*k1**2*s + 720*Dd**2*K*Pkdd2*b1*f**2*k1**2*s**2 - 360*Dd**2*K*Pkdd2*b1*f**2*k1**2*s - 2160*Dd**2*Pk2*b1*f**3*r**2 + 2160*Dd**2*Pk2*b1*f**3*r - 360*Dd**2*Pk2*b1*f**3 - 3240*Dd**2*Pk2*b1*f**2*r**2 + 3240*Dd**2*Pk2*b1*f**2*r - 540*Dd**2*Pk2*b1*f**2 - 4320*Dd**2*Pk2*b2*f**2*r*s + 1080*Dd**2*Pk2*b2*f**2*r - 4320*Dd**2*Pk2*b2*f**2*s**2 + 4320*Dd**2*Pk2*b2*f**2*s - 720*Dd**2*Pk2*b2*f**2 + 1080*Dd**2*Pk2*f**4*r**2 - 1080*Dd**2*Pk2*f**4*r + 180*Dd**2*Pk2*f**4 - 4800*Dd**2*Pk2*f**3*r**2 + 4800*Dd**2*Pk2*f**3*r*s + 3600*Dd**2*Pk2*f**3*r + 1440*Dd**2*Pk2*f**3*s**2 - 3120*Dd**2*Pk2*f**3*s - 2160*Dd**2*Pk2*f**2*g2*r**2 + 17280*Dd**2*Pk2*f**2*g2*r*s - 2160*Dd**2*Pk2*f**2*g2*r + 8640*Dd**2*Pk2*f**2*g2*s**2 - 12960*Dd**2*Pk2*f**2*g2*s + 2520*Dd**2*Pk2*f**2*g2 - 252*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 126*Dd**2*Pkdd2*b1**2*f*k1**2*s - 360*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 + 180*Dd**2*Pkdd2*b1*f**3*k1**2*s - 432*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 216*Dd**2*Pkdd2*b1*f**2*k1**2*s - 504*Dd**2*Pkdd2*b1*f*g2*k1**2*s**2 + 252*Dd**2*Pkdd2*b1*f*g2*k1**2*s - 360*Dd**2*Pkdd2*f**3*k1**2*s**2 + 180*Dd**2*Pkdd2*f**3*k1**2*s - 1440*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 720*Dd**2*Pkdd2*f**2*g2*k1**2*s)/(210*d**2*k3**4) + D1**2*Pk3*ct**2*k2**2*st**2*(-360*C*D1**2*Pk2*bdd1*f**2*r**2 - 672*C*D1**2*Pk2*bdd1*f**2*r*s - 4464*C*D1**2*Pk2*f**2*fd*r**2 - 9696*C*D1**2*Pk2*f**2*fd*r*s + 6208*C*D1**2*Pk2*f**2*fd*r - 2376*C*D1**2*Pk2*f**2*fd*s**2 + 4816*C*D1**2*Pk2*f**2*fd*s - 2280*C*D1**2*Pk2*f**2*fd + 4824*C*D1**2*Pk2*f**2*fdd*r**2 + 9024*C*D1**2*Pk2*f**2*fdd*r*s - 6224*C*D1**2*Pk2*f**2*fdd*r + 1944*C*D1**2*Pk2*f**2*fdd*s**2 - 4304*C*D1**2*Pk2*f**2*fdd*s + 2256*C*D1**2*Pk2*f**2*fdd + 9648*C*D1**2*Pk2*f*fd**2*r**2 + 18048*C*D1**2*Pk2*f*fd**2*r*s - 12448*C*D1**2*Pk2*f*fd**2*r + 3888*C*D1**2*Pk2*f*fd**2*s**2 - 8608*C*D1**2*Pk2*f*fd**2*s + 3008*C*D1**2*Pk2*f*fd**2 + 72*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 144*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 72*C*D1**2*Pkdd2*bdd1*f**2*k1**2 + 96*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 64*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 32*C*D1**2*Pkdd2*f**2*fd*k1**2 + 60*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 40*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 20*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 120*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 80*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 5952*C*D1*Dd*Pk2*f**3*r**2 - 12928*C*D1*Dd*Pk2*f**3*r*s + 9184*C*D1*Dd*Pk2*f**3*r - 3168*C*D1*Dd*Pk2*f**3*s**2 + 8048*C*D1*Dd*Pk2*f**3*s - 3768*C*D1*Dd*Pk2*f**3 + 38592*C*D1*Dd*Pk2*f**2*fd*r**2 + 72192*C*D1*Dd*Pk2*f**2*fd*r*s - 53216*C*D1*Dd*Pk2*f**2*fd*r + 15552*C*D1*Dd*Pk2*f**2*fd*s**2 - 39152*C*D1*Dd*Pk2*f**2*fd*s + 16752*C*D1*Dd*Pk2*f**2*fd + 128*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 64*C*D1*Dd*Pkdd2*f**3*k1**2*s + 32*C*D1*Dd*Pkdd2*f**3*k1**2 + 480*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 280*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 40*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 6432*C*D1*Ddd*Pk2*f**3*r**2 + 12032*C*D1*Ddd*Pk2*f**3*r*s - 9440*C*D1*Ddd*Pk2*f**3*r + 2592*C*D1*Ddd*Pk2*f**3*s**2 - 7312*C*D1*Ddd*Pk2*f**3*s + 3864*C*D1*Ddd*Pk2*f**3 + 80*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 40*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 20*C*D1*Ddd*Pkdd2*f**3*k1**2 + 19296*C*Dd**2*Pk2*f**3*r**2 + 36096*C*Dd**2*Pk2*f**3*r*s - 28320*C*Dd**2*Pk2*f**3*r + 7776*C*Dd**2*Pk2*f**3*s**2 - 21936*C*Dd**2*Pk2*f**3*s + 9232*C*Dd**2*Pk2*f**3 + 240*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 120*C*Dd**2*Pkdd2*f**3*k1**2*s + 756*D1**2*K*Pk2*bdd1*f**2*r**2 + 2016*D1**2*K*Pk2*bdd1*f**2*r*s - 1512*D1**2*K*Pk2*bdd1*f**2*r + 756*D1**2*K*Pk2*bdd1*f**2*s**2 - 2016*D1**2*K*Pk2*bdd1*f**2*s + 756*D1**2*K*Pk2*bdd1*f**2 + 18*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 504*D1**2*Pk2*b2*f*fd*r**2 - 2352*D1**2*Pk2*b2*f*fd*r*s + 1176*D1**2*Pk2*b2*f*fd*r - 1848*D1**2*Pk2*b2*f*fd*s**2 + 1848*D1**2*Pk2*b2*f*fd*s - 924*D1**2*Pk2*b2*f*fd + 840*D1**2*Pk2*b2*f*fdd*r**2 + 2352*D1**2*Pk2*b2*f*fdd*r*s - 1176*D1**2*Pk2*b2*f*fdd*r + 1512*D1**2*Pk2*b2*f*fdd*s**2 - 1512*D1**2*Pk2*b2*f*fdd*s + 756*D1**2*Pk2*b2*f*fdd + 840*D1**2*Pk2*b2*fd**2*r**2 + 2352*D1**2*Pk2*b2*fd**2*r*s - 1176*D1**2*Pk2*b2*fd**2*r + 1512*D1**2*Pk2*b2*fd**2*s**2 - 1512*D1**2*Pk2*b2*fd**2*s - 168*D1**2*Pk2*bdd1*f**3*r**2 - 420*D1**2*Pk2*bdd1*f**3*r*s + 504*D1**2*Pk2*bdd1*f**3*r + 420*D1**2*Pk2*bdd1*f**3*s - 252*D1**2*Pk2*bdd1*f**3 - 144*D1**2*Pk2*bdd1*f**2*r**2 - 84*D1**2*Pk2*bdd1*f**2*r*s + 504*D1**2*Pk2*bdd1*f**2*r + 420*D1**2*Pk2*bdd1*f**2*s - 168*D1**2*Pk2*bdd1*f**2 + 504*D1**2*Pk2*bdd1*f*g2*r**2 + 672*D1**2*Pk2*bdd1*f*g2*r*s + 420*D1**2*Pk2*bdd2*f**2*r**2 + 1176*D1**2*Pk2*bdd2*f**2*r*s - 840*D1**2*Pk2*bdd2*f**2*r + 756*D1**2*Pk2*bdd2*f**2*s**2 - 1176*D1**2*Pk2*bdd2*f**2*s + 420*D1**2*Pk2*bdd2*f**2 + 2556*D1**2*Pk2*f**2*fd*r**2 + 5940*D1**2*Pk2*f**2*fd*r*s - 3684*D1**2*Pk2*f**2*fd*r + 1188*D1**2*Pk2*f**2*fd*s**2 - 2772*D1**2*Pk2*f**2*fd*s + 1248*D1**2*Pk2*f**2*fd - 3060*D1**2*Pk2*f**2*fdd*r**2 - 5724*D1**2*Pk2*f**2*fdd*r*s + 3948*D1**2*Pk2*f**2*fdd*r - 972*D1**2*Pk2*f**2*fdd*s**2 + 2556*D1**2*Pk2*f**2*fdd*s - 1344*D1**2*Pk2*f**2*fdd + 1008*D1**2*Pk2*f**2*gd2*r**2 + 4032*D1**2*Pk2*f**2*gd2*r*s - 2016*D1**2*Pk2*f**2*gd2*r + 1848*D1**2*Pk2*f**2*gd2*s**2 - 4032*D1**2*Pk2*f**2*gd2*s + 1008*D1**2*Pk2*f**2*gd2 - 1512*D1**2*Pk2*f**2*gdd2*r**2 - 4032*D1**2*Pk2*f**2*gdd2*r*s + 3024*D1**2*Pk2*f**2*gdd2*r - 1512*D1**2*Pk2*f**2*gdd2*s**2 + 4032*D1**2*Pk2*f**2*gdd2*s - 1512*D1**2*Pk2*f**2*gdd2 - 6120*D1**2*Pk2*f*fd**2*r**2 - 11448*D1**2*Pk2*f*fd**2*r*s + 7896*D1**2*Pk2*f*fd**2*r - 1944*D1**2*Pk2*f*fd**2*s**2 + 5112*D1**2*Pk2*f*fd**2*s - 1908*D1**2*Pk2*f*fd**2 + 2016*D1**2*Pk2*f*fd*g2*r**2 + 8064*D1**2*Pk2*f*fd*g2*r*s - 4032*D1**2*Pk2*f*fd*g2*r + 3696*D1**2*Pk2*f*fd*g2*s**2 - 3696*D1**2*Pk2*f*fd*g2*s + 1848*D1**2*Pk2*f*fd*g2 - 6048*D1**2*Pk2*f*fd*gd2*r**2 - 16128*D1**2*Pk2*f*fd*gd2*r*s + 10080*D1**2*Pk2*f*fd*gd2*r - 6048*D1**2*Pk2*f*fd*gd2*s**2 + 11088*D1**2*Pk2*f*fd*gd2*s - 4032*D1**2*Pk2*f*fd*gd2 - 3024*D1**2*Pk2*f*fdd*g2*r**2 - 8064*D1**2*Pk2*f*fdd*g2*r*s + 4032*D1**2*Pk2*f*fdd*g2*r - 3024*D1**2*Pk2*f*fdd*g2*s**2 + 3024*D1**2*Pk2*f*fdd*g2*s - 1512*D1**2*Pk2*f*fdd*g2 - 3024*D1**2*Pk2*fd**2*g2*r**2 - 8064*D1**2*Pk2*fd**2*g2*r*s + 4032*D1**2*Pk2*fd**2*g2*r - 3024*D1**2*Pk2*fd**2*g2*s**2 + 3024*D1**2*Pk2*fd**2*g2*s - 54*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 108*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 54*D1**2*Pkdd2*bdd1*f**2*k1**2 - 168*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 + 336*D1**2*Pkdd2*bdd1*f*g2*k1**2*s - 168*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 102*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 68*D1**2*Pkdd2*f**2*fd*k1**2*s - 34*D1**2*Pkdd2*f**2*fd*k1**2 - 30*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 20*D1**2*Pkdd2*f**2*fdd*k1**2*s - 10*D1**2*Pkdd2*f**2*fdd*k1**2 - 96*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 36*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 60*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 40*D1**2*Pkdd2*f*fd**2*k1**2*s - 192*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 192*D1**2*Pkdd2*f*fd*g2*k1**2*s - 96*D1**2*Pkdd2*f*fd*g2*k1**2 - 144*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 72*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 72*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 72*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 36*D1**2*Pkdd2*f*fdd*g2*k1**2 - 72*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 72*D1**2*Pkdd2*fd**2*g2*k1**2*s + 12*D1**2*bd1**2*f*(14*Pk2*(2*K*s + f*(r - 1) - r**2*(3*K + 1) + r*(-4*K*s + 3*K + 2) - 1) - Pkdd2*k1**2*s*(s - 1)*(-14*K + 9*f + 7)) - 1008*D1*Dd*Pk2*b2*f**2*r**2 - 4704*D1*Dd*Pk2*b2*f**2*r*s + 2184*D1*Dd*Pk2*b2*f**2*r - 3696*D1*Dd*Pk2*b2*f**2*s**2 + 4200*D1*Dd*Pk2*b2*f**2*s - 1428*D1*Dd*Pk2*b2*f**2 + 6720*D1*Dd*Pk2*b2*f*fd*r**2 + 18816*D1*Dd*Pk2*b2*f*fd*r*s - 10416*D1*Dd*Pk2*b2*f*fd*r + 12096*D1*Dd*Pk2*b2*f*fd*s**2 - 13776*D1*Dd*Pk2*b2*f*fd*s + 3864*D1*Dd*Pk2*b2*f*fd + 3408*D1*Dd*Pk2*f**3*r**2 + 7920*D1*Dd*Pk2*f**3*r*s - 5388*D1*Dd*Pk2*f**3*r + 1584*D1*Dd*Pk2*f**3*s**2 - 4752*D1*Dd*Pk2*f**3*s + 2100*D1*Dd*Pk2*f**3 - 24480*D1*Dd*Pk2*f**2*fd*r**2 - 45792*D1*Dd*Pk2*f**2*fd*r*s + 33756*D1*Dd*Pk2*f**2*fd*r - 7776*D1*Dd*Pk2*f**2*fd*s**2 + 23616*D1*Dd*Pk2*f**2*fd*s - 10452*D1*Dd*Pk2*f**2*fd + 4032*D1*Dd*Pk2*f**2*g2*r**2 + 16128*D1*Dd*Pk2*f**2*g2*r*s - 8064*D1*Dd*Pk2*f**2*g2*r + 7392*D1*Dd*Pk2*f**2*g2*s**2 - 11760*D1*Dd*Pk2*f**2*g2*s + 3864*D1*Dd*Pk2*f**2*g2 - 12096*D1*Dd*Pk2*f**2*gd2*r**2 - 32256*D1*Dd*Pk2*f**2*gd2*r*s + 22176*D1*Dd*Pk2*f**2*gd2*r - 12096*D1*Dd*Pk2*f**2*gd2*s**2 + 27216*D1*Dd*Pk2*f**2*gd2*s - 10080*D1*Dd*Pk2*f**2*gd2 - 24192*D1*Dd*Pk2*f*fd*g2*r**2 - 64512*D1*Dd*Pk2*f*fd*g2*r*s + 36288*D1*Dd*Pk2*f*fd*g2*r - 24192*D1*Dd*Pk2*f*fd*g2*s**2 + 34272*D1*Dd*Pk2*f*fd*g2*s - 11088*D1*Dd*Pk2*f*fd*g2 - 136*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 68*D1*Dd*Pkdd2*f**3*k1**2*s - 34*D1*Dd*Pkdd2*f**3*k1**2 - 240*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 140*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 20*D1*Dd*Pkdd2*f**2*fd*k1**2 - 384*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 192*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 96*D1*Dd*Pkdd2*f**2*g2*k1**2 - 288*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 72*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 576*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 432*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 72*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 1680*D1*Ddd*Pk2*b2*f**2*r**2 + 4704*D1*Ddd*Pk2*b2*f**2*r*s - 2856*D1*Ddd*Pk2*b2*f**2*r + 3024*D1*Ddd*Pk2*b2*f**2*s**2 - 3864*D1*Ddd*Pk2*b2*f**2*s + 1596*D1*Ddd*Pk2*b2*f**2 - 4080*D1*Ddd*Pk2*f**3*r**2 - 7632*D1*Ddd*Pk2*f**3*r*s + 5988*D1*Ddd*Pk2*f**3*r - 1296*D1*Ddd*Pk2*f**3*s**2 + 4464*D1*Ddd*Pk2*f**3*s - 2364*D1*Ddd*Pk2*f**3 - 6048*D1*Ddd*Pk2*f**2*g2*r**2 - 16128*D1*Ddd*Pk2*f**2*g2*r*s + 10080*D1*Ddd*Pk2*f**2*g2*r - 6048*D1*Ddd*Pk2*f**2*g2*s**2 + 11088*D1*Ddd*Pk2*f**2*g2*s - 4536*D1*Ddd*Pk2*f**2*g2 - 40*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 20*D1*Ddd*Pkdd2*f**3*k1**2*s - 10*D1*Ddd*Pkdd2*f**3*k1**2 - 144*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 72*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 36*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 84*D1*Pk2*bd2*f*(D1*(f*(3*r**2 + 14*r*s - 6*r + 11*s**2 - 14*s + 3) - 2*fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 23*s + 7)) - 2*Dd*f*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17)) - 2*D1*bd1*(D1*(-3*f**3*(14*Pk2*(2*r**2 + r*(5*s - 6) - 5*s + 3) - 3*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) + f**2*(2*Pk2*(-138*C*r**2 - 224*C*r*s + 21*K*(6*r**2 + 24*r*s - 12*r + 11*s**2 - 24*s + 6) + 21*fd*(12*r**2 + 5*r*(6*s - 5) - 20*s + 11) + 47*r**2 + 49*r*s + 14*r + 63*s + 21) + Pkdd2*k1**2*(65*C*(s - 1)**2 - s**2*(24*K + 26) + 94*s - 47)) + f*(-6*fd*(Pk2*(56*C*s + 42*K*(6*r**2 + 2*r*(8*s - 5) + 6*s**2 - 11*s + 4) + r**2*(-120*C - 48) + r*(-224*C*s + 116*C - 28*s + 73) + 42*s - 49) + 3*Pkdd2*k1**2*s*(8*C*(s - 1) + K*(2*s - 1) - 6*s + 6)) - 7*g2*(-24*Pk2*r*(3*r + 4*s) + 19*Pkdd2*k1**2*(s - 1)**2) + 168*gd2*(Pk2*(-3*r**2 + r*(3 - 4*s) + 2*s) + Pkdd2*k1**2*s*(s - 1))) - 168*fd*g2*(Pk2*r*(3*r + 4*s - 2) - Pkdd2*k1**2*s*(s - 1))) + 6*Dd*f*(7*Pk2*f**2*(16*r**2 + r*(40*s - 37) - 30*s + 17) + f*(Pk2*(-42*K*(12*r**2 + r*(32*s - 22) + 12*s**2 - 27*s + 10) + r**2*(240*C + 96) + r*(16*C*(28*s - 11) + 56*s - 223) - s*(112*C + 154) + 119) - 3*Pkdd2*k1**2*(4*s - 1)*(4*C*(s - 1) + s*(K - 3) + 3)) + 28*g2*(4*Pk2*(-3*r**2 + r*(2 - 4*s) + s) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 5040*Dd**2*Pk2*b2*f**2*r**2 + 14112*Dd**2*Pk2*b2*f**2*r*s - 8568*Dd**2*Pk2*b2*f**2*r + 9072*Dd**2*Pk2*b2*f**2*s**2 - 11592*Dd**2*Pk2*b2*f**2*s + 3192*Dd**2*Pk2*b2*f**2 - 12240*Dd**2*Pk2*f**3*r**2 - 22896*Dd**2*Pk2*f**3*r*s + 17964*Dd**2*Pk2*f**3*r - 3888*Dd**2*Pk2*f**3*s**2 + 13392*Dd**2*Pk2*f**3*s - 5856*Dd**2*Pk2*f**3 - 18144*Dd**2*Pk2*f**2*g2*r**2 - 48384*Dd**2*Pk2*f**2*g2*r*s + 30240*Dd**2*Pk2*f**2*g2*r - 18144*Dd**2*Pk2*f**2*g2*s**2 + 33264*Dd**2*Pk2*f**2*g2*s - 11088*Dd**2*Pk2*f**2*g2 - 120*Dd**2*Pkdd2*f**3*k1**2*s**2 + 60*Dd**2*Pkdd2*f**3*k1**2*s - 432*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 216*Dd**2*Pkdd2*f**2*g2*k1**2*s + b1**2*(D1**2*(-12*fd**2*(14*Pk2*(r - 1) + 9*Pkdd2*k1**2*s**2) + fd*(168*Pk2*r*(K*(3*r + 4*s - 4) + f + r + 2) + Pkdd2*k1**2*s**2*(-133*K + 216*f + 49)) - 6*fdd*(14*Pk2*r*(K*(3*r + 4*s - 4) + 2*f + r + 2) + Pkdd2*k1**2*s**2*(-14*K + 18*f + 7))) + D1*(Dd*(108*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + f*(336*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) - 2*fd*r + fd + 2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-133*K*(4*s**2 - 2*s + 1) + s**2*(196 - 864*fd) + s*(216*fd - 98) + 49)) - 84*fd*(4*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) + 2*r**2 + r - 1) + Pkdd2*k1**2*s*(K*(2 - 8*s) + 4*s - 1))) - 6*Ddd*f*(28*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + 2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-14*K + 9*f + 7)*(4*s**2 - 2*s + 1))) - 12*Dd**2*f*(14*Pk2*(K*(18*r**2 + 24*r*(s - 1) - 12*s + 7) + 6*r**2 - 6*r + 1) + Pkdd2*k1**2*s*(2*s - 1)*(-42*K + 27*f + 21))) - b1*(-6*D1**2*bdd1*f*(-14*Pk2*(K*(6*r**2 + r*(8*s - 6) - 4*s + 3) + 2*r**2 - r*(2*f + 4) + 1) - Pkdd2*k1**2*(-14*K + 9*f + 7)*(2*s**2 - 2*s + 1)) + 2*D1**2*(-3*f**2*(-14*Pk2*fdd*(6*r**2 + r*(15*s - 7) - 5*s + 1) + fd*(14*Pk2*(6*r**2 + 15*r*s - 7*r - 5*s + 1) - 9*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + f*(42*Pk2*fd**2*(12*r**2 + 2*r*(15*s - 7) - 10*s + 3) + 6*Pk2*fdd*(2*C*(30*r**2 + r*(56*s - 58) - 28*s + 15) - 21*K*(6*r**2 + 16*r*s - 8*r + 6*s**2 - 6*s + 3) + 24*r**2 + 14*r*s + 11*r + 28*s - 2) + 168*Pk2*gd2*(r - 1)*(3*r + 4*s - 3) - 84*Pk2*gdd2*(r - 1)*(3*r + 4*s - 3) - 9*Pkdd2*fdd*k1**2*(K*(2*s**2 - 2*s + 1) + s**2*(8*C - 6)) - 133*Pkdd2*gd2*k1**2*s**2 + 84*Pkdd2*gdd2*k1**2*s**2 + fd*(2*Pk2*(-2*C*(138*r**2 + r*(224*s - 250) - 112*s + 69) + 21*K*(12*r**2 + 48*r*s - 24*r + 22*s**2 - 22*s + 11) + 94*r**2 + 98*r*s - 157*r - 112*s + 26) + Pkdd2*k1**2*(-24*K*(2*s**2 - 2*s + 1) + s**2*(130*C - 52) - 42*s + 21))) + 6*fd**2*(Pk2*(4*C*(15*r**2 + 28*r*s - 29*r - 14*s + 14) - 126*K*s**2 + 126*K*s + r**2*(24 - 126*K) + r*(-336*K*s + 168*K + 14*s + 11) + 28*s - 42) + 3*Pkdd2*k1**2*s*(-K*s + K + s*(3 - 4*C))) - 7*fd*(-24*Pk2*g2*r*(3*r + 4*s - 4) + 24*Pk2*gd2*(3*r**2 + r*(4*s - 5) - 2*s + 2) + 19*Pkdd2*g2*k1**2*s**2 - 24*Pkdd2*gd2*k1**2*s**2) + 84*fdd*g2*(Pk2*r*(-3*r - 4*s + 4) + Pkdd2*k1**2*s**2)) + D1*bd1*(D1*(-12*f**2*(-14*Pk2*r + 9*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - f*(168*Pk2*(K*(6*r**2 + r*(8*s - 6) - 4*s + 3) + 2*r**2 - 4*r + 1) + Pkdd2*k1**2*(-133*K*(2*s**2 - 2*s + 1) + s**2*(98 - 432*fd) + s*(216*fd - 98) + 49)) + 84*fd*(2*Pk2*(K*(6*r**2 + 8*r*s - 7*r - 2*s + 2) + 2*r**2 - 1) + Pkdd2*k1**2*s*(K*(2 - 4*s) + 2*s - 1))) + 12*Dd*f*(-28*Pk2*(2*r - 1)*(-2*K*(3*r + 4*s - 2) + f - 2*r + 2) + Pkdd2*k1**2*(-14*K + 9*f + 7)*(8*s**2 - 6*s + 1))) + 2*D1*(Dd*(-6*f**3*(7*Pk2*(8*r**2 + r*(20*s - 13) - 10*s + 4) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(2*Pk2*(-4*C*(138*r**2 + 2*r*(112*s - 97) - 112*s + 69) + 504*K*r**2 + 2016*K*r*s - 1008*K*r + 924*K*s**2 - 1470*K*s + 483*K + 21*fd*(48*r**2 + 120*r*s - 67*r - 50*s + 19) + 188*r**2 + 196*r*s - 237*r - 98*s + 94) + Pkdd2*k1**2*(65*C - 24*K - 26)*(4*s**2 - 2*s + 1)) + f*(336*Pk2*g2*(6*r**2 + 8*r*(s - 1) - 4*s + 3) - 672*Pk2*gd2*(3*r**2 + r*(4*s - 5) - 3*s + 2) - 133*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) - 168*Pkdd2*gd2*k1**2*s*(1 - 4*s) + 6*fd*(2*Pk2*(8*C*(2*r - 1)*(15*r + 28*s - 18) - 21*K*(24*r**2 + 64*r*s - 36*r + 24*s**2 - 34*s + 11) + 96*r**2 + 56*r*s - 33*r + 42*s - 25) - 3*Pkdd2*k1**2*(4*s - 1)*(8*C*s + 2*K*s - K - 6*s))) - 168*fd*g2*(4*Pk2*(3*r**2 + 4*r*(s - 1) - s + 1) + Pkdd2*k1**2*s*(1 - 4*s))) + 3*Ddd*f*(14*Pk2*f**2*(8*r**2 + r*(20*s - 13) - 10*s + 4) + f*(2*Pk2*(4*C*(30*r**2 + r*(56*s - 44) - 28*s + 15) - 21*K*(12*r**2 + 4*r*(8*s - 5) + 12*s**2 - 22*s + 9) + 48*r**2 + 28*r*s - 55*r - 14*s + 24) + Pkdd2*k1**2*(-12*C - 3*K + 9)*(4*s**2 - 2*s + 1)) + 28*g2*(-2*Pk2*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 12*Dd**2*f*(7*Pk2*f**2*(24*r**2 + r*(60*s - 39) - 30*s + 14) + f*(Pk2*(4*C*(90*r**2 + 12*r*(14*s - 11) - 84*s + 43) - 42*K*(18*r**2 + 6*r*(8*s - 5) + 18*s**2 - 33*s + 11) + 144*r**2 + 84*r*s - 165*r - 42*s + 38) + Pkdd2*k1**2*s*(2*s - 1)*(-36*C - 9*K + 27)) - 28*g2*(Pk2*(18*r**2 + 24*r*(s - 1) - 12*s + 7) + 3*Pkdd2*k1**2*s*(1 - 2*s)))))/(210*d**2*k3**4) - D1**2*Pk3*ct**2*k2**2*(4704*C*D1**2*Pk2*bd1**2*f*r**2 + 6720*C*D1**2*Pk2*bd1**2*f*r*s - 3360*C*D1**2*Pk2*bd1**2*f*r + 2016*C*D1**2*Pk2*bd1**2*f*s**2 - 2016*C*D1**2*Pk2*bd1**2*f*s + 6804*C*D1**2*Pk2*bd1*f**2*r**2 + 7752*C*D1**2*Pk2*bd1*f**2*r*s - 7824*C*D1**2*Pk2*bd1*f**2*r + 756*C*D1**2*Pk2*bd1*f**2*s**2 - 3024*C*D1**2*Pk2*bd1*f**2*s + 1512*C*D1**2*Pk2*bd1*f**2 - 16128*C*D1**2*Pk2*bd1*f*fd*r**2 - 25248*C*D1**2*Pk2*bd1*f*fd*r*s + 22488*C*D1**2*Pk2*bd1*f*fd*r - 5040*C*D1**2*Pk2*bd1*f*fd*s**2 + 13872*C*D1**2*Pk2*bd1*f*fd*s - 8112*C*D1**2*Pk2*bd1*f*fd - 4032*C*D1**2*Pk2*bdd1*f**2*r**2 - 6312*C*D1**2*Pk2*bdd1*f**2*r*s + 8112*C*D1**2*Pk2*bdd1*f**2*r - 1260*C*D1**2*Pk2*bdd1*f**2*s**2 + 5040*C*D1**2*Pk2*bdd1*f**2*s - 2520*C*D1**2*Pk2*bdd1*f**2 + 1956*C*D1**2*Pk2*f**2*fd*r**2 + 7128*C*D1**2*Pk2*f**2*fd*r*s - 3680*C*D1**2*Pk2*f**2*fd*r + 4536*C*D1**2*Pk2*f**2*fd*s**2 - 5400*C*D1**2*Pk2*f**2*fd*s + 2164*C*D1**2*Pk2*f**2*fd - 1356*C*D1**2*Pk2*f**2*fdd*r**2 - 7128*C*D1**2*Pk2*f**2*fdd*r*s + 3280*C*D1**2*Pk2*f**2*fdd*r - 4536*C*D1**2*Pk2*f**2*fdd*s**2 + 5400*C*D1**2*Pk2*f**2*fdd*s - 1964*C*D1**2*Pk2*f**2*fdd - 2712*C*D1**2*Pk2*f*fd**2*r**2 - 14256*C*D1**2*Pk2*f*fd**2*r*s + 6560*C*D1**2*Pk2*f*fd**2*r - 9072*C*D1**2*Pk2*f*fd**2*s**2 + 10800*C*D1**2*Pk2*f*fd**2*s - 2376*C*D1**2*Pk2*f*fd**2 - 324*C*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 + 648*C*D1**2*Pkdd2*bd1*f**2*k1**2*s - 324*C*D1**2*Pkdd2*bd1*f**2*k1**2 - 360*C*D1**2*Pkdd2*bd1*f*fd*k1**2*s**2 + 360*C*D1**2*Pkdd2*bd1*f*fd*k1**2*s - 90*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 180*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 90*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 270*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 180*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 90*C*D1**2*Pkdd2*f**2*fd*k1**2 - 32256*C*D1*Dd*Pk2*bd1*f**2*r**2 - 50496*C*D1*Dd*Pk2*bd1*f**2*r*s + 54888*C*D1*Dd*Pk2*bd1*f**2*r - 10080*C*D1*Dd*Pk2*bd1*f**2*s**2 + 35304*C*D1*Dd*Pk2*bd1*f**2*s - 21264*C*D1*Dd*Pk2*bd1*f**2 + 2608*C*D1*Dd*Pk2*f**3*r**2 + 9504*C*D1*Dd*Pk2*f**3*r*s - 4984*C*D1*Dd*Pk2*f**3*r + 6048*C*D1*Dd*Pk2*f**3*s**2 - 7776*C*D1*Dd*Pk2*f**3*s + 2816*C*D1*Dd*Pk2*f**3 - 10848*C*D1*Dd*Pk2*f**2*fd*r**2 - 57024*C*D1*Dd*Pk2*f**2*fd*r*s + 25672*C*D1*Dd*Pk2*f**2*fd*r - 36288*C*D1*Dd*Pk2*f**2*fd*s**2 + 44928*C*D1*Dd*Pk2*f**2*fd*s - 11960*C*D1*Dd*Pk2*f**2*fd - 720*C*D1*Dd*Pkdd2*bd1*f**2*k1**2*s**2 + 900*C*D1*Dd*Pkdd2*bd1*f**2*k1**2*s - 180*C*D1*Dd*Pkdd2*bd1*f**2*k1**2 - 360*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 180*C*D1*Dd*Pkdd2*f**3*k1**2*s - 90*C*D1*Dd*Pkdd2*f**3*k1**2 - 1808*C*D1*Ddd*Pk2*f**3*r**2 - 9504*C*D1*Ddd*Pk2*f**3*r*s + 4184*C*D1*Ddd*Pk2*f**3*r - 6048*C*D1*Ddd*Pk2*f**3*s**2 + 7776*C*D1*Ddd*Pk2*f**3*s - 2416*C*D1*Ddd*Pk2*f**3 - 5424*C*Dd**2*Pk2*f**3*r**2 - 28512*C*Dd**2*Pk2*f**3*r*s + 12552*C*Dd**2*Pk2*f**3*r - 18144*C*Dd**2*Pk2*f**3*s**2 + 23328*C*Dd**2*Pk2*f**3*s - 5656*C*Dd**2*Pk2*f**3 - 3360*D1**2*K*Pk2*bd1**2*f*r**2 - 5880*D1**2*K*Pk2*bd1**2*f*r*s + 7560*D1**2*K*Pk2*bd1**2*f*r - 2100*D1**2*K*Pk2*bd1**2*f*s**2 + 7140*D1**2*K*Pk2*bd1**2*f*s - 4200*D1**2*K*Pk2*bd1**2*f + 210*D1**2*K*Pk2*bd1*f**2*r**2 + 1260*D1**2*K*Pk2*bd1*f**2*r*s - 420*D1**2*K*Pk2*bd1*f**2*r + 1260*D1**2*K*Pk2*bd1*f**2*s**2 - 1260*D1**2*K*Pk2*bd1*f**2*s + 210*D1**2*K*Pk2*bd1*f**2 - 840*D1**2*K*Pk2*bd1*f*fd*r**2 - 5040*D1**2*K*Pk2*bd1*f*fd*r*s + 2100*D1**2*K*Pk2*bd1*f*fd*r - 5040*D1**2*K*Pk2*bd1*f*fd*s**2 + 5040*D1**2*K*Pk2*bd1*f*fd*s - 1260*D1**2*K*Pk2*bd1*f*fd - 210*D1**2*K*Pk2*bdd1*f**2*r**2 - 1260*D1**2*K*Pk2*bdd1*f**2*r*s + 420*D1**2*K*Pk2*bdd1*f**2*r - 1260*D1**2*K*Pk2*bdd1*f**2*s**2 + 1260*D1**2*K*Pk2*bdd1*f**2*s - 210*D1**2*K*Pk2*bdd1*f**2 - 126*D1**2*K*Pkdd2*bd1**2*f*k1**2*s**2 + 126*D1**2*K*Pkdd2*bd1**2*f*k1**2*s - 63*D1**2*K*Pkdd2*bd1*f**2*k1**2*s**2 + 1260*D1**2*Pk2*bd1**2*f**2*r**2 + 1260*D1**2*Pk2*bd1**2*f**2*r*s - 1890*D1**2*Pk2*bd1**2*f**2*r - 630*D1**2*Pk2*bd1**2*f**2*s + 630*D1**2*Pk2*bd1**2*f**2 - 2688*D1**2*Pk2*bd1**2*f*r**2 - 3276*D1**2*Pk2*bd1**2*f*r*s + 798*D1**2*Pk2*bd1**2*f*r - 1008*D1**2*Pk2*bd1**2*f*s**2 + 378*D1**2*Pk2*bd1**2*f*s + 630*D1**2*Pk2*bd1**2*f - 3360*D1**2*Pk2*bd1**2*g2*r**2 - 6720*D1**2*Pk2*bd1**2*g2*r*s + 3360*D1**2*Pk2*bd1**2*g2*r - 3360*D1**2*Pk2*bd1**2*g2*s**2 + 3360*D1**2*Pk2*bd1**2*g2*s - 2100*D1**2*Pk2*bd1*bd2*f*r**2 - 4200*D1**2*Pk2*bd1*bd2*f*r*s + 4200*D1**2*Pk2*bd1*bd2*f*r - 2100*D1**2*Pk2*bd1*bd2*f*s**2 + 4200*D1**2*Pk2*bd1*bd2*f*s - 2100*D1**2*Pk2*bd1*bd2*f - 4248*D1**2*Pk2*bd1*f**2*r**2 - 4482*D1**2*Pk2*bd1*f**2*r*s + 4266*D1**2*Pk2*bd1*f**2*r - 378*D1**2*Pk2*bd1*f**2*s**2 + 1512*D1**2*Pk2*bd1*f**2*s - 756*D1**2*Pk2*bd1*f**2 + 10512*D1**2*Pk2*bd1*f*fd*r**2 + 15768*D1**2*Pk2*bd1*f*fd*r*s - 14040*D1**2*Pk2*bd1*f*fd*r + 2520*D1**2*Pk2*bd1*f*fd*s**2 - 7722*D1**2*Pk2*bd1*f*fd*s + 4842*D1**2*Pk2*bd1*f*fd - 4620*D1**2*Pk2*bd1*f*g2*r**2 - 5880*D1**2*Pk2*bd1*f*g2*r*s + 5040*D1**2*Pk2*bd1*f*g2*r - 1260*D1**2*Pk2*bd1*f*g2*s**2 + 5040*D1**2*Pk2*bd1*f*g2*s - 2520*D1**2*Pk2*bd1*f*g2 + 6720*D1**2*Pk2*bd1*f*gd2*r**2 + 11760*D1**2*Pk2*bd1*f*gd2*r*s - 15120*D1**2*Pk2*bd1*f*gd2*r + 4200*D1**2*Pk2*bd1*f*gd2*s**2 - 14280*D1**2*Pk2*bd1*f*gd2*s + 8400*D1**2*Pk2*bd1*f*gd2 + 6720*D1**2*Pk2*bd1*fd*g2*r**2 + 11760*D1**2*Pk2*bd1*fd*g2*r*s - 5880*D1**2*Pk2*bd1*fd*g2*r + 4200*D1**2*Pk2*bd1*fd*g2*s**2 - 4200*D1**2*Pk2*bd1*fd*g2*s + 2628*D1**2*Pk2*bdd1*f**2*r**2 + 3942*D1**2*Pk2*bdd1*f**2*r*s - 4842*D1**2*Pk2*bdd1*f**2*r + 630*D1**2*Pk2*bdd1*f**2*s**2 - 2520*D1**2*Pk2*bdd1*f**2*s + 1260*D1**2*Pk2*bdd1*f**2 + 3360*D1**2*Pk2*bdd1*f*g2*r**2 + 5880*D1**2*Pk2*bdd1*f*g2*r*s - 8400*D1**2*Pk2*bdd1*f*g2*r + 2100*D1**2*Pk2*bdd1*f*g2*s**2 - 8400*D1**2*Pk2*bdd1*f*g2*s + 4200*D1**2*Pk2*bdd1*f*g2 - 978*D1**2*Pk2*f**2*fd*r**2 - 3564*D1**2*Pk2*f**2*fd*r*s + 1840*D1**2*Pk2*f**2*fd*r - 2268*D1**2*Pk2*f**2*fd*s**2 + 2700*D1**2*Pk2*f**2*fd*s - 1082*D1**2*Pk2*f**2*fd + 678*D1**2*Pk2*f**2*fdd*r**2 + 3564*D1**2*Pk2*f**2*fdd*r*s - 1640*D1**2*Pk2*f**2*fdd*r + 2268*D1**2*Pk2*f**2*fdd*s**2 - 2700*D1**2*Pk2*f**2*fdd*s + 982*D1**2*Pk2*f**2*fdd - 420*D1**2*Pk2*f**2*gd2*r**2 - 2520*D1**2*Pk2*f**2*gd2*r*s + 840*D1**2*Pk2*f**2*gd2*r - 2520*D1**2*Pk2*f**2*gd2*s**2 + 2520*D1**2*Pk2*f**2*gd2*s - 420*D1**2*Pk2*f**2*gd2 + 420*D1**2*Pk2*f**2*gdd2*r**2 + 2520*D1**2*Pk2*f**2*gdd2*r*s - 840*D1**2*Pk2*f**2*gdd2*r + 2520*D1**2*Pk2*f**2*gdd2*s**2 - 2520*D1**2*Pk2*f**2*gdd2*s + 420*D1**2*Pk2*f**2*gdd2 + 1356*D1**2*Pk2*f*fd**2*r**2 + 7128*D1**2*Pk2*f*fd**2*r*s - 3280*D1**2*Pk2*f*fd**2*r + 4536*D1**2*Pk2*f*fd**2*s**2 - 5400*D1**2*Pk2*f*fd**2*s + 1188*D1**2*Pk2*f*fd**2 - 840*D1**2*Pk2*f*fd*g2*r**2 - 5040*D1**2*Pk2*f*fd*g2*r*s + 2520*D1**2*Pk2*f*fd*g2*r - 5040*D1**2*Pk2*f*fd*g2*s**2 + 5040*D1**2*Pk2*f*fd*g2*s - 2520*D1**2*Pk2*f*fd*g2 + 1680*D1**2*Pk2*f*fd*gd2*r**2 + 10080*D1**2*Pk2*f*fd*gd2*r*s - 4200*D1**2*Pk2*f*fd*gd2*r + 10080*D1**2*Pk2*f*fd*gd2*s**2 - 10080*D1**2*Pk2*f*fd*gd2*s + 2520*D1**2*Pk2*f*fd*gd2 + 840*D1**2*Pk2*f*fdd*g2*r**2 + 5040*D1**2*Pk2*f*fdd*g2*r*s - 2520*D1**2*Pk2*f*fdd*g2*r + 5040*D1**2*Pk2*f*fdd*g2*s**2 - 5040*D1**2*Pk2*f*fdd*g2*s + 2520*D1**2*Pk2*f*fdd*g2 + 840*D1**2*Pk2*fd**2*g2*r**2 + 5040*D1**2*Pk2*fd**2*g2*r*s - 2520*D1**2*Pk2*fd**2*g2*r + 5040*D1**2*Pk2*fd**2*g2*s**2 - 5040*D1**2*Pk2*fd**2*g2*s + 288*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 - 576*D1**2*Pkdd2*bd1*f**2*k1**2*s + 288*D1**2*Pkdd2*bd1*f**2*k1**2 + 180*D1**2*Pkdd2*bd1*f*fd*k1**2*s**2 - 180*D1**2*Pkdd2*bd1*f*fd*k1**2*s + 588*D1**2*Pkdd2*bd1*f*g2*k1**2*s**2 - 1176*D1**2*Pkdd2*bd1*f*g2*k1**2*s + 588*D1**2*Pkdd2*bd1*f*g2*k1**2 + 252*D1**2*Pkdd2*bd1*f*gd2*k1**2*s**2 - 252*D1**2*Pkdd2*bd1*f*gd2*k1**2*s + 252*D1**2*Pkdd2*bd1*fd*g2*k1**2*s**2 - 252*D1**2*Pkdd2*bd1*fd*g2*k1**2*s + 45*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 90*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 45*D1**2*Pkdd2*bdd1*f**2*k1**2 + 126*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 252*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 126*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 135*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 90*D1**2*Pkdd2*f**2*fd*k1**2*s + 45*D1**2*Pkdd2*f**2*fd*k1**2 + 126*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 252*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 252*D1**2*Pkdd2*f*fd*g2*k1**2*s + 126*D1**2*Pkdd2*f*fd*g2*k1**2 - 1680*D1*Dd*K*Pk2*bd1*f**2*r**2 - 10080*D1*Dd*K*Pk2*bd1*f**2*r*s + 3780*D1*Dd*K*Pk2*bd1*f**2*r - 10080*D1*Dd*K*Pk2*bd1*f**2*s**2 + 10080*D1*Dd*K*Pk2*bd1*f**2*s - 2100*D1*Dd*K*Pk2*bd1*f**2 + 21024*D1*Dd*Pk2*bd1*f**2*r**2 + 31536*D1*Dd*Pk2*bd1*f**2*r*s - 33822*D1*Dd*Pk2*bd1*f**2*r + 5040*D1*Dd*Pk2*bd1*f**2*s**2 - 19224*D1*Dd*Pk2*bd1*f**2*s + 12204*D1*Dd*Pk2*bd1*f**2 + 26880*D1*Dd*Pk2*bd1*f*g2*r**2 + 47040*D1*Dd*Pk2*bd1*f*g2*r*s - 52920*D1*Dd*Pk2*bd1*f*g2*r + 16800*D1*Dd*Pk2*bd1*f*g2*s**2 - 49560*D1*Dd*Pk2*bd1*f*g2*s + 25200*D1*Dd*Pk2*bd1*f*g2 - 1304*D1*Dd*Pk2*f**3*r**2 - 4752*D1*Dd*Pk2*f**3*r*s + 2492*D1*Dd*Pk2*f**3*r - 3024*D1*Dd*Pk2*f**3*s**2 + 3888*D1*Dd*Pk2*f**3*s - 1408*D1*Dd*Pk2*f**3 + 5424*D1*Dd*Pk2*f**2*fd*r**2 + 28512*D1*Dd*Pk2*f**2*fd*r*s - 12836*D1*Dd*Pk2*f**2*fd*r + 18144*D1*Dd*Pk2*f**2*fd*s**2 - 22464*D1*Dd*Pk2*f**2*fd*s + 5980*D1*Dd*Pk2*f**2*fd - 1680*D1*Dd*Pk2*f**2*g2*r**2 - 10080*D1*Dd*Pk2*f**2*g2*r*s + 4200*D1*Dd*Pk2*f**2*g2*r - 10080*D1*Dd*Pk2*f**2*g2*s**2 + 10080*D1*Dd*Pk2*f**2*g2*s - 3360*D1*Dd*Pk2*f**2*g2 + 3360*D1*Dd*Pk2*f**2*gd2*r**2 + 20160*D1*Dd*Pk2*f**2*gd2*r*s - 7560*D1*Dd*Pk2*f**2*gd2*r + 20160*D1*Dd*Pk2*f**2*gd2*s**2 - 20160*D1*Dd*Pk2*f**2*gd2*s + 4200*D1*Dd*Pk2*f**2*gd2 + 6720*D1*Dd*Pk2*f*fd*g2*r**2 + 40320*D1*Dd*Pk2*f*fd*g2*r*s - 18480*D1*Dd*Pk2*f*fd*g2*r + 40320*D1*Dd*Pk2*f*fd*g2*s**2 - 40320*D1*Dd*Pk2*f*fd*g2*s + 10080*D1*Dd*Pk2*f*fd*g2 + 360*D1*Dd*Pkdd2*bd1*f**2*k1**2*s**2 - 450*D1*Dd*Pkdd2*bd1*f**2*k1**2*s + 90*D1*Dd*Pkdd2*bd1*f**2*k1**2 + 1008*D1*Dd*Pkdd2*bd1*f*g2*k1**2*s**2 - 1260*D1*Dd*Pkdd2*bd1*f*g2*k1**2*s + 252*D1*Dd*Pkdd2*bd1*f*g2*k1**2 + 180*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 90*D1*Dd*Pkdd2*f**3*k1**2*s + 45*D1*Dd*Pkdd2*f**3*k1**2 + 504*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 252*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 126*D1*Dd*Pkdd2*f**2*g2*k1**2 + 904*D1*Ddd*Pk2*f**3*r**2 + 4752*D1*Ddd*Pk2*f**3*r*s - 2092*D1*Ddd*Pk2*f**3*r + 3024*D1*Ddd*Pk2*f**3*s**2 - 3888*D1*Ddd*Pk2*f**3*s + 1208*D1*Ddd*Pk2*f**3 + 1680*D1*Ddd*Pk2*f**2*g2*r**2 + 10080*D1*Ddd*Pk2*f**2*g2*r*s - 4200*D1*Ddd*Pk2*f**2*g2*r + 10080*D1*Ddd*Pk2*f**2*g2*s**2 - 10080*D1*Ddd*Pk2*f**2*g2*s + 3360*D1*Ddd*Pk2*f**2*g2 + 210*D1*Pk2*b2*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + 2712*Dd**2*Pk2*f**3*r**2 + 14256*Dd**2*Pk2*f**3*r*s - 6276*Dd**2*Pk2*f**3*r + 9072*Dd**2*Pk2*f**3*s**2 - 11664*Dd**2*Pk2*f**3*s + 2828*Dd**2*Pk2*f**3 + 5040*Dd**2*Pk2*f**2*g2*r**2 + 30240*Dd**2*Pk2*f**2*g2*r*s - 12600*Dd**2*Pk2*f**2*g2*r + 30240*Dd**2*Pk2*f**2*g2*s**2 - 30240*Dd**2*Pk2*f**2*g2*s + 5880*Dd**2*Pk2*f**2*g2 + 420*Pk2*b1**3*(D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(Dd*(-4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) + Ddd*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 21*b1**2*(-224*C*D1**2*Pk2*fd*r**2 - 320*C*D1**2*Pk2*fd*r*s + 448*C*D1**2*Pk2*fd*r - 96*C*D1**2*Pk2*fd*s**2 + 320*C*D1**2*Pk2*fd*s - 224*C*D1**2*Pk2*fd + 112*C*D1**2*Pk2*fdd*r**2 + 160*C*D1**2*Pk2*fdd*r*s - 224*C*D1**2*Pk2*fdd*r + 48*C*D1**2*Pk2*fdd*s**2 - 160*C*D1**2*Pk2*fdd*s + 112*C*D1**2*Pk2*fdd - 896*C*D1*Dd*Pk2*f*r**2 - 1280*C*D1*Dd*Pk2*f*r*s + 1216*C*D1*Dd*Pk2*f*r - 384*C*D1*Dd*Pk2*f*s**2 + 832*C*D1*Dd*Pk2*f*s - 544*C*D1*Dd*Pk2*f + 896*C*D1*Dd*Pk2*fd*r**2 + 1280*C*D1*Dd*Pk2*fd*r*s - 1504*C*D1*Dd*Pk2*fd*r + 384*C*D1*Dd*Pk2*fd*s**2 - 1056*C*D1*Dd*Pk2*fd*s + 608*C*D1*Dd*Pk2*fd + 448*C*D1*Ddd*Pk2*f*r**2 + 640*C*D1*Ddd*Pk2*f*r*s - 608*C*D1*Ddd*Pk2*f*r + 192*C*D1*Ddd*Pk2*f*s**2 - 416*C*D1*Ddd*Pk2*f*s + 272*C*D1*Ddd*Pk2*f + 1344*C*Dd**2*Pk2*f*r**2 + 1920*C*Dd**2*Pk2*f*r*s - 1824*C*Dd**2*Pk2*f*r + 576*C*Dd**2*Pk2*f*s**2 - 1248*C*Dd**2*Pk2*f*s + 544*C*Dd**2*Pk2*f + 110*D1**2*K*Pk2*fd*r**2 + 140*D1**2*K*Pk2*fd*r*s - 20*D1**2*K*Pk2*fd*r + 30*D1**2*K*Pk2*fd*s**2 + 60*D1**2*K*Pk2*fd*s - 30*D1**2*K*Pk2*fd - 80*D1**2*K*Pk2*fdd*r**2 - 140*D1**2*K*Pk2*fdd*r*s - 60*D1**2*K*Pk2*fdd*r - 50*D1**2*K*Pk2*fdd*s**2 - 100*D1**2*K*Pk2*fdd*s + 50*D1**2*K*Pk2*fdd - 14*D1**2*K*Pkdd2*fd*k1**2*s**2 - 3*D1**2*K*Pkdd2*fdd*k1**2*s**2 + 20*D1**2*Pk2*bdd1*(2*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(-3*r**2 - 3*r*(s - 1) + s - 1) - 3*r**2 - 3*r*s + 3*r + s - 1) - 60*D1**2*Pk2*f*fd*r**2 - 60*D1**2*Pk2*f*fd*r*s + 60*D1**2*Pk2*f*fd*r + 30*D1**2*Pk2*f*fd*s - 30*D1**2*Pk2*f*fd + 60*D1**2*Pk2*f*fdd*r**2 + 60*D1**2*Pk2*f*fdd*r*s - 60*D1**2*Pk2*f*fdd*r - 30*D1**2*Pk2*f*fdd*s + 30*D1**2*Pk2*f*fdd + 60*D1**2*Pk2*fd**2*r**2 + 60*D1**2*Pk2*fd**2*r*s - 60*D1**2*Pk2*fd**2*r - 30*D1**2*Pk2*fd**2*s + 158*D1**2*Pk2*fd*r**2 + 206*D1**2*Pk2*fd*r*s - 316*D1**2*Pk2*fd*r + 48*D1**2*Pk2*fd*s**2 - 216*D1**2*Pk2*fd*s + 168*D1**2*Pk2*fd - 64*D1**2*Pk2*fdd*r**2 - 78*D1**2*Pk2*fdd*r*s + 168*D1**2*Pk2*fdd*r - 24*D1**2*Pk2*fdd*s**2 + 108*D1**2*Pk2*fdd*s - 84*D1**2*Pk2*fdd + 160*D1**2*Pk2*gd2*r**2 + 320*D1**2*Pk2*gd2*r*s - 320*D1**2*Pk2*gd2*r + 160*D1**2*Pk2*gd2*s**2 - 320*D1**2*Pk2*gd2*s + 160*D1**2*Pk2*gd2 - 80*D1**2*Pk2*gdd2*r**2 - 160*D1**2*Pk2*gdd2*r*s + 160*D1**2*Pk2*gdd2*r - 80*D1**2*Pk2*gdd2*s**2 + 160*D1**2*Pk2*gdd2*s - 80*D1**2*Pk2*gdd2 + 18*D1**2*Pkdd2*f*fd*k1**2*s**2 + 10*D1**2*Pkdd2*fd*k1**2*s**2 + 440*D1*Dd*K*Pk2*f*r**2 + 560*D1*Dd*K*Pk2*f*r*s - 580*D1*Dd*K*Pk2*f*r + 120*D1*Dd*K*Pk2*f*s**2 - 340*D1*Dd*K*Pk2*f*s + 250*D1*Dd*K*Pk2*f - 640*D1*Dd*K*Pk2*fd*r**2 - 1120*D1*Dd*K*Pk2*fd*r*s + 220*D1*Dd*K*Pk2*fd*r - 400*D1*Dd*K*Pk2*fd*s**2 - 20*D1*Dd*K*Pk2*fd*s + 220*D1*Dd*K*Pk2*fd - 56*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 28*D1*Dd*K*Pkdd2*f*k1**2*s - 14*D1*Dd*K*Pkdd2*f*k1**2 - 24*D1*Dd*K*Pkdd2*fd*k1**2*s**2 + 6*D1*Dd*K*Pkdd2*fd*k1**2*s - 120*D1*Dd*Pk2*f**2*r**2 - 120*D1*Dd*Pk2*f**2*r*s + 150*D1*Dd*Pk2*f**2*r + 60*D1*Dd*Pk2*f**2*s - 60*D1*Dd*Pk2*f**2 + 480*D1*Dd*Pk2*f*fd*r**2 + 480*D1*Dd*Pk2*f*fd*r*s - 540*D1*Dd*Pk2*f*fd*r - 240*D1*Dd*Pk2*f*fd*s + 150*D1*Dd*Pk2*f*fd + 632*D1*Dd*Pk2*f*r**2 + 824*D1*Dd*Pk2*f*r*s - 838*D1*Dd*Pk2*f*r + 192*D1*Dd*Pk2*f*s**2 - 508*D1*Dd*Pk2*f*s + 364*D1*Dd*Pk2*f - 512*D1*Dd*Pk2*fd*r**2 - 624*D1*Dd*Pk2*fd*r*s + 1006*D1*Dd*Pk2*fd*r - 192*D1*Dd*Pk2*fd*s**2 + 636*D1*Dd*Pk2*fd*s - 444*D1*Dd*Pk2*fd + 640*D1*Dd*Pk2*g2*r**2 + 1280*D1*Dd*Pk2*g2*r*s - 960*D1*Dd*Pk2*g2*r + 640*D1*Dd*Pk2*g2*s**2 - 960*D1*Dd*Pk2*g2*s + 480*D1*Dd*Pk2*g2 - 640*D1*Dd*Pk2*gd2*r**2 - 1280*D1*Dd*Pk2*gd2*r*s + 1120*D1*Dd*Pk2*gd2*r - 640*D1*Dd*Pk2*gd2*s**2 + 1120*D1*Dd*Pk2*gd2*s - 480*D1*Dd*Pk2*gd2 + 36*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**2*k1**2*s + 9*D1*Dd*Pkdd2*f**2*k1**2 + 40*D1*Dd*Pkdd2*f*k1**2*s**2 - 20*D1*Dd*Pkdd2*f*k1**2*s + 10*D1*Dd*Pkdd2*f*k1**2 - 320*D1*Ddd*K*Pk2*f*r**2 - 560*D1*Ddd*K*Pk2*f*r*s + 460*D1*Ddd*K*Pk2*f*r - 200*D1*Ddd*K*Pk2*f*s**2 + 380*D1*Ddd*K*Pk2*f*s - 210*D1*Ddd*K*Pk2*f - 12*D1*Ddd*K*Pkdd2*f*k1**2*s**2 + 6*D1*Ddd*K*Pkdd2*f*k1**2*s - 3*D1*Ddd*K*Pkdd2*f*k1**2 + 120*D1*Ddd*Pk2*f**2*r**2 + 120*D1*Ddd*Pk2*f**2*r*s - 150*D1*Ddd*Pk2*f**2*r - 60*D1*Ddd*Pk2*f**2*s + 60*D1*Ddd*Pk2*f**2 - 256*D1*Ddd*Pk2*f*r**2 - 312*D1*Ddd*Pk2*f*r*s + 334*D1*Ddd*Pk2*f*r - 96*D1*Ddd*Pk2*f*s**2 + 204*D1*Ddd*Pk2*f*s - 152*D1*Ddd*Pk2*f - 320*D1*Ddd*Pk2*g2*r**2 - 640*D1*Ddd*Pk2*g2*r*s + 480*D1*Ddd*Pk2*g2*r - 320*D1*Ddd*Pk2*g2*s**2 + 480*D1*Ddd*Pk2*g2*s - 240*D1*Ddd*Pk2*g2 + 20*D1*Pk2*bd1*(D1*(-4*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) + Dd*(4*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) - 24*r**2 - 24*r*s + 27*r + 10*s - 7)) - 960*Dd**2*K*Pk2*f*r**2 - 1680*Dd**2*K*Pk2*f*r*s + 1380*Dd**2*K*Pk2*f*r - 600*Dd**2*K*Pk2*f*s**2 + 1140*Dd**2*K*Pk2*f*s - 440*Dd**2*K*Pk2*f - 36*Dd**2*K*Pkdd2*f*k1**2*s**2 + 18*Dd**2*K*Pkdd2*f*k1**2*s + 360*Dd**2*Pk2*f**2*r**2 + 360*Dd**2*Pk2*f**2*r*s - 450*Dd**2*Pk2*f**2*r - 180*Dd**2*Pk2*f**2*s + 120*Dd**2*Pk2*f**2 - 768*Dd**2*Pk2*f*r**2 - 936*Dd**2*Pk2*f*r*s + 1002*Dd**2*Pk2*f*r - 288*Dd**2*Pk2*f*s**2 + 612*Dd**2*Pk2*f*s - 284*Dd**2*Pk2*f - 960*Dd**2*Pk2*g2*r**2 - 1920*Dd**2*Pk2*g2*r*s + 1440*Dd**2*Pk2*g2*r - 960*Dd**2*Pk2*g2*s**2 + 1440*Dd**2*Pk2*g2*s - 480*Dd**2*Pk2*g2) - 3*b1*(-1568*C*D1**2*Pk2*bdd1*f*r**2 - 2240*C*D1**2*Pk2*bdd1*f*r*s + 1120*C*D1**2*Pk2*bdd1*f*r - 672*C*D1**2*Pk2*bdd1*f*s**2 + 672*C*D1**2*Pk2*bdd1*f*s - 336*C*D1**2*Pk2*bdd1*f - 4536*C*D1**2*Pk2*f*fd*r**2 - 5168*C*D1**2*Pk2*f*fd*r*s + 4512*C*D1**2*Pk2*f*fd*r - 504*C*D1**2*Pk2*f*fd*s**2 + 2080*C*D1**2*Pk2*f*fd*s - 2016*C*D1**2*Pk2*f*fd + 2688*C*D1**2*Pk2*f*fdd*r**2 + 4208*C*D1**2*Pk2*f*fdd*r*s - 2088*C*D1**2*Pk2*f*fdd*r + 840*C*D1**2*Pk2*f*fdd*s**2 - 1264*C*D1**2*Pk2*f*fdd*s + 924*C*D1**2*Pk2*f*fdd + 2688*C*D1**2*Pk2*fd**2*r**2 + 4208*C*D1**2*Pk2*fd**2*r*s - 2088*C*D1**2*Pk2*fd**2*r + 840*C*D1**2*Pk2*fd**2*s**2 - 1264*C*D1**2*Pk2*fd**2*s - 600*C*D1**2*Pk2*fd**2 + 216*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 60*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 60*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 9072*C*D1*Dd*Pk2*f**2*r**2 - 10336*C*D1*Dd*Pk2*f**2*r*s + 11656*C*D1*Dd*Pk2*f**2*r - 1008*C*D1*Dd*Pk2*f**2*s**2 + 5672*C*D1*Dd*Pk2*f**2*s - 4788*C*D1*Dd*Pk2*f**2 + 21504*C*D1*Dd*Pk2*f*fd*r**2 + 33664*C*D1*Dd*Pk2*f*fd*r*s - 23312*C*D1*Dd*Pk2*f*fd*r + 6720*C*D1*Dd*Pk2*f*fd*s**2 - 15152*C*D1*Dd*Pk2*f*fd*s + 5440*C*D1*Dd*Pk2*f*fd + 432*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 216*C*D1*Dd*Pkdd2*f**2*k1**2*s + 108*C*D1*Dd*Pkdd2*f**2*k1**2 + 480*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 120*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 5376*C*D1*Ddd*Pk2*f**2*r**2 + 8416*C*D1*Ddd*Pk2*f**2*r*s - 7480*C*D1*Ddd*Pk2*f**2*r + 1680*C*D1*Ddd*Pk2*f**2*s**2 - 5048*C*D1*Ddd*Pk2*f**2*s + 3108*C*D1*Ddd*Pk2*f**2 + 120*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 60*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 30*C*D1*Ddd*Pkdd2*f**2*k1**2 + 16128*C*Dd**2*Pk2*f**2*r**2 + 25248*C*Dd**2*Pk2*f**2*r*s - 22440*C*Dd**2*Pk2*f**2*r + 5040*C*Dd**2*Pk2*f**2*s**2 - 15144*C*Dd**2*Pk2*f**2*s + 6896*C*Dd**2*Pk2*f**2 + 360*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 180*C*Dd**2*Pkdd2*f**2*k1**2*s + 1120*D1**2*K*Pk2*bdd1*f*r**2 + 1960*D1**2*K*Pk2*bdd1*f*r*s - 2520*D1**2*K*Pk2*bdd1*f*r + 700*D1**2*K*Pk2*bdd1*f*s**2 - 2380*D1**2*K*Pk2*bdd1*f*s + 1260*D1**2*K*Pk2*bdd1*f - 140*D1**2*K*Pk2*f*fd*r**2 - 840*D1**2*K*Pk2*f*fd*r*s + 420*D1**2*K*Pk2*f*fd*r - 840*D1**2*K*Pk2*f*fd*s**2 + 840*D1**2*K*Pk2*f*fd*s - 420*D1**2*K*Pk2*f*fd + 140*D1**2*K*Pk2*f*fdd*r**2 + 840*D1**2*K*Pk2*f*fdd*r*s - 420*D1**2*K*Pk2*f*fdd*r + 840*D1**2*K*Pk2*f*fdd*s**2 - 840*D1**2*K*Pk2*f*fdd*s + 420*D1**2*K*Pk2*f*fdd + 140*D1**2*K*Pk2*fd**2*r**2 + 840*D1**2*K*Pk2*fd**2*r*s - 420*D1**2*K*Pk2*fd**2*r + 840*D1**2*K*Pk2*fd**2*s**2 - 840*D1**2*K*Pk2*fd**2*s + 42*D1**2*K*Pkdd2*bdd1*f*k1**2*s**2 - 42*D1**2*K*Pkdd2*bdd1*f*k1**2*s + 21*D1**2*K*Pkdd2*bdd1*f*k1**2 + 42*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 42*D1**2*K*Pkdd2*f*fd*k1**2*s + 21*D1**2*K*Pkdd2*f*fd*k1**2 - 210*D1**2*Pk2*b2*fd*r**2 - 420*D1**2*Pk2*b2*fd*r*s - 210*D1**2*Pk2*b2*fd*s**2 + 350*D1**2*Pk2*b2*fdd*r**2 + 700*D1**2*Pk2*b2*fdd*r*s + 350*D1**2*Pk2*b2*fdd*s**2 + 140*D1**2*Pk2*bd1**2*(-4*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*r**2 + 6*r*s - 6*r - 2*s + 1) - 420*D1**2*Pk2*bdd1*f**2*r**2 - 420*D1**2*Pk2*bdd1*f**2*r*s + 630*D1**2*Pk2*bdd1*f**2*r + 210*D1**2*Pk2*bdd1*f**2*s - 210*D1**2*Pk2*bdd1*f**2 + 896*D1**2*Pk2*bdd1*f*r**2 + 1092*D1**2*Pk2*bdd1*f*r*s - 266*D1**2*Pk2*bdd1*f*r + 336*D1**2*Pk2*bdd1*f*s**2 - 126*D1**2*Pk2*bdd1*f*s + 28*D1**2*Pk2*bdd1*f + 1120*D1**2*Pk2*bdd1*g2*r**2 + 2240*D1**2*Pk2*bdd1*g2*r*s - 1120*D1**2*Pk2*bdd1*g2*r + 1120*D1**2*Pk2*bdd1*g2*s**2 - 1120*D1**2*Pk2*bdd1*g2*s + 560*D1**2*Pk2*bdd1*g2 + 350*D1**2*Pk2*bdd2*f*r**2 + 700*D1**2*Pk2*bdd2*f*r*s - 700*D1**2*Pk2*bdd2*f*r + 350*D1**2*Pk2*bdd2*f*s**2 - 700*D1**2*Pk2*bdd2*f*s + 350*D1**2*Pk2*bdd2*f + 2832*D1**2*Pk2*f*fd*r**2 + 2988*D1**2*Pk2*f*fd*r*s - 2904*D1**2*Pk2*f*fd*r + 252*D1**2*Pk2*f*fd*s**2 - 1242*D1**2*Pk2*f*fd*s + 1290*D1**2*Pk2*f*fd - 1752*D1**2*Pk2*f*fdd*r**2 - 2628*D1**2*Pk2*f*fdd*r*s + 1452*D1**2*Pk2*f*fdd*r - 420*D1**2*Pk2*f*fdd*s**2 + 894*D1**2*Pk2*f*fdd*s - 666*D1**2*Pk2*f*fdd + 1540*D1**2*Pk2*f*gd2*r**2 + 1960*D1**2*Pk2*f*gd2*r*s - 3080*D1**2*Pk2*f*gd2*r + 420*D1**2*Pk2*f*gd2*s**2 - 1960*D1**2*Pk2*f*gd2*s + 1540*D1**2*Pk2*f*gd2 - 1120*D1**2*Pk2*f*gdd2*r**2 - 1960*D1**2*Pk2*f*gdd2*r*s + 2240*D1**2*Pk2*f*gdd2*r - 700*D1**2*Pk2*f*gdd2*s**2 + 1960*D1**2*Pk2*f*gdd2*s - 1120*D1**2*Pk2*f*gdd2 - 1752*D1**2*Pk2*fd**2*r**2 - 2628*D1**2*Pk2*fd**2*r*s + 1452*D1**2*Pk2*fd**2*r - 420*D1**2*Pk2*fd**2*s**2 + 894*D1**2*Pk2*fd**2*s + 300*D1**2*Pk2*fd**2 + 1540*D1**2*Pk2*fd*g2*r**2 + 1960*D1**2*Pk2*fd*g2*r*s - 280*D1**2*Pk2*fd*g2*r + 420*D1**2*Pk2*fd*g2*s**2 + 840*D1**2*Pk2*fd*g2*s - 420*D1**2*Pk2*fd*g2 - 2240*D1**2*Pk2*fd*gd2*r**2 - 3920*D1**2*Pk2*fd*gd2*r*s + 1400*D1**2*Pk2*fd*gd2*r - 1400*D1**2*Pk2*fd*gd2*s**2 + 560*D1**2*Pk2*fd*gd2*s + 840*D1**2*Pk2*fd*gd2 - 1120*D1**2*Pk2*fdd*g2*r**2 - 1960*D1**2*Pk2*fdd*g2*r*s - 840*D1**2*Pk2*fdd*g2*r - 700*D1**2*Pk2*fdd*g2*s**2 - 1400*D1**2*Pk2*fdd*g2*s + 700*D1**2*Pk2*fdd*g2 - 192*D1**2*Pkdd2*f*fd*k1**2*s**2 - 30*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 196*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 30*D1**2*Pkdd2*fd**2*k1**2*s**2 - 196*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 84*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 280*D1*Dd*K*Pk2*f**2*r**2 - 1680*D1*Dd*K*Pk2*f**2*r*s + 700*D1*Dd*K*Pk2*f**2*r - 1680*D1*Dd*K*Pk2*f**2*s**2 + 1680*D1*Dd*K*Pk2*f**2*s - 560*D1*Dd*K*Pk2*f**2 + 1120*D1*Dd*K*Pk2*f*fd*r**2 + 6720*D1*Dd*K*Pk2*f*fd*r*s - 3080*D1*Dd*K*Pk2*f*fd*r + 6720*D1*Dd*K*Pk2*f*fd*s**2 - 6720*D1*Dd*K*Pk2*f*fd*s + 1680*D1*Dd*K*Pk2*f*fd + 84*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 42*D1*Dd*K*Pkdd2*f**2*k1**2*s + 21*D1*Dd*K*Pkdd2*f**2*k1**2 - 840*D1*Dd*Pk2*b2*f*r**2 - 1680*D1*Dd*Pk2*b2*f*r*s + 1260*D1*Dd*Pk2*b2*f*r - 840*D1*Dd*Pk2*b2*f*s**2 + 1260*D1*Dd*Pk2*b2*f*s - 630*D1*Dd*Pk2*b2*f + 2800*D1*Dd*Pk2*b2*fd*r**2 + 5600*D1*Dd*Pk2*b2*fd*r*s - 2100*D1*Dd*Pk2*b2*fd*r + 2800*D1*Dd*Pk2*b2*fd*s**2 - 2100*D1*Dd*Pk2*b2*fd*s + 5664*D1*Dd*Pk2*f**2*r**2 + 5976*D1*Dd*Pk2*f**2*r*s - 7158*D1*Dd*Pk2*f**2*r + 504*D1*Dd*Pk2*f**2*s**2 - 3240*D1*Dd*Pk2*f**2*s + 2958*D1*Dd*Pk2*f**2 - 14016*D1*Dd*Pk2*f*fd*r**2 - 21024*D1*Dd*Pk2*f*fd*r*s + 15444*D1*Dd*Pk2*f*fd*r - 3360*D1*Dd*Pk2*f*fd*s**2 + 9672*D1*Dd*Pk2*f*fd*s - 3798*D1*Dd*Pk2*f*fd + 6160*D1*Dd*Pk2*f*g2*r**2 + 7840*D1*Dd*Pk2*f*g2*r*s - 8120*D1*Dd*Pk2*f*g2*r + 1680*D1*Dd*Pk2*f*g2*s**2 - 4760*D1*Dd*Pk2*f*g2*s + 3500*D1*Dd*Pk2*f*g2 - 8960*D1*Dd*Pk2*f*gd2*r**2 - 15680*D1*Dd*Pk2*f*gd2*r*s + 15400*D1*Dd*Pk2*f*gd2*r - 5600*D1*Dd*Pk2*f*gd2*s**2 + 13160*D1*Dd*Pk2*f*gd2*s - 6440*D1*Dd*Pk2*f*gd2 - 8960*D1*Dd*Pk2*fd*g2*r**2 - 15680*D1*Dd*Pk2*fd*g2*r*s + 3080*D1*Dd*Pk2*fd*g2*r - 5600*D1*Dd*Pk2*fd*g2*s**2 - 280*D1*Dd*Pk2*fd*g2*s + 3080*D1*Dd*Pk2*fd*g2 - 384*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 192*D1*Dd*Pkdd2*f**2*k1**2*s - 96*D1*Dd*Pkdd2*f**2*k1**2 - 240*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 60*D1*Dd*Pkdd2*f*fd*k1**2*s - 784*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 392*D1*Dd*Pkdd2*f*g2*k1**2*s - 196*D1*Dd*Pkdd2*f*g2*k1**2 - 336*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 84*D1*Dd*Pkdd2*f*gd2*k1**2*s - 336*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 84*D1*Dd*Pkdd2*fd*g2*k1**2*s + 280*D1*Ddd*K*Pk2*f**2*r**2 + 1680*D1*Ddd*K*Pk2*f**2*r*s - 700*D1*Ddd*K*Pk2*f**2*r + 1680*D1*Ddd*K*Pk2*f**2*s**2 - 1680*D1*Ddd*K*Pk2*f**2*s + 560*D1*Ddd*K*Pk2*f**2 + 1400*D1*Ddd*Pk2*b2*f*r**2 + 2800*D1*Ddd*Pk2*b2*f*r*s - 2100*D1*Ddd*Pk2*b2*f*r + 1400*D1*Ddd*Pk2*b2*f*s**2 - 2100*D1*Ddd*Pk2*b2*f*s + 1050*D1*Ddd*Pk2*b2*f - 3504*D1*Ddd*Pk2*f**2*r**2 - 5256*D1*Ddd*Pk2*f**2*r*s + 4818*D1*Ddd*Pk2*f**2*r - 840*D1*Ddd*Pk2*f**2*s**2 + 3048*D1*Ddd*Pk2*f**2*s - 1962*D1*Ddd*Pk2*f**2 - 4480*D1*Ddd*Pk2*f*g2*r**2 - 7840*D1*Ddd*Pk2*f*g2*r*s + 6440*D1*Ddd*Pk2*f*g2*r - 2800*D1*Ddd*Pk2*f*g2*s**2 + 5320*D1*Ddd*Pk2*f*g2*s - 2940*D1*Ddd*Pk2*f*g2 - 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 30*D1*Ddd*Pkdd2*f**2*k1**2*s - 15*D1*Ddd*Pkdd2*f**2*k1**2 - 168*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 84*D1*Ddd*Pkdd2*f*g2*k1**2*s - 42*D1*Ddd*Pkdd2*f*g2*k1**2 - 70*D1*Pk2*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 7*D1*bd1*(D1*(-6*K*Pkdd2*fd*k1**2*s*(1 - 2*s) - 2*Pk2*fd*(16*C*(14*r**2 + r*(20*s - 19) + 6*s**2 - 13*s + 5) - 10*K*(16*r**2 + 4*r*(7*s - 3) + 10*s**2 - 7*s - 3) - 128*r**2 - 156*r*s + 187*r - 48*s**2 + 117*s - 54) - 160*Pk2*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 160*Pk2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 3*f**2*(10*Pk2*(2*r - 1)*(r + s - 1) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 2*f*(Pk2*(16*C*(14*r**2 + 10*r*(2*s - 1) + 6*s**2 - 6*s + 3) - 110*K*r**2 - 140*K*r*s + 170*K*r - 30*K*s**2 + 130*K*s - 85*K - 15*fd*(2*r - 1)*(4*r + 4*s - 3) - 158*r**2 - 206*r*s + 103*r - 48*s**2 + 43*s - 19) + Pkdd2*k1**2*(7*K - 5)*(2*s**2 - 2*s + 1))) - 2*Dd*(15*Pk2*f**2*(2*r - 1)*(8*r + 8*s - 7) - 80*Pk2*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f*(-3*K*Pkdd2*k1**2*(8*s**2 - 6*s + 1) + Pk2*(16*C*(56*r**2 + r*(80*s - 58) + 24*s**2 - 38*s + 13) - 10*K*(64*r**2 + 2*r*(56*s - 59) + 40*s**2 - 106*s + 53) - 512*r**2 - 624*r*s + 410*r - 192*s**2 + 240*s - 47)))) + 840*Dd**2*K*Pk2*f**2*r**2 + 5040*Dd**2*K*Pk2*f**2*r*s - 2100*Dd**2*K*Pk2*f**2*r + 5040*Dd**2*K*Pk2*f**2*s**2 - 5040*Dd**2*K*Pk2*f**2*s + 980*Dd**2*K*Pk2*f**2 + 4200*Dd**2*Pk2*b2*f*r**2 + 8400*Dd**2*Pk2*b2*f*r*s - 6300*Dd**2*Pk2*b2*f*r + 4200*Dd**2*Pk2*b2*f*s**2 - 6300*Dd**2*Pk2*b2*f*s + 2100*Dd**2*Pk2*b2*f - 10512*Dd**2*Pk2*f**2*r**2 - 15768*Dd**2*Pk2*f**2*r*s + 14454*Dd**2*Pk2*f**2*r - 2520*Dd**2*Pk2*f**2*s**2 + 9144*Dd**2*Pk2*f**2*s - 4380*Dd**2*Pk2*f**2 - 13440*Dd**2*Pk2*f*g2*r**2 - 23520*Dd**2*Pk2*f*g2*r*s + 19320*Dd**2*Pk2*f*g2*r - 8400*Dd**2*Pk2*f*g2*s**2 + 15960*Dd**2*Pk2*f*g2*s - 6160*Dd**2*Pk2*f*g2 - 180*Dd**2*Pkdd2*f**2*k1**2*s**2 + 90*Dd**2*Pkdd2*f**2*k1**2*s - 504*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 252*Dd**2*Pkdd2*f*g2*k1**2*s))/(630*d**2*k3**4) + D1**2*Pk3*ct**2*st**4*(1440*C*D1**2*Pk2*f**2*fd*s**2 - 960*C*D1**2*Pk2*f**2*fd*s + 480*C*D1**2*Pk2*f**2*fd - 720*C*D1**2*Pk2*f**2*fdd*s**2 + 480*C*D1**2*Pk2*f**2*fdd*s - 240*C*D1**2*Pk2*f**2*fdd - 1440*C*D1**2*Pk2*f*fd**2*s**2 + 960*C*D1**2*Pk2*f*fd**2*s - 24*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 24*C*D1**2*Pkdd2*b1*f*fd*k1**2*s - 12*C*D1**2*Pkdd2*b1*f*fd*k1**2 + 12*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 12*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 6*C*D1**2*Pkdd2*b1*f*fdd*k1**2 + 12*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 12*C*D1**2*Pkdd2*b1*fd**2*k1**2*s + 6*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 1920*C*D1*Dd*Pk2*f**3*s**2 - 960*C*D1*Dd*Pk2*f**3*s + 480*C*D1*Dd*Pk2*f**3 - 5760*C*D1*Dd*Pk2*f**2*fd*s**2 + 3360*C*D1*Dd*Pk2*f**2*fd*s - 480*C*D1*Dd*Pk2*f**2*fd - 48*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 24*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 12*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 96*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 72*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 12*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 - 960*C*D1*Ddd*Pk2*f**3*s**2 + 480*C*D1*Ddd*Pk2*f**3*s - 240*C*D1*Ddd*Pk2*f**3 + 24*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 12*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 6*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 2880*C*Dd**2*Pk2*f**3*s**2 + 1440*C*Dd**2*Pk2*f**3*s + 72*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 36*C*Dd**2*Pkdd2*b1*f**2*k1**2*s + 1440*D1**2*K*Pk2*b1*f*fd*s**2 - 1440*D1**2*K*Pk2*b1*f*fd*s + 720*D1**2*K*Pk2*b1*f*fd - 720*D1**2*K*Pk2*b1*f*fdd*s**2 + 720*D1**2*K*Pk2*b1*f*fdd*s - 360*D1**2*K*Pk2*b1*f*fdd - 720*D1**2*K*Pk2*b1*fd**2*s**2 + 720*D1**2*K*Pk2*b1*fd**2*s - 360*D1**2*K*Pk2*bdd1*f**2*s**2 - 42*D1**2*K*Pkdd2*b1**2*fd*k1**2*s**2 + 84*D1**2*K*Pkdd2*b1**2*fd*k1**2*s - 42*D1**2*K*Pkdd2*b1**2*fd*k1**2 + 21*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s**2 - 42*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s + 21*D1**2*K*Pkdd2*b1**2*fdd*k1**2 + 42*D1**2*K*Pkdd2*b1*bdd1*f*k1**2*s**2 + 1080*D1**2*Pk2*b1*f**2*fd*r*s - 360*D1**2*Pk2*b1*f**2*fd*r - 360*D1**2*Pk2*b1*f**2*fd*s - 1080*D1**2*Pk2*b1*f**2*fdd*r*s + 360*D1**2*Pk2*b1*f**2*fdd*r + 360*D1**2*Pk2*b1*f**2*fdd*s - 2160*D1**2*Pk2*b1*f*fd**2*r*s + 720*D1**2*Pk2*b1*f*fd**2*r + 720*D1**2*Pk2*b1*f*fd**2*s - 360*D1**2*Pk2*b1*f*fd**2 + 1440*D1**2*Pk2*b1*f*fd*r*s - 720*D1**2*Pk2*b1*f*fd*r - 720*D1**2*Pk2*b1*f*fdd*r*s + 360*D1**2*Pk2*b1*f*fdd*r - 720*D1**2*Pk2*b1*fd**2*r*s + 360*D1**2*Pk2*b1*fd**2*r + 720*D1**2*Pk2*bd2*f**2*s**2 - 1440*D1**2*Pk2*bd2*f*fd*s**2 + 720*D1**2*Pk2*bd2*f*fd*s - 360*D1**2*Pk2*bdd1*f**3*r*s + 360*D1**2*Pk2*bdd1*f**3*s - 360*D1**2*Pk2*bdd1*f**2*r*s + 360*D1**2*Pk2*bdd1*f**2*s - 360*D1**2*Pk2*bdd2*f**2*s**2 + 1104*D1**2*Pk2*f**2*fd*r*s - 368*D1**2*Pk2*f**2*fd*r - 720*D1**2*Pk2*f**2*fd*s**2 + 112*D1**2*Pk2*f**2*fd*s - 240*D1**2*Pk2*f**2*fd - 840*D1**2*Pk2*f**2*fdd*r*s + 280*D1**2*Pk2*f**2*fdd*r + 360*D1**2*Pk2*f**2*fdd*s**2 + 40*D1**2*Pk2*f**2*fdd*s + 120*D1**2*Pk2*f**2*fdd - 1440*D1**2*Pk2*f**2*gd2*s**2 + 720*D1**2*Pk2*f**2*gdd2*s**2 - 1680*D1**2*Pk2*f*fd**2*r*s + 560*D1**2*Pk2*f*fd**2*r + 720*D1**2*Pk2*f*fd**2*s**2 + 80*D1**2*Pk2*f*fd**2*s - 280*D1**2*Pk2*f*fd**2 - 2880*D1**2*Pk2*f*fd*g2*s**2 + 2880*D1**2*Pk2*f*fd*g2*s - 1440*D1**2*Pk2*f*fd*g2 + 2880*D1**2*Pk2*f*fd*gd2*s**2 - 1440*D1**2*Pk2*f*fd*gd2*s + 1440*D1**2*Pk2*f*fdd*g2*s**2 - 1440*D1**2*Pk2*f*fdd*g2*s + 720*D1**2*Pk2*f*fdd*g2 + 1440*D1**2*Pk2*fd**2*g2*s**2 - 1440*D1**2*Pk2*fd**2*g2*s + 42*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 84*D1**2*Pkdd2*b1**2*fd*k1**2*s + 42*D1**2*Pkdd2*b1**2*fd*k1**2 - 21*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 42*D1**2*Pkdd2*b1**2*fdd*k1**2*s - 21*D1**2*Pkdd2*b1**2*fdd*k1**2 - 42*D1**2*Pkdd2*b1*bdd1*f*k1**2*s**2 - 270*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 180*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 90*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 135*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 90*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 45*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 270*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 180*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 96*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 96*D1**2*Pkdd2*b1*f*fd*k1**2*s - 48*D1**2*Pkdd2*b1*f*fd*k1**2 + 48*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 48*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 24*D1**2*Pkdd2*b1*f*fdd*k1**2 + 84*D1**2*Pkdd2*b1*f*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*b1*f*gdd2*k1**2*s**2 + 48*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 48*D1**2*Pkdd2*b1*fd**2*k1**2*s + 84*D1**2*Pkdd2*b1*fd*g2*k1**2*s**2 - 168*D1**2*Pkdd2*b1*fd*g2*k1**2*s + 84*D1**2*Pkdd2*b1*fd*g2*k1**2 - 84*D1**2*Pkdd2*b1*fd*gd2*k1**2*s**2 + 84*D1**2*Pkdd2*b1*fd*gd2*k1**2*s - 42*D1**2*Pkdd2*b1*fdd*g2*k1**2*s**2 + 84*D1**2*Pkdd2*b1*fdd*g2*k1**2*s - 42*D1**2*Pkdd2*b1*fdd*g2*k1**2 + 42*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(K - 1) + 45*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 24*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 42*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 60*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 40*D1**2*Pkdd2*f**2*fd*k1**2*s - 20*D1**2*Pkdd2*f**2*fd*k1**2 + 30*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 20*D1**2*Pkdd2*f**2*fdd*k1**2*s + 10*D1**2*Pkdd2*f**2*fdd*k1**2 + 60*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 40*D1**2*Pkdd2*f*fd**2*k1**2*s + 2880*D1*Dd*K*Pk2*b1*f**2*s**2 - 1440*D1*Dd*K*Pk2*b1*f**2*s + 720*D1*Dd*K*Pk2*b1*f**2 - 5760*D1*Dd*K*Pk2*b1*f*fd*s**2 + 4320*D1*Dd*K*Pk2*b1*f*fd*s - 720*D1*Dd*K*Pk2*b1*f*fd - 168*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s**2 + 84*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s - 42*D1*Dd*K*Pkdd2*b1**2*f*k1**2 + 168*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s**2 - 210*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s + 42*D1*Dd*K*Pkdd2*b1**2*fd*k1**2 + 1440*D1*Dd*Pk2*b1*f**3*r*s - 360*D1*Dd*Pk2*b1*f**3*r - 720*D1*Dd*Pk2*b1*f**3*s - 8640*D1*Dd*Pk2*b1*f**2*fd*r*s + 2520*D1*Dd*Pk2*b1*f**2*fd*r + 3600*D1*Dd*Pk2*b1*f**2*fd*s - 1080*D1*Dd*Pk2*b1*f**2*fd + 2880*D1*Dd*Pk2*b1*f**2*r*s - 720*D1*Dd*Pk2*b1*f**2*r - 1440*D1*Dd*Pk2*b1*f**2*s - 5760*D1*Dd*Pk2*b1*f*fd*r*s + 2160*D1*Dd*Pk2*b1*f*fd*r + 1440*D1*Dd*Pk2*b1*f*fd*s - 720*D1*Dd*Pk2*b1*f*fd - 2880*D1*Dd*Pk2*bd2*f**2*s**2 + 720*D1*Dd*Pk2*bd2*f**2*s + 1472*D1*Dd*Pk2*f**3*r*s - 368*D1*Dd*Pk2*f**3*r - 960*D1*Dd*Pk2*f**3*s**2 - 256*D1*Dd*Pk2*f**3*s - 240*D1*Dd*Pk2*f**3 - 6720*D1*Dd*Pk2*f**2*fd*r*s + 1960*D1*Dd*Pk2*f**2*fd*r + 2880*D1*Dd*Pk2*f**2*fd*s**2 + 1120*D1*Dd*Pk2*f**2*fd*s - 600*D1*Dd*Pk2*f**2*fd - 5760*D1*Dd*Pk2*f**2*g2*s**2 + 2880*D1*Dd*Pk2*f**2*g2*s - 1440*D1*Dd*Pk2*f**2*g2 + 5760*D1*Dd*Pk2*f**2*gd2*s**2 - 1440*D1*Dd*Pk2*f**2*gd2*s + 11520*D1*Dd*Pk2*f*fd*g2*s**2 - 8640*D1*Dd*Pk2*f*fd*g2*s + 1440*D1*Dd*Pk2*f*fd*g2 + 168*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 84*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 42*D1*Dd*Pkdd2*b1**2*f*k1**2 - 168*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 210*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 42*D1*Dd*Pkdd2*b1**2*fd*k1**2 - 360*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 180*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 90*D1*Dd*Pkdd2*b1*f**3*k1**2 + 1080*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 630*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 90*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 192*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 96*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 48*D1*Dd*Pkdd2*b1*f**2*k1**2 + 384*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 288*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 48*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 336*D1*Dd*Pkdd2*b1*f*g2*k1**2*s**2 - 168*D1*Dd*Pkdd2*b1*f*g2*k1**2*s + 84*D1*Dd*Pkdd2*b1*f*g2*k1**2 - 336*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s**2 + 84*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s - 336*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s**2 + 420*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s - 84*D1*Dd*Pkdd2*b1*fd*g2*k1**2 - 80*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 40*D1*Dd*Pkdd2*f**3*k1**2*s - 20*D1*Dd*Pkdd2*f**3*k1**2 + 240*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 140*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 20*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1440*D1*Ddd*K*Pk2*b1*f**2*s**2 + 720*D1*Ddd*K*Pk2*b1*f**2*s - 360*D1*Ddd*K*Pk2*b1*f**2 + 84*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s**2 - 42*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s + 21*D1*Ddd*K*Pkdd2*b1**2*f*k1**2 - 1440*D1*Ddd*Pk2*b1*f**3*r*s + 360*D1*Ddd*Pk2*b1*f**3*r + 720*D1*Ddd*Pk2*b1*f**3*s - 1440*D1*Ddd*Pk2*b1*f**2*r*s + 360*D1*Ddd*Pk2*b1*f**2*r + 720*D1*Ddd*Pk2*b1*f**2*s - 1120*D1*Ddd*Pk2*f**3*r*s + 280*D1*Ddd*Pk2*f**3*r + 480*D1*Ddd*Pk2*f**3*s**2 + 320*D1*Ddd*Pk2*f**3*s + 120*D1*Ddd*Pk2*f**3 + 2880*D1*Ddd*Pk2*f**2*g2*s**2 - 1440*D1*Ddd*Pk2*f**2*g2*s + 720*D1*Ddd*Pk2*f**2*g2 - 84*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 42*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 21*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 180*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 90*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 45*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 96*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 48*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 24*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 168*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s**2 + 84*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s - 42*D1*Ddd*Pkdd2*b1*f*g2*k1**2 + 40*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 20*D1*Ddd*Pkdd2*f**3*k1**2*s + 10*D1*Ddd*Pkdd2*f**3*k1**2 + 6*D1*bd1*(D1*(-14*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) - 15*f**3*s*(-4*Pk2*(r - 1) + Pkdd2*k1**2*s) + f**2*(-15*fd*(4*Pk2*(6*r*s - r - 4*s + 1) + Pkdd2*k1**2*s*(1 - 3*s)) - 2*s*(-60*Pk2*(K*s + r - 1) + Pkdd2*k1**2*s*(C + 4))) - 2*f*(Pkdd2*k1**2*s**2*(7*b1*(K - 1) - 7*g2 + 7*gd2) + fd*(30*Pk2*(r*(4*s - 1) + (2*s - 1)*(2*K*s - 1)) - Pkdd2*k1**2*s*(C + 4)*(2*s - 1)))) + Dd*f*(-60*Pk2*f*(8*K*s**2 + r*(8*s - 1) - s*(2*K + 6) + 1) + Pkdd2*f*k1**2*s*(2*C + 8)*(4*s - 1) - Pkdd2*k1**2*s*(4*s - 1)*(-14*K*b1 + 14*b1 + 14*g2) - 15*f**2*(4*Pk2*(r*(8*s - 1) - 6*s + 1) + Pkdd2*k1**2*s*(1 - 4*s)))) - 4320*Dd**2*K*Pk2*b1*f**2*s**2 + 2160*Dd**2*K*Pk2*b1*f**2*s + 252*Dd**2*K*Pkdd2*b1**2*f*k1**2*s**2 - 126*Dd**2*K*Pkdd2*b1**2*f*k1**2*s - 4320*Dd**2*Pk2*b1*f**3*r*s + 1080*Dd**2*Pk2*b1*f**3*r + 2160*Dd**2*Pk2*b1*f**3*s - 720*Dd**2*Pk2*b1*f**3 - 4320*Dd**2*Pk2*b1*f**2*r*s + 1080*Dd**2*Pk2*b1*f**2*r + 2160*Dd**2*Pk2*b1*f**2*s - 720*Dd**2*Pk2*b1*f**2 - 3360*Dd**2*Pk2*f**3*r*s + 840*Dd**2*Pk2*f**3*r + 1440*Dd**2*Pk2*f**3*s**2 + 960*Dd**2*Pk2*f**3*s - 560*Dd**2*Pk2*f**3 + 8640*Dd**2*Pk2*f**2*g2*s**2 - 4320*Dd**2*Pk2*f**2*g2*s - 252*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 126*Dd**2*Pkdd2*b1**2*f*k1**2*s + 540*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 270*Dd**2*Pkdd2*b1*f**3*k1**2*s + 288*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 144*Dd**2*Pkdd2*b1*f**2*k1**2*s - 504*Dd**2*Pkdd2*b1*f*g2*k1**2*s**2 + 252*Dd**2*Pkdd2*b1*f*g2*k1**2*s + 120*Dd**2*Pkdd2*f**3*k1**2*s**2 - 60*Dd**2*Pkdd2*f**3*k1**2*s + 360*Pk2*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(210*d**2*k3**2) + D1**2*Pk3*ct**2*st**2*(-1536*C*D1**2*Pk2*f**2*fd*r*s + 512*C*D1**2*Pk2*f**2*fd*r - 2376*C*D1**2*Pk2*f**2*fd*s**2 + 2096*C*D1**2*Pk2*f**2*fd*s - 792*C*D1**2*Pk2*f**2*fd + 1632*C*D1**2*Pk2*f**2*fdd*r*s - 544*C*D1**2*Pk2*f**2*fdd*r + 1944*C*D1**2*Pk2*f**2*fdd*s**2 - 1840*C*D1**2*Pk2*f**2*fdd*s + 648*C*D1**2*Pk2*f**2*fdd + 3264*C*D1**2*Pk2*f*fd**2*r*s - 1088*C*D1**2*Pk2*f*fd**2*r + 3888*C*D1**2*Pk2*f*fd**2*s**2 - 3680*C*D1**2*Pk2*f*fd**2*s + 544*C*D1**2*Pk2*f*fd**2 + 120*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 80*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 40*C*D1**2*Pkdd2*f**2*fd*k1**2 - 60*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 40*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 20*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 120*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 80*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 2048*C*D1*Dd*Pk2*f**3*r*s + 512*C*D1*Dd*Pk2*f**3*r - 3168*C*D1*Dd*Pk2*f**3*s**2 + 2608*C*D1*Dd*Pk2*f**3*s - 792*C*D1*Dd*Pk2*f**3 + 13056*C*D1*Dd*Pk2*f**2*fd*r*s - 3808*C*D1*Dd*Pk2*f**2*fd*r + 15552*C*D1*Dd*Pk2*f**2*fd*s**2 - 14512*C*D1*Dd*Pk2*f**2*fd*s + 2928*C*D1*Dd*Pk2*f**2*fd + 160*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 80*C*D1*Dd*Pkdd2*f**3*k1**2*s + 40*C*D1*Dd*Pkdd2*f**3*k1**2 - 480*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 280*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 40*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 2176*C*D1*Ddd*Pk2*f**3*r*s - 544*C*D1*Ddd*Pk2*f**3*r + 2592*C*D1*Ddd*Pk2*f**3*s**2 - 2384*C*D1*Ddd*Pk2*f**3*s + 648*C*D1*Ddd*Pk2*f**3 - 80*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 40*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 20*C*D1*Ddd*Pkdd2*f**3*k1**2 + 6528*C*Dd**2*Pk2*f**3*r*s - 1632*C*Dd**2*Pk2*f**3*r + 7776*C*Dd**2*Pk2*f**3*s**2 - 7152*C*Dd**2*Pk2*f**3*s + 1088*C*Dd**2*Pk2*f**3 - 240*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 120*C*Dd**2*Pkdd2*f**3*k1**2*s - 672*D1**2*Pk2*b2*f*fd*r*s + 336*D1**2*Pk2*b2*f*fd*r - 1848*D1**2*Pk2*b2*f*fd*s**2 + 1848*D1**2*Pk2*b2*f*fd*s - 924*D1**2*Pk2*b2*f*fd + 672*D1**2*Pk2*b2*f*fdd*r*s - 336*D1**2*Pk2*b2*f*fdd*r + 1512*D1**2*Pk2*b2*f*fdd*s**2 - 1512*D1**2*Pk2*b2*f*fdd*s + 756*D1**2*Pk2*b2*f*fdd + 672*D1**2*Pk2*b2*fd**2*r*s - 336*D1**2*Pk2*b2*fd**2*r + 1512*D1**2*Pk2*b2*fd**2*s**2 - 1512*D1**2*Pk2*b2*fd**2*s - 336*D1**2*Pk2*bd2*f**2*r*s - 924*D1**2*Pk2*bd2*f**2*s**2 + 336*D1**2*Pk2*bd2*f**2*s + 1344*D1**2*Pk2*bd2*f*fd*r*s - 336*D1**2*Pk2*bd2*f*fd*r + 3024*D1**2*Pk2*bd2*f*fd*s**2 - 2184*D1**2*Pk2*bd2*f*fd*s + 336*D1**2*Pk2*bd2*f*fd + 336*D1**2*Pk2*bdd2*f**2*r*s + 756*D1**2*Pk2*bdd2*f**2*s**2 - 336*D1**2*Pk2*bdd2*f**2*s - 648*D1**2*Pk2*f**2*fd*r**2 - 756*D1**2*Pk2*f**2*fd*r*s + 684*D1**2*Pk2*f**2*fd*r + 1188*D1**2*Pk2*f**2*fd*s**2 - 540*D1**2*Pk2*f**2*fd*s + 180*D1**2*Pk2*f**2*fd + 648*D1**2*Pk2*f**2*fdd*r**2 + 396*D1**2*Pk2*f**2*fdd*r*s - 564*D1**2*Pk2*f**2*fdd*r - 972*D1**2*Pk2*f**2*fdd*s**2 + 516*D1**2*Pk2*f**2*fdd*s - 108*D1**2*Pk2*f**2*fdd + 672*D1**2*Pk2*f**2*gd2*r*s + 1848*D1**2*Pk2*f**2*gd2*s**2 - 672*D1**2*Pk2*f**2*gd2*s - 672*D1**2*Pk2*f**2*gdd2*r*s - 1512*D1**2*Pk2*f**2*gdd2*s**2 + 672*D1**2*Pk2*f**2*gdd2*s + 1296*D1**2*Pk2*f*fd**2*r**2 + 792*D1**2*Pk2*f*fd**2*r*s - 1128*D1**2*Pk2*f*fd**2*r - 1944*D1**2*Pk2*f*fd**2*s**2 + 1032*D1**2*Pk2*f*fd**2*s + 132*D1**2*Pk2*f*fd**2 + 1344*D1**2*Pk2*f*fd*g2*r*s - 672*D1**2*Pk2*f*fd*g2*r + 3696*D1**2*Pk2*f*fd*g2*s**2 - 3696*D1**2*Pk2*f*fd*g2*s + 1848*D1**2*Pk2*f*fd*g2 - 2688*D1**2*Pk2*f*fd*gd2*r*s + 672*D1**2*Pk2*f*fd*gd2*r - 6048*D1**2*Pk2*f*fd*gd2*s**2 + 4368*D1**2*Pk2*f*fd*gd2*s - 672*D1**2*Pk2*f*fd*gd2 - 1344*D1**2*Pk2*f*fdd*g2*r*s + 672*D1**2*Pk2*f*fdd*g2*r - 3024*D1**2*Pk2*f*fdd*g2*s**2 + 3024*D1**2*Pk2*f*fdd*g2*s - 1512*D1**2*Pk2*f*fdd*g2 - 1344*D1**2*Pk2*fd**2*g2*r*s + 672*D1**2*Pk2*fd**2*g2*r - 3024*D1**2*Pk2*fd**2*g2*s**2 + 3024*D1**2*Pk2*fd**2*g2*s + 72*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 - 72*D1**2*Pkdd2*b2*f*fd*k1**2*s + 36*D1**2*Pkdd2*b2*f*fd*k1**2 - 36*D1**2*Pkdd2*b2*f*fdd*k1**2*s**2 + 36*D1**2*Pkdd2*b2*f*fdd*k1**2*s - 18*D1**2*Pkdd2*b2*f*fdd*k1**2 - 36*D1**2*Pkdd2*b2*fd**2*k1**2*s**2 + 36*D1**2*Pkdd2*b2*fd**2*k1**2*s + 36*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 - 72*D1**2*Pkdd2*bd2*f*fd*k1**2*s**2 + 36*D1**2*Pkdd2*bd2*f*fd*k1**2*s - 18*D1**2*Pkdd2*bdd2*f**2*k1**2*s**2 - 6*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 4*D1**2*Pkdd2*f**2*fd*k1**2*s - 2*D1**2*Pkdd2*f**2*fd*k1**2 + 30*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 20*D1**2*Pkdd2*f**2*fdd*k1**2*s + 10*D1**2*Pkdd2*f**2*fdd*k1**2 - 72*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 36*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 60*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 40*D1**2*Pkdd2*f*fd**2*k1**2*s - 144*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 144*D1**2*Pkdd2*f*fd*g2*k1**2*s - 72*D1**2*Pkdd2*f*fd*g2*k1**2 + 144*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 72*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 72*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 72*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 36*D1**2*Pkdd2*f*fdd*g2*k1**2 + 72*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 72*D1**2*Pkdd2*fd**2*g2*k1**2*s + 4*D1**2*bd1**2*(-35*Pkdd2*g2*k1**2*s*(s - 1) + 3*f**2*(14*Pk2*(r - 1) + 3*Pkdd2*k1**2*s*(2*s - 3)) + 7*f*(6*Pk2*(2*K*s + r**2*(K - 1) - r*(4*K*s + K - 2) - 1) + Pkdd2*k1**2*s*(C + 2)*(s - 1))) + 6*D1**2*bdd1*f*(14*Pk2*f**2*(3*r**2 + r*(5*s - 4) - 5*s + 2) - 28*Pk2*g2*r*(r - 4*s) + f*(2*Pk2*(63*K*s**2 + r**2*(26*C - 12) - 7*r*(s*(8*C - 4*K - 9) + 2) - 7*s*(4*K + 5) + 14) + 3*Pkdd2*k1**2*(-s**2*(K - 1) - 2*s + 1))) - 1344*D1*Dd*Pk2*b2*f**2*r*s + 336*D1*Dd*Pk2*b2*f**2*r - 3696*D1*Dd*Pk2*b2*f**2*s**2 + 2520*D1*Dd*Pk2*b2*f**2*s - 924*D1*Dd*Pk2*b2*f**2 + 5376*D1*Dd*Pk2*b2*f*fd*r*s - 2016*D1*Dd*Pk2*b2*f*fd*r + 12096*D1*Dd*Pk2*b2*f*fd*s**2 - 10416*D1*Dd*Pk2*b2*f*fd*s + 2184*D1*Dd*Pk2*b2*f*fd + 2688*D1*Dd*Pk2*bd2*f**2*r*s - 336*D1*Dd*Pk2*bd2*f**2*r + 6048*D1*Dd*Pk2*bd2*f**2*s**2 - 3528*D1*Dd*Pk2*bd2*f**2*s + 336*D1*Dd*Pk2*bd2*f**2 - 864*D1*Dd*Pk2*f**3*r**2 - 1008*D1*Dd*Pk2*f**3*r*s + 1116*D1*Dd*Pk2*f**3*r + 1584*D1*Dd*Pk2*f**3*s**2 - 288*D1*Dd*Pk2*f**3*s - 36*D1*Dd*Pk2*f**3 + 5184*D1*Dd*Pk2*f**2*fd*r**2 + 3168*D1*Dd*Pk2*f**2*fd*r*s - 5244*D1*Dd*Pk2*f**2*fd*r - 7776*D1*Dd*Pk2*f**2*fd*s**2 + 3216*D1*Dd*Pk2*f**2*fd*s + 612*D1*Dd*Pk2*f**2*fd + 2688*D1*Dd*Pk2*f**2*g2*r*s - 672*D1*Dd*Pk2*f**2*g2*r + 7392*D1*Dd*Pk2*f**2*g2*s**2 - 5040*D1*Dd*Pk2*f**2*g2*s + 1848*D1*Dd*Pk2*f**2*g2 - 5376*D1*Dd*Pk2*f**2*gd2*r*s + 672*D1*Dd*Pk2*f**2*gd2*r - 12096*D1*Dd*Pk2*f**2*gd2*s**2 + 7056*D1*Dd*Pk2*f**2*gd2*s - 672*D1*Dd*Pk2*f**2*gd2 - 10752*D1*Dd*Pk2*f*fd*g2*r*s + 4032*D1*Dd*Pk2*f*fd*g2*r - 24192*D1*Dd*Pk2*f*fd*g2*s**2 + 20832*D1*Dd*Pk2*f*fd*g2*s - 4368*D1*Dd*Pk2*f*fd*g2 + 144*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 - 72*D1*Dd*Pkdd2*b2*f**2*k1**2*s + 36*D1*Dd*Pkdd2*b2*f**2*k1**2 - 288*D1*Dd*Pkdd2*b2*f*fd*k1**2*s**2 + 216*D1*Dd*Pkdd2*b2*f*fd*k1**2*s - 36*D1*Dd*Pkdd2*b2*f*fd*k1**2 - 144*D1*Dd*Pkdd2*bd2*f**2*k1**2*s**2 + 36*D1*Dd*Pkdd2*bd2*f**2*k1**2*s - 8*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 4*D1*Dd*Pkdd2*f**3*k1**2*s - 2*D1*Dd*Pkdd2*f**3*k1**2 + 240*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 140*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 20*D1*Dd*Pkdd2*f**2*fd*k1**2 - 288*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 144*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 72*D1*Dd*Pkdd2*f**2*g2*k1**2 + 288*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 72*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 576*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 432*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 72*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 1344*D1*Ddd*Pk2*b2*f**2*r*s - 336*D1*Ddd*Pk2*b2*f**2*r + 3024*D1*Ddd*Pk2*b2*f**2*s**2 - 2184*D1*Ddd*Pk2*b2*f**2*s + 756*D1*Ddd*Pk2*b2*f**2 + 864*D1*Ddd*Pk2*f**3*r**2 + 528*D1*Ddd*Pk2*f**3*r*s - 996*D1*Ddd*Pk2*f**3*r - 1296*D1*Ddd*Pk2*f**3*s**2 + 384*D1*Ddd*Pk2*f**3*s + 108*D1*Ddd*Pk2*f**3 - 2688*D1*Ddd*Pk2*f**2*g2*r*s + 672*D1*Ddd*Pk2*f**2*g2*r - 6048*D1*Ddd*Pk2*f**2*g2*s**2 + 4368*D1*Ddd*Pk2*f**2*g2*s - 1512*D1*Ddd*Pk2*f**2*g2 - 72*D1*Ddd*Pkdd2*b2*f**2*k1**2*s**2 + 36*D1*Ddd*Pkdd2*b2*f**2*k1**2*s - 18*D1*Ddd*Pkdd2*b2*f**2*k1**2 + 40*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 20*D1*Ddd*Pkdd2*f**3*k1**2*s + 10*D1*Ddd*Pkdd2*f**3*k1**2 + 144*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 72*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 36*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 2*D1*bd1*(D1*(-168*Pk2*fd*g2*r*(r - 4*s + 2) - 3*f**3*(14*Pk2*(3*r**2 + r*(5*s - 4) - 5*s + 2) - 9*Pkdd2*k1**2*s**2) + f**2*(2*Pk2*(-231*K*s**2 + 21*fd*(18*r**2 + 5*r*(6*s - 5) - 20*s + 9) + r**2*(44 - 86*C) + 7*r*(s*(32*C - 12*K - 37) + 4) + 21*s*(4*K + 7) - 42) + Pkdd2*k1**2*(s**2*(7*C + 18*K - 4) + 36*s - 18)) + f*(-168*Pk2*gd2*(r**2 - r*(4*s + 1) + 2*s) + 6*fd*(Pk2*(56*C*s + 14*K*(r*(8*s - 2) + 18*s**2 - 13*s + 2) + r**2*(104*C - 48) + r*(-224*C*s + 4*C + 252*s - 53) - 98*s + 21) + 3*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 2)) - 7*g2*(-24*Pk2*r*(r - 4*s) + 5*Pkdd2*k1**2*s**2))) + 6*Dd*f*(7*Pk2*f**2*(24*r**2 + r*(40*s - 33) - 30*s + 13) - 112*Pk2*g2*(r**2 - 4*r*s + s) + f*(Pk2*(112*C*s + 14*K*(2*r*(8*s - 1) + 36*s**2 - 21*s + 2) + r**2*(208*C - 96) - r*(448*C*s + 48*C - 504*s + 71) - 266*s + 63) - 3*Pkdd2*k1**2*(4*s - 1)*(s*(K - 1) + 1)))) + 4032*Dd**2*Pk2*b2*f**2*r*s - 1008*Dd**2*Pk2*b2*f**2*r + 9072*Dd**2*Pk2*b2*f**2*s**2 - 6552*Dd**2*Pk2*b2*f**2*s + 672*Dd**2*Pk2*b2*f**2 + 2592*Dd**2*Pk2*f**3*r**2 + 1584*Dd**2*Pk2*f**3*r*s - 2988*Dd**2*Pk2*f**3*r - 3888*Dd**2*Pk2*f**3*s**2 + 1152*Dd**2*Pk2*f**3*s + 696*Dd**2*Pk2*f**3 - 8064*Dd**2*Pk2*f**2*g2*r*s + 2016*Dd**2*Pk2*f**2*g2*r - 18144*Dd**2*Pk2*f**2*g2*s**2 + 13104*Dd**2*Pk2*f**2*g2*s - 1344*Dd**2*Pk2*f**2*g2 - 216*Dd**2*Pkdd2*b2*f**2*k1**2*s**2 + 108*Dd**2*Pkdd2*b2*f**2*k1**2*s + 120*Dd**2*Pkdd2*f**3*k1**2*s**2 - 60*Dd**2*Pkdd2*f**3*k1**2*s + 432*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 216*Dd**2*Pkdd2*f**2*g2*k1**2*s - 35*Pkdd2*b1**3*k1**2*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + b1**2*(D1**2*(14*C*Pkdd2*fdd*k1**2*s**2 + 84*K*Pk2*fdd*r**2 - 336*K*Pk2*fdd*r*s + 336*K*Pk2*fdd*r + 105*K*Pkdd2*bdd1*k1**2*s**2 - 70*K*Pkdd2*bdd1*k1**2*s + 35*K*Pkdd2*bdd1*k1**2 - 168*Pk2*f*fdd*r - 84*Pk2*fdd*r**2 - 168*Pk2*fdd*r - 70*Pkdd2*bd1*k1**2*(K - 1)*(3*s**2 - 2*s + 1) - 105*Pkdd2*bdd1*k1**2*s**2 + 70*Pkdd2*bdd1*k1**2*s - 35*Pkdd2*bdd1*k1**2 + 72*Pkdd2*f*fdd*k1**2*s**2 + 36*Pkdd2*f*fdd*k1**2*s - 18*Pkdd2*f*fdd*k1**2 + 28*Pkdd2*fdd*k1**2*s**2 + 140*Pkdd2*gd2*k1**2*s**2 - 70*Pkdd2*gdd2*k1**2*s**2 + fd**2*(-168*Pk2*(r - 1) + 36*Pkdd2*k1**2*s*(2*s + 1)) + fd*(168*Pk2*r*(-K*(r - 4*s + 4) + f + r + 2) - Pkdd2*k1**2*(-35*K*(s - 1)**2 + 36*f*(4*s**2 + 2*s - 1) + 7*s**2*(4*C + 13) - 70*s + 35))) + D1*(-Dd*(336*Pk2*f*(K*(2*r**2 - 8*r*s + 4*s + 1) + fd*(2*r - 1) - 2*r**2 + 2*r - 1) + 72*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*f*k1**2*(28*C*(4*s**2 - 2*s + 1) + fd*(36 - 576*s**2) - (35*K - 91)*(4*s**2 - 2*s + 1)) - 70*Pkdd2*k1**2*(bd1*(K - 1)*(12*s**2 - 7*s + 1) + 2*g2*(4*s**2 - 2*s + 1) + 2*gd2*s*(1 - 4*s)) - 28*fd*(12*Pk2*(2*K*(r**2 - 4*r*s + 2*r + s - 1) - 2*r**2 - r + 1) + Pkdd2*k1**2*s*(C + 2)*(4*s - 1))) + 2*Ddd*(84*Pk2*f*(K*(2*r**2 - 8*r*s + 4*s + 1) - 2*r**2 + 2*r - 1) + 18*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*f*k1**2*(7*C + 14)*(4*s**2 - 2*s + 1) - 35*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1))) + 12*Dd**2*(18*Pkdd2*f**2*k1**2*s*(2*s - 1) + 35*Pkdd2*g2*k1**2*s*(1 - 2*s) + 7*f*(2*Pk2*(3*K*(2*r**2 - 8*r*s + 4*s - 1) - 6*r**2 + 6*r - 1) + Pkdd2*k1**2*s*(C + 2)*(2*s - 1)))) + 2*b1*(-344*C*D1**2*Pk2*f*fd*r**2 + 896*C*D1**2*Pk2*f*fd*r*s - 104*C*D1**2*Pk2*f*fd*r - 448*C*D1**2*Pk2*f*fd*s - 172*C*D1**2*Pk2*f*fd + 312*C*D1**2*Pk2*f*fdd*r**2 - 672*C*D1**2*Pk2*f*fdd*r*s + 24*C*D1**2*Pk2*f*fdd*r + 336*C*D1**2*Pk2*f*fdd*s + 156*C*D1**2*Pk2*f*fdd + 312*C*D1**2*Pk2*fd**2*r**2 - 672*C*D1**2*Pk2*fd**2*r*s + 24*C*D1**2*Pk2*fd**2*r + 336*C*D1**2*Pk2*fd**2*s - 336*C*D1**2*Pk2*fd**2 + 14*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 14*C*D1**2*Pkdd2*f*fd*k1**2*s + 7*C*D1**2*Pkdd2*f*fd*k1**2 - 688*C*D1*Dd*Pk2*f**2*r**2 + 1792*C*D1*Dd*Pk2*f**2*r*s + 240*C*D1*Dd*Pk2*f**2*r - 896*C*D1*Dd*Pk2*f**2*s - 344*C*D1*Dd*Pk2*f**2 + 2496*C*D1*Dd*Pk2*f*fd*r**2 - 5376*C*D1*Dd*Pk2*f*fd*r*s - 480*C*D1*Dd*Pk2*f*fd*r + 2688*C*D1*Dd*Pk2*f*fd*s - 384*C*D1*Dd*Pk2*f*fd + 28*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 14*C*D1*Dd*Pkdd2*f**2*k1**2*s + 7*C*D1*Dd*Pkdd2*f**2*k1**2 + 624*C*D1*Ddd*Pk2*f**2*r**2 - 1344*C*D1*Ddd*Pk2*f**2*r*s - 288*C*D1*Ddd*Pk2*f**2*r + 672*C*D1*Ddd*Pk2*f**2*s + 312*C*D1*Ddd*Pk2*f**2 + 1872*C*Dd**2*Pk2*f**2*r**2 - 4032*C*Dd**2*Pk2*f**2*r*s - 864*C*Dd**2*Pk2*f**2*r + 2016*C*Dd**2*Pk2*f**2*s - 360*C*Dd**2*Pk2*f**2 - 336*D1**2*K*Pk2*f*fd*r*s + 168*D1**2*K*Pk2*f*fd*r - 924*D1**2*K*Pk2*f*fd*s**2 + 924*D1**2*K*Pk2*f*fd*s - 462*D1**2*K*Pk2*f*fd + 336*D1**2*K*Pk2*f*fdd*r*s - 168*D1**2*K*Pk2*f*fdd*r + 756*D1**2*K*Pk2*f*fdd*s**2 - 756*D1**2*K*Pk2*f*fdd*s + 378*D1**2*K*Pk2*f*fdd + 336*D1**2*K*Pk2*fd**2*r*s - 168*D1**2*K*Pk2*fd**2*r + 756*D1**2*K*Pk2*fd**2*s**2 - 756*D1**2*K*Pk2*fd**2*s + 36*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 36*D1**2*K*Pkdd2*f*fd*k1**2*s + 18*D1**2*K*Pkdd2*f*fd*k1**2 - 18*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 18*D1**2*K*Pkdd2*f*fdd*k1**2*s - 9*D1**2*K*Pkdd2*f*fdd*k1**2 - 18*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 18*D1**2*K*Pkdd2*fd**2*k1**2*s - 378*D1**2*Pk2*f**2*fd*r**2 - 630*D1**2*Pk2*f**2*fd*r*s + 546*D1**2*Pk2*f**2*fd*r + 210*D1**2*Pk2*f**2*fd*s - 168*D1**2*Pk2*f**2*fd + 378*D1**2*Pk2*f**2*fdd*r**2 + 630*D1**2*Pk2*f**2*fdd*r*s - 546*D1**2*Pk2*f**2*fdd*r - 210*D1**2*Pk2*f**2*fdd*s + 168*D1**2*Pk2*f**2*fdd + 756*D1**2*Pk2*f*fd**2*r**2 + 1260*D1**2*Pk2*f*fd**2*r*s - 1092*D1**2*Pk2*f*fd**2*r - 420*D1**2*Pk2*f*fd**2*s + 294*D1**2*Pk2*f*fd**2 + 176*D1**2*Pk2*f*fd*r**2 - 1036*D1**2*Pk2*f*fd*r*s + 286*D1**2*Pk2*f*fd*r + 224*D1**2*Pk2*f*fd*s + 172*D1**2*Pk2*f*fd - 144*D1**2*Pk2*f*fdd*r**2 + 756*D1**2*Pk2*f*fdd*r*s - 150*D1**2*Pk2*f*fdd*r - 168*D1**2*Pk2*f*fdd*s - 156*D1**2*Pk2*f*fdd + 168*D1**2*Pk2*f*gd2*r**2 - 672*D1**2*Pk2*f*gd2*r*s - 336*D1**2*Pk2*f*gd2*r + 672*D1**2*Pk2*f*gd2*s + 168*D1**2*Pk2*f*gd2 - 84*D1**2*Pk2*f*gdd2*r**2 + 336*D1**2*Pk2*f*gdd2*r*s + 168*D1**2*Pk2*f*gdd2*r - 336*D1**2*Pk2*f*gdd2*s - 84*D1**2*Pk2*f*gdd2 - 144*D1**2*Pk2*fd**2*r**2 + 756*D1**2*Pk2*fd**2*r*s - 150*D1**2*Pk2*fd**2*r - 168*D1**2*Pk2*fd**2*s + 252*D1**2*Pk2*fd**2 + 168*D1**2*Pk2*fd*g2*r**2 - 672*D1**2*Pk2*fd*g2*r*s + 672*D1**2*Pk2*fd*g2*r - 168*D1**2*Pk2*fd*gd2*r**2 + 672*D1**2*Pk2*fd*gd2*r*s - 168*D1**2*Pk2*fd*gd2*r - 336*D1**2*Pk2*fd*gd2*s + 336*D1**2*Pk2*fd*gd2 - 84*D1**2*Pk2*fdd*g2*r**2 + 336*D1**2*Pk2*fdd*g2*r*s - 336*D1**2*Pk2*fdd*g2*r + 35*D1**2*Pkdd2*bd1**2*k1**2*s*(K - 1)*(3*s - 2) + 81*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 54*D1**2*Pkdd2*f**2*fd*k1**2*s + 27*D1**2*Pkdd2*f**2*fd*k1**2 - 8*D1**2*Pkdd2*f*fd*k1**2*s**2 - 28*D1**2*Pkdd2*f*fd*k1**2*s + 14*D1**2*Pkdd2*f*fd*k1**2 + 18*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 35*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 18*D1**2*Pkdd2*fd**2*k1**2*s**2 - 35*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 70*D1**2*Pkdd2*fd*g2*k1**2*s - 35*D1**2*Pkdd2*fd*g2*k1**2 + D1**2*bdd1*(-35*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 3*f**2*(28*Pk2*r + 3*Pkdd2*k1**2*(4*s**2 - 6*s + 3)) + 7*f*(6*Pk2*(K*(2*r**2 - 8*r*s - 2*r + 4*s + 1) - 2*r**2 + 4*r - 1) + Pkdd2*k1**2*(C + 2)*(2*s**2 - 2*s + 1))) - 672*D1*Dd*K*Pk2*f**2*r*s + 168*D1*Dd*K*Pk2*f**2*r - 1848*D1*Dd*K*Pk2*f**2*s**2 + 1260*D1*Dd*K*Pk2*f**2*s - 462*D1*Dd*K*Pk2*f**2 + 2688*D1*Dd*K*Pk2*f*fd*r*s - 1008*D1*Dd*K*Pk2*f*fd*r + 6048*D1*Dd*K*Pk2*f*fd*s**2 - 5208*D1*Dd*K*Pk2*f*fd*s + 1092*D1*Dd*K*Pk2*f*fd + 72*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 36*D1*Dd*K*Pkdd2*f**2*k1**2*s + 18*D1*Dd*K*Pkdd2*f**2*k1**2 - 144*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 108*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 18*D1*Dd*K*Pkdd2*f*fd*k1**2 - 504*D1*Dd*Pk2*f**3*r**2 - 840*D1*Dd*Pk2*f**3*r*s + 714*D1*Dd*Pk2*f**3*r + 420*D1*Dd*Pk2*f**3*s - 252*D1*Dd*Pk2*f**3 + 3024*D1*Dd*Pk2*f**2*fd*r**2 + 5040*D1*Dd*Pk2*f**2*fd*r*s - 4326*D1*Dd*Pk2*f**2*fd*r - 2100*D1*Dd*Pk2*f**2*fd*s + 1302*D1*Dd*Pk2*f**2*fd + 352*D1*Dd*Pk2*f**2*r**2 - 2072*D1*Dd*Pk2*f**2*r*s + 166*D1*Dd*Pk2*f**2*r + 1036*D1*Dd*Pk2*f**2*s + 176*D1*Dd*Pk2*f**2 - 1152*D1*Dd*Pk2*f*fd*r**2 + 6048*D1*Dd*Pk2*f*fd*r*s - 780*D1*Dd*Pk2*f*fd*r - 2184*D1*Dd*Pk2*f*fd*s + 468*D1*Dd*Pk2*f*fd + 672*D1*Dd*Pk2*f*g2*r**2 - 2688*D1*Dd*Pk2*f*g2*r*s + 1344*D1*Dd*Pk2*f*g2*s + 336*D1*Dd*Pk2*f*g2 - 672*D1*Dd*Pk2*f*gd2*r**2 + 2688*D1*Dd*Pk2*f*gd2*r*s + 672*D1*Dd*Pk2*f*gd2*r - 2016*D1*Dd*Pk2*f*gd2*s - 672*D1*Dd*Pk2*fd*g2*r**2 + 2688*D1*Dd*Pk2*fd*g2*r*s - 1344*D1*Dd*Pk2*fd*g2*r - 672*D1*Dd*Pk2*fd*g2*s + 672*D1*Dd*Pk2*fd*g2 + 108*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 54*D1*Dd*Pkdd2*f**3*k1**2*s + 27*D1*Dd*Pkdd2*f**3*k1**2 - 16*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 8*D1*Dd*Pkdd2*f**2*k1**2*s - 4*D1*Dd*Pkdd2*f**2*k1**2 + 144*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 36*D1*Dd*Pkdd2*f*fd*k1**2*s - 140*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 70*D1*Dd*Pkdd2*f*g2*k1**2*s - 35*D1*Dd*Pkdd2*f*g2*k1**2 + 672*D1*Ddd*K*Pk2*f**2*r*s - 168*D1*Ddd*K*Pk2*f**2*r + 1512*D1*Ddd*K*Pk2*f**2*s**2 - 1092*D1*Ddd*K*Pk2*f**2*s + 378*D1*Ddd*K*Pk2*f**2 - 36*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 18*D1*Ddd*K*Pkdd2*f**2*k1**2*s - 9*D1*Ddd*K*Pkdd2*f**2*k1**2 + 504*D1*Ddd*Pk2*f**3*r**2 + 840*D1*Ddd*Pk2*f**3*r*s - 714*D1*Ddd*Pk2*f**3*r - 420*D1*Ddd*Pk2*f**3*s + 252*D1*Ddd*Pk2*f**3 - 288*D1*Ddd*Pk2*f**2*r**2 + 1512*D1*Ddd*Pk2*f**2*r*s - 90*D1*Ddd*Pk2*f**2*r - 756*D1*Ddd*Pk2*f**2*s - 144*D1*Ddd*Pk2*f**2 - 336*D1*Ddd*Pk2*f*g2*r**2 + 1344*D1*Ddd*Pk2*f*g2*r*s - 672*D1*Ddd*Pk2*f*g2*s - 168*D1*Ddd*Pk2*f*g2 + 36*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Ddd*Pkdd2*f**2*k1**2*s + 9*D1*Ddd*Pkdd2*f**2*k1**2 + D1*bd1*(D1*(70*Pkdd2*k1**2*(g2*(2*s**2 - 2*s + 1) + gd2*s*(1 - 2*s)) - 6*f**2*(14*Pk2*r + 3*Pkdd2*k1**2*(4*s**2 - 6*s + 3)) + f*(-84*Pk2*(K*(2*r**2 - 2*r*(4*s + 1) + 4*s + 1) - 2*r**2 + 4*r - 1) + Pkdd2*k1**2*(-14*C*(2*s**2 - 2*s + 1) + s**2*(35*K + 144*fd - 91) - s*(72*fd - 56) - 28)) + 14*fd*(6*Pk2*(K*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*r**2 + 1) + Pkdd2*k1**2*s*(C + 2)*(2*s - 1))) + 2*Dd*(-35*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) + 3*f**2*(28*Pk2*(2*r - 1) + 3*Pkdd2*k1**2*(16*s**2 - 16*s + 3)) + 7*f*(24*Pk2*(2*r - 1)*(-4*K*s + r*(K - 1) + 1) + Pkdd2*k1**2*(C + 2)*(8*s**2 - 6*s + 1)))) + 2016*Dd**2*K*Pk2*f**2*r*s - 504*Dd**2*K*Pk2*f**2*r + 4536*Dd**2*K*Pk2*f**2*s**2 - 3276*Dd**2*K*Pk2*f**2*s + 336*Dd**2*K*Pk2*f**2 - 108*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 54*Dd**2*K*Pkdd2*f**2*k1**2*s + 1512*Dd**2*Pk2*f**3*r**2 + 2520*Dd**2*Pk2*f**3*r*s - 2142*Dd**2*Pk2*f**3*r - 1260*Dd**2*Pk2*f**3*s + 672*Dd**2*Pk2*f**3 - 864*Dd**2*Pk2*f**2*r**2 + 4536*Dd**2*Pk2*f**2*r*s - 270*Dd**2*Pk2*f**2*r - 2268*Dd**2*Pk2*f**2*s + 612*Dd**2*Pk2*f**2 - 1008*Dd**2*Pk2*f*g2*r**2 + 4032*Dd**2*Pk2*f*g2*r*s - 2016*Dd**2*Pk2*f*g2*s + 504*Dd**2*Pk2*f*g2 + 108*Dd**2*Pkdd2*f**2*k1**2*s**2 - 54*Dd**2*Pkdd2*f**2*k1**2*s))/(210*d**2*k3**2) + D1**2*Pk3*ct**2*(3144*C*D1**2*Pk2*bdd1*f**2*r*s + 1956*C*D1**2*Pk2*f**2*fd*r**2 + 7128*C*D1**2*Pk2*f**2*fd*r*s - 3680*C*D1**2*Pk2*f**2*fd*r + 4536*C*D1**2*Pk2*f**2*fd*s**2 - 5400*C*D1**2*Pk2*f**2*fd*s + 2164*C*D1**2*Pk2*f**2*fd - 1356*C*D1**2*Pk2*f**2*fdd*r**2 - 7128*C*D1**2*Pk2*f**2*fdd*r*s + 3280*C*D1**2*Pk2*f**2*fdd*r - 4536*C*D1**2*Pk2*f**2*fdd*s**2 + 5400*C*D1**2*Pk2*f**2*fdd*s - 1964*C*D1**2*Pk2*f**2*fdd - 2712*C*D1**2*Pk2*f*fd**2*r**2 - 14256*C*D1**2*Pk2*f*fd**2*r*s + 6560*C*D1**2*Pk2*f*fd**2*r - 9072*C*D1**2*Pk2*f*fd**2*s**2 + 10800*C*D1**2*Pk2*f*fd**2*s - 2376*C*D1**2*Pk2*f*fd**2 - 90*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 180*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 90*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 270*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 180*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 90*C*D1**2*Pkdd2*f**2*fd*k1**2 + 2608*C*D1*Dd*Pk2*f**3*r**2 + 9504*C*D1*Dd*Pk2*f**3*r*s - 4984*C*D1*Dd*Pk2*f**3*r + 6048*C*D1*Dd*Pk2*f**3*s**2 - 7776*C*D1*Dd*Pk2*f**3*s + 2816*C*D1*Dd*Pk2*f**3 - 10848*C*D1*Dd*Pk2*f**2*fd*r**2 - 57024*C*D1*Dd*Pk2*f**2*fd*r*s + 25672*C*D1*Dd*Pk2*f**2*fd*r - 36288*C*D1*Dd*Pk2*f**2*fd*s**2 + 44928*C*D1*Dd*Pk2*f**2*fd*s - 11960*C*D1*Dd*Pk2*f**2*fd - 360*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 180*C*D1*Dd*Pkdd2*f**3*k1**2*s - 90*C*D1*Dd*Pkdd2*f**3*k1**2 - 1808*C*D1*Ddd*Pk2*f**3*r**2 - 9504*C*D1*Ddd*Pk2*f**3*r*s + 4184*C*D1*Ddd*Pk2*f**3*r - 6048*C*D1*Ddd*Pk2*f**3*s**2 + 7776*C*D1*Ddd*Pk2*f**3*s - 2416*C*D1*Ddd*Pk2*f**3 - 5424*C*Dd**2*Pk2*f**3*r**2 - 28512*C*Dd**2*Pk2*f**3*r*s + 12552*C*Dd**2*Pk2*f**3*r - 18144*C*Dd**2*Pk2*f**3*s**2 + 23328*C*Dd**2*Pk2*f**3*s - 5656*C*Dd**2*Pk2*f**3 - 210*D1**2*K*Pk2*bdd1*f**2*r**2 - 1260*D1**2*K*Pk2*bdd1*f**2*r*s + 420*D1**2*K*Pk2*bdd1*f**2*r - 1260*D1**2*K*Pk2*bdd1*f**2*s**2 + 1260*D1**2*K*Pk2*bdd1*f**2*s - 210*D1**2*K*Pk2*bdd1*f**2 + 420*D1**2*Pk2*b2*f*fd*r**2 + 2520*D1**2*Pk2*b2*f*fd*r*s - 1260*D1**2*Pk2*b2*f*fd*r + 2520*D1**2*Pk2*b2*f*fd*s**2 - 2520*D1**2*Pk2*b2*f*fd*s + 1260*D1**2*Pk2*b2*f*fd - 420*D1**2*Pk2*b2*f*fdd*r**2 - 2520*D1**2*Pk2*b2*f*fdd*r*s + 1260*D1**2*Pk2*b2*f*fdd*r - 2520*D1**2*Pk2*b2*f*fdd*s**2 + 2520*D1**2*Pk2*b2*f*fdd*s - 1260*D1**2*Pk2*b2*f*fdd - 420*D1**2*Pk2*b2*fd**2*r**2 - 2520*D1**2*Pk2*b2*fd**2*r*s + 1260*D1**2*Pk2*b2*fd**2*r - 2520*D1**2*Pk2*b2*fd**2*s**2 + 2520*D1**2*Pk2*b2*fd**2*s + 210*D1**2*Pk2*bd2*f**2*r**2 + 1260*D1**2*Pk2*bd2*f**2*r*s - 420*D1**2*Pk2*bd2*f**2*r + 1260*D1**2*Pk2*bd2*f**2*s**2 - 1260*D1**2*Pk2*bd2*f**2*s + 210*D1**2*Pk2*bd2*f**2 - 840*D1**2*Pk2*bd2*f*fd*r**2 - 5040*D1**2*Pk2*bd2*f*fd*r*s + 2100*D1**2*Pk2*bd2*f*fd*r - 5040*D1**2*Pk2*bd2*f*fd*s**2 + 5040*D1**2*Pk2*bd2*f*fd*s - 1260*D1**2*Pk2*bd2*f*fd + 612*D1**2*Pk2*bdd1*f**2*r**2 - 1572*D1**2*Pk2*bdd1*f**2*r*s - 786*D1**2*Pk2*bdd1*f**2*r - 2520*D1**2*Pk2*bdd1*f*g2*r*s - 210*D1**2*Pk2*bdd2*f**2*r**2 - 1260*D1**2*Pk2*bdd2*f**2*r*s + 420*D1**2*Pk2*bdd2*f**2*r - 1260*D1**2*Pk2*bdd2*f**2*s**2 + 1260*D1**2*Pk2*bdd2*f**2*s - 210*D1**2*Pk2*bdd2*f**2 - 978*D1**2*Pk2*f**2*fd*r**2 - 3564*D1**2*Pk2*f**2*fd*r*s + 1840*D1**2*Pk2*f**2*fd*r - 2268*D1**2*Pk2*f**2*fd*s**2 + 2700*D1**2*Pk2*f**2*fd*s - 1082*D1**2*Pk2*f**2*fd + 678*D1**2*Pk2*f**2*fdd*r**2 + 3564*D1**2*Pk2*f**2*fdd*r*s - 1640*D1**2*Pk2*f**2*fdd*r + 2268*D1**2*Pk2*f**2*fdd*s**2 - 2700*D1**2*Pk2*f**2*fdd*s + 982*D1**2*Pk2*f**2*fdd - 420*D1**2*Pk2*f**2*gd2*r**2 - 2520*D1**2*Pk2*f**2*gd2*r*s + 840*D1**2*Pk2*f**2*gd2*r - 2520*D1**2*Pk2*f**2*gd2*s**2 + 2520*D1**2*Pk2*f**2*gd2*s - 420*D1**2*Pk2*f**2*gd2 + 420*D1**2*Pk2*f**2*gdd2*r**2 + 2520*D1**2*Pk2*f**2*gdd2*r*s - 840*D1**2*Pk2*f**2*gdd2*r + 2520*D1**2*Pk2*f**2*gdd2*s**2 - 2520*D1**2*Pk2*f**2*gdd2*s + 420*D1**2*Pk2*f**2*gdd2 + 1356*D1**2*Pk2*f*fd**2*r**2 + 7128*D1**2*Pk2*f*fd**2*r*s - 3280*D1**2*Pk2*f*fd**2*r + 4536*D1**2*Pk2*f*fd**2*s**2 - 5400*D1**2*Pk2*f*fd**2*s + 1188*D1**2*Pk2*f*fd**2 - 840*D1**2*Pk2*f*fd*g2*r**2 - 5040*D1**2*Pk2*f*fd*g2*r*s + 2520*D1**2*Pk2*f*fd*g2*r - 5040*D1**2*Pk2*f*fd*g2*s**2 + 5040*D1**2*Pk2*f*fd*g2*s - 2520*D1**2*Pk2*f*fd*g2 + 1680*D1**2*Pk2*f*fd*gd2*r**2 + 10080*D1**2*Pk2*f*fd*gd2*r*s - 4200*D1**2*Pk2*f*fd*gd2*r + 10080*D1**2*Pk2*f*fd*gd2*s**2 - 10080*D1**2*Pk2*f*fd*gd2*s + 2520*D1**2*Pk2*f*fd*gd2 + 840*D1**2*Pk2*f*fdd*g2*r**2 + 5040*D1**2*Pk2*f*fdd*g2*r*s - 2520*D1**2*Pk2*f*fdd*g2*r + 5040*D1**2*Pk2*f*fdd*g2*s**2 - 5040*D1**2*Pk2*f*fdd*g2*s + 2520*D1**2*Pk2*f*fdd*g2 + 840*D1**2*Pk2*fd**2*g2*r**2 + 5040*D1**2*Pk2*fd**2*g2*r*s - 2520*D1**2*Pk2*fd**2*g2*r + 5040*D1**2*Pk2*fd**2*g2*s**2 - 5040*D1**2*Pk2*fd**2*g2*s - 63*D1**2*Pkdd2*b2*bdd1*f*k1**2*s**2 + 126*D1**2*Pkdd2*b2*bdd1*f*k1**2*s - 63*D1**2*Pkdd2*b2*bdd1*f*k1**2 - 126*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 + 126*D1**2*Pkdd2*b2*f*fd*k1**2*s - 63*D1**2*Pkdd2*b2*f*fd*k1**2 - 63*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 + 45*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 90*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 45*D1**2*Pkdd2*bdd1*f**2*k1**2 + 126*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 252*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 126*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 135*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 90*D1**2*Pkdd2*f**2*fd*k1**2*s + 45*D1**2*Pkdd2*f**2*fd*k1**2 + 126*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 252*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 252*D1**2*Pkdd2*f*fd*g2*k1**2*s + 126*D1**2*Pkdd2*f*fd*g2*k1**2 + 42*D1**2*bd1**2*(-3*K*Pkdd2*f*k1**2*s*(s - 1) + 5*Pk2*f**2*(4*r**2 - 5*r + 3) + Pk2*f*(-30*K*s + r**2*(52*C - 32) + 5*r*(12*K*s - 7) + 15) - 20*Pk2*g2*r**2) + 840*D1*Dd*Pk2*b2*f**2*r**2 + 5040*D1*Dd*Pk2*b2*f**2*r*s - 2100*D1*Dd*Pk2*b2*f**2*r + 5040*D1*Dd*Pk2*b2*f**2*s**2 - 5040*D1*Dd*Pk2*b2*f**2*s + 1680*D1*Dd*Pk2*b2*f**2 - 3360*D1*Dd*Pk2*b2*f*fd*r**2 - 20160*D1*Dd*Pk2*b2*f*fd*r*s + 9240*D1*Dd*Pk2*b2*f*fd*r - 20160*D1*Dd*Pk2*b2*f*fd*s**2 + 20160*D1*Dd*Pk2*b2*f*fd*s - 5040*D1*Dd*Pk2*b2*f*fd - 1680*D1*Dd*Pk2*bd2*f**2*r**2 - 10080*D1*Dd*Pk2*bd2*f**2*r*s + 3780*D1*Dd*Pk2*bd2*f**2*r - 10080*D1*Dd*Pk2*bd2*f**2*s**2 + 10080*D1*Dd*Pk2*bd2*f**2*s - 2100*D1*Dd*Pk2*bd2*f**2 - 1304*D1*Dd*Pk2*f**3*r**2 - 4752*D1*Dd*Pk2*f**3*r*s + 2492*D1*Dd*Pk2*f**3*r - 3024*D1*Dd*Pk2*f**3*s**2 + 3888*D1*Dd*Pk2*f**3*s - 1408*D1*Dd*Pk2*f**3 + 5424*D1*Dd*Pk2*f**2*fd*r**2 + 28512*D1*Dd*Pk2*f**2*fd*r*s - 12836*D1*Dd*Pk2*f**2*fd*r + 18144*D1*Dd*Pk2*f**2*fd*s**2 - 22464*D1*Dd*Pk2*f**2*fd*s + 5980*D1*Dd*Pk2*f**2*fd - 1680*D1*Dd*Pk2*f**2*g2*r**2 - 10080*D1*Dd*Pk2*f**2*g2*r*s + 4200*D1*Dd*Pk2*f**2*g2*r - 10080*D1*Dd*Pk2*f**2*g2*s**2 + 10080*D1*Dd*Pk2*f**2*g2*s - 3360*D1*Dd*Pk2*f**2*g2 + 3360*D1*Dd*Pk2*f**2*gd2*r**2 + 20160*D1*Dd*Pk2*f**2*gd2*r*s - 7560*D1*Dd*Pk2*f**2*gd2*r + 20160*D1*Dd*Pk2*f**2*gd2*s**2 - 20160*D1*Dd*Pk2*f**2*gd2*s + 4200*D1*Dd*Pk2*f**2*gd2 + 6720*D1*Dd*Pk2*f*fd*g2*r**2 + 40320*D1*Dd*Pk2*f*fd*g2*r*s - 18480*D1*Dd*Pk2*f*fd*g2*r + 40320*D1*Dd*Pk2*f*fd*g2*s**2 - 40320*D1*Dd*Pk2*f*fd*g2*s + 10080*D1*Dd*Pk2*f*fd*g2 - 252*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 + 126*D1*Dd*Pkdd2*b2*f**2*k1**2*s - 63*D1*Dd*Pkdd2*b2*f**2*k1**2 + 180*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 90*D1*Dd*Pkdd2*f**3*k1**2*s + 45*D1*Dd*Pkdd2*f**3*k1**2 + 504*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 252*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 126*D1*Dd*Pkdd2*f**2*g2*k1**2 - 840*D1*Ddd*Pk2*b2*f**2*r**2 - 5040*D1*Ddd*Pk2*b2*f**2*r*s + 2100*D1*Ddd*Pk2*b2*f**2*r - 5040*D1*Ddd*Pk2*b2*f**2*s**2 + 5040*D1*Ddd*Pk2*b2*f**2*s - 1680*D1*Ddd*Pk2*b2*f**2 + 904*D1*Ddd*Pk2*f**3*r**2 + 4752*D1*Ddd*Pk2*f**3*r*s - 2092*D1*Ddd*Pk2*f**3*r + 3024*D1*Ddd*Pk2*f**3*s**2 - 3888*D1*Ddd*Pk2*f**3*s + 1208*D1*Ddd*Pk2*f**3 + 1680*D1*Ddd*Pk2*f**2*g2*r**2 + 10080*D1*Ddd*Pk2*f**2*g2*r*s - 4200*D1*Ddd*Pk2*f**2*g2*r + 10080*D1*Ddd*Pk2*f**2*g2*s**2 - 10080*D1*Ddd*Pk2*f**2*g2*s + 3360*D1*Ddd*Pk2*f**2*g2 + 3*D1*bd1*(D1*(f**2*(70*K*Pk2*(r**2 + r*(6*s - 2) + 6*s**2 - 6*s + 1) - 21*K*Pkdd2*k1**2*s**2 + 2*Pk2*r*(r*(42*C - 204) + 143*s*(2 - 4*C) + 143) + Pkdd2*k1**2*(60*C + 12)*(s - 1)**2) - 2*f*(Pk2*fd*(70*K*(2*r**2 + r*(12*s - 5) + 3*(1 - 2*s)**2) - 408*r**2 + r*(-524*C*(4*s - 1) + 1048*s + 73) + 131*s*(4*C - 2) - 131) - 21*Pkdd2*b2*k1**2*(s - 1)**2 + Pkdd2*fd*k1**2*s*(60*C - 30)*(s - 1) + 14*g2*(5*Pk2*r*(r - 6*s) + 3*Pkdd2*k1**2*(s - 1)**2) - 7*s*(3*Pk2*gd2*(20 - 40*r) - 3*Pkdd2*bd2*k1**2*(s - 1) + 6*Pkdd2*gd2*k1**2*(s - 1))) - 42*fd*(20*Pk2*g2*r*(2*s - 1) + Pkdd2*b2*k1**2*s*(s - 1) - 2*Pkdd2*g2*k1**2*s*(s - 1))) - 2*Dd*f*(2*Pk2*f*(35*K*(4*r**2 + 3*r*(8*s - 3) + 24*s**2 - 24*s + 5) - 408*r**2 + r*(-262*C*(8*s - 1) + 1048*s + 335) + 131*s*(4*C - 2) - 131) + 21*Pkdd2*b2*k1**2*(4*s**2 - 5*s + 1) + Pkdd2*f*k1**2*(30*C - 15)*(4*s**2 - 5*s + 1) - 42*g2*(10*Pk2*(-8*r*s + r + 2*s) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 2520*Dd**2*Pk2*b2*f**2*r**2 - 15120*Dd**2*Pk2*b2*f**2*r*s + 6300*Dd**2*Pk2*b2*f**2*r - 15120*Dd**2*Pk2*b2*f**2*s**2 + 15120*Dd**2*Pk2*b2*f**2*s - 2940*Dd**2*Pk2*b2*f**2 + 2712*Dd**2*Pk2*f**3*r**2 + 14256*Dd**2*Pk2*f**3*r*s - 6276*Dd**2*Pk2*f**3*r + 9072*Dd**2*Pk2*f**3*s**2 - 11664*Dd**2*Pk2*f**3*s + 2828*Dd**2*Pk2*f**3 + 5040*Dd**2*Pk2*f**2*g2*r**2 + 30240*Dd**2*Pk2*f**2*g2*r*s - 12600*Dd**2*Pk2*f**2*g2*r + 30240*Dd**2*Pk2*f**2*g2*s**2 - 30240*Dd**2*Pk2*f**2*g2*s + 5880*Dd**2*Pk2*f**2*g2 + 21*b1**3*(3*D1**2*Pkdd2*k1**2*s**2*(2*fd - fdd) + D1*(-40*Dd*Pk2*(K - 1)*(2*r**2 - 2*r + 1) + 3*Dd*Pkdd2*k1**2*(5*K*(4*s**2 - 2*s + 1) + f*(8*s**2 - 4*s + 2) - 8*fd*s**2 + 2*fd*s - 20*s**2 + 10*s - 5) + 20*Ddd*Pk2*(K - 1)*(2*r**2 - 2*r + 1) - 3*Ddd*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) + 2*Dd**2*(Pk2*(10*K - 10)*(6*r**2 - 6*r + 1) + 9*Pkdd2*f*k1**2*s*(1 - 2*s))) - 21*b1**2*(104*C*D1**2*Pk2*fd*r**2 - 208*C*D1**2*Pk2*fd*r + 104*C*D1**2*Pk2*fd - 52*C*D1**2*Pk2*fdd*r**2 + 104*C*D1**2*Pk2*fdd*r - 52*C*D1**2*Pk2*fdd - 10*C*D1**2*Pkdd2*fd*k1**2*s**2 + 416*C*D1*Dd*Pk2*f*r**2 - 416*C*D1*Dd*Pk2*f*r + 208*C*D1*Dd*Pk2*f - 416*C*D1*Dd*Pk2*fd*r**2 + 624*C*D1*Dd*Pk2*fd*r - 208*C*D1*Dd*Pk2*fd - 40*C*D1*Dd*Pkdd2*f*k1**2*s**2 + 20*C*D1*Dd*Pkdd2*f*k1**2*s - 10*C*D1*Dd*Pkdd2*f*k1**2 - 208*C*D1*Ddd*Pk2*f*r**2 + 208*C*D1*Ddd*Pk2*f*r - 104*C*D1*Ddd*Pk2*f - 624*C*Dd**2*Pk2*f*r**2 + 624*C*Dd**2*Pk2*f*r - 104*C*Dd**2*Pk2*f - 10*D1**2*K*Pk2*fd*r**2 + 60*D1**2*K*Pk2*fd*r*s - 60*D1**2*K*Pk2*fd*r - 60*D1**2*K*Pk2*fdd*r*s + 60*D1**2*K*Pk2*fdd*r - 6*D1**2*K*Pkdd2*fd*k1**2*s**2 + 3*D1**2*K*Pkdd2*fdd*k1**2*s**2 + 40*D1**2*Pk2*f*fd*r**2 - 30*D1**2*Pk2*f*fd*r + 30*D1**2*Pk2*f*fd - 40*D1**2*Pk2*f*fdd*r**2 + 30*D1**2*Pk2*f*fdd*r - 30*D1**2*Pk2*f*fdd - 40*D1**2*Pk2*fd**2*r**2 + 30*D1**2*Pk2*fd**2*r + 10*D1**2*Pk2*fd**2 - 74*D1**2*Pk2*fd*r**2 + 238*D1**2*Pk2*fd*r - 104*D1**2*Pk2*fd + 32*D1**2*Pk2*fdd*r**2 - 134*D1**2*Pk2*fdd*r + 52*D1**2*Pk2*fdd - 40*D1**2*Pk2*gd2*r**2 + 80*D1**2*Pk2*gd2*r - 40*D1**2*Pk2*gd2 + 20*D1**2*Pk2*gdd2*r**2 - 40*D1**2*Pk2*gdd2*r + 20*D1**2*Pk2*gdd2 - 12*D1**2*Pkdd2*f*fd*k1**2*s**2 - 6*D1**2*Pkdd2*f*fd*k1**2*s + 3*D1**2*Pkdd2*f*fd*k1**2 + 30*D1**2*Pkdd2*gd2*k1**2*s**2 + D1**2*bdd1*(Pk2*(10 - 10*K)*(3*r**2 - 2*r + 1) + 3*Pkdd2*f*k1**2*(3*s**2 - 2*s + 1)) - 40*D1*Dd*K*Pk2*f*r**2 + 240*D1*Dd*K*Pk2*f*r*s - 20*D1*Dd*K*Pk2*f*r - 120*D1*Dd*K*Pk2*f*s - 20*D1*Dd*K*Pk2*f - 480*D1*Dd*K*Pk2*fd*r*s + 300*D1*Dd*K*Pk2*fd*r + 120*D1*Dd*K*Pk2*fd*s - 120*D1*Dd*K*Pk2*fd - 24*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 12*D1*Dd*K*Pkdd2*f*k1**2*s - 6*D1*Dd*K*Pkdd2*f*k1**2 + 24*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 6*D1*Dd*K*Pkdd2*fd*k1**2*s + 80*D1*Dd*Pk2*f**2*r**2 - 80*D1*Dd*Pk2*f**2*r + 40*D1*Dd*Pk2*f**2 - 320*D1*Dd*Pk2*f*fd*r**2 + 280*D1*Dd*Pk2*f*fd*r - 60*D1*Dd*Pk2*f*fd - 296*D1*Dd*Pk2*f*r**2 + 296*D1*Dd*Pk2*f*r - 148*D1*Dd*Pk2*f + 256*D1*Dd*Pk2*fd*r**2 - 664*D1*Dd*Pk2*fd*r + 268*D1*Dd*Pk2*fd - 160*D1*Dd*Pk2*g2*r**2 + 160*D1*Dd*Pk2*g2*r - 80*D1*Dd*Pk2*g2 + 160*D1*Dd*Pk2*gd2*r**2 - 240*D1*Dd*Pk2*gd2*r + 80*D1*Dd*Pk2*gd2 - 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 12*D1*Dd*Pkdd2*f**2*k1**2*s - 6*D1*Dd*Pkdd2*f**2*k1**2 + 120*D1*Dd*Pkdd2*g2*k1**2*s**2 - 60*D1*Dd*Pkdd2*g2*k1**2*s + 30*D1*Dd*Pkdd2*g2*k1**2 - 240*D1*Ddd*K*Pk2*f*r*s + 60*D1*Ddd*K*Pk2*f*r + 120*D1*Ddd*K*Pk2*f*s + 12*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 6*D1*Ddd*K*Pkdd2*f*k1**2*s + 3*D1*Ddd*K*Pkdd2*f*k1**2 - 80*D1*Ddd*Pk2*f**2*r**2 + 80*D1*Ddd*Pk2*f**2*r - 40*D1*Ddd*Pk2*f**2 + 128*D1*Ddd*Pk2*f*r**2 - 128*D1*Ddd*Pk2*f*r + 64*D1*Ddd*Pk2*f + 80*D1*Ddd*Pk2*g2*r**2 - 80*D1*Ddd*Pk2*g2*r + 40*D1*Ddd*Pk2*g2 + D1*bd1*(20*D1*Pk2*(K - 1)*(3*r**2 - 2*r + 1) - 3*D1*Pkdd2*k1**2*(5*K*(3*s**2 - 2*s + 1) + f*(6*s**2 - 4*s + 2) - 6*fd*s**2 + 2*fd*s - 15*s**2 + 10*s - 5) - 40*Dd*Pk2*(K - 1)*(6*r**2 - 5*r + 1) + 6*Dd*Pkdd2*f*k1**2*(12*s**2 - 7*s + 1)) - 720*Dd**2*K*Pk2*f*r*s + 180*Dd**2*K*Pk2*f*r + 360*Dd**2*K*Pk2*f*s - 120*Dd**2*K*Pk2*f + 36*Dd**2*K*Pkdd2*f*k1**2*s**2 - 18*Dd**2*K*Pkdd2*f*k1**2*s - 240*Dd**2*Pk2*f**2*r**2 + 240*Dd**2*Pk2*f**2*r - 40*Dd**2*Pk2*f**2 + 384*Dd**2*Pk2*f*r**2 - 384*Dd**2*Pk2*f*r + 64*Dd**2*Pk2*f + 240*Dd**2*Pk2*g2*r**2 - 240*Dd**2*Pk2*g2*r + 40*Dd**2*Pk2*g2) - 3*b1*(-168*C*D1**2*Pk2*f*fd*r**2 + 2288*C*D1**2*Pk2*f*fd*r*s - 976*C*D1**2*Pk2*f*fd*r - 1144*C*D1**2*Pk2*f*fd*s - 84*C*D1**2*Pk2*f*fd - 2096*C*D1**2*Pk2*f*fdd*r*s + 1048*C*D1**2*Pk2*f*fdd*r + 1048*C*D1**2*Pk2*f*fdd*s - 2096*C*D1**2*Pk2*fd**2*r*s + 1048*C*D1**2*Pk2*fd**2*r + 1048*C*D1**2*Pk2*fd**2*s - 1048*C*D1**2*Pk2*fd**2 - 120*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 60*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 60*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 336*C*D1*Dd*Pk2*f**2*r**2 + 4576*C*D1*Dd*Pk2*f**2*r*s - 808*C*D1*Dd*Pk2*f**2*r - 2288*C*D1*Dd*Pk2*f**2*s - 168*C*D1*Dd*Pk2*f**2 - 16768*C*D1*Dd*Pk2*f*fd*r*s + 6288*C*D1*Dd*Pk2*f*fd*r + 8384*C*D1*Dd*Pk2*f*fd*s - 3144*C*D1*Dd*Pk2*f*fd - 240*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 120*C*D1*Dd*Pkdd2*f**2*k1**2*s - 60*C*D1*Dd*Pkdd2*f**2*k1**2 + 480*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 120*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 4192*C*D1*Ddd*Pk2*f**2*r*s + 1048*C*D1*Ddd*Pk2*f**2*r + 2096*C*D1*Ddd*Pk2*f**2*s + 120*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 60*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 30*C*D1*Ddd*Pkdd2*f**2*k1**2 - 12576*C*Dd**2*Pk2*f**2*r*s + 3144*C*Dd**2*Pk2*f**2*r + 6288*C*Dd**2*Pk2*f**2*s - 2096*C*Dd**2*Pk2*f**2 + 360*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 180*C*Dd**2*Pkdd2*f**2*k1**2*s - 140*D1**2*K*Pk2*f*fd*r**2 - 840*D1**2*K*Pk2*f*fd*r*s + 420*D1**2*K*Pk2*f*fd*r - 840*D1**2*K*Pk2*f*fd*s**2 + 840*D1**2*K*Pk2*f*fd*s - 420*D1**2*K*Pk2*f*fd + 140*D1**2*K*Pk2*f*fdd*r**2 + 840*D1**2*K*Pk2*f*fdd*r*s - 420*D1**2*K*Pk2*f*fdd*r + 840*D1**2*K*Pk2*f*fdd*s**2 - 840*D1**2*K*Pk2*f*fdd*s + 420*D1**2*K*Pk2*f*fdd + 140*D1**2*K*Pk2*fd**2*r**2 + 840*D1**2*K*Pk2*fd**2*r*s - 420*D1**2*K*Pk2*fd**2*r + 840*D1**2*K*Pk2*fd**2*s**2 - 840*D1**2*K*Pk2*fd**2*s + 42*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 42*D1**2*K*Pkdd2*f*fd*k1**2*s + 21*D1**2*K*Pkdd2*f*fd*k1**2 + 816*D1**2*Pk2*f*fd*r**2 - 1144*D1**2*Pk2*f*fd*r*s + 42*D1**2*Pk2*f*fd*r + 572*D1**2*Pk2*f*fd*s + 408*D1**2*Pk2*f*fd - 408*D1**2*Pk2*f*fdd*r**2 + 1048*D1**2*Pk2*f*fdd*r*s - 378*D1**2*Pk2*f*fdd*r - 524*D1**2*Pk2*f*fdd*s - 204*D1**2*Pk2*f*fdd + 140*D1**2*Pk2*f*gd2*r**2 - 840*D1**2*Pk2*f*gd2*r*s - 280*D1**2*Pk2*f*gd2*r + 840*D1**2*Pk2*f*gd2*s + 140*D1**2*Pk2*f*gd2 + 840*D1**2*Pk2*f*gdd2*r*s - 840*D1**2*Pk2*f*gdd2*s - 408*D1**2*Pk2*fd**2*r**2 + 1048*D1**2*Pk2*fd**2*r*s - 378*D1**2*Pk2*fd**2*r - 524*D1**2*Pk2*fd**2*s + 786*D1**2*Pk2*fd**2 + 140*D1**2*Pk2*fd*g2*r**2 - 840*D1**2*Pk2*fd*g2*r*s + 840*D1**2*Pk2*fd*g2*r + 1680*D1**2*Pk2*fd*gd2*r*s - 840*D1**2*Pk2*fd*gd2*r - 840*D1**2*Pk2*fd*gd2*s + 840*D1**2*Pk2*fd*gd2 + 840*D1**2*Pk2*fdd*g2*r*s - 840*D1**2*Pk2*fdd*g2*r - 42*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 21*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 42*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 42*D1**2*Pkdd2*bd2*fd*k1**2*s**2 + 21*D1**2*Pkdd2*bdd2*f*k1**2*s**2 - 24*D1**2*Pkdd2*f*fd*k1**2*s**2 - 30*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 84*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 30*D1**2*Pkdd2*fd**2*k1**2*s**2 + 84*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 84*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 42*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 14*D1**2*bd1**2*(Pk2*r*(10*K - 10)*(3*r - 2) + 3*Pkdd2*f*k1**2*s*(2 - 3*s)) - 7*D1**2*bdd1*(-3*K*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + 10*Pk2*f**2*(4*r**2 - 5*r + 1) + 2*Pk2*f*(-30*K*s + r**2*(52*C - 32) + 5*r*(12*K*s - 7) + 10) - 40*Pk2*g2*r**2) - 280*D1*Dd*K*Pk2*f**2*r**2 - 1680*D1*Dd*K*Pk2*f**2*r*s + 700*D1*Dd*K*Pk2*f**2*r - 1680*D1*Dd*K*Pk2*f**2*s**2 + 1680*D1*Dd*K*Pk2*f**2*s - 560*D1*Dd*K*Pk2*f**2 + 1120*D1*Dd*K*Pk2*f*fd*r**2 + 6720*D1*Dd*K*Pk2*f*fd*r*s - 3080*D1*Dd*K*Pk2*f*fd*r + 6720*D1*Dd*K*Pk2*f*fd*s**2 - 6720*D1*Dd*K*Pk2*f*fd*s + 1680*D1*Dd*K*Pk2*f*fd + 84*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 42*D1*Dd*K*Pkdd2*f**2*k1**2*s + 21*D1*Dd*K*Pkdd2*f**2*k1**2 + 1632*D1*Dd*Pk2*f**2*r**2 - 2288*D1*Dd*Pk2*f**2*r*s - 1060*D1*Dd*Pk2*f**2*r + 1144*D1*Dd*Pk2*f**2*s + 816*D1*Dd*Pk2*f**2 - 3264*D1*Dd*Pk2*f*fd*r**2 + 8384*D1*Dd*Pk2*f*fd*r*s - 928*D1*Dd*Pk2*f*fd*r - 4192*D1*Dd*Pk2*f*fd*s + 1280*D1*Dd*Pk2*f*fd + 560*D1*Dd*Pk2*f*g2*r**2 - 3360*D1*Dd*Pk2*f*g2*r*s + 280*D1*Dd*Pk2*f*g2*r + 1680*D1*Dd*Pk2*f*g2*s + 280*D1*Dd*Pk2*f*g2 + 6720*D1*Dd*Pk2*f*gd2*r*s - 840*D1*Dd*Pk2*f*gd2*r - 5040*D1*Dd*Pk2*f*gd2*s + 840*D1*Dd*Pk2*f*gd2 + 6720*D1*Dd*Pk2*fd*g2*r*s - 4200*D1*Dd*Pk2*fd*g2*r - 1680*D1*Dd*Pk2*fd*g2*s + 1680*D1*Dd*Pk2*fd*g2 - 168*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 84*D1*Dd*Pkdd2*b2*f*k1**2*s - 42*D1*Dd*Pkdd2*b2*f*k1**2 + 168*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 42*D1*Dd*Pkdd2*b2*fd*k1**2*s + 168*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 42*D1*Dd*Pkdd2*bd2*f*k1**2*s - 48*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 24*D1*Dd*Pkdd2*f**2*k1**2*s - 12*D1*Dd*Pkdd2*f**2*k1**2 - 240*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 60*D1*Dd*Pkdd2*f*fd*k1**2*s + 336*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 168*D1*Dd*Pkdd2*f*g2*k1**2*s + 84*D1*Dd*Pkdd2*f*g2*k1**2 - 336*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 84*D1*Dd*Pkdd2*f*gd2*k1**2*s - 336*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 84*D1*Dd*Pkdd2*fd*g2*k1**2*s + 280*D1*Ddd*K*Pk2*f**2*r**2 + 1680*D1*Ddd*K*Pk2*f**2*r*s - 700*D1*Ddd*K*Pk2*f**2*r + 1680*D1*Ddd*K*Pk2*f**2*s**2 - 1680*D1*Ddd*K*Pk2*f**2*s + 560*D1*Ddd*K*Pk2*f**2 - 816*D1*Ddd*Pk2*f**2*r**2 + 2096*D1*Ddd*Pk2*f**2*r*s + 292*D1*Ddd*Pk2*f**2*r - 1048*D1*Ddd*Pk2*f**2*s - 408*D1*Ddd*Pk2*f**2 + 3360*D1*Ddd*Pk2*f*g2*r*s - 840*D1*Ddd*Pk2*f*g2*r - 1680*D1*Ddd*Pk2*f*g2*s + 84*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 42*D1*Ddd*Pkdd2*b2*f*k1**2*s + 21*D1*Ddd*Pkdd2*b2*f*k1**2 - 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 30*D1*Ddd*Pkdd2*f**2*k1**2*s - 15*D1*Ddd*Pkdd2*f**2*k1**2 - 168*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 84*D1*Ddd*Pkdd2*f*g2*k1**2*s - 42*D1*Ddd*Pkdd2*f*g2*k1**2 + 7*D1*bd1*(D1*(6*K*Pkdd2*fd*k1**2*s*(2*s - 1) + 2*Pk2*fd*(-30*K*(r*(4*s - 2) - s + 1) - r**2*(104*C - 64) + r*(104*C - 99) + 15) - 80*Pk2*g2*r**2 + 80*Pk2*gd2*r*(r - 1) + 30*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + f**2*(10*Pk2*(4*r**2 - 5*r + 1) - 3*Pkdd2*k1**2*(4*s**2 - 6*s + 3)) - 2*f*(Pk2*(-104*C*r**2 + 5*K*(2*r**2 - 2*r*(6*s + 1) + 6*s + 1) + 10*fd*(8*r**2 - 8*r + 1) + 74*r**2 + 45*r - 15) + Pkdd2*k1**2*(5*C + 3*K)*(2*s**2 - 2*s + 1))) + 2*Dd*(3*K*Pkdd2*f*k1**2*(8*s**2 - 6*s + 1) - 10*Pk2*f**2*(16*r**2 - 18*r + 5) - 2*Pk2*f*(2*r - 1)*(15*K*(8*s - 1) + r*(104*C - 64) - 35) + 80*Pk2*g2*r*(2*r - 1))) + 840*Dd**2*K*Pk2*f**2*r**2 + 5040*Dd**2*K*Pk2*f**2*r*s - 2100*Dd**2*K*Pk2*f**2*r + 5040*Dd**2*K*Pk2*f**2*s**2 - 5040*Dd**2*K*Pk2*f**2*s + 980*Dd**2*K*Pk2*f**2 - 2448*Dd**2*Pk2*f**2*r**2 + 6288*Dd**2*Pk2*f**2*r*s + 876*Dd**2*Pk2*f**2*r - 3144*Dd**2*Pk2*f**2*s + 640*Dd**2*Pk2*f**2 + 10080*Dd**2*Pk2*f*g2*r*s - 2520*Dd**2*Pk2*f*g2*r - 5040*Dd**2*Pk2*f*g2*s + 1680*Dd**2*Pk2*f*g2 + 252*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 126*Dd**2*Pkdd2*b2*f*k1**2*s - 180*Dd**2*Pkdd2*f**2*k1**2*s**2 + 90*Dd**2*Pkdd2*f**2*k1**2*s - 504*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 252*Dd**2*Pkdd2*f*g2*k1**2*s))/(630*d**2*k3**2) + D1**2*Pk3*ct**2*k2**4*st**2*(D1**2*(-3*Pkdd2*k1**2*s*(b1*s*(fd**2*(6 - 12*C) + 14*fd*(K*b1 - 2*g2 + 2*gd2) + 7*fdd*(-K*b1 + 2*g2)) + 14*bd1*fd*(K*b1*(1 - 2*s) + 2*g2*(s - 1))) + f**2*(Pk2*fdd*(8 - 16*C)*(3*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(bd1*(12*C*(s - 1)**2 - s**2*(7*K + 6) + 12*s - 6) - 3*bdd1*(2*C - 1)*(s - 1)**2 + 14*gd2*s**2) + fd*(2*C - 1)*(4*Pk2*(3*r**2 - 2*r + 1) + 9*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + f*(-96*C*Pk2*fd**2*r**2 + 64*C*Pk2*fd**2*r - 72*C*Pkdd2*b1*fd*k1**2*s**2 + 36*C*Pkdd2*b1*fdd*k1**2*s**2 + 42*K*Pkdd2*b1*fd*k1**2*s**2 - 42*K*Pkdd2*b1*fd*k1**2*s + 21*K*Pkdd2*b1*fd*k1**2 + 42*K*Pkdd2*bd1**2*k1**2*s*(s - 1) + 48*Pk2*fd**2*r**2 - 32*Pk2*fd**2*r + 36*Pkdd2*b1*fd*k1**2*s**2 - 18*Pkdd2*b1*fdd*k1**2*s**2 + 84*Pkdd2*b1*gd2*k1**2*s**2 - 42*Pkdd2*b1*gdd2*k1**2*s**2 + 6*Pkdd2*bd1*k1**2*(-7*K*b1*(2*s**2 - 2*s + 1) + 14*g2*(s - 1)**2 + s*(s - 1)*(12*C*fd - 6*fd - 14*gd2)) - 21*Pkdd2*bdd1*k1**2*(K*b1*(-2*s**2 + 2*s - 1) + 2*g2*(s - 1)**2) - 84*Pkdd2*fd*g2*k1**2*s**2 + 84*Pkdd2*fd*g2*k1**2*s - 42*Pkdd2*fd*g2*k1**2)) + D1*(Dd*(42*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(K*b1 - 2*g2) - 6*Pkdd2*f*k1**2*(7*K*b1**2*(4*s**2 - 2*s + 1) - b1*(14*g2*(4*s**2 - 2*s + 1) + (4*s - 1)*(7*K*bd1*(2*s - 1) + s*(12*C*fd - 6*fd - 14*gd2))) + 14*bd1*g2*(4*s**2 - 5*s + 1)) + f**3*(2*C - 1)*(8*Pk2*(2*r**2 - 2*r + 1) + 9*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(Pk2*fd*(32 - 64*C)*(6*r**2 - 5*r + 1) - 3*Pkdd2*k1**2*(b1*(12*C - 7*K - 6)*(4*s**2 - 2*s + 1) - 6*bd1*(2*C - 1)*(4*s**2 - 5*s + 1) + 14*g2*(4*s**2 - 2*s + 1)))) + Ddd*f*(Pk2*f**2*(16 - 32*C)*(2*r**2 - 2*r + 1) + 9*Pkdd2*b1*f*k1**2*(2*C - 1)*(4*s**2 - 2*s + 1) + 21*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*f**2*(8 - 16*C)*(6*r**2 - 6*r + 1) + 27*Pkdd2*b1*f*k1**2*s*(2*C - 1)*(2*s - 1) + 63*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2)))/(105*d**2*k1**2*k3**4) + D1**2*Pk3*ct**2*k2**4*(35*D1*K*Pkdd2*b1**2*k1**2*(D1*fd*s**2 + Dd*f*(4*s**2 - 2*s + 1)) + D1*f*(20*D1*Pk2*bdd1*f*r**2*(1 - 2*C) + D1*bd1*(Pk2*fd*r*(40 - 80*C)*(2*r - 1) - 70*Pkdd2*g2*k1**2*(s - 1)**2 + f*(2*C - 1)*(-16*Pk2*r**2 + 21*Pkdd2*k1**2*(s - 1)**2)) - 80*Dd*Pk2*bd1*f*r*(2*C - 1)*(2*r - 1)) - b1*(D1**2*(Pk2*fd**2*r*(80*C - 40)*(r - 1) + 70*Pkdd2*fd*g2*k1**2*s**2 + f*fd*(4*C - 2)*(8*Pk2*(2*r**2 - 2*r + 1) - 21*Pkdd2*k1**2*s**2) + 5*f*(Pk2*fdd*(8*C - 4)*(2*r**2 - 2*r + 1) - 7*Pkdd2*k1**2*(K*bd1*(2*s**2 - 2*s + 1) - 2*gd2*s**2))) + D1*f*(Dd*(Pk2*fd*(1 - 2*r)**2*(160*C - 80) + 70*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + f*(2*C - 1)*(32*Pk2*(2*r**2 - 2*r + 1) - 21*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(80*C - 40)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f**2*(80*C - 40)*(6*r**2 - 6*r + 1)))/(210*d**2*k1**2*k3**4) - D1**2*Pk3*ct**2*k2**2*st**2*(D1**2*(3*Pkdd2*k1**2*(-7*K*b1**2*(2*fd - fdd)*(2*s - 1) + b1*(fd**2*s*(12*C - 6) + 14*fd*(g2*(4*s - 2) + s*(K*bd1 - b2*s + bd2*s - 2*gd2)) + 7*fdd*(b2*s**2 + g2*(2 - 4*s))) + 14*b2*bd1*fd*s*(s - 1)) + f**2*(Pk2*fdd*(8 - 16*C)*(3*r**2 - 2*r + 1) + 3*Pkdd2*k1**2*(bd1*(12*C*(2*s - 1) + 7*K*s**2 - 12*s + 6) - 3*bdd1*(2*C - 1)*(2*s - 1) + s**2*(7*bd2 - 14*gd2)) + fd*(2*C - 1)*(4*Pk2*(3*r**2 - 2*r + 1) + 9*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + f*(-42*K*Pkdd2*bd1**2*k1**2*s - 3*Pkdd2*b1*k1**2*(-14*K*bd1*(2*s - 1) - 7*bdd1*(-2*K*s + K) + fd*(12*C*(2*s - 1) - 7*K*(2*s**2 - 2*s + 1) - 12*s + 6) + fdd*(3 - 6*C)*(2*s - 1) - 7*s**2*(-2*bd2 + bdd2)) + 21*Pkdd2*b2*k1**2*(-2*bd1*(s - 1)**2 + bdd1*(s - 1)**2 + fd*(2*s**2 - 2*s + 1)) - 6*Pkdd2*bd1*k1**2*(14*g2*(2*s - 1) + s*(6*C*fd - 7*bd2*s + 7*bd2 - 3*fd - 14*gd2)) - 42*Pkdd2*bdd1*g2*k1**2*(1 - 2*s) - 2*fd*(Pk2*fd*r*(16*C - 8)*(3*r - 2) + 21*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1)))) + D1*(Dd*(42*Pkdd2*b1*fd*k1**2*(4*s - 1)*(K*b1 + b2*s - 2*g2) - 6*Pkdd2*f*k1**2*(b1*(7*b2*(4*s**2 - 2*s + 1) - (4*s - 1)*(6*C*fd - 7*K*bd1 + 7*bd2*s - 3*fd)) - 7*bd1*(4*s - 1)*(b2*(s - 1) + 2*g2)) + f**3*(2*C - 1)*(8*Pk2*(2*r**2 - 2*r + 1) + 9*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(Pk2*fd*(32 - 64*C)*(6*r**2 - 5*r + 1) + 3*Pkdd2*k1**2*(7*b2*(4*s**2 - 2*s + 1) - 6*bd1*(2*C - 1)*(4*s - 1) - (-7*K*b1 + 14*g2)*(4*s**2 - 2*s + 1)))) + Ddd*f*(Pk2*f**2*(16 - 32*C)*(2*r**2 - 2*r + 1) + 21*Pkdd2*b1*b2*k1**2*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*f**2*(8 - 16*C)*(6*r**2 - 6*r + 1) + 63*Pkdd2*b1*b2*k1**2*s*(2*s - 1)))/(105*d**2*k1**2*k3**2) + D1**2*Pk3*ct**2*(D1*(20*D1*Pk2*bdd1*f**2*r**2*(2*C - 1) - 14*D1*Pkdd2*bd1**2*k1**2*s*(s - 1)*(5*b2 + f*(6*C - 3) - 10*g2) + bd1*f*(D1*(Pk2*fd*r*(80*C - 40)*(2*r - 1) - Pkdd2*k1**2*s**2*(35*b2 - 70*g2) + f*(2*C - 1)*(16*Pk2*r**2 - 21*Pkdd2*k1**2*s**2)) + Dd*Pk2*f*r*(160*C - 80)*(2*r - 1))) + 35*K*Pkdd2*b1**3*k1**2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 7*Pkdd2*b1**2*k1**2*(D1**2*(12*C*fd*s**2 - 6*C*fdd*s**2 + 10*K*bd1*(3*s**2 - 2*s + 1) - 5*K*bdd1*(3*s**2 - 2*s + 1) - 5*K*fd*s**2 + 10*K*fd*s - 5*K*fd + 10*bd2*s**2 - 5*bdd2*s**2 - 6*fd*s**2 + 3*fdd*s**2 - 20*gd2*s**2 + 10*gdd2*s**2) + D1*(Dd*(f*(12*C - 5*K - 6)*(4*s**2 - 2*s + 1) - 20*g2*(4*s**2 - 2*s + 1) - (8*s - 2)*(5*K*bd1*(3*s - 1) + s*(6*C*fd + 5*bd2 - 3*fd - 10*gd2))) - Ddd*(f*(6*C - 3) - 10*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*s*(2*s - 1)*(f*(6*C - 3) - 10*g2) + 5*b2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s))) + b1*(D1**2*(-70*K*Pkdd2*bd1**2*k1**2*s*(3*s - 2) - 35*Pkdd2*b2*k1**2*(bd1*(-4*s**2 + 4*s - 2) + bdd1*(2*s**2 - 2*s + 1) + fd*(s - 1)**2) - 14*Pkdd2*bd1*k1**2*(10*g2*(2*s**2 - 2*s + 1) + s*(2*s - 1)*(6*C*fd + 5*bd2 - 3*fd - 10*gd2)) + 70*Pkdd2*bdd1*g2*k1**2*(2*s**2 - 2*s + 1) + f*(Pk2*fdd*(40*C - 20)*(2*r**2 - 2*r + 1) + 7*Pkdd2*k1**2*(2*bd1*(6*C*(2*s**2 - 2*s + 1) - s**2*(5*K + 6) + 6*s - 3) - 3*bdd1*(2*C - 1)*(2*s**2 - 2*s + 1) + s**2*(-5*bd2 + 10*gd2)) + fd*(2*C - 1)*(16*Pk2*(2*r**2 - 2*r + 1) - 21*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 10*fd*(Pk2*fd*r*(8*C - 4)*(r - 1) + 7*Pkdd2*g2*k1**2*(s - 1)**2)) + D1*(Dd*(-70*Pkdd2*bd1*k1**2*(b2 - 2*g2)*(8*s**2 - 6*s + 1) + f**2*(2*C - 1)*(32*Pk2*(2*r**2 - 2*r + 1) - 21*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(Pk2*fd*(1 - 2*r)**2*(160*C - 80) - 7*Pkdd2*k1**2*(5*b2*(4*s**2 - 2*s + 1) + 6*bd1*(2*C - 1)*(8*s**2 - 6*s + 1) - 10*g2*(4*s**2 - 2*s + 1)))) + Ddd*Pk2*f**2*(80*C - 40)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f**2*(80*C - 40)*(6*r**2 - 6*r + 1)))/(210*d**2*k1**2) + D1**2*Pk3*ct*k1**3*st**4*(2112*C*D1**2*Pk2*f**2*fd*r*s - 704*C*D1**2*Pk2*f**2*fd*r + 2112*C*D1**2*Pk2*f**2*fd*s**2 - 2112*C*D1**2*Pk2*f**2*fd*s + 704*C*D1**2*Pk2*f**2*fd - 1056*C*D1**2*Pk2*f**2*fdd*r*s + 352*C*D1**2*Pk2*f**2*fdd*r - 1056*C*D1**2*Pk2*f**2*fdd*s**2 + 1056*C*D1**2*Pk2*f**2*fdd*s - 352*C*D1**2*Pk2*f**2*fdd - 2112*C*D1**2*Pk2*f*fd**2*r*s + 704*C*D1**2*Pk2*f*fd**2*r - 2112*C*D1**2*Pk2*f*fd**2*s**2 + 2112*C*D1**2*Pk2*f*fd**2*s - 352*C*D1**2*Pk2*f*fd**2 + 2816*C*D1*Dd*Pk2*f**3*r*s - 704*C*D1*Dd*Pk2*f**3*r + 2816*C*D1*Dd*Pk2*f**3*s**2 - 2816*C*D1*Dd*Pk2*f**3*s + 704*C*D1*Dd*Pk2*f**3 - 8448*C*D1*Dd*Pk2*f**2*fd*r*s + 2464*C*D1*Dd*Pk2*f**2*fd*r - 8448*C*D1*Dd*Pk2*f**2*fd*s**2 + 8448*C*D1*Dd*Pk2*f**2*fd*s - 1760*C*D1*Dd*Pk2*f**2*fd - 1408*C*D1*Ddd*Pk2*f**3*r*s + 352*C*D1*Ddd*Pk2*f**3*r - 1408*C*D1*Ddd*Pk2*f**3*s**2 + 1408*C*D1*Ddd*Pk2*f**3*s - 352*C*D1*Ddd*Pk2*f**3 - 4224*C*Dd**2*Pk2*f**3*r*s + 1056*C*Dd**2*Pk2*f**3*r - 4224*C*Dd**2*Pk2*f**3*s**2 + 4224*C*Dd**2*Pk2*f**3*s - 704*C*Dd**2*Pk2*f**3 - 528*D1**2*K*Pk2*bdd1*f**2*r*s - 528*D1**2*K*Pk2*bdd1*f**2*s**2 + 528*D1**2*K*Pk2*bdd1*f**2*s + 4400*D1**2*Pk2*bdd1*f**3*r*s + 4400*D1**2*Pk2*bdd1*f**3*s**2 - 5280*D1**2*Pk2*bdd1*f**3*s + 1320*D1**2*Pk2*bdd1*f**3 + 2112*D1**2*Pk2*bdd1*f**2*r*s + 2376*D1**2*Pk2*bdd1*f**2*s**2 - 2112*D1**2*Pk2*bdd1*f**2*s + 21120*D1**2*Pk2*f**3*fd*r*s - 5280*D1**2*Pk2*f**3*fd*r + 39600*D1**2*Pk2*f**3*fd*s**2 - 30360*D1**2*Pk2*f**3*fd*s + 9900*D1**2*Pk2*f**3*fd - 21120*D1**2*Pk2*f**3*fdd*r*s + 5280*D1**2*Pk2*f**3*fdd*r - 29040*D1**2*Pk2*f**3*fdd*s**2 + 25080*D1**2*Pk2*f**3*fdd*s - 7260*D1**2*Pk2*f**3*fdd - 63360*D1**2*Pk2*f**2*fd**2*r*s + 15840*D1**2*Pk2*f**2*fd**2*r - 87120*D1**2*Pk2*f**2*fd**2*s**2 + 75240*D1**2*Pk2*f**2*fd**2*s - 10560*D1**2*Pk2*f**2*fd**2 - 5280*D1**2*Pk2*f**2*fd*r*s + 1760*D1**2*Pk2*f**2*fd*r - 5808*D1**2*Pk2*f**2*fd*s**2 + 5632*D1**2*Pk2*f**2*fd*s - 1936*D1**2*Pk2*f**2*fd + 2640*D1**2*Pk2*f**2*fdd*r*s - 880*D1**2*Pk2*f**2*fdd*r + 2904*D1**2*Pk2*f**2*fdd*s**2 - 2816*D1**2*Pk2*f**2*fdd*s + 968*D1**2*Pk2*f**2*fdd - 2112*D1**2*Pk2*f**2*gd2*r*s - 2112*D1**2*Pk2*f**2*gd2*s**2 + 2112*D1**2*Pk2*f**2*gd2*s + 1056*D1**2*Pk2*f**2*gdd2*r*s + 1056*D1**2*Pk2*f**2*gdd2*s**2 - 1056*D1**2*Pk2*f**2*gdd2*s + 5280*D1**2*Pk2*f*fd**2*r*s - 1760*D1**2*Pk2*f*fd**2*r + 5808*D1**2*Pk2*f*fd**2*s**2 - 5632*D1**2*Pk2*f*fd**2*s + 880*D1**2*Pk2*f*fd**2 - 4224*D1**2*Pk2*f*fd*g2*r*s + 2112*D1**2*Pk2*f*fd*g2*r - 4224*D1**2*Pk2*f*fd*g2*s**2 + 4224*D1**2*Pk2*f*fd*g2*s - 2112*D1**2*Pk2*f*fd*g2 + 4224*D1**2*Pk2*f*fd*gd2*r*s - 1056*D1**2*Pk2*f*fd*gd2*r + 4224*D1**2*Pk2*f*fd*gd2*s**2 - 4224*D1**2*Pk2*f*fd*gd2*s + 1056*D1**2*Pk2*f*fd*gd2 + 2112*D1**2*Pk2*f*fdd*g2*r*s - 1056*D1**2*Pk2*f*fdd*g2*r + 2112*D1**2*Pk2*f*fdd*g2*s**2 - 2112*D1**2*Pk2*f*fdd*g2*s + 1056*D1**2*Pk2*f*fdd*g2 + 2112*D1**2*Pk2*fd**2*g2*r*s - 1056*D1**2*Pk2*fd**2*g2*r + 2112*D1**2*Pk2*fd**2*g2*s**2 - 2112*D1**2*Pk2*fd**2*g2*s - 200*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 100*D1**2*Pkdd2*f**3*fd*k1**2*s - 50*D1**2*Pkdd2*f**3*fd*k1**2 + 100*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 50*D1**2*Pkdd2*f**3*fdd*k1**2*s + 25*D1**2*Pkdd2*f**3*fdd*k1**2 + 300*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 150*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 21120*D1*Dd*Pk2*f**4*r*s - 5280*D1*Dd*Pk2*f**4*r + 39600*D1*Dd*Pk2*f**4*s**2 - 30360*D1*Dd*Pk2*f**4*s + 9900*D1*Dd*Pk2*f**4 - 168960*D1*Dd*Pk2*f**3*fd*r*s + 42240*D1*Dd*Pk2*f**3*fd*r - 232320*D1*Dd*Pk2*f**3*fd*s**2 + 200640*D1*Dd*Pk2*f**3*fd*s - 35640*D1*Dd*Pk2*f**3*fd - 7040*D1*Dd*Pk2*f**3*r*s + 1760*D1*Dd*Pk2*f**3*r - 7744*D1*Dd*Pk2*f**3*s**2 + 7392*D1*Dd*Pk2*f**3*s - 1936*D1*Dd*Pk2*f**3 + 21120*D1*Dd*Pk2*f**2*fd*r*s - 6160*D1*Dd*Pk2*f**2*fd*r + 23232*D1*Dd*Pk2*f**2*fd*s**2 - 22352*D1*Dd*Pk2*f**2*fd*s + 4576*D1*Dd*Pk2*f**2*fd - 8448*D1*Dd*Pk2*f**2*g2*r*s + 2112*D1*Dd*Pk2*f**2*g2*r - 8448*D1*Dd*Pk2*f**2*g2*s**2 + 8448*D1*Dd*Pk2*f**2*g2*s - 2112*D1*Dd*Pk2*f**2*g2 + 8448*D1*Dd*Pk2*f**2*gd2*r*s - 1056*D1*Dd*Pk2*f**2*gd2*r + 8448*D1*Dd*Pk2*f**2*gd2*s**2 - 8448*D1*Dd*Pk2*f**2*gd2*s + 1056*D1*Dd*Pk2*f**2*gd2 + 16896*D1*Dd*Pk2*f*fd*g2*r*s - 6336*D1*Dd*Pk2*f*fd*g2*r + 16896*D1*Dd*Pk2*f*fd*g2*s**2 - 16896*D1*Dd*Pk2*f*fd*g2*s + 4224*D1*Dd*Pk2*f*fd*g2 - 200*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 100*D1*Dd*Pkdd2*f**4*k1**2*s - 50*D1*Dd*Pkdd2*f**4*k1**2 + 800*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 400*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 50*D1*Dd*Pkdd2*f**3*fd*k1**2 - 21120*D1*Ddd*Pk2*f**4*r*s + 5280*D1*Ddd*Pk2*f**4*r - 29040*D1*Ddd*Pk2*f**4*s**2 + 25080*D1*Ddd*Pk2*f**4*s - 7260*D1*Ddd*Pk2*f**4 + 3520*D1*Ddd*Pk2*f**3*r*s - 880*D1*Ddd*Pk2*f**3*r + 3872*D1*Ddd*Pk2*f**3*s**2 - 3696*D1*Ddd*Pk2*f**3*s + 968*D1*Ddd*Pk2*f**3 + 4224*D1*Ddd*Pk2*f**2*g2*r*s - 1056*D1*Ddd*Pk2*f**2*g2*r + 4224*D1*Ddd*Pk2*f**2*g2*s**2 - 4224*D1*Ddd*Pk2*f**2*g2*s + 1056*D1*Ddd*Pk2*f**2*g2 + 100*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 50*D1*Ddd*Pkdd2*f**4*k1**2*s + 25*D1*Ddd*Pkdd2*f**4*k1**2 - 176*D1*Pk2*bd1*f*(D1*(f**2*(41*s**2 + s*(41*r - 54) + 15) + f*(-5*fd*(5*r*(6*s - 1) + 30*s**2 - 32*s + 3) + 3*s*(-2*K*(r + s - 1) + 8*r + 9*s - 8)) + 3*fd*(K*(r*(4*s - 1) + (1 - 2*s)**2) - 16*r*s + 4*r - 18*s**2 + 17*s - 4)) + Dd*f*(3*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 5*f*(5*r*(8*s - 1) + 40*s**2 - 44*s + 6) - 96*r*s + 12*r - 108*s**2 + 99*s - 12)) - 63360*Dd**2*Pk2*f**4*r*s + 15840*Dd**2*Pk2*f**4*r - 87120*Dd**2*Pk2*f**4*s**2 + 75240*Dd**2*Pk2*f**4*s - 10560*Dd**2*Pk2*f**4 + 10560*Dd**2*Pk2*f**3*r*s - 2640*Dd**2*Pk2*f**3*r + 11616*Dd**2*Pk2*f**3*s**2 - 11088*Dd**2*Pk2*f**3*s + 1760*Dd**2*Pk2*f**3 + 12672*Dd**2*Pk2*f**2*g2*r*s - 3168*Dd**2*Pk2*f**2*g2*r + 12672*Dd**2*Pk2*f**2*g2*s**2 - 12672*Dd**2*Pk2*f**2*g2*s + 2112*Dd**2*Pk2*f**2*g2 + 300*Dd**2*Pkdd2*f**4*k1**2*s**2 - 150*Dd**2*Pkdd2*f**4*k1**2*s - 88*Pk2*b1*(D1**2*(f**2*(fd*(82*r*(3*s - 1) + 246*s**2 - 220*s + 52) - 5*fdd*(10*r*(3*s - 1) + 30*s**2 - 28*s + 7)) + f*(-10*fd**2*(10*r*(3*s - 1) + 30*s**2 - 28*s + 7) - 6*fd*(K*(4*r*s - 2*r + 4*s**2 - 4*s + 2) - 16*r*s + 8*r - 18*s**2 + 18*s - 9) + 3*fdd*(K*(4*r*s - 2*r + 4*s**2 - 4*s + 2) - 16*r*s + 8*r - 18*s**2 + 18*s - 9)) + 6*fd**2*(r*(K - 4)*(2*s - 1) + s*(2*K - 9)*(s - 1))) + D1*f*(2*Dd*(41*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-3*K*r*(8*s - 2) - 6*K*(1 - 2*s)**2 - 5*fd*(5*r*(24*s - 7) + 120*s**2 - 116*s + 24) - 3*r*(8 - 32*s) + 108*s**2 - 102*s + 27) + 3*fd*(2*K*r*(8*s - 3) + 4*K*(1 - 2*s)**2 - 8*r*(8*s - 3) - 72*s**2 + 70*s - 17)) + Ddd*f*(3*K*r*(8*s - 2) + 6*K*(1 - 2*s)**2 - 50*f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*r*(8 - 32*s) - 108*s**2 + 102*s - 27)) - 2*Dd**2*f**2*(-3*K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 25*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 144*r*s - 36*r + 162*s**2 - 153*s + 24)))/(2310*d**2*k2*k3**4) - D1**2*Pk3*ct*k1**3*st**2*(288*C*D1**2*Pk2*bdd1*f**2*r*s - 144*C*D1**2*Pk2*bdd1*f**2*r + 432*C*D1**2*Pk2*bdd1*f**2*s**2 - 576*C*D1**2*Pk2*bdd1*f**2*s + 288*C*D1**2*Pk2*bdd1*f**2 + 1392*C*D1**2*Pk2*f**2*fd*r*s - 464*C*D1**2*Pk2*f**2*fd*r - 2160*C*D1**2*Pk2*f**2*fd*s**2 + 976*C*D1**2*Pk2*f**2*fd*s - 720*C*D1**2*Pk2*f**2*fd - 912*C*D1**2*Pk2*f**2*fdd*r*s + 304*C*D1**2*Pk2*f**2*fdd*r + 864*C*D1**2*Pk2*f**2*fdd*s**2 - 272*C*D1**2*Pk2*f**2*fdd*s + 288*C*D1**2*Pk2*f**2*fdd - 1824*C*D1**2*Pk2*f*fd**2*r*s + 608*C*D1**2*Pk2*f*fd**2*r + 1728*C*D1**2*Pk2*f*fd**2*s**2 - 544*C*D1**2*Pk2*f*fd**2*s - 304*C*D1**2*Pk2*f*fd**2 + 1856*C*D1*Dd*Pk2*f**3*r*s - 464*C*D1*Dd*Pk2*f**3*r - 2880*C*D1*Dd*Pk2*f**3*s**2 + 512*C*D1*Dd*Pk2*f**3*s - 720*C*D1*Dd*Pk2*f**3 - 7296*C*D1*Dd*Pk2*f**2*fd*r*s + 2128*C*D1*Dd*Pk2*f**2*fd*r + 6912*C*D1*Dd*Pk2*f**2*fd*s**2 - 992*C*D1*Dd*Pk2*f**2*fd*s - 336*C*D1*Dd*Pk2*f**2*fd - 1216*C*D1*Ddd*Pk2*f**3*r*s + 304*C*D1*Ddd*Pk2*f**3*r + 1152*C*D1*Ddd*Pk2*f**3*s**2 + 32*C*D1*Ddd*Pk2*f**3*s + 288*C*D1*Ddd*Pk2*f**3 - 3648*C*Dd**2*Pk2*f**3*r*s + 912*C*Dd**2*Pk2*f**3*r + 3456*C*Dd**2*Pk2*f**3*s**2 + 96*C*Dd**2*Pk2*f**3*s - 608*C*Dd**2*Pk2*f**3 - 312*D1**2*K*Pk2*bdd1*f**2*r*s + 240*D1**2*K*Pk2*bdd1*f**2*s**2 + 312*D1**2*K*Pk2*bdd1*f**2*s - 528*D1**2*Pk2*b2*f*fd*r*s + 264*D1**2*Pk2*b2*f*fd*r - 528*D1**2*Pk2*b2*f*fd*s**2 + 528*D1**2*Pk2*b2*f*fd*s - 264*D1**2*Pk2*b2*f*fd + 432*D1**2*Pk2*b2*f*fdd*r*s - 216*D1**2*Pk2*b2*f*fdd*r + 432*D1**2*Pk2*b2*f*fdd*s**2 - 432*D1**2*Pk2*b2*f*fdd*s + 216*D1**2*Pk2*b2*f*fdd + 432*D1**2*Pk2*b2*fd**2*r*s - 216*D1**2*Pk2*b2*fd**2*r + 432*D1**2*Pk2*b2*fd**2*s**2 - 432*D1**2*Pk2*b2*fd**2*s - 24*D1**2*Pk2*bd1**2*f*(-7*K*(4*r*s - r + 6*s**2 - 6*s + 1) + 9*f*(r*(8*s - 5) + 8*s**2 - 12*s + 3) + 70*r*s - 28*r + 84*s**2 - 105*s + 28) - 264*D1**2*Pk2*bd2*f**2*r*s - 264*D1**2*Pk2*bd2*f**2*s**2 + 264*D1**2*Pk2*bd2*f**2*s + 864*D1**2*Pk2*bd2*f*fd*r*s - 216*D1**2*Pk2*bd2*f*fd*r + 864*D1**2*Pk2*bd2*f*fd*s**2 - 864*D1**2*Pk2*bd2*f*fd*s + 216*D1**2*Pk2*bd2*f*fd + 756*D1**2*Pk2*bdd1*f**3*r**2 + 3672*D1**2*Pk2*bdd1*f**3*r*s - 2052*D1**2*Pk2*bdd1*f**3*r + 2052*D1**2*Pk2*bdd1*f**3*s**2 - 3456*D1**2*Pk2*bdd1*f**3*s + 1512*D1**2*Pk2*bdd1*f**3 + 318*D1**2*Pk2*bdd1*f**2*r**2 + 1380*D1**2*Pk2*bdd1*f**2*r*s - 276*D1**2*Pk2*bdd1*f**2*r + 684*D1**2*Pk2*bdd1*f**2*s**2 - 876*D1**2*Pk2*bdd1*f**2*s - 186*D1**2*Pk2*bdd1*f**2 - 672*D1**2*Pk2*bdd1*f*g2*r*s + 336*D1**2*Pk2*bdd1*f*g2*r - 1008*D1**2*Pk2*bdd1*f*g2*s**2 + 1344*D1**2*Pk2*bdd1*f*g2*s - 672*D1**2*Pk2*bdd1*f*g2 + 216*D1**2*Pk2*bdd2*f**2*r*s + 216*D1**2*Pk2*bdd2*f**2*s**2 - 216*D1**2*Pk2*bdd2*f**2*s + 2160*D1**2*Pk2*f**3*fd*r**2 + 10368*D1**2*Pk2*f**3*fd*r*s - 4752*D1**2*Pk2*f**3*fd*r + 6480*D1**2*Pk2*f**3*fd*s**2 - 8424*D1**2*Pk2*f**3*fd*s + 2700*D1**2*Pk2*f**3*fd - 2160*D1**2*Pk2*f**3*fdd*r**2 - 10368*D1**2*Pk2*f**3*fdd*r*s + 4752*D1**2*Pk2*f**3*fdd*r - 6480*D1**2*Pk2*f**3*fdd*s**2 + 8424*D1**2*Pk2*f**3*fdd*s - 2700*D1**2*Pk2*f**3*fdd - 6480*D1**2*Pk2*f**2*fd**2*r**2 - 31104*D1**2*Pk2*f**2*fd**2*r*s + 14256*D1**2*Pk2*f**2*fd**2*r - 19440*D1**2*Pk2*f**2*fd**2*s**2 + 25272*D1**2*Pk2*f**2*fd**2*s - 6264*D1**2*Pk2*f**2*fd**2 - 606*D1**2*Pk2*f**2*fd*r**2 - 4068*D1**2*Pk2*f**2*fd*r*s + 1760*D1**2*Pk2*f**2*fd*r - 540*D1**2*Pk2*f**2*fd*s**2 + 1716*D1**2*Pk2*f**2*fd*s - 382*D1**2*Pk2*f**2*fd + 546*D1**2*Pk2*f**2*fdd*r**2 + 3276*D1**2*Pk2*f**2*fdd*r*s - 1456*D1**2*Pk2*f**2*fdd*r + 1404*D1**2*Pk2*f**2*fdd*s**2 - 2028*D1**2*Pk2*f**2*fdd*s + 650*D1**2*Pk2*f**2*fdd - 912*D1**2*Pk2*f**2*gd2*r*s + 1296*D1**2*Pk2*f**2*gd2*s**2 + 912*D1**2*Pk2*f**2*gd2*s + 624*D1**2*Pk2*f**2*gdd2*r*s - 480*D1**2*Pk2*f**2*gdd2*s**2 - 624*D1**2*Pk2*f**2*gdd2*s + 1092*D1**2*Pk2*f*fd**2*r**2 + 6552*D1**2*Pk2*f*fd**2*r*s - 2912*D1**2*Pk2*f*fd**2*r + 2808*D1**2*Pk2*f*fd**2*s**2 - 4056*D1**2*Pk2*f*fd**2*s + 1092*D1**2*Pk2*f*fd**2 - 1824*D1**2*Pk2*f*fd*g2*r*s + 912*D1**2*Pk2*f*fd*g2*r + 2592*D1**2*Pk2*f*fd*g2*s**2 - 2592*D1**2*Pk2*f*fd*g2*s + 1296*D1**2*Pk2*f*fd*g2 + 2496*D1**2*Pk2*f*fd*gd2*r*s - 624*D1**2*Pk2*f*fd*gd2*r - 1920*D1**2*Pk2*f*fd*gd2*s**2 - 288*D1**2*Pk2*f*fd*gd2*s + 624*D1**2*Pk2*f*fd*gd2 + 1248*D1**2*Pk2*f*fdd*g2*r*s - 624*D1**2*Pk2*f*fdd*g2*r - 960*D1**2*Pk2*f*fdd*g2*s**2 + 960*D1**2*Pk2*f*fdd*g2*s - 480*D1**2*Pk2*f*fdd*g2 + 1248*D1**2*Pk2*fd**2*g2*r*s - 624*D1**2*Pk2*fd**2*g2*r - 960*D1**2*Pk2*fd**2*g2*s**2 + 960*D1**2*Pk2*fd**2*g2*s - 15*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 30*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 15*D1**2*Pkdd2*bdd1*f**3*k1**2 - 60*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 30*D1**2*Pkdd2*f**3*fd*k1**2*s - 15*D1**2*Pkdd2*f**3*fd*k1**2 - 1056*D1*Dd*Pk2*b2*f**2*r*s + 264*D1*Dd*Pk2*b2*f**2*r - 1056*D1*Dd*Pk2*b2*f**2*s**2 + 1056*D1*Dd*Pk2*b2*f**2*s - 264*D1*Dd*Pk2*b2*f**2 + 3456*D1*Dd*Pk2*b2*f*fd*r*s - 1296*D1*Dd*Pk2*b2*f*fd*r + 3456*D1*Dd*Pk2*b2*f*fd*s**2 - 3456*D1*Dd*Pk2*b2*f*fd*s + 864*D1*Dd*Pk2*b2*f*fd + 1728*D1*Dd*Pk2*bd2*f**2*r*s - 216*D1*Dd*Pk2*bd2*f**2*r + 1728*D1*Dd*Pk2*bd2*f**2*s**2 - 1728*D1*Dd*Pk2*bd2*f**2*s + 216*D1*Dd*Pk2*bd2*f**2 + 2160*D1*Dd*Pk2*f**4*r**2 + 10368*D1*Dd*Pk2*f**4*r*s - 4752*D1*Dd*Pk2*f**4*r + 6480*D1*Dd*Pk2*f**4*s**2 - 8424*D1*Dd*Pk2*f**4*s + 2700*D1*Dd*Pk2*f**4 - 17280*D1*Dd*Pk2*f**3*fd*r**2 - 82944*D1*Dd*Pk2*f**3*fd*r*s + 38016*D1*Dd*Pk2*f**3*fd*r - 51840*D1*Dd*Pk2*f**3*fd*s**2 + 67392*D1*Dd*Pk2*f**3*fd*s - 17928*D1*Dd*Pk2*f**3*fd - 808*D1*Dd*Pk2*f**3*r**2 - 5424*D1*Dd*Pk2*f**3*r*s + 2164*D1*Dd*Pk2*f**3*r - 720*D1*Dd*Pk2*f**3*s**2 + 3072*D1*Dd*Pk2*f**3*s - 584*D1*Dd*Pk2*f**3 + 4368*D1*Dd*Pk2*f**2*fd*r**2 + 26208*D1*Dd*Pk2*f**2*fd*r*s - 11284*D1*Dd*Pk2*f**2*fd*r + 11232*D1*Dd*Pk2*f**2*fd*s**2 - 17472*D1*Dd*Pk2*f**2*fd*s + 4940*D1*Dd*Pk2*f**2*fd - 3648*D1*Dd*Pk2*f**2*g2*r*s + 912*D1*Dd*Pk2*f**2*g2*r + 5184*D1*Dd*Pk2*f**2*g2*s**2 - 768*D1*Dd*Pk2*f**2*g2*s + 1296*D1*Dd*Pk2*f**2*g2 + 4992*D1*Dd*Pk2*f**2*gd2*r*s - 624*D1*Dd*Pk2*f**2*gd2*r - 3840*D1*Dd*Pk2*f**2*gd2*s**2 - 2784*D1*Dd*Pk2*f**2*gd2*s + 624*D1*Dd*Pk2*f**2*gd2 + 9984*D1*Dd*Pk2*f*fd*g2*r*s - 3744*D1*Dd*Pk2*f*fd*g2*r - 7680*D1*Dd*Pk2*f*fd*g2*s**2 + 3264*D1*Dd*Pk2*f*fd*g2*s + 288*D1*Dd*Pk2*f*fd*g2 - 60*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 30*D1*Dd*Pkdd2*f**4*k1**2*s - 15*D1*Dd*Pkdd2*f**4*k1**2 + 864*D1*Ddd*Pk2*b2*f**2*r*s - 216*D1*Ddd*Pk2*b2*f**2*r + 864*D1*Ddd*Pk2*b2*f**2*s**2 - 864*D1*Ddd*Pk2*b2*f**2*s + 216*D1*Ddd*Pk2*b2*f**2 - 2160*D1*Ddd*Pk2*f**4*r**2 - 10368*D1*Ddd*Pk2*f**4*r*s + 4752*D1*Ddd*Pk2*f**4*r - 6480*D1*Ddd*Pk2*f**4*s**2 + 8424*D1*Ddd*Pk2*f**4*s - 2700*D1*Ddd*Pk2*f**4 + 728*D1*Ddd*Pk2*f**3*r**2 + 4368*D1*Ddd*Pk2*f**3*r*s - 1820*D1*Ddd*Pk2*f**3*r + 1872*D1*Ddd*Pk2*f**3*s**2 - 3120*D1*Ddd*Pk2*f**3*s + 832*D1*Ddd*Pk2*f**3 + 2496*D1*Ddd*Pk2*f**2*g2*r*s - 624*D1*Ddd*Pk2*f**2*g2*r - 1920*D1*Ddd*Pk2*f**2*g2*s**2 - 288*D1*Ddd*Pk2*f**2*g2*s - 480*D1*Ddd*Pk2*f**2*g2 - 6*D1*bd1*(D1*(-2*Pk2*f*(fd*(12*C*(r*(8*s - 3) + 12*s**2 - 12*s + 1) + 2*K*(r*(13 - 52*s) + 40*s**2 + 6*s - 13) + 106*r**2 + 460*r*s - 191*r + 228*s**2 - 302*s + 127) - 28*g2*(r*(s + 2) - s**2 + 8*s - 4) - 28*gd2*(r*(4*s - 1) + 6*s**2 - 6*s + 1)) + 112*Pk2*fd*g2*(r*(2*s - 1) + s*(3*s - 3)) + f**3*(18*Pk2*(5*r**2 + r*(38*s - 17) + (4 - 5*s)**2) - 5*Pkdd2*k1**2*(s - 1)**2) + f**2*(Pk2*(8*C*(r*(5*s - 6) + 11*s**2 - 24*s + 12) - 76*K*r*s + 108*K*s**2 + 76*K*s - 36*fd*(21*r**2 + 102*r*s - 50*r + 57*s**2 - 85*s + 21) + 43*r**2 + 222*r*s + 34*r + 18*s**2 + 2*s - 125) + 15*Pkdd2*fd*k1**2*s*(s - 1))) - Dd*f*(2*Pk2*f*(24*C*(r*(8*s - 3) + 12*s**2 - 13*s + 3) + K*(-208*r*s + 26*r + 160*s**2 + 116*s - 26) + 212*r**2 + 920*r*s - 313*r + 456*s**2 - 636*s + 119) - 112*Pk2*g2*(r*(8*s - 3) + 12*s**2 - 13*s + 3) + f**2*(36*Pk2*(28*r**2 + r*(136*s - 69) + 76*s**2 - 117*s + 35) - 5*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 2592*Dd**2*Pk2*b2*f**2*r*s - 648*Dd**2*Pk2*b2*f**2*r + 2592*Dd**2*Pk2*b2*f**2*s**2 - 2592*Dd**2*Pk2*b2*f**2*s + 432*Dd**2*Pk2*b2*f**2 - 6480*Dd**2*Pk2*f**4*r**2 - 31104*Dd**2*Pk2*f**4*r*s + 14256*Dd**2*Pk2*f**4*r - 19440*Dd**2*Pk2*f**4*s**2 + 25272*Dd**2*Pk2*f**4*s - 6264*Dd**2*Pk2*f**4 + 2184*Dd**2*Pk2*f**3*r**2 + 13104*Dd**2*Pk2*f**3*r*s - 5460*Dd**2*Pk2*f**3*r + 5616*Dd**2*Pk2*f**3*s**2 - 9360*Dd**2*Pk2*f**3*s + 2548*Dd**2*Pk2*f**3 + 7488*Dd**2*Pk2*f**2*g2*r*s - 1872*Dd**2*Pk2*f**2*g2*r - 5760*Dd**2*Pk2*f**2*g2*s**2 - 864*Dd**2*Pk2*f**2*g2*s + 1248*Dd**2*Pk2*f**2*g2 + 24*Pk2*b1**2*(D1**2*(f*fd*(r*(116*s + 11) + 116*s**2 - 65*s - 11) - 9*f*fdd*(8*r*s + r + 8*s**2 - 4*s - 1) - 9*fd**2*(8*r*s + r + 8*s**2 - 4*s - 1) + 7*fd*(K*(r*(s - 3) - s**2 - 6*s + 3) + 5*r*s + 3*r + 7*s**2 + 6*s - 3) + 7*fdd*(K*(2*r*s - r + 3*s**2 - 2*s + 1) - 5*r*s + r - 6*s**2 + 2*s - 1)) + D1*(Dd*(58*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 18*f*fd*(r*(32*s - 2) + 32*s**2 - 24*s + 1) + 7*f*(-K*(-4*r*s + r + 4*s**2 + 1) + 20*r*s - 5*r + 28*s**2 - 24*s + 7) + 7*fd*(2*K*(8*r*s - 3*r + 12*s**2 - 9*s + 2) - 40*r*s + 9*r - 48*s**2 + 30*s - 4)) + Ddd*f*(7*K*(8*r*s - 2*r + 12*s**2 - 10*s + 3) - 36*f*(r*(4*s - 1) + (1 - 2*s)**2) - 140*r*s + 35*r - 168*s**2 + 154*s - 42)) + Dd**2*f*(7*K*(24*r*s - 6*r + 36*s**2 - 30*s + 4) - 36*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - 420*r*s + 105*r - 504*s**2 + 462*s - 70)) + 3*b1*(-160*C*D1**2*Pk2*f*fd*r*s - 16*C*D1**2*Pk2*f*fd*r - 352*C*D1**2*Pk2*f*fd*s**2 + 48*C*D1**2*Pk2*f*fd*s + 16*C*D1**2*Pk2*f*fd + 192*C*D1**2*Pk2*f*fdd*r*s - 48*C*D1**2*Pk2*f*fdd*r + 288*C*D1**2*Pk2*f*fdd*s**2 - 192*C*D1**2*Pk2*f*fdd*s + 48*C*D1**2*Pk2*f*fdd + 192*C*D1**2*Pk2*fd**2*r*s - 48*C*D1**2*Pk2*fd**2*r + 288*C*D1**2*Pk2*fd**2*s**2 - 192*C*D1**2*Pk2*fd**2*s + 48*C*D1**2*Pk2*fd**2 - 320*C*D1*Dd*Pk2*f**2*r*s + 80*C*D1*Dd*Pk2*f**2*r - 704*C*D1*Dd*Pk2*f**2*s**2 + 512*C*D1*Dd*Pk2*f**2*s - 176*C*D1*Dd*Pk2*f**2 + 1536*C*D1*Dd*Pk2*f*fd*r*s - 384*C*D1*Dd*Pk2*f*fd*r + 2304*C*D1*Dd*Pk2*f*fd*s**2 - 1728*C*D1*Dd*Pk2*f*fd*s + 288*C*D1*Dd*Pk2*f*fd + 384*C*D1*Ddd*Pk2*f**2*r*s - 96*C*D1*Ddd*Pk2*f**2*r + 576*C*D1*Ddd*Pk2*f**2*s**2 - 480*C*D1*Ddd*Pk2*f**2*s + 144*C*D1*Ddd*Pk2*f**2 + 1152*C*Dd**2*Pk2*f**2*r*s - 288*C*Dd**2*Pk2*f**2*r + 1728*C*Dd**2*Pk2*f**2*s**2 - 1440*C*Dd**2*Pk2*f**2*s + 192*C*Dd**2*Pk2*f**2 + 304*D1**2*K*Pk2*f*fd*r*s - 152*D1**2*K*Pk2*f*fd*r - 432*D1**2*K*Pk2*f*fd*s**2 + 432*D1**2*K*Pk2*f*fd*s - 216*D1**2*K*Pk2*f*fd - 208*D1**2*K*Pk2*f*fdd*r*s + 104*D1**2*K*Pk2*f*fdd*r + 160*D1**2*K*Pk2*f*fdd*s**2 - 160*D1**2*K*Pk2*f*fdd*s + 80*D1**2*K*Pk2*f*fdd - 208*D1**2*K*Pk2*fd**2*r*s + 104*D1**2*K*Pk2*fd**2*r + 160*D1**2*K*Pk2*fd**2*s**2 - 160*D1**2*K*Pk2*fd**2*s - 8*D1**2*Pk2*bdd1*f*(-7*K*(4*r*s - r + 6*s**2 - 6*s + 2) + 9*f*(r*(8*s - 5) + 8*s**2 - 12*s + 5) + 70*r*s - 28*r + 84*s**2 - 105*s + 35) - 540*D1**2*Pk2*f**2*fd*r**2 - 4104*D1**2*Pk2*f**2*fd*r*s + 1476*D1**2*Pk2*f**2*fd*r - 2700*D1**2*Pk2*f**2*fd*s**2 + 3096*D1**2*Pk2*f**2*fd*s - 684*D1**2*Pk2*f**2*fd + 756*D1**2*Pk2*f**2*fdd*r**2 + 3672*D1**2*Pk2*f**2*fdd*r*s - 1548*D1**2*Pk2*f**2*fdd*r + 2052*D1**2*Pk2*f**2*fdd*s**2 - 2664*D1**2*Pk2*f**2*fdd*s + 684*D1**2*Pk2*f**2*fdd + 1512*D1**2*Pk2*f*fd**2*r**2 + 7344*D1**2*Pk2*f*fd**2*r*s - 3096*D1**2*Pk2*f*fd**2*r + 4104*D1**2*Pk2*f*fd**2*s**2 - 5328*D1**2*Pk2*f*fd**2*s + 1440*D1**2*Pk2*f*fd**2 - 172*D1**2*Pk2*f*fd*r**2 - 888*D1**2*Pk2*f*fd*r*s + 684*D1**2*Pk2*f*fd*r - 72*D1**2*Pk2*f*fd*s**2 + 520*D1**2*Pk2*f*fd*s - 372*D1**2*Pk2*f*fd + 212*D1**2*Pk2*f*fdd*r**2 + 920*D1**2*Pk2*f*fdd*r*s - 580*D1**2*Pk2*f*fdd*r + 456*D1**2*Pk2*f*fdd*s**2 - 624*D1**2*Pk2*f*fdd*s + 396*D1**2*Pk2*f*fdd - 112*D1**2*Pk2*f*gd2*r*s + 112*D1**2*Pk2*f*gd2*s**2 + 112*D1**2*Pk2*f*gd2*s - 224*D1**2*Pk2*f*gdd2*r*s - 336*D1**2*Pk2*f*gdd2*s**2 + 224*D1**2*Pk2*f*gdd2*s + 212*D1**2*Pk2*fd**2*r**2 + 920*D1**2*Pk2*fd**2*r*s - 580*D1**2*Pk2*fd**2*r + 456*D1**2*Pk2*fd**2*s**2 - 624*D1**2*Pk2*fd**2*s - 48*D1**2*Pk2*fd**2 - 112*D1**2*Pk2*fd*g2*r*s + 336*D1**2*Pk2*fd*g2*r + 112*D1**2*Pk2*fd*g2*s**2 + 672*D1**2*Pk2*fd*g2*s - 336*D1**2*Pk2*fd*g2 - 448*D1**2*Pk2*fd*gd2*r*s + 112*D1**2*Pk2*fd*gd2*r - 672*D1**2*Pk2*fd*gd2*s**2 + 448*D1**2*Pk2*fd*gd2*s - 112*D1**2*Pk2*fd*gd2 - 224*D1**2*Pk2*fdd*g2*r*s + 112*D1**2*Pk2*fdd*g2*r - 336*D1**2*Pk2*fdd*g2*s**2 + 224*D1**2*Pk2*fdd*g2*s - 112*D1**2*Pk2*fdd*g2 + 30*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 15*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 30*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 608*D1*Dd*K*Pk2*f**2*r*s - 152*D1*Dd*K*Pk2*f**2*r - 864*D1*Dd*K*Pk2*f**2*s**2 + 128*D1*Dd*K*Pk2*f**2*s - 216*D1*Dd*K*Pk2*f**2 - 1664*D1*Dd*K*Pk2*f*fd*r*s + 624*D1*Dd*K*Pk2*f*fd*r + 1280*D1*Dd*K*Pk2*f*fd*s**2 - 544*D1*Dd*K*Pk2*f*fd*s - 48*D1*Dd*K*Pk2*f*fd - 720*D1*Dd*Pk2*f**3*r**2 - 5472*D1*Dd*Pk2*f**3*r*s + 2088*D1*Dd*Pk2*f**3*r - 3600*D1*Dd*Pk2*f**3*s**2 + 4536*D1*Dd*Pk2*f**3*s - 1260*D1*Dd*Pk2*f**3 + 6048*D1*Dd*Pk2*f**2*fd*r**2 + 29376*D1*Dd*Pk2*f**2*fd*r*s - 12888*D1*Dd*Pk2*f**2*fd*r + 16416*D1*Dd*Pk2*f**2*fd*s**2 - 22104*D1*Dd*Pk2*f**2*fd*s + 5760*D1*Dd*Pk2*f**2*fd - 344*D1*Dd*Pk2*f**2*r**2 - 1776*D1*Dd*Pk2*f**2*r*s + 788*D1*Dd*Pk2*f**2*r - 144*D1*Dd*Pk2*f**2*s**2 + 960*D1*Dd*Pk2*f**2*s - 208*D1*Dd*Pk2*f**2 + 1696*D1*Dd*Pk2*f*fd*r**2 + 7360*D1*Dd*Pk2*f*fd*r*s - 4088*D1*Dd*Pk2*f*fd*r + 3648*D1*Dd*Pk2*f*fd*s**2 - 5248*D1*Dd*Pk2*f*fd*s + 1784*D1*Dd*Pk2*f*fd - 448*D1*Dd*Pk2*f*g2*r*s + 112*D1*Dd*Pk2*f*g2*r + 448*D1*Dd*Pk2*f*g2*s**2 + 112*D1*Dd*Pk2*f*g2 - 1792*D1*Dd*Pk2*f*gd2*r*s + 224*D1*Dd*Pk2*f*gd2*r - 2688*D1*Dd*Pk2*f*gd2*s**2 + 2016*D1*Dd*Pk2*f*gd2*s - 224*D1*Dd*Pk2*f*gd2 - 1792*D1*Dd*Pk2*fd*g2*r*s + 672*D1*Dd*Pk2*fd*g2*r - 2688*D1*Dd*Pk2*fd*g2*s**2 + 2016*D1*Dd*Pk2*fd*g2*s - 448*D1*Dd*Pk2*fd*g2 + 40*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 20*D1*Dd*Pkdd2*f**3*k1**2*s + 10*D1*Dd*Pkdd2*f**3*k1**2 - 120*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 30*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 416*D1*Ddd*K*Pk2*f**2*r*s + 104*D1*Ddd*K*Pk2*f**2*r + 320*D1*Ddd*K*Pk2*f**2*s**2 + 48*D1*Ddd*K*Pk2*f**2*s + 80*D1*Ddd*K*Pk2*f**2 + 1008*D1*Ddd*Pk2*f**3*r**2 + 4896*D1*Ddd*Pk2*f**3*r*s - 2232*D1*Ddd*Pk2*f**3*r + 2736*D1*Ddd*Pk2*f**3*s**2 - 3816*D1*Ddd*Pk2*f**3*s + 1188*D1*Ddd*Pk2*f**3 + 424*D1*Ddd*Pk2*f**2*r**2 + 1840*D1*Ddd*Pk2*f**2*r*s - 884*D1*Ddd*Pk2*f**2*r + 912*D1*Ddd*Pk2*f**2*s**2 - 1376*D1*Ddd*Pk2*f**2*s + 440*D1*Ddd*Pk2*f**2 - 896*D1*Ddd*Pk2*f*g2*r*s + 224*D1*Ddd*Pk2*f*g2*r - 1344*D1*Ddd*Pk2*f*g2*s**2 + 1120*D1*Ddd*Pk2*f*g2*s - 336*D1*Ddd*Pk2*f*g2 - 20*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 10*D1*Ddd*Pkdd2*f**3*k1**2*s - 5*D1*Ddd*Pkdd2*f**3*k1**2 + 8*D1*Pk2*bd1*(D1*(f**2*(r*(116*s - 69) + 116*s**2 - 167*s + 69) + f*(7*K*(2*r*(s + 1) - 2*s**2 + 7*s - 4) - 18*fd*(4*s - 1)*(4*r + 4*s - 3) + 70*r*s - 56*r + 98*s**2 - 175*s + 70) + 7*fd*(K*(8*r*s - 3*r + 12*s**2 - 10*s + 1) - 20*r*s + 6*r - 24*s**2 + 19*s - 1)) + Dd*f*(28*K*(4*s - 1)*(2*r + 3*s - 2) - 18*f*(2*r*(16*s - 7) + 32*s**2 - 40*s + 11) - 560*r*s + 182*r - 672*s**2 + 728*s - 161)) - 1248*Dd**2*K*Pk2*f**2*r*s + 312*Dd**2*K*Pk2*f**2*r + 960*Dd**2*K*Pk2*f**2*s**2 + 144*Dd**2*K*Pk2*f**2*s - 208*Dd**2*K*Pk2*f**2 + 3024*Dd**2*Pk2*f**3*r**2 + 14688*Dd**2*Pk2*f**3*r*s - 6696*Dd**2*Pk2*f**3*r + 8208*Dd**2*Pk2*f**3*s**2 - 11448*Dd**2*Pk2*f**3*s + 2952*Dd**2*Pk2*f**3 + 1272*Dd**2*Pk2*f**2*r**2 + 5520*Dd**2*Pk2*f**2*r*s - 2652*Dd**2*Pk2*f**2*r + 2736*Dd**2*Pk2*f**2*s**2 - 4128*Dd**2*Pk2*f**2*s + 1132*Dd**2*Pk2*f**2 - 2688*Dd**2*Pk2*f*g2*r*s + 672*Dd**2*Pk2*f*g2*r - 4032*Dd**2*Pk2*f*g2*s**2 + 3360*Dd**2*Pk2*f*g2*s - 448*Dd**2*Pk2*f*g2 - 60*Dd**2*Pkdd2*f**3*k1**2*s**2 + 30*Dd**2*Pkdd2*f**3*k1**2*s))/(630*d**2*k2*k3**4) + D1**2*Pk3*ct*k1**3*(-28*D1**2*Pk2*bd1**2*(3*f**2*(14*r**2 + r*(28*s - 23) + 14*s**2 - 25*s + 9) + f*(-2*K*(9*r*(2*s - 1) + 13*s**2 - 22*s + 9) + 31*r**2 + 2*r*(12*C*s - 6*C + 43*s - 37) + (s - 1)*(24*C*s + 45*s - 55)) + 20*g2*(-2*r*s + r - s*(2*s - 2))) + D1*bd1*(D1*(-2*Pk2*f**2*(12*C*(s - 1)*(32*r + 17*s - 17) + 84*K*r*s + 238*K*s**2 - 84*K*s - 84*fd*(15*r**2 + 24*r*s - 26*r - 13*s + 10) - 129*r**2 - 714*r*s + 714*r - 482*s**2 + 810*s - 405) + 4*Pk2*f*(fd*(12*C*(30*r*(2*s - 1) + 38*s**2 - 53*s + 15) + 14*K*(12*r*s - 3*r + 34*s**2 - 23*s + 3) - 318*r**2 - 1428*r*s + 873*r - 1000*s**2 + 1280*s - 357) + 14*g2*(s - 1)*(16*r + 11*s - 11) - 28*gd2*(9*r*(2*s - 1) + 13*s**2 - 22*s + 9)) - 112*Pk2*fd*g2*(9*r*(2*s - 1) + s*(13*s - 13)) - 3*f**3*(14*Pk2*(10*r**2 + 8*r*(2*s - 3) - 10*s + 9) - 5*Pkdd2*k1**2*(s - 1)**2)) + 4*Dd*Pk2*f*(21*f**2*(40*r**2 + r*(64*s - 76) - 36*s + 29) + f*(12*C*(15*r*(8*s - 5) + 76*s**2 - 125*s + 49) + 14*K*(24*r*s - 3*r + 68*s**2 - 35*s + 3) - 636*r**2 - 2856*r*s + 2103*r - 2000*s**2 + 2906*s - 1137) - 28*g2*(9*r*(8*s - 5) + 52*s**2 - 83*s + 31))) - 280*Pk2*b1**3*(K - 1)*(D1*(Dd + Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 14*Pk2*b1**2*(-8*C*D1**2*fd*r*s - 8*C*D1**2*fd*s**2 + 8*C*D1**2*fd*s + 24*C*D1**2*fdd*r*s + 24*C*D1**2*fdd*s**2 - 24*C*D1**2*fdd*s - 32*C*D1*Dd*f*r*s + 8*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 + 32*C*D1*Dd*f*s - 8*C*D1*Dd*f + 192*C*D1*Dd*fd*r*s - 24*C*D1*Dd*fd*r + 192*C*D1*Dd*fd*s**2 - 192*C*D1*Dd*fd*s + 24*C*D1*Dd*fd + 96*C*D1*Ddd*f*r*s - 24*C*D1*Ddd*f*r + 96*C*D1*Ddd*f*s**2 - 96*C*D1*Ddd*f*s + 24*C*D1*Ddd*f + 288*C*Dd**2*f*r*s - 72*C*Dd**2*f*r + 288*C*Dd**2*f*s**2 - 288*C*Dd**2*f*s + 48*C*Dd**2*f + 32*D1**2*K*fd*r*s + 22*D1**2*K*fd*s**2 - 36*D1**2*K*fdd*r*s - 26*D1**2*K*fdd*s**2 + 20*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 60*D1**2*f*fd*r**2 - 168*D1**2*f*fd*r*s + 78*D1**2*f*fd*r - 108*D1**2*f*fd*s**2 + 102*D1**2*f*fd*s - 33*D1**2*f*fd + 84*D1**2*f*fdd*r**2 + 168*D1**2*f*fdd*r*s - 114*D1**2*f*fdd*r + 84*D1**2*f*fdd*s**2 - 102*D1**2*f*fdd*s + 51*D1**2*f*fdd + 84*D1**2*fd**2*r**2 + 168*D1**2*fd**2*r*s - 114*D1**2*fd**2*r + 84*D1**2*fd**2*s**2 - 102*D1**2*fd**2*s + 30*D1**2*fd**2 - 17*D1**2*fd*r**2 - 82*D1**2*fd*r*s - 55*D1**2*fd*s**2 - 8*D1**2*fd*s + 31*D1**2*fdd*r**2 + 86*D1**2*fdd*r*s + 45*D1**2*fdd*s**2 + 24*D1**2*fdd*s - 40*D1**2*gd2*r*s - 40*D1**2*gd2*s**2 + 40*D1**2*gd2*s - 40*D1**2*gdd2*r*s - 40*D1**2*gdd2*s**2 + 40*D1**2*gdd2*s + 128*D1*Dd*K*f*r*s - 32*D1*Dd*K*f*r + 88*D1*Dd*K*f*s**2 - 108*D1*Dd*K*f*s + 22*D1*Dd*K*f - 288*D1*Dd*K*fd*r*s + 36*D1*Dd*K*fd*r - 208*D1*Dd*K*fd*s**2 + 124*D1*Dd*K*fd*s - 120*D1*Dd*f**2*r**2 - 336*D1*Dd*f**2*r*s + 204*D1*Dd*f**2*r - 216*D1*Dd*f**2*s**2 + 276*D1*Dd*f**2*s - 114*D1*Dd*f**2 + 672*D1*Dd*f*fd*r**2 + 1344*D1*Dd*f*fd*r*s - 960*D1*Dd*f*fd*r + 672*D1*Dd*f*fd*s**2 - 912*D1*Dd*f*fd*s + 330*D1*Dd*f*fd - 68*D1*Dd*f*r**2 - 328*D1*Dd*f*r*s + 150*D1*Dd*f*r - 220*D1*Dd*f*s**2 + 274*D1*Dd*f*s - 89*D1*Dd*f + 248*D1*Dd*fd*r**2 + 688*D1*Dd*fd*r*s - 210*D1*Dd*fd*r + 360*D1*Dd*fd*s**2 - 166*D1*Dd*fd*s - 24*D1*Dd*fd - 160*D1*Dd*g2*r*s + 40*D1*Dd*g2*r - 160*D1*Dd*g2*s**2 + 160*D1*Dd*g2*s - 40*D1*Dd*g2 - 320*D1*Dd*gd2*r*s + 40*D1*Dd*gd2*r - 320*D1*Dd*gd2*s**2 + 320*D1*Dd*gd2*s - 40*D1*Dd*gd2 - 144*D1*Ddd*K*f*r*s + 36*D1*Ddd*K*f*r - 104*D1*Ddd*K*f*s**2 + 124*D1*Ddd*K*f*s - 26*D1*Ddd*K*f + 168*D1*Ddd*f**2*r**2 + 336*D1*Ddd*f**2*r*s - 252*D1*Ddd*f**2*r + 168*D1*Ddd*f**2*s**2 - 252*D1*Ddd*f**2*s + 126*D1*Ddd*f**2 + 124*D1*Ddd*f*r**2 + 344*D1*Ddd*f*r*s - 210*D1*Ddd*f*r + 180*D1*Ddd*f*s**2 - 262*D1*Ddd*f*s + 107*D1*Ddd*f - 160*D1*Ddd*g2*r*s + 40*D1*Ddd*g2*r - 160*D1*Ddd*g2*s**2 + 160*D1*Ddd*g2*s - 40*D1*Ddd*g2 + 20*D1*bd1*(K - 1)*(D1*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*(24*r*s - 7*r + 24*s**2 - 24*s + 5)) - 432*Dd**2*K*f*r*s + 108*Dd**2*K*f*r - 312*Dd**2*K*f*s**2 + 372*Dd**2*K*f*s - 72*Dd**2*K*f + 504*Dd**2*f**2*r**2 + 1008*Dd**2*f**2*r*s - 756*Dd**2*f**2*r + 504*Dd**2*f**2*s**2 - 756*Dd**2*f**2*s + 252*Dd**2*f**2 + 372*Dd**2*f*r**2 + 1032*Dd**2*f*r*s - 630*Dd**2*f*r + 540*Dd**2*f*s**2 - 786*Dd**2*f*s + 234*Dd**2*f - 480*Dd**2*g2*r*s + 120*Dd**2*g2*r - 480*Dd**2*g2*s**2 + 480*Dd**2*g2*s - 80*Dd**2*g2) + 2*Pk2*(-360*C*D1**2*f**2*fd*r*s + 120*C*D1**2*f**2*fd*r - 972*C*D1**2*f**2*fd*s**2 + 768*C*D1**2*f**2*fd*s - 324*C*D1**2*f**2*fd + 360*C*D1**2*f**2*fdd*r*s - 120*C*D1**2*f**2*fdd*r + 972*C*D1**2*f**2*fdd*s**2 - 768*C*D1**2*f**2*fdd*s + 324*C*D1**2*f**2*fdd + 720*C*D1**2*f*fd**2*r*s - 240*C*D1**2*f*fd**2*r + 1944*C*D1**2*f*fd**2*s**2 - 1536*C*D1**2*f*fd**2*s + 120*C*D1**2*f*fd**2 - 480*C*D1*Dd*f**3*r*s + 120*C*D1*Dd*f**3*r - 1296*C*D1*Dd*f**3*s**2 + 888*C*D1*Dd*f**3*s - 324*C*D1*Dd*f**3 + 2880*C*D1*Dd*f**2*fd*r*s - 840*C*D1*Dd*f**2*fd*r + 7776*C*D1*Dd*f**2*fd*s**2 - 5736*C*D1*Dd*f**2*fd*s + 1008*C*D1*Dd*f**2*fd + 480*C*D1*Ddd*f**3*r*s - 120*C*D1*Ddd*f**3*r + 1296*C*D1*Ddd*f**3*s**2 - 888*C*D1*Ddd*f**3*s + 324*C*D1*Ddd*f**3 + 1440*C*Dd**2*f**3*r*s - 360*C*Dd**2*f**3*r + 3888*C*Dd**2*f**3*s**2 - 2664*C*Dd**2*f**3*s + 240*C*Dd**2*f**3 - 84*D1**2*bd2*f**2*r*s - 84*D1**2*bd2*f**2*s**2 + 84*D1**2*bd2*f**2*s + 336*D1**2*bd2*f*fd*r*s - 84*D1**2*bd2*f*fd*r + 336*D1**2*bd2*f*fd*s**2 - 336*D1**2*bd2*f*fd*s + 84*D1**2*bd2*f*fd + D1**2*bdd1*f*(21*f**2*(10*r**2 + 8*r*(2*s - 3) - 10*s + 9) + f*(12*C*(s - 1)*(30*r + 19*s - 19) + 238*K*s**2 - 84*K*s - 159*r**2 + 42*r*(2*K*s - 17*s + 17) - 500*s**2 + 846*s - 423) - 28*g2*(s - 1)*(18*r + 13*s - 13)) + 84*D1**2*bdd2*f**2*r*s + 84*D1**2*bdd2*f**2*s**2 - 84*D1**2*bdd2*f**2*s + 180*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 639*D1**2*f**2*fd*s**2 - 486*D1**2*f**2*fd*s + 213*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 639*D1**2*f**2*fdd*s**2 + 486*D1**2*f**2*fdd*s - 213*D1**2*f**2*fdd + 168*D1**2*f**2*gd2*r*s + 476*D1**2*f**2*gd2*s**2 - 168*D1**2*f**2*gd2*s - 168*D1**2*f**2*gdd2*r*s - 476*D1**2*f**2*gdd2*s**2 + 168*D1**2*f**2*gdd2*s - 360*D1**2*f*fd**2*r*s + 120*D1**2*f*fd**2*r - 1278*D1**2*f*fd**2*s**2 + 972*D1**2*f*fd**2*s - 60*D1**2*f*fd**2 + 336*D1**2*f*fd*g2*r*s - 168*D1**2*f*fd*g2*r + 952*D1**2*f*fd*g2*s**2 - 952*D1**2*f*fd*g2*s + 476*D1**2*f*fd*g2 - 672*D1**2*f*fd*gd2*r*s + 168*D1**2*f*fd*gd2*r - 1904*D1**2*f*fd*gd2*s**2 + 1288*D1**2*f*fd*gd2*s - 168*D1**2*f*fd*gd2 - 336*D1**2*f*fdd*g2*r*s + 168*D1**2*f*fdd*g2*r - 952*D1**2*f*fdd*g2*s**2 + 952*D1**2*f*fdd*g2*s - 476*D1**2*f*fdd*g2 - 336*D1**2*fd**2*g2*r*s + 168*D1**2*fd**2*g2*r - 952*D1**2*fd**2*g2*s**2 + 952*D1**2*fd**2*g2*s + 672*D1*Dd*bd2*f**2*r*s - 84*D1*Dd*bd2*f**2*r + 672*D1*Dd*bd2*f**2*s**2 - 672*D1*Dd*bd2*f**2*s + 84*D1*Dd*bd2*f**2 + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 852*D1*Dd*f**3*s**2 - 546*D1*Dd*f**3*s + 213*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r*s + 420*D1*Dd*f**2*fd*r - 5112*D1*Dd*f**2*fd*s**2 + 3582*D1*Dd*f**2*fd*s - 606*D1*Dd*f**2*fd + 672*D1*Dd*f**2*g2*r*s - 168*D1*Dd*f**2*g2*r + 1904*D1*Dd*f**2*g2*s**2 - 1288*D1*Dd*f**2*g2*s + 476*D1*Dd*f**2*g2 - 1344*D1*Dd*f**2*gd2*r*s + 168*D1*Dd*f**2*gd2*r - 3808*D1*Dd*f**2*gd2*s**2 + 1960*D1*Dd*f**2*gd2*s - 168*D1*Dd*f**2*gd2 - 2688*D1*Dd*f*fd*g2*r*s + 1008*D1*Dd*f*fd*g2*r - 7616*D1*Dd*f*fd*g2*s**2 + 6384*D1*Dd*f*fd*g2*s - 1288*D1*Dd*f*fd*g2 - 240*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 852*D1*Ddd*f**3*s**2 + 546*D1*Ddd*f**3*s - 213*D1*Ddd*f**3 - 672*D1*Ddd*f**2*g2*r*s + 168*D1*Ddd*f**2*g2*r - 1904*D1*Ddd*f**2*g2*s**2 + 1288*D1*Ddd*f**2*g2*s - 476*D1*Ddd*f**2*g2 - 720*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 2556*Dd**2*f**3*s**2 + 1638*Dd**2*f**3*s - 120*Dd**2*f**3 - 2016*Dd**2*f**2*g2*r*s + 504*Dd**2*f**2*g2*r - 5712*Dd**2*f**2*g2*s**2 + 3864*Dd**2*f**2*g2*s - 336*Dd**2*f**2*g2 - 84*b2*(D1**2*(f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))) + b1*(-1536*C*D1**2*Pk2*f*fd*r*s - 816*C*D1**2*Pk2*f*fd*s**2 + 768*C*D1**2*Pk2*f*fd*s + 1440*C*D1**2*Pk2*f*fdd*r*s + 912*C*D1**2*Pk2*f*fdd*s**2 - 720*C*D1**2*Pk2*f*fdd*s + 1440*C*D1**2*Pk2*fd**2*r*s + 912*C*D1**2*Pk2*fd**2*s**2 - 720*C*D1**2*Pk2*fd**2*s - 3072*C*D1*Dd*Pk2*f**2*r*s + 768*C*D1*Dd*Pk2*f**2*r - 1632*C*D1*Dd*Pk2*f**2*s**2 + 2352*C*D1*Dd*Pk2*f**2*s - 408*C*D1*Dd*Pk2*f**2 + 11520*C*D1*Dd*Pk2*f*fd*r*s - 1440*C*D1*Dd*Pk2*f*fd*r + 7296*C*D1*Dd*Pk2*f*fd*s**2 - 7584*C*D1*Dd*Pk2*f*fd*s + 720*C*D1*Dd*Pk2*f*fd + 2880*C*D1*Ddd*Pk2*f**2*r*s - 720*C*D1*Ddd*Pk2*f**2*r + 1824*C*D1*Ddd*Pk2*f**2*s**2 - 2352*C*D1*Ddd*Pk2*f**2*s + 456*C*D1*Ddd*Pk2*f**2 + 8640*C*Dd**2*Pk2*f**2*r*s - 2160*C*Dd**2*Pk2*f**2*r + 5472*C*Dd**2*Pk2*f**2*s**2 - 7056*C*Dd**2*Pk2*f**2*s + 1440*C*Dd**2*Pk2*f**2 - 336*D1**2*K*Pk2*f*fd*r*s + 168*D1**2*K*Pk2*f*fd*r - 952*D1**2*K*Pk2*f*fd*s**2 + 952*D1**2*K*Pk2*f*fd*s - 476*D1**2*K*Pk2*f*fd + 336*D1**2*K*Pk2*f*fdd*r*s - 168*D1**2*K*Pk2*f*fdd*r + 952*D1**2*K*Pk2*f*fdd*s**2 - 952*D1**2*K*Pk2*f*fdd*s + 476*D1**2*K*Pk2*f*fdd + 336*D1**2*K*Pk2*fd**2*r*s - 168*D1**2*K*Pk2*fd**2*r + 952*D1**2*K*Pk2*fd**2*s**2 - 952*D1**2*K*Pk2*fd**2*s - 280*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 14*D1**2*Pk2*bdd1*(3*f**2*(28*r**2 + r*(56*s - 46) + 28*s**2 - 50*s + 25) + 2*f*(12*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-36*r*s + 18*r - 26*s**2 + 44*s - 13) + 31*r**2 + 86*r*s - 74*r + 45*s**2 - 100*s + 38) - 40*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 1260*D1**2*Pk2*f**2*fd*r**2 - 2016*D1**2*Pk2*f**2*fd*r*s + 1344*D1**2*Pk2*f**2*fd*r + 924*D1**2*Pk2*f**2*fd*s - 462*D1**2*Pk2*f**2*fd + 1260*D1**2*Pk2*f**2*fdd*r**2 + 2016*D1**2*Pk2*f**2*fdd*r*s - 1344*D1**2*Pk2*f**2*fdd*r - 924*D1**2*Pk2*f**2*fdd*s + 462*D1**2*Pk2*f**2*fdd + 2520*D1**2*Pk2*f*fd**2*r**2 + 4032*D1**2*Pk2*f*fd**2*r*s - 2688*D1**2*Pk2*f*fd**2*r - 1848*D1**2*Pk2*f*fd**2*s + 504*D1**2*Pk2*f*fd**2 + 516*D1**2*Pk2*f*fd*r**2 + 2856*D1**2*Pk2*f*fd*r*s - 516*D1**2*Pk2*f*fd*r + 1928*D1**2*Pk2*f*fd*s**2 - 1736*D1**2*Pk2*f*fd*s + 412*D1**2*Pk2*f*fd - 636*D1**2*Pk2*f*fdd*r**2 - 2856*D1**2*Pk2*f*fdd*r*s + 636*D1**2*Pk2*f*fdd*r - 2000*D1**2*Pk2*f*fdd*s**2 + 1736*D1**2*Pk2*f*fdd*s - 472*D1**2*Pk2*f*fdd + 896*D1**2*Pk2*f*gd2*r*s + 616*D1**2*Pk2*f*gd2*s**2 - 896*D1**2*Pk2*f*gd2*s - 1008*D1**2*Pk2*f*gdd2*r*s - 728*D1**2*Pk2*f*gdd2*s**2 + 1008*D1**2*Pk2*f*gdd2*s - 636*D1**2*Pk2*fd**2*r**2 - 2856*D1**2*Pk2*fd**2*r*s + 636*D1**2*Pk2*fd**2*r - 2000*D1**2*Pk2*fd**2*s**2 + 1736*D1**2*Pk2*fd**2*s + 896*D1**2*Pk2*fd*g2*r*s + 616*D1**2*Pk2*fd*g2*s**2 - 2016*D1**2*Pk2*fd*gd2*r*s - 1456*D1**2*Pk2*fd*gd2*s**2 + 1008*D1**2*Pk2*fd*gd2*s - 1008*D1**2*Pk2*fdd*g2*r*s - 728*D1**2*Pk2*fdd*g2*s**2 + 45*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 672*D1*Dd*K*Pk2*f**2*r*s + 168*D1*Dd*K*Pk2*f**2*r - 1904*D1*Dd*K*Pk2*f**2*s**2 + 1288*D1*Dd*K*Pk2*f**2*s - 476*D1*Dd*K*Pk2*f**2 + 2688*D1*Dd*K*Pk2*f*fd*r*s - 1008*D1*Dd*K*Pk2*f*fd*r + 7616*D1*Dd*K*Pk2*f*fd*s**2 - 6384*D1*Dd*K*Pk2*f*fd*s + 1288*D1*Dd*K*Pk2*f*fd - 1680*D1*Dd*Pk2*f**3*r**2 - 2688*D1*Dd*Pk2*f**3*r*s + 2352*D1*Dd*Pk2*f**3*r + 1344*D1*Dd*Pk2*f**3*s - 840*D1*Dd*Pk2*f**3 + 10080*D1*Dd*Pk2*f**2*fd*r**2 + 16128*D1*Dd*Pk2*f**2*fd*r*s - 12432*D1*Dd*Pk2*f**2*fd*r - 7728*D1*Dd*Pk2*f**2*fd*s + 3612*D1*Dd*Pk2*f**2*fd + 1032*D1*Dd*Pk2*f**2*r**2 + 5712*D1*Dd*Pk2*f**2*r*s - 2460*D1*Dd*Pk2*f**2*r + 3856*D1*Dd*Pk2*f**2*s**2 - 4784*D1*Dd*Pk2*f**2*s + 1480*D1*Dd*Pk2*f**2 - 5088*D1*Dd*Pk2*f*fd*r**2 - 22848*D1*Dd*Pk2*f*fd*r*s + 7944*D1*Dd*Pk2*f*fd*r - 16000*D1*Dd*Pk2*f*fd*s**2 + 16656*D1*Dd*Pk2*f*fd*s - 3008*D1*Dd*Pk2*f*fd + 3584*D1*Dd*Pk2*f*g2*r*s - 896*D1*Dd*Pk2*f*g2*r + 2464*D1*Dd*Pk2*f*g2*s**2 - 3024*D1*Dd*Pk2*f*g2*s + 616*D1*Dd*Pk2*f*g2 - 8064*D1*Dd*Pk2*f*gd2*r*s + 1008*D1*Dd*Pk2*f*gd2*r - 5824*D1*Dd*Pk2*f*gd2*s**2 + 7504*D1*Dd*Pk2*f*gd2*s - 1008*D1*Dd*Pk2*f*gd2 - 8064*D1*Dd*Pk2*fd*g2*r*s + 1008*D1*Dd*Pk2*fd*g2*r - 5824*D1*Dd*Pk2*fd*g2*s**2 + 3472*D1*Dd*Pk2*fd*g2*s + 60*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 30*D1*Dd*Pkdd2*f**3*k1**2*s + 15*D1*Dd*Pkdd2*f**3*k1**2 + 672*D1*Ddd*K*Pk2*f**2*r*s - 168*D1*Ddd*K*Pk2*f**2*r + 1904*D1*Ddd*K*Pk2*f**2*s**2 - 1288*D1*Ddd*K*Pk2*f**2*s + 476*D1*Ddd*K*Pk2*f**2 + 1680*D1*Ddd*Pk2*f**3*r**2 + 2688*D1*Ddd*Pk2*f**3*r*s - 2352*D1*Ddd*Pk2*f**3*r - 1344*D1*Ddd*Pk2*f**3*s + 840*D1*Ddd*Pk2*f**3 - 1272*D1*Ddd*Pk2*f**2*r**2 - 5712*D1*Ddd*Pk2*f**2*r*s + 2700*D1*Ddd*Pk2*f**2*r - 4000*D1*Ddd*Pk2*f**2*s**2 + 4856*D1*Ddd*Pk2*f**2*s - 1636*D1*Ddd*Pk2*f**2 - 4032*D1*Ddd*Pk2*f*g2*r*s + 1008*D1*Ddd*Pk2*f*g2*r - 2912*D1*Ddd*Pk2*f*g2*s**2 + 3472*D1*Ddd*Pk2*f*g2*s - 728*D1*Ddd*Pk2*f*g2 + 14*D1*Pk2*bd1*(D1*(3*f**2*(20*r**2 + 14*r*(4*s - 3) + 36*s**2 - 58*s + 27) + 2*f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) - 32*K*r*s + 16*K*r - 22*K*s**2 + 38*K*s - 11*K - 84*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 17*r**2 + 82*r*s - 58*r + 55*s**2 - 100*s + 36) - 4*fd*(6*C*(r*(4*s - 1) + (1 - 2*s)**2) - 26*K*s**2 + 22*K*s + 31*r**2 + r*(-36*K*s + 9*K + 86*s - 37) + 45*s**2 - 38*s - 6) + 40*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 40*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd*(3*f**2*(112*r**2 + 16*r*(14*s - 11) + 112*s**2 - 184*s + 71) + 2*f*(12*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 2*K*(9*r*(8*s - 3) + 52*s**2 - 75*s + 20) + 124*r**2 + 344*r*s - 253*r + 180*s**2 - 331*s + 124) - 40*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 2016*Dd**2*K*Pk2*f**2*r*s - 504*Dd**2*K*Pk2*f**2*r + 5712*Dd**2*K*Pk2*f**2*s**2 - 3864*Dd**2*K*Pk2*f**2*s + 336*Dd**2*K*Pk2*f**2 + 5040*Dd**2*Pk2*f**3*r**2 + 8064*Dd**2*Pk2*f**3*r*s - 7056*Dd**2*Pk2*f**3*r - 4032*Dd**2*Pk2*f**3*s + 2184*Dd**2*Pk2*f**3 - 3816*Dd**2*Pk2*f**2*r**2 - 17136*Dd**2*Pk2*f**2*r*s + 8100*Dd**2*Pk2*f**2*r - 12000*Dd**2*Pk2*f**2*s**2 + 14568*Dd**2*Pk2*f**2*s - 3492*Dd**2*Pk2*f**2 - 12096*Dd**2*Pk2*f*g2*r*s + 3024*Dd**2*Pk2*f*g2*r - 8736*Dd**2*Pk2*f*g2*s**2 + 10416*Dd**2*Pk2*f*g2*s - 2016*Dd**2*Pk2*f*g2))/(210*d**2*k2*k3**4) - D1**2*Pk3*ct*k1*k2*st**6*(-2112*C*D1**2*Pk2*f**2*fd*r*s + 704*C*D1**2*Pk2*f**2*fd*r + 2112*C*D1**2*Pk2*f**2*fd*s**2 - 704*C*D1**2*Pk2*f**2*fd*s + 704*C*D1**2*Pk2*f**2*fd + 1056*C*D1**2*Pk2*f**2*fdd*r*s - 352*C*D1**2*Pk2*f**2*fdd*r - 1056*C*D1**2*Pk2*f**2*fdd*s**2 + 352*C*D1**2*Pk2*f**2*fdd*s - 352*C*D1**2*Pk2*f**2*fdd + 2112*C*D1**2*Pk2*f*fd**2*r*s - 704*C*D1**2*Pk2*f*fd**2*r - 2112*C*D1**2*Pk2*f*fd**2*s**2 + 704*C*D1**2*Pk2*f*fd**2*s + 352*C*D1**2*Pk2*f*fd**2 - 2816*C*D1*Dd*Pk2*f**3*r*s + 704*C*D1*Dd*Pk2*f**3*r + 2816*C*D1*Dd*Pk2*f**3*s**2 + 704*C*D1*Dd*Pk2*f**3 + 8448*C*D1*Dd*Pk2*f**2*fd*r*s - 2464*C*D1*Dd*Pk2*f**2*fd*r - 8448*C*D1*Dd*Pk2*f**2*fd*s**2 + 1408*C*D1*Dd*Pk2*f**2*fd*s + 352*C*D1*Dd*Pk2*f**2*fd + 1408*C*D1*Ddd*Pk2*f**3*r*s - 352*C*D1*Ddd*Pk2*f**3*r - 1408*C*D1*Ddd*Pk2*f**3*s**2 - 352*C*D1*Ddd*Pk2*f**3 + 4224*C*Dd**2*Pk2*f**3*r*s - 1056*C*Dd**2*Pk2*f**3*r - 4224*C*Dd**2*Pk2*f**3*s**2 + 704*C*Dd**2*Pk2*f**3 + 1584*D1**2*K*Pk2*bdd1*f**2*r*s - 1584*D1**2*K*Pk2*bdd1*f**2*s**2 - 1584*D1**2*K*Pk2*bdd1*f**2*s - 1232*D1**2*Pk2*bdd1*f**3*r*s - 616*D1**2*Pk2*bdd1*f**3*s**2 + 1232*D1**2*Pk2*bdd1*f**3*s - 3168*D1**2*Pk2*bdd1*f**2*r*s - 792*D1**2*Pk2*bdd1*f**2*s**2 + 3168*D1**2*Pk2*bdd1*f**2*s - 4928*D1**2*Pk2*f**3*fd*r*s + 1232*D1**2*Pk2*f**3*fd*r + 2464*D1**2*Pk2*f**3*fd*s + 4928*D1**2*Pk2*f**3*fdd*r*s - 1232*D1**2*Pk2*f**3*fdd*r - 2464*D1**2*Pk2*f**3*fdd*s + 14784*D1**2*Pk2*f**2*fd**2*r*s - 3696*D1**2*Pk2*f**2*fd**2*r - 7392*D1**2*Pk2*f**2*fd**2*s + 2464*D1**2*Pk2*f**2*fd**2 + 3168*D1**2*Pk2*f**2*fd*r*s - 1056*D1**2*Pk2*f**2*fd*r - 528*D1**2*Pk2*f**2*fd*s**2 - 704*D1**2*Pk2*f**2*fd*s - 176*D1**2*Pk2*f**2*fd - 1584*D1**2*Pk2*f**2*fdd*r*s + 528*D1**2*Pk2*f**2*fdd*r + 264*D1**2*Pk2*f**2*fdd*s**2 + 352*D1**2*Pk2*f**2*fdd*s + 88*D1**2*Pk2*f**2*fdd + 6336*D1**2*Pk2*f**2*gd2*r*s - 6336*D1**2*Pk2*f**2*gd2*s**2 - 6336*D1**2*Pk2*f**2*gd2*s - 3168*D1**2*Pk2*f**2*gdd2*r*s + 3168*D1**2*Pk2*f**2*gdd2*s**2 + 3168*D1**2*Pk2*f**2*gdd2*s - 3168*D1**2*Pk2*f*fd**2*r*s + 1056*D1**2*Pk2*f*fd**2*r + 528*D1**2*Pk2*f*fd**2*s**2 + 704*D1**2*Pk2*f*fd**2*s - 528*D1**2*Pk2*f*fd**2 + 12672*D1**2*Pk2*f*fd*g2*r*s - 6336*D1**2*Pk2*f*fd*g2*r - 12672*D1**2*Pk2*f*fd*g2*s**2 + 12672*D1**2*Pk2*f*fd*g2*s - 6336*D1**2*Pk2*f*fd*g2 - 12672*D1**2*Pk2*f*fd*gd2*r*s + 3168*D1**2*Pk2*f*fd*gd2*r + 12672*D1**2*Pk2*f*fd*gd2*s**2 - 3168*D1**2*Pk2*f*fd*gd2 - 6336*D1**2*Pk2*f*fdd*g2*r*s + 3168*D1**2*Pk2*f*fdd*g2*r + 6336*D1**2*Pk2*f*fdd*g2*s**2 - 6336*D1**2*Pk2*f*fdd*g2*s + 3168*D1**2*Pk2*f*fdd*g2 - 6336*D1**2*Pk2*fd**2*g2*r*s + 3168*D1**2*Pk2*fd**2*g2*r + 6336*D1**2*Pk2*fd**2*g2*s**2 - 6336*D1**2*Pk2*fd**2*g2*s + 504*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 252*D1**2*Pkdd2*f**3*fd*k1**2*s + 126*D1**2*Pkdd2*f**3*fd*k1**2 - 252*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 126*D1**2*Pkdd2*f**3*fdd*k1**2*s - 63*D1**2*Pkdd2*f**3*fdd*k1**2 - 756*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 378*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 4928*D1*Dd*Pk2*f**4*r*s + 1232*D1*Dd*Pk2*f**4*r + 2464*D1*Dd*Pk2*f**4*s + 39424*D1*Dd*Pk2*f**3*fd*r*s - 9856*D1*Dd*Pk2*f**3*fd*r - 19712*D1*Dd*Pk2*f**3*fd*s + 4928*D1*Dd*Pk2*f**3*fd + 4224*D1*Dd*Pk2*f**3*r*s - 1056*D1*Dd*Pk2*f**3*r - 704*D1*Dd*Pk2*f**3*s**2 - 1760*D1*Dd*Pk2*f**3*s - 176*D1*Dd*Pk2*f**3 - 12672*D1*Dd*Pk2*f**2*fd*r*s + 3696*D1*Dd*Pk2*f**2*fd*r + 2112*D1*Dd*Pk2*f**2*fd*s**2 + 4048*D1*Dd*Pk2*f**2*fd*s - 1408*D1*Dd*Pk2*f**2*fd + 25344*D1*Dd*Pk2*f**2*g2*r*s - 6336*D1*Dd*Pk2*f**2*g2*r - 25344*D1*Dd*Pk2*f**2*g2*s**2 - 6336*D1*Dd*Pk2*f**2*g2 - 25344*D1*Dd*Pk2*f**2*gd2*r*s + 3168*D1*Dd*Pk2*f**2*gd2*r + 25344*D1*Dd*Pk2*f**2*gd2*s**2 + 12672*D1*Dd*Pk2*f**2*gd2*s - 3168*D1*Dd*Pk2*f**2*gd2 - 50688*D1*Dd*Pk2*f*fd*g2*r*s + 19008*D1*Dd*Pk2*f*fd*g2*r + 50688*D1*Dd*Pk2*f*fd*g2*s**2 - 25344*D1*Dd*Pk2*f*fd*g2*s + 504*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 252*D1*Dd*Pkdd2*f**4*k1**2*s + 126*D1*Dd*Pkdd2*f**4*k1**2 - 2016*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 1008*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 126*D1*Dd*Pkdd2*f**3*fd*k1**2 + 4928*D1*Ddd*Pk2*f**4*r*s - 1232*D1*Ddd*Pk2*f**4*r - 2464*D1*Ddd*Pk2*f**4*s - 2112*D1*Ddd*Pk2*f**3*r*s + 528*D1*Ddd*Pk2*f**3*r + 352*D1*Ddd*Pk2*f**3*s**2 + 880*D1*Ddd*Pk2*f**3*s + 88*D1*Ddd*Pk2*f**3 - 12672*D1*Ddd*Pk2*f**2*g2*r*s + 3168*D1*Ddd*Pk2*f**2*g2*r + 12672*D1*Ddd*Pk2*f**2*g2*s**2 + 3168*D1*Ddd*Pk2*f**2*g2 - 252*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 126*D1*Ddd*Pkdd2*f**4*k1**2*s - 63*D1*Ddd*Pkdd2*f**4*k1**2 + 176*D1*Pk2*bd1*f*(-7*D1*f*fd*(r*(6*s - 1) + 3*s**2 - 5*s + 1) + D1*f*s*(9*K*(-2*r + 2*s + 2) + 7*f*(2*r + s - 2) + 36*r + 9*s - 36) + 9*D1*fd*(K*r*(4*s - 1) - 4*K*s**2 + K + r*(2 - 8*s) - 2*s**2 + 5*s - 2) - 7*Dd*f**2*(r*(8*s - 1) + 4*s**2 - 7*s + 1) + 9*Dd*f*(-K*(-8*r*s + r + 8*s**2 + 4*s - 1) + r*(2 - 16*s) - 4*s**2 + 13*s - 2)) + 14784*Dd**2*Pk2*f**4*r*s - 3696*Dd**2*Pk2*f**4*r - 7392*Dd**2*Pk2*f**4*s + 2464*Dd**2*Pk2*f**4 - 6336*Dd**2*Pk2*f**3*r*s + 1584*Dd**2*Pk2*f**3*r + 1056*Dd**2*Pk2*f**3*s**2 + 2640*Dd**2*Pk2*f**3*s - 1056*Dd**2*Pk2*f**3 - 38016*Dd**2*Pk2*f**2*g2*r*s + 9504*Dd**2*Pk2*f**2*g2*r + 38016*Dd**2*Pk2*f**2*g2*s**2 - 6336*Dd**2*Pk2*f**2*g2 - 756*Dd**2*Pkdd2*f**4*k1**2*s**2 + 378*Dd**2*Pkdd2*f**4*k1**2*s + 88*Pk2*b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s - 1)*(2*r + s - 1) + f*(-14*fd**2*(3*s - 1)*(2*r + s - 1) - 18*fd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) - 8*r*s + 4*r - 2*s**2 + 2*s - 1) + 9*fdd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) - 8*r*s + 4*r - 2*s**2 + 2*s - 1)) + 18*fd**2*(r*(K - 2)*(2*s - 1) - s*(2*K + 1)*(s - 1))) + D1*f*(2*Dd*(7*f**2*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + f*(18*K*(-4*r*s + r + 4*s**2 + 1) - 7*fd*(r*(24*s - 7) + 12*s**2 - 17*s + 4) + 144*r*s - 36*r + 36*s**2 - 90*s + 9) + 9*fd*(r*(2*K - 4)*(8*s - 3) - (2*s - 1)*(8*K*s + 4*s - 5))) - Ddd*f*(18*K*(-4*r*s + r + 4*s**2 + 1) + 7*f*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + 144*r*s - 36*r + 36*s**2 - 90*s + 9)) - 2*Dd**2*f**2*(-9*K*(12*r*s - 3*r - 12*s**2 + 2) + 7*f*(3*r*(4*s - 1) + 6*s**2 - 9*s + 2) + 216*r*s - 54*r + 54*s**2 - 135*s + 36)))/(1386*d**2*k3**4) - D1**2*Pk3*ct*k1*k2*st**4*(48*C*D1**2*Pk2*bdd1*f**2*r**2 - 48*C*D1**2*Pk2*bdd1*f**2*r - 96*C*D1**2*Pk2*bdd1*f**2*s**2 + 480*C*D1**2*Pk2*f**2*fd*r**2 - 1872*C*D1**2*Pk2*f**2*fd*r*s + 304*C*D1**2*Pk2*f**2*fd*r - 2424*C*D1**2*Pk2*f**2*fd*s**2 + 2240*C*D1**2*Pk2*f**2*fd*s - 648*C*D1**2*Pk2*f**2*fd - 456*C*D1**2*Pk2*f**2*fdd*r**2 + 1296*C*D1**2*Pk2*f**2*fdd*r*s - 128*C*D1**2*Pk2*f**2*fdd*r + 1608*C*D1**2*Pk2*f**2*fdd*s**2 - 1504*C*D1**2*Pk2*f**2*fdd*s + 384*C*D1**2*Pk2*f**2*fdd - 912*C*D1**2*Pk2*f*fd**2*r**2 + 2592*C*D1**2*Pk2*f*fd**2*r*s - 256*C*D1**2*Pk2*f*fd**2*r + 3216*C*D1**2*Pk2*f*fd**2*s**2 - 3008*C*D1**2*Pk2*f*fd**2*s + 432*C*D1**2*Pk2*f*fd**2 + 24*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 16*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 8*C*D1**2*Pkdd2*f**2*fd*k1**2 - 12*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 8*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 4*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 24*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 16*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 640*C*D1*Dd*Pk2*f**3*r**2 - 2496*C*D1*Dd*Pk2*f**3*r*s - 16*C*D1*Dd*Pk2*f**3*r - 3232*C*D1*Dd*Pk2*f**3*s**2 + 2864*C*D1*Dd*Pk2*f**3*s - 488*C*D1*Dd*Pk2*f**3 - 3648*C*D1*Dd*Pk2*f**2*fd*r**2 + 10368*C*D1*Dd*Pk2*f**2*fd*r*s + 16*C*D1*Dd*Pk2*f**2*fd*r + 12864*C*D1*Dd*Pk2*f**2*fd*s**2 - 11824*C*D1*Dd*Pk2*f**2*fd*s + 1760*C*D1*Dd*Pk2*f**2*fd + 32*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 16*C*D1*Dd*Pkdd2*f**3*k1**2*s + 8*C*D1*Dd*Pkdd2*f**3*k1**2 - 96*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 56*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 8*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 608*C*D1*Ddd*Pk2*f**3*r**2 + 1728*C*D1*Ddd*Pk2*f**3*r*s + 176*C*D1*Ddd*Pk2*f**3*r + 2144*C*D1*Ddd*Pk2*f**3*s**2 - 1936*C*D1*Ddd*Pk2*f**3*s + 232*C*D1*Ddd*Pk2*f**3 - 16*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 8*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 4*C*D1*Ddd*Pkdd2*f**3*k1**2 - 1824*C*Dd**2*Pk2*f**3*r**2 + 5184*C*Dd**2*Pk2*f**3*r*s + 528*C*Dd**2*Pk2*f**3*r + 6432*C*Dd**2*Pk2*f**3*s**2 - 5808*C*Dd**2*Pk2*f**3*s + 560*C*Dd**2*Pk2*f**3 - 48*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 24*C*Dd**2*Pkdd2*f**3*k1**2*s - 228*D1**2*K*Pk2*bdd1*f**2*r**2 + 456*D1**2*K*Pk2*bdd1*f**2*r*s + 456*D1**2*K*Pk2*bdd1*f**2*r + 1236*D1**2*K*Pk2*bdd1*f**2*s**2 - 456*D1**2*K*Pk2*bdd1*f**2*s - 228*D1**2*K*Pk2*bdd1*f**2 - 6*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 1104*D1**2*Pk2*b2*f*fd*r*s + 552*D1**2*Pk2*b2*f*fd*r - 1104*D1**2*Pk2*b2*f*fd*s**2 + 1104*D1**2*Pk2*b2*f*fd*s - 552*D1**2*Pk2*b2*f*fd + 720*D1**2*Pk2*b2*f*fdd*r*s - 360*D1**2*Pk2*b2*f*fdd*r + 720*D1**2*Pk2*b2*f*fdd*s**2 - 720*D1**2*Pk2*b2*f*fdd*s + 360*D1**2*Pk2*b2*f*fdd + 720*D1**2*Pk2*b2*fd**2*r*s - 360*D1**2*Pk2*b2*fd**2*r + 720*D1**2*Pk2*b2*fd**2*s**2 - 720*D1**2*Pk2*b2*fd**2*s + 24*D1**2*Pk2*bd1**2*f*(7*K*(2*r**2 - 3*r - 4*s**2 + 1) + 5*f*(r + 2*s - 1) - (14*r - 14)*(r + 2*s - 1)) - 552*D1**2*Pk2*bd2*f**2*r*s - 552*D1**2*Pk2*bd2*f**2*s**2 + 552*D1**2*Pk2*bd2*f**2*s + 1440*D1**2*Pk2*bd2*f*fd*r*s - 360*D1**2*Pk2*bd2*f*fd*r + 1440*D1**2*Pk2*bd2*f*fd*s**2 - 1440*D1**2*Pk2*bd2*f*fd*s + 360*D1**2*Pk2*bd2*f*fd + 450*D1**2*Pk2*bdd1*f**3*r**2 + 540*D1**2*Pk2*bdd1*f**3*r*s - 780*D1**2*Pk2*bdd1*f**3*r - 300*D1**2*Pk2*bdd1*f**3*s + 330*D1**2*Pk2*bdd1*f**3 + 570*D1**2*Pk2*bdd1*f**2*r**2 + 972*D1**2*Pk2*bdd1*f**2*r*s - 1164*D1**2*Pk2*bdd1*f**2*r + 48*D1**2*Pk2*bdd1*f**2*s**2 - 972*D1**2*Pk2*bdd1*f**2*s + 594*D1**2*Pk2*bdd1*f**2 - 336*D1**2*Pk2*bdd1*f*g2*r**2 + 336*D1**2*Pk2*bdd1*f*g2*r + 672*D1**2*Pk2*bdd1*f*g2*s**2 + 360*D1**2*Pk2*bdd2*f**2*r*s + 360*D1**2*Pk2*bdd2*f**2*s**2 - 360*D1**2*Pk2*bdd2*f**2*s + 1080*D1**2*Pk2*f**3*fd*r**2 + 1440*D1**2*Pk2*f**3*fd*r*s - 1440*D1**2*Pk2*f**3*fd*r - 720*D1**2*Pk2*f**3*fd*s + 540*D1**2*Pk2*f**3*fd - 1080*D1**2*Pk2*f**3*fdd*r**2 - 1440*D1**2*Pk2*f**3*fdd*r*s + 1440*D1**2*Pk2*f**3*fdd*r + 720*D1**2*Pk2*f**3*fdd*s - 540*D1**2*Pk2*f**3*fdd - 3240*D1**2*Pk2*f**2*fd**2*r**2 - 4320*D1**2*Pk2*f**2*fd**2*r*s + 4320*D1**2*Pk2*f**2*fd**2*r + 2160*D1**2*Pk2*f**2*fd**2*s - 1260*D1**2*Pk2*f**2*fd**2 - 1002*D1**2*Pk2*f**2*fd*r**2 - 12*D1**2*Pk2*f**2*fd*r*s + 672*D1**2*Pk2*f**2*fd*r + 1140*D1**2*Pk2*f**2*fd*s**2 - 756*D1**2*Pk2*f**2*fd*s + 46*D1**2*Pk2*f**2*fd + 870*D1**2*Pk2*f**2*fdd*r**2 - 12*D1**2*Pk2*f**2*fdd*r*s - 576*D1**2*Pk2*f**2*fdd*r - 804*D1**2*Pk2*f**2*fdd*s**2 + 540*D1**2*Pk2*f**2*fdd*s + 22*D1**2*Pk2*f**2*fdd - 576*D1**2*Pk2*f**2*gd2*r**2 + 1488*D1**2*Pk2*f**2*gd2*r*s + 1152*D1**2*Pk2*f**2*gd2*r + 3096*D1**2*Pk2*f**2*gd2*s**2 - 1488*D1**2*Pk2*f**2*gd2*s - 576*D1**2*Pk2*f**2*gd2 + 456*D1**2*Pk2*f**2*gdd2*r**2 - 912*D1**2*Pk2*f**2*gdd2*r*s - 912*D1**2*Pk2*f**2*gdd2*r - 2472*D1**2*Pk2*f**2*gdd2*s**2 + 912*D1**2*Pk2*f**2*gdd2*s + 456*D1**2*Pk2*f**2*gdd2 + 1740*D1**2*Pk2*f*fd**2*r**2 - 24*D1**2*Pk2*f*fd**2*r*s - 1152*D1**2*Pk2*f*fd**2*r - 1608*D1**2*Pk2*f*fd**2*s**2 + 1080*D1**2*Pk2*f*fd**2*s - 4*D1**2*Pk2*f*fd**2 - 1152*D1**2*Pk2*f*fd*g2*r**2 + 2976*D1**2*Pk2*f*fd*g2*r*s - 1488*D1**2*Pk2*f*fd*g2*r + 6192*D1**2*Pk2*f*fd*g2*s**2 - 6192*D1**2*Pk2*f*fd*g2*s + 3096*D1**2*Pk2*f*fd*g2 + 1824*D1**2*Pk2*f*fd*gd2*r**2 - 3648*D1**2*Pk2*f*fd*gd2*r*s - 912*D1**2*Pk2*f*fd*gd2*r - 9888*D1**2*Pk2*f*fd*gd2*s**2 + 6768*D1**2*Pk2*f*fd*gd2*s - 912*D1**2*Pk2*f*fd*gd2 + 912*D1**2*Pk2*f*fdd*g2*r**2 - 1824*D1**2*Pk2*f*fdd*g2*r*s + 912*D1**2*Pk2*f*fdd*g2*r - 4944*D1**2*Pk2*f*fdd*g2*s**2 + 4944*D1**2*Pk2*f*fdd*g2*s - 2472*D1**2*Pk2*f*fdd*g2 + 912*D1**2*Pk2*fd**2*g2*r**2 - 1824*D1**2*Pk2*fd**2*g2*r*s + 912*D1**2*Pk2*fd**2*g2*r - 4944*D1**2*Pk2*fd**2*g2*s**2 + 4944*D1**2*Pk2*fd**2*g2*s + 30*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 15*D1**2*Pkdd2*bdd1*f**3*k1**2 + 3*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 60*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 30*D1**2*Pkdd2*f**3*fd*k1**2*s - 15*D1**2*Pkdd2*f**3*fd*k1**2 - 18*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 12*D1**2*Pkdd2*f**2*fd*k1**2*s - 6*D1**2*Pkdd2*f**2*fd*k1**2 + 9*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 6*D1**2*Pkdd2*f**2*fdd*k1**2*s + 3*D1**2*Pkdd2*f**2*fdd*k1**2 - 24*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 12*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 18*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 12*D1**2*Pkdd2*f*fd**2*k1**2*s - 48*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 48*D1**2*Pkdd2*f*fd*g2*k1**2*s - 24*D1**2*Pkdd2*f*fd*g2*k1**2 + 48*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 24*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 24*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 24*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 12*D1**2*Pkdd2*f*fdd*g2*k1**2 + 24*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 24*D1**2*Pkdd2*fd**2*g2*k1**2*s - 2208*D1*Dd*Pk2*b2*f**2*r*s + 552*D1*Dd*Pk2*b2*f**2*r - 2208*D1*Dd*Pk2*b2*f**2*s**2 + 2208*D1*Dd*Pk2*b2*f**2*s - 552*D1*Dd*Pk2*b2*f**2 + 5760*D1*Dd*Pk2*b2*f*fd*r*s - 2160*D1*Dd*Pk2*b2*f*fd*r + 5760*D1*Dd*Pk2*b2*f*fd*s**2 - 5760*D1*Dd*Pk2*b2*f*fd*s + 1440*D1*Dd*Pk2*b2*f*fd + 2880*D1*Dd*Pk2*bd2*f**2*r*s - 360*D1*Dd*Pk2*bd2*f**2*r + 2880*D1*Dd*Pk2*bd2*f**2*s**2 - 2880*D1*Dd*Pk2*bd2*f**2*s + 360*D1*Dd*Pk2*bd2*f**2 + 1080*D1*Dd*Pk2*f**4*r**2 + 1440*D1*Dd*Pk2*f**4*r*s - 1440*D1*Dd*Pk2*f**4*r - 720*D1*Dd*Pk2*f**4*s + 540*D1*Dd*Pk2*f**4 - 8640*D1*Dd*Pk2*f**3*fd*r**2 - 11520*D1*Dd*Pk2*f**3*fd*r*s + 11520*D1*Dd*Pk2*f**3*fd*r + 5760*D1*Dd*Pk2*f**3*fd*s - 3600*D1*Dd*Pk2*f**3*fd - 1336*D1*Dd*Pk2*f**3*r**2 - 16*D1*Dd*Pk2*f**3*r*s + 1340*D1*Dd*Pk2*f**3*r + 1520*D1*Dd*Pk2*f**3*s**2 - 752*D1*Dd*Pk2*f**3*s - 288*D1*Dd*Pk2*f**3 + 6960*D1*Dd*Pk2*f**2*fd*r**2 - 96*D1*Dd*Pk2*f**2*fd*r*s - 5772*D1*Dd*Pk2*f**2*fd*r - 6432*D1*Dd*Pk2*f**2*fd*s**2 + 3792*D1*Dd*Pk2*f**2*fd*s + 612*D1*Dd*Pk2*f**2*fd - 2304*D1*Dd*Pk2*f**2*g2*r**2 + 5952*D1*Dd*Pk2*f**2*g2*r*s + 816*D1*Dd*Pk2*f**2*g2*r + 12384*D1*Dd*Pk2*f**2*g2*s**2 - 9168*D1*Dd*Pk2*f**2*g2*s + 1944*D1*Dd*Pk2*f**2*g2 + 3648*D1*Dd*Pk2*f**2*gd2*r**2 - 7296*D1*Dd*Pk2*f**2*gd2*r*s - 4560*D1*Dd*Pk2*f**2*gd2*r - 19776*D1*Dd*Pk2*f**2*gd2*s**2 + 10416*D1*Dd*Pk2*f**2*gd2*s + 912*D1*Dd*Pk2*f**2*gd2 + 7296*D1*Dd*Pk2*f*fd*g2*r**2 - 14592*D1*Dd*Pk2*f*fd*g2*r*s + 1824*D1*Dd*Pk2*f*fd*g2*r - 39552*D1*Dd*Pk2*f*fd*g2*s**2 + 33312*D1*Dd*Pk2*f*fd*g2*s - 6768*D1*Dd*Pk2*f*fd*g2 - 60*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 30*D1*Dd*Pkdd2*f**4*k1**2*s - 15*D1*Dd*Pkdd2*f**4*k1**2 - 24*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 12*D1*Dd*Pkdd2*f**3*k1**2*s - 6*D1*Dd*Pkdd2*f**3*k1**2 + 72*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 42*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 6*D1*Dd*Pkdd2*f**2*fd*k1**2 - 96*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 48*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 24*D1*Dd*Pkdd2*f**2*g2*k1**2 + 96*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 24*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 192*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 144*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 24*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 1440*D1*Ddd*Pk2*b2*f**2*r*s - 360*D1*Ddd*Pk2*b2*f**2*r + 1440*D1*Ddd*Pk2*b2*f**2*s**2 - 1440*D1*Ddd*Pk2*b2*f**2*s + 360*D1*Ddd*Pk2*b2*f**2 - 1080*D1*Ddd*Pk2*f**4*r**2 - 1440*D1*Ddd*Pk2*f**4*r*s + 1440*D1*Ddd*Pk2*f**4*r + 720*D1*Ddd*Pk2*f**4*s - 540*D1*Ddd*Pk2*f**4 + 1160*D1*Ddd*Pk2*f**3*r**2 - 16*D1*Ddd*Pk2*f**3*r*s - 1156*D1*Ddd*Pk2*f**3*r - 1072*D1*Ddd*Pk2*f**3*s**2 + 544*D1*Ddd*Pk2*f**3*s + 312*D1*Ddd*Pk2*f**3 + 1824*D1*Ddd*Pk2*f**2*g2*r**2 - 3648*D1*Ddd*Pk2*f**2*g2*r*s - 912*D1*Ddd*Pk2*f**2*g2*r - 9888*D1*Ddd*Pk2*f**2*g2*s**2 + 6768*D1*Ddd*Pk2*f**2*g2*s - 1560*D1*Ddd*Pk2*f**2*g2 + 12*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 6*D1*Ddd*Pkdd2*f**3*k1**2*s + 3*D1*Ddd*Pkdd2*f**3*k1**2 + 48*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 24*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 12*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 6*D1*bd1*(D1*(56*Pk2*f*(2*g2*(-r**2 + r + 2*s**2) + gd2*(2*r**2 - 3*r - 4*s**2 + 1)) + 112*Pk2*fd*g2*(r**2 - s*(2*s - 2)) + 5*f**3*(Pk2*(13*r**2 + 22*r*(s - 1) + 4*s**2 - 14*s + 9) + Pkdd2*k1**2*(2*s - 1)) + f**2*(Pk2*(16*C*r**2 - 16*C*r - 32*C*s**2 - 2*K*(24*r**2 - 62*r*s - 48*r - 129*s**2 + 62*s + 24) - 10*fd*(45*r**2 + r*(54*s - 65) - 28*s + 20) + 99*r**2 + 198*r*s - 206*r + 44*s**2 - 198*s + 107) + Pkdd2*k1**2*s*(-2*K*s - 10*fd + s)) - f*fd*(2*Pk2*(4*C*(4*r**2 - 3*r - 8*s**2 + 4*s + 1) + K*(-76*r**2 + 38*r*(4*s + 1) + 412*s**2 - 282*s + 38) + 190*r**2 + 324*r*s - 273*r + 16*s**2 - 170*s + 79) + Pkdd2*k1**2*s*(K*(2 - 4*s) + 2*s - 1))) - Dd*f*(-112*Pk2*g2*(4*r**2 - 4*r - 8*s**2 + 2*s + 1) + 5*f**2*(2*Pk2*(60*r**2 + r*(72*s - 91) - 38*s + 31) + Pkdd2*k1**2*(4*s - 1)) + f*(2*Pk2*(8*C*(4*r**2 - 4*r - 8*s**2 + 2*s + 1) - 2*K*(76*r**2 - 19*r*(8*s + 5) - 412*s**2 + 217*s + 19) + 380*r**2 + 648*r*s - 659*r + 32*s**2 - 494*s + 275) + Pkdd2*k1**2*s*(K*(2 - 8*s) + 4*s - 1)))) + 4320*Dd**2*Pk2*b2*f**2*r*s - 1080*Dd**2*Pk2*b2*f**2*r + 4320*Dd**2*Pk2*b2*f**2*s**2 - 4320*Dd**2*Pk2*b2*f**2*s + 720*Dd**2*Pk2*b2*f**2 - 3240*Dd**2*Pk2*f**4*r**2 - 4320*Dd**2*Pk2*f**4*r*s + 4320*Dd**2*Pk2*f**4*r + 2160*Dd**2*Pk2*f**4*s - 1260*Dd**2*Pk2*f**4 + 3480*Dd**2*Pk2*f**3*r**2 - 48*Dd**2*Pk2*f**3*r*s - 3468*Dd**2*Pk2*f**3*r - 3216*Dd**2*Pk2*f**3*s**2 + 1632*Dd**2*Pk2*f**3*s + 572*Dd**2*Pk2*f**3 + 5472*Dd**2*Pk2*f**2*g2*r**2 - 10944*Dd**2*Pk2*f**2*g2*r*s - 2736*Dd**2*Pk2*f**2*g2*r - 29664*Dd**2*Pk2*f**2*g2*s**2 + 20304*Dd**2*Pk2*f**2*g2*s - 912*Dd**2*Pk2*f**2*g2 + 36*Dd**2*Pkdd2*f**3*k1**2*s**2 - 18*Dd**2*Pkdd2*f**3*k1**2*s + 144*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 72*Dd**2*Pkdd2*f**2*g2*k1**2*s + 24*Pk2*b1**2*(D1**2*(-5*fd**2*(r + 2*s - 1) + 2*fd*(-7*K*(r**2 + r - 2*(s - 1)**2) + 5*f*(r + 2*s - 1) + (7*r + 7)*(r + 2*s - 1)) - fdd*(-7*K*(r**2 + r - 2*(s - 1)**2) + 5*f*(r + 2*s - 1) + (7*r + 7)*(r + 2*s - 1))) - 2*D1*(Dd*(-7*K*fd*(4*r**2 - 8*s**2 + 10*s - 3) + 2*f*(5*fd*(r + 2*s - 1) + r**2*(14*K - 14) - 7*r*(2*K + 4*s - 3) - (14*s - 7)*(2*K*s - 1)) + 7*fd*(4*r + 1)*(r + 2*s - 1)) - 7*Ddd*f*(r**2*(2*K - 2) + r*(-2*K - 4*s + 3) - (2*s - 1)*(2*K*s - 1))) + 14*Dd**2*f*(K*(6*r**2 - 6*r - 12*s**2 + 6*s + 1) + (3 - 6*r)*(r + 2*s - 1))) - 3*b1*(64*C*D1**2*Pk2*f*fd*r**2 - 32*C*D1**2*Pk2*f*fd*r - 128*C*D1**2*Pk2*f*fd*s**2 + 128*C*D1**2*Pk2*f*fd*s - 32*C*D1**2*Pk2*f*fd - 32*C*D1**2*Pk2*f*fdd*r**2 + 16*C*D1**2*Pk2*f*fdd*r + 64*C*D1**2*Pk2*f*fdd*s**2 - 64*C*D1**2*Pk2*f*fdd*s + 16*C*D1**2*Pk2*f*fdd - 32*C*D1**2*Pk2*fd**2*r**2 + 16*C*D1**2*Pk2*fd**2*r + 64*C*D1**2*Pk2*fd**2*s**2 - 64*C*D1**2*Pk2*fd**2*s + 16*C*D1**2*Pk2*fd**2 + 128*C*D1*Dd*Pk2*f**2*r**2 - 128*C*D1*Dd*Pk2*f**2*r - 256*C*D1*Dd*Pk2*f**2*s**2 + 128*C*D1*Dd*Pk2*f**2*s - 256*C*D1*Dd*Pk2*f*fd*r**2 + 192*C*D1*Dd*Pk2*f*fd*r + 512*C*D1*Dd*Pk2*f*fd*s**2 - 384*C*D1*Dd*Pk2*f*fd*s + 32*C*D1*Dd*Pk2*f*fd - 64*C*D1*Ddd*Pk2*f**2*r**2 + 64*C*D1*Ddd*Pk2*f**2*r + 128*C*D1*Ddd*Pk2*f**2*s**2 - 64*C*D1*Ddd*Pk2*f**2*s - 192*C*Dd**2*Pk2*f**2*r**2 + 192*C*Dd**2*Pk2*f**2*r + 384*C*Dd**2*Pk2*f**2*s**2 - 192*C*Dd**2*Pk2*f**2*s - 32*C*Dd**2*Pk2*f**2 - 192*D1**2*K*Pk2*f*fd*r**2 + 496*D1**2*K*Pk2*f*fd*r*s - 248*D1**2*K*Pk2*f*fd*r + 1032*D1**2*K*Pk2*f*fd*s**2 - 1032*D1**2*K*Pk2*f*fd*s + 516*D1**2*K*Pk2*f*fd + 152*D1**2*K*Pk2*f*fdd*r**2 - 304*D1**2*K*Pk2*f*fdd*r*s + 152*D1**2*K*Pk2*f*fdd*r - 824*D1**2*K*Pk2*f*fdd*s**2 + 824*D1**2*K*Pk2*f*fdd*s - 412*D1**2*K*Pk2*f*fdd + 152*D1**2*K*Pk2*fd**2*r**2 - 304*D1**2*K*Pk2*fd**2*r*s + 152*D1**2*K*Pk2*fd**2*r - 824*D1**2*K*Pk2*fd**2*s**2 + 824*D1**2*K*Pk2*fd**2*s - 8*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 8*D1**2*K*Pkdd2*f*fd*k1**2*s - 4*D1**2*K*Pkdd2*f*fd*k1**2 + 4*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 4*D1**2*K*Pkdd2*f*fdd*k1**2*s + 2*D1**2*K*Pkdd2*f*fdd*k1**2 + 4*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 4*D1**2*K*Pkdd2*fd**2*k1**2*s - 8*D1**2*Pk2*bdd1*f*(7*K*(2*r**2 - 3*r - 4*s**2 + 1) + 5*f*(r + 2*s - 1) - (14*r - 14)*(r + 2*s - 1)) + 390*D1**2*Pk2*f**2*fd*r**2 + 660*D1**2*Pk2*f**2*fd*r*s - 520*D1**2*Pk2*f**2*fd*r + 120*D1**2*Pk2*f**2*fd*s**2 - 380*D1**2*Pk2*f**2*fd*s + 210*D1**2*Pk2*f**2*fd - 450*D1**2*Pk2*f**2*fdd*r**2 - 540*D1**2*Pk2*f**2*fdd*r*s + 520*D1**2*Pk2*f**2*fdd*r + 260*D1**2*Pk2*f**2*fdd*s - 190*D1**2*Pk2*f**2*fdd - 900*D1**2*Pk2*f*fd**2*r**2 - 1080*D1**2*Pk2*f*fd**2*r*s + 1040*D1**2*Pk2*f*fd**2*r + 520*D1**2*Pk2*f*fd**2*s - 260*D1**2*Pk2*f*fd**2 + 396*D1**2*Pk2*f*fd*r**2 + 792*D1**2*Pk2*f*fd*r*s - 380*D1**2*Pk2*f*fd*r + 176*D1**2*Pk2*f*fd*s**2 - 176*D1**2*Pk2*f*fd*s + 72*D1**2*Pk2*f*fd - 380*D1**2*Pk2*f*fdd*r**2 - 648*D1**2*Pk2*f*fdd*r*s + 316*D1**2*Pk2*f*fdd*r - 32*D1**2*Pk2*f*fdd*s**2 + 32*D1**2*Pk2*f*fdd*s - 8*D1**2*Pk2*f*fdd - 224*D1**2*Pk2*f*gd2*r**2 + 448*D1**2*Pk2*f*gd2*r + 448*D1**2*Pk2*f*gd2*s**2 - 224*D1**2*Pk2*f*gd2 + 112*D1**2*Pk2*f*gdd2*r**2 - 224*D1**2*Pk2*f*gdd2*r - 224*D1**2*Pk2*f*gdd2*s**2 + 112*D1**2*Pk2*f*gdd2 - 380*D1**2*Pk2*fd**2*r**2 - 648*D1**2*Pk2*fd**2*r*s + 316*D1**2*Pk2*fd**2*r - 32*D1**2*Pk2*fd**2*s**2 + 32*D1**2*Pk2*fd**2*s - 8*D1**2*Pk2*fd**2 - 224*D1**2*Pk2*fd*g2*r**2 - 224*D1**2*Pk2*fd*g2*r + 448*D1**2*Pk2*fd*g2*s**2 - 896*D1**2*Pk2*fd*g2*s + 448*D1**2*Pk2*fd*g2 + 224*D1**2*Pk2*fd*gd2*r**2 - 112*D1**2*Pk2*fd*gd2*r - 448*D1**2*Pk2*fd*gd2*s**2 + 448*D1**2*Pk2*fd*gd2*s - 112*D1**2*Pk2*fd*gd2 + 112*D1**2*Pk2*fdd*g2*r**2 + 112*D1**2*Pk2*fdd*g2*r - 224*D1**2*Pk2*fdd*g2*s**2 + 448*D1**2*Pk2*fdd*g2*s - 224*D1**2*Pk2*fdd*g2 - 20*D1**2*Pkdd2*f**2*fd*k1**2*s + 10*D1**2*Pkdd2*f**2*fd*k1**2 + 10*D1**2*Pkdd2*f**2*fdd*k1**2*s - 5*D1**2*Pkdd2*f**2*fdd*k1**2 + 20*D1**2*Pkdd2*f*fd**2*k1**2*s + 4*D1**2*Pkdd2*f*fd*k1**2*s**2 - 4*D1**2*Pkdd2*f*fd*k1**2*s + 2*D1**2*Pkdd2*f*fd*k1**2 - 2*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 2*D1**2*Pkdd2*f*fdd*k1**2*s - D1**2*Pkdd2*f*fdd*k1**2 - 2*D1**2*Pkdd2*fd**2*k1**2*s**2 + 2*D1**2*Pkdd2*fd**2*k1**2*s - 384*D1*Dd*K*Pk2*f**2*r**2 + 992*D1*Dd*K*Pk2*f**2*r*s + 136*D1*Dd*K*Pk2*f**2*r + 2064*D1*Dd*K*Pk2*f**2*s**2 - 1528*D1*Dd*K*Pk2*f**2*s + 324*D1*Dd*K*Pk2*f**2 + 1216*D1*Dd*K*Pk2*f*fd*r**2 - 2432*D1*Dd*K*Pk2*f*fd*r*s + 304*D1*Dd*K*Pk2*f*fd*r - 6592*D1*Dd*K*Pk2*f*fd*s**2 + 5552*D1*Dd*K*Pk2*f*fd*s - 1128*D1*Dd*K*Pk2*f*fd - 16*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 8*D1*Dd*K*Pkdd2*f**2*k1**2*s - 4*D1*Dd*K*Pkdd2*f**2*k1**2 + 32*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 24*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 4*D1*Dd*K*Pkdd2*f*fd*k1**2 + 520*D1*Dd*Pk2*f**3*r**2 + 880*D1*Dd*Pk2*f**3*r*s - 740*D1*Dd*Pk2*f**3*r + 160*D1*Dd*Pk2*f**3*s**2 - 520*D1*Dd*Pk2*f**3*s + 300*D1*Dd*Pk2*f**3 - 3600*D1*Dd*Pk2*f**2*fd*r**2 - 4320*D1*Dd*Pk2*f**2*fd*r*s + 4420*D1*Dd*Pk2*f**2*fd*r + 2120*D1*Dd*Pk2*f**2*fd*s - 1300*D1*Dd*Pk2*f**2*fd + 792*D1*Dd*Pk2*f**2*r**2 + 1584*D1*Dd*Pk2*f**2*r*s - 1188*D1*Dd*Pk2*f**2*r + 352*D1*Dd*Pk2*f**2*s**2 - 968*D1*Dd*Pk2*f**2*s + 484*D1*Dd*Pk2*f**2 - 3040*D1*Dd*Pk2*f*fd*r**2 - 5184*D1*Dd*Pk2*f*fd*r*s + 3432*D1*Dd*Pk2*f*fd*r - 256*D1*Dd*Pk2*f*fd*s**2 + 1488*D1*Dd*Pk2*f*fd*s - 664*D1*Dd*Pk2*f*fd - 896*D1*Dd*Pk2*f*g2*r**2 + 896*D1*Dd*Pk2*f*g2*r + 1792*D1*Dd*Pk2*f*g2*s**2 - 896*D1*Dd*Pk2*f*g2*s + 896*D1*Dd*Pk2*f*gd2*r**2 - 1344*D1*Dd*Pk2*f*gd2*r - 1792*D1*Dd*Pk2*f*gd2*s**2 + 448*D1*Dd*Pk2*f*gd2*s + 448*D1*Dd*Pk2*f*gd2 + 896*D1*Dd*Pk2*fd*g2*r**2 - 1792*D1*Dd*Pk2*fd*g2*s**2 + 2240*D1*Dd*Pk2*fd*g2*s - 672*D1*Dd*Pk2*fd*g2 + 40*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 10*D1*Dd*Pkdd2*f**2*fd*k1**2 + 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**2*k1**2*s + 2*D1*Dd*Pkdd2*f**2*k1**2 - 16*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*Pkdd2*f*fd*k1**2*s - 2*D1*Dd*Pkdd2*f*fd*k1**2 + 304*D1*Ddd*K*Pk2*f**2*r**2 - 608*D1*Ddd*K*Pk2*f**2*r*s - 152*D1*Ddd*K*Pk2*f**2*r - 1648*D1*Ddd*K*Pk2*f**2*s**2 + 1128*D1*Ddd*K*Pk2*f**2*s - 260*D1*Ddd*K*Pk2*f**2 + 8*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 4*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 2*D1*Ddd*K*Pkdd2*f**2*k1**2 - 600*D1*Ddd*Pk2*f**3*r**2 - 720*D1*Ddd*Pk2*f**3*r*s + 780*D1*Ddd*Pk2*f**3*r + 360*D1*Ddd*Pk2*f**3*s - 300*D1*Ddd*Pk2*f**3 - 760*D1*Ddd*Pk2*f**2*r**2 - 1296*D1*Ddd*Pk2*f**2*r*s + 1084*D1*Ddd*Pk2*f**2*r - 64*D1*Ddd*Pk2*f**2*s**2 + 680*D1*Ddd*Pk2*f**2*s - 396*D1*Ddd*Pk2*f**2 + 448*D1*Ddd*Pk2*f*g2*r**2 - 448*D1*Ddd*Pk2*f*g2*r - 896*D1*Ddd*Pk2*f*g2*s**2 + 448*D1*Ddd*Pk2*f*g2*s - 4*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**2*k1**2*s - D1*Ddd*Pkdd2*f**2*k1**2 + 8*D1*Pk2*bd1*(D1*(14*K*f*(2*r**2 - 3*r - 4*s**2 + 1) - 7*K*fd*(4*r**2 - r - 8*s**2 + 8*s - 1) + 10*f**2*(r + 2*s - 1) - 28*f*(r - 1)*(r + 2*s - 1) + 28*fd*r*(r + 2*s - 1)) - 2*Dd*f*(7*K*(8*r**2 - 10*r - 16*s**2 + 4*s + 3) + 10*f*(r + 2*s - 1) - (56*r - 42)*(r + 2*s - 1))) + 912*Dd**2*K*Pk2*f**2*r**2 - 1824*Dd**2*K*Pk2*f**2*r*s - 456*Dd**2*K*Pk2*f**2*r - 4944*Dd**2*K*Pk2*f**2*s**2 + 3384*Dd**2*K*Pk2*f**2*s - 152*Dd**2*K*Pk2*f**2 + 24*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 12*Dd**2*K*Pkdd2*f**2*k1**2*s - 1800*Dd**2*Pk2*f**3*r**2 - 2160*Dd**2*Pk2*f**3*r*s + 2340*Dd**2*Pk2*f**3*r + 1080*Dd**2*Pk2*f**3*s - 660*Dd**2*Pk2*f**3 - 2280*Dd**2*Pk2*f**2*r**2 - 3888*Dd**2*Pk2*f**2*r*s + 3252*Dd**2*Pk2*f**2*r - 192*Dd**2*Pk2*f**2*s**2 + 2040*Dd**2*Pk2*f**2*s - 1028*Dd**2*Pk2*f**2 + 1344*Dd**2*Pk2*f*g2*r**2 - 1344*Dd**2*Pk2*f*g2*r - 2688*Dd**2*Pk2*f*g2*s**2 + 1344*Dd**2*Pk2*f*g2*s + 224*Dd**2*Pk2*f*g2 - 12*Dd**2*Pkdd2*f**2*k1**2*s**2 + 6*Dd**2*Pkdd2*f**2*k1**2*s))/(210*d**2*k3**4) - D1**2*Pk3*ct*k1*k2*st**2*(48*C*D1**2*Pk2*bdd1*f**2*r**2 + 1344*C*D1**2*Pk2*bdd1*f**2*r*s + 912*C*D1**2*Pk2*bdd1*f**2*r + 1272*C*D1**2*Pk2*bdd1*f**2*s**2 + 7080*C*D1**2*Pk2*f**2*fd*r**2 + 28224*C*D1**2*Pk2*f**2*fd*r*s - 14128*C*D1**2*Pk2*f**2*fd*r + 14040*C*D1**2*Pk2*f**2*fd*s**2 - 18768*C*D1**2*Pk2*f**2*fd*s + 7040*C*D1**2*Pk2*f**2*fd - 8400*C*D1**2*Pk2*f**2*fdd*r**2 - 26208*C*D1**2*Pk2*f**2*fdd*r*s + 14336*C*D1**2*Pk2*f**2*fdd*r - 12744*C*D1**2*Pk2*f**2*fdd*s**2 + 17232*C*D1**2*Pk2*f**2*fdd*s - 7048*C*D1**2*Pk2*f**2*fdd - 16800*C*D1**2*Pk2*f*fd**2*r**2 - 52416*C*D1**2*Pk2*f*fd**2*r*s + 28672*C*D1**2*Pk2*f*fd**2*r - 25488*C*D1**2*Pk2*f*fd**2*s**2 + 34464*C*D1**2*Pk2*f*fd**2*s - 8736*C*D1**2*Pk2*f*fd**2 - 36*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 72*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 36*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 108*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 72*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 36*C*D1**2*Pkdd2*f**2*fd*k1**2 + 9440*C*D1*Dd*Pk2*f**3*r**2 + 37632*C*D1*Dd*Pk2*f**3*r*s - 18848*C*D1*Dd*Pk2*f**3*r + 18720*C*D1*Dd*Pk2*f**3*s**2 - 28176*C*D1*Dd*Pk2*f**3*s + 9400*C*D1*Dd*Pk2*f**3 - 67200*C*D1*Dd*Pk2*f**2*fd*r**2 - 209664*C*D1*Dd*Pk2*f**2*fd*r*s + 117152*C*D1*Dd*Pk2*f**2*fd*r - 101952*C*D1*Dd*Pk2*f**2*fd*s**2 + 146832*C*D1*Dd*Pk2*f**2*fd*s - 45904*C*D1*Dd*Pk2*f**2*fd - 144*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 72*C*D1*Dd*Pkdd2*f**3*k1**2*s - 36*C*D1*Dd*Pkdd2*f**3*k1**2 - 11200*C*D1*Ddd*Pk2*f**3*r**2 - 34944*C*D1*Ddd*Pk2*f**3*r*s + 19936*C*D1*Ddd*Pk2*f**3*r - 16992*C*D1*Ddd*Pk2*f**3*s**2 + 25968*C*D1*Ddd*Pk2*f**3*s - 9848*C*D1*Ddd*Pk2*f**3 - 33600*C*Dd**2*Pk2*f**3*r**2 - 104832*C*Dd**2*Pk2*f**3*r*s + 59808*C*Dd**2*Pk2*f**3*r - 50976*C*Dd**2*Pk2*f**3*s**2 + 77904*C*Dd**2*Pk2*f**3*s - 23072*C*Dd**2*Pk2*f**3 - 2184*D1**2*K*Pk2*bdd1*f**2*r**2 - 9072*D1**2*K*Pk2*bdd1*f**2*r*s + 4368*D1**2*K*Pk2*bdd1*f**2*r - 6300*D1**2*K*Pk2*bdd1*f**2*s**2 + 9072*D1**2*K*Pk2*bdd1*f**2*s - 2184*D1**2*K*Pk2*bdd1*f**2 + 1512*D1**2*Pk2*b2*f*fd*r**2 + 8064*D1**2*Pk2*b2*f*fd*r*s - 4032*D1**2*Pk2*b2*f*fd*r + 6552*D1**2*Pk2*b2*f*fd*s**2 - 6552*D1**2*Pk2*b2*f*fd*s + 3276*D1**2*Pk2*b2*f*fd - 2520*D1**2*Pk2*b2*f*fdd*r**2 - 8064*D1**2*Pk2*b2*f*fdd*r*s + 4032*D1**2*Pk2*b2*f*fdd*r - 5544*D1**2*Pk2*b2*f*fdd*s**2 + 5544*D1**2*Pk2*b2*f*fdd*s - 2772*D1**2*Pk2*b2*f*fdd - 2520*D1**2*Pk2*b2*fd**2*r**2 - 8064*D1**2*Pk2*b2*fd**2*r*s + 4032*D1**2*Pk2*b2*fd**2*r - 5544*D1**2*Pk2*b2*fd**2*s**2 + 5544*D1**2*Pk2*b2*fd**2*s + 756*D1**2*Pk2*bd2*f**2*r**2 + 4032*D1**2*Pk2*bd2*f**2*r*s - 1512*D1**2*Pk2*bd2*f**2*r + 3276*D1**2*Pk2*bd2*f**2*s**2 - 4032*D1**2*Pk2*bd2*f**2*s + 756*D1**2*Pk2*bd2*f**2 - 5040*D1**2*Pk2*bd2*f*fd*r**2 - 16128*D1**2*Pk2*bd2*f*fd*r*s + 9072*D1**2*Pk2*bd2*f*fd*r - 11088*D1**2*Pk2*bd2*f*fd*s**2 + 13608*D1**2*Pk2*bd2*f*fd*s - 4032*D1**2*Pk2*bd2*f*fd + 2016*D1**2*Pk2*bdd1*f**3*r*s - 1260*D1**2*Pk2*bdd1*f**3*r + 1260*D1**2*Pk2*bdd1*f**3*s**2 - 3024*D1**2*Pk2*bdd1*f**3*s + 1134*D1**2*Pk2*bdd1*f**3 + 1482*D1**2*Pk2*bdd1*f**2*r**2 + 2880*D1**2*Pk2*bdd1*f**2*r*s - 2976*D1**2*Pk2*bdd1*f**2*r + 1128*D1**2*Pk2*bdd1*f**2*s**2 - 3156*D1**2*Pk2*bdd1*f**2*s + 780*D1**2*Pk2*bdd1*f**2 + 336*D1**2*Pk2*bdd1*f*g2*r**2 - 4032*D1**2*Pk2*bdd1*f*g2*r*s - 3024*D1**2*Pk2*bdd1*f*g2*r - 5208*D1**2*Pk2*bdd1*f*g2*s**2 - 1260*D1**2*Pk2*bdd2*f**2*r**2 - 4032*D1**2*Pk2*bdd2*f**2*r*s + 2520*D1**2*Pk2*bdd2*f**2*r - 2772*D1**2*Pk2*bdd2*f**2*s**2 + 4032*D1**2*Pk2*bdd2*f**2*s - 1260*D1**2*Pk2*bdd2*f**2 - 3366*D1**2*Pk2*f**2*fd*r**2 - 17280*D1**2*Pk2*f**2*fd*r*s + 8004*D1**2*Pk2*f**2*fd*r - 8424*D1**2*Pk2*f**2*fd*s**2 + 11376*D1**2*Pk2*f**2*fd*s - 3930*D1**2*Pk2*f**2*fd + 5058*D1**2*Pk2*f**2*fdd*r**2 + 16632*D1**2*Pk2*f**2*fdd*r*s - 8916*D1**2*Pk2*f**2*fdd*r + 7776*D1**2*Pk2*f**2*fdd*s**2 - 10728*D1**2*Pk2*f**2*fdd*s + 4278*D1**2*Pk2*f**2*fdd - 2856*D1**2*Pk2*f**2*gd2*r**2 - 18144*D1**2*Pk2*f**2*gd2*r*s + 5712*D1**2*Pk2*f**2*gd2*r - 13608*D1**2*Pk2*f**2*gd2*s**2 + 18144*D1**2*Pk2*f**2*gd2*s - 2856*D1**2*Pk2*f**2*gd2 + 4368*D1**2*Pk2*f**2*gdd2*r**2 + 18144*D1**2*Pk2*f**2*gdd2*r*s - 8736*D1**2*Pk2*f**2*gdd2*r + 12600*D1**2*Pk2*f**2*gdd2*s**2 - 18144*D1**2*Pk2*f**2*gdd2*s + 4368*D1**2*Pk2*f**2*gdd2 + 10116*D1**2*Pk2*f*fd**2*r**2 + 33264*D1**2*Pk2*f*fd**2*r*s - 17832*D1**2*Pk2*f*fd**2*r + 15552*D1**2*Pk2*f*fd**2*s**2 - 21456*D1**2*Pk2*f*fd**2*s + 5544*D1**2*Pk2*f*fd**2 - 5712*D1**2*Pk2*f*fd*g2*r**2 - 36288*D1**2*Pk2*f*fd*g2*r*s + 18144*D1**2*Pk2*f*fd*g2*r - 27216*D1**2*Pk2*f*fd*g2*s**2 + 27216*D1**2*Pk2*f*fd*g2*s - 13608*D1**2*Pk2*f*fd*g2 + 17472*D1**2*Pk2*f*fd*gd2*r**2 + 72576*D1**2*Pk2*f*fd*gd2*r*s - 35616*D1**2*Pk2*f*fd*gd2*r + 50400*D1**2*Pk2*f*fd*gd2*s**2 - 61488*D1**2*Pk2*f*fd*gd2*s + 18144*D1**2*Pk2*f*fd*gd2 + 8736*D1**2*Pk2*f*fdd*g2*r**2 + 36288*D1**2*Pk2*f*fdd*g2*r*s - 18144*D1**2*Pk2*f*fdd*g2*r + 25200*D1**2*Pk2*f*fdd*g2*s**2 - 25200*D1**2*Pk2*f*fdd*g2*s + 12600*D1**2*Pk2*f*fdd*g2 + 8736*D1**2*Pk2*fd**2*g2*r**2 + 36288*D1**2*Pk2*fd**2*g2*r*s - 18144*D1**2*Pk2*fd**2*g2*r + 25200*D1**2*Pk2*fd**2*g2*s**2 - 25200*D1**2*Pk2*fd**2*g2*s + 27*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 54*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 27*D1**2*Pkdd2*bdd1*f**2*k1**2 + 84*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 168*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 84*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 81*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 54*D1**2*Pkdd2*f**2*fd*k1**2*s + 27*D1**2*Pkdd2*f**2*fd*k1**2 + 84*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 168*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 168*D1**2*Pkdd2*f*fd*g2*k1**2*s + 84*D1**2*Pkdd2*f*fd*g2*k1**2 + 6*D1**2*bd1**2*(-280*Pk2*g2*r*(2*r + 2*s - 1) + 3*f**2*(14*Pk2*(8*r**2 + r*(8*s - 15) - 9*s + 9) + 9*Pkdd2*k1**2*s*(s - 1)) - 7*f*(2*Pk2*(2*K*(2*r**2 - r*(24*s + 11) - 31*s**2 + 12*s + 9) - r**2*(8*C + 50) + r*(-8*C*s + 4*C - 60*s + 109) + 65*s - 55) + Pkdd2*k1**2*s*(2*K - 1)*(s - 1))) + 3024*D1*Dd*Pk2*b2*f**2*r**2 + 16128*D1*Dd*Pk2*b2*f**2*r*s - 7056*D1*Dd*Pk2*b2*f**2*r + 13104*D1*Dd*Pk2*b2*f**2*s**2 - 14616*D1*Dd*Pk2*b2*f**2*s + 4788*D1*Dd*Pk2*b2*f**2 - 20160*D1*Dd*Pk2*b2*f*fd*r**2 - 64512*D1*Dd*Pk2*b2*f*fd*r*s + 34272*D1*Dd*Pk2*b2*f*fd*r - 44352*D1*Dd*Pk2*b2*f*fd*s**2 + 49392*D1*Dd*Pk2*b2*f*fd*s - 13608*D1*Dd*Pk2*b2*f*fd - 10080*D1*Dd*Pk2*bd2*f**2*r**2 - 32256*D1*Dd*Pk2*bd2*f**2*r*s + 19152*D1*Dd*Pk2*bd2*f**2*r - 22176*D1*Dd*Pk2*bd2*f**2*s**2 + 29736*D1*Dd*Pk2*bd2*f**2*s - 9072*D1*Dd*Pk2*bd2*f**2 - 4488*D1*Dd*Pk2*f**3*r**2 - 23040*D1*Dd*Pk2*f**3*r*s + 10248*D1*Dd*Pk2*f**3*r - 11232*D1*Dd*Pk2*f**3*s**2 + 17136*D1*Dd*Pk2*f**3*s - 5052*D1*Dd*Pk2*f**3 + 40464*D1*Dd*Pk2*f**2*fd*r**2 + 133056*D1*Dd*Pk2*f**2*fd*r*s - 72528*D1*Dd*Pk2*f**2*fd*r + 62208*D1*Dd*Pk2*f**2*fd*s**2 - 91728*D1*Dd*Pk2*f**2*fd*s + 28560*D1*Dd*Pk2*f**2*fd - 11424*D1*Dd*Pk2*f**2*g2*r**2 - 72576*D1*Dd*Pk2*f**2*g2*r*s + 29568*D1*Dd*Pk2*f**2*g2*r - 54432*D1*Dd*Pk2*f**2*g2*s**2 + 63504*D1*Dd*Pk2*f**2*g2*s - 19320*D1*Dd*Pk2*f**2*g2 + 34944*D1*Dd*Pk2*f**2*gd2*r**2 + 145152*D1*Dd*Pk2*f**2*gd2*r*s - 70560*D1*Dd*Pk2*f**2*gd2*r + 100800*D1*Dd*Pk2*f**2*gd2*s**2 - 134064*D1*Dd*Pk2*f**2*gd2*s + 35616*D1*Dd*Pk2*f**2*gd2 + 69888*D1*Dd*Pk2*f*fd*g2*r**2 + 290304*D1*Dd*Pk2*f*fd*g2*r*s - 143808*D1*Dd*Pk2*f*fd*g2*r + 201600*D1*Dd*Pk2*f*fd*g2*s**2 - 223776*D1*Dd*Pk2*f*fd*g2*s + 61488*D1*Dd*Pk2*f*fd*g2 + 108*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 54*D1*Dd*Pkdd2*f**3*k1**2*s + 27*D1*Dd*Pkdd2*f**3*k1**2 + 336*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 168*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 84*D1*Dd*Pkdd2*f**2*g2*k1**2 - 5040*D1*Ddd*Pk2*b2*f**2*r**2 - 16128*D1*Ddd*Pk2*b2*f**2*r*s + 9072*D1*Ddd*Pk2*b2*f**2*r - 11088*D1*Ddd*Pk2*b2*f**2*s**2 + 13608*D1*Ddd*Pk2*b2*f**2*s - 5292*D1*Ddd*Pk2*b2*f**2 + 6744*D1*Ddd*Pk2*f**3*r**2 + 22176*D1*Ddd*Pk2*f**3*r*s - 12288*D1*Ddd*Pk2*f**3*r + 10368*D1*Ddd*Pk2*f**3*s**2 - 16272*D1*Ddd*Pk2*f**3*s + 5964*D1*Ddd*Pk2*f**3 + 17472*D1*Ddd*Pk2*f**2*g2*r**2 + 72576*D1*Ddd*Pk2*f**2*g2*r*s - 35616*D1*Ddd*Pk2*f**2*g2*r + 50400*D1*Ddd*Pk2*f**2*g2*s**2 - 61488*D1*Ddd*Pk2*f**2*g2*s + 21336*D1*Ddd*Pk2*f**2*g2 - 3*D1*bd1*(D1*(3*f**3*(14*Pk2*(2*r*(8*s - 5) + 10*s**2 - 24*s + 9) + 9*Pkdd2*k1**2*(1 - 2*s)) + f**2*(Pk2*(-24*C*r**2 + 448*C*r*s + 384*C*r + 568*C*s**2 - 28*K*(17*r**2 + 108*r*s - 34*r + 81*s**2 - 108*s + 17) - 84*fd*(6*r*(8*s - 3) + 30*s**2 - 50*s + 13) + 330*r**2 + 912*r*s - 640*r + 304*s**2 - 956*s + 44) + Pkdd2*k1**2*(-24*C*(s - 1)**2 + s**2*(14*K + 11) - 36*s + 18)) - 4*f*fd*(Pk2*(4*C*(4*r**2 + r*(112*s - 11) + 106*s**2 - 81*s - 19) - 14*K*(52*r**2 + 216*r*s - 106*r + 150*s**2 - 183*s + 54) + 494*r**2 + 960*r*s - 735*r + 376*s**2 - 691*s + 381) + Pkdd2*k1**2*s*(9 - 12*C)*(s - 1)) + 56*f*(Pk2*g2*(29*r**2 - 8*r*(s + 2) - 37*s**2) + Pk2*gd2*(-4*r**2 + r*(48*s + 22) + 62*s**2 - 24*s - 18) + Pkdd2*g2*k1**2*(s - 1)**2 - Pkdd2*gd2*k1**2*s*(s - 1)) - 56*fd*g2*(Pk2*(4*r**2 + r*(24 - 48*s) - s*(62*s - 62)) + Pkdd2*k1**2*s*(s - 1))) - 2*Dd*f*(84*Pk2*f**2*(2*r*(16*s - 7) + 20*s**2 - 37*s + 11) + f*(2*Pk2*(4*C*(8*r**2 + 4*r*(56*s + 11) + 212*s**2 - 109*s - 38) - 14*K*(104*r**2 + 6*r*(72*s - 35) + 300*s**2 - 399*s + 106) + 988*r**2 + 1920*r*s - 1726*r + 752*s**2 - 1720*s + 759) + Pkdd2*k1**2*(9 - 12*C)*(4*s**2 - 5*s + 1)) + 28*g2*(2*Pk2*(8*r**2 - 4*r*(24*s + 7) - 124*s**2 + 55*s + 18) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 15120*Dd**2*Pk2*b2*f**2*r**2 - 48384*Dd**2*Pk2*b2*f**2*r*s + 27216*Dd**2*Pk2*b2*f**2*r - 33264*Dd**2*Pk2*b2*f**2*s**2 + 40824*Dd**2*Pk2*b2*f**2*s - 10584*Dd**2*Pk2*b2*f**2 + 20232*Dd**2*Pk2*f**3*r**2 + 66528*Dd**2*Pk2*f**3*r*s - 36864*Dd**2*Pk2*f**3*r + 31104*Dd**2*Pk2*f**3*s**2 - 48816*Dd**2*Pk2*f**3*s + 14460*Dd**2*Pk2*f**3 + 52416*Dd**2*Pk2*f**2*g2*r**2 + 217728*Dd**2*Pk2*f**2*g2*r*s - 106848*Dd**2*Pk2*f**2*g2*r + 151200*Dd**2*Pk2*f**2*g2*s**2 - 184464*Dd**2*Pk2*f**2*g2*s + 45024*Dd**2*Pk2*f**2*g2 - 840*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)) - 3*b1**2*(224*C*D1**2*Pk2*fd*r**2 + 224*C*D1**2*Pk2*fd*r*s - 448*C*D1**2*Pk2*fd*r - 224*C*D1**2*Pk2*fd*s + 224*C*D1**2*Pk2*fd - 112*C*D1**2*Pk2*fdd*r**2 - 112*C*D1**2*Pk2*fdd*r*s + 224*C*D1**2*Pk2*fdd*r + 112*C*D1**2*Pk2*fdd*s - 112*C*D1**2*Pk2*fdd + 896*C*D1*Dd*Pk2*f*r**2 + 896*C*D1*Dd*Pk2*f*r*s - 1120*C*D1*Dd*Pk2*f*r - 448*C*D1*Dd*Pk2*f*s + 448*C*D1*Dd*Pk2*f - 896*C*D1*Dd*Pk2*fd*r**2 - 896*C*D1*Dd*Pk2*fd*r*s + 1456*C*D1*Dd*Pk2*fd*r + 672*C*D1*Dd*Pk2*fd*s - 560*C*D1*Dd*Pk2*fd - 448*C*D1*Ddd*Pk2*f*r**2 - 448*C*D1*Ddd*Pk2*f*r*s + 560*C*D1*Ddd*Pk2*f*r + 224*C*D1*Ddd*Pk2*f*s - 224*C*D1*Ddd*Pk2*f - 1344*C*Dd**2*Pk2*f*r**2 - 1344*C*Dd**2*Pk2*f*r*s + 1680*C*Dd**2*Pk2*f*r + 672*C*Dd**2*Pk2*f*s - 448*C*Dd**2*Pk2*f - 812*D1**2*K*Pk2*fd*r**2 + 224*D1**2*K*Pk2*fd*r*s - 672*D1**2*K*Pk2*fd*r + 1036*D1**2*K*Pk2*fd*s**2 - 2072*D1**2*K*Pk2*fd*s + 1036*D1**2*K*Pk2*fd + 56*D1**2*K*Pk2*fdd*r**2 - 672*D1**2*K*Pk2*fdd*r*s + 1176*D1**2*K*Pk2*fdd*r - 868*D1**2*K*Pk2*fdd*s**2 + 1736*D1**2*K*Pk2*fdd*s - 868*D1**2*K*Pk2*fdd - 28*D1**2*K*Pkdd2*fd*k1**2*s**2 + 14*D1**2*K*Pkdd2*fdd*k1**2*s**2 - 280*D1**2*Pk2*bdd1*(K - 1)*(3*r**2 + 3*r*(s - 1) - s + 1) + 672*D1**2*Pk2*f*fd*r**2 + 672*D1**2*Pk2*f*fd*r*s - 420*D1**2*Pk2*f*fd*r + 252*D1**2*Pk2*f*fd*s + 126*D1**2*Pk2*f*fd - 672*D1**2*Pk2*f*fdd*r**2 - 672*D1**2*Pk2*f*fdd*r*s + 420*D1**2*Pk2*f*fdd*r - 84*D1**2*Pk2*f*fdd*s - 210*D1**2*Pk2*f*fdd - 672*D1**2*Pk2*fd**2*r**2 - 672*D1**2*Pk2*fd**2*r*s + 420*D1**2*Pk2*fd**2*r - 84*D1**2*Pk2*fd**2*s + 252*D1**2*Pk2*fd**2 + 1120*D1**2*Pk2*fd*r**2 + 1120*D1**2*Pk2*fd*r*s + 644*D1**2*Pk2*fd*r + 1260*D1**2*Pk2*fd*s - 742*D1**2*Pk2*fd - 700*D1**2*Pk2*fdd*r**2 - 840*D1**2*Pk2*fdd*r*s - 812*D1**2*Pk2*fdd*r - 980*D1**2*Pk2*fdd*s + 546*D1**2*Pk2*fdd - 1120*D1**2*Pk2*gd2*r**2 - 1120*D1**2*Pk2*gd2*r*s + 2240*D1**2*Pk2*gd2*r + 1120*D1**2*Pk2*gd2*s - 1120*D1**2*Pk2*gd2 + 560*D1**2*Pk2*gdd2*r**2 + 560*D1**2*Pk2*gdd2*r*s - 1120*D1**2*Pk2*gdd2*r - 560*D1**2*Pk2*gdd2*s + 560*D1**2*Pk2*gdd2 + 108*D1**2*Pkdd2*f*fd*k1**2*s**2 - 54*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 54*D1**2*Pkdd2*fd**2*k1**2*s**2 + 14*D1**2*Pkdd2*fd*k1**2*s**2 - 7*D1**2*Pkdd2*fdd*k1**2*s**2 - 3248*D1*Dd*K*Pk2*f*r**2 + 896*D1*Dd*K*Pk2*f*r*s + 3024*D1*Dd*K*Pk2*f*r + 4144*D1*Dd*K*Pk2*f*s**2 - 2520*D1*Dd*K*Pk2*f*s - 588*D1*Dd*K*Pk2*f + 448*D1*Dd*K*Pk2*fd*r**2 - 5376*D1*Dd*K*Pk2*fd*r*s + 5152*D1*Dd*K*Pk2*fd*r - 6944*D1*Dd*K*Pk2*fd*s**2 + 10024*D1*Dd*K*Pk2*fd*s - 4088*D1*Dd*K*Pk2*fd - 112*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 56*D1*Dd*K*Pkdd2*f*k1**2*s - 28*D1*Dd*K*Pkdd2*f*k1**2 + 112*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 28*D1*Dd*K*Pkdd2*fd*k1**2*s + 1344*D1*Dd*Pk2*f**2*r**2 + 1344*D1*Dd*Pk2*f**2*r*s - 1680*D1*Dd*Pk2*f**2*r - 672*D1*Dd*Pk2*f**2*s + 672*D1*Dd*Pk2*f**2 - 5376*D1*Dd*Pk2*f*fd*r**2 - 5376*D1*Dd*Pk2*f*fd*r*s + 5040*D1*Dd*Pk2*f*fd*r + 1008*D1*Dd*Pk2*f*fd*s - 756*D1*Dd*Pk2*f*fd + 4480*D1*Dd*Pk2*f*r**2 + 4480*D1*Dd*Pk2*f*r*s - 5600*D1*Dd*Pk2*f*r - 2240*D1*Dd*Pk2*f*s + 2240*D1*Dd*Pk2*f - 5600*D1*Dd*Pk2*fd*r**2 - 6720*D1*Dd*Pk2*fd*r*s + 392*D1*Dd*Pk2*fd*r - 2240*D1*Dd*Pk2*fd*s + 2604*D1*Dd*Pk2*fd - 4480*D1*Dd*Pk2*g2*r**2 - 4480*D1*Dd*Pk2*g2*r*s + 5600*D1*Dd*Pk2*g2*r + 2240*D1*Dd*Pk2*g2*s - 2240*D1*Dd*Pk2*g2 + 4480*D1*Dd*Pk2*gd2*r**2 + 4480*D1*Dd*Pk2*gd2*r*s - 7280*D1*Dd*Pk2*gd2*r - 3360*D1*Dd*Pk2*gd2*s + 2800*D1*Dd*Pk2*gd2 + 216*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 108*D1*Dd*Pkdd2*f**2*k1**2*s + 54*D1*Dd*Pkdd2*f**2*k1**2 - 432*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 108*D1*Dd*Pkdd2*f*fd*k1**2*s + 56*D1*Dd*Pkdd2*f*k1**2*s**2 - 28*D1*Dd*Pkdd2*f*k1**2*s + 14*D1*Dd*Pkdd2*f*k1**2 - 56*D1*Dd*Pkdd2*fd*k1**2*s**2 + 14*D1*Dd*Pkdd2*fd*k1**2*s + 224*D1*Ddd*K*Pk2*f*r**2 - 2688*D1*Ddd*K*Pk2*f*r*s + 448*D1*Ddd*K*Pk2*f*r - 3472*D1*Ddd*K*Pk2*f*s**2 + 3080*D1*Ddd*K*Pk2*f*s - 756*D1*Ddd*K*Pk2*f + 56*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 28*D1*Ddd*K*Pkdd2*f*k1**2*s + 14*D1*Ddd*K*Pkdd2*f*k1**2 - 1344*D1*Ddd*Pk2*f**2*r**2 - 1344*D1*Ddd*Pk2*f**2*r*s + 1680*D1*Ddd*Pk2*f**2*r + 672*D1*Ddd*Pk2*f**2*s - 672*D1*Ddd*Pk2*f**2 - 2800*D1*Ddd*Pk2*f*r**2 - 3360*D1*Ddd*Pk2*f*r*s + 3640*D1*Ddd*Pk2*f*r + 1680*D1*Ddd*Pk2*f*s - 1400*D1*Ddd*Pk2*f + 2240*D1*Ddd*Pk2*g2*r**2 + 2240*D1*Ddd*Pk2*g2*r*s - 2800*D1*Ddd*Pk2*g2*r - 1120*D1*Ddd*Pk2*g2*s + 1120*D1*Ddd*Pk2*g2 - 108*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 54*D1*Ddd*Pkdd2*f**2*k1**2*s - 27*D1*Ddd*Pkdd2*f**2*k1**2 - 28*D1*Ddd*Pkdd2*f*k1**2*s**2 + 14*D1*Ddd*Pkdd2*f*k1**2*s - 7*D1*Ddd*Pkdd2*f*k1**2 + 280*D1*Pk2*bd1*(K - 1)*(D1*(6*r**2 + 6*r*(s - 1) - 2*s + 2) + Dd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7)) + 672*Dd**2*K*Pk2*f*r**2 - 8064*Dd**2*K*Pk2*f*r*s + 1344*Dd**2*K*Pk2*f*r - 10416*Dd**2*K*Pk2*f*s**2 + 9240*Dd**2*K*Pk2*f*s - 1232*Dd**2*K*Pk2*f + 168*Dd**2*K*Pkdd2*f*k1**2*s**2 - 84*Dd**2*K*Pkdd2*f*k1**2*s - 4032*Dd**2*Pk2*f**2*r**2 - 4032*Dd**2*Pk2*f**2*r*s + 5040*Dd**2*Pk2*f**2*r + 2016*Dd**2*Pk2*f**2*s - 1344*Dd**2*Pk2*f**2 - 8400*Dd**2*Pk2*f*r**2 - 10080*Dd**2*Pk2*f*r*s + 10920*Dd**2*Pk2*f*r + 5040*Dd**2*Pk2*f*s - 3080*Dd**2*Pk2*f + 6720*Dd**2*Pk2*g2*r**2 + 6720*Dd**2*Pk2*g2*r*s - 8400*Dd**2*Pk2*g2*r - 3360*Dd**2*Pk2*g2*s + 2240*Dd**2*Pk2*g2 - 324*Dd**2*Pkdd2*f**2*k1**2*s**2 + 162*Dd**2*Pkdd2*f**2*k1**2*s - 84*Dd**2*Pkdd2*f*k1**2*s**2 + 42*Dd**2*Pkdd2*f*k1**2*s) + 3*b1*(48*C*D1**2*Pk2*f*fd*r**2 - 896*C*D1**2*Pk2*f*fd*r*s + 784*C*D1**2*Pk2*f*fd*r - 1136*C*D1**2*Pk2*f*fd*s**2 + 1584*C*D1**2*Pk2*f*fd*s - 544*C*D1**2*Pk2*f*fd + 32*C*D1**2*Pk2*f*fdd*r**2 + 896*C*D1**2*Pk2*f*fdd*r*s - 784*C*D1**2*Pk2*f*fdd*r + 848*C*D1**2*Pk2*f*fdd*s**2 - 1296*C*D1**2*Pk2*f*fdd*s + 440*C*D1**2*Pk2*f*fdd + 32*C*D1**2*Pk2*fd**2*r**2 + 896*C*D1**2*Pk2*fd**2*r*s - 784*C*D1**2*Pk2*fd**2*r + 848*C*D1**2*Pk2*fd**2*s**2 - 1296*C*D1**2*Pk2*fd**2*s + 752*C*D1**2*Pk2*fd**2 + 48*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 24*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 24*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 96*C*D1*Dd*Pk2*f**2*r**2 - 1792*C*D1*Dd*Pk2*f**2*r*s + 352*C*D1*Dd*Pk2*f**2*r - 2272*C*D1*Dd*Pk2*f**2*s**2 + 2032*C*D1*Dd*Pk2*f**2*s - 520*C*D1*Dd*Pk2*f**2 + 256*C*D1*Dd*Pk2*f*fd*r**2 + 7168*C*D1*Dd*Pk2*f*fd*r*s - 4160*C*D1*Dd*Pk2*f*fd*r + 6784*C*D1*Dd*Pk2*f*fd*s**2 - 8672*C*D1*Dd*Pk2*f*fd*s + 2864*C*D1*Dd*Pk2*f*fd + 96*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 48*C*D1*Dd*Pkdd2*f**2*k1**2*s + 24*C*D1*Dd*Pkdd2*f**2*k1**2 - 192*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 48*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 64*C*D1*Ddd*Pk2*f**2*r**2 + 1792*C*D1*Ddd*Pk2*f**2*r*s - 512*C*D1*Ddd*Pk2*f**2*r + 1696*C*D1*Ddd*Pk2*f**2*s**2 - 1744*C*D1*Ddd*Pk2*f**2*s + 456*C*D1*Ddd*Pk2*f**2 - 48*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 24*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 12*C*D1*Ddd*Pkdd2*f**2*k1**2 + 192*C*Dd**2*Pk2*f**2*r**2 + 5376*C*Dd**2*Pk2*f**2*r*s - 1536*C*Dd**2*Pk2*f**2*r + 5088*C*Dd**2*Pk2*f**2*s**2 - 5232*C*Dd**2*Pk2*f**2*s + 928*C*Dd**2*Pk2*f**2 - 144*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 72*C*Dd**2*Pkdd2*f**2*k1**2*s + 952*D1**2*K*Pk2*f*fd*r**2 + 6048*D1**2*K*Pk2*f*fd*r*s - 3024*D1**2*K*Pk2*f*fd*r + 4536*D1**2*K*Pk2*f*fd*s**2 - 4536*D1**2*K*Pk2*f*fd*s + 2268*D1**2*K*Pk2*f*fd - 1456*D1**2*K*Pk2*f*fdd*r**2 - 6048*D1**2*K*Pk2*f*fdd*r*s + 3024*D1**2*K*Pk2*f*fdd*r - 4200*D1**2*K*Pk2*f*fdd*s**2 + 4200*D1**2*K*Pk2*f*fdd*s - 2100*D1**2*K*Pk2*f*fdd - 1456*D1**2*K*Pk2*fd**2*r**2 - 6048*D1**2*K*Pk2*fd**2*r*s + 3024*D1**2*K*Pk2*fd**2*r - 4200*D1**2*K*Pk2*fd**2*s**2 + 4200*D1**2*K*Pk2*fd**2*s - 28*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 28*D1**2*K*Pkdd2*f*fd*k1**2*s - 14*D1**2*K*Pkdd2*f*fd*k1**2 + 280*D1**2*Pk2*bd1**2*(K - 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 2016*D1**2*Pk2*f**2*fd*r*s + 252*D1**2*Pk2*f**2*fd*r - 1260*D1**2*Pk2*f**2*fd*s**2 + 1176*D1**2*Pk2*f**2*fd*s - 42*D1**2*Pk2*f**2*fd + 2016*D1**2*Pk2*f**2*fdd*r*s - 252*D1**2*Pk2*f**2*fdd*r + 1260*D1**2*Pk2*f**2*fdd*s**2 - 1176*D1**2*Pk2*f**2*fdd*s + 42*D1**2*Pk2*f**2*fdd + 4032*D1**2*Pk2*f*fd**2*r*s - 504*D1**2*Pk2*f*fd**2*r + 2520*D1**2*Pk2*f*fd**2*s**2 - 2352*D1**2*Pk2*f*fd**2*s + 252*D1**2*Pk2*f*fd**2 - 660*D1**2*Pk2*f*fd*r**2 - 1824*D1**2*Pk2*f*fd*r*s + 932*D1**2*Pk2*f*fd*r - 608*D1**2*Pk2*f*fd*s**2 + 564*D1**2*Pk2*f*fd*s - 590*D1**2*Pk2*f*fd + 988*D1**2*Pk2*f*fdd*r**2 + 1920*D1**2*Pk2*f*fdd*r*s - 956*D1**2*Pk2*f*fdd*r + 752*D1**2*Pk2*f*fdd*s**2 - 660*D1**2*Pk2*f*fdd*s + 610*D1**2*Pk2*f*fdd - 1624*D1**2*Pk2*f*gd2*r**2 + 448*D1**2*Pk2*f*gd2*r*s + 3248*D1**2*Pk2*f*gd2*r + 2072*D1**2*Pk2*f*gd2*s**2 - 448*D1**2*Pk2*f*gd2*s - 1624*D1**2*Pk2*f*gd2 + 112*D1**2*Pk2*f*gdd2*r**2 - 1344*D1**2*Pk2*f*gdd2*r*s - 224*D1**2*Pk2*f*gdd2*r - 1736*D1**2*Pk2*f*gdd2*s**2 + 1344*D1**2*Pk2*f*gdd2*s + 112*D1**2*Pk2*f*gdd2 + 988*D1**2*Pk2*fd**2*r**2 + 1920*D1**2*Pk2*fd**2*r*s - 956*D1**2*Pk2*fd**2*r + 752*D1**2*Pk2*fd**2*s**2 - 660*D1**2*Pk2*fd**2*s - 564*D1**2*Pk2*fd**2 - 1624*D1**2*Pk2*fd*g2*r**2 + 448*D1**2*Pk2*fd*g2*r*s - 1344*D1**2*Pk2*fd*g2*r + 2072*D1**2*Pk2*fd*g2*s**2 - 4144*D1**2*Pk2*fd*g2*s + 2072*D1**2*Pk2*fd*g2 + 224*D1**2*Pk2*fd*gd2*r**2 - 2688*D1**2*Pk2*fd*gd2*r*s + 2128*D1**2*Pk2*fd*gd2*r - 3472*D1**2*Pk2*fd*gd2*s**2 + 4816*D1**2*Pk2*fd*gd2*s - 2352*D1**2*Pk2*fd*gd2 + 112*D1**2*Pk2*fdd*g2*r**2 - 1344*D1**2*Pk2*fdd*g2*r*s + 2352*D1**2*Pk2*fdd*g2*r - 1736*D1**2*Pk2*fdd*g2*s**2 + 3472*D1**2*Pk2*fdd*g2*s - 1736*D1**2*Pk2*fdd*g2 - 54*D1**2*Pkdd2*f**2*fd*k1**2*s + 27*D1**2*Pkdd2*f**2*fd*k1**2 - 22*D1**2*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*Pkdd2*f*fd*k1**2*s + 7*D1**2*Pkdd2*f*fd*k1**2 + 18*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 56*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 28*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 18*D1**2*Pkdd2*fd**2*k1**2*s**2 - 56*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 56*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 28*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + D1**2*bdd1*(-560*Pk2*g2*r*(2*r + 2*s - 1) + 3*f**2*(14*Pk2*(16*r**2 + 2*r*(8*s - 15) - 18*s + 11) + 9*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - 7*f*(2*Pk2*(4*K*(2*r**2 - r*(24*s + 11) - 31*s**2 + 12*s + 1) - r**2*(16*C + 100) - 2*r*(8*C*s - 4*C + 60*s - 109) + 130*s - 89) + Pkdd2*k1**2*(2*K - 1)*(2*s**2 - 2*s + 1))) + 1904*D1*Dd*K*Pk2*f**2*r**2 + 12096*D1*Dd*K*Pk2*f**2*r*s - 4928*D1*Dd*K*Pk2*f**2*r + 9072*D1*Dd*K*Pk2*f**2*s**2 - 10584*D1*Dd*K*Pk2*f**2*s + 3220*D1*Dd*K*Pk2*f**2 - 11648*D1*Dd*K*Pk2*f*fd*r**2 - 48384*D1*Dd*K*Pk2*f*fd*r*s + 23968*D1*Dd*K*Pk2*f*fd*r - 33600*D1*Dd*K*Pk2*f*fd*s**2 + 37296*D1*Dd*K*Pk2*f*fd*s - 10248*D1*Dd*K*Pk2*f*fd - 56*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 28*D1*Dd*K*Pkdd2*f**2*k1**2*s - 14*D1*Dd*K*Pkdd2*f**2*k1**2 - 2688*D1*Dd*Pk2*f**3*r*s + 672*D1*Dd*Pk2*f**3*r - 1680*D1*Dd*Pk2*f**3*s**2 + 2184*D1*Dd*Pk2*f**3*s - 420*D1*Dd*Pk2*f**3 + 16128*D1*Dd*Pk2*f**2*fd*r*s - 3024*D1*Dd*Pk2*f**2*fd*r + 10080*D1*Dd*Pk2*f**2*fd*s**2 - 11256*D1*Dd*Pk2*f**2*fd*s + 1680*D1*Dd*Pk2*f**2*fd - 1320*D1*Dd*Pk2*f**2*r**2 - 3648*D1*Dd*Pk2*f**2*r*s + 2232*D1*Dd*Pk2*f**2*r - 1216*D1*Dd*Pk2*f**2*s**2 + 2432*D1*Dd*Pk2*f**2*s - 964*D1*Dd*Pk2*f**2 + 7904*D1*Dd*Pk2*f*fd*r**2 + 15360*D1*Dd*Pk2*f*fd*r*s - 9696*D1*Dd*Pk2*f*fd*r + 6016*D1*Dd*Pk2*f*fd*s**2 - 7984*D1*Dd*Pk2*f*fd*s + 2572*D1*Dd*Pk2*f*fd - 6496*D1*Dd*Pk2*f*g2*r**2 + 1792*D1*Dd*Pk2*f*g2*r*s + 6048*D1*Dd*Pk2*f*g2*r + 8288*D1*Dd*Pk2*f*g2*s**2 - 5040*D1*Dd*Pk2*f*g2*s - 1176*D1*Dd*Pk2*f*g2 + 896*D1*Dd*Pk2*f*gd2*r**2 - 10752*D1*Dd*Pk2*f*gd2*r*s - 13888*D1*Dd*Pk2*f*gd2*s**2 + 11536*D1*Dd*Pk2*f*gd2*s - 896*D1*Dd*Pk2*f*gd2 + 896*D1*Dd*Pk2*fd*g2*r**2 - 10752*D1*Dd*Pk2*fd*g2*r*s + 10304*D1*Dd*Pk2*fd*g2*r - 13888*D1*Dd*Pk2*fd*g2*s**2 + 20048*D1*Dd*Pk2*fd*g2*s - 8176*D1*Dd*Pk2*fd*g2 - 44*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 22*D1*Dd*Pkdd2*f**2*k1**2*s - 11*D1*Dd*Pkdd2*f**2*k1**2 + 144*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 36*D1*Dd*Pkdd2*f*fd*k1**2*s - 224*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 112*D1*Dd*Pkdd2*f*g2*k1**2*s - 56*D1*Dd*Pkdd2*f*g2*k1**2 + 224*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 - 56*D1*Dd*Pkdd2*f*gd2*k1**2*s + 224*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 - 56*D1*Dd*Pkdd2*fd*g2*k1**2*s - 2912*D1*Ddd*K*Pk2*f**2*r**2 - 12096*D1*Ddd*K*Pk2*f**2*r*s + 5936*D1*Ddd*K*Pk2*f**2*r - 8400*D1*Ddd*K*Pk2*f**2*s**2 + 10248*D1*Ddd*K*Pk2*f**2*s - 3556*D1*Ddd*K*Pk2*f**2 + 2688*D1*Ddd*Pk2*f**3*r*s - 672*D1*Ddd*Pk2*f**3*r + 1680*D1*Ddd*Pk2*f**3*s**2 - 2184*D1*Ddd*Pk2*f**3*s + 420*D1*Ddd*Pk2*f**3 + 1976*D1*Ddd*Pk2*f**2*r**2 + 3840*D1*Ddd*Pk2*f**2*r*s - 2936*D1*Ddd*Pk2*f**2*r + 1504*D1*Ddd*Pk2*f**2*s**2 - 2672*D1*Ddd*Pk2*f**2*s + 1364*D1*Ddd*Pk2*f**2 + 448*D1*Ddd*Pk2*f*g2*r**2 - 5376*D1*Ddd*Pk2*f*g2*r*s + 896*D1*Ddd*Pk2*f*g2*r - 6944*D1*Ddd*Pk2*f*g2*s**2 + 6160*D1*Ddd*Pk2*f*g2*s - 1512*D1*Ddd*Pk2*f*g2 + 36*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Ddd*Pkdd2*f**2*k1**2*s + 9*D1*Ddd*Pkdd2*f**2*k1**2 + 112*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 - 56*D1*Ddd*Pkdd2*f*g2*k1**2*s + 28*D1*Ddd*Pkdd2*f*g2*k1**2 - 2*D1*bd1*(3*D1*f**2*(7*Pk2*(16*r**2 + 2*r*(8*s - 15) - 22*s + 13) + 9*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + D1*f*(-7*Pk2*(-32*C*r**2 - 32*C*r*s + 16*C*r + 2*K*(58*r**2 - 2*r*(8*s + 37) - 74*s**2 + 8*s + 29) + 12*fd*(16*r**2 + 4*r*(4*s - 5) - 8*s + 5) - 160*r**2 - 160*r*s + 286*r + 170*s - 133) + Pkdd2*k1**2*(-14*K*(2*s**2 - 2*s + 1) - s**2*(108*fd - 14) + s*(54*fd - 14) + 7)) - 7*D1*(2*Pk2*fd*(4*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 2*K*(4*r**2 - 48*r*s + 31*r - 62*s**2 + 74*s - 21) + 100*r**2 + 120*r*s - 51*r + 5*s - 25) + 80*Pk2*g2*r*(2*r + 2*s - 1) - 40*Pk2*gd2*(4*r**2 + r*(4*s - 5) - 2*s + 1) + Pkdd2*fd*k1**2*s*(K*(2 - 4*s) + 2*s - 1)) + 560*Dd*Pk2*g2*(8*r**2 + r*(8*s - 7) - 2*s + 1) - 3*Dd*f**2*(14*Pk2*(16*r - 13)*(4*r + 4*s - 3) + 9*Pkdd2*k1**2*(8*s**2 - 6*s + 1)) - 7*Dd*f*(2*Pk2*(8*C*(8*r**2 + r*(8*s - 7) - 2*s + 1) - 4*K*(8*r**2 - 2*r*(48*s + 7) - 124*s**2 + 79*s + 5) + 400*r**2 + 480*r*s - 696*r - 380*s + 283) - Pkdd2*k1**2*(2*K - 1)*(8*s**2 - 6*s + 1))) - 8736*Dd**2*K*Pk2*f**2*r**2 - 36288*Dd**2*K*Pk2*f**2*r*s + 17808*Dd**2*K*Pk2*f**2*r - 25200*Dd**2*K*Pk2*f**2*s**2 + 30744*Dd**2*K*Pk2*f**2*s - 7504*Dd**2*K*Pk2*f**2 + 8064*Dd**2*Pk2*f**3*r*s - 2016*Dd**2*Pk2*f**3*r + 5040*Dd**2*Pk2*f**3*s**2 - 6552*Dd**2*Pk2*f**3*s + 1344*Dd**2*Pk2*f**3 + 5928*Dd**2*Pk2*f**2*r**2 + 11520*Dd**2*Pk2*f**2*r*s - 8808*Dd**2*Pk2*f**2*r + 4512*Dd**2*Pk2*f**2*s**2 - 8016*Dd**2*Pk2*f**2*s + 2908*Dd**2*Pk2*f**2 + 1344*Dd**2*Pk2*f*g2*r**2 - 16128*Dd**2*Pk2*f*g2*r*s + 2688*Dd**2*Pk2*f*g2*r - 20832*Dd**2*Pk2*f*g2*s**2 + 18480*Dd**2*Pk2*f*g2*s - 2464*Dd**2*Pk2*f*g2 + 108*Dd**2*Pkdd2*f**2*k1**2*s**2 - 54*Dd**2*Pkdd2*f**2*k1**2*s + 336*Dd**2*Pkdd2*f*g2*k1**2*s**2 - 168*Dd**2*Pkdd2*f*g2*k1**2*s))/(630*d**2*k3**4) + D1**2*Pk3*ct*k1*k2*(-2128*C*D1**2*Pk2*bd1**2*f*r**2 - 4032*C*D1**2*Pk2*bd1**2*f*r*s + 2016*C*D1**2*Pk2*bd1**2*f*r - 1904*C*D1**2*Pk2*bd1**2*f*s**2 + 1904*C*D1**2*Pk2*bd1**2*f*s - 2232*C*D1**2*Pk2*bd1*f**2*r**2 - 3504*C*D1**2*Pk2*bd1*f**2*r*s + 3840*C*D1**2*Pk2*bd1*f**2*r - 952*C*D1**2*Pk2*bd1*f**2*s**2 + 2576*C*D1**2*Pk2*bd1*f**2*s - 1288*C*D1**2*Pk2*bd1*f**2 + 8832*C*D1**2*Pk2*bd1*f*fd*r**2 + 17088*C*D1**2*Pk2*bd1*f*fd*r*s - 13296*C*D1**2*Pk2*bd1*f*fd*r + 6496*C*D1**2*Pk2*bd1*f*fd*s**2 - 11440*C*D1**2*Pk2*bd1*f*fd*s + 4608*C*D1**2*Pk2*bd1*f*fd + 2208*C*D1**2*Pk2*bdd1*f**2*r**2 + 4272*C*D1**2*Pk2*bdd1*f**2*r*s - 4608*C*D1**2*Pk2*bdd1*f**2*r + 1624*C*D1**2*Pk2*bdd1*f**2*s**2 - 3920*C*D1**2*Pk2*bdd1*f**2*s + 1960*C*D1**2*Pk2*bdd1*f**2 - 1296*C*D1**2*Pk2*f**2*fd*r*s + 432*C*D1**2*Pk2*f**2*fd*r - 1512*C*D1**2*Pk2*f**2*fd*s**2 + 1440*C*D1**2*Pk2*f**2*fd*s - 504*C*D1**2*Pk2*f**2*fd + 1296*C*D1**2*Pk2*f**2*fdd*r*s - 432*C*D1**2*Pk2*f**2*fdd*r + 1512*C*D1**2*Pk2*f**2*fdd*s**2 - 1440*C*D1**2*Pk2*f**2*fdd*s + 504*C*D1**2*Pk2*f**2*fdd + 2592*C*D1**2*Pk2*f*fd**2*r*s - 864*C*D1**2*Pk2*f*fd**2*r + 3024*C*D1**2*Pk2*f*fd**2*s**2 - 2880*C*D1**2*Pk2*f*fd**2*s + 432*C*D1**2*Pk2*f*fd**2 + 84*C*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 - 168*C*D1**2*Pkdd2*bd1*f**2*k1**2*s + 84*C*D1**2*Pkdd2*bd1*f**2*k1**2 + 17664*C*D1*Dd*Pk2*bd1*f**2*r**2 + 34176*C*D1*Dd*Pk2*bd1*f**2*r*s - 31536*C*D1*Dd*Pk2*bd1*f**2*r + 12992*C*D1*Dd*Pk2*bd1*f**2*s**2 - 27472*C*D1*Dd*Pk2*bd1*f**2*s + 13136*C*D1*Dd*Pk2*bd1*f**2 - 1728*C*D1*Dd*Pk2*f**3*r*s + 432*C*D1*Dd*Pk2*f**3*r - 2016*C*D1*Dd*Pk2*f**3*s**2 + 1872*C*D1*Dd*Pk2*f**3*s - 504*C*D1*Dd*Pk2*f**3 + 10368*C*D1*Dd*Pk2*f**2*fd*r*s - 3024*C*D1*Dd*Pk2*f**2*fd*r + 12096*C*D1*Dd*Pk2*f**2*fd*s**2 - 11376*C*D1*Dd*Pk2*f**2*fd*s + 2304*C*D1*Dd*Pk2*f**2*fd + 1728*C*D1*Ddd*Pk2*f**3*r*s - 432*C*D1*Ddd*Pk2*f**3*r + 2016*C*D1*Ddd*Pk2*f**3*s**2 - 1872*C*D1*Ddd*Pk2*f**3*s + 504*C*D1*Ddd*Pk2*f**3 + 5184*C*Dd**2*Pk2*f**3*r*s - 1296*C*Dd**2*Pk2*f**3*r + 6048*C*Dd**2*Pk2*f**3*s**2 - 5616*C*Dd**2*Pk2*f**3*s + 864*C*Dd**2*Pk2*f**3 + 2800*D1**2*K*Pk2*bd1**2*f*r**2 + 6160*D1**2*K*Pk2*bd1**2*f*r*s - 6160*D1**2*K*Pk2*bd1**2*f*r + 3080*D1**2*K*Pk2*bd1**2*f*s**2 - 6720*D1**2*K*Pk2*bd1**2*f*s + 3360*D1**2*K*Pk2*bd1**2*f - 280*D1**2*K*Pk2*bd1*f**2*r*s - 420*D1**2*K*Pk2*bd1*f**2*s**2 + 280*D1**2*K*Pk2*bd1*f**2*s + 1120*D1**2*K*Pk2*bd1*f*fd*r*s - 280*D1**2*K*Pk2*bd1*f*fd*r + 1680*D1**2*K*Pk2*bd1*f*fd*s**2 - 1400*D1**2*K*Pk2*bd1*f*fd*s + 280*D1**2*K*Pk2*bd1*f*fd + 280*D1**2*K*Pk2*bdd1*f**2*r*s + 420*D1**2*K*Pk2*bdd1*f**2*s**2 - 280*D1**2*K*Pk2*bdd1*f**2*s - 1260*D1**2*Pk2*bd1**2*f**2*r**2 - 1680*D1**2*Pk2*bd1**2*f**2*r*s + 2100*D1**2*Pk2*bd1**2*f**2*r - 420*D1**2*Pk2*bd1**2*f**2*s**2 + 1260*D1**2*Pk2*bd1**2*f**2*s - 840*D1**2*Pk2*bd1**2*f**2 + 896*D1**2*Pk2*bd1**2*f*r**2 + 1176*D1**2*Pk2*bd1**2*f*r*s + 112*D1**2*Pk2*bd1**2*f*r + 560*D1**2*Pk2*bd1**2*f*s**2 + 280*D1**2*Pk2*bd1**2*f*s - 840*D1**2*Pk2*bd1**2*f + 2800*D1**2*Pk2*bd1**2*g2*r**2 + 6720*D1**2*Pk2*bd1**2*g2*r*s - 3360*D1**2*Pk2*bd1**2*g2*r + 3920*D1**2*Pk2*bd1**2*g2*s**2 - 3920*D1**2*Pk2*bd1**2*g2*s + 1400*D1**2*Pk2*bd1*bd2*f*r**2 + 2800*D1**2*Pk2*bd1*bd2*f*r*s - 2800*D1**2*Pk2*bd1*bd2*f*r + 1400*D1**2*Pk2*bd1*bd2*f*s**2 - 2800*D1**2*Pk2*bd1*bd2*f*s + 1400*D1**2*Pk2*bd1*bd2*f + 1194*D1**2*Pk2*bd1*f**2*r**2 + 2016*D1**2*Pk2*bd1*f**2*r*s - 2184*D1**2*Pk2*bd1*f**2*r + 630*D1**2*Pk2*bd1*f**2*s**2 - 1596*D1**2*Pk2*bd1*f**2*s + 798*D1**2*Pk2*bd1*f**2 - 5496*D1**2*Pk2*bd1*f*fd*r**2 - 10752*D1**2*Pk2*bd1*f*fd*r*s + 8292*D1**2*Pk2*bd1*f*fd*r - 3864*D1**2*Pk2*bd1*f*fd*s**2 + 6888*D1**2*Pk2*bd1*f*fd*s - 2856*D1**2*Pk2*bd1*f*fd + 1960*D1**2*Pk2*bd1*f*g2*r**2 + 3920*D1**2*Pk2*bd1*f*g2*r*s - 4480*D1**2*Pk2*bd1*f*g2*r + 1960*D1**2*Pk2*bd1*f*g2*s**2 - 5040*D1**2*Pk2*bd1*f*g2*s + 2520*D1**2*Pk2*bd1*f*g2 - 5600*D1**2*Pk2*bd1*f*gd2*r**2 - 12320*D1**2*Pk2*bd1*f*gd2*r*s + 12320*D1**2*Pk2*bd1*f*gd2*r - 6160*D1**2*Pk2*bd1*f*gd2*s**2 + 13440*D1**2*Pk2*bd1*f*gd2*s - 6720*D1**2*Pk2*bd1*f*gd2 - 5600*D1**2*Pk2*bd1*fd*g2*r**2 - 12320*D1**2*Pk2*bd1*fd*g2*r*s + 6160*D1**2*Pk2*bd1*fd*g2*r - 6160*D1**2*Pk2*bd1*fd*g2*s**2 + 6160*D1**2*Pk2*bd1*fd*g2*s - 1374*D1**2*Pk2*bdd1*f**2*r**2 - 2688*D1**2*Pk2*bdd1*f**2*r*s + 2856*D1**2*Pk2*bdd1*f**2*r - 966*D1**2*Pk2*bdd1*f**2*s**2 + 2268*D1**2*Pk2*bdd1*f**2*s - 1134*D1**2*Pk2*bdd1*f**2 - 2800*D1**2*Pk2*bdd1*f*g2*r**2 - 6160*D1**2*Pk2*bdd1*f*g2*r*s + 6720*D1**2*Pk2*bdd1*f*g2*r - 3080*D1**2*Pk2*bdd1*f*g2*s**2 + 7280*D1**2*Pk2*bdd1*f*g2*s - 3640*D1**2*Pk2*bdd1*f*g2 + 648*D1**2*Pk2*f**2*fd*r*s - 216*D1**2*Pk2*f**2*fd*r + 756*D1**2*Pk2*f**2*fd*s**2 - 720*D1**2*Pk2*f**2*fd*s + 252*D1**2*Pk2*f**2*fd - 648*D1**2*Pk2*f**2*fdd*r*s + 216*D1**2*Pk2*f**2*fdd*r - 756*D1**2*Pk2*f**2*fdd*s**2 + 720*D1**2*Pk2*f**2*fdd*s - 252*D1**2*Pk2*f**2*fdd + 560*D1**2*Pk2*f**2*gd2*r*s + 840*D1**2*Pk2*f**2*gd2*s**2 - 560*D1**2*Pk2*f**2*gd2*s - 560*D1**2*Pk2*f**2*gdd2*r*s - 840*D1**2*Pk2*f**2*gdd2*s**2 + 560*D1**2*Pk2*f**2*gdd2*s - 1296*D1**2*Pk2*f*fd**2*r*s + 432*D1**2*Pk2*f*fd**2*r - 1512*D1**2*Pk2*f*fd**2*s**2 + 1440*D1**2*Pk2*f*fd**2*s - 216*D1**2*Pk2*f*fd**2 + 1120*D1**2*Pk2*f*fd*g2*r*s - 560*D1**2*Pk2*f*fd*g2*r + 1680*D1**2*Pk2*f*fd*g2*s**2 - 1680*D1**2*Pk2*f*fd*g2*s + 840*D1**2*Pk2*f*fd*g2 - 2240*D1**2*Pk2*f*fd*gd2*r*s + 560*D1**2*Pk2*f*fd*gd2*r - 3360*D1**2*Pk2*f*fd*gd2*s**2 + 2800*D1**2*Pk2*f*fd*gd2*s - 560*D1**2*Pk2*f*fd*gd2 - 1120*D1**2*Pk2*f*fdd*g2*r*s + 560*D1**2*Pk2*f*fdd*g2*r - 1680*D1**2*Pk2*f*fdd*g2*s**2 + 1680*D1**2*Pk2*f*fdd*g2*s - 840*D1**2*Pk2*f*fdd*g2 - 1120*D1**2*Pk2*fd**2*g2*r*s + 560*D1**2*Pk2*fd**2*g2*r - 1680*D1**2*Pk2*fd**2*g2*s**2 + 1680*D1**2*Pk2*fd**2*g2*s - 63*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 + 126*D1**2*Pkdd2*bd1*f**2*k1**2*s - 63*D1**2*Pkdd2*bd1*f**2*k1**2 - 140*D1**2*Pkdd2*bd1*f*g2*k1**2*s**2 + 280*D1**2*Pkdd2*bd1*f*g2*k1**2*s - 140*D1**2*Pkdd2*bd1*f*g2*k1**2 + 2240*D1*Dd*K*Pk2*bd1*f**2*r*s - 280*D1*Dd*K*Pk2*bd1*f**2*r + 3360*D1*Dd*K*Pk2*bd1*f**2*s**2 - 2520*D1*Dd*K*Pk2*bd1*f**2*s + 280*D1*Dd*K*Pk2*bd1*f**2 - 10992*D1*Dd*Pk2*bd1*f**2*r**2 - 21504*D1*Dd*Pk2*bd1*f**2*r*s + 19608*D1*Dd*Pk2*bd1*f**2*r - 7728*D1*Dd*Pk2*bd1*f**2*s**2 + 16380*D1*Dd*Pk2*bd1*f**2*s - 7980*D1*Dd*Pk2*bd1*f**2 - 22400*D1*Dd*Pk2*bd1*f*g2*r**2 - 49280*D1*Dd*Pk2*bd1*f*g2*r*s + 44240*D1*Dd*Pk2*bd1*f*g2*r - 24640*D1*Dd*Pk2*bd1*f*g2*s**2 + 47600*D1*Dd*Pk2*bd1*f*g2*s - 20720*D1*Dd*Pk2*bd1*f*g2 + 864*D1*Dd*Pk2*f**3*r*s - 216*D1*Dd*Pk2*f**3*r + 1008*D1*Dd*Pk2*f**3*s**2 - 936*D1*Dd*Pk2*f**3*s + 252*D1*Dd*Pk2*f**3 - 5184*D1*Dd*Pk2*f**2*fd*r*s + 1512*D1*Dd*Pk2*f**2*fd*r - 6048*D1*Dd*Pk2*f**2*fd*s**2 + 5688*D1*Dd*Pk2*f**2*fd*s - 1152*D1*Dd*Pk2*f**2*fd + 2240*D1*Dd*Pk2*f**2*g2*r*s - 560*D1*Dd*Pk2*f**2*g2*r + 3360*D1*Dd*Pk2*f**2*g2*s**2 - 2800*D1*Dd*Pk2*f**2*g2*s + 840*D1*Dd*Pk2*f**2*g2 - 4480*D1*Dd*Pk2*f**2*gd2*r*s + 560*D1*Dd*Pk2*f**2*gd2*r - 6720*D1*Dd*Pk2*f**2*gd2*s**2 + 5040*D1*Dd*Pk2*f**2*gd2*s - 560*D1*Dd*Pk2*f**2*gd2 - 8960*D1*Dd*Pk2*f*fd*g2*r*s + 3360*D1*Dd*Pk2*f*fd*g2*r - 13440*D1*Dd*Pk2*f*fd*g2*s**2 + 12320*D1*Dd*Pk2*f*fd*g2*s - 2800*D1*Dd*Pk2*f*fd*g2 - 864*D1*Ddd*Pk2*f**3*r*s + 216*D1*Ddd*Pk2*f**3*r - 1008*D1*Ddd*Pk2*f**3*s**2 + 936*D1*Ddd*Pk2*f**3*s - 252*D1*Ddd*Pk2*f**3 - 2240*D1*Ddd*Pk2*f**2*g2*r*s + 560*D1*Ddd*Pk2*f**2*g2*r - 3360*D1*Ddd*Pk2*f**2*g2*s**2 + 2800*D1*Ddd*Pk2*f**2*g2*s - 840*D1*Ddd*Pk2*f**2*g2 - 140*D1*Pk2*b2*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) - 2592*Dd**2*Pk2*f**3*r*s + 648*Dd**2*Pk2*f**3*r - 3024*Dd**2*Pk2*f**3*s**2 + 2808*Dd**2*Pk2*f**3*s - 432*Dd**2*Pk2*f**3 - 6720*Dd**2*Pk2*f**2*g2*r*s + 1680*Dd**2*Pk2*f**2*g2*r - 10080*Dd**2*Pk2*f**2*g2*s**2 + 8400*Dd**2*Pk2*f**2*g2*s - 1120*Dd**2*Pk2*f**2*g2 - 70*Pk2*b1**3*(D1**2*(fd*(5*r + s - 5) + fdd*(-7*r - 3*s + 7))*(r + s - 1) + D1*(Dd*(88*K*r**2 + 144*K*r*s - 124*K*r + 56*K*s**2 - 100*K*s + 58*K + f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11) - 2*fd*(28*r**2 + 40*r*s - 47*r + 12*s**2 - 33*s + 19) - 68*r**2 - 88*r*s + 90*r - 20*s**2 + 54*s - 39) - Ddd*(-2*K*(20*r**2 + 48*r*s - 32*r + 28*s**2 - 38*s + 17) + f*(28*r**2 + r*(40*s - 38) + 12*s**2 - 26*s + 17) + 20*r**2 + 40*r*s - 30*r + 20*s**2 - 30*s + 15)) - 2*Dd**2*(-2*K*(30*r**2 + 72*r*s - 48*r + 42*s**2 - 57*s + 17) + f*(42*r**2 + r*(60*s - 57) + 18*s**2 - 39*s + 17) + 30*r**2 + 60*r*s - 45*r + 30*s**2 - 45*s + 15)) - 7*b1**2*(-24*C*D1**2*Pk2*fd*r**2 - 16*C*D1**2*Pk2*fd*r*s + 48*C*D1**2*Pk2*fd*r + 8*C*D1**2*Pk2*fd*s**2 + 16*C*D1**2*Pk2*fd*s - 24*C*D1**2*Pk2*fd + 152*C*D1**2*Pk2*fdd*r**2 + 288*C*D1**2*Pk2*fdd*r*s - 304*C*D1**2*Pk2*fdd*r + 136*C*D1**2*Pk2*fdd*s**2 - 288*C*D1**2*Pk2*fdd*s + 152*C*D1**2*Pk2*fdd - 96*C*D1*Dd*Pk2*f*r**2 - 64*C*D1*Dd*Pk2*f*r*s + 112*C*D1*Dd*Pk2*f*r + 32*C*D1*Dd*Pk2*f*s**2 + 16*C*D1*Dd*Pk2*f*s - 40*C*D1*Dd*Pk2*f + 1216*C*D1*Dd*Pk2*fd*r**2 + 2304*C*D1*Dd*Pk2*fd*r*s - 2112*C*D1*Dd*Pk2*fd*r + 1088*C*D1*Dd*Pk2*fd*s**2 - 2000*C*D1*Dd*Pk2*fd*s + 896*C*D1*Dd*Pk2*fd + 608*C*D1*Ddd*Pk2*f*r**2 + 1152*C*D1*Ddd*Pk2*f*r*s - 896*C*D1*Ddd*Pk2*f*r + 544*C*D1*Ddd*Pk2*f*s**2 - 848*C*D1*Ddd*Pk2*f*s + 440*C*D1*Ddd*Pk2*f + 1824*C*Dd**2*Pk2*f*r**2 + 3456*C*Dd**2*Pk2*f*r*s - 2688*C*Dd**2*Pk2*f*r + 1632*C*Dd**2*Pk2*f*s**2 - 2544*C*Dd**2*Pk2*f*s + 880*C*Dd**2*Pk2*f + 140*D1**2*K*Pk2*fd*r**2 + 280*D1**2*K*Pk2*fd*r*s + 40*D1**2*K*Pk2*fd*r + 140*D1**2*K*Pk2*fd*s**2 + 80*D1**2*K*Pk2*fd*s - 40*D1**2*K*Pk2*fd - 200*D1**2*K*Pk2*fdd*r**2 - 440*D1**2*K*Pk2*fdd*r*s - 40*D1**2*K*Pk2*fdd*r - 220*D1**2*K*Pk2*fdd*s**2 - 80*D1**2*K*Pk2*fdd*s + 40*D1**2*K*Pk2*fdd - 10*D1**2*K*Pkdd2*fd*k1**2*s**2 - 10*D1**2*Pk2*bdd1*(-2*K*(15*r**2 + 36*r*s - 22*r + 21*s**2 - 26*s + 12) + f*(21*r**2 + 6*r*(5*s - 4) + 9*s**2 - 16*s + 10) + 15*r**2 + 30*r*s - 20*r + 15*s**2 - 20*s + 10) - 180*D1**2*Pk2*f*fd*r**2 - 240*D1**2*Pk2*f*fd*r*s + 180*D1**2*Pk2*f*fd*r - 60*D1**2*Pk2*f*fd*s**2 + 120*D1**2*Pk2*f*fd*s - 90*D1**2*Pk2*f*fd + 180*D1**2*Pk2*f*fdd*r**2 + 240*D1**2*Pk2*f*fdd*r*s - 180*D1**2*Pk2*f*fdd*r + 60*D1**2*Pk2*f*fdd*s**2 - 120*D1**2*Pk2*f*fdd*s + 90*D1**2*Pk2*f*fdd + 180*D1**2*Pk2*fd**2*r**2 + 240*D1**2*Pk2*fd**2*r*s - 180*D1**2*Pk2*fd**2*r + 60*D1**2*Pk2*fd**2*s**2 - 120*D1**2*Pk2*fd**2*s + 8*D1**2*Pk2*fd*r**2 - 52*D1**2*Pk2*fd*r*s + 4*D1**2*Pk2*fd*r - 60*D1**2*Pk2*fd*s**2 + 12*D1**2*Pk2*fd*s - 2*D1**2*Pk2*fd - 64*D1**2*Pk2*fdd*r**2 - 84*D1**2*Pk2*fdd*r*s + 228*D1**2*Pk2*fdd*r - 40*D1**2*Pk2*fdd*s**2 + 204*D1**2*Pk2*fdd*s - 114*D1**2*Pk2*fdd - 440*D1**2*Pk2*gd2*r**2 - 720*D1**2*Pk2*gd2*r*s + 880*D1**2*Pk2*gd2*r - 280*D1**2*Pk2*gd2*s**2 + 720*D1**2*Pk2*gd2*s - 440*D1**2*Pk2*gd2 - 200*D1**2*Pk2*gdd2*r**2 - 480*D1**2*Pk2*gdd2*r*s + 400*D1**2*Pk2*gdd2*r - 280*D1**2*Pk2*gdd2*s**2 + 480*D1**2*Pk2*gdd2*s - 200*D1**2*Pk2*gdd2 + 18*D1**2*Pkdd2*f*fd*k1**2*s**2 + 5*D1**2*Pkdd2*fd*k1**2*s**2 + 560*D1*Dd*K*Pk2*f*r**2 + 1120*D1*Dd*K*Pk2*f*r*s - 840*D1*Dd*K*Pk2*f*r + 560*D1*Dd*K*Pk2*f*s**2 - 840*D1*Dd*K*Pk2*f*s + 420*D1*Dd*K*Pk2*f - 1600*D1*Dd*K*Pk2*fd*r**2 - 3520*D1*Dd*K*Pk2*fd*r*s + 1080*D1*Dd*K*Pk2*fd*r - 1760*D1*Dd*K*Pk2*fd*s**2 + 1000*D1*Dd*K*Pk2*fd*s + 160*D1*Dd*K*Pk2*fd - 40*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 20*D1*Dd*K*Pkdd2*f*k1**2*s - 10*D1*Dd*K*Pkdd2*f*k1**2 - 360*D1*Dd*Pk2*f**2*r**2 - 480*D1*Dd*Pk2*f**2*r*s + 480*D1*Dd*Pk2*f**2*r - 120*D1*Dd*Pk2*f**2*s**2 + 300*D1*Dd*Pk2*f**2*s - 210*D1*Dd*Pk2*f**2 + 1440*D1*Dd*Pk2*f*fd*r**2 + 1920*D1*Dd*Pk2*f*fd*r*s - 1680*D1*Dd*Pk2*f*fd*r + 480*D1*Dd*Pk2*f*fd*s**2 - 1080*D1*Dd*Pk2*f*fd*s + 480*D1*Dd*Pk2*f*fd + 32*D1*Dd*Pk2*f*r**2 - 208*D1*Dd*Pk2*f*r*s + 20*D1*Dd*Pk2*f*r - 240*D1*Dd*Pk2*f*s**2 + 224*D1*Dd*Pk2*f*s - 44*D1*Dd*Pk2*f - 512*D1*Dd*Pk2*fd*r**2 - 672*D1*Dd*Pk2*fd*r*s + 1252*D1*Dd*Pk2*fd*r - 320*D1*Dd*Pk2*fd*s**2 + 1064*D1*Dd*Pk2*fd*s - 660*D1*Dd*Pk2*fd - 1760*D1*Dd*Pk2*g2*r**2 - 2880*D1*Dd*Pk2*g2*r*s + 2480*D1*Dd*Pk2*g2*r - 1120*D1*Dd*Pk2*g2*s**2 + 2000*D1*Dd*Pk2*g2*s - 1160*D1*Dd*Pk2*g2 - 1600*D1*Dd*Pk2*gd2*r**2 - 3840*D1*Dd*Pk2*gd2*r*s + 2880*D1*Dd*Pk2*gd2*r - 2240*D1*Dd*Pk2*gd2*s**2 + 3440*D1*Dd*Pk2*gd2*s - 1280*D1*Dd*Pk2*gd2 + 36*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**2*k1**2*s + 9*D1*Dd*Pkdd2*f**2*k1**2 + 20*D1*Dd*Pkdd2*f*k1**2*s**2 - 10*D1*Dd*Pkdd2*f*k1**2*s + 5*D1*Dd*Pkdd2*f*k1**2 - 800*D1*Ddd*K*Pk2*f*r**2 - 1760*D1*Ddd*K*Pk2*f*r*s + 1240*D1*Ddd*K*Pk2*f*r - 880*D1*Ddd*K*Pk2*f*s**2 + 1320*D1*Ddd*K*Pk2*f*s - 620*D1*Ddd*K*Pk2*f + 360*D1*Ddd*Pk2*f**2*r**2 + 480*D1*Ddd*Pk2*f**2*r*s - 480*D1*Ddd*Pk2*f**2*r + 120*D1*Ddd*Pk2*f**2*s**2 - 300*D1*Ddd*Pk2*f**2*s + 210*D1*Ddd*Pk2*f**2 - 256*D1*Ddd*Pk2*f*r**2 - 336*D1*Ddd*Pk2*f*r*s + 340*D1*Ddd*Pk2*f*r - 160*D1*Ddd*Pk2*f*s**2 + 248*D1*Ddd*Pk2*f*s - 168*D1*Ddd*Pk2*f - 800*D1*Ddd*Pk2*g2*r**2 - 1920*D1*Ddd*Pk2*g2*r*s + 1280*D1*Ddd*Pk2*g2*r - 1120*D1*Ddd*Pk2*g2*s**2 + 1520*D1*Ddd*Pk2*g2*s - 680*D1*Ddd*Pk2*g2 + 10*D1*Pk2*bd1*(D1*(66*K*r**2 + 108*K*r*s - 80*K*r + 42*K*s**2 - 64*K*s + 36*K + f*(15*r**2 + 2*r*(9*s - 8) + 3*s**2 - 8*s + 6) - 2*fd*(21*r**2 + 30*r*s - 33*r + 9*s**2 - 23*s + 12) - 51*r**2 - 66*r*s + 56*r - 15*s**2 + 32*s - 22) - 2*Dd*(-2*K*(60*r**2 + 144*r*s - 92*r + 84*s**2 - 109*s + 35) + f*(84*r**2 + 15*r*(8*s - 7) + 36*s**2 - 71*s + 32) + 60*r**2 + 120*r*s - 85*r + 60*s**2 - 85*s + 30)) - 2400*Dd**2*K*Pk2*f*r**2 - 5280*Dd**2*K*Pk2*f*r*s + 3720*Dd**2*K*Pk2*f*r - 2640*Dd**2*K*Pk2*f*s**2 + 3960*Dd**2*K*Pk2*f*s - 1280*Dd**2*K*Pk2*f + 1080*Dd**2*Pk2*f**2*r**2 + 1440*Dd**2*Pk2*f**2*r*s - 1440*Dd**2*Pk2*f**2*r + 360*Dd**2*Pk2*f**2*s**2 - 900*Dd**2*Pk2*f**2*s + 420*Dd**2*Pk2*f**2 - 768*Dd**2*Pk2*f*r**2 - 1008*Dd**2*Pk2*f*r*s + 1020*Dd**2*Pk2*f*r - 480*Dd**2*Pk2*f*s**2 + 744*Dd**2*Pk2*f*s - 296*Dd**2*Pk2*f - 2400*Dd**2*Pk2*g2*r**2 - 5760*Dd**2*Pk2*g2*r*s + 3840*Dd**2*Pk2*g2*r - 3360*Dd**2*Pk2*g2*s**2 + 4560*Dd**2*Pk2*g2*s - 1360*Dd**2*Pk2*g2) + b1*(-2128*C*D1**2*Pk2*bdd1*f*r**2 - 4032*C*D1**2*Pk2*bdd1*f*r*s + 2016*C*D1**2*Pk2*bdd1*f*r - 1904*C*D1**2*Pk2*bdd1*f*s**2 + 1904*C*D1**2*Pk2*bdd1*f*s - 952*C*D1**2*Pk2*bdd1*f - 4464*C*D1**2*Pk2*f*fd*r**2 - 7008*C*D1**2*Pk2*f*fd*r*s + 4128*C*D1**2*Pk2*f*fd*r - 1904*C*D1**2*Pk2*f*fd*s**2 + 2832*C*D1**2*Pk2*f*fd*s - 1896*C*D1**2*Pk2*f*fd + 4416*C*D1**2*Pk2*f*fdd*r**2 + 8544*C*D1**2*Pk2*f*fdd*r*s - 4080*C*D1**2*Pk2*f*fdd*r + 3248*C*D1**2*Pk2*f*fdd*s**2 - 3600*C*D1**2*Pk2*f*fdd*s + 1872*C*D1**2*Pk2*f*fdd + 4416*C*D1**2*Pk2*fd**2*r**2 + 8544*C*D1**2*Pk2*fd**2*r*s - 4080*C*D1**2*Pk2*fd**2*r + 3248*C*D1**2*Pk2*fd**2*s**2 - 3600*C*D1**2*Pk2*fd**2*s - 336*C*D1**2*Pk2*fd**2 + 168*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 8928*C*D1*Dd*Pk2*f**2*r**2 - 14016*C*D1*Dd*Pk2*f**2*r*s + 12432*C*D1*Dd*Pk2*f**2*r - 3808*C*D1*Dd*Pk2*f**2*s**2 + 8912*C*D1*Dd*Pk2*f**2*s - 5416*C*D1*Dd*Pk2*f**2 + 35328*C*D1*Dd*Pk2*f*fd*r**2 + 68352*C*D1*Dd*Pk2*f*fd*r*s - 42528*C*D1*Dd*Pk2*f*fd*r + 25984*C*D1*Dd*Pk2*f*fd*s**2 - 37984*C*D1*Dd*Pk2*f*fd*s + 11760*C*D1*Dd*Pk2*f*fd + 336*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 168*C*D1*Dd*Pkdd2*f**2*k1**2*s + 84*C*D1*Dd*Pkdd2*f**2*k1**2 + 8832*C*D1*Ddd*Pk2*f**2*r**2 + 17088*C*D1*Ddd*Pk2*f**2*r*s - 13104*C*D1*Ddd*Pk2*f**2*r + 6496*C*D1*Ddd*Pk2*f**2*s**2 - 11792*C*D1*Ddd*Pk2*f**2*s + 6040*C*D1*Ddd*Pk2*f**2 + 26496*C*Dd**2*Pk2*f**2*r**2 + 51264*C*Dd**2*Pk2*f**2*r*s - 39312*C*Dd**2*Pk2*f**2*r + 19488*C*Dd**2*Pk2*f**2*s**2 - 35376*C*Dd**2*Pk2*f**2*s + 12960*C*Dd**2*Pk2*f**2 + 2800*D1**2*K*Pk2*bdd1*f*r**2 + 6160*D1**2*K*Pk2*bdd1*f*r*s - 6160*D1**2*K*Pk2*bdd1*f*r + 3080*D1**2*K*Pk2*bdd1*f*s**2 - 6720*D1**2*K*Pk2*bdd1*f*s + 3220*D1**2*K*Pk2*bdd1*f - 560*D1**2*K*Pk2*f*fd*r*s + 280*D1**2*K*Pk2*f*fd*r - 840*D1**2*K*Pk2*f*fd*s**2 + 840*D1**2*K*Pk2*f*fd*s - 420*D1**2*K*Pk2*f*fd + 560*D1**2*K*Pk2*f*fdd*r*s - 280*D1**2*K*Pk2*f*fdd*r + 840*D1**2*K*Pk2*f*fdd*s**2 - 840*D1**2*K*Pk2*f*fdd*s + 420*D1**2*K*Pk2*f*fdd + 560*D1**2*K*Pk2*fd**2*r*s - 280*D1**2*K*Pk2*fd**2*r + 840*D1**2*K*Pk2*fd**2*s**2 - 840*D1**2*K*Pk2*fd**2*s - 420*D1**2*Pk2*b2*fd*r**2 - 840*D1**2*Pk2*b2*fd*r*s - 420*D1**2*Pk2*b2*fd*s**2 + 700*D1**2*Pk2*b2*fdd*r**2 + 1400*D1**2*Pk2*b2*fdd*r*s + 700*D1**2*Pk2*b2*fdd*s**2 + 140*D1**2*Pk2*bd1**2*(-2*K*(15*r**2 + 36*r*s - 22*r + 21*s**2 - 26*s + 6) + f*(21*r**2 + 6*r*(5*s - 4) + 9*s**2 - 16*s + 5) + 15*r**2 + 30*r*s - 20*r + 15*s**2 - 20*s + 5) - 1260*D1**2*Pk2*bdd1*f**2*r**2 - 1680*D1**2*Pk2*bdd1*f**2*r*s + 2100*D1**2*Pk2*bdd1*f**2*r - 420*D1**2*Pk2*bdd1*f**2*s**2 + 1260*D1**2*Pk2*bdd1*f**2*s - 840*D1**2*Pk2*bdd1*f**2 + 896*D1**2*Pk2*bdd1*f*r**2 + 1176*D1**2*Pk2*bdd1*f*r*s + 112*D1**2*Pk2*bdd1*f*r + 560*D1**2*Pk2*bdd1*f*s**2 + 280*D1**2*Pk2*bdd1*f*s - 70*D1**2*Pk2*bdd1*f + 2800*D1**2*Pk2*bdd1*g2*r**2 + 6720*D1**2*Pk2*bdd1*g2*r*s - 3360*D1**2*Pk2*bdd1*g2*r + 3920*D1**2*Pk2*bdd1*g2*s**2 - 3920*D1**2*Pk2*bdd1*g2*s + 1960*D1**2*Pk2*bdd1*g2 + 700*D1**2*Pk2*bdd2*f*r**2 + 1400*D1**2*Pk2*bdd2*f*r*s - 1400*D1**2*Pk2*bdd2*f*r + 700*D1**2*Pk2*bdd2*f*s**2 - 1400*D1**2*Pk2*bdd2*f*s + 700*D1**2*Pk2*bdd2*f + 2388*D1**2*Pk2*f*fd*r**2 + 4032*D1**2*Pk2*f*fd*r*s - 2220*D1**2*Pk2*f*fd*r + 1260*D1**2*Pk2*f*fd*s**2 - 1680*D1**2*Pk2*f*fd*s + 1026*D1**2*Pk2*f*fd - 2748*D1**2*Pk2*f*fdd*r**2 - 5376*D1**2*Pk2*f*fdd*r*s + 2580*D1**2*Pk2*f*fdd*r - 1932*D1**2*Pk2*f*fdd*s**2 + 2352*D1**2*Pk2*f*fdd*s - 1206*D1**2*Pk2*f*fdd + 1960*D1**2*Pk2*f*gd2*r**2 + 3920*D1**2*Pk2*f*gd2*r*s - 3920*D1**2*Pk2*f*gd2*r + 1960*D1**2*Pk2*f*gd2*s**2 - 3920*D1**2*Pk2*f*gd2*s + 1960*D1**2*Pk2*f*gd2 - 2800*D1**2*Pk2*f*gdd2*r**2 - 6160*D1**2*Pk2*f*gdd2*r*s + 5600*D1**2*Pk2*f*gdd2*r - 3080*D1**2*Pk2*f*gdd2*s**2 + 6160*D1**2*Pk2*f*gdd2*s - 2800*D1**2*Pk2*f*gdd2 - 2748*D1**2*Pk2*fd**2*r**2 - 5376*D1**2*Pk2*fd**2*r*s + 2580*D1**2*Pk2*fd**2*r - 1932*D1**2*Pk2*fd**2*s**2 + 2352*D1**2*Pk2*fd**2*s + 168*D1**2*Pk2*fd**2 + 1960*D1**2*Pk2*fd*g2*r**2 + 3920*D1**2*Pk2*fd*g2*r*s + 560*D1**2*Pk2*fd*g2*r + 1960*D1**2*Pk2*fd*g2*s**2 + 1120*D1**2*Pk2*fd*g2*s - 560*D1**2*Pk2*fd*g2 - 5600*D1**2*Pk2*fd*gd2*r**2 - 12320*D1**2*Pk2*fd*gd2*r*s + 5040*D1**2*Pk2*fd*gd2*r - 6160*D1**2*Pk2*fd*gd2*s**2 + 5040*D1**2*Pk2*fd*gd2*s + 560*D1**2*Pk2*fd*gd2 - 2800*D1**2*Pk2*fdd*g2*r**2 - 6160*D1**2*Pk2*fdd*g2*r*s - 560*D1**2*Pk2*fdd*g2*r - 3080*D1**2*Pk2*fdd*g2*s**2 - 1120*D1**2*Pk2*fdd*g2*s + 560*D1**2*Pk2*fdd*g2 - 126*D1**2*Pkdd2*f*fd*k1**2*s**2 - 140*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 140*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 1120*D1*Dd*K*Pk2*f**2*r*s + 280*D1*Dd*K*Pk2*f**2*r - 1680*D1*Dd*K*Pk2*f**2*s**2 + 1400*D1*Dd*K*Pk2*f**2*s - 420*D1*Dd*K*Pk2*f**2 + 4480*D1*Dd*K*Pk2*f*fd*r*s - 1680*D1*Dd*K*Pk2*f*fd*r + 6720*D1*Dd*K*Pk2*f*fd*s**2 - 6160*D1*Dd*K*Pk2*f*fd*s + 1400*D1*Dd*K*Pk2*f*fd - 1680*D1*Dd*Pk2*b2*f*r**2 - 3360*D1*Dd*Pk2*b2*f*r*s + 2520*D1*Dd*Pk2*b2*f*r - 1680*D1*Dd*Pk2*b2*f*s**2 + 2520*D1*Dd*Pk2*b2*f*s - 1260*D1*Dd*Pk2*b2*f + 5600*D1*Dd*Pk2*b2*fd*r**2 + 11200*D1*Dd*Pk2*b2*fd*r*s - 4200*D1*Dd*Pk2*b2*fd*r + 5600*D1*Dd*Pk2*b2*fd*s**2 - 4200*D1*Dd*Pk2*b2*fd*s + 4776*D1*Dd*Pk2*f**2*r**2 + 8064*D1*Dd*Pk2*f**2*r*s - 6792*D1*Dd*Pk2*f**2*r + 2520*D1*Dd*Pk2*f**2*s**2 - 5292*D1*Dd*Pk2*f**2*s + 3018*D1*Dd*Pk2*f**2 - 21984*D1*Dd*Pk2*f*fd*r**2 - 43008*D1*Dd*Pk2*f*fd*r*s + 26688*D1*Dd*Pk2*f*fd*r - 15456*D1*Dd*Pk2*f*fd*s**2 + 24024*D1*Dd*Pk2*f*fd*s - 7512*D1*Dd*Pk2*f*fd + 7840*D1*Dd*Pk2*f*g2*r**2 + 15680*D1*Dd*Pk2*f*g2*r*s - 11760*D1*Dd*Pk2*f*g2*r + 7840*D1*Dd*Pk2*f*g2*s**2 - 11760*D1*Dd*Pk2*f*g2*s + 5880*D1*Dd*Pk2*f*g2 - 22400*D1*Dd*Pk2*f*gd2*r**2 - 49280*D1*Dd*Pk2*f*gd2*r*s + 39760*D1*Dd*Pk2*f*gd2*r - 24640*D1*Dd*Pk2*f*gd2*s**2 + 43120*D1*Dd*Pk2*f*gd2*s - 17360*D1*Dd*Pk2*f*gd2 - 22400*D1*Dd*Pk2*fd*g2*r**2 - 49280*D1*Dd*Pk2*fd*g2*r*s + 15120*D1*Dd*Pk2*fd*g2*r - 24640*D1*Dd*Pk2*fd*g2*s**2 + 14000*D1*Dd*Pk2*fd*g2*s + 2240*D1*Dd*Pk2*fd*g2 - 252*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 126*D1*Dd*Pkdd2*f**2*k1**2*s - 63*D1*Dd*Pkdd2*f**2*k1**2 - 560*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 280*D1*Dd*Pkdd2*f*g2*k1**2*s - 140*D1*Dd*Pkdd2*f*g2*k1**2 + 1120*D1*Ddd*K*Pk2*f**2*r*s - 280*D1*Ddd*K*Pk2*f**2*r + 1680*D1*Ddd*K*Pk2*f**2*s**2 - 1400*D1*Ddd*K*Pk2*f**2*s + 420*D1*Ddd*K*Pk2*f**2 + 2800*D1*Ddd*Pk2*b2*f*r**2 + 5600*D1*Ddd*Pk2*b2*f*r*s - 4200*D1*Ddd*Pk2*b2*f*r + 2800*D1*Ddd*Pk2*b2*f*s**2 - 4200*D1*Ddd*Pk2*b2*f*s + 2100*D1*Ddd*Pk2*b2*f - 5496*D1*Ddd*Pk2*f**2*r**2 - 10752*D1*Ddd*Pk2*f**2*r*s + 8184*D1*Ddd*Pk2*f**2*r - 3864*D1*Ddd*Pk2*f**2*s**2 + 7308*D1*Ddd*Pk2*f**2*s - 3714*D1*Ddd*Pk2*f**2 - 11200*D1*Ddd*Pk2*f*g2*r**2 - 24640*D1*Ddd*Pk2*f*g2*r*s + 17360*D1*Ddd*Pk2*f*g2*r - 12320*D1*Ddd*Pk2*f*g2*s**2 + 18480*D1*Ddd*Pk2*f*g2*s - 8680*D1*Ddd*Pk2*f*g2 - 140*D1*Pk2*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 7*D1*bd1*(D1*(-4*Pk2*fd*(4*C*(38*r**2 + 8*r*(9*s - 7) + 34*s**2 - 53*s + 18) - 10*K*(20*r**2 + 44*r*s - 20*r + 22*s**2 - 20*s - 1) - 64*r**2 - 84*r*s + 110*r - 40*s**2 + 92*s - 51) + 40*Pk2*(g2*(22*r**2 + 36*r*s - 18*r + 14*s**2 - 14*s + 7) + 2*gd2*(10*r**2 + 8*r*(3*s - 2) + 14*s**2 - 19*s + 6)) + 3*f**2*(20*Pk2*(3*r**2 + r*(4*s - 5) + s**2 - 3*s + 2) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(2*Pk2*(4*C*(6*r**2 + r*(4*s - 2) - 2*s**2 + 2*s - 1) - 140*K*r**2 - 280*K*r*s + 300*K*r - 140*K*s**2 + 320*K*s - 160*K - 30*fd*(12*r**2 + 16*r*(s - 1) + 4*s**2 - 10*s + 5) - 8*r**2 + 52*r*s - 16*r + 60*s**2 - 80*s + 25) + Pkdd2*k1**2*(10*K - 5)*(2*s**2 - 2*s + 1))) - 4*Dd*Pk2*(15*f**2*(24*r**2 + 4*r*(8*s - 9) + 8*s**2 - 22*s + 13) + 2*f*(2*C*(152*r**2 + 8*r*(36*s - 23) + 136*s**2 - 174*s + 53) - 10*K*(40*r**2 + 88*r*s - 75*r + 44*s**2 - 81*s + 34) - 128*r**2 - 168*r*s + 77*r - 80*s**2 + 42*s + 9) - 20*g2*(40*r**2 + 8*r*(12*s - 7) + 56*s**2 - 66*s + 19))) + 3360*Dd**2*K*Pk2*f**2*r*s - 840*Dd**2*K*Pk2*f**2*r + 5040*Dd**2*K*Pk2*f**2*s**2 - 4200*Dd**2*K*Pk2*f**2*s + 560*Dd**2*K*Pk2*f**2 + 8400*Dd**2*Pk2*b2*f*r**2 + 16800*Dd**2*Pk2*b2*f*r*s - 12600*Dd**2*Pk2*b2*f*r + 8400*Dd**2*Pk2*b2*f*s**2 - 12600*Dd**2*Pk2*b2*f*s + 4200*Dd**2*Pk2*b2*f - 16488*Dd**2*Pk2*f**2*r**2 - 32256*Dd**2*Pk2*f**2*r*s + 24552*Dd**2*Pk2*f**2*r - 11592*Dd**2*Pk2*f**2*s**2 + 21924*Dd**2*Pk2*f**2*s - 8124*Dd**2*Pk2*f**2 - 33600*Dd**2*Pk2*f*g2*r**2 - 73920*Dd**2*Pk2*f*g2*r*s + 52080*Dd**2*Pk2*f*g2*r - 36960*Dd**2*Pk2*f*g2*s**2 + 55440*Dd**2*Pk2*f*g2*s - 17920*Dd**2*Pk2*f*g2))/(210*d**2*k3**4) - D1**2*Pk3*ct*k1*st**4*(96*C*D1**2*Pk2*bdd1*f**2*r*s - 96*C*D1**2*Pk2*bdd1*f**2*s**2 - 960*C*D1**2*Pk2*f**2*fd*s**2 + 640*C*D1**2*Pk2*f**2*fd*s - 320*C*D1**2*Pk2*f**2*fd + 480*C*D1**2*Pk2*f**2*fdd*s**2 - 320*C*D1**2*Pk2*f**2*fdd*s + 160*C*D1**2*Pk2*f**2*fdd + 960*C*D1**2*Pk2*f*fd**2*s**2 - 640*C*D1**2*Pk2*f*fd**2*s - 1280*C*D1*Dd*Pk2*f**3*s**2 + 640*C*D1*Dd*Pk2*f**3*s - 320*C*D1*Dd*Pk2*f**3 + 3840*C*D1*Dd*Pk2*f**2*fd*s**2 - 2240*C*D1*Dd*Pk2*f**2*fd*s + 320*C*D1*Dd*Pk2*f**2*fd + 640*C*D1*Ddd*Pk2*f**3*s**2 - 320*C*D1*Ddd*Pk2*f**3*s + 160*C*D1*Ddd*Pk2*f**3 + 1920*C*Dd**2*Pk2*f**3*s**2 - 960*C*Dd**2*Pk2*f**3*s + 240*D1**2*K*Pk2*bdd1*f**2*s**2 - 960*D1**2*Pk2*b2*f*fd*s**2 + 960*D1**2*Pk2*b2*f*fd*s - 480*D1**2*Pk2*b2*f*fd + 480*D1**2*Pk2*b2*f*fdd*s**2 - 480*D1**2*Pk2*b2*f*fdd*s + 240*D1**2*Pk2*b2*f*fdd + 480*D1**2*Pk2*b2*fd**2*s**2 - 480*D1**2*Pk2*b2*fd**2*s + 48*D1**2*Pk2*bd1**2*f*s*(7*K*(2*r - 2*s - 1) + 5*f - 14*r + 14) - 480*D1**2*Pk2*bd2*f**2*s**2 + 960*D1**2*Pk2*bd2*f*fd*s**2 - 480*D1**2*Pk2*bd2*f*fd*s + 720*D1**2*Pk2*bdd1*f**3*r*s + 660*D1**2*Pk2*bdd1*f**3*s**2 - 480*D1**2*Pk2*bdd1*f**3*s + 480*D1**2*Pk2*bdd1*f**2*r*s + 924*D1**2*Pk2*bdd1*f**2*s**2 - 528*D1**2*Pk2*bdd1*f**2*s - 24*D1**2*Pk2*bdd1*f**2 - 672*D1**2*Pk2*bdd1*f*g2*r*s + 672*D1**2*Pk2*bdd1*f*g2*s**2 + 240*D1**2*Pk2*bdd2*f**2*s**2 - 720*D1**2*Pk2*f**2*fd*r*s + 240*D1**2*Pk2*f**2*fd*r - 156*D1**2*Pk2*f**2*fd*s**2 + 344*D1**2*Pk2*f**2*fd*s - 52*D1**2*Pk2*f**2*fd + 576*D1**2*Pk2*f**2*fdd*r*s - 192*D1**2*Pk2*f**2*fdd*r + 204*D1**2*Pk2*f**2*fdd*s**2 - 328*D1**2*Pk2*f**2*fdd*s + 68*D1**2*Pk2*f**2*fdd + 960*D1**2*Pk2*f**2*gd2*s**2 - 480*D1**2*Pk2*f**2*gdd2*s**2 + 1152*D1**2*Pk2*f*fd**2*r*s - 384*D1**2*Pk2*f*fd**2*r + 408*D1**2*Pk2*f*fd**2*s**2 - 656*D1**2*Pk2*f*fd**2*s + 192*D1**2*Pk2*f*fd**2 + 1920*D1**2*Pk2*f*fd*g2*s**2 - 1920*D1**2*Pk2*f*fd*g2*s + 960*D1**2*Pk2*f*fd*g2 - 1920*D1**2*Pk2*f*fd*gd2*s**2 + 960*D1**2*Pk2*f*fd*gd2*s - 960*D1**2*Pk2*f*fdd*g2*s**2 + 960*D1**2*Pk2*f*fdd*g2*s - 480*D1**2*Pk2*f*fdd*g2 - 960*D1**2*Pk2*fd**2*g2*s**2 + 960*D1**2*Pk2*fd**2*g2*s - 10*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 3*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 6*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 4*D1**2*Pkdd2*f**2*fd*k1**2*s + 2*D1**2*Pkdd2*f**2*fd*k1**2 - 3*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 2*D1**2*Pkdd2*f**2*fdd*k1**2*s - D1**2*Pkdd2*f**2*fdd*k1**2 - 6*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 4*D1**2*Pkdd2*f*fd**2*k1**2*s - 1920*D1*Dd*Pk2*b2*f**2*s**2 + 960*D1*Dd*Pk2*b2*f**2*s - 480*D1*Dd*Pk2*b2*f**2 + 3840*D1*Dd*Pk2*b2*f*fd*s**2 - 2880*D1*Dd*Pk2*b2*f*fd*s + 480*D1*Dd*Pk2*b2*f*fd + 1920*D1*Dd*Pk2*bd2*f**2*s**2 - 480*D1*Dd*Pk2*bd2*f**2*s - 960*D1*Dd*Pk2*f**3*r*s + 240*D1*Dd*Pk2*f**3*r - 208*D1*Dd*Pk2*f**3*s**2 + 584*D1*Dd*Pk2*f**3*s - 52*D1*Dd*Pk2*f**3 + 4608*D1*Dd*Pk2*f**2*fd*r*s - 1344*D1*Dd*Pk2*f**2*fd*r + 1632*D1*Dd*Pk2*f**2*fd*s**2 - 2872*D1*Dd*Pk2*f**2*fd*s + 712*D1*Dd*Pk2*f**2*fd + 3840*D1*Dd*Pk2*f**2*g2*s**2 - 1920*D1*Dd*Pk2*f**2*g2*s + 960*D1*Dd*Pk2*f**2*g2 - 3840*D1*Dd*Pk2*f**2*gd2*s**2 + 960*D1*Dd*Pk2*f**2*gd2*s - 7680*D1*Dd*Pk2*f*fd*g2*s**2 + 5760*D1*Dd*Pk2*f*fd*g2*s - 960*D1*Dd*Pk2*f*fd*g2 + 8*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**3*k1**2*s + 2*D1*Dd*Pkdd2*f**3*k1**2 - 24*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 14*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 2*D1*Dd*Pkdd2*f**2*fd*k1**2 + 960*D1*Ddd*Pk2*b2*f**2*s**2 - 480*D1*Ddd*Pk2*b2*f**2*s + 240*D1*Ddd*Pk2*b2*f**2 + 768*D1*Ddd*Pk2*f**3*r*s - 192*D1*Ddd*Pk2*f**3*r + 272*D1*Ddd*Pk2*f**3*s**2 - 520*D1*Ddd*Pk2*f**3*s + 68*D1*Ddd*Pk2*f**3 - 1920*D1*Ddd*Pk2*f**2*g2*s**2 + 960*D1*Ddd*Pk2*f**2*g2*s - 480*D1*Ddd*Pk2*f**2*g2 - 4*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**3*k1**2*s - D1*Ddd*Pkdd2*f**3*k1**2 - 2*D1*bd1*(D1*(-336*Pk2*fd*g2*(-2*r*s + r + s*(2*s - 2)) + 10*f**3*s*(3*Pk2*(12*r + 15*s - 8) - Pkdd2*k1**2*s) + f**2*(-6*Pk2*(10*fd*(6*r*(6*s - 1) + 33*s**2 - 31*s + 4) + s**2*(16*C - 40*K - 105) - s*(16*C*r + 52*r - 60) + 4) + Pkdd2*k1**2*s*(10*fd*(3*s - 1) - 3*s)) - 3*f*(4*Pk2*fd*(r*(4*C + 20)*(4*s - 1) + s**2*(-16*C + 40*K + 154) + s*(4*C - 20*K - 119) + 24) + 112*Pk2*s*(2*g2*r - 2*g2*s - 2*gd2*r + 2*gd2*s + gd2) + Pkdd2*fd*k1**2*s*(1 - 2*s))) - Dd*f*(336*Pk2*g2*(-8*r*s + r + 8*s**2) + 10*f**2*(6*Pk2*(6*r*(8*s - 1) + 44*s**2 - 39*s + 4) + Pkdd2*k1**2*s*(1 - 4*s)) + 3*f*(4*Pk2*(r*(4*C + 20)*(8*s - 1) + s**2*(-32*C + 80*K + 308) - s*(20*K + 205) + 22) + Pkdd2*k1**2*s*(1 - 4*s)))) + 2880*Dd**2*Pk2*b2*f**2*s**2 - 1440*Dd**2*Pk2*b2*f**2*s + 2304*Dd**2*Pk2*f**3*r*s - 576*Dd**2*Pk2*f**3*r + 816*Dd**2*Pk2*f**3*s**2 - 1560*Dd**2*Pk2*f**3*s + 384*Dd**2*Pk2*f**3 - 5760*Dd**2*Pk2*f**2*g2*s**2 + 2880*Dd**2*Pk2*f**2*g2*s - 12*Dd**2*Pkdd2*f**3*k1**2*s**2 + 6*Dd**2*Pkdd2*f**3*k1**2*s + 24*Pk2*b1**2*(-2*D1*Dd*(14*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s) + fd*(56*K*s**2 - 56*K*s + 5*f*(4*s - 1) - r*(7*K - 7)*(8*s - 5) + 14*s + 7)) - D1*(D1*(-10*f*fd*(2*s - 1) + 5*f*fdd*(2*s - 1) + 10*fd**2*s + 14*fd*(2*K*(s - 1)*(r - s + 1) - 2*r*s + 2*r - 2*s + 1) - 7*fdd*(2*K*(s - 1)*(r - s + 1) - 2*r*s + 2*r - 2*s + 1)) - 14*Ddd*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s)) + 14*Dd**2*f*(K*(12*r*s - 3*r - 12*s**2 + 2) - 12*r*s + 3*r + 6*s - 2)) + b1*(-384*C*D1**2*Pk2*f*fd*r*s + 192*C*D1**2*Pk2*f*fd*r + 384*C*D1**2*Pk2*f*fd*s**2 - 192*C*D1**2*Pk2*f*fd*s + 192*C*D1**2*Pk2*f*fd + 192*C*D1**2*Pk2*f*fdd*r*s - 96*C*D1**2*Pk2*f*fdd*r - 192*C*D1**2*Pk2*f*fdd*s**2 + 96*C*D1**2*Pk2*f*fdd*s - 96*C*D1**2*Pk2*f*fdd + 192*C*D1**2*Pk2*fd**2*r*s - 96*C*D1**2*Pk2*fd**2*r - 192*C*D1**2*Pk2*fd**2*s**2 + 96*C*D1**2*Pk2*fd**2*s + 96*C*D1**2*Pk2*fd**2 - 768*C*D1*Dd*Pk2*f**2*r*s + 192*C*D1*Dd*Pk2*f**2*r + 768*C*D1*Dd*Pk2*f**2*s**2 + 192*C*D1*Dd*Pk2*f**2 + 1536*C*D1*Dd*Pk2*f*fd*r*s - 576*C*D1*Dd*Pk2*f*fd*r - 1536*C*D1*Dd*Pk2*f*fd*s**2 + 384*C*D1*Dd*Pk2*f*fd*s + 96*C*D1*Dd*Pk2*f*fd + 384*C*D1*Ddd*Pk2*f**2*r*s - 96*C*D1*Ddd*Pk2*f**2*r - 384*C*D1*Ddd*Pk2*f**2*s**2 - 96*C*D1*Ddd*Pk2*f**2 + 1152*C*Dd**2*Pk2*f**2*r*s - 288*C*Dd**2*Pk2*f**2*r - 1152*C*Dd**2*Pk2*f**2*s**2 + 192*C*Dd**2*Pk2*f**2 - 960*D1**2*K*Pk2*f*fd*s**2 + 960*D1**2*K*Pk2*f*fd*s - 480*D1**2*K*Pk2*f*fd + 480*D1**2*K*Pk2*f*fdd*s**2 - 480*D1**2*K*Pk2*f*fdd*s + 240*D1**2*K*Pk2*f*fdd + 480*D1**2*K*Pk2*fd**2*s**2 - 480*D1**2*K*Pk2*fd**2*s + 24*D1**2*Pk2*bdd1*f*(-28*K*s**2 + 5*f*(2*s - 1) - 7*s*(-4*K*r + 2*K + 4*r - 4) - 7) - 2160*D1**2*Pk2*f**2*fd*r*s + 720*D1**2*Pk2*f**2*fd*r - 2700*D1**2*Pk2*f**2*fd*s**2 + 2760*D1**2*Pk2*f**2*fd*s - 900*D1**2*Pk2*f**2*fd + 2160*D1**2*Pk2*f**2*fdd*r*s - 720*D1**2*Pk2*f**2*fdd*r + 1980*D1**2*Pk2*f**2*fdd*s**2 - 2280*D1**2*Pk2*f**2*fdd*s + 660*D1**2*Pk2*f**2*fdd + 4320*D1**2*Pk2*f*fd**2*r*s - 1440*D1**2*Pk2*f*fd**2*r + 3960*D1**2*Pk2*f*fd**2*s**2 - 4560*D1**2*Pk2*f*fd**2*s + 960*D1**2*Pk2*f*fd**2 - 1248*D1**2*Pk2*f*fd*r*s + 624*D1**2*Pk2*f*fd*r - 2520*D1**2*Pk2*f*fd*s**2 + 2424*D1**2*Pk2*f*fd*s - 1308*D1**2*Pk2*f*fd + 960*D1**2*Pk2*f*fdd*r*s - 480*D1**2*Pk2*f*fdd*r + 1848*D1**2*Pk2*f*fdd*s**2 - 1800*D1**2*Pk2*f*fdd*s + 948*D1**2*Pk2*f*fdd + 1344*D1**2*Pk2*f*gd2*r*s - 1344*D1**2*Pk2*f*gd2*s**2 - 1344*D1**2*Pk2*f*gd2*s - 672*D1**2*Pk2*f*gdd2*r*s + 672*D1**2*Pk2*f*gdd2*s**2 + 672*D1**2*Pk2*f*gdd2*s + 960*D1**2*Pk2*fd**2*r*s - 480*D1**2*Pk2*fd**2*r + 1848*D1**2*Pk2*fd**2*s**2 - 1800*D1**2*Pk2*fd**2*s - 96*D1**2*Pk2*fd**2 + 1344*D1**2*Pk2*fd*g2*r*s - 1344*D1**2*Pk2*fd*g2*r - 1344*D1**2*Pk2*fd*g2*s**2 + 2688*D1**2*Pk2*fd*g2*s - 1344*D1**2*Pk2*fd*g2 - 1344*D1**2*Pk2*fd*gd2*r*s + 672*D1**2*Pk2*fd*gd2*r + 1344*D1**2*Pk2*fd*gd2*s**2 - 672*D1**2*Pk2*fd*gd2*s - 672*D1**2*Pk2*fd*gd2 - 672*D1**2*Pk2*fdd*g2*r*s + 672*D1**2*Pk2*fdd*g2*r + 672*D1**2*Pk2*fdd*g2*s**2 - 1344*D1**2*Pk2*fdd*g2*s + 672*D1**2*Pk2*fdd*g2 + 60*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 40*D1**2*Pkdd2*f**2*fd*k1**2*s + 20*D1**2*Pkdd2*f**2*fd*k1**2 - 30*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 20*D1**2*Pkdd2*f**2*fdd*k1**2*s - 10*D1**2*Pkdd2*f**2*fdd*k1**2 - 60*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 40*D1**2*Pkdd2*f*fd**2*k1**2*s + 12*D1**2*Pkdd2*f*fd*k1**2*s**2 - 12*D1**2*Pkdd2*f*fd*k1**2*s + 6*D1**2*Pkdd2*f*fd*k1**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 6*D1**2*Pkdd2*f*fdd*k1**2*s - 3*D1**2*Pkdd2*f*fdd*k1**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s**2 + 6*D1**2*Pkdd2*fd**2*k1**2*s - 1920*D1*Dd*K*Pk2*f**2*s**2 + 960*D1*Dd*K*Pk2*f**2*s - 480*D1*Dd*K*Pk2*f**2 + 3840*D1*Dd*K*Pk2*f*fd*s**2 - 2880*D1*Dd*K*Pk2*f*fd*s + 480*D1*Dd*K*Pk2*f*fd - 2880*D1*Dd*Pk2*f**3*r*s + 720*D1*Dd*Pk2*f**3*r - 3600*D1*Dd*Pk2*f**3*s**2 + 3240*D1*Dd*Pk2*f**3*s - 900*D1*Dd*Pk2*f**3 + 17280*D1*Dd*Pk2*f**2*fd*r*s - 5040*D1*Dd*Pk2*f**2*fd*r + 15840*D1*Dd*Pk2*f**2*fd*s**2 - 17400*D1*Dd*Pk2*f**2*fd*s + 3720*D1*Dd*Pk2*f**2*fd - 2496*D1*Dd*Pk2*f**2*r*s + 624*D1*Dd*Pk2*f**2*r - 5040*D1*Dd*Pk2*f**2*s**2 + 3768*D1*Dd*Pk2*f**2*s - 1260*D1*Dd*Pk2*f**2 + 7680*D1*Dd*Pk2*f*fd*r*s - 2880*D1*Dd*Pk2*f*fd*r + 14784*D1*Dd*Pk2*f*fd*s**2 - 12816*D1*Dd*Pk2*f*fd*s + 2760*D1*Dd*Pk2*f*fd + 5376*D1*Dd*Pk2*f*g2*r*s - 1344*D1*Dd*Pk2*f*g2*r - 5376*D1*Dd*Pk2*f*g2*s**2 - 1344*D1*Dd*Pk2*f*g2 - 5376*D1*Dd*Pk2*f*gd2*r*s + 672*D1*Dd*Pk2*f*gd2*r + 5376*D1*Dd*Pk2*f*gd2*s**2 + 2688*D1*Dd*Pk2*f*gd2*s - 672*D1*Dd*Pk2*f*gd2 - 5376*D1*Dd*Pk2*fd*g2*r*s + 3360*D1*Dd*Pk2*fd*g2*r + 5376*D1*Dd*Pk2*fd*g2*s**2 - 5376*D1*Dd*Pk2*fd*g2*s + 80*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 40*D1*Dd*Pkdd2*f**3*k1**2*s + 20*D1*Dd*Pkdd2*f**3*k1**2 - 240*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 140*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 20*D1*Dd*Pkdd2*f**2*fd*k1**2 + 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 12*D1*Dd*Pkdd2*f**2*k1**2*s + 6*D1*Dd*Pkdd2*f**2*k1**2 - 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 36*D1*Dd*Pkdd2*f*fd*k1**2*s - 6*D1*Dd*Pkdd2*f*fd*k1**2 + 960*D1*Ddd*K*Pk2*f**2*s**2 - 480*D1*Ddd*K*Pk2*f**2*s + 240*D1*Ddd*K*Pk2*f**2 + 2880*D1*Ddd*Pk2*f**3*r*s - 720*D1*Ddd*Pk2*f**3*r + 2640*D1*Ddd*Pk2*f**3*s**2 - 2760*D1*Ddd*Pk2*f**3*s + 660*D1*Ddd*Pk2*f**3 + 1920*D1*Ddd*Pk2*f**2*r*s - 480*D1*Ddd*Pk2*f**2*r + 3696*D1*Ddd*Pk2*f**2*s**2 - 2808*D1*Ddd*Pk2*f**2*s + 924*D1*Ddd*Pk2*f**2 - 2688*D1*Ddd*Pk2*f*g2*r*s + 672*D1*Ddd*Pk2*f*g2*r + 2688*D1*Ddd*Pk2*f*g2*s**2 + 672*D1*Ddd*Pk2*f*g2 - 40*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 20*D1*Ddd*Pkdd2*f**3*k1**2*s - 10*D1*Ddd*Pkdd2*f**3*k1**2 - 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*D1*Ddd*Pkdd2*f**2*k1**2 - 48*D1*Pk2*bd1*(D1*(5*f**2*(2*s - 1) - 7*f*(4*K*s**2 + s*(-4*K*r + 2*K + 4*r - 4) + 1) - 7*fd*(K*(4*r*s - 2*r - 4*s**2 + 3*s + 1) - 4*r*s + 2*r - 1)) + Dd*f*(-7*K*(16*r*s - 2*r - 16*s**2 - 4*s + 1) + f*(5 - 20*s) + 112*r*s - 14*r - 84*s + 14)) + 2880*Dd**2*K*Pk2*f**2*s**2 - 1440*Dd**2*K*Pk2*f**2*s + 8640*Dd**2*Pk2*f**3*r*s - 2160*Dd**2*Pk2*f**3*r + 7920*Dd**2*Pk2*f**3*s**2 - 8280*Dd**2*Pk2*f**3*s + 1440*Dd**2*Pk2*f**3 + 5760*Dd**2*Pk2*f**2*r*s - 1440*Dd**2*Pk2*f**2*r + 11088*Dd**2*Pk2*f**2*s**2 - 8424*Dd**2*Pk2*f**2*s + 960*Dd**2*Pk2*f**2 - 8064*Dd**2*Pk2*f*g2*r*s + 2016*Dd**2*Pk2*f*g2*r + 8064*Dd**2*Pk2*f*g2*s**2 - 1344*Dd**2*Pk2*f*g2 - 120*Dd**2*Pkdd2*f**3*k1**2*s**2 + 60*Dd**2*Pkdd2*f**3*k1**2*s - 36*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*Dd**2*Pkdd2*f**2*k1**2*s))/(210*d**2*k2*k3**2) + D1**2*Pk3*ct*k1*st**2*(912*C*D1**2*Pk2*bdd1*f**2*r*s - 1272*C*D1**2*Pk2*bdd1*f**2*s**2 - 1584*C*D1**2*Pk2*f**2*fd*r*s + 528*C*D1**2*Pk2*f**2*fd*r - 5832*C*D1**2*Pk2*f**2*fd*s**2 + 4416*C*D1**2*Pk2*f**2*fd*s - 1944*C*D1**2*Pk2*f**2*fd + 1872*C*D1**2*Pk2*f**2*fdd*r*s - 624*C*D1**2*Pk2*f**2*fdd*r + 4536*C*D1**2*Pk2*f**2*fdd*s**2 - 3648*C*D1**2*Pk2*f**2*fdd*s + 1512*C*D1**2*Pk2*f**2*fdd + 3744*C*D1**2*Pk2*f*fd**2*r*s - 1248*C*D1**2*Pk2*f*fd**2*r + 9072*C*D1**2*Pk2*f*fd**2*s**2 - 7296*C*D1**2*Pk2*f*fd**2*s + 624*C*D1**2*Pk2*f*fd**2 - 2112*C*D1*Dd*Pk2*f**3*r*s + 528*C*D1*Dd*Pk2*f**3*r - 7776*C*D1*Dd*Pk2*f**3*s**2 + 4944*C*D1*Dd*Pk2*f**3*s - 1944*C*D1*Dd*Pk2*f**3 + 14976*C*D1*Dd*Pk2*f**2*fd*r*s - 4368*C*D1*Dd*Pk2*f**2*fd*r + 36288*C*D1*Dd*Pk2*f**2*fd*s**2 - 27408*C*D1*Dd*Pk2*f**2*fd*s + 4896*C*D1*Dd*Pk2*f**2*fd + 2496*C*D1*Ddd*Pk2*f**3*r*s - 624*C*D1*Ddd*Pk2*f**3*r + 6048*C*D1*Ddd*Pk2*f**3*s**2 - 4272*C*D1*Ddd*Pk2*f**3*s + 1512*C*D1*Ddd*Pk2*f**3 + 7488*C*Dd**2*Pk2*f**3*r*s - 1872*C*Dd**2*Pk2*f**3*r + 18144*C*Dd**2*Pk2*f**3*s**2 - 12816*C*Dd**2*Pk2*f**3*s + 1248*C*Dd**2*Pk2*f**3 + 504*D1**2*K*Pk2*bdd1*f**2*r*s + 1764*D1**2*K*Pk2*bdd1*f**2*s**2 - 504*D1**2*K*Pk2*bdd1*f**2*s - 1008*D1**2*Pk2*b2*f*fd*r*s + 504*D1**2*Pk2*b2*f*fd*r - 4536*D1**2*Pk2*b2*f*fd*s**2 + 4536*D1**2*Pk2*b2*f*fd*s - 2268*D1**2*Pk2*b2*f*fd + 1008*D1**2*Pk2*b2*f*fdd*r*s - 504*D1**2*Pk2*b2*f*fdd*r + 3528*D1**2*Pk2*b2*f*fdd*s**2 - 3528*D1**2*Pk2*b2*f*fdd*s + 1764*D1**2*Pk2*b2*f*fdd + 1008*D1**2*Pk2*b2*fd**2*r*s - 504*D1**2*Pk2*b2*fd**2*r + 3528*D1**2*Pk2*b2*fd**2*s**2 - 3528*D1**2*Pk2*b2*fd**2*s - 504*D1**2*Pk2*bd2*f**2*r*s - 2268*D1**2*Pk2*bd2*f**2*s**2 + 504*D1**2*Pk2*bd2*f**2*s + 2016*D1**2*Pk2*bd2*f*fd*r*s - 504*D1**2*Pk2*bd2*f*fd*r + 7056*D1**2*Pk2*bd2*f*fd*s**2 - 4536*D1**2*Pk2*bd2*f*fd*s + 504*D1**2*Pk2*bd2*f*fd + 756*D1**2*Pk2*bdd1*f**3*r**2 + 3024*D1**2*Pk2*bdd1*f**3*r*s - 756*D1**2*Pk2*bdd1*f**3*r + 1260*D1**2*Pk2*bdd1*f**3*s**2 - 2016*D1**2*Pk2*bdd1*f**3*s + 378*D1**2*Pk2*bdd1*f**3 + 462*D1**2*Pk2*bdd1*f**2*r**2 + 1032*D1**2*Pk2*bdd1*f**2*r*s - 348*D1**2*Pk2*bdd1*f**2*r + 2400*D1**2*Pk2*bdd1*f**2*s**2 - 1884*D1**2*Pk2*bdd1*f**2*s + 144*D1**2*Pk2*bdd1*f**2 - 3024*D1**2*Pk2*bdd1*f*g2*r*s + 5208*D1**2*Pk2*bdd1*f*g2*s**2 + 504*D1**2*Pk2*bdd2*f**2*r*s + 1764*D1**2*Pk2*bdd2*f**2*s**2 - 504*D1**2*Pk2*bdd2*f**2*s - 798*D1**2*Pk2*f**2*fd*r**2 - 3672*D1**2*Pk2*f**2*fd*r*s + 1756*D1**2*Pk2*f**2*fd*r + 1512*D1**2*Pk2*f**2*fd*s**2 + 216*D1**2*Pk2*f**2*fd*s + 238*D1**2*Pk2*f**2*fd + 858*D1**2*Pk2*f**2*fdd*r**2 + 2592*D1**2*Pk2*f**2*fdd*r*s - 1436*D1**2*Pk2*f**2*fdd*r - 864*D1**2*Pk2*f**2*fdd*s**2 - 288*D1**2*Pk2*f**2*fdd*s - 2*D1**2*Pk2*f**2*fdd + 1008*D1**2*Pk2*f**2*gd2*r*s + 4536*D1**2*Pk2*f**2*gd2*s**2 - 1008*D1**2*Pk2*f**2*gd2*s - 1008*D1**2*Pk2*f**2*gdd2*r*s - 3528*D1**2*Pk2*f**2*gdd2*s**2 + 1008*D1**2*Pk2*f**2*gdd2*s + 1716*D1**2*Pk2*f*fd**2*r**2 + 5184*D1**2*Pk2*f*fd**2*r*s - 2872*D1**2*Pk2*f*fd**2*r - 1728*D1**2*Pk2*f*fd**2*s**2 - 576*D1**2*Pk2*f*fd**2*s + 864*D1**2*Pk2*f*fd**2 + 2016*D1**2*Pk2*f*fd*g2*r*s - 1008*D1**2*Pk2*f*fd*g2*r + 9072*D1**2*Pk2*f*fd*g2*s**2 - 9072*D1**2*Pk2*f*fd*g2*s + 4536*D1**2*Pk2*f*fd*g2 - 4032*D1**2*Pk2*f*fd*gd2*r*s + 1008*D1**2*Pk2*f*fd*gd2*r - 14112*D1**2*Pk2*f*fd*gd2*s**2 + 9072*D1**2*Pk2*f*fd*gd2*s - 1008*D1**2*Pk2*f*fd*gd2 - 2016*D1**2*Pk2*f*fdd*g2*r*s + 1008*D1**2*Pk2*f*fdd*g2*r - 7056*D1**2*Pk2*f*fdd*g2*s**2 + 7056*D1**2*Pk2*f*fdd*g2*s - 3528*D1**2*Pk2*f*fdd*g2 - 2016*D1**2*Pk2*fd**2*g2*r*s + 1008*D1**2*Pk2*fd**2*g2*r - 7056*D1**2*Pk2*fd**2*g2*s**2 + 7056*D1**2*Pk2*fd**2*g2*s + 9*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 18*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 9*D1**2*Pkdd2*bdd1*f**2*k1**2 + 27*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 18*D1**2*Pkdd2*f**2*fd*k1**2*s + 9*D1**2*Pkdd2*f**2*fd*k1**2 - 6*D1**2*bd1**2*(280*Pk2*g2*r*(1 - 2*s) + 6*f**2*(7*Pk2*(8*r*s - 6*r - 9*s + 4) - 3*Pkdd2*k1**2*s*(s - 1)) + 7*f*(2*Pk2*(62*K*s**2 + 18*K*s - 4*r*(-2*C*s + C + 9*K*s - 15*s + 3) - 65*s + 16) - Pkdd2*k1**2*s*(s - 1))) - 2016*D1*Dd*Pk2*b2*f**2*r*s + 504*D1*Dd*Pk2*b2*f**2*r - 9072*D1*Dd*Pk2*b2*f**2*s**2 + 5544*D1*Dd*Pk2*b2*f**2*s - 2268*D1*Dd*Pk2*b2*f**2 + 8064*D1*Dd*Pk2*b2*f*fd*r*s - 3024*D1*Dd*Pk2*b2*f*fd*r + 28224*D1*Dd*Pk2*b2*f*fd*s**2 - 23184*D1*Dd*Pk2*b2*f*fd*s + 4536*D1*Dd*Pk2*b2*f*fd + 4032*D1*Dd*Pk2*bd2*f**2*r*s - 504*D1*Dd*Pk2*bd2*f**2*r + 14112*D1*Dd*Pk2*bd2*f**2*s**2 - 6552*D1*Dd*Pk2*bd2*f**2*s + 504*D1*Dd*Pk2*bd2*f**2 - 1064*D1*Dd*Pk2*f**3*r**2 - 4896*D1*Dd*Pk2*f**3*r*s + 2288*D1*Dd*Pk2*f**3*r + 2016*D1*Dd*Pk2*f**3*s**2 + 1440*D1*Dd*Pk2*f**3*s - 28*D1*Dd*Pk2*f**3 + 6864*D1*Dd*Pk2*f**2*fd*r**2 + 20736*D1*Dd*Pk2*f**2*fd*r*s - 11768*D1*Dd*Pk2*f**2*fd*r - 6912*D1*Dd*Pk2*f**2*fd*s**2 - 4608*D1*Dd*Pk2*f**2*fd*s + 3160*D1*Dd*Pk2*f**2*fd + 4032*D1*Dd*Pk2*f**2*g2*r*s - 1008*D1*Dd*Pk2*f**2*g2*r + 18144*D1*Dd*Pk2*f**2*g2*s**2 - 11088*D1*Dd*Pk2*f**2*g2*s + 4536*D1*Dd*Pk2*f**2*g2 - 8064*D1*Dd*Pk2*f**2*gd2*r*s + 1008*D1*Dd*Pk2*f**2*gd2*r - 28224*D1*Dd*Pk2*f**2*gd2*s**2 + 13104*D1*Dd*Pk2*f**2*gd2*s - 1008*D1*Dd*Pk2*f**2*gd2 - 16128*D1*Dd*Pk2*f*fd*g2*r*s + 6048*D1*Dd*Pk2*f*fd*g2*r - 56448*D1*Dd*Pk2*f*fd*g2*s**2 + 46368*D1*Dd*Pk2*f*fd*g2*s - 9072*D1*Dd*Pk2*f*fd*g2 + 36*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**3*k1**2*s + 9*D1*Dd*Pkdd2*f**3*k1**2 + 2016*D1*Ddd*Pk2*b2*f**2*r*s - 504*D1*Ddd*Pk2*b2*f**2*r + 7056*D1*Ddd*Pk2*b2*f**2*s**2 - 4536*D1*Ddd*Pk2*b2*f**2*s + 1764*D1*Ddd*Pk2*b2*f**2 + 1144*D1*Ddd*Pk2*f**3*r**2 + 3456*D1*Ddd*Pk2*f**3*r*s - 2008*D1*Ddd*Pk2*f**3*r - 1152*D1*Ddd*Pk2*f**3*s**2 - 1152*D1*Ddd*Pk2*f**3*s + 284*D1*Ddd*Pk2*f**3 - 4032*D1*Ddd*Pk2*f**2*g2*r*s + 1008*D1*Ddd*Pk2*f**2*g2*r - 14112*D1*Ddd*Pk2*f**2*g2*s**2 + 9072*D1*Ddd*Pk2*f**2*g2*s - 3528*D1*Ddd*Pk2*f**2*g2 - 3*D1*bd1*(D1*(112*Pk2*fd*g2*(9*r*(2*s - 1) + s*(31 - 31*s)) + 6*f**3*(7*Pk2*(6*r**2 + 6*r*(4*s - 1) + 10*s**2 - 16*s + 3) - 3*Pkdd2*k1**2*s**2) + f**2*(-2*Pk2*(284*C*s**2 - 378*K*s**2 + 84*K*s + 42*fd*(18*r**2 + 6*r*(12*s - 5) + 30*s**2 - 50*s + 11) - 77*r**2 - r*s*(248*C + 84*K + 148) + 46*r - 436*s**2 + 362*s - 6) - Pkdd2*k1**2*(s**2 + 12*s - 6)) - 4*f*(14*Pk2*s*(g2*(26*r - 37*s) + gd2*(-36*r + 62*s + 18)) + fd*(Pk2*(-424*C*s**2 + 136*C*s + 42*K*(r*(4*s - 1) + 14*s**2 - 9*s + 1) + 154*r**2 + 4*r*(76*C*s - 19*C + 86*s - 48) + 800*s**2 - 643*s + 162) + 3*Pkdd2*k1**2*s*(s - 1)))) - 2*Dd*f*(84*Pk2*f**2*(12*r**2 + 6*r*(8*s - 3) + 20*s**2 - 33*s + 7) + 56*Pk2*g2*(r*(9 - 72*s) + s*(124*s - 13)) + f*(2*Pk2*(-848*C*s**2 + 60*C*s + 42*K*(r*(8*s - 1) + 28*s**2 - 13*s + 1) + 308*r**2 + 4*r*(19*C*(8*s - 1) + 172*s - 89) + 1600*s**2 - 1200*s + 215) + 3*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 6048*Dd**2*Pk2*b2*f**2*r*s - 1512*Dd**2*Pk2*b2*f**2*r + 21168*Dd**2*Pk2*b2*f**2*s**2 - 13608*Dd**2*Pk2*b2*f**2*s + 1008*Dd**2*Pk2*b2*f**2 + 3432*Dd**2*Pk2*f**3*r**2 + 10368*Dd**2*Pk2*f**3*r*s - 6024*Dd**2*Pk2*f**3*r - 3456*Dd**2*Pk2*f**3*s**2 - 3456*Dd**2*Pk2*f**3*s + 2300*Dd**2*Pk2*f**3 - 12096*Dd**2*Pk2*f**2*g2*r*s + 3024*Dd**2*Pk2*f**2*g2*r - 42336*Dd**2*Pk2*f**2*g2*s**2 + 27216*Dd**2*Pk2*f**2*g2*s - 2016*Dd**2*Pk2*f**2*g2 - 840*Pk2*b1**3*(K - 1)*(2*D1*Dd*(-4*r*s + r + 2*s) + D1*Ddd*(r*(4*s - 1) - 2*s) + Dd**2*(3*r*(4*s - 1) - 6*s + 2)) + 3*b1**2*(-2*D1*Dd*(-448*C*Pk2*f*r*s + 112*C*Pk2*f*r + 224*C*Pk2*f*s + 1456*K*Pk2*f*r*s - 364*K*Pk2*f*r - 2072*K*Pk2*f*s**2 + 308*K*Pk2*f*s - 518*K*Pk2*f - 672*Pk2*f**2*r*s + 168*Pk2*f**2*r + 336*Pk2*f**2*s - 2240*Pk2*f*r*s + 560*Pk2*f*r + 1120*Pk2*f*s + 14*Pk2*fd*(4*C*(r*(8*s - 1) - 6*s + 1) - 144*K*r*s + 90*K*r + 248*K*s**2 - 274*K*s + 26*K + 3*f*(64*r*s - 12*s - 5) + 240*r*s - 102*r + 80*s + 1) + 2240*Pk2*g2*r*s - 560*Pk2*g2*r - 1120*Pk2*g2*s - 280*Pk2*gd2*(r*(8*s - 1) - 6*s + 1) + 72*Pkdd2*f**2*k1**2*s**2 - 36*Pkdd2*f**2*k1**2*s + 18*Pkdd2*f**2*k1**2 + 28*Pkdd2*f*k1**2*s**2 - 14*Pkdd2*f*k1**2*s + 7*Pkdd2*f*k1**2 - Pkdd2*fd*k1**2*s*(36*f + 7)*(4*s - 1)) - 280*D1*Pk2*bd1*(K - 1)*(2*D1*(-3*r*s + r + s) + Dd*(r*(24*s - 7) - 10*s + 3)) + D1*(D1*(-280*Pk2*(bdd1*(K - 1)*(r*(3*s - 1) - s) + s*(4*gd2 - 2*gdd2)*(r - 1)) - 12*fd**2*(7*Pk2*(r*(8*s + 2) + s - 2) - 3*Pkdd2*k1**2*s**2) + 2*fd*(7*Pk2*(16*C*r*s - 16*C*s - 2*K*(s - 1)*(26*r - 37*s + 37) + 3*f*(4*r*(4*s + 1) + 6*s - 9) + 80*r*s - 52*r + 90*s - 37) - Pkdd2*k1**2*s**2*(36*f + 7)) + fdd*(-14*Pk2*(8*C*r*s - 8*C*s - 2*K*(s - 1)*(18*r - 31*s + 31) + 3*f*(4*r*(4*s + 1) + 2*s - 7) + 60*r*s - 36*r + 70*s - 31) + Pkdd2*k1**2*s**2*(36*f + 7))) + Ddd*(560*Pk2*g2*(r*(4*s - 1) - 2*s) + 6*f**2*(56*Pk2*(-4*r*s + r + 2*s) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 7*f*(-4*K*Pk2*(r*(18 - 72*s) + 124*s**2 - 26*s + 31) + Pk2*(-16*C - 120)*(4*r*s - r - 2*s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) - 2*Dd**2*(-280*Pk2*g2*(3*r*(4*s - 1) - 6*s + 2) + 6*f**2*(28*Pk2*(12*r*s - 3*r - 6*s + 2) + 9*Pkdd2*k1**2*s*(1 - 2*s)) + 7*f*(8*C*Pk2*(3*r*(4*s - 1) - 6*s + 2) - 12*Pk2*(K*(36*r*s - 9*r - 62*s**2 + 13*s + 6) - 60*r*s + 15*r + 30*s - 10) + 3*Pkdd2*k1**2*s*(1 - 2*s)))) - 3*b1*(992*C*D1**2*Pk2*f*fd*r*s - 496*C*D1**2*Pk2*f*fd*r - 1136*C*D1**2*Pk2*f*fd*s**2 + 640*C*D1**2*Pk2*f*fd*s - 568*C*D1**2*Pk2*f*fd - 608*C*D1**2*Pk2*f*fdd*r*s + 304*C*D1**2*Pk2*f*fdd*r + 848*C*D1**2*Pk2*f*fdd*s**2 - 544*C*D1**2*Pk2*f*fdd*s + 424*C*D1**2*Pk2*f*fdd - 608*C*D1**2*Pk2*fd**2*r*s + 304*C*D1**2*Pk2*fd**2*r + 848*C*D1**2*Pk2*fd**2*s**2 - 544*C*D1**2*Pk2*fd**2*s - 304*C*D1**2*Pk2*fd**2 + 1984*C*D1*Dd*Pk2*f**2*r*s - 496*C*D1*Dd*Pk2*f**2*r - 2272*C*D1*Dd*Pk2*f**2*s**2 + 144*C*D1*Dd*Pk2*f**2*s - 568*C*D1*Dd*Pk2*f**2 - 4864*C*D1*Dd*Pk2*f*fd*r*s + 1824*C*D1*Dd*Pk2*f*fd*r + 6784*C*D1*Dd*Pk2*f*fd*s**2 - 2656*C*D1*Dd*Pk2*f*fd*s - 64*C*D1*Dd*Pk2*f*fd - 1216*C*D1*Ddd*Pk2*f**2*r*s + 304*C*D1*Ddd*Pk2*f**2*r + 1696*C*D1*Ddd*Pk2*f**2*s**2 - 240*C*D1*Ddd*Pk2*f**2*s + 424*C*D1*Ddd*Pk2*f**2 - 3648*C*Dd**2*Pk2*f**2*r*s + 912*C*Dd**2*Pk2*f**2*r + 5088*C*Dd**2*Pk2*f**2*s**2 - 720*C*Dd**2*Pk2*f**2*s - 608*C*Dd**2*Pk2*f**2 + 336*D1**2*K*Pk2*f*fd*r*s - 168*D1**2*K*Pk2*f*fd*r + 1512*D1**2*K*Pk2*f*fd*s**2 - 1512*D1**2*K*Pk2*f*fd*s + 756*D1**2*K*Pk2*f*fd - 336*D1**2*K*Pk2*f*fdd*r*s + 168*D1**2*K*Pk2*f*fdd*r - 1176*D1**2*K*Pk2*f*fdd*s**2 + 1176*D1**2*K*Pk2*f*fdd*s - 588*D1**2*K*Pk2*f*fdd - 336*D1**2*K*Pk2*fd**2*r*s + 168*D1**2*K*Pk2*fd**2*r - 1176*D1**2*K*Pk2*fd**2*s**2 + 1176*D1**2*K*Pk2*fd**2*s + 280*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) - 2*s + 1) + 756*D1**2*Pk2*f**2*fd*r**2 + 3024*D1**2*Pk2*f**2*fd*r*s - 1764*D1**2*Pk2*f**2*fd*r + 1260*D1**2*Pk2*f**2*fd*s**2 - 2184*D1**2*Pk2*f**2*fd*s + 798*D1**2*Pk2*f**2*fd - 756*D1**2*Pk2*f**2*fdd*r**2 - 3024*D1**2*Pk2*f**2*fdd*r*s + 1764*D1**2*Pk2*f**2*fdd*r - 1260*D1**2*Pk2*f**2*fdd*s**2 + 2184*D1**2*Pk2*f**2*fdd*s - 798*D1**2*Pk2*f**2*fdd - 1512*D1**2*Pk2*f*fd**2*r**2 - 6048*D1**2*Pk2*f*fd**2*r*s + 3528*D1**2*Pk2*f*fd**2*r - 2520*D1**2*Pk2*f*fd**2*s**2 + 4368*D1**2*Pk2*f*fd**2*s - 1596*D1**2*Pk2*f*fd**2 + 308*D1**2*Pk2*f*fd*r**2 + 592*D1**2*Pk2*f*fd*r*s - 512*D1**2*Pk2*f*fd*r + 1744*D1**2*Pk2*f*fd*s**2 - 1316*D1**2*Pk2*f*fd*s + 1014*D1**2*Pk2*f*fd - 308*D1**2*Pk2*f*fdd*r**2 - 688*D1**2*Pk2*f*fdd*r*s + 536*D1**2*Pk2*f*fdd*r - 1600*D1**2*Pk2*f*fdd*s**2 + 1316*D1**2*Pk2*f*fdd*s - 906*D1**2*Pk2*f*fdd - 1456*D1**2*Pk2*f*gd2*r*s + 2072*D1**2*Pk2*f*gd2*s**2 + 1456*D1**2*Pk2*f*gd2*s + 1008*D1**2*Pk2*f*gdd2*r*s - 1736*D1**2*Pk2*f*gdd2*s**2 - 1008*D1**2*Pk2*f*gdd2*s - 308*D1**2*Pk2*fd**2*r**2 - 688*D1**2*Pk2*fd**2*r*s + 536*D1**2*Pk2*fd**2*r - 1600*D1**2*Pk2*fd**2*s**2 + 1316*D1**2*Pk2*fd**2*s + 304*D1**2*Pk2*fd**2 - 1456*D1**2*Pk2*fd*g2*r*s + 1456*D1**2*Pk2*fd*g2*r + 2072*D1**2*Pk2*fd*g2*s**2 - 4144*D1**2*Pk2*fd*g2*s + 2072*D1**2*Pk2*fd*g2 + 2016*D1**2*Pk2*fd*gd2*r*s - 1008*D1**2*Pk2*fd*gd2*r - 3472*D1**2*Pk2*fd*gd2*s**2 + 2464*D1**2*Pk2*fd*gd2*s + 1008*D1**2*Pk2*fd*gd2 + 1008*D1**2*Pk2*fdd*g2*r*s - 1008*D1**2*Pk2*fdd*g2*r - 1736*D1**2*Pk2*fdd*g2*s**2 + 3472*D1**2*Pk2*fdd*g2*s - 1736*D1**2*Pk2*fdd*g2 - 54*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 36*D1**2*Pkdd2*f**2*fd*k1**2*s - 18*D1**2*Pkdd2*f**2*fd*k1**2 - 2*D1**2*Pkdd2*f*fd*k1**2*s**2 + 14*D1**2*Pkdd2*f*fd*k1**2*s - 7*D1**2*Pkdd2*f*fd*k1**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s**2 + D1**2*bdd1*(560*Pk2*g2*r*(1 - 2*s) + 6*f**2*(7*Pk2*(4*r*(4*s - 3) - 18*s + 7) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 7*f*(2*Pk2*(124*K*s**2 + 36*K*s - 8*r*(-2*C*s + C + 9*K*s - 15*s + 3) - 130*s + 31) + Pkdd2*k1**2*(-2*s**2 + 2*s - 1))) + 672*D1*Dd*K*Pk2*f**2*r*s - 168*D1*Dd*K*Pk2*f**2*r + 3024*D1*Dd*K*Pk2*f**2*s**2 - 1848*D1*Dd*K*Pk2*f**2*s + 756*D1*Dd*K*Pk2*f**2 - 2688*D1*Dd*K*Pk2*f*fd*r*s + 1008*D1*Dd*K*Pk2*f*fd*r - 9408*D1*Dd*K*Pk2*f*fd*s**2 + 7728*D1*Dd*K*Pk2*f*fd*s - 1512*D1*Dd*K*Pk2*f*fd + 1008*D1*Dd*Pk2*f**3*r**2 + 4032*D1*Dd*Pk2*f**3*r*s - 2016*D1*Dd*Pk2*f**3*r + 1680*D1*Dd*Pk2*f**3*s**2 - 2856*D1*Dd*Pk2*f**3*s + 924*D1*Dd*Pk2*f**3 - 6048*D1*Dd*Pk2*f**2*fd*r**2 - 24192*D1*Dd*Pk2*f**2*fd*r*s + 13104*D1*Dd*Pk2*f**2*fd*r - 10080*D1*Dd*Pk2*f**2*fd*s**2 + 17304*D1*Dd*Pk2*f**2*fd*s - 5712*D1*Dd*Pk2*f**2*fd + 616*D1*Dd*Pk2*f**2*r**2 + 1184*D1*Dd*Pk2*f**2*r*s - 912*D1*Dd*Pk2*f**2*r + 3488*D1*Dd*Pk2*f**2*s**2 - 2336*D1*Dd*Pk2*f**2*s + 1180*D1*Dd*Pk2*f**2 - 2464*D1*Dd*Pk2*f*fd*r**2 - 5504*D1*Dd*Pk2*f*fd*r*s + 4064*D1*Dd*Pk2*f*fd*r - 12800*D1*Dd*Pk2*f*fd*s**2 + 9840*D1*Dd*Pk2*f*fd*s - 2388*D1*Dd*Pk2*f*fd - 5824*D1*Dd*Pk2*f*g2*r*s + 1456*D1*Dd*Pk2*f*g2*r + 8288*D1*Dd*Pk2*f*g2*s**2 - 1232*D1*Dd*Pk2*f*g2*s + 2072*D1*Dd*Pk2*f*g2 + 8064*D1*Dd*Pk2*f*gd2*r*s - 1008*D1*Dd*Pk2*f*gd2*r - 13888*D1*Dd*Pk2*f*gd2*s**2 - 2576*D1*Dd*Pk2*f*gd2*s + 1008*D1*Dd*Pk2*f*gd2 + 8064*D1*Dd*Pk2*fd*g2*r*s - 5040*D1*Dd*Pk2*fd*g2*r - 13888*D1*Dd*Pk2*fd*g2*s**2 + 15344*D1*Dd*Pk2*fd*g2*s - 1456*D1*Dd*Pk2*fd*g2 - 72*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 36*D1*Dd*Pkdd2*f**3*k1**2*s - 18*D1*Dd*Pkdd2*f**3*k1**2 - 4*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 2*D1*Dd*Pkdd2*f**2*k1**2*s - D1*Dd*Pkdd2*f**2*k1**2 - 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*Pkdd2*f*fd*k1**2*s - 672*D1*Ddd*K*Pk2*f**2*r*s + 168*D1*Ddd*K*Pk2*f**2*r - 2352*D1*Ddd*K*Pk2*f**2*s**2 + 1512*D1*Ddd*K*Pk2*f**2*s - 588*D1*Ddd*K*Pk2*f**2 - 1008*D1*Ddd*Pk2*f**3*r**2 - 4032*D1*Ddd*Pk2*f**3*r*s + 2016*D1*Ddd*Pk2*f**3*r - 1680*D1*Ddd*Pk2*f**3*s**2 + 2856*D1*Ddd*Pk2*f**3*s - 924*D1*Ddd*Pk2*f**3 - 616*D1*Ddd*Pk2*f**2*r**2 - 1376*D1*Ddd*Pk2*f**2*r*s + 960*D1*Ddd*Pk2*f**2*r - 3200*D1*Ddd*Pk2*f**2*s**2 + 2288*D1*Ddd*Pk2*f**2*s - 1108*D1*Ddd*Pk2*f**2 + 4032*D1*Ddd*Pk2*f*g2*r*s - 1008*D1*Ddd*Pk2*f*g2*r - 6944*D1*Ddd*Pk2*f*g2*s**2 + 1456*D1*Ddd*Pk2*f*g2*s - 1736*D1*Ddd*Pk2*f*g2 - 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*D1*Ddd*Pkdd2*f**2*k1**2 - 2*D1*bd1*(D1*(-14*Pk2*fd*(4*C*(r*(4*s - 1) - 2*s + 1) - 2*K*(36*r*s - 18*r - 62*s**2 + 53*s + 9) + 120*r*s - 48*r + 5*s + 14) - 560*Pk2*g2*r*(2*s - 1) - 280*Pk2*gd2*(-4*r*s + r + 2*s - 1) - 7*Pkdd2*fd*k1**2*s*(1 - 2*s) + 3*f**2*(7*Pk2*(4*r*(4*s - 3) - 22*s + 9) - 6*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(-7*Pk2*(-148*K*s**2 - 52*K*s + 12*fd*(4*r*(4*s - 1) - 8*s + 3) + 4*r*(C*(4 - 8*s) + 26*K*s - 40*s + 7) + 170*s - 37) + Pkdd2*k1**2*(s**2*(72*fd - 14) + s*(14 - 36*fd) - 7))) + Dd*(560*Pk2*g2*(r*(8*s - 3) - 2*s + 1) - 6*f**2*(7*Pk2*(32*r*(2*s - 1) - 52*s + 21) - 3*Pkdd2*k1**2*(8*s**2 - 6*s + 1)) - 7*f*(2*Pk2*(8*C*(r*(8*s - 3) - 2*s + 1) + K*(-288*r*s + 36*r + 496*s**2 + 20*s - 18) + 480*r*s - 108*r - 380*s + 89) + Pkdd2*k1**2*(-8*s**2 + 6*s - 1)))) - 2016*Dd**2*K*Pk2*f**2*r*s + 504*Dd**2*K*Pk2*f**2*r - 7056*Dd**2*K*Pk2*f**2*s**2 + 4536*Dd**2*K*Pk2*f**2*s - 336*Dd**2*K*Pk2*f**2 - 3024*Dd**2*Pk2*f**3*r**2 - 12096*Dd**2*Pk2*f**3*r*s + 6048*Dd**2*Pk2*f**3*r - 5040*Dd**2*Pk2*f**3*s**2 + 8568*Dd**2*Pk2*f**3*s - 2520*Dd**2*Pk2*f**3 - 1848*Dd**2*Pk2*f**2*r**2 - 4128*Dd**2*Pk2*f**2*r*s + 2880*Dd**2*Pk2*f**2*r - 9600*Dd**2*Pk2*f**2*s**2 + 6864*Dd**2*Pk2*f**2*s - 996*Dd**2*Pk2*f**2 + 12096*Dd**2*Pk2*f*g2*r*s - 3024*Dd**2*Pk2*f*g2*r - 20832*Dd**2*Pk2*f*g2*s**2 + 4368*Dd**2*Pk2*f*g2*s + 2016*Dd**2*Pk2*f*g2 - 36*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*Dd**2*Pkdd2*f**2*k1**2*s))/(630*d**2*k2*k3**2) + D1**2*Pk3*ct*k1*(28*D1**2*Pk2*bd1**2*(5*f**2*(6*r**2 + r*(8*s - 9) - 5*s + 4) + f*(50*K*s**2 + 25*r**2 + r*(48*C*s - 24*C + 12*s - 31) - 55*s + 30) + 40*g2*r*(1 - 2*s)) + D1*bd1*(D1*(-4*Pk2*f*(fd*(-616*C*s**2 + 308*C*s + 70*K*(4*r*s - r + 6*s**2 - 5*s + 1) - 270*r**2 - 552*r*s + 411*r + 308*s**2 + 61*s - 138) + s**2*(-350*g2 + 700*gd2)) - 2800*Pk2*fd*g2*s*(s - 1) + f**2*(Pk2*(-330*r**2 + 40*r*(s*(7*K - 15) + 15) + 14*s**2*(-44*C + 30*K + 22) + 14*s*(22 - 20*K) - 154) + 21*Pkdd2*k1**2*(s - 1)**2)) + 4*Dd*Pk2*f*(f*(1232*C*s**2 - 308*C*s - 70*K*(r*(8*s - 1) + 12*s**2 - 9*s + 1) + 540*r**2 + 48*r*(23*s - 20) - 616*s**2 - 430*s + 353) + 700*g2*s*(1 - 4*s))) + 280*Pk2*b1**3*(K - 1)*(D1*Dd*(-4*r*s + r + 2*s) + 2*D1*Ddd*(r*(4*s - 1) - 2*s) + 2*Dd**2*(3*r*(4*s - 1) - 6*s + 2)) + 2*Pk2*(648*C*D1**2*f**2*fd*r*s - 216*C*D1**2*f**2*fd*r + 756*C*D1**2*f**2*fd*s**2 - 720*C*D1**2*f**2*fd*s + 252*C*D1**2*f**2*fd - 648*C*D1**2*f**2*fdd*r*s + 216*C*D1**2*f**2*fdd*r - 756*C*D1**2*f**2*fdd*s**2 + 720*C*D1**2*f**2*fdd*s - 252*C*D1**2*f**2*fdd - 1296*C*D1**2*f*fd**2*r*s + 432*C*D1**2*f*fd**2*r - 1512*C*D1**2*f*fd**2*s**2 + 1440*C*D1**2*f*fd**2*s - 216*C*D1**2*f*fd**2 + 864*C*D1*Dd*f**3*r*s - 216*C*D1*Dd*f**3*r + 1008*C*D1*Dd*f**3*s**2 - 936*C*D1*Dd*f**3*s + 252*C*D1*Dd*f**3 - 5184*C*D1*Dd*f**2*fd*r*s + 1512*C*D1*Dd*f**2*fd*r - 6048*C*D1*Dd*f**2*fd*s**2 + 5688*C*D1*Dd*f**2*fd*s - 1152*C*D1*Dd*f**2*fd - 864*C*D1*Ddd*f**3*r*s + 216*C*D1*Ddd*f**3*r - 1008*C*D1*Ddd*f**3*s**2 + 936*C*D1*Ddd*f**3*s - 252*C*D1*Ddd*f**3 - 2592*C*Dd**2*f**3*r*s + 648*C*Dd**2*f**3*r - 3024*C*Dd**2*f**3*s**2 + 2808*C*Dd**2*f**3*s - 432*C*Dd**2*f**3 + D1**2*bdd1*f*(f*(135*r**2 - 4*r*(s*(35*K - 69) + 69) + 7*s**2*(44*C - 30*K - 22) + 7*s*(20*K - 22) + 77) - 700*g2*s**2) - 140*D1**2*bdd2*f**2*r*s - 210*D1**2*bdd2*f**2*s**2 + 140*D1**2*bdd2*f**2*s - 324*D1**2*f**2*fd*r*s + 108*D1**2*f**2*fd*r - 378*D1**2*f**2*fd*s**2 + 360*D1**2*f**2*fd*s - 126*D1**2*f**2*fd + 324*D1**2*f**2*fdd*r*s - 108*D1**2*f**2*fdd*r + 378*D1**2*f**2*fdd*s**2 - 360*D1**2*f**2*fdd*s + 126*D1**2*f**2*fdd - 280*D1**2*f**2*gd2*r*s - 420*D1**2*f**2*gd2*s**2 + 280*D1**2*f**2*gd2*s + 280*D1**2*f**2*gdd2*r*s + 420*D1**2*f**2*gdd2*s**2 - 280*D1**2*f**2*gdd2*s + 648*D1**2*f*fd**2*r*s - 216*D1**2*f*fd**2*r + 756*D1**2*f*fd**2*s**2 - 720*D1**2*f*fd**2*s + 108*D1**2*f*fd**2 - 560*D1**2*f*fd*g2*r*s + 280*D1**2*f*fd*g2*r - 840*D1**2*f*fd*g2*s**2 + 840*D1**2*f*fd*g2*s - 420*D1**2*f*fd*g2 + 1120*D1**2*f*fd*gd2*r*s - 280*D1**2*f*fd*gd2*r + 1680*D1**2*f*fd*gd2*s**2 - 1400*D1**2*f*fd*gd2*s + 280*D1**2*f*fd*gd2 + 560*D1**2*f*fdd*g2*r*s - 280*D1**2*f*fdd*g2*r + 840*D1**2*f*fdd*g2*s**2 - 840*D1**2*f*fdd*g2*s + 420*D1**2*f*fdd*g2 + 560*D1**2*fd**2*g2*r*s - 280*D1**2*fd**2*g2*r + 840*D1**2*fd**2*g2*s**2 - 840*D1**2*fd**2*g2*s - 432*D1*Dd*f**3*r*s + 108*D1*Dd*f**3*r - 504*D1*Dd*f**3*s**2 + 468*D1*Dd*f**3*s - 126*D1*Dd*f**3 + 2592*D1*Dd*f**2*fd*r*s - 756*D1*Dd*f**2*fd*r + 3024*D1*Dd*f**2*fd*s**2 - 2844*D1*Dd*f**2*fd*s + 576*D1*Dd*f**2*fd - 1120*D1*Dd*f**2*g2*r*s + 280*D1*Dd*f**2*g2*r - 1680*D1*Dd*f**2*g2*s**2 + 1400*D1*Dd*f**2*g2*s - 420*D1*Dd*f**2*g2 + 2240*D1*Dd*f**2*gd2*r*s - 280*D1*Dd*f**2*gd2*r + 3360*D1*Dd*f**2*gd2*s**2 - 2520*D1*Dd*f**2*gd2*s + 280*D1*Dd*f**2*gd2 + 4480*D1*Dd*f*fd*g2*r*s - 1680*D1*Dd*f*fd*g2*r + 6720*D1*Dd*f*fd*g2*s**2 - 6160*D1*Dd*f*fd*g2*s + 1400*D1*Dd*f*fd*g2 + 432*D1*Ddd*f**3*r*s - 108*D1*Ddd*f**3*r + 504*D1*Ddd*f**3*s**2 - 468*D1*Ddd*f**3*s + 126*D1*Ddd*f**3 + 1120*D1*Ddd*f**2*g2*r*s - 280*D1*Ddd*f**2*g2*r + 1680*D1*Ddd*f**2*g2*s**2 - 1400*D1*Ddd*f**2*g2*s + 420*D1*Ddd*f**2*g2 + 70*D1*bd2*f*(D1*(f*s*(2*r + 3*s - 2) - 2*fd*(4*r*s - r + 6*s**2 - 5*s + 1)) - 2*Dd*f*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) + 1296*Dd**2*f**3*r*s - 324*Dd**2*f**3*r + 1512*Dd**2*f**3*s**2 - 1404*Dd**2*f**3*s + 216*Dd**2*f**3 + 3360*Dd**2*f**2*g2*r*s - 840*Dd**2*f**2*g2*r + 5040*Dd**2*f**2*g2*s**2 - 4200*Dd**2*f**2*g2*s + 560*Dd**2*f**2*g2 + 70*b2*(D1**2*(f*(fd - fdd)*(r*(4*s - 2) + 6*s**2 - 6*s + 3) + 2*fd**2*(-2*r*s + r - s*(3*s - 3))) + D1*f*(Dd*(f*(8*r*s - 2*r + 12*s**2 - 10*s + 3) - 2*fd*(16*r*s - 6*r + 24*s**2 - 22*s + 5)) + Ddd*f*(r*(2 - 8*s) - 12*s**2 + 10*s - 3)) - 2*Dd**2*f**2*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2))) - 7*b1**2*(-D1**2*(20*Pk2*fd**2*(6*r**2 + r*(8*s - 7) - 3*s + 1) - 2*Pk2*fd*(56*C*r*s - 56*C*s + 50*K*(s - 1)**2 + 10*f*(6*r**2 + r*(8*s - 7) - 3*s + 3) + 25*r**2 + 4*r*s + 106*s - 25) + 2*Pk2*(40*bdd1*(K - 1)*(r*(3*s - 1) - s) + fdd*(48*C*r*s - 48*C*s + 50*K*(s - 1)**2 + 10*f*(6*r**2 + r*(8*s - 7) - 3*s + 3) + 25*r**2 + 12*r*s + 98*s - 25) + 40*s*(gd2 - 2*gdd2)*(r - 1)) + Pkdd2*fd*k1**2*s**2*(12*f + 5)) - 40*D1*Pk2*bd1*(K - 1)*(D1*(-3*r*s + r + s) + 2*Dd*(r*(24*s - 7) - 10*s + 3)) + D1*(Dd*(-4*Pk2*fd*(24*C*(r*(8*s - 1) - 6*s + 1) + 50*K*(4*s**2 - 5*s + 1) + 100*r**2 + 48*r*s - 56*r + 184*s - 49) + 80*Pk2*(g2*(-4*r*s + r + 2*s) + 2*gd2*(r*(8*s - 1) - 6*s + 1)) + 2*f**2*(20*Pk2*(6*r**2 + 8*r*(s - 1) - 4*s + 3) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(-4*Pk2*(-112*C*r*s + 28*C*r + 56*C*s - 25*K*(4*s**2 - 2*s + 1) + 5*fd*(48*r**2 + r*(64*s - 60) - 28*s + 17) - 50*r**2 - 8*r*s + 52*r + 4*s - 25) - 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 4*Ddd*Pk2*(10*f**2*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + f*(-48*C*s + 25*K*(4*s**2 - 2*s + 1) + 50*r**2 + 8*r*(12*C*s - 3*C + 3*s - 7) - 12*s + 25) + 40*g2*(-4*r*s + r + 2*s))) - 4*Dd**2*Pk2*(10*f**2*(18*r**2 + 24*r*(s - 1) - 12*s + 7) + f*(24*C*(3*r*(4*s - 1) - 6*s + 2) + 300*K*s**2 - 150*K*s + 150*r**2 + 24*r*(3*s - 7) - 36*s + 37) - 40*g2*(3*r*(4*s - 1) - 6*s + 2))) + b1*(-1232*C*D1**2*Pk2*f*fd*s**2 + 1232*C*D1**2*Pk2*f*fd*s - 616*C*D1**2*Pk2*f*fd + 1232*C*D1**2*Pk2*f*fdd*s**2 - 1232*C*D1**2*Pk2*f*fdd*s + 616*C*D1**2*Pk2*f*fdd + 1232*C*D1**2*Pk2*fd**2*s**2 - 1232*C*D1**2*Pk2*fd**2*s - 2464*C*D1*Dd*Pk2*f**2*s**2 + 1232*C*D1*Dd*Pk2*f**2*s - 616*C*D1*Dd*Pk2*f**2 + 9856*C*D1*Dd*Pk2*f*fd*s**2 - 7392*C*D1*Dd*Pk2*f*fd*s + 1232*C*D1*Dd*Pk2*f*fd + 2464*C*D1*Ddd*Pk2*f**2*s**2 - 1232*C*D1*Ddd*Pk2*f**2*s + 616*C*D1*Ddd*Pk2*f**2 + 7392*C*Dd**2*Pk2*f**2*s**2 - 3696*C*Dd**2*Pk2*f**2*s + 560*D1**2*K*Pk2*f*fd*r*s - 280*D1**2*K*Pk2*f*fd*r + 840*D1**2*K*Pk2*f*fd*s**2 - 840*D1**2*K*Pk2*f*fd*s + 420*D1**2*K*Pk2*f*fd - 560*D1**2*K*Pk2*f*fdd*r*s + 280*D1**2*K*Pk2*f*fdd*r - 840*D1**2*K*Pk2*f*fdd*s**2 + 840*D1**2*K*Pk2*f*fdd*s - 420*D1**2*K*Pk2*f*fdd - 560*D1**2*K*Pk2*fd**2*r*s + 280*D1**2*K*Pk2*fd**2*r - 840*D1**2*K*Pk2*fd**2*s**2 + 840*D1**2*K*Pk2*fd**2*s + 560*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) - 2*s + 1) + 28*D1**2*Pk2*bdd1*(5*f**2*(6*r**2 + r*(8*s - 9) - 5*s + 3) + f*(50*K*s**2 + 25*r**2 + r*(48*C*s - 24*C + 12*s - 31) - 55*s + 25) + 40*g2*r*(1 - 2*s)) - 660*D1**2*Pk2*f*fd*r**2 - 1200*D1**2*Pk2*f*fd*r*s + 660*D1**2*Pk2*f*fd*r + 616*D1**2*Pk2*f*fd*s**2 - 324*D1**2*Pk2*f*fd*s + 132*D1**2*Pk2*f*fd + 540*D1**2*Pk2*f*fdd*r**2 + 1104*D1**2*Pk2*f*fdd*r*s - 540*D1**2*Pk2*f*fdd*r - 616*D1**2*Pk2*f*fdd*s**2 + 372*D1**2*Pk2*f*fdd*s - 192*D1**2*Pk2*f*fdd + 1400*D1**2*Pk2*f*gd2*s**2 - 1400*D1**2*Pk2*f*gdd2*s**2 + 540*D1**2*Pk2*fd**2*r**2 + 1104*D1**2*Pk2*fd**2*r*s - 540*D1**2*Pk2*fd**2*r - 616*D1**2*Pk2*fd**2*s**2 + 372*D1**2*Pk2*fd**2*s + 1400*D1**2*Pk2*fd*g2*s**2 - 2800*D1**2*Pk2*fd*g2*s + 1400*D1**2*Pk2*fd*g2 - 2800*D1**2*Pk2*fd*gd2*s**2 + 2800*D1**2*Pk2*fd*gd2*s - 1400*D1**2*Pk2*fdd*g2*s**2 + 2800*D1**2*Pk2*fdd*g2*s - 1400*D1**2*Pk2*fdd*g2 + 42*D1**2*Pkdd2*f*fd*k1**2*s**2 + 1120*D1*Dd*K*Pk2*f**2*r*s - 280*D1*Dd*K*Pk2*f**2*r + 1680*D1*Dd*K*Pk2*f**2*s**2 - 1400*D1*Dd*K*Pk2*f**2*s + 420*D1*Dd*K*Pk2*f**2 - 4480*D1*Dd*K*Pk2*f*fd*r*s + 1680*D1*Dd*K*Pk2*f*fd*r - 6720*D1*Dd*K*Pk2*f*fd*s**2 + 6160*D1*Dd*K*Pk2*f*fd*s - 1400*D1*Dd*K*Pk2*f*fd - 1320*D1*Dd*Pk2*f**2*r**2 - 2400*D1*Dd*Pk2*f**2*r*s + 1920*D1*Dd*Pk2*f**2*r + 1232*D1*Dd*Pk2*f**2*s**2 + 584*D1*Dd*Pk2*f**2*s - 352*D1*Dd*Pk2*f**2 + 4320*D1*Dd*Pk2*f*fd*r**2 + 8832*D1*Dd*Pk2*f*fd*r*s - 5424*D1*Dd*Pk2*f*fd*r - 4928*D1*Dd*Pk2*f*fd*s**2 + 512*D1*Dd*Pk2*f*fd*s + 708*D1*Dd*Pk2*f*fd + 5600*D1*Dd*Pk2*f*g2*s**2 - 2800*D1*Dd*Pk2*f*g2*s + 1400*D1*Dd*Pk2*f*g2 - 11200*D1*Dd*Pk2*f*gd2*s**2 + 2800*D1*Dd*Pk2*f*gd2*s - 11200*D1*Dd*Pk2*fd*g2*s**2 + 14000*D1*Dd*Pk2*fd*g2*s - 2800*D1*Dd*Pk2*fd*g2 + 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 42*D1*Dd*Pkdd2*f**2*k1**2*s + 21*D1*Dd*Pkdd2*f**2*k1**2 - 1120*D1*Ddd*K*Pk2*f**2*r*s + 280*D1*Ddd*K*Pk2*f**2*r - 1680*D1*Ddd*K*Pk2*f**2*s**2 + 1400*D1*Ddd*K*Pk2*f**2*s - 420*D1*Ddd*K*Pk2*f**2 + 1080*D1*Ddd*Pk2*f**2*r**2 + 2208*D1*Ddd*Pk2*f**2*r*s - 1632*D1*Ddd*Pk2*f**2*r - 1232*D1*Ddd*Pk2*f**2*s**2 - 488*D1*Ddd*Pk2*f**2*s + 232*D1*Ddd*Pk2*f**2 - 5600*D1*Ddd*Pk2*f*g2*s**2 + 2800*D1*Ddd*Pk2*f*g2*s - 1400*D1*Ddd*Pk2*f*g2 - 7*D1*bd1*(D1*(20*Pk2*f**2*(6*r**2 + r*(8*s - 9) - 5*s + 3) - 4*Pk2*f*(-50*K*s**2 + 5*fd*(24*r**2 + 32*r*(s - 1) - 16*s + 9) - 25*r**2 + r*(-56*C*s + 28*C - 4*s + 27) + 55*s - 25) - 4*Pk2*fd*(24*C*(r*(4*s - 1) - 2*s + 1) + 100*K*s**2 - 100*K*s + 50*r**2 + r*(24*s - 31) + 43*s - 24) - 80*Pk2*(g2*r*(2*s - 1) + gd2*(r*(2 - 8*s) + 4*s - 2)) - 6*Pkdd2*f**2*k1**2*(2*s**2 - 2*s + 1) - 5*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) - 4*Dd*Pk2*(5*f**2*(48*r**2 + r*(64*s - 68) - 36*s + 23) + f*(48*C*(8*r*s - 3*r - 2*s + 1) + 400*K*s**2 - 100*K*s + 200*r**2 + 96*r*s - 236*r - 244*s + 117) - 80*g2*(r*(8*s - 3) - 2*s + 1))) - 3360*Dd**2*K*Pk2*f**2*r*s + 840*Dd**2*K*Pk2*f**2*r - 5040*Dd**2*K*Pk2*f**2*s**2 + 4200*Dd**2*K*Pk2*f**2*s - 560*Dd**2*K*Pk2*f**2 + 3240*Dd**2*Pk2*f**2*r**2 + 6624*Dd**2*Pk2*f**2*r*s - 4896*Dd**2*Pk2*f**2*r - 3696*Dd**2*Pk2*f**2*s**2 - 1464*Dd**2*Pk2*f**2*s + 1644*Dd**2*Pk2*f**2 - 16800*Dd**2*Pk2*f*g2*s**2 + 8400*Dd**2*Pk2*f*g2*s))/(210*d**2*k2*k3**2) - D1**2*Pk3*ct*k2**3*st**4*(D1**2*(15*Pkdd2*bd1*f**3*k1**2*s**2 + 3*Pkdd2*k1**2*s*(b1**2*s*(10*fd**2 + 14*fd*(2*K - 1) + 7*fdd*(1 - 2*K)) + b1*(-14*bd1*fd*(2*K - 1)*(2*s - 1) + fd**2*(-8*C*s - 20*K*(s - 1) + 6*s) - 56*fd*s*(g2 - gd2) + 28*fdd*g2*s) + 8*fd*g2*(7*bd1 + 5*fd)*(s - 1)) + f**2*(3*Pkdd2*k1**2*(10*bd1**2*s*(s - 1) + bd1*(8*C*(s - 1)**2 + 6*K*s**2 - 10*b1*(2*s**2 - 2*s + 1) + s**2 + 12*s - 6) + bdd1*(-4*C*(s - 1)**2 - 10*K*s**2 + 5*b1*(2*s**2 - 2*s + 1) + 3*s**2 - 6*s + 3) + s**2*(-12*gd2 + 20*gdd2)) + fd*(16*Pk2*(4*C*(15*r**2 + 6*r*(s - 2) - 2*s + 5) - 39*r**2 - 6*r*(2*s - 5) + 4*s - 13) + Pkdd2*k1**2*(28*C + 15*b1 - 11)*(3*s**2 - 2*s + 1)) - 10*fdd*(2*Pk2*(4*C*(15*r**2 + 6*r*(s - 2) - 2*s + 5) - 39*r**2 - 12*r*s + 30*r + 4*s - 13) + Pkdd2*k1**2*(2*C - 1)*(3*s**2 - 2*s + 1))) + f*(-3*Pkdd2*fd*k1**2*(20*b1**2*s**2 - b1*(6*K*(2*s**2 - 2*s + 1) + s**2*(16*C + 40*bd1 + 2) - s*(20*bd1 + 14) + 7) + 4*bd1*s*(4*C*(s - 1) + 5*K*(2*s - 1) - 3*s + 3) + 4*g2*(6*s**2 - 6*s + 3) + 40*gd2*s*(1 - 2*s)) + 3*Pkdd2*k1**2*(10*b1**2*fdd*s**2 + b1*(-8*C*fdd*s**2 - 20*K*fdd*s**2 + 20*K*fdd*s - 10*K*fdd + 14*bd1*(2*K - 1)*(2*s**2 - 2*s + 1) - 7*bdd1*(2*K - 1)*(2*s**2 - 2*s + 1) + 6*fdd*s**2 - 56*gd2*s**2 + 28*gdd2*s**2) - 14*bd1**2*s*(2*K - 1)*(s - 1) - 56*bd1*(s - 1)*(g2*(s - 1) - gd2*s) + 4*g2*(7*bdd1*(s - 1)**2 + 5*fdd*(2*s**2 - 2*s + 1))) - 20*fd**2*(2*Pk2*(4*C*(15*r**2 + 6*r*(s - 2) - 2*s + 1) - 39*r**2 - 12*r*s + 30*r + 4*s - 2) + Pkdd2*k1**2*s*(2*C - 1)*(3*s - 2)))) + D1*(Dd*(-42*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(b1*(2*K - 1) - 4*g2) + 6*Pkdd2*f*k1**2*(b1**2*(14*K*(4*s**2 - 2*s + 1) + s**2*(40*fd - 28) - s*(10*fd - 14) - 7) - b1*(7*bd1*(2*K - 1)*(8*s**2 - 6*s + 1) + 28*g2*(4*s**2 - 2*s + 1) + (8*s - 2)*(5*K*fd*(2*s - 1) + fd*s*(4*C - 3) - 14*gd2*s)) + 4*g2*(4*s - 1)*(7*bd1*(s - 1) + 5*fd*(2*s - 1))) + f**3*(32*Pk2*(4*C*(10*r**2 + r*(4*s - 11) - 2*s + 5) - 26*r**2 + r*(28 - 8*s) + 4*s - 13) + Pkdd2*k1**2*(28*C + 15*b1 - 11)*(4*s**2 - 2*s + 1)) + f**2*(-3*Pkdd2*k1**2*(10*b1**2*(4*s**2 - 2*s + 1) - 10*b1*bd1*(8*s**2 - 6*s + 1) - b1*(8*C + 6*K + 1)*(4*s**2 - 2*s + 1) + 2*bd1*(4*s - 1)*(4*C*(s - 1) + s*(10*K - 3) + 3) + 12*g2*(4*s**2 - 2*s + 1) + 40*gd2*s*(1 - 4*s)) - 20*fd*(8*Pk2*(C*(60*r**2 + 3*r*(8*s - 19) - 10*s + 13) - 39*r**2 - 12*r*(s - 3) + 5*s - 8) + Pkdd2*k1**2*(2*C - 1)*(12*s**2 - 7*s + 1)))) + Ddd*f*(-21*Pkdd2*b1*k1**2*(b1*(2*K - 1) - 4*g2)*(4*s**2 - 2*s + 1) + 3*Pkdd2*f*k1**2*(5*b1**2 + b1*(-4*C - 10*K + 3) + 20*g2)*(4*s**2 - 2*s + 1) - 10*f**2*(4*Pk2*(4*C*(10*r**2 + 4*r*s - 11*r - 2*s + 5) - 26*r**2 - 8*r*s + 28*r + 4*s - 13) + Pkdd2*k1**2*(2*C - 1)*(4*s**2 - 2*s + 1)))) + 2*Dd**2*f*(-63*Pkdd2*b1*k1**2*s*(2*s - 1)*(b1*(2*K - 1) - 4*g2) + 9*Pkdd2*f*k1**2*s*(2*s - 1)*(5*b1**2 + b1*(-4*C - 10*K + 3) + 20*g2) - 10*f**2*(2*Pk2*(4*C*(30*r**2 + 12*r*s - 33*r - 6*s + 7) - 78*r**2 - 24*r*s + 84*r + 12*s - 17) + Pkdd2*k1**2*s*(6*C - 3)*(2*s - 1))))/(210*d**2*k1*k3**4) - D1**2*Pk3*ct*k2**3*st**2*(-84*D1**2*K*Pkdd2*bd1**2*f*k1**2*s*(s - 1) + D1*bd1*(D1*(168*Pkdd2*fd*g2*k1**2*s*(s - 1) + f**2*(20*Pk2*r*(4*C*(3*r + 2*s - 4) - 9*r - 4*s + 8) + Pkdd2*k1**2*(44*C*(s - 1)**2 - s**2*(42*K + 15) + 30*s - 15)) - 4*f*(7*Pkdd2*k1**2*(s - 1)*(g2*(s - 1) - 6*gd2*s) + 6*fd*(2*Pk2*(4*C*(6*r**2 + 4*r*s - 6*r - s + 2) - 18*r**2 - 8*r*s + 15*r + 2*s - 4) + Pkdd2*k1**2*s*(6*C - 3)*(s - 1)))) - 12*Dd*f*(16*Pk2*f*(C*(12*r**2 + r*(8*s - 15) - 2*s + 4) - 9*r**2 + r*(9 - 4*s) + s - 2) + Pkdd2*f*k1**2*(6*C - 3)*(4*s**2 - 5*s + 1) - 14*Pkdd2*g2*k1**2*(4*s**2 - 5*s + 1))) + 7*Pkdd2*b1**2*k1**2*(D1**2*s**2*(-6*K*fdd + fd*(2*K + 6*f + 5)) + D1*(Dd*(12*K*fd*s*(1 - 4*s) + 3*f**2*(4*s**2 - 2*s + 1) + f*(2*K + 5)*(4*s**2 - 2*s + 1)) - 6*Ddd*K*f*(4*s**2 - 2*s + 1)) + 36*Dd**2*K*f*s*(1 - 2*s)) + b1*(D1**2*(21*Pkdd2*bd1*f**2*k1**2*(2*s**2 - 2*s + 1) + 7*Pkdd2*f*k1**2*(-6*K*bdd1*(2*s**2 - 2*s + 1) + bd1*(2*K + 5)*(2*s**2 - 2*s + 1) + s**2*(-4*gd2 + 12*gdd2)) - 28*Pkdd2*fd*k1**2*s*(3*K*bd1*(2*s - 1) + s*(g2 - 6*gd2)) + 84*Pkdd2*fdd*g2*k1**2*s**2 + 2*f*fd*(10*Pk2*(4*C*(6*r**2 + 4*r*(s - 1) - 2*s + 3) - 18*r**2 - 8*r*s + 14*r + 4*s - 9) + Pkdd2*k1**2*(-21*K*(2*s**2 - 2*s + 1) + s**2*(44*C - 15))) - 12*f*fdd*(2*Pk2*(4*C*(6*r**2 + 4*r*(s - 1) - 2*s + 3) - 18*r**2 - 8*r*s + 14*r + 4*s - 9) + Pkdd2*k1**2*s**2*(6*C - 3)) - 12*fd**2*(4*Pk2*(4*C*(3*r**2 + 2*r*(s - 1) - s - 1) - 9*r**2 - 4*r*s + 7*r + 2*s + 2) + Pkdd2*k1**2*s**2*(6*C - 3))) + D1*(Dd*(168*Pkdd2*fd*g2*k1**2*s*(4*s - 1) + f**2*(40*Pk2*(4*C*(6*r**2 + r*(4*s - 7) - 2*s + 3) - 18*r**2 + r*(20 - 8*s) + 4*s - 9) + Pkdd2*k1**2*(44*C - 42*K - 15)*(4*s**2 - 2*s + 1)) - 4*f*(7*Pkdd2*k1**2*(g2*(4*s**2 - 2*s + 1) - (12*s - 3)*(bd1*(-2*K*s + K) + 2*gd2*s)) + 6*fd*(8*Pk2*(2*r - 1)*(C*(12*r + 8*s - 5) - 9*r - 4*s + 4) + Pkdd2*k1**2*s*(6*C - 3)*(4*s - 1)))) - 6*Ddd*f*(8*Pk2*f*(4*C*(6*r**2 + r*(4*s - 7) - 2*s + 3) - 18*r**2 + r*(20 - 8*s) + 4*s - 9) + Pkdd2*f*k1**2*(6*C - 3)*(4*s**2 - 2*s + 1) - 14*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1))) - 12*Dd**2*f*(4*Pk2*f*(4*C*(18*r**2 + 3*r*(4*s - 7) - 6*s + 5) - 54*r**2 + r*(60 - 24*s) + 12*s - 13) + Pkdd2*f*k1**2*s*(18*C - 9)*(2*s - 1) + 42*Pkdd2*g2*k1**2*s*(1 - 2*s))) + 2*f*(D1**2*(-Pk2*fd**2*(32*C - 16)*(15*r**2 + r*(36*s - 22) - 12*s + 6) + 42*Pkdd2*bdd1*g2*k1**2*(s - 1)**2 + 42*Pkdd2*fd*g2*k1**2*(2*s**2 - 2*s + 1) + f*(-12*Pk2*bdd1*r*(4*C*(3*r + 2*s - 4) - 9*r - 4*s + 8) - Pk2*fdd*(16*C - 8)*(15*r**2 + r*(36*s - 22) - 12*s + 5) - 9*Pkdd2*bdd1*k1**2*(2*C - 1)*(s - 1)**2 + 42*Pkdd2*gd2*k1**2*s**2 + fd*(2*C - 1)*(4*Pk2*(33*r**2 + r*(72*s - 46) - 24*s + 11) - 9*Pkdd2*k1**2*(3*s**2 - 2*s + 1)))) + D1*f*(Dd*(-Pk2*fd*(128*C - 64)*(15*r**2 + r*(36*s - 23) - 15*s + 7) + 42*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + f*(2*C - 1)*(8*Pk2*(22*r**2 + r*(48*s - 34) - 24*s + 11) - 9*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(16 - 32*C)*(10*r**2 + 8*r*(3*s - 2) - 12*s + 5)) + Dd**2*Pk2*f**2*(16 - 32*C)*(30*r**2 + 24*r*(3*s - 2) - 36*s + 17)))/(210*d**2*k1*k3**4) + D1**2*Pk3*ct*k2**3*(D1*f*(-56*D1*Pk2*bd1**2*r*(2*C - 1)*(2*r + 2*s - 1) + 4*D1*Pk2*bdd1*f*r*(2*C - 1)*(9*r + 14*s - 14) + bd1*(D1*(Pk2*fd*(16*C - 8)*(18*r**2 + r*(28*s - 23) - 7*s + 7) - 70*Pkdd2*g2*k1**2*(s - 1)**2 + f*(2*C - 1)*(-8*Pk2*r*(9*r + 7*s - 7) + 21*Pkdd2*k1**2*(s - 1)**2)) + Dd*Pk2*f*(16*C - 8)*(36*r**2 + 56*r*s - 53*r - 14*s + 14))) + 7*b1**2*(D1**2*(5*K*Pkdd2*fd*k1**2*s**2 + Pk2*fd*(32*C - 16)*(r - 1)*(r + s - 1) - Pk2*fdd*(16*C - 8)*(r - 1)*(r + s - 1)) + D1*(Dd*(Pk2*fd*(8 - 16*C)*(8*r**2 + r*(8*s - 13) - 6*s + 5) + f*(5*K*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + Pk2*(32*C - 16)*(4*r**2 + r*(4*s - 5) - 2*s + 2))) + Ddd*Pk2*f*(8 - 16*C)*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - Dd**2*Pk2*f*(16*C - 8)*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) + b1*(-2*D1**2*(f*(28*Pk2*bdd1*r*(2*C - 1)*(2*r + 2*s - 1) - Pk2*fdd*(4*C - 2)*(18*r**2 + 2*r*(14*s - 9) - 14*s + 9) + 35*Pkdd2*gd2*k1**2*s**2 + fd*(2*C - 1)*(4*Pk2*(18*r**2 + 2*r*(7*s - 9) - 7*s + 9) - 21*Pkdd2*k1**2*s**2)) + fd*(-Pk2*fd*(8*C - 4)*(9*r**2 + r*(14*s - 9) - 7*s) + 35*Pkdd2*g2*k1**2*s**2)) + 7*D1*bd1*(D1*(Pk2*fd*(8 - 16*C)*(4*r**2 + r*(4*s - 5) - 2*s + 1) + f*(5*K*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + Pk2*r*(32*C - 16)*(2*r + 2*s - 1))) + Dd*Pk2*f*(16 - 32*C)*(8*r**2 + r*(8*s - 7) - 2*s + 1)) + D1*f*(Dd*(Pk2*fd*(16*C - 8)*(2*r - 1)*(36*r + 56*s - 25) - 70*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) - f*(2*C - 1)*(8*Pk2*(36*r**2 + r*(28*s - 43) - 14*s + 18) - 21*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(16*C - 8)*(18*r**2 + r*(28*s - 25) - 14*s + 9)) + Dd**2*Pk2*f**2*(16*C - 8)*(54*r**2 + r*(84*s - 75) - 42*s + 23)))/(105*d**2*k1*k3**4) + D1**2*Pk3*ct*k2*st**4*(D1**2*(15*Pkdd2*bd1*f**3*k1**2*s**2 + 3*Pkdd2*k1**2*(b1**2*(10*fd**2*s - 14*fd*(2*K*(s - 1)**2 + 2*s - 1) + 7*fdd*(2*K*(s - 1)**2 + 2*s - 1)) + 2*b1*(fd**2*s*(4*C*(s - 1) - 10*K*(s - 1) - 2*s + 3) + 7*fd*(4*g2*(s - 1)**2 + s*(4*K*bd1*(s - 1) + bd1 - 4*gd2*(s - 1))) - 14*fdd*g2*(s - 1)**2) - 4*fd*s*(s - 1)*(5*b2*fd + g2*(14*bd1 - 10*fd))) + f**2*(3*Pkdd2*k1**2*(-10*bd1**2*s + bd1*(10*b1*(2*s - 1) + s**2*(-8*C + 20*K + 11) + 4*s - 2) + bdd1*(b1*(5 - 10*s) + s**2*(4*C - 10*K - 2) - 2*s + 1) + s**2*(20*bd2 - 10*bdd2 - 40*gd2 + 20*gdd2)) + fd*(-16*Pk2*(9*r**2 + 2*r*(4*C*(3*s - 1) - 6*s - 1) + s*(4 - 8*C) + 3) + Pkdd2*k1**2*(40*C + 15*b1 - 17)*(3*s**2 - 2*s + 1)) + 10*fdd*(2*Pk2*(-8*C*s + 9*r**2 + 2*r*(12*C*s - 4*C - 6*s - 1) + 4*s + 3) - Pkdd2*k1**2*(2*C - 1)*(3*s**2 - 2*s + 1))) + f*(-3*Pkdd2*fd*k1**2*(-16*C*bd1*s**2 + 8*C*bd1*s + 40*K*bd1*s**2 - 20*K*bd1*s + 10*b1**2*(2*s - 1) + b1*(8*C*(2*s**2 - 2*s + 1) - 20*K*(2*s**2 - 2*s + 1) - 22*s**2 + 26*s - 13) - 20*b2*(2*s**2 - 2*s + 1) + 8*bd1*s**2 - 2*bd1*s + 40*bd2*s**2 - 20*bd2*s + 80*g2*s**2 - 80*g2*s + 40*g2 - 80*gd2*s**2 + 40*gd2*s) + 3*Pkdd2*k1**2*(5*b1**2*fdd*(2*s - 1) + b1*(8*C*fdd*s**2 - 8*C*fdd*s + 4*C*fdd - 20*K*fdd*s**2 + 20*K*fdd*s - 10*K*fdd - 14*bd1*(4*K*s**2 - 2*s + 1) + 7*bdd1*(4*K*s**2 - 2*s + 1) - 4*fdd*s**2 + 6*fdd*s - 3*fdd + 56*gd2*s**2 - 28*gdd2*s**2) - 10*b2*fdd*(2*s**2 - 2*s + 1) + 20*fdd*g2*(2*s**2 - 2*s + 1) - 14*s*(bd1**2*(-2*K*s + 1) + 4*bd1*s*(-g2 + gd2) + 2*bdd1*g2*s)) + 20*fd**2*(2*Pk2*(4*C*(r*(6*s - 2) - 2*s + 1) + 9*r**2 - 2*r*(6*s + 1) + 4*s - 2) + Pkdd2*k1**2*s*(C*(4 - 6*s) + 3*s - 2)))) + D1*(Dd*(42*Pkdd2*b1*fd*k1**2*(4*s - 1)*(2*K*b1*(s - 1) + b1 - 4*g2*(s - 1)) + 6*Pkdd2*f*k1**2*(b1**2*(-14*K*(4*s**2 - 2*s + 1) + 5*fd*(4*s - 1)) + b1*(7*bd1*(4*s - 1)*(4*K*s - 1) + fd*(4*s - 1)*(8*C*s - 4*C - 20*K*s + 10*K - 4*s + 3) + 112*g2*s**2 - 56*g2*s + 28*g2 - 112*gd2*s**2 + 28*gd2*s) + (2 - 8*s)*(5*b2*fd*(2*s - 1) + 2*g2*(7*bd1*s + fd*(5 - 10*s)))) + f**3*(-32*Pk2*(6*r**2 + 4*r*(C*(4*s - 1) - 2*s - 1) + s*(4 - 8*C) + 3) + Pkdd2*k1**2*(40*C + 15*b1 - 17)*(4*s**2 - 2*s + 1)) + f**2*(8*C*(-3*Pkdd2*k1**2*(b1*(4*s**2 - 2*s + 1) + bd1*s*(1 - 4*s)) + 5*fd*(4*Pk2*(24*r*s - 7*r - 10*s + 3) + Pkdd2*k1**2*(-12*s**2 + 7*s - 1))) - 3*Pkdd2*b1*k1**2*(10*bd1*(4*s - 1) - (20*K + 11)*(4*s**2 - 2*s + 1)) + 60*Pkdd2*b2*k1**2*(4*s**2 - 2*s + 1) - 6*Pkdd2*bd1*k1**2*(4*s - 1)*(s*(10*K + 2) + 1) - 60*Pkdd2*k1**2*(g2*(8*s**2 - 4*s + 2) + s*(bd2 - 2*gd2)*(4*s - 1)) + 20*fd*(8*Pk2*(9*r**2 - 4*r*(3*s + 1) + 5*s) + Pkdd2*k1**2*(12*s**2 - 7*s + 1)))) + 2*Ddd*f*(21*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1) - 3*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)*(-2*C*b1 + 5*K*b1 + b1 + 5*b2 - 10*g2) + 5*f**2*(4*Pk2*(-8*C*s + 6*r**2 + 4*r*(4*C*s - C - 2*s - 1) + 4*s + 3) - Pkdd2*k1**2*(2*C - 1)*(4*s**2 - 2*s + 1)))) + 4*Dd**2*f*(63*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2) - 9*Pkdd2*f*k1**2*s*(2*s - 1)*(-2*C*b1 + 5*K*b1 + b1 + 5*b2 - 10*g2) + 5*f**2*(2*Pk2*(4*C*(3*r*(4*s - 1) - 6*s + 2) + 18*r**2 - 12*r*(2*s + 1) + 12*s - 1) + 3*Pkdd2*k1**2*s*(C*(2 - 4*s) + 2*s - 1))))/(210*d**2*k1*k3**2) + D1**2*Pk3*ct*k2*st**2*(D1**2*(-28*Pkdd2*bd1*k1**2*s*(s - 1)*(3*b2*fd + 10*bd1*g2 - 6*fd*g2) + f**2*(-240*C*Pk2*bd1*r**2 + 288*C*Pk2*bdd1*r**2 + 100*C*Pkdd2*bd1*k1**2*s**2 - 144*C*Pkdd2*bd1*k1**2*s + 72*C*Pkdd2*bd1*k1**2 - 36*C*Pkdd2*bdd1*k1**2*s**2 + 72*C*Pkdd2*bdd1*k1**2*s - 36*C*Pkdd2*bdd1*k1**2 - 42*K*Pkdd2*bd1*k1**2*s**2 + 120*Pk2*bd1*r**2 - 144*Pk2*bdd1*r**2 - Pk2*fdd*(32*C - 16)*(15*r**2 + 36*r*s - 22*r - 12*s + 5) - 50*Pkdd2*bd1*k1**2*s**2 + 58*Pkdd2*bd1*k1**2*s - 29*Pkdd2*bd1*k1**2 - 42*Pkdd2*bd2*k1**2*s**2 + 18*Pkdd2*bdd1*k1**2*s**2 - 36*Pkdd2*bdd1*k1**2*s + 18*Pkdd2*bdd1*k1**2 + 84*Pkdd2*gd2*k1**2*s**2 + fd*(4*C - 2)*(4*Pk2*(33*r**2 + 72*r*s - 46*r - 24*s + 11) - 9*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) - 2*f*(Pk2*fd**2*(32*C - 16)*(15*r**2 + r*(36*s - 22) - 12*s + 6) - 7*Pkdd2*k1**2*(3*b2*(2*bd1 - bdd1)*(s - 1)**2 + bd1**2*s*(s - 1)*(4*C - 6*K - 3) - 2*bd1*(g2*(11*s**2 - 12*s + 6) + s*(3*bd2 - 6*gd2)*(s - 1)) + 6*bdd1*g2*(s - 1)**2) + 3*fd*(7*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) - 14*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) - 12*bd1*(2*C - 1)*(4*Pk2*r*(2*r - 1) - Pkdd2*k1**2*s*(s - 1))))) + 2*D1*f*(Dd*(-42*Pkdd2*bd1*k1**2*(b2 - 2*g2)*(4*s**2 - 5*s + 1) + f**2*(2*C - 1)*(8*Pk2*(22*r**2 + r*(48*s - 34) - 24*s + 11) - 9*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(Pk2*fd*(64 - 128*C)*(15*r**2 + r*(36*s - 23) - 15*s + 7) - 21*Pkdd2*b2*k1**2*(4*s**2 - 2*s + 1) + 42*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) - 18*bd1*(2*C - 1)*(16*Pk2*r*(1 - 2*r) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + Ddd*Pk2*f**2*(16 - 32*C)*(10*r**2 + 8*r*(3*s - 2) - 12*s + 5)) + Dd**2*Pk2*f**3*(32 - 64*C)*(30*r**2 + 24*r*(3*s - 2) - 36*s + 17) + 7*Pkdd2*b1**3*k1**2*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-10*K*(4*s**2 - 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s + 20*s**2 - 10*s + 5) - D1*Ddd*(-10*K + 3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-10*K + 3*f + 5)) + 7*Pkdd2*b1**2*k1**2*(-8*C*D1**2*fd*s**2 + 4*C*D1**2*fdd*s**2 - 32*C*D1*Dd*f*s**2 + 16*C*D1*Dd*f*s - 8*C*D1*Dd*f + 32*C*D1*Dd*fd*s**2 - 8*C*D1*Dd*fd*s + 16*C*D1*Ddd*f*s**2 - 8*C*D1*Ddd*f*s + 4*C*D1*Ddd*f + 48*C*Dd**2*f*s**2 - 24*C*Dd**2*f*s + 22*D1**2*K*fd*s**2 - 20*D1**2*K*fd*s + 10*D1**2*K*fd - 6*D1**2*K*fdd*s**2 - D1**2*bdd1*(-10*K + 3*f + 5)*(3*s**2 - 2*s + 1) + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 6*D1**2*fd*s**2 + 10*D1**2*fd*s - 5*D1**2*fd - 3*D1**2*fdd*s**2 + 40*D1**2*gd2*s**2 - 20*D1**2*gdd2*s**2 + 88*D1*Dd*K*f*s**2 - 44*D1*Dd*K*f*s + 22*D1*Dd*K*f - 48*D1*Dd*K*fd*s**2 + 12*D1*Dd*K*fd*s + 24*D1*Dd*f*s**2 - 12*D1*Dd*f*s + 6*D1*Dd*f - 24*D1*Dd*fd*s**2 + 6*D1*Dd*fd*s + 160*D1*Dd*g2*s**2 - 80*D1*Dd*g2*s + 40*D1*Dd*g2 - 160*D1*Dd*gd2*s**2 + 40*D1*Dd*gd2*s - 24*D1*Ddd*K*f*s**2 + 12*D1*Ddd*K*f*s - 6*D1*Ddd*K*f - 12*D1*Ddd*f*s**2 + 6*D1*Ddd*f*s - 3*D1*Ddd*f - 80*D1*Ddd*g2*s**2 + 40*D1*Ddd*g2*s - 20*D1*Ddd*g2 + 2*D1*bd1*(D1*(-10*K*(3*s**2 - 2*s + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s + 15*s**2 - 10*s + 5) - Dd*(-10*K + 3*f + 5)*(12*s**2 - 7*s + 1)) - 72*Dd**2*K*f*s**2 + 36*Dd**2*K*f*s - 36*Dd**2*f*s**2 + 18*Dd**2*f*s - 240*Dd**2*g2*s**2 + 120*Dd**2*g2*s) - b1*(D1**2*(-576*C*Pk2*fd**2*r**2 + 576*C*Pk2*fd**2*r + 72*C*Pkdd2*fd**2*k1**2*s**2 + 288*Pk2*fd**2*r**2 - 288*Pk2*fd**2*r - 84*Pkdd2*b2*fd*k1**2*s**2 + 42*Pkdd2*b2*fdd*k1**2*s**2 - 70*Pkdd2*bd1**2*k1**2*s*(2*K - 1)*(3*s - 2) + 21*Pkdd2*bd1*f**2*k1**2*(2*s - 1) - 14*Pkdd2*bd1*k1**2*(20*g2*(2*s**2 - 2*s + 1) + s*(2*s - 1)*(fd*(4*C - 6*K - 3) - 20*gd2)) + 84*Pkdd2*bd2*fd*k1**2*s**2 + 140*Pkdd2*bdd1*g2*k1**2*(2*s**2 - 2*s + 1) - 36*Pkdd2*fd**2*k1**2*s**2 + 308*Pkdd2*fd*g2*k1**2*s**2 - 280*Pkdd2*fd*g2*k1**2*s + 140*Pkdd2*fd*g2*k1**2 - 168*Pkdd2*fd*gd2*k1**2*s**2 - 84*Pkdd2*fdd*g2*k1**2*s**2 + f*(7*Pkdd2*k1**2*(6*bd1**2*s*(3*s - 2) + bd1*(8*C*(2*s**2 - 2*s + 1) - 4*K*(11*s**2 - 6*s + 3) - 12*s**2 + 22*s - 11) - bdd1*(4*C - 6*K - 3)*(2*s**2 - 2*s + 1) + s**2*(-12*bd2 + 6*bdd2 + 44*gd2 - 12*gdd2)) + fd*(Pk2*(240*C - 120)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-4*C*(50*s**2 - 14*s + 7) + 42*K*(2*s**2 - 2*s + 1) + 100*s**2 - 42*s + 21)) + fdd*(36 - 72*C)*(Pk2*(8*r**2 - 8*r + 4) - Pkdd2*k1**2*s**2))) + 2*D1*(Dd*(14*Pkdd2*k1**2*(4*s - 1)*(10*bd1*g2*(2*s - 1) + 3*fd*s*(b2 - 2*g2)) + f**2*(Pk2*(240*C - 120)*(2*r**2 - 2*r + 1) - Pkdd2*k1**2*(50*C - 21*K - 25)*(4*s**2 - 2*s + 1)) + f*(-7*Pkdd2*k1**2*(6*b2*(4*s**2 - 2*s + 1) + bd1*(4*C - 6*K - 3)*(8*s**2 - 6*s + 1) - 24*bd2*s**2 + 6*bd2*s - 88*g2*s**2 + 44*g2*s - 22*g2 + 48*gd2*s**2 - 12*gd2*s) + fd*(36 - 72*C)*(8*Pk2*(1 - 2*r)**2 + Pkdd2*k1**2*s*(1 - 4*s)))) + 3*Ddd*f*(Pkdd2*k1**2*(7*b2 - 14*g2)*(4*s**2 - 2*s + 1) - f*(6*C - 3)*(16*Pk2*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-4*s**2 + 2*s - 1)))) + 36*Dd**2*f*(Pkdd2*k1**2*s*(7*b2 - 14*g2)*(2*s - 1) - f*(2*C - 1)*(8*Pk2*(6*r**2 - 6*r + 1) + 3*Pkdd2*k1**2*s*(1 - 2*s)))))/(210*d**2*k1*k3**2) - D1**2*Pk3*ct*k2*(35*D1*Pkdd2*b1**3*k1**2*(D1*fd*s**2 + Dd*(-6*K + f + 3)*(4*s**2 - 2*s + 1)) + 2*D1*f*(-28*D1*Pk2*bd1**2*r*(4*C*(3*r + 2*s - 1) - 9*r - 4*s + 2) + 4*D1*Pk2*bdd1*f*r*(2*C - 1)*(9*r - 14) + bd1*(D1*(-144*C*Pk2*f*r**2 + 112*C*Pk2*f*r + 42*C*Pkdd2*f*k1**2*s**2 - 84*C*Pkdd2*f*k1**2*s + 42*C*Pkdd2*f*k1**2 + 72*Pk2*f*r**2 - 56*Pk2*f*r + Pk2*fd*(16*C - 8)*(18*r**2 - 16*r + 7) + 35*Pkdd2*b2*k1**2*(s - 1)**2 - 21*Pkdd2*f*k1**2*s**2 + 42*Pkdd2*f*k1**2*s - 21*Pkdd2*f*k1**2 - 70*Pkdd2*g2*k1**2*s**2 + 140*Pkdd2*g2*k1**2*s - 70*Pkdd2*g2*k1**2) + Dd*Pk2*f*(32*C - 16)*(18*r**2 - 23*r + 7))) + 7*b1**2*(D1**2*(-4*Pk2*fdd*(r - 1)*(4*C*(3*r + 2*s - 3) - 9*r - 4*s + 9) + 5*Pkdd2*k1**2*(bd1*(-6*K + f + 3)*(3*s**2 - 2*s + 1) + 12*gd2*s**2) + fd*(8*Pk2*(r - 1)*(4*C*(3*r + 2*s - 3) - 9*r - 4*s + 9) + Pkdd2*k1**2*s**2*(-20*C + 10*K + 15))) + D1*(Dd*(-32*Pk2*fd*(C*(12*r**2 + 8*r*s - 19*r - 6*s + 7) - 9*r**2 - 4*r*s + 14*r + 3*s - 5) + 60*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + f*(16*Pk2*(4*C*(6*r**2 + 4*r*s - 7*r - 2*s + 3) - 18*r**2 - 8*r*s + 20*r + 4*s - 9) + Pkdd2*k1**2*(-20*C + 10*K + 15)*(4*s**2 - 2*s + 1))) - 8*Ddd*Pk2*f*(4*C*(6*r**2 + r*(4*s - 7) - 2*s + 3) - 18*r**2 + r*(20 - 8*s) + 4*s - 9)) - 8*Dd**2*Pk2*f*(4*C*(18*r**2 + 3*r*(4*s - 7) - 6*s + 5) - 54*r**2 + r*(60 - 24*s) + 12*s - 13)) + b1*(2*D1**2*(f*(-28*Pk2*bdd1*r*(4*C*(3*r + 2*s - 1) - 9*r - 4*s + 2) + Pk2*fdd*(8*C - 4)*(18*r**2 - 4*r + 9) + Pkdd2*k1**2*s**2*(35*bd2 - 70*gd2) - fd*(4*C - 2)*(4*Pk2*(18*r**2 - 11*r + 9) - 21*Pkdd2*k1**2*s**2)) + fd*(Pk2*fd*(16*C - 8)*(9*r**2 - 2*r - 7) + Pkdd2*k1**2*s**2*(35*b2 - 70*g2))) + 7*D1*bd1*(D1*(16*Pk2*f*r*(4*C*(3*r + 2*s - 1) - 9*r - 4*s + 2) - 16*Pk2*fd*(2*C*(6*r**2 + r*(4*s - 7) - 2*s + 1) - 9*r**2 + r*(10 - 4*s) + 2*s - 1) - 5*Pkdd2*f*k1**2*(4*C - 2*K - 3)*(2*s**2 - 2*s + 1) + 60*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1)) - 32*Dd*Pk2*f*(2*C*(12*r**2 + r*(8*s - 9) - 2*s + 1) - 18*r**2 + r*(12 - 8*s) + 2*s - 1)) + 2*D1*f*(Dd*(Pk2*fd*(64*C - 32)*(18*r**2 - 11*r + 1) + Pkdd2*k1**2*(35*b2 - 70*g2)*(4*s**2 - 2*s + 1) - f*(6*C - 3)*(48*Pk2*(2*r**2 - 2*r + 1) - 7*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(144*C - 72)*(2*r**2 - 2*r + 1)) + 2*Dd**2*Pk2*f**2*(144*C - 72)*(6*r**2 - 6*r + 1)))/(210*d**2*k1*k3**2) + D1**2*Pk3*ct*st**2*(D1*f*(24*D1*Pk2*bdd1*f*r*(8*C*s + 3*r - 4*s) + 14*D1*Pkdd2*bd1**2*k1**2*s*(s - 1) + D1*bd1*(48*Pk2*fd*(-4*C*s + 6*r**2 + r*(16*C*s - 4*C - 8*s - 1) + 2*s) + f*(-20*Pk2*r*(8*C*s + 3*r - 4*s) + 7*Pkdd2*k1**2*s**2)) + 192*Dd*Pk2*bd1*f*(-2*C*s + 3*r**2 + r*(C*(8*s - 1) - 4*s - 1) + s)) - 7*Pkdd2*b1**3*k1**2*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd - 20) + s*(3*fd - 10) + 5) - D1*Ddd*(3*f + 5)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 5)*(2*s - 1)) - 7*Pkdd2*b1**2*k1**2*(-D1**2*bdd1*(3*f + 5)*(3*s**2 - 2*s + 1) - 6*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s - 3*D1**2*f*fd - 3*D1**2*fd*s**2 + 10*D1**2*fd*s - 5*D1**2*fd - D1**2*fdd*s**2 - 12*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 12*D1*Dd*f*s**2 + 6*D1*Dd*f*s - 3*D1*Dd*f - 8*D1*Dd*fd*s**2 + 2*D1*Dd*fd*s - 4*D1*Ddd*f*s**2 + 2*D1*Ddd*f*s - D1*Ddd*f + 2*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(15 - 9*fd) + s*(3*fd - 10) + 5) - Dd*(3*f + 5)*(12*s**2 - 7*s + 1)) - 12*Dd**2*f*s**2 + 6*Dd**2*f*s) + b1*(D1**2*(48*Pk2*fd**2*(C*(r*(8*s - 4) - 4*s + 4) + 3*r**2 - 4*r*s - r + 2*s - 2) + 70*Pkdd2*bd1**2*k1**2*s*(3*s - 2) + 42*Pkdd2*bd1*f**2*k1**2*s**2 + 14*Pkdd2*bd1*fd*k1**2*s*(2*s - 1) + f*(24*Pk2*fdd*(-8*C*s + 6*r**2 + 2*r*(8*C*s - 4*C - 4*s - 1) + 4*s + 3) + 7*Pkdd2*k1**2*(6*bd1**2*s*(3*s - 2) + bd1*(6*s**2 + 4*s - 2) + bdd1*(2*s**2 - 2*s + 1)) + fd*(-20*Pk2*(-8*C*s + 6*r**2 + 2*r*(8*C*s - 4*C - 4*s - 1) + 4*s + 3) + 7*Pkdd2*k1**2*(2*s**2 - 2*s + 1)))) + D1*f*(Dd*(192*C*Pk2*fd*(2*r - 1)*(8*s - 3) - 40*Pk2*f*(6*r**2 + 4*r*(C*(4*s - 1) - 2*s - 1) + s*(4 - 8*C) + 3) + 192*Pk2*fd*(2*r - 1)*(3*r - 4*s) + 14*Pkdd2*bd1*k1**2*(8*s**2 - 6*s + 1) + 7*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) + 48*Ddd*Pk2*f*(6*r**2 + 4*r*(C*(4*s - 1) - 2*s - 1) + s*(4 - 8*C) + 3)) + 48*Dd**2*Pk2*f**2*(4*C*(3*r*(4*s - 1) - 6*s + 2) + 18*r**2 - 12*r*(2*s + 1) + 12*s - 1)))/(210*d**2*k1*k2) + D1**2*Pk3*ct*(8*D1*Pk2*f*(3*D1*bd1**2*r**2 + 2*D1*bdd1*f*r*s*(1 - 2*C) - 2*bd1*(2*C - 1)*(-D1*(f*r*s + fd*(-4*r*s + r + s)) + Dd*f*(r*(8*s - 1) - 2*s))) + 5*D1*Pkdd2*b1**3*k1**2*(D1*fd*s**2 + Dd*(f + 3)*(4*s**2 - 2*s + 1)) + b1**2*(D1**2*(12*Pk2*fdd*(r - 1)**2 + 5*Pkdd2*bd1*k1**2*(f + 3)*(3*s**2 - 2*s + 1) + fd*(-24*Pk2*(r - 1)**2 + 5*Pkdd2*k1**2*s**2)) + D1*(Dd*(-48*Pk2*f*(2*r**2 - 2*r + 1) + 48*Pk2*fd*(2*r**2 - 3*r + 1) + 5*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) + 24*Ddd*Pk2*f*(2*r**2 - 2*r + 1)) + 24*Dd**2*Pk2*f*(6*r**2 - 6*r + 1)) + b1*(16*D1*Dd*Pk2*f*(6*bd1*r*(2*r - 1) + f*(2*C - 1)*(4*r*s - r - 2*s) - fd*(2*C - 1)*(2*r - 1)*(8*s - 3)) + D1*(D1*(Pk2*fd**2*(16 - 32*C)*(r*(2*s - 1) - s + 1) + 16*Pk2*fd*(3*bd1*r*(r - 1) + f*(2*C - 1)*(2*r*s - r - s)) + f*(-48*Pk2*bd1*r**2 + 24*Pk2*bdd1*r**2 - Pk2*fdd*(32*C - 16)*(r*(2*s - 1) - s) + 5*Pkdd2*bd1*k1**2*(2*s**2 - 2*s + 1))) + Ddd*Pk2*f**2*(16 - 32*C)*(r*(4*s - 1) - 2*s)) + Dd**2*Pk2*f**2*(16 - 32*C)*(3*r*(4*s - 1) - 6*s + 2)))/(30*d**2*k1*k2) + D1**2*Pk3*f*k1**2*st**6*(-4224*D1**2*Pk2*b1*f*fd*r*s + 1408*D1**2*Pk2*b1*f*fd*r - 3168*D1**2*Pk2*b1*f*fd*s**2 + 3520*D1**2*Pk2*b1*f*fd*s - 880*D1**2*Pk2*b1*f*fd + 2112*D1**2*Pk2*b1*f*fdd*r*s - 704*D1**2*Pk2*b1*f*fdd*r + 1584*D1**2*Pk2*b1*f*fdd*s**2 - 1760*D1**2*Pk2*b1*f*fdd*s + 440*D1**2*Pk2*b1*f*fdd + 4224*D1**2*Pk2*b1*fd**2*r*s - 1408*D1**2*Pk2*b1*fd**2*r + 3168*D1**2*Pk2*b1*fd**2*s**2 - 3520*D1**2*Pk2*b1*fd**2*s + 880*D1**2*Pk2*b1*fd**2 + 88*D1**2*Pk2*bdd1*f**2*(6*s**2 + s*(8*r - 8) + 1) + 3168*D1**2*Pk2*f**2*fd*r*s - 792*D1**2*Pk2*f**2*fd*r + 2992*D1**2*Pk2*f**2*fd*s**2 - 3080*D1**2*Pk2*f**2*fd*s + 748*D1**2*Pk2*f**2*fd - 3168*D1**2*Pk2*f**2*fdd*r*s + 792*D1**2*Pk2*f**2*fdd*r - 2288*D1**2*Pk2*f**2*fdd*s**2 + 2728*D1**2*Pk2*f**2*fdd*s - 572*D1**2*Pk2*f**2*fdd - 9504*D1**2*Pk2*f*fd**2*r*s + 2376*D1**2*Pk2*f*fd**2*r - 6864*D1**2*Pk2*f*fd**2*s**2 + 8184*D1**2*Pk2*f*fd**2*s - 1584*D1**2*Pk2*f*fd**2 - 72*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 36*D1**2*Pkdd2*f**2*fd*k1**2*s - 18*D1**2*Pkdd2*f**2*fd*k1**2 + 36*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 18*D1**2*Pkdd2*f**2*fdd*k1**2*s + 9*D1**2*Pkdd2*f**2*fdd*k1**2 + 108*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 54*D1**2*Pkdd2*f*fd**2*k1**2*s - 5632*D1*Dd*Pk2*b1*f**2*r*s + 1408*D1*Dd*Pk2*b1*f**2*r - 4224*D1*Dd*Pk2*b1*f**2*s**2 + 4928*D1*Dd*Pk2*b1*f**2*s - 1056*D1*Dd*Pk2*b1*f**2 + 16896*D1*Dd*Pk2*b1*f*fd*r*s - 4928*D1*Dd*Pk2*b1*f*fd*r + 12672*D1*Dd*Pk2*b1*f*fd*s**2 - 14432*D1*Dd*Pk2*b1*f*fd*s + 3168*D1*Dd*Pk2*b1*f*fd + 3168*D1*Dd*Pk2*f**3*r*s - 792*D1*Dd*Pk2*f**3*r + 2992*D1*Dd*Pk2*f**3*s**2 - 3080*D1*Dd*Pk2*f**3*s + 748*D1*Dd*Pk2*f**3 - 25344*D1*Dd*Pk2*f**2*fd*r*s + 6336*D1*Dd*Pk2*f**2*fd*r - 18304*D1*Dd*Pk2*f**2*fd*s**2 + 21824*D1*Dd*Pk2*f**2*fd*s - 4312*D1*Dd*Pk2*f**2*fd - 72*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 36*D1*Dd*Pkdd2*f**3*k1**2*s - 18*D1*Dd*Pkdd2*f**3*k1**2 + 288*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 144*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 18*D1*Dd*Pkdd2*f**2*fd*k1**2 + 2816*D1*Ddd*Pk2*b1*f**2*r*s - 704*D1*Ddd*Pk2*b1*f**2*r + 2112*D1*Ddd*Pk2*b1*f**2*s**2 - 2464*D1*Ddd*Pk2*b1*f**2*s + 528*D1*Ddd*Pk2*b1*f**2 - 3168*D1*Ddd*Pk2*f**3*r*s + 792*D1*Ddd*Pk2*f**3*r - 2288*D1*Ddd*Pk2*f**3*s**2 + 2728*D1*Ddd*Pk2*f**3*s - 572*D1*Ddd*Pk2*f**3 + 36*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 18*D1*Ddd*Pkdd2*f**3*k1**2*s + 9*D1*Ddd*Pkdd2*f**3*k1**2 - 176*D1*Pk2*bd1*f*(D1*(f*(6*s**2 + s*(8*r - 8) + 1) + fd*(r*(4 - 24*s) - 18*s**2 + 22*s - 3)) - 2*Dd*f*(2*r*(8*s - 1) + 12*s**2 - 15*s + 2)) + 8448*Dd**2*Pk2*b1*f**2*r*s - 2112*Dd**2*Pk2*b1*f**2*r + 6336*Dd**2*Pk2*b1*f**2*s**2 - 7392*Dd**2*Pk2*b1*f**2*s + 1408*Dd**2*Pk2*b1*f**2 - 9504*Dd**2*Pk2*f**3*r*s + 2376*Dd**2*Pk2*f**3*r - 6864*Dd**2*Pk2*f**3*s**2 + 8184*Dd**2*Pk2*f**3*s - 1584*Dd**2*Pk2*f**3 + 108*Dd**2*Pkdd2*f**3*k1**2*s**2 - 54*Dd**2*Pkdd2*f**3*k1**2*s)/(1386*d**2*k3**4) - D1**2*Pk3*k1**2*st**4*(24*C*D1**2*Pk2*f**2*fd*r**2 - 288*C*D1**2*Pk2*f**2*fd*r*s + 80*C*D1**2*Pk2*f**2*fd*r - 492*C*D1**2*Pk2*f**2*fd*s**2 + 424*C*D1**2*Pk2*f**2*fd*s - 156*C*D1**2*Pk2*f**2*fd - 12*C*D1**2*Pk2*f**2*fdd*r**2 + 144*C*D1**2*Pk2*f**2*fdd*r*s - 40*C*D1**2*Pk2*f**2*fdd*r + 228*C*D1**2*Pk2*f**2*fdd*s**2 - 200*C*D1**2*Pk2*f**2*fdd*s + 72*C*D1**2*Pk2*f**2*fdd - 24*C*D1**2*Pk2*f*fd**2*r**2 + 288*C*D1**2*Pk2*f*fd**2*r*s - 80*C*D1**2*Pk2*f*fd**2*r + 456*C*D1**2*Pk2*f*fd**2*s**2 - 400*C*D1**2*Pk2*f*fd**2*s + 48*C*D1**2*Pk2*f*fd**2 + 32*C*D1*Dd*Pk2*f**3*r**2 - 384*C*D1*Dd*Pk2*f**3*r*s + 64*C*D1*Dd*Pk2*f**3*r - 656*C*D1*Dd*Pk2*f**3*s**2 + 520*C*D1*Dd*Pk2*f**3*s - 148*C*D1*Dd*Pk2*f**3 - 96*C*D1*Dd*Pk2*f**2*fd*r**2 + 1152*C*D1*Dd*Pk2*f**2*fd*r*s - 256*C*D1*Dd*Pk2*f**2*fd*r + 1824*C*D1*Dd*Pk2*f**2*fd*s**2 - 1544*C*D1*Dd*Pk2*f**2*fd*s + 280*C*D1*Dd*Pk2*f**2*fd - 16*C*D1*Ddd*Pk2*f**3*r**2 + 192*C*D1*Ddd*Pk2*f**3*r*s - 32*C*D1*Ddd*Pk2*f**3*r + 304*C*D1*Ddd*Pk2*f**3*s**2 - 248*C*D1*Ddd*Pk2*f**3*s + 68*C*D1*Ddd*Pk2*f**3 - 48*C*Dd**2*Pk2*f**3*r**2 + 576*C*Dd**2*Pk2*f**3*r*s - 96*C*Dd**2*Pk2*f**3*r + 912*C*Dd**2*Pk2*f**3*s**2 - 744*C*Dd**2*Pk2*f**3*s + 88*C*Dd**2*Pk2*f**3 + 24*D1**2*K*Pk2*b1*f*fd*r**2 - 288*D1**2*K*Pk2*b1*f*fd*r*s + 144*D1**2*K*Pk2*b1*f*fd*r - 540*D1**2*K*Pk2*b1*f*fd*s**2 + 540*D1**2*K*Pk2*b1*f*fd*s - 270*D1**2*K*Pk2*b1*f*fd - 12*D1**2*K*Pk2*b1*f*fdd*r**2 + 144*D1**2*K*Pk2*b1*f*fdd*r*s - 72*D1**2*K*Pk2*b1*f*fdd*r + 228*D1**2*K*Pk2*b1*f*fdd*s**2 - 228*D1**2*K*Pk2*b1*f*fdd*s + 114*D1**2*K*Pk2*b1*f*fdd - 12*D1**2*K*Pk2*b1*fd**2*r**2 + 144*D1**2*K*Pk2*b1*fd**2*r*s - 72*D1**2*K*Pk2*b1*fd**2*r + 228*D1**2*K*Pk2*b1*fd**2*s**2 - 228*D1**2*K*Pk2*b1*fd**2*s + 192*D1**2*Pk2*b1**2*f*fd*r*s + 96*D1**2*Pk2*b1**2*f*fd*r + 192*D1**2*Pk2*b1**2*f*fd*s**2 + 48*D1**2*Pk2*b1**2*f*fd*s - 96*D1**2*Pk2*b1**2*f*fd - 96*D1**2*Pk2*b1**2*f*fdd*r*s - 48*D1**2*Pk2*b1**2*f*fdd*r - 96*D1**2*Pk2*b1**2*f*fdd*s**2 - 24*D1**2*Pk2*b1**2*f*fdd*s + 48*D1**2*Pk2*b1**2*f*fdd - 96*D1**2*Pk2*b1**2*fd**2*r*s - 48*D1**2*Pk2*b1**2*fd**2*r - 96*D1**2*Pk2*b1**2*fd**2*s**2 - 24*D1**2*Pk2*b1**2*fd**2*s + 48*D1**2*Pk2*b1**2*fd**2 - 378*D1**2*Pk2*b1*f**2*fd*r**2 - 1368*D1**2*Pk2*b1*f**2*fd*r*s + 708*D1**2*Pk2*b1*f**2*fd*r - 594*D1**2*Pk2*b1*f**2*fd*s**2 + 972*D1**2*Pk2*b1*f**2*fd*s - 312*D1**2*Pk2*b1*f**2*fd + 486*D1**2*Pk2*b1*f**2*fdd*r**2 + 1152*D1**2*Pk2*b1*f**2*fdd*r*s - 732*D1**2*Pk2*b1*f**2*fdd*r + 342*D1**2*Pk2*b1*f**2*fdd*s**2 - 732*D1**2*Pk2*b1*f**2*fdd*s + 288*D1**2*Pk2*b1*f**2*fdd + 972*D1**2*Pk2*b1*f*fd**2*r**2 + 2304*D1**2*Pk2*b1*f*fd**2*r*s - 1464*D1**2*Pk2*b1*f*fd**2*r + 684*D1**2*Pk2*b1*f*fd**2*s**2 - 1464*D1**2*Pk2*b1*f*fd**2*s + 528*D1**2*Pk2*b1*f*fd**2 - 168*D1**2*Pk2*b1*f*fd*r**2 - 168*D1**2*Pk2*b1*f*fd*r*s + 84*D1**2*Pk2*b1*f*fd*r + 180*D1**2*Pk2*b1*f*fd*s**2 - 180*D1**2*Pk2*b1*f*fd*s + 90*D1**2*Pk2*b1*f*fd + 84*D1**2*Pk2*b1*f*fdd*r**2 + 168*D1**2*Pk2*b1*f*fdd*r*s - 84*D1**2*Pk2*b1*f*fdd*r + 36*D1**2*Pk2*b1*f*fdd*s**2 - 36*D1**2*Pk2*b1*f*fdd*s + 18*D1**2*Pk2*b1*f*fdd + 84*D1**2*Pk2*b1*fd**2*r**2 + 168*D1**2*Pk2*b1*fd**2*r*s - 84*D1**2*Pk2*b1*fd**2*r + 36*D1**2*Pk2*b1*fd**2*s**2 - 36*D1**2*Pk2*b1*fd**2*s - 288*D1**2*Pk2*b2*f*fd*r*s + 144*D1**2*Pk2*b2*f*fd*r - 288*D1**2*Pk2*b2*f*fd*s**2 + 288*D1**2*Pk2*b2*f*fd*s - 144*D1**2*Pk2*b2*f*fd + 144*D1**2*Pk2*b2*f*fdd*r*s - 72*D1**2*Pk2*b2*f*fdd*r + 144*D1**2*Pk2*b2*f*fdd*s**2 - 144*D1**2*Pk2*b2*f*fdd*s + 72*D1**2*Pk2*b2*f*fdd + 144*D1**2*Pk2*b2*fd**2*r*s - 72*D1**2*Pk2*b2*fd**2*r + 144*D1**2*Pk2*b2*fd**2*s**2 - 144*D1**2*Pk2*b2*fd**2*s - 24*D1**2*Pk2*bd1**2*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 3) - 144*D1**2*Pk2*bd2*f**2*r*s - 144*D1**2*Pk2*bd2*f**2*s**2 + 144*D1**2*Pk2*bd2*f**2*s + 288*D1**2*Pk2*bd2*f*fd*r*s - 72*D1**2*Pk2*bd2*f*fd*r + 288*D1**2*Pk2*bd2*f*fd*s**2 - 288*D1**2*Pk2*bd2*f*fd*s + 72*D1**2*Pk2*bd2*f*fd + 72*D1**2*Pk2*bdd2*f**2*r*s + 72*D1**2*Pk2*bdd2*f**2*s**2 - 72*D1**2*Pk2*bdd2*f**2*s + 432*D1**2*Pk2*f**3*fd*r**2 + 1080*D1**2*Pk2*f**3*fd*r*s - 702*D1**2*Pk2*f**3*fd*r + 360*D1**2*Pk2*f**3*fd*s**2 - 720*D1**2*Pk2*f**3*fd*s + 306*D1**2*Pk2*f**3*fd - 432*D1**2*Pk2*f**3*fdd*r**2 - 1080*D1**2*Pk2*f**3*fdd*r*s + 702*D1**2*Pk2*f**3*fdd*r - 360*D1**2*Pk2*f**3*fdd*s**2 + 720*D1**2*Pk2*f**3*fdd*s - 306*D1**2*Pk2*f**3*fdd - 1296*D1**2*Pk2*f**2*fd**2*r**2 - 3240*D1**2*Pk2*f**2*fd**2*r*s + 2106*D1**2*Pk2*f**2*fd**2*r - 1080*D1**2*Pk2*f**2*fd**2*s**2 + 2160*D1**2*Pk2*f**2*fd**2*s - 756*D1**2*Pk2*f**2*fd**2 - 96*D1**2*Pk2*f**2*fd*r**2 + 12*D1**2*Pk2*f**2*fd*r*s + 60*D1**2*Pk2*f**2*fd*r + 264*D1**2*Pk2*f**2*fd*s**2 - 180*D1**2*Pk2*f**2*fd*s + 56*D1**2*Pk2*f**2*fd + 48*D1**2*Pk2*f**2*fdd*r**2 + 12*D1**2*Pk2*f**2*fdd*r*s - 36*D1**2*Pk2*f**2*fdd*r - 96*D1**2*Pk2*f**2*fdd*s**2 + 60*D1**2*Pk2*f**2*fdd*s - 16*D1**2*Pk2*f**2*fdd - 24*D1**2*Pk2*f**2*gd2*r**2 + 288*D1**2*Pk2*f**2*gd2*r*s + 48*D1**2*Pk2*f**2*gd2*r + 540*D1**2*Pk2*f**2*gd2*s**2 - 288*D1**2*Pk2*f**2*gd2*s - 24*D1**2*Pk2*f**2*gd2 + 12*D1**2*Pk2*f**2*gdd2*r**2 - 144*D1**2*Pk2*f**2*gdd2*r*s - 24*D1**2*Pk2*f**2*gdd2*r - 228*D1**2*Pk2*f**2*gdd2*s**2 + 144*D1**2*Pk2*f**2*gdd2*s + 12*D1**2*Pk2*f**2*gdd2 + 96*D1**2*Pk2*f*fd**2*r**2 + 24*D1**2*Pk2*f*fd**2*r*s - 72*D1**2*Pk2*f*fd**2*r - 192*D1**2*Pk2*f*fd**2*s**2 + 120*D1**2*Pk2*f*fd**2*s + 4*D1**2*Pk2*f*fd**2 - 48*D1**2*Pk2*f*fd*g2*r**2 + 576*D1**2*Pk2*f*fd*g2*r*s - 288*D1**2*Pk2*f*fd*g2*r + 1080*D1**2*Pk2*f*fd*g2*s**2 - 1080*D1**2*Pk2*f*fd*g2*s + 540*D1**2*Pk2*f*fd*g2 + 48*D1**2*Pk2*f*fd*gd2*r**2 - 576*D1**2*Pk2*f*fd*gd2*r*s + 96*D1**2*Pk2*f*fd*gd2*r - 912*D1**2*Pk2*f*fd*gd2*s**2 + 744*D1**2*Pk2*f*fd*gd2*s - 144*D1**2*Pk2*f*fd*gd2 + 24*D1**2*Pk2*f*fdd*g2*r**2 - 288*D1**2*Pk2*f*fdd*g2*r*s + 144*D1**2*Pk2*f*fdd*g2*r - 456*D1**2*Pk2*f*fdd*g2*s**2 + 456*D1**2*Pk2*f*fdd*g2*s - 228*D1**2*Pk2*f*fdd*g2 + 24*D1**2*Pk2*fd**2*g2*r**2 - 288*D1**2*Pk2*fd**2*g2*r*s + 144*D1**2*Pk2*fd**2*g2*r - 456*D1**2*Pk2*fd**2*g2*s**2 + 456*D1**2*Pk2*fd**2*g2*s + 12*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 4*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 2*D1**2*Pkdd2*b1*f**2*fd*k1**2 - 6*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 2*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + D1**2*Pkdd2*b1*f**2*fdd*k1**2 - 12*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 4*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 12*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 6*D1**2*Pkdd2*f**3*fd*k1**2*s - 3*D1**2*Pkdd2*f**3*fd*k1**2 + D1**2*bdd1*f**2*(-6*Pk2*(K*r**2 - 12*K*r*s - 2*K*r - 19*K*s**2 + 12*K*s + K + 4*b1*(4*r*(s - 1) + 4*s**2 - 9*s + 4) - f*(27*r**2 + 64*r*s - 50*r + 19*s**2 - 44*s + 25) - 7*r**2 - 14*r*s + 14*r - 3*s**2 + 14*s - 7) + Pkdd2*f*k1**2*(-2*s**2 + 6*s - 3)) + 48*D1*Dd*K*Pk2*b1*f**2*r**2 - 576*D1*Dd*K*Pk2*b1*f**2*r*s + 96*D1*Dd*K*Pk2*b1*f**2*r - 1080*D1*Dd*K*Pk2*b1*f**2*s**2 + 828*D1*Dd*K*Pk2*b1*f**2*s - 246*D1*Dd*K*Pk2*b1*f**2 - 96*D1*Dd*K*Pk2*b1*f*fd*r**2 + 1152*D1*Dd*K*Pk2*b1*f*fd*r*s - 384*D1*Dd*K*Pk2*b1*f*fd*r + 1824*D1*Dd*K*Pk2*b1*f*fd*s**2 - 1656*D1*Dd*K*Pk2*b1*f*fd*s + 372*D1*Dd*K*Pk2*b1*f*fd + 384*D1*Dd*Pk2*b1**2*f**2*r*s - 96*D1*Dd*Pk2*b1**2*f**2*r + 384*D1*Dd*Pk2*b1**2*f**2*s**2 - 384*D1*Dd*Pk2*b1**2*f**2*s + 96*D1*Dd*Pk2*b1**2*f**2 - 768*D1*Dd*Pk2*b1**2*f*fd*r*s - 96*D1*Dd*Pk2*b1**2*f*fd*r - 768*D1*Dd*Pk2*b1**2*f*fd*s**2 + 288*D1*Dd*Pk2*b1**2*f*fd*s + 120*D1*Dd*Pk2*b1**2*f*fd - 504*D1*Dd*Pk2*b1*f**3*r**2 - 1824*D1*Dd*Pk2*b1*f**3*r*s + 960*D1*Dd*Pk2*b1*f**3*r - 792*D1*Dd*Pk2*b1*f**3*s**2 + 1308*D1*Dd*Pk2*b1*f**3*s - 450*D1*Dd*Pk2*b1*f**3 + 3888*D1*Dd*Pk2*b1*f**2*fd*r**2 + 9216*D1*Dd*Pk2*b1*f**2*fd*r*s - 6024*D1*Dd*Pk2*b1*f**2*fd*r + 2736*D1*Dd*Pk2*b1*f**2*fd*s**2 - 5916*D1*Dd*Pk2*b1*f**2*fd*s + 2196*D1*Dd*Pk2*b1*f**2*fd - 336*D1*Dd*Pk2*b1*f**2*r**2 - 336*D1*Dd*Pk2*b1*f**2*r*s + 420*D1*Dd*Pk2*b1*f**2*r + 360*D1*Dd*Pk2*b1*f**2*s**2 - 12*D1*Dd*Pk2*b1*f**2*s - 78*D1*Dd*Pk2*b1*f**2 + 672*D1*Dd*Pk2*b1*f*fd*r**2 + 1344*D1*Dd*Pk2*b1*f*fd*r*s - 840*D1*Dd*Pk2*b1*f*fd*r + 288*D1*Dd*Pk2*b1*f*fd*s**2 - 552*D1*Dd*Pk2*b1*f*fd*s + 204*D1*Dd*Pk2*b1*f*fd - 576*D1*Dd*Pk2*b2*f**2*r*s + 144*D1*Dd*Pk2*b2*f**2*r - 576*D1*Dd*Pk2*b2*f**2*s**2 + 576*D1*Dd*Pk2*b2*f**2*s - 144*D1*Dd*Pk2*b2*f**2 + 1152*D1*Dd*Pk2*b2*f*fd*r*s - 432*D1*Dd*Pk2*b2*f*fd*r + 1152*D1*Dd*Pk2*b2*f*fd*s**2 - 1152*D1*Dd*Pk2*b2*f*fd*s + 288*D1*Dd*Pk2*b2*f*fd + 576*D1*Dd*Pk2*bd2*f**2*r*s - 72*D1*Dd*Pk2*bd2*f**2*r + 576*D1*Dd*Pk2*bd2*f**2*s**2 - 576*D1*Dd*Pk2*bd2*f**2*s + 72*D1*Dd*Pk2*bd2*f**2 + 432*D1*Dd*Pk2*f**4*r**2 + 1080*D1*Dd*Pk2*f**4*r*s - 702*D1*Dd*Pk2*f**4*r + 360*D1*Dd*Pk2*f**4*s**2 - 720*D1*Dd*Pk2*f**4*s + 306*D1*Dd*Pk2*f**4 - 3456*D1*Dd*Pk2*f**3*fd*r**2 - 8640*D1*Dd*Pk2*f**3*fd*r*s + 5616*D1*Dd*Pk2*f**3*fd*r - 2880*D1*Dd*Pk2*f**3*fd*s**2 + 5760*D1*Dd*Pk2*f**3*fd*s - 2124*D1*Dd*Pk2*f**3*fd - 128*D1*Dd*Pk2*f**3*r**2 + 16*D1*Dd*Pk2*f**3*r*s + 124*D1*Dd*Pk2*f**3*r + 352*D1*Dd*Pk2*f**3*s**2 - 184*D1*Dd*Pk2*f**3*s + 24*D1*Dd*Pk2*f**3 + 384*D1*Dd*Pk2*f**2*fd*r**2 + 96*D1*Dd*Pk2*f**2*fd*r*s - 348*D1*Dd*Pk2*f**2*fd*r - 768*D1*Dd*Pk2*f**2*fd*s**2 + 408*D1*Dd*Pk2*f**2*fd*s + 12*D1*Dd*Pk2*f**2*fd - 96*D1*Dd*Pk2*f**2*g2*r**2 + 1152*D1*Dd*Pk2*f**2*g2*r*s - 192*D1*Dd*Pk2*f**2*g2*r + 2160*D1*Dd*Pk2*f**2*g2*s**2 - 1656*D1*Dd*Pk2*f**2*g2*s + 492*D1*Dd*Pk2*f**2*g2 + 96*D1*Dd*Pk2*f**2*gd2*r**2 - 1152*D1*Dd*Pk2*f**2*gd2*r*s - 1824*D1*Dd*Pk2*f**2*gd2*s**2 + 1320*D1*Dd*Pk2*f**2*gd2*s - 96*D1*Dd*Pk2*f**2*gd2 + 192*D1*Dd*Pk2*f*fd*g2*r**2 - 2304*D1*Dd*Pk2*f*fd*g2*r*s + 768*D1*Dd*Pk2*f*fd*g2*r - 3648*D1*Dd*Pk2*f*fd*g2*s**2 + 3312*D1*Dd*Pk2*f*fd*g2*s - 744*D1*Dd*Pk2*f*fd*g2 + 16*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 - 8*D1*Dd*Pkdd2*b1*f**3*k1**2*s + 4*D1*Dd*Pkdd2*b1*f**3*k1**2 - 48*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 + 4*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 2*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 12*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 6*D1*Dd*Pkdd2*f**4*k1**2*s - 3*D1*Dd*Pkdd2*f**4*k1**2 - 24*D1*Ddd*K*Pk2*b1*f**2*r**2 + 288*D1*Ddd*K*Pk2*b1*f**2*r*s - 48*D1*Ddd*K*Pk2*b1*f**2*r + 456*D1*Ddd*K*Pk2*b1*f**2*s**2 - 372*D1*Ddd*K*Pk2*b1*f**2*s + 102*D1*Ddd*K*Pk2*b1*f**2 - 192*D1*Ddd*Pk2*b1**2*f**2*r*s + 48*D1*Ddd*Pk2*b1**2*f**2*r - 192*D1*Ddd*Pk2*b1**2*f**2*s**2 + 192*D1*Ddd*Pk2*b1**2*f**2*s - 48*D1*Ddd*Pk2*b1**2*f**2 + 648*D1*Ddd*Pk2*b1*f**3*r**2 + 1536*D1*Ddd*Pk2*b1*f**3*r*s - 1032*D1*Ddd*Pk2*b1*f**3*r + 456*D1*Ddd*Pk2*b1*f**3*s**2 - 996*D1*Ddd*Pk2*b1*f**3*s + 438*D1*Ddd*Pk2*b1*f**3 + 168*D1*Ddd*Pk2*b1*f**2*r**2 + 336*D1*Ddd*Pk2*b1*f**2*r*s - 252*D1*Ddd*Pk2*b1*f**2*r + 72*D1*Ddd*Pk2*b1*f**2*s**2 - 204*D1*Ddd*Pk2*b1*f**2*s + 102*D1*Ddd*Pk2*b1*f**2 + 288*D1*Ddd*Pk2*b2*f**2*r*s - 72*D1*Ddd*Pk2*b2*f**2*r + 288*D1*Ddd*Pk2*b2*f**2*s**2 - 288*D1*Ddd*Pk2*b2*f**2*s + 72*D1*Ddd*Pk2*b2*f**2 - 432*D1*Ddd*Pk2*f**4*r**2 - 1080*D1*Ddd*Pk2*f**4*r*s + 702*D1*Ddd*Pk2*f**4*r - 360*D1*Ddd*Pk2*f**4*s**2 + 720*D1*Ddd*Pk2*f**4*s - 306*D1*Ddd*Pk2*f**4 + 64*D1*Ddd*Pk2*f**3*r**2 + 16*D1*Ddd*Pk2*f**3*r*s - 68*D1*Ddd*Pk2*f**3*r - 128*D1*Ddd*Pk2*f**3*s**2 + 56*D1*Ddd*Pk2*f**3*s + 48*D1*Ddd*Pk2*f**2*g2*r**2 - 576*D1*Ddd*Pk2*f**2*g2*r*s + 96*D1*Ddd*Pk2*f**2*g2*r - 912*D1*Ddd*Pk2*f**2*g2*s**2 + 744*D1*Ddd*Pk2*f**2*g2*s - 204*D1*Ddd*Pk2*f**2*g2 - 8*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 + 4*D1*Ddd*Pkdd2*b1*f**3*k1**2*s - 2*D1*Ddd*Pkdd2*b1*f**3*k1**2 - 2*D1*bd1*f*(D1*(6*Pk2*fd*(K*(2*r**2 - 24*r*s + 4*r - 38*s**2 + 31*s - 6) + 2*b1*(4*s - 1)*(4*r + 4*s - 3) - 14*r**2 - 28*r*s + 21*r - 6*s**2 + 17*s - 7) + f**2*(3*Pk2*(21*r**2 + r*(76*s - 42) + 33*s**2 - 56*s + 23) + Pkdd2*k1**2*(-2*s**2 + 6*s - 3)) - f*(3*Pk2*(2*K*r**2 - 24*K*r*s - 4*K*r - 45*K*s**2 + 24*K*s + 2*K + 8*b1*(4*r*(s - 1) + 4*s**2 - 9*s + 4) + 2*fd*(81*r**2 + 8*r*(24*s - 17) + 57*s**2 - 127*s + 47) - 14*r**2 - 14*r*s + 28*r + 15*s**2 + 14*s - 14) + 2*Pkdd2*fd*k1**2*s*(4 - 3*s))) - Dd*f*(6*Pk2*(-4*K*r**2 + 48*K*r*s + 76*K*s**2 - 55*K*s + 4*K - 2*b1*(4*r*(8*s - 5) + 32*s**2 - 52*s + 17) + f*(108*r**2 + 256*r*s - 186*r + 76*s**2 - 171*s + 72) + 28*r**2 + 56*r*s - 49*r + 12*s**2 - 45*s + 21) + Pkdd2*f*k1**2*(-8*s**2 + 14*s - 3))) - 72*Dd**2*K*Pk2*b1*f**2*r**2 + 864*Dd**2*K*Pk2*b1*f**2*r*s - 144*Dd**2*K*Pk2*b1*f**2*r + 1368*Dd**2*K*Pk2*b1*f**2*s**2 - 1116*Dd**2*K*Pk2*b1*f**2*s + 132*Dd**2*K*Pk2*b1*f**2 - 576*Dd**2*Pk2*b1**2*f**2*r*s + 144*Dd**2*Pk2*b1**2*f**2*r - 576*Dd**2*Pk2*b1**2*f**2*s**2 + 576*Dd**2*Pk2*b1**2*f**2*s - 96*Dd**2*Pk2*b1**2*f**2 + 1944*Dd**2*Pk2*b1*f**3*r**2 + 4608*Dd**2*Pk2*b1*f**3*r*s - 3096*Dd**2*Pk2*b1*f**3*r + 1368*Dd**2*Pk2*b1*f**3*s**2 - 2988*Dd**2*Pk2*b1*f**3*s + 1092*Dd**2*Pk2*b1*f**3 + 504*Dd**2*Pk2*b1*f**2*r**2 + 1008*Dd**2*Pk2*b1*f**2*r*s - 756*Dd**2*Pk2*b1*f**2*r + 216*Dd**2*Pk2*b1*f**2*s**2 - 612*Dd**2*Pk2*b1*f**2*s + 252*Dd**2*Pk2*b1*f**2 + 864*Dd**2*Pk2*b2*f**2*r*s - 216*Dd**2*Pk2*b2*f**2*r + 864*Dd**2*Pk2*b2*f**2*s**2 - 864*Dd**2*Pk2*b2*f**2*s + 144*Dd**2*Pk2*b2*f**2 - 1296*Dd**2*Pk2*f**4*r**2 - 3240*Dd**2*Pk2*f**4*r*s + 2106*Dd**2*Pk2*f**4*r - 1080*Dd**2*Pk2*f**4*s**2 + 2160*Dd**2*Pk2*f**4*s - 756*Dd**2*Pk2*f**4 + 192*Dd**2*Pk2*f**3*r**2 + 48*Dd**2*Pk2*f**3*r*s - 204*Dd**2*Pk2*f**3*r - 384*Dd**2*Pk2*f**3*s**2 + 168*Dd**2*Pk2*f**3*s + 40*Dd**2*Pk2*f**3 + 144*Dd**2*Pk2*f**2*g2*r**2 - 1728*Dd**2*Pk2*f**2*g2*r*s + 288*Dd**2*Pk2*f**2*g2*r - 2736*Dd**2*Pk2*f**2*g2*s**2 + 2232*Dd**2*Pk2*f**2*g2*s - 264*Dd**2*Pk2*f**2*g2 - 24*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 + 12*Dd**2*Pkdd2*b1*f**3*k1**2*s)/(210*d**2*k3**4) + D1**2*Pk3*k1**2*st**2*(-6*D1**2*bd1**2*f*(14*Pk2*(K*(-r**2 + 3*r + 3*s**2 + s - 2) + f*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + 7*r**2 + 14*r*s - 15*r + 5*s**2 - 14*s + 8) + 3*Pkdd2*f*k1**2*s*(s - 1)) - 3*D1*bd1*(D1*(2*Pk2*f**2*(2*C*(6*r**2 + 4*r*(7*s - 6) + 3*s**2 + 2*s - 1) + 14*K*r**2 + 224*K*r*s - 28*K*r + 217*K*s**2 - 224*K*s + 14*K - 21*fd*(24*r**2 - 26*r - 24*s**2 + 18*s + 5) - 27*r**2 - 133*r*s + 64*r - 68*s**2 + 61*s + 1) - 2*Pk2*f*(fd*(12*C*(2*r**2 - 3*r - 6*s**2 + 2*s + 2) + 14*K*(10*r**2 + 64*r*s - 26*r + 58*s**2 - 61*s + 16) - 96*r**2 - 308*r*s + 185*r - 192*s**2 + 256*s - 95) + 14*g2*(2*r**2 + 4*r*(5*s - 2) + 9*s**2 + 6*s - 3) + 28*gd2*(-r**2 + 3*r + 3*s**2 + s - 2)) + 56*Pk2*fd*g2*(r**2 - s*(3*s - 3)) - 3*f**3*(14*Pk2*(-4*r**2 + 5*r + s*(4*s - 5)) + Pkdd2*k1**2*(2*s**2 - 6*s + 3))) - 2*Dd*Pk2*f*(21*f**2*(32*r**2 - 36*r - 32*s**2 + 28*s + 5) + f*(12*C*(4*r**2 - 10*r - 12*s**2 - s + 5) + 14*K*(20*r**2 + 128*r*s - 46*r + 116*s**2 - 125*s + 26) - 192*r**2 - 616*r*s + 413*r - 384*s**2 + 582*s - 203) - 28*g2*(4*r**2 - 10*r - 12*s**2 - s + 5))) - 2*Pk2*(300*C*D1**2*f**2*fd*r**2 + 2112*C*D1**2*f**2*fd*r*s - 904*C*D1**2*f**2*fd*r + 1674*C*D1**2*f**2*fd*s**2 - 1820*C*D1**2*f**2*fd*s + 658*C*D1**2*f**2*fd - 366*C*D1**2*f**2*fdd*r**2 - 1920*C*D1**2*f**2*fdd*r*s + 884*C*D1**2*f**2*fdd*r - 1566*C*D1**2*f**2*fdd*s**2 + 1684*C*D1**2*f**2*fdd*s - 644*C*D1**2*f**2*fdd - 732*C*D1**2*f*fd**2*r**2 - 3840*C*D1**2*f*fd**2*r*s + 1768*C*D1**2*f*fd**2*r - 3132*C*D1**2*f*fd**2*s**2 + 3368*C*D1**2*f*fd**2*s - 640*C*D1**2*f*fd**2 + 400*C*D1*Dd*f**3*r**2 + 2816*C*D1*Dd*f**3*r*s - 1104*C*D1*Dd*f**3*r + 2232*C*D1*Dd*f**3*s**2 - 2524*C*D1*Dd*f**3*s + 758*C*D1*Dd*f**3 - 2928*C*D1*Dd*f**2*fd*r**2 - 15360*C*D1*Dd*f**2*fd*r*s + 6920*C*D1*Dd*f**2*fd*r - 12528*C*D1*Dd*f**2*fd*s**2 + 13708*C*D1*Dd*f**2*fd*s - 3452*C*D1*Dd*f**2*fd - 488*C*D1*Ddd*f**3*r**2 - 2560*C*D1*Ddd*f**3*r*s + 1128*C*D1*Ddd*f**3*r - 2088*C*D1*Ddd*f**3*s**2 + 2324*C*D1*Ddd*f**3*s - 766*C*D1*Ddd*f**3 - 1464*C*Dd**2*f**3*r**2 - 7680*C*Dd**2*f**3*r*s + 3384*C*Dd**2*f**3*r - 6264*C*Dd**2*f**3*s**2 + 6972*C*Dd**2*f**3*s - 1524*C*Dd**2*f**3 + 126*D1**2*b2*f*fd*r**2 + 924*D1**2*b2*f*fd*r*s - 462*D1**2*b2*f*fd*r + 798*D1**2*b2*f*fd*s**2 - 798*D1**2*b2*f*fd*s + 399*D1**2*b2*f*fd - 210*D1**2*b2*f*fdd*r**2 - 924*D1**2*b2*f*fdd*r*s + 462*D1**2*b2*f*fdd*r - 714*D1**2*b2*f*fdd*s**2 + 714*D1**2*b2*f*fdd*s - 357*D1**2*b2*f*fdd - 210*D1**2*b2*fd**2*r**2 - 924*D1**2*b2*fd**2*r*s + 462*D1**2*b2*fd**2*r - 714*D1**2*b2*fd**2*s**2 + 714*D1**2*b2*fd**2*s - 3*D1**2*bdd1*f*(21*f**2*(4*r**2 - 5*r + s*(5 - 4*s)) + f*(6*C*(r**2 - 4*r - 3*s**2 - 2*s + 1) + 7*K*(5*r**2 + 32*r*s - 10*r + 29*s**2 - 32*s + 5) - 24*r**2 - 77*r*s + 60*r - 48*s**2 + 83*s - 24) - 14*g2*(r**2 - 4*r - 3*s**2 - 2*s + 1)) - 105*D1**2*bdd2*f**2*r**2 - 462*D1**2*bdd2*f**2*r*s + 210*D1**2*bdd2*f**2*r - 357*D1**2*bdd2*f**2*s**2 + 462*D1**2*bdd2*f**2*s - 105*D1**2*bdd2*f**2 - 69*D1**2*f**2*fd*r**2 - 1185*D1**2*f**2*fd*r*s + 441*D1**2*f**2*fd*r - 999*D1**2*f**2*fd*s**2 + 1061*D1**2*f**2*fd*s - 356*D1**2*f**2*fd + 183*D1**2*f**2*fdd*r**2 + 1119*D1**2*f**2*fdd*r*s - 495*D1**2*f**2*fdd*r + 945*D1**2*f**2*fdd*s**2 - 1003*D1**2*f**2*fdd*s + 376*D1**2*f**2*fdd - 84*D1**2*f**2*gd2*r**2 - 1344*D1**2*f**2*gd2*r*s + 168*D1**2*f**2*gd2*r - 1302*D1**2*f**2*gd2*s**2 + 1344*D1**2*f**2*gd2*s - 84*D1**2*f**2*gd2 + 210*D1**2*f**2*gdd2*r**2 + 1344*D1**2*f**2*gdd2*r*s - 420*D1**2*f**2*gdd2*r + 1218*D1**2*f**2*gdd2*s**2 - 1344*D1**2*f**2*gdd2*s + 210*D1**2*f**2*gdd2 + 366*D1**2*f*fd**2*r**2 + 2238*D1**2*f*fd**2*r*s - 990*D1**2*f*fd**2*r + 1890*D1**2*f*fd**2*s**2 - 2006*D1**2*f*fd**2*s + 373*D1**2*f*fd**2 - 168*D1**2*f*fd*g2*r**2 - 2688*D1**2*f*fd*g2*r*s + 1344*D1**2*f*fd*g2*r - 2604*D1**2*f*fd*g2*s**2 + 2604*D1**2*f*fd*g2*s - 1302*D1**2*f*fd*g2 + 840*D1**2*f*fd*gd2*r**2 + 5376*D1**2*f*fd*gd2*r*s - 2184*D1**2*f*fd*gd2*r + 4872*D1**2*f*fd*gd2*s**2 - 5124*D1**2*f*fd*gd2*s + 1344*D1**2*f*fd*gd2 + 420*D1**2*f*fdd*g2*r**2 + 2688*D1**2*f*fdd*g2*r*s - 1344*D1**2*f*fdd*g2*r + 2436*D1**2*f*fdd*g2*s**2 - 2436*D1**2*f*fdd*g2*s + 1218*D1**2*f*fdd*g2 + 420*D1**2*fd**2*g2*r**2 + 2688*D1**2*fd**2*g2*r*s - 1344*D1**2*fd**2*g2*r + 2436*D1**2*fd**2*g2*s**2 - 2436*D1**2*fd**2*g2*s + 252*D1*Dd*b2*f**2*r**2 + 1848*D1*Dd*b2*f**2*r*s - 714*D1*Dd*b2*f**2*r + 1596*D1*Dd*b2*f**2*s**2 - 1722*D1*Dd*b2*f**2*s + 525*D1*Dd*b2*f**2 - 1680*D1*Dd*b2*f*fd*r**2 - 7392*D1*Dd*b2*f*fd*r*s + 3612*D1*Dd*b2*f*fd*r - 5712*D1*Dd*b2*f*fd*s**2 + 6132*D1*Dd*b2*f*fd*s - 1638*D1*Dd*b2*f*fd - 92*D1*Dd*f**3*r**2 - 1580*D1*Dd*f**3*r*s + 487*D1*Dd*f**3*r - 1332*D1*Dd*f**3*s**2 + 1456*D1*Dd*f**3*s - 379*D1*Dd*f**3 + 1464*D1*Dd*f**2*fd*r**2 + 8952*D1*Dd*f**2*fd*r*s - 3831*D1*Dd*f**2*fd*r + 7560*D1*Dd*f**2*fd*s**2 - 8140*D1*Dd*f**2*fd*s + 1993*D1*Dd*f**2*fd - 336*D1*Dd*f**2*g2*r**2 - 5376*D1*Dd*f**2*g2*r*s + 1680*D1*Dd*f**2*g2*r - 5208*D1*Dd*f**2*g2*s**2 + 5292*D1*Dd*f**2*g2*s - 1470*D1*Dd*f**2*g2 + 1680*D1*Dd*f**2*gd2*r**2 + 10752*D1*Dd*f**2*gd2*r*s - 3864*D1*Dd*f**2*gd2*r + 9744*D1*Dd*f**2*gd2*s**2 - 10500*D1*Dd*f**2*gd2*s + 2184*D1*Dd*f**2*gd2 + 3360*D1*Dd*f*fd*g2*r**2 + 21504*D1*Dd*f*fd*g2*r*s - 9744*D1*Dd*f*fd*g2*r + 19488*D1*Dd*f*fd*g2*s**2 - 19992*D1*Dd*f*fd*g2*s + 5124*D1*Dd*f*fd*g2 - 420*D1*Ddd*b2*f**2*r**2 - 1848*D1*Ddd*b2*f**2*r*s + 882*D1*Ddd*b2*f**2*r - 1428*D1*Ddd*b2*f**2*s**2 + 1638*D1*Ddd*b2*f**2*s - 567*D1*Ddd*b2*f**2 + 244*D1*Ddd*f**3*r**2 + 1492*D1*Ddd*f**3*r*s - 617*D1*Ddd*f**3*r + 1260*D1*Ddd*f**3*s**2 - 1376*D1*Ddd*f**3*s + 437*D1*Ddd*f**3 + 840*D1*Ddd*f**2*g2*r**2 + 5376*D1*Ddd*f**2*g2*r*s - 2184*D1*Ddd*f**2*g2*r + 4872*D1*Ddd*f**2*g2*s**2 - 5124*D1*Ddd*f**2*g2*s + 1638*D1*Ddd*f**2*g2 + 21*D1*bd2*f*(D1*(f*(3*r**2 + 22*r*s - 6*r + 19*s**2 - 22*s + 3) - 2*fd*(10*r**2 + 44*r*s - 21*r + 34*s**2 - 39*s + 11)) - 2*Dd*f*(20*r**2 + r*(88*s - 41) + 68*s**2 - 83*s + 21)) - 1260*Dd**2*b2*f**2*r**2 - 5544*Dd**2*b2*f**2*r*s + 2646*Dd**2*b2*f**2*r - 4284*Dd**2*b2*f**2*s**2 + 4914*Dd**2*b2*f**2*s - 1134*Dd**2*b2*f**2 + 732*Dd**2*f**3*r**2 + 4476*Dd**2*f**3*r*s - 1851*Dd**2*f**3*r + 3780*Dd**2*f**3*s**2 - 4128*Dd**2*f**3*s + 868*Dd**2*f**3 + 2520*Dd**2*f**2*g2*r**2 + 16128*Dd**2*f**2*g2*r*s - 6552*Dd**2*f**2*g2*r + 14616*Dd**2*f**2*g2*s**2 - 15372*Dd**2*f**2*g2*s + 3108*Dd**2*f**2*g2) + 3*b1**2*(-2*D1**2*(14*Pk2*fd**2*(22*r**2 + r*(32*s - 25) + 10*s**2 - 13*s + 3) - 7*Pk2*fd*(-K*(2*r**2 + 20*r*s - 12*r + 9*s**2 - 24*s + 12) + 2*f*(18*r**2 + r*(32*s - 19) + 14*s**2 - 11*s + 7) + 14*r**2 + 28*r*s - 6*r + 5*s**2 - 12*s + 6) + 7*Pk2*fdd*(-K*(r**2 + 4*r - 3*s**2 + 8*s - 4) + f*(44*r**2 + r*(64*s - 50) + 20*s**2 - 26*s + 22) + 7*r**2 + 14*r*s + 2*r + 5*s**2 + 4*s - 2) - 6*Pkdd2*f*fd*k1**2*s**2 + 3*Pkdd2*f*fdd*k1**2*s**2 + 3*Pkdd2*fd**2*k1**2*s**2) + D1*(2*Dd*(14*Pk2*fd*(K*(4*r**2 + 6*r - 12*s**2 + 19*s - 8) - 28*r**2 + r*(17 - 56*s) - 20*s**2 + 11*s + 4) + f**2*(14*Pk2*(36*r**2 + r*(64*s - 52) + 28*s**2 - 46*s + 25) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - f*(7*Pk2*(K*(8*r**2 + 80*r*s - 28*r + 36*s**2 - 58*s + 13) + 2*fd*(176*r**2 + 4*r*(64*s - 55) + 80*s**2 - 136*s + 63) - 56*r**2 - 112*r*s + 84*r - 20*s**2 + 66*s - 33) + 6*Pkdd2*fd*k1**2*s*(4*s - 1))) - Ddd*f*(14*Pk2*(K*(-4*r**2 + 4*r + 12*s**2 - 6*s + 1) + 2*f*(44*r**2 + r*(64*s - 60) + 20*s**2 - 42*s + 27) + 28*r**2 + 56*r*s - 42*r + 20*s**2 - 38*s + 19) + 3*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(14*Pk2*(K*(-6*r**2 + 6*r + 18*s**2 - 9*s - 1) + 6*f*(22*r**2 + r*(32*s - 30) + 10*s**2 - 21*s + 9) + 42*r**2 + 84*r*s - 63*r + 30*s**2 - 57*s + 21) + 9*Pkdd2*f*k1**2*s*(2*s - 1))) + 3*b1*(-48*C*D1**2*Pk2*f*fd*r**2 - 224*C*D1**2*Pk2*f*fd*r*s + 64*C*D1**2*Pk2*f*fd*r - 24*C*D1**2*Pk2*f*fd*s**2 + 144*C*D1**2*Pk2*f*fd*s - 40*C*D1**2*Pk2*f*fd + 24*C*D1**2*Pk2*f*fdd*r**2 + 24*C*D1**2*Pk2*f*fdd*r - 72*C*D1**2*Pk2*f*fdd*s**2 + 96*C*D1**2*Pk2*f*fdd*s - 36*C*D1**2*Pk2*f*fdd + 24*C*D1**2*Pk2*fd**2*r**2 + 24*C*D1**2*Pk2*fd**2*r - 72*C*D1**2*Pk2*fd**2*s**2 + 96*C*D1**2*Pk2*fd**2*s - 48*C*D1**2*Pk2*fd**2 - 96*C*D1*Dd*Pk2*f**2*r**2 - 448*C*D1*Dd*Pk2*f**2*r*s + 208*C*D1*Dd*Pk2*f**2*r - 48*C*D1*Dd*Pk2*f**2*s**2 + 248*C*D1*Dd*Pk2*f**2*s - 60*C*D1*Dd*Pk2*f**2 + 192*C*D1*Dd*Pk2*f*fd*r**2 - 576*C*D1*Dd*Pk2*f*fd*s**2 + 528*C*D1*Dd*Pk2*f*fd*s - 144*C*D1*Dd*Pk2*f*fd + 48*C*D1*Ddd*Pk2*f**2*r**2 - 48*C*D1*Ddd*Pk2*f**2*r - 144*C*D1*Ddd*Pk2*f**2*s**2 + 72*C*D1*Ddd*Pk2*f**2*s - 12*C*D1*Ddd*Pk2*f**2 + 144*C*Dd**2*Pk2*f**2*r**2 - 144*C*Dd**2*Pk2*f**2*r - 432*C*Dd**2*Pk2*f**2*s**2 + 216*C*Dd**2*Pk2*f**2*s + 24*C*Dd**2*Pk2*f**2 - 56*D1**2*K*Pk2*f*fd*r**2 - 896*D1**2*K*Pk2*f*fd*r*s + 448*D1**2*K*Pk2*f*fd*r - 868*D1**2*K*Pk2*f*fd*s**2 + 868*D1**2*K*Pk2*f*fd*s - 434*D1**2*K*Pk2*f*fd + 140*D1**2*K*Pk2*f*fdd*r**2 + 896*D1**2*K*Pk2*f*fdd*r*s - 448*D1**2*K*Pk2*f*fdd*r + 812*D1**2*K*Pk2*f*fdd*s**2 - 812*D1**2*K*Pk2*f*fdd*s + 406*D1**2*K*Pk2*f*fdd + 140*D1**2*K*Pk2*fd**2*r**2 + 896*D1**2*K*Pk2*fd**2*r*s - 448*D1**2*K*Pk2*fd**2*r + 812*D1**2*K*Pk2*fd**2*s**2 - 812*D1**2*K*Pk2*fd**2*s - 504*D1**2*Pk2*f**2*fd*r**2 + 462*D1**2*Pk2*f**2*fd*r + 504*D1**2*Pk2*f**2*fd*s**2 - 126*D1**2*Pk2*f**2*fd*s - 168*D1**2*Pk2*f**2*fd + 504*D1**2*Pk2*f**2*fdd*r**2 - 462*D1**2*Pk2*f**2*fdd*r - 504*D1**2*Pk2*f**2*fdd*s**2 + 126*D1**2*Pk2*f**2*fdd*s + 168*D1**2*Pk2*f**2*fdd + 1008*D1**2*Pk2*f*fd**2*r**2 - 924*D1**2*Pk2*f*fd**2*r - 1008*D1**2*Pk2*f*fd**2*s**2 + 252*D1**2*Pk2*f*fd**2*s + 126*D1**2*Pk2*f*fd**2 + 108*D1**2*Pk2*f*fd*r**2 + 532*D1**2*Pk2*f*fd*r*s - 246*D1**2*Pk2*f*fd*r + 272*D1**2*Pk2*f*fd*s**2 - 416*D1**2*Pk2*f*fd*s + 192*D1**2*Pk2*f*fd - 96*D1**2*Pk2*f*fdd*r**2 - 308*D1**2*Pk2*f*fdd*r*s + 130*D1**2*Pk2*f*fdd*r - 192*D1**2*Pk2*f*fdd*s**2 + 180*D1**2*Pk2*f*fdd*s - 96*D1**2*Pk2*f*fdd + 56*D1**2*Pk2*f*gd2*r**2 + 560*D1**2*Pk2*f*gd2*r*s - 112*D1**2*Pk2*f*gd2*r + 252*D1**2*Pk2*f*gd2*s**2 - 560*D1**2*Pk2*f*gd2*s + 56*D1**2*Pk2*f*gd2 - 28*D1**2*Pk2*f*gdd2*r**2 + 56*D1**2*Pk2*f*gdd2*r + 84*D1**2*Pk2*f*gdd2*s**2 - 28*D1**2*Pk2*f*gdd2 - 96*D1**2*Pk2*fd**2*r**2 - 308*D1**2*Pk2*fd**2*r*s + 130*D1**2*Pk2*fd**2*r - 192*D1**2*Pk2*fd**2*s**2 + 180*D1**2*Pk2*fd**2*s + 36*D1**2*Pk2*fd**2 + 56*D1**2*Pk2*fd*g2*r**2 + 560*D1**2*Pk2*fd*g2*r*s - 336*D1**2*Pk2*fd*g2*r + 252*D1**2*Pk2*fd*g2*s**2 - 672*D1**2*Pk2*fd*g2*s + 336*D1**2*Pk2*fd*g2 - 56*D1**2*Pk2*fd*gd2*r**2 - 56*D1**2*Pk2*fd*gd2*r + 168*D1**2*Pk2*fd*gd2*s**2 - 224*D1**2*Pk2*fd*gd2*s + 112*D1**2*Pk2*fd*gd2 - 28*D1**2*Pk2*fdd*g2*r**2 - 112*D1**2*Pk2*fdd*g2*r + 84*D1**2*Pk2*fdd*g2*s**2 - 224*D1**2*Pk2*fdd*g2*s + 112*D1**2*Pk2*fdd*g2 + 18*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 6*D1**2*Pkdd2*f**2*fd*k1**2*s - 3*D1**2*Pkdd2*f**2*fd*k1**2 - D1**2*bdd1*f*(28*Pk2*(K*(-r**2 + 3*r + 3*s**2 + s - 1) + f*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + 7*r**2 + 14*r*s - 15*r + 5*s**2 - 14*s + 7) + 3*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) - 112*D1*Dd*K*Pk2*f**2*r**2 - 1792*D1*Dd*K*Pk2*f**2*r*s + 560*D1*Dd*K*Pk2*f**2*r - 1736*D1*Dd*K*Pk2*f**2*s**2 + 1764*D1*Dd*K*Pk2*f**2*s - 490*D1*Dd*K*Pk2*f**2 + 1120*D1*Dd*K*Pk2*f*fd*r**2 + 7168*D1*Dd*K*Pk2*f*fd*r*s - 3248*D1*Dd*K*Pk2*f*fd*r + 6496*D1*Dd*K*Pk2*f*fd*s**2 - 6664*D1*Dd*K*Pk2*f*fd*s + 1708*D1*Dd*K*Pk2*f*fd - 672*D1*Dd*Pk2*f**3*r**2 + 672*D1*Dd*Pk2*f**3*r + 672*D1*Dd*Pk2*f**3*s**2 - 336*D1*Dd*Pk2*f**3*s - 168*D1*Dd*Pk2*f**3 + 4032*D1*Dd*Pk2*f**2*fd*r**2 - 3864*D1*Dd*Pk2*f**2*fd*r - 4032*D1*Dd*Pk2*f**2*fd*s**2 + 1512*D1*Dd*Pk2*f**2*fd*s + 798*D1*Dd*Pk2*f**2*fd + 216*D1*Dd*Pk2*f**2*r**2 + 1064*D1*Dd*Pk2*f**2*r*s - 482*D1*Dd*Pk2*f**2*r + 544*D1*Dd*Pk2*f**2*s**2 - 804*D1*Dd*Pk2*f**2*s + 244*D1*Dd*Pk2*f**2 - 768*D1*Dd*Pk2*f*fd*r**2 - 2464*D1*Dd*Pk2*f*fd*r*s + 1212*D1*Dd*Pk2*f*fd*r - 1536*D1*Dd*Pk2*f*fd*s**2 + 1720*D1*Dd*Pk2*f*fd*s - 440*D1*Dd*Pk2*f*fd + 224*D1*Dd*Pk2*f*g2*r**2 + 2240*D1*Dd*Pk2*f*g2*r*s - 784*D1*Dd*Pk2*f*g2*r + 1008*D1*Dd*Pk2*f*g2*s**2 - 1624*D1*Dd*Pk2*f*g2*s + 364*D1*Dd*Pk2*f*g2 - 224*D1*Dd*Pk2*f*gd2*r**2 + 336*D1*Dd*Pk2*f*gd2*r + 672*D1*Dd*Pk2*f*gd2*s**2 - 168*D1*Dd*Pk2*f*gd2*s - 112*D1*Dd*Pk2*f*gd2 - 224*D1*Dd*Pk2*fd*g2*r**2 - 336*D1*Dd*Pk2*fd*g2*r + 672*D1*Dd*Pk2*fd*g2*s**2 - 1064*D1*Dd*Pk2*fd*g2*s + 448*D1*Dd*Pk2*fd*g2 + 24*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 12*D1*Dd*Pkdd2*f**3*k1**2*s + 6*D1*Dd*Pkdd2*f**3*k1**2 + 280*D1*Ddd*K*Pk2*f**2*r**2 + 1792*D1*Ddd*K*Pk2*f**2*r*s - 728*D1*Ddd*K*Pk2*f**2*r + 1624*D1*Ddd*K*Pk2*f**2*s**2 - 1708*D1*Ddd*K*Pk2*f**2*s + 546*D1*Ddd*K*Pk2*f**2 + 672*D1*Ddd*Pk2*f**3*r**2 - 672*D1*Ddd*Pk2*f**3*r - 672*D1*Ddd*Pk2*f**3*s**2 + 336*D1*Ddd*Pk2*f**3*s + 168*D1*Ddd*Pk2*f**3 - 192*D1*Ddd*Pk2*f**2*r**2 - 616*D1*Ddd*Pk2*f**2*r*s + 346*D1*Ddd*Pk2*f**2*r - 384*D1*Ddd*Pk2*f**2*s**2 + 500*D1*Ddd*Pk2*f**2*s - 192*D1*Ddd*Pk2*f**2 - 112*D1*Ddd*Pk2*f*g2*r**2 + 112*D1*Ddd*Pk2*f*g2*r + 336*D1*Ddd*Pk2*f*g2*s**2 - 168*D1*Ddd*Pk2*f*g2*s + 28*D1*Ddd*Pk2*f*g2 + 2*D1*bd1*(D1*(14*Pk2*fd*(K*(2*r**2 + r - 6*s**2 + 7*s - 2) - 14*r**2 + r*(13 - 28*s) - 10*s**2 + 10*s + 1) + f**2*(14*Pk2*(18*r**2 + r*(32*s - 33) + 14*s**2 - 35*s + 18) + 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(-7*Pk2*(K*(4*r**2 + 40*r*s - 12*r + 18*s**2 - 14*s - 1) + 2*fd*(88*r**2 + 8*r*(16*s - 15) + 40*s**2 - 84*s + 35) - 28*r**2 - 56*r*s + 50*r - 10*s**2 + 26*s - 13) + 6*Pkdd2*fd*k1**2*s*(1 - 2*s))) - Dd*f*(14*Pk2*(K*(-8*r**2 + 16*r + 24*s**2 - 2*s - 7) + f*(176*r**2 + 4*r*(64*s - 65) + 80*s**2 - 200*s + 99) + 56*r**2 + 2*r*(56*s - 51) + 40*s**2 - 94*s + 44) + 3*Pkdd2*f*k1**2*(8*s**2 - 6*s + 1))) + 840*Dd**2*K*Pk2*f**2*r**2 + 5376*Dd**2*K*Pk2*f**2*r*s - 2184*Dd**2*K*Pk2*f**2*r + 4872*Dd**2*K*Pk2*f**2*s**2 - 5124*Dd**2*K*Pk2*f**2*s + 1036*Dd**2*K*Pk2*f**2 + 2016*Dd**2*Pk2*f**3*r**2 - 2016*Dd**2*Pk2*f**3*r - 2016*Dd**2*Pk2*f**3*s**2 + 1008*Dd**2*Pk2*f**3*s + 336*Dd**2*Pk2*f**3 - 576*Dd**2*Pk2*f**2*r**2 - 1848*Dd**2*Pk2*f**2*r*s + 1038*Dd**2*Pk2*f**2*r - 1152*Dd**2*Pk2*f**2*s**2 + 1500*Dd**2*Pk2*f**2*s - 404*Dd**2*Pk2*f**2 - 336*Dd**2*Pk2*f*g2*r**2 + 336*Dd**2*Pk2*f*g2*r + 1008*Dd**2*Pk2*f*g2*s**2 - 504*Dd**2*Pk2*f*g2*s - 56*Dd**2*Pk2*f*g2))/(630*d**2*k3**4) + D1**2*Pk3*k1**2*(-70*Pk2*b1**3*(D1**2*(fd*(3*r + s - 3) + fdd*(-5*r - 3*s + 5))*(r + s - 1) + D1*(Dd*(f*(12*r**2 + 16*r*(s - 1) + 4*s**2 - 10*s + 7) - 2*fd*(20*r**2 + r*(32*s - 34) + 12*s**2 - 27*s + 14) + (4*K - 2)*(r*(4*s - 1) + (1 - 2*s)**2)) - Ddd*f*(20*r**2 + 4*r*(8*s - 7) + 12*s**2 - 22*s + 13) + 2*Ddd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd**2*(f*(30*r**2 + 6*r*(8*s - 7) + 18*s**2 - 33*s + 13) - (2*K - 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))) - 2*Pk2*(-258*C*D1**2*bdd1*f**2*r**2 - 768*C*D1**2*bdd1*f**2*r*s + 768*C*D1**2*bdd1*f**2*r - 420*C*D1**2*bdd1*f**2*s**2 + 840*C*D1**2*bdd1*f**2*s - 420*C*D1**2*bdd1*f**2 + 126*C*D1**2*f**2*fd*s**2 - 84*C*D1**2*f**2*fd*s + 42*C*D1**2*f**2*fd - 126*C*D1**2*f**2*fdd*s**2 + 84*C*D1**2*f**2*fdd*s - 42*C*D1**2*f**2*fdd - 252*C*D1**2*f*fd**2*s**2 + 168*C*D1**2*f*fd**2*s + 168*C*D1*Dd*f**3*s**2 - 84*C*D1*Dd*f**3*s + 42*C*D1*Dd*f**3 - 1008*C*D1*Dd*f**2*fd*s**2 + 588*C*D1*Dd*f**2*fd*s - 84*C*D1*Dd*f**2*fd - 168*C*D1*Ddd*f**3*s**2 + 84*C*D1*Ddd*f**3*s - 42*C*D1*Ddd*f**3 - 504*C*Dd**2*f**3*s**2 + 252*C*Dd**2*f**3*s - 35*D1**2*K*bdd1*f**2*s**2 + 7*D1**2*bd1**2*(15*f**2*(4*r**2 + r*(6*s - 7) + 2*s**2 - 5*s + 3) + f*(-10*K*(5*r**2 + 16*r*s - 13*r + 10*s**2 - 18*s + 8) + r*(24*C - 3)*(2*s - 1) + (s - 1)*(48*C*s - 16*s - 15)) + 40*g2*(-2*r*s + r - s*(2*s - 2))) + 129*D1**2*bdd1*f**2*r**2 + 459*D1**2*bdd1*f**2*r*s - 459*D1**2*bdd1*f**2*r + 252*D1**2*bdd1*f**2*s**2 - 504*D1**2*bdd1*f**2*s + 252*D1**2*bdd1*f**2 + 350*D1**2*bdd1*f*g2*r**2 + 1120*D1**2*bdd1*f*g2*r*s - 1120*D1**2*bdd1*f*g2*r + 700*D1**2*bdd1*f*g2*s**2 - 1400*D1**2*bdd1*f*g2*s + 700*D1**2*bdd1*f*g2 - 63*D1**2*f**2*fd*s**2 + 42*D1**2*f**2*fd*s - 21*D1**2*f**2*fd + 63*D1**2*f**2*fdd*s**2 - 42*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd - 70*D1**2*f**2*gd2*s**2 + 70*D1**2*f**2*gdd2*s**2 + 126*D1**2*f*fd**2*s**2 - 84*D1**2*f*fd**2*s - 140*D1**2*f*fd*g2*s**2 + 140*D1**2*f*fd*g2*s - 70*D1**2*f*fd*g2 + 280*D1**2*f*fd*gd2*s**2 - 140*D1**2*f*fd*gd2*s + 140*D1**2*f*fdd*g2*s**2 - 140*D1**2*f*fdd*g2*s + 70*D1**2*f*fdd*g2 + 140*D1**2*fd**2*g2*s**2 - 140*D1**2*fd**2*g2*s - 84*D1*Dd*f**3*s**2 + 42*D1*Dd*f**3*s - 21*D1*Dd*f**3 + 504*D1*Dd*f**2*fd*s**2 - 294*D1*Dd*f**2*fd*s + 42*D1*Dd*f**2*fd - 280*D1*Dd*f**2*g2*s**2 + 140*D1*Dd*f**2*g2*s - 70*D1*Dd*f**2*g2 + 560*D1*Dd*f**2*gd2*s**2 - 140*D1*Dd*f**2*gd2*s + 1120*D1*Dd*f*fd*g2*s**2 - 840*D1*Dd*f*fd*g2*s + 140*D1*Dd*f*fd*g2 + 84*D1*Ddd*f**3*s**2 - 42*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 + 280*D1*Ddd*f**2*g2*s**2 - 140*D1*Ddd*f**2*g2*s + 70*D1*Ddd*f**2*g2 + 35*D1*b2*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + D1*bd1*(-350*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(12*C*(15*r**2 + 44*r*(s - 1) + 21*(s - 1)**2) - 27*r**2 - 267*r*(s - 1) + 7*s**2*(5*K - 24) + 336*s - 168) + f*(fd*(-12*C*(86*r**2 + 256*r*s - 171*r + 140*s**2 - 204*s + 64) - 140*K*s**2 + 70*K*s + 516*r**2 + 12*r*(153*s - 98) + 1008*s**2 - 1467*s + 459) - 140*g2*(r**2 + 4*r*(s - 1) + 3*(s - 1)**2) + 140*gd2*(5*r**2 + 16*r*s - 13*r + 10*s**2 - 18*s + 8)) + 140*fd*g2*(5*r**2 + 8*r*(2*s - 1) + s*(10*s - 10))) + Dd*f*(f*(-24*C*(86*r**2 + 256*r*s - 203*r + 140*s**2 - 239*s + 99) - 280*K*s**2 + 70*K*s + 1032*r**2 + 3672*r*s - 2811*r + 2016*s**2 - 3438*s + 1422) + 280*g2*(10*r**2 + r*(32*s - 25) + 20*s**2 - 33*s + 13))) + 252*Dd**2*f**3*s**2 - 126*Dd**2*f**3*s + 840*Dd**2*f**2*g2*s**2 - 420*Dd**2*f**2*g2*s) - 7*b1**2*(-16*C*D1**2*Pk2*fd*r*s - 16*C*D1**2*Pk2*fd*s**2 + 16*C*D1**2*Pk2*fd*s + 48*C*D1**2*Pk2*fdd*r*s + 48*C*D1**2*Pk2*fdd*s**2 - 48*C*D1**2*Pk2*fdd*s - 64*C*D1*Dd*Pk2*f*r*s + 16*C*D1*Dd*Pk2*f*r - 64*C*D1*Dd*Pk2*f*s**2 + 64*C*D1*Dd*Pk2*f*s - 16*C*D1*Dd*Pk2*f + 384*C*D1*Dd*Pk2*fd*r*s - 48*C*D1*Dd*Pk2*fd*r + 384*C*D1*Dd*Pk2*fd*s**2 - 384*C*D1*Dd*Pk2*fd*s + 48*C*D1*Dd*Pk2*fd + 192*C*D1*Ddd*Pk2*f*r*s - 48*C*D1*Ddd*Pk2*f*r + 192*C*D1*Ddd*Pk2*f*s**2 - 192*C*D1*Ddd*Pk2*f*s + 48*C*D1*Ddd*Pk2*f + 576*C*Dd**2*Pk2*f*r*s - 144*C*Dd**2*Pk2*f*r + 576*C*Dd**2*Pk2*f*s**2 - 576*C*Dd**2*Pk2*f*s + 96*C*Dd**2*Pk2*f + 20*D1**2*K*Pk2*fd*r**2 + 80*D1**2*K*Pk2*fd*r*s + 60*D1**2*K*Pk2*fd*s**2 - 50*D1**2*K*Pk2*fdd*r**2 - 160*D1**2*K*Pk2*fdd*r*s - 100*D1**2*K*Pk2*fdd*s**2 - 10*D1**2*Pk2*bdd1*(f*(15*r**2 + 6*r*(4*s - 3) + 9*s**2 - 14*s + 8) + (2 - 4*K)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - 120*D1**2*Pk2*f*fd*r**2 - 180*D1**2*Pk2*f*fd*r*s + 120*D1**2*Pk2*f*fd*r - 60*D1**2*Pk2*f*fd*s**2 + 90*D1**2*Pk2*f*fd*s - 60*D1**2*Pk2*f*fd + 120*D1**2*Pk2*f*fdd*r**2 + 180*D1**2*Pk2*f*fdd*r*s - 120*D1**2*Pk2*f*fdd*r + 60*D1**2*Pk2*f*fdd*s**2 - 90*D1**2*Pk2*f*fdd*s + 60*D1**2*Pk2*f*fdd + 120*D1**2*Pk2*fd**2*r**2 + 180*D1**2*Pk2*fd**2*r*s - 120*D1**2*Pk2*fd**2*r + 60*D1**2*Pk2*fd**2*s**2 - 90*D1**2*Pk2*fd**2*s + 30*D1**2*Pk2*fd*r**2 + 22*D1**2*Pk2*fd*r*s - 8*D1**2*Pk2*fd*s**2 - 12*D1**2*Pk2*fd*s - 6*D1**2*Pk2*fdd*r*s - 16*D1**2*Pk2*fdd*s**2 + 36*D1**2*Pk2*fdd*s - 80*D1**2*Pk2*gd2*r*s - 80*D1**2*Pk2*gd2*s**2 + 80*D1**2*Pk2*gd2*s - 80*D1**2*Pk2*gdd2*r*s - 80*D1**2*Pk2*gdd2*s**2 + 80*D1**2*Pk2*gdd2*s + 6*D1**2*Pkdd2*f*fd*k1**2*s**2 + 80*D1*Dd*K*Pk2*f*r**2 + 320*D1*Dd*K*Pk2*f*r*s - 160*D1*Dd*K*Pk2*f*r + 240*D1*Dd*K*Pk2*f*s**2 - 280*D1*Dd*K*Pk2*f*s + 100*D1*Dd*K*Pk2*f - 400*D1*Dd*K*Pk2*fd*r**2 - 1280*D1*Dd*K*Pk2*fd*r*s + 360*D1*Dd*K*Pk2*fd*r - 800*D1*Dd*K*Pk2*fd*s**2 + 520*D1*Dd*K*Pk2*fd*s - 240*D1*Dd*Pk2*f**2*r**2 - 360*D1*Dd*Pk2*f**2*r*s + 330*D1*Dd*Pk2*f**2*r - 120*D1*Dd*Pk2*f**2*s**2 + 240*D1*Dd*Pk2*f**2*s - 150*D1*Dd*Pk2*f**2 + 960*D1*Dd*Pk2*f*fd*r**2 + 1440*D1*Dd*Pk2*f*fd*r*s - 1140*D1*Dd*Pk2*f*fd*r + 480*D1*Dd*Pk2*f*fd*s**2 - 840*D1*Dd*Pk2*f*fd*s + 330*D1*Dd*Pk2*f*fd + 120*D1*Dd*Pk2*f*r**2 + 88*D1*Dd*Pk2*f*r*s - 142*D1*Dd*Pk2*f*r - 32*D1*Dd*Pk2*f*s**2 - 28*D1*Dd*Pk2*f*s + 52*D1*Dd*Pk2*f - 48*D1*Dd*Pk2*fd*r*s + 6*D1*Dd*Pk2*fd*r - 128*D1*Dd*Pk2*fd*s**2 + 188*D1*Dd*Pk2*fd*s - 36*D1*Dd*Pk2*fd - 320*D1*Dd*Pk2*g2*r*s + 80*D1*Dd*Pk2*g2*r - 320*D1*Dd*Pk2*g2*s**2 + 320*D1*Dd*Pk2*g2*s - 80*D1*Dd*Pk2*g2 - 640*D1*Dd*Pk2*gd2*r*s + 80*D1*Dd*Pk2*gd2*r - 640*D1*Dd*Pk2*gd2*s**2 + 640*D1*Dd*Pk2*gd2*s - 80*D1*Dd*Pk2*gd2 + 12*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 6*D1*Dd*Pkdd2*f**2*k1**2*s + 3*D1*Dd*Pkdd2*f**2*k1**2 - 200*D1*Ddd*K*Pk2*f*r**2 - 640*D1*Ddd*K*Pk2*f*r*s + 360*D1*Ddd*K*Pk2*f*r - 400*D1*Ddd*K*Pk2*f*s**2 + 520*D1*Ddd*K*Pk2*f*s - 200*D1*Ddd*K*Pk2*f + 240*D1*Ddd*Pk2*f**2*r**2 + 360*D1*Ddd*Pk2*f**2*r*s - 330*D1*Ddd*Pk2*f**2*r + 120*D1*Ddd*Pk2*f**2*s**2 - 240*D1*Ddd*Pk2*f**2*s + 150*D1*Ddd*Pk2*f**2 - 24*D1*Ddd*Pk2*f*r*s + 6*D1*Ddd*Pk2*f*r - 64*D1*Ddd*Pk2*f*s**2 + 44*D1*Ddd*Pk2*f*s - 16*D1*Ddd*Pk2*f - 320*D1*Ddd*Pk2*g2*r*s + 80*D1*Ddd*Pk2*g2*r - 320*D1*Ddd*Pk2*g2*s**2 + 320*D1*Ddd*Pk2*g2*s - 80*D1*Ddd*Pk2*g2 + 10*D1*Pk2*bd1*(D1*(f*(9*r**2 + 2*r*(6*s - 5) + 3*s**2 - 6*s + 4) - 2*fd*(15*r**2 + 24*r*(s - 1) + 9*s**2 - 19*s + 9) + (4*K - 2)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - 2*Dd*f*(60*r**2 + r*(96*s - 78) + 36*s**2 - 61*s + 25) + 2*Dd*(2*K - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 600*Dd**2*K*Pk2*f*r**2 - 1920*Dd**2*K*Pk2*f*r*s + 1080*Dd**2*K*Pk2*f*r - 1200*Dd**2*K*Pk2*f*s**2 + 1560*Dd**2*K*Pk2*f*s - 420*Dd**2*K*Pk2*f + 720*Dd**2*Pk2*f**2*r**2 + 1080*Dd**2*Pk2*f**2*r*s - 990*Dd**2*Pk2*f**2*r + 360*Dd**2*Pk2*f**2*s**2 - 720*Dd**2*Pk2*f**2*s + 300*Dd**2*Pk2*f**2 - 72*Dd**2*Pk2*f*r*s + 18*Dd**2*Pk2*f*r - 192*Dd**2*Pk2*f*s**2 + 132*Dd**2*Pk2*f*s - 12*Dd**2*Pk2*f - 960*Dd**2*Pk2*g2*r*s + 240*Dd**2*Pk2*g2*r - 960*Dd**2*Pk2*g2*s**2 + 960*Dd**2*Pk2*g2*s - 160*Dd**2*Pk2*g2) + b1*(140*D1**2*Pk2*bd1**2*(f*(15*r**2 + 6*r*(4*s - 3) + 9*s**2 - 14*s + 4) - (2*K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 7*D1*bd1*(D1*(2*Pk2*f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 20*K*r**2 - 80*K*r*s + 60*K*r - 60*K*s**2 + 100*K*s - 40*K - 15*fd*(16*r**2 + 24*r*s - 22*r + 8*s**2 - 16*s + 7) - 30*r**2 - 22*r*s + 41*r + 8*s**2 - 3*s - 11) + 2*Pk2*(fd*(-24*C*(r*(4*s - 1) + (1 - 2*s)**2) + 100*K*r**2 + 200*K*s**2 - 180*K*s + r*(320*K*s - 130*K + 12*s - 3) + 32*s**2 - 37*s + 18) + 40*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 40*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*f**2*(10*Pk2*(4*r**2 + r*(6*s - 7) + 2*s**2 - 5*s + 3) + Pkdd2*k1**2*(-2*s**2 + 2*s - 1))) - 2*Dd*Pk2*(15*f**2*(32*r**2 + r*(48*s - 50) + 16*s**2 - 36*s + 19) + f*(48*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 40*K*(10*r**2 + 32*r*s - 22*r + 20*s**2 - 31*s + 11) - 48*r*s + 18*r - 128*s**2 + 48*s - 7) - 80*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 2*Pk2*(360*C*D1**2*f*fd*r**2 + 1056*C*D1**2*f*fd*r*s - 360*C*D1**2*f*fd*r + 504*C*D1**2*f*fd*s**2 - 528*C*D1**2*f*fd*s + 180*C*D1**2*f*fd - 516*C*D1**2*f*fdd*r**2 - 1536*C*D1**2*f*fdd*r*s + 516*C*D1**2*f*fdd*r - 840*C*D1**2*f*fdd*s**2 + 768*C*D1**2*f*fdd*s - 258*C*D1**2*f*fdd - 516*C*D1**2*fd**2*r**2 - 1536*C*D1**2*fd**2*r*s + 516*C*D1**2*fd**2*r - 840*C*D1**2*fd**2*s**2 + 768*C*D1**2*fd**2*s + 720*C*D1*Dd*f**2*r**2 + 2112*C*D1*Dd*f**2*r*s - 1248*C*D1*Dd*f**2*r + 1008*C*D1*Dd*f**2*s**2 - 1560*C*D1*Dd*f**2*s + 612*C*D1*Dd*f**2 - 4128*C*D1*Dd*f*fd*r**2 - 12288*C*D1*Dd*f*fd*r*s + 5664*C*D1*Dd*f*fd*r - 6720*C*D1*Dd*f*fd*s**2 + 7824*C*D1*Dd*f*fd*s - 1800*C*D1*Dd*f*fd - 1032*C*D1*Ddd*f**2*r**2 - 3072*C*D1*Ddd*f**2*r*s + 1800*C*D1*Ddd*f**2*r - 1680*C*D1*Ddd*f**2*s**2 + 2376*C*D1*Ddd*f**2*s - 936*C*D1*Ddd*f**2 - 3096*C*Dd**2*f**2*r**2 - 9216*C*Dd**2*f**2*r*s + 5400*C*Dd**2*f**2*r - 5040*C*Dd**2*f**2*s**2 + 7128*C*Dd**2*f**2*s - 2052*C*Dd**2*f**2 + 70*D1**2*K*f*fd*s**2 - 70*D1**2*K*f*fd*s + 35*D1**2*K*f*fd - 70*D1**2*K*f*fdd*s**2 + 70*D1**2*K*f*fdd*s - 35*D1**2*K*f*fdd - 70*D1**2*K*fd**2*s**2 + 70*D1**2*K*fd**2*s + 105*D1**2*b2*fd*r**2 + 210*D1**2*b2*fd*r*s + 105*D1**2*b2*fd*s**2 - 175*D1**2*b2*fdd*r**2 - 350*D1**2*b2*fdd*r*s - 175*D1**2*b2*fdd*s**2 + 7*D1**2*bdd1*(15*f**2*(4*r**2 + r*(6*s - 7) + 2*s**2 - 5*s + 3) + f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 5*K*(10*r**2 + 32*r*s - 26*r + 20*s**2 - 36*s + 15) - 6*r*s + 3*r - 16*s**2 + s - 8) - 40*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 175*D1**2*bdd2*f*r**2 - 350*D1**2*bdd2*f*r*s + 350*D1**2*bdd2*f*r - 175*D1**2*bdd2*f*s**2 + 350*D1**2*bdd2*f*s - 175*D1**2*bdd2*f - 54*D1**2*f*fd*r**2 - 534*D1**2*f*fd*r*s + 54*D1**2*f*fd*r - 336*D1**2*f*fd*s**2 + 267*D1**2*f*fd*s - 27*D1**2*f*fd + 258*D1**2*f*fdd*r**2 + 918*D1**2*f*fdd*r*s - 258*D1**2*f*fdd*r + 504*D1**2*f*fdd*s**2 - 459*D1**2*f*fdd*s + 129*D1**2*f*fdd - 140*D1**2*f*gd2*r**2 - 560*D1**2*f*gd2*r*s + 280*D1**2*f*gd2*r - 420*D1**2*f*gd2*s**2 + 560*D1**2*f*gd2*s - 140*D1**2*f*gd2 + 350*D1**2*f*gdd2*r**2 + 1120*D1**2*f*gdd2*r*s - 700*D1**2*f*gdd2*r + 700*D1**2*f*gdd2*s**2 - 1120*D1**2*f*gdd2*s + 350*D1**2*f*gdd2 + 258*D1**2*fd**2*r**2 + 918*D1**2*fd**2*r*s - 258*D1**2*fd**2*r + 504*D1**2*fd**2*s**2 - 459*D1**2*fd**2*s - 140*D1**2*fd*g2*r**2 - 560*D1**2*fd*g2*r*s - 420*D1**2*fd*g2*s**2 + 700*D1**2*fd*gd2*r**2 + 2240*D1**2*fd*gd2*r*s - 700*D1**2*fd*gd2*r + 1400*D1**2*fd*gd2*s**2 - 1120*D1**2*fd*gd2*s + 350*D1**2*fdd*g2*r**2 + 1120*D1**2*fdd*g2*r*s + 700*D1**2*fdd*g2*s**2 + 140*D1*Dd*K*f**2*s**2 - 70*D1*Dd*K*f**2*s + 35*D1*Dd*K*f**2 - 560*D1*Dd*K*f*fd*s**2 + 420*D1*Dd*K*f*fd*s - 70*D1*Dd*K*f*fd + 420*D1*Dd*b2*f*r**2 + 840*D1*Dd*b2*f*r*s - 630*D1*Dd*b2*f*r + 420*D1*Dd*b2*f*s**2 - 630*D1*Dd*b2*f*s + 315*D1*Dd*b2*f - 1400*D1*Dd*b2*fd*r**2 - 2800*D1*Dd*b2*fd*r*s + 1050*D1*Dd*b2*fd*r - 1400*D1*Dd*b2*fd*s**2 + 1050*D1*Dd*b2*fd*s - 108*D1*Dd*f**2*r**2 - 1068*D1*Dd*f**2*r*s + 375*D1*Dd*f**2*r - 672*D1*Dd*f**2*s**2 + 870*D1*Dd*f**2*s - 222*D1*Dd*f**2 + 2064*D1*Dd*f*fd*r**2 + 7344*D1*Dd*f*fd*r*s - 2982*D1*Dd*f*fd*r + 4032*D1*Dd*f*fd*s**2 - 4680*D1*Dd*f*fd*s + 975*D1*Dd*f*fd - 560*D1*Dd*f*g2*r**2 - 2240*D1*Dd*f*g2*r*s + 1120*D1*Dd*f*g2*r - 1680*D1*Dd*f*g2*s**2 + 1960*D1*Dd*f*g2*s - 700*D1*Dd*f*g2 + 2800*D1*Dd*f*gd2*r**2 + 8960*D1*Dd*f*gd2*r*s - 5320*D1*Dd*f*gd2*r + 5600*D1*Dd*f*gd2*s**2 - 8120*D1*Dd*f*gd2*s + 2520*D1*Dd*f*gd2 + 2800*D1*Dd*fd*g2*r**2 + 8960*D1*Dd*fd*g2*r*s - 2520*D1*Dd*fd*g2*r + 5600*D1*Dd*fd*g2*s**2 - 3640*D1*Dd*fd*g2*s - 140*D1*Ddd*K*f**2*s**2 + 70*D1*Ddd*K*f**2*s - 35*D1*Ddd*K*f**2 - 700*D1*Ddd*b2*f*r**2 - 1400*D1*Ddd*b2*f*r*s + 1050*D1*Ddd*b2*f*r - 700*D1*Ddd*b2*f*s**2 + 1050*D1*Ddd*b2*f*s - 525*D1*Ddd*b2*f + 516*D1*Ddd*f**2*r**2 + 1836*D1*Ddd*f**2*r*s - 975*D1*Ddd*f**2*r + 1008*D1*Ddd*f**2*s**2 - 1422*D1*Ddd*f**2*s + 510*D1*Ddd*f**2 + 1400*D1*Ddd*f*g2*r**2 + 4480*D1*Ddd*f*g2*r*s - 2520*D1*Ddd*f*g2*r + 2800*D1*Ddd*f*g2*s**2 - 3640*D1*Ddd*f*g2*s + 1400*D1*Ddd*f*g2 + 35*D1*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) - 420*Dd**2*K*f**2*s**2 + 210*Dd**2*K*f**2*s - 2100*Dd**2*b2*f*r**2 - 4200*Dd**2*b2*f*r*s + 3150*Dd**2*b2*f*r - 2100*Dd**2*b2*f*s**2 + 3150*Dd**2*b2*f*s - 1050*Dd**2*b2*f + 1548*Dd**2*f**2*r**2 + 5508*Dd**2*f**2*r*s - 2925*Dd**2*f**2*r + 3024*Dd**2*f**2*s**2 - 4266*Dd**2*f**2*s + 1176*Dd**2*f**2 + 4200*Dd**2*f*g2*r**2 + 13440*Dd**2*f*g2*r*s - 7560*Dd**2*f*g2*r + 8400*Dd**2*f*g2*s**2 - 10920*Dd**2*f*g2*s + 2940*Dd**2*f*g2)))/(210*d**2*k3**4) + D1**2*Pk3*k2**2*st**6*(-24*C*D1**2*Pk2*f**2*fd*r**2 + 192*C*D1**2*Pk2*f**2*fd*r*s - 48*C*D1**2*Pk2*f**2*fd*r + 96*C*D1**2*Pk2*f**2*fd*s**2 - 128*C*D1**2*Pk2*f**2*fd*s + 24*C*D1**2*Pk2*f**2*fd + 12*C*D1**2*Pk2*f**2*fdd*r**2 - 96*C*D1**2*Pk2*f**2*fdd*r*s + 24*C*D1**2*Pk2*f**2*fdd*r - 48*C*D1**2*Pk2*f**2*fdd*s**2 + 64*C*D1**2*Pk2*f**2*fdd*s - 12*C*D1**2*Pk2*f**2*fdd + 24*C*D1**2*Pk2*f*fd**2*r**2 - 192*C*D1**2*Pk2*f*fd**2*r*s + 48*C*D1**2*Pk2*f*fd**2*r - 96*C*D1**2*Pk2*f*fd**2*s**2 + 128*C*D1**2*Pk2*f*fd**2*s - 32*C*D1**2*Pk2*f*fd**2 - 32*C*D1*Dd*Pk2*f**3*r**2 + 256*C*D1*Dd*Pk2*f**3*r*s - 32*C*D1*Dd*Pk2*f**3*r + 128*C*D1*Dd*Pk2*f**3*s**2 - 192*C*D1*Dd*Pk2*f**3*s + 16*C*D1*Dd*Pk2*f**3 + 96*C*D1*Dd*Pk2*f**2*fd*r**2 - 768*C*D1*Dd*Pk2*f**2*fd*r*s + 144*C*D1*Dd*Pk2*f**2*fd*r - 384*C*D1*Dd*Pk2*f**2*fd*s**2 + 544*C*D1*Dd*Pk2*f**2*fd*s - 112*C*D1*Dd*Pk2*f**2*fd + 16*C*D1*Ddd*Pk2*f**3*r**2 - 128*C*D1*Ddd*Pk2*f**3*r*s + 16*C*D1*Ddd*Pk2*f**3*r - 64*C*D1*Ddd*Pk2*f**3*s**2 + 96*C*D1*Ddd*Pk2*f**3*s - 8*C*D1*Ddd*Pk2*f**3 + 48*C*Dd**2*Pk2*f**3*r**2 - 384*C*Dd**2*Pk2*f**3*r*s + 48*C*Dd**2*Pk2*f**3*r - 192*C*Dd**2*Pk2*f**3*s**2 + 288*C*Dd**2*Pk2*f**3*s - 56*C*Dd**2*Pk2*f**3 - 72*D1**2*K*Pk2*b1*f*fd*r**2 + 576*D1**2*K*Pk2*b1*f*fd*r*s - 288*D1**2*K*Pk2*b1*f*fd*r + 288*D1**2*K*Pk2*b1*f*fd*s**2 - 288*D1**2*K*Pk2*b1*f*fd*s + 144*D1**2*K*Pk2*b1*f*fd + 36*D1**2*K*Pk2*b1*f*fdd*r**2 - 288*D1**2*K*Pk2*b1*f*fdd*r*s + 144*D1**2*K*Pk2*b1*f*fdd*r - 144*D1**2*K*Pk2*b1*f*fdd*s**2 + 144*D1**2*K*Pk2*b1*f*fdd*s - 72*D1**2*K*Pk2*b1*f*fdd + 36*D1**2*K*Pk2*b1*fd**2*r**2 - 288*D1**2*K*Pk2*b1*fd**2*r*s + 144*D1**2*K*Pk2*b1*fd**2*r - 144*D1**2*K*Pk2*b1*fd**2*s**2 + 144*D1**2*K*Pk2*b1*fd**2*s + 108*D1**2*Pk2*b1*f**2*fd*r**2 - 72*D1**2*Pk2*b1*f**2*fd*r + 36*D1**2*Pk2*b1*f**2*fd - 108*D1**2*Pk2*b1*f**2*fdd*r**2 + 72*D1**2*Pk2*b1*f**2*fdd*r - 36*D1**2*Pk2*b1*f**2*fdd - 216*D1**2*Pk2*b1*f*fd**2*r**2 + 144*D1**2*Pk2*b1*f*fd**2*r + 216*D1**2*Pk2*b1*f*fd*r**2 - 108*D1**2*Pk2*b1*f*fdd*r**2 - 108*D1**2*Pk2*b1*fd**2*r**2 + 288*D1**2*Pk2*b2*f*fd*r*s - 144*D1**2*Pk2*b2*f*fd*r + 288*D1**2*Pk2*b2*f*fd*s**2 - 288*D1**2*Pk2*b2*f*fd*s + 144*D1**2*Pk2*b2*f*fd - 144*D1**2*Pk2*b2*f*fdd*r*s + 72*D1**2*Pk2*b2*f*fdd*r - 144*D1**2*Pk2*b2*f*fdd*s**2 + 144*D1**2*Pk2*b2*f*fdd*s - 72*D1**2*Pk2*b2*f*fdd - 144*D1**2*Pk2*b2*fd**2*r*s + 72*D1**2*Pk2*b2*fd**2*r - 144*D1**2*Pk2*b2*fd**2*s**2 + 144*D1**2*Pk2*b2*fd**2*s + 144*D1**2*Pk2*bd2*f**2*r*s + 144*D1**2*Pk2*bd2*f**2*s**2 - 144*D1**2*Pk2*bd2*f**2*s - 288*D1**2*Pk2*bd2*f*fd*r*s + 72*D1**2*Pk2*bd2*f*fd*r - 288*D1**2*Pk2*bd2*f*fd*s**2 + 288*D1**2*Pk2*bd2*f*fd*s - 72*D1**2*Pk2*bd2*f*fd - 72*D1**2*Pk2*bdd2*f**2*r*s - 72*D1**2*Pk2*bdd2*f**2*s**2 + 72*D1**2*Pk2*bdd2*f**2*s - 72*D1**2*Pk2*f**3*fd*r**2 + 72*D1**2*Pk2*f**3*fd*r - 36*D1**2*Pk2*f**3*fd + 72*D1**2*Pk2*f**3*fdd*r**2 - 72*D1**2*Pk2*f**3*fdd*r + 36*D1**2*Pk2*f**3*fdd + 216*D1**2*Pk2*f**2*fd**2*r**2 - 216*D1**2*Pk2*f**2*fd**2*r + 36*D1**2*Pk2*f**2*fd**2 + 48*D1**2*Pk2*f**2*fd*r**2 - 96*D1**2*Pk2*f**2*fd*r*s - 48*D1**2*Pk2*f**2*fd*s**2 + 64*D1**2*Pk2*f**2*fd*s - 24*D1**2*Pk2*f**2*fdd*r**2 + 48*D1**2*Pk2*f**2*fdd*r*s + 24*D1**2*Pk2*f**2*fdd*s**2 - 32*D1**2*Pk2*f**2*fdd*s + 72*D1**2*Pk2*f**2*gd2*r**2 - 576*D1**2*Pk2*f**2*gd2*r*s - 144*D1**2*Pk2*f**2*gd2*r - 288*D1**2*Pk2*f**2*gd2*s**2 + 576*D1**2*Pk2*f**2*gd2*s + 72*D1**2*Pk2*f**2*gd2 - 36*D1**2*Pk2*f**2*gdd2*r**2 + 288*D1**2*Pk2*f**2*gdd2*r*s + 72*D1**2*Pk2*f**2*gdd2*r + 144*D1**2*Pk2*f**2*gdd2*s**2 - 288*D1**2*Pk2*f**2*gdd2*s - 36*D1**2*Pk2*f**2*gdd2 - 48*D1**2*Pk2*f*fd**2*r**2 + 96*D1**2*Pk2*f*fd**2*r*s + 48*D1**2*Pk2*f*fd**2*s**2 - 64*D1**2*Pk2*f*fd**2*s + 16*D1**2*Pk2*f*fd**2 + 144*D1**2*Pk2*f*fd*g2*r**2 - 1152*D1**2*Pk2*f*fd*g2*r*s + 576*D1**2*Pk2*f*fd*g2*r - 576*D1**2*Pk2*f*fd*g2*s**2 + 576*D1**2*Pk2*f*fd*g2*s - 288*D1**2*Pk2*f*fd*g2 - 144*D1**2*Pk2*f*fd*gd2*r**2 + 1152*D1**2*Pk2*f*fd*gd2*r*s - 144*D1**2*Pk2*f*fd*gd2*r + 576*D1**2*Pk2*f*fd*gd2*s**2 - 864*D1**2*Pk2*f*fd*gd2*s + 288*D1**2*Pk2*f*fd*gd2 - 72*D1**2*Pk2*f*fdd*g2*r**2 + 576*D1**2*Pk2*f*fdd*g2*r*s - 288*D1**2*Pk2*f*fdd*g2*r + 288*D1**2*Pk2*f*fdd*g2*s**2 - 288*D1**2*Pk2*f*fdd*g2*s + 144*D1**2*Pk2*f*fdd*g2 - 72*D1**2*Pk2*fd**2*g2*r**2 + 576*D1**2*Pk2*fd**2*g2*r*s - 288*D1**2*Pk2*fd**2*g2*r + 288*D1**2*Pk2*fd**2*g2*s**2 - 288*D1**2*Pk2*fd**2*g2*s + 12*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 - 12*D1**2*Pkdd2*b1*f**2*fd*k1**2*s + 6*D1**2*Pkdd2*b1*f**2*fd*k1**2 - 6*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 + 6*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s - 3*D1**2*Pkdd2*b1*f**2*fdd*k1**2 - 12*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 + 12*D1**2*Pkdd2*b1*f*fd**2*k1**2*s + 4*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 2*D1**2*Pkdd2*f**3*fd*k1**2*s + D1**2*Pkdd2*f**3*fd*k1**2 - D1**2*bdd1*f**2*(18*Pk2*(-K*(r**2 - 8*r*s - 2*r - 4*s**2 + 8*s + 1) + 2*f*(r - 1)**2 + 3*(r - 1)**2) + Pkdd2*f*k1**2*(2*s**2 + 2*s - 1)) - 144*D1*Dd*K*Pk2*b1*f**2*r**2 + 1152*D1*Dd*K*Pk2*b1*f**2*r*s - 144*D1*Dd*K*Pk2*b1*f**2*r + 576*D1*Dd*K*Pk2*b1*f**2*s**2 - 864*D1*Dd*K*Pk2*b1*f**2*s + 72*D1*Dd*K*Pk2*b1*f**2 + 288*D1*Dd*K*Pk2*b1*f*fd*r**2 - 2304*D1*Dd*K*Pk2*b1*f*fd*r*s + 720*D1*Dd*K*Pk2*b1*f*fd*r - 1152*D1*Dd*K*Pk2*b1*f*fd*s**2 + 1440*D1*Dd*K*Pk2*b1*f*fd*s - 432*D1*Dd*K*Pk2*b1*f*fd + 144*D1*Dd*Pk2*b1*f**3*r**2 - 144*D1*Dd*Pk2*b1*f**3*r + 72*D1*Dd*Pk2*b1*f**3 - 864*D1*Dd*Pk2*b1*f**2*fd*r**2 + 720*D1*Dd*Pk2*b1*f**2*fd*r - 144*D1*Dd*Pk2*b1*f**2*fd + 432*D1*Dd*Pk2*b1*f**2*r**2 - 432*D1*Dd*Pk2*b1*f**2*r + 216*D1*Dd*Pk2*b1*f**2 - 864*D1*Dd*Pk2*b1*f*fd*r**2 + 432*D1*Dd*Pk2*b1*f*fd*r + 576*D1*Dd*Pk2*b2*f**2*r*s - 144*D1*Dd*Pk2*b2*f**2*r + 576*D1*Dd*Pk2*b2*f**2*s**2 - 576*D1*Dd*Pk2*b2*f**2*s + 144*D1*Dd*Pk2*b2*f**2 - 1152*D1*Dd*Pk2*b2*f*fd*r*s + 432*D1*Dd*Pk2*b2*f*fd*r - 1152*D1*Dd*Pk2*b2*f*fd*s**2 + 1152*D1*Dd*Pk2*b2*f*fd*s - 288*D1*Dd*Pk2*b2*f*fd - 576*D1*Dd*Pk2*bd2*f**2*r*s + 72*D1*Dd*Pk2*bd2*f**2*r - 576*D1*Dd*Pk2*bd2*f**2*s**2 + 576*D1*Dd*Pk2*bd2*f**2*s - 72*D1*Dd*Pk2*bd2*f**2 - 72*D1*Dd*Pk2*f**4*r**2 + 72*D1*Dd*Pk2*f**4*r - 36*D1*Dd*Pk2*f**4 + 576*D1*Dd*Pk2*f**3*fd*r**2 - 576*D1*Dd*Pk2*f**3*fd*r + 144*D1*Dd*Pk2*f**3*fd + 64*D1*Dd*Pk2*f**3*r**2 - 128*D1*Dd*Pk2*f**3*r*s - 32*D1*Dd*Pk2*f**3*r - 64*D1*Dd*Pk2*f**3*s**2 + 96*D1*Dd*Pk2*f**3*s + 16*D1*Dd*Pk2*f**3 - 192*D1*Dd*Pk2*f**2*fd*r**2 + 384*D1*Dd*Pk2*f**2*fd*r*s + 48*D1*Dd*Pk2*f**2*fd*r + 192*D1*Dd*Pk2*f**2*fd*s**2 - 272*D1*Dd*Pk2*f**2*fd*s + 32*D1*Dd*Pk2*f**2*fd + 288*D1*Dd*Pk2*f**2*g2*r**2 - 2304*D1*Dd*Pk2*f**2*g2*r*s + 288*D1*Dd*Pk2*f**2*g2*r - 1152*D1*Dd*Pk2*f**2*g2*s**2 + 1728*D1*Dd*Pk2*f**2*g2*s - 144*D1*Dd*Pk2*f**2*g2 - 288*D1*Dd*Pk2*f**2*gd2*r**2 + 2304*D1*Dd*Pk2*f**2*gd2*r*s + 144*D1*Dd*Pk2*f**2*gd2*r + 1152*D1*Dd*Pk2*f**2*gd2*s**2 - 2016*D1*Dd*Pk2*f**2*gd2*s + 144*D1*Dd*Pk2*f**2*gd2 - 576*D1*Dd*Pk2*f*fd*g2*r**2 + 4608*D1*Dd*Pk2*f*fd*g2*r*s - 1440*D1*Dd*Pk2*f*fd*g2*r + 2304*D1*Dd*Pk2*f*fd*g2*s**2 - 2880*D1*Dd*Pk2*f*fd*g2*s + 864*D1*Dd*Pk2*f*fd*g2 + 16*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 - 8*D1*Dd*Pkdd2*b1*f**3*k1**2*s + 4*D1*Dd*Pkdd2*b1*f**3*k1**2 - 48*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 + 36*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s - 6*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 + 4*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 2*D1*Dd*Pkdd2*f**4*k1**2*s + D1*Dd*Pkdd2*f**4*k1**2 + 72*D1*Ddd*K*Pk2*b1*f**2*r**2 - 576*D1*Ddd*K*Pk2*b1*f**2*r*s + 72*D1*Ddd*K*Pk2*b1*f**2*r - 288*D1*Ddd*K*Pk2*b1*f**2*s**2 + 432*D1*Ddd*K*Pk2*b1*f**2*s - 36*D1*Ddd*K*Pk2*b1*f**2 - 144*D1*Ddd*Pk2*b1*f**3*r**2 + 144*D1*Ddd*Pk2*b1*f**3*r - 72*D1*Ddd*Pk2*b1*f**3 - 216*D1*Ddd*Pk2*b1*f**2*r**2 + 216*D1*Ddd*Pk2*b1*f**2*r - 108*D1*Ddd*Pk2*b1*f**2 - 288*D1*Ddd*Pk2*b2*f**2*r*s + 72*D1*Ddd*Pk2*b2*f**2*r - 288*D1*Ddd*Pk2*b2*f**2*s**2 + 288*D1*Ddd*Pk2*b2*f**2*s - 72*D1*Ddd*Pk2*b2*f**2 + 72*D1*Ddd*Pk2*f**4*r**2 - 72*D1*Ddd*Pk2*f**4*r + 36*D1*Ddd*Pk2*f**4 - 32*D1*Ddd*Pk2*f**3*r**2 + 64*D1*Ddd*Pk2*f**3*r*s + 16*D1*Ddd*Pk2*f**3*r + 32*D1*Ddd*Pk2*f**3*s**2 - 48*D1*Ddd*Pk2*f**3*s - 8*D1*Ddd*Pk2*f**3 - 144*D1*Ddd*Pk2*f**2*g2*r**2 + 1152*D1*Ddd*Pk2*f**2*g2*r*s - 144*D1*Ddd*Pk2*f**2*g2*r + 576*D1*Ddd*Pk2*f**2*g2*s**2 - 864*D1*Ddd*Pk2*f**2*g2*s + 72*D1*Ddd*Pk2*f**2*g2 - 8*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 + 4*D1*Ddd*Pkdd2*b1*f**3*k1**2*s - 2*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 2*D1*bd1*f*(D1*(36*Pk2*fd*(K*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + r*(3 - 3*r)) + f**2*(18*Pk2*(r - 1)**2 + Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 6*f*(3*Pk2*(K*(r**2 - 8*r*s - 2*r - 4*s**2 + 8*s + 1) + fd*(6*r**2 - 8*r + 2) - 3*(r - 1)**2) + Pkdd2*fd*k1**2*s**2)) - Dd*f*(36*Pk2*(K*(-2*r**2 + 16*r*s + r + 8*s**2 - 14*s + 1) + f*(4*r**2 - 6*r + 2) + 6*r**2 - 9*r + 3) + Pkdd2*f*k1**2*(8*s**2 + 2*s - 1))) + 216*Dd**2*K*Pk2*b1*f**2*r**2 - 1728*Dd**2*K*Pk2*b1*f**2*r*s + 216*Dd**2*K*Pk2*b1*f**2*r - 864*Dd**2*K*Pk2*b1*f**2*s**2 + 1296*Dd**2*K*Pk2*b1*f**2*s - 252*Dd**2*K*Pk2*b1*f**2 - 432*Dd**2*Pk2*b1*f**3*r**2 + 432*Dd**2*Pk2*b1*f**3*r - 72*Dd**2*Pk2*b1*f**3 - 648*Dd**2*Pk2*b1*f**2*r**2 + 648*Dd**2*Pk2*b1*f**2*r - 108*Dd**2*Pk2*b1*f**2 - 864*Dd**2*Pk2*b2*f**2*r*s + 216*Dd**2*Pk2*b2*f**2*r - 864*Dd**2*Pk2*b2*f**2*s**2 + 864*Dd**2*Pk2*b2*f**2*s - 144*Dd**2*Pk2*b2*f**2 + 216*Dd**2*Pk2*f**4*r**2 - 216*Dd**2*Pk2*f**4*r + 36*Dd**2*Pk2*f**4 - 96*Dd**2*Pk2*f**3*r**2 + 192*Dd**2*Pk2*f**3*r*s + 48*Dd**2*Pk2*f**3*r + 96*Dd**2*Pk2*f**3*s**2 - 144*Dd**2*Pk2*f**3*s + 16*Dd**2*Pk2*f**3 - 432*Dd**2*Pk2*f**2*g2*r**2 + 3456*Dd**2*Pk2*f**2*g2*r*s - 432*Dd**2*Pk2*f**2*g2*r + 1728*Dd**2*Pk2*f**2*g2*s**2 - 2592*Dd**2*Pk2*f**2*g2*s + 504*Dd**2*Pk2*f**2*g2 - 24*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 + 12*Dd**2*Pkdd2*b1*f**3*k1**2*s)/(126*d**2*k3**4) + D1**2*Pk3*k2**2*st**4*(-36*C*D1**2*Pk2*bdd1*f**2*r**2 - 48*C*D1**2*Pk2*bdd1*f**2*r*s - 600*C*D1**2*Pk2*f**2*fd*r**2 - 1344*C*D1**2*Pk2*f**2*fd*r*s + 848*C*D1**2*Pk2*f**2*fd*r - 396*C*D1**2*Pk2*f**2*fd*s**2 + 712*C*D1**2*Pk2*f**2*fd*s - 332*C*D1**2*Pk2*f**2*fd + 804*C*D1**2*Pk2*f**2*fdd*r**2 + 1248*C*D1**2*Pk2*f**2*fdd*r*s - 952*C*D1**2*Pk2*f**2*fdd*r + 324*C*D1**2*Pk2*f**2*fdd*s**2 - 632*C*D1**2*Pk2*f**2*fdd*s + 376*C*D1**2*Pk2*f**2*fdd + 1608*C*D1**2*Pk2*f*fd**2*r**2 + 2496*C*D1**2*Pk2*f*fd**2*r*s - 1904*C*D1**2*Pk2*f*fd**2*r + 648*C*D1**2*Pk2*f*fd**2*s**2 - 1264*C*D1**2*Pk2*f*fd**2*s + 416*C*D1**2*Pk2*f*fd**2 - 12*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 8*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 4*C*D1**2*Pkdd2*f**2*fd*k1**2 + 6*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 4*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 2*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 12*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 8*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 800*C*D1*Dd*Pk2*f**3*r**2 - 1792*C*D1*Dd*Pk2*f**3*r*s + 1248*C*D1*Dd*Pk2*f**3*r - 528*C*D1*Dd*Pk2*f**3*s**2 + 1160*C*D1*Dd*Pk2*f**3*s - 532*C*D1*Dd*Pk2*f**3 + 6432*C*D1*Dd*Pk2*f**2*fd*r**2 + 9984*C*D1*Dd*Pk2*f**2*fd*r*s - 8272*C*D1*Dd*Pk2*f**2*fd*r + 2592*C*D1*Dd*Pk2*f**2*fd*s**2 - 5672*C*D1*Dd*Pk2*f**2*fd*s + 2536*C*D1*Dd*Pk2*f**2*fd - 16*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 8*C*D1*Dd*Pkdd2*f**3*k1**2*s - 4*C*D1*Dd*Pkdd2*f**3*k1**2 + 48*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 28*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 4*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 1072*C*D1*Ddd*Pk2*f**3*r**2 + 1664*C*D1*Ddd*Pk2*f**3*r*s - 1488*C*D1*Ddd*Pk2*f**3*r + 432*C*D1*Ddd*Pk2*f**3*s**2 - 1048*C*D1*Ddd*Pk2*f**3*s + 644*C*D1*Ddd*Pk2*f**3 + 8*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 4*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 2*C*D1*Ddd*Pkdd2*f**3*k1**2 + 3216*C*Dd**2*Pk2*f**3*r**2 + 4992*C*Dd**2*Pk2*f**3*r*s - 4464*C*Dd**2*Pk2*f**3*r + 1296*C*Dd**2*Pk2*f**3*s**2 - 3144*C*Dd**2*Pk2*f**3*s + 1368*C*Dd**2*Pk2*f**3 + 24*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 12*C*Dd**2*Pkdd2*f**3*k1**2*s + 378*D1**2*K*Pk2*bdd1*f**2*r**2 + 1008*D1**2*K*Pk2*bdd1*f**2*r*s - 756*D1**2*K*Pk2*bdd1*f**2*r + 378*D1**2*K*Pk2*bdd1*f**2*s**2 - 1008*D1**2*K*Pk2*bdd1*f**2*s + 378*D1**2*K*Pk2*bdd1*f**2 + 3*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 252*D1**2*Pk2*b2*f*fd*r**2 - 1176*D1**2*Pk2*b2*f*fd*r*s + 588*D1**2*Pk2*b2*f*fd*r - 924*D1**2*Pk2*b2*f*fd*s**2 + 924*D1**2*Pk2*b2*f*fd*s - 462*D1**2*Pk2*b2*f*fd + 420*D1**2*Pk2*b2*f*fdd*r**2 + 1176*D1**2*Pk2*b2*f*fdd*r*s - 588*D1**2*Pk2*b2*f*fdd*r + 756*D1**2*Pk2*b2*f*fdd*s**2 - 756*D1**2*Pk2*b2*f*fdd*s + 378*D1**2*Pk2*b2*f*fdd + 420*D1**2*Pk2*b2*fd**2*r**2 + 1176*D1**2*Pk2*b2*fd**2*r*s - 588*D1**2*Pk2*b2*fd**2*r + 756*D1**2*Pk2*b2*fd**2*s**2 - 756*D1**2*Pk2*b2*fd**2*s - 126*D1**2*Pk2*bd2*f**2*r**2 - 588*D1**2*Pk2*bd2*f**2*r*s + 252*D1**2*Pk2*bd2*f**2*r - 462*D1**2*Pk2*bd2*f**2*s**2 + 588*D1**2*Pk2*bd2*f**2*s - 126*D1**2*Pk2*bd2*f**2 + 840*D1**2*Pk2*bd2*f*fd*r**2 + 2352*D1**2*Pk2*bd2*f*fd*r*s - 1428*D1**2*Pk2*bd2*f*fd*r + 1512*D1**2*Pk2*bd2*f*fd*s**2 - 1932*D1**2*Pk2*bd2*f*fd*s + 588*D1**2*Pk2*bd2*f*fd - 84*D1**2*Pk2*bdd1*f**3*r**2 - 210*D1**2*Pk2*bdd1*f**3*r*s + 252*D1**2*Pk2*bdd1*f**3*r + 210*D1**2*Pk2*bdd1*f**3*s - 126*D1**2*Pk2*bdd1*f**3 - 72*D1**2*Pk2*bdd1*f**2*r**2 - 186*D1**2*Pk2*bdd1*f**2*r*s + 180*D1**2*Pk2*bdd1*f**2*r + 210*D1**2*Pk2*bdd1*f**2*s - 84*D1**2*Pk2*bdd1*f**2 + 252*D1**2*Pk2*bdd1*f*g2*r**2 + 336*D1**2*Pk2*bdd1*f*g2*r*s + 210*D1**2*Pk2*bdd2*f**2*r**2 + 588*D1**2*Pk2*bdd2*f**2*r*s - 420*D1**2*Pk2*bdd2*f**2*r + 378*D1**2*Pk2*bdd2*f**2*s**2 - 588*D1**2*Pk2*bdd2*f**2*s + 210*D1**2*Pk2*bdd2*f**2 + 306*D1**2*Pk2*f**2*fd*r**2 + 774*D1**2*Pk2*f**2*fd*r*s - 462*D1**2*Pk2*f**2*fd*r + 198*D1**2*Pk2*f**2*fd*s**2 - 390*D1**2*Pk2*f**2*fd*s + 168*D1**2*Pk2*f**2*fd - 486*D1**2*Pk2*f**2*fdd*r**2 - 738*D1**2*Pk2*f**2*fdd*r*s + 570*D1**2*Pk2*f**2*fdd*r - 162*D1**2*Pk2*f**2*fdd*s**2 + 354*D1**2*Pk2*f**2*fdd*s - 216*D1**2*Pk2*f**2*fdd + 504*D1**2*Pk2*f**2*gd2*r**2 + 2016*D1**2*Pk2*f**2*gd2*r*s - 1008*D1**2*Pk2*f**2*gd2*r + 924*D1**2*Pk2*f**2*gd2*s**2 - 2016*D1**2*Pk2*f**2*gd2*s + 504*D1**2*Pk2*f**2*gd2 - 756*D1**2*Pk2*f**2*gdd2*r**2 - 2016*D1**2*Pk2*f**2*gdd2*r*s + 1512*D1**2*Pk2*f**2*gdd2*r - 756*D1**2*Pk2*f**2*gdd2*s**2 + 2016*D1**2*Pk2*f**2*gdd2*s - 756*D1**2*Pk2*f**2*gdd2 - 972*D1**2*Pk2*f*fd**2*r**2 - 1476*D1**2*Pk2*f*fd**2*r*s + 1140*D1**2*Pk2*f*fd**2*r - 324*D1**2*Pk2*f*fd**2*s**2 + 708*D1**2*Pk2*f*fd**2*s - 246*D1**2*Pk2*f*fd**2 + 1008*D1**2*Pk2*f*fd*g2*r**2 + 4032*D1**2*Pk2*f*fd*g2*r*s - 2016*D1**2*Pk2*f*fd*g2*r + 1848*D1**2*Pk2*f*fd*g2*s**2 - 1848*D1**2*Pk2*f*fd*g2*s + 924*D1**2*Pk2*f*fd*g2 - 3024*D1**2*Pk2*f*fd*gd2*r**2 - 8064*D1**2*Pk2*f*fd*gd2*r*s + 5040*D1**2*Pk2*f*fd*gd2*r - 3024*D1**2*Pk2*f*fd*gd2*s**2 + 5544*D1**2*Pk2*f*fd*gd2*s - 2016*D1**2*Pk2*f*fd*gd2 - 1512*D1**2*Pk2*f*fdd*g2*r**2 - 4032*D1**2*Pk2*f*fdd*g2*r*s + 2016*D1**2*Pk2*f*fdd*g2*r - 1512*D1**2*Pk2*f*fdd*g2*s**2 + 1512*D1**2*Pk2*f*fdd*g2*s - 756*D1**2*Pk2*f*fdd*g2 - 1512*D1**2*Pk2*fd**2*g2*r**2 - 4032*D1**2*Pk2*fd**2*g2*r*s + 2016*D1**2*Pk2*fd**2*g2*r - 1512*D1**2*Pk2*fd**2*g2*s**2 + 1512*D1**2*Pk2*fd**2*g2*s + 6*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 4*D1**2*Pkdd2*f**2*fd*k1**2*s + 2*D1**2*Pkdd2*f**2*fd*k1**2 - 3*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 2*D1**2*Pkdd2*f**2*fdd*k1**2*s - D1**2*Pkdd2*f**2*fdd*k1**2 + 12*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 6*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 6*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 4*D1**2*Pkdd2*f*fd**2*k1**2*s + 24*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 24*D1**2*Pkdd2*f*fd*g2*k1**2*s + 12*D1**2*Pkdd2*f*fd*g2*k1**2 - 24*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 12*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 12*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 12*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 6*D1**2*Pkdd2*f*fdd*g2*k1**2 - 12*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 12*D1**2*Pkdd2*fd**2*g2*k1**2*s + 6*D1**2*bd1**2*f*(14*Pk2*(2*K*s + f*(r - 1) - r**2*(3*K + 1) + r*(-4*K*s + 3*K + 2) - 1) - 3*Pkdd2*f*k1**2*s*(s - 1)) - 504*D1*Dd*Pk2*b2*f**2*r**2 - 2352*D1*Dd*Pk2*b2*f**2*r*s + 1092*D1*Dd*Pk2*b2*f**2*r - 1848*D1*Dd*Pk2*b2*f**2*s**2 + 2100*D1*Dd*Pk2*b2*f**2*s - 714*D1*Dd*Pk2*b2*f**2 + 3360*D1*Dd*Pk2*b2*f*fd*r**2 + 9408*D1*Dd*Pk2*b2*f*fd*r*s - 5208*D1*Dd*Pk2*b2*f*fd*r + 6048*D1*Dd*Pk2*b2*f*fd*s**2 - 6888*D1*Dd*Pk2*b2*f*fd*s + 1932*D1*Dd*Pk2*b2*f*fd + 1680*D1*Dd*Pk2*bd2*f**2*r**2 + 4704*D1*Dd*Pk2*bd2*f**2*r*s - 3108*D1*Dd*Pk2*bd2*f**2*r + 3024*D1*Dd*Pk2*bd2*f**2*s**2 - 4284*D1*Dd*Pk2*bd2*f**2*s + 1428*D1*Dd*Pk2*bd2*f**2 + 408*D1*Dd*Pk2*f**3*r**2 + 1032*D1*Dd*Pk2*f**3*r*s - 666*D1*Dd*Pk2*f**3*r + 264*D1*Dd*Pk2*f**3*s**2 - 648*D1*Dd*Pk2*f**3*s + 270*D1*Dd*Pk2*f**3 - 3888*D1*Dd*Pk2*f**2*fd*r**2 - 5904*D1*Dd*Pk2*f**2*fd*r*s + 4962*D1*Dd*Pk2*f**2*fd*r - 1296*D1*Dd*Pk2*f**2*fd*s**2 + 3216*D1*Dd*Pk2*f**2*fd*s - 1494*D1*Dd*Pk2*f**2*fd + 2016*D1*Dd*Pk2*f**2*g2*r**2 + 8064*D1*Dd*Pk2*f**2*g2*r*s - 4032*D1*Dd*Pk2*f**2*g2*r + 3696*D1*Dd*Pk2*f**2*g2*s**2 - 5880*D1*Dd*Pk2*f**2*g2*s + 1932*D1*Dd*Pk2*f**2*g2 - 6048*D1*Dd*Pk2*f**2*gd2*r**2 - 16128*D1*Dd*Pk2*f**2*gd2*r*s + 11088*D1*Dd*Pk2*f**2*gd2*r - 6048*D1*Dd*Pk2*f**2*gd2*s**2 + 13608*D1*Dd*Pk2*f**2*gd2*s - 5040*D1*Dd*Pk2*f**2*gd2 - 12096*D1*Dd*Pk2*f*fd*g2*r**2 - 32256*D1*Dd*Pk2*f*fd*g2*r*s + 18144*D1*Dd*Pk2*f*fd*g2*r - 12096*D1*Dd*Pk2*f*fd*g2*s**2 + 17136*D1*Dd*Pk2*f*fd*g2*s - 5544*D1*Dd*Pk2*f*fd*g2 + 8*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**3*k1**2*s + 2*D1*Dd*Pkdd2*f**3*k1**2 - 24*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 14*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 2*D1*Dd*Pkdd2*f**2*fd*k1**2 + 48*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 24*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 12*D1*Dd*Pkdd2*f**2*g2*k1**2 - 48*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 12*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 96*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 72*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 12*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 840*D1*Ddd*Pk2*b2*f**2*r**2 + 2352*D1*Ddd*Pk2*b2*f**2*r*s - 1428*D1*Ddd*Pk2*b2*f**2*r + 1512*D1*Ddd*Pk2*b2*f**2*s**2 - 1932*D1*Ddd*Pk2*b2*f**2*s + 798*D1*Ddd*Pk2*b2*f**2 - 648*D1*Ddd*Pk2*f**3*r**2 - 984*D1*Ddd*Pk2*f**3*r*s + 894*D1*Ddd*Pk2*f**3*r - 216*D1*Ddd*Pk2*f**3*s**2 + 600*D1*Ddd*Pk2*f**3*s - 378*D1*Ddd*Pk2*f**3 - 3024*D1*Ddd*Pk2*f**2*g2*r**2 - 8064*D1*Ddd*Pk2*f**2*g2*r*s + 5040*D1*Ddd*Pk2*f**2*g2*r - 3024*D1*Ddd*Pk2*f**2*g2*s**2 + 5544*D1*Ddd*Pk2*f**2*g2*s - 2268*D1*Ddd*Pk2*f**2*g2 - 4*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**3*k1**2*s - D1*Ddd*Pkdd2*f**3*k1**2 - 24*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 12*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 6*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 3*D1*bd1*(D1*(56*Pk2*fd*g2*r*(3*r + 4*s - 2) + f**3*(14*Pk2*(2*r**2 + r*(5*s - 6) - 5*s + 3) + Pkdd2*k1**2*(-2*s**2 - 2*s + 1)) - 2*f**2*(K*Pkdd2*k1**2*s**2 + Pk2*(-12*C*r**2 - 16*C*r*s + 7*K*(6*r**2 + 24*r*s - 12*r + 11*s**2 - 24*s + 6) + 7*fd*(12*r**2 + 5*r*(6*s - 5) - 20*s + 11) + 11*r**2 - 13*r*s - 10*r + 21*s + 7)) + 2*f*(-28*Pk2*(g2*r*(3*r + 4*s) + gd2*(-3*r**2 + r*(3 - 4*s) + 2*s)) + fd*(K*Pkdd2*k1**2*s*(2*s - 1) + Pk2*(8*C*s + 42*K*(6*r**2 + 2*r*(8*s - 5) + 6*s**2 - 11*s + 4) - r**2*(24*C + 48) + r*(-32*C*s + 20*C - 124*s + 85) + 66*s - 37)))) - 2*Dd*f*(7*Pk2*f**2*(16*r**2 + r*(40*s - 37) - 30*s + 17) - 112*Pk2*g2*(3*r**2 + r*(4*s - 2) - s) + f*(K*Pkdd2*k1**2*s*(1 - 4*s) + Pk2*(-16*C*s - 42*K*(12*r**2 + r*(32*s - 22) + 12*s**2 - 27*s + 10) + r**2*(48*C + 96) + r*(64*C*s - 32*C + 248*s - 199) - 202*s + 95)))) + 2520*Dd**2*Pk2*b2*f**2*r**2 + 7056*Dd**2*Pk2*b2*f**2*r*s - 4284*Dd**2*Pk2*b2*f**2*r + 4536*Dd**2*Pk2*b2*f**2*s**2 - 5796*Dd**2*Pk2*b2*f**2*s + 1596*Dd**2*Pk2*b2*f**2 - 1944*Dd**2*Pk2*f**3*r**2 - 2952*Dd**2*Pk2*f**3*r*s + 2682*Dd**2*Pk2*f**3*r - 648*Dd**2*Pk2*f**3*s**2 + 1800*Dd**2*Pk2*f**3*s - 816*Dd**2*Pk2*f**3 - 9072*Dd**2*Pk2*f**2*g2*r**2 - 24192*Dd**2*Pk2*f**2*g2*r*s + 15120*Dd**2*Pk2*f**2*g2*r - 9072*Dd**2*Pk2*f**2*g2*s**2 + 16632*Dd**2*Pk2*f**2*g2*s - 5544*Dd**2*Pk2*f**2*g2 - 12*Dd**2*Pkdd2*f**3*k1**2*s**2 + 6*Dd**2*Pkdd2*f**3*k1**2*s - 72*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 36*Dd**2*Pkdd2*f**2*g2*k1**2*s + 3*b1**2*(-2*D1**2*(fd**2*(14*Pk2*(r - 1) + 3*Pkdd2*k1**2*s**2) - 2*fd*(7*Pk2*r*(K*(3*r + 4*s - 4) + f + r + 2) + 3*Pkdd2*f*k1**2*s**2) + fdd*(7*Pk2*r*(K*(3*r + 4*s - 4) + 2*f + r + 2) + 3*Pkdd2*f*k1**2*s**2)) + D1*(2*Dd*(-28*Pk2*fd*(K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) + 2*r**2 + r - 1) + 3*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + f*(28*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) - 2*fd*r + fd + 2*r**2 - 2*r + 1) + 6*Pkdd2*fd*k1**2*s*(1 - 4*s))) - Ddd*f*(28*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + 2*r**2 - 2*r + 1) + 3*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(14*Pk2*(K*(18*r**2 + 24*r*(s - 1) - 12*s + 7) + 6*r**2 - 6*r + 1) + 9*Pkdd2*f*k1**2*s*(2*s - 1))) - 3*b1*(-48*C*D1**2*Pk2*f*fd*r**2 - 64*C*D1**2*Pk2*f*fd*r*s + 80*C*D1**2*Pk2*f*fd*r + 32*C*D1**2*Pk2*f*fd*s - 24*C*D1**2*Pk2*f*fd + 24*C*D1**2*Pk2*f*fdd*r**2 + 32*C*D1**2*Pk2*f*fdd*r*s - 40*C*D1**2*Pk2*f*fdd*r - 16*C*D1**2*Pk2*f*fdd*s + 12*C*D1**2*Pk2*f*fdd + 24*C*D1**2*Pk2*fd**2*r**2 + 32*C*D1**2*Pk2*fd**2*r*s - 40*C*D1**2*Pk2*fd**2*r - 16*C*D1**2*Pk2*fd**2*s + 16*C*D1**2*Pk2*fd**2 - 96*C*D1*Dd*Pk2*f**2*r**2 - 128*C*D1*Dd*Pk2*f**2*r*s + 128*C*D1*Dd*Pk2*f**2*r + 64*C*D1*Dd*Pk2*f**2*s - 48*C*D1*Dd*Pk2*f**2 + 192*C*D1*Dd*Pk2*f*fd*r**2 + 256*C*D1*Dd*Pk2*f*fd*r*s - 288*C*D1*Dd*Pk2*f*fd*r - 128*C*D1*Dd*Pk2*f*fd*s + 96*C*D1*Dd*Pk2*f*fd + 48*C*D1*Ddd*Pk2*f**2*r**2 + 64*C*D1*Ddd*Pk2*f**2*r*s - 64*C*D1*Ddd*Pk2*f**2*r - 32*C*D1*Ddd*Pk2*f**2*s + 24*C*D1*Ddd*Pk2*f**2 + 144*C*Dd**2*Pk2*f**2*r**2 + 192*C*Dd**2*Pk2*f**2*r*s - 192*C*Dd**2*Pk2*f**2*r - 96*C*Dd**2*Pk2*f**2*s + 56*C*Dd**2*Pk2*f**2 + 168*D1**2*K*Pk2*f*fd*r**2 + 672*D1**2*K*Pk2*f*fd*r*s - 336*D1**2*K*Pk2*f*fd*r + 308*D1**2*K*Pk2*f*fd*s**2 - 308*D1**2*K*Pk2*f*fd*s + 154*D1**2*K*Pk2*f*fd - 252*D1**2*K*Pk2*f*fdd*r**2 - 672*D1**2*K*Pk2*f*fdd*r*s + 336*D1**2*K*Pk2*f*fdd*r - 252*D1**2*K*Pk2*f*fdd*s**2 + 252*D1**2*K*Pk2*f*fdd*s - 126*D1**2*K*Pk2*f*fdd - 252*D1**2*K*Pk2*fd**2*r**2 - 672*D1**2*K*Pk2*fd**2*r*s + 336*D1**2*K*Pk2*fd**2*r - 252*D1**2*K*Pk2*fd**2*s**2 + 252*D1**2*K*Pk2*fd**2*s + 4*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 4*D1**2*K*Pkdd2*f*fd*k1**2*s + 2*D1**2*K*Pkdd2*f*fd*k1**2 - 2*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 2*D1**2*K*Pkdd2*f*fdd*k1**2*s - D1**2*K*Pkdd2*f*fdd*k1**2 - 2*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 2*D1**2*K*Pkdd2*fd**2*k1**2*s - 84*D1**2*Pk2*f**2*fd*r**2 - 210*D1**2*Pk2*f**2*fd*r*s + 98*D1**2*Pk2*f**2*fd*r + 70*D1**2*Pk2*f**2*fd*s - 14*D1**2*Pk2*f**2*fd + 84*D1**2*Pk2*f**2*fdd*r**2 + 210*D1**2*Pk2*f**2*fdd*r*s - 98*D1**2*Pk2*f**2*fdd*r - 70*D1**2*Pk2*f**2*fdd*s + 14*D1**2*Pk2*f**2*fdd + 168*D1**2*Pk2*f*fd**2*r**2 + 420*D1**2*Pk2*f*fd**2*r*s - 196*D1**2*Pk2*f*fd**2*r - 140*D1**2*Pk2*f*fd**2*s + 42*D1**2*Pk2*f*fd**2 + 44*D1**2*Pk2*f*fd*r**2 - 52*D1**2*Pk2*f*fd*r*s + 2*D1**2*Pk2*f*fd*r - 16*D1**2*Pk2*f*fd*s + 8*D1**2*Pk2*f*fd + 48*D1**2*Pk2*f*fdd*r**2 + 124*D1**2*Pk2*f*fdd*r*s - 50*D1**2*Pk2*f*fdd*r + 8*D1**2*Pk2*f*fdd*s - 4*D1**2*Pk2*f*fdd + 168*D1**2*Pk2*f*gd2*r**2 + 224*D1**2*Pk2*f*gd2*r*s - 336*D1**2*Pk2*f*gd2*r - 224*D1**2*Pk2*f*gd2*s + 168*D1**2*Pk2*f*gd2 - 84*D1**2*Pk2*f*gdd2*r**2 - 112*D1**2*Pk2*f*gdd2*r*s + 168*D1**2*Pk2*f*gdd2*r + 112*D1**2*Pk2*f*gdd2*s - 84*D1**2*Pk2*f*gdd2 + 48*D1**2*Pk2*fd**2*r**2 + 124*D1**2*Pk2*fd**2*r*s - 50*D1**2*Pk2*fd**2*r + 8*D1**2*Pk2*fd**2*s - 12*D1**2*Pk2*fd**2 + 168*D1**2*Pk2*fd*g2*r**2 + 224*D1**2*Pk2*fd*g2*r*s - 224*D1**2*Pk2*fd*g2*r - 168*D1**2*Pk2*fd*gd2*r**2 - 224*D1**2*Pk2*fd*gd2*r*s + 280*D1**2*Pk2*fd*gd2*r + 112*D1**2*Pk2*fd*gd2*s - 112*D1**2*Pk2*fd*gd2 - 84*D1**2*Pk2*fdd*g2*r**2 - 112*D1**2*Pk2*fdd*g2*r*s + 112*D1**2*Pk2*fdd*g2*r + 6*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 6*D1**2*Pkdd2*f**2*fd*k1**2*s + 3*D1**2*Pkdd2*f**2*fd*k1**2 + D1**2*bdd1*f*(14*Pk2*(K*(6*r**2 + r*(8*s - 6) - 4*s + 3) + 2*r**2 - r*(2*f + 4) + 1) + 3*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) + 336*D1*Dd*K*Pk2*f**2*r**2 + 1344*D1*Dd*K*Pk2*f**2*r*s - 672*D1*Dd*K*Pk2*f**2*r + 616*D1*Dd*K*Pk2*f**2*s**2 - 980*D1*Dd*K*Pk2*f**2*s + 322*D1*Dd*K*Pk2*f**2 - 2016*D1*Dd*K*Pk2*f*fd*r**2 - 5376*D1*Dd*K*Pk2*f*fd*r*s + 3024*D1*Dd*K*Pk2*f*fd*r - 2016*D1*Dd*K*Pk2*f*fd*s**2 + 2856*D1*Dd*K*Pk2*f*fd*s - 924*D1*Dd*K*Pk2*f*fd + 8*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 4*D1*Dd*K*Pkdd2*f**2*k1**2*s + 2*D1*Dd*K*Pkdd2*f**2*k1**2 - 16*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 2*D1*Dd*K*Pkdd2*f*fd*k1**2 - 112*D1*Dd*Pk2*f**3*r**2 - 280*D1*Dd*Pk2*f**3*r*s + 182*D1*Dd*Pk2*f**3*r + 140*D1*Dd*Pk2*f**3*s - 56*D1*Dd*Pk2*f**3 + 672*D1*Dd*Pk2*f**2*fd*r**2 + 1680*D1*Dd*Pk2*f**2*fd*r*s - 938*D1*Dd*Pk2*f**2*fd*r - 700*D1*Dd*Pk2*f**2*fd*s + 266*D1*Dd*Pk2*f**2*fd + 88*D1*Dd*Pk2*f**2*r**2 - 104*D1*Dd*Pk2*f**2*r*s - 62*D1*Dd*Pk2*f**2*r + 52*D1*Dd*Pk2*f**2*s + 44*D1*Dd*Pk2*f**2 + 384*D1*Dd*Pk2*f*fd*r**2 + 992*D1*Dd*Pk2*f*fd*r*s - 516*D1*Dd*Pk2*f*fd*r - 216*D1*Dd*Pk2*f*fd*s + 92*D1*Dd*Pk2*f*fd + 672*D1*Dd*Pk2*f*g2*r**2 + 896*D1*Dd*Pk2*f*g2*r*s - 896*D1*Dd*Pk2*f*g2*r - 448*D1*Dd*Pk2*f*g2*s + 336*D1*Dd*Pk2*f*g2 - 672*D1*Dd*Pk2*f*gd2*r**2 - 896*D1*Dd*Pk2*f*gd2*r*s + 1120*D1*Dd*Pk2*f*gd2*r + 672*D1*Dd*Pk2*f*gd2*s - 448*D1*Dd*Pk2*f*gd2 - 672*D1*Dd*Pk2*fd*g2*r**2 - 896*D1*Dd*Pk2*fd*g2*r*s + 896*D1*Dd*Pk2*fd*g2*r + 224*D1*Dd*Pk2*fd*g2*s - 224*D1*Dd*Pk2*fd*g2 + 8*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**3*k1**2*s + 2*D1*Dd*Pkdd2*f**3*k1**2 - 504*D1*Ddd*K*Pk2*f**2*r**2 - 1344*D1*Ddd*K*Pk2*f**2*r*s + 840*D1*Ddd*K*Pk2*f**2*r - 504*D1*Ddd*K*Pk2*f**2*s**2 + 924*D1*Ddd*K*Pk2*f**2*s - 378*D1*Ddd*K*Pk2*f**2 - 4*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 2*D1*Ddd*K*Pkdd2*f**2*k1**2*s - D1*Ddd*K*Pkdd2*f**2*k1**2 + 112*D1*Ddd*Pk2*f**3*r**2 + 280*D1*Ddd*Pk2*f**3*r*s - 182*D1*Ddd*Pk2*f**3*r - 140*D1*Ddd*Pk2*f**3*s + 56*D1*Ddd*Pk2*f**3 + 96*D1*Ddd*Pk2*f**2*r**2 + 248*D1*Ddd*Pk2*f**2*r*s - 158*D1*Ddd*Pk2*f**2*r - 124*D1*Ddd*Pk2*f**2*s + 48*D1*Ddd*Pk2*f**2 - 336*D1*Ddd*Pk2*f*g2*r**2 - 448*D1*Ddd*Pk2*f*g2*r*s + 448*D1*Ddd*Pk2*f*g2*r + 224*D1*Ddd*Pk2*f*g2*s - 168*D1*Ddd*Pk2*f*g2 + 2*D1*bd1*(D1*(14*Pk2*fd*(K*(6*r**2 + 8*r*s - 7*r - 2*s + 2) + 2*r**2 - 1) + f**2*(14*Pk2*r - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - 2*f*(7*Pk2*(K*(6*r**2 + 8*r*s - 6*r - 4*s + 3) + 2*r**2 - 4*r + 1) + 3*Pkdd2*fd*k1**2*s*(1 - 2*s))) + Dd*f*(-28*Pk2*(2*r - 1)*(-6*K*r - 8*K*s + 4*K + f - 2*r + 2) + 3*Pkdd2*f*k1**2*(8*s**2 - 6*s + 1))) - 1512*Dd**2*K*Pk2*f**2*r**2 - 4032*Dd**2*K*Pk2*f**2*r*s + 2520*Dd**2*K*Pk2*f**2*r - 1512*Dd**2*K*Pk2*f**2*s**2 + 2772*Dd**2*K*Pk2*f**2*s - 924*Dd**2*K*Pk2*f**2 - 12*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 6*Dd**2*K*Pkdd2*f**2*k1**2*s + 336*Dd**2*Pk2*f**3*r**2 + 840*Dd**2*Pk2*f**3*r*s - 546*Dd**2*Pk2*f**3*r - 420*Dd**2*Pk2*f**3*s + 196*Dd**2*Pk2*f**3 + 288*Dd**2*Pk2*f**2*r**2 + 744*Dd**2*Pk2*f**2*r*s - 474*Dd**2*Pk2*f**2*r - 372*Dd**2*Pk2*f**2*s + 172*Dd**2*Pk2*f**2 - 1008*Dd**2*Pk2*f*g2*r**2 - 1344*Dd**2*Pk2*f*g2*r*s + 1344*Dd**2*Pk2*f*g2*r + 672*Dd**2*Pk2*f*g2*s - 392*Dd**2*Pk2*f*g2))/(210*d**2*k3**4) - D1**2*Pk3*k2**2*st**2*(672*C*D1**2*Pk2*bd1**2*f*r**2 + 1344*C*D1**2*Pk2*bd1**2*f*r*s - 672*C*D1**2*Pk2*bd1**2*f*r + 672*C*D1**2*Pk2*bd1**2*f*s**2 - 672*C*D1**2*Pk2*bd1**2*f*s + 1116*C*D1**2*Pk2*bd1*f**2*r**2 + 1752*C*D1**2*Pk2*bd1*f**2*r*s - 1968*C*D1**2*Pk2*bd1*f**2*r + 252*C*D1**2*Pk2*bd1*f**2*s**2 - 1008*C*D1**2*Pk2*bd1*f**2*s + 504*C*D1**2*Pk2*bd1*f**2 - 5760*C*D1**2*Pk2*bd1*f*fd*r**2 - 8544*C*D1**2*Pk2*bd1*f*fd*r*s + 7848*C*D1**2*Pk2*bd1*f*fd*r - 1680*C*D1**2*Pk2*bd1*f*fd*s**2 + 4656*C*D1**2*Pk2*bd1*f*fd*s - 2832*C*D1**2*Pk2*bd1*f*fd - 1440*C*D1**2*Pk2*bdd1*f**2*r**2 - 2136*C*D1**2*Pk2*bdd1*f**2*r*s + 2832*C*D1**2*Pk2*bdd1*f**2*r - 420*C*D1**2*Pk2*bdd1*f**2*s**2 + 1680*C*D1**2*Pk2*bdd1*f**2*s - 840*C*D1**2*Pk2*bdd1*f**2 + 804*C*D1**2*Pk2*f**2*fd*r**2 + 3240*C*D1**2*Pk2*f**2*fd*r*s - 1616*C*D1**2*Pk2*f**2*fd*r + 1512*C*D1**2*Pk2*f**2*fd*s**2 - 2088*C*D1**2*Pk2*f**2*fd*s + 772*C*D1**2*Pk2*f**2*fd - 780*C*D1**2*Pk2*f**2*fdd*r**2 - 3240*C*D1**2*Pk2*f**2*fdd*r*s + 1600*C*D1**2*Pk2*f**2*fdd*r - 1512*C*D1**2*Pk2*f**2*fdd*s**2 + 2088*C*D1**2*Pk2*f**2*fdd*s - 764*C*D1**2*Pk2*f**2*fdd - 1560*C*D1**2*Pk2*f*fd**2*r**2 - 6480*C*D1**2*Pk2*f*fd**2*r*s + 3200*C*D1**2*Pk2*f*fd**2*r - 3024*C*D1**2*Pk2*f*fd**2*s**2 + 4176*C*D1**2*Pk2*f*fd**2*s - 1080*C*D1**2*Pk2*f*fd**2 + 36*C*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 - 72*C*D1**2*Pkdd2*bd1*f**2*k1**2*s + 36*C*D1**2*Pkdd2*bd1*f**2*k1**2 - 72*C*D1**2*Pkdd2*bd1*f*fd*k1**2*s**2 + 72*C*D1**2*Pkdd2*bd1*f*fd*k1**2*s - 18*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 36*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 18*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 54*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 36*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 18*C*D1**2*Pkdd2*f**2*fd*k1**2 - 11520*C*D1*Dd*Pk2*bd1*f**2*r**2 - 17088*C*D1*Dd*Pk2*bd1*f**2*r*s + 19224*C*D1*Dd*Pk2*bd1*f**2*r - 3360*C*D1*Dd*Pk2*bd1*f**2*s**2 + 11832*C*D1*Dd*Pk2*bd1*f**2*s - 7344*C*D1*Dd*Pk2*bd1*f**2 + 1072*C*D1*Dd*Pk2*f**3*r**2 + 4320*C*D1*Dd*Pk2*f**3*r*s - 2152*C*D1*Dd*Pk2*f**3*r + 2016*C*D1*Dd*Pk2*f**3*s**2 - 3168*C*D1*Dd*Pk2*f**3*s + 1040*C*D1*Dd*Pk2*f**3 - 6240*C*D1*Dd*Pk2*f**2*fd*r**2 - 25920*C*D1*Dd*Pk2*f**2*fd*r*s + 12760*C*D1*Dd*Pk2*f**2*fd*r - 12096*C*D1*Dd*Pk2*f**2*fd*s**2 + 17856*C*D1*Dd*Pk2*f**2*fd*s - 5288*C*D1*Dd*Pk2*f**2*fd - 144*C*D1*Dd*Pkdd2*bd1*f**2*k1**2*s**2 + 180*C*D1*Dd*Pkdd2*bd1*f**2*k1**2*s - 36*C*D1*Dd*Pkdd2*bd1*f**2*k1**2 - 72*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 36*C*D1*Dd*Pkdd2*f**3*k1**2*s - 18*C*D1*Dd*Pkdd2*f**3*k1**2 - 1040*C*D1*Ddd*Pk2*f**3*r**2 - 4320*C*D1*Ddd*Pk2*f**3*r*s + 2120*C*D1*Ddd*Pk2*f**3*r - 2016*C*D1*Ddd*Pk2*f**3*s**2 + 3168*C*D1*Ddd*Pk2*f**3*s - 1024*C*D1*Ddd*Pk2*f**3 - 3120*C*Dd**2*Pk2*f**3*r**2 - 12960*C*Dd**2*Pk2*f**3*r*s + 6360*C*Dd**2*Pk2*f**3*r - 6048*C*Dd**2*Pk2*f**3*s**2 + 9504*C*Dd**2*Pk2*f**3*s - 2680*C*Dd**2*Pk2*f**3 - 3360*D1**2*K*Pk2*bd1**2*f*r**2 - 5880*D1**2*K*Pk2*bd1**2*f*r*s + 7560*D1**2*K*Pk2*bd1**2*f*r - 2100*D1**2*K*Pk2*bd1**2*f*s**2 + 7140*D1**2*K*Pk2*bd1**2*f*s - 4200*D1**2*K*Pk2*bd1**2*f + 210*D1**2*K*Pk2*bd1*f**2*r**2 + 1260*D1**2*K*Pk2*bd1*f**2*r*s - 420*D1**2*K*Pk2*bd1*f**2*r + 1260*D1**2*K*Pk2*bd1*f**2*s**2 - 1260*D1**2*K*Pk2*bd1*f**2*s + 210*D1**2*K*Pk2*bd1*f**2 - 840*D1**2*K*Pk2*bd1*f*fd*r**2 - 5040*D1**2*K*Pk2*bd1*f*fd*r*s + 2100*D1**2*K*Pk2*bd1*f*fd*r - 5040*D1**2*K*Pk2*bd1*f*fd*s**2 + 5040*D1**2*K*Pk2*bd1*f*fd*s - 1260*D1**2*K*Pk2*bd1*f*fd - 210*D1**2*K*Pk2*bdd1*f**2*r**2 - 1260*D1**2*K*Pk2*bdd1*f**2*r*s + 420*D1**2*K*Pk2*bdd1*f**2*r - 1260*D1**2*K*Pk2*bdd1*f**2*s**2 + 1260*D1**2*K*Pk2*bdd1*f**2*s - 210*D1**2*K*Pk2*bdd1*f**2 - 42*D1**2*K*Pkdd2*bd1**2*f*k1**2*s**2 + 42*D1**2*K*Pkdd2*bd1**2*f*k1**2*s - 21*D1**2*K*Pkdd2*bd1*f**2*k1**2*s**2 + 1260*D1**2*Pk2*bd1**2*f**2*r**2 + 1260*D1**2*Pk2*bd1**2*f**2*r*s - 1890*D1**2*Pk2*bd1**2*f**2*r - 630*D1**2*Pk2*bd1**2*f**2*s + 630*D1**2*Pk2*bd1**2*f**2 + 336*D1**2*Pk2*bd1**2*f*r**2 + 420*D1**2*Pk2*bd1**2*f*r*s - 1050*D1**2*Pk2*bd1**2*f*r - 336*D1**2*Pk2*bd1**2*f*s**2 - 294*D1**2*Pk2*bd1**2*f*s + 630*D1**2*Pk2*bd1**2*f - 3360*D1**2*Pk2*bd1**2*g2*r**2 - 6720*D1**2*Pk2*bd1**2*g2*r*s + 3360*D1**2*Pk2*bd1**2*g2*r - 3360*D1**2*Pk2*bd1**2*g2*s**2 + 3360*D1**2*Pk2*bd1**2*g2*s - 2100*D1**2*Pk2*bd1*bd2*f*r**2 - 4200*D1**2*Pk2*bd1*bd2*f*r*s + 4200*D1**2*Pk2*bd1*bd2*f*r - 2100*D1**2*Pk2*bd1*bd2*f*s**2 + 4200*D1**2*Pk2*bd1*bd2*f*s - 2100*D1**2*Pk2*bd1*bd2*f - 624*D1**2*Pk2*bd1*f**2*r**2 - 1014*D1**2*Pk2*bd1*f**2*r*s + 1038*D1**2*Pk2*bd1*f**2*r - 126*D1**2*Pk2*bd1*f**2*s**2 + 504*D1**2*Pk2*bd1*f**2*s - 252*D1**2*Pk2*bd1*f**2 + 3600*D1**2*Pk2*bd1*f*fd*r**2 + 4968*D1**2*Pk2*bd1*f*fd*r*s - 4632*D1**2*Pk2*bd1*f*fd*r + 840*D1**2*Pk2*bd1*f*fd*s**2 - 2502*D1**2*Pk2*bd1*f*fd*s + 1590*D1**2*Pk2*bd1*f*fd - 4620*D1**2*Pk2*bd1*f*g2*r**2 - 5880*D1**2*Pk2*bd1*f*g2*r*s + 5040*D1**2*Pk2*bd1*f*g2*r - 1260*D1**2*Pk2*bd1*f*g2*s**2 + 5040*D1**2*Pk2*bd1*f*g2*s - 2520*D1**2*Pk2*bd1*f*g2 + 6720*D1**2*Pk2*bd1*f*gd2*r**2 + 11760*D1**2*Pk2*bd1*f*gd2*r*s - 15120*D1**2*Pk2*bd1*f*gd2*r + 4200*D1**2*Pk2*bd1*f*gd2*s**2 - 14280*D1**2*Pk2*bd1*f*gd2*s + 8400*D1**2*Pk2*bd1*f*gd2 + 6720*D1**2*Pk2*bd1*fd*g2*r**2 + 11760*D1**2*Pk2*bd1*fd*g2*r*s - 5880*D1**2*Pk2*bd1*fd*g2*r + 4200*D1**2*Pk2*bd1*fd*g2*s**2 - 4200*D1**2*Pk2*bd1*fd*g2*s + 900*D1**2*Pk2*bdd1*f**2*r**2 + 1242*D1**2*Pk2*bdd1*f**2*r*s - 1590*D1**2*Pk2*bdd1*f**2*r + 210*D1**2*Pk2*bdd1*f**2*s**2 - 840*D1**2*Pk2*bdd1*f**2*s + 420*D1**2*Pk2*bdd1*f**2 + 3360*D1**2*Pk2*bdd1*f*g2*r**2 + 5880*D1**2*Pk2*bdd1*f*g2*r*s - 8400*D1**2*Pk2*bdd1*f*g2*r + 2100*D1**2*Pk2*bdd1*f*g2*s**2 - 8400*D1**2*Pk2*bdd1*f*g2*s + 4200*D1**2*Pk2*bdd1*f*g2 - 402*D1**2*Pk2*f**2*fd*r**2 - 1620*D1**2*Pk2*f**2*fd*r*s + 808*D1**2*Pk2*f**2*fd*r - 756*D1**2*Pk2*f**2*fd*s**2 + 1044*D1**2*Pk2*f**2*fd*s - 386*D1**2*Pk2*f**2*fd + 390*D1**2*Pk2*f**2*fdd*r**2 + 1620*D1**2*Pk2*f**2*fdd*r*s - 800*D1**2*Pk2*f**2*fdd*r + 756*D1**2*Pk2*f**2*fdd*s**2 - 1044*D1**2*Pk2*f**2*fdd*s + 382*D1**2*Pk2*f**2*fdd - 420*D1**2*Pk2*f**2*gd2*r**2 - 2520*D1**2*Pk2*f**2*gd2*r*s + 840*D1**2*Pk2*f**2*gd2*r - 2520*D1**2*Pk2*f**2*gd2*s**2 + 2520*D1**2*Pk2*f**2*gd2*s - 420*D1**2*Pk2*f**2*gd2 + 420*D1**2*Pk2*f**2*gdd2*r**2 + 2520*D1**2*Pk2*f**2*gdd2*r*s - 840*D1**2*Pk2*f**2*gdd2*r + 2520*D1**2*Pk2*f**2*gdd2*s**2 - 2520*D1**2*Pk2*f**2*gdd2*s + 420*D1**2*Pk2*f**2*gdd2 + 780*D1**2*Pk2*f*fd**2*r**2 + 3240*D1**2*Pk2*f*fd**2*r*s - 1600*D1**2*Pk2*f*fd**2*r + 1512*D1**2*Pk2*f*fd**2*s**2 - 2088*D1**2*Pk2*f*fd**2*s + 540*D1**2*Pk2*f*fd**2 - 840*D1**2*Pk2*f*fd*g2*r**2 - 5040*D1**2*Pk2*f*fd*g2*r*s + 2520*D1**2*Pk2*f*fd*g2*r - 5040*D1**2*Pk2*f*fd*g2*s**2 + 5040*D1**2*Pk2*f*fd*g2*s - 2520*D1**2*Pk2*f*fd*g2 + 1680*D1**2*Pk2*f*fd*gd2*r**2 + 10080*D1**2*Pk2*f*fd*gd2*r*s - 4200*D1**2*Pk2*f*fd*gd2*r + 10080*D1**2*Pk2*f*fd*gd2*s**2 - 10080*D1**2*Pk2*f*fd*gd2*s + 2520*D1**2*Pk2*f*fd*gd2 + 840*D1**2*Pk2*f*fdd*g2*r**2 + 5040*D1**2*Pk2*f*fdd*g2*r*s - 2520*D1**2*Pk2*f*fdd*g2*r + 5040*D1**2*Pk2*f*fdd*g2*s**2 - 5040*D1**2*Pk2*f*fdd*g2*s + 2520*D1**2*Pk2*f*fdd*g2 + 840*D1**2*Pk2*fd**2*g2*r**2 + 5040*D1**2*Pk2*fd**2*g2*r*s - 2520*D1**2*Pk2*fd**2*g2*r + 5040*D1**2*Pk2*fd**2*g2*s**2 - 5040*D1**2*Pk2*fd**2*g2*s - 18*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 + 36*D1**2*Pkdd2*bd1*f**2*k1**2*s - 18*D1**2*Pkdd2*bd1*f**2*k1**2 + 36*D1**2*Pkdd2*bd1*f*fd*k1**2*s**2 - 36*D1**2*Pkdd2*bd1*f*fd*k1**2*s - 84*D1**2*Pkdd2*bd1*f*g2*k1**2*s**2 + 168*D1**2*Pkdd2*bd1*f*g2*k1**2*s - 84*D1**2*Pkdd2*bd1*f*g2*k1**2 + 84*D1**2*Pkdd2*bd1*f*gd2*k1**2*s**2 - 84*D1**2*Pkdd2*bd1*f*gd2*k1**2*s + 84*D1**2*Pkdd2*bd1*fd*g2*k1**2*s**2 - 84*D1**2*Pkdd2*bd1*fd*g2*k1**2*s + 9*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 18*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 9*D1**2*Pkdd2*bdd1*f**2*k1**2 + 42*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 84*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 42*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 27*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 18*D1**2*Pkdd2*f**2*fd*k1**2*s + 9*D1**2*Pkdd2*f**2*fd*k1**2 + 42*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 84*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 84*D1**2*Pkdd2*f*fd*g2*k1**2*s + 42*D1**2*Pkdd2*f*fd*g2*k1**2 - 1680*D1*Dd*K*Pk2*bd1*f**2*r**2 - 10080*D1*Dd*K*Pk2*bd1*f**2*r*s + 3780*D1*Dd*K*Pk2*bd1*f**2*r - 10080*D1*Dd*K*Pk2*bd1*f**2*s**2 + 10080*D1*Dd*K*Pk2*bd1*f**2*s - 2100*D1*Dd*K*Pk2*bd1*f**2 + 7200*D1*Dd*Pk2*bd1*f**2*r**2 + 9936*D1*Dd*Pk2*bd1*f**2*r*s - 11202*D1*Dd*Pk2*bd1*f**2*r + 1680*D1*Dd*Pk2*bd1*f**2*s**2 - 6264*D1*Dd*Pk2*bd1*f**2*s + 4020*D1*Dd*Pk2*bd1*f**2 + 26880*D1*Dd*Pk2*bd1*f*g2*r**2 + 47040*D1*Dd*Pk2*bd1*f*g2*r*s - 52920*D1*Dd*Pk2*bd1*f*g2*r + 16800*D1*Dd*Pk2*bd1*f*g2*s**2 - 49560*D1*Dd*Pk2*bd1*f*g2*s + 25200*D1*Dd*Pk2*bd1*f*g2 - 536*D1*Dd*Pk2*f**3*r**2 - 2160*D1*Dd*Pk2*f**3*r*s + 1076*D1*Dd*Pk2*f**3*r - 1008*D1*Dd*Pk2*f**3*s**2 + 1584*D1*Dd*Pk2*f**3*s - 520*D1*Dd*Pk2*f**3 + 3120*D1*Dd*Pk2*f**2*fd*r**2 + 12960*D1*Dd*Pk2*f**2*fd*r*s - 6380*D1*Dd*Pk2*f**2*fd*r + 6048*D1*Dd*Pk2*f**2*fd*s**2 - 8928*D1*Dd*Pk2*f**2*fd*s + 2644*D1*Dd*Pk2*f**2*fd - 1680*D1*Dd*Pk2*f**2*g2*r**2 - 10080*D1*Dd*Pk2*f**2*g2*r*s + 4200*D1*Dd*Pk2*f**2*g2*r - 10080*D1*Dd*Pk2*f**2*g2*s**2 + 10080*D1*Dd*Pk2*f**2*g2*s - 3360*D1*Dd*Pk2*f**2*g2 + 3360*D1*Dd*Pk2*f**2*gd2*r**2 + 20160*D1*Dd*Pk2*f**2*gd2*r*s - 7560*D1*Dd*Pk2*f**2*gd2*r + 20160*D1*Dd*Pk2*f**2*gd2*s**2 - 20160*D1*Dd*Pk2*f**2*gd2*s + 4200*D1*Dd*Pk2*f**2*gd2 + 6720*D1*Dd*Pk2*f*fd*g2*r**2 + 40320*D1*Dd*Pk2*f*fd*g2*r*s - 18480*D1*Dd*Pk2*f*fd*g2*r + 40320*D1*Dd*Pk2*f*fd*g2*s**2 - 40320*D1*Dd*Pk2*f*fd*g2*s + 10080*D1*Dd*Pk2*f*fd*g2 + 72*D1*Dd*Pkdd2*bd1*f**2*k1**2*s**2 - 90*D1*Dd*Pkdd2*bd1*f**2*k1**2*s + 18*D1*Dd*Pkdd2*bd1*f**2*k1**2 + 336*D1*Dd*Pkdd2*bd1*f*g2*k1**2*s**2 - 420*D1*Dd*Pkdd2*bd1*f*g2*k1**2*s + 84*D1*Dd*Pkdd2*bd1*f*g2*k1**2 + 36*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**3*k1**2*s + 9*D1*Dd*Pkdd2*f**3*k1**2 + 168*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 84*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 42*D1*Dd*Pkdd2*f**2*g2*k1**2 + 520*D1*Ddd*Pk2*f**3*r**2 + 2160*D1*Ddd*Pk2*f**3*r*s - 1060*D1*Ddd*Pk2*f**3*r + 1008*D1*Ddd*Pk2*f**3*s**2 - 1584*D1*Ddd*Pk2*f**3*s + 512*D1*Ddd*Pk2*f**3 + 1680*D1*Ddd*Pk2*f**2*g2*r**2 + 10080*D1*Ddd*Pk2*f**2*g2*r*s - 4200*D1*Ddd*Pk2*f**2*g2*r + 10080*D1*Ddd*Pk2*f**2*g2*s**2 - 10080*D1*Ddd*Pk2*f**2*g2*s + 3360*D1*Ddd*Pk2*f**2*g2 + 210*D1*Pk2*b2*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + 1560*Dd**2*Pk2*f**3*r**2 + 6480*Dd**2*Pk2*f**3*r*s - 3180*Dd**2*Pk2*f**3*r + 3024*Dd**2*Pk2*f**3*s**2 - 4752*Dd**2*Pk2*f**3*s + 1340*Dd**2*Pk2*f**3 + 5040*Dd**2*Pk2*f**2*g2*r**2 + 30240*Dd**2*Pk2*f**2*g2*r*s - 12600*Dd**2*Pk2*f**2*g2*r + 30240*Dd**2*Pk2*f**2*g2*s**2 - 30240*Dd**2*Pk2*f**2*g2*s + 5880*Dd**2*Pk2*f**2*g2 + 420*Pk2*b1**3*(D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(Dd*(-4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) + Ddd*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 21*b1**2*(-32*C*D1**2*Pk2*fd*r**2 - 64*C*D1**2*Pk2*fd*r*s + 64*C*D1**2*Pk2*fd*r - 32*C*D1**2*Pk2*fd*s**2 + 64*C*D1**2*Pk2*fd*s - 32*C*D1**2*Pk2*fd + 16*C*D1**2*Pk2*fdd*r**2 + 32*C*D1**2*Pk2*fdd*r*s - 32*C*D1**2*Pk2*fdd*r + 16*C*D1**2*Pk2*fdd*s**2 - 32*C*D1**2*Pk2*fdd*s + 16*C*D1**2*Pk2*fdd - 128*C*D1*Dd*Pk2*f*r**2 - 256*C*D1*Dd*Pk2*f*r*s + 192*C*D1*Dd*Pk2*f*r - 128*C*D1*Dd*Pk2*f*s**2 + 192*C*D1*Dd*Pk2*f*s - 96*C*D1*Dd*Pk2*f + 128*C*D1*Dd*Pk2*fd*r**2 + 256*C*D1*Dd*Pk2*fd*r*s - 224*C*D1*Dd*Pk2*fd*r + 128*C*D1*Dd*Pk2*fd*s**2 - 224*C*D1*Dd*Pk2*fd*s + 96*C*D1*Dd*Pk2*fd + 64*C*D1*Ddd*Pk2*f*r**2 + 128*C*D1*Ddd*Pk2*f*r*s - 96*C*D1*Ddd*Pk2*f*r + 64*C*D1*Ddd*Pk2*f*s**2 - 96*C*D1*Ddd*Pk2*f*s + 48*C*D1*Ddd*Pk2*f + 192*C*Dd**2*Pk2*f*r**2 + 384*C*Dd**2*Pk2*f*r*s - 288*C*Dd**2*Pk2*f*r + 192*C*Dd**2*Pk2*f*s**2 - 288*C*Dd**2*Pk2*f*s + 96*C*Dd**2*Pk2*f + 110*D1**2*K*Pk2*fd*r**2 + 140*D1**2*K*Pk2*fd*r*s - 20*D1**2*K*Pk2*fd*r + 30*D1**2*K*Pk2*fd*s**2 + 60*D1**2*K*Pk2*fd*s - 30*D1**2*K*Pk2*fd - 80*D1**2*K*Pk2*fdd*r**2 - 140*D1**2*K*Pk2*fdd*r*s - 60*D1**2*K*Pk2*fdd*r - 50*D1**2*K*Pk2*fdd*s**2 - 100*D1**2*K*Pk2*fdd*s + 50*D1**2*K*Pk2*fdd + 2*D1**2*K*Pkdd2*fd*k1**2*s**2 - D1**2*K*Pkdd2*fdd*k1**2*s**2 + 20*D1**2*Pk2*bdd1*(2*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(-3*r**2 - 3*r*(s - 1) + s - 1) - 3*r**2 - 3*r*s + 3*r + s - 1) - 60*D1**2*Pk2*f*fd*r**2 - 60*D1**2*Pk2*f*fd*r*s + 60*D1**2*Pk2*f*fd*r + 30*D1**2*Pk2*f*fd*s - 30*D1**2*Pk2*f*fd + 60*D1**2*Pk2*f*fdd*r**2 + 60*D1**2*Pk2*f*fdd*r*s - 60*D1**2*Pk2*f*fdd*r - 30*D1**2*Pk2*f*fdd*s + 30*D1**2*Pk2*f*fdd + 60*D1**2*Pk2*fd**2*r**2 + 60*D1**2*Pk2*fd**2*r*s - 60*D1**2*Pk2*fd**2*r - 30*D1**2*Pk2*fd**2*s + 14*D1**2*Pk2*fd*r**2 + 30*D1**2*Pk2*fd*r*s - 28*D1**2*Pk2*fd*r + 16*D1**2*Pk2*fd*s**2 - 40*D1**2*Pk2*fd*s + 24*D1**2*Pk2*fd + 8*D1**2*Pk2*fdd*r**2 + 10*D1**2*Pk2*fdd*r*s + 24*D1**2*Pk2*fdd*r - 8*D1**2*Pk2*fdd*s**2 + 20*D1**2*Pk2*fdd*s - 12*D1**2*Pk2*fdd + 160*D1**2*Pk2*gd2*r**2 + 320*D1**2*Pk2*gd2*r*s - 320*D1**2*Pk2*gd2*r + 160*D1**2*Pk2*gd2*s**2 - 320*D1**2*Pk2*gd2*s + 160*D1**2*Pk2*gd2 - 80*D1**2*Pk2*gdd2*r**2 - 160*D1**2*Pk2*gdd2*r*s + 160*D1**2*Pk2*gdd2*r - 80*D1**2*Pk2*gdd2*s**2 + 160*D1**2*Pk2*gdd2*s - 80*D1**2*Pk2*gdd2 + 6*D1**2*Pkdd2*f*fd*k1**2*s**2 + 440*D1*Dd*K*Pk2*f*r**2 + 560*D1*Dd*K*Pk2*f*r*s - 580*D1*Dd*K*Pk2*f*r + 120*D1*Dd*K*Pk2*f*s**2 - 340*D1*Dd*K*Pk2*f*s + 250*D1*Dd*K*Pk2*f - 640*D1*Dd*K*Pk2*fd*r**2 - 1120*D1*Dd*K*Pk2*fd*r*s + 220*D1*Dd*K*Pk2*fd*r - 400*D1*Dd*K*Pk2*fd*s**2 - 20*D1*Dd*K*Pk2*fd*s + 220*D1*Dd*K*Pk2*fd + 8*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 4*D1*Dd*K*Pkdd2*f*k1**2*s + 2*D1*Dd*K*Pkdd2*f*k1**2 - 8*D1*Dd*K*Pkdd2*fd*k1**2*s**2 + 2*D1*Dd*K*Pkdd2*fd*k1**2*s - 120*D1*Dd*Pk2*f**2*r**2 - 120*D1*Dd*Pk2*f**2*r*s + 150*D1*Dd*Pk2*f**2*r + 60*D1*Dd*Pk2*f**2*s - 60*D1*Dd*Pk2*f**2 + 480*D1*Dd*Pk2*f*fd*r**2 + 480*D1*Dd*Pk2*f*fd*r*s - 540*D1*Dd*Pk2*f*fd*r - 240*D1*Dd*Pk2*f*fd*s + 150*D1*Dd*Pk2*f*fd + 56*D1*Dd*Pk2*f*r**2 + 120*D1*Dd*Pk2*f*r*s - 86*D1*Dd*Pk2*f*r + 64*D1*Dd*Pk2*f*s**2 - 92*D1*Dd*Pk2*f*s + 44*D1*Dd*Pk2*f + 64*D1*Dd*Pk2*fd*r**2 + 80*D1*Dd*Pk2*fd*r*s + 54*D1*Dd*Pk2*fd*r - 64*D1*Dd*Pk2*fd*s**2 + 76*D1*Dd*Pk2*fd*s - 68*D1*Dd*Pk2*fd + 640*D1*Dd*Pk2*g2*r**2 + 1280*D1*Dd*Pk2*g2*r*s - 960*D1*Dd*Pk2*g2*r + 640*D1*Dd*Pk2*g2*s**2 - 960*D1*Dd*Pk2*g2*s + 480*D1*Dd*Pk2*g2 - 640*D1*Dd*Pk2*gd2*r**2 - 1280*D1*Dd*Pk2*gd2*r*s + 1120*D1*Dd*Pk2*gd2*r - 640*D1*Dd*Pk2*gd2*s**2 + 1120*D1*Dd*Pk2*gd2*s - 480*D1*Dd*Pk2*gd2 + 12*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 6*D1*Dd*Pkdd2*f**2*k1**2*s + 3*D1*Dd*Pkdd2*f**2*k1**2 - 320*D1*Ddd*K*Pk2*f*r**2 - 560*D1*Ddd*K*Pk2*f*r*s + 460*D1*Ddd*K*Pk2*f*r - 200*D1*Ddd*K*Pk2*f*s**2 + 380*D1*Ddd*K*Pk2*f*s - 210*D1*Ddd*K*Pk2*f - 4*D1*Ddd*K*Pkdd2*f*k1**2*s**2 + 2*D1*Ddd*K*Pkdd2*f*k1**2*s - D1*Ddd*K*Pkdd2*f*k1**2 + 120*D1*Ddd*Pk2*f**2*r**2 + 120*D1*Ddd*Pk2*f**2*r*s - 150*D1*Ddd*Pk2*f**2*r - 60*D1*Ddd*Pk2*f**2*s + 60*D1*Ddd*Pk2*f**2 + 32*D1*Ddd*Pk2*f*r**2 + 40*D1*Ddd*Pk2*f*r*s - 42*D1*Ddd*Pk2*f*r - 32*D1*Ddd*Pk2*f*s**2 - 4*D1*Ddd*Pk2*f*s + 8*D1*Ddd*Pk2*f - 320*D1*Ddd*Pk2*g2*r**2 - 640*D1*Ddd*Pk2*g2*r*s + 480*D1*Ddd*Pk2*g2*r - 320*D1*Ddd*Pk2*g2*s**2 + 480*D1*Ddd*Pk2*g2*s - 240*D1*Ddd*Pk2*g2 + 20*D1*Pk2*bd1*(D1*(-4*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) + Dd*(4*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) - 24*r**2 - 24*r*s + 27*r + 10*s - 7)) - 960*Dd**2*K*Pk2*f*r**2 - 1680*Dd**2*K*Pk2*f*r*s + 1380*Dd**2*K*Pk2*f*r - 600*Dd**2*K*Pk2*f*s**2 + 1140*Dd**2*K*Pk2*f*s - 440*Dd**2*K*Pk2*f - 12*Dd**2*K*Pkdd2*f*k1**2*s**2 + 6*Dd**2*K*Pkdd2*f*k1**2*s + 360*Dd**2*Pk2*f**2*r**2 + 360*Dd**2*Pk2*f**2*r*s - 450*Dd**2*Pk2*f**2*r - 180*Dd**2*Pk2*f**2*s + 120*Dd**2*Pk2*f**2 + 96*Dd**2*Pk2*f*r**2 + 120*Dd**2*Pk2*f*r*s - 126*Dd**2*Pk2*f*r - 96*Dd**2*Pk2*f*s**2 - 12*Dd**2*Pk2*f*s + 36*Dd**2*Pk2*f - 960*Dd**2*Pk2*g2*r**2 - 1920*Dd**2*Pk2*g2*r*s + 1440*Dd**2*Pk2*g2*r - 960*Dd**2*Pk2*g2*s**2 + 1440*Dd**2*Pk2*g2*s - 480*Dd**2*Pk2*g2) - 3*b1*(-224*C*D1**2*Pk2*bdd1*f*r**2 - 448*C*D1**2*Pk2*bdd1*f*r*s + 224*C*D1**2*Pk2*bdd1*f*r - 224*C*D1**2*Pk2*bdd1*f*s**2 + 224*C*D1**2*Pk2*bdd1*f*s - 112*C*D1**2*Pk2*bdd1*f - 744*C*D1**2*Pk2*f*fd*r**2 - 1168*C*D1**2*Pk2*f*fd*r*s + 672*C*D1**2*Pk2*f*fd*r - 168*C*D1**2*Pk2*f*fd*s**2 + 416*C*D1**2*Pk2*f*fd*s - 288*C*D1**2*Pk2*f*fd + 960*C*D1**2*Pk2*f*fdd*r**2 + 1424*C*D1**2*Pk2*f*fdd*r*s - 728*C*D1**2*Pk2*f*fdd*r + 280*C*D1**2*Pk2*f*fdd*s**2 - 432*C*D1**2*Pk2*f*fdd*s + 340*C*D1**2*Pk2*f*fdd + 960*C*D1**2*Pk2*fd**2*r**2 + 1424*C*D1**2*Pk2*fd**2*r*s - 728*C*D1**2*Pk2*fd**2*r + 280*C*D1**2*Pk2*fd**2*s**2 - 432*C*D1**2*Pk2*fd**2*s - 232*C*D1**2*Pk2*fd**2 - 24*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 12*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 12*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 1488*C*D1*Dd*Pk2*f**2*r**2 - 2336*C*D1*Dd*Pk2*f**2*r*s + 2072*C*D1*Dd*Pk2*f**2*r - 336*C*D1*Dd*Pk2*f**2*s**2 + 1336*C*D1*Dd*Pk2*f**2*s - 828*C*D1*Dd*Pk2*f**2 + 7680*C*D1*Dd*Pk2*f*fd*r**2 + 11392*C*D1*Dd*Pk2*f*fd*r*s - 8176*C*D1*Dd*Pk2*f*fd*r + 2240*C*D1*Dd*Pk2*f*fd*s**2 - 5136*C*D1*Dd*Pk2*f*fd*s + 1888*C*D1*Dd*Pk2*f*fd - 48*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 24*C*D1*Dd*Pkdd2*f**2*k1**2*s - 12*C*D1*Dd*Pkdd2*f**2*k1**2 + 96*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 24*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 1920*C*D1*Ddd*Pk2*f**2*r**2 + 2848*C*D1*Ddd*Pk2*f**2*r*s - 2632*C*D1*Ddd*Pk2*f**2*r + 560*C*D1*Ddd*Pk2*f**2*s**2 - 1704*C*D1*Ddd*Pk2*f**2*s + 1100*C*D1*Ddd*Pk2*f**2 + 24*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 12*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 6*C*D1*Ddd*Pkdd2*f**2*k1**2 + 5760*C*Dd**2*Pk2*f**2*r**2 + 8544*C*Dd**2*Pk2*f**2*r*s - 7896*C*Dd**2*Pk2*f**2*r + 1680*C*Dd**2*Pk2*f**2*s**2 - 5112*C*Dd**2*Pk2*f**2*s + 2384*C*Dd**2*Pk2*f**2 + 72*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 36*C*Dd**2*Pkdd2*f**2*k1**2*s + 1120*D1**2*K*Pk2*bdd1*f*r**2 + 1960*D1**2*K*Pk2*bdd1*f*r*s - 2520*D1**2*K*Pk2*bdd1*f*r + 700*D1**2*K*Pk2*bdd1*f*s**2 - 2380*D1**2*K*Pk2*bdd1*f*s + 1260*D1**2*K*Pk2*bdd1*f - 140*D1**2*K*Pk2*f*fd*r**2 - 840*D1**2*K*Pk2*f*fd*r*s + 420*D1**2*K*Pk2*f*fd*r - 840*D1**2*K*Pk2*f*fd*s**2 + 840*D1**2*K*Pk2*f*fd*s - 420*D1**2*K*Pk2*f*fd + 140*D1**2*K*Pk2*f*fdd*r**2 + 840*D1**2*K*Pk2*f*fdd*r*s - 420*D1**2*K*Pk2*f*fdd*r + 840*D1**2*K*Pk2*f*fdd*s**2 - 840*D1**2*K*Pk2*f*fdd*s + 420*D1**2*K*Pk2*f*fdd + 140*D1**2*K*Pk2*fd**2*r**2 + 840*D1**2*K*Pk2*fd**2*r*s - 420*D1**2*K*Pk2*fd**2*r + 840*D1**2*K*Pk2*fd**2*s**2 - 840*D1**2*K*Pk2*fd**2*s + 14*D1**2*K*Pkdd2*bdd1*f*k1**2*s**2 - 14*D1**2*K*Pkdd2*bdd1*f*k1**2*s + 7*D1**2*K*Pkdd2*bdd1*f*k1**2 + 14*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*K*Pkdd2*f*fd*k1**2*s + 7*D1**2*K*Pkdd2*f*fd*k1**2 - 210*D1**2*Pk2*b2*fd*r**2 - 420*D1**2*Pk2*b2*fd*r*s - 210*D1**2*Pk2*b2*fd*s**2 + 350*D1**2*Pk2*b2*fdd*r**2 + 700*D1**2*Pk2*b2*fdd*r*s + 350*D1**2*Pk2*b2*fdd*s**2 + 140*D1**2*Pk2*bd1**2*(-4*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*r**2 + 6*r*s - 6*r - 2*s + 1) - 420*D1**2*Pk2*bdd1*f**2*r**2 - 420*D1**2*Pk2*bdd1*f**2*r*s + 630*D1**2*Pk2*bdd1*f**2*r + 210*D1**2*Pk2*bdd1*f**2*s - 210*D1**2*Pk2*bdd1*f**2 - 112*D1**2*Pk2*bdd1*f*r**2 - 140*D1**2*Pk2*bdd1*f*r*s + 350*D1**2*Pk2*bdd1*f*r + 112*D1**2*Pk2*bdd1*f*s**2 + 98*D1**2*Pk2*bdd1*f*s - 84*D1**2*Pk2*bdd1*f + 1120*D1**2*Pk2*bdd1*g2*r**2 + 2240*D1**2*Pk2*bdd1*g2*r*s - 1120*D1**2*Pk2*bdd1*g2*r + 1120*D1**2*Pk2*bdd1*g2*s**2 - 1120*D1**2*Pk2*bdd1*g2*s + 560*D1**2*Pk2*bdd1*g2 + 350*D1**2*Pk2*bdd2*f*r**2 + 700*D1**2*Pk2*bdd2*f*r*s - 700*D1**2*Pk2*bdd2*f*r + 350*D1**2*Pk2*bdd2*f*s**2 - 700*D1**2*Pk2*bdd2*f*s + 350*D1**2*Pk2*bdd2*f + 416*D1**2*Pk2*f*fd*r**2 + 676*D1**2*Pk2*f*fd*r*s - 408*D1**2*Pk2*f*fd*r + 84*D1**2*Pk2*f*fd*s**2 - 254*D1**2*Pk2*f*fd*s + 166*D1**2*Pk2*f*fd - 600*D1**2*Pk2*f*fdd*r**2 - 828*D1**2*Pk2*f*fdd*r*s + 484*D1**2*Pk2*f*fdd*r - 140*D1**2*Pk2*f*fdd*s**2 + 274*D1**2*Pk2*f*fdd*s - 230*D1**2*Pk2*f*fdd + 1540*D1**2*Pk2*f*gd2*r**2 + 1960*D1**2*Pk2*f*gd2*r*s - 3080*D1**2*Pk2*f*gd2*r + 420*D1**2*Pk2*f*gd2*s**2 - 1960*D1**2*Pk2*f*gd2*s + 1540*D1**2*Pk2*f*gd2 - 1120*D1**2*Pk2*f*gdd2*r**2 - 1960*D1**2*Pk2*f*gdd2*r*s + 2240*D1**2*Pk2*f*gdd2*r - 700*D1**2*Pk2*f*gdd2*s**2 + 1960*D1**2*Pk2*f*gdd2*s - 1120*D1**2*Pk2*f*gdd2 - 600*D1**2*Pk2*fd**2*r**2 - 828*D1**2*Pk2*fd**2*r*s + 484*D1**2*Pk2*fd**2*r - 140*D1**2*Pk2*fd**2*s**2 + 274*D1**2*Pk2*fd**2*s + 116*D1**2*Pk2*fd**2 + 1540*D1**2*Pk2*fd*g2*r**2 + 1960*D1**2*Pk2*fd*g2*r*s - 280*D1**2*Pk2*fd*g2*r + 420*D1**2*Pk2*fd*g2*s**2 + 840*D1**2*Pk2*fd*g2*s - 420*D1**2*Pk2*fd*g2 - 2240*D1**2*Pk2*fd*gd2*r**2 - 3920*D1**2*Pk2*fd*gd2*r*s + 1400*D1**2*Pk2*fd*gd2*r - 1400*D1**2*Pk2*fd*gd2*s**2 + 560*D1**2*Pk2*fd*gd2*s + 840*D1**2*Pk2*fd*gd2 - 1120*D1**2*Pk2*fdd*g2*r**2 - 1960*D1**2*Pk2*fdd*g2*r*s - 840*D1**2*Pk2*fdd*g2*r - 700*D1**2*Pk2*fdd*g2*s**2 - 1400*D1**2*Pk2*fdd*g2*s + 700*D1**2*Pk2*fdd*g2 + 12*D1**2*Pkdd2*f*fd*k1**2*s**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 28*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s**2 + 28*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 28*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 280*D1*Dd*K*Pk2*f**2*r**2 - 1680*D1*Dd*K*Pk2*f**2*r*s + 700*D1*Dd*K*Pk2*f**2*r - 1680*D1*Dd*K*Pk2*f**2*s**2 + 1680*D1*Dd*K*Pk2*f**2*s - 560*D1*Dd*K*Pk2*f**2 + 1120*D1*Dd*K*Pk2*f*fd*r**2 + 6720*D1*Dd*K*Pk2*f*fd*r*s - 3080*D1*Dd*K*Pk2*f*fd*r + 6720*D1*Dd*K*Pk2*f*fd*s**2 - 6720*D1*Dd*K*Pk2*f*fd*s + 1680*D1*Dd*K*Pk2*f*fd + 28*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 14*D1*Dd*K*Pkdd2*f**2*k1**2*s + 7*D1*Dd*K*Pkdd2*f**2*k1**2 - 840*D1*Dd*Pk2*b2*f*r**2 - 1680*D1*Dd*Pk2*b2*f*r*s + 1260*D1*Dd*Pk2*b2*f*r - 840*D1*Dd*Pk2*b2*f*s**2 + 1260*D1*Dd*Pk2*b2*f*s - 630*D1*Dd*Pk2*b2*f + 2800*D1*Dd*Pk2*b2*fd*r**2 + 5600*D1*Dd*Pk2*b2*fd*r*s - 2100*D1*Dd*Pk2*b2*fd*r + 2800*D1*Dd*Pk2*b2*fd*s**2 - 2100*D1*Dd*Pk2*b2*fd*s + 832*D1*Dd*Pk2*f**2*r**2 + 1352*D1*Dd*Pk2*f**2*r*s - 1170*D1*Dd*Pk2*f**2*r + 168*D1*Dd*Pk2*f**2*s**2 - 760*D1*Dd*Pk2*f**2*s + 458*D1*Dd*Pk2*f**2 - 4800*D1*Dd*Pk2*f*fd*r**2 - 6624*D1*Dd*Pk2*f*fd*r*s + 5164*D1*Dd*Pk2*f*fd*r - 1120*D1*Dd*Pk2*f*fd*s**2 + 3032*D1*Dd*Pk2*f*fd*s - 1242*D1*Dd*Pk2*f*fd + 6160*D1*Dd*Pk2*f*g2*r**2 + 7840*D1*Dd*Pk2*f*g2*r*s - 8120*D1*Dd*Pk2*f*g2*r + 1680*D1*Dd*Pk2*f*g2*s**2 - 4760*D1*Dd*Pk2*f*g2*s + 3500*D1*Dd*Pk2*f*g2 - 8960*D1*Dd*Pk2*f*gd2*r**2 - 15680*D1*Dd*Pk2*f*gd2*r*s + 15400*D1*Dd*Pk2*f*gd2*r - 5600*D1*Dd*Pk2*f*gd2*s**2 + 13160*D1*Dd*Pk2*f*gd2*s - 6440*D1*Dd*Pk2*f*gd2 - 8960*D1*Dd*Pk2*fd*g2*r**2 - 15680*D1*Dd*Pk2*fd*g2*r*s + 3080*D1*Dd*Pk2*fd*g2*r - 5600*D1*Dd*Pk2*fd*g2*s**2 - 280*D1*Dd*Pk2*fd*g2*s + 3080*D1*Dd*Pk2*fd*g2 + 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 12*D1*Dd*Pkdd2*f**2*k1**2*s + 6*D1*Dd*Pkdd2*f**2*k1**2 - 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*Pkdd2*f*fd*k1**2*s + 112*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 56*D1*Dd*Pkdd2*f*g2*k1**2*s + 28*D1*Dd*Pkdd2*f*g2*k1**2 - 112*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 28*D1*Dd*Pkdd2*f*gd2*k1**2*s - 112*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 28*D1*Dd*Pkdd2*fd*g2*k1**2*s + 280*D1*Ddd*K*Pk2*f**2*r**2 + 1680*D1*Ddd*K*Pk2*f**2*r*s - 700*D1*Ddd*K*Pk2*f**2*r + 1680*D1*Ddd*K*Pk2*f**2*s**2 - 1680*D1*Ddd*K*Pk2*f**2*s + 560*D1*Ddd*K*Pk2*f**2 + 1400*D1*Ddd*Pk2*b2*f*r**2 + 2800*D1*Ddd*Pk2*b2*f*r*s - 2100*D1*Ddd*Pk2*b2*f*r + 1400*D1*Ddd*Pk2*b2*f*s**2 - 2100*D1*Ddd*Pk2*b2*f*s + 1050*D1*Ddd*Pk2*b2*f - 1200*D1*Ddd*Pk2*f**2*r**2 - 1656*D1*Ddd*Pk2*f**2*r*s + 1614*D1*Ddd*Pk2*f**2*r - 280*D1*Ddd*Pk2*f**2*s**2 + 968*D1*Ddd*Pk2*f**2*s - 670*D1*Ddd*Pk2*f**2 - 4480*D1*Ddd*Pk2*f*g2*r**2 - 7840*D1*Ddd*Pk2*f*g2*r*s + 6440*D1*Ddd*Pk2*f*g2*r - 2800*D1*Ddd*Pk2*f*g2*s**2 + 5320*D1*Ddd*Pk2*f*g2*s - 2940*D1*Ddd*Pk2*f*g2 - 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*D1*Ddd*Pkdd2*f**2*k1**2 - 56*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 28*D1*Ddd*Pkdd2*f*g2*k1**2*s - 14*D1*Ddd*Pkdd2*f*g2*k1**2 - 70*D1*Pk2*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 7*D1*bd1*(D1*(-2*K*Pkdd2*fd*k1**2*s*(1 - 2*s) - 2*Pk2*fd*(16*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 10*K*(16*r**2 + 4*r*(7*s - 3) + 10*s**2 - 7*s - 3) + 16*r**2 + 20*r*s - r - 16*s**2 + 13*s - 10) - 160*Pk2*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 160*Pk2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + f**2*(30*Pk2*(2*r - 1)*(r + s - 1) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 2*f*(K*Pkdd2*k1**2*(-2*s**2 + 2*s - 1) + Pk2*(16*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 110*K*r**2 - 140*K*r*s + 170*K*r - 30*K*s**2 + 130*K*s - 85*K - 15*fd*(2*r - 1)*(4*r + 4*s - 3) - 14*r**2 - 30*r*s + 15*r - 16*s**2 + 11*s - 3))) - 2*Dd*(15*Pk2*f**2*(2*r - 1)*(8*r + 8*s - 7) - 80*Pk2*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f*(K*Pkdd2*k1**2*(-8*s**2 + 6*s - 1) + Pk2*(16*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 10*K*(64*r**2 + 2*r*(56*s - 59) + 40*s**2 - 106*s + 53) + 64*r**2 + 80*r*s - 142*r - 64*s**2 - 32*s + 57)))) + 840*Dd**2*K*Pk2*f**2*r**2 + 5040*Dd**2*K*Pk2*f**2*r*s - 2100*Dd**2*K*Pk2*f**2*r + 5040*Dd**2*K*Pk2*f**2*s**2 - 5040*Dd**2*K*Pk2*f**2*s + 980*Dd**2*K*Pk2*f**2 + 4200*Dd**2*Pk2*b2*f*r**2 + 8400*Dd**2*Pk2*b2*f*r*s - 6300*Dd**2*Pk2*b2*f*r + 4200*Dd**2*Pk2*b2*f*s**2 - 6300*Dd**2*Pk2*b2*f*s + 2100*Dd**2*Pk2*b2*f - 3600*Dd**2*Pk2*f**2*r**2 - 4968*Dd**2*Pk2*f**2*r*s + 4842*Dd**2*Pk2*f**2*r - 840*Dd**2*Pk2*f**2*s**2 + 2904*Dd**2*Pk2*f**2*s - 1428*Dd**2*Pk2*f**2 - 13440*Dd**2*Pk2*f*g2*r**2 - 23520*Dd**2*Pk2*f*g2*r*s + 19320*Dd**2*Pk2*f*g2*r - 8400*Dd**2*Pk2*f*g2*s**2 + 15960*Dd**2*Pk2*f*g2*s - 6160*Dd**2*Pk2*f*g2 - 36*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*Dd**2*Pkdd2*f**2*k1**2*s - 168*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 84*Dd**2*Pkdd2*f*g2*k1**2*s))/(630*d**2*k3**4) + D1**2*Pk3*k2**2*(-D1*(-28*D1*Pk2*bd1**2*(f*(15*K*(r + s - 1)**2 - (2*C - 1)*(13*r**2 + 9*r*(2*s - 1) + s*(5*s - 5))) + 30*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*Pk2*bdd1*f*(-f*(2*C - 1)*(81*r**2 + 126*r*(s - 1) + 35*(s - 1)**2) + 210*g2*(r + s - 1)**2) + bd1*(D1*(-Pk2*f*fd*(8*C - 4)*(162*r**2 + 9*r*(28*s - 23) + 70*s**2 - 133*s + 63) + 840*Pk2*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1)) + f**2*(2*C - 1)*(2*Pk2*(99*r**2 + 126*r*(s - 1) + 35*(s - 1)**2) - 21*Pkdd2*k1**2*(s - 1)**2) + 70*f*(12*Pk2*gd2*(r + s - 1)**2 + g2*(-6*Pk2*(r + s - 1)**2 + Pkdd2*k1**2*(s - 1)**2))) - 4*Dd*Pk2*f*(f*(2*C - 1)*(324*r**2 + 9*r*(56*s - 53) + 140*s**2 - 301*s + 161) - 210*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) - 210*Pk2*b1**3*(D1*(Dd*(5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + Ddd*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 7*b1**2*(D1**2*(-5*K*Pkdd2*fd*k1**2*s**2 + 2*Pk2*fd*(2*C*(9*r**2 + 2*r*(17*s - 9) + 25*s**2 - 34*s + 9) + 15*K*s**2 + r**2*(15*K - 19) + r*(30*K*s - 44*s + 38) - 25*s**2 + 44*s - 19) + 2*Pk2*fdd*(2*C*(13*r**2 + 2*r*(9*s - 13) + 5*s**2 - 18*s + 13) - 15*K*s**2 - r**2*(15*K + 13) - r*s*(30*K + 18) + 26*r - 5*s**2 + 18*s - 13) - 30*Pk2*(-K*bdd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 10*gd2*(r + s - 1)**2 + 2*gdd2*(r + s - 1)**2)) + 30*D1*Pk2*bd1*(D1*(5*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 6*r**2 - 6*r*s + 6*r + 2*s - 2) + 2*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(-5*K*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + 2*Pk2*f*(2*C*(36*r**2 + 2*r*(68*s - 35) + 100*s**2 - 118*s + 43) + 15*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 76*r**2 - 176*r*s + 120*r - 100*s**2 + 138*s - 63) + 4*Pk2*fd*(2*C*(52*r**2 + r*(72*s - 87) + 20*s**2 - 59*s + 35) - 60*K*s**2 + 45*K*s - r**2*(60*K + 52) + r*(-120*K*s + 45*K - 72*s + 87) - 20*s**2 + 59*s - 35) - 60*Pk2*(5*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + 2*Ddd*Pk2*(f*(2*C*(52*r**2 + r*(72*s - 70) + 20*s**2 - 46*s + 31) - 15*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 52*r**2 - 72*r*s + 70*r - 20*s**2 + 46*s - 31) - 30*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + 4*Dd**2*Pk2*(f*(2*C*(78*r**2 + 3*r*(36*s - 35) + 30*s**2 - 69*s + 31) - 45*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 78*r**2 - 108*r*s + 105*r - 30*s**2 + 69*s - 31) - 90*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + b1*(-792*C*D1**2*Pk2*f*fd*r**2 - 1008*C*D1**2*Pk2*f*fd*r*s + 792*C*D1**2*Pk2*f*fd*r - 280*C*D1**2*Pk2*f*fd*s**2 + 504*C*D1**2*Pk2*f*fd*s - 396*C*D1**2*Pk2*f*fd + 648*C*D1**2*Pk2*f*fdd*r**2 + 1008*C*D1**2*Pk2*f*fdd*r*s - 648*C*D1**2*Pk2*f*fdd*r + 280*C*D1**2*Pk2*f*fdd*s**2 - 504*C*D1**2*Pk2*f*fdd*s + 324*C*D1**2*Pk2*f*fdd + 648*C*D1**2*Pk2*fd**2*r**2 + 1008*C*D1**2*Pk2*fd**2*r*s - 648*C*D1**2*Pk2*fd**2*r + 280*C*D1**2*Pk2*fd**2*s**2 - 504*C*D1**2*Pk2*fd**2*s + 84*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 1584*C*D1*Dd*Pk2*f**2*r**2 - 2016*C*D1*Dd*Pk2*f**2*r*s + 2088*C*D1*Dd*Pk2*f**2*r - 560*C*D1*Dd*Pk2*f**2*s**2 + 1288*C*D1*Dd*Pk2*f**2*s - 932*C*D1*Dd*Pk2*f**2 + 5184*C*D1*Dd*Pk2*f*fd*r**2 + 8064*C*D1*Dd*Pk2*f*fd*r*s - 6192*C*D1*Dd*Pk2*f*fd*r + 2240*C*D1*Dd*Pk2*f*fd*s**2 - 4592*C*D1*Dd*Pk2*f*fd*s + 1800*C*D1*Dd*Pk2*f*fd + 168*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 84*C*D1*Dd*Pkdd2*f**2*k1**2*s + 42*C*D1*Dd*Pkdd2*f**2*k1**2 + 1296*C*D1*Ddd*Pk2*f**2*r**2 + 2016*C*D1*Ddd*Pk2*f**2*r*s - 1800*C*D1*Ddd*Pk2*f**2*r + 560*C*D1*Ddd*Pk2*f**2*s**2 - 1288*C*D1*Ddd*Pk2*f**2*s + 788*C*D1*Ddd*Pk2*f**2 + 3888*C*Dd**2*Pk2*f**2*r**2 + 6048*C*Dd**2*Pk2*f**2*r*s - 5400*C*Dd**2*Pk2*f**2*r + 1680*C*Dd**2*Pk2*f**2*s**2 - 3864*C*Dd**2*Pk2*f**2*s + 1656*C*Dd**2*Pk2*f**2 - 420*D1**2*K*Pk2*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 14*D1**2*Pk2*bdd1*(f*(2*C*(26*r**2 + 36*r*s - 18*r + 10*s**2 - 10*s + 5) - 30*K*(r + s - 1)**2 - 26*r**2 - 36*r*s + 18*r - 10*s**2 + 10*s - 5) - 30*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 396*D1**2*Pk2*f*fd*r**2 + 504*D1**2*Pk2*f*fd*r*s - 396*D1**2*Pk2*f*fd*r + 140*D1**2*Pk2*f*fd*s**2 - 252*D1**2*Pk2*f*fd*s + 198*D1**2*Pk2*f*fd - 324*D1**2*Pk2*f*fdd*r**2 - 504*D1**2*Pk2*f*fdd*r*s + 324*D1**2*Pk2*f*fdd*r - 140*D1**2*Pk2*f*fdd*s**2 + 252*D1**2*Pk2*f*fdd*s - 162*D1**2*Pk2*f*fdd + 420*D1**2*Pk2*f*gd2*r**2 + 840*D1**2*Pk2*f*gd2*r*s - 840*D1**2*Pk2*f*gd2*r + 420*D1**2*Pk2*f*gd2*s**2 - 840*D1**2*Pk2*f*gd2*s + 420*D1**2*Pk2*f*gd2 - 420*D1**2*Pk2*f*gdd2*r**2 - 840*D1**2*Pk2*f*gdd2*r*s + 840*D1**2*Pk2*f*gdd2*r - 420*D1**2*Pk2*f*gdd2*s**2 + 840*D1**2*Pk2*f*gdd2*s - 420*D1**2*Pk2*f*gdd2 - 324*D1**2*Pk2*fd**2*r**2 - 504*D1**2*Pk2*fd**2*r*s + 324*D1**2*Pk2*fd**2*r - 140*D1**2*Pk2*fd**2*s**2 + 252*D1**2*Pk2*fd**2*s + 420*D1**2*Pk2*fd*g2*r**2 + 840*D1**2*Pk2*fd*g2*r*s + 420*D1**2*Pk2*fd*g2*s**2 - 840*D1**2*Pk2*fd*gd2*r**2 - 1680*D1**2*Pk2*fd*gd2*r*s + 840*D1**2*Pk2*fd*gd2*r - 840*D1**2*Pk2*fd*gd2*s**2 + 840*D1**2*Pk2*fd*gd2*s - 420*D1**2*Pk2*fdd*g2*r**2 - 840*D1**2*Pk2*fdd*g2*r*s - 420*D1**2*Pk2*fdd*g2*s**2 - 42*D1**2*Pkdd2*f*fd*k1**2*s**2 - 70*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 70*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 792*D1*Dd*Pk2*f**2*r**2 + 1008*D1*Dd*Pk2*f**2*r*s - 1044*D1*Dd*Pk2*f**2*r + 280*D1*Dd*Pk2*f**2*s**2 - 644*D1*Dd*Pk2*f**2*s + 466*D1*Dd*Pk2*f**2 - 2592*D1*Dd*Pk2*f*fd*r**2 - 4032*D1*Dd*Pk2*f*fd*r*s + 3096*D1*Dd*Pk2*f*fd*r - 1120*D1*Dd*Pk2*f*fd*s**2 + 2296*D1*Dd*Pk2*f*fd*s - 900*D1*Dd*Pk2*f*fd + 1680*D1*Dd*Pk2*f*g2*r**2 + 3360*D1*Dd*Pk2*f*g2*r*s - 2520*D1*Dd*Pk2*f*g2*r + 1680*D1*Dd*Pk2*f*g2*s**2 - 2520*D1*Dd*Pk2*f*g2*s + 1260*D1*Dd*Pk2*f*g2 - 3360*D1*Dd*Pk2*f*gd2*r**2 - 6720*D1*Dd*Pk2*f*gd2*r*s + 5880*D1*Dd*Pk2*f*gd2*r - 3360*D1*Dd*Pk2*f*gd2*s**2 + 5880*D1*Dd*Pk2*f*gd2*s - 2520*D1*Dd*Pk2*f*gd2 - 3360*D1*Dd*Pk2*fd*g2*r**2 - 6720*D1*Dd*Pk2*fd*g2*r*s + 2520*D1*Dd*Pk2*fd*g2*r - 3360*D1*Dd*Pk2*fd*g2*s**2 + 2520*D1*Dd*Pk2*fd*g2*s - 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 42*D1*Dd*Pkdd2*f**2*k1**2*s - 21*D1*Dd*Pkdd2*f**2*k1**2 - 280*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 140*D1*Dd*Pkdd2*f*g2*k1**2*s - 70*D1*Dd*Pkdd2*f*g2*k1**2 - 648*D1*Ddd*Pk2*f**2*r**2 - 1008*D1*Ddd*Pk2*f**2*r*s + 900*D1*Ddd*Pk2*f**2*r - 280*D1*Ddd*Pk2*f**2*s**2 + 644*D1*Ddd*Pk2*f**2*s - 394*D1*Ddd*Pk2*f**2 - 1680*D1*Ddd*Pk2*f*g2*r**2 - 3360*D1*Ddd*Pk2*f*g2*r*s + 2520*D1*Ddd*Pk2*f*g2*r - 1680*D1*Ddd*Pk2*f*g2*s**2 + 2520*D1*Ddd*Pk2*f*g2*s - 1260*D1*Ddd*Pk2*f*g2 - 7*D1*bd1*(D1*(-5*K*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + 2*Pk2*f*(2*C*(18*r**2 + 68*r*s - 34*r + 50*s**2 - 50*s + 25) + 30*K*(r + s - 1)**2 - 38*r**2 - 88*r*s + 44*r - 50*s**2 + 50*s - 25) + 4*Pk2*fd*(2*C*(26*r**2 + r*(36*s - 35) + 10*s**2 - 23*s + 9) - 30*K*s**2 + 30*K*s - r**2*(30*K + 26) + r*(-60*K*s + 30*K - 36*s + 35) - 10*s**2 + 23*s - 9) - 60*Pk2*(5*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + 4*Dd*Pk2*(f*(2*C*(104*r**2 + 2*r*(72*s - 53) + 40*s**2 - 66*s + 23) - 30*K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 104*r**2 - 144*r*s + 106*r - 40*s**2 + 66*s - 23) - 30*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 1944*Dd**2*Pk2*f**2*r**2 - 3024*Dd**2*Pk2*f**2*r*s + 2700*Dd**2*Pk2*f**2*r - 840*Dd**2*Pk2*f**2*s**2 + 1932*Dd**2*Pk2*f**2*s - 828*Dd**2*Pk2*f**2 - 5040*Dd**2*Pk2*f*g2*r**2 - 10080*Dd**2*Pk2*f*g2*r*s + 7560*Dd**2*Pk2*f*g2*r - 5040*Dd**2*Pk2*f*g2*s**2 + 7560*Dd**2*Pk2*f*g2*s - 2520*Dd**2*Pk2*f*g2))/(210*d**2*k3**4) + D1**2*Pk3*st**6*(96*C*D1**2*Pk2*f**2*fd*s**2 - 64*C*D1**2*Pk2*f**2*fd*s + 32*C*D1**2*Pk2*f**2*fd - 48*C*D1**2*Pk2*f**2*fdd*s**2 + 32*C*D1**2*Pk2*f**2*fdd*s - 16*C*D1**2*Pk2*f**2*fdd - 96*C*D1**2*Pk2*f*fd**2*s**2 + 64*C*D1**2*Pk2*f*fd**2*s + 128*C*D1*Dd*Pk2*f**3*s**2 - 64*C*D1*Dd*Pk2*f**3*s + 32*C*D1*Dd*Pk2*f**3 - 384*C*D1*Dd*Pk2*f**2*fd*s**2 + 224*C*D1*Dd*Pk2*f**2*fd*s - 32*C*D1*Dd*Pk2*f**2*fd - 64*C*D1*Ddd*Pk2*f**3*s**2 + 32*C*D1*Ddd*Pk2*f**3*s - 16*C*D1*Ddd*Pk2*f**3 - 192*C*Dd**2*Pk2*f**3*s**2 + 96*C*Dd**2*Pk2*f**3*s + 288*D1**2*K*Pk2*b1*f*fd*s**2 - 288*D1**2*K*Pk2*b1*f*fd*s + 144*D1**2*K*Pk2*b1*f*fd - 144*D1**2*K*Pk2*b1*f*fdd*s**2 + 144*D1**2*K*Pk2*b1*f*fdd*s - 72*D1**2*K*Pk2*b1*f*fdd - 144*D1**2*K*Pk2*b1*fd**2*s**2 + 144*D1**2*K*Pk2*b1*fd**2*s - 72*D1**2*K*Pk2*bdd1*f**2*s**2 + 216*D1**2*Pk2*b1*f**2*fd*r*s - 72*D1**2*Pk2*b1*f**2*fd*r - 72*D1**2*Pk2*b1*f**2*fd*s - 216*D1**2*Pk2*b1*f**2*fdd*r*s + 72*D1**2*Pk2*b1*f**2*fdd*r + 72*D1**2*Pk2*b1*f**2*fdd*s - 432*D1**2*Pk2*b1*f*fd**2*r*s + 144*D1**2*Pk2*b1*f*fd**2*r + 144*D1**2*Pk2*b1*f*fd**2*s - 72*D1**2*Pk2*b1*f*fd**2 + 288*D1**2*Pk2*b1*f*fd*r*s - 144*D1**2*Pk2*b1*f*fd*r - 144*D1**2*Pk2*b1*f*fdd*r*s + 72*D1**2*Pk2*b1*f*fdd*r - 144*D1**2*Pk2*b1*fd**2*r*s + 72*D1**2*Pk2*b1*fd**2*r + 144*D1**2*Pk2*bd2*f**2*s**2 - 288*D1**2*Pk2*bd2*f*fd*s**2 + 144*D1**2*Pk2*bd2*f*fd*s - 72*D1**2*Pk2*bdd1*f**3*r*s + 72*D1**2*Pk2*bdd1*f**3*s - 72*D1**2*Pk2*bdd1*f**2*r*s + 72*D1**2*Pk2*bdd1*f**2*s - 72*D1**2*Pk2*bdd2*f**2*s**2 + 48*D1**2*Pk2*f**2*fd*r*s - 16*D1**2*Pk2*f**2*fd*r - 48*D1**2*Pk2*f**2*fd*s**2 + 16*D1**2*Pk2*f**2*fd*s - 16*D1**2*Pk2*f**2*fd - 24*D1**2*Pk2*f**2*fdd*r*s + 8*D1**2*Pk2*f**2*fdd*r + 24*D1**2*Pk2*f**2*fdd*s**2 - 8*D1**2*Pk2*f**2*fdd*s + 8*D1**2*Pk2*f**2*fdd - 288*D1**2*Pk2*f**2*gd2*s**2 + 144*D1**2*Pk2*f**2*gdd2*s**2 - 48*D1**2*Pk2*f*fd**2*r*s + 16*D1**2*Pk2*f*fd**2*r + 48*D1**2*Pk2*f*fd**2*s**2 - 16*D1**2*Pk2*f*fd**2*s - 8*D1**2*Pk2*f*fd**2 - 576*D1**2*Pk2*f*fd*g2*s**2 + 576*D1**2*Pk2*f*fd*g2*s - 288*D1**2*Pk2*f*fd*g2 + 576*D1**2*Pk2*f*fd*gd2*s**2 - 288*D1**2*Pk2*f*fd*gd2*s + 288*D1**2*Pk2*f*fdd*g2*s**2 - 288*D1**2*Pk2*f*fdd*g2*s + 144*D1**2*Pk2*f*fdd*g2 + 288*D1**2*Pk2*fd**2*g2*s**2 - 288*D1**2*Pk2*fd**2*g2*s - 18*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 12*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 6*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 9*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 6*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 3*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 18*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 12*D1**2*Pkdd2*b1*f*fd**2*k1**2*s + 3*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 576*D1*Dd*K*Pk2*b1*f**2*s**2 - 288*D1*Dd*K*Pk2*b1*f**2*s + 144*D1*Dd*K*Pk2*b1*f**2 - 1152*D1*Dd*K*Pk2*b1*f*fd*s**2 + 864*D1*Dd*K*Pk2*b1*f*fd*s - 144*D1*Dd*K*Pk2*b1*f*fd + 288*D1*Dd*Pk2*b1*f**3*r*s - 72*D1*Dd*Pk2*b1*f**3*r - 144*D1*Dd*Pk2*b1*f**3*s - 1728*D1*Dd*Pk2*b1*f**2*fd*r*s + 504*D1*Dd*Pk2*b1*f**2*fd*r + 720*D1*Dd*Pk2*b1*f**2*fd*s - 216*D1*Dd*Pk2*b1*f**2*fd + 576*D1*Dd*Pk2*b1*f**2*r*s - 144*D1*Dd*Pk2*b1*f**2*r - 288*D1*Dd*Pk2*b1*f**2*s - 1152*D1*Dd*Pk2*b1*f*fd*r*s + 432*D1*Dd*Pk2*b1*f*fd*r + 288*D1*Dd*Pk2*b1*f*fd*s - 144*D1*Dd*Pk2*b1*f*fd - 576*D1*Dd*Pk2*bd2*f**2*s**2 + 144*D1*Dd*Pk2*bd2*f**2*s + 64*D1*Dd*Pk2*f**3*r*s - 16*D1*Dd*Pk2*f**3*r - 64*D1*Dd*Pk2*f**3*s**2 - 16*D1*Dd*Pk2*f**3 - 192*D1*Dd*Pk2*f**2*fd*r*s + 56*D1*Dd*Pk2*f**2*fd*r + 192*D1*Dd*Pk2*f**2*fd*s**2 - 32*D1*Dd*Pk2*f**2*fd*s - 8*D1*Dd*Pk2*f**2*fd - 1152*D1*Dd*Pk2*f**2*g2*s**2 + 576*D1*Dd*Pk2*f**2*g2*s - 288*D1*Dd*Pk2*f**2*g2 + 1152*D1*Dd*Pk2*f**2*gd2*s**2 - 288*D1*Dd*Pk2*f**2*gd2*s + 2304*D1*Dd*Pk2*f*fd*g2*s**2 - 1728*D1*Dd*Pk2*f*fd*g2*s + 288*D1*Dd*Pk2*f*fd*g2 - 24*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 12*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 6*D1*Dd*Pkdd2*b1*f**3*k1**2 + 72*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 42*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 6*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 288*D1*Ddd*K*Pk2*b1*f**2*s**2 + 144*D1*Ddd*K*Pk2*b1*f**2*s - 72*D1*Ddd*K*Pk2*b1*f**2 - 288*D1*Ddd*Pk2*b1*f**3*r*s + 72*D1*Ddd*Pk2*b1*f**3*r + 144*D1*Ddd*Pk2*b1*f**3*s - 288*D1*Ddd*Pk2*b1*f**2*r*s + 72*D1*Ddd*Pk2*b1*f**2*r + 144*D1*Ddd*Pk2*b1*f**2*s - 32*D1*Ddd*Pk2*f**3*r*s + 8*D1*Ddd*Pk2*f**3*r + 32*D1*Ddd*Pk2*f**3*s**2 + 8*D1*Ddd*Pk2*f**3 + 576*D1*Ddd*Pk2*f**2*g2*s**2 - 288*D1*Ddd*Pk2*f**2*g2*s + 144*D1*Ddd*Pk2*f**2*g2 + 12*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 6*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 3*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 6*D1*bd1*f*(-D1*(f*s*(-12*Pk2*(2*K*s + f*(r - 1) + 2*r - 2) + Pkdd2*f*k1**2*s) + fd*(12*Pk2*(f*r*(6*s - 1) - 4*f*s + f + r*(4*s - 1) + (2*s - 1)*(2*K*s - 1)) + Pkdd2*f*k1**2*s*(1 - 3*s))) + Dd*f*(-12*Pk2*(8*K*s**2 - 2*K*s + f*r*(8*s - 1) - 6*f*s + f + r*(8*s - 1) - 6*s + 1) + Pkdd2*f*k1**2*s*(4*s - 1))) - 864*Dd**2*K*Pk2*b1*f**2*s**2 + 432*Dd**2*K*Pk2*b1*f**2*s - 864*Dd**2*Pk2*b1*f**3*r*s + 216*Dd**2*Pk2*b1*f**3*r + 432*Dd**2*Pk2*b1*f**3*s - 144*Dd**2*Pk2*b1*f**3 - 864*Dd**2*Pk2*b1*f**2*r*s + 216*Dd**2*Pk2*b1*f**2*r + 432*Dd**2*Pk2*b1*f**2*s - 144*Dd**2*Pk2*b1*f**2 - 96*Dd**2*Pk2*f**3*r*s + 24*Dd**2*Pk2*f**3*r + 96*Dd**2*Pk2*f**3*s**2 - 16*Dd**2*Pk2*f**3 + 1728*Dd**2*Pk2*f**2*g2*s**2 - 864*Dd**2*Pk2*f**2*g2*s + 36*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 18*Dd**2*Pkdd2*b1*f**3*k1**2*s + 72*Pk2*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(126*d**2*k3**2) + D1**2*Pk3*st**4*(12*C*D1**2*Pk2*bdd1*f**2*r**2 - 48*C*D1**2*Pk2*bdd1*f**2*r*s - 240*C*D1**2*Pk2*f**2*fd*r*s + 80*C*D1**2*Pk2*f**2*fd*r - 396*C*D1**2*Pk2*f**2*fd*s**2 + 344*C*D1**2*Pk2*f**2*fd*s - 132*C*D1**2*Pk2*f**2*fd + 336*C*D1**2*Pk2*f**2*fdd*r*s - 112*C*D1**2*Pk2*f**2*fdd*r + 324*C*D1**2*Pk2*f**2*fdd*s**2 - 328*C*D1**2*Pk2*f**2*fdd*s + 108*C*D1**2*Pk2*f**2*fdd + 672*C*D1**2*Pk2*f*fd**2*r*s - 224*C*D1**2*Pk2*f*fd**2*r + 648*C*D1**2*Pk2*f*fd**2*s**2 - 656*C*D1**2*Pk2*f*fd**2*s + 112*C*D1**2*Pk2*f*fd**2 + 12*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 8*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 4*C*D1**2*Pkdd2*f**2*fd*k1**2 - 6*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 4*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 2*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 12*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 8*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 320*C*D1*Dd*Pk2*f**3*r*s + 80*C*D1*Dd*Pk2*f**3*r - 528*C*D1*Dd*Pk2*f**3*s**2 + 424*C*D1*Dd*Pk2*f**3*s - 132*C*D1*Dd*Pk2*f**3 + 2688*C*D1*Dd*Pk2*f**2*fd*r*s - 784*C*D1*Dd*Pk2*f**2*fd*r + 2592*C*D1*Dd*Pk2*f**2*fd*s**2 - 2632*C*D1*Dd*Pk2*f**2*fd*s + 552*C*D1*Dd*Pk2*f**2*fd + 16*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 8*C*D1*Dd*Pkdd2*f**3*k1**2*s + 4*C*D1*Dd*Pkdd2*f**3*k1**2 - 48*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 28*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 4*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 448*C*D1*Ddd*Pk2*f**3*r*s - 112*C*D1*Ddd*Pk2*f**3*r + 432*C*D1*Ddd*Pk2*f**3*s**2 - 440*C*D1*Ddd*Pk2*f**3*s + 108*C*D1*Ddd*Pk2*f**3 - 8*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 4*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 2*C*D1*Ddd*Pkdd2*f**3*k1**2 + 1344*C*Dd**2*Pk2*f**3*r*s - 336*C*Dd**2*Pk2*f**3*r + 1296*C*Dd**2*Pk2*f**3*s**2 - 1320*C*Dd**2*Pk2*f**3*s + 224*C*Dd**2*Pk2*f**3 - 24*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 12*C*Dd**2*Pkdd2*f**3*k1**2*s + 168*D1**2*K*Pk2*bdd1*f**2*r*s + 378*D1**2*K*Pk2*bdd1*f**2*s**2 - 168*D1**2*K*Pk2*bdd1*f**2*s - 3*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 336*D1**2*Pk2*b2*f*fd*r*s + 168*D1**2*Pk2*b2*f*fd*r - 924*D1**2*Pk2*b2*f*fd*s**2 + 924*D1**2*Pk2*b2*f*fd*s - 462*D1**2*Pk2*b2*f*fd + 336*D1**2*Pk2*b2*f*fdd*r*s - 168*D1**2*Pk2*b2*f*fdd*r + 756*D1**2*Pk2*b2*f*fdd*s**2 - 756*D1**2*Pk2*b2*f*fdd*s + 378*D1**2*Pk2*b2*f*fdd + 336*D1**2*Pk2*b2*fd**2*r*s - 168*D1**2*Pk2*b2*fd**2*r + 756*D1**2*Pk2*b2*fd**2*s**2 - 756*D1**2*Pk2*b2*fd**2*s - 168*D1**2*Pk2*bd2*f**2*r*s - 462*D1**2*Pk2*bd2*f**2*s**2 + 168*D1**2*Pk2*bd2*f**2*s + 672*D1**2*Pk2*bd2*f*fd*r*s - 168*D1**2*Pk2*bd2*f*fd*r + 1512*D1**2*Pk2*bd2*f*fd*s**2 - 1092*D1**2*Pk2*bd2*f*fd*s + 168*D1**2*Pk2*bd2*f*fd + 126*D1**2*Pk2*bdd1*f**3*r**2 + 210*D1**2*Pk2*bdd1*f**3*r*s - 168*D1**2*Pk2*bdd1*f**3*r - 210*D1**2*Pk2*bdd1*f**3*s + 84*D1**2*Pk2*bdd1*f**3 + 72*D1**2*Pk2*bdd1*f**2*r**2 + 234*D1**2*Pk2*bdd1*f**2*r*s - 156*D1**2*Pk2*bdd1*f**2*r - 210*D1**2*Pk2*bdd1*f**2*s + 84*D1**2*Pk2*bdd1*f**2 - 84*D1**2*Pk2*bdd1*f*g2*r**2 + 336*D1**2*Pk2*bdd1*f*g2*r*s + 168*D1**2*Pk2*bdd2*f**2*r*s + 378*D1**2*Pk2*bdd2*f**2*s**2 - 168*D1**2*Pk2*bdd2*f**2*s - 60*D1**2*Pk2*f**2*fd*r**2 - 54*D1**2*Pk2*f**2*fd*r*s + 58*D1**2*Pk2*f**2*fd*r + 198*D1**2*Pk2*f**2*fd*s**2 - 114*D1**2*Pk2*f**2*fd*s + 46*D1**2*Pk2*f**2*fd + 84*D1**2*Pk2*f**2*fdd*r**2 - 54*D1**2*Pk2*f**2*fdd*r*s - 38*D1**2*Pk2*f**2*fdd*r - 162*D1**2*Pk2*f**2*fdd*s**2 + 126*D1**2*Pk2*f**2*fdd*s - 26*D1**2*Pk2*f**2*fdd + 336*D1**2*Pk2*f**2*gd2*r*s + 924*D1**2*Pk2*f**2*gd2*s**2 - 336*D1**2*Pk2*f**2*gd2*s - 336*D1**2*Pk2*f**2*gdd2*r*s - 756*D1**2*Pk2*f**2*gdd2*s**2 + 336*D1**2*Pk2*f**2*gdd2*s + 168*D1**2*Pk2*f*fd**2*r**2 - 108*D1**2*Pk2*f*fd**2*r*s - 76*D1**2*Pk2*f*fd**2*r - 324*D1**2*Pk2*f*fd**2*s**2 + 252*D1**2*Pk2*f*fd**2*s - 18*D1**2*Pk2*f*fd**2 + 672*D1**2*Pk2*f*fd*g2*r*s - 336*D1**2*Pk2*f*fd*g2*r + 1848*D1**2*Pk2*f*fd*g2*s**2 - 1848*D1**2*Pk2*f*fd*g2*s + 924*D1**2*Pk2*f*fd*g2 - 1344*D1**2*Pk2*f*fd*gd2*r*s + 336*D1**2*Pk2*f*fd*gd2*r - 3024*D1**2*Pk2*f*fd*gd2*s**2 + 2184*D1**2*Pk2*f*fd*gd2*s - 336*D1**2*Pk2*f*fd*gd2 - 672*D1**2*Pk2*f*fdd*g2*r*s + 336*D1**2*Pk2*f*fdd*g2*r - 1512*D1**2*Pk2*f*fdd*g2*s**2 + 1512*D1**2*Pk2*f*fdd*g2*s - 756*D1**2*Pk2*f*fdd*g2 - 672*D1**2*Pk2*fd**2*g2*r*s + 336*D1**2*Pk2*fd**2*g2*r - 1512*D1**2*Pk2*fd**2*g2*s**2 + 1512*D1**2*Pk2*fd**2*g2*s + 12*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 - 12*D1**2*Pkdd2*b2*f*fd*k1**2*s + 6*D1**2*Pkdd2*b2*f*fd*k1**2 - 6*D1**2*Pkdd2*b2*f*fdd*k1**2*s**2 + 6*D1**2*Pkdd2*b2*f*fdd*k1**2*s - 3*D1**2*Pkdd2*b2*f*fdd*k1**2 - 6*D1**2*Pkdd2*b2*fd**2*k1**2*s**2 + 6*D1**2*Pkdd2*b2*fd**2*k1**2*s + 6*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 - 12*D1**2*Pkdd2*bd2*f*fd*k1**2*s**2 + 6*D1**2*Pkdd2*bd2*f*fd*k1**2*s - 3*D1**2*Pkdd2*bdd2*f**2*k1**2*s**2 - 6*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 4*D1**2*Pkdd2*f**2*fd*k1**2*s - 2*D1**2*Pkdd2*f**2*fd*k1**2 + 3*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 2*D1**2*Pkdd2*f**2*fdd*k1**2*s + D1**2*Pkdd2*f**2*fdd*k1**2 - 12*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 6*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 6*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 4*D1**2*Pkdd2*f*fd**2*k1**2*s - 24*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 24*D1**2*Pkdd2*f*fd*g2*k1**2*s - 12*D1**2*Pkdd2*f*fd*g2*k1**2 + 24*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 12*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 12*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 12*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 6*D1**2*Pkdd2*f*fdd*g2*k1**2 + 12*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 12*D1**2*Pkdd2*fd**2*g2*k1**2*s + 6*D1**2*bd1**2*f*(14*Pk2*(2*K*s + f*(r - 1) + r**2*(K - 1) - r*(4*K*s + K - 2) - 1) + Pkdd2*f*k1**2*s*(2*s - 3)) - 672*D1*Dd*Pk2*b2*f**2*r*s + 168*D1*Dd*Pk2*b2*f**2*r - 1848*D1*Dd*Pk2*b2*f**2*s**2 + 1260*D1*Dd*Pk2*b2*f**2*s - 462*D1*Dd*Pk2*b2*f**2 + 2688*D1*Dd*Pk2*b2*f*fd*r*s - 1008*D1*Dd*Pk2*b2*f*fd*r + 6048*D1*Dd*Pk2*b2*f*fd*s**2 - 5208*D1*Dd*Pk2*b2*f*fd*s + 1092*D1*Dd*Pk2*b2*f*fd + 1344*D1*Dd*Pk2*bd2*f**2*r*s - 168*D1*Dd*Pk2*bd2*f**2*r + 3024*D1*Dd*Pk2*bd2*f**2*s**2 - 1764*D1*Dd*Pk2*bd2*f**2*s + 168*D1*Dd*Pk2*bd2*f**2 - 80*D1*Dd*Pk2*f**3*r**2 - 72*D1*Dd*Pk2*f**3*r*s + 98*D1*Dd*Pk2*f**3*r + 264*D1*Dd*Pk2*f**3*s**2 - 96*D1*Dd*Pk2*f**3*s + 26*D1*Dd*Pk2*f**3 + 672*D1*Dd*Pk2*f**2*fd*r**2 - 432*D1*Dd*Pk2*f**2*fd*r*s - 434*D1*Dd*Pk2*f**2*fd*r - 1296*D1*Dd*Pk2*f**2*fd*s**2 + 936*D1*Dd*Pk2*f**2*fd*s - 50*D1*Dd*Pk2*f**2*fd + 1344*D1*Dd*Pk2*f**2*g2*r*s - 336*D1*Dd*Pk2*f**2*g2*r + 3696*D1*Dd*Pk2*f**2*g2*s**2 - 2520*D1*Dd*Pk2*f**2*g2*s + 924*D1*Dd*Pk2*f**2*g2 - 2688*D1*Dd*Pk2*f**2*gd2*r*s + 336*D1*Dd*Pk2*f**2*gd2*r - 6048*D1*Dd*Pk2*f**2*gd2*s**2 + 3528*D1*Dd*Pk2*f**2*gd2*s - 336*D1*Dd*Pk2*f**2*gd2 - 5376*D1*Dd*Pk2*f*fd*g2*r*s + 2016*D1*Dd*Pk2*f*fd*g2*r - 12096*D1*Dd*Pk2*f*fd*g2*s**2 + 10416*D1*Dd*Pk2*f*fd*g2*s - 2184*D1*Dd*Pk2*f*fd*g2 + 24*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 - 12*D1*Dd*Pkdd2*b2*f**2*k1**2*s + 6*D1*Dd*Pkdd2*b2*f**2*k1**2 - 48*D1*Dd*Pkdd2*b2*f*fd*k1**2*s**2 + 36*D1*Dd*Pkdd2*b2*f*fd*k1**2*s - 6*D1*Dd*Pkdd2*b2*f*fd*k1**2 - 24*D1*Dd*Pkdd2*bd2*f**2*k1**2*s**2 + 6*D1*Dd*Pkdd2*bd2*f**2*k1**2*s - 8*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 4*D1*Dd*Pkdd2*f**3*k1**2*s - 2*D1*Dd*Pkdd2*f**3*k1**2 + 24*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 14*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 2*D1*Dd*Pkdd2*f**2*fd*k1**2 - 48*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 24*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 12*D1*Dd*Pkdd2*f**2*g2*k1**2 + 48*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 12*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 96*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 72*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 12*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 672*D1*Ddd*Pk2*b2*f**2*r*s - 168*D1*Ddd*Pk2*b2*f**2*r + 1512*D1*Ddd*Pk2*b2*f**2*s**2 - 1092*D1*Ddd*Pk2*b2*f**2*s + 378*D1*Ddd*Pk2*b2*f**2 + 112*D1*Ddd*Pk2*f**3*r**2 - 72*D1*Ddd*Pk2*f**3*r*s - 94*D1*Ddd*Pk2*f**3*r - 216*D1*Ddd*Pk2*f**3*s**2 + 144*D1*Ddd*Pk2*f**3*s + 2*D1*Ddd*Pk2*f**3 - 1344*D1*Ddd*Pk2*f**2*g2*r*s + 336*D1*Ddd*Pk2*f**2*g2*r - 3024*D1*Ddd*Pk2*f**2*g2*s**2 + 2184*D1*Ddd*Pk2*f**2*g2*s - 756*D1*Ddd*Pk2*f**2*g2 - 12*D1*Ddd*Pkdd2*b2*f**2*k1**2*s**2 + 6*D1*Ddd*Pkdd2*b2*f**2*k1**2*s - 3*D1*Ddd*Pkdd2*b2*f**2*k1**2 + 4*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 2*D1*Ddd*Pkdd2*f**3*k1**2*s + D1*Ddd*Pkdd2*f**3*k1**2 + 24*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 12*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 6*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 3*D1*bd1*(D1*(56*Pk2*fd*g2*r*(r - 4*s + 2) + f**3*(14*Pk2*(3*r**2 + r*(5*s - 4) - 5*s + 2) - 3*Pkdd2*k1**2*s**2) - 2*f**2*(K*Pkdd2*k1**2*s**2 + Pk2*(-77*K*s**2 + 7*fd*(18*r**2 + 5*r*(6*s - 5) - 20*s + 9) - r**2*(4*C + 10) + r*s*(16*C - 28*K - 57) + 24*r + s*(28*K + 49) - 14)) - 2*f*(28*Pk2*(g2*r*(r - 4*s) + gd2*(-r**2 + 4*r*s + r - 2*s)) + fd*(K*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*(8*C*s + 14*K*(r*(8*s - 2) + 18*s**2 - 13*s + 2) + r**2*(8*C + 48) + r*(-32*C*s + 4*C + 156*s - 89) - 74*s + 33)))) - 2*Dd*f*(7*Pk2*f**2*(24*r**2 + r*(40*s - 33) - 30*s + 13) - 112*Pk2*g2*(r**2 - 4*r*s + s) + f*(K*Pkdd2*k1**2*s*(1 - 4*s) + Pk2*(16*C*s + 14*K*(2*r*(8*s - 1) + 36*s**2 - 21*s + 2) + r**2*(16*C + 96) + r*(-64*C*s + 312*s - 191) - 218*s + 87)))) + 2016*Dd**2*Pk2*b2*f**2*r*s - 504*Dd**2*Pk2*b2*f**2*r + 4536*Dd**2*Pk2*b2*f**2*s**2 - 3276*Dd**2*Pk2*b2*f**2*s + 336*Dd**2*Pk2*b2*f**2 + 336*Dd**2*Pk2*f**3*r**2 - 216*Dd**2*Pk2*f**3*r*s - 282*Dd**2*Pk2*f**3*r - 648*Dd**2*Pk2*f**3*s**2 + 432*Dd**2*Pk2*f**3*s + 20*Dd**2*Pk2*f**3 - 4032*Dd**2*Pk2*f**2*g2*r*s + 1008*Dd**2*Pk2*f**2*g2*r - 9072*Dd**2*Pk2*f**2*g2*s**2 + 6552*Dd**2*Pk2*f**2*g2*s - 672*Dd**2*Pk2*f**2*g2 - 36*Dd**2*Pkdd2*b2*f**2*k1**2*s**2 + 18*Dd**2*Pkdd2*b2*f**2*k1**2*s + 12*Dd**2*Pkdd2*f**3*k1**2*s**2 - 6*Dd**2*Pkdd2*f**3*k1**2*s + 72*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 36*Dd**2*Pkdd2*f**2*g2*k1**2*s + 3*b1**2*(D1**2*(-28*Pk2*fd**2*(r - 1) - 28*Pk2*fd*r*(K*(r - 4*s + 4) - r - 2) + 14*Pk2*fdd*r*(K*(r - 4*s + 4) - r - 2) + 2*Pkdd2*fd**2*k1**2*s*(2*s + 1) + 2*f*fd*(14*Pk2*r + Pkdd2*k1**2*(-4*s**2 - 2*s + 1)) + f*fdd*(-28*Pk2*r + Pkdd2*k1**2*(4*s**2 + 2*s - 1))) - 2*D1*Dd*(-28*Pk2*fd*(2*K*(r**2 - 4*r*s + 2*r + s - 1) - 2*r**2 - r + 1) + 2*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + f*(28*Pk2*(2*K*r**2 - 8*K*r*s + 4*K*s + K + 2*fd*r - fd - 2*r**2 + 2*r - 1) + Pkdd2*fd*k1**2*(1 - 16*s**2))) + 2*D1*Ddd*f*(14*Pk2*(2*K*r**2 - 8*K*r*s + 4*K*s + K - 2*r**2 + 2*r - 1) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) + 4*Dd**2*f*(7*Pk2*(3*K*(2*r**2 - 8*r*s + 4*s - 1) - 6*r**2 + 6*r - 1) + 3*Pkdd2*f*k1**2*s*(2*s - 1))) - 3*b1*(16*C*D1**2*Pk2*f*fd*r**2 - 64*C*D1**2*Pk2*f*fd*r*s + 16*C*D1**2*Pk2*f*fd*r + 32*C*D1**2*Pk2*f*fd*s + 8*C*D1**2*Pk2*f*fd - 8*C*D1**2*Pk2*f*fdd*r**2 + 32*C*D1**2*Pk2*f*fdd*r*s - 8*C*D1**2*Pk2*f*fdd*r - 16*C*D1**2*Pk2*f*fdd*s - 4*C*D1**2*Pk2*f*fdd - 8*C*D1**2*Pk2*fd**2*r**2 + 32*C*D1**2*Pk2*fd**2*r*s - 8*C*D1**2*Pk2*fd**2*r - 16*C*D1**2*Pk2*fd**2*s + 16*C*D1**2*Pk2*fd**2 + 32*C*D1*Dd*Pk2*f**2*r**2 - 128*C*D1*Dd*Pk2*f**2*r*s + 64*C*D1*Dd*Pk2*f**2*s + 16*C*D1*Dd*Pk2*f**2 - 64*C*D1*Dd*Pk2*f*fd*r**2 + 256*C*D1*Dd*Pk2*f*fd*r*s - 32*C*D1*Dd*Pk2*f*fd*r - 128*C*D1*Dd*Pk2*f*fd*s + 32*C*D1*Dd*Pk2*f*fd - 16*C*D1*Ddd*Pk2*f**2*r**2 + 64*C*D1*Ddd*Pk2*f**2*r*s - 32*C*D1*Ddd*Pk2*f**2*s - 8*C*D1*Ddd*Pk2*f**2 - 48*C*Dd**2*Pk2*f**2*r**2 + 192*C*Dd**2*Pk2*f**2*r*s - 96*C*Dd**2*Pk2*f**2*s + 24*C*Dd**2*Pk2*f**2 + 112*D1**2*K*Pk2*f*fd*r*s - 56*D1**2*K*Pk2*f*fd*r + 308*D1**2*K*Pk2*f*fd*s**2 - 308*D1**2*K*Pk2*f*fd*s + 154*D1**2*K*Pk2*f*fd - 112*D1**2*K*Pk2*f*fdd*r*s + 56*D1**2*K*Pk2*f*fdd*r - 252*D1**2*K*Pk2*f*fdd*s**2 + 252*D1**2*K*Pk2*f*fdd*s - 126*D1**2*K*Pk2*f*fdd - 112*D1**2*K*Pk2*fd**2*r*s + 56*D1**2*K*Pk2*fd**2*r - 252*D1**2*K*Pk2*fd**2*s**2 + 252*D1**2*K*Pk2*fd**2*s - 4*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 4*D1**2*K*Pkdd2*f*fd*k1**2*s - 2*D1**2*K*Pkdd2*f*fd*k1**2 + 2*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 2*D1**2*K*Pkdd2*f*fdd*k1**2*s + D1**2*K*Pkdd2*f*fdd*k1**2 + 2*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 2*D1**2*K*Pkdd2*fd**2*k1**2*s + 126*D1**2*Pk2*f**2*fd*r**2 + 210*D1**2*Pk2*f**2*fd*r*s - 182*D1**2*Pk2*f**2*fd*r - 70*D1**2*Pk2*f**2*fd*s + 56*D1**2*Pk2*f**2*fd - 126*D1**2*Pk2*f**2*fdd*r**2 - 210*D1**2*Pk2*f**2*fdd*r*s + 182*D1**2*Pk2*f**2*fdd*r + 70*D1**2*Pk2*f**2*fdd*s - 56*D1**2*Pk2*f**2*fdd - 252*D1**2*Pk2*f*fd**2*r**2 - 420*D1**2*Pk2*f*fd**2*r*s + 364*D1**2*Pk2*f*fd**2*r + 140*D1**2*Pk2*f*fd**2*s - 98*D1**2*Pk2*f*fd**2 + 40*D1**2*Pk2*f*fd*r**2 + 228*D1**2*Pk2*f*fd*r*s - 106*D1**2*Pk2*f*fd*r - 16*D1**2*Pk2*f*fd*s - 8*D1**2*Pk2*f*fd - 48*D1**2*Pk2*f*fdd*r**2 - 156*D1**2*Pk2*f*fdd*r*s + 74*D1**2*Pk2*f*fdd*r + 8*D1**2*Pk2*f*fdd*s + 4*D1**2*Pk2*f*fdd - 56*D1**2*Pk2*f*gd2*r**2 + 224*D1**2*Pk2*f*gd2*r*s + 112*D1**2*Pk2*f*gd2*r - 224*D1**2*Pk2*f*gd2*s - 56*D1**2*Pk2*f*gd2 + 28*D1**2*Pk2*f*gdd2*r**2 - 112*D1**2*Pk2*f*gdd2*r*s - 56*D1**2*Pk2*f*gdd2*r + 112*D1**2*Pk2*f*gdd2*s + 28*D1**2*Pk2*f*gdd2 - 48*D1**2*Pk2*fd**2*r**2 - 156*D1**2*Pk2*fd**2*r*s + 74*D1**2*Pk2*fd**2*r + 8*D1**2*Pk2*fd**2*s - 12*D1**2*Pk2*fd**2 - 56*D1**2*Pk2*fd*g2*r**2 + 224*D1**2*Pk2*fd*g2*r*s - 224*D1**2*Pk2*fd*g2*r + 56*D1**2*Pk2*fd*gd2*r**2 - 224*D1**2*Pk2*fd*gd2*r*s + 56*D1**2*Pk2*fd*gd2*r + 112*D1**2*Pk2*fd*gd2*s - 112*D1**2*Pk2*fd*gd2 + 28*D1**2*Pk2*fdd*g2*r**2 - 112*D1**2*Pk2*fdd*g2*r*s + 112*D1**2*Pk2*fdd*g2*r - 9*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 6*D1**2*Pkdd2*f**2*fd*k1**2*s - 3*D1**2*Pkdd2*f**2*fd*k1**2 - D1**2*bdd1*f*(14*Pk2*(K*(2*r**2 - 2*r*(4*s + 1) + 4*s + 1) - 2*r**2 + r*(2*f + 4) - 1) + Pkdd2*f*k1**2*(4*s**2 - 6*s + 3)) + 224*D1*Dd*K*Pk2*f**2*r*s - 56*D1*Dd*K*Pk2*f**2*r + 616*D1*Dd*K*Pk2*f**2*s**2 - 420*D1*Dd*K*Pk2*f**2*s + 154*D1*Dd*K*Pk2*f**2 - 896*D1*Dd*K*Pk2*f*fd*r*s + 336*D1*Dd*K*Pk2*f*fd*r - 2016*D1*Dd*K*Pk2*f*fd*s**2 + 1736*D1*Dd*K*Pk2*f*fd*s - 364*D1*Dd*K*Pk2*f*fd - 8*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 4*D1*Dd*K*Pkdd2*f**2*k1**2*s - 2*D1*Dd*K*Pkdd2*f**2*k1**2 + 16*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 12*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 2*D1*Dd*K*Pkdd2*f*fd*k1**2 + 168*D1*Dd*Pk2*f**3*r**2 + 280*D1*Dd*Pk2*f**3*r*s - 238*D1*Dd*Pk2*f**3*r - 140*D1*Dd*Pk2*f**3*s + 84*D1*Dd*Pk2*f**3 - 1008*D1*Dd*Pk2*f**2*fd*r**2 - 1680*D1*Dd*Pk2*f**2*fd*r*s + 1442*D1*Dd*Pk2*f**2*fd*r + 700*D1*Dd*Pk2*f**2*fd*s - 434*D1*Dd*Pk2*f**2*fd + 80*D1*Dd*Pk2*f**2*r**2 + 456*D1*Dd*Pk2*f**2*r*s - 194*D1*Dd*Pk2*f**2*r - 228*D1*Dd*Pk2*f**2*s + 40*D1*Dd*Pk2*f**2 - 384*D1*Dd*Pk2*f*fd*r**2 - 1248*D1*Dd*Pk2*f*fd*r*s + 644*D1*Dd*Pk2*f*fd*r + 344*D1*Dd*Pk2*f*fd*s - 156*D1*Dd*Pk2*f*fd - 224*D1*Dd*Pk2*f*g2*r**2 + 896*D1*Dd*Pk2*f*g2*r*s - 448*D1*Dd*Pk2*f*g2*s - 112*D1*Dd*Pk2*f*g2 + 224*D1*Dd*Pk2*f*gd2*r**2 - 896*D1*Dd*Pk2*f*gd2*r*s - 224*D1*Dd*Pk2*f*gd2*r + 672*D1*Dd*Pk2*f*gd2*s + 224*D1*Dd*Pk2*fd*g2*r**2 - 896*D1*Dd*Pk2*fd*g2*r*s + 448*D1*Dd*Pk2*fd*g2*r + 224*D1*Dd*Pk2*fd*g2*s - 224*D1*Dd*Pk2*fd*g2 - 12*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 6*D1*Dd*Pkdd2*f**3*k1**2*s - 3*D1*Dd*Pkdd2*f**3*k1**2 - 224*D1*Ddd*K*Pk2*f**2*r*s + 56*D1*Ddd*K*Pk2*f**2*r - 504*D1*Ddd*K*Pk2*f**2*s**2 + 364*D1*Ddd*K*Pk2*f**2*s - 126*D1*Ddd*K*Pk2*f**2 + 4*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 2*D1*Ddd*K*Pkdd2*f**2*k1**2*s + D1*Ddd*K*Pkdd2*f**2*k1**2 - 168*D1*Ddd*Pk2*f**3*r**2 - 280*D1*Ddd*Pk2*f**3*r*s + 238*D1*Ddd*Pk2*f**3*r + 140*D1*Ddd*Pk2*f**3*s - 84*D1*Ddd*Pk2*f**3 - 96*D1*Ddd*Pk2*f**2*r**2 - 312*D1*Ddd*Pk2*f**2*r*s + 174*D1*Ddd*Pk2*f**2*r + 156*D1*Ddd*Pk2*f**2*s - 48*D1*Ddd*Pk2*f**2 + 112*D1*Ddd*Pk2*f*g2*r**2 - 448*D1*Ddd*Pk2*f*g2*r*s + 224*D1*Ddd*Pk2*f*g2*s + 56*D1*Ddd*Pk2*f*g2 + 2*D1*bd1*(D1*(-14*Pk2*fd*(K*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*r**2 + 1) + f**2*(14*Pk2*r + Pkdd2*k1**2*(4*s**2 - 6*s + 3)) + 2*f*(7*Pk2*(K*(2*r**2 - 8*r*s - 2*r + 4*s + 1) - 2*r**2 + 4*r - 1) + 2*Pkdd2*fd*k1**2*s*(1 - 2*s))) + Dd*f*(-28*Pk2*(2*r - 1)*(-8*K*s + f + r*(2*K - 2) + 2) + Pkdd2*f*k1**2*(-16*s**2 + 16*s - 3))) - 672*Dd**2*K*Pk2*f**2*r*s + 168*Dd**2*K*Pk2*f**2*r - 1512*Dd**2*K*Pk2*f**2*s**2 + 1092*Dd**2*K*Pk2*f**2*s - 112*Dd**2*K*Pk2*f**2 + 12*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 6*Dd**2*K*Pkdd2*f**2*k1**2*s - 504*Dd**2*Pk2*f**3*r**2 - 840*Dd**2*Pk2*f**3*r*s + 714*Dd**2*Pk2*f**3*r + 420*Dd**2*Pk2*f**3*s - 224*Dd**2*Pk2*f**3 - 288*Dd**2*Pk2*f**2*r**2 - 936*Dd**2*Pk2*f**2*r*s + 522*Dd**2*Pk2*f**2*r + 468*Dd**2*Pk2*f**2*s - 204*Dd**2*Pk2*f**2 + 336*Dd**2*Pk2*f*g2*r**2 - 1344*Dd**2*Pk2*f*g2*r*s + 672*Dd**2*Pk2*f*g2*s - 168*Dd**2*Pk2*f*g2))/(210*d**2*k3**2) + D1**2*Pk3*st**2*(696*C*D1**2*Pk2*bdd1*f**2*r*s + 804*C*D1**2*Pk2*f**2*fd*r**2 + 3240*C*D1**2*Pk2*f**2*fd*r*s - 1616*C*D1**2*Pk2*f**2*fd*r + 1512*C*D1**2*Pk2*f**2*fd*s**2 - 2088*C*D1**2*Pk2*f**2*fd*s + 772*C*D1**2*Pk2*f**2*fd - 780*C*D1**2*Pk2*f**2*fdd*r**2 - 3240*C*D1**2*Pk2*f**2*fdd*r*s + 1600*C*D1**2*Pk2*f**2*fdd*r - 1512*C*D1**2*Pk2*f**2*fdd*s**2 + 2088*C*D1**2*Pk2*f**2*fdd*s - 764*C*D1**2*Pk2*f**2*fdd - 1560*C*D1**2*Pk2*f*fd**2*r**2 - 6480*C*D1**2*Pk2*f*fd**2*r*s + 3200*C*D1**2*Pk2*f*fd**2*r - 3024*C*D1**2*Pk2*f*fd**2*s**2 + 4176*C*D1**2*Pk2*f*fd**2*s - 1080*C*D1**2*Pk2*f*fd**2 - 18*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 36*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 18*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 54*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 36*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 18*C*D1**2*Pkdd2*f**2*fd*k1**2 + 1072*C*D1*Dd*Pk2*f**3*r**2 + 4320*C*D1*Dd*Pk2*f**3*r*s - 2152*C*D1*Dd*Pk2*f**3*r + 2016*C*D1*Dd*Pk2*f**3*s**2 - 3168*C*D1*Dd*Pk2*f**3*s + 1040*C*D1*Dd*Pk2*f**3 - 6240*C*D1*Dd*Pk2*f**2*fd*r**2 - 25920*C*D1*Dd*Pk2*f**2*fd*r*s + 12760*C*D1*Dd*Pk2*f**2*fd*r - 12096*C*D1*Dd*Pk2*f**2*fd*s**2 + 17856*C*D1*Dd*Pk2*f**2*fd*s - 5288*C*D1*Dd*Pk2*f**2*fd - 72*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 36*C*D1*Dd*Pkdd2*f**3*k1**2*s - 18*C*D1*Dd*Pkdd2*f**3*k1**2 - 1040*C*D1*Ddd*Pk2*f**3*r**2 - 4320*C*D1*Ddd*Pk2*f**3*r*s + 2120*C*D1*Ddd*Pk2*f**3*r - 2016*C*D1*Ddd*Pk2*f**3*s**2 + 3168*C*D1*Ddd*Pk2*f**3*s - 1024*C*D1*Ddd*Pk2*f**3 - 3120*C*Dd**2*Pk2*f**3*r**2 - 12960*C*Dd**2*Pk2*f**3*r*s + 6360*C*Dd**2*Pk2*f**3*r - 6048*C*Dd**2*Pk2*f**3*s**2 + 9504*C*Dd**2*Pk2*f**3*s - 2680*C*Dd**2*Pk2*f**3 - 210*D1**2*K*Pk2*bdd1*f**2*r**2 - 1260*D1**2*K*Pk2*bdd1*f**2*r*s + 420*D1**2*K*Pk2*bdd1*f**2*r - 1260*D1**2*K*Pk2*bdd1*f**2*s**2 + 1260*D1**2*K*Pk2*bdd1*f**2*s - 210*D1**2*K*Pk2*bdd1*f**2 + 420*D1**2*Pk2*b2*f*fd*r**2 + 2520*D1**2*Pk2*b2*f*fd*r*s - 1260*D1**2*Pk2*b2*f*fd*r + 2520*D1**2*Pk2*b2*f*fd*s**2 - 2520*D1**2*Pk2*b2*f*fd*s + 1260*D1**2*Pk2*b2*f*fd - 420*D1**2*Pk2*b2*f*fdd*r**2 - 2520*D1**2*Pk2*b2*f*fdd*r*s + 1260*D1**2*Pk2*b2*f*fdd*r - 2520*D1**2*Pk2*b2*f*fdd*s**2 + 2520*D1**2*Pk2*b2*f*fdd*s - 1260*D1**2*Pk2*b2*f*fdd - 420*D1**2*Pk2*b2*fd**2*r**2 - 2520*D1**2*Pk2*b2*fd**2*r*s + 1260*D1**2*Pk2*b2*fd**2*r - 2520*D1**2*Pk2*b2*fd**2*s**2 + 2520*D1**2*Pk2*b2*fd**2*s + 210*D1**2*Pk2*bd2*f**2*r**2 + 1260*D1**2*Pk2*bd2*f**2*r*s - 420*D1**2*Pk2*bd2*f**2*r + 1260*D1**2*Pk2*bd2*f**2*s**2 - 1260*D1**2*Pk2*bd2*f**2*s + 210*D1**2*Pk2*bd2*f**2 - 840*D1**2*Pk2*bd2*f*fd*r**2 - 5040*D1**2*Pk2*bd2*f*fd*r*s + 2100*D1**2*Pk2*bd2*f*fd*r - 5040*D1**2*Pk2*bd2*f*fd*s**2 + 5040*D1**2*Pk2*bd2*f*fd*s - 1260*D1**2*Pk2*bd2*f*fd + 180*D1**2*Pk2*bdd1*f**2*r**2 - 348*D1**2*Pk2*bdd1*f**2*r*s - 174*D1**2*Pk2*bdd1*f**2*r - 2520*D1**2*Pk2*bdd1*f*g2*r*s - 210*D1**2*Pk2*bdd2*f**2*r**2 - 1260*D1**2*Pk2*bdd2*f**2*r*s + 420*D1**2*Pk2*bdd2*f**2*r - 1260*D1**2*Pk2*bdd2*f**2*s**2 + 1260*D1**2*Pk2*bdd2*f**2*s - 210*D1**2*Pk2*bdd2*f**2 - 402*D1**2*Pk2*f**2*fd*r**2 - 1620*D1**2*Pk2*f**2*fd*r*s + 808*D1**2*Pk2*f**2*fd*r - 756*D1**2*Pk2*f**2*fd*s**2 + 1044*D1**2*Pk2*f**2*fd*s - 386*D1**2*Pk2*f**2*fd + 390*D1**2*Pk2*f**2*fdd*r**2 + 1620*D1**2*Pk2*f**2*fdd*r*s - 800*D1**2*Pk2*f**2*fdd*r + 756*D1**2*Pk2*f**2*fdd*s**2 - 1044*D1**2*Pk2*f**2*fdd*s + 382*D1**2*Pk2*f**2*fdd - 420*D1**2*Pk2*f**2*gd2*r**2 - 2520*D1**2*Pk2*f**2*gd2*r*s + 840*D1**2*Pk2*f**2*gd2*r - 2520*D1**2*Pk2*f**2*gd2*s**2 + 2520*D1**2*Pk2*f**2*gd2*s - 420*D1**2*Pk2*f**2*gd2 + 420*D1**2*Pk2*f**2*gdd2*r**2 + 2520*D1**2*Pk2*f**2*gdd2*r*s - 840*D1**2*Pk2*f**2*gdd2*r + 2520*D1**2*Pk2*f**2*gdd2*s**2 - 2520*D1**2*Pk2*f**2*gdd2*s + 420*D1**2*Pk2*f**2*gdd2 + 780*D1**2*Pk2*f*fd**2*r**2 + 3240*D1**2*Pk2*f*fd**2*r*s - 1600*D1**2*Pk2*f*fd**2*r + 1512*D1**2*Pk2*f*fd**2*s**2 - 2088*D1**2*Pk2*f*fd**2*s + 540*D1**2*Pk2*f*fd**2 - 840*D1**2*Pk2*f*fd*g2*r**2 - 5040*D1**2*Pk2*f*fd*g2*r*s + 2520*D1**2*Pk2*f*fd*g2*r - 5040*D1**2*Pk2*f*fd*g2*s**2 + 5040*D1**2*Pk2*f*fd*g2*s - 2520*D1**2*Pk2*f*fd*g2 + 1680*D1**2*Pk2*f*fd*gd2*r**2 + 10080*D1**2*Pk2*f*fd*gd2*r*s - 4200*D1**2*Pk2*f*fd*gd2*r + 10080*D1**2*Pk2*f*fd*gd2*s**2 - 10080*D1**2*Pk2*f*fd*gd2*s + 2520*D1**2*Pk2*f*fd*gd2 + 840*D1**2*Pk2*f*fdd*g2*r**2 + 5040*D1**2*Pk2*f*fdd*g2*r*s - 2520*D1**2*Pk2*f*fdd*g2*r + 5040*D1**2*Pk2*f*fdd*g2*s**2 - 5040*D1**2*Pk2*f*fdd*g2*s + 2520*D1**2*Pk2*f*fdd*g2 + 840*D1**2*Pk2*fd**2*g2*r**2 + 5040*D1**2*Pk2*fd**2*g2*r*s - 2520*D1**2*Pk2*fd**2*g2*r + 5040*D1**2*Pk2*fd**2*g2*s**2 - 5040*D1**2*Pk2*fd**2*g2*s - 21*D1**2*Pkdd2*b2*bdd1*f*k1**2*s**2 + 42*D1**2*Pkdd2*b2*bdd1*f*k1**2*s - 21*D1**2*Pkdd2*b2*bdd1*f*k1**2 - 42*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 + 42*D1**2*Pkdd2*b2*f*fd*k1**2*s - 21*D1**2*Pkdd2*b2*f*fd*k1**2 - 21*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 + 9*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 18*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 9*D1**2*Pkdd2*bdd1*f**2*k1**2 + 42*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 84*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 42*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 27*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 18*D1**2*Pkdd2*f**2*fd*k1**2*s + 9*D1**2*Pkdd2*f**2*fd*k1**2 + 42*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 84*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 84*D1**2*Pkdd2*f*fd*g2*k1**2*s + 42*D1**2*Pkdd2*f*fd*g2*k1**2 + 42*D1**2*bd1**2*(-K*Pkdd2*f*k1**2*s*(s - 1) + 5*Pk2*f**2*(4*r**2 - 5*r + 3) + Pk2*f*(-30*K*s + r**2*(4*C + 16) + 5*r*(12*K*s - 7) + 15) - 20*Pk2*g2*r**2) + 840*D1*Dd*Pk2*b2*f**2*r**2 + 5040*D1*Dd*Pk2*b2*f**2*r*s - 2100*D1*Dd*Pk2*b2*f**2*r + 5040*D1*Dd*Pk2*b2*f**2*s**2 - 5040*D1*Dd*Pk2*b2*f**2*s + 1680*D1*Dd*Pk2*b2*f**2 - 3360*D1*Dd*Pk2*b2*f*fd*r**2 - 20160*D1*Dd*Pk2*b2*f*fd*r*s + 9240*D1*Dd*Pk2*b2*f*fd*r - 20160*D1*Dd*Pk2*b2*f*fd*s**2 + 20160*D1*Dd*Pk2*b2*f*fd*s - 5040*D1*Dd*Pk2*b2*f*fd - 1680*D1*Dd*Pk2*bd2*f**2*r**2 - 10080*D1*Dd*Pk2*bd2*f**2*r*s + 3780*D1*Dd*Pk2*bd2*f**2*r - 10080*D1*Dd*Pk2*bd2*f**2*s**2 + 10080*D1*Dd*Pk2*bd2*f**2*s - 2100*D1*Dd*Pk2*bd2*f**2 - 536*D1*Dd*Pk2*f**3*r**2 - 2160*D1*Dd*Pk2*f**3*r*s + 1076*D1*Dd*Pk2*f**3*r - 1008*D1*Dd*Pk2*f**3*s**2 + 1584*D1*Dd*Pk2*f**3*s - 520*D1*Dd*Pk2*f**3 + 3120*D1*Dd*Pk2*f**2*fd*r**2 + 12960*D1*Dd*Pk2*f**2*fd*r*s - 6380*D1*Dd*Pk2*f**2*fd*r + 6048*D1*Dd*Pk2*f**2*fd*s**2 - 8928*D1*Dd*Pk2*f**2*fd*s + 2644*D1*Dd*Pk2*f**2*fd - 1680*D1*Dd*Pk2*f**2*g2*r**2 - 10080*D1*Dd*Pk2*f**2*g2*r*s + 4200*D1*Dd*Pk2*f**2*g2*r - 10080*D1*Dd*Pk2*f**2*g2*s**2 + 10080*D1*Dd*Pk2*f**2*g2*s - 3360*D1*Dd*Pk2*f**2*g2 + 3360*D1*Dd*Pk2*f**2*gd2*r**2 + 20160*D1*Dd*Pk2*f**2*gd2*r*s - 7560*D1*Dd*Pk2*f**2*gd2*r + 20160*D1*Dd*Pk2*f**2*gd2*s**2 - 20160*D1*Dd*Pk2*f**2*gd2*s + 4200*D1*Dd*Pk2*f**2*gd2 + 6720*D1*Dd*Pk2*f*fd*g2*r**2 + 40320*D1*Dd*Pk2*f*fd*g2*r*s - 18480*D1*Dd*Pk2*f*fd*g2*r + 40320*D1*Dd*Pk2*f*fd*g2*s**2 - 40320*D1*Dd*Pk2*f*fd*g2*s + 10080*D1*Dd*Pk2*f*fd*g2 - 84*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 + 42*D1*Dd*Pkdd2*b2*f**2*k1**2*s - 21*D1*Dd*Pkdd2*b2*f**2*k1**2 + 36*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**3*k1**2*s + 9*D1*Dd*Pkdd2*f**3*k1**2 + 168*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 84*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 42*D1*Dd*Pkdd2*f**2*g2*k1**2 - 840*D1*Ddd*Pk2*b2*f**2*r**2 - 5040*D1*Ddd*Pk2*b2*f**2*r*s + 2100*D1*Ddd*Pk2*b2*f**2*r - 5040*D1*Ddd*Pk2*b2*f**2*s**2 + 5040*D1*Ddd*Pk2*b2*f**2*s - 1680*D1*Ddd*Pk2*b2*f**2 + 520*D1*Ddd*Pk2*f**3*r**2 + 2160*D1*Ddd*Pk2*f**3*r*s - 1060*D1*Ddd*Pk2*f**3*r + 1008*D1*Ddd*Pk2*f**3*s**2 - 1584*D1*Ddd*Pk2*f**3*s + 512*D1*Ddd*Pk2*f**3 + 1680*D1*Ddd*Pk2*f**2*g2*r**2 + 10080*D1*Ddd*Pk2*f**2*g2*r*s - 4200*D1*Ddd*Pk2*f**2*g2*r + 10080*D1*Ddd*Pk2*f**2*g2*s**2 - 10080*D1*Ddd*Pk2*f**2*g2*s + 3360*D1*Ddd*Pk2*f**2*g2 + 3*D1*bd1*(D1*(f**2*(70*K*Pk2*(r**2 + r*(6*s - 2) + 6*s**2 - 6*s + 1) - 7*K*Pkdd2*k1**2*s**2 + 2*Pk2*r*(r*(14*C - 32) + s*(74 - 148*C) + 37) + Pkdd2*k1**2*(12*C - 6)*(s - 1)**2) - 2*f*(Pk2*fd*(116*C*s + 70*K*(2*r**2 + r*(12*s - 5) + 3*(1 - 2*s)**2) - 120*r**2 + r*(-464*C*s + 116*C + 232*s + 31) - 58*s - 29) - 7*Pkdd2*b2*k1**2*(s - 1)**2 + Pkdd2*fd*k1**2*s*(12*C - 6)*(s - 1) + 14*g2*(5*Pk2*r*(r - 6*s) + Pkdd2*k1**2*(s - 1)**2) - 7*s*(-60*Pk2*gd2*(2*r - 1) - Pkdd2*bd2*k1**2*(s - 1) + 2*Pkdd2*gd2*k1**2*(s - 1))) - 14*fd*(60*Pk2*g2*r*(2*s - 1) + Pkdd2*b2*k1**2*s*(s - 1) - 2*Pkdd2*g2*k1**2*s*(s - 1))) - 2*Dd*f*(2*Pk2*f*(116*C*s + 35*K*(4*r**2 + 3*r*(8*s - 3) + 24*s**2 - 24*s + 5) - 120*r**2 + r*(-464*C*s + 58*C + 232*s + 89) - 58*s - 29) + 7*Pkdd2*b2*k1**2*(4*s**2 - 5*s + 1) + Pkdd2*f*k1**2*(6*C - 3)*(4*s**2 - 5*s + 1) - 14*g2*(30*Pk2*(-8*r*s + r + 2*s) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 2520*Dd**2*Pk2*b2*f**2*r**2 - 15120*Dd**2*Pk2*b2*f**2*r*s + 6300*Dd**2*Pk2*b2*f**2*r - 15120*Dd**2*Pk2*b2*f**2*s**2 + 15120*Dd**2*Pk2*b2*f**2*s - 2940*Dd**2*Pk2*b2*f**2 + 1560*Dd**2*Pk2*f**3*r**2 + 6480*Dd**2*Pk2*f**3*r*s - 3180*Dd**2*Pk2*f**3*r + 3024*Dd**2*Pk2*f**3*s**2 - 4752*Dd**2*Pk2*f**3*s + 1340*Dd**2*Pk2*f**3 + 5040*Dd**2*Pk2*f**2*g2*r**2 + 30240*Dd**2*Pk2*f**2*g2*r*s - 12600*Dd**2*Pk2*f**2*g2*r + 30240*Dd**2*Pk2*f**2*g2*s**2 - 30240*Dd**2*Pk2*f**2*g2*s + 5880*Dd**2*Pk2*f**2*g2 + 21*b1**3*(D1**2*Pkdd2*k1**2*s**2*(2*fd - fdd) + D1*(-40*Dd*Pk2*(K - 1)*(2*r**2 - 2*r + 1) + 2*Dd*Pkdd2*k1**2*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + 20*Ddd*Pk2*(K - 1)*(2*r**2 - 2*r + 1) + Ddd*Pkdd2*f*k1**2*(-4*s**2 + 2*s - 1)) + 2*Dd**2*(Pk2*(10*K - 10)*(6*r**2 - 6*r + 1) + 3*Pkdd2*f*k1**2*s*(1 - 2*s))) - 21*b1**2*(8*C*D1**2*Pk2*fd*r**2 - 16*C*D1**2*Pk2*fd*r + 8*C*D1**2*Pk2*fd - 4*C*D1**2*Pk2*fdd*r**2 + 8*C*D1**2*Pk2*fdd*r - 4*C*D1**2*Pk2*fdd + 32*C*D1*Dd*Pk2*f*r**2 - 32*C*D1*Dd*Pk2*f*r + 16*C*D1*Dd*Pk2*f - 32*C*D1*Dd*Pk2*fd*r**2 + 48*C*D1*Dd*Pk2*fd*r - 16*C*D1*Dd*Pk2*fd - 16*C*D1*Ddd*Pk2*f*r**2 + 16*C*D1*Ddd*Pk2*f*r - 8*C*D1*Ddd*Pk2*f - 48*C*Dd**2*Pk2*f*r**2 + 48*C*Dd**2*Pk2*f*r - 8*C*Dd**2*Pk2*f - 10*D1**2*K*Pk2*fd*r**2 + 60*D1**2*K*Pk2*fd*r*s - 60*D1**2*K*Pk2*fd*r - 60*D1**2*K*Pk2*fdd*r*s + 60*D1**2*K*Pk2*fdd*r - 2*D1**2*K*Pkdd2*fd*k1**2*s**2 + D1**2*K*Pkdd2*fdd*k1**2*s**2 + 40*D1**2*Pk2*f*fd*r**2 - 30*D1**2*Pk2*f*fd*r + 30*D1**2*Pk2*f*fd - 40*D1**2*Pk2*f*fdd*r**2 + 30*D1**2*Pk2*f*fdd*r - 30*D1**2*Pk2*f*fdd - 40*D1**2*Pk2*fd**2*r**2 + 30*D1**2*Pk2*fd**2*r + 10*D1**2*Pk2*fd**2 + 22*D1**2*Pk2*fd*r**2 + 46*D1**2*Pk2*fd*r - 8*D1**2*Pk2*fd - 16*D1**2*Pk2*fdd*r**2 - 38*D1**2*Pk2*fdd*r + 4*D1**2*Pk2*fdd - 40*D1**2*Pk2*gd2*r**2 + 80*D1**2*Pk2*gd2*r - 40*D1**2*Pk2*gd2 + 20*D1**2*Pk2*gdd2*r**2 - 40*D1**2*Pk2*gdd2*r + 20*D1**2*Pk2*gdd2 - 4*D1**2*Pkdd2*f*fd*k1**2*s**2 - 2*D1**2*Pkdd2*f*fd*k1**2*s + D1**2*Pkdd2*f*fd*k1**2 + D1**2*bdd1*(Pk2*(10 - 10*K)*(3*r**2 - 2*r + 1) + Pkdd2*f*k1**2*(3*s**2 - 2*s + 1)) - 40*D1*Dd*K*Pk2*f*r**2 + 240*D1*Dd*K*Pk2*f*r*s - 20*D1*Dd*K*Pk2*f*r - 120*D1*Dd*K*Pk2*f*s - 20*D1*Dd*K*Pk2*f - 480*D1*Dd*K*Pk2*fd*r*s + 300*D1*Dd*K*Pk2*fd*r + 120*D1*Dd*K*Pk2*fd*s - 120*D1*Dd*K*Pk2*fd - 8*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 4*D1*Dd*K*Pkdd2*f*k1**2*s - 2*D1*Dd*K*Pkdd2*f*k1**2 + 8*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 2*D1*Dd*K*Pkdd2*fd*k1**2*s + 80*D1*Dd*Pk2*f**2*r**2 - 80*D1*Dd*Pk2*f**2*r + 40*D1*Dd*Pk2*f**2 - 320*D1*Dd*Pk2*f*fd*r**2 + 280*D1*Dd*Pk2*f*fd*r - 60*D1*Dd*Pk2*f*fd + 88*D1*Dd*Pk2*f*r**2 - 88*D1*Dd*Pk2*f*r + 44*D1*Dd*Pk2*f - 128*D1*Dd*Pk2*fd*r**2 - 88*D1*Dd*Pk2*fd*r + 76*D1*Dd*Pk2*fd - 160*D1*Dd*Pk2*g2*r**2 + 160*D1*Dd*Pk2*g2*r - 80*D1*Dd*Pk2*g2 + 160*D1*Dd*Pk2*gd2*r**2 - 240*D1*Dd*Pk2*gd2*r + 80*D1*Dd*Pk2*gd2 - 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 4*D1*Dd*Pkdd2*f**2*k1**2*s - 2*D1*Dd*Pkdd2*f**2*k1**2 - 240*D1*Ddd*K*Pk2*f*r*s + 60*D1*Ddd*K*Pk2*f*r + 120*D1*Ddd*K*Pk2*f*s + 4*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 2*D1*Ddd*K*Pkdd2*f*k1**2*s + D1*Ddd*K*Pkdd2*f*k1**2 - 80*D1*Ddd*Pk2*f**2*r**2 + 80*D1*Ddd*Pk2*f**2*r - 40*D1*Ddd*Pk2*f**2 - 64*D1*Ddd*Pk2*f*r**2 + 64*D1*Ddd*Pk2*f*r - 32*D1*Ddd*Pk2*f + 80*D1*Ddd*Pk2*g2*r**2 - 80*D1*Ddd*Pk2*g2*r + 40*D1*Ddd*Pk2*g2 + 2*D1*bd1*(10*D1*Pk2*(K - 1)*(3*r**2 - 2*r + 1) - D1*Pkdd2*k1**2*(f*(3*s**2 - 2*s + 1) + fd*s*(1 - 3*s)) - 20*Dd*Pk2*(K - 1)*(6*r**2 - 5*r + 1) + Dd*Pkdd2*f*k1**2*(12*s**2 - 7*s + 1)) - 720*Dd**2*K*Pk2*f*r*s + 180*Dd**2*K*Pk2*f*r + 360*Dd**2*K*Pk2*f*s - 120*Dd**2*K*Pk2*f + 12*Dd**2*K*Pkdd2*f*k1**2*s**2 - 6*Dd**2*K*Pkdd2*f*k1**2*s - 240*Dd**2*Pk2*f**2*r**2 + 240*Dd**2*Pk2*f**2*r - 40*Dd**2*Pk2*f**2 - 192*Dd**2*Pk2*f*r**2 + 192*Dd**2*Pk2*f*r - 32*Dd**2*Pk2*f + 240*Dd**2*Pk2*g2*r**2 - 240*Dd**2*Pk2*g2*r + 40*Dd**2*Pk2*g2) - 3*b1*(-56*C*D1**2*Pk2*f*fd*r**2 + 592*C*D1**2*Pk2*f*fd*r*s - 240*C*D1**2*Pk2*f*fd*r - 296*C*D1**2*Pk2*f*fd*s - 28*C*D1**2*Pk2*f*fd - 464*C*D1**2*Pk2*f*fdd*r*s + 232*C*D1**2*Pk2*f*fdd*r + 232*C*D1**2*Pk2*f*fdd*s - 464*C*D1**2*Pk2*fd**2*r*s + 232*C*D1**2*Pk2*fd**2*r + 232*C*D1**2*Pk2*fd**2*s - 232*C*D1**2*Pk2*fd**2 - 24*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 12*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 12*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 112*C*D1*Dd*Pk2*f**2*r**2 + 1184*C*D1*Dd*Pk2*f**2*r*s - 184*C*D1*Dd*Pk2*f**2*r - 592*C*D1*Dd*Pk2*f**2*s - 56*C*D1*Dd*Pk2*f**2 - 3712*C*D1*Dd*Pk2*f*fd*r*s + 1392*C*D1*Dd*Pk2*f*fd*r + 1856*C*D1*Dd*Pk2*f*fd*s - 696*C*D1*Dd*Pk2*f*fd - 48*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 24*C*D1*Dd*Pkdd2*f**2*k1**2*s - 12*C*D1*Dd*Pkdd2*f**2*k1**2 + 96*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 24*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 928*C*D1*Ddd*Pk2*f**2*r*s + 232*C*D1*Ddd*Pk2*f**2*r + 464*C*D1*Ddd*Pk2*f**2*s + 24*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 12*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 6*C*D1*Ddd*Pkdd2*f**2*k1**2 - 2784*C*Dd**2*Pk2*f**2*r*s + 696*C*Dd**2*Pk2*f**2*r + 1392*C*Dd**2*Pk2*f**2*s - 464*C*Dd**2*Pk2*f**2 + 72*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 36*C*Dd**2*Pkdd2*f**2*k1**2*s - 140*D1**2*K*Pk2*f*fd*r**2 - 840*D1**2*K*Pk2*f*fd*r*s + 420*D1**2*K*Pk2*f*fd*r - 840*D1**2*K*Pk2*f*fd*s**2 + 840*D1**2*K*Pk2*f*fd*s - 420*D1**2*K*Pk2*f*fd + 140*D1**2*K*Pk2*f*fdd*r**2 + 840*D1**2*K*Pk2*f*fdd*r*s - 420*D1**2*K*Pk2*f*fdd*r + 840*D1**2*K*Pk2*f*fdd*s**2 - 840*D1**2*K*Pk2*f*fdd*s + 420*D1**2*K*Pk2*f*fdd + 140*D1**2*K*Pk2*fd**2*r**2 + 840*D1**2*K*Pk2*fd**2*r*s - 420*D1**2*K*Pk2*fd**2*r + 840*D1**2*K*Pk2*fd**2*s**2 - 840*D1**2*K*Pk2*fd**2*s + 14*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*K*Pkdd2*f*fd*k1**2*s + 7*D1**2*K*Pkdd2*f*fd*k1**2 + 128*D1**2*Pk2*f*fd*r**2 - 296*D1**2*Pk2*f*fd*r*s + 94*D1**2*Pk2*f*fd*r + 148*D1**2*Pk2*f*fd*s + 64*D1**2*Pk2*f*fd - 120*D1**2*Pk2*f*fdd*r**2 + 232*D1**2*Pk2*f*fdd*r*s - 54*D1**2*Pk2*f*fdd*r - 116*D1**2*Pk2*f*fdd*s - 60*D1**2*Pk2*f*fdd + 140*D1**2*Pk2*f*gd2*r**2 - 840*D1**2*Pk2*f*gd2*r*s - 280*D1**2*Pk2*f*gd2*r + 840*D1**2*Pk2*f*gd2*s + 140*D1**2*Pk2*f*gd2 + 840*D1**2*Pk2*f*gdd2*r*s - 840*D1**2*Pk2*f*gdd2*s - 120*D1**2*Pk2*fd**2*r**2 + 232*D1**2*Pk2*fd**2*r*s - 54*D1**2*Pk2*fd**2*r - 116*D1**2*Pk2*fd**2*s + 174*D1**2*Pk2*fd**2 + 140*D1**2*Pk2*fd*g2*r**2 - 840*D1**2*Pk2*fd*g2*r*s + 840*D1**2*Pk2*fd*g2*r + 1680*D1**2*Pk2*fd*gd2*r*s - 840*D1**2*Pk2*fd*gd2*r - 840*D1**2*Pk2*fd*gd2*s + 840*D1**2*Pk2*fd*gd2 + 840*D1**2*Pk2*fdd*g2*r*s - 840*D1**2*Pk2*fdd*g2*r - 14*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 7*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 14*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 14*D1**2*Pkdd2*bd2*fd*k1**2*s**2 + 7*D1**2*Pkdd2*bdd2*f*k1**2*s**2 + 12*D1**2*Pkdd2*f*fd*k1**2*s**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 28*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s**2 + 28*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 28*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 14*D1**2*bd1**2*(Pk2*r*(10*K - 10)*(3*r - 2) + Pkdd2*f*k1**2*s*(2 - 3*s)) - 7*D1**2*bdd1*(K*Pkdd2*f*k1**2*(-2*s**2 + 2*s - 1) + 10*Pk2*f**2*(4*r**2 - 5*r + 1) + 2*Pk2*f*(-30*K*s + r**2*(4*C + 16) + 5*r*(12*K*s - 7) + 10) - 40*Pk2*g2*r**2) - 280*D1*Dd*K*Pk2*f**2*r**2 - 1680*D1*Dd*K*Pk2*f**2*r*s + 700*D1*Dd*K*Pk2*f**2*r - 1680*D1*Dd*K*Pk2*f**2*s**2 + 1680*D1*Dd*K*Pk2*f**2*s - 560*D1*Dd*K*Pk2*f**2 + 1120*D1*Dd*K*Pk2*f*fd*r**2 + 6720*D1*Dd*K*Pk2*f*fd*r*s - 3080*D1*Dd*K*Pk2*f*fd*r + 6720*D1*Dd*K*Pk2*f*fd*s**2 - 6720*D1*Dd*K*Pk2*f*fd*s + 1680*D1*Dd*K*Pk2*f*fd + 28*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 14*D1*Dd*K*Pkdd2*f**2*k1**2*s + 7*D1*Dd*K*Pkdd2*f**2*k1**2 + 256*D1*Dd*Pk2*f**2*r**2 - 592*D1*Dd*Pk2*f**2*r*s - 108*D1*Dd*Pk2*f**2*r + 296*D1*Dd*Pk2*f**2*s + 128*D1*Dd*Pk2*f**2 - 960*D1*Dd*Pk2*f*fd*r**2 + 1856*D1*Dd*Pk2*f*fd*r*s + 32*D1*Dd*Pk2*f*fd*r - 928*D1*Dd*Pk2*f*fd*s + 224*D1*Dd*Pk2*f*fd + 560*D1*Dd*Pk2*f*g2*r**2 - 3360*D1*Dd*Pk2*f*g2*r*s + 280*D1*Dd*Pk2*f*g2*r + 1680*D1*Dd*Pk2*f*g2*s + 280*D1*Dd*Pk2*f*g2 + 6720*D1*Dd*Pk2*f*gd2*r*s - 840*D1*Dd*Pk2*f*gd2*r - 5040*D1*Dd*Pk2*f*gd2*s + 840*D1*Dd*Pk2*f*gd2 + 6720*D1*Dd*Pk2*fd*g2*r*s - 4200*D1*Dd*Pk2*fd*g2*r - 1680*D1*Dd*Pk2*fd*g2*s + 1680*D1*Dd*Pk2*fd*g2 - 56*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 28*D1*Dd*Pkdd2*b2*f*k1**2*s - 14*D1*Dd*Pkdd2*b2*f*k1**2 + 56*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 14*D1*Dd*Pkdd2*b2*fd*k1**2*s + 56*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 14*D1*Dd*Pkdd2*bd2*f*k1**2*s + 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 12*D1*Dd*Pkdd2*f**2*k1**2*s + 6*D1*Dd*Pkdd2*f**2*k1**2 - 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*Pkdd2*f*fd*k1**2*s + 112*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 56*D1*Dd*Pkdd2*f*g2*k1**2*s + 28*D1*Dd*Pkdd2*f*g2*k1**2 - 112*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 28*D1*Dd*Pkdd2*f*gd2*k1**2*s - 112*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 28*D1*Dd*Pkdd2*fd*g2*k1**2*s + 280*D1*Ddd*K*Pk2*f**2*r**2 + 1680*D1*Ddd*K*Pk2*f**2*r*s - 700*D1*Ddd*K*Pk2*f**2*r + 1680*D1*Ddd*K*Pk2*f**2*s**2 - 1680*D1*Ddd*K*Pk2*f**2*s + 560*D1*Ddd*K*Pk2*f**2 - 240*D1*Ddd*Pk2*f**2*r**2 + 464*D1*Ddd*Pk2*f**2*r*s + 124*D1*Ddd*Pk2*f**2*r - 232*D1*Ddd*Pk2*f**2*s - 120*D1*Ddd*Pk2*f**2 + 3360*D1*Ddd*Pk2*f*g2*r*s - 840*D1*Ddd*Pk2*f*g2*r - 1680*D1*Ddd*Pk2*f*g2*s + 28*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 14*D1*Ddd*Pkdd2*b2*f*k1**2*s + 7*D1*Ddd*Pkdd2*b2*f*k1**2 - 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*D1*Ddd*Pkdd2*f**2*k1**2 - 56*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 28*D1*Ddd*Pkdd2*f*g2*k1**2*s - 14*D1*Ddd*Pkdd2*f*g2*k1**2 + 7*D1*bd1*(D1*(-2*K*Pkdd2*fd*k1**2*s*(1 - 2*s) - 2*Pk2*fd*(30*K*(r*(4*s - 2) - s + 1) + r**2*(8*C + 32) + r*(3 - 8*C) - 15) - 80*Pk2*r*(g2*r - gd2*r + gd2) + f**2*(10*Pk2*(4*r**2 - 5*r + 1) + Pkdd2*k1**2*(-4*s**2 + 6*s - 3)) - 2*f*(K*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + Pk2*(-8*C*r**2 + 5*K*(2*r**2 - 2*r*(6*s + 1) + 6*s + 1) + 10*fd*(8*r**2 - 8*r + 1) - 22*r**2 + 45*r - 15))) - 2*Dd*(K*Pkdd2*f*k1**2*(-8*s**2 + 6*s - 1) + 10*Pk2*f**2*(16*r**2 - 18*r + 5) + 2*Pk2*f*(2*r - 1)*(15*K*(8*s - 1) + r*(8*C + 32) - 35) + 80*Pk2*g2*r*(1 - 2*r))) + 840*Dd**2*K*Pk2*f**2*r**2 + 5040*Dd**2*K*Pk2*f**2*r*s - 2100*Dd**2*K*Pk2*f**2*r + 5040*Dd**2*K*Pk2*f**2*s**2 - 5040*Dd**2*K*Pk2*f**2*s + 980*Dd**2*K*Pk2*f**2 - 720*Dd**2*Pk2*f**2*r**2 + 1392*Dd**2*Pk2*f**2*r*s + 372*Dd**2*Pk2*f**2*r - 696*Dd**2*Pk2*f**2*s + 112*Dd**2*Pk2*f**2 + 10080*Dd**2*Pk2*f*g2*r*s - 2520*Dd**2*Pk2*f*g2*r - 5040*Dd**2*Pk2*f*g2*s + 1680*Dd**2*Pk2*f*g2 + 84*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 42*Dd**2*Pkdd2*b2*f*k1**2*s - 36*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*Dd**2*Pkdd2*f**2*k1**2*s - 168*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 84*Dd**2*Pkdd2*f*g2*k1**2*s))/(630*d**2*k3**2) + D1**2*Pk3*(D1*(-14*D1*Pk2*bd1**2*(f*(30*K*(r - 1)*(r + 2*s - 1) - r*(36*C - 27)*(2*s - 1) + s*(10 - 20*C)*(s - 1)) + 60*g2*(r*(2*s - 1) + s*(s - 1))) + 2*D1*Pk2*bdd1*f*(-f*(2*C - 1)*(81*r**2 + 126*r*(s - 1) - 70*s + 35) + 210*g2*(r - 1)*(r + 2*s - 1)) + 35*b2*(-6*D1*Pk2*bdd1*f*(r + s - 1)**2 + D1*bd1*(-12*Pk2*fd*(r**2 + r*(2*s - 1) + s*(s - 1)) + f*(6*Pk2*(r + s - 1)**2 - Pkdd2*k1**2*(s - 1)**2)) - 12*Dd*Pk2*bd1*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + bd1*(-420*D1*Pk2*bd2*f*(r + s - 1)**2 + D1*(-Pk2*f*fd*(8*C - 4)*(162*r**2 + 9*r*(28*s - 23) - 98*s + 63) + 840*Pk2*fd*g2*r*(r + 2*s - 1) + f**2*(2*C - 1)*(2*Pk2*(99*r**2 + 126*r*(s - 1) - 70*s + 35) - 21*Pkdd2*k1**2*(s - 1)**2) + 70*f*(-6*Pk2*g2*(r - 1)*(r + 2*s - 1) + 12*Pk2*gd2*(r - 1)*(r + 2*s - 1) + Pkdd2*g2*k1**2*(s - 1)**2)) - 4*Dd*Pk2*f*(f*(2*C - 1)*(324*r**2 + 9*r*(56*s - 53) - 266*s + 161) - 210*g2*(4*r - 3)*(r + 2*s - 1)))) + 35*b1**3*(D1**2*(6*Pk2*fd*(r - 1)*(r + s - 1) - 6*Pk2*fdd*(r - 1)*(r + s - 1) - Pkdd2*fd*k1**2*s**2) + D1*(Dd*(6*Pk2*(4*K*r**2 + 8*K*r*s - 6*K*r + 4*K*s**2 - 6*K*s + 3*K + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 13*r + 6*s - 5) - 4*r**2 - 4*r*s + 5*r + 2*s - 2) + Pkdd2*f*k1**2*(-4*s**2 + 2*s - 1)) + 6*Ddd*Pk2*(K*(8*r*s - 2*r + 4*s**2 - 6*s + 1) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r*s + r + 2*s)) - 6*Dd**2*Pk2*(-2*K*(12*r*s - 3*r + 6*s**2 - 9*s + 2) + f*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 12*r*s - 3*r - 6*s + 2)) + 7*b1**2*(20*C*D1**2*Pk2*fd*r**2 - 24*C*D1**2*Pk2*fd*r*s - 40*C*D1**2*Pk2*fd*r + 20*C*D1**2*Pk2*fd*s**2 + 24*C*D1**2*Pk2*fd*s + 20*C*D1**2*Pk2*fd + 72*C*D1**2*Pk2*fdd*r*s + 20*C*D1**2*Pk2*fdd*s**2 - 72*C*D1**2*Pk2*fdd*s + 80*C*D1*Dd*Pk2*f*r**2 - 96*C*D1*Dd*Pk2*f*r*s - 56*C*D1*Dd*Pk2*f*r + 80*C*D1*Dd*Pk2*f*s**2 + 8*C*D1*Dd*Pk2*f*s + 60*C*D1*Dd*Pk2*f + 576*C*D1*Dd*Pk2*fd*r*s - 72*C*D1*Dd*Pk2*fd*r + 160*C*D1*Dd*Pk2*fd*s**2 - 472*C*D1*Dd*Pk2*fd*s + 72*C*D1*Dd*Pk2*fd + 288*C*D1*Ddd*Pk2*f*r*s - 72*C*D1*Ddd*Pk2*f*r + 80*C*D1*Ddd*Pk2*f*s**2 - 184*C*D1*Ddd*Pk2*f*s + 20*C*D1*Ddd*Pk2*f + 864*C*Dd**2*Pk2*f*r*s - 216*C*Dd**2*Pk2*f*r + 240*C*Dd**2*Pk2*f*s**2 - 552*C*Dd**2*Pk2*f*s + 144*C*Dd**2*Pk2*f + 30*D1**2*K*Pk2*fd*r**2 + 60*D1**2*K*Pk2*fd*r*s + 60*D1**2*K*Pk2*fd*s - 30*D1**2*K*Pk2*fd - 30*D1**2*K*Pk2*fdd*r**2 - 60*D1**2*K*Pk2*fdd*r*s - 60*D1**2*K*Pk2*fdd*s + 30*D1**2*K*Pk2*fdd - 5*D1**2*K*Pkdd2*fd*k1**2*s**2 + 30*D1**2*Pk2*bdd1*(K*(3*s - 1)*(2*r + s - 1) + f*(-3*r**2 - 3*r*(s - 1) + s - 1) - 3*r*s + r + s) - 20*D1**2*Pk2*fd*r**2 + 18*D1**2*Pk2*fd*r*s + 40*D1**2*Pk2*fd*r - 10*D1**2*Pk2*fd*s**2 - 18*D1**2*Pk2*fd*s - 20*D1**2*Pk2*fd - 54*D1**2*Pk2*fdd*r*s - 10*D1**2*Pk2*fdd*s**2 + 54*D1**2*Pk2*fdd*s - 60*D1**2*Pk2*gd2*r**2 - 120*D1**2*Pk2*gd2*r*s + 120*D1**2*Pk2*gd2*r - 60*D1**2*Pk2*gd2*s**2 + 120*D1**2*Pk2*gd2*s - 60*D1**2*Pk2*gd2 - 120*D1**2*Pk2*gdd2*r*s - 60*D1**2*Pk2*gdd2*s**2 + 120*D1**2*Pk2*gdd2*s + 120*D1*Dd*K*Pk2*f*r**2 + 240*D1*Dd*K*Pk2*f*r*s - 180*D1*Dd*K*Pk2*f*r - 120*D1*Dd*K*Pk2*f*s + 60*D1*Dd*K*Pk2*f - 240*D1*Dd*K*Pk2*fd*r**2 - 480*D1*Dd*K*Pk2*fd*r*s + 180*D1*Dd*K*Pk2*fd*r - 120*D1*Dd*K*Pk2*fd*s + 60*D1*Dd*K*Pk2*fd - 20*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 10*D1*Dd*K*Pkdd2*f*k1**2*s - 5*D1*Dd*K*Pkdd2*f*k1**2 - 80*D1*Dd*Pk2*f*r**2 + 72*D1*Dd*Pk2*f*r*s + 62*D1*Dd*Pk2*f*r - 40*D1*Dd*Pk2*f*s**2 - 16*D1*Dd*Pk2*f*s - 50*D1*Dd*Pk2*f - 432*D1*Dd*Pk2*fd*r*s + 54*D1*Dd*Pk2*fd*r - 80*D1*Dd*Pk2*fd*s**2 + 344*D1*Dd*Pk2*fd*s - 54*D1*Dd*Pk2*fd - 240*D1*Dd*Pk2*g2*r**2 - 480*D1*Dd*Pk2*g2*r*s + 360*D1*Dd*Pk2*g2*r - 240*D1*Dd*Pk2*g2*s**2 + 360*D1*Dd*Pk2*g2*s - 180*D1*Dd*Pk2*g2 - 960*D1*Dd*Pk2*gd2*r*s + 120*D1*Dd*Pk2*gd2*r - 480*D1*Dd*Pk2*gd2*s**2 + 840*D1*Dd*Pk2*gd2*s - 120*D1*Dd*Pk2*gd2 - 120*D1*Ddd*K*Pk2*f*r**2 - 240*D1*Ddd*K*Pk2*f*r*s + 180*D1*Ddd*K*Pk2*f*r + 120*D1*Ddd*K*Pk2*f*s - 60*D1*Ddd*K*Pk2*f - 216*D1*Ddd*Pk2*f*r*s + 54*D1*Ddd*Pk2*f*r - 40*D1*Ddd*Pk2*f*s**2 + 128*D1*Ddd*Pk2*f*s - 10*D1*Ddd*Pk2*f - 480*D1*Ddd*Pk2*g2*r*s + 120*D1*Ddd*Pk2*g2*r - 240*D1*Ddd*Pk2*g2*s**2 + 360*D1*Ddd*Pk2*g2*s - 60*D1*Ddd*Pk2*g2 + 5*D1*bd1*(D1*(6*Pk2*(3*K*r**2 + 6*K*r*s - 4*K*r + 3*K*s**2 - 4*K*s + 2*K + f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 - 6*r*s + 9*r + 4*s - 3) - 3*r**2 - 3*r*s + 3*r + s - 1) + Pkdd2*f*k1**2*(-3*s**2 + 2*s - 1)) - 6*Dd*Pk2*(-2*K*(24*r*s - 7*r + 12*s**2 - 17*s + 4) + f*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7) + 24*r*s - 7*r - 10*s + 3)) - 360*Dd**2*K*Pk2*f*r**2 - 720*Dd**2*K*Pk2*f*r*s + 540*Dd**2*K*Pk2*f*r + 360*Dd**2*K*Pk2*f*s - 180*Dd**2*K*Pk2*f - 648*Dd**2*Pk2*f*r*s + 162*Dd**2*Pk2*f*r - 120*Dd**2*Pk2*f*s**2 + 384*Dd**2*Pk2*f*s - 108*Dd**2*Pk2*f - 1440*Dd**2*Pk2*g2*r*s + 360*Dd**2*Pk2*g2*r - 720*Dd**2*Pk2*g2*s**2 + 1080*Dd**2*Pk2*g2*s - 240*Dd**2*Pk2*g2) - b1*(-1008*C*D1**2*Pk2*bdd1*f*r*s + 504*C*D1**2*Pk2*bdd1*f*r - 280*C*D1**2*Pk2*bdd1*f*s**2 + 280*C*D1**2*Pk2*bdd1*f*s - 140*C*D1**2*Pk2*bdd1*f - 792*C*D1**2*Pk2*f*fd*r**2 - 1008*C*D1**2*Pk2*f*fd*r*s + 792*C*D1**2*Pk2*f*fd*r + 224*C*D1**2*Pk2*f*fd*s - 256*C*D1**2*Pk2*f*fd + 648*C*D1**2*Pk2*f*fdd*r**2 + 1008*C*D1**2*Pk2*f*fdd*r*s - 648*C*D1**2*Pk2*f*fdd*r - 224*C*D1**2*Pk2*f*fdd*s + 184*C*D1**2*Pk2*f*fdd + 648*C*D1**2*Pk2*fd**2*r**2 + 1008*C*D1**2*Pk2*fd**2*r*s - 648*C*D1**2*Pk2*fd**2*r - 224*C*D1**2*Pk2*fd**2*s + 84*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 1584*C*D1*Dd*Pk2*f**2*r**2 - 2016*C*D1*Dd*Pk2*f**2*r*s + 2088*C*D1*Dd*Pk2*f**2*r + 1008*C*D1*Dd*Pk2*f**2*s - 792*C*D1*Dd*Pk2*f**2 + 5184*C*D1*Dd*Pk2*f*fd*r**2 + 8064*C*D1*Dd*Pk2*f*fd*r*s - 6192*C*D1*Dd*Pk2*f*fd*r - 2912*C*D1*Dd*Pk2*f*fd*s + 1520*C*D1*Dd*Pk2*f*fd + 168*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 84*C*D1*Dd*Pkdd2*f**2*k1**2*s + 42*C*D1*Dd*Pkdd2*f**2*k1**2 + 1296*C*D1*Ddd*Pk2*f**2*r**2 + 2016*C*D1*Ddd*Pk2*f**2*r*s - 1800*C*D1*Ddd*Pk2*f**2*r - 1008*C*D1*Ddd*Pk2*f**2*s + 648*C*D1*Ddd*Pk2*f**2 + 3888*C*Dd**2*Pk2*f**2*r**2 + 6048*C*Dd**2*Pk2*f**2*r*s - 5400*C*Dd**2*Pk2*f**2*r - 3024*C*Dd**2*Pk2*f**2*s + 1656*C*Dd**2*Pk2*f**2 + 420*D1**2*K*Pk2*bdd1*f*r**2 + 840*D1**2*K*Pk2*bdd1*f*r*s - 840*D1**2*K*Pk2*bdd1*f*r - 840*D1**2*K*Pk2*bdd1*f*s + 420*D1**2*K*Pk2*bdd1*f - 210*D1**2*Pk2*b2*fd*r**2 - 420*D1**2*Pk2*b2*fd*r*s - 210*D1**2*Pk2*b2*fd*s**2 + 210*D1**2*Pk2*b2*fdd*r**2 + 420*D1**2*Pk2*b2*fdd*r*s + 210*D1**2*Pk2*b2*fdd*s**2 + 210*D1**2*Pk2*bd1**2*(-2*K*(3*s - 1)*(2*r + s - 1) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*r*s - 2*r - 2*s + 1) + 756*D1**2*Pk2*bdd1*f*r*s - 378*D1**2*Pk2*bdd1*f*r + 140*D1**2*Pk2*bdd1*f*s**2 - 140*D1**2*Pk2*bdd1*f*s + 70*D1**2*Pk2*bdd1*f + 1680*D1**2*Pk2*bdd1*g2*r*s - 840*D1**2*Pk2*bdd1*g2*r + 840*D1**2*Pk2*bdd1*g2*s**2 - 840*D1**2*Pk2*bdd1*g2*s + 420*D1**2*Pk2*bdd1*g2 + 210*D1**2*Pk2*bdd2*f*r**2 + 420*D1**2*Pk2*bdd2*f*r*s - 420*D1**2*Pk2*bdd2*f*r + 210*D1**2*Pk2*bdd2*f*s**2 - 420*D1**2*Pk2*bdd2*f*s + 210*D1**2*Pk2*bdd2*f + 396*D1**2*Pk2*f*fd*r**2 + 504*D1**2*Pk2*f*fd*r*s - 396*D1**2*Pk2*f*fd*r - 112*D1**2*Pk2*f*fd*s + 128*D1**2*Pk2*f*fd - 324*D1**2*Pk2*f*fdd*r**2 - 504*D1**2*Pk2*f*fdd*r*s + 324*D1**2*Pk2*f*fdd*r + 112*D1**2*Pk2*f*fdd*s - 92*D1**2*Pk2*f*fdd + 420*D1**2*Pk2*f*gd2*r**2 + 840*D1**2*Pk2*f*gd2*r*s - 840*D1**2*Pk2*f*gd2*r - 840*D1**2*Pk2*f*gd2*s + 420*D1**2*Pk2*f*gd2 - 420*D1**2*Pk2*f*gdd2*r**2 - 840*D1**2*Pk2*f*gdd2*r*s + 840*D1**2*Pk2*f*gdd2*r + 840*D1**2*Pk2*f*gdd2*s - 420*D1**2*Pk2*f*gdd2 - 324*D1**2*Pk2*fd**2*r**2 - 504*D1**2*Pk2*fd**2*r*s + 324*D1**2*Pk2*fd**2*r + 112*D1**2*Pk2*fd**2*s + 420*D1**2*Pk2*fd*g2*r**2 + 840*D1**2*Pk2*fd*g2*r*s + 840*D1**2*Pk2*fd*g2*s - 420*D1**2*Pk2*fd*g2 - 840*D1**2*Pk2*fd*gd2*r**2 - 1680*D1**2*Pk2*fd*gd2*r*s + 840*D1**2*Pk2*fd*gd2*r - 420*D1**2*Pk2*fdd*g2*r**2 - 840*D1**2*Pk2*fdd*g2*r*s - 840*D1**2*Pk2*fdd*g2*s + 420*D1**2*Pk2*fdd*g2 + 35*D1**2*Pkdd2*b2*fd*k1**2*s**2 - 42*D1**2*Pkdd2*f*fd*k1**2*s**2 - 70*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 70*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 840*D1*Dd*Pk2*b2*f*r**2 - 1680*D1*Dd*Pk2*b2*f*r*s + 1260*D1*Dd*Pk2*b2*f*r - 840*D1*Dd*Pk2*b2*f*s**2 + 1260*D1*Dd*Pk2*b2*f*s - 630*D1*Dd*Pk2*b2*f + 1680*D1*Dd*Pk2*b2*fd*r**2 + 3360*D1*Dd*Pk2*b2*fd*r*s - 1260*D1*Dd*Pk2*b2*fd*r + 1680*D1*Dd*Pk2*b2*fd*s**2 - 1260*D1*Dd*Pk2*b2*fd*s + 792*D1*Dd*Pk2*f**2*r**2 + 1008*D1*Dd*Pk2*f**2*r*s - 1044*D1*Dd*Pk2*f**2*r - 504*D1*Dd*Pk2*f**2*s + 396*D1*Dd*Pk2*f**2 - 2592*D1*Dd*Pk2*f*fd*r**2 - 4032*D1*Dd*Pk2*f*fd*r*s + 3096*D1*Dd*Pk2*f*fd*r + 1456*D1*Dd*Pk2*f*fd*s - 760*D1*Dd*Pk2*f*fd + 1680*D1*Dd*Pk2*f*g2*r**2 + 3360*D1*Dd*Pk2*f*g2*r*s - 2520*D1*Dd*Pk2*f*g2*r - 1680*D1*Dd*Pk2*f*g2*s + 840*D1*Dd*Pk2*f*g2 - 3360*D1*Dd*Pk2*f*gd2*r**2 - 6720*D1*Dd*Pk2*f*gd2*r*s + 5880*D1*Dd*Pk2*f*gd2*r + 5040*D1*Dd*Pk2*f*gd2*s - 2520*D1*Dd*Pk2*f*gd2 - 3360*D1*Dd*Pk2*fd*g2*r**2 - 6720*D1*Dd*Pk2*fd*g2*r*s + 2520*D1*Dd*Pk2*fd*g2*r - 1680*D1*Dd*Pk2*fd*g2*s + 840*D1*Dd*Pk2*fd*g2 + 140*D1*Dd*Pkdd2*b2*f*k1**2*s**2 - 70*D1*Dd*Pkdd2*b2*f*k1**2*s + 35*D1*Dd*Pkdd2*b2*f*k1**2 - 84*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 42*D1*Dd*Pkdd2*f**2*k1**2*s - 21*D1*Dd*Pkdd2*f**2*k1**2 - 280*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 140*D1*Dd*Pkdd2*f*g2*k1**2*s - 70*D1*Dd*Pkdd2*f*g2*k1**2 + 840*D1*Ddd*Pk2*b2*f*r**2 + 1680*D1*Ddd*Pk2*b2*f*r*s - 1260*D1*Ddd*Pk2*b2*f*r + 840*D1*Ddd*Pk2*b2*f*s**2 - 1260*D1*Ddd*Pk2*b2*f*s + 630*D1*Ddd*Pk2*b2*f - 648*D1*Ddd*Pk2*f**2*r**2 - 1008*D1*Ddd*Pk2*f**2*r*s + 900*D1*Ddd*Pk2*f**2*r + 504*D1*Ddd*Pk2*f**2*s - 324*D1*Ddd*Pk2*f**2 - 1680*D1*Ddd*Pk2*f*g2*r**2 - 3360*D1*Ddd*Pk2*f*g2*r*s + 2520*D1*Ddd*Pk2*f*g2*r + 1680*D1*Ddd*Pk2*f*g2*s - 840*D1*Ddd*Pk2*f*g2 - 7*D1*bd1*(D1*(-5*K*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + 2*Pk2*f*(2*C*(10*r**2 - 12*r*s + 6*r + 10*s**2 - 10*s + 5) + 30*K*(r - 1)*(r + 2*s - 1) - 20*r**2 + 18*r*s - 9*r - 10*s**2 + 10*s - 5) + 2*Pk2*fd*(4*C*(9*r*(4*s - 1) + 10*s**2 - 23*s + 9) - 60*K*r**2 - 3*r*(40*K*s - 20*K + 36*s - 9) - 20*s**2 + 64*s - 27) - 60*Pk2*(g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*gd2*(r*(4*s - 1) + 2*s**2 - 3*s + 1))) + 4*Dd*Pk2*(f*(2*C*(18*r*(8*s - 3) + 40*s**2 - 66*s + 23) - 30*K*(4*r - 3)*(r + 2*s - 1) - 216*r*s + 81*r - 40*s**2 + 84*s - 32) - 30*g2*(2*r*(8*s - 3) + 8*s**2 - 10*s + 3))) - 35*D1*bd2*(D1*(-12*Pk2*fd*(r**2 + r*(2*s - 1) + s*(s - 1)) + f*(6*Pk2*(r + s - 1)**2 - Pkdd2*k1**2*s**2)) - 12*Dd*Pk2*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 2520*Dd**2*Pk2*b2*f*r**2 + 5040*Dd**2*Pk2*b2*f*r*s - 3780*Dd**2*Pk2*b2*f*r + 2520*Dd**2*Pk2*b2*f*s**2 - 3780*Dd**2*Pk2*b2*f*s + 1260*Dd**2*Pk2*b2*f - 1944*Dd**2*Pk2*f**2*r**2 - 3024*Dd**2*Pk2*f**2*r*s + 2700*Dd**2*Pk2*f**2*r + 1512*Dd**2*Pk2*f**2*s - 828*Dd**2*Pk2*f**2 - 5040*Dd**2*Pk2*f*g2*r**2 - 10080*Dd**2*Pk2*f*g2*r*s + 7560*Dd**2*Pk2*f*g2*r + 5040*Dd**2*Pk2*f*g2*s - 2520*Dd**2*Pk2*f*g2))/(210*d**2*k3**2) + D1**2*Pk3*k2**4*st**4*(D1**2*(-3*Pkdd2*k1**2*s*(b1*s*(fd**2*(2 - 4*C) + 14*fd*(K*b1 - 2*g2 + 2*gd2) + 7*fdd*(-K*b1 + 2*g2)) + 14*bd1*fd*(K*b1*(1 - 2*s) + 2*g2*(s - 1))) + f**2*(Pk2*fdd*(40*C - 20)*(3*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(bd1*(4*C*(s - 1)**2 - s**2*(7*K + 2) + 4*s - 2) - bdd1*(2*C - 1)*(s - 1)**2 + 14*gd2*s**2) - fd*(2*C - 1)*(16*Pk2*(3*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + f*(240*C*Pk2*fd**2*r**2 - 160*C*Pk2*fd**2*r - 24*C*Pkdd2*b1*fd*k1**2*s**2 + 12*C*Pkdd2*b1*fdd*k1**2*s**2 + 42*K*Pkdd2*b1*fd*k1**2*s**2 - 42*K*Pkdd2*b1*fd*k1**2*s + 21*K*Pkdd2*b1*fd*k1**2 + 42*K*Pkdd2*bd1**2*k1**2*s*(s - 1) - 120*Pk2*fd**2*r**2 + 80*Pk2*fd**2*r + 12*Pkdd2*b1*fd*k1**2*s**2 - 6*Pkdd2*b1*fdd*k1**2*s**2 + 84*Pkdd2*b1*gd2*k1**2*s**2 - 42*Pkdd2*b1*gdd2*k1**2*s**2 + 6*Pkdd2*bd1*k1**2*(-7*K*b1*(2*s**2 - 2*s + 1) + 14*g2*(s - 1)**2 + s*(s - 1)*(4*C*fd - 2*fd - 14*gd2)) - 21*Pkdd2*bdd1*k1**2*(K*b1*(-2*s**2 + 2*s - 1) + 2*g2*(s - 1)**2) - 84*Pkdd2*fd*g2*k1**2*s**2 + 84*Pkdd2*fd*g2*k1**2*s - 42*Pkdd2*fd*g2*k1**2)) + D1*(Dd*(42*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(K*b1 - 2*g2) - 6*Pkdd2*f*k1**2*(7*K*b1**2*(4*s**2 - 2*s + 1) - b1*(14*g2*(4*s**2 - 2*s + 1) + (4*s - 1)*(7*K*bd1*(2*s - 1) + s*(4*C*fd - 2*fd - 14*gd2))) + 14*bd1*g2*(4*s**2 - 5*s + 1)) - f**3*(2*C - 1)*(32*Pk2*(2*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(Pk2*fd*(160*C - 80)*(6*r**2 - 5*r + 1) - 3*Pkdd2*k1**2*(b1*(4*C - 7*K - 2)*(4*s**2 - 2*s + 1) - 2*bd1*(2*C - 1)*(4*s**2 - 5*s + 1) + 14*g2*(4*s**2 - 2*s + 1)))) + Ddd*f*(Pk2*f**2*(80*C - 40)*(2*r**2 - 2*r + 1) + 3*Pkdd2*b1*f*k1**2*(2*C - 1)*(4*s**2 - 2*s + 1) + 21*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*f**2*(40*C - 20)*(6*r**2 - 6*r + 1) + 9*Pkdd2*b1*f*k1**2*s*(2*C - 1)*(2*s - 1) + 63*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2)))/(210*d**2*k1**2*k3**4) + D1**2*Pk3*k2**4*st**2*(35*D1*K*Pkdd2*b1**2*k1**2*(D1*fd*s**2 + Dd*f*(4*s**2 - 2*s + 1)) + D1*f*(24*D1*Pk2*bdd1*f*r**2*(2*C - 1) + D1*bd1*(Pk2*fd*r*(96*C - 48)*(2*r - 1) - 70*Pkdd2*g2*k1**2*(s - 1)**2 + f*(2*C - 1)*(-20*Pk2*r**2 + 7*Pkdd2*k1**2*(s - 1)**2)) + 96*Dd*Pk2*bd1*f*r*(2*C - 1)*(2*r - 1)) - b1*(D1**2*(-Pk2*f*fdd*(48*C - 24)*(2*r**2 - 2*r + 1) + Pk2*fd**2*r*(48 - 96*C)*(r - 1) - 35*Pkdd2*f*k1**2*(K*bd1*(2*s**2 - 2*s + 1) - 2*gd2*s**2) + 70*Pkdd2*fd*g2*k1**2*s**2 + f*fd*(4*C - 2)*(10*Pk2*(2*r**2 - 2*r + 1) - 7*Pkdd2*k1**2*s**2)) + D1*f*(Dd*(Pk2*fd*(1 - 2*r)**2*(96 - 192*C) + 70*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + f*(2*C - 1)*(40*Pk2*(2*r**2 - 2*r + 1) - 7*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(48 - 96*C)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f**2*(48 - 96*C)*(6*r**2 - 6*r + 1)))/(210*d**2*k1**2*k3**4) + D1**2*Pk3*k2**2*st**4*(D1**2*(3*Pkdd2*k1**2*(7*K*b1**2*(2*fd - fdd)*(2*s - 1) + b1*(fd**2*s*(2 - 4*C) - 14*fd*(g2*(4*s - 2) + s*(K*bd1 - b2*s + bd2*s - 2*gd2)) - 7*fdd*(b2*s**2 + g2*(2 - 4*s))) - 14*b2*bd1*fd*s*(s - 1)) + f**2*(Pk2*fdd*(20 - 40*C)*(3*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(bd1*(C*(8*s - 4) + 7*K*s**2 - 4*s + 2) + bdd1*(-4*C*s + 2*C + 2*s - 1) + s**2*(7*bd2 - 14*gd2)) + fd*(2*C - 1)*(16*Pk2*(3*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + f*(42*K*Pkdd2*bd1**2*k1**2*s + Pk2*fd**2*r*(40 - 80*C)*(3*r - 2) + 3*Pkdd2*b1*k1**2*(-14*K*bd1*(2*s - 1) - 7*bdd1*(-2*K*s + K) + fd*(C*(8*s - 4) - 7*K*(2*s**2 - 2*s + 1) - 4*s + 2) + fdd*(C*(2 - 4*s) + 2*s - 1) - 7*s**2*(-2*bd2 + bdd2)) - 21*Pkdd2*b2*k1**2*(-2*bd1*(s - 1)**2 + bdd1*(s - 1)**2 + fd*(2*s**2 - 2*s + 1)) + 6*Pkdd2*bd1*k1**2*(14*g2*(2*s - 1) - s*(-2*C*fd + 7*bd2*(s - 1) + fd + 14*gd2)) + 42*Pkdd2*bdd1*g2*k1**2*(1 - 2*s) + 42*Pkdd2*fd*g2*k1**2*(2*s**2 - 2*s + 1))) + D1*(Dd*(-42*Pkdd2*b1*fd*k1**2*(4*s - 1)*(K*b1 + b2*s - 2*g2) + 6*Pkdd2*f*k1**2*(b1*(7*b2*(4*s**2 - 2*s + 1) - (4*s - 1)*(2*C*fd - 7*K*bd1 + 7*bd2*s - fd)) - 7*bd1*(4*s - 1)*(b2*(s - 1) + 2*g2)) + f**3*(2*C - 1)*(32*Pk2*(2*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(Pk2*fd*(80 - 160*C)*(6*r**2 - 5*r + 1) - 3*Pkdd2*k1**2*(7*b2*(4*s**2 - 2*s + 1) - 2*bd1*(2*C - 1)*(4*s - 1) - (-7*K*b1 + 14*g2)*(4*s**2 - 2*s + 1)))) + Ddd*f*(Pk2*f**2*(40 - 80*C)*(2*r**2 - 2*r + 1) - 21*Pkdd2*b1*b2*k1**2*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*f**2*(20 - 40*C)*(6*r**2 - 6*r + 1) + 63*Pkdd2*b1*b2*k1**2*s*(1 - 2*s)))/(210*d**2*k1**2*k3**2) + D1**2*Pk3*k2**2*(8*D1**2*Pk2*bd1**2*f*r**2*(2*C - 1) + 15*D1*Dd*K*Pkdd2*b1**3*k1**2*(4*s**2 - 2*s + 1) + D1*b1*(8*D1*Pk2*bdd1*f*r**2*(2*C - 1) + D1*bd1*(Pk2*fd*r*(32*C - 16)*(r - 1) - 30*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + f*(2*C - 1)*(-16*Pk2*r**2 + 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 32*Dd*Pk2*bd1*f*r*(2*C - 1)*(2*r - 1)) + b1**2*(D1**2*(Pk2*fdd*(8*C - 4)*(r - 1)**2 + 15*Pkdd2*k1**2*(K*bd1*(3*s**2 - 2*s + 1) - 2*gd2*s**2) - fd*(2*C - 1)*(8*Pk2*(r - 1)**2 - 5*Pkdd2*k1**2*s**2)) + D1*(Dd*(Pk2*fd*(32*C - 16)*(2*r**2 - 3*r + 1) - 30*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) - f*(2*C - 1)*(16*Pk2*(2*r**2 - 2*r + 1) - 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(16*C - 8)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f*(16*C - 8)*(6*r**2 - 6*r + 1)))/(30*d**2*k1**2*k3**2) + D1**2*Pk3*st**2*(D1*(24*D1*Pk2*bdd1*f**2*r**2*(1 - 2*C) - 14*D1*Pkdd2*bd1**2*k1**2*s*(s - 1)*(5*b2 + f*(2*C - 1) - 10*g2) + bd1*f*(D1*(Pk2*fd*r*(48 - 96*C)*(2*r - 1) - Pkdd2*k1**2*s**2*(35*b2 - 70*g2) + f*(2*C - 1)*(20*Pk2*r**2 - 7*Pkdd2*k1**2*s**2)) + Dd*Pk2*f*r*(96 - 192*C)*(2*r - 1))) + 35*K*Pkdd2*b1**3*k1**2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 7*Pkdd2*b1**2*k1**2*(D1**2*(4*C*fd*s**2 - 2*C*fdd*s**2 + 10*K*bd1*(3*s**2 - 2*s + 1) - 5*K*bdd1*(3*s**2 - 2*s + 1) - 5*K*fd*s**2 + 10*K*fd*s - 5*K*fd + 10*bd2*s**2 - 5*bdd2*s**2 - 2*fd*s**2 + fdd*s**2 - 20*gd2*s**2 + 10*gdd2*s**2) + D1*(Dd*(f*(4*C - 5*K - 2)*(4*s**2 - 2*s + 1) - 20*g2*(4*s**2 - 2*s + 1) - (8*s - 2)*(5*K*bd1*(3*s - 1) + s*(2*C*fd + 5*bd2 - fd - 10*gd2))) - Ddd*(f*(2*C - 1) - 10*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*s*(2*s - 1)*(f*(2*C - 1) - 10*g2) + 5*b2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s))) + b1*(D1**2*(-70*K*Pkdd2*bd1**2*k1**2*s*(3*s - 2) - 35*Pkdd2*b2*k1**2*(bd1*(-4*s**2 + 4*s - 2) + bdd1*(2*s**2 - 2*s + 1) + fd*(s - 1)**2) - 14*Pkdd2*bd1*k1**2*(10*g2*(2*s**2 - 2*s + 1) + s*(2*s - 1)*(2*C*fd + 5*bd2 - fd - 10*gd2)) + 70*Pkdd2*bdd1*g2*k1**2*(2*s**2 - 2*s + 1) + f*(Pk2*fdd*(24 - 48*C)*(2*r**2 - 2*r + 1) + 7*Pkdd2*k1**2*(2*bd1*(C*(4*s**2 - 4*s + 2) - s**2*(5*K + 2) + 2*s - 1) - bdd1*(2*C - 1)*(2*s**2 - 2*s + 1) + s**2*(-5*bd2 + 10*gd2)) + fd*(2*C - 1)*(20*Pk2*(2*r**2 - 2*r + 1) - 7*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 2*fd*(Pk2*fd*r*(48*C - 24)*(r - 1) - 35*Pkdd2*g2*k1**2*(s - 1)**2)) + D1*(Dd*(-70*Pkdd2*bd1*k1**2*(b2 - 2*g2)*(8*s**2 - 6*s + 1) + f**2*(2*C - 1)*(40*Pk2*(2*r**2 - 2*r + 1) - 7*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(Pk2*fd*(1 - 2*r)**2*(96 - 192*C) - 7*Pkdd2*k1**2*(5*b2*(4*s**2 - 2*s + 1) + 2*bd1*(2*C - 1)*(8*s**2 - 6*s + 1) - 10*g2*(4*s**2 - 2*s + 1)))) + Ddd*Pk2*f**2*(48 - 96*C)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f**2*(48 - 96*C)*(6*r**2 - 6*r + 1)))/(210*d**2*k1**2) + D1**2*Pk3*(8*D1**2*Pk2*bd1**2*f*r**2*(1 - 2*C) - 15*D1*Dd*K*Pkdd2*b1**3*k1**2*(4*s**2 - 2*s + 1) + D1*b1*(8*D1*Pk2*bdd1*f*r**2*(1 - 2*C) - 15*D1*Pkdd2*b2*bd1*k1**2*(2*s**2 - 2*s + 1) + D1*bd1*(Pk2*fd*r*(16 - 32*C)*(r - 1) + 30*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) - f*(2*C - 1)*(-16*Pk2*r**2 + 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 32*Dd*Pk2*bd1*f*r*(2*C - 1)*(2*r - 1)) + b1**2*(D1**2*(Pk2*fdd*(4 - 8*C)*(r - 1)**2 - 15*Pkdd2*k1**2*(K*bd1*(3*s**2 - 2*s + 1) + s**2*(bd2 - 2*gd2)) + fd*(2*C - 1)*(8*Pk2*(r - 1)**2 - 5*Pkdd2*k1**2*s**2)) + D1*(Dd*(Pk2*fd*(16 - 32*C)*(2*r**2 - 3*r + 1) - Pkdd2*k1**2*(15*b2 - 30*g2)*(4*s**2 - 2*s + 1) + f*(2*C - 1)*(16*Pk2*(2*r**2 - 2*r + 1) - 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(8 - 16*C)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f*(8 - 16*C)*(6*r**2 - 6*r + 1)))/(30*d**2*k1**2) - D1**2*Pkd2*Pkd3*b1*k1**2*st**2*(D1**2*bd1**2*f*(r*(2 - 6*s) - 6*s**2 + 6*s - 1) + D1*b1*(D1*bd1*(f*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fd*(-6*r*s + r - 6*s**2 + 6*s - 1)) + D1*bdd1*f*(-3*r*s + r - 3*s**2 + 3*s - 1) + Dd*bd1*f*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) + b1**2*(D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r - 8*s**2 + 8*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(15*d**2*k2*k3) - D1**2*Pkd2*Pkd3*ct**8*k1**2*k2**3*(924*C*D1**2*f**2*fd*r*s - 308*C*D1**2*f**2*fd*r + 924*C*D1**2*f**2*fd*s**2 - 924*C*D1**2*f**2*fd*s + 308*C*D1**2*f**2*fd - 462*C*D1**2*f**2*fdd*r*s + 154*C*D1**2*f**2*fdd*r - 462*C*D1**2*f**2*fdd*s**2 + 462*C*D1**2*f**2*fdd*s - 154*C*D1**2*f**2*fdd - 924*C*D1**2*f*fd**2*r*s + 308*C*D1**2*f*fd**2*r - 924*C*D1**2*f*fd**2*s**2 + 924*C*D1**2*f*fd**2*s - 154*C*D1**2*f*fd**2 + 1232*C*D1*Dd*f**3*r*s - 308*C*D1*Dd*f**3*r + 1232*C*D1*Dd*f**3*s**2 - 1232*C*D1*Dd*f**3*s + 308*C*D1*Dd*f**3 - 3696*C*D1*Dd*f**2*fd*r*s + 1078*C*D1*Dd*f**2*fd*r - 3696*C*D1*Dd*f**2*fd*s**2 + 3696*C*D1*Dd*f**2*fd*s - 770*C*D1*Dd*f**2*fd - 616*C*D1*Ddd*f**3*r*s + 154*C*D1*Ddd*f**3*r - 616*C*D1*Ddd*f**3*s**2 + 616*C*D1*Ddd*f**3*s - 154*C*D1*Ddd*f**3 - 1848*C*Dd**2*f**3*r*s + 462*C*Dd**2*f**3*r - 1848*C*Dd**2*f**3*s**2 + 1848*C*Dd**2*f**3*s - 308*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 504*D1**2*f**3*fd*r*s - 126*D1**2*f**3*fd*r + 504*D1**2*f**3*fd*s**2 - 504*D1**2*f**3*fd*s + 126*D1**2*f**3*fd - 252*D1**2*f**3*fdd*r*s + 63*D1**2*f**3*fdd*r - 252*D1**2*f**3*fdd*s**2 + 252*D1**2*f**3*fdd*s - 63*D1**2*f**3*fdd - 756*D1**2*f**2*fd**2*r*s + 189*D1**2*f**2*fd**2*r - 756*D1**2*f**2*fd**2*s**2 + 756*D1**2*f**2*fd**2*s - 126*D1**2*f**2*fd**2 - 924*D1**2*f**2*fd*r*s + 308*D1**2*f**2*fd*r - 924*D1**2*f**2*fd*s**2 + 924*D1**2*f**2*fd*s - 308*D1**2*f**2*fd + 462*D1**2*f**2*fdd*r*s - 154*D1**2*f**2*fdd*r + 462*D1**2*f**2*fdd*s**2 - 462*D1**2*f**2*fdd*s + 154*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 924*D1**2*f*fd**2*r*s - 308*D1**2*f*fd**2*r + 924*D1**2*f*fd**2*s**2 - 924*D1**2*f*fd**2*s + 154*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 504*D1*Dd*f**4*r*s - 126*D1*Dd*f**4*r + 504*D1*Dd*f**4*s**2 - 504*D1*Dd*f**4*s + 126*D1*Dd*f**4 - 2016*D1*Dd*f**3*fd*r*s + 504*D1*Dd*f**3*fd*r - 2016*D1*Dd*f**3*fd*s**2 + 2016*D1*Dd*f**3*fd*s - 378*D1*Dd*f**3*fd - 1232*D1*Dd*f**3*r*s + 308*D1*Dd*f**3*r - 1232*D1*Dd*f**3*s**2 + 1232*D1*Dd*f**3*s - 308*D1*Dd*f**3 + 3696*D1*Dd*f**2*fd*r*s - 1078*D1*Dd*f**2*fd*r + 3696*D1*Dd*f**2*fd*s**2 - 3696*D1*Dd*f**2*fd*s + 770*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 252*D1*Ddd*f**4*r*s + 63*D1*Ddd*f**4*r - 252*D1*Ddd*f**4*s**2 + 252*D1*Ddd*f**4*s - 63*D1*Ddd*f**4 + 616*D1*Ddd*f**3*r*s - 154*D1*Ddd*f**3*r + 616*D1*Ddd*f**3*s**2 - 616*D1*Ddd*f**3*s + 154*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 756*Dd**2*f**4*r*s + 189*Dd**2*f**4*r - 756*Dd**2*f**4*s**2 + 756*Dd**2*f**4*s - 126*Dd**2*f**4 + 1848*Dd**2*f**3*r*s - 462*Dd**2*f**3*r + 1848*Dd**2*f**3*s**2 - 1848*Dd**2*f**3*s + 308*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**7*k1**3*k2**2*(10890*C*D1**2*f**2*fd*r*s - 3630*C*D1**2*f**2*fd*r + 10890*C*D1**2*f**2*fd*s**2 - 10890*C*D1**2*f**2*fd*s + 3630*C*D1**2*f**2*fd - 6930*C*D1**2*f**2*fdd*r*s + 2310*C*D1**2*f**2*fdd*r - 6930*C*D1**2*f**2*fdd*s**2 + 6930*C*D1**2*f**2*fdd*s - 2310*C*D1**2*f**2*fdd - 13860*C*D1**2*f*fd**2*r*s + 4620*C*D1**2*f*fd**2*r - 13860*C*D1**2*f*fd**2*s**2 + 13860*C*D1**2*f*fd**2*s - 2310*C*D1**2*f*fd**2 + 14520*C*D1*Dd*f**3*r*s - 3630*C*D1*Dd*f**3*r + 14520*C*D1*Dd*f**3*s**2 - 14520*C*D1*Dd*f**3*s + 3630*C*D1*Dd*f**3 - 55440*C*D1*Dd*f**2*fd*r*s + 16170*C*D1*Dd*f**2*fd*r - 55440*C*D1*Dd*f**2*fd*s**2 + 55440*C*D1*Dd*f**2*fd*s - 11550*C*D1*Dd*f**2*fd - 9240*C*D1*Ddd*f**3*r*s + 2310*C*D1*Ddd*f**3*r - 9240*C*D1*Ddd*f**3*s**2 + 9240*C*D1*Ddd*f**3*s - 2310*C*D1*Ddd*f**3 - 27720*C*Dd**2*f**3*r*s + 6930*C*Dd**2*f**3*r - 27720*C*Dd**2*f**3*s**2 + 27720*C*Dd**2*f**3*s - 4620*C*Dd**2*f**3 - 1485*D1**2*K*bdd1*f**2*r*s - 1485*D1**2*K*bdd1*f**2*s**2 + 1485*D1**2*K*bdd1*f**2*s + 1485*D1**2*bdd1*f**2*r*s + 1485*D1**2*bdd1*f**2*s**2 - 1485*D1**2*bdd1*f**2*s + 8540*D1**2*f**3*fd*r*s - 2135*D1**2*f**3*fd*r + 8540*D1**2*f**3*fd*s**2 - 8540*D1**2*f**3*fd*s + 2135*D1**2*f**3*fd - 5040*D1**2*f**3*fdd*r*s + 1260*D1**2*f**3*fdd*r - 5040*D1**2*f**3*fdd*s**2 + 5040*D1**2*f**3*fdd*s - 1260*D1**2*f**3*fdd - 15120*D1**2*f**2*fd**2*r*s + 3780*D1**2*f**2*fd**2*r - 15120*D1**2*f**2*fd**2*s**2 + 15120*D1**2*f**2*fd**2*s - 2520*D1**2*f**2*fd**2 - 10890*D1**2*f**2*fd*r*s + 3630*D1**2*f**2*fd*r - 10890*D1**2*f**2*fd*s**2 + 10890*D1**2*f**2*fd*s - 3630*D1**2*f**2*fd + 6930*D1**2*f**2*fdd*r*s - 2310*D1**2*f**2*fdd*r + 6930*D1**2*f**2*fdd*s**2 - 6930*D1**2*f**2*fdd*s + 2310*D1**2*f**2*fdd - 4554*D1**2*f**2*gd2*r*s - 4554*D1**2*f**2*gd2*s**2 + 4554*D1**2*f**2*gd2*s + 2970*D1**2*f**2*gdd2*r*s + 2970*D1**2*f**2*gdd2*s**2 - 2970*D1**2*f**2*gdd2*s + 13860*D1**2*f*fd**2*r*s - 4620*D1**2*f*fd**2*r + 13860*D1**2*f*fd**2*s**2 - 13860*D1**2*f*fd**2*s + 2310*D1**2*f*fd**2 - 9108*D1**2*f*fd*g2*r*s + 4554*D1**2*f*fd*g2*r - 9108*D1**2*f*fd*g2*s**2 + 9108*D1**2*f*fd*g2*s - 4554*D1**2*f*fd*g2 + 11880*D1**2*f*fd*gd2*r*s - 2970*D1**2*f*fd*gd2*r + 11880*D1**2*f*fd*gd2*s**2 - 11880*D1**2*f*fd*gd2*s + 2970*D1**2*f*fd*gd2 + 5940*D1**2*f*fdd*g2*r*s - 2970*D1**2*f*fdd*g2*r + 5940*D1**2*f*fdd*g2*s**2 - 5940*D1**2*f*fdd*g2*s + 2970*D1**2*f*fdd*g2 + 5940*D1**2*fd**2*g2*r*s - 2970*D1**2*fd**2*g2*r + 5940*D1**2*fd**2*g2*s**2 - 5940*D1**2*fd**2*g2*s + 8540*D1*Dd*f**4*r*s - 2135*D1*Dd*f**4*r + 8540*D1*Dd*f**4*s**2 - 8540*D1*Dd*f**4*s + 2135*D1*Dd*f**4 - 40320*D1*Dd*f**3*fd*r*s + 10080*D1*Dd*f**3*fd*r - 40320*D1*Dd*f**3*fd*s**2 + 40320*D1*Dd*f**3*fd*s - 7560*D1*Dd*f**3*fd - 14520*D1*Dd*f**3*r*s + 3630*D1*Dd*f**3*r - 14520*D1*Dd*f**3*s**2 + 14520*D1*Dd*f**3*s - 3630*D1*Dd*f**3 + 55440*D1*Dd*f**2*fd*r*s - 16170*D1*Dd*f**2*fd*r + 55440*D1*Dd*f**2*fd*s**2 - 55440*D1*Dd*f**2*fd*s + 11550*D1*Dd*f**2*fd - 18216*D1*Dd*f**2*g2*r*s + 4554*D1*Dd*f**2*g2*r - 18216*D1*Dd*f**2*g2*s**2 + 18216*D1*Dd*f**2*g2*s - 4554*D1*Dd*f**2*g2 + 23760*D1*Dd*f**2*gd2*r*s - 2970*D1*Dd*f**2*gd2*r + 23760*D1*Dd*f**2*gd2*s**2 - 23760*D1*Dd*f**2*gd2*s + 2970*D1*Dd*f**2*gd2 + 47520*D1*Dd*f*fd*g2*r*s - 17820*D1*Dd*f*fd*g2*r + 47520*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 11880*D1*Dd*f*fd*g2 - 5040*D1*Ddd*f**4*r*s + 1260*D1*Ddd*f**4*r - 5040*D1*Ddd*f**4*s**2 + 5040*D1*Ddd*f**4*s - 1260*D1*Ddd*f**4 + 9240*D1*Ddd*f**3*r*s - 2310*D1*Ddd*f**3*r + 9240*D1*Ddd*f**3*s**2 - 9240*D1*Ddd*f**3*s + 2310*D1*Ddd*f**3 + 11880*D1*Ddd*f**2*g2*r*s - 2970*D1*Ddd*f**2*g2*r + 11880*D1*Ddd*f**2*g2*s**2 - 11880*D1*Ddd*f**2*g2*s + 2970*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 15120*Dd**2*f**4*r*s + 3780*Dd**2*f**4*r - 15120*Dd**2*f**4*s**2 + 15120*Dd**2*f**4*s - 2520*Dd**2*f**4 + 27720*Dd**2*f**3*r*s - 6930*Dd**2*f**3*r + 27720*Dd**2*f**3*s**2 - 27720*Dd**2*f**3*s + 4620*Dd**2*f**3 + 35640*Dd**2*f**2*g2*r*s - 8910*Dd**2*f**2*g2*r + 35640*Dd**2*f**2*g2*s**2 - 35640*Dd**2*f**2*g2*s + 5940*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**7*k1*k2**4*(168*C*D1**2*f**2*fd*r*s - 56*C*D1**2*f**2*fd*r + 168*C*D1**2*f**2*fd*s**2 - 168*C*D1**2*f**2*fd*s + 56*C*D1**2*f**2*fd - 84*C*D1**2*f**2*fdd*r*s + 28*C*D1**2*f**2*fdd*r - 84*C*D1**2*f**2*fdd*s**2 + 84*C*D1**2*f**2*fdd*s - 28*C*D1**2*f**2*fdd - 168*C*D1**2*f*fd**2*r*s + 56*C*D1**2*f*fd**2*r - 168*C*D1**2*f*fd**2*s**2 + 168*C*D1**2*f*fd**2*s - 28*C*D1**2*f*fd**2 + 224*C*D1*Dd*f**3*r*s - 56*C*D1*Dd*f**3*r + 224*C*D1*Dd*f**3*s**2 - 224*C*D1*Dd*f**3*s + 56*C*D1*Dd*f**3 - 672*C*D1*Dd*f**2*fd*r*s + 196*C*D1*Dd*f**2*fd*r - 672*C*D1*Dd*f**2*fd*s**2 + 672*C*D1*Dd*f**2*fd*s - 140*C*D1*Dd*f**2*fd - 112*C*D1*Ddd*f**3*r*s + 28*C*D1*Ddd*f**3*r - 112*C*D1*Ddd*f**3*s**2 + 112*C*D1*Ddd*f**3*s - 28*C*D1*Ddd*f**3 - 336*C*Dd**2*f**3*r*s + 84*C*Dd**2*f**3*r - 336*C*Dd**2*f**3*s**2 + 336*C*Dd**2*f**3*s - 56*C*Dd**2*f**3 - 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s + 7*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 - 7*D1**2*bdd1*f**3*s + 9*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 - 9*D1**2*bdd1*f**2*s - 126*D1**2*f**2*fd*r*s + 42*D1**2*f**2*fd*r - 126*D1**2*f**2*fd*s**2 + 126*D1**2*f**2*fd*s - 42*D1**2*f**2*fd + 63*D1**2*f**2*fdd*r*s - 21*D1**2*f**2*fdd*r + 63*D1**2*f**2*fdd*s**2 - 63*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 126*D1**2*f*fd**2*r*s - 42*D1**2*f*fd**2*r + 126*D1**2*f*fd**2*s**2 - 126*D1**2*f*fd**2*s + 21*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 168*D1*Dd*f**3*r*s + 42*D1*Dd*f**3*r - 168*D1*Dd*f**3*s**2 + 168*D1*Dd*f**3*s - 42*D1*Dd*f**3 + 504*D1*Dd*f**2*fd*r*s - 147*D1*Dd*f**2*fd*r + 504*D1*Dd*f**2*fd*s**2 - 504*D1*Dd*f**2*fd*s + 105*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r*s - 36*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 288*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r*s - 216*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 576*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 84*D1*Ddd*f**3*r*s - 21*D1*Ddd*f**3*r + 84*D1*Ddd*f**3*s**2 - 84*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-18*K + 7*f + 9)*(r + s - 1) - 9*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-18*K + 7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 252*Dd**2*f**3*r*s - 63*Dd**2*f**3*r + 252*Dd**2*f**3*s**2 - 252*Dd**2*f**3*s + 42*Dd**2*f**3 + 432*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1)) - 9*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (36*K - 18)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 7*f + 9)) + Dd**2*f**2*(-18*K + 7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**7*k1*k2**2*(b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) - 18*fd*(2*r*s - r + 2*s**2 - 2*s + 1) + 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 18*r*(4*s - 1) - 18*(1 - 2*s)**2) + 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(7*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(7*bdd1*f**2*s*(r + s - 1) + f*(9*bdd1*s*(r + s - 1) - 14*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(7*f + 9)*(r + s - 1) + 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 7*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + 7*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k3**3) - D1**2*Pkd2*Pkd3*ct**6*k1**4*k2*(2640*C*D1**2*f**2*fd*r*s - 880*C*D1**2*f**2*fd*r + 2640*C*D1**2*f**2*fd*s**2 - 2640*C*D1**2*f**2*fd*s + 880*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r*s + 770*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 2310*C*D1**2*f**2*fdd*s - 770*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r*s + 1540*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 4620*C*D1**2*f*fd**2*s - 770*C*D1**2*f*fd**2 + 3520*C*D1*Dd*f**3*r*s - 880*C*D1*Dd*f**3*r + 3520*C*D1*Dd*f**3*s**2 - 3520*C*D1*Dd*f**3*s + 880*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r*s + 5390*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 18480*C*D1*Dd*f**2*fd*s - 3850*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r*s + 770*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 3080*C*D1*Ddd*f**3*s - 770*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r*s + 2310*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 9240*C*Dd**2*f**3*s - 1540*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 3500*D1**2*f**3*fd*r*s - 875*D1**2*f**3*fd*r + 3500*D1**2*f**3*fd*s**2 - 3500*D1**2*f**3*fd*s + 875*D1**2*f**3*fd - 2520*D1**2*f**3*fdd*r*s + 630*D1**2*f**3*fdd*r - 2520*D1**2*f**3*fdd*s**2 + 2520*D1**2*f**3*fdd*s - 630*D1**2*f**3*fdd - 7560*D1**2*f**2*fd**2*r*s + 1890*D1**2*f**2*fd**2*r - 7560*D1**2*f**2*fd**2*s**2 + 7560*D1**2*f**2*fd**2*s - 1260*D1**2*f**2*fd**2 - 2640*D1**2*f**2*fd*r*s + 880*D1**2*f**2*fd*r - 2640*D1**2*f**2*fd*s**2 + 2640*D1**2*f**2*fd*s - 880*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r*s - 770*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2310*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd - 1056*D1**2*f**2*gd2*r*s - 1056*D1**2*f**2*gd2*s**2 + 1056*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 4620*D1**2*f*fd**2*r*s - 1540*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 4620*D1**2*f*fd**2*s + 770*D1**2*f*fd**2 - 2112*D1**2*f*fd*g2*r*s + 1056*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s**2 + 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 3500*D1*Dd*f**4*r*s - 875*D1*Dd*f**4*r + 3500*D1*Dd*f**4*s**2 - 3500*D1*Dd*f**4*s + 875*D1*Dd*f**4 - 20160*D1*Dd*f**3*fd*r*s + 5040*D1*Dd*f**3*fd*r - 20160*D1*Dd*f**3*fd*s**2 + 20160*D1*Dd*f**3*fd*s - 3780*D1*Dd*f**3*fd - 3520*D1*Dd*f**3*r*s + 880*D1*Dd*f**3*r - 3520*D1*Dd*f**3*s**2 + 3520*D1*Dd*f**3*s - 880*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r*s - 5390*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 18480*D1*Dd*f**2*fd*s + 3850*D1*Dd*f**2*fd - 4224*D1*Dd*f**2*g2*r*s + 1056*D1*Dd*f**2*g2*r - 4224*D1*Dd*f**2*g2*s**2 + 4224*D1*Dd*f**2*g2*s - 1056*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 2520*D1*Ddd*f**4*r*s + 630*D1*Ddd*f**4*r - 2520*D1*Ddd*f**4*s**2 + 2520*D1*Ddd*f**4*s - 630*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r*s - 770*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 3080*D1*Ddd*f**3*s + 770*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(16*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 7560*Dd**2*f**4*r*s + 1890*Dd**2*f**4*r - 7560*Dd**2*f**4*s**2 + 7560*Dd**2*f**4*s - 1260*Dd**2*f**4 + 9240*Dd**2*f**3*r*s - 2310*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 9240*Dd**2*f**3*s + 1540*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(16*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - 15*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**6*k1**2*k2**3*st**2*(1980*C*D1**2*f**2*fd*r*s - 660*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd*s**2 - 1980*C*D1**2*f**2*fd*s + 660*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 2640*C*D1*Dd*f**3*r*s - 660*C*D1*Dd*f**3*r + 2640*C*D1*Dd*f**3*s**2 - 2640*C*D1*Dd*f**3*s + 660*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 1568*D1**2*f**3*fd*r*s - 392*D1**2*f**3*fd*r + 1568*D1**2*f**3*fd*s**2 - 1568*D1**2*f**3*fd*s + 392*D1**2*f**3*fd - 784*D1**2*f**3*fdd*r*s + 196*D1**2*f**3*fdd*r - 784*D1**2*f**3*fdd*s**2 + 784*D1**2*f**3*fdd*s - 196*D1**2*f**3*fdd - 2352*D1**2*f**2*fd**2*r*s + 588*D1**2*f**2*fd**2*r - 2352*D1**2*f**2*fd**2*s**2 + 2352*D1**2*f**2*fd**2*s - 392*D1**2*f**2*fd**2 - 1980*D1**2*f**2*fd*r*s + 660*D1**2*f**2*fd*r - 1980*D1**2*f**2*fd*s**2 + 1980*D1**2*f**2*fd*s - 660*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 1188*D1**2*f**2*gd2*r*s - 1188*D1**2*f**2*gd2*s**2 + 1188*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 2376*D1**2*f*fd*g2*r*s + 1188*D1**2*f*fd*g2*r - 2376*D1**2*f*fd*g2*s**2 + 2376*D1**2*f*fd*g2*s - 1188*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 1568*D1*Dd*f**4*r*s - 392*D1*Dd*f**4*r + 1568*D1*Dd*f**4*s**2 - 1568*D1*Dd*f**4*s + 392*D1*Dd*f**4 - 6272*D1*Dd*f**3*fd*r*s + 1568*D1*Dd*f**3*fd*r - 6272*D1*Dd*f**3*fd*s**2 + 6272*D1*Dd*f**3*fd*s - 1176*D1*Dd*f**3*fd - 2640*D1*Dd*f**3*r*s + 660*D1*Dd*f**3*r - 2640*D1*Dd*f**3*s**2 + 2640*D1*Dd*f**3*s - 660*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*g2*r*s + 1188*D1*Dd*f**2*g2*r - 4752*D1*Dd*f**2*g2*s**2 + 4752*D1*Dd*f**2*g2*s - 1188*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 784*D1*Ddd*f**4*r*s + 196*D1*Ddd*f**4*r - 784*D1*Ddd*f**4*s**2 + 784*D1*Ddd*f**4*s - 196*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 297*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 2352*Dd**2*f**4*r*s + 588*Dd**2*f**4*r - 2352*Dd**2*f**4*s**2 + 2352*Dd**2*f**4*s - 392*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 297*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**6*k1**2*k2**3*(-90*C*D1**2*bdd1*f**2*r*s + 90*C*D1**2*bdd1*f**2*r - 90*C*D1**2*bdd1*f**2*s**2 + 180*C*D1**2*bdd1*f**2*s - 90*C*D1**2*bdd1*f**2 + 1710*C*D1**2*f**2*fd*r*s - 570*C*D1**2*f**2*fd*r + 1710*C*D1**2*f**2*fd*s**2 - 1710*C*D1**2*f**2*fd*s + 570*C*D1**2*f**2*fd - 1260*C*D1**2*f**2*fdd*r*s + 420*C*D1**2*f**2*fdd*r - 1260*C*D1**2*f**2*fdd*s**2 + 1260*C*D1**2*f**2*fdd*s - 420*C*D1**2*f**2*fdd - 2520*C*D1**2*f*fd**2*r*s + 840*C*D1**2*f*fd**2*r - 2520*C*D1**2*f*fd**2*s**2 + 2520*C*D1**2*f*fd**2*s - 420*C*D1**2*f*fd**2 + 2280*C*D1*Dd*f**3*r*s - 570*C*D1*Dd*f**3*r + 2280*C*D1*Dd*f**3*s**2 - 2280*C*D1*Dd*f**3*s + 570*C*D1*Dd*f**3 - 10080*C*D1*Dd*f**2*fd*r*s + 2940*C*D1*Dd*f**2*fd*r - 10080*C*D1*Dd*f**2*fd*s**2 + 10080*C*D1*Dd*f**2*fd*s - 2100*C*D1*Dd*f**2*fd - 1680*C*D1*Ddd*f**3*r*s + 420*C*D1*Ddd*f**3*r - 1680*C*D1*Ddd*f**3*s**2 + 1680*C*D1*Ddd*f**3*s - 420*C*D1*Ddd*f**3 - 5040*C*Dd**2*f**3*r*s + 1260*C*Dd**2*f**3*r - 5040*C*Dd**2*f**3*s**2 + 5040*C*Dd**2*f**3*s - 840*C*Dd**2*f**3 - 270*D1**2*K*bdd1*f**2*r*s - 270*D1**2*K*bdd1*f**2*s**2 + 270*D1**2*K*bdd1*f**2*s - 63*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 105*D1**2*bdd1*f**3*r*s + 35*D1**2*bdd1*f**3*r + 105*D1**2*bdd1*f**3*s**2 - 70*D1**2*bdd1*f**3*s - 35*D1**2*bdd1*f**3 + 225*D1**2*bdd1*f**2*r*s - 90*D1**2*bdd1*f**2*r + 225*D1**2*bdd1*f**2*s**2 - 315*D1**2*bdd1*f**2*s + 90*D1**2*bdd1*f**2 + 126*D1**2*bdd1*f*g2*r*s - 126*D1**2*bdd1*f*g2*r + 126*D1**2*bdd1*f*g2*s**2 - 252*D1**2*bdd1*f*g2*s + 126*D1**2*bdd1*f*g2 - 140*D1**2*f**3*fd*r*s + 35*D1**2*f**3*fd*r - 140*D1**2*f**3*fd*s**2 + 140*D1**2*f**3*fd*s - 35*D1**2*f**3*fd - 1215*D1**2*f**2*fd*r*s + 405*D1**2*f**2*fd*r - 1215*D1**2*f**2*fd*s**2 + 1215*D1**2*f**2*fd*s - 405*D1**2*f**2*fd + 945*D1**2*f**2*fdd*r*s - 315*D1**2*f**2*fdd*r + 945*D1**2*f**2*fdd*s**2 - 945*D1**2*f**2*fdd*s + 315*D1**2*f**2*fdd - 702*D1**2*f**2*gd2*r*s - 702*D1**2*f**2*gd2*s**2 + 702*D1**2*f**2*gd2*s + 540*D1**2*f**2*gdd2*r*s + 540*D1**2*f**2*gdd2*s**2 - 540*D1**2*f**2*gdd2*s + 1890*D1**2*f*fd**2*r*s - 630*D1**2*f*fd**2*r + 1890*D1**2*f*fd**2*s**2 - 1890*D1**2*f*fd**2*s + 315*D1**2*f*fd**2 - 1404*D1**2*f*fd*g2*r*s + 702*D1**2*f*fd*g2*r - 1404*D1**2*f*fd*g2*s**2 + 1404*D1**2*f*fd*g2*s - 702*D1**2*f*fd*g2 + 2160*D1**2*f*fd*gd2*r*s - 540*D1**2*f*fd*gd2*r + 2160*D1**2*f*fd*gd2*s**2 - 2160*D1**2*f*fd*gd2*s + 540*D1**2*f*fd*gd2 + 1080*D1**2*f*fdd*g2*r*s - 540*D1**2*f*fdd*g2*r + 1080*D1**2*f*fdd*g2*s**2 - 1080*D1**2*f*fdd*g2*s + 540*D1**2*f*fdd*g2 + 1080*D1**2*fd**2*g2*r*s - 540*D1**2*fd**2*g2*r + 1080*D1**2*fd**2*g2*s**2 - 1080*D1**2*fd**2*g2*s - 140*D1*Dd*f**4*r*s + 35*D1*Dd*f**4*r - 140*D1*Dd*f**4*s**2 + 140*D1*Dd*f**4*s - 35*D1*Dd*f**4 - 1620*D1*Dd*f**3*r*s + 405*D1*Dd*f**3*r - 1620*D1*Dd*f**3*s**2 + 1620*D1*Dd*f**3*s - 405*D1*Dd*f**3 + 7560*D1*Dd*f**2*fd*r*s - 2205*D1*Dd*f**2*fd*r + 7560*D1*Dd*f**2*fd*s**2 - 7560*D1*Dd*f**2*fd*s + 1575*D1*Dd*f**2*fd - 2808*D1*Dd*f**2*g2*r*s + 702*D1*Dd*f**2*g2*r - 2808*D1*Dd*f**2*g2*s**2 + 2808*D1*Dd*f**2*g2*s - 702*D1*Dd*f**2*g2 + 4320*D1*Dd*f**2*gd2*r*s - 540*D1*Dd*f**2*gd2*r + 4320*D1*Dd*f**2*gd2*s**2 - 4320*D1*Dd*f**2*gd2*s + 540*D1*Dd*f**2*gd2 + 8640*D1*Dd*f*fd*g2*r*s - 3240*D1*Dd*f*fd*g2*r + 8640*D1*Dd*f*fd*g2*s**2 - 8640*D1*Dd*f*fd*g2*s + 2160*D1*Dd*f*fd*g2 + 1260*D1*Ddd*f**3*r*s - 315*D1*Ddd*f**3*r + 1260*D1*Ddd*f**3*s**2 - 1260*D1*Ddd*f**3*s + 315*D1*Ddd*f**3 + 2160*D1*Ddd*f**2*g2*r*s - 540*D1*Ddd*f**2*g2*r + 2160*D1*Ddd*f**2*g2*s**2 - 2160*D1*Ddd*f**2*g2*s + 540*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(33*s + 14)*(r + s - 1) + f**2*(180*C*(s - 1)*(r + s - 1) + 35*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + (9*r + 9*s - 9)*(39*K*s - 36*s + 20)) - 9*f*(5*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 6*K*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 7*r - 20*s**2 + 22*s - 5) + (14*r + 14*s - 14)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(35*f**2*(24*r*s + r + 4*s*(6*s - 5)) - 45*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 6*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 40*r*s + 13*r - 40*s**2 + 48*s - 11) + 126*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 3780*Dd**2*f**3*r*s - 945*Dd**2*f**3*r + 3780*Dd**2*f**3*s**2 - 3780*Dd**2*f**3*s + 630*Dd**2*f**3 + 6480*Dd**2*f**2*g2*r*s - 1620*Dd**2*f**2*g2*r + 6480*Dd**2*f**2*g2*s**2 - 6480*Dd**2*f**2*g2*s + 1080*Dd**2*f**2*g2 + 63*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(360*C*D1**2*f*fd*r*s + 360*C*D1**2*f*fd*s**2 - 180*C*D1**2*f*fd*s - 180*C*D1**2*f*fdd*r*s - 180*C*D1**2*f*fdd*s**2 + 90*C*D1**2*f*fdd*s - 180*C*D1**2*fd**2*r*s - 180*C*D1**2*fd**2*s**2 + 90*C*D1**2*fd**2*s + 720*C*D1*Dd*f**2*r*s - 180*C*D1*Dd*f**2*r + 720*C*D1*Dd*f**2*s**2 - 720*C*D1*Dd*f**2*s + 180*C*D1*Dd*f**2 - 1440*C*D1*Dd*f*fd*r*s + 180*C*D1*Dd*f*fd*r - 1440*C*D1*Dd*f*fd*s**2 + 1080*C*D1*Dd*f*fd*s - 90*C*D1*Dd*f*fd - 360*C*D1*Ddd*f**2*r*s + 90*C*D1*Ddd*f**2*r - 360*C*D1*Ddd*f**2*s**2 + 360*C*D1*Ddd*f**2*s - 90*C*D1*Ddd*f**2 - 1080*C*Dd**2*f**2*r*s + 270*C*Dd**2*f**2*r - 1080*C*Dd**2*f**2*s**2 + 1080*C*Dd**2*f**2*s - 180*C*Dd**2*f**2 + 702*D1**2*K*f*fd*r*s - 351*D1**2*K*f*fd*r + 702*D1**2*K*f*fd*s**2 - 702*D1**2*K*f*fd*s + 351*D1**2*K*f*fd - 540*D1**2*K*f*fdd*r*s + 270*D1**2*K*f*fdd*r - 540*D1**2*K*f*fdd*s**2 + 540*D1**2*K*f*fdd*s - 270*D1**2*K*f*fdd - 540*D1**2*K*fd**2*r*s + 270*D1**2*K*fd**2*r - 540*D1**2*K*fd**2*s**2 + 540*D1**2*K*fd**2*s - 63*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 495*D1**2*f**2*fd*r*s + 235*D1**2*f**2*fd*r - 495*D1**2*f**2*fd*s**2 + 565*D1**2*f**2*fd*s - 235*D1**2*f**2*fd + 315*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r + 315*D1**2*f**2*fdd*s**2 - 350*D1**2*f**2*fdd*s + 140*D1**2*f**2*fdd + 630*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r + 630*D1**2*f*fd**2*s**2 - 700*D1**2*f*fd**2*s + 140*D1**2*f*fd**2 - 648*D1**2*f*fd*r*s + 144*D1**2*f*fd*r - 648*D1**2*f*fd*s**2 + 468*D1**2*f*fd*s - 144*D1**2*f*fd + 450*D1**2*f*fdd*r*s - 135*D1**2*f*fdd*r + 450*D1**2*f*fdd*s**2 - 360*D1**2*f*fdd*s + 135*D1**2*f*fdd - 252*D1**2*f*gd2*r*s - 252*D1**2*f*gd2*s**2 + 252*D1**2*f*gd2*s + 126*D1**2*f*gdd2*r*s + 126*D1**2*f*gdd2*s**2 - 126*D1**2*f*gdd2*s + 450*D1**2*fd**2*r*s - 135*D1**2*fd**2*r + 450*D1**2*fd**2*s**2 - 360*D1**2*fd**2*s - 252*D1**2*fd*g2*r*s - 252*D1**2*fd*g2*s**2 + 252*D1**2*fd*gd2*r*s + 252*D1**2*fd*gd2*s**2 - 126*D1**2*fd*gd2*s + 126*D1**2*fdd*g2*r*s + 126*D1**2*fdd*g2*s**2 + 1404*D1*Dd*K*f**2*r*s - 351*D1*Dd*K*f**2*r + 1404*D1*Dd*K*f**2*s**2 - 1404*D1*Dd*K*f**2*s + 351*D1*Dd*K*f**2 - 4320*D1*Dd*K*f*fd*r*s + 1620*D1*Dd*K*f*fd*r - 4320*D1*Dd*K*f*fd*s**2 + 4320*D1*Dd*K*f*fd*s - 1080*D1*Dd*K*f*fd - 660*D1*Dd*f**3*r*s + 165*D1*Dd*f**3*r - 660*D1*Dd*f**3*s**2 + 660*D1*Dd*f**3*s - 165*D1*Dd*f**3 + 2520*D1*Dd*f**2*fd*r*s - 875*D1*Dd*f**2*fd*r + 2520*D1*Dd*f**2*fd*s**2 - 2660*D1*Dd*f**2*fd*s + 630*D1*Dd*f**2*fd - 1296*D1*Dd*f**2*r*s + 324*D1*Dd*f**2*r - 1296*D1*Dd*f**2*s**2 + 1296*D1*Dd*f**2*s - 324*D1*Dd*f**2 + 3600*D1*Dd*f*fd*r*s - 990*D1*Dd*f*fd*r + 3600*D1*Dd*f*fd*s**2 - 3240*D1*Dd*f*fd*s + 630*D1*Dd*f*fd - 1008*D1*Dd*f*g2*r*s + 252*D1*Dd*f*g2*r - 1008*D1*Dd*f*g2*s**2 + 1008*D1*Dd*f*g2*s - 252*D1*Dd*f*g2 + 1008*D1*Dd*f*gd2*r*s - 126*D1*Dd*f*gd2*r + 1008*D1*Dd*f*gd2*s**2 - 1008*D1*Dd*f*gd2*s + 126*D1*Dd*f*gd2 + 1008*D1*Dd*fd*g2*r*s - 126*D1*Dd*fd*g2*r + 1008*D1*Dd*fd*g2*s**2 - 504*D1*Dd*fd*g2*s - 1080*D1*Ddd*K*f**2*r*s + 270*D1*Ddd*K*f**2*r - 1080*D1*Ddd*K*f**2*s**2 + 1080*D1*Ddd*K*f**2*s - 270*D1*Ddd*K*f**2 + 420*D1*Ddd*f**3*r*s - 105*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s**2 - 420*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 + 900*D1*Ddd*f**2*r*s - 225*D1*Ddd*f**2*r + 900*D1*Ddd*f**2*s**2 - 900*D1*Ddd*f**2*s + 225*D1*Ddd*f**2 + 504*D1*Ddd*f*g2*r*s - 126*D1*Ddd*f*g2*r + 504*D1*Ddd*f*g2*s**2 - 504*D1*Ddd*f*g2*s + 126*D1*Ddd*f*g2 + 63*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 3240*Dd**2*K*f**2*r*s + 810*Dd**2*K*f**2*r - 3240*Dd**2*K*f**2*s**2 + 3240*Dd**2*K*f**2*s - 540*Dd**2*K*f**2 + 1260*Dd**2*f**3*r*s - 315*Dd**2*f**3*r + 1260*Dd**2*f**3*s**2 - 1260*Dd**2*f**3*s + 210*Dd**2*f**3 + 2700*Dd**2*f**2*r*s - 675*Dd**2*f**2*r + 2700*Dd**2*f**2*s**2 - 2700*Dd**2*f**2*s + 450*Dd**2*f**2 + 1512*Dd**2*f*g2*r*s - 378*Dd**2*f*g2*r + 1512*Dd**2*f*g2*s**2 - 1512*Dd**2*f*g2*s + 252*Dd**2*f*g2))/(315*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**6*k1**2*k2*(63*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(-5*f**3*s*(47*r + 47*s - 33) + f**2*(35*fd*(6*s - 1)*(4*r + 4*s - 3) - 9*s*(20*C*s + r*(20*C + 3) + 3*s - 23)) + 9*f*(5*fd*(r*(2*C + 1)*(4*s - 1) + s**2*(8*C + 4) - s*(6*C + 6) + 3) + 14*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) - 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(35*f**2*(8*s - 1)*(4*r + 4*s - 3) + 45*f*(r*(2*C + 1)*(8*s - 1) + s**2*(16*C + 8) - s*(8*C + 16) + 3) - 126*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 63*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(-5*f**2*(fd*(47*r*(3*s - 1) + 141*s**2 - 155*s + 47) - 7*fdd*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4)) + f*(35*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) - 9*fd*(20*C*(2*s - 1)*(r + s - 1) + 6*r*s - 3*r + 6*s**2 + 14*s + 3) + 45*fdd*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 + 1) + 63*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) + 45*fd**2*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 - 2) + 126*fd*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) - 126*fdd*g2*(s - 1)*(r + s - 1)) + 63*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(-235*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(-180*C*(r*(4*s - 1) + (1 - 2*s)**2) + 35*fd*(24*s - 7)*(4*r + 4*s - 3) - 27*r*(4*s - 1) - 27*(1 - 2*s)**2) + 18*f*(5*fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + r*(8*s - 3) + 8*s**2 - 4*s + 1) + 7*g2*r*(8*s - 2) + 14*g2*(1 - 2*s)**2 + 7*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) - 126*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(140*f**2 + f*(90*C + 45) - 126*g2)) + Dd**2*f*(140*f**2 + f*(90*C + 45) - 126*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(35*bdd1*f**2*s*(4*r + 4*s - 3) + 45*bdd1*f*s*(2*C*r + 2*C*s + r + s - 3) - 126*bdd1*g2*s*(r + s) - 165*f*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 105*f*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 105*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 15*D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 7*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 105*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**6*k2**5*(D1**2*(f**2*(-fd*(28*C - 14)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(14*C - 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(9*K*(-2*bd1 + bdd1) + 36*gd2 - 18*gdd2)) + f*(fd**2*(14*C - 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 9*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) - 9*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 9*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(14 - 28*C)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(9*K*(b1*r*(2 - 8*s) - 2*b1*(1 - 2*s)**2 + bd1*r*(8*s - 1) + 8*bd1*s**2 - 8*bd1*s + bd1) + fd*(14*C - 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 36*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 18*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 18*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(14*C*f + 9*K*b1 - 7*f - 18*g2)) + Dd**2*f**2*(14*C*f + 9*K*b1 - 7*f - 18*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(63*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**6*k2**3*(84*C*D1**2*f**2*fd*r*s - 28*C*D1**2*f**2*fd*r + 84*C*D1**2*f**2*fd*s**2 - 84*C*D1**2*f**2*fd*s + 28*C*D1**2*f**2*fd - 42*C*D1**2*f**2*fdd*r*s + 14*C*D1**2*f**2*fdd*r - 42*C*D1**2*f**2*fdd*s**2 + 42*C*D1**2*f**2*fdd*s - 14*C*D1**2*f**2*fdd - 84*C*D1**2*f*fd**2*r*s + 28*C*D1**2*f*fd**2*r - 84*C*D1**2*f*fd**2*s**2 + 84*C*D1**2*f*fd**2*s - 14*C*D1**2*f*fd**2 + 112*C*D1*Dd*f**3*r*s - 28*C*D1*Dd*f**3*r + 112*C*D1*Dd*f**3*s**2 - 112*C*D1*Dd*f**3*s + 28*C*D1*Dd*f**3 - 336*C*D1*Dd*f**2*fd*r*s + 98*C*D1*Dd*f**2*fd*r - 336*C*D1*Dd*f**2*fd*s**2 + 336*C*D1*Dd*f**2*fd*s - 70*C*D1*Dd*f**2*fd - 56*C*D1*Ddd*f**3*r*s + 14*C*D1*Ddd*f**3*r - 56*C*D1*Ddd*f**3*s**2 + 56*C*D1*Ddd*f**3*s - 14*C*D1*Ddd*f**3 - 168*C*Dd**2*f**3*r*s + 42*C*Dd**2*f**3*r - 168*C*Dd**2*f**3*s**2 + 168*C*Dd**2*f**3*s - 28*C*Dd**2*f**3 + 36*D1**2*K*b1*f*fd*r*s - 18*D1**2*K*b1*f*fd*r + 36*D1**2*K*b1*f*fd*s**2 - 36*D1**2*K*b1*f*fd*s + 18*D1**2*K*b1*f*fd - 18*D1**2*K*b1*f*fdd*r*s + 9*D1**2*K*b1*f*fdd*r - 18*D1**2*K*b1*f*fdd*s**2 + 18*D1**2*K*b1*f*fdd*s - 9*D1**2*K*b1*f*fdd - 18*D1**2*K*b1*fd**2*r*s + 9*D1**2*K*b1*fd**2*r - 18*D1**2*K*b1*fd**2*s**2 + 18*D1**2*K*b1*fd**2*s + 18*D1**2*K*bd1*f**2*r*s + 18*D1**2*K*bd1*f**2*s**2 - 18*D1**2*K*bd1*f**2*s - 36*D1**2*K*bd1*f*fd*r*s + 9*D1**2*K*bd1*f*fd*r - 36*D1**2*K*bd1*f*fd*s**2 + 36*D1**2*K*bd1*f*fd*s - 9*D1**2*K*bd1*f*fd - 9*D1**2*K*bdd1*f**2*r*s - 9*D1**2*K*bdd1*f**2*s**2 + 9*D1**2*K*bdd1*f**2*s - 9*D1**2*bdd2*f**2*r*s - 9*D1**2*bdd2*f**2*s**2 + 9*D1**2*bdd2*f**2*s - 42*D1**2*f**2*fd*r*s + 14*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 42*D1**2*f**2*fd*s - 14*D1**2*f**2*fd + 21*D1**2*f**2*fdd*r*s - 7*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s**2 - 21*D1**2*f**2*fdd*s + 7*D1**2*f**2*fdd - 36*D1**2*f**2*gd2*r*s - 36*D1**2*f**2*gd2*s**2 + 36*D1**2*f**2*gd2*s + 18*D1**2*f**2*gdd2*r*s + 18*D1**2*f**2*gdd2*s**2 - 18*D1**2*f**2*gdd2*s + 42*D1**2*f*fd**2*r*s - 14*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s**2 - 42*D1**2*f*fd**2*s + 7*D1**2*f*fd**2 - 72*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 72*D1**2*f*fd*g2*s - 36*D1**2*f*fd*g2 + 72*D1**2*f*fd*gd2*r*s - 18*D1**2*f*fd*gd2*r + 72*D1**2*f*fd*gd2*s**2 - 72*D1**2*f*fd*gd2*s + 18*D1**2*f*fd*gd2 + 36*D1**2*f*fdd*g2*r*s - 18*D1**2*f*fdd*g2*r + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 36*D1**2*fd**2*g2*r*s - 18*D1**2*fd**2*g2*r + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 72*D1*Dd*K*b1*f**2*r*s - 18*D1*Dd*K*b1*f**2*r + 72*D1*Dd*K*b1*f**2*s**2 - 72*D1*Dd*K*b1*f**2*s + 18*D1*Dd*K*b1*f**2 - 144*D1*Dd*K*b1*f*fd*r*s + 54*D1*Dd*K*b1*f*fd*r - 144*D1*Dd*K*b1*f*fd*s**2 + 144*D1*Dd*K*b1*f*fd*s - 36*D1*Dd*K*b1*f*fd - 72*D1*Dd*K*bd1*f**2*r*s + 9*D1*Dd*K*bd1*f**2*r - 72*D1*Dd*K*bd1*f**2*s**2 + 72*D1*Dd*K*bd1*f**2*s - 9*D1*Dd*K*bd1*f**2 - 56*D1*Dd*f**3*r*s + 14*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 56*D1*Dd*f**3*s - 14*D1*Dd*f**3 + 168*D1*Dd*f**2*fd*r*s - 49*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s**2 - 168*D1*Dd*f**2*fd*s + 35*D1*Dd*f**2*fd - 144*D1*Dd*f**2*g2*r*s + 36*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 144*D1*Dd*f**2*g2*s - 36*D1*Dd*f**2*g2 + 144*D1*Dd*f**2*gd2*r*s - 18*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s**2 - 144*D1*Dd*f**2*gd2*s + 18*D1*Dd*f**2*gd2 + 288*D1*Dd*f*fd*g2*r*s - 108*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s**2 - 288*D1*Dd*f*fd*g2*s + 72*D1*Dd*f*fd*g2 - 36*D1*Ddd*K*b1*f**2*r*s + 9*D1*Ddd*K*b1*f**2*r - 36*D1*Ddd*K*b1*f**2*s**2 + 36*D1*Ddd*K*b1*f**2*s - 9*D1*Ddd*K*b1*f**2 + 28*D1*Ddd*f**3*r*s - 7*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 28*D1*Ddd*f**3*s + 7*D1*Ddd*f**3 + 72*D1*Ddd*f**2*g2*r*s - 18*D1*Ddd*f**2*g2*r + 72*D1*Ddd*f**2*g2*s**2 - 72*D1*Ddd*f**2*g2*s + 18*D1*Ddd*f**2*g2 + 9*D1*bd2*f*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 108*Dd**2*K*b1*f**2*r*s + 27*Dd**2*K*b1*f**2*r - 108*Dd**2*K*b1*f**2*s**2 + 108*Dd**2*K*b1*f**2*s - 18*Dd**2*K*b1*f**2 + 84*Dd**2*f**3*r*s - 21*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 84*Dd**2*f**3*s + 14*Dd**2*f**3 + 216*Dd**2*f**2*g2*r*s - 54*Dd**2*f**2*g2*r + 216*Dd**2*f**2*g2*s**2 - 216*Dd**2*f**2*g2*s + 36*Dd**2*f**2*g2 + 9*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(63*d**2*k3**3) - D1**2*Pkd2*Pkd3*ct**5*k1**5*(1650*C*D1**2*f**2*fd*r*s - 550*C*D1**2*f**2*fd*r + 1650*C*D1**2*f**2*fd*s**2 - 1650*C*D1**2*f**2*fd*s + 550*C*D1**2*f**2*fd - 2310*C*D1**2*f**2*fdd*r*s + 770*C*D1**2*f**2*fdd*r - 2310*C*D1**2*f**2*fdd*s**2 + 2310*C*D1**2*f**2*fdd*s - 770*C*D1**2*f**2*fdd - 4620*C*D1**2*f*fd**2*r*s + 1540*C*D1**2*f*fd**2*r - 4620*C*D1**2*f*fd**2*s**2 + 4620*C*D1**2*f*fd**2*s - 770*C*D1**2*f*fd**2 + 2200*C*D1*Dd*f**3*r*s - 550*C*D1*Dd*f**3*r + 2200*C*D1*Dd*f**3*s**2 - 2200*C*D1*Dd*f**3*s + 550*C*D1*Dd*f**3 - 18480*C*D1*Dd*f**2*fd*r*s + 5390*C*D1*Dd*f**2*fd*r - 18480*C*D1*Dd*f**2*fd*s**2 + 18480*C*D1*Dd*f**2*fd*s - 3850*C*D1*Dd*f**2*fd - 3080*C*D1*Ddd*f**3*r*s + 770*C*D1*Ddd*f**3*r - 3080*C*D1*Ddd*f**3*s**2 + 3080*C*D1*Ddd*f**3*s - 770*C*D1*Ddd*f**3 - 9240*C*Dd**2*f**3*r*s + 2310*C*Dd**2*f**3*r - 9240*C*Dd**2*f**3*s**2 + 9240*C*Dd**2*f**3*s - 1540*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 5460*D1**2*f**3*fd*r*s - 1365*D1**2*f**3*fd*r + 5460*D1**2*f**3*fd*s**2 - 5460*D1**2*f**3*fd*s + 1365*D1**2*f**3*fd - 5040*D1**2*f**3*fdd*r*s + 1260*D1**2*f**3*fdd*r - 5040*D1**2*f**3*fdd*s**2 + 5040*D1**2*f**3*fdd*s - 1260*D1**2*f**3*fdd - 15120*D1**2*f**2*fd**2*r*s + 3780*D1**2*f**2*fd**2*r - 15120*D1**2*f**2*fd**2*s**2 + 15120*D1**2*f**2*fd**2*s - 2520*D1**2*f**2*fd**2 - 1650*D1**2*f**2*fd*r*s + 550*D1**2*f**2*fd*r - 1650*D1**2*f**2*fd*s**2 + 1650*D1**2*f**2*fd*s - 550*D1**2*f**2*fd + 2310*D1**2*f**2*fdd*r*s - 770*D1**2*f**2*fdd*r + 2310*D1**2*f**2*fdd*s**2 - 2310*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd - 594*D1**2*f**2*gd2*r*s - 594*D1**2*f**2*gd2*s**2 + 594*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 4620*D1**2*f*fd**2*r*s - 1540*D1**2*f*fd**2*r + 4620*D1**2*f*fd**2*s**2 - 4620*D1**2*f*fd**2*s + 770*D1**2*f*fd**2 - 1188*D1**2*f*fd*g2*r*s + 594*D1**2*f*fd*g2*r - 1188*D1**2*f*fd*g2*s**2 + 1188*D1**2*f*fd*g2*s - 594*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 5460*D1*Dd*f**4*r*s - 1365*D1*Dd*f**4*r + 5460*D1*Dd*f**4*s**2 - 5460*D1*Dd*f**4*s + 1365*D1*Dd*f**4 - 40320*D1*Dd*f**3*fd*r*s + 10080*D1*Dd*f**3*fd*r - 40320*D1*Dd*f**3*fd*s**2 + 40320*D1*Dd*f**3*fd*s - 7560*D1*Dd*f**3*fd - 2200*D1*Dd*f**3*r*s + 550*D1*Dd*f**3*r - 2200*D1*Dd*f**3*s**2 + 2200*D1*Dd*f**3*s - 550*D1*Dd*f**3 + 18480*D1*Dd*f**2*fd*r*s - 5390*D1*Dd*f**2*fd*r + 18480*D1*Dd*f**2*fd*s**2 - 18480*D1*Dd*f**2*fd*s + 3850*D1*Dd*f**2*fd - 2376*D1*Dd*f**2*g2*r*s + 594*D1*Dd*f**2*g2*r - 2376*D1*Dd*f**2*g2*s**2 + 2376*D1*Dd*f**2*g2*s - 594*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 5040*D1*Ddd*f**4*r*s + 1260*D1*Ddd*f**4*r - 5040*D1*Ddd*f**4*s**2 + 5040*D1*Ddd*f**4*s - 1260*D1*Ddd*f**4 + 3080*D1*Ddd*f**3*r*s - 770*D1*Ddd*f**3*r + 3080*D1*Ddd*f**3*s**2 - 3080*D1*Ddd*f**3*s + 770*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(3*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 15120*Dd**2*f**4*r*s + 3780*Dd**2*f**4*r - 15120*Dd**2*f**4*s**2 + 15120*Dd**2*f**4*s - 2520*Dd**2*f**4 + 9240*Dd**2*f**3*r*s - 2310*Dd**2*f**3*r + 9240*Dd**2*f**3*s**2 - 9240*Dd**2*f**3*s + 1540*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(3*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(3*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**5*k1**3*k2**2*st**2*(5412*C*D1**2*f**2*fd*r*s - 1804*C*D1**2*f**2*fd*r + 5412*C*D1**2*f**2*fd*s**2 - 5412*C*D1**2*f**2*fd*s + 1804*C*D1**2*f**2*fd - 3300*C*D1**2*f**2*fdd*r*s + 1100*C*D1**2*f**2*fdd*r - 3300*C*D1**2*f**2*fdd*s**2 + 3300*C*D1**2*f**2*fdd*s - 1100*C*D1**2*f**2*fdd - 6600*C*D1**2*f*fd**2*r*s + 2200*C*D1**2*f*fd**2*r - 6600*C*D1**2*f*fd**2*s**2 + 6600*C*D1**2*f*fd**2*s - 1100*C*D1**2*f*fd**2 + 7216*C*D1*Dd*f**3*r*s - 1804*C*D1*Dd*f**3*r + 7216*C*D1*Dd*f**3*s**2 - 7216*C*D1*Dd*f**3*s + 1804*C*D1*Dd*f**3 - 26400*C*D1*Dd*f**2*fd*r*s + 7700*C*D1*Dd*f**2*fd*r - 26400*C*D1*Dd*f**2*fd*s**2 + 26400*C*D1*Dd*f**2*fd*s - 5500*C*D1*Dd*f**2*fd - 4400*C*D1*Ddd*f**3*r*s + 1100*C*D1*Ddd*f**3*r - 4400*C*D1*Ddd*f**3*s**2 + 4400*C*D1*Ddd*f**3*s - 1100*C*D1*Ddd*f**3 - 13200*C*Dd**2*f**3*r*s + 3300*C*Dd**2*f**3*r - 13200*C*Dd**2*f**3*s**2 + 13200*C*Dd**2*f**3*s - 2200*C*Dd**2*f**3 - 990*D1**2*K*bdd1*f**2*r*s - 990*D1**2*K*bdd1*f**2*s**2 + 990*D1**2*K*bdd1*f**2*s + 990*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*s**2 - 990*D1**2*bdd1*f**2*s + 6740*D1**2*f**3*fd*r*s - 1685*D1**2*f**3*fd*r + 6740*D1**2*f**3*fd*s**2 - 6740*D1**2*f**3*fd*s + 1685*D1**2*f**3*fd - 3920*D1**2*f**3*fdd*r*s + 980*D1**2*f**3*fdd*r - 3920*D1**2*f**3*fdd*s**2 + 3920*D1**2*f**3*fdd*s - 980*D1**2*f**3*fdd - 11760*D1**2*f**2*fd**2*r*s + 2940*D1**2*f**2*fd**2*r - 11760*D1**2*f**2*fd**2*s**2 + 11760*D1**2*f**2*fd**2*s - 1960*D1**2*f**2*fd**2 - 5412*D1**2*f**2*fd*r*s + 1804*D1**2*f**2*fd*r - 5412*D1**2*f**2*fd*s**2 + 5412*D1**2*f**2*fd*s - 1804*D1**2*f**2*fd + 3300*D1**2*f**2*fdd*r*s - 1100*D1**2*f**2*fdd*r + 3300*D1**2*f**2*fdd*s**2 - 3300*D1**2*f**2*fdd*s + 1100*D1**2*f**2*fdd - 3036*D1**2*f**2*gd2*r*s - 3036*D1**2*f**2*gd2*s**2 + 3036*D1**2*f**2*gd2*s + 1980*D1**2*f**2*gdd2*r*s + 1980*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 6600*D1**2*f*fd**2*r*s - 2200*D1**2*f*fd**2*r + 6600*D1**2*f*fd**2*s**2 - 6600*D1**2*f*fd**2*s + 1100*D1**2*f*fd**2 - 6072*D1**2*f*fd*g2*r*s + 3036*D1**2*f*fd*g2*r - 6072*D1**2*f*fd*g2*s**2 + 6072*D1**2*f*fd*g2*s - 3036*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s + 6740*D1*Dd*f**4*r*s - 1685*D1*Dd*f**4*r + 6740*D1*Dd*f**4*s**2 - 6740*D1*Dd*f**4*s + 1685*D1*Dd*f**4 - 31360*D1*Dd*f**3*fd*r*s + 7840*D1*Dd*f**3*fd*r - 31360*D1*Dd*f**3*fd*s**2 + 31360*D1*Dd*f**3*fd*s - 5880*D1*Dd*f**3*fd - 7216*D1*Dd*f**3*r*s + 1804*D1*Dd*f**3*r - 7216*D1*Dd*f**3*s**2 + 7216*D1*Dd*f**3*s - 1804*D1*Dd*f**3 + 26400*D1*Dd*f**2*fd*r*s - 7700*D1*Dd*f**2*fd*r + 26400*D1*Dd*f**2*fd*s**2 - 26400*D1*Dd*f**2*fd*s + 5500*D1*Dd*f**2*fd - 12144*D1*Dd*f**2*g2*r*s + 3036*D1*Dd*f**2*g2*r - 12144*D1*Dd*f**2*g2*s**2 + 12144*D1*Dd*f**2*g2*s - 3036*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r*s - 1980*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 15840*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 31680*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 - 3920*D1*Ddd*f**4*r*s + 980*D1*Ddd*f**4*r - 3920*D1*Ddd*f**4*s**2 + 3920*D1*Ddd*f**4*s - 980*D1*Ddd*f**4 + 4400*D1*Ddd*f**3*r*s - 1100*D1*Ddd*f**3*r + 4400*D1*Ddd*f**3*s**2 - 4400*D1*Ddd*f**3*s + 1100*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 1980*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 11760*Dd**2*f**4*r*s + 2940*Dd**2*f**4*r - 11760*Dd**2*f**4*s**2 + 11760*Dd**2*f**4*s - 1960*Dd**2*f**4 + 13200*Dd**2*f**3*r*s - 3300*Dd**2*f**3*r + 13200*Dd**2*f**3*s**2 - 13200*Dd**2*f**3*s + 2200*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 3960*Dd**2*f**2*g2 + 66*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**5*k1**3*k2**2*(-270*C*D1**2*bdd1*f**2*r*s + 270*C*D1**2*bdd1*f**2*r - 270*C*D1**2*bdd1*f**2*s**2 + 540*C*D1**2*bdd1*f**2*s - 270*C*D1**2*bdd1*f**2 + 900*C*D1**2*f**2*fd*r*s - 300*C*D1**2*f**2*fd*r + 900*C*D1**2*f**2*fd*s**2 - 900*C*D1**2*f**2*fd*s + 300*C*D1**2*f**2*fd - 1260*C*D1**2*f**2*fdd*r*s + 420*C*D1**2*f**2*fdd*r - 1260*C*D1**2*f**2*fdd*s**2 + 1260*C*D1**2*f**2*fdd*s - 420*C*D1**2*f**2*fdd - 2520*C*D1**2*f*fd**2*r*s + 840*C*D1**2*f*fd**2*r - 2520*C*D1**2*f*fd**2*s**2 + 2520*C*D1**2*f*fd**2*s - 420*C*D1**2*f*fd**2 + 1200*C*D1*Dd*f**3*r*s - 300*C*D1*Dd*f**3*r + 1200*C*D1*Dd*f**3*s**2 - 1200*C*D1*Dd*f**3*s + 300*C*D1*Dd*f**3 - 10080*C*D1*Dd*f**2*fd*r*s + 2940*C*D1*Dd*f**2*fd*r - 10080*C*D1*Dd*f**2*fd*s**2 + 10080*C*D1*Dd*f**2*fd*s - 2100*C*D1*Dd*f**2*fd - 1680*C*D1*Ddd*f**3*r*s + 420*C*D1*Ddd*f**3*r - 1680*C*D1*Ddd*f**3*s**2 + 1680*C*D1*Ddd*f**3*s - 420*C*D1*Ddd*f**3 - 5040*C*Dd**2*f**3*r*s + 1260*C*Dd**2*f**3*r - 5040*C*Dd**2*f**3*s**2 + 5040*C*Dd**2*f**3*s - 840*C*Dd**2*f**3 - 270*D1**2*K*bdd1*f**2*r*s - 270*D1**2*K*bdd1*f**2*s**2 + 270*D1**2*K*bdd1*f**2*s - 189*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 70*D1**2*bdd1*f**3*r*s + 140*D1**2*bdd1*f**3*r + 70*D1**2*bdd1*f**3*s**2 + 70*D1**2*bdd1*f**3*s - 140*D1**2*bdd1*f**3 + 405*D1**2*bdd1*f**2*r*s - 270*D1**2*bdd1*f**2*r + 405*D1**2*bdd1*f**2*s**2 - 675*D1**2*bdd1*f**2*s + 270*D1**2*bdd1*f**2 + 378*D1**2*bdd1*f*g2*r*s - 378*D1**2*bdd1*f*g2*r + 378*D1**2*bdd1*f*g2*s**2 - 756*D1**2*bdd1*f*g2*s + 378*D1**2*bdd1*f*g2 - 420*D1**2*f**3*fd*r*s + 105*D1**2*f**3*fd*r - 420*D1**2*f**3*fd*s**2 + 420*D1**2*f**3*fd*s - 105*D1**2*f**3*fd - 540*D1**2*f**2*fd*r*s + 180*D1**2*f**2*fd*r - 540*D1**2*f**2*fd*s**2 + 540*D1**2*f**2*fd*s - 180*D1**2*f**2*fd + 945*D1**2*f**2*fdd*r*s - 315*D1**2*f**2*fdd*r + 945*D1**2*f**2*fdd*s**2 - 945*D1**2*f**2*fdd*s + 315*D1**2*f**2*fdd - 324*D1**2*f**2*gd2*r*s - 324*D1**2*f**2*gd2*s**2 + 324*D1**2*f**2*gd2*s + 540*D1**2*f**2*gdd2*r*s + 540*D1**2*f**2*gdd2*s**2 - 540*D1**2*f**2*gdd2*s + 1890*D1**2*f*fd**2*r*s - 630*D1**2*f*fd**2*r + 1890*D1**2*f*fd**2*s**2 - 1890*D1**2*f*fd**2*s + 315*D1**2*f*fd**2 - 648*D1**2*f*fd*g2*r*s + 324*D1**2*f*fd*g2*r - 648*D1**2*f*fd*g2*s**2 + 648*D1**2*f*fd*g2*s - 324*D1**2*f*fd*g2 + 2160*D1**2*f*fd*gd2*r*s - 540*D1**2*f*fd*gd2*r + 2160*D1**2*f*fd*gd2*s**2 - 2160*D1**2*f*fd*gd2*s + 540*D1**2*f*fd*gd2 + 1080*D1**2*f*fdd*g2*r*s - 540*D1**2*f*fdd*g2*r + 1080*D1**2*f*fdd*g2*s**2 - 1080*D1**2*f*fdd*g2*s + 540*D1**2*f*fdd*g2 + 1080*D1**2*fd**2*g2*r*s - 540*D1**2*fd**2*g2*r + 1080*D1**2*fd**2*g2*s**2 - 1080*D1**2*fd**2*g2*s - 420*D1*Dd*f**4*r*s + 105*D1*Dd*f**4*r - 420*D1*Dd*f**4*s**2 + 420*D1*Dd*f**4*s - 105*D1*Dd*f**4 - 720*D1*Dd*f**3*r*s + 180*D1*Dd*f**3*r - 720*D1*Dd*f**3*s**2 + 720*D1*Dd*f**3*s - 180*D1*Dd*f**3 + 7560*D1*Dd*f**2*fd*r*s - 2205*D1*Dd*f**2*fd*r + 7560*D1*Dd*f**2*fd*s**2 - 7560*D1*Dd*f**2*fd*s + 1575*D1*Dd*f**2*fd - 1296*D1*Dd*f**2*g2*r*s + 324*D1*Dd*f**2*g2*r - 1296*D1*Dd*f**2*g2*s**2 + 1296*D1*Dd*f**2*g2*s - 324*D1*Dd*f**2*g2 + 4320*D1*Dd*f**2*gd2*r*s - 540*D1*Dd*f**2*gd2*r + 4320*D1*Dd*f**2*gd2*s**2 - 4320*D1*Dd*f**2*gd2*s + 540*D1*Dd*f**2*gd2 + 8640*D1*Dd*f*fd*g2*r*s - 3240*D1*Dd*f*fd*g2*r + 8640*D1*Dd*f*fd*g2*s**2 - 8640*D1*Dd*f*fd*g2*s + 2160*D1*Dd*f*fd*g2 + 1260*D1*Ddd*f**3*r*s - 315*D1*Ddd*f**3*r + 1260*D1*Ddd*f**3*s**2 - 1260*D1*Ddd*f**3*s + 315*D1*Ddd*f**3 + 2160*D1*Ddd*f**2*g2*r*s - 540*D1*Ddd*f**2*g2*r + 2160*D1*Ddd*f**2*g2*s**2 - 2160*D1*Ddd*f**2*g2*s + 540*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(5*f**3*(10*s + 47)*(r + s - 1) - 2*f**2*(207*C*(s - 1)*(r + s - 1) + 35*fd*(r*(6*s + 3) + 6*s**2 - 2*s - 1) + (s*(9*K - 24) + 23)*(9*r + 9*s - 9)) + 3*f*(45*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 5*r - 12*s**2 + 14*s - 3) + (182*g2*(s - 1) + 126*gd2*(1 - 2*s))*(r + s - 1)) - 378*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(70*f**2*(r*(8*s + 7) + 8*s**2 - 5) - 135*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 11*r - 24*s**2 + 32*s - 9) + 378*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 3780*Dd**2*f**3*r*s - 945*Dd**2*f**3*r + 3780*Dd**2*f**3*s**2 - 3780*Dd**2*f**3*s + 630*Dd**2*f**3 + 6480*Dd**2*f**2*g2*r*s - 1620*Dd**2*f**2*g2*r + 6480*Dd**2*f**2*g2*s**2 - 6480*Dd**2*f**2*g2*s + 1080*Dd**2*f**2*g2 + 21*b1**2*(K - 1)*(D1**2*s*(13*fd - 9*fdd)*(r + s) + D1*Dd*(13*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(-8*r*s + r + s*(4 - 8*s))) - 9*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(828*C*D1**2*f*fd*r*s + 828*C*D1**2*f*fd*s**2 - 414*C*D1**2*f*fd*s - 540*C*D1**2*f*fdd*r*s - 540*C*D1**2*f*fdd*s**2 + 270*C*D1**2*f*fdd*s - 540*C*D1**2*fd**2*r*s - 540*C*D1**2*fd**2*s**2 + 270*C*D1**2*fd**2*s + 1656*C*D1*Dd*f**2*r*s - 414*C*D1*Dd*f**2*r + 1656*C*D1*Dd*f**2*s**2 - 1656*C*D1*Dd*f**2*s + 414*C*D1*Dd*f**2 - 4320*C*D1*Dd*f*fd*r*s + 540*C*D1*Dd*f*fd*r - 4320*C*D1*Dd*f*fd*s**2 + 3240*C*D1*Dd*f*fd*s - 270*C*D1*Dd*f*fd - 1080*C*D1*Ddd*f**2*r*s + 270*C*D1*Ddd*f**2*r - 1080*C*D1*Ddd*f**2*s**2 + 1080*C*D1*Ddd*f**2*s - 270*C*D1*Ddd*f**2 - 3240*C*Dd**2*f**2*r*s + 810*C*Dd**2*f**2*r - 3240*C*Dd**2*f**2*s**2 + 3240*C*Dd**2*f**2*s - 540*C*Dd**2*f**2 + 324*D1**2*K*f*fd*r*s - 162*D1**2*K*f*fd*r + 324*D1**2*K*f*fd*s**2 - 324*D1**2*K*f*fd*s + 162*D1**2*K*f*fd - 540*D1**2*K*f*fdd*r*s + 270*D1**2*K*f*fdd*r - 540*D1**2*K*f*fdd*s**2 + 540*D1**2*K*f*fdd*s - 270*D1**2*K*f*fdd - 540*D1**2*K*fd**2*r*s + 270*D1**2*K*fd**2*r - 540*D1**2*K*fd**2*s**2 + 540*D1**2*K*fd**2*s - 189*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 150*D1**2*f**2*fd*r*s + 285*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 385*D1**2*f**2*fd*s - 285*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r*s - 210*D1**2*f**2*fdd*r + 210*D1**2*f**2*fdd*s**2 - 350*D1**2*f**2*fdd*s + 210*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r*s - 420*D1**2*f*fd**2*r + 420*D1**2*f*fd**2*s**2 - 700*D1**2*f*fd**2*s + 210*D1**2*f*fd**2 - 864*D1**2*f*fd*r*s + 18*D1**2*f*fd*r - 864*D1**2*f*fd*s**2 + 450*D1**2*f*fd*s - 18*D1**2*f*fd + 810*D1**2*f*fdd*r*s - 135*D1**2*f*fdd*r + 810*D1**2*f*fdd*s**2 - 540*D1**2*f*fdd*s + 135*D1**2*f*fdd - 546*D1**2*f*gd2*r*s - 546*D1**2*f*gd2*s**2 + 546*D1**2*f*gd2*s + 378*D1**2*f*gdd2*r*s + 378*D1**2*f*gdd2*s**2 - 378*D1**2*f*gdd2*s + 810*D1**2*fd**2*r*s - 135*D1**2*fd**2*r + 810*D1**2*fd**2*s**2 - 540*D1**2*fd**2*s - 546*D1**2*fd*g2*r*s - 546*D1**2*fd*g2*s**2 + 756*D1**2*fd*gd2*r*s + 756*D1**2*fd*gd2*s**2 - 378*D1**2*fd*gd2*s + 378*D1**2*fdd*g2*r*s + 378*D1**2*fdd*g2*s**2 + 648*D1*Dd*K*f**2*r*s - 162*D1*Dd*K*f**2*r + 648*D1*Dd*K*f**2*s**2 - 648*D1*Dd*K*f**2*s + 162*D1*Dd*K*f**2 - 4320*D1*Dd*K*f*fd*r*s + 1620*D1*Dd*K*f*fd*r - 4320*D1*Dd*K*f*fd*s**2 + 4320*D1*Dd*K*f*fd*s - 1080*D1*Dd*K*f*fd - 200*D1*Dd*f**3*r*s + 50*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 200*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r*s - 1050*D1*Dd*f**2*fd*r + 1680*D1*Dd*f**2*fd*s**2 - 2240*D1*Dd*f**2*fd*s + 770*D1*Dd*f**2*fd - 1728*D1*Dd*f**2*r*s + 432*D1*Dd*f**2*r - 1728*D1*Dd*f**2*s**2 + 1728*D1*Dd*f**2*s - 432*D1*Dd*f**2 + 6480*D1*Dd*f*fd*r*s - 1350*D1*Dd*f*fd*r + 6480*D1*Dd*f*fd*s**2 - 5400*D1*Dd*f*fd*s + 810*D1*Dd*f*fd - 2184*D1*Dd*f*g2*r*s + 546*D1*Dd*f*g2*r - 2184*D1*Dd*f*g2*s**2 + 2184*D1*Dd*f*g2*s - 546*D1*Dd*f*g2 + 3024*D1*Dd*f*gd2*r*s - 378*D1*Dd*f*gd2*r + 3024*D1*Dd*f*gd2*s**2 - 3024*D1*Dd*f*gd2*s + 378*D1*Dd*f*gd2 + 3024*D1*Dd*fd*g2*r*s - 378*D1*Dd*fd*g2*r + 3024*D1*Dd*fd*g2*s**2 - 1512*D1*Dd*fd*g2*s - 1080*D1*Ddd*K*f**2*r*s + 270*D1*Ddd*K*f**2*r - 1080*D1*Ddd*K*f**2*s**2 + 1080*D1*Ddd*K*f**2*s - 270*D1*Ddd*K*f**2 + 280*D1*Ddd*f**3*r*s - 70*D1*Ddd*f**3*r + 280*D1*Ddd*f**3*s**2 - 280*D1*Ddd*f**3*s + 70*D1*Ddd*f**3 + 1620*D1*Ddd*f**2*r*s - 405*D1*Ddd*f**2*r + 1620*D1*Ddd*f**2*s**2 - 1620*D1*Ddd*f**2*s + 405*D1*Ddd*f**2 + 1512*D1*Ddd*f*g2*r*s - 378*D1*Ddd*f*g2*r + 1512*D1*Ddd*f*g2*s**2 - 1512*D1*Ddd*f*g2*s + 378*D1*Ddd*f*g2 + 21*D1*bd1*(K - 1)*(D1*(13*f*(2*s - 1)*(r + s - 1) + 9*fd*(-4*r*s + r + s*(3 - 4*s))) - 9*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3240*Dd**2*K*f**2*r*s + 810*Dd**2*K*f**2*r - 3240*Dd**2*K*f**2*s**2 + 3240*Dd**2*K*f**2*s - 540*Dd**2*K*f**2 + 840*Dd**2*f**3*r*s - 210*Dd**2*f**3*r + 840*Dd**2*f**3*s**2 - 840*Dd**2*f**3*s + 140*Dd**2*f**3 + 4860*Dd**2*f**2*r*s - 1215*Dd**2*f**2*r + 4860*Dd**2*f**2*s**2 - 4860*Dd**2*f**2*s + 810*Dd**2*f**2 + 4536*Dd**2*f*g2*r*s - 1134*Dd**2*f*g2*r + 4536*Dd**2*f*g2*s**2 - 4536*Dd**2*f*g2*s + 756*Dd**2*f*g2))/(315*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**5*k1**3*(63*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(-5*f**3*s*(43*r + 43*s - 24) + f**2*(35*fd*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3) - 18*s*(3*C*s + r*(3*C + 5) + 5*s - 8)) + 45*f*fd*(r*(2*C + 1)*(4*s - 1) + s**2*(8*C + 4) - s*(6*C + 6) + 3) + 42*f*s*(g2*(r + s) + gd2*(-6*r - 6*s + 3)) - 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(35*f**2*(5*r*(8*s - 1) + 40*s**2 - 32*s + 3) + 45*f*(r*(2*C + 1)*(8*s - 1) + s**2*(16*C + 8) - s*(8*C + 16) + 3) - 126*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 21*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(-5*f**2*(fd*(43*r*(3*s - 1) + 129*s**2 - 148*s + 43) - 7*fdd*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5)) + f*(35*fd**2*(10*r*(3*s - 1) + 30*s**2 - 34*s + 7) - 18*fd*(3*C*(2*s - 1)*(r + s - 1) + 10*r*s - 5*r + 10*s**2 - 7*s + 5) + 45*fdd*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 + 1) + 21*s*(3*bdd1*(K - 1)*(2*r + 2*s - 1) + (2*gd2 - 6*gdd2)*(r + s - 1))) + 45*fd**2*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 - 2) + 42*fd*(g2*(s - 1) + gd2*(3 - 6*s))*(r + s - 1) - 126*fdd*g2*(s - 1)*(r + s - 1)) + 21*D1*bd1*(K - 1)*(D1*(f*s*(-2*r - 2*s + 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 3*Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(-215*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(-54*C*(r*(4*s - 1) + (1 - 2*s)**2) + 35*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) - 90*r*(4*s - 1) - 90*(1 - 2*s)**2) + 6*f*(15*fd*(C*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + 8*r*s - 3*r + 8*s**2 - 4*s + 1) + 7*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 21*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 126*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(175*f**2 + f*(90*C + 45) - 126*g2)) + Dd**2*f*(175*f**2 + f*(90*C + 45) - 126*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(35*bdd1*f**2*s*(5*r + 5*s - 3) - 126*bdd1*g2*s*(r + s) - 15*f*(-3*bdd1*s*(2*C*r + 2*C*s + r + s - 3) + 8*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 105*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 15*D1*f*(Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - 7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 7*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 105*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k3**3) - D1**2*Pkd2*Pkd3*ct**5*k1*k2**4*st**2*(120*C*D1**2*f**2*fd*r*s - 40*C*D1**2*f**2*fd*r + 120*C*D1**2*f**2*fd*s**2 - 120*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd - 60*C*D1**2*f**2*fdd*r*s + 20*C*D1**2*f**2*fdd*r - 60*C*D1**2*f**2*fdd*s**2 + 60*C*D1**2*f**2*fdd*s - 20*C*D1**2*f**2*fdd - 120*C*D1**2*f*fd**2*r*s + 40*C*D1**2*f*fd**2*r - 120*C*D1**2*f*fd**2*s**2 + 120*C*D1**2*f*fd**2*s - 20*C*D1**2*f*fd**2 + 160*C*D1*Dd*f**3*r*s - 40*C*D1*Dd*f**3*r + 160*C*D1*Dd*f**3*s**2 - 160*C*D1*Dd*f**3*s + 40*C*D1*Dd*f**3 - 480*C*D1*Dd*f**2*fd*r*s + 140*C*D1*Dd*f**2*fd*r - 480*C*D1*Dd*f**2*fd*s**2 + 480*C*D1*Dd*f**2*fd*s - 100*C*D1*Dd*f**2*fd - 80*C*D1*Ddd*f**3*r*s + 20*C*D1*Ddd*f**3*r - 80*C*D1*Ddd*f**3*s**2 + 80*C*D1*Ddd*f**3*s - 20*C*D1*Ddd*f**3 - 240*C*Dd**2*f**3*r*s + 60*C*Dd**2*f**3*r - 240*C*Dd**2*f**3*s**2 + 240*C*Dd**2*f**3*s - 40*C*Dd**2*f**3 - 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s + 7*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 - 7*D1**2*bdd1*f**3*s + 9*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 - 9*D1**2*bdd1*f**2*s - 90*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 90*D1**2*f**2*fd*s - 30*D1**2*f**2*fd + 45*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 45*D1**2*f**2*fdd*s + 15*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 90*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 90*D1**2*f*fd**2*s + 15*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 120*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 120*D1*Dd*f**3*s - 30*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*r*s - 105*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 360*D1*Dd*f**2*fd*s + 75*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r*s - 36*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 288*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r*s - 216*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 576*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 60*D1*Ddd*f**3*r*s - 15*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-18*K + 7*f + 9)*(r + s - 1) - 9*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-18*K + 7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 180*Dd**2*f**3*r*s - 45*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 30*Dd**2*f**3 + 432*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1)) - 9*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (36*K - 18)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 7*f + 9)) + Dd**2*f**2*(-18*K + 7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**5*k1*k2**4*(60*C*D1**2*bdd1*f**2*r*s - 60*C*D1**2*bdd1*f**2*r + 60*C*D1**2*bdd1*f**2*s**2 - 120*C*D1**2*bdd1*f**2*s + 60*C*D1**2*bdd1*f**2 - 150*C*D1**2*f**2*fd*r*s + 50*C*D1**2*f**2*fd*r - 150*C*D1**2*f**2*fd*s**2 + 150*C*D1**2*f**2*fd*s - 50*C*D1**2*f**2*fd + 210*C*D1**2*f**2*fdd*r*s - 70*C*D1**2*f**2*fdd*r + 210*C*D1**2*f**2*fdd*s**2 - 210*C*D1**2*f**2*fdd*s + 70*C*D1**2*f**2*fdd + 420*C*D1**2*f*fd**2*r*s - 140*C*D1**2*f*fd**2*r + 420*C*D1**2*f*fd**2*s**2 - 420*C*D1**2*f*fd**2*s + 70*C*D1**2*f*fd**2 - 200*C*D1*Dd*f**3*r*s + 50*C*D1*Dd*f**3*r - 200*C*D1*Dd*f**3*s**2 + 200*C*D1*Dd*f**3*s - 50*C*D1*Dd*f**3 + 1680*C*D1*Dd*f**2*fd*r*s - 490*C*D1*Dd*f**2*fd*r + 1680*C*D1*Dd*f**2*fd*s**2 - 1680*C*D1*Dd*f**2*fd*s + 350*C*D1*Dd*f**2*fd + 280*C*D1*Ddd*f**3*r*s - 70*C*D1*Ddd*f**3*r + 280*C*D1*Ddd*f**3*s**2 - 280*C*D1*Ddd*f**3*s + 70*C*D1*Ddd*f**3 + 840*C*Dd**2*f**3*r*s - 210*C*Dd**2*f**3*r + 840*C*Dd**2*f**3*s**2 - 840*C*Dd**2*f**3*s + 140*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*s**2 - 45*D1**2*K*bdd1*f**2*s - 3*D1**2*bd1**2*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 45*D1**2*bdd1*f**2*r*s + 45*D1**2*bdd1*f**2*r - 45*D1**2*bdd1*f**2*s**2 + 90*D1**2*bdd1*f**2*s - 45*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 + 30*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 30*D1**2*f**2*fd*s + 10*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r*s + 35*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 105*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd + 54*D1**2*f**2*gd2*r*s + 54*D1**2*f**2*gd2*s**2 - 54*D1**2*f**2*gd2*s - 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*s**2 + 90*D1**2*f**2*gdd2*s - 210*D1**2*f*fd**2*r*s + 70*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 210*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1**2*f*fd*g2*r*s - 54*D1**2*f*fd*g2*r + 108*D1**2*f*fd*g2*s**2 - 108*D1**2*f*fd*g2*s + 54*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r*s + 90*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 90*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r*s + 90*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r*s + 90*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s + 40*D1*Dd*f**3*r*s - 10*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 40*D1*Dd*f**3*s + 10*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r*s + 245*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 840*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd + 216*D1*Dd*f**2*g2*r*s - 54*D1*Dd*f**2*g2*r + 216*D1*Dd*f**2*g2*s**2 - 216*D1*Dd*f**2*g2*s + 54*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r*s + 90*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 720*D1*Dd*f**2*gd2*s - 90*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r*s + 540*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**3*r*s + 35*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 140*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r*s + 90*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + f**2*(r + s - 1)*(40*C*(s - 1) + s*(9*K - 23) + 30) + f*(-5*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 3*K*(r*(4*s - 1) + (1 - 2*s)**2) - 12*r*s + 6*r - 12*s**2 + 15*s - 3) + (-28*r - 28*s + 28)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 28*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-5*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 3*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) + 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 420*Dd**2*f**3*r*s + 105*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 420*Dd**2*f**3*s - 70*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r*s + 270*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 + 3*b1**2*(D1**2*s*(5*f*(2*fd - fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 14*fd*(2*K - 1)*(r + s) + 7*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (14 - 28*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 5*f + 7)) - Dd**2*f*(-14*K + 5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 3*b1*(-80*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*s**2 + 40*C*D1**2*f*fd*s + 40*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 40*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 40*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 - 18*D1**2*K*f*fd*r*s + 9*D1**2*K*f*fd*r - 18*D1**2*K*f*fd*s**2 + 18*D1**2*K*f*fd*s - 9*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 46*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 46*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s - 7*D1**2*f*fd - 30*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*s**2 + 15*D1**2*f*fdd*s + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 30*D1**2*fd**2*r*s - 30*D1**2*fd**2*s**2 + 15*D1**2*fd**2*s + 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*s**2 + 28*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 36*D1*Dd*K*f**2*r*s + 9*D1*Dd*K*f**2*r - 36*D1*Dd*K*f**2*s**2 + 36*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 + 92*D1*Dd*f**2*r*s - 23*D1*Dd*f**2*r + 92*D1*Dd*f**2*s**2 - 92*D1*Dd*f**2*s + 23*D1*Dd*f**2 - 240*D1*Dd*f*fd*r*s + 30*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 15*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 224*D1*Dd*f*gd2*s - 28*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r*s + 28*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 112*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 60*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 112*D1*Ddd*f*g2*s - 28*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(2*s - 1)*(r + s - 1) + f*(-5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (14 - 28*K)*(2*s - 1)*(r + s - 1)) + 7*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-14*K + 5*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 180*Dd**2*f**2*r*s + 45*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 30*Dd**2*f**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 336*Dd**2*f*g2*s - 56*Dd**2*f*g2))/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**5*k1*k2**2*st**2*(b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) - 18*fd*(2*r*s - r + 2*s**2 - 2*s + 1) + 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 18*r*(4*s - 1) - 18*(1 - 2*s)**2) + 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(7*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(7*bdd1*f**2*s*(r + s - 1) + f*(9*bdd1*s*(r + s - 1) - 10*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(7*f + 9)*(r + s - 1) + 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 5*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**3) - D1**2*Pkd2*Pkd3*ct**5*k1*k2**2*(-60*C*D1**2*bdd1*f**2*r*s - 60*C*D1**2*bdd1*f**2*s**2 - 330*C*D1**2*f**2*fd*r*s + 110*C*D1**2*f**2*fd*r - 330*C*D1**2*f**2*fd*s**2 + 330*C*D1**2*f**2*fd*s - 110*C*D1**2*f**2*fd + 210*C*D1**2*f**2*fdd*r*s - 70*C*D1**2*f**2*fdd*r + 210*C*D1**2*f**2*fdd*s**2 - 210*C*D1**2*f**2*fdd*s + 70*C*D1**2*f**2*fdd + 420*C*D1**2*f*fd**2*r*s - 140*C*D1**2*f*fd**2*r + 420*C*D1**2*f*fd**2*s**2 - 420*C*D1**2*f*fd**2*s + 70*C*D1**2*f*fd**2 - 440*C*D1*Dd*f**3*r*s + 110*C*D1*Dd*f**3*r - 440*C*D1*Dd*f**3*s**2 + 440*C*D1*Dd*f**3*s - 110*C*D1*Dd*f**3 + 1680*C*D1*Dd*f**2*fd*r*s - 490*C*D1*Dd*f**2*fd*r + 1680*C*D1*Dd*f**2*fd*s**2 - 1680*C*D1*Dd*f**2*fd*s + 350*C*D1*Dd*f**2*fd + 280*C*D1*Ddd*f**3*r*s - 70*C*D1*Ddd*f**3*r + 280*C*D1*Ddd*f**3*s**2 - 280*C*D1*Ddd*f**3*s + 70*C*D1*Ddd*f**3 + 840*C*Dd**2*f**3*r*s - 210*C*Dd**2*f**3*r + 840*C*Dd**2*f**3*s**2 - 840*C*Dd**2*f**3*s + 140*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*s**2 - 45*D1**2*K*bdd1*f**2*s - 138*D1**2*b2*f*fd*r*s + 69*D1**2*b2*f*fd*r - 138*D1**2*b2*f*fd*s**2 + 138*D1**2*b2*f*fd*s - 69*D1**2*b2*f*fd + 90*D1**2*b2*f*fdd*r*s - 45*D1**2*b2*f*fdd*r + 90*D1**2*b2*f*fdd*s**2 - 90*D1**2*b2*f*fdd*s + 45*D1**2*b2*f*fdd + 90*D1**2*b2*fd**2*r*s - 45*D1**2*b2*fd**2*r + 90*D1**2*b2*fd**2*s**2 - 90*D1**2*b2*fd**2*s + 3*D1**2*bd1**2*f*(5*f*(r + 2*s - 1) - 7*r*(4*K*s - 1) - 7*(2*s - 1)*(2*K*s - 1)) - 69*D1**2*bd2*f**2*r*s - 69*D1**2*bd2*f**2*s**2 + 69*D1**2*bd2*f**2*s + 180*D1**2*bd2*f*fd*r*s - 45*D1**2*bd2*f*fd*r + 180*D1**2*bd2*f*fd*s**2 - 180*D1**2*bd2*f*fd*s + 45*D1**2*bd2*f*fd + 30*D1**2*bdd1*f**2*r*s + 15*D1**2*bdd1*f**2*r + 30*D1**2*bdd1*f**2*s**2 + 30*D1**2*bdd1*f**2*s - 15*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*s**2 + 45*D1**2*bdd2*f**2*r*s + 45*D1**2*bdd2*f**2*s**2 - 45*D1**2*bdd2*f**2*s + 120*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 120*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s + 40*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r*s + 35*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 105*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd + 138*D1**2*f**2*gd2*r*s + 138*D1**2*f**2*gd2*s**2 - 138*D1**2*f**2*gd2*s - 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*s**2 + 90*D1**2*f**2*gdd2*s - 210*D1**2*f*fd**2*r*s + 70*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 210*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 276*D1**2*f*fd*g2*r*s - 138*D1**2*f*fd*g2*r + 276*D1**2*f*fd*g2*s**2 - 276*D1**2*f*fd*g2*s + 138*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r*s + 90*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 90*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r*s + 90*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r*s + 90*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s - 276*D1*Dd*b2*f**2*r*s + 69*D1*Dd*b2*f**2*r - 276*D1*Dd*b2*f**2*s**2 + 276*D1*Dd*b2*f**2*s - 69*D1*Dd*b2*f**2 + 720*D1*Dd*b2*f*fd*r*s - 270*D1*Dd*b2*f*fd*r + 720*D1*Dd*b2*f*fd*s**2 - 720*D1*Dd*b2*f*fd*s + 180*D1*Dd*b2*f*fd + 360*D1*Dd*bd2*f**2*r*s - 45*D1*Dd*bd2*f**2*r + 360*D1*Dd*bd2*f**2*s**2 - 360*D1*Dd*bd2*f**2*s + 45*D1*Dd*bd2*f**2 + 160*D1*Dd*f**3*r*s - 40*D1*Dd*f**3*r + 160*D1*Dd*f**3*s**2 - 160*D1*Dd*f**3*s + 40*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r*s + 245*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 840*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd + 552*D1*Dd*f**2*g2*r*s - 138*D1*Dd*f**2*g2*r + 552*D1*Dd*f**2*g2*s**2 - 552*D1*Dd*f**2*g2*s + 138*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r*s + 90*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 720*D1*Dd*f**2*gd2*s - 90*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r*s + 540*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 + 180*D1*Ddd*b2*f**2*r*s - 45*D1*Ddd*b2*f**2*r + 180*D1*Ddd*b2*f**2*s**2 - 180*D1*Ddd*b2*f**2*s + 45*D1*Ddd*b2*f**2 - 140*D1*Ddd*f**3*r*s + 35*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 140*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r*s + 90*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + f**2*(r*(s*(-40*C + 23*K + 27) + 10) + s**2*(-40*C + 23*K + 27) + s*(13 - 23*K) - 10) + f*(-5*fd*(-16*C*s**2 + 12*C*s + 3*K*(r*(4*s - 1) + (1 - 2*s)**2) + r*(-16*C*s + 4*C + 8*s - 1) + 8*s**2 - 4*s - 1) + 28*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 28*fd*g2*(-2*r*s + r - s*(2*s - 2))) - Dd*f*(5*f*(-32*C*r*s + 4*C*r - 32*C*s**2 + 16*C*s + 3*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 16*r*s + 2*r + 16*s**2 - 4) + 28*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 540*Dd**2*b2*f**2*r*s - 135*Dd**2*b2*f**2*r + 540*Dd**2*b2*f**2*s**2 - 540*Dd**2*b2*f**2*s + 90*Dd**2*b2*f**2 - 420*Dd**2*f**3*r*s + 105*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 420*Dd**2*f**3*s - 70*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r*s + 270*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 - 3*b1**2*(D1**2*(5*fd**2*(r + 2*s - 1) - 2*fd*(14*K*(s - 1)*(r + s - 1) + 5*f*(r + 2*s - 1) + 7*r + 14*s - 7) + fdd*(14*K*(s - 1)*(r + s - 1) + 5*f*(r + 2*s - 1) + 7*r + 14*s - 7)) + 2*D1*(Dd*(-14*K*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(7*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*f*(r + 2*s - 1) + 14*r + 28*s - 14)) + 7*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 14*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 3*b1*(-80*C*D1**2*f*fd*r*s + 40*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 120*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s + 20*C*D1**2*fd**2 - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 120*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 + 46*D1**2*K*f*fd*r*s - 23*D1**2*K*f*fd*r + 46*D1**2*K*f*fd*s**2 - 46*D1**2*K*f*fd*s + 23*D1**2*K*f*fd - 30*D1**2*K*f*fdd*r*s + 15*D1**2*K*f*fdd*r - 30*D1**2*K*f*fdd*s**2 + 30*D1**2*K*f*fdd*s - 15*D1**2*K*f*fdd - 30*D1**2*K*fd**2*r*s + 15*D1**2*K*fd**2*r - 30*D1**2*K*fd**2*s**2 + 30*D1**2*K*fd**2*s + D1**2*bdd1*f*(-5*f*(r + 2*s - 1) + 7*r*(4*K*s - 1) + (14*s - 7)*(2*K*s - 1)) + 15*D1**2*f**2*fd*r*s - 5*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 15*D1**2*f**2*fd*s + 5*D1**2*f**2*fd + 54*D1**2*f*fd*r*s - 37*D1**2*f*fd*r + 54*D1**2*f*fd*s**2 - 94*D1**2*f*fd*s + 37*D1**2*f*fd - 20*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r - 20*D1**2*f*fdd*s**2 + 40*D1**2*f*fdd*s - 15*D1**2*f*fdd + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 20*D1**2*fd**2*r*s + 15*D1**2*fd**2*r - 20*D1**2*fd**2*s**2 + 40*D1**2*fd**2*s - 15*D1**2*fd**2 + 56*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 56*D1**2*fd*g2*s**2 - 112*D1**2*fd*g2*s + 56*D1**2*fd*g2 - 56*D1**2*fd*gd2*r*s + 28*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s - 28*D1**2*fd*gd2 - 28*D1**2*fdd*g2*r*s + 28*D1**2*fdd*g2*r - 28*D1**2*fdd*g2*s**2 + 56*D1**2*fdd*g2*s - 28*D1**2*fdd*g2 + 92*D1*Dd*K*f**2*r*s - 23*D1*Dd*K*f**2*r + 92*D1*Dd*K*f**2*s**2 - 92*D1*Dd*K*f**2*s + 23*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*r*s + 90*D1*Dd*K*f*fd*r - 240*D1*Dd*K*f*fd*s**2 + 240*D1*Dd*K*f*fd*s - 60*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r*s - 5*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 20*D1*Dd*f**3*s + 5*D1*Dd*f**3 + 108*D1*Dd*f**2*r*s - 27*D1*Dd*f**2*r + 108*D1*Dd*f**2*s**2 - 108*D1*Dd*f**2*s + 27*D1*Dd*f**2 - 160*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 240*D1*Dd*f*fd*s - 70*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 224*D1*Dd*f*gd2*s - 28*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r*s + 140*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 336*D1*Dd*fd*g2*s - 112*D1*Dd*fd*g2 - 60*D1*Ddd*K*f**2*r*s + 15*D1*Ddd*K*f**2*r - 60*D1*Ddd*K*f**2*s**2 + 60*D1*Ddd*K*f**2*s - 15*D1*Ddd*K*f**2 - 40*D1*Ddd*f**2*r*s + 10*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 40*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 112*D1*Ddd*f*g2*s - 28*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(r + 2*s - 1) - 14*f*(r*(4*K*s - 1) + (2*s - 1)*(2*K*s - 1)) + 7*fd*(2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + r + 2*s - 1)) - 2*Dd*f*(-7*K*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 10*f*(r + 2*s - 1) + 14*r + 28*s - 14)) - 180*Dd**2*K*f**2*r*s + 45*Dd**2*K*f**2*r - 180*Dd**2*K*f**2*s**2 + 180*Dd**2*K*f**2*s - 30*Dd**2*K*f**2 - 120*Dd**2*f**2*r*s + 30*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 120*Dd**2*f**2*s - 20*Dd**2*f**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 336*Dd**2*f*g2*s - 56*Dd**2*f*g2))/(105*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**5*k1*(D1*f*(D1*bd1**2*s*(5*f + 7)*(2*r + 2*s - 1) + 5*D1*bdd1*f*s*(r + s) + 5*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1)))) + b1**2*(D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) - 2*fd*(10*f*s - 5*f + 7*s - 7) + fdd*(10*f*s - 5*f + 7*s - 7)) + D1*(Dd*(-10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) - 14*r*(4*s - 1) - 14*(1 - 2*s)**2) + 7*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + Ddd*f*(5*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f*(5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(7*bdd1*s*(2*r + 2*s - 1) - 10*fd*(2*s - 1)*(r + s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) + 5*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) - 2*f*s*(5*f + 7)*(2*r + 2*s - 1) + 7*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(5*f + 7)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) - 5*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(6 - 16*s) - 16*s**2 + 20*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k3) + D1**2*Pkd2*Pkd3*ct**4*f**2*k1**6*(D1**2*(-f*(7*fd - 9*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(-7*f*(r*(4*s - 1) + (1 - 2*s)**2) + 18*fd*(4*s - 1)*(4*r + 4*s - 3)) + 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(99*d**2*k2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**4*k1**4*k2*st**2*(1386*C*D1**2*f**2*fd*r*s - 462*C*D1**2*f**2*fd*r + 1386*C*D1**2*f**2*fd*s**2 - 1386*C*D1**2*f**2*fd*s + 462*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 1848*C*D1*Dd*f**3*r*s - 462*C*D1*Dd*f**3*r + 1848*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 462*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 3100*D1**2*f**3*fd*r*s - 775*D1**2*f**3*fd*r + 3100*D1**2*f**3*fd*s**2 - 3100*D1**2*f**3*fd*s + 775*D1**2*f**3*fd - 2100*D1**2*f**3*fdd*r*s + 525*D1**2*f**3*fdd*r - 2100*D1**2*f**3*fdd*s**2 + 2100*D1**2*f**3*fdd*s - 525*D1**2*f**3*fdd - 6300*D1**2*f**2*fd**2*r*s + 1575*D1**2*f**2*fd**2*r - 6300*D1**2*f**2*fd**2*s**2 + 6300*D1**2*f**2*fd**2*s - 1050*D1**2*f**2*fd**2 - 1386*D1**2*f**2*fd*r*s + 462*D1**2*f**2*fd*r - 1386*D1**2*f**2*fd*s**2 + 1386*D1**2*f**2*fd*s - 462*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*s**2 + 726*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 1452*D1**2*f*fd*g2*r*s + 726*D1**2*f*fd*g2*r - 1452*D1**2*f*fd*g2*s**2 + 1452*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 3100*D1*Dd*f**4*r*s - 775*D1*Dd*f**4*r + 3100*D1*Dd*f**4*s**2 - 3100*D1*Dd*f**4*s + 775*D1*Dd*f**4 - 16800*D1*Dd*f**3*fd*r*s + 4200*D1*Dd*f**3*fd*r - 16800*D1*Dd*f**3*fd*s**2 + 16800*D1*Dd*f**3*fd*s - 3150*D1*Dd*f**3*fd - 1848*D1*Dd*f**3*r*s + 462*D1*Dd*f**3*r - 1848*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 462*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 2904*D1*Dd*f**2*g2*r*s + 726*D1*Dd*f**2*g2*r - 2904*D1*Dd*f**2*g2*s**2 + 2904*D1*Dd*f**2*g2*s - 726*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 2100*D1*Ddd*f**4*r*s + 525*D1*Ddd*f**4*r - 2100*D1*Ddd*f**4*s**2 + 2100*D1*Ddd*f**4*s - 525*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 6300*Dd**2*f**4*r*s + 1575*Dd**2*f**4*r - 6300*Dd**2*f**4*s**2 + 6300*Dd**2*f**4*s - 1050*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**4*k1**4*k2*(270*C*D1**2*bdd1*f**2*r*s - 270*C*D1**2*bdd1*f**2*r + 270*C*D1**2*bdd1*f**2*s**2 - 540*C*D1**2*bdd1*f**2*s + 270*C*D1**2*bdd1*f**2 - 30*C*D1**2*f**2*fd*r*s + 10*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 30*C*D1**2*f**2*fd*s - 10*C*D1**2*f**2*fd + 420*C*D1**2*f**2*fdd*r*s - 140*C*D1**2*f**2*fdd*r + 420*C*D1**2*f**2*fdd*s**2 - 420*C*D1**2*f**2*fdd*s + 140*C*D1**2*f**2*fdd + 840*C*D1**2*f*fd**2*r*s - 280*C*D1**2*f*fd**2*r + 840*C*D1**2*f*fd**2*s**2 - 840*C*D1**2*f*fd**2*s + 140*C*D1**2*f*fd**2 - 40*C*D1*Dd*f**3*r*s + 10*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 40*C*D1*Dd*f**3*s - 10*C*D1*Dd*f**3 + 3360*C*D1*Dd*f**2*fd*r*s - 980*C*D1*Dd*f**2*fd*r + 3360*C*D1*Dd*f**2*fd*s**2 - 3360*C*D1*Dd*f**2*fd*s + 700*C*D1*Dd*f**2*fd + 560*C*D1*Ddd*f**3*r*s - 140*C*D1*Ddd*f**3*r + 560*C*D1*Ddd*f**3*s**2 - 560*C*D1*Ddd*f**3*s + 140*C*D1*Ddd*f**3 + 1680*C*Dd**2*f**3*r*s - 420*C*Dd**2*f**3*r + 1680*C*Dd**2*f**3*s**2 - 1680*C*Dd**2*f**3*s + 280*C*Dd**2*f**3 + 90*D1**2*K*bdd1*f**2*r*s + 90*D1**2*K*bdd1*f**2*s**2 - 90*D1**2*K*bdd1*f**2*s + 189*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 70*D1**2*bdd1*f**3*r*s - 210*D1**2*bdd1*f**3*r + 70*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 210*D1**2*bdd1*f**3 - 315*D1**2*bdd1*f**2*r*s + 270*D1**2*bdd1*f**2*r - 315*D1**2*bdd1*f**2*s**2 + 585*D1**2*bdd1*f**2*s - 270*D1**2*bdd1*f**2 - 378*D1**2*bdd1*f*g2*r*s + 378*D1**2*bdd1*f*g2*r - 378*D1**2*bdd1*f*g2*s**2 + 756*D1**2*bdd1*f*g2*s - 378*D1**2*bdd1*f*g2 + 420*D1**2*f**3*fd*r*s - 105*D1**2*f**3*fd*r + 420*D1**2*f**3*fd*s**2 - 420*D1**2*f**3*fd*s + 105*D1**2*f**3*fd - 45*D1**2*f**2*fd*r*s + 15*D1**2*f**2*fd*r - 45*D1**2*f**2*fd*s**2 + 45*D1**2*f**2*fd*s - 15*D1**2*f**2*fd - 315*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r - 315*D1**2*f**2*fdd*s**2 + 315*D1**2*f**2*fdd*s - 105*D1**2*f**2*fdd - 18*D1**2*f**2*gd2*r*s - 18*D1**2*f**2*gd2*s**2 + 18*D1**2*f**2*gd2*s - 180*D1**2*f**2*gdd2*r*s - 180*D1**2*f**2*gdd2*s**2 + 180*D1**2*f**2*gdd2*s - 630*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r - 630*D1**2*f*fd**2*s**2 + 630*D1**2*f*fd**2*s - 105*D1**2*f*fd**2 - 36*D1**2*f*fd*g2*r*s + 18*D1**2*f*fd*g2*r - 36*D1**2*f*fd*g2*s**2 + 36*D1**2*f*fd*g2*s - 18*D1**2*f*fd*g2 - 720*D1**2*f*fd*gd2*r*s + 180*D1**2*f*fd*gd2*r - 720*D1**2*f*fd*gd2*s**2 + 720*D1**2*f*fd*gd2*s - 180*D1**2*f*fd*gd2 - 360*D1**2*f*fdd*g2*r*s + 180*D1**2*f*fdd*g2*r - 360*D1**2*f*fdd*g2*s**2 + 360*D1**2*f*fdd*g2*s - 180*D1**2*f*fdd*g2 - 360*D1**2*fd**2*g2*r*s + 180*D1**2*fd**2*g2*r - 360*D1**2*fd**2*g2*s**2 + 360*D1**2*fd**2*g2*s + 420*D1*Dd*f**4*r*s - 105*D1*Dd*f**4*r + 420*D1*Dd*f**4*s**2 - 420*D1*Dd*f**4*s + 105*D1*Dd*f**4 - 60*D1*Dd*f**3*r*s + 15*D1*Dd*f**3*r - 60*D1*Dd*f**3*s**2 + 60*D1*Dd*f**3*s - 15*D1*Dd*f**3 - 2520*D1*Dd*f**2*fd*r*s + 735*D1*Dd*f**2*fd*r - 2520*D1*Dd*f**2*fd*s**2 + 2520*D1*Dd*f**2*fd*s - 525*D1*Dd*f**2*fd - 72*D1*Dd*f**2*g2*r*s + 18*D1*Dd*f**2*g2*r - 72*D1*Dd*f**2*g2*s**2 + 72*D1*Dd*f**2*g2*s - 18*D1*Dd*f**2*g2 - 1440*D1*Dd*f**2*gd2*r*s + 180*D1*Dd*f**2*gd2*r - 1440*D1*Dd*f**2*gd2*s**2 + 1440*D1*Dd*f**2*gd2*s - 180*D1*Dd*f**2*gd2 - 2880*D1*Dd*f*fd*g2*r*s + 1080*D1*Dd*f*fd*g2*r - 2880*D1*Dd*f*fd*g2*s**2 + 2880*D1*Dd*f*fd*g2*s - 720*D1*Dd*f*fd*g2 - 420*D1*Ddd*f**3*r*s + 105*D1*Ddd*f**3*r - 420*D1*Ddd*f**3*s**2 + 420*D1*Ddd*f**3*s - 105*D1*Ddd*f**3 - 720*D1*Ddd*f**2*g2*r*s + 180*D1*Ddd*f**2*g2*r - 720*D1*Ddd*f**2*g2*s**2 + 720*D1*Ddd*f**2*g2*s - 180*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(28*s - 57)*(r + s - 1) + f**2*(-288*C*(s - 1)*(r + s - 1) + 70*fd*(r*(6*s - 7) + 6*s**2 - 12*s + 4) + (s*(K + 28) - 32)*(9*r + 9*s - 9)) + 45*f*fd*(6*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 28*r*s + 13*r - 28*s**2 + 34*s - 7) + 42*f*(8*g2*(s - 1) + 9*gd2*(1 - 2*s))*(r + s - 1) - 378*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(70*f**2*(r*(8*s - 13) + 8*s**2 - 20*s + 10) + 45*f*(6*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 56*r*s + 31*r - 56*s**2 + 80*s - 25) - 378*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 1260*Dd**2*f**3*r*s + 315*Dd**2*f**3*r - 1260*Dd**2*f**3*s**2 + 1260*Dd**2*f**3*s - 210*Dd**2*f**3 - 2160*Dd**2*f**2*g2*r*s + 540*Dd**2*f**2*g2*r - 2160*Dd**2*f**2*g2*s**2 + 2160*Dd**2*f**2*g2*s - 360*Dd**2*f**2*g2 - 21*b1**2*(K - 1)*(D1**2*s*(8*fd - 9*fdd)*(r + s) + D1*Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(-8*r*s + r + s*(4 - 8*s))) - 9*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-576*C*D1**2*f*fd*r*s - 576*C*D1**2*f*fd*s**2 + 288*C*D1**2*f*fd*s + 540*C*D1**2*f*fdd*r*s + 540*C*D1**2*f*fdd*s**2 - 270*C*D1**2*f*fdd*s + 540*C*D1**2*fd**2*r*s + 540*C*D1**2*fd**2*s**2 - 270*C*D1**2*fd**2*s - 1152*C*D1*Dd*f**2*r*s + 288*C*D1*Dd*f**2*r - 1152*C*D1*Dd*f**2*s**2 + 1152*C*D1*Dd*f**2*s - 288*C*D1*Dd*f**2 + 4320*C*D1*Dd*f*fd*r*s - 540*C*D1*Dd*f*fd*r + 4320*C*D1*Dd*f*fd*s**2 - 3240*C*D1*Dd*f*fd*s + 270*C*D1*Dd*f*fd + 1080*C*D1*Ddd*f**2*r*s - 270*C*D1*Ddd*f**2*r + 1080*C*D1*Ddd*f**2*s**2 - 1080*C*D1*Ddd*f**2*s + 270*C*D1*Ddd*f**2 + 3240*C*Dd**2*f**2*r*s - 810*C*Dd**2*f**2*r + 3240*C*Dd**2*f**2*s**2 - 3240*C*Dd**2*f**2*s + 540*C*Dd**2*f**2 + 18*D1**2*K*f*fd*r*s - 9*D1**2*K*f*fd*r + 18*D1**2*K*f*fd*s**2 - 18*D1**2*K*f*fd*s + 9*D1**2*K*f*fd + 180*D1**2*K*f*fdd*r*s - 90*D1**2*K*f*fdd*r + 180*D1**2*K*f*fdd*s**2 - 180*D1**2*K*f*fdd*s + 90*D1**2*K*f*fdd + 180*D1**2*K*fd**2*r*s - 90*D1**2*K*fd**2*r + 180*D1**2*K*fd**2*s**2 - 180*D1**2*K*fd**2*s + 189*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 420*D1**2*f**2*fd*r*s - 145*D1**2*f**2*fd*r - 420*D1**2*f**2*fd*s**2 + 135*D1**2*f**2*fd*s + 145*D1**2*f**2*fd + 210*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r + 210*D1**2*f**2*fdd*s**2 - 140*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r + 420*D1**2*f*fd**2*s**2 - 140*D1**2*f*fd**2 + 504*D1**2*f*fd*r*s + 36*D1**2*f*fd*r + 504*D1**2*f*fd*s**2 - 216*D1**2*f*fd*s - 36*D1**2*f*fd - 630*D1**2*f*fdd*r*s + 45*D1**2*f*fdd*r - 630*D1**2*f*fdd*s**2 + 360*D1**2*f*fdd*s - 45*D1**2*f*fdd + 336*D1**2*f*gd2*r*s + 336*D1**2*f*gd2*s**2 - 336*D1**2*f*gd2*s - 378*D1**2*f*gdd2*r*s - 378*D1**2*f*gdd2*s**2 + 378*D1**2*f*gdd2*s - 630*D1**2*fd**2*r*s + 45*D1**2*fd**2*r - 630*D1**2*fd**2*s**2 + 360*D1**2*fd**2*s + 336*D1**2*fd*g2*r*s + 336*D1**2*fd*g2*s**2 - 756*D1**2*fd*gd2*r*s - 756*D1**2*fd*gd2*s**2 + 378*D1**2*fd*gd2*s - 378*D1**2*fdd*g2*r*s - 378*D1**2*fdd*g2*s**2 + 36*D1*Dd*K*f**2*r*s - 9*D1*Dd*K*f**2*r + 36*D1*Dd*K*f**2*s**2 - 36*D1*Dd*K*f**2*s + 9*D1*Dd*K*f**2 + 1440*D1*Dd*K*f*fd*r*s - 540*D1*Dd*K*f*fd*r + 1440*D1*Dd*K*f*fd*s**2 - 1440*D1*Dd*K*f*fd*s + 360*D1*Dd*K*f*fd - 560*D1*Dd*f**3*r*s + 140*D1*Dd*f**3*r - 560*D1*Dd*f**3*s**2 + 560*D1*Dd*f**3*s - 140*D1*Dd*f**3 + 1680*D1*Dd*f**2*fd*r*s + 350*D1*Dd*f**2*fd*r + 1680*D1*Dd*f**2*fd*s**2 - 840*D1*Dd*f**2*fd*s - 280*D1*Dd*f**2*fd + 1008*D1*Dd*f**2*r*s - 252*D1*Dd*f**2*r + 1008*D1*Dd*f**2*s**2 - 1008*D1*Dd*f**2*s + 252*D1*Dd*f**2 - 5040*D1*Dd*f*fd*r*s + 810*D1*Dd*f*fd*r - 5040*D1*Dd*f*fd*s**2 + 3960*D1*Dd*f*fd*s - 450*D1*Dd*f*fd + 1344*D1*Dd*f*g2*r*s - 336*D1*Dd*f*g2*r + 1344*D1*Dd*f*g2*s**2 - 1344*D1*Dd*f*g2*s + 336*D1*Dd*f*g2 - 3024*D1*Dd*f*gd2*r*s + 378*D1*Dd*f*gd2*r - 3024*D1*Dd*f*gd2*s**2 + 3024*D1*Dd*f*gd2*s - 378*D1*Dd*f*gd2 - 3024*D1*Dd*fd*g2*r*s + 378*D1*Dd*fd*g2*r - 3024*D1*Dd*fd*g2*s**2 + 1512*D1*Dd*fd*g2*s + 360*D1*Ddd*K*f**2*r*s - 90*D1*Ddd*K*f**2*r + 360*D1*Ddd*K*f**2*s**2 - 360*D1*Ddd*K*f**2*s + 90*D1*Ddd*K*f**2 + 280*D1*Ddd*f**3*r*s - 70*D1*Ddd*f**3*r + 280*D1*Ddd*f**3*s**2 - 280*D1*Ddd*f**3*s + 70*D1*Ddd*f**3 - 1260*D1*Ddd*f**2*r*s + 315*D1*Ddd*f**2*r - 1260*D1*Ddd*f**2*s**2 + 1260*D1*Ddd*f**2*s - 315*D1*Ddd*f**2 - 1512*D1*Ddd*f*g2*r*s + 378*D1*Ddd*f*g2*r - 1512*D1*Ddd*f*g2*s**2 + 1512*D1*Ddd*f*g2*s - 378*D1*Ddd*f*g2 - 21*D1*bd1*(K - 1)*(D1*(8*f*(2*s - 1)*(r + s - 1) + 9*fd*(-4*r*s + r + s*(3 - 4*s))) - 9*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 1080*Dd**2*K*f**2*r*s - 270*Dd**2*K*f**2*r + 1080*Dd**2*K*f**2*s**2 - 1080*Dd**2*K*f**2*s + 180*Dd**2*K*f**2 + 840*Dd**2*f**3*r*s - 210*Dd**2*f**3*r + 840*Dd**2*f**3*s**2 - 840*Dd**2*f**3*s + 140*Dd**2*f**3 - 3780*Dd**2*f**2*r*s + 945*Dd**2*f**2*r - 3780*Dd**2*f**2*s**2 + 3780*Dd**2*f**2*s - 630*Dd**2*f**2 - 4536*Dd**2*f*g2*r*s + 1134*Dd**2*f*g2*r - 4536*Dd**2*f*g2*s**2 + 4536*Dd**2*f*g2*s - 756*Dd**2*f*g2))/(315*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**4*k1**4*(D1**2*b1*(-5*f**2*(5*fd - 7*fdd)*(r*(6*s - 2) + 6*s**2 - 7*s + 2) + f*(35*fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3) - 27*fd*(2*r*s - r + 2*s**2 - 2*s + 1) + 45*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 45*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*b1*f*(Dd*(-50*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(35*fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11) - 27*r*(4*s - 1) - 27*(1 - 2*s)**2) + 90*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + 5*Ddd*f*(14*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*bd1*f*(D1*(-f*s*(25*f*(2*r + 2*s - 1) + 27*r + 27*s - 27) + 5*fd*(7*f*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + 9*r*(4*s - 1) + 9*(1 - 2*s)**2)) + 5*Dd*f*(7*f*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 72*r*s - 9*r + 72*s**2 - 72*s + 9)) + 5*Dd**2*b1*f**2*(14*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 5*f*(D1**2*(7*bdd1*f**2*s*(2*r + 2*s - 1) + f*(9*bdd1*s*(r + s - 1) - 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 7*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(-5*f*(r*(4*s - 1) + (1 - 2*s)**2) + 7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 7*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k2*k3**3) - D1**2*Pkd2*Pkd3*ct**4*k1**2*k2**3*st**4*(396*C*D1**2*f**2*fd*r*s - 132*C*D1**2*f**2*fd*r + 396*C*D1**2*f**2*fd*s**2 - 396*C*D1**2*f**2*fd*s + 132*C*D1**2*f**2*fd - 198*C*D1**2*f**2*fdd*r*s + 66*C*D1**2*f**2*fdd*r - 198*C*D1**2*f**2*fdd*s**2 + 198*C*D1**2*f**2*fdd*s - 66*C*D1**2*f**2*fdd - 396*C*D1**2*f*fd**2*r*s + 132*C*D1**2*f*fd**2*r - 396*C*D1**2*f*fd**2*s**2 + 396*C*D1**2*f*fd**2*s - 66*C*D1**2*f*fd**2 + 528*C*D1*Dd*f**3*r*s - 132*C*D1*Dd*f**3*r + 528*C*D1*Dd*f**3*s**2 - 528*C*D1*Dd*f**3*s + 132*C*D1*Dd*f**3 - 1584*C*D1*Dd*f**2*fd*r*s + 462*C*D1*Dd*f**2*fd*r - 1584*C*D1*Dd*f**2*fd*s**2 + 1584*C*D1*Dd*f**2*fd*s - 330*C*D1*Dd*f**2*fd - 264*C*D1*Ddd*f**3*r*s + 66*C*D1*Ddd*f**3*r - 264*C*D1*Ddd*f**3*s**2 + 264*C*D1*Ddd*f**3*s - 66*C*D1*Ddd*f**3 - 792*C*Dd**2*f**3*r*s + 198*C*Dd**2*f**3*r - 792*C*Dd**2*f**3*s**2 + 792*C*Dd**2*f**3*s - 132*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 560*D1**2*f**3*fd*r*s - 140*D1**2*f**3*fd*r + 560*D1**2*f**3*fd*s**2 - 560*D1**2*f**3*fd*s + 140*D1**2*f**3*fd - 280*D1**2*f**3*fdd*r*s + 70*D1**2*f**3*fdd*r - 280*D1**2*f**3*fdd*s**2 + 280*D1**2*f**3*fdd*s - 70*D1**2*f**3*fdd - 840*D1**2*f**2*fd**2*r*s + 210*D1**2*f**2*fd**2*r - 840*D1**2*f**2*fd**2*s**2 + 840*D1**2*f**2*fd**2*s - 140*D1**2*f**2*fd**2 - 396*D1**2*f**2*fd*r*s + 132*D1**2*f**2*fd*r - 396*D1**2*f**2*fd*s**2 + 396*D1**2*f**2*fd*s - 132*D1**2*f**2*fd + 198*D1**2*f**2*fdd*r*s - 66*D1**2*f**2*fdd*r + 198*D1**2*f**2*fdd*s**2 - 198*D1**2*f**2*fdd*s + 66*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 396*D1**2*f*fd**2*r*s - 132*D1**2*f*fd**2*r + 396*D1**2*f*fd**2*s**2 - 396*D1**2*f*fd**2*s + 66*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 560*D1*Dd*f**4*r*s - 140*D1*Dd*f**4*r + 560*D1*Dd*f**4*s**2 - 560*D1*Dd*f**4*s + 140*D1*Dd*f**4 - 2240*D1*Dd*f**3*fd*r*s + 560*D1*Dd*f**3*fd*r - 2240*D1*Dd*f**3*fd*s**2 + 2240*D1*Dd*f**3*fd*s - 420*D1*Dd*f**3*fd - 528*D1*Dd*f**3*r*s + 132*D1*Dd*f**3*r - 528*D1*Dd*f**3*s**2 + 528*D1*Dd*f**3*s - 132*D1*Dd*f**3 + 1584*D1*Dd*f**2*fd*r*s - 462*D1*Dd*f**2*fd*r + 1584*D1*Dd*f**2*fd*s**2 - 1584*D1*Dd*f**2*fd*s + 330*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 280*D1*Ddd*f**4*r*s + 70*D1*Ddd*f**4*r - 280*D1*Ddd*f**4*s**2 + 280*D1*Ddd*f**4*s - 70*D1*Ddd*f**4 + 264*D1*Ddd*f**3*r*s - 66*D1*Ddd*f**3*r + 264*D1*Ddd*f**3*s**2 - 264*D1*Ddd*f**3*s + 66*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 840*Dd**2*f**4*r*s + 210*Dd**2*f**4*r - 840*Dd**2*f**4*s**2 + 840*Dd**2*f**4*s - 140*Dd**2*f**4 + 792*Dd**2*f**3*r*s - 198*Dd**2*f**3*r + 792*Dd**2*f**3*s**2 - 792*Dd**2*f**3*s + 132*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(231*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**4*k1**2*k2**3*st**2*(-36*C*D1**2*bdd1*f**2*r*s + 36*C*D1**2*bdd1*f**2*r - 36*C*D1**2*bdd1*f**2*s**2 + 72*C*D1**2*bdd1*f**2*s - 36*C*D1**2*bdd1*f**2 + 876*C*D1**2*f**2*fd*r*s - 292*C*D1**2*f**2*fd*r + 876*C*D1**2*f**2*fd*s**2 - 876*C*D1**2*f**2*fd*s + 292*C*D1**2*f**2*fd - 600*C*D1**2*f**2*fdd*r*s + 200*C*D1**2*f**2*fdd*r - 600*C*D1**2*f**2*fdd*s**2 + 600*C*D1**2*f**2*fdd*s - 200*C*D1**2*f**2*fdd - 1200*C*D1**2*f*fd**2*r*s + 400*C*D1**2*f*fd**2*r - 1200*C*D1**2*f*fd**2*s**2 + 1200*C*D1**2*f*fd**2*s - 200*C*D1**2*f*fd**2 + 1168*C*D1*Dd*f**3*r*s - 292*C*D1*Dd*f**3*r + 1168*C*D1*Dd*f**3*s**2 - 1168*C*D1*Dd*f**3*s + 292*C*D1*Dd*f**3 - 4800*C*D1*Dd*f**2*fd*r*s + 1400*C*D1*Dd*f**2*fd*r - 4800*C*D1*Dd*f**2*fd*s**2 + 4800*C*D1*Dd*f**2*fd*s - 1000*C*D1*Dd*f**2*fd - 800*C*D1*Ddd*f**3*r*s + 200*C*D1*Ddd*f**3*r - 800*C*D1*Ddd*f**3*s**2 + 800*C*D1*Ddd*f**3*s - 200*C*D1*Ddd*f**3 - 2400*C*Dd**2*f**3*r*s + 600*C*Dd**2*f**3*r - 2400*C*Dd**2*f**3*s**2 + 2400*C*Dd**2*f**3*s - 400*C*Dd**2*f**3 - 180*D1**2*K*bdd1*f**2*r*s - 180*D1**2*K*bdd1*f**2*s**2 + 180*D1**2*K*bdd1*f**2*s - 42*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 75*D1**2*bdd1*f**3*r*s + 25*D1**2*bdd1*f**3*r + 75*D1**2*bdd1*f**3*s**2 - 50*D1**2*bdd1*f**3*s - 25*D1**2*bdd1*f**3 + 126*D1**2*bdd1*f**2*r*s - 36*D1**2*bdd1*f**2*r + 126*D1**2*bdd1*f**2*s**2 - 162*D1**2*bdd1*f**2*s + 36*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*g2*r*s - 84*D1**2*bdd1*f*g2*r + 84*D1**2*bdd1*f*g2*s**2 - 168*D1**2*bdd1*f*g2*s + 84*D1**2*bdd1*f*g2 - 100*D1**2*f**3*fd*r*s + 25*D1**2*f**3*fd*r - 100*D1**2*f**3*fd*s**2 + 100*D1**2*f**3*fd*s - 25*D1**2*f**3*fd - 630*D1**2*f**2*fd*r*s + 210*D1**2*f**2*fd*r - 630*D1**2*f**2*fd*s**2 + 630*D1**2*f**2*fd*s - 210*D1**2*f**2*fd + 450*D1**2*f**2*fdd*r*s - 150*D1**2*f**2*fdd*r + 450*D1**2*f**2*fdd*s**2 - 450*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd - 468*D1**2*f**2*gd2*r*s - 468*D1**2*f**2*gd2*s**2 + 468*D1**2*f**2*gd2*s + 360*D1**2*f**2*gdd2*r*s + 360*D1**2*f**2*gdd2*s**2 - 360*D1**2*f**2*gdd2*s + 900*D1**2*f*fd**2*r*s - 300*D1**2*f*fd**2*r + 900*D1**2*f*fd**2*s**2 - 900*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 936*D1**2*f*fd*g2*r*s + 468*D1**2*f*fd*g2*r - 936*D1**2*f*fd*g2*s**2 + 936*D1**2*f*fd*g2*s - 468*D1**2*f*fd*g2 + 1440*D1**2*f*fd*gd2*r*s - 360*D1**2*f*fd*gd2*r + 1440*D1**2*f*fd*gd2*s**2 - 1440*D1**2*f*fd*gd2*s + 360*D1**2*f*fd*gd2 + 720*D1**2*f*fdd*g2*r*s - 360*D1**2*f*fdd*g2*r + 720*D1**2*f*fdd*g2*s**2 - 720*D1**2*f*fdd*g2*s + 360*D1**2*f*fdd*g2 + 720*D1**2*fd**2*g2*r*s - 360*D1**2*fd**2*g2*r + 720*D1**2*fd**2*g2*s**2 - 720*D1**2*fd**2*g2*s - 100*D1*Dd*f**4*r*s + 25*D1*Dd*f**4*r - 100*D1*Dd*f**4*s**2 + 100*D1*Dd*f**4*s - 25*D1*Dd*f**4 - 840*D1*Dd*f**3*r*s + 210*D1*Dd*f**3*r - 840*D1*Dd*f**3*s**2 + 840*D1*Dd*f**3*s - 210*D1*Dd*f**3 + 3600*D1*Dd*f**2*fd*r*s - 1050*D1*Dd*f**2*fd*r + 3600*D1*Dd*f**2*fd*s**2 - 3600*D1*Dd*f**2*fd*s + 750*D1*Dd*f**2*fd - 1872*D1*Dd*f**2*g2*r*s + 468*D1*Dd*f**2*g2*r - 1872*D1*Dd*f**2*g2*s**2 + 1872*D1*Dd*f**2*g2*s - 468*D1*Dd*f**2*g2 + 2880*D1*Dd*f**2*gd2*r*s - 360*D1*Dd*f**2*gd2*r + 2880*D1*Dd*f**2*gd2*s**2 - 2880*D1*Dd*f**2*gd2*s + 360*D1*Dd*f**2*gd2 + 5760*D1*Dd*f*fd*g2*r*s - 2160*D1*Dd*f*fd*g2*r + 5760*D1*Dd*f*fd*g2*s**2 - 5760*D1*Dd*f*fd*g2*s + 1440*D1*Dd*f*fd*g2 + 600*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 600*D1*Ddd*f**3*s**2 - 600*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 + 1440*D1*Ddd*f**2*g2*r*s - 360*D1*Ddd*f**2*g2*r + 1440*D1*Ddd*f**2*g2*s**2 - 1440*D1*Ddd*f**2*g2*s + 360*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-10*f**3*(12*s + 5)*(r + s - 1) + f**2*(72*C*(s - 1)*(r + s - 1) + 25*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + (6*r + 6*s - 6)*(39*K*s - 28*s + 12)) - 6*f*(3*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 10*K*(r*(4*s - 1) + (1 - 2*s)**2) - 28*r*s + 9*r - 28*s**2 + 30*s - 7) + (14*r + 14*s - 14)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(25*f**2*(24*r*s + r + 4*s*(6*s - 5)) - 18*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 56*r*s + 15*r - 56*s**2 + 64*s - 13) + 84*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 1800*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 1800*Dd**2*f**3*s**2 - 1800*Dd**2*f**3*s + 300*Dd**2*f**3 + 4320*Dd**2*f**2*g2*r*s - 1080*Dd**2*f**2*g2*r + 4320*Dd**2*f**2*g2*s**2 - 4320*Dd**2*f**2*g2*s + 720*Dd**2*f**2*g2 + 42*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(144*C*D1**2*f*fd*r*s + 144*C*D1**2*f*fd*s**2 - 72*C*D1**2*f*fd*s - 72*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*s**2 + 36*C*D1**2*f*fdd*s - 72*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*s**2 + 36*C*D1**2*fd**2*s + 288*C*D1*Dd*f**2*r*s - 72*C*D1*Dd*f**2*r + 288*C*D1*Dd*f**2*s**2 - 288*C*D1*Dd*f**2*s + 72*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r*s + 72*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 432*C*D1*Dd*f*fd*s - 36*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r*s + 36*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 144*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r*s + 108*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 432*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 + 468*D1**2*K*f*fd*r*s - 234*D1**2*K*f*fd*r + 468*D1**2*K*f*fd*s**2 - 468*D1**2*K*f*fd*s + 234*D1**2*K*f*fd - 360*D1**2*K*f*fdd*r*s + 180*D1**2*K*f*fdd*r - 360*D1**2*K*f*fdd*s**2 + 360*D1**2*K*f*fdd*s - 180*D1**2*K*f*fdd - 360*D1**2*K*fd**2*r*s + 180*D1**2*K*fd**2*r - 360*D1**2*K*fd**2*s**2 + 360*D1**2*K*fd**2*s - 42*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 360*D1**2*f**2*fd*r*s + 170*D1**2*f**2*fd*r - 360*D1**2*f**2*fd*s**2 + 410*D1**2*f**2*fd*s - 170*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 250*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 500*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 336*D1**2*f*fd*r*s + 96*D1**2*f*fd*r - 336*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 96*D1**2*f*fd + 252*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 252*D1**2*f*fdd*s**2 - 216*D1**2*f*fdd*s + 90*D1**2*f*fdd - 168*D1**2*f*gd2*r*s - 168*D1**2*f*gd2*s**2 + 168*D1**2*f*gd2*s + 84*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 252*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 252*D1**2*fd**2*s**2 - 216*D1**2*fd**2*s - 168*D1**2*fd*g2*r*s - 168*D1**2*fd*g2*s**2 + 168*D1**2*fd*gd2*r*s + 168*D1**2*fd*gd2*s**2 - 84*D1**2*fd*gd2*s + 84*D1**2*fdd*g2*r*s + 84*D1**2*fdd*g2*s**2 + 936*D1*Dd*K*f**2*r*s - 234*D1*Dd*K*f**2*r + 936*D1*Dd*K*f**2*s**2 - 936*D1*Dd*K*f**2*s + 234*D1*Dd*K*f**2 - 2880*D1*Dd*K*f*fd*r*s + 1080*D1*Dd*K*f*fd*r - 2880*D1*Dd*K*f*fd*s**2 + 2880*D1*Dd*K*f*fd*s - 720*D1*Dd*K*f*fd - 480*D1*Dd*f**3*r*s + 120*D1*Dd*f**3*r - 480*D1*Dd*f**3*s**2 + 480*D1*Dd*f**3*s - 120*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r*s - 625*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 1900*D1*Dd*f**2*fd*s + 450*D1*Dd*f**2*fd - 672*D1*Dd*f**2*r*s + 168*D1*Dd*f**2*r - 672*D1*Dd*f**2*s**2 + 672*D1*Dd*f**2*s - 168*D1*Dd*f**2 + 2016*D1*Dd*f*fd*r*s - 612*D1*Dd*f*fd*r + 2016*D1*Dd*f*fd*s**2 - 1872*D1*Dd*f*fd*s + 396*D1*Dd*f*fd - 672*D1*Dd*f*g2*r*s + 168*D1*Dd*f*g2*r - 672*D1*Dd*f*g2*s**2 + 672*D1*Dd*f*g2*s - 168*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r*s - 84*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 672*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r*s - 84*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 336*D1*Dd*fd*g2*s - 720*D1*Ddd*K*f**2*r*s + 180*D1*Ddd*K*f**2*r - 720*D1*Ddd*K*f**2*s**2 + 720*D1*Ddd*K*f**2*s - 180*D1*Ddd*K*f**2 + 300*D1*Ddd*f**3*r*s - 75*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 504*D1*Ddd*f**2*r*s - 126*D1*Ddd*f**2*r + 504*D1*Ddd*f**2*s**2 - 504*D1*Ddd*f**2*s + 126*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 336*D1*Ddd*f*g2*s + 84*D1*Ddd*f*g2 + 42*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 2160*Dd**2*K*f**2*r*s + 540*Dd**2*K*f**2*r - 2160*Dd**2*K*f**2*s**2 + 2160*Dd**2*K*f**2*s - 360*Dd**2*K*f**2 + 900*Dd**2*f**3*r*s - 225*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 150*Dd**2*f**3 + 1512*Dd**2*f**2*r*s - 378*Dd**2*f**2*r + 1512*Dd**2*f**2*s**2 - 1512*Dd**2*f**2*s + 252*Dd**2*f**2 + 1008*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1008*Dd**2*f*g2*s + 168*Dd**2*f*g2))/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**4*k1**2*k2**3*(180*C*D1**2*bdd1*f**2*r*s - 180*C*D1**2*bdd1*f**2*r + 180*C*D1**2*bdd1*f**2*s**2 - 360*C*D1**2*bdd1*f**2*s + 180*C*D1**2*bdd1*f**2 + 120*C*D1**2*f**2*fd*r*s - 40*C*D1**2*f**2*fd*r + 120*C*D1**2*f**2*fd*s**2 - 120*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd + 210*C*D1**2*f**2*fdd*r*s - 70*C*D1**2*f**2*fdd*r + 210*C*D1**2*f**2*fdd*s**2 - 210*C*D1**2*f**2*fdd*s + 70*C*D1**2*f**2*fdd + 420*C*D1**2*f*fd**2*r*s - 140*C*D1**2*f*fd**2*r + 420*C*D1**2*f*fd**2*s**2 - 420*C*D1**2*f*fd**2*s + 70*C*D1**2*f*fd**2 + 160*C*D1*Dd*f**3*r*s - 40*C*D1*Dd*f**3*r + 160*C*D1*Dd*f**3*s**2 - 160*C*D1*Dd*f**3*s + 40*C*D1*Dd*f**3 + 1680*C*D1*Dd*f**2*fd*r*s - 490*C*D1*Dd*f**2*fd*r + 1680*C*D1*Dd*f**2*fd*s**2 - 1680*C*D1*Dd*f**2*fd*s + 350*C*D1*Dd*f**2*fd + 280*C*D1*Ddd*f**3*r*s - 70*C*D1*Ddd*f**3*r + 280*C*D1*Ddd*f**3*s**2 - 280*C*D1*Ddd*f**3*s + 70*C*D1*Ddd*f**3 + 840*C*Dd**2*f**3*r*s - 210*C*Dd**2*f**3*r + 840*C*Dd**2*f**3*s**2 - 840*C*Dd**2*f**3*s + 140*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*s**2 - 45*D1**2*K*bdd1*f**2*s - 3*D1**2*bd1**2*f*(2*s - 1)*(-42*K + 20*f + 21)*(r + s - 1) - 135*D1**2*bdd1*f**2*r*s + 135*D1**2*bdd1*f**2*r - 135*D1**2*bdd1*f**2*s**2 + 270*D1**2*bdd1*f**2*s - 135*D1**2*bdd1*f**2 - 252*D1**2*bdd1*f*g2*r*s + 252*D1**2*bdd1*f*g2*r - 252*D1**2*bdd1*f*g2*s**2 + 504*D1**2*bdd1*f*g2*s - 252*D1**2*bdd1*f*g2 - 150*D1**2*f**2*fd*r*s + 50*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 150*D1**2*f**2*fd*s - 50*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r*s + 35*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 105*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s - 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*s**2 + 90*D1**2*f**2*gdd2*s - 210*D1**2*f*fd**2*r*s + 70*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 210*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r*s + 90*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 90*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r*s + 90*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r*s + 90*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s - 200*D1*Dd*f**3*r*s + 50*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 200*D1*Dd*f**3*s - 50*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r*s + 245*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 840*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r*s + 90*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 720*D1*Dd*f**2*gd2*s - 90*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r*s + 540*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**3*r*s + 35*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 140*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r*s + 90*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*(2*s + 1)*(r + s - 1) + f**2*(r + s - 1)*(78*C*(s - 1) - s*(12*K + 41) + 55) + f*(-15*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + (-7*g2*(s - 1) + 6*gd2*(2*s - 1))*(14*r + 14*s - 14)) + 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(5*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 420*Dd**2*f**3*r*s + 105*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 420*Dd**2*f**3*s - 70*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r*s + 270*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 + b1**2*(D1**2*s*(3*f*(33*fd - 20*fdd)*(2*r + 2*s - 1) - 60*fd**2*(2*r + 2*s - 1) - 7*fd*(21*K - 8)*(r + s) + 63*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(99*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-60*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (56 - 147*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 63*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-42*K + 20*f + 21)) - 3*Dd**2*f*(-42*K + 20*f + 21)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*bdd1*f*(2*s - 1)*(-42*K + 20*f + 21)*(r + s - 1) - 3*D1**2*(5*f**2*fd*(r*(6*s - 3) + 6*s**2 - 7*s + 3) - f*(fd*(-156*C*s**2 + 78*C*s + 12*K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + r*(-156*C*s + 82*s + 14) + 82*s**2 - 27*s - 14) + 15*fdd*(K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + s*(4*C - 3)*(2*r + 2*s - 1)) + s*(98*gd2 - 84*gdd2)*(r + s - 1)) - 15*fd**2*(K*r*(2*s - 1) + 2*K*s*(s - 1) + s*(4*C - 3)*(2*r + 2*s - 1)) + 14*fd*s*(-7*g2*(r + s) + 6*gd2*(2*r + 2*s - 1)) + 84*fdd*g2*s*(r + s)) + D1*bd1*(D1*(99*f**2*(2*s - 1)*(r + s - 1) + f*(-60*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + (56 - 147*K)*(2*s - 1)*(r + s - 1)) + 63*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 3*Dd*f*(-42*K + 20*f + 21)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*D1*(Dd*(10*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(78*C - 12*K - 41) + f*(-15*fd*(C*(8*r*(8*s - 1) + 64*s**2 - 48*s + 4) + 2*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 48*r*s + 6*r - 48*s**2 + 36*s - 3) - 98*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 84*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 84*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(5*f*(4*C + K - 3) - 28*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*Dd**2*f*(5*f*(4*C + K - 3) - 28*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**4*k1**2*k2*st**2*(42*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(-10*f**3*s*(17*r + 17*s - 12) + f**2*(25*fd*(6*s - 1)*(4*r + 4*s - 3) - 6*s*(12*C*s + r*(12*C + 11) + 11*s - 23)) + 6*f*(3*fd*(r*(2*C + 3)*(4*s - 1) + s**2*(8*C + 12) - s*(6*C + 14) + 5) + 14*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) - 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(25*f**2*(8*s - 1)*(4*r + 4*s - 3) + 18*f*(r*(2*C + 3)*(8*s - 1) + s**2*(16*C + 24) - s*(8*C + 32) + 5) - 84*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 42*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(-5*f**2*(2*fd*(17*r*(3*s - 1) + 51*s**2 - 56*s + 17) - 5*fdd*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4)) + f*(25*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) - 6*fd*(12*C*(2*s - 1)*(r + s - 1) + 22*r*s - 11*r + 22*s**2 - 10*s + 11) + 18*fdd*(2*C*(2*s - 1)*(r + s - 1) + 6*r*s - 3*r + 6*s**2 - 4*s + 3) + 42*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) + 18*fd**2*(2*C*(2*s - 1)*(r + s - 1) + r*(6*s - 3) + 6*s**2 - 4*s - 2) + 84*fd*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) - 84*fdd*g2*(s - 1)*(r + s - 1)) + 42*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(-170*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(-72*C*(r*(4*s - 1) + (1 - 2*s)**2) + 25*fd*(24*s - 7)*(4*r + 4*s - 3) - 66*r*(4*s - 1) - 66*(1 - 2*s)**2) + 12*f*(3*fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 3*r*(8*s - 3) + 24*s**2 - 20*s + 5) + 7*g2*r*(8*s - 2) + 14*g2*(1 - 2*s)**2 + 7*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) - 84*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(50*f**2 + f*(18*C + 27) - 42*g2)) + 2*Dd**2*f*(50*f**2 + f*(18*C + 27) - 42*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(25*bdd1*f**2*s*(4*r + 4*s - 3) - 84*bdd1*g2*s*(r + s) + 2*f*(9*bdd1*s*(2*C*r + 2*C*s + 3*r + 3*s - 5) - 41*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 50*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 2*D1*f*(Dd*(41*f*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 25*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 50*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**4*k1**2*k2*(60*C*D1**2*bdd1*f**2*r*s + 60*C*D1**2*bdd1*f**2*s**2 + 240*C*D1**2*f**2*fd*r*s - 80*C*D1**2*f**2*fd*r + 240*C*D1**2*f**2*fd*s**2 - 240*C*D1**2*f**2*fd*s + 80*C*D1**2*f**2*fd - 210*C*D1**2*f**2*fdd*r*s + 70*C*D1**2*f**2*fdd*r - 210*C*D1**2*f**2*fdd*s**2 + 210*C*D1**2*f**2*fdd*s - 70*C*D1**2*f**2*fdd - 420*C*D1**2*f*fd**2*r*s + 140*C*D1**2*f*fd**2*r - 420*C*D1**2*f*fd**2*s**2 + 420*C*D1**2*f*fd**2*s - 70*C*D1**2*f*fd**2 + 320*C*D1*Dd*f**3*r*s - 80*C*D1*Dd*f**3*r + 320*C*D1*Dd*f**3*s**2 - 320*C*D1*Dd*f**3*s + 80*C*D1*Dd*f**3 - 1680*C*D1*Dd*f**2*fd*r*s + 490*C*D1*Dd*f**2*fd*r - 1680*C*D1*Dd*f**2*fd*s**2 + 1680*C*D1*Dd*f**2*fd*s - 350*C*D1*Dd*f**2*fd - 280*C*D1*Ddd*f**3*r*s + 70*C*D1*Ddd*f**3*r - 280*C*D1*Ddd*f**3*s**2 + 280*C*D1*Ddd*f**3*s - 70*C*D1*Ddd*f**3 - 840*C*Dd**2*f**3*r*s + 210*C*Dd**2*f**3*r - 840*C*Dd**2*f**3*s**2 + 840*C*Dd**2*f**3*s - 140*C*Dd**2*f**3 - 45*D1**2*K*bdd1*f**2*r*s - 45*D1**2*K*bdd1*f**2*s**2 + 45*D1**2*K*bdd1*f**2*s + 96*D1**2*b2*f*fd*r*s - 48*D1**2*b2*f*fd*r + 96*D1**2*b2*f*fd*s**2 - 96*D1**2*b2*f*fd*s + 48*D1**2*b2*f*fd - 90*D1**2*b2*f*fdd*r*s + 45*D1**2*b2*f*fdd*r - 90*D1**2*b2*f*fdd*s**2 + 90*D1**2*b2*f*fdd*s - 45*D1**2*b2*f*fdd - 90*D1**2*b2*fd**2*r*s + 45*D1**2*b2*fd**2*r - 90*D1**2*b2*fd**2*s**2 + 90*D1**2*b2*fd**2*s + D1**2*bd1**2*(15*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 3) + 21*f*(r*(C*(4*s - 2) + 4*K*s - 1) + s**2*(4*C + 4*K) - s*(4*C + 2*K + 4) + 3) - 70*g2*(r*(2*s - 1) + s*(2*s - 2))) + 48*D1**2*bd2*f**2*r*s + 48*D1**2*bd2*f**2*s**2 - 48*D1**2*bd2*f**2*s - 180*D1**2*bd2*f*fd*r*s + 45*D1**2*bd2*f*fd*r - 180*D1**2*bd2*f*fd*s**2 + 180*D1**2*bd2*f*fd*s - 45*D1**2*bd2*f*fd - 45*D1**2*bdd1*f**2*r - 90*D1**2*bdd1*f**2*s + 45*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r*s - 84*D1**2*bdd1*f*g2*s**2 - 45*D1**2*bdd2*f**2*r*s - 45*D1**2*bdd2*f**2*s**2 + 45*D1**2*bdd2*f**2*s - 30*D1**2*f**2*fd*r*s + 10*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 30*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r*s - 35*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 105*D1**2*f**2*fdd*s + 35*D1**2*f**2*fdd - 96*D1**2*f**2*gd2*r*s - 96*D1**2*f**2*gd2*s**2 + 96*D1**2*f**2*gd2*s + 90*D1**2*f**2*gdd2*r*s + 90*D1**2*f**2*gdd2*s**2 - 90*D1**2*f**2*gdd2*s + 210*D1**2*f*fd**2*r*s - 70*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 210*D1**2*f*fd**2*s + 35*D1**2*f*fd**2 - 192*D1**2*f*fd*g2*r*s + 96*D1**2*f*fd*g2*r - 192*D1**2*f*fd*g2*s**2 + 192*D1**2*f*fd*g2*s - 96*D1**2*f*fd*g2 + 360*D1**2*f*fd*gd2*r*s - 90*D1**2*f*fd*gd2*r + 360*D1**2*f*fd*gd2*s**2 - 360*D1**2*f*fd*gd2*s + 90*D1**2*f*fd*gd2 + 180*D1**2*f*fdd*g2*r*s - 90*D1**2*f*fdd*g2*r + 180*D1**2*f*fdd*g2*s**2 - 180*D1**2*f*fdd*g2*s + 90*D1**2*f*fdd*g2 + 180*D1**2*fd**2*g2*r*s - 90*D1**2*fd**2*g2*r + 180*D1**2*fd**2*g2*s**2 - 180*D1**2*fd**2*g2*s + 192*D1*Dd*b2*f**2*r*s - 48*D1*Dd*b2*f**2*r + 192*D1*Dd*b2*f**2*s**2 - 192*D1*Dd*b2*f**2*s + 48*D1*Dd*b2*f**2 - 720*D1*Dd*b2*f*fd*r*s + 270*D1*Dd*b2*f*fd*r - 720*D1*Dd*b2*f*fd*s**2 + 720*D1*Dd*b2*f*fd*s - 180*D1*Dd*b2*f*fd - 360*D1*Dd*bd2*f**2*r*s + 45*D1*Dd*bd2*f**2*r - 360*D1*Dd*bd2*f**2*s**2 + 360*D1*Dd*bd2*f**2*s - 45*D1*Dd*bd2*f**2 - 40*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 40*D1*Dd*f**3*s - 10*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r*s - 245*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 840*D1*Dd*f**2*fd*s + 175*D1*Dd*f**2*fd - 384*D1*Dd*f**2*g2*r*s + 96*D1*Dd*f**2*g2*r - 384*D1*Dd*f**2*g2*s**2 + 384*D1*Dd*f**2*g2*s - 96*D1*Dd*f**2*g2 + 720*D1*Dd*f**2*gd2*r*s - 90*D1*Dd*f**2*gd2*r + 720*D1*Dd*f**2*gd2*s**2 - 720*D1*Dd*f**2*gd2*s + 90*D1*Dd*f**2*gd2 + 1440*D1*Dd*f*fd*g2*r*s - 540*D1*Dd*f*fd*g2*r + 1440*D1*Dd*f*fd*g2*s**2 - 1440*D1*Dd*f*fd*g2*s + 360*D1*Dd*f*fd*g2 - 180*D1*Ddd*b2*f**2*r*s + 45*D1*Ddd*b2*f**2*r - 180*D1*Ddd*b2*f**2*s**2 + 180*D1*Ddd*b2*f**2*s - 45*D1*Ddd*b2*f**2 + 140*D1*Ddd*f**3*r*s - 35*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 140*D1*Ddd*f**3*s + 35*D1*Ddd*f**3 + 360*D1*Ddd*f**2*g2*r*s - 90*D1*Ddd*f**2*g2*r + 360*D1*Ddd*f**2*g2*s**2 - 360*D1*Ddd*f**2*g2*s + 90*D1*Ddd*f**2*g2 + 3*D1*bd1*(D1*(5*f**3*s*(3*r + 3*s - 2) + f**2*(r*(s*(2*C + 16*K - 14) + 23) + s**2*(2*C + 16*K - 14) - s*(16*K - 32) - 23) - f*(5*fd*(-16*C*s**2 + 12*C*s + 3*K*(r*(4*s - 1) + (1 - 2*s)**2) + r*(-16*C*s + 4*C + 3) + 6*s - 3) + 14*s*(g2*(r + s) + gd2*(4*r + 4*s - 2))) + 28*fd*g2*(-2*r*s + r - s*(2*s - 2))) - Dd*f*(5*f*(3*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 4*r*(8*C*s - C - 3) - 4*(2*s - 1)*(4*C*s - 3)) + 28*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 540*Dd**2*b2*f**2*r*s + 135*Dd**2*b2*f**2*r - 540*Dd**2*b2*f**2*s**2 + 540*Dd**2*b2*f**2*s - 90*Dd**2*b2*f**2 + 420*Dd**2*f**3*r*s - 105*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 420*Dd**2*f**3*s + 70*Dd**2*f**3 + 1080*Dd**2*f**2*g2*r*s - 270*Dd**2*f**2*g2*r + 1080*Dd**2*f**2*g2*s**2 - 1080*Dd**2*f**2*g2*s + 180*Dd**2*f**2*g2 - 35*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(-84*C*D1**2*fd*r*s - 84*C*D1**2*fd*s**2 + 84*C*D1**2*fd*s + 42*C*D1**2*fdd*r*s + 42*C*D1**2*fdd*s**2 - 42*C*D1**2*fdd*s - 336*C*D1*Dd*f*r*s + 84*C*D1*Dd*f*r - 336*C*D1*Dd*f*s**2 + 336*C*D1*Dd*f*s - 84*C*D1*Dd*f + 336*C*D1*Dd*fd*r*s - 42*C*D1*Dd*fd*r + 336*C*D1*Dd*fd*s**2 - 336*C*D1*Dd*fd*s + 42*C*D1*Dd*fd + 168*C*D1*Ddd*f*r*s - 42*C*D1*Ddd*f*r + 168*C*D1*Ddd*f*s**2 - 168*C*D1*Ddd*f*s + 42*C*D1*Ddd*f + 504*C*Dd**2*f*r*s - 126*C*Dd**2*f*r + 504*C*Dd**2*f*s**2 - 504*C*Dd**2*f*s + 84*C*Dd**2*f + 21*D1**2*K*fd*r*s - 21*D1**2*K*fd*r + 21*D1**2*K*fd*s**2 - 42*D1**2*K*fd*s + 21*D1**2*K*fd + 42*D1**2*K*fdd*r*s - 42*D1**2*K*fdd*r + 42*D1**2*K*fdd*s**2 - 84*D1**2*K*fdd*s + 42*D1**2*K*fdd + 35*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 120*D1**2*f*fd*r*s - 39*D1**2*f*fd*r - 120*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s + 39*D1**2*f*fd + 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 + 15*D1**2*f*fdd*s - 30*D1**2*f*fdd + 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 + 15*D1**2*fd**2*s - 30*D1**2*fd**2 - 35*D1**2*fd*r*s + 28*D1**2*fd*r - 35*D1**2*fd*s**2 - 28*D1**2*fd*s - 28*D1**2*fd + 21*D1**2*fdd*r + 84*D1**2*fdd*s - 21*D1**2*fdd + 140*D1**2*gd2*r*s + 140*D1**2*gd2*s**2 - 140*D1**2*gd2*s - 70*D1**2*gdd2*r*s - 70*D1**2*gdd2*s**2 + 70*D1**2*gdd2*s + 84*D1*Dd*K*f*r*s - 21*D1*Dd*K*f*r + 84*D1*Dd*K*f*s**2 - 84*D1*Dd*K*f*s + 21*D1*Dd*K*f + 336*D1*Dd*K*fd*r*s - 210*D1*Dd*K*fd*r + 336*D1*Dd*K*fd*s**2 - 504*D1*Dd*K*fd*s + 168*D1*Dd*K*fd - 240*D1*Dd*f**2*r*s + 60*D1*Dd*f**2*r - 240*D1*Dd*f**2*s**2 + 240*D1*Dd*f**2*s - 60*D1*Dd*f**2 + 480*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 180*D1*Dd*f*fd*s - 75*D1*Dd*f*fd - 140*D1*Dd*f*r*s + 35*D1*Dd*f*r - 140*D1*Dd*f*s**2 + 140*D1*Dd*f*s - 35*D1*Dd*f + 84*D1*Dd*fd*r + 336*D1*Dd*fd*s - 126*D1*Dd*fd + 560*D1*Dd*g2*r*s - 140*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 560*D1*Dd*g2*s + 140*D1*Dd*g2 - 560*D1*Dd*gd2*r*s + 70*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 560*D1*Dd*gd2*s - 70*D1*Dd*gd2 + 168*D1*Ddd*K*f*r*s - 42*D1*Ddd*K*f*r + 168*D1*Ddd*K*f*s**2 - 168*D1*Ddd*K*f*s + 42*D1*Ddd*K*f + 120*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 120*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 - 280*D1*Ddd*g2*r*s + 70*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 280*D1*Ddd*g2*s - 70*D1*Ddd*g2 - 35*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 504*Dd**2*K*f*r*s - 126*Dd**2*K*f*r + 504*Dd**2*K*f*s**2 - 504*Dd**2*K*f*s + 84*Dd**2*K*f + 360*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 360*Dd**2*f**2*s + 60*Dd**2*f**2 - 840*Dd**2*g2*r*s + 210*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 840*Dd**2*g2*s - 140*Dd**2*g2) + b1*(35*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(15*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 4) + 21*f*(C*(4*r*s - 2*r + 4*s**2 - 4*s + 2) + 4*K*r*s + 4*K*s**2 - 2*K*s - r - 4*s + 1) - 70*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 3*D1**2*(5*f**2*fd*(r*(9*s - 3) + 9*s**2 - 10*s + 3) + f*(fd*(2*C*(2*s - 1)*(r + s - 1) + 16*K*(2*r*s - r + 2*s**2 - 2*s + 1) - 28*r*s - 9*r - 28*s**2 + 10*s + 9) + 5*fdd*(4*C*(2*s - 1)*(r + s - 1) + 3*K*(-2*r*s + r - 2*s**2 + 2*s - 1) + 3*r + 6*s - 3) + s*(-14*gd2 - 28*gdd2)*(r + s - 1)) + 5*fd**2*(4*C*(2*s - 1)*(r + s - 1) - 6*K*s**2 + 6*K*s + 3*r*(-2*K*s + K + 1) + 6*s - 3) - 14*fd*(g2*(s - 1) + 2*gd2*(2*s - 1))*(r + s - 1) - 28*fdd*g2*(s - 1)*(r + s - 1)) + D1*bd1*(D1*(-3*f**2*(r*(40*s - 33) + 40*s**2 - 76*s + 33) + f*(-84*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd*(4*s - 1)*(4*r + 4*s - 3) + 7*r*s*(6*K - 10) + 7*r + 7*s**2*(6*K - 10) + 7*s*(19 - 3*K) - 7) + 21*fd*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + 2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + r + 4*s - 3) + 70*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 70*gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*(15*f**2*(4*r*(8*s - 5) + 32*s**2 - 52*s + 17) + 42*f*(2*C*r*(8*s - 3) + 4*C*(1 - 2*s)**2 + K*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 2*r - 8*s + 3) - 140*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 3*D1*(Dd*(15*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + 2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(C + 8*K - 7) + 2*f*(5*fd*(2*C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) - 3*K*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 6*r + 12*s - 6) - 7*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 14*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 28*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(20*C*f - 15*K*f - 28*g2)) + 3*Dd**2*f*(20*C*f - 15*K*f - 28*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**4*k1**2*(3*D1*f*(D1*bd1**2*s*(5*f + 7)*(2*r + 2*s - 1) + D1*bd1*(-3*f*s*(r + s) + 5*fd*(r*(4*s - 1) + s*(4*s - 3))) + 5*D1*bdd1*f*s*(r + s) + 5*Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + b1**2*(D1**2*(r + s - 1)*(15*fd**2*(2*s - 1) + fd*(f*(9 - 18*s) - 7*s + 7) + 3*fdd*(10*f*s - 5*f + 7*s - 7)) + D1*(Dd*(-9*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(15*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) - 7*r*(4*s - 1) - 7*(1 - 2*s)**2) + 21*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 3*Ddd*f*(5*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd**2*f*(5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(3*D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(7*bdd1*s*(2*r + 2*s - 1) - 3*fd*(2*s - 1)*(r + s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) + 5*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-f*s*(9*f + 7)*(2*r + 2*s - 1) + 3*fd*(5*f*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + 28*r*s - 14*r + 28*s**2 - 35*s + 7)) + 3*Dd*f*(5*f + 7)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 3*D1*f*(Dd*(-3*f*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2*k3) + D1**2*Pkd2*Pkd3*ct**4*k2**5*st**2*(D1**2*(f**2*(-fd*(20*C - 10)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(9*K*(-2*bd1 + bdd1) + 36*gd2 - 18*gdd2)) + f*(fd**2*(10*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 9*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) - 9*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 9*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(10 - 20*C)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(9*K*(b1*r*(2 - 8*s) - 2*b1*(1 - 2*s)**2 + bd1*r*(8*s - 1) + 8*bd1*s**2 - 8*bd1*s + bd1) + fd*(10*C - 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 36*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 18*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 18*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(10*C*f + 9*K*b1 - 5*f - 18*g2)) + Dd**2*f**2*(10*C*f + 9*K*b1 - 5*f - 18*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(21*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**4*k2**5*(-40*C*D1**2*b1*f*fd*r*s - 40*C*D1**2*b1*f*fd*s**2 + 20*C*D1**2*b1*f*fd*s + 20*C*D1**2*b1*f*fdd*r*s + 20*C*D1**2*b1*f*fdd*s**2 - 10*C*D1**2*b1*f*fdd*s + 20*C*D1**2*b1*fd**2*r*s + 20*C*D1**2*b1*fd**2*s**2 - 10*C*D1**2*b1*fd**2*s + 30*C*D1**2*f**2*fd*r*s - 10*C*D1**2*f**2*fd*r + 30*C*D1**2*f**2*fd*s**2 - 30*C*D1**2*f**2*fd*s + 10*C*D1**2*f**2*fd - 80*C*D1*Dd*b1*f**2*r*s + 20*C*D1*Dd*b1*f**2*r - 80*C*D1*Dd*b1*f**2*s**2 + 80*C*D1*Dd*b1*f**2*s - 20*C*D1*Dd*b1*f**2 + 160*C*D1*Dd*b1*f*fd*r*s - 20*C*D1*Dd*b1*f*fd*r + 160*C*D1*Dd*b1*f*fd*s**2 - 120*C*D1*Dd*b1*f*fd*s + 10*C*D1*Dd*b1*f*fd + 40*C*D1*Dd*f**3*r*s - 10*C*D1*Dd*f**3*r + 40*C*D1*Dd*f**3*s**2 - 40*C*D1*Dd*f**3*s + 10*C*D1*Dd*f**3 + 40*C*D1*Ddd*b1*f**2*r*s - 10*C*D1*Ddd*b1*f**2*r + 40*C*D1*Ddd*b1*f**2*s**2 - 40*C*D1*Ddd*b1*f**2*s + 10*C*D1*Ddd*b1*f**2 + 120*C*Dd**2*b1*f**2*r*s - 30*C*Dd**2*b1*f**2*r + 120*C*Dd**2*b1*f**2*s**2 - 120*C*Dd**2*b1*f**2*s + 20*C*Dd**2*b1*f**2 - 14*D1**2*K*b1**2*fd*r*s - 14*D1**2*K*b1**2*fd*s**2 + 7*D1**2*K*b1**2*fdd*r*s + 7*D1**2*K*b1**2*fdd*s**2 + 14*D1**2*K*b1*f*fd*r*s - 7*D1**2*K*b1*f*fd*r + 14*D1**2*K*b1*f*fd*s**2 - 14*D1**2*K*b1*f*fd*s + 7*D1**2*K*b1*f*fd + 7*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 20*D1**2*b1*f*fd*r*s + 20*D1**2*b1*f*fd*s**2 - 10*D1**2*b1*f*fd*s - 10*D1**2*b1*f*fdd*r*s - 10*D1**2*b1*f*fdd*s**2 + 5*D1**2*b1*f*fdd*s + 28*D1**2*b1*f*gd2*r*s + 28*D1**2*b1*f*gd2*s**2 - 28*D1**2*b1*f*gd2*s - 14*D1**2*b1*f*gdd2*r*s - 14*D1**2*b1*f*gdd2*s**2 + 14*D1**2*b1*f*gdd2*s - 10*D1**2*b1*fd**2*r*s - 10*D1**2*b1*fd**2*s**2 + 5*D1**2*b1*fd**2*s + 28*D1**2*b1*fd*g2*r*s + 28*D1**2*b1*fd*g2*s**2 - 28*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*s**2 + 14*D1**2*b1*fd*gd2*s - 14*D1**2*b1*fdd*g2*r*s - 14*D1**2*b1*fdd*g2*s**2 + D1**2*bdd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(10*C - 5)*(s - 1) - 14*g2*(s - 1)) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd - 14*D1**2*f**2*gd2*r*s - 14*D1**2*f**2*gd2*s**2 + 14*D1**2*f**2*gd2*s - 28*D1**2*f*fd*g2*r*s + 14*D1**2*f*fd*g2*r - 28*D1**2*f*fd*g2*s**2 + 28*D1**2*f*fd*g2*s - 14*D1**2*f*fd*g2 - 56*D1*Dd*K*b1**2*f*r*s + 14*D1*Dd*K*b1**2*f*r - 56*D1*Dd*K*b1**2*f*s**2 + 56*D1*Dd*K*b1**2*f*s - 14*D1*Dd*K*b1**2*f + 56*D1*Dd*K*b1**2*fd*r*s - 7*D1*Dd*K*b1**2*fd*r + 56*D1*Dd*K*b1**2*fd*s**2 - 28*D1*Dd*K*b1**2*fd*s + 28*D1*Dd*K*b1*f**2*r*s - 7*D1*Dd*K*b1*f**2*r + 28*D1*Dd*K*b1*f**2*s**2 - 28*D1*Dd*K*b1*f**2*s + 7*D1*Dd*K*b1*f**2 + 40*D1*Dd*b1*f**2*r*s - 10*D1*Dd*b1*f**2*r + 40*D1*Dd*b1*f**2*s**2 - 40*D1*Dd*b1*f**2*s + 10*D1*Dd*b1*f**2 - 80*D1*Dd*b1*f*fd*r*s + 10*D1*Dd*b1*f*fd*r - 80*D1*Dd*b1*f*fd*s**2 + 60*D1*Dd*b1*f*fd*s - 5*D1*Dd*b1*f*fd + 112*D1*Dd*b1*f*g2*r*s - 28*D1*Dd*b1*f*g2*r + 112*D1*Dd*b1*f*g2*s**2 - 112*D1*Dd*b1*f*g2*s + 28*D1*Dd*b1*f*g2 - 112*D1*Dd*b1*f*gd2*r*s + 14*D1*Dd*b1*f*gd2*r - 112*D1*Dd*b1*f*gd2*s**2 + 112*D1*Dd*b1*f*gd2*s - 14*D1*Dd*b1*f*gd2 - 112*D1*Dd*b1*fd*g2*r*s + 14*D1*Dd*b1*fd*g2*r - 112*D1*Dd*b1*fd*g2*s**2 + 56*D1*Dd*b1*fd*g2*s - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 - 56*D1*Dd*f**2*g2*r*s + 14*D1*Dd*f**2*g2*r - 56*D1*Dd*f**2*g2*s**2 + 56*D1*Dd*f**2*g2*s - 14*D1*Dd*f**2*g2 + 28*D1*Ddd*K*b1**2*f*r*s - 7*D1*Ddd*K*b1**2*f*r + 28*D1*Ddd*K*b1**2*f*s**2 - 28*D1*Ddd*K*b1**2*f*s + 7*D1*Ddd*K*b1**2*f - 20*D1*Ddd*b1*f**2*r*s + 5*D1*Ddd*b1*f**2*r - 20*D1*Ddd*b1*f**2*s**2 + 20*D1*Ddd*b1*f**2*s - 5*D1*Ddd*b1*f**2 - 56*D1*Ddd*b1*f*g2*r*s + 14*D1*Ddd*b1*f*g2*r - 56*D1*Ddd*b1*f*g2*s**2 + 56*D1*Ddd*b1*f*g2*s - 14*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(-f**2*(r + s - 1)*(20*C*(s - 1) - 7*K*s - 10*s + 10) + f*(fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(14*r + 14*s - 14)) - 7*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(7*K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + f*(10*C - 5)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 14*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) + 84*Dd**2*K*b1**2*f*r*s - 21*Dd**2*K*b1**2*f*r + 84*Dd**2*K*b1**2*f*s**2 - 84*Dd**2*K*b1**2*f*s + 14*Dd**2*K*b1**2*f - 60*Dd**2*b1*f**2*r*s + 15*Dd**2*b1*f**2*r - 60*Dd**2*b1*f**2*s**2 + 60*Dd**2*b1*f**2*s - 10*Dd**2*b1*f**2 - 168*Dd**2*b1*f*g2*r*s + 42*Dd**2*b1*f*g2*r - 168*Dd**2*b1*f*g2*s**2 + 168*Dd**2*b1*f*g2*s - 28*Dd**2*b1*f*g2)/(35*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**4*k2**3*st**2*(60*C*D1**2*f**2*fd*r*s - 20*C*D1**2*f**2*fd*r + 60*C*D1**2*f**2*fd*s**2 - 60*C*D1**2*f**2*fd*s + 20*C*D1**2*f**2*fd - 30*C*D1**2*f**2*fdd*r*s + 10*C*D1**2*f**2*fdd*r - 30*C*D1**2*f**2*fdd*s**2 + 30*C*D1**2*f**2*fdd*s - 10*C*D1**2*f**2*fdd - 60*C*D1**2*f*fd**2*r*s + 20*C*D1**2*f*fd**2*r - 60*C*D1**2*f*fd**2*s**2 + 60*C*D1**2*f*fd**2*s - 10*C*D1**2*f*fd**2 + 80*C*D1*Dd*f**3*r*s - 20*C*D1*Dd*f**3*r + 80*C*D1*Dd*f**3*s**2 - 80*C*D1*Dd*f**3*s + 20*C*D1*Dd*f**3 - 240*C*D1*Dd*f**2*fd*r*s + 70*C*D1*Dd*f**2*fd*r - 240*C*D1*Dd*f**2*fd*s**2 + 240*C*D1*Dd*f**2*fd*s - 50*C*D1*Dd*f**2*fd - 40*C*D1*Ddd*f**3*r*s + 10*C*D1*Ddd*f**3*r - 40*C*D1*Ddd*f**3*s**2 + 40*C*D1*Ddd*f**3*s - 10*C*D1*Ddd*f**3 - 120*C*Dd**2*f**3*r*s + 30*C*Dd**2*f**3*r - 120*C*Dd**2*f**3*s**2 + 120*C*Dd**2*f**3*s - 20*C*Dd**2*f**3 + 36*D1**2*K*b1*f*fd*r*s - 18*D1**2*K*b1*f*fd*r + 36*D1**2*K*b1*f*fd*s**2 - 36*D1**2*K*b1*f*fd*s + 18*D1**2*K*b1*f*fd - 18*D1**2*K*b1*f*fdd*r*s + 9*D1**2*K*b1*f*fdd*r - 18*D1**2*K*b1*f*fdd*s**2 + 18*D1**2*K*b1*f*fdd*s - 9*D1**2*K*b1*f*fdd - 18*D1**2*K*b1*fd**2*r*s + 9*D1**2*K*b1*fd**2*r - 18*D1**2*K*b1*fd**2*s**2 + 18*D1**2*K*b1*fd**2*s + 18*D1**2*K*bd1*f**2*r*s + 18*D1**2*K*bd1*f**2*s**2 - 18*D1**2*K*bd1*f**2*s - 36*D1**2*K*bd1*f*fd*r*s + 9*D1**2*K*bd1*f*fd*r - 36*D1**2*K*bd1*f*fd*s**2 + 36*D1**2*K*bd1*f*fd*s - 9*D1**2*K*bd1*f*fd - 9*D1**2*K*bdd1*f**2*r*s - 9*D1**2*K*bdd1*f**2*s**2 + 9*D1**2*K*bdd1*f**2*s - 9*D1**2*bdd2*f**2*r*s - 9*D1**2*bdd2*f**2*s**2 + 9*D1**2*bdd2*f**2*s - 30*D1**2*f**2*fd*r*s + 10*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 30*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r*s - 5*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 15*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd - 36*D1**2*f**2*gd2*r*s - 36*D1**2*f**2*gd2*s**2 + 36*D1**2*f**2*gd2*s + 18*D1**2*f**2*gdd2*r*s + 18*D1**2*f**2*gdd2*s**2 - 18*D1**2*f**2*gdd2*s + 30*D1**2*f*fd**2*r*s - 10*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 30*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 - 72*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 72*D1**2*f*fd*g2*s - 36*D1**2*f*fd*g2 + 72*D1**2*f*fd*gd2*r*s - 18*D1**2*f*fd*gd2*r + 72*D1**2*f*fd*gd2*s**2 - 72*D1**2*f*fd*gd2*s + 18*D1**2*f*fd*gd2 + 36*D1**2*f*fdd*g2*r*s - 18*D1**2*f*fdd*g2*r + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 36*D1**2*fd**2*g2*r*s - 18*D1**2*fd**2*g2*r + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 72*D1*Dd*K*b1*f**2*r*s - 18*D1*Dd*K*b1*f**2*r + 72*D1*Dd*K*b1*f**2*s**2 - 72*D1*Dd*K*b1*f**2*s + 18*D1*Dd*K*b1*f**2 - 144*D1*Dd*K*b1*f*fd*r*s + 54*D1*Dd*K*b1*f*fd*r - 144*D1*Dd*K*b1*f*fd*s**2 + 144*D1*Dd*K*b1*f*fd*s - 36*D1*Dd*K*b1*f*fd - 72*D1*Dd*K*bd1*f**2*r*s + 9*D1*Dd*K*bd1*f**2*r - 72*D1*Dd*K*bd1*f**2*s**2 + 72*D1*Dd*K*bd1*f**2*s - 9*D1*Dd*K*bd1*f**2 - 40*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 40*D1*Dd*f**3*s - 10*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r*s - 35*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 120*D1*Dd*f**2*fd*s + 25*D1*Dd*f**2*fd - 144*D1*Dd*f**2*g2*r*s + 36*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 144*D1*Dd*f**2*g2*s - 36*D1*Dd*f**2*g2 + 144*D1*Dd*f**2*gd2*r*s - 18*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s**2 - 144*D1*Dd*f**2*gd2*s + 18*D1*Dd*f**2*gd2 + 288*D1*Dd*f*fd*g2*r*s - 108*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s**2 - 288*D1*Dd*f*fd*g2*s + 72*D1*Dd*f*fd*g2 - 36*D1*Ddd*K*b1*f**2*r*s + 9*D1*Ddd*K*b1*f**2*r - 36*D1*Ddd*K*b1*f**2*s**2 + 36*D1*Ddd*K*b1*f**2*s - 9*D1*Ddd*K*b1*f**2 + 20*D1*Ddd*f**3*r*s - 5*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 20*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 72*D1*Ddd*f**2*g2*r*s - 18*D1*Ddd*f**2*g2*r + 72*D1*Ddd*f**2*g2*s**2 - 72*D1*Ddd*f**2*g2*s + 18*D1*Ddd*f**2*g2 + 9*D1*bd2*f*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 108*Dd**2*K*b1*f**2*r*s + 27*Dd**2*K*b1*f**2*r - 108*Dd**2*K*b1*f**2*s**2 + 108*Dd**2*K*b1*f**2*s - 18*Dd**2*K*b1*f**2 + 60*Dd**2*f**3*r*s - 15*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 60*Dd**2*f**3*s + 10*Dd**2*f**3 + 216*Dd**2*f**2*g2*r*s - 54*Dd**2*f**2*g2*r + 216*Dd**2*f**2*g2*s**2 - 216*Dd**2*f**2*g2*s + 36*Dd**2*f**2*g2 + 9*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(21*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**4*k2**3*(D1*(7*D1*K*bd1**2*f*(r + 2*s - 1) + 7*K*b1**2*(r + 2*s - 1)*(2*D1*fd - D1*fdd - 4*Dd*fd) + b1*(7*D1*bd2*s*(2*f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + D1*f*(7*K*bdd1*(r + 2*s - 1) - 7*bdd2*s*(r + s - 1) + fd*(20*C*(r + 2*s - 1) - 7*K*(2*r*s - r + 2*s**2 - 2*s + 1) - 10*r - 20*s + 10) - fdd*(10*C - 5)*(r + 2*s - 1)) - D1*(r + 2*s - 1)*(fd**2*(10*C - 5) + 14*fd*(2*g2 - gd2) - 14*fdd*g2) - 7*Dd*K*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 7*Dd*bd2*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + Dd*f*fd*(20 - 40*C)*(r + 2*s - 1) + 56*Dd*fd*g2*(r + 2*s - 1)) - bd1*(7*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(7*K*b1*fd*(r + 2*s - 1) + f**2*(20*C*(r + 2*s - 1) + 7*K*s**2 - 7*K*s + r*(7*K*s - 10) - 20*s + 10) - f*(r + 2*s - 1)*(-14*K*b1 + fd*(10*C - 5) + 28*g2 - 14*gd2)) - 4*Dd*f*(r + 2*s - 1)*(10*C*f + 7*K*b1 - 5*f - 14*g2)) + f*(D1*bdd1*(f*(10*C - 5) - 14*g2)*(r + 2*s - 1) + D1*(f*(-fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-7*bd2 + 14*gd2)*(r + s - 1)) + 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(35*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**4*k2*(D1*(-7*D1*K*bd1**2*f*s*(2*r + 2*s - 1) - D1*bdd1*f*s*(r + s)*(f*(10*C - 5) - 14*g2) - 7*b2*(D1*bd1*(-2*f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + D1*bdd1*f*s*(r + s) + Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) - bd1*(D1*(f**2*s*(10 - 20*C)*(r + s) + f*(fd*(10*C - 5)*(r*(4*s - 1) + s*(4*s - 3)) + 7*s*(bd2*(2*r + 2*s - 1) + 4*g2*(r + s) + gd2*(-4*r - 4*s + 2))) + 14*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 7*K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(40*C*D1**2*f*fd*r*s - 20*C*D1**2*f*fd*r + 40*C*D1**2*f*fd*s**2 - 60*C*D1**2*f*fd*s + 20*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r*s + 10*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 30*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r*s + 10*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 30*C*D1**2*fd**2*s - 10*C*D1**2*fd**2 + 80*C*D1*Dd*f**2*r*s - 20*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s**2 - 80*C*D1*Dd*f**2*s + 20*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r*s + 60*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 200*C*D1*Dd*f*fd*s - 50*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r*s + 10*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 40*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r*s + 30*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 120*C*Dd**2*f**2*s - 20*C*Dd**2*f**2 + 28*D1**2*K*bd1*f*r*s + 28*D1**2*K*bd1*f*s**2 - 14*D1**2*K*bd1*f*s - 28*D1**2*K*bd1*fd*r*s + 14*D1**2*K*bd1*fd*r - 28*D1**2*K*bd1*fd*s**2 + 35*D1**2*K*bd1*fd*s - 7*D1**2*K*bd1*fd - 14*D1**2*K*bdd1*f*r*s - 14*D1**2*K*bdd1*f*s**2 + 7*D1**2*K*bdd1*f*s - 7*D1**2*bdd2*f*r*s - 7*D1**2*bdd2*f*s**2 + 7*D1**2*bdd2*f*s - 20*D1**2*f*fd*r*s + 10*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 30*D1**2*f*fd*s - 10*D1**2*f*fd + 10*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 15*D1**2*f*fdd*s + 5*D1**2*f*fdd - 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*s**2 + 28*D1**2*f*gd2*s + 14*D1**2*f*gdd2*r*s + 14*D1**2*f*gdd2*s**2 - 14*D1**2*f*gdd2*s + 10*D1**2*fd**2*r*s - 5*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 15*D1**2*fd**2*s + 5*D1**2*fd**2 - 28*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 28*D1**2*fd*gd2*r*s - 14*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 42*D1**2*fd*gd2*s + 14*D1**2*fd*gd2 + 14*D1**2*fdd*g2*r*s - 14*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 112*D1*Dd*K*bd1*f*r*s + 14*D1*Dd*K*bd1*f*r - 112*D1*Dd*K*bd1*f*s**2 + 84*D1*Dd*K*bd1*f*s - 7*D1*Dd*K*bd1*f - 40*D1*Dd*f**2*r*s + 10*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 40*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 80*D1*Dd*f*fd*r*s - 30*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 100*D1*Dd*f*fd*s + 25*D1*Dd*f*fd - 112*D1*Dd*f*g2*r*s + 28*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 112*D1*Dd*f*g2*s - 28*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r*s - 14*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 112*D1*Dd*f*gd2*s + 14*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r*s - 70*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s + 56*D1*Dd*fd*g2 + 20*D1*Ddd*f**2*r*s - 5*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 20*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r*s - 14*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 56*D1*Ddd*f*g2*s + 14*D1*Ddd*f*g2 + 7*D1*bd2*(D1*(r + s - 1)*(2*f*s - 2*fd*s + fd) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 60*Dd**2*f**2*r*s - 15*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 60*Dd**2*f**2*s + 10*Dd**2*f**2 + 168*Dd**2*f*g2*r*s - 42*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 168*Dd**2*f*g2*s + 28*Dd**2*f*g2 + 7*b2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(35*d**2*k3) - D1**2*Pkd2*Pkd3*ct**3*k1**5*st**2*(1386*C*D1**2*f**2*fd*r*s - 462*C*D1**2*f**2*fd*r + 1386*C*D1**2*f**2*fd*s**2 - 1386*C*D1**2*f**2*fd*s + 462*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 1848*C*D1*Dd*f**3*r*s - 462*C*D1*Dd*f**3*r + 1848*C*D1*Dd*f**3*s**2 - 1848*C*D1*Dd*f**3*s + 462*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 297*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 297*D1**2*K*bdd1*f**2*s + 297*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 297*D1**2*bdd1*f**2*s + 7240*D1**2*f**3*fd*r*s - 1810*D1**2*f**3*fd*r + 7240*D1**2*f**3*fd*s**2 - 7240*D1**2*f**3*fd*s + 1810*D1**2*f**3*fd - 5600*D1**2*f**3*fdd*r*s + 1400*D1**2*f**3*fdd*r - 5600*D1**2*f**3*fdd*s**2 + 5600*D1**2*f**3*fdd*s - 1400*D1**2*f**3*fdd - 16800*D1**2*f**2*fd**2*r*s + 4200*D1**2*f**2*fd**2*r - 16800*D1**2*f**2*fd**2*s**2 + 16800*D1**2*f**2*fd**2*s - 2800*D1**2*f**2*fd**2 - 1386*D1**2*f**2*fd*r*s + 462*D1**2*f**2*fd*r - 1386*D1**2*f**2*fd*s**2 + 1386*D1**2*f**2*fd*s - 462*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 726*D1**2*f**2*gd2*r*s - 726*D1**2*f**2*gd2*s**2 + 726*D1**2*f**2*gd2*s + 594*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 594*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 1452*D1**2*f*fd*g2*r*s + 726*D1**2*f*fd*g2*r - 1452*D1**2*f*fd*g2*s**2 + 1452*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r*s - 594*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 594*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r*s - 594*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r*s - 594*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 7240*D1*Dd*f**4*r*s - 1810*D1*Dd*f**4*r + 7240*D1*Dd*f**4*s**2 - 7240*D1*Dd*f**4*s + 1810*D1*Dd*f**4 - 44800*D1*Dd*f**3*fd*r*s + 11200*D1*Dd*f**3*fd*r - 44800*D1*Dd*f**3*fd*s**2 + 44800*D1*Dd*f**3*fd*s - 8400*D1*Dd*f**3*fd - 1848*D1*Dd*f**3*r*s + 462*D1*Dd*f**3*r - 1848*D1*Dd*f**3*s**2 + 1848*D1*Dd*f**3*s - 462*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 2904*D1*Dd*f**2*g2*r*s + 726*D1*Dd*f**2*g2*r - 2904*D1*Dd*f**2*g2*s**2 + 2904*D1*Dd*f**2*g2*s - 726*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r*s - 594*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 594*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r*s - 3564*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 9504*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 - 5600*D1*Ddd*f**4*r*s + 1400*D1*Ddd*f**4*r - 5600*D1*Ddd*f**4*s**2 + 5600*D1*Ddd*f**4*s - 1400*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r*s - 594*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 16800*Dd**2*f**4*r*s + 4200*Dd**2*f**4*r - 16800*Dd**2*f**4*s**2 + 16800*Dd**2*f**4*s - 2800*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r*s - 1782*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 1188*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3465*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**3*k1**5*(D1*(63*D1*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + D1*bdd1*f*(r + s - 1)*(35*f**2*(3*s - 4) + f*(90*C - 90)*(s - 1) - 126*g2*(s - 1)) + bd1*(D1*(-5*f**3*(24*s - 29)*(r + s - 1) + f**2*(-54*C*(s - 1)*(r + s - 1) + 35*fd*(18*r*s - 11*r + 18*s**2 - 26*s + 7) + (54*s - 54)*(r + s - 1)) + 6*f*(fd*(15*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (7*g2*(s - 1) + 7*gd2*(3 - 6*s))*(r + s - 1)) - 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(35*f**2*(r*(24*s - 19) + 24*s**2 - 40*s + 15) + f*(90*C - 90)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 126*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 35*f**3*(D1*fd + Dd*f)*(r*(4*s - 1) + (1 - 2*s)**2)) - 21*b1**2*(K - 1)*(D1**2*s*(fd - 3*fdd)*(r + s) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*fd*(-8*r*s + r + s*(4 - 8*s))) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-108*C*D1**2*f*fd*r*s - 108*C*D1**2*f*fd*s**2 + 54*C*D1**2*f*fd*s + 180*C*D1**2*f*fdd*r*s + 180*C*D1**2*f*fdd*s**2 - 90*C*D1**2*f*fdd*s + 180*C*D1**2*fd**2*r*s + 180*C*D1**2*fd**2*s**2 - 90*C*D1**2*fd**2*s - 216*C*D1*Dd*f**2*r*s + 54*C*D1*Dd*f**2*r - 216*C*D1*Dd*f**2*s**2 + 216*C*D1*Dd*f**2*s - 54*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r*s - 180*C*D1*Dd*f*fd*r + 1440*C*D1*Dd*f*fd*s**2 - 1080*C*D1*Dd*f*fd*s + 90*C*D1*Dd*f*fd + 360*C*D1*Ddd*f**2*r*s - 90*C*D1*Ddd*f**2*r + 360*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 90*C*D1*Ddd*f**2 + 1080*C*Dd**2*f**2*r*s - 270*C*Dd**2*f**2*r + 1080*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 180*C*Dd**2*f**2 + 63*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 360*D1**2*f**2*fd*r*s - 25*D1**2*f**2*fd*r - 360*D1**2*f**2*fd*s**2 + 215*D1**2*f**2*fd*s + 25*D1**2*f**2*fd + 315*D1**2*f**2*fdd*r*s + 35*D1**2*f**2*fdd*r + 315*D1**2*f**2*fdd*s**2 - 175*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd + 630*D1**2*f*fd**2*r*s + 70*D1**2*f*fd**2*r + 630*D1**2*f*fd**2*s**2 - 350*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 108*D1**2*f*fd*r*s + 108*D1**2*f*fd*s**2 - 54*D1**2*f*fd*s - 180*D1**2*f*fdd*r*s - 180*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s + 42*D1**2*f*gd2*r*s + 42*D1**2*f*gd2*s**2 - 42*D1**2*f*gd2*s - 126*D1**2*f*gdd2*r*s - 126*D1**2*f*gdd2*s**2 + 126*D1**2*f*gdd2*s - 180*D1**2*fd**2*r*s - 180*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 42*D1**2*fd*g2*r*s + 42*D1**2*fd*g2*s**2 - 252*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*s**2 + 126*D1**2*fd*gd2*s - 126*D1**2*fdd*g2*r*s - 126*D1**2*fdd*g2*s**2 - 480*D1*Dd*f**3*r*s + 120*D1*Dd*f**3*r - 480*D1*Dd*f**3*s**2 + 480*D1*Dd*f**3*s - 120*D1*Dd*f**3 + 2520*D1*Dd*f**2*fd*r*s - 175*D1*Dd*f**2*fd*r + 2520*D1*Dd*f**2*fd*s**2 - 1960*D1*Dd*f**2*fd*s + 105*D1*Dd*f**2*fd + 216*D1*Dd*f**2*r*s - 54*D1*Dd*f**2*r + 216*D1*Dd*f**2*s**2 - 216*D1*Dd*f**2*s + 54*D1*Dd*f**2 - 1440*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 1440*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 168*D1*Dd*f*g2*r*s - 42*D1*Dd*f*g2*r + 168*D1*Dd*f*g2*s**2 - 168*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r*s + 126*D1*Dd*f*gd2*r - 1008*D1*Dd*f*gd2*s**2 + 1008*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r*s + 126*D1*Dd*fd*g2*r - 1008*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s + 420*D1*Ddd*f**3*r*s - 105*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s**2 - 420*D1*Ddd*f**3*s + 105*D1*Ddd*f**3 - 360*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 360*D1*Ddd*f**2*s**2 + 360*D1*Ddd*f**2*s - 90*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r*s + 126*D1*Ddd*f*g2*r - 504*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 - 21*D1*bd1*(K - 1)*(D1*(f*(2*s - 1)*(r + s - 1) + 3*fd*(-4*r*s + r + s*(3 - 4*s))) - 3*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 1260*Dd**2*f**3*r*s - 315*Dd**2*f**3*r + 1260*Dd**2*f**3*s**2 - 1260*Dd**2*f**3*s + 210*Dd**2*f**3 - 1080*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 1080*Dd**2*f**2*s**2 + 1080*Dd**2*f**2*s - 180*Dd**2*f**2 - 1512*Dd**2*f*g2*r*s + 378*Dd**2*f*g2*r - 1512*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(315*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**3*k1**3*k2**2*st**4*(1782*C*D1**2*f**2*fd*r*s - 594*C*D1**2*f**2*fd*r + 1782*C*D1**2*f**2*fd*s**2 - 1782*C*D1**2*f**2*fd*s + 594*C*D1**2*f**2*fd - 990*C*D1**2*f**2*fdd*r*s + 330*C*D1**2*f**2*fdd*r - 990*C*D1**2*f**2*fdd*s**2 + 990*C*D1**2*f**2*fdd*s - 330*C*D1**2*f**2*fdd - 1980*C*D1**2*f*fd**2*r*s + 660*C*D1**2*f*fd**2*r - 1980*C*D1**2*f*fd**2*s**2 + 1980*C*D1**2*f*fd**2*s - 330*C*D1**2*f*fd**2 + 2376*C*D1*Dd*f**3*r*s - 594*C*D1*Dd*f**3*r + 2376*C*D1*Dd*f**3*s**2 - 2376*C*D1*Dd*f**3*s + 594*C*D1*Dd*f**3 - 7920*C*D1*Dd*f**2*fd*r*s + 2310*C*D1*Dd*f**2*fd*r - 7920*C*D1*Dd*f**2*fd*s**2 + 7920*C*D1*Dd*f**2*fd*s - 1650*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*f**3*r*s + 330*C*D1*Ddd*f**3*r - 1320*C*D1*Ddd*f**3*s**2 + 1320*C*D1*Ddd*f**3*s - 330*C*D1*Ddd*f**3 - 3960*C*Dd**2*f**3*r*s + 990*C*Dd**2*f**3*r - 3960*C*Dd**2*f**3*s**2 + 3960*C*Dd**2*f**3*s - 660*C*Dd**2*f**3 - 495*D1**2*K*bdd1*f**2*r*s - 495*D1**2*K*bdd1*f**2*s**2 + 495*D1**2*K*bdd1*f**2*s + 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 - 495*D1**2*bdd1*f**2*s + 4940*D1**2*f**3*fd*r*s - 1235*D1**2*f**3*fd*r + 4940*D1**2*f**3*fd*s**2 - 4940*D1**2*f**3*fd*s + 1235*D1**2*f**3*fd - 2800*D1**2*f**3*fdd*r*s + 700*D1**2*f**3*fdd*r - 2800*D1**2*f**3*fdd*s**2 + 2800*D1**2*f**3*fdd*s - 700*D1**2*f**3*fdd - 8400*D1**2*f**2*fd**2*r*s + 2100*D1**2*f**2*fd**2*r - 8400*D1**2*f**2*fd**2*s**2 + 8400*D1**2*f**2*fd**2*s - 1400*D1**2*f**2*fd**2 - 1782*D1**2*f**2*fd*r*s + 594*D1**2*f**2*fd*r - 1782*D1**2*f**2*fd*s**2 + 1782*D1**2*f**2*fd*s - 594*D1**2*f**2*fd + 990*D1**2*f**2*fdd*r*s - 330*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 990*D1**2*f**2*fdd*s + 330*D1**2*f**2*fdd - 1518*D1**2*f**2*gd2*r*s - 1518*D1**2*f**2*gd2*s**2 + 1518*D1**2*f**2*gd2*s + 990*D1**2*f**2*gdd2*r*s + 990*D1**2*f**2*gdd2*s**2 - 990*D1**2*f**2*gdd2*s + 1980*D1**2*f*fd**2*r*s - 660*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 1980*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 - 3036*D1**2*f*fd*g2*r*s + 1518*D1**2*f*fd*g2*r - 3036*D1**2*f*fd*g2*s**2 + 3036*D1**2*f*fd*g2*s - 1518*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r*s - 990*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r*s - 990*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r*s - 990*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 4940*D1*Dd*f**4*r*s - 1235*D1*Dd*f**4*r + 4940*D1*Dd*f**4*s**2 - 4940*D1*Dd*f**4*s + 1235*D1*Dd*f**4 - 22400*D1*Dd*f**3*fd*r*s + 5600*D1*Dd*f**3*fd*r - 22400*D1*Dd*f**3*fd*s**2 + 22400*D1*Dd*f**3*fd*s - 4200*D1*Dd*f**3*fd - 2376*D1*Dd*f**3*r*s + 594*D1*Dd*f**3*r - 2376*D1*Dd*f**3*s**2 + 2376*D1*Dd*f**3*s - 594*D1*Dd*f**3 + 7920*D1*Dd*f**2*fd*r*s - 2310*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 7920*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 6072*D1*Dd*f**2*g2*r*s + 1518*D1*Dd*f**2*g2*r - 6072*D1*Dd*f**2*g2*s**2 + 6072*D1*Dd*f**2*g2*s - 1518*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r*s - 990*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 7920*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r*s - 5940*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 - 2800*D1*Ddd*f**4*r*s + 700*D1*Ddd*f**4*r - 2800*D1*Ddd*f**4*s**2 + 2800*D1*Ddd*f**4*s - 700*D1*Ddd*f**4 + 1320*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 1320*D1*Ddd*f**3*s + 330*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*g2*r*s - 990*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(23*f*s*(r + s - 1) - 15*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 8400*Dd**2*f**4*r*s + 2100*Dd**2*f**4*r - 8400*Dd**2*f**4*s**2 + 8400*Dd**2*f**4*s - 1400*Dd**2*f**4 + 3960*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 3960*Dd**2*f**3*s + 660*Dd**2*f**3 + 11880*Dd**2*f**2*g2*r*s - 2970*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(23*fd - 15*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 15*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 30*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 15*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(1155*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**3*k1**3*k2**2*st**2*(-189*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 2*D1**2*bdd1*f*(r + s - 1)*(50*f**2*(s + 2) - 81*f*(C*(s - 1) + s*(2*K - 2) + 1) + 189*g2*(s - 1)) + 6*D1**2*(-25*f**3*fd*(r*(4*s - 1) + (1 - 2*s)**2) + 3*f**2*(fd*(22*C - 15)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(20*C - 15)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-30*gd2 + 36*gdd2)*(r + s - 1)) - 3*f*(fd**2*(20*C - 15)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*fd*(5*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 6*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) - 36*fdd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 108*fd**2*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*D1*bd1*(D1*(f**3*(46*s + 173)*(r + s - 1) - f**2*(141*C*(s - 1)*(r + s - 1) + 50*fd*(r*(6*s + 3) + 6*s**2 - 2*s - 1) + (s*(45*K - 59) + 47)*(3*r + 3*s - 3)) + 3*f*(27*fd*(C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 8*r*s + 3*r - 8*s**2 + 9*s - 2) + (91*g2*(s - 1) + 63*gd2*(1 - 2*s))*(r + s - 1)) - 189*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(50*f**2*(r*(8*s + 7) + 8*s**2 - 5) - 81*f*(C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 16*r*s + 6*r - 16*s**2 + 20*s - 5) + 189*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 6*D1*f*(Dd*(-25*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(66*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2) - 3*f*(fd*(20*C - 15)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 30*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 36*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 216*fd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(f*(20*C - 15) - 36*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*Dd**2*f**2*(f*(20*C - 15) - 36*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 21*b1**2*(K - 1)*(D1**2*s*(13*fd - 9*fdd)*(r + s) + D1*Dd*(13*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(-8*r*s + r + s*(4 - 8*s))) - 9*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-189*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 2*D1**2*(f**2*(fd*(-3*r*(46*s - 73) - 138*s**2 + 311*s - 219) + 50*fdd*(3*r*(s - 1) + 3*s**2 - 5*s + 3)) + f*(50*fd**2*(6*r*(s - 1) + 6*s**2 - 10*s + 3) + 3*fd*(94*C*s**2 - 47*C*s + 45*K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*r*(47*C*s - 59*s + 6) - 118*s**2 + 71*s - 12) - 81*fdd*(2*C*r*s + 2*C*s**2 - C*s + K*(4*r*s - 2*r + 4*s**2 - 4*s + 2) - 4*r*s + r - 4*s**2 + 3*s - 1) - 3*s*(91*gd2 - 63*gdd2)*(r + s - 1)) - 81*fd**2*(r*(K*(4*s - 2) + s*(2*C - 4) + 1) + s*(C*(2*s - 1) + 4*K*(s - 1) - 4*s + 3)) + 21*fd*s*(-13*g2*(r + s) + 9*gd2*(2*r + 2*s - 1)) + 189*fdd*g2*s*(r + s)) + 21*D1*bd1*(K - 1)*(D1*(13*f*(2*s - 1)*(r + s - 1) + 9*fd*(-4*r*s + r + s*(3 - 4*s))) - 9*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 2*D1*(Dd*(-46*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(141*C*(r*(4*s - 1) + (1 - 2*s)**2) + 50*fd*(3*r*(8*s - 5) + 24*s**2 - 32*s + 11) + (135*K - 177)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*f*(27*fd*(C*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 4*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - (4*s - 1)*(8*r + 8*s - 5)) + 91*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 63*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 189*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(50*f**2 - 81*f*(C + 2*K - 2) + 189*g2)) + 2*Dd**2*f*(50*f**2 - 81*f*(C + 2*K - 2) + 189*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**3*k1**3*k2**2*(540*C*D1**2*bdd1*f**2*r*s - 540*C*D1**2*bdd1*f**2*r + 540*C*D1**2*bdd1*f**2*s**2 - 1080*C*D1**2*bdd1*f**2*s + 540*C*D1**2*bdd1*f**2 + 390*C*D1**2*f**2*fd*r*s - 130*C*D1**2*f**2*fd*r + 390*C*D1**2*f**2*fd*s**2 - 390*C*D1**2*f**2*fd*s + 130*C*D1**2*f**2*fd + 210*C*D1**2*f**2*fdd*r*s - 70*C*D1**2*f**2*fdd*r + 210*C*D1**2*f**2*fdd*s**2 - 210*C*D1**2*f**2*fdd*s + 70*C*D1**2*f**2*fdd + 420*C*D1**2*f*fd**2*r*s - 140*C*D1**2*f*fd**2*r + 420*C*D1**2*f*fd**2*s**2 - 420*C*D1**2*f*fd**2*s + 70*C*D1**2*f*fd**2 + 520*C*D1*Dd*f**3*r*s - 130*C*D1*Dd*f**3*r + 520*C*D1*Dd*f**3*s**2 - 520*C*D1*Dd*f**3*s + 130*C*D1*Dd*f**3 + 1680*C*D1*Dd*f**2*fd*r*s - 490*C*D1*Dd*f**2*fd*r + 1680*C*D1*Dd*f**2*fd*s**2 - 1680*C*D1*Dd*f**2*fd*s + 350*C*D1*Dd*f**2*fd + 280*C*D1*Ddd*f**3*r*s - 70*C*D1*Ddd*f**3*r + 280*C*D1*Ddd*f**3*s**2 - 280*C*D1*Ddd*f**3*s + 70*C*D1*Ddd*f**3 + 840*C*Dd**2*f**3*r*s - 210*C*Dd**2*f**3*r + 840*C*Dd**2*f**3*s**2 - 840*C*Dd**2*f**3*s + 140*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*s**2 - 45*D1**2*K*bdd1*f**2*s - 27*D1**2*bd1**2*f*(2*s - 1)*(-14*K + 10*f + 7)*(r + s - 1) - 405*D1**2*bdd1*f**2*r*s + 405*D1**2*bdd1*f**2*r - 405*D1**2*bdd1*f**2*s**2 + 810*D1**2*bdd1*f**2*s - 405*D1**2*bdd1*f**2 - 756*D1**2*bdd1*f*g2*r*s + 756*D1**2*bdd1*f*g2*r - 756*D1**2*bdd1*f*g2*s**2 + 1512*D1**2*bdd1*f*g2*s - 756*D1**2*bdd1*f*g2 - 330*D1**2*f**2*fd*r*s + 110*D1**2*f**2*fd*r - 330*D1**2*f**2*fd*s**2 + 330*D1**2*f**2*fd*s - 110*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r*s + 35*D1**2*f**2*fdd*r - 105*D1**2*f**2*fdd*s**2 + 105*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 198*D1**2*f**2*gd2*r*s - 198*D1**2*f**2*gd2*s**2 + 198*D1**2*f**2*gd2*s - 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*s**2 + 90*D1**2*f**2*gdd2*s - 210*D1**2*f*fd**2*r*s + 70*D1**2*f*fd**2*r - 210*D1**2*f*fd**2*s**2 + 210*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 - 396*D1**2*f*fd*g2*r*s + 198*D1**2*f*fd*g2*r - 396*D1**2*f*fd*g2*s**2 + 396*D1**2*f*fd*g2*s - 198*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r*s + 90*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 90*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r*s + 90*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r*s + 90*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s - 440*D1*Dd*f**3*r*s + 110*D1*Dd*f**3*r - 440*D1*Dd*f**3*s**2 + 440*D1*Dd*f**3*s - 110*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r*s + 245*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd*s**2 + 840*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd - 792*D1*Dd*f**2*g2*r*s + 198*D1*Dd*f**2*g2*r - 792*D1*Dd*f**2*g2*s**2 + 792*D1*Dd*f**2*g2*s - 198*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r*s + 90*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 720*D1*Dd*f**2*gd2*s - 90*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r*s + 540*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 - 140*D1*Ddd*f**3*r*s + 35*D1*Ddd*f**3*r - 140*D1*Ddd*f**3*s**2 + 140*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r*s + 90*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 9*D1*bd1*(D1*(15*f**3*(r + s - 1) + f**2*(r + s - 1)*(36*C*(s - 1) - s*(11*K + 13) + 20) + f*(-5*fd*(12*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 9*r*(4*s - 2) - 36*s**2 + 45*s - 9) + (28*r + 28*s - 28)*(-g2*s + g2 + 6*gd2*s - 3*gd2)) + 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-5*f*(12*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 72*r*s + 45*r - 72*s**2 + 108*s - 36) + 84*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 420*Dd**2*f**3*r*s + 105*Dd**2*f**3*r - 420*Dd**2*f**3*s**2 + 420*Dd**2*f**3*s - 70*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r*s + 270*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 + 3*b1**2*(-D1**2*s*(-9*f*(13*fd - 10*fdd)*(2*r + 2*s - 1) + 90*fd**2*(2*r + 2*s - 1) + 14*fd*(3*K + 1)*(r + s) - 63*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(117*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(45*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (21*K + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + 63*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 10*f + 7)) - 9*Dd**2*f*(-14*K + 10*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 3*b1*(-9*D1**2*bdd1*f*(2*s - 1)*(-14*K + 10*f + 7)*(r + s - 1) + 3*D1**2*(15*f**2*fd*(r + s - 1) + f*(fd*(-72*C*s**2 + 36*C*s + 11*K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + r*(-72*C*s + 26*s + 7) + 26*s**2 - 6*s - 7) + 5*fdd*(K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + s*(12*C - 9)*(2*r + 2*s - 1)) + s*(28*gd2 - 84*gdd2)*(r + s - 1)) + 5*fd**2*(K*r*(2*s - 1) + 2*K*s*(s - 1) + s*(12*C - 9)*(2*r + 2*s - 1)) + 28*fd*s*(g2*(r + s) + gd2*(-6*r - 6*s + 3)) - 84*fdd*g2*s*(r + s)) - 3*D1*Dd*(f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(36*C - 11*K - 13) + f*(-5*fd*(12*C*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 2*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 144*r*s + 18*r - 144*s**2 + 108*s - 9) - 28*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 84*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 84*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 3*D1*Ddd*f*(5*f*(12*C + K - 9) - 84*g2)*(r*(4*s - 1) + (1 - 2*s)**2) + D1*bd1*(D1*(117*f**2*(2*s - 1)*(r + s - 1) - 2*f*(45*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + (21*K + 7)*(2*s - 1)*(r + s - 1)) + 63*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 9*Dd*f*(-14*K + 10*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 3*Dd**2*f*(5*f*(12*C + K - 9) - 84*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**3*k1**3*st**2*(63*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) - 2*D1*bd1*(D1*(f**3*s*(169*r + 169*s - 96) + f**2*(-25*fd*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3) + 33*s*(r*(C + 2) + s*(C + 2) - 3)) - 3*f*(9*fd*(r*(C + 2)*(4*s - 1) + s**2*(4*C + 8) - s*(3*C + 9) + 3) + 7*s*(g2*(r + s) + gd2*(-6*r - 6*s + 3))) + 63*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(25*f**2*(5*r*(8*s - 1) + 40*s**2 - 32*s + 3) + 27*f*(r*(C + 2)*(8*s - 1) + s**2*(8*C + 16) - s*(4*C + 20) + 3) - 63*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 21*b1**2*(K - 1)*(D1**2*(fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(-2*f**2*(fd*(169*r*(3*s - 1) + 507*s**2 - 580*s + 169) - 25*fdd*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5)) + f*(50*fd**2*(10*r*(3*s - 1) + 30*s**2 - 34*s + 7) - 66*fd*(C*(2*s - 1)*(r + s - 1) + r*(4*s - 2) + 4*s**2 - 3*s + 2) + 54*fdd*(C*(2*s - 1)*(r + s - 1) + r*(4*s - 2) + 4*s**2 - 3*s + 2) + 21*s*(3*bdd1*(K - 1)*(2*r + 2*s - 1) + (2*gd2 - 6*gdd2)*(r + s - 1))) + 54*fd**2*(C*(2*s - 1)*(r + s - 1) + r*(4*s - 2) + 4*s**2 - 3*s - 1) + 42*fd*(g2*(s - 1) + gd2*(3 - 6*s))*(r + s - 1) - 126*fdd*g2*(s - 1)*(r + s - 1)) - 2*D1*Dd*(169*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(33*C*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 3*f*(9*fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 4*r*(8*s - 3) + 32*s**2 - 28*s + 7) + 7*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 21*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 63*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 2*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(125*f**2 + f*(27*C + 54) - 63*g2) + 21*D1*bd1*(K - 1)*(D1*(f*s*(-2*r - 2*s + 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 3*Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 2*Dd**2*f*(125*f**2 + f*(27*C + 54) - 63*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 2*f*(D1**2*(25*bdd1*f**2*s*(5*r + 5*s - 3) - 63*bdd1*g2*s*(r + s) - 9*f*(-3*bdd1*s*(r*(C + 2) + s*(C + 2) - 3) + 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + 45*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 9*D1*f*(Dd*(7*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 45*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**3*k1**3*(150*C*D1**2*f**2*fd*r*s - 50*C*D1**2*f**2*fd*r + 150*C*D1**2*f**2*fd*s**2 - 150*C*D1**2*f**2*fd*s + 50*C*D1**2*f**2*fd - 210*C*D1**2*f**2*fdd*r*s + 70*C*D1**2*f**2*fdd*r - 210*C*D1**2*f**2*fdd*s**2 + 210*C*D1**2*f**2*fdd*s - 70*C*D1**2*f**2*fdd - 420*C*D1**2*f*fd**2*r*s + 140*C*D1**2*f*fd**2*r - 420*C*D1**2*f*fd**2*s**2 + 420*C*D1**2*f*fd**2*s - 70*C*D1**2*f*fd**2 + 200*C*D1*Dd*f**3*r*s - 50*C*D1*Dd*f**3*r + 200*C*D1*Dd*f**3*s**2 - 200*C*D1*Dd*f**3*s + 50*C*D1*Dd*f**3 - 1680*C*D1*Dd*f**2*fd*r*s + 490*C*D1*Dd*f**2*fd*r - 1680*C*D1*Dd*f**2*fd*s**2 + 1680*C*D1*Dd*f**2*fd*s - 350*C*D1*Dd*f**2*fd - 280*C*D1*Ddd*f**3*r*s + 70*C*D1*Ddd*f**3*r - 280*C*D1*Ddd*f**3*s**2 + 280*C*D1*Ddd*f**3*s - 70*C*D1*Ddd*f**3 - 840*C*Dd**2*f**3*r*s + 210*C*Dd**2*f**3*r - 840*C*Dd**2*f**3*s**2 + 840*C*Dd**2*f**3*s - 140*C*Dd**2*f**3 - 45*D1**2*K*bdd1*f**2*r*s - 45*D1**2*K*bdd1*f**2*s**2 + 45*D1**2*K*bdd1*f**2*s + 54*D1**2*b2*f*fd*r*s - 27*D1**2*b2*f*fd*r + 54*D1**2*b2*f*fd*s**2 - 54*D1**2*b2*f*fd*s + 27*D1**2*b2*f*fd - 90*D1**2*b2*f*fdd*r*s + 45*D1**2*b2*f*fdd*r - 90*D1**2*b2*f*fdd*s**2 + 90*D1**2*b2*f*fdd*s - 45*D1**2*b2*f*fdd - 90*D1**2*b2*fd**2*r*s + 45*D1**2*b2*fd**2*r - 90*D1**2*b2*fd**2*s**2 + 90*D1**2*b2*fd**2*s + 3*D1**2*bd1**2*(15*f**2*(r*(8*s - 5) + 8*s**2 - 12*s + 3) + 21*f*(r*(2*C + 1)*(2*s - 1) + (s - 1)*(4*C*s + 2*s - 3)) - 70*g2*(r*(2*s - 1) + s*(2*s - 2))) + 27*D1**2*bd2*f**2*r*s + 27*D1**2*bd2*f**2*s**2 - 27*D1**2*bd2*f**2*s - 180*D1**2*bd2*f*fd*r*s + 45*D1**2*bd2*f*fd*r - 180*D1**2*bd2*f*fd*s**2 + 180*D1**2*bd2*f*fd*s - 45*D1**2*bd2*f*fd + 135*D1**2*bdd1*f**2*r*s - 135*D1**2*bdd1*f**2*r + 135*D1**2*bdd1*f**2*s**2 - 270*D1**2*bdd1*f**2*s + 135*D1**2*bdd1*f**2 - 45*D1**2*bdd2*f**2*r*s - 45*D1**2*bdd2*f**2*s**2 + 45*D1**2*bdd2*f**2*s + 60*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 60*D1**2*f**2*fd*s**2 - 60*D1**2*f**2*fd*s + 20*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r*s - 35*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 105*D1**2*f**2*fdd*s + 35*D1**2*f**2*fdd - 54*D1**2*f**2*gd2*r*s - 54*D1**2*f**2*gd2*s**2 + 54*D1**2*f**2*gd2*s + 90*D1**2*f**2*gdd2*r*s + 90*D1**2*f**2*gdd2*s**2 - 90*D1**2*f**2*gdd2*s + 210*D1**2*f*fd**2*r*s - 70*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 210*D1**2*f*fd**2*s + 35*D1**2*f*fd**2 - 108*D1**2*f*fd*g2*r*s + 54*D1**2*f*fd*g2*r - 108*D1**2*f*fd*g2*s**2 + 108*D1**2*f*fd*g2*s - 54*D1**2*f*fd*g2 + 360*D1**2*f*fd*gd2*r*s - 90*D1**2*f*fd*gd2*r + 360*D1**2*f*fd*gd2*s**2 - 360*D1**2*f*fd*gd2*s + 90*D1**2*f*fd*gd2 + 180*D1**2*f*fdd*g2*r*s - 90*D1**2*f*fdd*g2*r + 180*D1**2*f*fdd*g2*s**2 - 180*D1**2*f*fdd*g2*s + 90*D1**2*f*fdd*g2 + 180*D1**2*fd**2*g2*r*s - 90*D1**2*fd**2*g2*r + 180*D1**2*fd**2*g2*s**2 - 180*D1**2*fd**2*g2*s + 108*D1*Dd*b2*f**2*r*s - 27*D1*Dd*b2*f**2*r + 108*D1*Dd*b2*f**2*s**2 - 108*D1*Dd*b2*f**2*s + 27*D1*Dd*b2*f**2 - 720*D1*Dd*b2*f*fd*r*s + 270*D1*Dd*b2*f*fd*r - 720*D1*Dd*b2*f*fd*s**2 + 720*D1*Dd*b2*f*fd*s - 180*D1*Dd*b2*f*fd - 360*D1*Dd*bd2*f**2*r*s + 45*D1*Dd*bd2*f**2*r - 360*D1*Dd*bd2*f**2*s**2 + 360*D1*Dd*bd2*f**2*s - 45*D1*Dd*bd2*f**2 + 80*D1*Dd*f**3*r*s - 20*D1*Dd*f**3*r + 80*D1*Dd*f**3*s**2 - 80*D1*Dd*f**3*s + 20*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r*s - 245*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 840*D1*Dd*f**2*fd*s + 175*D1*Dd*f**2*fd - 216*D1*Dd*f**2*g2*r*s + 54*D1*Dd*f**2*g2*r - 216*D1*Dd*f**2*g2*s**2 + 216*D1*Dd*f**2*g2*s - 54*D1*Dd*f**2*g2 + 720*D1*Dd*f**2*gd2*r*s - 90*D1*Dd*f**2*gd2*r + 720*D1*Dd*f**2*gd2*s**2 - 720*D1*Dd*f**2*gd2*s + 90*D1*Dd*f**2*gd2 + 1440*D1*Dd*f*fd*g2*r*s - 540*D1*Dd*f*fd*g2*r + 1440*D1*Dd*f*fd*g2*s**2 - 1440*D1*Dd*f*fd*g2*s + 360*D1*Dd*f*fd*g2 - 180*D1*Ddd*b2*f**2*r*s + 45*D1*Ddd*b2*f**2*r - 180*D1*Ddd*b2*f**2*s**2 + 180*D1*Ddd*b2*f**2*s - 45*D1*Ddd*b2*f**2 + 140*D1*Ddd*f**3*r*s - 35*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 140*D1*Ddd*f**3*s + 35*D1*Ddd*f**3 + 360*D1*Ddd*f**2*g2*r*s - 90*D1*Ddd*f**2*g2*r + 360*D1*Ddd*f**2*g2*s**2 - 360*D1*Ddd*f**2*g2*s + 90*D1*Ddd*f**2*g2 + 9*D1*bd1*f*(D1*(5*f**2*s*(2*r + 2*s - 1) + f*(s*(3*K - 9) + 16)*(r + s - 1) - 5*fd*(K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3)) - 5*Dd*f*(K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12)) - 540*Dd**2*b2*f**2*r*s + 135*Dd**2*b2*f**2*r - 540*Dd**2*b2*f**2*s**2 + 540*Dd**2*b2*f**2*s - 90*Dd**2*b2*f**2 + 420*Dd**2*f**3*r*s - 105*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 420*Dd**2*f**3*s + 70*Dd**2*f**3 + 1080*Dd**2*f**2*g2*r*s - 270*Dd**2*f**2*g2*r + 1080*Dd**2*f**2*g2*s**2 - 1080*Dd**2*f**2*g2*s + 180*Dd**2*f**2*g2 + 105*b1**3*(K - 1)*(D1*(Dd + Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 3*b1**2*(-14*C*D1**2*fd*r*s - 14*C*D1**2*fd*s**2 + 14*C*D1**2*fd*s + 42*C*D1**2*fdd*r*s + 42*C*D1**2*fdd*s**2 - 42*C*D1**2*fdd*s - 56*C*D1*Dd*f*r*s + 14*C*D1*Dd*f*r - 56*C*D1*Dd*f*s**2 + 56*C*D1*Dd*f*s - 14*C*D1*Dd*f + 336*C*D1*Dd*fd*r*s - 42*C*D1*Dd*fd*r + 336*C*D1*Dd*fd*s**2 - 336*C*D1*Dd*fd*s + 42*C*D1*Dd*fd + 168*C*D1*Ddd*f*r*s - 42*C*D1*Ddd*f*r + 168*C*D1*Ddd*f*s**2 - 168*C*D1*Ddd*f*s + 42*C*D1*Ddd*f + 504*C*Dd**2*f*r*s - 126*C*Dd**2*f*r + 504*C*Dd**2*f*s**2 - 504*C*Dd**2*f*s + 84*C*Dd**2*f + 35*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 156*D1**2*f*fd*r*s - 9*D1**2*f*fd*r - 156*D1**2*f*fd*s**2 + 99*D1**2*f*fd*s + 9*D1**2*f*fd + 120*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 120*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s - 15*D1**2*f*fdd + 120*D1**2*fd**2*r*s + 15*D1**2*fd**2*r + 120*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s - 15*D1**2*fd**2 - 42*D1**2*fd*r*s - 42*D1**2*fd*s**2 - 14*D1**2*fd*s + 21*D1**2*fdd*r*s + 21*D1**2*fdd*s**2 + 42*D1**2*fdd*s - 70*D1**2*gd2*r*s - 70*D1**2*gd2*s**2 + 70*D1**2*gd2*s - 70*D1**2*gdd2*r*s - 70*D1**2*gdd2*s**2 + 70*D1**2*gdd2*s - 312*D1*Dd*f**2*r*s + 78*D1*Dd*f**2*r - 312*D1*Dd*f**2*s**2 + 312*D1*Dd*f**2*s - 78*D1*Dd*f**2 + 960*D1*Dd*f*fd*r*s - 60*D1*Dd*f*fd*r + 960*D1*Dd*f*fd*s**2 - 720*D1*Dd*f*fd*s + 30*D1*Dd*f*fd - 168*D1*Dd*f*r*s + 42*D1*Dd*f*r - 168*D1*Dd*f*s**2 + 168*D1*Dd*f*s - 42*D1*Dd*f + 168*D1*Dd*fd*r*s - 21*D1*Dd*fd*r + 168*D1*Dd*fd*s**2 + 84*D1*Dd*fd*s - 42*D1*Dd*fd - 280*D1*Dd*g2*r*s + 70*D1*Dd*g2*r - 280*D1*Dd*g2*s**2 + 280*D1*Dd*g2*s - 70*D1*Dd*g2 - 560*D1*Dd*gd2*r*s + 70*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 560*D1*Dd*gd2*s - 70*D1*Dd*gd2 + 240*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 240*D1*Ddd*f**2*s**2 - 240*D1*Ddd*f**2*s + 60*D1*Ddd*f**2 + 84*D1*Ddd*f*r*s - 21*D1*Ddd*f*r + 84*D1*Ddd*f*s**2 - 84*D1*Ddd*f*s + 21*D1*Ddd*f - 280*D1*Ddd*g2*r*s + 70*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 280*D1*Ddd*g2*s - 70*D1*Ddd*g2 + 35*D1*bd1*(K - 1)*(D1*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*(24*r*s - 7*r + 24*s**2 - 24*s + 5)) + 720*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 720*Dd**2*f**2*s**2 - 720*Dd**2*f**2*s + 120*Dd**2*f**2 + 252*Dd**2*f*r*s - 63*Dd**2*f*r + 252*Dd**2*f*s**2 - 252*Dd**2*f*s + 42*Dd**2*f - 840*Dd**2*g2*r*s + 210*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 840*Dd**2*g2*s - 140*Dd**2*g2) + 3*b1*(35*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(15*f**2*(r*(8*s - 5) + 8*s**2 - 12*s + 5) + 21*f*(C*(4*r*s - 2*r + 4*s**2 - 4*s + 2) + 2*r*s - r + 2*s**2 - 5*s + 1) - 70*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 3*D1**2*(5*f**2*fd*(r*(6*s - 2) + 6*s**2 - 7*s + 2) + f*(fd*(K*(6*r*s - 3*r + 6*s**2 - 6*s + 3) - 18*r*s - 7*r - 18*s**2 + 2*s + 7) - 5*fdd*(K*(2*r*s - r + 2*s**2 - 2*s + 1) - 3*s*(2*r + 2*s - 1))) - 5*fd**2*(K*r*(2*s - 1) + 2*K*s*(s - 1) - 3*s*(2*r + 2*s - 1))) - D1*bd1*(D1*(3*f**2*(r*(52*s - 29) + 52*s**2 - 71*s + 29) + 2*f*(7*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 15*fd*(4*s - 1)*(4*r + 4*s - 3) + 42*r*s - 21*r + 42*s**2 - 70*s + 21) - 21*fd*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + r*(4*s - 1) + 4*s**2 - s - 2) + 70*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 70*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*(30*f**2*(2*r*(16*s - 7) + 32*s**2 - 40*s + 11) + 21*f*(4*C*r*(8*s - 3) + 8*C*(1 - 2*s)**2 + 2*r*(8*s - 3) + 16*s**2 - 28*s + 7) - 140*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 3*D1*f*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 3*f*(K - 3)*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(2*K*r*(8*s - 3) + 4*K*(1 - 2*s)**2 + r*(6 - 48*s) - 48*s**2 + 36*s - 3)) - 5*Ddd*f*(K - 3)*(r*(4*s - 1) + (1 - 2*s)**2)) - 15*Dd**2*f**2*(K - 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(315*d**2*k3**3) - D1**2*Pkd2*Pkd3*ct**3*k1*k2**4*st**4*(72*C*D1**2*f**2*fd*r*s - 24*C*D1**2*f**2*fd*r + 72*C*D1**2*f**2*fd*s**2 - 72*C*D1**2*f**2*fd*s + 24*C*D1**2*f**2*fd - 36*C*D1**2*f**2*fdd*r*s + 12*C*D1**2*f**2*fdd*r - 36*C*D1**2*f**2*fdd*s**2 + 36*C*D1**2*f**2*fdd*s - 12*C*D1**2*f**2*fdd - 72*C*D1**2*f*fd**2*r*s + 24*C*D1**2*f*fd**2*r - 72*C*D1**2*f*fd**2*s**2 + 72*C*D1**2*f*fd**2*s - 12*C*D1**2*f*fd**2 + 96*C*D1*Dd*f**3*r*s - 24*C*D1*Dd*f**3*r + 96*C*D1*Dd*f**3*s**2 - 96*C*D1*Dd*f**3*s + 24*C*D1*Dd*f**3 - 288*C*D1*Dd*f**2*fd*r*s + 84*C*D1*Dd*f**2*fd*r - 288*C*D1*Dd*f**2*fd*s**2 + 288*C*D1*Dd*f**2*fd*s - 60*C*D1*Dd*f**2*fd - 48*C*D1*Ddd*f**3*r*s + 12*C*D1*Ddd*f**3*r - 48*C*D1*Ddd*f**3*s**2 + 48*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 144*C*Dd**2*f**3*r*s + 36*C*Dd**2*f**3*r - 144*C*Dd**2*f**3*s**2 + 144*C*Dd**2*f**3*s - 24*C*Dd**2*f**3 - 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s + 7*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 - 7*D1**2*bdd1*f**3*s + 9*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 - 9*D1**2*bdd1*f**2*s - 54*D1**2*f**2*fd*r*s + 18*D1**2*f**2*fd*r - 54*D1**2*f**2*fd*s**2 + 54*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 27*D1**2*f**2*fdd*r*s - 9*D1**2*f**2*fdd*r + 27*D1**2*f**2*fdd*s**2 - 27*D1**2*f**2*fdd*s + 9*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 54*D1**2*f*fd**2*r*s - 18*D1**2*f*fd**2*r + 54*D1**2*f*fd**2*s**2 - 54*D1**2*f*fd**2*s + 9*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 72*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 72*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 216*D1*Dd*f**2*fd*r*s - 63*D1*Dd*f**2*fd*r + 216*D1*Dd*f**2*fd*s**2 - 216*D1*Dd*f**2*fd*s + 45*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r*s - 36*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 288*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r*s - 216*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 576*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 36*D1*Ddd*f**3*r*s - 9*D1*Ddd*f**3*r + 36*D1*Ddd*f**3*s**2 - 36*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-18*K + 7*f + 9)*(r + s - 1) - 9*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-18*K + 7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 108*Dd**2*f**3*r*s - 27*Dd**2*f**3*r + 108*Dd**2*f**3*s**2 - 108*Dd**2*f**3*s + 18*Dd**2*f**3 + 432*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1)) - 9*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (36*K - 18)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 7*f + 9)) + Dd**2*f**2*(-18*K + 7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct**3*k1*k2**4*st**2*(36*C*D1**2*bdd1*f**2*r*s - 36*C*D1**2*bdd1*f**2*r + 36*C*D1**2*bdd1*f**2*s**2 - 72*C*D1**2*bdd1*f**2*s + 36*C*D1**2*bdd1*f**2 - 138*C*D1**2*f**2*fd*r*s + 46*C*D1**2*f**2*fd*r - 138*C*D1**2*f**2*fd*s**2 + 138*C*D1**2*f**2*fd*s - 46*C*D1**2*f**2*fd + 150*C*D1**2*f**2*fdd*r*s - 50*C*D1**2*f**2*fdd*r + 150*C*D1**2*f**2*fdd*s**2 - 150*C*D1**2*f**2*fdd*s + 50*C*D1**2*f**2*fdd + 300*C*D1**2*f*fd**2*r*s - 100*C*D1**2*f*fd**2*r + 300*C*D1**2*f*fd**2*s**2 - 300*C*D1**2*f*fd**2*s + 50*C*D1**2*f*fd**2 - 184*C*D1*Dd*f**3*r*s + 46*C*D1*Dd*f**3*r - 184*C*D1*Dd*f**3*s**2 + 184*C*D1*Dd*f**3*s - 46*C*D1*Dd*f**3 + 1200*C*D1*Dd*f**2*fd*r*s - 350*C*D1*Dd*f**2*fd*r + 1200*C*D1*Dd*f**2*fd*s**2 - 1200*C*D1*Dd*f**2*fd*s + 250*C*D1*Dd*f**2*fd + 200*C*D1*Ddd*f**3*r*s - 50*C*D1*Ddd*f**3*r + 200*C*D1*Ddd*f**3*s**2 - 200*C*D1*Ddd*f**3*s + 50*C*D1*Ddd*f**3 + 600*C*Dd**2*f**3*r*s - 150*C*Dd**2*f**3*r + 600*C*Dd**2*f**3*s**2 - 600*C*Dd**2*f**3*s + 100*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*s**2 - 45*D1**2*K*bdd1*f**2*s - 3*D1**2*bd1**2*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 27*D1**2*bdd1*f**2*r*s + 27*D1**2*bdd1*f**2*r - 27*D1**2*bdd1*f**2*s**2 + 54*D1**2*bdd1*f**2*s - 27*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 + 42*D1**2*f**2*fd*r*s - 14*D1**2*f**2*fd*r + 42*D1**2*f**2*fd*s**2 - 42*D1**2*f**2*fd*s + 14*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r*s + 25*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 75*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd + 54*D1**2*f**2*gd2*r*s + 54*D1**2*f**2*gd2*s**2 - 54*D1**2*f**2*gd2*s - 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*s**2 + 90*D1**2*f**2*gdd2*s - 150*D1**2*f*fd**2*r*s + 50*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 150*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 108*D1**2*f*fd*g2*r*s - 54*D1**2*f*fd*g2*r + 108*D1**2*f*fd*g2*s**2 - 108*D1**2*f*fd*g2*s + 54*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r*s + 90*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 90*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r*s + 90*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r*s + 90*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s + 56*D1*Dd*f**3*r*s - 14*D1*Dd*f**3*r + 56*D1*Dd*f**3*s**2 - 56*D1*Dd*f**3*s + 14*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r*s + 175*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 600*D1*Dd*f**2*fd*s - 125*D1*Dd*f**2*fd + 216*D1*Dd*f**2*g2*r*s - 54*D1*Dd*f**2*g2*r + 216*D1*Dd*f**2*g2*s**2 - 216*D1*Dd*f**2*g2*s + 54*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r*s + 90*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 720*D1*Dd*f**2*gd2*s - 90*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r*s + 540*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 - 100*D1*Ddd*f**3*r*s + 25*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 100*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r*s + 90*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + f**2*(r + s - 1)*(24*C*(s - 1) + s*(9*K - 11) + 18) + f*(-3*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 5*K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + (-28*r - 28*s + 28)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 28*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-3*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 5*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) + 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 300*Dd**2*f**3*r*s + 75*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 300*Dd**2*f**3*s - 50*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r*s + 270*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 + 3*b1**2*(D1**2*s*(5*f*(2*fd - fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 14*fd*(2*K - 1)*(r + s) + 7*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (14 - 28*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 5*f + 7)) - Dd**2*f*(-14*K + 5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 3*b1*(-48*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s + 24*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*s**2 - 12*C*D1**2*f*fdd*s + 24*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*s**2 - 12*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r*s - 24*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 144*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 18*D1**2*K*f*fd*r*s + 9*D1**2*K*f*fd*r - 18*D1**2*K*f*fd*s**2 + 18*D1**2*K*f*fd*s - 9*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 22*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s - 7*D1**2*f*fd - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*s**2 + 28*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 36*D1*Dd*K*f**2*r*s + 9*D1*Dd*K*f**2*r - 36*D1*Dd*K*f**2*s**2 + 36*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 + 44*D1*Dd*f**2*r*s - 11*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 44*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 108*D1*Dd*f*fd*s - 9*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 224*D1*Dd*f*gd2*s - 28*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r*s + 28*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 112*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 112*D1*Ddd*f*g2*s - 28*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(2*s - 1)*(r + s - 1) + f*(-5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (14 - 28*K)*(2*s - 1)*(r + s - 1)) + 7*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-14*K + 5*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 336*Dd**2*f*g2*s - 56*Dd**2*f*g2))/(105*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**3*k1*k2**4*(-3*D1*(21*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + D1*bd1*(-2*f**2*(r + s - 1)*(9*C*(s - 1) - s*(7*K + 1) + 1) + f*(fd*(30*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (14*g2*(s - 1) + 14*gd2*(3 - 6*s))*(r + s - 1)) + 42*fd*g2*(-2*r*s + r - s*(2*s - 2))) + 3*D1*bdd1*f*(s - 1)*(f*(10*C - 5) - 14*g2)*(r + s - 1) + 3*Dd*bd1*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*f*(D1*(f*(fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 14*gd2*s*(r + s - 1)) - 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b1**2*(D1**2*s*(3*f*fd*(2*r + 2*s - 1) + (r + s)*(-9*K*fdd + fd*(3*K + 5))) + D1*(Dd*(9*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 3*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(3*K + 5)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(3*D1**2*(-21*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(-14*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(18*C - 2)*(2*r + 2*s - 1) - fdd*s*(30*C - 15)*(2*r + 2*s - 1) + s*(-14*gd2 + 42*gdd2)*(r + s - 1)) + s*(-fd**2*(30*C - 15)*(2*r + 2*s - 1) + 14*fd*(-g2*(r + s) + gd2*(6*r + 6*s - 3)) + 42*fdd*g2*(r + s))) + 7*D1*bd1*(D1*(9*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 3*f**2*(2*s - 1)*(r + s - 1) + f*(3*K + 5)*(2*s - 1)*(r + s - 1)) - 9*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 3*D1*(Dd*(2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(9*C - 7*K - 1) + f*(-fd*(30*C - 15)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 14*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 42*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 42*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f*(f*(10*C - 5) - 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**3*k1*k2**2*st**4*(b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) - 18*fd*(2*r*s - r + 2*s**2 - 2*s + 1) + 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 18*r*(4*s - 1) - 18*(1 - 2*s)**2) + 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(7*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(7*bdd1*f**2*s*(r + s - 1) + 3*f*(3*bdd1*s*(r + s - 1) + fd*(r*(2 - 6*s) - 6*s**2 + 6*s - 2) + fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 3*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(7*f + 9)*(r + s - 1) + 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 3*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**3*k1*k2**2*st**2*(-36*C*D1**2*bdd1*f**2*r*s - 36*C*D1**2*bdd1*f**2*s**2 - 246*C*D1**2*f**2*fd*r*s + 82*C*D1**2*f**2*fd*r - 246*C*D1**2*f**2*fd*s**2 + 246*C*D1**2*f**2*fd*s - 82*C*D1**2*f**2*fd + 150*C*D1**2*f**2*fdd*r*s - 50*C*D1**2*f**2*fdd*r + 150*C*D1**2*f**2*fdd*s**2 - 150*C*D1**2*f**2*fdd*s + 50*C*D1**2*f**2*fdd + 300*C*D1**2*f*fd**2*r*s - 100*C*D1**2*f*fd**2*r + 300*C*D1**2*f*fd**2*s**2 - 300*C*D1**2*f*fd**2*s + 50*C*D1**2*f*fd**2 - 328*C*D1*Dd*f**3*r*s + 82*C*D1*Dd*f**3*r - 328*C*D1*Dd*f**3*s**2 + 328*C*D1*Dd*f**3*s - 82*C*D1*Dd*f**3 + 1200*C*D1*Dd*f**2*fd*r*s - 350*C*D1*Dd*f**2*fd*r + 1200*C*D1*Dd*f**2*fd*s**2 - 1200*C*D1*Dd*f**2*fd*s + 250*C*D1*Dd*f**2*fd + 200*C*D1*Ddd*f**3*r*s - 50*C*D1*Ddd*f**3*r + 200*C*D1*Ddd*f**3*s**2 - 200*C*D1*Ddd*f**3*s + 50*C*D1*Ddd*f**3 + 600*C*Dd**2*f**3*r*s - 150*C*Dd**2*f**3*r + 600*C*Dd**2*f**3*s**2 - 600*C*Dd**2*f**3*s + 100*C*Dd**2*f**3 + 45*D1**2*K*bdd1*f**2*r*s + 45*D1**2*K*bdd1*f**2*s**2 - 45*D1**2*K*bdd1*f**2*s - 138*D1**2*b2*f*fd*r*s + 69*D1**2*b2*f*fd*r - 138*D1**2*b2*f*fd*s**2 + 138*D1**2*b2*f*fd*s - 69*D1**2*b2*f*fd + 90*D1**2*b2*f*fdd*r*s - 45*D1**2*b2*f*fdd*r + 90*D1**2*b2*f*fdd*s**2 - 90*D1**2*b2*f*fdd*s + 45*D1**2*b2*f*fdd + 90*D1**2*b2*fd**2*r*s - 45*D1**2*b2*fd**2*r + 90*D1**2*b2*fd**2*s**2 - 90*D1**2*b2*fd**2*s + 3*D1**2*bd1**2*f*(5*f*(r + 2*s - 1) - 7*r*(4*K*s - 1) - 7*(2*s - 1)*(2*K*s - 1)) - 69*D1**2*bd2*f**2*r*s - 69*D1**2*bd2*f**2*s**2 + 69*D1**2*bd2*f**2*s + 180*D1**2*bd2*f*fd*r*s - 45*D1**2*bd2*f*fd*r + 180*D1**2*bd2*f*fd*s**2 - 180*D1**2*bd2*f*fd*s + 45*D1**2*bd2*f*fd + 18*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*r + 18*D1**2*bdd1*f**2*s**2 + 18*D1**2*bdd1*f**2*s - 9*D1**2*bdd1*f**2 + 84*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*s**2 + 45*D1**2*bdd2*f**2*r*s + 45*D1**2*bdd2*f**2*s**2 - 45*D1**2*bdd2*f**2*s + 96*D1**2*f**2*fd*r*s - 32*D1**2*f**2*fd*r + 96*D1**2*f**2*fd*s**2 - 96*D1**2*f**2*fd*s + 32*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r*s + 25*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 75*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd + 138*D1**2*f**2*gd2*r*s + 138*D1**2*f**2*gd2*s**2 - 138*D1**2*f**2*gd2*s - 90*D1**2*f**2*gdd2*r*s - 90*D1**2*f**2*gdd2*s**2 + 90*D1**2*f**2*gdd2*s - 150*D1**2*f*fd**2*r*s + 50*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 150*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 276*D1**2*f*fd*g2*r*s - 138*D1**2*f*fd*g2*r + 276*D1**2*f*fd*g2*s**2 - 276*D1**2*f*fd*g2*s + 138*D1**2*f*fd*g2 - 360*D1**2*f*fd*gd2*r*s + 90*D1**2*f*fd*gd2*r - 360*D1**2*f*fd*gd2*s**2 + 360*D1**2*f*fd*gd2*s - 90*D1**2*f*fd*gd2 - 180*D1**2*f*fdd*g2*r*s + 90*D1**2*f*fdd*g2*r - 180*D1**2*f*fdd*g2*s**2 + 180*D1**2*f*fdd*g2*s - 90*D1**2*f*fdd*g2 - 180*D1**2*fd**2*g2*r*s + 90*D1**2*fd**2*g2*r - 180*D1**2*fd**2*g2*s**2 + 180*D1**2*fd**2*g2*s - 276*D1*Dd*b2*f**2*r*s + 69*D1*Dd*b2*f**2*r - 276*D1*Dd*b2*f**2*s**2 + 276*D1*Dd*b2*f**2*s - 69*D1*Dd*b2*f**2 + 720*D1*Dd*b2*f*fd*r*s - 270*D1*Dd*b2*f*fd*r + 720*D1*Dd*b2*f*fd*s**2 - 720*D1*Dd*b2*f*fd*s + 180*D1*Dd*b2*f*fd + 360*D1*Dd*bd2*f**2*r*s - 45*D1*Dd*bd2*f**2*r + 360*D1*Dd*bd2*f**2*s**2 - 360*D1*Dd*bd2*f**2*s + 45*D1*Dd*bd2*f**2 + 128*D1*Dd*f**3*r*s - 32*D1*Dd*f**3*r + 128*D1*Dd*f**3*s**2 - 128*D1*Dd*f**3*s + 32*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r*s + 175*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 600*D1*Dd*f**2*fd*s - 125*D1*Dd*f**2*fd + 552*D1*Dd*f**2*g2*r*s - 138*D1*Dd*f**2*g2*r + 552*D1*Dd*f**2*g2*s**2 - 552*D1*Dd*f**2*g2*s + 138*D1*Dd*f**2*g2 - 720*D1*Dd*f**2*gd2*r*s + 90*D1*Dd*f**2*gd2*r - 720*D1*Dd*f**2*gd2*s**2 + 720*D1*Dd*f**2*gd2*s - 90*D1*Dd*f**2*gd2 - 1440*D1*Dd*f*fd*g2*r*s + 540*D1*Dd*f*fd*g2*r - 1440*D1*Dd*f*fd*g2*s**2 + 1440*D1*Dd*f*fd*g2*s - 360*D1*Dd*f*fd*g2 + 180*D1*Ddd*b2*f**2*r*s - 45*D1*Ddd*b2*f**2*r + 180*D1*Ddd*b2*f**2*s**2 - 180*D1*Ddd*b2*f**2*s + 45*D1*Ddd*b2*f**2 - 100*D1*Ddd*f**3*r*s + 25*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 100*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 - 360*D1*Ddd*f**2*g2*r*s + 90*D1*Ddd*f**2*g2*r - 360*D1*Ddd*f**2*g2*s**2 + 360*D1*Ddd*f**2*g2*s - 90*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + f**2*(r*(s*(-24*C + 23*K + 19) + 6) + s**2*(-24*C + 23*K + 19) + s*(5 - 23*K) - 6) + f*(-3*fd*(-16*C*s**2 + 12*C*s + 5*K*(r*(4*s - 1) + (1 - 2*s)**2) + r*(-16*C*s + 4*C + 8*s - 1) + 8*s**2 - 4*s - 1) + 28*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 28*fd*g2*(-2*r*s + r - s*(2*s - 2))) - Dd*f*(3*f*(-32*C*r*s + 4*C*r - 32*C*s**2 + 16*C*s + 5*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 16*r*s + 2*r + 16*s**2 - 4) + 28*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 540*Dd**2*b2*f**2*r*s - 135*Dd**2*b2*f**2*r + 540*Dd**2*b2*f**2*s**2 - 540*Dd**2*b2*f**2*s + 90*Dd**2*b2*f**2 - 300*Dd**2*f**3*r*s + 75*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 300*Dd**2*f**3*s - 50*Dd**2*f**3 - 1080*Dd**2*f**2*g2*r*s + 270*Dd**2*f**2*g2*r - 1080*Dd**2*f**2*g2*s**2 + 1080*Dd**2*f**2*g2*s - 180*Dd**2*f**2*g2 - 3*b1**2*(D1**2*(5*fd**2*(r + 2*s - 1) - 2*fd*(14*K*(s - 1)*(r + s - 1) + 5*f*(r + 2*s - 1) + 7*r + 14*s - 7) + fdd*(14*K*(s - 1)*(r + s - 1) + 5*f*(r + 2*s - 1) + 7*r + 14*s - 7)) + 2*D1*(Dd*(-14*K*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(7*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*f*(r + 2*s - 1) + 14*r + 28*s - 14)) + 7*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 14*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 3*b1*(-48*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r*s - 12*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r*s - 12*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 36*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r*s - 72*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 + 46*D1**2*K*f*fd*r*s - 23*D1**2*K*f*fd*r + 46*D1**2*K*f*fd*s**2 - 46*D1**2*K*f*fd*s + 23*D1**2*K*f*fd - 30*D1**2*K*f*fdd*r*s + 15*D1**2*K*f*fdd*r - 30*D1**2*K*f*fdd*s**2 + 30*D1**2*K*f*fdd*s - 15*D1**2*K*f*fdd - 30*D1**2*K*fd**2*r*s + 15*D1**2*K*fd**2*r - 30*D1**2*K*fd**2*s**2 + 30*D1**2*K*fd**2*s + D1**2*bdd1*f*(-5*f*(r + 2*s - 1) + 7*r*(4*K*s - 1) + (14*s - 7)*(2*K*s - 1)) + 15*D1**2*f**2*fd*r*s - 5*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 15*D1**2*f**2*fd*s + 5*D1**2*f**2*fd + 38*D1**2*f*fd*r*s - 25*D1**2*f*fd*r + 38*D1**2*f*fd*s**2 - 62*D1**2*f*fd*s + 25*D1**2*f*fd - 12*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s - 9*D1**2*f*fdd + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 12*D1**2*fd**2*r*s + 9*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s - 9*D1**2*fd**2 + 56*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 56*D1**2*fd*g2*s**2 - 112*D1**2*fd*g2*s + 56*D1**2*fd*g2 - 56*D1**2*fd*gd2*r*s + 28*D1**2*fd*gd2*r - 56*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s - 28*D1**2*fd*gd2 - 28*D1**2*fdd*g2*r*s + 28*D1**2*fdd*g2*r - 28*D1**2*fdd*g2*s**2 + 56*D1**2*fdd*g2*s - 28*D1**2*fdd*g2 + 92*D1*Dd*K*f**2*r*s - 23*D1*Dd*K*f**2*r + 92*D1*Dd*K*f**2*s**2 - 92*D1*Dd*K*f**2*s + 23*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*r*s + 90*D1*Dd*K*f*fd*r - 240*D1*Dd*K*f*fd*s**2 + 240*D1*Dd*K*f*fd*s - 60*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r*s - 5*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 20*D1*Dd*f**3*s + 5*D1*Dd*f**3 + 76*D1*Dd*f**2*r*s - 19*D1*Dd*f**2*r + 76*D1*Dd*f**2*s**2 - 76*D1*Dd*f**2*s + 19*D1*Dd*f**2 - 96*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 144*D1*Dd*f*fd*s - 42*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 224*D1*Dd*f*gd2*s - 28*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r*s + 140*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 336*D1*Dd*fd*g2*s - 112*D1*Dd*fd*g2 - 60*D1*Ddd*K*f**2*r*s + 15*D1*Ddd*K*f**2*r - 60*D1*Ddd*K*f**2*s**2 + 60*D1*Ddd*K*f**2*s - 15*D1*Ddd*K*f**2 - 24*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 24*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 112*D1*Ddd*f*g2*s - 28*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(r + 2*s - 1) - 14*f*(r*(4*K*s - 1) + (2*s - 1)*(2*K*s - 1)) + 7*fd*(2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + r + 2*s - 1)) - 2*Dd*f*(-7*K*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 10*f*(r + 2*s - 1) + 14*r + 28*s - 14)) - 180*Dd**2*K*f**2*r*s + 45*Dd**2*K*f**2*r - 180*Dd**2*K*f**2*s**2 + 180*Dd**2*K*f**2*s - 30*Dd**2*K*f**2 - 72*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 72*Dd**2*f**2*s - 12*Dd**2*f**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 336*Dd**2*f*g2*s - 56*Dd**2*f*g2))/(105*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**3*k1*k2**2*(D1*(-7*D1*bd1**2*(3*K*f*(r*(4*s - 3) + 4*s**2 - 8*s + 3) - f*(12*C - 9)*(r*(2*s - 1) + s*(2*s - 2)) + 20*g2*r*(2*s - 1) + 40*g2*s*(s - 1)) + 7*b2*(bd1*(D1*(13*f*(s - 1)*(r + s - 1) + 9*fd*(-2*r*s + r - s*(2*s - 2))) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + 2*D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + bd1*(-63*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(6*f**2*(C*(r*(34*s - 23) + 34*s**2 - 46*s + 23) - 7*K*s**2 + 7*K*s + r*(-7*K*s - 17*s + 8) - 17*s**2 + 16*s - 8) + f*(-fd*(30*C - 15)*(r*(8*s - 5) + 8*s**2 - 12*s + 3) - 14*g2*(22*r*s - 13*r + 22*s**2 - 26*s + 13) + 42*gd2*(4*r*s - 3*r + 4*s**2 - 8*s + 3)) + 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 6*Dd*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 7) + 8*s**2 - 16*s + 6)) - 3*f*(D1*bdd1*(f*(10*C - 5) - 14*g2)*(r*(2*s - 3) + 2*s**2 - 6*s + 3) + 2*D1*(f*(fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(7*bd2 - 14*gd2)*(r + s - 1)) - 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 2*Dd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - (20*K - 10)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(-10*K + 3*f + 5) - Dd**2*(-10*K + 3*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(-24*C*D1**2*fd*r*s - 24*C*D1**2*fd*s**2 + 24*C*D1**2*fd*s + 12*C*D1**2*fdd*r*s + 12*C*D1**2*fdd*s**2 - 12*C*D1**2*fdd*s - 96*C*D1*Dd*f*r*s + 24*C*D1*Dd*f*r - 96*C*D1*Dd*f*s**2 + 96*C*D1*Dd*f*s - 24*C*D1*Dd*f + 96*C*D1*Dd*fd*r*s - 12*C*D1*Dd*fd*r + 96*C*D1*Dd*fd*s**2 - 96*C*D1*Dd*fd*s + 12*C*D1*Dd*fd + 48*C*D1*Ddd*f*r*s - 12*C*D1*Ddd*f*r + 48*C*D1*Ddd*f*s**2 - 48*C*D1*Ddd*f*s + 12*C*D1*Ddd*f + 144*C*Dd**2*f*r*s - 36*C*Dd**2*f*r + 144*C*Dd**2*f*s**2 - 144*C*Dd**2*f*s + 24*C*Dd**2*f + 22*D1**2*K*fd*r*s - 9*D1**2*K*fd*r + 22*D1**2*K*fd*s**2 - 18*D1**2*K*fd*s + 9*D1**2*K*fd - 6*D1**2*K*fdd*r*s - 3*D1**2*K*fdd*r - 6*D1**2*K*fdd*s**2 - 6*D1**2*K*fdd*s + 3*D1**2*K*fdd - D1**2*bdd1*(-10*K + 3*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 3*D1**2*f*fd*r + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 18*D1**2*fd*r*s + 5*D1**2*fd*r + 18*D1**2*fd*s**2 - 8*D1**2*fd*s - 5*D1**2*fd - 9*D1**2*fdd*r*s - 9*D1**2*fdd*s**2 + 9*D1**2*fdd*s + 40*D1**2*gd2*r*s + 40*D1**2*gd2*s**2 - 40*D1**2*gd2*s - 20*D1**2*gdd2*r*s - 20*D1**2*gdd2*s**2 + 20*D1**2*gdd2*s + 88*D1*Dd*K*f*r*s - 22*D1*Dd*K*f*r + 88*D1*Dd*K*f*s**2 - 88*D1*Dd*K*f*s + 22*D1*Dd*K*f - 48*D1*Dd*K*fd*r*s - 6*D1*Dd*K*fd*r - 48*D1*Dd*K*fd*s**2 + 12*D1*Dd*K*fd + 72*D1*Dd*f*r*s - 18*D1*Dd*f*r + 72*D1*Dd*f*s**2 - 72*D1*Dd*f*s + 18*D1*Dd*f - 72*D1*Dd*fd*r*s + 9*D1*Dd*fd*r - 72*D1*Dd*fd*s**2 + 72*D1*Dd*fd*s - 9*D1*Dd*fd + 160*D1*Dd*g2*r*s - 40*D1*Dd*g2*r + 160*D1*Dd*g2*s**2 - 160*D1*Dd*g2*s + 40*D1*Dd*g2 - 160*D1*Dd*gd2*r*s + 20*D1*Dd*gd2*r - 160*D1*Dd*gd2*s**2 + 160*D1*Dd*gd2*s - 20*D1*Dd*gd2 - 24*D1*Ddd*K*f*r*s + 6*D1*Ddd*K*f*r - 24*D1*Ddd*K*f*s**2 + 24*D1*Ddd*K*f*s - 6*D1*Ddd*K*f - 36*D1*Ddd*f*r*s + 9*D1*Ddd*f*r - 36*D1*Ddd*f*s**2 + 36*D1*Ddd*f*s - 9*D1*Ddd*f - 80*D1*Ddd*g2*r*s + 20*D1*Ddd*g2*r - 80*D1*Ddd*g2*s**2 + 80*D1*Ddd*g2*s - 20*D1*Ddd*g2 + D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + (10 - 20*K)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(-10*K + 3*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 72*Dd**2*K*f*r*s + 18*Dd**2*K*f*r - 72*Dd**2*K*f*s**2 + 72*Dd**2*K*f*s - 12*Dd**2*K*f - 108*Dd**2*f*r*s + 27*Dd**2*f*r - 108*Dd**2*f*s**2 + 108*Dd**2*f*s - 18*Dd**2*f - 240*Dd**2*g2*r*s + 60*Dd**2*g2*r - 240*Dd**2*g2*s**2 + 240*Dd**2*g2*s - 40*Dd**2*g2) + b1*(408*C*D1**2*f*fd*r*s - 66*C*D1**2*f*fd*r + 408*C*D1**2*f*fd*s**2 - 336*C*D1**2*f*fd*s + 66*C*D1**2*f*fd - 120*C*D1**2*f*fdd*r*s - 30*C*D1**2*f*fdd*r - 120*C*D1**2*f*fdd*s**2 + 30*C*D1**2*f*fdd - 120*C*D1**2*fd**2*r*s - 30*C*D1**2*fd**2*r - 120*C*D1**2*fd**2*s**2 + 30*C*D1**2*fd**2 + 816*C*D1*Dd*f**2*r*s - 204*C*D1*Dd*f**2*r + 816*C*D1*Dd*f**2*s**2 - 816*C*D1*Dd*f**2*s + 204*C*D1*Dd*f**2 - 960*C*D1*Dd*f*fd*r*s - 960*C*D1*Dd*f*fd*s**2 + 480*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd - 240*C*D1*Ddd*f**2*r*s + 60*C*D1*Ddd*f**2*r - 240*C*D1*Ddd*f**2*s**2 + 240*C*D1*Ddd*f**2*s - 60*C*D1*Ddd*f**2 - 720*C*Dd**2*f**2*r*s + 180*C*Dd**2*f**2*r - 720*C*Dd**2*f**2*s**2 + 720*C*Dd**2*f**2*s - 120*C*Dd**2*f**2 - 84*D1**2*K*f*fd*r*s + 42*D1**2*K*f*fd*r - 84*D1**2*K*f*fd*s**2 + 84*D1**2*K*f*fd*s - 42*D1**2*K*f*fd + 91*D1**2*b2*fd*r*s + 91*D1**2*b2*fd*s**2 - 63*D1**2*b2*fdd*r*s - 63*D1**2*b2*fdd*s**2 - 7*D1**2*bd1**2*(-10*K + 3*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 91*D1**2*bd2*f*r*s + 91*D1**2*bd2*f*s**2 - 91*D1**2*bd2*f*s - 126*D1**2*bd2*fd*r*s - 126*D1**2*bd2*fd*s**2 + 63*D1**2*bd2*fd*s + 7*D1**2*bdd1*(3*f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + K*(-4*r*s + 3*r - 4*s**2 + 8*s - 3) - 6*r*s + 3*r - 6*s**2 + 6*s - 3) - 20*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 63*D1**2*bdd2*f*r*s - 63*D1**2*bdd2*f*s**2 + 63*D1**2*bdd2*f*s - 204*D1**2*f*fd*r*s + 54*D1**2*f*fd*r - 204*D1**2*f*fd*s**2 + 210*D1**2*f*fd*s - 54*D1**2*f*fd + 60*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 - 15*D1**2*f*fdd - 308*D1**2*f*gd2*r*s - 308*D1**2*f*gd2*s**2 + 308*D1**2*f*gd2*s + 84*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 60*D1**2*fd**2*r*s + 15*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 15*D1**2*fd**2 - 308*D1**2*fd*g2*r*s + 126*D1**2*fd*g2*r - 308*D1**2*fd*g2*s**2 + 252*D1**2*fd*g2*s - 126*D1**2*fd*g2 + 168*D1**2*fd*gd2*r*s + 42*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 42*D1**2*fd*gd2 + 84*D1**2*fdd*g2*r*s + 42*D1**2*fdd*g2*r + 84*D1**2*fdd*g2*s**2 + 84*D1**2*fdd*g2*s - 42*D1**2*fdd*g2 - 168*D1*Dd*K*f**2*r*s + 42*D1*Dd*K*f**2*r - 168*D1*Dd*K*f**2*s**2 + 168*D1*Dd*K*f**2*s - 42*D1*Dd*K*f**2 + 364*D1*Dd*b2*f*r*s - 91*D1*Dd*b2*f*r + 364*D1*Dd*b2*f*s**2 - 364*D1*Dd*b2*f*s + 91*D1*Dd*b2*f - 504*D1*Dd*b2*fd*r*s + 63*D1*Dd*b2*fd*r - 504*D1*Dd*b2*fd*s**2 + 252*D1*Dd*b2*fd*s - 504*D1*Dd*bd2*f*r*s + 63*D1*Dd*bd2*f*r - 504*D1*Dd*bd2*f*s**2 + 504*D1*Dd*bd2*f*s - 63*D1*Dd*bd2*f - 408*D1*Dd*f**2*r*s + 102*D1*Dd*f**2*r - 408*D1*Dd*f**2*s**2 + 408*D1*Dd*f**2*s - 102*D1*Dd*f**2 + 480*D1*Dd*f*fd*r*s + 480*D1*Dd*f*fd*s**2 - 240*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 1232*D1*Dd*f*g2*r*s + 308*D1*Dd*f*g2*r - 1232*D1*Dd*f*g2*s**2 + 1232*D1*Dd*f*g2*s - 308*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r*s - 84*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 672*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r*s + 84*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2 - 252*D1*Ddd*b2*f*r*s + 63*D1*Ddd*b2*f*r - 252*D1*Ddd*b2*f*s**2 + 252*D1*Ddd*b2*f*s - 63*D1*Ddd*b2*f + 120*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 120*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 336*D1*Ddd*f*g2*s + 84*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(3*f**2*(r + 2*s - 1) + f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-44*r*s + 13*r - 44*s**2 + 48*s - 13) - 36*r*s + 23*r - 36*s**2 + 46*s - 23) - 3*fd*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(-8*r*s + r - 8*s**2 + 4*s + 1) - 3*r*(4*s - 1) - 3*(1 - 2*s)**2) - 20*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 20*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 6*Dd*f*(4*C*r*(8*s - 3) + 8*C*(1 - 2*s)**2 + K*(r*(8 - 16*s) - 16*s**2 + 24*s - 7) - 3*r*(8*s - 3) - 6*(1 - 2*s)**2) + 40*Dd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 756*Dd**2*b2*f*r*s + 189*Dd**2*b2*f*r - 756*Dd**2*b2*f*s**2 + 756*Dd**2*b2*f*s - 126*Dd**2*b2*f + 360*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 360*Dd**2*f**2*s + 60*Dd**2*f**2 + 1008*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1008*Dd**2*f*g2*s + 168*Dd**2*f*g2))/(105*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**3*k1*st**2*(-D1*f*(D1*bd1**2*s*(5*f + 7)*(2*r + 2*s - 1) + 3*D1*bdd1*f*s*(r + s) + 3*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1)))) + b1**2*(-D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) - 2*fd*(10*f*s - 5*f + 7*s - 7) + fdd*(10*f*s - 5*f + 7*s - 7)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 14*r*(4*s - 1) + 14*(1 - 2*s)**2) - 7*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(5*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(7*bdd1*s*(2*r + 2*s - 1) - 6*fd*(2*s - 1)*(r + s - 1) + 3*fdd*(2*s - 1)*(r + s - 1)) + 3*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + 2*f*s*(5*f + 7)*(2*r + 2*s - 1) - 7*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - Dd*f*(5*f + 7)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 3*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(6 - 16*s) - 16*s**2 + 20*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k3) - D1**2*Pkd2*Pkd3*ct**3*k1*(D1*(21*D1*bd1**2*f*(r*s*(2*K - 2) + r + s*(K*(2*s - 1) - 2*s + 2)) + 3*D1*bdd1*f*s*(r + s)*(7*b2 + f*(10*C - 5) - 14*g2) + bd1*(D1*(f**2*s*(-18*C - 12)*(r + s) + f*(fd*(30*C - 15)*(r*(4*s - 1) + s*(4*s - 3)) + 7*s*(bd2*(6*r + 6*s - 3) + 2*g2*(r + s) - 6*gd2*(2*r + 2*s - 1))) + 42*fd*g2*(-2*r*s + r - s*(2*s - 2))) + 3*Dd*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + 7*b2*(D1*(-f*s*(r + s) + fd*r*(6*s - 3) + 6*fd*s*(s - 1)) + 3*Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 7*b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 10*r*(4*s - 1) + 10*(1 - 2*s)**2) - D1*Ddd*(3*f + 5)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(3*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(-D1**2*K*fd*r*s + D1**2*K*fd*r - D1**2*K*fd*s**2 + 2*D1**2*K*fd*s - D1**2*K*fd + 3*D1**2*K*fdd*r*s - 3*D1**2*K*fdd*r + 3*D1**2*K*fdd*s**2 - 6*D1**2*K*fdd*s + 3*D1**2*K*fdd - D1**2*bdd1*(3*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 6*D1**2*f*fd*r*s + 3*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 + 9*D1**2*f*fd*s - 3*D1**2*f*fd + D1**2*fd*r*s + 5*D1**2*fd*r + D1**2*fd*s**2 + 4*D1**2*fd*s - 5*D1**2*fd - 3*D1**2*fdd*r*s - 3*D1**2*fdd*s**2 + 3*D1**2*fdd*s - 4*D1*Dd*K*f*r*s + D1*Dd*K*f*r - 4*D1*Dd*K*f*s**2 + 4*D1*Dd*K*f*s - D1*Dd*K*f + 24*D1*Dd*K*fd*r*s - 15*D1*Dd*K*fd*r + 24*D1*Dd*K*fd*s**2 - 36*D1*Dd*K*fd*s + 12*D1*Dd*K*fd - 12*D1*Dd*f**2*r*s + 3*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 4*D1*Dd*f*r*s - D1*Dd*f*r + 4*D1*Dd*f*s**2 - 4*D1*Dd*f*s + D1*Dd*f - 24*D1*Dd*fd*r*s + 3*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 24*D1*Dd*fd*s - 3*D1*Dd*fd + 12*D1*Ddd*K*f*r*s - 3*D1*Ddd*K*f*r + 12*D1*Ddd*K*f*s**2 - 12*D1*Ddd*K*f*s + 3*D1*Ddd*K*f - 12*D1*Ddd*f*r*s + 3*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 12*D1*Ddd*f*s - 3*D1*Ddd*f + D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + 30*r*s - 10*r + 30*s**2 - 30*s + 10) - Dd*(3*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 36*Dd**2*K*f*r*s - 9*Dd**2*K*f*r + 36*Dd**2*K*f*s**2 - 36*Dd**2*K*f*s + 6*Dd**2*K*f - 36*Dd**2*f*r*s + 9*Dd**2*f*r - 36*Dd**2*f*s**2 + 36*Dd**2*f*s - 6*Dd**2*f) - b1*(36*C*D1**2*f*fd*r*s - 18*C*D1**2*f*fd*r + 36*C*D1**2*f*fd*s**2 - 54*C*D1**2*f*fd*s + 18*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r*s + 30*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 90*C*D1**2*f*fdd*s - 30*C*D1**2*f*fdd - 60*C*D1**2*fd**2*r*s + 30*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 90*C*D1**2*fd**2*s - 30*C*D1**2*fd**2 + 72*C*D1*Dd*f**2*r*s - 18*C*D1*Dd*f**2*r + 72*C*D1*Dd*f**2*s**2 - 72*C*D1*Dd*f**2*s + 18*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r*s + 180*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 600*C*D1*Dd*f*fd*s - 150*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r*s + 30*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 120*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r*s + 90*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 360*C*Dd**2*f**2*s - 60*C*Dd**2*f**2 + 7*D1**2*b2*fd*r*s - 7*D1**2*b2*fd*r + 7*D1**2*b2*fd*s**2 - 14*D1**2*b2*fd*s + 7*D1**2*b2*fd - 21*D1**2*b2*fdd*r*s + 21*D1**2*b2*fdd*r - 21*D1**2*b2*fdd*s**2 + 42*D1**2*b2*fdd*s - 21*D1**2*b2*fdd + 7*D1**2*bd1**2*(3*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 7*D1**2*bd2*f*r*s + 7*D1**2*bd2*f*s**2 - 7*D1**2*bd2*f*s - 42*D1**2*bd2*fd*r*s + 21*D1**2*bd2*fd*r - 42*D1**2*bd2*fd*s**2 + 63*D1**2*bd2*fd*s - 21*D1**2*bd2*fd - 21*D1**2*bdd1*f*(r*s*(2*K - 2) + r + s**2*(2*K - 2) - s*(K - 2) - 1) - 21*D1**2*bdd2*f*r*s - 21*D1**2*bdd2*f*s**2 + 21*D1**2*bdd2*f*s + 24*D1**2*f*fd*r*s - 12*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s + 12*D1**2*f*fd + 30*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 45*D1**2*f*fdd*s + 15*D1**2*f*fdd - 14*D1**2*f*gd2*r*s - 14*D1**2*f*gd2*s**2 + 14*D1**2*f*gd2*s + 42*D1**2*f*gdd2*r*s + 42*D1**2*f*gdd2*s**2 - 42*D1**2*f*gdd2*s + 30*D1**2*fd**2*r*s - 15*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 45*D1**2*fd**2*s + 15*D1**2*fd**2 - 14*D1**2*fd*g2*r*s + 14*D1**2*fd*g2*r - 14*D1**2*fd*g2*s**2 + 28*D1**2*fd*g2*s - 14*D1**2*fd*g2 + 84*D1**2*fd*gd2*r*s - 42*D1**2*fd*gd2*r + 84*D1**2*fd*gd2*s**2 - 126*D1**2*fd*gd2*s + 42*D1**2*fd*gd2 + 42*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*r + 42*D1**2*fdd*g2*s**2 - 84*D1**2*fdd*g2*s + 42*D1**2*fdd*g2 + 28*D1*Dd*b2*f*r*s - 7*D1*Dd*b2*f*r + 28*D1*Dd*b2*f*s**2 - 28*D1*Dd*b2*f*s + 7*D1*Dd*b2*f - 168*D1*Dd*b2*fd*r*s + 105*D1*Dd*b2*fd*r - 168*D1*Dd*b2*fd*s**2 + 252*D1*Dd*b2*fd*s - 84*D1*Dd*b2*fd - 168*D1*Dd*bd2*f*r*s + 21*D1*Dd*bd2*f*r - 168*D1*Dd*bd2*f*s**2 + 168*D1*Dd*bd2*f*s - 21*D1*Dd*bd2*f + 48*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 48*D1*Dd*f**2*s + 12*D1*Dd*f**2 + 240*D1*Dd*f*fd*r*s - 90*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 300*D1*Dd*f*fd*s + 75*D1*Dd*f*fd - 56*D1*Dd*f*g2*r*s + 14*D1*Dd*f*g2*r - 56*D1*Dd*f*g2*s**2 + 56*D1*Dd*f*g2*s - 14*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r*s - 42*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s**2 - 336*D1*Dd*f*gd2*s + 42*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r*s - 210*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s**2 - 504*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 - 84*D1*Ddd*b2*f*r*s + 21*D1*Ddd*b2*f*r - 84*D1*Ddd*b2*f*s**2 + 84*D1*Ddd*b2*f*s - 21*D1*Ddd*b2*f + 60*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 60*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*r*s - 42*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s**2 - 168*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 7*D1*bd1*(3*D1*f**2*s*(2*r + 2*s - 1) + D1*f*(2*r*(s*(K - 1) + 3) + s**2*(2*K - 2) - s*(K - 7) - 6) - 3*D1*fd*(K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r*s + r - (1 - 2*s)**2) - 3*Dd*K*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 6*Dd*f*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 252*Dd**2*b2*f*r*s + 63*Dd**2*b2*f*r - 252*Dd**2*b2*f*s**2 + 252*Dd**2*b2*f*s - 42*Dd**2*b2*f + 180*Dd**2*f**2*r*s - 45*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 180*Dd**2*f**2*s + 30*Dd**2*f**2 + 504*Dd**2*f*g2*r*s - 126*Dd**2*f*g2*r + 504*Dd**2*f*g2*s**2 - 504*Dd**2*f*g2*s + 84*Dd**2*f*g2))/(105*d**2*k3) + D1**2*Pkd2*Pkd3*ct**2*f**2*k1**6*st**2*(D1**2*(-f*(17*fd - 14*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + 14*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(-17*f*(r*(4*s - 1) + (1 - 2*s)**2) + 28*fd*(4*s - 1)*(4*r + 4*s - 3)) + 14*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 14*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k2*k3**5) + D1**2*Pkd2*Pkd3*ct**2*f*k1**6*(7*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(-5*f*(s - 1)*(r + s - 1) + 7*fd*(6*r*s - 3*r + 6*s**2 - 8*s + 2)) + 7*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + b1*(-D1**2*s*(3*r + 3*s - 2)*(5*f*fd - 7*f*fdd - 14*fd**2) + D1*f*(Dd*(-5*f*(r*(4*s - 1) + (1 - 2*s)**2) + 7*fd*(3*r*(8*s - 1) + 24*s**2 - 20*s + 2)) + 7*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k2*k3**5) - D1**2*Pkd2*Pkd3*ct**2*k1**4*k2*st**4*(132*C*D1**2*f**2*fd*r*s - 44*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 132*C*D1**2*f**2*fd*s + 44*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r*s + 22*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 66*C*D1**2*f**2*fdd*s - 22*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r*s + 44*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 132*C*D1**2*f*fd**2*s - 22*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r*s - 44*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 176*C*D1*Dd*f**3*s + 44*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r*s + 154*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 528*C*D1*Dd*f**2*fd*s - 110*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r*s + 22*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 88*C*D1*Ddd*f**3*s - 22*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r*s + 66*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 264*C*Dd**2*f**3*s - 44*C*Dd**2*f**3 - 33*D1**2*K*bdd1*f**2*r*s - 33*D1**2*K*bdd1*f**2*s**2 + 33*D1**2*K*bdd1*f**2*s + 33*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s + 980*D1**2*f**3*fd*r*s - 245*D1**2*f**3*fd*r + 980*D1**2*f**3*fd*s**2 - 980*D1**2*f**3*fd*s + 245*D1**2*f**3*fd - 600*D1**2*f**3*fdd*r*s + 150*D1**2*f**3*fdd*r - 600*D1**2*f**3*fdd*s**2 + 600*D1**2*f**3*fdd*s - 150*D1**2*f**3*fdd - 1800*D1**2*f**2*fd**2*r*s + 450*D1**2*f**2*fd**2*r - 1800*D1**2*f**2*fd**2*s**2 + 1800*D1**2*f**2*fd**2*s - 300*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r*s + 44*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 132*D1**2*f**2*fd*s - 44*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r*s - 22*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 66*D1**2*f**2*fdd*s + 22*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s + 66*D1**2*f**2*gdd2*r*s + 66*D1**2*f**2*gdd2*s**2 - 66*D1**2*f**2*gdd2*s + 132*D1**2*f*fd**2*r*s - 44*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 132*D1**2*f*fd**2*s + 22*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r*s - 66*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 264*D1**2*f*fd*gd2*s + 66*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r*s - 66*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r*s - 66*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 980*D1*Dd*f**4*r*s - 245*D1*Dd*f**4*r + 980*D1*Dd*f**4*s**2 - 980*D1*Dd*f**4*s + 245*D1*Dd*f**4 - 4800*D1*Dd*f**3*fd*r*s + 1200*D1*Dd*f**3*fd*r - 4800*D1*Dd*f**3*fd*s**2 + 4800*D1*Dd*f**3*fd*s - 900*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 176*D1*Dd*f**3*s - 44*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r*s - 154*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 528*D1*Dd*f**2*fd*s + 110*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r*s + 132*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r*s - 66*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 528*D1*Dd*f**2*gd2*s + 66*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r*s - 396*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1056*D1*Dd*f*fd*g2*s + 264*D1*Dd*f*fd*g2 - 600*D1*Ddd*f**4*r*s + 150*D1*Ddd*f**4*r - 600*D1*Ddd*f**4*s**2 + 600*D1*Ddd*f**4*s - 150*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 88*D1*Ddd*f**3*s + 22*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r*s - 66*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 264*D1*Ddd*f**2*g2*s + 66*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 1800*Dd**2*f**4*r*s + 450*Dd**2*f**4*r - 1800*Dd**2*f**4*s**2 + 1800*Dd**2*f**4*s - 300*Dd**2*f**4 + 264*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 264*Dd**2*f**3*s + 44*Dd**2*f**3 + 792*Dd**2*f**2*g2*r*s - 198*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 792*Dd**2*f**2*g2*s + 132*Dd**2*f**2*g2 + 33*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(385*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**2*k1**4*k2*st**2*(18*C*D1**2*bdd1*f**2*r*s - 18*C*D1**2*bdd1*f**2*r + 18*C*D1**2*bdd1*f**2*s**2 - 36*C*D1**2*bdd1*f**2*s + 18*C*D1**2*bdd1*f**2 - 66*C*D1**2*f**2*fd*r*s + 22*C*D1**2*f**2*fd*r - 66*C*D1**2*f**2*fd*s**2 + 66*C*D1**2*f**2*fd*s - 22*C*D1**2*f**2*fd + 60*C*D1**2*f**2*fdd*r*s - 20*C*D1**2*f**2*fdd*r + 60*C*D1**2*f**2*fdd*s**2 - 60*C*D1**2*f**2*fdd*s + 20*C*D1**2*f**2*fdd + 120*C*D1**2*f*fd**2*r*s - 40*C*D1**2*f*fd**2*r + 120*C*D1**2*f*fd**2*s**2 - 120*C*D1**2*f*fd**2*s + 20*C*D1**2*f*fd**2 - 88*C*D1*Dd*f**3*r*s + 22*C*D1*Dd*f**3*r - 88*C*D1*Dd*f**3*s**2 + 88*C*D1*Dd*f**3*s - 22*C*D1*Dd*f**3 + 480*C*D1*Dd*f**2*fd*r*s - 140*C*D1*Dd*f**2*fd*r + 480*C*D1*Dd*f**2*fd*s**2 - 480*C*D1*Dd*f**2*fd*s + 100*C*D1*Dd*f**2*fd + 80*C*D1*Ddd*f**3*r*s - 20*C*D1*Ddd*f**3*r + 80*C*D1*Ddd*f**3*s**2 - 80*C*D1*Ddd*f**3*s + 20*C*D1*Ddd*f**3 + 240*C*Dd**2*f**3*r*s - 60*C*Dd**2*f**3*r + 240*C*Dd**2*f**3*s**2 - 240*C*Dd**2*f**3*s + 40*C*Dd**2*f**3 + 18*D1**2*K*bdd1*f**2*r*s + 18*D1**2*K*bdd1*f**2*s**2 - 18*D1**2*K*bdd1*f**2*s + 21*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 20*D1**2*bdd1*f**3*r*s - 60*D1**2*bdd1*f**3*r + 20*D1**2*bdd1*f**3*s**2 - 80*D1**2*bdd1*f**3*s + 60*D1**2*bdd1*f**3 - 27*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*r - 27*D1**2*bdd1*f**2*s**2 + 45*D1**2*bdd1*f**2*s - 18*D1**2*bdd1*f**2 - 42*D1**2*bdd1*f*g2*r*s + 42*D1**2*bdd1*f*g2*r - 42*D1**2*bdd1*f*g2*s**2 + 84*D1**2*bdd1*f*g2*s - 42*D1**2*bdd1*f*g2 + 120*D1**2*f**3*fd*r*s - 30*D1**2*f**3*fd*r + 120*D1**2*f**3*fd*s**2 - 120*D1**2*f**3*fd*s + 30*D1**2*f**3*fd + 45*D1**2*f**2*fd*r*s - 15*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s**2 - 45*D1**2*f**2*fd*s + 15*D1**2*f**2*fd - 45*D1**2*f**2*fdd*r*s + 15*D1**2*f**2*fdd*r - 45*D1**2*f**2*fdd*s**2 + 45*D1**2*f**2*fdd*s - 15*D1**2*f**2*fdd + 30*D1**2*f**2*gd2*r*s + 30*D1**2*f**2*gd2*s**2 - 30*D1**2*f**2*gd2*s - 36*D1**2*f**2*gdd2*r*s - 36*D1**2*f**2*gdd2*s**2 + 36*D1**2*f**2*gdd2*s - 90*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r - 90*D1**2*f*fd**2*s**2 + 90*D1**2*f*fd**2*s - 15*D1**2*f*fd**2 + 60*D1**2*f*fd*g2*r*s - 30*D1**2*f*fd*g2*r + 60*D1**2*f*fd*g2*s**2 - 60*D1**2*f*fd*g2*s + 30*D1**2*f*fd*g2 - 144*D1**2*f*fd*gd2*r*s + 36*D1**2*f*fd*gd2*r - 144*D1**2*f*fd*gd2*s**2 + 144*D1**2*f*fd*gd2*s - 36*D1**2*f*fd*gd2 - 72*D1**2*f*fdd*g2*r*s + 36*D1**2*f*fdd*g2*r - 72*D1**2*f*fdd*g2*s**2 + 72*D1**2*f*fdd*g2*s - 36*D1**2*f*fdd*g2 - 72*D1**2*fd**2*g2*r*s + 36*D1**2*fd**2*g2*r - 72*D1**2*fd**2*g2*s**2 + 72*D1**2*fd**2*g2*s + 120*D1*Dd*f**4*r*s - 30*D1*Dd*f**4*r + 120*D1*Dd*f**4*s**2 - 120*D1*Dd*f**4*s + 30*D1*Dd*f**4 + 60*D1*Dd*f**3*r*s - 15*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 15*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r*s + 105*D1*Dd*f**2*fd*r - 360*D1*Dd*f**2*fd*s**2 + 360*D1*Dd*f**2*fd*s - 75*D1*Dd*f**2*fd + 120*D1*Dd*f**2*g2*r*s - 30*D1*Dd*f**2*g2*r + 120*D1*Dd*f**2*g2*s**2 - 120*D1*Dd*f**2*g2*s + 30*D1*Dd*f**2*g2 - 288*D1*Dd*f**2*gd2*r*s + 36*D1*Dd*f**2*gd2*r - 288*D1*Dd*f**2*gd2*s**2 + 288*D1*Dd*f**2*gd2*s - 36*D1*Dd*f**2*gd2 - 576*D1*Dd*f*fd*g2*r*s + 216*D1*Dd*f*fd*g2*r - 576*D1*Dd*f*fd*g2*s**2 + 576*D1*Dd*f*fd*g2*s - 144*D1*Dd*f*fd*g2 - 60*D1*Ddd*f**3*r*s + 15*D1*Ddd*f**3*r - 60*D1*Ddd*f**3*s**2 + 60*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 - 144*D1*Ddd*f**2*g2*r*s + 36*D1*Ddd*f**2*g2*r - 144*D1*Ddd*f**2*g2*s**2 + 144*D1*Ddd*f**2*g2*s - 36*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-f**3*(40*s - 93)*(r + s - 1) + f**2*(-36*C*(s - 1)*(r + s - 1) + 20*fd*(r*(6*s - 7) + 6*s**2 - 12*s + 4) - (s*(15*K - 40) + 36)*(r + s - 1)) + 9*f*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 5*r - 12*s**2 + 14*s - 3) + 42*f*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 42*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(20*f**2*(r*(8*s - 13) + 8*s**2 - 20*s + 10) + 9*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 11*r - 24*s**2 + 32*s - 9) - 42*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 180*Dd**2*f**3*r*s + 45*Dd**2*f**3*r - 180*Dd**2*f**3*s**2 + 180*Dd**2*f**3*s - 30*Dd**2*f**3 - 432*Dd**2*f**2*g2*r*s + 108*Dd**2*f**2*g2*r - 432*Dd**2*f**2*g2*s**2 + 432*Dd**2*f**2*g2*s - 72*Dd**2*f**2*g2 - 21*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(-72*C*D1**2*f*fd*r*s - 72*C*D1**2*f*fd*s**2 + 36*C*D1**2*f*fd*s + 36*C*D1**2*f*fdd*r*s + 36*C*D1**2*f*fdd*s**2 - 18*C*D1**2*f*fdd*s + 36*C*D1**2*fd**2*r*s + 36*C*D1**2*fd**2*s**2 - 18*C*D1**2*fd**2*s - 144*C*D1*Dd*f**2*r*s + 36*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 36*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r*s - 36*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 216*C*D1*Dd*f*fd*s + 18*C*D1*Dd*f*fd + 72*C*D1*Ddd*f**2*r*s - 18*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 18*C*D1*Ddd*f**2 + 216*C*Dd**2*f**2*r*s - 54*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 36*C*Dd**2*f**2 - 30*D1**2*K*f*fd*r*s + 15*D1**2*K*f*fd*r - 30*D1**2*K*f*fd*s**2 + 30*D1**2*K*f*fd*s - 15*D1**2*K*f*fd + 36*D1**2*K*f*fdd*r*s - 18*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r*s - 18*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s + 21*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 120*D1**2*f**2*fd*r*s - 53*D1**2*f**2*fd*r - 120*D1**2*f**2*fd*s**2 + 27*D1**2*f**2*fd*s + 53*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r*s + 40*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 40*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r*s + 80*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2 + 80*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 80*D1**2*f*fd*s**2 - 44*D1**2*f*fd*s + 4*D1**2*f*fd - 54*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 9*D1**2*f*fdd + 84*D1**2*f*gd2*r*s + 84*D1**2*f*gd2*s**2 - 84*D1**2*f*gd2*s - 42*D1**2*f*gdd2*r*s - 42*D1**2*f*gdd2*s**2 + 42*D1**2*f*gdd2*s - 54*D1**2*fd**2*r*s + 9*D1**2*fd**2*r - 54*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 84*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*s**2 - 84*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*s**2 + 42*D1**2*fd*gd2*s - 42*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*s**2 - 60*D1*Dd*K*f**2*r*s + 15*D1*Dd*K*f**2*r - 60*D1*Dd*K*f**2*s**2 + 60*D1*Dd*K*f**2*s - 15*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r*s - 108*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 288*D1*Dd*K*f*fd*s + 72*D1*Dd*K*f*fd - 160*D1*Dd*f**3*r*s + 40*D1*Dd*f**3*r - 160*D1*Dd*f**3*s**2 + 160*D1*Dd*f**3*s - 40*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r*s + 100*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 240*D1*Dd*f**2*fd*s - 80*D1*Dd*f**2*fd + 160*D1*Dd*f**2*r*s - 40*D1*Dd*f**2*r + 160*D1*Dd*f**2*s**2 - 160*D1*Dd*f**2*s + 40*D1*Dd*f**2 - 432*D1*Dd*f*fd*r*s + 90*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 336*D1*Dd*f*g2*r*s - 84*D1*Dd*f*g2*r + 336*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r*s + 42*D1*Dd*f*gd2*r - 336*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 42*D1*Dd*f*gd2 - 336*D1*Dd*fd*g2*r*s + 42*D1*Dd*fd*g2*r - 336*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 72*D1*Ddd*K*f**2*r*s - 18*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 72*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 + 80*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 80*D1*Ddd*f**3*s + 20*D1*Ddd*f**3 - 108*D1*Ddd*f**2*r*s + 27*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r*s + 42*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 42*D1*Ddd*f*g2 - 21*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) + 216*Dd**2*K*f**2*r*s - 54*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 216*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 + 240*Dd**2*f**3*r*s - 60*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 240*Dd**2*f**3*s + 40*Dd**2*f**3 - 324*Dd**2*f**2*r*s + 81*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 54*Dd**2*f**2 - 504*Dd**2*f*g2*r*s + 126*Dd**2*f*g2*r - 504*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 84*Dd**2*f*g2))/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**2*k1**4*k2*(-3*D1*(D1*bd1**2*f*(2*s - 1)*(-14*K + 20*f + 7)*(r + s - 1) - D1*bdd1*f*(s - 1)*(f*(20*C - 15) - 28*g2)*(r + s - 1) + bd1*(D1*(-5*f**3*(2*s - 3)*(r + s - 1) - f**2*(2*C - 5)*(s - 1)*(r + s - 1) + f*(-fd*(20*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (g2*(s - 1) + 2*gd2*(2*s - 1))*(14*r + 14*s - 14)) + 28*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(f*(20*C - 15) - 28*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + b1**2*(D1**2*s*(3*f*(19*fd - 20*fdd)*(2*r + 2*s - 1) - 60*fd**2*(2*r + 2*s - 1) + 7*fd*(3*K - 4)*(r + s) + 21*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(57*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-60*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (21*K - 28)*(r*(4*s - 1) + (1 - 2*s)**2)) + 21*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 20*f + 7)) - 3*Dd**2*f*(-14*K + 20*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*bdd1*f*(2*s - 1)*(-14*K + 20*f + 7)*(r + s - 1) - 3*D1**2*(-5*f**2*fd*(6*r*s + r + 6*s**2 - 3*s - 1) + f*s*(-fd*(2*C - 5)*(2*r + 2*s - 1) - fdd*(20*C - 15)*(2*r + 2*s - 1) + (14*gd2 + 28*gdd2)*(r + s - 1)) + s*(-fd**2*(20*C - 15)*(2*r + 2*s - 1) + 14*fd*(g2*(r + s) + gd2*(4*r + 4*s - 2)) + 28*fdd*g2*(r + s))) + D1*bd1*(D1*(57*f**2*(2*s - 1)*(r + s - 1) + f*(-60*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + (21*K - 28)*(2*s - 1)*(r + s - 1)) + 21*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 3*Dd*f*(-14*K + 20*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*D1*(Dd*(-10*f**3*(r*(4*s - 1) + (1 - 2*s)**2) - f**2*(2*C - 5)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(15 - 20*C)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 14*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 28*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 28*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(f*(20*C - 15) - 28*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd**2*f*(f*(20*C - 15) - 28*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**2*k1**4*st**2*(b1*(D1**2*(-f**2*(11*fd - 10*fdd)*(r*(6*s - 2) + 6*s**2 - 7*s + 2) + f*(10*fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3) - 11*fd*(2*r*s - r + 2*s**2 - 2*s + 1) + 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-22*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(10*fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11) - 11*r*(4*s - 1) - 11*(1 - 2*s)**2) + 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(20*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(20*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(10*bdd1*f**2*s*(2*r + 2*s - 1) + f*(9*bdd1*s*(r + s - 1) - 7*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-11*f*s*(f*(2*r + 2*s - 1) + r + s - 1) + fd*(10*f*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + 9*r*(4*s - 1) + 9*(1 - 2*s)**2)) + Dd*f*(10*f*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 72*r*s - 9*r + 72*s**2 - 72*s + 9)) + D1*f*(Dd*(-7*f*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2*k3**3) + D1**2*Pkd2*Pkd3*ct**2*k1**4*(3*D1*f*(D1*bd1**2*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + (2*s - 1)*(7*r + 7*s - 7)) + 5*D1*bdd1*f*(s - 1)*(r + s - 1) + bd1*(D1*(-3*f*(s - 1)*(r + s - 1) + 5*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + b1**2*(D1**2*s*(-3*f*(3*fd - 5*fdd)*(4*r + 4*s - 3) + 15*fd**2*(4*r + 4*s - 3) - 7*fd*(r + s) + 21*fdd*(r + s)) + D1*(Dd*(-18*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(15*fd*(8*s - 1)*(4*r + 4*s - 3) - 7*r*(4*s - 1) - 7*(1 - 2*s)**2) + 21*fd*(r*(8*s - 1) + 4*s*(2*s - 1))) + 3*Ddd*f*(10*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd**2*f*(10*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(3*D1**2*bdd1*f*(5*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + (2*s - 1)*(7*r + 7*s - 7)) - 3*D1**2*s*(2*r + 2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + D1*bd1*(D1*(-9*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(15*fd*(4*s - 1)*(4*r + 4*s - 3) + (2*s - 1)*(-7*r - 7*s + 7)) + 21*fd*(r*(4*s - 1) + s*(4*s - 3))) + 3*Dd*f*(5*f*(8*s - 3)*(4*r + 4*s - 3) + 112*r*s - 42*r + 112*s**2 - 140*s + 35)) + 3*D1*f*(Dd*(-3*f*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 15*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2*k3**3) - D1**2*Pkd2*Pkd3*ct**2*k1**2*k2**3*st**6*(132*C*D1**2*f**2*fd*r*s - 44*C*D1**2*f**2*fd*r + 132*C*D1**2*f**2*fd*s**2 - 132*C*D1**2*f**2*fd*s + 44*C*D1**2*f**2*fd - 66*C*D1**2*f**2*fdd*r*s + 22*C*D1**2*f**2*fdd*r - 66*C*D1**2*f**2*fdd*s**2 + 66*C*D1**2*f**2*fdd*s - 22*C*D1**2*f**2*fdd - 132*C*D1**2*f*fd**2*r*s + 44*C*D1**2*f*fd**2*r - 132*C*D1**2*f*fd**2*s**2 + 132*C*D1**2*f*fd**2*s - 22*C*D1**2*f*fd**2 + 176*C*D1*Dd*f**3*r*s - 44*C*D1*Dd*f**3*r + 176*C*D1*Dd*f**3*s**2 - 176*C*D1*Dd*f**3*s + 44*C*D1*Dd*f**3 - 528*C*D1*Dd*f**2*fd*r*s + 154*C*D1*Dd*f**2*fd*r - 528*C*D1*Dd*f**2*fd*s**2 + 528*C*D1*Dd*f**2*fd*s - 110*C*D1*Dd*f**2*fd - 88*C*D1*Ddd*f**3*r*s + 22*C*D1*Ddd*f**3*r - 88*C*D1*Ddd*f**3*s**2 + 88*C*D1*Ddd*f**3*s - 22*C*D1*Ddd*f**3 - 264*C*Dd**2*f**3*r*s + 66*C*Dd**2*f**3*r - 264*C*Dd**2*f**3*s**2 + 264*C*Dd**2*f**3*s - 44*C*Dd**2*f**3 - 99*D1**2*K*bdd1*f**2*r*s - 99*D1**2*K*bdd1*f**2*s**2 + 99*D1**2*K*bdd1*f**2*s + 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 99*D1**2*bdd1*f**2*s + 672*D1**2*f**3*fd*r*s - 168*D1**2*f**3*fd*r + 672*D1**2*f**3*fd*s**2 - 672*D1**2*f**3*fd*s + 168*D1**2*f**3*fd - 336*D1**2*f**3*fdd*r*s + 84*D1**2*f**3*fdd*r - 336*D1**2*f**3*fdd*s**2 + 336*D1**2*f**3*fdd*s - 84*D1**2*f**3*fdd - 1008*D1**2*f**2*fd**2*r*s + 252*D1**2*f**2*fd**2*r - 1008*D1**2*f**2*fd**2*s**2 + 1008*D1**2*f**2*fd**2*s - 168*D1**2*f**2*fd**2 - 132*D1**2*f**2*fd*r*s + 44*D1**2*f**2*fd*r - 132*D1**2*f**2*fd*s**2 + 132*D1**2*f**2*fd*s - 44*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r*s - 22*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 66*D1**2*f**2*fdd*s + 22*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s + 198*D1**2*f**2*gdd2*r*s + 198*D1**2*f**2*gdd2*s**2 - 198*D1**2*f**2*gdd2*s + 132*D1**2*f*fd**2*r*s - 44*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 132*D1**2*f*fd**2*s + 22*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r*s + 396*D1**2*f*fd*g2*r - 792*D1**2*f*fd*g2*s**2 + 792*D1**2*f*fd*g2*s - 396*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r*s - 198*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r*s - 198*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r*s - 198*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s + 672*D1*Dd*f**4*r*s - 168*D1*Dd*f**4*r + 672*D1*Dd*f**4*s**2 - 672*D1*Dd*f**4*s + 168*D1*Dd*f**4 - 2688*D1*Dd*f**3*fd*r*s + 672*D1*Dd*f**3*fd*r - 2688*D1*Dd*f**3*fd*s**2 + 2688*D1*Dd*f**3*fd*s - 504*D1*Dd*f**3*fd - 176*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r - 176*D1*Dd*f**3*s**2 + 176*D1*Dd*f**3*s - 44*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r*s - 154*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 528*D1*Dd*f**2*fd*s + 110*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 1584*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r*s - 198*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 1584*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r*s - 1188*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 336*D1*Ddd*f**4*r*s + 84*D1*Ddd*f**4*r - 336*D1*Ddd*f**4*s**2 + 336*D1*Ddd*f**4*s - 84*D1*Ddd*f**4 + 88*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 88*D1*Ddd*f**3*s + 22*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r*s - 198*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 99*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 1008*Dd**2*f**4*r*s + 252*Dd**2*f**4*r - 1008*Dd**2*f**4*s**2 + 1008*Dd**2*f**4*s - 168*Dd**2*f**4 + 264*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 264*Dd**2*f**3*s + 44*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r*s - 594*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 99*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**2*k1**2*k2**3*st**4*(-2*C*D1**2*bdd1*f**2*r*s + 2*C*D1**2*bdd1*f**2*r - 2*C*D1**2*bdd1*f**2*s**2 + 4*C*D1**2*bdd1*f**2*s - 2*C*D1**2*bdd1*f**2 + 102*C*D1**2*f**2*fd*r*s - 34*C*D1**2*f**2*fd*r + 102*C*D1**2*f**2*fd*s**2 - 102*C*D1**2*f**2*fd*s + 34*C*D1**2*f**2*fd - 60*C*D1**2*f**2*fdd*r*s + 20*C*D1**2*f**2*fdd*r - 60*C*D1**2*f**2*fdd*s**2 + 60*C*D1**2*f**2*fdd*s - 20*C*D1**2*f**2*fdd - 120*C*D1**2*f*fd**2*r*s + 40*C*D1**2*f*fd**2*r - 120*C*D1**2*f*fd**2*s**2 + 120*C*D1**2*f*fd**2*s - 20*C*D1**2*f*fd**2 + 136*C*D1*Dd*f**3*r*s - 34*C*D1*Dd*f**3*r + 136*C*D1*Dd*f**3*s**2 - 136*C*D1*Dd*f**3*s + 34*C*D1*Dd*f**3 - 480*C*D1*Dd*f**2*fd*r*s + 140*C*D1*Dd*f**2*fd*r - 480*C*D1*Dd*f**2*fd*s**2 + 480*C*D1*Dd*f**2*fd*s - 100*C*D1*Dd*f**2*fd - 80*C*D1*Ddd*f**3*r*s + 20*C*D1*Ddd*f**3*r - 80*C*D1*Ddd*f**3*s**2 + 80*C*D1*Ddd*f**3*s - 20*C*D1*Ddd*f**3 - 240*C*Dd**2*f**3*r*s + 60*C*Dd**2*f**3*r - 240*C*Dd**2*f**3*s**2 + 240*C*Dd**2*f**3*s - 40*C*Dd**2*f**3 - 30*D1**2*K*bdd1*f**2*r*s - 30*D1**2*K*bdd1*f**2*s**2 + 30*D1**2*K*bdd1*f**2*s - 7*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 15*D1**2*bdd1*f**3*r*s + 5*D1**2*bdd1*f**3*r + 15*D1**2*bdd1*f**3*s**2 - 10*D1**2*bdd1*f**3*s - 5*D1**2*bdd1*f**3 + 17*D1**2*bdd1*f**2*r*s - 2*D1**2*bdd1*f**2*r + 17*D1**2*bdd1*f**2*s**2 - 19*D1**2*bdd1*f**2*s + 2*D1**2*bdd1*f**2 + 14*D1**2*bdd1*f*g2*r*s - 14*D1**2*bdd1*f*g2*r + 14*D1**2*bdd1*f*g2*s**2 - 28*D1**2*bdd1*f*g2*s + 14*D1**2*bdd1*f*g2 - 20*D1**2*f**3*fd*r*s + 5*D1**2*f**3*fd*r - 20*D1**2*f**3*fd*s**2 + 20*D1**2*f**3*fd*s - 5*D1**2*f**3*fd - 75*D1**2*f**2*fd*r*s + 25*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 75*D1**2*f**2*fd*s - 25*D1**2*f**2*fd + 45*D1**2*f**2*fdd*r*s - 15*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 45*D1**2*f**2*fdd*s + 15*D1**2*f**2*fdd - 78*D1**2*f**2*gd2*r*s - 78*D1**2*f**2*gd2*s**2 + 78*D1**2*f**2*gd2*s + 60*D1**2*f**2*gdd2*r*s + 60*D1**2*f**2*gdd2*s**2 - 60*D1**2*f**2*gdd2*s + 90*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 90*D1**2*f*fd**2*s + 15*D1**2*f*fd**2 - 156*D1**2*f*fd*g2*r*s + 78*D1**2*f*fd*g2*r - 156*D1**2*f*fd*g2*s**2 + 156*D1**2*f*fd*g2*s - 78*D1**2*f*fd*g2 + 240*D1**2*f*fd*gd2*r*s - 60*D1**2*f*fd*gd2*r + 240*D1**2*f*fd*gd2*s**2 - 240*D1**2*f*fd*gd2*s + 60*D1**2*f*fd*gd2 + 120*D1**2*f*fdd*g2*r*s - 60*D1**2*f*fdd*g2*r + 120*D1**2*f*fdd*g2*s**2 - 120*D1**2*f*fdd*g2*s + 60*D1**2*f*fdd*g2 + 120*D1**2*fd**2*g2*r*s - 60*D1**2*fd**2*g2*r + 120*D1**2*fd**2*g2*s**2 - 120*D1**2*fd**2*g2*s - 20*D1*Dd*f**4*r*s + 5*D1*Dd*f**4*r - 20*D1*Dd*f**4*s**2 + 20*D1*Dd*f**4*s - 5*D1*Dd*f**4 - 100*D1*Dd*f**3*r*s + 25*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 100*D1*Dd*f**3*s - 25*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*r*s - 105*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 360*D1*Dd*f**2*fd*s + 75*D1*Dd*f**2*fd - 312*D1*Dd*f**2*g2*r*s + 78*D1*Dd*f**2*g2*r - 312*D1*Dd*f**2*g2*s**2 + 312*D1*Dd*f**2*g2*s - 78*D1*Dd*f**2*g2 + 480*D1*Dd*f**2*gd2*r*s - 60*D1*Dd*f**2*gd2*r + 480*D1*Dd*f**2*gd2*s**2 - 480*D1*Dd*f**2*gd2*s + 60*D1*Dd*f**2*gd2 + 960*D1*Dd*f*fd*g2*r*s - 360*D1*Dd*f*fd*g2*r + 960*D1*Dd*f*fd*g2*s**2 - 960*D1*Dd*f*fd*g2*s + 240*D1*Dd*f*fd*g2 + 60*D1*Ddd*f**3*r*s - 15*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 240*D1*Ddd*f**2*g2*r*s - 60*D1*Ddd*f**2*g2*r + 240*D1*Ddd*f**2*g2*s**2 - 240*D1*Ddd*f**2*g2*s + 60*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(5*s + 2)*(r + s - 1) + f**2*(4*C*(s - 1)*(r + s - 1) + 5*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + (r + s - 1)*(39*K*s - 20*s + 4)) + f*(fd*(-2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 30*K*(r*(4*s - 1) + (1 - 2*s)**2) + 68*r*s - 19*r + 68*s**2 - 70*s + 17) + (-14*r - 14*s + 14)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 14*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(5*f**2*(24*r*s + r + 4*s*(6*s - 5)) + f*(-2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 30*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 136*r*s - 25*r + 136*s**2 - 144*s + 23) + 14*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 180*Dd**2*f**3*r*s - 45*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 30*Dd**2*f**3 + 720*Dd**2*f**2*g2*r*s - 180*Dd**2*f**2*g2*r + 720*Dd**2*f**2*g2*s**2 - 720*Dd**2*f**2*g2*s + 120*Dd**2*f**2*g2 + 7*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(8*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*s**2 - 4*C*D1**2*f*fd*s - 4*C*D1**2*f*fdd*r*s - 4*C*D1**2*f*fdd*s**2 + 2*C*D1**2*f*fdd*s - 4*C*D1**2*fd**2*r*s - 4*C*D1**2*fd**2*s**2 + 2*C*D1**2*fd**2*s + 16*C*D1*Dd*f**2*r*s - 4*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 16*C*D1*Dd*f**2*s + 4*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r*s + 4*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 24*C*D1*Dd*f*fd*s - 2*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r*s + 2*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 8*C*D1*Ddd*f**2*s - 2*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r*s + 6*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 24*C*Dd**2*f**2*s - 4*C*Dd**2*f**2 + 78*D1**2*K*f*fd*r*s - 39*D1**2*K*f*fd*r + 78*D1**2*K*f*fd*s**2 - 78*D1**2*K*f*fd*s + 39*D1**2*K*f*fd - 60*D1**2*K*f*fdd*r*s + 30*D1**2*K*f*fdd*r - 60*D1**2*K*f*fdd*s**2 + 60*D1**2*K*f*fdd*s - 30*D1**2*K*f*fdd - 60*D1**2*K*fd**2*r*s + 30*D1**2*K*fd**2*r - 60*D1**2*K*fd**2*s**2 + 60*D1**2*K*fd**2*s - 7*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 75*D1**2*f**2*fd*r*s + 35*D1**2*f**2*fd*r - 75*D1**2*f**2*fd*s**2 + 85*D1**2*f**2*fd*s - 35*D1**2*f**2*fd + 45*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 50*D1**2*f**2*fdd*s + 20*D1**2*f**2*fdd + 90*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 100*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 - 40*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 40*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 16*D1**2*f*fd + 34*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r + 34*D1**2*f*fdd*s**2 - 32*D1**2*f*fdd*s + 15*D1**2*f*fdd - 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*s**2 + 28*D1**2*f*gd2*s + 14*D1**2*f*gdd2*r*s + 14*D1**2*f*gdd2*s**2 - 14*D1**2*f*gdd2*s + 34*D1**2*fd**2*r*s - 15*D1**2*fd**2*r + 34*D1**2*fd**2*s**2 - 32*D1**2*fd**2*s - 28*D1**2*fd*g2*r*s - 28*D1**2*fd*g2*s**2 + 28*D1**2*fd*gd2*r*s + 28*D1**2*fd*gd2*s**2 - 14*D1**2*fd*gd2*s + 14*D1**2*fdd*g2*r*s + 14*D1**2*fdd*g2*s**2 + 156*D1*Dd*K*f**2*r*s - 39*D1*Dd*K*f**2*r + 156*D1*Dd*K*f**2*s**2 - 156*D1*Dd*K*f**2*s + 39*D1*Dd*K*f**2 - 480*D1*Dd*K*f*fd*r*s + 180*D1*Dd*K*f*fd*r - 480*D1*Dd*K*f*fd*s**2 + 480*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd - 100*D1*Dd*f**3*r*s + 25*D1*Dd*f**3*r - 100*D1*Dd*f**3*s**2 + 100*D1*Dd*f**3*s - 25*D1*Dd*f**3 + 360*D1*Dd*f**2*fd*r*s - 125*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 380*D1*Dd*f**2*fd*s + 90*D1*Dd*f**2*fd - 80*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r - 80*D1*Dd*f**2*s**2 + 80*D1*Dd*f**2*s - 20*D1*Dd*f**2 + 272*D1*Dd*f*fd*r*s - 94*D1*Dd*f*fd*r + 272*D1*Dd*f*fd*s**2 - 264*D1*Dd*f*fd*s + 62*D1*Dd*f*fd - 112*D1*Dd*f*g2*r*s + 28*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 112*D1*Dd*f*g2*s - 28*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r*s - 14*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 112*D1*Dd*f*gd2*s + 14*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r*s - 14*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 56*D1*Dd*fd*g2*s - 120*D1*Ddd*K*f**2*r*s + 30*D1*Ddd*K*f**2*r - 120*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 30*D1*Ddd*K*f**2 + 60*D1*Ddd*f**3*r*s - 15*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 68*D1*Ddd*f**2*r*s - 17*D1*Ddd*f**2*r + 68*D1*Ddd*f**2*s**2 - 68*D1*Ddd*f**2*s + 17*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r*s - 14*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 56*D1*Ddd*f*g2*s + 14*D1*Ddd*f*g2 + 7*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 360*Dd**2*K*f**2*r*s + 90*Dd**2*K*f**2*r - 360*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 60*Dd**2*K*f**2 + 180*Dd**2*f**3*r*s - 45*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 30*Dd**2*f**3 + 204*Dd**2*f**2*r*s - 51*Dd**2*f**2*r + 204*Dd**2*f**2*s**2 - 204*Dd**2*f**2*s + 34*Dd**2*f**2 + 168*Dd**2*f*g2*r*s - 42*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 168*Dd**2*f*g2*s + 28*Dd**2*f*g2))/(35*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**2*k1**2*k2**3*st**2*(-9*D1**2*bd1**2*f*(2*s - 1)*(-14*K + 8*f + 7)*(r + s - 1) + 9*D1**2*bdd1*f*(3*f*(4*C*(s - 1) + 2*K*s - 3*s + 3) - 28*g2*(s - 1))*(r + s - 1) - 6*D1**2*(f**2*(fd*(2*C + 2)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(6*gd2 + 18*gdd2)*(r + s - 1)) + f*(-fd**2*(10*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*fd*(g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) + 18*fdd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 18*fd**2*g2*(r*(2*s - 1) + s*(2*s - 2))) + D1*bd1*(D1*(-18*f**3*(2*s + 1)*(r + s - 1) - f**2*(r + s - 1)*(174*C*(s - 1) - s*(18*K + 85) + 127) + 3*f*(9*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 6*r - 12*s**2 + 15*s - 3) + (98*g2*(s - 1) + 84*gd2*(1 - 2*s))*(r + s - 1)) - 252*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 9*Dd*f*(3*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 6*D1*f*(Dd*(f**2*(2*C + 2)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(5 - 10*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 6*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 18*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 36*fd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(f*(10*C - 5) - 18*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*Dd**2*f**2*(f*(10*C - 5) - 18*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + b1**2*(D1**2*s*(3*f*(41*fd - 24*fdd)*(2*r + 2*s - 1) - 72*fd**2*(2*r + 2*s - 1) - 7*fd*(21*K - 8)*(r + s) + 63*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(123*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-72*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (56 - 147*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 63*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 8*f + 7)) - 9*Dd**2*f*(-14*K + 8*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-348*C*D1**2*f*fd*r*s - 348*C*D1**2*f*fd*s**2 + 174*C*D1**2*f*fd*s + 216*C*D1**2*f*fdd*r*s + 216*C*D1**2*f*fdd*s**2 - 108*C*D1**2*f*fdd*s + 216*C*D1**2*fd**2*r*s + 216*C*D1**2*fd**2*s**2 - 108*C*D1**2*fd**2*s - 696*C*D1*Dd*f**2*r*s + 174*C*D1*Dd*f**2*r - 696*C*D1*Dd*f**2*s**2 + 696*C*D1*Dd*f**2*s - 174*C*D1*Dd*f**2 + 1728*C*D1*Dd*f*fd*r*s - 216*C*D1*Dd*f*fd*r + 1728*C*D1*Dd*f*fd*s**2 - 1296*C*D1*Dd*f*fd*s + 108*C*D1*Dd*f*fd + 432*C*D1*Ddd*f**2*r*s - 108*C*D1*Ddd*f**2*r + 432*C*D1*Ddd*f**2*s**2 - 432*C*D1*Ddd*f**2*s + 108*C*D1*Ddd*f**2 + 1296*C*Dd**2*f**2*r*s - 324*C*Dd**2*f**2*r + 1296*C*Dd**2*f**2*s**2 - 1296*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 + 36*D1**2*K*f*fd*r*s - 18*D1**2*K*f*fd*r + 36*D1**2*K*f*fd*s**2 - 36*D1**2*K*f*fd*s + 18*D1**2*K*f*fd + 108*D1**2*K*f*fdd*r*s - 54*D1**2*K*f*fdd*r + 108*D1**2*K*f*fdd*s**2 - 108*D1**2*K*f*fdd*s + 54*D1**2*K*f*fdd + 108*D1**2*K*fd**2*r*s - 54*D1**2*K*fd**2*r + 108*D1**2*K*fd**2*s**2 - 108*D1**2*K*fd**2*s - 9*D1**2*bdd1*f*(2*s - 1)*(-14*K + 8*f + 7)*(r + s - 1) - 108*D1**2*f**2*fd*r*s + 54*D1**2*f**2*fd*r - 108*D1**2*f**2*fd*s**2 + 126*D1**2*f**2*fd*s - 54*D1**2*f**2*fd + 170*D1**2*f*fd*r*s + 42*D1**2*f*fd*r + 170*D1**2*f*fd*s**2 - 43*D1**2*f*fd*s - 42*D1**2*f*fd - 162*D1**2*f*fdd*r*s - 162*D1**2*f*fdd*s**2 + 81*D1**2*f*fdd*s + 294*D1**2*f*gd2*r*s + 294*D1**2*f*gd2*s**2 - 294*D1**2*f*gd2*s - 252*D1**2*f*gdd2*r*s - 252*D1**2*f*gdd2*s**2 + 252*D1**2*f*gdd2*s - 162*D1**2*fd**2*r*s - 162*D1**2*fd**2*s**2 + 81*D1**2*fd**2*s + 294*D1**2*fd*g2*r*s + 294*D1**2*fd*g2*s**2 - 504*D1**2*fd*gd2*r*s - 504*D1**2*fd*gd2*s**2 + 252*D1**2*fd*gd2*s - 252*D1**2*fdd*g2*r*s - 252*D1**2*fdd*g2*s**2 + 72*D1*Dd*K*f**2*r*s - 18*D1*Dd*K*f**2*r + 72*D1*Dd*K*f**2*s**2 - 72*D1*Dd*K*f**2*s + 18*D1*Dd*K*f**2 + 864*D1*Dd*K*f*fd*r*s - 324*D1*Dd*K*f*fd*r + 864*D1*Dd*K*f*fd*s**2 - 864*D1*Dd*K*f*fd*s + 216*D1*Dd*K*f*fd - 144*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 144*D1*Dd*f**3*s**2 + 144*D1*Dd*f**3*s - 36*D1*Dd*f**3 + 340*D1*Dd*f**2*r*s - 85*D1*Dd*f**2*r + 340*D1*Dd*f**2*s**2 - 340*D1*Dd*f**2*s + 85*D1*Dd*f**2 - 1296*D1*Dd*f*fd*r*s + 162*D1*Dd*f*fd*r - 1296*D1*Dd*f*fd*s**2 + 972*D1*Dd*f*fd*s - 81*D1*Dd*f*fd + 1176*D1*Dd*f*g2*r*s - 294*D1*Dd*f*g2*r + 1176*D1*Dd*f*g2*s**2 - 1176*D1*Dd*f*g2*s + 294*D1*Dd*f*g2 - 2016*D1*Dd*f*gd2*r*s + 252*D1*Dd*f*gd2*r - 2016*D1*Dd*f*gd2*s**2 + 2016*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 2016*D1*Dd*fd*g2*r*s + 252*D1*Dd*fd*g2*r - 2016*D1*Dd*fd*g2*s**2 + 1008*D1*Dd*fd*g2*s + 216*D1*Ddd*K*f**2*r*s - 54*D1*Ddd*K*f**2*r + 216*D1*Ddd*K*f**2*s**2 - 216*D1*Ddd*K*f**2*s + 54*D1*Ddd*K*f**2 - 324*D1*Ddd*f**2*r*s + 81*D1*Ddd*f**2*r - 324*D1*Ddd*f**2*s**2 + 324*D1*Ddd*f**2*s - 81*D1*Ddd*f**2 - 1008*D1*Ddd*f*g2*r*s + 252*D1*Ddd*f*g2*r - 1008*D1*Ddd*f*g2*s**2 + 1008*D1*Ddd*f*g2*s - 252*D1*Ddd*f*g2 + D1*bd1*(D1*(123*f**2*(2*s - 1)*(r + s - 1) + f*(-72*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + (56 - 147*K)*(2*s - 1)*(r + s - 1)) + 63*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 9*Dd*f*(-14*K + 8*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 648*Dd**2*K*f**2*r*s - 162*Dd**2*K*f**2*r + 648*Dd**2*K*f**2*s**2 - 648*Dd**2*K*f**2*s + 108*Dd**2*K*f**2 - 972*Dd**2*f**2*r*s + 243*Dd**2*f**2*r - 972*Dd**2*f**2*s**2 + 972*Dd**2*f**2*s - 162*Dd**2*f**2 - 3024*Dd**2*f*g2*r*s + 756*Dd**2*f*g2*r - 3024*Dd**2*f*g2*s**2 + 3024*Dd**2*f*g2*s - 504*Dd**2*f*g2))/(105*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**2*k1**2*k2**3*(-3*D1*(21*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + bd1*(D1*(f**2*(r + s - 1)*(24*C*(s - 1) + s*(7*K - 26) + 26) + f*(fd*(30*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (4*g2*(s - 1) + 3*gd2*(2*s - 1))*(-14*r - 14*s + 14)) + 42*fd*g2*(-2*r*s + r - s*(2*s - 2))) + 3*Dd*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + f*(3*D1*bdd1*(s - 1)*(f*(10*C - 5) - 14*g2)*(r + s - 1) + D1*(f*(fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 14*gd2*s*(r + s - 1)) - 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b1**2*(D1**2*s*(9*f*fd*(2*r + 2*s - 1) - (r + s)*(9*K*fdd + 2*fd*(6*K - 5))) + D1*(Dd*(9*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 9*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(6*K - 5)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*(21*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(7*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(24*C - 26)*(2*r + 2*s - 1) + fdd*s*(30*C - 15)*(2*r + 2*s - 1) + s*(-56*gd2 - 42*gdd2)*(r + s - 1)) + s*(fd**2*(30*C - 15)*(2*r + 2*s - 1) - 14*fd*(4*g2*(r + s) + gd2*(6*r + 6*s - 3)) - 42*fdd*g2*(r + s))) + 7*D1*bd1*(D1*(9*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 9*f**2*(2*s - 1)*(r + s - 1) - 2*f*(6*K - 5)*(2*s - 1)*(r + s - 1)) - 9*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*D1*(Dd*(f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(24*C + 7*K - 26) + f*(fd*(30*C - 15)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 56*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 42*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 42*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 3*Ddd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f*(f*(10*C - 5) - 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**2*k1**2*k2*st**4*(7*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(-5*f**3*s*(7*r + 7*s - 5) + f**2*(5*fd*(6*s - 1)*(4*r + 4*s - 3) - s*(4*C*s + r*(4*C + 19) + 19*s - 23)) + f*(fd*(r*(2*C + 13)*(4*s - 1) + s**2*(8*C + 52) - s*(6*C + 54) + 15) + 14*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 14*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(5*f**2*(8*s - 1)*(4*r + 4*s - 3) + f*(r*(2*C + 13)*(8*s - 1) + s**2*(16*C + 104) - s*(8*C + 112) + 15) - 14*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 7*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(-5*f**2*(fd*(7*r*(3*s - 1) + 21*s**2 - 23*s + 7) + fdd*(r*(4 - 12*s) - 12*s**2 + 13*s - 4)) + f*(5*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) - fd*(4*C*(2*s - 1)*(r + s - 1) + 38*r*s - 19*r + 38*s**2 - 34*s + 19) + fdd*(2*C*(2*s - 1)*(r + s - 1) + 26*r*s - 13*r + 26*s**2 - 24*s + 13) + 7*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) + fd**2*(2*C*(2*s - 1)*(r + s - 1) + 13*r*(2*s - 1) + 26*s**2 - 24*s - 2) + 14*fd*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) - 14*fdd*g2*(s - 1)*(r + s - 1)) + 7*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(-35*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(-4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(24*s - 7)*(4*r + 4*s - 3) - 19*r*(4*s - 1) - 19*(1 - 2*s)**2) + 2*f*(fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 13*r*(8*s - 3) + 104*s**2 - 100*s + 25) + 7*g2*r*(8*s - 2) + 14*g2*(1 - 2*s)**2 + 7*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) - 14*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(20*f**2 + f*(2*C + 13) - 14*g2)) + Dd**2*f*(20*f**2 + f*(2*C + 13) - 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(5*bdd1*f**2*s*(4*r + 4*s - 3) - 14*bdd1*g2*s*(r + s) + f*(bdd1*s*(2*C*r + 2*C*s + 13*r + 13*s - 15) - 9*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(-9*f*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**2*k1**2*k2*st**2*(252*C*D1**2*f**2*fd*r*s - 84*C*D1**2*f**2*fd*r + 252*C*D1**2*f**2*fd*s**2 - 252*C*D1**2*f**2*fd*s + 84*C*D1**2*f**2*fd - 180*C*D1**2*f**2*fdd*r*s + 60*C*D1**2*f**2*fdd*r - 180*C*D1**2*f**2*fdd*s**2 + 180*C*D1**2*f**2*fdd*s - 60*C*D1**2*f**2*fdd - 360*C*D1**2*f*fd**2*r*s + 120*C*D1**2*f*fd**2*r - 360*C*D1**2*f*fd**2*s**2 + 360*C*D1**2*f*fd**2*s - 60*C*D1**2*f*fd**2 + 336*C*D1*Dd*f**3*r*s - 84*C*D1*Dd*f**3*r + 336*C*D1*Dd*f**3*s**2 - 336*C*D1*Dd*f**3*s + 84*C*D1*Dd*f**3 - 1440*C*D1*Dd*f**2*fd*r*s + 420*C*D1*Dd*f**2*fd*r - 1440*C*D1*Dd*f**2*fd*s**2 + 1440*C*D1*Dd*f**2*fd*s - 300*C*D1*Dd*f**2*fd - 240*C*D1*Ddd*f**3*r*s + 60*C*D1*Ddd*f**3*r - 240*C*D1*Ddd*f**3*s**2 + 240*C*D1*Ddd*f**3*s - 60*C*D1*Ddd*f**3 - 720*C*Dd**2*f**3*r*s + 180*C*Dd**2*f**3*r - 720*C*Dd**2*f**3*s**2 + 720*C*Dd**2*f**3*s - 120*C*Dd**2*f**3 + D1**2*bd1**2*(18*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 3) + 7*f*(r*(C*(4*s - 2) + 12*K*s + 8*s - 7) + s**2*(4*C + 12*K + 8) - s*(4*C + 6*K + 20) + 9) - 70*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*D1**2*bdd1*f*(3*f*(r*(-4*C*s + 6*K*s + 3) + s**2*(-4*C + 6*K) - s*(6*K - 6) - 3) + 28*g2*s*(r + s)) - 54*D1**2*bdd2*f**2*r*s - 54*D1**2*bdd2*f**2*s**2 + 54*D1**2*bdd2*f**2*s - 72*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r - 72*D1**2*f**2*fd*s**2 + 72*D1**2*f**2*fd*s - 24*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r*s - 30*D1**2*f**2*fdd*r + 90*D1**2*f**2*fdd*s**2 - 90*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s + 108*D1**2*f**2*gdd2*r*s + 108*D1**2*f**2*gdd2*s**2 - 108*D1**2*f**2*gdd2*s + 180*D1**2*f*fd**2*r*s - 60*D1**2*f*fd**2*r + 180*D1**2*f*fd**2*s**2 - 180*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 432*D1**2*f*fd*gd2*r*s - 108*D1**2*f*fd*gd2*r + 432*D1**2*f*fd*gd2*s**2 - 432*D1**2*f*fd*gd2*s + 108*D1**2*f*fd*gd2 + 216*D1**2*f*fdd*g2*r*s - 108*D1**2*f*fdd*g2*r + 216*D1**2*f*fdd*g2*s**2 - 216*D1**2*f*fdd*g2*s + 108*D1**2*f*fdd*g2 + 216*D1**2*fd**2*g2*r*s - 108*D1**2*fd**2*g2*r + 216*D1**2*fd**2*g2*s**2 - 216*D1**2*fd**2*g2*s - 96*D1*Dd*f**3*r*s + 24*D1*Dd*f**3*r - 96*D1*Dd*f**3*s**2 + 96*D1*Dd*f**3*s - 24*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r*s - 210*D1*Dd*f**2*fd*r + 720*D1*Dd*f**2*fd*s**2 - 720*D1*Dd*f**2*fd*s + 150*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r*s + 132*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 + 864*D1*Dd*f**2*gd2*r*s - 108*D1*Dd*f**2*gd2*r + 864*D1*Dd*f**2*gd2*s**2 - 864*D1*Dd*f**2*gd2*s + 108*D1*Dd*f**2*gd2 + 1728*D1*Dd*f*fd*g2*r*s - 648*D1*Dd*f*fd*g2*r + 1728*D1*Dd*f*fd*g2*s**2 - 1728*D1*Dd*f*fd*g2*s + 432*D1*Dd*f*fd*g2 + 120*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 120*D1*Ddd*f**3*s**2 - 120*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + 432*D1*Ddd*f**2*g2*r*s - 108*D1*Ddd*f**2*g2*r + 432*D1*Ddd*f**2*g2*s**2 - 432*D1*Ddd*f**2*g2*s + 108*D1*Ddd*f**2*g2 + D1*bd1*(D1*(18*f**3*s*(3*r + 3*s - 2) + f**2*(r*(s*(-30*C + 66*K + 14) + 47) + s**2*(-30*C + 66*K + 14) + s*(52 - 66*K) - 47) - 3*f*(3*fd*(-16*C*s**2 + 12*C*s + 6*K*(r*(4*s - 1) + (1 - 2*s)**2) + r*(-16*C*s + 4*C + 3) + 6*s - 3) + 14*s*(g2*(r + s) + gd2*(4*r + 4*s - 2))) - 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 6*Dd*f*(9*K*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 6*f*r*(-8*C*s + C + 3) - 6*f*(2*s - 1)*(4*C*s - 3) + 14*g2*r*(8*s - 1) + 56*g2*s*(2*s - 1))) + 6*D1*bd2*f*(D1*(11*f*s*(r + s - 1) - 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 360*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 360*Dd**2*f**3*s**2 - 360*Dd**2*f**3*s + 60*Dd**2*f**3 + 1296*Dd**2*f**2*g2*r*s - 324*Dd**2*f**2*g2*r + 1296*Dd**2*f**2*g2*s**2 - 1296*Dd**2*f**2*g2*s + 216*Dd**2*f**2*g2 - 35*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(-28*C*D1**2*fd*r*s - 28*C*D1**2*fd*s**2 + 28*C*D1**2*fd*s + 14*C*D1**2*fdd*r*s + 14*C*D1**2*fdd*s**2 - 14*C*D1**2*fdd*s - 112*C*D1*Dd*f*r*s + 28*C*D1*Dd*f*r - 112*C*D1*Dd*f*s**2 + 112*C*D1*Dd*f*s - 28*C*D1*Dd*f + 112*C*D1*Dd*fd*r*s - 14*C*D1*Dd*fd*r + 112*C*D1*Dd*fd*s**2 - 112*C*D1*Dd*fd*s + 14*C*D1*Dd*fd + 56*C*D1*Ddd*f*r*s - 14*C*D1*Ddd*f*r + 56*C*D1*Ddd*f*s**2 - 56*C*D1*Ddd*f*s + 14*C*D1*Ddd*f + 168*C*Dd**2*f*r*s - 42*C*Dd**2*f*r + 168*C*Dd**2*f*s**2 - 168*C*Dd**2*f*s + 28*C*Dd**2*f + 21*D1**2*K*fd*r*s - 21*D1**2*K*fd*r + 21*D1**2*K*fd*s**2 - 42*D1**2*K*fd*s + 21*D1**2*K*fd + 42*D1**2*K*fdd*r*s - 42*D1**2*K*fdd*r + 42*D1**2*K*fdd*s**2 - 84*D1**2*K*fdd*s + 42*D1**2*K*fdd + 35*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 144*D1**2*f*fd*r*s - 51*D1**2*f*fd*r - 144*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s + 51*D1**2*f*fd + 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r + 72*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 36*D1**2*f*fdd + 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r + 72*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s - 36*D1**2*fd**2 - 91*D1**2*fd*r*s + 28*D1**2*fd*r - 91*D1**2*fd*s**2 + 28*D1**2*fd*s - 28*D1**2*fd + 28*D1**2*fdd*r*s + 21*D1**2*fdd*r + 28*D1**2*fdd*s**2 + 56*D1**2*fdd*s - 21*D1**2*fdd + 140*D1**2*gd2*r*s + 140*D1**2*gd2*s**2 - 140*D1**2*gd2*s - 70*D1**2*gdd2*r*s - 70*D1**2*gdd2*s**2 + 70*D1**2*gdd2*s + 84*D1*Dd*K*f*r*s - 21*D1*Dd*K*f*r + 84*D1*Dd*K*f*s**2 - 84*D1*Dd*K*f*s + 21*D1*Dd*K*f + 336*D1*Dd*K*fd*r*s - 210*D1*Dd*K*fd*r + 336*D1*Dd*K*fd*s**2 - 504*D1*Dd*K*fd*s + 168*D1*Dd*K*fd - 288*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 288*D1*Dd*f**2*s**2 + 288*D1*Dd*f**2*s - 72*D1*Dd*f**2 + 576*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*r + 576*D1*Dd*f*fd*s**2 - 216*D1*Dd*f*fd*s - 90*D1*Dd*f*fd - 364*D1*Dd*f*r*s + 91*D1*Dd*f*r - 364*D1*Dd*f*s**2 + 364*D1*Dd*f*s - 91*D1*Dd*f + 224*D1*Dd*fd*r*s + 56*D1*Dd*fd*r + 224*D1*Dd*fd*s**2 + 112*D1*Dd*fd*s - 98*D1*Dd*fd + 560*D1*Dd*g2*r*s - 140*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 560*D1*Dd*g2*s + 140*D1*Dd*g2 - 560*D1*Dd*gd2*r*s + 70*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 560*D1*Dd*gd2*s - 70*D1*Dd*gd2 + 168*D1*Ddd*K*f*r*s - 42*D1*Ddd*K*f*r + 168*D1*Ddd*K*f*s**2 - 168*D1*Ddd*K*f*s + 42*D1*Ddd*K*f + 144*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 144*D1*Ddd*f**2*s**2 - 144*D1*Ddd*f**2*s + 36*D1*Ddd*f**2 + 112*D1*Ddd*f*r*s - 28*D1*Ddd*f*r + 112*D1*Ddd*f*s**2 - 112*D1*Ddd*f*s + 28*D1*Ddd*f - 280*D1*Ddd*g2*r*s + 70*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 280*D1*Ddd*g2*s - 70*D1*Ddd*g2 - 35*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 504*Dd**2*K*f*r*s - 126*Dd**2*K*f*r + 504*Dd**2*K*f*s**2 - 504*Dd**2*K*f*s + 84*Dd**2*K*f + 432*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 432*Dd**2*f**2*s**2 - 432*Dd**2*f**2*s + 72*Dd**2*f**2 + 336*Dd**2*f*r*s - 84*Dd**2*f*r + 336*Dd**2*f*s**2 - 336*Dd**2*f*s + 56*Dd**2*f - 840*Dd**2*g2*r*s + 210*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 840*Dd**2*g2*s - 140*Dd**2*g2) + b1*(-60*C*D1**2*f*fd*r*s + 30*C*D1**2*f*fd*r - 60*C*D1**2*f*fd*s**2 + 90*C*D1**2*f*fd*s - 30*C*D1**2*f*fd + 72*C*D1**2*f*fdd*r*s - 36*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s**2 - 108*C*D1**2*f*fdd*s + 36*C*D1**2*f*fdd + 72*C*D1**2*fd**2*r*s - 36*C*D1**2*fd**2*r + 72*C*D1**2*fd**2*s**2 - 108*C*D1**2*fd**2*s + 36*C*D1**2*fd**2 - 120*C*D1*Dd*f**2*r*s + 30*C*D1*Dd*f**2*r - 120*C*D1*Dd*f**2*s**2 + 120*C*D1*Dd*f**2*s - 30*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r*s - 216*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 180*C*D1*Dd*f*fd + 144*C*D1*Ddd*f**2*r*s - 36*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r*s - 108*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 + 132*D1**2*K*f*fd*r*s - 66*D1**2*K*f*fd*r + 132*D1**2*K*f*fd*s**2 - 132*D1**2*K*f*fd*s + 66*D1**2*K*f*fd - 108*D1**2*K*f*fdd*r*s + 54*D1**2*K*f*fdd*r - 108*D1**2*K*f*fdd*s**2 + 108*D1**2*K*f*fdd*s - 54*D1**2*K*f*fdd - 108*D1**2*K*fd**2*r*s + 54*D1**2*K*fd**2*r - 108*D1**2*K*fd**2*s**2 + 108*D1**2*K*fd**2*s + 35*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(18*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 4) + 7*f*(C*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 12*K*s**2 - 6*K*s + r*(12*K*s + 8*s - 7) + 8*s**2 - 20*s + 7) - 70*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 162*D1**2*f**2*fd*r*s - 54*D1**2*f**2*fd*r + 162*D1**2*f**2*fd*s**2 - 180*D1**2*f**2*fd*s + 54*D1**2*f**2*fd + 28*D1**2*f*fd*r*s - 61*D1**2*f*fd*r + 28*D1**2*f*fd*s**2 - 94*D1**2*f*fd*s + 61*D1**2*f*fd + 27*D1**2*f*fdd*r + 54*D1**2*f*fdd*s - 27*D1**2*f*fdd - 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*s**2 + 42*D1**2*f*gd2*s - 84*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s + 27*D1**2*fd**2*r + 54*D1**2*fd**2*s - 27*D1**2*fd**2 - 42*D1**2*fd*g2*r*s + 42*D1**2*fd*g2*r - 42*D1**2*fd*g2*s**2 + 84*D1**2*fd*g2*s - 42*D1**2*fd*g2 - 168*D1**2*fd*gd2*r*s + 84*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 252*D1**2*fd*gd2*s - 84*D1**2*fd*gd2 - 84*D1**2*fdd*g2*r*s + 84*D1**2*fdd*g2*r - 84*D1**2*fdd*g2*s**2 + 168*D1**2*fdd*g2*s - 84*D1**2*fdd*g2 + 264*D1*Dd*K*f**2*r*s - 66*D1*Dd*K*f**2*r + 264*D1*Dd*K*f**2*s**2 - 264*D1*Dd*K*f**2*s + 66*D1*Dd*K*f**2 - 864*D1*Dd*K*f*fd*r*s + 324*D1*Dd*K*f*fd*r - 864*D1*Dd*K*f*fd*s**2 + 864*D1*Dd*K*f*fd*s - 216*D1*Dd*K*f*fd + 216*D1*Dd*f**3*r*s - 54*D1*Dd*f**3*r + 216*D1*Dd*f**3*s**2 - 216*D1*Dd*f**3*s + 54*D1*Dd*f**3 + 56*D1*Dd*f**2*r*s - 14*D1*Dd*f**2*r + 56*D1*Dd*f**2*s**2 - 56*D1*Dd*f**2*s + 14*D1*Dd*f**2 + 108*D1*Dd*f*fd*r + 216*D1*Dd*f*fd*s - 108*D1*Dd*f*fd - 168*D1*Dd*f*g2*r*s + 42*D1*Dd*f*g2*r - 168*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 42*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r*s + 84*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 672*D1*Dd*f*gd2*s - 84*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r*s + 420*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 1008*D1*Dd*fd*g2*s - 336*D1*Dd*fd*g2 - 216*D1*Ddd*K*f**2*r*s + 54*D1*Ddd*K*f**2*r - 216*D1*Ddd*K*f**2*s**2 + 216*D1*Ddd*K*f**2*s - 54*D1*Ddd*K*f**2 - 336*D1*Ddd*f*g2*r*s + 84*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 336*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + D1*bd1*(D1*(-3*f**2*(r*(48*s - 41) + 48*s**2 - 94*s + 41) + f*(-28*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 18*fd*(4*s - 1)*(4*r + 4*s - 3) + 7*r*(s*(6*K - 26) + 9) + 7*s**2*(6*K - 26) + 7*s*(35 - 3*K) - 63) + 7*fd*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + 6*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 16*r*s - r + 16*s**2 - 4*s - 5) + 70*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 70*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(9*f**2*(4*r*(8*s - 5) + 32*s**2 - 52*s + 17) + 7*f*(2*C*r*(8*s - 3) + 4*C*(1 - 2*s)**2 + K*(6*r*(8*s - 1) + 48*s**2 - 36*s + 3) + 32*r*s - 18*r + 32*s**2 - 56*s + 17) - 70*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 648*Dd**2*K*f**2*r*s + 162*Dd**2*K*f**2*r - 648*Dd**2*K*f**2*s**2 + 648*Dd**2*K*f**2*s - 108*Dd**2*K*f**2 - 1008*Dd**2*f*g2*r*s + 252*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1008*Dd**2*f*g2*s - 168*Dd**2*f*g2) + 6*b2*(D1**2*(f*(11*fd - 9*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 9*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**2*k1**2*k2*(D1*(-7*D1*bd1**2*(9*K*f*(2*s - 1)*(r + s - 1) - f*(12*C - 9)*(r*(2*s - 1) + s*(2*s - 2)) + 20*g2*(r*(2*s - 1) + s*(2*s - 2))) + 7*b2*(bd1*(D1*(8*f*(s - 1)*(r + s - 1) + 9*fd*(-2*r*s + r - s*(2*s - 2))) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + bd1*(-63*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(3*f**2*(r + s - 1)*(32*C*(s - 1) - s*(7*K + 2) + 2) + f*(-fd*(90*C - 45)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (-8*g2*(s - 1) + 9*gd2*(2*s - 1))*(14*r + 14*s - 14)) + 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 9*Dd*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(f*(10*C - 5) - 14*g2)*(r + s - 1) + D1*(f*(fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(7*bd2 - 14*gd2)*(r + s - 1)) - 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b1**3*(D1**2*s*(7*fd - 6*fdd)*(r + s - 1) + D1*Dd*(7*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + (25*K - 20)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(-10*K + 6*f + 5) - Dd**2*(-10*K + 6*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(6*C*D1**2*fd*r*s + 6*C*D1**2*fd*s**2 - 6*C*D1**2*fd*s + 12*C*D1**2*fdd*r*s + 12*C*D1**2*fdd*s**2 - 12*C*D1**2*fdd*s + 24*C*D1*Dd*f*r*s - 6*C*D1*Dd*f*r + 24*C*D1*Dd*f*s**2 - 24*C*D1*Dd*f*s + 6*C*D1*Dd*f + 96*C*D1*Dd*fd*r*s - 12*C*D1*Dd*fd*r + 96*C*D1*Dd*fd*s**2 - 96*C*D1*Dd*fd*s + 12*C*D1*Dd*fd + 48*C*D1*Ddd*f*r*s - 12*C*D1*Ddd*f*r + 48*C*D1*Ddd*f*s**2 - 48*C*D1*Ddd*f*s + 12*C*D1*Ddd*f + 144*C*Dd**2*f*r*s - 36*C*Dd**2*f*r + 144*C*Dd**2*f*s**2 - 144*C*Dd**2*f*s + 24*C*Dd**2*f + 8*D1**2*K*fd*r*s + 8*D1**2*K*fd*s**2 - 9*D1**2*K*fdd*r*s - 9*D1**2*K*fdd*s**2 - D1**2*bdd1*(-10*K + 6*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 12*D1**2*f*fd*r*s + 3*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 - 3*D1**2*f*fd*s - 3*D1**2*f*fd + 3*D1**2*fd*r*s + 3*D1**2*fd*s**2 + 7*D1**2*fd*s - 9*D1**2*fdd*r*s - 9*D1**2*fdd*s**2 + 9*D1**2*fdd*s - 50*D1**2*gd2*r*s - 50*D1**2*gd2*s**2 + 50*D1**2*gd2*s - 20*D1**2*gdd2*r*s - 20*D1**2*gdd2*s**2 + 20*D1**2*gdd2*s + 32*D1*Dd*K*f*r*s - 8*D1*Dd*K*f*r + 32*D1*Dd*K*f*s**2 - 32*D1*Dd*K*f*s + 8*D1*Dd*K*f - 72*D1*Dd*K*fd*r*s + 9*D1*Dd*K*fd*r - 72*D1*Dd*K*fd*s**2 + 36*D1*Dd*K*fd*s + 24*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 6*D1*Dd*f**2 + 12*D1*Dd*f*r*s - 3*D1*Dd*f*r + 12*D1*Dd*f*s**2 - 12*D1*Dd*f*s + 3*D1*Dd*f - 72*D1*Dd*fd*r*s + 9*D1*Dd*fd*r - 72*D1*Dd*fd*s**2 + 72*D1*Dd*fd*s - 9*D1*Dd*fd - 200*D1*Dd*g2*r*s + 50*D1*Dd*g2*r - 200*D1*Dd*g2*s**2 + 200*D1*Dd*g2*s - 50*D1*Dd*g2 - 160*D1*Dd*gd2*r*s + 20*D1*Dd*gd2*r - 160*D1*Dd*gd2*s**2 + 160*D1*Dd*gd2*s - 20*D1*Dd*gd2 - 36*D1*Ddd*K*f*r*s + 9*D1*Ddd*K*f*r - 36*D1*Ddd*K*f*s**2 + 36*D1*Ddd*K*f*s - 9*D1*Ddd*K*f - 36*D1*Ddd*f*r*s + 9*D1*Ddd*f*r - 36*D1*Ddd*f*s**2 + 36*D1*Ddd*f*s - 9*D1*Ddd*f - 80*D1*Ddd*g2*r*s + 20*D1*Ddd*g2*r - 80*D1*Ddd*g2*s**2 + 80*D1*Ddd*g2*s - 20*D1*Ddd*g2 + D1*bd1*(D1*(7*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 6*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + (25*K - 20)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(-10*K + 6*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 108*Dd**2*K*f*r*s + 27*Dd**2*K*f*r - 108*Dd**2*K*f*s**2 + 108*Dd**2*K*f*s - 18*Dd**2*K*f - 108*Dd**2*f*r*s + 27*Dd**2*f*r - 108*Dd**2*f*s**2 + 108*Dd**2*f*s - 18*Dd**2*f - 240*Dd**2*g2*r*s + 60*Dd**2*g2*r - 240*Dd**2*g2*s**2 + 240*Dd**2*g2*s - 40*Dd**2*g2) - b1*(-192*C*D1**2*f*fd*r*s - 192*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s + 180*C*D1**2*f*fdd*r*s + 180*C*D1**2*f*fdd*s**2 - 90*C*D1**2*f*fdd*s + 180*C*D1**2*fd**2*r*s + 180*C*D1**2*fd**2*s**2 - 90*C*D1**2*fd**2*s - 384*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r - 384*C*D1*Dd*f**2*s**2 + 384*C*D1*Dd*f**2*s - 96*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r*s - 180*C*D1*Dd*f*fd*r + 1440*C*D1*Dd*f*fd*s**2 - 1080*C*D1*Dd*f*fd*s + 90*C*D1*Dd*f*fd + 360*C*D1*Ddd*f**2*r*s - 90*C*D1*Ddd*f**2*r + 360*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 90*C*D1*Ddd*f**2 + 1080*C*Dd**2*f**2*r*s - 270*C*Dd**2*f**2*r + 1080*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 180*C*Dd**2*f**2 + 42*D1**2*K*f*fd*r*s - 21*D1**2*K*f*fd*r + 42*D1**2*K*f*fd*s**2 - 42*D1**2*K*f*fd*s + 21*D1**2*K*f*fd - 56*D1**2*b2*fd*r*s - 56*D1**2*b2*fd*s**2 + 63*D1**2*b2*fdd*r*s + 63*D1**2*b2*fdd*s**2 + 7*D1**2*bd1**2*(-10*K + 6*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 56*D1**2*bd2*f*r*s - 56*D1**2*bd2*f*s**2 + 56*D1**2*bd2*f*s + 126*D1**2*bd2*fd*r*s + 126*D1**2*bd2*fd*s**2 - 63*D1**2*bd2*fd*s - 7*D1**2*bdd1*(3*f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) - 3*K*(2*s - 1)*(r + s - 1) - 6*r*s + 3*r - 6*s**2 + 6*s - 3) - 20*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 63*D1**2*bdd2*f*r*s + 63*D1**2*bdd2*f*s**2 - 63*D1**2*bdd2*f*s + 12*D1**2*f*fd*r*s + 12*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s - 90*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*s**2 + 45*D1**2*f*fdd*s + 112*D1**2*f*gd2*r*s + 112*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s - 126*D1**2*f*gdd2*r*s - 126*D1**2*f*gdd2*s**2 + 126*D1**2*f*gdd2*s - 90*D1**2*fd**2*r*s - 90*D1**2*fd**2*s**2 + 45*D1**2*fd**2*s + 112*D1**2*fd*g2*r*s + 112*D1**2*fd*g2*s**2 - 252*D1**2*fd*gd2*r*s - 252*D1**2*fd*gd2*s**2 + 126*D1**2*fd*gd2*s - 126*D1**2*fdd*g2*r*s - 126*D1**2*fdd*g2*s**2 + 84*D1*Dd*K*f**2*r*s - 21*D1*Dd*K*f**2*r + 84*D1*Dd*K*f**2*s**2 - 84*D1*Dd*K*f**2*s + 21*D1*Dd*K*f**2 - 224*D1*Dd*b2*f*r*s + 56*D1*Dd*b2*f*r - 224*D1*Dd*b2*f*s**2 + 224*D1*Dd*b2*f*s - 56*D1*Dd*b2*f + 504*D1*Dd*b2*fd*r*s - 63*D1*Dd*b2*fd*r + 504*D1*Dd*b2*fd*s**2 - 252*D1*Dd*b2*fd*s + 504*D1*Dd*bd2*f*r*s - 63*D1*Dd*bd2*f*r + 504*D1*Dd*bd2*f*s**2 - 504*D1*Dd*bd2*f*s + 63*D1*Dd*bd2*f + 24*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 720*D1*Dd*f*fd*r*s + 90*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 540*D1*Dd*f*fd*s - 45*D1*Dd*f*fd + 448*D1*Dd*f*g2*r*s - 112*D1*Dd*f*g2*r + 448*D1*Dd*f*g2*s**2 - 448*D1*Dd*f*g2*s + 112*D1*Dd*f*g2 - 1008*D1*Dd*f*gd2*r*s + 126*D1*Dd*f*gd2*r - 1008*D1*Dd*f*gd2*s**2 + 1008*D1*Dd*f*gd2*s - 126*D1*Dd*f*gd2 - 1008*D1*Dd*fd*g2*r*s + 126*D1*Dd*fd*g2*r - 1008*D1*Dd*fd*g2*s**2 + 504*D1*Dd*fd*g2*s + 252*D1*Ddd*b2*f*r*s - 63*D1*Ddd*b2*f*r + 252*D1*Ddd*b2*f*s**2 - 252*D1*Ddd*b2*f*s + 63*D1*Ddd*b2*f - 180*D1*Ddd*f**2*r*s + 45*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 504*D1*Ddd*f*g2*r*s + 126*D1*Ddd*f*g2*r - 504*D1*Ddd*f*g2*s**2 + 504*D1*Ddd*f*g2*s - 126*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(12*C*fd*(r*(4*s - 1) + (1 - 2*s)**2) + 3*f**2*(4*s - 3)*(r + s - 1) + f*(6*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 8*K*(2*s - 1)*(r + s - 1) + 6*r*s - 3*r + 6*s**2 - 16*s + 3) - 9*fd*(r*(K + 1)*(4*s - 1) + s**2*(4*K + 4) - s*(3*K + 4) + 1) - 50*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 20*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*(3*f*(8*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 3*K*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) - 6*r*(8*s - 3) - 12*(1 - 2*s)**2) - 40*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 756*Dd**2*b2*f*r*s - 189*Dd**2*b2*f*r + 756*Dd**2*b2*f*s**2 - 756*Dd**2*b2*f*s + 126*Dd**2*b2*f - 540*Dd**2*f**2*r*s + 135*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 90*Dd**2*f**2 - 1512*Dd**2*f*g2*r*s + 378*Dd**2*f*g2*r - 1512*Dd**2*f*g2*s**2 + 1512*Dd**2*f*g2*s - 252*Dd**2*f*g2))/(105*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**2*k1**2*st**2*(D1*f*(3*D1*bd1**2*s*(6*f + 7)*(2*r + 2*s - 1) + D1*bd1*(-11*f*s*(r + s) + 9*fd*(r*(4*s - 1) + s*(4*s - 3))) + 9*D1*bdd1*f*s*(r + s) + 9*Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + b1**2*(D1**2*(r + s - 1)*(18*fd**2*(2*s - 1) + fd*(f*(15 - 30*s) - 7*s + 7) + 3*fdd*(12*f*s - 6*f + 7*s - 7)) + D1*(Dd*(-15*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(18*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) - 7*r*(4*s - 1) - 7*(1 - 2*s)**2) + 21*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 3*Ddd*f*(6*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd**2*f*(6*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(18*bdd1*f**2*s*(2*r + 2*s - 1) + f*(21*bdd1*s*(2*r + 2*s - 1) - 11*fd*(2*s - 1)*(r + s - 1) + 9*fdd*(2*s - 1)*(r + s - 1)) + 9*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-f*s*(15*f + 7)*(2*r + 2*s - 1) + 3*fd*(6*f*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + 28*r*s - 14*r + 28*s**2 - 35*s + 7)) + 3*Dd*f*(6*f + 7)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*f*(Dd*(-11*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 9*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2*k3) + D1**2*Pkd2*Pkd3*ct**2*k1**2*(3*D1**2*bd1**2*f*(r*(2*s - 1) + s*(2*s - 2)) + D1*b1*(D1*bd1**2*(3*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 3*D1*bdd1*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + bd1*(D1*(f*(-2*r*s + r - 2*s**2 + 2*s - 1) + 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*Dd*f*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + b1**3*(-D1**2*s*(fd - 3*fdd)*(r + s - 1) + D1*Dd*(f*(-4*r*s + r - (1 - 2*s)**2) + 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 5*r*(4*s - 1) + 5*(1 - 2*s)**2) + D1*Ddd*(3*f + 5)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(3*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(D1**2*bdd1*(3*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - D1**2*fd*r*s - D1**2*fd*s**2 + D1**2*fd*s + 3*D1**2*fdd*r*s + 3*D1**2*fdd*s**2 - 3*D1**2*fdd*s - 4*D1*Dd*f*r*s + D1*Dd*f*r - 4*D1*Dd*f*s**2 + 4*D1*Dd*f*s - D1*Dd*f + 24*D1*Dd*fd*r*s - 3*D1*Dd*fd*r + 24*D1*Dd*fd*s**2 - 24*D1*Dd*fd*s + 3*D1*Dd*fd + 12*D1*Ddd*f*r*s - 3*D1*Ddd*f*r + 12*D1*Ddd*f*s**2 - 12*D1*Ddd*f*s + 3*D1*Ddd*f + D1*bd1*(D1*(f*(-3*r*s + r - 3*s**2 + 3*s - 1) + 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + 15*r*s - 5*r + 15*s**2 - 15*s + 5) + Dd*(3*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 36*Dd**2*f*r*s - 9*Dd**2*f*r + 36*Dd**2*f*s**2 - 36*Dd**2*f*s + 6*Dd**2*f))/(15*d**2*k2*k3) + D1**2*Pkd2*Pkd3*ct**2*k2**5*st**4*(D1**2*(f**2*(-fd*(4*C - 2)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(2*C - 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(3*K*(-2*bd1 + bdd1) + 12*gd2 - 6*gdd2)) + f*(fd**2*(2*C - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 3*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) - 3*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 3*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(2 - 4*C)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(3*K*(b1*r*(2 - 8*s) - 2*b1*(1 - 2*s)**2 + bd1*r*(8*s - 1) + 8*bd1*s**2 - 8*bd1*s + bd1) + fd*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 12*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 6*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 6*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(3*K*b1 + f*(2*C - 1) - 6*g2)) + Dd**2*f**2*(3*K*b1 + f*(2*C - 1) - 6*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(7*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**2*k2**5*st**2*(24*C*D1**2*b1*f*fd*r*s + 24*C*D1**2*b1*f*fd*s**2 - 12*C*D1**2*b1*f*fd*s - 12*C*D1**2*b1*f*fdd*r*s - 12*C*D1**2*b1*f*fdd*s**2 + 6*C*D1**2*b1*f*fdd*s - 12*C*D1**2*b1*fd**2*r*s - 12*C*D1**2*b1*fd**2*s**2 + 6*C*D1**2*b1*fd**2*s - 18*C*D1**2*f**2*fd*r*s + 6*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 18*C*D1**2*f**2*fd*s - 6*C*D1**2*f**2*fd + 48*C*D1*Dd*b1*f**2*r*s - 12*C*D1*Dd*b1*f**2*r + 48*C*D1*Dd*b1*f**2*s**2 - 48*C*D1*Dd*b1*f**2*s + 12*C*D1*Dd*b1*f**2 - 96*C*D1*Dd*b1*f*fd*r*s + 12*C*D1*Dd*b1*f*fd*r - 96*C*D1*Dd*b1*f*fd*s**2 + 72*C*D1*Dd*b1*f*fd*s - 6*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r*s + 6*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 24*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 24*C*D1*Ddd*b1*f**2*r*s + 6*C*D1*Ddd*b1*f**2*r - 24*C*D1*Ddd*b1*f**2*s**2 + 24*C*D1*Ddd*b1*f**2*s - 6*C*D1*Ddd*b1*f**2 - 72*C*Dd**2*b1*f**2*r*s + 18*C*Dd**2*b1*f**2*r - 72*C*Dd**2*b1*f**2*s**2 + 72*C*Dd**2*b1*f**2*s - 12*C*Dd**2*b1*f**2 + 14*D1**2*K*b1**2*fd*r*s + 14*D1**2*K*b1**2*fd*s**2 - 7*D1**2*K*b1**2*fdd*r*s - 7*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r*s + 7*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 7*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 12*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*s**2 + 6*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*s**2 - 3*D1**2*b1*f*fdd*s - 28*D1**2*b1*f*gd2*r*s - 28*D1**2*b1*f*gd2*s**2 + 28*D1**2*b1*f*gd2*s + 14*D1**2*b1*f*gdd2*r*s + 14*D1**2*b1*f*gdd2*s**2 - 14*D1**2*b1*f*gdd2*s + 6*D1**2*b1*fd**2*r*s + 6*D1**2*b1*fd**2*s**2 - 3*D1**2*b1*fd**2*s - 28*D1**2*b1*fd*g2*r*s - 28*D1**2*b1*fd*g2*s**2 + 28*D1**2*b1*fd*gd2*r*s + 28*D1**2*b1*fd*gd2*s**2 - 14*D1**2*b1*fd*gd2*s + 14*D1**2*b1*fdd*g2*r*s + 14*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(6*C - 3)*(s - 1) - 14*g2*(s - 1)) + 9*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 9*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r*s + 14*D1**2*f**2*gd2*s**2 - 14*D1**2*f**2*gd2*s + 28*D1**2*f*fd*g2*r*s - 14*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 56*D1*Dd*K*b1**2*f*r*s - 14*D1*Dd*K*b1**2*f*r + 56*D1*Dd*K*b1**2*f*s**2 - 56*D1*Dd*K*b1**2*f*s + 14*D1*Dd*K*b1**2*f - 56*D1*Dd*K*b1**2*fd*r*s + 7*D1*Dd*K*b1**2*fd*r - 56*D1*Dd*K*b1**2*fd*s**2 + 28*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r*s + 7*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 28*D1*Dd*K*b1*f**2*s - 7*D1*Dd*K*b1*f**2 - 24*D1*Dd*b1*f**2*r*s + 6*D1*Dd*b1*f**2*r - 24*D1*Dd*b1*f**2*s**2 + 24*D1*Dd*b1*f**2*s - 6*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r*s - 6*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 36*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 112*D1*Dd*b1*f*g2*r*s + 28*D1*Dd*b1*f*g2*r - 112*D1*Dd*b1*f*g2*s**2 + 112*D1*Dd*b1*f*g2*s - 28*D1*Dd*b1*f*g2 + 112*D1*Dd*b1*f*gd2*r*s - 14*D1*Dd*b1*f*gd2*r + 112*D1*Dd*b1*f*gd2*s**2 - 112*D1*Dd*b1*f*gd2*s + 14*D1*Dd*b1*f*gd2 + 112*D1*Dd*b1*fd*g2*r*s - 14*D1*Dd*b1*fd*g2*r + 112*D1*Dd*b1*fd*g2*s**2 - 56*D1*Dd*b1*fd*g2*s + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r*s - 14*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 56*D1*Dd*f**2*g2*s + 14*D1*Dd*f**2*g2 - 28*D1*Ddd*K*b1**2*f*r*s + 7*D1*Ddd*K*b1**2*f*r - 28*D1*Ddd*K*b1**2*f*s**2 + 28*D1*Ddd*K*b1**2*f*s - 7*D1*Ddd*K*b1**2*f + 12*D1*Ddd*b1*f**2*r*s - 3*D1*Ddd*b1*f**2*r + 12*D1*Ddd*b1*f**2*s**2 - 12*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 56*D1*Ddd*b1*f*g2*r*s - 14*D1*Ddd*b1*f*g2*r + 56*D1*Ddd*b1*f*g2*s**2 - 56*D1*Ddd*b1*f*g2*s + 14*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(12*C*(s - 1) - s*(7*K + 6) + 6) + f*(-fd*(6*C - 3)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(-14*r - 14*s + 14)) + 7*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(-7*K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - f*(6*C - 3)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 14*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 84*Dd**2*K*b1**2*f*r*s + 21*Dd**2*K*b1**2*f*r - 84*Dd**2*K*b1**2*f*s**2 + 84*Dd**2*K*b1**2*f*s - 14*Dd**2*K*b1**2*f + 36*Dd**2*b1*f**2*r*s - 9*Dd**2*b1*f**2*r + 36*Dd**2*b1*f**2*s**2 - 36*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 168*Dd**2*b1*f*g2*r*s - 42*Dd**2*b1*f*g2*r + 168*Dd**2*b1*f*g2*s**2 - 168*Dd**2*b1*f*g2*s + 28*Dd**2*b1*f*g2)/(35*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**2*k2**3*st**4*(12*C*D1**2*f**2*fd*r*s - 4*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 12*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r*s + 2*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 6*C*D1**2*f**2*fdd*s - 2*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r*s + 4*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 12*C*D1**2*f*fd**2*s - 2*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r*s - 4*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 16*C*D1*Dd*f**3*s + 4*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r*s + 14*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 48*C*D1*Dd*f**2*fd*s - 10*C*D1*Dd*f**2*fd - 8*C*D1*Ddd*f**3*r*s + 2*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 8*C*D1*Ddd*f**3*s - 2*C*D1*Ddd*f**3 - 24*C*Dd**2*f**3*r*s + 6*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 24*C*Dd**2*f**3*s - 4*C*Dd**2*f**3 + 12*D1**2*K*b1*f*fd*r*s - 6*D1**2*K*b1*f*fd*r + 12*D1**2*K*b1*f*fd*s**2 - 12*D1**2*K*b1*f*fd*s + 6*D1**2*K*b1*f*fd - 6*D1**2*K*b1*f*fdd*r*s + 3*D1**2*K*b1*f*fdd*r - 6*D1**2*K*b1*f*fdd*s**2 + 6*D1**2*K*b1*f*fdd*s - 3*D1**2*K*b1*f*fdd - 6*D1**2*K*b1*fd**2*r*s + 3*D1**2*K*b1*fd**2*r - 6*D1**2*K*b1*fd**2*s**2 + 6*D1**2*K*b1*fd**2*s + 6*D1**2*K*bd1*f**2*r*s + 6*D1**2*K*bd1*f**2*s**2 - 6*D1**2*K*bd1*f**2*s - 12*D1**2*K*bd1*f*fd*r*s + 3*D1**2*K*bd1*f*fd*r - 12*D1**2*K*bd1*f*fd*s**2 + 12*D1**2*K*bd1*f*fd*s - 3*D1**2*K*bd1*f*fd - 3*D1**2*K*bdd1*f**2*r*s - 3*D1**2*K*bdd1*f**2*s**2 + 3*D1**2*K*bdd1*f**2*s - 3*D1**2*bdd2*f**2*r*s - 3*D1**2*bdd2*f**2*s**2 + 3*D1**2*bdd2*f**2*s - 6*D1**2*f**2*fd*r*s + 2*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r*s - D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 3*D1**2*f**2*fdd*s + D1**2*f**2*fdd - 12*D1**2*f**2*gd2*r*s - 12*D1**2*f**2*gd2*s**2 + 12*D1**2*f**2*gd2*s + 6*D1**2*f**2*gdd2*r*s + 6*D1**2*f**2*gdd2*s**2 - 6*D1**2*f**2*gdd2*s + 6*D1**2*f*fd**2*r*s - 2*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 6*D1**2*f*fd**2*s + D1**2*f*fd**2 - 24*D1**2*f*fd*g2*r*s + 12*D1**2*f*fd*g2*r - 24*D1**2*f*fd*g2*s**2 + 24*D1**2*f*fd*g2*s - 12*D1**2*f*fd*g2 + 24*D1**2*f*fd*gd2*r*s - 6*D1**2*f*fd*gd2*r + 24*D1**2*f*fd*gd2*s**2 - 24*D1**2*f*fd*gd2*s + 6*D1**2*f*fd*gd2 + 12*D1**2*f*fdd*g2*r*s - 6*D1**2*f*fdd*g2*r + 12*D1**2*f*fdd*g2*s**2 - 12*D1**2*f*fdd*g2*s + 6*D1**2*f*fdd*g2 + 12*D1**2*fd**2*g2*r*s - 6*D1**2*fd**2*g2*r + 12*D1**2*fd**2*g2*s**2 - 12*D1**2*fd**2*g2*s + 24*D1*Dd*K*b1*f**2*r*s - 6*D1*Dd*K*b1*f**2*r + 24*D1*Dd*K*b1*f**2*s**2 - 24*D1*Dd*K*b1*f**2*s + 6*D1*Dd*K*b1*f**2 - 48*D1*Dd*K*b1*f*fd*r*s + 18*D1*Dd*K*b1*f*fd*r - 48*D1*Dd*K*b1*f*fd*s**2 + 48*D1*Dd*K*b1*f*fd*s - 12*D1*Dd*K*b1*f*fd - 24*D1*Dd*K*bd1*f**2*r*s + 3*D1*Dd*K*bd1*f**2*r - 24*D1*Dd*K*bd1*f**2*s**2 + 24*D1*Dd*K*bd1*f**2*s - 3*D1*Dd*K*bd1*f**2 - 8*D1*Dd*f**3*r*s + 2*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 8*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r*s - 7*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 24*D1*Dd*f**2*fd*s + 5*D1*Dd*f**2*fd - 48*D1*Dd*f**2*g2*r*s + 12*D1*Dd*f**2*g2*r - 48*D1*Dd*f**2*g2*s**2 + 48*D1*Dd*f**2*g2*s - 12*D1*Dd*f**2*g2 + 48*D1*Dd*f**2*gd2*r*s - 6*D1*Dd*f**2*gd2*r + 48*D1*Dd*f**2*gd2*s**2 - 48*D1*Dd*f**2*gd2*s + 6*D1*Dd*f**2*gd2 + 96*D1*Dd*f*fd*g2*r*s - 36*D1*Dd*f*fd*g2*r + 96*D1*Dd*f*fd*g2*s**2 - 96*D1*Dd*f*fd*g2*s + 24*D1*Dd*f*fd*g2 - 12*D1*Ddd*K*b1*f**2*r*s + 3*D1*Ddd*K*b1*f**2*r - 12*D1*Ddd*K*b1*f**2*s**2 + 12*D1*Ddd*K*b1*f**2*s - 3*D1*Ddd*K*b1*f**2 + 4*D1*Ddd*f**3*r*s - D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 4*D1*Ddd*f**3*s + D1*Ddd*f**3 + 24*D1*Ddd*f**2*g2*r*s - 6*D1*Ddd*f**2*g2*r + 24*D1*Ddd*f**2*g2*s**2 - 24*D1*Ddd*f**2*g2*s + 6*D1*Ddd*f**2*g2 + 3*D1*bd2*f*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 36*Dd**2*K*b1*f**2*r*s + 9*Dd**2*K*b1*f**2*r - 36*Dd**2*K*b1*f**2*s**2 + 36*Dd**2*K*b1*f**2*s - 6*Dd**2*K*b1*f**2 + 12*Dd**2*f**3*r*s - 3*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 12*Dd**2*f**3*s + 2*Dd**2*f**3 + 72*Dd**2*f**2*g2*r*s - 18*Dd**2*f**2*g2*r + 72*Dd**2*f**2*g2*s**2 - 72*Dd**2*f**2*g2*s + 12*Dd**2*f**2*g2 + 3*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(7*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct**2*k2**3*st**2*(D1*(7*D1*K*bd1**2*f*(r + 2*s - 1) + 7*K*b1**2*(r + 2*s - 1)*(2*D1*fd - D1*fdd - 4*Dd*fd) + b1*(7*D1*bd2*s*(2*f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + D1*f*(7*K*bdd1*(r + 2*s - 1) - 7*bdd2*s*(r + s - 1) + fd*(12*C*(r + 2*s - 1) - 7*K*(2*r*s - r + 2*s**2 - 2*s + 1) - 6*r - 12*s + 6) - fdd*(6*C - 3)*(r + 2*s - 1)) - D1*(r + 2*s - 1)*(fd**2*(6*C - 3) + 14*fd*(2*g2 - gd2) - 14*fdd*g2) - 7*Dd*K*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 7*Dd*bd2*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + Dd*f*fd*(12 - 24*C)*(r + 2*s - 1) + 56*Dd*fd*g2*(r + 2*s - 1)) - bd1*(7*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(7*K*b1*fd*(r + 2*s - 1) + f**2*(12*C*(r + 2*s - 1) + 7*K*s**2 - 7*K*s + r*(7*K*s - 6) - 12*s + 6) - f*(r + 2*s - 1)*(-14*K*b1 + fd*(6*C - 3) + 28*g2 - 14*gd2)) - 4*Dd*f*(r + 2*s - 1)*(6*C*f + 7*K*b1 - 3*f - 14*g2)) + f*(D1*bdd1*(f*(6*C - 3) - 14*g2)*(r + 2*s - 1) + D1*(f*(-fd*(6*C - 3)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-7*bd2 + 14*gd2)*(r + s - 1)) + 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(6*C - 3) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(35*d**2*k3**3) - D1**2*Pkd2*Pkd3*ct**2*k2**3*(D1**2*bd1*(5*b2*f*(s - 1)*(r + s - 1) - (f*(6*C - 3) - 10*g2)*(bd1*r*(2*s - 1) + 2*bd1*s*(s - 1) + f*(r + 2*s - 1))) + D1*b1*(6*C*D1*f*fd*r + 12*C*D1*f*fd*s - 6*C*D1*f*fd - 5*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 5*D1*b2*fd*r*s + 5*D1*b2*fd*s**2 + 5*D1*bd2*f*r*s + 5*D1*bd2*f*s**2 - 5*D1*bd2*f*s - D1*bdd1*(f*(6*C - 3) - 10*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 3*D1*f*fd*r - 6*D1*f*fd*s + 3*D1*f*fd - 10*D1*fd*g2*r - 20*D1*fd*g2*s + 10*D1*fd*g2 + 20*Dd*b2*f*r*s - 5*Dd*b2*f*r + 20*Dd*b2*f*s**2 - 20*Dd*b2*f*s + 5*Dd*b2*f + bd1*(D1*(f*(12*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 5*K*(r + 2*s - 1) - 12*r*s + 6*r - 12*s**2 + 12*s - 6) + fd*(3 - 6*C)*(r*(4*s - 1) + (1 - 2*s)**2) - 10*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 10*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd*(f*(6*C - 3) - 10*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 5*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(D1**2*(12*C*fd*r*s + 12*C*fd*s**2 - 12*C*fd*s - 6*C*fdd*r*s - 6*C*fdd*s**2 + 6*C*fdd*s + 10*K*bd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*K*bdd1*(3*r*s - r + 3*s**2 - 3*s + 1) + 5*K*fd*r + 10*K*fd*s - 5*K*fd - 6*fd*r*s - 6*fd*s**2 + 6*fd*s + 3*fdd*r*s + 3*fdd*s**2 - 3*fdd*s - 20*gd2*r*s - 20*gd2*s**2 + 20*gd2*s + 10*gdd2*r*s + 10*gdd2*s**2 - 10*gdd2*s) + D1*(Dd*(-5*K*bd1*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + f*(12*C - 6)*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(6*C - 3)*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 20*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 10*gd2*(8*r*s - r + 8*s**2 - 8*s + 1)) - Ddd*(f*(6*C - 3) - 10*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*(f*(6*C - 3) - 10*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(15*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct**2*k2*st**2*(D1*(-7*D1*K*bd1**2*f*s*(2*r + 2*s - 1) - D1*bdd1*f*s*(r + s)*(f*(6*C - 3) - 14*g2) - 7*b2*(D1*bd1*(-2*f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + D1*bdd1*f*s*(r + s) + Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) - bd1*(D1*(f**2*s*(6 - 12*C)*(r + s) + f*(fd*(6*C - 3)*(r*(4*s - 1) + s*(4*s - 3)) + 7*s*(bd2*(2*r + 2*s - 1) + 4*g2*(r + s) + gd2*(-4*r - 4*s + 2))) + 14*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(6*C - 3) - 14*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 7*K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(24*C*D1**2*f*fd*r*s - 12*C*D1**2*f*fd*r + 24*C*D1**2*f*fd*s**2 - 36*C*D1**2*f*fd*s + 12*C*D1**2*f*fd - 12*C*D1**2*f*fdd*r*s + 6*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s**2 + 18*C*D1**2*f*fdd*s - 6*C*D1**2*f*fdd - 12*C*D1**2*fd**2*r*s + 6*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s**2 + 18*C*D1**2*fd**2*s - 6*C*D1**2*fd**2 + 48*C*D1*Dd*f**2*r*s - 12*C*D1*Dd*f**2*r + 48*C*D1*Dd*f**2*s**2 - 48*C*D1*Dd*f**2*s + 12*C*D1*Dd*f**2 - 96*C*D1*Dd*f*fd*r*s + 36*C*D1*Dd*f*fd*r - 96*C*D1*Dd*f*fd*s**2 + 120*C*D1*Dd*f*fd*s - 30*C*D1*Dd*f*fd - 24*C*D1*Ddd*f**2*r*s + 6*C*D1*Ddd*f**2*r - 24*C*D1*Ddd*f**2*s**2 + 24*C*D1*Ddd*f**2*s - 6*C*D1*Ddd*f**2 - 72*C*Dd**2*f**2*r*s + 18*C*Dd**2*f**2*r - 72*C*Dd**2*f**2*s**2 + 72*C*Dd**2*f**2*s - 12*C*Dd**2*f**2 + 28*D1**2*K*bd1*f*r*s + 28*D1**2*K*bd1*f*s**2 - 14*D1**2*K*bd1*f*s - 28*D1**2*K*bd1*fd*r*s + 14*D1**2*K*bd1*fd*r - 28*D1**2*K*bd1*fd*s**2 + 35*D1**2*K*bd1*fd*s - 7*D1**2*K*bd1*fd - 14*D1**2*K*bdd1*f*r*s - 14*D1**2*K*bdd1*f*s**2 + 7*D1**2*K*bdd1*f*s - 7*D1**2*bdd2*f*r*s - 7*D1**2*bdd2*f*s**2 + 7*D1**2*bdd2*f*s - 12*D1**2*f*fd*r*s + 6*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s - 6*D1**2*f*fd + 6*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 9*D1**2*f*fdd*s + 3*D1**2*f*fdd - 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*s**2 + 28*D1**2*f*gd2*s + 14*D1**2*f*gdd2*r*s + 14*D1**2*f*gdd2*s**2 - 14*D1**2*f*gdd2*s + 6*D1**2*fd**2*r*s - 3*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 9*D1**2*fd**2*s + 3*D1**2*fd**2 - 28*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 28*D1**2*fd*gd2*r*s - 14*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 42*D1**2*fd*gd2*s + 14*D1**2*fd*gd2 + 14*D1**2*fdd*g2*r*s - 14*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 112*D1*Dd*K*bd1*f*r*s + 14*D1*Dd*K*bd1*f*r - 112*D1*Dd*K*bd1*f*s**2 + 84*D1*Dd*K*bd1*f*s - 7*D1*Dd*K*bd1*f - 24*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 48*D1*Dd*f*fd*r*s - 18*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 15*D1*Dd*f*fd - 112*D1*Dd*f*g2*r*s + 28*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 112*D1*Dd*f*g2*s - 28*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r*s - 14*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 112*D1*Dd*f*gd2*s + 14*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r*s - 70*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s + 56*D1*Dd*fd*g2 + 12*D1*Ddd*f**2*r*s - 3*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r*s - 14*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 56*D1*Ddd*f*g2*s + 14*D1*Ddd*f*g2 + 7*D1*bd2*(D1*(r + s - 1)*(2*f*s - 2*fd*s + fd) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 36*Dd**2*f**2*r*s - 9*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 6*Dd**2*f**2 + 168*Dd**2*f*g2*r*s - 42*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 168*Dd**2*f*g2*s + 28*Dd**2*f*g2 + 7*b2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(35*d**2*k3) - D1**2*Pkd2*Pkd3*ct**2*k2*(D1**2*bd1*(5*b2 + f*(6*C - 3) - 10*g2)*(bd1*r*(2*s - 1) + 2*bd1*s*(s - 1) + f*s*(r + s)) + D1*b1*(12*C*D1*bdd1*f*r*s - 6*C*D1*bdd1*f*r + 12*C*D1*bdd1*f*s**2 - 12*C*D1*bdd1*f*s + 6*C*D1*bdd1*f + 12*C*D1*f*fd*r*s - 6*C*D1*f*fd*r + 12*C*D1*f*fd*s**2 - 18*C*D1*f*fd*s + 6*C*D1*f*fd + 24*C*Dd*f**2*r*s - 6*C*Dd*f**2*r + 24*C*Dd*f**2*s**2 - 24*C*Dd*f**2*s + 6*C*Dd*f**2 + 5*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 5*D1*bd2*f*r*s + 5*D1*bd2*f*s**2 - 5*D1*bd2*f*s - 6*D1*bdd1*f*r*s + 3*D1*bdd1*f*r - 6*D1*bdd1*f*s**2 + 6*D1*bdd1*f*s - 3*D1*bdd1*f - 20*D1*bdd1*g2*r*s + 10*D1*bdd1*g2*r - 20*D1*bdd1*g2*s**2 + 20*D1*bdd1*g2*s - 10*D1*bdd1*g2 - 6*D1*f*fd*r*s + 3*D1*f*fd*r - 6*D1*f*fd*s**2 + 9*D1*f*fd*s - 3*D1*f*fd - 10*D1*f*gd2*r*s - 10*D1*f*gd2*s**2 + 10*D1*f*gd2*s - 10*D1*fd*g2*r*s + 10*D1*fd*g2*r - 10*D1*fd*g2*s**2 + 20*D1*fd*g2*s - 10*D1*fd*g2 - 12*Dd*f**2*r*s + 3*Dd*f**2*r - 12*Dd*f**2*s**2 + 12*Dd*f**2*s - 3*Dd*f**2 - 40*Dd*f*g2*r*s + 10*Dd*f*g2*r - 40*Dd*f*g2*s**2 + 40*Dd*f*g2*s - 10*Dd*f*g2 - 5*b2*(-D1*bdd1*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - D1*fd*r*s + D1*fd*r - D1*fd*s**2 + 2*D1*fd*s - D1*fd - 4*Dd*f*r*s + Dd*f*r - 4*Dd*f*s**2 + 4*Dd*f*s - Dd*f + 2*bd1*(D1*r*(2*s - 1) + 2*D1*s**2 - 2*D1*s + D1 + Dd*r*(3 - 8*s) - 2*Dd*(1 - 2*s)**2)) + bd1*(5*D1*bd2*(r*(4*s - 1) + (1 - 2*s)**2) + D1*(f*(-12*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 10*K*s**2 - 5*K*s + 2*r*(5*K*s + 6*s - 3) + 12*s**2 - 12*s + 6) + fd*(6*C - 3)*(r*(4*s - 1) + (1 - 2*s)**2) + 10*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 10*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(f*(6*C - 3) - 10*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 5*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(-12*C*D1**2*fd*r*s - 12*C*D1**2*fd*s**2 + 12*C*D1**2*fd*s + 6*C*D1**2*fdd*r*s + 6*C*D1**2*fdd*s**2 - 6*C*D1**2*fdd*s - 48*C*D1*Dd*f*r*s + 12*C*D1*Dd*f*r - 48*C*D1*Dd*f*s**2 + 48*C*D1*Dd*f*s - 12*C*D1*Dd*f + 48*C*D1*Dd*fd*r*s - 6*C*D1*Dd*fd*r + 48*C*D1*Dd*fd*s**2 - 48*C*D1*Dd*fd*s + 6*C*D1*Dd*fd + 24*C*D1*Ddd*f*r*s - 6*C*D1*Ddd*f*r + 24*C*D1*Ddd*f*s**2 - 24*C*D1*Ddd*f*s + 6*C*D1*Ddd*f + 72*C*Dd**2*f*r*s - 18*C*Dd**2*f*r + 72*C*Dd**2*f*s**2 - 72*C*Dd**2*f*s + 12*C*Dd**2*f - 30*D1**2*K*bd1*r*s + 10*D1**2*K*bd1*r - 30*D1**2*K*bd1*s**2 + 30*D1**2*K*bd1*s - 10*D1**2*K*bd1 + 15*D1**2*K*bdd1*r*s - 5*D1**2*K*bdd1*r + 15*D1**2*K*bdd1*s**2 - 15*D1**2*K*bdd1*s + 5*D1**2*K*bdd1 + 5*D1**2*K*fd*r*s - 5*D1**2*K*fd*r + 5*D1**2*K*fd*s**2 - 10*D1**2*K*fd*s + 5*D1**2*K*fd + 5*D1**2*bdd2*r*s + 5*D1**2*bdd2*s**2 - 5*D1**2*bdd2*s + 6*D1**2*fd*r*s + 6*D1**2*fd*s**2 - 6*D1**2*fd*s - 3*D1**2*fdd*r*s - 3*D1**2*fdd*s**2 + 3*D1**2*fdd*s + 20*D1**2*gd2*r*s + 20*D1**2*gd2*s**2 - 20*D1**2*gd2*s - 10*D1**2*gdd2*r*s - 10*D1**2*gdd2*s**2 + 10*D1**2*gdd2*s + 120*D1*Dd*K*bd1*r*s - 35*D1*Dd*K*bd1*r + 120*D1*Dd*K*bd1*s**2 - 120*D1*Dd*K*bd1*s + 25*D1*Dd*K*bd1 + 20*D1*Dd*K*f*r*s - 5*D1*Dd*K*f*r + 20*D1*Dd*K*f*s**2 - 20*D1*Dd*K*f*s + 5*D1*Dd*K*f + 24*D1*Dd*f*r*s - 6*D1*Dd*f*r + 24*D1*Dd*f*s**2 - 24*D1*Dd*f*s + 6*D1*Dd*f - 24*D1*Dd*fd*r*s + 3*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 24*D1*Dd*fd*s - 3*D1*Dd*fd + 80*D1*Dd*g2*r*s - 20*D1*Dd*g2*r + 80*D1*Dd*g2*s**2 - 80*D1*Dd*g2*s + 20*D1*Dd*g2 - 80*D1*Dd*gd2*r*s + 10*D1*Dd*gd2*r - 80*D1*Dd*gd2*s**2 + 80*D1*Dd*gd2*s - 10*D1*Dd*gd2 - 12*D1*Ddd*f*r*s + 3*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 12*D1*Ddd*f*s - 3*D1*Ddd*f - 40*D1*Ddd*g2*r*s + 10*D1*Ddd*g2*r - 40*D1*Ddd*g2*s**2 + 40*D1*Ddd*g2*s - 10*D1*Ddd*g2 - 5*D1*bd2*(2*D1*s*(r + s - 1) + Dd*(-8*r*s + r - 8*s**2 + 8*s - 1)) - 36*Dd**2*f*r*s + 9*Dd**2*f*r - 36*Dd**2*f*s**2 + 36*Dd**2*f*s - 6*Dd**2*f - 120*Dd**2*g2*r*s + 30*Dd**2*g2*r - 120*Dd**2*g2*s**2 + 120*Dd**2*g2*s - 20*Dd**2*g2 - 5*b2*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(15*d**2*k3) + D1**2*Pkd2*Pkd3*ct*f**2*k1**5*st**4*(D1**2*(-f*(167*fd - 100*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + 100*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(-167*f*(r*(4*s - 1) + (1 - 2*s)**2) + 200*fd*(4*s - 1)*(4*r + 4*s - 3)) + 100*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 100*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1155*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*f**2*k1**3*k2**2*st**6*(D1**2*(-f*(157*fd - 84*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + 84*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(-157*f*(r*(4*s - 1) + (1 - 2*s)**2) + 168*fd*(4*s - 1)*(4*r + 4*s - 3)) + 84*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 84*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(693*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*f*k1**5*st**2*(-72*D1**2*b1*f*fd*r*s - 7*D1**2*b1*f*fd*r - 72*D1**2*b1*f*fd*s**2 + 41*D1**2*b1*f*fd*s + 7*D1**2*b1*f*fd + 45*D1**2*b1*f*fdd*r*s + 5*D1**2*b1*f*fdd*r + 45*D1**2*b1*f*fdd*s**2 - 25*D1**2*b1*f*fdd*s - 5*D1**2*b1*f*fdd + 90*D1**2*b1*fd**2*r*s + 10*D1**2*b1*fd**2*r + 90*D1**2*b1*fd**2*s**2 - 50*D1**2*b1*fd**2*s - 5*D1**2*b1*fd**2 + 5*D1**2*bdd1*f**2*(3*s - 4)*(r + s - 1) + 20*D1**2*f**2*fd*r*s - 5*D1**2*f**2*fd*r + 20*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 5*D1**2*f**2*fd - 96*D1*Dd*b1*f**2*r*s + 24*D1*Dd*b1*f**2*r - 96*D1*Dd*b1*f**2*s**2 + 96*D1*Dd*b1*f**2*s - 24*D1*Dd*b1*f**2 + 360*D1*Dd*b1*f*fd*r*s - 25*D1*Dd*b1*f*fd*r + 360*D1*Dd*b1*f*fd*s**2 - 280*D1*Dd*b1*f*fd*s + 15*D1*Dd*b1*f*fd + 20*D1*Dd*f**3*r*s - 5*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 20*D1*Dd*f**3*s + 5*D1*Dd*f**3 + 60*D1*Ddd*b1*f**2*r*s - 15*D1*Ddd*b1*f**2*r + 60*D1*Ddd*b1*f**2*s**2 - 60*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + D1*bd1*f*(D1*(-f*(24*s - 31)*(r + s - 1) + 5*fd*(18*r*s - 11*r + 18*s**2 - 26*s + 7)) + 5*Dd*f*(r*(24*s - 19) + 24*s**2 - 40*s + 15)) + 180*Dd**2*b1*f**2*r*s - 45*Dd**2*b1*f**2*r + 180*Dd**2*b1*f**2*s**2 - 180*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2)/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*k1**5*(-5*D1**2*bd1*f**2*(r + s - 1)*(bd1*(2*s - 1) - f*s + f) + D1*b1*f*(bd1*(D1*(3*f*(2*s - 1)*(r + s - 1) - 5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1)) - 5*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 5*f*(-D1*bdd1*(2*s - 1)*(r + s - 1) + D1*fd*s*(3*r + 3*s - 2) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**2*(D1**2*s*(2*r + 2*s - 1)*(3*f*fd - 5*f*fdd - 5*fd**2) + D1*f*(Dd*(3*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct*k1**3*k2**2*st**4*(72*C*D1**2*f**2*fd*r*s - 24*C*D1**2*f**2*fd*r + 72*C*D1**2*f**2*fd*s**2 - 72*C*D1**2*f**2*fd*s + 24*C*D1**2*f**2*fd - 36*C*D1**2*f**2*fdd*r*s + 12*C*D1**2*f**2*fdd*r - 36*C*D1**2*f**2*fdd*s**2 + 36*C*D1**2*f**2*fdd*s - 12*C*D1**2*f**2*fdd - 72*C*D1**2*f*fd**2*r*s + 24*C*D1**2*f*fd**2*r - 72*C*D1**2*f*fd**2*s**2 + 72*C*D1**2*f*fd**2*s - 12*C*D1**2*f*fd**2 + 96*C*D1*Dd*f**3*r*s - 24*C*D1*Dd*f**3*r + 96*C*D1*Dd*f**3*s**2 - 96*C*D1*Dd*f**3*s + 24*C*D1*Dd*f**3 - 288*C*D1*Dd*f**2*fd*r*s + 84*C*D1*Dd*f**2*fd*r - 288*C*D1*Dd*f**2*fd*s**2 + 288*C*D1*Dd*f**2*fd*s - 60*C*D1*Dd*f**2*fd - 48*C*D1*Ddd*f**3*r*s + 12*C*D1*Ddd*f**3*r - 48*C*D1*Ddd*f**3*s**2 + 48*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 144*C*Dd**2*f**3*r*s + 36*C*Dd**2*f**3*r - 144*C*Dd**2*f**3*s**2 + 144*C*Dd**2*f**3*s - 24*C*Dd**2*f**3 - 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s + 10*D1**2*bdd1*f**3*r*s + 20*D1**2*bdd1*f**3*r + 10*D1**2*bdd1*f**3*s**2 + 10*D1**2*bdd1*f**3*s - 20*D1**2*bdd1*f**3 + 9*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 - 9*D1**2*bdd1*f**2*s - 60*D1**2*f**3*fd*r*s + 15*D1**2*f**3*fd*r - 60*D1**2*f**3*fd*s**2 + 60*D1**2*f**3*fd*s - 15*D1**2*f**3*fd - 54*D1**2*f**2*fd*r*s + 18*D1**2*f**2*fd*r - 54*D1**2*f**2*fd*s**2 + 54*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 27*D1**2*f**2*fdd*r*s - 9*D1**2*f**2*fdd*r + 27*D1**2*f**2*fdd*s**2 - 27*D1**2*f**2*fdd*s + 9*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 54*D1**2*f*fd**2*r*s - 18*D1**2*f*fd**2*r + 54*D1**2*f*fd**2*s**2 - 54*D1**2*f*fd**2*s + 9*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 60*D1*Dd*f**4*r*s + 15*D1*Dd*f**4*r - 60*D1*Dd*f**4*s**2 + 60*D1*Dd*f**4*s - 15*D1*Dd*f**4 - 72*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 72*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 216*D1*Dd*f**2*fd*r*s - 63*D1*Dd*f**2*fd*r + 216*D1*Dd*f**2*fd*s**2 - 216*D1*Dd*f**2*fd*s + 45*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r*s - 36*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 288*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r*s - 216*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 576*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 36*D1*Ddd*f**3*r*s - 9*D1*Ddd*f**3*r + 36*D1*Ddd*f**3*s**2 - 36*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(-D1*(f**2*(14*s + 37)*(r + s - 1) - 2*f*(5*fd*(6*r*s + 3*r + 6*s**2 - 2*s - 1) + s*(18*K - 9)*(r + s - 1)) + 9*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(10*f*(8*r*s + 7*r + 8*s**2 - 5) - (18*K - 9)*(8*r*s - r + 8*s**2 - 8*s + 1))) + 108*Dd**2*f**3*r*s - 27*Dd**2*f**3*r + 108*Dd**2*f**3*s**2 - 108*Dd**2*f**3*s + 18*Dd**2*f**3 + 432*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 + b1*(D1**2*(f**2*(fd*(r*(51 - 42*s) - 42*s**2 + 79*s - 51) + 10*fdd*(3*r*(s - 1) + 3*s**2 - 5*s + 3)) + f*(10*fd**2*(6*r*(s - 1) + 6*s**2 - 10*s + 3) + 18*fd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 9*fdd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 9*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(-2*Dd*(7*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(3*r*(8*s - 5) + 24*s**2 - 32*s + 11) + (9 - 18*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 10*f + 9)) + Dd**2*f**2*(-18*K + 10*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*k1**3*k2**2*st**2*(36*C*D1**2*bdd1*f**2*r*s - 36*C*D1**2*bdd1*f**2*r + 36*C*D1**2*bdd1*f**2*s**2 - 72*C*D1**2*bdd1*f**2*s + 36*C*D1**2*bdd1*f**2 - 6*C*D1**2*f**2*fd*r*s + 2*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 6*C*D1**2*f**2*fd*s - 2*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r*s - 10*C*D1**2*f**2*fdd*r + 30*C*D1**2*f**2*fdd*s**2 - 30*C*D1**2*f**2*fdd*s + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r*s - 20*C*D1**2*f*fd**2*r + 60*C*D1**2*f*fd**2*s**2 - 60*C*D1**2*f*fd**2*s + 10*C*D1**2*f*fd**2 - 8*C*D1*Dd*f**3*r*s + 2*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 8*C*D1*Dd*f**3*s - 2*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r*s - 70*C*D1*Dd*f**2*fd*r + 240*C*D1*Dd*f**2*fd*s**2 - 240*C*D1*Dd*f**2*fd*s + 50*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*r*s - 10*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s**2 - 40*C*D1*Ddd*f**3*s + 10*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*r*s - 30*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s**2 - 120*C*Dd**2*f**3*s + 20*C*Dd**2*f**3 + 9*D1**2*K*bdd1*f**2*r*s + 9*D1**2*K*bdd1*f**2*s**2 - 9*D1**2*K*bdd1*f**2*s - 3*D1**2*bd1**2*f*(2*s - 1)*(-14*K + 18*f + 7)*(r + s - 1) - 27*D1**2*bdd1*f**2*r*s + 27*D1**2*bdd1*f**2*r - 27*D1**2*bdd1*f**2*s**2 + 54*D1**2*bdd1*f**2*s - 27*D1**2*bdd1*f**2 - 84*D1**2*bdd1*f*g2*r*s + 84*D1**2*bdd1*f*g2*r - 84*D1**2*bdd1*f*g2*s**2 + 168*D1**2*bdd1*f*g2*s - 84*D1**2*bdd1*f*g2 - 6*D1**2*f**2*fd*r*s + 2*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 2*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r*s + 5*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 15*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd - 6*D1**2*f**2*gd2*r*s - 6*D1**2*f**2*gd2*s**2 + 6*D1**2*f**2*gd2*s - 18*D1**2*f**2*gdd2*r*s - 18*D1**2*f**2*gdd2*s**2 + 18*D1**2*f**2*gdd2*s - 30*D1**2*f*fd**2*r*s + 10*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 30*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 - 12*D1**2*f*fd*g2*r*s + 6*D1**2*f*fd*g2*r - 12*D1**2*f*fd*g2*s**2 + 12*D1**2*f*fd*g2*s - 6*D1**2*f*fd*g2 - 72*D1**2*f*fd*gd2*r*s + 18*D1**2*f*fd*gd2*r - 72*D1**2*f*fd*gd2*s**2 + 72*D1**2*f*fd*gd2*s - 18*D1**2*f*fd*gd2 - 36*D1**2*f*fdd*g2*r*s + 18*D1**2*f*fdd*g2*r - 36*D1**2*f*fdd*g2*s**2 + 36*D1**2*f*fdd*g2*s - 18*D1**2*f*fdd*g2 - 36*D1**2*fd**2*g2*r*s + 18*D1**2*fd**2*g2*r - 36*D1**2*fd**2*g2*s**2 + 36*D1**2*fd**2*g2*s - 8*D1*Dd*f**3*r*s + 2*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 8*D1*Dd*f**3*s - 2*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r*s + 35*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 120*D1*Dd*f**2*fd*s - 25*D1*Dd*f**2*fd - 24*D1*Dd*f**2*g2*r*s + 6*D1*Dd*f**2*g2*r - 24*D1*Dd*f**2*g2*s**2 + 24*D1*Dd*f**2*g2*s - 6*D1*Dd*f**2*g2 - 144*D1*Dd*f**2*gd2*r*s + 18*D1*Dd*f**2*gd2*r - 144*D1*Dd*f**2*gd2*s**2 + 144*D1*Dd*f**2*gd2*s - 18*D1*Dd*f**2*gd2 - 288*D1*Dd*f*fd*g2*r*s + 108*D1*Dd*f*fd*g2*r - 288*D1*Dd*f*fd*g2*s**2 + 288*D1*Dd*f*fd*g2*s - 72*D1*Dd*f*fd*g2 - 20*D1*Ddd*f**3*r*s + 5*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 20*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 - 72*D1*Ddd*f**2*g2*r*s + 18*D1*Ddd*f**2*g2*r - 72*D1*Ddd*f**2*g2*s**2 + 72*D1*Ddd*f**2*g2*s - 18*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-27*f**3*(r + s - 1) - f**2*(r + s - 1)*(72*C*(s - 1) - s*(3*K + 47) + 54) + 9*f*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + 84*f*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) - 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 3*Dd*f*(3*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 60*Dd**2*f**3*r*s + 15*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 60*Dd**2*f**3*s - 10*Dd**2*f**3 - 216*Dd**2*f**2*g2*r*s + 54*Dd**2*f**2*g2*r - 216*Dd**2*f**2*g2*s**2 + 216*Dd**2*f**2*g2*s - 36*Dd**2*f**2*g2 + 3*b1**2*(D1**2*s*(f*(29*fd - 18*fdd)*(2*r + 2*s - 1) - 18*fd**2*(2*r + 2*s - 1) - 14*fd*(2*K - 1)*(r + s) + 7*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(29*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(9*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (14*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 18*f + 7)) - Dd**2*f*(-14*K + 18*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-144*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s + 72*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 72*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*s**2 - 36*C*D1**2*fd**2*s - 288*C*D1*Dd*f**2*r*s + 72*C*D1*Dd*f**2*r - 288*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r*s - 72*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 432*C*D1*Dd*f*fd*s + 36*C*D1*Dd*f*fd + 144*C*D1*Ddd*f**2*r*s - 36*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r*s - 108*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 + 6*D1**2*K*f*fd*r*s - 3*D1**2*K*f*fd*r + 6*D1**2*K*f*fd*s**2 - 6*D1**2*K*f*fd*s + 3*D1**2*K*f*fd + 18*D1**2*K*f*fdd*r*s - 9*D1**2*K*f*fdd*r + 18*D1**2*K*f*fdd*s**2 - 18*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 18*D1**2*K*fd**2*r*s - 9*D1**2*K*fd**2*r + 18*D1**2*K*fd**2*s**2 - 18*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(2*s - 1)*(-14*K + 18*f + 7)*(r + s - 1) + 27*D1**2*f**2*fd*r + 27*D1**2*f**2*fd*s - 27*D1**2*f**2*fd + 94*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 94*D1**2*f*fd*s**2 - 40*D1**2*f*fd*s - 7*D1**2*f*fd - 54*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*s**2 + 27*D1**2*f*fdd*s + 168*D1**2*f*gd2*r*s + 168*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s - 84*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s - 54*D1**2*fd**2*r*s - 54*D1**2*fd**2*s**2 + 27*D1**2*fd**2*s + 168*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*s**2 - 168*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*s**2 + 84*D1**2*fd*gd2*s - 84*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 + 12*D1*Dd*K*f**2*r*s - 3*D1*Dd*K*f**2*r + 12*D1*Dd*K*f**2*s**2 - 12*D1*Dd*K*f**2*s + 3*D1*Dd*K*f**2 + 144*D1*Dd*K*f*fd*r*s - 54*D1*Dd*K*f*fd*r + 144*D1*Dd*K*f*fd*s**2 - 144*D1*Dd*K*f*fd*s + 36*D1*Dd*K*f*fd + 188*D1*Dd*f**2*r*s - 47*D1*Dd*f**2*r + 188*D1*Dd*f**2*s**2 - 188*D1*Dd*f**2*s + 47*D1*Dd*f**2 - 432*D1*Dd*f*fd*r*s + 54*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 324*D1*Dd*f*fd*s - 27*D1*Dd*f*fd + 672*D1*Dd*f*g2*r*s - 168*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 168*D1*Dd*f*g2 - 672*D1*Dd*f*gd2*r*s + 84*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 672*D1*Dd*f*gd2*s - 84*D1*Dd*f*gd2 - 672*D1*Dd*fd*g2*r*s + 84*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 336*D1*Dd*fd*g2*s + 36*D1*Ddd*K*f**2*r*s - 9*D1*Ddd*K*f**2*r + 36*D1*Ddd*K*f**2*s**2 - 36*D1*Ddd*K*f**2*s + 9*D1*Ddd*K*f**2 - 108*D1*Ddd*f**2*r*s + 27*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 336*D1*Ddd*f*g2*r*s + 84*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 336*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(29*f**2*(2*s - 1)*(r + s - 1) - 2*f*(9*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (14*K - 7)*(2*s - 1)*(r + s - 1)) + 7*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-14*K + 18*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 108*Dd**2*K*f**2*r*s - 27*Dd**2*K*f**2*r + 108*Dd**2*K*f**2*s**2 - 108*Dd**2*K*f**2*s + 18*Dd**2*K*f**2 - 324*Dd**2*f**2*r*s + 81*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 54*Dd**2*f**2 - 1008*Dd**2*f*g2*r*s + 252*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1008*Dd**2*f*g2*s - 168*Dd**2*f*g2))/(105*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct*k1**3*k2**2*(-3*D1*(7*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + D1*bdd1*f*(s - 1)*(f*(10*C - 5) - 14*g2)*(r + s - 1) + bd1*(D1*(f**2*(22*C - 18)*(s - 1)*(r + s - 1) + f*(fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (3*g2*(s - 1) + gd2*(2*s - 1))*(-14*r - 14*s + 14)) + 14*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 7*b1**2*(D1**2*s*(9*f*fd*(2*r + 2*s - 1) - (r + s)*(3*K*fdd + fd*(9*K - 5))) + D1*(Dd*(3*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 9*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(9*K - 5)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*(7*K*bdd1*f*(2*s - 1)*(r + s - 1) + s*(f*(fd*(22*C - 18)*(2*r + 2*s - 1) + fdd*(10*C - 5)*(2*r + 2*s - 1) + (-42*gd2 - 14*gdd2)*(r + s - 1)) + fd**2*(10*C - 5)*(2*r + 2*s - 1) - 14*fd*(3*g2*(r + s) + gd2*(2*r + 2*s - 1)) - 14*fdd*g2*(r + s))) + 7*D1*bd1*(D1*(3*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 9*f**2*(2*s - 1)*(r + s - 1) - f*(9*K - 5)*(2*s - 1)*(r + s - 1)) - 3*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*D1*(Dd*(f**2*(22*C - 18)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(10*C - 5)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 42*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 14*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 14*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + Ddd*f*(f*(10*C - 5) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(f*(10*C - 5) - 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*k1**3*st**4*(b1*(D1**2*(f**2*(fd*(-123*r*s + 41*r - 123*s**2 + 140*s - 41) + 5*fdd*(15*r*s - 5*r + 15*s**2 - 17*s + 5)) + f*(5*fd**2*(30*r*s - 10*r + 30*s**2 - 34*s + 7) - 18*fd*(2*r*s - r + 2*s**2 - 2*s + 1) + 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-41*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(5*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) - 18*r*(4*s - 1) - 18*(1 - 2*s)**2) + 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(25*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(25*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(5*bdd1*f**2*s*(5*r + 5*s - 3) + 3*f*(3*bdd1*s*(r + s - 1) + fd*(r*(2 - 6*s) - 6*s**2 + 6*s - 2) + fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 3*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-f*s*(f*(41*r + 41*s - 24) + 18*r + 18*s - 18) + fd*(5*f*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3) + 9*r*(4*s - 1) + 9*(1 - 2*s)**2)) + Dd*f*(5*f*(40*r*s - 5*r + 40*s**2 - 32*s + 3) + 72*r*s - 9*r + 72*s**2 - 72*s + 9)) - 3*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct*k1**3*st**2*(42*C*D1**2*f**2*fd*r*s - 14*C*D1**2*f**2*fd*r + 42*C*D1**2*f**2*fd*s**2 - 42*C*D1**2*f**2*fd*s + 14*C*D1**2*f**2*fd - 30*C*D1**2*f**2*fdd*r*s + 10*C*D1**2*f**2*fdd*r - 30*C*D1**2*f**2*fdd*s**2 + 30*C*D1**2*f**2*fdd*s - 10*C*D1**2*f**2*fdd - 60*C*D1**2*f*fd**2*r*s + 20*C*D1**2*f*fd**2*r - 60*C*D1**2*f*fd**2*s**2 + 60*C*D1**2*f*fd**2*s - 10*C*D1**2*f*fd**2 + 56*C*D1*Dd*f**3*r*s - 14*C*D1*Dd*f**3*r + 56*C*D1*Dd*f**3*s**2 - 56*C*D1*Dd*f**3*s + 14*C*D1*Dd*f**3 - 240*C*D1*Dd*f**2*fd*r*s + 70*C*D1*Dd*f**2*fd*r - 240*C*D1*Dd*f**2*fd*s**2 + 240*C*D1*Dd*f**2*fd*s - 50*C*D1*Dd*f**2*fd - 40*C*D1*Ddd*f**3*r*s + 10*C*D1*Ddd*f**3*r - 40*C*D1*Ddd*f**3*s**2 + 40*C*D1*Ddd*f**3*s - 10*C*D1*Ddd*f**3 - 120*C*Dd**2*f**3*r*s + 30*C*Dd**2*f**3*r - 120*C*Dd**2*f**3*s**2 + 120*C*Dd**2*f**3*s - 20*C*Dd**2*f**3 - 9*D1**2*K*bdd1*f**2*r*s - 9*D1**2*K*bdd1*f**2*s**2 + 9*D1**2*K*bdd1*f**2*s + 22*D1**2*b2*f*fd*r*s - 11*D1**2*b2*f*fd*r + 22*D1**2*b2*f*fd*s**2 - 22*D1**2*b2*f*fd*s + 11*D1**2*b2*f*fd - 18*D1**2*b2*f*fdd*r*s + 9*D1**2*b2*f*fdd*r - 18*D1**2*b2*f*fdd*s**2 + 18*D1**2*b2*f*fdd*s - 9*D1**2*b2*f*fdd - 18*D1**2*b2*fd**2*r*s + 9*D1**2*b2*fd**2*r - 18*D1**2*b2*fd**2*s**2 + 18*D1**2*b2*fd**2*s + 3*D1**2*bd1**2*f*(3*f*(r*(8*s - 5) + 8*s**2 - 12*s + 3) + (2*s - 1)*(7*r + 7*s - 7)) + 11*D1**2*bd2*f**2*r*s + 11*D1**2*bd2*f**2*s**2 - 11*D1**2*bd2*f**2*s - 36*D1**2*bd2*f*fd*r*s + 9*D1**2*bd2*f*fd*r - 36*D1**2*bd2*f*fd*s**2 + 36*D1**2*bd2*f*fd*s - 9*D1**2*bd2*f*fd + 9*D1**2*bdd1*f**2*r*s - 9*D1**2*bdd1*f**2*r + 9*D1**2*bdd1*f**2*s**2 - 18*D1**2*bdd1*f**2*s + 9*D1**2*bdd1*f**2 - 9*D1**2*bdd2*f**2*r*s - 9*D1**2*bdd2*f**2*s**2 + 9*D1**2*bdd2*f**2*s - 12*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r - 12*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r*s - 5*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 15*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd - 22*D1**2*f**2*gd2*r*s - 22*D1**2*f**2*gd2*s**2 + 22*D1**2*f**2*gd2*s + 18*D1**2*f**2*gdd2*r*s + 18*D1**2*f**2*gdd2*s**2 - 18*D1**2*f**2*gdd2*s + 30*D1**2*f*fd**2*r*s - 10*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 30*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 - 44*D1**2*f*fd*g2*r*s + 22*D1**2*f*fd*g2*r - 44*D1**2*f*fd*g2*s**2 + 44*D1**2*f*fd*g2*s - 22*D1**2*f*fd*g2 + 72*D1**2*f*fd*gd2*r*s - 18*D1**2*f*fd*gd2*r + 72*D1**2*f*fd*gd2*s**2 - 72*D1**2*f*fd*gd2*s + 18*D1**2*f*fd*gd2 + 36*D1**2*f*fdd*g2*r*s - 18*D1**2*f*fdd*g2*r + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 36*D1**2*fd**2*g2*r*s - 18*D1**2*fd**2*g2*r + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 44*D1*Dd*b2*f**2*r*s - 11*D1*Dd*b2*f**2*r + 44*D1*Dd*b2*f**2*s**2 - 44*D1*Dd*b2*f**2*s + 11*D1*Dd*b2*f**2 - 144*D1*Dd*b2*f*fd*r*s + 54*D1*Dd*b2*f*fd*r - 144*D1*Dd*b2*f*fd*s**2 + 144*D1*Dd*b2*f*fd*s - 36*D1*Dd*b2*f*fd - 72*D1*Dd*bd2*f**2*r*s + 9*D1*Dd*bd2*f**2*r - 72*D1*Dd*bd2*f**2*s**2 + 72*D1*Dd*bd2*f**2*s - 9*D1*Dd*bd2*f**2 - 16*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r - 16*D1*Dd*f**3*s**2 + 16*D1*Dd*f**3*s - 4*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r*s - 35*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 120*D1*Dd*f**2*fd*s + 25*D1*Dd*f**2*fd - 88*D1*Dd*f**2*g2*r*s + 22*D1*Dd*f**2*g2*r - 88*D1*Dd*f**2*g2*s**2 + 88*D1*Dd*f**2*g2*s - 22*D1*Dd*f**2*g2 + 144*D1*Dd*f**2*gd2*r*s - 18*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s**2 - 144*D1*Dd*f**2*gd2*s + 18*D1*Dd*f**2*gd2 + 288*D1*Dd*f*fd*g2*r*s - 108*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s**2 - 288*D1*Dd*f*fd*g2*s + 72*D1*Dd*f*fd*g2 - 36*D1*Ddd*b2*f**2*r*s + 9*D1*Ddd*b2*f**2*r - 36*D1*Ddd*b2*f**2*s**2 + 36*D1*Ddd*b2*f**2*s - 9*D1*Ddd*b2*f**2 + 20*D1*Ddd*f**3*r*s - 5*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 20*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 72*D1*Ddd*f**2*g2*r*s - 18*D1*Ddd*f**2*g2*r + 72*D1*Ddd*f**2*g2*s**2 - 72*D1*Ddd*f**2*g2*s + 18*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(9*f**2*s*(2*r + 2*s - 1) + f*(s*(11*K - 11) + 18)*(r + s - 1) - 9*fd*(K*(r*(4*s - 1) + (1 - 2*s)**2) - 4*r*s + 2*r - 4*s**2 + 5*s - 1)) - 9*Dd*f*(K*(8*r*s - r + 8*s**2 - 8*s + 1) - 8*r*s + 5*r - 8*s**2 + 12*s - 4)) - 108*Dd**2*b2*f**2*r*s + 27*Dd**2*b2*f**2*r - 108*Dd**2*b2*f**2*s**2 + 108*Dd**2*b2*f**2*s - 18*Dd**2*b2*f**2 + 60*Dd**2*f**3*r*s - 15*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 60*Dd**2*f**3*s + 10*Dd**2*f**3 + 216*Dd**2*f**2*g2*r*s - 54*Dd**2*f**2*g2*r + 216*Dd**2*f**2*g2*s**2 - 216*Dd**2*f**2*g2*s + 36*Dd**2*f**2*g2 + b1**2*(D1**2*(f*fd*(-r*(116*s + 11) - 116*s**2 + 65*s + 11) + 9*f*fdd*(8*r*s + r + 8*s**2 - 4*s - 1) + 9*fd**2*(8*r*s + r + 8*s**2 - 4*s - 1) - 42*fd*s*(r + s) + 21*fdd*s*(r + s)) + D1*(Dd*(-58*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 6*f*(fd*(r*(96*s - 6) + 96*s**2 - 72*s + 3) - 7*r*(4*s - 1) - 7*(1 - 2*s)**2) + 21*fd*(r*(8*s - 1) + 4*s*(2*s - 1))) + 3*Ddd*f*(12*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd**2*f*(12*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(22*D1**2*K*f*fd*r*s - 11*D1**2*K*f*fd*r + 22*D1**2*K*f*fd*s**2 - 22*D1**2*K*f*fd*s + 11*D1**2*K*f*fd - 18*D1**2*K*f*fdd*r*s + 9*D1**2*K*f*fdd*r - 18*D1**2*K*f*fdd*s**2 + 18*D1**2*K*f*fdd*s - 9*D1**2*K*f*fdd - 18*D1**2*K*fd**2*r*s + 9*D1**2*K*fd**2*r - 18*D1**2*K*fd**2*s**2 + 18*D1**2*K*fd**2*s + 3*D1**2*bdd1*f*(3*f*(8*r*s - 5*r + 8*s**2 - 12*s + 5) + (2*s - 1)*(7*r + 7*s - 7)) + 54*D1**2*f**2*fd*r*s - 18*D1**2*f**2*fd*r + 54*D1**2*f**2*fd*s**2 - 63*D1**2*f**2*fd*s + 18*D1**2*f**2*fd - 22*D1**2*f*fd*r*s - 7*D1**2*f*fd*r - 22*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s + 7*D1**2*f*fd + 18*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*s**2 - 9*D1**2*f*fdd*s + 18*D1**2*fd**2*r*s + 18*D1**2*fd**2*s**2 - 9*D1**2*fd**2*s + 44*D1*Dd*K*f**2*r*s - 11*D1*Dd*K*f**2*r + 44*D1*Dd*K*f**2*s**2 - 44*D1*Dd*K*f**2*s + 11*D1*Dd*K*f**2 - 144*D1*Dd*K*f*fd*r*s + 54*D1*Dd*K*f*fd*r - 144*D1*Dd*K*f*fd*s**2 + 144*D1*Dd*K*f*fd*s - 36*D1*Dd*K*f*fd + 72*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 72*D1*Dd*f**3*s**2 - 72*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 44*D1*Dd*f**2*r*s + 11*D1*Dd*f**2*r - 44*D1*Dd*f**2*s**2 + 44*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 144*D1*Dd*f*fd*r*s - 18*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 108*D1*Dd*f*fd*s + 9*D1*Dd*f*fd - 36*D1*Ddd*K*f**2*r*s + 9*D1*Ddd*K*f**2*r - 36*D1*Ddd*K*f**2*s**2 + 36*D1*Ddd*K*f**2*s - 9*D1*Ddd*K*f**2 + 36*D1*Ddd*f**2*r*s - 9*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + D1*bd1*(D1*(f**2*(r*(69 - 116*s) - 116*s**2 + 167*s - 69) + 6*f*(3*fd*(4*s - 1)*(4*r + 4*s - 3) + (2*s - 1)*(-7*r - 7*s + 7)) + 21*fd*(r*(4*s - 1) + s*(4*s - 3))) + 3*Dd*f*(6*f*(32*r*s - 14*r + 32*s**2 - 40*s + 11) + 112*r*s - 42*r + 112*s**2 - 140*s + 35)) - 108*Dd**2*K*f**2*r*s + 27*Dd**2*K*f**2*r - 108*Dd**2*K*f**2*s**2 + 108*Dd**2*K*f**2*s - 18*Dd**2*K*f**2 + 108*Dd**2*f**2*r*s - 27*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 18*Dd**2*f**2))/(105*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct*k1**3*(D1*(-21*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 3*D1*bdd1*f*(s - 1)*(f*(10*C - 5) - 14*g2)*(r + s - 1) + 7*b2*(D1*bd1*(f*(s - 1)*(r + s - 1) + 3*fd*(-2*r*s + r - s*(2*s - 2))) - 3*D1*bdd1*f*(s - 1)*(r + s - 1) - 3*Dd*bd1*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + bd1*(-21*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(f**2*(18*C + 12)*(s - 1)*(r + s - 1) + f*(-fd*(30*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (14*r + 14*s - 14)*(-g2*s + g2 + 6*gd2*s - 3*gd2)) + 42*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(f*(10*C - 5) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 7*b1**3*(D1**2*s*(fd - 3*fdd)*(r + s - 1) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(D1**2*K*fd*r*s + D1**2*K*fd*s**2 - 3*D1**2*K*fdd*r*s - 3*D1**2*K*fdd*s**2 - 3*D1**2*bdd1*f*(3*r*s - r + 3*s**2 - 3*s + 1) + 12*D1**2*f*fd*r*s + 12*D1**2*f*fd*s**2 - 9*D1**2*f*fd*s + 5*D1**2*fd*r*s + 5*D1**2*fd*s**2 + 4*D1*Dd*K*f*r*s - D1*Dd*K*f*r + 4*D1*Dd*K*f*s**2 - 4*D1*Dd*K*f*s + D1*Dd*K*f - 24*D1*Dd*K*fd*r*s + 3*D1*Dd*K*fd*r - 24*D1*Dd*K*fd*s**2 + 12*D1*Dd*K*fd*s + 24*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 6*D1*Dd*f**2 + 20*D1*Dd*f*r*s - 5*D1*Dd*f*r + 20*D1*Dd*f*s**2 - 20*D1*Dd*f*s + 5*D1*Dd*f - 12*D1*Ddd*K*f*r*s + 3*D1*Ddd*K*f*r - 12*D1*Ddd*K*f*s**2 + 12*D1*Ddd*K*f*s - 3*D1*Ddd*K*f + D1*bd1*(D1*(f*(3*r*s - r + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1)) - 3*Dd*f*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 36*Dd**2*K*f*r*s + 9*Dd**2*K*f*r - 36*Dd**2*K*f*s**2 + 36*Dd**2*K*f*s - 6*Dd**2*K*f) + b1*(36*C*D1**2*f*fd*r*s + 36*C*D1**2*f*fd*s**2 - 18*C*D1**2*f*fd*s - 60*C*D1**2*f*fdd*r*s - 60*C*D1**2*f*fdd*s**2 + 30*C*D1**2*f*fdd*s - 60*C*D1**2*fd**2*r*s - 60*C*D1**2*fd**2*s**2 + 30*C*D1**2*fd**2*s + 72*C*D1*Dd*f**2*r*s - 18*C*D1*Dd*f**2*r + 72*C*D1*Dd*f**2*s**2 - 72*C*D1*Dd*f**2*s + 18*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r*s + 60*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 360*C*D1*Dd*f*fd*s - 30*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r*s + 30*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 120*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r*s + 90*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 360*C*Dd**2*f**2*s - 60*C*Dd**2*f**2 - 42*D1**2*K*bdd1*f*r*s + 21*D1**2*K*bdd1*f*r - 42*D1**2*K*bdd1*f*s**2 + 63*D1**2*K*bdd1*f*s - 21*D1**2*K*bdd1*f - 21*D1**2*bd1**2*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 7*D1**2*bd2*f*r*s + 7*D1**2*bd2*f*s**2 - 7*D1**2*bd2*f*s - 42*D1**2*bd2*fd*r*s - 42*D1**2*bd2*fd*s**2 + 21*D1**2*bd2*fd*s - 21*D1**2*bdd2*f*r*s - 21*D1**2*bdd2*f*s**2 + 21*D1**2*bdd2*f*s + 24*D1**2*f*fd*r*s + 24*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s + 30*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*s**2 - 15*D1**2*f*fdd*s - 14*D1**2*f*gd2*r*s - 14*D1**2*f*gd2*s**2 + 14*D1**2*f*gd2*s + 42*D1**2*f*gdd2*r*s + 42*D1**2*f*gdd2*s**2 - 42*D1**2*f*gdd2*s + 30*D1**2*fd**2*r*s + 30*D1**2*fd**2*s**2 - 15*D1**2*fd**2*s - 14*D1**2*fd*g2*r*s - 14*D1**2*fd*g2*s**2 + 84*D1**2*fd*gd2*r*s + 84*D1**2*fd*gd2*s**2 - 42*D1**2*fd*gd2*s + 42*D1**2*fdd*g2*r*s + 42*D1**2*fdd*g2*s**2 - 168*D1*Dd*bd2*f*r*s + 21*D1*Dd*bd2*f*r - 168*D1*Dd*bd2*f*s**2 + 168*D1*Dd*bd2*f*s - 21*D1*Dd*bd2*f + 48*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 48*D1*Dd*f**2*s + 12*D1*Dd*f**2 + 240*D1*Dd*f*fd*r*s - 30*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 180*D1*Dd*f*fd*s + 15*D1*Dd*f*fd - 56*D1*Dd*f*g2*r*s + 14*D1*Dd*f*g2*r - 56*D1*Dd*f*g2*s**2 + 56*D1*Dd*f*g2*s - 14*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r*s - 42*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s**2 - 336*D1*Dd*f*gd2*s + 42*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r*s - 42*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s + 60*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 60*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*r*s - 42*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s**2 - 168*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(3*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 3*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(K + 5)*(2*s - 1)*(r + s - 1)) - 3*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*f**2*r*s - 45*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 180*Dd**2*f**2*s + 30*Dd**2*f**2 + 504*Dd**2*f*g2*r*s - 126*Dd**2*f*g2*r + 504*Dd**2*f*g2*s**2 - 504*Dd**2*f*g2*s + 84*Dd**2*f*g2 + 7*b2*(D1**2*s*(fd - 3*fdd)*(r + s) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*fd*(-8*r*s + r + s*(4 - 8*s))) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2))))/(105*d**2*k3**3) - D1**2*Pkd2*Pkd3*ct*k1*k2**4*st**6*(24*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r + 24*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r*s + 4*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r*s + 8*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 32*C*D1*Dd*f**3*r*s - 8*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s**2 - 32*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r*s + 28*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 96*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 16*C*D1*Ddd*f**3*r*s + 4*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 16*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 48*C*Dd**2*f**3*r*s + 12*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 48*C*Dd**2*f**3*s - 8*C*Dd**2*f**3 - 18*D1**2*K*bdd1*f**2*r*s - 18*D1**2*K*bdd1*f**2*s**2 + 18*D1**2*K*bdd1*f**2*s + 7*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 - 7*D1**2*bdd1*f**3*s + 9*D1**2*bdd1*f**2*r*s + 9*D1**2*bdd1*f**2*s**2 - 9*D1**2*bdd1*f**2*s - 18*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 18*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 9*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r + 9*D1**2*f**2*fdd*s**2 - 9*D1**2*f**2*fdd*s + 3*D1**2*f**2*fdd - 72*D1**2*f**2*gd2*r*s - 72*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s + 36*D1**2*f**2*gdd2*r*s + 36*D1**2*f**2*gdd2*s**2 - 36*D1**2*f**2*gdd2*s + 18*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r + 18*D1**2*f*fd**2*s**2 - 18*D1**2*f*fd**2*s + 3*D1**2*f*fd**2 - 144*D1**2*f*fd*g2*r*s + 72*D1**2*f*fd*g2*r - 144*D1**2*f*fd*g2*s**2 + 144*D1**2*f*fd*g2*s - 72*D1**2*f*fd*g2 + 144*D1**2*f*fd*gd2*r*s - 36*D1**2*f*fd*gd2*r + 144*D1**2*f*fd*gd2*s**2 - 144*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 72*D1**2*f*fdd*g2*r*s - 36*D1**2*f*fdd*g2*r + 72*D1**2*f*fdd*g2*s**2 - 72*D1**2*f*fdd*g2*s + 36*D1**2*f*fdd*g2 + 72*D1**2*fd**2*g2*r*s - 36*D1**2*fd**2*g2*r + 72*D1**2*fd**2*g2*s**2 - 72*D1**2*fd**2*g2*s - 24*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 24*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 72*D1*Dd*f**2*fd*r*s - 21*D1*Dd*f**2*fd*r + 72*D1*Dd*f**2*fd*s**2 - 72*D1*Dd*f**2*fd*s + 15*D1*Dd*f**2*fd - 288*D1*Dd*f**2*g2*r*s + 72*D1*Dd*f**2*g2*r - 288*D1*Dd*f**2*g2*s**2 + 288*D1*Dd*f**2*g2*s - 72*D1*Dd*f**2*g2 + 288*D1*Dd*f**2*gd2*r*s - 36*D1*Dd*f**2*gd2*r + 288*D1*Dd*f**2*gd2*s**2 - 288*D1*Dd*f**2*gd2*s + 36*D1*Dd*f**2*gd2 + 576*D1*Dd*f*fd*g2*r*s - 216*D1*Dd*f*fd*g2*r + 576*D1*Dd*f*fd*g2*s**2 - 576*D1*Dd*f*fd*g2*s + 144*D1*Dd*f*fd*g2 + 12*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 144*D1*Ddd*f**2*g2*r*s - 36*D1*Ddd*f**2*g2*r + 144*D1*Ddd*f**2*g2*s**2 - 144*D1*Ddd*f**2*g2*s + 36*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-18*K + 7*f + 9)*(r + s - 1) - 9*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-18*K + 7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 36*Dd**2*f**3*r*s - 9*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 6*Dd**2*f**3 + 432*Dd**2*f**2*g2*r*s - 108*Dd**2*f**2*g2*r + 432*Dd**2*f**2*g2*s**2 - 432*Dd**2*f**2*g2*s + 72*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 18*fd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1) - 9*fdd*(2*K - 1)*(2*r*s - r + 2*s**2 - 2*s + 1)) - 9*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (36*K - 18)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 7*f + 9)) + Dd**2*f**2*(-18*K + 7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*k1*k2**4*st**4*(4*C*D1**2*bdd1*f**2*r*s - 4*C*D1**2*bdd1*f**2*r + 4*C*D1**2*bdd1*f**2*s**2 - 8*C*D1**2*bdd1*f**2*s + 4*C*D1**2*bdd1*f**2 - 42*C*D1**2*f**2*fd*r*s + 14*C*D1**2*f**2*fd*r - 42*C*D1**2*f**2*fd*s**2 + 42*C*D1**2*f**2*fd*s - 14*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r*s - 10*C*D1**2*f**2*fdd*r + 30*C*D1**2*f**2*fdd*s**2 - 30*C*D1**2*f**2*fdd*s + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r*s - 20*C*D1**2*f*fd**2*r + 60*C*D1**2*f*fd**2*s**2 - 60*C*D1**2*f*fd**2*s + 10*C*D1**2*f*fd**2 - 56*C*D1*Dd*f**3*r*s + 14*C*D1*Dd*f**3*r - 56*C*D1*Dd*f**3*s**2 + 56*C*D1*Dd*f**3*s - 14*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r*s - 70*C*D1*Dd*f**2*fd*r + 240*C*D1*Dd*f**2*fd*s**2 - 240*C*D1*Dd*f**2*fd*s + 50*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*r*s - 10*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s**2 - 40*C*D1*Ddd*f**3*s + 10*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*r*s - 30*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s**2 - 120*C*Dd**2*f**3*s + 20*C*Dd**2*f**3 + 15*D1**2*K*bdd1*f**2*r*s + 15*D1**2*K*bdd1*f**2*s**2 - 15*D1**2*K*bdd1*f**2*s - D1**2*bd1**2*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 3*D1**2*bdd1*f**2*r*s + 3*D1**2*bdd1*f**2*r - 3*D1**2*bdd1*f**2*s**2 + 6*D1**2*bdd1*f**2*s - 3*D1**2*bdd1*f**2 - 28*D1**2*bdd1*f*g2*r*s + 28*D1**2*bdd1*f*g2*r - 28*D1**2*bdd1*f*g2*s**2 + 56*D1**2*bdd1*f*g2*s - 28*D1**2*bdd1*f*g2 + 18*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 18*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r*s + 5*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 15*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd + 18*D1**2*f**2*gd2*r*s + 18*D1**2*f**2*gd2*s**2 - 18*D1**2*f**2*gd2*s - 30*D1**2*f**2*gdd2*r*s - 30*D1**2*f**2*gdd2*s**2 + 30*D1**2*f**2*gdd2*s - 30*D1**2*f*fd**2*r*s + 10*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 30*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 + 36*D1**2*f*fd*g2*r*s - 18*D1**2*f*fd*g2*r + 36*D1**2*f*fd*g2*s**2 - 36*D1**2*f*fd*g2*s + 18*D1**2*f*fd*g2 - 120*D1**2*f*fd*gd2*r*s + 30*D1**2*f*fd*gd2*r - 120*D1**2*f*fd*gd2*s**2 + 120*D1**2*f*fd*gd2*s - 30*D1**2*f*fd*gd2 - 60*D1**2*f*fdd*g2*r*s + 30*D1**2*f*fdd*g2*r - 60*D1**2*f*fdd*g2*s**2 + 60*D1**2*f*fdd*g2*s - 30*D1**2*f*fdd*g2 - 60*D1**2*fd**2*g2*r*s + 30*D1**2*fd**2*g2*r - 60*D1**2*fd**2*g2*s**2 + 60*D1**2*fd**2*g2*s + 24*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 24*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r*s + 35*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 120*D1*Dd*f**2*fd*s - 25*D1*Dd*f**2*fd + 72*D1*Dd*f**2*g2*r*s - 18*D1*Dd*f**2*g2*r + 72*D1*Dd*f**2*g2*s**2 - 72*D1*Dd*f**2*g2*s + 18*D1*Dd*f**2*g2 - 240*D1*Dd*f**2*gd2*r*s + 30*D1*Dd*f**2*gd2*r - 240*D1*Dd*f**2*gd2*s**2 + 240*D1*Dd*f**2*gd2*s - 30*D1*Dd*f**2*gd2 - 480*D1*Dd*f*fd*g2*r*s + 180*D1*Dd*f*fd*g2*r - 480*D1*Dd*f*fd*g2*s**2 + 480*D1*Dd*f*fd*g2*s - 120*D1*Dd*f*fd*g2 - 20*D1*Ddd*f**3*r*s + 5*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 20*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 - 120*D1*Ddd*f**2*g2*r*s + 30*D1*Ddd*f**2*g2*r - 120*D1*Ddd*f**2*g2*s**2 + 120*D1*Ddd*f**2*g2*s - 30*D1*Ddd*f**2*g2 - D1*bd1*(D1*(5*f**3*s*(r + s - 1) + f**2*(r + s - 1)*(8*C*(s - 1) + 9*K*s + s + 6) + f*(fd*(-4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 15*K*(r*(4*s - 1) + (1 - 2*s)**2) + 12*r*s - 6*r + 12*s**2 - 15*s + 3) + (-28*r - 28*s + 28)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 28*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(f*(-4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 15*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 24*r*s - 15*r + 24*s**2 - 36*s + 12) + 28*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 60*Dd**2*f**3*r*s + 15*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 60*Dd**2*f**3*s - 10*Dd**2*f**3 - 360*Dd**2*f**2*g2*r*s + 90*Dd**2*f**2*g2*r - 360*Dd**2*f**2*g2*s**2 + 360*Dd**2*f**2*g2*s - 60*Dd**2*f**2*g2 + b1**2*(D1**2*s*(5*f*(2*fd - fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 14*fd*(2*K - 1)*(r + s) + 7*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (14 - 28*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 5*f + 7)) - Dd**2*f*(-14*K + 5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-16*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*s**2 + 8*C*D1**2*f*fd*s + 8*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*s**2 - 4*C*D1**2*f*fdd*s + 8*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*s**2 - 4*C*D1**2*fd**2*s - 32*C*D1*Dd*f**2*r*s + 8*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 32*C*D1*Dd*f**2*s - 8*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r*s - 8*C*D1*Dd*f*fd*r + 64*C*D1*Dd*f*fd*s**2 - 48*C*D1*Dd*f*fd*s + 4*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r*s - 4*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s**2 - 16*C*D1*Ddd*f**2*s + 4*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r*s - 12*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s**2 - 48*C*Dd**2*f**2*s + 8*C*Dd**2*f**2 - 18*D1**2*K*f*fd*r*s + 9*D1**2*K*f*fd*r - 18*D1**2*K*f*fd*s**2 + 18*D1**2*K*f*fd*s - 9*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*s - 1)*(-14*K + 5*f + 7)*(r + s - 1) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd - 2*D1**2*f*fd*r*s + 7*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 7*D1**2*f*fd - 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 28*D1**2*f*gdd2*r*s - 28*D1**2*f*gdd2*s**2 + 28*D1**2*f*gdd2*s - 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s + 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 56*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*s**2 + 28*D1**2*fd*gd2*s - 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*s**2 - 36*D1*Dd*K*f**2*r*s + 9*D1*Dd*K*f**2*r - 36*D1*Dd*K*f**2*s**2 + 36*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 36*D1*Dd*f*fd*s - 3*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 224*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 224*D1*Dd*f*gd2*s**2 + 224*D1*Dd*f*gd2*s - 28*D1*Dd*f*gd2 - 224*D1*Dd*fd*g2*r*s + 28*D1*Dd*fd*g2*r - 224*D1*Dd*fd*g2*s**2 + 112*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 - 112*D1*Ddd*f*g2*r*s + 28*D1*Ddd*f*g2*r - 112*D1*Ddd*f*g2*s**2 + 112*D1*Ddd*f*g2*s - 28*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(2*s - 1)*(r + s - 1) + f*(-5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (14 - 28*K)*(2*s - 1)*(r + s - 1)) + 7*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-14*K + 5*f + 7)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s - 6*Dd**2*f**2 - 336*Dd**2*f*g2*r*s + 84*Dd**2*f*g2*r - 336*Dd**2*f*g2*s**2 + 336*Dd**2*f*g2*s - 56*Dd**2*f*g2))/(35*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct*k1*k2**4*st**2*(D1*(-63*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + D1*bd1*(2*f**2*(r + s - 1)*(33*C*(s - 1) - s*(21*K + 13) + 13) - 3*f*(fd*(18*C - 9)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (14*g2*(s - 1) + 14*gd2*(3 - 6*s))*(r + s - 1)) + 126*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 9*D1*bdd1*f*(s - 1)*(f*(6*C - 3) - 14*g2)*(r + s - 1) - 9*Dd*bd1*f*(f*(6*C - 3) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 6*f*(D1*(f*(fd*(6*C - 3)*(3*r*s - r + 3*s**2 - 3*s + 1) - 14*gd2*s*(r + s - 1)) - 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(6*C - 3) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b1**2*(D1**2*s*(3*f*fd*(2*r + 2*s - 1) + (r + s)*(-9*K*fdd + fd*(3*K + 5))) + D1*(Dd*(9*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 3*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(3*K + 5)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(-63*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(-42*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(66*C - 26)*(2*r + 2*s - 1) - 3*s*(fdd*(18*C - 9)*(2*r + 2*s - 1) + (14*gd2 - 42*gdd2)*(r + s - 1))) - 3*s*(fd**2*(18*C - 9)*(2*r + 2*s - 1) + 14*fd*(g2*(r + s) + gd2*(-6*r - 6*s + 3)) - 42*fdd*g2*(r + s))) + 7*D1*bd1*(D1*(9*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 3*f**2*(2*s - 1)*(r + s - 1) + f*(3*K + 5)*(2*s - 1)*(r + s - 1)) - 9*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + D1*(Dd*(2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(33*C - 21*K - 13) - 3*f*(fd*(18*C - 9)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 14*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 42*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 126*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - 9*Ddd*f*(f*(6*C - 3) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f*(f*(6*C - 3) - 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*k1*k2**2*st**6*(b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) - 18*fd*(2*r*s - r + 2*s**2 - 2*s + 1) + 9*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 9*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 18*r*(4*s - 1) - 18*(1 - 2*s)**2) + 18*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(7*f + 9)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(7*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(7*bdd1*f**2*s*(r + s - 1) + f*(9*bdd1*s*(r + s - 1) + fd*(r*(2 - 6*s) - 6*s**2 + 6*s - 2) + fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(7*f + 9)*(r + s - 1) + 9*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(7*f + 9)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + D1*f*(Dd*(f*(-8*r*s + 2*r - 8*s**2 + 8*s - 2) + fd*(24*r*s - 7*r + 24*s**2 - 24*s + 5)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k3**3) - D1**2*Pkd2*Pkd3*ct*k1*k2**2*st**4*(-4*C*D1**2*bdd1*f**2*r*s - 4*C*D1**2*bdd1*f**2*s**2 - 54*C*D1**2*f**2*fd*r*s + 18*C*D1**2*f**2*fd*r - 54*C*D1**2*f**2*fd*s**2 + 54*C*D1**2*f**2*fd*s - 18*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r*s - 10*C*D1**2*f**2*fdd*r + 30*C*D1**2*f**2*fdd*s**2 - 30*C*D1**2*f**2*fdd*s + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r*s - 20*C*D1**2*f*fd**2*r + 60*C*D1**2*f*fd**2*s**2 - 60*C*D1**2*f*fd**2*s + 10*C*D1**2*f*fd**2 - 72*C*D1*Dd*f**3*r*s + 18*C*D1*Dd*f**3*r - 72*C*D1*Dd*f**3*s**2 + 72*C*D1*Dd*f**3*s - 18*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r*s - 70*C*D1*Dd*f**2*fd*r + 240*C*D1*Dd*f**2*fd*s**2 - 240*C*D1*Dd*f**2*fd*s + 50*C*D1*Dd*f**2*fd + 40*C*D1*Ddd*f**3*r*s - 10*C*D1*Ddd*f**3*r + 40*C*D1*Ddd*f**3*s**2 - 40*C*D1*Ddd*f**3*s + 10*C*D1*Ddd*f**3 + 120*C*Dd**2*f**3*r*s - 30*C*Dd**2*f**3*r + 120*C*Dd**2*f**3*s**2 - 120*C*Dd**2*f**3*s + 20*C*Dd**2*f**3 + 15*D1**2*K*bdd1*f**2*r*s + 15*D1**2*K*bdd1*f**2*s**2 - 15*D1**2*K*bdd1*f**2*s - 46*D1**2*b2*f*fd*r*s + 23*D1**2*b2*f*fd*r - 46*D1**2*b2*f*fd*s**2 + 46*D1**2*b2*f*fd*s - 23*D1**2*b2*f*fd + 30*D1**2*b2*f*fdd*r*s - 15*D1**2*b2*f*fdd*r + 30*D1**2*b2*f*fdd*s**2 - 30*D1**2*b2*f*fdd*s + 15*D1**2*b2*f*fdd + 30*D1**2*b2*fd**2*r*s - 15*D1**2*b2*fd**2*r + 30*D1**2*b2*fd**2*s**2 - 30*D1**2*b2*fd**2*s + D1**2*bd1**2*f*(5*f*(r + 2*s - 1) - 7*r*(4*K*s - 1) - 7*(2*s - 1)*(2*K*s - 1)) - 23*D1**2*bd2*f**2*r*s - 23*D1**2*bd2*f**2*s**2 + 23*D1**2*bd2*f**2*s + 60*D1**2*bd2*f*fd*r*s - 15*D1**2*bd2*f*fd*r + 60*D1**2*bd2*f*fd*s**2 - 60*D1**2*bd2*f*fd*s + 15*D1**2*bd2*f*fd + 2*D1**2*bdd1*f**2*r*s + D1**2*bdd1*f**2*r + 2*D1**2*bdd1*f**2*s**2 + 2*D1**2*bdd1*f**2*s - D1**2*bdd1*f**2 + 28*D1**2*bdd1*f*g2*r*s + 28*D1**2*bdd1*f*g2*s**2 + 15*D1**2*bdd2*f**2*r*s + 15*D1**2*bdd2*f**2*s**2 - 15*D1**2*bdd2*f**2*s + 24*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 24*D1**2*f**2*fd*s**2 - 24*D1**2*f**2*fd*s + 8*D1**2*f**2*fd - 15*D1**2*f**2*fdd*r*s + 5*D1**2*f**2*fdd*r - 15*D1**2*f**2*fdd*s**2 + 15*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd + 46*D1**2*f**2*gd2*r*s + 46*D1**2*f**2*gd2*s**2 - 46*D1**2*f**2*gd2*s - 30*D1**2*f**2*gdd2*r*s - 30*D1**2*f**2*gdd2*s**2 + 30*D1**2*f**2*gdd2*s - 30*D1**2*f*fd**2*r*s + 10*D1**2*f*fd**2*r - 30*D1**2*f*fd**2*s**2 + 30*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 + 92*D1**2*f*fd*g2*r*s - 46*D1**2*f*fd*g2*r + 92*D1**2*f*fd*g2*s**2 - 92*D1**2*f*fd*g2*s + 46*D1**2*f*fd*g2 - 120*D1**2*f*fd*gd2*r*s + 30*D1**2*f*fd*gd2*r - 120*D1**2*f*fd*gd2*s**2 + 120*D1**2*f*fd*gd2*s - 30*D1**2*f*fd*gd2 - 60*D1**2*f*fdd*g2*r*s + 30*D1**2*f*fdd*g2*r - 60*D1**2*f*fdd*g2*s**2 + 60*D1**2*f*fdd*g2*s - 30*D1**2*f*fdd*g2 - 60*D1**2*fd**2*g2*r*s + 30*D1**2*fd**2*g2*r - 60*D1**2*fd**2*g2*s**2 + 60*D1**2*fd**2*g2*s - 92*D1*Dd*b2*f**2*r*s + 23*D1*Dd*b2*f**2*r - 92*D1*Dd*b2*f**2*s**2 + 92*D1*Dd*b2*f**2*s - 23*D1*Dd*b2*f**2 + 240*D1*Dd*b2*f*fd*r*s - 90*D1*Dd*b2*f*fd*r + 240*D1*Dd*b2*f*fd*s**2 - 240*D1*Dd*b2*f*fd*s + 60*D1*Dd*b2*f*fd + 120*D1*Dd*bd2*f**2*r*s - 15*D1*Dd*bd2*f**2*r + 120*D1*Dd*bd2*f**2*s**2 - 120*D1*Dd*bd2*f**2*s + 15*D1*Dd*bd2*f**2 + 32*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 32*D1*Dd*f**3*s**2 - 32*D1*Dd*f**3*s + 8*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r*s + 35*D1*Dd*f**2*fd*r - 120*D1*Dd*f**2*fd*s**2 + 120*D1*Dd*f**2*fd*s - 25*D1*Dd*f**2*fd + 184*D1*Dd*f**2*g2*r*s - 46*D1*Dd*f**2*g2*r + 184*D1*Dd*f**2*g2*s**2 - 184*D1*Dd*f**2*g2*s + 46*D1*Dd*f**2*g2 - 240*D1*Dd*f**2*gd2*r*s + 30*D1*Dd*f**2*gd2*r - 240*D1*Dd*f**2*gd2*s**2 + 240*D1*Dd*f**2*gd2*s - 30*D1*Dd*f**2*gd2 - 480*D1*Dd*f*fd*g2*r*s + 180*D1*Dd*f*fd*g2*r - 480*D1*Dd*f*fd*g2*s**2 + 480*D1*Dd*f*fd*g2*s - 120*D1*Dd*f*fd*g2 + 60*D1*Ddd*b2*f**2*r*s - 15*D1*Ddd*b2*f**2*r + 60*D1*Ddd*b2*f**2*s**2 - 60*D1*Ddd*b2*f**2*s + 15*D1*Ddd*b2*f**2 - 20*D1*Ddd*f**3*r*s + 5*D1*Ddd*f**3*r - 20*D1*Ddd*f**3*s**2 + 20*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 - 120*D1*Ddd*f**2*g2*r*s + 30*D1*Ddd*f**2*g2*r - 120*D1*Ddd*f**2*g2*s**2 + 120*D1*Ddd*f**2*g2*s - 30*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(5*f**3*s*(r + s - 1) + f**2*(r*(s*(-8*C + 23*K + 11) + 2) + s**2*(-8*C + 23*K + 11) - s*(23*K + 3) - 2) + f*(fd*(16*C*r*s - 4*C*r + 16*C*s**2 - 12*C*s - 15*K*(r*(4*s - 1) + (1 - 2*s)**2) - 8*r*s + r - 8*s**2 + 4*s + 1) + 28*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 28*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(-32*C*r*s + 4*C*r - 32*C*s**2 + 16*C*s + 15*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 16*r*s + 2*r + 16*s**2 - 4) + 28*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 180*Dd**2*b2*f**2*r*s - 45*Dd**2*b2*f**2*r + 180*Dd**2*b2*f**2*s**2 - 180*Dd**2*b2*f**2*s + 30*Dd**2*b2*f**2 - 60*Dd**2*f**3*r*s + 15*Dd**2*f**3*r - 60*Dd**2*f**3*s**2 + 60*Dd**2*f**3*s - 10*Dd**2*f**3 - 360*Dd**2*f**2*g2*r*s + 90*Dd**2*f**2*g2*r - 360*Dd**2*f**2*g2*s**2 + 360*Dd**2*f**2*g2*s - 60*Dd**2*f**2*g2 - b1**2*(D1**2*(5*fd**2*(r + 2*s - 1) - 2*fd*(14*K*(s - 1)*(r + s - 1) + 5*f*(r + 2*s - 1) + 7*r + 14*s - 7) + fdd*(14*K*(s - 1)*(r + s - 1) + 5*f*(r + 2*s - 1) + 7*r + 14*s - 7)) + 2*D1*(Dd*(-14*K*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(7*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*f*(r + 2*s - 1) + 14*r + 28*s - 14)) + 7*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 14*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(16*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r + 16*C*D1**2*f*fd*s**2 - 24*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 8*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*r - 8*C*D1**2*f*fdd*s**2 + 12*C*D1**2*f*fdd*s - 4*C*D1**2*f*fdd - 8*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*r - 8*C*D1**2*fd**2*s**2 + 12*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r*s - 8*C*D1*Dd*f**2*r + 32*C*D1*Dd*f**2*s**2 - 32*C*D1*Dd*f**2*s + 8*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r*s + 24*C*D1*Dd*f*fd*r - 64*C*D1*Dd*f*fd*s**2 + 80*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r*s + 4*C*D1*Ddd*f**2*r - 16*C*D1*Ddd*f**2*s**2 + 16*C*D1*Ddd*f**2*s - 4*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r*s + 12*C*Dd**2*f**2*r - 48*C*Dd**2*f**2*s**2 + 48*C*Dd**2*f**2*s - 8*C*Dd**2*f**2 - 46*D1**2*K*f*fd*r*s + 23*D1**2*K*f*fd*r - 46*D1**2*K*f*fd*s**2 + 46*D1**2*K*f*fd*s - 23*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s + D1**2*bdd1*f*(5*f*(r + 2*s - 1) - 7*r*(4*K*s - 1) - 7*(2*s - 1)*(2*K*s - 1)) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd - 22*D1**2*f*fd*r*s + 13*D1**2*f*fd*r - 22*D1**2*f*fd*s**2 + 30*D1**2*f*fd*s - 13*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r + 4*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s + 3*D1**2*f*fdd - 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s + 28*D1**2*f*gdd2*r*s + 28*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s + 4*D1**2*fd**2*r*s - 3*D1**2*fd**2*r + 4*D1**2*fd**2*s**2 - 8*D1**2*fd**2*s + 3*D1**2*fd**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 56*D1**2*fd*g2*s**2 + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 + 56*D1**2*fd*gd2*r*s - 28*D1**2*fd*gd2*r + 56*D1**2*fd*gd2*s**2 - 84*D1**2*fd*gd2*s + 28*D1**2*fd*gd2 + 28*D1**2*fdd*g2*r*s - 28*D1**2*fdd*g2*r + 28*D1**2*fdd*g2*s**2 - 56*D1**2*fdd*g2*s + 28*D1**2*fdd*g2 - 92*D1*Dd*K*f**2*r*s + 23*D1*Dd*K*f**2*r - 92*D1*Dd*K*f**2*s**2 + 92*D1*Dd*K*f**2*s - 23*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 - 44*D1*Dd*f**2*r*s + 11*D1*Dd*f**2*r - 44*D1*Dd*f**2*s**2 + 44*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 16*D1*Dd*f*fd*r + 32*D1*Dd*f*fd*s**2 - 48*D1*Dd*f*fd*s + 14*D1*Dd*f*fd - 224*D1*Dd*f*g2*r*s + 56*D1*Dd*f*g2*r - 224*D1*Dd*f*g2*s**2 + 224*D1*Dd*f*g2*s - 56*D1*Dd*f*g2 + 224*D1*Dd*f*gd2*r*s - 28*D1*Dd*f*gd2*r + 224*D1*Dd*f*gd2*s**2 - 224*D1*Dd*f*gd2*s + 28*D1*Dd*f*gd2 + 224*D1*Dd*fd*g2*r*s - 140*D1*Dd*fd*g2*r + 224*D1*Dd*fd*g2*s**2 - 336*D1*Dd*fd*g2*s + 112*D1*Dd*fd*g2 + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 8*D1*Ddd*f**2*s**2 - 8*D1*Ddd*f**2*s + 2*D1*Ddd*f**2 + 112*D1*Ddd*f*g2*r*s - 28*D1*Ddd*f*g2*r + 112*D1*Ddd*f*g2*s**2 - 112*D1*Ddd*f*g2*s + 28*D1*Ddd*f*g2 - D1*bd1*(D1*(10*f**2*(r + 2*s - 1) - 14*f*(r*(4*K*s - 1) + (2*s - 1)*(2*K*s - 1)) + 7*fd*(2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + r + 2*s - 1)) - 2*Dd*f*(-7*K*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 10*f*(r + 2*s - 1) + 14*r + 28*s - 14)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 24*Dd**2*f**2*s**2 - 24*Dd**2*f**2*s + 4*Dd**2*f**2 + 336*Dd**2*f*g2*r*s - 84*Dd**2*f*g2*r + 336*Dd**2*f*g2*s**2 - 336*Dd**2*f*g2*s + 56*Dd**2*f*g2))/(35*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct*k1*k2**2*st**2*(D1*(-7*D1*bd1**2*(3*K*f*(r*(4*s - 3) + 4*s**2 - 8*s + 3) - f*(4*C - 3)*(r*(2*s - 1) + s*(2*s - 2)) + 20*g2*r*(2*s - 1) + 40*g2*s*(s - 1)) + 7*b2*(bd1*(D1*(13*f*(s - 1)*(r + s - 1) + 9*fd*(-2*r*s + r - s*(2*s - 2))) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + 2*D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + bd1*(-63*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(2*f**2*(C*(r*(50*s - 47) + 50*s**2 - 94*s + 47) - 21*K*s**2 + 21*K*s + r*(-21*K*s - 25*s + 20) - 25*s**2 + 40*s - 20) + f*(-fd*(18*C - 9)*(r*(8*s - 5) + 8*s**2 - 12*s + 3) - 14*g2*(22*r*s - 13*r + 22*s**2 - 26*s + 13) + 42*gd2*(4*r*s - 3*r + 4*s**2 - 8*s + 3)) + 84*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 6*Dd*f*(f*(6*C - 3) - 14*g2)*(r*(8*s - 7) + 8*s**2 - 16*s + 6)) - 3*f*(D1*bdd1*(f*(6*C - 3) - 14*g2)*(r*(2*s - 3) + 2*s**2 - 6*s + 3) + 2*D1*(f*(fd*(6*C - 3)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(7*bd2 - 14*gd2)*(r + s - 1)) - 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 2*Dd*f*(f*(6*C - 3) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - (20*K - 10)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(-10*K + 3*f + 5) - Dd**2*(-10*K + 3*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(-8*C*D1**2*fd*r*s - 8*C*D1**2*fd*s**2 + 8*C*D1**2*fd*s + 4*C*D1**2*fdd*r*s + 4*C*D1**2*fdd*s**2 - 4*C*D1**2*fdd*s - 32*C*D1*Dd*f*r*s + 8*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 + 32*C*D1*Dd*f*s - 8*C*D1*Dd*f + 32*C*D1*Dd*fd*r*s - 4*C*D1*Dd*fd*r + 32*C*D1*Dd*fd*s**2 - 32*C*D1*Dd*fd*s + 4*C*D1*Dd*fd + 16*C*D1*Ddd*f*r*s - 4*C*D1*Ddd*f*r + 16*C*D1*Ddd*f*s**2 - 16*C*D1*Ddd*f*s + 4*C*D1*Ddd*f + 48*C*Dd**2*f*r*s - 12*C*Dd**2*f*r + 48*C*Dd**2*f*s**2 - 48*C*Dd**2*f*s + 8*C*Dd**2*f + 22*D1**2*K*fd*r*s - 9*D1**2*K*fd*r + 22*D1**2*K*fd*s**2 - 18*D1**2*K*fd*s + 9*D1**2*K*fd - 6*D1**2*K*fdd*r*s - 3*D1**2*K*fdd*r - 6*D1**2*K*fdd*s**2 - 6*D1**2*K*fdd*s + 3*D1**2*K*fdd - D1**2*bdd1*(-10*K + 3*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 3*D1**2*f*fd*r + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 6*D1**2*fd*r*s + 5*D1**2*fd*r + 6*D1**2*fd*s**2 + 4*D1**2*fd*s - 5*D1**2*fd - 3*D1**2*fdd*r*s - 3*D1**2*fdd*s**2 + 3*D1**2*fdd*s + 40*D1**2*gd2*r*s + 40*D1**2*gd2*s**2 - 40*D1**2*gd2*s - 20*D1**2*gdd2*r*s - 20*D1**2*gdd2*s**2 + 20*D1**2*gdd2*s + 88*D1*Dd*K*f*r*s - 22*D1*Dd*K*f*r + 88*D1*Dd*K*f*s**2 - 88*D1*Dd*K*f*s + 22*D1*Dd*K*f - 48*D1*Dd*K*fd*r*s - 6*D1*Dd*K*fd*r - 48*D1*Dd*K*fd*s**2 + 12*D1*Dd*K*fd + 24*D1*Dd*f*r*s - 6*D1*Dd*f*r + 24*D1*Dd*f*s**2 - 24*D1*Dd*f*s + 6*D1*Dd*f - 24*D1*Dd*fd*r*s + 3*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 24*D1*Dd*fd*s - 3*D1*Dd*fd + 160*D1*Dd*g2*r*s - 40*D1*Dd*g2*r + 160*D1*Dd*g2*s**2 - 160*D1*Dd*g2*s + 40*D1*Dd*g2 - 160*D1*Dd*gd2*r*s + 20*D1*Dd*gd2*r - 160*D1*Dd*gd2*s**2 + 160*D1*Dd*gd2*s - 20*D1*Dd*gd2 - 24*D1*Ddd*K*f*r*s + 6*D1*Ddd*K*f*r - 24*D1*Ddd*K*f*s**2 + 24*D1*Ddd*K*f*s - 6*D1*Ddd*K*f - 12*D1*Ddd*f*r*s + 3*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 12*D1*Ddd*f*s - 3*D1*Ddd*f - 80*D1*Ddd*g2*r*s + 20*D1*Ddd*g2*r - 80*D1*Ddd*g2*s**2 + 80*D1*Ddd*g2*s - 20*D1*Ddd*g2 + D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + (10 - 20*K)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(-10*K + 3*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 72*Dd**2*K*f*r*s + 18*Dd**2*K*f*r - 72*Dd**2*K*f*s**2 + 72*Dd**2*K*f*s - 12*Dd**2*K*f - 36*Dd**2*f*r*s + 9*Dd**2*f*r - 36*Dd**2*f*s**2 + 36*Dd**2*f*s - 6*Dd**2*f - 240*Dd**2*g2*r*s + 60*Dd**2*g2*r - 240*Dd**2*g2*s**2 + 240*Dd**2*g2*s - 40*Dd**2*g2) + b1*(200*C*D1**2*f*fd*r*s - 6*C*D1**2*f*fd*r + 200*C*D1**2*f*fd*s**2 - 112*C*D1**2*f*fd*s + 6*C*D1**2*f*fd - 72*C*D1**2*f*fdd*r*s - 18*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s**2 + 18*C*D1**2*f*fdd - 72*C*D1**2*fd**2*r*s - 18*C*D1**2*fd**2*r - 72*C*D1**2*fd**2*s**2 + 18*C*D1**2*fd**2 + 400*C*D1*Dd*f**2*r*s - 100*C*D1*Dd*f**2*r + 400*C*D1*Dd*f**2*s**2 - 400*C*D1*Dd*f**2*s + 100*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*r*s - 576*C*D1*Dd*f*fd*s**2 + 288*C*D1*Dd*f*fd*s + 36*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r*s + 36*C*D1*Ddd*f**2*r - 144*C*D1*Ddd*f**2*s**2 + 144*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r*s + 108*C*Dd**2*f**2*r - 432*C*Dd**2*f**2*s**2 + 432*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 - 84*D1**2*K*f*fd*r*s + 42*D1**2*K*f*fd*r - 84*D1**2*K*f*fd*s**2 + 84*D1**2*K*f*fd*s - 42*D1**2*K*f*fd + 91*D1**2*b2*fd*r*s + 91*D1**2*b2*fd*s**2 - 63*D1**2*b2*fdd*r*s - 63*D1**2*b2*fdd*s**2 - 7*D1**2*bd1**2*(-10*K + 3*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 91*D1**2*bd2*f*r*s + 91*D1**2*bd2*f*s**2 - 91*D1**2*bd2*f*s - 126*D1**2*bd2*fd*r*s - 126*D1**2*bd2*fd*s**2 + 63*D1**2*bd2*fd*s + 7*D1**2*bdd1*(f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) - 3*K*(4*r*s - 3*r + 4*s**2 - 8*s + 3) - 6*r*s + 3*r - 6*s**2 + 6*s - 3) - 20*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 63*D1**2*bdd2*f*r*s - 63*D1**2*bdd2*f*s**2 + 63*D1**2*bdd2*f*s - 100*D1**2*f*fd*r*s + 10*D1**2*f*fd*r - 100*D1**2*f*fd*s**2 + 70*D1**2*f*fd*s - 10*D1**2*f*fd + 36*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 9*D1**2*f*fdd - 308*D1**2*f*gd2*r*s - 308*D1**2*f*gd2*s**2 + 308*D1**2*f*gd2*s + 84*D1**2*f*gdd2*r*s + 84*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 36*D1**2*fd**2*r*s + 9*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 9*D1**2*fd**2 - 308*D1**2*fd*g2*r*s + 126*D1**2*fd*g2*r - 308*D1**2*fd*g2*s**2 + 252*D1**2*fd*g2*s - 126*D1**2*fd*g2 + 168*D1**2*fd*gd2*r*s + 42*D1**2*fd*gd2*r + 168*D1**2*fd*gd2*s**2 - 42*D1**2*fd*gd2 + 84*D1**2*fdd*g2*r*s + 42*D1**2*fdd*g2*r + 84*D1**2*fdd*g2*s**2 + 84*D1**2*fdd*g2*s - 42*D1**2*fdd*g2 - 168*D1*Dd*K*f**2*r*s + 42*D1*Dd*K*f**2*r - 168*D1*Dd*K*f**2*s**2 + 168*D1*Dd*K*f**2*s - 42*D1*Dd*K*f**2 + 364*D1*Dd*b2*f*r*s - 91*D1*Dd*b2*f*r + 364*D1*Dd*b2*f*s**2 - 364*D1*Dd*b2*f*s + 91*D1*Dd*b2*f - 504*D1*Dd*b2*fd*r*s + 63*D1*Dd*b2*fd*r - 504*D1*Dd*b2*fd*s**2 + 252*D1*Dd*b2*fd*s - 504*D1*Dd*bd2*f*r*s + 63*D1*Dd*bd2*f*r - 504*D1*Dd*bd2*f*s**2 + 504*D1*Dd*bd2*f*s - 63*D1*Dd*bd2*f - 200*D1*Dd*f**2*r*s + 50*D1*Dd*f**2*r - 200*D1*Dd*f**2*s**2 + 200*D1*Dd*f**2*s - 50*D1*Dd*f**2 + 288*D1*Dd*f*fd*r*s + 288*D1*Dd*f*fd*s**2 - 144*D1*Dd*f*fd*s - 18*D1*Dd*f*fd - 1232*D1*Dd*f*g2*r*s + 308*D1*Dd*f*g2*r - 1232*D1*Dd*f*g2*s**2 + 1232*D1*Dd*f*g2*s - 308*D1*Dd*f*g2 + 672*D1*Dd*f*gd2*r*s - 84*D1*Dd*f*gd2*r + 672*D1*Dd*f*gd2*s**2 - 672*D1*Dd*f*gd2*s + 84*D1*Dd*f*gd2 + 672*D1*Dd*fd*g2*r*s + 84*D1*Dd*fd*g2*r + 672*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2 - 252*D1*Ddd*b2*f*r*s + 63*D1*Ddd*b2*f*r - 252*D1*Ddd*b2*f*s**2 + 252*D1*Ddd*b2*f*s - 63*D1*Ddd*b2*f + 72*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 72*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + 336*D1*Ddd*f*g2*r*s - 84*D1*Ddd*f*g2*r + 336*D1*Ddd*f*g2*s**2 - 336*D1*Ddd*f*g2*s + 84*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(3*f**2*(r + 2*s - 1) + f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-44*r*s + 13*r - 44*s**2 + 48*s - 13) - 12*r*s + 11*r - 12*s**2 + 22*s - 11) + fd*(-4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 3*K*(r*(8*s - 1) + 8*s**2 - 4*s - 1) + 3*r*(4*s - 1) + 3*(1 - 2*s)**2) - 20*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 20*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(-4*C*f*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 3*f*(K*(8*r*(2*s - 1) + 16*s**2 - 24*s + 7) + r*(8*s - 3) + 2*(1 - 2*s)**2) + 20*g2*r*(8*s - 3) + 40*g2*(1 - 2*s)**2)) - 756*Dd**2*b2*f*r*s + 189*Dd**2*b2*f*r - 756*Dd**2*b2*f*s**2 + 756*Dd**2*b2*f*s - 126*Dd**2*b2*f + 216*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 216*Dd**2*f**2*s + 36*Dd**2*f**2 + 1008*Dd**2*f*g2*r*s - 252*Dd**2*f*g2*r + 1008*Dd**2*f*g2*s**2 - 1008*Dd**2*f*g2*s + 168*Dd**2*f*g2))/(105*d**2*k3**3) - D1**2*Pkd2*Pkd3*ct*k1*k2**2*(D1**2*bd1*(10*b2*f*(s - 1)*(r + s - 1) + (bd1*(-2*r*s + r - s*(2*s - 2)) + 2*f*(s - 1)*(r + s - 1))*(f*(6*C - 3) - 10*g2)) + D1*b1*(-5*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - D1*bdd1*(f*(6*C - 3) - 10*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*D1*s*(5*bd2*f*(r + s - 1) + f*fd*(6*C - 3)*(2*r + 2*s - 1) - 10*f*gd2*(r + s - 1) - 10*fd*g2*(r + s)) + 2*Dd*f*(f*(6*C - 3) - 10*g2)*(r*(4*s - 1) + (1 - 2*s)**2) + 10*b2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + bd1*(D1*(-2*f*(9*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 5*K*(2*s - 1)*(r + s - 1) - 14*r*s + 7*r - 14*s**2 + 14*s - 7) + fd*(3 - 6*C)*(r*(4*s - 1) + (1 - 2*s)**2) + 70*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 10*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd*(f*(6*C - 3) - 10*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 5*b1**3*(D1**2*fd*s*(r + s - 1) + D1*(Dd*(-7*K + f + 3) - Ddd*K)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*K*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(D1**2*(-5*K*bdd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-2*fd*(9*C*(r + s - 1) - 5*K*r - 5*K*s - 7*r - 7*s + 7) - (r + s - 1)*(fdd*(6*C - 3) - 70*gd2 - 10*gdd2))) + 5*D1*bd1*(D1*(-7*K + f + 3)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*K*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) + D1*(Dd*(-2*f*(r*(4*s - 1) + (1 - 2*s)**2)*(9*C - 5*K - 7) - fd*(6*C - 3)*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 70*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 10*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - Ddd*(f*(6*C - 3) - 10*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*(f*(6*C - 3) - 10*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(15*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct*k1*st**4*(D1*f*(D1*bd1**2*s*(5*f + 7)*(2*r + 2*s - 1) + D1*bd1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + D1*bdd1*f*s*(r + s) + Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + b1**2*(D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) - 2*fd*(10*f*s - 5*f + 7*s - 7) + fdd*(10*f*s - 5*f + 7*s - 7)) + D1*(Dd*(-10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) - 14*r*(4*s - 1) - 14*(1 - 2*s)**2) + 7*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + Ddd*f*(5*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f*(5*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(7*bdd1*s*(2*r + 2*s - 1) - 2*fd*(2*s - 1)*(r + s - 1) + fdd*(2*s - 1)*(r + s - 1)) + fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) - 2*f*s*(5*f + 7)*(2*r + 2*s - 1) + 7*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(5*f + 7)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*f*(Dd*(f*(-8*r*s + 2*r - 8*s**2 + 8*s - 2) + fd*(16*r*s - 6*r + 16*s**2 - 20*s + 5)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k3) - D1**2*Pkd2*Pkd3*ct*k1*st**2*(D1*(7*D1*bd1**2*f*(r*s*(6*K - 2) + r + s*(K*(6*s - 3) - 2*s + 2)) + 3*D1*bdd1*f*s*(r + s)*(7*b2 + f*(6*C - 3) - 14*g2) + bd1*(D1*(f**2*s*(4 - 22*C)*(r + s) + f*(fd*(18*C - 9)*(r*(4*s - 1) + s*(4*s - 3)) + 7*s*(bd2*(6*r + 6*s - 3) + 2*g2*(r + s) - 6*gd2*(2*r + 2*s - 1))) + 42*fd*g2*(-2*r*s + r - s*(2*s - 2))) + 3*Dd*f*(f*(6*C - 3) - 14*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + 7*b2*(D1*(-f*s*(r + s) + fd*r*(6*s - 3) + 6*fd*s*(s - 1)) + 3*Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 7*b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 10*r*(4*s - 1) + 10*(1 - 2*s)**2) - D1*Ddd*(3*f + 5)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(3*f + 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 7*b1**2*(-D1**2*K*fd*r*s + D1**2*K*fd*r - D1**2*K*fd*s**2 + 2*D1**2*K*fd*s - D1**2*K*fd + 3*D1**2*K*fdd*r*s - 3*D1**2*K*fdd*r + 3*D1**2*K*fdd*s**2 - 6*D1**2*K*fdd*s + 3*D1**2*K*fdd - D1**2*bdd1*(3*f + 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 6*D1**2*f*fd*r*s + 3*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 + 9*D1**2*f*fd*s - 3*D1**2*f*fd - 3*D1**2*fd*r*s + 5*D1**2*fd*r - 3*D1**2*fd*s**2 + 8*D1**2*fd*s - 5*D1**2*fd - D1**2*fdd*r*s - D1**2*fdd*s**2 + D1**2*fdd*s - 4*D1*Dd*K*f*r*s + D1*Dd*K*f*r - 4*D1*Dd*K*f*s**2 + 4*D1*Dd*K*f*s - D1*Dd*K*f + 24*D1*Dd*K*fd*r*s - 15*D1*Dd*K*fd*r + 24*D1*Dd*K*fd*s**2 - 36*D1*Dd*K*fd*s + 12*D1*Dd*K*fd - 12*D1*Dd*f**2*r*s + 3*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 12*D1*Dd*f*r*s + 3*D1*Dd*f*r - 12*D1*Dd*f*s**2 + 12*D1*Dd*f*s - 3*D1*Dd*f - 8*D1*Dd*fd*r*s + D1*Dd*fd*r - 8*D1*Dd*fd*s**2 + 8*D1*Dd*fd*s - D1*Dd*fd + 12*D1*Ddd*K*f*r*s - 3*D1*Ddd*K*f*r + 12*D1*Ddd*K*f*s**2 - 12*D1*Ddd*K*f*s + 3*D1*Ddd*K*f - 4*D1*Ddd*f*r*s + D1*Ddd*f*r - 4*D1*Ddd*f*s**2 + 4*D1*Ddd*f*s - D1*Ddd*f + D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + 30*r*s - 10*r + 30*s**2 - 30*s + 10) - Dd*(3*f + 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 36*Dd**2*K*f*r*s - 9*Dd**2*K*f*r + 36*Dd**2*K*f*s**2 - 36*Dd**2*K*f*s + 6*Dd**2*K*f - 12*Dd**2*f*r*s + 3*Dd**2*f*r - 12*Dd**2*f*s**2 + 12*Dd**2*f*s - 2*Dd**2*f) - b1*(44*C*D1**2*f*fd*r*s - 22*C*D1**2*f*fd*r + 44*C*D1**2*f*fd*s**2 - 66*C*D1**2*f*fd*s + 22*C*D1**2*f*fd - 36*C*D1**2*f*fdd*r*s + 18*C*D1**2*f*fdd*r - 36*C*D1**2*f*fdd*s**2 + 54*C*D1**2*f*fdd*s - 18*C*D1**2*f*fdd - 36*C*D1**2*fd**2*r*s + 18*C*D1**2*fd**2*r - 36*C*D1**2*fd**2*s**2 + 54*C*D1**2*fd**2*s - 18*C*D1**2*fd**2 + 88*C*D1*Dd*f**2*r*s - 22*C*D1*Dd*f**2*r + 88*C*D1*Dd*f**2*s**2 - 88*C*D1*Dd*f**2*s + 22*C*D1*Dd*f**2 - 288*C*D1*Dd*f*fd*r*s + 108*C*D1*Dd*f*fd*r - 288*C*D1*Dd*f*fd*s**2 + 360*C*D1*Dd*f*fd*s - 90*C*D1*Dd*f*fd - 72*C*D1*Ddd*f**2*r*s + 18*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 72*C*D1*Ddd*f**2*s - 18*C*D1*Ddd*f**2 - 216*C*Dd**2*f**2*r*s + 54*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 216*C*Dd**2*f**2*s - 36*C*Dd**2*f**2 + 7*D1**2*b2*fd*r*s - 7*D1**2*b2*fd*r + 7*D1**2*b2*fd*s**2 - 14*D1**2*b2*fd*s + 7*D1**2*b2*fd - 21*D1**2*b2*fdd*r*s + 21*D1**2*b2*fdd*r - 21*D1**2*b2*fdd*s**2 + 42*D1**2*b2*fdd*s - 21*D1**2*b2*fdd + 7*D1**2*bd1**2*(3*f + 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 7*D1**2*bd2*f*r*s + 7*D1**2*bd2*f*s**2 - 7*D1**2*bd2*f*s - 42*D1**2*bd2*fd*r*s + 21*D1**2*bd2*fd*r - 42*D1**2*bd2*fd*s**2 + 63*D1**2*bd2*fd*s - 21*D1**2*bd2*fd - 7*D1**2*bdd1*f*(r*s*(6*K - 2) + r + s**2*(6*K - 2) + s*(2 - 3*K) - 1) - 21*D1**2*bdd2*f*r*s - 21*D1**2*bdd2*f*s**2 + 21*D1**2*bdd2*f*s - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 4*D1**2*f*fd + 18*D1**2*f*fdd*r*s - 9*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 27*D1**2*f*fdd*s + 9*D1**2*f*fdd - 14*D1**2*f*gd2*r*s - 14*D1**2*f*gd2*s**2 + 14*D1**2*f*gd2*s + 42*D1**2*f*gdd2*r*s + 42*D1**2*f*gdd2*s**2 - 42*D1**2*f*gdd2*s + 18*D1**2*fd**2*r*s - 9*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 27*D1**2*fd**2*s + 9*D1**2*fd**2 - 14*D1**2*fd*g2*r*s + 14*D1**2*fd*g2*r - 14*D1**2*fd*g2*s**2 + 28*D1**2*fd*g2*s - 14*D1**2*fd*g2 + 84*D1**2*fd*gd2*r*s - 42*D1**2*fd*gd2*r + 84*D1**2*fd*gd2*s**2 - 126*D1**2*fd*gd2*s + 42*D1**2*fd*gd2 + 42*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*r + 42*D1**2*fdd*g2*s**2 - 84*D1**2*fdd*g2*s + 42*D1**2*fdd*g2 + 28*D1*Dd*b2*f*r*s - 7*D1*Dd*b2*f*r + 28*D1*Dd*b2*f*s**2 - 28*D1*Dd*b2*f*s + 7*D1*Dd*b2*f - 168*D1*Dd*b2*fd*r*s + 105*D1*Dd*b2*fd*r - 168*D1*Dd*b2*fd*s**2 + 252*D1*Dd*b2*fd*s - 84*D1*Dd*b2*fd - 168*D1*Dd*bd2*f*r*s + 21*D1*Dd*bd2*f*r - 168*D1*Dd*bd2*f*s**2 + 168*D1*Dd*bd2*f*s - 21*D1*Dd*bd2*f - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 144*D1*Dd*f*fd*r*s - 54*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 180*D1*Dd*f*fd*s + 45*D1*Dd*f*fd - 56*D1*Dd*f*g2*r*s + 14*D1*Dd*f*g2*r - 56*D1*Dd*f*g2*s**2 + 56*D1*Dd*f*g2*s - 14*D1*Dd*f*g2 + 336*D1*Dd*f*gd2*r*s - 42*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s**2 - 336*D1*Dd*f*gd2*s + 42*D1*Dd*f*gd2 + 336*D1*Dd*fd*g2*r*s - 210*D1*Dd*fd*g2*r + 336*D1*Dd*fd*g2*s**2 - 504*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 - 84*D1*Ddd*b2*f*r*s + 21*D1*Ddd*b2*f*r - 84*D1*Ddd*b2*f*s**2 + 84*D1*Ddd*b2*f*s - 21*D1*Ddd*b2*f + 36*D1*Ddd*f**2*r*s - 9*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 168*D1*Ddd*f*g2*r*s - 42*D1*Ddd*f*g2*r + 168*D1*Ddd*f*g2*s**2 - 168*D1*Ddd*f*g2*s + 42*D1*Ddd*f*g2 + 7*D1*bd1*(D1*(3*f**2*s*(2*r + 2*s - 1) + f*(2*r*(s*(K + 3) + 1) + s**2*(2*K + 6) - s*(K + 1) - 2) - fd*(3*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r*s + r - (1 - 2*s)**2)) + Dd*f*(K*(r*(6 - 48*s) - 48*s**2 + 36*s - 3) + 2*r*(8*s - 3) + 4*(1 - 2*s)**2)) - 252*Dd**2*b2*f*r*s + 63*Dd**2*b2*f*r - 252*Dd**2*b2*f*s**2 + 252*Dd**2*b2*f*s - 42*Dd**2*b2*f + 108*Dd**2*f**2*r*s - 27*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 18*Dd**2*f**2 + 504*Dd**2*f*g2*r*s - 126*Dd**2*f*g2*r + 504*Dd**2*f*g2*s**2 - 504*Dd**2*f*g2*s + 84*Dd**2*f*g2))/(105*d**2*k3) + D1**2*Pkd2*Pkd3*ct*k1*(-D1**2*bd1**2*(r*(2*s - 1) + s*(2*s - 2))*(5*b2 + f*(6*C - 3) - 10*g2) + D1*b1*(-5*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - D1*bdd1*(f*(6*C - 3) - 10*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 5*b2*(D1*bdd1*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + bd1*(D1*r*(2*s - 1) + 2*D1*s**2 - 2*D1*s + D1 + 2*Dd*r*(8*s - 3) + 4*Dd*(1 - 2*s)**2)) + bd1*(-5*D1*bd2*(r*(4*s - 1) + (1 - 2*s)**2) + D1*(f*(2*C + 4)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - fd*(6*C - 3)*(r*(4*s - 1) + (1 - 2*s)**2) + 10*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 10*gd2*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd*(f*(6*C - 3) - 10*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 5*b1**3*(D1**2*fd*s*(r + s - 1) + D1*(Dd*(-K + f + 3) - Ddd*K)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*K*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(2*C*D1**2*fd*r*s + 2*C*D1**2*fd*s**2 - 2*C*D1**2*fd*s - 6*C*D1**2*fdd*r*s - 6*C*D1**2*fdd*s**2 + 6*C*D1**2*fdd*s + 8*C*D1*Dd*f*r*s - 2*C*D1*Dd*f*r + 8*C*D1*Dd*f*s**2 - 8*C*D1*Dd*f*s + 2*C*D1*Dd*f - 48*C*D1*Dd*fd*r*s + 6*C*D1*Dd*fd*r - 48*C*D1*Dd*fd*s**2 + 48*C*D1*Dd*fd*s - 6*C*D1*Dd*fd - 24*C*D1*Ddd*f*r*s + 6*C*D1*Ddd*f*r - 24*C*D1*Ddd*f*s**2 + 24*C*D1*Ddd*f*s - 6*C*D1*Ddd*f - 72*C*Dd**2*f*r*s + 18*C*Dd**2*f*r - 72*C*Dd**2*f*s**2 + 72*C*Dd**2*f*s - 12*C*Dd**2*f - 15*D1**2*K*bdd1*r*s + 5*D1**2*K*bdd1*r - 15*D1**2*K*bdd1*s**2 + 15*D1**2*K*bdd1*s - 5*D1**2*K*bdd1 - 5*D1**2*bd2*r*s - 5*D1**2*bd2*s**2 + 5*D1**2*bd2*s - 5*D1**2*bdd2*r*s - 5*D1**2*bdd2*s**2 + 5*D1**2*bdd2*s + 4*D1**2*fd*r*s + 4*D1**2*fd*s**2 - 4*D1**2*fd*s + 3*D1**2*fdd*r*s + 3*D1**2*fdd*s**2 - 3*D1**2*fdd*s + 10*D1**2*gd2*r*s + 10*D1**2*gd2*s**2 - 10*D1**2*gd2*s + 10*D1**2*gdd2*r*s + 10*D1**2*gdd2*s**2 - 10*D1**2*gdd2*s - 40*D1*Dd*bd2*r*s + 5*D1*Dd*bd2*r - 40*D1*Dd*bd2*s**2 + 40*D1*Dd*bd2*s - 5*D1*Dd*bd2 + 16*D1*Dd*f*r*s - 4*D1*Dd*f*r + 16*D1*Dd*f*s**2 - 16*D1*Dd*f*s + 4*D1*Dd*f + 24*D1*Dd*fd*r*s - 3*D1*Dd*fd*r + 24*D1*Dd*fd*s**2 - 24*D1*Dd*fd*s + 3*D1*Dd*fd + 40*D1*Dd*g2*r*s - 10*D1*Dd*g2*r + 40*D1*Dd*g2*s**2 - 40*D1*Dd*g2*s + 10*D1*Dd*g2 + 80*D1*Dd*gd2*r*s - 10*D1*Dd*gd2*r + 80*D1*Dd*gd2*s**2 - 80*D1*Dd*gd2*s + 10*D1*Dd*gd2 + 12*D1*Ddd*f*r*s - 3*D1*Ddd*f*r + 12*D1*Ddd*f*s**2 - 12*D1*Ddd*f*s + 3*D1*Ddd*f + 40*D1*Ddd*g2*r*s - 10*D1*Ddd*g2*r + 40*D1*Ddd*g2*s**2 - 40*D1*Ddd*g2*s + 10*D1*Ddd*g2 + 5*D1*bd1*(D1*(-K + f + 3)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*K*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) + 36*Dd**2*f*r*s - 9*Dd**2*f*r + 36*Dd**2*f*s**2 - 36*Dd**2*f*s + 6*Dd**2*f + 120*Dd**2*g2*r*s - 30*Dd**2*g2*r + 120*Dd**2*g2*s**2 - 120*Dd**2*g2*s + 20*Dd**2*g2 - 5*b2*(D1*(Dd + Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))))/(15*d**2*k3) + D1**2*Pkd2*Pkd3*f**2*k1**6*st**4*(D1**2*(-f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(-2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) + 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k2*k3**5) - 2*D1**2*Pkd2*Pkd3*f**2*k1**4*k2*st**6*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(77*d**2*k3**5) + D1**2*Pkd2*Pkd3*f**2*k1**2*k2**3*st**8*(D1**2*(-f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(-2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) + 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(99*d**2*k3**5) + D1**2*Pkd2*Pkd3*f*k1**6*st**2*(D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(-2*f*(s - 1)*(r + s - 1) + fd*(6*r*s - 3*r + 6*s**2 - 8*s + 2)) + Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + b1*(-D1**2*s*(3*r + 3*s - 2)*(2*f*fd - f*fdd - 2*fd**2) + D1*f*(Dd*(f*(-8*r*s + 2*r - 8*s**2 + 8*s - 2) + fd*(24*r*s - 3*r + 24*s**2 - 20*s + 2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k2*k3**5) + D1**2*Pkd2*Pkd3*f*k1**4*k2*st**4*(-12*D1**2*b1*f*fd*r*s - 8*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s**2 + 8*D1**2*b1*f*fd + 6*D1**2*b1*f*fdd*r*s + 4*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 - 4*D1**2*b1*f*fdd + 12*D1**2*b1*fd**2*r*s + 8*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 - 4*D1**2*b1*fd**2 + 2*D1**2*bdd1*f**2*(s - 3)*(r + s - 1) + 12*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 12*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 3*D1**2*f**2*fd - 16*D1*Dd*b1*f**2*r*s + 4*D1*Dd*b1*f**2*r - 16*D1*Dd*b1*f**2*s**2 + 16*D1*Dd*b1*f**2*s - 4*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r*s + 10*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 24*D1*Dd*b1*f*fd*s - 8*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 8*D1*Ddd*b1*f**2*r*s - 2*D1*Ddd*b1*f**2*r + 8*D1*Ddd*b1*f**2*s**2 - 8*D1*Ddd*b1*f**2*s + 2*D1*Ddd*b1*f**2 - 2*D1*bd1*f*(D1*(2*f*(s - 3)*(r + s - 1) + fd*(-6*r*s + 7*r - 6*s**2 + 12*s - 4)) + Dd*f*(r*(13 - 8*s) - 8*s**2 + 20*s - 10)) + 24*Dd**2*b1*f**2*r*s - 6*Dd**2*b1*f**2*r + 24*Dd**2*b1*f**2*s**2 - 24*Dd**2*b1*f**2*s + 4*Dd**2*b1*f**2)/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*f*k1**4*st**4*(D1*f*(D1*bd1*(-2*f*s*(2*r + 2*s - 1) + fd*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1)) + D1*bdd1*f*s*(2*r + 2*s - 1) + Dd*bd1*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + b1*(D1**2*(-f*(2*fd - fdd)*(6*r*s - 2*r + 6*s**2 - 7*s + 2) + fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3)) + D1*f*(Dd*(-4*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11)) + 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(105*d**2*k2*k3**3) + D1**2*Pkd2*Pkd3*f*k1**2*k2**3*st**6*(18*D1**2*b1*f*fd*r*s - 8*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fd*s**2 - 20*D1**2*b1*f*fd*s + 8*D1**2*b1*f*fd - 9*D1**2*b1*f*fdd*r*s + 4*D1**2*b1*f*fdd*r - 9*D1**2*b1*f*fdd*s**2 + 10*D1**2*b1*f*fdd*s - 4*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r*s + 8*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 20*D1**2*b1*fd**2*s - 4*D1**2*b1*fd**2 - D1**2*bdd1*f**2*(3*s + 1)*(r + s - 1) + 4*D1**2*f**2*fd*r*s - D1**2*f**2*fd*r + 4*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + D1**2*f**2*fd + 24*D1*Dd*b1*f**2*r*s - 6*D1*Dd*b1*f**2*r + 24*D1*Dd*b1*f**2*s**2 - 24*D1*Dd*b1*f**2*s + 6*D1*Dd*b1*f**2 - 72*D1*Dd*b1*f*fd*r*s + 25*D1*Dd*b1*f*fd*r - 72*D1*Dd*b1*f*fd*s**2 + 76*D1*Dd*b1*f*fd*s - 18*D1*Dd*b1*f*fd + 4*D1*Dd*f**3*r*s - D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s + D1*Dd*f**3 - 12*D1*Ddd*b1*f**2*r*s + 3*D1*Ddd*b1*f**2*r - 12*D1*Ddd*b1*f**2*s**2 + 12*D1*Ddd*b1*f**2*s - 3*D1*Ddd*b1*f**2 + D1*bd1*f*(D1*(2*f*(3*s + 1)*(r + s - 1) + fd*(-18*r*s + r - 18*s**2 + 16*s - 2)) - Dd*f*(24*r*s + r + 4*s*(6*s - 5))) - 36*Dd**2*b1*f**2*r*s + 9*Dd**2*b1*f**2*r - 36*Dd**2*b1*f**2*s**2 + 36*Dd**2*b1*f**2*s - 6*Dd**2*b1*f**2)/(63*d**2*k3**5) + D1**2*Pkd2*Pkd3*f*k1**2*k2*st**6*(D1*f*(4*r + 4*s - 3)*(-D1*bd1*(2*f*s - 6*fd*s + fd) + D1*bdd1*f*s + Dd*bd1*f*(8*s - 1)) + b1*(D1**2*(-f*(2*fd - fdd)*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4) + fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5)) + D1*f*(Dd*(-8*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(24*s - 7)*(4*r + 4*s - 3)) + 4*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 4*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(63*d**2*k3**3) + D1**2*Pkd2*Pkd3*k1**4*k2*st**2*(D1**2*bd1*f**2*(bd1*(4 - 8*s) + f*(2*s - 3))*(r + s - 1) + D1*b1*f*(4*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-8*r*s + 2*r - 8*s**2 + 8*s - 1)) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) + f*(-4*D1*bdd1*(2*s - 1)*(r + s - 1) + D1*fd*(6*r*s + r + 6*s**2 - 3*s - 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + 4*b1**2*(D1**2*s*(2*r + 2*s - 1)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(2 - 16*s) - 16*s**2 + 12*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(35*d**2*k3**5) + D1**2*Pkd2*Pkd3*k1**4*st**2*(D1**2*bd1**2*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1*b1*f*(D1*bdd1*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + bd1*(-2*D1*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + D1*fd*(4*s - 1)*(4*r + 4*s - 3) + Dd*f*(8*s - 3)*(4*r + 4*s - 3))) + b1**2*(-D1**2*s*(4*r + 4*s - 3)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*(-4*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(8*s - 1)*(4*r + 4*s - 3)) + 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k2*k3**3) - D1**2*Pkd2*Pkd3*k1**2*k2**3*st**4*(12*C*D1**2*f**2*fd*r*s - 4*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 12*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r*s + 2*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 6*C*D1**2*f**2*fdd*s - 2*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r*s + 4*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 12*C*D1**2*f*fd**2*s - 2*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r*s - 4*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 16*C*D1*Dd*f**3*s + 4*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r*s + 14*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 48*C*D1*Dd*f**2*fd*s - 10*C*D1*Dd*f**2*fd - 8*C*D1*Ddd*f**3*r*s + 2*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 8*C*D1*Ddd*f**3*s - 2*C*D1*Ddd*f**3 - 24*C*Dd**2*f**3*r*s + 6*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 24*C*Dd**2*f**3*s - 4*C*Dd**2*f**3 - 3*D1**2*K*bdd1*f**2*r*s - 3*D1**2*K*bdd1*f**2*s**2 + 3*D1**2*K*bdd1*f**2*s + 4*D1**2*bd1**2*f**2*(2*s - 1)*(r + s - 1) - 6*D1**2*f**2*fd*r*s + 2*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r*s - D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 3*D1**2*f**2*fdd*s + D1**2*f**2*fdd - 12*D1**2*f**2*gd2*r*s - 12*D1**2*f**2*gd2*s**2 + 12*D1**2*f**2*gd2*s + 6*D1**2*f**2*gdd2*r*s + 6*D1**2*f**2*gdd2*s**2 - 6*D1**2*f**2*gdd2*s + 6*D1**2*f*fd**2*r*s - 2*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 6*D1**2*f*fd**2*s + D1**2*f*fd**2 - 24*D1**2*f*fd*g2*r*s + 12*D1**2*f*fd*g2*r - 24*D1**2*f*fd*g2*s**2 + 24*D1**2*f*fd*g2*s - 12*D1**2*f*fd*g2 + 24*D1**2*f*fd*gd2*r*s - 6*D1**2*f*fd*gd2*r + 24*D1**2*f*fd*gd2*s**2 - 24*D1**2*f*fd*gd2*s + 6*D1**2*f*fd*gd2 + 12*D1**2*f*fdd*g2*r*s - 6*D1**2*f*fdd*g2*r + 12*D1**2*f*fdd*g2*s**2 - 12*D1**2*f*fdd*g2*s + 6*D1**2*f*fdd*g2 + 12*D1**2*fd**2*g2*r*s - 6*D1**2*fd**2*g2*r + 12*D1**2*fd**2*g2*s**2 - 12*D1**2*fd**2*g2*s - 8*D1*Dd*f**3*r*s + 2*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 8*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r*s - 7*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 24*D1*Dd*f**2*fd*s + 5*D1*Dd*f**2*fd - 48*D1*Dd*f**2*g2*r*s + 12*D1*Dd*f**2*g2*r - 48*D1*Dd*f**2*g2*s**2 + 48*D1*Dd*f**2*g2*s - 12*D1*Dd*f**2*g2 + 48*D1*Dd*f**2*gd2*r*s - 6*D1*Dd*f**2*gd2*r + 48*D1*Dd*f**2*gd2*s**2 - 48*D1*Dd*f**2*gd2*s + 6*D1*Dd*f**2*gd2 + 96*D1*Dd*f*fd*g2*r*s - 36*D1*Dd*f*fd*g2*r + 96*D1*Dd*f*fd*g2*s**2 - 96*D1*Dd*f*fd*g2*s + 24*D1*Dd*f*fd*g2 + 4*D1*Ddd*f**3*r*s - D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 4*D1*Ddd*f**3*s + D1*Ddd*f**3 + 24*D1*Ddd*f**2*g2*r*s - 6*D1*Ddd*f**2*g2*r + 24*D1*Ddd*f**2*g2*s**2 - 24*D1*Ddd*f**2*g2*s + 6*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(6*K*f*s*(r + s - 1) - 3*K*fd*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(2*s + 1)*(r + s - 1)) - 3*Dd*K*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 12*Dd**2*f**3*r*s - 3*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 12*Dd**2*f**3*s + 2*Dd**2*f**3 + 72*Dd**2*f**2*g2*r*s - 18*Dd**2*f**2*g2*r + 72*Dd**2*f**2*g2*s**2 - 72*Dd**2*f**2*g2*s + 12*Dd**2*f**2*g2 - 4*b1**2*(D1**2*s*(2*r + 2*s - 1)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(2 - 16*s) - 16*s**2 + 12*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(12*D1**2*K*f*fd*r*s - 6*D1**2*K*f*fd*r + 12*D1**2*K*f*fd*s**2 - 12*D1**2*K*f*fd*s + 6*D1**2*K*f*fd - 6*D1**2*K*f*fdd*r*s + 3*D1**2*K*f*fdd*r - 6*D1**2*K*f*fdd*s**2 + 6*D1**2*K*f*fdd*s - 3*D1**2*K*f*fdd - 6*D1**2*K*fd**2*r*s + 3*D1**2*K*fd**2*r - 6*D1**2*K*fd**2*s**2 + 6*D1**2*K*fd**2*s + 4*D1**2*bdd1*f**2*(2*s - 1)*(r + s - 1) + 6*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 7*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 24*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s**2 - 24*D1*Dd*K*f**2*s + 6*D1*Dd*K*f**2 - 48*D1*Dd*K*f*fd*r*s + 18*D1*Dd*K*f*fd*r - 48*D1*Dd*K*f*fd*s**2 + 48*D1*Dd*K*f*fd*s - 12*D1*Dd*K*f*fd + 8*D1*Dd*f**3*r*s - 2*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 2*D1*Dd*f**3 - 12*D1*Ddd*K*f**2*r*s + 3*D1*Ddd*K*f**2*r - 12*D1*Ddd*K*f**2*s**2 + 12*D1*Ddd*K*f**2*s - 3*D1*Ddd*K*f**2 - 4*D1*bd1*f*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-8*r*s + 2*r - 8*s**2 + 8*s - 1)) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 36*Dd**2*K*f**2*r*s + 9*Dd**2*K*f**2*r - 36*Dd**2*K*f**2*s**2 + 36*Dd**2*K*f**2*s - 6*Dd**2*K*f**2))/(35*d**2*k3**5) - D1**2*Pkd2*Pkd3*k1**2*k2**3*st**2*(72*C*D1**2*b1*f*fd*r*s + 72*C*D1**2*b1*f*fd*s**2 - 36*C*D1**2*b1*f*fd*s - 36*C*D1**2*b1*f*fdd*r*s - 36*C*D1**2*b1*f*fdd*s**2 + 18*C*D1**2*b1*f*fdd*s - 36*C*D1**2*b1*fd**2*r*s - 36*C*D1**2*b1*fd**2*s**2 + 18*C*D1**2*b1*fd**2*s - 18*C*D1**2*f**2*fd*r*s + 6*C*D1**2*f**2*fd*r - 18*C*D1**2*f**2*fd*s**2 + 18*C*D1**2*f**2*fd*s - 6*C*D1**2*f**2*fd + 144*C*D1*Dd*b1*f**2*r*s - 36*C*D1*Dd*b1*f**2*r + 144*C*D1*Dd*b1*f**2*s**2 - 144*C*D1*Dd*b1*f**2*s + 36*C*D1*Dd*b1*f**2 - 288*C*D1*Dd*b1*f*fd*r*s + 36*C*D1*Dd*b1*f*fd*r - 288*C*D1*Dd*b1*f*fd*s**2 + 216*C*D1*Dd*b1*f*fd*s - 18*C*D1*Dd*b1*f*fd - 24*C*D1*Dd*f**3*r*s + 6*C*D1*Dd*f**3*r - 24*C*D1*Dd*f**3*s**2 + 24*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 72*C*D1*Ddd*b1*f**2*r*s + 18*C*D1*Ddd*b1*f**2*r - 72*C*D1*Ddd*b1*f**2*s**2 + 72*C*D1*Ddd*b1*f**2*s - 18*C*D1*Ddd*b1*f**2 - 216*C*Dd**2*b1*f**2*r*s + 54*C*Dd**2*b1*f**2*r - 216*C*Dd**2*b1*f**2*s**2 + 216*C*Dd**2*b1*f**2*s - 36*C*Dd**2*b1*f**2 + 42*D1**2*K*b1**2*fd*r*s + 42*D1**2*K*b1**2*fd*s**2 - 21*D1**2*K*b1**2*fdd*r*s - 21*D1**2*K*b1**2*fdd*s**2 - 14*D1**2*K*b1*f*fd*r*s + 7*D1**2*K*b1*f*fd*r - 14*D1**2*K*b1*f*fd*s**2 + 14*D1**2*K*b1*f*fd*s - 7*D1**2*K*b1*f*fd - 21*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 42*D1**2*b1**2*f*fd*r*s + 42*D1**2*b1**2*f*fd*s**2 - 21*D1**2*b1**2*f*fd*s - 36*D1**2*b1*f*fd*r*s - 36*D1**2*b1*f*fd*s**2 + 18*D1**2*b1*f*fd*s + 18*D1**2*b1*f*fdd*r*s + 18*D1**2*b1*f*fdd*s**2 - 9*D1**2*b1*f*fdd*s - 84*D1**2*b1*f*gd2*r*s - 84*D1**2*b1*f*gd2*s**2 + 84*D1**2*b1*f*gd2*s + 42*D1**2*b1*f*gdd2*r*s + 42*D1**2*b1*f*gdd2*s**2 - 42*D1**2*b1*f*gdd2*s + 18*D1**2*b1*fd**2*r*s + 18*D1**2*b1*fd**2*s**2 - 9*D1**2*b1*fd**2*s - 84*D1**2*b1*fd*g2*r*s - 84*D1**2*b1*fd*g2*s**2 + 84*D1**2*b1*fd*gd2*r*s + 84*D1**2*b1*fd*gd2*s**2 - 42*D1**2*b1*fd*gd2*s + 42*D1**2*b1*fdd*g2*r*s + 42*D1**2*b1*fdd*g2*s**2 - 3*D1**2*bdd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(6*C - 3)*(s - 1) - 14*g2*(s - 1)) + 9*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 9*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 14*D1**2*f**2*gd2*r*s + 14*D1**2*f**2*gd2*s**2 - 14*D1**2*f**2*gd2*s + 28*D1**2*f*fd*g2*r*s - 14*D1**2*f*fd*g2*r + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 + 168*D1*Dd*K*b1**2*f*r*s - 42*D1*Dd*K*b1**2*f*r + 168*D1*Dd*K*b1**2*f*s**2 - 168*D1*Dd*K*b1**2*f*s + 42*D1*Dd*K*b1**2*f - 168*D1*Dd*K*b1**2*fd*r*s + 21*D1*Dd*K*b1**2*fd*r - 168*D1*Dd*K*b1**2*fd*s**2 + 84*D1*Dd*K*b1**2*fd*s - 28*D1*Dd*K*b1*f**2*r*s + 7*D1*Dd*K*b1*f**2*r - 28*D1*Dd*K*b1*f**2*s**2 + 28*D1*Dd*K*b1*f**2*s - 7*D1*Dd*K*b1*f**2 + 84*D1*Dd*b1**2*f**2*r*s - 21*D1*Dd*b1**2*f**2*r + 84*D1*Dd*b1**2*f**2*s**2 - 84*D1*Dd*b1**2*f**2*s + 21*D1*Dd*b1**2*f**2 - 72*D1*Dd*b1*f**2*r*s + 18*D1*Dd*b1*f**2*r - 72*D1*Dd*b1*f**2*s**2 + 72*D1*Dd*b1*f**2*s - 18*D1*Dd*b1*f**2 + 144*D1*Dd*b1*f*fd*r*s - 18*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 108*D1*Dd*b1*f*fd*s + 9*D1*Dd*b1*f*fd - 336*D1*Dd*b1*f*g2*r*s + 84*D1*Dd*b1*f*g2*r - 336*D1*Dd*b1*f*g2*s**2 + 336*D1*Dd*b1*f*g2*s - 84*D1*Dd*b1*f*g2 + 336*D1*Dd*b1*f*gd2*r*s - 42*D1*Dd*b1*f*gd2*r + 336*D1*Dd*b1*f*gd2*s**2 - 336*D1*Dd*b1*f*gd2*s + 42*D1*Dd*b1*f*gd2 + 336*D1*Dd*b1*fd*g2*r*s - 42*D1*Dd*b1*fd*g2*r + 336*D1*Dd*b1*fd*g2*s**2 - 168*D1*Dd*b1*fd*g2*s + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 56*D1*Dd*f**2*g2*r*s - 14*D1*Dd*f**2*g2*r + 56*D1*Dd*f**2*g2*s**2 - 56*D1*Dd*f**2*g2*s + 14*D1*Dd*f**2*g2 - 84*D1*Ddd*K*b1**2*f*r*s + 21*D1*Ddd*K*b1**2*f*r - 84*D1*Ddd*K*b1**2*f*s**2 + 84*D1*Ddd*K*b1**2*f*s - 21*D1*Ddd*K*b1**2*f + 36*D1*Ddd*b1*f**2*r*s - 9*D1*Ddd*b1*f**2*r + 36*D1*Ddd*b1*f**2*s**2 - 36*D1*Ddd*b1*f**2*s + 9*D1*Ddd*b1*f**2 + 168*D1*Ddd*b1*f*g2*r*s - 42*D1*Ddd*b1*f*g2*r + 168*D1*Ddd*b1*f*g2*s**2 - 168*D1*Ddd*b1*f*g2*s + 42*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(36*C*(s - 1) - 7*K*s + 21*b1*(2*s - 1) - 18*s + 18) - 3*f*(fd*(6*C - 3)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(14*r + 14*s - 14)) + 21*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) - 3*Dd*f*(7*K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + f*(6*C - 3)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 14*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 252*Dd**2*K*b1**2*f*r*s + 63*Dd**2*K*b1**2*f*r - 252*Dd**2*K*b1**2*f*s**2 + 252*Dd**2*K*b1**2*f*s - 42*Dd**2*K*b1**2*f + 108*Dd**2*b1*f**2*r*s - 27*Dd**2*b1*f**2*r + 108*Dd**2*b1*f**2*s**2 - 108*Dd**2*b1*f**2*s + 18*Dd**2*b1*f**2 + 504*Dd**2*b1*f*g2*r*s - 126*Dd**2*b1*f*g2*r + 504*Dd**2*b1*f*g2*s**2 - 504*Dd**2*b1*f*g2*s + 84*Dd**2*b1*f*g2)/(105*d**2*k3**5) + D1**2*Pkd2*Pkd3*k1**2*k2*st**4*(12*C*D1**2*f**2*fd*r*s - 4*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 12*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r*s + 2*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 6*C*D1**2*f**2*fdd*s - 2*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r*s + 4*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 12*C*D1**2*f*fd**2*s - 2*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r*s - 4*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 16*C*D1*Dd*f**3*s + 4*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r*s + 14*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 48*C*D1*Dd*f**2*fd*s - 10*C*D1*Dd*f**2*fd - 8*C*D1*Ddd*f**3*r*s + 2*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 8*C*D1*Ddd*f**3*s - 2*C*D1*Ddd*f**3 - 24*C*Dd**2*f**3*r*s + 6*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 24*C*Dd**2*f**3*s - 4*C*Dd**2*f**3 - 3*D1**2*K*bdd1*f**2*r*s - 3*D1**2*K*bdd1*f**2*s**2 + 3*D1**2*K*bdd1*f**2*s + 12*D1**2*b2*f*fd*r*s - 6*D1**2*b2*f*fd*r + 12*D1**2*b2*f*fd*s**2 - 12*D1**2*b2*f*fd*s + 6*D1**2*b2*f*fd - 6*D1**2*b2*f*fdd*r*s + 3*D1**2*b2*f*fdd*r - 6*D1**2*b2*f*fdd*s**2 + 6*D1**2*b2*f*fdd*s - 3*D1**2*b2*f*fdd - 6*D1**2*b2*fd**2*r*s + 3*D1**2*b2*fd**2*r - 6*D1**2*b2*fd**2*s**2 + 6*D1**2*b2*fd**2*s + D1**2*bd1**2*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 3) + 6*D1**2*bd2*f**2*r*s + 6*D1**2*bd2*f**2*s**2 - 6*D1**2*bd2*f**2*s - 12*D1**2*bd2*f*fd*r*s + 3*D1**2*bd2*f*fd*r - 12*D1**2*bd2*f*fd*s**2 + 12*D1**2*bd2*f*fd*s - 3*D1**2*bd2*f*fd - 3*D1**2*bdd2*f**2*r*s - 3*D1**2*bdd2*f**2*s**2 + 3*D1**2*bdd2*f**2*s - 6*D1**2*f**2*fd*r*s + 2*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r*s - D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 3*D1**2*f**2*fdd*s + D1**2*f**2*fdd - 12*D1**2*f**2*gd2*r*s - 12*D1**2*f**2*gd2*s**2 + 12*D1**2*f**2*gd2*s + 6*D1**2*f**2*gdd2*r*s + 6*D1**2*f**2*gdd2*s**2 - 6*D1**2*f**2*gdd2*s + 6*D1**2*f*fd**2*r*s - 2*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 6*D1**2*f*fd**2*s + D1**2*f*fd**2 - 24*D1**2*f*fd*g2*r*s + 12*D1**2*f*fd*g2*r - 24*D1**2*f*fd*g2*s**2 + 24*D1**2*f*fd*g2*s - 12*D1**2*f*fd*g2 + 24*D1**2*f*fd*gd2*r*s - 6*D1**2*f*fd*gd2*r + 24*D1**2*f*fd*gd2*s**2 - 24*D1**2*f*fd*gd2*s + 6*D1**2*f*fd*gd2 + 12*D1**2*f*fdd*g2*r*s - 6*D1**2*f*fdd*g2*r + 12*D1**2*f*fdd*g2*s**2 - 12*D1**2*f*fdd*g2*s + 6*D1**2*f*fdd*g2 + 12*D1**2*fd**2*g2*r*s - 6*D1**2*fd**2*g2*r + 12*D1**2*fd**2*g2*s**2 - 12*D1**2*fd**2*g2*s + 24*D1*Dd*b2*f**2*r*s - 6*D1*Dd*b2*f**2*r + 24*D1*Dd*b2*f**2*s**2 - 24*D1*Dd*b2*f**2*s + 6*D1*Dd*b2*f**2 - 48*D1*Dd*b2*f*fd*r*s + 18*D1*Dd*b2*f*fd*r - 48*D1*Dd*b2*f*fd*s**2 + 48*D1*Dd*b2*f*fd*s - 12*D1*Dd*b2*f*fd - 24*D1*Dd*bd2*f**2*r*s + 3*D1*Dd*bd2*f**2*r - 24*D1*Dd*bd2*f**2*s**2 + 24*D1*Dd*bd2*f**2*s - 3*D1*Dd*bd2*f**2 - 8*D1*Dd*f**3*r*s + 2*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 8*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r*s - 7*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 24*D1*Dd*f**2*fd*s + 5*D1*Dd*f**2*fd - 48*D1*Dd*f**2*g2*r*s + 12*D1*Dd*f**2*g2*r - 48*D1*Dd*f**2*g2*s**2 + 48*D1*Dd*f**2*g2*s - 12*D1*Dd*f**2*g2 + 48*D1*Dd*f**2*gd2*r*s - 6*D1*Dd*f**2*gd2*r + 48*D1*Dd*f**2*gd2*s**2 - 48*D1*Dd*f**2*gd2*s + 6*D1*Dd*f**2*gd2 + 96*D1*Dd*f*fd*g2*r*s - 36*D1*Dd*f*fd*g2*r + 96*D1*Dd*f*fd*g2*s**2 - 96*D1*Dd*f*fd*g2*s + 24*D1*Dd*f*fd*g2 - 12*D1*Ddd*b2*f**2*r*s + 3*D1*Ddd*b2*f**2*r - 12*D1*Ddd*b2*f**2*s**2 + 12*D1*Ddd*b2*f**2*s - 3*D1*Ddd*b2*f**2 + 4*D1*Ddd*f**3*r*s - D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 4*D1*Ddd*f**3*s + D1*Ddd*f**3 + 24*D1*Ddd*f**2*g2*r*s - 6*D1*Ddd*f**2*g2*r + 24*D1*Ddd*f**2*g2*s**2 - 24*D1*Ddd*f**2*g2*s + 6*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(-3*K*fd*(r*(4*s - 1) + (1 - 2*s)**2) + f*s*(6*K*(r + s - 1) + f*(3*r + 3*s - 2))) - 3*Dd*K*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 36*Dd**2*b2*f**2*r*s + 9*Dd**2*b2*f**2*r - 36*Dd**2*b2*f**2*s**2 + 36*Dd**2*b2*f**2*s - 6*Dd**2*b2*f**2 + 12*Dd**2*f**3*r*s - 3*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 12*Dd**2*f**3*s + 2*Dd**2*f**3 + 72*Dd**2*f**2*g2*r*s - 18*Dd**2*f**2*g2*r + 72*Dd**2*f**2*g2*s**2 - 72*Dd**2*f**2*g2*s + 12*Dd**2*f**2*g2 + b1**2*(-D1**2*(2*f*fd - f*fdd - fd**2)*(r*(4*s + 2) + 4*s**2 + s - 2) + D1*f*(Dd*(-4*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(4*r*(8*s + 1) + 32*s**2 - 12*s - 5)) + 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(12*D1**2*K*f*fd*r*s - 6*D1**2*K*f*fd*r + 12*D1**2*K*f*fd*s**2 - 12*D1**2*K*f*fd*s + 6*D1**2*K*f*fd - 6*D1**2*K*f*fdd*r*s + 3*D1**2*K*f*fdd*r - 6*D1**2*K*f*fdd*s**2 + 6*D1**2*K*f*fdd*s - 3*D1**2*K*f*fdd - 6*D1**2*K*fd**2*r*s + 3*D1**2*K*fd**2*r - 6*D1**2*K*fd**2*s**2 + 6*D1**2*K*fd**2*s + D1**2*bdd1*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 4) + 9*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s**2 - 10*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 24*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s**2 - 24*D1*Dd*K*f**2*s + 6*D1*Dd*K*f**2 - 48*D1*Dd*K*f*fd*r*s + 18*D1*Dd*K*f*fd*r - 48*D1*Dd*K*f*fd*s**2 + 48*D1*Dd*K*f*fd*s - 12*D1*Dd*K*f*fd + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 12*D1*Ddd*K*f**2*r*s + 3*D1*Ddd*K*f**2*r - 12*D1*Ddd*K*f**2*s**2 + 12*D1*Ddd*K*f**2*s - 3*D1*Ddd*K*f**2 + D1*bd1*f*(D1*(-2*f*(4*r*(s - 1) + 4*s**2 - 9*s + 4) + fd*(4*s - 1)*(4*r + 4*s - 3)) + Dd*f*(4*r*(8*s - 5) + 32*s**2 - 52*s + 17)) - 36*Dd**2*K*f**2*r*s + 9*Dd**2*K*f**2*r - 36*Dd**2*K*f**2*s**2 + 36*Dd**2*K*f**2*s - 6*Dd**2*K*f**2))/(35*d**2*k3**3) + D1**2*Pkd2*Pkd3*k1**2*k2*st**2*(D1*(-21*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 7*b2*(3*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - f*(3*D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + bd1*(-21*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(f**2*(r + s - 1)*(36*C*(s - 1) - s*(7*K + 18) + 18) - 3*f*(fd*(6*C - 3)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (14*r + 14*s - 14)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 42*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(f*(6*C - 3) - 14*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + f*(-3*D1*bdd1*(s - 1)*(f*(6*C - 3) - 14*g2)*(r + s - 1) + D1*(f*(-fd*(6*C - 3)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-7*bd2 + 14*gd2)*(r + s - 1)) + 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(6*C - 3) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 14*b1**3*(D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r - 8*s**2 + 8*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 7*b1**2*(6*D1**2*K*fd*r*s + 6*D1**2*K*fd*s**2 - 3*D1**2*K*fdd*r*s - 3*D1**2*K*fdd*s**2 - 2*D1**2*bdd1*f*(3*r*s - r + 3*s**2 - 3*s + 1) + 4*D1**2*f*fd*r*s + D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - D1**2*f*fd*s - D1**2*f*fd + 24*D1*Dd*K*f*r*s - 6*D1*Dd*K*f*r + 24*D1*Dd*K*f*s**2 - 24*D1*Dd*K*f*s + 6*D1*Dd*K*f - 24*D1*Dd*K*fd*r*s + 3*D1*Dd*K*fd*r - 24*D1*Dd*K*fd*s**2 + 12*D1*Dd*K*fd*s + 8*D1*Dd*f**2*r*s - 2*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 12*D1*Ddd*K*f*r*s + 3*D1*Ddd*K*f*r - 12*D1*Ddd*K*f*s**2 + 12*D1*Ddd*K*f*s - 3*D1*Ddd*K*f + 2*D1*bd1*(D1*(f*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + fd*(-6*r*s + r - 6*s**2 + 6*s - 1)) + Dd*f*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) - 36*Dd**2*K*f*r*s + 9*Dd**2*K*f*r - 36*Dd**2*K*f*s**2 + 36*Dd**2*K*f*s - 6*Dd**2*K*f) - b1*(-72*C*D1**2*f*fd*r*s - 72*C*D1**2*f*fd*s**2 + 36*C*D1**2*f*fd*s + 36*C*D1**2*f*fdd*r*s + 36*C*D1**2*f*fdd*s**2 - 18*C*D1**2*f*fdd*s + 36*C*D1**2*fd**2*r*s + 36*C*D1**2*fd**2*s**2 - 18*C*D1**2*fd**2*s - 144*C*D1*Dd*f**2*r*s + 36*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 36*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r*s - 36*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 216*C*D1*Dd*f*fd*s + 18*C*D1*Dd*f*fd + 72*C*D1*Ddd*f**2*r*s - 18*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 18*C*D1*Ddd*f**2 + 216*C*Dd**2*f**2*r*s - 54*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 36*C*Dd**2*f**2 + 42*D1**2*K*bdd1*f*r*s - 21*D1**2*K*bdd1*f*r + 42*D1**2*K*bdd1*f*s**2 - 63*D1**2*K*bdd1*f*s + 21*D1**2*K*bdd1*f + 14*D1**2*K*f*fd*r*s - 7*D1**2*K*f*fd*r + 14*D1**2*K*f*fd*s**2 - 14*D1**2*K*f*fd*s + 7*D1**2*K*f*fd + 14*D1**2*bd1**2*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 42*D1**2*bd2*f*r*s - 42*D1**2*bd2*f*s**2 + 42*D1**2*bd2*f*s + 42*D1**2*bd2*fd*r*s + 42*D1**2*bd2*fd*s**2 - 21*D1**2*bd2*fd*s + 21*D1**2*bdd2*f*r*s + 21*D1**2*bdd2*f*s**2 - 21*D1**2*bdd2*f*s + 36*D1**2*f*fd*r*s + 36*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s + 84*D1**2*f*gd2*r*s + 84*D1**2*f*gd2*s**2 - 84*D1**2*f*gd2*s - 42*D1**2*f*gdd2*r*s - 42*D1**2*f*gdd2*s**2 + 42*D1**2*f*gdd2*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 84*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*s**2 - 84*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*s**2 + 42*D1**2*fd*gd2*s - 42*D1**2*fdd*g2*r*s - 42*D1**2*fdd*g2*s**2 + 28*D1*Dd*K*f**2*r*s - 7*D1*Dd*K*f**2*r + 28*D1*Dd*K*f**2*s**2 - 28*D1*Dd*K*f**2*s + 7*D1*Dd*K*f**2 + 168*D1*Dd*bd2*f*r*s - 21*D1*Dd*bd2*f*r + 168*D1*Dd*bd2*f*s**2 - 168*D1*Dd*bd2*f*s + 21*D1*Dd*bd2*f + 72*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 18*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 108*D1*Dd*f*fd*s - 9*D1*Dd*f*fd + 336*D1*Dd*f*g2*r*s - 84*D1*Dd*f*g2*r + 336*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 84*D1*Dd*f*g2 - 336*D1*Dd*f*gd2*r*s + 42*D1*Dd*f*gd2*r - 336*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 42*D1*Dd*f*gd2 - 336*D1*Dd*fd*g2*r*s + 42*D1*Dd*fd*g2*r - 336*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 168*D1*Ddd*f*g2*r*s + 42*D1*Ddd*f*g2*r - 168*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 42*D1*Ddd*f*g2 - 7*D1*bd1*(D1*(6*K*f*(2*s - 1)*(r + s - 1) + 3*K*fd*(-4*r*s + r + s*(3 - 4*s)) + f**2*(4*s - 3)*(r + s - 1)) - 3*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2 - 504*Dd**2*f*g2*r*s + 126*Dd**2*f*g2*r - 504*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 84*Dd**2*f*g2 - 21*b2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(105*d**2*k3**3) + D1**2*Pkd2*Pkd3*k1**2*st**4*(D1**2*bd1**2*f**2*s*(2*r + 2*s - 1) + D1*b1*f*(D1*bd1*(-2*f*s*(2*r + 2*s - 1) + fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1)) + D1*bdd1*f*s*(2*r + 2*s - 1) + Dd*bd1*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + b1**2*(-D1**2*(2*s - 1)*(r + s - 1)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*(f*(-8*r*s + 2*r - 8*s**2 + 8*s - 2) + fd*(16*r*s - 6*r + 16*s**2 - 20*s + 5)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(35*d**2*k2*k3) + D1**2*Pkd2*Pkd3*k2**5*st**6*(D1**2*(f**2*(-fd*(4*C - 2)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(2*C - 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(9*K*(-2*bd1 + bdd1) + 36*gd2 - 18*gdd2)) + f*(fd**2*(2*C - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 9*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) - 9*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 9*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(2 - 4*C)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(9*K*(b1*r*(2 - 8*s) - 2*b1*(1 - 2*s)**2 + bd1*r*(8*s - 1) + 8*bd1*s**2 - 8*bd1*s + bd1) + fd*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 36*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 18*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 18*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(2*C*f + 9*K*b1 - f - 18*g2)) + Dd**2*f**2*(2*C*f + 9*K*b1 - f - 18*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(63*d**2*k3**5) + D1**2*Pkd2*Pkd3*k2**5*st**4*(-8*C*D1**2*b1*f*fd*r*s - 8*C*D1**2*b1*f*fd*s**2 + 4*C*D1**2*b1*f*fd*s + 4*C*D1**2*b1*f*fdd*r*s + 4*C*D1**2*b1*f*fdd*s**2 - 2*C*D1**2*b1*f*fdd*s + 4*C*D1**2*b1*fd**2*r*s + 4*C*D1**2*b1*fd**2*s**2 - 2*C*D1**2*b1*fd**2*s + 6*C*D1**2*f**2*fd*r*s - 2*C*D1**2*f**2*fd*r + 6*C*D1**2*f**2*fd*s**2 - 6*C*D1**2*f**2*fd*s + 2*C*D1**2*f**2*fd - 16*C*D1*Dd*b1*f**2*r*s + 4*C*D1*Dd*b1*f**2*r - 16*C*D1*Dd*b1*f**2*s**2 + 16*C*D1*Dd*b1*f**2*s - 4*C*D1*Dd*b1*f**2 + 32*C*D1*Dd*b1*f*fd*r*s - 4*C*D1*Dd*b1*f*fd*r + 32*C*D1*Dd*b1*f*fd*s**2 - 24*C*D1*Dd*b1*f*fd*s + 2*C*D1*Dd*b1*f*fd + 8*C*D1*Dd*f**3*r*s - 2*C*D1*Dd*f**3*r + 8*C*D1*Dd*f**3*s**2 - 8*C*D1*Dd*f**3*s + 2*C*D1*Dd*f**3 + 8*C*D1*Ddd*b1*f**2*r*s - 2*C*D1*Ddd*b1*f**2*r + 8*C*D1*Ddd*b1*f**2*s**2 - 8*C*D1*Ddd*b1*f**2*s + 2*C*D1*Ddd*b1*f**2 + 24*C*Dd**2*b1*f**2*r*s - 6*C*Dd**2*b1*f**2*r + 24*C*Dd**2*b1*f**2*s**2 - 24*C*Dd**2*b1*f**2*s + 4*C*Dd**2*b1*f**2 - 14*D1**2*K*b1**2*fd*r*s - 14*D1**2*K*b1**2*fd*s**2 + 7*D1**2*K*b1**2*fdd*r*s + 7*D1**2*K*b1**2*fdd*s**2 + 14*D1**2*K*b1*f*fd*r*s - 7*D1**2*K*b1*f*fd*r + 14*D1**2*K*b1*f*fd*s**2 - 14*D1**2*K*b1*f*fd*s + 7*D1**2*K*b1*f*fd + 7*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 4*D1**2*b1*f*fd*r*s + 4*D1**2*b1*f*fd*s**2 - 2*D1**2*b1*f*fd*s - 2*D1**2*b1*f*fdd*r*s - 2*D1**2*b1*f*fdd*s**2 + D1**2*b1*f*fdd*s + 28*D1**2*b1*f*gd2*r*s + 28*D1**2*b1*f*gd2*s**2 - 28*D1**2*b1*f*gd2*s - 14*D1**2*b1*f*gdd2*r*s - 14*D1**2*b1*f*gdd2*s**2 + 14*D1**2*b1*f*gdd2*s - 2*D1**2*b1*fd**2*r*s - 2*D1**2*b1*fd**2*s**2 + D1**2*b1*fd**2*s + 28*D1**2*b1*fd*g2*r*s + 28*D1**2*b1*fd*g2*s**2 - 28*D1**2*b1*fd*gd2*r*s - 28*D1**2*b1*fd*gd2*s**2 + 14*D1**2*b1*fd*gd2*s - 14*D1**2*b1*fdd*g2*r*s - 14*D1**2*b1*fdd*g2*s**2 + D1**2*bdd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(2*C - 1)*(s - 1) - 14*g2*(s - 1)) - 3*D1**2*f**2*fd*r*s + D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s**2 + 3*D1**2*f**2*fd*s - D1**2*f**2*fd - 14*D1**2*f**2*gd2*r*s - 14*D1**2*f**2*gd2*s**2 + 14*D1**2*f**2*gd2*s - 28*D1**2*f*fd*g2*r*s + 14*D1**2*f*fd*g2*r - 28*D1**2*f*fd*g2*s**2 + 28*D1**2*f*fd*g2*s - 14*D1**2*f*fd*g2 - 56*D1*Dd*K*b1**2*f*r*s + 14*D1*Dd*K*b1**2*f*r - 56*D1*Dd*K*b1**2*f*s**2 + 56*D1*Dd*K*b1**2*f*s - 14*D1*Dd*K*b1**2*f + 56*D1*Dd*K*b1**2*fd*r*s - 7*D1*Dd*K*b1**2*fd*r + 56*D1*Dd*K*b1**2*fd*s**2 - 28*D1*Dd*K*b1**2*fd*s + 28*D1*Dd*K*b1*f**2*r*s - 7*D1*Dd*K*b1*f**2*r + 28*D1*Dd*K*b1*f**2*s**2 - 28*D1*Dd*K*b1*f**2*s + 7*D1*Dd*K*b1*f**2 + 8*D1*Dd*b1*f**2*r*s - 2*D1*Dd*b1*f**2*r + 8*D1*Dd*b1*f**2*s**2 - 8*D1*Dd*b1*f**2*s + 2*D1*Dd*b1*f**2 - 16*D1*Dd*b1*f*fd*r*s + 2*D1*Dd*b1*f*fd*r - 16*D1*Dd*b1*f*fd*s**2 + 12*D1*Dd*b1*f*fd*s - D1*Dd*b1*f*fd + 112*D1*Dd*b1*f*g2*r*s - 28*D1*Dd*b1*f*g2*r + 112*D1*Dd*b1*f*g2*s**2 - 112*D1*Dd*b1*f*g2*s + 28*D1*Dd*b1*f*g2 - 112*D1*Dd*b1*f*gd2*r*s + 14*D1*Dd*b1*f*gd2*r - 112*D1*Dd*b1*f*gd2*s**2 + 112*D1*Dd*b1*f*gd2*s - 14*D1*Dd*b1*f*gd2 - 112*D1*Dd*b1*fd*g2*r*s + 14*D1*Dd*b1*fd*g2*r - 112*D1*Dd*b1*fd*g2*s**2 + 56*D1*Dd*b1*fd*g2*s - 4*D1*Dd*f**3*r*s + D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 4*D1*Dd*f**3*s - D1*Dd*f**3 - 56*D1*Dd*f**2*g2*r*s + 14*D1*Dd*f**2*g2*r - 56*D1*Dd*f**2*g2*s**2 + 56*D1*Dd*f**2*g2*s - 14*D1*Dd*f**2*g2 + 28*D1*Ddd*K*b1**2*f*r*s - 7*D1*Ddd*K*b1**2*f*r + 28*D1*Ddd*K*b1**2*f*s**2 - 28*D1*Ddd*K*b1**2*f*s + 7*D1*Ddd*K*b1**2*f - 4*D1*Ddd*b1*f**2*r*s + D1*Ddd*b1*f**2*r - 4*D1*Ddd*b1*f**2*s**2 + 4*D1*Ddd*b1*f**2*s - D1*Ddd*b1*f**2 - 56*D1*Ddd*b1*f*g2*r*s + 14*D1*Ddd*b1*f*g2*r - 56*D1*Ddd*b1*f*g2*s**2 + 56*D1*Ddd*b1*f*g2*s - 14*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(-f**2*(r + s - 1)*(4*C*(s - 1) - 7*K*s - 2*s + 2) + f*(fd*(2*C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(14*r + 14*s - 14)) - 7*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(7*K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + f*(2*C - 1)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 14*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) + 84*Dd**2*K*b1**2*f*r*s - 21*Dd**2*K*b1**2*f*r + 84*Dd**2*K*b1**2*f*s**2 - 84*Dd**2*K*b1**2*f*s + 14*Dd**2*K*b1**2*f - 12*Dd**2*b1*f**2*r*s + 3*Dd**2*b1*f**2*r - 12*Dd**2*b1*f**2*s**2 + 12*Dd**2*b1*f**2*s - 2*Dd**2*b1*f**2 - 168*Dd**2*b1*f*g2*r*s + 42*Dd**2*b1*f*g2*r - 168*Dd**2*b1*f*g2*s**2 + 168*Dd**2*b1*f*g2*s - 28*Dd**2*b1*f*g2)/(35*d**2*k3**5) + D1**2*Pkd2*Pkd3*k2**3*st**6*(12*C*D1**2*f**2*fd*r*s - 4*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 12*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r*s + 2*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 6*C*D1**2*f**2*fdd*s - 2*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r*s + 4*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 12*C*D1**2*f*fd**2*s - 2*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r*s - 4*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 16*C*D1*Dd*f**3*s + 4*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r*s + 14*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 48*C*D1*Dd*f**2*fd*s - 10*C*D1*Dd*f**2*fd - 8*C*D1*Ddd*f**3*r*s + 2*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 8*C*D1*Ddd*f**3*s - 2*C*D1*Ddd*f**3 - 24*C*Dd**2*f**3*r*s + 6*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 24*C*Dd**2*f**3*s - 4*C*Dd**2*f**3 + 36*D1**2*K*b1*f*fd*r*s - 18*D1**2*K*b1*f*fd*r + 36*D1**2*K*b1*f*fd*s**2 - 36*D1**2*K*b1*f*fd*s + 18*D1**2*K*b1*f*fd - 18*D1**2*K*b1*f*fdd*r*s + 9*D1**2*K*b1*f*fdd*r - 18*D1**2*K*b1*f*fdd*s**2 + 18*D1**2*K*b1*f*fdd*s - 9*D1**2*K*b1*f*fdd - 18*D1**2*K*b1*fd**2*r*s + 9*D1**2*K*b1*fd**2*r - 18*D1**2*K*b1*fd**2*s**2 + 18*D1**2*K*b1*fd**2*s + 18*D1**2*K*bd1*f**2*r*s + 18*D1**2*K*bd1*f**2*s**2 - 18*D1**2*K*bd1*f**2*s - 36*D1**2*K*bd1*f*fd*r*s + 9*D1**2*K*bd1*f*fd*r - 36*D1**2*K*bd1*f*fd*s**2 + 36*D1**2*K*bd1*f*fd*s - 9*D1**2*K*bd1*f*fd - 9*D1**2*K*bdd1*f**2*r*s - 9*D1**2*K*bdd1*f**2*s**2 + 9*D1**2*K*bdd1*f**2*s - 9*D1**2*bdd2*f**2*r*s - 9*D1**2*bdd2*f**2*s**2 + 9*D1**2*bdd2*f**2*s - 6*D1**2*f**2*fd*r*s + 2*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r*s - D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 3*D1**2*f**2*fdd*s + D1**2*f**2*fdd - 36*D1**2*f**2*gd2*r*s - 36*D1**2*f**2*gd2*s**2 + 36*D1**2*f**2*gd2*s + 18*D1**2*f**2*gdd2*r*s + 18*D1**2*f**2*gdd2*s**2 - 18*D1**2*f**2*gdd2*s + 6*D1**2*f*fd**2*r*s - 2*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 6*D1**2*f*fd**2*s + D1**2*f*fd**2 - 72*D1**2*f*fd*g2*r*s + 36*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 72*D1**2*f*fd*g2*s - 36*D1**2*f*fd*g2 + 72*D1**2*f*fd*gd2*r*s - 18*D1**2*f*fd*gd2*r + 72*D1**2*f*fd*gd2*s**2 - 72*D1**2*f*fd*gd2*s + 18*D1**2*f*fd*gd2 + 36*D1**2*f*fdd*g2*r*s - 18*D1**2*f*fdd*g2*r + 36*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 18*D1**2*f*fdd*g2 + 36*D1**2*fd**2*g2*r*s - 18*D1**2*fd**2*g2*r + 36*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 72*D1*Dd*K*b1*f**2*r*s - 18*D1*Dd*K*b1*f**2*r + 72*D1*Dd*K*b1*f**2*s**2 - 72*D1*Dd*K*b1*f**2*s + 18*D1*Dd*K*b1*f**2 - 144*D1*Dd*K*b1*f*fd*r*s + 54*D1*Dd*K*b1*f*fd*r - 144*D1*Dd*K*b1*f*fd*s**2 + 144*D1*Dd*K*b1*f*fd*s - 36*D1*Dd*K*b1*f*fd - 72*D1*Dd*K*bd1*f**2*r*s + 9*D1*Dd*K*bd1*f**2*r - 72*D1*Dd*K*bd1*f**2*s**2 + 72*D1*Dd*K*bd1*f**2*s - 9*D1*Dd*K*bd1*f**2 - 8*D1*Dd*f**3*r*s + 2*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 8*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r*s - 7*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 24*D1*Dd*f**2*fd*s + 5*D1*Dd*f**2*fd - 144*D1*Dd*f**2*g2*r*s + 36*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 144*D1*Dd*f**2*g2*s - 36*D1*Dd*f**2*g2 + 144*D1*Dd*f**2*gd2*r*s - 18*D1*Dd*f**2*gd2*r + 144*D1*Dd*f**2*gd2*s**2 - 144*D1*Dd*f**2*gd2*s + 18*D1*Dd*f**2*gd2 + 288*D1*Dd*f*fd*g2*r*s - 108*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s**2 - 288*D1*Dd*f*fd*g2*s + 72*D1*Dd*f*fd*g2 - 36*D1*Ddd*K*b1*f**2*r*s + 9*D1*Ddd*K*b1*f**2*r - 36*D1*Ddd*K*b1*f**2*s**2 + 36*D1*Ddd*K*b1*f**2*s - 9*D1*Ddd*K*b1*f**2 + 4*D1*Ddd*f**3*r*s - D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 4*D1*Ddd*f**3*s + D1*Ddd*f**3 + 72*D1*Ddd*f**2*g2*r*s - 18*D1*Ddd*f**2*g2*r + 72*D1*Ddd*f**2*g2*s**2 - 72*D1*Ddd*f**2*g2*s + 18*D1*Ddd*f**2*g2 + 9*D1*bd2*f*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 108*Dd**2*K*b1*f**2*r*s + 27*Dd**2*K*b1*f**2*r - 108*Dd**2*K*b1*f**2*s**2 + 108*Dd**2*K*b1*f**2*s - 18*Dd**2*K*b1*f**2 + 12*Dd**2*f**3*r*s - 3*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 12*Dd**2*f**3*s + 2*Dd**2*f**3 + 216*Dd**2*f**2*g2*r*s - 54*Dd**2*f**2*g2*r + 216*Dd**2*f**2*g2*s**2 - 216*Dd**2*f**2*g2*s + 36*Dd**2*f**2*g2 + 9*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(63*d**2*k3**3) + D1**2*Pkd2*Pkd3*k2**3*st**4*(D1*(7*D1*K*bd1**2*f*(r + 2*s - 1) + 7*K*b1**2*(r + 2*s - 1)*(2*D1*fd - D1*fdd - 4*Dd*fd) + b1*(7*D1*bd2*s*(2*f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + D1*f*(7*K*bdd1*(r + 2*s - 1) - 7*bdd2*s*(r + s - 1) + fd*(4*C*(r + 2*s - 1) - 7*K*(2*r*s - r + 2*s**2 - 2*s + 1) - 2*r - 4*s + 2) - fdd*(2*C - 1)*(r + 2*s - 1)) - D1*(r + 2*s - 1)*(fd**2*(2*C - 1) + 14*fd*(2*g2 - gd2) - 14*fdd*g2) - 7*Dd*K*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 7*Dd*bd2*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + Dd*f*fd*(4 - 8*C)*(r + 2*s - 1) + 56*Dd*fd*g2*(r + 2*s - 1)) - bd1*(7*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(7*K*b1*fd*(r + 2*s - 1) + f**2*(4*C*(r + 2*s - 1) + 7*K*s**2 - 7*K*s + r*(7*K*s - 2) - 4*s + 2) - f*(r + 2*s - 1)*(-14*K*b1 + fd*(2*C - 1) + 28*g2 - 14*gd2)) - 4*Dd*f*(r + 2*s - 1)*(2*C*f + 7*K*b1 - f - 14*g2)) + f*(D1*bdd1*(f*(2*C - 1) - 14*g2)*(r + 2*s - 1) + D1*(f*(-fd*(2*C - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + s*(-7*bd2 + 14*gd2)*(r + s - 1)) + 14*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(2*C - 1) - 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 7*b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(35*d**2*k3**3) - D1**2*Pkd2*Pkd3*k2**3*st**2*(D1**2*bd1*(5*b2*f*(s - 1)*(r + s - 1) - (f*(2*C - 1) - 10*g2)*(bd1*r*(2*s - 1) + 2*bd1*s*(s - 1) + f*(r + 2*s - 1))) + D1*b1*(2*C*D1*f*fd*r + 4*C*D1*f*fd*s - 2*C*D1*f*fd - 5*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 5*D1*b2*fd*r*s + 5*D1*b2*fd*s**2 + 5*D1*bd2*f*r*s + 5*D1*bd2*f*s**2 - 5*D1*bd2*f*s - D1*bdd1*(f*(2*C - 1) - 10*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - D1*f*fd*r - 2*D1*f*fd*s + D1*f*fd - 10*D1*fd*g2*r - 20*D1*fd*g2*s + 10*D1*fd*g2 + 20*Dd*b2*f*r*s - 5*Dd*b2*f*r + 20*Dd*b2*f*s**2 - 20*Dd*b2*f*s + 5*Dd*b2*f + bd1*(D1*(f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) - 5*K*(r + 2*s - 1) - 4*r*s + 2*r - 4*s**2 + 4*s - 2) - fd*(2*C - 1)*(r*(4*s - 1) + (1 - 2*s)**2) - 10*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 10*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd*(f*(2*C - 1) - 10*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 5*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(D1**2*(4*C*fd*r*s + 4*C*fd*s**2 - 4*C*fd*s - 2*C*fdd*r*s - 2*C*fdd*s**2 + 2*C*fdd*s + 10*K*bd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*K*bdd1*(3*r*s - r + 3*s**2 - 3*s + 1) + 5*K*fd*r + 10*K*fd*s - 5*K*fd - 2*fd*r*s - 2*fd*s**2 + 2*fd*s + fdd*r*s + fdd*s**2 - fdd*s - 20*gd2*r*s - 20*gd2*s**2 + 20*gd2*s + 10*gdd2*r*s + 10*gdd2*s**2 - 10*gdd2*s) + D1*(Dd*(-5*K*bd1*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + f*(4*C - 2)*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(2*C - 1)*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 20*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 10*gd2*(8*r*s - r + 8*s**2 - 8*s + 1)) - Ddd*(f*(2*C - 1) - 10*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*(f*(2*C - 1) - 10*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(15*d**2*k3**3) + D1**2*Pkd2*Pkd3*k2*st**4*(D1*(-7*D1*K*bd1**2*f*s*(2*r + 2*s - 1) - D1*bdd1*f*s*(r + s)*(f*(2*C - 1) - 14*g2) - 7*b2*(D1*bd1*(-2*f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + D1*bdd1*f*s*(r + s) + Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) - bd1*(D1*(f**2*s*(2 - 4*C)*(r + s) + f*(fd*(2*C - 1)*(r*(4*s - 1) + s*(4*s - 3)) + 7*s*(bd2*(2*r + 2*s - 1) + 4*g2*(r + s) + gd2*(-4*r - 4*s + 2))) + 14*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(2*C - 1) - 14*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 7*K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(8*C*D1**2*f*fd*r*s - 4*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 12*C*D1**2*f*fd*s + 4*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r*s + 2*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 6*C*D1**2*f*fdd*s - 2*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r*s + 2*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 6*C*D1**2*fd**2*s - 2*C*D1**2*fd**2 + 16*C*D1*Dd*f**2*r*s - 4*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 16*C*D1*Dd*f**2*s + 4*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r*s + 12*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 40*C*D1*Dd*f*fd*s - 10*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r*s + 2*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 8*C*D1*Ddd*f**2*s - 2*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r*s + 6*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 24*C*Dd**2*f**2*s - 4*C*Dd**2*f**2 + 28*D1**2*K*bd1*f*r*s + 28*D1**2*K*bd1*f*s**2 - 14*D1**2*K*bd1*f*s - 28*D1**2*K*bd1*fd*r*s + 14*D1**2*K*bd1*fd*r - 28*D1**2*K*bd1*fd*s**2 + 35*D1**2*K*bd1*fd*s - 7*D1**2*K*bd1*fd - 14*D1**2*K*bdd1*f*r*s - 14*D1**2*K*bdd1*f*s**2 + 7*D1**2*K*bdd1*f*s - 7*D1**2*bdd2*f*r*s - 7*D1**2*bdd2*f*s**2 + 7*D1**2*bdd2*f*s - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s - 2*D1**2*f*fd + 2*D1**2*f*fdd*r*s - D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 3*D1**2*f*fdd*s + D1**2*f*fdd - 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*s**2 + 28*D1**2*f*gd2*s + 14*D1**2*f*gdd2*r*s + 14*D1**2*f*gdd2*s**2 - 14*D1**2*f*gdd2*s + 2*D1**2*fd**2*r*s - D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 3*D1**2*fd**2*s + D1**2*fd**2 - 28*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*r - 28*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 28*D1**2*fd*gd2*r*s - 14*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 42*D1**2*fd*gd2*s + 14*D1**2*fd*gd2 + 14*D1**2*fdd*g2*r*s - 14*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 28*D1**2*fdd*g2*s + 14*D1**2*fdd*g2 - 112*D1*Dd*K*bd1*f*r*s + 14*D1*Dd*K*bd1*f*r - 112*D1*Dd*K*bd1*f*s**2 + 84*D1*Dd*K*bd1*f*s - 7*D1*Dd*K*bd1*f - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 8*D1*Dd*f**2*s - 2*D1*Dd*f**2 + 16*D1*Dd*f*fd*r*s - 6*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 20*D1*Dd*f*fd*s + 5*D1*Dd*f*fd - 112*D1*Dd*f*g2*r*s + 28*D1*Dd*f*g2*r - 112*D1*Dd*f*g2*s**2 + 112*D1*Dd*f*g2*s - 28*D1*Dd*f*g2 + 112*D1*Dd*f*gd2*r*s - 14*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 112*D1*Dd*f*gd2*s + 14*D1*Dd*f*gd2 + 112*D1*Dd*fd*g2*r*s - 70*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s + 56*D1*Dd*fd*g2 + 4*D1*Ddd*f**2*r*s - D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 4*D1*Ddd*f**2*s + D1*Ddd*f**2 + 56*D1*Ddd*f*g2*r*s - 14*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 56*D1*Ddd*f*g2*s + 14*D1*Ddd*f*g2 + 7*D1*bd2*(D1*(r + s - 1)*(2*f*s - 2*fd*s + fd) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 12*Dd**2*f**2*r*s - 3*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 12*Dd**2*f**2*s + 2*Dd**2*f**2 + 168*Dd**2*f*g2*r*s - 42*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 168*Dd**2*f*g2*s + 28*Dd**2*f*g2 + 7*b2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(35*d**2*k3) - D1**2*Pkd2*Pkd3*k2*st**2*(D1**2*bd1*(5*b2 + f*(2*C - 1) - 10*g2)*(bd1*r*(2*s - 1) + 2*bd1*s*(s - 1) + f*s*(r + s)) + D1*b1*(4*C*D1*bdd1*f*r*s - 2*C*D1*bdd1*f*r + 4*C*D1*bdd1*f*s**2 - 4*C*D1*bdd1*f*s + 2*C*D1*bdd1*f + 4*C*D1*f*fd*r*s - 2*C*D1*f*fd*r + 4*C*D1*f*fd*s**2 - 6*C*D1*f*fd*s + 2*C*D1*f*fd + 8*C*Dd*f**2*r*s - 2*C*Dd*f**2*r + 8*C*Dd*f**2*s**2 - 8*C*Dd*f**2*s + 2*C*Dd*f**2 + 5*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 5*D1*bd2*f*r*s + 5*D1*bd2*f*s**2 - 5*D1*bd2*f*s - 2*D1*bdd1*f*r*s + D1*bdd1*f*r - 2*D1*bdd1*f*s**2 + 2*D1*bdd1*f*s - D1*bdd1*f - 20*D1*bdd1*g2*r*s + 10*D1*bdd1*g2*r - 20*D1*bdd1*g2*s**2 + 20*D1*bdd1*g2*s - 10*D1*bdd1*g2 - 2*D1*f*fd*r*s + D1*f*fd*r - 2*D1*f*fd*s**2 + 3*D1*f*fd*s - D1*f*fd - 10*D1*f*gd2*r*s - 10*D1*f*gd2*s**2 + 10*D1*f*gd2*s - 10*D1*fd*g2*r*s + 10*D1*fd*g2*r - 10*D1*fd*g2*s**2 + 20*D1*fd*g2*s - 10*D1*fd*g2 - 4*Dd*f**2*r*s + Dd*f**2*r - 4*Dd*f**2*s**2 + 4*Dd*f**2*s - Dd*f**2 - 40*Dd*f*g2*r*s + 10*Dd*f*g2*r - 40*Dd*f*g2*s**2 + 40*Dd*f*g2*s - 10*Dd*f*g2 - 5*b2*(-D1*bdd1*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - D1*fd*r*s + D1*fd*r - D1*fd*s**2 + 2*D1*fd*s - D1*fd - 4*Dd*f*r*s + Dd*f*r - 4*Dd*f*s**2 + 4*Dd*f*s - Dd*f + 2*bd1*(D1*r*(2*s - 1) + 2*D1*s**2 - 2*D1*s + D1 + Dd*r*(3 - 8*s) - 2*Dd*(1 - 2*s)**2)) + bd1*(5*D1*bd2*(r*(4*s - 1) + (1 - 2*s)**2) + D1*(f*(C*(r*(4 - 8*s) - 8*s**2 + 8*s - 4) + 10*K*s**2 - 5*K*s + 2*r*(5*K*s + 2*s - 1) + 4*s**2 - 4*s + 2) + fd*(2*C - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 10*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 10*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(f*(2*C - 1) - 10*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 5*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(-4*C*D1**2*fd*r*s - 4*C*D1**2*fd*s**2 + 4*C*D1**2*fd*s + 2*C*D1**2*fdd*r*s + 2*C*D1**2*fdd*s**2 - 2*C*D1**2*fdd*s - 16*C*D1*Dd*f*r*s + 4*C*D1*Dd*f*r - 16*C*D1*Dd*f*s**2 + 16*C*D1*Dd*f*s - 4*C*D1*Dd*f + 16*C*D1*Dd*fd*r*s - 2*C*D1*Dd*fd*r + 16*C*D1*Dd*fd*s**2 - 16*C*D1*Dd*fd*s + 2*C*D1*Dd*fd + 8*C*D1*Ddd*f*r*s - 2*C*D1*Ddd*f*r + 8*C*D1*Ddd*f*s**2 - 8*C*D1*Ddd*f*s + 2*C*D1*Ddd*f + 24*C*Dd**2*f*r*s - 6*C*Dd**2*f*r + 24*C*Dd**2*f*s**2 - 24*C*Dd**2*f*s + 4*C*Dd**2*f - 30*D1**2*K*bd1*r*s + 10*D1**2*K*bd1*r - 30*D1**2*K*bd1*s**2 + 30*D1**2*K*bd1*s - 10*D1**2*K*bd1 + 15*D1**2*K*bdd1*r*s - 5*D1**2*K*bdd1*r + 15*D1**2*K*bdd1*s**2 - 15*D1**2*K*bdd1*s + 5*D1**2*K*bdd1 + 5*D1**2*K*fd*r*s - 5*D1**2*K*fd*r + 5*D1**2*K*fd*s**2 - 10*D1**2*K*fd*s + 5*D1**2*K*fd + 5*D1**2*bdd2*r*s + 5*D1**2*bdd2*s**2 - 5*D1**2*bdd2*s + 2*D1**2*fd*r*s + 2*D1**2*fd*s**2 - 2*D1**2*fd*s - D1**2*fdd*r*s - D1**2*fdd*s**2 + D1**2*fdd*s + 20*D1**2*gd2*r*s + 20*D1**2*gd2*s**2 - 20*D1**2*gd2*s - 10*D1**2*gdd2*r*s - 10*D1**2*gdd2*s**2 + 10*D1**2*gdd2*s + 120*D1*Dd*K*bd1*r*s - 35*D1*Dd*K*bd1*r + 120*D1*Dd*K*bd1*s**2 - 120*D1*Dd*K*bd1*s + 25*D1*Dd*K*bd1 + 20*D1*Dd*K*f*r*s - 5*D1*Dd*K*f*r + 20*D1*Dd*K*f*s**2 - 20*D1*Dd*K*f*s + 5*D1*Dd*K*f + 8*D1*Dd*f*r*s - 2*D1*Dd*f*r + 8*D1*Dd*f*s**2 - 8*D1*Dd*f*s + 2*D1*Dd*f - 8*D1*Dd*fd*r*s + D1*Dd*fd*r - 8*D1*Dd*fd*s**2 + 8*D1*Dd*fd*s - D1*Dd*fd + 80*D1*Dd*g2*r*s - 20*D1*Dd*g2*r + 80*D1*Dd*g2*s**2 - 80*D1*Dd*g2*s + 20*D1*Dd*g2 - 80*D1*Dd*gd2*r*s + 10*D1*Dd*gd2*r - 80*D1*Dd*gd2*s**2 + 80*D1*Dd*gd2*s - 10*D1*Dd*gd2 - 4*D1*Ddd*f*r*s + D1*Ddd*f*r - 4*D1*Ddd*f*s**2 + 4*D1*Ddd*f*s - D1*Ddd*f - 40*D1*Ddd*g2*r*s + 10*D1*Ddd*g2*r - 40*D1*Ddd*g2*s**2 + 40*D1*Ddd*g2*s - 10*D1*Ddd*g2 - 5*D1*bd2*(2*D1*s*(r + s - 1) + Dd*(-8*r*s + r - 8*s**2 + 8*s - 1)) - 12*Dd**2*f*r*s + 3*Dd**2*f*r - 12*Dd**2*f*s**2 + 12*Dd**2*f*s - 2*Dd**2*f - 120*Dd**2*g2*r*s + 30*Dd**2*g2*r - 120*Dd**2*g2*s**2 + 120*Dd**2*g2*s - 20*Dd**2*g2 - 5*b2*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(15*d**2*k3)
        
        return np.sqrt((4*np.pi))*(perm12+perm13+perm23)
    
    def l2(cosmo_functions,k1,k2,k3=None,theta=None,zz=0,r=0,s=0,nonlin=False,growth2=False):
        
        #get generic cosmology parameters
        k1,k2,k3,theta,Pk1,Pk2,Pk3,Pkd1,Pkd2,Pkd3,Pkdd1,Pkdd2,Pkdd3,d,K,C,f,D1,b1,b2,g2 = cosmo_functions.get_params(k1,k2,k3,theta,zz,nonlin=nonlin,growth2=growth2)
        
        fd,Dd,gd2,bd2,bd1,fdd,Ddd,gdd2,bdd2,bdd1 = cosmo_functions.get_derivs(zz)
        
        st = np.sin(theta)
        ct= np.cos(theta)

        perm12 = -16*C*D1**3*Pk1*Pk2*k1**2*k2**2*(6*D1*bd1*f**2*(r + s - 1)**2 + 7*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*b1*f*(7*D1*bd1*(r + s - 1)**2 + (3*D1*fd + 6*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(21*d**2*k3**6) + 8*C*D1**3*Pk1*Pk2*k2**4*st**2*(-D1*bd1*f**2*(r + s - 1)**2 + 7*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + b1*(14*D1*bd1*f*(r + s - 1)**2 - f*(D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(21*d**2*k3**6) + 8*C*D1**3*Pk1*Pkd2*k1**2*k2*(6*D1*bd1*f**2*(s - 1)*(r + s - 1) + 7*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(7*D1*bd1*(2*s - 1)*(r + s - 1) + 6*D1*fd*s*(2*r + 2*s - 1) + 6*Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))/(21*d**2*k3**4) + 4*C*D1**3*Pk1*Pkd2*k2**3*st**2*(D1*bd1*f**2*(s - 1)*(r + s - 1) - 7*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(-7*D1*bd1*(2*s - 1)*(r + s - 1) + D1*fd*s*(2*r + 2*s - 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1)))/(21*d**2*k3**4) + 16*C*D1**2*Pk1*Pk2*f*k1**2*k2**2*st**4*(11*D1**2*bd1*f*(r + s - 1)**2 + 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 11*D1*b1*(D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*D1*f*(2*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) - Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 4*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1))/(77*d**2*k3**6) + 8*C*D1**2*Pk1*Pk2*k1**4*st**2*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 66*D1**2*b1*f*fd*s + 33*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 51*D1**2*f**2*fd*r**2 + 102*D1**2*f**2*fd*r*s - 68*D1**2*f**2*fd*r + 51*D1**2*f**2*fd*s**2 - 68*D1**2*f**2*fd*s + 34*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 528*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 528*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 68*D1*Dd*f**3*r**2 + 136*D1*Dd*f**3*r*s - 68*D1*Dd*f**3*r + 68*D1*Dd*f**3*s**2 - 68*D1*Dd*f**3*s + 34*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 700*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 700*D1*Dd*f**2*fd*s - 200*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 132*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 100*D1*Ddd*f**3*s - 50*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 4*Dd*f*(2*r + 2*s - 1)) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 396*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 300*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 300*Dd**2*f**3*s - 50*Dd**2*f**3)/(693*d**2*k3**6) + 16*C*D1**2*Pk1*Pk2*k1**4*(-D1*f*(r + s - 1)*(12*D1*bd1**2*(r + s - 1) + 5*D1*bdd1*f*(r + s - 1) + bd1*(-4*D1*f*(r + s - 1) + 10*D1*fd*(2*r + 2*s - 1) + 20*Dd*f*(2*r + 2*s - 1))) + b1**2*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + 2*D1*(Dd*(5*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 12*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-12*D1**2*bdd1*f*(r + s - 1)**2 + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 8*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 80*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 20*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 + 2*D1*bd1*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 60*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k3**6) + 8*C*D1**2*Pk1*Pk2*k1**2*k2**2*st**2*(D1*f*(-12*D1*bd1**2*(r + s - 1)**2 + 2*bd1*(r + s - 1)*(5*D1*f*(r + s - 1) - 6*D1*fd*(2*r + 2*s - 1) - 12*Dd*f*(2*r + 2*s - 1)) - f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1))) + b1**2*(D1**2*(19*fd - 6*fdd)*(r + s)**2 + 2*D1*(Dd*(19*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 12*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 2*b1*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 10*D1**2*f*fd*r**2 + 20*D1**2*f*fd*r*s - 10*D1**2*f*fd*r + 10*D1**2*f*fd*s**2 - 10*D1**2*f*fd*s + 5*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 6*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 3*D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s + 20*D1*Dd*f**2*r**2 + 40*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r + 20*D1*Dd*f**2*s**2 - 20*D1*Dd*f**2*s + 10*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 48*D1*Dd*f*fd*s - 12*D1*Dd*f*fd - 12*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) - 36*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 36*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s - 6*Dd**2*f**2))/(21*d**2*k3**6) - 40*C*D1**2*Pk1*Pk2*k2**4*st**6*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 264*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 528*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 528*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 28*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s - 8*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 132*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 396*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 12*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s - 2*Dd**2*f**3)/(693*d**2*k3**6) - 16*C*D1**2*Pk1*Pk2*k2**4*st**4*(-D1**2*bd1*f*(2*bd1 + f)*(r + s - 1)**2 + D1*b1*(4*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) - f*(2*D1*bdd1*(r + s - 1)**2 + (D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(7*d**2*k3**6) - 8*C*D1**2*Pk1*Pkd2*f*k1**2*k2*st**4*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1))/(77*d**2*k3**4) - 4*C*D1**2*Pk1*Pkd2*k1**2*k2*st**2*(D1*f*(-3*D1*bd1**2*(2*s - 1)*(r + s - 1) + bd1*(D1*(f*(5*s - 6)*(r + s - 1) - 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 3*Dd*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) - f*(3*D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1))) + 3*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(-3*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + 10*D1**2*f*fd*r*s + D1**2*f*fd*r + 10*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s - D1**2*f*fd - 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s - 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s + 20*D1*Dd*f**2*r*s - 5*D1*Dd*f**2*r + 20*D1*Dd*f**2*s**2 - 15*D1*Dd*f**2*s + 5*D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 30*D1*Dd*f*fd*s - 3*D1*Dd*f*fd - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 9*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 3*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 27*Dd**2*f**2*s - 3*Dd**2*f**2))/(21*d**2*k3**4) + 20*C*D1**2*Pk1*Pkd2*k2**3*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(693*d**2*k3**4) + 8*C*D1**2*Pk1*Pkd2*k2**3*st**4*(-D1**2*bd1*f*(bd1*(2*s - 1) + f*s)*(r + s - 1) + D1*b1*(bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - f*(D1*bdd1*(2*s - 1)*(r + s - 1) + D1*fd*(2*r*s - r + 2*s**2 - 2*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1))) + b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(7*d**2*k3**4) - 8*C*D1**2*Pk2*Pkd1*f*k1*k2**2*st**4*(11*D1**2*bd1*f*(r - 1)*(r + s - 1) + 6*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s - 6*D1**2*f*fd*r - 2*D1**2*f*fd*s + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 - 3*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + D1**2*f*fdd*s - D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 2*D1**2*fd**2*s - D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 - 24*D1*Dd*f*fd*r*s + 21*D1*Dd*f*fd*r + 7*D1*Dd*f*fd*s - 4*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 4*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r + D1*Ddd*f**2*s - D1*Ddd*f**2 + 11*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*s - 3*r - s + 1)) - 12*Dd**2*f**2*r**2 - 12*Dd**2*f**2*r*s + 9*Dd**2*f**2*r + 3*Dd**2*f**2*s - Dd**2*f**2)/(77*d**2*k3**4) - 4*C*D1**2*Pk2*Pkd1*k1**3*st**2*(66*D1**2*b1*f*fd*r**2 + 66*D1**2*b1*f*fd*r*s - 33*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 33*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 51*D1**2*f**2*fd*r**2 + 51*D1**2*f**2*fd*r*s - 51*D1**2*f**2*fd*r - 17*D1**2*f**2*fd*s + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 132*D1*Dd*b1*f**2*r*s - 99*D1*Dd*b1*f**2*r - 33*D1*Dd*b1*f**2*s + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 330*D1*Dd*b1*f*fd*r + 66*D1*Dd*b1*f*fd*s - 33*D1*Dd*b1*f*fd + 68*D1*Dd*f**3*r**2 + 68*D1*Dd*f**3*r*s - 51*D1*Dd*f**3*r - 17*D1*Dd*f**3*s + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 525*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s - 100*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 99*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 75*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(-8*r**2 + r*(11 - 8*s) + 5*s - 3)) - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 297*Dd**2*b1*f**2*r + 99*Dd**2*b1*f**2*s - 33*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 225*Dd**2*f**3*r + 75*Dd**2*f**3*s - 25*Dd**2*f**3)/(693*d**2*k3**4) + 8*C*D1**2*Pk2*Pkd1*k1**3*(D1*f*(6*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-4*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + b1**2*(-D1**2*r*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(-5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*fd*(8*r**2 + 8*r*s - 3*r - s)) + 6*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 6*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(6*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 4*D1**2*f*fd*s - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r - 5*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*r - 5*D1**2*fd**2*s - 16*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 80*D1*Dd*f*fd*r*s - 70*D1*Dd*f*fd*r - 30*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 20*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r - 5*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-5*f*(2*r - 1)*(r + s - 1) + 6*fd*(4*r**2 + 4*r*s - 3*r - s)) + 12*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 60*Dd**2*f**2*r**2 + 60*Dd**2*f**2*r*s - 45*Dd**2*f**2*r - 15*Dd**2*f**2*s + 5*Dd**2*f**2))/(21*d**2*k3**4) + 4*C*D1**2*Pk2*Pkd1*k1*k2**2*st**2*(D1*f*(3*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-5*f*r*(r + s - 1) + 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*D1*bdd1*f*r*(r + s - 1) + 3*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + b1**2*(-D1**2*r*(13*fd - 3*fdd)*(r + s) + D1*(Dd*(-13*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(8*r**2 + 8*r*s - 3*r - s)) + 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(3*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 10*D1**2*f*fd*r**2 - 10*D1**2*f*fd*r*s + 10*D1**2*f*fd*r + 5*D1**2*f*fd*s - 5*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 3*D1**2*fd**2*s - 20*D1*Dd*f**2*r**2 - 20*D1*Dd*f**2*r*s + 15*D1*Dd*f**2*r + 5*D1*Dd*f**2*s - 5*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 42*D1*Dd*f*fd*r - 18*D1*Dd*f*fd*s + 9*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s - 9*D1*Ddd*f**2*r - 3*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + D1*bd1*(D1*(-13*f*(2*r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 3*r - s)) + 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 36*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s - 27*Dd**2*f**2*r - 9*Dd**2*f**2*s + 3*Dd**2*f**2))/(21*d**2*k3**4) + 2*C*D1**2*Pk2*Pkdd1*f*k2**2*st**4*(33*D1**2*bd1*f*(r - 1)**2 + 6*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 6*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 + 14*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + 33*D1*b1*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r)/(231*d**2*k3**2) + C*D1**2*Pk2*Pkdd1*k1**2*st**2*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(693*d**2*k3**2) + 2*C*D1**2*Pk2*Pkdd1*k1**2*(D1*f*r*(-12*D1*bd1**2*(r - 1) - 5*D1*bdd1*f*r + 2*bd1*(2*D1*f*r + D1*fd*(5 - 10*r) + 5*Dd*f*(1 - 4*r))) + b1**2*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + b1*(-6*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 60*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + D1*bd1*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(21*d**2*k3**2) + C*D1**2*Pk2*Pkdd1*k2**2*st**2*(D1*f*r*(-2*D1*bd1**2*(r - 1) - D1*bdd1*f*r + bd1*(D1*f*r + D1*fd*(2 - 4*r) + Dd*f*(2 - 8*r))) + b1**2*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) + b1*(-D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 2*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 2*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 + 12*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + D1*bd1*(9*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 2*r) - 2*Dd*f*(8*r**2 - 6*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r))/(21*d**2*k3**2) + 4*C*D1**2*Pkd1*Pkd2*ct*k1**2*(-6*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) - 5*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(D1*b1*(5*f*r*(2*s - 1) - 5*f*s + 6*fd*(-4*r*s + r + s)) + D1*f*(4*f*r*(s - 1) - 5*fd*(r*(4*s - 2) - s + 1)) - 12*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) - 5*Dd*f**2*(r*(8*s - 5) - s + 1)) + b1**2*(D1*Dd*(5*f*r*(4*s - 1) - 5*f*s + 6*fd*(-8*r*s + r + s)) + D1*(D1*r*s*(5*fd - 6*fdd) + 6*Ddd*f*(-4*r*s + r + s)) - 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(4*f*(r*(4*s - 1) - s) - 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(6*D1*bdd1*f*(-2*r*s + r + s) + D1*s*(2*r - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k3**2) + 8*C*D1**2*Pkd1*Pkd2*f*k1*k2*st**4*(D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 7*r + 7*s - 2)) + D1*(D1*(2*f*fd*(3*r*s - r - s) + f*fdd*(-3*r*s + r + s) + fd**2*(-6*r*s + 2*r + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))/(231*d**2*k3**2) + 4*C*D1**2*Pkd1*Pkd2*k1*k2*st**2*(D1**2*bd1**2*f*(-2*r*s + r + s - 1) - D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(D1*b1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) + D1*f*(2*f*r*(s - 1) + fd*(r*(2 - 4*s) + s - 1)) - 2*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) + Dd*f**2*(r*(5 - 8*s) + s - 1)) + b1**2*(D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) + D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) - Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(2*f*(r*(4*s - 1) - s) + fd*(r*(2 - 16*s) + 6*s - 1)) + D1*(D1*bdd1*f*(-2*r*s + r + s) + D1*s*(2*r - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k3**2) - 8*D1**3*Pk1*Pk2*ct**3*k2**5*(6*D1*bd1*f**2*(r + s - 1)**2 + 7*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*b1*f*(7*D1*bd1*(r + s - 1)**2 + (3*D1*fd + 6*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(21*d**2*k1*k3**6) - D1**3*Pk1*Pk2*ct**2*k2**4*(16*C + 16)*(6*D1*bd1*f**2*(r + s - 1)**2 + 7*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*b1*f*(7*D1*bd1*(r + s - 1)**2 + (3*D1*fd + 6*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(21*d**2*k3**6) + 4*D1**3*Pk1*Pk2*ct**2*k2**4*st**2*(7*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + b1*f*(7*D1*bd1*(2*r - 1)*(r + s - 1) + D1*fd*(8*r**2 + 8*r*s - 5*r - s + 1) + 4*Dd*f*(4*r**2 + 4*r*s - 3*r - s + 1)) + f**2*(D1*bd1*(4*r - 3)*(r + s - 1) + 3*D1*fd*(3*r**2 + 3*r*(s - 1) - s + 1) + 3*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)))/(21*d**2*k1**2*k3**4) + 4*D1**3*Pk1*Pk2*ct**2*k2**4*(6*D1*bd1*f**2*r*(r + s - 1) + 7*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s - 3*r - s + 1)) + b1*f*(7*D1*bd1*(2*r - 1)*(r + s - 1) + 6*D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + 6*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)))/(21*d**2*k1**2*k3**4) - D1**3*Pk1*Pk2*ct*k1*k2**3*(32*C + 8)*(6*D1*bd1*f**2*(r + s - 1)**2 + 7*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*b1*f*(7*D1*bd1*(r + s - 1)**2 + (3*D1*fd + 6*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(21*d**2*k3**6) + 4*D1**3*Pk1*Pk2*ct*k2**5*st**2*(-D1*bd1*f**2*(r + s - 1)**2 + 7*b1**2*(D1*fd*(r + s)**2 + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + b1*(14*D1*bd1*f*(r + s - 1)**2 - f*(D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))/(21*d**2*k1*k3**6) + 8*D1**3*Pk1*Pk2*ct*k2**3*(6*D1*bd1*f**2*r*(r + s - 1) + 7*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s - 3*r - s + 1)) + b1*f*(7*D1*bd1*(2*r - 1)*(r + s - 1) + 6*D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + 6*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)))/(21*d**2*k1*k3**4) + 4*D1**3*Pk1*Pk2*k2**2*(6*D1*bd1*f**2*r*(r + s - 1) + 7*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*s - 3*r - s + 1)) + b1*f*(7*D1*bd1*(2*r - 1)*(r + s - 1) + 6*D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + 6*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)))/(21*d**2*k3**4) + 2*D1**3*Pk1*Pk2*k2**4*st**2*(D1*bd1*f**2*r*(r + s - 1) - 7*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + b1*f*(-7*D1*bd1*(2*r - 1)*(r + s - 1) + D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)))/(21*d**2*k1**2*k3**4) + 2*D1**3*Pk1*Pkd2*b1*k2*(-D1*b1*fd*s*(r - 1) + D1*bd1*f*r*(1 - 2*s) + Dd*b1*f*(-4*r*s + r + s))/(3*d**2*k1**2) + 4*D1**3*Pk1*Pkd2*ct**3*k2**4*(6*D1*bd1*f**2*(s - 1)*(r + s - 1) + 7*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(7*D1*bd1*(2*s - 1)*(r + s - 1) + 6*D1*fd*s*(2*r + 2*s - 1) + 6*Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))/(21*d**2*k1*k3**4) + D1**3*Pk1*Pkd2*ct**2*k2**3*(8*C + 8)*(6*D1*bd1*f**2*(s - 1)*(r + s - 1) + 7*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(7*D1*bd1*(2*s - 1)*(r + s - 1) + 6*D1*fd*s*(2*r + 2*s - 1) + 6*Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))/(21*d**2*k3**4) + 2*D1**3*Pk1*Pkd2*ct**2*k2**3*st**2*(-7*b1**2*(D1*fd*r*s + Dd*f*(r*(4*s - 1) - s)) + b1*f*(7*D1*bd1*(-2*r*s + r + s) + D1*fd*(-8*r*s + 3*r + s) + 4*Dd*f*(-4*r*s + r + s)) + f**2*(D1*bd1*(-4*r*s + r + 3*s) + 3*D1*fd*(-3*r*s + r + s) + 3*Dd*f*(-4*r*s + r + s)))/(21*d**2*k1**2*k3**2) - 2*D1**3*Pk1*Pkd2*ct**2*k2**3*(6*D1*bd1*f**2*r*(s - 1) + 7*b1**2*(D1*fd*r*s + Dd*f*(4*r*s - r - s)) + b1*f*(7*D1*bd1*r*(2*s - 1) - 7*D1*bd1*s + 6*D1*fd*s*(2*r - 1) + 6*Dd*f*(r*(4*s - 1) - s)))/(21*d**2*k1**2*k3**2) + D1**3*Pk1*Pkd2*ct*k1*k2**2*(16*C + 4)*(6*D1*bd1*f**2*(s - 1)*(r + s - 1) + 7*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(7*D1*bd1*(2*s - 1)*(r + s - 1) + 6*D1*fd*s*(2*r + 2*s - 1) + 6*Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))/(21*d**2*k3**4) + 2*D1**3*Pk1*Pkd2*ct*k2**4*st**2*(D1*bd1*f**2*(s - 1)*(r + s - 1) - 7*b1**2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + b1*f*(-7*D1*bd1*(2*s - 1)*(r + s - 1) + D1*fd*s*(2*r + 2*s - 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1)))/(21*d**2*k1*k3**4) - 4*D1**3*Pk1*Pkd2*ct*k2**2*(6*D1*bd1*f**2*r*(s - 1) + 7*b1**2*(D1*fd*r*s + Dd*f*(4*r*s - r - s)) + b1*f*(7*D1*bd1*r*(2*s - 1) - 7*D1*bd1*s + 6*D1*fd*s*(2*r - 1) + 6*Dd*f*(r*(4*s - 1) - s)))/(21*d**2*k1*k3**2) - 2*D1**3*Pk1*Pkd2*k2*(6*D1*bd1*f**2*r*(s - 1) + 7*b1**2*(D1*fd*r*s + Dd*f*(4*r*s - r - s)) + b1*f*(7*D1*bd1*r*(2*s - 1) - 7*D1*bd1*s + 6*D1*fd*s*(2*r - 1) + 6*Dd*f*(r*(4*s - 1) - s)))/(21*d**2*k3**2) + D1**3*Pk1*Pkd2*k2**3*st**2*(-D1*bd1*f**2*r*(s - 1) + 7*b1**2*(D1*fd*r*s + Dd*f*(r*(4*s - 1) - s)) + b1*f*(7*D1*bd1*(r*(2*s - 1) - s) + D1*fd*s*(1 - 2*r) + Dd*f*(-4*r*s + r + s)))/(21*d**2*k1**2*k3**2) - D1**2*Pk1*Pk2*ct**8*k2**4*(80*C - 80)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 168*D1**2*f**2*fd*r**2 + 336*D1**2*f**2*fd*r*s - 224*D1**2*f**2*fd*r + 168*D1**2*f**2*fd*s**2 - 224*D1**2*f**2*fd*s + 112*D1**2*f**2*fd - 84*D1**2*f**2*fdd*r**2 - 168*D1**2*f**2*fdd*r*s + 112*D1**2*f**2*fdd*r - 84*D1**2*f**2*fdd*s**2 + 112*D1**2*f**2*fdd*s - 56*D1**2*f**2*fdd - 168*D1**2*f*fd**2*r**2 - 336*D1**2*f*fd**2*r*s + 224*D1**2*f*fd**2*r - 168*D1**2*f*fd**2*s**2 + 224*D1**2*f*fd**2*s - 56*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 264*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 528*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 528*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 224*D1*Dd*f**3*r**2 + 448*D1*Dd*f**3*r*s - 224*D1*Dd*f**3*r + 224*D1*Dd*f**3*s**2 - 224*D1*Dd*f**3*s + 112*D1*Dd*f**3 - 672*D1*Dd*f**2*fd*r**2 - 1344*D1*Dd*f**2*fd*r*s + 784*D1*Dd*f**2*fd*r - 672*D1*Dd*f**2*fd*s**2 + 784*D1*Dd*f**2*fd*s - 224*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 132*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 112*D1*Ddd*f**3*r**2 - 224*D1*Ddd*f**3*r*s + 112*D1*Ddd*f**3*r - 112*D1*Ddd*f**3*s**2 + 112*D1*Ddd*f**3*s - 56*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 396*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 336*Dd**2*f**3*r**2 - 672*Dd**2*f**3*r*s + 336*Dd**2*f**3*r - 336*Dd**2*f**3*s**2 + 336*Dd**2*f**3*s - 56*Dd**2*f**3)/(693*d**2*k3**6) - D1**2*Pk1*Pk2*ct**8*k2**2*(160*C - 160)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 56*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 28*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 28*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k3**4) - D1**2*Pk1*Pk2*ct**8*(80*C - 80)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 2*D1*f*(28*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k3**2) + 40*D1**2*Pk1*Pk2*ct**7*f*(52*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(90*fd*(4*s**2 - 2*s + 1) - 45*fdd*(4*s**2 - 2*s + 1) + s**2*(104*bd1 - 52*bdd1)) + 2*fd*s*(-52*bd1*(3*s - 1) + 135*fd*(1 - 2*s))) + D1*f*(90*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(52*bd1*s + 45*fd*(4*s - 1)) - 45*Ddd*f*(4*s**2 - 2*s + 1)) + 270*Dd**2*f**2*s*(1 - 2*s)))/(429*d**2*k1*k2) - 8*D1**2*Pk1*Pk2*ct**7*k1*k2**3*(3696*C*D1**2*b1*f*fd*r**2 + 7392*C*D1**2*b1*f*fd*r*s - 3696*C*D1**2*b1*f*fd*r + 3696*C*D1**2*b1*f*fd*s**2 - 3696*C*D1**2*b1*f*fd*s + 1848*C*D1**2*b1*f*fd - 2640*C*D1**2*b1*f*fdd*r**2 - 5280*C*D1**2*b1*f*fdd*r*s + 2640*C*D1**2*b1*f*fdd*r - 2640*C*D1**2*b1*f*fdd*s**2 + 2640*C*D1**2*b1*f*fdd*s - 1320*C*D1**2*b1*f*fdd - 2640*C*D1**2*b1*fd**2*r**2 - 5280*C*D1**2*b1*fd**2*r*s + 2640*C*D1**2*b1*fd**2*r - 2640*C*D1**2*b1*fd**2*s**2 + 2640*C*D1**2*b1*fd**2*s + 4740*C*D1**2*f**2*fd*r**2 + 9480*C*D1**2*f**2*fd*r*s - 6320*C*D1**2*f**2*fd*r + 4740*C*D1**2*f**2*fd*s**2 - 6320*C*D1**2*f**2*fd*s + 3160*C*D1**2*f**2*fd - 3360*C*D1**2*f**2*fdd*r**2 - 6720*C*D1**2*f**2*fdd*r*s + 4480*C*D1**2*f**2*fdd*r - 3360*C*D1**2*f**2*fdd*s**2 + 4480*C*D1**2*f**2*fdd*s - 2240*C*D1**2*f**2*fdd - 6720*C*D1**2*f*fd**2*r**2 - 13440*C*D1**2*f*fd**2*r*s + 8960*C*D1**2*f*fd**2*r - 6720*C*D1**2*f*fd**2*s**2 + 8960*C*D1**2*f*fd**2*s - 2240*C*D1**2*f*fd**2 + 7392*C*D1*Dd*b1*f**2*r**2 + 14784*C*D1*Dd*b1*f**2*r*s - 7392*C*D1*Dd*b1*f**2*r + 7392*C*D1*Dd*b1*f**2*s**2 - 7392*C*D1*Dd*b1*f**2*s + 3696*C*D1*Dd*b1*f**2 - 21120*C*D1*Dd*b1*f*fd*r**2 - 42240*C*D1*Dd*b1*f*fd*r*s + 21120*C*D1*Dd*b1*f*fd*r - 21120*C*D1*Dd*b1*f*fd*s**2 + 21120*C*D1*Dd*b1*f*fd*s - 5280*C*D1*Dd*b1*f*fd + 6320*C*D1*Dd*f**3*r**2 + 12640*C*D1*Dd*f**3*r*s - 6320*C*D1*Dd*f**3*r + 6320*C*D1*Dd*f**3*s**2 - 6320*C*D1*Dd*f**3*s + 3160*C*D1*Dd*f**3 - 26880*C*D1*Dd*f**2*fd*r**2 - 53760*C*D1*Dd*f**2*fd*r*s + 31360*C*D1*Dd*f**2*fd*r - 26880*C*D1*Dd*f**2*fd*s**2 + 31360*C*D1*Dd*f**2*fd*s - 8960*C*D1*Dd*f**2*fd - 5280*C*D1*Ddd*b1*f**2*r**2 - 10560*C*D1*Ddd*b1*f**2*r*s + 5280*C*D1*Ddd*b1*f**2*r - 5280*C*D1*Ddd*b1*f**2*s**2 + 5280*C*D1*Ddd*b1*f**2*s - 2640*C*D1*Ddd*b1*f**2 - 4480*C*D1*Ddd*f**3*r**2 - 8960*C*D1*Ddd*f**3*r*s + 4480*C*D1*Ddd*f**3*r - 4480*C*D1*Ddd*f**3*s**2 + 4480*C*D1*Ddd*f**3*s - 2240*C*D1*Ddd*f**3 - 15840*C*Dd**2*b1*f**2*r**2 - 31680*C*Dd**2*b1*f**2*r*s + 15840*C*Dd**2*b1*f**2*r - 15840*C*Dd**2*b1*f**2*s**2 + 15840*C*Dd**2*b1*f**2*s - 2640*C*Dd**2*b1*f**2 - 13440*C*Dd**2*f**3*r**2 - 26880*C*Dd**2*f**3*r*s + 13440*C*Dd**2*f**3*r - 13440*C*Dd**2*f**3*s**2 + 13440*C*Dd**2*f**3*s - 2240*C*Dd**2*f**3 - 4356*D1**2*b1*f*fd*r**2 - 8712*D1**2*b1*f*fd*r*s + 4356*D1**2*b1*f*fd*r - 4356*D1**2*b1*f*fd*s**2 + 4356*D1**2*b1*f*fd*s - 2178*D1**2*b1*f*fd + 2970*D1**2*b1*f*fdd*r**2 + 5940*D1**2*b1*f*fdd*r*s - 2970*D1**2*b1*f*fdd*r + 2970*D1**2*b1*f*fdd*s**2 - 2970*D1**2*b1*f*fdd*s + 1485*D1**2*b1*f*fdd + 2970*D1**2*b1*fd**2*r**2 + 5940*D1**2*b1*fd**2*r*s - 2970*D1**2*b1*fd**2*r + 2970*D1**2*b1*fd**2*s**2 - 2970*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(8*C - 9)*(r + s - 1)**2 - 5580*D1**2*f**2*fd*r**2 - 11160*D1**2*f**2*fd*r*s + 7440*D1**2*f**2*fd*r - 5580*D1**2*f**2*fd*s**2 + 7440*D1**2*f**2*fd*s - 3720*D1**2*f**2*fd + 3780*D1**2*f**2*fdd*r**2 + 7560*D1**2*f**2*fdd*r*s - 5040*D1**2*f**2*fdd*r + 3780*D1**2*f**2*fdd*s**2 - 5040*D1**2*f**2*fdd*s + 2520*D1**2*f**2*fdd + 7560*D1**2*f*fd**2*r**2 + 15120*D1**2*f*fd**2*r*s - 10080*D1**2*f*fd**2*r + 7560*D1**2*f*fd**2*s**2 - 10080*D1**2*f*fd**2*s + 2520*D1**2*f*fd**2 - 8712*D1*Dd*b1*f**2*r**2 - 17424*D1*Dd*b1*f**2*r*s + 8712*D1*Dd*b1*f**2*r - 8712*D1*Dd*b1*f**2*s**2 + 8712*D1*Dd*b1*f**2*s - 4356*D1*Dd*b1*f**2 + 23760*D1*Dd*b1*f*fd*r**2 + 47520*D1*Dd*b1*f*fd*r*s - 23760*D1*Dd*b1*f*fd*r + 23760*D1*Dd*b1*f*fd*s**2 - 23760*D1*Dd*b1*f*fd*s + 5940*D1*Dd*b1*f*fd - 7440*D1*Dd*f**3*r**2 - 14880*D1*Dd*f**3*r*s + 7440*D1*Dd*f**3*r - 7440*D1*Dd*f**3*s**2 + 7440*D1*Dd*f**3*s - 3720*D1*Dd*f**3 + 30240*D1*Dd*f**2*fd*r**2 + 60480*D1*Dd*f**2*fd*r*s - 35280*D1*Dd*f**2*fd*r + 30240*D1*Dd*f**2*fd*s**2 - 35280*D1*Dd*f**2*fd*s + 10080*D1*Dd*f**2*fd + 5940*D1*Ddd*b1*f**2*r**2 + 11880*D1*Ddd*b1*f**2*r*s - 5940*D1*Ddd*b1*f**2*r + 5940*D1*Ddd*b1*f**2*s**2 - 5940*D1*Ddd*b1*f**2*s + 2970*D1*Ddd*b1*f**2 + 5040*D1*Ddd*f**3*r**2 + 10080*D1*Ddd*f**3*r*s - 5040*D1*Ddd*f**3*r + 5040*D1*Ddd*f**3*s**2 - 5040*D1*Ddd*f**3*s + 2520*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(28*C - 33)*(r + s - 1) - D1*fd*(40*C - 45)*(2*r + 2*s - 1) - Dd*f*(80*C - 90)*(2*r + 2*s - 1)) + 17820*Dd**2*b1*f**2*r**2 + 35640*Dd**2*b1*f**2*r*s - 17820*Dd**2*b1*f**2*r + 17820*Dd**2*b1*f**2*s**2 - 17820*Dd**2*b1*f**2*s + 2970*Dd**2*b1*f**2 + 15120*Dd**2*f**3*r**2 + 30240*Dd**2*f**3*r*s - 15120*Dd**2*f**3*r + 15120*Dd**2*f**3*s**2 - 15120*Dd**2*f**3*s + 2520*Dd**2*f**3)/(693*d**2*k3**6) - 16*D1**2*Pk1*Pk2*ct**7*k1*k2*(33*b1*(D1**2*(f*(fd*(48*C - 58) + fdd*(35 - 30*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(35 - 30*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(48*C - 58)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(35 - 30*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(35 - 30*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(35 - 30*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(270*C - 326)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (6*C - 7)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(196 - 168*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(48*C - 58)*(r + s - 1) - fd*(30*C - 35)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(35 - 30*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 10*D1*f*(Dd*(f*(135*C - 163)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(84*C - 98)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(98 - 84*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(196 - 168*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k3**4) - D1**2*Pk1*Pk2*ct**7*k1*(160*C - 200)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 2*D1*f*(28*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2*k3**2) + 40*D1**2*Pk1*Pk2*ct**7*k2**5*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 168*D1**2*f**2*fd*r**2 + 336*D1**2*f**2*fd*r*s - 224*D1**2*f**2*fd*r + 168*D1**2*f**2*fd*s**2 - 224*D1**2*f**2*fd*s + 112*D1**2*f**2*fd - 84*D1**2*f**2*fdd*r**2 - 168*D1**2*f**2*fdd*r*s + 112*D1**2*f**2*fdd*r - 84*D1**2*f**2*fdd*s**2 + 112*D1**2*f**2*fdd*s - 56*D1**2*f**2*fdd - 168*D1**2*f*fd**2*r**2 - 336*D1**2*f*fd**2*r*s + 224*D1**2*f*fd**2*r - 168*D1**2*f*fd**2*s**2 + 224*D1**2*f*fd**2*s - 56*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 264*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 528*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 528*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 224*D1*Dd*f**3*r**2 + 448*D1*Dd*f**3*r*s - 224*D1*Dd*f**3*r + 224*D1*Dd*f**3*s**2 - 224*D1*Dd*f**3*s + 112*D1*Dd*f**3 - 672*D1*Dd*f**2*fd*r**2 - 1344*D1*Dd*f**2*fd*r*s + 784*D1*Dd*f**2*fd*r - 672*D1*Dd*f**2*fd*s**2 + 784*D1*Dd*f**2*fd*s - 224*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 132*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 112*D1*Ddd*f**3*r**2 - 224*D1*Ddd*f**3*r*s + 112*D1*Ddd*f**3*r - 112*D1*Ddd*f**3*s**2 + 112*D1*Ddd*f**3*s - 56*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 396*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 336*Dd**2*f**3*r**2 - 672*Dd**2*f**3*r*s + 336*Dd**2*f**3*r - 336*Dd**2*f**3*s**2 + 336*Dd**2*f**3*s - 56*Dd**2*f**3)/(693*d**2*k1*k3**6) + 8*D1**2*Pk1*Pk2*ct**7*k2**3*(33*D1*bd1*f*(D1*(2*f*(r + s - 1)*(6*C*(r - 1) - 6*r + 5*s + 6) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 33*b1*(D1**2*(f*(2*fd*(r**2*(12*C - 12) + r*(6*C - 1)*(2*s - 1) + 10*s**2 - 10*s + 5) - 5*fdd*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(6*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 24*r**2 - 4*r*s + 13*r + 20*s**2 - 9*s - 1) - 5*fd*(8*s - 3)*(2*r + 2*s - 1)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) - 5*f*(D1**2*(f*(33*bdd1*s*(r + s - 1) + fd*(-86*C*(3*r**2 + 3*r*(s - 1) - s + 1) + 258*r**2 + 90*r*s - 202*r - 168*s**2 + 82*s + 30) + 2*fdd*(5*C*(3*r**2 + 3*r*(s - 1) - s + 1) - 15*r**2 + 27*r*s + r + 42*s**2 - 37*s + 9)) + 2*fd**2*(5*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 30*r**2 + r*(54*s + 2) + 84*s**2 - 74*s + 9)) + 2*D1*f*(Dd*(f*(-43*C*(4*r**2 + 4*r*s - 3*r - s + 1) + 172*r**2 + 60*r*s - 101*r - 112*s**2 + 41*s + 15) + fd*(5*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) - 120*r**2 + 216*r*s + 7*r + 336*s**2 - 259*s + 36)) + Ddd*f*(5*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 20*r**2 + 36*r*s + r + 56*s**2 - 37*s + 9)) + 2*Dd**2*f**2*(5*C*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1) - 60*r**2 + 108*r*s + 3*r + 168*s**2 - 111*s + 9)))/(693*d**2*k1*k3**4) - 16*D1**2*Pk1*Pk2*ct**6*k1**2*k2**2*(1980*C*D1**2*b1*f*fd*r**2 + 3960*C*D1**2*b1*f*fd*r*s - 1980*C*D1**2*b1*f*fd*r + 1980*C*D1**2*b1*f*fd*s**2 - 1980*C*D1**2*b1*f*fd*s + 990*C*D1**2*b1*f*fd - 1980*C*D1**2*b1*f*fdd*r**2 - 3960*C*D1**2*b1*f*fdd*r*s + 1980*C*D1**2*b1*f*fdd*r - 1980*C*D1**2*b1*f*fdd*s**2 + 1980*C*D1**2*b1*f*fdd*s - 990*C*D1**2*b1*f*fdd - 1980*C*D1**2*b1*fd**2*r**2 - 3960*C*D1**2*b1*fd**2*r*s + 1980*C*D1**2*b1*fd**2*r - 1980*C*D1**2*b1*fd**2*s**2 + 1980*C*D1**2*b1*fd**2*s + 2565*C*D1**2*f**2*fd*r**2 + 5130*C*D1**2*f**2*fd*r*s - 3420*C*D1**2*f**2*fd*r + 2565*C*D1**2*f**2*fd*s**2 - 3420*C*D1**2*f**2*fd*s + 1710*C*D1**2*f**2*fd - 2520*C*D1**2*f**2*fdd*r**2 - 5040*C*D1**2*f**2*fdd*r*s + 3360*C*D1**2*f**2*fdd*r - 2520*C*D1**2*f**2*fdd*s**2 + 3360*C*D1**2*f**2*fdd*s - 1680*C*D1**2*f**2*fdd - 5040*C*D1**2*f*fd**2*r**2 - 10080*C*D1**2*f*fd**2*r*s + 6720*C*D1**2*f*fd**2*r - 5040*C*D1**2*f*fd**2*s**2 + 6720*C*D1**2*f*fd**2*s - 1680*C*D1**2*f*fd**2 + 3960*C*D1*Dd*b1*f**2*r**2 + 7920*C*D1*Dd*b1*f**2*r*s - 3960*C*D1*Dd*b1*f**2*r + 3960*C*D1*Dd*b1*f**2*s**2 - 3960*C*D1*Dd*b1*f**2*s + 1980*C*D1*Dd*b1*f**2 - 15840*C*D1*Dd*b1*f*fd*r**2 - 31680*C*D1*Dd*b1*f*fd*r*s + 15840*C*D1*Dd*b1*f*fd*r - 15840*C*D1*Dd*b1*f*fd*s**2 + 15840*C*D1*Dd*b1*f*fd*s - 3960*C*D1*Dd*b1*f*fd + 3420*C*D1*Dd*f**3*r**2 + 6840*C*D1*Dd*f**3*r*s - 3420*C*D1*Dd*f**3*r + 3420*C*D1*Dd*f**3*s**2 - 3420*C*D1*Dd*f**3*s + 1710*C*D1*Dd*f**3 - 20160*C*D1*Dd*f**2*fd*r**2 - 40320*C*D1*Dd*f**2*fd*r*s + 23520*C*D1*Dd*f**2*fd*r - 20160*C*D1*Dd*f**2*fd*s**2 + 23520*C*D1*Dd*f**2*fd*s - 6720*C*D1*Dd*f**2*fd - 3960*C*D1*Ddd*b1*f**2*r**2 - 7920*C*D1*Ddd*b1*f**2*r*s + 3960*C*D1*Ddd*b1*f**2*r - 3960*C*D1*Ddd*b1*f**2*s**2 + 3960*C*D1*Ddd*b1*f**2*s - 1980*C*D1*Ddd*b1*f**2 - 3360*C*D1*Ddd*f**3*r**2 - 6720*C*D1*Ddd*f**3*r*s + 3360*C*D1*Ddd*f**3*r - 3360*C*D1*Ddd*f**3*s**2 + 3360*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 11880*C*Dd**2*b1*f**2*r**2 - 23760*C*Dd**2*b1*f**2*r*s + 11880*C*Dd**2*b1*f**2*r - 11880*C*Dd**2*b1*f**2*s**2 + 11880*C*Dd**2*b1*f**2*s - 1980*C*Dd**2*b1*f**2 - 10080*C*Dd**2*f**3*r**2 - 20160*C*Dd**2*f**3*r*s + 10080*C*Dd**2*f**3*r - 10080*C*Dd**2*f**3*s**2 + 10080*C*Dd**2*f**3*s - 1680*C*Dd**2*f**3 - 2904*D1**2*b1*f*fd*r**2 - 5808*D1**2*b1*f*fd*r*s + 2904*D1**2*b1*f*fd*r - 2904*D1**2*b1*f*fd*s**2 + 2904*D1**2*b1*f*fd*s - 1452*D1**2*b1*f*fd + 2640*D1**2*b1*f*fdd*r**2 + 5280*D1**2*b1*f*fdd*r*s - 2640*D1**2*b1*f*fdd*r + 2640*D1**2*b1*f*fdd*s**2 - 2640*D1**2*b1*f*fdd*s + 1320*D1**2*b1*f*fdd + 2640*D1**2*b1*fd**2*r**2 + 5280*D1**2*b1*fd**2*r*s - 2640*D1**2*b1*fd**2*r + 2640*D1**2*b1*fd**2*s**2 - 2640*D1**2*b1*fd**2*s - 330*D1**2*bdd1*f**2*(3*C - 4)*(r + s - 1)**2 - 3750*D1**2*f**2*fd*r**2 - 7500*D1**2*f**2*fd*r*s + 5000*D1**2*f**2*fd*r - 3750*D1**2*f**2*fd*s**2 + 5000*D1**2*f**2*fd*s - 2500*D1**2*f**2*fd + 3360*D1**2*f**2*fdd*r**2 + 6720*D1**2*f**2*fdd*r*s - 4480*D1**2*f**2*fdd*r + 3360*D1**2*f**2*fdd*s**2 - 4480*D1**2*f**2*fdd*s + 2240*D1**2*f**2*fdd + 6720*D1**2*f*fd**2*r**2 + 13440*D1**2*f*fd**2*r*s - 8960*D1**2*f*fd**2*r + 6720*D1**2*f*fd**2*s**2 - 8960*D1**2*f*fd**2*s + 2240*D1**2*f*fd**2 - 5808*D1*Dd*b1*f**2*r**2 - 11616*D1*Dd*b1*f**2*r*s + 5808*D1*Dd*b1*f**2*r - 5808*D1*Dd*b1*f**2*s**2 + 5808*D1*Dd*b1*f**2*s - 2904*D1*Dd*b1*f**2 + 21120*D1*Dd*b1*f*fd*r**2 + 42240*D1*Dd*b1*f*fd*r*s - 21120*D1*Dd*b1*f*fd*r + 21120*D1*Dd*b1*f*fd*s**2 - 21120*D1*Dd*b1*f*fd*s + 5280*D1*Dd*b1*f*fd - 5000*D1*Dd*f**3*r**2 - 10000*D1*Dd*f**3*r*s + 5000*D1*Dd*f**3*r - 5000*D1*Dd*f**3*s**2 + 5000*D1*Dd*f**3*s - 2500*D1*Dd*f**3 + 26880*D1*Dd*f**2*fd*r**2 + 53760*D1*Dd*f**2*fd*r*s - 31360*D1*Dd*f**2*fd*r + 26880*D1*Dd*f**2*fd*s**2 - 31360*D1*Dd*f**2*fd*s + 8960*D1*Dd*f**2*fd + 5280*D1*Ddd*b1*f**2*r**2 + 10560*D1*Ddd*b1*f**2*r*s - 5280*D1*Ddd*b1*f**2*r + 5280*D1*Ddd*b1*f**2*s**2 - 5280*D1*Ddd*b1*f**2*s + 2640*D1*Ddd*b1*f**2 + 4480*D1*Ddd*f**3*r**2 + 8960*D1*Ddd*f**3*r*s - 4480*D1*Ddd*f**3*r + 4480*D1*Ddd*f**3*s**2 - 4480*D1*Ddd*f**3*s + 2240*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(15*C - 22)*(r + s - 1) - D1*fd*(30*C - 40)*(2*r + 2*s - 1) - Dd*f*(60*C - 80)*(2*r + 2*s - 1)) + 15840*Dd**2*b1*f**2*r**2 + 31680*Dd**2*b1*f**2*r*s - 15840*Dd**2*b1*f**2*r + 15840*Dd**2*b1*f**2*s**2 - 15840*Dd**2*b1*f**2*s + 2640*Dd**2*b1*f**2 + 13440*Dd**2*f**3*r**2 + 26880*Dd**2*f**3*r*s - 13440*Dd**2*f**3*r + 13440*Dd**2*f**3*s**2 - 13440*Dd**2*f**3*s + 2240*Dd**2*f**3)/(693*d**2*k3**6) - 16*D1**2*Pk1*Pk2*ct**6*k1**2*(33*b1*(D1**2*(f*(fd*(12*C - 20) + fdd*(15 - 10*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(15 - 10*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(12*C - 20)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(15 - 10*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(15 - 10*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(15 - 10*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(68*C - 113)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (2*C - 3)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(84 - 56*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(12*C - 20)*(r + s - 1) - fd*(10*C - 15)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(15 - 10*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*(f*(68*C - 113)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(56*C - 84)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(84 - 56*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(84 - 56*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k3**4) - D1**2*Pk1*Pk2*ct**6*k1**2*(80*C - 160)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 2*D1*f*(28*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2**2*k3**2) - D1**2*Pk1*Pk2*ct**6*k2**4*st**2*(40*C - 40)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 150*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 - 200*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 264*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 528*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 528*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 200*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 200*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 - 200*D1*Dd*f**3*s + 100*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 700*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 700*D1*Dd*f**2*fd*s - 200*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 132*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 100*D1*Ddd*f**3*s - 50*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 396*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 300*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 300*Dd**2*f**3*s - 50*Dd**2*f**3)/(231*d**2*k3**6) - 16*D1**2*Pk1*Pk2*ct**6*k2**4*(198*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 99*b1*(-4*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r*s + 4*C*D1**2*f*fd*r - 4*C*D1**2*f*fd*s**2 + 4*C*D1**2*f*fd*s - 2*C*D1**2*f*fd - 8*C*D1*Dd*f**2*r**2 - 16*C*D1*Dd*f**2*r*s + 8*C*D1*Dd*f**2*r - 8*C*D1*Dd*f**2*s**2 + 8*C*D1*Dd*f**2*s - 4*C*D1*Dd*f**2 - 4*D1**2*bdd1*f*(C - 1)*(r + s - 1)**2 - 12*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 6*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 10*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s - 24*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 80*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 80*D1*Dd*f*fd*s + 20*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 20*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 20*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 + 8*D1*bd1*(C - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 60*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 60*Dd**2*f**2*s + 10*Dd**2*f**2) + f*(-396*D1**2*bd1**2*(C - 1)*(r + s - 1)**2 + 495*D1**2*bdd1*f*(r + s - 1)**2 + 5*D1**2*(-f*(fd*(89*C + 46) - fdd*(28*C + 56))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(56*C + 112)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 198*D1*bd1*(r + s - 1)*(D1*f*(C + 3)*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(2*r + 2*s - 1)) - 10*D1*f*(Dd*(f*(89*C + 46)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(56*C + 112)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Ddd*f*(-28*C - 56)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 5*Dd**2*f**2*(56*C + 112)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(693*d**2*k3**6) - D1**2*Pk1*Pk2*ct**6*k2**2*st**2*(80*C - 80)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 50*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 25*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 25*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k3**4) - 4*D1**2*Pk1*Pk2*ct**6*k2**2*(792*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 33*b1*(-132*C*D1**2*f*fd*r**2 - 344*C*D1**2*f*fd*r*s + 212*C*D1**2*f*fd*r - 212*C*D1**2*f*fd*s**2 + 252*C*D1**2*f*fd*s - 146*C*D1**2*f*fd + 60*C*D1**2*f*fdd*r**2 + 208*C*D1**2*f*fdd*r*s - 124*C*D1**2*f*fdd*r + 148*C*D1**2*f*fdd*s**2 - 168*C*D1**2*f*fdd*s + 94*C*D1**2*f*fdd + 60*C*D1**2*fd**2*r**2 + 208*C*D1**2*fd**2*r*s - 124*C*D1**2*fd**2*r + 148*C*D1**2*fd**2*s**2 - 168*C*D1**2*fd**2*s - 264*C*D1*Dd*f**2*r**2 - 688*C*D1*Dd*f**2*r*s + 304*C*D1*Dd*f**2*r - 424*C*D1*Dd*f**2*s**2 + 384*C*D1*Dd*f**2*s - 172*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*r**2 + 1664*C*D1*Dd*f*fd*r*s - 824*C*D1*Dd*f*fd*r + 1184*C*D1*Dd*f*fd*s**2 - 1176*C*D1*Dd*f*fd*s + 292*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*r**2 + 416*C*D1*Ddd*f**2*r*s - 164*C*D1*Ddd*f**2*r + 296*C*D1*Ddd*f**2*s**2 - 252*C*D1*Ddd*f**2*s + 104*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*r**2 + 1248*C*Dd**2*f**2*r*s - 492*C*Dd**2*f**2*r + 888*C*Dd**2*f**2*s**2 - 756*C*Dd**2*f**2*s + 104*C*Dd**2*f**2 - 24*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) + 152*D1**2*f*fd*r**2 + 188*D1**2*f*fd*r*s - 134*D1**2*f*fd*r + 36*D1**2*f*fd*s**2 - 76*D1**2*f*fd*s + 58*D1**2*f*fd - 70*D1**2*f*fdd*r**2 - 118*D1**2*f*fdd*r*s + 79*D1**2*f*fdd*r - 48*D1**2*f*fdd*s**2 + 68*D1**2*f*fdd*s - 44*D1**2*f*fdd - 70*D1**2*fd**2*r**2 - 118*D1**2*fd**2*r*s + 79*D1**2*fd**2*r - 48*D1**2*fd**2*s**2 + 68*D1**2*fd**2*s + 304*D1*Dd*f**2*r**2 + 376*D1*Dd*f**2*r*s - 246*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 130*D1*Dd*f**2*s + 94*D1*Dd*f**2 - 560*D1*Dd*f*fd*r**2 - 944*D1*Dd*f*fd*r*s + 574*D1*Dd*f*fd*r - 384*D1*Dd*f*fd*s**2 + 486*D1*Dd*f*fd*s - 147*D1*Dd*f*fd - 140*D1*Ddd*f**2*r**2 - 236*D1*Ddd*f**2*r*s + 129*D1*Ddd*f**2*r - 96*D1*Ddd*f**2*s**2 + 107*D1*Ddd*f**2*s - 59*D1*Ddd*f**2 + 24*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 420*Dd**2*f**2*r**2 - 708*Dd**2*f**2*r*s + 387*Dd**2*f**2*r - 288*Dd**2*f**2*s**2 + 321*Dd**2*f**2*s - 59*Dd**2*f**2) + f*(-792*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(2*C*(15*r + 37*s - 5) - 35*r - 24*s + 15) - 5*D1**2*(f*(fd*(C*(1449*r**2 + r*(3882*s - 2260) + 2433*s**2 - 2916*s + 1294) - 1677*r**2 + r*(1994 - 2628*s) - 951*s**2 + 1510*s - 876) + fdd*(-C*(675*r**2 + 2*r*(1119*s - 598) + 1563*s**2 - 1788*s + 746) + 789*r**2 + 2*r*(756*s - 515) + 723*s**2 - 986*s + 504)) - 2*fd**2*(C*(675*r**2 + 2*r*(1119*s - 598) + 1563*s**2 - 1788*s + 373) - 789*r**2 - 2*r*(756*s - 515) - 723*s**2 + 986*s - 252)) - 33*D1*bd1*(D1*(2*f*(r + s - 1)*(C*(33*r + 53*s - 13) - 38*r - 9*s + 18) + fd*(-4*C*(30*r**2 + 104*r*s - 51*r + 74*s**2 - 84*s + 26) + 140*r**2 + 236*r*s - 179*r + 96*s**2 - 146*s + 59)) + Dd*f*(-4*C*(60*r**2 + 208*r*s - 81*r + 148*s**2 - 147*s + 31) + 280*r**2 + 472*r*s - 329*r + 192*s**2 - 263*s + 89)) - 10*D1*f*(Dd*(f*(C*(966*r**2 + 2*r*(1294*s - 565) + 1622*s**2 - 1458*s + 647) - 1118*r**2 + r*(997 - 1752*s) - 634*s**2 + 755*s - 438) + fd*(-2*C*(1350*r**2 + r*(4476*s - 2093) + 3126*s**2 - 3129*s + 746) + 3156*r**2 + 7*r*(864*s - 515) + 2892*s**2 - 3451*s + 1008)) + Ddd*f*(-C*(450*r**2 + 2*r*(746*s - 299) + 1042*s**2 - 894*s + 373) + 526*r**2 + r*(1008*s - 515) + 482*s**2 - 493*s + 252)) - 10*Dd**2*f**2*(-C*(1350*r**2 + 6*r*(746*s - 299) + 3126*s**2 - 2682*s + 373) + 1578*r**2 + 3*r*(1008*s - 515) + 1446*s**2 - 1479*s + 252)))/(693*d**2*k3**4) - D1**2*Pk1*Pk2*ct**6*st**2*(40*C - 40)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(50*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k3**2) + 8*D1**2*Pk1*Pk2*ct**6*(D1**2*(70*f**3*(30*fd*(4*s**2 - 2*s + 1) - 15*fdd*(4*s**2 - 2*s + 1) + s**2*(52*bd1 - 26*bdd1)) - 5*f**2*s*(286*bd1**2*s + 26*bd1*(28*fd*(3*s - 1) + s*(11*K - 11)) + 1260*fd**2*(2*s - 1) - s*(143*bdd1*(K - 1) + 572*gd2 - 286*gdd2)) + 286*f*(5*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 5*fdd*g2*(2*s**2 - 2*s + 1) + s**2*(6*bd1**2*(K - 1) + 12*bd1*(g2 - gd2) - 6*bdd1*g2)) - 572*fd*g2*s*(6*bd1 + 5*fd)*(s - 1)) + 2*D1*f*(Dd*(1050*f**3*(4*s**2 - 2*s + 1) - 70*f**2*(4*s - 1)*(26*bd1*s + 15*fd*(4*s - 1)) + 715*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 286*g2*(4*s - 1)*(6*bd1*s + 5*fd*(2*s - 1))) - 5*Ddd*f*(105*f**2 + 143*g2)*(4*s**2 - 2*s + 1)) - 60*Dd**2*f**2*s*(105*f**2 + 143*g2)*(2*s - 1) + 143*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) - 12*fd*(K - 1)*(s - 1)**2 + 6*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) - 6*f*(K - 1)*(4*s**2 - 2*s + 1) + 6*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-6*K + 5*f + 6)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-6*K + 5*f + 6)) + 13*b1*(D1**2*(10*f**2*(28*fd*(3*s**2 - 2*s + 1) - 14*fdd*(3*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + f*(-280*fd**2*s*(3*s - 2) - 110*fd*(K*(2*s**2 - 2*s + 1) + s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) + 55*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(132*K*bdd1 - 264*bd1*(K - 1) - 132*bdd1 + 264*gd2 - 132*gdd2)) + (22*s - 22)*(5*fd**2*s*(K - 1) + 12*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 6*fdd*g2*(s - 1))) + D1*(2*Dd*(140*f**3*(4*s**2 - 2*s + 1) - 5*f**2*(11*K*(4*s**2 - 2*s + 1) + 28*fd*(12*s**2 - 7*s + 1) + 11*s**2*(8*bd1 - 4) - 11*s*(2*bd1 - 2) - 11) + 11*f*(5*fd*(K - 1)*(8*s**2 - 6*s + 1) + 12*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(12*K*bd1 - 12*bd1 - 12*gd2)) - 132*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(140*f**2 - 55*f*(K - 1) + 132*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(140*f**2 - 55*f*(K - 1) + 132*g2)))/(1001*d**2*k2**2) - 4*D1**2*Pk1*Pk2*ct**6*k2**4*(44*D1**2*b1*f*fd*r**2 + 44*D1**2*b1*f*fd*r*s - 22*D1**2*b1*f*fd*r + 110*D1**2*b1*f*fdd*r**2 + 110*D1**2*b1*f*fdd*r*s - 55*D1**2*b1*f*fdd*r + 110*D1**2*b1*fd**2*r**2 + 110*D1**2*b1*fd**2*r*s - 55*D1**2*b1*fd**2*r + 55*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 150*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 150*D1**2*f**2*fd*r - 50*D1**2*f**2*fd*s + 50*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r**2 + 90*D1**2*f**2*fdd*r*s - 90*D1**2*f**2*fdd*r - 30*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r**2 + 180*D1**2*f*fd**2*r*s - 180*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 88*D1*Dd*b1*f**2*r*s - 66*D1*Dd*b1*f**2*r - 22*D1*Dd*b1*f**2*s + 22*D1*Dd*b1*f**2 + 880*D1*Dd*b1*f*fd*r**2 + 880*D1*Dd*b1*f*fd*r*s - 550*D1*Dd*b1*f*fd*r - 110*D1*Dd*b1*f*fd*s + 55*D1*Dd*b1*f*fd + 200*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 150*D1*Dd*f**3*r - 50*D1*Dd*f**3*s + 50*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r**2 + 720*D1*Dd*f**2*fd*r*s - 630*D1*Dd*f**2*fd*r - 210*D1*Dd*f**2*fd*s + 120*D1*Dd*f**2*fd + 220*D1*Ddd*b1*f**2*r**2 + 220*D1*Ddd*b1*f**2*r*s - 165*D1*Ddd*b1*f**2*r - 55*D1*Ddd*b1*f**2*s + 55*D1*Ddd*b1*f**2 + 120*D1*Ddd*f**3*r**2 + 120*D1*Ddd*f**3*r*s - 90*D1*Ddd*f**3*r - 30*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + 11*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 660*Dd**2*b1*f**2*r**2 + 660*Dd**2*b1*f**2*r*s - 495*Dd**2*b1*f**2*r - 165*Dd**2*b1*f**2*s + 55*Dd**2*b1*f**2 + 360*Dd**2*f**3*r**2 + 360*Dd**2*f**3*r*s - 270*Dd**2*f**3*r - 90*Dd**2*f**3*s + 30*Dd**2*f**3)/(231*d**2*k1**2*k3**4) + 20*D1**2*Pk1*Pk2*ct**5*f*st**2*(65*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(98*fd*(4*s**2 - 2*s + 1) - 49*fdd*(4*s**2 - 2*s + 1) + s**2*(130*bd1 - 65*bdd1)) + 2*fd*s*(-65*bd1*(3*s - 1) + 147*fd*(1 - 2*s))) + D1*f*(98*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(65*bd1*s + 49*fd*(4*s - 1)) - 49*Ddd*f*(4*s**2 - 2*s + 1)) + 294*Dd**2*f**2*s*(1 - 2*s)))/(143*d**2*k1*k2) - 8*D1**2*Pk1*Pk2*ct**5*k1**3*k2*(2112*C*D1**2*b1*f*fd*r**2 + 4224*C*D1**2*b1*f*fd*r*s - 2112*C*D1**2*b1*f*fd*r + 2112*C*D1**2*b1*f*fd*s**2 - 2112*C*D1**2*b1*f*fd*s + 1056*C*D1**2*b1*f*fd - 2640*C*D1**2*b1*f*fdd*r**2 - 5280*C*D1**2*b1*f*fdd*r*s + 2640*C*D1**2*b1*f*fdd*r - 2640*C*D1**2*b1*f*fdd*s**2 + 2640*C*D1**2*b1*f*fdd*s - 1320*C*D1**2*b1*f*fdd - 2640*C*D1**2*b1*fd**2*r**2 - 5280*C*D1**2*b1*fd**2*r*s + 2640*C*D1**2*b1*fd**2*r - 2640*C*D1**2*b1*fd**2*s**2 + 2640*C*D1**2*b1*fd**2*s + 2760*C*D1**2*f**2*fd*r**2 + 5520*C*D1**2*f**2*fd*r*s - 3680*C*D1**2*f**2*fd*r + 2760*C*D1**2*f**2*fd*s**2 - 3680*C*D1**2*f**2*fd*s + 1840*C*D1**2*f**2*fd - 3360*C*D1**2*f**2*fdd*r**2 - 6720*C*D1**2*f**2*fdd*r*s + 4480*C*D1**2*f**2*fdd*r - 3360*C*D1**2*f**2*fdd*s**2 + 4480*C*D1**2*f**2*fdd*s - 2240*C*D1**2*f**2*fdd - 6720*C*D1**2*f*fd**2*r**2 - 13440*C*D1**2*f*fd**2*r*s + 8960*C*D1**2*f*fd**2*r - 6720*C*D1**2*f*fd**2*s**2 + 8960*C*D1**2*f*fd**2*s - 2240*C*D1**2*f*fd**2 + 4224*C*D1*Dd*b1*f**2*r**2 + 8448*C*D1*Dd*b1*f**2*r*s - 4224*C*D1*Dd*b1*f**2*r + 4224*C*D1*Dd*b1*f**2*s**2 - 4224*C*D1*Dd*b1*f**2*s + 2112*C*D1*Dd*b1*f**2 - 21120*C*D1*Dd*b1*f*fd*r**2 - 42240*C*D1*Dd*b1*f*fd*r*s + 21120*C*D1*Dd*b1*f*fd*r - 21120*C*D1*Dd*b1*f*fd*s**2 + 21120*C*D1*Dd*b1*f*fd*s - 5280*C*D1*Dd*b1*f*fd + 3680*C*D1*Dd*f**3*r**2 + 7360*C*D1*Dd*f**3*r*s - 3680*C*D1*Dd*f**3*r + 3680*C*D1*Dd*f**3*s**2 - 3680*C*D1*Dd*f**3*s + 1840*C*D1*Dd*f**3 - 26880*C*D1*Dd*f**2*fd*r**2 - 53760*C*D1*Dd*f**2*fd*r*s + 31360*C*D1*Dd*f**2*fd*r - 26880*C*D1*Dd*f**2*fd*s**2 + 31360*C*D1*Dd*f**2*fd*s - 8960*C*D1*Dd*f**2*fd - 5280*C*D1*Ddd*b1*f**2*r**2 - 10560*C*D1*Ddd*b1*f**2*r*s + 5280*C*D1*Ddd*b1*f**2*r - 5280*C*D1*Ddd*b1*f**2*s**2 + 5280*C*D1*Ddd*b1*f**2*s - 2640*C*D1*Ddd*b1*f**2 - 4480*C*D1*Ddd*f**3*r**2 - 8960*C*D1*Ddd*f**3*r*s + 4480*C*D1*Ddd*f**3*r - 4480*C*D1*Ddd*f**3*s**2 + 4480*C*D1*Ddd*f**3*s - 2240*C*D1*Ddd*f**3 - 15840*C*Dd**2*b1*f**2*r**2 - 31680*C*Dd**2*b1*f**2*r*s + 15840*C*Dd**2*b1*f**2*r - 15840*C*Dd**2*b1*f**2*s**2 + 15840*C*Dd**2*b1*f**2*s - 2640*C*Dd**2*b1*f**2 - 13440*C*Dd**2*f**3*r**2 - 26880*C*Dd**2*f**3*r*s + 13440*C*Dd**2*f**3*r - 13440*C*Dd**2*f**3*s**2 + 13440*C*Dd**2*f**3*s - 2240*C*Dd**2*f**3 - 4092*D1**2*b1*f*fd*r**2 - 8184*D1**2*b1*f*fd*r*s + 4092*D1**2*b1*f*fd*r - 4092*D1**2*b1*f*fd*s**2 + 4092*D1**2*b1*f*fd*s - 2046*D1**2*b1*f*fd + 4620*D1**2*b1*f*fdd*r**2 + 9240*D1**2*b1*f*fdd*r*s - 4620*D1**2*b1*f*fdd*r + 4620*D1**2*b1*f*fdd*s**2 - 4620*D1**2*b1*f*fdd*s + 2310*D1**2*b1*f*fdd + 4620*D1**2*b1*fd**2*r**2 + 9240*D1**2*b1*fd**2*r*s - 4620*D1**2*b1*fd**2*r + 4620*D1**2*b1*fd**2*s**2 - 4620*D1**2*b1*fd**2*s - 330*D1**2*bdd1*f**2*(4*C - 7)*(r + s - 1)**2 - 5325*D1**2*f**2*fd*r**2 - 10650*D1**2*f**2*fd*r*s + 7100*D1**2*f**2*fd*r - 5325*D1**2*f**2*fd*s**2 + 7100*D1**2*f**2*fd*s - 3550*D1**2*f**2*fd + 5880*D1**2*f**2*fdd*r**2 + 11760*D1**2*f**2*fdd*r*s - 7840*D1**2*f**2*fdd*r + 5880*D1**2*f**2*fdd*s**2 - 7840*D1**2*f**2*fdd*s + 3920*D1**2*f**2*fdd + 11760*D1**2*f*fd**2*r**2 + 23520*D1**2*f*fd**2*r*s - 15680*D1**2*f*fd**2*r + 11760*D1**2*f*fd**2*s**2 - 15680*D1**2*f*fd**2*s + 3920*D1**2*f*fd**2 - 8184*D1*Dd*b1*f**2*r**2 - 16368*D1*Dd*b1*f**2*r*s + 8184*D1*Dd*b1*f**2*r - 8184*D1*Dd*b1*f**2*s**2 + 8184*D1*Dd*b1*f**2*s - 4092*D1*Dd*b1*f**2 + 36960*D1*Dd*b1*f*fd*r**2 + 73920*D1*Dd*b1*f*fd*r*s - 36960*D1*Dd*b1*f*fd*r + 36960*D1*Dd*b1*f*fd*s**2 - 36960*D1*Dd*b1*f*fd*s + 9240*D1*Dd*b1*f*fd - 7100*D1*Dd*f**3*r**2 - 14200*D1*Dd*f**3*r*s + 7100*D1*Dd*f**3*r - 7100*D1*Dd*f**3*s**2 + 7100*D1*Dd*f**3*s - 3550*D1*Dd*f**3 + 47040*D1*Dd*f**2*fd*r**2 + 94080*D1*Dd*f**2*fd*r*s - 54880*D1*Dd*f**2*fd*r + 47040*D1*Dd*f**2*fd*s**2 - 54880*D1*Dd*f**2*fd*s + 15680*D1*Dd*f**2*fd + 9240*D1*Ddd*b1*f**2*r**2 + 18480*D1*Ddd*b1*f**2*r*s - 9240*D1*Ddd*b1*f**2*r + 9240*D1*Ddd*b1*f**2*s**2 - 9240*D1*Ddd*b1*f**2*s + 4620*D1*Ddd*b1*f**2 + 7840*D1*Ddd*f**3*r**2 + 15680*D1*Ddd*f**3*r*s - 7840*D1*Ddd*f**3*r + 7840*D1*Ddd*f**3*s**2 - 7840*D1*Ddd*f**3*s + 3920*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(16*C - 31)*(r + s - 1) - D1*fd*(40*C - 70)*(2*r + 2*s - 1) - Dd*f*(80*C - 140)*(2*r + 2*s - 1)) + 27720*Dd**2*b1*f**2*r**2 + 55440*Dd**2*b1*f**2*r*s - 27720*Dd**2*b1*f**2*r + 27720*Dd**2*b1*f**2*s**2 - 27720*Dd**2*b1*f**2*s + 4620*Dd**2*b1*f**2 + 23520*Dd**2*f**3*r**2 + 47040*Dd**2*f**3*r*s - 23520*Dd**2*f**3*r + 23520*Dd**2*f**3*s**2 - 23520*Dd**2*f**3*s + 3920*Dd**2*f**3)/(693*d**2*k3**6) - 16*D1**2*Pk1*Pk2*ct**5*k1**3*(33*b1*(D1**2*(f*(fd*(8*C - 26) + fdd*(25 - 10*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(25 - 10*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(8*C - 26)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(25 - 10*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(25 - 10*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(25 - 10*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(46*C - 148)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (2*C - 5)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(140 - 56*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(8*C - 26)*(r + s - 1) - fd*(10*C - 25)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(25 - 10*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 10*D1*f*(Dd*(f*(23*C - 74)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(28*C - 70)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(70 - 28*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(140 - 56*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k2*k3**4) + 40*D1**2*Pk1*Pk2*ct**5*k1**3*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 2*D1*f*(28*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2**3*k3**2) - 4*D1**2*Pk1*Pk2*ct**5*k1*k2**3*st**2*(8976*C*D1**2*b1*f*fd*r**2 + 17952*C*D1**2*b1*f*fd*r*s - 8976*C*D1**2*b1*f*fd*r + 8976*C*D1**2*b1*f*fd*s**2 - 8976*C*D1**2*b1*f*fd*s + 4488*C*D1**2*b1*f*fd - 5280*C*D1**2*b1*f*fdd*r**2 - 10560*C*D1**2*b1*f*fdd*r*s + 5280*C*D1**2*b1*f*fdd*r - 5280*C*D1**2*b1*f*fdd*s**2 + 5280*C*D1**2*b1*f*fdd*s - 2640*C*D1**2*b1*f*fdd - 5280*C*D1**2*b1*fd**2*r**2 - 10560*C*D1**2*b1*fd**2*r*s + 5280*C*D1**2*b1*fd**2*r - 5280*C*D1**2*b1*fd**2*s**2 + 5280*C*D1**2*b1*fd**2*s + 9624*C*D1**2*f**2*fd*r**2 + 19248*C*D1**2*f**2*fd*r*s - 12832*C*D1**2*f**2*fd*r + 9624*C*D1**2*f**2*fd*s**2 - 12832*C*D1**2*f**2*fd*s + 6416*C*D1**2*f**2*fd - 6000*C*D1**2*f**2*fdd*r**2 - 12000*C*D1**2*f**2*fdd*r*s + 8000*C*D1**2*f**2*fdd*r - 6000*C*D1**2*f**2*fdd*s**2 + 8000*C*D1**2*f**2*fdd*s - 4000*C*D1**2*f**2*fdd - 12000*C*D1**2*f*fd**2*r**2 - 24000*C*D1**2*f*fd**2*r*s + 16000*C*D1**2*f*fd**2*r - 12000*C*D1**2*f*fd**2*s**2 + 16000*C*D1**2*f*fd**2*s - 4000*C*D1**2*f*fd**2 + 17952*C*D1*Dd*b1*f**2*r**2 + 35904*C*D1*Dd*b1*f**2*r*s - 17952*C*D1*Dd*b1*f**2*r + 17952*C*D1*Dd*b1*f**2*s**2 - 17952*C*D1*Dd*b1*f**2*s + 8976*C*D1*Dd*b1*f**2 - 42240*C*D1*Dd*b1*f*fd*r**2 - 84480*C*D1*Dd*b1*f*fd*r*s + 42240*C*D1*Dd*b1*f*fd*r - 42240*C*D1*Dd*b1*f*fd*s**2 + 42240*C*D1*Dd*b1*f*fd*s - 10560*C*D1*Dd*b1*f*fd + 12832*C*D1*Dd*f**3*r**2 + 25664*C*D1*Dd*f**3*r*s - 12832*C*D1*Dd*f**3*r + 12832*C*D1*Dd*f**3*s**2 - 12832*C*D1*Dd*f**3*s + 6416*C*D1*Dd*f**3 - 48000*C*D1*Dd*f**2*fd*r**2 - 96000*C*D1*Dd*f**2*fd*r*s + 56000*C*D1*Dd*f**2*fd*r - 48000*C*D1*Dd*f**2*fd*s**2 + 56000*C*D1*Dd*f**2*fd*s - 16000*C*D1*Dd*f**2*fd - 10560*C*D1*Ddd*b1*f**2*r**2 - 21120*C*D1*Ddd*b1*f**2*r*s + 10560*C*D1*Ddd*b1*f**2*r - 10560*C*D1*Ddd*b1*f**2*s**2 + 10560*C*D1*Ddd*b1*f**2*s - 5280*C*D1*Ddd*b1*f**2 - 8000*C*D1*Ddd*f**3*r**2 - 16000*C*D1*Ddd*f**3*r*s + 8000*C*D1*Ddd*f**3*r - 8000*C*D1*Ddd*f**3*s**2 + 8000*C*D1*Ddd*f**3*s - 4000*C*D1*Ddd*f**3 - 31680*C*Dd**2*b1*f**2*r**2 - 63360*C*Dd**2*b1*f**2*r*s + 31680*C*Dd**2*b1*f**2*r - 31680*C*Dd**2*b1*f**2*s**2 + 31680*C*Dd**2*b1*f**2*s - 5280*C*Dd**2*b1*f**2 - 24000*C*Dd**2*f**3*r**2 - 48000*C*Dd**2*f**3*r*s + 24000*C*Dd**2*f**3*r - 24000*C*Dd**2*f**3*s**2 + 24000*C*Dd**2*f**3*s - 4000*C*Dd**2*f**3 - 10956*D1**2*b1*f*fd*r**2 - 21912*D1**2*b1*f*fd*r*s + 10956*D1**2*b1*f*fd*r - 10956*D1**2*b1*f*fd*s**2 + 10956*D1**2*b1*f*fd*s - 5478*D1**2*b1*f*fd + 6270*D1**2*b1*f*fdd*r**2 + 12540*D1**2*b1*f*fdd*r*s - 6270*D1**2*b1*f*fdd*r + 6270*D1**2*b1*f*fdd*s**2 - 6270*D1**2*b1*f*fdd*s + 3135*D1**2*b1*f*fdd + 6270*D1**2*b1*fd**2*r**2 + 12540*D1**2*b1*fd**2*r*s - 6270*D1**2*b1*fd**2*r + 6270*D1**2*b1*fd**2*s**2 - 6270*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(16*C - 19)*(r + s - 1)**2 - 11874*D1**2*f**2*fd*r**2 - 23748*D1**2*f**2*fd*r*s + 15832*D1**2*f**2*fd*r - 11874*D1**2*f**2*fd*s**2 + 15832*D1**2*f**2*fd*s - 7916*D1**2*f**2*fd + 7125*D1**2*f**2*fdd*r**2 + 14250*D1**2*f**2*fdd*r*s - 9500*D1**2*f**2*fdd*r + 7125*D1**2*f**2*fdd*s**2 - 9500*D1**2*f**2*fdd*s + 4750*D1**2*f**2*fdd + 14250*D1**2*f*fd**2*r**2 + 28500*D1**2*f*fd**2*r*s - 19000*D1**2*f*fd**2*r + 14250*D1**2*f*fd**2*s**2 - 19000*D1**2*f*fd**2*s + 4750*D1**2*f*fd**2 - 21912*D1*Dd*b1*f**2*r**2 - 43824*D1*Dd*b1*f**2*r*s + 21912*D1*Dd*b1*f**2*r - 21912*D1*Dd*b1*f**2*s**2 + 21912*D1*Dd*b1*f**2*s - 10956*D1*Dd*b1*f**2 + 50160*D1*Dd*b1*f*fd*r**2 + 100320*D1*Dd*b1*f*fd*r*s - 50160*D1*Dd*b1*f*fd*r + 50160*D1*Dd*b1*f*fd*s**2 - 50160*D1*Dd*b1*f*fd*s + 12540*D1*Dd*b1*f*fd - 15832*D1*Dd*f**3*r**2 - 31664*D1*Dd*f**3*r*s + 15832*D1*Dd*f**3*r - 15832*D1*Dd*f**3*s**2 + 15832*D1*Dd*f**3*s - 7916*D1*Dd*f**3 + 57000*D1*Dd*f**2*fd*r**2 + 114000*D1*Dd*f**2*fd*r*s - 66500*D1*Dd*f**2*fd*r + 57000*D1*Dd*f**2*fd*s**2 - 66500*D1*Dd*f**2*fd*s + 19000*D1*Dd*f**2*fd + 12540*D1*Ddd*b1*f**2*r**2 + 25080*D1*Ddd*b1*f**2*r*s - 12540*D1*Ddd*b1*f**2*r + 12540*D1*Ddd*b1*f**2*s**2 - 12540*D1*Ddd*b1*f**2*s + 6270*D1*Ddd*b1*f**2 + 9500*D1*Ddd*f**3*r**2 + 19000*D1*Ddd*f**3*r*s - 9500*D1*Ddd*f**3*r + 9500*D1*Ddd*f**3*s**2 - 9500*D1*Ddd*f**3*s + 4750*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(68*C - 83)*(r + s - 1) - D1*fd*(80*C - 95)*(2*r + 2*s - 1) - Dd*f*(160*C - 190)*(2*r + 2*s - 1)) + 37620*Dd**2*b1*f**2*r**2 + 75240*Dd**2*b1*f**2*r*s - 37620*Dd**2*b1*f**2*r + 37620*Dd**2*b1*f**2*s**2 - 37620*Dd**2*b1*f**2*s + 6270*Dd**2*b1*f**2 + 28500*Dd**2*f**3*r**2 + 57000*Dd**2*f**3*r*s - 28500*Dd**2*f**3*r + 28500*Dd**2*f**3*s**2 - 28500*Dd**2*f**3*s + 4750*Dd**2*f**3)/(693*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**5*k1*k2**3*(66*b1**2*(D1**2*(r + s)**2*(fd*(34*C - 40) + fdd*(27 - 24*C)) + 4*D1*Dd*(f*(17*C - 20)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(24*C - 27)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - D1*Ddd*f*(48*C - 54)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd**2*f*(48*C - 54)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 33*b1*(-12*D1**2*bdd1*f*(8*C - 9)*(r + s - 1)**2 - 3*D1**2*(f*(fd*(8*C + 22) - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 50*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 8*D1*bd1*(r + s - 1)*(D1*f*(17*C - 20)*(r + s - 1) - D1*fd*(24*C - 27)*(r + s) - Dd*f*(48*C - 54)*(2*r + 2*s - 1)) - 6*D1*f*(2*Dd*(f*(4*C + 11)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 25*fd*(2*r + 2*s - 1)**2) - 25*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 150*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + f*(-396*D1**2*bd1**2*(8*C - 9)*(r + s - 1)**2 + 2475*D1**2*bdd1*f*(r + s - 1)**2 - 10*D1**2*(f*(fd*(224*C + 3) - fdd*(112*C + 84))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(-224*C - 168)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 198*D1*bd1*(r + s - 1)*(D1*f*(4*C + 11)*(r + s - 1) - 25*D1*fd*(2*r + 2*s - 1) - 50*Dd*f*(2*r + 2*s - 1)) - 20*D1*f*(Dd*(f*(224*C + 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(224*C + 168)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Ddd*f*(-112*C - 84)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 5*Dd**2*f**2*(448*C + 336)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(693*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**5*k1*k2*st**2*(33*b1*(D1**2*(f*(fd*(36*C - 46) + fdd*(25 - 20*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(25 - 20*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(36*C - 46)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(25 - 20*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(25 - 20*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(25 - 20*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(868*C - 1118)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 25)*(33*bdd1*s*(r + s - 1) + 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(625 - 500*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(36*C - 46)*(r + s - 1) - fd*(20*C - 25)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(25 - 20*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(868*C - 1118)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(500*C - 625)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(625 - 500*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(625 - 500*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k3**4) - 2*D1**2*Pk1*Pk2*ct**5*k1*k2*(264*b1**2*(D1**2*s*(r + s)*(fd*(29*C - 35) + fdd*(21 - 18*C)) + D1*(Dd*(f*(29*C - 35)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(18*C - 21)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(21 - 18*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(18*C - 21)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 66*b1*(-120*C*D1**2*f*fd*r**2 - 624*C*D1**2*f*fd*r*s + 408*C*D1**2*f*fd*r - 504*C*D1**2*f*fd*s**2 + 600*C*D1**2*f*fd*s - 348*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 504*C*D1**2*f*fdd*r*s - 312*C*D1**2*f*fdd*r + 384*C*D1**2*f*fdd*s**2 - 444*C*D1**2*f*fdd*s + 252*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 + 504*C*D1**2*fd**2*r*s - 312*C*D1**2*fd**2*r + 384*C*D1**2*fd**2*s**2 - 444*C*D1**2*fd**2*s - 240*C*D1*Dd*f**2*r**2 - 1248*C*D1*Dd*f**2*r*s + 432*C*D1*Dd*f**2*r - 1008*C*D1*Dd*f**2*s**2 + 816*C*D1*Dd*f**2*s - 312*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 4032*C*D1*Dd*f*fd*r*s - 1992*C*D1*Dd*f*fd*r + 3072*C*D1*Dd*f*fd*s**2 - 3048*C*D1*Dd*f*fd*s + 756*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 1008*C*D1*Ddd*f**2*r*s - 372*C*D1*Ddd*f**2*r + 768*C*D1*Ddd*f**2*s**2 - 636*C*D1*Ddd*f**2*s + 252*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 3024*C*Dd**2*f**2*r*s - 1116*C*Dd**2*f**2*r + 2304*C*Dd**2*f**2*s**2 - 1908*C*Dd**2*f**2*s + 252*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(6*C - 7)*(2*s - 1)*(r + s - 1) + 186*D1**2*f*fd*r**2 + 484*D1**2*f*fd*r*s - 358*D1**2*f*fd*r + 298*D1**2*f*fd*s**2 - 414*D1**2*f*fd*s + 265*D1**2*f*fd - 180*D1**2*f*fdd*r**2 - 428*D1**2*f*fdd*r*s + 284*D1**2*f*fdd*r - 248*D1**2*f*fdd*s**2 + 318*D1**2*f*fdd*s - 194*D1**2*f*fdd - 180*D1**2*fd**2*r**2 - 428*D1**2*fd**2*r*s + 284*D1**2*fd**2*r - 248*D1**2*fd**2*s**2 + 318*D1**2*fd**2*s + 372*D1*Dd*f**2*r**2 + 968*D1*Dd*f**2*r*s - 428*D1*Dd*f**2*r + 596*D1*Dd*f**2*s**2 - 540*D1*Dd*f**2*s + 242*D1*Dd*f**2 - 1440*D1*Dd*f*fd*r**2 - 3424*D1*Dd*f*fd*r*s + 1924*D1*Dd*f*fd*r - 1984*D1*Dd*f*fd*s**2 + 2196*D1*Dd*f*fd*s - 602*D1*Dd*f*fd - 360*D1*Ddd*f**2*r**2 - 856*D1*Ddd*f**2*r*s + 394*D1*Ddd*f**2*r - 496*D1*Ddd*f**2*s**2 + 462*D1*Ddd*f**2*s - 214*D1*Ddd*f**2 + 4*D1*bd1*(D1*(f*(29*C - 35)*(2*s - 1)*(r + s - 1) - fd*(18*C - 21)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(42 - 36*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 1080*Dd**2*f**2*r**2 - 2568*Dd**2*f**2*r*s + 1182*Dd**2*f**2*r - 1488*Dd**2*f**2*s**2 + 1386*Dd**2*f**2*s - 214*Dd**2*f**2) + f*(-792*D1**2*bd1**2*(6*C - 7)*(2*s - 1)*(r + s - 1) + 132*D1**2*bdd1*f*(r + s - 1)*(r*(30*C - 45) + s*(96*C - 62) + 10) - 5*D1**2*(f*(fd*(12*C*(225*r**2 + 1194*r*s - 548*r + 969*s**2 - 1044*s + 398) - 4167*r**2 - 12954*r*s + 7096*r - 8787*s**2 + 10176*s - 4318) + fdd*(-12*C*(195*r**2 + 894*r*s - 428*r + 699*s**2 - 764*s + 298) + 3519*r**2 + 9942*r*s - 5660*r + 6423*s**2 - 7596*s + 3314)) - 2*fd**2*(12*C*(195*r**2 + 894*r*s - 428*r + 699*s**2 - 764*s + 149) - 3519*r**2 - 9942*r*s + 5660*r - 6423*s**2 + 7596*s - 1657)) - 66*D1*bd1*(D1*(f*(r + s - 1)*(12*C*(5*r + 21*s + 3) - 93*r - 149*s - 23) + 2*fd*(-6*C*(20*r**2 + 84*r*s - 36*r + 64*s**2 - 69*s + 21) + 180*r**2 + 428*r*s - 252*r + 248*s**2 - 303*s + 107)) - 2*Dd*f*(6*C*(40*r**2 + 168*r*s - 51*r + 128*s**2 - 117*s + 21) - 360*r**2 - 856*r*s + 417*r - 496*s**2 + 519*s - 127)) - 10*D1*f*(Dd*(f*(12*C*(150*r**2 + 796*r*s - 274*r + 646*s**2 - 522*s + 199) - 2778*r**2 - 8636*r*s + 3548*r - 5858*s**2 + 5088*s - 2159) + 2*fd*(-12*C*(390*r**2 + 1788*r*s - 749*r + 1398*s**2 - 1337*s + 298) + 7038*r**2 + 19884*r*s - 9905*r + 12846*s**2 - 13293*s + 3314)) + Ddd*f*(-12*C*(130*r**2 + 596*r*s - 214*r + 466*s**2 - 382*s + 149) + 2346*r**2 + 6628*r*s - 2830*r + 4282*s**2 - 3798*s + 1657)) - 10*Dd**2*f**2*(-12*C*(390*r**2 + 1788*r*s - 642*r + 1398*s**2 - 1146*s + 149) + 7038*r**2 + 19884*r*s - 8490*r + 12846*s**2 - 11394*s + 1657)))/(693*d**2*k3**4) - D1**2*Pk1*Pk2*ct**5*k1*st**2*(160*C - 220)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(50*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2*k3**2) + 8*D1**2*Pk1*Pk2*ct**5*k1*(429*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 12*fd*(s - 1)**2 - 6*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 6*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 6)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 6)*(2*s - 1)) + 13*b1*(D1**2*(10*f**2*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + f*(-560*fd**2*s*(3*s - 2) - 330*fd*(s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) - 165*fdd*(2*s**2 - 2*s + 1) + 33*s**2*(24*bd1 - 12*bdd1)) - 66*fd*s*(12*bd1 + 5*fd)*(s - 1)) + D1*f*(2*Dd*(280*f**2*(4*s**2 - 2*s + 1) - 5*f*(56*fd*(12*s**2 - 7*s + 1) + 33*s**2*(8*bd1 - 4) - 33*s*(2*bd1 - 2) - 33) - (132*s - 33)*(12*bd1*s + 5*fd*(2*s - 1))) - 5*Ddd*f*(56*f + 33)*(4*s**2 - 2*s + 1)) - 30*Dd**2*f**2*s*(56*f + 33)*(2*s - 1)) + f*(D1**2*(-858*bd1*s*(6*bd1*s + 5*fd*(2*s - 1)) + 35*f**2*(90*fd*(4*s**2 - 2*s + 1) - 45*fdd*(4*s**2 - 2*s + 1) + s**2*(208*bd1 - 104*bdd1)) - 5*f*s*(858*bd1**2*s + 26*bd1*(56*fd*(3*s - 1) - 33*s) + 429*bdd1*s + 1890*fd**2*(2*s - 1))) + 5*D1*f*(2*Dd*(429*bd1*s*(1 - 4*s) + 315*f**2*(4*s**2 - 2*s + 1) - 7*f*(4*s - 1)*(104*bd1*s + 45*fd*(4*s - 1))) - 315*Ddd*f**2*(4*s**2 - 2*s + 1)) - 9450*Dd**2*f**3*s*(2*s - 1)))/(3003*d**2*k2**3) + 20*D1**2*Pk1*Pk2*ct**5*k2**5*st**2*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 150*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 - 200*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 264*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 528*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 528*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 200*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 200*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 - 200*D1*Dd*f**3*s + 100*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 700*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 700*D1*Dd*f**2*fd*s - 200*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 132*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 100*D1*Ddd*f**3*s - 50*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 396*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 300*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 300*Dd**2*f**3*s - 50*Dd**2*f**3)/(231*d**2*k1*k3**6) + 8*D1**2*Pk1*Pk2*ct**5*k2**5*(D1*f*(-12*D1*bd1**2*(r + s - 1)**2 + 2*bd1*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(2*r + 2*s - 1)) - 5*f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1))) + 6*b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-12*D1**2*bdd1*f*(r + s - 1)**2 + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 8*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 80*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 20*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 + 24*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 60*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk2*ct**5*k2**3*st**2*(2112*C*D1**2*b1*f*fd*r**2 + 2112*C*D1**2*b1*f*fd*r*s - 1056*C*D1**2*b1*f*fd*r - 660*C*D1**2*b1*f*fdd*r**2 - 660*C*D1**2*b1*f*fdd*r*s + 330*C*D1**2*b1*f*fdd*r - 660*C*D1**2*b1*fd**2*r**2 - 660*C*D1**2*b1*fd**2*r*s + 330*C*D1**2*b1*fd**2*r + 2856*C*D1**2*f**2*fd*r**2 + 2856*C*D1**2*f**2*fd*r*s - 2856*C*D1**2*f**2*fd*r - 952*C*D1**2*f**2*fd*s + 952*C*D1**2*f**2*fd - 1230*C*D1**2*f**2*fdd*r**2 - 1230*C*D1**2*f**2*fdd*r*s + 1230*C*D1**2*f**2*fdd*r + 410*C*D1**2*f**2*fdd*s - 410*C*D1**2*f**2*fdd - 2460*C*D1**2*f*fd**2*r**2 - 2460*C*D1**2*f*fd**2*r*s + 2460*C*D1**2*f*fd**2*r + 820*C*D1**2*f*fd**2*s - 410*C*D1**2*f*fd**2 + 4224*C*D1*Dd*b1*f**2*r**2 + 4224*C*D1*Dd*b1*f**2*r*s - 3168*C*D1*Dd*b1*f**2*r - 1056*C*D1*Dd*b1*f**2*s + 1056*C*D1*Dd*b1*f**2 - 5280*C*D1*Dd*b1*f*fd*r**2 - 5280*C*D1*Dd*b1*f*fd*r*s + 3300*C*D1*Dd*b1*f*fd*r + 660*C*D1*Dd*b1*f*fd*s - 330*C*D1*Dd*b1*f*fd + 3808*C*D1*Dd*f**3*r**2 + 3808*C*D1*Dd*f**3*r*s - 2856*C*D1*Dd*f**3*r - 952*C*D1*Dd*f**3*s + 952*C*D1*Dd*f**3 - 9840*C*D1*Dd*f**2*fd*r**2 - 9840*C*D1*Dd*f**2*fd*r*s + 8610*C*D1*Dd*f**2*fd*r + 2870*C*D1*Dd*f**2*fd*s - 1640*C*D1*Dd*f**2*fd - 1320*C*D1*Ddd*b1*f**2*r**2 - 1320*C*D1*Ddd*b1*f**2*r*s + 990*C*D1*Ddd*b1*f**2*r + 330*C*D1*Ddd*b1*f**2*s - 330*C*D1*Ddd*b1*f**2 - 1640*C*D1*Ddd*f**3*r**2 - 1640*C*D1*Ddd*f**3*r*s + 1230*C*D1*Ddd*f**3*r + 410*C*D1*Ddd*f**3*s - 410*C*D1*Ddd*f**3 - 3960*C*Dd**2*b1*f**2*r**2 - 3960*C*Dd**2*b1*f**2*r*s + 2970*C*Dd**2*b1*f**2*r + 990*C*Dd**2*b1*f**2*s - 330*C*Dd**2*b1*f**2 - 4920*C*Dd**2*f**3*r**2 - 4920*C*Dd**2*f**3*r*s + 3690*C*Dd**2*f**3*r + 1230*C*Dd**2*f**3*s - 410*C*Dd**2*f**3 - 2112*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r + 1980*D1**2*b1*f*fd*s**2 - 1980*D1**2*b1*f*fd*s + 990*D1**2*b1*f*fd + 660*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 990*D1**2*b1*f*fdd*s**2 + 990*D1**2*b1*f*fdd*s - 495*D1**2*b1*f*fdd + 660*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 990*D1**2*b1*fd**2*s**2 + 990*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)*(2*C*(r - 1) - 2*r + 3*s + 2) - 2856*D1**2*f**2*fd*r**2 - 606*D1**2*f**2*fd*r*s + 2106*D1**2*f**2*fd*r + 2250*D1**2*f**2*fd*s**2 - 1298*D1**2*f**2*fd*s - 202*D1**2*f**2*fd + 1230*D1**2*f**2*fdd*r**2 + 105*D1**2*f**2*fdd*r*s - 855*D1**2*f**2*fdd*r - 1125*D1**2*f**2*fdd*s**2 + 715*D1**2*f**2*fdd*s + 35*D1**2*f**2*fdd + 2460*D1**2*f*fd**2*r**2 + 210*D1**2*f*fd**2*r*s - 1710*D1**2*f*fd**2*r - 2250*D1**2*f*fd**2*s**2 + 1430*D1**2*f*fd**2*s + 35*D1**2*f*fd**2 - 4224*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 2178*D1*Dd*b1*f**2*r + 3960*D1*Dd*b1*f**2*s**2 - 1914*D1*Dd*b1*f**2*s - 66*D1*Dd*b1*f**2 + 5280*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s - 330*D1*Dd*b1*f*fd*r - 7920*D1*Dd*b1*f*fd*s**2 + 6270*D1*Dd*b1*f*fd*s - 1155*D1*Dd*b1*f*fd - 3808*D1*Dd*f**3*r**2 - 808*D1*Dd*f**3*r*s + 2106*D1*Dd*f**3*r + 3000*D1*Dd*f**3*s**2 - 1298*D1*Dd*f**3*s - 202*D1*Dd*f**3 + 9840*D1*Dd*f**2*fd*r**2 + 840*D1*Dd*f**2*fd*r*s - 5985*D1*Dd*f**2*fd*r - 9000*D1*Dd*f**2*fd*s**2 + 5005*D1*Dd*f**2*fd*s + 140*D1*Dd*f**2*fd + 1320*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s - 495*D1*Ddd*b1*f**2*r - 1980*D1*Ddd*b1*f**2*s**2 + 1155*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 + 1640*D1*Ddd*f**3*r**2 + 140*D1*Ddd*f**3*r*s - 855*D1*Ddd*f**3*r - 1500*D1*Ddd*f**3*s**2 + 715*D1*Ddd*f**3*s + 35*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(2*f*(r + s - 1)*(16*C*(r - 1) - 16*r + 15*s + 16) - 5*fd*(2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 8*r**2 + 4*r*s + 7*r + 12*s**2 - 8*s + 1)) - 5*Dd*f*(2*C*(8*r**2 + 8*r*s - 11*r - 5*s + 3) - 16*r**2 + 8*r*s + 19*r + 24*s**2 - 11*s - 3)) + 3960*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s - 1485*Dd**2*b1*f**2*r - 5940*Dd**2*b1*f**2*s**2 + 3465*Dd**2*b1*f**2*s - 165*Dd**2*b1*f**2 + 4920*Dd**2*f**3*r**2 + 420*Dd**2*f**3*r*s - 2565*Dd**2*f**3*r - 4500*Dd**2*f**3*s**2 + 2145*Dd**2*f**3*s + 35*Dd**2*f**3)/(693*d**2*k1*k3**4) + 2*D1**2*Pk1*Pk2*ct**5*k2**3*(1848*D1*b1**2*(C - 1)*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 66*b1*(28*D1**2*bd1*f*(C - 1)*(2*r - 1)*(r + s - 1) + D1**2*(f*(fd*(8*C*(2*r**2 + r*(2*s - 5) - 4*s + 4) - 34*r**2 + r*(86 - 108*s) - 74*s**2 + 106*s - 69) + 4*fdd*(C*(-2*r**2 - 2*r*(s - 1) + s - 1) + 2*r**2 + 2*r*(9*s - 5) + 16*s**2 - 17*s + 9)) + 4*fd**2*(r**2*(2 - 2*C) - 2*r*(C*(s - 1) - 9*s + 5) + s*(C + 16*s - 17))) + 2*D1*f*(Dd*(f*(4*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 34*r**2 - 108*r*s + 44*r - 74*s**2 + 64*s - 27) - 2*fd*(2*r + 2*s - 1)*(C*(8*r - 3) - 8*r - 64*s + 27)) + 2*Ddd*f*(C*(-4*r**2 - 4*r*s + 3*r + s - 1) + 4*r**2 + 36*r*s - 11*r + 32*s**2 - 25*s + 9)) - 4*Dd**2*f**2*(C*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1) - 12*r**2 - 3*r*(36*s - 11) - 96*s**2 + 75*s - 9)) + f*(D1**2*(f*(-264*bdd1*(r*(C - 1) - 8*s)*(r + s - 1) - 5*fd*(344*C*(3*r**2 + 3*r*(s - 1) - s + 1) - 153*r**2 + 1074*r*s - 256*r + 1227*s**2 - 1176*s + 358) + 5*fdd*(40*C*(3*r**2 + 3*r*(s - 1) - s + 1) + 171*r**2 + 1230*r*s - 524*r + 1059*s**2 - 1116*s + 410)) + 10*fd**2*(20*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 171*r**2 + 2*r*(615*s - 262) + 1059*s**2 - 1116*s + 205)) + 66*D1*bd1*(D1*(f*(r + s - 1)*(8*C*(r + 3) - 17*r - 37*s - 15) - 4*fd*(C*(4*r**2 + 4*r*(s - 1) - s + 1) - 4*r**2 - 36*r*s + 12*r - 32*s**2 + 33*s - 9)) - 4*Dd*f*(C*(8*r**2 + 8*r*s - 7*r - s + 1) - 8*r**2 - 72*r*s + 15*r - 64*s**2 + 57*s - 9)) - 10*D1*f*(Dd*(f*(172*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 102*r**2 + 716*r*s - 128*r + 818*s**2 - 588*s + 179) - 2*fd*(10*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + 342*r**2 + 2460*r*s - 917*r + 2118*s**2 - 1953*s + 410)) - Ddd*f*(20*C*(4*r**2 + 4*r*s - 3*r - s + 1) + 114*r**2 + 820*r*s - 262*r + 706*s**2 - 558*s + 205)) + 10*Dd**2*f**2*(20*C*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1) + 342*r**2 + 6*r*(410*s - 131) + 2118*s**2 - 1674*s + 205)))/(693*d**2*k1*k3**4) - D1**2*Pk1*Pk2*ct**4*f*k2**4*st**4*(80*C - 80)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 2*D1*f*(2*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) - Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1))/(77*d**2*k3**6) - D1**2*Pk1*Pk2*ct**4*f*k2**2*st**4*(160*C - 160)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1))/(77*d**2*k3**4) - D1**2*Pk1*Pk2*ct**4*f*st**4*(240*C - 240)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k3**2) - D1**2*Pk1*Pk2*ct**4*k1**4*(16*C - 48)*(264*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r + 264*D1**2*b1*f*fd*s**2 - 264*D1**2*b1*f*fd*s + 132*D1**2*b1*f*fd - 330*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 330*D1**2*b1*f*fdd*s**2 + 330*D1**2*b1*f*fdd*s - 165*D1**2*b1*f*fdd - 330*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r - 330*D1**2*b1*fd**2*s**2 + 330*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)**2 + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r + 528*D1*Dd*b1*f**2*s**2 - 528*D1*Dd*b1*f**2*s + 264*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 2640*D1*Dd*b1*f*fd*r - 2640*D1*Dd*b1*f*fd*s**2 + 2640*D1*Dd*b1*f*fd*s - 660*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 460*D1*Dd*f**3*s + 230*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 3920*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3920*D1*Dd*f**2*fd*s - 1120*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r - 660*D1*Ddd*b1*f**2*s**2 + 660*D1*Ddd*b1*f**2*s - 330*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 280*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(2*r + 2*s - 1)) - 1980*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r - 1980*Dd**2*b1*f**2*s**2 + 1980*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**6) + 16*D1**2*Pk1*Pk2*ct**4*k1**4*(33*b1*(D1**2*(f*(4*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(4*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 5*fd*(8*s - 3)*(2*r + 2*s - 1)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(-5*D1**2*(f*(33*bdd1*s*(r + s - 1) - 23*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(4*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) - 5*D1*f*(Dd*(-23*f*(4*r*s - r + 4*s**2 - 3*s + 1) + 28*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) + 28*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 140*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k2**2*k3**4) - 16*D1**2*Pk1*Pk2*ct**4*k1**2*k2**2*st**2*(1782*C*D1**2*b1*f*fd*r**2 + 3564*C*D1**2*b1*f*fd*r*s - 1782*C*D1**2*b1*f*fd*r + 1782*C*D1**2*b1*f*fd*s**2 - 1782*C*D1**2*b1*f*fd*s + 891*C*D1**2*b1*f*fd - 1188*C*D1**2*b1*f*fdd*r**2 - 2376*C*D1**2*b1*f*fdd*r*s + 1188*C*D1**2*b1*f*fdd*r - 1188*C*D1**2*b1*f*fdd*s**2 + 1188*C*D1**2*b1*f*fdd*s - 594*C*D1**2*b1*f*fdd - 1188*C*D1**2*b1*fd**2*r**2 - 2376*C*D1**2*b1*fd**2*r*s + 1188*C*D1**2*b1*fd**2*r - 1188*C*D1**2*b1*fd**2*s**2 + 1188*C*D1**2*b1*fd**2*s + 1809*C*D1**2*f**2*fd*r**2 + 3618*C*D1**2*f**2*fd*r*s - 2412*C*D1**2*f**2*fd*r + 1809*C*D1**2*f**2*fd*s**2 - 2412*C*D1**2*f**2*fd*s + 1206*C*D1**2*f**2*fd - 1350*C*D1**2*f**2*fdd*r**2 - 2700*C*D1**2*f**2*fdd*r*s + 1800*C*D1**2*f**2*fdd*r - 1350*C*D1**2*f**2*fdd*s**2 + 1800*C*D1**2*f**2*fdd*s - 900*C*D1**2*f**2*fdd - 2700*C*D1**2*f*fd**2*r**2 - 5400*C*D1**2*f*fd**2*r*s + 3600*C*D1**2*f*fd**2*r - 2700*C*D1**2*f*fd**2*s**2 + 3600*C*D1**2*f*fd**2*s - 900*C*D1**2*f*fd**2 + 3564*C*D1*Dd*b1*f**2*r**2 + 7128*C*D1*Dd*b1*f**2*r*s - 3564*C*D1*Dd*b1*f**2*r + 3564*C*D1*Dd*b1*f**2*s**2 - 3564*C*D1*Dd*b1*f**2*s + 1782*C*D1*Dd*b1*f**2 - 9504*C*D1*Dd*b1*f*fd*r**2 - 19008*C*D1*Dd*b1*f*fd*r*s + 9504*C*D1*Dd*b1*f*fd*r - 9504*C*D1*Dd*b1*f*fd*s**2 + 9504*C*D1*Dd*b1*f*fd*s - 2376*C*D1*Dd*b1*f*fd + 2412*C*D1*Dd*f**3*r**2 + 4824*C*D1*Dd*f**3*r*s - 2412*C*D1*Dd*f**3*r + 2412*C*D1*Dd*f**3*s**2 - 2412*C*D1*Dd*f**3*s + 1206*C*D1*Dd*f**3 - 10800*C*D1*Dd*f**2*fd*r**2 - 21600*C*D1*Dd*f**2*fd*r*s + 12600*C*D1*Dd*f**2*fd*r - 10800*C*D1*Dd*f**2*fd*s**2 + 12600*C*D1*Dd*f**2*fd*s - 3600*C*D1*Dd*f**2*fd - 2376*C*D1*Ddd*b1*f**2*r**2 - 4752*C*D1*Ddd*b1*f**2*r*s + 2376*C*D1*Ddd*b1*f**2*r - 2376*C*D1*Ddd*b1*f**2*s**2 + 2376*C*D1*Ddd*b1*f**2*s - 1188*C*D1*Ddd*b1*f**2 - 1800*C*D1*Ddd*f**3*r**2 - 3600*C*D1*Ddd*f**3*r*s + 1800*C*D1*Ddd*f**3*r - 1800*C*D1*Ddd*f**3*s**2 + 1800*C*D1*Ddd*f**3*s - 900*C*D1*Ddd*f**3 - 7128*C*Dd**2*b1*f**2*r**2 - 14256*C*Dd**2*b1*f**2*r*s + 7128*C*Dd**2*b1*f**2*r - 7128*C*Dd**2*b1*f**2*s**2 + 7128*C*Dd**2*b1*f**2*s - 1188*C*Dd**2*b1*f**2 - 5400*C*Dd**2*f**3*r**2 - 10800*C*Dd**2*f**3*r*s + 5400*C*Dd**2*f**3*r - 5400*C*Dd**2*f**3*s**2 + 5400*C*Dd**2*f**3*s - 900*C*Dd**2*f**3 - 2904*D1**2*b1*f*fd*r**2 - 5808*D1**2*b1*f*fd*r*s + 2904*D1**2*b1*f*fd*r - 2904*D1**2*b1*f*fd*s**2 + 2904*D1**2*b1*f*fd*s - 1452*D1**2*b1*f*fd + 1848*D1**2*b1*f*fdd*r**2 + 3696*D1**2*b1*f*fdd*r*s - 1848*D1**2*b1*f*fdd*r + 1848*D1**2*b1*f*fdd*s**2 - 1848*D1**2*b1*f*fdd*s + 924*D1**2*b1*f*fdd + 1848*D1**2*b1*fd**2*r**2 + 3696*D1**2*b1*fd**2*r*s - 1848*D1**2*b1*fd**2*r + 1848*D1**2*b1*fd**2*s**2 - 1848*D1**2*b1*fd**2*s - 66*D1**2*bdd1*f**2*(9*C - 14)*(r + s - 1)**2 - 3012*D1**2*f**2*fd*r**2 - 6024*D1**2*f**2*fd*r*s + 4016*D1**2*f**2*fd*r - 3012*D1**2*f**2*fd*s**2 + 4016*D1**2*f**2*fd*s - 2008*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 5808*D1*Dd*b1*f**2*r**2 - 11616*D1*Dd*b1*f**2*r*s + 5808*D1*Dd*b1*f**2*r - 5808*D1*Dd*b1*f**2*s**2 + 5808*D1*Dd*b1*f**2*s - 2904*D1*Dd*b1*f**2 + 14784*D1*Dd*b1*f*fd*r**2 + 29568*D1*Dd*b1*f*fd*r*s - 14784*D1*Dd*b1*f*fd*r + 14784*D1*Dd*b1*f*fd*s**2 - 14784*D1*Dd*b1*f*fd*s + 3696*D1*Dd*b1*f*fd - 4016*D1*Dd*f**3*r**2 - 8032*D1*Dd*f**3*r*s + 4016*D1*Dd*f**3*r - 4016*D1*Dd*f**3*s**2 + 4016*D1*Dd*f**3*s - 2008*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 19600*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 19600*D1*Dd*f**2*fd*s + 5600*D1*Dd*f**2*fd + 3696*D1*Ddd*b1*f**2*r**2 + 7392*D1*Ddd*b1*f**2*r*s - 3696*D1*Ddd*b1*f**2*r + 3696*D1*Ddd*b1*f**2*s**2 - 3696*D1*Ddd*b1*f**2*s + 1848*D1*Ddd*b1*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 2800*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 2800*D1*Ddd*f**3*s + 1400*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(27*C - 44)*(r + s - 1) - D1*fd*(36*C - 56)*(2*r + 2*s - 1) - Dd*f*(72*C - 112)*(2*r + 2*s - 1)) + 11088*Dd**2*b1*f**2*r**2 + 22176*Dd**2*b1*f**2*r*s - 11088*Dd**2*b1*f**2*r + 11088*Dd**2*b1*f**2*s**2 - 11088*Dd**2*b1*f**2*s + 1848*Dd**2*b1*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 8400*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 8400*Dd**2*f**3*s + 1400*Dd**2*f**3)/(693*d**2*k3**6) - 16*D1**2*Pk1*Pk2*ct**4*k1**2*k2**2*(33*b1**2*(D1**2*(r + s)**2*(fd*(37*C - 54) + fdd*(48 - 36*C)) + 2*D1*(Dd*(f*(37*C - 54)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(72*C - 96)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(48 - 36*C)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(72*C - 96)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 66*b1*(-6*C*D1**2*f*fd*r**2 - 12*C*D1**2*f*fd*r*s + 6*C*D1**2*f*fd*r - 6*C*D1**2*f*fd*s**2 + 6*C*D1**2*f*fd*s - 3*C*D1**2*f*fd - 12*C*D1*Dd*f**2*r**2 - 24*C*D1*Dd*f**2*r*s + 12*C*D1*Dd*f**2*r - 12*C*D1*Dd*f**2*s**2 + 12*C*D1*Dd*f**2*s - 6*C*D1*Dd*f**2 - 12*D1**2*bdd1*f*(3*C - 4)*(r + s - 1)**2 - 40*D1**2*f*fd*r**2 - 80*D1**2*f*fd*r*s + 40*D1**2*f*fd*r - 40*D1**2*f*fd*s**2 + 40*D1**2*f*fd*s - 20*D1**2*f*fd + 50*D1**2*f*fdd*r**2 + 100*D1**2*f*fdd*r*s - 50*D1**2*f*fdd*r + 50*D1**2*f*fdd*s**2 - 50*D1**2*f*fdd*s + 25*D1**2*f*fdd + 50*D1**2*fd**2*r**2 + 100*D1**2*fd**2*r*s - 50*D1**2*fd**2*r + 50*D1**2*fd**2*s**2 - 50*D1**2*fd**2*s - 80*D1*Dd*f**2*r**2 - 160*D1*Dd*f**2*r*s + 80*D1*Dd*f**2*r - 80*D1*Dd*f**2*s**2 + 80*D1*Dd*f**2*s - 40*D1*Dd*f**2 + 400*D1*Dd*f*fd*r**2 + 800*D1*Dd*f*fd*r*s - 400*D1*Dd*f*fd*r + 400*D1*Dd*f*fd*s**2 - 400*D1*Dd*f*fd*s + 100*D1*Dd*f*fd + 100*D1*Ddd*f**2*r**2 + 200*D1*Ddd*f**2*r*s - 100*D1*Ddd*f**2*r + 100*D1*Ddd*f**2*s**2 - 100*D1*Ddd*f**2*s + 50*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(D1*f*(37*C - 54)*(r + s - 1) - D1*fd*(72*C - 96)*(r + s) - Dd*f*(144*C - 192)*(2*r + 2*s - 1)) + 300*Dd**2*f**2*r**2 + 600*Dd**2*f**2*r*s - 300*Dd**2*f**2*r + 300*Dd**2*f**2*s**2 - 300*Dd**2*f**2*s + 50*Dd**2*f**2) - 2*f*(396*D1**2*bd1**2*(3*C - 4)*(r + s - 1)**2 - 825*D1**2*bdd1*f*(r + s - 1)**2 - 10*D1**2*(-f*(-42*C*fdd + fd*(51*C - 5) - 14*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(84*C + 28)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 33*D1*bd1*(r + s - 1)*(D1*f*(3*C + 20)*(r + s - 1) - 50*D1*fd*(2*r + 2*s - 1) - 100*Dd*f*(2*r + 2*s - 1)) + 20*D1*f*(Dd*(f*(51*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(84*C + 28)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Ddd*f*(-42*C - 14)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 5*Dd**2*f**2*(168*C + 56)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(693*d**2*k3**6) - 16*D1**2*Pk1*Pk2*ct**4*k1**2*st**2*(33*b1*(D1**2*(f*(fd*(10*C - 19) + fdd*(11 - 6*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - fd**2*(6*C - 11)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(10*C - 19)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C - 11)*(8*s - 3)*(2*r + 2*s - 1)) - Ddd*f*(6*C - 11)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f**2*(6*C - 11)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(234*C - 451)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (6*C - 11)*(33*bdd1*s*(r + s - 1) + 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(275 - 150*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(10*C - 19)*(r + s - 1) - fd*(6*C - 11)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(6*C - 11)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(234*C - 451)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(150*C - 275)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(275 - 150*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(275 - 150*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k3**4) - 4*D1**2*Pk1*Pk2*ct**4*k1**2*(66*b1**2*(D1**2*s*(r + s)*(fd*(44*C - 73) + fdd*(54 - 36*C)) + D1*(Dd*(f*(44*C - 73)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(36*C - 54)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(54 - 36*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(36*C - 54)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 33*b1*(-36*C*D1**2*f*fd*r**2 - 408*C*D1**2*f*fd*r*s + 276*C*D1**2*f*fd*r - 372*C*D1**2*f*fd*s**2 + 444*C*D1**2*f*fd*s - 258*C*D1**2*f*fd + 60*C*D1**2*f*fdd*r**2 + 384*C*D1**2*f*fdd*r*s - 252*C*D1**2*f*fdd*r + 324*C*D1**2*f*fdd*s**2 - 384*C*D1**2*f*fdd*s + 222*C*D1**2*f*fdd + 60*C*D1**2*fd**2*r**2 + 384*C*D1**2*fd**2*r*s - 252*C*D1**2*fd**2*r + 324*C*D1**2*fd**2*s**2 - 384*C*D1**2*fd**2*s - 72*C*D1*Dd*f**2*r**2 - 816*C*D1*Dd*f**2*r*s + 240*C*D1*Dd*f**2*r - 744*C*D1*Dd*f**2*s**2 + 576*C*D1*Dd*f**2*s - 204*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*r**2 + 3072*C*D1*Dd*f*fd*r*s - 1512*C*D1*Dd*f*fd*r + 2592*C*D1*Dd*f*fd*s**2 - 2568*C*D1*Dd*f*fd*s + 636*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*r**2 + 768*C*D1*Ddd*f**2*r*s - 252*C*D1*Ddd*f**2*r + 648*C*D1*Ddd*f**2*s**2 - 516*C*D1*Ddd*f**2*s + 192*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*r**2 + 2304*C*Dd**2*f**2*r*s - 756*C*Dd**2*f**2*r + 1944*C*Dd**2*f**2*s**2 - 1548*C*Dd**2*f**2*s + 192*C*Dd**2*f**2 - 36*D1**2*bdd1*f*(2*C - 3)*(2*s - 1)*(r + s - 1) + 108*D1**2*f*fd*r**2 + 452*D1**2*f*fd*r*s - 346*D1**2*f*fd*r + 344*D1**2*f*fd*s**2 - 464*D1**2*f*fd*s + 292*D1**2*f*fd - 150*D1**2*f*fdd*r**2 - 436*D1**2*f*fdd*r*s + 308*D1**2*f*fdd*r - 286*D1**2*f*fdd*s**2 + 376*D1**2*f*fdd*s - 233*D1**2*f*fdd - 150*D1**2*fd**2*r**2 - 436*D1**2*fd**2*r*s + 308*D1**2*fd**2*r - 286*D1**2*fd**2*s**2 + 376*D1**2*fd**2*s + 216*D1*Dd*f**2*r**2 + 904*D1*Dd*f**2*r*s - 334*D1*Dd*f**2*r + 688*D1*Dd*f**2*s**2 - 570*D1*Dd*f**2*s + 226*D1*Dd*f**2 - 1200*D1*Dd*f*fd*r**2 - 3488*D1*Dd*f*fd*r*s + 1968*D1*Dd*f*fd*r - 2288*D1*Dd*f*fd*s**2 + 2512*D1*Dd*f*fd*s - 684*D1*Dd*f*fd - 300*D1*Ddd*f**2*r**2 - 872*D1*Ddd*f**2*r*s + 368*D1*Ddd*f**2*r - 572*D1*Ddd*f**2*s**2 + 504*D1*Ddd*f**2*s - 218*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(44*C - 73)*(2*s - 1)*(r + s - 1) - fd*(36*C - 54)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(108 - 72*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 900*Dd**2*f**2*r**2 - 2616*Dd**2*f**2*r*s + 1104*Dd**2*f**2*r - 1716*Dd**2*f**2*s**2 + 1512*Dd**2*f**2*s - 218*Dd**2*f**2) + f*(-1188*D1**2*bd1**2*(2*C - 3)*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(6*C*(5*r + 27*s + 5) - 75*r - 143*s - 15) - 5*D1**2*(-2*C*fd**2*(555*r**2 + 6*r*(709*s - 298) + 3699*s**2 - 3884*s + 709) + f*fd*(C*(417*r**2 + 6*r*(791*s - 310) + 4329*s**2 - 4468*s + 1582) - 1200*r**2 - 6057*r*s + 2819*r - 4857*s**2 + 5257*s - 2019) + f*fdd*(-C*(555*r**2 + 6*r*(709*s - 298) + 3699*s**2 - 3884*s + 1418) + 1392*r**2 + 8*r*(657*s - 335) + 3864*s**2 - 4328*s + 1752) + 8*fd**2*(348*r**2 + 2*r*(657*s - 335) + 966*s**2 - 1082*s + 219)) - 66*D1*bd1*(D1*(f*(r + s - 1)*(3*C*(3*r + 31*s + 9) - 27*r - 86*s - 33) + fd*(-6*C*(10*r**2 + 64*r*s - 21*r + 54*s**2 - 54*s + 16) + 150*r**2 + 436*r*s - 214*r + 286*s**2 - 316*s + 109)) + 2*Dd*f*(-3*C*(20*r**2 + 128*r*s - 21*r + 108*s**2 - 87*s + 11) + 150*r**2 + 436*r*s - 152*r + 286*s**2 - 254*s + 47)) - 5*D1*f*(-4*C*Dd*fd*(1110*r**2 + r*(8508*s - 3129) + 7398*s**2 - 6797*s + 1418) - 2*C*Ddd*f*(370*r**2 + r*(2836*s - 894) + 2466*s**2 - 1942*s + 709) + Dd*f*(2*C*(278*r**2 + 3164*r*s - 930*r + 2886*s**2 - 2234*s + 791) - 1600*r**2 - 8076*r*s + 2819*r - 6476*s**2 + 5257*s - 2019) + 8*Dd*fd*(1392*r**2 + r*(5256*s - 2345) + 3864*s**2 - 3787*s + 876) + 8*Ddd*f*(232*r**2 + r*(876*s - 335) + 644*s**2 - 541*s + 219)) + 10*Dd**2*f**2*(C*(1110*r**2 + 8508*r*s - 2682*r + 7398*s**2 - 5826*s + 709) - 2784*r**2 - 10512*r*s + 4020*r - 7728*s**2 + 6492*s - 876)))/(693*d**2*k3**4) - D1**2*Pk1*Pk2*ct**4*k1**2*st**2*(48*C - 128)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(50*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2**2*k3**2) - 8*D1**2*Pk1*Pk2*ct**4*k1**2*(396*b1**2*(C - 2)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(-140*C*D1**2*f*fd*s**2 + 180*C*D1**2*f*fd*s - 90*C*D1**2*f*fd + 100*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 100*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 280*C*D1*Dd*f**2*s**2 + 140*C*D1*Dd*f**2*s - 70*C*D1*Dd*f**2 + 800*C*D1*Dd*f*fd*s**2 - 680*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*s**2 - 100*C*D1*Ddd*f**2*s + 50*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*s**2 - 300*C*Dd**2*f**2*s - 12*D1**2*bdd1*f*(C - 2)*(2*s**2 - 2*s + 1) + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 208*D1**2*f*fd*s**2 - 288*D1**2*f*fd*s + 144*D1**2*f*fd - 34*D1**2*f*fdd*r*s + 17*D1**2*f*fdd*r - 164*D1**2*f*fdd*s**2 + 204*D1**2*f*fdd*s - 102*D1**2*f*fdd - 34*D1**2*fd**2*r*s + 17*D1**2*fd**2*r - 164*D1**2*fd**2*s**2 + 204*D1**2*fd**2*s + 88*D1*Dd*f**2*r*s - 22*D1*Dd*f**2*r + 416*D1*Dd*f**2*s**2 - 230*D1*Dd*f**2*s + 104*D1*Dd*f**2 - 272*D1*Dd*f*fd*r*s + 102*D1*Dd*f*fd*r - 1312*D1*Dd*f*fd*s**2 + 1178*D1*Dd*f*fd*s - 221*D1*Dd*f*fd - 68*D1*Ddd*f**2*r*s + 17*D1*Ddd*f**2*r - 328*D1*Ddd*f**2*s**2 + 181*D1*Ddd*f**2*s - 82*D1*Ddd*f**2 + 24*D1*bd1*(C - 2)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 204*Dd**2*f**2*r*s + 51*Dd**2*f**2*r - 984*Dd**2*f**2*s**2 + 543*Dd**2*f**2*s - 17*Dd**2*f**2) - f*(792*D1**2*bd1**2*s*(C - 2)*(s - 1) + 33*D1**2*bdd1*f*(-10*C*(5*s**2 + 2*s - 1) + 82*s**2 + s*(17*r + 23) - 20) + 5*D1**2*(f*(501*C*fd*(3*s**2 - 2*s + 1) - 333*C*fdd*(3*s**2 - 2*s + 1) - 2*fd*(71*r*(3*s - 1) + 1197*s**2 - 869*s + 399) + 4*fdd*(26*r*(3*s - 1) + 423*s**2 - 308*s + 141)) + 2*fd**2*(104*r*(3*s - 1) + s**2*(1692 - 999*C) + s*(666*C - 1232) + 52)) + 33*D1*bd1*(D1*(2*f*(5*C*(7*s**2 + 4*s - 2) - 52*s**2 - s*(11*r + 29) + 20) + fd*(17*r*(4*s - 1) - s**2*(200*C - 328) + s*(80*C - 158) + 17)) + Dd*f*(20*C*(-20*s**2 + s + 1) + 17*r*(8*s - 1) + 656*s**2 - 89*s - 23)) + 5*D1*f*(-333*C*Ddd*f*(4*s**2 - 2*s + 1) + Dd*f*(501*C*(4*s**2 - 2*s + 1) - 142*r*(4*s - 1) - 3192*s**2 + 1738*s - 798) + 2*Dd*fd*(-333*C*(12*s**2 - 7*s + 1) + 52*r*(24*s - 7) + 6768*s**2 - 4312*s + 668) + 4*Ddd*f*(26*r*(4*s - 1) + 564*s**2 - 308*s + 141)) + 10*Dd**2*f**2*(156*r*(4*s - 1) + s**2*(3384 - 1998*C) + s*(999*C - 1848) + 52)))/(693*d**2*k2**2*k3**2) - 8*D1**2*Pk1*Pk2*ct**4*k2**4*st**2*(198*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 33*b1*(-48*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 18*C*D1**2*f*fdd*r**2 + 36*C*D1**2*f*fdd*r*s - 18*C*D1**2*f*fdd*r + 18*C*D1**2*f*fdd*s**2 - 18*C*D1**2*f*fdd*s + 9*C*D1**2*f*fdd + 18*C*D1**2*fd**2*r**2 + 36*C*D1**2*fd**2*r*s - 18*C*D1**2*fd**2*r + 18*C*D1**2*fd**2*s**2 - 18*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 144*C*D1*Dd*f*fd*r**2 + 288*C*D1*Dd*f*fd*r*s - 144*C*D1*Dd*f*fd*r + 144*C*D1*Dd*f*fd*s**2 - 144*C*D1*Dd*f*fd*s + 36*C*D1*Dd*f*fd + 36*C*D1*Ddd*f**2*r**2 + 72*C*D1*Ddd*f**2*r*s - 36*C*D1*Ddd*f**2*r + 36*C*D1*Ddd*f**2*s**2 - 36*C*D1*Ddd*f**2*s + 18*C*D1*Ddd*f**2 + 108*C*Dd**2*f**2*r**2 + 216*C*Dd**2*f**2*r*s - 108*C*Dd**2*f**2*r + 108*C*Dd**2*f**2*s**2 - 108*C*Dd**2*f**2*s + 18*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(C - 1)*(r + s - 1)**2 - 80*D1**2*f*fd*r**2 - 160*D1**2*f*fd*r*s + 80*D1**2*f*fd*r - 80*D1**2*f*fd*s**2 + 80*D1**2*f*fd*s - 40*D1**2*f*fd + 52*D1**2*f*fdd*r**2 + 104*D1**2*f*fdd*r*s - 52*D1**2*f*fdd*r + 52*D1**2*f*fdd*s**2 - 52*D1**2*f*fdd*s + 26*D1**2*f*fdd + 52*D1**2*fd**2*r**2 + 104*D1**2*fd**2*r*s - 52*D1**2*fd**2*r + 52*D1**2*fd**2*s**2 - 52*D1**2*fd**2*s - 160*D1*Dd*f**2*r**2 - 320*D1*Dd*f**2*r*s + 160*D1*Dd*f**2*r - 160*D1*Dd*f**2*s**2 + 160*D1*Dd*f**2*s - 80*D1*Dd*f**2 + 416*D1*Dd*f*fd*r**2 + 832*D1*Dd*f*fd*r*s - 416*D1*Dd*f*fd*r + 416*D1*Dd*f*fd*s**2 - 416*D1*Dd*f*fd*s + 104*D1*Dd*f*fd + 104*D1*Ddd*f**2*r**2 + 208*D1*Ddd*f**2*r*s - 104*D1*Ddd*f**2*r + 104*D1*Ddd*f**2*s**2 - 104*D1*Ddd*f**2*s + 52*D1*Ddd*f**2 + 24*D1*bd1*(C - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) + 312*Dd**2*f**2*r**2 + 624*Dd**2*f**2*r*s - 312*Dd**2*f**2*r + 312*Dd**2*f**2*s**2 - 312*Dd**2*f**2*s + 52*Dd**2*f**2) + f*(-2844*C*D1**2*f*fd*r**2 - 5688*C*D1**2*f*fd*r*s + 3792*C*D1**2*f*fd*r - 2844*C*D1**2*f*fd*s**2 + 3792*C*D1**2*f*fd*s - 1896*C*D1**2*f*fd + 1125*C*D1**2*f*fdd*r**2 + 2250*C*D1**2*f*fdd*r*s - 1500*C*D1**2*f*fdd*r + 1125*C*D1**2*f*fdd*s**2 - 1500*C*D1**2*f*fdd*s + 750*C*D1**2*f*fdd + 2250*C*D1**2*fd**2*r**2 + 4500*C*D1**2*fd**2*r*s - 3000*C*D1**2*fd**2*r + 2250*C*D1**2*fd**2*s**2 - 3000*C*D1**2*fd**2*s + 750*C*D1**2*fd**2 - 3792*C*D1*Dd*f**2*r**2 - 7584*C*D1*Dd*f**2*r*s + 3792*C*D1*Dd*f**2*r - 3792*C*D1*Dd*f**2*s**2 + 3792*C*D1*Dd*f**2*s - 1896*C*D1*Dd*f**2 + 9000*C*D1*Dd*f*fd*r**2 + 18000*C*D1*Dd*f*fd*r*s - 10500*C*D1*Dd*f*fd*r + 9000*C*D1*Dd*f*fd*s**2 - 10500*C*D1*Dd*f*fd*s + 3000*C*D1*Dd*f*fd + 1500*C*D1*Ddd*f**2*r**2 + 3000*C*D1*Ddd*f**2*r*s - 1500*C*D1*Ddd*f**2*r + 1500*C*D1*Ddd*f**2*s**2 - 1500*C*D1*Ddd*f**2*s + 750*C*D1*Ddd*f**2 + 4500*C*Dd**2*f**2*r**2 + 9000*C*Dd**2*f**2*r*s - 4500*C*Dd**2*f**2*r + 4500*C*Dd**2*f**2*s**2 - 4500*C*Dd**2*f**2*s + 750*C*Dd**2*f**2 - 396*D1**2*bd1**2*(C - 1)*(r + s - 1)**2 + 33*D1**2*bdd1*f*(9*C + 26)*(r + s - 1)**2 - 1812*D1**2*f*fd*r**2 - 3624*D1**2*f*fd*r*s + 2416*D1**2*f*fd*r - 1812*D1**2*f*fd*s**2 + 2416*D1**2*f*fd*s - 1208*D1**2*f*fd + 1500*D1**2*f*fdd*r**2 + 3000*D1**2*f*fdd*r*s - 2000*D1**2*f*fdd*r + 1500*D1**2*f*fdd*s**2 - 2000*D1**2*f*fdd*s + 1000*D1**2*f*fdd + 3000*D1**2*fd**2*r**2 + 6000*D1**2*fd**2*r*s - 4000*D1**2*fd**2*r + 3000*D1**2*fd**2*s**2 - 4000*D1**2*fd**2*s + 1000*D1**2*fd**2 - 2416*D1*Dd*f**2*r**2 - 4832*D1*Dd*f**2*r*s + 2416*D1*Dd*f**2*r - 2416*D1*Dd*f**2*s**2 + 2416*D1*Dd*f**2*s - 1208*D1*Dd*f**2 + 12000*D1*Dd*f*fd*r**2 + 24000*D1*Dd*f*fd*r*s - 14000*D1*Dd*f*fd*r + 12000*D1*Dd*f*fd*s**2 - 14000*D1*Dd*f*fd*s + 4000*D1*Dd*f*fd + 2000*D1*Ddd*f**2*r**2 + 4000*D1*Ddd*f**2*r*s - 2000*D1*Ddd*f**2*r + 2000*D1*Ddd*f**2*s**2 - 2000*D1*Ddd*f**2*s + 1000*D1*Ddd*f**2 - 66*D1*bd1*(r + s - 1)*(D1*f*(12*C + 20)*(r + s - 1) - D1*fd*(9*C + 26)*(2*r + 2*s - 1) - Dd*f*(18*C + 52)*(2*r + 2*s - 1)) + 6000*Dd**2*f**2*r**2 + 12000*Dd**2*f**2*r*s - 6000*Dd**2*f**2*r + 6000*Dd**2*f**2*s**2 - 6000*Dd**2*f**2*s + 1000*Dd**2*f**2))/(693*d**2*k3**6) + 16*D1**2*Pk1*Pk2*ct**4*k2**4*(D1*f*(-12*D1*bd1**2*(C + 2)*(r + s - 1)**2 + 2*bd1*(r + s - 1)*(D1*f*(5*C + 1)*(r + s - 1) - D1*fd*(5*C + 10)*(2*r + 2*s - 1) - Dd*f*(10*C + 20)*(2*r + 2*s - 1)) - 5*f*(D1*bdd1*(C + 2)*(r + s - 1)**2 + (C + 1)*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))) + b1**2*(D1**2*(r + s)**2*(fd*(19*C + 10) - fdd*(6*C + 12)) + 2*D1*(Dd*(f*(19*C + 10)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(12*C + 24)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(-6*C - 12)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(12*C + 24)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(20*C*D1**2*f*fd*r**2 + 40*C*D1**2*f*fd*r*s - 20*C*D1**2*f*fd*r + 20*C*D1**2*f*fd*s**2 - 20*C*D1**2*f*fd*s + 10*C*D1**2*f*fd - 10*C*D1**2*f*fdd*r**2 - 20*C*D1**2*f*fdd*r*s + 10*C*D1**2*f*fdd*r - 10*C*D1**2*f*fdd*s**2 + 10*C*D1**2*f*fdd*s - 5*C*D1**2*f*fdd - 10*C*D1**2*fd**2*r**2 - 20*C*D1**2*fd**2*r*s + 10*C*D1**2*fd**2*r - 10*C*D1**2*fd**2*s**2 + 10*C*D1**2*fd**2*s + 40*C*D1*Dd*f**2*r**2 + 80*C*D1*Dd*f**2*r*s - 40*C*D1*Dd*f**2*r + 40*C*D1*Dd*f**2*s**2 - 40*C*D1*Dd*f**2*s + 20*C*D1*Dd*f**2 - 80*C*D1*Dd*f*fd*r**2 - 160*C*D1*Dd*f*fd*r*s + 80*C*D1*Dd*f*fd*r - 80*C*D1*Dd*f*fd*s**2 + 80*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd - 20*C*D1*Ddd*f**2*r**2 - 40*C*D1*Ddd*f**2*r*s + 20*C*D1*Ddd*f**2*r - 20*C*D1*Ddd*f**2*s**2 + 20*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 60*C*Dd**2*f**2*r**2 - 120*C*Dd**2*f**2*r*s + 60*C*Dd**2*f**2*r - 60*C*Dd**2*f**2*s**2 + 60*C*Dd**2*f**2*s - 10*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(C + 2)*(r + s - 1)**2 + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 20*D1**2*f*fdd*r**2 - 40*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*r - 20*D1**2*f*fdd*s**2 + 20*D1**2*f*fdd*s - 10*D1**2*f*fdd - 20*D1**2*fd**2*r**2 - 40*D1**2*fd**2*r*s + 20*D1**2*fd**2*r - 20*D1**2*fd**2*s**2 + 20*D1**2*fd**2*s + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 - 320*D1*Dd*f*fd*r*s + 160*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 160*D1*Dd*f*fd*s - 40*D1*Dd*f*fd - 40*D1*Ddd*f**2*r**2 - 80*D1*Ddd*f**2*r*s + 40*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 40*D1*Ddd*f**2*s - 20*D1*Ddd*f**2 + 2*D1*bd1*(r + s - 1)*(D1*f*(19*C + 10)*(r + s - 1) - D1*fd*(12*C + 24)*(r + s) - Dd*f*(24*C + 48)*(2*r + 2*s - 1)) - 120*Dd**2*f**2*r**2 - 240*Dd**2*f**2*r*s + 120*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 120*Dd**2*f**2*s - 20*Dd**2*f**2))/(21*d**2*k3**6) - 2*D1**2*Pk1*Pk2*ct**4*k2**2*st**2*(792*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 33*b1*(-276*C*D1**2*f*fd*r**2 - 712*C*D1**2*f*fd*r*s + 404*C*D1**2*f*fd*r - 436*C*D1**2*f*fd*s**2 + 484*C*D1**2*f*fd*s - 266*C*D1**2*f*fd + 156*C*D1**2*f*fdd*r**2 + 416*C*D1**2*f*fdd*r*s - 232*C*D1**2*f*fdd*r + 260*C*D1**2*f*fdd*s**2 - 284*C*D1**2*f*fdd*s + 154*C*D1**2*f*fdd + 156*C*D1**2*fd**2*r**2 + 416*C*D1**2*fd**2*r*s - 232*C*D1**2*fd**2*r + 260*C*D1**2*fd**2*s**2 - 284*C*D1**2*fd**2*s - 552*C*D1*Dd*f**2*r**2 - 1424*C*D1*Dd*f**2*r*s + 632*C*D1*Dd*f**2*r - 872*C*D1*Dd*f**2*s**2 + 792*C*D1*Dd*f**2*s - 356*C*D1*Dd*f**2 + 1248*C*D1*Dd*f*fd*r**2 + 3328*C*D1*Dd*f*fd*r*s - 1656*C*D1*Dd*f*fd*r + 2080*C*D1*Dd*f*fd*s**2 - 2072*C*D1*Dd*f*fd*s + 516*C*D1*Dd*f*fd + 312*C*D1*Ddd*f**2*r**2 + 832*C*D1*Ddd*f**2*r*s - 364*C*D1*Ddd*f**2*r + 520*C*D1*Ddd*f**2*s**2 - 468*C*D1*Ddd*f**2*s + 208*C*D1*Ddd*f**2 + 936*C*Dd**2*f**2*r**2 + 2496*C*Dd**2*f**2*r*s - 1092*C*Dd**2*f**2*r + 1560*C*Dd**2*f**2*s**2 - 1404*C*Dd**2*f**2*s + 208*C*Dd**2*f**2 - 24*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) + 336*D1**2*f*fd*r**2 + 316*D1**2*f*fd*r*s - 206*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 - 28*D1**2*f*fd*s + 38*D1**2*f*fd - 186*D1**2*f*fdd*r**2 - 206*D1**2*f*fdd*r*s + 127*D1**2*f*fdd*r - 20*D1**2*f*fdd*s**2 + 44*D1**2*f*fdd*s - 34*D1**2*f*fdd - 186*D1**2*fd**2*r**2 - 206*D1**2*fd**2*r*s + 127*D1**2*fd**2*r - 20*D1**2*fd**2*s**2 + 44*D1**2*fd**2*s + 672*D1*Dd*f**2*r**2 + 632*D1*Dd*f**2*r*s - 494*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 - 138*D1*Dd*f**2*s + 158*D1*Dd*f**2 - 1488*D1*Dd*f*fd*r**2 - 1648*D1*Dd*f*fd*r*s + 1086*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 422*D1*Dd*f*fd*s - 171*D1*Dd*f*fd - 372*D1*Ddd*f**2*r**2 - 412*D1*Ddd*f**2*r*s + 289*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 123*D1*Ddd*f**2*s - 103*D1*Ddd*f**2 + 24*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 1116*Dd**2*f**2*r**2 - 1236*Dd**2*f**2*r*s + 867*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 369*Dd**2*f**2*s - 103*Dd**2*f**2) - f*(12438*C*D1**2*f*fd*r**2 + 33972*C*D1**2*f*fd*r*s - 19616*C*D1**2*f*fd*r + 21534*C*D1**2*f*fd*s**2 - 25680*C*D1**2*f*fd*s + 11324*C*D1**2*f*fd - 8298*C*D1**2*f*fdd*r**2 - 21144*C*D1**2*f*fdd*r*s + 12580*C*D1**2*f*fdd*r - 12846*C*D1**2*f*fdd*s**2 + 15612*C*D1**2*f*fdd*s - 7048*C*D1**2*f*fdd - 16596*C*D1**2*fd**2*r**2 - 42288*C*D1**2*fd**2*r*s + 25160*C*D1**2*fd**2*r - 25692*C*D1**2*fd**2*s**2 + 31224*C*D1**2*fd**2*s - 7048*C*D1**2*fd**2 + 16584*C*D1*Dd*f**2*r**2 + 45296*C*D1*Dd*f**2*r*s - 19616*C*D1*Dd*f**2*r + 28712*C*D1*Dd*f**2*s**2 - 25680*C*D1*Dd*f**2*s + 11324*C*D1*Dd*f**2 - 66384*C*D1*Dd*f*fd*r**2 - 169152*C*D1*Dd*f*fd*r*s + 88060*C*D1*Dd*f*fd*r - 102768*C*D1*Dd*f*fd*s**2 + 109284*C*D1*Dd*f*fd*s - 28192*C*D1*Dd*f*fd - 11064*C*D1*Ddd*f**2*r**2 - 28192*C*D1*Ddd*f**2*r*s + 12580*C*D1*Ddd*f**2*r - 17128*C*D1*Ddd*f**2*s**2 + 15612*C*D1*Ddd*f**2*s - 7048*C*D1*Ddd*f**2 - 33192*C*Dd**2*f**2*r**2 - 84576*C*Dd**2*f**2*r*s + 37740*C*Dd**2*f**2*r - 51384*C*Dd**2*f**2*s**2 + 46836*C*Dd**2*f**2*s - 7048*C*Dd**2*f**2 + 792*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) - 33*D1**2*bdd1*f*(r + s - 1)*(2*C*(39*r + 65*s - 27) - 93*r - 10*s + 69) - 14856*D1**2*f*fd*r**2 - 19578*D1**2*f*fd*r*s + 16430*D1**2*f*fd*r - 4722*D1**2*f*fd*s**2 + 9674*D1**2*f*fd*s - 6526*D1**2*f*fd + 9903*D1**2*f*fdd*r**2 + 13749*D1**2*f*fdd*r*s - 11185*D1**2*f*fdd*r + 3846*D1**2*f*fdd*s**2 - 7147*D1**2*f*fdd*s + 4583*D1**2*f*fdd + 19806*D1**2*fd**2*r**2 + 27498*D1**2*fd**2*r*s - 22370*D1**2*fd**2*r + 7692*D1**2*fd**2*s**2 - 14294*D1**2*fd**2*s + 4583*D1**2*fd**2 - 19808*D1*Dd*f**2*r**2 - 26104*D1*Dd*f**2*r*s + 16430*D1*Dd*f**2*r - 6296*D1*Dd*f**2*s**2 + 9674*D1*Dd*f**2*s - 6526*D1*Dd*f**2 + 79224*D1*Dd*f*fd*r**2 + 109992*D1*Dd*f*fd*r*s - 78295*D1*Dd*f*fd*r + 30768*D1*Dd*f*fd*s**2 - 50029*D1*Dd*f*fd*s + 18332*D1*Dd*f*fd + 13204*D1*Ddd*f**2*r**2 + 18332*D1*Ddd*f**2*r*s - 11185*D1*Ddd*f**2*r + 5128*D1*Ddd*f**2*s**2 - 7147*D1*Ddd*f**2*s + 4583*D1*Ddd*f**2 + 33*D1*bd1*(D1*(2*f*(r + s - 1)*(C*(69*r + 109*s - 45) - 84*r + 5*s + 60) + fd*(-4*C*(78*r**2 + 4*r*(52*s - 31) + 130*s**2 - 163*s + 52) + 372*r**2 + 412*r*s - 451*r + 40*s**2 - 202*s + 103)) + Dd*f*(-4*C*(156*r**2 + 416*r*s - 223*r + 260*s**2 - 301*s + 79) + 744*r**2 + 824*r*s - 937*r + 80*s**2 - 439*s + 241)) + 39612*Dd**2*f**2*r**2 + 54996*Dd**2*f**2*r*s - 33555*Dd**2*f**2*r + 15384*Dd**2*f**2*s**2 - 21441*Dd**2*f**2*s + 4583*Dd**2*f**2))/(693*d**2*k3**4) + 4*D1**2*Pk1*Pk2*ct**4*k2**2*(11*b1**2*(D1**2*(r + s)*(fd*r*(77*C - 89) + fd*s*(69*C - 69) + fdd*r*(41 - 35*C) - fdd*s*(59*C - 59)) + 2*D1*(Dd*(f*(C*(154*r**2 + 292*r*s - 150*r + 138*s**2 - 142*s + 73) - 178*r**2 - 316*r*s + 168*r - 138*s**2 + 148*s - 79) + fd*(r**2*(164 - 140*C) + r*(-376*C*s + 82*C + 400*s - 91) + s*(-236*C*s + 106*C + 236*s - 109))) + Ddd*f*(-C*(70*r**2 + 188*r*s - 82*r + 118*s**2 - 106*s + 47) + 82*r**2 + 200*r*s - 91*r + 118*s**2 - 109*s + 50)) + 2*Dd**2*f*(-C*(210*r**2 + 6*r*(94*s - 41) + 354*s**2 - 318*s + 47) + 246*r**2 + 600*r*s - 273*r + 354*s**2 - 327*s + 50)) + 11*b1*(48*C*D1**2*f*fd*r**2 + 32*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 - 16*C*D1**2*f*fd*s + 24*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 - 16*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*s**2 - 16*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r**2 - 16*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*s**2 - 16*C*D1**2*fd**2*s + 96*C*D1*Dd*f**2*r**2 + 64*C*D1*Dd*f**2*r*s - 64*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 16*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 - 128*C*D1*Dd*f*fd*r*s + 64*C*D1*Dd*f*fd*r + 64*C*D1*Dd*f*fd*s**2 - 64*C*D1*Dd*f*fd*s + 16*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r**2 - 32*C*D1*Ddd*f**2*r*s + 32*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s**2 - 8*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r**2 - 96*C*Dd**2*f**2*r*s + 96*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s**2 - 8*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(r + s - 1)*(C*(35*r + 59*s - 47) - 41*r - 59*s + 50) - 124*D1**2*f*fd*r**2 - 420*D1**2*f*fd*r*s + 256*D1**2*f*fd*r - 296*D1**2*f*fd*s**2 + 342*D1**2*f*fd*s - 194*D1**2*f*fd + 128*D1**2*f*fdd*r**2 + 390*D1**2*f*fdd*r*s - 194*D1**2*f*fdd*r + 262*D1**2*f*fdd*s**2 - 261*D1**2*f*fdd*s + 130*D1**2*f*fdd + 128*D1**2*fd**2*r**2 + 390*D1**2*fd**2*r*s - 194*D1**2*fd**2*r + 262*D1**2*fd**2*s**2 - 261*D1**2*fd**2*s - 248*D1*Dd*f**2*r**2 - 840*D1*Dd*f**2*r*s + 334*D1*Dd*f**2*r - 592*D1*Dd*f**2*s**2 + 506*D1*Dd*f**2*s - 210*D1*Dd*f**2 + 1024*D1*Dd*f*fd*r**2 + 3120*D1*Dd*f*fd*r*s - 1422*D1*Dd*f*fd*r + 2096*D1*Dd*f*fd*s**2 - 1958*D1*Dd*f*fd*s + 455*D1*Dd*f*fd + 256*D1*Ddd*f**2*r**2 + 780*D1*Ddd*f**2*r*s - 323*D1*Ddd*f**2*r + 524*D1*Ddd*f**2*s**2 - 457*D1*Ddd*f**2*s + 195*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(r + s - 1)*(C*(77*r + 69*s - 73) - 89*r - 69*s + 79) + fd*(r**2*(82 - 70*C) + r*(-188*C*s + 82*C + 200*s - 91) + s*(-118*C*s + 106*C + 118*s - 109))) + 2*Dd*f*(-2*C*(70*r**2 + 188*r*s - 123*r + 118*s**2 - 159*s + 47) + 164*r**2 + 400*r*s - 273*r + 236*s**2 - 327*s + 100)) + 768*Dd**2*f**2*r**2 + 2340*Dd**2*f**2*r*s - 969*Dd**2*f**2*r + 1572*Dd**2*f**2*s**2 - 1371*Dd**2*f**2*s + 195*Dd**2*f**2) + f*(-22*D1**2*bd1**2*(r + s - 1)*(C*(35*r + 59*s - 47) - 41*r - 59*s + 50) - 11*D1**2*bdd1*f*(r + s - 1)*(4*C*(3*r - s - 5) - 64*r - 131*s + 65) - 5*D1**2*(f*(fd*(C*(483*r**2 + 846*r*s - 604*r + 363*s**2 - 524*s + 282) - 174*r**2 + 324*r*s + 8*r + 498*s**2 - 440*s + 108) - fdd*(3*C*(75*r**2 + 6*r*(29*s - 18) + 99*s**2 - 124*s + 58) + 111*r**2 + 558*r*s - 260*r + 447*s**2 - 484*s + 186)) - 2*fd**2*(3*C*(75*r**2 + 6*r*(29*s - 18) + 99*s**2 - 124*s + 29) + 111*r**2 + 558*r*s - 260*r + 447*s**2 - 484*s + 93)) + 11*D1*bd1*(D1*(2*f*(r + s - 1)*(4*C*(3*r - s + 1) - 31*r - 74*s + 8) + fd*(-8*C*(6*r**2 + 4*r*(s - 2) - 2*s**2 - 2*s + 1) + 256*r**2 + 780*r*s - 452*r + 524*s**2 - 653*s + 195)) + Dd*f*(-16*C*(6*r**2 + 4*r*s - 10*r - 2*s**2 - 4*s + 3) + 512*r**2 + 1560*r*s - 839*r + 1048*s**2 - 1241*s + 325)) - 10*D1*f*(Dd*(f*(C*(322*r**2 + 564*r*s - 302*r + 242*s**2 - 262*s + 141) - 116*r**2 + 216*r*s + 4*r + 332*s**2 - 220*s + 54) - 2*fd*(3*C*(150*r**2 + 348*r*s - 189*r + 198*s**2 - 217*s + 58) + 222*r**2 + 1116*r*s - 455*r + 894*s**2 - 847*s + 186)) - Ddd*f*(3*C*(50*r**2 + 116*r*s - 54*r + 66*s**2 - 62*s + 29) + 74*r**2 + 372*r*s - 130*r + 298*s**2 - 242*s + 93)) + 30*Dd**2*f**2*(C*(150*r**2 + 6*r*(58*s - 27) + 198*s**2 - 186*s + 29) + 74*r**2 + 372*r*s - 130*r + 298*s**2 - 242*s + 31)))/(231*d**2*k3**4) + 4*D1**2*Pk1*Pk2*ct**4*st**2*(D1**2*(25*f**3*(196*fd*(4*s**2 - 2*s + 1) - 98*fdd*(4*s**2 - 2*s + 1) + s**2*(390*bd1 - 195*bdd1)) - 6*f**2*s*(715*bd1**2*s + 13*bd1*(125*fd*(3*s - 1) + s*(22*K - 22)) + 2450*fd**2*(2*s - 1) - s*(143*bdd1*(K - 1) + 572*gd2 - 286*gdd2)) + 1716*f*(fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - fdd*g2*(2*s**2 - 2*s + 1) + s**2*(bd1**2*(K - 1) + 2*bd1*(g2 - gd2) - bdd1*g2)) - 3432*fd*g2*s*(bd1 + fd)*(s - 1)) + 2*D1*f*(Dd*(2450*f**3*(4*s**2 - 2*s + 1) - 25*f**2*(4*s - 1)*(195*bd1*s + 98*fd*(4*s - 1)) + 858*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 1716*g2*(4*s - 1)*(bd1*s + fd*(2*s - 1))) - Ddd*f*(1225*f**2 + 858*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(1225*f**2 + 858*g2)*(2*s - 1) + 429*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) - 4*fd*(K - 1)*(s - 1)**2 + 2*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) - 2*f*(K - 1)*(4*s**2 - 2*s + 1) + 2*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-2*K + 5*f + 2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-2*K + 5*f + 2)) + 39*b1*(D1**2*(5*f**2*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(44*bd1 - 22*bdd1)) + f*(-250*fd**2*s*(3*s - 2) - 44*fd*(K*(2*s**2 - 2*s + 1) + s**2*(10*bd1 - 2) + s*(2 - 5*bd1) - 1) + 22*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(44*K*bdd1 - 88*bd1*(K - 1) - 44*bdd1 + 88*gd2 - 44*gdd2)) + (44*s - 44)*(fd**2*s*(K - 1) + 2*fd*g2*(s - 1) - 2*fd*s*(-K*bd1 + bd1 + gd2) - fdd*g2*(s - 1))) + D1*(2*Dd*(125*f**3*(4*s**2 - 2*s + 1) + f**2*(-22*K*(4*s**2 - 2*s + 1) - 125*fd*(12*s**2 - 7*s + 1) - 22*s**2*(20*bd1 - 4) - 22*s*(2 - 5*bd1) + 22) + 22*f*(fd*(K - 1)*(8*s**2 - 6*s + 1) + 2*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(2*K*bd1 - 2*bd1 - 2*gd2)) - 44*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(125*f**2 - 22*f*(K - 1) + 44*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(125*f**2 - 22*f*(K - 1) + 44*g2)))/(1001*d**2*k2**2) + 4*D1**2*Pk1*Pk2*ct**4*(-50622*D1**2*K*bd1**2*f*s**2 - 10296*D1**2*K*bd1**2*f*s + 38610*D1**2*K*bd1*f**2*s**2 - 102960*D1**2*K*bd1*f*fd*s**2 + 51480*D1**2*K*bd1*f*fd*s - 25740*D1**2*K*bdd1*f**2*s**2 + 10296*D1**2*bd1**2*f**2*r*s + 12012*D1**2*bd1**2*f**2*s**2 + 20592*D1**2*bd1**2*f**2*s + 10296*D1**2*bd1**2*f*r*s + 30030*D1**2*bd1**2*f*s**2 + 5148*D1**2*bd1**2*f*s - 24024*D1**2*bd1**2*g2*s**2 + 24024*D1**2*bd1**2*g2*s - 10296*D1**2*bd1*bd2*f*s**2 - 13780*D1**2*bd1*f**3*r*s - 61815*D1**2*bd1*f**3*s**2 - 22230*D1**2*bd1*f**3*s + 14560*D1**2*bd1*f**3 + 67080*D1**2*bd1*f**2*fd*r*s - 11180*D1**2*bd1*f**2*fd*r + 281970*D1**2*bd1*f**2*fd*s**2 - 87230*D1**2*bd1*f**2*fd*s + 5590*D1**2*bd1*f**2*fd - 12012*D1**2*bd1*f**2*r*s - 21450*D1**2*bd1*f**2*s**2 + 24024*D1**2*bd1*f*fd*r*s - 6006*D1**2*bd1*f*fd*r + 68640*D1**2*bd1*f*fd*s**2 - 40326*D1**2*bd1*f*fd*s - 71214*D1**2*bd1*f*g2*s**2 - 41184*D1**2*bd1*f*g2*s + 20592*D1**2*bd1*f*g2 + 101244*D1**2*bd1*f*gd2*s**2 + 20592*D1**2*bd1*f*gd2*s + 101244*D1**2*bd1*fd*g2*s**2 - 101244*D1**2*bd1*fd*g2*s + 8580*D1**2*bd2*f**2*s**2 - 17160*D1**2*bd2*f*fd*s**2 + 8580*D1**2*bd2*f*fd*s + 11180*D1**2*bdd1*f**3*r*s + 46995*D1**2*bdd1*f**3*s**2 + 8970*D1**2*bdd1*f**3*s - 7280*D1**2*bdd1*f**3 + 6006*D1**2*bdd1*f**2*r*s + 17160*D1**2*bdd1*f**2*s**2 + 50622*D1**2*bdd1*f*g2*s**2 + 20592*D1**2*bdd1*f*g2*s - 10296*D1**2*bdd1*f*g2 - 4290*D1**2*bdd2*f**2*s**2 - 30240*D1**2*f**3*fd*r*s + 7560*D1**2*f**3*fd*r - 189280*D1**2*f**3*fd*s**2 + 102200*D1**2*f**3*fd*s - 47320*D1**2*f**3*fd + 22400*D1**2*f**3*fdd*r*s - 5600*D1**2*f**3*fdd*r + 131040*D1**2*f**3*fdd*s**2 - 71120*D1**2*f**3*fdd*s + 32760*D1**2*f**3*fdd + 67200*D1**2*f**2*fd**2*r*s - 16800*D1**2*f**2*fd**2*r + 393120*D1**2*f**2*fd**2*s**2 - 213360*D1**2*f**2*fd**2*s + 5600*D1**2*f**2*fd**2 - 77220*D1**2*f**2*gd2*s**2 + 51480*D1**2*f**2*gdd2*s**2 - 154440*D1**2*f*fd*g2*s**2 + 154440*D1**2*f*fd*g2*s - 77220*D1**2*f*fd*g2 + 205920*D1**2*f*fd*gd2*s**2 - 102960*D1**2*f*fd*gd2*s + 102960*D1**2*f*fdd*g2*s**2 - 102960*D1**2*f*fdd*g2*s + 51480*D1**2*f*fdd*g2 + 102960*D1**2*fd**2*g2*s**2 - 102960*D1**2*fd**2*g2*s - 205920*D1*Dd*K*bd1*f**2*s**2 + 51480*D1*Dd*K*bd1*f**2*s + 89440*D1*Dd*bd1*f**3*r*s - 11180*D1*Dd*bd1*f**3*r + 375960*D1*Dd*bd1*f**3*s**2 - 69290*D1*Dd*bd1*f**3*s - 8970*D1*Dd*bd1*f**3 + 48048*D1*Dd*bd1*f**2*r*s - 6006*D1*Dd*bd1*f**2*r + 137280*D1*Dd*bd1*f**2*s**2 - 40326*D1*Dd*bd1*f**2*s + 404976*D1*Dd*bd1*f*g2*s**2 - 18876*D1*Dd*bd1*f*g2*s - 20592*D1*Dd*bd1*f*g2 - 34320*D1*Dd*bd2*f**2*s**2 + 8580*D1*Dd*bd2*f**2*s - 30240*D1*Dd*f**4*r*s + 7560*D1*Dd*f**4*r - 189280*D1*Dd*f**4*s**2 + 102200*D1*Dd*f**4*s - 47320*D1*Dd*f**4 + 179200*D1*Dd*f**3*fd*r*s - 44800*D1*Dd*f**3*fd*r + 1048320*D1*Dd*f**3*fd*s**2 - 568960*D1*Dd*f**3*fd*s + 76720*D1*Dd*f**3*fd - 308880*D1*Dd*f**2*g2*s**2 + 154440*D1*Dd*f**2*g2*s - 77220*D1*Dd*f**2*g2 + 411840*D1*Dd*f**2*gd2*s**2 - 102960*D1*Dd*f**2*gd2*s + 823680*D1*Dd*f*fd*g2*s**2 - 617760*D1*Dd*f*fd*g2*s + 102960*D1*Dd*f*fd*g2 + 22400*D1*Ddd*f**4*r*s - 5600*D1*Ddd*f**4*r + 131040*D1*Ddd*f**4*s**2 - 71120*D1*Ddd*f**4*s + 32760*D1*Ddd*f**4 + 205920*D1*Ddd*f**2*g2*s**2 - 102960*D1*Ddd*f**2*g2*s + 51480*D1*Ddd*f**2*g2 + 67200*Dd**2*f**4*r*s - 16800*Dd**2*f**4*r + 393120*Dd**2*f**4*s**2 - 213360*Dd**2*f**4*s + 5600*Dd**2*f**4 + 617760*Dd**2*f**2*g2*s**2 - 308880*Dd**2*f**2*g2*s + 858*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-7*K*(4*s**2 - 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s + 28*s**2 - 14*s + 7) - D1*Ddd*(-7*K + 6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-7*K + 6*f + 7)) + 429*b1**2*(83*D1**2*K*fd*s**2 - 214*D1**2*K*fd*s + 107*D1**2*K*fd - 59*D1**2*K*fdd*s**2 + 142*D1**2*K*fdd*s - 71*D1**2*K*fdd - 2*D1**2*bdd1*(-7*K + 6*f + 7)*(3*s**2 - 2*s + 1) - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 + 116*D1**2*f*fd*s - 58*D1**2*f*fd + 24*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 28*D1**2*f*fdd*s**2 - 88*D1**2*f*fdd*s + 44*D1**2*f*fdd + 24*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 28*D1**2*fd**2*s**2 - 88*D1**2*fd**2*s - 24*D1**2*fd*r*s + 24*D1**2*fd*r - 35*D1**2*fd*s**2 + 118*D1**2*fd*s - 59*D1**2*fd + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r + 35*D1**2*fdd*s**2 - 94*D1**2*fdd*s + 47*D1**2*fdd + 56*D1**2*gd2*s**2 - 28*D1**2*gdd2*s**2 + 332*D1*Dd*K*f*s**2 - 166*D1*Dd*K*f*s + 83*D1*Dd*K*f - 472*D1*Dd*K*fd*s**2 + 686*D1*Dd*K*fd*s - 142*D1*Dd*K*fd - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 + 8*D1*Dd*f**2*s + 2*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r + 224*D1*Dd*f*fd*s**2 - 432*D1*Dd*f*fd*s + 100*D1*Dd*f*fd - 96*D1*Dd*f*r*s + 24*D1*Dd*f*r - 140*D1*Dd*f*s**2 + 94*D1*Dd*f*s - 35*D1*Dd*f + 96*D1*Dd*fd*r*s - 60*D1*Dd*fd*r + 280*D1*Dd*fd*s**2 - 458*D1*Dd*fd*s + 106*D1*Dd*fd + 224*D1*Dd*g2*s**2 - 112*D1*Dd*g2*s + 56*D1*Dd*g2 - 224*D1*Dd*gd2*s**2 + 56*D1*Dd*gd2*s - 236*D1*Ddd*K*f*s**2 + 118*D1*Ddd*K*f*s - 59*D1*Ddd*K*f + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 56*D1*Ddd*f**2*s**2 - 40*D1*Ddd*f**2*s + 14*D1*Ddd*f**2 + 48*D1*Ddd*f*r*s - 12*D1*Ddd*f*r + 140*D1*Ddd*f*s**2 - 82*D1*Ddd*f*s + 35*D1*Ddd*f - 112*D1*Ddd*g2*s**2 + 56*D1*Ddd*g2*s - 28*D1*Ddd*g2 + 4*D1*bd1*(D1*(-7*K*(3*s**2 - 2*s + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s + 21*s**2 - 14*s + 7) - Dd*(-7*K + 6*f + 7)*(12*s**2 - 7*s + 1)) - 708*Dd**2*K*f*s**2 + 354*Dd**2*K*f*s + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 168*Dd**2*f**2*s**2 - 120*Dd**2*f**2*s + 12*Dd**2*f**2 + 144*Dd**2*f*r*s - 36*Dd**2*f*r + 420*Dd**2*f*s**2 - 246*Dd**2*f*s + 12*Dd**2*f - 336*Dd**2*g2*s**2 + 168*Dd**2*g2*s) - 13*b1*(-5940*D1**2*K*f*fd*s**2 + 5940*D1**2*K*f*fd*s - 2970*D1**2*K*f*fd + 3960*D1**2*K*f*fdd*s**2 - 3960*D1**2*K*f*fdd*s + 1980*D1**2*K*f*fdd + 3960*D1**2*K*fd**2*s**2 - 3960*D1**2*K*fd**2*s - 792*D1**2*b2*fd*s**2 + 1584*D1**2*b2*fd*s - 792*D1**2*b2*fd + 396*D1**2*b2*fdd*s**2 - 792*D1**2*b2*fdd*s + 396*D1**2*b2*fdd + 132*D1**2*bd1**2*s*(3*s - 2)*(-7*K + 6*f + 7) - 792*D1**2*bd2*f*s**2 + 792*D1**2*bd2*fd*s**2 - 792*D1**2*bd2*fd*s - 66*D1**2*bdd1*(f**2*(14*s**2 + s*(12*r + 24) - 15) + f*(K*(-59*s**2 - 12*s + 6) + 12*r*s + 35*s**2 + 6*s - 6) - 14*g2*(2*s**2 - 2*s + 1)) + 396*D1**2*bdd2*f*s**2 + 3180*D1**2*f**2*fd*r*s - 1060*D1**2*f**2*fd*r + 14265*D1**2*f**2*fd*s**2 - 12280*D1**2*f**2*fd*s + 5875*D1**2*f**2*fd - 2580*D1**2*f**2*fdd*r*s + 860*D1**2*f**2*fdd*r - 10845*D1**2*f**2*fdd*s**2 + 8780*D1**2*f**2*fdd*s - 4175*D1**2*f**2*fdd - 5160*D1**2*f*fd**2*r*s + 1720*D1**2*f*fd**2*r - 21690*D1**2*f*fd**2*s**2 + 17560*D1**2*f*fd**2*s - 430*D1**2*f*fd**2 + 1848*D1**2*f*fd*r*s - 924*D1**2*f*fd*r + 3300*D1**2*f*fd*s**2 - 4224*D1**2*f*fd*s + 1650*D1**2*f*fd - 924*D1**2*f*fdd*r*s + 462*D1**2*f*fdd*r - 2640*D1**2*f*fdd*s**2 + 3102*D1**2*f*fdd*s - 1320*D1**2*f*fdd + 5478*D1**2*f*gd2*s**2 - 3894*D1**2*f*gdd2*s**2 - 924*D1**2*fd**2*r*s + 462*D1**2*fd**2*r - 2640*D1**2*fd**2*s**2 + 3102*D1**2*fd**2*s - 462*D1**2*fd**2 + 5478*D1**2*fd*g2*s**2 - 14124*D1**2*fd*g2*s + 7062*D1**2*fd*g2 - 7788*D1**2*fd*gd2*s**2 + 9372*D1**2*fd*gd2*s - 3894*D1**2*fdd*g2*s**2 + 9372*D1**2*fdd*g2*s - 4686*D1**2*fdd*g2 - 11880*D1*Dd*K*f**2*s**2 + 5940*D1*Dd*K*f**2*s - 2970*D1*Dd*K*f**2 + 31680*D1*Dd*K*f*fd*s**2 - 23760*D1*Dd*K*f*fd*s + 3960*D1*Dd*K*f*fd - 3168*D1*Dd*b2*f*s**2 + 1584*D1*Dd*b2*f*s - 792*D1*Dd*b2*f + 3168*D1*Dd*b2*fd*s**2 - 3960*D1*Dd*b2*fd*s + 792*D1*Dd*b2*fd + 3168*D1*Dd*bd2*f*s**2 - 792*D1*Dd*bd2*f*s + 4240*D1*Dd*f**3*r*s - 1060*D1*Dd*f**3*r + 19020*D1*Dd*f**3*s**2 - 10570*D1*Dd*f**3*s + 4755*D1*Dd*f**3 - 20640*D1*Dd*f**2*fd*r*s + 6020*D1*Dd*f**2*fd*r - 86760*D1*Dd*f**2*fd*s**2 + 59390*D1*Dd*f**2*fd*s - 9640*D1*Dd*f**2*fd + 3696*D1*Dd*f**2*r*s - 924*D1*Dd*f**2*r + 6600*D1*Dd*f**2*s**2 - 4224*D1*Dd*f**2*s + 1650*D1*Dd*f**2 - 7392*D1*Dd*f*fd*r*s + 2772*D1*Dd*f*fd*r - 21120*D1*Dd*f*fd*s**2 + 18612*D1*Dd*f*fd*s - 3564*D1*Dd*f*fd + 21912*D1*Dd*f*g2*s**2 - 10956*D1*Dd*f*g2*s + 5478*D1*Dd*f*g2 - 31152*D1*Dd*f*gd2*s**2 + 7788*D1*Dd*f*gd2*s - 31152*D1*Dd*fd*g2*s**2 + 45276*D1*Dd*fd*g2*s - 9372*D1*Dd*fd*g2 + 7920*D1*Ddd*K*f**2*s**2 - 3960*D1*Ddd*K*f**2*s + 1980*D1*Ddd*K*f**2 + 1584*D1*Ddd*b2*f*s**2 - 792*D1*Ddd*b2*f*s + 396*D1*Ddd*b2*f - 3440*D1*Ddd*f**3*r*s + 860*D1*Ddd*f**3*r - 14460*D1*Ddd*f**3*s**2 + 8090*D1*Ddd*f**3*s - 3615*D1*Ddd*f**3 - 1848*D1*Ddd*f**2*r*s + 462*D1*Ddd*f**2*r - 5280*D1*Ddd*f**2*s**2 + 3102*D1*Ddd*f**2*s - 1320*D1*Ddd*f**2 - 15576*D1*Ddd*f*g2*s**2 + 7788*D1*Ddd*f*g2*s - 3894*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(-2*f**2*(s**2 - s*(6*r + 27) + 15) + f*(K*(-83*s**2 - 24*s + 12) - 2*fd*(6*r*(4*s - 1) + 28*s**2 - 20*s + 3) + 24*r*s + 35*s**2 + 12*s - 12) - 2*fd*(6*r*(2*s - 1) + s**2*(35 - 59*K) + s*(65*K - 44) + 3) - 28*g2*(2*s**2 - 2*s + 1) - 28*gd2*s*(1 - 2*s)) - 2*Dd*(2*f**2*(3*r*(8*s - 1) + 28*s**2 + 14*s - 6) + f*(K*(-236*s**2 + 35*s + 6) + 48*r*s - 6*r + 140*s**2 - 29*s - 3) - 14*g2*(8*s**2 - 6*s + 1))) + 23760*Dd**2*K*f**2*s**2 - 11880*Dd**2*K*f**2*s + 4752*Dd**2*b2*f*s**2 - 2376*Dd**2*b2*f*s - 10320*Dd**2*f**3*r*s + 2580*Dd**2*f**3*r - 43380*Dd**2*f**3*s**2 + 24270*Dd**2*f**3*s - 860*Dd**2*f**3 - 5544*Dd**2*f**2*r*s + 1386*Dd**2*f**2*r - 15840*Dd**2*f**2*s**2 + 9306*Dd**2*f**2*s - 462*Dd**2*f**2 - 46728*Dd**2*f*g2*s**2 + 23364*Dd**2*f*g2*s) + 858*b2*(D1**2*(f*(10*fd*(2*s**2 - 2*s + 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(12*bd1 - 6*bdd1)) - 2*fd*s*(6*bd1 + 5*fd)*(s - 1)) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(6*bd1*s + 5*fd*(2*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(9009*d**2*k2**2) - 2*D1**2*Pk1*Pk2*ct**4*k2**4*st**2*(132*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 330*D1**2*b1*f*fdd*r**2 + 330*D1**2*b1*f*fdd*r*s - 165*D1**2*b1*f*fdd*r + 330*D1**2*b1*fd**2*r**2 + 330*D1**2*b1*fd**2*r*s - 165*D1**2*b1*fd**2*r + 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 606*D1**2*f**2*fd*r**2 + 606*D1**2*f**2*fd*r*s - 606*D1**2*f**2*fd*r - 202*D1**2*f**2*fd*s + 202*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 198*D1*Dd*b1*f**2*r - 66*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 + 2640*D1*Dd*b1*f*fd*r**2 + 2640*D1*Dd*b1*f*fd*r*s - 1650*D1*Dd*b1*f*fd*r - 330*D1*Dd*b1*f*fd*s + 165*D1*Dd*b1*f*fd + 808*D1*Dd*f**3*r**2 + 808*D1*Dd*f**3*r*s - 606*D1*Dd*f**3*r - 202*D1*Dd*f**3*s + 202*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 735*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 140*D1*Dd*f**2*fd + 660*D1*Ddd*b1*f**2*r**2 + 660*D1*Ddd*b1*f**2*r*s - 495*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2*s + 165*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 105*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 1980*Dd**2*b1*f**2*r**2 + 1980*Dd**2*b1*f**2*r*s - 1485*Dd**2*b1*f**2*r - 495*Dd**2*b1*f**2*s + 165*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 315*Dd**2*f**3*r + 105*Dd**2*f**3*s - 35*Dd**2*f**3)/(693*d**2*k1**2*k3**4) - 4*D1**2*Pk1*Pk2*ct**4*k2**4*(D1*f*(6*D1*bd1**2*(2*r - 1)*(r + s - 1) + 3*bd1*(D1*(2*f*(r + s - 1) + fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*f*(8*r**2 + r*(8*s - 7) - s + 1)) + f*(D1*(3*bdd1*r*(r + s - 1) - 5*fd*(3*r**2 + 3*r*(s - 1) - s + 1)) - 5*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1))) + 2*b1**2*(D1**2*r*(fd + 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(8*r**2 + 8*r*s - 3*r - s)) + 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(6*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) + 3*D1*Dd*f*fd*(8*r - 3)*(2*r + 2*s - 1) + 2*D1*bd1*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 3*r - s)) + 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 3*D1*(D1*(f*(-2*fd*(r + s - 1) + fdd*(2*r**2 + 2*r*(s - 1) - s + 1)) + fd**2*(2*r**2 + 2*r*(s - 1) - s)) + Ddd*f**2*(4*r**2 + r*(4*s - 3) - s + 1)) + 3*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)))/(21*d**2*k1**2*k3**4) - 8*D1**2*Pk1*Pk2*ct**3*f*k1*k2**3*st**4*(132*D1**2*bd1*f*(C - 1)*(r + s - 1)**2 + 132*D1*b1*(C - 1)*(D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (40*C - 55)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 2*D1*f*(2*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) - Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(231*d**2*k3**6) - 16*D1**2*Pk1*Pk2*ct**3*f*k1*k2*st**4*(D1**2*(f*(22*bd1*s*(C - 1)*(r + s - 1) + fd*(20*C - 30)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(10*C - 15)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(15 - 10*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 22*D1*b1*(C - 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + D1*f*(10*C - 15)*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(15 - 10*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1))/(77*d**2*k3**4) - D1**2*Pk1*Pk2*ct**3*f*k1*st**4*(160*C - 280)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k2*k3**2) + 40*D1**2*Pk1*Pk2*ct**3*f*k2**5*st**4*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 2*D1*f*(2*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) - Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1))/(77*d**2*k1*k3**6) - 8*D1**2*Pk1*Pk2*ct**3*f*k2**3*st**4*(66*D1**2*bd1*f*(C - 1)*(r - 1)*(r + s - 1) - 5*D1**2*(f*(2*fd - fdd)*(C*(6*r**2 + 6*r*(s - 1) - 2*s + 2) - 6*r**2 + 3*r*(s + 1) + 9*s**2 - 7*s + 1) - fd**2*(2*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 12*r**2 + 6*r*(s + 1) + 18*s**2 - 14*s + 1)) + 66*D1*b1*(C - 1)*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 5*D1*f*(Dd*(2*f*(C*(8*r**2 + r*(8*s - 6) - 2*s + 2) - 8*r**2 + r*(4*s + 3) + 12*s**2 - 7*s + 1) - fd*(2*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) - 48*r**2 + 3*r*(8*s + 7) + 72*s**2 - 49*s + 4)) - Ddd*f*(C*(8*r**2 + r*(8*s - 6) - 2*s + 2) - 8*r**2 + r*(4*s + 3) + 12*s**2 - 7*s + 1)) + 5*Dd**2*f**2*(2*C*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1) - 24*r**2 + 3*r*(4*s + 3) + 36*s**2 - 21*s + 1))/(231*d**2*k1*k3**4) + 40*D1**2*Pk1*Pk2*ct**3*f*st**4*(13*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(20*fd*(4*s**2 - 2*s + 1) - 10*fdd*(4*s**2 - 2*s + 1) + s**2*(26*bd1 - 13*bdd1)) + 2*fd*s*(bd1*(13 - 39*s) + 30*fd*(1 - 2*s))) + 2*D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(13*bd1*s + 10*fd*(4*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 60*Dd**2*f**2*s*(1 - 2*s)))/(143*d**2*k1*k2) + 8*D1**2*Pk1*Pk2*ct**3*k1**5*(264*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r + 264*D1**2*b1*f*fd*s**2 - 264*D1**2*b1*f*fd*s + 132*D1**2*b1*f*fd - 330*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 330*D1**2*b1*f*fdd*s**2 + 330*D1**2*b1*f*fdd*s - 165*D1**2*b1*f*fdd - 330*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r - 330*D1**2*b1*fd**2*s**2 + 330*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)**2 + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r + 528*D1*Dd*b1*f**2*s**2 - 528*D1*Dd*b1*f**2*s + 264*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 2640*D1*Dd*b1*f*fd*r - 2640*D1*Dd*b1*f*fd*s**2 + 2640*D1*Dd*b1*f*fd*s - 660*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 460*D1*Dd*f**3*s + 230*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 3920*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3920*D1*Dd*f**2*fd*s - 1120*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r - 660*D1*Ddd*b1*f**2*s**2 + 660*D1*Ddd*b1*f**2*s - 330*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 280*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(2*r + 2*s - 1)) - 1980*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r - 1980*Dd**2*b1*f**2*s**2 + 1980*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k2*k3**6) - 8*D1**2*Pk1*Pk2*ct**3*k1**3*k2*st**2*(352*C*D1**2*b1*f*fd*r**2 + 704*C*D1**2*b1*f*fd*r*s - 352*C*D1**2*b1*f*fd*r + 352*C*D1**2*b1*f*fd*s**2 - 352*C*D1**2*b1*f*fd*s + 176*C*D1**2*b1*f*fd - 264*C*D1**2*b1*f*fdd*r**2 - 528*C*D1**2*b1*f*fdd*r*s + 264*C*D1**2*b1*f*fdd*r - 264*C*D1**2*b1*f*fdd*s**2 + 264*C*D1**2*b1*f*fdd*s - 132*C*D1**2*b1*f*fdd - 264*C*D1**2*b1*fd**2*r**2 - 528*C*D1**2*b1*fd**2*r*s + 264*C*D1**2*b1*fd**2*r - 264*C*D1**2*b1*fd**2*s**2 + 264*C*D1**2*b1*fd**2*s + 336*C*D1**2*f**2*fd*r**2 + 672*C*D1**2*f**2*fd*r*s - 448*C*D1**2*f**2*fd*r + 336*C*D1**2*f**2*fd*s**2 - 448*C*D1**2*f**2*fd*s + 224*C*D1**2*f**2*fd - 300*C*D1**2*f**2*fdd*r**2 - 600*C*D1**2*f**2*fdd*r*s + 400*C*D1**2*f**2*fdd*r - 300*C*D1**2*f**2*fdd*s**2 + 400*C*D1**2*f**2*fdd*s - 200*C*D1**2*f**2*fdd - 600*C*D1**2*f*fd**2*r**2 - 1200*C*D1**2*f*fd**2*r*s + 800*C*D1**2*f*fd**2*r - 600*C*D1**2*f*fd**2*s**2 + 800*C*D1**2*f*fd**2*s - 200*C*D1**2*f*fd**2 + 704*C*D1*Dd*b1*f**2*r**2 + 1408*C*D1*Dd*b1*f**2*r*s - 704*C*D1*Dd*b1*f**2*r + 704*C*D1*Dd*b1*f**2*s**2 - 704*C*D1*Dd*b1*f**2*s + 352*C*D1*Dd*b1*f**2 - 2112*C*D1*Dd*b1*f*fd*r**2 - 4224*C*D1*Dd*b1*f*fd*r*s + 2112*C*D1*Dd*b1*f*fd*r - 2112*C*D1*Dd*b1*f*fd*s**2 + 2112*C*D1*Dd*b1*f*fd*s - 528*C*D1*Dd*b1*f*fd + 448*C*D1*Dd*f**3*r**2 + 896*C*D1*Dd*f**3*r*s - 448*C*D1*Dd*f**3*r + 448*C*D1*Dd*f**3*s**2 - 448*C*D1*Dd*f**3*s + 224*C*D1*Dd*f**3 - 2400*C*D1*Dd*f**2*fd*r**2 - 4800*C*D1*Dd*f**2*fd*r*s + 2800*C*D1*Dd*f**2*fd*r - 2400*C*D1*Dd*f**2*fd*s**2 + 2800*C*D1*Dd*f**2*fd*s - 800*C*D1*Dd*f**2*fd - 528*C*D1*Ddd*b1*f**2*r**2 - 1056*C*D1*Ddd*b1*f**2*r*s + 528*C*D1*Ddd*b1*f**2*r - 528*C*D1*Ddd*b1*f**2*s**2 + 528*C*D1*Ddd*b1*f**2*s - 264*C*D1*Ddd*b1*f**2 - 400*C*D1*Ddd*f**3*r**2 - 800*C*D1*Ddd*f**3*r*s + 400*C*D1*Ddd*f**3*r - 400*C*D1*Ddd*f**3*s**2 + 400*C*D1*Ddd*f**3*s - 200*C*D1*Ddd*f**3 - 1584*C*Dd**2*b1*f**2*r**2 - 3168*C*Dd**2*b1*f**2*r*s + 1584*C*Dd**2*b1*f**2*r - 1584*C*Dd**2*b1*f**2*s**2 + 1584*C*Dd**2*b1*f**2*s - 264*C*Dd**2*b1*f**2 - 1200*C*Dd**2*f**3*r**2 - 2400*C*Dd**2*f**3*r*s + 1200*C*Dd**2*f**3*r - 1200*C*Dd**2*f**3*s**2 + 1200*C*Dd**2*f**3*s - 200*C*Dd**2*f**3 - 946*D1**2*b1*f*fd*r**2 - 1892*D1**2*b1*f*fd*r*s + 946*D1**2*b1*f*fd*r - 946*D1**2*b1*f*fd*s**2 + 946*D1**2*b1*f*fd*s - 473*D1**2*b1*f*fd + 660*D1**2*b1*f*fdd*r**2 + 1320*D1**2*b1*f*fdd*r*s - 660*D1**2*b1*f*fdd*r + 660*D1**2*b1*f*fdd*s**2 - 660*D1**2*b1*f*fdd*s + 330*D1**2*b1*f*fdd + 660*D1**2*b1*fd**2*r**2 + 1320*D1**2*b1*fd**2*r*s - 660*D1**2*b1*fd**2*r + 660*D1**2*b1*fd**2*s**2 - 660*D1**2*b1*fd**2*s - 66*D1**2*bdd1*f**2*(2*C - 5)*(r + s - 1)**2 - 939*D1**2*f**2*fd*r**2 - 1878*D1**2*f**2*fd*r*s + 1252*D1**2*f**2*fd*r - 939*D1**2*f**2*fd*s**2 + 1252*D1**2*f**2*fd*s - 626*D1**2*f**2*fd + 750*D1**2*f**2*fdd*r**2 + 1500*D1**2*f**2*fdd*r*s - 1000*D1**2*f**2*fdd*r + 750*D1**2*f**2*fdd*s**2 - 1000*D1**2*f**2*fdd*s + 500*D1**2*f**2*fdd + 1500*D1**2*f*fd**2*r**2 + 3000*D1**2*f*fd**2*r*s - 2000*D1**2*f*fd**2*r + 1500*D1**2*f*fd**2*s**2 - 2000*D1**2*f*fd**2*s + 500*D1**2*f*fd**2 - 1892*D1*Dd*b1*f**2*r**2 - 3784*D1*Dd*b1*f**2*r*s + 1892*D1*Dd*b1*f**2*r - 1892*D1*Dd*b1*f**2*s**2 + 1892*D1*Dd*b1*f**2*s - 946*D1*Dd*b1*f**2 + 5280*D1*Dd*b1*f*fd*r**2 + 10560*D1*Dd*b1*f*fd*r*s - 5280*D1*Dd*b1*f*fd*r + 5280*D1*Dd*b1*f*fd*s**2 - 5280*D1*Dd*b1*f*fd*s + 1320*D1*Dd*b1*f*fd - 1252*D1*Dd*f**3*r**2 - 2504*D1*Dd*f**3*r*s + 1252*D1*Dd*f**3*r - 1252*D1*Dd*f**3*s**2 + 1252*D1*Dd*f**3*s - 626*D1*Dd*f**3 + 6000*D1*Dd*f**2*fd*r**2 + 12000*D1*Dd*f**2*fd*r*s - 7000*D1*Dd*f**2*fd*r + 6000*D1*Dd*f**2*fd*s**2 - 7000*D1*Dd*f**2*fd*s + 2000*D1*Dd*f**2*fd + 1320*D1*Ddd*b1*f**2*r**2 + 2640*D1*Ddd*b1*f**2*r*s - 1320*D1*Ddd*b1*f**2*r + 1320*D1*Ddd*b1*f**2*s**2 - 1320*D1*Ddd*b1*f**2*s + 660*D1*Ddd*b1*f**2 + 1000*D1*Ddd*f**3*r**2 + 2000*D1*Ddd*f**3*r*s - 1000*D1*Ddd*f**3*r + 1000*D1*Ddd*f**3*s**2 - 1000*D1*Ddd*f**3*s + 500*D1*Ddd*f**3 + 11*D1*bd1*f*(r + s - 1)*(D1*f*(16*C - 43)*(r + s - 1) - D1*fd*(24*C - 60)*(2*r + 2*s - 1) - Dd*f*(48*C - 120)*(2*r + 2*s - 1)) + 3960*Dd**2*b1*f**2*r**2 + 7920*Dd**2*b1*f**2*r*s - 3960*Dd**2*b1*f**2*r + 3960*Dd**2*b1*f**2*s**2 - 3960*Dd**2*b1*f**2*s + 660*Dd**2*b1*f**2 + 3000*Dd**2*f**3*r**2 + 6000*Dd**2*f**3*r*s - 3000*Dd**2*f**3*r + 3000*Dd**2*f**3*s**2 - 3000*Dd**2*f**3*s + 500*Dd**2*f**3)/(231*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct**3*k1**3*k2*(33*b1**2*(D1**2*(r + s)**2*(fd*(40*C - 77) + fdd*(84 - 48*C)) + 2*D1*(Dd*(f*(40*C - 77)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(96*C - 168)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(84 - 48*C)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(96*C - 168)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 33*b1*(-24*D1**2*bdd1*f*(4*C - 7)*(r + s - 1)**2 - 15*D1**2*(f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*bd1*(r + s - 1)*(D1*f*(40*C - 77)*(r + s - 1) - D1*fd*(96*C - 168)*(r + s) - Dd*f*(192*C - 336)*(2*r + 2*s - 1)) - 30*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 5*fd*(2*r + 2*s - 1)**2) - 5*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 150*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + f*(-792*D1**2*bd1**2*(4*C - 7)*(r + s - 1)**2 + 2475*D1**2*bdd1*f*(r + s - 1)**2 + 10*D1**2*(-f*(-112*C*fdd + fd*(92*C - 5) - 14*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(224*C + 28)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 990*D1*bd1*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(2*r + 2*s - 1)) + 20*D1*f*(Dd*(-f*(92*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(224*C + 28)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Ddd*f*(112*C + 14)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 5*Dd**2*f**2*(448*C + 56)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(693*d**2*k3**6) - D1**2*Pk1*Pk2*ct**3*k1**3*st**2*(16*C - 64)*(11*b1*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 3*fd*(8*s - 3)*(2*r + 2*s - 1)) - 3*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(39*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 25*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 25*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 25*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k2*k3**4) - 2*D1**2*Pk1*Pk2*ct**3*k1**3*(264*b1**2*(D1**2*s*(r + s)*(fd*(5*C - 16) + fdd*(15 - 6*C)) + D1*(Dd*(f*(5*C - 16)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C - 15)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(15 - 6*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(6*C - 15)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 66*b1*(-80*C*D1**2*f*fd*r*s + 56*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 56*C*D1**2*f*fd + 88*C*D1**2*f*fdd*r*s - 64*C*D1**2*f*fdd*r + 88*C*D1**2*f*fdd*s**2 - 108*C*D1**2*f*fdd*s + 64*C*D1**2*f*fdd + 88*C*D1**2*fd**2*r*s - 64*C*D1**2*fd**2*r + 88*C*D1**2*fd**2*s**2 - 108*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 120*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 + 704*C*D1*Dd*f*fd*r*s - 344*C*D1*Dd*f*fd*r + 704*C*D1*Dd*f*fd*s**2 - 696*C*D1*Dd*f*fd*s + 172*C*D1*Dd*f*fd + 176*C*D1*Ddd*f**2*r*s - 44*C*D1*Ddd*f**2*r + 176*C*D1*Ddd*f**2*s**2 - 132*C*D1*Ddd*f**2*s + 44*C*D1*Ddd*f**2 + 528*C*Dd**2*f**2*r*s - 132*C*Dd**2*f**2*r + 528*C*Dd**2*f**2*s**2 - 396*C*Dd**2*f**2*s + 44*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(2*C - 5)*(2*s - 1)*(r + s - 1) + 26*D1**2*f*fd*r**2 + 164*D1**2*f*fd*r*s - 134*D1**2*f*fd*r + 138*D1**2*f*fd*s**2 - 190*D1**2*f*fd*s + 121*D1**2*f*fd - 40*D1**2*f*fdd*r**2 - 160*D1**2*f*fdd*r*s + 130*D1**2*f*fdd*r - 120*D1**2*f*fdd*s**2 + 170*D1**2*f*fdd*s - 110*D1**2*f*fdd - 40*D1**2*fd**2*r**2 - 160*D1**2*fd**2*r*s + 130*D1**2*fd**2*r - 120*D1**2*fd**2*s**2 + 170*D1**2*fd**2*s + 52*D1*Dd*f**2*r**2 + 328*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r + 276*D1*Dd*f**2*s**2 - 220*D1*Dd*f**2*s + 82*D1*Dd*f**2 - 320*D1*Dd*f*fd*r**2 - 1280*D1*Dd*f*fd*r*s + 760*D1*Dd*f*fd*r - 960*D1*Dd*f*fd*s**2 + 1080*D1*Dd*f*fd*s - 300*D1*Dd*f*fd - 80*D1*Ddd*f**2*r**2 - 320*D1*Ddd*f**2*r*s + 120*D1*Ddd*f**2*r - 240*D1*Ddd*f**2*s**2 + 200*D1*Ddd*f**2*s - 80*D1*Ddd*f**2 + 4*D1*bd1*(D1*(f*(5*C - 16)*(2*s - 1)*(r + s - 1) - fd*(6*C - 15)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(30 - 12*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 240*Dd**2*f**2*r**2 - 960*Dd**2*f**2*r*s + 360*Dd**2*f**2*r - 720*Dd**2*f**2*s**2 + 600*Dd**2*f**2*s - 80*Dd**2*f**2) - f*(792*D1**2*bd1**2*(2*C - 5)*(2*s - 1)*(r + s - 1) + 132*D1**2*bdd1*f*(r + s - 1)*(-2*C*(11*s + 5) + 10*r + 30*s + 15) + 5*D1**2*(f*(fd*(632*C*(3*r*s - r + 3*s**2 - 3*s + 1) - 555*r**2 - 4590*r*s + 1900*r - 4035*s**2 + 4220*s - 1530) + fdd*(-712*C*(3*r*s - r + 3*s**2 - 3*s + 1) + 723*r**2 + 4374*r*s - 1940*r + 3651*s**2 - 3892*s + 1458)) + 2*fd**2*(-356*C*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 723*r**2 + 4374*r*s - 1940*r + 3651*s**2 - 3892*s + 729)) + 66*D1*bd1*(-4*C*Dd*f*(r*(88*s + 9) + 88*s**2 - 57*s + 1) + D1*f*(r + s - 1)*(8*C*(5*s + 2) - 13*r - 69*s - 39) + 2*D1*fd*(-2*C*(r*(44*s - 6) + 44*s**2 - 39*s + 11) + 40*r**2 + 5*r*(32*s - 11) + 120*s**2 - 115*s + 40) + 20*Dd*f*(8*r**2 + 4*r*(8*s - 1) + 24*s**2 - 16*s + 1)) + 10*D1*f*(Dd*(f*(316*C*(4*r*s - r + 4*s**2 - 3*s + 1) - 370*r**2 - 3060*r*s + 950*r - 2690*s**2 + 2110*s - 765) + 2*fd*(-178*C*(24*r*s - 7*r + 24*s**2 - 21*s + 4) + 1446*r**2 + 8748*r*s - 3395*r + 7302*s**2 - 6811*s + 1458)) + Ddd*f*(-356*C*(4*r*s - r + 4*s**2 - 3*s + 1) + 482*r**2 + 2916*r*s - 970*r + 2434*s**2 - 1946*s + 729)) + 10*Dd**2*f**2*(-356*C*(12*r*s - 3*r + 12*s**2 - 9*s + 1) + 1446*r**2 + 8748*r*s - 2910*r + 7302*s**2 - 5838*s + 729)))/(693*d**2*k2*k3**4) + 8*D1**2*Pk1*Pk2*ct**3*k1**3*st**2*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(50*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2**3*k3**2) + 4*D1**2*Pk1*Pk2*ct**3*k1**3*(396*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 66*b1*(-6*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 42*D1**2*f*fd*s**2 + 62*D1**2*f*fd*s - 31*D1**2*f*fd + 30*D1**2*f*fdd*s**2 - 40*D1**2*f*fdd*s + 20*D1**2*f*fdd + 30*D1**2*fd**2*s**2 - 40*D1**2*fd**2*s - 84*D1*Dd*f**2*s**2 + 42*D1*Dd*f**2*s - 21*D1*Dd*f**2 + 240*D1*Dd*f*fd*s**2 - 220*D1*Dd*f*fd*s + 40*D1*Dd*f*fd + 60*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 12*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 180*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s) + f*(-792*D1**2*bd1**2*s*(s - 1) + 330*D1**2*bdd1*f*(3*s**2 + 2*s - 1) + 5*D1**2*(-f*(343*fd - 221*fdd)*(3*s**2 - 2*s + 1) + 442*fd**2*s*(3*s - 2)) - 66*D1*bd1*(D1*f*(21*s**2 + 20*s - 10) + 20*D1*fd*s*(1 - 3*s) - 10*Dd*f*(12*s**2 + s - 1)) + 5*D1*f*(-343*Dd*f*(4*s**2 - 2*s + 1) + 442*Dd*fd*(12*s**2 - 7*s + 1) + 221*Ddd*f*(4*s**2 - 2*s + 1)) + 6630*Dd**2*f**2*s*(2*s - 1)))/(693*d**2*k2**3*k3**2) - 8*D1**2*Pk1*Pk2*ct**3*k1*k2**3*st**2*(33*b1**2*(D1**2*(r + s)**2*(fd*(38*C - 44) + fdd*(15 - 12*C)) + 4*D1*Dd*(f*(19*C - 22)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(12*C - 15)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - D1*Ddd*f*(24*C - 30)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd**2*f*(24*C - 30)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 33*b1*(-104*C*D1**2*f*fd*r**2 - 208*C*D1**2*f*fd*r*s + 104*C*D1**2*f*fd*r - 104*C*D1**2*f*fd*s**2 + 104*C*D1**2*f*fd*s - 52*C*D1**2*f*fd + 56*C*D1**2*f*fdd*r**2 + 112*C*D1**2*f*fdd*r*s - 56*C*D1**2*f*fdd*r + 56*C*D1**2*f*fdd*s**2 - 56*C*D1**2*f*fdd*s + 28*C*D1**2*f*fdd + 56*C*D1**2*fd**2*r**2 + 112*C*D1**2*fd**2*r*s - 56*C*D1**2*fd**2*r + 56*C*D1**2*fd**2*s**2 - 56*C*D1**2*fd**2*s - 208*C*D1*Dd*f**2*r**2 - 416*C*D1*Dd*f**2*r*s + 208*C*D1*Dd*f**2*r - 208*C*D1*Dd*f**2*s**2 + 208*C*D1*Dd*f**2*s - 104*C*D1*Dd*f**2 + 448*C*D1*Dd*f*fd*r**2 + 896*C*D1*Dd*f*fd*r*s - 448*C*D1*Dd*f*fd*r + 448*C*D1*Dd*f*fd*s**2 - 448*C*D1*Dd*f*fd*s + 112*C*D1*Dd*f*fd + 112*C*D1*Ddd*f**2*r**2 + 224*C*D1*Ddd*f**2*r*s - 112*C*D1*Ddd*f**2*r + 112*C*D1*Ddd*f**2*s**2 - 112*C*D1*Ddd*f**2*s + 56*C*D1*Ddd*f**2 + 336*C*Dd**2*f**2*r**2 + 672*C*Dd**2*f**2*r*s - 336*C*Dd**2*f**2*r + 336*C*Dd**2*f**2*s**2 - 336*C*Dd**2*f**2*s + 56*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(4*C - 5)*(r + s - 1)**2 - 92*D1**2*f*fd*r**2 - 184*D1**2*f*fd*r*s + 92*D1**2*f*fd*r - 92*D1**2*f*fd*s**2 + 92*D1**2*f*fd*s - 46*D1**2*f*fd + 66*D1**2*f*fdd*r**2 + 132*D1**2*f*fdd*r*s - 66*D1**2*f*fdd*r + 66*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 33*D1**2*f*fdd + 66*D1**2*fd**2*r**2 + 132*D1**2*fd**2*r*s - 66*D1**2*fd**2*r + 66*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s - 184*D1*Dd*f**2*r**2 - 368*D1*Dd*f**2*r*s + 184*D1*Dd*f**2*r - 184*D1*Dd*f**2*s**2 + 184*D1*Dd*f**2*s - 92*D1*Dd*f**2 + 528*D1*Dd*f*fd*r**2 + 1056*D1*Dd*f*fd*r*s - 528*D1*Dd*f*fd*r + 528*D1*Dd*f*fd*s**2 - 528*D1*Dd*f*fd*s + 132*D1*Dd*f*fd + 132*D1*Ddd*f**2*r**2 + 264*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 132*D1*Ddd*f**2*s**2 - 132*D1*Ddd*f**2*s + 66*D1*Ddd*f**2 + 4*D1*bd1*(r + s - 1)*(D1*f*(19*C - 22)*(r + s - 1) - D1*fd*(12*C - 15)*(r + s) - Dd*f*(24*C - 30)*(2*r + 2*s - 1)) + 396*Dd**2*f**2*r**2 + 792*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 396*Dd**2*f**2*s**2 - 396*Dd**2*f**2*s + 66*Dd**2*f**2) + f*(-198*D1**2*bd1**2*(4*C - 5)*(r + s - 1)**2 + 33*D1**2*bdd1*f*(28*C + 33)*(r + s - 1)**2 - 2*D1**2*(f*(fd*(901*C + 153) - fdd*(500*C + 225))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(-1000*C - 450)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 66*D1*bd1*(r + s - 1)*(D1*f*(26*C + 23)*(r + s - 1) - D1*fd*(28*C + 33)*(2*r + 2*s - 1) - Dd*f*(56*C + 66)*(2*r + 2*s - 1)) - 4*D1*f*(Dd*(f*(901*C + 153)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(1000*C + 450)*(6*r**2 + r*(12*s - 7) + 6*s**2 - 7*s + 2)) + Ddd*f*(-500*C - 225)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd**2*f**2*(2000*C + 900)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(693*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct**3*k1*k2**3*(D1*f*(-24*D1*bd1**2*(4*C + 3)*(r + s - 1)**2 + 2*bd1*(r + s - 1)*(D1*f*(28*C - 3)*(r + s - 1) - D1*fd*(40*C + 30)*(2*r + 2*s - 1) - Dd*f*(80*C + 60)*(2*r + 2*s - 1)) - 5*f*(2*D1*bdd1*(4*C + 3)*(r + s - 1)**2 + (4*C + 1)*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))) + 2*b1**2*(D1**2*(r + s)**2*(48*C*fd + fd - fdd*(24*C + 18)) + 2*D1*(Dd*(f*(48*C + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(48*C + 36)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(-24*C - 18)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(48*C + 36)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 2*b1*(56*C*D1**2*f*fd*r**2 + 112*C*D1**2*f*fd*r*s - 56*C*D1**2*f*fd*r + 56*C*D1**2*f*fd*s**2 - 56*C*D1**2*f*fd*s + 28*C*D1**2*f*fd - 40*C*D1**2*f*fdd*r**2 - 80*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*r - 40*C*D1**2*f*fdd*s**2 + 40*C*D1**2*f*fdd*s - 20*C*D1**2*f*fdd - 40*C*D1**2*fd**2*r**2 - 80*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*r - 40*C*D1**2*fd**2*s**2 + 40*C*D1**2*fd**2*s + 112*C*D1*Dd*f**2*r**2 + 224*C*D1*Dd*f**2*r*s - 112*C*D1*Dd*f**2*r + 112*C*D1*Dd*f**2*s**2 - 112*C*D1*Dd*f**2*s + 56*C*D1*Dd*f**2 - 320*C*D1*Dd*f*fd*r**2 - 640*C*D1*Dd*f*fd*r*s + 320*C*D1*Dd*f*fd*r - 320*C*D1*Dd*f*fd*s**2 + 320*C*D1*Dd*f*fd*s - 80*C*D1*Dd*f*fd - 80*C*D1*Ddd*f**2*r**2 - 160*C*D1*Ddd*f**2*r*s + 80*C*D1*Ddd*f**2*r - 80*C*D1*Ddd*f**2*s**2 + 80*C*D1*Ddd*f**2*s - 40*C*D1*Ddd*f**2 - 240*C*Dd**2*f**2*r**2 - 480*C*Dd**2*f**2*r*s + 240*C*Dd**2*f**2*r - 240*C*Dd**2*f**2*s**2 + 240*C*Dd**2*f**2*s - 40*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(4*C + 3)*(r + s - 1)**2 - 6*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s + 6*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s - 3*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s - 12*D1*Dd*f**2*r**2 - 24*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 240*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 240*D1*Dd*f*fd*s - 60*D1*Dd*f*fd - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 + 2*D1*bd1*(r + s - 1)*(D1*f*(48*C + 1)*(r + s - 1) - D1*fd*(48*C + 36)*(r + s) - Dd*f*(96*C + 72)*(2*r + 2*s - 1)) - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 30*Dd**2*f**2))/(21*d**2*k3**6) - 2*D1**2*Pk1*Pk2*ct**3*k1*k2*st**2*(132*b1**2*(D1**2*s*(r + s)*(fd*(25*C - 31) + fdd*(12 - 9*C)) + D1*(Dd*(f*(25*C - 31)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(9*C - 12)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(12 - 9*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(9*C - 12)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 33*b1*(-188*C*D1**2*f*fd*r**2 - 880*C*D1**2*f*fd*r*s + 508*C*D1**2*f*fd*r - 692*C*D1**2*f*fd*s**2 + 760*C*D1**2*f*fd*s - 414*C*D1**2*f*fd + 132*C*D1**2*f*fdd*r**2 + 576*C*D1**2*f*fdd*r*s - 324*C*D1**2*f*fdd*r + 444*C*D1**2*f*fdd*s**2 - 480*C*D1**2*f*fdd*s + 258*C*D1**2*f*fdd + 132*C*D1**2*fd**2*r**2 + 576*C*D1**2*fd**2*r*s - 324*C*D1**2*fd**2*r + 444*C*D1**2*fd**2*s**2 - 480*C*D1**2*fd**2*s - 376*C*D1*Dd*f**2*r**2 - 1760*C*D1*Dd*f**2*r*s + 628*C*D1*Dd*f**2*r - 1384*C*D1*Dd*f**2*s**2 + 1132*C*D1*Dd*f**2*s - 440*C*D1*Dd*f**2 + 1056*C*D1*Dd*f*fd*r**2 + 4608*C*D1*Dd*f*fd*r*s - 2136*C*D1*Dd*f*fd*r + 3552*C*D1*Dd*f*fd*s**2 - 3384*C*D1*Dd*f*fd*s + 804*C*D1*Dd*f*fd + 264*C*D1*Ddd*f**2*r**2 + 1152*C*D1*Ddd*f**2*r*s - 420*C*D1*Ddd*f**2*r + 888*C*D1*Ddd*f**2*s**2 - 732*C*D1*Ddd*f**2*s + 288*C*D1*Ddd*f**2 + 792*C*Dd**2*f**2*r**2 + 3456*C*Dd**2*f**2*r*s - 1260*C*Dd**2*f**2*r + 2664*C*Dd**2*f**2*s**2 - 2196*C*Dd**2*f**2*s + 288*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(3*C - 4)*(2*s - 1)*(r + s - 1) + 314*D1**2*f*fd*r**2 + 524*D1**2*f*fd*r*s - 354*D1**2*f*fd*r + 210*D1**2*f*fd*s**2 - 302*D1**2*f*fd*s + 197*D1**2*f*fd - 222*D1**2*f*fdd*r**2 - 404*D1**2*f*fdd*r*s + 250*D1**2*f*fdd*r - 182*D1**2*f*fdd*s**2 + 230*D1**2*f*fdd*s - 139*D1**2*f*fdd - 222*D1**2*fd**2*r**2 - 404*D1**2*fd**2*r*s + 250*D1**2*fd**2*r - 182*D1**2*fd**2*s**2 + 230*D1**2*fd**2*s + 628*D1*Dd*f**2*r**2 + 1048*D1*Dd*f**2*r*s - 576*D1*Dd*f**2*r + 420*D1*Dd*f**2*s**2 - 472*D1*Dd*f**2*s + 262*D1*Dd*f**2 - 1776*D1*Dd*f*fd*r**2 - 3232*D1*Dd*f*fd*r*s + 1848*D1*Dd*f*fd*r - 1456*D1*Dd*f*fd*s**2 + 1688*D1*Dd*f*fd*s - 480*D1*Dd*f*fd - 444*D1*Ddd*f**2*r**2 - 808*D1*Ddd*f**2*r*s + 424*D1*Ddd*f**2*r - 364*D1*Ddd*f**2*s**2 + 384*D1*Ddd*f**2*s - 202*D1*Ddd*f**2 + 4*D1*bd1*(D1*(f*(25*C - 31)*(2*s - 1)*(r + s - 1) - fd*(9*C - 12)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(24 - 18*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 1332*Dd**2*f**2*r**2 - 2424*Dd**2*f**2*r*s + 1272*Dd**2*f**2*r - 1092*Dd**2*f**2*s**2 + 1152*Dd**2*f**2*s - 202*Dd**2*f**2) + f*(-8514*C*D1**2*f*fd*r**2 - 40284*C*D1**2*f*fd*r*s + 19104*C*D1**2*f*fd*r - 31770*C*D1**2*f*fd*s**2 + 34608*C*D1**2*f*fd*s - 13428*C*D1**2*f*fd + 6534*C*D1**2*f*fdd*r**2 + 27468*C*D1**2*f*fdd*r*s - 13512*C*D1**2*f*fdd*r + 20934*C*D1**2*f*fdd*s**2 - 23112*C*D1**2*f*fdd*s + 9156*C*D1**2*f*fdd + 13068*C*D1**2*fd**2*r**2 + 54936*C*D1**2*fd**2*r*s - 27024*C*D1**2*fd**2*r + 41868*C*D1**2*fd**2*s**2 - 46224*C*D1**2*fd**2*s + 9156*C*D1**2*fd**2 - 11352*C*D1*Dd*f**2*r**2 - 53712*C*D1*Dd*f**2*r*s + 19104*C*D1*Dd*f**2*r - 42360*C*D1*Dd*f**2*s**2 + 34608*C*D1*Dd*f**2*s - 13428*C*D1*Dd*f**2 + 52272*C*D1*Dd*f*fd*r**2 + 219744*C*D1*Dd*f*fd*r*s - 94584*C*D1*Dd*f*fd*r + 167472*C*D1*Dd*f*fd*s**2 - 161784*C*D1*Dd*f*fd*s + 36624*C*D1*Dd*f*fd + 8712*C*D1*Ddd*f**2*r**2 + 36624*C*D1*Ddd*f**2*r*s - 13512*C*D1*Ddd*f**2*r + 27912*C*D1*Ddd*f**2*s**2 - 23112*C*D1*Ddd*f**2*s + 9156*C*D1*Ddd*f**2 + 26136*C*Dd**2*f**2*r**2 + 109872*C*Dd**2*f**2*r*s - 40536*C*Dd**2*f**2*r + 83736*C*Dd**2*f**2*s**2 - 69336*C*Dd**2*f**2*s + 9156*C*Dd**2*f**2 - 396*D1**2*bd1**2*(3*C - 4)*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(6*C*(11*r + 37*s - 5) - 111*r - 91*s + 63) + 13851*D1**2*f*fd*r**2 + 31146*D1**2*f*fd*r*s - 19616*D1**2*f*fd*r + 17295*D1**2*f*fd*s**2 - 21912*D1**2*f*fd*s + 10382*D1**2*f*fd - 11133*D1**2*f*fdd*r**2 - 23790*D1**2*f*fdd*r*s + 15352*D1**2*f*fdd*r - 12657*D1**2*f*fdd*s**2 + 16368*D1**2*f*fdd*s - 7930*D1**2*f*fdd - 22266*D1**2*fd**2*r**2 - 47580*D1**2*fd**2*r*s + 30704*D1**2*fd**2*r - 25314*D1**2*fd**2*s**2 + 32736*D1**2*fd**2*s - 7930*D1**2*fd**2 + 18468*D1*Dd*f**2*r**2 + 41528*D1*Dd*f**2*r*s - 19616*D1*Dd*f**2*r + 23060*D1*Dd*f**2*s**2 - 21912*D1*Dd*f**2*s + 10382*D1*Dd*f**2 - 89064*D1*Dd*f*fd*r**2 - 190320*D1*Dd*f*fd*r*s + 107464*D1*Dd*f*fd*r - 101256*D1*Dd*f*fd*s**2 + 114576*D1*Dd*f*fd*s - 31720*D1*Dd*f*fd - 14844*D1*Ddd*f**2*r**2 - 31720*D1*Ddd*f**2*r*s + 15352*D1*Ddd*f**2*r - 16876*D1*Ddd*f**2*s**2 + 16368*D1*Ddd*f**2*s - 7930*D1*Ddd*f**2 - 33*D1*bd1*(-12*C*Dd*f*(44*r**2 + r*(192*s - 67) + 148*s**2 - 145*s + 29) + D1*f*(r + s - 1)*(C*(94*r + 346*s - 26) - 157*r - 105*s + 65) + 2*D1*fd*(-6*C*(22*r**2 + 96*r*s - 43*r + 74*s**2 - 82*s + 24) + 222*r**2 + 404*r*s - 299*r + 182*s**2 - 269*s + 101) + 8*Dd*f*(111*r**2 + 2*r*(101*s - 70) + 91*s**2 - 125*s + 41)) - 44532*Dd**2*f**2*r**2 - 95160*Dd**2*f**2*r*s + 46056*Dd**2*f**2*r - 50628*Dd**2*f**2*s**2 + 49104*Dd**2*f**2*s - 7930*Dd**2*f**2))/(693*d**2*k3**4) + 2*D1**2*Pk1*Pk2*ct**3*k1*k2*(11*b1**2*(D1**2*(r + s)*(fd*r*(140*C - 219) + fd*s*(316*C - 375) + fdd*r*(211 - 140*C) + fdd*s*(331 - 284*C)) + 2*D1*(Dd*(f*(4*C*(70*r**2 + 4*r*(57*s - 23) + 158*s**2 - 136*s + 57) - 438*r**2 - 12*r*(99*s - 43) - 750*s**2 + 672*s - 297) + 2*fd*(r**2*(422 - 280*C) + r*(-848*C*s + 176*C + 1084*s - 241) + s*(-568*C*s + 248*C + 662*s - 301))) + Ddd*f*(-4*C*(70*r**2 + 212*r*s - 88*r + 142*s**2 - 124*s + 53) + 422*r**2 + 1084*r*s - 482*r + 662*s**2 - 602*s + 271)) + 2*Dd**2*f*(-4*C*(210*r**2 + 12*r*(53*s - 22) + 426*s**2 - 372*s + 53) + 1266*r**2 + 6*r*(542*s - 241) + 1986*s**2 - 1806*s + 271)) + 22*b1*(-D1**2*bdd1*f*(r + s - 1)*(4*C*(35*r + 71*s - 53) - 211*r - 331*s + 271) + 2*D1**2*(f*(fd*(12*C*(2*r**2 + 2*r - 2*s**2 + 4*s - 3) - 98*r**2 - 324*r*s + 148*r - 226*s**2 + 212*s - 99) + fdd*(-6*C*(2*r**2 + 4*r - 2*s**2 + 6*s - 5) + 118*r**2 + 324*r*s - 146*r + 206*s**2 - 190*s + 87)) - 2*fd**2*(r**2*(6*C - 59) + r*(12*C - 162*s + 73) + s*(-6*C*(s - 3) - 103*s + 95))) + D1*bd1*(D1*(f*(r + s - 1)*(4*C*(35*r + 79*s - 57) - 219*r - 375*s + 297) + 2*fd*(r**2*(211 - 140*C) + r*(-424*C*s + 176*C + 542*s - 241) + s*(-284*C*s + 248*C + 331*s - 301))) - 4*Dd*f*(4*C*(70*r**2 + 4*r*(53*s - 33) + 142*s**2 - 186*s + 53) - 422*r**2 - 1084*r*s + 723*r - 662*s**2 + 903*s - 271)) + 4*D1*f*(Dd*(f*(r**2*(24*C - 98) - 2*r*(6*C + 162*s - 65) - s**2*(24*C + 226) + s*(12*C + 194) - 81) - 2*fd*(2*r + 2*s - 1)*(3*C*(4*r - 4*s + 5) - 118*r - 206*s + 84)) + Ddd*f*(-r**2*(12*C - 118) + 2*r*(3*C + 162*s - 70) + s**2*(12*C + 206) - s*(6*C + 184) + 81)) - 12*Dd**2*f**2*(r**2*(12*C - 118) - 2*r*(3*C + 162*s - 70) - s**2*(12*C + 206) + s*(6*C + 184) - 27)) + f*(-22*D1**2*bd1**2*(r + s - 1)*(4*C*(35*r + 71*s - 53) - 211*r - 331*s + 271) - 44*D1**2*bdd1*f*(r + s - 1)*(6*C*(r - s - 5) - 59*r - 103*s + 75) - 5*D1**2*(f*(fd*(4*C*(225*r**2 + r*(654*s - 368) + 429*s**2 - 504*s + 218) - 303*r**2 + 6*r*(77*s + 8) + 765*s**2 - 664*s + 154) - fdd*(4*C*(195*r**2 + r*(558*s - 316) + 363*s**2 - 428*s + 186) + 129*r**2 + 6*r*(143*s - 62) + 729*s**2 - 772*s + 286)) - 2*fd**2*(4*C*(195*r**2 + r*(558*s - 316) + 363*s**2 - 428*s + 93) + 129*r**2 + 6*r*(143*s - 62) + 729*s**2 - 772*s + 143)) + 44*D1*bd1*(D1*(f*(r + s - 1)*(12*C*(r - s - 3) - 49*r - 113*s + 63) + 2*fd*(-r**2*(12*C - 118) + 3*r*(8*C + 108*s - 69) + s**2*(12*C + 206) + s*(6*C - 273) + 81)) + 4*Dd*f*(-3*C*(4*r**2 - 13*r - 4*s**2 - 7*s + 5) + 118*r**2 + 12*r*(27*s - 17) + 206*s**2 - 270*s + 78)) - 10*D1*f*(Dd*(f*(4*C*(150*r**2 + 4*r*(109*s - 46) + 286*s**2 - 252*s + 109) - 202*r**2 + 4*r*(77*s + 6) + 510*s**2 - 332*s + 77) - 2*fd*(4*C*(390*r**2 + r*(1116*s - 553) + 726*s**2 - 749*s + 186) + 258*r**2 + 3*r*(572*s - 217) + 1458*s**2 - 1351*s + 286)) - Ddd*f*(4*C*(130*r**2 + 2*r*(186*s - 79) + 242*s**2 - 214*s + 93) + 86*r**2 + 2*r*(286*s - 93) + 486*s**2 - 386*s + 143)) + 10*Dd**2*f**2*(12*C*(130*r**2 + 2*r*(186*s - 79) + 242*s**2 - 214*s + 31) + 258*r**2 + 6*r*(286*s - 93) + 1458*s**2 - 1158*s + 143)))/(231*d**2*k3**4) + 8*D1**2*Pk1*Pk2*ct**3*k1*st**2*(429*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 6*fd*(s - 1)**2 - 3*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(-5*fd*(8*s**2 - 6*s + 1) + 12*s**2 - 6*s + 3) - 3*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 3)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 3)*(2*s - 1)) + 13*b1*(D1**2*(10*f**2*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + f*(-500*fd**2*s*(3*s - 2) - 66*fd*(s**2*(20*bd1 - 6) + s*(6 - 10*bd1) - 3) - 99*fdd*(2*s**2 - 2*s + 1) - 99*s**2*(-4*bd1 + 2*bdd1)) - 198*fd*s*(2*bd1 + fd)*(s - 1)) + D1*f*(2*Dd*(250*f**2*(4*s**2 - 2*s + 1) + f*(-250*fd*(12*s**2 - 7*s + 1) - 33*s**2*(40*bd1 - 12) - 33*s*(6 - 10*bd1) + 99) - (396*s - 99)*(2*bd1*s + fd*(2*s - 1))) - Ddd*f*(250*f + 99)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(250*f + 99)*(2*s - 1)) + f*(D1**2*(-2574*bd1*s*(bd1*s + fd*(2*s - 1)) + 25*f**2*(98*fd*(4*s**2 - 2*s + 1) - 49*fdd*(4*s**2 - 2*s + 1) + s**2*(260*bd1 - 130*bdd1)) + f*s*(-4290*bd1**2*s - 6500*bd1*fd*(3*s - 1) + 2574*bd1*s - 1287*bdd1*s - 7350*fd**2*(2*s - 1))) + D1*f*(2574*Dd*bd1*s*(1 - 4*s) + 2450*Dd*f**2*(4*s**2 - 2*s + 1) - 50*Dd*f*(4*s - 1)*(130*bd1*s + 49*fd*(4*s - 1)) - 1225*Ddd*f**2*(4*s**2 - 2*s + 1)) - 7350*Dd**2*f**3*s*(2*s - 1)))/(3003*d**2*k2**3) + 4*D1**2*Pk1*Pk2*ct**3*k1*(66*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(6*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 28) + s*(6*fd - 14) + 7) - D1*Ddd*(6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(6*f + 7)*(2*s - 1)) + 33*b1**2*(-2*D1**2*bdd1*(6*f + 7)*(3*s**2 - 2*s + 1) - 52*D1**2*f*fd*s**2 + 132*D1**2*f*fd*s - 66*D1**2*f*fd + 44*D1**2*f*fdd*s**2 - 84*D1**2*f*fdd*s + 42*D1**2*f*fdd + 44*D1**2*fd**2*s**2 - 84*D1**2*fd**2*s - 49*D1**2*fd*s**2 + 146*D1**2*fd*s - 73*D1**2*fd + 35*D1**2*fdd*s**2 - 94*D1**2*fdd*s + 47*D1**2*fdd - 104*D1*Dd*f**2*s**2 + 52*D1*Dd*f**2*s - 26*D1*Dd*f**2 + 352*D1*Dd*f*fd*s**2 - 424*D1*Dd*f*fd*s + 84*D1*Dd*f*fd - 196*D1*Dd*f*s**2 + 98*D1*Dd*f*s - 49*D1*Dd*f + 280*D1*Dd*fd*s**2 - 446*D1*Dd*fd*s + 94*D1*Dd*fd + 88*D1*Ddd*f**2*s**2 - 44*D1*Ddd*f**2*s + 22*D1*Ddd*f**2 + 140*D1*Ddd*f*s**2 - 70*D1*Ddd*f*s + 35*D1*Ddd*f + 4*D1*bd1*(D1*(6*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 21) + s*(6*fd - 14) + 7) - Dd*(6*f + 7)*(12*s**2 - 7*s + 1)) + 264*Dd**2*f**2*s**2 - 132*Dd**2*f**2*s + 420*Dd**2*f*s**2 - 210*Dd**2*f*s) - 2*b1*(66*D1**2*bd1**2*s*(6*f + 7)*(3*s - 2) - 33*D1**2*bdd1*f*(2*f*(11*s**2 + 10*s - 5) + 35*s**2 + 12*s - 6) + 4605*D1**2*f**2*fd*s**2 - 3630*D1**2*f**2*fd*s + 1815*D1**2*f**2*fd - 3045*D1**2*f**2*fdd*s**2 + 2310*D1**2*f**2*fdd*s - 1155*D1**2*f**2*fdd - 6090*D1**2*f*fd**2*s**2 + 4620*D1**2*f*fd**2*s + 2046*D1**2*f*fd*s**2 - 2046*D1**2*f*fd*s + 1023*D1**2*f*fd - 1320*D1**2*f*fdd*s**2 + 1320*D1**2*f*fdd*s - 660*D1**2*f*fdd - 1320*D1**2*fd**2*s**2 + 1320*D1**2*fd**2*s + 6140*D1*Dd*f**3*s**2 - 3070*D1*Dd*f**3*s + 1535*D1*Dd*f**3 - 24360*D1*Dd*f**2*fd*s**2 + 15330*D1*Dd*f**2*fd*s - 2310*D1*Dd*f**2*fd + 4092*D1*Dd*f**2*s**2 - 2046*D1*Dd*f**2*s + 1023*D1*Dd*f**2 - 10560*D1*Dd*f*fd*s**2 + 7920*D1*Dd*f*fd*s - 1320*D1*Dd*f*fd - 4060*D1*Ddd*f**3*s**2 + 2030*D1*Ddd*f**3*s - 1015*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*s**2 + 1320*D1*Ddd*f**2*s - 660*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f**2*(26*s**2 + 40*s - 20) + f*(s**2*(49 - 88*fd) + s*(44*fd + 24) - 12) + 2*fd*s*(41 - 35*s)) - 2*Dd*f*(4*s - 1)*(2*f*(11*s + 5) + 35*s + 6)) - 12180*Dd**2*f**3*s**2 + 6090*Dd**2*f**3*s - 7920*Dd**2*f**2*s**2 + 3960*Dd**2*f**2*s) + 2*f*(33*D1**2*bd1**2*s*(f*(22*s + 20) + 35*s + 12) - D1*bd1*(D1*(5*f**2*(307*s**2 + 112*s - 56) + 3*f*s*(-70*fd*(29*s - 7) + 341*s) + 1320*fd*s*(1 - 2*s)) - 10*Dd*f*(4*s - 1)*(7*f*(29*s + 4) + 132*s)) + 5*f*(D1**2*bdd1*(7*f*(29*s**2 + 8*s - 4) + 132*s**2) - 14*D1**2*(f*(11*fd - 7*fdd)*(4*s**2 - 2*s + 1) + 42*fd**2*s*(1 - 2*s)) - 14*D1*f*(11*Dd*f*(4*s**2 - 2*s + 1) - 14*Dd*fd*(1 - 4*s)**2 - 7*Ddd*f*(4*s**2 - 2*s + 1)) - 588*Dd**2*f**2*s*(1 - 2*s))))/(693*d**2*k2**3) + 8*D1**2*Pk1*Pk2*ct**3*k2**5*st**2*(D1*f*(-2*D1*bd1**2*(r + s - 1)**2 + bd1*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 4*Dd*f*(2*r + 2*s - 1)) - f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-2*D1**2*bdd1*f*(r + s - 1)**2 + 2*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 4*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 16*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 16*D1*Dd*f*fd*s - 4*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 4*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + 4*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 12*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 12*Dd**2*f**2*s - 2*Dd**2*f**2))/(7*d**2*k1*k3**6) - 2*D1**2*Pk1*Pk2*ct**3*k2**3*st**2*(132*b1**2*(C - 1)*(D1**2*r*(fd + 3*fdd)*(r + s) + D1*(Dd*(f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(8*r**2 + 8*r*s - 3*r - s)) + 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 33*b1*(8*C*D1**2*f*fd*r**2 + 8*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r + 20*C*D1**2*f*fd*s - 20*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 24*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 24*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s + 16*C*D1*Dd*f**2*r**2 + 16*C*D1*Dd*f**2*r*s - 12*C*D1*Dd*f**2*r - 4*C*D1*Dd*f**2*s + 4*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 192*C*D1*Dd*f*fd*r*s - 168*C*D1*Dd*f*fd*r - 72*C*D1*Dd*f*fd*s + 36*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 48*C*D1*Ddd*f**2*r*s - 36*C*D1*Ddd*f**2*r - 12*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 144*C*Dd**2*f**2*r*s - 108*C*Dd**2*f**2*r - 36*C*Dd**2*f**2*s + 12*C*Dd**2*f**2 + 12*D1**2*bdd1*f*(C - 1)*(2*r - 1)*(r + s - 1) + 22*D1**2*f*fd*r**2 + 116*D1**2*f*fd*r*s - 78*D1**2*f*fd*r + 94*D1**2*f*fd*s**2 - 114*D1**2*f*fd*s + 67*D1**2*f*fd - 42*D1**2*f*fdd*r**2 - 116*D1**2*f*fdd*r*s + 70*D1**2*f*fdd*r - 74*D1**2*f*fdd*s**2 + 86*D1**2*f*fdd*s - 49*D1**2*f*fdd - 42*D1**2*fd**2*r**2 - 116*D1**2*fd**2*r*s + 70*D1**2*fd**2*r - 74*D1**2*fd**2*s**2 + 86*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 232*D1*Dd*f**2*r*s - 80*D1*Dd*f**2*r + 188*D1*Dd*f**2*s**2 - 152*D1*Dd*f**2*s + 58*D1*Dd*f**2 - 336*D1*Dd*f*fd*r**2 - 928*D1*Dd*f*fd*r*s + 480*D1*Dd*f*fd*r - 592*D1*Dd*f*fd*s**2 + 608*D1*Dd*f*fd*s - 156*D1*Dd*f*fd - 84*D1*Ddd*f**2*r**2 - 232*D1*Ddd*f**2*r*s + 100*D1*Ddd*f**2*r - 148*D1*Ddd*f**2*s**2 + 132*D1*Ddd*f**2*s - 58*D1*Ddd*f**2 + 4*D1*bd1*(C - 1)*(D1*(f*(2*r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 3*r - s)) + 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 252*Dd**2*f**2*r**2 - 696*Dd**2*f**2*r*s + 300*Dd**2*f**2*r - 444*Dd**2*f**2*s**2 + 396*Dd**2*f**2*s - 58*Dd**2*f**2) + f*(2712*C*D1**2*f*fd*r**2 + 2712*C*D1**2*f*fd*r*s - 2712*C*D1**2*f*fd*r - 904*C*D1**2*f*fd*s + 904*C*D1**2*f*fd - 960*C*D1**2*f*fdd*r**2 - 960*C*D1**2*f*fdd*r*s + 960*C*D1**2*f*fdd*r + 320*C*D1**2*f*fdd*s - 320*C*D1**2*f*fdd - 1920*C*D1**2*fd**2*r**2 - 1920*C*D1**2*fd**2*r*s + 1920*C*D1**2*fd**2*r + 640*C*D1**2*fd**2*s - 320*C*D1**2*fd**2 + 3616*C*D1*Dd*f**2*r**2 + 3616*C*D1*Dd*f**2*r*s - 2712*C*D1*Dd*f**2*r - 904*C*D1*Dd*f**2*s + 904*C*D1*Dd*f**2 - 7680*C*D1*Dd*f*fd*r**2 - 7680*C*D1*Dd*f*fd*r*s + 6720*C*D1*Dd*f*fd*r + 2240*C*D1*Dd*f*fd*s - 1280*C*D1*Dd*f*fd - 1280*C*D1*Ddd*f**2*r**2 - 1280*C*D1*Ddd*f**2*r*s + 960*C*D1*Ddd*f**2*r + 320*C*D1*Ddd*f**2*s - 320*C*D1*Ddd*f**2 - 3840*C*Dd**2*f**2*r**2 - 3840*C*Dd**2*f**2*r*s + 2880*C*Dd**2*f**2*r + 960*C*Dd**2*f**2*s - 320*C*Dd**2*f**2 + 396*D1**2*bd1**2*(C - 1)*(2*r - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(r*(12*C - 21) - 37*s + 9) - 63*D1**2*f*fd*r**2 + 4110*D1**2*f*fd*r*s - 1328*D1**2*f*fd*r + 4173*D1**2*f*fd*s**2 - 4152*D1**2*f*fd*s + 1370*D1**2*f*fd - 1899*D1**2*f*fdd*r**2 - 5322*D1**2*f*fdd*r*s + 3040*D1**2*f*fdd*r - 3423*D1**2*f*fdd*s**2 + 4056*D1**2*f*fdd*s - 1774*D1**2*f*fdd - 3798*D1**2*fd**2*r**2 - 10644*D1**2*fd**2*r*s + 6080*D1**2*fd**2*r - 6846*D1**2*fd**2*s**2 + 8112*D1**2*fd**2*s - 1774*D1**2*fd**2 - 84*D1*Dd*f**2*r**2 + 5480*D1*Dd*f**2*r*s - 1328*D1*Dd*f**2*r + 5564*D1*Dd*f**2*s**2 - 4152*D1*Dd*f**2*s + 1370*D1*Dd*f**2 - 15192*D1*Dd*f*fd*r**2 - 42576*D1*Dd*f*fd*r*s + 21280*D1*Dd*f*fd*r - 27384*D1*Dd*f*fd*s**2 + 28392*D1*Dd*f*fd*s - 7096*D1*Dd*f*fd - 2532*D1*Ddd*f**2*r**2 - 7096*D1*Ddd*f**2*r*s + 3040*D1*Ddd*f**2*r - 4564*D1*Ddd*f**2*s**2 + 4056*D1*Ddd*f**2*s - 1774*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f*(r + s - 1)*(4*C*(r - 6) + 11*r + 47*s + 9) + 2*fd*(6*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 42*r**2 - 116*r*s + 65*r - 74*s**2 + 89*s - 29)) + 4*Dd*f*(3*C*(8*r**2 + 8*r*s - 7*r - s + 1) - 42*r**2 - 116*r*s + 55*r - 74*s**2 + 79*s - 19)) - 7596*Dd**2*f**2*r**2 - 21288*Dd**2*f**2*r*s + 9120*Dd**2*f**2*r - 13692*Dd**2*f**2*s**2 + 12168*Dd**2*f**2*s - 1774*Dd**2*f**2))/(693*d**2*k1*k3**4) - 2*D1**2*Pk1*Pk2*ct**3*k2**3*(2*D1*f*(D1*bd1**2*(r**2 + r*(22 - 46*s) - 47*s**2 + 70*s - 23) + bd1*(D1*(f*(r + s - 1)*(r*(32*C - 15) + 13*s - 1) - 2*fd*(C*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 12*r**2 + 52*r*s - 32*r + 40*s**2 - 53*s + 13)) - 2*Dd*f*(2*C*(8*r**2 + 8*r*s - 7*r - s + 1) + 24*r**2 + 104*r*s - 71*r + 80*s**2 - 113*s + 33)) - 2*f*(D1*bdd1*(r + s - 1)*(r*(2*C + 3) + 10*s - 10) + 5*D1*fd*(3*r**2 + 3*r*(s - 1) - s + 1) + 5*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1))) + b1**2*(D1**2*(r + s)*(fd*r*(56*C - 37) + 31*fd*s + fdd*(r - 47*s)) + 2*D1*(Dd*(f*(28*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 74*r**2 - 12*r*s + 40*r + 62*s**2 - 28*s - 3) + 2*fd*(2*r**2 + r*(11 - 92*s) + s*(35 - 94*s))) + Ddd*f*(2*r**2 + r*(22 - 92*s) - 94*s**2 + 70*s - 23)) + 2*Dd**2*f*(6*r**2 + r*(66 - 276*s) - 282*s**2 + 210*s - 23)) + 2*b1*(64*C*D1**2*f*fd*r**2 + 64*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s + 32*C*D1**2*f*fd - 8*C*D1**2*f*fdd*r**2 - 8*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*r + 4*C*D1**2*f*fdd*s - 4*C*D1**2*f*fdd - 8*C*D1**2*fd**2*r**2 - 8*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*r + 4*C*D1**2*fd**2*s + 128*C*D1*Dd*f**2*r**2 + 128*C*D1*Dd*f**2*r*s - 96*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s + 32*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r**2 - 64*C*D1*Dd*f*fd*r*s + 56*C*D1*Dd*f*fd*r + 24*C*D1*Dd*f*fd*s - 12*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 - 16*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r + 4*C*D1*Ddd*f**2*s - 4*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 - 48*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r + 12*C*Dd**2*f**2*s - 4*C*Dd**2*f**2 + D1**2*bdd1*f*(r**2 - 46*r*s + 22*r - 47*s**2 + 70*s - 23) - 30*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 18*D1**2*f*fd*r + 26*D1**2*f*fd*s**2 - 10*D1**2*f*fd*s - 3*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 52*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 40*D1**2*f*fdd*s**2 + 26*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 52*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 40*D1**2*fd**2*s**2 + 26*D1**2*fd**2*s - 60*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 32*D1*Dd*f**2*r + 52*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s - 2*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 416*D1*Dd*f*fd*r*s + 124*D1*Dd*f*fd*r - 320*D1*Dd*f*fd*s**2 + 236*D1*Dd*f*fd*s - 38*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 - 104*D1*Ddd*f**2*r*s + 38*D1*Ddd*f**2*r - 80*D1*Ddd*f**2*s**2 + 66*D1*Ddd*f**2*s - 26*D1*Ddd*f**2 + D1*bd1*(D1*(f*(r + s - 1)*(28*C*(2*r - 1) - 37*r + 31*s + 3) + 2*fd*(r**2 + r*(11 - 46*s) + s*(35 - 47*s))) + 4*Dd*f*(2*r**2 + r*(33 - 92*s) - 94*s**2 + 105*s - 23)) - 72*Dd**2*f**2*r**2 - 312*Dd**2*f**2*r*s + 114*Dd**2*f**2*r - 240*Dd**2*f**2*s**2 + 198*Dd**2*f**2*s - 26*Dd**2*f**2))/(21*d**2*k1*k3**4) - 16*D1**2*Pk1*Pk2*ct**2*f*k1**2*k2**2*st**4*(33*D1**2*bd1*f*(C - 2)*(r + s - 1)**2 + 33*D1*b1*(C - 2)*(D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (6*C - 16)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 2*D1*f*(2*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) - Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(231*d**2*k3**6) + 16*D1**2*Pk1*Pk2*ct**2*f*k1**2*st**4*(D1**2*(f*(11*bd1*s*(r + s - 1) - fd*(4*C - 14)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(2*C - 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(2*C - 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*b1*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - D1*f*(2*C - 7)*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(2*C - 7)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1))/(77*d**2*k3**4) - D1**2*Pk1*Pk2*ct**2*f*k1**2*st**4*(16*C - 96)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k2**2*k3**2) + 4*D1**2*Pk1*Pk2*ct**2*f*k2**4*st**4*(66*D1**2*bd1*f*(r - 1)*(r + s - 1) + 5*D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + 66*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 5*D1*f*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-24*r**2 - 24*r*s + 21*r + 7*s - 4)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + 5*Dd**2*f**2*(-12*r**2 + r*(9 - 12*s) + 3*s - 1))/(231*d**2*k1**2*k3**4) - 8*D1**2*Pk1*Pk2*ct**2*k1**4*st**2*(66*C*D1**2*b1*f*fd*r**2 + 132*C*D1**2*b1*f*fd*r*s - 66*C*D1**2*b1*f*fd*r + 66*C*D1**2*b1*f*fd*s**2 - 66*C*D1**2*b1*f*fd*s + 33*C*D1**2*b1*f*fd - 66*C*D1**2*b1*f*fdd*r**2 - 132*C*D1**2*b1*f*fdd*r*s + 66*C*D1**2*b1*f*fdd*r - 66*C*D1**2*b1*f*fdd*s**2 + 66*C*D1**2*b1*f*fdd*s - 33*C*D1**2*b1*f*fdd - 66*C*D1**2*b1*fd**2*r**2 - 132*C*D1**2*b1*fd**2*r*s + 66*C*D1**2*b1*fd**2*r - 66*C*D1**2*b1*fd**2*s**2 + 66*C*D1**2*b1*fd**2*s + 51*C*D1**2*f**2*fd*r**2 + 102*C*D1**2*f**2*fd*r*s - 68*C*D1**2*f**2*fd*r + 51*C*D1**2*f**2*fd*s**2 - 68*C*D1**2*f**2*fd*s + 34*C*D1**2*f**2*fd - 75*C*D1**2*f**2*fdd*r**2 - 150*C*D1**2*f**2*fdd*r*s + 100*C*D1**2*f**2*fdd*r - 75*C*D1**2*f**2*fdd*s**2 + 100*C*D1**2*f**2*fdd*s - 50*C*D1**2*f**2*fdd - 150*C*D1**2*f*fd**2*r**2 - 300*C*D1**2*f*fd**2*r*s + 200*C*D1**2*f*fd**2*r - 150*C*D1**2*f*fd**2*s**2 + 200*C*D1**2*f*fd**2*s - 50*C*D1**2*f*fd**2 + 132*C*D1*Dd*b1*f**2*r**2 + 264*C*D1*Dd*b1*f**2*r*s - 132*C*D1*Dd*b1*f**2*r + 132*C*D1*Dd*b1*f**2*s**2 - 132*C*D1*Dd*b1*f**2*s + 66*C*D1*Dd*b1*f**2 - 528*C*D1*Dd*b1*f*fd*r**2 - 1056*C*D1*Dd*b1*f*fd*r*s + 528*C*D1*Dd*b1*f*fd*r - 528*C*D1*Dd*b1*f*fd*s**2 + 528*C*D1*Dd*b1*f*fd*s - 132*C*D1*Dd*b1*f*fd + 68*C*D1*Dd*f**3*r**2 + 136*C*D1*Dd*f**3*r*s - 68*C*D1*Dd*f**3*r + 68*C*D1*Dd*f**3*s**2 - 68*C*D1*Dd*f**3*s + 34*C*D1*Dd*f**3 - 600*C*D1*Dd*f**2*fd*r**2 - 1200*C*D1*Dd*f**2*fd*r*s + 700*C*D1*Dd*f**2*fd*r - 600*C*D1*Dd*f**2*fd*s**2 + 700*C*D1*Dd*f**2*fd*s - 200*C*D1*Dd*f**2*fd - 132*C*D1*Ddd*b1*f**2*r**2 - 264*C*D1*Ddd*b1*f**2*r*s + 132*C*D1*Ddd*b1*f**2*r - 132*C*D1*Ddd*b1*f**2*s**2 + 132*C*D1*Ddd*b1*f**2*s - 66*C*D1*Ddd*b1*f**2 - 100*C*D1*Ddd*f**3*r**2 - 200*C*D1*Ddd*f**3*r*s + 100*C*D1*Ddd*f**3*r - 100*C*D1*Ddd*f**3*s**2 + 100*C*D1*Ddd*f**3*s - 50*C*D1*Ddd*f**3 - 396*C*Dd**2*b1*f**2*r**2 - 792*C*Dd**2*b1*f**2*r*s + 396*C*Dd**2*b1*f**2*r - 396*C*Dd**2*b1*f**2*s**2 + 396*C*Dd**2*b1*f**2*s - 66*C*Dd**2*b1*f**2 - 300*C*Dd**2*f**3*r**2 - 600*C*Dd**2*f**3*r*s + 300*C*Dd**2*f**3*r - 300*C*Dd**2*f**3*s**2 + 300*C*Dd**2*f**3*s - 50*C*Dd**2*f**3 - 594*D1**2*b1*f*fd*r**2 - 1188*D1**2*b1*f*fd*r*s + 594*D1**2*b1*f*fd*r - 594*D1**2*b1*f*fd*s**2 + 594*D1**2*b1*f*fd*s - 297*D1**2*b1*f*fd + 462*D1**2*b1*f*fdd*r**2 + 924*D1**2*b1*f*fdd*r*s - 462*D1**2*b1*f*fdd*r + 462*D1**2*b1*f*fdd*s**2 - 462*D1**2*b1*f*fdd*s + 231*D1**2*b1*f*fdd + 462*D1**2*b1*fd**2*r**2 + 924*D1**2*b1*fd**2*r*s - 462*D1**2*b1*fd**2*r + 462*D1**2*b1*fd**2*s**2 - 462*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(C - 7)*(r + s - 1)**2 - 555*D1**2*f**2*fd*r**2 - 1110*D1**2*f**2*fd*r*s + 740*D1**2*f**2*fd*r - 555*D1**2*f**2*fd*s**2 + 740*D1**2*f**2*fd*s - 370*D1**2*f**2*fd + 525*D1**2*f**2*fdd*r**2 + 1050*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 525*D1**2*f**2*fdd*s**2 - 700*D1**2*f**2*fdd*s + 350*D1**2*f**2*fdd + 1050*D1**2*f*fd**2*r**2 + 2100*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 1050*D1**2*f*fd**2*s**2 - 1400*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 - 1188*D1*Dd*b1*f**2*r**2 - 2376*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 1188*D1*Dd*b1*f**2*s**2 + 1188*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 + 3696*D1*Dd*b1*f*fd*r**2 + 7392*D1*Dd*b1*f*fd*r*s - 3696*D1*Dd*b1*f*fd*r + 3696*D1*Dd*b1*f*fd*s**2 - 3696*D1*Dd*b1*f*fd*s + 924*D1*Dd*b1*f*fd - 740*D1*Dd*f**3*r**2 - 1480*D1*Dd*f**3*r*s + 740*D1*Dd*f**3*r - 740*D1*Dd*f**3*s**2 + 740*D1*Dd*f**3*s - 370*D1*Dd*f**3 + 4200*D1*Dd*f**2*fd*r**2 + 8400*D1*Dd*f**2*fd*r*s - 4900*D1*Dd*f**2*fd*r + 4200*D1*Dd*f**2*fd*s**2 - 4900*D1*Dd*f**2*fd*s + 1400*D1*Dd*f**2*fd + 924*D1*Ddd*b1*f**2*r**2 + 1848*D1*Ddd*b1*f**2*r*s - 924*D1*Ddd*b1*f**2*r + 924*D1*Ddd*b1*f**2*s**2 - 924*D1*Ddd*b1*f**2*s + 462*D1*Ddd*b1*f**2 + 700*D1*Ddd*f**3*r**2 + 1400*D1*Ddd*f**3*r*s - 700*D1*Ddd*f**3*r + 700*D1*Ddd*f**3*s**2 - 700*D1*Ddd*f**3*s + 350*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(C - 9)*(r + s - 1) - D1*fd*(2*C - 14)*(2*r + 2*s - 1) - Dd*f*(4*C - 28)*(2*r + 2*s - 1)) + 2772*Dd**2*b1*f**2*r**2 + 5544*Dd**2*b1*f**2*r*s - 2772*Dd**2*b1*f**2*r + 2772*Dd**2*b1*f**2*s**2 - 2772*Dd**2*b1*f**2*s + 462*Dd**2*b1*f**2 + 2100*Dd**2*f**3*r**2 + 4200*Dd**2*f**3*r*s - 2100*Dd**2*f**3*r + 2100*Dd**2*f**3*s**2 - 2100*Dd**2*f**3*s + 350*Dd**2*f**3)/(693*d**2*k3**6) - 16*D1**2*Pk1*Pk2*ct**2*k1**4*(33*b1**2*(C - 3)*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + 2*D1*(Dd*(5*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 12*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 33*b1*(-12*D1**2*bdd1*f*(C - 3)*(r + s - 1)**2 - 3*D1**2*(f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*bd1*(C - 3)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) - 6*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 5*fd*(2*r + 2*s - 1)**2) - 5*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 30*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + f*(5*C*(D1**2*(-f*(23*fd - 28*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 56*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 2*D1*f*(Dd*(23*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 56*fd*(6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) - 28*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 56*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) - 396*D1**2*bd1**2*(C - 3)*(r + s - 1)**2 + 495*D1**2*bdd1*f*(r + s - 1)**2 - 198*D1*bd1*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(2*r + 2*s - 1))))/(693*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct**2*k1**4*st**2*(11*b1*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 3*fd*(8*s - 3)*(2*r + 2*s - 1)) - 3*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(39*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 25*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 25*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 25*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k2**2*k3**4) + 4*D1**2*Pk1*Pk2*ct**2*k1**4*(66*b1**2*(D1**2*s*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(5*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + 6*fd*(-8*r*s + r + s*(3 - 8*s))) - 6*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 6*Dd**2*f*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 33*b1*(-12*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 16*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 16*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 16*D1**2*f*fd + 14*D1**2*f*fdd*r*s - 17*D1**2*f*fdd*r + 14*D1**2*f*fdd*s**2 - 24*D1**2*f*fdd*s + 17*D1**2*f*fdd + 14*D1**2*fd**2*r*s - 17*D1**2*fd**2*r + 14*D1**2*fd**2*s**2 - 24*D1**2*fd**2*s - 32*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r - 32*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 112*D1*Dd*f*fd*r*s - 82*D1*Dd*f*fd*r + 112*D1*Dd*f*fd*s**2 - 138*D1*Dd*f*fd*s + 41*D1*Dd*f*fd + 28*D1*Ddd*f**2*r*s - 7*D1*Ddd*f**2*r + 28*D1*Ddd*f**2*s**2 - 21*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 + 2*D1*bd1*(D1*(5*f*(2*s - 1)*(r + s - 1) + 6*fd*(-4*r*s + r + s*(3 - 4*s))) - 12*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 84*Dd**2*f**2*r*s - 21*Dd**2*f**2*r + 84*Dd**2*f**2*s**2 - 63*Dd**2*f**2*s + 7*Dd**2*f**2) + f*(-396*D1**2*bd1**2*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(7*s + 10)*(r + s - 1) - 5*D1**2*(f*(89*fd - 94*fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 94*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 33*D1*bd1*(D1*(8*f*(s + 1)*(r + s - 1) - fd*(28*r*s + 3*r + 28*s**2 - 18*s + 7)) + Dd*f*(-r*(56*s + 33) - 56*s**2 + 9*s + 13)) - 5*D1*f*(Dd*(89*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 94*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 94*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 470*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k2**2*k3**4) - 8*D1**2*Pk1*Pk2*ct**2*k1**2*k2**2*st**2*(11*b1**2*(C - 2)*(D1**2*(19*fd - 6*fdd)*(r + s)**2 + 2*D1*(Dd*(19*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 12*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 22*b1*(-44*C*D1**2*f*fd*r**2 - 88*C*D1**2*f*fd*r*s + 44*C*D1**2*f*fd*r - 44*C*D1**2*f*fd*s**2 + 44*C*D1**2*f*fd*s - 22*C*D1**2*f*fd + 30*C*D1**2*f*fdd*r**2 + 60*C*D1**2*f*fdd*r*s - 30*C*D1**2*f*fdd*r + 30*C*D1**2*f*fdd*s**2 - 30*C*D1**2*f*fdd*s + 15*C*D1**2*f*fdd + 30*C*D1**2*fd**2*r**2 + 60*C*D1**2*fd**2*r*s - 30*C*D1**2*fd**2*r + 30*C*D1**2*fd**2*s**2 - 30*C*D1**2*fd**2*s - 88*C*D1*Dd*f**2*r**2 - 176*C*D1*Dd*f**2*r*s + 88*C*D1*Dd*f**2*r - 88*C*D1*Dd*f**2*s**2 + 88*C*D1*Dd*f**2*s - 44*C*D1*Dd*f**2 + 240*C*D1*Dd*f*fd*r**2 + 480*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 240*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 60*C*D1*Ddd*f**2*r**2 + 120*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 60*C*D1*Ddd*f**2*s**2 - 60*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 180*C*Dd**2*f**2*r**2 + 360*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 180*C*Dd**2*f**2*s**2 - 180*C*Dd**2*f**2*s + 30*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(C - 2)*(r + s - 1)**2 - 26*D1**2*f*fd*r**2 - 52*D1**2*f*fd*r*s + 26*D1**2*f*fd*r - 26*D1**2*f*fd*s**2 + 26*D1**2*f*fd*s - 13*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 36*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 36*D1**2*fd**2*r*s - 18*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 52*D1*Dd*f**2*r**2 - 104*D1*Dd*f**2*r*s + 52*D1*Dd*f**2*r - 52*D1*Dd*f**2*s**2 + 52*D1*Dd*f**2*s - 26*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 288*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 144*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 36*D1*Ddd*f**2*r**2 + 72*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + D1*bd1*(C - 2)*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) + 108*Dd**2*f**2*r**2 + 216*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 18*Dd**2*f**2) + f*(-1239*C*D1**2*f*fd*r**2 - 2478*C*D1**2*f*fd*r*s + 1652*C*D1**2*f*fd*r - 1239*C*D1**2*f*fd*s**2 + 1652*C*D1**2*f*fd*s - 826*C*D1**2*f*fd + 900*C*D1**2*f*fdd*r**2 + 1800*C*D1**2*f*fdd*r*s - 1200*C*D1**2*f*fdd*r + 900*C*D1**2*f*fdd*s**2 - 1200*C*D1**2*f*fdd*s + 600*C*D1**2*f*fdd + 1800*C*D1**2*fd**2*r**2 + 3600*C*D1**2*fd**2*r*s - 2400*C*D1**2*fd**2*r + 1800*C*D1**2*fd**2*s**2 - 2400*C*D1**2*fd**2*s + 600*C*D1**2*fd**2 - 1652*C*D1*Dd*f**2*r**2 - 3304*C*D1*Dd*f**2*r*s + 1652*C*D1*Dd*f**2*r - 1652*C*D1*Dd*f**2*s**2 + 1652*C*D1*Dd*f**2*s - 826*C*D1*Dd*f**2 + 7200*C*D1*Dd*f*fd*r**2 + 14400*C*D1*Dd*f*fd*r*s - 8400*C*D1*Dd*f*fd*r + 7200*C*D1*Dd*f*fd*s**2 - 8400*C*D1*Dd*f*fd*s + 2400*C*D1*Dd*f*fd + 1200*C*D1*Ddd*f**2*r**2 + 2400*C*D1*Ddd*f**2*r*s - 1200*C*D1*Ddd*f**2*r + 1200*C*D1*Ddd*f**2*s**2 - 1200*C*D1*Ddd*f**2*s + 600*C*D1*Ddd*f**2 + 3600*C*Dd**2*f**2*r**2 + 7200*C*Dd**2*f**2*r*s - 3600*C*Dd**2*f**2*r + 3600*C*Dd**2*f**2*s**2 - 3600*C*Dd**2*f**2*s + 600*C*Dd**2*f**2 - 132*D1**2*bd1**2*(C - 2)*(r + s - 1)**2 + 66*D1**2*bdd1*f*(5*C + 3)*(r + s - 1)**2 - 36*D1**2*f*fd*r**2 - 72*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 48*D1**2*f*fd*s - 24*D1**2*f*fd + 150*D1**2*f*fdd*r**2 + 300*D1**2*f*fdd*r*s - 200*D1**2*f*fdd*r + 150*D1**2*f*fdd*s**2 - 200*D1**2*f*fdd*s + 100*D1**2*f*fdd + 300*D1**2*fd**2*r**2 + 600*D1**2*fd**2*r*s - 400*D1**2*fd**2*r + 300*D1**2*fd**2*s**2 - 400*D1**2*fd**2*s + 100*D1**2*fd**2 - 48*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s + 48*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 48*D1*Dd*f**2*s - 24*D1*Dd*f**2 + 1200*D1*Dd*f*fd*r**2 + 2400*D1*Dd*f*fd*r*s - 1400*D1*Dd*f*fd*r + 1200*D1*Dd*f*fd*s**2 - 1400*D1*Dd*f*fd*s + 400*D1*Dd*f*fd + 200*D1*Ddd*f**2*r**2 + 400*D1*Ddd*f**2*r*s - 200*D1*Ddd*f**2*r + 200*D1*Ddd*f**2*s**2 - 200*D1*Ddd*f**2*s + 100*D1*Ddd*f**2 - 22*D1*bd1*(r + s - 1)*(D1*f*(22*C + 13)*(r + s - 1) - D1*fd*(30*C + 18)*(2*r + 2*s - 1) - Dd*f*(60*C + 36)*(2*r + 2*s - 1)) + 600*Dd**2*f**2*r**2 + 1200*Dd**2*f**2*r*s - 600*Dd**2*f**2*r + 600*Dd**2*f**2*s**2 - 600*Dd**2*f**2*s + 100*Dd**2*f**2))/(231*d**2*k3**6) + 16*D1**2*Pk1*Pk2*ct**2*k1**2*k2**2*(D1*f*(-24*D1*bd1**2*(3*C + 1)*(r + s - 1)**2 + 2*bd1*(r + s - 1)*(D1*f*(15*C - 2)*(r + s - 1) - D1*fd*(30*C + 10)*(2*r + 2*s - 1) - Dd*f*(60*C + 20)*(2*r + 2*s - 1)) - 5*f*(C*D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*C*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*D1*bdd1*(3*C + 1)*(r + s - 1)**2)) + 4*b1**2*(D1**2*(r + s)**2*(-9*C*fdd + fd*(11*C - 1) - 3*fdd) + 2*D1*(Dd*(f*(11*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(18*C + 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(-9*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(18*C + 6)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 2*b1*(30*C*D1**2*f*fd*r**2 + 60*C*D1**2*f*fd*r*s - 30*C*D1**2*f*fd*r + 30*C*D1**2*f*fd*s**2 - 30*C*D1**2*f*fd*s + 15*C*D1**2*f*fd - 30*C*D1**2*f*fdd*r**2 - 60*C*D1**2*f*fdd*r*s + 30*C*D1**2*f*fdd*r - 30*C*D1**2*f*fdd*s**2 + 30*C*D1**2*f*fdd*s - 15*C*D1**2*f*fdd - 30*C*D1**2*fd**2*r**2 - 60*C*D1**2*fd**2*r*s + 30*C*D1**2*fd**2*r - 30*C*D1**2*fd**2*s**2 + 30*C*D1**2*fd**2*s + 60*C*D1*Dd*f**2*r**2 + 120*C*D1*Dd*f**2*r*s - 60*C*D1*Dd*f**2*r + 60*C*D1*Dd*f**2*s**2 - 60*C*D1*Dd*f**2*s + 30*C*D1*Dd*f**2 - 240*C*D1*Dd*f*fd*r**2 - 480*C*D1*Dd*f*fd*r*s + 240*C*D1*Dd*f*fd*r - 240*C*D1*Dd*f*fd*s**2 + 240*C*D1*Dd*f*fd*s - 60*C*D1*Dd*f*fd - 60*C*D1*Ddd*f**2*r**2 - 120*C*D1*Ddd*f**2*r*s + 60*C*D1*Ddd*f**2*r - 60*C*D1*Ddd*f**2*s**2 + 60*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 180*C*Dd**2*f**2*r**2 - 360*C*Dd**2*f**2*r*s + 180*C*Dd**2*f**2*r - 180*C*Dd**2*f**2*s**2 + 180*C*Dd**2*f**2*s - 30*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(3*C + 1)*(r + s - 1)**2 - 4*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 2*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s - 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 8*D1*Dd*f**2*s - 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 80*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 20*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 + 4*D1*bd1*(r + s - 1)*(D1*f*(11*C - 1)*(r + s - 1) - D1*fd*(18*C + 6)*(r + s) - Dd*f*(36*C + 12)*(2*r + 2*s - 1)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 60*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k3**6) - 2*D1**2*Pk1*Pk2*ct**2*k1**2*st**2*(66*b1**2*(D1**2*s*(r + s)*(fd*(12*C - 37) + fdd*(15 - 6*C)) + D1*(Dd*(f*(12*C - 37)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C - 15)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(15 - 6*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(6*C - 15)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 33*b1*(-38*C*D1**2*f*fd*r**2 - 364*C*D1**2*f*fd*r*s + 206*C*D1**2*f*fd*r - 326*C*D1**2*f*fd*s**2 + 350*C*D1**2*f*fd*s - 187*C*D1**2*f*fd + 26*C*D1**2*f*fdd*r**2 + 252*C*D1**2*f*fdd*r*s - 138*C*D1**2*f*fdd*r + 226*C*D1**2*f*fdd*s**2 - 238*C*D1**2*f*fdd*s + 125*C*D1**2*f*fdd + 26*C*D1**2*fd**2*r**2 + 252*C*D1**2*fd**2*r*s - 138*C*D1**2*fd**2*r + 226*C*D1**2*fd**2*s**2 - 238*C*D1**2*fd**2*s - 76*C*D1*Dd*f**2*r**2 - 728*C*D1*Dd*f**2*r*s + 220*C*D1*Dd*f**2*r - 652*C*D1*Dd*f**2*s**2 + 508*C*D1*Dd*f**2*s - 182*C*D1*Dd*f**2 + 208*C*D1*Dd*f*fd*r**2 + 2016*C*D1*Dd*f*fd*r*s - 856*C*D1*Dd*f*fd*r + 1808*C*D1*Dd*f*fd*s**2 - 1656*C*D1*Dd*f*fd*s + 376*C*D1*Dd*f*fd + 52*C*D1*Ddd*f**2*r**2 + 504*C*D1*Ddd*f**2*r*s - 152*C*D1*Ddd*f**2*r + 452*C*D1*Ddd*f**2*s**2 - 352*C*D1*Ddd*f**2*s + 126*C*D1*Ddd*f**2 + 156*C*Dd**2*f**2*r**2 + 1512*C*Dd**2*f**2*r*s - 456*C*Dd**2*f**2*r + 1356*C*Dd**2*f**2*s**2 - 1056*C*Dd**2*f**2*s + 126*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(2*C - 5)*(2*s - 1)*(r + s - 1) + 116*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 190*D1**2*f*fd*r + 148*D1**2*f*fd*s**2 - 206*D1**2*f*fd*s + 132*D1**2*f*fd - 92*D1**2*f*fdd*r**2 - 228*D1**2*f*fdd*r*s + 144*D1**2*f*fdd*r - 136*D1**2*f*fdd*s**2 + 166*D1**2*f*fdd*s - 98*D1**2*f*fdd - 92*D1**2*fd**2*r**2 - 228*D1**2*fd**2*r*s + 144*D1**2*fd**2*r - 136*D1**2*fd**2*s**2 + 166*D1**2*fd**2*s + 232*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 248*D1*Dd*f**2*r + 296*D1*Dd*f**2*s**2 - 280*D1*Dd*f**2*s + 132*D1*Dd*f**2 - 736*D1*Dd*f*fd*r**2 - 1824*D1*Dd*f*fd*r*s + 988*D1*Dd*f*fd*r - 1088*D1*Dd*f*fd*s**2 + 1164*D1*Dd*f*fd*s - 310*D1*Dd*f*fd - 184*D1*Ddd*f**2*r**2 - 456*D1*Ddd*f**2*r*s + 206*D1*Ddd*f**2*r - 272*D1*Ddd*f**2*s**2 + 250*D1*Ddd*f**2*s - 114*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(12*C - 37)*(2*s - 1)*(r + s - 1) - fd*(6*C - 15)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(30 - 12*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 552*Dd**2*f**2*r**2 - 1368*Dd**2*f**2*r*s + 618*Dd**2*f**2*r - 816*Dd**2*f**2*s**2 + 750*Dd**2*f**2*s - 114*Dd**2*f**2) + f*(-1689*C*D1**2*f*fd*r**2 - 15018*C*D1**2*f*fd*r*s + 6132*C*D1**2*f*fd*r - 13329*C*D1**2*f*fd*s**2 + 13892*C*D1**2*f*fd*s - 5006*C*D1**2*f*fd + 1191*C*D1**2*f*fdd*r**2 + 10974*C*D1**2*f*fdd*r*s - 4452*C*D1**2*f*fdd*r + 9783*C*D1**2*f*fdd*s**2 - 10180*C*D1**2*f*fdd*s + 3658*C*D1**2*f*fdd + 2382*C*D1**2*fd**2*r**2 + 21948*C*D1**2*fd**2*r*s - 8904*C*D1**2*fd**2*r + 19566*C*D1**2*fd**2*s**2 - 20360*C*D1**2*fd**2*s + 3658*C*D1**2*fd**2 - 2252*C*D1*Dd*f**2*r**2 - 20024*C*D1*Dd*f**2*r*s + 6132*C*D1*Dd*f**2*r - 17772*C*D1*Dd*f**2*s**2 + 13892*C*D1*Dd*f**2*s - 5006*C*D1*Dd*f**2 + 9528*C*D1*Dd*f*fd*r**2 + 87792*C*D1*Dd*f*fd*r*s - 31164*C*D1*Dd*f*fd*r + 78264*C*D1*Dd*f*fd*s**2 - 71260*C*D1*Dd*f*fd*s + 14632*C*D1*Dd*f*fd + 1588*C*D1*Ddd*f**2*r**2 + 14632*C*D1*Ddd*f**2*r*s - 4452*C*D1*Ddd*f**2*r + 13044*C*D1*Ddd*f**2*s**2 - 10180*C*D1*Ddd*f**2*s + 3658*C*D1*Ddd*f**2 + 4764*C*Dd**2*f**2*r**2 + 43896*C*Dd**2*f**2*r*s - 13356*C*Dd**2*f**2*r + 39132*C*Dd**2*f**2*s**2 - 30540*C*Dd**2*f**2*s + 3658*C*Dd**2*f**2 - 198*D1**2*bd1**2*(2*C - 5)*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(C*(13*r + 113*s - 1) - 46*r - 68*s + 16) + 5154*D1**2*f*fd*r**2 + 15918*D1**2*f*fd*r*s - 8742*D1**2*f*fd*r + 10764*D1**2*f*fd*s**2 - 12482*D1**2*f*fd*s + 5306*D1**2*f*fd - 4458*D1**2*f*fdd*r**2 - 13008*D1**2*f*fdd*r*s + 7308*D1**2*f*fdd*r - 8550*D1**2*f*fdd*s**2 + 10036*D1**2*f*fdd*s - 4336*D1**2*f*fdd - 8916*D1**2*fd**2*r**2 - 26016*D1**2*fd**2*r*s + 14616*D1**2*fd**2*r - 17100*D1**2*fd**2*s**2 + 20072*D1**2*fd**2*s - 4336*D1**2*fd**2 + 6872*D1*Dd*f**2*r**2 + 21224*D1*Dd*f**2*r*s - 8742*D1*Dd*f**2*r + 14352*D1*Dd*f**2*s**2 - 12482*D1*Dd*f**2*s + 5306*D1*Dd*f**2 - 35664*D1*Dd*f*fd*r**2 - 104064*D1*Dd*f*fd*r*s + 51156*D1*Dd*f*fd*r - 68400*D1*Dd*f*fd*s**2 + 70252*D1*Dd*f*fd*s - 17344*D1*Dd*f*fd - 5944*D1*Ddd*f**2*r**2 - 17344*D1*Ddd*f**2*r*s + 7308*D1*Ddd*f**2*r - 11400*D1*Ddd*f**2*s**2 + 10036*D1*Ddd*f**2*s - 4336*D1*Ddd*f**2 - 33*D1*bd1*(C*D1*(f*(19*r**2 + 182*r*s - 14*r + 163*s**2 - 158*s - 5) - 2*fd*(26*r**2 + 252*r*s - 83*r + 226*s**2 - 233*s + 63)) - 8*C*Dd*f*(13*r**2 + 2*r*(63*s - 13) + 113*s**2 - 101*s + 16) + 2*D1*(f*(-29*r**2 + r*(29 - 66*s) - s*(37*s - 37)) + fd*(92*r**2 + 2*r*(114*s - 67) + 136*s**2 - 167*s + 57)) + 2*Dd*f*(184*r**2 + r*(456*s - 227) + 272*s**2 - 293*s + 73)) - 17832*Dd**2*f**2*r**2 - 52032*Dd**2*f**2*r*s + 21924*Dd**2*f**2*r - 34200*Dd**2*f**2*s**2 + 30108*Dd**2*f**2*s - 4336*Dd**2*f**2))/(693*d**2*k3**4) + 4*D1**2*Pk1*Pk2*ct**2*k1**2*(33*b1**2*(D1**2*(r + s)*(fd*r*(21*C - 64) + fd*s*(109*C - 173) + fdd*r*(88 - 35*C) + fdd*s*(160 - 107*C)) + D1*(-2*C*Ddd*f*(70*r**2 + 2*r*(142*s - 53) + 214*s**2 - 178*s + 71) + Dd*f*(2*C*(42*r**2 + r*(260*s - 86) + 218*s**2 - 174*s + 65) - 256*r**2 + r*(365 - 948*s) - 692*s**2 + 583*s - 237) - 4*Dd*fd*(r**2*(70*C - 176) + r*(C*(284*s - 53) - 496*s + 106) + s*(C*(214*s - 89) - 320*s + 142)) + 8*Ddd*f*(44*r**2 + r*(124*s - 53) + 80*s**2 - 71*s + 31)) - 2*Dd**2*f*(C*(210*r**2 + 6*r*(142*s - 53) + 642*s**2 - 534*s + 71) - 528*r**2 - 12*r*(124*s - 53) - 960*s**2 + 852*s - 124)) + 33*b1*(16*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 80*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 112*C*D1**2*f*fd*s - 88*C*D1**2*f*fd - 8*C*D1**2*f*fdd*r**2 + 16*C*D1**2*f*fdd*r*s - 64*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 80*C*D1**2*f*fdd*s + 68*C*D1**2*f*fdd - 8*C*D1**2*fd**2*r**2 + 16*C*D1**2*fd**2*r*s - 64*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 80*C*D1**2*fd**2*s + 32*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s - 96*C*D1*Dd*f**2*s**2 + 64*C*D1*Dd*f**2*s - 16*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r**2 + 128*C*D1*Dd*f*fd*r*s - 256*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 384*C*D1*Dd*f*fd*s + 144*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 + 32*C*D1*Ddd*f**2*r*s + 48*C*D1*Ddd*f**2*s**2 - 32*C*D1*Ddd*f**2*s + 8*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 + 96*C*Dd**2*f**2*r*s + 144*C*Dd**2*f**2*s**2 - 96*C*Dd**2*f**2*s + 8*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(r + s - 1)*(35*C*r + 107*C*s - 71*C - 88*r - 160*s + 124) - 136*D1**2*f*fd*r**2 - 456*D1**2*f*fd*r*s + 158*D1**2*f*fd*r - 320*D1**2*f*fd*s**2 + 250*D1**2*f*fd*s - 90*D1**2*f*fd + 170*D1**2*f*fdd*r**2 + 474*D1**2*f*fdd*r*s - 187*D1**2*f*fdd*r + 304*D1**2*f*fdd*s**2 - 254*D1**2*f*fdd*s + 102*D1**2*f*fdd + 170*D1**2*fd**2*r**2 + 474*D1**2*fd**2*r*s - 187*D1**2*fd**2*r + 304*D1**2*fd**2*s**2 - 254*D1**2*fd**2*s - 272*D1*Dd*f**2*r**2 - 912*D1*Dd*f**2*r*s + 364*D1*Dd*f**2*r - 640*D1*Dd*f**2*s**2 + 548*D1*Dd*f**2*s - 228*D1*Dd*f**2 + 1360*D1*Dd*f*fd*r**2 + 3792*D1*Dd*f*fd*r*s - 1562*D1*Dd*f*fd*r + 2432*D1*Dd*f*fd*s**2 - 2098*D1*Dd*f*fd*s + 441*D1*Dd*f*fd + 340*D1*Ddd*f**2*r**2 + 948*D1*Ddd*f**2*r*s - 407*D1*Ddd*f**2*r + 608*D1*Ddd*f**2*s**2 - 541*D1*Ddd*f**2*s + 237*D1*Ddd*f**2 + D1*bd1*(-8*C*Dd*f*(70*r**2 + r*(284*s - 159) + 214*s**2 - 267*s + 71) + D1*f*(r + s - 1)*(2*C*(21*r + 109*s - 65) - 128*r - 346*s + 237) - 4*D1*fd*(r**2*(35*C - 88) + r*(142*C*s - 53*C - 248*s + 106) + s*(107*C*s - 89*C - 160*s + 142)) + 16*Dd*f*(88*r**2 + r*(248*s - 159) + 160*s**2 - 213*s + 62)) + 1020*Dd**2*f**2*r**2 + 2844*Dd**2*f**2*r*s - 1221*Dd**2*f**2*r + 1824*Dd**2*f**2*s**2 - 1623*Dd**2*f**2*s + 237*Dd**2*f**2) + f*(-66*D1**2*bd1**2*(r + s - 1)*(C*(35*r + 107*s - 71) - 88*r - 160*s + 124) - 33*D1**2*bdd1*f*(r + s - 1)*(4*C*(r - 3*s - 15) - 85*r - 152*s + 135) - 5*D1**2*(f*(fd*(C*(417*r**2 + 6*r*(383*s - 174) + 1881*s**2 - 2020*s + 766) - 99*r**2 + 2*r*(84*s + 5) + 267*s**2 - 234*s + 56) - fdd*(C*(555*r**2 + 6*r*(373*s - 186) + 1683*s**2 - 1868*s + 746) + 94*r*(3*s - 1) + 282*s**2 - 282*s + 94)) - 2*fd**2*(C*(555*r**2 + 6*r*(373*s - 186) + 1683*s**2 - 1868*s + 373) + 47*r*(6*s - 2) + 282*s**2 - 282*s + 47)) + 33*D1*bd1*(D1*(2*f*(r + s - 1)*(4*C*(r - 3*s - 9) - 34*r - 80*s + 69) + fd*(8*C*(-2*r**2 + 4*r*(s + 2) + 6*s**2 + 2*s + 1) + 340*r**2 + 948*r*s - 627*r + 608*s**2 - 828*s + 237)) + Dd*f*(-16*C*(2*r**2 - 4*r*(s + 4) - 6*s**2 - 10*s + 7) + 680*r**2 + 3*r*(632*s - 429) + 1216*s**2 - 1689*s + 507)) - 10*D1*f*(Dd*(f*(C*(278*r**2 + 1532*r*s - 522*r + 1254*s**2 - 1010*s + 383) - 66*r**2 + 112*r*s + 5*r + 178*s**2 - 117*s + 28) - fd*(2*C*(1110*r**2 + 4476*r*s - 1953*r + 3366*s**2 - 3269*s + 746) + 1128*r*s - 329*r + 1128*s**2 - 987*s + 188)) - Ddd*f*(C*(370*r**2 + 1492*r*s - 558*r + 1122*s**2 - 934*s + 373) + 188*r*s - 47*r + 188*s**2 - 141*s + 47)) + 10*Dd**2*f**2*(C*(1110*r**2 + 6*r*(746*s - 279) + 3366*s**2 - 2802*s + 373) + 141*r*(4*s - 1) + 564*s**2 - 423*s + 47)))/(693*d**2*k3**4) - 4*D1**2*Pk1*Pk2*ct**2*k1**2*st**2*(22*b1**2*(C - 4)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 11*b1*(-98*C*D1**2*f*fd*s**2 + 106*C*D1**2*f*fd*s - 53*C*D1**2*f*fd + 54*C*D1**2*f*fdd*s**2 - 58*C*D1**2*f*fdd*s + 29*C*D1**2*f*fdd + 54*C*D1**2*fd**2*s**2 - 58*C*D1**2*fd**2*s - 196*C*D1*Dd*f**2*s**2 + 98*C*D1*Dd*f**2*s - 49*C*D1*Dd*f**2 + 432*C*D1*Dd*f*fd*s**2 - 340*C*D1*Dd*f*fd*s + 58*C*D1*Dd*f*fd + 108*C*D1*Ddd*f**2*s**2 - 54*C*D1*Ddd*f**2*s + 27*C*D1*Ddd*f**2 + 324*C*Dd**2*f**2*s**2 - 162*C*Dd**2*f**2*s - 2*D1**2*bdd1*f*(C - 4)*(2*s**2 - 2*s + 1) + 36*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 128*D1**2*f*fd*s**2 - 160*D1**2*f*fd*s + 80*D1**2*f*fd - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 84*D1**2*f*fdd*s**2 + 100*D1**2*f*fdd*s - 50*D1**2*f*fdd - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 84*D1**2*fd**2*s**2 + 100*D1**2*fd**2*s + 72*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 256*D1*Dd*f**2*s**2 - 146*D1*Dd*f**2*s + 64*D1*Dd*f**2 - 192*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*r - 672*D1*Dd*f*fd*s**2 + 592*D1*Dd*f*fd*s - 112*D1*Dd*f*fd - 48*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r - 168*D1*Ddd*f**2*s**2 + 96*D1*Ddd*f**2*s - 42*D1*Ddd*f**2 + 4*D1*bd1*(C - 4)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 144*Dd**2*f**2*r*s + 36*Dd**2*f**2*r - 504*Dd**2*f**2*s**2 + 288*Dd**2*f**2*s - 12*Dd**2*f**2) - f*(1365*C*D1**2*f*fd*s**2 - 910*C*D1**2*f*fd*s + 455*C*D1**2*f*fd - 765*C*D1**2*f*fdd*s**2 + 510*C*D1**2*f*fdd*s - 255*C*D1**2*f*fdd - 1530*C*D1**2*fd**2*s**2 + 1020*C*D1**2*fd**2*s + 1820*C*D1*Dd*f**2*s**2 - 910*C*D1*Dd*f**2*s + 455*C*D1*Dd*f**2 - 6120*C*D1*Dd*f*fd*s**2 + 3570*C*D1*Dd*f*fd*s - 510*C*D1*Dd*f*fd - 1020*C*D1*Ddd*f**2*s**2 + 510*C*D1*Ddd*f**2*s - 255*C*D1*Ddd*f**2 - 3060*C*Dd**2*f**2*s**2 + 1530*C*Dd**2*f**2*s + 44*D1**2*bd1**2*s*(C - 4)*(s - 1) + 11*D1**2*bdd1*f*(C*(-27*s**2 - 4*s + 2) + 42*s**2 + s*(12*r + 4) - 8) - 462*D1**2*f*fd*r*s + 154*D1**2*f*fd*r - 2256*D1**2*f*fd*s**2 + 1658*D1**2*f*fd*s - 752*D1**2*f*fd + 396*D1**2*f*fdd*r*s - 132*D1**2*f*fdd*r + 1458*D1**2*f*fdd*s**2 - 1104*D1**2*f*fdd*s + 486*D1**2*f*fdd + 792*D1**2*fd**2*r*s - 264*D1**2*fd**2*r + 2916*D1**2*fd**2*s**2 - 2208*D1**2*fd**2*s + 132*D1**2*fd**2 - 616*D1*Dd*f**2*r*s + 154*D1*Dd*f**2*r - 3008*D1*Dd*f**2*s**2 + 1658*D1*Dd*f**2*s - 752*D1*Dd*f**2 + 3168*D1*Dd*f*fd*r*s - 924*D1*Dd*f*fd*r + 11664*D1*Dd*f*fd*s**2 - 7728*D1*Dd*f*fd*s + 1236*D1*Dd*f*fd + 528*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 1944*D1*Ddd*f**2*s**2 - 1104*D1*Ddd*f**2*s + 486*D1*Ddd*f**2 + 11*D1*bd1*(D1*(f*(C*(49*s**2 + 8*s - 4) - 64*s**2 - s*(18*r + 14) + 16) + 2*fd*(6*r*(4*s - 1) + s**2*(84 - 54*C) + s*(25*C - 46) + 6)) + 2*Dd*f*(C*(-108*s**2 + 19*s + 2) + 6*r*(8*s - 1) + 168*s**2 - 40*s - 2)) + 1584*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 5832*Dd**2*f**2*s**2 - 3312*Dd**2*f**2*s + 132*Dd**2*f**2))/(231*d**2*k2**2*k3**2) + 2*D1**2*Pk1*Pk2*ct**2*k1**2*(66*b1**2*(D1**2*s*(-26*fd*r + fd*s*(41*C - 86) + 20*fdd*r + fdd*s*(64 - 31*C)) + D1*(Dd*(41*C*f*(4*s**2 - 2*s + 1) - 2*f*(13*r*(4*s - 1) + 172*s**2 - 99*s + 43) + 20*fd*r*(8*s - 1) + 2*fd*s*(-31*C*(4*s - 1) + 256*s - 74)) + Ddd*f*(-31*C*(4*s**2 - 2*s + 1) + 80*r*s - 20*r + 256*s**2 - 148*s + 64)) + 2*Dd**2*f*(30*r*(4*s - 1) - s**2*(186*C - 384) + s*(93*C - 222) + 10)) + 66*b1*(-86*C*D1**2*f*fd*s**2 + 154*C*D1**2*f*fd*s - 77*C*D1**2*f*fd + 80*C*D1**2*f*fdd*s**2 - 132*C*D1**2*f*fdd*s + 66*C*D1**2*f*fdd + 80*C*D1**2*fd**2*s**2 - 132*C*D1**2*fd**2*s - 172*C*D1*Dd*f**2*s**2 + 86*C*D1*Dd*f**2*s - 43*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*s**2 - 688*C*D1*Dd*f*fd*s + 132*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 40*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + D1**2*bdd1*f*(-31*C*(2*s**2 - 2*s + 1) + 20*r*(2*s - 1) + 128*s**2 - 148*s + 64) + 18*D1**2*f*fd*r*s - 35*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 122*D1**2*f*fd*s + 74*D1**2*f*fd - 20*D1**2*f*fdd*r*s + 29*D1**2*f*fdd*r - 42*D1**2*f*fdd*s**2 + 131*D1**2*f*fdd*s - 75*D1**2*f*fdd - 20*D1**2*fd**2*r*s + 29*D1**2*fd**2*r - 42*D1**2*fd**2*s**2 + 131*D1**2*fd**2*s + 36*D1*Dd*f**2*r*s - 9*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 13*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 160*D1*Dd*f*fd*r*s + 136*D1*Dd*f*fd*r - 336*D1*Dd*f*fd*s**2 + 628*D1*Dd*f*fd*s - 160*D1*Dd*f*fd - 40*D1*Ddd*f**2*r*s + 10*D1*Ddd*f**2*r - 84*D1*Ddd*f**2*s**2 + 52*D1*Ddd*f**2*s - 21*D1*Ddd*f**2 + D1*bd1*(D1*(41*C*f*(2*s**2 - 2*s + 1) - 2*f*(13*r*(2*s - 1) + 86*s**2 - 99*s + 43) + 20*fd*r*(4*s - 1) + 2*fd*s*(C*(31 - 62*s) + 128*s - 74)) + 2*Dd*f*(-31*C*(8*s**2 - 6*s + 1) + 20*r*(8*s - 3) + 512*s**2 - 444*s + 84)) - 120*Dd**2*f**2*r*s + 30*Dd**2*f**2*r - 252*Dd**2*f**2*s**2 + 156*Dd**2*f**2*s - 10*Dd**2*f**2) - f*(12768*C*D1**2*f*fd*s**2 - 8512*C*D1**2*f*fd*s + 4256*C*D1**2*f*fd - 10938*C*D1**2*f*fdd*s**2 + 7292*C*D1**2*f*fdd*s - 3646*C*D1**2*f*fdd - 21876*C*D1**2*fd**2*s**2 + 14584*C*D1**2*fd**2*s + 17024*C*D1*Dd*f**2*s**2 - 8512*C*D1*Dd*f**2*s + 4256*C*D1*Dd*f**2 - 87504*C*D1*Dd*f*fd*s**2 + 51044*C*D1*Dd*f*fd*s - 7292*C*D1*Dd*f*fd - 14584*C*D1*Ddd*f**2*s**2 + 7292*C*D1*Ddd*f**2*s - 3646*C*D1*Ddd*f**2 - 43752*C*Dd**2*f**2*s**2 + 21876*C*Dd**2*f**2*s - 132*D1**2*bd1**2*(10*r*(2*s - 1) - (s - 1)*(s*(31*C - 64) + 10)) + 66*D1**2*bdd1*f*(C*(-40*s**2 - 52*s + 26) + r*(10*s + 19) + 21*s**2 + 79*s - 54) - 6537*D1**2*f*fd*r*s + 2179*D1**2*f*fd*r - 12372*D1**2*f*fd*s**2 + 10427*D1**2*f*fd*s - 4124*D1**2*f*fd + 5397*D1**2*f*fdd*r*s - 1799*D1**2*f*fdd*r + 12522*D1**2*f*fdd*s**2 - 10147*D1**2*f*fdd*s + 4174*D1**2*f*fdd + 10794*D1**2*fd**2*r*s - 3598*D1**2*fd**2*r + 25044*D1**2*fd**2*s**2 - 20294*D1**2*fd**2*s + 1799*D1**2*fd**2 - 8716*D1*Dd*f**2*r*s + 2179*D1*Dd*f**2*r - 16496*D1*Dd*f**2*s**2 + 10427*D1*Dd*f**2*s - 4124*D1*Dd*f**2 + 43176*D1*Dd*f*fd*r*s - 12593*D1*Dd*f*fd*r + 100176*D1*Dd*f*fd*s**2 - 71029*D1*Dd*f*fd*s + 11946*D1*Dd*f*fd + 7196*D1*Ddd*f**2*r*s - 1799*D1*Ddd*f**2*r + 16696*D1*Ddd*f**2*s**2 - 10147*D1*Ddd*f**2*s + 4174*D1*Ddd*f**2 + 66*D1*bd1*(D1*(f*(C*(43*s**2 + 68*s - 34) - r*(9*s + 26) - 2*s**2 - 109*s + 72) + fd*(r*(40*s + 9) + s**2*(84 - 160*C) + s*(28*C + 27) + 10)) + 2*Dd*f*(-2*C*(80*s**2 + 32*s - 13) + r*(40*s + 33) + 84*s**2 + 132*s - 49)) + 21588*Dd**2*f**2*r*s - 5397*Dd**2*f**2*r + 50088*Dd**2*f**2*s**2 - 30441*Dd**2*f**2*s + 1799*Dd**2*f**2))/(693*d**2*k2**2*k3**2) + D1**2*Pk1*Pk2*ct**2*k2**4*st**6*(40*C - 40)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 264*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 528*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 528*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 28*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s - 8*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 132*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 396*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 12*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s - 2*Dd**2*f**3)/(693*d**2*k3**6) + 16*D1**2*Pk1*Pk2*ct**2*k2**4*st**4*(33*D1*b1*(4*bd1*(C - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) + f*(-2*D1*bdd1*(C - 1)*(r + s - 1)**2 - (C - 2)*(D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1))) + 33*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + f*(-66*D1**2*bd1**2*(C - 1)*(r + s - 1)**2 - 33*D1**2*bd1*f*(C - 2)*(r + s - 1)**2 + (15*C + 10)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 2*D1*f*(2*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) - Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1))))/(231*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct**2*k2**4*st**2*(D1*f*(-12*D1*bd1**2*(C + 1)*(r + s - 1)**2 + bd1*(C + 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 12*D1*fd*(2*r + 2*s - 1) - 24*Dd*f*(2*r + 2*s - 1)) - 3*f*(2*D1*bdd1*(C + 1)*(r + s - 1)**2 + (2*C + 1)*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))) + b1**2*(D1**2*(r + s)**2*(fd*(5*C + 26) - fdd*(6*C + 6)) + 2*D1*(Dd*(f*(5*C + 26)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(12*C + 12)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(-6*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(12*C + 12)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(2*D1*bd1*(r + s - 1)*(D1*f*(5*C + 26)*(r + s - 1) - D1*fd*(12*C + 12)*(r + s) - Dd*f*(24*C + 24)*(2*r + 2*s - 1)) - (C + 1)*(12*D1**2*bdd1*f*(r + s - 1)**2 + D1**2*(-f*(7*fd - 6*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 12*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*f*(Dd*(-7*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 12*fd*(2*r + 2*s - 1)**2) + 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 12*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1))))/(21*d**2*k3**6) + D1**2*Pk1*Pk2*ct**2*k2**2*st**6*(80*C - 80)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(693*d**2*k3**4) + 4*D1**2*Pk1*Pk2*ct**2*k2**2*st**4*(132*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 33*b1*(-6*C*D1**2*f*fd*r**2 - 28*C*D1**2*f*fd*r*s + 14*C*D1**2*f*fd*r - 22*C*D1**2*f*fd*s**2 + 22*C*D1**2*f*fd*s - 11*C*D1**2*f*fd + 10*C*D1**2*f*fdd*r**2 + 28*C*D1**2*f*fdd*r*s - 14*C*D1**2*f*fdd*r + 18*C*D1**2*f*fdd*s**2 - 18*C*D1**2*f*fdd*s + 9*C*D1**2*f*fdd + 10*C*D1**2*fd**2*r**2 + 28*C*D1**2*fd**2*r*s - 14*C*D1**2*fd**2*r + 18*C*D1**2*fd**2*s**2 - 18*C*D1**2*fd**2*s - 12*C*D1*Dd*f**2*r**2 - 56*C*D1*Dd*f**2*r*s + 20*C*D1*Dd*f**2*r - 44*C*D1*Dd*f**2*s**2 + 36*C*D1*Dd*f**2*s - 14*C*D1*Dd*f**2 + 80*C*D1*Dd*f*fd*r**2 + 224*C*D1*Dd*f*fd*r*s - 104*C*D1*Dd*f*fd*r + 144*C*D1*Dd*f*fd*s**2 - 136*C*D1*Dd*f*fd*s + 32*C*D1*Dd*f*fd + 20*C*D1*Ddd*f**2*r**2 + 56*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 36*C*D1*Ddd*f**2*s**2 - 32*C*D1*Ddd*f**2*s + 14*C*D1*Ddd*f**2 + 60*C*Dd**2*f**2*r**2 + 168*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 108*C*Dd**2*f**2*s**2 - 96*C*Dd**2*f**2*s + 14*C*Dd**2*f**2 - 4*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) + 6*D1**2*f*fd*r**2 + 32*D1**2*f*fd*r*s - 16*D1**2*f*fd*r + 26*D1**2*f*fd*s**2 - 26*D1**2*f*fd*s + 13*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 12*D1*Dd*f**2*r**2 + 64*D1*Dd*f**2*r*s - 22*D1*Dd*f**2*r + 52*D1*Dd*f**2*s**2 - 42*D1*Dd*f**2*s + 16*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 104*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 136*D1*Dd*f*fd*s - 32*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 32*D1*Ddd*f**2*s - 14*D1*Ddd*f**2 + 4*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 60*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 72*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 96*Dd**2*f**2*s - 14*Dd**2*f**2) + f*(216*C*D1**2*f*fd*r**2 + 696*C*D1**2*f*fd*r*s - 376*C*D1**2*f*fd*r + 480*C*D1**2*f*fd*s**2 - 552*C*D1**2*f*fd*s + 232*C*D1**2*f*fd - 108*C*D1**2*f*fdd*r**2 - 348*C*D1**2*f*fdd*r*s + 188*C*D1**2*f*fdd*r - 240*C*D1**2*f*fdd*s**2 + 276*C*D1**2*f*fdd*s - 116*C*D1**2*f*fdd - 216*C*D1**2*fd**2*r**2 - 696*C*D1**2*fd**2*r*s + 376*C*D1**2*fd**2*r - 480*C*D1**2*fd**2*s**2 + 552*C*D1**2*fd**2*s - 116*C*D1**2*fd**2 + 288*C*D1*Dd*f**2*r**2 + 928*C*D1*Dd*f**2*r*s - 376*C*D1*Dd*f**2*r + 640*C*D1*Dd*f**2*s**2 - 552*C*D1*Dd*f**2*s + 232*C*D1*Dd*f**2 - 864*C*D1*Dd*f*fd*r**2 - 2784*C*D1*Dd*f*fd*r*s + 1316*C*D1*Dd*f*fd*r - 1920*C*D1*Dd*f*fd*s**2 + 1932*C*D1*Dd*f*fd*s - 464*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*r**2 - 464*C*D1*Ddd*f**2*r*s + 188*C*D1*Ddd*f**2*r - 320*C*D1*Ddd*f**2*s**2 + 276*C*D1*Ddd*f**2*s - 116*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*r**2 - 1392*C*Dd**2*f**2*r*s + 564*C*Dd**2*f**2*r - 960*C*Dd**2*f**2*s**2 + 828*C*Dd**2*f**2*s - 116*C*Dd**2*f**2 - 132*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(C - 1)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) - 246*D1**2*f*fd*r**2 - 186*D1**2*f*fd*r*s + 226*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 + 22*D1**2*f*fd*s - 62*D1**2*f*fd + 123*D1**2*f*fdd*r**2 + 93*D1**2*f*fdd*r*s - 113*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 - 11*D1**2*f*fdd*s + 31*D1**2*f*fdd + 246*D1**2*fd**2*r**2 + 186*D1**2*fd**2*r*s - 226*D1**2*fd**2*r - 60*D1**2*fd**2*s**2 - 22*D1**2*fd**2*s + 31*D1**2*fd**2 - 328*D1*Dd*f**2*r**2 - 248*D1*Dd*f**2*r*s + 226*D1*Dd*f**2*r + 80*D1*Dd*f**2*s**2 + 22*D1*Dd*f**2*s - 62*D1*Dd*f**2 + 984*D1*Dd*f*fd*r**2 + 744*D1*Dd*f*fd*r*s - 791*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 - 77*D1*Dd*f*fd*s + 124*D1*Dd*f*fd + 164*D1*Ddd*f**2*r**2 + 124*D1*Ddd*f**2*r*s - 113*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 - 11*D1*Ddd*f**2*s + 31*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(r + s - 1)*(C*(3*r + 11*s - 3) - 3*r - 13*s + 3) - fd*(2*C - 2)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7)) + Dd*f*(8 - 8*C)*(5*r**2 + 2*r*(7*s - 4) + 9*s**2 - 11*s + 3)) + 492*Dd**2*f**2*r**2 + 372*Dd**2*f**2*r*s - 339*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 - 33*Dd**2*f**2*s + 31*Dd**2*f**2))/(231*d**2*k3**4) + 2*D1**2*Pk1*Pk2*ct**2*k2**2*st**2*(11*b1**2*(D1**2*(r + s)*(fd*r*(27*C - 39) + fd*s*(3*C - 3) + fdd*r*(11*C - 5) + fdd*s*(23*C - 23)) + 2*D1*(Dd*(3*f*(C*(18*r**2 + 20*r*s - 14*r + 2*s**2 - 6*s + 5) - 26*r**2 - 28*r*s + 20*r - 2*s**2 + 8*s - 7) + fd*(r**2*(44*C - 20) + r*(4*C*(34*s - 7) - 112*s + 19) + s*(C*(92*s - 40) - 92*s + 37))) + Ddd*f*(C*(22*r**2 + 68*r*s - 28*r + 46*s**2 - 40*s + 17) - 10*r**2 - 56*r*s + 19*r - 46*s**2 + 37*s - 14)) + 2*Dd**2*f*(C*(66*r**2 + 204*r*s - 84*r + 138*s**2 - 120*s + 17) - 30*r**2 - 168*r*s + 57*r - 138*s**2 + 111*s - 14)) + 11*b1*(2*C*D1**2*f*fd*r**2 - 76*C*D1**2*f*fd*r*s + 22*C*D1**2*f*fd*r - 78*C*D1**2*f*fd*s**2 + 62*C*D1**2*f*fd*s - 23*C*D1**2*f*fd + 2*C*D1**2*f*fdd*r**2 + 76*C*D1**2*f*fdd*r*s - 26*C*D1**2*f*fdd*r + 74*C*D1**2*f*fdd*s**2 - 62*C*D1**2*f*fdd*s + 25*C*D1**2*f*fdd + 2*C*D1**2*fd**2*r**2 + 76*C*D1**2*fd**2*r*s - 26*C*D1**2*fd**2*r + 74*C*D1**2*fd**2*s**2 - 62*C*D1**2*fd**2*s + 4*C*D1*Dd*f**2*r**2 - 152*C*D1*Dd*f**2*r*s + 36*C*D1*Dd*f**2*r - 156*C*D1*Dd*f**2*s**2 + 116*C*D1*Dd*f**2*s - 38*C*D1*Dd*f**2 + 16*C*D1*Dd*f*fd*r**2 + 608*C*D1*Dd*f*fd*r*s - 184*C*D1*Dd*f*fd*r + 592*C*D1*Dd*f*fd*s**2 - 472*C*D1*Dd*f*fd*s + 88*C*D1*Dd*f*fd + 4*C*D1*Ddd*f**2*r**2 + 152*C*D1*Ddd*f**2*r*s - 40*C*D1*Ddd*f**2*r + 148*C*D1*Ddd*f**2*s**2 - 112*C*D1*Ddd*f**2*s + 38*C*D1*Ddd*f**2 + 12*C*Dd**2*f**2*r**2 + 456*C*Dd**2*f**2*r*s - 120*C*Dd**2*f**2*r + 444*C*Dd**2*f**2*s**2 - 336*C*Dd**2*f**2*s + 38*C*Dd**2*f**2 + 2*D1**2*bdd1*f*(r + s - 1)*(C*(11*r + 23*s - 17) - 5*r - 23*s + 14) - 76*D1**2*f*fd*r**2 - 256*D1**2*f*fd*r*s + 152*D1**2*f*fd*r - 180*D1**2*f*fd*s**2 + 204*D1**2*f*fd*s - 114*D1**2*f*fd + 100*D1**2*f*fdd*r**2 + 236*D1**2*f*fdd*r*s - 136*D1**2*f*fdd*r + 136*D1**2*f*fdd*s**2 - 154*D1**2*f*fdd*s + 86*D1**2*f*fdd + 100*D1**2*fd**2*r**2 + 236*D1**2*fd**2*r*s - 136*D1**2*fd**2*r + 136*D1**2*fd**2*s**2 - 154*D1**2*fd**2*s - 152*D1*Dd*f**2*r**2 - 512*D1*Dd*f**2*r*s + 204*D1*Dd*f**2*r - 360*D1*Dd*f**2*s**2 + 308*D1*Dd*f**2*s - 128*D1*Dd*f**2 + 800*D1*Dd*f*fd*r**2 + 1888*D1*Dd*f*fd*r*s - 980*D1*Dd*f*fd*r + 1088*D1*Dd*f*fd*s**2 - 1124*D1*Dd*f*fd*s + 290*D1*Dd*f*fd + 200*D1*Ddd*f**2*r**2 + 472*D1*Ddd*f**2*r*s - 218*D1*Ddd*f**2*r + 272*D1*Ddd*f**2*s**2 - 254*D1*Ddd*f**2*s + 118*D1*Ddd*f**2 + 2*D1*bd1*(D1*(3*f*(r + s - 1)*(C*(9*r + s - 5) - 13*r - s + 7) + fd*(r**2*(22*C - 10) + r*(68*C*s - 28*C - 56*s + 19) + s*(46*C*s - 40*C - 46*s + 37))) + 2*Dd*f*(2*C*(22*r**2 + 68*r*s - 42*r + 46*s**2 - 60*s + 17) - 20*r**2 - 112*r*s + 57*r - 92*s**2 + 111*s - 28)) + 600*Dd**2*f**2*r**2 + 1416*Dd**2*f**2*r*s - 654*Dd**2*f**2*r + 816*Dd**2*f**2*s**2 - 762*Dd**2*f**2*s + 118*Dd**2*f**2) + f*(-1746*C*D1**2*f*fd*r**2 - 3924*C*D1**2*f*fd*r*s + 2472*C*D1**2*f*fd*r - 2178*C*D1**2*f*fd*s**2 + 2760*C*D1**2*f*fd*s - 1308*C*D1**2*f*fd + 1566*C*D1**2*f*fdd*r**2 + 3348*C*D1**2*f*fdd*r*s - 2160*C*D1**2*f*fdd*r + 1782*C*D1**2*f*fdd*s**2 - 2304*C*D1**2*f*fdd*s + 1116*C*D1**2*f*fdd + 3132*C*D1**2*fd**2*r**2 + 6696*C*D1**2*fd**2*r*s - 4320*C*D1**2*fd**2*r + 3564*C*D1**2*fd**2*s**2 - 4608*C*D1**2*fd**2*s + 1116*C*D1**2*fd**2 - 2328*C*D1*Dd*f**2*r**2 - 5232*C*D1*Dd*f**2*r*s + 2472*C*D1*Dd*f**2*r - 2904*C*D1*Dd*f**2*s**2 + 2760*C*D1*Dd*f**2*s - 1308*C*D1*Dd*f**2 + 12528*C*D1*Dd*f*fd*r**2 + 26784*C*D1*Dd*f*fd*r*s - 15120*C*D1*Dd*f*fd*r + 14256*C*D1*Dd*f*fd*s**2 - 16128*C*D1*Dd*f*fd*s + 4464*C*D1*Dd*f*fd + 2088*C*D1*Ddd*f**2*r**2 + 4464*C*D1*Ddd*f**2*r*s - 2160*C*D1*Ddd*f**2*r + 2376*C*D1*Ddd*f**2*s**2 - 2304*C*D1*Ddd*f**2*s + 1116*C*D1*Ddd*f**2 + 6264*C*Dd**2*f**2*r**2 + 13392*C*Dd**2*f**2*r*s - 6480*C*Dd**2*f**2*r + 7128*C*Dd**2*f**2*s**2 - 6912*C*Dd**2*f**2*s + 1116*C*Dd**2*f**2 + 22*D1**2*bd1**2*(r + s - 1)*(C*(11*r + 23*s - 17) - 5*r - 23*s + 14) + 11*D1**2*bdd1*f*(r + s - 1)*(C*(r + 37*s - 13) + 50*r + 68*s - 32) + 273*D1**2*f*fd*r**2 - 1518*D1**2*f*fd*r*s + 324*D1**2*f*fd*r - 1791*D1**2*f*fd*s**2 + 1700*D1**2*f*fd*s - 506*D1**2*f*fd + 639*D1**2*f*fdd*r**2 + 2178*D1**2*f*fdd*r*s - 1152*D1**2*f*fdd*r + 1539*D1**2*f*fdd*s**2 - 1752*D1**2*f*fdd*s + 726*D1**2*f*fdd + 1278*D1**2*fd**2*r**2 + 4356*D1**2*fd**2*r*s - 2304*D1**2*fd**2*r + 3078*D1**2*fd**2*s**2 - 3504*D1**2*fd**2*s + 726*D1**2*fd**2 + 364*D1*Dd*f**2*r**2 - 2024*D1*Dd*f**2*r*s + 324*D1*Dd*f**2*r - 2388*D1*Dd*f**2*s**2 + 1700*D1*Dd*f**2*s - 506*D1*Dd*f**2 + 5112*D1*Dd*f*fd*r**2 + 17424*D1*Dd*f*fd*r*s - 8064*D1*Dd*f*fd*r + 12312*D1*Dd*f*fd*s**2 - 12264*D1*Dd*f*fd*s + 2904*D1*Dd*f*fd + 852*D1*Ddd*f**2*r**2 + 2904*D1*Ddd*f**2*r*s - 1152*D1*Ddd*f**2*r + 2052*D1*Ddd*f**2*s**2 - 1752*D1*Ddd*f**2*s + 726*D1*Ddd*f**2 + 11*D1*bd1*(D1*(f*(r + s - 1)*(C*(r - 39*s + 15) - 38*r - 90*s + 14) + 2*fd*(C*(2*r**2 + 76*r*s - 27*r + 74*s**2 - 81*s + 19) + 100*r**2 + 236*r*s - 150*r + 136*s**2 - 177*s + 59)) + 2*Dd*f*(4*C*(r**2 + 38*r*s - 12*r + 37*s**2 - 39*s + 8) + 200*r**2 + 472*r*s - 273*r + 272*s**2 - 327*s + 91)) + 2556*Dd**2*f**2*r**2 + 8712*Dd**2*f**2*r*s - 3456*Dd**2*f**2*r + 6156*Dd**2*f**2*s**2 - 5256*Dd**2*f**2*s + 726*Dd**2*f**2))/(231*d**2*k3**4) - 4*D1**2*Pk1*Pk2*ct**2*k2**2*(D1*f*(-2*D1*bd1**2*(r + s - 1)*(35*C*(r + s - 1) + 17*r + 53*s - 35) + 6*bd1*(D1*(f*(r + s - 1)*(3*C*(5*r + s - 1) - 6*r + 5*s - 4) - fd*(2*C*(14*r**2 + 24*r*s - 19*r + 10*s**2 - 16*s + 6) + 14*r**2 + 44*r*s - 29*r + 30*s**2 - 41*s + 11)) - 2*Dd*f*(C*(28*r**2 + 48*r*s - 37*r + 20*s**2 - 31*s + 11) + 14*r**2 + 44*r*s - 31*r + 30*s**2 - 43*s + 13)) - f*(3*D1*bdd1*(r + s - 1)*(2*C*(7*r + 5*s - 5) + 7*r + 15*s - 15) + 5*D1*fd*(3*r**2 + 3*r*(s - 1) - s + 1) + 5*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1))) + b1**2*(D1**2*(r + s)*(fd*(77*C*r + 21*C*s - 50*r + 36*s) - fdd*(35*C*r + 35*C*s + 17*r + 53*s)) + 2*D1*(Dd*(f*(7*C*(22*r**2 + 28*r*s - 18*r + 6*s**2 - 10*s + 7) - 100*r**2 - 28*r*s + 57*r + 72*s**2 - 29*s - 7) - 2*fd*(r**2*(70*C + 34) + r*(35*C*(4*s - 1) + 140*s - 26) + s*(35*C*(2*s - 1) + 106*s - 44))) - Ddd*f*(35*C*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 34*r**2 + 140*r*s - 52*r + 106*s**2 - 88*s + 35)) - 2*Dd**2*f*(35*C*(6*r**2 + 12*r*s - 6*r + 6*s**2 - 6*s + 1) + 102*r**2 + 420*r*s - 156*r + 318*s**2 - 264*s + 35)) + b1*(-2*D1**2*bdd1*f*(r + s - 1)*(35*C*(r + s - 1) + 17*r + 53*s - 35) + 3*D1**2*(f*(2*fd*(3*C*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) - 12*r**2 - 2*r*s + 11*r + 10*s**2 - 5) - fdd*(2*C*(14*r**2 + 24*r*s - 14*r + 10*s**2 - 12*s + 7) + 14*r**2 + 44*r*s - 14*r + 30*s**2 - 22*s + 7)) - 2*fd**2*(r**2*(14*C + 7) + r*(2*C*(12*s - 7) + 22*s - 7) + s*(2*C*(5*s - 6) + 15*s - 11))) + 2*D1*bd1*(D1*(f*(r + s - 1)*(7*C*(11*r + 3*s - 7) - 50*r + 36*s + 7) - 2*fd*(r**2*(35*C + 17) + r*(35*C*(2*s - 1) + 70*s - 26) + s*(35*C*(s - 1) + 53*s - 44))) - 4*Dd*f*(35*C*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 34*r**2 + 140*r*s - 78*r + 106*s**2 - 132*s + 35)) + 6*D1*f*(Dd*(f*(6*C*(10*r**2 + 12*r*s - 8*r + 2*s**2 - 4*s + 3) - 24*r**2 - 4*r*s + 13*r + 20*s**2 - 9*s - 1) - 2*fd*(2*r + 2*s - 1)*(C*(28*r + 20*s - 13) + 14*r + 30*s - 9)) - Ddd*f*(2*C*(14*r**2 + 24*r*s - 13*r + 10*s**2 - 11*s + 6) + 14*r**2 + 44*r*s - 18*r + 30*s**2 - 26*s + 11)) - 6*Dd**2*f**2*(6*C*(14*r**2 + r*(24*s - 13) + 10*s**2 - 11*s + 2) + 42*r**2 + 6*r*(22*s - 9) + 90*s**2 - 78*s + 11)))/(21*d**2*k3**4) + D1**2*Pk1*Pk2*ct**2*st**6*(40*C - 40)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k3**2) + 24*D1**2*Pk1*Pk2*ct**2*st**4*(D1**2*(572*bd1*fd*g2*s*(s - 1) + 5*f**3*(40*fd*(4*s**2 - 2*s + 1) - 20*fdd*(4*s**2 - 2*s + 1) + s**2*(78*bd1 - 39*bdd1)) - 30*f**2*fd*s*(13*bd1*(3*s - 1) + 20*fd*(2*s - 1)) + 286*f*s**2*(-K*bd1**2 + bd1**2 - 2*bd1*g2 + 2*bd1*gd2 + bdd1*g2)) + 2*D1*f*(Dd*(286*bd1*g2*s*(4*s - 1) + 100*f**3*(4*s**2 - 2*s + 1) - 5*f**2*(4*s - 1)*(39*bd1*s + 80*fd*s - 20*fd)) - 50*Ddd*f**3*(4*s**2 - 2*s + 1)) + 600*Dd**2*f**4*s*(1 - 2*s) + 143*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 13*b1*(D1**2*(15*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*f*s*(fd**2*(30 - 45*s) + s*(-11*K*bdd1 + 22*bd1*(K - 1) + 11*bdd1 - 22*gd2 + 11*gdd2)) + (22 - 22*s)*(2*fd*g2*(s - 1) - 2*fd*s*(-K*bd1 + bd1 + gd2) - fdd*g2*(s - 1))) + D1*(2*Dd*(15*f**3*(4*s**2 - 2*s + 1) - 15*f**2*fd*(12*s**2 - 7*s + 1) - 22*f*g2*(4*s**2 - 2*s + 1) + 22*f*s*(4*s - 1)*(-K*bd1 + bd1 + gd2) + 22*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(15*f**2 - 22*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(15*f**2 - 22*g2)*(2*s - 1)))/(1001*d**2*k2**2) + 2*D1**2*Pk1*Pk2*ct**2*st**2*(3718*D1**2*K*bd1**2*f*s**2 - 572*D1**2*K*bd1**2*f*s + 7579*D1**2*K*bd1*f**2*s**2 - 16588*D1**2*K*bd1*f*fd*s**2 + 8294*D1**2*K*bd1*f*fd*s - 4147*D1**2*K*bdd1*f**2*s**2 + 3432*D1**2*bd1**2*f**2*r*s + 1716*D1**2*bd1**2*f**2*s**2 + 8580*D1**2*bd1**2*f**2*s + 3432*D1**2*bd1**2*f*r*s - 10582*D1**2*bd1**2*f*s**2 - 1144*D1**2*bd1**2*f*s + 8008*D1**2*bd1**2*g2*s**2 - 8008*D1**2*bd1**2*g2*s - 3432*D1**2*bd1*bd2*f*s**2 - 3328*D1**2*bd1*f**3*r*s - 25662*D1**2*bd1*f**3*s**2 - 8736*D1**2*bd1*f**3*s + 5200*D1**2*bd1*f**3 + 30576*D1**2*bd1*f**2*fd*r*s - 5096*D1**2*bd1*f**2*fd*r + 115596*D1**2*bd1*f**2*fd*s**2 - 38324*D1**2*bd1*f**2*fd*s + 2548*D1**2*bd1*f**2*fd - 2288*D1**2*bd1*f**2*r*s - 715*D1**2*bd1*f**2*s**2 + 6864*D1**2*bd1*f*fd*r*s - 1716*D1**2*bd1*f*fd*r + 2860*D1**2*bd1*f*fd*s**2 - 3146*D1**2*bd1*f*fd*s - 2574*D1**2*bd1*f*g2*s**2 - 2288*D1**2*bd1*f*g2*s + 1144*D1**2*bd1*f*g2 - 7436*D1**2*bd1*f*gd2*s**2 + 1144*D1**2*bd1*f*gd2*s - 7436*D1**2*bd1*fd*g2*s**2 + 7436*D1**2*bd1*fd*g2*s + 3432*D1**2*bd2*f**2*s**2 - 6864*D1**2*bd2*f*fd*s**2 + 3432*D1**2*bd2*f*fd*s + 5096*D1**2*bdd1*f**3*r*s + 19266*D1**2*bdd1*f**3*s**2 + 2652*D1**2*bdd1*f**3*s - 2600*D1**2*bdd1*f**3 + 1716*D1**2*bdd1*f**2*r*s + 715*D1**2*bdd1*f**2*s**2 - 3718*D1**2*bdd1*f*g2*s**2 + 1144*D1**2*bdd1*f*g2*s - 572*D1**2*bdd1*f*g2 - 1716*D1**2*bdd2*f**2*s**2 - 5040*D1**2*f**3*fd*r*s + 1260*D1**2*f**3*fd*r - 67600*D1**2*f**3*fd*s**2 + 35060*D1**2*f**3*fd*s - 16900*D1**2*f**3*fd + 10320*D1**2*f**3*fdd*r*s - 2580*D1**2*f**3*fdd*r + 46800*D1**2*f**3*fdd*s**2 - 25980*D1**2*f**3*fdd*s + 11700*D1**2*f**3*fdd + 30960*D1**2*f**2*fd**2*r*s - 7740*D1**2*f**2*fd**2*r + 140400*D1**2*f**2*fd**2*s**2 - 77940*D1**2*f**2*fd**2*s + 2580*D1**2*f**2*fd**2 - 15158*D1**2*f**2*gd2*s**2 + 8294*D1**2*f**2*gdd2*s**2 - 30316*D1**2*f*fd*g2*s**2 + 30316*D1**2*f*fd*g2*s - 15158*D1**2*f*fd*g2 + 33176*D1**2*f*fd*gd2*s**2 - 16588*D1**2*f*fd*gd2*s + 16588*D1**2*f*fdd*g2*s**2 - 16588*D1**2*f*fdd*g2*s + 8294*D1**2*f*fdd*g2 + 16588*D1**2*fd**2*g2*s**2 - 16588*D1**2*fd**2*g2*s - 33176*D1*Dd*K*bd1*f**2*s**2 + 8294*D1*Dd*K*bd1*f**2*s + 40768*D1*Dd*bd1*f**3*r*s - 5096*D1*Dd*bd1*f**3*r + 154128*D1*Dd*bd1*f**3*s**2 - 33020*D1*Dd*bd1*f**3*s - 2652*D1*Dd*bd1*f**3 + 13728*D1*Dd*bd1*f**2*r*s - 1716*D1*Dd*bd1*f**2*r + 5720*D1*Dd*bd1*f**2*s**2 - 3146*D1*Dd*bd1*f**2*s - 29744*D1*Dd*bd1*f*g2*s**2 + 12012*D1*Dd*bd1*f*g2*s - 1144*D1*Dd*bd1*f*g2 - 13728*D1*Dd*bd2*f**2*s**2 + 3432*D1*Dd*bd2*f**2*s - 5040*D1*Dd*f**4*r*s + 1260*D1*Dd*f**4*r - 67600*D1*Dd*f**4*s**2 + 35060*D1*Dd*f**4*s - 16900*D1*Dd*f**4 + 82560*D1*Dd*f**3*fd*r*s - 20640*D1*Dd*f**3*fd*r + 374400*D1*Dd*f**3*fd*s**2 - 207840*D1*Dd*f**3*fd*s + 28560*D1*Dd*f**3*fd - 60632*D1*Dd*f**2*g2*s**2 + 30316*D1*Dd*f**2*g2*s - 15158*D1*Dd*f**2*g2 + 66352*D1*Dd*f**2*gd2*s**2 - 16588*D1*Dd*f**2*gd2*s + 132704*D1*Dd*f*fd*g2*s**2 - 99528*D1*Dd*f*fd*g2*s + 16588*D1*Dd*f*fd*g2 + 10320*D1*Ddd*f**4*r*s - 2580*D1*Ddd*f**4*r + 46800*D1*Ddd*f**4*s**2 - 25980*D1*Ddd*f**4*s + 11700*D1*Ddd*f**4 + 33176*D1*Ddd*f**2*g2*s**2 - 16588*D1*Ddd*f**2*g2*s + 8294*D1*Ddd*f**2*g2 + 30960*Dd**2*f**4*r*s - 7740*Dd**2*f**4*r + 140400*Dd**2*f**4*s**2 - 77940*Dd**2*f**4*s + 2580*Dd**2*f**4 + 99528*Dd**2*f**2*g2*s**2 - 49764*Dd**2*f**2*g2*s + 286*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(7*K*(4*s**2 - 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s - 28*s**2 + 14*s - 7) - D1*Ddd*(7*K + 6*f - 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(7*K + 6*f - 7)) + 143*b1**2*(9*D1**2*K*fd*s**2 - 26*D1**2*K*fd*s + 13*D1**2*K*fd + 13*D1**2*K*fdd*s**2 - 22*D1**2*K*fdd*s + 11*D1**2*K*fdd - 2*D1**2*bdd1*(7*K + 6*f - 7)*(3*s**2 - 2*s + 1) - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 36*D1**2*f*fd*s**2 + 108*D1**2*f*fd*s - 54*D1**2*f*fd + 24*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 12*D1**2*f*fdd*s**2 - 84*D1**2*f*fdd*s + 42*D1**2*f*fdd + 24*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 12*D1**2*fd**2*s**2 - 84*D1**2*fd**2*s - 24*D1**2*fd*r*s + 24*D1**2*fd*r + 39*D1**2*fd*s**2 - 70*D1**2*fd*s + 35*D1**2*fd + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r - 37*D1**2*fdd*s**2 + 70*D1**2*fdd*s - 35*D1**2*fdd - 56*D1**2*gd2*s**2 + 28*D1**2*gdd2*s**2 + 36*D1*Dd*K*f*s**2 - 18*D1*Dd*K*f*s + 9*D1*Dd*K*f + 104*D1*Dd*K*fd*s**2 - 114*D1*Dd*K*fd*s + 22*D1*Dd*K*fd - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 18*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r + 96*D1*Dd*f*fd*s**2 - 384*D1*Dd*f*fd*s + 96*D1*Dd*f*fd - 96*D1*Dd*f*r*s + 24*D1*Dd*f*r + 156*D1*Dd*f*s**2 - 54*D1*Dd*f*s + 39*D1*Dd*f + 96*D1*Dd*fd*r*s - 60*D1*Dd*fd*r - 296*D1*Dd*fd*s**2 + 342*D1*Dd*fd*s - 58*D1*Dd*fd - 224*D1*Dd*g2*s**2 + 112*D1*Dd*g2*s - 56*D1*Dd*g2 + 224*D1*Dd*gd2*s**2 - 56*D1*Dd*gd2*s + 52*D1*Ddd*K*f*s**2 - 26*D1*Ddd*K*f*s + 13*D1*Ddd*K*f + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s**2 - 24*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 48*D1*Ddd*f*r*s - 12*D1*Ddd*f*r - 148*D1*Ddd*f*s**2 + 62*D1*Ddd*f*s - 37*D1*Ddd*f + 112*D1*Ddd*g2*s**2 - 56*D1*Ddd*g2*s + 28*D1*Ddd*g2 + 4*D1*bd1*(D1*(7*K*(3*s**2 - 2*s + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s - 21*s**2 + 14*s - 7) - Dd*(7*K + 6*f - 7)*(12*s**2 - 7*s + 1)) + 156*Dd**2*K*f*s**2 - 78*Dd**2*K*f*s + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 72*Dd**2*f**2*s**2 - 72*Dd**2*f**2*s + 12*Dd**2*f**2 + 144*Dd**2*f*r*s - 36*Dd**2*f*r - 444*Dd**2*f*s**2 + 186*Dd**2*f*s + 12*Dd**2*f + 336*Dd**2*g2*s**2 - 168*Dd**2*g2*s) - 13*b1*(-1166*D1**2*K*f*fd*s**2 + 1166*D1**2*K*f*fd*s - 583*D1**2*K*f*fd + 638*D1**2*K*f*fdd*s**2 - 638*D1**2*K*f*fdd*s + 319*D1**2*K*f*fdd + 638*D1**2*K*fd**2*s**2 - 638*D1**2*K*fd**2*s - 264*D1**2*b2*fd*s**2 + 528*D1**2*b2*fd*s - 264*D1**2*b2*fd + 132*D1**2*b2*fdd*s**2 - 264*D1**2*b2*fdd*s + 132*D1**2*b2*fdd + 44*D1**2*bd1**2*s*(3*s - 2)*(7*K + 6*f - 7) - 264*D1**2*bd2*f*s**2 + 264*D1**2*bd2*fd*s**2 - 264*D1**2*bd2*fd*s - 22*D1**2*bdd1*(6*f**2*(s**2 + s*(2*r + 5) - 3) + f*(13*K*s**2 - 2*K*s + K + 12*r*s - 37*s**2 - 4*s - 1) + 14*g2*(2*s**2 - 2*s + 1)) + 132*D1**2*bdd2*f*s**2 + 768*D1**2*f**2*fd*r*s - 256*D1**2*f**2*fd*r + 5922*D1**2*f**2*fd*s**2 - 4876*D1**2*f**2*fd*s + 2374*D1**2*f**2*fd - 1176*D1**2*f**2*fdd*r*s + 392*D1**2*f**2*fdd*r - 4446*D1**2*f**2*fdd*s**2 + 3560*D1**2*f**2*fdd*s - 1682*D1**2*f**2*fdd - 2352*D1**2*f*fd**2*r*s + 784*D1**2*f*fd**2*r - 8892*D1**2*f*fd**2*s**2 + 7120*D1**2*f*fd**2*s - 196*D1**2*f*fd**2 + 352*D1**2*f*fd*r*s - 176*D1**2*f*fd*r + 110*D1**2*f*fd*s**2 - 286*D1**2*f*fd*s + 55*D1**2*f*fd - 264*D1**2*f*fdd*r*s + 132*D1**2*f*fdd*r - 110*D1**2*f*fdd*s**2 + 242*D1**2*f*fdd*s - 55*D1**2*f*fdd + 198*D1**2*f*gd2*s**2 + 286*D1**2*f*gdd2*s**2 - 264*D1**2*fd**2*r*s + 132*D1**2*fd**2*r - 110*D1**2*fd**2*s**2 + 242*D1**2*fd**2*s - 132*D1**2*fd**2 + 198*D1**2*fd*g2*s**2 - 572*D1**2*fd*g2*s + 286*D1**2*fd*g2 + 572*D1**2*fd*gd2*s**2 - 484*D1**2*fd*gd2*s + 286*D1**2*fdd*g2*s**2 - 484*D1**2*fdd*g2*s + 242*D1**2*fdd*g2 - 2332*D1*Dd*K*f**2*s**2 + 1166*D1*Dd*K*f**2*s - 583*D1*Dd*K*f**2 + 5104*D1*Dd*K*f*fd*s**2 - 3828*D1*Dd*K*f*fd*s + 638*D1*Dd*K*f*fd - 1056*D1*Dd*b2*f*s**2 + 528*D1*Dd*b2*f*s - 264*D1*Dd*b2*f + 1056*D1*Dd*b2*fd*s**2 - 1320*D1*Dd*b2*fd*s + 264*D1*Dd*b2*fd + 1056*D1*Dd*bd2*f*s**2 - 264*D1*Dd*bd2*f*s + 1024*D1*Dd*f**3*r*s - 256*D1*Dd*f**3*r + 7896*D1*Dd*f**3*s**2 - 4204*D1*Dd*f**3*s + 1974*D1*Dd*f**3 - 9408*D1*Dd*f**2*fd*r*s + 2744*D1*Dd*f**2*fd*r - 35568*D1*Dd*f**2*fd*s**2 + 24308*D1*Dd*f**2*fd*s - 3952*D1*Dd*f**2*fd + 704*D1*Dd*f**2*r*s - 176*D1*Dd*f**2*r + 220*D1*Dd*f**2*s**2 - 286*D1*Dd*f**2*s + 55*D1*Dd*f**2 - 2112*D1*Dd*f*fd*r*s + 792*D1*Dd*f*fd*r - 880*D1*Dd*f*fd*s**2 + 1452*D1*Dd*f*fd*s - 374*D1*Dd*f*fd + 792*D1*Dd*f*g2*s**2 - 396*D1*Dd*f*g2*s + 198*D1*Dd*f*g2 + 2288*D1*Dd*f*gd2*s**2 - 572*D1*Dd*f*gd2*s + 2288*D1*Dd*fd*g2*s**2 - 2508*D1*Dd*fd*g2*s + 484*D1*Dd*fd*g2 + 1276*D1*Ddd*K*f**2*s**2 - 638*D1*Ddd*K*f**2*s + 319*D1*Ddd*K*f**2 + 528*D1*Ddd*b2*f*s**2 - 264*D1*Ddd*b2*f*s + 132*D1*Ddd*b2*f - 1568*D1*Ddd*f**3*r*s + 392*D1*Ddd*f**3*r - 5928*D1*Ddd*f**3*s**2 + 3356*D1*Ddd*f**3*s - 1482*D1*Ddd*f**3 - 528*D1*Ddd*f**2*r*s + 132*D1*Ddd*f**2*r - 220*D1*Ddd*f**2*s**2 + 242*D1*Ddd*f**2*s - 55*D1*Ddd*f**2 + 1144*D1*Ddd*f*g2*s**2 - 572*D1*Ddd*f*g2*s + 286*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(6*f**2*(-3*s**2 + s*(2*r + 11) - 6) - f*(K*(9*s**2 + 4*s - 2) + 6*fd*(r*(8*s - 2) + (1 - 2*s)**2) - 24*r*s + 39*s**2 + 8*s + 2) - 2*fd*(6*r*(2*s - 1) + s**2*(13*K - 37) + s*(33 - 12*K) + 3) + 28*g2*(2*s**2 - 2*s + 1) + 28*gd2*s*(1 - 2*s)) - 2*Dd*(3*f**2*(2*r*(8*s - 1) + 8*s**2 + 16*s - 5) + f*(52*K*s**2 - 17*K*s + K + 48*r*s - 6*r - 148*s**2 + 23*s + 2) + 14*g2*(8*s**2 - 6*s + 1))) + 3828*Dd**2*K*f**2*s**2 - 1914*Dd**2*K*f**2*s + 1584*Dd**2*b2*f*s**2 - 792*Dd**2*b2*f*s - 4704*Dd**2*f**3*r*s + 1176*Dd**2*f**3*r - 17784*Dd**2*f**3*s**2 + 10068*Dd**2*f**3*s - 392*Dd**2*f**3 - 1584*Dd**2*f**2*r*s + 396*Dd**2*f**2*r - 660*Dd**2*f**2*s**2 + 726*Dd**2*f**2*s - 132*Dd**2*f**2 + 3432*Dd**2*f*g2*s**2 - 1716*Dd**2*f*g2*s) + 1716*b2*(D1**2*(-f*(fd*(-4*s**2 + 4*s - 2) + fdd*(2*s**2 - 2*s + 1) + s**2*(-2*bd1 + bdd1)) - 2*fd*s*(bd1 + fd)*(s - 1)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(bd1*s + fd*(2*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(3003*d**2*k2**2) - 2*D1**2*Pk1*Pk2*ct**2*(-2178*D1**2*K*bdd1*f**2*s**2 - 1155*D1**2*b2*bdd1*f*s**2 + 2772*D1**2*b2*f*fd*s**2 - 2772*D1**2*b2*f*fd*s + 1386*D1**2*b2*f*fd - 1980*D1**2*b2*f*fdd*s**2 + 1980*D1**2*b2*f*fdd*s - 990*D1**2*b2*f*fdd - 1980*D1**2*b2*fd**2*s**2 + 1980*D1**2*b2*fd**2*s - 33*D1**2*bd1**2*(f**2*(r*(22*s - 32) + 156*s**2 - 175*s + 16) + f*(-2*r*(5*s + 8) + s*(76*K*s + 62*K + 64*s - 41)) + 112*g2*s*(s - 1)) + 1386*D1**2*bd2*f**2*s**2 - 3960*D1**2*bd2*f*fd*s**2 + 1980*D1**2*bd2*f*fd*s + 1054*D1**2*bdd1*f**3*r*s + 530*D1**2*bdd1*f**3*r + 1089*D1**2*bdd1*f**3*s**2 + 2508*D1**2*bdd1*f**3*s - 1650*D1**2*bdd1*f**3 + 792*D1**2*bdd1*f**2*r*s + 198*D1**2*bdd1*f**2*s**2 + 2508*D1**2*bdd1*f*g2*s**2 + 4092*D1**2*bdd1*f*g2*s - 2046*D1**2*bdd1*f*g2 - 990*D1**2*bdd2*f**2*s**2 - 3180*D1**2*f**3*fd*r*s + 795*D1**2*f**3*fd*r - 7920*D1**2*f**3*fd*s**2 + 4755*D1**2*f**3*fd*s - 1980*D1**2*f**3*fd + 3180*D1**2*f**3*fdd*r*s - 795*D1**2*f**3*fdd*r + 7920*D1**2*f**3*fdd*s**2 - 4755*D1**2*f**3*fdd*s + 1980*D1**2*f**3*fdd + 9540*D1**2*f**2*fd**2*r*s - 2385*D1**2*f**2*fd**2*r + 23760*D1**2*f**2*fd**2*s**2 - 14265*D1**2*f**2*fd**2*s + 795*D1**2*f**2*fd**2 - 5082*D1**2*f**2*gd2*s**2 + 4356*D1**2*f**2*gdd2*s**2 - 10164*D1**2*f*fd*g2*s**2 + 10164*D1**2*f*fd*g2*s - 5082*D1**2*f*fd*g2 + 17424*D1**2*f*fd*gd2*s**2 - 8712*D1**2*f*fd*gd2*s + 8712*D1**2*f*fdd*g2*s**2 - 8712*D1**2*f*fdd*g2*s + 4356*D1**2*f*fdd*g2 + 8712*D1**2*fd**2*g2*s**2 - 8712*D1**2*fd**2*g2*s + 5544*D1*Dd*b2*f**2*s**2 - 2772*D1*Dd*b2*f**2*s + 1386*D1*Dd*b2*f**2 - 15840*D1*Dd*b2*f*fd*s**2 + 11880*D1*Dd*b2*f*fd*s - 1980*D1*Dd*b2*f*fd - 7920*D1*Dd*bd2*f**2*s**2 + 1980*D1*Dd*bd2*f**2*s - 3180*D1*Dd*f**4*r*s + 795*D1*Dd*f**4*r - 7920*D1*Dd*f**4*s**2 + 4755*D1*Dd*f**4*s - 1980*D1*Dd*f**4 + 25440*D1*Dd*f**3*fd*r*s - 6360*D1*Dd*f**3*fd*r + 63360*D1*Dd*f**3*fd*s**2 - 38040*D1*Dd*f**3*fd*s + 5550*D1*Dd*f**3*fd - 20328*D1*Dd*f**2*g2*s**2 + 10164*D1*Dd*f**2*g2*s - 5082*D1*Dd*f**2*g2 + 34848*D1*Dd*f**2*gd2*s**2 - 8712*D1*Dd*f**2*gd2*s + 69696*D1*Dd*f*fd*g2*s**2 - 52272*D1*Dd*f*fd*g2*s + 8712*D1*Dd*f*fd*g2 - 3960*D1*Ddd*b2*f**2*s**2 + 1980*D1*Ddd*b2*f**2*s - 990*D1*Ddd*b2*f**2 + 3180*D1*Ddd*f**4*r*s - 795*D1*Ddd*f**4*r + 7920*D1*Ddd*f**4*s**2 - 4755*D1*Ddd*f**4*s + 1980*D1*Ddd*f**4 + 17424*D1*Ddd*f**2*g2*s**2 - 8712*D1*Ddd*f**2*g2*s + 4356*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-f**3*(r*(854*s + 730) + 99*s**2 + 3828*s - 2310) + f**2*(2*fd*(r*(3162*s + 3) + 3267*s**2 + 892*s + 131) + 33*s*(77*K*s - 38*r + 7*s)) - 33*f*(-12*fd*(r*(8*s - 2) + s*(-22*K*s + 11*K + 2*s - 3)) + 82*g2*(s**2 + 2*s - 1) - s*(4*gd2*(38*s + 31) + s*(49*b2 - 70*bd2))) - 66*fd*s*(35*b2 - 76*g2)*(s - 1)) + 2*Dd*f*(f**2*(r*(4216*s + 533) + 4356*s**2 + 3400*s - 1519) + 198*f*(2*r*(8*s - 1) + s*(-44*K*s + 11*K + 4*s - 3)) + (132*s - 33)*(-35*b2*s + g2*(76*s + 62)))) - 11880*Dd**2*b2*f**2*s**2 + 5940*Dd**2*b2*f**2*s + 9540*Dd**2*f**4*r*s - 2385*Dd**2*f**4*r + 23760*Dd**2*f**4*s**2 - 14265*Dd**2*f**4*s + 795*Dd**2*f**4 + 52272*Dd**2*f**2*g2*s**2 - 26136*Dd**2*f**2*g2*s + 231*b1**3*(D1**2*s*(2*fd*r + 7*fd*s - 2*fdd*r - 5*fdd*s) + D1*(Dd*f*(r*(8*s - 2) + 28*s**2 - 16*s + 7) - 2*Dd*(4*K*(4*s**2 - 2*s + 1) + r*(fd*(8*s - 1) - 8*s + 2) + s**2*(20*fd - 16) + s*(10 - 6*fd) - 4) + Ddd*f*(r*(2 - 8*s) - 20*s**2 + 12*s - 5) + 2*Ddd*(K*(8*s**2 - 4*s + 2) - 4*r*s + r - 8*s**2 + 5*s - 2)) - 2*Dd**2*(-24*K*s**2 + 12*K*s + f*(3*r*(4*s - 1) + 30*s**2 - 18*s + 1) + 3*r*(4*s - 1) + 24*s**2 - 15*s + 1)) + 33*b1**2*(41*D1**2*K*fd*s**2 - 164*D1**2*K*fd*s + 82*D1**2*K*fd - 38*D1**2*K*fdd*s**2 + 138*D1**2*K*fdd*s - 69*D1**2*K*fdd - 7*D1**2*bdd1*(-2*K*(6*s**2 - 4*s + 2) + f*(r*(6*s - 2) + 15*s**2 - 12*s + 5) + 6*r*s - 2*r + 12*s**2 - 10*s + 4) + 38*D1**2*f*fd*r*s + 21*D1**2*f*fd*r + 252*D1**2*f*fd*s**2 - 20*D1**2*f*fd*s - 22*D1**2*f*fdd*r*s - 21*D1**2*f*fdd*r - 156*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s + 12*D1**2*f*fdd - 22*D1**2*fd**2*r*s - 21*D1**2*fd**2*r - 156*D1**2*fd**2*s**2 - 8*D1**2*fd**2*s - 3*D1**2*fd*r*s + 35*D1**2*fd*r + 57*D1**2*fd*s**2 - 64*D1**2*fd*s + 16*D1**2*fd + 5*D1**2*fdd*r*s - 21*D1**2*fdd*r - 32*D1**2*fdd*s**2 + 18*D1**2*fdd*s - D1**2*fdd + 112*D1**2*gd2*s**2 - 56*D1**2*gdd2*s**2 + 164*D1*Dd*K*f*s**2 - 82*D1*Dd*K*f*s + 41*D1*Dd*K*f - 304*D1*Dd*K*fd*s**2 + 628*D1*Dd*K*fd*s - 138*D1*Dd*K*fd + 76*D1*Dd*f**2*r*s - 19*D1*Dd*f**2*r + 504*D1*Dd*f**2*s**2 - 271*D1*Dd*f**2*s + 126*D1*Dd*f**2 - 176*D1*Dd*f*fd*r*s - 62*D1*Dd*f*fd*r - 1248*D1*Dd*f*fd*s**2 + 302*D1*Dd*f*fd*s + 29*D1*Dd*f*fd - 12*D1*Dd*f*r*s + 3*D1*Dd*f*r + 228*D1*Dd*f*s**2 - 111*D1*Dd*f*s + 57*D1*Dd*f + 40*D1*Dd*fd*r*s - 89*D1*Dd*fd*r - 256*D1*Dd*fd*s**2 + 131*D1*Dd*fd*s + 3*D1*Dd*fd + 448*D1*Dd*g2*s**2 - 224*D1*Dd*g2*s + 112*D1*Dd*g2 - 448*D1*Dd*gd2*s**2 + 112*D1*Dd*gd2*s - 152*D1*Ddd*K*f*s**2 + 76*D1*Ddd*K*f*s - 38*D1*Ddd*K*f - 44*D1*Ddd*f**2*r*s + 11*D1*Ddd*f**2*r - 312*D1*Ddd*f**2*s**2 + 167*D1*Ddd*f**2*s - 78*D1*Ddd*f**2 + 20*D1*Ddd*f*r*s - 5*D1*Ddd*f*r - 128*D1*Ddd*f*s**2 + 59*D1*Ddd*f*s - 32*D1*Ddd*f - 224*D1*Ddd*g2*s**2 + 112*D1*Ddd*g2*s - 56*D1*Ddd*g2 + 7*D1*bd1*(D1*(-8*K*(3*s**2 - 2*s + 1) + f*(r*(6*s - 2) + 21*s**2 - 16*s + 7) - 30*fd*s**2 + 12*fd*s - 2*r*(6*fd*s - fd - 6*s + 2) + 24*s**2 - 20*s + 8) - 2*Dd*(-4*K*(12*s**2 - 7*s + 1) + f*(r*(24*s - 7) + 60*s**2 - 42*s + 7) + 24*r*s - 7*r + 48*s**2 - 35*s + 6)) - 456*Dd**2*K*f*s**2 + 228*Dd**2*K*f*s - 132*Dd**2*f**2*r*s + 33*Dd**2*f**2*r - 936*Dd**2*f**2*s**2 + 501*Dd**2*f**2*s - 11*Dd**2*f**2 + 60*Dd**2*f*r*s - 15*Dd**2*f*r - 384*Dd**2*f*s**2 + 177*Dd**2*f*s + 5*Dd**2*f - 672*Dd**2*g2*s**2 + 336*Dd**2*g2*s) + b1*(5082*D1**2*K*f*fd*s**2 - 5082*D1**2*K*f*fd*s + 2541*D1**2*K*f*fd - 4356*D1**2*K*f*fdd*s**2 + 4356*D1**2*K*f*fdd*s - 2178*D1**2*K*f*fdd - 4356*D1**2*K*fd**2*s**2 + 4356*D1**2*K*fd**2*s + 1617*D1**2*b2*fd*s**2 - 3234*D1**2*b2*fd*s + 1617*D1**2*b2*fd - 1155*D1**2*b2*fdd*s**2 + 2310*D1**2*b2*fdd*s - 1155*D1**2*b2*fdd - 462*D1**2*bd1**2*(-12*K*s**2 + 8*K*s + f*(r*(6*s - 2) + 15*s**2 - 12*s + 1) + r*(6*s - 2) + 12*s**2 - 10*s + 1) + 1617*D1**2*bd2*f*s**2 - 2310*D1**2*bd2*fd*s**2 + 2310*D1**2*bd2*fd*s - 33*D1**2*bdd1*(f**2*(r*(22*s - 32) + 156*s**2 - 175*s + 90) + f*(K*(76*s**2 + 62*s - 31) - 2*r*(5*s + 8) + 64*s**2 - 41*s + 31) + 56*g2*(2*s**2 - 2*s + 1)) - 1155*D1**2*bdd2*f*s**2 - 2562*D1**2*f**2*fd*r*s + 1584*D1**2*f**2*fd*r - 297*D1**2*f**2*fd*s**2 + 4880*D1**2*f**2*fd*s - 2409*D1**2*f**2*fd + 3162*D1**2*f**2*fdd*r*s - 1584*D1**2*f**2*fdd*r + 3267*D1**2*f**2*fdd*s**2 - 5740*D1**2*f**2*fdd*s + 2739*D1**2*f**2*fdd + 6324*D1**2*f*fd**2*r*s - 3168*D1**2*f*fd**2*r + 6534*D1**2*f*fd**2*s**2 - 11480*D1**2*f*fd**2*s + 792*D1**2*f*fd**2 - 2508*D1**2*f*fd*r*s + 1254*D1**2*f*fd*r + 462*D1**2*f*fd*s**2 + 792*D1**2*f*fd*s + 231*D1**2*f*fd + 1584*D1**2*f*fdd*r*s - 792*D1**2*f*fdd*r + 396*D1**2*f*fdd*s**2 - 1188*D1**2*f*fdd*s + 198*D1**2*f*fdd - 2706*D1**2*f*gd2*s**2 + 2508*D1**2*f*gdd2*s**2 + 1584*D1**2*fd**2*r*s - 792*D1**2*fd**2*r + 396*D1**2*fd**2*s**2 - 1188*D1**2*fd**2*s + 792*D1**2*fd**2 - 2706*D1**2*fd*g2*s**2 + 10824*D1**2*fd*g2*s - 5412*D1**2*fd*g2 + 5016*D1**2*fd*gd2*s**2 - 9108*D1**2*fd*gd2*s + 2508*D1**2*fdd*g2*s**2 - 9108*D1**2*fdd*g2*s + 4554*D1**2*fdd*g2 + 10164*D1*Dd*K*f**2*s**2 - 5082*D1*Dd*K*f**2*s + 2541*D1*Dd*K*f**2 - 34848*D1*Dd*K*f*fd*s**2 + 26136*D1*Dd*K*f*fd*s - 4356*D1*Dd*K*f*fd + 6468*D1*Dd*b2*f*s**2 - 3234*D1*Dd*b2*f*s + 1617*D1*Dd*b2*f - 9240*D1*Dd*b2*fd*s**2 + 11550*D1*Dd*b2*fd*s - 2310*D1*Dd*b2*fd - 9240*D1*Dd*bd2*f*s**2 + 2310*D1*Dd*bd2*f*s - 3416*D1*Dd*f**3*r*s + 854*D1*Dd*f**3*r - 396*D1*Dd*f**3*s**2 + 1052*D1*Dd*f**3*s - 99*D1*Dd*f**3 + 25296*D1*Dd*f**2*fd*r*s - 9498*D1*Dd*f**2*fd*r + 26136*D1*Dd*f**2*fd*s**2 - 32656*D1*Dd*f**2*fd*s + 7324*D1*Dd*f**2*fd - 5016*D1*Dd*f**2*r*s + 1254*D1*Dd*f**2*r + 924*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s + 231*D1*Dd*f**2 + 12672*D1*Dd*f*fd*r*s - 4752*D1*Dd*f*fd*r + 3168*D1*Dd*f*fd*s**2 - 7128*D1*Dd*f*fd*s + 1980*D1*Dd*f*fd - 10824*D1*Dd*f*g2*s**2 + 5412*D1*Dd*f*g2*s - 2706*D1*Dd*f*g2 + 20064*D1*Dd*f*gd2*s**2 - 5016*D1*Dd*f*gd2*s + 20064*D1*Dd*fd*g2*s**2 - 41448*D1*Dd*fd*g2*s + 9108*D1*Dd*fd*g2 - 8712*D1*Ddd*K*f**2*s**2 + 4356*D1*Ddd*K*f**2*s - 2178*D1*Ddd*K*f**2 - 4620*D1*Ddd*b2*f*s**2 + 2310*D1*Ddd*b2*f*s - 1155*D1*Ddd*b2*f + 4216*D1*Ddd*f**3*r*s - 1054*D1*Ddd*f**3*r + 4356*D1*Ddd*f**3*s**2 - 3232*D1*Ddd*f**3*s + 1089*D1*Ddd*f**3 + 3168*D1*Ddd*f**2*r*s - 792*D1*Ddd*f**2*r + 792*D1*Ddd*f**2*s**2 - 1188*D1*Ddd*f**2*s + 198*D1*Ddd*f**2 + 10032*D1*Ddd*f*g2*s**2 - 5016*D1*Ddd*f*g2*s + 2508*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(f**2*(r*(38*s - 40) + 252*s**2 - 251*s + 126) + f*(41*K*(2*s**2 + 2*s - 1) + fd*(r*(22 - 88*s) - 624*s**2 + 334*s + 5) - 6*r*s - 32*r + 114*s**2 - 47*s + 41) + fd*(r*(20*s - 26) - s**2*(152*K + 128) + s*(214*K + 77) + 5) + 112*g2*(2*s**2 - 2*s + 1) + 112*gd2*s*(1 - 2*s)) - Dd*(f**2*(2*r*(88*s - 75) + 1248*s**2 - 1034*s + 207) + f*(K*(608*s**2 + 96*s - 62) - 80*r*s - 54*r + 512*s**2 - 282*s + 57) + 112*g2*(8*s**2 - 6*s + 1))) - 26136*Dd**2*K*f**2*s**2 + 13068*Dd**2*K*f**2*s - 13860*Dd**2*b2*f*s**2 + 6930*Dd**2*b2*f*s + 12648*Dd**2*f**3*r*s - 3162*Dd**2*f**3*r + 13068*Dd**2*f**3*s**2 - 9696*Dd**2*f**3*s + 1054*Dd**2*f**3 + 9504*Dd**2*f**2*r*s - 2376*Dd**2*f**2*r + 2376*Dd**2*f**2*s**2 - 3564*Dd**2*f**2*s + 792*Dd**2*f**2 + 30096*Dd**2*f*g2*s**2 - 15048*Dd**2*f*g2*s))/(693*d**2*k2**2) + 8*D1**2*Pk1*Pk2*ct*f*k1**3*k2*st**4*(11*D1**2*bd1*f*(r + s - 1)**2 + 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 11*D1*b1*(D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*D1*f*(2*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) - Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 4*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1))/(77*d**2*k3**6) + 16*D1**2*Pk1*Pk2*ct*f*k1**3*st**4*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1))/(77*d**2*k2*k3**4) + 8*D1**2*Pk1*Pk2*ct*f*k1**3*st**4*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k2**3*k3**2) + 20*D1**2*Pk1*Pk2*ct*f*st**6*(-13*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(6*fd*(4*s**2 - 2*s + 1) - 3*fdd*(4*s**2 - 2*s + 1) + s**2*(-26*bd1 + 13*bdd1)) + 2*fd*s*(13*bd1*(3*s - 1) + 9*fd*(1 - 2*s))) + D1*f*(6*Dd*f*(4*s**2 - 2*s + 1) + 2*Dd*(4*s - 1)*(13*bd1*s + fd*(3 - 12*s)) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(429*d**2*k1*k2) + 4*D1**2*Pk1*Pk2*ct*k1**5*st**2*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 66*D1**2*b1*f*fd*s + 33*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 51*D1**2*f**2*fd*r**2 + 102*D1**2*f**2*fd*r*s - 68*D1**2*f**2*fd*r + 51*D1**2*f**2*fd*s**2 - 68*D1**2*f**2*fd*s + 34*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 528*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 528*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 68*D1*Dd*f**3*r**2 + 136*D1*Dd*f**3*r*s - 68*D1*Dd*f**3*r + 68*D1*Dd*f**3*s**2 - 68*D1*Dd*f**3*s + 34*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 700*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 700*D1*Dd*f**2*fd*s - 200*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 132*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 100*D1*Ddd*f**3*s - 50*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 4*Dd*f*(2*r + 2*s - 1)) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 396*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 300*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 300*Dd**2*f**3*s - 50*Dd**2*f**3)/(693*d**2*k2*k3**6) + 8*D1**2*Pk1*Pk2*ct*k1**5*(-D1*f*(r + s - 1)*(12*D1*bd1**2*(r + s - 1) + 5*D1*bdd1*f*(r + s - 1) + bd1*(-4*D1*f*(r + s - 1) + 10*D1*fd*(2*r + 2*s - 1) + 20*Dd*f*(2*r + 2*s - 1))) + b1**2*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + 2*D1*(Dd*(5*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 12*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(-12*D1**2*bdd1*f*(r + s - 1)**2 + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 8*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 80*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 20*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 + 2*D1*bd1*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 60*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k2*k3**6) + 4*D1**2*Pk1*Pk2*ct*k1**3*k2*st**2*(33*b1**2*(D1**2*(19*fd - 6*fdd)*(r + s)**2 + 2*D1*(Dd*(19*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 12*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 33*b1*(64*C*D1**2*f*fd*r**2 + 128*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*r + 64*C*D1**2*f*fd*s**2 - 64*C*D1**2*f*fd*s + 32*C*D1**2*f*fd - 48*C*D1**2*f*fdd*r**2 - 96*C*D1**2*f*fdd*r*s + 48*C*D1**2*f*fdd*r - 48*C*D1**2*f*fdd*s**2 + 48*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r**2 - 96*C*D1**2*fd**2*r*s + 48*C*D1**2*fd**2*r - 48*C*D1**2*fd**2*s**2 + 48*C*D1**2*fd**2*s + 128*C*D1*Dd*f**2*r**2 + 256*C*D1*Dd*f**2*r*s - 128*C*D1*Dd*f**2*r + 128*C*D1*Dd*f**2*s**2 - 128*C*D1*Dd*f**2*s + 64*C*D1*Dd*f**2 - 384*C*D1*Dd*f*fd*r**2 - 768*C*D1*Dd*f*fd*r*s + 384*C*D1*Dd*f*fd*r - 384*C*D1*Dd*f*fd*s**2 + 384*C*D1*Dd*f*fd*s - 96*C*D1*Dd*f*fd - 96*C*D1*Ddd*f**2*r**2 - 192*C*D1*Ddd*f**2*r*s + 96*C*D1*Ddd*f**2*r - 96*C*D1*Ddd*f**2*s**2 + 96*C*D1*Ddd*f**2*s - 48*C*D1*Ddd*f**2 - 288*C*Dd**2*f**2*r**2 - 576*C*Dd**2*f**2*r*s + 288*C*Dd**2*f**2*r - 288*C*Dd**2*f**2*s**2 + 288*C*Dd**2*f**2*s - 48*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(r + s - 1)**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 14*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 14*D1**2*f*fdd*s**2 + 14*D1**2*f*fdd*s - 7*D1**2*f*fdd - 14*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 14*D1**2*fd**2*s**2 + 14*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 44*D1*Dd*f**2*s + 22*D1*Dd*f**2 - 112*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 112*D1*Dd*f*fd*r - 112*D1*Dd*f*fd*s**2 + 112*D1*Dd*f*fd*s - 28*D1*Dd*f*fd - 28*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 28*D1*Ddd*f**2*r - 28*D1*Ddd*f**2*s**2 + 28*D1*Ddd*f**2*s - 14*D1*Ddd*f**2 + 2*D1*bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) - 84*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 84*Dd**2*f**2*r - 84*Dd**2*f**2*s**2 + 84*Dd**2*f**2*s - 14*Dd**2*f**2) + f*(2016*C*D1**2*f*fd*r**2 + 4032*C*D1**2*f*fd*r*s - 2688*C*D1**2*f*fd*r + 2016*C*D1**2*f*fd*s**2 - 2688*C*D1**2*f*fd*s + 1344*C*D1**2*f*fd - 1800*C*D1**2*f*fdd*r**2 - 3600*C*D1**2*f*fdd*r*s + 2400*C*D1**2*f*fdd*r - 1800*C*D1**2*f*fdd*s**2 + 2400*C*D1**2*f*fdd*s - 1200*C*D1**2*f*fdd - 3600*C*D1**2*fd**2*r**2 - 7200*C*D1**2*fd**2*r*s + 4800*C*D1**2*fd**2*r - 3600*C*D1**2*fd**2*s**2 + 4800*C*D1**2*fd**2*s - 1200*C*D1**2*fd**2 + 2688*C*D1*Dd*f**2*r**2 + 5376*C*D1*Dd*f**2*r*s - 2688*C*D1*Dd*f**2*r + 2688*C*D1*Dd*f**2*s**2 - 2688*C*D1*Dd*f**2*s + 1344*C*D1*Dd*f**2 - 14400*C*D1*Dd*f*fd*r**2 - 28800*C*D1*Dd*f*fd*r*s + 16800*C*D1*Dd*f*fd*r - 14400*C*D1*Dd*f*fd*s**2 + 16800*C*D1*Dd*f*fd*s - 4800*C*D1*Dd*f*fd - 2400*C*D1*Ddd*f**2*r**2 - 4800*C*D1*Ddd*f**2*r*s + 2400*C*D1*Ddd*f**2*r - 2400*C*D1*Ddd*f**2*s**2 + 2400*C*D1*Ddd*f**2*s - 1200*C*D1*Ddd*f**2 - 7200*C*Dd**2*f**2*r**2 - 14400*C*Dd**2*f**2*r*s + 7200*C*Dd**2*f**2*r - 7200*C*Dd**2*f**2*s**2 + 7200*C*Dd**2*f**2*s - 1200*C*Dd**2*f**2 - 396*D1**2*bd1**2*(r + s - 1)**2 - 33*D1**2*bdd1*f*(24*C + 7)*(r + s - 1)**2 - 48*D1**2*f*fd*r**2 - 96*D1**2*f*fd*r*s + 64*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 64*D1**2*f*fd*s - 32*D1**2*f*fd - 75*D1**2*f*fdd*r**2 - 150*D1**2*f*fdd*r*s + 100*D1**2*f*fdd*r - 75*D1**2*f*fdd*s**2 + 100*D1**2*f*fdd*s - 50*D1**2*f*fdd - 150*D1**2*fd**2*r**2 - 300*D1**2*fd**2*r*s + 200*D1**2*fd**2*r - 150*D1**2*fd**2*s**2 + 200*D1**2*fd**2*s - 50*D1**2*fd**2 - 64*D1*Dd*f**2*r**2 - 128*D1*Dd*f**2*r*s + 64*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 + 64*D1*Dd*f**2*s - 32*D1*Dd*f**2 - 600*D1*Dd*f*fd*r**2 - 1200*D1*Dd*f*fd*r*s + 700*D1*Dd*f*fd*r - 600*D1*Dd*f*fd*s**2 + 700*D1*Dd*f*fd*s - 200*D1*Dd*f*fd - 100*D1*Ddd*f**2*r**2 - 200*D1*Ddd*f**2*r*s + 100*D1*Ddd*f**2*r - 100*D1*Ddd*f**2*s**2 + 100*D1*Ddd*f**2*s - 50*D1*Ddd*f**2 + 33*D1*bd1*(r + s - 1)*(D1*f*(32*C + 11)*(r + s - 1) - D1*fd*(48*C + 14)*(2*r + 2*s - 1) - Dd*f*(96*C + 28)*(2*r + 2*s - 1)) - 300*Dd**2*f**2*r**2 - 600*Dd**2*f**2*r*s + 300*Dd**2*f**2*r - 300*Dd**2*f**2*s**2 + 300*Dd**2*f**2*s - 50*Dd**2*f**2))/(693*d**2*k3**6) + 8*D1**2*Pk1*Pk2*ct*k1**3*k2*(-D1*f*(r + s - 1)*(12*D1*bd1**2*(8*C + 1)*(r + s - 1) + 5*D1*bdd1*f*(8*C + 1)*(r + s - 1) + 2*bd1*(-D1*f*(16*C - 1)*(r + s - 1) + D1*fd*(40*C + 5)*(2*r + 2*s - 1) + Dd*f*(80*C + 10)*(2*r + 2*s - 1))) + 2*b1**2*(D1**2*(r + s)**2*(-24*C*fdd + fd*(20*C - 1) - 3*fdd) + 2*D1*(Dd*(f*(20*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(48*C + 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(-24*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(48*C + 6)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(64*C*D1**2*f*fd*r**2 + 128*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*r + 64*C*D1**2*f*fd*s**2 - 64*C*D1**2*f*fd*s + 32*C*D1**2*f*fd - 80*C*D1**2*f*fdd*r**2 - 160*C*D1**2*f*fdd*r*s + 80*C*D1**2*f*fdd*r - 80*C*D1**2*f*fdd*s**2 + 80*C*D1**2*f*fdd*s - 40*C*D1**2*f*fdd - 80*C*D1**2*fd**2*r**2 - 160*C*D1**2*fd**2*r*s + 80*C*D1**2*fd**2*r - 80*C*D1**2*fd**2*s**2 + 80*C*D1**2*fd**2*s + 128*C*D1*Dd*f**2*r**2 + 256*C*D1*Dd*f**2*r*s - 128*C*D1*Dd*f**2*r + 128*C*D1*Dd*f**2*s**2 - 128*C*D1*Dd*f**2*s + 64*C*D1*Dd*f**2 - 640*C*D1*Dd*f*fd*r**2 - 1280*C*D1*Dd*f*fd*r*s + 640*C*D1*Dd*f*fd*r - 640*C*D1*Dd*f*fd*s**2 + 640*C*D1*Dd*f*fd*s - 160*C*D1*Dd*f*fd - 160*C*D1*Ddd*f**2*r**2 - 320*C*D1*Ddd*f**2*r*s + 160*C*D1*Ddd*f**2*r - 160*C*D1*Ddd*f**2*s**2 + 160*C*D1*Ddd*f**2*s - 80*C*D1*Ddd*f**2 - 480*C*Dd**2*f**2*r**2 - 960*C*Dd**2*f**2*r*s + 480*C*Dd**2*f**2*r - 480*C*Dd**2*f**2*s**2 + 480*C*Dd**2*f**2*s - 80*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(8*C + 1)*(r + s - 1)**2 - 4*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 2*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s - 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 8*D1*Dd*f**2*s - 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 80*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 20*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 + 4*D1*bd1*(r + s - 1)*(D1*f*(20*C - 1)*(r + s - 1) - D1*fd*(48*C + 6)*(r + s) - Dd*f*(96*C + 12)*(2*r + 2*s - 1)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 60*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k3**6) + D1**2*Pk1*Pk2*ct*k1**3*st**2*(396*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 33*b1*(96*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*r + 96*C*D1**2*f*fd*s**2 - 96*C*D1**2*f*fd*s + 48*C*D1**2*f*fd - 64*C*D1**2*f*fdd*r*s + 32*C*D1**2*f*fdd*r - 64*C*D1**2*f*fdd*s**2 + 64*C*D1**2*f*fdd*s - 32*C*D1**2*f*fdd - 64*C*D1**2*fd**2*r*s + 32*C*D1**2*fd**2*r - 64*C*D1**2*fd**2*s**2 + 64*C*D1**2*fd**2*s + 192*C*D1*Dd*f**2*r*s - 48*C*D1*Dd*f**2*r + 192*C*D1*Dd*f**2*s**2 - 144*C*D1*Dd*f**2*s + 48*C*D1*Dd*f**2 - 512*C*D1*Dd*f*fd*r*s + 192*C*D1*Dd*f*fd*r - 512*C*D1*Dd*f*fd*s**2 + 448*C*D1*Dd*f*fd*s - 96*C*D1*Dd*f*fd - 128*C*D1*Ddd*f**2*r*s + 32*C*D1*Ddd*f**2*r - 128*C*D1*Ddd*f**2*s**2 + 96*C*D1*Ddd*f**2*s - 32*C*D1*Ddd*f**2 - 384*C*Dd**2*f**2*r*s + 96*C*Dd**2*f**2*r - 384*C*Dd**2*f**2*s**2 + 288*C*Dd**2*f**2*s - 32*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 26*D1**2*f*fd*r**2 - 84*D1**2*f*fd*r*s + 66*D1**2*f*fd*r - 58*D1**2*f*fd*s**2 + 82*D1**2*f*fd*s - 53*D1**2*f*fd + 22*D1**2*f*fdd*r**2 + 84*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r + 62*D1**2*f*fdd*s**2 - 74*D1**2*f*fdd*s + 43*D1**2*f*fdd + 22*D1**2*fd**2*r**2 + 84*D1**2*fd**2*r*s - 54*D1**2*fd**2*r + 62*D1**2*fd**2*s**2 - 74*D1**2*fd**2*s - 52*D1*Dd*f**2*r**2 - 168*D1*Dd*f**2*r*s + 68*D1*Dd*f**2*r - 116*D1*Dd*f**2*s**2 + 100*D1*Dd*f**2*s - 42*D1*Dd*f**2 + 176*D1*Dd*f*fd*r**2 + 672*D1*Dd*f*fd*r*s - 344*D1*Dd*f*fd*r + 496*D1*Dd*f*fd*s**2 - 504*D1*Dd*f*fd*s + 128*D1*Dd*f*fd + 44*D1*Ddd*f**2*r**2 + 168*D1*Ddd*f**2*r*s - 64*D1*Ddd*f**2*r + 124*D1*Ddd*f**2*s**2 - 104*D1*Ddd*f**2*s + 42*D1*Ddd*f**2 + 12*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 132*Dd**2*f**2*r**2 + 504*Dd**2*f**2*r*s - 192*Dd**2*f**2*r + 372*Dd**2*f**2*s**2 - 312*Dd**2*f**2*s + 42*Dd**2*f**2) + f*(3216*C*D1**2*f*fd*r*s - 1072*C*D1**2*f*fd*r + 3216*C*D1**2*f*fd*s**2 - 3216*C*D1**2*f*fd*s + 1072*C*D1**2*f*fd - 2400*C*D1**2*f*fdd*r*s + 800*C*D1**2*f*fdd*r - 2400*C*D1**2*f*fdd*s**2 + 2400*C*D1**2*f*fdd*s - 800*C*D1**2*f*fdd - 4800*C*D1**2*fd**2*r*s + 1600*C*D1**2*fd**2*r - 4800*C*D1**2*fd**2*s**2 + 4800*C*D1**2*fd**2*s - 800*C*D1**2*fd**2 + 4288*C*D1*Dd*f**2*r*s - 1072*C*D1*Dd*f**2*r + 4288*C*D1*Dd*f**2*s**2 - 3216*C*D1*Dd*f**2*s + 1072*C*D1*Dd*f**2 - 19200*C*D1*Dd*f*fd*r*s + 5600*C*D1*Dd*f*fd*r - 19200*C*D1*Dd*f*fd*s**2 + 16800*C*D1*Dd*f*fd*s - 3200*C*D1*Dd*f*fd - 3200*C*D1*Ddd*f**2*r*s + 800*C*D1*Ddd*f**2*r - 3200*C*D1*Ddd*f**2*s**2 + 2400*C*D1*Ddd*f**2*s - 800*C*D1*Ddd*f**2 - 9600*C*Dd**2*f**2*r*s + 2400*C*Dd**2*f**2*r - 9600*C*Dd**2*f**2*s**2 + 7200*C*Dd**2*f**2*s - 800*C*Dd**2*f**2 - 396*D1**2*bd1**2*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(-32*C*s + 11*r + 31*s + 1) - 1191*D1**2*f*fd*r**2 - 5190*D1**2*f*fd*r*s + 2524*D1**2*f*fd*r - 3999*D1**2*f*fd*s**2 + 4396*D1**2*f*fd*s - 1730*D1**2*f*fd + 1041*D1**2*f*fdd*r**2 + 4674*D1**2*f*fdd*r*s - 2252*D1**2*f*fdd*r + 3633*D1**2*f*fdd*s**2 - 3980*D1**2*f*fdd*s + 1558*D1**2*f*fdd + 2082*D1**2*fd**2*r**2 + 9348*D1**2*fd**2*r*s - 4504*D1**2*fd**2*r + 7266*D1**2*fd**2*s**2 - 7960*D1**2*fd**2*s + 1558*D1**2*fd**2 - 1588*D1*Dd*f**2*r**2 - 6920*D1*Dd*f**2*r*s + 2524*D1*Dd*f**2*r - 5332*D1*Dd*f**2*s**2 + 4396*D1*Dd*f**2*s - 1730*D1*Dd*f**2 + 8328*D1*Dd*f*fd*r**2 + 37392*D1*Dd*f*fd*r*s - 15764*D1*Dd*f*fd*r + 29064*D1*Dd*f*fd*s**2 - 27860*D1*Dd*f*fd*s + 6232*D1*Dd*f*fd + 1388*D1*Ddd*f**2*r**2 + 6232*D1*Ddd*f**2*r*s - 2252*D1*Ddd*f**2*r + 4844*D1*Ddd*f**2*s**2 - 3980*D1*Ddd*f**2*s + 1558*D1*Ddd*f**2 + 33*D1*bd1*(D1*(-f*(r + s - 1)*(-48*C*s + 13*r + 29*s + 11) - 2*fd*(16*C*(r*(4*s - 1) + (1 - 2*s)**2) - 22*r**2 - 84*r*s + 37*r - 62*s**2 + 67*s - 21)) - 8*Dd*f*(4*C*(8*r*s - r + 8*s**2 - 7*s + 1) - 11*r**2 - 42*r*s + 13*r - 31*s**2 + 28*s - 5)) + 4164*Dd**2*f**2*r**2 + 18696*Dd**2*f**2*r*s - 6756*Dd**2*f**2*r + 14532*Dd**2*f**2*s**2 - 11940*Dd**2*f**2*s + 1558*Dd**2*f**2))/(693*d**2*k2*k3**4) + 2*D1**2*Pk1*Pk2*ct*k1**3*(b1**2*(-D1**2*(r + s)*(31*fd*r + fd*s*(119 - 40*C) - 47*fdd*r + fdd*s*(48*C - 119)) + 2*D1*(Dd*(f*(20*C*(4*r*s - r + 4*s**2 - 3*s + 1) - 62*r**2 - 300*r*s + 106*r - 238*s**2 + 194*s - 75) + 2*fd*(94*r**2 + r*(-96*C*s + 12*C + 332*s - 65) + s*(-96*C*s + 36*C + 238*s - 101))) + Ddd*f*(-24*C*(4*r*s - r + 4*s**2 - 3*s + 1) + 94*r**2 + 332*r*s - 130*r + 238*s**2 - 202*s + 83)) - 2*Dd**2*f*(24*C*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) - 282*r**2 + r*(390 - 996*s) - 714*s**2 + 606*s - 83)) + 2*b1*(-16*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 8*C*D1**2*f*fdd*s**2 - 28*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s**2 - 28*C*D1**2*fd**2*s - 32*C*D1*Dd*f**2*r*s + 8*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 24*C*D1*Dd*f**2*s - 8*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r*s - 104*C*D1*Dd*f*fd*r + 64*C*D1*Dd*f*fd*s**2 - 136*C*D1*Dd*f*fd*s + 52*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r*s - 4*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s**2 - 12*C*D1*Ddd*f**2*s + 4*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r*s - 12*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s**2 - 36*C*Dd**2*f**2*s + 4*C*Dd**2*f**2 + D1**2*bdd1*f*(r + s - 1)*(-48*C*s + 24*C + 47*r + 119*s - 83) - 34*D1**2*f*fd*r**2 - 132*D1**2*f*fd*r*s + 34*D1**2*f*fd*r - 98*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 17*D1**2*f*fd + 44*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s - 44*D1**2*f*fdd*r + 100*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 22*D1**2*f*fdd + 44*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s - 44*D1**2*fd**2*r + 100*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s - 68*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r*s + 100*D1*Dd*f**2*r - 196*D1*Dd*f**2*s**2 + 164*D1*Dd*f**2*s - 66*D1*Dd*f**2 + 352*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 408*D1*Dd*f*fd*r + 800*D1*Dd*f*fd*s**2 - 632*D1*Dd*f*fd*s + 116*D1*Dd*f*fd + 88*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 116*D1*Ddd*f**2*r + 200*D1*Ddd*f**2*s**2 - 172*D1*Ddd*f**2*s + 72*D1*Ddd*f**2 + D1*bd1*(D1*(f*(r + s - 1)*(20*C*(2*s - 1) - 31*r - 119*s + 75) + 2*fd*(47*r**2 + r*(-48*C*s + 12*C + 166*s - 65) + s*(-48*C*s + 36*C + 119*s - 101))) - 4*Dd*f*(12*C*(8*r*s - 3*r + 8*s**2 - 9*s + 2) - 94*r**2 - 332*r*s + 195*r - 238*s**2 + 303*s - 83)) + 264*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 348*Dd**2*f**2*r + 600*Dd**2*f**2*s**2 - 516*Dd**2*f**2*s + 72*Dd**2*f**2) - 2*f*(20*C*(D1**2*(f*(fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + D1**2*bd1**2*(r + s - 1)*(24*C*(2*s - 1) - 47*r - 119*s + 83) - 2*D1**2*bdd1*f*(r + s - 1)*(2*C*(s + 5) + 11*r + 25*s - 25) + D1*bd1*(D1*(f*(r + s - 1)*(8*C*(s + 2) + 17*r + 49*s - 49) - 4*fd*(C*(4*r*(s + 1) + 4*s**2 + s + 1) + 22*r**2 + 72*r*s - 47*r + 50*s**2 - 68*s + 18)) - 4*Dd*f*(C*(8*r*s + 19*r + 8*s**2 + 13*s - 9) + 44*r**2 + 144*r*s - 101*r + 100*s**2 - 143*s + 43))))/(21*d**2*k2*k3**4) + 2*D1**2*Pk1*Pk2*ct*k1**3*st**2*(22*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 11*b1*(-2*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 30*D1**2*f*fd*s**2 + 38*D1**2*f*fd*s - 19*D1**2*f*fd + 18*D1**2*f*fdd*s**2 - 22*D1**2*f*fdd*s + 11*D1**2*f*fdd + 18*D1**2*fd**2*s**2 - 22*D1**2*fd**2*s - 60*D1*Dd*f**2*s**2 + 30*D1*Dd*f**2*s - 15*D1*Dd*f**2 + 144*D1*Dd*f*fd*s**2 - 124*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 36*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 4*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 108*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s) + f*(-44*D1**2*bd1**2*s*(s - 1) + 11*D1**2*bdd1*f*(9*s**2 + 4*s - 2) - 3*D1**2*(f*(59*fd - 35*fdd)*(3*s**2 - 2*s + 1) + 70*fd**2*s*(2 - 3*s)) - 11*D1*bd1*(D1*f*(15*s**2 + 8*s - 4) + 2*D1*fd*s*(7 - 18*s) + 2*Dd*f*(-36*s**2 + s + 2)) - 3*D1*f*(59*Dd*f*(4*s**2 - 2*s + 1) - 70*Dd*fd*(12*s**2 - 7*s + 1) - 35*Ddd*f*(4*s**2 - 2*s + 1)) - 630*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2**3*k3**2) - 2*D1**2*Pk1*Pk2*ct*k1**3*(b1**2*(D1**2*s**2*(31*fd - 19*fdd) + D1*(31*Dd*f*(4*s**2 - 2*s + 1) + 38*Dd*fd*s*(1 - 4*s) - 19*Ddd*f*(4*s**2 - 2*s + 1)) + 114*Dd**2*f*s*(1 - 2*s)) + b1*(-19*D1**2*bdd1*f*(2*s**2 - 2*s + 1) + 14*D1**2*f*fd*s**2 + 38*D1**2*f*fd*s - 19*D1**2*f*fd + 6*D1**2*f*fdd*s**2 - 38*D1**2*f*fdd*s + 19*D1**2*f*fdd + 6*D1**2*fd**2*s**2 - 38*D1**2*fd**2*s + 28*D1*Dd*f**2*s**2 - 14*D1*Dd*f**2*s + 7*D1*Dd*f**2 + 48*D1*Dd*f*fd*s**2 - 164*D1*Dd*f*fd*s + 38*D1*Dd*f*fd + 12*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + D1*bd1*(31*D1*f*(2*s**2 - 2*s + 1) + 38*D1*fd*s*(1 - 2*s) - 38*Dd*f*(8*s**2 - 6*s + 1)) + 36*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s) + f*(-38*D1**2*bd1**2*s*(s - 1) + D1**2*bdd1*f*(3*s**2 + 32*s - 16) - 16*D1**2*(f*(fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*bd1*(D1*f*(7*s**2 - 52*s + 26) + 2*D1*fd*s*(6*s + 13) + 2*Dd*f*(12*s**2 + 61*s - 16)) - 16*D1*f*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(12*s**2 - 7*s + 1) + Ddd*f*(-4*s**2 + 2*s - 1)) - 96*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2**3*k3**2) - 20*D1**2*Pk1*Pk2*ct*k1*k2**3*st**6*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 264*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 528*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 528*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 28*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s - 8*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 132*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 396*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 12*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s - 2*Dd**2*f**3)/(693*d**2*k3**6) - 8*D1**2*Pk1*Pk2*ct*k1*k2**3*st**4*(66*D1*b1*(2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) - f*(D1*bdd1*(r + s - 1)**2 + (2*C + 1)*(D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1))) + 33*b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) - 2*f*(33*D1**2*bd1**2*(r + s - 1)**2 + 33*D1**2*bd1*f*(2*C + 1)*(r + s - 1)**2 + (20*C + 3)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 2*D1*f*(2*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) - Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd**2*f**2*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1))))/(231*d**2*k3**6) + 4*D1**2*Pk1*Pk2*ct*k1*k2**3*st**2*(D1*f*(-12*D1*bd1**2*(4*C + 1)*(r + s - 1)**2 + bd1*(r + s - 1)*(D1*f*(32*C + 9)*(r + s - 1) - D1*fd*(48*C + 12)*(2*r + 2*s - 1) - Dd*f*(96*C + 24)*(2*r + 2*s - 1)) - f*(6*D1*bdd1*(4*C + 1)*(r + s - 1)**2 + (12*C + 1)*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*Dd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)))) + 2*b1**2*(D1**2*(r + s)**2*(-12*C*fdd + fd*(38*C + 13) - 3*fdd) + 2*D1*(Dd*(f*(38*C + 13)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(24*C + 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) + Ddd*f*(-12*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(24*C + 6)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(64*C*D1**2*f*fd*r**2 + 128*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*r + 64*C*D1**2*f*fd*s**2 - 64*C*D1**2*f*fd*s + 32*C*D1**2*f*fd - 48*C*D1**2*f*fdd*r**2 - 96*C*D1**2*f*fdd*r*s + 48*C*D1**2*f*fdd*r - 48*C*D1**2*f*fdd*s**2 + 48*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r**2 - 96*C*D1**2*fd**2*r*s + 48*C*D1**2*fd**2*r - 48*C*D1**2*fd**2*s**2 + 48*C*D1**2*fd**2*s + 128*C*D1*Dd*f**2*r**2 + 256*C*D1*Dd*f**2*r*s - 128*C*D1*Dd*f**2*r + 128*C*D1*Dd*f**2*s**2 - 128*C*D1*Dd*f**2*s + 64*C*D1*Dd*f**2 - 384*C*D1*Dd*f*fd*r**2 - 768*C*D1*Dd*f*fd*r*s + 384*C*D1*Dd*f*fd*r - 384*C*D1*Dd*f*fd*s**2 + 384*C*D1*Dd*f*fd*s - 96*C*D1*Dd*f*fd - 96*C*D1*Ddd*f**2*r**2 - 192*C*D1*Ddd*f**2*r*s + 96*C*D1*Ddd*f**2*r - 96*C*D1*Ddd*f**2*s**2 + 96*C*D1*Ddd*f**2*s - 48*C*D1*Ddd*f**2 - 288*C*Dd**2*f**2*r**2 - 576*C*Dd**2*f**2*r*s + 288*C*Dd**2*f**2*r - 288*C*Dd**2*f**2*s**2 + 288*C*Dd**2*f**2*s - 48*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(4*C + 1)*(r + s - 1)**2 + 18*D1**2*f*fd*r**2 + 36*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 18*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 9*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 12*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 12*D1**2*fd**2*s + 36*D1*Dd*f**2*r**2 + 72*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r + 36*D1*Dd*f**2*s**2 - 36*D1*Dd*f**2*s + 18*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 96*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 96*D1*Dd*f*fd*s - 24*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 24*D1*Ddd*f**2*s - 12*D1*Ddd*f**2 + 4*D1*bd1*(r + s - 1)*(D1*f*(38*C + 13)*(r + s - 1) - D1*fd*(24*C + 6)*(r + s) - Dd*f*(48*C + 12)*(2*r + 2*s - 1)) - 72*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 72*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 72*Dd**2*f**2*s - 12*Dd**2*f**2))/(21*d**2*k3**6) - 40*D1**2*Pk1*Pk2*ct*k1*k2*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(693*d**2*k3**4) - 2*D1**2*Pk1*Pk2*ct*k1*k2*st**4*(132*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 33*b1*(-32*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s - 16*C*D1**2*f*fd - 64*C*D1*Dd*f**2*r*s + 16*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 16*C*D1*Dd*f**2 - 4*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 2*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s + 6*D1**2*f*fd*r - 10*D1**2*f*fd*s**2 + 10*D1**2*f*fd*s - 5*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 28*D1**2*f*fdd*r*s - 14*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 28*D1**2*fd**2*r*s - 14*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 4*D1*Dd*f**2*r**2 - 24*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r - 20*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 224*D1*Dd*f*fd*r*s - 104*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 136*D1*Dd*f*fd*s + 32*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 56*D1*Ddd*f**2*r*s - 24*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 32*D1*Ddd*f**2*s + 14*D1*Ddd*f**2 + 4*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 60*Dd**2*f**2*r**2 + 168*Dd**2*f**2*r*s - 72*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 96*Dd**2*f**2*s + 14*Dd**2*f**2) + f*(-132*D1**2*bd1**2*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) - 2*D1**2*(f*(2*fd - fdd)*(12*C*(3*r**2 + 3*r*(7*s - 3) + 18*s**2 - 19*s + 7) - 63*r**2 + r*(74 - 96*s) - 33*s**2 + 54*s - 32) - 2*fd**2*(6*C*(6*r**2 + 6*r*(7*s - 3) + 36*s**2 - 38*s + 7) - 63*r**2 + r*(74 - 96*s) - 33*s**2 + 54*s - 16)) - 33*D1*bd1*(D1*(f*(r + s - 1)*(16*C*s + r + 5*s - 1) - 2*fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 23*s + 7)) - 8*Dd*f*(5*r**2 + 2*r*(7*s - 4) + 9*s**2 - 11*s + 3)) - 4*D1*f*(Dd*(2*f*(6*C*(4*r**2 + 28*r*s - 9*r + 24*s**2 - 19*s + 7) - 42*r**2 - 64*r*s + 37*r - 22*s**2 + 27*s - 16) + fd*(-6*C*(24*r**2 + 21*r*(8*s - 3) + 144*s**2 - 133*s + 28) + 252*r**2 + 384*r*s - 259*r + 132*s**2 - 189*s + 64)) + Ddd*f*(-6*C*(4*r**2 + 28*r*s - 9*r + 24*s**2 - 19*s + 7) + 42*r**2 + 64*r*s - 37*r + 22*s**2 - 27*s + 16)) + 4*Dd**2*f**2*(6*C*(12*r**2 + 3*r*(28*s - 9) + 72*s**2 - 57*s + 7) - 126*r**2 - 3*r*(64*s - 37) - 66*s**2 + 81*s - 16)))/(231*d**2*k3**4) + D1**2*Pk1*Pk2*ct*k1*k2*st**2*(33*b1**2*(D1**2*(r + s)*(fd*(r*(48*C - 77) + s*(104*C - 81)) - fdd*(r*(24*C - 7) + s*(24*C + 5))) + 2*D1*(Dd*(f*(4*C*(24*r**2 + 76*r*s - 31*r + 52*s**2 - 45*s + 19) - 154*r**2 - 316*r*s + 156*r - 162*s**2 + 160*s - 79) + 4*fd*(r**2*(7 - 24*C) + 2*r*(-24*C*s + 6*C + s - 1) + s*(-24*C*s + 12*C - 5*s + 1))) + Ddd*f*(-24*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*r**2 + 4*r*(s - 2) - 10*s**2 + 4*s + 1)) + 2*Dd**2*f*(-24*C*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) + 42*r**2 + 12*r*(s - 2) - 30*s**2 + 12*s + 1)) + 66*b1*(4*C*D1**2*f*fd*r**2 - 112*C*D1**2*f*fd*r*s + 52*C*D1**2*f*fd*r - 116*C*D1**2*f*fd*s**2 + 112*C*D1**2*f*fd*s - 54*C*D1**2*f*fd + 36*C*D1**2*f*fdd*r**2 + 144*C*D1**2*f*fdd*r*s - 72*C*D1**2*f*fdd*r + 108*C*D1**2*f*fdd*s**2 - 108*C*D1**2*f*fdd*s + 54*C*D1**2*f*fdd + 36*C*D1**2*fd**2*r**2 + 144*C*D1**2*fd**2*r*s - 72*C*D1**2*fd**2*r + 108*C*D1**2*fd**2*s**2 - 108*C*D1**2*fd**2*s + 8*C*D1*Dd*f**2*r**2 - 224*C*D1*Dd*f**2*r*s + 52*C*D1*Dd*f**2*r - 232*C*D1*Dd*f**2*s**2 + 172*C*D1*Dd*f**2*s - 56*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r**2 + 1152*C*D1*Dd*f*fd*r*s - 504*C*D1*Dd*f*fd*r + 864*C*D1*Dd*f*fd*s**2 - 792*C*D1*Dd*f*fd*s + 180*C*D1*Dd*f*fd + 72*C*D1*Ddd*f**2*r**2 + 288*C*D1*Ddd*f**2*r*s - 108*C*D1*Ddd*f**2*r + 216*C*D1*Ddd*f**2*s**2 - 180*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 216*C*Dd**2*f**2*r**2 + 864*C*Dd**2*f**2*r*s - 324*C*Dd**2*f**2*r + 648*C*Dd**2*f**2*s**2 - 540*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - D1**2*bdd1*f*(r + s - 1)*(24*C*(r + s - 1) - 7*r + 5*s + 1) - 66*D1**2*f*fd*r**2 - 164*D1**2*f*fd*r*s + 92*D1**2*f*fd*r - 98*D1**2*f*fd*s**2 + 108*D1**2*f*fd*s - 59*D1**2*f*fd + 54*D1**2*f*fdd*r**2 + 124*D1**2*f*fdd*r*s - 68*D1**2*f*fdd*r + 70*D1**2*f*fdd*s**2 - 76*D1**2*f*fdd*s + 41*D1**2*f*fdd + 54*D1**2*fd**2*r**2 + 124*D1**2*fd**2*r*s - 68*D1**2*fd**2*r + 70*D1**2*fd**2*s**2 - 76*D1**2*fd**2*s - 132*D1*Dd*f**2*r**2 - 328*D1*Dd*f**2*r*s + 148*D1*Dd*f**2*r - 196*D1*Dd*f**2*s**2 + 180*D1*Dd*f**2*s - 82*D1*Dd*f**2 + 432*D1*Dd*f*fd*r**2 + 992*D1*Dd*f*fd*r*s - 504*D1*Dd*f*fd*r + 560*D1*Dd*f*fd*s**2 - 568*D1*Dd*f*fd*s + 144*D1*Dd*f*fd + 108*D1*Ddd*f**2*r**2 + 248*D1*Ddd*f**2*r*s - 116*D1*Ddd*f**2*r + 140*D1*Ddd*f**2*s**2 - 132*D1*Ddd*f**2*s + 62*D1*Ddd*f**2 + D1*bd1*(D1*(f*(r + s - 1)*(4*C*(12*r + 26*s - 19) - 77*r - 81*s + 79) + 2*fd*(r**2*(7 - 24*C) + r*(-48*C*s + 24*C + 2*s - 4) + s*(-24*C*(s - 1) - 5*s + 2))) - 4*Dd*f*(24*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 14*r**2 - 4*r*(s - 3) + 10*s**2 - 6*s - 1)) + 324*Dd**2*f**2*r**2 + 744*Dd**2*f**2*r*s - 348*Dd**2*f**2*r + 420*Dd**2*f**2*s**2 - 396*Dd**2*f**2*s + 62*Dd**2*f**2) + f*(-6228*C*D1**2*f*fd*r**2 - 21672*C*D1**2*f*fd*r*s + 11376*C*D1**2*f*fd*r - 15444*C*D1**2*f*fd*s**2 + 17520*C*D1**2*f*fd*s - 7224*C*D1**2*f*fd + 7668*C*D1**2*f*fdd*r**2 + 20736*C*D1**2*f*fdd*r*s - 12024*C*D1**2*f*fdd*r + 13068*C*D1**2*f*fdd*s**2 - 15624*C*D1**2*f*fdd*s + 6912*C*D1**2*f*fdd + 15336*C*D1**2*fd**2*r**2 + 41472*C*D1**2*fd**2*r*s - 24048*C*D1**2*fd**2*r + 26136*C*D1**2*fd**2*s**2 - 31248*C*D1**2*fd**2*s + 6912*C*D1**2*fd**2 - 8304*C*D1*Dd*f**2*r**2 - 28896*C*D1*Dd*f**2*r*s + 11376*C*D1*Dd*f**2*r - 20592*C*D1*Dd*f**2*s**2 + 17520*C*D1*Dd*f**2*s - 7224*C*D1*Dd*f**2 + 61344*C*D1*Dd*f*fd*r**2 + 165888*C*D1*Dd*f*fd*r*s - 84168*C*D1*Dd*f*fd*r + 104544*C*D1*Dd*f*fd*s**2 - 109368*C*D1*Dd*f*fd*s + 27648*C*D1*Dd*f*fd + 10224*C*D1*Ddd*f**2*r**2 + 27648*C*D1*Ddd*f**2*r*s - 12024*C*D1*Ddd*f**2*r + 17424*C*D1*Ddd*f**2*s**2 - 15624*C*D1*Ddd*f**2*s + 6912*C*D1*Ddd*f**2 + 30672*C*Dd**2*f**2*r**2 + 82944*C*Dd**2*f**2*r*s - 36072*C*Dd**2*f**2*r + 52272*C*Dd**2*f**2*s**2 - 46872*C*Dd**2*f**2*s + 6912*C*Dd**2*f**2 - 66*D1**2*bd1**2*(r + s - 1)*(24*C*(r + s - 1) - 7*r + 5*s + 1) + 66*D1**2*bdd1*f*(r + s - 1)*(18*C*(r + 3*s - 1) + 27*r + 35*s - 21) + 993*D1**2*f*fd*r**2 - 2202*D1**2*f*fd*r*s + 72*D1**2*f*fd*r - 3195*D1**2*f*fd*s**2 + 2864*D1**2*f*fd*s - 734*D1**2*f*fd + 741*D1**2*f*fdd*r**2 + 3774*D1**2*f*fdd*r*s - 1752*D1**2*f*fdd*r + 3033*D1**2*f*fdd*s**2 - 3280*D1**2*f*fdd*s + 1258*D1**2*f*fdd + 1482*D1**2*fd**2*r**2 + 7548*D1**2*fd**2*r*s - 3504*D1**2*fd**2*r + 6066*D1**2*fd**2*s**2 - 6560*D1**2*fd**2*s + 1258*D1**2*fd**2 + 1324*D1*Dd*f**2*r**2 - 2936*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 4260*D1*Dd*f**2*s**2 + 2864*D1*Dd*f**2*s - 734*D1*Dd*f**2 + 5928*D1*Dd*f*fd*r**2 + 30192*D1*Dd*f*fd*r*s - 12264*D1*Dd*f*fd*r + 24264*D1*Dd*f*fd*s**2 - 22960*D1*Dd*f*fd*s + 5032*D1*Dd*f*fd + 988*D1*Ddd*f**2*r**2 + 5032*D1*Ddd*f**2*r*s - 1752*D1*Ddd*f**2*r + 4044*D1*Ddd*f**2*s**2 - 3280*D1*Ddd*f**2*s + 1258*D1*Ddd*f**2 + 66*D1*bd1*(D1*(f*(r + s - 1)*(2*C*(r - 29*s + 1) - 33*r - 49*s + 23) + 2*fd*(18*C*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 7*s + 2) + 54*r**2 + 124*r*s - 82*r + 70*s**2 - 94*s + 31)) + 4*Dd*f*(9*C*(4*r**2 + 16*r*s - 7*r + 12*s**2 - 13*s + 3) + 54*r**2 + 124*r*s - 77*r + 70*s**2 - 89*s + 26)) + 2964*Dd**2*f**2*r**2 + 15096*Dd**2*f**2*r*s - 5256*Dd**2*f**2*r + 12132*Dd**2*f**2*s**2 - 9840*Dd**2*f**2*s + 1258*Dd**2*f**2))/(693*d**2*k3**4) - 2*D1**2*Pk1*Pk2*ct*k1*k2*(-2*D1*f*(D1*bd1**2*(r + s - 1)*(140*C*(r + s - 1) + 23*r + 71*s - 47) - 3*D1*bd1*(f*(r + s - 1)*(4*C*(7*r + 3*s - 3) - 9*r + 7*s - 7) - 2*fd*(C*(48*r**2 + 88*r*s - 68*r + 40*s**2 - 62*s + 22) + 8*r**2 + 28*r*s - 18*r + 20*s**2 - 27*s + 7)) + 6*D1*bdd1*f*(r + s - 1)*(2*C*(6*r + 5*s - 5) + 2*r + 5*s - 5) + 6*Dd*bd1*f*(2*C*(48*r**2 + r*(88*s - 67) + 40*s**2 - 61*s + 21) + 16*r**2 + r*(56*s - 39) + 40*s**2 - 57*s + 17)) + b1**2*(D1**2*(r + s)*(fd*(140*C*r + 84*C*s - 73*r + 51*s) - fdd*(r*(140*C + 23) + s*(140*C + 71))) + 2*D1*(Dd*(f*(28*C*(10*r**2 + 16*r*s - 9*r + 6*s**2 - 7*s + 4) - 146*r**2 - 44*r*s + 84*r + 102*s**2 - 40*s - 11) - 2*fd*(r**2*(280*C + 46) + r*(140*C*(4*s - 1) + 188*s - 35) + s*(140*C*(2*s - 1) + 142*s - 59))) - Ddd*f*(140*C*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 46*r**2 + 188*r*s - 70*r + 142*s**2 - 118*s + 47)) - 2*Dd**2*f*(140*C*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1) + 138*r**2 + 6*r*(94*s - 35) + 426*s**2 - 354*s + 47)) + 2*b1*(-D1**2*bdd1*f*(r + s - 1)*(140*C*(r + s - 1) + 23*r + 71*s - 47) + 3*D1**2*(f*(fd*(4*C*(14*r**2 + 20*r*s - 14*r + 6*s**2 - 10*s + 7) - 18*r**2 - 4*r*s + 18*r + 14*s**2 + 2*s - 9) - 2*fdd*(2*C*(12*r**2 + 22*r*s - 12*r + 10*s**2 - 11*s + 6) + 4*r**2 + 14*r*s - 4*r + 10*s**2 - 7*s + 2)) - 2*fd**2*(r**2*(24*C + 4) + 2*r*(22*C*s - 12*C + 7*s - 2) + s*(20*C*s - 22*C + 10*s - 7))) + D1*bd1*(D1*(f*(r + s - 1)*(28*C*(5*r + 3*s - 4) - 73*r + 51*s + 11) - 2*fd*(r**2*(140*C + 23) + r*(140*C*(2*s - 1) + 94*s - 35) + s*(140*C*(s - 1) + 71*s - 59))) - 4*Dd*f*(140*C*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 46*r**2 + 188*r*s - 105*r + 142*s**2 - 177*s + 47)) + 6*D1*f*(Dd*(f*(4*C*(14*r**2 + 4*r*(5*s - 3) + 6*s**2 - 8*s + 5) - 18*r**2 - 4*r*s + 10*r + 14*s**2 - 6*s - 1) - fd*(2*r + 2*s - 1)*(C*(96*r + 80*s - 46) + 16*r + 40*s - 11)) - Ddd*f*(C*(48*r**2 + 88*r*s - 46*r + 40*s**2 - 42*s + 22) + 8*r**2 + 28*r*s - 11*r + 20*s**2 - 17*s + 7)) - 6*Dd**2*f**2*(2*C*(72*r**2 + 3*r*(44*s - 23) + 60*s**2 - 63*s + 11) + 24*r**2 + r*(84*s - 33) + 60*s**2 - 51*s + 7)))/(21*d**2*k3**4) - 20*D1**2*Pk1*Pk2*ct*k1*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2*k3**2) - 8*D1**2*Pk1*Pk2*ct*k1*st**4*(-2*D1**2*f*(429*bd1**2*s**2 + 5*f**2*(10*fd*(4*s**2 - 2*s + 1) - 5*fdd*(4*s**2 - 2*s + 1) + s**2*(26*bd1 - 13*bdd1)) - 10*f*fd*s*(13*bd1*(3*s - 1) + 15*fd*(2*s - 1))) - 10*D1*f**3*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(13*bd1*s + 5*fd*(4*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) - 300*Dd**2*f**4*s*(1 - 2*s) + 429*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 26*b1*(D1**2*(66*bd1*fd*s*(s - 1) + 5*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*s*(fd**2*(20 - 30*s) + s*(-66*bd1 + 33*bdd1))) + D1*(2*Dd*f*(33*bd1*s*(4*s - 1) + 5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(12*s**2 - 7*s + 1)) - 5*Ddd*f**3*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**3*s*(1 - 2*s)))/(1001*d**2*k2**3) + 2*D1**2*Pk1*Pk2*ct*k1*st**2*(22*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd + 28) + s*(3*fd + 14) - 7) - D1*Ddd*(3*f - 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f - 7)*(2*s - 1)) + 11*b1**2*(-2*D1**2*bdd1*(3*f - 7)*(3*s**2 - 2*s + 1) - 18*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 33*D1**2*f*fd + 18*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd + 18*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s + 41*D1**2*fd*s**2 - 74*D1**2*fd*s + 37*D1**2*fd - 31*D1**2*fdd*s**2 + 58*D1**2*fdd*s - 29*D1**2*fdd - 36*D1*Dd*f**2*s**2 + 18*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 144*D1*Dd*f*fd*s**2 - 204*D1*Dd*f*fd*s + 42*D1*Dd*f*fd + 164*D1*Dd*f*s**2 - 82*D1*Dd*f*s + 41*D1*Dd*f - 248*D1*Dd*fd*s**2 + 294*D1*Dd*fd*s - 58*D1*Dd*fd + 36*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 - 124*D1*Ddd*f*s**2 + 62*D1*Ddd*f*s - 31*D1*Ddd*f + 4*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) - s**2*(9*fd + 21) + s*(3*fd + 14) - 7) - Dd*(3*f - 7)*(12*s**2 - 7*s + 1)) + 108*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s - 372*Dd**2*f*s**2 + 186*Dd**2*f*s) + b1*(-44*D1**2*bd1**2*s*(3*f - 7)*(3*s - 2) + 22*D1**2*bdd1*f*(3*f*(3*s**2 + 4*s - 2) - 31*s**2 + 2*s - 1) - 1878*D1**2*f**2*fd*s**2 + 1452*D1**2*f**2*fd*s - 726*D1**2*f**2*fd + 1236*D1**2*f**2*fdd*s**2 - 924*D1**2*f**2*fdd*s + 462*D1**2*f**2*fdd + 2472*D1**2*f*fd**2*s**2 - 1848*D1**2*f*fd**2*s - 418*D1**2*f*fd*s**2 + 418*D1**2*f*fd*s - 209*D1**2*f*fd + 242*D1**2*f*fdd*s**2 - 242*D1**2*f*fdd*s + 121*D1**2*f*fdd + 242*D1**2*fd**2*s**2 - 242*D1**2*fd**2*s - 2504*D1*Dd*f**3*s**2 + 1252*D1*Dd*f**3*s - 626*D1*Dd*f**3 + 9888*D1*Dd*f**2*fd*s**2 - 6168*D1*Dd*f**2*fd*s + 924*D1*Dd*f**2*fd - 836*D1*Dd*f**2*s**2 + 418*D1*Dd*f**2*s - 209*D1*Dd*f**2 + 1936*D1*Dd*f*fd*s**2 - 1452*D1*Dd*f*fd*s + 242*D1*Dd*f*fd + 1648*D1*Ddd*f**3*s**2 - 824*D1*Ddd*f**3*s + 412*D1*Ddd*f**3 + 484*D1*Ddd*f**2*s**2 - 242*D1*Ddd*f**2*s + 121*D1*Ddd*f**2 - 22*D1*bd1*(D1*(3*f**2*(3*s**2 + 8*s - 4) + f*(-s**2*(36*fd + 41) + s*(18*fd + 4) - 2) + 2*fd*s*(31*s - 30)) - 2*Dd*f*(4*s - 1)*(f*(9*s + 6) - 31*s + 1)) + 4944*Dd**2*f**3*s**2 - 2472*Dd**2*f**3*s + 1452*Dd**2*f**2*s**2 - 726*Dd**2*f**2*s) + f*(22*D1**2*bd1**2*s*(3*f*(3*s + 4) - 31*s + 2) - D1*bd1*(D1*(2*f**2*(313*s**2 + 100*s - 50) + f*s*(-2472*fd*s + 624*fd + 209*s) + 242*fd*s*(1 - 2*s)) - 2*Dd*f*(4*s - 1)*(f*(412*s + 50) + 121*s)) + f*(D1**2*bdd1*(2*f*(206*s**2 + 50*s - 25) + 121*s**2) - 25*D1**2*(f*(11*fd - 7*fdd)*(4*s**2 - 2*s + 1) + 42*fd**2*s*(1 - 2*s)) - 25*D1*f*(11*Dd*f*(4*s**2 - 2*s + 1) - 14*Dd*fd*(1 - 4*s)**2 - 7*Ddd*f*(4*s**2 - 2*s + 1)) - 1050*Dd**2*f**2*s*(1 - 2*s))))/(231*d**2*k2**3) - 2*D1**2*Pk1*Pk2*ct*k1*(7*b1**3*(D1**2*s**2*(5*fd - 3*fdd) + D1*Dd*(5*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 16) + s*(6*fd - 8) + 4) - D1*Ddd*(3*f + 2)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 2)*(2*s - 1)) + b1**2*(-7*D1**2*bdd1*(3*f + 2)*(3*s**2 - 2*s + 1) + 78*D1**2*f*fd*s**2 + 42*D1**2*f*fd*s - 21*D1**2*f*fd - 30*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd - 30*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s + 17*D1**2*fd*s**2 + 28*D1**2*fd*s - 14*D1**2*fd - 5*D1**2*fdd*s**2 - 28*D1**2*fdd*s + 14*D1**2*fdd + 156*D1*Dd*f**2*s**2 - 78*D1*Dd*f**2*s + 39*D1*Dd*f**2 - 240*D1*Dd*f*fd*s**2 - 108*D1*Dd*f*fd*s + 42*D1*Dd*f*fd + 68*D1*Dd*f*s**2 - 34*D1*Dd*f*s + 17*D1*Dd*f - 40*D1*Dd*fd*s**2 - 102*D1*Dd*fd*s + 28*D1*Dd*fd - 60*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 20*D1*Ddd*f*s**2 + 10*D1*Ddd*f*s - 5*D1*Ddd*f + 7*D1*bd1*(D1*(5*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 12) + s*(6*fd - 8) + 4) - 2*Dd*(3*f + 2)*(12*s**2 - 7*s + 1)) - 180*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 60*Dd**2*f*s**2 + 30*Dd**2*f*s) - b1*(14*D1**2*bd1**2*s*(3*f + 2)*(3*s - 2) + D1**2*bdd1*f*(6*f*(5*s**2 - 12*s + 6) + 10*s**2 - 38*s + 19) + 33*D1**2*f**2*fd*s**2 - 72*D1**2*f**2*fd*s + 36*D1**2*f**2*fd - 63*D1**2*f**2*fdd*s**2 + 72*D1**2*f**2*fdd*s - 36*D1**2*f**2*fdd - 126*D1**2*f*fd**2*s**2 + 144*D1**2*f*fd**2*s + 38*D1**2*f*fd*s**2 - 38*D1**2*f*fd*s + 19*D1**2*f*fd - 38*D1**2*f*fdd*s**2 + 38*D1**2*f*fdd*s - 19*D1**2*f*fdd - 38*D1**2*fd**2*s**2 + 38*D1**2*fd**2*s + 44*D1*Dd*f**3*s**2 - 22*D1*Dd*f**3*s + 11*D1*Dd*f**3 - 504*D1*Dd*f**2*fd*s**2 + 414*D1*Dd*f**2*fd*s - 72*D1*Dd*f**2*fd + 76*D1*Dd*f**2*s**2 - 38*D1*Dd*f**2*s + 19*D1*Dd*f**2 - 304*D1*Dd*f*fd*s**2 + 228*D1*Dd*f*fd*s - 38*D1*Dd*f*fd - 84*D1*Ddd*f**3*s**2 + 42*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 - 76*D1*Ddd*f**2*s**2 + 38*D1*Ddd*f**2*s - 19*D1*Ddd*f**2 + D1*bd1*(D1*(-6*f**2*(13*s**2 - 20*s + 10) + f*(s**2*(120*fd - 34) + s*(62 - 60*fd) - 31) + 2*fd*s*(10*s + 9)) + 2*Dd*f*(4*s - 1)*(6*f*(5*s - 6) + 10*s - 19)) - 252*Dd**2*f**3*s**2 + 126*Dd**2*f**3*s - 228*Dd**2*f**2*s**2 + 114*Dd**2*f**2*s) + f*(2*D1**2*bd1**2*s*(f*(36 - 15*s) - 5*s + 19) + D1*bd1*(D1*(f**2*(-11*s**2 - 50*s + 25) + f*s*(18*fd*(7*s + 1) - 19*s) + 38*fd*s*(2*s - 1)) + 2*Dd*f*(4*s - 1)*(3*f*(7*s + 5) + 19*s)) + f*(D1**2*bdd1*(3*f*(7*s**2 + 10*s - 5) + 19*s**2) - 15*D1**2*(f*(fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) - 15*D1*f*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) - 90*Dd**2*f**2*s*(1 - 2*s))))/(21*d**2*k2**3) - 20*D1**2*Pk1*Pk2*ct*k2**5*st**6*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 264*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 528*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 528*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 8*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 28*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 28*D1*Dd*f**2*fd*s - 8*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 132*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 4*D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 2*Dd*f*(2*r + 2*s - 1))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 396*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 12*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 12*Dd**2*f**3*s - 2*Dd**2*f**3)/(693*d**2*k1*k3**6) - 8*D1**2*Pk1*Pk2*ct*k2**5*st**4*(-D1**2*bd1*f*(2*bd1 + f)*(r + s - 1)**2 + D1*b1*(4*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) - 2*Dd*f*(2*r + 2*s - 1)) - f*(2*D1*bdd1*(r + s - 1)**2 + (D1*fd + 2*Dd*f)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + 4*D1*Dd*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(-2*r**2 - 4*r*s + r - 2*s**2 + s)) - 2*D1*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)))/(7*d**2*k1*k3**6) - 20*D1**2*Pk1*Pk2*ct*k2**3*st**6*(264*C*D1**2*b1*f*fd*r**2 + 264*C*D1**2*b1*f*fd*r*s - 132*C*D1**2*b1*f*fd*r - 132*C*D1**2*b1*f*fdd*r**2 - 132*C*D1**2*b1*f*fdd*r*s + 66*C*D1**2*b1*f*fdd*r - 132*C*D1**2*b1*fd**2*r**2 - 132*C*D1**2*b1*fd**2*r*s + 66*C*D1**2*b1*fd**2*r + 12*C*D1**2*f**2*fd*r**2 + 12*C*D1**2*f**2*fd*r*s - 12*C*D1**2*f**2*fd*r - 4*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r**2 - 6*C*D1**2*f**2*fdd*r*s + 6*C*D1**2*f**2*fdd*r + 2*C*D1**2*f**2*fdd*s - 2*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r**2 - 12*C*D1**2*f*fd**2*r*s + 12*C*D1**2*f*fd**2*r + 4*C*D1**2*f*fd**2*s - 2*C*D1**2*f*fd**2 + 528*C*D1*Dd*b1*f**2*r**2 + 528*C*D1*Dd*b1*f**2*r*s - 396*C*D1*Dd*b1*f**2*r - 132*C*D1*Dd*b1*f**2*s + 132*C*D1*Dd*b1*f**2 - 1056*C*D1*Dd*b1*f*fd*r**2 - 1056*C*D1*Dd*b1*f*fd*r*s + 660*C*D1*Dd*b1*f*fd*r + 132*C*D1*Dd*b1*f*fd*s - 66*C*D1*Dd*b1*f*fd + 16*C*D1*Dd*f**3*r**2 + 16*C*D1*Dd*f**3*r*s - 12*C*D1*Dd*f**3*r - 4*C*D1*Dd*f**3*s + 4*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r**2 - 48*C*D1*Dd*f**2*fd*r*s + 42*C*D1*Dd*f**2*fd*r + 14*C*D1*Dd*f**2*fd*s - 8*C*D1*Dd*f**2*fd - 264*C*D1*Ddd*b1*f**2*r**2 - 264*C*D1*Ddd*b1*f**2*r*s + 198*C*D1*Ddd*b1*f**2*r + 66*C*D1*Ddd*b1*f**2*s - 66*C*D1*Ddd*b1*f**2 - 8*C*D1*Ddd*f**3*r**2 - 8*C*D1*Ddd*f**3*r*s + 6*C*D1*Ddd*f**3*r + 2*C*D1*Ddd*f**3*s - 2*C*D1*Ddd*f**3 - 792*C*Dd**2*b1*f**2*r**2 - 792*C*Dd**2*b1*f**2*r*s + 594*C*Dd**2*b1*f**2*r + 198*C*Dd**2*b1*f**2*s - 66*C*Dd**2*b1*f**2 - 24*C*Dd**2*f**3*r**2 - 24*C*Dd**2*f**3*r*s + 18*C*Dd**2*f**3*r + 6*C*Dd**2*f**3*s - 2*C*Dd**2*f**3 - 264*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd + 132*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*f*fdd*r*s - 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd + 132*D1**2*b1*fd**2*r**2 + 66*D1**2*b1*fd**2*r*s - 33*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)*(2*C*(r - 1) - 2*r + s + 2) - 12*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 10*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 2*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 5*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + D1**2*f**2*fdd*s + D1**2*f**2*fdd + 12*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 10*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 2*D1**2*f*fd**2*s + D1**2*f*fd**2 - 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 330*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 66*D1*Dd*b1*f**2*s - 66*D1*Dd*b1*f**2 + 1056*D1*Dd*b1*f*fd*r**2 + 528*D1*Dd*b1*f*fd*r*s - 462*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 330*D1*Dd*b1*f*fd*s - 33*D1*Dd*b1*f*fd - 16*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 2*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 35*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 7*D1*Dd*f**2*fd*s + 4*D1*Dd*f**2*fd + 264*D1*Ddd*b1*f**2*r**2 + 132*D1*Ddd*b1*f**2*r*s - 165*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 33*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 + 8*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 5*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + D1*Ddd*f**3*s + D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(2*f*(r + s - 1)*(2*C*(r - 1) - 2*r + s + 2) + fd*(-2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 8*r**2 + 4*r*s - 9*r - 4*s**2 + 1)) + Dd*f*(-2*C*(8*r**2 + 8*r*s - 11*r - 5*s + 3) + 16*r**2 + 8*r*s - 21*r - 8*s**2 - 3*s + 5)) + 792*Dd**2*b1*f**2*r**2 + 396*Dd**2*b1*f**2*r*s - 495*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 99*Dd**2*b1*f**2*s + 33*Dd**2*b1*f**2 + 24*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 15*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 3*Dd**2*f**3*s + Dd**2*f**3)/(693*d**2*k1*k3**4) - 2*D1**2*Pk1*Pk2*ct*k2**3*st**4*(264*b1**2*(C - 1)*(D1**2*r*(2*fd - fdd)*(r + s) + D1*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 3*r + s)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + Dd**2*f*(-12*r**2 + r*(9 - 12*s) + 3*s - 1)) + 33*b1*(-16*C*D1**2*f*fd*r**2 - 16*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*r - 32*C*D1*Dd*f**2*r**2 - 32*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s - 8*C*D1*Dd*f**2 - 8*D1**2*bdd1*f*(C - 1)*(2*r - 1)*(r + s - 1) + 6*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s + 6*D1**2*f*fd*r - 18*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s - 9*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 28*D1**2*f*fdd*r*s - 14*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 28*D1**2*fd**2*r*s - 14*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s + 12*D1*Dd*f**2*r**2 - 24*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 224*D1*Dd*f*fd*r*s - 104*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 136*D1*Dd*f*fd*s + 32*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 56*D1*Ddd*f**2*r*s - 24*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 32*D1*Ddd*f**2*s + 14*D1*Ddd*f**2 + 8*D1*bd1*(C - 1)*(D1*(2*f*(2*r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 3*r + s)) - 2*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 60*Dd**2*f**2*r**2 + 168*Dd**2*f**2*r*s - 72*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 96*Dd**2*f**2*s + 14*Dd**2*f**2) + f*(-264*D1**2*bd1**2*(C - 1)*(2*r - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) - 2*D1**2*(f*(2*fd - fdd)*(20*C*(3*r**2 + 3*r*(s - 1) - s + 1) - 9*r**2 + r*(14 - 24*s) - 15*s**2 + 18*s - 8) + 2*fd**2*(-10*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 9*r**2 + 2*r*(12*s - 7) + 15*s**2 - 18*s + 4)) - 33*D1*bd1*(D1*(f*(r + s - 1)*(8*C*(r - 1) - 3*r + 9*s + 3) - 2*fd*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7)) - 8*Dd*f*(5*r**2 + 2*r*(7*s - 4) + 9*s**2 - 11*s + 3)) - 4*D1*f*(Dd*(2*f*(10*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 6*r**2 - 16*r*s + 7*r - 10*s**2 + 9*s - 4) + fd*(-10*C*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4) + 36*r**2 + 96*r*s - 49*r + 60*s**2 - 63*s + 16)) + Ddd*f*(-10*C*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*r**2 + 16*r*s - 7*r + 10*s**2 - 9*s + 4)) - 4*Dd**2*f**2*(-10*C*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1) + 18*r**2 + 3*r*(16*s - 7) + 30*s**2 - 27*s + 4)))/(231*d**2*k1*k3**4) + D1**2*Pk1*Pk2*ct*k2**3*st**2*(D1*f*(-58*D1*bd1**2*(r + s - 1)**2 + bd1*(r + s - 1)*(D1*f*(r*(8*C + 11) - 13*s + 1) + 22*D1*fd*(2*r + 2*s - 1) + 44*Dd*f*(2*r + 2*s - 1)) + f*(11*D1*bdd1*(r + s - 1)**2 + 12*D1*fd*(3*r**2 + 3*r*(s - 1) - s + 1) + 12*Dd*f*(4*r**2 + r*(4*s - 3) - s + 1))) + b1**2*(D1**2*(r + s)*(fd*r*(56*C - 33) - 5*fd*s - 29*fdd*(r + s)) + 2*D1*(Dd*(f*(28*C*(4*r**2 + 4*r*s - 3*r - s + 1) - 66*r**2 - 76*r*s + 52*r - 10*s**2 + 24*s - 19) - 58*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 29*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 58*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(16*C*D1**2*f*fd*r**2 + 16*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r - 8*C*D1**2*f*fd*s + 8*C*D1**2*f*fd + 32*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r - 8*C*D1*Dd*f**2*s + 8*C*D1*Dd*f**2 - 58*D1**2*bdd1*f*(r + s - 1)**2 + 22*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s - 10*D1**2*f*fd*r - 26*D1**2*f*fd*s**2 + 14*D1**2*f*fd*s - D1**2*f*fd + 22*D1**2*f*fdd*r**2 + 44*D1**2*f*fdd*r*s - 22*D1**2*f*fdd*r + 22*D1**2*f*fdd*s**2 - 22*D1**2*f*fdd*s + 11*D1**2*f*fdd + 22*D1**2*fd**2*r**2 + 44*D1**2*fd**2*r*s - 22*D1**2*fd**2*r + 22*D1**2*fd**2*s**2 - 22*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r - 52*D1*Dd*f**2*s**2 + 28*D1*Dd*f**2*s - 2*D1*Dd*f**2 + 176*D1*Dd*f*fd*r**2 + 352*D1*Dd*f*fd*r*s - 176*D1*Dd*f*fd*r + 176*D1*Dd*f*fd*s**2 - 176*D1*Dd*f*fd*s + 44*D1*Dd*f*fd + 44*D1*Ddd*f**2*r**2 + 88*D1*Ddd*f**2*r*s - 44*D1*Ddd*f**2*r + 44*D1*Ddd*f**2*s**2 - 44*D1*Ddd*f**2*s + 22*D1*Ddd*f**2 + 2*D1*bd1*(r + s - 1)*(D1*f*(28*C*(2*r - 1) - 33*r - 5*s + 19) - 58*D1*fd*(r + s) - 116*Dd*f*(2*r + 2*s - 1)) + 132*Dd**2*f**2*r**2 + 264*Dd**2*f**2*r*s - 132*Dd**2*f**2*r + 132*Dd**2*f**2*s**2 - 132*Dd**2*f**2*s + 22*Dd**2*f**2))/(21*d**2*k1*k3**4) - 4*D1**2*Pk1*Pk2*f*k1**2*st**4*(D1**2*(f*(11*bd1*s*(r + s - 1) + fd*(-8*C*(3*r*s - r + 3*s**2 - 3*s + 1) + 6*r**2 + 12*r*s - 8*r + 6*s**2 - 8*s + 4) + fdd*(4*C*(3*r*s - r + 3*s**2 - 3*s + 1) - 3*r**2 - 6*r*s + 4*r - 3*s**2 + 4*s - 2)) + 2*fd**2*(2*C*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 3*r**2 + r*(4 - 6*s) - 3*s**2 + 4*s - 1)) + 11*D1*b1*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 2*D1*f*(2*Dd*(f*(C*(8*r*s - 2*r + 8*s**2 - 6*s + 2) - 2*r**2 - 4*r*s + 2*r - 2*s**2 + 2*s - 1) + fd*(C*(-24*r*s + 7*r - 24*s**2 + 21*s - 4) + 6*r**2 + 12*r*s - 7*r + 6*s**2 - 7*s + 2)) + Ddd*f*(C*(-8*r*s + 2*r - 8*s**2 + 6*s - 2) + 2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 2*Dd**2*f**2*(2*C*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) - 6*r**2 + r*(6 - 12*s) - 6*s**2 + 6*s - 1))/(77*d**2*k3**4) + 8*D1**2*Pk1*Pk2*f*k1**2*st**4*(D1**2*(f*(2*fd - fdd)*(C*(6*s**2 - 4*s + 2) - 3*r*s + r - 6*s**2 + 5*s - 2) + fd**2*(r*(6*s - 2) - s**2*(12*C - 12) + s*(8*C - 10) + 1)) + D1*f*(Dd*(2*f*(C*(8*s**2 - 4*s + 2) - 4*r*s + r - 8*s**2 + 5*s - 2) + fd*(-4*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r + 48*s**2 - 35*s + 6)) - Ddd*f*(C*(8*s**2 - 4*s + 2) - 4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f**2*(3*r*(4*s - 1) - s**2*(24*C - 24) + s*(12*C - 15) + 1))/(231*d**2*k2**2*k3**2) - 2*D1**2*Pk1*Pk2*k1**4*st**2*(33*b1*(D1**2*(f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 17*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(17*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 25*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 25*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 25*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k2**2*k3**4) + 4*D1**2*Pk1*Pk2*k1**4*(D1*f*(6*D1*bd1**2*(2*s - 1)*(r + s - 1) + D1*bd1*(-4*f*(s - 1)*(r + s - 1) + 5*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + 5*D1*bdd1*f*(s - 1)*(r + s - 1) + 5*Dd*bd1*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) + b1**2*(-D1**2*s*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(-5*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + 6*fd*(r*(8*s - 1) + s*(8*s - 3))) + 6*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 6*Dd**2*f*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(6*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s + 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*s**2 - 5*D1**2*f*fdd*s + 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*s**2 - 5*D1**2*fd**2*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r*s - 10*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 50*D1*Dd*f*fd*s + 5*D1*Dd*f*fd + 20*D1*Ddd*f**2*r*s - 5*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 15*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-5*f*(2*s - 1)*(r + s - 1) + 6*fd*(r*(4*s - 1) + s*(4*s - 3))) + 12*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 60*Dd**2*f**2*r*s - 15*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 45*Dd**2*f**2*s + 5*Dd**2*f**2))/(21*d**2*k2**2*k3**4) - 2*D1**2*Pk1*Pk2*k1**2*st**2*(33*b1**2*(D1**2*(r + s)*(fd*(6*r + 13*s) - 3*fdd*(r + s)) + D1*(Dd*(f*(24*r**2 + r*(76*s - 31) + 52*s**2 - 45*s + 19) - 12*fd*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - 6*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 6*Dd**2*f*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + 33*b1*(6*C*D1**2*f*fd*r**2 + 44*C*D1**2*f*fd*r*s - 22*C*D1**2*f*fd*r + 38*C*D1**2*f*fd*s**2 - 38*C*D1**2*f*fd*s + 19*C*D1**2*f*fd - 10*C*D1**2*f*fdd*r**2 - 44*C*D1**2*f*fdd*r*s + 22*C*D1**2*f*fdd*r - 34*C*D1**2*f*fdd*s**2 + 34*C*D1**2*f*fdd*s - 17*C*D1**2*f*fdd - 10*C*D1**2*fd**2*r**2 - 44*C*D1**2*fd**2*r*s + 22*C*D1**2*fd**2*r - 34*C*D1**2*fd**2*s**2 + 34*C*D1**2*fd**2*s + 12*C*D1*Dd*f**2*r**2 + 88*C*D1*Dd*f**2*r*s - 28*C*D1*Dd*f**2*r + 76*C*D1*Dd*f**2*s**2 - 60*C*D1*Dd*f**2*s + 22*C*D1*Dd*f**2 - 80*C*D1*Dd*f*fd*r**2 - 352*C*D1*Dd*f*fd*r*s + 152*C*D1*Dd*f*fd*r - 272*C*D1*Dd*f*fd*s**2 + 248*C*D1*Dd*f*fd*s - 56*C*D1*Dd*f*fd - 20*C*D1*Ddd*f**2*r**2 - 88*C*D1*Ddd*f**2*r*s + 32*C*D1*Ddd*f**2*r - 68*C*D1*Ddd*f**2*s**2 + 56*C*D1*Ddd*f**2*s - 22*C*D1*Ddd*f**2 - 60*C*Dd**2*f**2*r**2 - 264*C*Dd**2*f**2*r*s + 96*C*Dd**2*f**2*r - 204*C*Dd**2*f**2*s**2 + 168*C*Dd**2*f**2*s - 22*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(r + s - 1)**2 + 10*D1**2*f*fd*r**2 + 22*D1**2*f*fd*r*s - 12*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 - 13*D1**2*f*fd*s + 7*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 14*D1**2*f*fdd*r*s + 7*D1**2*f*fdd*r - 8*D1**2*f*fdd*s**2 + 8*D1**2*f*fdd*s - 4*D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 14*D1**2*fd**2*r*s + 7*D1**2*fd**2*r - 8*D1**2*fd**2*s**2 + 8*D1**2*fd**2*s + 20*D1*Dd*f**2*r**2 + 44*D1*Dd*f**2*r*s - 21*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 23*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 112*D1*Dd*f*fd*r*s + 54*D1*Dd*f*fd*r - 64*D1*Dd*f*fd*s**2 + 62*D1*Dd*f*fd*s - 15*D1*Dd*f*fd - 12*D1*Ddd*f**2*r**2 - 28*D1*Ddd*f**2*r*s + 13*D1*Ddd*f**2*r - 16*D1*Ddd*f**2*s**2 + 15*D1*Ddd*f**2*s - 7*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(D1*f*(12*r + 26*s - 19) - 12*D1*fd*(r + s) - 24*Dd*f*(2*r + 2*s - 1)) - 36*Dd**2*f**2*r**2 - 84*Dd**2*f**2*r*s + 39*Dd**2*f**2*r - 48*Dd**2*f**2*s**2 + 45*Dd**2*f**2*s - 7*Dd**2*f**2) + f*(489*C*D1**2*f*fd*r**2 + 2370*C*D1**2*f*fd*r*s - 1116*C*D1**2*f*fd*r + 1881*C*D1**2*f*fd*s**2 - 2044*C*D1**2*f*fd*s + 790*C*D1**2*f*fd - 591*C*D1**2*f*fdd*r**2 - 2274*C*D1**2*f*fdd*r*s + 1152*C*D1**2*f*fdd*r - 1683*C*D1**2*f*fdd*s**2 + 1880*C*D1**2*f*fdd*s - 758*C*D1**2*f*fdd - 1182*C*D1**2*fd**2*r**2 - 4548*C*D1**2*fd**2*r*s + 2304*C*D1**2*fd**2*r - 3366*C*D1**2*fd**2*s**2 + 3760*C*D1**2*fd**2*s - 758*C*D1**2*fd**2 + 652*C*D1*Dd*f**2*r**2 + 3160*C*D1*Dd*f**2*r*s - 1116*C*D1*Dd*f**2*r + 2508*C*D1*Dd*f**2*s**2 - 2044*C*D1*Dd*f**2*s + 790*C*D1*Dd*f**2 - 4728*C*D1*Dd*f*fd*r**2 - 18192*C*D1*Dd*f*fd*r*s + 8064*C*D1*Dd*f*fd*r - 13464*C*D1*Dd*f*fd*s**2 + 13160*C*D1*Dd*f*fd*s - 3032*C*D1*Dd*f*fd - 788*C*D1*Ddd*f**2*r**2 - 3032*C*D1*Ddd*f**2*r*s + 1152*C*D1*Ddd*f**2*r - 2244*C*D1*Ddd*f**2*s**2 + 1880*C*D1*Ddd*f**2*s - 758*C*D1*Ddd*f**2 - 2364*C*Dd**2*f**2*r**2 - 9096*C*Dd**2*f**2*r*s + 3456*C*Dd**2*f**2*r - 6732*C*Dd**2*f**2*s**2 + 5640*C*Dd**2*f**2*s - 758*C*Dd**2*f**2 - 198*D1**2*bd1**2*(r + s - 1)**2 - 33*D1**2*bdd1*f*(r + s - 1)*(C*(5*r + 17*s - 5) + 3*r + 4*s - 3) - 99*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 82*D1**2*f*fd*r + 51*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s - 16*D1**2*f*fd - 75*D1**2*f*fdd*r*s + 25*D1**2*f*fdd*r - 75*D1**2*f*fdd*s**2 + 75*D1**2*f*fdd*s - 25*D1**2*f*fdd - 150*D1**2*fd**2*r*s + 50*D1**2*fd**2*r - 150*D1**2*fd**2*s**2 + 150*D1**2*fd**2*s - 25*D1**2*fd**2 - 132*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 82*D1*Dd*f**2*r + 68*D1*Dd*f**2*s**2 - 18*D1*Dd*f**2*s - 16*D1*Dd*f**2 - 600*D1*Dd*f*fd*r*s + 175*D1*Dd*f*fd*r - 600*D1*Dd*f*fd*s**2 + 525*D1*Dd*f*fd*s - 100*D1*Dd*f*fd - 100*D1*Ddd*f**2*r*s + 25*D1*Ddd*f**2*r - 100*D1*Ddd*f**2*s**2 + 75*D1*Ddd*f**2*s - 25*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f*(r + s - 1)*(C*(3*r + 19*s - 3) + 5*r + 6*s - 4) - fd*(C*(20*r**2 + 88*r*s - 42*r + 68*s**2 - 78*s + 22) + 12*r**2 + 28*r*s - 19*r + 16*s**2 - 22*s + 7)) - Dd*f*(8*C*(5*r**2 + 22*r*s - 9*r + 17*s**2 - 18*s + 4) + 24*r**2 + 56*r*s - 37*r + 32*s**2 - 43*s + 13)) - 300*Dd**2*f**2*r*s + 75*Dd**2*f**2*r - 300*Dd**2*f**2*s**2 + 225*Dd**2*f**2*s - 25*Dd**2*f**2))/(693*d**2*k3**4) - 4*D1**2*Pk1*Pk2*k1**2*(D1*f*(-2*D1*bd1**2*(r + s - 1)*(35*C*(r + s - 1) + 6*s - 3) - D1*bdd1*f*(r + s - 1)*(34*C*r + 30*C*(s - 1) + 5*s - 5) + bd1*(-4*C*Dd*f*(68*r**2 + r*(128*s - 97) + 60*s**2 - 91*s + 31) + 2*D1*f*(r + s - 1)*(C*(13*r + 9*s - 9) - 3*r + 2*s - 2) - D1*fd*(4*C*(34*r**2 + r*(64*s - 49) + 30*s**2 - 46*s + 16) + 5*r*(4*s - 2) + 20*s**2 - 25*s + 5) - 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3))) + b1**2*(D1**2*(r + s)*(-35*C*fdd*(r + s) + fd*r*(21*C - 7) + fd*s*(21*C + 5) - 6*fdd*s) + 2*D1*(-35*C*Ddd*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(21*C*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 14*r**2 - 4*r*s + 8*r + 10*s**2 - 4*s - 1) + Dd*fd*(-140*C*r**2 + r*(-280*C*s + 70*C - 24*s + 3) + s*(-140*C*s + 70*C - 24*s + 9)) - 3*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 2*Dd**2*f*(35*C*(6*r**2 + 12*r*s - 6*r + 6*s**2 - 6*s + 1) + 36*r*s - 9*r + 36*s**2 - 27*s + 3)) + b1*(52*C*D1**2*f*fd*r**2 + 88*C*D1**2*f*fd*r*s - 52*C*D1**2*f*fd*r + 36*C*D1**2*f*fd*s**2 - 44*C*D1**2*f*fd*s + 26*C*D1**2*f*fd - 68*C*D1**2*f*fdd*r**2 - 128*C*D1**2*f*fdd*r*s + 68*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 64*C*D1**2*f*fdd*s - 34*C*D1**2*f*fdd - 68*C*D1**2*fd**2*r**2 - 128*C*D1**2*fd**2*r*s + 68*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 64*C*D1**2*fd**2*s + 104*C*D1*Dd*f**2*r**2 + 176*C*D1*Dd*f**2*r*s - 96*C*D1*Dd*f**2*r + 72*C*D1*Dd*f**2*s**2 - 80*C*D1*Dd*f**2*s + 44*C*D1*Dd*f**2 - 544*C*D1*Dd*f*fd*r**2 - 1024*C*D1*Dd*f*fd*r*s + 536*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 504*C*D1*Dd*f*fd*s - 132*C*D1*Dd*f*fd - 136*C*D1*Ddd*f**2*r**2 - 256*C*D1*Ddd*f**2*r*s + 132*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 124*C*D1*Ddd*f**2*s - 64*C*D1*Ddd*f**2 - 408*C*Dd**2*f**2*r**2 - 768*C*Dd**2*f**2*r*s + 396*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 372*C*Dd**2*f**2*s - 64*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(r + s - 1)*(35*C*(r + s - 1) + 6*s - 3) - 12*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - 6*D1**2*f*fd - 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*s**2 + 5*D1**2*f*fdd*s - 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*s**2 + 5*D1**2*fd**2*s - 24*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 14*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s - 2*D1*Dd*f**2 - 80*D1*Dd*f*fd*r*s + 10*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 50*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 20*D1*Ddd*f**2*r*s + 5*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 15*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(r + s - 1)*(21*C*(r + s - 1) - 7*r + 5*s + 1) + fd*(-70*C*r**2 + r*(-70*C*(2*s - 1) - 12*s + 3) + s*(-70*C*(s - 1) - 12*s + 9))) - 2*Dd*f*(70*C*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 24*r*s - 9*r + 24*s**2 - 27*s + 6)) - 60*Dd**2*f**2*r*s + 15*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 45*Dd**2*f**2*s - 5*Dd**2*f**2))/(21*d**2*k3**4) - D1**2*Pk1*Pk2*k1**2*st**2*(66*b1**2*(D1**2*s*(2*fd - fdd)*(r + 2*s) + D1*(2*Dd*f*(r*(4*s - 1) + 8*s**2 - 5*s + 2) + Dd*fd*(-8*r*s + r + s*(5 - 16*s)) + Ddd*f*(-4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f*(r*(3 - 12*s) - 24*s**2 + 15*s - 1)) + 33*b1*(32*C*D1**2*f*fd*s**2 - 32*C*D1**2*f*fd*s + 16*C*D1**2*f*fd - 24*C*D1**2*f*fdd*s**2 + 24*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 24*C*D1**2*fd**2*s**2 + 24*C*D1**2*fd**2*s + 64*C*D1*Dd*f**2*s**2 - 32*C*D1*Dd*f**2*s + 16*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*s**2 + 144*C*D1*Dd*f*fd*s - 24*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*s**2 + 24*C*D1*Ddd*f**2*s - 12*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*s**2 + 72*C*Dd**2*f**2*s - 2*D1**2*bdd1*f*(2*r*s - r + 4*s**2 - 5*s + 2) - 6*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 12*D1**2*f*fd*s - 8*D1**2*f*fd + 6*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r + 8*D1**2*f*fdd*s**2 - 14*D1**2*f*fdd*s + 8*D1**2*f*fdd + 6*D1**2*fd**2*r*s - 5*D1**2*fd**2*r + 8*D1**2*fd**2*s**2 - 14*D1**2*fd**2*s - 12*D1*Dd*f**2*r*s + 3*D1*Dd*f**2*r + 3*D1*Dd*f**2*s + 48*D1*Dd*f*fd*r*s - 26*D1*Dd*f*fd*r + 64*D1*Dd*f*fd*s**2 - 78*D1*Dd*f*fd*s + 19*D1*Dd*f*fd + 12*D1*Ddd*f**2*r*s - 3*D1*Ddd*f**2*r + 16*D1*Ddd*f**2*s**2 - 11*D1*Ddd*f**2*s + 4*D1*Ddd*f**2 + 2*D1*bd1*(D1*(2*f*(r*(2*s - 1) + 4*s**2 - 5*s + 2) + fd*(-4*r*s + r + s*(5 - 8*s))) - 2*Dd*f*(r*(8*s - 3) + 16*s**2 - 15*s + 3)) + 36*Dd**2*f**2*r*s - 9*Dd**2*f**2*r + 48*Dd**2*f**2*s**2 - 33*Dd**2*f**2*s + 3*Dd**2*f**2) + f*(1488*C*D1**2*f*fd*s**2 - 992*C*D1**2*f*fd*s + 496*C*D1**2*f*fd - 1140*C*D1**2*f*fdd*s**2 + 760*C*D1**2*f*fdd*s - 380*C*D1**2*f*fdd - 2280*C*D1**2*fd**2*s**2 + 1520*C*D1**2*fd**2*s + 1984*C*D1*Dd*f**2*s**2 - 992*C*D1*Dd*f**2*s + 496*C*D1*Dd*f**2 - 9120*C*D1*Dd*f*fd*s**2 + 5320*C*D1*Dd*f*fd*s - 760*C*D1*Dd*f*fd - 1520*C*D1*Ddd*f**2*s**2 + 760*C*D1*Ddd*f**2*s - 380*C*D1*Ddd*f**2 - 4560*C*Dd**2*f**2*s**2 + 2280*C*Dd**2*f**2*s - 66*D1**2*bd1**2*(r*(2*s - 1) + 4*s**2 - 5*s + 1) + 33*D1**2*bdd1*f*(r*(3*s + 2) + s**2*(4 - 12*C) + 3*s - 4) - 789*D1**2*f*fd*r*s + 263*D1**2*f*fd*r - 696*D1**2*f*fd*s**2 + 727*D1**2*f*fd*s - 232*D1**2*f*fd + 543*D1**2*f*fdd*r*s - 181*D1**2*f*fdd*r + 744*D1**2*f*fdd*s**2 - 677*D1**2*f*fdd*s + 248*D1**2*f*fdd + 1086*D1**2*fd**2*r*s - 362*D1**2*fd**2*r + 1488*D1**2*fd**2*s**2 - 1354*D1**2*fd**2*s + 181*D1**2*fd**2 - 1052*D1*Dd*f**2*r*s + 263*D1*Dd*f**2*r - 928*D1*Dd*f**2*s**2 + 727*D1*Dd*f**2*s - 232*D1*Dd*f**2 + 4344*D1*Dd*f*fd*r*s - 1267*D1*Dd*f*fd*r + 5952*D1*Dd*f*fd*s**2 - 4739*D1*Dd*f*fd*s + 858*D1*Dd*f*fd + 724*D1*Ddd*f**2*r*s - 181*D1*Ddd*f**2*r + 992*D1*Ddd*f**2*s**2 - 677*D1*Ddd*f**2*s + 248*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(-16*C*s**2 + r*(3*s + 4) + 9*s - 8) + fd*(-12*r*s + r + s**2*(48*C - 16) + s*(8 - 24*C) - 3)) - Dd*f*(24*C*s + r*(24*s + 5) + s**2*(32 - 96*C) + s - 5)) + 2172*Dd**2*f**2*r*s - 543*Dd**2*f**2*r + 2976*Dd**2*f**2*s**2 - 2031*Dd**2*f**2*s + 181*Dd**2*f**2))/(693*d**2*k2**2*k3**2) - 2*D1**2*Pk1*Pk2*k1**2*(b1**2*(D1**2*s*(-21*fd*r + fd*s*(10*C - 24) + 21*fdd*r + fdd*s*(26 - 12*C)) + D1*(Dd*(10*C*f*(4*s**2 - 2*s + 1) - 3*f*(7*r*(4*s - 1) + 32*s**2 - 23*s + 8) + 21*fd*r*(8*s - 1) + fd*s*(C*(24 - 96*s) + 208*s - 73)) + Ddd*f*(-12*C*(4*s**2 - 2*s + 1) + 84*r*s - 21*r + 104*s**2 - 73*s + 26)) + 3*Dd**2*f*(21*r*(4*s - 1) - s**2*(48*C - 104) + s*(24*C - 73) + 7)) + b1*(D1**2*bdd1*f*(-12*C*(2*s**2 - 2*s + 1) + 21*r*(2*s - 1) + 52*s**2 - 73*s + 26) + 2*D1**2*(C*(f*fd*(-6*s**2 + 14*s - 7) + f*fdd*(4*s**2 - 14*s + 7) + 2*fd**2*s*(2*s - 7)) + s*(f*fd*(-22*r - 20*s + 11) + 2*f*fdd*(10*r + 11*s - 5) + 2*fd**2*(10*r + 11*s - 5))) + D1*bd1*(D1*(10*C*f*(2*s**2 - 2*s + 1) - 3*f*(7*r*(2*s - 1) + 16*s**2 - 23*s + 8) + 21*fd*r*(4*s - 1) + fd*s*(C*(24 - 48*s) + 104*s - 73)) + 2*Dd*f*(-12*C*(8*s**2 - 6*s + 1) + 21*r*(8*s - 3) + 208*s**2 - 219*s + 47)) + 2*D1*f*(Dd*(-f*(3*C*(4*s**2 - 2*s + 1) + 44*r*s - 11*r + 40*s**2 - 31*s + 10) + 2*fd*(C*(16*s**2 - 32*s + 7) + 80*r*s - 10*r + 88*s**2 - 52*s + 5)) + Ddd*f*(C*(8*s**2 - 4*s + 2) + 40*r*s - 10*r + 44*s**2 - 32*s + 11)) + 4*Dd**2*f**2*(15*r*(4*s - 1) + s**2*(12*C + 66) - s*(6*C + 48) + 5)) + f*(-12*C*(D1**2*(f*(fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(12*s**2 - 7*s + 1) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + D1**2*bd1**2*(21*r*(2*s - 1) - (s - 1)*(s*(24*C - 52) + 21)) + 2*D1**2*bdd1*f*(C*(2*s**2 + 10*s - 5) + (s - 1)*(10*r + 11*s - 11)) - 2*D1*bd1*(D1*(f*(C*(3*s**2 + 8*s - 4) + (s - 1)*(11*r + 10*s - 10)) - 2*fd*(10*r*(2*s - 1) + s**2*(4*C + 22) + s*(3*C - 27) + 5)) - 2*Dd*f*(C*(8*s**2 + 18*s - 5) + 5*r*(8*s - 5) + 44*s**2 - 60*s + 16))))/(21*d**2*k2**2*k3**2) - 10*D1**2*Pk1*Pk2*k2**2*st**6*(528*C*D1**2*b1*f*fd*r*s - 264*C*D1**2*b1*f*fd*r + 528*C*D1**2*b1*f*fd*s**2 - 528*C*D1**2*b1*f*fd*s + 264*C*D1**2*b1*f*fd - 264*C*D1**2*b1*f*fdd*r*s + 132*C*D1**2*b1*f*fdd*r - 264*C*D1**2*b1*f*fdd*s**2 + 264*C*D1**2*b1*f*fdd*s - 132*C*D1**2*b1*f*fdd - 264*C*D1**2*b1*fd**2*r*s + 132*C*D1**2*b1*fd**2*r - 264*C*D1**2*b1*fd**2*s**2 + 264*C*D1**2*b1*fd**2*s + 24*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r + 24*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r*s + 4*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r*s + 8*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 1056*C*D1*Dd*b1*f**2*r*s - 264*C*D1*Dd*b1*f**2*r + 1056*C*D1*Dd*b1*f**2*s**2 - 792*C*D1*Dd*b1*f**2*s + 264*C*D1*Dd*b1*f**2 - 2112*C*D1*Dd*b1*f*fd*r*s + 792*C*D1*Dd*b1*f*fd*r - 2112*C*D1*Dd*b1*f*fd*s**2 + 1848*C*D1*Dd*b1*f*fd*s - 396*C*D1*Dd*b1*f*fd + 32*C*D1*Dd*f**3*r*s - 8*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r*s + 28*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 84*C*D1*Dd*f**2*fd*s - 16*C*D1*Dd*f**2*fd - 528*C*D1*Ddd*b1*f**2*r*s + 132*C*D1*Ddd*b1*f**2*r - 528*C*D1*Ddd*b1*f**2*s**2 + 396*C*D1*Ddd*b1*f**2*s - 132*C*D1*Ddd*b1*f**2 - 16*C*D1*Ddd*f**3*r*s + 4*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 12*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 1584*C*Dd**2*b1*f**2*r*s + 396*C*Dd**2*b1*f**2*r - 1584*C*Dd**2*b1*f**2*s**2 + 1188*C*Dd**2*b1*f**2*s - 132*C*Dd**2*b1*f**2 - 48*C*Dd**2*f**3*r*s + 12*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 36*C*Dd**2*f**3*s - 4*C*Dd**2*f**3 - 132*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*f*fdd*r*s - 33*D1**2*b1*f*fdd*r + 66*D1**2*b1*fd**2*r**2 + 66*D1**2*b1*fd**2*r*s - 33*D1**2*b1*fd**2*r + 33*D1**2*bdd1*f**2*(r + s - 1)*(-4*C*s + r - 1) - 6*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r + 2*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 - 264*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 198*D1*Dd*b1*f**2*r + 66*D1*Dd*b1*f**2*s - 66*D1*Dd*b1*f**2 + 528*D1*Dd*b1*f*fd*r**2 + 528*D1*Dd*b1*f*fd*r*s - 330*D1*Dd*b1*f*fd*r - 66*D1*Dd*b1*f*fd*s + 33*D1*Dd*b1*f*fd - 8*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r + 2*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 21*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 4*D1*Dd*f**2*fd + 132*D1*Ddd*b1*f**2*r**2 + 132*D1*Ddd*b1*f**2*r*s - 99*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2*s + 33*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r - D1*Ddd*f**3*s + D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(-2*f*(r + s - 1)*(-4*C*s + r - 1) + fd*(-4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 + 4*r*s - 5*r - 2*s + 1)) + Dd*f*(-4*C*(8*r*s - r + 8*s**2 - 7*s + 1) + 8*r**2 + 8*r*s - 11*r - 5*s + 3)) + 396*Dd**2*b1*f**2*r**2 + 396*Dd**2*b1*f**2*r*s - 297*Dd**2*b1*f**2*r - 99*Dd**2*b1*f**2*s + 33*Dd**2*b1*f**2 + 12*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 9*Dd**2*f**3*r - 3*Dd**2*f**3*s + Dd**2*f**3)/(693*d**2*k3**4) + 4*D1**2*Pk1*Pk2*k2**2*st**4*(11*b1**2*(D1**2*r*(2*fd - fdd)*(r + s) + D1*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 3*r + s)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + Dd**2*f*(-12*r**2 + r*(9 - 12*s) + 3*s - 1)) + 11*b1*(6*C*D1**2*f*fd*r**2 + 28*C*D1**2*f*fd*r*s - 14*C*D1**2*f*fd*r + 22*C*D1**2*f*fd*s**2 - 22*C*D1**2*f*fd*s + 11*C*D1**2*f*fd - 10*C*D1**2*f*fdd*r**2 - 28*C*D1**2*f*fdd*r*s + 14*C*D1**2*f*fdd*r - 18*C*D1**2*f*fdd*s**2 + 18*C*D1**2*f*fdd*s - 9*C*D1**2*f*fdd - 10*C*D1**2*fd**2*r**2 - 28*C*D1**2*fd**2*r*s + 14*C*D1**2*fd**2*r - 18*C*D1**2*fd**2*s**2 + 18*C*D1**2*fd**2*s + 12*C*D1*Dd*f**2*r**2 + 56*C*D1*Dd*f**2*r*s - 20*C*D1*Dd*f**2*r + 44*C*D1*Dd*f**2*s**2 - 36*C*D1*Dd*f**2*s + 14*C*D1*Dd*f**2 - 80*C*D1*Dd*f*fd*r**2 - 224*C*D1*Dd*f*fd*r*s + 104*C*D1*Dd*f*fd*r - 144*C*D1*Dd*f*fd*s**2 + 136*C*D1*Dd*f*fd*s - 32*C*D1*Dd*f*fd - 20*C*D1*Ddd*f**2*r**2 - 56*C*D1*Ddd*f**2*r*s + 24*C*D1*Ddd*f**2*r - 36*C*D1*Ddd*f**2*s**2 + 32*C*D1*Ddd*f**2*s - 14*C*D1*Ddd*f**2 - 60*C*Dd**2*f**2*r**2 - 168*C*Dd**2*f**2*r*s + 72*C*Dd**2*f**2*r - 108*C*Dd**2*f**2*s**2 + 96*C*Dd**2*f**2*s - 14*C*Dd**2*f**2 - D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - 2*D1*Dd*f**2 + D1*bd1*(D1*(2*f*(2*r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 3*r + s)) - 2*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2))) + f*(-11*C*D1**2*bdd1*f*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) + 24*C*D1**2*f*fd*r**2 + 24*C*D1**2*f*fd*r*s - 24*C*D1**2*f*fd*r - 8*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 12*C*D1**2*f*fdd*r**2 - 12*C*D1**2*f*fdd*r*s + 12*C*D1**2*f*fdd*r + 4*C*D1**2*f*fdd*s - 4*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r - 8*C*D1*Dd*f**2*s + 8*C*D1*Dd*f**2 - 96*C*D1*Dd*f*fd*r**2 - 96*C*D1*Dd*f*fd*r*s + 84*C*D1*Dd*f*fd*r + 28*C*D1*Dd*f*fd*s - 16*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 - 16*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r + 4*C*D1*Ddd*f**2*s - 4*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 - 48*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r + 12*C*Dd**2*f**2*s - 4*C*Dd**2*f**2 - 11*D1**2*bd1**2*(2*r - 1)*(r + s - 1) - 6*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 4*D1**2*f*fd + 3*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 3*D1**2*f*fdd*s**2 - 4*D1**2*f*fdd*s + 2*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 8*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 8*D1**2*fd**2*s + 2*D1**2*fd**2 - 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 8*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 24*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 28*D1*Dd*f*fd*r + 24*D1*Dd*f*fd*s**2 - 28*D1*Dd*f*fd*s + 8*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 4*D1*Ddd*f**2*s + 2*D1*Ddd*f**2 + 11*D1*bd1*(-8*C*Dd*f*(5*r**2 + 2*r*(7*s - 4) + 9*s**2 - 11*s + 3) + D1*(-2*C*fd*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) + f*(r + s - 1)*(C*(3*r + 11*s - 3) - r - s + 1))) + 12*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 12*Dd**2*f**2*s + 2*Dd**2*f**2))/(77*d**2*k3**4) + 2*D1**2*Pk1*Pk2*k2**2*st**2*(D1*f*(-2*D1*bd1**2*(35*C - 3)*(r + s - 1)**2 + bd1*(r + s - 1)*(D1*f*(C*(5*r - 3*s + 3) - 4*r - 5*s + 4) + D1*fd*(10*C + 6)*(2*r + 2*s - 1) + Dd*f*(20*C + 12)*(2*r + 2*s - 1)) + f*(D1*bdd1*(5*C + 3)*(r + s - 1)**2 + D1*fd*(3*r**2 + 3*r*(s - 1) - s + 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1))) + b1**2*(D1**2*(r + s)**2*(fd*(21*C - 13) + fdd*(3 - 35*C)) + 2*D1*(Dd*(f*(21*C - 13)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fd*(70*C - 6)*(2*r**2 + r*(4*s - 1) + s*(2*s - 1))) - Ddd*f*(35*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd**2*f*(70*C - 6)*(6*r**2 + 6*r*(2*s - 1) + 6*s**2 - 6*s + 1)) + b1*(10*C*D1**2*f*fd*r**2 + 4*C*D1**2*f*fd*r*s - 10*C*D1**2*f*fd*r - 6*C*D1**2*f*fd*s**2 - 2*C*D1**2*f*fd*s + 5*C*D1**2*f*fd + 10*C*D1**2*f*fdd*r**2 + 20*C*D1**2*f*fdd*r*s - 10*C*D1**2*f*fdd*r + 10*C*D1**2*f*fdd*s**2 - 10*C*D1**2*f*fdd*s + 5*C*D1**2*f*fdd + 10*C*D1**2*fd**2*r**2 + 20*C*D1**2*fd**2*r*s - 10*C*D1**2*fd**2*r + 10*C*D1**2*fd**2*s**2 - 10*C*D1**2*fd**2*s + 20*C*D1*Dd*f**2*r**2 + 8*C*D1*Dd*f**2*r*s - 12*C*D1*Dd*f**2*r - 12*C*D1*Dd*f**2*s**2 + 4*C*D1*Dd*f**2*s + 2*C*D1*Dd*f**2 + 80*C*D1*Dd*f*fd*r**2 + 160*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r + 80*C*D1*Dd*f*fd*s**2 - 80*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 20*C*D1*Ddd*f**2*r**2 + 40*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 20*C*D1*Ddd*f**2*s**2 - 20*C*D1*Ddd*f**2*s + 10*C*D1*Ddd*f**2 + 60*C*Dd**2*f**2*r**2 + 120*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 60*C*Dd**2*f**2*s**2 - 60*C*Dd**2*f**2*s + 10*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(35*C - 3)*(r + s - 1)**2 - 8*D1**2*f*fd*r**2 - 18*D1**2*f*fd*r*s + 9*D1**2*f*fd*r - 10*D1**2*f*fd*s**2 + 10*D1**2*f*fd*s - 5*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 6*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 6*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 6*D1**2*fd**2*s - 16*D1*Dd*f**2*r**2 - 36*D1*Dd*f**2*r*s + 17*D1*Dd*f**2*r - 20*D1*Dd*f**2*s**2 + 19*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 48*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 48*D1*Dd*f*fd*s + 12*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 2*D1*bd1*(r + s - 1)*(D1*f*(21*C - 13)*(r + s - 1) - D1*fd*(70*C - 6)*(r + s) - Dd*f*(140*C - 12)*(2*r + 2*s - 1)) + 36*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 6*Dd**2*f**2))/(21*d**2*k3**4) - 20*D1**2*Pk1*Pk2*st**6*(-33*D1*bd1*f*(-2*D1*f*s*(2*C*s - r + 1) - D1*fd*r*(4*s - 1) + D1*fd*(2*s - 1)*(4*C*s + 1) + Dd*f*(16*C*s**2 - 8*r*s + r + s*(5 - 4*C) - 1)) + 33*b1*(2*C*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(2*C*(D1**2*(-f*(33*bdd1*s**2 + fd*(-6*s**2 + 4*s - 2) + 3*fdd*s**2 - 2*fdd*s + fdd) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + D1*Dd*f*(2*f*(-4*r*s + r + s) + fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(2*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) + fd**2*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - 20*D1**2*Pk1*Pk2*st**6*(143*b1**2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + 13*b1*f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(44*bd1 - 22*bdd1)) + 2*fd*s*(bd1*(22 - 44*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(22*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f**2*(D1**2*(f*(-4*fd*(4*s**2 - 2*s + 1) + fdd*(8*s**2 - 4*s + 2) + s**2*(26*bd1 - 13*bdd1)) - 2*s*(143*bd1**2*s + 13*bd1*fd*(3*s - 1) + 6*fd**2*(1 - 2*s))) + 2*D1*f*(Dd*f*(-8*s**2 + 4*s - 2) + Dd*(4*s - 1)*(-13*bd1*s + fd*(8*s - 2)) + Ddd*f*(4*s**2 - 2*s + 1)) + 12*Dd**2*f**2*s*(2*s - 1)))/(1001*d**2*k2**2) - 4*D1**2*Pk1*Pk2*st**4*(858*D1**2*bd1**2*f*s*(-2*K*s + f*(2*r + 9*s - 1) + 2*r - 2*s - 1) - 52*D1*bd1*(D1*(f**3*(4*r*s + 3*s**2 - 6*s + 2) - f**2*fd*(12*r*s - 2*r + 9*s**2 - 11*s + 1) - 33*f*s**2*(b2 - bd2 - 2*g2 + 2*gd2) + 33*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(f**2*(-16*r*s + 2*r - 12*s**2 + 17*s - 3) + s*(33*b2 - 66*g2)*(4*s - 1))) + 858*b1**3*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 429*b1**2*(4*D1**2*K*fd*s**2 - 8*D1**2*K*fd*s + 4*D1**2*K*fd - 2*D1**2*K*fdd*s**2 + 4*D1**2*K*fdd*s - 2*D1**2*K*fdd - 2*D1**2*bdd1*f*(3*s**2 - 2*s + 1) - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 26*D1**2*f*fd*s**2 + 26*D1**2*f*fd*s - 13*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 4*D1**2*fd**2*r*s - 2*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 4*D1**2*fd*r*s + 4*D1**2*fd*r + 4*D1**2*fd*s**2 - 8*D1**2*fd*s + 4*D1**2*fd + 2*D1**2*fdd*r*s - 2*D1**2*fdd*r - 2*D1**2*fdd*s**2 + 4*D1**2*fdd*s - 2*D1**2*fdd + 16*D1*Dd*K*f*s**2 - 8*D1*Dd*K*f*s + 4*D1*Dd*K*f - 16*D1*Dd*K*fd*s**2 + 20*D1*Dd*K*fd*s - 4*D1*Dd*K*fd - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 52*D1*Dd*f**2*s**2 + 28*D1*Dd*f**2*s - 13*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 112*D1*Dd*f*fd*s + 20*D1*Dd*f*fd - 16*D1*Dd*f*r*s + 4*D1*Dd*f*r + 16*D1*Dd*f*s**2 - 4*D1*Dd*f*s + 4*D1*Dd*f + 16*D1*Dd*fd*r*s - 10*D1*Dd*fd*r - 16*D1*Dd*fd*s**2 + 18*D1*Dd*fd*s - 2*D1*Dd*fd - 8*D1*Ddd*K*f*s**2 + 4*D1*Ddd*K*f*s - 2*D1*Ddd*K*f + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 20*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 8*D1*Ddd*f*r*s - 2*D1*Ddd*f*r - 8*D1*Ddd*f*s**2 + 2*D1*Ddd*f*s - 2*D1*Ddd*f + 4*D1*bd1*(D1*f*(3*s**2 - 2*s + 1) + D1*fd*s*(1 - 3*s) + Dd*f*(-12*s**2 + 7*s - 1)) - 24*Dd**2*K*f*s**2 + 12*Dd**2*K*f*s + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 60*Dd**2*f**2*s + 2*Dd**2*f**2 + 24*Dd**2*f*r*s - 6*Dd**2*f*r - 24*Dd**2*f*s**2 + 6*Dd**2*f*s + 2*Dd**2*f) + 26*b1*(-66*D1**2*K*bdd1*f*s**2 - 66*D1**2*bd1**2*f*s*(3*s - 2) + 66*D1**2*bd2*f*s**2 - 66*D1**2*bd2*fd*s**2 + 66*D1**2*bd2*fd*s + 66*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s + 66*D1**2*bdd1*f*r*s - 66*D1**2*bdd1*f*s**2 - 33*D1**2*bdd1*f*s - 33*D1**2*bdd2*f*s**2 - 24*D1**2*f**2*fd*r*s + 8*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 8*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r*s - 4*D1**2*f**2*fdd*r + 9*D1**2*f**2*fdd*s**2 - 4*D1**2*f**2*fdd*s + D1**2*f**2*fdd + 24*D1**2*f*fd**2*r*s - 8*D1**2*f*fd**2*r + 18*D1**2*f*fd**2*s**2 - 8*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 - 132*D1**2*f*gd2*s**2 + 66*D1**2*f*gdd2*s**2 - 132*D1**2*fd*g2*s**2 + 264*D1**2*fd*g2*s - 132*D1**2*fd*g2 + 132*D1**2*fd*gd2*s**2 - 132*D1**2*fd*gd2*s + 66*D1**2*fdd*g2*s**2 - 132*D1**2*fdd*g2*s + 66*D1**2*fdd*g2 - 264*D1*Dd*bd2*f*s**2 + 66*D1*Dd*bd2*f*s - 32*D1*Dd*f**3*r*s + 8*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r*s - 28*D1*Dd*f**2*fd*r + 72*D1*Dd*f**2*fd*s**2 - 46*D1*Dd*f**2*fd*s + 8*D1*Dd*f**2*fd - 528*D1*Dd*f*g2*s**2 + 264*D1*Dd*f*g2*s - 132*D1*Dd*f*g2 + 528*D1*Dd*f*gd2*s**2 - 132*D1*Dd*f*gd2*s + 528*D1*Dd*fd*g2*s**2 - 660*D1*Dd*fd*g2*s + 132*D1*Dd*fd*g2 + 16*D1*Ddd*f**3*r*s - 4*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 10*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 264*D1*Ddd*f*g2*s**2 - 132*D1*Ddd*f*g2*s + 66*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(f*s*(4*K*s - 2*f*r - 13*f*s + f - 4*r + 4*s + 2) + fd*(f*(r*(8*s - 2) + 36*s**2 - 20*s + 1) + r*(4*s - 2) - (s - 1)*(s*(4*K + 4) + 1))) + Dd*f*(-16*K*s**2 + 4*K*s + f*(2*r*(8*s - 1) + 72*s**2 - 24*s + 1) + 2*r*(8*s - 1) - 16*s**2 - 2*s + 1)) + 48*Dd**2*f**3*r*s - 12*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 30*Dd**2*f**3*s + 4*Dd**2*f**3 + 792*Dd**2*f*g2*s**2 - 396*Dd**2*f*g2*s + 33*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))) + 2*f*(13*D1**2*bdd1*(f**2*(4*r*s + 3*s**2 - 6*s + 2) + s**2*(-33*b2 + 66*g2)) - f*(D1**2*(f*(fd*(15*r*(4*s - 1) - 676*s**2 + 323*s - 169) + fdd*(25*r*(4*s - 1) + 468*s**2 - 259*s + 117)) + fd**2*(75*r*(4*s - 1) + 1404*s**2 - 777*s + 25)) + D1*f*(Dd*(f*(60*r*s - 15*r - 676*s**2 + 323*s - 169) + 4*fd*(4*s - 1)*(50*r + 234*s - 71)) + Ddd*f*(25*r*(4*s - 1) + 468*s**2 - 259*s + 117)) + Dd**2*f**2*(75*r*(4*s - 1) + 1404*s**2 - 777*s + 25))))/(3003*d**2*k2**2) - D1**2*Pk1*Pk2*st**2*(-198*D1**2*K*bdd1*f**2*s**2 + 1155*D1**2*b2*bdd1*f*s**2 + 462*D1**2*b2*f*fd*s**2 - 462*D1**2*b2*f*fd*s + 231*D1**2*b2*f*fd - 330*D1**2*b2*f*fdd*s**2 + 330*D1**2*b2*f*fdd*s - 165*D1**2*b2*f*fdd - 330*D1**2*b2*fd**2*s**2 + 330*D1**2*b2*fd**2*s - 33*D1**2*bd1**2*f*(f*(r*(50*s - 4) + 124*s**2 - 53*s + 2) + r*(46*s - 2) - s*(68*K*s + 72*s + 21)) + 231*D1**2*bd2*f**2*s**2 - 660*D1**2*bd2*f*fd*s**2 + 330*D1**2*bd2*f*fd*s + 68*D1**2*bdd1*f**3*r*s + 130*D1**2*bdd1*f**3*r + 99*D1**2*bdd1*f**3*s**2 + 561*D1**2*bdd1*f**3*s - 330*D1**2*bdd1*f**3 + 99*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*s**2 - 2244*D1**2*bdd1*f*g2*s**2 - 165*D1**2*bdd2*f**2*s**2 - 780*D1**2*f**3*fd*r*s + 195*D1**2*f**3*fd*r - 1584*D1**2*f**3*fd*s**2 + 987*D1**2*f**3*fd*s - 396*D1**2*f**3*fd + 780*D1**2*f**3*fdd*r*s - 195*D1**2*f**3*fdd*r + 1584*D1**2*f**3*fdd*s**2 - 987*D1**2*f**3*fdd*s + 396*D1**2*f**3*fdd + 2340*D1**2*f**2*fd**2*r*s - 585*D1**2*f**2*fd**2*r + 4752*D1**2*f**2*fd**2*s**2 - 2961*D1**2*f**2*fd**2*s + 195*D1**2*f**2*fd**2 - 528*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gdd2*s**2 - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 + 1584*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 792*D1**2*f*fdd*g2*s**2 - 792*D1**2*f*fdd*g2*s + 396*D1**2*f*fdd*g2 + 792*D1**2*fd**2*g2*s**2 - 792*D1**2*fd**2*g2*s + 924*D1*Dd*b2*f**2*s**2 - 462*D1*Dd*b2*f**2*s + 231*D1*Dd*b2*f**2 - 2640*D1*Dd*b2*f*fd*s**2 + 1980*D1*Dd*b2*f*fd*s - 330*D1*Dd*b2*f*fd - 1320*D1*Dd*bd2*f**2*s**2 + 330*D1*Dd*bd2*f**2*s - 780*D1*Dd*f**4*r*s + 195*D1*Dd*f**4*r - 1584*D1*Dd*f**4*s**2 + 987*D1*Dd*f**4*s - 396*D1*Dd*f**4 + 6240*D1*Dd*f**3*fd*r*s - 1560*D1*Dd*f**3*fd*r + 12672*D1*Dd*f**3*fd*s**2 - 7896*D1*Dd*f**3*fd*s + 1182*D1*Dd*f**3*fd - 2112*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s - 528*D1*Dd*f**2*g2 + 3168*D1*Dd*f**2*gd2*s**2 - 792*D1*Dd*f**2*gd2*s + 6336*D1*Dd*f*fd*g2*s**2 - 4752*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 660*D1*Ddd*b2*f**2*s**2 + 330*D1*Ddd*b2*f**2*s - 165*D1*Ddd*b2*f**2 + 780*D1*Ddd*f**4*r*s - 195*D1*Ddd*f**4*r + 1584*D1*Ddd*f**4*s**2 - 987*D1*Ddd*f**4*s + 396*D1*Ddd*f**4 + 1584*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 396*D1*Ddd*f**2*g2 + D1*bd1*(D1*(f**3*(-268*r*s + 70*r + 99*s**2 - 825*s + 462) + f**2*(fd*(24*r*(17*s + 8) + 594*s**2 + 856*s - 31) + 33*s*(8*K*s - 5*r + 6*s)) + 33*f*(3*fd*r*(4*s - 1) + fd*s*(K*(12 - 24*s) - 16*s + 5) + s**2*(-49*b2 + 70*bd2 + 80*g2 - 136*gd2)) + 66*fd*s*(35*b2 - 68*g2)*(s - 1)) + Dd*f*(f**2*(r*(544*s + 452) + 792*s**2 + 1978*s - 691) + 33*f*(3*r*(8*s - 1) + s*(-48*K*s + 12*K - 32*s + 5)) + s*(2310*b2 - 4488*g2)*(4*s - 1))) - 1980*Dd**2*b2*f**2*s**2 + 990*Dd**2*b2*f**2*s + 2340*Dd**2*f**4*r*s - 585*Dd**2*f**4*r + 4752*Dd**2*f**4*s**2 - 2961*Dd**2*f**4*s + 195*Dd**2*f**4 + 4752*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 231*b1**3*(D1*Dd*(f*(r*(2 - 8*s) - 28*s**2 + 16*s - 7) + 2*r*(fd*(8*s - 1) - 8*s + 2) + 4*s*(fd*(10*s - 3) + 1)) + D1*(D1*s*(-2*fd*r - 7*fd*s + 2*fdd*r + 5*fdd*s) + Ddd*(f*(8*r*s - 2*r + 20*s**2 - 12*s + 5) + 8*r*s - 2*r - 2*s)) + 2*Dd**2*(f*(12*r*s - 3*r + 30*s**2 - 18*s + 1) + 12*r*s - 3*r - 3*s + 1)) - 33*b1**2*(40*D1**2*K*fd*s**2 - 80*D1**2*K*fd*s + 40*D1**2*K*fd - 34*D1**2*K*fdd*s**2 + 68*D1**2*K*fdd*s - 34*D1**2*K*fdd - 7*D1**2*bdd1*(f*(6*r*s - 2*r + 15*s**2 - 12*s + 5) + 6*r*s - 2*r - 2*s) - 34*D1**2*f*fd*r*s + 21*D1**2*f*fd*r - 140*D1**2*f*fd*s**2 + 96*D1**2*f*fd*s - 49*D1**2*f*fd + 50*D1**2*f*fdd*r*s - 21*D1**2*f*fdd*r + 124*D1**2*f*fdd*s**2 - 96*D1**2*f*fdd*s + 47*D1**2*f*fdd + 50*D1**2*fd**2*r*s - 21*D1**2*fd**2*r + 124*D1**2*fd**2*s**2 - 96*D1**2*fd**2*s - 39*D1**2*fd*r*s + 35*D1**2*fd*r + 58*D1**2*fd*s**2 - 112*D1**2*fd*s + 58*D1**2*fd + 23*D1**2*fdd*r*s - 21*D1**2*fdd*r - 36*D1**2*fdd*s**2 + 70*D1**2*fdd*s - 36*D1**2*fdd + 160*D1*Dd*K*f*s**2 - 80*D1*Dd*K*f*s + 40*D1*Dd*K*f - 272*D1*Dd*K*fd*s**2 + 340*D1*Dd*K*fd*s - 68*D1*Dd*K*fd - 68*D1*Dd*f**2*r*s + 17*D1*Dd*f**2*r - 280*D1*Dd*f**2*s**2 + 157*D1*Dd*f**2*s - 70*D1*Dd*f**2 + 400*D1*Dd*f*fd*r*s - 134*D1*Dd*f*fd*r + 992*D1*Dd*f*fd*s**2 - 682*D1*Dd*f*fd*s + 117*D1*Dd*f*fd - 156*D1*Dd*f*r*s + 39*D1*Dd*f*r + 232*D1*Dd*f*s**2 - 77*D1*Dd*f*s + 58*D1*Dd*f + 184*D1*Dd*fd*r*s - 107*D1*Dd*fd*r - 288*D1*Dd*fd*s**2 + 329*D1*Dd*fd*s - 49*D1*Dd*fd - 136*D1*Ddd*K*f*s**2 + 68*D1*Ddd*K*f*s - 34*D1*Ddd*K*f + 100*D1*Ddd*f**2*r*s - 25*D1*Ddd*f**2*r + 248*D1*Ddd*f**2*s**2 - 149*D1*Ddd*f**2*s + 62*D1*Ddd*f**2 + 92*D1*Ddd*f*r*s - 23*D1*Ddd*f*r - 144*D1*Ddd*f*s**2 + 49*D1*Ddd*f*s - 36*D1*Ddd*f + 7*D1*bd1*(D1*(f*(r*(6*s - 2) + 21*s**2 - 16*s + 7) - 2*r*(6*fd*s - fd - 6*s + 2) - 2*s*(15*fd*s - 6*fd + 2)) - 2*Dd*(f*(24*r*s - 7*r + 60*s**2 - 42*s + 7) + 24*r*s - 7*r - 7*s + 2)) - 408*Dd**2*K*f*s**2 + 204*Dd**2*K*f*s + 300*Dd**2*f**2*r*s - 75*Dd**2*f**2*r + 744*Dd**2*f**2*s**2 - 447*Dd**2*f**2*s + 25*Dd**2*f**2 + 276*Dd**2*f*r*s - 69*Dd**2*f*r - 432*Dd**2*f*s**2 + 147*Dd**2*f*s + 23*Dd**2*f) + b1*(2244*D1**2*K*bdd1*f*s**2 + 528*D1**2*K*f*fd*s**2 - 528*D1**2*K*f*fd*s + 264*D1**2*K*f*fd - 396*D1**2*K*f*fdd*s**2 + 396*D1**2*K*f*fdd*s - 198*D1**2*K*f*fdd - 396*D1**2*K*fd**2*s**2 + 396*D1**2*K*fd**2*s + 462*D1**2*bd1**2*(f*(r*(6*s - 2) + 15*s**2 - 12*s + 1) + r*(6*s - 2) - 2*s + 1) - 1617*D1**2*bd2*f*s**2 + 2310*D1**2*bd2*fd*s**2 - 2310*D1**2*bd2*fd*s - 1650*D1**2*bdd1*f**2*r*s + 132*D1**2*bdd1*f**2*r - 4092*D1**2*bdd1*f**2*s**2 + 1749*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 1518*D1**2*bdd1*f*r*s + 66*D1**2*bdd1*f*r + 2376*D1**2*bdd1*f*s**2 + 693*D1**2*bdd1*f*s + 1155*D1**2*bdd2*f*s**2 - 804*D1**2*f**2*fd*r*s + 198*D1**2*f**2*fd*r + 297*D1**2*f**2*fd*s**2 + 895*D1**2*f**2*fd*s - 363*D1**2*f**2*fd + 204*D1**2*f**2*fdd*r*s - 198*D1**2*f**2*fdd*r + 297*D1**2*f**2*fdd*s**2 - 827*D1**2*f**2*fdd*s + 429*D1**2*f**2*fdd + 408*D1**2*f*fd**2*r*s - 396*D1**2*f*fd**2*r + 594*D1**2*f*fd**2*s**2 - 1654*D1**2*f*fd**2*s + 99*D1**2*f*fd**2 - 330*D1**2*f*fd*r*s + 165*D1**2*f*fd*r + 396*D1**2*f*fd*s**2 - 231*D1**2*f*fd*s + 198*D1**2*f*fd + 198*D1**2*f*fdd*r*s - 99*D1**2*f*fdd*r - 264*D1**2*f*fdd*s**2 + 165*D1**2*f*fdd*s - 132*D1**2*f*fdd + 2640*D1**2*f*gd2*s**2 - 2244*D1**2*f*gdd2*s**2 + 198*D1**2*fd**2*r*s - 99*D1**2*fd**2*r - 264*D1**2*fd**2*s**2 + 165*D1**2*fd**2*s + 99*D1**2*fd**2 + 2640*D1**2*fd*g2*s**2 - 5280*D1**2*fd*g2*s + 2640*D1**2*fd*g2 - 4488*D1**2*fd*gd2*s**2 + 4488*D1**2*fd*gd2*s - 2244*D1**2*fdd*g2*s**2 + 4488*D1**2*fdd*g2*s - 2244*D1**2*fdd*g2 + 1056*D1*Dd*K*f**2*s**2 - 528*D1*Dd*K*f**2*s + 264*D1*Dd*K*f**2 - 3168*D1*Dd*K*f*fd*s**2 + 2376*D1*Dd*K*f*fd*s - 396*D1*Dd*K*f*fd + 9240*D1*Dd*bd2*f*s**2 - 2310*D1*Dd*bd2*f*s - 1072*D1*Dd*f**3*r*s + 268*D1*Dd*f**3*r + 396*D1*Dd*f**3*s**2 + 70*D1*Dd*f**3*s + 99*D1*Dd*f**3 + 1632*D1*Dd*f**2*fd*r*s - 996*D1*Dd*f**2*fd*r + 2376*D1*Dd*f**2*fd*s**2 - 4106*D1*Dd*f**2*fd*s + 1025*D1*Dd*f**2*fd - 660*D1*Dd*f**2*r*s + 165*D1*Dd*f**2*r + 792*D1*Dd*f**2*s**2 - 231*D1*Dd*f**2*s + 198*D1*Dd*f**2 + 1584*D1*Dd*f*fd*r*s - 594*D1*Dd*f*fd*r - 2112*D1*Dd*f*fd*s**2 + 990*D1*Dd*f*fd*s - 66*D1*Dd*f*fd + 10560*D1*Dd*f*g2*s**2 - 5280*D1*Dd*f*g2*s + 2640*D1*Dd*f*g2 - 17952*D1*Dd*f*gd2*s**2 + 4488*D1*Dd*f*gd2*s - 17952*D1*Dd*fd*g2*s**2 + 22440*D1*Dd*fd*g2*s - 4488*D1*Dd*fd*g2 - 792*D1*Ddd*K*f**2*s**2 + 396*D1*Ddd*K*f**2*s - 198*D1*Ddd*K*f**2 + 272*D1*Ddd*f**3*r*s - 68*D1*Ddd*f**3*r + 396*D1*Ddd*f**3*s**2 - 266*D1*Ddd*f**3*s + 99*D1*Ddd*f**3 + 396*D1*Ddd*f**2*r*s - 99*D1*Ddd*f**2*r - 528*D1*Ddd*f**2*s**2 + 165*D1*Ddd*f**2*s - 132*D1*Ddd*f**2 - 8976*D1*Ddd*f*g2*s**2 + 4488*D1*Ddd*f*g2*s - 2244*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(f**2*(r*(34*s + 4) + 140*s**2 - 61*s + 21) - f*(fd*(50*r*(4*s - 1) + 496*s**2 - 298*s + 23) + r*(4 - 78*s) + s*(80*K*s + 116*s + 35)) + fd*(r*(44 - 92*s) + s**2*(136*K + 144) - s*(136*K + 119) - 23)) - Dd*f*(-544*K*s**2 + 136*K*s + f*(r*(400*s - 66) + 992*s**2 - 510*s + 57) + r*(368*s - 54) - 576*s**2 + 14*s + 23)) - 2376*Dd**2*K*f**2*s**2 + 1188*Dd**2*K*f**2*s + 816*Dd**2*f**3*r*s - 204*Dd**2*f**3*r + 1188*Dd**2*f**3*s**2 - 798*Dd**2*f**3*s + 68*Dd**2*f**3 + 1188*Dd**2*f**2*r*s - 297*Dd**2*f**2*r - 1584*Dd**2*f**2*s**2 + 495*Dd**2*f**2*s + 99*Dd**2*f**2 - 26928*Dd**2*f*g2*s**2 + 13464*Dd**2*f*g2*s - 231*b2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + D1*(7*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(4*s**2 - 5*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f*s*(1 - 2*s))))/(693*d**2*k2**2) - 2*D1**2*Pk1*Pk2*(7*D1**2*K*bdd1*f**2*s**2 - 14*D1**2*b2*f*fd*s**2 + 14*D1**2*b2*f*fd*s - 7*D1**2*b2*f*fd + 14*D1**2*b2*f*fdd*s**2 - 14*D1**2*b2*f*fdd*s + 7*D1**2*b2*f*fdd + 14*D1**2*b2*fd**2*s**2 - 14*D1**2*b2*fd**2*s + D1**2*bd1**2*(f**2*(18*r*(2*s - 1) + 56*s**2 - 51*s + 9) + 3*f*(r*(6*s - 3) + 4*s*(-K*s + K + s - 1)) + 28*g2*s*(s - 1)) - 7*D1**2*bd2*f**2*s**2 + 28*D1**2*bd2*f*fd*s**2 - 14*D1**2*bd2*f*fd*s + 10*D1**2*bdd1*f**3*r*s - 10*D1**2*bdd1*f**3*r + 18*D1**2*bdd1*f**3*s**2 - 24*D1**2*bdd1*f**3*s + 12*D1**2*bdd1*f**3 + 7*D1**2*bdd1*f**2*s**2 + 12*D1**2*bdd1*f*g2*s**2 - 24*D1**2*bdd1*f*g2*s + 12*D1**2*bdd1*f*g2 + 7*D1**2*bdd2*f**2*s**2 + 14*D1**2*f**2*gd2*s**2 - 14*D1**2*f**2*gdd2*s**2 + 28*D1**2*f*fd*g2*s**2 - 28*D1**2*f*fd*g2*s + 14*D1**2*f*fd*g2 - 56*D1**2*f*fd*gd2*s**2 + 28*D1**2*f*fd*gd2*s - 28*D1**2*f*fdd*g2*s**2 + 28*D1**2*f*fdd*g2*s - 14*D1**2*f*fdd*g2 - 28*D1**2*fd**2*g2*s**2 + 28*D1**2*fd**2*g2*s - 28*D1*Dd*b2*f**2*s**2 + 14*D1*Dd*b2*f**2*s - 7*D1*Dd*b2*f**2 + 112*D1*Dd*b2*f*fd*s**2 - 84*D1*Dd*b2*f*fd*s + 14*D1*Dd*b2*f*fd + 56*D1*Dd*bd2*f**2*s**2 - 14*D1*Dd*bd2*f**2*s + 56*D1*Dd*f**2*g2*s**2 - 28*D1*Dd*f**2*g2*s + 14*D1*Dd*f**2*g2 - 112*D1*Dd*f**2*gd2*s**2 + 28*D1*Dd*f**2*gd2*s - 224*D1*Dd*f*fd*g2*s**2 + 168*D1*Dd*f*fd*g2*s - 28*D1*Dd*f*fd*g2 + 28*D1*Ddd*b2*f**2*s**2 - 14*D1*Ddd*b2*f**2*s + 7*D1*Ddd*b2*f**2 - 56*D1*Ddd*f**2*g2*s**2 + 28*D1*Ddd*f**2*g2*s - 14*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(2*f**3*(5*r*(s - 1) + 9*s**2 - 12*s + 6) + f**2*(-2*fd*(30*r*s - 15*r + 54*s**2 - 47*s + 5) + s**2*(7*K + 7)) + 2*f*(-7*fd*s*(K + 1)*(2*s - 1) + 5*g2*(s - 1)**2 - 12*gd2*s*(s - 1)) - 24*fd*g2*s*(s - 1)) + 2*Dd*f*(f**2*(5*r*(8*s - 5) + 72*s**2 - 71*s + 17) + 7*f*s*(K + 1)*(4*s - 1) + 12*g2*(4*s**2 - 5*s + 1))) + 84*Dd**2*b2*f**2*s**2 - 42*Dd**2*b2*f**2*s - 168*Dd**2*f**2*g2*s**2 + 84*Dd**2*f**2*g2*s + 7*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + b1**2*(5*D1**2*K*fd*s**2 - 6*D1**2*K*fdd*s**2 - 7*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) - 36*D1**2*f*fd*r*s - 56*D1**2*f*fd*s**2 + 23*D1**2*f*fd*s - 7*D1**2*f*fd + 36*D1**2*f*fdd*r*s + 56*D1**2*f*fdd*s**2 - 23*D1**2*f*fdd*s + 7*D1**2*f*fdd + 36*D1**2*fd**2*r*s + 56*D1**2*fd**2*s**2 - 23*D1**2*fd**2*s - 11*D1**2*fd*r*s - 5*D1**2*fd*s**2 + 11*D1**2*fd*s + 9*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 - 9*D1**2*fdd*s - 28*D1**2*gd2*s**2 + 14*D1**2*gdd2*s**2 + 20*D1*Dd*K*f*s**2 - 10*D1*Dd*K*f*s + 5*D1*Dd*K*f - 48*D1*Dd*K*fd*s**2 + 12*D1*Dd*K*fd*s - 72*D1*Dd*f**2*r*s + 18*D1*Dd*f**2*r - 112*D1*Dd*f**2*s**2 + 74*D1*Dd*f**2*s - 28*D1*Dd*f**2 + 288*D1*Dd*f*fd*r*s - 36*D1*Dd*f*fd*r + 448*D1*Dd*f*fd*s**2 - 240*D1*Dd*f*fd*s + 23*D1*Dd*f*fd - 44*D1*Dd*f*r*s + 11*D1*Dd*f*r - 20*D1*Dd*f*s**2 + 21*D1*Dd*f*s - 5*D1*Dd*f + 72*D1*Dd*fd*r*s - 9*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 57*D1*Dd*fd*s + 9*D1*Dd*fd - 112*D1*Dd*g2*s**2 + 56*D1*Dd*g2*s - 28*D1*Dd*g2 + 112*D1*Dd*gd2*s**2 - 28*D1*Dd*gd2*s - 24*D1*Ddd*K*f*s**2 + 12*D1*Ddd*K*f*s - 6*D1*Ddd*K*f + 72*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 112*D1*Ddd*f**2*s**2 - 74*D1*Ddd*f**2*s + 28*D1*Ddd*f**2 + 36*D1*Ddd*f*r*s - 9*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 21*D1*Ddd*f*s + 6*D1*Ddd*f + 56*D1*Ddd*g2*s**2 - 28*D1*Ddd*g2*s + 14*D1*Ddd*g2 + 14*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) - 72*Dd**2*K*f*s**2 + 36*Dd**2*K*f*s + 216*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 336*Dd**2*f**2*s**2 - 222*Dd**2*f**2*s + 18*Dd**2*f**2 + 108*Dd**2*f*r*s - 27*Dd**2*f*r + 72*Dd**2*f*s**2 - 63*Dd**2*f*s + 9*Dd**2*f + 168*Dd**2*g2*s**2 - 84*Dd**2*g2*s) + b1*(-14*D1**2*K*f*fd*s**2 + 14*D1**2*K*f*fd*s - 7*D1**2*K*f*fd + 14*D1**2*K*f*fdd*s**2 - 14*D1**2*K*f*fdd*s + 7*D1**2*K*f*fdd + 14*D1**2*K*fd**2*s**2 - 14*D1**2*K*fd**2*s - 14*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + D1**2*bdd1*(f**2*(18*r*(2*s - 1) + 56*s**2 - 51*s + 21) + 3*f*(K*(-4*s**2 + 4*s - 2) + 6*r*s - 3*r + 4*s**2 - 4*s + 2) + 14*g2*(2*s**2 - 2*s + 1)) - 30*D1**2*f**2*fd*r*s - 54*D1**2*f**2*fd*s**2 + 22*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r*s + 54*D1**2*f**2*fdd*s**2 - 22*D1**2*f**2*fdd*s + 6*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r*s + 108*D1**2*f*fd**2*s**2 - 44*D1**2*f*fd**2*s - 14*D1**2*f*fd*s**2 + 14*D1**2*f*fd*s - 7*D1**2*f*fd + 14*D1**2*f*fdd*s**2 - 14*D1**2*f*fdd*s + 7*D1**2*f*fdd - 10*D1**2*f*gd2*s**2 + 12*D1**2*f*gdd2*s**2 + 14*D1**2*fd**2*s**2 - 14*D1**2*fd**2*s - 10*D1**2*fd*g2*s**2 + 24*D1**2*fd*gd2*s**2 + 12*D1**2*fdd*g2*s**2 - 28*D1*Dd*K*f**2*s**2 + 14*D1*Dd*K*f**2*s - 7*D1*Dd*K*f**2 + 112*D1*Dd*K*f*fd*s**2 - 84*D1*Dd*K*f*fd*s + 14*D1*Dd*K*f*fd - 40*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 46*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r*s - 30*D1*Dd*f**2*fd*r + 432*D1*Dd*f**2*fd*s**2 - 226*D1*Dd*f**2*fd*s + 22*D1*Dd*f**2*fd - 28*D1*Dd*f**2*s**2 + 14*D1*Dd*f**2*s - 7*D1*Dd*f**2 + 112*D1*Dd*f*fd*s**2 - 84*D1*Dd*f*fd*s + 14*D1*Dd*f*fd - 40*D1*Dd*f*g2*s**2 + 20*D1*Dd*f*g2*s - 10*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*s**2 - 24*D1*Dd*f*gd2*s + 96*D1*Dd*fd*g2*s**2 - 24*D1*Dd*fd*g2*s + 28*D1*Ddd*K*f**2*s**2 - 14*D1*Ddd*K*f**2*s + 7*D1*Ddd*K*f**2 + 40*D1*Ddd*f**3*r*s - 10*D1*Ddd*f**3*r + 72*D1*Ddd*f**3*s**2 - 46*D1*Ddd*f**3*s + 18*D1*Ddd*f**3 + 28*D1*Ddd*f**2*s**2 - 14*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*s**2 - 24*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(r*(18 - 36*s) - 56*s**2 + 51*s - 21) + f*(5*K*(2*s**2 - 2*s + 1) + fd*(36*r*(4*s - 1) + 224*s**2 - 148*s + 9) - 22*r*s + 11*r - 10*s**2 + 10*s - 5) + 9*fd*r*(4*s - 1) - 3*fd*(2*s - 1)*(s*(4*K - 4) + 3) - 28*g2*(2*s**2 - 2*s + 1) - 28*gd2*s*(1 - 2*s)) + Dd*(f**2*(8*s - 3)*(36*r + 56*s - 23) - 3*f*(4*K*(8*s**2 - 6*s + 1) - 48*r*s + 18*r - 32*s**2 + 30*s - 7) + 28*g2*(8*s**2 - 6*s + 1))) + 84*Dd**2*K*f**2*s**2 - 42*Dd**2*K*f**2*s + 120*Dd**2*f**3*r*s - 30*Dd**2*f**3*r + 216*Dd**2*f**3*s**2 - 138*Dd**2*f**3*s + 10*Dd**2*f**3 + 84*Dd**2*f**2*s**2 - 42*Dd**2*f**2*s + 144*Dd**2*f*g2*s**2 - 72*Dd**2*f*g2*s))/(21*d**2*k2**2) + 10*D1**2*Pk1*Pk2*k2**4*st**6*(132*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 33*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 6*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r - 2*D1**2*f**2*fd*s + 2*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 3*D1**2*f**2*fdd*r*s + 3*D1**2*f**2*fdd*r + D1**2*f**2*fdd*s - D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 6*D1**2*f*fd**2*r*s + 6*D1**2*f*fd**2*r + 2*D1**2*f*fd**2*s - D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 198*D1*Dd*b1*f**2*r - 66*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 330*D1*Dd*b1*f*fd*r + 66*D1*Dd*b1*f*fd*s - 33*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r - 2*D1*Dd*f**3*s + 2*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 24*D1*Dd*f**2*fd*r*s + 21*D1*Dd*f**2*fd*r + 7*D1*Dd*f**2*fd*s - 4*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 99*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 4*D1*Ddd*f**3*r*s + 3*D1*Ddd*f**3*r + D1*Ddd*f**3*s - D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(-8*r**2 + r*(11 - 8*s) + 5*s - 3)) - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 297*Dd**2*b1*f**2*r + 99*Dd**2*b1*f**2*s - 33*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 12*Dd**2*f**3*r*s + 9*Dd**2*f**3*r + 3*Dd**2*f**3*s - Dd**2*f**3)/(693*d**2*k1**2*k3**4) + 4*D1**2*Pk1*Pk2*k2**4*st**4*(-D1**2*bd1*f*(bd1*(2*r - 1) + f*(r - 1))*(r + s - 1) + D1*b1*(bd1*(D1*(2*f*(2*r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 3*r + s)) - 2*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - f*(D1*bdd1*(2*r - 1)*(r + s - 1) + D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*s - 3*r - s + 1))) + b1**2*(D1**2*r*(2*fd - fdd)*(r + s) + D1*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 3*r + s)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + Dd**2*f*(-12*r**2 + r*(9 - 12*s) + 3*s - 1)))/(7*d**2*k1**2*k3**4) + D1**2*Pk1*Pkd2*ct**8*k2**3*(40*C - 40)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 56*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 28*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 28*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**8*k2*(10*C - 10)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 2*D1*f*(28*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k3**2) - 5*D1**2*Pk1*Pkd2*ct**7*f*(52*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(90*fd*(4*s**2 - 2*s + 1) - 45*fdd*(4*s**2 - 2*s + 1) + s**2*(104*bd1 - 52*bdd1)) + 2*fd*s*(-52*bd1*(3*s - 1) + 135*fd*(1 - 2*s))) + D1*f*(90*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(52*bd1*s + 45*fd*(4*s - 1)) - 45*Ddd*f*(4*s**2 - 2*s + 1)) + 270*Dd**2*f**2*s*(1 - 2*s)))/(143*d**2*k1) + 4*D1**2*Pk1*Pkd2*ct**7*k1*k2**2*(33*b1*(D1**2*(f*(fd*(48*C - 58) + fdd*(35 - 30*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(35 - 30*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(48*C - 58)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(35 - 30*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(35 - 30*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(35 - 30*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(270*C - 326)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (6*C - 7)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(196 - 168*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(48*C - 58)*(r + s - 1) - fd*(30*C - 35)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(35 - 30*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 10*D1*f*(Dd*(f*(135*C - 163)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(84*C - 98)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(98 - 84*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(196 - 168*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**7*k1*(20*C - 25)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 2*D1*f*(28*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k3**2) - 20*D1**2*Pk1*Pkd2*ct**7*k2**4*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 56*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 28*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 28*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k1*k3**4) + D1**2*Pk1*Pkd2*ct**7*k2**2*(-33*b1*(D1**2*(f*(fd*r*(48*C - 48)*(2*s - 1) + 50*fd*(2*s**2 - 2*s + 1) - 25*fdd*(2*s**2 - 2*s + 1)) - 50*fd**2*s*(s - 1)) + D1*f*(2*Dd*f*(-24*C*s + r*(24*C - 24)*(4*s - 1) + 100*s**2 - 26*s + 25) - 50*Dd*fd*(8*s**2 - 6*s + 1) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(-40*fd*(r*(43*C - 43)*(3*s - 1) + 105*s**2 - s*(43*C + 27) + 35) + 100*fdd*(r*(2*C - 2)*(3*s - 1) + 21*s**2 - s*(2*C + 12) + 7) - 33*s*(bd1*(48*C*(r - 1) - 48*r + 50*s + 48) - 25*bdd1*s)) + 50*fd*(33*bd1*s*(2*s - 1) + 4*fd*(C*r*(6*s - 2) - 2*C*s + C + r*(2 - 6*s) + 21*s**2 - 12*s - 1))) - 10*D1*f*(Dd*(-165*bd1*s*(4*s - 1) + 4*f*(-43*C*s + r*(43*C - 43)*(4*s - 1) + 140*s**2 - 27*s + 35) - 20*fd*(C*(24*r*s - 7*r - 7*s + 2) - 24*r*s + 7*r + 84*s**2 - 42*s + 5)) - 10*Ddd*f*(r*(2*C - 2)*(4*s - 1) + 28*s**2 - s*(2*C + 12) + 7)) + 200*Dd**2*f**2*(3*C*r*(4*s - 1) - 3*C*s + C + r*(3 - 12*s) + 42*s**2 - 18*s - 1)))/(693*d**2*k1*k3**2) - 10*D1**2*Pk1*Pkd2*ct**6*f*k2*(13*D1*bd1*f*(D1*(13*f*s*(r - 1) - 23*fd*(6*r*s - r - 3*s + 1)) - 23*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 13*b1*(D1*Dd*f*(13*f*(-4*r*s + r + s) + 23*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(13*f*fd - 23*f*fdd - 46*fd**2) + 23*Ddd*f**2*(4*r*s - r - s)) + 23*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(-28*D1*Dd*f*(f*r*(4*s - 1) - f*s + 12*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-28*f*fd*(r*(4*s - 1) - s) + f*(-299*bdd1*s*(r - 1) - 168*fdd*(4*r*s - r - s)) - 168*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 168*Ddd*f**2*(-4*r*s + r + s)) - 168*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k1**2) + 4*D1**2*Pk1*Pkd2*ct**6*k1**2*k2*(33*b1*(D1**2*(f*(fd*(12*C - 20) + fdd*(15 - 10*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(15 - 10*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(12*C - 20)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(15 - 10*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(15 - 10*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(15 - 10*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(68*C - 113)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (2*C - 3)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(84 - 56*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(12*C - 20)*(r + s - 1) - fd*(10*C - 15)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(15 - 10*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*(f*(68*C - 113)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(56*C - 84)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(84 - 56*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(84 - 56*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**6*k1**2*(10*C - 20)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 2*D1*f*(28*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2*k3**2) + D1**2*Pk1*Pkd2*ct**6*k2**3*st**2*(20*C - 20)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 50*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 25*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 25*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k3**4) + 4*D1**2*Pk1*Pkd2*ct**6*k2**3*(396*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 33*b1*(-24*C*D1**2*f*fd*r*s + 32*C*D1**2*f*fd*r - 24*C*D1**2*f*fd*s**2 + 44*C*D1**2*f*fd*s - 32*C*D1**2*f*fd - 10*C*D1**2*f*fdd*r - 10*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd - 10*C*D1**2*fd**2*r - 10*C*D1**2*fd**2*s - 48*C*D1*Dd*f**2*r*s + 12*C*D1*Dd*f**2*r - 48*C*D1*Dd*f**2*s**2 + 36*C*D1*Dd*f**2*s - 12*C*D1*Dd*f**2 - 40*C*D1*Dd*f*fd*r - 40*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd - 12*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) - 64*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 64*D1**2*f*fd*s**2 + 44*D1**2*f*fd*s - 12*D1**2*f*fd + 50*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r + 50*D1**2*f*fdd*s**2 - 40*D1**2*f*fdd*s + 15*D1**2*f*fdd + 50*D1**2*fd**2*r*s - 15*D1**2*fd**2*r + 50*D1**2*fd**2*s**2 - 40*D1**2*fd**2*s - 128*D1*Dd*f**2*r*s + 32*D1*Dd*f**2*r - 128*D1*Dd*f**2*s**2 + 96*D1*Dd*f**2*s - 32*D1*Dd*f**2 + 400*D1*Dd*f*fd*r*s - 110*D1*Dd*f*fd*r + 400*D1*Dd*f*fd*s**2 - 310*D1*Dd*f*fd*s + 55*D1*Dd*f*fd + 100*D1*Ddd*f**2*r*s - 25*D1*Ddd*f**2*r + 100*D1*Ddd*f**2*s**2 - 75*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 + 12*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 300*Dd**2*f**2*r*s - 75*Dd**2*f**2*r + 300*Dd**2*f**2*s**2 - 225*Dd**2*f**2*s + 25*Dd**2*f**2) + f*(-396*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) + 165*D1**2*bdd1*f*(2*C + 5*s - 2)*(r + s - 1) + 5*D1**2*(-f*(fd*(178*C + 69) - fdd*(56*C + 84))*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(56*C + 84)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 33*D1*bd1*(D1*(4*f*(r + s - 1)*(C*(3*s + 5) + 8*s - 5) - 5*fd*(r*(2*C + 20*s - 7) + 20*s**2 + s*(2*C - 22) + 5)) - 5*Dd*f*(C*(8*r + 8*s - 4) + r*(40*s - 13) + 40*s**2 - 43*s + 9)) + 5*D1*f*(Dd*(-f*(178*C + 69)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(56*C + 84)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(56*C + 84)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(56*C + 84)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**6*k2*st**2*(15*C - 15)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(50*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k3**2) + 2*D1**2*Pk1*Pkd2*ct**6*k2*(990*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(-144*C*D1**2*f*fd*r*s + 72*C*D1**2*f*fd*r - 224*C*D1**2*f*fd*s**2 + 324*C*D1**2*f*fd*s - 162*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 148*C*D1**2*f*fdd*s**2 - 198*C*D1**2*f*fdd*s + 99*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 148*C*D1**2*fd**2*s**2 - 198*C*D1**2*fd**2*s - 288*C*D1*Dd*f**2*r*s + 72*C*D1*Dd*f**2*r - 448*C*D1*Dd*f**2*s**2 + 296*C*D1*Dd*f**2*s - 112*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r*s - 144*C*D1*Dd*f*fd*r + 1184*C*D1*Dd*f*fd*s**2 - 1136*C*D1*Dd*f*fd*s + 222*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 296*C*D1*Ddd*f**2*s**2 - 172*C*D1*Ddd*f**2*s + 74*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 888*C*Dd**2*f**2*s**2 - 516*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 30*D1**2*bdd1*f*(C - 1)*(2*s**2 - 2*s + 1) + 164*D1**2*f*fd*r*s - 82*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 - 124*D1**2*f*fd*s + 62*D1**2*f*fd - 58*D1**2*f*fdd*r*s + 29*D1**2*f*fdd*r - 48*D1**2*f*fdd*s**2 + 98*D1**2*f*fdd*s - 49*D1**2*f*fdd - 58*D1**2*fd**2*r*s + 29*D1**2*fd**2*r - 48*D1**2*fd**2*s**2 + 98*D1**2*fd**2*s + 328*D1*Dd*f**2*r*s - 82*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 106*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 464*D1*Dd*f*fd*r*s + 174*D1*Dd*f*fd*r - 384*D1*Dd*f*fd*s**2 + 546*D1*Dd*f*fd*s - 127*D1*Dd*f*fd - 116*D1*Ddd*f**2*r*s + 29*D1*Ddd*f**2*r - 96*D1*Ddd*f**2*s**2 + 77*D1*Ddd*f**2*s - 24*D1*Ddd*f**2 + 60*D1*bd1*(C - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 348*Dd**2*f**2*r*s + 87*Dd**2*f**2*r - 288*Dd**2*f**2*s**2 + 231*Dd**2*f**2*s - 29*Dd**2*f**2) - f*(1980*D1**2*bd1**2*s*(C - 1)*(s - 1) - 33*D1**2*bdd1*f*(C*(74*s**2 + s*(24*r + 26) - 25) - 24*s**2 - s*(29*r + 21) + 25) + 5*D1**2*(f*(4*fd*(C*(119*r*(3*s - 1) + 675*s**2 - 569*s + 225) - 138*r*(3*s - 1) - 255*s**2 + 308*s - 85) + fdd*(C*(-172*r*(3*s - 1) - 1647*s**2 + 1270*s - 549) + 210*r*(3*s - 1) + 807*s**2 - 748*s + 269)) - 2*fd**2*(C*(172*r*(3*s - 1) + 1647*s**2 - 1270*s + 86) - 210*r*(3*s - 1) - 807*s**2 + 748*s - 105)) + 33*D1*bd1*(D1*(2*f*(C*(56*s**2 + s*(36*r + 14) - 25) - 6*s**2 - s*(41*r + 9) + 25) + fd*(-2*C*(12*r*(4*s - 1) + 148*s**2 - 73*s + 12) + 29*r*(4*s - 1) + 96*s**2 - 56*s + 29)) + Dd*f*(C*(-24*r*(8*s - 1) - 592*s**2 + 68*s + 26) + 29*r*(8*s - 1) + 192*s**2 + 7*s - 21)) + 5*D1*f*(2*Dd*(2*f*(C*(119*r*(4*s - 1) + 900*s**2 - 569*s + 225) - 138*r*(4*s - 1) - 340*s**2 + 308*s - 85) + fd*(C*(-86*r*(24*s - 7) - 6588*s**2 + 4445*s - 721) + 105*r*(24*s - 7) + 3228*s**2 - 2618*s + 479)) + Ddd*f*(C*(-172*r*(4*s - 1) - 2196*s**2 + 1270*s - 549) + 210*r*(4*s - 1) + 1076*s**2 - 748*s + 269)) + 10*Dd**2*f**2*(C*(-258*r*(4*s - 1) - 3294*s**2 + 1905*s - 86) + 315*r*(4*s - 1) + 1614*s**2 - 1122*s + 105)))/(693*d**2*k3**2) - 3*D1**2*Pk1*Pkd2*ct**6*(D1**2*(70*f**3*(30*fd*(4*s**2 - 2*s + 1) - 15*fdd*(4*s**2 - 2*s + 1) + s**2*(52*bd1 - 26*bdd1)) - 5*f**2*s*(286*bd1**2*s + 26*bd1*(28*fd*(3*s - 1) + s*(11*K - 11)) + 1260*fd**2*(2*s - 1) - s*(143*bdd1*(K - 1) + 572*gd2 - 286*gdd2)) + 286*f*(5*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 5*fdd*g2*(2*s**2 - 2*s + 1) + s**2*(6*bd1**2*(K - 1) + 12*bd1*(g2 - gd2) - 6*bdd1*g2)) - 572*fd*g2*s*(6*bd1 + 5*fd)*(s - 1)) + 2*D1*f*(Dd*(1050*f**3*(4*s**2 - 2*s + 1) - 70*f**2*(4*s - 1)*(26*bd1*s + 15*fd*(4*s - 1)) + 715*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 286*g2*(4*s - 1)*(6*bd1*s + 5*fd*(2*s - 1))) - 5*Ddd*f*(105*f**2 + 143*g2)*(4*s**2 - 2*s + 1)) - 60*Dd**2*f**2*s*(105*f**2 + 143*g2)*(2*s - 1) + 143*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) - 12*fd*(K - 1)*(s - 1)**2 + 6*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) - 6*f*(K - 1)*(4*s**2 - 2*s + 1) + 6*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-6*K + 5*f + 6)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-6*K + 5*f + 6)) + 13*b1*(D1**2*(10*f**2*(28*fd*(3*s**2 - 2*s + 1) - 14*fdd*(3*s**2 - 2*s + 1) + s**2*(22*bd1 - 11*bdd1)) + f*(-280*fd**2*s*(3*s - 2) - 110*fd*(K*(2*s**2 - 2*s + 1) + s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) + 55*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(132*K*bdd1 - 264*bd1*(K - 1) - 132*bdd1 + 264*gd2 - 132*gdd2)) + (22*s - 22)*(5*fd**2*s*(K - 1) + 12*fd*(g2*(s - 1) - s*(-K*bd1 + bd1 + gd2)) - 6*fdd*g2*(s - 1))) + D1*(2*Dd*(140*f**3*(4*s**2 - 2*s + 1) - 5*f**2*(11*K*(4*s**2 - 2*s + 1) + 28*fd*(12*s**2 - 7*s + 1) + 11*s**2*(8*bd1 - 4) - 11*s*(2*bd1 - 2) - 11) + 11*f*(5*fd*(K - 1)*(8*s**2 - 6*s + 1) + 12*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(12*K*bd1 - 12*bd1 - 12*gd2)) - 132*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(140*f**2 - 55*f*(K - 1) + 132*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(140*f**2 - 55*f*(K - 1) + 132*g2)))/(1001*d**2*k2) + 2*D1**2*Pk1*Pkd2*ct**6*k2**3*(11*D1*bd1*f*(D1*(2*f*s*(r - 1) + 5*fd*(4*r*s - r - 2*s + 1)) + 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) + 11*b1*(D1*Dd*f*(2*f*(4*r*s - r - s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(D1*r*(2*s - 1)*(2*f*fd + 5*f*fdd + 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 5*f*(2*D1*Dd*f*(5*f*(r*(4*s - 1) - s) + 3*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(10*f*fd*(r*(3*s - 1) - s) + f*(11*bdd1*s*(r - 1) + 6*fdd*r*(3*s - 1) - 6*fdd*s) + 6*fd**2*(r*(6*s - 2) - 2*s + 1)) + 6*Ddd*f**2*(r*(4*s - 1) - s)) + 6*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k1**2*k3**2) - 15*D1**2*Pk1*Pkd2*ct**5*f*st**2*(65*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(98*fd*(4*s**2 - 2*s + 1) - 49*fdd*(4*s**2 - 2*s + 1) + s**2*(130*bd1 - 65*bdd1)) + 2*fd*s*(-65*bd1*(3*s - 1) + 147*fd*(1 - 2*s))) + D1*f*(98*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(65*bd1*s + 49*fd*(4*s - 1)) - 49*Ddd*f*(4*s**2 - 2*s + 1)) + 294*Dd**2*f**2*s*(1 - 2*s)))/(286*d**2*k1) + 4*D1**2*Pk1*Pkd2*ct**5*k1**3*(33*b1*(D1**2*(f*(fd*(8*C - 26) + fdd*(25 - 10*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(25 - 10*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(8*C - 26)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(25 - 10*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(25 - 10*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(25 - 10*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(5*D1**2*(f*(fd*(46*C - 148)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (2*C - 5)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(140 - 56*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(8*C - 26)*(r + s - 1) - fd*(10*C - 25)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(25 - 10*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 10*D1*f*(Dd*(f*(23*C - 74)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(28*C - 70)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(70 - 28*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(140 - 56*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k3**4) - 5*D1**2*Pk1*Pkd2*ct**5*k1**3*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 2*D1*f*(28*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2**2*k3**2) + 2*D1**2*Pk1*Pkd2*ct**5*k1*k2**2*st**2*(33*b1*(D1**2*(f*(fd*(36*C - 46) + fdd*(25 - 20*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(25 - 20*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(36*C - 46)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(25 - 20*C)*(8*s - 3)*(2*r + 2*s - 1)) + Ddd*f*(25 - 20*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(25 - 20*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(868*C - 1118)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 25)*(33*bdd1*s*(r + s - 1) + 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(625 - 500*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(36*C - 46)*(r + s - 1) - fd*(20*C - 25)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(25 - 20*C)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(868*C - 1118)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(500*C - 625)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(625 - 500*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(625 - 500*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k3**4) + 4*D1**2*Pk1*Pkd2*ct**5*k1*k2**2*(22*b1**2*(D1**2*s*(r + s)*(fd*(29*C - 35) + fdd*(21 - 18*C)) + D1*(Dd*(f*(29*C - 35)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(18*C - 21)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(21 - 18*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(18*C - 21)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 11*b1*(-48*C*D1**2*f*fd*r*s + 72*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 72*C*D1**2*f*fd - 30*C*D1**2*f*fdd*r - 30*C*D1**2*f*fdd*s + 30*C*D1**2*f*fdd - 30*C*D1**2*fd**2*r - 30*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 72*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 - 120*C*D1*Dd*f*fd*r - 120*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd - 6*D1**2*bdd1*f*(6*C - 7)*(2*s - 1)*(r + s - 1) - 92*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 92*D1**2*f*fd*s**2 + 34*D1**2*f*fd*s + 12*D1**2*f*fd + 100*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r + 100*D1**2*f*fdd*s**2 - 65*D1**2*f*fdd*s + 15*D1**2*f*fdd + 100*D1**2*fd**2*r*s - 15*D1**2*fd**2*r + 100*D1**2*fd**2*s**2 - 65*D1**2*fd**2*s - 184*D1*Dd*f**2*r*s + 46*D1*Dd*f**2*r - 184*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 46*D1*Dd*f**2 + 800*D1*Dd*f*fd*r*s - 160*D1*Dd*f*fd*r + 800*D1*Dd*f*fd*s**2 - 560*D1*Dd*f*fd*s + 80*D1*Dd*f*fd + 200*D1*Ddd*f**2*r*s - 50*D1*Ddd*f**2*r + 200*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 50*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(29*C - 35)*(2*s - 1)*(r + s - 1) - fd*(18*C - 21)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(42 - 36*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 600*Dd**2*f**2*r*s - 150*Dd**2*f**2*r + 600*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 50*Dd**2*f**2) + f*(-66*D1**2*bd1**2*(6*C - 7)*(2*s - 1)*(r + s - 1) + 55*D1**2*bdd1*f*(6*C + 10*s - 7)*(r + s - 1) + 5*D1**2*(-f*(-56*C*fdd + fd*(134*C - 21) - 28*fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(56*C + 28)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 11*D1*bd1*(D1*(2*f*(r + s - 1)*(12*C*(s + 2) + 23*s - 29) - 5*fd*(6*C*s + r*(6*C + 40*s - 17) + 40*s**2 - 47*s + 10)) - 10*Dd*f*(6*C*(2*r + 2*s - 1) + 40*r*s - 19*r + 40*s**2 - 49*s + 12)) + 5*D1*f*(Dd*(-f*(134*C - 21)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(56*C + 28)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(56*C + 28)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(56*C + 28)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**5*k1*st**2*(40*C - 55)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(50*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**5*k1*(990*b1**2*(4*C - 5)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(-192*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r - 800*C*D1**2*f*fd*s**2 + 1200*C*D1**2*f*fd*s - 600*C*D1**2*f*fd + 96*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 496*C*D1**2*f*fdd*s**2 - 696*C*D1**2*f*fdd*s + 348*C*D1**2*f*fdd + 96*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 496*C*D1**2*fd**2*s**2 - 696*C*D1**2*fd**2*s - 384*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r - 1600*C*D1*Dd*f**2*s**2 + 896*C*D1*Dd*f**2*s - 400*C*D1*Dd*f**2 + 768*C*D1*Dd*f*fd*r*s - 288*C*D1*Dd*f*fd*r + 3968*C*D1*Dd*f*fd*s**2 - 3872*C*D1*Dd*f*fd*s + 744*C*D1*Dd*f*fd + 192*C*D1*Ddd*f**2*r*s - 48*C*D1*Ddd*f**2*r + 992*C*D1*Ddd*f**2*s**2 - 544*C*D1*Ddd*f**2*s + 248*C*D1*Ddd*f**2 + 576*C*Dd**2*f**2*r*s - 144*C*Dd**2*f**2*r + 2976*C*Dd**2*f**2*s**2 - 1632*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 - 30*D1**2*bdd1*f*(4*C - 5)*(2*s**2 - 2*s + 1) + 320*D1**2*f*fd*r*s - 160*D1**2*f*fd*r + 408*D1**2*f*fd*s**2 - 908*D1**2*f*fd*s + 454*D1**2*f*fd - 184*D1**2*f*fdd*r*s + 92*D1**2*f*fdd*r - 324*D1**2*f*fdd*s**2 + 574*D1**2*f*fdd*s - 287*D1**2*f*fdd - 184*D1**2*fd**2*r*s + 92*D1**2*fd**2*r - 324*D1**2*fd**2*s**2 + 574*D1**2*fd**2*s + 640*D1*Dd*f**2*r*s - 160*D1*Dd*f**2*r + 816*D1*Dd*f**2*s**2 - 568*D1*Dd*f**2*s + 204*D1*Dd*f**2 - 1472*D1*Dd*f*fd*r*s + 552*D1*Dd*f*fd*r - 2592*D1*Dd*f*fd*s**2 + 3128*D1*Dd*f*fd*s - 666*D1*Dd*f*fd - 368*D1*Ddd*f**2*r*s + 92*D1*Ddd*f**2*r - 648*D1*Ddd*f**2*s**2 + 416*D1*Ddd*f**2*s - 162*D1*Ddd*f**2 + 60*D1*bd1*(4*C - 5)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 1104*Dd**2*f**2*r*s + 276*Dd**2*f**2*r - 1944*Dd**2*f**2*s**2 + 1248*Dd**2*f**2*s - 92*Dd**2*f**2) + f*(-1980*D1**2*bd1**2*s*(4*C - 5)*(s - 1) + 33*D1**2*bdd1*f*(4*C*(62*s**2 + s*(12*r + 38) - 25) - 162*s**2 - s*(92*r + 158) + 125) - 5*D1**2*(f*(2*fd*(4*C*(76*r*(3*s - 1) + 1251*s**2 - 910*s + 417) - 522*r*(3*s - 1) - 3765*s**2 + 3032*s - 1255) + fdd*(-4*C*(76*r*(3*s - 1) + 1449*s**2 - 1042*s + 483) + 588*r*(3*s - 1) + 4755*s**2 - 3758*s + 1585)) + 2*fd**2*(-4*C*(76*r*(3*s - 1) + 1449*s**2 - 1042*s + 38) + 588*r*(3*s - 1) + 4755*s**2 - 3758*s + 294)) - 66*D1*bd1*(D1*(f*(4*C*(50*s**2 + s*(12*r + 38) - 25) - 102*s**2 - s*(80*r + 170) + 125) + fd*(-4*C*(6*r*(4*s - 1) + 124*s**2 - 49*s + 6) + 46*r*(4*s - 1) + 324*s**2 - 129*s + 46)) + Dd*f*(-4*C*(6*r*(8*s - 1) + 248*s**2 + 8*s - 19) + 46*r*(8*s - 1) + 648*s**2 + 108*s - 79)) - 5*D1*f*(2*Dd*(f*(4*C*(76*r*(4*s - 1) + 1668*s**2 - 910*s + 417) - 522*r*(4*s - 1) - 5020*s**2 + 3032*s - 1255) + fd*(-4*C*(38*r*(24*s - 7) + 5796*s**2 - 3647*s + 559) + 294*r*(24*s - 7) + 19020*s**2 - 13153*s + 2173)) + Ddd*f*(-4*C*(76*r*(4*s - 1) + 1932*s**2 - 1042*s + 483) + 588*r*(4*s - 1) + 6340*s**2 - 3758*s + 1585)) + 10*Dd**2*f**2*(4*C*(114*r*(4*s - 1) + 2898*s**2 - 1563*s + 38) - 882*r*(4*s - 1) - 9510*s**2 + 5637*s - 294)))/(693*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**5*k1*(-429*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 12*fd*(s - 1)**2 - 6*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 6*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 6)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 6)*(2*s - 1)) - 13*b1*(D1**2*(10*f**2*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + f*(-560*fd**2*s*(3*s - 2) - 330*fd*(s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) - 165*fdd*(2*s**2 - 2*s + 1) + 33*s**2*(24*bd1 - 12*bdd1)) - 66*fd*s*(12*bd1 + 5*fd)*(s - 1)) + D1*f*(2*Dd*(280*f**2*(4*s**2 - 2*s + 1) - 5*f*(56*fd*(12*s**2 - 7*s + 1) + 33*s**2*(8*bd1 - 4) - 33*s*(2*bd1 - 2) - 33) - (132*s - 33)*(12*bd1*s + 5*fd*(2*s - 1))) - 5*Ddd*f*(56*f + 33)*(4*s**2 - 2*s + 1)) - 30*Dd**2*f**2*s*(56*f + 33)*(2*s - 1)) + f*(D1**2*(858*bd1*s*(6*bd1*s + 5*fd*(2*s - 1)) - 35*f**2*(90*fd*(4*s**2 - 2*s + 1) - 45*fdd*(4*s**2 - 2*s + 1) + s**2*(208*bd1 - 104*bdd1)) + 5*f*s*(858*bd1**2*s + 26*bd1*(56*fd*(3*s - 1) - 33*s) + 429*bdd1*s + 1890*fd**2*(2*s - 1))) - 5*D1*f*(2*Dd*(429*bd1*s*(1 - 4*s) + 315*f**2*(4*s**2 - 2*s + 1) - 7*f*(4*s - 1)*(104*bd1*s + 45*fd*(4*s - 1))) - 315*Ddd*f**2*(4*s**2 - 2*s + 1)) + 9450*Dd**2*f**3*s*(2*s - 1)))/(1001*d**2*k2**2) - 10*D1**2*Pk1*Pkd2*ct**5*k2**4*st**2*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 50*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + 25*D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) - 25*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k1*k3**4) - 4*D1**2*Pk1*Pkd2*ct**5*k2**4*(D1*f*(-6*D1*bd1**2*(2*s - 1)*(r + s - 1) + bd1*(D1*(2*f*(2*s - 5)*(r + s - 1) - 5*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) - 5*f*(D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1))) + 6*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(-6*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + 8*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - 6*D1**2*f*fd - 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*s**2 + 5*D1**2*f*fdd*s - 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*s**2 + 5*D1**2*fd**2*s + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r*s + 10*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 50*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 20*D1*Ddd*f**2*r*s + 5*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 15*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + 6*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 60*Dd**2*f**2*r*s + 15*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 45*Dd**2*f**2*s - 5*Dd**2*f**2))/(21*d**2*k1*k3**4) + D1**2*Pk1*Pkd2*ct**5*k2**2*st**2*(-33*b1*(D1**2*(f*(2*fd*(r*(64*C - 64)*(2*s - 1) + 150*s**2 - 150*s + 75) - 5*fdd*(r*(8*C - 8)*(2*s - 1) + 30*s**2 - 30*s + 15)) - 10*fd**2*(r*(4*C - 4)*(2*s - 1) + s*(15*s - 15))) + D1*f*(2*Dd*(f*(-64*C*s + r*(64*C - 64)*(4*s - 1) + 300*s**2 - 86*s + 75) - 5*fd*(4*C*(16*r*s - 6*r - 2*s + 1) - 64*r*s + 24*r + 120*s**2 - 82*s + 11)) - 5*Ddd*f*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 60*s**2 - 22*s + 15)) - 10*Dd**2*f**2*(4*C*(3*r*(4*s - 1) - 3*s + 1) + r*(12 - 48*s) + 90*s**2 - 33*s - 4)) + f*(D1**2*(f*(165*bdd1*s*(8*C*(r - 1) - 8*r + 15*s + 8) - 2*fd*(r*(1904*C - 1904)*(3*s - 1) + 5625*s**2 - s*(1904*C + 1846) + 1875) + 5*fdd*(-328*C*s + r*(328*C - 328)*(3*s - 1) + 1125*s**2 - 422*s + 375)) + 10*fd**2*(164*C*(r*(6*s - 2) - 2*s + 1) - 328*r*(3*s - 1) + 1125*s**2 - 422*s - 164)) - 66*D1*bd1*(D1*(f*s*(64*C*(r - 1) - 64*r + 75*s + 64) - 5*fd*(4*C*(4*r*s - r - 2*s + 1) - 16*r*s + 4*r + 30*s**2 - 7*s - 4)) - 5*Dd*f*(4*C*(8*r*s - r - 5*s + 1) - 32*r*s + 4*r + 60*s**2 + 5*s - 4)) + D1*f*(-2*Dd*(f*(r*(1904*C - 1904)*(4*s - 1) + 7500*s**2 - s*(1904*C + 1846) + 1875) - 5*fd*(164*C*(r*(24*s - 7) - 7*s + 2) - 164*r*(24*s - 7) + 4500*s**2 - 1477*s + 47)) + 5*Ddd*f*(r*(328*C - 328)*(4*s - 1) + 1500*s**2 - s*(328*C + 422) + 375)) + 10*Dd**2*f**2*(164*C*(3*r*(4*s - 1) - 3*s + 1) - 492*r*(4*s - 1) + 2250*s**2 - 633*s - 164)))/(1386*d**2*k1*k3**2) - D1**2*Pk1*Pkd2*ct**5*k2**2*(66*b1**2*(D1**2*s*(fd*r*(28*C - 28) + 6*fd*s - 3*fdd*s) + D1*(2*Dd*f*(r*(14*C - 14)*(4*s - 1) + 12*s**2 + s*(8 - 14*C) + 3) + 6*Dd*fd*s*(1 - 4*s) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f*s*(1 - 2*s)) + 33*b1*(32*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 64*C*D1**2*f*fd*s - 16*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*s - 16*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*s + 64*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*r - 16*C*D1*Dd*f**2*s - 128*C*D1*Dd*f*fd*r*s + 16*C*D1*Dd*f*fd*r + 48*C*D1*Dd*f*fd*s - 8*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r*s + 8*C*D1*Ddd*f**2*r + 8*C*D1*Ddd*f**2*s - 96*C*Dd**2*f**2*r*s + 24*C*Dd**2*f**2*r + 24*C*Dd**2*f**2*s - 8*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 96*D1**2*f*fd*r*s - 16*D1**2*f*fd*r - 140*D1**2*f*fd*s**2 + 224*D1**2*f*fd*s - 80*D1**2*f*fd + 24*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 118*D1**2*f*fdd*s**2 - 136*D1**2*f*fdd*s + 64*D1**2*f*fdd + 24*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 118*D1**2*fd**2*s**2 - 136*D1**2*fd**2*s - 192*D1*Dd*f**2*r*s + 48*D1*Dd*f**2*r - 280*D1*Dd*f**2*s**2 + 188*D1*Dd*f**2*s - 70*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s - 40*D1*Dd*f*fd*r + 944*D1*Dd*f*fd*s**2 - 804*D1*Dd*f*fd*s + 140*D1*Dd*f*fd + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 236*D1*Ddd*f**2*s**2 - 130*D1*Ddd*f**2*s + 59*D1*Ddd*f**2 + 4*D1*bd1*(D1*f*(-14*C*s + r*(14*C - 14)*(2*s - 1) + 6*s**2 + 8*s + 3) + 3*D1*fd*s*(1 - 2*s) - 3*Dd*f*(8*s**2 - 6*s + 1)) + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 708*Dd**2*f**2*s**2 - 390*Dd**2*f**2*s + 12*Dd**2*f**2) + f*(-396*D1**2*bd1**2*s*(s - 1) - 33*D1**2*bdd1*f*(4*r*(2*C*(s - 1) - 3*s + 2) - 59*s**2 - 6*s + 5) - 5*D1**2*(f*(2*fd*(r*(172*C - 6)*(3*s - 1) + 663*s**2 - s*(172*C + 436) + 221) + fdd*(-r*(40*C + 60)*(3*s - 1) - 1059*s**2 + s*(40*C + 766) - 353)) - 2*fd**2*(20*C*(r*(6*s - 2) - 2*s + 1) + 60*r*(3*s - 1) + 1059*s**2 - 766*s + 30)) + 66*D1*bd1*(D1*(f*(8*r*(C*(s - 4) - 3*s + 4) - 35*s**2 + s*(24*C - 18) + 5) + 2*fd*(C*(-8*r*s + 4*r + 2*s - 2) + r*(12*s - 5) + 59*s**2 - 31*s + 3)) + Dd*f*(-4*C*(r*(8*s - 5) - s + 1) + r*(48*s - 22) + 236*s**2 - 53*s + 1)) - 5*D1*f*(2*Dd*(f*(r*(172*C - 6)*(4*s - 1) + 884*s**2 - s*(172*C + 436) + 221) + fd*(-20*C*(r*(24*s - 7) - 7*s + 2) - 30*r*(24*s - 7) - 4236*s**2 + 2681*s - 413)) + Ddd*f*(-r*(40*C + 60)*(4*s - 1) - 1412*s**2 + s*(40*C + 766) - 353)) + 10*Dd**2*f**2*(20*C*(3*r*(4*s - 1) - 3*s + 1) + 90*r*(4*s - 1) + 2118*s**2 - 1149*s + 30)))/(693*d**2*k1*k3**2) - D1**2*Pk1*Pkd2*ct**5*(-1716*D1**2*K*bdd1*f**2*r*s - 4290*D1**2*bd1**2*f*s*(5*f*(2*s - 1) + 6*s) + 3900*D1**2*bdd1*f**3*r*s + 5395*D1**2*bdd1*f**3*s**2 + 15600*D1**2*bdd1*f**3*s - 9100*D1**2*bdd1*f**3 + 1716*D1**2*bdd1*f**2*r*s - 10725*D1**2*bdd1*f**2*s**2 - 31360*D1**2*f**3*fd*r*s + 7840*D1**2*f**3*fd*r - 131040*D1**2*f**3*fd*s**2 + 73360*D1**2*f**3*fd*s - 32760*D1**2*f**3*fd + 15680*D1**2*f**3*fdd*r*s - 3920*D1**2*f**3*fdd*r + 80080*D1**2*f**3*fdd*s**2 - 43960*D1**2*f**3*fdd*s + 20020*D1**2*f**3*fdd + 47040*D1**2*f**2*fd**2*r*s - 11760*D1**2*f**2*fd**2*r + 240240*D1**2*f**2*fd**2*s**2 - 131880*D1**2*f**2*fd**2*s + 3920*D1**2*f**2*fd**2 - 27456*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gdd2*r*s - 54912*D1**2*f*fd*g2*r*s + 27456*D1**2*f*fd*g2*r + 27456*D1**2*f*fd*g2*s + 13728*D1**2*f*fd*gd2*r*s - 3432*D1**2*f*fd*gd2*r - 3432*D1**2*f*fd*gd2*s + 6864*D1**2*f*fdd*g2*r*s - 3432*D1**2*f*fdd*g2*r - 3432*D1**2*f*fdd*g2*s + 6864*D1**2*fd**2*g2*r*s - 3432*D1**2*fd**2*g2*r - 3432*D1**2*fd**2*g2*s + 3432*D1**2*fd**2*g2 - 31360*D1*Dd*f**4*r*s + 7840*D1*Dd*f**4*r - 131040*D1*Dd*f**4*s**2 + 73360*D1*Dd*f**4*s - 32760*D1*Dd*f**4 + 125440*D1*Dd*f**3*fd*r*s - 31360*D1*Dd*f**3*fd*r + 640640*D1*Dd*f**3*fd*s**2 - 351680*D1*Dd*f**3*fd*s + 47880*D1*Dd*f**3*fd - 109824*D1*Dd*f**2*g2*r*s + 27456*D1*Dd*f**2*g2*r + 27456*D1*Dd*f**2*g2*s + 27456*D1*Dd*f**2*gd2*r*s - 3432*D1*Dd*f**2*gd2*r - 3432*D1*Dd*f**2*gd2*s + 54912*D1*Dd*f*fd*g2*r*s - 20592*D1*Dd*f*fd*g2*r - 20592*D1*Dd*f*fd*g2*s + 6864*D1*Dd*f*fd*g2 + 15680*D1*Ddd*f**4*r*s - 3920*D1*Ddd*f**4*r + 80080*D1*Ddd*f**4*s**2 - 43960*D1*Ddd*f**4*s + 20020*D1*Ddd*f**4 + 13728*D1*Ddd*f**2*g2*r*s - 3432*D1*Ddd*f**2*g2*r - 3432*D1*Ddd*f**2*g2*s - 26*D1*bd1*f*(5*D1*f**2*(17*s**2 + s*(60*r + 240) - 140) - D1*f*(5*fd*(30*r*(6*s - 1) + 249*s**2 + 127*s + 20) + 33*s*(r*(16*K - 16) + 25*s)) + 33*D1*(2*fd*r*(K - 1)*(4*s - 1) + fd*s*(-2*K + 50*s - 23) + 28*g2*s*(r - 1)) - 5*Dd*f**2*(30*r*(8*s - 1) + 332*s**2 + 367*s - 120) + 33*Dd*f*(r*(2*K - 2)*(8*s - 1) + s*(-2*K + 100*s - 23))) + 47040*Dd**2*f**4*r*s - 11760*Dd**2*f**4*r + 240240*Dd**2*f**4*s**2 - 131880*Dd**2*f**4*s + 3920*Dd**2*f**4 + 41184*Dd**2*f**2*g2*r*s - 10296*Dd**2*f**2*g2*r - 10296*Dd**2*f**2*g2*s + 3432*Dd**2*f**2*g2 + 429*b1**2*(D1**2*(50*f*fd*(4*s**2 - 2*s + 1) - 50*fd**2*s*(2*s - 1) + 4*fd*(s - 1)*(r*(7*K - 7) + 15*s - 15) - 5*fdd*(5*f*(4*s**2 - 2*s + 1) + 6*(s - 1)**2)) + 2*D1*(Dd*(50*f**2*(4*s**2 - 2*s + 1) - 25*f*fd*(1 - 4*s)**2 + 2*f*(-7*K*s + r*(7*K - 7)*(4*s - 1) + 60*s**2 - 23*s + 15) - 30*fd*(4*s**2 - 5*s + 1)) - 5*Ddd*f*(5*f + 3)*(4*s**2 - 2*s + 1)) - 60*Dd**2*f*s*(5*f + 3)*(2*s - 1)) + 13*b1*(2112*D1**2*K*f*fd*r*s - 1056*D1**2*K*f*fd*r - 1056*D1**2*K*f*fd*s - 264*D1**2*K*f*fdd*r*s + 132*D1**2*K*f*fdd*r + 132*D1**2*K*f*fdd*s - 264*D1**2*K*fd**2*r*s + 132*D1**2*K*fd**2*r + 132*D1**2*K*fd**2*s - 132*D1**2*K*fd**2 - 165*D1**2*bdd1*f*(5*f*(4*s**2 - 2*s + 1) + 12*s**2) - 1800*D1**2*f**2*fd*r*s + 600*D1**2*f**2*fd*r - 510*D1**2*f**2*fd*s**2 + 3340*D1**2*f**2*fd*s - 1570*D1**2*f**2*fd + 900*D1**2*f**2*fdd*r*s - 300*D1**2*f**2*fdd*r + 1245*D1**2*f**2*fdd*s**2 - 2330*D1**2*f**2*fdd*s + 1115*D1**2*f**2*fdd + 1800*D1**2*f*fd**2*r*s - 600*D1**2*f*fd**2*r + 2490*D1**2*f*fd**2*s**2 - 4660*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 2112*D1**2*f*fd*r*s + 1056*D1**2*f*fd*r + 3300*D1**2*f*fd*s**2 - 2244*D1**2*f*fd*s + 1650*D1**2*f*fd + 264*D1**2*f*fdd*r*s - 132*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1518*D1**2*f*fdd*s - 825*D1**2*f*fdd - 1848*D1**2*f*gd2*r*s + 264*D1**2*fd**2*r*s - 132*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1518*D1**2*fd**2*s + 132*D1**2*fd**2 - 1848*D1**2*fd*g2*r*s + 1848*D1**2*fd*g2*r + 4224*D1*Dd*K*f**2*r*s - 1056*D1*Dd*K*f**2*r - 1056*D1*Dd*K*f**2*s - 2112*D1*Dd*K*f*fd*r*s + 792*D1*Dd*K*f*fd*r + 792*D1*Dd*K*f*fd*s - 264*D1*Dd*K*f*fd - 2400*D1*Dd*f**3*r*s + 600*D1*Dd*f**3*r - 680*D1*Dd*f**3*s**2 + 940*D1*Dd*f**3*s - 170*D1*Dd*f**3 + 7200*D1*Dd*f**2*fd*r*s - 2100*D1*Dd*f**2*fd*r + 9960*D1*Dd*f**2*fd*s**2 - 12710*D1*Dd*f**2*fd*s + 2630*D1*Dd*f**2*fd - 4224*D1*Dd*f**2*r*s + 1056*D1*Dd*f**2*r + 6600*D1*Dd*f**2*s**2 - 2244*D1*Dd*f**2*s + 1650*D1*Dd*f**2 + 2112*D1*Dd*f*fd*r*s - 792*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 9108*D1*Dd*f*fd*s - 1386*D1*Dd*f*fd - 7392*D1*Dd*f*g2*r*s + 1848*D1*Dd*f*g2*r + 1848*D1*Dd*f*g2*s - 528*D1*Ddd*K*f**2*r*s + 132*D1*Ddd*K*f**2*r + 132*D1*Ddd*K*f**2*s + 1200*D1*Ddd*f**3*r*s - 300*D1*Ddd*f**3*r + 1660*D1*Ddd*f**3*s**2 - 1130*D1*Ddd*f**3*s + 415*D1*Ddd*f**3 + 528*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 1518*D1*Ddd*f**2*s - 825*D1*Ddd*f**2 + 66*D1*bd1*(D1*(25*f**2*(4*s**2 - 2*s + 1) - 2*f*s*(-14*K*r + 7*K + 50*fd*(2*s - 1) + 14*r - 30*s - 7) - 60*fd*s*(s - 1)) - 5*Dd*f*(4*s - 1)*(5*f*(4*s - 1) + 12*s)) - 1584*Dd**2*K*f**2*r*s + 396*Dd**2*K*f**2*r + 396*Dd**2*K*f**2*s - 132*Dd**2*K*f**2 + 3600*Dd**2*f**3*r*s - 900*Dd**2*f**3*r + 4980*Dd**2*f**3*s**2 - 3390*Dd**2*f**3*s + 300*Dd**2*f**3 + 1584*Dd**2*f**2*r*s - 396*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 4554*Dd**2*f**2*s + 132*Dd**2*f**2))/(9009*d**2*k1) + D1**2*Pk1*Pkd2*ct**4*f*k2**3*st**4*(40*C - 40)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1))/(77*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**4*f*k2*st**4*(90*C - 90)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k3**2) - 5*D1**2*Pk1*Pkd2*ct**4*f*k2*st**2*(39*D1*bd1*f*(D1*(23*f*s*(r - 1) - 17*fd*(6*r*s - r - 3*s + 1)) - 17*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 39*b1*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 17*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(23*f*fd - 17*f*fdd - 34*fd**2) + 17*Ddd*f**2*(4*r*s - r - s)) + 17*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(5*D1*Dd*f*(71*f*(4*r*s - r - s) - 6*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(355*f*fd*(r*(4*s - 1) - s) + 3*f*(-221*bdd1*s*(r - 1) + 5*fdd*(-4*r*s + r + s)) - 15*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 15*Ddd*f**2*(-4*r*s + r + s)) - 15*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k1**2) - 4*D1**2*Pk1*Pkd2*ct**4*k1**4*(33*b1*(D1**2*(f*(4*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(4*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 5*fd*(8*s - 3)*(2*r + 2*s - 1)) - 5*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 5*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(-5*D1**2*(f*(33*bdd1*s*(r + s - 1) - 23*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(4*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) - 5*D1*f*(Dd*(-23*f*(4*r*s - r + 4*s**2 - 3*s + 1) + 28*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) + 28*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 140*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k2*k3**4) + 4*D1**2*Pk1*Pkd2*ct**4*k1**2*k2*st**2*(33*b1*(D1**2*(f*(fd*(10*C - 19) + fdd*(11 - 6*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - fd**2*(6*C - 11)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(10*C - 19)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C - 11)*(8*s - 3)*(2*r + 2*s - 1)) - Ddd*f*(6*C - 11)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f**2*(6*C - 11)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(fd*(234*C - 451)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (6*C - 11)*(33*bdd1*s*(r + s - 1) + 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(275 - 150*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(10*C - 19)*(r + s - 1) - fd*(6*C - 11)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(6*C - 11)*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(234*C - 451)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(150*C - 275)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(275 - 150*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + Dd**2*f**2*(275 - 150*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k3**4) + 4*D1**2*Pk1*Pkd2*ct**4*k1**2*k2*(33*b1**2*(D1**2*s*(r + s)*(fd*(44*C - 73) + fdd*(54 - 36*C)) + D1*(Dd*(f*(44*C - 73)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(36*C - 54)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(54 - 36*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(36*C - 54)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 33*b1*(-24*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 24*C*D1**2*f*fd*s**2 + 60*C*D1**2*f*fd*s - 48*C*D1**2*f*fd - 30*C*D1**2*f*fdd*r - 30*C*D1**2*f*fdd*s + 30*C*D1**2*f*fdd - 30*C*D1**2*fd**2*r - 30*C*D1**2*fd**2*s - 48*C*D1*Dd*f**2*r*s + 12*C*D1*Dd*f**2*r - 48*C*D1*Dd*f**2*s**2 + 36*C*D1*Dd*f**2*s - 12*C*D1*Dd*f**2 - 120*C*D1*Dd*f*fd*r - 120*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd - 18*D1**2*bdd1*f*(2*C - 3)*(2*s - 1)*(r + s - 1) - 80*D1**2*f*fd*r*s - 20*D1**2*f*fd*r - 80*D1**2*f*fd*s**2 + 20*D1**2*f*fd*s + 20*D1**2*f*fd + 100*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r + 100*D1**2*f*fdd*s**2 - 55*D1**2*f*fdd*s + 5*D1**2*f*fdd + 100*D1**2*fd**2*r*s - 5*D1**2*fd**2*r + 100*D1**2*fd**2*s**2 - 55*D1**2*fd**2*s - 160*D1*Dd*f**2*r*s + 40*D1*Dd*f**2*r - 160*D1*Dd*f**2*s**2 + 120*D1*Dd*f**2*s - 40*D1*Dd*f**2 + 800*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 800*D1*Dd*f*fd*s**2 - 520*D1*Dd*f*fd*s + 60*D1*Dd*f*fd + 200*D1*Ddd*f**2*r*s - 50*D1*Ddd*f**2*r + 200*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 50*D1*Ddd*f**2 + D1*bd1*(D1*(f*(44*C - 73)*(2*s - 1)*(r + s - 1) - fd*(36*C - 54)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(108 - 72*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 600*Dd**2*f**2*r*s - 150*Dd**2*f**2*r + 600*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 50*Dd**2*f**2) + f*(-594*D1**2*bd1**2*(2*C - 3)*(2*s - 1)*(r + s - 1) + 165*D1**2*bdd1*f*(6*C + 10*s - 9)*(r + s - 1) + 5*D1**2*(-f*(-168*C*fdd + fd*(270*C - 109) - 28*fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(168*C + 28)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 33*D1*bd1*(D1*(4*f*(r + s - 1)*(3*C*(s + 3) + 10*s - 15) - 5*fd*(6*C*s + r*(6*C + 40*s - 19) + 40*s**2 - 49*s + 10)) - 10*Dd*f*(6*C*(2*r + 2*s - 1) + 40*r*s - 23*r + 40*s**2 - 53*s + 14)) + 5*D1*f*(Dd*(-f*(270*C - 109)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(168*C + 28)*(r*(24*s - 7) + 24*s**2 - 21*s + 4)) + Ddd*f*(168*C + 28)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 5*Dd**2*f**2*(168*C + 28)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(693*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**4*k1**2*st**2*(6*C - 16)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(50*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2*k3**2) + 2*D1**2*Pk1*Pkd2*ct**4*k1**2*(990*b1**2*(C - 2)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(-176*C*D1**2*f*fd*s**2 + 276*C*D1**2*f*fd*s - 138*C*D1**2*f*fd + 100*C*D1**2*f*fdd*s**2 - 150*C*D1**2*f*fdd*s + 75*C*D1**2*f*fdd + 100*C*D1**2*fd**2*s**2 - 150*C*D1**2*fd**2*s - 352*C*D1*Dd*f**2*s**2 + 176*C*D1*Dd*f**2*s - 88*C*D1*Dd*f**2 + 800*C*D1*Dd*f*fd*s**2 - 800*C*D1*Dd*f*fd*s + 150*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*s**2 - 100*C*D1*Ddd*f**2*s + 50*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*s**2 - 300*C*Dd**2*f**2*s - 30*D1**2*bdd1*f*(C - 2)*(2*s**2 - 2*s + 1) + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 160*D1**2*f*fd*s**2 - 360*D1**2*f*fd*s + 180*D1**2*f*fd - 34*D1**2*f*fdd*r*s + 17*D1**2*f*fdd*r - 104*D1**2*f*fdd*s**2 + 204*D1**2*f*fdd*s - 102*D1**2*f*fdd - 34*D1**2*fd**2*r*s + 17*D1**2*fd**2*r - 104*D1**2*fd**2*s**2 + 204*D1**2*fd**2*s + 88*D1*Dd*f**2*r*s - 22*D1*Dd*f**2*r + 320*D1*Dd*f**2*s**2 - 182*D1*Dd*f**2*s + 80*D1*Dd*f**2 - 272*D1*Dd*f*fd*r*s + 102*D1*Dd*f*fd*r - 832*D1*Dd*f*fd*s**2 + 1058*D1*Dd*f*fd*s - 221*D1*Dd*f*fd - 68*D1*Ddd*f**2*r*s + 17*D1*Ddd*f**2*r - 208*D1*Ddd*f**2*s**2 + 121*D1*Ddd*f**2*s - 52*D1*Ddd*f**2 + 60*D1*bd1*(C - 2)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 204*Dd**2*f**2*r*s + 51*Dd**2*f**2*r - 624*Dd**2*f**2*s**2 + 363*Dd**2*f**2*s - 17*Dd**2*f**2) - f*(1980*D1**2*bd1**2*s*(C - 2)*(s - 1) + 33*D1**2*bdd1*f*(-25*C*(2*s**2 + 2*s - 1) + 52*s**2 + s*(17*r + 83) - 50) + 5*D1**2*(f*(2*fd*(384*C*(3*s**2 - 2*s + 1) - 213*r*s + 71*r - 1494*s**2 + 1067*s - 498) + fdd*(-417*C*(3*s**2 - 2*s + 1) + 312*r*s - 104*r + 1692*s**2 - 1232*s + 564)) + 2*fd**2*(104*r*(3*s - 1) - s**2*(1251*C - 1692) + s*(834*C - 1232) + 52)) + 33*D1*bd1*(D1*(2*f*(C*(44*s**2 + 50*s - 25) - 40*s**2 - s*(11*r + 89) + 50) + fd*(17*r*(4*s - 1) - s**2*(200*C - 208) + s*(50*C - 38) + 17)) + Dd*f*(-50*C*(8*s**2 + 2*s - 1) + 17*r*(8*s - 1) + 416*s**2 + 211*s - 83)) + 5*D1*f*(2*Dd*(f*(384*C*(4*s**2 - 2*s + 1) - 284*r*s + 71*r - 1992*s**2 + 1067*s - 498) + fd*(-417*C*(12*s**2 - 7*s + 1) + 52*r*(24*s - 7) + 6768*s**2 - 4312*s + 668)) + Ddd*f*(-417*C*(4*s**2 - 2*s + 1) + 104*r*(4*s - 1) + 2256*s**2 - 1232*s + 564)) + 10*Dd**2*f**2*(156*r*(4*s - 1) + s**2*(3384 - 2502*C) + s*(1251*C - 1848) + 52)))/(693*d**2*k2*k3**2) + 4*D1**2*Pk1*Pkd2*ct**4*k2**3*st**2*(66*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 33*b1*(-16*C*D1**2*f*fd*r*s + 12*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 20*C*D1**2*f*fd*s - 12*C*D1**2*f*fd + 6*C*D1**2*f*fdd*r*s - 5*C*D1**2*f*fdd*r + 6*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s + 5*C*D1**2*f*fdd + 6*C*D1**2*fd**2*r*s - 5*C*D1**2*fd**2*r + 6*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s - 32*C*D1*Dd*f**2*r*s + 8*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 24*C*D1*Dd*f**2*s - 8*C*D1*Dd*f**2 + 48*C*D1*Dd*f*fd*r*s - 26*C*D1*Dd*f*fd*r + 48*C*D1*Dd*f*fd*s**2 - 50*C*D1*Dd*f*fd*s + 13*C*D1*Dd*f*fd + 12*C*D1*Ddd*f**2*r*s - 3*C*D1*Ddd*f**2*r + 12*C*D1*Ddd*f**2*s**2 - 9*C*D1*Ddd*f**2*s + 3*C*D1*Ddd*f**2 + 36*C*Dd**2*f**2*r*s - 9*C*Dd**2*f**2*r + 36*C*Dd**2*f**2*s**2 - 27*C*Dd**2*f**2*s + 3*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(C - 1)*(2*s - 1)*(r + s - 1) - 22*D1**2*f*fd*r*s + 7*D1**2*f*fd*r - 22*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s - 7*D1**2*f*fd + 14*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r + 14*D1**2*f*fdd*s**2 - 12*D1**2*f*fdd*s + 5*D1**2*f*fdd + 14*D1**2*fd**2*r*s - 5*D1**2*fd**2*r + 14*D1**2*fd**2*s**2 - 12*D1**2*fd**2*s - 44*D1*Dd*f**2*r*s + 11*D1*Dd*f**2*r - 44*D1*Dd*f**2*s**2 + 33*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 112*D1*Dd*f*fd*r*s - 34*D1*Dd*f*fd*r + 112*D1*Dd*f*fd*s**2 - 90*D1*Dd*f*fd*s + 17*D1*Dd*f*fd + 28*D1*Ddd*f**2*r*s - 7*D1*Ddd*f**2*r + 28*D1*Ddd*f**2*s**2 - 21*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 + 2*D1*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 84*Dd**2*f**2*r*s - 21*Dd**2*f**2*r + 84*Dd**2*f**2*s**2 - 63*Dd**2*f**2*s + 7*Dd**2*f**2) + f*(-948*C*D1**2*f*fd*r*s + 316*C*D1**2*f*fd*r - 948*C*D1**2*f*fd*s**2 + 948*C*D1**2*f*fd*s - 316*C*D1**2*f*fd + 375*C*D1**2*f*fdd*r*s - 125*C*D1**2*f*fdd*r + 375*C*D1**2*f*fdd*s**2 - 375*C*D1**2*f*fdd*s + 125*C*D1**2*f*fdd + 750*C*D1**2*fd**2*r*s - 250*C*D1**2*fd**2*r + 750*C*D1**2*fd**2*s**2 - 750*C*D1**2*fd**2*s + 125*C*D1**2*fd**2 - 1264*C*D1*Dd*f**2*r*s + 316*C*D1*Dd*f**2*r - 1264*C*D1*Dd*f**2*s**2 + 948*C*D1*Dd*f**2*s - 316*C*D1*Dd*f**2 + 3000*C*D1*Dd*f*fd*r*s - 875*C*D1*Dd*f*fd*r + 3000*C*D1*Dd*f*fd*s**2 - 2625*C*D1*Dd*f*fd*s + 500*C*D1*Dd*f*fd + 500*C*D1*Ddd*f**2*r*s - 125*C*D1*Ddd*f**2*r + 500*C*D1*Ddd*f**2*s**2 - 375*C*D1*Ddd*f**2*s + 125*C*D1*Ddd*f**2 + 1500*C*Dd**2*f**2*r*s - 375*C*Dd**2*f**2*r + 1500*C*Dd**2*f**2*s**2 - 1125*C*Dd**2*f**2*s + 125*C*Dd**2*f**2 - 66*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(3*C*s + 2*C + 7*s - 2) - 453*D1**2*f*fd*r*s + 151*D1**2*f*fd*r - 453*D1**2*f*fd*s**2 + 453*D1**2*f*fd*s - 151*D1**2*f*fd + 375*D1**2*f*fdd*r*s - 125*D1**2*f*fdd*r + 375*D1**2*f*fdd*s**2 - 375*D1**2*f*fdd*s + 125*D1**2*f*fdd + 750*D1**2*fd**2*r*s - 250*D1**2*fd**2*r + 750*D1**2*fd**2*s**2 - 750*D1**2*fd**2*s + 125*D1**2*fd**2 - 604*D1*Dd*f**2*r*s + 151*D1*Dd*f**2*r - 604*D1*Dd*f**2*s**2 + 453*D1*Dd*f**2*s - 151*D1*Dd*f**2 + 3000*D1*Dd*f*fd*r*s - 875*D1*Dd*f*fd*r + 3000*D1*Dd*f*fd*s**2 - 2625*D1*Dd*f*fd*s + 500*D1*Dd*f*fd + 500*D1*Ddd*f**2*r*s - 125*D1*Ddd*f**2*r + 500*D1*Ddd*f**2*s**2 - 375*D1*Ddd*f**2*s + 125*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(r + s - 1)*(C*(8*s + 4) + 11*s - 4) + fd*(C*(-12*r*s + r - 12*s**2 + 10*s - 3) - 28*r*s + 9*r - 28*s**2 + 30*s - 7)) + Dd*f*(C*(-24*r*s - 5*r - 24*s**2 + 13*s + 1) - 56*r*s + 15*r - 56*s**2 + 57*s - 11)) + 1500*Dd**2*f**2*r*s - 375*Dd**2*f**2*r + 1500*Dd**2*f**2*s**2 - 1125*Dd**2*f**2*s + 125*Dd**2*f**2))/(231*d**2*k3**4) - 4*D1**2*Pk1*Pkd2*ct**4*k2**3*(D1*f*(-6*D1*bd1**2*(2*C + 3)*(2*s - 1)*(r + s - 1) + bd1*(D1*(4*f*(C*(5*s - 8) - 3)*(r + s - 1) + fd*(-10*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(-10*C - 15)*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) - 5*f*(D1*bdd1*(2*C + 3)*(s - 1)*(r + s - 1) + (2*C + 2)*(D1*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))) + b1**2*(D1**2*s*(r + s)*(fd*(38*C + 15) - fdd*(12*C + 18)) + D1*(Dd*(f*(38*C + 15)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(12*C + 18)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(-12*C - 18)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(12*C + 18)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(40*C*D1**2*f*fd*r*s + 12*C*D1**2*f*fd*r + 40*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd*s - 12*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*s**2 + 10*C*D1**2*f*fdd*s - 20*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*s**2 + 10*C*D1**2*fd**2*s + 80*C*D1*Dd*f**2*r*s - 20*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s**2 - 60*C*D1*Dd*f**2*s + 20*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r*s + 20*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 100*C*D1*Dd*f*fd*s - 10*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r*s + 10*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 30*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r*s + 30*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 90*C*Dd**2*f**2*s - 10*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(2*C + 3)*(2*s - 1)*(r + s - 1) + 12*D1**2*f*fd*r + 12*D1**2*f*fd*s - 12*D1**2*f*fd - 30*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*s**2 + 15*D1**2*f*fdd*s - 30*D1**2*fd**2*r*s - 30*D1**2*fd**2*s**2 + 15*D1**2*fd**2*s - 240*D1*Dd*f*fd*r*s + 30*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 150*D1*Dd*f*fd*s - 15*D1*Dd*f*fd - 60*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 45*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + D1*bd1*(D1*(f*(38*C + 15)*(2*s - 1)*(r + s - 1) - fd*(12*C + 18)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(-24*C - 36)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 180*Dd**2*f**2*r*s + 45*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 135*Dd**2*f**2*s - 15*Dd**2*f**2))/(21*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**4*k2*st**2*(990*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(-224*C*D1**2*f*fd*r*s + 112*C*D1**2*f*fd*r - 484*C*D1**2*f*fd*s**2 + 604*C*D1**2*f*fd*s - 302*C*D1**2*f*fd + 112*C*D1**2*f*fdd*r*s - 56*C*D1**2*f*fdd*r + 278*C*D1**2*f*fdd*s**2 - 338*C*D1**2*f*fdd*s + 169*C*D1**2*f*fdd + 112*C*D1**2*fd**2*r*s - 56*C*D1**2*fd**2*r + 278*C*D1**2*fd**2*s**2 - 338*C*D1**2*fd**2*s - 448*C*D1*Dd*f**2*r*s + 112*C*D1*Dd*f**2*r - 968*C*D1*Dd*f**2*s**2 + 596*C*D1*Dd*f**2*s - 242*C*D1*Dd*f**2 + 896*C*D1*Dd*f*fd*r*s - 336*C*D1*Dd*f*fd*r + 2224*C*D1*Dd*f*fd*s**2 - 2020*C*D1*Dd*f*fd*s + 394*C*D1*Dd*f*fd + 224*C*D1*Ddd*f**2*r*s - 56*C*D1*Ddd*f**2*r + 556*C*D1*Ddd*f**2*s**2 - 334*C*D1*Ddd*f**2*s + 139*C*D1*Ddd*f**2 + 672*C*Dd**2*f**2*r*s - 168*C*Dd**2*f**2*r + 1668*C*Dd**2*f**2*s**2 - 1002*C*Dd**2*f**2*s + 56*C*Dd**2*f**2 - 30*D1**2*bdd1*f*(C - 1)*(2*s**2 - 2*s + 1) + 284*D1**2*f*fd*r*s - 142*D1**2*f*fd*r - 16*D1**2*f*fd*s**2 - 104*D1**2*f*fd*s + 52*D1**2*f*fd - 142*D1**2*f*fdd*r*s + 71*D1**2*f*fdd*r - 28*D1**2*f*fdd*s**2 + 88*D1**2*f*fdd*s - 44*D1**2*f*fdd - 142*D1**2*fd**2*r*s + 71*D1**2*fd**2*r - 28*D1**2*fd**2*s**2 + 88*D1**2*fd**2*s + 568*D1*Dd*f**2*r*s - 142*D1*Dd*f**2*r - 32*D1*Dd*f**2*s**2 - 126*D1*Dd*f**2*s - 8*D1*Dd*f**2 - 1136*D1*Dd*f*fd*r*s + 426*D1*Dd*f*fd*r - 224*D1*Dd*f*fd*s**2 + 550*D1*Dd*f*fd*s - 159*D1*Dd*f*fd - 284*D1*Ddd*f**2*r*s + 71*D1*Ddd*f**2*r - 56*D1*Ddd*f**2*s**2 + 99*D1*Ddd*f**2*s - 14*D1*Ddd*f**2 + 60*D1*bd1*(C - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 852*Dd**2*f**2*r*s + 213*Dd**2*f**2*r - 168*Dd**2*f**2*s**2 + 297*Dd**2*f**2*s - 71*Dd**2*f**2) - f*(9480*C*D1**2*f*fd*r*s - 3160*C*D1**2*f*fd*r + 24378*C*D1**2*f*fd*s**2 - 19412*C*D1**2*f*fd*s + 8126*C*D1**2*f*fd - 5928*C*D1**2*f*fdd*r*s + 1976*C*D1**2*f*fdd*r - 13971*C*D1**2*f*fdd*s**2 + 11290*C*D1**2*f*fdd*s - 4657*C*D1**2*f*fdd - 11856*C*D1**2*fd**2*r*s + 3952*C*D1**2*fd**2*r - 27942*C*D1**2*fd**2*s**2 + 22580*C*D1**2*fd**2*s - 1976*C*D1**2*fd**2 + 12640*C*D1*Dd*f**2*r*s - 3160*C*D1*Dd*f**2*r + 32504*C*D1*Dd*f**2*s**2 - 19412*C*D1*Dd*f**2*s + 8126*C*D1*Dd*f**2 - 47424*C*D1*Dd*f*fd*r*s + 13832*C*D1*Dd*f*fd*r - 111768*C*D1*Dd*f*fd*s**2 + 79030*C*D1*Dd*f*fd*s - 13266*C*D1*Dd*f*fd - 7904*C*D1*Ddd*f**2*r*s + 1976*C*D1*Ddd*f**2*r - 18628*C*D1*Ddd*f**2*s**2 + 11290*C*D1*Ddd*f**2*s - 4657*C*D1*Ddd*f**2 - 23712*C*Dd**2*f**2*r*s + 5928*C*Dd**2*f**2*r - 55884*C*Dd**2*f**2*s**2 + 33870*C*Dd**2*f**2*s - 1976*C*Dd**2*f**2 + 1980*D1**2*bd1**2*s*(C - 1)*(s - 1) - 33*D1**2*bdd1*f*(C*(139*s**2 + s*(56*r + 4) - 30) - 14*s**2 + s*(11 - 71*r) + 30) - 11898*D1**2*f*fd*r*s + 3966*D1**2*f*fd*r - 5628*D1**2*f*fd*s**2 + 7718*D1**2*f*fd*s - 1876*D1**2*f*fd + 7533*D1**2*f*fdd*r*s - 2511*D1**2*f*fdd*r + 4596*D1**2*f*fdd*s**2 - 5575*D1**2*f*fdd*s + 1532*D1**2*f*fdd + 15066*D1**2*fd**2*r*s - 5022*D1**2*fd**2*r + 9192*D1**2*fd**2*s**2 - 11150*D1**2*fd**2*s + 2511*D1**2*fd**2 - 15864*D1*Dd*f**2*r*s + 3966*D1*Dd*f**2*r - 7504*D1*Dd*f**2*s**2 + 7718*D1*Dd*f**2*s - 1876*D1*Dd*f**2 + 60264*D1*Dd*f*fd*r*s - 17577*D1*Dd*f*fd*r + 36768*D1*Dd*f*fd*s**2 - 39025*D1*Dd*f*fd*s + 8086*D1*Dd*f*fd + 10044*D1*Ddd*f**2*r*s - 2511*D1*Ddd*f**2*r + 6128*D1*Ddd*f**2*s**2 - 5575*D1*Ddd*f**2*s + 1532*D1*Ddd*f**2 + 33*D1*bd1*(D1*(2*f*(C*(121*s**2 + s*(56*r + 4) - 30) + 4*s**2 + s*(11 - 71*r) + 30) + fd*(C*(-56*r*(4*s - 1) - 556*s**2 + 330*s - 56) + 71*r*(4*s - 1) + 56*s**2 - 110*s + 71)) + Dd*f*(C*(-56*r*(8*s - 1) - 1112*s**2 + 318*s + 4) + 71*r*(8*s - 1) + 112*s**2 - 143*s + 11)) + 30132*Dd**2*f**2*r*s - 7533*Dd**2*f**2*r + 18384*Dd**2*f**2*s**2 - 16725*Dd**2*f**2*s + 2511*Dd**2*f**2))/(693*d**2*k3**2) - 2*D1**2*Pk1*Pkd2*ct**4*k2*(33*b1**2*(D1**2*s*(fd*r*(84*C - 96) + fd*s*(88*C - 64) + fdd*r*(34 - 28*C) + fdd*s*(53 - 65*C)) + D1*(2*Dd*(2*C*f*(21*r*(4*s - 1) + 88*s**2 - 65*s + 22) - 16*f*(3*r*(4*s - 1) + 8*s**2 - 7*s + 2) - fd*r*(14*C - 17)*(8*s - 1) + fd*s*(C*(79 - 260*s) + 212*s - 70)) + Ddd*f*(C*(-28*r*(4*s - 1) - 260*s**2 + 158*s - 65) + 34*r*(4*s - 1) + 212*s**2 - 140*s + 53)) + 2*Dd**2*f*(C*(-42*r*(4*s - 1) - 390*s**2 + 237*s - 14) + 51*r*(4*s - 1) + 318*s**2 - 210*s + 17)) + 33*b1*(32*C*D1**2*f*fd*r*s + 72*C*D1**2*f*fd*r + 4*C*D1**2*f*fd*s**2 + 56*C*D1**2*f*fd*s - 72*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r - 2*C*D1**2*f*fdd*s**2 - 76*C*D1**2*f*fdd*s + 54*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r - 2*C*D1**2*fd**2*s**2 - 76*C*D1**2*fd**2*s + 64*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s**2 - 20*C*D1*Dd*f**2*s + 2*C*D1*Dd*f**2 - 128*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r - 16*C*D1*Dd*f*fd*s**2 - 284*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r*s + 8*C*D1*Ddd*f**2*r - 4*C*D1*Ddd*f**2*s**2 + 10*C*D1*Ddd*f**2*s - C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r*s + 24*C*Dd**2*f**2*r - 12*C*Dd**2*f**2*s**2 + 30*C*Dd**2*f**2*s - 8*C*Dd**2*f**2 + D1**2*bdd1*f*(C*(r*(28 - 56*s) - 130*s**2 + 158*s - 65) + 34*r*(2*s - 1) + 106*s**2 - 140*s + 53) - 124*D1**2*f*fd*r*s - 40*D1**2*f*fd*r - 244*D1**2*f*fd*s**2 + 238*D1**2*f*fd*s - 68*D1**2*f*fd + 92*D1**2*f*fdd*r*s - 7*D1**2*f*fdd*r + 194*D1**2*f*fdd*s**2 - 143*D1**2*f*fdd*s + 52*D1**2*f*fdd + 92*D1**2*fd**2*r*s - 7*D1**2*fd**2*r + 194*D1**2*fd**2*s**2 - 143*D1**2*fd**2*s - 248*D1*Dd*f**2*r*s + 62*D1*Dd*f**2*r - 488*D1*Dd*f**2*s**2 + 306*D1*Dd*f**2*s - 122*D1*Dd*f**2 + 736*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 1552*D1*Dd*f*fd*s**2 - 1052*D1*Dd*f*fd*s + 150*D1*Dd*f*fd + 184*D1*Ddd*f**2*r*s - 46*D1*Ddd*f**2*r + 388*D1*Ddd*f**2*s**2 - 240*D1*Ddd*f**2*s + 97*D1*Ddd*f**2 + 2*D1*bd1*(D1*(2*C*f*(21*r*(2*s - 1) + 44*s**2 - 65*s + 22) - 16*f*(r*(6*s - 3) + 4*s**2 - 7*s + 2) - fd*r*(14*C - 17)*(4*s - 1) + fd*s*(C*(79 - 130*s) + 106*s - 70)) + Dd*f*(C*(-28*r*(8*s - 3) - 520*s**2 + 474*s - 93) + 34*r*(8*s - 3) + 424*s**2 - 420*s + 87)) + 552*Dd**2*f**2*r*s - 138*Dd**2*f**2*r + 1164*Dd**2*f**2*s**2 - 720*Dd**2*f**2*s + 46*Dd**2*f**2) + f*(-66*D1**2*bd1**2*(C*(14*r*(2*s - 1) + 65*s**2 - 79*s + 14) + r*(17 - 34*s) - 53*s**2 + 70*s - 17) - 33*D1**2*bdd1*f*(C*(8*r*(s - 4) + s**2 - 86*s + 55) + r*(39 - 46*s) - 97*s**2 + 97*s - 45) - 5*D1**2*(f*(fd*(4*C*(119*r*(3*s - 1) + 297*s**2 - 317*s + 99) - 201*r*(3*s - 1) + 1128*s**2 - 551*s + 376) - fdd*(C*(172*r*(3*s - 1) + 891*s**2 - 766*s + 297) + 48*r*(3*s - 1) + 861*s**2 - 622*s + 287)) - 2*fd**2*(C*(172*r*(3*s - 1) + 891*s**2 - 766*s + 86) + 48*r*(3*s - 1) + 861*s**2 - 622*s + 24)) + 33*D1*bd1*(D1*(2*f*(C*(8*r*s - 44*r + s**2 - 38*s + 37) - 31*r*s + 51*r - 61*s**2 + 34*s - 27) + fd*(-4*C*(8*r*s - 10*r + s**2 - 24*s + 2) + 184*r*s - 85*r + 388*s**2 - 337*s + 46)) + 2*Dd*f*(C*(-32*r*s + 68*r - 4*s**2 + 177*s - 59) + 184*r*s - 101*r + 388*s**2 - 314*s + 68)) - 5*D1*f*(Dd*(f*(4*C*(119*r*(4*s - 1) + 396*s**2 - 317*s + 99) - 201*r*(4*s - 1) + 1504*s**2 - 551*s + 376) - 2*fd*(C*(86*r*(24*s - 7) + 3564*s**2 - 2681*s + 469) + 24*r*(24*s - 7) + 3444*s**2 - 2177*s + 335)) - Ddd*f*(C*(172*r*(4*s - 1) + 1188*s**2 - 766*s + 297) + 48*r*(4*s - 1) + 1148*s**2 - 622*s + 287)) + 10*Dd**2*f**2*(C*(258*r*(4*s - 1) + 1782*s**2 - 1149*s + 86) + 72*r*(4*s - 1) + 1722*s**2 - 933*s + 24)))/(693*d**2*k3**2) - 3*D1**2*Pk1*Pkd2*ct**4*st**2*(D1**2*(25*f**3*(196*fd*(4*s**2 - 2*s + 1) - 98*fdd*(4*s**2 - 2*s + 1) + s**2*(390*bd1 - 195*bdd1)) - 6*f**2*s*(715*bd1**2*s + 13*bd1*(125*fd*(3*s - 1) + s*(22*K - 22)) + 2450*fd**2*(2*s - 1) - s*(143*bdd1*(K - 1) + 572*gd2 - 286*gdd2)) + 1716*f*(fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - fdd*g2*(2*s**2 - 2*s + 1) + s**2*(bd1**2*(K - 1) + 2*bd1*(g2 - gd2) - bdd1*g2)) - 3432*fd*g2*s*(bd1 + fd)*(s - 1)) + 2*D1*f*(Dd*(2450*f**3*(4*s**2 - 2*s + 1) - 25*f**2*(4*s - 1)*(195*bd1*s + 98*fd*(4*s - 1)) + 858*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 1716*g2*(4*s - 1)*(bd1*s + fd*(2*s - 1))) - Ddd*f*(1225*f**2 + 858*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(1225*f**2 + 858*g2)*(2*s - 1) + 429*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) - 4*fd*(K - 1)*(s - 1)**2 + 2*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) - 2*f*(K - 1)*(4*s**2 - 2*s + 1) + 2*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-2*K + 5*f + 2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-2*K + 5*f + 2)) + 39*b1*(D1**2*(5*f**2*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(44*bd1 - 22*bdd1)) + f*(-250*fd**2*s*(3*s - 2) - 44*fd*(K*(2*s**2 - 2*s + 1) + s**2*(10*bd1 - 2) + s*(2 - 5*bd1) - 1) + 22*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(44*K*bdd1 - 88*bd1*(K - 1) - 44*bdd1 + 88*gd2 - 44*gdd2)) + (44*s - 44)*(fd**2*s*(K - 1) + 2*fd*g2*(s - 1) - 2*fd*s*(-K*bd1 + bd1 + gd2) - fdd*g2*(s - 1))) + D1*(2*Dd*(125*f**3*(4*s**2 - 2*s + 1) + f**2*(-22*K*(4*s**2 - 2*s + 1) - 125*fd*(12*s**2 - 7*s + 1) - 22*s**2*(20*bd1 - 4) - 22*s*(2 - 5*bd1) + 22) + 22*f*(fd*(K - 1)*(8*s**2 - 6*s + 1) + 2*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(2*K*bd1 - 2*bd1 - 2*gd2)) - 44*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(125*f**2 - 22*f*(K - 1) + 44*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(125*f**2 - 22*f*(K - 1) + 44*g2)))/(2002*d**2*k2) - D1**2*Pk1*Pkd2*ct**4*(-50622*D1**2*K*bd1**2*f*s**2 - 25740*D1**2*K*bd1**2*f*s + 59202*D1**2*K*bd1*f**2*s**2 - 128700*D1**2*K*bd1*f*fd*s**2 + 64350*D1**2*K*bd1*f*fd*s - 32175*D1**2*K*bdd1*f**2*s**2 + 10296*D1**2*bd1**2*f**2*r*s - 39468*D1**2*bd1**2*f**2*s**2 + 59202*D1**2*bd1**2*f**2*s + 10296*D1**2*bd1**2*f*r*s - 858*D1**2*bd1**2*f*s**2 + 20592*D1**2*bd1**2*f*s - 60060*D1**2*bd1**2*g2*s**2 + 60060*D1**2*bd1**2*g2*s - 25740*D1**2*bd1*bd2*f*s**2 - 13780*D1**2*bd1*f**3*r*s - 48360*D1**2*bd1*f**3*s**2 - 65910*D1**2*bd1*f**3*s + 36400*D1**2*bd1*f**3 + 67080*D1**2*bd1*f**2*fd*r*s - 11180*D1**2*bd1*f**2*fd*r + 183690*D1**2*bd1*f**2*fd*s**2 - 10790*D1**2*bd1*f**2*fd*s + 5590*D1**2*bd1*f**2*fd - 12012*D1**2*bd1*f**2*r*s - 16302*D1**2*bd1*f**2*s**2 + 24024*D1**2*bd1*f*fd*r*s - 6006*D1**2*bd1*f*fd*r + 42900*D1**2*bd1*f*fd*s**2 - 27456*D1**2*bd1*f*fd*s - 89232*D1**2*bd1*f*g2*s**2 - 102960*D1**2*bd1*f*g2*s + 51480*D1**2*bd1*f*g2 + 101244*D1**2*bd1*f*gd2*s**2 + 51480*D1**2*bd1*f*gd2*s + 101244*D1**2*bd1*fd*g2*s**2 - 101244*D1**2*bd1*fd*g2*s + 21450*D1**2*bd2*f**2*s**2 - 42900*D1**2*bd2*f*fd*s**2 + 21450*D1**2*bd2*f*fd*s + 11180*D1**2*bdd1*f**3*r*s + 30615*D1**2*bdd1*f**3*s**2 + 30810*D1**2*bdd1*f**3*s - 18200*D1**2*bdd1*f**3 + 6006*D1**2*bdd1*f**2*r*s + 10725*D1**2*bdd1*f**2*s**2 + 50622*D1**2*bdd1*f*g2*s**2 + 51480*D1**2*bdd1*f*g2*s - 25740*D1**2*bdd1*f*g2 - 10725*D1**2*bdd2*f**2*s**2 - 30240*D1**2*f**3*fd*r*s + 7560*D1**2*f**3*fd*r - 232960*D1**2*f**3*fd*s**2 + 124040*D1**2*f**3*fd*s - 58240*D1**2*f**3*fd + 22400*D1**2*f**3*fdd*r*s - 5600*D1**2*f**3*fdd*r + 131040*D1**2*f**3*fdd*s**2 - 71120*D1**2*f**3*fdd*s + 32760*D1**2*f**3*fdd + 67200*D1**2*f**2*fd**2*r*s - 16800*D1**2*f**2*fd**2*r + 393120*D1**2*f**2*fd**2*s**2 - 213360*D1**2*f**2*fd**2*s + 5600*D1**2*f**2*fd**2 - 118404*D1**2*f**2*gd2*s**2 + 64350*D1**2*f**2*gdd2*s**2 - 236808*D1**2*f*fd*g2*s**2 + 236808*D1**2*f*fd*g2*s - 118404*D1**2*f*fd*g2 + 257400*D1**2*f*fd*gd2*s**2 - 128700*D1**2*f*fd*gd2*s + 128700*D1**2*f*fdd*g2*s**2 - 128700*D1**2*f*fdd*g2*s + 64350*D1**2*f*fdd*g2 + 128700*D1**2*fd**2*g2*s**2 - 128700*D1**2*fd**2*g2*s - 257400*D1*Dd*K*bd1*f**2*s**2 + 64350*D1*Dd*K*bd1*f**2*s + 89440*D1*Dd*bd1*f**3*r*s - 11180*D1*Dd*bd1*f**3*r + 244920*D1*Dd*bd1*f**3*s**2 + 50830*D1*Dd*bd1*f**3*s - 30810*D1*Dd*bd1*f**3 + 48048*D1*Dd*bd1*f**2*r*s - 6006*D1*Dd*bd1*f**2*r + 85800*D1*Dd*bd1*f**2*s**2 - 27456*D1*Dd*bd1*f**2*s + 404976*D1*Dd*bd1*f*g2*s**2 + 104676*D1*Dd*bd1*f*g2*s - 51480*D1*Dd*bd1*f*g2 - 85800*D1*Dd*bd2*f**2*s**2 + 21450*D1*Dd*bd2*f**2*s - 30240*D1*Dd*f**4*r*s + 7560*D1*Dd*f**4*r - 232960*D1*Dd*f**4*s**2 + 124040*D1*Dd*f**4*s - 58240*D1*Dd*f**4 + 179200*D1*Dd*f**3*fd*r*s - 44800*D1*Dd*f**3*fd*r + 1048320*D1*Dd*f**3*fd*s**2 - 568960*D1*Dd*f**3*fd*s + 76720*D1*Dd*f**3*fd - 473616*D1*Dd*f**2*g2*s**2 + 236808*D1*Dd*f**2*g2*s - 118404*D1*Dd*f**2*g2 + 514800*D1*Dd*f**2*gd2*s**2 - 128700*D1*Dd*f**2*gd2*s + 1029600*D1*Dd*f*fd*g2*s**2 - 772200*D1*Dd*f*fd*g2*s + 128700*D1*Dd*f*fd*g2 + 22400*D1*Ddd*f**4*r*s - 5600*D1*Ddd*f**4*r + 131040*D1*Ddd*f**4*s**2 - 71120*D1*Ddd*f**4*s + 32760*D1*Ddd*f**4 + 257400*D1*Ddd*f**2*g2*s**2 - 128700*D1*Ddd*f**2*g2*s + 64350*D1*Ddd*f**2*g2 + 67200*Dd**2*f**4*r*s - 16800*Dd**2*f**4*r + 393120*Dd**2*f**4*s**2 - 213360*Dd**2*f**4*s + 5600*Dd**2*f**4 + 772200*Dd**2*f**2*g2*s**2 - 386100*Dd**2*f**2*g2*s + 2145*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-7*K*(4*s**2 - 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s + 28*s**2 - 14*s + 7) - D1*Ddd*(-7*K + 6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-7*K + 6*f + 7)) + 429*b1**2*(104*D1**2*K*fd*s**2 - 328*D1**2*K*fd*s + 164*D1**2*K*fd - 59*D1**2*K*fdd*s**2 + 178*D1**2*K*fdd*s - 89*D1**2*K*fdd - 5*D1**2*bdd1*(-7*K + 6*f + 7)*(3*s**2 - 2*s + 1) - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 208*D1**2*f*fd*s**2 + 92*D1**2*f*fd*s - 46*D1**2*f*fd + 24*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r - 92*D1**2*f*fdd*s**2 - 58*D1**2*f*fdd*s + 29*D1**2*f*fdd + 24*D1**2*fd**2*r*s - 12*D1**2*fd**2*r - 92*D1**2*fd**2*s**2 - 58*D1**2*fd**2*s - 24*D1**2*fd*r*s + 24*D1**2*fd*r + 16*D1**2*fd*s**2 + 88*D1**2*fd*s - 44*D1**2*fd + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r - D1**2*fdd*s**2 - 58*D1**2*fdd*s + 29*D1**2*fdd + 140*D1**2*gd2*s**2 - 70*D1**2*gdd2*s**2 + 416*D1*Dd*K*f*s**2 - 208*D1*Dd*K*f*s + 104*D1*Dd*K*f - 472*D1*Dd*K*fd*s**2 + 830*D1*Dd*K*fd*s - 178*D1*Dd*K*fd - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 416*D1*Dd*f**2*s**2 - 196*D1*Dd*f**2*s + 104*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r - 736*D1*Dd*f*fd*s**2 - 72*D1*Dd*f*fd*s + 70*D1*Dd*f*fd - 96*D1*Dd*f*r*s + 24*D1*Dd*f*r + 64*D1*Dd*f*s**2 - 8*D1*Dd*f*s + 16*D1*Dd*f + 96*D1*Dd*fd*r*s - 60*D1*Dd*fd*r - 8*D1*Dd*fd*s**2 - 242*D1*Dd*fd*s + 70*D1*Dd*fd + 560*D1*Dd*g2*s**2 - 280*D1*Dd*g2*s + 140*D1*Dd*g2 - 560*D1*Dd*gd2*s**2 + 140*D1*Dd*gd2*s - 236*D1*Ddd*K*f*s**2 + 118*D1*Ddd*K*f*s - 59*D1*Ddd*K*f + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r - 184*D1*Ddd*f**2*s**2 + 80*D1*Ddd*f**2*s - 46*D1*Ddd*f**2 + 48*D1*Ddd*f*r*s - 12*D1*Ddd*f*r - 4*D1*Ddd*f*s**2 - 10*D1*Ddd*f*s - D1*Ddd*f - 280*D1*Ddd*g2*s**2 + 140*D1*Ddd*g2*s - 70*D1*Ddd*g2 + 10*D1*bd1*(D1*(-7*K*(3*s**2 - 2*s + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s + 21*s**2 - 14*s + 7) - Dd*(-7*K + 6*f + 7)*(12*s**2 - 7*s + 1)) - 708*Dd**2*K*f*s**2 + 354*Dd**2*K*f*s + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r - 552*Dd**2*f**2*s**2 + 240*Dd**2*f**2*s + 12*Dd**2*f**2 + 144*Dd**2*f*r*s - 36*Dd**2*f*r - 12*Dd**2*f*s**2 - 30*Dd**2*f*s + 12*Dd**2*f - 840*Dd**2*g2*s**2 + 420*Dd**2*g2*s) - 13*b1*(-9108*D1**2*K*f*fd*s**2 + 9108*D1**2*K*f*fd*s - 4554*D1**2*K*f*fd + 4950*D1**2*K*f*fdd*s**2 - 4950*D1**2*K*f*fdd*s + 2475*D1**2*K*f*fdd + 4950*D1**2*K*fd**2*s**2 - 4950*D1**2*K*fd**2*s - 1980*D1**2*b2*fd*s**2 + 3960*D1**2*b2*fd*s - 1980*D1**2*b2*fd + 990*D1**2*b2*fdd*s**2 - 1980*D1**2*b2*fdd*s + 990*D1**2*b2*fdd + 330*D1**2*bd1**2*s*(3*s - 2)*(-7*K + 6*f + 7) - 1980*D1**2*bd2*f*s**2 + 1980*D1**2*bd2*fd*s**2 - 1980*D1**2*bd2*fd*s + 33*D1**2*bdd1*(f**2*(92*s**2 - s*(24*r + 138) + 75) + 2*f*(K*(59*s**2 + 30*s - 15) + s**2 - s*(12*r + 24) + 15) + 70*g2*(2*s**2 - 2*s + 1)) + 990*D1**2*bdd2*f*s**2 + 3180*D1**2*f**2*fd*r*s - 1060*D1**2*f**2*fd*r + 11160*D1**2*f**2*fd*s**2 - 13570*D1**2*f**2*fd*s + 6520*D1**2*f**2*fd - 2580*D1**2*f**2*fdd*r*s + 860*D1**2*f**2*fdd*r - 7065*D1**2*f**2*fdd*s**2 + 7940*D1**2*f**2*fdd*s - 3755*D1**2*f**2*fdd - 5160*D1**2*f*fd**2*r*s + 1720*D1**2*f*fd**2*r - 14130*D1**2*f*fd**2*s**2 + 15880*D1**2*f*fd**2*s - 430*D1**2*f*fd**2 + 1848*D1**2*f*fd*r*s - 924*D1**2*f*fd*r + 2508*D1**2*f*fd*s**2 - 3432*D1**2*f*fd*s + 1254*D1**2*f*fd - 924*D1**2*f*fdd*r*s + 462*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 2112*D1**2*f*fdd*s - 825*D1**2*f*fdd + 6864*D1**2*f*gd2*s**2 - 3894*D1**2*f*gdd2*s**2 - 924*D1**2*fd**2*r*s + 462*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 2112*D1**2*fd**2*s - 462*D1**2*fd**2 + 6864*D1**2*fd*g2*s**2 - 21648*D1**2*fd*g2*s + 10824*D1**2*fd*g2 - 7788*D1**2*fd*gd2*s**2 + 11748*D1**2*fd*gd2*s - 3894*D1**2*fdd*g2*s**2 + 11748*D1**2*fdd*g2*s - 5874*D1**2*fdd*g2 - 18216*D1*Dd*K*f**2*s**2 + 9108*D1*Dd*K*f**2*s - 4554*D1*Dd*K*f**2 + 39600*D1*Dd*K*f*fd*s**2 - 29700*D1*Dd*K*f*fd*s + 4950*D1*Dd*K*f*fd - 7920*D1*Dd*b2*f*s**2 + 3960*D1*Dd*b2*f*s - 1980*D1*Dd*b2*f + 7920*D1*Dd*b2*fd*s**2 - 9900*D1*Dd*b2*fd*s + 1980*D1*Dd*b2*fd + 7920*D1*Dd*bd2*f*s**2 - 1980*D1*Dd*bd2*f*s + 4240*D1*Dd*f**3*r*s - 1060*D1*Dd*f**3*r + 14880*D1*Dd*f**3*s**2 - 8500*D1*Dd*f**3*s + 3720*D1*Dd*f**3 - 20640*D1*Dd*f**2*fd*r*s + 6020*D1*Dd*f**2*fd*r - 56520*D1*Dd*f**2*fd*s**2 + 48470*D1*Dd*f**2*fd*s - 8800*D1*Dd*f**2*fd + 3696*D1*Dd*f**2*r*s - 924*D1*Dd*f**2*r + 5016*D1*Dd*f**2*s**2 - 3432*D1*Dd*f**2*s + 1254*D1*Dd*f**2 - 7392*D1*Dd*f*fd*r*s + 2772*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 12672*D1*Dd*f*fd*s - 2574*D1*Dd*f*fd + 27456*D1*Dd*f*g2*s**2 - 13728*D1*Dd*f*g2*s + 6864*D1*Dd*f*g2 - 31152*D1*Dd*f*gd2*s**2 + 7788*D1*Dd*f*gd2*s - 31152*D1*Dd*fd*g2*s**2 + 54780*D1*Dd*fd*g2*s - 11748*D1*Dd*fd*g2 + 9900*D1*Ddd*K*f**2*s**2 - 4950*D1*Ddd*K*f**2*s + 2475*D1*Ddd*K*f**2 + 3960*D1*Ddd*b2*f*s**2 - 1980*D1*Ddd*b2*f*s + 990*D1*Ddd*b2*f - 3440*D1*Ddd*f**3*r*s + 860*D1*Ddd*f**3*r - 9420*D1*Ddd*f**3*s**2 + 5570*D1*Ddd*f**3*s - 2355*D1*Ddd*f**3 - 1848*D1*Ddd*f**2*r*s + 462*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 2112*D1*Ddd*f**2*s - 825*D1*Ddd*f**2 - 15576*D1*Ddd*f*g2*s**2 + 7788*D1*Ddd*f*g2*s - 3894*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f**2*(-104*s**2 + s*(12*r + 144) - 75) - 2*f*(K*(52*s**2 + 30*s - 15) + fd*(6*r*(4*s - 1) - 92*s**2 + 40*s + 3) - 12*r*s + 8*s**2 - 24*s + 15) + 2*fd*(r*(6 - 12*s) + s**2*(59*K + 1) + s*(17 - 74*K) - 3) - 70*g2*(2*s**2 - 2*s + 1) - 70*gd2*s*(1 - 2*s)) + Dd*(f**2*(r*(12 - 96*s) + 368*s**2 - 356*s + 69) + 2*f*(K*(236*s**2 + s - 15) - 48*r*s + 6*r + 4*s**2 - 43*s + 12) + 70*g2*(8*s**2 - 6*s + 1))) + 29700*Dd**2*K*f**2*s**2 - 14850*Dd**2*K*f**2*s + 11880*Dd**2*b2*f*s**2 - 5940*Dd**2*b2*f*s - 10320*Dd**2*f**3*r*s + 2580*Dd**2*f**3*r - 28260*Dd**2*f**3*s**2 + 16710*Dd**2*f**3*s - 860*Dd**2*f**3 - 5544*Dd**2*f**2*r*s + 1386*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 6336*Dd**2*f**2*s - 462*Dd**2*f**2 - 46728*Dd**2*f*g2*s**2 + 23364*Dd**2*f*g2*s) + 2145*b2*(D1**2*(f*(10*fd*(2*s**2 - 2*s + 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(12*bd1 - 6*bdd1)) - 2*fd*s*(6*bd1 + 5*fd)*(s - 1)) + D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(6*bd1*s + 5*fd*(2*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(9009*d**2*k2) + D1**2*Pk1*Pkd2*ct**4*k2**3*st**2*(33*D1*bd1*f*(D1*(2*f*s*(r - 1) + 5*fd*(4*r*s - r - 2*s + 1)) + 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) + 33*b1*(D1*Dd*f*(2*f*(4*r*s - r - s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(D1*r*(2*s - 1)*(2*f*fd + 5*f*fdd + 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(202*f*(4*r*s - r - s) - 35*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(202*f*fd*(r*(3*s - 1) - s) + 5*f*(33*bdd1*s*(r - 1) + 7*fdd*(-3*r*s + r + s)) - 35*fd**2*(r*(6*s - 2) - 2*s + 1)) + 35*Ddd*f**2*(-4*r*s + r + s)) - 35*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1**2*k3**2) + 2*D1**2*Pk1*Pkd2*ct**4*k2**3*(6*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + D1*bd1*(2*b1*(D1*(f*r*(2*s - 1) - f*s + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) - 3*f*(D1*(2*f*(r - s) + fd*(-4*r*s + 2*r + s - 1)) + Dd*f*(r*(5 - 8*s) + s - 1))) + D1*f**2*(3*D1*bdd1*r*(s - 1) + 5*D1*fd*(-3*r*s + r + s) + 5*Dd*f*(-4*r*s + r + s)) + 2*b1**2*(D1*Dd*(f*r*(4*s - 1) - f*s + 3*fd*r*(8*s - 1) - 3*fd*s) + D1*(D1*r*s*(fd + 3*fdd) + 3*Ddd*f*(r*(4*s - 1) - s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 3*b1*(D1*Dd*f*fd*(2*r*(8*s - 1) - 6*s + 1) + D1*(2*D1*bdd1*f*(r*(2*s - 1) - s) + D1*(2*f*fd*(r - s) + f*fdd*s*(2*r - 1) + fd**2*s*(2*r - 1)) + Ddd*f**2*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k1**2*k3**2) - 2*D1**2*Pk1*Pkd2*ct**4*k2*(D1*f*(-66*D1*bd1**2*(f*(8*r*s - 2*r - 4*s + 2) + s*(6*r - 3)) + D1*bdd1*f*r*(-65*f*(2*s - 1) - 99*s) + bd1*(D1*(35*f**2*r*(1 - 2*s) - 65*f*fd*(4*r*(3*s - 1) - 2*s + 1) - 198*f*r*s + 99*fd*(-4*r*s + r + s)) + Dd*f*(-65*f*(16*r*s - 6*r - 2*s + 1) - 792*r*s + 99*r + 99*s))) - 66*b1**2*(D1*Dd*(-f*(2*f - 1)*(r*(4*s - 1) - s) + fd*(2*f*(8*r - 1)*(4*s - 1) + 3*r*(8*s - 5) - 3*s + 3)) + D1*(D1*r*(fd**2*(8*s - 2) + fd*(-4*f*s + f + s - 1) + fdd*(8*f*s - 2*f + 3*s - 3)) + Ddd*f*(4*f + 3)*(r*(4*s - 1) - s)) + Dd**2*f*(4*f + 3)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(-2*f*(35*f + 99)*(r*(4*s - 1) - s) + fd*(-65*f*(48*r*s - 10*r - 14*s + 3) - 1584*r*s + 594*r + 594*s - 198)) + 66*D1*bd1*(D1*(f*(f*r*(4*s - 1) - 2*f*s - 2*r*s + s) + fd*(-2*f*(4*r - 1)*(4*s - 1) + 3*r*(2 - 4*s) + 3*s - 3)) + Dd*f*(-2*f*(8*r - 3)*(4*s - 1) + r*(6 - 48*s) + 18*s - 3)) + D1*(D1*(f*fd*(r*(-210*f*s + 35*f - 396*s + 198) + s*(70*f + 198)) + f*(-66*bdd1*(8*f*r*s - 2*f*r - 4*f*s + 6*r*s - 3*s) + fdd*r*(-65*f*(6*s - 1) - 198*s + 99) + fdd*s*(130*f + 99)) + fd**2*(-65*f*(12*r*s - 2*r - 4*s + 1) - 198*r*s + 99*r + 99*s - 99)) - Ddd*f**2*(130*f + 99)*(r*(4*s - 1) - s)) - Dd**2*f**2*(130*f + 99)*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1**2) + 4*D1**2*Pk1*Pkd2*ct**3*f*k1*k2**2*st**4*(D1**2*(f*(22*bd1*s*(C - 1)*(r + s - 1) + fd*(20*C - 30)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(10*C - 15)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(15 - 10*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 22*D1*b1*(C - 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + D1*f*(10*C - 15)*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(15 - 10*C)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1))/(77*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**3*f*k1*st**4*(60*C - 105)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k3**2) - 20*D1**2*Pk1*Pkd2*ct**3*f*k2**4*st**4*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1))/(77*d**2*k1*k3**4) + D1**2*Pk1*Pkd2*ct**3*f*k2**2*st**4*(D1**2*(f*(264*bd1*s*(C - 1)*(r - 1) - 10*fd*(-8*C*s + r*(8*C - 8)*(3*s - 1) + 45*s**2 - 22*s + 15) + 5*fdd*(-8*C*s + r*(8*C - 8)*(3*s - 1) + 45*s**2 - 22*s + 15)) + 2*fd*(132*b1*r*(C - 1)*(2*s - 1) + 5*fd*(4*C*(6*r*s - 2*r - 2*s + 1) - 24*r*s + 8*r + 45*s**2 - 22*s - 4))) + D1*f*(-2*Dd*(-132*b1*(C - 1)*(r*(4*s - 1) - s) + 5*f*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 60*s**2 - 22*s + 15) - 5*fd*(4*C*(24*r*s - 7*r - 7*s + 2) - 96*r*s + 28*r + 180*s**2 - 77*s + 7)) + 5*Ddd*f*(r*(8*C - 8)*(4*s - 1) + 60*s**2 - s*(8*C + 22) + 15)) + 10*Dd**2*f**2*(4*C*(3*r*(4*s - 1) - 3*s + 1) + r*(12 - 48*s) + 90*s**2 - 33*s - 4))/(231*d**2*k1*k3**2) - 15*D1**2*Pk1*Pkd2*ct**3*f*st**4*(13*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(20*fd*(4*s**2 - 2*s + 1) - 10*fdd*(4*s**2 - 2*s + 1) + s**2*(26*bd1 - 13*bdd1)) + 2*fd*s*(bd1*(13 - 39*s) + 30*fd*(1 - 2*s))) + 2*D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(13*bd1*s + 10*fd*(4*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 60*Dd**2*f**2*s*(1 - 2*s)))/(143*d**2*k1) + D1**2*Pk1*Pkd2*ct**3*k1**3*st**2*(4*C - 16)*(11*b1*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 3*fd*(8*s - 3)*(2*r + 2*s - 1)) - 3*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(39*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 25*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 25*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 25*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k3**4) + 4*D1**2*Pk1*Pkd2*ct**3*k1**3*(66*b1**2*(D1**2*s*(r + s)*(fd*(5*C - 16) + fdd*(15 - 6*C)) + D1*(Dd*(f*(5*C - 16)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C - 15)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(15 - 6*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(6*C - 15)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 33*b1*(8*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s - 8*C*D1**2*f*fd - 10*C*D1**2*f*fdd*r - 10*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd - 10*C*D1**2*fd**2*r - 10*C*D1**2*fd**2*s - 40*C*D1*Dd*f*fd*r - 40*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd - 6*D1**2*bdd1*f*(2*C - 5)*(2*s - 1)*(r + s - 1) - 40*D1**2*f*fd*r*s - 6*D1**2*f*fd*r - 40*D1**2*f*fd*s**2 + 14*D1**2*f*fd*s + 6*D1**2*f*fd + 50*D1**2*f*fdd*r*s + 50*D1**2*f*fdd*s**2 - 25*D1**2*f*fdd*s + 50*D1**2*fd**2*r*s + 50*D1**2*fd**2*s**2 - 25*D1**2*fd**2*s - 80*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r - 80*D1*Dd*f**2*s**2 + 60*D1*Dd*f**2*s - 20*D1*Dd*f**2 + 400*D1*Dd*f*fd*r*s - 50*D1*Dd*f*fd*r + 400*D1*Dd*f*fd*s**2 - 250*D1*Dd*f*fd*s + 25*D1*Dd*f*fd + 100*D1*Ddd*f**2*r*s - 25*D1*Ddd*f**2*r + 100*D1*Ddd*f**2*s**2 - 75*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(5*C - 16)*(2*s - 1)*(r + s - 1) - fd*(6*C - 15)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(30 - 12*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 300*Dd**2*f**2*r*s - 75*Dd**2*f**2*r + 300*Dd**2*f**2*s**2 - 225*Dd**2*f**2*s + 25*Dd**2*f**2) + f*(280*C*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) - 198*D1**2*bd1**2*(2*C - 5)*(2*s - 1)*(r + s - 1) + 165*D1**2*bdd1*f*(2*C + 5*s - 5)*(r + s - 1) + 5*D1**2*(56*C*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - f*(-56*C*fdd + fd*(46*C - 33))*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - 33*D1*bd1*(D1*(2*f*(4*C + 10*s - 13)*(r + s - 1) - 5*fd*(2*C*s + 2*r*(C + 10*s - 5) + 20*s**2 - 25*s + 5)) - 5*Dd*f*(C*(8*r + 8*s - 4) + 40*r*s - 25*r + 40*s**2 - 55*s + 15)) + 5*D1*f*(56*C*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + Dd*(56*C*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4) - f*(46*C - 33)*(4*r*s - r + 4*s**2 - 3*s + 1)))))/(693*d**2*k3**4) - 3*D1**2*Pk1*Pkd2*ct**3*k1**3*st**2*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(50*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2**2*k3**2) - 5*D1**2*Pk1*Pkd2*ct**3*k1**3*(198*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(-6*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 12*D1**2*f*fd*s**2 + 32*D1**2*f*fd*s - 16*D1**2*f*fd + 6*D1**2*f*fdd*s**2 - 16*D1**2*f*fdd*s + 8*D1**2*f*fdd + 6*D1**2*fd**2*s**2 - 16*D1**2*fd**2*s - 24*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 48*D1*Dd*f*fd*s**2 - 76*D1*Dd*f*fd*s + 16*D1*Dd*f*fd + 12*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 12*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 36*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s) + f*(-396*D1**2*bd1**2*s*(s - 1) + 33*D1**2*bdd1*f*(3*s**2 + 10*s - 5) - 221*D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) - 66*D1*bd1*(D1*f*(3*s**2 + 10*s - 5) - 2*D1*fd*s*(3*s + 1) + Dd*f*(-12*s**2 - 17*s + 5)) - 221*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 1326*Dd**2*f**2*s*(1 - 2*s)))/(693*d**2*k2**2*k3**2) + 4*D1**2*Pk1*Pkd2*ct**3*k1*k2**2*st**2*(11*b1**2*(D1**2*s*(r + s)*(fd*(25*C - 31) + fdd*(12 - 9*C)) + D1*(Dd*(f*(25*C - 31)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(9*C - 12)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(12 - 9*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(9*C - 12)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 11*b1*(-86*C*D1**2*f*fd*r*s + 60*C*D1**2*f*fd*r - 86*C*D1**2*f*fd*s**2 + 103*C*D1**2*f*fd*s - 60*C*D1**2*f*fd + 42*C*D1**2*f*fdd*r*s - 30*C*D1**2*f*fdd*r + 42*C*D1**2*f*fdd*s**2 - 51*C*D1**2*f*fdd*s + 30*C*D1**2*f*fdd + 42*C*D1**2*fd**2*r*s - 30*C*D1**2*fd**2*r + 42*C*D1**2*fd**2*s**2 - 51*C*D1**2*fd**2*s - 172*C*D1*Dd*f**2*r*s + 43*C*D1*Dd*f**2*r - 172*C*D1*Dd*f**2*s**2 + 129*C*D1*Dd*f**2*s - 43*C*D1*Dd*f**2 + 336*C*D1*Dd*f*fd*r*s - 162*C*D1*Dd*f*fd*r + 336*C*D1*Dd*f*fd*s**2 - 330*C*D1*Dd*f*fd*s + 81*C*D1*Dd*f*fd + 84*C*D1*Ddd*f**2*r*s - 21*C*D1*Ddd*f**2*r + 84*C*D1*Ddd*f**2*s**2 - 63*C*D1*Ddd*f**2*s + 21*C*D1*Ddd*f**2 + 252*C*Dd**2*f**2*r*s - 63*C*Dd**2*f**2*r + 252*C*Dd**2*f**2*s**2 - 189*C*Dd**2*f**2*s + 21*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(3*C - 4)*(2*s - 1)*(r + s - 1) - 58*D1**2*f*fd*r*s + 6*D1**2*f*fd*r - 58*D1**2*f*fd*s**2 + 35*D1**2*f*fd*s - 6*D1**2*f*fd + 42*D1**2*f*fdd*r*s - 9*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s + 9*D1**2*f*fdd + 42*D1**2*fd**2*r*s - 9*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s - 116*D1*Dd*f**2*r*s + 29*D1*Dd*f**2*r - 116*D1*Dd*f**2*s**2 + 87*D1*Dd*f**2*s - 29*D1*Dd*f**2 + 336*D1*Dd*f*fd*r*s - 78*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 246*D1*Dd*f*fd*s + 39*D1*Dd*f*fd + 84*D1*Ddd*f**2*r*s - 21*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 63*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 + D1*bd1*(D1*(f*(25*C - 31)*(2*s - 1)*(r + s - 1) - fd*(9*C - 12)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(24 - 18*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 252*Dd**2*f**2*r*s - 63*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 189*Dd**2*f**2*s + 21*Dd**2*f**2) + f*(-1500*C*D1**2*f*fd*r*s + 500*C*D1**2*f*fd*r - 1500*C*D1**2*f*fd*s**2 + 1500*C*D1**2*f*fd*s - 500*C*D1**2*f*fd + 750*C*D1**2*f*fdd*r*s - 250*C*D1**2*f*fdd*r + 750*C*D1**2*f*fdd*s**2 - 750*C*D1**2*f*fdd*s + 250*C*D1**2*f*fdd + 1500*C*D1**2*fd**2*r*s - 500*C*D1**2*fd**2*r + 1500*C*D1**2*fd**2*s**2 - 1500*C*D1**2*fd**2*s + 250*C*D1**2*fd**2 - 2000*C*D1*Dd*f**2*r*s + 500*C*D1*Dd*f**2*r - 2000*C*D1*Dd*f**2*s**2 + 1500*C*D1*Dd*f**2*s - 500*C*D1*Dd*f**2 + 6000*C*D1*Dd*f*fd*r*s - 1750*C*D1*Dd*f*fd*r + 6000*C*D1*Dd*f*fd*s**2 - 5250*C*D1*Dd*f*fd*s + 1000*C*D1*Dd*f*fd + 1000*C*D1*Ddd*f**2*r*s - 250*C*D1*Ddd*f**2*r + 1000*C*D1*Ddd*f**2*s**2 - 750*C*D1*Ddd*f**2*s + 250*C*D1*Ddd*f**2 + 3000*C*Dd**2*f**2*r*s - 750*C*Dd**2*f**2*r + 3000*C*Dd**2*f**2*s**2 - 2250*C*Dd**2*f**2*s + 250*C*Dd**2*f**2 - 33*D1**2*bd1**2*(3*C - 4)*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(7*C*s + 3*C + 7*s - 4) - 54*D1**2*f*fd*r*s + 18*D1**2*f*fd*r - 54*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s - 18*D1**2*f*fd + 225*D1**2*f*fdd*r*s - 75*D1**2*f*fdd*r + 225*D1**2*f*fdd*s**2 - 225*D1**2*f*fdd*s + 75*D1**2*f*fdd + 450*D1**2*fd**2*r*s - 150*D1**2*fd**2*r + 450*D1**2*fd**2*s**2 - 450*D1**2*fd**2*s + 75*D1**2*fd**2 - 72*D1*Dd*f**2*r*s + 18*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 54*D1*Dd*f**2*s - 18*D1*Dd*f**2 + 1800*D1*Dd*f*fd*r*s - 525*D1*Dd*f*fd*r + 1800*D1*Dd*f*fd*s**2 - 1575*D1*Dd*f*fd*s + 300*D1*Dd*f*fd + 300*D1*Ddd*f**2*r*s - 75*D1*Ddd*f**2*r + 300*D1*Ddd*f**2*s**2 - 225*D1*Ddd*f**2*s + 75*D1*Ddd*f**2 - 11*D1*bd1*(D1*(f*(r + s - 1)*(C*(43*s + 17) + 29*s - 23) - 3*fd*(C*(28*r*s - 4*r + 28*s**2 - 25*s + 7) + 28*r*s - 11*r + 28*s**2 - 32*s + 7)) - 3*Dd*f*(C*(56*r*s + 5*r + 56*s**2 - 37*s + 1) + 56*r*s - 23*r + 56*s**2 - 65*s + 15)) + 900*Dd**2*f**2*r*s - 225*Dd**2*f**2*r + 900*Dd**2*f**2*s**2 - 675*Dd**2*f**2*s + 75*Dd**2*f**2))/(231*d**2*k3**4) - 4*D1**2*Pk1*Pkd2*ct**3*k1*k2**2*(D1*f*(-18*D1*bd1**2*(2*C + 1)*(2*s - 1)*(r + s - 1) + 3*bd1*(D1*(2*f*(r + s - 1)*(4*C*(2*s - 3) - 3*s + 2) - fd*(10*C + 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(-10*C - 5)*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) - 5*f*(3*D1*bdd1*(2*C + 1)*(s - 1)*(r + s - 1) + (4*C + 1)*(D1*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))) + b1**2*(D1**2*s*(r + s)*(-36*C*fdd + fd*(86*C - 13) - 18*fdd) + D1*(Dd*(f*(86*C - 13)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(36*C + 18)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(-36*C - 18)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(36*C + 18)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(-18*D1**2*bdd1*f*(2*C + 1)*(2*s - 1)*(r + s - 1) - 3*D1**2*(-2*f*fd*(4*C*(4*r*s + r + 4*s**2 - s - 1) - 6*r*s + r - 6*s**2 + 4*s - 1) + f*fdd*s*(10*C + 5)*(2*r + 2*s - 1) + fd**2*s*(10*C + 5)*(2*r + 2*s - 1)) + D1*bd1*(D1*(f*(86*C - 13)*(2*s - 1)*(r + s - 1) - fd*(36*C + 18)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(-72*C - 36)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 3*D1*f*(Dd*(-f*(16*C - 6)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + fd*(10*C + 5)*(8*s - 1)*(2*r + 2*s - 1)) + Ddd*f*(10*C + 5)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f**2*(10*C + 5)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(21*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**3*k1*st**2*(495*b1**2*(2*C - 3)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(-80*C*D1**2*f*fd*r*s + 40*C*D1**2*f*fd*r - 592*C*D1**2*f*fd*s**2 + 712*C*D1**2*f*fd*s - 356*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 320*C*D1**2*f*fdd*s**2 - 380*C*D1**2*f*fdd*s + 190*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 320*C*D1**2*fd**2*s**2 - 380*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r - 1184*C*D1*Dd*f**2*s**2 + 632*C*D1*Dd*f**2*s - 296*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r*s - 144*C*D1*Dd*f*fd*r + 2560*C*D1*Dd*f*fd*s**2 - 2208*C*D1*Dd*f*fd*s + 404*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 640*C*D1*Ddd*f**2*s**2 - 344*C*D1*Ddd*f**2*s + 160*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 1920*C*Dd**2*f**2*s**2 - 1032*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 15*D1**2*bdd1*f*(2*C - 3)*(2*s**2 - 2*s + 1) + 184*D1**2*f*fd*r*s - 92*D1**2*f*fd*r + 196*D1**2*f*fd*s**2 - 376*D1**2*f*fd*s + 188*D1**2*f*fd - 112*D1**2*f*fdd*r*s + 56*D1**2*f*fdd*r - 134*D1**2*f*fdd*s**2 + 224*D1**2*f*fdd*s - 112*D1**2*f*fdd - 112*D1**2*fd**2*r*s + 56*D1**2*fd**2*r - 134*D1**2*fd**2*s**2 + 224*D1**2*fd**2*s + 368*D1*Dd*f**2*r*s - 92*D1*Dd*f**2*r + 392*D1*Dd*f**2*s**2 - 288*D1*Dd*f**2*s + 98*D1*Dd*f**2 - 896*D1*Dd*f*fd*r*s + 336*D1*Dd*f*fd*r - 1072*D1*Dd*f*fd*s**2 + 1276*D1*Dd*f*fd*s - 280*D1*Dd*f*fd - 224*D1*Ddd*f**2*r*s + 56*D1*Ddd*f**2*r - 268*D1*Ddd*f**2*s**2 + 190*D1*Ddd*f**2*s - 67*D1*Ddd*f**2 + 30*D1*bd1*(2*C - 3)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 672*Dd**2*f**2*r*s + 168*Dd**2*f**2*r - 804*Dd**2*f**2*s**2 + 570*Dd**2*f**2*s - 56*Dd**2*f**2) + f*(-990*D1**2*bd1**2*s*(2*C - 3)*(s - 1) + 33*D1**2*bdd1*f*(2*C*(80*s**2 + s*(12*r + 18) - 15) - 67*s**2 - s*(56*r + 34) + 45) - 2*D1**2*(f*(2*fd*(C*(264*r*(3*s - 1) + 7035*s**2 - 4954*s + 2345) - 610*r*(3*s - 1) - 4137*s**2 + 3368*s - 1379) + fdd*(C*(-396*r*(3*s - 1) - 7629*s**2 + 5482*s - 2543) + 940*r*(3*s - 1) + 5028*s**2 - 4292*s + 1676)) - 2*fd**2*(C*(396*r*(3*s - 1) + 7629*s**2 - 5482*s + 198) - 940*r*(3*s - 1) - 5028*s**2 + 4292*s - 470)) - 66*D1*bd1*(D1*(f*(2*C*(74*s**2 + s*(10*r + 20) - 15) - 46*r*s - 49*s**2 - 44*s + 45) - 2*fd*(C*(24*r*s - 6*r + 160*s**2 - 77*s + 6) - 56*r*s + 14*r - 67*s**2 + 39*s - 14)) + Dd*f*(-2*C*(6*r*(8*s - 1) + 320*s**2 - 50*s - 9) + 28*r*(8*s - 1) + 268*s**2 - 27*s - 17)) - 2*D1*f*(2*Dd*(f*(C*(264*r*(4*s - 1) + 9380*s**2 - 4954*s + 2345) - 610*r*(4*s - 1) - 5516*s**2 + 3368*s - 1379) + fd*(C*(-198*r*(24*s - 7) - 30516*s**2 + 19187*s - 2939) + 470*r*(24*s - 7) + 20112*s**2 - 15022*s + 2616)) + Ddd*f*(C*(-396*r*(4*s - 1) - 10172*s**2 + 5482*s - 2543) + 940*r*(4*s - 1) + 6704*s**2 - 4292*s + 1676)) + 4*Dd**2*f**2*(3*C*(198*r*(4*s - 1) + 5086*s**2 - 2741*s + 66) - 1410*r*(4*s - 1) - 10056*s**2 + 6438*s - 470)))/(693*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**3*k1*(-33*b1**2*(D1**2*s*(fd*r*(112*C - 188) + fd*s*(296*C - 302) + fdd*r*(108 - 56*C) + fdd*s*(221 - 204*C)) + D1*(2*Dd*(f*(4*C*(56*r*s - 14*r + 148*s**2 - 88*s + 37) - 376*r*s + 94*r - 604*s**2 + 396*s - 151) + fd*(r*(54 - 28*C)*(8*s - 1) + s*(-816*C*s + 232*C + 884*s - 275))) + Ddd*f*(-4*C*(14*r*(4*s - 1) + 204*s**2 - 116*s + 51) + 108*r*(4*s - 1) + 884*s**2 - 550*s + 221)) - 2*Dd**2*f*(4*C*(21*r*(4*s - 1) + 306*s**2 - 174*s + 7) - 162*r*(4*s - 1) - 1326*s**2 + 825*s - 54)) - 33*b1*(32*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r + 16*C*D1**2*f*fd*s**2 + 368*C*D1**2*f*fd*s - 240*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r - 8*C*D1**2*f*fdd*s**2 - 280*C*D1**2*f*fdd*s + 168*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r - 8*C*D1**2*fd**2*s**2 - 280*C*D1**2*fd**2*s + 64*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*r + 32*C*D1*Dd*f**2*s**2 - 32*C*D1*Dd*f**2*s + 8*C*D1*Dd*f**2 - 128*C*D1*Dd*f*fd*r*s - 176*C*D1*Dd*f*fd*r - 64*C*D1*Dd*f*fd*s**2 - 1088*C*D1*Dd*f*fd*s + 328*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r*s + 8*C*D1*Ddd*f**2*r - 16*C*D1*Ddd*f**2*s**2 + 16*C*D1*Ddd*f**2*s - 4*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r*s + 24*C*Dd**2*f**2*r - 48*C*Dd**2*f**2*s**2 + 48*C*Dd**2*f**2*s - 8*C*Dd**2*f**2 + D1**2*bdd1*f*(-4*C*(14*r*(2*s - 1) + 102*s**2 - 116*s + 51) + 108*r*(2*s - 1) + 442*s**2 - 550*s + 221) - 240*D1**2*f*fd*r*s - 72*D1**2*f*fd*r - 620*D1**2*f*fd*s**2 + 304*D1**2*f*fd*s - 56*D1**2*f*fd + 216*D1**2*f*fdd*r*s + 454*D1**2*f*fdd*s**2 - 188*D1**2*f*fdd*s + 40*D1**2*f*fdd + 216*D1**2*fd**2*r*s + 454*D1**2*fd**2*s**2 - 188*D1**2*fd**2*s - 480*D1*Dd*f**2*r*s + 120*D1*Dd*f**2*r - 1240*D1*Dd*f**2*s**2 + 740*D1*Dd*f**2*s - 310*D1*Dd*f**2 + 1728*D1*Dd*f*fd*r*s - 216*D1*Dd*f*fd*r + 3632*D1*Dd*f*fd*s**2 - 1876*D1*Dd*f*fd*s + 188*D1*Dd*f*fd + 432*D1*Ddd*f**2*r*s - 108*D1*Ddd*f**2*r + 908*D1*Ddd*f**2*s**2 - 562*D1*Ddd*f**2*s + 227*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(4*C*(28*r*s - 14*r + 74*s**2 - 88*s + 37) - 188*r*s + 94*r - 302*s**2 + 396*s - 151) + fd*(r*(54 - 28*C)*(4*s - 1) + s*(-408*C*s + 232*C + 442*s - 275))) + Dd*f*(-4*C*(14*r*(8*s - 3) + 408*s**2 - 348*s + 65) + 108*r*(8*s - 3) + 1768*s**2 - 1650*s + 329)) + 1296*Dd**2*f**2*r*s - 324*Dd**2*f**2*r + 2724*Dd**2*f**2*s**2 - 1686*Dd**2*f**2*s + 108*Dd**2*f**2) + f*(66*D1**2*bd1**2*(4*C*(7*r*(2*s - 1) + 51*s**2 - 58*s + 7) - 54*r*(2*s - 1) - 221*s**2 + 275*s - 54) + 33*D1**2*bdd1*f*(4*C*(2*r*(s - 7) + s**2 - 74*s + 43) - 108*r*(s - 1) - 227*s**2 + 374*s - 187) + 5*D1**2*(f*(2*fd*(4*C*(76*r*(3*s - 1) + 495*s**2 - 406*s + 165) - 594*r*s + 198*r + 465*s**2 - 112*s + 155) - fdd*(4*C*(76*r*(3*s - 1) + 693*s**2 - 538*s + 231) + 663*s**2 - 442*s + 221)) - 2*fd**2*(4*C*(76*r*(3*s - 1) + 693*s**2 - 538*s + 38) + 221*s*(3*s - 2))) - 66*D1*bd1*(D1*(f*(4*C*(2*r*(s - 7) + s**2 - 50*s + 31) + r*(96 - 60*s) - 155*s**2 + 218*s - 127) + 2*fd*(-2*C*(4*r*(s - 2) + 2*s**2 - 39*s + 1) + 54*r*(2*s - 1) + 227*s**2 - 234*s + 27)) + Dd*f*(-4*C*(r*(8*s - 29) + 4*s**2 - 150*s + 44) + 54*r*(8*s - 5) + 908*s**2 - 1029*s + 241)) + 5*D1*f*(-4*C*Ddd*f*(76*r*(4*s - 1) + 924*s**2 - 538*s + 231) + 2*Dd*f*(4*C*(76*r*(4*s - 1) + 660*s**2 - 406*s + 165) - 792*r*s + 198*r + 620*s**2 - 112*s + 155) - 2*Dd*fd*(4*C*(38*r*(24*s - 7) + 2772*s**2 - 1883*s + 307) + 2652*s**2 - 1547*s + 221) - 221*Ddd*f*(4*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(4*C*(114*r*(4*s - 1) + 1386*s**2 - 807*s + 38) + 663*s*(2*s - 1))))/(693*d**2*k3**2) + D1**2*Pk1*Pkd2*ct**3*k1*st**2*(-429*b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 6*fd*(s - 1)**2 - 3*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(-5*fd*(8*s**2 - 6*s + 1) + 12*s**2 - 6*s + 3) - 3*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 3)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 3)*(2*s - 1)) - 13*b1*(D1**2*(10*f**2*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + f*(-500*fd**2*s*(3*s - 2) - 66*fd*(s**2*(20*bd1 - 6) + s*(6 - 10*bd1) - 3) - 99*fdd*(2*s**2 - 2*s + 1) - 99*s**2*(-4*bd1 + 2*bdd1)) - 198*fd*s*(2*bd1 + fd)*(s - 1)) + D1*f*(2*Dd*(250*f**2*(4*s**2 - 2*s + 1) + f*(-250*fd*(12*s**2 - 7*s + 1) - 33*s**2*(40*bd1 - 12) - 33*s*(6 - 10*bd1) + 99) - (396*s - 99)*(2*bd1*s + fd*(2*s - 1))) - Ddd*f*(250*f + 99)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(250*f + 99)*(2*s - 1)) + f*(D1**2*(2574*bd1*s*(bd1*s + fd*(2*s - 1)) - 25*f**2*(98*fd*(4*s**2 - 2*s + 1) - 49*fdd*(4*s**2 - 2*s + 1) + s**2*(260*bd1 - 130*bdd1)) + f*s*(4290*bd1**2*s + 26*bd1*(250*fd*(3*s - 1) - 99*s) + 1287*bdd1*s + 7350*fd**2*(2*s - 1))) + D1*f*(2574*Dd*bd1*s*(4*s - 1) - 2450*Dd*f**2*(4*s**2 - 2*s + 1) + 50*Dd*f*(4*s - 1)*(130*bd1*s + 49*fd*(4*s - 1)) + 1225*Ddd*f**2*(4*s**2 - 2*s + 1)) + 7350*Dd**2*f**3*s*(2*s - 1)))/(1001*d**2*k2**2) - D1**2*Pk1*Pkd2*ct**3*k1*(165*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(6*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 28) + s*(6*fd - 14) + 7) - D1*Ddd*(6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(6*f + 7)*(2*s - 1)) + 33*b1**2*(-5*D1**2*bdd1*(6*f + 7)*(3*s**2 - 2*s + 1) + 32*D1**2*f*fd*s**2 + 168*D1**2*f*fd*s - 84*D1**2*f*fd - 16*D1**2*f*fdd*s**2 - 84*D1**2*f*fdd*s + 42*D1**2*f*fdd - 16*D1**2*fd**2*s**2 - 84*D1**2*fd**2*s - 34*D1**2*fd*s**2 + 188*D1**2*fd*s - 94*D1**2*fd + 17*D1**2*fdd*s**2 - 94*D1**2*fdd*s + 47*D1**2*fdd + 64*D1*Dd*f**2*s**2 - 32*D1*Dd*f**2*s + 16*D1*Dd*f**2 - 128*D1*Dd*f*fd*s**2 - 304*D1*Dd*f*fd*s + 84*D1*Dd*f*fd - 136*D1*Dd*f*s**2 + 68*D1*Dd*f*s - 34*D1*Dd*f + 136*D1*Dd*fd*s**2 - 410*D1*Dd*fd*s + 94*D1*Dd*fd - 32*D1*Ddd*f**2*s**2 + 16*D1*Ddd*f**2*s - 8*D1*Ddd*f**2 + 68*D1*Ddd*f*s**2 - 34*D1*Ddd*f*s + 17*D1*Ddd*f + 10*D1*bd1*(D1*(6*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 21) + s*(6*fd - 14) + 7) - Dd*(6*f + 7)*(12*s**2 - 7*s + 1)) - 96*Dd**2*f**2*s**2 + 48*Dd**2*f**2*s + 204*Dd**2*f*s**2 - 102*Dd**2*f*s) - 2*b1*(165*D1**2*bd1**2*s*(6*f + 7)*(3*s - 2) + 33*D1**2*bdd1*f*(f*(8*s**2 - 50*s + 25) - 17*s**2 - 30*s + 15) + 15*D1**2*(7*f**2*(2*fd - fdd)*(23*s**2 - 22*s + 11) - 2*f*(7*fd**2*s*(23*s - 22) - 44*fd*(2*s**2 - 2*s + 1) + 22*fdd*(2*s**2 - 2*s + 1)) - 88*fd**2*s*(s - 1)) - 66*D1*bd1*(D1*(f**2*(8*s**2 - 50*s + 25) + f*(-s**2*(16*fd + 17) + s*(8*fd - 30) + 15) + fd*s*(17*s - 32)) - Dd*f*(4*s - 1)*(f*(8*s - 25) - 17*s - 15)) + 5*D1*f*(2*Dd*(161*f**2*(4*s**2 - 2*s + 1) - 21*f*fd*(92*s**2 - 67*s + 11) + 132*f*(4*s**2 - 2*s + 1) - 132*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(161*f + 132)*(4*s**2 - 2*s + 1)) - 30*Dd**2*f**2*s*(161*f + 132)*(2*s - 1)) - 2*f*(33*D1**2*bd1**2*s*(f*(8*s - 50) - 17*s - 30) + 10*D1*bd1*(D1*(7*f**2*(23*s**2 + 20*s - 10) + 3*f*s*(-161*fd*s + 7*fd + 44*s) + 132*fd*s*(1 - 2*s)) - Dd*f*(4*s - 1)*(7*f*(23*s + 10) + 132*s)) - 5*f*(D1**2*bdd1*(7*f*(23*s**2 + 20*s - 10) + 132*s**2) - 98*D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) - 98*D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) - 588*Dd**2*f**2*s*(1 - 2*s))))/(693*d**2*k2**2) - 4*D1**2*Pk1*Pkd2*ct**3*k2**4*st**2*(D1*f*(-D1*bd1**2*(2*s - 1)*(r + s - 1) + bd1*(D1*(f*(s - 2)*(r + s - 1) + fd*(-4*r*s + 2*r - 4*s**2 + 5*s - 1)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 11*s - 3)) - f*(D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1))) + b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + b1*(-D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + 2*D1**2*f*fd*r*s + D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - D1**2*f*fd - 2*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*s**2 + D1**2*f*fdd*s - 2*D1**2*fd**2*r*s - 2*D1**2*fd**2*s**2 + D1**2*fd**2*s + 4*D1*Dd*f**2*r*s - D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 3*D1*Dd*f**2*s + D1*Dd*f**2 - 16*D1*Dd*f*fd*r*s + 2*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 10*D1*Dd*f*fd*s - D1*Dd*f*fd - 4*D1*Ddd*f**2*r*s + D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 3*D1*Ddd*f**2*s - D1*Ddd*f**2 + D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 12*Dd**2*f**2*r*s + 3*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 9*Dd**2*f**2*s - Dd**2*f**2))/(7*d**2*k1*k3**4) + D1**2*Pk1*Pkd2*ct**3*k2**2*st**2*(33*b1**2*(D1**2*s*(fd*(r*(4*C - 4) - 6*s) + 3*fdd*(r*(4*C - 4) + s)) + D1*(2*Dd*(f*(-2*C*s + r*(2*C - 2)*(4*s - 1) - 12*s**2 + 8*s - 3) + 3*fd*(r*(2*C - 2)*(8*s - 1) + s*(-2*C + 4*s + 1))) + 3*Ddd*f*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 4*s**2 + 2*s + 1)) + 6*Dd**2*f*(C*(24*r*s - 6*r - 6*s + 2) - 24*r*s + 6*r + 6*s**2 + 3*s - 2)) + 33*b1*(8*C*D1**2*f*fd*r*s - 24*C*D1**2*f*fd*r + 20*C*D1**2*f*fd*s + 24*C*D1**2*f*fdd*r*s - 12*C*D1**2*f*fdd*s + 24*C*D1**2*fd**2*r*s - 12*C*D1**2*fd**2*s + 16*C*D1*Dd*f**2*r*s - 4*C*D1*Dd*f**2*r - 4*C*D1*Dd*f**2*s + 192*C*D1*Dd*f*fd*r*s - 24*C*D1*Dd*f*fd*r - 72*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r - 12*C*D1*Ddd*f**2*s + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r - 36*C*Dd**2*f**2*s + 12*C*Dd**2*f**2 + 3*D1**2*bdd1*f*(-4*C*s + r*(4*C - 4)*(2*s - 1) + 2*s**2 + 2*s + 1) + 24*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 88*D1**2*f*fd*s**2 - 120*D1**2*f*fd*s + 50*D1**2*f*fd - 40*D1**2*f*fdd*r*s + 8*D1**2*f*fdd*r - 68*D1**2*f*fdd*s**2 + 86*D1**2*f*fdd*s - 37*D1**2*f*fdd - 40*D1**2*fd**2*r*s + 8*D1**2*fd**2*r - 68*D1**2*fd**2*s**2 + 86*D1**2*fd**2*s + 48*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 176*D1*Dd*f**2*s**2 - 100*D1*Dd*f**2*s + 44*D1*Dd*f**2 - 320*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*r - 544*D1*Dd*f*fd*s**2 + 520*D1*Dd*f*fd*s - 94*D1*Dd*f*fd - 80*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 136*D1*Ddd*f**2*s**2 + 88*D1*Ddd*f**2*s - 34*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(-2*C*s + r*(2*C - 2)*(2*s - 1) - 6*s**2 + 8*s - 3) + 3*fd*(r*(2*C - 2)*(4*s - 1) + s*(-2*C + 2*s + 1))) + 3*Dd*f*(4*C*(8*r*s - 3*r - 3*s + 1) - 32*r*s + 12*r + 8*s**2 + 6*s - 3)) - 240*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 408*Dd**2*f**2*s**2 + 264*Dd**2*f**2*s - 20*Dd**2*f**2) + f*(2712*C*D1**2*f*fd*r*s - 904*C*D1**2*f*fd*r - 904*C*D1**2*f*fd*s - 960*C*D1**2*f*fdd*r*s + 320*C*D1**2*f*fdd*r + 320*C*D1**2*f*fdd*s - 1920*C*D1**2*fd**2*r*s + 640*C*D1**2*fd**2*r + 640*C*D1**2*fd**2*s - 320*C*D1**2*fd**2 + 3616*C*D1*Dd*f**2*r*s - 904*C*D1*Dd*f**2*r - 904*C*D1*Dd*f**2*s - 7680*C*D1*Dd*f*fd*r*s + 2240*C*D1*Dd*f*fd*r + 2240*C*D1*Dd*f*fd*s - 640*C*D1*Dd*f*fd - 1280*C*D1*Ddd*f**2*r*s + 320*C*D1*Ddd*f**2*r + 320*C*D1*Ddd*f**2*s - 3840*C*Dd**2*f**2*r*s + 960*C*Dd**2*f**2*r + 960*C*Dd**2*f**2*s - 320*C*Dd**2*f**2 + 198*D1**2*bd1**2*(C*(4*r*s - 2*r - 2*s + 2) - 4*r*s + 2*r + s**2 + s - 2) + 33*D1**2*bdd1*f*(4*r*(3*C*(s - 1) - 5*s + 3) - 34*s**2 + 2*s + 3) - 636*D1**2*f*fd*r*s + 212*D1**2*f*fd*r + 4470*D1**2*f*fd*s**2 - 2768*D1**2*f*fd*s + 1490*D1**2*f*fd - 1464*D1**2*f*fdd*r*s + 488*D1**2*f*fdd*r - 3423*D1**2*f*fdd*s**2 + 2770*D1**2*f*fdd*s - 1141*D1**2*f*fdd - 2928*D1**2*fd**2*r*s + 976*D1**2*fd**2*r - 6846*D1**2*fd**2*s**2 + 5540*D1**2*fd**2*s - 488*D1**2*fd**2 - 848*D1*Dd*f**2*r*s + 212*D1*Dd*f**2*r + 5960*D1*Dd*f**2*s**2 - 2768*D1*Dd*f**2*s + 1490*D1*Dd*f**2 - 11712*D1*Dd*f*fd*r*s + 3416*D1*Dd*f*fd*r - 27384*D1*Dd*f*fd*s**2 + 19390*D1*Dd*f*fd*s - 3258*D1*Dd*f*fd - 1952*D1*Ddd*f**2*r*s + 488*D1*Ddd*f**2*r - 4564*D1*Ddd*f**2*s**2 + 2770*D1*Ddd*f**2*s - 1141*D1*Ddd*f**2 + 66*D1*bd1*(D1*(f*(-12*C*s + 2*r*(C*(s + 5) + 3*s - 5) + 22*s**2 + 10*s - 3) + fd*(6*C*(4*r*s - 2*r - s + 1) - 40*r*s + 16*r - 68*s**2 + 45*s - 10)) + Dd*f*(6*C*(8*r*s - 5*r - s + 1) - 80*r*s + 34*r - 136*s**2 + 48*s - 7)) - 5856*Dd**2*f**2*r*s + 1464*Dd**2*f**2*r - 13692*Dd**2*f**2*s**2 + 8310*Dd**2*f**2*s - 488*Dd**2*f**2))/(693*d**2*k1*k3**2) + D1**2*Pk1*Pkd2*ct**3*k2**2*(-2*D1*f*(D1*bd1**2*(r*(4*s - 2) + 47*s**2 - 49*s + 2) - 2*bd1*(D1*(2*f*(8*C*r*(s - 1) - 3*r*s + 4*s**2 - 5*s + 4) + fd*(C*(-8*r*s + 4*r + 2*s - 2) - 12*r*s + 6*r - 40*s**2 + 43*s - 3)) + Dd*f*(-2*C*(8*r*s - 5*r - s + 1) - 24*r*s + 15*r - 80*s**2 + 103*s - 23)) + 2*f*(D1*bdd1*(s - 1)*(r*(2*C + 3) + 10*s - 10) + 5*D1*fd*(3*r*s - r - s) + 5*Dd*f*(4*r*s - r - s))) + b1**2*(D1**2*s*(56*C*fd*r - 20*fd*r + 38*fd*s - 4*fdd*r - 47*fdd*s) + D1*(2*Dd*(f*(r*(28*C - 10)*(4*s - 1) + 76*s**2 - s*(28*C + 28) + 19) + fd*(r*(2 - 16*s) + s*(49 - 188*s))) + Ddd*f*(r*(4 - 16*s) - 188*s**2 + 98*s - 47)) - 2*Dd**2*f*(6*r*(4*s - 1) + 282*s**2 - 147*s + 2)) + b1*(D1**2*bdd1*f*(r*(4 - 8*s) - 94*s**2 + 98*s - 47) + 4*D1**2*(f*(2*fd*(r*(16*C*s - 6*s + 3) + 8*s*(-C + s)) + fdd*s*(C*(2 - 4*r) - 6*r - 20*s + 3)) + fd**2*s*(C*(2 - 4*r) - 6*r - 20*s + 3)) + 2*D1*bd1*(D1*(f*(r*(28*C - 10)*(2*s - 1) + 38*s**2 - s*(28*C + 28) + 19) + fd*(r*(2 - 8*s) + s*(49 - 94*s))) + Dd*f*(-4*r*(8*s - 3) - 376*s**2 + 294*s - 51)) + 4*D1*f*(Dd*(2*f*(-8*C*s + r*(8*C - 3)*(4*s - 1) + 16*s**2 - 5*s + 4) + fd*(C*(-32*r*s + 4*r + 12*s - 2) - 48*r*s + 6*r - 160*s**2 + 58*s - 3)) + Ddd*f*(2*C*s - r*(2*C + 3)*(4*s - 1) - 40*s**2 + 23*s - 10)) + 4*Dd**2*f**2*(C*(-24*r*s + 6*r + 6*s - 2) - 36*r*s + 9*r - 120*s**2 + 69*s - 3)))/(21*d**2*k1*k3**2) - D1**2*Pk1*Pkd2*ct**3*st**2*(-2574*D1**2*K*bdd1*f**2*r*s - 858*D1**2*bd1**2*f*s*(K*(6*r - 3) + 25*f*(2*s - 1) - 6*r + 15*s + 3) + 6240*D1**2*bdd1*f**3*r*s + 7345*D1**2*bdd1*f**3*s**2 + 12090*D1**2*bdd1*f**3*s - 8125*D1**2*bdd1*f**3 + 2574*D1**2*bdd1*f**2*r*s - 6435*D1**2*bdd1*f**2*s**2 + 5148*D1**2*bdd1*f*g2*r*s - 5148*D1**2*bdd1*f*g2*s - 9600*D1**2*f**3*fd*r*s + 2400*D1**2*f**3*fd*r - 117000*D1**2*f**3*fd*s**2 + 60900*D1**2*f**3*fd*s - 29250*D1**2*f**3*fd + 25600*D1**2*f**3*fdd*r*s - 6400*D1**2*f**3*fdd*r + 71500*D1**2*f**3*fdd*s**2 - 42150*D1**2*f**3*fdd*s + 17875*D1**2*f**3*fdd + 76800*D1**2*f**2*fd**2*r*s - 19200*D1**2*f**2*fd**2*r + 214500*D1**2*f**2*fd**2*s**2 - 126450*D1**2*f**2*fd**2*s + 6400*D1**2*f**2*fd**2 - 8580*D1**2*f**2*gd2*r*s + 5148*D1**2*f**2*gdd2*r*s - 17160*D1**2*f*fd*g2*r*s + 8580*D1**2*f*fd*g2*r + 8580*D1**2*f*fd*g2*s + 20592*D1**2*f*fd*gd2*r*s - 5148*D1**2*f*fd*gd2*r - 5148*D1**2*f*fd*gd2*s + 10296*D1**2*f*fdd*g2*r*s - 5148*D1**2*f*fdd*g2*r - 5148*D1**2*f*fdd*g2*s + 10296*D1**2*fd**2*g2*r*s - 5148*D1**2*fd**2*g2*r - 5148*D1**2*fd**2*g2*s + 5148*D1**2*fd**2*g2 - 9600*D1*Dd*f**4*r*s + 2400*D1*Dd*f**4*r - 117000*D1*Dd*f**4*s**2 + 60900*D1*Dd*f**4*s - 29250*D1*Dd*f**4 + 204800*D1*Dd*f**3*fd*r*s - 51200*D1*Dd*f**3*fd*r + 572000*D1*Dd*f**3*fd*s**2 - 337200*D1*Dd*f**3*fd*s + 48550*D1*Dd*f**3*fd - 34320*D1*Dd*f**2*g2*r*s + 8580*D1*Dd*f**2*g2*r + 8580*D1*Dd*f**2*g2*s + 41184*D1*Dd*f**2*gd2*r*s - 5148*D1*Dd*f**2*gd2*r - 5148*D1*Dd*f**2*gd2*s + 82368*D1*Dd*f*fd*g2*r*s - 30888*D1*Dd*f*fd*g2*r - 30888*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 + 25600*D1*Ddd*f**4*r*s - 6400*D1*Ddd*f**4*r + 71500*D1*Ddd*f**4*s**2 - 42150*D1*Ddd*f**4*s + 17875*D1*Ddd*f**4 + 20592*D1*Ddd*f**2*g2*r*s - 5148*D1*Ddd*f**2*g2*r - 5148*D1*Ddd*f**2*g2*s - 26*D1*bd1*(D1*(f**3*(235*s**2 + s*(84*r + 1194) - 625) - 5*f**2*(fd*(48*r*(6*s - 1) + 339*s**2 + 25*s + 32) + 33*s*(r*(K - 1) + 3*s)) + 33*f*(3*fd*(r*(K - 1)*(4*s - 1) + s*(-K + 10*s - 4)) + s*(-2*g2*r + 2*g2 - 12*gd2*r + 6*gd2)) - 198*fd*g2*(r*(2*s - 1) - s + 1)) - Dd*f*(5*f**2*(48*r*(8*s - 1) + 452*s**2 + 211*s - 93) - 99*f*(r*(K - 1)*(8*s - 1) + s*(-K + 20*s - 4)) + 198*g2*(r*(8*s - 1) - 5*s + 1))) + 76800*Dd**2*f**4*r*s - 19200*Dd**2*f**4*r + 214500*Dd**2*f**4*s**2 - 126450*Dd**2*f**4*s + 6400*Dd**2*f**4 + 61776*Dd**2*f**2*g2*r*s - 15444*Dd**2*f**2*g2*r - 15444*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 429*b1**2*(D1**2*(50*f*fd*(4*s**2 - 2*s + 1) - 50*fd**2*s*(2*s - 1) - 2*fd*(s - 1)*(r*(K - 1) - 15*s + 15) - fdd*(25*f*(4*s**2 - 2*s + 1) + (3*s - 3)*(2*K*r - 2*r + 5*s - 5))) + D1*(2*Dd*(50*f**2*(4*s**2 - 2*s + 1) + f*(K*s - 25*fd*(1 - 4*s)**2 + r*(-4*K*s + K + 4*s - 1) + 60*s**2 - 31*s + 15) - 3*fd*(K*r*(8*s - 5) - K*s + K - 8*r*s + 5*r + 20*s**2 - 24*s + 4)) + Ddd*f*(6*K*s - 50*f*(4*s**2 - 2*s + 1) - r*(6*K - 6)*(4*s - 1) - 60*s**2 + 24*s - 15)) - 6*Dd**2*f*(3*K*r*(4*s - 1) - 3*K*s + K + 100*f*s**2 - 50*f*s + r*(3 - 12*s) + 30*s**2 - 12*s - 1)) + 13*b1*(660*D1**2*K*f*fd*r*s - 330*D1**2*K*f*fd*r - 330*D1**2*K*f*fd*s - 396*D1**2*K*f*fdd*r*s + 198*D1**2*K*f*fdd*r + 198*D1**2*K*f*fdd*s - 396*D1**2*K*fd**2*r*s + 198*D1**2*K*fd**2*r + 198*D1**2*K*fd**2*s - 198*D1**2*K*fd**2 - 33*D1**2*bdd1*f*(25*f*(4*s**2 - 2*s + 1) + 6*s*(K*(2*r - 1) - 2*r + 5*s + 1)) - 504*D1**2*f**2*fd*r*s + 168*D1**2*f**2*fd*r - 1410*D1**2*f**2*fd*s**2 + 3496*D1**2*f**2*fd*s - 1720*D1**2*f**2*fd + 1440*D1**2*f**2*fdd*r*s - 480*D1**2*f**2*fdd*r + 1695*D1**2*f**2*fdd*s**2 - 2540*D1**2*f**2*fdd*s + 1190*D1**2*f**2*fdd + 2880*D1**2*f*fd**2*r*s - 960*D1**2*f*fd**2*r + 3390*D1**2*f*fd**2*s**2 - 5080*D1**2*f*fd**2*s + 160*D1**2*f*fd**2 - 660*D1**2*f*fd*r*s + 330*D1**2*f*fd*r + 1980*D1**2*f*fd*s**2 - 1650*D1**2*f*fd*s + 990*D1**2*f*fd + 396*D1**2*f*fdd*r*s - 198*D1**2*f*fdd*r - 990*D1**2*f*fdd*s**2 + 792*D1**2*f*fdd*s - 495*D1**2*f*fdd + 132*D1**2*f*gd2*r*s + 396*D1**2*f*gdd2*r*s + 396*D1**2*fd**2*r*s - 198*D1**2*fd**2*r - 990*D1**2*fd**2*s**2 + 792*D1**2*fd**2*s + 198*D1**2*fd**2 + 132*D1**2*fd*g2*r*s - 132*D1**2*fd*g2*r + 792*D1**2*fd*gd2*r*s - 396*D1**2*fd*gd2*r + 396*D1**2*fdd*g2*r*s - 396*D1**2*fdd*g2*r + 1320*D1*Dd*K*f**2*r*s - 330*D1*Dd*K*f**2*r - 330*D1*Dd*K*f**2*s - 3168*D1*Dd*K*f*fd*r*s + 1188*D1*Dd*K*f*fd*r + 1188*D1*Dd*K*f*fd*s - 396*D1*Dd*K*f*fd - 672*D1*Dd*f**3*r*s + 168*D1*Dd*f**3*r - 1880*D1*Dd*f**3*s**2 + 1108*D1*Dd*f**3*s - 470*D1*Dd*f**3 + 11520*D1*Dd*f**2*fd*r*s - 3360*D1*Dd*f**2*fd*r + 13560*D1*Dd*f**2*fd*s**2 - 14990*D1*Dd*f**2*fd*s + 3020*D1*Dd*f**2*fd - 1320*D1*Dd*f**2*r*s + 330*D1*Dd*f**2*r + 3960*D1*Dd*f**2*s**2 - 1650*D1*Dd*f**2*s + 990*D1*Dd*f**2 + 3168*D1*Dd*f*fd*r*s - 1188*D1*Dd*f*fd*r - 7920*D1*Dd*f*fd*s**2 + 4752*D1*Dd*f*fd*s - 594*D1*Dd*f*fd + 528*D1*Dd*f*g2*r*s - 132*D1*Dd*f*g2*r - 132*D1*Dd*f*g2*s + 3168*D1*Dd*f*gd2*r*s - 396*D1*Dd*f*gd2*r - 396*D1*Dd*f*gd2*s + 3168*D1*Dd*fd*g2*r*s - 1980*D1*Dd*fd*g2*r - 396*D1*Dd*fd*g2*s + 396*D1*Dd*fd*g2 - 792*D1*Ddd*K*f**2*r*s + 198*D1*Ddd*K*f**2*r + 198*D1*Ddd*K*f**2*s + 1920*D1*Ddd*f**3*r*s - 480*D1*Ddd*f**3*r + 2260*D1*Ddd*f**3*s**2 - 1610*D1*Ddd*f**3*s + 565*D1*Ddd*f**3 + 792*D1*Ddd*f**2*r*s - 198*D1*Ddd*f**2*r - 1980*D1*Ddd*f**2*s**2 + 792*D1*Ddd*f**2*s - 495*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r*s - 396*D1*Ddd*f*g2*r - 396*D1*Ddd*f*g2*s + 66*D1*bd1*(D1*(25*f**2*(4*s**2 - 2*s + 1) + f*s*(-2*K*r + K - 100*fd*(2*s - 1) + 2*r + 30*s - 1) + 3*fd*(K*(-4*r*s + 2*r + s - 1) + 4*r*s - 2*r - 10*s**2 + 9*s + 1)) + Dd*f*(-6*K*r*(8*s - 1) + 18*K*s - 3*K - 25*f*(1 - 4*s)**2 - 3*r*(2 - 16*s) - 120*s**2 + 12*s + 3)) - 2376*Dd**2*K*f**2*r*s + 594*Dd**2*K*f**2*r + 594*Dd**2*K*f**2*s - 198*Dd**2*K*f**2 + 5760*Dd**2*f**3*r*s - 1440*Dd**2*f**3*r + 6780*Dd**2*f**3*s**2 - 4830*Dd**2*f**3*s + 480*Dd**2*f**3 + 2376*Dd**2*f**2*r*s - 594*Dd**2*f**2*r - 5940*Dd**2*f**2*s**2 + 2376*Dd**2*f**2*s + 198*Dd**2*f**2 + 4752*Dd**2*f*g2*r*s - 1188*Dd**2*f*g2*r - 1188*Dd**2*f*g2*s + 396*Dd**2*f*g2))/(9009*d**2*k1) - D1**2*Pk1*Pkd2*ct**3*(132*D1**2*K*bdd1*f**2*r*s - 528*D1**2*b2*f*fd*r*s + 264*D1**2*b2*f*fd*r + 264*D1**2*b2*f*fd*s + 264*D1**2*b2*f*fdd*r*s - 132*D1**2*b2*f*fdd*r - 132*D1**2*b2*f*fdd*s + 264*D1**2*b2*fd**2*r*s - 132*D1**2*b2*fd**2*r - 132*D1**2*b2*fd**2*s + 132*D1**2*b2*fd**2 + 66*D1**2*bd1**2*f*(f*(2*r*(8*s - 3) + 79*s**2 - 43*s + 4) + r*(2 - 2*K)*(2*s - 1) + s*(41*s + 6)) - 264*D1**2*bd2*f**2*r*s + 528*D1**2*bd2*f*fd*r*s - 132*D1**2*bd2*f*fd*r - 132*D1**2*bd2*f*fd*s + 600*D1**2*bdd1*f**3*r*s - 400*D1**2*bdd1*f**3*r + 2310*D1**2*bdd1*f**3*s**2 - 2310*D1**2*bdd1*f**3*s + 1155*D1**2*bdd1*f**3 + 132*D1**2*bdd1*f**2*r*s + 1320*D1**2*bdd1*f**2*s**2 + 264*D1**2*bdd1*f*g2*r*s - 264*D1**2*bdd1*f*g2*r + 132*D1**2*bdd2*f**2*r*s + 2112*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gdd2*r*s + 4224*D1**2*f*fd*g2*r*s - 2112*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*gd2*r*s + 264*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s - 264*D1**2*fd**2*g2 - 1056*D1*Dd*b2*f**2*r*s + 264*D1*Dd*b2*f**2*r + 264*D1*Dd*b2*f**2*s + 2112*D1*Dd*b2*f*fd*r*s - 792*D1*Dd*b2*f*fd*r - 792*D1*Dd*b2*f*fd*s + 264*D1*Dd*b2*f*fd + 1056*D1*Dd*bd2*f**2*r*s - 132*D1*Dd*bd2*f**2*r - 132*D1*Dd*bd2*f**2*s + 8448*D1*Dd*f**2*g2*r*s - 2112*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s - 2112*D1*Dd*f**2*gd2*r*s + 264*D1*Dd*f**2*gd2*r + 264*D1*Dd*f**2*gd2*s - 4224*D1*Dd*f*fd*g2*r*s + 1584*D1*Dd*f*fd*g2*r + 1584*D1*Dd*f*fd*g2*s - 528*D1*Dd*f*fd*g2 + 528*D1*Ddd*b2*f**2*r*s - 132*D1*Ddd*b2*f**2*r - 132*D1*Ddd*b2*f**2*s - 1056*D1*Ddd*f**2*g2*r*s + 264*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s - 2*D1*bd1*(D1*(25*f**3*(8*r*(3*s - 2) + 66*s**2 - 66*s + 33) + f**2*(-10*fd*(180*r*s - 70*r + 693*s**2 - 492*s + 20) + 132*s*(4*K*r - 2*r + 7*s)) - 66*f*(fd*r*(K + 1)*(4*s - 1) + fd*s*(-K + 40*s - 21) - 2*g2*(r*(2*s - 9) + 7*s) + 2*gd2*r*(2*s - 1)) - 132*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-5*f**2*(20*r*(24*s - 11) + 1848*s**2 - 1446*s + 271) - 66*f*(r*(K + 1)*(8*s - 1) + s*(-K + 80*s - 21)) - 132*g2*(r*(8*s - 5) - s + 1))) + 1584*Dd**2*b2*f**2*r*s - 396*Dd**2*b2*f**2*r - 396*Dd**2*b2*f**2*s + 132*Dd**2*b2*f**2 - 3168*Dd**2*f**2*g2*r*s + 792*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s - 264*Dd**2*f**2*g2 + 33*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(6*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 28) + s*(6*fd - 14) + 7) - D1*Ddd*(6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(6*f + 7)*(2*s - 1)) + 33*b1**2*(8*D1**2*K*fd*r*s + 28*D1**2*K*fd*r - 36*D1**2*K*fd*s - 4*D1**2*K*fdd*r*s + 4*D1**2*K*fdd*s - D1**2*bdd1*(6*f + 7)*(3*s**2 - 2*s + 1) - 64*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 220*D1**2*f*fd*s**2 + 128*D1**2*f*fd*s - 60*D1**2*f*fd + 32*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 158*D1**2*f*fdd*s**2 - 88*D1**2*f*fdd*s + 42*D1**2*f*fdd + 32*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 158*D1**2*fd**2*s**2 - 88*D1**2*fd**2*s - 8*D1**2*fd*r*s - 28*D1**2*fd*r - 54*D1**2*fd*s**2 + 168*D1**2*fd*s - 66*D1**2*fd + 4*D1**2*fdd*r*s + 41*D1**2*fdd*s**2 - 98*D1**2*fdd*s + 47*D1**2*fdd + 32*D1*Dd*K*f*r*s - 8*D1*Dd*K*f*r - 8*D1*Dd*K*f*s - 32*D1*Dd*K*fd*r*s + 4*D1*Dd*K*fd*r + 20*D1*Dd*K*fd*s - 4*D1*Dd*K*fd - 128*D1*Dd*f**2*r*s + 32*D1*Dd*f**2*r - 440*D1*Dd*f**2*s**2 + 252*D1*Dd*f**2*s - 110*D1*Dd*f**2 + 256*D1*Dd*f*fd*r*s - 48*D1*Dd*f*fd*r + 1264*D1*Dd*f*fd*s**2 - 700*D1*Dd*f*fd*s + 92*D1*Dd*f*fd - 32*D1*Dd*f*r*s + 8*D1*Dd*f*r - 216*D1*Dd*f*s**2 + 116*D1*Dd*f*s - 54*D1*Dd*f + 32*D1*Dd*fd*r*s - 4*D1*Dd*fd*r + 328*D1*Dd*fd*s**2 - 478*D1*Dd*fd*s + 98*D1*Dd*fd - 16*D1*Ddd*K*f*r*s + 4*D1*Ddd*K*f*r + 4*D1*Ddd*K*f*s + 64*D1*Ddd*f**2*r*s - 16*D1*Ddd*f**2*r + 316*D1*Ddd*f**2*s**2 - 174*D1*Ddd*f**2*s + 79*D1*Ddd*f**2 + 16*D1*Ddd*f*r*s - 4*D1*Ddd*f*r + 164*D1*Ddd*f*s**2 - 86*D1*Ddd*f*s + 41*D1*Ddd*f + 2*D1*bd1*(D1*(6*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 21) + s*(6*fd - 14) + 7) - Dd*(6*f + 7)*(12*s**2 - 7*s + 1)) - 48*Dd**2*K*f*r*s + 12*Dd**2*K*f*r + 12*Dd**2*K*f*s - 4*Dd**2*K*f + 192*Dd**2*f**2*r*s - 48*Dd**2*f**2*r + 948*Dd**2*f**2*s**2 - 522*Dd**2*f**2*s + 16*Dd**2*f**2 + 48*Dd**2*f*r*s - 12*Dd**2*f*r + 492*Dd**2*f*s**2 - 258*Dd**2*f*s + 4*Dd**2*f) + b1*(-2112*D1**2*K*f*fd*r*s + 1056*D1**2*K*f*fd*r + 1056*D1**2*K*f*fd*s + 264*D1**2*K*f*fdd*r*s - 132*D1**2*K*f*fdd*r - 132*D1**2*K*f*fdd*s + 264*D1**2*K*fd**2*r*s - 132*D1**2*K*fd**2*r - 132*D1**2*K*fd**2*s + 132*D1**2*K*fd**2 - 66*D1**2*bd1**2*s*(6*f + 7)*(3*s - 2) + 33*D1**2*bdd1*f*(f*(4*r*(8*s - 3) + 158*s**2 - 86*s + 37) - r*(4*K - 4)*(2*s - 1) + 82*s**2 + 12*s - 6) - 3600*D1**2*f**2*fd*r*s + 400*D1**2*f**2*fd*r - 9900*D1**2*f**2*fd*s**2 + 4500*D1**2*f**2*fd*s - 1650*D1**2*f**2*fd + 1800*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 6930*D1**2*f**2*fdd*s**2 - 2910*D1**2*f**2*fdd*s + 1155*D1**2*f**2*fdd + 3600*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 13860*D1**2*f*fd**2*s**2 - 5820*D1**2*f*fd**2*s + 200*D1**2*f*fd**2 + 1056*D1**2*f*fd*r*s - 528*D1**2*f*fd*r - 3696*D1**2*f*fd*s**2 + 3168*D1**2*f*fd*s - 1848*D1**2*f*fd + 264*D1**2*f*fdd*r*s - 132*D1**2*f*fdd*r + 2640*D1**2*f*fdd*s**2 - 2772*D1**2*f*fdd*s + 1320*D1**2*f*fdd - 528*D1**2*f*gd2*r*s + 264*D1**2*f*gdd2*r*s + 264*D1**2*fd**2*r*s - 132*D1**2*fd**2*r + 2640*D1**2*fd**2*s**2 - 2772*D1**2*fd**2*s + 132*D1**2*fd**2 - 528*D1**2*fd*g2*r*s - 1848*D1**2*fd*g2*r + 2376*D1**2*fd*g2*s + 528*D1**2*fd*gd2*r*s - 264*D1**2*fd*gd2*s + 264*D1**2*fdd*g2*r*s - 264*D1**2*fdd*g2*s - 4224*D1*Dd*K*f**2*r*s + 1056*D1*Dd*K*f**2*r + 1056*D1*Dd*K*f**2*s + 2112*D1*Dd*K*f*fd*r*s - 792*D1*Dd*K*f*fd*r - 792*D1*Dd*K*f*fd*s + 264*D1*Dd*K*f*fd - 4800*D1*Dd*f**3*r*s + 1200*D1*Dd*f**3*r - 13200*D1*Dd*f**3*s**2 + 7800*D1*Dd*f**3*s - 3300*D1*Dd*f**3 + 14400*D1*Dd*f**2*fd*r*s - 2600*D1*Dd*f**2*fd*r + 55440*D1*Dd*f**2*fd*s**2 - 27300*D1*Dd*f**2*fd*s + 3110*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*r*s - 528*D1*Dd*f**2*r - 7392*D1*Dd*f**2*s**2 + 3168*D1*Dd*f**2*s - 1848*D1*Dd*f**2 + 2112*D1*Dd*f*fd*r*s - 792*D1*Dd*f*fd*r + 21120*D1*Dd*f*fd*s**2 - 16632*D1*Dd*f*fd*s + 2904*D1*Dd*f*fd - 2112*D1*Dd*f*g2*r*s + 528*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s + 2112*D1*Dd*f*gd2*r*s - 264*D1*Dd*f*gd2*r - 264*D1*Dd*f*gd2*s + 2112*D1*Dd*fd*g2*r*s - 264*D1*Dd*fd*g2*r - 1320*D1*Dd*fd*g2*s + 264*D1*Dd*fd*g2 + 528*D1*Ddd*K*f**2*r*s - 132*D1*Ddd*K*f**2*r - 132*D1*Ddd*K*f**2*s + 2400*D1*Ddd*f**3*r*s - 600*D1*Ddd*f**3*r + 9240*D1*Ddd*f**3*s**2 - 5220*D1*Ddd*f**3*s + 2310*D1*Ddd*f**3 + 528*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 5280*D1*Ddd*f**2*s**2 - 2772*D1*Ddd*f**2*s + 1320*D1*Ddd*f**2 + 1056*D1*Ddd*f*g2*r*s - 264*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2*s - 66*D1*bd1*(D1*(f**2*(4*r*(8*s - 3) + 110*s**2 - 62*s + 25) - 2*f*(7*K*s + fd*(8*r*(4*s - 1) + 158*s**2 - 87*s + 2) + r*(K - 1)*(4*s - 9) - 27*s**2 - 13*s + 3) + 2*fd*(K*r*(4*s - 1) - 2*K*s + K - 4*r*s + r - 41*s**2 + 46*s - 1)) + Dd*f*(4*K*r*(8*s - 3) - 4*K*s + 2*K + f*(-8*r*(16*s - 5) - 632*s**2 + 346*s - 49) + 2*r*(6 - 16*s) - 328*s**2 + 62*s + 4)) + 1584*Dd**2*K*f**2*r*s - 396*Dd**2*K*f**2*r - 396*Dd**2*K*f**2*s + 132*Dd**2*K*f**2 + 7200*Dd**2*f**3*r*s - 1800*Dd**2*f**3*r + 27720*Dd**2*f**3*s**2 - 15660*Dd**2*f**3*s + 600*Dd**2*f**3 + 1584*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 15840*Dd**2*f**2*s**2 - 8316*Dd**2*f**2*s + 132*Dd**2*f**2 + 3168*Dd**2*f*g2*r*s - 792*Dd**2*f*g2*r - 792*Dd**2*f*g2*s + 264*Dd**2*f*g2))/(693*d**2*k1) - 4*D1**2*Pk1*Pkd2*ct**2*f*k1**2*k2*st**4*(D1**2*(f*(11*bd1*s*(r + s - 1) - fd*(4*C - 14)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(2*C - 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(2*C - 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*b1*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - D1*f*(2*C - 7)*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(2*C - 7)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1))/(77*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**2*f*k1**2*st**4*(6*C - 36)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k2*k3**2) - 2*D1**2*Pk1*Pkd2*ct**2*f*k2**3*st**4*(D1*Dd*f*(-5*fd*(r*(24*s - 7) - 7*s + 2) + (66*b1 + 10*f)*(r*(4*s - 1) - s)) + D1*(D1*(f*(66*bd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1) + 2*fd*(33*b1*r*(2*s - 1) + 5*f*r*(3*s - 1) - 5*f*s)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))/(231*d**2*k1**2*k3**2) - 10*D1**2*Pk1*Pkd2*ct**2*f*k2*st**4*(78*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-6*r*s + r + 3*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 78*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + fd*r*(24*s - 7) - 3*fd*s + fd) - D1*(D1*r*(3*s - 1)*(2*f*fd - f*fdd - 2*fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(71*f*(4*r*s - r - s) - 6*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(71*f*fd*(r*(4*s - 1) - s) + 3*f*(-26*bdd1*s*(r - 1) + fdd*(-4*r*s + r + s)) + fd**2*(r*(9 - 36*s) + 9*s - 3)) + 3*Ddd*f**2*(-4*r*s + r + s)) - 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(3003*d**2*k1**2) - 2*D1**2*Pk1*Pkd2*ct**2*k1**4*st**2*(11*b1*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 3*fd*(8*s - 3)*(2*r + 2*s - 1)) - 3*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 3*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(39*f*(4*r*s - r + 4*s**2 - 3*s + 1) - 25*fd*(24*r*s - 7*r + 24*s**2 - 21*s + 4)) - 25*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - 25*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)))/(231*d**2*k2*k3**4) + 4*D1**2*Pk1*Pkd2*ct**2*k1**4*(D1*f*(6*D1*bd1**2*(2*s - 1)*(r + s - 1) + D1*bd1*(-4*f*(s - 1)*(r + s - 1) + 5*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + 5*D1*bdd1*f*(s - 1)*(r + s - 1) + 5*Dd*bd1*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) + b1**2*(-D1**2*s*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(-5*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + 6*fd*(r*(8*s - 1) + s*(8*s - 3))) + 6*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) + 6*Dd**2*f*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(6*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s + 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*s**2 - 5*D1**2*f*fdd*s + 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*s**2 - 5*D1**2*fd**2*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r*s - 10*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 50*D1*Dd*f*fd*s + 5*D1*Dd*f*fd + 20*D1*Ddd*f**2*r*s - 5*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 15*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-5*f*(2*s - 1)*(r + s - 1) + 6*fd*(r*(4*s - 1) + s*(4*s - 3))) + 12*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 60*Dd**2*f**2*r*s - 15*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 45*Dd**2*f**2*s + 5*Dd**2*f**2))/(21*d**2*k2*k3**4) + 2*D1**2*Pk1*Pkd2*ct**2*k1**2*k2*st**2*(11*b1**2*(D1**2*s*(r + s)*(fd*(12*C - 37) + fdd*(15 - 6*C)) + D1*(Dd*(f*(12*C - 37)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(6*C - 15)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(15 - 6*C)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(6*C - 15)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + 11*b1*(-100*C*D1**2*f*fd*r*s + 62*C*D1**2*f*fd*r - 100*C*D1**2*f*fd*s**2 + 112*C*D1**2*f*fd*s - 62*C*D1**2*f*fd + 60*C*D1**2*f*fdd*r*s - 36*C*D1**2*f*fdd*r + 60*C*D1**2*f*fdd*s**2 - 66*C*D1**2*f*fdd*s + 36*C*D1**2*f*fdd + 60*C*D1**2*fd**2*r*s - 36*C*D1**2*fd**2*r + 60*C*D1**2*fd**2*s**2 - 66*C*D1**2*fd**2*s - 200*C*D1*Dd*f**2*r*s + 50*C*D1*Dd*f**2*r - 200*C*D1*Dd*f**2*s**2 + 150*C*D1*Dd*f**2*s - 50*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*r*s - 204*C*D1*Dd*f*fd*r + 480*C*D1*Dd*f*fd*s**2 - 444*C*D1*Dd*f*fd*s + 102*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*r*s - 30*C*D1*Ddd*f**2*r + 120*C*D1*Ddd*f**2*s**2 - 90*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*r*s - 90*C*Dd**2*f**2*r + 360*C*Dd**2*f**2*s**2 - 270*C*Dd**2*f**2*s + 30*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(2*C - 5)*(2*s - 1)*(r + s - 1) - 52*D1**2*f*fd*r*s - 3*D1**2*f*fd*r - 52*D1**2*f*fd*s**2 + 23*D1**2*f*fd*s + 3*D1**2*f*fd + 36*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 21*D1**2*f*fdd*s + 3*D1**2*f*fdd + 36*D1**2*fd**2*r*s - 3*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 21*D1**2*fd**2*s - 104*D1*Dd*f**2*r*s + 26*D1*Dd*f**2*r - 104*D1*Dd*f**2*s**2 + 78*D1*Dd*f**2*s - 26*D1*Dd*f**2 + 288*D1*Dd*f*fd*r*s - 48*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s**2 - 192*D1*Dd*f*fd*s + 24*D1*Dd*f*fd + 72*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 54*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + D1*bd1*(D1*(f*(12*C - 37)*(2*s - 1)*(r + s - 1) - fd*(6*C - 15)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(30 - 12*C)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + 216*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 162*Dd**2*f**2*s + 18*Dd**2*f**2) + f*(-1470*C*D1**2*f*fd*r*s + 490*C*D1**2*f*fd*r - 1470*C*D1**2*f*fd*s**2 + 1470*C*D1**2*f*fd*s - 490*C*D1**2*f*fd + 900*C*D1**2*f*fdd*r*s - 300*C*D1**2*f*fdd*r + 900*C*D1**2*f*fdd*s**2 - 900*C*D1**2*f*fdd*s + 300*C*D1**2*f*fdd + 1800*C*D1**2*fd**2*r*s - 600*C*D1**2*fd**2*r + 1800*C*D1**2*fd**2*s**2 - 1800*C*D1**2*fd**2*s + 300*C*D1**2*fd**2 - 1960*C*D1*Dd*f**2*r*s + 490*C*D1*Dd*f**2*r - 1960*C*D1*Dd*f**2*s**2 + 1470*C*D1*Dd*f**2*s - 490*C*D1*Dd*f**2 + 7200*C*D1*Dd*f*fd*r*s - 2100*C*D1*Dd*f*fd*r + 7200*C*D1*Dd*f*fd*s**2 - 6300*C*D1*Dd*f*fd*s + 1200*C*D1*Dd*f*fd + 1200*C*D1*Ddd*f**2*r*s - 300*C*D1*Ddd*f**2*r + 1200*C*D1*Ddd*f**2*s**2 - 900*C*D1*Ddd*f**2*s + 300*C*D1*Ddd*f**2 + 3600*C*Dd**2*f**2*r*s - 900*C*Dd**2*f**2*r + 3600*C*Dd**2*f**2*s**2 - 2700*C*Dd**2*f**2*s + 300*C*Dd**2*f**2 - 33*D1**2*bd1**2*(2*C - 5)*(2*s - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(10*C*s + 2*C + 6*s - 5) + 147*D1**2*f*fd*r*s - 49*D1**2*f*fd*r + 147*D1**2*f*fd*s**2 - 147*D1**2*f*fd*s + 49*D1**2*f*fd + 75*D1**2*f*fdd*r*s - 25*D1**2*f*fdd*r + 75*D1**2*f*fdd*s**2 - 75*D1**2*f*fdd*s + 25*D1**2*f*fdd + 150*D1**2*fd**2*r*s - 50*D1**2*fd**2*r + 150*D1**2*fd**2*s**2 - 150*D1**2*fd**2*s + 25*D1**2*fd**2 + 196*D1*Dd*f**2*r*s - 49*D1*Dd*f**2*r + 196*D1*Dd*f**2*s**2 - 147*D1*Dd*f**2*s + 49*D1*Dd*f**2 + 600*D1*Dd*f*fd*r*s - 175*D1*Dd*f*fd*r + 600*D1*Dd*f*fd*s**2 - 525*D1*Dd*f*fd*s + 100*D1*Dd*f*fd + 100*D1*Ddd*f**2*r*s - 25*D1*Ddd*f**2*r + 100*D1*Ddd*f**2*s**2 - 75*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 - 11*D1*bd1*(D1*(f*(r + s - 1)*(2*C*(25*s + 6) + 26*s - 29) - 3*fd*(2*C*(20*r*s - 4*r + 20*s**2 - 19*s + 5) + 24*r*s - 11*r + 24*s**2 - 29*s + 6)) - 6*Dd*f*(C*(40*r*s - r + 40*s**2 - 31*s + 3) + 24*r*s - 13*r + 24*s**2 - 31*s + 8)) + 300*Dd**2*f**2*r*s - 75*Dd**2*f**2*r + 300*Dd**2*f**2*s**2 - 225*Dd**2*f**2*s + 25*Dd**2*f**2))/(231*d**2*k3**4) - 4*D1**2*Pk1*Pkd2*ct**2*k1**2*k2*(D1*f*(-6*D1*bd1**2*(6*C + 1)*(2*s - 1)*(r + s - 1) + bd1*(D1*(4*f*(r + s - 1)*(3*C*(3*s - 4) - 5*s + 5) - fd*(30*C + 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(-30*C - 5)*(r*(8*s - 5) + 8*s**2 - 11*s + 3)) - 5*f*(2*C*(D1*fd*(3*r*s - r + 3*s**2 - 3*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1)) + D1*bdd1*(6*C + 1)*(s - 1)*(r + s - 1))) + b1**2*(D1**2*s*(r + s)*(-36*C*fdd + fd*(58*C - 23) - 6*fdd) + D1*(Dd*(f*(58*C - 23)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(36*C + 6)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(-36*C - 6)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(36*C + 6)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(72*C*D1**2*f*fd*r*s + 12*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s**2 - 24*C*D1**2*f*fd*s - 12*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r*s - 60*C*D1**2*f*fdd*s**2 + 30*C*D1**2*f*fdd*s - 60*C*D1**2*fd**2*r*s - 60*C*D1**2*fd**2*s**2 + 30*C*D1**2*fd**2*s + 144*C*D1*Dd*f**2*r*s - 36*C*D1*Dd*f**2*r + 144*C*D1*Dd*f**2*s**2 - 108*C*D1*Dd*f**2*s + 36*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r*s + 60*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 300*C*D1*Dd*f*fd*s - 30*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r*s + 30*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 90*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r*s + 90*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 270*C*Dd**2*f**2*s - 30*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(6*C + 1)*(2*s - 1)*(r + s - 1) - 40*D1**2*f*fd*r*s - 40*D1**2*f*fd*s**2 + 20*D1**2*f*fd*s - 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*s**2 + 5*D1**2*f*fdd*s - 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*s**2 + 5*D1**2*fd**2*s - 80*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r - 80*D1*Dd*f**2*s**2 + 60*D1*Dd*f**2*s - 20*D1*Dd*f**2 - 80*D1*Dd*f*fd*r*s + 10*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 50*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 20*D1*Ddd*f**2*r*s + 5*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 15*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(f*(58*C - 23)*(2*s - 1)*(r + s - 1) - fd*(36*C + 6)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(-72*C - 12)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 60*Dd**2*f**2*r*s + 15*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 45*Dd**2*f**2*s - 5*Dd**2*f**2))/(21*d**2*k3**4) + D1**2*Pk1*Pkd2*ct**2*k1**2*st**2*(55*b1**2*(C - 4)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 11*b1*(-164*C*D1**2*f*fd*s**2 + 184*C*D1**2*f*fd*s - 92*C*D1**2*f*fd + 84*C*D1**2*f*fdd*s**2 - 94*C*D1**2*f*fdd*s + 47*C*D1**2*f*fdd + 84*C*D1**2*fd**2*s**2 - 94*C*D1**2*fd**2*s - 328*C*D1*Dd*f**2*s**2 + 164*C*D1*Dd*f**2*s - 82*C*D1*Dd*f**2 + 672*C*D1*Dd*f*fd*s**2 - 544*C*D1*Dd*f*fd*s + 94*C*D1*Dd*f*fd + 168*C*D1*Ddd*f**2*s**2 - 84*C*D1*Ddd*f**2*s + 42*C*D1*Ddd*f**2 + 504*C*Dd**2*f**2*s**2 - 252*C*Dd**2*f**2*s - 5*D1**2*bdd1*f*(C - 4)*(2*s**2 - 2*s + 1) + 36*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 104*D1**2*f*fd*s**2 - 184*D1**2*f*fd*s + 92*D1**2*f*fd - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 60*D1**2*f*fdd*s**2 + 100*D1**2*f*fdd*s - 50*D1**2*f*fdd - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 60*D1**2*fd**2*s**2 + 100*D1**2*fd**2*s + 72*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 208*D1*Dd*f**2*s**2 - 122*D1*Dd*f**2*s + 52*D1*Dd*f**2 - 192*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 544*D1*Dd*f*fd*s - 112*D1*Dd*f*fd - 48*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 72*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 + 10*D1*bd1*(C - 4)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 144*Dd**2*f**2*r*s + 36*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 216*Dd**2*f**2*s - 12*Dd**2*f**2) - f*(2364*C*D1**2*f*fd*s**2 - 1576*C*D1**2*f*fd*s + 788*C*D1**2*f*fd - 1215*C*D1**2*f*fdd*s**2 + 810*C*D1**2*f*fdd*s - 405*C*D1**2*f*fdd - 2430*C*D1**2*fd**2*s**2 + 1620*C*D1**2*fd**2*s + 3152*C*D1*Dd*f**2*s**2 - 1576*C*D1*Dd*f**2*s + 788*C*D1*Dd*f**2 - 9720*C*D1*Dd*f*fd*s**2 + 5670*C*D1*Dd*f*fd*s - 810*C*D1*Dd*f*fd - 1620*C*D1*Ddd*f**2*s**2 + 810*C*D1*Ddd*f**2*s - 405*C*D1*Ddd*f**2 - 4860*C*Dd**2*f**2*s**2 + 2430*C*Dd**2*f**2*s + 110*D1**2*bd1**2*s*(C - 4)*(s - 1) - 11*D1**2*bdd1*f*(C*(42*s**2 + 10*s - 5) - 30*s**2 - s*(12*r + 28) + 20) - 462*D1**2*f*fd*r*s + 154*D1**2*f*fd*r - 2652*D1**2*f*fd*s**2 + 1922*D1**2*f*fd*s - 884*D1**2*f*fd + 396*D1**2*f*fdd*r*s - 132*D1**2*f*fdd*r + 1458*D1**2*f*fdd*s**2 - 1104*D1**2*f*fdd*s + 486*D1**2*f*fdd + 792*D1**2*fd**2*r*s - 264*D1**2*fd**2*r + 2916*D1**2*fd**2*s**2 - 2208*D1**2*fd**2*s + 132*D1**2*fd**2 - 616*D1*Dd*f**2*r*s + 154*D1*Dd*f**2*r - 3536*D1*Dd*f**2*s**2 + 1922*D1*Dd*f**2*s - 884*D1*Dd*f**2 + 3168*D1*Dd*f*fd*r*s - 924*D1*Dd*f*fd*r + 11664*D1*Dd*f*fd*s**2 - 7728*D1*Dd*f*fd*s + 1236*D1*Dd*f*fd + 528*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 1944*D1*Ddd*f**2*s**2 - 1104*D1*Ddd*f**2*s + 486*D1*Ddd*f**2 + 22*D1*bd1*(C*Dd*f*(-168*s**2 + 22*s + 5) + D1*f*(C*(41*s**2 + 10*s - 5) - 26*s**2 - s*(9*r + 31) + 20) + D1*fd*(6*r*(4*s - 1) + s**2*(60 - 84*C) + s*(37*C - 22) + 6) + 2*Dd*f*(3*r*(8*s - 1) + 60*s**2 + 10*s - 7)) + 1584*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 5832*Dd**2*f**2*s**2 - 3312*Dd**2*f**2*s + 132*Dd**2*f**2))/(231*d**2*k2*k3**2) - 2*D1**2*Pk1*Pkd2*ct**2*k1**2*(b1**2*(D1**2*s*(-26*fd*r + fd*s*(60*C - 100) + 20*fdd*r + fdd*s*(64 - 37*C)) + D1*(2*Dd*(f*(30*C*(4*s**2 - 2*s + 1) - 52*r*s + 13*r - 200*s**2 + 113*s - 50) + fd*(10*r*(8*s - 1) + s*(-148*C*s + 37*C + 256*s - 74))) + Ddd*f*(-37*C*(4*s**2 - 2*s + 1) + 80*r*s - 20*r + 256*s**2 - 148*s + 64)) + 2*Dd**2*f*(30*r*(4*s - 1) - s**2*(222*C - 384) + s*(111*C - 222) + 10)) + b1*(4*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 48*C*D1**2*f*fd - 2*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 30*C*D1**2*f*fdd - 2*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s + 8*C*D1*Dd*f**2*s**2 - 4*C*D1*Dd*f**2*s + 2*C*D1*Dd*f**2 - 16*C*D1*Dd*f*fd*s**2 - 236*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd - 4*C*D1*Ddd*f**2*s**2 + 2*C*D1*Ddd*f**2*s - C*D1*Ddd*f**2 - 12*C*Dd**2*f**2*s**2 + 6*C*Dd**2*f**2*s + D1**2*bdd1*f*(-37*C*(2*s**2 - 2*s + 1) + 20*r*(2*s - 1) + 128*s**2 - 148*s + 64) - 40*D1**2*f*fd*r*s - 6*D1**2*f*fd*r - 168*D1**2*f*fd*s**2 + 26*D1**2*f*fd*s + 38*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*s**2 - 19*D1**2*f*fdd*s + 38*D1**2*fd**2*r*s + 108*D1**2*fd**2*s**2 - 19*D1**2*fd**2*s - 80*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r - 336*D1*Dd*f**2*s**2 + 188*D1*Dd*f**2*s - 84*D1*Dd*f**2 + 304*D1*Dd*f*fd*r*s - 38*D1*Dd*f*fd*r + 864*D1*Dd*f*fd*s**2 - 330*D1*Dd*f*fd*s + 19*D1*Dd*f*fd + 76*D1*Ddd*f**2*r*s - 19*D1*Ddd*f**2*r + 216*D1*Ddd*f**2*s**2 - 127*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(30*C*(2*s**2 - 2*s + 1) - 26*r*s + 13*r - 100*s**2 + 113*s - 50) + fd*(10*r*(4*s - 1) + s*(-74*C*s + 37*C + 128*s - 74))) + Dd*f*(-37*C*(8*s**2 - 6*s + 1) + 20*r*(8*s - 3) + 512*s**2 - 444*s + 84)) + 228*Dd**2*f**2*r*s - 57*Dd**2*f**2*r + 648*Dd**2*f**2*s**2 - 381*Dd**2*f**2*s + 19*Dd**2*f**2) + f*(-5*C*(D1**2*(f*(8*fd - 5*fdd)*(3*s**2 - 2*s + 1) + 10*fd**2*s*(2 - 3*s)) + D1*f*(8*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(12*s**2 - 7*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)) + 2*D1**2*bd1**2*(10*r*(2*s - 1) - (s - 1)*(s*(37*C - 64) + 10)) + D1**2*bdd1*f*(-C*(s**2 - 62*s + 31) + (s - 1)*(19*r + 54*s - 54)) + D1*bd1*(D1*(2*f*(C*(s**2 - 50*s + 25) + r*(13 - 10*s) - 42*s**2 + 81*s - 42) + fd*(38*r*(2*s - 1) - s**2*(4*C - 216) + s*(64*C - 235) + 19)) + Dd*f*(C*(-8*s**2 + 250*s - 62) + 19*r*(8*s - 5) + 432*s**2 - 559*s + 127)) - 5*D1*f*(D1*fd*(-3*r*s + r + s) + Dd*f*(-4*r*s + r + s))))/(21*d**2*k2*k3**2) - D1**2*Pk1*Pkd2*ct**2*k2**3*st**6*(20*C - 20)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(693*d**2*k3**4) - 4*D1**2*Pk1*Pkd2*ct**2*k2**3*st**4*(11*D1*b1*(2*bd1*(C - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) + f*(-2*D1*bdd1*(C - 1)*(2*s - 1)*(r + s - 1) - (2*C - 3)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))) + 22*b1**2*(C - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(-22*D1**2*bd1**2*(C - 1)*(2*s - 1)*(r + s - 1) - 11*D1**2*bd1*f*s*(2*C - 3)*(r + s - 1) + (10*C + 5)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1))))/(77*d**2*k3**4) - 2*D1**2*Pk1*Pkd2*ct**2*k2**3*st**2*(D1*f*(-3*D1*bd1**2*(4*C + 3)*(2*s - 1)*(r + s - 1) + D1*bd1*(f*(r + s - 1)*(2*C*(7*s - 13) + 9*s - 15) + fd*(-12*C - 9)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - 3*D1*bdd1*f*(4*C + 3)*(s - 1)*(r + s - 1) - 3*Dd*bd1*f*(4*C + 3)*(r*(8*s - 5) + 8*s**2 - 11*s + 3) - f*(12*C + 6)*(D1*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1))) + b1**2*(D1**2*s*(r + s)*(fd*(10*C + 39) - fdd*(12*C + 9)) + D1*(Dd*(f*(10*C + 39)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(12*C + 9)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(-12*C - 9)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(12*C + 9)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(28*C*D1**2*f*fd*r*s + 12*C*D1**2*f*fd*r + 28*C*D1**2*f*fd*s**2 - 2*C*D1**2*f*fd*s - 12*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*s**2 + 12*C*D1**2*f*fdd*s - 24*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*s**2 + 12*C*D1**2*fd**2*s + 56*C*D1*Dd*f**2*r*s - 14*C*D1*Dd*f**2*r + 56*C*D1*Dd*f**2*s**2 - 42*C*D1*Dd*f**2*s + 14*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r*s + 24*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 120*C*D1*Dd*f*fd*s - 12*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 36*C*D1*Ddd*f**2*s - 12*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 108*C*Dd**2*f**2*s - 12*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(4*C + 3)*(2*s - 1)*(r + s - 1) + 18*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 18*D1**2*f*fd*s**2 - 3*D1**2*f*fd*s - 6*D1**2*f*fd - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 36*D1*Dd*f**2*r*s - 9*D1*Dd*f**2*r + 36*D1*Dd*f**2*s**2 - 27*D1*Dd*f**2*s + 9*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 90*D1*Dd*f*fd*s - 9*D1*Dd*f*fd - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 27*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + D1*bd1*(D1*(f*(10*C + 39)*(2*s - 1)*(r + s - 1) - fd*(12*C + 9)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(-24*C - 18)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 81*Dd**2*f**2*s - 9*Dd**2*f**2))/(21*d**2*k3**4) - D1**2*Pk1*Pkd2*ct**2*k2*st**6*(5*C - 5)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k3**2) - 2*D1**2*Pk1*Pkd2*ct**2*k2*st**4*(165*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(C - 1)*(-5*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 28*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 116*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 22*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 10*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 66*Dd**2*f**2*s + 4*Dd**2*f**2) + f*(-330*D1**2*bd1**2*s*(C - 1)*(s - 1) + D1**2*(f*(33*bdd1*s*(C - 1)*(4*r + 9*s - 4) + 2*fd*(C*(72*r*s - 24*r + 285*s**2 - 214*s + 95) - 87*r*s + 29*r + 15*s**2 + 19*s + 5) - fdd*(C*(72*r*s - 24*r + 285*s**2 - 214*s + 95) - 87*r*s + 29*r + 15*s**2 + 19*s + 5)) - fd**2*(2*C*(24*r*(3*s - 1) + 285*s**2 - 214*s + 12) - 58*r*(3*s - 1) + 30*s**2 + 38*s - 29)) + 66*D1*bd1*(C - 1)*(D1*(-2*f*s*(r + 3*s - 1) + fd*(8*r*s - 2*r + 18*s**2 - 13*s + 2)) + Dd*f*(2*r*(8*s - 1) + 36*s**2 - 19*s + 2)) + D1*f*(Dd*(2*f*(C*(96*r*s - 24*r + 380*s**2 - 214*s + 95) - 116*r*s + 29*r + 20*s**2 + 19*s + 5) - fd*(2*C*(288*r*s - 84*r + 1140*s**2 - 749*s + 119) - 696*r*s + 203*r + 120*s**2 + 133*s - 48)) - Ddd*f*(C*(96*r*s - 24*r + 380*s**2 - 214*s + 95) - 116*r*s + 29*r + 20*s**2 + 19*s + 5)) - Dd**2*f**2*(6*C*(12*r*(4*s - 1) + 190*s**2 - 107*s + 4) - 87*r*(4*s - 1) + 60*s**2 + 57*s - 29)))/(231*d**2*k3**2) - D1**2*Pk1*Pkd2*ct**2*k2*st**2*(11*b1**2*(D1**2*s*(fd*r*(4*C - 16) + fd*s*(8*C + 10) + fdd*r*(12*C - 6) + fdd*s*(17*C - 26)) + D1*(2*Dd*(f*(2*C*(4*r*s - r + 8*s**2 - 5*s + 2) - 32*r*s + 8*r + 20*s**2 - 2*s + 5) + fd*(r*(6*C - 3)*(8*s - 1) + s*(68*C*s - 23*C - 104*s + 29))) + Ddd*f*(C*(48*r*s - 12*r + 68*s**2 - 46*s + 17) - 24*r*s + 6*r - 104*s**2 + 58*s - 26)) + 6*Dd**2*f*(C*(24*r*s - 6*r + 34*s**2 - 23*s + 2) - 12*r*s + 3*r - 52*s**2 + 29*s - 1)) + 11*b1*(-40*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 64*C*D1**2*f*fd*s**2 + 116*C*D1**2*f*fd*s - 72*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 62*C*D1**2*f*fdd*s**2 - 88*C*D1**2*f*fdd*s + 54*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 62*C*D1**2*fd**2*s**2 - 88*C*D1**2*fd**2*s - 80*C*D1*Dd*f**2*r*s + 20*C*D1*Dd*f**2*r - 128*C*D1*Dd*f**2*s**2 + 84*C*D1*Dd*f**2*s - 32*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r*s - 104*C*D1*Dd*f*fd*r + 496*C*D1*Dd*f*fd*s**2 - 484*C*D1*Dd*f*fd*s + 112*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r*s - 4*C*D1*Ddd*f**2*r + 124*C*D1*Ddd*f**2*s**2 - 66*C*D1*Ddd*f**2*s + 31*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r*s - 12*C*Dd**2*f**2*r + 372*C*Dd**2*f**2*s**2 - 198*C*Dd**2*f**2*s + 4*C*Dd**2*f**2 + D1**2*bdd1*f*(C*(24*r*s - 12*r + 34*s**2 - 46*s + 17) - 12*r*s + 6*r - 52*s**2 + 58*s - 26) - 28*D1**2*f*fd*r*s - 22*D1**2*f*fd*r - 140*D1**2*f*fd*s**2 + 132*D1**2*f*fd*s - 48*D1**2*f*fd + 64*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r + 94*D1**2*f*fdd*s**2 - 92*D1**2*f*fdd*s + 33*D1**2*f*fdd + 64*D1**2*fd**2*r*s - 6*D1**2*fd**2*r + 94*D1**2*fd**2*s**2 - 92*D1**2*fd**2*s - 56*D1*Dd*f**2*r*s + 14*D1*Dd*f**2*r - 280*D1*Dd*f**2*s**2 + 154*D1*Dd*f**2*s - 70*D1*Dd*f**2 + 512*D1*Dd*f*fd*r*s - 88*D1*Dd*f*fd*r + 752*D1*Dd*f*fd*s**2 - 620*D1*Dd*f*fd*s + 98*D1*Dd*f*fd + 128*D1*Ddd*f**2*r*s - 32*D1*Ddd*f**2*r + 188*D1*Ddd*f**2*s**2 - 126*D1*Ddd*f**2*s + 47*D1*Ddd*f**2 + 2*D1*bd1*(C*Dd*f*(12*r*(8*s - 3) + 136*s**2 - 138*s + 29) + D1*f*(2*C*(2*r*s - r + 4*s**2 - 5*s + 2) - 16*r*s + 8*r + 10*s**2 - 2*s + 5) + D1*fd*(r*(6*C - 3)*(4*s - 1) + s*(34*C*s - 23*C - 52*s + 29)) - 2*Dd*f*(3*r*(8*s - 3) + 104*s**2 - 87*s + 16)) + 384*Dd**2*f**2*r*s - 96*Dd**2*f**2*r + 564*Dd**2*f**2*s**2 - 378*Dd**2*f**2*s + 32*Dd**2*f**2) + f*(-1560*C*D1**2*f*fd*r*s + 520*C*D1**2*f*fd*r - 2376*C*D1**2*f*fd*s**2 + 2104*C*D1**2*f*fd*s - 792*C*D1**2*f*fd + 1176*C*D1**2*f*fdd*r*s - 392*C*D1**2*f*fdd*r + 1782*C*D1**2*f*fdd*s**2 - 1580*C*D1**2*f*fdd*s + 594*C*D1**2*f*fdd + 2352*C*D1**2*fd**2*r*s - 784*C*D1**2*fd**2*r + 3564*C*D1**2*fd**2*s**2 - 3160*C*D1**2*fd**2*s + 392*C*D1**2*fd**2 - 2080*C*D1*Dd*f**2*r*s + 520*C*D1*Dd*f**2*r - 3168*C*D1*Dd*f**2*s**2 + 2104*C*D1*Dd*f**2*s - 792*C*D1*Dd*f**2 + 9408*C*D1*Dd*f*fd*r*s - 2744*C*D1*Dd*f*fd*r + 14256*C*D1*Dd*f*fd*s**2 - 11060*C*D1*Dd*f*fd*s + 1972*C*D1*Dd*f*fd + 1568*C*D1*Ddd*f**2*r*s - 392*C*D1*Ddd*f**2*r + 2376*C*D1*Ddd*f**2*s**2 - 1580*C*D1*Ddd*f**2*s + 594*C*D1*Ddd*f**2 + 4704*C*Dd**2*f**2*r*s - 1176*C*Dd**2*f**2*r + 7128*C*Dd**2*f**2*s**2 - 4740*C*Dd**2*f**2*s + 392*C*Dd**2*f**2 + 22*D1**2*bd1**2*(C*(12*r*s - 6*r + 17*s**2 - 23*s + 6) - 6*r*s + 3*r - 26*s**2 + 29*s - 3) + 11*D1**2*bdd1*f*(C*(4*r*(s + 5) + 31*s**2 + 22*s - 23) + 32*r*s - 26*r + 47*s**2 - 34*s + 14) + 762*D1**2*f*fd*r*s - 254*D1**2*f*fd*r - 1392*D1**2*f*fd*s**2 + 674*D1**2*f*fd*s - 464*D1**2*f*fd + 246*D1**2*f*fdd*r*s - 82*D1**2*f*fdd*r + 993*D1**2*f*fdd*s**2 - 744*D1**2*f*fdd*s + 331*D1**2*f*fdd + 492*D1**2*fd**2*r*s - 164*D1**2*fd**2*r + 1986*D1**2*fd**2*s**2 - 1488*D1**2*fd**2*s + 82*D1**2*fd**2 + 1016*D1*Dd*f**2*r*s - 254*D1*Dd*f**2*r - 1856*D1*Dd*f**2*s**2 + 674*D1*Dd*f**2*s - 464*D1*Dd*f**2 + 1968*D1*Dd*f*fd*r*s - 574*D1*Dd*f*fd*r + 7944*D1*Dd*f*fd*s**2 - 5208*D1*Dd*f*fd*s + 826*D1*Dd*f*fd + 328*D1*Ddd*f**2*r*s - 82*D1*Ddd*f**2*r + 1324*D1*Ddd*f**2*s**2 - 744*D1*Ddd*f**2*s + 331*D1*Ddd*f**2 - 22*D1*bd1*(D1*(f*(2*C*(5*r*s + 7*r + 8*s**2 + 8*s - 10) + 7*r*s - 18*r + 35*s**2 - 11*s + 11) - fd*(C*(8*r*(s + 1) + 62*s**2 - 22*s + 2) + 64*r*s - 29*r + 94*s**2 - 80*s + 16)) - Dd*f*(C*(16*r*s + 38*r + 124*s**2 + 11*s - 21) + 128*r*s - 68*r + 188*s**2 - 131*s + 30)) + 984*Dd**2*f**2*r*s - 246*Dd**2*f**2*r + 3972*Dd**2*f**2*s**2 - 2232*Dd**2*f**2*s + 82*Dd**2*f**2))/(231*d**2*k3**2) + 2*D1**2*Pk1*Pkd2*ct**2*k2*(D1*f*(-2*D1*bd1**2*(7*C*(r*(4*s - 2) + 5*s**2 - 7*s + 2) + r*(8*s - 4) + 33*s**2 - 37*s + 4) + bd1*(D1*(f*(8*C*(s - 1)*(11*r + 3*s - 3) - 42*r*s + 36*r + 20*s**2 - 34*s + 20) - fd*(8*C*(16*r*s - 8*r + 15*s**2 - 19*s + 4) + 36*r*s - 18*r + 112*s**2 - 121*s + 9)) - Dd*f*(4*C*(8*r*(8*s - 5) + 60*s**2 - 83*s + 23) + 9*r*(8*s - 5) + 224*s**2 - 289*s + 65)) + f*(-D1*bdd1*(s - 1)*(32*C*r + 30*C*(s - 1) + 9*r + 28*s - 28) + 5*D1*fd*(-3*r*s + r + s) + 5*Dd*f*(-4*r*s + r + s))) + b1**2*(D1**2*s*(fd*r*(84*C - 47) + fd*s*(28*C + 24) - fdd*r*(28*C + 8) - fdd*s*(35*C + 33)) + D1*(Dd*(f*(28*C*(4*s - 1)*(3*r + s - 1) - 188*r*s + 47*r + 96*s**2 - s + 24) + 2*fd*(r*(-14*C - 4)*(8*s - 1) + s*(-140*C*s + 49*C - 132*s + 37))) - Ddd*f*(7*C*(16*r*s - 4*r + 20*s**2 - 14*s + 5) + 32*r*s - 8*r + 132*s**2 - 74*s + 33)) - 2*Dd**2*f*(7*C*(24*r*s - 6*r + 30*s**2 - 21*s + 2) + 48*r*s - 12*r + 198*s**2 - 111*s + 4)) + b1*(176*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*s**2 - 88*C*D1**2*f*fd*s - 64*C*D1**2*f*fdd*r*s - 60*C*D1**2*f*fdd*s**2 + 32*C*D1**2*f*fdd*s - 64*C*D1**2*fd**2*r*s - 60*C*D1**2*fd**2*s**2 + 32*C*D1**2*fd**2*s + 352*C*D1*Dd*f**2*r*s - 88*C*D1*Dd*f**2*r + 96*C*D1*Dd*f**2*s**2 - 136*C*D1*Dd*f**2*s + 24*C*D1*Dd*f**2 - 512*C*D1*Dd*f*fd*r*s + 64*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 312*C*D1*Dd*f*fd*s - 32*C*D1*Dd*f*fd - 128*C*D1*Ddd*f**2*r*s + 32*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 92*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 384*C*Dd**2*f**2*r*s + 96*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 276*C*Dd**2*f**2*s - 32*C*Dd**2*f**2 - D1**2*bdd1*f*(7*C*(r*(8*s - 4) + 10*s**2 - 14*s + 5) + 8*r*(2*s - 1) + 66*s**2 - 74*s + 33) - 84*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 40*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 18*D1**2*f*fdd*r*s - 56*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s - 18*D1**2*fd**2*r*s - 56*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s - 168*D1*Dd*f**2*r*s + 42*D1*Dd*f**2*r + 80*D1*Dd*f**2*s**2 + 2*D1*Dd*f**2*s + 20*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 448*D1*Dd*f*fd*s**2 + 166*D1*Dd*f*fd*s - 9*D1*Dd*f*fd - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 112*D1*Ddd*f**2*s**2 + 65*D1*Ddd*f**2*s - 28*D1*Ddd*f**2 + D1*bd1*(D1*(f*(28*C*(6*r*s - 3*r + 2*s**2 - 5*s + 1) - 94*r*s + 47*r + 48*s**2 - s + 24) + 2*fd*(r*(-14*C - 4)*(4*s - 1) + s*(-70*C*s + 49*C - 66*s + 37))) - 2*Dd*f*(7*C*(4*r*(8*s - 3) + 40*s**2 - 42*s + 9) + 8*r*(8*s - 3) + 264*s**2 - 222*s + 41)) - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 336*Dd**2*f**2*s**2 + 195*Dd**2*f**2*s - 9*Dd**2*f**2))/(21*d**2*k3**2) - 9*D1**2*Pk1*Pkd2*ct**2*st**4*(D1**2*(572*bd1*fd*g2*s*(s - 1) + 5*f**3*(40*fd*(4*s**2 - 2*s + 1) - 20*fdd*(4*s**2 - 2*s + 1) + s**2*(78*bd1 - 39*bdd1)) - 30*f**2*fd*s*(13*bd1*(3*s - 1) + 20*fd*(2*s - 1)) + 286*f*s**2*(-K*bd1**2 + bd1**2 - 2*bd1*g2 + 2*bd1*gd2 + bdd1*g2)) + 2*D1*f*(Dd*(286*bd1*g2*s*(4*s - 1) + 100*f**3*(4*s**2 - 2*s + 1) - 5*f**2*(4*s - 1)*(39*bd1*s + 80*fd*s - 20*fd)) - 50*Ddd*f**3*(4*s**2 - 2*s + 1)) + 600*Dd**2*f**4*s*(1 - 2*s) + 143*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 13*b1*(D1**2*(15*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*f*s*(fd**2*(30 - 45*s) + s*(-11*K*bdd1 + 22*bd1*(K - 1) + 11*bdd1 - 22*gd2 + 11*gdd2)) + (22 - 22*s)*(2*fd*g2*(s - 1) - 2*fd*s*(-K*bd1 + bd1 + gd2) - fdd*g2*(s - 1))) + D1*(2*Dd*(15*f**3*(4*s**2 - 2*s + 1) - 15*f**2*fd*(12*s**2 - 7*s + 1) - 22*f*g2*(4*s**2 - 2*s + 1) + 22*f*s*(4*s - 1)*(-K*bd1 + bd1 + gd2) + 22*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(15*f**2 - 22*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(15*f**2 - 22*g2)*(2*s - 1)))/(1001*d**2*k2) - D1**2*Pk1*Pkd2*ct**2*st**2*(-572*D1**2*K*bd1**2*f*s**2 - 1430*D1**2*K*bd1**2*f*s + 13156*D1**2*K*bd1*f**2*s**2 - 26884*D1**2*K*bd1*f*fd*s**2 + 13442*D1**2*K*bd1*f*fd*s - 6721*D1**2*K*bdd1*f**2*s**2 + 3432*D1**2*bd1**2*f**2*r*s - 18876*D1**2*bd1**2*f**2*s**2 + 24024*D1**2*bd1**2*f**2*s + 3432*D1**2*bd1**2*f*r*s - 16588*D1**2*bd1**2*f*s**2 - 286*D1**2*bd1**2*f*s + 20020*D1**2*bd1**2*g2*s**2 - 20020*D1**2*bd1**2*g2*s - 8580*D1**2*bd1*bd2*f*s**2 - 3328*D1**2*bd1*f**3*r*s - 21684*D1**2*bd1*f**3*s**2 - 24336*D1**2*bd1*f**3*s + 13000*D1**2*bd1*f**3 + 30576*D1**2*bd1*f**2*fd*r*s - 5096*D1**2*bd1*f**2*fd*r + 80496*D1**2*bd1*f**2*fd*s**2 - 11024*D1**2*bd1*f**2*fd*s + 2548*D1**2*bd1*f**2*fd - 2288*D1**2*bd1*f**2*r*s + 4004*D1**2*bd1*f**2*s**2 + 6864*D1**2*bd1*f*fd*r*s - 1716*D1**2*bd1*f*fd*r - 7436*D1**2*bd1*f*fd*s**2 + 2002*D1**2*bd1*f*fd*s - 5148*D1**2*bd1*f*g2*s**2 - 5720*D1**2*bd1*f*g2*s + 2860*D1**2*bd1*f*g2 + 1144*D1**2*bd1*f*gd2*s**2 + 2860*D1**2*bd1*f*gd2*s + 1144*D1**2*bd1*fd*g2*s**2 - 1144*D1**2*bd1*fd*g2*s + 8580*D1**2*bd2*f**2*s**2 - 17160*D1**2*bd2*f*fd*s**2 + 8580*D1**2*bd2*f*fd*s + 5096*D1**2*bdd1*f**3*r*s + 13416*D1**2*bdd1*f**3*s**2 + 10452*D1**2*bdd1*f**3*s - 6500*D1**2*bdd1*f**3 + 1716*D1**2*bdd1*f**2*r*s - 1859*D1**2*bdd1*f**2*s**2 + 572*D1**2*bdd1*f*g2*s**2 + 2860*D1**2*bdd1*f*g2*s - 1430*D1**2*bdd1*f*g2 - 4290*D1**2*bdd2*f**2*s**2 - 5040*D1**2*f**3*fd*r*s + 1260*D1**2*f**3*fd*r - 83200*D1**2*f**3*fd*s**2 + 42860*D1**2*f**3*fd*s - 20800*D1**2*f**3*fd + 10320*D1**2*f**3*fdd*r*s - 2580*D1**2*f**3*fdd*r + 46800*D1**2*f**3*fdd*s**2 - 25980*D1**2*f**3*fdd*s + 11700*D1**2*f**3*fdd + 30960*D1**2*f**2*fd**2*r*s - 7740*D1**2*f**2*fd**2*r + 140400*D1**2*f**2*fd**2*s**2 - 77940*D1**2*f**2*fd**2*s + 2580*D1**2*f**2*fd**2 - 26312*D1**2*f**2*gd2*s**2 + 13442*D1**2*f**2*gdd2*s**2 - 52624*D1**2*f*fd*g2*s**2 + 52624*D1**2*f*fd*g2*s - 26312*D1**2*f*fd*g2 + 53768*D1**2*f*fd*gd2*s**2 - 26884*D1**2*f*fd*gd2*s + 26884*D1**2*f*fdd*g2*s**2 - 26884*D1**2*f*fdd*g2*s + 13442*D1**2*f*fdd*g2 + 26884*D1**2*fd**2*g2*s**2 - 26884*D1**2*fd**2*g2*s - 53768*D1*Dd*K*bd1*f**2*s**2 + 13442*D1*Dd*K*bd1*f**2*s + 40768*D1*Dd*bd1*f**3*r*s - 5096*D1*Dd*bd1*f**3*r + 107328*D1*Dd*bd1*f**3*s**2 + 9880*D1*Dd*bd1*f**3*s - 10452*D1*Dd*bd1*f**3 + 13728*D1*Dd*bd1*f**2*r*s - 1716*D1*Dd*bd1*f**2*r - 14872*D1*Dd*bd1*f**2*s**2 + 2002*D1*Dd*bd1*f**2*s + 4576*D1*Dd*bd1*f*g2*s**2 + 10296*D1*Dd*bd1*f*g2*s - 2860*D1*Dd*bd1*f*g2 - 34320*D1*Dd*bd2*f**2*s**2 + 8580*D1*Dd*bd2*f**2*s - 5040*D1*Dd*f**4*r*s + 1260*D1*Dd*f**4*r - 83200*D1*Dd*f**4*s**2 + 42860*D1*Dd*f**4*s - 20800*D1*Dd*f**4 + 82560*D1*Dd*f**3*fd*r*s - 20640*D1*Dd*f**3*fd*r + 374400*D1*Dd*f**3*fd*s**2 - 207840*D1*Dd*f**3*fd*s + 28560*D1*Dd*f**3*fd - 105248*D1*Dd*f**2*g2*s**2 + 52624*D1*Dd*f**2*g2*s - 26312*D1*Dd*f**2*g2 + 107536*D1*Dd*f**2*gd2*s**2 - 26884*D1*Dd*f**2*gd2*s + 215072*D1*Dd*f*fd*g2*s**2 - 161304*D1*Dd*f*fd*g2*s + 26884*D1*Dd*f*fd*g2 + 10320*D1*Ddd*f**4*r*s - 2580*D1*Ddd*f**4*r + 46800*D1*Ddd*f**4*s**2 - 25980*D1*Ddd*f**4*s + 11700*D1*Ddd*f**4 + 53768*D1*Ddd*f**2*g2*s**2 - 26884*D1*Ddd*f**2*g2*s + 13442*D1*Ddd*f**2*g2 + 30960*Dd**2*f**4*r*s - 7740*Dd**2*f**4*r + 140400*Dd**2*f**4*s**2 - 77940*Dd**2*f**4*s + 2580*Dd**2*f**4 + 161304*Dd**2*f**2*g2*s**2 - 80652*Dd**2*f**2*g2*s + 715*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(7*K*(4*s**2 - 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s - 28*s**2 + 14*s - 7) - D1*Ddd*(7*K + 6*f - 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(7*K + 6*f - 7)) + 143*b1**2*(18*D1**2*K*fd*s**2 - 56*D1**2*K*fd*s + 28*D1**2*K*fd - 2*D1**2*K*fdd*s**2 + 14*D1**2*K*fdd*s - 7*D1**2*K*fdd - 5*D1**2*bdd1*(7*K + 6*f - 7)*(3*s**2 - 2*s + 1) - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 288*D1**2*f*fd*s**2 + 72*D1**2*f*fd*s - 36*D1**2*f*fd + 24*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r - 132*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 24*D1**2*f*fdd + 24*D1**2*fd**2*r*s - 12*D1**2*fd**2*r - 132*D1**2*fd**2*s**2 - 48*D1**2*fd**2*s - 24*D1**2*fd*r*s + 24*D1**2*fd*r + 102*D1**2*fd*s**2 - 184*D1**2*fd*s + 92*D1**2*fd + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r - 58*D1**2*fdd*s**2 + 106*D1**2*fdd*s - 53*D1**2*fdd - 140*D1**2*gd2*s**2 + 70*D1**2*gdd2*s**2 + 72*D1*Dd*K*f*s**2 - 36*D1*Dd*K*f*s + 18*D1*Dd*K*f - 16*D1*Dd*K*fd*s**2 + 60*D1*Dd*K*fd*s - 14*D1*Dd*K*fd - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 576*D1*Dd*f**2*s**2 - 276*D1*Dd*f**2*s + 144*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r - 1056*D1*Dd*f*fd*s**2 + 48*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 96*D1*Dd*f*r*s + 24*D1*Dd*f*r + 408*D1*Dd*f*s**2 - 180*D1*Dd*f*s + 102*D1*Dd*f + 96*D1*Dd*fd*r*s - 60*D1*Dd*fd*r - 464*D1*Dd*fd*s**2 + 528*D1*Dd*fd*s - 94*D1*Dd*fd - 560*D1*Dd*g2*s**2 + 280*D1*Dd*g2*s - 140*D1*Dd*g2 + 560*D1*Dd*gd2*s**2 - 140*D1*Dd*gd2*s - 8*D1*Ddd*K*f*s**2 + 4*D1*Ddd*K*f*s - 2*D1*Ddd*K*f + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r - 264*D1*Ddd*f**2*s**2 + 120*D1*Ddd*f**2*s - 66*D1*Ddd*f**2 + 48*D1*Ddd*f*r*s - 12*D1*Ddd*f*r - 232*D1*Ddd*f*s**2 + 104*D1*Ddd*f*s - 58*D1*Ddd*f + 280*D1*Ddd*g2*s**2 - 140*D1*Ddd*g2*s + 70*D1*Ddd*g2 + 10*D1*bd1*(D1*(7*K*(3*s**2 - 2*s + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s - 21*s**2 + 14*s - 7) - Dd*(7*K + 6*f - 7)*(12*s**2 - 7*s + 1)) - 24*Dd**2*K*f*s**2 + 12*Dd**2*K*f*s + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r - 792*Dd**2*f**2*s**2 + 360*Dd**2*f**2*s + 12*Dd**2*f**2 + 144*Dd**2*f*r*s - 36*Dd**2*f*r - 696*Dd**2*f*s**2 + 312*Dd**2*f*s + 12*Dd**2*f + 840*Dd**2*g2*s**2 - 420*Dd**2*g2*s) - 13*b1*(-2024*D1**2*K*f*fd*s**2 + 2024*D1**2*K*f*fd*s - 1012*D1**2*K*f*fd + 1034*D1**2*K*f*fdd*s**2 - 1034*D1**2*K*f*fdd*s + 517*D1**2*K*f*fdd + 1034*D1**2*K*fd**2*s**2 - 1034*D1**2*K*fd**2*s - 660*D1**2*b2*fd*s**2 + 1320*D1**2*b2*fd*s - 660*D1**2*b2*fd + 330*D1**2*b2*fdd*s**2 - 660*D1**2*b2*fdd*s + 330*D1**2*b2*fdd + 110*D1**2*bd1**2*s*(3*s - 2)*(7*K + 6*f - 7) - 660*D1**2*bd2*f*s**2 + 660*D1**2*bd2*fd*s**2 - 660*D1**2*bd2*fd*s + 11*D1**2*bdd1*(6*f**2*(22*s**2 - s*(4*r + 28) + 15) + f*(K*(4*s**2 + 10*s - 5) - 24*r*s + 116*s**2 + 2*s + 5) - 70*g2*(2*s**2 - 2*s + 1)) + 330*D1**2*bdd2*f*s**2 + 768*D1**2*f**2*fd*r*s - 256*D1**2*f**2*fd*r + 5004*D1**2*f**2*fd*s**2 - 5464*D1**2*f**2*fd*s + 2668*D1**2*f**2*fd - 1176*D1**2*f**2*fdd*r*s + 392*D1**2*f**2*fdd*r - 3096*D1**2*f**2*fdd*s**2 + 3260*D1**2*f**2*fdd*s - 1532*D1**2*f**2*fdd - 2352*D1**2*f*fd**2*r*s + 784*D1**2*f*fd**2*r - 6192*D1**2*f*fd**2*s**2 + 6520*D1**2*f*fd**2*s - 196*D1**2*f*fd**2 + 352*D1**2*f*fd*r*s - 176*D1**2*f*fd*r - 616*D1**2*f*fd*s**2 + 440*D1**2*f*fd*s - 308*D1**2*f*fd - 264*D1**2*f*fdd*r*s + 132*D1**2*f*fdd*r + 286*D1**2*f*fdd*s**2 - 154*D1**2*f*fdd*s + 143*D1**2*f*fdd + 396*D1**2*f*gd2*s**2 - 44*D1**2*f*gdd2*s**2 - 264*D1**2*fd**2*r*s + 132*D1**2*fd**2*r + 286*D1**2*fd**2*s**2 - 154*D1**2*fd**2*s - 132*D1**2*fd**2 + 396*D1**2*fd*g2*s**2 - 1232*D1**2*fd*g2*s + 616*D1**2*fd*g2 - 88*D1**2*fd*gd2*s**2 + 308*D1**2*fd*gd2*s - 44*D1**2*fdd*g2*s**2 + 308*D1**2*fdd*g2*s - 154*D1**2*fdd*g2 - 4048*D1*Dd*K*f**2*s**2 + 2024*D1*Dd*K*f**2*s - 1012*D1*Dd*K*f**2 + 8272*D1*Dd*K*f*fd*s**2 - 6204*D1*Dd*K*f*fd*s + 1034*D1*Dd*K*f*fd - 2640*D1*Dd*b2*f*s**2 + 1320*D1*Dd*b2*f*s - 660*D1*Dd*b2*f + 2640*D1*Dd*b2*fd*s**2 - 3300*D1*Dd*b2*fd*s + 660*D1*Dd*b2*fd + 2640*D1*Dd*bd2*f*s**2 - 660*D1*Dd*bd2*f*s + 1024*D1*Dd*f**3*r*s - 256*D1*Dd*f**3*r + 6672*D1*Dd*f**3*s**2 - 3592*D1*Dd*f**3*s + 1668*D1*Dd*f**3 - 9408*D1*Dd*f**2*fd*r*s + 2744*D1*Dd*f**2*fd*r - 24768*D1*Dd*f**2*fd*s**2 + 20408*D1*Dd*f**2*fd*s - 3652*D1*Dd*f**2*fd + 704*D1*Dd*f**2*r*s - 176*D1*Dd*f**2*r - 1232*D1*Dd*f**2*s**2 + 440*D1*Dd*f**2*s - 308*D1*Dd*f**2 - 2112*D1*Dd*f*fd*r*s + 792*D1*Dd*f*fd*r + 2288*D1*Dd*f*fd*s**2 - 924*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 1584*D1*Dd*f*g2*s**2 - 792*D1*Dd*f*g2*s + 396*D1*Dd*f*g2 - 352*D1*Dd*f*gd2*s**2 + 88*D1*Dd*f*gd2*s - 352*D1*Dd*fd*g2*s**2 + 1320*D1*Dd*fd*g2*s - 308*D1*Dd*fd*g2 + 2068*D1*Ddd*K*f**2*s**2 - 1034*D1*Ddd*K*f**2*s + 517*D1*Ddd*K*f**2 + 1320*D1*Ddd*b2*f*s**2 - 660*D1*Ddd*b2*f*s + 330*D1*Ddd*b2*f - 1568*D1*Ddd*f**3*r*s + 392*D1*Ddd*f**3*r - 4128*D1*Ddd*f**3*s**2 + 2456*D1*Ddd*f**3*s - 1032*D1*Ddd*f**3 - 528*D1*Ddd*f**2*r*s + 132*D1*Ddd*f**2*r + 572*D1*Ddd*f**2*s**2 - 154*D1*Ddd*f**2*s + 143*D1*Ddd*f**2 - 176*D1*Ddd*f*g2*s**2 + 88*D1*Ddd*f*g2*s - 44*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(6*f**2*(-24*s**2 + s*(2*r + 29) - 15) - f*(K*(18*s**2 + 10*s - 5) + 6*fd*(r*(8*s - 2) - 44*s**2 + 20*s + 1) - 24*r*s + 102*s**2 + 2*s + 5) + fd*(r*(12 - 24*s) + s**2*(4*K + 116) - s*(9*K + 105) - 6) + 70*g2*(2*s**2 - 2*s + 1) + 70*gd2*s*(1 - 2*s)) - Dd*(-12*f**2*(-8*r*s + r + 44*s**2 - 38*s + 7) + f*(K*(-16*s**2 - 16*s + 5) + 96*r*s - 12*r - 464*s**2 + 100*s + 1) + 70*g2*(8*s**2 - 6*s + 1))) + 6204*Dd**2*K*f**2*s**2 - 3102*Dd**2*K*f**2*s + 3960*Dd**2*b2*f*s**2 - 1980*Dd**2*b2*f*s - 4704*Dd**2*f**3*r*s + 1176*Dd**2*f**3*r - 12384*Dd**2*f**3*s**2 + 7368*Dd**2*f**3*s - 392*Dd**2*f**3 - 1584*Dd**2*f**2*r*s + 396*Dd**2*f**2*r + 1716*Dd**2*f**2*s**2 - 462*Dd**2*f**2*s - 132*Dd**2*f**2 - 528*Dd**2*f*g2*s**2 + 264*Dd**2*f*g2*s) + 4290*b2*(D1**2*(-f*(fd*(-4*s**2 + 4*s - 2) + fdd*(2*s**2 - 2*s + 1) + s**2*(-2*bd1 + bdd1)) - 2*fd*s*(bd1 + fd)*(s - 1)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(bd1*s + fd*(2*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(6006*d**2*k2) - D1**2*Pk1*Pkd2*ct**2*(-132*D1**2*K*bd1**2*f*s**2 + 2442*D1**2*K*bd1**2*f*s - 1584*D1**2*K*bd1*f**2*s**2 + 3960*D1**2*K*bd1*f*fd*s**2 - 1980*D1**2*K*bd1*f*fd*s + 990*D1**2*K*bdd1*f**2*s**2 + 2112*D1**2*bd1**2*f**2*r*s - 1056*D1**2*bd1**2*f**2*r + 7590*D1**2*bd1**2*f**2*s**2 - 6138*D1**2*bd1**2*f**2*s + 528*D1**2*bd1**2*f**2 + 1056*D1**2*bd1**2*f*r*s - 528*D1**2*bd1**2*f*r + 3960*D1**2*bd1**2*f*s**2 - 1650*D1**2*bd1**2*f*s + 4620*D1**2*bd1**2*g2*s**2 - 4620*D1**2*bd1**2*g2*s + 1914*D1**2*bd1*bd2*f*s**2 + 396*D1**2*bd1*bd2*f*s - 730*D1**2*bd1*f**3*r*s + 730*D1**2*bd1*f**3*r - 3960*D1**2*bd1*f**3*s**2 + 5280*D1**2*bd1*f**3*s - 2640*D1**2*bd1*f**3 + 3180*D1**2*bd1*f**2*fd*r*s - 1590*D1**2*bd1*f**2*fd*r + 14850*D1**2*bd1*f**2*fd*s**2 - 12080*D1**2*bd1*f**2*fd*s + 530*D1**2*bd1*f**2*fd + 396*D1**2*bd1*f**2*r*s - 1584*D1**2*bd1*f**2*s**2 + 3960*D1**2*bd1*f*fd*s**2 - 1980*D1**2*bd1*f*fd*s - 264*D1**2*bd1*f*g2*s**2 + 7920*D1**2*bd1*f*g2*s - 3960*D1**2*bd1*f*g2 + 264*D1**2*bd1*f*gd2*s**2 - 4884*D1**2*bd1*f*gd2*s + 264*D1**2*bd1*fd*g2*s**2 - 264*D1**2*bd1*fd*g2*s - 1584*D1**2*bd2*f**2*s**2 + 3960*D1**2*bd2*f*fd*s**2 - 1980*D1**2*bd2*f*fd*s + 530*D1**2*bdd1*f**3*r*s - 530*D1**2*bdd1*f**3*r + 2475*D1**2*bdd1*f**3*s**2 - 3300*D1**2*bdd1*f**3*s + 1650*D1**2*bdd1*f**3 + 990*D1**2*bdd1*f**2*s**2 + 132*D1**2*bdd1*f*g2*s**2 - 4884*D1**2*bdd1*f*g2*s + 2442*D1**2*bdd1*f*g2 + 990*D1**2*bdd2*f**2*s**2 + 3168*D1**2*f**2*gd2*s**2 - 1980*D1**2*f**2*gdd2*s**2 + 6336*D1**2*f*fd*g2*s**2 - 6336*D1**2*f*fd*g2*s + 3168*D1**2*f*fd*g2 - 7920*D1**2*f*fd*gd2*s**2 + 3960*D1**2*f*fd*gd2*s - 3960*D1**2*f*fdd*g2*s**2 + 3960*D1**2*f*fdd*g2*s - 1980*D1**2*f*fdd*g2 - 3960*D1**2*fd**2*g2*s**2 + 3960*D1**2*fd**2*g2*s + 7920*D1*Dd*K*bd1*f**2*s**2 - 1980*D1*Dd*K*bd1*f**2*s + 4240*D1*Dd*bd1*f**3*r*s - 2650*D1*Dd*bd1*f**3*r + 19800*D1*Dd*bd1*f**3*s**2 - 18680*D1*Dd*bd1*f**3*s + 3830*D1*Dd*bd1*f**3 + 7920*D1*Dd*bd1*f**2*s**2 - 1980*D1*Dd*bd1*f**2*s + 1056*D1*Dd*bd1*f*g2*s**2 - 19800*D1*Dd*bd1*f*g2*s + 4884*D1*Dd*bd1*f*g2 + 7920*D1*Dd*bd2*f**2*s**2 - 1980*D1*Dd*bd2*f**2*s + 12672*D1*Dd*f**2*g2*s**2 - 6336*D1*Dd*f**2*g2*s + 3168*D1*Dd*f**2*g2 - 15840*D1*Dd*f**2*gd2*s**2 + 3960*D1*Dd*f**2*gd2*s - 31680*D1*Dd*f*fd*g2*s**2 + 23760*D1*Dd*f*fd*g2*s - 3960*D1*Dd*f*fd*g2 - 7920*D1*Ddd*f**2*g2*s**2 + 3960*D1*Ddd*f**2*g2*s - 1980*D1*Ddd*f**2*g2 - 23760*Dd**2*f**2*g2*s**2 + 11880*Dd**2*f**2*g2*s - 33*b1**3*(D1**2*s*(14*fd*r + 44*fd*s - 14*fdd*r - 29*fdd*s) + D1*(2*Dd*(-35*K*(4*s**2 - 2*s + 1) + f*(7*r*(4*s - 1) + 88*s**2 - 51*s + 22) - 56*fd*r*s + 7*fd*r - 116*fd*s**2 + 36*fd*s + 56*r*s - 14*r + 84*s**2 - 56*s + 21) + Ddd*(35*K*(4*s**2 - 2*s + 1) + f*(r*(14 - 56*s) - 116*s**2 + 72*s - 29) - 56*r*s + 14*r - 84*s**2 + 56*s - 21)) - 2*Dd**2*(f*(21*r*(4*s - 1) + 174*s**2 - 108*s + 7) + 21*r*(4*s - 1) - 7*s**2*(30*K - 18) + 7*s*(15*K - 12) + 7)) - 33*b1**2*(-4*D1**2*K*fd*s**2 - 112*D1**2*K*fd*s + 56*D1**2*K*fd + 2*D1**2*K*fdd*s**2 + 70*D1**2*K*fdd*s - 35*D1**2*K*fdd - 14*D1**2*bd2*s**2 + D1**2*bdd1*(35*K*(3*s**2 - 2*s + 1) + f*(r*(14 - 42*s) - 87*s**2 + 72*s - 29) - 42*r*s + 14*r - 63*s**2 + 56*s - 21) + 7*D1**2*bdd2*s**2 + 80*D1**2*f*fd*r*s + 364*D1**2*f*fd*s**2 - 116*D1**2*f*fd*s + 48*D1**2*f*fd - 64*D1**2*f*fdd*r*s - 230*D1**2*f*fdd*s**2 + 76*D1**2*f*fdd*s - 30*D1**2*f*fdd - 64*D1**2*fd**2*r*s - 230*D1**2*fd**2*s**2 + 76*D1**2*fd**2*s + 18*D1**2*fd*r*s + 14*D1**2*fd*r + 92*D1**2*fd*s**2 - 144*D1**2*fd*s + 56*D1**2*fd - 16*D1**2*fdd*r*s - 60*D1**2*fdd*s**2 + 86*D1**2*fdd*s - 35*D1**2*fdd + 140*D1**2*gd2*s**2 - 70*D1**2*gdd2*s**2 - 16*D1*Dd*K*f*s**2 + 8*D1*Dd*K*f*s - 4*D1*Dd*K*f + 16*D1*Dd*K*fd*s**2 + 276*D1*Dd*K*fd*s - 70*D1*Dd*K*fd - 56*D1*Dd*b2*s**2 + 28*D1*Dd*b2*s - 14*D1*Dd*b2 + 56*D1*Dd*bd2*s**2 - 14*D1*Dd*bd2*s + 160*D1*Dd*f**2*r*s - 40*D1*Dd*f**2*r + 728*D1*Dd*f**2*s**2 - 404*D1*Dd*f**2*s + 182*D1*Dd*f**2 - 512*D1*Dd*f*fd*r*s + 64*D1*Dd*f*fd*r - 1840*D1*Dd*f*fd*s**2 + 828*D1*Dd*f*fd*s - 76*D1*Dd*f*fd + 72*D1*Dd*f*r*s - 18*D1*Dd*f*r + 368*D1*Dd*f*s**2 - 202*D1*Dd*f*s + 92*D1*Dd*f - 128*D1*Dd*fd*r*s + 16*D1*Dd*fd*r - 480*D1*Dd*fd*s**2 + 480*D1*Dd*fd*s - 86*D1*Dd*fd + 560*D1*Dd*g2*s**2 - 280*D1*Dd*g2*s + 140*D1*Dd*g2 - 560*D1*Dd*gd2*s**2 + 140*D1*Dd*gd2*s + 8*D1*Ddd*K*f*s**2 - 4*D1*Ddd*K*f*s + 2*D1*Ddd*K*f + 28*D1*Ddd*b2*s**2 - 14*D1*Ddd*b2*s + 7*D1*Ddd*b2 - 128*D1*Ddd*f**2*r*s + 32*D1*Ddd*f**2*r - 460*D1*Ddd*f**2*s**2 + 262*D1*Ddd*f**2*s - 115*D1*Ddd*f**2 - 64*D1*Ddd*f*r*s + 16*D1*Ddd*f*r - 240*D1*Ddd*f*s**2 + 136*D1*Ddd*f*s - 60*D1*Ddd*f - 280*D1*Ddd*g2*s**2 + 140*D1*Ddd*g2*s - 70*D1*Ddd*g2 + 2*D1*bd1*(D1*(-35*K*(3*s**2 - 2*s + 1) + f*(7*r*(3*s - 1) + 66*s**2 - 51*s + 22) - 42*fd*r*s + 7*fd*r - 87*fd*s**2 + 36*fd*s + 42*r*s - 14*r + 63*s**2 - 56*s + 21) + Dd*(35*K*(12*s**2 - 7*s + 1) + f*(-7*r*(24*s - 7) - 348*s**2 + 252*s - 43) - 168*r*s + 49*r - 252*s**2 + 196*s - 35)) + 24*Dd**2*K*f*s**2 - 12*Dd**2*K*f*s + 84*Dd**2*b2*s**2 - 42*Dd**2*b2*s - 384*Dd**2*f**2*r*s + 96*Dd**2*f**2*r - 1380*Dd**2*f**2*s**2 + 786*Dd**2*f**2*s - 32*Dd**2*f**2 - 192*Dd**2*f*r*s + 48*Dd**2*f*r - 720*Dd**2*f*s**2 + 408*Dd**2*f*s - 16*Dd**2*f - 840*Dd**2*g2*s**2 + 420*Dd**2*g2*s) + b1*(-132*D1**2*K*bdd1*f*s**2 + 2442*D1**2*K*bdd1*f*s - 1221*D1**2*K*bdd1*f - 3168*D1**2*K*f*fd*s**2 + 3168*D1**2*K*f*fd*s - 1584*D1**2*K*f*fd + 1980*D1**2*K*f*fdd*s**2 - 1980*D1**2*K*f*fdd*s + 990*D1**2*K*f*fdd + 1980*D1**2*K*fd**2*s**2 - 1980*D1**2*K*fd**2*s + 66*D1**2*bd1**2*(f*(14*r*(3*s - 1) + 87*s**2 - 72*s + 7) + 7*r*(6*s - 2) + 7*s**2*(9 - 15*K) + 7*s*(10*K - 8) + 7) - 1452*D1**2*bd2*f*s**2 + 1914*D1**2*bd2*fd*s**2 - 2310*D1**2*bd2*fd*s + 2112*D1**2*bdd1*f**2*r*s - 1056*D1**2*bdd1*f**2*r + 7590*D1**2*bdd1*f**2*s**2 - 6138*D1**2*bdd1*f**2*s + 2805*D1**2*bdd1*f**2 + 1056*D1**2*bdd1*f*r*s - 528*D1**2*bdd1*f*r + 3960*D1**2*bdd1*f*s**2 - 1650*D1**2*bdd1*f*s + 825*D1**2*bdd1*f + 4620*D1**2*bdd1*g2*s**2 - 4620*D1**2*bdd1*g2*s + 2310*D1**2*bdd1*g2 + 957*D1**2*bdd2*f*s**2 - 2190*D1**2*f**2*fd*r*s - 11880*D1**2*f**2*fd*s**2 + 3370*D1**2*f**2*fd*s - 1320*D1**2*f**2*fd + 1590*D1**2*f**2*fdd*r*s + 7425*D1**2*f**2*fdd*s**2 - 2180*D1**2*f**2*fdd*s + 825*D1**2*f**2*fdd + 3180*D1**2*f*fd**2*r*s + 14850*D1**2*f*fd**2*s**2 - 4360*D1**2*f*fd**2*s + 792*D1**2*f*fd*r*s - 396*D1**2*f*fd*r - 3168*D1**2*f*fd*s**2 + 2772*D1**2*f*fd*s - 1584*D1**2*f*fd + 1980*D1**2*f*fdd*s**2 - 1980*D1**2*f*fdd*s + 990*D1**2*f*fdd - 264*D1**2*f*gd2*s**2 + 132*D1**2*f*gdd2*s**2 + 1980*D1**2*fd**2*s**2 - 1980*D1**2*fd**2*s - 264*D1**2*fd*g2*s**2 - 7392*D1**2*fd*g2*s + 3696*D1**2*fd*g2 + 264*D1**2*fd*gd2*s**2 + 4620*D1**2*fd*gd2*s + 132*D1**2*fdd*g2*s**2 + 4620*D1**2*fdd*g2*s - 2310*D1**2*fdd*g2 - 6336*D1*Dd*K*f**2*s**2 + 3168*D1*Dd*K*f**2*s - 1584*D1*Dd*K*f**2 + 15840*D1*Dd*K*f*fd*s**2 - 11880*D1*Dd*K*f*fd*s + 1980*D1*Dd*K*f*fd + 7656*D1*Dd*bd2*f*s**2 - 1914*D1*Dd*bd2*f*s - 2920*D1*Dd*f**3*r*s + 730*D1*Dd*f**3*r - 15840*D1*Dd*f**3*s**2 + 8650*D1*Dd*f**3*s - 3960*D1*Dd*f**3 + 12720*D1*Dd*f**2*fd*r*s - 1590*D1*Dd*f**2*fd*r + 59400*D1*Dd*f**2*fd*s**2 - 25160*D1*Dd*f**2*fd*s + 2180*D1*Dd*f**2*fd + 1584*D1*Dd*f**2*r*s - 396*D1*Dd*f**2*r - 6336*D1*Dd*f**2*s**2 + 2772*D1*Dd*f**2*s - 1584*D1*Dd*f**2 + 15840*D1*Dd*f*fd*s**2 - 11880*D1*Dd*f*fd*s + 1980*D1*Dd*f*fd - 1056*D1*Dd*f*g2*s**2 + 528*D1*Dd*f*g2*s - 264*D1*Dd*f*g2 + 1056*D1*Dd*f*gd2*s**2 - 264*D1*Dd*f*gd2*s + 1056*D1*Dd*fd*g2*s**2 + 18216*D1*Dd*fd*g2*s - 4620*D1*Dd*fd*g2 + 3960*D1*Ddd*K*f**2*s**2 - 1980*D1*Ddd*K*f**2*s + 990*D1*Ddd*K*f**2 + 2120*D1*Ddd*f**3*r*s - 530*D1*Ddd*f**3*r + 9900*D1*Ddd*f**3*s**2 - 5480*D1*Ddd*f**3*s + 2475*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*s**2 - 1980*D1*Ddd*f**2*s + 990*D1*Ddd*f**2 + 528*D1*Ddd*f*g2*s**2 - 264*D1*Ddd*f*g2*s + 132*D1*Ddd*f*g2 - 66*D1*bd1*(D1*(f**2*(20*r*(2*s - 1) + 182*s**2 - 144*s + 67) + f*(K*(-4*s**2 + 60*s - 30) - 2*fd*(16*r*(4*s - 1) + 230*s**2 - 131*s + 4) + 18*r*s - 16*r + 92*s**2 - 29*s + 18) + fd*(r*(8 - 32*s) + s**2*(4*K - 120) + s*(33*K + 111) - 8) + 70*g2*(2*s**2 - 2*s + 1) + s*(7*bd2 - 70*gd2)*(2*s - 1)) - Dd*(f**2*(32*r*(8*s - 3) + 920*s**2 - 634*s + 109) + f*(K*(-16*s**2 + 152*s - 37) + 16*r*(8*s - 3) + 480*s**2 - 236*s + 33) + 70*g2*(8*s**2 - 6*s + 1))) + 11880*Dd**2*K*f**2*s**2 - 5940*Dd**2*K*f**2*s + 6360*Dd**2*f**3*r*s - 1590*Dd**2*f**3*r + 29700*Dd**2*f**3*s**2 - 16440*Dd**2*f**3*s + 530*Dd**2*f**3 + 11880*Dd**2*f**2*s**2 - 5940*Dd**2*f**2*s + 1584*Dd**2*f*g2*s**2 - 792*Dd**2*f*g2*s + 33*b2*(-7*D1**2*bdd1*(2*s**2 - 2*s + 1) - 44*D1**2*fd*s**2 + 112*D1**2*fd*s - 56*D1**2*fd + 29*D1**2*fdd*s**2 - 70*D1**2*fdd*s + 35*D1**2*fdd - 176*D1*Dd*f*s**2 + 88*D1*Dd*f*s - 44*D1*Dd*f + 232*D1*Dd*fd*s**2 - 338*D1*Dd*fd*s + 70*D1*Dd*fd + 116*D1*Ddd*f*s**2 - 58*D1*Ddd*f*s + 29*D1*Ddd*f + 14*D1*bd1*(D1*(2*s**2 - 2*s + 1) + Dd*(-8*s**2 + 6*s - 1)) + 348*Dd**2*f*s**2 - 174*Dd**2*f*s)) - 33*b2*(14*D1**2*bd1**2*s*(s - 1) + D1**2*bdd1*f*(-29*s**2 - 12*s + 6) + 6*D1**2*(f*(8*fd - 5*fdd)*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1)) + 2*D1*bd1*(2*D1*f*(11*s**2 + 6*s - 3) - 29*D1*fd*s*(s - 1) + Dd*f*(-116*s**2 + 5*s + 6)) + 6*D1*f*(8*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(8*s**2 - 6*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 180*Dd**2*f**2*s*(1 - 2*s)))/(693*d**2*k2) + 2*D1**2*Pk1*Pkd2*ct**2*k2*st**2*(33*D1**2*bd1**2*f**2*(r*(4*s - 1) - 2*s + 1) + D1**2*bdd1*f**3*r*(2*s - 1) + D1*bd1*f*(11*b1*(D1*(6*f*(-4*r*s + r + 2*s) + 3*fd*(4*r - 1)*(4*s - 1) + s*(7 - 14*r)) + 3*Dd*f*(8*r - 3)*(4*s - 1)) + f*(D1*(f*r*(35 - 70*s) + 4*fd*r*(3*s - 1) - 2*fd*s + fd - 11*r*s) + Dd*f*(2*r*(8*s - 3) - 2*s + 1))) + 11*b1**2*(D1*Dd*f*(3*fd*(8*r - 1)*(4*s - 1) - (12*f + 7)*(4*r*s - r - s)) + D1*(D1*r*(3*f*fdd*(4*s - 1) + 3*fd**2*(4*s - 1) + fd*(-24*f*s + 6*f - 7*s + 7)) + 6*Ddd*f**2*(r*(4*s - 1) - s)) + 6*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + b1*f*(D1*Dd*f*(fd*(2*r*(24*s - 5) - 14*s + 3) - (70*f + 11)*(r*(4*s - 1) - s)) + D1*(D1*(f*(33*bdd1*r*(4*s - 1) - 66*bdd1*s + fdd*r*(6*s - 1) - 2*fdd*s) + fd**2*(2*r*(6*s - 1) - 4*s + 1) + fd*(r*(-35*f*(6*s - 1) - 22*s + 11) + s*(70*f + 11))) + 2*Ddd*f**2*(r*(4*s - 1) - s)) + 2*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k1**2) - 2*D1**2*Pk1*Pkd2*ct**2*k2*(2*D1**2*bd1*f*r*(-bd1*(f + 2)*(2*s - 1) + 3*f*s) + D1*b1*(-D1*bd1**2*(5*f + 7)*(r*(6*s - 2) - 2*s + 1) + bd1*(D1*(f*(2*r*(-2*f*s + f + s + 3) - 7*s) - 2*fd*(f*r*(8*s - 2) - 2*f*s + f + r*(8*s - 2) - 4*s + 2)) - 2*Dd*f*(f + 2)*(2*r*(8*s - 3) - 2*s + 1)) - 2*f*(D1*bdd1*r*(f + 2)*(2*s - 1) + 3*D1*fd*(-2*r*s + r + s) + 3*Dd*f*(-4*r*s + r + s))) + b1**3*(D1*Dd*(r*(12*f*s - 3*f - 40*fd*s + 5*fd + 56*s - 14) + s*(-3*f + 5*fd - 14)) + D1*(D1*r*s*(3*fd - 5*fdd) - Ddd*(5*f + 7)*(4*r*s - r - s)) - Dd**2*(5*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(-D1*Dd*(f*(2*f - 1)*(r*(4*s - 1) - s) + 2*fd*(16*f*r*s - 2*f*r - 6*f*s + f + 16*r*s - 2*r - 10*s + 2)) + D1*bd1*(D1*(r*(9*f*s - 3*f - 30*fd*s + 5*fd + 42*s - 14) + s*(-3*f + 5*fd - 14)) - Dd*(5*f + 7)*(r*(24*s - 7) - 7*s + 2)) + D1*(-D1*bdd1*(5*f + 7)*(r*(3*s - 1) - s) + D1*(fd**2*s*(2 - 4*r) + fd*r*(-4*f*s + s - 7) + fd*s*(2*f + 6) + 2*fdd*s*(-2*f*r + f - 2*r + 2)) - 2*Ddd*f*(f + 2)*(r*(4*s - 1) - s)) - 2*Dd**2*f*(f + 2)*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k1**2) - 4*D1**2*Pk1*Pkd2*ct*f*k1**3*st**4*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1))/(77*d**2*k3**4) - 3*D1**2*Pk1*Pkd2*ct*f*k1**3*st**4*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k2**2*k3**2) - 5*D1**2*Pk1*Pkd2*ct*f*st**6*(-13*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(6*fd*(4*s**2 - 2*s + 1) - 3*fdd*(4*s**2 - 2*s + 1) + s**2*(-26*bd1 + 13*bdd1)) + 2*fd*s*(13*bd1*(3*s - 1) + 9*fd*(1 - 2*s))) + D1*f*(6*Dd*f*(4*s**2 - 2*s + 1) + 2*Dd*(4*s - 1)*(13*bd1*s + fd*(3 - 12*s)) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(286*d**2*k1) - 2*D1**2*Pk1*Pkd2*ct*k1**3*st**2*(33*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + 11*b1*(20*C*D1**2*f*fd*r*s - 10*C*D1**2*f*fd*r + 20*C*D1**2*f*fd*s**2 - 20*C*D1**2*f*fd*s + 10*C*D1**2*f*fd - 12*C*D1**2*f*fdd*r*s + 6*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s**2 + 12*C*D1**2*f*fdd*s - 6*C*D1**2*f*fdd - 12*C*D1**2*fd**2*r*s + 6*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s**2 + 12*C*D1**2*fd**2*s + 40*C*D1*Dd*f**2*r*s - 10*C*D1*Dd*f**2*r + 40*C*D1*Dd*f**2*s**2 - 30*C*D1*Dd*f**2*s + 10*C*D1*Dd*f**2 - 96*C*D1*Dd*f*fd*r*s + 36*C*D1*Dd*f*fd*r - 96*C*D1*Dd*f*fd*s**2 + 84*C*D1*Dd*f*fd*s - 18*C*D1*Dd*f*fd - 24*C*D1*Ddd*f**2*r*s + 6*C*D1*Ddd*f**2*r - 24*C*D1*Ddd*f**2*s**2 + 18*C*D1*Ddd*f**2*s - 6*C*D1*Ddd*f**2 - 72*C*Dd**2*f**2*r*s + 18*C*Dd**2*f**2*r - 72*C*Dd**2*f**2*s**2 + 54*C*Dd**2*f**2*s - 6*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) + 10*D1**2*f*fd*r*s + D1**2*f*fd*r + 10*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s - D1**2*f*fd - 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s - 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s + 20*D1*Dd*f**2*r*s - 5*D1*Dd*f**2*r + 20*D1*Dd*f**2*s**2 - 15*D1*Dd*f**2*s + 5*D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 30*D1*Dd*f*fd*s - 3*D1*Dd*f*fd - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 9*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 3*D1*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 27*Dd**2*f**2*s - 3*Dd**2*f**2) + f*(234*C*D1**2*f*fd*r*s - 78*C*D1**2*f*fd*r + 234*C*D1**2*f*fd*s**2 - 234*C*D1**2*f*fd*s + 78*C*D1**2*f*fd - 150*C*D1**2*f*fdd*r*s + 50*C*D1**2*f*fdd*r - 150*C*D1**2*f*fdd*s**2 + 150*C*D1**2*f*fdd*s - 50*C*D1**2*f*fdd - 300*C*D1**2*fd**2*r*s + 100*C*D1**2*fd**2*r - 300*C*D1**2*fd**2*s**2 + 300*C*D1**2*fd**2*s - 50*C*D1**2*fd**2 + 312*C*D1*Dd*f**2*r*s - 78*C*D1*Dd*f**2*r + 312*C*D1*Dd*f**2*s**2 - 234*C*D1*Dd*f**2*s + 78*C*D1*Dd*f**2 - 1200*C*D1*Dd*f*fd*r*s + 350*C*D1*Dd*f*fd*r - 1200*C*D1*Dd*f*fd*s**2 + 1050*C*D1*Dd*f*fd*s - 200*C*D1*Dd*f*fd - 200*C*D1*Ddd*f**2*r*s + 50*C*D1*Ddd*f**2*r - 200*C*D1*Ddd*f**2*s**2 + 150*C*D1*Ddd*f**2*s - 50*C*D1*Ddd*f**2 - 600*C*Dd**2*f**2*r*s + 150*C*Dd**2*f**2*r - 600*C*Dd**2*f**2*s**2 + 450*C*Dd**2*f**2*s - 50*C*Dd**2*f**2 - 33*D1**2*bd1**2*(2*s - 1)*(r + s - 1) - 33*D1**2*bdd1*f*(r + s - 1)*(2*C*s + s - 1) - 33*D1**2*f*fd*r*s + 11*D1**2*f*fd*r - 33*D1**2*f*fd*s**2 + 33*D1**2*f*fd*s - 11*D1**2*f*fd - 44*D1*Dd*f**2*r*s + 11*D1*Dd*f**2*r - 44*D1*Dd*f**2*s**2 + 33*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 11*D1*bd1*(D1*(f*(s*(10*C + 5) - 6)*(r + s - 1) - 3*fd*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + r*(4*s - 2) + 4*s**2 - 5*s + 1)) - 3*Dd*f*(2*C*(r*(8*s - 1) + 8*s**2 - 7*s + 1) + r*(8*s - 5) + 8*s**2 - 11*s + 3))))/(231*d**2*k3**4) - 4*D1**2*Pk1*Pkd2*ct*k1**3*(-2*D1*f*(6*C*D1*bd1**2*(2*s - 1)*(r + s - 1) + 5*C*D1*bdd1*f*(s - 1)*(r + s - 1) + 5*C*Dd*bd1*f*(r*(8*s - 5) + 8*s**2 - 11*s + 3) + D1*bd1*(5*C*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - f*(4*C - 3)*(s - 1)*(r + s - 1))) + b1**2*(-12*C*Dd**2*f*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) + D1**2*s*(r + s)*(-12*C*fdd + fd*(10*C - 7)) + D1*(-12*C*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + Dd*(12*C*fd*(-8*r*s + r + s*(3 - 8*s)) + f*(10*C - 7)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))) + b1*(-12*C*D1**2*bdd1*f*(2*s - 1)*(r + s - 1) - 10*C*Dd**2*f**2*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1) - 2*D1**2*s*(2*r + 2*s - 1)*(5*C*f*fdd + 5*C*fd**2 + f*fd*(3 - 4*C)) + D1*bd1*(-24*C*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2) + D1*(12*C*fd*(-4*r*s + r + s*(3 - 4*s)) + f*(10*C - 7)*(2*s - 1)*(r + s - 1))) - 2*D1*f*(5*C*Ddd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1) + Dd*(5*C*fd*(8*s - 1)*(2*r + 2*s - 1) - f*(4*C - 3)*(4*r*s - r + 4*s**2 - 3*s + 1)))))/(21*d**2*k3**4) - D1**2*Pk1*Pkd2*ct*k1**3*st**2*(55*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 11*b1*(-5*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 24*D1**2*f*fd*s**2 + 44*D1**2*f*fd*s - 22*D1**2*f*fd + 12*D1**2*f*fdd*s**2 - 22*D1**2*f*fdd*s + 11*D1**2*f*fdd + 12*D1**2*fd**2*s**2 - 22*D1**2*fd**2*s - 48*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 96*D1*Dd*f*fd*s**2 - 112*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 24*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 10*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 72*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s) + f*(-110*D1**2*bd1**2*s*(s - 1) + 11*D1**2*bdd1*f*(6*s**2 + 10*s - 5) - 105*D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) - 22*D1*bd1*(D1*f*(6*s**2 + 10*s - 5) + D1*fd*s*(1 - 12*s) + Dd*f*(-24*s**2 - 14*s + 5)) - 105*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 630*Dd**2*f**2*s*(1 - 2*s)))/(462*d**2*k2**2*k3**2) + D1**2*Pk1*Pkd2*ct*k1**3*(-2*D1*f*(s - 1)*(19*D1*bd1**2*s + 8*D1*bdd1*f*(s - 1) + 16*bd1*(D1*(-f*s + f + 2*fd*s) + Dd*f*(4*s - 1))) + 19*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-19*D1**2*bdd1*f*(2*s**2 - 2*s + 1) + 32*D1**2*s**2*(2*f*fd - f*fdd - fd**2) + 38*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 16*D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) + 4*Dd*fd*s*(1 - 4*s) + Ddd*f*(-4*s**2 + 2*s - 1)) + 96*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2**2*k3**2) + 10*D1**2*Pk1*Pkd2*ct*k1*k2**2*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(693*d**2*k3**4) + 4*D1**2*Pk1*Pkd2*ct*k1*k2**2*st**4*(11*D1*b1*(bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - f*(D1*bdd1*(2*s - 1)*(r + s - 1) + (2*C + 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1)))) + 11*b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(-11*D1**2*bd1**2*(2*s - 1)*(r + s - 1) - 11*D1**2*bd1*f*s*(2*C + 1)*(r + s - 1) - (10*C + 1)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1))))/(77*d**2*k3**4) - 2*D1**2*Pk1*Pkd2*ct*k1*k2**2*st**2*(D1*f*(-3*D1*bd1**2*(6*C + 1)*(2*s - 1)*(r + s - 1) + D1*bd1*(f*(r + s - 1)*(C*(22*s - 34) + 4*s - 5) + fd*(-18*C - 3)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - 3*D1*bdd1*f*(6*C + 1)*(s - 1)*(r + s - 1) - 3*Dd*bd1*f*(6*C + 1)*(r*(8*s - 5) + 8*s**2 - 11*s + 3) - f*(12*C + 1)*(D1*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*f*(r*(4*s - 1) + 4*s**2 - 3*s + 1))) + b1**2*(D1**2*s*(r + s)*(-18*C*fdd + fd*(50*C + 13) - 3*fdd) + D1*(Dd*(f*(50*C + 13)*(r*(4*s - 1) + 4*s**2 - 3*s + 1) - fd*(18*C + 3)*(r*(8*s - 1) + s*(8*s - 3))) + Ddd*f*(-18*C - 3)*(r*(4*s - 1) + 4*s**2 - 3*s + 1)) - Dd**2*f*(18*C + 3)*(3*r*(4*s - 1) + 12*s**2 - 9*s + 1)) + b1*(44*C*D1**2*f*fd*r*s + 12*C*D1**2*f*fd*r + 44*C*D1**2*f*fd*s**2 - 10*C*D1**2*f*fd*s - 12*C*D1**2*f*fd - 36*C*D1**2*f*fdd*r*s - 36*C*D1**2*f*fdd*s**2 + 18*C*D1**2*f*fdd*s - 36*C*D1**2*fd**2*r*s - 36*C*D1**2*fd**2*s**2 + 18*C*D1**2*fd**2*s + 88*C*D1*Dd*f**2*r*s - 22*C*D1*Dd*f**2*r + 88*C*D1*Dd*f**2*s**2 - 66*C*D1*Dd*f**2*s + 22*C*D1*Dd*f**2 - 288*C*D1*Dd*f*fd*r*s + 36*C*D1*Dd*f*fd*r - 288*C*D1*Dd*f*fd*s**2 + 180*C*D1*Dd*f*fd*s - 18*C*D1*Dd*f*fd - 72*C*D1*Ddd*f**2*r*s + 18*C*D1*Ddd*f**2*r - 72*C*D1*Ddd*f**2*s**2 + 54*C*D1*Ddd*f**2*s - 18*C*D1*Ddd*f**2 - 216*C*Dd**2*f**2*r*s + 54*C*Dd**2*f**2*r - 216*C*Dd**2*f**2*s**2 + 162*C*Dd**2*f**2*s - 18*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(6*C + 1)*(2*s - 1)*(r + s - 1) + 8*D1**2*f*fd*r*s + D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 3*D1**2*f*fd*s - D1**2*f*fd - 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s - 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 30*D1*Dd*f*fd*s - 3*D1*Dd*f*fd - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 9*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + D1*bd1*(D1*(f*(50*C + 13)*(2*s - 1)*(r + s - 1) - fd*(18*C + 3)*(r*(4*s - 1) + s*(4*s - 3))) + Dd*f*(-36*C - 6)*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 27*Dd**2*f**2*s - 3*Dd**2*f**2))/(21*d**2*k3**4) + 5*D1**2*Pk1*Pkd2*ct*k1*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**2) + D1**2*Pk1*Pkd2*ct*k1*st**4*(165*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(-5*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 28*D1**2*f*fd*s**2 + 28*D1**2*f*fd*s - 14*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 56*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 14*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 116*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 22*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 10*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 66*Dd**2*f**2*s + 4*Dd**2*f**2) + f*(-330*D1**2*bd1**2*s*(s - 1) + D1**2*(f*(33*bdd1*s*(4*r + 9*s - 4) - 2*fd*(4*C*(6*r*s - 2*r + 87*s**2 - 60*s + 29) - 60*r*s + 20*r - 63*s**2 + 62*s - 21) + fdd*(4*C*(6*r*s - 2*r + 87*s**2 - 60*s + 29) - 60*r*s + 20*r - 63*s**2 + 62*s - 21)) + 2*fd**2*(4*C*(r*(6*s - 2) + 87*s**2 - 60*s + 1) + r*(20 - 60*s) - 63*s**2 + 62*s - 10)) - 66*D1*bd1*(D1*(f*s*(2*r + 7*s - 2) + fd*(-8*r*s + 2*r - 18*s**2 + 13*s - 2)) + Dd*f*(r*(2 - 16*s) - 36*s**2 + 19*s - 2)) + D1*f*(-2*Dd*(f*(4*C*(8*r*s - 2*r + 116*s**2 - 60*s + 29) - 80*r*s + 20*r - 84*s**2 + 62*s - 21) + fd*(-4*C*(24*r*s - 7*r + 348*s**2 - 210*s + 31) + 240*r*s - 70*r + 252*s**2 - 217*s + 41)) + Ddd*f*(4*C*(8*r*s - 2*r + 116*s**2 - 60*s + 29) - 80*r*s + 20*r - 84*s**2 + 62*s - 21)) + 2*Dd**2*f**2*(4*C*(3*r*(4*s - 1) + 174*s**2 - 90*s + 1) - 30*r*(4*s - 1) - 126*s**2 + 93*s - 10)))/(231*d**2*k3**2) + D1**2*Pk1*Pkd2*ct*k1*st**2*(44*D1**2*bd1**2*f*(2*C*(r*(2*s - 1) + 7*s**2 - 8*s + 1) + r*(4*s - 2) + 7*s**2 - 9*s + 2) - 22*D1*bd1*(2*b1*(2*C*(D1*(f*(r*(4*s - 2) + 14*s**2 - 16*s + 7) + fd*(-4*r*s + r + s*(8 - 14*s))) + Dd*f*(r*(6 - 16*s) - 56*s**2 + 48*s - 9)) + D1*(3*f*(-2*r*s + r + s) + fd*r*(2 - 8*s) + fd*s*(9 - 14*s)) + Dd*f*(-4*r*(8*s - 3) - 56*s**2 + 54*s - 11)) + f*(-D1*f*(4*C*(2*r*(s + 1) + 8*s**2 + 10*s - 7) + 8*r*s - 18*r + 33*s**2 - 38*s + 24) + D1*fd*(4*C*(8*r*s - r + 28*s**2 - 12*s + 2) + 48*r*s - 24*r + 74*s**2 - 75*s + 12) + Dd*f*(4*C*(16*r*s + 2*r + 56*s**2 - 5) + 96*r*s - 60*r + 148*s**2 - 153*s + 38))) - 22*b1**2*(2*C*(D1**2*s*(2*fd - fdd)*(2*r + 7*s) + D1*(2*Dd*(f*(r*(8*s - 2) + 28*s**2 - 16*s + 7) + fd*(-8*r*s + r + s*(8 - 28*s))) + Ddd*f*(r*(2 - 8*s) - 28*s**2 + 16*s - 7)) - 2*Dd**2*f*(3*r*(4*s - 1) + 42*s**2 - 24*s + 1)) + 2*D1*Dd*(3*f*(-4*r*s + r + s) + fd*r*(2 - 16*s) + fd*s*(9 - 28*s)) - D1*(D1*s*(6*fd*r + 4*fdd*r + 7*fdd*s) + Ddd*f*(16*r*s - 4*r + 28*s**2 - 18*s + 7)) - 2*Dd**2*f*(6*r*(4*s - 1) + 42*s**2 - 27*s + 2)) + 11*b1*(2*D1**2*bdd1*f*(2*C*(r*(4*s - 2) + 14*s**2 - 16*s + 7) + r*(8*s - 4) + 14*s**2 - 18*s + 7) + D1**2*(f*(2*fd*(4*C*(4*r*(s - 1) + 16*s**2 - 28*s + 15) + 2*r*(8*s + 5) + 66*s**2 - 36*s + 9) - fdd*(4*C*(r*(8*s - 6) + 28*s**2 - 40*s + 21) + 74*s**2 + s*(48*r - 46) + 11)) - 2*fd**2*(4*C*r*(4*s - 3) + 8*C*s*(7*s - 10) + s*(24*r + 37*s - 23))) + D1*f*(2*Dd*(f*(8*C*(r*(4*s - 1) + 16*s**2 - 9*s + 4) + 8*r*(4*s - 1) + 132*s**2 - 74*s + 33) - fd*(4*C*(16*r*(2*s - 1) + 112*s**2 - 112*s + 23) + 24*r*(8*s - 1) + 296*s**2 - 190*s + 23)) - Ddd*f*(8*C*(r*(8*s - 2) + 28*s**2 - 16*s + 7) + 24*r*(4*s - 1) + 148*s**2 - 98*s + 37)) - 2*Dd**2*f**2*(8*C*(3*r*(4*s - 1) + 42*s**2 - 24*s + 1) + 36*r*(4*s - 1) + 222*s**2 - 147*s + 12)) + f*(-11*D1**2*bdd1*f*(4*C*(r*(4*s + 2) + 14*s**2 + 8*s - 7) + 24*r*(s - 1) + 37*s**2 - 52*s + 26) + D1**2*(f*(2*fd*(4*C*(38*r*(3*s - 1) + 495*s**2 - 368*s + 165) - 330*r*s + 110*r + 249*s**2 - 56*s + 83) - fdd*(4*C*(82*r*(3*s - 1) + 693*s**2 - 544*s + 231) + 315*s**2 - 210*s + 105)) - 2*fd**2*(4*C*(82*r*(3*s - 1) + 693*s**2 - 544*s + 41) + 105*s*(3*s - 2))) + D1*f*(-4*C*Ddd*f*(82*r*(4*s - 1) + 924*s**2 - 544*s + 231) + 2*Dd*f*(4*C*(38*r*(4*s - 1) + 660*s**2 - 368*s + 165) - 110*r*(4*s - 1) + 332*s**2 - 56*s + 83) - 2*Dd*fd*(4*C*(41*r*(24*s - 7) + 2772*s**2 - 1904*s + 313) + 1260*s**2 - 735*s + 105) - 105*Ddd*f*(4*s**2 - 2*s + 1)) - 2*Dd**2*f**2*(4*C*(123*r*(4*s - 1) + 1386*s**2 - 816*s + 41) + 315*s*(2*s - 1))))/(462*d**2*k3**2) + D1**2*Pk1*Pkd2*ct*k1*(-2*D1*f*(D1*bd1**2*(28*C*(2*r*s - r + 3*s**2 - 4*s + 1) + s*(19*s - 19)) - 4*D1*bd1*(f*(s - 1)*(2*C*(7*r + 3*s - 3) - 9*r + s - 1) + fd*(C*(-28*r*s + 14*r - 36*s**2 + 43*s - 7) + s*(8 - 8*s))) + 4*D1*bdd1*f*(s - 1)*(C*(7*r + 9*s - 9) + 2*s - 2) + 4*Dd*bd1*f*(C*(7*r*(8*s - 5) + 72*s**2 - 97*s + 25) + 16*s**2 - 20*s + 4)) + b1**2*(D1**2*s*(fd*r*(112*C - 84) + fd*s*(56*C + 10) - fdd*(56*C*r + 84*C*s + 19*s)) + D1*(2*Dd*(f*(28*C*(r*(8*s - 2) + (1 - 2*s)**2) - 168*r*s + 42*r + 20*s**2 + 32*s + 5) + fd*(-28*C*(r*(8*s - 1) + 4*s*(3*s - 1)) + s*(19 - 76*s))) - Ddd*f*(28*C*(8*r*s - 2*r + 12*s**2 - 8*s + 3) + 76*s**2 - 38*s + 19)) - 2*Dd**2*f*(28*C*(3*r*(4*s - 1) + 18*s**2 - 12*s + 1) + 57*s*(2*s - 1))) + b1*(-D1**2*bdd1*f*(28*C*(4*r*s - 2*r + 6*s**2 - 8*s + 3) + 38*s**2 - 38*s + 19) + 8*D1**2*s*(f*(fd*(2*C*(14*r + 6*s - 7) - 18*r + 2*s + 9) - fdd*(C*(14*r + 18*s - 7) + 4*s)) - fd**2*(C*(14*r + 18*s - 7) + 4*s)) + 2*D1*bd1*(-28*C*Dd*f*(2*r*(8*s - 3) + 24*s**2 - 24*s + 5) + D1*f*(28*C*(4*r*s - 2*r + 2*s**2 - 4*s + 1) - 84*r*s + 42*r + 10*s**2 + 32*s + 5) + D1*fd*(-28*C*(4*r*s - r + 6*s**2 - 4*s) + s*(19 - 38*s)) - 19*Dd*f*(8*s**2 - 6*s + 1)) + 8*D1*f*(Dd*(f*(2*C*(28*r*s - 7*r + 12*s**2 - 13*s + 3) - 36*r*s + 9*r + 4*s**2 + 7*s + 1) + fd*(C*(-112*r*s + 14*r - 144*s**2 + 78*s - 7) + s*(8 - 32*s))) - Ddd*f*(C*(28*r*s - 7*r + 36*s**2 - 25*s + 9) + 8*s**2 - 4*s + 2)) + 8*Dd**2*f**2*(C*(-84*r*s + 21*r - 108*s**2 + 75*s - 7) + s*(12 - 24*s))))/(21*d**2*k3**2) + 3*D1**2*Pk1*Pkd2*ct*k1*st**4*(-2*D1**2*f*(429*bd1**2*s**2 + 5*f**2*(10*fd*(4*s**2 - 2*s + 1) - 5*fdd*(4*s**2 - 2*s + 1) + s**2*(26*bd1 - 13*bdd1)) - 10*f*fd*s*(13*bd1*(3*s - 1) + 15*fd*(2*s - 1))) - 10*D1*f**3*(10*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(13*bd1*s + 5*fd*(4*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) - 300*Dd**2*f**4*s*(1 - 2*s) + 429*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 26*b1*(D1**2*(66*bd1*fd*s*(s - 1) + 5*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*s*(fd**2*(20 - 30*s) + s*(-66*bd1 + 33*bdd1))) + D1*(2*Dd*f*(33*bd1*s*(4*s - 1) + 5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(12*s**2 - 7*s + 1)) - 5*Ddd*f**3*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**3*s*(1 - 2*s)))/(1001*d**2*k2**2) - D1**2*Pk1*Pkd2*ct*k1*st**2*(55*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd + 28) + s*(3*fd + 14) - 7) - D1*Ddd*(3*f - 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f - 7)*(2*s - 1)) + 11*b1**2*(-5*D1**2*bdd1*(3*f - 7)*(3*s**2 - 2*s + 1) + 36*D1**2*f*fd*s**2 + 84*D1**2*f*fd*s - 42*D1**2*f*fd - 18*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd - 18*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s + 68*D1**2*fd*s**2 - 116*D1**2*fd*s + 58*D1**2*fd - 34*D1**2*fdd*s**2 + 58*D1**2*fdd*s - 29*D1**2*fdd + 72*D1*Dd*f**2*s**2 - 36*D1*Dd*f**2*s + 18*D1*Dd*f**2 - 144*D1*Dd*f*fd*s**2 - 132*D1*Dd*f*fd*s + 42*D1*Dd*f*fd + 272*D1*Dd*f*s**2 - 136*D1*Dd*f*s + 68*D1*Dd*f - 272*D1*Dd*fd*s**2 + 300*D1*Dd*fd*s - 58*D1*Dd*fd - 36*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 136*D1*Ddd*f*s**2 + 68*D1*Ddd*f*s - 34*D1*Ddd*f + 10*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) - s**2*(9*fd + 21) + s*(3*fd + 14) - 7) - Dd*(3*f - 7)*(12*s**2 - 7*s + 1)) - 108*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 408*Dd**2*f*s**2 + 204*Dd**2*f*s) + b1*(-110*D1**2*bd1**2*s*(3*f - 7)*(3*s - 2) - 11*D1**2*bdd1*f*(6*f*(3*s**2 - 10*s + 5) + 68*s**2 - 10*s + 5) - 2022*D1**2*f**2*fd*s**2 + 1848*D1**2*f**2*fd*s - 924*D1**2*f**2*fd + 1011*D1**2*f**2*fdd*s**2 - 924*D1**2*f**2*fdd*s + 462*D1**2*f**2*fdd + 2022*D1**2*f*fd**2*s**2 - 1848*D1**2*f*fd**2*s - 484*D1**2*f*fd*s**2 + 484*D1**2*f*fd*s - 242*D1**2*f*fd + 242*D1**2*f*fdd*s**2 - 242*D1**2*f*fdd*s + 121*D1**2*f*fdd + 242*D1**2*fd**2*s**2 - 242*D1**2*fd**2*s - 2696*D1*Dd*f**3*s**2 + 1348*D1*Dd*f**3*s - 674*D1*Dd*f**3 + 8088*D1*Dd*f**2*fd*s**2 - 5718*D1*Dd*f**2*fd*s + 924*D1*Dd*f**2*fd - 968*D1*Dd*f**2*s**2 + 484*D1*Dd*f**2*s - 242*D1*Dd*f**2 + 1936*D1*Dd*f*fd*s**2 - 1452*D1*Dd*f*fd*s + 242*D1*Dd*f*fd + 1348*D1*Ddd*f**3*s**2 - 674*D1*Ddd*f**3*s + 337*D1*Ddd*f**3 + 484*D1*Ddd*f**2*s**2 - 242*D1*Ddd*f**2*s + 121*D1*Ddd*f**2 + 22*D1*bd1*(D1*(6*f**2*(3*s**2 - 10*s + 5) + f*(s**2*(68 - 36*fd) + s*(18*fd - 10) + 5) + fd*s*(63 - 68*s)) - Dd*f*(4*s - 1)*(6*f*(3*s - 5) + 68*s - 5)) + 4044*Dd**2*f**3*s**2 - 2022*Dd**2*f**3*s + 1452*Dd**2*f**2*s**2 - 726*Dd**2*f**2*s) + f*(-22*D1**2*bd1**2*s*(f*(9*s - 30) + 34*s - 5) - 2*D1*bd1*(D1*(f**2*(337*s**2 + 250*s - 125) + f*s*(-1011*fd*s + 87*fd + 121*s) + 121*fd*s*(1 - 2*s)) - Dd*f*(4*s - 1)*(f*(337*s + 125) + 121*s)) + f*(D1**2*bdd1*(f*(337*s**2 + 250*s - 125) + 121*s**2) - 175*D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) - 175*D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) - 1050*Dd**2*f**2*s*(1 - 2*s))))/(462*d**2*k2**2) - D1**2*Pk1*Pkd2*ct*k1*(D1*f*(s - 1)*(2*D1*bd1**2*s*(36*f + 19) + 15*D1*bdd1*f**2*(s - 1) + 30*bd1*f*(D1*(-f*s + f + 3*fd*s) + Dd*f*(4*s - 1))) - 7*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) + s**2*(8 - 12*fd) + s*(3*fd - 4) + 2) - D1*Ddd*(3*f + 2)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 2)*(2*s - 1)) + b1**2*(7*D1**2*bdd1*(3*f + 2)*(3*s**2 - 2*s + 1) - 144*D1**2*f*fd*s**2 + 72*D1**2*f*fdd*s**2 + 72*D1**2*fd**2*s**2 - 38*D1**2*fd*s**2 + 19*D1**2*fdd*s**2 - 288*D1*Dd*f**2*s**2 + 144*D1*Dd*f**2*s - 72*D1*Dd*f**2 + 576*D1*Dd*f*fd*s**2 - 144*D1*Dd*f*fd*s - 152*D1*Dd*f*s**2 + 76*D1*Dd*f*s - 38*D1*Dd*f + 152*D1*Dd*fd*s**2 - 38*D1*Dd*fd*s + 144*D1*Ddd*f**2*s**2 - 72*D1*Ddd*f**2*s + 36*D1*Ddd*f**2 + 76*D1*Ddd*f*s**2 - 38*D1*Ddd*f*s + 19*D1*Ddd*f - 14*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(6 - 9*fd) + s*(3*fd - 4) + 2) - Dd*(3*f + 2)*(12*s**2 - 7*s + 1)) + 432*Dd**2*f**2*s**2 - 216*Dd**2*f**2*s + 228*Dd**2*f*s**2 - 114*Dd**2*f*s) + b1*(14*D1**2*bd1**2*s*(3*f + 2)*(3*s - 2) - 2*D1**2*bd1*(36*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(38 - 144*fd) + s*(72*fd - 38) + 19) + 19*fd*s*(1 - 2*s)) + D1**2*bdd1*f*(36*f + 19)*(2*s**2 - 2*s + 1) + 2*D1*Dd*bd1*f*(36*f + 19)*(8*s**2 - 6*s + 1) - 15*f*(3*D1**2*s**2*(2*f*fd - f*fdd - 2*fd**2) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) + 6*Dd*fd*s*(1 - 4*s) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))))/(21*d**2*k2**2) + 10*D1**2*Pk1*Pkd2*ct*k2**4*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) - Dd*fd*(8*s - 3)*(2*r + 2*s - 1) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 21*s - 4) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f**2*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(693*d**2*k1*k3**4) + 4*D1**2*Pk1*Pkd2*ct*k2**4*st**4*(-D1**2*bd1*f*(bd1*(2*s - 1) + f*s)*(r + s - 1) + D1*b1*(bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) - 2*Dd*f*(r*(8*s - 3) + 8*s**2 - 9*s + 2)) - f*(D1*bdd1*(2*s - 1)*(r + s - 1) + D1*fd*(2*r*s - r + 2*s**2 - 2*s + 1) + Dd*f*(4*r*s - r + 4*s**2 - 3*s + 1))) + b1**2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 8*s**2 - 6*s + 2) + Dd*fd*(-8*r*s + r + s*(3 - 8*s)) + Ddd*f*(-4*r*s + r - 4*s**2 + 3*s - 1)) + Dd**2*f*(r*(3 - 12*s) - 12*s**2 + 9*s - 1)))/(7*d**2*k1*k3**4) + 5*D1**2*Pk1*Pkd2*ct*k2**2*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(8*C - 8)*(2*s - 1) + 10*s**2 - 10*s + 5) - 2*fd**2*(r*(4*C - 4)*(2*s - 1) + s*(5*s - 5))) + D1*f*(2*Dd*(f*(r*(8*C - 8)*(4*s - 1) + 20*s**2 - s*(8*C + 2) + 5) + fd*(C*(-8*r*(8*s - 3) + 8*s - 4) + 8*r*(8*s - 3) - 40*s**2 + 22*s - 1)) + Ddd*f*(-r*(8*C - 8)*(4*s - 1) - 20*s**2 + s*(8*C + 2) - 5)) + 2*Dd**2*f**2*(-4*C*(3*r*(4*s - 1) - 3*s + 1) + 12*r*(4*s - 1) - 30*s**2 + 3*s + 4)) + f*(D1**2*(f*(-33*bdd1*s*(8*C*(r - 1) - 8*r + 5*s + 8) + 2*fd*(-8*C*s + r*(8*C - 8)*(3*s - 1) + 15*s**2 - 2*s + 5) + fdd*(8*C*s - r*(8*C - 8)*(3*s - 1) - 15*s**2 + 2*s - 5)) + 2*fd**2*(C*(r*(8 - 24*s) + 8*s - 4) + 8*r*(3*s - 1) - 15*s**2 + 2*s + 4)) + 66*D1*bd1*(D1*(f*s*(8*C*(r - 1) - 8*r + 5*s + 8) + fd*(4*C*(-4*r*s + r + 2*s - 1) + 16*r*s - 4*r - 10*s**2 - 3*s + 4)) + Dd*f*(-4*C*(8*r*s - r - 5*s + 1) + 32*r*s - 4*r - 20*s**2 - 15*s + 4)) + D1*f*(2*Dd*(f*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 20*s**2 - 2*s + 5) + fd*(-4*C*(24*r*s - 7*r - 7*s + 2) + 96*r*s - 28*r - 60*s**2 + 7*s + 3)) + Ddd*f*(8*C*s - r*(8*C - 8)*(4*s - 1) - 20*s**2 + 2*s - 5)) + 2*Dd**2*f**2*(-4*C*(3*r*(4*s - 1) - 3*s + 1) + 12*r*(4*s - 1) - 30*s**2 + 3*s + 4)))/(1386*d**2*k1*k3**2) + D1**2*Pk1*Pkd2*ct*k2**2*st**4*(33*b1**2*(D1**2*s*(2*fd - fdd)*(r*(8*C - 8) + s) + D1*(2*Dd*(f*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 4*s**2 + 6*s + 1) + fd*(-r*(4*C - 4)*(8*s - 1) + s*(4*C - 4*s - 3))) - Ddd*f*(-8*C*s + r*(8*C - 8)*(4*s - 1) + 4*s**2 + 6*s + 1)) - 2*Dd**2*f*(4*C*(12*r*s - 3*r - 3*s + 1) - 48*r*s + 12*r + 6*s**2 + 9*s - 4)) + 33*b1*(-16*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*r - 32*C*D1*Dd*f**2*r*s + 8*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s - D1**2*bdd1*f*(r*(8*C - 8)*(2*s - 1) + 2*s**2 + s*(6 - 8*C) + 1) + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 20*D1**2*f*fd*s - 10*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 116*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 22*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(-8*C*s + r*(8*C - 8)*(2*s - 1) + 2*s**2 + 6*s + 1) + fd*(-r*(4*C - 4)*(4*s - 1) + s*(4*C - 2*s - 3))) + Dd*f*(-8*C*(r*(8*s - 3) - 3*s + 1) + 8*r*(8*s - 3) - 8*s**2 - 18*s + 7)) + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 66*Dd**2*f**2*s + 4*Dd**2*f**2) - f*(66*D1**2*bd1**2*(C*(r*(8*s - 4) - 4*s + 4) + r*(4 - 8*s) + s**2 + 3*s - 4) + D1**2*(f*(-33*bdd1*s*(4*r + 9*s - 4) + 4*fd*(r*(20*C - 2)*(3*s - 1) - 15*s**2 - s*(20*C - 12) - 5) + 2*fdd*(-r*(20*C - 2)*(3*s - 1) + 15*s**2 + s*(20*C - 12) + 5)) + 4*fd**2*(-10*C*(r*(6*s - 2) - 2*s + 1) + r*(6*s - 2) + 15*s**2 - 12*s + 1)) + 66*D1*bd1*(D1*(f*s*(4*C*(r - 1) - 2*r + 5*s + 2) + fd*(r*(2 - 8*s) - 18*s**2 + 13*s - 2)) + Dd*f*(r*(2 - 16*s) - 36*s**2 + 19*s - 2)) + 2*D1*f*(2*Dd*(f*(-20*C*s + r*(20*C - 2)*(4*s - 1) - 20*s**2 + 12*s - 5) + fd*(-10*C*(24*r*s - 7*r - 7*s + 2) + 24*r*s - 7*r + 60*s**2 - 42*s + 7)) + Ddd*f*(-r*(20*C - 2)*(4*s - 1) + 20*s**2 + s*(20*C - 12) + 5)) + 4*Dd**2*f**2*(-10*C*(3*r*(4*s - 1) - 3*s + 1) + 3*r*(4*s - 1) + 30*s**2 - 18*s + 1)))/(231*d**2*k1*k3**2) + D1**2*Pk1*Pkd2*ct*k2**2*st**2*(D1*f*(2*D1*bd1**2*(12*r*(2*s - 1) + 29*s**2 - 41*s + 12) - 2*bd1*(D1*(f*(r*(4*C*(s - 1) + 8*s - 2) - 7*s**2 + 8*s - 7) + 2*fd*(r*(8*s - 4) + 11*s**2 - 13*s + 2)) + Dd*f*(4*r*(8*s - 5) + 44*s**2 - 59*s + 15)) + f*(-D1*bdd1*(s - 1)*(8*r + 11*s - 11) + 12*D1*fd*(-3*r*s + r + s) + 12*Dd*f*(-4*r*s + r + s))) + b1**2*(D1**2*s*(-2*fd*(28*C*r - 18*r + s) + fdd*(24*r + 29*s)) + D1*(-2*Dd*(f*(-28*C*s + r*(28*C - 18)*(4*s - 1) + 4*s**2 + 16*s + 1) + fd*(r*(12 - 96*s) + s*(41 - 116*s))) + Ddd*f*(24*r*(4*s - 1) + 116*s**2 - 82*s + 29)) + 6*Dd**2*f*(12*r*(4*s - 1) + 58*s**2 - 41*s + 4)) + b1*(-16*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*s - 32*C*D1*Dd*f**2*r*s + 8*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s + D1**2*bdd1*f*(48*r*s - 24*r + 58*s**2 - 82*s + 29) - 32*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 28*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 16*D1**2*f*fdd*r*s - 22*D1**2*f*fdd*s**2 + 8*D1**2*f*fdd*s - 16*D1**2*fd**2*r*s - 22*D1**2*fd**2*s**2 + 8*D1**2*fd**2*s - 64*D1*Dd*f**2*r*s + 16*D1*Dd*f**2*r + 56*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 14*D1*Dd*f**2 - 128*D1*Dd*f*fd*r*s + 16*D1*Dd*f*fd*r - 176*D1*Dd*f*fd*s**2 + 92*D1*Dd*f*fd*s - 8*D1*Dd*f*fd - 32*D1*Ddd*f**2*r*s + 8*D1*Ddd*f**2*r - 44*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 11*D1*Ddd*f**2 - 2*D1*bd1*(D1*(f*(-28*C*s + r*(28*C - 18)*(2*s - 1) + 2*s**2 + 16*s + 1) + fd*(r*(12 - 48*s) + s*(41 - 58*s))) + Dd*f*(-24*r*(8*s - 3) - 232*s**2 + 246*s - 53)) - 96*Dd**2*f**2*r*s + 24*Dd**2*f**2*r - 132*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 8*Dd**2*f**2))/(42*d**2*k1*k3**2) + D1**2*Pk1*Pkd2*ct*st**4*(-858*D1**2*bd1**2*f*s*(K*(4*r - 2) - 4*r + 5*s + 2) - 26*D1*bd1*(D1*(5*f**3*(10*s**2 + s*(12*r - 18) + 5) - 10*f**2*fd*(3*r*(6*s - 1) + 15*s**2 - 17*s + 2) + 132*f*s*(2*g2*(r - 1) - 2*gd2*r + gd2) - 132*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-5*f**2*(48*r*s - 6*r + 40*s**2 - 52*s + 9) - 132*g2*(8*r*s - r - 5*s + 1))) + 429*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r*(4*K - 4) + 5*s - 5) + D1*(2*Dd*(f*(r*(4*K - 4)*(4*s - 1) + 20*s**2 - s*(4*K + 6) + 5) + fd*(-2*K*(r*(8*s - 5) - s + 1) + 2*r*(8*s - 5) - 20*s**2 + 23*s - 3)) + Ddd*f*(-r*(4*K - 4)*(4*s - 1) - 20*s**2 + s*(4*K + 6) - 5)) + 2*Dd**2*f*(K*(r*(6 - 24*s) + 6*s - 2) + 6*r*(4*s - 1) - 30*s**2 + 9*s + 2)) + 13*b1*(D1**2*(-5*f**2*(2*fd - fdd)*(12*r*(3*s - 1) + 30*s**2 - 14*s + 5) + 20*f*fd**2*(6*r*(3*s - 1) + 15*s**2 - 7*s + 1) - 66*f*s*(bdd1*(4*K*r - 2*K - 4*r + 5*s + 2) + 8*gd2*r - 4*gdd2*r) - 264*r*(fd*(2*g2*(s - 1) - 2*gd2*s + gd2) - fdd*g2*(s - 1))) + 132*D1*bd1*(D1*(f*s*(K*(4*r - 2) - 4*r + 5*s + 2) + fd*(K*(-4*r*s + 2*r + s - 1) + 4*r*s - 2*r - 5*s**2 + 4*s + 1)) - Dd*f*(2*K*r*(8*s - 1) - 6*K*s + K + r*(2 - 16*s) + 20*s**2 + s - 1)) - 2*D1*(Dd*(10*f**3*(6*r*(4*s - 1) + 20*s**2 - 16*s + 5) - 5*f**2*fd*(6*r*(24*s - 7) + 120*s**2 - 76*s + 13) + 132*f*(g2*r*(8*s - 2) - 2*g2*s + gd2*(-8*r*s + r + s)) - 132*fd*g2*(r*(8*s - 5) - s + 1)) + Ddd*f*(-5*f**2*(6*r*(4*s - 1) + 20*s**2 - 16*s + 5) + 132*g2*(-4*r*s + r + s))) + 12*Dd**2*f*(5*f**2*(3*r*(4*s - 1) + 10*s**2 - 8*s + 1) + 22*g2*(3*r*(4*s - 1) - 3*s + 1))) + f*(13*D1**2*bdd1*(5*f**2*(10*s**2 + s*(12*r - 18) + 5) + 264*g2*s*(r - 1)) - f*(D1**2*(f*(2*fd*(176*r*(4*s - 1) - 2340*s**2 + 994*s - 585) + 5*fdd*(48*r*(4*s - 1) + 572*s**2 - 334*s + 143)) + 30*fd**2*(24*r*(4*s - 1) + 286*s**2 - 167*s + 8)) + D1*f*(2*Dd*(f*(176*r*(4*s - 1) - 2340*s**2 + 994*s - 585) + 5*fd*(4*s - 1)*(192*r + 572*s - 191)) + 5*Ddd*f*(48*r*(4*s - 1) + 572*s**2 - 334*s + 143)) + 30*Dd**2*f**2*(24*r*(4*s - 1) + 286*s**2 - 167*s + 8))))/(3003*d**2*k1) - D1**2*Pk1*Pkd2*ct*st**2*(D1*(-22*D1*bd1**2*(2*f*r*(K - 1)*(2*s - 1) - f*s*(3*f*(13*s - 6) - 30*s + 1) + 28*g2*(r*(2*s - 1) - s + 1)) + 2*bd1*(D1*(3*f**3*(8*r*(3*s - 2) - 110*s**2 + 110*s - 55) + f**2*(2*fd*(16*r*(18*s - 7) + 693*s**2 - 510*s + 32) + s*(11*r*(2*K + 6) - 99*s)) + 11*f*(g2*r*(8 - 36*s) + 28*g2*s + (2*s - 1)*(11*fd*s + 4*gd2*r)) + 44*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(f**2*(32*r*(24*s - 11) + 1848*s**2 - 1482*s + 295) + 121*f*s*(4*s - 1) + 44*g2*(r*(8*s - 5) - s + 1))) + f*(88*D1*b2*fd*(r*(2*s - 1) - s) + D1*bdd1*(f**2*(64*r*(3*s - 2) + 462*s**2 - 462*s + 231) + 121*f*s**2 + 88*g2*r*(s - 1)) + 88*D1*f*r*s*(bd2 - gd2) + 88*D1*fd*g2*(-2*r*s + r + s) + 88*Dd*b2*f*(r*(4*s - 1) - s) + 88*Dd*f*g2*(-4*r*s + r + s))) + 11*b1**3*(3*D1**2*s**2*(2*fd - fdd) + D1*(2*Dd*(28*K*s + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s - r*(28*K - 28)*(4*s - 1) - 28*s**2 - 14*s - 7) + Ddd*(-28*K*s - 3*f*(4*s**2 - 2*s + 1) + 7*r*(4*K - 4)*(4*s - 1) + 28*s**2 + 14*s + 7)) + 2*Dd**2*(14*K*(3*r*(4*s - 1) - 3*s + 1) - 18*f*s**2 + 9*f*s - 42*r*(4*s - 1) + 42*s**2 + 21*s - 14)) + 11*b1**2*(36*D1**2*K*fd*r*s - 28*D1**2*K*fd*r - 8*D1**2*K*fd*s - 4*D1**2*K*fdd*r*s + 4*D1**2*K*fdd*s + D1**2*bdd1*(-28*K*s + f*(-9*s**2 + 6*s - 3) + 7*r*(4*K - 4)*(3*s - 1) + 21*s**2 + 14*s + 7) + 64*D1**2*f*fd*r*s - 8*D1**2*f*fd*r - 108*D1**2*f*fd*s**2 + 52*D1**2*f*fd*s - 30*D1**2*f*fd + 78*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd + 78*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s - 36*D1**2*fd*r*s + 28*D1**2*fd*r + 32*D1**2*fd*s**2 - 52*D1**2*fd*s + 30*D1**2*fd + 4*D1**2*fdd*r*s - 30*D1**2*fdd*s**2 + 54*D1**2*fdd*s - 29*D1**2*fdd + 112*D1**2*gd2*r*s - 56*D1**2*gdd2*r*s + 144*D1*Dd*K*f*r*s - 36*D1*Dd*K*f*r - 36*D1*Dd*K*f*s - 32*D1*Dd*K*fd*r*s + 4*D1*Dd*K*fd*r + 20*D1*Dd*K*fd*s - 4*D1*Dd*K*fd + 128*D1*Dd*f**2*r*s - 32*D1*Dd*f**2*r - 216*D1*Dd*f**2*s**2 + 76*D1*Dd*f**2*s - 54*D1*Dd*f**2 + 624*D1*Dd*f*fd*s**2 - 324*D1*Dd*f*fd*s + 42*D1*Dd*f*fd - 144*D1*Dd*f*r*s + 36*D1*Dd*f*r + 128*D1*Dd*f*s**2 - 28*D1*Dd*f*s + 32*D1*Dd*f + 32*D1*Dd*fd*r*s - 4*D1*Dd*fd*r - 240*D1*Dd*fd*s**2 + 272*D1*Dd*fd*s - 54*D1*Dd*fd + 448*D1*Dd*g2*r*s - 112*D1*Dd*g2*r - 112*D1*Dd*g2*s - 448*D1*Dd*gd2*r*s + 56*D1*Dd*gd2*r + 56*D1*Dd*gd2*s - 16*D1*Ddd*K*f*r*s + 4*D1*Ddd*K*f*r + 4*D1*Ddd*K*f*s + 156*D1*Ddd*f**2*s**2 - 78*D1*Ddd*f**2*s + 39*D1*Ddd*f**2 + 16*D1*Ddd*f*r*s - 4*D1*Ddd*f*r - 120*D1*Ddd*f*s**2 + 56*D1*Ddd*f*s - 30*D1*Ddd*f - 224*D1*Ddd*g2*r*s + 56*D1*Ddd*g2*r + 56*D1*Ddd*g2*s + 2*D1*bd1*(D1*(28*K*s + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s - r*(28*K - 28)*(3*s - 1) - 21*s**2 - 14*s - 7) + Dd*(14*K*(24*r*s - 7*r - 7*s + 2) - 3*f*(12*s**2 - 7*s + 1) - 336*r*s + 98*r + 84*s**2 + 49*s - 21)) - 48*Dd**2*K*f*r*s + 12*Dd**2*K*f*r + 12*Dd**2*K*f*s - 4*Dd**2*K*f + 468*Dd**2*f**2*s**2 - 234*Dd**2*f**2*s + 48*Dd**2*f*r*s - 12*Dd**2*f*r - 360*Dd**2*f*s**2 + 168*Dd**2*f*s + 4*Dd**2*f - 672*Dd**2*g2*r*s + 168*Dd**2*g2*r + 168*Dd**2*g2*s - 56*Dd**2*g2) + b1*(88*D1**2*K*f*fd*r*s - 44*D1**2*K*f*fd*r - 44*D1**2*K*f*fd*s + 22*D1**2*bd1**2*(14*K*(r*(6*s - 2) - 2*s + 1) - 9*f*s**2 + 6*f*s + r*(28 - 84*s) + 21*s**2 + 14*s - 14) + 11*D1**2*bdd1*(6*f**2*(13*s**2 - 6*s + 3) + f*(-r*(4*K - 4)*(2*s - 1) - 60*s**2 + 2*s - 1) + 56*g2*(-2*r*s + r + s)) + 432*D1**2*f**2*fd*r*s - 48*D1**2*f**2*fd*r - 1980*D1**2*f**2*fd*s**2 + 516*D1**2*f**2*fd*s - 330*D1**2*f**2*fd + 576*D1**2*f**2*fdd*r*s - 64*D1**2*f**2*fdd*r + 1386*D1**2*f**2*fdd*s**2 - 654*D1**2*f**2*fdd*s + 231*D1**2*f**2*fdd + 1152*D1**2*f*fd**2*r*s - 128*D1**2*f*fd**2*r + 2772*D1**2*f*fd**2*s**2 - 1308*D1**2*f*fd**2*s + 64*D1**2*f*fd**2 + 264*D1**2*f*fd*r*s - 132*D1**2*f*fd*r - 396*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 198*D1**2*f*fd + 242*D1**2*f*fdd*s**2 - 242*D1**2*f*fdd*s + 121*D1**2*f*fdd - 792*D1**2*f*gd2*r*s + 88*D1**2*f*gdd2*r*s + 242*D1**2*fd**2*s**2 - 242*D1**2*fd**2*s - 792*D1**2*fd*g2*r*s + 616*D1**2*fd*g2*r + 176*D1**2*fd*g2*s + 176*D1**2*fd*gd2*r*s - 88*D1**2*fd*gd2*s + 88*D1**2*fdd*g2*r*s - 88*D1**2*fdd*g2*s + 176*D1*Dd*K*f**2*r*s - 44*D1*Dd*K*f**2*r - 44*D1*Dd*K*f**2*s + 576*D1*Dd*f**3*r*s - 144*D1*Dd*f**3*r - 2640*D1*Dd*f**3*s**2 + 1176*D1*Dd*f**3*s - 660*D1*Dd*f**3 + 4608*D1*Dd*f**2*fd*r*s - 832*D1*Dd*f**2*fd*r + 11088*D1*Dd*f**2*fd*s**2 - 5964*D1*Dd*f**2*fd*s + 718*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r*s - 132*D1*Dd*f**2*r - 792*D1*Dd*f**2*s**2 + 264*D1*Dd*f**2*s - 198*D1*Dd*f**2 + 1936*D1*Dd*f*fd*s**2 - 1452*D1*Dd*f*fd*s + 242*D1*Dd*f*fd - 3168*D1*Dd*f*g2*r*s + 792*D1*Dd*f*g2*r + 792*D1*Dd*f*g2*s + 704*D1*Dd*f*gd2*r*s - 88*D1*Dd*f*gd2*r - 88*D1*Dd*f*gd2*s + 704*D1*Dd*fd*g2*r*s - 88*D1*Dd*fd*g2*r - 440*D1*Dd*fd*g2*s + 88*D1*Dd*fd*g2 + 768*D1*Ddd*f**3*r*s - 192*D1*Ddd*f**3*r + 1848*D1*Ddd*f**3*s**2 - 1116*D1*Ddd*f**3*s + 462*D1*Ddd*f**3 + 484*D1*Ddd*f**2*s**2 - 242*D1*Ddd*f**2*s + 121*D1*Ddd*f**2 + 352*D1*Ddd*f*g2*r*s - 88*D1*Ddd*f*g2*r - 88*D1*Ddd*f*g2*s + 22*D1*bd1*(D1*(2*f**2*(2*r*(8*s - 3) - 27*s**2 + 6*s - 6) + f*(r*(4*K - 4)*(9*s - 1) + s**2*(156*fd + 32) - s*(14*K + 78*fd - 12) + 1) + fd*(K*(r*(2 - 8*s) + 4*s - 2) + r*(8*s - 2) - 60*s**2 + 55*s + 2) + 28*g2*r*(4*s - 2) - 56*g2*s + 28*gd2*(-4*r*s + r + s)) + Dd*(6*f**2*(52*s**2 - 25*s + 3) + f*(K*(-4*r*(8*s - 3) + 4*s - 2) + 4*r*(8*s - 3) - 240*s**2 + 60*s + 1) - 56*g2*(r*(8*s - 3) - 3*s + 1))) + 2304*Dd**2*f**3*r*s - 576*Dd**2*f**3*r + 5544*Dd**2*f**3*s**2 - 3348*Dd**2*f**3*s + 192*Dd**2*f**3 + 1452*Dd**2*f**2*s**2 - 726*Dd**2*f**2*s + 1056*Dd**2*f*g2*r*s - 264*Dd**2*f*g2*r - 264*Dd**2*f*g2*s + 88*Dd**2*f*g2))/(462*d**2*k1) + D1**2*Pk1*Pkd2*ct*(2*D1*(D1*bd1**2*f*(-r*(2*s - 1)*(2*K + 4*f + 2) - s*(18*f + 19)*(s - 1)) + 4*D1*bdd1*f*g2*r*(s - 1) - 2*b2*(D1*bd1*(-2*f*r*(s - 1) + fd*r*(2*s - 1) - fd*s + fd) + D1*bdd1*f*r*(s - 1) + Dd*bd1*f*(r*(8*s - 5) - s + 1)) + 2*bd1*(D1*(f*r*(-2*bd2*s + bd2 - 18*g2*(s - 1) + 4*gd2*s - 2*gd2) + 2*fd*g2*(r*(2*s - 1) - s + 1)) + 2*Dd*f*g2*(r*(8*s - 5) - s + 1))) + b1**3*(D1**2*s*(8*fd*r + 14*fd*s - 4*fdd*r - 21*fdd*s) + D1*(2*Dd*(f*(4*r*(4*s - 1) + 28*s**2 - 18*s + 7) + fd*(r*(2 - 16*s) + s*(23 - 84*s)) + 56*s**2 - 28*s + 14) - Ddd*(f*(4*r*(4*s - 1) + 84*s**2 - 46*s + 21) + 56*s**2 - 28*s + 14)) - 2*Dd**2*(f*(6*r*(4*s - 1) + 126*s**2 - 69*s + 2) + 42*s*(2*s - 1))) + b1**2*(36*D1**2*K*fd*r*s - 36*D1**2*K*fd*s - 4*D1**2*K*fdd*r*s + 4*D1**2*K*fdd*s - D1**2*bdd1*(f*(4*r*(3*s - 1) + 63*s**2 - 46*s + 21) + 42*s**2 - 28*s + 14) + 32*D1**2*f*fd*r*s + 24*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s - 16*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*s**2 + 8*D1**2*f*fdd*s - 16*D1**2*fd**2*r*s - 36*D1**2*fd**2*s**2 + 8*D1**2*fd**2*s - 20*D1**2*fd*r*s + 10*D1**2*fd*s**2 + 20*D1**2*fd*s - 4*D1**2*fdd*r*s - 19*D1**2*fdd*s**2 + 4*D1**2*fdd*s + 144*D1*Dd*K*f*r*s - 36*D1*Dd*K*f*r - 36*D1*Dd*K*f*s - 32*D1*Dd*K*fd*r*s + 4*D1*Dd*K*fd*r + 20*D1*Dd*K*fd*s - 4*D1*Dd*K*fd + 64*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 40*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 128*D1*Dd*f*fd*r*s + 16*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 120*D1*Dd*f*fd*s - 8*D1*Dd*f*fd - 80*D1*Dd*f*r*s + 20*D1*Dd*f*r + 40*D1*Dd*f*s**2 + 10*D1*Dd*f - 32*D1*Dd*fd*r*s + 4*D1*Dd*fd*r - 152*D1*Dd*fd*s**2 + 58*D1*Dd*fd*s - 4*D1*Dd*fd - 16*D1*Ddd*K*f*r*s + 4*D1*Ddd*K*f*r + 4*D1*Ddd*K*f*s - 32*D1*Ddd*f**2*r*s + 8*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 44*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 - 16*D1*Ddd*f*r*s + 4*D1*Ddd*f*r - 76*D1*Ddd*f*s**2 + 42*D1*Ddd*f*s - 19*D1*Ddd*f + 2*D1*bd1*(D1*(f*(4*r*(3*s - 1) + 21*s**2 - 18*s + 7) + fd*(r*(2 - 12*s) + s*(23 - 63*s)) + 42*s**2 - 28*s + 14) - Dd*(f*(2*r*(24*s - 7) + 252*s**2 - 161*s + 25) + 168*s**2 - 98*s + 14)) - 48*Dd**2*K*f*r*s + 12*Dd**2*K*f*r + 12*Dd**2*K*f*s - 4*Dd**2*K*f - 96*Dd**2*f**2*r*s + 24*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 132*Dd**2*f**2*s - 8*Dd**2*f**2 - 48*Dd**2*f*r*s + 12*Dd**2*f*r - 228*Dd**2*f*s**2 + 126*Dd**2*f*s - 4*Dd**2*f) - b1*(2*D1**2*bd1**2*(f*(4*r*(3*s - 1) + 63*s**2 - 46*s + 2) + 14*s*(3*s - 2)) + D1**2*bdd1*f*(2*f*(8*r*s - 4*r + 18*s**2 - 18*s + 9) + r*(4*K + 4)*(2*s - 1) + 38*s**2 - 38*s + 19) - 4*D1*Dd*(f*(bd2*(-8*r*s + r + s) - 18*g2*r*(4*s - 1) + 18*g2*s - 2*gd2*(-8*r*s + r + s)) + 2*fd*g2*(r*(8*s - 1) - 5*s + 1)) - 2*D1*bd1*(D1*(2*f**2*(r*(8*s - 4) + 6*s**2 - 6*s + 3) + f*(-4*fd*(r*(8*s - 2) + 18*s**2 - 11*s + 1) + r*(18*K - 10)*(2*s - 1) + 10*s**2 - 10*s + 5) + fd*(K*(r*(2 - 8*s) + 4*s - 2) + r*(2 - 8*s) - 38*s**2 + 23*s - 2)) - Dd*f*(2*K*(16*r*s - 6*r - 2*s + 1) + 2*f*(4*r*(8*s - 3) + 72*s**2 - 58*s + 11) + 32*r*s - 12*r + 152*s**2 - 118*s + 21)) - 4*D1*(D1*s*(bd2*(2*f*r - 2*fd*r + fd) - bdd2*f*r - 18*f*gd2*r + 2*f*gdd2*r - 2*fd*(9*g2*(r - 1) - 2*gd2*r + gd2) + 2*fdd*g2*r - 2*fdd*g2) + 2*Ddd*f*g2*(r*(4*s - 1) - s)) - 8*Dd**2*f*g2*(3*r*(4*s - 1) - 3*s + 1) - 4*b2*(-D1*Dd*(2*f*(-4*r*s + r + s) + fd*r*(8*s - 1) - 5*fd*s + fd) + D1*(D1*s*(2*fd - fdd)*(r - 1) + Ddd*f*(-4*r*s + r + s)) - Dd**2*f*(3*r*(4*s - 1) - 3*s + 1))))/(21*d**2*k1) - 2*D1**2*Pk1*Pkd2*f*k1**2*st**4*(D1**2*(f*(2*fd - fdd)*(5*C*(3*s**2 - 2*s + 1) - 3*r*s + r - 6*s**2 + 5*s - 2) + fd**2*(r*(6*s - 2) - s**2*(30*C - 12) + s*(20*C - 10) + 1)) + D1*f*(Dd*(2*f*(5*C*(4*s**2 - 2*s + 1) - 4*r*s + r - 8*s**2 + 5*s - 2) + fd*(-10*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r + 48*s**2 - 35*s + 6)) - Ddd*f*(5*C*(4*s**2 - 2*s + 1) - 4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f**2*(3*r*(4*s - 1) + s**2*(24 - 60*C) + s*(30*C - 15) + 1))/(231*d**2*k2*k3**2) - 5*D1**2*Pk1*Pkd2*f*k2*st**6*(13*D1*bd1*f*(D1*(29*f*s*(r - 1) - 31*fd*(6*r*s - r - 3*s + 1)) - 31*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 13*b1*(D1*Dd*f*(29*f*(-4*r*s + r + s) + 31*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(29*f*fd - 31*f*fdd - 62*fd**2) + 31*Ddd*f**2*(4*r*s - r - s)) + 31*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(3*D1*Dd*f*(21*f*(r*(4*s - 1) - s) - 34*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(63*f*fd*(r*(4*s - 1) - s) + f*(-403*bdd1*s*(r - 1) - 51*fdd*r*(4*s - 1) + 51*fdd*s) - 51*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 51*Ddd*f**2*(-4*r*s + r + s)) - 51*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k1**2) + D1**2*Pk1*Pkd2*k1**2*st**2*(b1**2*(D1**2*s*(2*fd - fdd)*(r - s*(C - 2)) + D1*(-2*Dd*f*(4*C*s**2 - 2*C*s + C - 4*r*s + r - 8*s**2 + 5*s - 2) + Dd*fd*(-8*r*s + r + s*(C*(8*s - 2) - 16*s + 5)) + Ddd*f*(4*C*s**2 - 2*C*s + C - 4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f*(r*(3 - 12*s) + s**2*(12*C - 24) + s*(15 - 6*C) - 1)) + b1*(12*C*D1**2*f*fd*s**2 - 16*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 8*C*D1**2*f*fdd*s**2 + 10*C*D1**2*f*fdd*s - 5*C*D1**2*f*fdd - 8*C*D1**2*fd**2*s**2 + 10*C*D1**2*fd**2*s + 24*C*D1*Dd*f**2*s**2 - 12*C*D1*Dd*f**2*s + 6*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*s**2 + 56*C*D1*Dd*f*fd*s - 10*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*s**2 + 8*C*D1*Ddd*f**2*s - 4*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*s**2 + 24*C*Dd**2*f**2*s + D1**2*bdd1*f*(2*C*s**2 - 2*C*s + C - 2*r*s + r - 4*s**2 + 5*s - 2) + 2*D1**2*f*fd*r*s + D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s - 2*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*s**2 + D1**2*f*fdd*s - 2*D1**2*fd**2*r*s - 4*D1**2*fd**2*s**2 + D1**2*fd**2*s + 4*D1*Dd*f**2*r*s - D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 9*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 16*D1*Dd*f*fd*r*s + 2*D1*Dd*f*fd*r - 32*D1*Dd*f*fd*s**2 + 14*D1*Dd*f*fd*s - D1*Dd*f*fd - 4*D1*Ddd*f**2*r*s + D1*Ddd*f**2*r - 8*D1*Ddd*f**2*s**2 + 5*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + D1*bd1*(-2*D1*f*(2*C*s**2 - 2*C*s + C - 2*r*s + r - 4*s**2 + 5*s - 2) + D1*fd*(-4*r*s + r + s*(4*C*s - 2*C - 8*s + 5)) + 2*Dd*f*(8*C*s**2 - 6*C*s + C - 8*r*s + 3*r - 16*s**2 + 15*s - 3)) - 12*Dd**2*f**2*r*s + 3*Dd**2*f**2*r - 24*Dd**2*f**2*s**2 + 15*Dd**2*f**2*s - Dd**2*f**2) + f*(24*C*D1**2*f*fd*s**2 - 16*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 15*C*D1**2*f*fdd*s**2 + 10*C*D1**2*f*fdd*s - 5*C*D1**2*f*fdd - 30*C*D1**2*fd**2*s**2 + 20*C*D1**2*fd**2*s + 32*C*D1*Dd*f**2*s**2 - 16*C*D1*Dd*f**2*s + 8*C*D1*Dd*f**2 - 120*C*D1*Dd*f*fd*s**2 + 70*C*D1*Dd*f*fd*s - 10*C*D1*Dd*f*fd - 20*C*D1*Ddd*f**2*s**2 + 10*C*D1*Ddd*f**2*s - 5*C*D1*Ddd*f**2 - 60*C*Dd**2*f**2*s**2 + 30*C*Dd**2*f**2*s - D1**2*bd1**2*(r*(2*s - 1) - (s - 1)*(s*(2*C - 4) + 1)) + D1**2*bdd1*f*(C*(-4*s**2 - 2*s + 1) - (s - 1)*(r + 2*s - 2)) - 3*D1**2*f*fd*r*s + D1**2*f*fd*r + D1**2*f*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r + D1*Dd*f**2*s + D1*bd1*(D1*(f*(C*(6*s**2 + 4*s - 2) + r*(s - 2) + 4*s**2 - 7*s + 4) + fd*(r*(2 - 4*s) - s**2*(16*C + 8) + s*(6*C + 9) - 1)) + Dd*f*(C*(2 - 32*s**2) + r*(5 - 8*s) - 16*s**2 + 21*s - 5))))/(21*d**2*k2*k3**2) - 2*D1**2*Pk1*Pkd2*k1**2*(2*D1*f*(s - 1)*(3*C*D1*bdd1*f*(s - 1) + bd1*(C*D1*s*(7*bd1 + 12*fd) + 6*C*Dd*f*(4*s - 1) + 3*D1*f*r)) + 7*b1**2*(C*(D1**2*fdd*s**2 + 2*D1*Dd*fd*s*(4*s - 1) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1)) + D1*(D1*fd*r*s + Dd*f*(4*r*s - r - s))) + b1*(7*C*D1**2*bdd1*f*(2*s**2 - 2*s + 1) + 6*C*(2*D1**2*s**2*(f*fdd + fd**2) + D1*f*(4*Dd*fd*s*(4*s - 1) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)) + 7*D1*bd1*(2*C*(2*s - 1)*(D1*fd*s + Dd*f*(4*s - 1)) + D1*f*(r*(2*s - 1) - s)) + 6*D1*f*(D1*fd*s*(2*r - 1) + Dd*f*(4*r*s - r - s))))/(21*d**2*k2*k3**2) + 5*D1**2*Pk1*Pkd2*k2*st**6*(-33*D1*bd1*f*(-2*D1*f*s*(5*C*s - r + 1) - D1*fd*r*(4*s - 1) + D1*fd*(2*s - 1)*(10*C*s + 1) + Dd*f*(40*C*s**2 - 8*r*s + r + s*(5 - 10*C) - 1)) + 33*b1*(5*C*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(5*C*(D1**2*(-f*(33*bdd1*s**2 + fd*(-6*s**2 + 4*s - 2) + 3*fdd*s**2 - 2*fdd*s + fdd) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + D1*Dd*f*(2*f*(-4*r*s + r + s) + fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(2*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + fdd*r*(3*s - 1) - fdd*s) + fd**2*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - 2*D1**2*Pk1*Pkd2*k2*st**4*(-33*D1**2*bd1**2*f*(r*(2*s - 1) - (s - 1)*(2*C*s + 1)) - 33*D1*bd1*(b1*(2*C*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - D1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) + 2*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(2*C*(D1*(-2*f*s*(r + 3*s - 1) + fd*(8*r*s - 2*r + 18*s**2 - 13*s + 2)) + Dd*f*(2*r*(8*s - 1) + 36*s**2 - 19*s + 2)) + D1*f*s*(r - 1))) - 33*b1**2*(C*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1*(C*(D1**2*(f*(4*fd*(2*r*s - r + 6*s**2 - 6*s + 3) + fdd*(-8*r*s + 4*r - 18*s**2 + 18*s - 9)) + 2*fd**2*(r*(2 - 4*s) - s*(9*s - 9))) + D1*f*(2*Dd*(2*f*(4*r*s - r + 12*s**2 - 7*s + 3) + fd*(-32*r*s + 12*r - 72*s**2 + 58*s - 11)) + Ddd*f*(r*(4 - 16*s) - 36*s**2 + 22*s - 9)) - 2*Dd**2*f**2*(6*r*(4*s - 1) + 54*s**2 - 33*s + 2)) + D1**2*bdd1*f*(2*C*s**2 - 2*C*s + C - 2*r*s + r + s) + D1*f*(D1*fd*r*(1 - 2*s) + Dd*f*(-4*r*s + r + s))) + f*(D1**2*(f*(-33*C*bdd1*s*(4*r + 9*s - 4) + 2*fd*(-8*C*s + r*(8*C - 1)*(3*s - 1) - 6*s**2 + 5*s - 2) + fdd*(8*C*s - r*(8*C - 1)*(3*s - 1) + 6*s**2 - 5*s + 2)) + fd**2*(-8*C*(r*(6*s - 2) - 2*s + 1) + r*(6*s - 2) + 12*s**2 - 10*s + 1)) + D1*f*(Dd*(2*f*(-8*C*s + r*(8*C - 1)*(4*s - 1) - 8*s**2 + 5*s - 2) + fd*(-8*C*(24*r*s - 7*r - 7*s + 2) + 24*r*s - 7*r + 48*s**2 - 35*s + 6)) + Ddd*f*(8*C*s - r*(8*C - 1)*(4*s - 1) + 8*s**2 - 5*s + 2)) + Dd**2*f**2*(-8*C*(3*r*(4*s - 1) - 3*s + 1) + 3*r*(4*s - 1) + 24*s**2 - 15*s + 1)))/(231*d**2*k3**2) - D1**2*Pk1*Pkd2*k2*st**2*(D1*f*(-D1*bd1**2*(14*C*(r*(4*s - 2) + 5*s**2 - 7*s + 2) - 2*r*s + r - 4*s**2 + 5*s - 1) + bd1*(D1*(f*(4*C*(s - 1)*(r - s + 1) + r - 4*s**2 + 7*s - 4) + fd*(4*C*(4*r*s - 2*r + 5*s**2 - 6*s + 1) + 4*r*s - 2*r + 8*s**2 - 9*s + 1)) + Dd*f*(2*C*(2*r*(8*s - 5) + 20*s**2 - 27*s + 7) + 8*r*s - 5*r + 16*s**2 - 21*s + 5)) + f*(D1*bdd1*(s - 1)*(C*(4*r + 5*s - 5) + r + 2*s - 2) + D1*fd*(3*r*s - r - s) + Dd*f*(4*r*s - r - s))) + b1**2*(D1**2*s*(fd*(28*C*r + 28*C*s - 9*r - 4*s) + fdd*(-28*C*r - 35*C*s + r + 2*s)) + D1*(Dd*(f*(28*C*(4*r*s - r + 4*s**2 - 3*s + 1) - 36*r*s + 9*r - 16*s**2 + 17*s - 4) - fd*(r*(28*C - 1)*(8*s - 1) + s*(280*C*s - 98*C - 16*s + 5))) - Ddd*f*(7*C*(16*r*s - 4*r + 20*s**2 - 14*s + 5) - 4*r*s + r - 8*s**2 + 5*s - 2)) + Dd**2*f*(-14*C*(24*r*s - 6*r + 30*s**2 - 21*s + 2) + 12*r*s - 3*r + 24*s**2 - 15*s + 1)) + b1*(8*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*s**2 - 4*C*D1**2*f*fd*s + 8*C*D1**2*f*fdd*r*s + 10*C*D1**2*f*fdd*s**2 - 4*C*D1**2*f*fdd*s + 8*C*D1**2*fd**2*r*s + 10*C*D1**2*fd**2*s**2 - 4*C*D1**2*fd**2*s + 16*C*D1*Dd*f**2*r*s - 4*C*D1*Dd*f**2*r - 16*C*D1*Dd*f**2*s**2 + 4*C*D1*Dd*f**2*s - 4*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r*s - 8*C*D1*Dd*f*fd*r + 80*C*D1*Dd*f*fd*s**2 - 44*C*D1*Dd*f*fd*s + 4*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r*s - 4*C*D1*Ddd*f**2*r + 20*C*D1*Ddd*f**2*s**2 - 14*C*D1*Ddd*f**2*s + 5*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r*s - 12*C*Dd**2*f**2*r + 60*C*Dd**2*f**2*s**2 - 42*C*Dd**2*f**2*s + 4*C*Dd**2*f**2 - D1**2*bdd1*f*(7*C*(8*r*s - 4*r + 10*s**2 - 14*s + 5) - 2*r*s + r - 4*s**2 + 5*s - 2) - D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + D1**2*f*fd*s + 2*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*s**2 - D1**2*f*fdd*s + 2*D1**2*fd**2*r*s + 4*D1**2*fd**2*s**2 - D1**2*fd**2*s - 16*D1*Dd*f**2*s**2 + 8*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 16*D1*Dd*f*fd*r*s - 2*D1*Dd*f*fd*r + 32*D1*Dd*f*fd*s**2 - 14*D1*Dd*f*fd*s + D1*Dd*f*fd + 4*D1*Ddd*f**2*r*s - D1*Ddd*f**2*r + 8*D1*Ddd*f**2*s**2 - 5*D1*Ddd*f**2*s + 2*D1*Ddd*f**2 + D1*bd1*(D1*(f*(28*C*(2*s - 1)*(r + s - 1) - 18*r*s + 9*r - 8*s**2 + 17*s - 4) - fd*(r*(28*C - 1)*(4*s - 1) + s*(140*C*s - 98*C - 8*s + 5))) + 2*Dd*f*(-7*C*(4*r*(8*s - 3) + 40*s**2 - 42*s + 9) + 8*r*s - 3*r + 16*s**2 - 15*s + 3)) + 12*Dd**2*f**2*r*s - 3*Dd**2*f**2*r + 24*Dd**2*f**2*s**2 - 15*Dd**2*f**2*s + Dd**2*f**2))/(21*d**2*k3**2) + 15*D1**2*Pk1*Pkd2*st**6*(143*b1**2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + 13*b1*f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(44*bd1 - 22*bdd1)) + 2*fd*s*(bd1*(22 - 44*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(22*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f**2*(D1**2*(f*(-4*fd*(4*s**2 - 2*s + 1) + fdd*(8*s**2 - 4*s + 2) + s**2*(26*bd1 - 13*bdd1)) - 2*s*(143*bd1**2*s + 13*bd1*fd*(3*s - 1) + 6*fd**2*(1 - 2*s))) + 2*D1*f*(Dd*f*(-8*s**2 + 4*s - 2) + Dd*(4*s - 1)*(-13*bd1*s + fd*(8*s - 2)) + Ddd*f*(4*s**2 - 2*s + 1)) + 12*Dd**2*f**2*s*(2*s - 1)))/(2002*d**2*k2) + D1**2*Pk1*Pkd2*st**4*(858*D1**2*bd1**2*f*s*(-5*K*s + f*(2*r + 9*s - 1) + 2*r - 5*s - 1) - 26*D1*bd1*(D1*(f**3*(15*s**2 + s*(8*r - 24) + 10) + f**2*fd*(r*(4 - 24*s) - 45*s**2 + 43*s - 2) - 165*f*s**2*(b2 - bd2 - 2*g2 + 2*gd2) + 165*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(f**2*(-32*r*s + 4*r - 60*s**2 + 67*s - 12) + s*(165*b2 - 330*g2)*(4*s - 1))) + 2145*b1**3*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 429*b1**2*(10*D1**2*K*fd*s**2 - 20*D1**2*K*fd*s + 10*D1**2*K*fd - 5*D1**2*K*fdd*s**2 + 10*D1**2*K*fdd*s - 5*D1**2*K*fdd - 5*D1**2*bdd1*f*(3*s**2 - 2*s + 1) - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 32*D1**2*f*fd*s**2 + 32*D1**2*f*fd*s - 16*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 4*D1**2*fd**2*r*s - 2*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 4*D1**2*fd*r*s + 4*D1**2*fd*r + 10*D1**2*fd*s**2 - 20*D1**2*fd*s + 10*D1**2*fd + 2*D1**2*fdd*r*s - 2*D1**2*fdd*r - 5*D1**2*fdd*s**2 + 10*D1**2*fdd*s - 5*D1**2*fdd + 40*D1*Dd*K*f*s**2 - 20*D1*Dd*K*f*s + 10*D1*Dd*K*f - 40*D1*Dd*K*fd*s**2 + 50*D1*Dd*K*fd*s - 10*D1*Dd*K*fd - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 + 34*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 112*D1*Dd*f*fd*s + 20*D1*Dd*f*fd - 16*D1*Dd*f*r*s + 4*D1*Dd*f*r + 40*D1*Dd*f*s**2 - 16*D1*Dd*f*s + 10*D1*Dd*f + 16*D1*Dd*fd*r*s - 10*D1*Dd*fd*r - 40*D1*Dd*fd*s**2 + 48*D1*Dd*fd*s - 8*D1*Dd*fd - 20*D1*Ddd*K*f*s**2 + 10*D1*Ddd*K*f*s - 5*D1*Ddd*K*f + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 20*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 8*D1*Ddd*f*r*s - 2*D1*Ddd*f*r - 20*D1*Ddd*f*s**2 + 8*D1*Ddd*f*s - 5*D1*Ddd*f + 10*D1*bd1*(D1*f*(3*s**2 - 2*s + 1) + D1*fd*s*(1 - 3*s) + Dd*f*(-12*s**2 + 7*s - 1)) - 60*Dd**2*K*f*s**2 + 30*Dd**2*K*f*s + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 60*Dd**2*f**2*s + 2*Dd**2*f**2 + 24*Dd**2*f*r*s - 6*Dd**2*f*r - 60*Dd**2*f*s**2 + 24*Dd**2*f*s + 2*Dd**2*f) + 13*b1*(-330*D1**2*K*bdd1*f*s**2 - 330*D1**2*bd1**2*f*s*(3*s - 2) + 330*D1**2*bd2*f*s**2 - 330*D1**2*bd2*fd*s**2 + 330*D1**2*bd2*fd*s + 132*D1**2*bdd1*f**2*r*s + 594*D1**2*bdd1*f**2*s**2 - 66*D1**2*bdd1*f**2*s + 132*D1**2*bdd1*f*r*s - 330*D1**2*bdd1*f*s**2 - 66*D1**2*bdd1*f*s - 165*D1**2*bdd2*f*s**2 - 48*D1**2*f**2*fd*r*s + 16*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 28*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 24*D1**2*f**2*fdd*r*s - 8*D1**2*f**2*fdd*r + 45*D1**2*f**2*fdd*s**2 - 14*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 48*D1**2*f*fd**2*r*s - 16*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s**2 - 28*D1**2*f*fd**2*s + 4*D1**2*f*fd**2 - 660*D1**2*f*gd2*s**2 + 330*D1**2*f*gdd2*s**2 - 660*D1**2*fd*g2*s**2 + 1320*D1**2*fd*g2*s - 660*D1**2*fd*g2 + 660*D1**2*fd*gd2*s**2 - 660*D1**2*fd*gd2*s + 330*D1**2*fdd*g2*s**2 - 660*D1**2*fdd*g2*s + 330*D1**2*fdd*g2 - 1320*D1*Dd*bd2*f*s**2 + 330*D1*Dd*bd2*f*s - 64*D1*Dd*f**3*r*s + 16*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 76*D1*Dd*f**3*s - 30*D1*Dd*f**3 + 192*D1*Dd*f**2*fd*r*s - 56*D1*Dd*f**2*fd*r + 360*D1*Dd*f**2*fd*s**2 - 170*D1*Dd*f**2*fd*s + 22*D1*Dd*f**2*fd - 2640*D1*Dd*f*g2*s**2 + 1320*D1*Dd*f*g2*s - 660*D1*Dd*f*g2 + 2640*D1*Dd*f*gd2*s**2 - 660*D1*Dd*f*gd2*s + 2640*D1*Dd*fd*g2*s**2 - 3300*D1*Dd*fd*g2*s + 660*D1*Dd*fd*g2 + 32*D1*Ddd*f**3*r*s - 8*D1*Ddd*f**3*r + 60*D1*Ddd*f**3*s**2 - 38*D1*Ddd*f**3*s + 15*D1*Ddd*f**3 + 1320*D1*Ddd*f*g2*s**2 - 660*D1*Ddd*f*g2*s + 330*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f*s*(10*K*s - 2*f*r - 16*f*s + f - 4*r + 10*s + 2) + fd*(f*(r*(8*s - 2) + 36*s**2 - 20*s + 1) + r*(4*s - 2) - (s - 1)*(s*(10*K + 10) + 1))) + Dd*f*(-40*K*s**2 + 10*K*s + f*(2*r*(8*s - 1) + 72*s**2 - 24*s + 1) + 2*r*(8*s - 1) - 40*s**2 + 4*s + 1)) + 96*Dd**2*f**3*r*s - 24*Dd**2*f**3*r + 180*Dd**2*f**3*s**2 - 114*Dd**2*f**3*s + 8*Dd**2*f**3 + 3960*Dd**2*f*g2*s**2 - 1980*Dd**2*f*g2*s + 165*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))) + f*(13*D1**2*bdd1*(f**2*(15*s**2 + s*(8*r - 24) + 10) + s**2*(-165*b2 + 330*g2)) - 2*f*(D1**2*(f*(fd*(15*r*(4*s - 1) - 832*s**2 + 401*s - 208) + fdd*(25*r*(4*s - 1) + 468*s**2 - 259*s + 117)) + fd**2*(75*r*(4*s - 1) + 1404*s**2 - 777*s + 25)) + D1*f*(Dd*(f*(60*r*s - 15*r - 832*s**2 + 401*s - 208) + 4*fd*(4*s - 1)*(50*r + 234*s - 71)) + Ddd*f*(25*r*(4*s - 1) + 468*s**2 - 259*s + 117)) + Dd**2*f**2*(75*r*(4*s - 1) + 1404*s**2 - 777*s + 25))))/(3003*d**2*k2) - D1**2*Pk1*Pkd2*st**2*(-2376*D1**2*K*bd1**2*f*s**2 + 66*D1**2*K*bd1**2*f*s - 264*D1**2*K*bd1*f**2*s**2 + 660*D1**2*K*bd1*f*fd*s**2 - 330*D1**2*K*bd1*f*fd*s + 165*D1**2*K*bdd1*f**2*s**2 + 264*D1**2*bd1**2*f**2*r*s - 132*D1**2*bd1**2*f**2*r + 1254*D1**2*bd1**2*f**2*s**2 - 990*D1**2*bd1**2*f**2*s + 66*D1**2*bd1**2*f**2 + 132*D1**2*bd1**2*f*r*s - 66*D1**2*bd1**2*f*r - 2376*D1**2*bd1**2*f*s**2 + 66*D1**2*bd1**2*f*s - 924*D1**2*bd1**2*g2*s**2 + 924*D1**2*bd1**2*g2*s - 2376*D1**2*bd1*bd2*f*s**2 + 66*D1**2*bd1*bd2*f*s + 70*D1**2*bd1*f**3*r*s - 70*D1**2*bd1*f**3*r - 792*D1**2*bd1*f**3*s**2 + 1056*D1**2*bd1*f**3*s - 528*D1**2*bd1*f**3 + 780*D1**2*bd1*f**2*fd*r*s - 390*D1**2*bd1*f**2*fd*r + 2970*D1**2*bd1*f**2*fd*s**2 - 2440*D1**2*bd1*f**2*fd*s + 130*D1**2*bd1*f**2*fd + 66*D1**2*bd1*f**2*r*s - 264*D1**2*bd1*f**2*s**2 + 660*D1**2*bd1*f*fd*s**2 - 330*D1**2*bd1*f*fd*s - 3828*D1**2*bd1*f*g2*s**2 + 264*D1**2*bd1*f*g2*s - 132*D1**2*bd1*f*g2 + 4752*D1**2*bd1*f*gd2*s**2 - 132*D1**2*bd1*f*gd2*s + 4752*D1**2*bd1*fd*g2*s**2 - 4752*D1**2*bd1*fd*g2*s - 264*D1**2*bd2*f**2*s**2 + 660*D1**2*bd2*f*fd*s**2 - 330*D1**2*bd2*f*fd*s + 130*D1**2*bdd1*f**3*r*s - 130*D1**2*bdd1*f**3*r + 495*D1**2*bdd1*f**3*s**2 - 660*D1**2*bdd1*f**3*s + 330*D1**2*bdd1*f**3 + 165*D1**2*bdd1*f**2*s**2 + 2376*D1**2*bdd1*f*g2*s**2 - 132*D1**2*bdd1*f*g2*s + 66*D1**2*bdd1*f*g2 + 165*D1**2*bdd2*f**2*s**2 + 528*D1**2*f**2*gd2*s**2 - 330*D1**2*f**2*gdd2*s**2 + 1056*D1**2*f*fd*g2*s**2 - 1056*D1**2*f*fd*g2*s + 528*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*s**2 + 660*D1**2*f*fd*gd2*s - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s + 1320*D1*Dd*K*bd1*f**2*s**2 - 330*D1*Dd*K*bd1*f**2*s + 1040*D1*Dd*bd1*f**3*r*s - 650*D1*Dd*bd1*f**3*r + 3960*D1*Dd*bd1*f**3*s**2 - 3760*D1*Dd*bd1*f**3*s + 790*D1*Dd*bd1*f**3 + 1320*D1*Dd*bd1*f**2*s**2 - 330*D1*Dd*bd1*f**2*s + 19008*D1*Dd*bd1*f*g2*s**2 - 5280*D1*Dd*bd1*f*g2*s + 132*D1*Dd*bd1*f*g2 + 1320*D1*Dd*bd2*f**2*s**2 - 330*D1*Dd*bd2*f**2*s + 2112*D1*Dd*f**2*g2*s**2 - 1056*D1*Dd*f**2*g2*s + 528*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*s**2 + 660*D1*Dd*f**2*gd2*s - 5280*D1*Dd*f*fd*g2*s**2 + 3960*D1*Dd*f*fd*g2*s - 660*D1*Dd*f*fd*g2 - 1320*D1*Ddd*f**2*g2*s**2 + 660*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 3960*Dd**2*f**2*g2*s**2 + 1980*Dd**2*f**2*g2*s + 33*b1**3*(2*D1**2*s*(7*fd*r + 29*fd*s - 7*fdd*r - 18*fdd*s) + D1*(2*Dd*(-7*K*(4*s**2 - 2*s + 1) + f*(7*r*(4*s - 1) + 116*s**2 - 65*s + 29) - 56*fd*r*s + 7*fd*r - 144*fd*s**2 + 43*fd*s + 56*r*s - 14*r - 28*s**2 - 7) + Ddd*(28*K*s**2 - 14*K*s + 7*K - 2*f*(7*r*(4*s - 1) + 72*s**2 - 43*s + 18) - 56*r*s + 14*r + 28*s**2 + 7)) - 2*Dd**2*(21*K*s*(1 - 2*s) + f*(21*r*(4*s - 1) + 216*s**2 - 129*s + 7) + 21*r*(4*s - 1) - 42*s**2 + 7)) + 33*b1**2*(58*D1**2*K*fd*s**2 - 112*D1**2*K*fd*s + 56*D1**2*K*fd - 36*D1**2*K*fdd*s**2 + 70*D1**2*K*fdd*s - 35*D1**2*K*fdd - 14*D1**2*bd2*s**2 + D1**2*bdd1*(21*K*s**2 - 14*K*s + 7*K - 2*f*(7*r*(3*s - 1) + 54*s**2 - 43*s + 18) - 42*r*s + 14*r + 21*s**2 + 7) + 7*D1**2*bdd2*s**2 + 8*D1**2*f*fd*r*s - 60*D1**2*f*fd*s**2 + 14*D1**2*f*fd*s - 8*D1**2*f*fd + 8*D1**2*f*fdd*r*s + 38*D1**2*f*fdd*s**2 - 12*D1**2*f*fdd*s + 5*D1**2*f*fdd + 8*D1**2*fd**2*r*s + 38*D1**2*fd**2*s**2 - 12*D1**2*fd**2*s - 18*D1**2*fd*r*s + 14*D1**2*fd*r + 58*D1**2*fd*s**2 - 108*D1**2*fd*s + 56*D1**2*fd + 2*D1**2*fdd*r*s - 36*D1**2*fdd*s**2 + 68*D1**2*fdd*s - 35*D1**2*fdd + 28*D1**2*gd2*s**2 - 14*D1**2*gdd2*s**2 + 232*D1*Dd*K*f*s**2 - 116*D1*Dd*K*f*s + 58*D1*Dd*K*f - 288*D1*Dd*K*fd*s**2 + 352*D1*Dd*K*fd*s - 70*D1*Dd*K*fd - 56*D1*Dd*b2*s**2 + 28*D1*Dd*b2*s - 14*D1*Dd*b2 + 56*D1*Dd*bd2*s**2 - 14*D1*Dd*bd2*s + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r - 120*D1*Dd*f**2*s**2 + 56*D1*Dd*f**2*s - 30*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 8*D1*Dd*f*fd*r + 304*D1*Dd*f*fd*s**2 - 132*D1*Dd*f*fd*s + 12*D1*Dd*f*fd - 72*D1*Dd*f*r*s + 18*D1*Dd*f*r + 232*D1*Dd*f*s**2 - 98*D1*Dd*f*s + 58*D1*Dd*f + 16*D1*Dd*fd*r*s - 2*D1*Dd*fd*r - 288*D1*Dd*fd*s**2 + 342*D1*Dd*fd*s - 68*D1*Dd*fd + 112*D1*Dd*g2*s**2 - 56*D1*Dd*g2*s + 28*D1*Dd*g2 - 112*D1*Dd*gd2*s**2 + 28*D1*Dd*gd2*s - 144*D1*Ddd*K*f*s**2 + 72*D1*Ddd*K*f*s - 36*D1*Ddd*K*f + 28*D1*Ddd*b2*s**2 - 14*D1*Ddd*b2*s + 7*D1*Ddd*b2 + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 76*D1*Ddd*f**2*s**2 - 42*D1*Ddd*f**2*s + 19*D1*Ddd*f**2 + 8*D1*Ddd*f*r*s - 2*D1*Ddd*f*r - 144*D1*Ddd*f*s**2 + 70*D1*Ddd*f*s - 36*D1*Ddd*f - 56*D1*Ddd*g2*s**2 + 28*D1*Ddd*g2*s - 14*D1*Ddd*g2 + 2*D1*bd1*(D1*(-7*K*(3*s**2 - 2*s + 1) + f*(7*r*(3*s - 1) + 87*s**2 - 65*s + 29) - 42*fd*r*s + 7*fd*r - 108*fd*s**2 + 43*fd*s + 42*r*s - 14*r - 21*s**2 - 7) + Dd*(84*K*s**2 - 49*K*s + 7*K + f*(-7*r*(24*s - 7) - 432*s**2 + 301*s - 50) - 168*r*s + 49*r + 84*s**2 - 7)) - 432*Dd**2*K*f*s**2 + 216*Dd**2*K*f*s + 84*Dd**2*b2*s**2 - 42*Dd**2*b2*s + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 228*Dd**2*f**2*s**2 - 126*Dd**2*f**2*s + 4*Dd**2*f**2 + 24*Dd**2*f*r*s - 6*Dd**2*f*r - 432*Dd**2*f*s**2 + 210*Dd**2*f*s + 2*Dd**2*f - 168*Dd**2*g2*s**2 + 84*Dd**2*g2*s) + b1*(-2376*D1**2*K*bdd1*f*s**2 + 66*D1**2*K*bdd1*f*s - 33*D1**2*K*bdd1*f - 528*D1**2*K*f*fd*s**2 + 528*D1**2*K*f*fd*s - 264*D1**2*K*f*fd + 330*D1**2*K*f*fdd*s**2 - 330*D1**2*K*f*fdd*s + 165*D1**2*K*f*fdd + 330*D1**2*K*fd**2*s**2 - 330*D1**2*K*fd**2*s - 66*D1**2*bd1**2*(7*K*s*(2 - 3*s) + f*(14*r*(3*s - 1) + 108*s**2 - 86*s + 7) + 7*r*(6*s - 2) - 21*s**2 + 7) + 1914*D1**2*bd2*f*s**2 - 2376*D1**2*bd2*fd*s**2 + 2310*D1**2*bd2*fd*s + 264*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*r + 1254*D1**2*bdd1*f**2*s**2 - 990*D1**2*bdd1*f**2*s + 462*D1**2*bdd1*f**2 + 132*D1**2*bdd1*f*r*s - 66*D1**2*bdd1*f*r - 2376*D1**2*bdd1*f*s**2 + 66*D1**2*bdd1*f*s - 33*D1**2*bdd1*f - 924*D1**2*bdd1*g2*s**2 + 924*D1**2*bdd1*g2*s - 462*D1**2*bdd1*g2 - 1188*D1**2*bdd2*f*s**2 + 210*D1**2*f**2*fd*r*s - 2376*D1**2*f**2*fd*s**2 + 458*D1**2*f**2*fd*s - 264*D1**2*f**2*fd + 390*D1**2*f**2*fdd*r*s + 1485*D1**2*f**2*fdd*s**2 - 460*D1**2*f**2*fdd*s + 165*D1**2*f**2*fdd + 780*D1**2*f*fd**2*r*s + 2970*D1**2*f*fd**2*s**2 - 920*D1**2*f*fd**2*s + 132*D1**2*f*fd*r*s - 66*D1**2*f*fd*r - 528*D1**2*f*fd*s**2 + 462*D1**2*f*fd*s - 264*D1**2*f*fd + 330*D1**2*f*fdd*s**2 - 330*D1**2*f*fdd*s + 165*D1**2*f*fdd - 3828*D1**2*f*gd2*s**2 + 2376*D1**2*f*gdd2*s**2 + 330*D1**2*fd**2*s**2 - 330*D1**2*fd**2*s - 3828*D1**2*fd*g2*s**2 + 7392*D1**2*fd*g2*s - 3696*D1**2*fd*g2 + 4752*D1**2*fd*gd2*s**2 - 4620*D1**2*fd*gd2*s + 2376*D1**2*fdd*g2*s**2 - 4620*D1**2*fdd*g2*s + 2310*D1**2*fdd*g2 - 1056*D1*Dd*K*f**2*s**2 + 528*D1*Dd*K*f**2*s - 264*D1*Dd*K*f**2 + 2640*D1*Dd*K*f*fd*s**2 - 1980*D1*Dd*K*f*fd*s + 330*D1*Dd*K*f*fd - 9504*D1*Dd*bd2*f*s**2 + 2376*D1*Dd*bd2*f*s + 280*D1*Dd*f**3*r*s - 70*D1*Dd*f**3*r - 3168*D1*Dd*f**3*s**2 + 1514*D1*Dd*f**3*s - 792*D1*Dd*f**3 + 3120*D1*Dd*f**2*fd*r*s - 390*D1*Dd*f**2*fd*r + 11880*D1*Dd*f**2*fd*s**2 - 5200*D1*Dd*f**2*fd*s + 460*D1*Dd*f**2*fd + 264*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r - 1056*D1*Dd*f**2*s**2 + 462*D1*Dd*f**2*s - 264*D1*Dd*f**2 + 2640*D1*Dd*f*fd*s**2 - 1980*D1*Dd*f*fd*s + 330*D1*Dd*f*fd - 15312*D1*Dd*f*g2*s**2 + 7656*D1*Dd*f*g2*s - 3828*D1*Dd*f*g2 + 19008*D1*Dd*f*gd2*s**2 - 4752*D1*Dd*f*gd2*s + 19008*D1*Dd*fd*g2*s**2 - 23232*D1*Dd*fd*g2*s + 4620*D1*Dd*fd*g2 + 660*D1*Ddd*K*f**2*s**2 - 330*D1*Ddd*K*f**2*s + 165*D1*Ddd*K*f**2 + 520*D1*Ddd*f**3*r*s - 130*D1*Ddd*f**3*r + 1980*D1*Ddd*f**3*s**2 - 1120*D1*Ddd*f**3*s + 495*D1*Ddd*f**3 + 660*D1*Ddd*f**2*s**2 - 330*D1*Ddd*f**2*s + 165*D1*Ddd*f**2 + 9504*D1*Ddd*f*g2*s**2 - 4752*D1*Ddd*f*g2*s + 2376*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f**2*(r*(4*s - 2) - 30*s**2 + 21*s - 11) + f*(58*K*s**2 - 2*K*s + K + fd*(4*r*(4*s - 1) + 76*s**2 - 42*s + 1) - 18*r*s + 2*r + 58*s**2 + 5*s + 1) + fd*(r*(4*s - 1) - s**2*(72*K + 72) + s*(71*K + 69) + 1) + 7*g2*(4*s**2 - 4*s + 2) + 7*s*(bd2 - 2*gd2)*(2*s - 1)) + Dd*(f**2*(4*r*(8*s - 3) + 152*s**2 - 102*s + 17) - f*(288*K*s**2 - 76*K*s + K - 16*r*s + 6*r + 288*s**2 - 74*s) - 14*g2*(8*s**2 - 6*s + 1))) + 1980*Dd**2*K*f**2*s**2 - 990*Dd**2*K*f**2*s + 1560*Dd**2*f**3*r*s - 390*Dd**2*f**3*r + 5940*Dd**2*f**3*s**2 - 3360*Dd**2*f**3*s + 130*Dd**2*f**3 + 1980*Dd**2*f**2*s**2 - 990*Dd**2*f**2*s + 28512*Dd**2*f*g2*s**2 - 14256*Dd**2*f*g2*s - 33*b2*(-7*D1**2*bdd1*(2*s**2 - 2*s + 1) - 58*D1**2*fd*s**2 + 112*D1**2*fd*s - 56*D1**2*fd + 36*D1**2*fdd*s**2 - 70*D1**2*fdd*s + 35*D1**2*fdd - 232*D1*Dd*f*s**2 + 116*D1*Dd*f*s - 58*D1*Dd*f + 288*D1*Dd*fd*s**2 - 352*D1*Dd*fd*s + 70*D1*Dd*fd + 144*D1*Ddd*f*s**2 - 72*D1*Ddd*f*s + 36*D1*Ddd*f + 14*D1*bd1*(D1*(2*s**2 - 2*s + 1) + Dd*(-8*s**2 + 6*s - 1)) + 432*Dd**2*f*s**2 - 216*Dd**2*f*s)) + 33*b2*(14*D1**2*bd1**2*s*(s - 1) - D1**2*bdd1*f*(36*s**2 - 2*s + 1) - 16*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 10*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s - 32*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 80*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 10*D1*Dd*f*fd + 20*D1*Ddd*f**2*s**2 - 10*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + 2*D1*bd1*(D1*f*(29*s**2 - 2*s + 1) - 36*D1*fd*s*(s - 1) + Dd*f*(-144*s**2 + 40*s - 1)) + 60*Dd**2*f**2*s**2 - 30*Dd**2*f**2*s))/(1386*d**2*k2) - D1**2*Pk1*Pkd2*(D1*(s - 1)*(7*D1*b2*bdd1*f*(s - 1) + 2*D1*bd1*s*(bd1*f*(7*K + 6*f + 7) + 7*bd2*f - 14*f*gd2 - 14*fd*g2) - 14*D1*bdd1*f*g2*(s - 1) + 28*Dd*bd1*f*g2*(1 - 4*s) + 14*b2*bd1*(D1*fd*s + Dd*f*(4*s - 1))) + 7*b1**3*(D1**2*fdd*s**2 + 2*D1*Dd*fd*s*(4*s - 1) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1)) + b1**2*(7*D1**2*K*fdd*s**2 + 7*D1**2*bdd1*f*(3*s**2 - 2*s + 1) + 12*D1**2*f*fdd*s**2 + 12*D1**2*fd**2*s**2 + 14*D1**2*fd*r*s - 14*D1**2*fd*s + 7*D1**2*fdd*s**2 + 56*D1*Dd*K*fd*s**2 - 14*D1*Dd*K*fd*s + 96*D1*Dd*f*fd*s**2 - 24*D1*Dd*f*fd*s + 56*D1*Dd*f*r*s - 14*D1*Dd*f*r - 14*D1*Dd*f*s + 56*D1*Dd*fd*s**2 - 14*D1*Dd*fd*s + 28*D1*Ddd*K*f*s**2 - 14*D1*Ddd*K*f*s + 7*D1*Ddd*K*f + 24*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 28*D1*Ddd*f*s**2 - 14*D1*Ddd*f*s + 7*D1*Ddd*f + 14*D1*bd1*(3*s - 1)*(D1*fd*s + Dd*f*(4*s - 1)) + 84*Dd**2*K*f*s**2 - 42*Dd**2*K*f*s + 72*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 84*Dd**2*f*s**2 - 42*Dd**2*f*s) + b1*(14*D1**2*bd1**2*f*s*(3*s - 2) + D1**2*bdd1*f*(7*K + 6*f + 7)*(2*s**2 - 2*s + 1) + 7*D1**2*s**2*(2*bd2*fd + bdd2*f - 2*f*gdd2 - 4*fd*gd2 - 2*fdd*g2) + 14*D1*Dd*s*(4*s - 1)*(bd2*f - 2*f*gd2 - 2*fd*g2) - 14*D1*Ddd*f*g2*(4*s**2 - 2*s + 1) + 2*D1*bd1*(2*s - 1)*(D1*f*(12*fd*s + 7*r) + 7*D1*fd*s*(K + 1) + Dd*f*(4*s - 1)*(7*K + 6*f + 7)) + 84*Dd**2*f*g2*s*(1 - 2*s) + 7*b2*(D1**2*fdd*s**2 + 2*D1*Dd*fd*s*(4*s - 1) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1))))/(21*d**2*k2) - 5*D1**2*Pk1*Pkd2*k2**3*st**6*(33*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-4*r*s + r + 2*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 33*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 7*r + 7*s - 2)) + D1*(D1*(2*f*fd*(r*(3*s - 1) - s) + f*(-33*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) + fd**2*(r*(2 - 6*s) + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1**2*k3**2) - 2*D1**2*Pk1*Pkd2*k2**3*st**4*(D1**2*bd1**2*f*(-2*r*s + r + s - 1) + D1*bd1*(D1*b1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) - D1*f**2*s*(r - 1) - 2*Dd*b1*f*(r*(8*s - 3) - 3*s + 1)) + b1*(D1*f*(D1*bdd1*(-2*r*s + r + s) + D1*fd*r*(1 - 2*s) + Dd*f*(-4*r*s + r + s)) + b1*(D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) + D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) - Dd**2*f*(3*r*(4*s - 1) - 3*s + 1))))/(7*d**2*k1**2*k3**2) - 2*D1**2*Pk1*Pkd2*k2*st**4*(D1*f*(-33*D1*bd1**2*(f*r*(4*s - 1) - 2*f*s + f + s*(2*r - 1)) + 4*D1*bdd1*f**2*r*(1 - 2*s) - 4*bd1*f*(D1*(2*f*r*(1 - 2*s) + 4*fd*r*(3*s - 1) - 2*fd*s + fd) + Dd*f*(2*r*(8*s - 3) - 2*s + 1))) - 33*b1**2*(D1*Dd*(-2*f*(f + 1)*(r*(4*s - 1) - s) + fd*(f*(8*r - 1)*(4*s - 1) + 8*r*s - 5*r - s + 1)) + D1*(D1*r*(fd**2*(4*s - 1) + fd*(-4*f*s + f - 2*s + 2) + fdd*(4*f*s - f + s - 1)) + Ddd*f*(2*f + 1)*(r*(4*s - 1) - s)) + Dd**2*f*(2*f + 1)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(33*D1*bd1*(-D1*(f*(f*(-4*r*s + r + 2*s) - 4*r*s + 2*s) + fd*(f*(4*r - 1)*(4*s - 1) + 4*r*s - 2*r - s + 1)) - Dd*f*(f*(8*r - 3)*(4*s - 1) + 16*r*s - 2*r - 6*s + 1)) + f*(4*D1*Dd*f*(4*f*(r*(4*s - 1) - s) + fd*(r*(10 - 48*s) + 14*s - 3)) + D1*(D1*(-33*bdd1*(f*r*(4*s - 1) - 2*f*s + s*(2*r - 1)) + 8*f*fd*(r*(6*s - 1) - 2*s) + 4*f*fdd*(-6*r*s + r + 2*s) + fd**2*(r*(8 - 48*s) + 16*s - 4)) + 8*Ddd*f**2*(-4*r*s + r + s)) - 8*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(231*d**2*k1**2) + D1**2*Pk1*Pkd2*k2*st**2*(D1**2*bd1*f*r*(bd1*(f - 1)*(2*s - 1) - f*s) + D1*b1*(D1*bd1**2*(9*f + 7)*(r*(6*s - 2) - 2*s + 1) + bd1*(D1*(f*(r*(f*(5 - 10*s) + 18*s - 2) - 7*s) + fd*(f*r*(8*s - 2) - 2*f*s + f - 4*r*s + r + 2*s - 1)) + Dd*f*(f - 1)*(2*r*(8*s - 3) - 2*s + 1)) + f*(D1*bdd1*r*(f - 1)*(2*s - 1) + D1*fd*(-2*r*s + r + s) + Dd*f*(-4*r*s + r + s))) + b1**3*(D1*Dd*(r*(-44*f*s + 11*f + 72*fd*s - 9*fd - 56*s + 14) + s*(11*f - 9*fd + 14)) + D1*(D1*r*s*(-11*fd + 9*fdd) + Ddd*(9*f + 7)*(4*r*s - r - s)) + Dd**2*(9*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) - b1**2*(D1*Dd*(f*(5*f - 9)*(r*(4*s - 1) - s) - fd*(2*f*r*(8*s - 1) - 6*f*s + f - 8*r*s + r + 5*s - 1)) + D1*bd1*(D1*(r*(33*f*s - 11*f - 54*fd*s + 9*fd + 42*s - 14) + s*(-11*f + 9*fd - 14)) - Dd*(9*f + 7)*(r*(24*s - 7) - 7*s + 2)) + D1*(-D1*bdd1*(9*f + 7)*(r*(3*s - 1) - s) + D1*(fd**2*(-2*r*s + s) + fd*r*(s*(10*f - 9) + 7) + fd*s*(2 - 5*f) + fdd*s*(-2*f*r + f + r - 1)) - Ddd*f*(f - 1)*(r*(4*s - 1) - s)) - Dd**2*f*(f - 1)*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k1**2) - D1**2*Pk1*Pkdd2*ct**8*k2**2*(10*C - 10)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 2*D1*f*(28*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(693*d**2*k3**2) + 5*D1**2*Pk1*Pkdd2*ct**7*f*k2*(52*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(90*fd*(4*s**2 - 2*s + 1) - 45*fdd*(4*s**2 - 2*s + 1) + s**2*(104*bd1 - 52*bdd1)) + 2*fd*s*(-52*bd1*(3*s - 1) + 135*fd*(1 - 2*s))) + D1*f*(90*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(52*bd1*s + 45*fd*(4*s - 1)) - 45*Ddd*f*(4*s**2 - 2*s + 1)) + 270*Dd**2*f**2*s*(1 - 2*s)))/(1287*d**2*k1) + 5*D1**2*Pk1*Pkdd2*ct**7*k2**3*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 2*D1*f*(28*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(693*d**2*k1*k3**2) - D1**2*Pk1*Pkdd2*ct**6*k2**2*st**2*(5*C - 5)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(50*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k3**2) + 5*D1**2*Pk1*Pkdd2*ct**5*f*k2*st**2*(65*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(98*fd*(4*s**2 - 2*s + 1) - 49*fdd*(4*s**2 - 2*s + 1) + s**2*(130*bd1 - 65*bdd1)) + 2*fd*s*(-65*bd1*(3*s - 1) + 147*fd*(1 - 2*s))) + D1*f*(98*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(65*bd1*s + 49*fd*(4*s - 1)) - 49*Ddd*f*(4*s**2 - 2*s + 1)) + 294*Dd**2*f**2*s*(1 - 2*s)))/(858*d**2*k1) + 5*D1**2*Pk1*Pkdd2*ct**5*k2**3*st**2*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(50*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(462*d**2*k1*k3**2) - D1**2*Pk1*Pkdd2*ct**4*f*k2**2*st**4*(10*C - 10)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k3**2) + 5*D1**2*Pk1*Pkdd2*ct**3*f*k2**3*st**4*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k1*k3**2) + 5*D1**2*Pk1*Pkdd2*ct**3*f*k2*st**4*(13*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(20*fd*(4*s**2 - 2*s + 1) - 10*fdd*(4*s**2 - 2*s + 1) + s**2*(26*bd1 - 13*bdd1)) + 2*fd*s*(bd1*(13 - 39*s) + 30*fd*(1 - 2*s))) + 2*D1*f*(10*Dd*f*(4*s**2 - 2*s + 1) - Dd*(4*s - 1)*(13*bd1*s + 10*fd*(4*s - 1)) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 60*Dd**2*f**2*s*(1 - 2*s)))/(429*d**2*k1) + D1**2*Pk1*Pkdd2*ct**2*k2**2*st**6*(5*C - 5)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(693*d**2*k3**2) + 5*D1**2*Pk1*Pkdd2*ct*f*k2*st**6*(-13*b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(6*fd*(4*s**2 - 2*s + 1) - 3*fdd*(4*s**2 - 2*s + 1) + s**2*(-26*bd1 + 13*bdd1)) + 2*fd*s*(13*bd1*(3*s - 1) + 9*fd*(1 - 2*s))) + D1*f*(6*Dd*f*(4*s**2 - 2*s + 1) + 2*Dd*(4*s - 1)*(13*bd1*s + fd*(3 - 12*s)) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(2574*d**2*k1) - 5*D1**2*Pk1*Pkdd2*ct*k2**3*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*(4*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1386*d**2*k1*k3**2) + D1**2*Pk1*ct**7*k2*(33*b1*(D1**2*(f*(2*fd*(Pk2*r*(96*C - 96)*(2*s - 1) + 40*Pk2*(2*s**2 - 2*s + 1) - Pkdd2*k1**2*(20*C - 25)*(2*s**2 - 2*s + 1)) - 5*fdd*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(2*s**2 - 2*s + 1)) - 10*fd**2*s*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(s - 1)) + D1*f*(2*Dd*(f*(8*Pk2*(-12*C*s + r*(12*C - 12)*(4*s - 1) + 20*s**2 + 2*s + 5) + Pkdd2*k1**2*(25 - 20*C)*(4*s**2 - 2*s + 1)) - 5*fd*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(8*s**2 - 6*s + 1)) - 5*Ddd*f*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(4*s**2 - 2*s + 1)) - 30*Dd**2*f**2*s*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(2*s - 1)) + f*(D1**2*(f*(40*fd*(4*Pk2*(-43*C*s + r*(43*C - 43)*(3*s - 1) + 42*s**2 + 15*s + 14) + Pkdd2*k1**2*(35 - 28*C)*(3*s**2 - 2*s + 1)) - 20*fdd*(8*Pk2*(-5*C*s + r*(5*C - 5)*(3*s - 1) + 21*s**2 - 9*s + 7) + Pkdd2*k1**2*(35 - 28*C)*(3*s**2 - 2*s + 1)) + 33*s*(2*bd1*(8*Pk2*(12*C*(r - 1) - 12*r + 5*s + 12) + Pkdd2*k1**2*s*(25 - 20*C)) + 5*bdd1*s*(-8*Pk2 + Pkdd2*k1**2*(4*C - 5)))) + 10*fd*(-33*bd1*s*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(2*s - 1) - 4*fd*(4*Pk2*(5*C*(6*r*s - 2*r - 2*s + 1) - 30*r*s + 10*r + 42*s**2 - 18*s - 5) + Pkdd2*k1**2*s*(35 - 28*C)*(3*s - 2)))) + 10*D1*f*(Dd*(-33*bd1*s*(8*Pk2 + Pkdd2*k1**2*(5 - 4*C))*(4*s - 1) + 4*f*(4*Pk2*(-43*C*s + r*(43*C - 43)*(4*s - 1) + 56*s**2 + 15*s + 14) + Pkdd2*k1**2*(35 - 28*C)*(4*s**2 - 2*s + 1)) - 4*fd*(4*Pk2*(5*C*(24*r*s - 7*r - 7*s + 2) - 120*r*s + 35*r + 168*s**2 - 63*s + 4) + Pkdd2*k1**2*(35 - 28*C)*(12*s**2 - 7*s + 1))) + 2*Ddd*f*(-8*Pk2*(-5*C*s + r*(5*C - 5)*(4*s - 1) + 28*s**2 - 9*s + 7) + Pkdd2*k1**2*(28*C - 35)*(4*s**2 - 2*s + 1))) + 40*Dd**2*f**2*(-4*Pk2*(5*C*(12*r*s - 3*r - 3*s + 1) - 60*r*s + 15*r + 84*s**2 - 27*s - 5) + Pkdd2*k1**2*s*(84*C - 105)*(2*s - 1))))/(693*d**2*k1*k3**2) - 2*D1**2*Pk1*ct**6*(1584*Pk2*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(-576*C*D1**2*Pk2*f*fd*r*s + 288*C*D1**2*Pk2*f*fd*r - 752*C*D1**2*Pk2*f*fd*s**2 + 912*C*D1**2*Pk2*f*fd*s - 456*C*D1**2*Pk2*f*fd + 192*C*D1**2*Pk2*f*fdd*r*s - 96*C*D1**2*Pk2*f*fdd*r + 592*C*D1**2*Pk2*f*fdd*s**2 - 672*C*D1**2*Pk2*f*fdd*s + 336*C*D1**2*Pk2*f*fdd + 192*C*D1**2*Pk2*fd**2*r*s - 96*C*D1**2*Pk2*fd**2*r + 592*C*D1**2*Pk2*fd**2*s**2 - 672*C*D1**2*Pk2*fd**2*s + 20*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 20*C*D1**2*Pkdd2*f*fd*k1**2*s + 10*C*D1**2*Pkdd2*f*fd*k1**2 - 10*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 10*C*D1**2*Pkdd2*f*fdd*k1**2*s - 5*C*D1**2*Pkdd2*f*fdd*k1**2 - 10*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 10*C*D1**2*Pkdd2*fd**2*k1**2*s - 1152*C*D1*Dd*Pk2*f**2*r*s + 288*C*D1*Dd*Pk2*f**2*r - 1504*C*D1*Dd*Pk2*f**2*s**2 + 1040*C*D1*Dd*Pk2*f**2*s - 376*C*D1*Dd*Pk2*f**2 + 1536*C*D1*Dd*Pk2*f*fd*r*s - 576*C*D1*Dd*Pk2*f*fd*r + 4736*C*D1*Dd*Pk2*f*fd*s**2 - 4064*C*D1*Dd*Pk2*f*fd*s + 768*C*D1*Dd*Pk2*f*fd + 40*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 20*C*D1*Dd*Pkdd2*f**2*k1**2*s + 10*C*D1*Dd*Pkdd2*f**2*k1**2 - 80*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 60*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 10*C*D1*Dd*Pkdd2*f*fd*k1**2 + 384*C*D1*Ddd*Pk2*f**2*r*s - 96*C*D1*Ddd*Pk2*f**2*r + 1184*C*D1*Ddd*Pk2*f**2*s**2 - 688*C*D1*Ddd*Pk2*f**2*s + 296*C*D1*Ddd*Pk2*f**2 - 20*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 10*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 5*C*D1*Ddd*Pkdd2*f**2*k1**2 + 1152*C*Dd**2*Pk2*f**2*r*s - 288*C*Dd**2*Pk2*f**2*r + 3552*C*Dd**2*Pk2*f**2*s**2 - 2064*C*Dd**2*Pk2*f**2*s + 96*C*Dd**2*Pk2*f**2 - 60*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 30*C*Dd**2*Pkdd2*f**2*k1**2*s - 48*D1**2*Pk2*bdd1*f*(C - 1)*(2*s**2 - 2*s + 1) + 656*D1**2*Pk2*f*fd*r*s - 328*D1**2*Pk2*f*fd*r + 432*D1**2*Pk2*f*fd*s**2 - 592*D1**2*Pk2*f*fd*s + 296*D1**2*Pk2*f*fd - 232*D1**2*Pk2*f*fdd*r*s + 116*D1**2*Pk2*f*fdd*r - 432*D1**2*Pk2*f*fdd*s**2 + 512*D1**2*Pk2*f*fdd*s - 256*D1**2*Pk2*f*fdd - 232*D1**2*Pk2*fd**2*r*s + 116*D1**2*Pk2*fd**2*r - 432*D1**2*Pk2*fd**2*s**2 + 512*D1**2*Pk2*fd**2*s - 40*D1**2*Pkdd2*f*fd*k1**2*s**2 + 40*D1**2*Pkdd2*f*fd*k1**2*s - 20*D1**2*Pkdd2*f*fd*k1**2 + 20*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 20*D1**2*Pkdd2*f*fdd*k1**2*s + 10*D1**2*Pkdd2*f*fdd*k1**2 + 20*D1**2*Pkdd2*fd**2*k1**2*s**2 - 20*D1**2*Pkdd2*fd**2*k1**2*s + 1312*D1*Dd*Pk2*f**2*r*s - 328*D1*Dd*Pk2*f**2*r + 864*D1*Dd*Pk2*f**2*s**2 - 760*D1*Dd*Pk2*f**2*s + 216*D1*Dd*Pk2*f**2 - 1856*D1*Dd*Pk2*f*fd*r*s + 696*D1*Dd*Pk2*f*fd*r - 3456*D1*Dd*Pk2*f*fd*s**2 + 3144*D1*Dd*Pk2*f*fd*s - 628*D1*Dd*Pk2*f*fd - 80*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 40*D1*Dd*Pkdd2*f**2*k1**2*s - 20*D1*Dd*Pkdd2*f**2*k1**2 + 160*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 120*D1*Dd*Pkdd2*f*fd*k1**2*s + 20*D1*Dd*Pkdd2*f*fd*k1**2 - 464*D1*Ddd*Pk2*f**2*r*s + 116*D1*Ddd*Pk2*f**2*r - 864*D1*Ddd*Pk2*f**2*s**2 + 548*D1*Ddd*Pk2*f**2*s - 216*D1*Ddd*Pk2*f**2 + 40*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 20*D1*Ddd*Pkdd2*f**2*k1**2*s + 10*D1*Ddd*Pkdd2*f**2*k1**2 + 96*D1*Pk2*bd1*(C - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 1392*Dd**2*Pk2*f**2*r*s + 348*Dd**2*Pk2*f**2*r - 2592*Dd**2*Pk2*f**2*s**2 + 1644*Dd**2*Pk2*f**2*s - 116*Dd**2*Pk2*f**2 + 120*Dd**2*Pkdd2*f**2*k1**2*s**2 - 60*Dd**2*Pkdd2*f**2*k1**2*s) + f*(-3168*D1**2*Pk2*bd1**2*s*(C - 1)*(s - 1) + 33*D1**2*bdd1*f*(4*Pk2*(2*C*(12*r*s + 37*s**2 - 2*s - 5) - 29*r*s - 54*s**2 + 9*s + 10) + Pkdd2*k1**2*s**2*(10 - 5*C)) + 20*D1**2*(f*(Pk2*fd*(C*(-476*r*(3*s - 1) - 1899*s**2 + 1742*s - 633) + 552*r*(3*s - 1) + 1227*s**2 - 1370*s + 409) + Pk2*fdd*(C*(172*r*(3*s - 1) + 1395*s**2 - 1102*s + 465) - 210*r*(3*s - 1) - 1059*s**2 + 916*s - 353) + Pkdd2*fd*k1**2*(14*C - 28)*(3*s**2 - 2*s + 1) - Pkdd2*fdd*k1**2*(7*C - 14)*(3*s**2 - 2*s + 1)) + 2*fd**2*(Pk2*(C*(172*r*(3*s - 1) + 1395*s**2 - 1102*s + 86) - 630*r*s + 210*r - 1059*s**2 + 916*s - 105) + Pkdd2*k1**2*s*(14 - 7*C)*(3*s - 2))) - 66*D1*bd1*(D1*(4*Pk2*f*(C*(47*s**2 + s*(36*r - 16) - 10) - 27*s**2 + s*(21 - 41*r) + 10) + Pk2*fd*(-16*C*(3*r*(4*s - 1) + 37*s**2 - 22*s + 3) + 58*r*(4*s - 1) + 432*s**2 - 292*s + 58) + Pkdd2*f*k1**2*s**2*(10 - 5*C) + Pkdd2*fd*k1**2*s*(5*C - 10)*(2*s - 1)) + Dd*f*(-2*Pk2*(4*C*(48*r*s - 6*r + 148*s**2 - 47*s + 1) - 232*r*s + 29*r - 432*s**2 + 173*s - 9) + Pkdd2*k1**2*s*(5*C - 10)*(4*s - 1))) + 20*D1*f*(Dd*(Pk2*f*(C*(-476*r*(4*s - 1) - 2532*s**2 + 1742*s - 633) + 552*r*(4*s - 1) + 1636*s**2 - 1370*s + 409) + 2*Pk2*fd*(C*(86*r*(24*s - 7) + 5580*s**2 - 3857*s + 637) - 105*r*(24*s - 7) - 4236*s**2 + 3206*s - 563) + Pkdd2*f*k1**2*(14*C - 28)*(4*s**2 - 2*s + 1) - Pkdd2*fd*k1**2*(14*C - 28)*(12*s**2 - 7*s + 1)) + Ddd*f*(Pk2*(C*(172*r*(4*s - 1) + 1860*s**2 - 1102*s + 465) - 840*r*s + 210*r - 1412*s**2 + 916*s - 353) + Pkdd2*k1**2*(14 - 7*C)*(4*s**2 - 2*s + 1))) + 40*Dd**2*f**2*(C*Pk2*(258*r*(4*s - 1) + 2790*s**2 - 1653*s + 86) - 3*Pk2*(105*r*(4*s - 1) + 706*s**2 - 458*s + 35) + 21*Pkdd2*k1**2*s*(-2*C*s + C + 4*s - 2))))/(693*d**2*k3**2) + 2*D1**2*Pk1*ct**6*k2**2*(-2112*C*D1**2*Pk2*b1*f*fd*r**2 - 132*C*D1**2*Pk2*b1*f*fdd*r**2 - 132*C*D1**2*Pk2*b1*fd**2*r**2 - 3648*C*D1**2*Pk2*f**2*fd*r**2 + 2432*C*D1**2*Pk2*f**2*fd*r - 1216*C*D1**2*Pk2*f**2*fd - 552*C*D1**2*Pk2*f**2*fdd*r**2 + 368*C*D1**2*Pk2*f**2*fdd*r - 184*C*D1**2*Pk2*f**2*fdd - 1104*C*D1**2*Pk2*f*fd**2*r**2 + 736*C*D1**2*Pk2*f*fd**2*r - 396*C*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 198*C*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 396*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 1056*C*D1**2*Pkdd2*b1*f*fd*k1**2*s + 528*C*D1**2*Pkdd2*b1*f*fd*k1**2 + 330*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 165*C*D1**2*Pkdd2*b1*f*fdd*k1**2 + 330*C*D1**2*Pkdd2*b1*fd**2*k1**2*s + 1335*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 890*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 445*C*D1**2*Pkdd2*f**2*fd*k1**2 - 420*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 280*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 140*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 840*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 560*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 4224*C*D1*Dd*Pk2*b1*f**2*r**2 + 2112*C*D1*Dd*Pk2*b1*f**2*r - 1056*C*D1*Dd*Pk2*b1*f**2 - 1056*C*D1*Dd*Pk2*b1*f*fd*r**2 + 264*C*D1*Dd*Pk2*b1*f*fd*r - 4864*C*D1*Dd*Pk2*f**3*r**2 + 2432*C*D1*Dd*Pk2*f**3*r - 1216*C*D1*Dd*Pk2*f**3 - 4416*C*D1*Dd*Pk2*f**2*fd*r**2 + 2576*C*D1*Dd*Pk2*f**2*fd*r - 368*C*D1*Dd*Pk2*f**2*fd - 1584*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 792*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 396*C*D1*Dd*Pkdd2*b1**2*f*k1**2 + 1584*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 396*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 792*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 396*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 198*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 1320*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 330*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 1780*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 890*C*D1*Dd*Pkdd2*f**3*k1**2*s + 445*C*D1*Dd*Pkdd2*f**3*k1**2 - 3360*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 1960*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 280*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 264*C*D1*Ddd*Pk2*b1*f**2*r**2 + 132*C*D1*Ddd*Pk2*b1*f**2*r - 66*C*D1*Ddd*Pk2*b1*f**2 - 736*C*D1*Ddd*Pk2*f**3*r**2 + 368*C*D1*Ddd*Pk2*f**3*r - 184*C*D1*Ddd*Pk2*f**3 + 792*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 396*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 198*C*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 560*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 280*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 140*C*D1*Ddd*Pkdd2*f**3*k1**2 - 792*C*Dd**2*Pk2*b1*f**2*r**2 + 396*C*Dd**2*Pk2*b1*f**2*r - 2208*C*Dd**2*Pk2*f**3*r**2 + 1104*C*Dd**2*Pk2*f**3*r + 2376*C*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 1188*C*Dd**2*Pkdd2*b1**2*f*k1**2*s - 1680*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 840*C*Dd**2*Pkdd2*f**3*k1**2*s + 2112*D1**2*Pk2*b1*f*fd*r**2 - 264*D1**2*Pk2*b1*f*fd*r*s + 132*D1**2*Pk2*b1*f*fd*r + 132*D1**2*Pk2*b1*f*fdd*r**2 - 660*D1**2*Pk2*b1*f*fdd*r*s + 330*D1**2*Pk2*b1*f*fdd*r + 132*D1**2*Pk2*b1*fd**2*r**2 - 660*D1**2*Pk2*b1*fd**2*r*s + 330*D1**2*Pk2*b1*fd**2*r + 3648*D1**2*Pk2*f**2*fd*r**2 - 900*D1**2*Pk2*f**2*fd*r*s - 2132*D1**2*Pk2*f**2*fd*r + 300*D1**2*Pk2*f**2*fd*s + 1216*D1**2*Pk2*f**2*fd + 552*D1**2*Pk2*f**2*fdd*r**2 - 540*D1**2*Pk2*f**2*fdd*r*s - 188*D1**2*Pk2*f**2*fdd*r + 180*D1**2*Pk2*f**2*fdd*s + 184*D1**2*Pk2*f**2*fdd + 1104*D1**2*Pk2*f*fd**2*r**2 - 1080*D1**2*Pk2*f*fd**2*r*s - 376*D1**2*Pk2*f*fd**2*r + 360*D1**2*Pk2*f*fd**2*s - 180*D1**2*Pk2*f*fd**2 + 396*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 198*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 924*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 264*D1**2*Pkdd2*b1*f*fd*k1**2*s + 132*D1**2*Pkdd2*b1*f*fd*k1**2 - 660*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 330*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 165*D1**2*Pkdd2*b1*f*fdd*k1**2 - 660*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 330*D1**2*Pkdd2*b1*fd**2*k1**2*s + 396*D1**2*Pkdd2*bd1**2*f*k1**2*s*(C - 1)*(s - 1) + 345*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 230*D1**2*Pkdd2*f**2*fd*k1**2*s + 115*D1**2*Pkdd2*f**2*fd*k1**2 - 420*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 280*D1**2*Pkdd2*f**2*fdd*k1**2*s - 140*D1**2*Pkdd2*f**2*fdd*k1**2 - 840*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 560*D1**2*Pkdd2*f*fd**2*k1**2*s - 33*D1**2*bdd1*f*(2*Pk2*f*(r - 1)*(C*(r - 1) - r + 5*s + 1) - 6*Pkdd2*b1*k1**2*(C - 1)*(2*s**2 - 2*s + 1) + 5*Pkdd2*f*k1**2*(C*(2*s - 1) + 2*s**2 - 2*s + 1)) + 4224*D1*Dd*Pk2*b1*f**2*r**2 - 528*D1*Dd*Pk2*b1*f**2*r*s - 1980*D1*Dd*Pk2*b1*f**2*r + 132*D1*Dd*Pk2*b1*f**2*s + 1056*D1*Dd*Pk2*b1*f**2 + 1056*D1*Dd*Pk2*b1*f*fd*r**2 - 5280*D1*Dd*Pk2*b1*f*fd*r*s + 1716*D1*Dd*Pk2*b1*f*fd*r + 660*D1*Dd*Pk2*b1*f*fd*s - 330*D1*Dd*Pk2*b1*f*fd + 4864*D1*Dd*Pk2*f**3*r**2 - 1200*D1*Dd*Pk2*f**3*r*s - 2132*D1*Dd*Pk2*f**3*r + 300*D1*Dd*Pk2*f**3*s + 1216*D1*Dd*Pk2*f**3 + 4416*D1*Dd*Pk2*f**2*fd*r**2 - 4320*D1*Dd*Pk2*f**2*fd*r*s - 1316*D1*Dd*Pk2*f**2*fd*r + 1260*D1*Dd*Pk2*f**2*fd*s + 8*D1*Dd*Pk2*f**2*fd + 1584*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 792*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 396*D1*Dd*Pkdd2*b1**2*f*k1**2 - 1584*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 396*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 1848*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 924*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 462*D1*Dd*Pkdd2*b1*f**2*k1**2 - 5280*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 2640*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 330*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 460*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 230*D1*Dd*Pkdd2*f**3*k1**2*s + 115*D1*Dd*Pkdd2*f**3*k1**2 - 3360*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 1960*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 280*D1*Dd*Pkdd2*f**2*fd*k1**2 + 264*D1*Ddd*Pk2*b1*f**2*r**2 - 1320*D1*Ddd*Pk2*b1*f**2*r*s + 198*D1*Ddd*Pk2*b1*f**2*r + 330*D1*Ddd*Pk2*b1*f**2*s + 66*D1*Ddd*Pk2*b1*f**2 + 736*D1*Ddd*Pk2*f**3*r**2 - 720*D1*Ddd*Pk2*f**3*r*s - 188*D1*Ddd*Pk2*f**3*r + 180*D1*Ddd*Pk2*f**3*s + 184*D1*Ddd*Pk2*f**3 - 792*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 396*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 198*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 1320*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 660*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 330*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 560*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 280*D1*Ddd*Pkdd2*f**3*k1**2*s - 140*D1*Ddd*Pkdd2*f**3*k1**2 - 66*D1*bd1*(D1*(6*Pkdd2*b1*fd*k1**2*s*(-2*C*s + C + 2*s - 1) + f**2*(2*Pk2*(r - 1)*(8*C*(r - 1) - 8*r + s + 8) - Pkdd2*k1**2*(C*(3*s**2 + 10*s - 5) + 7*s**2 - 10*s + 5)) + f*(Pk2*fd*(r**2*(4*C - 4) + r*(-4*C + 20*s - 1) - 10*s + 5) + 6*Pkdd2*b1*k1**2*(C - 1)*(2*s**2 - 2*s + 1) + 5*Pkdd2*fd*k1**2*s*(C + 4*s - 3))) + Dd*f*(Pk2*f*(2*C*(4*r**2 - 5*r + 1) - 8*r**2 + 40*r*s + 5*r - 25*s + 3) - 6*Pkdd2*b1*k1**2*(C - 1)*(8*s**2 - 6*s + 1) + 5*Pkdd2*f*k1**2*(4*s - 1)*(C + 2*s - 1))) + 792*Dd**2*Pk2*b1*f**2*r**2 - 3960*Dd**2*Pk2*b1*f**2*r*s + 594*Dd**2*Pk2*b1*f**2*r + 990*Dd**2*Pk2*b1*f**2*s - 330*Dd**2*Pk2*b1*f**2 + 2208*Dd**2*Pk2*f**3*r**2 - 2160*Dd**2*Pk2*f**3*r*s - 564*Dd**2*Pk2*f**3*r + 540*Dd**2*Pk2*f**3*s - 180*Dd**2*Pk2*f**3 - 2376*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 1188*Dd**2*Pkdd2*b1**2*f*k1**2*s - 3960*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 1980*Dd**2*Pkdd2*b1*f**2*k1**2*s - 1680*Dd**2*Pkdd2*f**3*k1**2*s**2 + 840*Dd**2*Pkdd2*f**3*k1**2*s)/(693*d**2*k1**2*k3**2) - D1**2*Pk1*ct**6*(-2145*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 11960*D1**2*Pk2*bdd1*f**3*r*s - 11960*D1**2*Pk2*bdd1*f**3*s + 4480*D1**2*Pk2*f**3*fd*r*s - 1120*D1**2*Pk2*f**3*fd*r - 1120*D1**2*Pk2*f**3*fd*s + 26880*D1**2*Pk2*f**3*fdd*r*s - 6720*D1**2*Pk2*f**3*fdd*r - 6720*D1**2*Pk2*f**3*fdd*s + 80640*D1**2*Pk2*f**2*fd**2*r*s - 20160*D1**2*Pk2*f**2*fd**2*r - 20160*D1**2*Pk2*f**2*fd**2*s + 6720*D1**2*Pk2*f**2*fd**2 + 858*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(-6*K + 5*f + 6) + 5460*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 2145*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 5148*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 25200*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 12600*D1**2*Pkdd2*f**3*fd*k1**2*s - 6300*D1**2*Pkdd2*f**3*fd*k1**2 + 12600*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 6300*D1**2*Pkdd2*f**3*fdd*k1**2*s + 3150*D1**2*Pkdd2*f**3*fdd*k1**2 + 37800*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 18900*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 8580*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 4290*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 17160*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 17160*D1**2*Pkdd2*f*fd*g2*k1**2*s - 8580*D1**2*Pkdd2*f*fd*g2*k1**2 + 17160*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 8580*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 8580*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 8580*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 4290*D1**2*Pkdd2*f*fdd*g2*k1**2 + 8580*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 8580*D1**2*Pkdd2*fd**2*g2*k1**2*s + 4480*D1*Dd*Pk2*f**4*r*s - 1120*D1*Dd*Pk2*f**4*r - 1120*D1*Dd*Pk2*f**4*s + 215040*D1*Dd*Pk2*f**3*fd*r*s - 53760*D1*Dd*Pk2*f**3*fd*r - 53760*D1*Dd*Pk2*f**3*fd*s + 13440*D1*Dd*Pk2*f**3*fd - 25200*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 12600*D1*Dd*Pkdd2*f**4*k1**2*s - 6300*D1*Dd*Pkdd2*f**4*k1**2 + 100800*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 50400*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 6300*D1*Dd*Pkdd2*f**3*fd*k1**2 - 34320*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 17160*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 8580*D1*Dd*Pkdd2*f**2*g2*k1**2 + 34320*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 8580*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 68640*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 51480*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 8580*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 26880*D1*Ddd*Pk2*f**4*r*s - 6720*D1*Ddd*Pk2*f**4*r - 6720*D1*Ddd*Pk2*f**4*s + 12600*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 6300*D1*Ddd*Pkdd2*f**4*k1**2*s + 3150*D1*Ddd*Pkdd2*f**4*k1**2 + 17160*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 8580*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 4290*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 26*D1*bd1*(D1*(-33*Pkdd2*f*k1**2*s*(5*fd*(2*s - 1)*(-K + 2*b1 + 1) + s*(12*b1*(K - 1) - 12*g2 + 12*gd2)) - 396*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) + 20*f**3*s*(13*Pk2*(r - 1) + 21*Pkdd2*k1**2*s) - 5*f**2*(92*Pk2*fd*(r*(6*s - 1) - 3*s + 1) + 84*Pkdd2*fd*k1**2*s*(3*s - 1) + Pkdd2*k1**2*s**2*(33*K - 66*b1 - 33))) + Dd*f*(-165*Pkdd2*f*k1**2*s*(4*s - 1)*(-K + 2*b1 + 1) - Pkdd2*k1**2*s*(4*s - 1)*(-396*K*b1 + 396*b1 + 396*g2) - 20*f**2*(23*Pk2*(r*(8*s - 1) - 5*s + 1) + 21*Pkdd2*k1**2*s*(4*s - 1)))) + 80640*Dd**2*Pk2*f**4*r*s - 20160*Dd**2*Pk2*f**4*r - 20160*Dd**2*Pk2*f**4*s + 6720*Dd**2*Pk2*f**4 + 37800*Dd**2*Pkdd2*f**4*k1**2*s**2 - 18900*Dd**2*Pkdd2*f**4*k1**2*s + 51480*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 25740*Dd**2*Pkdd2*f**2*g2*k1**2*s - 429*Pkdd2*b1**2*k1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) - 12*fd*(K - 1)*(s - 1)**2 + 6*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) - 6*f*(K - 1)*(4*s**2 - 2*s + 1) + 6*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-6*K + 5*f + 6)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-6*K + 5*f + 6)) + 13*b1*(-2*D1*Dd*(33*Pkdd2*f*k1**2*(5*fd*(K - 1)*(8*s**2 - 6*s + 1) + 12*g2*(4*s**2 - 2*s + 1) + 12*gd2*s*(1 - 4*s)) - 396*Pkdd2*fd*g2*k1**2*(4*s**2 - 5*s + 1) + 20*f**3*(13*Pk2*(r*(4*s - 1) - s) + 21*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 5*f**2*(92*Pk2*fd*(r*(24*s - 7) - 3*s + 1) + 84*Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1) + Pkdd2*k1**2*(33*K - 33)*(4*s**2 - 2*s + 1))) + D1*(D1*(-66*Pkdd2*k1**2*(s - 1)*(5*fd**2*s*(K - 1) + 12*fd*(g2*(s - 1) - gd2*s) - 6*fdd*g2*(s - 1)) - 10*f**2*(52*Pk2*fd*r*(3*s - 1) - 92*Pk2*fdd*r*(3*s - 1) - 33*Pkdd2*bdd1*k1**2*s**2 + 84*Pkdd2*fd*k1**2*(3*s**2 - 2*s + 1) - 42*Pkdd2*fdd*k1**2*(3*s**2 - 2*s + 1)) + f*(330*Pkdd2*fd*k1**2*(K - 1)*(2*s**2 - 2*s + 1) - 33*Pkdd2*k1**2*(5*fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(12*bdd1*(K - 1) + 24*gd2 - 12*gdd2)) + 40*fd**2*(46*Pk2*r*(3*s - 1) + 21*Pkdd2*k1**2*s*(3*s - 2)))) + Ddd*f*(-165*Pkdd2*f*k1**2*(K - 1)*(4*s**2 - 2*s + 1) + 396*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 20*f**2*(46*Pk2*(4*r*s - r - s) + 21*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 2*Dd**2*f*(-495*Pkdd2*f*k1**2*s*(K - 1)*(2*s - 1) + 1188*Pkdd2*g2*k1**2*s*(2*s - 1) + 20*f**2*(23*Pk2*(12*r*s - 3*r - 3*s + 1) + 63*Pkdd2*k1**2*s*(2*s - 1)))))/(9009*d**2*k1**2) + D1**2*Pk1*ct**5*k1*(-1584*Pk2*b1**2*(4*C - 5)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 33*b1*(-768*C*D1**2*Pk2*f*fd*r*s + 384*C*D1**2*Pk2*f*fd*r - 2624*C*D1**2*Pk2*f*fd*s**2 + 3264*C*D1**2*Pk2*f*fd*s - 1632*C*D1**2*Pk2*f*fd + 384*C*D1**2*Pk2*f*fdd*r*s - 192*C*D1**2*Pk2*f*fdd*r + 1984*C*D1**2*Pk2*f*fdd*s**2 - 2304*C*D1**2*Pk2*f*fdd*s + 1152*C*D1**2*Pk2*f*fdd + 384*C*D1**2*Pk2*fd**2*r*s - 192*C*D1**2*Pk2*fd**2*r + 1984*C*D1**2*Pk2*fd**2*s**2 - 2304*C*D1**2*Pk2*fd**2*s - 1536*C*D1*Dd*Pk2*f**2*r*s + 384*C*D1*Dd*Pk2*f**2*r - 5248*C*D1*Dd*Pk2*f**2*s**2 + 3008*C*D1*Dd*Pk2*f**2*s - 1312*C*D1*Dd*Pk2*f**2 + 3072*C*D1*Dd*Pk2*f*fd*r*s - 1152*C*D1*Dd*Pk2*f*fd*r + 15872*C*D1*Dd*Pk2*f*fd*s**2 - 13568*C*D1*Dd*Pk2*f*fd*s + 2496*C*D1*Dd*Pk2*f*fd + 768*C*D1*Ddd*Pk2*f**2*r*s - 192*C*D1*Ddd*Pk2*f**2*r + 3968*C*D1*Ddd*Pk2*f**2*s**2 - 2176*C*D1*Ddd*Pk2*f**2*s + 992*C*D1*Ddd*Pk2*f**2 + 2304*C*Dd**2*Pk2*f**2*r*s - 576*C*Dd**2*Pk2*f**2*r + 11904*C*Dd**2*Pk2*f**2*s**2 - 6528*C*Dd**2*Pk2*f**2*s + 192*C*Dd**2*Pk2*f**2 - 48*D1**2*Pk2*bdd1*f*(4*C - 5)*(2*s**2 - 2*s + 1) + 1280*D1**2*Pk2*f*fd*r*s - 640*D1**2*Pk2*f*fd*r + 2352*D1**2*Pk2*f*fd*s**2 - 3152*D1**2*Pk2*f*fd*s + 1576*D1**2*Pk2*f*fd - 736*D1**2*Pk2*f*fdd*r*s + 368*D1**2*Pk2*f*fdd*r - 2016*D1**2*Pk2*f*fdd*s**2 + 2416*D1**2*Pk2*f*fdd*s - 1208*D1**2*Pk2*f*fdd - 736*D1**2*Pk2*fd**2*r*s + 368*D1**2*Pk2*fd**2*r - 2016*D1**2*Pk2*fd**2*s**2 + 2416*D1**2*Pk2*fd**2*s - 20*D1**2*Pkdd2*f*fd*k1**2*s**2 + 20*D1**2*Pkdd2*f*fd*k1**2*s - 10*D1**2*Pkdd2*f*fd*k1**2 + 10*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 10*D1**2*Pkdd2*f*fdd*k1**2*s + 5*D1**2*Pkdd2*f*fdd*k1**2 + 10*D1**2*Pkdd2*fd**2*k1**2*s**2 - 10*D1**2*Pkdd2*fd**2*k1**2*s + 2560*D1*Dd*Pk2*f**2*r*s - 640*D1*Dd*Pk2*f**2*r + 4704*D1*Dd*Pk2*f**2*s**2 - 2992*D1*Dd*Pk2*f**2*s + 1176*D1*Dd*Pk2*f**2 - 5888*D1*Dd*Pk2*f*fd*r*s + 2208*D1*Dd*Pk2*f*fd*r - 16128*D1*Dd*Pk2*f*fd*s**2 + 14432*D1*Dd*Pk2*f*fd*s - 2784*D1*Dd*Pk2*f*fd - 40*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 20*D1*Dd*Pkdd2*f**2*k1**2*s - 10*D1*Dd*Pkdd2*f**2*k1**2 + 80*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 60*D1*Dd*Pkdd2*f*fd*k1**2*s + 10*D1*Dd*Pkdd2*f*fd*k1**2 - 1472*D1*Ddd*Pk2*f**2*r*s + 368*D1*Ddd*Pk2*f**2*r - 4032*D1*Ddd*Pk2*f**2*s**2 + 2384*D1*Ddd*Pk2*f**2*s - 1008*D1*Ddd*Pk2*f**2 + 20*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 10*D1*Ddd*Pkdd2*f**2*k1**2*s + 5*D1*Ddd*Pkdd2*f**2*k1**2 + 96*D1*Pk2*bd1*(4*C - 5)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 4416*Dd**2*Pk2*f**2*r*s + 1104*Dd**2*Pk2*f**2*r - 12096*Dd**2*Pk2*f**2*s**2 + 7152*Dd**2*Pk2*f**2*s - 368*Dd**2*Pk2*f**2 + 60*Dd**2*Pkdd2*f**2*k1**2*s**2 - 30*Dd**2*Pkdd2*f**2*k1**2*s) + f*(3168*D1**2*Pk2*bd1**2*s*(4*C - 5)*(s - 1) - 33*D1**2*bdd1*f*(8*Pk2*(4*C*(6*r*s + 31*s**2 + 4*s - 5) - 46*r*s - 126*s**2 - 4*s + 25) + 5*Pkdd2*k1**2*s**2) + 20*D1**2*(f*(Pk2*fd*(4*C*(152*r*(3*s - 1) + 1701*s**2 - 1286*s + 567) - 1044*r*(3*s - 1) - 6549*s**2 + 5410*s - 2183) + Pk2*fdd*(-76*C*(4*r*(3*s - 1) + 63*s**2 - 46*s + 21) + 588*r*(3*s - 1) + 5007*s**2 - 3926*s + 1669) + 14*Pkdd2*fd*k1**2*(3*s**2 - 2*s + 1) - 7*Pkdd2*fdd*k1**2*(3*s**2 - 2*s + 1)) + 2*fd**2*(Pk2*(-76*C*(4*r*(3*s - 1) + 63*s**2 - 46*s + 2) + 588*r*(3*s - 1) + 5007*s**2 - 3926*s + 294) + 7*Pkdd2*k1**2*s*(2 - 3*s))) + 66*D1*bd1*(D1*(4*Pk2*f*(4*C*(41*s**2 + s*(12*r + 8) - 10) - 147*s**2 - s*(80*r + 20) + 50) - 8*Pk2*fd*(4*C*(3*r*(4*s - 1) + 62*s**2 - 32*s + 3) + r*(23 - 92*s) - 252*s**2 + 147*s - 23) + 5*Pkdd2*f*k1**2*s**2 + 5*Pkdd2*fd*k1**2*s*(1 - 2*s)) + Dd*f*(-8*Pk2*(4*C*(24*r*s - 3*r + 124*s**2 - 26*s - 2) - 184*r*s + 23*r - 504*s**2 + 141*s + 2) + 5*Pkdd2*k1**2*s*(1 - 4*s))) + 20*D1*f*(Dd*f*(Pk2*(4*C*(152*r*(4*s - 1) + 2268*s**2 - 1286*s + 567) - 1044*r*(4*s - 1) - 8732*s**2 + 5410*s - 2183) + 14*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 2*Dd*fd*(Pk2*(76*C*(2*r*(24*s - 7) + 252*s**2 - 161*s + 25) - 294*r*(24*s - 7) - 20028*s**2 + 13741*s - 2257) + 7*Pkdd2*k1**2*(12*s**2 - 7*s + 1)) + Ddd*Pk2*f*(-76*C*(4*r*(4*s - 1) + 84*s**2 - 46*s + 21) + 588*r*(4*s - 1) + 6676*s**2 - 3926*s + 1669) - 7*Ddd*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 40*Dd**2*f**2*(76*C*Pk2*(6*r*(4*s - 1) + 126*s**2 - 69*s + 2) - 3*Pk2*(294*r*(4*s - 1) + 3338*s**2 - 1963*s + 98) + 21*Pkdd2*k1**2*s*(2*s - 1))))/(693*d**2*k2*k3**2) + D1**2*Pk1*ct**5*k2*st**2*(33*b1*(D1**2*(f*(2*fd*(8*Pk2*(r*(32*C - 32)*(2*s - 1) + 30*s**2 - 30*s + 15) + Pkdd2*k1**2*(55 - 40*C)*(2*s**2 - 2*s + 1)) + 5*fdd*(-8*Pk2*(r*(4*C - 4)*(2*s - 1) + 6*s**2 - 6*s + 3) + Pkdd2*k1**2*(8*C - 11)*(2*s**2 - 2*s + 1))) + 10*fd**2*(-8*Pk2*(r*(2*C - 2)*(2*s - 1) + s*(3*s - 3)) + Pkdd2*k1**2*s*(8*C - 11)*(s - 1))) + D1*f*(2*Dd*(8*Pk2*f*(r*(32*C - 32)*(4*s - 1) + 60*s**2 + s*(2 - 32*C) + 15) - 40*Pk2*fd*(2*C*(2*r*(8*s - 3) - 2*s + 1) - 4*r*(8*s - 3) + 24*s**2 - 14*s + 1) + Pkdd2*f*k1**2*(55 - 40*C)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(40*C - 55)*(8*s**2 - 6*s + 1)) + 5*Ddd*f*(-8*Pk2*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 12*s**2 - 2*s + 3) + Pkdd2*k1**2*(8*C - 11)*(4*s**2 - 2*s + 1))) + 10*Dd**2*f**2*(-8*Pk2*(C*(24*r*s - 6*r - 6*s + 2) - 24*r*s + 6*r + 18*s**2 - 3*s - 2) + Pkdd2*k1**2*s*(24*C - 33)*(2*s - 1))) + f*(D1**2*(f*(16*Pk2*fd*(r*(952*C - 952)*(3*s - 1) + 1125*s**2 + s*(202 - 952*C) + 375) + Pkdd2*fd*k1**2*(2750 - 2000*C)*(3*s**2 - 2*s + 1) - 165*bdd1*s*(8*Pk2*(4*C*(r - 1) - 4*r + 3*s + 4) + Pkdd2*k1**2*s*(11 - 8*C)) - 5*fdd*(8*Pk2*(-164*C*s + r*(164*C - 164)*(3*s - 1) + 225*s**2 + 14*s + 75) + Pkdd2*k1**2*(275 - 200*C)*(3*s**2 - 2*s + 1))) - 10*fd**2*(8*Pk2*(82*C*(6*r*s - 2*r - 2*s + 1) - 492*r*s + 164*r + 225*s**2 + 14*s - 82) + Pkdd2*k1**2*s*(275 - 200*C)*(3*s - 2))) + 66*D1*bd1*(D1*f*s*(8*Pk2*(32*C*(r - 1) - 32*r + 15*s + 32) + Pkdd2*k1**2*s*(55 - 40*C)) + 5*D1*fd*(-8*Pk2*(C*(8*r*s - 2*r - 4*s + 2) - 8*r*s + 2*r + 6*s**2 + s - 2) + Pkdd2*k1**2*s*(8*C - 11)*(2*s - 1)) - 40*Dd*Pk2*f*(2*C*(r*(8*s - 1) - 5*s + 1) + r*(2 - 16*s) + 12*s**2 + 7*s - 2) + Dd*Pkdd2*f*k1**2*s*(40*C - 55)*(4*s - 1)) + D1*f*(2*Dd*(8*Pk2*f*(r*(952*C - 952)*(4*s - 1) + 1500*s**2 + s*(202 - 952*C) + 375) - 40*Pk2*fd*(82*C*(r*(24*s - 7) - 7*s + 2) - 82*r*(24*s - 7) + 900*s**2 + 49*s - 89) + Pkdd2*f*k1**2*(1375 - 1000*C)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(1000*C - 1375)*(12*s**2 - 7*s + 1)) - 5*Ddd*f*(8*Pk2*(-164*C*s + r*(164*C - 164)*(4*s - 1) + 300*s**2 + 14*s + 75) + Pkdd2*k1**2*(275 - 200*C)*(4*s**2 - 2*s + 1))) - 10*Dd**2*f**2*(8*Pk2*(82*C*(12*r*s - 3*r - 3*s + 1) - 984*r*s + 246*r + 450*s**2 + 21*s - 82) + Pkdd2*k1**2*s*(825 - 600*C)*(2*s - 1))))/(1386*d**2*k1*k3**2) - D1**2*Pk1*ct**5*k2*(-3696*C*D1**2*Pk2*b1**2*fd*r*s + 8448*C*D1**2*Pk2*b1*f*fd*r**2 - 1056*C*D1**2*Pk2*b1*f*fd*r*s - 3696*C*D1**2*Pk2*b1*f*fd*r + 4224*C*D1**2*Pk2*b1*f*fd*s + 528*C*D1**2*Pk2*b1*f*fdd*r**2 + 528*C*D1**2*Pk2*b1*f*fdd*r*s + 264*C*D1**2*Pk2*b1*f*fdd*r - 528*C*D1**2*Pk2*b1*f*fdd*s + 528*C*D1**2*Pk2*b1*fd**2*r**2 + 528*C*D1**2*Pk2*b1*fd**2*r*s + 264*C*D1**2*Pk2*b1*fd**2*r - 528*C*D1**2*Pk2*b1*fd**2*s + 16176*C*D1**2*Pk2*f**2*fd*r**2 + 17088*C*D1**2*Pk2*f**2*fd*r*s - 16480*C*D1**2*Pk2*f**2*fd*r - 5696*C*D1**2*Pk2*f**2*fd*s + 5392*C*D1**2*Pk2*f**2*fd + 624*C*D1**2*Pk2*f**2*fdd*r**2 - 6168*C*D1**2*Pk2*f**2*fdd*r*s + 1640*C*D1**2*Pk2*f**2*fdd*r + 2056*C*D1**2*Pk2*f**2*fdd*s + 208*C*D1**2*Pk2*f**2*fdd + 1248*C*D1**2*Pk2*f*fd**2*r**2 - 12336*C*D1**2*Pk2*f*fd**2*r*s + 3280*C*D1**2*Pk2*f*fd**2*r + 4112*C*D1**2*Pk2*f*fd**2*s - 2056*C*D1**2*Pk2*f*fd**2 + 1584*C*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 792*C*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 1584*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 4224*C*D1**2*Pkdd2*b1*f*fd*k1**2*s - 2112*C*D1**2*Pkdd2*b1*f*fd*k1**2 - 1320*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 660*C*D1**2*Pkdd2*b1*f*fdd*k1**2 - 1320*C*D1**2*Pkdd2*b1*fd**2*k1**2*s - 5340*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 3560*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 1780*C*D1**2*Pkdd2*f**2*fd*k1**2 + 1680*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 1120*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 560*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 3360*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 2240*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 14784*C*D1*Dd*Pk2*b1**2*f*r*s + 3696*C*D1*Dd*Pk2*b1**2*f*r + 3696*C*D1*Dd*Pk2*b1**2*f*s + 16896*C*D1*Dd*Pk2*b1*f**2*r**2 - 2112*C*D1*Dd*Pk2*b1*f**2*r*s - 7920*C*D1*Dd*Pk2*b1*f**2*r + 528*C*D1*Dd*Pk2*b1*f**2*s + 4224*C*D1*Dd*Pk2*b1*f**2 + 4224*C*D1*Dd*Pk2*b1*f*fd*r**2 + 4224*C*D1*Dd*Pk2*b1*f*fd*r*s - 528*C*D1*Dd*Pk2*b1*f*fd*r - 2640*C*D1*Dd*Pk2*b1*f*fd*s + 264*C*D1*Dd*Pk2*b1*f*fd + 21568*C*D1*Dd*Pk2*f**3*r**2 + 22784*C*D1*Dd*Pk2*f**3*r*s - 16480*C*D1*Dd*Pk2*f**3*r - 5696*C*D1*Dd*Pk2*f**3*s + 5392*C*D1*Dd*Pk2*f**3 + 4992*C*D1*Dd*Pk2*f**2*fd*r**2 - 49344*C*D1*Dd*Pk2*f**2*fd*r*s + 11480*C*D1*Dd*Pk2*f**2*fd*r + 14392*C*D1*Dd*Pk2*f**2*fd*s - 3696*C*D1*Dd*Pk2*f**2*fd + 6336*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 3168*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 1584*C*D1*Dd*Pkdd2*b1**2*f*k1**2 - 6336*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 1584*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 3168*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 1584*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 792*C*D1*Dd*Pkdd2*b1*f**2*k1**2 - 5280*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 1320*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 - 7120*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 3560*C*D1*Dd*Pkdd2*f**3*k1**2*s - 1780*C*D1*Dd*Pkdd2*f**3*k1**2 + 13440*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 7840*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 1120*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 1056*C*D1*Ddd*Pk2*b1*f**2*r**2 + 1056*C*D1*Ddd*Pk2*b1*f**2*r*s - 792*C*D1*Ddd*Pk2*b1*f**2*r - 264*C*D1*Ddd*Pk2*b1*f**2*s + 264*C*D1*Ddd*Pk2*b1*f**2 + 832*C*D1*Ddd*Pk2*f**3*r**2 - 8224*C*D1*Ddd*Pk2*f**3*r*s + 1640*C*D1*Ddd*Pk2*f**3*r + 2056*C*D1*Ddd*Pk2*f**3*s + 208*C*D1*Ddd*Pk2*f**3 - 3168*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 1584*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 792*C*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 2240*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 1120*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 560*C*D1*Ddd*Pkdd2*f**3*k1**2 + 3168*C*Dd**2*Pk2*b1*f**2*r**2 + 3168*C*Dd**2*Pk2*b1*f**2*r*s - 2376*C*Dd**2*Pk2*b1*f**2*r - 792*C*Dd**2*Pk2*b1*f**2*s + 264*C*Dd**2*Pk2*b1*f**2 + 2496*C*Dd**2*Pk2*f**3*r**2 - 24672*C*Dd**2*Pk2*f**3*r*s + 4920*C*Dd**2*Pk2*f**3*r + 6168*C*Dd**2*Pk2*f**3*s - 2056*C*Dd**2*Pk2*f**3 - 9504*C*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 4752*C*Dd**2*Pkdd2*b1**2*f*k1**2*s + 6720*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 3360*C*Dd**2*Pkdd2*f**3*k1**2*s + 3696*D1**2*Pk2*b1**2*fd*r*s - 8448*D1**2*Pk2*b1*f*fd*r**2 + 5280*D1**2*Pk2*b1*f*fd*r*s + 1584*D1**2*Pk2*b1*f*fd*r + 9768*D1**2*Pk2*b1*f*fd*s**2 - 13992*D1**2*Pk2*b1*f*fd*s + 4884*D1**2*Pk2*b1*f*fd - 528*D1**2*Pk2*b1*f*fdd*r**2 - 1056*D1**2*Pk2*b1*f*fdd*r*s - 8448*D1**2*Pk2*b1*f*fdd*s**2 + 8976*D1**2*Pk2*b1*f*fdd*s - 4224*D1**2*Pk2*b1*f*fdd - 528*D1**2*Pk2*b1*fd**2*r**2 - 1056*D1**2*Pk2*b1*fd**2*r*s - 8448*D1**2*Pk2*b1*fd**2*s**2 + 8976*D1**2*Pk2*b1*fd**2*s - 17754*D1**2*Pk2*f**2*fd*r**2 - 7128*D1**2*Pk2*f**2*fd*r*s + 14212*D1**2*Pk2*f**2*fd*r + 12270*D1**2*Pk2*f**2*fd*s**2 - 5804*D1**2*Pk2*f**2*fd*s - 1828*D1**2*Pk2*f**2*fd - 726*D1**2*Pk2*f**2*fdd*r**2 + 3168*D1**2*Pk2*f**2*fdd*r*s - 572*D1**2*Pk2*f**2*fdd*r - 10590*D1**2*Pk2*f**2*fdd*s**2 + 6004*D1**2*Pk2*f**2*fdd*s - 3772*D1**2*Pk2*f**2*fdd - 1452*D1**2*Pk2*f*fd**2*r**2 + 6336*D1**2*Pk2*f*fd**2*r*s - 1144*D1**2*Pk2*f*fd**2*r - 21180*D1**2*Pk2*f*fd**2*s**2 + 12008*D1**2*Pk2*f*fd**2*s + 1056*D1**2*Pk2*f*fd**2 - 1980*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 990*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 1980*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 1320*D1**2*Pkdd2*b1*f*fd*k1**2*s + 660*D1**2*Pkdd2*b1*f*fd*k1**2 + 1980*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 330*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 165*D1**2*Pkdd2*b1*f*fdd*k1**2 + 1980*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 330*D1**2*Pkdd2*b1*fd**2*k1**2*s - 396*D1**2*Pkdd2*bd1**2*f*k1**2*s*(4*C - 5)*(s - 1) + 1635*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 1090*D1**2*Pkdd2*f**2*fd*k1**2*s + 545*D1**2*Pkdd2*f**2*fd*k1**2 + 420*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 280*D1**2*Pkdd2*f**2*fdd*k1**2*s + 140*D1**2*Pkdd2*f**2*fdd*k1**2 + 840*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 560*D1**2*Pkdd2*f*fd**2*k1**2*s + 33*D1**2*bdd1*f*(8*Pk2*f*(C*(r**2 + r*(s - 4) + s + 1) - r**2 - 2*r*(s - 2) - 16*s**2 - 1) - 6*Pkdd2*b1*k1**2*(4*C - 5)*(2*s**2 - 2*s + 1) + 5*Pkdd2*f*k1**2*(C*(8*s - 4) + 6*s**2 - 10*s + 5)) + 14784*D1*Dd*Pk2*b1**2*f*r*s - 3696*D1*Dd*Pk2*b1**2*f*r - 3696*D1*Dd*Pk2*b1**2*f*s - 16896*D1*Dd*Pk2*b1*f**2*r**2 + 10560*D1*Dd*Pk2*b1*f**2*r*s + 5808*D1*Dd*Pk2*b1*f**2*r + 19536*D1*Dd*Pk2*b1*f**2*s**2 - 12408*D1*Dd*Pk2*b1*f**2*s + 660*D1*Dd*Pk2*b1*f**2 - 4224*D1*Dd*Pk2*b1*f*fd*r**2 - 8448*D1*Dd*Pk2*b1*f*fd*r*s + 2112*D1*Dd*Pk2*b1*f*fd*r - 67584*D1*Dd*Pk2*b1*f*fd*s**2 + 53856*D1*Dd*Pk2*b1*f*fd*s - 8976*D1*Dd*Pk2*b1*f*fd - 23672*D1*Dd*Pk2*f**3*r**2 - 9504*D1*Dd*Pk2*f**3*r*s + 14212*D1*Dd*Pk2*f**3*r + 16360*D1*Dd*Pk2*f**3*s**2 - 5804*D1*Dd*Pk2*f**3*s - 1828*D1*Dd*Pk2*f**3 - 5808*D1*Dd*Pk2*f**2*fd*r**2 + 25344*D1*Dd*Pk2*f**2*fd*r*s - 4004*D1*Dd*Pk2*f**2*fd*r - 84720*D1*Dd*Pk2*f**2*fd*s**2 + 42028*D1*Dd*Pk2*f**2*fd*s - 5432*D1*Dd*Pk2*f**2*fd - 7920*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 3960*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 1980*D1*Dd*Pkdd2*b1**2*f*k1**2 + 7920*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 1980*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 3960*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 1980*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 990*D1*Dd*Pkdd2*b1*f**2*k1**2 + 15840*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 5280*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 330*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 2180*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 1090*D1*Dd*Pkdd2*f**3*k1**2*s + 545*D1*Dd*Pkdd2*f**3*k1**2 + 3360*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 1960*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 280*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1056*D1*Ddd*Pk2*b1*f**2*r**2 - 2112*D1*Ddd*Pk2*b1*f**2*r*s + 1056*D1*Ddd*Pk2*b1*f**2*r - 16896*D1*Ddd*Pk2*b1*f**2*s**2 + 8976*D1*Ddd*Pk2*b1*f**2*s - 4488*D1*Ddd*Pk2*b1*f**2 - 968*D1*Ddd*Pk2*f**3*r**2 + 4224*D1*Ddd*Pk2*f**3*r*s - 572*D1*Ddd*Pk2*f**3*r - 14120*D1*Ddd*Pk2*f**3*s**2 + 6004*D1*Ddd*Pk2*f**3*s - 3772*D1*Ddd*Pk2*f**3 + 3960*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 1980*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 990*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 3960*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 1980*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 990*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 560*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 280*D1*Ddd*Pkdd2*f**3*k1**2*s + 140*D1*Ddd*Pkdd2*f**3*k1**2 + 66*D1*bd1*(D1*(-6*Pkdd2*b1*fd*k1**2*s*(4*C - 5)*(2*s - 1) + f**2*(Pk2*(8*C*(8*r**2 - r*(s + 8) - 7*s + 8) - 64*r**2 + 8*r*(5*s + 8) + 74*s**2 + 24*s - 64) - Pkdd2*k1**2*(4*C*(3*s**2 + 10*s - 5) + 15*s**2 - 50*s + 25)) + f*(-56*Pk2*b1*(C - 1)*(r*(2*s - 1) - s) + 6*Pkdd2*b1*k1**2*(4*C - 5)*(2*s**2 - 2*s + 1) + fd*(4*Pk2*(4*C*r**2 + C*r*(4*s - 7) + C - 4*r**2 - 8*r*(s - 1) - 64*s**2 + 34*s - 2) + 5*Pkdd2*k1**2*s*(4*C + 12*s - 11)))) + Dd*f*(-6*Pkdd2*b1*k1**2*(4*C - 5)*(8*s**2 - 6*s + 1) + f*(4*C*Pk2*(8*r**2 + 8*r*s - 19*r + 3*s + 3) - 8*Pk2*(4*r**2 + 2*r*(4*s - 5) + 64*s**2 - 17*s + 2) + 5*Pkdd2*k1**2*(4*s - 1)*(4*C + 6*s - 5)))) - 3168*Dd**2*Pk2*b1*f**2*r**2 - 6336*Dd**2*Pk2*b1*f**2*r*s + 3168*Dd**2*Pk2*b1*f**2*r - 50688*Dd**2*Pk2*b1*f**2*s**2 + 26928*Dd**2*Pk2*b1*f**2*s - 528*Dd**2*Pk2*b1*f**2 - 2904*Dd**2*Pk2*f**3*r**2 + 12672*Dd**2*Pk2*f**3*r*s - 1716*Dd**2*Pk2*f**3*r - 42360*Dd**2*Pk2*f**3*s**2 + 18012*Dd**2*Pk2*f**3*s + 1056*Dd**2*Pk2*f**3 + 11880*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 5940*Dd**2*Pkdd2*b1**2*f*k1**2*s + 11880*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 5940*Dd**2*Pkdd2*b1*f**2*k1**2*s + 1680*Dd**2*Pkdd2*f**3*k1**2*s**2 - 840*Dd**2*Pkdd2*f**3*k1**2*s)/(693*d**2*k1*k3**2) + D1**2*Pk1*ct**5*(-6864*D1**2*K*Pk2*bdd1*f**2*r*s + 15600*D1**2*Pk2*bdd1*f**3*r*s + 65260*D1**2*Pk2*bdd1*f**3*s**2 + 18720*D1**2*Pk2*bdd1*f**3*s - 14560*D1**2*Pk2*bdd1*f**3 + 6864*D1**2*Pk2*bdd1*f**2*r*s - 17160*D1**2*Pk2*bdd1*f**2*s**2 - 125440*D1**2*Pk2*f**3*fd*r*s + 31360*D1**2*Pk2*f**3*fd*r - 436800*D1**2*Pk2*f**3*fd*s**2 + 249760*D1**2*Pk2*f**3*fd*s - 109200*D1**2*Pk2*f**3*fd + 62720*D1**2*Pk2*f**3*fdd*r*s - 15680*D1**2*Pk2*f**3*fdd*r + 320320*D1**2*Pk2*f**3*fdd*s**2 - 175840*D1**2*Pk2*f**3*fdd*s + 80080*D1**2*Pk2*f**3*fdd + 188160*D1**2*Pk2*f**2*fd**2*r*s - 47040*D1**2*Pk2*f**2*fd**2*r + 960960*D1**2*Pk2*f**2*fd**2*s**2 - 527520*D1**2*Pk2*f**2*fd**2*s + 15680*D1**2*Pk2*f**2*fd**2 - 109824*D1**2*Pk2*f**2*gd2*r*s + 13728*D1**2*Pk2*f**2*gdd2*r*s - 219648*D1**2*Pk2*f*fd*g2*r*s + 109824*D1**2*Pk2*f*fd*g2*r + 109824*D1**2*Pk2*f*fd*g2*s + 54912*D1**2*Pk2*f*fd*gd2*r*s - 13728*D1**2*Pk2*f*fd*gd2*r - 13728*D1**2*Pk2*f*fd*gd2*s + 27456*D1**2*Pk2*f*fdd*g2*r*s - 13728*D1**2*Pk2*f*fdd*g2*r - 13728*D1**2*Pk2*f*fdd*g2*s + 27456*D1**2*Pk2*fd**2*g2*r*s - 13728*D1**2*Pk2*fd**2*g2*r - 13728*D1**2*Pk2*fd**2*g2*s + 13728*D1**2*Pk2*fd**2*g2 - 3640*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 2145*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 12600*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 6300*D1**2*Pkdd2*f**3*fd*k1**2*s + 3150*D1**2*Pkdd2*f**3*fd*k1**2 - 6300*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 3150*D1**2*Pkdd2*f**3*fdd*k1**2*s - 1575*D1**2*Pkdd2*f**3*fdd*k1**2 - 18900*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 9450*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 858*D1**2*bd1**2*f*s*(5*f*(8*Pk2*(2*s - 1) + Pkdd2*k1**2*s) + s*(48*Pk2 + 6*Pkdd2*k1**2)) - 125440*D1*Dd*Pk2*f**4*r*s + 31360*D1*Dd*Pk2*f**4*r - 436800*D1*Dd*Pk2*f**4*s**2 + 249760*D1*Dd*Pk2*f**4*s - 109200*D1*Dd*Pk2*f**4 + 501760*D1*Dd*Pk2*f**3*fd*r*s - 125440*D1*Dd*Pk2*f**3*fd*r + 2562560*D1*Dd*Pk2*f**3*fd*s**2 - 1406720*D1*Dd*Pk2*f**3*fd*s + 191520*D1*Dd*Pk2*f**3*fd - 439296*D1*Dd*Pk2*f**2*g2*r*s + 109824*D1*Dd*Pk2*f**2*g2*r + 109824*D1*Dd*Pk2*f**2*g2*s + 109824*D1*Dd*Pk2*f**2*gd2*r*s - 13728*D1*Dd*Pk2*f**2*gd2*r - 13728*D1*Dd*Pk2*f**2*gd2*s + 219648*D1*Dd*Pk2*f*fd*g2*r*s - 82368*D1*Dd*Pk2*f*fd*g2*r - 82368*D1*Dd*Pk2*f*fd*g2*s + 27456*D1*Dd*Pk2*f*fd*g2 + 12600*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 6300*D1*Dd*Pkdd2*f**4*k1**2*s + 3150*D1*Dd*Pkdd2*f**4*k1**2 - 50400*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 25200*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 3150*D1*Dd*Pkdd2*f**3*fd*k1**2 + 62720*D1*Ddd*Pk2*f**4*r*s - 15680*D1*Ddd*Pk2*f**4*r + 320320*D1*Ddd*Pk2*f**4*s**2 - 175840*D1*Ddd*Pk2*f**4*s + 80080*D1*Ddd*Pk2*f**4 + 54912*D1*Ddd*Pk2*f**2*g2*r*s - 13728*D1*Ddd*Pk2*f**2*g2*r - 13728*D1*Ddd*Pk2*f**2*g2*s - 6300*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 3150*D1*Ddd*Pkdd2*f**4*k1**2*s - 1575*D1*Ddd*Pkdd2*f**4*k1**2 - 26*D1*bd1*f*(D1*(264*Pk2*fd*(r*(K - 1)*(4*s - 1) + s*(-K + 10*s - 4)) + 3696*Pk2*g2*s*(r - 1) + 165*Pkdd2*fd*k1**2*s*(2*s - 1) + 10*f**2*(Pk2*(271*s**2 + s*(120*r + 144) - 112) - 28*Pkdd2*k1**2*s**2) - f*(20*fd*(Pk2*(30*r*(6*s - 1) + 753*s**2 - 209*s + 20) + 14*Pkdd2*k1**2*s*(1 - 3*s)) + 33*s*(8*Pk2*(r*(8*K - 8) + 5*s) + 5*Pkdd2*k1**2*s))) + Dd*f*(264*Pk2*(r*(K - 1)*(8*s - 1) + s*(-K + 20*s - 4)) + 165*Pkdd2*k1**2*s*(4*s - 1) - 20*f*(Pk2*(30*r*(8*s - 1) + 1004*s**2 - 137*s - 36) + 14*Pkdd2*k1**2*s*(1 - 4*s)))) + 188160*Dd**2*Pk2*f**4*r*s - 47040*Dd**2*Pk2*f**4*r + 960960*Dd**2*Pk2*f**4*s**2 - 527520*Dd**2*Pk2*f**4*s + 15680*Dd**2*Pk2*f**4 + 164736*Dd**2*Pk2*f**2*g2*r*s - 41184*Dd**2*Pk2*f**2*g2*r - 41184*Dd**2*Pk2*f**2*g2*s + 13728*Dd**2*Pk2*f**2*g2 - 18900*Dd**2*Pkdd2*f**4*k1**2*s**2 + 9450*Dd**2*Pkdd2*f**4*k1**2*s + 429*b1**2*(D1**2*(-10*fd**2*s*(8*Pk2*(2*s - 1) + Pkdd2*k1**2*(s - 1)) + 2*fd*(8*Pk2*(5*f*(4*s**2 - 2*s + 1) + (s - 1)*(7*K*r - 7*r + 6*s - 6)) + Pkdd2*k1**2*(5*f*(2*s**2 - 2*s + 1) + 6*(s - 1)**2)) - fdd*(8*Pk2*(5*f*(4*s**2 - 2*s + 1) + 6*(s - 1)**2) + Pkdd2*k1**2*(5*f*(2*s**2 - 2*s + 1) + 6*(s - 1)**2))) + D1*(2*Dd*(-8*Pk2*f*(7*K*s + 5*fd*(1 - 4*s)**2 - r*(7*K - 7)*(4*s - 1) - 24*s**2 + 5*s - 6) + Pkdd2*f*k1**2*(-5*fd*(8*s**2 - 6*s + 1) + 24*s**2 - 12*s + 6) + 5*f**2*(16*Pk2 + Pkdd2*k1**2)*(4*s**2 - 2*s + 1) - 6*fd*(8*Pk2 + Pkdd2*k1**2)*(4*s**2 - 5*s + 1)) - Ddd*f*(Pk2*(80*f + 48) + Pkdd2*k1**2*(5*f + 6))*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(Pk2*(80*f + 48) + Pkdd2*k1**2*(5*f + 6))) + 13*b1*(8448*D1**2*K*Pk2*f*fd*r*s - 4224*D1**2*K*Pk2*f*fd*r - 4224*D1**2*K*Pk2*f*fd*s - 1056*D1**2*K*Pk2*f*fdd*r*s + 528*D1**2*K*Pk2*f*fdd*r + 528*D1**2*K*Pk2*f*fdd*s - 1056*D1**2*K*Pk2*fd**2*r*s + 528*D1**2*K*Pk2*fd**2*r + 528*D1**2*K*Pk2*fd**2*s - 528*D1**2*K*Pk2*fd**2 - 7200*D1**2*Pk2*f**2*fd*r*s + 2400*D1**2*Pk2*f**2*fd*r - 16260*D1**2*Pk2*f**2*fd*s**2 + 16120*D1**2*Pk2*f**2*fd*s - 7660*D1**2*Pk2*f**2*fd + 3600*D1**2*Pk2*f**2*fdd*r*s - 1200*D1**2*Pk2*f**2*fdd*r + 15060*D1**2*Pk2*f**2*fdd*s**2 - 12680*D1**2*Pk2*f**2*fdd*s + 6140*D1**2*Pk2*f**2*fdd + 7200*D1**2*Pk2*f*fd**2*r*s - 2400*D1**2*Pk2*f*fd**2*r + 30120*D1**2*Pk2*f*fd**2*s**2 - 25360*D1**2*Pk2*f*fd**2*s + 400*D1**2*Pk2*f*fd**2 - 8448*D1**2*Pk2*f*fd*r*s + 4224*D1**2*Pk2*f*fd*r + 5280*D1**2*Pk2*f*fd*s**2 - 1056*D1**2*Pk2*f*fd*s + 2640*D1**2*Pk2*f*fd + 1056*D1**2*Pk2*f*fdd*r*s - 528*D1**2*Pk2*f*fdd*r - 2640*D1**2*Pk2*f*fdd*s**2 + 2112*D1**2*Pk2*f*fdd*s - 1320*D1**2*Pk2*f*fdd - 7392*D1**2*Pk2*f*gd2*r*s + 1056*D1**2*Pk2*fd**2*r*s - 528*D1**2*Pk2*fd**2*r - 2640*D1**2*Pk2*fd**2*s**2 + 2112*D1**2*Pk2*fd**2*s + 528*D1**2*Pk2*fd**2 - 7392*D1**2*Pk2*fd*g2*r*s + 7392*D1**2*Pk2*fd*g2*r + 1680*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 1120*D1**2*Pkdd2*f**2*fd*k1**2*s + 560*D1**2*Pkdd2*f**2*fd*k1**2 - 840*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 560*D1**2*Pkdd2*f**2*fdd*k1**2*s - 280*D1**2*Pkdd2*f**2*fdd*k1**2 - 1680*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 1120*D1**2*Pkdd2*f*fd**2*k1**2*s + 660*D1**2*Pkdd2*f*fd*k1**2*s**2 - 660*D1**2*Pkdd2*f*fd*k1**2*s + 330*D1**2*Pkdd2*f*fd*k1**2 - 330*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 330*D1**2*Pkdd2*f*fdd*k1**2*s - 165*D1**2*Pkdd2*f*fdd*k1**2 - 330*D1**2*Pkdd2*fd**2*k1**2*s**2 + 330*D1**2*Pkdd2*fd**2*k1**2*s - 66*D1**2*bdd1*f*(5*f*(4*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2) + s**2*(48*Pk2 + 6*Pkdd2*k1**2)) + 16896*D1*Dd*K*Pk2*f**2*r*s - 4224*D1*Dd*K*Pk2*f**2*r - 4224*D1*Dd*K*Pk2*f**2*s - 8448*D1*Dd*K*Pk2*f*fd*r*s + 3168*D1*Dd*K*Pk2*f*fd*r + 3168*D1*Dd*K*Pk2*f*fd*s - 1056*D1*Dd*K*Pk2*f*fd - 9600*D1*Dd*Pk2*f**3*r*s + 2400*D1*Dd*Pk2*f**3*r - 21680*D1*Dd*Pk2*f**3*s**2 + 13240*D1*Dd*Pk2*f**3*s - 5420*D1*Dd*Pk2*f**3 + 28800*D1*Dd*Pk2*f**2*fd*r*s - 8400*D1*Dd*Pk2*f**2*fd*r + 120480*D1*Dd*Pk2*f**2*fd*s**2 - 84440*D1*Dd*Pk2*f**2*fd*s + 13880*D1*Dd*Pk2*f**2*fd - 16896*D1*Dd*Pk2*f**2*r*s + 4224*D1*Dd*Pk2*f**2*r + 10560*D1*Dd*Pk2*f**2*s**2 - 1056*D1*Dd*Pk2*f**2*s + 2640*D1*Dd*Pk2*f**2 + 8448*D1*Dd*Pk2*f*fd*r*s - 3168*D1*Dd*Pk2*f*fd*r - 21120*D1*Dd*Pk2*f*fd*s**2 + 12672*D1*Dd*Pk2*f*fd*s - 1584*D1*Dd*Pk2*f*fd - 29568*D1*Dd*Pk2*f*g2*r*s + 7392*D1*Dd*Pk2*f*g2*r + 7392*D1*Dd*Pk2*f*g2*s + 2240*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 1120*D1*Dd*Pkdd2*f**3*k1**2*s + 560*D1*Dd*Pkdd2*f**3*k1**2 - 6720*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 3920*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 560*D1*Dd*Pkdd2*f**2*fd*k1**2 + 1320*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 660*D1*Dd*Pkdd2*f**2*k1**2*s + 330*D1*Dd*Pkdd2*f**2*k1**2 - 2640*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 1980*D1*Dd*Pkdd2*f*fd*k1**2*s - 330*D1*Dd*Pkdd2*f*fd*k1**2 - 2112*D1*Ddd*K*Pk2*f**2*r*s + 528*D1*Ddd*K*Pk2*f**2*r + 528*D1*Ddd*K*Pk2*f**2*s + 4800*D1*Ddd*Pk2*f**3*r*s - 1200*D1*Ddd*Pk2*f**3*r + 20080*D1*Ddd*Pk2*f**3*s**2 - 11240*D1*Ddd*Pk2*f**3*s + 5020*D1*Ddd*Pk2*f**3 + 2112*D1*Ddd*Pk2*f**2*r*s - 528*D1*Ddd*Pk2*f**2*r - 5280*D1*Ddd*Pk2*f**2*s**2 + 2112*D1*Ddd*Pk2*f**2*s - 1320*D1*Ddd*Pk2*f**2 - 1120*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 560*D1*Ddd*Pkdd2*f**3*k1**2*s - 280*D1*Ddd*Pkdd2*f**3*k1**2 - 660*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 330*D1*Ddd*Pkdd2*f**2*k1**2*s - 165*D1*Ddd*Pkdd2*f**2*k1**2 + 132*D1*bd1*(D1*(5*f**2*(4*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2) + f*s*(4*Pk2*(14*K*r - 7*K + fd*(20 - 40*s) - 14*r + 12*s + 7) + Pkdd2*k1**2*(fd*(5 - 10*s) + 6*s)) - 6*fd*s*(8*Pk2 + Pkdd2*k1**2)*(s - 1)) - Dd*f*(4*s - 1)*(5*f*(16*Pk2*s - 4*Pk2 + Pkdd2*k1**2*s) + s*(48*Pk2 + 6*Pkdd2*k1**2))) - 6336*Dd**2*K*Pk2*f**2*r*s + 1584*Dd**2*K*Pk2*f**2*r + 1584*Dd**2*K*Pk2*f**2*s - 528*Dd**2*K*Pk2*f**2 + 14400*Dd**2*Pk2*f**3*r*s - 3600*Dd**2*Pk2*f**3*r + 60240*Dd**2*Pk2*f**3*s**2 - 33720*Dd**2*Pk2*f**3*s + 1200*Dd**2*Pk2*f**3 + 6336*Dd**2*Pk2*f**2*r*s - 1584*Dd**2*Pk2*f**2*r - 15840*Dd**2*Pk2*f**2*s**2 + 6336*Dd**2*Pk2*f**2*s + 528*Dd**2*Pk2*f**2 - 3360*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1680*Dd**2*Pkdd2*f**3*k1**2*s - 1980*Dd**2*Pkdd2*f**2*k1**2*s**2 + 990*Dd**2*Pkdd2*f**2*k1**2*s))/(9009*d**2*k1*k2) - D1**2*Pk1*ct**5*k2**3*(-1848*D1**2*Pk2*b1*f*fd*r**2 + 528*D1**2*Pk2*b1*f*fdd*r**2 + 528*D1**2*Pk2*b1*fd**2*r**2 - 2748*D1**2*Pk2*f**2*fd*r**2 + 1832*D1**2*Pk2*f**2*fd*r - 916*D1**2*Pk2*f**2*fd - 12*D1**2*Pk2*f**2*fdd*r**2 + 8*D1**2*Pk2*f**2*fdd*r - 4*D1**2*Pk2*f**2*fdd - 24*D1**2*Pk2*f*fd**2*r**2 + 16*D1**2*Pk2*f*fd**2*r - 396*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 198*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 264*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 396*D1**2*Pkdd2*b1*f*fd*k1**2*s + 198*D1**2*Pkdd2*b1*f*fd*k1**2 + 330*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 330*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 396*D1**2*Pkdd2*bd1**2*f*k1**2*s*(s - 1) + 495*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 330*D1**2*Pkdd2*f**2*fd*k1**2*s + 165*D1**2*Pkdd2*f**2*fd*k1**2 + 33*D1**2*bdd1*f*(6*Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1) + f*(8*Pk2*(r - 1)**2 + 5*Pkdd2*k1**2*(s - 1)**2)) - 3696*D1*Dd*Pk2*b1*f**2*r**2 + 1848*D1*Dd*Pk2*b1*f**2*r - 924*D1*Dd*Pk2*b1*f**2 + 4224*D1*Dd*Pk2*b1*f*fd*r**2 - 1056*D1*Dd*Pk2*b1*f*fd*r - 3664*D1*Dd*Pk2*f**3*r**2 + 1832*D1*Dd*Pk2*f**3*r - 916*D1*Dd*Pk2*f**3 - 96*D1*Dd*Pk2*f**2*fd*r**2 + 56*D1*Dd*Pk2*f**2*fd*r - 8*D1*Dd*Pk2*f**2*fd - 1584*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 792*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 396*D1*Dd*Pkdd2*b1**2*f*k1**2 + 1584*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 396*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 528*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 264*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 132*D1*Dd*Pkdd2*b1*f**2*k1**2 + 2640*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 660*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 660*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 330*D1*Dd*Pkdd2*f**3*k1**2*s + 165*D1*Dd*Pkdd2*f**3*k1**2 + 1056*D1*Ddd*Pk2*b1*f**2*r**2 - 528*D1*Ddd*Pk2*b1*f**2*r + 264*D1*Ddd*Pk2*b1*f**2 - 16*D1*Ddd*Pk2*f**3*r**2 + 8*D1*Ddd*Pk2*f**3*r - 4*D1*Ddd*Pk2*f**3 + 792*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 396*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 198*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 660*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 330*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 165*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 66*D1*bd1*(D1*(6*Pkdd2*b1*fd*k1**2*s*(1 - 2*s) + f**2*(14*Pk2*(r - 1)**2 + Pkdd2*k1**2*(2*s**2 - 10*s + 5)) + 2*f*(-8*Pk2*fd*r*(r - 1) + 3*Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1) - 5*Pkdd2*fd*k1**2*s*(s - 1))) - Dd*f*(8*Pk2*f*(4*r**2 - 5*r + 1) + 6*Pkdd2*b1*k1**2*(8*s**2 - 6*s + 1) + 5*Pkdd2*f*k1**2*(4*s**2 - 5*s + 1))) + 3168*Dd**2*Pk2*b1*f**2*r**2 - 1584*Dd**2*Pk2*b1*f**2*r - 48*Dd**2*Pk2*f**3*r**2 + 24*Dd**2*Pk2*f**3*r + 2376*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 1188*Dd**2*Pkdd2*b1**2*f*k1**2*s + 1980*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 990*Dd**2*Pkdd2*b1*f**2*k1**2*s)/(693*d**2*k1**3*k3**2) - D1**2*Pk1*ct**5*k2*(-23010*D1**2*Pk2*b1*f**2*fd*r**2 + 5070*D1**2*Pk2*b1*f**2*fdd*r**2 + 10140*D1**2*Pk2*b1*f*fd**2*r**2 - 33560*D1**2*Pk2*f**3*fd*r**2 + 16780*D1**2*Pk2*f**3*fd*r - 8390*D1**2*Pk2*f**3*fd - 1160*D1**2*Pk2*f**3*fdd*r**2 + 580*D1**2*Pk2*f**3*fdd*r - 290*D1**2*Pk2*f**3*fdd - 3480*D1**2*Pk2*f**2*fd**2*r**2 + 1740*D1**2*Pk2*f**2*fd**2*r - 17160*D1**2*Pkdd2*b1**2*f*fd*k1**2*s**2 + 8580*D1**2*Pkdd2*b1**2*f*fd*k1**2*s - 4290*D1**2*Pkdd2*b1**2*f*fd*k1**2 + 8580*D1**2*Pkdd2*b1**2*f*fdd*k1**2*s**2 - 4290*D1**2*Pkdd2*b1**2*f*fdd*k1**2*s + 2145*D1**2*Pkdd2*b1**2*f*fdd*k1**2 + 8580*D1**2*Pkdd2*b1**2*fd**2*k1**2*s**2 - 4290*D1**2*Pkdd2*b1**2*fd**2*k1**2*s - 5148*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 10296*D1**2*Pkdd2*b1**2*fd*k1**2*s - 5148*D1**2*Pkdd2*b1**2*fd*k1**2 + 2574*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 5148*D1**2*Pkdd2*b1**2*fdd*k1**2*s + 2574*D1**2*Pkdd2*b1**2*fdd*k1**2 - 15405*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 2990*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 1495*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 10920*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 3640*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 1820*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 21840*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 7280*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 8580*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 8580*D1**2*Pkdd2*b1*f*fd*k1**2*s - 4290*D1**2*Pkdd2*b1*f*fd*k1**2 + 4290*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 4290*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 2145*D1**2*Pkdd2*b1*f*fdd*k1**2 + 4290*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 4290*D1**2*Pkdd2*b1*fd**2*k1**2*s + 858*D1**2*Pkdd2*bd1**2*f*k1**2*s*(5*f*(2*s - 1) + 6*s) + 7280*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 3640*D1**2*Pkdd2*f**3*fd*k1**2*s + 1820*D1**2*Pkdd2*f**3*fd*k1**2 + 13*D1**2*bdd1*f*(396*Pkdd2*b1*k1**2*s**2 + 165*Pkdd2*f*k1**2*(4*b1*s**2 - 2*b1*s + b1 + s**2) + 10*f**2*(13*Pk2*(r - 1)**2 + 14*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 30680*D1*Dd*Pk2*b1*f**3*r**2 + 15340*D1*Dd*Pk2*b1*f**3*r - 7670*D1*Dd*Pk2*b1*f**3 + 40560*D1*Dd*Pk2*b1*f**2*fd*r**2 - 10140*D1*Dd*Pk2*b1*f**2*fd*r - 33560*D1*Dd*Pk2*f**4*r**2 + 16780*D1*Dd*Pk2*f**4*r - 8390*D1*Dd*Pk2*f**4 - 9280*D1*Dd*Pk2*f**3*fd*r**2 + 4640*D1*Dd*Pk2*f**3*fd*r - 580*D1*Dd*Pk2*f**3*fd - 34320*D1*Dd*Pkdd2*b1**2*f**2*k1**2*s**2 + 17160*D1*Dd*Pkdd2*b1**2*f**2*k1**2*s - 8580*D1*Dd*Pkdd2*b1**2*f**2*k1**2 + 68640*D1*Dd*Pkdd2*b1**2*f*fd*k1**2*s**2 - 34320*D1*Dd*Pkdd2*b1**2*f*fd*k1**2*s + 4290*D1*Dd*Pkdd2*b1**2*f*fd*k1**2 - 20592*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 10296*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 5148*D1*Dd*Pkdd2*b1**2*f*k1**2 + 20592*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 25740*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 5148*D1*Dd*Pkdd2*b1**2*fd*k1**2 - 20540*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 10270*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 5135*D1*Dd*Pkdd2*b1*f**3*k1**2 + 87360*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 36400*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 3640*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 17160*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 8580*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 4290*D1*Dd*Pkdd2*b1*f**2*k1**2 + 34320*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 25740*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 4290*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 7280*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 3640*D1*Dd*Pkdd2*f**4*k1**2*s + 1820*D1*Dd*Pkdd2*f**4*k1**2 + 6760*D1*Ddd*Pk2*b1*f**3*r**2 - 3380*D1*Ddd*Pk2*b1*f**3*r + 1690*D1*Ddd*Pk2*b1*f**3 - 1160*D1*Ddd*Pk2*f**4*r**2 + 580*D1*Ddd*Pk2*f**4*r - 290*D1*Ddd*Pk2*f**4 + 17160*D1*Ddd*Pkdd2*b1**2*f**2*k1**2*s**2 - 8580*D1*Ddd*Pkdd2*b1**2*f**2*k1**2*s + 4290*D1*Ddd*Pkdd2*b1**2*f**2*k1**2 + 10296*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 5148*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 2574*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 14560*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 7280*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 3640*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 8580*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 4290*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 2145*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 13*D1*bd1*(D1*(-792*Pkdd2*b1*fd*k1**2*s*(s - 1) - 66*Pkdd2*f*k1**2*s*(-12*b1*s + fd*(20*b1 + 5)*(2*s - 1)) + 5*f**3*(118*Pk2*(r - 1)**2 + Pkdd2*k1**2*(79*s**2 - 112*s + 56)) + 10*f**2*(-78*Pk2*fd*r*(r - 1) + 33*Pkdd2*b1*k1**2*(4*s**2 - 2*s + 1) - 56*Pkdd2*fd*k1**2*s*(3*s - 2) + 33*Pkdd2*k1**2*s**2)) - 2*Dd*f*(396*Pkdd2*b1*k1**2*s*(4*s - 1) + 165*Pkdd2*f*k1**2*(4*s - 1)*(b1*(4*s - 1) + s) + 10*f**2*(13*Pk2*(4*r**2 - 5*r + 1) + 14*Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) + 20280*Dd**2*Pk2*b1*f**3*r**2 - 10140*Dd**2*Pk2*b1*f**3*r - 3480*Dd**2*Pk2*f**4*r**2 + 1740*Dd**2*Pk2*f**4*r + 51480*Dd**2*Pkdd2*b1**2*f**2*k1**2*s**2 - 25740*Dd**2*Pkdd2*b1**2*f**2*k1**2*s + 30888*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 15444*Dd**2*Pkdd2*b1**2*f*k1**2*s + 43680*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 21840*Dd**2*Pkdd2*b1*f**3*k1**2*s + 25740*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 12870*Dd**2*Pkdd2*b1*f**2*k1**2*s)/(9009*d**2*k1**3) - 2*D1**2*Pk1*ct**4*st**2*(792*Pk2*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 33*b1*(-448*C*D1**2*Pk2*f*fd*r*s + 224*C*D1**2*Pk2*f*fd*r - 680*C*D1**2*Pk2*f*fd*s**2 + 776*C*D1**2*Pk2*f*fd*s - 388*C*D1**2*Pk2*f*fd + 224*C*D1**2*Pk2*f*fdd*r*s - 112*C*D1**2*Pk2*f*fdd*r + 448*C*D1**2*Pk2*f*fdd*s**2 - 496*C*D1**2*Pk2*f*fdd*s + 248*C*D1**2*Pk2*f*fdd + 224*C*D1**2*Pk2*fd**2*r*s - 112*C*D1**2*Pk2*fd**2*r + 448*C*D1**2*Pk2*fd**2*s**2 - 496*C*D1**2*Pk2*fd**2*s + 12*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 12*C*D1**2*Pkdd2*f*fd*k1**2*s + 6*C*D1**2*Pkdd2*f*fd*k1**2 - 6*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 6*C*D1**2*Pkdd2*f*fdd*k1**2*s - 3*C*D1**2*Pkdd2*f*fdd*k1**2 - 6*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 6*C*D1**2*Pkdd2*fd**2*k1**2*s - 896*C*D1*Dd*Pk2*f**2*r*s + 224*C*D1*Dd*Pk2*f**2*r - 1360*C*D1*Dd*Pk2*f**2*s**2 + 904*C*D1*Dd*Pk2*f**2*s - 340*C*D1*Dd*Pk2*f**2 + 1792*C*D1*Dd*Pk2*f*fd*r*s - 672*C*D1*Dd*Pk2*f*fd*r + 3584*C*D1*Dd*Pk2*f*fd*s**2 - 3104*C*D1*Dd*Pk2*f*fd*s + 608*C*D1*Dd*Pk2*f*fd + 24*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 12*C*D1*Dd*Pkdd2*f**2*k1**2*s + 6*C*D1*Dd*Pkdd2*f**2*k1**2 - 48*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 36*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 6*C*D1*Dd*Pkdd2*f*fd*k1**2 + 448*C*D1*Ddd*Pk2*f**2*r*s - 112*C*D1*Ddd*Pk2*f**2*r + 896*C*D1*Ddd*Pk2*f**2*s**2 - 560*C*D1*Ddd*Pk2*f**2*s + 224*C*D1*Ddd*Pk2*f**2 - 12*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*C*D1*Ddd*Pkdd2*f**2*k1**2 + 1344*C*Dd**2*Pk2*f**2*r*s - 336*C*Dd**2*Pk2*f**2*r + 2688*C*Dd**2*Pk2*f**2*s**2 - 1680*C*Dd**2*Pk2*f**2*s + 112*C*Dd**2*Pk2*f**2 - 36*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*C*Dd**2*Pkdd2*f**2*k1**2*s - 24*D1**2*Pk2*bdd1*f*(C - 1)*(2*s**2 - 2*s + 1) + 568*D1**2*Pk2*f*fd*r*s - 284*D1**2*Pk2*f*fd*r + 280*D1**2*Pk2*f*fd*s**2 - 376*D1**2*Pk2*f*fd*s + 188*D1**2*Pk2*f*fd - 284*D1**2*Pk2*f*fdd*r*s + 142*D1**2*Pk2*f*fdd*r - 248*D1**2*Pk2*f*fdd*s**2 + 296*D1**2*Pk2*f*fdd*s - 148*D1**2*Pk2*f*fdd - 284*D1**2*Pk2*fd**2*r*s + 142*D1**2*Pk2*fd**2*r - 248*D1**2*Pk2*fd**2*s**2 + 296*D1**2*Pk2*fd**2*s - 32*D1**2*Pkdd2*f*fd*k1**2*s**2 + 32*D1**2*Pkdd2*f*fd*k1**2*s - 16*D1**2*Pkdd2*f*fd*k1**2 + 16*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 16*D1**2*Pkdd2*f*fdd*k1**2*s + 8*D1**2*Pkdd2*f*fdd*k1**2 + 16*D1**2*Pkdd2*fd**2*k1**2*s**2 - 16*D1**2*Pkdd2*fd**2*k1**2*s + 1136*D1*Dd*Pk2*f**2*r*s - 284*D1*Dd*Pk2*f**2*r + 560*D1*Dd*Pk2*f**2*s**2 - 564*D1*Dd*Pk2*f**2*s + 140*D1*Dd*Pk2*f**2 - 2272*D1*Dd*Pk2*f*fd*r*s + 852*D1*Dd*Pk2*f*fd*r - 1984*D1*Dd*Pk2*f*fd*s**2 + 1964*D1*Dd*Pk2*f*fd*s - 438*D1*Dd*Pk2*f*fd - 64*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 32*D1*Dd*Pkdd2*f**2*k1**2*s - 16*D1*Dd*Pkdd2*f**2*k1**2 + 128*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 96*D1*Dd*Pkdd2*f*fd*k1**2*s + 16*D1*Dd*Pkdd2*f*fd*k1**2 - 568*D1*Ddd*Pk2*f**2*r*s + 142*D1*Ddd*Pk2*f**2*r - 496*D1*Ddd*Pk2*f**2*s**2 + 390*D1*Ddd*Pk2*f**2*s - 124*D1*Ddd*Pk2*f**2 + 32*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 16*D1*Ddd*Pkdd2*f**2*k1**2*s + 8*D1*Ddd*Pkdd2*f**2*k1**2 + 48*D1*Pk2*bd1*(C - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 1704*Dd**2*Pk2*f**2*r*s + 426*Dd**2*Pk2*f**2*r - 1488*Dd**2*Pk2*f**2*s**2 + 1170*Dd**2*Pk2*f**2*s - 142*Dd**2*Pk2*f**2 + 96*Dd**2*Pkdd2*f**2*k1**2*s**2 - 48*Dd**2*Pkdd2*f**2*k1**2*s) + f*(-18960*C*D1**2*Pk2*f*fd*r*s + 6320*C*D1**2*Pk2*f*fd*r - 31692*C*D1**2*Pk2*f*fd*s**2 + 27448*C*D1**2*Pk2*f*fd*s - 10564*C*D1**2*Pk2*f*fd + 11856*C*D1**2*Pk2*f*fdd*r*s - 3952*C*D1**2*Pk2*f*fdd*r + 21192*C*D1**2*Pk2*f*fdd*s**2 - 18080*C*D1**2*Pk2*f*fdd*s + 7064*C*D1**2*Pk2*f*fdd + 23712*C*D1**2*Pk2*fd**2*r*s - 7904*C*D1**2*Pk2*fd**2*r + 42384*C*D1**2*Pk2*fd**2*s**2 - 36160*C*D1**2*Pk2*fd**2*s + 3952*C*D1**2*Pk2*fd**2 + 450*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 300*C*D1**2*Pkdd2*f*fd*k1**2*s + 150*C*D1**2*Pkdd2*f*fd*k1**2 - 225*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 150*C*D1**2*Pkdd2*f*fdd*k1**2*s - 75*C*D1**2*Pkdd2*f*fdd*k1**2 - 450*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 300*C*D1**2*Pkdd2*fd**2*k1**2*s - 25280*C*D1*Dd*Pk2*f**2*r*s + 6320*C*D1*Dd*Pk2*f**2*r - 42256*C*D1*Dd*Pk2*f**2*s**2 + 27448*C*D1*Dd*Pk2*f**2*s - 10564*C*D1*Dd*Pk2*f**2 + 94848*C*D1*Dd*Pk2*f*fd*r*s - 27664*C*D1*Dd*Pk2*f*fd*r + 169536*C*D1*Dd*Pk2*f*fd*s**2 - 126560*C*D1*Dd*Pk2*f*fd*s + 22032*C*D1*Dd*Pk2*f*fd + 600*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 300*C*D1*Dd*Pkdd2*f**2*k1**2*s + 150*C*D1*Dd*Pkdd2*f**2*k1**2 - 1800*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 1050*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 150*C*D1*Dd*Pkdd2*f*fd*k1**2 + 15808*C*D1*Ddd*Pk2*f**2*r*s - 3952*C*D1*Ddd*Pk2*f**2*r + 28256*C*D1*Ddd*Pk2*f**2*s**2 - 18080*C*D1*Ddd*Pk2*f**2*s + 7064*C*D1*Ddd*Pk2*f**2 - 300*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 150*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 75*C*D1*Ddd*Pkdd2*f**2*k1**2 + 47424*C*Dd**2*Pk2*f**2*r*s - 11856*C*Dd**2*Pk2*f**2*r + 84768*C*Dd**2*Pk2*f**2*s**2 - 54240*C*Dd**2*Pk2*f**2*s + 3952*C*Dd**2*Pk2*f**2 - 900*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 450*C*Dd**2*Pkdd2*f**2*k1**2*s - 1584*D1**2*Pk2*bd1**2*s*(C - 1)*(s - 1) + 23796*D1**2*Pk2*f*fd*r*s - 7932*D1**2*Pk2*f*fd*r + 16692*D1**2*Pk2*f*fd*s**2 - 19060*D1**2*Pk2*f*fd*s + 5564*D1**2*Pk2*f*fd - 15066*D1**2*Pk2*f*fdd*r*s + 5022*D1**2*Pk2*f*fdd*r - 13692*D1**2*Pk2*f*fdd*s**2 + 14150*D1**2*Pk2*f*fdd*s - 4564*D1**2*Pk2*f*fdd - 30132*D1**2*Pk2*fd**2*r*s + 10044*D1**2*Pk2*fd**2*r - 27384*D1**2*Pk2*fd**2*s**2 + 28300*D1**2*Pk2*fd**2*s - 5022*D1**2*Pk2*fd**2 - 1200*D1**2*Pkdd2*f*fd*k1**2*s**2 + 800*D1**2*Pkdd2*f*fd*k1**2*s - 400*D1**2*Pkdd2*f*fd*k1**2 + 600*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 400*D1**2*Pkdd2*f*fdd*k1**2*s + 200*D1**2*Pkdd2*f*fdd*k1**2 + 1200*D1**2*Pkdd2*fd**2*k1**2*s**2 - 800*D1**2*Pkdd2*fd**2*k1**2*s + 33*D1**2*bdd1*f*(2*Pk2*(4*C*(14*r*s + 28*s**2 - 8*s - 3) - 71*r*s - 62*s**2 + 47*s + 12) + Pkdd2*k1**2*s**2*(8 - 3*C)) + 31728*D1*Dd*Pk2*f**2*r*s - 7932*D1*Dd*Pk2*f**2*r + 22256*D1*Dd*Pk2*f**2*s**2 - 19060*D1*Dd*Pk2*f**2*s + 5564*D1*Dd*Pk2*f**2 - 120528*D1*Dd*Pk2*f*fd*r*s + 35154*D1*Dd*Pk2*f*fd*r - 109536*D1*Dd*Pk2*f*fd*s**2 + 99050*D1*Dd*Pk2*f*fd*s - 19172*D1*Dd*Pk2*f*fd - 1600*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 800*D1*Dd*Pkdd2*f**2*k1**2*s - 400*D1*Dd*Pkdd2*f**2*k1**2 + 4800*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 2800*D1*Dd*Pkdd2*f*fd*k1**2*s + 400*D1*Dd*Pkdd2*f*fd*k1**2 - 20088*D1*Ddd*Pk2*f**2*r*s + 5022*D1*Ddd*Pk2*f**2*r - 18256*D1*Ddd*Pk2*f**2*s**2 + 14150*D1*Ddd*Pk2*f**2*s - 4564*D1*Ddd*Pk2*f**2 + 800*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 400*D1*Ddd*Pkdd2*f**2*k1**2*s + 200*D1*Ddd*Pkdd2*f**2*k1**2 - 66*D1*bd1*(D1*(2*Pk2*f*(C*(85*s**2 + s*(56*r - 32) - 12) - 35*s**2 + s*(47 - 71*r) + 12) + Pk2*fd*(-8*C*(7*r*(4*s - 1) + 56*s**2 - 39*s + 7) + 71*r*(4*s - 1) + 248*s**2 - 242*s + 71) + Pkdd2*f*k1**2*s**2*(8 - 3*C) + Pkdd2*fd*k1**2*s*(3*C - 8)*(2*s - 1)) + Dd*f*(Pk2*(-8*C*(7*r*(8*s - 1) + 112*s**2 - 51*s + 4) + 71*r*(8*s - 1) + 496*s**2 - 383*s + 47) + Pkdd2*k1**2*s*(3*C - 8)*(4*s - 1))) - 60264*Dd**2*Pk2*f**2*r*s + 15066*Dd**2*Pk2*f**2*r - 54768*Dd**2*Pk2*f**2*s**2 + 42450*Dd**2*Pk2*f**2*s - 5022*Dd**2*Pk2*f**2 + 2400*Dd**2*Pkdd2*f**2*k1**2*s**2 - 1200*Dd**2*Pkdd2*f**2*k1**2*s))/(693*d**2*k3**2) + 2*D1**2*Pk1*ct**4*(66*b1**2*(D1**2*s*(3*fd*(Pk2*r*(28*C - 32) + Pk2*s*(23*C - 23) - Pkdd2*k1**2*s*(2*C - 4)) + fdd*(Pk2*r*(34 - 28*C) - Pk2*s*(59*C - 59) + Pkdd2*k1**2*s*(3*C - 6))) + D1*(Dd*(3*Pk2*f*(C*(28*r*(4*s - 1) + 92*s**2 - 74*s + 23) - 32*r*(4*s - 1) - 92*s**2 + 78*s - 23) - Pk2*fd*r*(28*C - 34)*(8*s - 1) + 2*Pk2*fd*s*(C*(73 - 236*s) + 236*s - 76) - Pkdd2*f*k1**2*(6*C - 12)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(6*C - 12)*(4*s - 1)) + Ddd*f*(Pk2*(C*(-28*r*(4*s - 1) - 236*s**2 + 146*s - 59) + 34*r*(4*s - 1) + 236*s**2 - 152*s + 59) + Pkdd2*k1**2*(3*C - 6)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*(C*(-42*r*(4*s - 1) - 354*s**2 + 219*s - 14) + 51*r*(4*s - 1) + 354*s**2 - 228*s + 17) + Pkdd2*k1**2*s*(9*C - 18)*(2*s - 1))) + 33*b1*(-92*C*D1**2*Pk2*f*fd*r**2 - 232*C*D1**2*Pk2*f*fd*r*s + 292*C*D1**2*Pk2*f*fd*r - 408*C*D1**2*Pk2*f*fd*s**2 + 464*C*D1**2*Pk2*f*fd*s - 320*C*D1**2*Pk2*f*fd + 24*C*D1**2*Pk2*f*fdd*r**2 + 248*C*D1**2*Pk2*f*fdd*r*s - 188*C*D1**2*Pk2*f*fdd*r + 396*C*D1**2*Pk2*f*fdd*s**2 - 532*C*D1**2*Pk2*f*fdd*s + 298*C*D1**2*Pk2*f*fdd + 24*C*D1**2*Pk2*fd**2*r**2 + 248*C*D1**2*Pk2*fd**2*r*s - 188*C*D1**2*Pk2*fd**2*r + 396*C*D1**2*Pk2*fd**2*s**2 - 532*C*D1**2*Pk2*fd**2*s + 12*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 32*C*D1**2*Pkdd2*f*fd*k1**2*s + 16*C*D1**2*Pkdd2*f*fd*k1**2 + 10*C*D1**2*Pkdd2*f*fdd*k1**2*s - 5*C*D1**2*Pkdd2*f*fdd*k1**2 + 10*C*D1**2*Pkdd2*fd**2*k1**2*s - 184*C*D1*Dd*Pk2*f**2*r**2 - 464*C*D1*Dd*Pk2*f**2*r*s + 208*C*D1*Dd*Pk2*f**2*r - 816*C*D1*Dd*Pk2*f**2*s**2 + 524*C*D1*Dd*Pk2*f**2*s - 250*C*D1*Dd*Pk2*f**2 + 192*C*D1*Dd*Pk2*f*fd*r**2 + 1984*C*D1*Dd*Pk2*f*fd*r*s - 1048*C*D1*Dd*Pk2*f*fd*r + 3168*C*D1*Dd*Pk2*f*fd*s**2 - 3168*C*D1*Dd*Pk2*f*fd*s + 720*C*D1*Dd*Pk2*f*fd + 24*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 12*C*D1*Dd*Pkdd2*f**2*k1**2*s + 6*C*D1*Dd*Pkdd2*f**2*k1**2 + 40*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 10*C*D1*Dd*Pkdd2*f*fd*k1**2 + 48*C*D1*Ddd*Pk2*f**2*r**2 + 496*C*D1*Ddd*Pk2*f**2*r*s - 148*C*D1*Ddd*Pk2*f**2*r + 792*C*D1*Ddd*Pk2*f**2*s**2 - 520*C*D1*Ddd*Pk2*f**2*s + 210*C*D1*Ddd*Pk2*f**2 + 144*C*Dd**2*Pk2*f**2*r**2 + 1488*C*Dd**2*Pk2*f**2*r*s - 444*C*Dd**2*Pk2*f**2*r + 2376*C*Dd**2*Pk2*f**2*s**2 - 1560*C*Dd**2*Pk2*f**2*s + 124*C*Dd**2*Pk2*f**2 + 116*D1**2*Pk2*f*fd*r**2 + 108*D1**2*Pk2*f*fd*r*s - 258*D1**2*Pk2*f*fd*r - 104*D1**2*Pk2*f*fd*s**2 + 76*D1**2*Pk2*f*fd*s + 64*D1**2*Pk2*f*fd - 48*D1**2*Pk2*f*fdd*r**2 - 156*D1**2*Pk2*f*fdd*r*s + 156*D1**2*Pk2*f*fdd*r + 28*D1**2*Pk2*f*fdd*s**2 + 94*D1**2*Pk2*f*fdd*s - 86*D1**2*Pk2*f*fdd - 48*D1**2*Pk2*fd**2*r**2 - 156*D1**2*Pk2*fd**2*r*s + 156*D1**2*Pk2*fd**2*r + 28*D1**2*Pk2*fd**2*s**2 + 94*D1**2*Pk2*fd**2*s + 16*D1**2*Pkdd2*f*fd*k1**2*s**2 + 24*D1**2*Pkdd2*f*fd*k1**2*s - 12*D1**2*Pkdd2*f*fd*k1**2 - 20*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 20*D1**2*Pkdd2*fd**2*k1**2*s**2 - 2*D1**2*bdd1*f*(Pk2*(C*(56*r*s - 28*r + 118*s**2 - 146*s + 59) - 68*r*s + 34*r - 118*s**2 + 152*s - 59) + Pkdd2*k1**2*(6 - 3*C)*(2*s**2 - 2*s + 1)) + 232*D1*Dd*Pk2*f**2*r**2 + 216*D1*Dd*Pk2*f**2*r*s - 170*D1*Dd*Pk2*f**2*r - 208*D1*Dd*Pk2*f**2*s**2 + 50*D1*Dd*Pk2*f**2*s + 6*D1*Dd*Pk2*f**2 - 384*D1*Dd*Pk2*f*fd*r**2 - 1248*D1*Dd*Pk2*f*fd*r*s + 876*D1*Dd*Pk2*f*fd*r + 224*D1*Dd*Pk2*f*fd*s**2 + 476*D1*Dd*Pk2*f*fd*s - 250*D1*Dd*Pk2*f*fd + 32*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 16*D1*Dd*Pkdd2*f**2*k1**2*s + 8*D1*Dd*Pkdd2*f**2*k1**2 - 160*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 40*D1*Dd*Pkdd2*f*fd*k1**2*s - 96*D1*Ddd*Pk2*f**2*r**2 - 312*D1*Ddd*Pk2*f**2*r*s + 126*D1*Ddd*Pk2*f**2*r + 56*D1*Ddd*Pk2*f**2*s**2 + 50*D1*Ddd*Pk2*f**2*s - 10*D1*Ddd*Pk2*f**2 - 40*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 20*D1*Ddd*Pkdd2*f**2*k1**2*s - 10*D1*Ddd*Pkdd2*f**2*k1**2 + 2*D1*bd1*(D1*(3*Pk2*f*(C*(28*r*(2*s - 1) + 46*s**2 - 74*s + 23) + r*(32 - 64*s) - 46*s**2 + 78*s - 23) - Pk2*fd*r*(28*C - 34)*(4*s - 1) + 2*Pk2*fd*s*(C*(73 - 118*s) + 118*s - 76) - Pkdd2*f*k1**2*(6*C - 12)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(6*C - 12)*(2*s - 1)) + 2*Dd*f*(Pk2*(C*(-28*r*(8*s - 3) - 472*s**2 + 438*s - 87) + 34*r*(8*s - 3) + 472*s**2 - 456*s + 93) + Pkdd2*k1**2*(3*C - 6)*(8*s**2 - 6*s + 1))) - 288*Dd**2*Pk2*f**2*r**2 - 936*Dd**2*Pk2*f**2*r*s + 378*Dd**2*Pk2*f**2*r + 168*Dd**2*Pk2*f**2*s**2 + 150*Dd**2*Pk2*f**2*s - 78*Dd**2*Pk2*f**2 - 120*Dd**2*Pkdd2*f**2*k1**2*s**2 + 60*Dd**2*Pkdd2*f**2*k1**2*s) + f*(-5628*C*D1**2*Pk2*f*fd*r**2 - 31344*C*D1**2*Pk2*f*fd*r*s + 14200*C*D1**2*Pk2*f*fd*r - 26628*C*D1**2*Pk2*f*fd*s**2 + 28200*C*D1**2*Pk2*f*fd*s - 10752*C*D1**2*Pk2*f*fd + 1428*C*D1**2*Pk2*f*fdd*r**2 + 20424*C*D1**2*Pk2*f*fdd*r*s - 7760*C*D1**2*Pk2*f*fdd*r + 24798*C*D1**2*Pk2*f*fdd*s**2 - 23340*C*D1**2*Pk2*f*fdd*s + 8742*C*D1**2*Pk2*f*fdd + 2856*C*D1**2*Pk2*fd**2*r**2 + 40848*C*D1**2*Pk2*fd**2*r*s - 15520*C*D1**2*Pk2*fd**2*r + 49596*C*D1**2*Pk2*fd**2*s**2 - 46680*C*D1**2*Pk2*fd**2*s + 6808*C*D1**2*Pk2*fd**2 + 1335*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 890*C*D1**2*Pkdd2*f*fd*k1**2*s + 445*C*D1**2*Pkdd2*f*fd*k1**2 - 420*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 280*C*D1**2*Pkdd2*f*fdd*k1**2*s - 140*C*D1**2*Pkdd2*f*fdd*k1**2 - 840*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 560*C*D1**2*Pkdd2*fd**2*k1**2*s - 7504*C*D1*Dd*Pk2*f**2*r**2 - 41792*C*D1*Dd*Pk2*f**2*r*s + 14200*C*D1*Dd*Pk2*f**2*r - 35504*C*D1*Dd*Pk2*f**2*s**2 + 28200*C*D1*Dd*Pk2*f**2*s - 10752*C*D1*Dd*Pk2*f**2 + 11424*C*D1*Dd*Pk2*f*fd*r**2 + 163392*C*D1*Dd*Pk2*f*fd*r*s - 54320*C*D1*Dd*Pk2*f*fd*r + 198384*C*D1*Dd*Pk2*f*fd*s**2 - 163380*C*D1*Dd*Pk2*f*fd*s + 31100*C*D1*Dd*Pk2*f*fd + 1780*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 890*C*D1*Dd*Pkdd2*f**2*k1**2*s + 445*C*D1*Dd*Pkdd2*f**2*k1**2 - 3360*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 1960*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 280*C*D1*Dd*Pkdd2*f*fd*k1**2 + 1904*C*D1*Ddd*Pk2*f**2*r**2 + 27232*C*D1*Ddd*Pk2*f**2*r*s - 7760*C*D1*Ddd*Pk2*f**2*r + 33064*C*D1*Ddd*Pk2*f**2*s**2 - 23340*C*D1*Ddd*Pk2*f**2*s + 8742*C*D1*Ddd*Pk2*f**2 - 560*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 280*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 140*C*D1*Ddd*Pkdd2*f**2*k1**2 + 5712*C*Dd**2*Pk2*f**2*r**2 + 81696*C*Dd**2*Pk2*f**2*r*s - 23280*C*Dd**2*Pk2*f**2*r + 99192*C*Dd**2*Pk2*f**2*s**2 - 70020*C*Dd**2*Pk2*f**2*s + 6808*C*Dd**2*Pk2*f**2 - 1680*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 840*C*Dd**2*Pkdd2*f**2*k1**2*s + 8592*D1**2*Pk2*f*fd*r**2 + 26661*D1**2*Pk2*f*fd*r*s - 14615*D1**2*Pk2*f*fd*r + 5448*D1**2*Pk2*f*fd*s**2 - 12519*D1**2*Pk2*f*fd*s + 4680*D1**2*Pk2*f*fd - 2712*D1**2*Pk2*f*fdd*r**2 - 17241*D1**2*Pk2*f*fdd*r*s + 7555*D1**2*Pk2*f*fdd*r - 7278*D1**2*Pk2*f*fdd*s**2 + 10599*D1**2*Pk2*f*fdd*s - 3330*D1**2*Pk2*f*fdd - 5424*D1**2*Pk2*fd**2*r**2 - 34482*D1**2*Pk2*fd**2*r*s + 15110*D1**2*Pk2*fd**2*r - 14556*D1**2*Pk2*fd**2*s**2 + 21198*D1**2*Pk2*fd**2*s - 5747*D1**2*Pk2*fd**2 - 990*D1**2*Pkdd2*f*fd*k1**2*s**2 + 660*D1**2*Pkdd2*f*fd*k1**2*s - 330*D1**2*Pkdd2*f*fd*k1**2 - 132*D1**2*bd1**2*(Pk2*(C*(28*r*s - 14*r + 59*s**2 - 73*s + 14) - 34*r*s + 17*r - 59*s**2 + 76*s - 17) + Pkdd2*k1**2*s*(6 - 3*C)*(s - 1)) + 33*D1**2*bdd1*f*(2*Pk2*(C*(6*r**2 + r*(62*s + 20) + 99*s**2 + 6*s - 44) - 12*r**2 - 3*r*(13*s + 5) + 7*s**2 - 22*s + 38) - 5*Pkdd2*k1**2*(C*(2*s - 1) + 2*(s - 1)**2)) + 11456*D1*Dd*Pk2*f**2*r**2 + 35548*D1*Dd*Pk2*f**2*r*s - 14615*D1*Dd*Pk2*f**2*r + 7264*D1*Dd*Pk2*f**2*s**2 - 12519*D1*Dd*Pk2*f**2*s + 4680*D1*Dd*Pk2*f**2 - 21696*D1*Dd*Pk2*f*fd*r**2 - 137928*D1*Dd*Pk2*f*fd*r*s + 52885*D1*Dd*Pk2*f*fd*r - 58224*D1*Dd*Pk2*f*fd*s**2 + 74193*D1*Dd*Pk2*f*fd*s - 18154*D1*Dd*Pk2*f*fd - 1320*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 660*D1*Dd*Pkdd2*f**2*k1**2*s - 330*D1*Dd*Pkdd2*f**2*k1**2 - 3616*D1*Ddd*Pk2*f**2*r**2 - 22988*D1*Ddd*Pk2*f**2*r*s + 7555*D1*Ddd*Pk2*f**2*r - 9704*D1*Ddd*Pk2*f**2*s**2 + 10599*D1*Ddd*Pk2*f**2*s - 3330*D1*Ddd*Pk2*f**2 - 66*D1*bd1*(D1*(Pk2*f*(C*(23*r**2 + 58*r*s + 42*r + 102*s**2 - 30*s - 35) - 29*r**2 - 27*r*s - 44*r + 26*s**2 + 13*s + 29) - Pk2*fd*(C*(24*r**2 + 248*r*s - 54*r + 396*s**2 - 254*s + 62) - 48*r**2 - 156*r*s + 48*r + 28*s**2 + 3*s - 39) - Pkdd2*f*k1**2*(C*(3*s**2 + 10*s - 5) + 4*s**2 - 20*s + 10) + 5*Pkdd2*fd*k1**2*s*(C + 4*s - 4)) + Dd*f*(-Pk2*(C*(48*r**2 + 496*r*s + 6*r + 792*s**2 - 236*s - 26) - 96*r**2 - 312*r*s + 3*r + 56*s**2 - 63*s + 37) + 5*Pkdd2*k1**2*(4*s - 1)*(C + 2*s - 2))) - 10848*Dd**2*Pk2*f**2*r**2 - 68964*Dd**2*Pk2*f**2*r*s + 22665*Dd**2*Pk2*f**2*r - 29112*Dd**2*Pk2*f**2*s**2 + 31797*Dd**2*Pk2*f**2*s - 5747*Dd**2*Pk2*f**2))/(693*d**2*k3**2) - D1**2*Pk1*ct**4*k2**2*st**2*(528*C*D1**2*Pk2*b1*f*fd*r**2 + 924*C*D1**2*Pk2*b1*f*fdd*r**2 + 924*C*D1**2*Pk2*b1*fd**2*r**2 - 672*C*D1**2*Pk2*f**2*fd*r**2 + 448*C*D1**2*Pk2*f**2*fd*r - 224*C*D1**2*Pk2*f**2*fd + 1722*C*D1**2*Pk2*f**2*fdd*r**2 - 1148*C*D1**2*Pk2*f**2*fdd*r + 574*C*D1**2*Pk2*f**2*fdd + 3444*C*D1**2*Pk2*f*fd**2*r**2 - 2296*C*D1**2*Pk2*f*fd**2*r + 396*C*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 198*C*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 1584*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 2376*C*D1**2*Pkdd2*b1*f*fd*k1**2*s - 1188*C*D1**2*Pkdd2*b1*f*fd*k1**2 + 594*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 990*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 495*C*D1**2*Pkdd2*b1*f*fdd*k1**2 + 594*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 990*C*D1**2*Pkdd2*b1*fd**2*k1**2*s - 2844*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 1896*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 948*C*D1**2*Pkdd2*f**2*fd*k1**2 + 1125*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 750*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 375*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 2250*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 1500*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 1056*C*D1*Dd*Pk2*b1*f**2*r**2 - 528*C*D1*Dd*Pk2*b1*f**2*r + 264*C*D1*Dd*Pk2*b1*f**2 + 7392*C*D1*Dd*Pk2*b1*f*fd*r**2 - 1848*C*D1*Dd*Pk2*b1*f*fd*r - 896*C*D1*Dd*Pk2*f**3*r**2 + 448*C*D1*Dd*Pk2*f**3*r - 224*C*D1*Dd*Pk2*f**3 + 13776*C*D1*Dd*Pk2*f**2*fd*r**2 - 8036*C*D1*Dd*Pk2*f**2*fd*r + 1148*C*D1*Dd*Pk2*f**2*fd + 1584*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 792*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 396*C*D1*Dd*Pkdd2*b1**2*f*k1**2 - 1584*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 396*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 3168*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 1584*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 792*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 4752*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 5148*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 990*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 - 3792*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 1896*C*D1*Dd*Pkdd2*f**3*k1**2*s - 948*C*D1*Dd*Pkdd2*f**3*k1**2 + 9000*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 5250*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 750*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 1848*C*D1*Ddd*Pk2*b1*f**2*r**2 - 924*C*D1*Ddd*Pk2*b1*f**2*r + 462*C*D1*Ddd*Pk2*b1*f**2 + 2296*C*D1*Ddd*Pk2*f**3*r**2 - 1148*C*D1*Ddd*Pk2*f**3*r + 574*C*D1*Ddd*Pk2*f**3 - 792*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 396*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 198*C*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 1188*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 594*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 297*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 1500*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 750*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 375*C*D1*Ddd*Pkdd2*f**3*k1**2 + 5544*C*Dd**2*Pk2*b1*f**2*r**2 - 2772*C*Dd**2*Pk2*b1*f**2*r + 6888*C*Dd**2*Pk2*f**3*r**2 - 3444*C*Dd**2*Pk2*f**3*r - 2376*C*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 1188*C*Dd**2*Pkdd2*b1**2*f*k1**2*s + 3564*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 1782*C*Dd**2*Pkdd2*b1*f**2*k1**2*s + 4500*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 2250*C*Dd**2*Pkdd2*f**3*k1**2*s - 528*D1**2*Pk2*b1*f*fd*r**2 + 264*D1**2*Pk2*b1*f*fd*r*s - 132*D1**2*Pk2*b1*f*fd*r - 924*D1**2*Pk2*b1*f*fdd*r**2 + 660*D1**2*Pk2*b1*f*fdd*r*s - 330*D1**2*Pk2*b1*f*fdd*r - 924*D1**2*Pk2*b1*fd**2*r**2 + 660*D1**2*Pk2*b1*fd**2*r*s - 330*D1**2*Pk2*b1*fd**2*r + 672*D1**2*Pk2*f**2*fd*r**2 + 1212*D1**2*Pk2*f**2*fd*r*s - 852*D1**2*Pk2*f**2*fd*r - 404*D1**2*Pk2*f**2*fd*s + 224*D1**2*Pk2*f**2*fd - 1722*D1**2*Pk2*f**2*fdd*r**2 - 210*D1**2*Pk2*f**2*fdd*r*s + 1218*D1**2*Pk2*f**2*fdd*r + 70*D1**2*Pk2*f**2*fdd*s - 574*D1**2*Pk2*f**2*fdd - 3444*D1**2*Pk2*f*fd**2*r**2 - 420*D1**2*Pk2*f*fd**2*r*s + 2436*D1**2*Pk2*f*fd**2*r + 140*D1**2*Pk2*f*fd**2*s - 70*D1**2*Pk2*f*fd**2 - 396*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 198*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 1716*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 924*D1**2*Pkdd2*b1*f*fd*k1**2*s - 462*D1**2*Pkdd2*b1*f*fd*k1**2 + 1056*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 660*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 330*D1**2*Pkdd2*b1*f*fdd*k1**2 + 1056*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 660*D1**2*Pkdd2*b1*fd**2*k1**2*s - 396*D1**2*Pkdd2*bd1**2*f*k1**2*s*(C - 1)*(s - 1) - 906*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 604*D1**2*Pkdd2*f**2*fd*k1**2*s - 302*D1**2*Pkdd2*f**2*fd*k1**2 + 750*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 500*D1**2*Pkdd2*f**2*fdd*k1**2*s + 250*D1**2*Pkdd2*f**2*fdd*k1**2 + 1500*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 1000*D1**2*Pkdd2*f*fd**2*k1**2*s + 33*D1**2*bdd1*f*(2*Pk2*f*(r - 1)*(7*C*(r - 1) - 7*r + 5*s + 7) - 6*Pkdd2*b1*k1**2*(C - 1)*(2*s**2 - 2*s + 1) + Pkdd2*f*k1**2*(3*C*(3*s**2 + 4*s - 2) + 16*s**2 - 12*s + 6)) - 1056*D1*Dd*Pk2*b1*f**2*r**2 + 528*D1*Dd*Pk2*b1*f**2*r*s + 396*D1*Dd*Pk2*b1*f**2*r - 132*D1*Dd*Pk2*b1*f**2*s - 264*D1*Dd*Pk2*b1*f**2 - 7392*D1*Dd*Pk2*b1*f*fd*r**2 + 5280*D1*Dd*Pk2*b1*f*fd*r*s - 132*D1*Dd*Pk2*b1*f*fd*r - 660*D1*Dd*Pk2*b1*f*fd*s + 330*D1*Dd*Pk2*b1*f*fd + 896*D1*Dd*Pk2*f**3*r**2 + 1616*D1*Dd*Pk2*f**3*r*s - 852*D1*Dd*Pk2*f**3*r - 404*D1*Dd*Pk2*f**3*s + 224*D1*Dd*Pk2*f**3 - 13776*D1*Dd*Pk2*f**2*fd*r**2 - 1680*D1*Dd*Pk2*f**2*fd*r*s + 8526*D1*Dd*Pk2*f**2*fd*r + 490*D1*Dd*Pk2*f**2*fd*s - 1288*D1*Dd*Pk2*f**2*fd - 1584*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 792*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 396*D1*Dd*Pkdd2*b1**2*f*k1**2 + 1584*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 396*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 3432*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 1716*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 858*D1*Dd*Pkdd2*b1*f**2*k1**2 + 8448*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 4752*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 660*D1*Dd*Pkdd2*b1*f*fd*k1**2 - 1208*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 604*D1*Dd*Pkdd2*f**3*k1**2*s - 302*D1*Dd*Pkdd2*f**3*k1**2 + 6000*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 3500*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 500*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1848*D1*Ddd*Pk2*b1*f**2*r**2 + 1320*D1*Ddd*Pk2*b1*f**2*r*s + 594*D1*Ddd*Pk2*b1*f**2*r - 330*D1*Ddd*Pk2*b1*f**2*s - 462*D1*Ddd*Pk2*b1*f**2 - 2296*D1*Ddd*Pk2*f**3*r**2 - 280*D1*Ddd*Pk2*f**3*r*s + 1218*D1*Ddd*Pk2*f**3*r + 70*D1*Ddd*Pk2*f**3*s - 574*D1*Ddd*Pk2*f**3 + 792*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 396*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 198*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 2112*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 1056*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 528*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 1000*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 500*D1*Ddd*Pkdd2*f**3*k1**2*s + 250*D1*Ddd*Pkdd2*f**3*k1**2 + 66*D1*bd1*(D1*(6*Pkdd2*b1*fd*k1**2*s*(-2*C*s + C + 2*s - 1) + f**2*(2*Pk2*(r - 1)*(2*C*(r - 1) - 2*r + s + 2) - Pkdd2*k1**2*(6*C*(2*s**2 + 2*s - 1) + 13*s**2 - 12*s + 6)) + f*(Pk2*fd*(r**2*(28*C - 28) + r*(-28*C + 20*s + 23) - 10*s + 5) + 6*Pkdd2*b1*k1**2*(C - 1)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(3*C*(6*s - 1) + 32*s - 22))) + Dd*f*(Pk2*f*(14*C*(4*r**2 - 5*r + 1) - 56*r**2 + 40*r*s + 65*r - 25*s - 9) - 6*Pkdd2*b1*k1**2*(C - 1)*(8*s**2 - 6*s + 1) + Pkdd2*f*k1**2*(4*s - 1)*(C*(9*s + 6) + 16*s - 6))) - 5544*Dd**2*Pk2*b1*f**2*r**2 + 3960*Dd**2*Pk2*b1*f**2*r*s + 1782*Dd**2*Pk2*b1*f**2*r - 990*Dd**2*Pk2*b1*f**2*s + 330*Dd**2*Pk2*b1*f**2 - 6888*Dd**2*Pk2*f**3*r**2 - 840*Dd**2*Pk2*f**3*r*s + 3654*Dd**2*Pk2*f**3*r + 210*Dd**2*Pk2*f**3*s - 70*Dd**2*Pk2*f**3 + 2376*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 1188*Dd**2*Pkdd2*b1**2*f*k1**2*s + 6336*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 3168*Dd**2*Pkdd2*b1*f**2*k1**2*s + 3000*Dd**2*Pkdd2*f**3*k1**2*s**2 - 1500*Dd**2*Pkdd2*f**3*k1**2*s)/(693*d**2*k1**2*k3**2) + 2*D1**2*Pk1*ct**4*k2**2*(-33*b1**2*(D1**2*(Pk2*fd*r**2*(38*C - 38) + Pk2*fdd*r**2*(2*C - 2) - Pkdd2*fd*k1**2*s**2*(19*C + 5) + Pkdd2*fdd*k1**2*s**2*(6*C + 6)) + D1*(Dd*(Pk2*f*(38*C - 38)*(4*r**2 - 2*r + 1) + Pk2*fd*r*(4*C - 4)*(4*r - 1) - Pkdd2*f*k1**2*(19*C + 5)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(12*C + 12)*(4*s - 1)) + 2*Ddd*f*(Pk2*(C - 1)*(4*r**2 - 2*r + 1) + Pkdd2*k1**2*(3*C + 3)*(4*s**2 - 2*s + 1))) + 12*Dd**2*f*(Pk2*r*(C - 1)*(2*r - 1) + Pkdd2*k1**2*s*(3*C + 3)*(2*s - 1))) - 33*b1*(60*C*D1**2*Pk2*f*fd*r**2 - 84*C*D1**2*Pk2*f*fd*r + 42*C*D1**2*Pk2*f*fd + 16*C*D1**2*Pk2*f*fdd*r**2 - 16*C*D1**2*Pk2*f*fdd*r + 8*C*D1**2*Pk2*f*fdd + 16*C*D1**2*Pk2*fd**2*r**2 - 16*C*D1**2*Pk2*fd**2*r - 20*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 12*C*D1**2*Pkdd2*f*fd*k1**2*s + 6*C*D1**2*Pkdd2*f*fd*k1**2 + 10*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 10*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 120*C*D1*Dd*Pk2*f**2*r**2 - 60*C*D1*Dd*Pk2*f**2*r + 30*C*D1*Dd*Pk2*f**2 + 128*C*D1*Dd*Pk2*f*fd*r**2 - 96*C*D1*Dd*Pk2*f*fd*r + 16*C*D1*Dd*Pk2*f*fd - 40*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 20*C*D1*Dd*Pkdd2*f**2*k1**2*s - 10*C*D1*Dd*Pkdd2*f**2*k1**2 + 80*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 20*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 32*C*D1*Ddd*Pk2*f**2*r**2 - 16*C*D1*Ddd*Pk2*f**2*r + 8*C*D1*Ddd*Pk2*f**2 + 20*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 10*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 5*C*D1*Ddd*Pkdd2*f**2*k1**2 + 96*C*Dd**2*Pk2*f**2*r**2 - 48*C*Dd**2*Pk2*f**2*r + 60*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 30*C*Dd**2*Pkdd2*f**2*k1**2*s - 92*D1**2*Pk2*f*fd*r**2 + 52*D1**2*Pk2*f*fd*r*s + 58*D1**2*Pk2*f*fd*r - 42*D1**2*Pk2*f*fd - 24*D1**2*Pk2*f*fdd*r**2 - 56*D1**2*Pk2*f*fdd*r*s + 44*D1**2*Pk2*f*fdd*r - 8*D1**2*Pk2*f*fdd - 24*D1**2*Pk2*fd**2*r**2 - 56*D1**2*Pk2*fd**2*r*s + 44*D1**2*Pk2*fd**2*r + 4*D1**2*Pkdd2*f*fd*k1**2*s**2 - 12*D1**2*Pkdd2*f*fd*k1**2*s + 6*D1**2*Pkdd2*f*fd*k1**2 + 10*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 10*D1**2*Pkdd2*fd**2*k1**2*s**2 + 2*D1**2*bdd1*f*(Pk2*(C - 1)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(3*C + 3)*(2*s**2 - 2*s + 1)) - 184*D1*Dd*Pk2*f**2*r**2 + 104*D1*Dd*Pk2*f**2*r*s + 66*D1*Dd*Pk2*f**2*r - 26*D1*Dd*Pk2*f**2*s - 46*D1*Dd*Pk2*f**2 - 192*D1*Dd*Pk2*f*fd*r**2 - 448*D1*Dd*Pk2*f*fd*r*s + 280*D1*Dd*Pk2*f*fd*r + 56*D1*Dd*Pk2*f*fd*s - 44*D1*Dd*Pk2*f*fd + 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**2*k1**2*s + 2*D1*Dd*Pkdd2*f**2*k1**2 + 80*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 20*D1*Dd*Pkdd2*f*fd*k1**2*s - 48*D1*Ddd*Pk2*f**2*r**2 - 112*D1*Ddd*Pk2*f**2*r*s + 52*D1*Ddd*Pk2*f**2*r + 28*D1*Ddd*Pk2*f**2*s - 12*D1*Ddd*Pk2*f**2 + 20*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 10*D1*Ddd*Pkdd2*f**2*k1**2*s + 5*D1*Ddd*Pkdd2*f**2*k1**2 + D1*bd1*(D1*(Pk2*f*(38*C - 38)*(2*r**2 - 2*r + 1) + Pk2*fd*r*(4*C - 4)*(2*r - 1) - Pkdd2*f*k1**2*(19*C + 5)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(12*C + 12)*(2*s - 1)) + 4*Dd*f*(Pk2*(C - 1)*(8*r**2 - 6*r + 1) + Pkdd2*k1**2*(3*C + 3)*(8*s**2 - 6*s + 1))) - 144*Dd**2*Pk2*f**2*r**2 - 336*Dd**2*Pk2*f**2*r*s + 156*Dd**2*Pk2*f**2*r + 84*Dd**2*Pk2*f**2*s - 28*Dd**2*Pk2*f**2 + 60*Dd**2*Pkdd2*f**2*k1**2*s**2 - 30*Dd**2*Pkdd2*f**2*k1**2*s) + f*(1968*C*D1**2*Pk2*f*fd*r**2 - 1312*C*D1**2*Pk2*f*fd*r + 656*C*D1**2*Pk2*f*fd + 402*C*D1**2*Pk2*f*fdd*r**2 - 268*C*D1**2*Pk2*f*fdd*r + 134*C*D1**2*Pk2*f*fdd + 804*C*D1**2*Pk2*fd**2*r**2 - 536*C*D1**2*Pk2*fd**2*r - 495*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 330*C*D1**2*Pkdd2*f*fd*k1**2*s - 165*C*D1**2*Pkdd2*f*fd*k1**2 + 2624*C*D1*Dd*Pk2*f**2*r**2 - 1312*C*D1*Dd*Pk2*f**2*r + 656*C*D1*Dd*Pk2*f**2 + 3216*C*D1*Dd*Pk2*f*fd*r**2 - 1876*C*D1*Dd*Pk2*f*fd*r + 268*C*D1*Dd*Pk2*f*fd - 660*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 330*C*D1*Dd*Pkdd2*f**2*k1**2*s - 165*C*D1*Dd*Pkdd2*f**2*k1**2 + 536*C*D1*Ddd*Pk2*f**2*r**2 - 268*C*D1*Ddd*Pk2*f**2*r + 134*C*D1*Ddd*Pk2*f**2 + 1608*C*Dd**2*Pk2*f**2*r**2 - 804*C*Dd**2*Pk2*f**2*r + 1164*D1**2*Pk2*f*fd*r**2 - 1083*D1**2*Pk2*f*fd*r*s - 415*D1**2*Pk2*f*fd*r + 361*D1**2*Pk2*f*fd*s + 388*D1**2*Pk2*f*fd + 606*D1**2*Pk2*f*fdd*r**2 + 1383*D1**2*Pk2*f*fdd*r*s - 865*D1**2*Pk2*f*fdd*r - 461*D1**2*Pk2*f*fdd*s + 202*D1**2*Pk2*f*fdd + 1212*D1**2*Pk2*fd**2*r**2 + 2766*D1**2*Pk2*fd**2*r*s - 1730*D1**2*Pk2*fd**2*r - 922*D1**2*Pk2*fd**2*s + 461*D1**2*Pk2*fd**2 - 495*D1**2*Pkdd2*f*fd*k1**2*s**2 + 330*D1**2*Pkdd2*f*fd*k1**2*s - 165*D1**2*Pkdd2*f*fd*k1**2 - 132*D1**2*bd1**2*(Pk2*r*(C - 1)*(r - 1) + Pkdd2*k1**2*s*(3*C + 3)*(s - 1)) - 33*D1**2*bdd1*f*(4*Pk2*(r**2*(2*C - 3) + r*(2 - 7*s) + 7*s - 1) + Pkdd2*k1**2*(5*C + 5)*(s - 1)**2) + 1552*D1*Dd*Pk2*f**2*r**2 - 1444*D1*Dd*Pk2*f**2*r*s - 415*D1*Dd*Pk2*f**2*r + 361*D1*Dd*Pk2*f**2*s + 388*D1*Dd*Pk2*f**2 + 4848*D1*Dd*Pk2*f*fd*r**2 + 11064*D1*Dd*Pk2*f*fd*r*s - 6055*D1*Dd*Pk2*f*fd*r - 3227*D1*Dd*Pk2*f*fd*s + 1326*D1*Dd*Pk2*f*fd - 660*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 330*D1*Dd*Pkdd2*f**2*k1**2*s - 165*D1*Dd*Pkdd2*f**2*k1**2 + 808*D1*Ddd*Pk2*f**2*r**2 + 1844*D1*Ddd*Pk2*f**2*r*s - 865*D1*Ddd*Pk2*f**2*r - 461*D1*Ddd*Pk2*f**2*s + 202*D1*Ddd*Pk2*f**2 - 66*D1*bd1*(D1*(Pk2*f*(3*C*(5*r**2 + 4*r - 2) - 23*r**2 + 13*r*s + 4*r - 13*s - 2) + 2*Pk2*fd*(r**2*(8*C - 12) + r*(-4*C - 28*s + 15) + 14*s - 7) + Pkdd2*f*k1**2*(C*(-5*s**2 + 16*s - 8) + s**2 + 4*s - 2) + Pkdd2*fd*k1**2*s*(10*C + 10)*(s - 1)) + Dd*f*(2*Pk2*(r**2*(16*C - 24) + r*(-4*C - 56*s + 21) + 35*s - 9) + Pkdd2*k1**2*(5*C + 5)*(4*s**2 - 5*s + 1))) + 2424*Dd**2*Pk2*f**2*r**2 + 5532*Dd**2*Pk2*f**2*r*s - 2595*Dd**2*Pk2*f**2*r - 1383*Dd**2*Pk2*f**2*s + 461*Dd**2*Pk2*f**2))/(693*d**2*k1**2*k3**2) - D1**2*Pk1*ct**4*st**2*(-2574*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 26520*D1**2*Pk2*bdd1*f**3*r*s - 26520*D1**2*Pk2*bdd1*f**3*s - 56800*D1**2*Pk2*f**3*fd*r*s + 14200*D1**2*Pk2*f**3*fd*r + 14200*D1**2*Pk2*f**3*fd*s + 2400*D1**2*Pk2*f**3*fdd*r*s - 600*D1**2*Pk2*f**3*fdd*r - 600*D1**2*Pk2*f**3*fdd*s + 7200*D1**2*Pk2*f**2*fd**2*r*s - 1800*D1**2*Pk2*f**2*fd**2*r - 1800*D1**2*Pk2*f**2*fd**2*s + 600*D1**2*Pk2*f**2*fd**2 + 2574*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(-2*K + 5*f + 2) + 14625*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 2574*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 5148*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 58800*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 29400*D1**2*Pkdd2*f**3*fd*k1**2*s - 14700*D1**2*Pkdd2*f**3*fd*k1**2 + 29400*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 14700*D1**2*Pkdd2*f**3*fdd*k1**2*s + 7350*D1**2*Pkdd2*f**3*fdd*k1**2 + 88200*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 44100*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 10296*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 5148*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 20592*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 20592*D1**2*Pkdd2*f*fd*g2*k1**2*s - 10296*D1**2*Pkdd2*f*fd*g2*k1**2 + 20592*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 10296*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 10296*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 10296*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 5148*D1**2*Pkdd2*f*fdd*g2*k1**2 + 10296*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 10296*D1**2*Pkdd2*fd**2*g2*k1**2*s - 56800*D1*Dd*Pk2*f**4*r*s + 14200*D1*Dd*Pk2*f**4*r + 14200*D1*Dd*Pk2*f**4*s + 19200*D1*Dd*Pk2*f**3*fd*r*s - 4800*D1*Dd*Pk2*f**3*fd*r - 4800*D1*Dd*Pk2*f**3*fd*s + 1200*D1*Dd*Pk2*f**3*fd - 58800*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 29400*D1*Dd*Pkdd2*f**4*k1**2*s - 14700*D1*Dd*Pkdd2*f**4*k1**2 + 235200*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 117600*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 14700*D1*Dd*Pkdd2*f**3*fd*k1**2 - 41184*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 20592*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 10296*D1*Dd*Pkdd2*f**2*g2*k1**2 + 41184*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 10296*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 82368*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 61776*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 10296*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 2400*D1*Ddd*Pk2*f**4*r*s - 600*D1*Ddd*Pk2*f**4*r - 600*D1*Ddd*Pk2*f**4*s + 29400*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 14700*D1*Ddd*Pkdd2*f**4*k1**2*s + 7350*D1*Ddd*Pkdd2*f**4*k1**2 + 20592*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 10296*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 5148*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 78*D1*bd1*(D1*(-66*Pkdd2*f*k1**2*s*(fd*(2*s - 1)*(-K + 5*b1 + 1) + s*(2*b1*(K - 1) - 2*g2 + 2*gd2)) - 132*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) + 5*f**3*s*(92*Pk2*(r - 1) + 75*Pkdd2*k1**2*s) + f**2*(Pkdd2*k1**2*s**2*(-66*K + 330*b1 + 66) - 5*fd*(68*Pk2*(6*r*s - r - 3*s + 1) + 75*Pkdd2*k1**2*s*(3*s - 1)))) + Dd*f*(-66*Pkdd2*f*k1**2*s*(4*s - 1)*(-K + 5*b1 + 1) - Pkdd2*k1**2*s*(4*s - 1)*(-132*K*b1 + 132*b1 + 132*g2) - 5*f**2*(68*Pk2*(r*(8*s - 1) - 5*s + 1) + 75*Pkdd2*k1**2*s*(4*s - 1)))) + 7200*Dd**2*Pk2*f**4*r*s - 1800*Dd**2*Pk2*f**4*r - 1800*Dd**2*Pk2*f**4*s + 600*Dd**2*Pk2*f**4 + 88200*Dd**2*Pkdd2*f**4*k1**2*s**2 - 44100*Dd**2*Pkdd2*f**4*k1**2*s + 61776*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 30888*Dd**2*Pkdd2*f**2*g2*k1**2*s - 1287*Pkdd2*b1**2*k1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) - 4*fd*(K - 1)*(s - 1)**2 + 2*fdd*(K - 1)*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) - 2*f*(K - 1)*(4*s**2 - 2*s + 1) + 2*fd*(K - 1)*(4*s**2 - 5*s + 1)) - Ddd*f*(-2*K + 5*f + 2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(-2*K + 5*f + 2)) + 39*b1*(-2*D1*Dd*(66*Pkdd2*f*k1**2*(fd*(K - 1)*(8*s**2 - 6*s + 1) + 2*g2*(4*s**2 - 2*s + 1) + 2*gd2*s*(1 - 4*s)) - 132*Pkdd2*fd*g2*k1**2*(4*s**2 - 5*s + 1) + 5*f**3*(92*Pk2*(r*(4*s - 1) - s) + 75*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(Pkdd2*k1**2*(66 - 66*K)*(4*s**2 - 2*s + 1) - 5*fd*(68*Pk2*(24*r*s - 7*r - 3*s + 1) + 75*Pkdd2*k1**2*(12*s**2 - 7*s + 1)))) + D1*(D1*(-132*Pkdd2*k1**2*(s - 1)*(fd**2*s*(K - 1) + 2*fd*g2*(s - 1) - 2*fd*gd2*s - fdd*g2*(s - 1)) - 5*f**2*(136*Pk2*fdd*r*(1 - 3*s) - 66*Pkdd2*bdd1*k1**2*s**2 - 75*Pkdd2*fdd*k1**2*(3*s**2 - 2*s + 1) + 2*fd*(92*Pk2*r*(3*s - 1) + 75*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + 2*f*(66*Pkdd2*fd*k1**2*(K - 1)*(2*s**2 - 2*s + 1) - 33*Pkdd2*k1**2*(fdd*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(2*bdd1*(K - 1) + 4*gd2 - 2*gdd2)) + 5*fd**2*(136*Pk2*r*(3*s - 1) + 75*Pkdd2*k1**2*s*(3*s - 2)))) + Ddd*f*(-66*Pkdd2*f*k1**2*(K - 1)*(4*s**2 - 2*s + 1) + 132*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 5*f**2*(136*Pk2*(4*r*s - r - s) + 75*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 2*Dd**2*f*(-198*Pkdd2*f*k1**2*s*(K - 1)*(2*s - 1) + 396*Pkdd2*g2*k1**2*s*(2*s - 1) + 5*f**2*(68*Pk2*(12*r*s - 3*r - 3*s + 1) + 225*Pkdd2*k1**2*s*(2*s - 1)))))/(18018*d**2*k1**2) + D1**2*Pk1*ct**4*(-3432*D1**2*K*Pk2*bdd1*f**2*r**2 - 2145*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 5226*D1**2*Pk2*bdd1*f**3*r**2 + 10400*D1**2*Pk2*bdd1*f**3*r*s - 3588*D1**2*Pk2*bdd1*f**3*r - 17160*D1**2*Pk2*bdd1*f**3*s + 3484*D1**2*Pk2*bdd1*f**3 + 3432*D1**2*Pk2*bdd1*f**2*r**2 - 5148*D1**2*Pk2*bdd1*f**2*r*s + 1716*D1**2*Pk2*bdd1*f*g2*r**2 - 3432*D1**2*Pk2*bdd1*f*g2*r + 1716*D1**2*Pk2*bdd1*f*g2 + 53600*D1**2*Pk2*f**3*fd*r**2 - 33800*D1**2*Pk2*f**3*fd*r*s - 18350*D1**2*Pk2*f**3*fd*r + 8450*D1**2*Pk2*f**3*fd*s + 13400*D1**2*Pk2*f**3*fd + 15840*D1**2*Pk2*f**3*fdd*r**2 + 33800*D1**2*Pk2*f**3*fdd*r*s - 16370*D1**2*Pk2*f**3*fdd*r - 8450*D1**2*Pk2*f**3*fdd*s + 3960*D1**2*Pk2*f**3*fdd + 47520*D1**2*Pk2*f**2*fd**2*r**2 + 101400*D1**2*Pk2*f**2*fd**2*r*s - 49110*D1**2*Pk2*f**2*fd**2*r - 25350*D1**2*Pk2*f**2*fd**2*s + 8450*D1**2*Pk2*f**2*fd**2 + 36036*D1**2*Pk2*f**2*gd2*r**2 + 6864*D1**2*Pk2*f**2*gdd2*r**2 + 72072*D1**2*Pk2*f*fd*g2*r**2 - 72072*D1**2*Pk2*f*fd*g2*r + 36036*D1**2*Pk2*f*fd*g2 + 27456*D1**2*Pk2*f*fd*gd2*r**2 - 13728*D1**2*Pk2*f*fd*gd2*r + 13728*D1**2*Pk2*f*fdd*g2*r**2 - 13728*D1**2*Pk2*f*fdd*g2*r + 6864*D1**2*Pk2*f*fdd*g2 + 13728*D1**2*Pk2*fd**2*g2*r**2 - 13728*D1**2*Pk2*fd**2*g2*r - 2574*D1**2*Pkdd2*b2*bdd1*f*k1**2*s**2 + 8580*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 - 8580*D1**2*Pkdd2*b2*f*fd*k1**2*s + 4290*D1**2*Pkdd2*b2*f*fd*k1**2 - 4290*D1**2*Pkdd2*b2*f*fdd*k1**2*s**2 + 4290*D1**2*Pkdd2*b2*f*fdd*k1**2*s - 2145*D1**2*Pkdd2*b2*f*fdd*k1**2 - 4290*D1**2*Pkdd2*b2*fd**2*k1**2*s**2 + 4290*D1**2*Pkdd2*b2*fd**2*k1**2*s + 4290*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 - 8580*D1**2*Pkdd2*bd2*f*fd*k1**2*s**2 + 4290*D1**2*Pkdd2*bd2*f*fd*k1**2*s - 5460*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 7280*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 3640*D1**2*Pkdd2*bdd1*f**3*k1**2 - 2145*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 10296*D1**2*Pkdd2*bdd1*f*g2*k1**2*s - 5148*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 2145*D1**2*Pkdd2*bdd2*f**2*k1**2*s**2 - 14560*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 7280*D1**2*Pkdd2*f**3*fd*k1**2*s - 3640*D1**2*Pkdd2*f**3*fd*k1**2 - 13728*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 4290*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 27456*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 27456*D1**2*Pkdd2*f*fd*g2*k1**2*s - 13728*D1**2*Pkdd2*f*fd*g2*k1**2 + 17160*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 8580*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 8580*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 8580*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 4290*D1**2*Pkdd2*f*fdd*g2*k1**2 + 8580*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 8580*D1**2*Pkdd2*fd**2*g2*k1**2*s - 858*D1**2*bd1**2*(14*Pkdd2*g2*k1**2*s*(s - 1) + f**2*(8*Pk2*(4*r*s - r - 2*s + 1) + 5*Pkdd2*k1**2*s*(4*s - 3)) + 2*f*(Pk2*(r**2*(K - 1) + r*(-K + 12*s + 1) - 6*s) + 3*Pkdd2*k1**2*s*(K + 2*s - 1))) + 53600*D1*Dd*Pk2*f**4*r**2 - 33800*D1*Dd*Pk2*f**4*r*s - 18350*D1*Dd*Pk2*f**4*r + 8450*D1*Dd*Pk2*f**4*s + 13400*D1*Dd*Pk2*f**4 + 126720*D1*Dd*Pk2*f**3*fd*r**2 + 270400*D1*Dd*Pk2*f**3*fd*r*s - 130960*D1*Dd*Pk2*f**3*fd*r - 67600*D1*Dd*Pk2*f**3*fd*s + 24820*D1*Dd*Pk2*f**3*fd + 144144*D1*Dd*Pk2*f**2*g2*r**2 - 72072*D1*Dd*Pk2*f**2*g2*r + 36036*D1*Dd*Pk2*f**2*g2 + 54912*D1*Dd*Pk2*f**2*gd2*r**2 - 13728*D1*Dd*Pk2*f**2*gd2*r + 109824*D1*Dd*Pk2*f*fd*g2*r**2 - 82368*D1*Dd*Pk2*f*fd*g2*r + 13728*D1*Dd*Pk2*f*fd*g2 + 17160*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 - 8580*D1*Dd*Pkdd2*b2*f**2*k1**2*s + 4290*D1*Dd*Pkdd2*b2*f**2*k1**2 - 34320*D1*Dd*Pkdd2*b2*f*fd*k1**2*s**2 + 25740*D1*Dd*Pkdd2*b2*f*fd*k1**2*s - 4290*D1*Dd*Pkdd2*b2*f*fd*k1**2 - 17160*D1*Dd*Pkdd2*bd2*f**2*k1**2*s**2 + 4290*D1*Dd*Pkdd2*bd2*f**2*k1**2*s - 14560*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 7280*D1*Dd*Pkdd2*f**4*k1**2*s - 3640*D1*Dd*Pkdd2*f**4*k1**2 - 54912*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 27456*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 13728*D1*Dd*Pkdd2*f**2*g2*k1**2 + 34320*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 8580*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 68640*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 51480*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 8580*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 15840*D1*Ddd*Pk2*f**4*r**2 + 33800*D1*Ddd*Pk2*f**4*r*s - 16370*D1*Ddd*Pk2*f**4*r - 8450*D1*Ddd*Pk2*f**4*s + 3960*D1*Ddd*Pk2*f**4 + 27456*D1*Ddd*Pk2*f**2*g2*r**2 - 13728*D1*Ddd*Pk2*f**2*g2*r + 6864*D1*Ddd*Pk2*f**2*g2 - 8580*D1*Ddd*Pkdd2*b2*f**2*k1**2*s**2 + 4290*D1*Ddd*Pkdd2*b2*f**2*k1**2*s - 2145*D1*Ddd*Pkdd2*b2*f**2*k1**2 + 17160*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 8580*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 4290*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 13*D1*bd1*(D1*(f**3*(2*Pk2*(489*r**2 - 2*r*(400*s + 291) + 660*s + 326) + 5*Pkdd2*k1**2*(69*s**2 - 224*s + 112)) + 2*f**2*(-99*Pk2*r*(r*(7*K - 7) + 4*s) + Pkdd2*k1**2*s**2*(264*K + 66) + 2*fd*(Pk2*(603*r**2 + 1200*r*s - 539*r - 860*s + 265) + 70*Pkdd2*k1**2*s*(7 - 9*s))) + 66*f*(-2*Pk2*fd*(r**2*(8*K - 8) + r*(-4*K + 12*s + 1) - 3*s) + 4*Pk2*gd2*r**2 - 4*Pk2*gd2*r + 6*Pkdd2*b2*k1**2*s**2 - 6*Pkdd2*bd2*k1**2*s**2 - 5*Pkdd2*fd*k1**2*s*(K + 1)*(2*s - 1) + 12*Pkdd2*gd2*k1**2*s + g2*(38*Pk2*(r - 1)**2 + Pkdd2*k1**2*(-7*s**2 - 24*s + 12))) + 132*fd*(2*Pk2*g2*r*(r - 1) - 3*Pkdd2*b2*k1**2*s*(s - 1))) + 2*Dd*f*(132*Pk2*g2*(4*r**2 - 5*r + 1) + 198*Pkdd2*b2*k1**2*s*(1 - 4*s) + 396*Pkdd2*g2*k1**2*(4*s - 1) + 2*f**2*(Pk2*(804*r**2 + r*(1600*s - 677) - 1520*s + 399) - 70*Pkdd2*k1**2*(12*s**2 - 11*s + 2)) - 33*f*(2*Pk2*(r**2*(16*K - 16) + r*(-4*K + 24*s + 1) - 3*s) + Pkdd2*k1**2*s*(5*K + 5)*(4*s - 1)))) + 47520*Dd**2*Pk2*f**4*r**2 + 101400*Dd**2*Pk2*f**4*r*s - 49110*Dd**2*Pk2*f**4*r - 25350*Dd**2*Pk2*f**4*s + 8450*Dd**2*Pk2*f**4 + 82368*Dd**2*Pk2*f**2*g2*r**2 - 41184*Dd**2*Pk2*f**2*g2*r - 25740*Dd**2*Pkdd2*b2*f**2*k1**2*s**2 + 12870*Dd**2*Pkdd2*b2*f**2*k1**2*s + 51480*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 25740*Dd**2*Pkdd2*f**2*g2*k1**2*s + 429*Pkdd2*b1**3*k1**2*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-7*K*(4*s**2 - 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s + 28*s**2 - 14*s + 7) - D1*Ddd*(-7*K + 6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-7*K + 6*f + 7)) + 429*b1**2*(D1**2*(-38*K*Pk2*fd*r**2 - 2*K*Pk2*fdd*r**2 + 7*K*Pkdd2*fd*k1**2*s**2 - 38*K*Pkdd2*fd*k1**2*s + 19*K*Pkdd2*fd*k1**2 + 12*K*Pkdd2*fdd*k1**2*s - 6*K*Pkdd2*fdd*k1**2 + 32*Pk2*f*fd*r*s - 8*Pk2*f*fd*r - 64*Pk2*f*fdd*r*s + 16*Pk2*f*fdd*r - 64*Pk2*fd**2*r*s + 16*Pk2*fd**2*r + 38*Pk2*fd*r**2 - 8*Pk2*fd*r*s + 8*Pk2*fd*r + 2*Pk2*fdd*r**2 - 24*Pk2*fdd*r*s + 24*Pk2*fdd*r + 2*Pkdd2*bd1*k1**2*(-7*K*(3*s**2 - 2*s + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s + 21*s**2 - 14*s + 7) - Pkdd2*bdd1*k1**2*(-7*K + 6*f + 7)*(3*s**2 - 2*s + 1) + 68*Pkdd2*f*fd*k1**2*s**2 - 8*Pkdd2*f*fd*k1**2*s + 4*Pkdd2*f*fd*k1**2 - 40*Pkdd2*f*fdd*k1**2*s**2 + 10*Pkdd2*f*fdd*k1**2*s - 5*Pkdd2*f*fdd*k1**2 - 40*Pkdd2*fd**2*k1**2*s**2 + 10*Pkdd2*fd**2*k1**2*s + 17*Pkdd2*fd*k1**2*s**2 - 10*Pkdd2*fd*k1**2*s + 5*Pkdd2*fd*k1**2 - 12*Pkdd2*fdd*k1**2*s**2 + 12*Pkdd2*fdd*k1**2*s - 6*Pkdd2*fdd*k1**2 + 28*Pkdd2*gd2*k1**2*s**2 - 14*Pkdd2*gdd2*k1**2*s**2) + D1*(Dd*(16*Pk2*f**2*(r*(4*s - 1) - s) - 2*Pk2*f*(19*K*(4*r**2 - 2*r + 1) + 8*fd*(8*r - 1)*(4*s - 1) - 76*r**2 + 16*r*s + 34*r - 4*s - 19) - 4*Pk2*fd*(r**2*(4*K - 4) - r*(K - 48*s + 29) - 6*s + 6) + 34*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*f*k1**2*(-12*bd1*(12*s**2 - 7*s + 1) - 10*fd*(32*s**2 - 12*s + 1) + (7*K + 17)*(4*s**2 - 2*s + 1)) + 12*Pkdd2*fd*k1**2*(4*s - 1)*(K - 2*s + 1) + 14*Pkdd2*k1**2*(bd1*(K - 1)*(12*s**2 - 7*s + 1) + 2*g2*(4*s**2 - 2*s + 1) + 2*gd2*s*(1 - 4*s))) - 2*Ddd*(7*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 2*f**2*(8*Pk2*r*(4*s - 1) - 8*Pk2*s + 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(Pk2*(4*K*r**2 - 2*K*r + K - 4*r**2 + 48*r*s - 10*r - 12*s - 1) + 6*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) - 4*Dd**2*(21*Pkdd2*g2*k1**2*s*(2*s - 1) + f**2*(8*Pk2*(12*r*s - 3*r - 3*s + 1) + 30*Pkdd2*k1**2*s*(2*s - 1)) + 3*f*(Pk2*(r**2*(2*K - 2) - r*(K - 24*s + 5) - 6*s + 2) + 6*Pkdd2*k1**2*s*(2*s - 1)))) - 13*b1*(2772*D1**2*K*Pk2*f*fd*r**2 - 2772*D1**2*K*Pk2*f*fd*r + 1386*D1**2*K*Pk2*f*fd + 528*D1**2*K*Pk2*f*fdd*r**2 - 528*D1**2*K*Pk2*f*fdd*r + 264*D1**2*K*Pk2*f*fdd + 528*D1**2*K*Pk2*fd**2*r**2 - 528*D1**2*K*Pk2*fd**2*r - 1056*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 1056*D1**2*K*Pkdd2*f*fd*k1**2*s - 528*D1**2*K*Pkdd2*f*fd*k1**2 + 330*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 330*D1**2*K*Pkdd2*f*fdd*k1**2*s + 165*D1**2*K*Pkdd2*f*fdd*k1**2 + 330*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 330*D1**2*K*Pkdd2*fd**2*k1**2*s - 2934*D1**2*Pk2*f**2*fd*r**2 + 4800*D1**2*Pk2*f**2*fd*r*s - 808*D1**2*Pk2*f**2*fd*r - 280*D1**2*Pk2*f**2*fd*s - 326*D1**2*Pk2*f**2*fd - 1206*D1**2*Pk2*f**2*fdd*r**2 - 2400*D1**2*Pk2*f**2*fdd*r*s + 1328*D1**2*Pk2*f**2*fdd*r - 520*D1**2*Pk2*f**2*fdd*s - 134*D1**2*Pk2*f**2*fdd - 2412*D1**2*Pk2*f*fd**2*r**2 - 4800*D1**2*Pk2*f*fd**2*r*s + 2656*D1**2*Pk2*f*fd**2*r - 1040*D1**2*Pk2*f*fd**2*s + 260*D1**2*Pk2*f*fd**2 - 2772*D1**2*Pk2*f*fd*r**2 + 1584*D1**2*Pk2*f*fd*r*s + 1980*D1**2*Pk2*f*fd*r - 792*D1**2*Pk2*f*fd*s - 1386*D1**2*Pk2*f*fd - 528*D1**2*Pk2*f*fdd*r**2 + 792*D1**2*Pk2*f*fdd*r*s + 132*D1**2*Pk2*f*fdd*r - 396*D1**2*Pk2*f*fdd*s - 264*D1**2*Pk2*f*fdd - 2508*D1**2*Pk2*f*gd2*r**2 - 132*D1**2*Pk2*f*gdd2*r**2 - 528*D1**2*Pk2*fd**2*r**2 + 792*D1**2*Pk2*fd**2*r*s + 132*D1**2*Pk2*fd**2*r - 396*D1**2*Pk2*fd**2*s + 396*D1**2*Pk2*fd**2 - 2508*D1**2*Pk2*fd*g2*r**2 - 264*D1**2*Pk2*fd*gd2*r**2 - 132*D1**2*Pk2*fdd*g2*r**2 - 396*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 792*D1**2*Pkdd2*b2*fd*k1**2*s - 396*D1**2*Pkdd2*b2*fd*k1**2 + 198*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 396*D1**2*Pkdd2*b2*fdd*k1**2*s + 198*D1**2*Pkdd2*b2*fdd*k1**2 + 66*D1**2*Pkdd2*bd1**2*k1**2*s*(3*s - 2)*(-7*K + 6*f + 7) - 396*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 396*D1**2*Pkdd2*bd2*fd*k1**2*s**2 - 396*D1**2*Pkdd2*bd2*fd*k1**2*s + 198*D1**2*Pkdd2*bdd2*f*k1**2*s**2 - 1035*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 430*D1**2*Pkdd2*f**2*fd*k1**2*s + 215*D1**2*Pkdd2*f**2*fd*k1**2 + 1260*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 280*D1**2*Pkdd2*f**2*fdd*k1**2*s + 140*D1**2*Pkdd2*f**2*fdd*k1**2 + 2520*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 560*D1**2*Pkdd2*f*fd**2*k1**2*s - 264*D1**2*Pkdd2*f*fd*k1**2*s**2 + 264*D1**2*Pkdd2*f*fd*k1**2*s - 132*D1**2*Pkdd2*f*fd*k1**2 + 330*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 330*D1**2*Pkdd2*f*fdd*k1**2*s + 165*D1**2*Pkdd2*f*fdd*k1**2 + 462*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 330*D1**2*Pkdd2*fd**2*k1**2*s**2 - 330*D1**2*Pkdd2*fd**2*k1**2*s + 462*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 2508*D1**2*Pkdd2*fd*g2*k1**2*s + 1254*D1**2*Pkdd2*fd*g2*k1**2 + 792*D1**2*Pkdd2*fd*gd2*k1**2*s + 792*D1**2*Pkdd2*fdd*g2*k1**2*s - 396*D1**2*Pkdd2*fdd*g2*k1**2 + 33*D1**2*bdd1*(14*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + f**2*(16*Pk2*(4*r*s - r - 2*s) + 5*Pkdd2*k1**2*(8*s**2 - 6*s + 3)) + 2*f*(Pk2*(2*K*r**2 - 2*K*r + K - 2*r**2 + 24*r*s + 2*r - 12*s - 1) + 3*Pkdd2*k1**2*(2*K*s - K + 4*s**2 - 2*s + 1))) + 5544*D1*Dd*K*Pk2*f**2*r**2 - 2772*D1*Dd*K*Pk2*f**2*r + 1386*D1*Dd*K*Pk2*f**2 + 4224*D1*Dd*K*Pk2*f*fd*r**2 - 3168*D1*Dd*K*Pk2*f*fd*r + 528*D1*Dd*K*Pk2*f*fd - 2112*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 1056*D1*Dd*K*Pkdd2*f**2*k1**2*s - 528*D1*Dd*K*Pkdd2*f**2*k1**2 + 2640*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 1980*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 330*D1*Dd*K*Pkdd2*f*fd*k1**2 - 3912*D1*Dd*Pk2*f**3*r**2 + 6400*D1*Dd*Pk2*f**3*r*s + 356*D1*Dd*Pk2*f**3*r - 1600*D1*Dd*Pk2*f**3*s - 978*D1*Dd*Pk2*f**3 - 9648*D1*Dd*Pk2*f**2*fd*r**2 - 19200*D1*Dd*Pk2*f**2*fd*r*s + 10124*D1*Dd*Pk2*f**2*fd*r + 320*D1*Dd*Pk2*f**2*fd*s - 808*D1*Dd*Pk2*f**2*fd - 5544*D1*Dd*Pk2*f**2*r**2 + 3168*D1*Dd*Pk2*f**2*r*s + 1980*D1*Dd*Pk2*f**2*r - 792*D1*Dd*Pk2*f**2*s - 1386*D1*Dd*Pk2*f**2 - 4224*D1*Dd*Pk2*f*fd*r**2 + 6336*D1*Dd*Pk2*f*fd*r*s + 792*D1*Dd*Pk2*f*fd*r - 2376*D1*Dd*Pk2*f*fd*s + 264*D1*Dd*Pk2*f*fd - 10032*D1*Dd*Pk2*f*g2*r**2 + 5016*D1*Dd*Pk2*f*g2*r - 2508*D1*Dd*Pk2*f*g2 - 1056*D1*Dd*Pk2*f*gd2*r**2 + 264*D1*Dd*Pk2*f*gd2*r - 1056*D1*Dd*Pk2*fd*g2*r**2 + 264*D1*Dd*Pk2*fd*g2*r - 1584*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 792*D1*Dd*Pkdd2*b2*f*k1**2*s - 396*D1*Dd*Pkdd2*b2*f*k1**2 + 1584*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 1980*D1*Dd*Pkdd2*b2*fd*k1**2*s + 396*D1*Dd*Pkdd2*b2*fd*k1**2 + 1584*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 396*D1*Dd*Pkdd2*bd2*f*k1**2*s - 1380*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 690*D1*Dd*Pkdd2*f**3*k1**2*s - 345*D1*Dd*Pkdd2*f**3*k1**2 + 10080*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 3640*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 280*D1*Dd*Pkdd2*f**2*fd*k1**2 - 528*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 264*D1*Dd*Pkdd2*f**2*k1**2*s - 132*D1*Dd*Pkdd2*f**2*k1**2 + 2640*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 1980*D1*Dd*Pkdd2*f*fd*k1**2*s + 330*D1*Dd*Pkdd2*f*fd*k1**2 + 1848*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 924*D1*Dd*Pkdd2*f*g2*k1**2*s + 462*D1*Dd*Pkdd2*f*g2*k1**2 + 3168*D1*Dd*Pkdd2*fd*g2*k1**2*s - 792*D1*Dd*Pkdd2*fd*g2*k1**2 + 1056*D1*Ddd*K*Pk2*f**2*r**2 - 528*D1*Ddd*K*Pk2*f**2*r + 264*D1*Ddd*K*Pk2*f**2 + 660*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 330*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 165*D1*Ddd*K*Pkdd2*f**2*k1**2 - 1608*D1*Ddd*Pk2*f**3*r**2 - 3200*D1*Ddd*Pk2*f**3*r*s + 1604*D1*Ddd*Pk2*f**3*r + 800*D1*Ddd*Pk2*f**3*s - 402*D1*Ddd*Pk2*f**3 - 1056*D1*Ddd*Pk2*f**2*r**2 + 1584*D1*Ddd*Pk2*f**2*r*s + 132*D1*Ddd*Pk2*f**2*r - 396*D1*Ddd*Pk2*f**2*s - 264*D1*Ddd*Pk2*f**2 - 528*D1*Ddd*Pk2*f*g2*r**2 + 264*D1*Ddd*Pk2*f*g2*r - 132*D1*Ddd*Pk2*f*g2 + 792*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 396*D1*Ddd*Pkdd2*b2*f*k1**2*s + 198*D1*Ddd*Pkdd2*b2*f*k1**2 + 1680*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 840*D1*Ddd*Pkdd2*f**3*k1**2*s + 420*D1*Ddd*Pkdd2*f**3*k1**2 + 660*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 330*D1*Ddd*Pkdd2*f**2*k1**2*s + 165*D1*Ddd*Pkdd2*f**2*k1**2 - 66*D1*bd1*(D1*(4*Pk2*f**2*(r*(4*s - 1) - 2*s) + Pk2*f*(-19*K*(2*r**2 - 2*r + 1) - 8*fd*(4*r - 1)*(4*s - 1) + 38*r**2 - 8*r*s - 38*r + 4*s + 19) + Pkdd2*f**2*k1**2*(34*s**2 - 30*s + 15) + Pkdd2*f*k1**2*(K*(7*s**2 + 12*s - 6) + s**2*(17 - 80*fd) + s*(40*fd - 12) + 6) + 14*Pkdd2*k1**2*(g2*(2*s**2 - 2*s + 1) + gd2*s*(1 - 2*s)) + 2*fd*(Pk2*(r**2*(2 - 2*K) + r*(K - 24*s + 11) + 6*s - 6) + 3*Pkdd2*k1**2*s*(K - 4*s + 3))) - Dd*(14*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) + f**2*(4*s - 1)*(8*Pk2*(8*r - 3) + 5*Pkdd2*k1**2*(8*s - 3)) + 2*f*(Pk2*(8*K*r**2 - 6*K*r + K - 8*r**2 + 96*r*s - 6*r - 36*s + 5) + 3*Pkdd2*k1**2*(4*s - 1)*(K + 4*s - 1)))) + 3168*Dd**2*K*Pk2*f**2*r**2 - 1584*Dd**2*K*Pk2*f**2*r + 1980*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 990*Dd**2*K*Pkdd2*f**2*k1**2*s - 4824*Dd**2*Pk2*f**3*r**2 - 9600*Dd**2*Pk2*f**3*r*s + 4812*Dd**2*Pk2*f**3*r + 2400*Dd**2*Pk2*f**3*s - 800*Dd**2*Pk2*f**3 - 3168*Dd**2*Pk2*f**2*r**2 + 4752*Dd**2*Pk2*f**2*r*s + 396*Dd**2*Pk2*f**2*r - 1188*Dd**2*Pk2*f**2*s + 396*Dd**2*Pk2*f**2 - 1584*Dd**2*Pk2*f*g2*r**2 + 792*Dd**2*Pk2*f*g2*r + 2376*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 1188*Dd**2*Pkdd2*b2*f*k1**2*s + 5040*Dd**2*Pkdd2*f**3*k1**2*s**2 - 2520*Dd**2*Pkdd2*f**3*k1**2*s + 1980*Dd**2*Pkdd2*f**2*k1**2*s**2 - 990*Dd**2*Pkdd2*f**2*k1**2*s))/(9009*d**2*k1**2) + D1**2*Pk1*ct**3*f*k2*st**4*(D1**2*(f*(-1056*Pk2*bd1*s*(C - 1)*(r - 1) + 80*Pk2*fd*(r*(4*C - 4)*(3*s - 1) + 9*s**2 - s*(4*C + 2) + 3) - 40*Pk2*fdd*(r*(4*C - 4)*(3*s - 1) + 9*s**2 - s*(4*C + 2) + 3) - Pkdd2*fd*k1**2*(40*C - 70)*(3*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(20*C - 35)*(3*s**2 - 2*s + 1)) - 2*fd*(528*Pk2*b1*r*(C - 1)*(2*s - 1) + 40*Pk2*fd*(2*C*(r*(6*s - 2) - 2*s + 1) + r*(4 - 12*s) + 9*s**2 - 2*s - 2) - Pkdd2*fd*k1**2*s*(20*C - 35)*(3*s - 2))) + D1*f*(2*Dd*(-528*Pk2*b1*(C - 1)*(r*(4*s - 1) - s) + 5*f*(8*Pk2*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 12*s**2 - 2*s + 3) - Pkdd2*k1**2*(4*C - 7)*(4*s**2 - 2*s + 1)) + 5*fd*(-8*Pk2*(2*C*(24*r*s - 7*r - 7*s + 2) - 48*r*s + 14*r + 36*s**2 - 7*s - 1) + Pkdd2*k1**2*(4*C - 7)*(12*s**2 - 7*s + 1))) + 5*Ddd*f*(-8*Pk2*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 12*s**2 - 2*s + 3) + Pkdd2*k1**2*(4*C - 7)*(4*s**2 - 2*s + 1))) + 10*Dd**2*f**2*(-8*Pk2*(C*(24*r*s - 6*r - 6*s + 2) - 24*r*s + 6*r + 18*s**2 - 3*s - 2) + Pkdd2*k1**2*s*(12*C - 21)*(2*s - 1)))/(231*d**2*k1*k3**2) + D1**2*Pk1*ct**3*k1*st**2*(-792*Pk2*b1**2*(2*C - 3)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 33*b1*(-320*C*D1**2*Pk2*f*fd*r*s + 160*C*D1**2*Pk2*f*fd*r - 1552*C*D1**2*Pk2*f*fd*s**2 + 1744*C*D1**2*Pk2*f*fd*s - 872*C*D1**2*Pk2*f*fd + 192*C*D1**2*Pk2*f*fdd*r*s - 96*C*D1**2*Pk2*f*fdd*r + 944*C*D1**2*Pk2*f*fdd*s**2 - 1040*C*D1**2*Pk2*f*fdd*s + 520*C*D1**2*Pk2*f*fdd + 192*C*D1**2*Pk2*fd**2*r*s - 96*C*D1**2*Pk2*fd**2*r + 944*C*D1**2*Pk2*fd**2*s**2 - 1040*C*D1**2*Pk2*fd**2*s - 640*C*D1*Dd*Pk2*f**2*r*s + 160*C*D1*Dd*Pk2*f**2*r - 3104*C*D1*Dd*Pk2*f**2*s**2 + 1712*C*D1*Dd*Pk2*f**2*s - 776*C*D1*Dd*Pk2*f**2 + 1536*C*D1*Dd*Pk2*f*fd*r*s - 576*C*D1*Dd*Pk2*f*fd*r + 7552*C*D1*Dd*Pk2*f*fd*s**2 - 6240*C*D1*Dd*Pk2*f*fd*s + 1136*C*D1*Dd*Pk2*f*fd + 384*C*D1*Ddd*Pk2*f**2*r*s - 96*C*D1*Ddd*Pk2*f**2*r + 1888*C*D1*Ddd*Pk2*f**2*s**2 - 1040*C*D1*Ddd*Pk2*f**2*s + 472*C*D1*Ddd*Pk2*f**2 + 1152*C*Dd**2*Pk2*f**2*r*s - 288*C*Dd**2*Pk2*f**2*r + 5664*C*Dd**2*Pk2*f**2*s**2 - 3120*C*Dd**2*Pk2*f**2*s + 96*C*Dd**2*Pk2*f**2 - 24*D1**2*Pk2*bdd1*f*(2*C - 3)*(2*s**2 - 2*s + 1) + 736*D1**2*Pk2*f*fd*r*s - 368*D1**2*Pk2*f*fd*r + 1144*D1**2*Pk2*f*fd*s**2 - 1432*D1**2*Pk2*f*fd*s + 716*D1**2*Pk2*f*fd - 448*D1**2*Pk2*f*fdd*r*s + 224*D1**2*Pk2*f*fdd*r - 824*D1**2*Pk2*f*fdd*s**2 + 968*D1**2*Pk2*f*fdd*s - 484*D1**2*Pk2*f*fdd - 448*D1**2*Pk2*fd**2*r*s + 224*D1**2*Pk2*fd**2*r - 824*D1**2*Pk2*fd**2*s**2 + 968*D1**2*Pk2*fd**2*s - 12*D1**2*Pkdd2*f*fd*k1**2*s**2 + 12*D1**2*Pkdd2*f*fd*k1**2*s - 6*D1**2*Pkdd2*f*fd*k1**2 + 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s + 3*D1**2*Pkdd2*f*fdd*k1**2 + 6*D1**2*Pkdd2*fd**2*k1**2*s**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s + 1472*D1*Dd*Pk2*f**2*r*s - 368*D1*Dd*Pk2*f**2*r + 2288*D1*Dd*Pk2*f**2*s**2 - 1512*D1*Dd*Pk2*f**2*s + 572*D1*Dd*Pk2*f**2 - 3584*D1*Dd*Pk2*f*fd*r*s + 1344*D1*Dd*Pk2*f*fd*r - 6592*D1*Dd*Pk2*f*fd*s**2 + 5968*D1*Dd*Pk2*f*fd*s - 1192*D1*Dd*Pk2*f*fd - 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 12*D1*Dd*Pkdd2*f**2*k1**2*s - 6*D1*Dd*Pkdd2*f**2*k1**2 + 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 36*D1*Dd*Pkdd2*f*fd*k1**2*s + 6*D1*Dd*Pkdd2*f*fd*k1**2 - 896*D1*Ddd*Pk2*f**2*r*s + 224*D1*Ddd*Pk2*f**2*r - 1648*D1*Ddd*Pk2*f**2*s**2 + 1048*D1*Ddd*Pk2*f**2*s - 412*D1*Ddd*Pk2*f**2 + 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 6*D1*Ddd*Pkdd2*f**2*k1**2*s + 3*D1*Ddd*Pkdd2*f**2*k1**2 + 48*D1*Pk2*bd1*(2*C - 3)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 2688*Dd**2*Pk2*f**2*r*s + 672*Dd**2*Pk2*f**2*r - 4944*Dd**2*Pk2*f**2*s**2 + 3144*Dd**2*Pk2*f**2*s - 224*Dd**2*Pk2*f**2 + 36*Dd**2*Pkdd2*f**2*k1**2*s**2 - 18*Dd**2*Pkdd2*f**2*k1**2*s) + f*(12672*C*D1**2*Pk2*f*fd*r*s - 4224*C*D1**2*Pk2*f*fd*r + 69432*C*D1**2*Pk2*f*fd*s**2 - 50512*C*D1**2*Pk2*f*fd*s + 23144*C*D1**2*Pk2*f*fd - 9504*C*D1**2*Pk2*f*fdd*r*s + 3168*C*D1**2*Pk2*f*fdd*r - 43032*C*D1**2*Pk2*f*fdd*s**2 + 31856*C*D1**2*Pk2*f*fdd*s - 14344*C*D1**2*Pk2*f*fdd - 19008*C*D1**2*Pk2*fd**2*r*s + 6336*C*D1**2*Pk2*fd**2*r - 86064*C*D1**2*Pk2*fd**2*s**2 + 63712*C*D1**2*Pk2*fd**2*s - 3168*C*D1**2*Pk2*fd**2 + 16896*C*D1*Dd*Pk2*f**2*r*s - 4224*C*D1*Dd*Pk2*f**2*r + 92576*C*D1*Dd*Pk2*f**2*s**2 - 50512*C*D1*Dd*Pk2*f**2*s + 23144*C*D1*Dd*Pk2*f**2 - 76032*C*D1*Dd*Pk2*f*fd*r*s + 22176*C*D1*Dd*Pk2*f*fd*r - 344256*C*D1*Dd*Pk2*f*fd*s**2 + 222992*C*D1*Dd*Pk2*f*fd*s - 35024*C*D1*Dd*Pk2*f*fd - 12672*C*D1*Ddd*Pk2*f**2*r*s + 3168*C*D1*Ddd*Pk2*f**2*r - 57376*C*D1*Ddd*Pk2*f**2*s**2 + 31856*C*D1*Ddd*Pk2*f**2*s - 14344*C*D1*Ddd*Pk2*f**2 - 38016*C*Dd**2*Pk2*f**2*r*s + 9504*C*Dd**2*Pk2*f**2*r - 172128*C*Dd**2*Pk2*f**2*s**2 + 95568*C*Dd**2*Pk2*f**2*s - 3168*C*Dd**2*Pk2*f**2 + 1584*D1**2*Pk2*bd1**2*s*(2*C - 3)*(s - 1) - 29280*D1**2*Pk2*f*fd*r*s + 9760*D1**2*Pk2*f*fd*r - 60900*D1**2*Pk2*f*fd*s**2 + 50360*D1**2*Pk2*f*fd*s - 20300*D1**2*Pk2*f*fd + 22560*D1**2*Pk2*f*fdd*r*s - 7520*D1**2*Pk2*f*fdd*r + 42924*D1**2*Pk2*f*fdd*s**2 - 36136*D1**2*Pk2*f*fdd*s + 14308*D1**2*Pk2*f*fdd + 45120*D1**2*Pk2*fd**2*r*s - 15040*D1**2*Pk2*fd**2*r + 85848*D1**2*Pk2*fd**2*s**2 - 72272*D1**2*Pk2*fd**2*s + 7520*D1**2*Pk2*fd**2 + 450*D1**2*Pkdd2*f*fd*k1**2*s**2 - 300*D1**2*Pkdd2*f*fd*k1**2*s + 150*D1**2*Pkdd2*f*fd*k1**2 - 225*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 150*D1**2*Pkdd2*f*fdd*k1**2*s - 75*D1**2*Pkdd2*f*fdd*k1**2 - 450*D1**2*Pkdd2*fd**2*k1**2*s**2 + 300*D1**2*Pkdd2*fd**2*k1**2*s - 33*D1**2*bdd1*f*(4*Pk2*(2*C*(12*r*s + 59*s**2 - 6) - 56*r*s - 103*s**2 + 20*s + 18) + 3*Pkdd2*k1**2*s**2) - 39040*D1*Dd*Pk2*f**2*r*s + 9760*D1*Dd*Pk2*f**2*r - 81200*D1*Dd*Pk2*f**2*s**2 + 50360*D1*Dd*Pk2*f**2*s - 20300*D1*Dd*Pk2*f**2 + 180480*D1*Dd*Pk2*f*fd*r*s - 52640*D1*Dd*Pk2*f*fd*r + 343392*D1*Dd*Pk2*f*fd*s**2 - 252952*D1*Dd*Pk2*f*fd*s + 43656*D1*Dd*Pk2*f*fd + 600*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 300*D1*Dd*Pkdd2*f**2*k1**2*s + 150*D1*Dd*Pkdd2*f**2*k1**2 - 1800*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 1050*D1*Dd*Pkdd2*f*fd*k1**2*s - 150*D1*Dd*Pkdd2*f*fd*k1**2 + 30080*D1*Ddd*Pk2*f**2*r*s - 7520*D1*Ddd*Pk2*f**2*r + 57232*D1*Ddd*Pk2*f**2*s**2 - 36136*D1*Ddd*Pk2*f**2*s + 14308*D1*Ddd*Pk2*f**2 - 300*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 150*D1*Ddd*Pkdd2*f**2*k1**2*s - 75*D1*Ddd*Pkdd2*f**2*k1**2 + 66*D1*bd1*(D1*(2*Pk2*f*(2*C*(97*s**2 + s*(20*r + 4) - 12) - 143*s**2 + s*(20 - 92*r) + 36) - 4*Pk2*fd*(2*C*(6*r*(4*s - 1) + 118*s**2 - 65*s + 6) - 28*r*(4*s - 1) - 206*s**2 + 141*s - 28) + 3*Pkdd2*f*k1**2*s**2 + 3*Pkdd2*fd*k1**2*s*(1 - 2*s)) + Dd*f*(-4*Pk2*(r*(12*C - 28)*(8*s - 1) + s**2*(472*C - 412) + s*(171 - 130*C) - 10) + 3*Pkdd2*k1**2*s*(1 - 4*s))) + 90240*Dd**2*Pk2*f**2*r*s - 22560*Dd**2*Pk2*f**2*r + 171696*Dd**2*Pk2*f**2*s**2 - 108408*Dd**2*Pk2*f**2*s + 7520*Dd**2*Pk2*f**2 - 900*Dd**2*Pkdd2*f**2*k1**2*s**2 + 450*Dd**2*Pkdd2*f**2*k1**2*s))/(693*d**2*k2*k3**2) + D1**2*Pk1*ct**3*k1*(66*b1**2*(D1**2*s*(Pk2*fd*r*(112*C - 188) + Pk2*fd*s*(220*C - 279) + Pk2*fdd*(r*(108 - 56*C) + s*(227 - 180*C)) + 6*Pkdd2*fd*k1**2*s - 3*Pkdd2*fdd*k1**2*s) + D1*(Dd*(Pk2*f*(4*C*(28*r*(4*s - 1) + 220*s**2 - 138*s + 55) - 188*r*(4*s - 1) - 1116*s**2 + 746*s - 279) - Pk2*fd*r*(56*C - 108)*(8*s - 1) + 2*Pk2*fd*s*(C*(208 - 720*s) + 908*s - 281) + 6*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + 6*Pkdd2*fd*k1**2*s*(1 - 4*s)) + Ddd*f*(Pk2*(-4*C*(14*r*(4*s - 1) + 180*s**2 - 104*s + 45) + 108*r*(4*s - 1) + 908*s**2 - 562*s + 227) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(4*C*Pk2*(21*r*(4*s - 1) + 270*s**2 - 156*s + 7) - 3*Pk2*(54*r*(4*s - 1) + 454*s**2 - 281*s + 18) + 9*Pkdd2*k1**2*s*(2*s - 1))) + 33*b1*(-384*C*D1**2*Pk2*f*fd*r*s + 416*C*D1**2*Pk2*f*fd*r - 1104*C*D1**2*Pk2*f*fd*s**2 + 1616*C*D1**2*Pk2*f*fd*s - 920*C*D1**2*Pk2*f*fd + 400*C*D1**2*Pk2*f*fdd*r*s - 312*C*D1**2*Pk2*f*fdd*r + 1056*C*D1**2*Pk2*f*fdd*s**2 - 1552*C*D1**2*Pk2*f*fdd*s + 832*C*D1**2*Pk2*f*fdd + 400*C*D1**2*Pk2*fd**2*r*s - 312*C*D1**2*Pk2*fd**2*r + 1056*C*D1**2*Pk2*fd**2*s**2 - 1552*C*D1**2*Pk2*fd**2*s - 768*C*D1*Dd*Pk2*f**2*r*s + 192*C*D1*Dd*Pk2*f**2*r - 2208*C*D1*Dd*Pk2*f**2*s**2 + 1296*C*D1*Dd*Pk2*f**2*s - 552*C*D1*Dd*Pk2*f**2 + 3200*C*D1*Dd*Pk2*f*fd*r*s - 1648*C*D1*Dd*Pk2*f*fd*r + 8448*C*D1*Dd*Pk2*f*fd*s**2 - 8720*C*D1*Dd*Pk2*f*fd*s + 1864*C*D1*Dd*Pk2*f*fd + 800*C*D1*Ddd*Pk2*f**2*r*s - 200*C*D1*Ddd*Pk2*f**2*r + 2112*C*D1*Ddd*Pk2*f**2*s**2 - 1256*C*D1*Ddd*Pk2*f**2*s + 528*C*D1*Ddd*Pk2*f**2 + 2400*C*Dd**2*Pk2*f**2*r*s - 600*C*Dd**2*Pk2*f**2*r + 6336*C*Dd**2*Pk2*f**2*s**2 - 3768*C*Dd**2*Pk2*f**2*s + 200*C*Dd**2*Pk2*f**2 + 76*D1**2*Pk2*f*fd*r**2 + 376*D1**2*Pk2*f*fd*r*s - 572*D1**2*Pk2*f*fd*r + 104*D1**2*Pk2*f*fd*s**2 - 656*D1**2*Pk2*f*fd*s + 520*D1**2*Pk2*f*fd - 76*D1**2*Pk2*f*fdd*r**2 - 408*D1**2*Pk2*f*fdd*r*s + 420*D1**2*Pk2*f*fdd*r - 328*D1**2*Pk2*f*fdd*s**2 + 880*D1**2*Pk2*f*fdd*s - 548*D1**2*Pk2*f*fdd - 76*D1**2*Pk2*fd**2*r**2 - 408*D1**2*Pk2*fd**2*r*s + 420*D1**2*Pk2*fd**2*r - 328*D1**2*Pk2*fd**2*s**2 + 880*D1**2*Pk2*fd**2*s + 8*D1**2*Pkdd2*f*fd*k1**2*s**2 + 12*D1**2*Pkdd2*f*fd*k1**2*s - 6*D1**2*Pkdd2*f*fd*k1**2 - 10*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 10*D1**2*Pkdd2*fd**2*k1**2*s**2 - 2*D1**2*bdd1*f*(Pk2*(4*C*(28*r*s - 14*r + 90*s**2 - 104*s + 45) - 216*r*s + 108*r - 454*s**2 + 562*s - 227) + 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 152*D1*Dd*Pk2*f**2*r**2 + 752*D1*Dd*Pk2*f**2*r*s - 264*D1*Dd*Pk2*f**2*r + 208*D1*Dd*Pk2*f**2*s**2 - 292*D1*Dd*Pk2*f**2*s + 90*D1*Dd*Pk2*f**2 - 608*D1*Dd*Pk2*f*fd*r**2 - 3264*D1*Dd*Pk2*f*fd*r*s + 2240*D1*Dd*Pk2*f*fd*r - 2624*D1*Dd*Pk2*f*fd*s**2 + 4584*D1*Dd*Pk2*f*fd*s - 1300*D1*Dd*Pk2*f*fd + 16*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 8*D1*Dd*Pkdd2*f**2*k1**2*s + 4*D1*Dd*Pkdd2*f**2*k1**2 - 80*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 20*D1*Dd*Pkdd2*f*fd*k1**2*s - 152*D1*Ddd*Pk2*f**2*r**2 - 816*D1*Ddd*Pk2*f**2*r*s + 280*D1*Ddd*Pk2*f**2*r - 656*D1*Ddd*Pk2*f**2*s**2 + 532*D1*Ddd*Pk2*f**2*s - 202*D1*Ddd*Pk2*f**2 - 20*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 10*D1*Ddd*Pkdd2*f**2*k1**2*s - 5*D1*Ddd*Pkdd2*f**2*k1**2 + 2*D1*bd1*(D1*(Pk2*f*(4*C*(56*r*s - 28*r + 110*s**2 - 138*s + 55) - 376*r*s + 188*r - 558*s**2 + 746*s - 279) - Pk2*fd*r*(56*C - 108)*(4*s - 1) + 2*Pk2*fd*s*(-8*C*(45*s - 26) + 454*s - 281) + 6*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + 6*Pkdd2*fd*k1**2*s*(1 - 2*s)) - 2*Dd*f*(Pk2*(4*C*(14*r*(8*s - 3) + 360*s**2 - 312*s + 59) - 864*r*s + 324*r - 1816*s**2 + 1686*s - 335) + 3*Pkdd2*k1**2*(8*s**2 - 6*s + 1))) - 456*Dd**2*Pk2*f**2*r**2 - 2448*Dd**2*Pk2*f**2*r*s + 840*Dd**2*Pk2*f**2*r - 1968*Dd**2*Pk2*f**2*s**2 + 1596*Dd**2*Pk2*f**2*s - 204*Dd**2*Pk2*f**2 - 60*Dd**2*Pkdd2*f**2*k1**2*s**2 + 30*Dd**2*Pkdd2*f**2*k1**2*s) - f*(40848*C*D1**2*Pk2*f*fd*r*s - 13616*C*D1**2*Pk2*f*fd*r + 76416*C*D1**2*Pk2*f*fd*s**2 - 64560*C*D1**2*Pk2*f*fd*s + 25472*C*D1**2*Pk2*f*fd - 29928*C*D1**2*Pk2*f*fdd*r*s + 9976*C*D1**2*Pk2*f*fdd*r - 69096*C*D1**2*Pk2*f*fdd*s**2 + 56040*C*D1**2*Pk2*f*fdd*s - 23032*C*D1**2*Pk2*f*fdd - 59856*C*D1**2*Pk2*fd**2*r*s + 19952*C*D1**2*Pk2*fd**2*r - 138192*C*D1**2*Pk2*fd**2*s**2 + 112080*C*D1**2*Pk2*fd**2*s - 9976*C*D1**2*Pk2*fd**2 + 54464*C*D1*Dd*Pk2*f**2*r*s - 13616*C*D1*Dd*Pk2*f**2*r + 101888*C*D1*Dd*Pk2*f**2*s**2 - 64560*C*D1*Dd*Pk2*f**2*s + 25472*C*D1*Dd*Pk2*f**2 - 239424*C*D1*Dd*Pk2*f*fd*r*s + 69832*C*D1*Dd*Pk2*f*fd*r - 552768*C*D1*Dd*Pk2*f*fd*s**2 + 392280*C*D1*Dd*Pk2*f*fd*s - 66016*C*D1*Dd*Pk2*f*fd - 39904*C*D1*Ddd*Pk2*f**2*r*s + 9976*C*D1*Ddd*Pk2*f**2*r - 92128*C*D1*Ddd*Pk2*f**2*s**2 + 56040*C*D1*Ddd*Pk2*f**2*s - 23032*C*D1*Ddd*Pk2*f**2 - 119712*C*Dd**2*Pk2*f**2*r*s + 29928*C*Dd**2*Pk2*f**2*r - 276384*C*Dd**2*Pk2*f**2*s**2 + 168120*C*Dd**2*Pk2*f**2*s - 9976*C*Dd**2*Pk2*f**2 - 5538*D1**2*Pk2*f*fd*r**2 - 55092*D1**2*Pk2*f*fd*r*s + 22056*D1**2*Pk2*f*fd*r - 43554*D1**2*Pk2*f*fd*s**2 + 47400*D1**2*Pk2*f*fd*s - 16364*D1**2*Pk2*f*fd + 3858*D1**2*Pk2*f*fdd*r**2 + 40812*D1**2*Pk2*f*fdd*r*s - 16176*D1**2*Pk2*f*fdd*r + 45834*D1**2*Pk2*f*fdd*s**2 - 44160*D1**2*Pk2*f*fdd*s + 16564*D1**2*Pk2*f*fdd + 7716*D1**2*Pk2*fd**2*r**2 + 81624*D1**2*Pk2*fd**2*r*s - 32352*D1**2*Pk2*fd**2*r + 91668*D1**2*Pk2*fd**2*s**2 - 88320*D1**2*Pk2*fd**2*s + 13604*D1**2*Pk2*fd**2 + 495*D1**2*Pkdd2*f*fd*k1**2*s**2 - 330*D1**2*Pkdd2*f*fd*k1**2*s + 165*D1**2*Pkdd2*f*fd*k1**2 + 132*D1**2*bd1**2*(Pk2*(4*C*(14*r*s - 7*r + 45*s**2 - 52*s + 7) - 108*r*s + 54*r - 227*s**2 + 281*s - 54) + 3*Pkdd2*k1**2*s*(s - 1)) - 33*D1**2*bdd1*f*(2*Pk2*(4*C*(r*(25*s + 14) + 66*s**2 + 37*s - 38) - 19*r**2 - 2*r*(51*s + 35) - 82*s**2 - 174*s + 173) - 5*Pkdd2*k1**2*(s - 1)**2) - 7384*D1*Dd*Pk2*f**2*r**2 - 73456*D1*Dd*Pk2*f**2*r*s + 22056*D1*Dd*Pk2*f**2*r - 58072*D1*Dd*Pk2*f**2*s**2 + 47400*D1*Dd*Pk2*f**2*s - 16364*D1*Dd*Pk2*f**2 + 30864*D1*Dd*Pk2*f*fd*r**2 + 326496*D1*Dd*Pk2*f*fd*r*s - 113232*D1*Dd*Pk2*f*fd*r + 366672*D1*Dd*Pk2*f*fd*s**2 - 309120*D1*Dd*Pk2*f*fd*s + 60336*D1*Dd*Pk2*f*fd + 660*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 330*D1*Dd*Pkdd2*f**2*k1**2*s + 165*D1*Dd*Pkdd2*f**2*k1**2 + 5144*D1*Ddd*Pk2*f**2*r**2 + 54416*D1*Ddd*Pk2*f**2*r*s - 16176*D1*Ddd*Pk2*f**2*r + 61112*D1*Ddd*Pk2*f**2*s**2 - 44160*D1*Ddd*Pk2*f**2*s + 16564*D1*Ddd*Pk2*f**2 + 66*D1*bd1*(D1*(Pk2*f*(4*C*(4*r*(6*s + 7) + 69*s**2 + 40*s - 46) - 19*r**2 - 2*r*(47*s + 77) - 26*s**2 - 182*s + 215) - 2*Pk2*fd*(C*(r*(200*s - 22) + 528*s**2 - 240*s + 50) - 38*r**2 + r*(35 - 204*s) - 164*s**2 + 46*s - 51) + Pkdd2*f*k1**2*(-2*s**2 + 10*s - 5) + 10*Pkdd2*fd*k1**2*s*(s - 1)) + Dd*f*(2*Pk2*(-2*C*(200*r*s + 31*r + 528*s**2 - 9*s - 51) + 76*r**2 + 408*r*s + 70*r + 328*s**2 + 215*s - 122) + 5*Pkdd2*k1**2*(4*s**2 - 5*s + 1))) + 15432*Dd**2*Pk2*f**2*r**2 + 163248*Dd**2*Pk2*f**2*r*s - 48528*Dd**2*Pk2*f**2*r + 183336*Dd**2*Pk2*f**2*s**2 - 132480*Dd**2*Pk2*f**2*s + 13604*Dd**2*Pk2*f**2))/(693*d**2*k2*k3**2) + D1**2*Pk1*ct**3*k2*st**2*(-198*D1**2*bd1**2*f*(Pk2*(4*C - 4)*(r*(2*s - 1) - s + 1) - Pkdd2*k1**2*s*(2*C - 3)*(s - 1)) - 33*D1*bd1*(2*D1*b1*(Pk2*f*(4*C - 4)*(r*(2*s - 1) - s) + Pk2*fd*(12*C - 12)*(r*(4*s - 1) - s) + Pkdd2*f*k1**2*(6*C - 9)*(2*s**2 - 2*s + 1) + 3*Pkdd2*fd*k1**2*s*(C*(2 - 4*s) + 6*s - 3)) + D1*f*(2*Pk2*f*(2*C*(5*r**2 + 22*r*s - 32*s + 5) - 10*r**2 - 28*r*s + 47*s**2 + 48*s - 10) - 4*Pk2*fd*(2*C*(2*r**2 + 4*r*(5*s - 1) - 13*s + 5) - 4*r**2 + r*(4 - 24*s) + 74*s**2 - 19*s - 6) - Pkdd2*f*k1**2*(2*C*(17*s**2 + 12*s - 6) + 15*s**2 - 36*s + 18) + 2*Pkdd2*fd*k1**2*s*(28*C*s - 8*C + 24*s - 21)) + 6*Dd*b1*f*(Pk2*(8*C - 8)*(r*(8*s - 3) - 3*s + 1) - Pkdd2*k1**2*(2*C - 3)*(8*s**2 - 6*s + 1)) + 2*Dd*f**2*(-2*Pk2*(2*C*(4*r**2 + r*(40*s + 2) - 37*s + 6) - 8*r**2 - 8*r*(6*s + 1) + 148*s**2 + 17*s - 8) + Pkdd2*k1**2*(4*s - 1)*(2*C*(7*s + 3) + 12*s - 9))) - 33*b1**2*(2*D1*Dd*(Pk2*f*(4*C - 4)*(r*(4*s - 1) - s) + Pk2*fd*(12*C - 12)*(r*(8*s - 1) - s) + Pkdd2*f*k1**2*(6*C - 9)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(9 - 6*C)*(4*s - 1)) + D1*(D1*s*(Pk2*fd*r*(8*C - 8) + Pkdd2*fd*k1**2*s*(12*C - 18) + 3*fdd*(Pk2*r*(8*C - 8) + Pkdd2*k1**2*s*(3 - 2*C))) - 3*Ddd*f*(Pk2*(8 - 8*C)*(4*r*s - r - s) + Pkdd2*k1**2*(2*C - 3)*(4*s**2 - 2*s + 1))) + 6*Dd**2*f*(Pk2*(4*C - 4)*(3*r*(4*s - 1) - 3*s + 1) + 3*Pkdd2*k1**2*s*(C*(2 - 4*s) + 6*s - 3))) - 33*b1*(D1**2*(f*(24*Pk2*bdd1*(C - 1)*(r*(2*s - 1) - s) - 2*Pk2*fdd*(12*C*s + r**2*(4*C - 4) + 8*r*(5*C*s - 4*C - 3*s + 3) + 74*s**2 - 86*s + 37) - 3*Pkdd2*bdd1*k1**2*(2*C - 3)*(2*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(4*C*(7*s**2 - 10*s + 5) + 24*s**2 - 6*s + 3) + fd*(2*Pk2*(20*C*s + r**2*(20*C - 20) + 8*r*(11*C*s - 8*C - 7*s + 6) + 94*s**2 - 114*s + 47) - Pkdd2*k1**2*(C*(68*s**2 - 92*s + 46) + 30*s**2 + 6*s - 3))) - 2*fd**2*(2*Pk2*(r**2*(2*C - 2) + 4*r*(5*C*s - 4*C - 3*s + 3) + s*(6*C + 37*s - 43)) + Pkdd2*k1**2*s*(C*(20 - 14*s) - 12*s + 3))) + D1*f*(Dd*(-4*Pk2*fd*(2*C*(8*r**2 + 80*r*s - 44*r + 2*s + 5) - 16*r**2 - 96*r*s + 64*r + 296*s**2 - 234*s + 31) + 2*Pkdd2*fd*k1**2*(4*s - 1)*(4*C*(7*s - 5) + 24*s - 3) + f*(2*Pk2*(2*C*(20*r**2 + 88*r*s - 32*r - 22*s + 5) - 40*r**2 - 112*r*s + 48*r + 188*s**2 - 66*s + 37) - Pkdd2*k1**2*(34*C + 15)*(4*s**2 - 2*s + 1))) + 2*Ddd*f*(Pk2*(C*(-8*r**2 - 80*r*s + 24*r + 20*s - 2) + 8*r**2 + 48*r*s - 16*r - 148*s**2 + 62*s - 35) + Pkdd2*k1**2*(7*C + 6)*(4*s**2 - 2*s + 1))) + 4*Dd**2*f**2*(-2*C*Pk2*(6*r**2 + 6*r*(10*s - 3) - 15*s + 5) + 3*Pk2*(4*r**2 + 8*r*(3*s - 1) - 74*s**2 + 31*s + 2) + Pkdd2*k1**2*s*(21*C + 18)*(2*s - 1))) + f*(33*D1**2*bdd1*f*(2*Pk2*(2*C*(r**2 + 2*r*(5*s + 2) - 16*s + 1) - 2*r**2 - 4*r*(3*s + 2) + 37*s**2 + 24*s - 2) - Pkdd2*k1**2*(2*C*(7*s**2 + 6*s - 3) + 12*s**2 - 18*s + 9)) + D1**2*(f*(2*Pk2*fd*(C*(6*r**2 + r*(2668 - 8016*s) + 2672*s + 2) + 96*r**2 + 4*r*(1485*s - 511) - 4173*s**2 + 802*s - 1359) + 2*Pk2*fdd*(2*C*(147*r**2 + r*(2400*s - 898) - 800*s + 49) - 246*r**2 + r*(956 - 2376*s) + 3423*s**2 - 1490*s + 1059) + Pkdd2*fd*k1**2*(1198*C - 147)*(3*s**2 - 2*s + 1) - Pkdd2*fdd*k1**2*(500*C + 75)*(3*s**2 - 2*s + 1)) - 2*fd**2*(Pk2*(-4*C*(147*r**2 + r*(2400*s - 898) - 800*s + 400) + 492*r**2 + 8*r*(594*s - 239) - 6846*s**2 + 2980*s + 792) + Pkdd2*k1**2*s*(500*C + 75)*(3*s - 2))) + D1*f*(Dd*(4*Pk2*fd*(2*C*(588*r**2 + 9600*r*s - 3143*r - 2800*s + 849) - 984*r**2 - 9504*r*s + 3346*r + 13692*s**2 - 5215*s + 267) + Pkdd2*fd*k1**2*(-1000*C - 150)*(12*s**2 - 7*s + 1) + f*(2*Pk2*(2*C*(4*r**2 - 5344*r*s + 1334*r + 1336*s + 1) + 128*r**2 + 7920*r*s - 2044*r - 5564*s**2 + 802*s - 1359) + Pkdd2*k1**2*(1198*C - 147)*(4*s**2 - 2*s + 1))) + Ddd*f*(2*Pk2*(2*C*(196*r**2 + 3200*r*s - 898*r - 800*s + 49) - 328*r**2 - 3168*r*s + 956*r + 4564*s**2 - 1490*s + 1059) + Pkdd2*k1**2*(-500*C - 75)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f**2*(4*C*Pk2*(294*r**2 + 3*r*(1600*s - 449) - 1200*s + 400) - 6*Pk2*(164*r**2 + 2*r*(792*s - 239) - 2282*s**2 + 745*s + 132) + Pkdd2*k1**2*s*(-1500*C - 225)*(2*s - 1))))/(693*d**2*k1*k3**2) - D1**2*Pk1*ct**3*k2*(33*b1**2*(D1**2*(Pk2*fd*r*(8*C - 8)*(19*r + 2*s) + Pk2*fdd*r*(8*C - 8)*(r - s) + Pkdd2*fd*k1**2*s**2*(23 - 76*C) + Pkdd2*fdd*k1**2*s**2*(24*C + 6)) + D1*(Dd*(Pk2*f*(8*C - 8)*(76*r**2 + 8*r*(s - 5) - 2*s + 19) + Pk2*fd*(8*C - 8)*(r - s)*(8*r - 1) - Pkdd2*f*k1**2*(76*C - 23)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(48*C + 12)*(4*s - 1)) + 2*Ddd*f*(Pk2*(4*C - 4)*(4*r**2 - r*(4*s + 1) + s + 1) + Pkdd2*k1**2*(12*C + 3)*(4*s**2 - 2*s + 1))) + 4*Dd**2*f*(Pk2*(2*C - 2)*(12*r**2 - 3*r*(4*s + 1) + 3*s - 1) + Pkdd2*k1**2*s*(36*C + 9)*(2*s - 1))) + 33*b1*(272*C*D1**2*Pk2*f*fd*r**2 + 128*C*D1**2*Pk2*f*fd*r*s - 368*C*D1**2*Pk2*f*fd*r - 64*C*D1**2*Pk2*f*fd*s + 184*C*D1**2*Pk2*f*fd + 32*C*D1**2*Pk2*f*fdd*r**2 - 80*C*D1**2*Pk2*f*fdd*r*s - 32*C*D1**2*Pk2*f*fdd*r + 40*C*D1**2*Pk2*f*fdd*s + 16*C*D1**2*Pk2*f*fdd + 32*C*D1**2*Pk2*fd**2*r**2 - 80*C*D1**2*Pk2*fd**2*r*s - 32*C*D1**2*Pk2*fd**2*r + 40*C*D1**2*Pk2*fd**2*s - 80*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 48*C*D1**2*Pkdd2*f*fd*k1**2*s + 24*C*D1**2*Pkdd2*f*fd*k1**2 + 40*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 40*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 544*C*D1*Dd*Pk2*f**2*r**2 + 256*C*D1*Dd*Pk2*f**2*r*s - 336*C*D1*Dd*Pk2*f**2*r - 64*C*D1*Dd*Pk2*f**2*s + 136*C*D1*Dd*Pk2*f**2 + 256*C*D1*Dd*Pk2*f*fd*r**2 - 640*C*D1*Dd*Pk2*f*fd*r*s - 112*C*D1*Dd*Pk2*f*fd*r + 240*C*D1*Dd*Pk2*f*fd*s - 8*C*D1*Dd*Pk2*f*fd - 160*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 80*C*D1*Dd*Pkdd2*f**2*k1**2*s - 40*C*D1*Dd*Pkdd2*f**2*k1**2 + 320*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 80*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 64*C*D1*Ddd*Pk2*f**2*r**2 - 160*C*D1*Ddd*Pk2*f**2*r*s + 8*C*D1*Ddd*Pk2*f**2*r + 40*C*D1*Ddd*Pk2*f**2*s + 16*C*D1*Ddd*Pk2*f**2 + 80*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 40*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 20*C*D1*Ddd*Pkdd2*f**2*k1**2 + 192*C*Dd**2*Pk2*f**2*r**2 - 480*C*Dd**2*Pk2*f**2*r*s + 24*C*Dd**2*Pk2*f**2*r + 120*C*Dd**2*Pk2*f**2*s - 40*C*Dd**2*Pk2*f**2 + 240*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 120*C*Dd**2*Pkdd2*f**2*k1**2*s - 344*D1**2*Pk2*f*fd*r**2 - 184*D1**2*Pk2*f*fd*r*s + 432*D1**2*Pk2*f*fd*r - 264*D1**2*Pk2*f*fd*s**2 + 328*D1**2*Pk2*f*fd*s - 334*D1**2*Pk2*f*fd - 40*D1**2*Pk2*f*fdd*r**2 + 120*D1**2*Pk2*f*fdd*r*s + 16*D1**2*Pk2*f*fdd*r + 264*D1**2*Pk2*f*fdd*s**2 - 304*D1**2*Pk2*f*fdd*s + 114*D1**2*Pk2*f*fdd - 40*D1**2*Pk2*fd**2*r**2 + 120*D1**2*Pk2*fd**2*r*s + 16*D1**2*Pk2*fd**2*r + 264*D1**2*Pk2*fd**2*s**2 - 304*D1**2*Pk2*fd**2*s + 52*D1**2*Pkdd2*f*fd*k1**2*s**2 - 12*D1**2*Pkdd2*f*fd*k1**2*s + 6*D1**2*Pkdd2*f*fd*k1**2 + 10*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 10*D1**2*Pkdd2*fd**2*k1**2*s**2 + 2*D1**2*bdd1*f*(Pk2*(4*C - 4)*(2*r**2 - r*(2*s + 1) + s + 1) + Pkdd2*k1**2*(12*C + 3)*(2*s**2 - 2*s + 1)) - 688*D1*Dd*Pk2*f**2*r**2 - 368*D1*Dd*Pk2*f**2*r*s + 436*D1*Dd*Pk2*f**2*r - 528*D1*Dd*Pk2*f**2*s**2 + 356*D1*Dd*Pk2*f**2*s - 304*D1*Dd*Pk2*f**2 - 320*D1*Dd*Pk2*f*fd*r**2 + 960*D1*Dd*Pk2*f*fd*r*s + 24*D1*Dd*Pk2*f*fd*r + 2112*D1*Dd*Pk2*f*fd*s**2 - 1864*D1*Dd*Pk2*f*fd*s + 288*D1*Dd*Pk2*f*fd + 104*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 52*D1*Dd*Pkdd2*f**2*k1**2*s + 26*D1*Dd*Pkdd2*f**2*k1**2 + 80*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 20*D1*Dd*Pkdd2*f*fd*k1**2*s - 80*D1*Ddd*Pk2*f**2*r**2 + 240*D1*Ddd*Pk2*f**2*r*s - 20*D1*Ddd*Pk2*f**2*r + 528*D1*Ddd*Pk2*f**2*s**2 - 324*D1*Ddd*Pk2*f**2*s + 112*D1*Ddd*Pk2*f**2 + 20*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 10*D1*Ddd*Pkdd2*f**2*k1**2*s + 5*D1*Ddd*Pkdd2*f**2*k1**2 + D1*bd1*(D1*(Pk2*f*(8*C - 8)*(38*r**2 + 4*r*(s - 10) - 2*s + 19) + Pk2*fd*(8*C - 8)*(r - s)*(4*r - 1) - Pkdd2*f*k1**2*(76*C - 23)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(48*C + 12)*(2*s - 1)) + 4*Dd*f*(Pk2*(4*C - 4)*(r - s)*(8*r - 3) + Pkdd2*k1**2*(12*C + 3)*(8*s**2 - 6*s + 1))) - 240*Dd**2*Pk2*f**2*r**2 + 720*Dd**2*Pk2*f**2*r*s - 60*Dd**2*Pk2*f**2*r + 1584*Dd**2*Pk2*f**2*s**2 - 972*Dd**2*Pk2*f**2*s + 60*Dd**2*Pk2*f**2 + 60*Dd**2*Pkdd2*f**2*k1**2*s**2 - 30*Dd**2*Pkdd2*f**2*k1**2*s) + f*(-9456*C*D1**2*Pk2*f*fd*r**2 - 3168*C*D1**2*Pk2*f*fd*r*s + 7360*C*D1**2*Pk2*f*fd*r + 1056*C*D1**2*Pk2*f*fd*s - 3152*C*D1**2*Pk2*f*fd - 24*C*D1**2*Pk2*f*fdd*r**2 + 3168*C*D1**2*Pk2*f*fdd*r*s - 1040*C*D1**2*Pk2*f*fdd*r - 1056*C*D1**2*Pk2*f*fdd*s - 8*C*D1**2*Pk2*f*fdd - 48*C*D1**2*Pk2*fd**2*r**2 + 6336*C*D1**2*Pk2*fd**2*r*s - 2080*C*D1**2*Pk2*fd**2*r - 2112*C*D1**2*Pk2*fd**2*s + 1056*C*D1**2*Pk2*fd**2 + 1980*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 1320*C*D1**2*Pkdd2*f*fd*k1**2*s + 660*C*D1**2*Pkdd2*f*fd*k1**2 - 12608*C*D1*Dd*Pk2*f**2*r**2 - 4224*C*D1*Dd*Pk2*f**2*r*s + 7360*C*D1*Dd*Pk2*f**2*r + 1056*C*D1*Dd*Pk2*f**2*s - 3152*C*D1*Dd*Pk2*f**2 - 192*C*D1*Dd*Pk2*f*fd*r**2 + 25344*C*D1*Dd*Pk2*f*fd*r*s - 7280*C*D1*Dd*Pk2*f*fd*r - 7392*C*D1*Dd*Pk2*f*fd*s + 2096*C*D1*Dd*Pk2*f*fd + 2640*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 1320*C*D1*Dd*Pkdd2*f**2*k1**2*s + 660*C*D1*Dd*Pkdd2*f**2*k1**2 - 32*C*D1*Ddd*Pk2*f**2*r**2 + 4224*C*D1*Ddd*Pk2*f**2*r*s - 1040*C*D1*Ddd*Pk2*f**2*r - 1056*C*D1*Ddd*Pk2*f**2*s - 8*C*D1*Ddd*Pk2*f**2 - 96*C*Dd**2*Pk2*f**2*r**2 + 12672*C*Dd**2*Pk2*f**2*r*s - 3120*C*Dd**2*Pk2*f**2*r - 3168*C*Dd**2*Pk2*f**2*s + 1056*C*Dd**2*Pk2*f**2 + 1212*D1**2*Pk2*f*fd*r**2 - 5964*D1**2*Pk2*f*fd*r*s + 1180*D1**2*Pk2*f*fd*r - 11088*D1**2*Pk2*f*fd*s**2 + 9380*D1**2*Pk2*f*fd*s - 3292*D1**2*Pk2*f*fd - 12*D1**2*Pk2*f*fdd*r**2 + 4764*D1**2*Pk2*f*fdd*r*s - 1580*D1**2*Pk2*f*fdd*r + 11088*D1**2*Pk2*f*fdd*s**2 - 8980*D1**2*Pk2*f*fdd*s + 3692*D1**2*Pk2*f*fdd - 24*D1**2*Pk2*fd**2*r**2 + 9528*D1**2*Pk2*fd**2*r*s - 3160*D1**2*Pk2*fd**2*r + 22176*D1**2*Pk2*fd**2*s**2 - 17960*D1**2*Pk2*fd**2*s + 1588*D1**2*Pk2*fd**2 + 495*D1**2*Pkdd2*f*fd*k1**2*s**2 - 330*D1**2*Pkdd2*f*fd*k1**2*s + 165*D1**2*Pkdd2*f*fd*k1**2 + 132*D1**2*bd1**2*(Pk2*(2*C - 2)*(2*r**2 - r*(2*s + 1) + s - 1) + Pkdd2*k1**2*s*(12*C + 3)*(s - 1)) + 33*D1**2*bdd1*f*(2*Pk2*(-20*C*r*(s - 1) + r**2*(8*C - 10) + 6*r*(5*s - 3) + 66*s**2 - 10*s - 1) + Pkdd2*k1**2*(20*C + 5)*(s - 1)**2) + 1616*D1*Dd*Pk2*f**2*r**2 - 7952*D1*Dd*Pk2*f**2*r*s + 1180*D1*Dd*Pk2*f**2*r - 14784*D1*Dd*Pk2*f**2*s**2 + 9380*D1*Dd*Pk2*f**2*s - 3292*D1*Dd*Pk2*f**2 - 96*D1*Dd*Pk2*f*fd*r**2 + 38112*D1*Dd*Pk2*f*fd*r*s - 11060*D1*Dd*Pk2*f*fd*r + 88704*D1*Dd*Pk2*f*fd*s**2 - 62860*D1*Dd*Pk2*f*fd*s + 10560*D1*Dd*Pk2*f*fd + 660*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 330*D1*Dd*Pkdd2*f**2*k1**2*s + 165*D1*Dd*Pkdd2*f**2*k1**2 - 16*D1*Ddd*Pk2*f**2*r**2 + 6352*D1*Ddd*Pk2*f**2*r*s - 1580*D1*Ddd*Pk2*f**2*r + 14784*D1*Ddd*Pk2*f**2*s**2 - 8980*D1*Ddd*Pk2*f**2*s + 3692*D1*Ddd*Pk2*f**2 + 66*D1*bd1*(D1*(Pk2*f*(4*C*(17*r**2 + 8*r*s + 4*r - 6) - 86*r**2 - 46*r*s + 2*r - 66*s**2 + 14*s + 15) + 2*Pk2*fd*(2*C*(8*r**2 - 20*r*s + 6*r + 5*s - 5) - 20*r**2 + 60*r*s - 14*r + 132*s**2 - 86*s + 15) + Pkdd2*f*k1**2*(-4*C*(5*s**2 - 16*s + 8) + 13*s**2 - 20*s + 10) + Pkdd2*fd*k1**2*s*(40*C + 10)*(s - 1)) + Dd*f*(2*Pk2*(2*C*(16*r**2 - 40*r*s + 21*r + 5*s - 5) - 40*r**2 + 120*r*s - 41*r + 264*s**2 - 101*s + 14) + Pkdd2*k1**2*(20*C + 5)*(4*s**2 - 5*s + 1))) - 48*Dd**2*Pk2*f**2*r**2 + 19056*Dd**2*Pk2*f**2*r*s - 4740*Dd**2*Pk2*f**2*r + 44352*Dd**2*Pk2*f**2*s**2 - 26940*Dd**2*Pk2*f**2*s + 1588*Dd**2*Pk2*f**2))/(693*d**2*k1*k3**2) + D1**2*Pk1*ct**3*st**2*(-10296*D1**2*K*Pk2*bdd1*f**2*r*s + 24960*D1**2*Pk2*bdd1*f**3*r*s + 68380*D1**2*Pk2*bdd1*f**3*s**2 + 9360*D1**2*Pk2*bdd1*f**3*s - 13000*D1**2*Pk2*bdd1*f**3 + 10296*D1**2*Pk2*bdd1*f**2*r*s - 10296*D1**2*Pk2*bdd1*f**2*s**2 + 20592*D1**2*Pk2*bdd1*f*g2*r*s - 20592*D1**2*Pk2*bdd1*f*g2*s - 38400*D1**2*Pk2*f**3*fd*r*s + 9600*D1**2*Pk2*f**3*fd*r - 390000*D1**2*Pk2*f**3*fd*s**2 + 204600*D1**2*Pk2*f**3*fd*s - 97500*D1**2*Pk2*f**3*fd + 102400*D1**2*Pk2*f**3*fdd*r*s - 25600*D1**2*Pk2*f**3*fdd*r + 286000*D1**2*Pk2*f**3*fdd*s**2 - 168600*D1**2*Pk2*f**3*fdd*s + 71500*D1**2*Pk2*f**3*fdd + 307200*D1**2*Pk2*f**2*fd**2*r*s - 76800*D1**2*Pk2*f**2*fd**2*r + 858000*D1**2*Pk2*f**2*fd**2*s**2 - 505800*D1**2*Pk2*f**2*fd**2*s + 25600*D1**2*Pk2*f**2*fd**2 - 34320*D1**2*Pk2*f**2*gd2*r*s + 20592*D1**2*Pk2*f**2*gdd2*r*s - 68640*D1**2*Pk2*f*fd*g2*r*s + 34320*D1**2*Pk2*f*fd*g2*r + 34320*D1**2*Pk2*f*fd*g2*s + 82368*D1**2*Pk2*f*fd*gd2*r*s - 20592*D1**2*Pk2*f*fd*gd2*r - 20592*D1**2*Pk2*f*fd*gd2*s + 41184*D1**2*Pk2*f*fdd*g2*r*s - 20592*D1**2*Pk2*f*fdd*g2*r - 20592*D1**2*Pk2*f*fdd*g2*s + 41184*D1**2*Pk2*fd**2*g2*r*s - 20592*D1**2*Pk2*fd**2*g2*r - 20592*D1**2*Pk2*fd**2*g2*s + 20592*D1**2*Pk2*fd**2*g2 - 3250*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 1287*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 9800*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 4900*D1**2*Pkdd2*f**3*fd*k1**2*s + 2450*D1**2*Pkdd2*f**3*fd*k1**2 - 4900*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 2450*D1**2*Pkdd2*f**3*fdd*k1**2*s - 1225*D1**2*Pkdd2*f**3*fdd*k1**2 - 14700*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 7350*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 858*D1**2*bd1**2*f*s*(4*Pk2*(6*K*r - 3*K + 10*f*(2*s - 1) - 6*r + 6*s + 3) + Pkdd2*k1**2*s*(5*f + 3)) - 38400*D1*Dd*Pk2*f**4*r*s + 9600*D1*Dd*Pk2*f**4*r - 390000*D1*Dd*Pk2*f**4*s**2 + 204600*D1*Dd*Pk2*f**4*s - 97500*D1*Dd*Pk2*f**4 + 819200*D1*Dd*Pk2*f**3*fd*r*s - 204800*D1*Dd*Pk2*f**3*fd*r + 2288000*D1*Dd*Pk2*f**3*fd*s**2 - 1348800*D1*Dd*Pk2*f**3*fd*s + 194200*D1*Dd*Pk2*f**3*fd - 137280*D1*Dd*Pk2*f**2*g2*r*s + 34320*D1*Dd*Pk2*f**2*g2*r + 34320*D1*Dd*Pk2*f**2*g2*s + 164736*D1*Dd*Pk2*f**2*gd2*r*s - 20592*D1*Dd*Pk2*f**2*gd2*r - 20592*D1*Dd*Pk2*f**2*gd2*s + 329472*D1*Dd*Pk2*f*fd*g2*r*s - 123552*D1*Dd*Pk2*f*fd*g2*r - 123552*D1*Dd*Pk2*f*fd*g2*s + 41184*D1*Dd*Pk2*f*fd*g2 + 9800*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 4900*D1*Dd*Pkdd2*f**4*k1**2*s + 2450*D1*Dd*Pkdd2*f**4*k1**2 - 39200*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 19600*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 2450*D1*Dd*Pkdd2*f**3*fd*k1**2 + 102400*D1*Ddd*Pk2*f**4*r*s - 25600*D1*Ddd*Pk2*f**4*r + 286000*D1*Ddd*Pk2*f**4*s**2 - 168600*D1*Ddd*Pk2*f**4*s + 71500*D1*Ddd*Pk2*f**4 + 82368*D1*Ddd*Pk2*f**2*g2*r*s - 20592*D1*Ddd*Pk2*f**2*g2*r - 20592*D1*Ddd*Pk2*f**2*g2*s - 4900*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 2450*D1*Ddd*Pkdd2*f**4*k1**2*s - 1225*D1*Ddd*Pkdd2*f**4*k1**2 - 26*D1*bd1*(D1*(-792*Pk2*fd*g2*(r*(2*s - 1) - s + 1) + 2*f**3*(Pk2*(1475*s**2 + s*(168*r + 888) - 500) - 125*Pkdd2*k1**2*s**2) - f**2*(10*fd*(2*Pk2*(48*r*(6*s - 1) + 789*s**2 - 275*s + 32) + 25*Pkdd2*k1**2*s*(1 - 3*s)) + 33*s*(4*Pk2*(r*(5*K - 5) + 6*s) + 3*Pkdd2*k1**2*s)) + 33*f*(8*Pk2*s*(-g2*r + g2 - 6*gd2*r + 3*gd2) + 3*fd*(4*Pk2*(r*(K - 1)*(4*s - 1) + s*(-K + 4*s - 1)) + Pkdd2*k1**2*s*(2*s - 1)))) + Dd*f*(-792*Pk2*g2*(r*(8*s - 1) - 5*s + 1) - 10*f**2*(Pk2*(96*r*(8*s - 1) + 2104*s**2 - 478*s - 36) + 25*Pkdd2*k1**2*s*(1 - 4*s)) + 99*f*(4*Pk2*(r*(K - 1)*(8*s - 1) + s*(-K + 8*s - 1)) + Pkdd2*k1**2*s*(4*s - 1)))) + 307200*Dd**2*Pk2*f**4*r*s - 76800*Dd**2*Pk2*f**4*r + 858000*Dd**2*Pk2*f**4*s**2 - 505800*Dd**2*Pk2*f**4*s + 25600*Dd**2*Pk2*f**4 + 247104*Dd**2*Pk2*f**2*g2*r*s - 61776*Dd**2*Pk2*f**2*g2*r - 61776*Dd**2*Pk2*f**2*g2*s + 20592*Dd**2*Pk2*f**2*g2 - 14700*Dd**2*Pkdd2*f**4*k1**2*s**2 + 7350*Dd**2*Pkdd2*f**4*k1**2*s + 429*b1**2*(D1**2*(-10*fd**2*s*(8*Pk2*(2*s - 1) + Pkdd2*k1**2*(s - 1)) + 2*fd*(40*Pk2*f*(4*s**2 - 2*s + 1) - 4*Pk2*(s - 1)*(r*(K - 1) - 6*s + 6) + Pkdd2*k1**2*(5*f*(2*s**2 - 2*s + 1) + 3*(s - 1)**2)) - fdd*(8*Pk2*(5*f*(4*s**2 - 2*s + 1) + (3*s - 3)*(r*(K - 1) + s - 1)) + Pkdd2*k1**2*(5*f*(2*s**2 - 2*s + 1) + 3*(s - 1)**2))) + D1*(2*Dd*(5*f**2*(16*Pk2 + Pkdd2*k1**2)*(4*s**2 - 2*s + 1) + f*(-4*Pk2*(-K*s + 10*fd*(1 - 4*s)**2 + r*(K - 1)*(4*s - 1) - 24*s**2 + 13*s - 6) + Pkdd2*k1**2*(-5*fd*(8*s**2 - 6*s + 1) + 12*s**2 - 6*s + 3)) - 3*fd*(4*Pk2*(K*r*(8*s - 5) - K*s + K + r*(5 - 8*s) + 8*s**2 - 9*s + 1) + Pkdd2*k1**2*(4*s**2 - 5*s + 1))) - Ddd*f*(8*Pk2*(-3*K*s + 10*f*(4*s**2 - 2*s + 1) + r*(3*K - 3)*(4*s - 1) + 12*s**2 - 3*s + 3) + Pkdd2*k1**2*(5*f + 3)*(4*s**2 - 2*s + 1))) - 6*Dd**2*f*(4*Pk2*(3*K*r*(4*s - 1) - 3*K*s + K + 40*f*s**2 - 20*f*s + r*(3 - 12*s) + 12*s**2 - 3*s - 1) + Pkdd2*k1**2*s*(5*f + 3)*(2*s - 1))) + 13*b1*(2640*D1**2*K*Pk2*f*fd*r*s - 1320*D1**2*K*Pk2*f*fd*r - 1320*D1**2*K*Pk2*f*fd*s - 1584*D1**2*K*Pk2*f*fdd*r*s + 792*D1**2*K*Pk2*f*fdd*r + 792*D1**2*K*Pk2*f*fdd*s - 1584*D1**2*K*Pk2*fd**2*r*s + 792*D1**2*K*Pk2*fd**2*r + 792*D1**2*K*Pk2*fd**2*s - 792*D1**2*K*Pk2*fd**2 - 2016*D1**2*Pk2*f**2*fd*r*s + 672*D1**2*Pk2*f**2*fd*r - 17700*D1**2*Pk2*f**2*fd*s**2 + 16024*D1**2*Pk2*f**2*fd*s - 7900*D1**2*Pk2*f**2*fd + 5760*D1**2*Pk2*f**2*fdd*r*s - 1920*D1**2*Pk2*f**2*fdd*r + 15780*D1**2*Pk2*f**2*fdd*s**2 - 13160*D1**2*Pk2*f**2*fdd*s + 6260*D1**2*Pk2*f**2*fdd + 11520*D1**2*Pk2*f*fd**2*r*s - 3840*D1**2*Pk2*f*fd**2*r + 31560*D1**2*Pk2*f*fd**2*s**2 - 26320*D1**2*Pk2*f*fd**2*s + 640*D1**2*Pk2*f*fd**2 - 2640*D1**2*Pk2*f*fd*r*s + 1320*D1**2*Pk2*f*fd*r + 3168*D1**2*Pk2*f*fd*s**2 - 1848*D1**2*Pk2*f*fd*s + 1584*D1**2*Pk2*f*fd + 1584*D1**2*Pk2*f*fdd*r*s - 792*D1**2*Pk2*f*fdd*r - 1584*D1**2*Pk2*f*fdd*s**2 + 792*D1**2*Pk2*f*fdd*s - 792*D1**2*Pk2*f*fdd + 528*D1**2*Pk2*f*gd2*r*s + 1584*D1**2*Pk2*f*gdd2*r*s + 1584*D1**2*Pk2*fd**2*r*s - 792*D1**2*Pk2*fd**2*r - 1584*D1**2*Pk2*fd**2*s**2 + 792*D1**2*Pk2*fd**2*s + 792*D1**2*Pk2*fd**2 + 528*D1**2*Pk2*fd*g2*r*s - 528*D1**2*Pk2*fd*g2*r + 3168*D1**2*Pk2*fd*gd2*r*s - 1584*D1**2*Pk2*fd*gd2*r + 1584*D1**2*Pk2*fdd*g2*r*s - 1584*D1**2*Pk2*fdd*g2*r + 1500*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 1000*D1**2*Pkdd2*f**2*fd*k1**2*s + 500*D1**2*Pkdd2*f**2*fd*k1**2 - 750*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 500*D1**2*Pkdd2*f**2*fdd*k1**2*s - 250*D1**2*Pkdd2*f**2*fdd*k1**2 - 1500*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 1000*D1**2*Pkdd2*f*fd**2*k1**2*s + 396*D1**2*Pkdd2*f*fd*k1**2*s**2 - 396*D1**2*Pkdd2*f*fd*k1**2*s + 198*D1**2*Pkdd2*f*fd*k1**2 - 198*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 198*D1**2*Pkdd2*f*fdd*k1**2*s - 99*D1**2*Pkdd2*f*fdd*k1**2 - 198*D1**2*Pkdd2*fd**2*k1**2*s**2 + 198*D1**2*Pkdd2*fd**2*k1**2*s - 66*D1**2*bdd1*f*(5*f*(4*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2) + 3*s*(Pk2*(8*K*r - 4*K - 8*r + 8*s + 4) + Pkdd2*k1**2*s)) + 5280*D1*Dd*K*Pk2*f**2*r*s - 1320*D1*Dd*K*Pk2*f**2*r - 1320*D1*Dd*K*Pk2*f**2*s - 12672*D1*Dd*K*Pk2*f*fd*r*s + 4752*D1*Dd*K*Pk2*f*fd*r + 4752*D1*Dd*K*Pk2*f*fd*s - 1584*D1*Dd*K*Pk2*f*fd - 2688*D1*Dd*Pk2*f**3*r*s + 672*D1*Dd*Pk2*f**3*r - 23600*D1*Dd*Pk2*f**3*s**2 + 12472*D1*Dd*Pk2*f**3*s - 5900*D1*Dd*Pk2*f**3 + 46080*D1*Dd*Pk2*f**2*fd*r*s - 13440*D1*Dd*Pk2*f**2*fd*r + 126240*D1*Dd*Pk2*f**2*fd*s**2 - 89960*D1*Dd*Pk2*f**2*fd*s + 15080*D1*Dd*Pk2*f**2*fd - 5280*D1*Dd*Pk2*f**2*r*s + 1320*D1*Dd*Pk2*f**2*r + 6336*D1*Dd*Pk2*f**2*s**2 - 1848*D1*Dd*Pk2*f**2*s + 1584*D1*Dd*Pk2*f**2 + 12672*D1*Dd*Pk2*f*fd*r*s - 4752*D1*Dd*Pk2*f*fd*r - 12672*D1*Dd*Pk2*f*fd*s**2 + 4752*D1*Dd*Pk2*f*fd*s + 2112*D1*Dd*Pk2*f*g2*r*s - 528*D1*Dd*Pk2*f*g2*r - 528*D1*Dd*Pk2*f*g2*s + 12672*D1*Dd*Pk2*f*gd2*r*s - 1584*D1*Dd*Pk2*f*gd2*r - 1584*D1*Dd*Pk2*f*gd2*s + 12672*D1*Dd*Pk2*fd*g2*r*s - 7920*D1*Dd*Pk2*fd*g2*r - 1584*D1*Dd*Pk2*fd*g2*s + 1584*D1*Dd*Pk2*fd*g2 + 2000*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 1000*D1*Dd*Pkdd2*f**3*k1**2*s + 500*D1*Dd*Pkdd2*f**3*k1**2 - 6000*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 3500*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 500*D1*Dd*Pkdd2*f**2*fd*k1**2 + 792*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 396*D1*Dd*Pkdd2*f**2*k1**2*s + 198*D1*Dd*Pkdd2*f**2*k1**2 - 1584*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 1188*D1*Dd*Pkdd2*f*fd*k1**2*s - 198*D1*Dd*Pkdd2*f*fd*k1**2 - 3168*D1*Ddd*K*Pk2*f**2*r*s + 792*D1*Ddd*K*Pk2*f**2*r + 792*D1*Ddd*K*Pk2*f**2*s + 7680*D1*Ddd*Pk2*f**3*r*s - 1920*D1*Ddd*Pk2*f**3*r + 21040*D1*Ddd*Pk2*f**3*s**2 - 12440*D1*Ddd*Pk2*f**3*s + 5260*D1*Ddd*Pk2*f**3 + 3168*D1*Ddd*Pk2*f**2*r*s - 792*D1*Ddd*Pk2*f**2*r - 3168*D1*Ddd*Pk2*f**2*s**2 + 792*D1*Ddd*Pk2*f**2*s - 792*D1*Ddd*Pk2*f**2 + 6336*D1*Ddd*Pk2*f*g2*r*s - 1584*D1*Ddd*Pk2*f*g2*r - 1584*D1*Ddd*Pk2*f*g2*s - 1000*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 500*D1*Ddd*Pkdd2*f**3*k1**2*s - 250*D1*Ddd*Pkdd2*f**3*k1**2 - 396*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 198*D1*Ddd*Pkdd2*f**2*k1**2*s - 99*D1*Ddd*Pkdd2*f**2*k1**2 + 132*D1*bd1*(D1*(5*f**2*(4*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2) + f*s*(2*Pk2*(-2*K*r + K + fd*(40 - 80*s) + 2*r + 12*s - 1) + Pkdd2*k1**2*(fd*(5 - 10*s) + 3*s)) - 3*fd*(2*Pk2*(K*r*(4*s - 2) - K*s + K + r*(2 - 4*s) + 4*s**2 - 3*s - 1) + Pkdd2*k1**2*s*(s - 1))) - Dd*f*(2*Pk2*(3*K*(2*r*(8*s - 1) - 6*s + 1) + 10*f*(1 - 4*s)**2 - 48*r*s + 6*r + 48*s**2 + 6*s - 3) + Pkdd2*k1**2*s*(5*f + 3)*(4*s - 1))) - 9504*Dd**2*K*Pk2*f**2*r*s + 2376*Dd**2*K*Pk2*f**2*r + 2376*Dd**2*K*Pk2*f**2*s - 792*Dd**2*K*Pk2*f**2 + 23040*Dd**2*Pk2*f**3*r*s - 5760*Dd**2*Pk2*f**3*r + 63120*Dd**2*Pk2*f**3*s**2 - 37320*Dd**2*Pk2*f**3*s + 1920*Dd**2*Pk2*f**3 + 9504*Dd**2*Pk2*f**2*r*s - 2376*Dd**2*Pk2*f**2*r - 9504*Dd**2*Pk2*f**2*s**2 + 2376*Dd**2*Pk2*f**2*s + 792*Dd**2*Pk2*f**2 + 19008*Dd**2*Pk2*f*g2*r*s - 4752*Dd**2*Pk2*f*g2*r - 4752*Dd**2*Pk2*f*g2*s + 1584*Dd**2*Pk2*f*g2 - 3000*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1500*Dd**2*Pkdd2*f**3*k1**2*s - 1188*Dd**2*Pkdd2*f**2*k1**2*s**2 + 594*Dd**2*Pkdd2*f**2*k1**2*s))/(9009*d**2*k1*k2) + D1**2*Pk1*ct**3*(12012*D1**2*K*Pk2*bdd1*f**2*r*s - 6864*D1**2*Pk2*bd2*f**2*r*s + 13728*D1**2*Pk2*bd2*f*fd*r*s - 3432*D1**2*Pk2*bd2*f*fd*r - 3432*D1**2*Pk2*bd2*f*fd*s + 52*D1**2*Pk2*bdd1*f**3*r**2 - 4992*D1**2*Pk2*bdd1*f**3*r*s - 10452*D1**2*Pk2*bdd1*f**3*r + 8580*D1**2*Pk2*bdd1*f**3*s**2 - 46332*D1**2*Pk2*bdd1*f**3*s + 30056*D1**2*Pk2*bdd1*f**3 + 858*D1**2*Pk2*bdd1*f**2*r**2 - 5148*D1**2*Pk2*bdd1*f**2*r*s + 34320*D1**2*Pk2*bdd1*f**2*s**2 + 3432*D1**2*Pk2*bdd1*f*g2*r*s - 6864*D1**2*Pk2*bdd1*f*g2*r + 3432*D1**2*Pk2*bdd1*f*g2*s + 3432*D1**2*Pk2*bdd2*f**2*r*s + 37200*D1**2*Pk2*f**3*fd*r**2 + 83200*D1**2*Pk2*f**3*fd*r*s - 39400*D1**2*Pk2*f**3*fd*r + 171600*D1**2*Pk2*f**3*fd*s**2 - 106600*D1**2*Pk2*f**3*fd*s + 52200*D1**2*Pk2*f**3*fd - 2480*D1**2*Pk2*f**3*fdd*r**2 - 83200*D1**2*Pk2*f**3*fdd*r*s + 22040*D1**2*Pk2*f**3*fdd*r - 171600*D1**2*Pk2*f**3*fdd*s**2 + 106600*D1**2*Pk2*f**3*fdd*s - 43520*D1**2*Pk2*f**3*fdd - 7440*D1**2*Pk2*f**2*fd**2*r**2 - 249600*D1**2*Pk2*f**2*fd**2*r*s + 66120*D1**2*Pk2*f**2*fd**2*r - 514800*D1**2*Pk2*f**2*fd**2*s**2 + 319800*D1**2*Pk2*f**2*fd**2*s - 20800*D1**2*Pk2*f**2*fd**2 + 82368*D1**2*Pk2*f**2*gd2*r*s - 24024*D1**2*Pk2*f**2*gdd2*r*s + 164736*D1**2*Pk2*f*fd*g2*r*s - 82368*D1**2*Pk2*f*fd*g2*r - 82368*D1**2*Pk2*f*fd*g2*s - 96096*D1**2*Pk2*f*fd*gd2*r*s + 24024*D1**2*Pk2*f*fd*gd2*r + 24024*D1**2*Pk2*f*fd*gd2*s - 48048*D1**2*Pk2*f*fdd*g2*r*s + 24024*D1**2*Pk2*f*fdd*g2*r + 24024*D1**2*Pk2*f*fdd*g2*s - 48048*D1**2*Pk2*fd**2*g2*r*s + 24024*D1**2*Pk2*fd**2*g2*r + 24024*D1**2*Pk2*fd**2*g2*s - 24024*D1**2*Pk2*fd**2*g2 - 1820*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 3640*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 1820*D1**2*Pkdd2*bdd1*f**3*k1**2 - 7280*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 3640*D1**2*Pkdd2*f**3*fd*k1**2*s - 1820*D1**2*Pkdd2*f**3*fd*k1**2 + 1716*D1**2*bd1**2*f*(2*Pk2*f*(r*(8*s - 3) + 42*s**2 - 24*s + 2) + 2*Pk2*r*(-K*s + K + s - 1) + Pk2*s*(-K + 47*s + 1) - 5*Pkdd2*f*k1**2*s*(s - 1) - 3*Pkdd2*k1**2*s*(s - 1)) + 27456*D1*Dd*Pk2*bd2*f**2*r*s - 3432*D1*Dd*Pk2*bd2*f**2*r - 3432*D1*Dd*Pk2*bd2*f**2*s + 37200*D1*Dd*Pk2*f**4*r**2 + 83200*D1*Dd*Pk2*f**4*r*s - 39400*D1*Dd*Pk2*f**4*r + 171600*D1*Dd*Pk2*f**4*s**2 - 106600*D1*Dd*Pk2*f**4*s + 52200*D1*Dd*Pk2*f**4 - 19840*D1*Dd*Pk2*f**3*fd*r**2 - 665600*D1*Dd*Pk2*f**3*fd*r*s + 176320*D1*Dd*Pk2*f**3*fd*r - 1372800*D1*Dd*Pk2*f**3*fd*s**2 + 852800*D1*Dd*Pk2*f**3*fd*s - 128640*D1*Dd*Pk2*f**3*fd + 329472*D1*Dd*Pk2*f**2*g2*r*s - 82368*D1*Dd*Pk2*f**2*g2*r - 82368*D1*Dd*Pk2*f**2*g2*s - 192192*D1*Dd*Pk2*f**2*gd2*r*s + 24024*D1*Dd*Pk2*f**2*gd2*r + 24024*D1*Dd*Pk2*f**2*gd2*s - 384384*D1*Dd*Pk2*f*fd*g2*r*s + 144144*D1*Dd*Pk2*f*fd*g2*r + 144144*D1*Dd*Pk2*f*fd*g2*s - 48048*D1*Dd*Pk2*f*fd*g2 - 7280*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 3640*D1*Dd*Pkdd2*f**4*k1**2*s - 1820*D1*Dd*Pkdd2*f**4*k1**2 - 2480*D1*Ddd*Pk2*f**4*r**2 - 83200*D1*Ddd*Pk2*f**4*r*s + 22040*D1*Ddd*Pk2*f**4*r - 171600*D1*Ddd*Pk2*f**4*s**2 + 106600*D1*Ddd*Pk2*f**4*s - 43520*D1*Ddd*Pk2*f**4 - 96096*D1*Ddd*Pk2*f**2*g2*r*s + 24024*D1*Ddd*Pk2*f**2*g2*r + 24024*D1*Ddd*Pk2*f**2*g2*s + 26*D1*bd1*(D1*(66*Pk2*f*(fd*(2*r**2 + r*(28*K*s - 7*K - 12*s + 2) + s*(-7*K + 80*s - 37)) - 4*g2*(r*(s - 9) + 8*s) + 2*gd2*(2*r*(s - 1) + s)) + 132*Pk2*fd*g2*(r*(2*s - 1) - s + 1) + f**3*(2*Pk2*(229*r**2 - 3*r*(68*s - 57) - 495*s**2 + 1221*s - 628) - 5*Pkdd2*k1**2*(5*s**2 + 56*s - 28)) + f**2*(4*Pk2*fd*(3*r**2 - 2*r*(144*s + 77) + 495*s**2 - 1008*s - 32) + 33*Pk2*(9*r**2 + r*s*(32 - 48*K) - 50*s**2) - 420*Pkdd2*fd*k1**2*s*(s - 1) - 99*Pkdd2*k1**2*s**2)) + 2*Dd*f*(33*Pk2*f*(4*r**2 + r*(56*K*s - 7*K - 24*s + 2) + s*(-7*K + 160*s - 37)) + 66*Pk2*g2*(r*(8*s - 9) + 3*s + 1) + 2*f**2*(Pk2*(4*r**2 - 384*r*s - 355*r + 660*s**2 - 1899*s + 546) - 35*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 7440*Dd**2*Pk2*f**4*r**2 - 249600*Dd**2*Pk2*f**4*r*s + 66120*Dd**2*Pk2*f**4*r - 514800*Dd**2*Pk2*f**4*s**2 + 319800*Dd**2*Pk2*f**4*s - 20800*Dd**2*Pk2*f**4 - 288288*Dd**2*Pk2*f**2*g2*r*s + 72072*Dd**2*Pk2*f**2*g2*r + 72072*Dd**2*Pk2*f**2*g2*s - 24024*Dd**2*Pk2*f**2*g2 + 3432*Pk2*b2*(2*D1*Dd*f*(f*(-4*r*s + r + s) + fd*r*(8*s - 3) - 3*fd*s + fd) + D1*(D1*(2*f*fd*(-2*r*s + r + s) + f*fdd*(2*r*s - r - s) + fd**2*(2*r*s - r - s + 1)) + Ddd*f**2*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 429*Pkdd2*b1**3*k1**2*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(6*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 28) + s*(6*fd - 14) + 7) - D1*Ddd*(6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(6*f + 7)*(2*s - 1)) - 429*b1**2*(D1**2*(-2*Pk2*fdd*(4*K*s + 2*f*(2*r*(8*s - 1) + 84*s**2 - 44*s + 21) - r*(2*K - 2)*(s + 1) + 47*s**2 - 98*s + 47) + Pkdd2*fdd*k1**2*s**2*(20*f + 6) - Pkdd2*k1**2*(2*bd1 - bdd1)*(6*f + 7)*(3*s**2 - 2*s + 1) + 4*fd**2*(2*Pk2*(-8*r*s + r + s*(22 - 42*s)) + 5*Pkdd2*k1**2*s**2) + fd*(2*Pk2*(36*K*s + 2*f*(4*r*(8*s - 1) + 108*s**2 - 58*s + 27) - r*(4*K - 4)*(s + 8) + 59*s**2 - 154*s + 59) - Pkdd2*k1**2*(2*f*(14*s**2 + 6*s - 3) + s**2*(5 - 36*bd1) + s*(12*bd1 + 14) - 7))) + D1*(Dd*(8*Pk2*f**2*(8*r*(4*s - 1) + 108*s**2 - 62*s + 27) - 2*Pk2*f*(-4*K*s + 4*fd*(4*r*(16*s - 3) + 336*s**2 - 180*s + 23) + r*(4*K - 4)*(4*s - 1) - 236*s**2 + 122*s - 59) + 4*Pk2*fd*(K*r*(8*s + 3) - 9*K*s + K - 8*r*s - 3*r - 188*s**2 + 244*s - 48) + 14*Pkdd2*bd1*k1**2*(12*s**2 - 7*s + 1) - 14*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*f*k1**2*(12*bd1*(12*s**2 - 7*s + 1) + s**2*(160*fd - 20) + s*(10 - 40*fd) - 5) + 12*Pkdd2*fd*k1**2*s*(4*s - 1)) - 2*Ddd*f*(Pk2*(2*K*s + 4*f*(4*r*(4*s - 1) + 84*s**2 - 46*s + 21) - r*(2*K - 2)*(4*s - 1) + 188*s**2 - 96*s + 47) - Pkdd2*k1**2*(5*f + 3)*(4*s**2 - 2*s + 1))) - 4*Dd**2*f*(Pk2*(K*(-12*r*s + 3*r + 3*s - 1) + 4*f*(6*r*(4*s - 1) + 126*s**2 - 69*s + 2) + 12*r*s - 3*r + 282*s**2 - 144*s + 1) + Pkdd2*k1**2*s*(-15*f - 9)*(2*s - 1))) - 26*b1*(3168*D1**2*K*Pk2*f*fd*r*s - 1584*D1**2*K*Pk2*f*fd*r - 1584*D1**2*K*Pk2*f*fd*s - 924*D1**2*K*Pk2*f*fdd*r*s + 462*D1**2*K*Pk2*f*fdd*r + 462*D1**2*K*Pk2*f*fdd*s - 924*D1**2*K*Pk2*fd**2*r*s + 462*D1**2*K*Pk2*fd**2*r + 462*D1**2*K*Pk2*fd**2*s - 462*D1**2*K*Pk2*fd**2 - 1374*D1**2*Pk2*f**2*fd*r**2 + 1224*D1**2*Pk2*f**2*fd*r*s + 850*D1**2*Pk2*f**2*fd*r + 2970*D1**2*Pk2*f**2*fd*s**2 + 54*D1**2*Pk2*f**2*fd*s - 724*D1**2*Pk2*f**2*fd - 6*D1**2*Pk2*f**2*fdd*r**2 + 576*D1**2*Pk2*f**2*fdd*r*s - 590*D1**2*Pk2*f**2*fdd*r - 990*D1**2*Pk2*f**2*fdd*s**2 - 1314*D1**2*Pk2*f**2*fdd*s + 824*D1**2*Pk2*f**2*fdd - 12*D1**2*Pk2*f*fd**2*r**2 + 1152*D1**2*Pk2*f*fd**2*r*s - 1180*D1**2*Pk2*f*fd**2*r - 1980*D1**2*Pk2*f*fd**2*s**2 - 2628*D1**2*Pk2*f*fd**2*s + 64*D1**2*Pk2*f*fd**2 - 594*D1**2*Pk2*f*fd*r**2 - 2112*D1**2*Pk2*f*fd*r*s + 1650*D1**2*Pk2*f*fd*r + 3300*D1**2*Pk2*f*fd*s**2 - 2244*D1**2*Pk2*f*fd*s + 1353*D1**2*Pk2*f*fd - 66*D1**2*Pk2*f*fdd*r**2 + 396*D1**2*Pk2*f*fdd*r*s - 132*D1**2*Pk2*f*fdd*r - 2640*D1**2*Pk2*f*fdd*s**2 + 2442*D1**2*Pk2*f*fdd*s - 1353*D1**2*Pk2*f*fdd + 264*D1**2*Pk2*f*gd2*r*s - 132*D1**2*Pk2*f*gdd2*r*s - 66*D1**2*Pk2*fd**2*r**2 + 396*D1**2*Pk2*fd**2*r*s - 132*D1**2*Pk2*fd**2*r - 2640*D1**2*Pk2*fd**2*s**2 + 2442*D1**2*Pk2*fd**2*s + 198*D1**2*Pk2*fd**2 + 264*D1**2*Pk2*fd*g2*r*s + 2112*D1**2*Pk2*fd*g2*r - 2376*D1**2*Pk2*fd*g2*s - 264*D1**2*Pk2*fd*gd2*r*s - 132*D1**2*Pk2*fd*gd2*r + 264*D1**2*Pk2*fd*gd2*s - 132*D1**2*Pk2*fdd*g2*r*s - 132*D1**2*Pk2*fdd*g2*r + 264*D1**2*Pk2*fdd*g2*s + 33*D1**2*Pkdd2*bd1**2*k1**2*s*(6*f + 7)*(3*s - 2) + 75*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 330*D1**2*Pkdd2*f**2*fd*k1**2*s + 165*D1**2*Pkdd2*f**2*fd*k1**2 + 210*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 420*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 198*D1**2*Pkdd2*f*fd*k1**2*s**2 - 198*D1**2*Pkdd2*f*fd*k1**2*s + 99*D1**2*Pkdd2*f*fd*k1**2 - 33*D1**2*bdd1*f*(2*Pk2*f*(2*r*(8*s - 3) + 84*s**2 - 48*s + 21) + 4*Pk2*r*(-K*s + K + s - 1) + 2*Pk2*s*(-K + 47*s + 1) - 5*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 6336*D1*Dd*K*Pk2*f**2*r*s - 1584*D1*Dd*K*Pk2*f**2*r - 1584*D1*Dd*K*Pk2*f**2*s - 7392*D1*Dd*K*Pk2*f*fd*r*s + 2772*D1*Dd*K*Pk2*f*fd*r + 2772*D1*Dd*K*Pk2*f*fd*s - 924*D1*Dd*K*Pk2*f*fd - 1832*D1*Dd*Pk2*f**3*r**2 + 1632*D1*Dd*Pk2*f**3*r*s + 508*D1*Dd*Pk2*f**3*r + 3960*D1*Dd*Pk2*f**3*s**2 - 2388*D1*Dd*Pk2*f**3*s + 532*D1*Dd*Pk2*f**3 - 48*D1*Dd*Pk2*f**2*fd*r**2 + 4608*D1*Dd*Pk2*f**2*fd*r*s - 2924*D1*Dd*Pk2*f**2*fd*r - 7920*D1*Dd*Pk2*f**2*fd*s**2 - 3852*D1*Dd*Pk2*f**2*fd*s + 1904*D1*Dd*Pk2*f**2*fd - 1188*D1*Dd*Pk2*f**2*r**2 - 4224*D1*Dd*Pk2*f**2*r*s + 1650*D1*Dd*Pk2*f**2*r + 6600*D1*Dd*Pk2*f**2*s**2 - 2244*D1*Dd*Pk2*f**2*s + 1353*D1*Dd*Pk2*f**2 - 528*D1*Dd*Pk2*f*fd*r**2 + 3168*D1*Dd*Pk2*f*fd*r*s - 792*D1*Dd*Pk2*f*fd*r - 21120*D1*Dd*Pk2*f*fd*s**2 + 14652*D1*Dd*Pk2*f*fd*s - 2310*D1*Dd*Pk2*f*fd + 1056*D1*Dd*Pk2*f*g2*r*s - 264*D1*Dd*Pk2*f*g2*r - 264*D1*Dd*Pk2*f*g2*s - 1056*D1*Dd*Pk2*f*gd2*r*s + 132*D1*Dd*Pk2*f*gd2*r + 132*D1*Dd*Pk2*f*gd2*s - 1056*D1*Dd*Pk2*fd*g2*r*s - 396*D1*Dd*Pk2*fd*g2*r + 1188*D1*Dd*Pk2*fd*g2*s - 132*D1*Dd*Pk2*fd*g2 + 100*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 50*D1*Dd*Pkdd2*f**3*k1**2*s + 25*D1*Dd*Pkdd2*f**3*k1**2 + 1680*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 420*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 396*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 198*D1*Dd*Pkdd2*f**2*k1**2*s + 99*D1*Dd*Pkdd2*f**2*k1**2 - 1848*D1*Ddd*K*Pk2*f**2*r*s + 462*D1*Ddd*K*Pk2*f**2*r + 462*D1*Ddd*K*Pk2*f**2*s - 8*D1*Ddd*Pk2*f**3*r**2 + 768*D1*Ddd*Pk2*f**3*r*s - 188*D1*Ddd*Pk2*f**3*r - 1320*D1*Ddd*Pk2*f**3*s**2 + 468*D1*Ddd*Pk2*f**3*s - 332*D1*Ddd*Pk2*f**3 - 132*D1*Ddd*Pk2*f**2*r**2 + 792*D1*Ddd*Pk2*f**2*r*s - 132*D1*Ddd*Pk2*f**2*r - 5280*D1*Ddd*Pk2*f**2*s**2 + 2442*D1*Ddd*Pk2*f**2*s - 1353*D1*Ddd*Pk2*f**2 - 528*D1*Ddd*Pk2*f*g2*r*s + 132*D1*Ddd*Pk2*f*g2*r + 132*D1*Ddd*Pk2*f*g2*s + 280*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 140*D1*Ddd*Pkdd2*f**3*k1**2*s + 70*D1*Ddd*Pkdd2*f**3*k1**2 + 33*D1*bd1*(2*D1*f**2*(4*Pk2*r*(8*s - 3) + 3*Pk2*(36*s**2 - 22*s + 9) + Pkdd2*k1**2*(-7*s**2 + 10*s - 5)) + D1*f*(Pk2*r*(4 - 4*K)*(2*s - 9) + 2*Pk2*s*(-16*K + 59*s + 16) + Pkdd2*k1**2*(-5*s**2 + 12*s - 6) - 4*fd*(2*Pk2*(16*r*s - 4*r + 84*s**2 - 46*s + 1) + 5*Pkdd2*k1**2*s*(1 - 2*s))) + 2*D1*fd*(Pk2*(K*s*(4*r - 3) + K - 94*s**2 + s*(97 - 4*r) - 1) + 3*Pkdd2*k1**2*s*(2*s - 1)) - 2*Dd*Pk2*f*(-K*(2*r*(8*s - 5) + 2*s + 1) + 2*f*(4*r*(16*s - 5) + 336*s**2 - 188*s + 27) + 16*r*s - 10*r + 376*s**2 - 92*s + 1) + 2*Dd*Pkdd2*f*k1**2*(5*f + 3)*(8*s**2 - 6*s + 1)) - 5544*Dd**2*K*Pk2*f**2*r*s + 1386*Dd**2*K*Pk2*f**2*r + 1386*Dd**2*K*Pk2*f**2*s - 462*Dd**2*K*Pk2*f**2 - 24*Dd**2*Pk2*f**3*r**2 + 2304*Dd**2*Pk2*f**3*r*s - 564*Dd**2*Pk2*f**3*r - 3960*Dd**2*Pk2*f**3*s**2 + 1404*Dd**2*Pk2*f**3*s + 192*Dd**2*Pk2*f**3 - 396*Dd**2*Pk2*f**2*r**2 + 2376*Dd**2*Pk2*f**2*r*s - 396*Dd**2*Pk2*f**2*r - 15840*Dd**2*Pk2*f**2*s**2 + 7326*Dd**2*Pk2*f**2*s + 198*Dd**2*Pk2*f**2 - 1584*Dd**2*Pk2*f*g2*r*s + 396*Dd**2*Pk2*f*g2*r + 396*Dd**2*Pk2*f*g2*s - 132*Dd**2*Pk2*f*g2 + 840*Dd**2*Pkdd2*f**3*k1**2*s**2 - 420*Dd**2*Pkdd2*f**3*k1**2*s))/(9009*d**2*k1*k2) + D1**2*Pk1*ct**3*k2**3*st**2*(132*D1**2*Pk2*b1*f*fd*r**2 + 132*D1**2*Pk2*b1*f*fdd*r**2 + 132*D1**2*Pk2*b1*fd**2*r**2 - 942*D1**2*Pk2*f**2*fd*r**2 + 628*D1**2*Pk2*f**2*fd*r - 314*D1**2*Pk2*f**2*fd + 966*D1**2*Pk2*f**2*fdd*r**2 - 644*D1**2*Pk2*f**2*fdd*r + 322*D1**2*Pk2*f**2*fdd + 1932*D1**2*Pk2*f*fd**2*r**2 - 1288*D1**2*Pk2*f*fd**2*r + 198*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 99*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 198*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 198*D1**2*Pkdd2*b1*f*fd*k1**2*s - 99*D1**2*Pkdd2*b1*f*fd*k1**2 - 198*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 198*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 198*D1**2*Pkdd2*bd1**2*f*k1**2*s*(s - 1) - 297*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 198*D1**2*Pkdd2*f**2*fd*k1**2*s - 99*D1**2*Pkdd2*f**2*fd*k1**2 + 33*D1**2*bdd1*f*(-3*Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1) + f*(2*Pk2*(r - 1)**2 - 3*Pkdd2*k1**2*(s - 1)**2)) + 264*D1*Dd*Pk2*b1*f**2*r**2 - 132*D1*Dd*Pk2*b1*f**2*r + 66*D1*Dd*Pk2*b1*f**2 + 1056*D1*Dd*Pk2*b1*f*fd*r**2 - 264*D1*Dd*Pk2*b1*f*fd*r - 1256*D1*Dd*Pk2*f**3*r**2 + 628*D1*Dd*Pk2*f**3*r - 314*D1*Dd*Pk2*f**3 + 7728*D1*Dd*Pk2*f**2*fd*r**2 - 4508*D1*Dd*Pk2*f**2*fd*r + 644*D1*Dd*Pk2*f**2*fd + 792*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 396*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 198*D1*Dd*Pkdd2*b1**2*f*k1**2 - 792*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 198*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 396*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 198*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 99*D1*Dd*Pkdd2*b1*f**2*k1**2 - 1584*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 396*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 396*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 198*D1*Dd*Pkdd2*f**3*k1**2*s - 99*D1*Dd*Pkdd2*f**3*k1**2 + 264*D1*Ddd*Pk2*b1*f**2*r**2 - 132*D1*Ddd*Pk2*b1*f**2*r + 66*D1*Ddd*Pk2*b1*f**2 + 1288*D1*Ddd*Pk2*f**3*r**2 - 644*D1*Ddd*Pk2*f**3*r + 322*D1*Ddd*Pk2*f**3 - 396*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 198*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 99*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 396*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 198*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 99*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 33*D1*bd1*(D1*(6*Pkdd2*b1*fd*k1**2*s*(1 - 2*s) + f**2*(2*Pk2*(r - 1)**2 + 3*Pkdd2*k1**2*(s**2 - 4*s + 2)) + 2*f*(4*Pk2*fd*r*(r - 1) + 3*Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1) - 6*Pkdd2*fd*k1**2*s*(s - 1))) + 2*Dd*f*(2*Pk2*f*(4*r**2 - 5*r + 1) - 3*Pkdd2*b1*k1**2*(8*s**2 - 6*s + 1) - 3*Pkdd2*f*k1**2*(4*s**2 - 5*s + 1))) + 792*Dd**2*Pk2*b1*f**2*r**2 - 396*Dd**2*Pk2*b1*f**2*r + 3864*Dd**2*Pk2*f**3*r**2 - 1932*Dd**2*Pk2*f**3*r - 1188*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 594*Dd**2*Pkdd2*b1**2*f*k1**2*s - 1188*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 594*Dd**2*Pkdd2*b1*f**2*k1**2*s)/(693*d**2*k1**3*k3**2) + D1**2*Pk1*ct**3*k2**3*(2*D1*f*(-10*D1*Pk2*bd1**2*r*(r - 1) + D1*Pk2*bdd1*f*r**2 + bd1*(2*D1*Pk2*fd*r*(2*r - 1) - 3*D1*f*(-5*Pk2*r**2 + Pkdd2*k1**2*(s - 1)**2) + 2*Dd*Pk2*f*r*(4*r - 1))) + b1**2*(D1**2*(34*Pk2*fd*r**2 - 10*Pk2*fdd*r**2 - 7*Pkdd2*fd*k1**2*s**2) + D1*Dd*(34*Pk2*f*(4*r**2 - 2*r + 1) + 20*Pk2*fd*r*(1 - 4*r) - 7*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 10*D1*Ddd*Pk2*f*(4*r**2 - 2*r + 1) + 60*Dd**2*Pk2*f*r*(1 - 2*r)) + b1*(-10*D1**2*Pk2*bdd1*f*(2*r**2 - 2*r + 1) + 2*D1**2*(2*Pk2*fd**2*r*(r - 1) + f*(15*Pk2*fd*(2*r**2 - 2*r + 1) + Pk2*fdd*(2*r**2 - 2*r + 1) - 6*Pkdd2*fd*k1**2*s**2)) + D1*bd1*(D1*(34*Pk2*f*(2*r**2 - 2*r + 1) + 20*Pk2*fd*r*(1 - 2*r) - 7*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) - 20*Dd*Pk2*f*(8*r**2 - 6*r + 1)) + 2*D1*f*(2*Dd*Pk2*fd*(8*r**2 - 6*r + 1) + 3*Dd*f*(5*Pk2*(4*r**2 - 2*r + 1) + Pkdd2*k1**2*(-4*s**2 + 2*s - 1)) + Ddd*Pk2*f*(4*r**2 - 2*r + 1)) + 12*Dd**2*Pk2*f**2*r*(2*r - 1)))/(21*d**2*k1**3*k3**2) - D1**2*Pk1*ct**3*k2*st**2*(-13650*D1**2*Pk2*b1*f**2*fd*r**2 + 390*D1**2*Pk2*b1*f**2*fdd*r**2 + 780*D1**2*Pk2*b1*f*fd**2*r**2 - 680*D1**2*Pk2*f**3*fd*r**2 + 340*D1**2*Pk2*f**3*fd*r - 170*D1**2*Pk2*f**3*fd - 12920*D1**2*Pk2*f**3*fdd*r**2 + 6460*D1**2*Pk2*f**3*fdd*r - 3230*D1**2*Pk2*f**3*fdd - 38760*D1**2*Pk2*f**2*fd**2*r**2 + 19380*D1**2*Pk2*f**2*fd**2*r - 17160*D1**2*Pkdd2*b1**2*f*fd*k1**2*s**2 + 8580*D1**2*Pkdd2*b1**2*f*fd*k1**2*s - 4290*D1**2*Pkdd2*b1**2*f*fd*k1**2 + 8580*D1**2*Pkdd2*b1**2*f*fdd*k1**2*s**2 - 4290*D1**2*Pkdd2*b1**2*f*fdd*k1**2*s + 2145*D1**2*Pkdd2*b1**2*f*fdd*k1**2 + 8580*D1**2*Pkdd2*b1**2*fd**2*k1**2*s**2 - 4290*D1**2*Pkdd2*b1**2*fd**2*k1**2*s - 2574*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 5148*D1**2*Pkdd2*b1**2*fd*k1**2*s - 2574*D1**2*Pkdd2*b1**2*fd*k1**2 + 1287*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 2574*D1**2*Pkdd2*b1**2*fdd*k1**2*s + 1287*D1**2*Pkdd2*b1**2*fdd*k1**2 - 13065*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 2210*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 1105*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 9750*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 3250*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 1625*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 19500*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 6500*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 5148*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 5148*D1**2*Pkdd2*b1*f*fd*k1**2*s - 2574*D1**2*Pkdd2*b1*f*fd*k1**2 + 2574*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 2574*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 1287*D1**2*Pkdd2*b1*f*fdd*k1**2 + 2574*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 2574*D1**2*Pkdd2*b1*fd**2*k1**2*s + 858*D1**2*Pkdd2*bd1**2*f*k1**2*s*(5*f*(2*s - 1) + 3*s) + 6500*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 3250*D1**2*Pkdd2*f**3*fd*k1**2*s + 1625*D1**2*Pkdd2*f**3*fd*k1**2 + 13*D1**2*bdd1*f*(198*Pkdd2*b1*k1**2*s**2 + 33*Pkdd2*f*k1**2*(5*b1*(4*s**2 - 2*s + 1) + 3*s**2) + 5*f**2*(2*Pk2*(r - 1)**2 + 25*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 18200*D1*Dd*Pk2*b1*f**3*r**2 + 9100*D1*Dd*Pk2*b1*f**3*r - 4550*D1*Dd*Pk2*b1*f**3 + 3120*D1*Dd*Pk2*b1*f**2*fd*r**2 - 780*D1*Dd*Pk2*b1*f**2*fd*r - 680*D1*Dd*Pk2*f**4*r**2 + 340*D1*Dd*Pk2*f**4*r - 170*D1*Dd*Pk2*f**4 - 103360*D1*Dd*Pk2*f**3*fd*r**2 + 51680*D1*Dd*Pk2*f**3*fd*r - 6460*D1*Dd*Pk2*f**3*fd - 34320*D1*Dd*Pkdd2*b1**2*f**2*k1**2*s**2 + 17160*D1*Dd*Pkdd2*b1**2*f**2*k1**2*s - 8580*D1*Dd*Pkdd2*b1**2*f**2*k1**2 + 68640*D1*Dd*Pkdd2*b1**2*f*fd*k1**2*s**2 - 34320*D1*Dd*Pkdd2*b1**2*f*fd*k1**2*s + 4290*D1*Dd*Pkdd2*b1**2*f*fd*k1**2 - 10296*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 5148*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 2574*D1*Dd*Pkdd2*b1**2*f*k1**2 + 10296*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 12870*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 2574*D1*Dd*Pkdd2*b1**2*fd*k1**2 - 17420*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 8710*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 4355*D1*Dd*Pkdd2*b1*f**3*k1**2 + 78000*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 32500*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 3250*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 10296*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 5148*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 2574*D1*Dd*Pkdd2*b1*f**2*k1**2 + 20592*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 15444*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 2574*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 6500*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 3250*D1*Dd*Pkdd2*f**4*k1**2*s + 1625*D1*Dd*Pkdd2*f**4*k1**2 + 520*D1*Ddd*Pk2*b1*f**3*r**2 - 260*D1*Ddd*Pk2*b1*f**3*r + 130*D1*Ddd*Pk2*b1*f**3 - 12920*D1*Ddd*Pk2*f**4*r**2 + 6460*D1*Ddd*Pk2*f**4*r - 3230*D1*Ddd*Pk2*f**4 + 17160*D1*Ddd*Pkdd2*b1**2*f**2*k1**2*s**2 - 8580*D1*Ddd*Pkdd2*b1**2*f**2*k1**2*s + 4290*D1*Ddd*Pkdd2*b1**2*f**2*k1**2 + 5148*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 2574*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 1287*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 13000*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 6500*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 3250*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 5148*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 2574*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 1287*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 13*D1*bd1*(D1*(-396*Pkdd2*b1*fd*k1**2*s*(s - 1) - 66*Pkdd2*f*k1**2*s*(-6*b1*s + fd*(20*b1 + 3)*(2*s - 1)) + 5*f**3*(70*Pk2*(r - 1)**2 + Pkdd2*k1**2*(67*s**2 - 100*s + 50)) + 2*f**2*(165*Pkdd2*b1*k1**2*(4*s**2 - 2*s + 1) + 99*Pkdd2*k1**2*s**2 - 10*fd*(3*Pk2*r*(r - 1) + 25*Pkdd2*k1**2*s*(3*s - 2)))) - 2*Dd*f*(198*Pkdd2*b1*k1**2*s*(4*s - 1) + 33*Pkdd2*f*k1**2*(4*s - 1)*(5*b1*(4*s - 1) + 3*s) + 5*f**2*(2*Pk2*(4*r**2 - 5*r + 1) + 25*Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) + 1560*Dd**2*Pk2*b1*f**3*r**2 - 780*Dd**2*Pk2*b1*f**3*r - 38760*Dd**2*Pk2*f**4*r**2 + 19380*Dd**2*Pk2*f**4*r + 51480*Dd**2*Pkdd2*b1**2*f**2*k1**2*s**2 - 25740*Dd**2*Pkdd2*b1**2*f**2*k1**2*s + 15444*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 7722*Dd**2*Pkdd2*b1**2*f*k1**2*s + 39000*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 19500*Dd**2*Pkdd2*b1*f**3*k1**2*s + 15444*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 7722*Dd**2*Pkdd2*b1*f**2*k1**2*s)/(9009*d**2*k1**3) + D1**2*Pk1*ct**3*k2*(D1*f*(2*D1*Pk2*bdd1*f*r**2*(24*f + 11) - 22*D1*bd1**2*(Pk2*r*(8*f + 10)*(r - 1) + Pkdd2*k1**2*s*(5*f + 6)*(s - 1)) + bd1*(D1*(44*Pk2*fd*r*(2*r - 1) + f**2*(432*Pk2*r**2 - 55*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 6*f*(16*Pk2*fd*r*(3*r - 1) + 55*Pk2*r**2 - 11*Pkdd2*k1**2*s**2)) + 4*Dd*Pk2*f*r*(24*f + 11)*(4*r - 1))) + 11*Pkdd2*b1**3*k1**2*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(6*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 28) + s*(6*fd - 14) + 7) - D1*Ddd*(6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(6*f + 7)*(2*s - 1)) + 11*b1**2*(D1**2*(80*Pk2*f*fd*r**2 - 16*Pk2*f*fdd*r**2 - 16*Pk2*fd**2*r**2 + 34*Pk2*fd*r**2 - 10*Pk2*fdd*r**2 + 2*Pkdd2*bd1*k1**2*(6*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 21) + s*(6*fd - 14) + 7) - Pkdd2*bdd1*k1**2*(6*f + 7)*(3*s**2 - 2*s + 1) - 4*Pkdd2*f*fd*k1**2*s**2 + 12*Pkdd2*f*fd*k1**2*s - 6*Pkdd2*f*fd*k1**2 - 10*Pkdd2*f*fdd*k1**2*s**2 - 10*Pkdd2*fd**2*k1**2*s**2 + 5*Pkdd2*fd*k1**2*s**2 + 14*Pkdd2*fd*k1**2*s - 7*Pkdd2*fd*k1**2 - 6*Pkdd2*fdd*k1**2*s**2) + D1*(Dd*(-20*Pk2*fd*r*(4*r - 1) - 14*Pkdd2*bd1*k1**2*(12*s**2 - 7*s + 1) - 12*Pkdd2*fd*k1**2*s*(4*s - 1) + 2*f**2*(20*Pk2*(4*r**2 - 2*r + 1) + Pkdd2*k1**2*(-4*s**2 + 2*s - 1)) + f*(Pk2*(-r**2*(128*fd - 136) + r*(32*fd - 68) + 34) + Pkdd2*k1**2*(-12*bd1*(12*s**2 - 7*s + 1) + s**2*(20 - 80*fd) + s*(20*fd - 10) + 5))) - Ddd*f*(Pk2*(8*f + 10)*(4*r**2 - 2*r + 1) + Pkdd2*k1**2*(5*f + 6)*(4*s**2 - 2*s + 1))) - 6*Dd**2*f*(Pk2*r*(8*f + 10)*(2*r - 1) + Pkdd2*k1**2*s*(5*f + 6)*(2*s - 1))) + b1*(1296*D1**2*Pk2*f**2*fd*r**2 - 864*D1**2*Pk2*f**2*fd*r + 432*D1**2*Pk2*f**2*fd + 144*D1**2*Pk2*f**2*fdd*r**2 - 96*D1**2*Pk2*f**2*fdd*r + 48*D1**2*Pk2*f**2*fdd + 288*D1**2*Pk2*f*fd**2*r**2 - 192*D1**2*Pk2*f*fd**2*r + 660*D1**2*Pk2*f*fd*r**2 - 660*D1**2*Pk2*f*fd*r + 330*D1**2*Pk2*f*fd + 44*D1**2*Pk2*f*fdd*r**2 - 44*D1**2*Pk2*f*fdd*r + 22*D1**2*Pk2*f*fdd + 44*D1**2*Pk2*fd**2*r**2 - 44*D1**2*Pk2*fd**2*r - 22*D1**2*Pkdd2*bd1**2*k1**2*s*(6*f + 7)*(3*s - 2) - 330*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 110*D1**2*Pkdd2*f**2*fd*k1**2*s - 55*D1**2*Pkdd2*f**2*fd*k1**2 - 132*D1**2*Pkdd2*f*fd*k1**2*s**2 + 132*D1**2*Pkdd2*f*fd*k1**2*s - 66*D1**2*Pkdd2*f*fd*k1**2 - 11*D1**2*bdd1*f*(Pk2*(8*f + 10)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(5*f + 6)*(2*s**2 - 2*s + 1)) + 1728*D1*Dd*Pk2*f**3*r**2 - 864*D1*Dd*Pk2*f**3*r + 432*D1*Dd*Pk2*f**3 + 1152*D1*Dd*Pk2*f**2*fd*r**2 - 672*D1*Dd*Pk2*f**2*fd*r + 96*D1*Dd*Pk2*f**2*fd + 1320*D1*Dd*Pk2*f**2*r**2 - 660*D1*Dd*Pk2*f**2*r + 330*D1*Dd*Pk2*f**2 + 352*D1*Dd*Pk2*f*fd*r**2 - 264*D1*Dd*Pk2*f*fd*r + 44*D1*Dd*Pk2*f*fd - 440*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 220*D1*Dd*Pkdd2*f**3*k1**2*s - 110*D1*Dd*Pkdd2*f**3*k1**2 - 264*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 132*D1*Dd*Pkdd2*f**2*k1**2*s - 66*D1*Dd*Pkdd2*f**2*k1**2 + 192*D1*Ddd*Pk2*f**3*r**2 - 96*D1*Ddd*Pk2*f**3*r + 48*D1*Ddd*Pk2*f**3 + 88*D1*Ddd*Pk2*f**2*r**2 - 44*D1*Ddd*Pk2*f**2*r + 22*D1*Ddd*Pk2*f**2 + 22*D1*bd1*(D1*(20*Pk2*f**2*(2*r**2 - 2*r + 1) + Pk2*f*(r**2*(34 - 32*fd) + r*(16*fd - 34) + 17) + 10*Pk2*fd*r*(1 - 2*r) - 2*Pkdd2*f**2*k1**2*(s**2 + 2*s - 1) + Pkdd2*f*k1**2*(s**2*(5 - 20*fd) + s*(10*fd - 12) + 6) + 6*Pkdd2*fd*k1**2*s*(1 - 2*s)) - Dd*f*(Pk2*(8*f + 10)*(8*r**2 - 6*r + 1) + Pkdd2*k1**2*(5*f + 6)*(8*s**2 - 6*s + 1))) + 576*Dd**2*Pk2*f**3*r**2 - 288*Dd**2*Pk2*f**3*r + 264*Dd**2*Pk2*f**2*r**2 - 132*Dd**2*Pk2*f**2*r))/(231*d**2*k1**3) + 2*D1**2*Pk1*ct**2*st**4*(264*Pk2*b1**2*(C - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 132*Pk2*b1*(C - 1)*(-2*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 18*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s - 9*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 36*D1*Dd*f**2*s**2 + 22*D1*Dd*f**2*s - 9*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 116*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 22*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 4*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 66*Dd**2*f**2*s + 4*Dd**2*f**2) + f*(-528*D1**2*Pk2*bd1**2*s*(C - 1)*(s - 1) + D1**2*(f*(132*Pk2*bdd1*s*(C - 1)*(4*r + 9*s - 4) + 8*Pk2*fd*(2*C*(36*r*s - 12*r + 75*s**2 - 62*s + 25) - 87*r*s + 29*r - 30*s**2 + 49*s - 10) - 4*Pk2*fdd*(2*C*(36*r*s - 12*r + 75*s**2 - 62*s + 25) - 87*r*s + 29*r - 30*s**2 + 49*s - 10) - Pkdd2*fd*k1**2*(2*C - 12)*(3*s**2 - 2*s + 1) + Pkdd2*fdd*k1**2*(C - 6)*(3*s**2 - 2*s + 1)) + 2*fd**2*(-2*Pk2*(4*C*(36*r*s - 12*r + 75*s**2 - 62*s + 6) - 174*r*s + 58*r - 60*s**2 + 98*s - 29) + Pkdd2*k1**2*s*(C - 6)*(3*s - 2))) + 132*D1*Pk2*bd1*(C - 1)*(D1*(f*s*(-4*r - 9*s + 4) + 2*fd*(8*r*s - 2*r + 18*s**2 - 13*s + 2)) + 2*Dd*f*(2*r*(8*s - 1) + 36*s**2 - 19*s + 2)) + D1*f*(2*Dd*(4*Pk2*f*(2*C*(48*r*s - 12*r + 100*s**2 - 62*s + 25) - 116*r*s + 29*r - 40*s**2 + 49*s - 10) - 2*Pk2*fd*(4*C*(6*r*(24*s - 7) + 300*s**2 - 217*s + 37) - 696*r*s + 203*r - 240*s**2 + 343*s - 78) - Pkdd2*f*k1**2*(C - 6)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(C - 6)*(12*s**2 - 7*s + 1)) + Ddd*f*(-4*Pk2*(2*C*(48*r*s - 12*r + 100*s**2 - 62*s + 25) - 116*r*s + 29*r - 40*s**2 + 49*s - 10) + Pkdd2*k1**2*(C - 6)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f**2*(-2*Pk2*(12*C*(24*r*s - 6*r + 50*s**2 - 31*s + 2) - 348*r*s + 87*r - 120*s**2 + 147*s - 29) + Pkdd2*k1**2*s*(3*C - 18)*(2*s - 1))))/(231*d**2*k3**2) + D1**2*Pk1*ct**2*st**2*(11*b1**2*(D1**2*s*(fd*(Pk2*r*(8*C - 32) + Pk2*s*(6*C - 6) - Pkdd2*k1**2*s*(2*C - 8)) + fdd*(Pk2*r*(24*C - 12) + Pk2*s*(46*C - 46) + Pkdd2*k1**2*s*(C - 4))) + D1*(2*Dd*(Pk2*f*(C*(16*r*s - 4*r + 12*s**2 - 10*s + 3) - 64*r*s + 16*r - 12*s**2 + 22*s - 3) + Pk2*fd*r*(12*C - 6)*(8*s - 1) + 2*Pk2*fd*s*(C*(92*s - 29) - 92*s + 26) - Pkdd2*f*k1**2*(C - 4)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(C - 4)*(4*s - 1)) + Ddd*f*(2*Pk2*(C*(48*r*s - 12*r + 92*s**2 - 58*s + 23) - 24*r*s + 6*r - 92*s**2 + 52*s - 23) + Pkdd2*k1**2*(C - 4)*(4*s**2 - 2*s + 1))) + 6*Dd**2*f*(2*Pk2*(C*(24*r*s - 6*r + 46*s**2 - 29*s + 2) - 12*r*s + 3*r - 46*s**2 + 26*s - 1) + Pkdd2*k1**2*s*(C - 4)*(2*s - 1))) + 11*b1*(8*C*D1**2*Pk2*f*fd*r**2 - 152*C*D1**2*Pk2*f*fd*r*s + 132*C*D1**2*Pk2*f*fd*r - 108*C*D1**2*Pk2*f*fd*s**2 + 160*C*D1**2*Pk2*f*fd*s - 108*C*D1**2*Pk2*f*fd - 8*C*D1**2*Pk2*f*fdd*r**2 + 40*C*D1**2*Pk2*f*fdd*r*s - 60*C*D1**2*Pk2*f*fdd*r + 100*C*D1**2*Pk2*f*fdd*s**2 - 128*C*D1**2*Pk2*f*fdd*s + 84*C*D1**2*Pk2*f*fdd - 8*C*D1**2*Pk2*fd**2*r**2 + 40*C*D1**2*Pk2*fd**2*r*s - 60*C*D1**2*Pk2*fd**2*r + 100*C*D1**2*Pk2*fd**2*s**2 - 128*C*D1**2*Pk2*fd**2*s + 22*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 26*C*D1**2*Pkdd2*f*fd*k1**2*s + 13*C*D1**2*Pkdd2*f*fd*k1**2 - 10*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 12*C*D1**2*Pkdd2*f*fdd*k1**2*s - 6*C*D1**2*Pkdd2*f*fdd*k1**2 - 10*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 12*C*D1**2*Pkdd2*fd**2*k1**2*s + 16*C*D1*Dd*Pk2*f**2*r**2 - 304*C*D1*Dd*Pk2*f**2*r*s + 68*C*D1*Dd*Pk2*f**2*r - 216*C*D1*Dd*Pk2*f**2*s**2 + 184*C*D1*Dd*Pk2*f**2*s - 50*C*D1*Dd*Pk2*f**2 - 64*C*D1*Dd*Pk2*f*fd*r**2 + 320*C*D1*Dd*Pk2*f*fd*r*s - 264*C*D1*Dd*Pk2*f*fd*r + 800*C*D1*Dd*Pk2*f*fd*s**2 - 752*C*D1*Dd*Pk2*f*fd*s + 188*C*D1*Dd*Pk2*f*fd + 44*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 22*C*D1*Dd*Pkdd2*f**2*k1**2*s + 11*C*D1*Dd*Pkdd2*f**2*k1**2 - 80*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 68*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 12*C*D1*Dd*Pkdd2*f*fd*k1**2 - 16*C*D1*Ddd*Pk2*f**2*r**2 + 80*C*D1*Ddd*Pk2*f**2*r*s - 12*C*D1*Ddd*Pk2*f**2*r + 200*C*D1*Ddd*Pk2*f**2*s**2 - 120*C*D1*Ddd*Pk2*f**2*s + 46*C*D1*Ddd*Pk2*f**2 - 20*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 10*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 5*C*D1*Ddd*Pkdd2*f**2*k1**2 - 48*C*Dd**2*Pk2*f**2*r**2 + 240*C*Dd**2*Pk2*f**2*r*s - 36*C*Dd**2*Pk2*f**2*r + 600*C*Dd**2*Pk2*f**2*s**2 - 360*C*Dd**2*Pk2*f**2*s + 20*C*Dd**2*Pk2*f**2 - 60*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 30*C*Dd**2*Pkdd2*f**2*k1**2*s + 16*D1**2*Pk2*f*fd*r**2 + 76*D1**2*Pk2*f*fd*r*s - 110*D1**2*Pk2*f*fd*r - 336*D1**2*Pk2*f*fd*s**2 + 300*D1**2*Pk2*f*fd*s - 114*D1**2*Pk2*f*fd - 16*D1**2*Pk2*f*fdd*r**2 + 44*D1**2*Pk2*f*fdd*r*s + 30*D1**2*Pk2*f*fdd*r + 248*D1**2*Pk2*f*fdd*s**2 - 232*D1**2*Pk2*f*fdd*s + 90*D1**2*Pk2*f*fdd - 16*D1**2*Pk2*fd**2*r**2 + 44*D1**2*Pk2*fd**2*r*s + 30*D1**2*Pk2*fd**2*r + 248*D1**2*Pk2*fd**2*s**2 - 232*D1**2*Pk2*fd**2*s + 8*D1**2*Pkdd2*f*fd*k1**2*s**2 + 8*D1**2*Pkdd2*f*fd*k1**2*s - 4*D1**2*Pkdd2*f*fd*k1**2 - 8*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 8*D1**2*Pkdd2*fd**2*k1**2*s**2 + D1**2*bdd1*f*(2*Pk2*(C*(24*r*s - 12*r + 46*s**2 - 58*s + 23) - 12*r*s + 6*r - 46*s**2 + 52*s - 23) + Pkdd2*k1**2*(C - 4)*(2*s**2 - 2*s + 1)) + 32*D1*Dd*Pk2*f**2*r**2 + 152*D1*Dd*Pk2*f**2*r*s - 54*D1*Dd*Pk2*f**2*r - 672*D1*Dd*Pk2*f**2*s**2 + 298*D1*Dd*Pk2*f**2*s - 160*D1*Dd*Pk2*f**2 - 128*D1*Dd*Pk2*f*fd*r**2 + 352*D1*Dd*Pk2*f*fd*r*s + 108*D1*Dd*Pk2*f*fd*r + 1984*D1*Dd*Pk2*f*fd*s**2 - 1468*D1*Dd*Pk2*f*fd*s + 202*D1*Dd*Pk2*f*fd + 16*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 8*D1*Dd*Pkdd2*f**2*k1**2*s + 4*D1*Dd*Pkdd2*f**2*k1**2 - 64*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 16*D1*Dd*Pkdd2*f*fd*k1**2*s - 32*D1*Ddd*Pk2*f**2*r**2 + 88*D1*Ddd*Pk2*f**2*r*s - 6*D1*Ddd*Pk2*f**2*r + 496*D1*Ddd*Pk2*f**2*s**2 - 270*D1*Ddd*Pk2*f**2*s + 116*D1*Ddd*Pk2*f**2 - 16*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 8*D1*Ddd*Pkdd2*f**2*k1**2*s - 4*D1*Ddd*Pkdd2*f**2*k1**2 + 2*D1*bd1*(D1*(Pk2*f*(C*(8*r*s - 4*r + 6*s**2 - 10*s + 3) - 32*r*s + 16*r - 6*s**2 + 22*s - 3) + Pk2*fd*r*(12*C - 6)*(4*s - 1) + 2*Pk2*fd*s*(C*(46*s - 29) - 46*s + 26) - Pkdd2*f*k1**2*(C - 4)*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(C - 4)*(2*s - 1)) + Dd*f*(2*Pk2*(C*(96*r*s - 36*r + 184*s**2 - 174*s + 35) - 48*r*s + 18*r - 184*s**2 + 156*s - 29) + Pkdd2*k1**2*(C - 4)*(8*s**2 - 6*s + 1))) - 96*Dd**2*Pk2*f**2*r**2 + 264*Dd**2*Pk2*f**2*r*s - 18*Dd**2*Pk2*f**2*r + 1488*Dd**2*Pk2*f**2*s**2 - 810*Dd**2*Pk2*f**2*s + 22*Dd**2*Pk2*f**2 - 48*Dd**2*Pkdd2*f**2*k1**2*s**2 + 24*Dd**2*Pkdd2*f**2*k1**2*s) - f*(192*C*D1**2*Pk2*f*fd*r**2 + 8244*C*D1**2*Pk2*f*fd*r*s - 2876*C*D1**2*Pk2*f*fd*r + 6540*C*D1**2*Pk2*f*fd*s**2 - 7108*C*D1**2*Pk2*f*fd*s + 2244*C*D1**2*Pk2*f*fd - 492*C*D1**2*Pk2*f*fdd*r**2 - 6300*C*D1**2*Pk2*f*fdd*r*s + 2428*C*D1**2*Pk2*f*fdd*r - 5844*C*D1**2*Pk2*f*fdd*s**2 + 5996*C*D1**2*Pk2*f*fdd*s - 2112*C*D1**2*Pk2*f*fdd - 984*C*D1**2*Pk2*fd**2*r**2 - 12600*C*D1**2*Pk2*fd**2*r*s + 4856*C*D1**2*Pk2*fd**2*r - 11688*C*D1**2*Pk2*fd**2*s**2 + 11992*C*D1**2*Pk2*fd**2*s - 2100*C*D1**2*Pk2*fd**2 - 333*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 222*C*D1**2*Pkdd2*f*fd*k1**2*s - 111*C*D1**2*Pkdd2*f*fd*k1**2 + 150*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 100*C*D1**2*Pkdd2*f*fdd*k1**2*s + 50*C*D1**2*Pkdd2*f*fdd*k1**2 + 300*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 200*C*D1**2*Pkdd2*fd**2*k1**2*s + 256*C*D1*Dd*Pk2*f**2*r**2 + 10992*C*D1*Dd*Pk2*f**2*r*s - 2876*C*D1*Dd*Pk2*f**2*r + 8720*C*D1*Dd*Pk2*f**2*s**2 - 7108*C*D1*Dd*Pk2*f**2*s + 2244*C*D1*Dd*Pk2*f**2 - 3936*C*D1*Dd*Pk2*f*fd*r**2 - 50400*C*D1*Dd*Pk2*f*fd*r*s + 16996*C*D1*Dd*Pk2*f*fd*r - 46752*C*D1*Dd*Pk2*f*fd*s**2 + 41972*C*D1*Dd*Pk2*f*fd*s - 8424*C*D1*Dd*Pk2*f*fd - 444*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 222*C*D1*Dd*Pkdd2*f**2*k1**2*s - 111*C*D1*Dd*Pkdd2*f**2*k1**2 + 1200*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 700*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 100*C*D1*Dd*Pkdd2*f*fd*k1**2 - 656*C*D1*Ddd*Pk2*f**2*r**2 - 8400*C*D1*Ddd*Pk2*f**2*r*s + 2428*C*D1*Ddd*Pk2*f**2*r - 7792*C*D1*Ddd*Pk2*f**2*s**2 + 5996*C*D1*Ddd*Pk2*f**2*s - 2112*C*D1*Ddd*Pk2*f**2 + 200*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 100*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 50*C*D1*Ddd*Pkdd2*f**2*k1**2 - 1968*C*Dd**2*Pk2*f**2*r**2 - 25200*C*Dd**2*Pk2*f**2*r*s + 7284*C*Dd**2*Pk2*f**2*r - 23376*C*Dd**2*Pk2*f**2*s**2 + 17988*C*Dd**2*Pk2*f**2*s - 2100*C*Dd**2*Pk2*f**2 + 600*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 300*C*Dd**2*Pkdd2*f**2*k1**2*s - 588*D1**2*Pk2*f*fd*r**2 - 7830*D1**2*Pk2*f*fd*r*s + 3002*D1**2*Pk2*f*fd*r + 402*D1**2*Pk2*f*fd*s**2 + 2342*D1**2*Pk2*f*fd*s - 62*D1**2*Pk2*f*fd + 888*D1**2*Pk2*f*fdd*r**2 + 4542*D1**2*Pk2*f*fdd*r*s - 2106*D1**2*Pk2*f*fdd*r + 294*D1**2*Pk2*f*fdd*s**2 - 1710*D1**2*Pk2*f*fdd*s + 394*D1**2*Pk2*f*fdd + 1776*D1**2*Pk2*fd**2*r**2 + 9084*D1**2*Pk2*fd**2*r*s - 4212*D1**2*Pk2*fd**2*r + 588*D1**2*Pk2*fd**2*s**2 - 3420*D1**2*Pk2*fd**2*s + 1514*D1**2*Pk2*fd**2 + 132*D1**2*Pkdd2*f*fd*k1**2*s**2 - 88*D1**2*Pkdd2*f*fd*k1**2*s + 44*D1**2*Pkdd2*f*fd*k1**2 - 22*D1**2*bd1**2*(2*Pk2*(C*(12*r*s - 6*r + 23*s**2 - 29*s + 6) - 6*r*s + 3*r - 23*s**2 + 26*s - 3) + Pkdd2*k1**2*s*(C - 4)*(s - 1)) + 11*D1**2*bdd1*f*(2*Pk2*(C*(2*r**2 - 2*r*(5*s + 12) - 25*s**2 - 4*s + 19) + 4*r**2 - 11*r*s + 18*r - 62*s**2 + 19*s - 13) + Pkdd2*k1**2*(C*(5*s**2 + 2*s - 1) + 4*(s - 1)**2)) - 784*D1*Dd*Pk2*f**2*r**2 - 10440*D1*Dd*Pk2*f**2*r*s + 3002*D1*Dd*Pk2*f**2*r + 536*D1*Dd*Pk2*f**2*s**2 + 2342*D1*Dd*Pk2*f**2*s - 62*D1*Dd*Pk2*f**2 + 7104*D1*Dd*Pk2*f*fd*r**2 + 36336*D1*Dd*Pk2*f*fd*r*s - 14742*D1*Dd*Pk2*f*fd*r + 2352*D1*Dd*Pk2*f*fd*s**2 - 11970*D1*Dd*Pk2*f*fd*s + 3816*D1*Dd*Pk2*f*fd + 176*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 88*D1*Dd*Pkdd2*f**2*k1**2*s + 44*D1*Dd*Pkdd2*f**2*k1**2 + 1184*D1*Ddd*Pk2*f**2*r**2 + 6056*D1*Ddd*Pk2*f**2*r*s - 2106*D1*Ddd*Pk2*f**2*r + 392*D1*Ddd*Pk2*f**2*s**2 - 1710*D1*Ddd*Pk2*f**2*s + 394*D1*Ddd*Pk2*f**2 - 11*D1*bd1*(D1*(2*Pk2*f*(C*(2*r**2 - 38*r*s - 32*r - 27*s**2 + 12*s + 29) + 4*r**2 + 19*r*s + 28*r - 84*s**2 - s - 23) + 2*Pk2*fd*(2*C*(-4*r**2 + 20*r*s + 9*r + 50*s**2 - 28*s + 5) - 16*r**2 + 44*r*s - 21*r + 248*s**2 - 154*s + 11) + Pkdd2*f*k1**2*(C*(11*s**2 + 4*s - 2) + 4*s**2 - 16*s + 8) + 4*Pkdd2*fd*k1**2*s*(C*(2 - 5*s) - 4*s + 4)) - 2*Dd*f*(Pk2*(2*C*(8*r**2 - 5*r*(8*s + 9) - 100*s**2 + 22*s + 14) + 32*r**2 - 88*r*s + 75*r - 496*s**2 + 211*s - 37) + Pkdd2*k1**2*(4*s - 1)*(5*C*s + C + 4*s - 4))) + 3552*Dd**2*Pk2*f**2*r**2 + 18168*Dd**2*Pk2*f**2*r*s - 6318*Dd**2*Pk2*f**2*r + 1176*Dd**2*Pk2*f**2*s**2 - 5130*Dd**2*Pk2*f**2*s + 1514*Dd**2*Pk2*f**2))/(231*d**2*k3**2) - 2*D1**2*Pk1*ct**2*(33*b1**2*(D1**2*(6*C*Pkdd2*fdd*k1**2*s**2 + Pk2*fd*(r**2*(38*C - 52) + r*s*(72*C - 93) + s**2*(66*C - 66)) + Pk2*fdd*(r**2*(2*C + 12) + r*s*(85 - 64*C) - s**2*(68*C - 68)) + Pkdd2*fd*k1**2*s**2*(14 - 19*C)) + D1*(Dd*(12*C*Pkdd2*fd*k1**2*s*(4*s - 1) + Pk2*f*(4*C*(38*r**2 + 72*r*s - 37*r + 66*s**2 - 51*s + 26) - 208*r**2 - 372*r*s + 197*r - 264*s**2 + 225*s - 118) + Pk2*fd*(r**2*(16*C + 96) + r*(-512*C*s + 60*C + 680*s - 109) + s*(-544*C*s + 200*C + 544*s - 221)) - Pkdd2*f*k1**2*(19*C - 14)*(4*s**2 - 2*s + 1)) + Ddd*f*(6*C*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + Pk2*(C*(8*r**2 - 256*r*s + 60*r - 272*s**2 + 200*s - 66) + 48*r**2 + 340*r*s - 109*r + 272*s**2 - 221*s + 80))) + Dd**2*f*(36*C*Pkdd2*k1**2*s*(2*s - 1) + Pk2*(4*C*(6*r**2 - 192*r*s + 45*r - 204*s**2 + 150*s - 16) + 144*r**2 + 1020*r*s - 327*r + 816*s**2 - 663*s + 85))) + 33*b1*(76*C*D1**2*Pk2*f*fd*r**2 + 96*C*D1**2*Pk2*f*fd*r*s - 44*C*D1**2*Pk2*f*fd*r - 28*C*D1**2*Pk2*f*fd*s**2 + 36*C*D1**2*Pk2*f*fd*s - 20*C*D1**2*Pk2*f*fd - 48*C*D1**2*Pk2*f*fdd*r*s - 56*C*D1**2*Pk2*f*fdd*r + 24*C*D1**2*Pk2*f*fdd*s**2 - 60*C*D1**2*Pk2*f*fdd*s + 70*C*D1**2*Pk2*f*fdd - 48*C*D1**2*Pk2*fd**2*r*s - 56*C*D1**2*Pk2*fd**2*r + 24*C*D1**2*Pk2*fd**2*s**2 - 60*C*D1**2*Pk2*fd**2*s - 20*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 12*C*D1**2*Pkdd2*f*fd*k1**2*s + 6*C*D1**2*Pkdd2*f*fd*k1**2 + 10*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 10*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 152*C*D1*Dd*Pk2*f**2*r**2 + 192*C*D1*Dd*Pk2*f**2*r*s - 124*C*D1*Dd*Pk2*f**2*r - 56*C*D1*Dd*Pk2*f**2*s**2 - 20*C*D1*Dd*Pk2*f**2*s + 24*C*D1*Dd*Pk2*f**2 - 384*C*D1*Dd*Pk2*f*fd*r*s - 176*C*D1*Dd*Pk2*f*fd*r + 192*C*D1*Dd*Pk2*f*fd*s**2 - 240*C*D1*Dd*Pk2*f*fd*s + 116*C*D1*Dd*Pk2*f*fd - 40*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 20*C*D1*Dd*Pkdd2*f**2*k1**2*s - 10*C*D1*Dd*Pkdd2*f**2*k1**2 + 80*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 20*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 96*C*D1*Ddd*Pk2*f**2*r*s + 24*C*D1*Ddd*Pk2*f**2*r + 48*C*D1*Ddd*Pk2*f**2*s**2 + 12*C*D1*Ddd*Pk2*f**2 + 20*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 10*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 5*C*D1*Ddd*Pkdd2*f**2*k1**2 - 288*C*Dd**2*Pk2*f**2*r*s + 72*C*Dd**2*Pk2*f**2*r + 144*C*Dd**2*Pk2*f**2*s**2 - 24*C*Dd**2*Pk2*f**2 + 60*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 30*C*Dd**2*Pkdd2*f**2*k1**2*s - 172*D1**2*Pk2*f*fd*r**2 - 368*D1**2*Pk2*f*fd*r*s + 222*D1**2*Pk2*f*fd*r - 296*D1**2*Pk2*f*fd*s**2 + 314*D1**2*Pk2*f*fd*s - 176*D1**2*Pk2*f*fd + 56*D1**2*Pk2*f*fdd*r**2 + 312*D1**2*Pk2*f*fdd*r*s - 80*D1**2*Pk2*f*fdd*r + 300*D1**2*Pk2*f*fdd*s**2 - 288*D1**2*Pk2*f*fdd*s + 106*D1**2*Pk2*f*fdd + 56*D1**2*Pk2*fd**2*r**2 + 312*D1**2*Pk2*fd**2*r*s - 80*D1**2*Pk2*fd**2*r + 300*D1**2*Pk2*fd**2*s**2 - 288*D1**2*Pk2*fd**2*s + 24*D1**2*Pkdd2*f*fd*k1**2*s**2 + D1**2*bdd1*f*(6*C*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + Pk2*(2*C*(2*r**2 - 64*r*s + 30*r - 68*s**2 + 100*s - 33) + 24*r**2 + 170*r*s - 109*r + 136*s**2 - 221*s + 80)) - 344*D1*Dd*Pk2*f**2*r**2 - 736*D1*Dd*Pk2*f**2*r*s + 356*D1*Dd*Pk2*f**2*r - 592*D1*Dd*Pk2*f**2*s**2 + 480*D1*Dd*Pk2*f**2*s - 234*D1*Dd*Pk2*f**2 + 448*D1*Dd*Pk2*f*fd*r**2 + 2496*D1*Dd*Pk2*f*fd*r*s - 744*D1*Dd*Pk2*f*fd*r + 2400*D1*Dd*Pk2*f*fd*s**2 - 2064*D1*Dd*Pk2*f*fd*s + 368*D1*Dd*Pk2*f*fd + 48*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 24*D1*Dd*Pkdd2*f**2*k1**2*s + 12*D1*Dd*Pkdd2*f**2*k1**2 + 112*D1*Ddd*Pk2*f**2*r**2 + 624*D1*Ddd*Pk2*f**2*r*s - 212*D1*Ddd*Pk2*f**2*r + 600*D1*Ddd*Pk2*f**2*s**2 - 456*D1*Ddd*Pk2*f**2*s + 178*D1*Ddd*Pk2*f**2 + D1*bd1*(D1*(12*C*Pkdd2*fd*k1**2*s*(2*s - 1) + Pk2*f*(4*C*(19*r**2 + 36*r*s - 37*r + 33*s**2 - 51*s + 26) - 104*r**2 - 186*r*s + 197*r - 132*s**2 + 225*s - 118) + Pk2*fd*(r**2*(8*C + 48) + r*(-256*C*s + 60*C + 340*s - 109) + s*(-272*C*s + 200*C + 272*s - 221)) - Pkdd2*f*k1**2*(19*C - 14)*(2*s**2 - 2*s + 1)) + 2*Dd*f*(6*C*Pkdd2*k1**2*(8*s**2 - 6*s + 1) + Pk2*(2*C*(8*r**2 - 256*r*s + 90*r - 272*s**2 + 300*s - 65) + 96*r**2 + 680*r*s - 327*r + 544*s**2 - 663*s + 165))) + 336*Dd**2*Pk2*f**2*r**2 + 1872*Dd**2*Pk2*f**2*r*s - 636*Dd**2*Pk2*f**2*r + 1800*Dd**2*Pk2*f**2*s**2 - 1368*Dd**2*Pk2*f**2*s + 156*Dd**2*Pk2*f**2) + f*(-3948*C*D1**2*Pk2*f*fd*r**2 - 9504*C*D1**2*Pk2*f*fd*r*s + 5800*C*D1**2*Pk2*f*fd*r - 7128*C*D1**2*Pk2*f*fd*s**2 + 7920*C*D1**2*Pk2*f*fd*s - 3692*C*D1**2*Pk2*f*fd + 1578*C*D1**2*Pk2*f*fdd*r**2 + 9504*C*D1**2*Pk2*f*fdd*r*s - 4220*C*D1**2*Pk2*f*fdd*r + 7128*C*D1**2*Pk2*f*fdd*s**2 - 7920*C*D1**2*Pk2*f*fdd*s + 2902*C*D1**2*Pk2*f*fdd + 3156*C*D1**2*Pk2*fd**2*r**2 + 19008*C*D1**2*Pk2*fd**2*r*s - 8440*C*D1**2*Pk2*fd**2*r + 14256*C*D1**2*Pk2*fd**2*s**2 - 15840*C*D1**2*Pk2*fd**2*s + 3168*C*D1**2*Pk2*fd**2 + 495*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 330*C*D1**2*Pkdd2*f*fd*k1**2*s + 165*C*D1**2*Pkdd2*f*fd*k1**2 - 5264*C*D1*Dd*Pk2*f**2*r**2 - 12672*C*D1*Dd*Pk2*f**2*r*s + 5800*C*D1*Dd*Pk2*f**2*r - 9504*C*D1*Dd*Pk2*f**2*s**2 + 7920*C*D1*Dd*Pk2*f**2*s - 3692*C*D1*Dd*Pk2*f**2 + 12624*C*D1*Dd*Pk2*f*fd*r**2 + 76032*C*D1*Dd*Pk2*f*fd*r*s - 29540*C*D1*Dd*Pk2*f*fd*r + 57024*C*D1*Dd*Pk2*f*fd*s**2 - 55440*C*D1*Dd*Pk2*f*fd*s + 12140*C*D1*Dd*Pk2*f*fd + 660*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 330*C*D1*Dd*Pkdd2*f**2*k1**2*s + 165*C*D1*Dd*Pkdd2*f**2*k1**2 + 2104*C*D1*Ddd*Pk2*f**2*r**2 + 12672*C*D1*Ddd*Pk2*f**2*r*s - 4220*C*D1*Ddd*Pk2*f**2*r + 9504*C*D1*Ddd*Pk2*f**2*s**2 - 7920*C*D1*Ddd*Pk2*f**2*s + 2902*C*D1*Ddd*Pk2*f**2 + 6312*C*Dd**2*Pk2*f**2*r**2 + 38016*C*Dd**2*Pk2*f**2*r*s - 12660*C*Dd**2*Pk2*f**2*r + 28512*C*Dd**2*Pk2*f**2*s**2 - 23760*C*Dd**2*Pk2*f**2*s + 3168*C*Dd**2*Pk2*f**2 + 990*D1**2*Pk2*f*fd*r**2 - 2877*D1**2*Pk2*f*fd*r*s + 299*D1**2*Pk2*f*fd*r - 6534*D1**2*Pk2*f*fd*s**2 + 5315*D1**2*Pk2*f*fd*s - 1848*D1**2*Pk2*f*fd + 2577*D1**2*Pk2*f*fdd*r*s - 859*D1**2*Pk2*f*fdd*r + 6534*D1**2*Pk2*f*fdd*s**2 - 5215*D1**2*Pk2*f*fdd*s + 2178*D1**2*Pk2*f*fdd + 5154*D1**2*Pk2*fd**2*r*s - 1718*D1**2*Pk2*fd**2*r + 13068*D1**2*Pk2*fd**2*s**2 - 10430*D1**2*Pk2*fd**2*s + 859*D1**2*Pk2*fd**2 + 33*D1**2*bd1**2*(12*C*Pkdd2*k1**2*s*(s - 1) + Pk2*(4*C*(r**2 - 32*r*s + 15*r - 34*s**2 + 50*s - 16) + 24*r**2 + 170*r*s - 109*r + 136*s**2 - 221*s + 85)) - 33*D1**2*bdd1*f*(-5*C*Pkdd2*k1**2*(s - 1)**2 + 2*Pk2*(C*(12*r*s - 40*r - 6*s**2 - 30*s + 29) - 14*r**2 - 78*r*s + 66*r - 75*s**2 + 84*s - 36)) + 1320*D1*Dd*Pk2*f**2*r**2 - 3836*D1*Dd*Pk2*f**2*r*s + 299*D1*Dd*Pk2*f**2*r - 8712*D1*Dd*Pk2*f**2*s**2 + 5315*D1*Dd*Pk2*f**2*s - 1848*D1*Dd*Pk2*f**2 + 20616*D1*Dd*Pk2*f*fd*r*s - 6013*D1*Dd*Pk2*f*fd*r + 52272*D1*Dd*Pk2*f*fd*s**2 - 36505*D1*Dd*Pk2*f*fd*s + 6074*D1*Dd*Pk2*f*fd + 3436*D1*Ddd*Pk2*f**2*r*s - 859*D1*Ddd*Pk2*f**2*r + 8712*D1*Ddd*Pk2*f**2*s**2 - 5215*D1*Ddd*Pk2*f**2*s + 2178*D1*Ddd*Pk2*f**2 + 66*D1*bd1*(D1*(10*C*Pkdd2*fd*k1**2*s*(s - 1) + Pk2*f*(C*(19*r**2 + 8*r*(3*s - 5) - 7*s**2 - 28*s + 22) - 43*r**2 - 92*r*s + 67*r - 74*s**2 + 83*s - 29) + 2*Pk2*fd*(C*(-24*r*s + 26*r + 12*s**2 + 15*s - 6) + 28*r**2 + 156*r*s - 86*r + 150*s**2 - 156*s + 39) + Pkdd2*f*k1**2*(C*(-5*s**2 + 16*s - 8) + 6*(s - 1)**2)) + Dd*f*(5*C*Pkdd2*k1**2*(4*s**2 - 5*s + 1) + 2*Pk2*(C*(-48*r*s + 86*r + 24*s**2 + 60*s - 35) + 56*r**2 + 312*r*s - 185*r + 300*s**2 - 282*s + 75))) + 10308*Dd**2*Pk2*f**2*r*s - 2577*Dd**2*Pk2*f**2*r + 26136*Dd**2*Pk2*f**2*s**2 - 15645*Dd**2*Pk2*f**2*s + 859*Dd**2*Pk2*f**2))/(693*d**2*k3**2) - 2*D1**2*Pk1*ct**2*k2**2*st**4*(-132*C*D1**2*Pk2*b1*f*fd*r**2 - 132*C*D1**2*Pk2*b1*f*fdd*r**2 - 132*C*D1**2*Pk2*b1*fd**2*r**2 - 354*C*D1**2*Pk2*f**2*fd*r**2 + 236*C*D1**2*Pk2*f**2*fd*r - 118*C*D1**2*Pk2*f**2*fd + 276*C*D1**2*Pk2*f**2*fdd*r**2 - 184*C*D1**2*Pk2*f**2*fdd*r + 92*C*D1**2*Pk2*f**2*fdd + 552*C*D1**2*Pk2*f*fd**2*r**2 - 368*C*D1**2*Pk2*f*fd**2*r - 66*C*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 33*C*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 66*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 66*C*D1**2*Pkdd2*b1*f*fd*k1**2*s + 33*C*D1**2*Pkdd2*b1*f*fd*k1**2 - 90*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 60*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 30*C*D1**2*Pkdd2*f**2*fd*k1**2 + 45*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 30*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 15*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 90*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 60*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 264*C*D1*Dd*Pk2*b1*f**2*r**2 + 132*C*D1*Dd*Pk2*b1*f**2*r - 66*C*D1*Dd*Pk2*b1*f**2 - 1056*C*D1*Dd*Pk2*b1*f*fd*r**2 + 264*C*D1*Dd*Pk2*b1*f*fd*r - 472*C*D1*Dd*Pk2*f**3*r**2 + 236*C*D1*Dd*Pk2*f**3*r - 118*C*D1*Dd*Pk2*f**3 + 2208*C*D1*Dd*Pk2*f**2*fd*r**2 - 1288*C*D1*Dd*Pk2*f**2*fd*r + 184*C*D1*Dd*Pk2*f**2*fd - 264*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 132*C*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 66*C*D1*Dd*Pkdd2*b1**2*f*k1**2 + 264*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 66*C*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 132*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 66*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 33*C*D1*Dd*Pkdd2*b1*f**2*k1**2 - 120*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 60*C*D1*Dd*Pkdd2*f**3*k1**2*s - 30*C*D1*Dd*Pkdd2*f**3*k1**2 + 360*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 210*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 30*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 264*C*D1*Ddd*Pk2*b1*f**2*r**2 + 132*C*D1*Ddd*Pk2*b1*f**2*r - 66*C*D1*Ddd*Pk2*b1*f**2 + 368*C*D1*Ddd*Pk2*f**3*r**2 - 184*C*D1*Ddd*Pk2*f**3*r + 92*C*D1*Ddd*Pk2*f**3 + 132*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 66*C*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 33*C*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 60*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 30*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 15*C*D1*Ddd*Pkdd2*f**3*k1**2 - 792*C*Dd**2*Pk2*b1*f**2*r**2 + 396*C*Dd**2*Pk2*b1*f**2*r + 1104*C*Dd**2*Pk2*f**3*r**2 - 552*C*Dd**2*Pk2*f**3*r + 396*C*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 198*C*Dd**2*Pkdd2*b1**2*f*k1**2*s + 180*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 90*C*Dd**2*Pkdd2*f**3*k1**2*s + 132*D1**2*Pk2*b1*f*fd*r**2 - 264*D1**2*Pk2*b1*f*fd*r*s + 132*D1**2*Pk2*b1*f*fd*r + 132*D1**2*Pk2*b1*f*fdd*r**2 + 132*D1**2*Pk2*b1*fd**2*r**2 + 354*D1**2*Pk2*f**2*fd*r**2 - 60*D1**2*Pk2*f**2*fd*r*s - 216*D1**2*Pk2*f**2*fd*r + 20*D1**2*Pk2*f**2*fd*s + 118*D1**2*Pk2*f**2*fd - 276*D1**2*Pk2*f**2*fdd*r**2 + 30*D1**2*Pk2*f**2*fdd*r*s + 174*D1**2*Pk2*f**2*fdd*r - 10*D1**2*Pk2*f**2*fdd*s - 92*D1**2*Pk2*f**2*fdd - 552*D1**2*Pk2*f*fd**2*r**2 + 60*D1**2*Pk2*f*fd**2*r*s + 348*D1**2*Pk2*f*fd**2*r - 20*D1**2*Pk2*f*fd**2*s + 10*D1**2*Pk2*f*fd**2 + 66*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 33*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 66*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 66*D1**2*Pkdd2*b1*f*fd*k1**2*s - 33*D1**2*Pkdd2*b1*f*fd*k1**2 + 66*D1**2*Pkdd2*bd1**2*f*k1**2*s*(C - 1)*(s - 1) - 30*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 20*D1**2*Pkdd2*f**2*fd*k1**2*s - 10*D1**2*Pkdd2*f**2*fd*k1**2 + 15*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 10*D1**2*Pkdd2*f**2*fdd*k1**2*s + 5*D1**2*Pkdd2*f**2*fdd*k1**2 + 30*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 20*D1**2*Pkdd2*f*fd**2*k1**2*s - 33*D1**2*bdd1*f*(C - 1)*(2*Pk2*f*(r - 1)**2 + Pkdd2*b1*k1**2*(-2*s**2 + 2*s - 1)) + 264*D1*Dd*Pk2*b1*f**2*r**2 - 528*D1*Dd*Pk2*b1*f**2*r*s + 132*D1*Dd*Pk2*b1*f**2*s + 66*D1*Dd*Pk2*b1*f**2 + 1056*D1*Dd*Pk2*b1*f*fd*r**2 - 264*D1*Dd*Pk2*b1*f*fd*r + 472*D1*Dd*Pk2*f**3*r**2 - 80*D1*Dd*Pk2*f**3*r*s - 216*D1*Dd*Pk2*f**3*r + 20*D1*Dd*Pk2*f**3*s + 118*D1*Dd*Pk2*f**3 - 2208*D1*Dd*Pk2*f**2*fd*r**2 + 240*D1*Dd*Pk2*f**2*fd*r*s + 1218*D1*Dd*Pk2*f**2*fd*r - 70*D1*Dd*Pk2*f**2*fd*s - 164*D1*Dd*Pk2*f**2*fd + 264*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 132*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 66*D1*Dd*Pkdd2*b1**2*f*k1**2 - 264*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 66*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 132*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 66*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 33*D1*Dd*Pkdd2*b1*f**2*k1**2 - 40*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 20*D1*Dd*Pkdd2*f**3*k1**2*s - 10*D1*Dd*Pkdd2*f**3*k1**2 + 120*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 70*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 10*D1*Dd*Pkdd2*f**2*fd*k1**2 + 264*D1*Ddd*Pk2*b1*f**2*r**2 - 132*D1*Ddd*Pk2*b1*f**2*r + 66*D1*Ddd*Pk2*b1*f**2 - 368*D1*Ddd*Pk2*f**3*r**2 + 40*D1*Ddd*Pk2*f**3*r*s + 174*D1*Ddd*Pk2*f**3*r - 10*D1*Ddd*Pk2*f**3*s - 92*D1*Ddd*Pk2*f**3 - 132*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 66*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 33*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 20*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 10*D1*Ddd*Pkdd2*f**3*k1**2*s + 5*D1*Ddd*Pkdd2*f**3*k1**2 - 33*D1*bd1*(D1*(2*Pkdd2*b1*fd*k1**2*s*(-2*C*s + C + 2*s - 1) + f**2*(2*Pk2*(r - 1)*(C*(r - 1) - r + 2*s + 1) - Pkdd2*k1**2*s**2*(C - 1)) + f*(2*C - 2)*(4*Pk2*fd*r*(r - 1) + Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1))) + Dd*f*(2*C - 2)*(2*Pk2*f*(4*r**2 - 5*r + 1) + Pkdd2*b1*k1**2*(-8*s**2 + 6*s - 1))) + 792*Dd**2*Pk2*b1*f**2*r**2 - 396*Dd**2*Pk2*b1*f**2*r - 1104*Dd**2*Pk2*f**3*r**2 + 120*Dd**2*Pk2*f**3*r*s + 522*Dd**2*Pk2*f**3*r - 30*Dd**2*Pk2*f**3*s + 10*Dd**2*Pk2*f**3 - 396*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 198*Dd**2*Pkdd2*b1**2*f*k1**2*s + 60*Dd**2*Pkdd2*f**3*k1**2*s**2 - 30*Dd**2*Pkdd2*f**3*k1**2*s)/(231*d**2*k1**2*k3**2) + D1**2*Pk1*ct**2*k2**2*st**2*(11*b1**2*(D1**2*(Pk2*fd*r**2*(22*C - 22) + Pk2*fdd*r**2*(10*C - 10) + Pkdd2*fd*k1**2*s**2*(5*C + 13) - Pkdd2*fdd*k1**2*s**2*(6*C + 3)) + D1*(Dd*(Pk2*f*(22*C - 22)*(4*r**2 - 2*r + 1) + Pk2*fd*r*(20*C - 20)*(4*r - 1) + Pkdd2*f*k1**2*(5*C + 13)*(4*s**2 - 2*s + 1) - Pkdd2*fd*k1**2*s*(12*C + 6)*(4*s - 1)) + Ddd*f*(Pk2*(10*C - 10)*(4*r**2 - 2*r + 1) - Pkdd2*k1**2*(6*C + 3)*(4*s**2 - 2*s + 1))) + 6*Dd**2*f*(Pk2*r*(10*C - 10)*(2*r - 1) - Pkdd2*k1**2*s*(6*C + 3)*(2*s - 1))) + 11*b1*(92*C*D1**2*Pk2*f*fd*r**2 - 68*C*D1**2*Pk2*f*fd*r + 34*C*D1**2*Pk2*f*fd - 44*C*D1**2*Pk2*f*fdd*r**2 + 44*C*D1**2*Pk2*f*fdd*r - 22*C*D1**2*Pk2*f*fdd - 44*C*D1**2*Pk2*fd**2*r**2 + 44*C*D1**2*Pk2*fd**2*r + 14*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 12*C*D1**2*Pkdd2*f*fd*k1**2*s - 6*C*D1**2*Pkdd2*f*fd*k1**2 - 12*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 12*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 184*C*D1*Dd*Pk2*f**2*r**2 - 92*C*D1*Dd*Pk2*f**2*r + 46*C*D1*Dd*Pk2*f**2 - 352*C*D1*Dd*Pk2*f*fd*r**2 + 264*C*D1*Dd*Pk2*f*fd*r - 44*C*D1*Dd*Pk2*f*fd + 28*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 14*C*D1*Dd*Pkdd2*f**2*k1**2*s + 7*C*D1*Dd*Pkdd2*f**2*k1**2 - 96*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 24*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 88*C*D1*Ddd*Pk2*f**2*r**2 + 44*C*D1*Ddd*Pk2*f**2*r - 22*C*D1*Ddd*Pk2*f**2 - 24*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 12*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 6*C*D1*Ddd*Pkdd2*f**2*k1**2 - 264*C*Dd**2*Pk2*f**2*r**2 + 132*C*Dd**2*Pk2*f**2*r - 72*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 36*C*Dd**2*Pkdd2*f**2*k1**2*s - 104*D1**2*Pk2*f*fd*r**2 - 12*D1**2*Pk2*f*fd*r*s + 74*D1**2*Pk2*f*fd*r - 34*D1**2*Pk2*f*fd + 56*D1**2*Pk2*f*fdd*r**2 + 12*D1**2*Pk2*f*fdd*r*s - 50*D1**2*Pk2*f*fdd*r + 22*D1**2*Pk2*f*fdd + 56*D1**2*Pk2*fd**2*r**2 + 12*D1**2*Pk2*fd**2*r*s - 50*D1**2*Pk2*fd**2*r + 4*D1**2*Pkdd2*f*fd*k1**2*s**2 + 6*D1**2*Pkdd2*f*fd*k1**2*s - 3*D1**2*Pkdd2*f*fd*k1**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s**2 + D1**2*bdd1*f*(Pk2*(10*C - 10)*(2*r**2 - 2*r + 1) - Pkdd2*k1**2*(6*C + 3)*(2*s**2 - 2*s + 1)) - 208*D1*Dd*Pk2*f**2*r**2 - 24*D1*Dd*Pk2*f**2*r*s + 110*D1*Dd*Pk2*f**2*r + 6*D1*Dd*Pk2*f**2*s - 52*D1*Dd*Pk2*f**2 + 448*D1*Dd*Pk2*f*fd*r**2 + 96*D1*Dd*Pk2*f*fd*r*s - 324*D1*Dd*Pk2*f*fd*r - 12*D1*Dd*Pk2*f*fd*s + 50*D1*Dd*Pk2*f*fd + 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**2*k1**2*s + 2*D1*Dd*Pkdd2*f**2*k1**2 - 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*Pkdd2*f*fd*k1**2*s + 112*D1*Ddd*Pk2*f**2*r**2 + 24*D1*Ddd*Pk2*f**2*r*s - 62*D1*Ddd*Pk2*f**2*r - 6*D1*Ddd*Pk2*f**2*s + 28*D1*Ddd*Pk2*f**2 - 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*D1*Ddd*Pkdd2*f**2*k1**2 + D1*bd1*(D1*(Pk2*f*(22*C - 22)*(2*r**2 - 2*r + 1) + Pk2*fd*r*(20*C - 20)*(2*r - 1) + Pkdd2*f*k1**2*(5*C + 13)*(2*s**2 - 2*s + 1) - Pkdd2*fd*k1**2*s*(12*C + 6)*(2*s - 1)) + Dd*Pk2*f*(20*C - 20)*(8*r**2 - 6*r + 1) - Dd*Pkdd2*f*k1**2*(12*C + 6)*(8*s**2 - 6*s + 1)) + 336*Dd**2*Pk2*f**2*r**2 + 72*Dd**2*Pk2*f**2*r*s - 186*Dd**2*Pk2*f**2*r - 18*Dd**2*Pk2*f**2*s + 6*Dd**2*Pk2*f**2 - 36*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*Dd**2*Pkdd2*f**2*k1**2*s) + f*(420*C*D1**2*Pk2*f*fd*r**2 - 280*C*D1**2*Pk2*f*fd*r + 140*C*D1**2*Pk2*f*fd + 384*C*D1**2*Pk2*f*fdd*r**2 - 256*C*D1**2*Pk2*f*fdd*r + 128*C*D1**2*Pk2*f*fdd + 768*C*D1**2*Pk2*fd**2*r**2 - 512*C*D1**2*Pk2*fd**2*r - 198*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 132*C*D1**2*Pkdd2*f*fd*k1**2*s - 66*C*D1**2*Pkdd2*f*fd*k1**2 + 560*C*D1*Dd*Pk2*f**2*r**2 - 280*C*D1*Dd*Pk2*f**2*r + 140*C*D1*Dd*Pk2*f**2 + 3072*C*D1*Dd*Pk2*f*fd*r**2 - 1792*C*D1*Dd*Pk2*f*fd*r + 256*C*D1*Dd*Pk2*f*fd - 264*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 132*C*D1*Dd*Pkdd2*f**2*k1**2*s - 66*C*D1*Dd*Pkdd2*f**2*k1**2 + 512*C*D1*Ddd*Pk2*f**2*r**2 - 256*C*D1*Ddd*Pk2*f**2*r + 128*C*D1*Ddd*Pk2*f**2 + 1536*C*Dd**2*Pk2*f**2*r**2 - 768*C*Dd**2*Pk2*f**2*r - 978*D1**2*Pk2*f*fd*r**2 + 186*D1**2*Pk2*f*fd*r*s + 590*D1**2*Pk2*f*fd*r - 62*D1**2*Pk2*f*fd*s - 326*D1**2*Pk2*f*fd + 390*D1**2*Pk2*f*fdd*r**2 + 6*D1**2*Pk2*f*fdd*r*s - 262*D1**2*Pk2*f*fdd*r - 2*D1**2*Pk2*f*fdd*s + 130*D1**2*Pk2*f*fdd + 780*D1**2*Pk2*fd**2*r**2 + 12*D1**2*Pk2*fd**2*r*s - 524*D1**2*Pk2*fd**2*r - 4*D1**2*Pk2*fd**2*s + 2*D1**2*Pk2*fd**2 - 99*D1**2*Pkdd2*f*fd*k1**2*s**2 + 66*D1**2*Pkdd2*f*fd*k1**2*s - 33*D1**2*Pkdd2*f*fd*k1**2 + 22*D1**2*bd1**2*(Pk2*r*(10*C - 10)*(r - 1) - Pkdd2*k1**2*s*(6*C + 3)*(s - 1)) - 11*D1**2*bdd1*f*(2*Pk2*(r**2*(11*C - 14) - 3*r*(s - 2) + 3*s - 3) + Pkdd2*k1**2*(6*C + 3)*(s - 1)**2) - 1304*D1*Dd*Pk2*f**2*r**2 + 248*D1*Dd*Pk2*f**2*r*s + 590*D1*Dd*Pk2*f**2*r - 62*D1*Dd*Pk2*f**2*s - 326*D1*Dd*Pk2*f**2 + 3120*D1*Dd*Pk2*f*fd*r**2 + 48*D1*Dd*Pk2*f*fd*r*s - 1834*D1*Dd*Pk2*f*fd*r - 14*D1*Dd*Pk2*f*fd*s + 264*D1*Dd*Pk2*f*fd - 132*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 66*D1*Dd*Pkdd2*f**2*k1**2*s - 33*D1*Dd*Pkdd2*f**2*k1**2 + 520*D1*Ddd*Pk2*f**2*r**2 + 8*D1*Ddd*Pk2*f**2*r*s - 262*D1*Ddd*Pk2*f**2*r - 2*D1*Ddd*Pk2*f**2*s + 130*D1*Ddd*Pk2*f**2 + 11*D1*bd1*(D1*(2*Pk2*f*(C*(23*r**2 - 12*r + 6) - 26*r**2 - 3*r*s + 18*r + 3*s - 9) + 2*Pk2*fd*(r**2*(56 - 44*C) + r*(22*C + 12*s - 37) - 6*s + 3) + Pkdd2*f*k1**2*(C*(7*s**2 - 26*s + 13) + 2*s**2 - 10*s + 5) + Pkdd2*fd*k1**2*s*(-24*C - 12)*(s - 1)) - 2*Dd*f*(Pk2*(r**2*(88*C - 112) + r*(-22*C - 24*s + 55) + 15*s - 9) + Pkdd2*k1**2*(6*C + 3)*(4*s**2 - 5*s + 1))) + 1560*Dd**2*Pk2*f**2*r**2 + 24*Dd**2*Pk2*f**2*r*s - 786*Dd**2*Pk2*f**2*r - 6*Dd**2*Pk2*f**2*s + 2*Dd**2*Pk2*f**2))/(231*d**2*k1**2*k3**2) + 2*D1**2*Pk1*ct**2*k2**2*(D1*f*(D1*Pk2*bd1**2*(8*r**2 + 38*r*s - 27*r - 19*s + 19) + 2*D1*Pk2*bdd1*f*r*(3*C*r + 5*r + 5*s - 5) + 2*bd1*(D1*(Pk2*fd*(-6*C*r + r**2*(12*C + 20) + 20*r*(s - 1) - 5*s + 5) + f*(Pk2*r*(r*(11*C + 5) - 9*s + 9) - Pkdd2*k1**2*(3*C + 3)*(s - 1)**2)) + Dd*Pk2*f*(r**2*(24*C + 40) + r*(-6*C + 40*s - 35) - 5*s + 5))) + b1**2*(D1**2*(Pk2*fd*r*(r*(14*C + 6) - 31*s) + Pk2*fdd*r*(4*r + 19*s) - Pkdd2*fd*k1**2*s**2*(7*C + 7)) + D1*(Dd*(Pk2*fd*(32*r**2 + r*(152*s - 27) - 19*s) + f*(Pk2*(14*C*(4*r**2 - 2*r + 1) + 24*r**2 - 124*r*s + 19*r + 31*s + 6) - Pkdd2*k1**2*(7*C + 7)*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(16*r**2 + r*(76*s - 27) - 19*s + 4)) + Dd**2*Pk2*f*(48*r**2 + 3*r*(76*s - 27) - 57*s + 19)) + b1*(D1**2*Pk2*bdd1*f*(8*r**2 + r*(38*s - 27) - 19*s + 4) + 2*D1**2*(Pk2*fd**2*(r**2*(6*C + 10) - 2*r*(3*C - 5*s + 5) - 5*s) + f*(Pk2*fdd*(C*(6*r**2 - 6*r + 3) + 10*r**2 + 10*r*(s - 1) - 5*s + 5) + fd*(Pk2*(11*C*(2*r**2 - 2*r + 1) + 10*r**2 - 2*r*(9*s + 5) + 9*s + 5) + Pkdd2*k1**2*s**2*(-6*C - 6)))) + D1*bd1*(D1*(Pk2*fd*(16*r**2 + r*(76*s - 27) - 19*s) + f*(Pk2*(14*C*(2*r**2 - 2*r + 1) + 12*r**2 - 62*r*s + 19*r + 31*s + 6) - Pkdd2*k1**2*(7*C + 7)*(2*s**2 - 2*s + 1))) + 2*Dd*Pk2*f*(32*r**2 + r*(152*s - 81) - 57*s + 23)) + 2*D1*f*(Dd*(6*C*Pk2*fd*(8*r**2 - 6*r + 1) + Pk2*f*(11*C*(4*r**2 - 2*r + 1) + 20*r**2 - r*(36*s + 1) + 9*s + 5) + 5*Pk2*fd*(8*r - 3)*(2*r + 2*s - 1) - Pkdd2*f*k1**2*(3*C + 3)*(4*s**2 - 2*s + 1)) + Ddd*Pk2*f*(3*C*(4*r**2 - 2*r + 1) + 20*r**2 + 5*r*(4*s - 3) - 5*s + 5)) + 2*Dd**2*Pk2*f**2*(r**2*(36*C + 60) - 3*r*(6*C - 20*s + 15) - 15*s + 5)))/(21*d**2*k1**2*k3**2) + D1**2*Pk1*ct**2*st**4*(-858*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(K - 1) + 40*D1*Dd*f**3*(f*(71*Pk2*(4*r*s - r - s) + 15*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 3*fd*(4*s - 1)*(Pk2*(8*r - 2) + 5*Pkdd2*k1**2*(4*s - 1))) + 78*D1*bd1*(D1*(22*Pkdd2*f*k1**2*s**2*(b1*(K - 1) - g2 + gd2) + 22*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) + 5*f**3*s*(16*Pk2*(r - 1) + 3*Pkdd2*k1**2*s) - 5*f**2*fd*(8*Pk2*(r*(6*s - 1) - 3*s + 1) + 3*Pkdd2*k1**2*s*(3*s - 1))) + Dd*f*(Pkdd2*k1**2*s*(4*s - 1)*(-22*K*b1 + 22*b1 + 22*g2) - 5*f**2*(8*Pk2*(r*(8*s - 1) - 5*s + 1) + 3*Pkdd2*k1**2*s*(4*s - 1)))) + D1*f*(D1*(858*Pkdd2*bdd1*g2*k1**2*s**2 + 5*f**2*(568*Pk2*fd*(r*(4*s - 1) - s) + 120*Pkdd2*fd*k1**2*(4*s**2 - 2*s + 1) - 39*bdd1*s*(16*Pk2*(r - 1) + 3*Pkdd2*k1**2*s) - 12*fdd*(2*Pk2*r*(4*s - 1) - 2*Pk2*s + 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 120*f*fd**2*(3*Pk2*r*(4*s - 1) - 3*Pk2*s + Pk2 + 15*Pkdd2*k1**2*s*(2*s - 1))) - 60*Ddd*f**3*(2*Pk2*r*(4*s - 1) - 2*Pk2*s + 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 120*Dd**2*f**4*(3*Pk2*r*(4*s - 1) - 3*Pk2*s + Pk2 + 15*Pkdd2*k1**2*s*(2*s - 1)) + 429*Pkdd2*b1**2*k1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 39*b1*(-2*D1*Dd*(-22*Pkdd2*f*k1**2*(g2*(4*s**2 - 2*s + 1) + gd2*s*(1 - 4*s)) + 22*Pkdd2*fd*g2*k1**2*(4*s**2 - 5*s + 1) + 5*f**3*(16*Pk2*(4*r*s - r - s) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 5*f**2*fd*(8*Pk2*(24*r*s - 7*r - 3*s + 1) + 3*Pkdd2*k1**2*(12*s**2 - 7*s + 1))) + D1*(-22*D1*Pkdd2*k1**2*(s - 1)*(2*fd*(-g2*s + g2 + gd2*s) + fdd*g2*(s - 1)) - 5*D1*f**2*(2*fd - fdd)*(16*Pk2*r*(3*s - 1) + 3*Pkdd2*k1**2*(3*s**2 - 2*s + 1)) + 2*D1*f*(Pkdd2*k1**2*s**2*(11*bdd1*(K - 1) + 22*gd2 - 11*gdd2) + 5*fd**2*(16*Pk2*r*(3*s - 1) + 3*Pkdd2*k1**2*s*(3*s - 2))) - 22*Ddd*Pkdd2*f*g2*k1**2*(4*s**2 - 2*s + 1) + 5*Ddd*f**3*(16*Pk2*(r*(4*s - 1) - s) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(66*Pkdd2*g2*k1**2*s*(1 - 2*s) + 5*f**2*(8*Pk2*(12*r*s - 3*r - 3*s + 1) + 9*Pkdd2*k1**2*s*(2*s - 1)))))/(3003*d**2*k1**2) + D1**2*Pk1*ct**2*st**2*(-286*D1**2*bd1**2*(-14*Pkdd2*g2*k1**2*s*(s - 1) + 6*f**2*(Pk2*(8*r*s - 2*r - 4*s + 2) + Pkdd2*k1**2*s*(4*s - 3)) + f*(Pk2*r*(10 - 10*K)*(r - 1) + Pkdd2*k1**2*s*(5*K*s + K + 7*s - 1))) + 26*D1**2*bdd1*f*(-110*Pk2*g2*(r - 1)**2 - 33*Pkdd2*b2*k1**2*s**2 - 11*Pkdd2*g2*k1**2*(-5*s**2 - 2*s + 1) + f**2*(2*Pk2*(96*r**2 + 7*r*(23*s - 18) - 165*s + 64) - 25*Pkdd2*k1**2*(3*s**2 - 4*s + 2)) - 11*f*(Pk2*r**2*(11*K - 11) + Pkdd2*k1**2*s**2*(3*K + 3))) + 2*D1**2*(2*f**3*(Pk2*fdd*(2688*r**2 + r*(260*s - 1409) - 65*s + 672) + fd*(Pk2*(32*r**2 - 260*r*s + 49*r + 65*s + 8) - 325*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + f**2*(2*Pk2*fd**2*(8064*r**2 + r*(780*s - 4227) - 195*s + 65) + 143*Pkdd2*k1**2*s**2*(6*bd2 - 3*bdd2) - 143*gd2*(34*Pk2*r**2 + 13*Pkdd2*k1**2*s**2) + 143*gdd2*(22*Pk2*r**2 + 6*Pkdd2*k1**2*s**2)) - 143*f*(fd*(34*Pk2*g2*(2*r**2 - 2*r + 1) - 88*Pk2*gd2*r**2 + 44*Pk2*gd2*r - 6*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) + 12*Pkdd2*bd2*k1**2*s**2 - 6*Pkdd2*bd2*k1**2*s + 13*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) - 24*Pkdd2*gd2*k1**2*s**2 + 12*Pkdd2*gd2*k1**2*s) + fdd*(-22*Pk2*g2*(2*r**2 - 2*r + 1) + 3*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) - 6*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1))) + 286*fd**2*(22*Pk2*g2*r*(r - 1) - 3*Pkdd2*b2*k1**2*s*(s - 1) + 6*Pkdd2*g2*k1**2*s*(s - 1))) + 13*D1*bd1*(D1*(2*f**3*(2*Pk2*(6*r**2 - 25*r*s - 78*r + 165*s + 4) + Pkdd2*k1**2*(51*s**2 - 200*s + 100)) + f**2*(4*Pk2*fd*(576*r**2 + r*(966*s - 605) - 491*s + 163) + 22*Pk2*r*(r*(17*K - 17) + 4*s) + 100*Pkdd2*fd*k1**2*s*(7 - 9*s) + Pkdd2*k1**2*s**2*(143*K + 121)) - 22*f*(22*Pk2*fd*r*(K - 1)*(2*r - 1) + 22*Pk2*g2*(r - 1)**2 + 20*Pk2*gd2*r**2 - 20*Pk2*gd2*r - 6*Pkdd2*b2*k1**2*s**2 + 6*Pkdd2*bd2*k1**2*s**2 + 6*Pkdd2*fd*k1**2*s*(K + 1)*(2*s - 1) + Pkdd2*g2*k1**2*(3*s**2 + 4*s - 2) - 10*Pkdd2*gd2*k1**2*s**2 - 2*Pkdd2*gd2*k1**2*s) - 44*fd*(10*Pk2*g2*r*(r - 1) + 3*Pkdd2*b2*k1**2*s*(s - 1) - 5*Pkdd2*g2*k1**2*s*(s - 1))) - 4*Dd*f*(110*Pk2*g2*(4*r**2 - 5*r + 1) + 33*Pkdd2*b2*k1**2*s*(4*s - 1) + 11*Pkdd2*g2*k1**2*(-20*s**2 + s + 1) + f**2*(Pk2*(-768*r**2 - 1288*r*s + 857*r + 821*s - 291) + 25*Pkdd2*k1**2*(12*s**2 - 11*s + 2)) + 11*f*(Pk2*r*(11*K - 11)*(4*r - 1) + Pkdd2*k1**2*s*(3*K + 3)*(4*s - 1)))) + 2*D1*f*(Dd*(4*Pk2*f**2*fd*(4*r - 1)*(2688*r + 260*s - 737) + 2*f**3*(Pk2*(32*r**2 - 260*r*s + 49*r + 65*s + 8) - 325*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 143*f*(34*Pk2*g2*(4*r**2 - 2*r + 1) - 176*Pk2*gd2*r**2 + 44*Pk2*gd2*r - 6*Pkdd2*b2*k1**2*(4*s**2 - 2*s + 1) + 24*Pkdd2*bd2*k1**2*s**2 - 6*Pkdd2*bd2*k1**2*s + 13*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) - 48*Pkdd2*gd2*k1**2*s**2 + 12*Pkdd2*gd2*k1**2*s) + 286*fd*(22*Pk2*g2*(8*r**2 - 6*r + 1) - 3*Pkdd2*b2*k1**2*(8*s**2 - 6*s + 1) + 6*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1))) + Ddd*f*(2*Pk2*f**2*(2688*r**2 + r*(260*s - 1409) - 65*s + 672) + 3146*Pk2*g2*(4*r**2 - 2*r + 1) - 429*Pkdd2*b2*k1**2*(4*s**2 - 2*s + 1) + 858*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1))) + 4*Dd**2*f**2*(Pk2*f**2*(8064*r**2 + r*(780*s - 4227) - 195*s + 65) + 9438*Pk2*g2*r*(2*r - 1) + 1287*Pkdd2*b2*k1**2*s*(1 - 2*s) + 2574*Pkdd2*g2*k1**2*s*(2*s - 1)) + 143*Pkdd2*b1**3*k1**2*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(7*K*(4*s**2 - 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s - 28*s**2 + 14*s - 7) - D1*Ddd*(7*K + 6*f - 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(7*K + 6*f - 7)) + 143*b1**2*(D1**2*(22*K*Pk2*fd*r**2 + 10*K*Pk2*fdd*r**2 + 3*K*Pkdd2*fd*k1**2*s**2 - 10*K*Pkdd2*fd*k1**2*s + 5*K*Pkdd2*fd*k1**2 - 5*K*Pkdd2*fdd*k1**2*s**2 + 12*K*Pkdd2*fdd*k1**2*s - 6*K*Pkdd2*fdd*k1**2 + 192*Pk2*f*fd*r*s - 48*Pk2*f*fd*r - 96*Pk2*f*fdd*r*s + 24*Pk2*f*fdd*r - 96*Pk2*fd**2*r*s + 24*Pk2*fd**2*r - 22*Pk2*fd*r**2 + 56*Pk2*fd*r*s - 56*Pk2*fd*r - 10*Pk2*fdd*r**2 + 2*Pkdd2*bd1*k1**2*(7*K*(3*s**2 - 2*s + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s - 21*s**2 + 14*s - 7) - Pkdd2*bdd1*k1**2*(7*K + 6*f - 7)*(3*s**2 - 2*s + 1) + 84*Pkdd2*f*fd*k1**2*s**2 - 12*Pkdd2*f*fd*k1**2*s + 6*Pkdd2*f*fd*k1**2 - 48*Pkdd2*f*fdd*k1**2*s**2 + 12*Pkdd2*f*fdd*k1**2*s - 6*Pkdd2*f*fdd*k1**2 - 48*Pkdd2*fd**2*k1**2*s**2 + 12*Pkdd2*fd**2*k1**2*s + 21*Pkdd2*fd*k1**2*s**2 - 38*Pkdd2*fd*k1**2*s + 19*Pkdd2*fd*k1**2 - 7*Pkdd2*fdd*k1**2*s**2 + 12*Pkdd2*fdd*k1**2*s - 6*Pkdd2*fdd*k1**2 - 28*Pkdd2*gd2*k1**2*s**2 + 14*Pkdd2*gdd2*k1**2*s**2) + D1*(Dd*(-14*Pkdd2*bd1*k1**2*(K - 1)*(12*s**2 - 7*s + 1) - 28*Pkdd2*k1**2*(g2*(4*s**2 - 2*s + 1) + gd2*s*(1 - 4*s)) + 6*f**2*(16*Pk2*(r*(4*s - 1) - s) + 7*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - f*(2*Pk2*(-11*K*(4*r**2 - 2*r + 1) + 12*fd*(8*r - 1)*(4*s - 1) + 44*r**2 - 112*r*s + 6*r + 28*s + 11) + 3*Pkdd2*k1**2*(4*bd1*(12*s**2 - 7*s + 1) + 4*fd*(32*s**2 - 12*s + 1) - (K + 7)*(4*s**2 - 2*s + 1))) - 2*fd*(Pk2*r*(10 - 10*K)*(4*r - 1) + Pkdd2*k1**2*(4*s - 1)*(K*(5*s - 6) + 7*s - 6))) + Ddd*(14*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) - 24*f**2*(2*Pk2*r*(4*s - 1) - 2*Pk2*s + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(Pk2*(10*K - 10)*(4*r**2 - 2*r + 1) - Pkdd2*k1**2*(5*K + 7)*(4*s**2 - 2*s + 1)))) - 6*Dd**2*(14*Pkdd2*g2*k1**2*s*(1 - 2*s) + 8*f**2*(3*Pk2*r*(4*s - 1) - 3*Pk2*s + Pk2 + 3*Pkdd2*k1**2*s*(2*s - 1)) + f*(Pk2*r*(10 - 10*K)*(2*r - 1) + Pkdd2*k1**2*s*(5*K + 7)*(2*s - 1)))) - 13*b1*(-748*D1**2*K*Pk2*f*fd*r**2 + 748*D1**2*K*Pk2*f*fd*r - 374*D1**2*K*Pk2*f*fd + 484*D1**2*K*Pk2*f*fdd*r**2 - 484*D1**2*K*Pk2*f*fdd*r + 242*D1**2*K*Pk2*f*fdd + 484*D1**2*K*Pk2*fd**2*r**2 - 484*D1**2*K*Pk2*fd**2*r - 286*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 286*D1**2*K*Pkdd2*f*fd*k1**2*s - 143*D1**2*K*Pkdd2*f*fd*k1**2 + 132*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 132*D1**2*K*Pkdd2*f*fdd*k1**2*s + 66*D1**2*K*Pkdd2*f*fdd*k1**2 + 132*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 132*D1**2*K*Pkdd2*fd**2*k1**2*s - 72*D1**2*Pk2*f**2*fd*r**2 + 300*D1**2*Pk2*f**2*fd*r*s - 364*D1**2*Pk2*f**2*fd*r + 560*D1**2*Pk2*f**2*fd*s - 8*D1**2*Pk2*f**2*fd - 1152*D1**2*Pk2*f**2*fdd*r**2 - 1932*D1**2*Pk2*f**2*fdd*r*s + 908*D1**2*Pk2*f**2*fdd*r - 16*D1**2*Pk2*f**2*fdd*s - 128*D1**2*Pk2*f**2*fdd - 2304*D1**2*Pk2*f*fd**2*r**2 - 3864*D1**2*Pk2*f*fd**2*r*s + 1816*D1**2*Pk2*f*fd**2*r - 32*D1**2*Pk2*f*fd**2*s + 8*D1**2*Pk2*f*fd**2 + 748*D1**2*Pk2*f*fd*r**2 - 176*D1**2*Pk2*f*fd*r*s - 660*D1**2*Pk2*f*fd*r + 88*D1**2*Pk2*f*fd*s + 374*D1**2*Pk2*f*fd - 484*D1**2*Pk2*f*fdd*r**2 + 484*D1**2*Pk2*f*fdd*r - 242*D1**2*Pk2*f*fdd + 484*D1**2*Pk2*f*gd2*r**2 + 220*D1**2*Pk2*f*gdd2*r**2 - 484*D1**2*Pk2*fd**2*r**2 + 484*D1**2*Pk2*fd**2*r + 484*D1**2*Pk2*fd*g2*r**2 + 440*D1**2*Pk2*fd*gd2*r**2 + 220*D1**2*Pk2*fdd*g2*r**2 - 132*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 264*D1**2*Pkdd2*b2*fd*k1**2*s - 132*D1**2*Pkdd2*b2*fd*k1**2 + 66*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 132*D1**2*Pkdd2*b2*fdd*k1**2*s + 66*D1**2*Pkdd2*b2*fdd*k1**2 + 22*D1**2*Pkdd2*bd1**2*k1**2*s*(3*s - 2)*(7*K + 6*f - 7) - 132*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 132*D1**2*Pkdd2*bd2*fd*k1**2*s**2 - 132*D1**2*Pkdd2*bd2*fd*k1**2*s + 66*D1**2*Pkdd2*bdd2*f*k1**2*s**2 - 306*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 196*D1**2*Pkdd2*f**2*fd*k1**2*s + 98*D1**2*Pkdd2*f**2*fd*k1**2 + 450*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 100*D1**2*Pkdd2*f**2*fdd*k1**2*s + 50*D1**2*Pkdd2*f**2*fdd*k1**2 + 900*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 200*D1**2*Pkdd2*f*fd**2*k1**2*s - 242*D1**2*Pkdd2*f*fd*k1**2*s**2 + 242*D1**2*Pkdd2*f*fd*k1**2*s - 121*D1**2*Pkdd2*f*fd*k1**2 + 132*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 132*D1**2*Pkdd2*f*fdd*k1**2*s + 66*D1**2*Pkdd2*f*fdd*k1**2 + 66*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 110*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 132*D1**2*Pkdd2*fd**2*k1**2*s**2 - 132*D1**2*Pkdd2*fd**2*k1**2*s + 66*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 220*D1**2*Pkdd2*fd*g2*k1**2*s + 110*D1**2*Pkdd2*fd*g2*k1**2 - 220*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 264*D1**2*Pkdd2*fd*gd2*k1**2*s - 110*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + 264*D1**2*Pkdd2*fdd*g2*k1**2*s - 132*D1**2*Pkdd2*fdd*g2*k1**2 + 11*D1**2*bdd1*(-14*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 6*f**2*(4*Pk2*r*(4*s - 1) - 8*Pk2*s + Pkdd2*k1**2*(8*s**2 - 6*s + 3)) + f*(Pk2*(10 - 10*K)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(K*(10*s**2 + 2*s - 1) + 14*s**2 - 2*s + 1))) - 1496*D1*Dd*K*Pk2*f**2*r**2 + 748*D1*Dd*K*Pk2*f**2*r - 374*D1*Dd*K*Pk2*f**2 + 3872*D1*Dd*K*Pk2*f*fd*r**2 - 2904*D1*Dd*K*Pk2*f*fd*r + 484*D1*Dd*K*Pk2*f*fd - 572*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 286*D1*Dd*K*Pkdd2*f**2*k1**2*s - 143*D1*Dd*K*Pkdd2*f**2*k1**2 + 1056*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 792*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 132*D1*Dd*K*Pkdd2*f*fd*k1**2 - 96*D1*Dd*Pk2*f**3*r**2 + 400*D1*Dd*Pk2*f**3*r*s - 52*D1*Dd*Pk2*f**3*r - 100*D1*Dd*Pk2*f**3*s - 24*D1*Dd*Pk2*f**3 - 9216*D1*Dd*Pk2*f**2*fd*r**2 - 15456*D1*Dd*Pk2*f**2*fd*r*s + 7868*D1*Dd*Pk2*f**2*fd*r + 1868*D1*Dd*Pk2*f**2*fd*s - 892*D1*Dd*Pk2*f**2*fd + 1496*D1*Dd*Pk2*f**2*r**2 - 352*D1*Dd*Pk2*f**2*r*s - 660*D1*Dd*Pk2*f**2*r + 88*D1*Dd*Pk2*f**2*s + 374*D1*Dd*Pk2*f**2 - 3872*D1*Dd*Pk2*f*fd*r**2 + 2904*D1*Dd*Pk2*f*fd*r - 484*D1*Dd*Pk2*f*fd + 1936*D1*Dd*Pk2*f*g2*r**2 - 968*D1*Dd*Pk2*f*g2*r + 484*D1*Dd*Pk2*f*g2 + 1760*D1*Dd*Pk2*f*gd2*r**2 - 440*D1*Dd*Pk2*f*gd2*r + 1760*D1*Dd*Pk2*fd*g2*r**2 - 440*D1*Dd*Pk2*fd*g2*r - 528*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 264*D1*Dd*Pkdd2*b2*f*k1**2*s - 132*D1*Dd*Pkdd2*b2*f*k1**2 + 528*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 660*D1*Dd*Pkdd2*b2*fd*k1**2*s + 132*D1*Dd*Pkdd2*b2*fd*k1**2 + 528*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 132*D1*Dd*Pkdd2*bd2*f*k1**2*s - 408*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 204*D1*Dd*Pkdd2*f**3*k1**2*s - 102*D1*Dd*Pkdd2*f**3*k1**2 + 3600*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 1300*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 100*D1*Dd*Pkdd2*f**2*fd*k1**2 - 484*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 242*D1*Dd*Pkdd2*f**2*k1**2*s - 121*D1*Dd*Pkdd2*f**2*k1**2 + 1056*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 792*D1*Dd*Pkdd2*f*fd*k1**2*s + 132*D1*Dd*Pkdd2*f*fd*k1**2 + 264*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 132*D1*Dd*Pkdd2*f*g2*k1**2*s + 66*D1*Dd*Pkdd2*f*g2*k1**2 - 880*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 220*D1*Dd*Pkdd2*f*gd2*k1**2*s - 880*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 1276*D1*Dd*Pkdd2*fd*g2*k1**2*s - 264*D1*Dd*Pkdd2*fd*g2*k1**2 + 968*D1*Ddd*K*Pk2*f**2*r**2 - 484*D1*Ddd*K*Pk2*f**2*r + 242*D1*Ddd*K*Pk2*f**2 + 264*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 132*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 66*D1*Ddd*K*Pkdd2*f**2*k1**2 - 1536*D1*Ddd*Pk2*f**3*r**2 - 2576*D1*Ddd*Pk2*f**3*r*s + 1412*D1*Ddd*Pk2*f**3*r + 644*D1*Ddd*Pk2*f**3*s - 384*D1*Ddd*Pk2*f**3 - 968*D1*Ddd*Pk2*f**2*r**2 + 484*D1*Ddd*Pk2*f**2*r - 242*D1*Ddd*Pk2*f**2 + 880*D1*Ddd*Pk2*f*g2*r**2 - 440*D1*Ddd*Pk2*f*g2*r + 220*D1*Ddd*Pk2*f*g2 + 264*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 132*D1*Ddd*Pkdd2*b2*f*k1**2*s + 66*D1*Ddd*Pkdd2*b2*f*k1**2 + 600*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 300*D1*Ddd*Pkdd2*f**3*k1**2*s + 150*D1*Ddd*Pkdd2*f**3*k1**2 + 264*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 132*D1*Ddd*Pkdd2*f**2*k1**2*s + 66*D1*Ddd*Pkdd2*f**2*k1**2 - 440*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 220*D1*Ddd*Pkdd2*f*g2*k1**2*s - 110*D1*Ddd*Pkdd2*f*g2*k1**2 - 22*D1*bd1*(D1*(20*K*Pk2*fd*r**2 - 10*K*Pk2*fd*r - 10*K*Pkdd2*fd*k1**2*s**2 + 11*K*Pkdd2*fd*k1**2*s - 20*Pk2*fd*r**2 + 10*Pk2*fd*r - 14*Pkdd2*fd*k1**2*s**2 + 13*Pkdd2*fd*k1**2*s - 14*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 28*Pkdd2*gd2*k1**2*s**2 - 14*Pkdd2*gd2*k1**2*s + 6*f**2*(4*Pk2*r*(4*s - 1) - 8*Pk2*s + Pkdd2*k1**2*(7*s**2 - 6*s + 3)) + f*(Pk2*(11*K*(2*r**2 - 2*r + 1) - 12*fd*(4*r - 1)*(4*s - 1) - 22*r**2 + 56*r*s + 22*r - 28*s - 11) + Pkdd2*k1**2*(K*(3*s**2 + 2*s - 1) + s**2*(21 - 96*fd) + s*(48*fd - 2) + 1))) + Dd*(14*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) - 6*f**2*(4*s - 1)*(2*Pk2*(8*r - 3) + Pkdd2*k1**2*(8*s - 3)) + f*(Pk2*(10*K - 10)*(8*r**2 - 6*r + 1) - Pkdd2*k1**2*(4*s - 1)*(10*K*s + K + 14*s - 1)))) + 2904*Dd**2*K*Pk2*f**2*r**2 - 1452*Dd**2*K*Pk2*f**2*r + 792*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 396*Dd**2*K*Pkdd2*f**2*k1**2*s - 4608*Dd**2*Pk2*f**3*r**2 - 7728*Dd**2*Pk2*f**3*r*s + 4236*Dd**2*Pk2*f**3*r + 1932*Dd**2*Pk2*f**3*s - 644*Dd**2*Pk2*f**3 - 2904*Dd**2*Pk2*f**2*r**2 + 1452*Dd**2*Pk2*f**2*r + 2640*Dd**2*Pk2*f*g2*r**2 - 1320*Dd**2*Pk2*f*g2*r + 792*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 396*Dd**2*Pkdd2*b2*f*k1**2*s + 1800*Dd**2*Pkdd2*f**3*k1**2*s**2 - 900*Dd**2*Pkdd2*f**3*k1**2*s + 792*Dd**2*Pkdd2*f**2*k1**2*s**2 - 396*Dd**2*Pkdd2*f**2*k1**2*s - 1320*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 660*Dd**2*Pkdd2*f*g2*k1**2*s))/(6006*d**2*k1**2) + D1**2*Pk1*ct**2*(22*D1**2*bd1**2*(-28*Pk2*g2*r*(r - 1) - 7*Pkdd2*b2*k1**2*s*(s - 1) + 14*Pkdd2*g2*k1**2*s*(s - 1) + f**2*(3*Pk2*(8*r**2 + 20*r*s - 11*r - 10*s + 5) - 5*Pkdd2*k1**2*s*(s - 1)) + f*(Pk2*(r**2*(24 - 24*K) + 38*r*s - 19*s) + Pkdd2*k1**2*s*(-6*K - 6)*(s - 1))) + 2*D1**2*(6*Pk2*bdd1*f**3*r*(17*r + 22*s - 11) - 132*Pk2*fd**2*g2*r*(r - 1) + 11*f**2*(Pk2*bdd1*r*(r*(3*K + 3) + 10*s) + 3*Pk2*bdd2*r**2 - 22*Pk2*gd2*r**2 - 6*Pk2*gdd2*r**2 + 6*Pkdd2*gd2*k1**2*s**2 + bd2*(5*Pk2*r**2 - 3*Pkdd2*k1**2*s**2)) - 22*f*(3*Pk2*fdd*g2*(2*r**2 - 2*r + 1) - 3*bdd1*g2*(4*Pk2*r**2 + Pkdd2*k1**2*(s - 1)**2) + fd*(11*Pk2*g2*(2*r**2 - 2*r + 1) + Pk2*r*(-3*bd2 + 6*gd2)*(2*r - 1) - 3*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1)))) + D1*bd1*(D1*(f**3*(12*Pk2*r*(43*r - 22*s + 11) - 55*Pkdd2*k1**2*(3*s**2 - 4*s + 2)) + 2*f**2*(6*Pk2*fd*(102*r**2 + 6*r*(22*s - 13) - 22*s + 11) - 11*Pk2*r*(-11*K*r + r + 6*s) - 11*Pkdd2*k1**2*s**2*(3*K + 3)) + 11*f*(4*Pk2*fd*(r**2*(6*K + 6) + r*(-3*K + 20*s - 8) - 5*s) + 4*Pk2*g2*(11*r**2 + 14*r - 7) + 96*Pk2*gd2*r**2 + Pkdd2*b2*k1**2*(5*s**2 - 24*s + 12) - 12*Pkdd2*bd2*k1**2*s*(s - 1) - 2*Pkdd2*g2*k1**2*(12*s**2 - 38*s + 19) + 24*Pkdd2*gd2*k1**2*s*(s - 1)) + 132*fd*(8*Pk2*g2*r*(r - 1) - Pkdd2*b2*k1**2*s*(s - 1) + 2*Pkdd2*g2*k1**2*s*(s - 1))) + 4*Dd*f*(3*Pk2*f**2*(136*r**2 + 4*r*(44*s - 25) - 22*s + 11) + 11*Pk2*f*(r**2*(12*K + 12) + r*(-3*K + 40*s - 8) - 5*s) - 33*Pkdd2*b2*k1**2*(4*s**2 - 5*s + 1) + 66*g2*(4*Pk2*r*(4*r - 1) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 44*D1*f*(6*Dd*Pk2*fd*g2*(8*r**2 - 6*r + 1) + Dd*f*(11*Pk2*g2*(4*r**2 - 2*r + 1) + Pk2*r*(-3*bd2 + 6*gd2)*(4*r - 1) - 3*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1)) + 3*Ddd*Pk2*f*g2*(4*r**2 - 2*r + 1)) + 792*Dd**2*Pk2*f**2*g2*r*(1 - 2*r) + 11*b1**3*(D1**2*Pkdd2*k1**2*s**2*(5*fd - 6*fdd) + D1*(-28*Dd*Pk2*(K - 1)*(4*r**2 - 2*r + 1) + Dd*Pkdd2*k1**2*(14*K*(4*s**2 - 2*s + 1) + 5*f*(4*s**2 - 2*s + 1) - s**2*(48*fd - 56) + s*(12*fd - 28) + 14) + 14*Ddd*Pk2*(K - 1)*(4*r**2 - 2*r + 1) - Ddd*Pkdd2*k1**2*(7*K + 6*f + 7)*(4*s**2 - 2*s + 1)) + 6*Dd**2*(Pk2*r*(14*K - 14)*(2*r - 1) - Pkdd2*k1**2*s*(2*s - 1)*(7*K + 6*f + 7))) - 11*b1**2*(22*D1**2*K*Pk2*fd*r**2 - 72*D1**2*K*Pk2*fd*r + 36*D1**2*K*Pk2*fd + 24*D1**2*K*Pk2*fdd*r**2 - 48*D1**2*K*Pk2*fdd*r + 24*D1**2*K*Pk2*fdd - 12*D1**2*K*Pkdd2*fd*k1**2*s**2 - 14*D1**2*K*Pkdd2*fd*k1**2*s + 7*D1**2*K*Pkdd2*fd*k1**2 + 6*D1**2*K*Pkdd2*fdd*k1**2*s**2 - 80*D1**2*Pk2*f*fd*r**2 + 120*D1**2*Pk2*f*fd*r*s - 10*D1**2*Pk2*f*fd*r - 10*D1**2*Pk2*f*fd - 48*D1**2*Pk2*f*fdd*r**2 - 120*D1**2*Pk2*f*fdd*r*s + 42*D1**2*Pk2*f*fdd*r - 6*D1**2*Pk2*f*fdd - 48*D1**2*Pk2*fd**2*r**2 - 120*D1**2*Pk2*fd**2*r*s + 42*D1**2*Pk2*fd**2*r - 22*D1**2*Pk2*fd*r**2 + 34*D1**2*Pk2*fd*r*s + 38*D1**2*Pk2*fd*r - 36*D1**2*Pk2*fd - 24*D1**2*Pk2*fdd*r**2 - 38*D1**2*Pk2*fdd*r*s + 86*D1**2*Pk2*fdd*r - 24*D1**2*Pk2*fdd - 56*D1**2*Pk2*gd2*r**2 + 28*D1**2*Pk2*gdd2*r**2 - 14*D1**2*Pkdd2*bd2*k1**2*s**2 + 7*D1**2*Pkdd2*bdd2*k1**2*s**2 + 28*D1**2*Pkdd2*f*fd*k1**2*s**2 - 12*D1**2*Pkdd2*f*fd*k1**2*s + 6*D1**2*Pkdd2*f*fd*k1**2 + 10*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 10*D1**2*Pkdd2*fd**2*k1**2*s**2 + 2*D1**2*Pkdd2*fd*k1**2*s**2 - 14*D1**2*Pkdd2*fd*k1**2*s + 7*D1**2*Pkdd2*fd*k1**2 + 6*D1**2*Pkdd2*fdd*k1**2*s**2 + 28*D1**2*Pkdd2*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*gdd2*k1**2*s**2 + D1**2*bdd1*(Pk2*(14 - 14*K)*(3*r**2 - 2*r + 1) + Pkdd2*k1**2*(7*K + 6*f + 7)*(3*s**2 - 2*s + 1)) + 88*D1*Dd*K*Pk2*f*r**2 - 44*D1*Dd*K*Pk2*f*r + 22*D1*Dd*K*Pk2*f + 192*D1*Dd*K*Pk2*fd*r**2 - 240*D1*Dd*K*Pk2*fd*r + 48*D1*Dd*K*Pk2*fd - 48*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 24*D1*Dd*K*Pkdd2*f*k1**2*s - 12*D1*Dd*K*Pkdd2*f*k1**2 + 48*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 12*D1*Dd*K*Pkdd2*fd*k1**2*s - 160*D1*Dd*Pk2*f**2*r**2 + 240*D1*Dd*Pk2*f**2*r*s + 20*D1*Dd*Pk2*f**2*r - 60*D1*Dd*Pk2*f**2*s - 40*D1*Dd*Pk2*f**2 - 384*D1*Dd*Pk2*f*fd*r**2 - 960*D1*Dd*Pk2*f*fd*r*s + 384*D1*Dd*Pk2*f*fd*r + 120*D1*Dd*Pk2*f*fd*s - 42*D1*Dd*Pk2*f*fd - 88*D1*Dd*Pk2*f*r**2 + 136*D1*Dd*Pk2*f*r*s + 10*D1*Dd*Pk2*f*r - 34*D1*Dd*Pk2*f*s - 22*D1*Dd*Pk2*f - 192*D1*Dd*Pk2*fd*r**2 - 304*D1*Dd*Pk2*fd*r*s + 430*D1*Dd*Pk2*fd*r + 38*D1*Dd*Pk2*fd*s - 86*D1*Dd*Pk2*fd - 224*D1*Dd*Pk2*g2*r**2 + 112*D1*Dd*Pk2*g2*r - 56*D1*Dd*Pk2*g2 + 224*D1*Dd*Pk2*gd2*r**2 - 56*D1*Dd*Pk2*gd2*r - 56*D1*Dd*Pkdd2*b2*k1**2*s**2 + 28*D1*Dd*Pkdd2*b2*k1**2*s - 14*D1*Dd*Pkdd2*b2*k1**2 + 56*D1*Dd*Pkdd2*bd2*k1**2*s**2 - 14*D1*Dd*Pkdd2*bd2*k1**2*s + 56*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 28*D1*Dd*Pkdd2*f**2*k1**2*s + 14*D1*Dd*Pkdd2*f**2*k1**2 + 80*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 20*D1*Dd*Pkdd2*f*fd*k1**2*s + 8*D1*Dd*Pkdd2*f*k1**2*s**2 - 4*D1*Dd*Pkdd2*f*k1**2*s + 2*D1*Dd*Pkdd2*f*k1**2 + 48*D1*Dd*Pkdd2*fd*k1**2*s**2 - 12*D1*Dd*Pkdd2*fd*k1**2*s + 112*D1*Dd*Pkdd2*g2*k1**2*s**2 - 56*D1*Dd*Pkdd2*g2*k1**2*s + 28*D1*Dd*Pkdd2*g2*k1**2 - 112*D1*Dd*Pkdd2*gd2*k1**2*s**2 + 28*D1*Dd*Pkdd2*gd2*k1**2*s + 96*D1*Ddd*K*Pk2*f*r**2 - 48*D1*Ddd*K*Pk2*f*r + 24*D1*Ddd*K*Pk2*f + 24*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 12*D1*Ddd*K*Pkdd2*f*k1**2*s + 6*D1*Ddd*K*Pkdd2*f*k1**2 - 96*D1*Ddd*Pk2*f**2*r**2 - 240*D1*Ddd*Pk2*f**2*r*s + 108*D1*Ddd*Pk2*f**2*r + 60*D1*Ddd*Pk2*f**2*s - 24*D1*Ddd*Pk2*f**2 - 96*D1*Ddd*Pk2*f*r**2 - 152*D1*Ddd*Pk2*f*r*s + 86*D1*Ddd*Pk2*f*r + 38*D1*Ddd*Pk2*f*s - 24*D1*Ddd*Pk2*f + 112*D1*Ddd*Pk2*g2*r**2 - 56*D1*Ddd*Pk2*g2*r + 28*D1*Ddd*Pk2*g2 + 28*D1*Ddd*Pkdd2*b2*k1**2*s**2 - 14*D1*Ddd*Pkdd2*b2*k1**2*s + 7*D1*Ddd*Pkdd2*b2*k1**2 + 20*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 10*D1*Ddd*Pkdd2*f**2*k1**2*s + 5*D1*Ddd*Pkdd2*f**2*k1**2 + 24*D1*Ddd*Pkdd2*f*k1**2*s**2 - 12*D1*Ddd*Pkdd2*f*k1**2*s + 6*D1*Ddd*Pkdd2*f*k1**2 - 56*D1*Ddd*Pkdd2*g2*k1**2*s**2 + 28*D1*Ddd*Pkdd2*g2*k1**2*s - 14*D1*Ddd*Pkdd2*g2*k1**2 + D1*bd1*(28*D1*Pk2*(K - 1)*(3*r**2 - 2*r + 1) - D1*Pkdd2*k1**2*(14*K*(3*s**2 - 2*s + 1) + 5*f*(3*s**2 - 2*s + 1) - s**2*(36*fd - 42) + s*(12*fd - 28) + 14) - 28*Dd*Pk2*(K - 1)*(12*r**2 - 7*r + 1) + 2*Dd*Pkdd2*k1**2*(7*K + 6*f + 7)*(12*s**2 - 7*s + 1)) + 288*Dd**2*K*Pk2*f*r**2 - 144*Dd**2*K*Pk2*f*r + 72*Dd**2*K*Pkdd2*f*k1**2*s**2 - 36*Dd**2*K*Pkdd2*f*k1**2*s - 288*Dd**2*Pk2*f**2*r**2 - 720*Dd**2*Pk2*f**2*r*s + 324*Dd**2*Pk2*f**2*r + 180*Dd**2*Pk2*f**2*s - 60*Dd**2*Pk2*f**2 - 288*Dd**2*Pk2*f*r**2 - 456*Dd**2*Pk2*f*r*s + 258*Dd**2*Pk2*f*r + 114*Dd**2*Pk2*f*s - 38*Dd**2*Pk2*f + 336*Dd**2*Pk2*g2*r**2 - 168*Dd**2*Pk2*g2*r + 84*Dd**2*Pkdd2*b2*k1**2*s**2 - 42*Dd**2*Pkdd2*b2*k1**2*s + 60*Dd**2*Pkdd2*f**2*k1**2*s**2 - 30*Dd**2*Pkdd2*f**2*k1**2*s + 72*Dd**2*Pkdd2*f*k1**2*s**2 - 36*Dd**2*Pkdd2*f*k1**2*s - 168*Dd**2*Pkdd2*g2*k1**2*s**2 + 84*Dd**2*Pkdd2*g2*k1**2*s) + b1*(484*D1**2*K*Pk2*f*fd*r**2 - 484*D1**2*K*Pk2*f*fd*r + 242*D1**2*K*Pk2*f*fd + 132*D1**2*K*Pk2*f*fdd*r**2 - 132*D1**2*K*Pk2*f*fdd*r + 66*D1**2*K*Pk2*f*fdd + 132*D1**2*K*Pk2*fd**2*r**2 - 132*D1**2*K*Pk2*fd**2*r - 132*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 132*D1**2*K*Pkdd2*f*fd*k1**2*s - 66*D1**2*K*Pkdd2*f*fd*k1**2 + 1548*D1**2*Pk2*f**2*fd*r**2 - 792*D1**2*Pk2*f**2*fd*r*s - 900*D1**2*Pk2*f**2*fd*r + 264*D1**2*Pk2*f**2*fd*s + 516*D1**2*Pk2*f**2*fd + 612*D1**2*Pk2*f**2*fdd*r**2 + 792*D1**2*Pk2*f**2*fdd*r*s - 540*D1**2*Pk2*f**2*fdd*r - 264*D1**2*Pk2*f**2*fdd*s + 204*D1**2*Pk2*f**2*fdd + 1224*D1**2*Pk2*f*fd**2*r**2 + 1584*D1**2*Pk2*f*fd**2*r*s - 1080*D1**2*Pk2*f*fd**2*r - 528*D1**2*Pk2*f*fd**2*s + 132*D1**2*Pk2*f*fd**2 - 44*D1**2*Pk2*f*fd*r**2 - 264*D1**2*Pk2*f*fd*r*s + 176*D1**2*Pk2*f*fd*r + 132*D1**2*Pk2*f*fd*s - 22*D1**2*Pk2*f*fd + 132*D1**2*Pk2*f*fdd*r**2 + 440*D1**2*Pk2*f*fdd*r*s - 352*D1**2*Pk2*f*fdd*r - 220*D1**2*Pk2*f*fdd*s + 66*D1**2*Pk2*f*fdd + 484*D1**2*Pk2*f*gd2*r**2 + 528*D1**2*Pk2*f*gdd2*r**2 + 132*D1**2*Pk2*fd**2*r**2 + 440*D1**2*Pk2*fd**2*r*s - 352*D1**2*Pk2*fd**2*r - 220*D1**2*Pk2*fd**2*s + 220*D1**2*Pk2*fd**2 + 484*D1**2*Pk2*fd*g2*r**2 - 1584*D1**2*Pk2*fd*g2*r + 792*D1**2*Pk2*fd*g2 + 1056*D1**2*Pk2*fd*gd2*r**2 - 1056*D1**2*Pk2*fd*gd2*r + 528*D1**2*Pk2*fdd*g2*r**2 - 1056*D1**2*Pk2*fdd*g2*r + 528*D1**2*Pk2*fdd*g2 + 55*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 154*D1**2*Pkdd2*b2*fd*k1**2*s - 77*D1**2*Pkdd2*b2*fd*k1**2 - 66*D1**2*Pkdd2*b2*fdd*k1**2*s**2 + 55*D1**2*Pkdd2*bd2*f*k1**2*s**2 - 132*D1**2*Pkdd2*bd2*fd*k1**2*s**2 - 66*D1**2*Pkdd2*bdd2*f*k1**2*s**2 - 495*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 110*D1**2*Pkdd2*f**2*fd*k1**2*s - 55*D1**2*Pkdd2*f**2*fd*k1**2 - 132*D1**2*Pkdd2*f*fd*k1**2*s**2 + 132*D1**2*Pkdd2*f*fd*k1**2*s - 66*D1**2*Pkdd2*f*fd*k1**2 - 264*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 132*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 264*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 308*D1**2*Pkdd2*fd*g2*k1**2*s + 154*D1**2*Pkdd2*fd*g2*k1**2 + 264*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 132*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + 22*D1**2*bd1**2*(Pk2*r*(14*K - 14)*(3*r - 2) - Pkdd2*k1**2*s*(3*s - 2)*(7*K + 6*f + 7)) + 11*D1**2*bdd1*(-7*Pk2*g2*(8*r**2 - 8*r + 4) - 7*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) + 14*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + f**2*(6*Pk2*(8*r**2 + 20*r*s - 11*r - 10*s + 3) - 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - 2*f*(Pk2*(r**2*(24*K - 24) - 38*r*s + 19*s) + Pkdd2*k1**2*(3*K + 3)*(2*s**2 - 2*s + 1))) + 968*D1*Dd*K*Pk2*f**2*r**2 - 484*D1*Dd*K*Pk2*f**2*r + 242*D1*Dd*K*Pk2*f**2 + 1056*D1*Dd*K*Pk2*f*fd*r**2 - 792*D1*Dd*K*Pk2*f*fd*r + 132*D1*Dd*K*Pk2*f*fd - 264*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 132*D1*Dd*K*Pkdd2*f**2*k1**2*s - 66*D1*Dd*K*Pkdd2*f**2*k1**2 + 2064*D1*Dd*Pk2*f**3*r**2 - 1056*D1*Dd*Pk2*f**3*r*s - 768*D1*Dd*Pk2*f**3*r + 264*D1*Dd*Pk2*f**3*s + 516*D1*Dd*Pk2*f**3 + 4896*D1*Dd*Pk2*f**2*fd*r**2 + 6336*D1*Dd*Pk2*f**2*fd*r*s - 4176*D1*Dd*Pk2*f**2*fd*r - 1848*D1*Dd*Pk2*f**2*fd*s + 804*D1*Dd*Pk2*f**2*fd - 88*D1*Dd*Pk2*f**2*r**2 - 528*D1*Dd*Pk2*f**2*r*s + 176*D1*Dd*Pk2*f**2*r + 132*D1*Dd*Pk2*f**2*s - 22*D1*Dd*Pk2*f**2 + 1056*D1*Dd*Pk2*f*fd*r**2 + 3520*D1*Dd*Pk2*f*fd*r*s - 2112*D1*Dd*Pk2*f*fd*r - 1320*D1*Dd*Pk2*f*fd*s + 572*D1*Dd*Pk2*f*fd + 1936*D1*Dd*Pk2*f*g2*r**2 - 968*D1*Dd*Pk2*f*g2*r + 484*D1*Dd*Pk2*f*g2 + 4224*D1*Dd*Pk2*f*gd2*r**2 - 1056*D1*Dd*Pk2*f*gd2*r + 4224*D1*Dd*Pk2*fd*g2*r**2 - 5280*D1*Dd*Pk2*fd*g2*r + 1056*D1*Dd*Pk2*fd*g2 + 220*D1*Dd*Pkdd2*b2*f*k1**2*s**2 - 110*D1*Dd*Pkdd2*b2*f*k1**2*s + 55*D1*Dd*Pkdd2*b2*f*k1**2 - 528*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 + 132*D1*Dd*Pkdd2*b2*fd*k1**2*s - 528*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 + 132*D1*Dd*Pkdd2*bd2*f*k1**2*s - 660*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 330*D1*Dd*Pkdd2*f**3*k1**2*s - 165*D1*Dd*Pkdd2*f**3*k1**2 - 264*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 132*D1*Dd*Pkdd2*f**2*k1**2*s - 66*D1*Dd*Pkdd2*f**2*k1**2 - 1056*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 528*D1*Dd*Pkdd2*f*g2*k1**2*s - 264*D1*Dd*Pkdd2*f*g2*k1**2 + 1056*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 - 264*D1*Dd*Pkdd2*f*gd2*k1**2*s + 1056*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 - 264*D1*Dd*Pkdd2*fd*g2*k1**2*s + 264*D1*Ddd*K*Pk2*f**2*r**2 - 132*D1*Ddd*K*Pk2*f**2*r + 66*D1*Ddd*K*Pk2*f**2 + 816*D1*Ddd*Pk2*f**3*r**2 + 1056*D1*Ddd*Pk2*f**3*r*s - 672*D1*Ddd*Pk2*f**3*r - 264*D1*Ddd*Pk2*f**3*s + 204*D1*Ddd*Pk2*f**3 + 264*D1*Ddd*Pk2*f**2*r**2 + 880*D1*Ddd*Pk2*f**2*r*s - 352*D1*Ddd*Pk2*f**2*r - 220*D1*Ddd*Pk2*f**2*s + 66*D1*Ddd*Pk2*f**2 + 2112*D1*Ddd*Pk2*f*g2*r**2 - 1056*D1*Ddd*Pk2*f*g2*r + 528*D1*Ddd*Pk2*f*g2 - 264*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 + 132*D1*Ddd*Pkdd2*b2*f*k1**2*s - 66*D1*Ddd*Pkdd2*b2*f*k1**2 + 528*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 - 264*D1*Ddd*Pkdd2*f*g2*k1**2*s + 132*D1*Ddd*Pkdd2*f*g2*k1**2 + 11*D1*bd1*(D1*(10*Pk2*f**2*(8*r**2 - 3*r*(4*s + 1) + 6*s + 3) + 2*Pk2*f*(K*(-22*r**2 - 14*r + 7) + 3*fd*(32*r**2 + 4*r*(20*s - 9) - 20*s + 5) + 22*r**2 - 34*r*s + 14*r + 17*s - 7) + 14*Pk2*g2*(8*r**2 - 8*r + 4) - 112*Pk2*gd2*r**2 + 56*Pk2*gd2*r + 14*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) - 28*Pkdd2*bd2*k1**2*s**2 + 14*Pkdd2*bd2*k1**2*s - 4*Pkdd2*f**2*k1**2*(7*s**2 - 4*s + 2) + Pkdd2*f*k1**2*(K*(24*s**2 - 38*s + 19) - s**2*(40*fd + 4) + s*(20*fd - 10) + 5) - 28*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 56*Pkdd2*gd2*k1**2*s**2 - 28*Pkdd2*gd2*k1**2*s + 2*fd*(Pk2*(r**2*(48 - 48*K) + r*(48*K + 76*s - 86) - 19*s + 19) + Pkdd2*k1**2*s*(-6*K - 6)*(2*s - 1))) - 2*Dd*(28*Pk2*g2*(8*r**2 - 6*r + 1) + 7*Pkdd2*b2*k1**2*(8*s**2 - 6*s + 1) - 14*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) + f**2*(-3*Pk2*(8*r - 3)*(8*r + 20*s - 7) + 5*Pkdd2*k1**2*(8*s**2 - 6*s + 1)) + f*(Pk2*(r**2*(192*K - 192) + r*(-48*K - 304*s + 86) + 114*s - 19) + Pkdd2*k1**2*(6*K + 6)*(8*s**2 - 6*s + 1)))) + 792*Dd**2*K*Pk2*f**2*r**2 - 396*Dd**2*K*Pk2*f**2*r + 2448*Dd**2*Pk2*f**3*r**2 + 3168*Dd**2*Pk2*f**3*r*s - 2016*Dd**2*Pk2*f**3*r - 792*Dd**2*Pk2*f**3*s + 264*Dd**2*Pk2*f**3 + 792*Dd**2*Pk2*f**2*r**2 + 2640*Dd**2*Pk2*f**2*r*s - 1056*Dd**2*Pk2*f**2*r - 660*Dd**2*Pk2*f**2*s + 220*Dd**2*Pk2*f**2 + 6336*Dd**2*Pk2*f*g2*r**2 - 3168*Dd**2*Pk2*f*g2*r - 792*Dd**2*Pkdd2*b2*f*k1**2*s**2 + 396*Dd**2*Pkdd2*b2*f*k1**2*s + 1584*Dd**2*Pkdd2*f*g2*k1**2*s**2 - 792*Dd**2*Pkdd2*f*g2*k1**2*s) + 22*b2*(D1**2*(6*Pk2*fd**2*r*(r - 1) + f*(5*Pk2*fd*(2*r**2 - 2*r + 1) + 3*Pk2*fdd*(2*r**2 - 2*r + 1) - 3*Pkdd2*bdd1*k1**2*(s - 1)**2 - 3*Pkdd2*fd*k1**2*(2*s**2 - 2*s + 1))) + D1*f*(Dd*(5*Pk2*f*(4*r**2 - 2*r + 1) + 6*Pk2*fd*(8*r**2 - 6*r + 1) - 3*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) + 3*Ddd*Pk2*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*Pk2*f**2*r*(2*r - 1)))/(231*d**2*k1**2) + D1**2*Pk1*ct*k1*st**4*(-264*Pk2*b1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 132*Pk2*b1*(-2*D1**2*bdd1*f*(2*s**2 - 2*s + 1) - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 22*D1**2*f*fd*s**2 + 22*D1**2*f*fd*s - 11*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 44*D1*Dd*f**2*s**2 + 26*D1*Dd*f**2*s - 11*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 116*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 22*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 4*D1*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 66*Dd**2*f**2*s + 4*Dd**2*f**2) + f*(528*D1**2*Pk2*bd1**2*s*(s - 1) + D1**2*(f*(-132*Pk2*bdd1*s*(4*r + 9*s - 4) + 32*Pk2*fd*(2*C*(r*(3*s - 1) + 21*s**2 - 15*s + 7) + r*(5 - 15*s) - 18*s**2 + 17*s - 6) - 16*Pk2*fdd*(2*C*(r*(3*s - 1) + 21*s**2 - 15*s + 7) + r*(5 - 15*s) - 18*s**2 + 17*s - 6) + 2*Pkdd2*fd*k1**2*(3*s**2 - 2*s + 1) - Pkdd2*fdd*k1**2*(3*s**2 - 2*s + 1)) + 2*fd**2*(-8*Pk2*(2*C*(6*r*s - 2*r + 42*s**2 - 30*s + 1) - 30*r*s + 10*r - 36*s**2 + 34*s - 5) + Pkdd2*k1**2*s*(2 - 3*s))) + 132*D1*Pk2*bd1*(D1*(f*s*(4*r + 11*s - 4) - 2*fd*(8*r*s - 2*r + 18*s**2 - 13*s + 2)) - 2*Dd*f*(2*r*(8*s - 1) + 36*s**2 - 19*s + 2)) + D1*f*(2*Dd*(16*Pk2*f*(2*C*(4*r*s - r + 28*s**2 - 15*s + 7) - 20*r*s + 5*r - 24*s**2 + 17*s - 6) - 8*Pk2*fd*(2*C*(24*r*s - 7*r + 168*s**2 - 105*s + 16) - 120*r*s + 35*r - 144*s**2 + 119*s - 22) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) - Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1)) - Ddd*f*(16*Pk2*(2*C*(4*r*s - r + 28*s**2 - 15*s + 7) - 20*r*s + 5*r - 24*s**2 + 17*s - 6) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 2*Dd**2*f**2*(-8*Pk2*(2*C*(12*r*s - 3*r + 84*s**2 - 45*s + 1) - 60*r*s + 15*r - 72*s**2 + 51*s - 5) + 3*Pkdd2*k1**2*s*(1 - 2*s))))/(231*d**2*k2*k3**2) + D1**2*Pk1*ct*k1*st**2*(33*b1**2*(D1**2*s*(2*fd*(Pk2*r*(16*C - 12) + Pk2*s*(32*C - 9) + Pkdd2*k1**2*s) - fdd*(2*Pk2*(r*(8*C + 8) + s*(16*C + 13)) + Pkdd2*k1**2*s)) + D1*(2*Dd*(Pk2*f*(16*C*(4*r*s - r + 8*s**2 - 5*s + 2) - 48*r*s + 12*r - 36*s**2 + 30*s - 9) - 2*Pk2*fd*(r*(4*C + 4)*(8*s - 1) + s*(64*C*s - 20*C + 52*s - 17)) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(1 - 4*s)) - Ddd*f*(2*Pk2*(8*C*(4*r*s - r + 8*s**2 - 5*s + 2) + 32*r*s - 8*r + 52*s**2 - 34*s + 13) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(2*Pk2*(4*C*(12*r*s - 3*r + 24*s**2 - 15*s + 1) + 48*r*s - 12*r + 78*s**2 - 51*s + 4) + 3*Pkdd2*k1**2*s*(2*s - 1))) + 33*b1*(-192*C*D1**2*Pk2*f*fd*r*s + 128*C*D1**2*Pk2*f*fd*r - 448*C*D1**2*Pk2*f*fd*s**2 + 544*C*D1**2*Pk2*f*fd*s - 288*C*D1**2*Pk2*f*fd + 160*C*D1**2*Pk2*f*fdd*r*s - 96*C*D1**2*Pk2*f*fdd*r + 416*C*D1**2*Pk2*f*fdd*s**2 - 464*C*D1**2*Pk2*f*fdd*s + 240*C*D1**2*Pk2*f*fdd + 160*C*D1**2*Pk2*fd**2*r*s - 96*C*D1**2*Pk2*fd**2*r + 416*C*D1**2*Pk2*fd**2*s**2 - 464*C*D1**2*Pk2*fd**2*s - 384*C*D1*Dd*Pk2*f**2*r*s + 96*C*D1*Dd*Pk2*f**2*r - 896*C*D1*Dd*Pk2*f**2*s**2 + 544*C*D1*Dd*Pk2*f**2*s - 224*C*D1*Dd*Pk2*f**2 + 1280*C*D1*Dd*Pk2*f*fd*r*s - 544*C*D1*Dd*Pk2*f*fd*r + 3328*C*D1*Dd*Pk2*f*fd*s**2 - 2848*C*D1*Dd*Pk2*f*fd*s + 560*C*D1*Dd*Pk2*f*fd + 320*C*D1*Ddd*Pk2*f**2*r*s - 80*C*D1*Ddd*Pk2*f**2*r + 832*C*D1*Ddd*Pk2*f**2*s**2 - 496*C*D1*Ddd*Pk2*f**2*s + 208*C*D1*Ddd*Pk2*f**2 + 960*C*Dd**2*Pk2*f**2*r*s - 240*C*Dd**2*Pk2*f**2*r + 2496*C*Dd**2*Pk2*f**2*s**2 - 1488*C*Dd**2*Pk2*f**2*s + 80*C*Dd**2*Pk2*f**2 - 4*D1**2*Pk2*f*fd*r**2 + 16*D1**2*Pk2*f*fd*r*s - 80*D1**2*Pk2*f*fd*r - 240*D1**2*Pk2*f*fd*s**2 + 116*D1**2*Pk2*f*fd*s - 22*D1**2*Pk2*f*fd + 4*D1**2*Pk2*f*fdd*r**2 + 48*D1**2*Pk2*f*fdd*r*s + 24*D1**2*Pk2*f*fdd*r + 128*D1**2*Pk2*f*fdd*s**2 - 68*D1**2*Pk2*f*fdd*s + 10*D1**2*Pk2*f*fdd + 4*D1**2*Pk2*fd**2*r**2 + 48*D1**2*Pk2*fd**2*r*s + 24*D1**2*Pk2*fd**2*r + 128*D1**2*Pk2*fd**2*s**2 - 68*D1**2*Pk2*fd**2*s + 2*D1**2*Pkdd2*f*fd*k1**2*s**2 + 2*D1**2*Pkdd2*f*fd*k1**2*s - D1**2*Pkdd2*f*fd*k1**2 - 2*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 2*D1**2*Pkdd2*fd**2*k1**2*s**2 - D1**2*bdd1*f*(2*Pk2*(8*C*(2*r*s - r + 4*s**2 - 5*s + 2) + 16*r*s - 8*r + 26*s**2 - 34*s + 13) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - 8*D1*Dd*Pk2*f**2*r**2 + 32*D1*Dd*Pk2*f**2*r*s - 4*D1*Dd*Pk2*f**2*r - 480*D1*Dd*Pk2*f**2*s**2 + 232*D1*Dd*Pk2*f**2*s - 122*D1*Dd*Pk2*f**2 + 32*D1*Dd*Pk2*f*fd*r**2 + 384*D1*Dd*Pk2*f*fd*r*s + 40*D1*Dd*Pk2*f*fd*r + 1024*D1*Dd*Pk2*f*fd*s**2 - 576*D1*Dd*Pk2*f*fd*s + 44*D1*Dd*Pk2*f*fd + 4*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 2*D1*Dd*Pkdd2*f**2*k1**2*s + D1*Dd*Pkdd2*f**2*k1**2 - 16*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 4*D1*Dd*Pkdd2*f*fd*k1**2*s + 8*D1*Ddd*Pk2*f**2*r**2 + 96*D1*Ddd*Pk2*f**2*r*s - 28*D1*Ddd*Pk2*f**2*r + 256*D1*Ddd*Pk2*f**2*s**2 - 152*D1*Ddd*Pk2*f**2*s + 66*D1*Ddd*Pk2*f**2 - 4*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**2*k1**2*s - D1*Ddd*Pkdd2*f**2*k1**2 + 2*D1*bd1*(D1*(f*(16*C*Pk2*(r*(2*s - 1) + 4*s**2 - 5*s + 2) - 3*Pk2*(r*(8*s - 4) + 6*s**2 - 10*s + 3) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + fd*(-Pk2*r*(8*C + 8)*(4*s - 1) + 2*Pk2*s*(-4*C*(8*s - 5) - 26*s + 17) + Pkdd2*k1**2*s*(1 - 2*s))) - Dd*f*(2*Pk2*(8*C*(r*(8*s - 3) + 16*s**2 - 15*s + 3) + 8*r*(8*s - 3) + 104*s**2 - 102*s + 21) + Pkdd2*k1**2*(8*s**2 - 6*s + 1))) + 24*Dd**2*Pk2*f**2*r**2 + 288*Dd**2*Pk2*f**2*r*s - 84*Dd**2*Pk2*f**2*r + 768*Dd**2*Pk2*f**2*s**2 - 456*Dd**2*Pk2*f**2*s + 24*Dd**2*Pk2*f**2 - 12*Dd**2*Pkdd2*f**2*k1**2*s**2 + 6*Dd**2*Pkdd2*f**2*k1**2*s) + f*(-12192*C*D1**2*Pk2*f*fd*r*s + 4064*C*D1**2*Pk2*f*fd*r - 27360*C*D1**2*Pk2*f*fd*s**2 + 22304*C*D1**2*Pk2*f*fd*s - 9120*C*D1**2*Pk2*f*fd + 10848*C*D1**2*Pk2*f*fdd*r*s - 3616*C*D1**2*Pk2*f*fdd*r + 23184*C*D1**2*Pk2*f*fdd*s**2 - 19072*C*D1**2*Pk2*f*fdd*s + 7728*C*D1**2*Pk2*f*fdd + 21696*C*D1**2*Pk2*fd**2*r*s - 7232*C*D1**2*Pk2*fd**2*r + 46368*C*D1**2*Pk2*fd**2*s**2 - 38144*C*D1**2*Pk2*fd**2*s + 3616*C*D1**2*Pk2*fd**2 - 16256*C*D1*Dd*Pk2*f**2*r*s + 4064*C*D1*Dd*Pk2*f**2*r - 36480*C*D1*Dd*Pk2*f**2*s**2 + 22304*C*D1*Dd*Pk2*f**2*s - 9120*C*D1*Dd*Pk2*f**2 + 86784*C*D1*Dd*Pk2*f*fd*r*s - 25312*C*D1*Dd*Pk2*f*fd*r + 185472*C*D1*Dd*Pk2*f*fd*s**2 - 133504*C*D1*Dd*Pk2*f*fd*s + 22688*C*D1*Dd*Pk2*f*fd + 14464*C*D1*Ddd*Pk2*f**2*r*s - 3616*C*D1*Ddd*Pk2*f**2*r + 30912*C*D1*Ddd*Pk2*f**2*s**2 - 19072*C*D1*Ddd*Pk2*f**2*s + 7728*C*D1*Ddd*Pk2*f**2 + 43392*C*Dd**2*Pk2*f**2*r*s - 10848*C*Dd**2*Pk2*f**2*r + 92736*C*Dd**2*Pk2*f**2*s**2 - 57216*C*Dd**2*Pk2*f**2*s + 3616*C*Dd**2*Pk2*f**2 + 1182*D1**2*Pk2*f*fd*r**2 + 18960*D1**2*Pk2*f*fd*r*s - 7108*D1**2*Pk2*f*fd*r + 6750*D1**2*Pk2*f*fd*s**2 - 10820*D1**2*Pk2*f*fd*s + 2644*D1**2*Pk2*f*fd - 1482*D1**2*Pk2*f*fdd*r**2 - 12648*D1**2*Pk2*f*fdd*r*s + 5204*D1**2*Pk2*f*fdd*r - 8226*D1**2*Pk2*f*fdd*s**2 + 9700*D1**2*Pk2*f*fdd*s - 3236*D1**2*Pk2*f*fdd - 2964*D1**2*Pk2*fd**2*r**2 - 25296*D1**2*Pk2*fd**2*r*s + 10408*D1**2*Pk2*fd**2*r - 16452*D1**2*Pk2*fd**2*s**2 + 19400*D1**2*Pk2*fd**2*s - 4216*D1**2*Pk2*fd**2 - 99*D1**2*Pkdd2*f*fd*k1**2*s**2 + 66*D1**2*Pkdd2*f*fd*k1**2*s - 33*D1**2*Pkdd2*f*fd*k1**2 - 66*D1**2*bd1**2*(2*Pk2*(4*C*(2*r*s - r + 4*s**2 - 5*s + 1) + 8*r*s - 4*r + 13*s**2 - 17*s + 4) + Pkdd2*k1**2*s*(s - 1)) + 33*D1**2*bdd1*f*(2*Pk2*(8*C*(5*r*s + r + 13*s**2 - 2*s - 2) + r**2 + 12*r*s - 26*r + 32*s**2 - 42*s + 28) - Pkdd2*k1**2*(s - 1)**2) + 1576*D1*Dd*Pk2*f**2*r**2 + 25280*D1*Dd*Pk2*f**2*r*s - 7108*D1*Dd*Pk2*f**2*r + 9000*D1*Dd*Pk2*f**2*s**2 - 10820*D1*Dd*Pk2*f**2*s + 2644*D1*Dd*Pk2*f**2 - 11856*D1*Dd*Pk2*f*fd*r**2 - 101184*D1*Dd*Pk2*f*fd*r*s + 36428*D1*Dd*Pk2*f*fd*r - 65808*D1*Dd*Pk2*f*fd*s**2 + 67900*D1*Dd*Pk2*f*fd*s - 14904*D1*Dd*Pk2*f*fd - 132*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 66*D1*Dd*Pkdd2*f**2*k1**2*s - 33*D1*Dd*Pkdd2*f**2*k1**2 - 1976*D1*Ddd*Pk2*f**2*r**2 - 16864*D1*Ddd*Pk2*f**2*r*s + 5204*D1*Ddd*Pk2*f**2*r - 10968*D1*Ddd*Pk2*f**2*s**2 + 9700*D1*Ddd*Pk2*f**2*s - 3236*D1*Ddd*Pk2*f**2 - 33*D1*bd1*(D1*(-4*Pk2*fd*(4*C*(4*r*(5*s - 1) + 52*s**2 - 33*s + 5) + 2*r**2 + 4*r*(6*s - 5) + 64*s**2 - 59*s + 6) + 4*Pkdd2*fd*k1**2*s*(s - 1) + f*(2*Pk2*(16*C*(3*r*s + r + 7*s**2 - 2) + r**2 - 4*r*s - 38*r + 60*s**2 - 58*s + 50) - Pkdd2*k1**2*(s**2 - 4*s + 2))) - 2*Dd*f*(2*Pk2*(4*C*(40*r*s - r + 104*s**2 - 39*s + 1) + 4*r**2 + 48*r*s - 59*r + 128*s**2 - 122*s + 34) + Pkdd2*k1**2*(-4*s**2 + 5*s - 1))) - 5928*Dd**2*Pk2*f**2*r**2 - 50592*Dd**2*Pk2*f**2*r*s + 15612*Dd**2*Pk2*f**2*r - 32904*Dd**2*Pk2*f**2*s**2 + 29100*Dd**2*Pk2*f**2*s - 4216*Dd**2*Pk2*f**2))/(1386*d**2*k2*k3**2) - D1**2*Pk1*ct*k1*(b1**2*(D1**2*(4*Pk2*fdd*(7*r**2 + r*s*(51 - 30*C) + s**2*(47 - 40*C)) + fd*(-4*Pk2*(7*r**2 + r*s*(53 - 32*C) + s**2*(45 - 38*C)) + 7*Pkdd2*k1**2*s**2)) + D1*(Dd*(4*Pk2*fd*(56*r**2 + r*(-240*C*s + 30*C + 408*s - 65) + s*(-320*C*s + 110*C + 376*s - 145)) + f*(4*Pk2*(2*C*(64*r*s - 16*r + 76*s**2 - 54*s + 19) - 28*r**2 - 212*r*s + 67*r - 180*s**2 + 143*s - 52) + 7*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 4*Ddd*Pk2*f*(10*C*(12*r*s - 3*r + 16*s**2 - 11*s + 4) - 28*r**2 - 204*r*s + 65*r - 188*s**2 + 145*s - 54)) - 12*Dd**2*Pk2*f*(10*C*(12*r*s - 3*r + 16*s**2 - 11*s + 1) - 28*r**2 - 204*r*s + 65*r - 188*s**2 + 145*s - 17)) + b1*(-4*D1**2*Pk2*bdd1*f*(10*C*(r*(6*s - 3) + 8*s**2 - 11*s + 4) - 14*r**2 + r*(65 - 102*s) - 94*s**2 + 145*s - 54) - 2*D1**2*(4*Pk2*fd**2*(-11*r**2 + r*(2*C*(s + 7) - 59*s + 11) + s*(C*(27 - 8*s) - 53*s + 39)) + f*(Pk2*fdd*(4*C*(2*r*(s + 7) - 8*s**2 + 27*s - 21) - 44*r**2 - 236*r*s + 44*r - 212*s**2 + 156*s - 41) + fd*(Pk2*(4*C*(-2*r*(4*s + 7) + 10*s**2 - 24*s + 21) + 64*r**2 + 268*r*s - 64*r + 204*s**2 - 172*s + 51) - 6*Pkdd2*k1**2*s**2))) + D1*bd1*(D1*(4*Pk2*fd*(28*r**2 + r*(-120*C*s + 30*C + 204*s - 65) + s*(-160*C*s + 110*C + 188*s - 145)) + f*(4*Pk2*(2*C*(32*r*s - 16*r + 38*s**2 - 54*s + 19) - 14*r**2 - 106*r*s + 67*r - 90*s**2 + 143*s - 52) + 7*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 8*Dd*Pk2*f*(10*C*(24*r*s - 9*r + 32*s**2 - 33*s + 7) - 56*r**2 - 408*r*s + 195*r - 376*s**2 + 435*s - 105)) + 2*D1*f*(Dd*(-4*Pk2*fd*(C*(16*r*s + 54*r - 64*s**2 + 122*s - 41) - 88*r**2 - 472*r*s + 125*r - 424*s**2 + 321*s - 50) + f*(2*Pk2*(2*C*(16*r*s - 4*r - 20*s**2 + 6*s - 5) - 64*r**2 - 268*r*s + 99*r - 204*s**2 + 169*s - 67) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 2*Ddd*Pk2*f*(2*C*(-4*r*s + r + 16*s**2 - 7*s + 4) + 44*r**2 + 236*r*s - 81*r + 212*s**2 - 165*s + 64)) - 4*Dd**2*Pk2*f**2*(C*(6*r*(4*s - 1) - 96*s**2 + 42*s + 2) - 132*r**2 + r*(243 - 708*s) - 636*s**2 + 495*s - 59)) - 2*f*(2*D1**2*Pk2*bd1**2*(10*C*(r*(6*s - 3) + 8*s**2 - 11*s + 3) - 14*r**2 + r*(65 - 102*s) - 94*s**2 + 145*s - 51) - D1*bd1*(D1*(2*Pk2*fd*(C*(-8*r*(s - 4) + 32*s**2 + 26*s - 2) + 44*r**2 + 4*r*(59*s - 35) + 212*s**2 - 252*s + 59) + f*(Pk2*(4*C*(2*r*(2*s - 9) - 5*s**2 - 18*s + 16) - 32*r**2 - 134*r*(s - 1) - 102*s**2 + 166*s - 83) + 3*Pkdd2*k1**2*(s - 1)**2)) + 2*Dd*Pk2*f*(2*C*(r*(61 - 8*s) + 32*s**2 + 73*s - 35) + 88*r**2 + r*(472*s - 317) + 424*s**2 - 513*s + 146)) + Pk2*(D1**2*bdd1*f*(4*C*(r*(s - 15) - 4*s**2 - 20*s + 17) - 22*r**2 - 118*r*(s - 1) - 106*s**2 + 174*s - 87) + 8*D1**2*(f*(fd - fdd)*(C*(7*r*(3*s - 1) + 27*s**2 - 25*s + 9) + 6*s**2 - 4*s + 2) + fd**2*(C*(r*(14 - 42*s) - 54*s**2 + 50*s - 7) + s*(8 - 12*s))) + 8*D1*f*(Dd*(f*(C*(28*r*s - 7*r + 36*s**2 - 25*s + 9) + 8*s**2 - 4*s + 2) - fd*(C*(7*r*(24*s - 7) + 216*s**2 - 175*s + 32) + 48*s**2 - 28*s + 4)) - Ddd*f*(C*(28*r*s - 7*r + 36*s**2 - 25*s + 9) + 8*s**2 - 4*s + 2)) + 8*Dd**2*f**2*(C*(r*(21 - 84*s) - 108*s**2 + 75*s - 7) + s*(12 - 24*s)))))/(21*d**2*k2*k3**2) - 5*D1**2*Pk1*ct*k2*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(8*Pk2*(r*(4*C - 4)*(2*s - 1) + 2*s**2 - 2*s + 1) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + 2*fd**2*(-8*Pk2*(r*(2*C - 2)*(2*s - 1) + s*(s - 1)) - Pkdd2*k1**2*s*(s - 1))) + D1*f*(2*Dd*(8*Pk2*f*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 4*s**2 + 2*s + 1) - 8*Pk2*fd*(2*C*(16*r*s - 6*r - 2*s + 1) - 32*r*s + 12*r + 8*s**2 - 2*s - 1) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*(-8*s**2 + 6*s - 1)) - Ddd*f*(8*Pk2*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 4*s**2 + 2*s + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(8*Pk2*(C*(24*r*s - 6*r - 6*s + 2) - 24*r*s + 6*r + 6*s**2 + 3*s - 2) + 3*Pkdd2*k1**2*s*(2*s - 1))) + f*(D1**2*(f*(-33*bdd1*s*(8*Pk2*(4*C*(r - 1) - 4*r + s + 4) + Pkdd2*k1**2*s) + 2*fd*(8*Pk2*(-4*C*s + r*(4*C - 4)*(3*s - 1) + 3*s**2 + 2*s + 1) + Pkdd2*k1**2*(3*s**2 - 2*s + 1)) - fdd*(8*Pk2*(-4*C*s + r*(4*C - 4)*(3*s - 1) + 3*s**2 + 2*s + 1) + Pkdd2*k1**2*(3*s**2 - 2*s + 1))) - 2*fd**2*(8*Pk2*(2*C*(6*r*s - 2*r - 2*s + 1) - 12*r*s + 4*r + 3*s**2 + 2*s - 2) + Pkdd2*k1**2*s*(3*s - 2))) + 66*D1*bd1*(D1*f*s*(8*Pk2*(4*C*(r - 1) - 4*r + s + 4) + Pkdd2*k1**2*s) + D1*fd*(-8*Pk2*(C*(8*r*s - 2*r - 4*s + 2) - 8*r*s + 2*r + 2*s**2 + 3*s - 2) + Pkdd2*k1**2*s*(1 - 2*s)) - 8*Dd*Pk2*f*(2*C*(r*(8*s - 1) - 5*s + 1) + r*(2 - 16*s) + 4*s**2 + 9*s - 2) + Dd*Pkdd2*f*k1**2*s*(1 - 4*s)) + D1*f*(2*Dd*(8*Pk2*f*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 4*s**2 + 2*s + 1) - 8*Pk2*fd*(2*C*(24*r*s - 7*r - 7*s + 2) - 48*r*s + 14*r + 12*s**2 + 7*s - 3) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) - Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1)) - Ddd*f*(8*Pk2*(-4*C*s + r*(4*C - 4)*(4*s - 1) + 4*s**2 + 2*s + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(8*Pk2*(C*(24*r*s - 6*r - 6*s + 2) - 24*r*s + 6*r + 6*s**2 + 3*s - 2) + 3*Pkdd2*k1**2*s*(2*s - 1))))/(1386*d**2*k1*k3**2) + D1**2*Pk1*ct*k2*st**4*(66*D1**2*bd1**2*f*(Pk2*(8*C - 8)*(r*(2*s - 1) - s + 1) + Pkdd2*k1**2*s*(s - 1)) - 33*D1*bd1*(2*D1*b1*(Pk2*f*(16*C - 16)*(r*(2*s - 1) - s) - Pk2*fd*(8*C - 8)*(r*(4*s - 1) - s) + Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(1 - 2*s)) - 2*Dd*b1*f*(Pk2*(16*C - 16)*(r*(8*s - 3) - 3*s + 1) + Pkdd2*k1**2*(8*s**2 - 6*s + 1)) + f*(4*D1*Pk2*fd*(2*C*(8*r**2 + 20*r*s - 13*r - 10*s + 5) - 16*r**2 - 32*r*s + 24*r + 18*s**2 + 7*s - 8) - D1*f*(2*Pk2*(8*C*(r - 1)*(r + 4*s - 1) - 8*r**2 - 28*r*s + 16*r + 9*s**2 + 28*s - 8) + Pkdd2*k1**2*s**2) + 4*Dd*Pk2*f*(2*C*(16*r**2 + 5*r*(8*s - 5) - 25*s + 9) - 32*r**2 - 64*r*s + 48*r + 36*s**2 + 31*s - 16))) + 33*b1**2*(-2*D1*Dd*(Pk2*f*(16*C - 16)*(r*(4*s - 1) - s) - Pk2*fd*(8*C - 8)*(r*(8*s - 1) - s) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(1 - 4*s)) + D1*(-D1*s*(2*fd - fdd)*(Pk2*r*(16*C - 16) + Pkdd2*k1**2*s) + Ddd*f*(Pk2*(16*C - 16)*(4*r*s - r - s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*(8*C - 8)*(3*r*(4*s - 1) - 3*s + 1) + 3*Pkdd2*k1**2*s*(2*s - 1))) + 33*b1*(D1**2*(-4*Pk2*fd**2*(r**2*(8*C - 8) + r*(10*C - 8)*(2*s - 1) + s*(9*s - 9)) + f*(-2*Pk2*fdd*(r**2*(16*C - 16) + r*(20*C - 16)*(2*s - 1) + 18*s**2 - 18*s + 9) + bdd1*(Pk2*(16*C - 16)*(2*r*s - r - s) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + fd*(2*Pk2*(r**2*(16*C - 16) + r*(32*C - 28)*(2*s - 1) + 18*s**2 - 18*s + 9) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)))) + D1*f*(Dd*(-4*Pk2*fd*(2*C*(32*r**2 + 80*r*s - 38*r - 10*s + 5) - 64*r**2 - 128*r*s + 64*r + 72*s**2 - 38*s + 1) + f*(2*Pk2*(8*C*(4*r**2 + 16*r*s - 6*r - 4*s + 1) - 32*r**2 - 112*r*s + 44*r + 36*s**2 + 10*s + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Ddd*Pk2*f*(4*C*(8*r**2 + 20*r*s - 9*r - 5*s + 2) - 32*r**2 - 64*r*s + 32*r + 36*s**2 - 2*s + 1)) - 4*Dd**2*Pk2*f**2*(2*C*(24*r**2 + 3*r*(20*s - 9) - 15*s + 5) - 48*r**2 + r*(48 - 96*s) + 54*s**2 - 3*s - 8)) + f*(-66*D1**2*Pk2*bdd1*f*(4*C*(r - 1)*(2*r + 5*s - 2) - 8*r**2 - 16*r*(s - 1) + 9*s**2 + 16*s - 8) + D1**2*(f*(2*fd*(Pk2*(24*C*(3*r**2 + 9*r*s - 5*r - 3*s + 1) - 207*r**2 + 138*r - 60*s**2 + 40*s - 89) + Pkdd2*k1**2*(20*C + 1)*(3*s**2 - 2*s + 1)) - fdd*(2*Pk2*(12*C*(3*r**2 + 9*r*s - 5*r - 3*s + 1) - 153*r**2 + 102*r - 30*s**2 + 20*s - 61) + Pkdd2*k1**2*(20*C + 1)*(3*s**2 - 2*s + 1))) - 2*fd**2*(4*C*(3*Pk2*(6*r**2 + 2*r*(9*s - 5) - 6*s + 3) + 5*Pkdd2*k1**2*s*(3*s - 2)) + Pk2*(-306*r**2 + 204*r + s*(40 - 60*s)) + Pkdd2*k1**2*s*(3*s - 2))) + D1*f*(2*Dd*(Pk2*f*(24*C*(4*r - 1)*(r + 3*s - 1) - 276*r**2 + 138*r - 80*s**2 + 40*s - 89) - 2*Pk2*fd*(6*C*(24*r**2 + r*(72*s - 35) - 21*s + 8) - 612*r**2 + 357*r - 120*s**2 + 70*s - 61) + Pkdd2*f*k1**2*(20*C + 1)*(4*s**2 - 2*s + 1) - Pkdd2*fd*k1**2*(20*C + 1)*(12*s**2 - 7*s + 1)) - Ddd*f*(2*Pk2*(12*C*(4*r - 1)*(r + 3*s - 1) - 204*r**2 + 102*r - 40*s**2 + 20*s - 61) + Pkdd2*k1**2*(20*C + 1)*(4*s**2 - 2*s + 1))) - 6*Dd**2*f**2*(4*C*(3*Pk2*(4*r - 1)*(r + 3*s - 1) + 5*Pkdd2*k1**2*s*(2*s - 1)) + Pk2*(-204*r**2 + 102*r + s*(20 - 40*s)) + Pkdd2*k1**2*s*(2*s - 1))))/(231*d**2*k1*k3**2) + D1**2*Pk1*ct*k2*st**2*(11*b1**2*(D1**2*(Pk2*fd*r*(16*C - 16)*(8*r + 13*s) - Pk2*fdd*r*(40*C - 40)*(3*r + 4*s) + Pkdd2*fd*k1**2*s**2*(24*C + 9) - Pkdd2*fdd*k1**2*s**2*(12*C + 1)) + D1*(Dd*(Pk2*f*(16*C - 16)*(32*r**2 + r*(52*s - 29) - 13*s + 8) - Pk2*fd*(80*C - 80)*(12*r**2 + r*(16*s - 5) - 2*s) + Pkdd2*f*k1**2*(24*C + 9)*(4*s**2 - 2*s + 1) + Pkdd2*fd*k1**2*s*(-24*C - 2)*(4*s - 1)) - Ddd*f*(Pk2*(40*C - 40)*(12*r**2 + 2*r*(8*s - 5) - 4*s + 3) + Pkdd2*k1**2*(12*C + 1)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(Pk2*(40*C - 40)*(18*r**2 + 3*r*(8*s - 5) - 6*s + 2) + Pkdd2*k1**2*s*(36*C + 3)*(2*s - 1))) + 11*b1*(112*C*D1**2*Pk2*f*fd*r**2 - 96*C*D1**2*Pk2*f*fd*r*s - 64*C*D1**2*Pk2*f*fd*r + 48*C*D1**2*Pk2*f*fd*s + 32*C*D1**2*Pk2*f*fd + 16*C*D1**2*Pk2*f*fdd*r**2 + 64*C*D1**2*Pk2*f*fdd*r*s - 16*C*D1**2*Pk2*f*fdd*r - 32*C*D1**2*Pk2*f*fdd*s + 8*C*D1**2*Pk2*f*fdd + 16*C*D1**2*Pk2*fd**2*r**2 + 64*C*D1**2*Pk2*fd**2*r*s - 16*C*D1**2*Pk2*fd**2*r - 32*C*D1**2*Pk2*fd**2*s + 24*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 24*C*D1**2*Pkdd2*f*fd*k1**2*s - 12*C*D1**2*Pkdd2*f*fd*k1**2 - 24*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 24*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 224*C*D1*Dd*Pk2*f**2*r**2 - 192*C*D1*Dd*Pk2*f**2*r*s - 64*C*D1*Dd*Pk2*f**2*r + 48*C*D1*Dd*Pk2*f**2*s + 56*C*D1*Dd*Pk2*f**2 + 128*C*D1*Dd*Pk2*f*fd*r**2 + 512*C*D1*Dd*Pk2*f*fd*r*s - 160*C*D1*Dd*Pk2*f*fd*r - 192*C*D1*Dd*Pk2*f*fd*s + 48*C*D1*Dd*Pk2*f*fd + 48*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 24*C*D1*Dd*Pkdd2*f**2*k1**2*s + 12*C*D1*Dd*Pkdd2*f**2*k1**2 - 192*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 48*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 32*C*D1*Ddd*Pk2*f**2*r**2 + 128*C*D1*Ddd*Pk2*f**2*r*s - 48*C*D1*Ddd*Pk2*f**2*r - 32*C*D1*Ddd*Pk2*f**2*s + 8*C*D1*Ddd*Pk2*f**2 - 48*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 24*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 12*C*D1*Ddd*Pkdd2*f**2*k1**2 + 96*C*Dd**2*Pk2*f**2*r**2 + 384*C*Dd**2*Pk2*f**2*r*s - 144*C*Dd**2*Pk2*f**2*r - 96*C*Dd**2*Pk2*f**2*s + 32*C*Dd**2*Pk2*f**2 - 144*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 72*C*Dd**2*Pkdd2*f**2*k1**2*s - 192*D1**2*Pk2*f*fd*r**2 - 48*D1**2*Pk2*f*fd*r*s + 176*D1**2*Pk2*f*fd*r - 120*D1**2*Pk2*f*fd*s**2 + 72*D1**2*Pk2*f*fd*s - 112*D1**2*Pk2*f*fd + 48*D1**2*Pk2*f*fdd*r**2 + 80*D1**2*Pk2*f*fdd*r*s - 88*D1**2*Pk2*f*fdd*r + 120*D1**2*Pk2*f*fdd*s**2 - 88*D1**2*Pk2*f*fdd*s + 68*D1**2*Pk2*f*fdd + 48*D1**2*Pk2*fd**2*r**2 + 80*D1**2*Pk2*fd**2*r*s - 88*D1**2*Pk2*fd**2*r + 120*D1**2*Pk2*fd**2*s**2 - 88*D1**2*Pk2*fd**2*s + 2*D1**2*Pkdd2*f*fd*k1**2*s - D1**2*Pkdd2*f*fd*k1**2 - 2*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 2*D1**2*Pkdd2*fd**2*k1**2*s**2 - D1**2*bdd1*f*(Pk2*(40*C - 40)*(6*r**2 + 2*r*(4*s - 5) - 4*s + 3) + Pkdd2*k1**2*(12*C + 1)*(2*s**2 - 2*s + 1)) - 384*D1*Dd*Pk2*f**2*r**2 - 96*D1*Dd*Pk2*f**2*r*s + 216*D1*Dd*Pk2*f**2*r - 240*D1*Dd*Pk2*f**2*s**2 + 144*D1*Dd*Pk2*f**2*s - 156*D1*Dd*Pk2*f**2 + 384*D1*Dd*Pk2*f*fd*r**2 + 640*D1*Dd*Pk2*f*fd*r*s - 528*D1*Dd*Pk2*f*fd*r + 960*D1*Dd*Pk2*f*fd*s**2 - 672*D1*Dd*Pk2*f*fd*s + 176*D1*Dd*Pk2*f*fd - 16*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 4*D1*Dd*Pkdd2*f*fd*k1**2*s + 96*D1*Ddd*Pk2*f**2*r**2 + 160*D1*Ddd*Pk2*f**2*r*s - 88*D1*Ddd*Pk2*f**2*r + 240*D1*Ddd*Pk2*f**2*s**2 - 160*D1*Ddd*Pk2*f**2*s + 84*D1*Ddd*Pk2*f**2 - 4*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**2*k1**2*s - D1*Ddd*Pkdd2*f**2*k1**2 + D1*bd1*(D1*(-Pk2*fd*(80*C - 80)*(6*r**2 + r*(8*s - 5) - 2*s) + Pkdd2*fd*k1**2*s*(-24*C - 2)*(2*s - 1) + f*(Pk2*(16*C - 16)*(16*r**2 + r*(26*s - 29) - 13*s + 8) + Pkdd2*k1**2*(24*C + 9)*(2*s**2 - 2*s + 1))) - 2*Dd*f*(Pk2*(40*C - 40)*(24*r**2 + r*(32*s - 30) - 12*s + 7) + Pkdd2*k1**2*(12*C + 1)*(8*s**2 - 6*s + 1))) + 288*Dd**2*Pk2*f**2*r**2 + 480*Dd**2*Pk2*f**2*r*s - 264*Dd**2*Pk2*f**2*r + 720*Dd**2*Pk2*f**2*s**2 - 480*Dd**2*Pk2*f**2*s + 40*Dd**2*Pk2*f**2 - 12*Dd**2*Pkdd2*f**2*k1**2*s**2 + 6*Dd**2*Pkdd2*f**2*k1**2*s) + f*(840*C*D1**2*Pk2*f*fd*r**2 - 560*C*D1**2*Pk2*f*fd*r + 280*C*D1**2*Pk2*f*fd + 768*C*D1**2*Pk2*f*fdd*r**2 - 512*C*D1**2*Pk2*f*fdd*r + 256*C*D1**2*Pk2*f*fdd + 1536*C*D1**2*Pk2*fd**2*r**2 - 1024*C*D1**2*Pk2*fd**2*r - 396*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 264*C*D1**2*Pkdd2*f*fd*k1**2*s - 132*C*D1**2*Pkdd2*f*fd*k1**2 + 1120*C*D1*Dd*Pk2*f**2*r**2 - 560*C*D1*Dd*Pk2*f**2*r + 280*C*D1*Dd*Pk2*f**2 + 6144*C*D1*Dd*Pk2*f*fd*r**2 - 3584*C*D1*Dd*Pk2*f*fd*r + 512*C*D1*Dd*Pk2*f*fd - 528*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 264*C*D1*Dd*Pkdd2*f**2*k1**2*s - 132*C*D1*Dd*Pkdd2*f**2*k1**2 + 1024*C*D1*Ddd*Pk2*f**2*r**2 - 512*C*D1*Ddd*Pk2*f**2*r + 256*C*D1*Ddd*Pk2*f**2 + 3072*C*Dd**2*Pk2*f**2*r**2 - 1536*C*Dd**2*Pk2*f**2*r - 1056*D1**2*Pk2*f*fd*r**2 + 1560*D1**2*Pk2*f*fd*r*s + 184*D1**2*Pk2*f*fd*r + 1188*D1**2*Pk2*f*fd*s**2 - 1312*D1**2*Pk2*f*fd*s + 44*D1**2*Pk2*f*fd - 1176*D1**2*Pk2*f*fdd*r*s + 392*D1**2*Pk2*f*fdd*r - 1188*D1**2*Pk2*f*fdd*s**2 + 1184*D1**2*Pk2*f*fdd*s - 396*D1**2*Pk2*f*fdd - 2352*D1**2*Pk2*fd**2*r*s + 784*D1**2*Pk2*fd**2*r - 2376*D1**2*Pk2*fd**2*s**2 + 2368*D1**2*Pk2*fd**2*s - 392*D1**2*Pk2*fd**2 - 33*D1**2*Pkdd2*f*fd*k1**2*s**2 + 22*D1**2*Pkdd2*f*fd*k1**2*s - 11*D1**2*Pkdd2*f*fd*k1**2 - 22*D1**2*bd1**2*(Pk2*(40*C - 40)*(3*r**2 + r*(4*s - 5) - 2*s + 2) + Pkdd2*k1**2*s*(12*C + 1)*(s - 1)) + 11*D1**2*bdd1*f*(4*Pk2*(2*C*r*(r + 4*s - 4) + 6*r**2 + 10*r*s + 15*s**2 - 18*s + 4) - Pkdd2*k1**2*(12*C + 1)*(s - 1)**2) - 1408*D1*Dd*Pk2*f**2*r**2 + 2080*D1*Dd*Pk2*f**2*r*s + 184*D1*Dd*Pk2*f**2*r + 1584*D1*Dd*Pk2*f**2*s**2 - 1312*D1*Dd*Pk2*f**2*s + 44*D1*Dd*Pk2*f**2 - 9408*D1*Dd*Pk2*f*fd*r*s + 2744*D1*Dd*Pk2*f*fd*r - 9504*D1*Dd*Pk2*f*fd*s**2 + 8288*D1*Dd*Pk2*f*fd*s - 1576*D1*Dd*Pk2*f*fd - 44*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 22*D1*Dd*Pkdd2*f**2*k1**2*s - 11*D1*Dd*Pkdd2*f**2*k1**2 - 1568*D1*Ddd*Pk2*f**2*r*s + 392*D1*Ddd*Pk2*f**2*r - 1584*D1*Ddd*Pk2*f**2*s**2 + 1184*D1*Ddd*Pk2*f**2*s - 396*D1*Ddd*Pk2*f**2 + 11*D1*bd1*(8*D1*Pk2*fd*(2*C*(2*r**2 + 8*r*s - 5*r - 2*s + 2) + 12*r**2 + 20*r*s - 11*r + 30*s**2 - 29*s + 5) + D1*Pkdd2*fd*k1**2*s*(-48*C - 4)*(s - 1) + D1*f*(4*Pk2*(2*C*(7*r**2 - 6*r*s + 3) - 24*r**2 - 6*r*s + 10*r - 15*s**2 + 18*s - 11) + Pkdd2*k1**2*(12*C*(s**2 - 4*s + 2) - 2*s + 1)) + 8*Dd*Pk2*f*(C*(8*r**2 + 32*r*s - 22*r - 4*s + 4) + 24*r**2 + 40*r*s - 11*r + 60*s**2 - 56*s + 9) - Dd*Pkdd2*f*k1**2*(24*C + 2)*(4*s**2 - 5*s + 1)) - 4704*Dd**2*Pk2*f**2*r*s + 1176*Dd**2*Pk2*f**2*r - 4752*Dd**2*Pk2*f**2*s**2 + 3552*Dd**2*Pk2*f**2*s - 392*Dd**2*Pk2*f**2))/(462*d**2*k1*k3**2) + D1**2*Pk1*ct*k2*(2*D1*f*(2*D1*Pk2*bd1**2*(9*r**2 + 2*r*(5*s - 7) - 14*s**2 + 9*s + 5) + D1*Pk2*bdd1*f*(r**2*(4*C + 2) - r*(8*C + 14)*(s - 1) - 19*(s - 1)**2) + bd1*(D1*(2*Pk2*fd*(4*C*(2*r**2 - 4*r*s + r + s - 1) + 4*r**2 - 28*r*s + 12*r - 38*s**2 + 45*s - 7) + f*(Pk2*(r**2*(52*C - 10) + r*(8*C - 2)*(s - 1) + 19*(s - 1)**2) - Pkdd2*k1**2*(12*C + 3)*(s - 1)**2)) + 2*Dd*Pk2*f*(4*C*(4*r**2 - 8*r*s + 4*r + s - 1) + 8*r**2 - 56*r*s + 33*r - 76*s**2 + 102*s - 26))) + b1**2*(D1**2*(Pk2*fd*(r**2*(56*C - 50) - 68*r*s + 28*s**2) + 2*Pk2*fdd*(9*r**2 + 10*r*s - 14*s**2) + Pkdd2*fd*k1**2*s**2*(-28*C - 7)) + D1*(Dd*(4*Pk2*fd*(36*r**2 + 2*r*(20*s - 7) + s*(9 - 56*s)) + f*(2*Pk2*(28*C*(4*r**2 - 2*r + 1) - 100*r**2 - 136*r*s + 84*r + 56*s**2 + 6*s - 11) + Pkdd2*k1**2*(-28*C - 7)*(4*s**2 - 2*s + 1))) + 2*Ddd*Pk2*f*(36*r**2 + 4*r*(10*s - 7) - 56*s**2 + 18*s - 5)) + 4*Dd**2*Pk2*f*(54*r**2 + 6*r*(10*s - 7) - 84*s**2 + 27*s + 5)) + b1*(2*D1**2*Pk2*bdd1*f*(18*r**2 + 4*r*(5*s - 7) - 28*s**2 + 18*s - 5) + 4*D1**2*(Pk2*fd**2*(r**2*(4*C + 2) - 2*r*(C*(4*s + 2) + 7*s + 1) + s*(4*C - 19*s + 7)) + f*(Pk2*fdd*(C*(4*r**2 - 4*r*(2*s + 1) + 4*s + 2) + 2*r**2 - 2*r*(7*s + 1) - 19*s**2 + 7*s + 1) + fd*(Pk2*(C*(52*r**2 + r*(8*s - 52) - 4*s + 26) - 10*r**2 - 2*r*(s - 5) + 19*s**2 + s - 5) + Pkdd2*k1**2*s**2*(-12*C - 3)))) + D1*bd1*(D1*(4*Pk2*fd*(18*r**2 + 2*r*(10*s - 7) + s*(9 - 28*s)) + f*(2*Pk2*(28*C*(2*r**2 - 2*r + 1) - 50*r**2 - 68*r*s + 84*r + 28*s**2 + 6*s - 11) + Pkdd2*k1**2*(-28*C - 7)*(2*s**2 - 2*s + 1))) + 4*Dd*Pk2*f*(72*r**2 + r*(80*s - 84) - 112*s**2 + 54*s + 5)) + 2*D1*f*(Dd*(2*Pk2*fd*(24*C*s + r**2*(32*C + 16) - 2*r*(32*C*s + 8*C + 56*s - 1) - 152*s**2 + 80*s - 5) + f*(Pk2*(4*C*(52*r**2 + 8*r*s - 28*r - 2*s + 13) - 40*r**2 - 8*r*s + 22*r + 76*s**2 - 36*s + 9) + Pkdd2*k1**2*(-12*C - 3)*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(4*C*(4*r**2 - 8*r*s + 2*s + 1) + 8*r**2 - 56*r*s + 10*r - 76*s**2 + 52*s - 17)) + 4*Dd**2*Pk2*f**2*(4*C*(6*r**2 - 12*r*s + 3*s - 1) + 12*r**2 + r*(15 - 84*s) - 114*s**2 + 78*s - 7)))/(21*d**2*k1*k3**2) + D1**2*Pk1*ct*st**4*(858*D1**2*bd1**2*f*s*(8*Pk2*(K*(2*r - 1) - 2*r + s + 1) + Pkdd2*k1**2*s) + 52*D1*bd1*(D1*(264*Pk2*f*s*(2*g2*(r - 1) - 2*gd2*r + gd2) - 264*Pk2*fd*g2*(r*(2*s - 1) - s + 1) + 5*f**3*(4*Pk2*(2*s**2 + s*(6*r - 6) + 1) + Pkdd2*k1**2*s**2) - 5*f**2*fd*(4*Pk2*(18*r*s - 3*r + 6*s**2 - 11*s + 2) + Pkdd2*k1**2*s*(3*s - 1))) + Dd*f*(-264*Pk2*g2*(r*(8*s - 1) - 5*s + 1) - 5*f**2*(4*Pk2*(24*r*s - 3*r + 8*s**2 - 17*s + 3) + Pkdd2*k1**2*s*(4*s - 1)))) - 429*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(8*Pk2*(r*(2*K - 2) + s - 1) + Pkdd2*k1**2*(s - 1)) + D1*(2*Dd*(f*(8*Pk2*(-2*K*s + r*(2*K - 2)*(4*s - 1) + 4*s**2 + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - fd*(8*K*Pk2*(r*(8*s - 5) - s + 1) + 8*Pk2*(r*(5 - 8*s) + s*(4*s - 4)) + Pkdd2*k1**2*(4*s**2 - 5*s + 1))) - Ddd*f*(8*Pk2*(-2*K*s + r*(2*K - 2)*(4*s - 1) + 4*s**2 + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(8*Pk2*(3*K*r*(4*s - 1) - 3*K*s + K + r*(3 - 12*s) + 6*s**2 - 1) + 3*Pkdd2*k1**2*s*(2*s - 1))) - 26*b1*(D1**2*(-528*Pk2*r*(fd*(2*g2*(s - 1) - 2*gd2*s + gd2) - fdd*g2*(s - 1)) - 5*f**2*(2*fd - fdd)*(4*Pk2*(6*r*(3*s - 1) + 6*s**2 - 4*s + 1) + Pkdd2*k1**2*(3*s**2 - 2*s + 1)) + f*(10*fd**2*(4*Pk2*(18*r*s - 6*r + 6*s**2 - 4*s + 1) + Pkdd2*k1**2*s*(3*s - 2)) - 33*s*(8*Pk2*bdd1*(K*(2*r - 1) - 2*r + s + 1) + Pk2*r*(32*gd2 - 16*gdd2) + Pkdd2*bdd1*k1**2*s))) + 66*D1*bd1*(D1*f*s*(8*Pk2*(K*(2*r - 1) - 2*r + s + 1) + Pkdd2*k1**2*s) + D1*fd*(-4*Pk2*(K*r*(4*s - 2) - K*s + K + r*(2 - 4*s) + 2*s**2 - s - 1) - Pkdd2*k1**2*s*(s - 1)) - 4*Dd*Pk2*f*(2*K*r*(8*s - 1) - 6*K*s + K + r*(2 - 16*s) + 8*s**2 + 4*s - 1) + Dd*Pkdd2*f*k1**2*s*(1 - 4*s)) + D1*(-2*Dd*(264*Pk2*f*(g2*r*(8*s - 2) - 2*g2*s + gd2*(-8*r*s + r + s)) - 264*Pk2*fd*g2*(r*(8*s - 5) - s + 1) + 5*f**3*(8*Pk2*(4*s - 1)*(3*r + s - 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 5*f**2*fd*(4*Pk2*(3*r*(24*s - 7) + 24*s**2 - 23*s + 5) + Pkdd2*k1**2*(12*s**2 - 7*s + 1))) + Ddd*f*(528*Pk2*g2*(r*(4*s - 1) - s) + 5*f**2*(8*Pk2*(4*s - 1)*(3*r + s - 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 6*Dd**2*f*(88*Pk2*g2*(3*r*(4*s - 1) - 3*s + 1) + 5*f**2*(4*Pk2*(4*s - 1)*(3*r + s - 1) + Pkdd2*k1**2*s*(2*s - 1)))) + 2*f*(-13*D1**2*bdd1*(528*Pk2*g2*s*(r - 1) + 5*f**2*(4*Pk2*(2*s**2 + s*(6*r - 6) + 1) + Pkdd2*k1**2*s**2)) + f*(D1**2*(f*(2*Pk2*fd*(352*r*(4*s - 1) - 3900*s**2 + 1598*s - 975) + 10*Pk2*fdd*(48*r*(4*s - 1) + 572*s**2 - 334*s + 143) + 50*Pkdd2*fd*k1**2*(4*s**2 - 2*s + 1) - 25*Pkdd2*fdd*k1**2*(4*s**2 - 2*s + 1)) + 30*fd**2*(2*Pk2*(24*r*(4*s - 1) + 286*s**2 - 167*s + 8) + 5*Pkdd2*k1**2*s*(1 - 2*s))) + D1*f*(2*Dd*(f*(Pk2*(352*r*(4*s - 1) - 3900*s**2 + 1598*s - 975) + 25*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 5*fd*(4*s - 1)*(2*Pk2*(192*r + 572*s - 191) + 5*Pkdd2*k1**2*(1 - 4*s))) + 5*Ddd*f*(2*Pk2*(48*r*(4*s - 1) + 572*s**2 - 334*s + 143) - 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 30*Dd**2*f**2*(2*Pk2*(24*r*(4*s - 1) + 286*s**2 - 167*s + 8) + 5*Pkdd2*k1**2*s*(1 - 2*s)))))/(3003*d**2*k1*k2) - D1**2*Pk1*ct*st**2*(-2288*D1**2*K*Pk2*bdd1*f**2*r*s - 4576*D1**2*Pk2*b2*f*fd*r*s + 2288*D1**2*Pk2*b2*f*fd*r + 2288*D1**2*Pk2*b2*f*fd*s - 2288*D1**2*Pk2*bd2*f**2*r*s - 1664*D1**2*Pk2*bdd1*f**3*r**2 - 4992*D1**2*Pk2*bdd1*f**3*r*s + 4992*D1**2*Pk2*bdd1*f**3*r - 3432*D1**2*Pk2*bdd1*f**3*s**2 + 12012*D1**2*Pk2*bdd1*f**3*s - 6838*D1**2*Pk2*bdd1*f**3 - 2288*D1**2*Pk2*bdd1*f**2*r**2 + 2288*D1**2*Pk2*bdd1*f**2*r*s - 3146*D1**2*Pk2*bdd1*f**2*s**2 - 25168*D1**2*Pk2*bdd1*f*g2*r*s + 2288*D1**2*Pk2*bdd1*f*g2*r + 22880*D1**2*Pk2*bdd1*f*g2*s - 3360*D1**2*Pk2*f**3*fd*r**2 - 26624*D1**2*Pk2*f**3*fd*r*s + 8336*D1**2*Pk2*f**3*fd*r - 34320*D1**2*Pk2*f**3*fd*s**2 + 23816*D1**2*Pk2*f**3*fd*s - 9420*D1**2*Pk2*f**3*fd + 640*D1**2*Pk2*f**3*fdd*r**2 + 26624*D1**2*Pk2*f**3*fdd*r*s - 6976*D1**2*Pk2*f**3*fdd*r + 34320*D1**2*Pk2*f**3*fdd*s**2 - 23816*D1**2*Pk2*f**3*fdd*s + 8740*D1**2*Pk2*f**3*fdd + 1920*D1**2*Pk2*f**2*fd**2*r**2 + 79872*D1**2*Pk2*f**2*fd**2*r*s - 20928*D1**2*Pk2*f**2*fd**2*r + 102960*D1**2*Pk2*f**2*fd**2*s**2 - 71448*D1**2*Pk2*f**2*fd**2*s + 6656*D1**2*Pk2*f**2*fd**2 - 4576*D1**2*Pk2*f**2*gd2*r*s + 4576*D1**2*Pk2*f**2*gdd2*r*s - 9152*D1**2*Pk2*f*fd*g2*r*s + 4576*D1**2*Pk2*f*fd*g2*r + 4576*D1**2*Pk2*f*fd*g2*s + 18304*D1**2*Pk2*f*fd*gd2*r*s - 4576*D1**2*Pk2*f*fd*gd2*r - 4576*D1**2*Pk2*f*fd*gd2*s + 9152*D1**2*Pk2*f*fdd*g2*r*s - 4576*D1**2*Pk2*f*fdd*g2*r - 4576*D1**2*Pk2*f*fdd*g2*s + 9152*D1**2*Pk2*fd**2*g2*r*s - 4576*D1**2*Pk2*fd**2*g2*r - 4576*D1**2*Pk2*fd**2*g2*s + 4576*D1**2*Pk2*fd**2*g2 + 325*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 650*D1**2*Pkdd2*bdd1*f**3*k1**2*s + 325*D1**2*Pkdd2*bdd1*f**3*k1**2 + 1300*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 650*D1**2*Pkdd2*f**3*fd*k1**2*s + 325*D1**2*Pkdd2*f**3*fd*k1**2 + 286*D1**2*bd1**2*(56*Pk2*g2*(r*(2*s - 1) - s + 1) + f*(Pk2*r*(4*K - 4)*(22*s - 1) + 2*Pk2*s*(-20*K + f*(21 - 42*s) + 29*s + 20) + Pkdd2*k1**2*s*(6*f + 1)*(s - 1))) - 9152*D1*Dd*Pk2*b2*f**2*r*s + 2288*D1*Dd*Pk2*b2*f**2*r + 2288*D1*Dd*Pk2*b2*f**2*s - 3360*D1*Dd*Pk2*f**4*r**2 - 26624*D1*Dd*Pk2*f**4*r*s + 8336*D1*Dd*Pk2*f**4*r - 34320*D1*Dd*Pk2*f**4*s**2 + 23816*D1*Dd*Pk2*f**4*s - 9420*D1*Dd*Pk2*f**4 + 5120*D1*Dd*Pk2*f**3*fd*r**2 + 212992*D1*Dd*Pk2*f**3*fd*r*s - 55808*D1*Dd*Pk2*f**3*fd*r + 274560*D1*Dd*Pk2*f**3*fd*s**2 - 190528*D1*Dd*Pk2*f**3*fd*s + 30792*D1*Dd*Pk2*f**3*fd - 18304*D1*Dd*Pk2*f**2*g2*r*s + 4576*D1*Dd*Pk2*f**2*g2*r + 4576*D1*Dd*Pk2*f**2*g2*s + 36608*D1*Dd*Pk2*f**2*gd2*r*s - 4576*D1*Dd*Pk2*f**2*gd2*r - 4576*D1*Dd*Pk2*f**2*gd2*s + 73216*D1*Dd*Pk2*f*fd*g2*r*s - 27456*D1*Dd*Pk2*f*fd*g2*r - 27456*D1*Dd*Pk2*f*fd*g2*s + 9152*D1*Dd*Pk2*f*fd*g2 + 1300*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 650*D1*Dd*Pkdd2*f**4*k1**2*s + 325*D1*Dd*Pkdd2*f**4*k1**2 + 640*D1*Ddd*Pk2*f**4*r**2 + 26624*D1*Ddd*Pk2*f**4*r*s - 6976*D1*Ddd*Pk2*f**4*r + 34320*D1*Ddd*Pk2*f**4*s**2 - 23816*D1*Ddd*Pk2*f**4*s + 8740*D1*Ddd*Pk2*f**4 + 18304*D1*Ddd*Pk2*f**2*g2*r*s - 4576*D1*Ddd*Pk2*f**2*g2*r - 4576*D1*Ddd*Pk2*f**2*g2*s - 13*D1*bd1*(D1*(44*Pk2*f*(fd*(16*r**2 + 4*r*(4*K*s - K - 4*s - 1) + s*(-4*K + 22*s - 7)) - 88*g2*r*s + 8*g2*r + 80*g2*s + 88*gd2*r*s - 4*gd2*r - 40*gd2*s) + 1936*Pk2*fd*g2*(r*(2*s - 1) - s + 1) + 2*f**3*(Pk2*(4*r**2 + 4*r*(36*s - 25) - 264*s**2 + 594*s - 295) + Pkdd2*k1**2*(-8*s**2 - 50*s + 25)) + f**2*(8*Pk2*fd*(96*r**2 + 16*r*(18*s - 11) + 198*s**2 - 345*s + 32) - 22*Pk2*(10*r**2 + r*s*(8*K - 24) + 17*s**2) - 150*Pkdd2*fd*k1**2*s*(s - 1) - 11*Pkdd2*k1**2*s**2)) + 2*Dd*f*(22*Pk2*f*(32*r**2 + 4*r*(8*K*s - K - 8*s - 1) + s*(-4*K + 44*s - 7)) + 88*Pk2*g2*(r*(88*s - 15) - 51*s + 11) + f**2*(2*Pk2*(256*r**2 + 768*r*s - 544*r + 528*s**2 - 1152*s + 327) - 25*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 1920*Dd**2*Pk2*f**4*r**2 + 79872*Dd**2*Pk2*f**4*r*s - 20928*Dd**2*Pk2*f**4*r + 102960*Dd**2*Pk2*f**4*s**2 - 71448*Dd**2*Pk2*f**4*s + 6656*Dd**2*Pk2*f**4 + 54912*Dd**2*Pk2*f**2*g2*r*s - 13728*Dd**2*Pk2*f**2*g2*r - 13728*Dd**2*Pk2*f**2*g2*s + 4576*Dd**2*Pk2*f**2*g2 - 143*b1**3*(2*D1*Dd*(Pk2*(56 - 56*K)*(r*(4*s - 1) - s) + Pkdd2*k1**2*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd + 28) + s*(3*fd + 14) - 7)) + D1*(3*D1*Pkdd2*k1**2*s**2*(2*fd - fdd) + 56*Ddd*Pk2*(K - 1)*(r*(4*s - 1) - s) - Ddd*Pkdd2*k1**2*(3*f - 7)*(4*s**2 - 2*s + 1)) + 2*Dd**2*(Pk2*(28*K - 28)*(3*r*(4*s - 1) - 3*s + 1) + Pkdd2*k1**2*s*(21 - 9*f)*(2*s - 1))) + 143*b1**2*(D1**2*(-168*K*Pk2*bdd1*r*s + 56*K*Pk2*bdd1*r + 56*K*Pk2*bdd1*s + 168*Pk2*bdd1*r*s - 56*Pk2*bdd1*r - 56*Pk2*bdd1*s - 2*Pk2*fdd*(4*K*s + 21*f*(4*s**2 - 2*s + 1) - r*(4*K - 4)*(11*s - 10) - 29*s**2 + 54*s - 29) - 224*Pk2*gd2*r*s + 112*Pk2*gdd2*r*s + 9*Pkdd2*bdd1*f*k1**2*s**2 - 6*Pkdd2*bdd1*f*k1**2*s + 3*Pkdd2*bdd1*f*k1**2 - 21*Pkdd2*bdd1*k1**2*s**2 + 14*Pkdd2*bdd1*k1**2*s - 7*Pkdd2*bdd1*k1**2 + Pkdd2*fdd*k1**2*s**2*(12*f + 1) + 12*fd**2*s*(Pk2*(7 - 14*s) + Pkdd2*k1**2*s) + fd*(-2*Pk2*(-8*K*s + f*(8*r*(8*s - 1) - 108*s**2 + 46*s - 27) + r*(8*K - 8)*(11*s - 10) + 23*s**2 - 38*s + 23) - Pkdd2*k1**2*(3*f*(6*s**2 + 2*s - 1) + 9*s**2 - 14*s + 7))) + 2*D1*bd1*(56*D1*Pk2*(K - 1)*(r*(3*s - 1) - s) + D1*Pkdd2*k1**2*(f*(-9*s**2 + 6*s - 3) + s**2*(9*fd + 21) - s*(3*fd + 14) + 7) - 28*Dd*Pk2*(K - 1)*(r*(24*s - 7) - 7*s + 2) + Dd*Pkdd2*k1**2*(3*f - 7)*(12*s**2 - 7*s + 1)) - D1*(Dd*(112*Pk2*(g2*r*(8*s - 2) - 2*g2*s + gd2*(-8*r*s + r + s)) + f**2*(4*Pk2*(16*r*(4*s - 1) - 108*s**2 + 38*s - 27) + 9*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(2*Pk2*(-88*K*s + 42*fd*(1 - 4*s)**2 + r*(88*K - 88)*(4*s - 1) + 92*s**2 + 42*s + 23) + 3*Pkdd2*k1**2*(-s**2*(32*fd - 12) + s*(8*fd - 6) + 3)) - 2*fd*(2*Pk2*(2*K*(88*r*s - 51*r - 15*s + 11) - 176*r*s + 102*r + 116*s**2 - 115*s + 7) + Pkdd2*k1**2*s*(4*s - 1))) + Ddd*(112*Pk2*g2*(-4*r*s + r + s) + 6*f**2*(14*Pk2 - Pkdd2*k1**2)*(4*s**2 - 2*s + 1) - f*(Pk2*(r*(88*K - 88)*(4*s - 1) + 232*s**2 - s*(88*K + 28) + 58) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) - 2*Dd**2*(-56*Pk2*g2*(3*r*(4*s - 1) - 3*s + 1) + 18*f**2*s*(14*Pk2 - Pkdd2*k1**2)*(2*s - 1) + f*(-2*Pk2*(22*K*(12*r*s - 3*r - 3*s + 1) - 264*r*s + 66*r + 174*s**2 - 21*s - 22) + 3*Pkdd2*k1**2*s*(1 - 2*s)))) - 13*b1*(-352*D1**2*K*Pk2*f*fd*r*s + 176*D1**2*K*Pk2*f*fd*r + 176*D1**2*K*Pk2*f*fd*s + 352*D1**2*K*Pk2*f*fdd*r*s - 176*D1**2*K*Pk2*f*fdd*r - 176*D1**2*K*Pk2*f*fdd*s + 352*D1**2*K*Pk2*fd**2*r*s - 176*D1**2*K*Pk2*fd**2*r - 176*D1**2*K*Pk2*fd**2*s + 176*D1**2*K*Pk2*fd**2 + 24*D1**2*Pk2*f**2*fd*r**2 + 864*D1**2*Pk2*f**2*fd*r*s - 104*D1**2*Pk2*f**2*fd*r - 1584*D1**2*Pk2*f**2*fd*s**2 - 420*D1**2*Pk2*f**2*fd*s + 70*D1**2*Pk2*f**2*fd + 384*D1**2*Pk2*f**2*fdd*r**2 + 1152*D1**2*Pk2*f**2*fdd*r*s - 256*D1**2*Pk2*f**2*fdd*r + 792*D1**2*Pk2*f**2*fdd*s**2 + 12*D1**2*Pk2*f**2*fdd*s - 134*D1**2*Pk2*f**2*fdd + 768*D1**2*Pk2*f*fd**2*r**2 + 2304*D1**2*Pk2*f*fd**2*r*s - 512*D1**2*Pk2*f*fd**2*r + 1584*D1**2*Pk2*f*fd**2*s**2 + 24*D1**2*Pk2*f*fd**2*s + 128*D1**2*Pk2*f*fd**2 - 440*D1**2*Pk2*f*fd*r**2 + 1056*D1**2*Pk2*f*fd*r*s - 88*D1**2*Pk2*f*fd*r - 748*D1**2*Pk2*f*fd*s**2 + 220*D1**2*Pk2*f*fd*s - 594*D1**2*Pk2*f*fd + 352*D1**2*Pk2*f*fdd*r**2 - 352*D1**2*Pk2*f*fdd*r*s - 176*D1**2*Pk2*f*fdd*r + 484*D1**2*Pk2*f*fdd*s**2 - 308*D1**2*Pk2*f*fdd*s + 418*D1**2*Pk2*f*fdd - 3872*D1**2*Pk2*f*gd2*r*s + 1936*D1**2*Pk2*f*gdd2*r*s + 352*D1**2*Pk2*fd**2*r**2 - 352*D1**2*Pk2*fd**2*r*s - 176*D1**2*Pk2*fd**2*r + 484*D1**2*Pk2*fd**2*s**2 - 308*D1**2*Pk2*fd**2*s - 176*D1**2*Pk2*fd**2 - 3872*D1**2*Pk2*fd*g2*r*s + 3520*D1**2*Pk2*fd*g2*r + 352*D1**2*Pk2*fd*g2*s + 3872*D1**2*Pk2*fd*gd2*r*s - 1760*D1**2*Pk2*fd*gd2*r - 176*D1**2*Pk2*fd*gd2*s + 1936*D1**2*Pk2*fdd*g2*r*s - 1760*D1**2*Pk2*fdd*g2*r - 176*D1**2*Pk2*fdd*g2*s - 48*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 132*D1**2*Pkdd2*f**2*fd*k1**2*s - 66*D1**2*Pkdd2*f**2*fd*k1**2 - 75*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 150*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 22*D1**2*Pkdd2*f*fd*k1**2*s**2 + 22*D1**2*Pkdd2*f*fd*k1**2*s - 11*D1**2*Pkdd2*f*fd*k1**2 + 22*D1**2*bd1**2*(Pk2*(28*K - 28)*(r*(6*s - 2) - 2*s + 1) - Pkdd2*k1**2*s*(3*f - 7)*(3*s - 2)) + 11*D1**2*bdd1*(112*Pk2*g2*(-2*r*s + r + s) + 6*f**2*(7*Pk2*(4*s**2 - 2*s + 1) + Pkdd2*k1**2*(-2*s**2 + 2*s - 1)) - f*(Pk2*r*(8*K - 8)*(22*s - 1) + 4*Pk2*s*(-20*K + 29*s + 20) + Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 704*D1*Dd*K*Pk2*f**2*r*s + 176*D1*Dd*K*Pk2*f**2*r + 176*D1*Dd*K*Pk2*f**2*s + 2816*D1*Dd*K*Pk2*f*fd*r*s - 1056*D1*Dd*K*Pk2*f*fd*r - 1056*D1*Dd*K*Pk2*f*fd*s + 352*D1*Dd*K*Pk2*f*fd + 32*D1*Dd*Pk2*f**3*r**2 + 1152*D1*Dd*Pk2*f**3*r*s - 304*D1*Dd*Pk2*f**3*r - 2112*D1*Dd*Pk2*f**3*s**2 + 768*D1*Dd*Pk2*f**3*s - 520*D1*Dd*Pk2*f**3 + 3072*D1*Dd*Pk2*f**2*fd*r**2 + 9216*D1*Dd*Pk2*f**2*fd*r*s - 2944*D1*Dd*Pk2*f**2*fd*r + 6336*D1*Dd*Pk2*f**2*fd*s**2 - 2688*D1*Dd*Pk2*f**2*fd*s + 244*D1*Dd*Pk2*f**2*fd - 880*D1*Dd*Pk2*f**2*r**2 + 2112*D1*Dd*Pk2*f**2*r*s - 88*D1*Dd*Pk2*f**2*r - 1496*D1*Dd*Pk2*f**2*s**2 + 220*D1*Dd*Pk2*f**2*s - 594*D1*Dd*Pk2*f**2 + 2816*D1*Dd*Pk2*f*fd*r**2 - 2816*D1*Dd*Pk2*f*fd*r*s - 1056*D1*Dd*Pk2*f*fd*r + 3872*D1*Dd*Pk2*f*fd*s**2 - 1848*D1*Dd*Pk2*f*fd*s + 484*D1*Dd*Pk2*f*fd - 15488*D1*Dd*Pk2*f*g2*r*s + 3872*D1*Dd*Pk2*f*g2*r + 3872*D1*Dd*Pk2*f*g2*s + 15488*D1*Dd*Pk2*f*gd2*r*s - 1936*D1*Dd*Pk2*f*gd2*r - 1936*D1*Dd*Pk2*f*gd2*s + 15488*D1*Dd*Pk2*fd*g2*r*s - 8976*D1*Dd*Pk2*fd*g2*r - 2640*D1*Dd*Pk2*fd*g2*s + 1936*D1*Dd*Pk2*fd*g2 - 64*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 32*D1*Dd*Pkdd2*f**3*k1**2*s - 16*D1*Dd*Pkdd2*f**3*k1**2 - 600*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 150*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 44*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 22*D1*Dd*Pkdd2*f**2*k1**2*s - 11*D1*Dd*Pkdd2*f**2*k1**2 + 704*D1*Ddd*K*Pk2*f**2*r*s - 176*D1*Ddd*K*Pk2*f**2*r - 176*D1*Ddd*K*Pk2*f**2*s + 512*D1*Ddd*Pk2*f**3*r**2 + 1536*D1*Ddd*Pk2*f**3*r*s - 640*D1*Ddd*Pk2*f**3*r + 1056*D1*Ddd*Pk2*f**3*s**2 - 912*D1*Ddd*Pk2*f**3*s + 392*D1*Ddd*Pk2*f**3 + 704*D1*Ddd*Pk2*f**2*r**2 - 704*D1*Ddd*Pk2*f**2*r*s - 176*D1*Ddd*Pk2*f**2*r + 968*D1*Ddd*Pk2*f**2*s**2 - 308*D1*Ddd*Pk2*f**2*s + 418*D1*Ddd*Pk2*f**2 + 7744*D1*Ddd*Pk2*f*g2*r*s - 1936*D1*Ddd*Pk2*f*g2*r - 1936*D1*Ddd*Pk2*f*g2*s - 100*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 50*D1*Ddd*Pkdd2*f**3*k1**2*s - 25*D1*Ddd*Pkdd2*f**3*k1**2 + 22*D1*bd1*(D1*(56*Pk2*(g2*r*(4*s - 2) - 2*g2*s + gd2*(-4*r*s + r + s)) + f**2*(8*Pk2*r*(8*s - 3) - 3*Pk2*(36*s**2 - 10*s + 9) + 3*Pkdd2*k1**2*(3*s**2 - 4*s + 2)) + f*(2*Pk2*(r*(4*K - 4)*(22*s - 1) + s*(-40*K + 84*fd*(2*s - 1) + 23*s + 40)) + Pkdd2*k1**2*(s**2*(9 - 24*fd) + s*(12*fd - 2) + 1)) + fd*(-4*Pk2*(K*(44*r*s - 21*r - 12*s + 11) - 44*r*s + 21*r + 29*s**2 - 17*s - 11) + Pkdd2*k1**2*s*(1 - 2*s))) + Dd*(-112*Pk2*g2*(r*(8*s - 3) - 3*s + 1) + 6*f**2*(4*s - 1)*(7*Pk2*(4*s - 1) + Pkdd2*k1**2*(1 - 2*s)) - f*(4*Pk2*(K*(176*r*s - 26*r - 62*s + 11) - 176*r*s + 26*r + 116*s**2 + 33*s - 11) + Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) + 2112*Dd**2*K*Pk2*f**2*r*s - 528*Dd**2*K*Pk2*f**2*r - 528*Dd**2*K*Pk2*f**2*s + 176*Dd**2*K*Pk2*f**2 + 1536*Dd**2*Pk2*f**3*r**2 + 4608*Dd**2*Pk2*f**3*r*s - 1920*Dd**2*Pk2*f**3*r + 3168*Dd**2*Pk2*f**3*s**2 - 2736*Dd**2*Pk2*f**3*s + 384*Dd**2*Pk2*f**3 + 2112*Dd**2*Pk2*f**2*r**2 - 2112*Dd**2*Pk2*f**2*r*s - 528*Dd**2*Pk2*f**2*r + 2904*Dd**2*Pk2*f**2*s**2 - 924*Dd**2*Pk2*f**2*s - 176*Dd**2*Pk2*f**2 + 23232*Dd**2*Pk2*f*g2*r*s - 5808*Dd**2*Pk2*f*g2*r - 5808*Dd**2*Pk2*f*g2*s + 1936*Dd**2*Pk2*f*g2 - 300*Dd**2*Pkdd2*f**3*k1**2*s**2 + 150*Dd**2*Pkdd2*f**3*k1**2*s))/(6006*d**2*k1*k2) - D1**2*Pk1*ct*(-44*D1**2*Pk2*bd1**2*(f**2*(2*r**2 + r*(5 - 16*s) - 42*s**2 + 27*s - 4) + f*(9*r**2 + r*(3*K - 3)*(2*s - 1) - 14*s**2) + 14*g2*(r*(2*s - 1) - s + 1)) - D1*bd1*(D1*(2*Pk2*f**2*(-4*fd*(15*r**2 + 396*r*s - 159*r + 594*s**2 - 462*s + 44) + 11*s*(r*(4*K + 4) + 19*s)) - 44*Pk2*f*(fd*(r*(2*K + 2)*(4*s - 1) + s*(-2*K + 38*s - 21)) - 6*r*(2*g2*(s - 1) - 2*gd2*s + gd2)) - 264*Pk2*fd*g2*(r*(2*s - 1) - s + 1) + f**3*(4*Pk2*(65*r**2 + 44*r*(3*s - 2) + 198*s**2 - 198*s + 99) - 55*Pkdd2*k1**2*(s - 1)**2)) - 4*Dd*Pk2*f*(2*f**2*(20*r**2 + 528*r*s - 247*r + 792*s**2 - 660*s + 143) + 11*f*(r*(2*K + 2)*(8*s - 1) + s*(-2*K + 76*s - 21)) + 66*g2*(r*(8*s - 5) - s + 1))) + 2*Pk2*(D1**2*bdd1*f*(2*f**2*(5*r**2 + 44*r*(3*s - 2) + 198*s**2 - 198*s + 99) + 11*f*s*(r*(4*K + 4) + 19*s) + 132*g2*r*(s - 1)) - 44*D1*Dd*f*(f*(bd2*(-8*r*s + r + s) + 2*g2*(-4*r*s + r + s) + 2*gd2*r*(8*s - 1) - 2*gd2*s) + 4*fd*g2*(r*(8*s - 3) - 3*s + 1)) - 44*D1*(D1*(f*fd*(bd2*(-4*r*s + r + s) + 2*g2*(-2*r*s + r + s) + 2*gd2*(4*r*s - r - s)) + f*(f*r*s*(bd2 - bdd2 - 2*gd2 + 2*gdd2) + 2*fdd*g2*(r*(2*s - 1) - s)) + 2*fd**2*g2*(r*(2*s - 1) - s + 1)) + 2*Ddd*f**2*g2*(r*(4*s - 1) - s)) - 88*Dd**2*f**2*g2*(3*r*(4*s - 1) - 3*s + 1) + 44*b2*(D1*Dd*f*(f*(-4*r*s + r + s) + 2*fd*(8*r*s - 3*r - 3*s + 1)) + D1*(D1*(f*fd*(-2*r*s + r + s) + f*fdd*(2*r*s - r - s) + fd**2*(2*r*s - r - s + 1)) + Ddd*f**2*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))) + 77*b1**3*(D1*Dd*(-Pk2*(8*K - 8)*(r*(4*s - 1) - s) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) + D1*(D1*Pkdd2*fd*k1**2*s**2 + 4*Ddd*Pk2*(K - 1)*(r*(4*s - 1) - s)) + 4*Dd**2*Pk2*(K - 1)*(3*r*(4*s - 1) - 3*s + 1)) - 11*b1**2*(D1**2*(4*Pk2*fd**2*(2*r**2 - 16*r*s + r + s*(23 - 42*s)) - 2*Pk2*(14*bdd1*(K - 1)*(r*(3*s - 1) - s) + fdd*(6*K*s - 2*f*(2*r**2 - 16*r*s + r - 42*s**2 + 23*s - 10) - 9*r**2 + 6*r*(-K*s + s + 3) + 14*s**2 - 34*s + 5) + 14*r*s*(4*gd2 - 2*gdd2)) + fd*(2*Pk2*(12*K*s + 2*f*(14*r**2 + r*(16*s - 9) + 42*s**2 - 23*s + 14) + 3*r**2 - 6*r*(s*(2*K - 2) + 1) + 14*s**2 - 40*s + 17) - Pkdd2*k1**2*s**2*(24*f + 7))) + 7*D1*bd1*(8*D1*Pk2*(K - 1)*(r*(3*s - 1) - s) - D1*Pkdd2*f*k1**2*(3*s**2 - 2*s + 1) - 4*Dd*Pk2*(K - 1)*(r*(24*s - 7) - 7*s + 2)) + D1*(Dd*(4*Pk2*(fd*(3*K*(r*(8*s - 1) - 5*s + 1) + 36*r**2 - 6*r*(4*s + 7) - 56*s**2 + 85*s - 8) - 14*g2*r*(8*s - 2) + 28*g2*s - 14*gd2*(-8*r*s + r + s)) + 4*f**2*(Pk2*(28*r**2 + r*(32*s - 22) + 84*s**2 - 50*s + 28) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(2*Pk2*(12*K*s + 16*fd*(2*r**2 + r*(2 - 16*s) - 42*s**2 + 24*s - 3) + 12*r**2 - 6*r*(8*K*s - 2*K - 8*s + 3) + 56*s**2 - 40*s + 17) - 7*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 2*Ddd*Pk2*(4*f**2*(2*r**2 + r*(3 - 16*s) - 42*s**2 + 25*s - 10) + f*(-6*K*s + 36*r**2 + 6*r*(4*K*s - K - 4*s - 2) - 56*s**2 + 34*s - 5) + 28*g2*(r*(4*s - 1) - s))) + 4*Dd**2*Pk2*(2*f**2*(6*r**2 + r*(9 - 48*s) - 126*s**2 + 75*s - 4) + 3*f*(3*K*r*(4*s - 1) - 3*K*s + K + 18*r**2 - 6*r*(2*s + 1) - 28*s**2 + 17*s - 1) + 14*g2*(3*r*(4*s - 1) - 3*s + 1))) + b1*(-176*D1**2*K*Pk2*f*fd*r*s + 88*D1**2*K*Pk2*f*fd*r + 88*D1**2*K*Pk2*f*fd*s + 176*D1**2*K*Pk2*f*fdd*r*s - 88*D1**2*K*Pk2*f*fdd*r - 88*D1**2*K*Pk2*f*fdd*s + 176*D1**2*K*Pk2*fd**2*r*s - 88*D1**2*K*Pk2*fd**2*r - 88*D1**2*K*Pk2*fd**2*s + 88*D1**2*K*Pk2*fd**2 + 308*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) - 2*s + 1) - 44*D1**2*Pk2*bdd1*(f**2*(2*r**2 + r*(5 - 16*s) - 42*s**2 + 27*s - 10) + f*(9*r**2 + r*(3*K - 3)*(2*s - 1) - 14*s**2) + 14*g2*(r*(2*s - 1) - s)) - 780*D1**2*Pk2*f**2*fd*r**2 - 1584*D1**2*Pk2*f**2*fd*r*s + 696*D1**2*Pk2*f**2*fd*r - 2376*D1**2*Pk2*f**2*fd*s**2 + 1320*D1**2*Pk2*f**2*fd*s - 656*D1**2*Pk2*f**2*fd + 60*D1**2*Pk2*f**2*fdd*r**2 + 1584*D1**2*Pk2*f**2*fdd*r*s - 216*D1**2*Pk2*f**2*fdd*r + 2376*D1**2*Pk2*f**2*fdd*s**2 - 1320*D1**2*Pk2*f**2*fdd*s + 416*D1**2*Pk2*f**2*fdd + 120*D1**2*Pk2*f*fd**2*r**2 + 3168*D1**2*Pk2*f*fd**2*r*s - 432*D1**2*Pk2*f*fd**2*r + 4752*D1**2*Pk2*f*fd**2*s**2 - 2640*D1**2*Pk2*f*fd**2*s + 176*D1**2*Pk2*f*fd**2 - 176*D1**2*Pk2*f*fd*r*s + 88*D1**2*Pk2*f*fd*r - 836*D1**2*Pk2*f*fd*s**2 + 924*D1**2*Pk2*f*fd*s - 418*D1**2*Pk2*f*fd + 176*D1**2*Pk2*f*fdd*r*s - 88*D1**2*Pk2*f*fdd*r + 836*D1**2*Pk2*f*fdd*s**2 - 924*D1**2*Pk2*f*fdd*s + 418*D1**2*Pk2*f*fdd - 528*D1**2*Pk2*f*gd2*r*s + 264*D1**2*Pk2*f*gdd2*r*s + 176*D1**2*Pk2*fd**2*r*s - 88*D1**2*Pk2*fd**2*r + 836*D1**2*Pk2*fd**2*s**2 - 924*D1**2*Pk2*fd**2*s + 88*D1**2*Pk2*fd**2 - 528*D1**2*Pk2*fd*g2*r*s + 528*D1**2*Pk2*fd*g2*s + 528*D1**2*Pk2*fd*gd2*r*s - 264*D1**2*Pk2*fd*gd2*s + 264*D1**2*Pk2*fdd*g2*r*s - 264*D1**2*Pk2*fdd*g2*s + 165*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 352*D1*Dd*K*Pk2*f**2*r*s + 88*D1*Dd*K*Pk2*f**2*r + 88*D1*Dd*K*Pk2*f**2*s + 1408*D1*Dd*K*Pk2*f*fd*r*s - 528*D1*Dd*K*Pk2*f*fd*r - 528*D1*Dd*K*Pk2*f*fd*s + 176*D1*Dd*K*Pk2*f*fd - 1040*D1*Dd*Pk2*f**3*r**2 - 2112*D1*Dd*Pk2*f**3*r*s + 1048*D1*Dd*Pk2*f**3*r - 3168*D1*Dd*Pk2*f**3*s**2 + 2112*D1*Dd*Pk2*f**3*s - 1052*D1*Dd*Pk2*f**3 + 480*D1*Dd*Pk2*f**2*fd*r**2 + 12672*D1*Dd*Pk2*f**2*fd*r*s - 2568*D1*Dd*Pk2*f**2*fd*r + 19008*D1*Dd*Pk2*f**2*fd*s**2 - 11616*D1*Dd*Pk2*f**2*fd*s + 1536*D1*Dd*Pk2*f**2*fd - 352*D1*Dd*Pk2*f**2*r*s + 88*D1*Dd*Pk2*f**2*r - 1672*D1*Dd*Pk2*f**2*s**2 + 924*D1*Dd*Pk2*f**2*s - 418*D1*Dd*Pk2*f**2 + 1408*D1*Dd*Pk2*f*fd*r*s - 528*D1*Dd*Pk2*f*fd*r + 6688*D1*Dd*Pk2*f*fd*s**2 - 5544*D1*Dd*Pk2*f*fd*s + 1012*D1*Dd*Pk2*f*fd - 2112*D1*Dd*Pk2*f*g2*r*s + 528*D1*Dd*Pk2*f*g2*r + 528*D1*Dd*Pk2*f*g2*s + 2112*D1*Dd*Pk2*f*gd2*r*s - 264*D1*Dd*Pk2*f*gd2*r - 264*D1*Dd*Pk2*f*gd2*s + 2112*D1*Dd*Pk2*fd*g2*r*s - 264*D1*Dd*Pk2*fd*g2*r - 1320*D1*Dd*Pk2*fd*g2*s + 264*D1*Dd*Pk2*fd*g2 + 220*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 110*D1*Dd*Pkdd2*f**3*k1**2*s + 55*D1*Dd*Pkdd2*f**3*k1**2 + 352*D1*Ddd*K*Pk2*f**2*r*s - 88*D1*Ddd*K*Pk2*f**2*r - 88*D1*Ddd*K*Pk2*f**2*s + 80*D1*Ddd*Pk2*f**3*r**2 + 2112*D1*Ddd*Pk2*f**3*r*s - 568*D1*Ddd*Pk2*f**3*r + 3168*D1*Ddd*Pk2*f**3*s**2 - 2112*D1*Ddd*Pk2*f**3*s + 812*D1*Ddd*Pk2*f**3 + 352*D1*Ddd*Pk2*f**2*r*s - 88*D1*Ddd*Pk2*f**2*r + 1672*D1*Ddd*Pk2*f**2*s**2 - 924*D1*Ddd*Pk2*f**2*s + 418*D1*Ddd*Pk2*f**2 + 1056*D1*Ddd*Pk2*f*g2*r*s - 264*D1*Ddd*Pk2*f*g2*r - 264*D1*Ddd*Pk2*f*g2*s - 11*D1*bd1*(D1*(4*Pk2*(fd*(3*K*(r*(4*s - 1) - 2*s + 1) + 18*r**2 - 3*r*(4*s + 5) - 28*s**2 + 34*s - 3) - 14*g2*r*(4*s - 2) + 28*g2*s - 14*gd2*(-4*r*s + r + s)) + 4*f**2*(Pk2*(14*r**2 + r*(16*s - 13) + 42*s**2 - 27*s + 14) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(16*Pk2*fd*(2*r**2 + r*(3 - 16*s) - 42*s**2 + 25*s - 1) + 4*Pk2*(3*r**2 - r*(6*K - 6)*(2*s - 1) + 14*s**2) - 7*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 4*Dd*Pk2*(16*f**2*(r**2 + r*(2 - 8*s) - 21*s**2 + 13*s - 2) + f*(3*K*(16*r*s - 6*r - 2*s + 1) + 72*r**2 - 48*r*s - 112*s**2 + 34*s - 3) + 28*g2*(r*(8*s - 3) - 3*s + 1))) + 1056*Dd**2*K*Pk2*f**2*r*s - 264*Dd**2*K*Pk2*f**2*r - 264*Dd**2*K*Pk2*f**2*s + 88*Dd**2*K*Pk2*f**2 + 240*Dd**2*Pk2*f**3*r**2 + 6336*Dd**2*Pk2*f**3*r*s - 1704*Dd**2*Pk2*f**3*r + 9504*Dd**2*Pk2*f**3*s**2 - 6336*Dd**2*Pk2*f**3*s + 528*Dd**2*Pk2*f**3 + 1056*Dd**2*Pk2*f**2*r*s - 264*Dd**2*Pk2*f**2*r + 5016*Dd**2*Pk2*f**2*s**2 - 2772*Dd**2*Pk2*f**2*s + 88*Dd**2*Pk2*f**2 + 3168*Dd**2*Pk2*f*g2*r*s - 792*Dd**2*Pk2*f*g2*r - 792*Dd**2*Pk2*f*g2*s + 264*Dd**2*Pk2*f*g2))/(231*d**2*k1*k2) + D1**2*Pk1*ct*k2**3*st**4*(132*D1**2*Pk2*b1*f*fd*r**2 - 132*D1**2*Pk2*b1*f*fdd*r**2 - 132*D1**2*Pk2*b1*fd**2*r**2 - 294*D1**2*Pk2*f**2*fd*r**2 + 196*D1**2*Pk2*f**2*fd*r - 98*D1**2*Pk2*f**2*fd + 246*D1**2*Pk2*f**2*fdd*r**2 - 164*D1**2*Pk2*f**2*fdd*r + 82*D1**2*Pk2*f**2*fdd + 492*D1**2*Pk2*f*fd**2*r**2 - 328*D1**2*Pk2*f*fd**2*r - 66*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 33*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 66*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 66*D1**2*Pkdd2*b1*f*fd*k1**2*s + 33*D1**2*Pkdd2*b1*f*fd*k1**2 + 66*D1**2*Pkdd2*bd1**2*f*k1**2*s*(s - 1) - 33*D1**2*bdd1*f*(2*Pk2*f*(r - 1)**2 + Pkdd2*b1*k1**2*(-2*s**2 + 2*s - 1)) + 264*D1*Dd*Pk2*b1*f**2*r**2 - 132*D1*Dd*Pk2*b1*f**2*r + 66*D1*Dd*Pk2*b1*f**2 - 1056*D1*Dd*Pk2*b1*f*fd*r**2 + 264*D1*Dd*Pk2*b1*f*fd*r - 392*D1*Dd*Pk2*f**3*r**2 + 196*D1*Dd*Pk2*f**3*r - 98*D1*Dd*Pk2*f**3 + 1968*D1*Dd*Pk2*f**2*fd*r**2 - 1148*D1*Dd*Pk2*f**2*fd*r + 164*D1*Dd*Pk2*f**2*fd - 264*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 132*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 66*D1*Dd*Pkdd2*b1**2*f*k1**2 + 264*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 66*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 132*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 66*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 33*D1*Dd*Pkdd2*b1*f**2*k1**2 - 264*D1*Ddd*Pk2*b1*f**2*r**2 + 132*D1*Ddd*Pk2*b1*f**2*r - 66*D1*Ddd*Pk2*b1*f**2 + 328*D1*Ddd*Pk2*f**3*r**2 - 164*D1*Ddd*Pk2*f**3*r + 82*D1*Ddd*Pk2*f**3 + 132*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 66*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 33*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 33*D1*bd1*(D1*(2*Pkdd2*b1*fd*k1**2*s*(2*s - 1) + f**2*(2*Pk2*(r - 1)**2 + Pkdd2*k1**2*s**2) - 2*f*(4*Pk2*fd*r*(r - 1) + Pkdd2*b1*k1**2*(2*s**2 - 2*s + 1))) + 2*Dd*f*(-2*Pk2*f*(4*r**2 - 5*r + 1) + Pkdd2*b1*k1**2*(8*s**2 - 6*s + 1))) - 792*Dd**2*Pk2*b1*f**2*r**2 + 396*Dd**2*Pk2*b1*f**2*r + 984*Dd**2*Pk2*f**3*r**2 - 492*Dd**2*Pk2*f**3*r + 396*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 198*Dd**2*Pkdd2*b1**2*f*k1**2*s)/(231*d**2*k1**3*k3**2) - D1**2*Pk1*ct*k2**3*st**2*(D1*f*(20*D1*Pk2*bd1**2*r*(r - 1) - 22*D1*Pk2*bdd1*f*r**2 + bd1*(44*D1*Pk2*fd*r*(1 - 2*r) + D1*f*(30*Pk2*r**2 + Pkdd2*k1**2*(s - 1)**2) + 44*Dd*Pk2*f*r*(1 - 4*r))) - b1**2*(D1**2*(6*Pk2*fd*r**2 - 10*Pk2*fdd*r**2 + 7*Pkdd2*fd*k1**2*s**2) + D1*Dd*(6*Pk2*f*(4*r**2 - 2*r + 1) + 20*Pk2*fd*r*(1 - 4*r) + 7*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 10*D1*Ddd*Pk2*f*(4*r**2 - 2*r + 1) + 60*Dd**2*Pk2*f*r*(1 - 2*r)) + b1*(10*D1**2*Pk2*bdd1*f*(2*r**2 - 2*r + 1) + 60*D1**2*Pk2*f*fd*r**2 - 60*D1**2*Pk2*f*fd*r + 30*D1**2*Pk2*f*fd - 44*D1**2*Pk2*f*fdd*r**2 + 44*D1**2*Pk2*f*fdd*r - 22*D1**2*Pk2*f*fdd - 44*D1**2*Pk2*fd**2*r**2 + 44*D1**2*Pk2*fd**2*r + 2*D1**2*Pkdd2*f*fd*k1**2*s**2 + 120*D1*Dd*Pk2*f**2*r**2 - 60*D1*Dd*Pk2*f**2*r + 30*D1*Dd*Pk2*f**2 - 352*D1*Dd*Pk2*f*fd*r**2 + 264*D1*Dd*Pk2*f*fd*r - 44*D1*Dd*Pk2*f*fd + 4*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 2*D1*Dd*Pkdd2*f**2*k1**2*s + D1*Dd*Pkdd2*f**2*k1**2 - 88*D1*Ddd*Pk2*f**2*r**2 + 44*D1*Ddd*Pk2*f**2*r - 22*D1*Ddd*Pk2*f**2 + D1*bd1*(-D1*(6*Pk2*f*(2*r**2 - 2*r + 1) + 20*Pk2*fd*r*(1 - 2*r) + 7*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) + 20*Dd*Pk2*f*(8*r**2 - 6*r + 1)) - 264*Dd**2*Pk2*f**2*r**2 + 132*Dd**2*Pk2*f**2*r))/(42*d**2*k1**3*k3**2) + D1**2*Pk1*ct*k2*st**4*(3120*D1**2*Pk2*b1*f**2*fd*r**2 - 1560*D1**2*Pk2*b1*f**2*fdd*r**2 - 3120*D1**2*Pk2*b1*f*fd**2*r**2 - 1840*D1**2*Pk2*f**3*fd*r**2 + 920*D1**2*Pk2*f**3*fd*r - 460*D1**2*Pk2*f**3*fd + 2480*D1**2*Pk2*f**3*fdd*r**2 - 1240*D1**2*Pk2*f**3*fdd*r + 620*D1**2*Pk2*f**3*fdd + 7440*D1**2*Pk2*f**2*fd**2*r**2 - 3720*D1**2*Pk2*f**2*fd**2*r - 858*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 1716*D1**2*Pkdd2*b1**2*fd*k1**2*s - 858*D1**2*Pkdd2*b1**2*fd*k1**2 + 429*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 858*D1**2*Pkdd2*b1**2*fdd*k1**2*s + 429*D1**2*Pkdd2*b1**2*fdd*k1**2 + 780*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 - 260*D1**2*Pkdd2*b1*f**2*fd*k1**2*s + 130*D1**2*Pkdd2*b1*f**2*fd*k1**2 - 390*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 + 130*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s - 65*D1**2*Pkdd2*b1*f**2*fdd*k1**2 - 780*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 + 260*D1**2*Pkdd2*b1*f*fd**2*k1**2*s + 858*D1**2*Pkdd2*bd1**2*f*k1**2*s**2 - 260*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 130*D1**2*Pkdd2*f**3*fd*k1**2*s - 65*D1**2*Pkdd2*f**3*fd*k1**2 - 13*D1**2*bdd1*f*(-66*Pkdd2*b1*k1**2*s**2 + 5*f**2*(8*Pk2*(r - 1)**2 + Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 4160*D1*Dd*Pk2*b1*f**3*r**2 - 2080*D1*Dd*Pk2*b1*f**3*r + 1040*D1*Dd*Pk2*b1*f**3 - 12480*D1*Dd*Pk2*b1*f**2*fd*r**2 + 3120*D1*Dd*Pk2*b1*f**2*fd*r - 1840*D1*Dd*Pk2*f**4*r**2 + 920*D1*Dd*Pk2*f**4*r - 460*D1*Dd*Pk2*f**4 + 19840*D1*Dd*Pk2*f**3*fd*r**2 - 9920*D1*Dd*Pk2*f**3*fd*r + 1240*D1*Dd*Pk2*f**3*fd - 3432*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 1716*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 858*D1*Dd*Pkdd2*b1**2*f*k1**2 + 3432*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 4290*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 858*D1*Dd*Pkdd2*b1**2*fd*k1**2 + 1040*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 - 520*D1*Dd*Pkdd2*b1*f**3*k1**2*s + 260*D1*Dd*Pkdd2*b1*f**3*k1**2 - 3120*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 + 1300*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s - 130*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 260*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 130*D1*Dd*Pkdd2*f**4*k1**2*s - 65*D1*Dd*Pkdd2*f**4*k1**2 - 2080*D1*Ddd*Pk2*b1*f**3*r**2 + 1040*D1*Ddd*Pk2*b1*f**3*r - 520*D1*Ddd*Pk2*b1*f**3 + 2480*D1*Ddd*Pk2*f**4*r**2 - 1240*D1*Ddd*Pk2*f**4*r + 620*D1*Ddd*Pk2*f**4 + 1716*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 858*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 429*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 520*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 + 260*D1*Ddd*Pkdd2*b1*f**3*k1**2*s - 130*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 26*D1*bd1*(D1*(-66*Pkdd2*b1*f*k1**2*s**2 + 66*Pkdd2*b1*fd*k1**2*s*(s - 1) + 5*f**3*(8*Pk2*(r - 1)**2 + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - 10*f**2*fd*(12*Pk2*r*(r - 1) + Pkdd2*k1**2*s*(3*s - 2))) - Dd*f*(66*Pkdd2*b1*k1**2*s*(1 - 4*s) + 5*f**2*(8*Pk2*(4*r**2 - 5*r + 1) + Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) - 6240*Dd**2*Pk2*b1*f**3*r**2 + 3120*Dd**2*Pk2*b1*f**3*r + 7440*Dd**2*Pk2*f**4*r**2 - 3720*Dd**2*Pk2*f**4*r + 5148*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 2574*Dd**2*Pkdd2*b1**2*f*k1**2*s - 1560*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 + 780*Dd**2*Pkdd2*b1*f**3*k1**2*s)/(3003*d**2*k1**3) + D1**2*Pk1*ct*k2*st**2*(-D1*f*(-2*D1*Pk2*bdd1*f*r**2*(126*f + 121) + 22*D1*bd1**2*(Pk2*r*(12*f + 10)*(r - 1) + Pkdd2*k1**2*s*(3*f + 1)*(s - 1)) + bd1*(D1*(484*Pk2*fd*r*(1 - 2*r) + 3*f**2*(36*Pk2*r**2 + 11*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(-504*Pk2*fd*r*(3*r - 1) + 330*Pk2*r**2 + 11*Pkdd2*k1**2*s**2)) - 4*Dd*Pk2*f*r*(126*f + 121)*(4*r - 1))) + 11*Pkdd2*b1**3*k1**2*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd + 28) + s*(3*fd + 14) - 7) - D1*Ddd*(3*f - 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f - 7)*(2*s - 1)) + 11*b1**2*(D1**2*(72*Pk2*f*fd*r**2 - 24*Pk2*f*fdd*r**2 - 24*Pk2*fd**2*r**2 + 6*Pk2*fd*r**2 - 10*Pk2*fdd*r**2 + 2*Pkdd2*bd1*k1**2*(f*(9*s**2 - 6*s + 3) - s**2*(9*fd + 21) + s*(3*fd + 14) - 7) - Pkdd2*bdd1*k1**2*(3*f - 7)*(3*s**2 - 2*s + 1) + 6*Pkdd2*f*fd*k1**2*s - 3*Pkdd2*f*fd*k1**2 - 6*Pkdd2*f*fdd*k1**2*s**2 - 6*Pkdd2*fd**2*k1**2*s**2 + 9*Pkdd2*fd*k1**2*s**2 - 14*Pkdd2*fd*k1**2*s + 7*Pkdd2*fd*k1**2 - Pkdd2*fdd*k1**2*s**2) + D1*(Dd*(36*Pk2*f**2*(4*r**2 - 2*r + 1) - 6*Pk2*f*(r**2*(32*fd - 4) + r*(2 - 8*fd) - 1) + 20*Pk2*fd*r*(1 - 4*r) + 14*Pkdd2*bd1*k1**2*(12*s**2 - 7*s + 1) - 3*Pkdd2*f*k1**2*(2*bd1*(12*s**2 - 7*s + 1) + s**2*(16*fd - 12) + s*(6 - 4*fd) - 3) + 2*Pkdd2*fd*k1**2*s*(1 - 4*s)) - Ddd*f*(Pk2*(12*f + 10)*(4*r**2 - 2*r + 1) + Pkdd2*k1**2*(3*f + 1)*(4*s**2 - 2*s + 1))) - 6*Dd**2*f*(Pk2*r*(12*f + 10)*(2*r - 1) + Pkdd2*k1**2*s*(3*f + 1)*(2*s - 1))) - b1*(324*D1**2*Pk2*f**2*fd*r**2 - 216*D1**2*Pk2*f**2*fd*r + 108*D1**2*Pk2*f**2*fd - 756*D1**2*Pk2*f**2*fdd*r**2 + 504*D1**2*Pk2*f**2*fdd*r - 252*D1**2*Pk2*f**2*fdd - 1512*D1**2*Pk2*f*fd**2*r**2 + 1008*D1**2*Pk2*f*fd**2*r + 660*D1**2*Pk2*f*fd*r**2 - 660*D1**2*Pk2*f*fd*r + 330*D1**2*Pk2*f*fd - 484*D1**2*Pk2*f*fdd*r**2 + 484*D1**2*Pk2*f*fdd*r - 242*D1**2*Pk2*f*fdd - 484*D1**2*Pk2*fd**2*r**2 + 484*D1**2*Pk2*fd**2*r + 22*D1**2*Pkdd2*bd1**2*k1**2*s*(3*f - 7)*(3*s - 2) + 198*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 66*D1**2*Pkdd2*f**2*fd*k1**2*s + 33*D1**2*Pkdd2*f**2*fd*k1**2 + 22*D1**2*Pkdd2*f*fd*k1**2*s**2 - 22*D1**2*Pkdd2*f*fd*k1**2*s + 11*D1**2*Pkdd2*f*fd*k1**2 + 11*D1**2*bdd1*f*(Pk2*(12*f + 10)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(3*f + 1)*(2*s**2 - 2*s + 1)) + 432*D1*Dd*Pk2*f**3*r**2 - 216*D1*Dd*Pk2*f**3*r + 108*D1*Dd*Pk2*f**3 - 6048*D1*Dd*Pk2*f**2*fd*r**2 + 3528*D1*Dd*Pk2*f**2*fd*r - 504*D1*Dd*Pk2*f**2*fd + 1320*D1*Dd*Pk2*f**2*r**2 - 660*D1*Dd*Pk2*f**2*r + 330*D1*Dd*Pk2*f**2 - 3872*D1*Dd*Pk2*f*fd*r**2 + 2904*D1*Dd*Pk2*f*fd*r - 484*D1*Dd*Pk2*f*fd + 264*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 132*D1*Dd*Pkdd2*f**3*k1**2*s + 66*D1*Dd*Pkdd2*f**3*k1**2 + 44*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 22*D1*Dd*Pkdd2*f**2*k1**2*s + 11*D1*Dd*Pkdd2*f**2*k1**2 - 1008*D1*Ddd*Pk2*f**3*r**2 + 504*D1*Ddd*Pk2*f**3*r - 252*D1*Ddd*Pk2*f**3 - 968*D1*Ddd*Pk2*f**2*r**2 + 484*D1*Ddd*Pk2*f**2*r - 242*D1*Ddd*Pk2*f**2 - 11*D1*bd1*(D1*(3*f**2*(12*Pk2*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(1 - 2*s)) - 2*f*(3*Pk2*(r**2*(16*fd - 2) + r*(2 - 8*fd) - 1) + Pkdd2*k1**2*(s**2*(12*fd - 9) + s*(2 - 6*fd) - 1)) + 2*fd*(10*Pk2*r*(1 - 2*r) + Pkdd2*k1**2*s*(1 - 2*s))) - 2*Dd*f*(Pk2*(12*f + 10)*(8*r**2 - 6*r + 1) + Pkdd2*k1**2*(3*f + 1)*(8*s**2 - 6*s + 1))) - 3024*Dd**2*Pk2*f**3*r**2 + 1512*Dd**2*Pk2*f**3*r - 2904*Dd**2*Pk2*f**2*r**2 + 1452*Dd**2*Pk2*f**2*r))/(462*d**2*k1**3) + D1**2*Pk1*ct*k2*(4*D1**2*Pk2*bd1**2*f*r**2*(3*f + 8) + D1*b1*(-4*D1*Pk2*bd1**2*r*(3*f + 14)*(3*r - 2) + 4*D1*Pk2*bdd1*f*r**2*(3*f + 8) + D1*bd1*(64*Pk2*fd*r*(r - 1) - 6*f**2*(-6*Pk2*r**2 + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(24*Pk2*r*(2*fd*r - fd + 2*r) - 7*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 8*Dd*Pk2*bd1*f*r*(3*f + 8)*(4*r - 1)) + b1**3*(D1**2*(26*Pk2*fd*r**2 - 6*Pk2*fdd*r**2 - 7*Pkdd2*fd*k1**2*s**2) + D1*(2*Dd*Pk2*(13*f*(4*r**2 - 2*r + 1) - r**2*(24*fd - 112) + r*(6*fd - 56) + 28) - 7*Dd*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) - 2*Ddd*Pk2*(3*f + 14)*(4*r**2 - 2*r + 1)) - 12*Dd**2*Pk2*r*(3*f + 14)*(2*r - 1)) + b1**2*(-2*D1**2*Pk2*bdd1*(3*f + 14)*(3*r**2 - 2*r + 1) + 36*D1**2*Pk2*f*fd*r**2 - 36*D1**2*Pk2*f*fd*r + 18*D1**2*Pk2*f*fd + 12*D1**2*Pk2*f*fdd*r**2 - 12*D1**2*Pk2*f*fdd*r + 6*D1**2*Pk2*f*fdd + 12*D1**2*Pk2*fd**2*r**2 - 12*D1**2*Pk2*fd**2*r + 24*D1**2*Pk2*fd*r**2 - 48*D1**2*Pk2*fd*r + 24*D1**2*Pk2*fd + 16*D1**2*Pk2*fdd*r**2 - 32*D1**2*Pk2*fdd*r + 16*D1**2*Pk2*fdd - 12*D1**2*Pkdd2*f*fd*k1**2*s**2 - 7*D1**2*Pkdd2*fd*k1**2*s**2 + 72*D1*Dd*Pk2*f**2*r**2 - 36*D1*Dd*Pk2*f**2*r + 18*D1*Dd*Pk2*f**2 + 96*D1*Dd*Pk2*f*fd*r**2 - 72*D1*Dd*Pk2*f*fd*r + 12*D1*Dd*Pk2*f*fd + 96*D1*Dd*Pk2*f*r**2 - 48*D1*Dd*Pk2*f*r + 24*D1*Dd*Pk2*f + 128*D1*Dd*Pk2*fd*r**2 - 160*D1*Dd*Pk2*fd*r + 32*D1*Dd*Pk2*fd - 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 12*D1*Dd*Pkdd2*f**2*k1**2*s - 6*D1*Dd*Pkdd2*f**2*k1**2 - 28*D1*Dd*Pkdd2*f*k1**2*s**2 + 14*D1*Dd*Pkdd2*f*k1**2*s - 7*D1*Dd*Pkdd2*f*k1**2 + 24*D1*Ddd*Pk2*f**2*r**2 - 12*D1*Ddd*Pk2*f**2*r + 6*D1*Ddd*Pk2*f**2 + 64*D1*Ddd*Pk2*f*r**2 - 32*D1*Ddd*Pk2*f*r + 16*D1*Ddd*Pk2*f + D1*bd1*(2*D1*Pk2*(13*f*(3*r**2 - 2*r + 1) + r**2*(84 - 18*fd) + r*(6*fd - 56) + 28) - 7*D1*Pkdd2*f*k1**2*(3*s**2 - 2*s + 1) - 4*Dd*Pk2*(3*f + 14)*(12*r**2 - 7*r + 1)) + 72*Dd**2*Pk2*f**2*r**2 - 36*Dd**2*Pk2*f**2*r + 192*Dd**2*Pk2*f*r**2 - 96*Dd**2*Pk2*f*r))/(21*d**2*k1**3) + 2*D1**2*Pk1*st**4*(-66*D1**2*Pk2*bd1**2*f*(r*(2*s - 1) - s + 1) + 33*D1*Pk2*bd1*(2*D1*b1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) - 4*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) + f*(D1*(f*(-2*r**2 + r*(s*(8*C - 7) + 4) + s**2*(20*C + 2) + s*(7 - 8*C) - 2) + fd*(-4*C*(r*(8*s - 2) + 18*s**2 - 13*s + 2) + 8*r**2 + r*(20*s - 13) - 10*s + 5)) + Dd*f*(-4*C*(2*r*(8*s - 1) + 36*s**2 - 19*s + 2) + 16*r**2 + 5*r*(8*s - 5) - 25*s + 9))) - 66*Pk2*b1**2*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*Pk2*b1*(2*C*(D1**2*(f*(2*fd*(4*r*s - 2*r + 10*s**2 - 10*s + 5) + fdd*(-8*r*s + 4*r - 18*s**2 + 18*s - 9)) + 2*fd**2*(r*(2 - 4*s) - s*(9*s - 9))) + D1*f*(2*Dd*(f*(8*r*s - 2*r + 20*s**2 - 12*s + 5) + fd*(-32*r*s + 12*r - 72*s**2 + 58*s - 11)) + Ddd*f*(r*(4 - 16*s) - 36*s**2 + 22*s - 9)) - 2*Dd**2*f**2*(6*r*(4*s - 1) + 54*s**2 - 33*s + 2)) + D1*Dd*f*(f*(-8*r**2 + r*(11 - 28*s) + s*(8*s + 3)) + fd*(32*r**2 + r*(80*s - 38) - 10*s + 5)) + D1*(D1*(f*(2*bdd1*(-2*r*s + r + s) + fd*(-4*r**2 + r*(7 - 14*s) + 4*s**2 - 4*s + 2) + fdd*r*(4*r + 10*s - 5)) + fd**2*r*(4*r + 10*s - 5)) + Ddd*f**2*(8*r**2 + r*(20*s - 9) - 5*s + 2)) + Dd**2*f**2*(24*r**2 + 3*r*(20*s - 9) - 15*s + 5)) + f*(33*D1**2*Pk2*bdd1*f*(-18*C*s**2 + 2*r**2 + r*(s*(5 - 8*C) - 4) + s*(8*C - 5) + 2) + D1**2*(-f*(2*fd - fdd)*(C*Pkdd2*k1**2*(-3*s**2 + 2*s - 1) + 2*Pk2*(C*(3*r**2 - 12*r*s + 2*r + 3*s**2 + 2*s + 2) + 3*r**2 - 6*r*s + 3*s**2 + 2)) + 2*fd**2*(C*Pkdd2*k1**2*s*(2 - 3*s) + 2*Pk2*(C*(3*r**2 - 12*r*s + 2*r + 3*s**2 + 2*s - 2) + 3*r**2 - 6*r*s + 3*s**2 - 1))) + D1*f*(-2*Dd*(-2*C*Pk2*fd*(12*r**2 + r*(7 - 48*s) + 12*s**2 + 7*s - 2) + C*Pkdd2*f*k1**2*(-4*s**2 + 2*s - 1) + C*Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1) + 4*Pk2*f*(C*(2*r**2 - 8*r*s + r + 2*s**2 + s + 1) + 2*r**2 - 4*r*s + 2*s**2 + 1) - 24*Pk2*fd*(r - s)**2) + Ddd*f*(C*Pkdd2*k1**2*(-4*s**2 + 2*s - 1) + 4*Pk2*(C*(2*r**2 - 8*r*s + r + 2*s**2 + s + 1) + 2*r**2 - 4*r*s + 2*s**2 + 1))) + 2*Dd**2*f**2*(3*C*Pkdd2*k1**2*s*(1 - 2*s) + 2*Pk2*(C*(6*r**2 - 24*r*s + 3*r + 6*s**2 + 3*s - 2) + 6*r**2 - 12*r*s + 6*s**2 - 1))))/(231*d**2*k3**2) - D1**2*Pk1*st**2*(33*b1**2*(D1**2*(C*Pkdd2*fdd*k1**2*s**2 - Pk2*fdd*(r**2*(2*C + 12) + r*s*(8*C + 13) + s**2*(2*C - 2)) + fd*(-2*C*Pkdd2*k1**2*s**2 + Pk2*(r**2*(4*C + 10) + r*s*(16*C + 5) + s**2*(18*C - 18)))) + D1*(Dd*(-2*C*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) + 2*C*Pkdd2*fd*k1**2*s*(4*s - 1) + Pk2*f*(2*C*(8*r**2 + 4*r*(8*s - 3) + 36*s**2 - 26*s + 11) + 40*r**2 + 5*r*(4*s - 5) - 72*s**2 + 31*s - 8) + Pk2*fd*(r**2*(-16*C - 96) + r*(C*(12 - 64*s) - 104*s + 37) + s*(-4*C*(4*s - 3) + 16*s + 9))) + Ddd*f*(C*Pkdd2*k1**2*(4*s**2 - 2*s + 1) - Pk2*(4*C*(2*r**2 + 8*r*s - 3*r + 2*s**2 - 3*s + 1) + 48*r**2 + 52*r*s - 37*r - 8*s**2 - 9*s + 10))) - Dd**2*f*(6*C*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*(4*C*(6*r**2 + 3*r*(8*s - 3) + 6*s**2 - 9*s + 2) + 144*r**2 + 3*r*(52*s - 37) - 24*s**2 - 27*s + 13))) + 33*b1*(32*C*D1**2*Pk2*f*fd*r**2 + 200*C*D1**2*Pk2*f*fd*r*s - 92*C*D1**2*Pk2*f*fd*r + 172*C*D1**2*Pk2*f*fd*s**2 - 184*C*D1**2*Pk2*f*fd*s + 88*C*D1**2*Pk2*f*fd - 32*C*D1**2*Pk2*f*fdd*r**2 - 184*C*D1**2*Pk2*f*fdd*r*s + 88*C*D1**2*Pk2*f*fdd*r - 172*C*D1**2*Pk2*f*fdd*s**2 + 176*C*D1**2*Pk2*f*fdd*s - 86*C*D1**2*Pk2*f*fdd - 32*C*D1**2*Pk2*fd**2*r**2 - 184*C*D1**2*Pk2*fd**2*r*s + 88*C*D1**2*Pk2*fd**2*r - 172*C*D1**2*Pk2*fd**2*s**2 + 176*C*D1**2*Pk2*fd**2*s - 2*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 2*C*D1**2*Pkdd2*f*fd*k1**2*s + C*D1**2*Pkdd2*f*fd*k1**2 + 2*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 2*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 64*C*D1*Dd*Pk2*f**2*r**2 + 400*C*D1*Dd*Pk2*f**2*r*s - 132*C*D1*Dd*Pk2*f**2*r + 344*C*D1*Dd*Pk2*f**2*s**2 - 272*C*D1*Dd*Pk2*f**2*s + 102*C*D1*Dd*Pk2*f**2 - 256*C*D1*Dd*Pk2*f*fd*r**2 - 1472*C*D1*Dd*Pk2*f*fd*r*s + 600*C*D1*Dd*Pk2*f*fd*r - 1376*C*D1*Dd*Pk2*f*fd*s**2 + 1232*C*D1*Dd*Pk2*f*fd*s - 264*C*D1*Dd*Pk2*f*fd - 4*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 2*C*D1*Dd*Pkdd2*f**2*k1**2*s - C*D1*Dd*Pkdd2*f**2*k1**2 + 16*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 4*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 64*C*D1*Ddd*Pk2*f**2*r**2 - 368*C*D1*Ddd*Pk2*f**2*r*s + 124*C*D1*Ddd*Pk2*f**2*r - 344*C*D1*Ddd*Pk2*f**2*s**2 + 264*C*D1*Ddd*Pk2*f**2*s - 102*C*D1*Ddd*Pk2*f**2 + 4*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 2*C*D1*Ddd*Pkdd2*f**2*k1**2*s + C*D1*Ddd*Pkdd2*f**2*k1**2 - 192*C*Dd**2*Pk2*f**2*r**2 - 1104*C*Dd**2*Pk2*f**2*r*s + 372*C*Dd**2*Pk2*f**2*r - 1032*C*Dd**2*Pk2*f**2*s**2 + 792*C*Dd**2*Pk2*f**2*s - 92*C*Dd**2*Pk2*f**2 + 12*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 6*C*Dd**2*Pkdd2*f**2*k1**2*s - 44*D1**2*Pk2*f*fd*r*s + 7*D1**2*Pk2*f*fd*r - 16*D1**2*Pk2*f*fd*s**2 + 31*D1**2*Pk2*f*fd*s - 8*D1**2*Pk2*f*fd + 8*D1**2*Pk2*f*fdd*r**2 + 28*D1**2*Pk2*f*fdd*r*s - 11*D1**2*Pk2*f*fdd*r + 16*D1**2*Pk2*f*fdd*s**2 - 23*D1**2*Pk2*f*fdd*s + 10*D1**2*Pk2*f*fdd + 8*D1**2*Pk2*fd**2*r**2 + 28*D1**2*Pk2*fd**2*r*s - 11*D1**2*Pk2*fd**2*r + 16*D1**2*Pk2*fd**2*s**2 - 23*D1**2*Pk2*fd**2*s + D1**2*bdd1*f*(C*Pkdd2*k1**2*(2*s**2 - 2*s + 1) - Pk2*(4*C*(r**2 + 4*r*s - 3*r + s**2 - 3*s + 1) + 24*r**2 + 26*r*s - 37*r - 4*s**2 - 9*s + 10)) - 88*D1*Dd*Pk2*f**2*r*s + 22*D1*Dd*Pk2*f**2*r - 32*D1*Dd*Pk2*f**2*s**2 + 38*D1*Dd*Pk2*f**2*s - 8*D1*Dd*Pk2*f**2 + 64*D1*Dd*Pk2*f*fd*r**2 + 224*D1*Dd*Pk2*f*fd*r*s - 88*D1*Dd*Pk2*f*fd*r + 128*D1*Dd*Pk2*f*fd*s**2 - 152*D1*Dd*Pk2*f*fd*s + 34*D1*Dd*Pk2*f*fd + 16*D1*Ddd*Pk2*f**2*r**2 + 56*D1*Ddd*Pk2*f**2*r*s - 22*D1*Ddd*Pk2*f**2*r + 32*D1*Ddd*Pk2*f**2*s**2 - 30*D1*Ddd*Pk2*f**2*s + 12*D1*Ddd*Pk2*f**2 + D1*bd1*(D1*(-2*C*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + 2*C*Pkdd2*fd*k1**2*s*(2*s - 1) + Pk2*f*(C*(8*r**2 + 8*r*(4*s - 3) + 36*s**2 - 52*s + 22) + 20*r**2 + 5*r*(2*s - 5) - 36*s**2 + 31*s - 8) + Pk2*fd*(r**2*(-8*C - 48) + r*(-4*C*(8*s - 3) - 52*s + 37) + s*(C*(12 - 8*s) + 8*s + 9))) + 2*Dd*f*(C*Pkdd2*k1**2*(8*s**2 - 6*s + 1) - Pk2*(4*C*(4*r**2 + 16*r*s - 9*r + 4*s**2 - 9*s + 3) + 96*r**2 + 104*r*s - 111*r - 16*s**2 - 27*s + 23))) + 48*Dd**2*Pk2*f**2*r**2 + 168*Dd**2*Pk2*f**2*r*s - 66*Dd**2*Pk2*f**2*r + 96*Dd**2*Pk2*f**2*s**2 - 90*Dd**2*Pk2*f**2*s + 14*Dd**2*Pk2*f**2) + f*(-408*C*D1**2*Pk2*f*fd*r**2 - 1188*C*D1**2*Pk2*f*fd*r*s + 668*C*D1**2*Pk2*f*fd*r - 1188*C*D1**2*Pk2*f*fd*s**2 + 1188*C*D1**2*Pk2*f*fd*s - 532*C*D1**2*Pk2*f*fd + 6*C*D1**2*Pk2*f*fdd*r**2 + 1188*C*D1**2*Pk2*f*fdd*r*s - 400*C*D1**2*Pk2*f*fdd*r + 1188*C*D1**2*Pk2*f*fdd*s**2 - 1188*C*D1**2*Pk2*f*fdd*s + 398*C*D1**2*Pk2*f*fdd + 12*C*D1**2*Pk2*fd**2*r**2 + 2376*C*D1**2*Pk2*fd**2*r*s - 800*C*D1**2*Pk2*fd**2*r + 2376*C*D1**2*Pk2*fd**2*s**2 - 2376*C*D1**2*Pk2*fd**2*s + 396*C*D1**2*Pk2*fd**2 + 99*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 66*C*D1**2*Pkdd2*f*fd*k1**2*s + 33*C*D1**2*Pkdd2*f*fd*k1**2 - 544*C*D1*Dd*Pk2*f**2*r**2 - 1584*C*D1*Dd*Pk2*f**2*r*s + 668*C*D1*Dd*Pk2*f**2*r - 1584*C*D1*Dd*Pk2*f**2*s**2 + 1188*C*D1*Dd*Pk2*f**2*s - 532*C*D1*Dd*Pk2*f**2 + 48*C*D1*Dd*Pk2*f*fd*r**2 + 9504*C*D1*Dd*Pk2*f*fd*r*s - 2800*C*D1*Dd*Pk2*f*fd*r + 9504*C*D1*Dd*Pk2*f*fd*s**2 - 8316*C*D1*Dd*Pk2*f*fd*s + 1588*C*D1*Dd*Pk2*f*fd + 132*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 66*C*D1*Dd*Pkdd2*f**2*k1**2*s + 33*C*D1*Dd*Pkdd2*f**2*k1**2 + 8*C*D1*Ddd*Pk2*f**2*r**2 + 1584*C*D1*Ddd*Pk2*f**2*r*s - 400*C*D1*Ddd*Pk2*f**2*r + 1584*C*D1*Ddd*Pk2*f**2*s**2 - 1188*C*D1*Ddd*Pk2*f**2*s + 398*C*D1*Ddd*Pk2*f**2 + 24*C*Dd**2*Pk2*f**2*r**2 + 4752*C*Dd**2*Pk2*f**2*r*s - 1200*C*Dd**2*Pk2*f**2*r + 4752*C*Dd**2*Pk2*f**2*s**2 - 3564*C*Dd**2*Pk2*f**2*s + 396*C*Dd**2*Pk2*f**2 + 198*D1**2*Pk2*f*fd*r**2 - 489*D1**2*Pk2*f*fd*r*s + 31*D1**2*Pk2*f*fd*r - 594*D1**2*Pk2*f*fd*s**2 + 559*D1**2*Pk2*f*fd*s - 132*D1**2*Pk2*f*fd + 393*D1**2*Pk2*f*fdd*r*s - 131*D1**2*Pk2*f*fdd*r + 594*D1**2*Pk2*f*fdd*s**2 - 527*D1**2*Pk2*f*fdd*s + 198*D1**2*Pk2*f*fdd + 786*D1**2*Pk2*fd**2*r*s - 262*D1**2*Pk2*fd**2*r + 1188*D1**2*Pk2*fd**2*s**2 - 1054*D1**2*Pk2*fd**2*s + 131*D1**2*Pk2*fd**2 - 33*D1**2*bd1**2*(-2*C*Pkdd2*k1**2*s*(s - 1) + Pk2*(4*C*(r**2 + 4*r*s - 3*r + s**2 - 3*s + 2) + 24*r**2 + 26*r*s - 37*r - 4*s**2 - 9*s + 13)) - 33*D1**2*bdd1*f*(-C*Pkdd2*k1**2*(s - 1)**2 + Pk2*(2*C*(8*r**2 + 46*r*s - 18*r + 43*s**2 - 44*s + 8) - 4*r**2 - 14*r*s + 11*r - 8*s**2 + 7*s - 2)) + 264*D1*Dd*Pk2*f**2*r**2 - 652*D1*Dd*Pk2*f**2*r*s + 31*D1*Dd*Pk2*f**2*r - 792*D1*Dd*Pk2*f**2*s**2 + 559*D1*Dd*Pk2*f**2*s - 132*D1*Dd*Pk2*f**2 + 3144*D1*Dd*Pk2*f*fd*r*s - 917*D1*Dd*Pk2*f*fd*r + 4752*D1*Dd*Pk2*f*fd*s**2 - 3689*D1*Dd*Pk2*f*fd*s + 658*D1*Dd*Pk2*f*fd + 524*D1*Ddd*Pk2*f**2*r*s - 131*D1*Ddd*Pk2*f**2*r + 792*D1*Ddd*Pk2*f**2*s**2 - 527*D1*Ddd*Pk2*f**2*s + 198*D1*Ddd*Pk2*f**2 + 33*D1*bd1*(C*D1*(-4*Pk2*fd*(16*r**2 + r*(92*s - 40) + 86*s**2 - 88*s + 23) + 4*Pkdd2*fd*k1**2*s*(s - 1) + f*(2*Pk2*(8*r**2 + 50*r*s - 20*r + 43*s**2 - 44*s + 7) - Pkdd2*k1**2*(s**2 - 4*s + 2))) + 2*C*Dd*f*(-2*Pk2*(32*r**2 + 184*r*s - 67*r + 172*s**2 - 154*s + 31) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)) + D1*Pk2*(f*(r*(15 - 22*s) + s*(7 - 8*s)) + fd*(16*r**2 + r*(56*s - 33) + 32*s**2 - 37*s + 14)) + 2*Dd*Pk2*f*(16*r**2 + r*(56*s - 33) + 32*s**2 - 29*s + 9)) + 1572*Dd**2*Pk2*f**2*r*s - 393*Dd**2*Pk2*f**2*r + 2376*Dd**2*Pk2*f**2*s**2 - 1581*Dd**2*Pk2*f**2*s + 131*Dd**2*Pk2*f**2))/(693*d**2*k3**2) - 2*D1**2*Pk1*(D1**2*Pk2*bd1**2*f*(9*r*(2*s - 1) + 28*s**2 - 37*s + 9) + 2*D1**2*Pk2*bdd1*f**2*(C*(8*r**2 + 18*r*(s - 1) + 7*(s - 1)**2) + (s - 1)*(5*r + 6*s - 6)) + D1*bd1*(b1*(-7*C*D1*f*(Pk2*(4*r**2 - 4*r + 2) + Pkdd2*k1**2*(-2*s**2 + 2*s - 1)) + Pk2*(D1*(28*f*r**2 + f*r*(6*s - 31) + f*s*(25 - 28*s) + 9*fd*r*(4*s - 1) + fd*s*(56*s - 37)) + 2*Dd*f*(9*r*(8*s - 3) + 112*s**2 - 111*s + 23))) + 2*f*(D1*(Pk2*fd*(2*C*(16*r**2 + r*(36*s - 26) + 14*s**2 - 23*s + 9) + 10*r*(2*s - 1) + 24*s**2 - 29*s + 5) + f*(3*C*Pkdd2*k1**2*(s - 1)**2 + Pk2*(-C*(22*r**2 + 18*r*(s - 1) + 7*(s - 1)**2) + 6*r**2 - r*s + r - 6*(s - 1)**2))) + Dd*Pk2*f*(2*C*(32*r**2 + 72*r*s - 53*r + 28*s**2 - 44*s + 16) + 5*r*(8*s - 5) + 48*s**2 - 65*s + 17))) + b1**2*(-7*C*D1*(D1*fd*(2*Pk2*r**2 - Pkdd2*k1**2*s**2) + Dd*f*(Pk2*(8*r**2 - 4*r + 2) + Pkdd2*k1**2*(-4*s**2 + 2*s - 1))) + Pk2*(D1*Dd*(56*f*r**2 + f*r*(12*s - 31) + f*s*(25 - 56*s) + 9*fd*r*(8*s - 1) + fd*s*(112*s - 37)) + D1*(D1*(fd*(14*r**2 + 3*r*s - 14*s**2) + fdd*s*(9*r + 14*s)) + Ddd*f*(9*r*(4*s - 1) + 56*s**2 - 37*s + 14)) + 3*Dd**2*f*(9*r*(4*s - 1) + 56*s**2 - 37*s + 3))) + b1*(2*C*(-2*D1**2*(Pk2*fd**2*(-8*r**2 + r*(8 - 18*s) + s*(9 - 7*s)) + f*(-Pk2*fdd*(8*r**2 + 2*r*(9*s - 4) + 7*s**2 - 9*s + 4) + fd*(Pk2*(22*r**2 + 18*r*s - 22*r + 7*s**2 - 9*s + 11) - 3*Pkdd2*k1**2*s**2))) + D1*f*(Dd*(2*Pk2*fd*(64*r**2 + 6*r*(24*s - 11) + 56*s**2 - 68*s + 17) + f*(-Pk2*(88*r**2 + 72*r*s - 62*r + 28*s**2 - 32*s + 29) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(32*r**2 + r*(72*s - 34) + 28*s**2 - 32*s + 15)) + 6*Dd**2*Pk2*f**2*(16*r**2 + r*(36*s - 17) + 14*s**2 - 16*s + 3)) + D1**2*Pk2*bdd1*f*(9*r*(2*s - 1) + 28*s**2 - 37*s + 14) + 2*Pk2*(D1*Dd*f*(f*(24*r**2 - r*(4*s + 11) + s*(13 - 24*s)) + fd*(10*r*(8*s - 1) + 96*s**2 - 54*s + 5)) + D1*(D1*(f*fd*(12*r**2 - 2*r*(s + 6) - 12*s**2 + s + 6) + f*fdd*s*(10*r + 12*s - 5) + fd**2*s*(10*r + 12*s - 5)) + Ddd*f**2*(5*r*(4*s - 1) + 24*s**2 - 17*s + 6)) + Dd**2*f**2*(15*r*(4*s - 1) + 72*s**2 - 51*s + 5))))/(21*d**2*k3**2) + 5*D1**2*Pk1*k2**2*st**6*(264*C*D1**2*Pk2*b1*f*fd*r**2 - 132*C*D1**2*Pk2*b1*f*fdd*r**2 - 132*C*D1**2*Pk2*b1*fd**2*r**2 + 12*C*D1**2*Pk2*f**2*fd*r**2 - 8*C*D1**2*Pk2*f**2*fd*r + 4*C*D1**2*Pk2*f**2*fd - 6*C*D1**2*Pk2*f**2*fdd*r**2 + 4*C*D1**2*Pk2*f**2*fdd*r - 2*C*D1**2*Pk2*f**2*fdd - 12*C*D1**2*Pk2*f*fd**2*r**2 + 8*C*D1**2*Pk2*f*fd**2*r - 132*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 132*C*D1**2*Pkdd2*b1*f*fd*k1**2*s - 66*C*D1**2*Pkdd2*b1*f*fd*k1**2 + 66*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 66*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 33*C*D1**2*Pkdd2*b1*f*fdd*k1**2 + 66*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 66*C*D1**2*Pkdd2*b1*fd**2*k1**2*s - 6*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 4*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 2*C*D1**2*Pkdd2*f**2*fd*k1**2 + 3*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 2*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + C*D1**2*Pkdd2*f**2*fdd*k1**2 + 6*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 4*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 528*C*D1*Dd*Pk2*b1*f**2*r**2 - 264*C*D1*Dd*Pk2*b1*f**2*r + 132*C*D1*Dd*Pk2*b1*f**2 - 1056*C*D1*Dd*Pk2*b1*f*fd*r**2 + 264*C*D1*Dd*Pk2*b1*f*fd*r + 16*C*D1*Dd*Pk2*f**3*r**2 - 8*C*D1*Dd*Pk2*f**3*r + 4*C*D1*Dd*Pk2*f**3 - 48*C*D1*Dd*Pk2*f**2*fd*r**2 + 28*C*D1*Dd*Pk2*f**2*fd*r - 4*C*D1*Dd*Pk2*f**2*fd - 264*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 132*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 66*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 528*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 396*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 66*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 - 8*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 4*C*D1*Dd*Pkdd2*f**3*k1**2*s - 2*C*D1*Dd*Pkdd2*f**3*k1**2 + 24*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 14*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 2*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 264*C*D1*Ddd*Pk2*b1*f**2*r**2 + 132*C*D1*Ddd*Pk2*b1*f**2*r - 66*C*D1*Ddd*Pk2*b1*f**2 - 8*C*D1*Ddd*Pk2*f**3*r**2 + 4*C*D1*Ddd*Pk2*f**3*r - 2*C*D1*Ddd*Pk2*f**3 + 132*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 66*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 33*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 4*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 2*C*D1*Ddd*Pkdd2*f**3*k1**2*s + C*D1*Ddd*Pkdd2*f**3*k1**2 - 792*C*Dd**2*Pk2*b1*f**2*r**2 + 396*C*Dd**2*Pk2*b1*f**2*r - 24*C*Dd**2*Pk2*f**3*r**2 + 12*C*Dd**2*Pk2*f**3*r + 396*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 198*C*Dd**2*Pkdd2*b1*f**2*k1**2*s + 12*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 6*C*Dd**2*Pkdd2*f**3*k1**2*s - 264*D1**2*Pk2*b1*f*fd*r**2 + 264*D1**2*Pk2*b1*f*fd*r*s - 132*D1**2*Pk2*b1*f*fd*r + 132*D1**2*Pk2*b1*f*fdd*r**2 - 132*D1**2*Pk2*b1*f*fdd*r*s + 66*D1**2*Pk2*b1*f*fdd*r + 132*D1**2*Pk2*b1*fd**2*r**2 - 132*D1**2*Pk2*b1*fd**2*r*s + 66*D1**2*Pk2*b1*fd**2*r - 12*D1**2*Pk2*f**2*fd*r**2 + 12*D1**2*Pk2*f**2*fd*r*s + 4*D1**2*Pk2*f**2*fd*r - 4*D1**2*Pk2*f**2*fd*s - 4*D1**2*Pk2*f**2*fd + 6*D1**2*Pk2*f**2*fdd*r**2 - 6*D1**2*Pk2*f**2*fdd*r*s - 2*D1**2*Pk2*f**2*fdd*r + 2*D1**2*Pk2*f**2*fdd*s + 2*D1**2*Pk2*f**2*fdd + 12*D1**2*Pk2*f*fd**2*r**2 - 12*D1**2*Pk2*f*fd**2*r*s - 4*D1**2*Pk2*f*fd**2*r + 4*D1**2*Pk2*f*fd**2*s - 2*D1**2*Pk2*f*fd**2 - 33*D1**2*bdd1*f**2*(-C*Pkdd2*k1**2*s**2 + 2*Pk2*(r - 1)*(C*(r - 1) - r + s + 1)) - 528*D1*Dd*Pk2*b1*f**2*r**2 + 528*D1*Dd*Pk2*b1*f**2*r*s + 132*D1*Dd*Pk2*b1*f**2*r - 132*D1*Dd*Pk2*b1*f**2*s - 132*D1*Dd*Pk2*b1*f**2 + 1056*D1*Dd*Pk2*b1*f*fd*r**2 - 1056*D1*Dd*Pk2*b1*f*fd*r*s + 132*D1*Dd*Pk2*b1*f*fd*r + 132*D1*Dd*Pk2*b1*f*fd*s - 66*D1*Dd*Pk2*b1*f*fd - 16*D1*Dd*Pk2*f**3*r**2 + 16*D1*Dd*Pk2*f**3*r*s + 4*D1*Dd*Pk2*f**3*r - 4*D1*Dd*Pk2*f**3*s - 4*D1*Dd*Pk2*f**3 + 48*D1*Dd*Pk2*f**2*fd*r**2 - 48*D1*Dd*Pk2*f**2*fd*r*s - 14*D1*Dd*Pk2*f**2*fd*r + 14*D1*Dd*Pk2*f**2*fd*s + 264*D1*Ddd*Pk2*b1*f**2*r**2 - 264*D1*Ddd*Pk2*b1*f**2*r*s - 66*D1*Ddd*Pk2*b1*f**2*r + 66*D1*Ddd*Pk2*b1*f**2*s + 66*D1*Ddd*Pk2*b1*f**2 + 8*D1*Ddd*Pk2*f**3*r**2 - 8*D1*Ddd*Pk2*f**3*r*s - 2*D1*Ddd*Pk2*f**3*r + 2*D1*Ddd*Pk2*f**3*s + 2*D1*Ddd*Pk2*f**3 + 66*D1*bd1*f*(C*Dd*Pkdd2*f*k1**2*s*(4*s - 1) + D1*f*(-C*Pkdd2*k1**2*s**2 + 2*Pk2*(r - 1)*(C*(r - 1) - r + s + 1)) - D1*fd*(C*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*(r**2*(4*C - 4) + r*(-4*C + 4*s + 3) - 2*s + 1)) + Dd*Pk2*f*(-2*C*(4*r**2 - 5*r + 1) + 8*r**2 - 8*r*s - 9*r + 5*s + 1)) + 792*Dd**2*Pk2*b1*f**2*r**2 - 792*Dd**2*Pk2*b1*f**2*r*s - 198*Dd**2*Pk2*b1*f**2*r + 198*Dd**2*Pk2*b1*f**2*s - 66*Dd**2*Pk2*b1*f**2 + 24*Dd**2*Pk2*f**3*r**2 - 24*Dd**2*Pk2*f**3*r*s - 6*Dd**2*Pk2*f**3*r + 6*Dd**2*Pk2*f**3*s - 2*Dd**2*Pk2*f**3)/(693*d**2*k1**2*k3**2) + 2*D1**2*Pk1*k2**2*st**4*(33*b1**2*(D1**2*(2*fd - fdd)*(-C*Pkdd2*k1**2*s**2 + Pk2*r**2*(2*C - 2)) + D1*(2*Dd*(C*Pkdd2*f*k1**2*(-4*s**2 + 2*s - 1) + C*Pkdd2*fd*k1**2*s*(4*s - 1) + Pk2*f*(2*C - 2)*(4*r**2 - 2*r + 1) + Pk2*fd*r*(2 - 2*C)*(4*r - 1)) + Ddd*f*(C*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + Pk2*(2 - 2*C)*(4*r**2 - 2*r + 1))) - 6*Dd**2*f*(C*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*r*(2*C - 2)*(2*r - 1))) + 33*b1*(-4*C*D1**2*Pk2*f*fd*r**2 + 2*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 2*C*D1**2*Pkdd2*f*fd*k1**2*s + C*D1**2*Pkdd2*f*fd*k1**2 - 8*C*D1*Dd*Pk2*f**2*r**2 + 4*C*D1*Dd*Pk2*f**2*r - 2*C*D1*Dd*Pk2*f**2 + 4*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 2*C*D1*Dd*Pkdd2*f**2*k1**2*s + C*D1*Dd*Pkdd2*f**2*k1**2 - 14*D1**2*Pk2*f*fd*r*s + 7*D1**2*Pk2*f*fd*r + 4*D1**2*Pk2*f*fdd*r**2 + 10*D1**2*Pk2*f*fdd*r*s - 5*D1**2*Pk2*f*fdd*r + 4*D1**2*Pk2*fd**2*r**2 + 10*D1**2*Pk2*fd**2*r*s - 5*D1**2*Pk2*fd**2*r + D1**2*bdd1*f*(C*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + Pk2*(2 - 2*C)*(2*r**2 - 2*r + 1)) - 28*D1*Dd*Pk2*f**2*r*s + 7*D1*Dd*Pk2*f**2*r + 7*D1*Dd*Pk2*f**2*s + 32*D1*Dd*Pk2*f*fd*r**2 + 80*D1*Dd*Pk2*f*fd*r*s - 38*D1*Dd*Pk2*f*fd*r - 10*D1*Dd*Pk2*f*fd*s + 5*D1*Dd*Pk2*f*fd + 8*D1*Ddd*Pk2*f**2*r**2 + 20*D1*Ddd*Pk2*f**2*r*s - 9*D1*Ddd*Pk2*f**2*r - 5*D1*Ddd*Pk2*f**2*s + 2*D1*Ddd*Pk2*f**2 + 2*D1*bd1*(D1*(C*Pkdd2*f*k1**2*(-2*s**2 + 2*s - 1) + C*Pkdd2*fd*k1**2*s*(2*s - 1) + Pk2*f*(2*C - 2)*(2*r**2 - 2*r + 1) + Pk2*fd*r*(2 - 2*C)*(2*r - 1)) + Dd*f*(C*Pkdd2*k1**2*(8*s**2 - 6*s + 1) + Pk2*(2 - 2*C)*(8*r**2 - 6*r + 1))) + 24*Dd**2*Pk2*f**2*r**2 + 60*Dd**2*Pk2*f**2*r*s - 27*Dd**2*Pk2*f**2*r - 15*Dd**2*Pk2*f**2*s + 5*Dd**2*Pk2*f**2) + f*(33*D1**2*Pk2*bdd1*f*(r - 1)*(2*r + 5*s - 2) - 66*D1**2*bd1**2*(-C*Pkdd2*k1**2*s*(s - 1) + Pk2*r*(2*C - 2)*(r - 1)) - 33*D1*bd1*(C*D1*f*(2*Pk2*(r - 1)**2 - Pkdd2*k1**2*s**2) - Pk2*(D1*(-7*f*s*(r - 1) + fd*(8*r**2 + 20*r*s - 13*r - 10*s + 5)) + Dd*f*(16*r**2 + 5*r*(8*s - 5) - 25*s + 9))) - 2*Pk2*(D1**2*(f*(25*C*fd*(3*r**2 - 2*r + 1) - 29*C*fdd*(3*r**2 - 2*r + 1) + 4*fd*(6*r**2 + r*(3*s - 5) - s + 2) - 2*fdd*(6*r**2 + r*(3*s - 5) - s + 2)) - 2*fd**2*(r**2*(87*C + 12) - 2*r*(29*C - 3*s + 5) - 2*s + 1)) + D1*f*(-29*C*Ddd*f*(4*r**2 - 2*r + 1) + Dd*f*(25*C*(4*r**2 - 2*r + 1) + 32*r**2 + 4*r*(4*s - 5) - 4*s + 8) - 2*Dd*fd*(29*C*(12*r**2 - 7*r + 1) + 48*r**2 + r*(24*s - 35) - 7*s + 6) - 2*Ddd*f*(8*r**2 + r*(4*s - 5) - s + 2)) - 2*Dd**2*f**2*(r**2*(174*C + 24) - 3*r*(29*C - 4*s + 5) - 3*s + 1))))/(231*d**2*k1**2*k3**2) + D1**2*Pk1*k2**2*st**2*(D1*f*(D1*Pk2*bd1**2*(36*r**2 + 46*r*s - 59*r - 23*s + 23) + D1*Pk2*bdd1*f*r*(r*(16*C + 2) - s + 1) + bd1*(D1*(Pk2*fd*(r**2*(64*C + 8) - 2*r*(16*C + 2*s + 1) + s - 1) - f*(C*(10*Pk2*r**2 + Pkdd2*k1**2*(s - 1)**2) + Pk2*r*(12*r + s - 1))) + Dd*Pk2*f*(r**2*(128*C + 16) + r*(-32*C - 8*s + 1) + s - 1))) + b1**2*(D1**2*(7*C*Pkdd2*fd*k1**2*s**2 - Pk2*fd*r*(r*(14*C + 8) + 25*s) + Pk2*fdd*r*(18*r + 23*s)) + D1*(Dd*(Pk2*fd*(144*r**2 + r*(184*s - 59) - 23*s) + f*(7*C*Pkdd2*k1**2*(4*s**2 - 2*s + 1) - Pk2*(14*C*(4*r**2 - 2*r + 1) + 32*r**2 + 100*r*s - 41*r - 25*s + 8))) + Ddd*Pk2*f*(72*r**2 + r*(92*s - 59) - 23*s + 18)) + Dd**2*Pk2*f*(216*r**2 + 3*r*(92*s - 59) - 69*s + 23)) + b1*(-20*C*D1**2*Pk2*f*fd*r**2 + 20*C*D1**2*Pk2*f*fd*r - 10*C*D1**2*Pk2*f*fd + 32*C*D1**2*Pk2*f*fdd*r**2 - 32*C*D1**2*Pk2*f*fdd*r + 16*C*D1**2*Pk2*f*fdd + 32*C*D1**2*Pk2*fd**2*r**2 - 32*C*D1**2*Pk2*fd**2*r - 2*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 40*C*D1*Dd*Pk2*f**2*r**2 + 20*C*D1*Dd*Pk2*f**2*r - 10*C*D1*Dd*Pk2*f**2 + 256*C*D1*Dd*Pk2*f*fd*r**2 - 192*C*D1*Dd*Pk2*f*fd*r + 32*C*D1*Dd*Pk2*f*fd - 4*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 2*C*D1*Dd*Pkdd2*f**2*k1**2*s - C*D1*Dd*Pkdd2*f**2*k1**2 + 64*C*D1*Ddd*Pk2*f**2*r**2 - 32*C*D1*Ddd*Pk2*f**2*r + 16*C*D1*Ddd*Pk2*f**2 + 192*C*Dd**2*Pk2*f**2*r**2 - 96*C*Dd**2*Pk2*f**2*r + D1**2*Pk2*bdd1*f*(36*r**2 + 46*r*s - 59*r - 23*s + 18) - 24*D1**2*Pk2*f*fd*r**2 - 2*D1**2*Pk2*f*fd*r*s + 24*D1**2*Pk2*f*fd*r + D1**2*Pk2*f*fd*s - 12*D1**2*Pk2*f*fd + 4*D1**2*Pk2*f*fdd*r**2 - 2*D1**2*Pk2*f*fdd*r*s - 4*D1**2*Pk2*f*fdd*r + D1**2*Pk2*f*fdd*s + 2*D1**2*Pk2*f*fdd + 4*D1**2*Pk2*fd**2*r**2 - 2*D1**2*Pk2*fd**2*r*s - 4*D1**2*Pk2*fd**2*r + D1**2*Pk2*fd**2*s - 48*D1*Dd*Pk2*f**2*r**2 - 4*D1*Dd*Pk2*f**2*r*s + 25*D1*Dd*Pk2*f**2*r + D1*Dd*Pk2*f**2*s - 12*D1*Dd*Pk2*f**2 + 32*D1*Dd*Pk2*f*fd*r**2 - 16*D1*Dd*Pk2*f*fd*r*s - 22*D1*Dd*Pk2*f*fd*r + 6*D1*Dd*Pk2*f*fd*s + 3*D1*Dd*Pk2*f*fd + 8*D1*Ddd*Pk2*f**2*r**2 - 4*D1*Ddd*Pk2*f**2*r*s - 3*D1*Ddd*Pk2*f**2*r + D1*Ddd*Pk2*f**2*s + 2*D1*Ddd*Pk2*f**2 + D1*bd1*(D1*(Pk2*fd*(72*r**2 + r*(92*s - 59) - 23*s) + f*(7*C*Pkdd2*k1**2*(2*s**2 - 2*s + 1) - Pk2*(14*C*(2*r**2 - 2*r + 1) + 16*r**2 + 50*r*s - 41*r - 25*s + 8))) + 2*Dd*Pk2*f*(144*r**2 + r*(184*s - 177) - 69*s + 41)) + 24*Dd**2*Pk2*f**2*r**2 - 12*Dd**2*Pk2*f**2*r*s - 9*Dd**2*Pk2*f**2*r + 3*Dd**2*Pk2*f**2*s - Dd**2*Pk2*f**2))/(21*d**2*k1**2*k3**2) + 5*D1**2*Pk1*st**6*(858*D1**2*Pkdd2*bd1**2*f**2*k1**2*s**2 + 26*D1*bd1*f*(D1*(66*Pkdd2*b1*fd*k1**2*s*(2*s - 1) + f**2*s*(116*Pk2*(r - 1) - 3*Pkdd2*k1**2*s) + f*(-124*Pk2*fd*(r*(6*s - 1) - 3*s + 1) - 66*Pkdd2*b1*k1**2*s**2 + 3*Pkdd2*fd*k1**2*s*(3*s - 1))) + Dd*f*(-124*Pk2*f*(r*(8*s - 1) - 5*s + 1) + 66*Pkdd2*b1*k1**2*s*(4*s - 1) + 3*Pkdd2*f*k1**2*s*(4*s - 1))) - 429*Pkdd2*b1**2*k1**2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) - 13*b1*f*(2*D1*Dd*f*(116*Pk2*f*(-4*r*s + r + s) + 124*Pk2*fd*(r*(24*s - 7) - 3*s + 1) + 3*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1) - 3*Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1)) + D1*(D1*(f*(232*Pk2*fd*r*(1 - 3*s) + 248*Pk2*fdd*r*(3*s - 1) - 66*Pkdd2*bdd1*k1**2*s**2 + 6*Pkdd2*fd*k1**2*(3*s**2 - 2*s + 1) - 3*Pkdd2*fdd*k1**2*(3*s**2 - 2*s + 1)) + 2*fd**2*(248*Pk2*r*(3*s - 1) + 3*Pkdd2*k1**2*s*(2 - 3*s))) - Ddd*f**2*(248*Pk2*(-4*r*s + r + s) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 2*Dd**2*f**2*(124*Pk2*(3*r*(4*s - 1) - 3*s + 1) + 9*Pkdd2*k1**2*s*(1 - 2*s))) + f**2*(12*D1*Dd*f*(f*(42*Pk2*(4*r*s - r - s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - fd*(4*s - 1)*(68*Pk2*(4*r - 1) + Pkdd2*k1**2*(4*s - 1))) + D1*(D1*(12*f*fd*(42*Pk2*(4*r*s - r - s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(13*bdd1*s*(-248*Pk2*(r - 1) + 3*Pkdd2*k1**2*s) - 6*fdd*(68*Pk2*(4*r*s - r - s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 12*fd**2*(34*Pk2*(12*r*s - 3*r - 3*s + 1) + 3*Pkdd2*k1**2*s*(2*s - 1))) - 6*Ddd*f**2*(68*Pk2*(4*r*s - r - s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 12*Dd**2*f**2*(34*Pk2*(12*r*s - 3*r - 3*s + 1) + 3*Pkdd2*k1**2*s*(2*s - 1))))/(18018*d**2*k1**2) + D1**2*Pk1*st**4*(-858*D1**2*bd1**2*f*(2*Pk2*f*(r*(4*s - 1) - 2*s + 1) + 2*Pk2*(r**2*(K - 1) + r*(-K + 2*s + 1) - s) - Pkdd2*k1**2*s**2*(K + 1)) - 26*D1*bd1*(D1*(f**3*(Pk2*(75*r**2 + 7*r*(19*s - 12) - 165*s + 50) + Pkdd2*k1**2*(-3*s**2 + 4*s - 2)) + f**2*fd*(Pk2*(-522*r**2 + r*(539 - 894*s) + 479*s - 157) + Pkdd2*k1**2*s*(9*s - 7)) + 33*f*(-4*Pk2*gd2*r*(r - 1) + 2*Pkdd2*gd2*k1**2*s**2 + Pkdd2*k1**2*s**2*(b2 - bd2) + g2*(4*Pk2*(r - 1)**2 - 2*Pkdd2*k1**2*s**2)) - 33*fd*(4*Pk2*g2*r*(r - 1) + Pkdd2*b2*k1**2*s*(s - 1) - 2*Pkdd2*g2*k1**2*s*(s - 1))) + Dd*f*(-132*Pk2*g2*(4*r**2 - 5*r + 1) - 33*Pkdd2*b2*k1**2*s*(4*s - 1) - 66*Pkdd2*g2*k1**2*s*(1 - 4*s) + f**2*(Pk2*(-696*r**2 - 1192*r*s + 755*r + 809*s - 273) + Pkdd2*k1**2*(12*s**2 - 11*s + 2)))) - 429*Pkdd2*b1**3*k1**2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 429*b1**2*(D1**2*(4*K*Pk2*fd*r**2 - 2*K*Pk2*fdd*r**2 - 2*K*Pkdd2*fd*k1**2*s**2 + 4*K*Pkdd2*fd*k1**2*s - 2*K*Pkdd2*fd*k1**2 + K*Pkdd2*fdd*k1**2*s**2 - 2*K*Pkdd2*fdd*k1**2*s + K*Pkdd2*fdd*k1**2 + 16*Pk2*f*fd*r*s - 4*Pk2*f*fd*r - 16*Pk2*f*fdd*r*s + 4*Pk2*f*fdd*r - 16*Pk2*fd**2*r*s + 4*Pk2*fd**2*r - 4*Pk2*fd*r**2 + 8*Pk2*fd*r*s - 8*Pk2*fd*r + 2*Pk2*fdd*r**2 - 4*Pk2*fdd*r*s + 4*Pk2*fdd*r - 2*Pkdd2*bd1*k1**2*(f*(3*s**2 - 2*s + 1) + fd*s*(1 - 3*s)) + Pkdd2*bdd1*f*k1**2*(3*s**2 - 2*s + 1) + 2*Pkdd2*f*fd*k1**2*s**2 - 2*Pkdd2*f*fd*k1**2*s + Pkdd2*f*fd*k1**2 - 2*Pkdd2*fd*k1**2*s**2 + 4*Pkdd2*fd*k1**2*s - 2*Pkdd2*fd*k1**2 + Pkdd2*fdd*k1**2*s**2 - 2*Pkdd2*fdd*k1**2*s + Pkdd2*fdd*k1**2) + D1*(Dd*(f**2*(8*Pk2*r*(4*s - 1) - 8*Pk2*s + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 2*f*(2*Pk2*(K*(-4*r**2 + 2*r - 1) + fd*(8*r - 1)*(4*s - 1) + 4*r**2 - 8*r*s + 2*s + 1) + Pkdd2*k1**2*(bd1*(-12*s**2 + 7*s - 1) + (K + 1)*(4*s**2 - 2*s + 1))) + 2*fd*(2*Pk2*(-r**2*(4*K - 4) + r*(K - 8*s + 4) + s - 1) + Pkdd2*k1**2*(K + 1)*(4*s**2 - 5*s + 1))) + Ddd*f*(Pk2*(K*(-8*r**2 + 4*r - 2) + 8*f*(-4*r*s + r + s) + 8*r**2 - 16*r*s + 4*s + 2) + Pkdd2*k1**2*(K + 1)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(2*Pk2*(3*K*r*(2*r - 1) + f*(6*r*(4*s - 1) - 6*s + 2) - 6*r**2 + 12*r*s - 3*s + 1) + Pkdd2*k1**2*s*(-3*K - 3)*(2*s - 1))) + 13*b1*(-450*D1**2*Pk2*f**2*fd*r**2 - 798*D1**2*Pk2*f**2*fd*r*s + 398*D1**2*Pk2*f**2*fd*r - 64*D1**2*Pk2*f**2*fd*s - 50*D1**2*Pk2*f**2*fd + 522*D1**2*Pk2*f**2*fdd*r**2 + 894*D1**2*Pk2*f**2*fdd*r*s - 430*D1**2*Pk2*f**2*fdd*r + 32*D1**2*Pk2*f**2*fdd*s + 58*D1**2*Pk2*f**2*fdd + 1044*D1**2*Pk2*f*fd**2*r**2 + 1788*D1**2*Pk2*f*fd**2*r*s - 860*D1**2*Pk2*f*fd**2*r + 64*D1**2*Pk2*f*fd**2*s - 16*D1**2*Pk2*f*fd**2 - 264*D1**2*Pk2*f*gd2*r**2 + 132*D1**2*Pk2*f*gdd2*r**2 - 264*D1**2*Pk2*fd*g2*r**2 + 264*D1**2*Pk2*fd*gd2*r**2 + 132*D1**2*Pk2*fdd*g2*r**2 - 66*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 132*D1**2*Pkdd2*b2*fd*k1**2*s - 66*D1**2*Pkdd2*b2*fd*k1**2 + 33*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 66*D1**2*Pkdd2*b2*fdd*k1**2*s + 33*D1**2*Pkdd2*b2*fdd*k1**2 + 66*D1**2*Pkdd2*bd1**2*f*k1**2*s*(3*s - 2) - 66*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 66*D1**2*Pkdd2*bd2*fd*k1**2*s**2 - 66*D1**2*Pkdd2*bd2*fd*k1**2*s + 33*D1**2*Pkdd2*bdd2*f*k1**2*s**2 + 18*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 4*D1**2*Pkdd2*f**2*fd*k1**2*s + 2*D1**2*Pkdd2*f**2*fd*k1**2 - 9*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 2*D1**2*Pkdd2*f**2*fdd*k1**2*s - D1**2*Pkdd2*f**2*fdd*k1**2 - 18*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 4*D1**2*Pkdd2*f*fd**2*k1**2*s + 132*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 66*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 132*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 264*D1**2*Pkdd2*fd*g2*k1**2*s + 132*D1**2*Pkdd2*fd*g2*k1**2 - 132*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 132*D1**2*Pkdd2*fd*gd2*k1**2*s - 66*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + 132*D1**2*Pkdd2*fdd*g2*k1**2*s - 66*D1**2*Pkdd2*fdd*g2*k1**2 - 66*D1**2*bdd1*f*(Pk2*(K*(2*r**2 - 2*r + 1) - 4*f*s - 2*r**2 + r*(8*f*s - 2*f + 4*s + 2) - 2*s - 1) - Pkdd2*k1**2*s**2*(K + 1)) - 600*D1*Dd*Pk2*f**3*r**2 - 1064*D1*Dd*Pk2*f**3*r*s + 566*D1*Dd*Pk2*f**3*r + 266*D1*Dd*Pk2*f**3*s - 150*D1*Dd*Pk2*f**3 + 4176*D1*Dd*Pk2*f**2*fd*r**2 + 7152*D1*Dd*Pk2*f**2*fd*r*s - 3658*D1*Dd*Pk2*f**2*fd*r - 766*D1*Dd*Pk2*f**2*fd*s + 398*D1*Dd*Pk2*f**2*fd - 1056*D1*Dd*Pk2*f*g2*r**2 + 528*D1*Dd*Pk2*f*g2*r - 264*D1*Dd*Pk2*f*g2 + 1056*D1*Dd*Pk2*f*gd2*r**2 - 264*D1*Dd*Pk2*f*gd2*r + 1056*D1*Dd*Pk2*fd*g2*r**2 - 264*D1*Dd*Pk2*fd*g2*r - 264*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 132*D1*Dd*Pkdd2*b2*f*k1**2*s - 66*D1*Dd*Pkdd2*b2*f*k1**2 + 264*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 330*D1*Dd*Pkdd2*b2*fd*k1**2*s + 66*D1*Dd*Pkdd2*b2*fd*k1**2 + 264*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 66*D1*Dd*Pkdd2*bd2*f*k1**2*s + 24*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 12*D1*Dd*Pkdd2*f**3*k1**2*s + 6*D1*Dd*Pkdd2*f**3*k1**2 - 72*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 26*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 2*D1*Dd*Pkdd2*f**2*fd*k1**2 + 528*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 264*D1*Dd*Pkdd2*f*g2*k1**2*s + 132*D1*Dd*Pkdd2*f*g2*k1**2 - 528*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 132*D1*Dd*Pkdd2*f*gd2*k1**2*s - 528*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 660*D1*Dd*Pkdd2*fd*g2*k1**2*s - 132*D1*Dd*Pkdd2*fd*g2*k1**2 + 696*D1*Ddd*Pk2*f**3*r**2 + 1192*D1*Ddd*Pk2*f**3*r*s - 646*D1*Ddd*Pk2*f**3*r - 298*D1*Ddd*Pk2*f**3*s + 174*D1*Ddd*Pk2*f**3 + 528*D1*Ddd*Pk2*f*g2*r**2 - 264*D1*Ddd*Pk2*f*g2*r + 132*D1*Ddd*Pk2*f*g2 + 132*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 66*D1*Ddd*Pkdd2*b2*f*k1**2*s + 33*D1*Ddd*Pkdd2*b2*f*k1**2 - 12*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**3*k1**2*s - 3*D1*Ddd*Pkdd2*f**3*k1**2 - 264*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 132*D1*Ddd*Pkdd2*f*g2*k1**2*s - 66*D1*Ddd*Pkdd2*f*g2*k1**2 + 66*D1*bd1*(D1*(f**2*(Pk2*r*(8*s - 2) - 4*Pk2*s + Pkdd2*k1**2*s**2) - 2*f*(Pk2*(K*(-2*r**2 + 2*r - 1) + fd*(4*r - 1)*(4*s - 1) + 2*r**2 - 4*r*s - 2*r + 2*s + 1) + Pkdd2*k1**2*s**2*(K + 1)) + 2*fd*(Pk2*(-r**2*(2*K - 2) + r*(K - 4*s + 1) + s - 1) + Pkdd2*k1**2*s*(K + 1)*(s - 1))) - 2*Dd*f*(K*Pk2*(8*r**2 - 6*r + 1) + K*Pkdd2*k1**2*s*(1 - 4*s) + Pk2*f*(8*r - 3)*(4*s - 1) - 8*Pk2*r**2 + 16*Pk2*r*s + 4*Pk2*r - 6*Pk2*s - 4*Pkdd2*k1**2*s**2 + Pkdd2*k1**2*s)) + 2088*Dd**2*Pk2*f**3*r**2 + 3576*Dd**2*Pk2*f**3*r*s - 1938*Dd**2*Pk2*f**3*r - 894*Dd**2*Pk2*f**3*s + 298*Dd**2*Pk2*f**3 + 1584*Dd**2*Pk2*f*g2*r**2 - 792*Dd**2*Pk2*f*g2*r + 396*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 198*Dd**2*Pkdd2*b2*f*k1**2*s - 36*Dd**2*Pkdd2*f**3*k1**2*s**2 + 18*Dd**2*Pkdd2*f**3*k1**2*s - 792*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 396*Dd**2*Pkdd2*f*g2*k1**2*s) + f*(13*D1**2*bdd1*(33*Pkdd2*b2*k1**2*s**2 + f**2*(2*Pk2*(87*r**2 + 149*r*s - 108*r - 165*s + 58) + Pkdd2*k1**2*(-3*s**2 + 4*s - 2)) + 33*g2*(4*Pk2*(r - 1)**2 - 2*Pkdd2*k1**2*s**2)) - 2*f*(D1**2*(-4*Pk2*fd**2*(684*r**2 + r*(780*s - 537) - 195*s + 65) + f*(-4*Pk2*fdd*(228*r**2 + r*(260*s - 179) - 65*s + 57) + fd*(4*Pk2*(196*r**2 + 260*r*s - 163*r - 65*s + 49) + 13*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + D1*f*(Dd*(4*Pk2*f*(196*r**2 + r*(260*s - 163) - 65*s + 49) - 16*Pk2*fd*(4*r - 1)*(114*r + 130*s - 61) + 13*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 4*Ddd*Pk2*f*(228*r**2 + r*(260*s - 179) - 65*s + 57)) - 4*Dd**2*Pk2*f**2*(684*r**2 + r*(780*s - 537) - 195*s + 65))))/(3003*d**2*k1**2) + D1**2*Pk1*st**2*(176*D1**2*K*Pk2*bdd1*f**2*r**2 - 264*D1**2*Pk2*b2*f*fd*r**2 + 264*D1**2*Pk2*b2*f*fd*r - 132*D1**2*Pk2*b2*f*fd + 352*D1**2*Pk2*b2*f*fdd*r**2 - 352*D1**2*Pk2*b2*f*fdd*r + 176*D1**2*Pk2*b2*f*fdd + 352*D1**2*Pk2*b2*fd**2*r**2 - 352*D1**2*Pk2*b2*fd**2*r - 132*D1**2*Pk2*bd2*f**2*r**2 + 704*D1**2*Pk2*bd2*f*fd*r**2 - 352*D1**2*Pk2*bd2*f*fd*r + 192*D1**2*Pk2*bdd1*f**3*r**2 + 132*D1**2*Pk2*bdd1*f**3*r*s - 66*D1**2*Pk2*bdd1*f**3*r + 176*D1**2*Pk2*bdd1*f**2*r**2 - 22*D1**2*Pk2*bdd1*f**2*r*s - 44*D1**2*Pk2*bdd1*f*g2*r**2 + 176*D1**2*Pk2*bdd2*f**2*r**2 + 220*D1**2*Pk2*f**2*gd2*r**2 - 352*D1**2*Pk2*f**2*gdd2*r**2 + 440*D1**2*Pk2*f*fd*g2*r**2 - 440*D1**2*Pk2*f*fd*g2*r + 220*D1**2*Pk2*f*fd*g2 - 1408*D1**2*Pk2*f*fd*gd2*r**2 + 704*D1**2*Pk2*f*fd*gd2*r - 704*D1**2*Pk2*f*fdd*g2*r**2 + 704*D1**2*Pk2*f*fdd*g2*r - 352*D1**2*Pk2*f*fdd*g2 - 704*D1**2*Pk2*fd**2*g2*r**2 + 704*D1**2*Pk2*fd**2*g2*r - 11*D1**2*Pkdd2*b2*bdd1*f*k1**2*s**2 + 22*D1**2*Pkdd2*b2*bdd1*f*k1**2*s - 11*D1**2*Pkdd2*b2*bdd1*f*k1**2 - 22*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 + 22*D1**2*Pkdd2*b2*f*fd*k1**2*s - 11*D1**2*Pkdd2*b2*f*fd*k1**2 - 11*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 + 22*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 44*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 22*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 22*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 44*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 44*D1**2*Pkdd2*f*fd*g2*k1**2*s + 22*D1**2*Pkdd2*f*fd*g2*k1**2 + 22*D1**2*bd1**2*(28*Pk2*g2*r*(r - 1) + 7*Pkdd2*b2*k1**2*s*(s - 1) - 14*Pkdd2*g2*k1**2*s*(s - 1) + f**2*(Pk2*(64*r**2 + 108*r*s - 75*r - 54*s + 27) - Pkdd2*k1**2*s*(s - 1)) + f*(Pk2*(r**2*(2*K - 2) + 46*r*s - 23*s) - Pkdd2*k1**2*s*(K + 1)*(s - 1))) - 528*D1*Dd*Pk2*b2*f**2*r**2 + 264*D1*Dd*Pk2*b2*f**2*r - 132*D1*Dd*Pk2*b2*f**2 + 2816*D1*Dd*Pk2*b2*f*fd*r**2 - 2112*D1*Dd*Pk2*b2*f*fd*r + 352*D1*Dd*Pk2*b2*f*fd + 1408*D1*Dd*Pk2*bd2*f**2*r**2 - 352*D1*Dd*Pk2*bd2*f**2*r + 880*D1*Dd*Pk2*f**2*g2*r**2 - 440*D1*Dd*Pk2*f**2*g2*r + 220*D1*Dd*Pk2*f**2*g2 - 2816*D1*Dd*Pk2*f**2*gd2*r**2 + 704*D1*Dd*Pk2*f**2*gd2*r - 5632*D1*Dd*Pk2*f*fd*g2*r**2 + 4224*D1*Dd*Pk2*f*fd*g2*r - 704*D1*Dd*Pk2*f*fd*g2 - 44*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 + 22*D1*Dd*Pkdd2*b2*f**2*k1**2*s - 11*D1*Dd*Pkdd2*b2*f**2*k1**2 + 88*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 44*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 22*D1*Dd*Pkdd2*f**2*g2*k1**2 + 704*D1*Ddd*Pk2*b2*f**2*r**2 - 352*D1*Ddd*Pk2*b2*f**2*r + 176*D1*Ddd*Pk2*b2*f**2 - 1408*D1*Ddd*Pk2*f**2*g2*r**2 + 704*D1*Ddd*Pk2*f**2*g2*r - 352*D1*Ddd*Pk2*f**2*g2 - D1*bd1*(D1*(f**3*(6*Pk2*r*(20*r + 22*s - 11) + 11*Pkdd2*k1**2*(3*s**2 - 4*s + 2)) + f**2*(-6*Pk2*fd*(192*r**2 + 12*r*(11*s - 9) - 22*s + 11) + 22*Pk2*r*(5*K*r + 7*r - s) + 11*Pkdd2*k1**2*s**2*(K + 1)) - 11*f*(2*Pk2*fd*(r**2*(32*K + 32) - r*(16*K + 4*s + 15) + s) - 8*Pk2*gd2*r**2 + Pkdd2*b2*k1**2*(9*s**2 - 4*s + 2) - 2*Pkdd2*bd2*k1**2*s**2 + 2*Pkdd2*bd2*k1**2*s + 4*Pkdd2*gd2*k1**2*s**2 - 4*Pkdd2*gd2*k1**2*s + 2*g2*(2*Pk2*(9*r**2 - 14*r + 7) + Pkdd2*k1**2*(-9*s**2 + 4*s - 2))) + 22*fd*(4*Pk2*g2*r*(r - 1) + Pkdd2*b2*k1**2*s*(s - 1) - 2*Pkdd2*g2*k1**2*s*(s - 1))) - 2*Dd*f*(3*Pk2*f**2*(256*r**2 + 2*r*(88*s - 65) - 22*s + 11) + 11*Pk2*f*(r**2*(64*K + 64) - r*(16*K + 8*s + 15) + s) - 11*Pkdd2*b2*k1**2*(4*s**2 - 5*s + 1) + 22*g2*(2*Pk2*r*(1 - 4*r) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 2112*Dd**2*Pk2*b2*f**2*r**2 - 1056*Dd**2*Pk2*b2*f**2*r - 4224*Dd**2*Pk2*f**2*g2*r**2 + 2112*Dd**2*Pk2*f**2*g2*r + 11*b1**3*(D1**2*Pkdd2*k1**2*s**2*(9*fd - fdd) + D1*(28*Dd*Pk2*(K - 1)*(4*r**2 - 2*r + 1) + Dd*Pkdd2*k1**2*(-14*K*(4*s**2 - 2*s + 1) + 9*f*(4*s**2 - 2*s + 1) - 2*s**2*(4*fd + 28) + 2*s*(fd + 14) - 14) - 14*Ddd*Pk2*(K - 1)*(4*r**2 - 2*r + 1) - Ddd*Pkdd2*k1**2*(-7*K + f - 7)*(4*s**2 - 2*s + 1)) - 6*Dd**2*(Pk2*r*(14*K - 14)*(2*r - 1) + Pkdd2*k1**2*s*(2*s - 1)*(-7*K + f - 7))) + 11*b1**2*(-18*D1**2*K*Pk2*fd*r**2 + 8*D1**2*K*Pk2*fd*r - 4*D1**2*K*Pk2*fd + 2*D1**2*K*Pk2*fdd*r**2 - 4*D1**2*K*Pk2*fdd*r + 2*D1**2*K*Pk2*fdd + 9*D1**2*K*Pkdd2*fd*k1**2*s**2 - 14*D1**2*K*Pkdd2*fd*k1**2*s + 7*D1**2*K*Pkdd2*fd*k1**2 - D1**2*K*Pkdd2*fdd*k1**2*s**2 - 96*D1**2*Pk2*f*fd*r**2 - 216*D1**2*Pk2*f*fd*r*s + 78*D1**2*Pk2*f*fd*r - 12*D1**2*Pk2*f*fd + 128*D1**2*Pk2*f*fdd*r**2 + 216*D1**2*Pk2*f*fdd*r*s - 86*D1**2*Pk2*f*fdd*r + 16*D1**2*Pk2*f*fdd + 128*D1**2*Pk2*fd**2*r**2 + 216*D1**2*Pk2*fd**2*r*s - 86*D1**2*Pk2*fd**2*r + 18*D1**2*Pk2*fd*r**2 - 78*D1**2*Pk2*fd*r*s + 70*D1**2*Pk2*fd*r + 4*D1**2*Pk2*fd - 2*D1**2*Pk2*fdd*r**2 + 46*D1**2*Pk2*fdd*r*s - 42*D1**2*Pk2*fdd*r - 2*D1**2*Pk2*fdd - 56*D1**2*Pk2*gd2*r**2 + 28*D1**2*Pk2*gdd2*r**2 - 14*D1**2*Pkdd2*bd2*k1**2*s**2 + 7*D1**2*Pkdd2*bdd2*k1**2*s**2 - 4*D1**2*Pkdd2*f*fd*k1**2*s**2 + 2*D1**2*Pkdd2*f*fd*k1**2*s - D1**2*Pkdd2*f*fd*k1**2 - 2*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 2*D1**2*Pkdd2*fd**2*k1**2*s**2 + 9*D1**2*Pkdd2*fd*k1**2*s**2 - 14*D1**2*Pkdd2*fd*k1**2*s + 7*D1**2*Pkdd2*fd*k1**2 - D1**2*Pkdd2*fdd*k1**2*s**2 + 28*D1**2*Pkdd2*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*gdd2*k1**2*s**2 + D1**2*bdd1*(Pk2*(14 - 14*K)*(3*r**2 - 2*r + 1) - Pkdd2*k1**2*(-7*K + f - 7)*(3*s**2 - 2*s + 1)) - 72*D1*Dd*K*Pk2*f*r**2 + 36*D1*Dd*K*Pk2*f*r - 18*D1*Dd*K*Pk2*f + 16*D1*Dd*K*Pk2*fd*r**2 - 20*D1*Dd*K*Pk2*fd*r + 4*D1*Dd*K*Pk2*fd + 36*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 18*D1*Dd*K*Pkdd2*f*k1**2*s + 9*D1*Dd*K*Pkdd2*f*k1**2 - 8*D1*Dd*K*Pkdd2*fd*k1**2*s**2 + 2*D1*Dd*K*Pkdd2*fd*k1**2*s - 192*D1*Dd*Pk2*f**2*r**2 - 432*D1*Dd*Pk2*f**2*r*s + 204*D1*Dd*Pk2*f**2*r + 108*D1*Dd*Pk2*f**2*s - 48*D1*Dd*Pk2*f**2 + 1024*D1*Dd*Pk2*f*fd*r**2 + 1728*D1*Dd*Pk2*f*fd*r*s - 816*D1*Dd*Pk2*f*fd*r - 216*D1*Dd*Pk2*f*fd*s + 86*D1*Dd*Pk2*f*fd + 72*D1*Dd*Pk2*f*r**2 - 312*D1*Dd*Pk2*f*r*s + 42*D1*Dd*Pk2*f*r + 78*D1*Dd*Pk2*f*s + 18*D1*Dd*Pk2*f - 16*D1*Dd*Pk2*fd*r**2 + 368*D1*Dd*Pk2*fd*r*s - 210*D1*Dd*Pk2*fd*r - 46*D1*Dd*Pk2*fd*s + 42*D1*Dd*Pk2*fd - 224*D1*Dd*Pk2*g2*r**2 + 112*D1*Dd*Pk2*g2*r - 56*D1*Dd*Pk2*g2 + 224*D1*Dd*Pk2*gd2*r**2 - 56*D1*Dd*Pk2*gd2*r - 56*D1*Dd*Pkdd2*b2*k1**2*s**2 + 28*D1*Dd*Pkdd2*b2*k1**2*s - 14*D1*Dd*Pkdd2*b2*k1**2 + 56*D1*Dd*Pkdd2*bd2*k1**2*s**2 - 14*D1*Dd*Pkdd2*bd2*k1**2*s - 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 4*D1*Dd*Pkdd2*f**2*k1**2*s - 2*D1*Dd*Pkdd2*f**2*k1**2 - 16*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 4*D1*Dd*Pkdd2*f*fd*k1**2*s + 36*D1*Dd*Pkdd2*f*k1**2*s**2 - 18*D1*Dd*Pkdd2*f*k1**2*s + 9*D1*Dd*Pkdd2*f*k1**2 - 8*D1*Dd*Pkdd2*fd*k1**2*s**2 + 2*D1*Dd*Pkdd2*fd*k1**2*s + 112*D1*Dd*Pkdd2*g2*k1**2*s**2 - 56*D1*Dd*Pkdd2*g2*k1**2*s + 28*D1*Dd*Pkdd2*g2*k1**2 - 112*D1*Dd*Pkdd2*gd2*k1**2*s**2 + 28*D1*Dd*Pkdd2*gd2*k1**2*s + 8*D1*Ddd*K*Pk2*f*r**2 - 4*D1*Ddd*K*Pk2*f*r + 2*D1*Ddd*K*Pk2*f - 4*D1*Ddd*K*Pkdd2*f*k1**2*s**2 + 2*D1*Ddd*K*Pkdd2*f*k1**2*s - D1*Ddd*K*Pkdd2*f*k1**2 + 256*D1*Ddd*Pk2*f**2*r**2 + 432*D1*Ddd*Pk2*f**2*r*s - 236*D1*Ddd*Pk2*f**2*r - 108*D1*Ddd*Pk2*f**2*s + 64*D1*Ddd*Pk2*f**2 - 8*D1*Ddd*Pk2*f*r**2 + 184*D1*Ddd*Pk2*f*r*s - 42*D1*Ddd*Pk2*f*r - 46*D1*Ddd*Pk2*f*s - 2*D1*Ddd*Pk2*f + 112*D1*Ddd*Pk2*g2*r**2 - 56*D1*Ddd*Pk2*g2*r + 28*D1*Ddd*Pk2*g2 + 28*D1*Ddd*Pkdd2*b2*k1**2*s**2 - 14*D1*Ddd*Pkdd2*b2*k1**2*s + 7*D1*Ddd*Pkdd2*b2*k1**2 - 4*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**2*k1**2*s - D1*Ddd*Pkdd2*f**2*k1**2 - 4*D1*Ddd*Pkdd2*f*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f*k1**2*s - D1*Ddd*Pkdd2*f*k1**2 - 56*D1*Ddd*Pkdd2*g2*k1**2*s**2 + 28*D1*Ddd*Pkdd2*g2*k1**2*s - 14*D1*Ddd*Pkdd2*g2*k1**2 + D1*bd1*(28*D1*Pk2*(K - 1)*(3*r**2 - 2*r + 1) + D1*Pkdd2*k1**2*(-14*K*(3*s**2 - 2*s + 1) + 9*f*(3*s**2 - 2*s + 1) - 2*s**2*(3*fd + 21) + 2*s*(fd + 14) - 14) - 28*Dd*Pk2*(K - 1)*(12*r**2 - 7*r + 1) - 2*Dd*Pkdd2*k1**2*(-7*K + f - 7)*(12*s**2 - 7*s + 1)) + 24*Dd**2*K*Pk2*f*r**2 - 12*Dd**2*K*Pk2*f*r - 12*Dd**2*K*Pkdd2*f*k1**2*s**2 + 6*Dd**2*K*Pkdd2*f*k1**2*s + 768*Dd**2*Pk2*f**2*r**2 + 1296*Dd**2*Pk2*f**2*r*s - 708*Dd**2*Pk2*f**2*r - 324*Dd**2*Pk2*f**2*s + 108*Dd**2*Pk2*f**2 - 24*Dd**2*Pk2*f*r**2 + 552*Dd**2*Pk2*f*r*s - 126*Dd**2*Pk2*f*r - 138*Dd**2*Pk2*f*s + 46*Dd**2*Pk2*f + 336*Dd**2*Pk2*g2*r**2 - 168*Dd**2*Pk2*g2*r + 84*Dd**2*Pkdd2*b2*k1**2*s**2 - 42*Dd**2*Pkdd2*b2*k1**2*s - 12*Dd**2*Pkdd2*f**2*k1**2*s**2 + 6*Dd**2*Pkdd2*f**2*k1**2*s - 12*Dd**2*Pkdd2*f*k1**2*s**2 + 6*Dd**2*Pkdd2*f*k1**2*s - 168*Dd**2*Pkdd2*g2*k1**2*s**2 + 84*Dd**2*Pkdd2*g2*k1**2*s) - b1*(220*D1**2*K*Pk2*f*fd*r**2 - 220*D1**2*K*Pk2*f*fd*r + 110*D1**2*K*Pk2*f*fd - 352*D1**2*K*Pk2*f*fdd*r**2 + 352*D1**2*K*Pk2*f*fdd*r - 176*D1**2*K*Pk2*f*fdd - 352*D1**2*K*Pk2*fd**2*r**2 + 352*D1**2*K*Pk2*fd**2*r + 22*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 22*D1**2*K*Pkdd2*f*fd*k1**2*s + 11*D1**2*K*Pkdd2*f*fd*k1**2 + 360*D1**2*Pk2*f**2*fd*r**2 + 396*D1**2*Pk2*f**2*fd*r*s - 306*D1**2*Pk2*f**2*fd*r - 132*D1**2*Pk2*f**2*fd*s + 120*D1**2*Pk2*f**2*fd - 576*D1**2*Pk2*f**2*fdd*r**2 - 396*D1**2*Pk2*f**2*fdd*r*s + 450*D1**2*Pk2*f**2*fdd*r + 132*D1**2*Pk2*f**2*fdd*s - 192*D1**2*Pk2*f**2*fdd - 1152*D1**2*Pk2*f*fd**2*r**2 - 792*D1**2*Pk2*f*fd**2*r*s + 900*D1**2*Pk2*f*fd**2*r + 264*D1**2*Pk2*f*fd**2*s - 66*D1**2*Pk2*f*fd**2 + 308*D1**2*Pk2*f*fd*r**2 - 44*D1**2*Pk2*f*fd*r*s - 286*D1**2*Pk2*f*fd*r + 22*D1**2*Pk2*f*fd*s + 154*D1**2*Pk2*f*fd - 352*D1**2*Pk2*f*fdd*r**2 + 44*D1**2*Pk2*f*fdd*r*s + 330*D1**2*Pk2*f*fdd*r - 22*D1**2*Pk2*f*fdd*s - 176*D1**2*Pk2*f*fdd - 396*D1**2*Pk2*f*gd2*r**2 + 44*D1**2*Pk2*f*gdd2*r**2 - 352*D1**2*Pk2*fd**2*r**2 + 44*D1**2*Pk2*fd**2*r*s + 330*D1**2*Pk2*fd**2*r - 22*D1**2*Pk2*fd**2*s + 22*D1**2*Pk2*fd**2 - 396*D1**2*Pk2*fd*g2*r**2 + 176*D1**2*Pk2*fd*g2*r - 88*D1**2*Pk2*fd*g2 + 88*D1**2*Pk2*fd*gd2*r**2 - 88*D1**2*Pk2*fd*gd2*r + 44*D1**2*Pk2*fdd*g2*r**2 - 88*D1**2*Pk2*fdd*g2*r + 44*D1**2*Pk2*fdd*g2 - 99*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 154*D1**2*Pkdd2*b2*fd*k1**2*s - 77*D1**2*Pkdd2*b2*fd*k1**2 + 11*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 99*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 22*D1**2*Pkdd2*bd2*fd*k1**2*s**2 + 11*D1**2*Pkdd2*bdd2*f*k1**2*s**2 + 99*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 22*D1**2*Pkdd2*f**2*fd*k1**2*s + 11*D1**2*Pkdd2*f**2*fd*k1**2 + 22*D1**2*Pkdd2*f*fd*k1**2*s**2 - 22*D1**2*Pkdd2*f*fd*k1**2*s + 11*D1**2*Pkdd2*f*fd*k1**2 + 198*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 22*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 198*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 308*D1**2*Pkdd2*fd*g2*k1**2*s + 154*D1**2*Pkdd2*fd*g2*k1**2 - 44*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 22*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + 22*D1**2*bd1**2*(Pk2*r*(14*K - 14)*(3*r - 2) + Pkdd2*k1**2*s*(3*s - 2)*(-7*K + f - 7)) - 11*D1**2*bdd1*(7*Pk2*g2*(8*r**2 - 8*r + 4) + 7*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) - 14*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + f**2*(2*Pk2*(64*r**2 + 108*r*s - 75*r - 54*s + 24) + Pkdd2*k1**2*(-2*s**2 + 2*s - 1)) - f*(Pk2*r**2*(4 - 4*K) - 92*Pk2*r*s + 46*Pk2*s + Pkdd2*k1**2*(K + 1)*(2*s**2 - 2*s + 1))) + 440*D1*Dd*K*Pk2*f**2*r**2 - 220*D1*Dd*K*Pk2*f**2*r + 110*D1*Dd*K*Pk2*f**2 - 2816*D1*Dd*K*Pk2*f*fd*r**2 + 2112*D1*Dd*K*Pk2*f*fd*r - 352*D1*Dd*K*Pk2*f*fd + 44*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 22*D1*Dd*K*Pkdd2*f**2*k1**2*s + 11*D1*Dd*K*Pkdd2*f**2*k1**2 + 480*D1*Dd*Pk2*f**3*r**2 + 528*D1*Dd*Pk2*f**3*r*s - 372*D1*Dd*Pk2*f**3*r - 132*D1*Dd*Pk2*f**3*s + 120*D1*Dd*Pk2*f**3 - 4608*D1*Dd*Pk2*f**2*fd*r**2 - 3168*D1*Dd*Pk2*f**2*fd*r*s + 3348*D1*Dd*Pk2*f**2*fd*r + 924*D1*Dd*Pk2*f**2*fd*s - 582*D1*Dd*Pk2*f**2*fd + 616*D1*Dd*Pk2*f**2*r**2 - 88*D1*Dd*Pk2*f**2*r*s - 286*D1*Dd*Pk2*f**2*r + 22*D1*Dd*Pk2*f**2*s + 154*D1*Dd*Pk2*f**2 - 2816*D1*Dd*Pk2*f*fd*r**2 + 352*D1*Dd*Pk2*f*fd*r*s + 1980*D1*Dd*Pk2*f*fd*r - 132*D1*Dd*Pk2*f*fd*s - 308*D1*Dd*Pk2*f*fd - 1584*D1*Dd*Pk2*f*g2*r**2 + 792*D1*Dd*Pk2*f*g2*r - 396*D1*Dd*Pk2*f*g2 + 352*D1*Dd*Pk2*f*gd2*r**2 - 88*D1*Dd*Pk2*f*gd2*r + 352*D1*Dd*Pk2*fd*g2*r**2 - 440*D1*Dd*Pk2*fd*g2*r + 88*D1*Dd*Pk2*fd*g2 - 396*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 198*D1*Dd*Pkdd2*b2*f*k1**2*s - 99*D1*Dd*Pkdd2*b2*f*k1**2 + 88*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 22*D1*Dd*Pkdd2*b2*fd*k1**2*s + 88*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 22*D1*Dd*Pkdd2*bd2*f*k1**2*s + 132*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 66*D1*Dd*Pkdd2*f**3*k1**2*s + 33*D1*Dd*Pkdd2*f**3*k1**2 + 44*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 22*D1*Dd*Pkdd2*f**2*k1**2*s + 11*D1*Dd*Pkdd2*f**2*k1**2 + 792*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 396*D1*Dd*Pkdd2*f*g2*k1**2*s + 198*D1*Dd*Pkdd2*f*g2*k1**2 - 176*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 44*D1*Dd*Pkdd2*f*gd2*k1**2*s - 176*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 44*D1*Dd*Pkdd2*fd*g2*k1**2*s - 704*D1*Ddd*K*Pk2*f**2*r**2 + 352*D1*Ddd*K*Pk2*f**2*r - 176*D1*Ddd*K*Pk2*f**2 - 768*D1*Ddd*Pk2*f**3*r**2 - 528*D1*Ddd*Pk2*f**3*r*s + 516*D1*Ddd*Pk2*f**3*r + 132*D1*Ddd*Pk2*f**3*s - 192*D1*Ddd*Pk2*f**3 - 704*D1*Ddd*Pk2*f**2*r**2 + 88*D1*Ddd*Pk2*f**2*r*s + 330*D1*Ddd*Pk2*f**2*r - 22*D1*Ddd*Pk2*f**2*s - 176*D1*Ddd*Pk2*f**2 + 176*D1*Ddd*Pk2*f*g2*r**2 - 88*D1*Ddd*Pk2*f*g2*r + 44*D1*Ddd*Pk2*f*g2 + 44*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 22*D1*Ddd*Pkdd2*b2*f*k1**2*s + 11*D1*Ddd*Pkdd2*b2*f*k1**2 - 88*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 44*D1*Ddd*Pkdd2*f*g2*k1**2*s - 22*D1*Ddd*Pkdd2*f*g2*k1**2 + 11*D1*bd1*(D1*(14*Pk2*g2*(8*r**2 - 8*r + 4) - 112*Pk2*gd2*r**2 + 56*Pk2*gd2*r + 14*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) - 28*Pkdd2*bd2*k1**2*s**2 + 14*Pkdd2*bd2*k1**2*s - 28*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 56*Pkdd2*gd2*k1**2*s**2 - 28*Pkdd2*gd2*k1**2*s + f**2*(6*Pk2*(16*r**2 + 3*r*(12*s - 7) - 18*s + 6) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 2*f*(Pk2*(K*(-18*r**2 + 14*r - 7) + fd*(256*r**2 + 4*r*(108*s - 59) - 108*s + 27) + 18*r**2 - 78*r*s - 14*r + 39*s + 7) + Pkdd2*k1**2*(K*(9*s**2 - 2*s + 1) + s**2*(9 - 4*fd) + s*(2*fd - 2) + 1)) + 2*fd*(Pk2*(r**2*(4 - 4*K) + r*(4*K - 92*s + 42) + 23*s - 23) + Pkdd2*k1**2*s*(K + 1)*(2*s - 1))) - 2*Dd*(28*Pk2*g2*(8*r**2 - 6*r + 1) + 7*Pkdd2*b2*k1**2*(8*s**2 - 6*s + 1) - 14*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) + f**2*(Pk2*(8*r - 3)*(64*r + 108*s - 43) + Pkdd2*k1**2*(-8*s**2 + 6*s - 1)) + f*(Pk2*(r**2*(16*K - 16) + r*(-4*K + 368*s - 42) - 138*s + 23) - Pkdd2*k1**2*(K + 1)*(8*s**2 - 6*s + 1)))) - 2112*Dd**2*K*Pk2*f**2*r**2 + 1056*Dd**2*K*Pk2*f**2*r - 2304*Dd**2*Pk2*f**3*r**2 - 1584*Dd**2*Pk2*f**3*r*s + 1548*Dd**2*Pk2*f**3*r + 396*Dd**2*Pk2*f**3*s - 132*Dd**2*Pk2*f**3 - 2112*Dd**2*Pk2*f**2*r**2 + 264*Dd**2*Pk2*f**2*r*s + 990*Dd**2*Pk2*f**2*r - 66*Dd**2*Pk2*f**2*s + 22*Dd**2*Pk2*f**2 + 528*Dd**2*Pk2*f*g2*r**2 - 264*Dd**2*Pk2*f*g2*r + 132*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 66*Dd**2*Pkdd2*b2*f*k1**2*s - 264*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 132*Dd**2*Pkdd2*f*g2*k1**2*s))/(462*d**2*k1**2) + D1**2*Pk1*(D1*(22*D1*Pk2*b2*bdd1*f*r**2 + 2*D1*Pk2*bd1**2*f*r*(3*f*(4*r + 2*s - 1) + r*(22*K + 22) + 6*s - 3) - 44*D1*Pk2*bdd1*f*g2*r**2 - b2*bd1*(-44*D1*Pk2*fd*r*(r - 1) + D1*f*(2*Pk2*r**2 + 7*Pkdd2*k1**2*(s - 1)**2) + 44*Dd*Pk2*f*r*(1 - 4*r)) + 2*bd1*(D1*(22*Pk2*f*r**2*(bd2 - 2*gd2) - 44*Pk2*fd*g2*r*(r - 1) + f*g2*(-12*Pk2*r**2 + 7*Pkdd2*k1**2*(s - 1)**2)) + 44*Dd*Pk2*f*g2*r*(1 - 4*r))) + b1**3*(D1*Dd*(4*Pk2*(44*fd*r**2 + 2*r*(28*fd*s - 9*fd - 28*s + 7) - s*(7*fd - 14)) - f*(2*Pk2*(4*r**2 + 8*r*(7*s - 2) - 14*s + 1) + 7*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + D1*(D1*(-2*Pk2*fd*r*(r + 14*s) + 2*Pk2*fdd*r*(11*r + 14*s) - 7*Pkdd2*fd*k1**2*s**2) + 2*Ddd*Pk2*(f*(44*r**2 + 56*r*s - 36*r - 14*s + 11) + 56*r*s - 14*r - 14*s)) + 4*Dd**2*Pk2*(f*(66*r**2 + 84*r*s - 54*r - 21*s + 7) + 84*r*s - 21*r - 21*s + 7)) + b1**2*(12*D1**2*K*Pk2*fd*r**2 - 24*D1**2*K*Pk2*fd*r + 12*D1**2*K*Pk2*fd + 22*D1**2*K*Pk2*fdd*r**2 - 44*D1**2*K*Pk2*fdd*r + 22*D1**2*K*Pk2*fdd - 7*D1**2*K*Pkdd2*fd*k1**2*s**2 + 2*D1**2*Pk2*bdd1*(f*(33*r**2 + 6*r*(7*s - 6) - 14*s + 11) + 14*r*(3*s - 1) - 14*s) + 24*D1**2*Pk2*f*fd*r**2 - 12*D1**2*Pk2*f*fd*r*s - 24*D1**2*Pk2*f*fd*r + 6*D1**2*Pk2*f*fd*s + 12*D1**2*Pk2*f*fd + 24*D1**2*Pk2*f*fdd*r**2 + 12*D1**2*Pk2*f*fdd*r*s - 24*D1**2*Pk2*f*fdd*r - 6*D1**2*Pk2*f*fdd*s + 12*D1**2*Pk2*f*fdd + 24*D1**2*Pk2*fd**2*r**2 + 12*D1**2*Pk2*fd**2*r*s - 24*D1**2*Pk2*fd**2*r - 6*D1**2*Pk2*fd**2*s - 16*D1**2*Pk2*fd*r**2 - 26*D1**2*Pk2*fd*r*s + 32*D1**2*Pk2*fd*r + 26*D1**2*Pk2*fd*s - 16*D1**2*Pk2*fd + 22*D1**2*Pk2*fdd*r**2 + 6*D1**2*Pk2*fdd*r*s - 44*D1**2*Pk2*fdd*r - 6*D1**2*Pk2*fdd*s + 22*D1**2*Pk2*fdd - 12*D1**2*Pkdd2*f*fd*k1**2*s**2 - 7*D1**2*Pkdd2*fd*k1**2*s**2 + 48*D1*Dd*K*Pk2*f*r**2 - 24*D1*Dd*K*Pk2*f*r + 12*D1*Dd*K*Pk2*f + 176*D1*Dd*K*Pk2*fd*r**2 - 220*D1*Dd*K*Pk2*fd*r + 44*D1*Dd*K*Pk2*fd - 28*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 14*D1*Dd*K*Pkdd2*f*k1**2*s - 7*D1*Dd*K*Pkdd2*f*k1**2 + 48*D1*Dd*Pk2*f**2*r**2 - 24*D1*Dd*Pk2*f**2*r*s - 18*D1*Dd*Pk2*f**2*r + 6*D1*Dd*Pk2*f**2*s + 12*D1*Dd*Pk2*f**2 + 192*D1*Dd*Pk2*f*fd*r**2 + 96*D1*Dd*Pk2*f*fd*r*s - 156*D1*Dd*Pk2*f*fd*r - 36*D1*Dd*Pk2*f*fd*s + 30*D1*Dd*Pk2*f*fd - 64*D1*Dd*Pk2*f*r**2 - 104*D1*Dd*Pk2*f*r*s + 58*D1*Dd*Pk2*f*r + 26*D1*Dd*Pk2*f*s - 16*D1*Dd*Pk2*f + 176*D1*Dd*Pk2*fd*r**2 + 48*D1*Dd*Pk2*fd*r*s - 226*D1*Dd*Pk2*fd*r - 30*D1*Dd*Pk2*fd*s + 50*D1*Dd*Pk2*fd - 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 12*D1*Dd*Pkdd2*f**2*k1**2*s - 6*D1*Dd*Pkdd2*f**2*k1**2 - 28*D1*Dd*Pkdd2*f*k1**2*s**2 + 14*D1*Dd*Pkdd2*f*k1**2*s - 7*D1*Dd*Pkdd2*f*k1**2 + 88*D1*Ddd*K*Pk2*f*r**2 - 44*D1*Ddd*K*Pk2*f*r + 22*D1*Ddd*K*Pk2*f + 48*D1*Ddd*Pk2*f**2*r**2 + 24*D1*Ddd*Pk2*f**2*r*s - 30*D1*Ddd*Pk2*f**2*r - 6*D1*Ddd*Pk2*f**2*s + 12*D1*Ddd*Pk2*f**2 + 88*D1*Ddd*Pk2*f*r**2 + 24*D1*Ddd*Pk2*f*r*s - 50*D1*Ddd*Pk2*f*r - 6*D1*Ddd*Pk2*f*s + 22*D1*Ddd*Pk2*f + D1*bd1*(D1*(4*Pk2*(33*fd*r**2 + 2*r*(21*fd*s - 9*fd - 21*s + 7) - s*(7*fd - 14)) - f*(Pk2*(6*r**2 + 84*r*s - 32*r - 28*s + 2) + 7*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + 4*Dd*Pk2*(f*(132*r**2 + 42*r*(4*s - 3) - 49*s + 25) + 7*r*(24*s - 7) - 49*s + 14)) + 264*Dd**2*K*Pk2*f*r**2 - 132*Dd**2*K*Pk2*f*r + 144*Dd**2*Pk2*f**2*r**2 + 72*Dd**2*Pk2*f**2*r*s - 90*Dd**2*Pk2*f**2*r - 18*Dd**2*Pk2*f**2*s + 6*Dd**2*Pk2*f**2 + 264*Dd**2*Pk2*f*r**2 + 72*Dd**2*Pk2*f*r*s - 150*Dd**2*Pk2*f*r - 18*Dd**2*Pk2*f*s + 6*Dd**2*Pk2*f) + b1*(44*D1**2*K*Pk2*bdd1*f*r**2 + 4*D1**2*Pk2*bd1**2*(f*(33*r**2 + 6*r*(7*s - 6) - 14*s + 7) + 7*r*(6*s - 2) - 14*s + 7) - 2*D1**2*Pk2*bd2*f*r**2 + 44*D1**2*Pk2*bd2*fd*r**2 - 44*D1**2*Pk2*bd2*fd*r + 24*D1**2*Pk2*bdd1*f**2*r**2 + 12*D1**2*Pk2*bdd1*f**2*r*s - 6*D1**2*Pk2*bdd1*f**2*r + 44*D1**2*Pk2*bdd1*f*r**2 + 12*D1**2*Pk2*bdd1*f*r*s - 6*D1**2*Pk2*bdd1*f*r + 22*D1**2*Pk2*bdd2*f*r**2 - 24*D1**2*Pk2*f*gd2*r**2 - 44*D1**2*Pk2*f*gdd2*r**2 - 24*D1**2*Pk2*fd*g2*r**2 + 48*D1**2*Pk2*fd*g2*r - 24*D1**2*Pk2*fd*g2 - 88*D1**2*Pk2*fd*gd2*r**2 + 88*D1**2*Pk2*fd*gd2*r - 44*D1**2*Pk2*fdd*g2*r**2 + 88*D1**2*Pk2*fdd*g2*r - 44*D1**2*Pk2*fdd*g2 - 7*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 14*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 14*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 176*D1*Dd*Pk2*bd2*f*r**2 - 44*D1*Dd*Pk2*bd2*f*r - 96*D1*Dd*Pk2*f*g2*r**2 + 48*D1*Dd*Pk2*f*g2*r - 24*D1*Dd*Pk2*f*g2 - 352*D1*Dd*Pk2*f*gd2*r**2 + 88*D1*Dd*Pk2*f*gd2*r - 352*D1*Dd*Pk2*fd*g2*r**2 + 440*D1*Dd*Pk2*fd*g2*r - 88*D1*Dd*Pk2*fd*g2 + 56*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 28*D1*Dd*Pkdd2*f*g2*k1**2*s + 14*D1*Dd*Pkdd2*f*g2*k1**2 - 176*D1*Ddd*Pk2*f*g2*r**2 + 88*D1*Ddd*Pk2*f*g2*r - 44*D1*Ddd*Pk2*f*g2 + D1*bd1*(D1*(2*Pk2*f*r*(3*f*(4*r - 2*s + 1) + r*(12*K - 16) - 26*s + 13) + 2*Pk2*fd*(3*f*(16*r**2 + 2*r*(4*s - 5) - 2*s + 1) + r**2*(44*K + 44) + r*(-44*K + 12*s - 47) - 6*s + 3) - Pkdd2*f*k1**2*(7*K + 6*f + 7)*(2*s**2 - 2*s + 1)) + 2*Dd*Pk2*f*(f*(96*r**2 + 6*r*(8*s - 7) - 6*s + 3) + r**2*(176*K + 176) + r*(-44*K + 48*s - 62) - 6*s + 3)) - 528*Dd**2*Pk2*f*g2*r**2 + 264*Dd**2*Pk2*f*g2*r + b2*(D1**2*(22*Pk2*fdd*(r - 1)**2 - fd*(2*Pk2*(r - 1)**2 + 7*Pkdd2*k1**2*s**2)) + D1*(44*Dd*Pk2*fd*(4*r**2 - 5*r + 1) - Dd*f*(Pk2*(8*r**2 - 4*r + 2) + 7*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 22*Ddd*Pk2*f*(4*r**2 - 2*r + 1)) + 132*Dd**2*Pk2*f*r*(2*r - 1))))/(21*d**2*k1**2) + D1**2*Pk2*Pkd1*ct**7*k2**3*(8*C - 8)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1650*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 345*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2940*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 560*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 495*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1485*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 165*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r + 420*Dd**2*f**3*s - 140*Dd**2*f**3)/(693*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**7*k2*(16*C - 16)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 1) - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - 40*D1**2*Pk2*Pkd1*ct**6*f*(13*D1*bd1*f*(D1*(23*f*s*(r - 1) - 28*fd*(6*r*s - r - 3*s + 1)) - 28*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 13*b1*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(23*f*fd - 28*f*fdd - 56*fd**2) + 28*Ddd*f**2*(4*r*s - r - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 7*f*(2*D1*Dd*f*(19*f*(-4*r*s + r + s) + 45*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-38*f*fd*(r*(4*s - 1) - s) + f*(52*bdd1*s*(r - 1) + 45*fdd*(4*r*s - r - s)) + 45*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 45*Ddd*f**2*(r*(4*s - 1) - s)) + 45*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k1) + D1**2*Pk2*Pkd1*ct**6*k1*k2**2*(24*C - 28)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1650*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 345*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2940*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 560*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 495*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1485*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 165*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r + 420*Dd**2*f**3*s - 140*Dd**2*f**3)/(693*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**6*k1*(32*C - 40)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 1) - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct**6*k2**4*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1650*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 345*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2940*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 560*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 495*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1485*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 165*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r + 420*Dd**2*f**3*s - 140*Dd**2*f**3)/(693*d**2*k1*k3**4) + 2*D1**2*Pk2*Pkd1*ct**6*k2**2*(660*C*D1**2*b1*f*fd*r**2 + 66*C*D1**2*b1*f*fdd*r**2 + 66*C*D1**2*b1*fd**2*r**2 + 240*C*D1**2*f**2*fd*r**2 - 160*C*D1**2*f**2*fd*r + 80*C*D1**2*f**2*fd + 375*C*D1**2*f**2*fdd*r**2 - 250*C*D1**2*f**2*fdd*r + 125*C*D1**2*f**2*fdd + 750*C*D1**2*f*fd**2*r**2 - 500*C*D1**2*f*fd**2*r + 1320*C*D1*Dd*b1*f**2*r**2 - 660*C*D1*Dd*b1*f**2*r + 330*C*D1*Dd*b1*f**2 + 528*C*D1*Dd*b1*f*fd*r**2 - 132*C*D1*Dd*b1*f*fd*r + 320*C*D1*Dd*f**3*r**2 - 160*C*D1*Dd*f**3*r + 80*C*D1*Dd*f**3 + 3000*C*D1*Dd*f**2*fd*r**2 - 1750*C*D1*Dd*f**2*fd*r + 250*C*D1*Dd*f**2*fd + 132*C*D1*Ddd*b1*f**2*r**2 - 66*C*D1*Ddd*b1*f**2*r + 33*C*D1*Ddd*b1*f**2 + 500*C*D1*Ddd*f**3*r**2 - 250*C*D1*Ddd*f**3*r + 125*C*D1*Ddd*f**3 + 396*C*Dd**2*b1*f**2*r**2 - 198*C*Dd**2*b1*f**2*r + 1500*C*Dd**2*f**3*r**2 - 750*C*Dd**2*f**3*r - 660*D1**2*b1*f*fd*r**2 - 528*D1**2*b1*f*fd*r*s + 264*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 + 660*D1**2*b1*f*fdd*r*s - 330*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 + 660*D1**2*b1*fd**2*r*s - 330*D1**2*b1*fd**2*r + 33*D1**2*bdd1*f**2*(r - 1)*(C*(r - 1) - r + 10*s + 1) - 240*D1**2*f**2*fd*r**2 - 690*D1**2*f**2*fd*r*s + 390*D1**2*f**2*fd*r + 230*D1**2*f**2*fd*s - 80*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 30*D1**2*f**2*fdd*r - 280*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 60*D1**2*f*fd**2*r - 560*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 1320*D1*Dd*b1*f**2*r**2 - 1056*D1*Dd*b1*f**2*r*s + 924*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s - 330*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 5280*D1*Dd*b1*f*fd*r*s - 1848*D1*Dd*b1*f*fd*r - 660*D1*Dd*b1*f*fd*s + 330*D1*Dd*b1*f*fd - 320*D1*Dd*f**3*r**2 - 920*D1*Dd*f**3*r*s + 390*D1*Dd*f**3*r + 230*D1*Dd*f**3*s - 80*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 210*D1*Dd*f**2*fd*r - 1960*D1*Dd*f**2*fd*s + 310*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 1320*D1*Ddd*b1*f**2*r*s - 264*D1*Ddd*b1*f**2*r - 330*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 500*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s - 125*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*f*(r - 1)*(5*C*(r - 1) - 5*r - 4*s + 5) + D1*fd*(r**2*(2*C - 2) + r*(-2*C + 20*s - 3) - 10*s + 5) + Dd*f*(4*C*r**2 - 5*C*r + C - 4*r**2 + 40*r*s - 25*s + 4)) - 396*Dd**2*b1*f**2*r**2 + 3960*Dd**2*b1*f**2*r*s - 792*Dd**2*b1*f**2*r - 990*Dd**2*b1*f**2*s + 330*Dd**2*b1*f**2 - 1500*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 90*Dd**2*f**3*r - 840*Dd**2*f**3*s + 280*Dd**2*f**3)/(693*d**2*k1*k3**2) - 205*D1**2*Pk2*Pkd1*ct**5*f*k2*(78*D1**2*b1*f*fd*r**2 - 39*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*fd**2*r**2 - 13*D1**2*bdd1*f**2*(r - 1)**2 + 56*D1**2*f**2*fd*r**2 - 28*D1**2*f**2*fd*r + 14*D1**2*f**2*fd - 28*D1**2*f**2*fdd*r**2 + 14*D1**2*f**2*fdd*r - 7*D1**2*f**2*fdd - 84*D1**2*f*fd**2*r**2 + 42*D1**2*f*fd**2*r + 104*D1*Dd*b1*f**2*r**2 - 52*D1*Dd*b1*f**2*r + 26*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 + 78*D1*Dd*b1*f*fd*r + 56*D1*Dd*f**3*r**2 - 28*D1*Dd*f**3*r + 14*D1*Dd*f**3 - 224*D1*Dd*f**2*fd*r**2 + 112*D1*Dd*f**2*fd*r - 14*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 + 26*D1*Ddd*b1*f**2*r - 13*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 + 14*D1*Ddd*f**3*r - 7*D1*Ddd*f**3 + 26*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 156*Dd**2*b1*f**2*r**2 + 78*Dd**2*b1*f**2*r - 84*Dd**2*f**3*r**2 + 42*Dd**2*f**3*r)/(9009*d**2*k1**2) + D1**2*Pk2*Pkd1*ct**5*k1**2*k2*(8*C - 12)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1650*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 345*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2940*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 560*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 495*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1485*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 165*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r + 420*Dd**2*f**3*s - 140*Dd**2*f**3)/(231*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**5*k1**2*(16*C - 32)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 1) - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k2*k3**2) + D1**2*Pk2*Pkd1*ct**5*k2**3*st**2*(8*C - 8)*(462*D1**2*b1*f*fd*r**2 + 462*D1**2*b1*f*fd*r*s - 231*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 453*D1**2*f**2*fd*r**2 + 453*D1**2*f**2*fd*r*s - 453*D1**2*f**2*fd*r - 151*D1**2*f**2*fd*s + 151*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 375*D1**2*f**2*fdd*r*s + 375*D1**2*f**2*fdd*r + 125*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 750*D1**2*f*fd**2*r*s + 750*D1**2*f*fd**2*r + 250*D1**2*f*fd**2*s - 125*D1**2*f*fd**2 + 924*D1*Dd*b1*f**2*r**2 + 924*D1*Dd*b1*f**2*r*s - 693*D1*Dd*b1*f**2*r - 231*D1*Dd*b1*f**2*s + 231*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1650*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 604*D1*Dd*f**3*r**2 + 604*D1*Dd*f**3*r*s - 453*D1*Dd*f**3*r - 151*D1*Dd*f**3*s + 151*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 3000*D1*Dd*f**2*fd*r*s + 2625*D1*Dd*f**2*fd*r + 875*D1*Dd*f**2*fd*s - 500*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 495*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 500*D1*Ddd*f**3*r**2 - 500*D1*Ddd*f**3*r*s + 375*D1*Ddd*f**3*r + 125*D1*Ddd*f**3*s - 125*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(7*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1485*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 165*Dd**2*b1*f**2 - 1500*Dd**2*f**3*r**2 - 1500*Dd**2*f**3*r*s + 1125*Dd**2*f**3*r + 375*Dd**2*f**3*s - 125*Dd**2*f**3)/(693*d**2*k3**4) + 4*D1**2*Pk2*Pkd1*ct**5*k2**3*(66*b1**2*(C - 1)*(D1**2*r*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 6*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 6*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 33*b1*(-8*C*D1**2*f*fd*r - 8*C*D1**2*f*fd*s + 8*C*D1**2*f*fd + 10*C*D1**2*f*fdd*r + 10*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd + 10*C*D1**2*fd**2*r + 10*C*D1**2*fd**2*s + 40*C*D1*Dd*f*fd*r + 40*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd - 12*D1**2*bdd1*f*(C - 1)*(2*r - 1)*(r + s - 1) - 40*D1**2*f*fd*r**2 - 40*D1**2*f*fd*r*s + 28*D1**2*f*fd*r + 8*D1**2*f*fd*s - 8*D1**2*f*fd + 50*D1**2*f*fdd*r**2 + 50*D1**2*f*fdd*r*s - 35*D1**2*f*fdd*r - 10*D1**2*f*fdd*s + 10*D1**2*f*fdd + 50*D1**2*fd**2*r**2 + 50*D1**2*fd**2*r*s - 35*D1**2*fd**2*r - 10*D1**2*fd**2*s - 80*D1*Dd*f**2*r**2 - 80*D1*Dd*f**2*r*s + 60*D1*Dd*f**2*r + 20*D1*Dd*f**2*s - 20*D1*Dd*f**2 + 400*D1*Dd*f*fd*r**2 + 400*D1*Dd*f*fd*r*s - 290*D1*Dd*f*fd*r - 90*D1*Dd*f*fd*s + 45*D1*Dd*f*fd + 100*D1*Ddd*f**2*r**2 + 100*D1*Ddd*f**2*r*s - 75*D1*Ddd*f**2*r - 25*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 + 2*D1*bd1*(C - 1)*(D1*(5*f*(2*r - 1)*(r + s - 1) + 6*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 12*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 300*Dd**2*f**2*r**2 + 300*Dd**2*f**2*r*s - 225*Dd**2*f**2*r - 75*Dd**2*f**2*s + 25*Dd**2*f**2) + f*(-396*D1**2*bd1**2*(C - 1)*(2*r - 1)*(r + s - 1) - 165*D1**2*bdd1*f*(2*C - 5*r + 3)*(r + s - 1) + 33*D1*bd1*(D1*(4*f*(2*C - 5*r + 3)*(r + s - 1) + 5*fd*(20*r**2 + r*(-2*C + 20*s - 23) - s*(2*C + 8) + 5)) + 5*Dd*f*(C*(-8*r - 8*s + 4) + 40*r**2 + r*(40*s - 47) - 17*s + 11)) - 5*(2*C + 3)*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 28*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(23*f*(4*r**2 + r*(4*s - 3) - s + 1) - 28*fd*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)) - 28*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 28*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1))))/(693*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**5*k2*st**2*(16*C - 16)*(33*D1*bd1*f*(D1*(7*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(7*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(7*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(151*f*(4*r*s - r - s) - 125*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(151*f*fd*(r*(3*s - 1) - s) - 5*f*(33*bdd1*s*(r - 1) + 25*fdd*(3*r*s - r - s)) - 125*fd**2*(r*(6*s - 2) - 2*s + 1)) + 125*Ddd*f**2*(-4*r*s + r + s)) - 125*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - D1**2*Pk2*Pkd1*ct**5*k2*(1584*D1**2*bd1**2*f*(C - 1)*(r*(2*s - 1) - s + 1) - 66*D1*bd1*(-4*b1*(C - 1)*(D1*(5*f*(-2*r*s + r + s) + 6*fd*r*(4*s - 1) - 6*fd*s) + 12*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(f*(-4*C*(r**2 + 16*r*s + 2*r - 20*s + 1) + 3*r**2 + 32*r*s + 10*r - 48*s + 3) + 2*fd*(2*C*(26*r**2 + 68*r*s - 38*r - 39*s + 17) - 63*r**2 - 56*r*s + 67*r + 38*s - 14)) + Dd*f*(4*C*(52*r**2 + 136*r*s - 62*r - 105*s + 30) - 252*r**2 - 224*r*s + 263*r + 220*s - 91))) + 264*b1**2*(C - 1)*(D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*r*(8*s - 1) - 6*fd*s) + D1*(D1*r*s*(-5*fd + 6*fdd) + 6*Ddd*f*(r*(4*s - 1) - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1*(2*D1**2*(24*bdd1*f*(C - 1)*(r*(2*s - 1) - s) + f*(2*fd*(r**2*(4*C - 3) + 8*r*(8*C*s - 5*C - 4*s + 3) + s*(8*C - 8)) + fdd*(r**2*(63 - 52*C) - 8*r*(17*C*s - 11*C - 7*s + 6) - s*(20*C - 20))) + fd**2*(r**2*(63 - 52*C) - 8*r*(17*C*s - 11*C - 7*s + 6) - s*(20*C - 20))) + D1*f*(-4*C*Ddd*f*(52*r**2 + 4*r*(34*s - 15) - 34*s + 13) + 2*Dd*f*(4*C*(4*r**2 + 2*r*(32*s - 9) - 16*s + 1) - 12*r**2 + r*(38 - 128*s) + 32*s - 3) + 4*Dd*fd*(C*(-208*r**2 - 8*r*(68*s - 37) + 28*s - 34) + 252*r**2 + 224*r*s - 187*r + 12*s + 14) + 7*Ddd*f*(36*r**2 + r*(32*s - 26) - 8*s + 9)) + 2*Dd**2*f**2*(-4*C*(78*r**2 + 6*r*(34*s - 15) - 51*s + 17) + 378*r**2 + 7*r*(48*s - 39) - 84*s + 28)) + f*(-33*D1**2*bdd1*f*(4*C*(13*r**2 + 2*r*(17*s - 8) - 44*s + 13) - 63*r**2 + r*(86 - 56*s) + 96*s - 63) + 5*D1**2*(f*(2*fd*(4*C*(75*r**2 + 6*r*(56*s - 27) - 112*s + 25) - 345*r**2 + r*(494 - 792*s) + 264*s - 115) + fdd*(-4*C*(273*r**2 + 6*r*(122*s - 71) - 244*s + 91) + 1335*r**2 + 2*r*(792*s - 709) - 528*s + 445)) + 2*fd**2*(-4*C*(273*r**2 + 6*r*(122*s - 71) - 244*s + 122) + 1335*r**2 + 2*r*(792*s - 709) - 528*s + 264)) + 5*D1*f*(2*Dd*(f*(4*C*(100*r**2 + 448*r*s - 162*r - 112*s + 25) - 460*r**2 - 1056*r*s + 494*r + 264*s - 115) + fd*(-4*C*(1092*r**2 + 3*r*(976*s - 497) - 854*s + 335) + 5340*r**2 + 6336*r*s - 4963*r - 1848*s + 973)) + Ddd*f*(-4*C*(364*r**2 + 976*r*s - 426*r - 244*s + 91) + 1780*r**2 + 2112*r*s - 1418*r - 528*s + 445)) + 10*Dd**2*f**2*(-4*C*(546*r**2 + 3*r*(488*s - 213) - 366*s + 122) + 2670*r**2 + 3*r*(1056*s - 709) - 792*s + 264)))/(693*d**2*k3**2) - 8*D1**2*Pk2*Pkd1*ct**5*(2145*D1**2*K*bdd1*f**2*r*s - 429*D1**2*bd1**2*f*s*(2*r - 1)*(-6*K + 5*f + 6) - 5460*D1**2*bdd1*f**3*r*s + 3640*D1**2*bdd1*f**3*s - 2145*D1**2*bdd1*f**2*r*s - 5148*D1**2*bdd1*f*g2*r*s + 5148*D1**2*bdd1*f*g2*s + 10640*D1**2*f**3*fd*r*s - 2660*D1**2*f**3*fd*r - 2660*D1**2*f**3*fd*s - 12600*D1**2*f**3*fdd*r*s + 3150*D1**2*f**3*fdd*r + 3150*D1**2*f**3*fdd*s - 37800*D1**2*f**2*fd**2*r*s + 9450*D1**2*f**2*fd**2*r + 9450*D1**2*f**2*fd**2*s - 3150*D1**2*f**2*fd**2 + 3432*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gdd2*r*s + 6864*D1**2*f*fd*g2*r*s - 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s - 17160*D1**2*f*fd*gd2*r*s + 4290*D1**2*f*fd*gd2*r + 4290*D1**2*f*fd*gd2*s - 8580*D1**2*f*fdd*g2*r*s + 4290*D1**2*f*fdd*g2*r + 4290*D1**2*f*fdd*g2*s - 8580*D1**2*fd**2*g2*r*s + 4290*D1**2*fd**2*g2*r + 4290*D1**2*fd**2*g2*s - 4290*D1**2*fd**2*g2 + 10640*D1*Dd*f**4*r*s - 2660*D1*Dd*f**4*r - 2660*D1*Dd*f**4*s - 100800*D1*Dd*f**3*fd*r*s + 25200*D1*Dd*f**3*fd*r + 25200*D1*Dd*f**3*fd*s - 6300*D1*Dd*f**3*fd + 13728*D1*Dd*f**2*g2*r*s - 3432*D1*Dd*f**2*g2*r - 3432*D1*Dd*f**2*g2*s - 34320*D1*Dd*f**2*gd2*r*s + 4290*D1*Dd*f**2*gd2*r + 4290*D1*Dd*f**2*gd2*s - 68640*D1*Dd*f*fd*g2*r*s + 25740*D1*Dd*f*fd*g2*r + 25740*D1*Dd*f*fd*g2*s - 8580*D1*Dd*f*fd*g2 - 12600*D1*Ddd*f**4*r*s + 3150*D1*Ddd*f**4*r + 3150*D1*Ddd*f**4*s - 17160*D1*Ddd*f**2*g2*r*s + 4290*D1*Ddd*f**2*g2*r + 4290*D1*Ddd*f**2*g2*s + 13*D1*bd1*(D1*(115*f**3*s*(3*r - 2) - 4*f**2*(35*fd*(18*r*s - 3*r - 7*s + 2) + r*s*(33*K - 33)) + 33*f*(5*fd*(K - 1)*(r*(4*s - 1) - s) + s*(10*g2*(r - 1) + 12*gd2*(1 - 2*r))) - 396*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-140*f**2*(24*r*s - 3*r - 11*s + 2) + 165*f*(K - 1)*(8*r*s - r - s) - 396*g2*(8*r*s - r - 5*s + 1))) - 37800*Dd**2*f**4*r*s + 9450*Dd**2*f**4*r + 9450*Dd**2*f**4*s - 3150*Dd**2*f**4 - 51480*Dd**2*f**2*g2*r*s + 12870*Dd**2*f**2*g2*r + 12870*Dd**2*f**2*g2*s - 4290*Dd**2*f**2*g2 - 429*b1**2*(D1*Dd*(-f*(r*(4*s - 1) - s)*(-5*K + 4*f + 5) + fd*(5*f*(16*r*s - 6*r - 2*s + 1) + (6 - 6*K)*(8*r*s - 5*r - s + 1))) + D1*(D1*r*(f*fd*(4 - 8*s) + 5*f*fdd*(2*s - 1) + 5*fd**2*(2*s - 1) + 5*fd*(K - 1)*(s - 1) + 6*fdd*(-K*s + K + s - 1)) + Ddd*f*(r*(4*s - 1) - s)*(-6*K + 5*f + 6)) + Dd**2*f*(-6*K + 5*f + 6)*(3*r*(4*s - 1) - 3*s + 1)) + 13*b1*(D1*Dd*(345*f**3*(r*(4*s - 1) - s) - 4*f**2*(35*fd*(3*r*(24*s - 7) - 13*s + 4) + (33*K - 33)*(r*(4*s - 1) - s)) + 66*f*(5*fd*(K - 1)*(r*(8*s - 3) - 3*s + 1) + 5*g2*(4*r*s - r - s) + 6*gd2*(-8*r*s + r + s)) - 396*fd*g2*(r*(8*s - 5) - s + 1)) + 33*D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) - 2*s + 1) + f*s*(2*r - 1)*(-5*K + 4*f + 5) + 6*fd*(K - 1)*(r*(4*s - 2) - s + 1)) - Dd*f*(-6*K + 5*f + 6)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(-5*f**2*(33*bdd1*s*(2*r - 1) + 28*fdd*(9*r*s - 3*r - s)) + 33*f*(5*fdd*(K - 1)*(r*(2*s - 1) - s) + s*(6*bdd1*(K - 1)*(2*r - 1) + 2*r*(5*gd2 - 6*gdd2))) - 5*fd**2*(28*f*(18*r*s - 6*r - 2*s + 1) + (33 - 33*K)*(2*r*s - r - s + 1)) + fd*(115*f**2*(r*(9*s - 3) - s) - 132*f*(K - 1)*(r*(2*s - 1) - s) + 66*r*(5*g2*(s - 1) + 6*gd2*(1 - 2*s))) - 396*fdd*g2*r*(s - 1)) - 3*Ddd*f*(r*(4*s - 1) - s)*(140*f**2 - 55*f*(K - 1) + 132*g2)) - 3*Dd**2*f*(140*f**2 - 55*f*(K - 1) + 132*g2)*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k2) + D1**2*Pk2*Pkd1*ct**5*k2**3*(-1188*D1**2*b1*f*fd*r**2 + 594*D1**2*b1*f*fdd*r**2 + 594*D1**2*b1*fd**2*r**2 + 297*D1**2*bdd1*f**2*(r - 1)**2 - 930*D1**2*f**2*fd*r**2 + 620*D1**2*f**2*fd*r - 310*D1**2*f**2*fd + 465*D1**2*f**2*fdd*r**2 - 310*D1**2*f**2*fdd*r + 155*D1**2*f**2*fdd + 930*D1**2*f*fd**2*r**2 - 620*D1**2*f*fd**2*r - 2376*D1*Dd*b1*f**2*r**2 + 1188*D1*Dd*b1*f**2*r - 594*D1*Dd*b1*f**2 + 4752*D1*Dd*b1*f*fd*r**2 - 1188*D1*Dd*b1*f*fd*r - 1240*D1*Dd*f**3*r**2 + 620*D1*Dd*f**3*r - 310*D1*Dd*f**3 + 3720*D1*Dd*f**2*fd*r**2 - 2170*D1*Dd*f**2*fd*r + 310*D1*Dd*f**2*fd + 1188*D1*Ddd*b1*f**2*r**2 - 594*D1*Ddd*b1*f**2*r + 297*D1*Ddd*b1*f**2 + 620*D1*Ddd*f**3*r**2 - 310*D1*Ddd*f**3*r + 155*D1*Ddd*f**3 - 594*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) + 3564*Dd**2*b1*f**2*r**2 - 1782*Dd**2*b1*f**2*r + 1860*Dd**2*f**3*r**2 - 930*Dd**2*f**3*r)/(693*d**2*k1**2*k3**2) - 20*D1**2*Pk2*Pkd1*ct**4*f*st**2*(39*D1*bd1*f*(D1*(28*f*s*(r - 1) - 25*fd*(6*r*s - r - 3*s + 1)) - 25*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 39*b1*(D1*Dd*f*(28*f*(-4*r*s + r + s) + 25*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(28*f*fd - 25*f*fdd - 50*fd**2) + 25*Ddd*f**2*(4*r*s - r - s)) + 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(-2*D1*Dd*f*(82*f*(4*r*s - r - s) - 147*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-164*f*fd*(r*(4*s - 1) - s) + 3*f*(65*bdd1*s*(r - 1) + 49*fdd*(4*r*s - r - s)) + 147*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 147*Ddd*f**2*(r*(4*s - 1) - s)) + 147*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k1) + D1**2*Pk2*Pkd1*ct**4*k1**3*(8*C - 20)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1650*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 345*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2940*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 560*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 495*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1485*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 165*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r + 420*Dd**2*f**3*s - 140*Dd**2*f**3)/(693*d**2*k3**4) - 8*D1**2*Pk2*Pkd1*ct**4*k1**3*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 1) - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k2**2*k3**2) + 4*D1**2*Pk2*Pkd1*ct**4*k1*k2**2*st**2*(1584*C*D1**2*b1*f*fd*r**2 + 1584*C*D1**2*b1*f*fd*r*s - 792*C*D1**2*b1*f*fd*r - 1188*C*D1**2*b1*f*fdd*r**2 - 1188*C*D1**2*b1*f*fdd*r*s + 594*C*D1**2*b1*f*fdd*r - 1188*C*D1**2*b1*fd**2*r**2 - 1188*C*D1**2*b1*fd**2*r*s + 594*C*D1**2*b1*fd**2*r + 1512*C*D1**2*f**2*fd*r**2 + 1512*C*D1**2*f**2*fd*r*s - 1512*C*D1**2*f**2*fd*r - 504*C*D1**2*f**2*fd*s + 504*C*D1**2*f**2*fd - 1350*C*D1**2*f**2*fdd*r**2 - 1350*C*D1**2*f**2*fdd*r*s + 1350*C*D1**2*f**2*fdd*r + 450*C*D1**2*f**2*fdd*s - 450*C*D1**2*f**2*fdd - 2700*C*D1**2*f*fd**2*r**2 - 2700*C*D1**2*f*fd**2*r*s + 2700*C*D1**2*f*fd**2*r + 900*C*D1**2*f*fd**2*s - 450*C*D1**2*f*fd**2 + 3168*C*D1*Dd*b1*f**2*r**2 + 3168*C*D1*Dd*b1*f**2*r*s - 2376*C*D1*Dd*b1*f**2*r - 792*C*D1*Dd*b1*f**2*s + 792*C*D1*Dd*b1*f**2 - 9504*C*D1*Dd*b1*f*fd*r**2 - 9504*C*D1*Dd*b1*f*fd*r*s + 5940*C*D1*Dd*b1*f*fd*r + 1188*C*D1*Dd*b1*f*fd*s - 594*C*D1*Dd*b1*f*fd + 2016*C*D1*Dd*f**3*r**2 + 2016*C*D1*Dd*f**3*r*s - 1512*C*D1*Dd*f**3*r - 504*C*D1*Dd*f**3*s + 504*C*D1*Dd*f**3 - 10800*C*D1*Dd*f**2*fd*r**2 - 10800*C*D1*Dd*f**2*fd*r*s + 9450*C*D1*Dd*f**2*fd*r + 3150*C*D1*Dd*f**2*fd*s - 1800*C*D1*Dd*f**2*fd - 2376*C*D1*Ddd*b1*f**2*r**2 - 2376*C*D1*Ddd*b1*f**2*r*s + 1782*C*D1*Ddd*b1*f**2*r + 594*C*D1*Ddd*b1*f**2*s - 594*C*D1*Ddd*b1*f**2 - 1800*C*D1*Ddd*f**3*r**2 - 1800*C*D1*Ddd*f**3*r*s + 1350*C*D1*Ddd*f**3*r + 450*C*D1*Ddd*f**3*s - 450*C*D1*Ddd*f**3 - 7128*C*Dd**2*b1*f**2*r**2 - 7128*C*Dd**2*b1*f**2*r*s + 5346*C*Dd**2*b1*f**2*r + 1782*C*Dd**2*b1*f**2*s - 594*C*Dd**2*b1*f**2 - 5400*C*Dd**2*f**3*r**2 - 5400*C*Dd**2*f**3*r*s + 4050*C*Dd**2*f**3*r + 1350*C*Dd**2*f**3*s - 450*C*Dd**2*f**3 - 2046*D1**2*b1*f*fd*r**2 - 2046*D1**2*b1*f*fd*r*s + 1023*D1**2*b1*f*fd*r + 1518*D1**2*b1*f*fdd*r**2 + 1518*D1**2*b1*f*fdd*r*s - 759*D1**2*b1*f*fdd*r + 1518*D1**2*b1*fd**2*r**2 + 1518*D1**2*b1*fd**2*r*s - 759*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(18*C - 23)*(r - 1)*(r + s - 1) - 1965*D1**2*f**2*fd*r**2 - 1965*D1**2*f**2*fd*r*s + 1965*D1**2*f**2*fd*r + 655*D1**2*f**2*fd*s - 655*D1**2*f**2*fd + 1725*D1**2*f**2*fdd*r**2 + 1725*D1**2*f**2*fdd*r*s - 1725*D1**2*f**2*fdd*r - 575*D1**2*f**2*fdd*s + 575*D1**2*f**2*fdd + 3450*D1**2*f*fd**2*r**2 + 3450*D1**2*f*fd**2*r*s - 3450*D1**2*f*fd**2*r - 1150*D1**2*f*fd**2*s + 575*D1**2*f*fd**2 - 4092*D1*Dd*b1*f**2*r**2 - 4092*D1*Dd*b1*f**2*r*s + 3069*D1*Dd*b1*f**2*r + 1023*D1*Dd*b1*f**2*s - 1023*D1*Dd*b1*f**2 + 12144*D1*Dd*b1*f*fd*r**2 + 12144*D1*Dd*b1*f*fd*r*s - 7590*D1*Dd*b1*f*fd*r - 1518*D1*Dd*b1*f*fd*s + 759*D1*Dd*b1*f*fd - 2620*D1*Dd*f**3*r**2 - 2620*D1*Dd*f**3*r*s + 1965*D1*Dd*f**3*r + 655*D1*Dd*f**3*s - 655*D1*Dd*f**3 + 13800*D1*Dd*f**2*fd*r**2 + 13800*D1*Dd*f**2*fd*r*s - 12075*D1*Dd*f**2*fd*r - 4025*D1*Dd*f**2*fd*s + 2300*D1*Dd*f**2*fd + 3036*D1*Ddd*b1*f**2*r**2 + 3036*D1*Ddd*b1*f**2*r*s - 2277*D1*Ddd*b1*f**2*r - 759*D1*Ddd*b1*f**2*s + 759*D1*Ddd*b1*f**2 + 2300*D1*Ddd*f**3*r**2 + 2300*D1*Ddd*f**3*r*s - 1725*D1*Ddd*f**3*r - 575*D1*Ddd*f**3*s + 575*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(24*C - 31)*(r - 1)*(r + s - 1) - fd*(18*C - 23)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(18*C - 23)*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 9108*Dd**2*b1*f**2*r**2 + 9108*Dd**2*b1*f**2*r*s - 6831*Dd**2*b1*f**2*r - 2277*Dd**2*b1*f**2*s + 759*Dd**2*b1*f**2 + 6900*Dd**2*f**3*r**2 + 6900*Dd**2*f**3*r*s - 5175*Dd**2*f**3*r - 1725*Dd**2*f**3*s + 575*Dd**2*f**3)/(693*d**2*k3**4) + 4*D1**2*Pk2*Pkd1*ct**4*k1*k2**2*(11*b1**2*(6*C - 7)*(D1**2*r*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 6*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 6*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 11*b1*(-24*C*D1**2*f*fd*r - 24*C*D1**2*f*fd*s + 24*C*D1**2*f*fd + 30*C*D1**2*f*fdd*r + 30*C*D1**2*f*fdd*s - 30*C*D1**2*f*fdd + 30*C*D1**2*fd**2*r + 30*C*D1**2*fd**2*s + 120*C*D1*Dd*f*fd*r + 120*C*D1*Dd*f*fd*s - 60*C*D1*Dd*f*fd - 6*D1**2*bdd1*f*(6*C - 7)*(2*r - 1)*(r + s - 1) - 80*D1**2*f*fd*r**2 - 80*D1**2*f*fd*r*s + 68*D1**2*f*fd*r + 28*D1**2*f*fd*s - 28*D1**2*f*fd + 100*D1**2*f*fdd*r**2 + 100*D1**2*f*fdd*r*s - 85*D1**2*f*fdd*r - 35*D1**2*f*fdd*s + 35*D1**2*f*fdd + 100*D1**2*fd**2*r**2 + 100*D1**2*fd**2*r*s - 85*D1**2*fd**2*r - 35*D1**2*fd**2*s - 160*D1*Dd*f**2*r**2 - 160*D1*Dd*f**2*r*s + 120*D1*Dd*f**2*r + 40*D1*Dd*f**2*s - 40*D1*Dd*f**2 + 800*D1*Dd*f*fd*r**2 + 800*D1*Dd*f*fd*r*s - 640*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s + 120*D1*Dd*f*fd + 200*D1*Ddd*f**2*r**2 + 200*D1*Ddd*f**2*r*s - 150*D1*Ddd*f**2*r - 50*D1*Ddd*f**2*s + 50*D1*Ddd*f**2 + D1*bd1*(6*C - 7)*(D1*(5*f*(2*r - 1)*(r + s - 1) + 6*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 12*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 600*Dd**2*f**2*r**2 + 600*Dd**2*f**2*r*s - 450*Dd**2*f**2*r - 150*Dd**2*f**2*s + 50*Dd**2*f**2) + f*(-66*D1**2*bd1**2*(6*C - 7)*(2*r - 1)*(r + s - 1) - 55*D1**2*bdd1*f*(6*C - 10*r + 3)*(r + s - 1) + 11*D1*bd1*(D1*(4*f*(6*C - 10*r + 3)*(r + s - 1) + 5*fd*(-6*C*s + 40*r**2 + r*(-6*C + 40*s - 43) - 13*s + 10)) - 10*Dd*f*(6*C*(2*r + 2*s - 1) - 40*r**2 - 40*r*s + 41*r + 11*s - 8)) - 5*(2*C + 1)*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 28*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(23*f*(4*r**2 + r*(4*s - 3) - s + 1) - 28*fd*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)) - 28*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 28*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1))))/(231*d**2*k3**4) + 8*D1**2*Pk2*Pkd1*ct**4*k1*st**2*(33*D1*bd1*f*(D1*(f*s*(18*C - 25)*(r - 1) - fd*(12*C - 17)*(4*r*s - r - 2*s + 1)) - Dd*f*(12*C - 17)*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(-f*(18*C - 25)*(r*(4*s - 1) - s) + fd*(12*C - 17)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(18*C - 25) + f*fdd*(17 - 12*C) + fd**2*(17 - 12*C)) + Ddd*f**2*(12*C - 17)*(r*(4*s - 1) - s)) + Dd**2*f**2*(12*C - 17)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(402*C - 553)*(r*(4*s - 1) - s) - fd*(300*C - 425)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(402*C - 553)*(r*(3*s - 1) - s) - f*(12*C - 17)*(33*bdd1*s*(r - 1) + 25*fdd*(r*(3*s - 1) - s)) - fd**2*(300*C - 425)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(425 - 300*C)*(r*(4*s - 1) - s)) + Dd**2*f**2*(425 - 300*C)*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - 2*D1**2*Pk2*Pkd1*ct**4*k1*(396*D1**2*bd1**2*f*(4*C - 5)*(r*(2*s - 1) - s + 1) + 33*D1*bd1*(2*b1*(4*C - 5)*(D1*(5*f*(-2*r*s + r + s) + 6*fd*r*(4*s - 1) - 6*fd*s) + 12*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(2*f*(C*(7*r**2 + 52*r*s + 2*r - 68*s + 7) - 12*r**2 - 42*r*s + 4*r + 62*s - 12) + fd*(-4*C*(25*r**2 + 112*r*s - 43*r - 66*s + 28) + 192*r**2 + 324*r*s - 223*r - 212*s + 81)) + Dd*f*(-2*C*(100*r**2 + 448*r*s - 101*r - 360*s + 81) + 384*r**2 + 648*r*s - 361*r - 605*s + 177))) + 66*b1**2*(4*C - 5)*(D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*r*(8*s - 1) - 6*fd*s) + D1*(D1*r*s*(-5*fd + 6*fdd) + 6*Ddd*f*(r*(4*s - 1) - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1*(D1**2*(12*bdd1*f*(4*C - 5)*(r*(2*s - 1) - s) + f*(4*fd*(r**2*(7*C - 12) + r*(52*C*s - 34*C - 42*s + 31) + s*(8*C - 10)) + fdd*(r**2*(96 - 50*C) + r*(-224*C*s + 152*C + 162*s - 131) + s*(50 - 40*C))) + fd**2*(r**2*(96 - 50*C) + r*(-224*C*s + 152*C + 162*s - 131) + s*(50 - 40*C))) + D1*f*(C*Ddd*f*(-100*r**2 + r*(162 - 448*s) + 112*s - 25) + 2*Dd*f*(C*(28*r**2 + r*(208*s - 66) - 52*s + 7) - 48*r**2 - 6*r*(28*s - 11) + 42*s - 12) + Dd*fd*(-4*C*(100*r**2 + r*(448*s - 233) - 16*s + 28) + 768*r**2 + 2*r*(648*s - 439) + 38*s + 81) + 3*Ddd*f*(64*r**2 + r*(108*s - 59) - 27*s + 16)) + Dd**2*f**2*(-2*C*(150*r**2 + 3*r*(224*s - 81) - 168*s + 56) + 576*r**2 + 9*r*(108*s - 59) - 243*s + 81)) + f*(-33*D1**2*bdd1*f*(C*(25*r**2 + 2*r*(56*s - 5) - 152*s + 25) - 48*r**2 + r*(46 - 81*s) + 131*s - 48) + 5*D1**2*(f*(4*C*fd*(87*r**2 + 3*r*(191*s - 83) - 191*s + 29) + C*fdd*(-471*r**2 - 6*r*(422*s - 193) + 844*s - 157) - 53*fd*(12*r**2 + 3*r*(13*s - 7) - 13*s + 4) + 4*fdd*(228*r**2 + r*(543*s - 333) - 181*s + 76)) + 2*fd**2*(C*(-471*r**2 - 2532*r*s + 1158*r + 844*s - 422) + 912*r**2 + 2172*r*s - 1332*r - 724*s + 362)) + 5*D1*f*(C*Ddd*f*(-628*r**2 + r*(1158 - 3376*s) + 844*s - 157) + Dd*f*(4*C*(116*r**2 + r*(764*s - 249) - 191*s + 29) - 848*r**2 - 53*r*(52*s - 21) + 689*s - 212) + 2*Dd*fd*(C*(-1884*r**2 - 10128*r*s + 4053*r + 2954*s - 1001) + 3648*r**2 + 6*r*(1448*s - 777) - 2534*s + 1028) + 4*Ddd*f*(304*r**2 + r*(724*s - 333) - 181*s + 76)) + 10*Dd**2*f**2*(-942*C*r**2 + C*r*(1737 - 5064*s) + 422*C*(3*s - 1) + 1824*r**2 + 6*r*(724*s - 333) - 1086*s + 362)))/(693*d**2*k3**2) - 8*D1**2*Pk2*Pkd1*ct**4*k1*(-429*b1**2*(D1*Dd*(-f*(4*f + 5)*(r*(4*s - 1) - s) + fd*(5*f*(2*r*(8*s - 3) - 2*s + 1) + 6*r*(8*s - 5) - 6*s + 6)) + D1*(D1*r*(5*fd**2*(2*s - 1) + fd*(-8*f*s + 4*f - 5*s + 5) + fdd*(10*f*s - 5*f + 6*s - 6)) + Ddd*f*(5*f + 6)*(r*(4*s - 1) - s)) + Dd**2*f*(5*f + 6)*(3*r*(4*s - 1) - 3*s + 1)) + 13*b1*(2*D1*Dd*f*(f*(115*f + 66)*(r*(4*s - 1) - s) - 5*fd*(14*f*(48*r*s - 14*r - 10*s + 3) + 264*r*s - 99*r - 99*s + 33)) + 33*D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) - 2*s + 1) + f*s*(4*f + 5)*(2*r - 1) + 6*fd*(r*(2 - 4*s) + s - 1)) - Dd*f*(5*f + 6)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(f*fd*(230*f*r*(3*s - 1) + 132*r*(2*s - 1) - s*(115*f + 132)) + f*(-33*bdd1*s*(5*f + 6)*(2*r - 1) - 5*fdd*r*(56*f*(3*s - 1) + 66*s - 33) + fdd*s*(140*f + 165)) - 5*fd**2*(28*f*(4*r*(3*s - 1) - 2*s + 1) + 33*r*(2*s - 1) - 33*s + 33)) - 5*Ddd*f**2*(56*f + 33)*(r*(4*s - 1) - s)) - 5*Dd**2*f**2*(56*f + 33)*(3*r*(4*s - 1) - 3*s + 1)) + f*(-429*D1**2*bd1**2*s*(5*f + 6)*(2*r - 1) + 13*D1*bd1*(D1*(115*f**2*s*(2*r - 1) - 140*f*fd*(2*r*(6*s - 1) - 4*s + 1) + 132*f*r*s + 165*fd*(-4*r*s + r + s)) - 5*Dd*f*(28*f*(16*r*s - 2*r - 6*s + 1) + 264*r*s - 33*r - 33*s)) - 5*f*(-14*D1*Dd*f*(19*f*(r*(4*s - 1) - s) - 45*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(429*bdd1*r*s - 266*f*fd*(r*(4*s - 1) - s) + 7*f*(52*bdd1*s*(2*r - 1) + 45*fdd*(4*r*s - r - s)) + 315*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 315*Ddd*f**2*(r*(4*s - 1) - s)) + 315*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(9009*d**2*k2**2) - 4*D1**2*Pk2*Pkd1*ct**4*k2**4*st**2*(462*D1**2*b1*f*fd*r**2 + 462*D1**2*b1*f*fd*r*s - 231*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 453*D1**2*f**2*fd*r**2 + 453*D1**2*f**2*fd*r*s - 453*D1**2*f**2*fd*r - 151*D1**2*f**2*fd*s + 151*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 375*D1**2*f**2*fdd*r*s + 375*D1**2*f**2*fdd*r + 125*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 750*D1**2*f*fd**2*r*s + 750*D1**2*f*fd**2*r + 250*D1**2*f*fd**2*s - 125*D1**2*f*fd**2 + 924*D1*Dd*b1*f**2*r**2 + 924*D1*Dd*b1*f**2*r*s - 693*D1*Dd*b1*f**2*r - 231*D1*Dd*b1*f**2*s + 231*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1650*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 604*D1*Dd*f**3*r**2 + 604*D1*Dd*f**3*r*s - 453*D1*Dd*f**3*r - 151*D1*Dd*f**3*s + 151*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 3000*D1*Dd*f**2*fd*r*s + 2625*D1*Dd*f**2*fd*r + 875*D1*Dd*f**2*fd*s - 500*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 495*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 500*D1*Ddd*f**3*r**2 - 500*D1*Ddd*f**3*r*s + 375*D1*Ddd*f**3*r + 125*D1*Ddd*f**3*s - 125*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(7*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1485*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 165*Dd**2*b1*f**2 - 1500*Dd**2*f**3*r**2 - 1500*Dd**2*f**3*r*s + 1125*Dd**2*f**3*r + 375*Dd**2*f**3*s - 125*Dd**2*f**3)/(693*d**2*k1*k3**4) + 4*D1**2*Pk2*Pkd1*ct**4*k2**4*(D1*f*(6*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-4*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + b1**2*(-D1**2*r*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(-5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*fd*(8*r**2 + 8*r*s - 3*r - s)) + 6*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 6*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(6*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 4*D1**2*f*fd*s - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r - 5*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*r - 5*D1**2*fd**2*s - 16*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 80*D1*Dd*f*fd*r*s - 70*D1*Dd*f*fd*r - 30*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 20*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r - 5*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-5*f*(2*r - 1)*(r + s - 1) + 6*fd*(4*r**2 + 4*r*s - 3*r - s)) + 12*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 60*Dd**2*f**2*r**2 + 60*Dd**2*f**2*r*s - 45*Dd**2*f**2*r - 15*Dd**2*f**2*s + 5*Dd**2*f**2))/(21*d**2*k1*k3**4) - 4*D1**2*Pk2*Pkd1*ct**4*k2**2*st**2*(330*C*D1**2*b1*f*fd*r**2 - 264*C*D1**2*b1*f*fdd*r**2 - 264*C*D1**2*b1*fd**2*r**2 + 663*C*D1**2*f**2*fd*r**2 - 442*C*D1**2*f**2*fd*r + 221*C*D1**2*f**2*fd - 480*C*D1**2*f**2*fdd*r**2 + 320*C*D1**2*f**2*fdd*r - 160*C*D1**2*f**2*fdd - 960*C*D1**2*f*fd**2*r**2 + 640*C*D1**2*f*fd**2*r + 660*C*D1*Dd*b1*f**2*r**2 - 330*C*D1*Dd*b1*f**2*r + 165*C*D1*Dd*b1*f**2 - 2112*C*D1*Dd*b1*f*fd*r**2 + 528*C*D1*Dd*b1*f*fd*r + 884*C*D1*Dd*f**3*r**2 - 442*C*D1*Dd*f**3*r + 221*C*D1*Dd*f**3 - 3840*C*D1*Dd*f**2*fd*r**2 + 2240*C*D1*Dd*f**2*fd*r - 320*C*D1*Dd*f**2*fd - 528*C*D1*Ddd*b1*f**2*r**2 + 264*C*D1*Ddd*b1*f**2*r - 132*C*D1*Ddd*b1*f**2 - 640*C*D1*Ddd*f**3*r**2 + 320*C*D1*Ddd*f**3*r - 160*C*D1*Ddd*f**3 - 1584*C*Dd**2*b1*f**2*r**2 + 792*C*Dd**2*b1*f**2*r - 1920*C*Dd**2*f**3*r**2 + 960*C*Dd**2*f**3*r - 330*D1**2*b1*f*fd*r**2 + 462*D1**2*b1*f*fd*r*s - 231*D1**2*b1*f*fd*r + 264*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r + 264*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(4*C*(r - 1) - 4*r + 5*s + 4) - 663*D1**2*f**2*fd*r**2 + 453*D1**2*f**2*fd*r*s + 291*D1**2*f**2*fd*r - 151*D1**2*f**2*fd*s - 221*D1**2*f**2*fd + 480*D1**2*f**2*fdd*r**2 - 375*D1**2*f**2*fdd*r*s - 195*D1**2*f**2*fdd*r + 125*D1**2*f**2*fdd*s + 160*D1**2*f**2*fdd + 960*D1**2*f*fd**2*r**2 - 750*D1**2*f*fd**2*r*s - 390*D1**2*f*fd**2*r + 250*D1**2*f*fd**2*s - 125*D1**2*f*fd**2 - 660*D1*Dd*b1*f**2*r**2 + 924*D1*Dd*b1*f**2*r*s + 99*D1*Dd*b1*f**2*r - 231*D1*Dd*b1*f**2*s - 165*D1*Dd*b1*f**2 + 2112*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 462*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd - 884*D1*Dd*f**3*r**2 + 604*D1*Dd*f**3*r*s + 291*D1*Dd*f**3*r - 151*D1*Dd*f**3*s - 221*D1*Dd*f**3 + 3840*D1*Dd*f**2*fd*r**2 - 3000*D1*Dd*f**2*fd*r*s - 1365*D1*Dd*f**2*fd*r + 875*D1*Dd*f**2*fd*s + 70*D1*Dd*f**2*fd + 528*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s - 99*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s + 132*D1*Ddd*b1*f**2 + 640*D1*Ddd*f**3*r**2 - 500*D1*Ddd*f**3*r*s - 195*D1*Ddd*f**3*r + 125*D1*Ddd*f**3*s + 160*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(r - 1)*(5*C*(r - 1) - 5*r + 7*s + 5) + fd*(-r**2*(16*C - 16) + r*(16*C - 20*s - 11) + 10*s - 5)) + Dd*f*(-8*C*(4*r**2 - 5*r + 1) + 32*r**2 - 5*r*(8*s + 7) + 25*s + 3)) + 1584*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s - 297*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 165*Dd**2*b1*f**2 + 1920*Dd**2*f**3*r**2 - 1500*Dd**2*f**3*r*s - 585*Dd**2*f**3*r + 375*Dd**2*f**3*s - 125*Dd**2*f**3)/(693*d**2*k1*k3**2) + 2*D1**2*Pk2*Pkd1*ct**4*k2**2*(33*b1**2*(C - 1)*(D1**2*r**2*(12*fd + fdd) + 2*D1*Dd*(6*f*(4*r**2 - 2*r + 1) + fd*r*(4*r - 1)) + D1*Ddd*f*(4*r**2 - 2*r + 1) + 6*Dd**2*f*r*(2*r - 1)) + 33*b1*(-16*C*D1**2*f*fd*r**2 - 4*C*D1**2*f*fd*r + 2*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r**2 - 10*C*D1**2*f*fdd*r + 5*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r**2 - 10*C*D1**2*fd**2*r - 32*C*D1*Dd*f**2*r**2 + 16*C*D1*Dd*f**2*r - 8*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r**2 - 56*C*D1*Dd*f*fd*r + 10*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r**2 - 8*C*D1*Ddd*f**2*r + 4*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r**2 - 24*C*Dd**2*f**2*r + D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 16*D1**2*f*fd*r**2 + 56*D1**2*f*fd*r*s - 24*D1**2*f*fd*r - 2*D1**2*f*fd - 16*D1**2*f*fdd*r**2 - 58*D1**2*f*fdd*r*s + 39*D1**2*f*fdd*r - 5*D1**2*f*fdd - 16*D1**2*fd**2*r**2 - 58*D1**2*fd**2*r*s + 39*D1**2*fd**2*r - 32*D1*Dd*f**2*r**2 + 112*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r - 28*D1*Dd*f**2*s - 8*D1*Dd*f**2 - 128*D1*Dd*f*fd*r**2 - 464*D1*Dd*f*fd*r*s + 246*D1*Dd*f*fd*r + 58*D1*Dd*f*fd*s - 39*D1*Dd*f*fd - 32*D1*Ddd*f**2*r**2 - 116*D1*Ddd*f**2*r*s + 45*D1*Ddd*f**2*r + 29*D1*Ddd*f**2*s - 8*D1*Ddd*f**2 + 2*D1*bd1*(C - 1)*(6*D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(2*r - 1) + Dd*f*(8*r**2 - 6*r + 1)) - 96*Dd**2*f**2*r**2 - 348*Dd**2*f**2*r*s + 135*Dd**2*f**2*r + 87*Dd**2*f**2*s - 29*Dd**2*f**2) - f*(-66*D1**2*bd1**2*r*(C - 1)*(r - 1) - 33*D1**2*bdd1*f*(C*(4*r**2 + 2*r - 1) - 8*r**2 + r*(6 - 29*s) + 29*s - 3) + 5*D1**2*(f*(fd*(16*C*(3*r**2 - 2*r + 1) - 12*r**2 - 465*r*s + 163*r + 155*s - 4) + 5*fdd*(5*C*(3*r**2 - 2*r + 1) + 21*r**2 + 96*r*s - 46*r - 32*s + 7)) + 10*fd**2*(r**2*(15*C + 21) - 2*r*(5*C - 48*s + 23) - 32*s + 16)) + 33*D1*bd1*(D1*(2*f*(C*(4*r**2 - 10*r + 5) + 4*r**2 - 2*r*(7*s + 3) + 14*s + 3) + fd*(-r**2*(16*C - 32) + r*(6*C + 116*s - 51) - 58*s + 29)) + Dd*f*(C*(2 - 32*r**2) + 64*r**2 + r*(232*s - 69) - 145*s + 35)) + 5*D1*f*(Dd*(f*(16*C*(4*r**2 - 2*r + 1) - 16*r**2 - 620*r*s + 163*r + 155*s - 4) + 10*fd*(5*C*(12*r**2 - 7*r + 1) + 84*r**2 + 384*r*s - 161*r - 112*s + 39)) + 5*Ddd*f*(5*C*(4*r**2 - 2*r + 1) + 28*r**2 + 128*r*s - 46*r - 32*s + 7)) + 50*Dd**2*f**2*(r**2*(30*C + 42) - 3*r*(5*C - 64*s + 23) - 48*s + 16)))/(693*d**2*k1*k3**2) - D1**2*Pk2*Pkd1*ct**4*(-2145*D1**2*K*bdd1*f**2*r**2 + 858*D1**2*bd1**2*f*(f*(r**2 + r*(9 - 40*s) + 20*s - 10) - r**2*(K - 1) + r*(K - 24*s - 1) + 12*s) + 4875*D1**2*bdd1*f**3*r**2 + 6890*D1**2*bdd1*f**3*r*s + 780*D1**2*bdd1*f**3*r - 21450*D1**2*bdd1*f**3*s + 3250*D1**2*bdd1*f**3 + 2145*D1**2*bdd1*f**2*r**2 - 8580*D1**2*bdd1*f**2*r*s + 858*D1**2*bdd1*f*g2*r**2 - 1716*D1**2*bdd1*f*g2*r + 858*D1**2*bdd1*f*g2 - 6160*D1**2*f**3*fd*r**2 - 72800*D1**2*f**3*fd*r*s + 21280*D1**2*f**3*fd*r + 18200*D1**2*f**3*fd*s - 1540*D1**2*f**3*fd + 17640*D1**2*f**3*fdd*r**2 + 72800*D1**2*f**3*fdd*r*s - 27020*D1**2*f**3*fdd*r - 18200*D1**2*f**3*fdd*s + 4410*D1**2*f**3*fdd + 52920*D1**2*f**2*fd**2*r**2 + 218400*D1**2*f**2*fd**2*r*s - 81060*D1**2*f**2*fd**2*r - 54600*D1**2*f**2*fd**2*s + 18200*D1**2*f**2*fd**2 + 1716*D1**2*f**2*gd2*r**2 + 4290*D1**2*f**2*gdd2*r**2 + 3432*D1**2*f*fd*g2*r**2 - 3432*D1**2*f*fd*g2*r + 1716*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r**2 - 8580*D1**2*f*fd*gd2*r + 8580*D1**2*f*fdd*g2*r**2 - 8580*D1**2*f*fdd*g2*r + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r**2 - 8580*D1**2*fd**2*g2*r - 6160*D1*Dd*f**4*r**2 - 72800*D1*Dd*f**4*r*s + 21280*D1*Dd*f**4*r + 18200*D1*Dd*f**4*s - 1540*D1*Dd*f**4 + 141120*D1*Dd*f**3*fd*r**2 + 582400*D1*Dd*f**3*fd*r*s - 216160*D1*Dd*f**3*fd*r - 145600*D1*Dd*f**3*fd*s + 45220*D1*Dd*f**3*fd + 6864*D1*Dd*f**2*g2*r**2 - 3432*D1*Dd*f**2*g2*r + 1716*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r**2 - 8580*D1*Dd*f**2*gd2*r + 68640*D1*Dd*f*fd*g2*r**2 - 51480*D1*Dd*f*fd*g2*r + 8580*D1*Dd*f*fd*g2 + 17640*D1*Ddd*f**4*r**2 + 72800*D1*Ddd*f**4*r*s - 27020*D1*Ddd*f**4*r - 18200*D1*Ddd*f**4*s + 4410*D1*Ddd*f**4 + 17160*D1*Ddd*f**2*g2*r**2 - 8580*D1*Ddd*f**2*g2*r + 4290*D1*Ddd*f**2*g2 + 26*D1*bd1*(D1*(5*f**3*(24*r**2 - r*(73*s + 78) + 165*s + 16) + f**2*(5*fd*(225*r**2 + 2*r*(159*s - 58) - 383*s + 109) + 33*r*(-K*r + r + 8*s)) + 33*f*(-10*fd*r**2*(K - 1) + 5*fd*r*(K - 8*s + 1) + 10*fd*s + 12*g2*(r - 1)**2 + 2*gd2*r*(r - 1)) + 66*fd*g2*r*(r - 1)) + Dd*f*(5*f**2*(300*r**2 + 8*r*(53*s - 13) - 713*s + 159) - 165*f*(r**2*(4*K - 4) - r*(K - 16*s + 1) - 2*s) + 66*g2*(4*r**2 - 5*r + 1))) + 52920*Dd**2*f**4*r**2 + 218400*Dd**2*f**4*r*s - 81060*Dd**2*f**4*r - 54600*Dd**2*f**4*s + 18200*Dd**2*f**4 + 51480*Dd**2*f**2*g2*r**2 - 25740*Dd**2*f**2*g2*r + 429*b1**2*(D1**2*r*(2*fd**2*(r - 40*s + 10) + 4*fd*(-3*K*r + f*(5*r + 16*s - 4) + 3*r + 5*s - 5) + fdd*(-K*r + 2*f*(r - 40*s + 10) + r - 24*s + 24)) + D1*(2*Dd*(f**2*(20*r**2 + r*(64*s - 26) - 16*s + 5) + 2*f*(-3*K*(4*r**2 - 2*r + 1) + fd*(4*r**2 + r*(39 - 160*s) + 20*s - 5) + 12*r**2 + 20*r*s - 11*r - 5*s + 3) + fd*(r**2*(4 - 4*K) + r*(K - 96*s + 59) + 12*s - 12)) + Ddd*f*(K*(-4*r**2 + 2*r - 1) + f*(4*r**2 + r*(38 - 160*s) + 40*s + 1) + 4*r**2 - 96*r*s + 22*r + 24*s + 1)) + 2*Dd**2*f*(f*(6*r**2 + r*(57 - 240*s) + 60*s - 20) - 3*r**2*(2*K - 2) + 3*r*(K - 48*s + 11) + 36*s - 12)) + 13*b1*(-132*D1**2*K*f*fd*r**2 + 132*D1**2*K*f*fd*r - 66*D1**2*K*f*fd - 330*D1**2*K*f*fdd*r**2 + 330*D1**2*K*f*fdd*r - 165*D1**2*K*f*fdd - 330*D1**2*K*fd**2*r**2 + 330*D1**2*K*fd**2*r + 33*D1**2*bdd1*f*(K*(-2*r**2 + 2*r - 1) + f*(2*r**2 + r*(18 - 80*s) + 40*s + 1) + 2*r**2 - 48*r*s - 2*r + 24*s + 1) + 720*D1**2*f**2*fd*r**2 - 2190*D1**2*f**2*fd*r*s + 1030*D1**2*f**2*fd*r - 920*D1**2*f**2*fd*s + 80*D1**2*f**2*fd + 1125*D1**2*f**2*fdd*r**2 + 1590*D1**2*f**2*fdd*r*s - 1340*D1**2*f**2*fdd*r + 1120*D1**2*f**2*fdd*s + 125*D1**2*f**2*fdd + 2250*D1**2*f*fd**2*r**2 + 3180*D1**2*f*fd**2*r*s - 2680*D1**2*f*fd**2*r + 2240*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 + 132*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 660*D1**2*f*fd*r - 528*D1**2*f*fd*s + 66*D1**2*f*fd + 330*D1**2*f*fdd*r**2 - 1320*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r + 660*D1**2*f*fdd*s + 165*D1**2*f*fdd + 792*D1**2*f*gd2*r**2 + 66*D1**2*f*gdd2*r**2 + 330*D1**2*fd**2*r**2 - 1320*D1**2*fd**2*r*s + 330*D1**2*fd**2*r + 660*D1**2*fd**2*s - 660*D1**2*fd**2 + 792*D1**2*fd*g2*r**2 + 132*D1**2*fd*gd2*r**2 + 66*D1**2*fdd*g2*r**2 - 264*D1*Dd*K*f**2*r**2 + 132*D1*Dd*K*f**2*r - 66*D1*Dd*K*f**2 - 2640*D1*Dd*K*f*fd*r**2 + 1980*D1*Dd*K*f*fd*r - 330*D1*Dd*K*f*fd + 960*D1*Dd*f**3*r**2 - 2920*D1*Dd*f**3*r*s + 250*D1*Dd*f**3*r + 730*D1*Dd*f**3*s + 240*D1*Dd*f**3 + 9000*D1*Dd*f**2*fd*r**2 + 12720*D1*Dd*f**2*fd*r*s - 9200*D1*Dd*f**2*fd*r + 2890*D1*Dd*f**2*fd*s + 220*D1*Dd*f**2*fd + 264*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 660*D1*Dd*f**2*r - 528*D1*Dd*f**2*s + 66*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 - 10560*D1*Dd*f*fd*r*s + 1980*D1*Dd*f*fd*r + 3960*D1*Dd*f*fd*s - 990*D1*Dd*f*fd + 3168*D1*Dd*f*g2*r**2 - 1584*D1*Dd*f*g2*r + 792*D1*Dd*f*g2 + 528*D1*Dd*f*gd2*r**2 - 132*D1*Dd*f*gd2*r + 528*D1*Dd*fd*g2*r**2 - 132*D1*Dd*fd*g2*r - 660*D1*Ddd*K*f**2*r**2 + 330*D1*Ddd*K*f**2*r - 165*D1*Ddd*K*f**2 + 1500*D1*Ddd*f**3*r**2 + 2120*D1*Ddd*f**3*r*s - 1280*D1*Ddd*f**3*r - 530*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 - 2640*D1*Ddd*f**2*r*s + 330*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s + 165*D1*Ddd*f**2 + 264*D1*Ddd*f*g2*r**2 - 132*D1*Ddd*f*g2*r + 66*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f**2*(10*r**2 + 2*r*(16*s - 9) - 16*s + 5) + 2*f*(K*(-6*r**2 + 6*r - 3) + fd*(2*r**2 + r*(19 - 80*s) + 20*s - 5) + 6*r**2 + 10*r*s - 6*r - 5*s + 3) + fd*(r**2*(2 - 2*K) + r*(K - 48*s + 23) + 12*s - 12)) + Dd*f*(K*(-8*r**2 + 6*r - 1) + f*(8*r**2 + r*(74 - 320*s) + 120*s - 29) + 8*r**2 - 192*r*s + 18*r + 72*s - 11)) - 1980*Dd**2*K*f**2*r**2 + 990*Dd**2*K*f**2*r + 4500*Dd**2*f**3*r**2 + 6360*Dd**2*f**3*r*s - 3840*Dd**2*f**3*r - 1590*Dd**2*f**3*s + 530*Dd**2*f**3 + 1980*Dd**2*f**2*r**2 - 7920*Dd**2*f**2*r*s + 990*Dd**2*f**2*r + 1980*Dd**2*f**2*s - 660*Dd**2*f**2 + 792*Dd**2*f*g2*r**2 - 396*Dd**2*f*g2*r))/(9009*d**2*k1) + D1**2*Pk2*Pkd1*ct**3*f*k2**3*st**4*(8*C - 8)*(33*D1**2*bd1*f*(r - 1)*(r + s - 1) + 5*D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + 33*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 5*D1*f*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-24*r**2 - 24*r*s + 21*r + 7*s - 4)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + 5*Dd**2*f**2*(-12*r**2 + r*(9 - 12*s) + 3*s - 1))/(231*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**3*f*k2*st**4*(16*C - 16)*(D1*Dd*f*(-5*fd*(24*r*s - 7*r - 7*s + 2) + (33*b1 + 10*f)*(4*r*s - r - s)) + D1*(D1*(f*(33*bd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1) + fd*(33*b1*r*(2*s - 1) + 10*f*(3*r*s - r - s))) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))/(231*d**2*k3**2) + 10*D1**2*Pk2*Pkd1*ct**3*f*k2*st**2*(-1014*D1**2*b1*f*fd*r**2 + 507*D1**2*b1*f*fdd*r**2 + 1014*D1**2*b1*fd**2*r**2 + 169*D1**2*bdd1*f**2*(r - 1)**2 + 280*D1**2*f**2*fd*r**2 - 140*D1**2*f**2*fd*r + 70*D1**2*f**2*fd - 140*D1**2*f**2*fdd*r**2 + 70*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 + 210*D1**2*f*fd**2*r - 1352*D1*Dd*b1*f**2*r**2 + 676*D1*Dd*b1*f**2*r - 338*D1*Dd*b1*f**2 + 4056*D1*Dd*b1*f*fd*r**2 - 1014*D1*Dd*b1*f*fd*r + 280*D1*Dd*f**3*r**2 - 140*D1*Dd*f**3*r + 70*D1*Dd*f**3 - 1120*D1*Dd*f**2*fd*r**2 + 560*D1*Dd*f**2*fd*r - 70*D1*Dd*f**2*fd + 676*D1*Ddd*b1*f**2*r**2 - 338*D1*Ddd*b1*f**2*r + 169*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 + 70*D1*Ddd*f**3*r - 35*D1*Ddd*f**3 - 338*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) + 2028*Dd**2*b1*f**2*r**2 - 1014*Dd**2*b1*f**2*r - 420*Dd**2*f**3*r**2 + 210*Dd**2*f**3*r)/(9009*d**2*k1**2) - 4*D1**2*Pk2*Pkd1*ct**3*k1**4*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1650*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 345*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 2940*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 560*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 495*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + r*(8*s - 11) - 5*s + 3)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1485*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 165*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r + 420*Dd**2*f**3*s - 140*Dd**2*f**3)/(693*d**2*k2*k3**4) + 4*D1**2*Pk2*Pkd1*ct**3*k1**2*k2*st**2*(242*C*D1**2*b1*f*fd*r**2 + 242*C*D1**2*b1*f*fd*r*s - 121*C*D1**2*b1*f*fd*r - 198*C*D1**2*b1*f*fdd*r**2 - 198*C*D1**2*b1*f*fdd*r*s + 99*C*D1**2*b1*f*fdd*r - 198*C*D1**2*b1*fd**2*r**2 - 198*C*D1**2*b1*fd**2*r*s + 99*C*D1**2*b1*fd**2*r + 219*C*D1**2*f**2*fd*r**2 + 219*C*D1**2*f**2*fd*r*s - 219*C*D1**2*f**2*fd*r - 73*C*D1**2*f**2*fd*s + 73*C*D1**2*f**2*fd - 225*C*D1**2*f**2*fdd*r**2 - 225*C*D1**2*f**2*fdd*r*s + 225*C*D1**2*f**2*fdd*r + 75*C*D1**2*f**2*fdd*s - 75*C*D1**2*f**2*fdd - 450*C*D1**2*f*fd**2*r**2 - 450*C*D1**2*f*fd**2*r*s + 450*C*D1**2*f*fd**2*r + 150*C*D1**2*f*fd**2*s - 75*C*D1**2*f*fd**2 + 484*C*D1*Dd*b1*f**2*r**2 + 484*C*D1*Dd*b1*f**2*r*s - 363*C*D1*Dd*b1*f**2*r - 121*C*D1*Dd*b1*f**2*s + 121*C*D1*Dd*b1*f**2 - 1584*C*D1*Dd*b1*f*fd*r**2 - 1584*C*D1*Dd*b1*f*fd*r*s + 990*C*D1*Dd*b1*f*fd*r + 198*C*D1*Dd*b1*f*fd*s - 99*C*D1*Dd*b1*f*fd + 292*C*D1*Dd*f**3*r**2 + 292*C*D1*Dd*f**3*r*s - 219*C*D1*Dd*f**3*r - 73*C*D1*Dd*f**3*s + 73*C*D1*Dd*f**3 - 1800*C*D1*Dd*f**2*fd*r**2 - 1800*C*D1*Dd*f**2*fd*r*s + 1575*C*D1*Dd*f**2*fd*r + 525*C*D1*Dd*f**2*fd*s - 300*C*D1*Dd*f**2*fd - 396*C*D1*Ddd*b1*f**2*r**2 - 396*C*D1*Ddd*b1*f**2*r*s + 297*C*D1*Ddd*b1*f**2*r + 99*C*D1*Ddd*b1*f**2*s - 99*C*D1*Ddd*b1*f**2 - 300*C*D1*Ddd*f**3*r**2 - 300*C*D1*Ddd*f**3*r*s + 225*C*D1*Ddd*f**3*r + 75*C*D1*Ddd*f**3*s - 75*C*D1*Ddd*f**3 - 1188*C*Dd**2*b1*f**2*r**2 - 1188*C*Dd**2*b1*f**2*r*s + 891*C*Dd**2*b1*f**2*r + 297*C*Dd**2*b1*f**2*s - 99*C*Dd**2*b1*f**2 - 900*C*Dd**2*f**3*r**2 - 900*C*Dd**2*f**3*r*s + 675*C*Dd**2*f**3*r + 225*C*Dd**2*f**3*s - 75*C*Dd**2*f**3 - 506*D1**2*b1*f*fd*r**2 - 506*D1**2*b1*f*fd*r*s + 253*D1**2*b1*f*fd*r + 396*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 396*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r - 99*D1**2*bdd1*f**2*(C - 2)*(r - 1)*(r + s - 1) - 471*D1**2*f**2*fd*r**2 - 471*D1**2*f**2*fd*r*s + 471*D1**2*f**2*fd*r + 157*D1**2*f**2*fd*s - 157*D1**2*f**2*fd + 450*D1**2*f**2*fdd*r**2 + 450*D1**2*f**2*fdd*r*s - 450*D1**2*f**2*fdd*r - 150*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd + 900*D1**2*f*fd**2*r**2 + 900*D1**2*f*fd**2*r*s - 900*D1**2*f*fd**2*r - 300*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 1012*D1*Dd*b1*f**2*r**2 - 1012*D1*Dd*b1*f**2*r*s + 759*D1*Dd*b1*f**2*r + 253*D1*Dd*b1*f**2*s - 253*D1*Dd*b1*f**2 + 3168*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r - 396*D1*Dd*b1*f*fd*s + 198*D1*Dd*b1*f*fd - 628*D1*Dd*f**3*r**2 - 628*D1*Dd*f**3*r*s + 471*D1*Dd*f**3*r + 157*D1*Dd*f**3*s - 157*D1*Dd*f**3 + 3600*D1*Dd*f**2*fd*r**2 + 3600*D1*Dd*f**2*fd*r*s - 3150*D1*Dd*f**2*fd*r - 1050*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd + 792*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r - 198*D1*Ddd*b1*f**2*s + 198*D1*Ddd*b1*f**2 + 600*D1*Ddd*f**3*r**2 + 600*D1*Ddd*f**3*r*s - 450*D1*Ddd*f**3*r - 150*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 + 11*D1*bd1*f*(D1*(f*(11*C - 23)*(r - 1)*(r + s - 1) - fd*(9*C - 18)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(18 - 9*C)*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 2376*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r - 594*Dd**2*b1*f**2*s + 198*Dd**2*b1*f**2 + 1800*Dd**2*f**3*r**2 + 1800*Dd**2*f**3*r*s - 1350*Dd**2*f**3*r - 450*Dd**2*f**3*s + 150*Dd**2*f**3)/(231*d**2*k3**4) + 4*D1**2*Pk2*Pkd1*ct**3*k1**2*k2*(99*b1**2*(2*C - 3)*(D1**2*r*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 6*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 6*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 33*b1*(-24*C*D1**2*f*fd*r - 24*C*D1**2*f*fd*s + 24*C*D1**2*f*fd + 30*C*D1**2*f*fdd*r + 30*C*D1**2*f*fdd*s - 30*C*D1**2*f*fdd + 30*C*D1**2*fd**2*r + 30*C*D1**2*fd**2*s + 120*C*D1*Dd*f*fd*r + 120*C*D1*Dd*f*fd*s - 60*C*D1*Dd*f*fd - 18*D1**2*bdd1*f*(2*C - 3)*(2*r - 1)*(r + s - 1) - 80*D1**2*f*fd*r**2 - 80*D1**2*f*fd*r*s + 76*D1**2*f*fd*r + 36*D1**2*f*fd*s - 36*D1**2*f*fd + 100*D1**2*f*fdd*r**2 + 100*D1**2*f*fdd*r*s - 95*D1**2*f*fdd*r - 45*D1**2*f*fdd*s + 45*D1**2*f*fdd + 100*D1**2*fd**2*r**2 + 100*D1**2*fd**2*r*s - 95*D1**2*fd**2*r - 45*D1**2*fd**2*s - 160*D1*Dd*f**2*r**2 - 160*D1*Dd*f**2*r*s + 120*D1*Dd*f**2*r + 40*D1*Dd*f**2*s - 40*D1*Dd*f**2 + 800*D1*Dd*f*fd*r**2 + 800*D1*Dd*f*fd*r*s - 680*D1*Dd*f*fd*r - 280*D1*Dd*f*fd*s + 140*D1*Dd*f*fd + 200*D1*Ddd*f**2*r**2 + 200*D1*Ddd*f**2*r*s - 150*D1*Ddd*f**2*r - 50*D1*Ddd*f**2*s + 50*D1*Ddd*f**2 + 3*D1*bd1*(2*C - 3)*(D1*(5*f*(2*r - 1)*(r + s - 1) + 6*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 12*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 600*Dd**2*f**2*r**2 + 600*Dd**2*f**2*r*s - 450*Dd**2*f**2*r - 150*Dd**2*f**2*s + 50*Dd**2*f**2) + f*(-594*D1**2*bd1**2*(2*C - 3)*(2*r - 1)*(r + s - 1) - 165*D1**2*bdd1*f*(6*C - 10*r + 1)*(r + s - 1) + 33*D1*bd1*(D1*(4*f*(6*C - 10*r + 1)*(r + s - 1) + 5*fd*(-6*C*s + 40*r**2 + r*(-6*C + 40*s - 41) - 11*s + 10)) - 10*Dd*f*(6*C*(2*r + 2*s - 1) - 40*r**2 - 40*r*s + 37*r + 7*s - 6)) - 5*(6*C + 1)*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 28*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(23*f*(4*r**2 + r*(4*s - 3) - s + 1) - 28*fd*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)) - 28*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 28*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1))))/(693*d**2*k3**4) + 8*D1**2*Pk2*Pkd1*ct**3*k1**2*st**2*(11*D1*bd1*f*(D1*(f*s*(5*C - 14)*(r - 1) - fd*(3*C - 9)*(r*(4*s - 1) - 2*s + 1)) + Dd*f*(9 - 3*C)*(r*(8*s - 1) - 5*s + 1)) - 11*b1*(D1*Dd*f*(-f*(5*C - 14)*(r*(4*s - 1) - s) + fd*(3*C - 9)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(5*C - 14) - f*fdd*(3*C - 9) - fd**2*(3*C - 9)) + Ddd*f**2*(3*C - 9)*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*C - 9)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(39*C - 106)*(r*(4*s - 1) - s) - fd*(25*C - 75)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(39*C - 106)*(r*(3*s - 1) - s) - f*(C - 3)*(33*bdd1*s*(r - 1) + 25*fdd*(r*(3*s - 1) - s)) - fd**2*(25*C - 75)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(75 - 25*C)*(r*(4*s - 1) - s)) + Dd**2*f**2*(75 - 25*C)*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k2*k3**2) - D1**2*Pk2*Pkd1*ct**3*k1**2*(1584*D1**2*bd1**2*f*(C - 2)*(r*(2*s - 1) - s + 1) - 66*D1*bd1*(-4*b1*(C - 2)*(D1*(5*f*(-2*r*s + r + s) + 6*fd*r*(4*s - 1) - 6*fd*s) + 12*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(4*C*Dd*f*(r*(88*s + 9) - 75*s + 11) + D1*f*(-8*C*r*(5*s + 2) + 11*r**2 + 52*r*s + 10*r + s*(56*C - 84) + 11) + 2*D1*fd*(2*C*(r*(44*s - 6) - 27*s + 11) - 35*r**2 - 20*r*(5*s - 2) + 70*s - 25) - 5*Dd*f*(28*r**2 + r*(80*s - 13) - 82*s + 17))) + 264*b1**2*(C - 2)*(D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*r*(8*s - 1) - 6*fd*s) + D1*(D1*r*s*(-5*fd + 6*fdd) + 6*Ddd*f*(r*(4*s - 1) - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1*(2*D1**2*(24*bdd1*f*(C - 2)*(r*(2*s - 1) - s) + f*(-2*fd*(11*r**2 + r*(-40*C*s + 28*C + 52*s - 42) - s*(8*C - 16)) + fdd*(35*r**2 + r*(-88*C*s + 64*C + 100*s - 90) - s*(20*C - 40))) + fd**2*(35*r**2 + r*(-88*C*s + 64*C + 100*s - 90) - s*(20*C - 40))) + D1*f*(-2*Dd*f*(40*C*s + 44*r**2 + r*(-160*C*s + 40*C + 208*s - 74) - 52*s + 11) + 4*Dd*fd*(C*(-352*r*s + 172*r + 4*s - 22) + 140*r**2 + 400*r*s - 265*r + 30*s + 25) + Ddd*f*(88*C*s + 140*r**2 + r*(-352*C*s + 88*C + 400*s - 170) - 100*s + 35)) + 2*Dd**2*f**2*(-44*C*(3*r*(4*s - 1) - 3*s + 1) + 210*r**2 + 15*r*(40*s - 17) - 150*s + 50)) + f*(33*D1**2*bdd1*f*(35*r**2 - 2*r*(4*C*(11*s + 5) - 50*s - 5) + s*(128*C - 180) + 35) + 5*D1**2*(f*(-2*fd*(243*r**2 + r*(-948*C*s + 316*C + 1404*s - 630) + s*(316*C - 468) + 81) + fdd*(-712*C*r*(3*s - 1) + 639*r**2 + 18*r*(166*s - 79) + s*(712*C - 996) + 213)) + 2*fd**2*(-356*C*(r*(6*s - 2) - 2*s + 1) + 639*r**2 + 18*r*(166*s - 79) - 996*s + 498)) + 5*D1*f*(2*Dd*(-f*(316*C*s + 324*r**2 - 2*r*(158*C*(4*s - 1) - 936*s + 315) - 468*s + 81) + fd*(-356*C*(24*r*s - 7*r - 7*s + 2) + 2556*r**2 + 11952*r*s - 4977*r - 3486*s + 1209)) + Ddd*f*(-712*C*r*(4*s - 1) + 852*r**2 + 6*r*(664*s - 237) + s*(712*C - 996) + 213)) + 10*Dd**2*f**2*(-356*C*(3*r*(4*s - 1) - 3*s + 1) + 1278*r**2 + 9*r*(664*s - 237) - 1494*s + 498)))/(693*d**2*k2*k3**2) + 4*D1**2*Pk2*Pkd1*ct**3*k2**3*st**2*(33*b1**2*(C - 1)*(D1**2*r*(13*fd - 3*fdd)*(r + s) + D1*(Dd*(13*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 33*b1*(-18*C*D1**2*f*fd*r**2 - 18*C*D1**2*f*fd*r*s + 4*C*D1**2*f*fd*r - 5*C*D1**2*f*fd*s + 5*C*D1**2*f*fd + 14*C*D1**2*f*fdd*r**2 + 14*C*D1**2*f*fdd*r*s - 4*C*D1**2*f*fdd*r + 3*C*D1**2*f*fdd*s - 3*C*D1**2*f*fdd + 14*C*D1**2*fd**2*r**2 + 14*C*D1**2*fd**2*r*s - 4*C*D1**2*fd**2*r + 3*C*D1**2*fd**2*s - 36*C*D1*Dd*f**2*r**2 - 36*C*D1*Dd*f**2*r*s + 27*C*D1*Dd*f**2*r + 9*C*D1*Dd*f**2*s - 9*C*D1*Dd*f**2 + 112*C*D1*Dd*f*fd*r**2 + 112*C*D1*Dd*f*fd*r*s - 58*C*D1*Dd*f*fd*r - 2*C*D1*Dd*f*fd*s + C*D1*Dd*f*fd + 28*C*D1*Ddd*f**2*r**2 + 28*C*D1*Ddd*f**2*r*s - 21*C*D1*Ddd*f**2*r - 7*C*D1*Ddd*f**2*s + 7*C*D1*Ddd*f**2 + 84*C*Dd**2*f**2*r**2 + 84*C*Dd**2*f**2*r*s - 63*C*Dd**2*f**2*r - 21*C*Dd**2*f**2*s + 7*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(C - 1)*(2*r - 1)*(r + s - 1) - 34*D1**2*f*fd*r**2 - 34*D1**2*f*fd*r*s + 22*D1**2*f*fd*r + 5*D1**2*f*fd*s - 5*D1**2*f*fd + 24*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s - 15*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 3*D1**2*f*fdd + 24*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 15*D1**2*fd**2*r - 3*D1**2*fd**2*s - 68*D1*Dd*f**2*r**2 - 68*D1*Dd*f**2*r*s + 51*D1*Dd*f**2*r + 17*D1*Dd*f**2*s - 17*D1*Dd*f**2 + 192*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s - 132*D1*Dd*f*fd*r - 36*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 48*D1*Ddd*f**2*r**2 + 48*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s + 12*D1*Ddd*f**2 + D1*bd1*(C - 1)*(D1*(13*f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 144*Dd**2*f**2*r**2 + 144*Dd**2*f**2*r*s - 108*Dd**2*f**2*r - 36*Dd**2*f**2*s + 12*Dd**2*f**2) + f*(-906*C*D1**2*f*fd*r**2 - 906*C*D1**2*f*fd*r*s + 906*C*D1**2*f*fd*r + 302*C*D1**2*f*fd*s - 302*C*D1**2*f*fd + 750*C*D1**2*f*fdd*r**2 + 750*C*D1**2*f*fdd*r*s - 750*C*D1**2*f*fdd*r - 250*C*D1**2*f*fdd*s + 250*C*D1**2*f*fdd + 1500*C*D1**2*fd**2*r**2 + 1500*C*D1**2*fd**2*r*s - 1500*C*D1**2*fd**2*r - 500*C*D1**2*fd**2*s + 250*C*D1**2*fd**2 - 1208*C*D1*Dd*f**2*r**2 - 1208*C*D1*Dd*f**2*r*s + 906*C*D1*Dd*f**2*r + 302*C*D1*Dd*f**2*s - 302*C*D1*Dd*f**2 + 6000*C*D1*Dd*f*fd*r**2 + 6000*C*D1*Dd*f*fd*r*s - 5250*C*D1*Dd*f*fd*r - 1750*C*D1*Dd*f*fd*s + 1000*C*D1*Dd*f*fd + 1000*C*D1*Ddd*f**2*r**2 + 1000*C*D1*Ddd*f**2*r*s - 750*C*D1*Ddd*f**2*r - 250*C*D1*Ddd*f**2*s + 250*C*D1*Ddd*f**2 + 3000*C*Dd**2*f**2*r**2 + 3000*C*Dd**2*f**2*r*s - 2250*C*Dd**2*f**2*r - 750*C*Dd**2*f**2*s + 250*C*Dd**2*f**2 - 99*D1**2*bd1**2*(C - 1)*(2*r - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(7*C*r - 10*C + 12*r - 9) - 756*D1**2*f*fd*r**2 - 756*D1**2*f*fd*r*s + 756*D1**2*f*fd*r + 252*D1**2*f*fd*s - 252*D1**2*f*fd + 675*D1**2*f*fdd*r**2 + 675*D1**2*f*fdd*r*s - 675*D1**2*f*fdd*r - 225*D1**2*f*fdd*s + 225*D1**2*f*fdd + 1350*D1**2*fd**2*r**2 + 1350*D1**2*fd**2*r*s - 1350*D1**2*fd**2*r - 450*D1**2*fd**2*s + 225*D1**2*fd**2 - 1008*D1*Dd*f**2*r**2 - 1008*D1*Dd*f**2*r*s + 756*D1*Dd*f**2*r + 252*D1*Dd*f**2*s - 252*D1*Dd*f**2 + 5400*D1*Dd*f*fd*r**2 + 5400*D1*Dd*f*fd*r*s - 4725*D1*Dd*f*fd*r - 1575*D1*Dd*f*fd*s + 900*D1*Dd*f*fd + 900*D1*Ddd*f**2*r**2 + 900*D1*Ddd*f**2*r*s - 675*D1*Ddd*f**2*r - 225*D1*Ddd*f**2*s + 225*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(r + s - 1)*(C*(9*r - 14) + 17*r - 12) - fd*(C*(28*r**2 + 28*r*s - 38*r - 17*s + 7) + 48*r**2 + 48*r*s - 57*r - 21*s + 12)) - Dd*f*(C*(56*r**2 + r*(56*s - 89) - 47*s + 27) + 96*r**2 + 24*r*(4*s - 5) - 48*s + 30)) + 2700*Dd**2*f**2*r**2 + 2700*Dd**2*f**2*r*s - 2025*Dd**2*f**2*r - 675*Dd**2*f**2*s + 225*Dd**2*f**2))/(693*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**3*k2**3*(8*C + 12)*(D1*f*(6*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-4*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + b1**2*(-D1**2*r*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(-5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*fd*(8*r**2 + 8*r*s - 3*r - s)) + 6*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 6*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(6*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 4*D1**2*f*fd*s - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r - 5*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*r - 5*D1**2*fd**2*s - 16*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 80*D1*Dd*f*fd*r*s - 70*D1*Dd*f*fd*r - 30*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 20*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r - 5*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-5*f*(2*r - 1)*(r + s - 1) + 6*fd*(4*r**2 + 4*r*s - 3*r - s)) + 12*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 60*Dd**2*f**2*r**2 + 60*Dd**2*f**2*r*s - 45*Dd**2*f**2*r - 15*Dd**2*f**2*s + 5*Dd**2*f**2))/(21*d**2*k3**4) - 2*D1**2*Pk2*Pkd1*ct**3*k2*st**2*(198*D1**2*bd1**2*f*(C - 1)*(r*(2*s - 1) - s + 1) + 66*D1*bd1*(b1*(C - 1)*(D1*(13*f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(f*(C*(12*r**2 + 21*r*s - 19*r - 26*s + 12) - 14*r**2 + 2*r*s + 23*r + 3*s - 14) + fd*(C*(-36*r**2 - 76*r*s + 52*r + 41*s - 19) + 46*r**2 + 12*r*s - 46*r - 9*s + 3)) + Dd*f*(C*(-72*r**2 - 152*r*s + 97*r + 107*s - 37) + 92*r**2 + 24*r*s - 106*r - 27*s + 26))) + 66*b1**2*(C - 1)*(D1*Dd*(13*f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) + D1*(D1*r*s*(-13*fd + 3*fdd) + 3*Ddd*f*(r*(4*s - 1) - s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1*(2*D1**2*(3*bdd1*f*(C - 1)*(r*(2*s - 1) - s) + f*(fd*(r**2*(24*C - 28) + r*(42*C*s - 26*C + 4*s + 3) + s*(5*C - 5)) + fdd*(r**2*(23 - 18*C) + r*(-38*C*s + 22*C + 6*s - 6) - s*(3*C - 3))) + fd**2*(r**2*(23 - 18*C) + r*(-38*C*s + 22*C + 6*s - 6) - s*(3*C - 3))) + D1*f*(2*Dd*(f*(3*C*(16*r**2 + 28*r*s - 15*r - 7*s + 4) - 56*r**2 + 8*r*s + 26*r - 2*s - 14) + fd*(C*(-144*r**2 - 304*r*s + 162*r + 26*s - 19) + 184*r**2 + 48*r*s - 76*r + 6*s + 3)) + Ddd*f*(-2*C*(36*r**2 + 76*r*s - 37*r - 19*s + 9) + 92*r**2 + 24*r*s - 52*r - 6*s + 23)) + 2*Dd**2*f**2*(C*(-108*r**2 - 3*r*(76*s - 37) + 57*s - 19) + 138*r**2 + 6*r*(6*s - 13) - 9*s + 3)) + f*(-33*D1**2*bdd1*f*(2*C*(9*r**2 + 19*r*s - 15*r - 22*s + 9) - 23*r**2 - 6*r*s + 40*r + 12*s - 23) + D1**2*(f*(28*C*fd*(90*r**2 + r*(129*s - 103) - 43*s + 30) - 22*fd*(138*r**2 + r*(27*s - 101) - 9*s + 46) + fdd*(-2*C*(927*r**2 + 2*r*(897*s - 608) - 598*s + 309) + 2409*r**2 + 22*r*(54*s - 91) - 396*s + 803)) + 2*fd**2*(-2*C*(927*r**2 + 2*r*(897*s - 608) - 598*s + 299) + 2409*r**2 + 22*r*(54*s - 91) - 396*s + 198)) + D1*f*(2*Dd*(14*C*f*(120*r**2 + r*(172*s - 103) - 43*s + 30) - 2*C*fd*(3708*r**2 + 8*r*(897*s - 532) - 2093*s + 907) - 11*f*(184*r**2 + r*(36*s - 101) - 9*s + 46) + 11*fd*(876*r**2 + r*(432*s - 637) - 126*s + 109)) + Ddd*f*(-2*C*(1236*r**2 + 8*r*(299*s - 152) - 598*s + 309) + 3212*r**2 + 22*r*(72*s - 91) - 396*s + 803)) + 2*Dd**2*f**2*(-2*C*(1854*r**2 + 3588*r*s - 1824*r - 897*s + 299) + 4818*r**2 + 2376*r*s - 3003*r - 594*s + 198)))/(693*d**2*k3**2) - D1**2*Pk2*Pkd1*ct**3*k2*(33*b1**2*(D1**2*r*(fd*r*(8*C - 6) + fd*s*(96*C - 96) + fdd*r*(73 - 60*C) - fdd*s*(104*C - 104)) + D1*(2*Dd*(4*C*f*(4*r**2 + 2*r*(24*s - 7) - 12*s + 1) - 3*f*(4*r**2 + 2*r*(32*s - 9) - 16*s + 1) + fd*r**2*(292 - 240*C) + fd*r*(-16*C*(26*s - 7) + 416*s - 125) + fd*s*(52*C - 52)) + Ddd*f*(-4*C*(60*r**2 + 8*r*(13*s - 7) - 26*s + 15) + 292*r**2 + 416*r*s - 250*r - 104*s + 73)) - 2*Dd**2*f*(4*C*(90*r**2 + 156*r*s - 84*r - 39*s + 13) - 438*r**2 - 624*r*s + 375*r + 156*s - 52)) + 33*b1*(64*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s + 40*C*D1**2*f*fd - 32*C*D1**2*f*fdd*r**2 + 16*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*r + 88*C*D1**2*f*fdd*s - 68*C*D1**2*f*fdd - 32*C*D1**2*fd**2*r**2 + 16*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*r + 88*C*D1**2*fd**2*s + 128*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s - 48*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s + 32*C*D1*Dd*f**2 - 256*C*D1*Dd*f*fd*r**2 + 128*C*D1*Dd*f*fd*r*s + 208*C*D1*Dd*f*fd*r + 336*C*D1*Dd*f*fd*s - 128*C*D1*Dd*f*fd - 64*C*D1*Ddd*f**2*r**2 + 32*C*D1*Ddd*f**2*r*s + 24*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s - 16*C*D1*Ddd*f**2 - 192*C*Dd**2*f**2*r**2 + 96*C*Dd**2*f**2*r*s + 72*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s + 8*C*Dd**2*f**2 + D1**2*bdd1*f*(-4*C*(30*r**2 + 52*r*s - 56*r - 26*s + 15) + 146*r**2 + 208*r*s - 250*r - 104*s + 73) - 104*D1**2*f*fd*r**2 - 336*D1**2*f*fd*r*s + 180*D1**2*f*fd*r + 80*D1**2*f*fd*s - 46*D1**2*f*fd + 196*D1**2*f*fdd*r**2 + 360*D1**2*f*fdd*r*s - 258*D1**2*f*fdd*r - 88*D1**2*f*fdd*s + 83*D1**2*f*fdd + 196*D1**2*fd**2*r**2 + 360*D1**2*fd**2*r*s - 258*D1**2*fd**2*r - 88*D1**2*fd**2*s - 208*D1*Dd*f**2*r**2 - 672*D1*Dd*f**2*r*s + 272*D1*Dd*f**2*r + 168*D1*Dd*f**2*s - 52*D1*Dd*f**2 + 1568*D1*Dd*f*fd*r**2 + 2880*D1*Dd*f*fd*r*s - 1784*D1*Dd*f*fd*r - 712*D1*Dd*f*fd*s + 346*D1*Dd*f*fd + 392*D1*Ddd*f**2*r**2 + 720*D1*Ddd*f**2*r*s - 376*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s + 98*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(C*(8*r**2 + 96*r*s - 56*r - 48*s + 4) - 6*r**2 - 96*r*s + 54*r + 48*s - 3) + fd*(r**2*(146 - 120*C) + r*(-208*C*s + 112*C + 208*s - 125) + s*(52*C - 52))) + Dd*f*(-4*C*(120*r**2 + 8*r*(26*s - 21) - 78*s + 41) + 584*r**2 + 832*r*s - 750*r - 312*s + 177)) + 1176*Dd**2*f**2*r**2 + 2160*Dd**2*f**2*r*s - 1128*Dd**2*f**2*r - 540*Dd**2*f**2*s + 180*Dd**2*f**2) + f*(-66*D1**2*bd1**2*(4*C*(15*r**2 + 26*r*s - 28*r - 13*s + 13) - 73*r**2 + r*(125 - 104*s) + 52*s - 52) - 33*D1**2*bdd1*f*(4*C*(4*r**2 - 2*r*(s - 2) + 24*s - 13) - 98*r**2 - 2*r*(90*s - 59) + 92*s - 15) - 5*D1**2*(f*(2*fd*(4*C*(75*r**2 + 2*r*(99*s - 58) - 66*s + 25) + 105*r**2 + 732*r*s - 314*r - 244*s + 35) - fdd*(4*C*(273*r**2 + 396*r*s - 314*r - 132*s + 91) + 303*r**2 + 1524*r*s - 710*r - 508*s + 101)) - 2*fd**2*(4*C*(273*r**2 + 396*r*s - 314*r - 132*s + 66) + 303*r**2 + 1524*r*s - 710*r - 508*s + 254)) + 66*D1*bd1*(D1*(f*(4*C*(4*r**2 - 2*r*(s + 4) + 12*s - 1) - 26*r**2 - 84*r*s + 46*r + 44*s - 3) + fd*(4*C*(-8*r**2 + 4*r*s + r - 13*s + 1) + 196*r**2 + 360*r*s - 247*r - 136*s + 90)) + Dd*f*(-4*C*(16*r**2 - 8*r*s + 5*r + 49*s - 14) + 392*r**2 + 8*r*(90*s - 53) - 274*s + 105)) - 5*D1*f*(2*Dd*(f*(4*C*(100*r**2 + 4*r*(66*s - 29) - 66*s + 25) + 140*r**2 + 976*r*s - 314*r - 244*s + 35) - fd*(4*C*(1092*r**2 + 1584*r*s - 1099*r - 462*s + 223) + 1212*r**2 + 6096*r*s - 2485*r - 1778*s + 609)) - Ddd*f*(4*C*(364*r**2 + 528*r*s - 314*r - 132*s + 91) + 404*r**2 + 2032*r*s - 710*r - 508*s + 101)) + 10*Dd**2*f**2*(12*C*(182*r**2 + 264*r*s - 157*r - 66*s + 22) + 606*r**2 + 3048*r*s - 1065*r - 762*s + 254)))/(693*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct**3*st**2*(1287*D1**2*K*bdd1*f**2*r*s - 429*D1**2*bd1**2*f*s*(2*r - 1)*(-3*K + 10*f + 3) - 9750*D1**2*bdd1*f**3*r*s + 6500*D1**2*bdd1*f**3*s - 1287*D1**2*bdd1*f**2*r*s - 2574*D1**2*bdd1*f*g2*r*s + 2574*D1**2*bdd1*f*g2*s + 23600*D1**2*f**3*fd*r*s - 5900*D1**2*f**3*fd*r - 5900*D1**2*f**3*fd*s - 19600*D1**2*f**3*fdd*r*s + 4900*D1**2*f**3*fdd*r + 4900*D1**2*f**3*fdd*s - 58800*D1**2*f**2*fd**2*r*s + 14700*D1**2*f**2*fd**2*r + 14700*D1**2*f**2*fd**2*s - 4900*D1**2*f**2*fd**2 + 4290*D1**2*f**2*gd2*r*s - 2574*D1**2*f**2*gdd2*r*s + 8580*D1**2*f*fd*g2*r*s - 4290*D1**2*f*fd*g2*r - 4290*D1**2*f*fd*g2*s - 10296*D1**2*f*fd*gd2*r*s + 2574*D1**2*f*fd*gd2*r + 2574*D1**2*f*fd*gd2*s - 5148*D1**2*f*fdd*g2*r*s + 2574*D1**2*f*fdd*g2*r + 2574*D1**2*f*fdd*g2*s - 5148*D1**2*fd**2*g2*r*s + 2574*D1**2*fd**2*g2*r + 2574*D1**2*fd**2*g2*s - 2574*D1**2*fd**2*g2 + 23600*D1*Dd*f**4*r*s - 5900*D1*Dd*f**4*r - 5900*D1*Dd*f**4*s - 156800*D1*Dd*f**3*fd*r*s + 39200*D1*Dd*f**3*fd*r + 39200*D1*Dd*f**3*fd*s - 9800*D1*Dd*f**3*fd + 17160*D1*Dd*f**2*g2*r*s - 4290*D1*Dd*f**2*g2*r - 4290*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*gd2*r*s + 2574*D1*Dd*f**2*gd2*r + 2574*D1*Dd*f**2*gd2*s - 41184*D1*Dd*f*fd*g2*r*s + 15444*D1*Dd*f*fd*g2*r + 15444*D1*Dd*f*fd*g2*s - 5148*D1*Dd*f*fd*g2 - 19600*D1*Ddd*f**4*r*s + 4900*D1*Ddd*f**4*r + 4900*D1*Ddd*f**4*s - 10296*D1*Ddd*f**2*g2*r*s + 2574*D1*Ddd*f**2*g2*r + 2574*D1*Ddd*f**2*g2*s + 13*D1*bd1*(D1*(302*f**3*s*(3*r - 2) - 5*f**2*(50*fd*(18*r*s - 3*r - 7*s + 2) + r*s*(33*K - 33)) + 33*f*(3*fd*(K - 1)*(r*(4*s - 1) - s) + s*(26*g2*(r - 1) - 12*gd2*r + 6*gd2)) - 198*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-250*f**2*(24*r*s - 3*r - 11*s + 2) + 99*f*(K - 1)*(8*r*s - r - s) - 198*g2*(8*r*s - r - 5*s + 1))) - 58800*Dd**2*f**4*r*s + 14700*Dd**2*f**4*r + 14700*Dd**2*f**4*s - 4900*Dd**2*f**4 - 30888*Dd**2*f**2*g2*r*s + 7722*Dd**2*f**2*g2*r + 7722*Dd**2*f**2*g2*s - 2574*Dd**2*f**2*g2 - 429*b1**2*(D1*Dd*(-f*(r*(4*s - 1) - s)*(-13*K + 14*f + 13) + fd*(10*f*(16*r*s - 6*r - 2*s + 1) + (3 - 3*K)*(8*r*s - 5*r - s + 1))) + D1*(D1*r*(f*fd*(14 - 28*s) + 10*f*fdd*(2*s - 1) + 10*fd**2*(2*s - 1) + 13*fd*(K - 1)*(s - 1) + 3*fdd*(-K*s + K + s - 1)) + Ddd*f*(r*(4*s - 1) - s)*(-3*K + 10*f + 3)) + Dd**2*f*(-3*K + 10*f + 3)*(3*r*(4*s - 1) - 3*s + 1)) + 13*b1*(D1*Dd*(906*f**3*(r*(4*s - 1) - s) - 5*f**2*(50*fd*(3*r*(24*s - 7) - 13*s + 4) + (33*K - 33)*(r*(4*s - 1) - s)) + 66*f*(3*fd*(K - 1)*(r*(8*s - 3) - 3*s + 1) + 13*g2*(4*r*s - r - s) + 3*gd2*(-8*r*s + r + s)) - 198*fd*g2*(r*(8*s - 5) - s + 1)) + 33*D1*bd1*(D1*(-10*f*fd*(r*(8*s - 2) - 2*s + 1) + f*s*(2*r - 1)*(-13*K + 14*f + 13) + 3*fd*(K - 1)*(r*(4*s - 2) - s + 1)) - Dd*f*(-3*K + 10*f + 3)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(-10*f**2*(33*bdd1*s*(2*r - 1) + 25*fdd*(9*r*s - 3*r - s)) + 33*f*(3*fdd*(K - 1)*(r*(2*s - 1) - s) + s*(3*bdd1*(K - 1)*(2*r - 1) + 26*gd2*r - 6*gdd2*r)) + fd**2*(-250*f*(18*r*s - 6*r - 2*s + 1) + (99*K - 99)*(2*r*s - r - s + 1)) + fd*(302*f**2*(r*(9*s - 3) - s) - 165*f*(K - 1)*(r*(2*s - 1) - s) + 66*r*(13*g2*(s - 1) - 6*gd2*s + 3*gd2)) - 198*fdd*g2*r*(s - 1)) - 3*Ddd*f*(r*(4*s - 1) - s)*(250*f**2 - 33*f*(K - 1) + 66*g2)) - 3*Dd**2*f*(250*f**2 - 33*f*(K - 1) + 66*g2)*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k2) - D1**2*Pk2*Pkd1*ct**3*(-44616*D1**2*K*bd1**2*f*r*s - 10296*D1**2*K*bd1**2*f*r + 32604*D1**2*K*bd1**2*f*s + 24024*D1**2*K*bd1*f**2*r*s - 109824*D1**2*K*bd1*f*fd*r*s + 27456*D1**2*K*bd1*f*fd*r + 27456*D1**2*K*bd1*f*fd*s - 27456*D1**2*K*bdd1*f**2*r*s + 11154*D1**2*bd1**2*f**2*r**2 - 27456*D1**2*bd1**2*f**2*r*s + 14586*D1**2*bd1**2*f**2*r + 5148*D1**2*bd1**2*f**2*s - 17160*D1**2*bd1**2*f**2 + 11154*D1**2*bd1**2*f*r**2 + 3432*D1**2*bd1**2*f*r*s - 858*D1**2*bd1**2*f*r - 12012*D1**2*bd1**2*f*s - 48048*D1**2*bd1**2*g2*r*s + 24024*D1**2*bd1**2*g2*r + 24024*D1**2*bd1**2*g2*s - 24024*D1**2*bd1**2*g2 - 20592*D1**2*bd1*bd2*f*r*s + 10296*D1**2*bd1*bd2*f*s - 6500*D1**2*bd1*f**3*r**2 - 33540*D1**2*bd1*f**3*r*s - 5460*D1**2*bd1*f**3*r + 34320*D1**2*bd1*f**3*s - 3250*D1**2*bd1*f**3 + 70980*D1**2*bd1*f**2*fd*r**2 + 177840*D1**2*bd1*f**2*fd*r*s - 47840*D1**2*bd1*f**2*fd*r - 98280*D1**2*bd1*f**2*fd*s + 19760*D1**2*bd1*f**2*fd - 2574*D1**2*bd1*f**2*r**2 - 10296*D1**2*bd1*f**2*r*s + 25740*D1**2*bd1*f*fd*r**2 + 41184*D1**2*bd1*f*fd*r*s - 23166*D1**2*bd1*f*fd*r - 10296*D1**2*bd1*f*fd*s - 41184*D1**2*bd1*f*g2*r*s - 17160*D1**2*bd1*f*g2*r + 58344*D1**2*bd1*f*g2*s + 89232*D1**2*bd1*f*gd2*r*s + 20592*D1**2*bd1*f*gd2*r - 65208*D1**2*bd1*f*gd2*s + 89232*D1**2*bd1*fd*g2*r*s - 44616*D1**2*bd1*fd*g2*r - 44616*D1**2*bd1*fd*g2*s + 44616*D1**2*bd1*fd*g2 + 6864*D1**2*bd2*f**2*r*s - 34320*D1**2*bd2*f*fd*r*s + 8580*D1**2*bd2*f*fd*r + 8580*D1**2*bd2*f*fd*s + 11830*D1**2*bdd1*f**3*r**2 + 29640*D1**2*bdd1*f**3*r*s + 2730*D1**2*bdd1*f**3*r - 34320*D1**2*bdd1*f**3*s + 5915*D1**2*bdd1*f**3 + 6435*D1**2*bdd1*f**2*r**2 + 10296*D1**2*bdd1*f**2*r*s + 44616*D1**2*bdd1*f*g2*r*s + 20592*D1**2*bdd1*f*g2*r - 65208*D1**2*bdd1*f*g2*s - 8580*D1**2*bdd2*f**2*r*s - 17640*D1**2*f**3*fd*r**2 - 116480*D1**2*f**3*fd*r*s + 37940*D1**2*f**3*fd*r + 29120*D1**2*f**3*fd*s - 4410*D1**2*f**3*fd + 23380*D1**2*f**3*fdd*r**2 + 116480*D1**2*f**3*fdd*r*s - 40810*D1**2*f**3*fdd*r - 29120*D1**2*f**3*fdd*s + 5845*D1**2*f**3*fdd + 70140*D1**2*f**2*fd**2*r**2 + 349440*D1**2*f**2*fd**2*r*s - 122430*D1**2*f**2*fd**2*r - 87360*D1**2*f**2*fd**2*s + 29120*D1**2*f**2*fd**2 - 48048*D1**2*f**2*gd2*r*s + 54912*D1**2*f**2*gdd2*r*s - 96096*D1**2*f*fd*g2*r*s + 48048*D1**2*f*fd*g2*r + 48048*D1**2*f*fd*g2*s + 219648*D1**2*f*fd*gd2*r*s - 54912*D1**2*f*fd*gd2*r - 54912*D1**2*f*fd*gd2*s + 109824*D1**2*f*fdd*g2*r*s - 54912*D1**2*f*fdd*g2*r - 54912*D1**2*f*fdd*g2*s + 109824*D1**2*fd**2*g2*r*s - 54912*D1**2*fd**2*g2*r - 54912*D1**2*fd**2*g2*s + 54912*D1**2*fd**2*g2 - 219648*D1*Dd*K*bd1*f**2*r*s + 27456*D1*Dd*K*bd1*f**2*r + 27456*D1*Dd*K*bd1*f**2*s + 94640*D1*Dd*bd1*f**3*r**2 + 237120*D1*Dd*bd1*f**3*r*s - 42380*D1*Dd*bd1*f**3*r - 166920*D1*Dd*bd1*f**3*s + 31590*D1*Dd*bd1*f**3 + 51480*D1*Dd*bd1*f**2*r**2 + 82368*D1*Dd*bd1*f**2*r*s - 23166*D1*Dd*bd1*f**2*r - 10296*D1*Dd*bd1*f**2*s + 356928*D1*Dd*bd1*f*g2*r*s + 37752*D1*Dd*bd1*f*g2*r - 305448*D1*Dd*bd1*f*g2*s + 44616*D1*Dd*bd1*f*g2 - 68640*D1*Dd*bd2*f**2*r*s + 8580*D1*Dd*bd2*f**2*r + 8580*D1*Dd*bd2*f**2*s - 17640*D1*Dd*f**4*r**2 - 116480*D1*Dd*f**4*r*s + 37940*D1*Dd*f**4*r + 29120*D1*Dd*f**4*s - 4410*D1*Dd*f**4 + 187040*D1*Dd*f**3*fd*r**2 + 931840*D1*Dd*f**3*fd*r*s - 326480*D1*Dd*f**3*fd*r - 232960*D1*Dd*f**3*fd*s + 69930*D1*Dd*f**3*fd - 192192*D1*Dd*f**2*g2*r*s + 48048*D1*Dd*f**2*g2*r + 48048*D1*Dd*f**2*g2*s + 439296*D1*Dd*f**2*gd2*r*s - 54912*D1*Dd*f**2*gd2*r - 54912*D1*Dd*f**2*gd2*s + 878592*D1*Dd*f*fd*g2*r*s - 329472*D1*Dd*f*fd*g2*r - 329472*D1*Dd*f*fd*g2*s + 109824*D1*Dd*f*fd*g2 + 23380*D1*Ddd*f**4*r**2 + 116480*D1*Ddd*f**4*r*s - 40810*D1*Ddd*f**4*r - 29120*D1*Ddd*f**4*s + 5845*D1*Ddd*f**4 + 219648*D1*Ddd*f**2*g2*r*s - 54912*D1*Ddd*f**2*g2*r - 54912*D1*Ddd*f**2*g2*s + 70140*Dd**2*f**4*r**2 + 349440*Dd**2*f**4*r*s - 122430*Dd**2*f**4*r - 87360*Dd**2*f**4*s + 29120*Dd**2*f**4 + 658944*Dd**2*f**2*g2*r*s - 164736*Dd**2*f**2*g2*r - 164736*Dd**2*f**2*g2*s + 54912*Dd**2*f**2*g2 - 1716*b1**3*(D1*Dd*(r*(f*(5 - 20*s) + 6*fd*(8*s - 1) + (14*K - 14)*(4*s - 1)) + s*(-14*K + 5*f - 6*fd + 14)) + D1*(D1*r*s*(-5*fd + 6*fdd) + Ddd*(r*(4*s - 1) - s)*(-7*K + 6*f + 7)) + Dd**2*(-7*K + 6*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 429*b1**2*(D1**2*(-52*K*fdd*r*s + 76*K*fdd*r - 24*K*fdd*s - 4*bdd1*(r*(3*s - 1) - s)*(-7*K + 6*f + 7) + 26*f*fdd*r**2 - 64*f*fdd*r*s - 28*f*fdd*r + 20*f*fdd*s + fd**2*(26*r**2 - 4*r*(16*s + 7) + 20*s) + 2*fd*(r**2*(1 - 2*f) + 2*r*(12*K*s - 17*K + 8*f*(s + 1) - 2*s + 7) - s*(-10*K + 8*f + 10)) + 13*fdd*r**2 + 4*fdd*r*s - 28*fdd*r + 24*fdd*s + 112*gd2*r*s - 56*gdd2*r*s) + 4*D1*bd1*(D1*(r*(-42*K*s + 14*K + 5*f*(3*s - 1) + fd*(6 - 36*s) + 42*s - 14) + s*(14*K - 5*f + 6*fd - 14)) - Dd*(-7*K + 6*f + 7)*(r*(24*s - 7) - 7*s + 2)) + D1*(-2*Dd*(f**2*(4*r**2 + r*(6 - 32*s) + 8*s + 1) - f*(-24*K*s + 2*fd*(52*r**2 - r*(128*s + 25) + 36*s + 2) + 4*r**2 + 2*r*(48*K*s - 12*K - 8*s + 1) + 4*s + 1) + fd*(2*K*(r*(104*s - 89) + 11*s + 13) - 52*r**2 + r*(71 - 16*s) - 46*s - 2) - 28*g2*r*(8*s - 2) + 56*g2*s - 28*gd2*(-8*r*s + r + s)) + Ddd*(f**2*(52*r**2 + r*(6 - 128*s) + 32*s + 13) + f*(52*K*s + 52*r**2 + r*(-208*K*s + 52*K + 16*s - 30) - 4*s + 13) + 56*g2*(-4*r*s + r + s))) + 2*Dd**2*(f**2*(78*r**2 + r*(9 - 192*s) + 48*s - 16) + f*(-26*K*(12*r*s - 3*r - 3*s + 1) + 78*r**2 + 24*r*s - 45*r - 6*s + 2) - 28*g2*(3*r*(4*s - 1) - 3*s + 1))) - 13*b1*(-3696*D1**2*K*f*fd*r*s + 1848*D1**2*K*f*fd*r + 1848*D1**2*K*f*fd*s + 4224*D1**2*K*f*fdd*r*s - 2112*D1**2*K*f*fdd*r - 2112*D1**2*K*f*fdd*s + 4224*D1**2*K*fd**2*r*s - 2112*D1**2*K*fd**2*r - 2112*D1**2*K*fd**2*s + 2112*D1**2*K*fd**2 - 660*D1**2*b2*fd*r*s + 660*D1**2*b2*fd*r + 792*D1**2*b2*fdd*r*s - 792*D1**2*b2*fdd*r + 132*D1**2*bd1**2*(-7*K + 6*f + 7)*(r*(6*s - 2) - 2*s + 1) - 660*D1**2*bd2*f*r*s + 1584*D1**2*bd2*fd*r*s - 792*D1**2*bd2*fd*r - 33*D1**2*bdd1*(f**2*(26*r**2 + r*(34 - 64*s) + 12*s + 13) + f*(76*K*s + 26*r**2 - 2*r*(52*K*s + 12*K - 4*s + 1) - 28*s + 13) + 56*g2*(-2*r*s + r + s)) + 792*D1**2*bdd2*f*r*s + 1500*D1**2*f**2*fd*r**2 + 7740*D1**2*f**2*fd*r*s - 4000*D1**2*f**2*fd*r + 60*D1**2*f**2*fd*s + 250*D1**2*f**2*fd - 2730*D1**2*f**2*fdd*r**2 - 6840*D1**2*f**2*fdd*r*s + 4310*D1**2*f**2*fdd*r - 360*D1**2*f**2*fdd*s - 455*D1**2*f**2*fdd - 5460*D1**2*f*fd**2*r**2 - 13680*D1**2*f*fd**2*r*s + 8620*D1**2*f*fd**2*r - 720*D1**2*f*fd**2*s - 760*D1**2*f*fd**2 + 396*D1**2*f*fd*r**2 + 1584*D1**2*f*fd*r*s - 1188*D1**2*f*fd*r - 792*D1**2*f*fd*s + 198*D1**2*f*fd - 990*D1**2*f*fdd*r**2 - 1584*D1**2*f*fdd*r*s + 1782*D1**2*f*fdd*r + 792*D1**2*f*fdd*s - 495*D1**2*f*fdd + 3168*D1**2*f*gd2*r*s - 3432*D1**2*f*gdd2*r*s - 990*D1**2*fd**2*r**2 - 1584*D1**2*fd**2*r*s + 1782*D1**2*fd**2*r + 792*D1**2*fd**2*s - 792*D1**2*fd**2 + 3168*D1**2*fd*g2*r*s - 4488*D1**2*fd*g2*r + 1320*D1**2*fd*g2*s - 6864*D1**2*fd*gd2*r*s + 5016*D1**2*fd*gd2*r - 1584*D1**2*fd*gd2*s - 3432*D1**2*fdd*g2*r*s + 5016*D1**2*fdd*g2*r - 1584*D1**2*fdd*g2*s - 7392*D1*Dd*K*f**2*r*s + 1848*D1*Dd*K*f**2*r + 1848*D1*Dd*K*f**2*s + 33792*D1*Dd*K*f*fd*r*s - 12672*D1*Dd*K*f*fd*r - 12672*D1*Dd*K*f*fd*s + 4224*D1*Dd*K*f*fd - 2640*D1*Dd*b2*f*r*s + 660*D1*Dd*b2*f*r + 660*D1*Dd*b2*f*s + 6336*D1*Dd*b2*fd*r*s - 3960*D1*Dd*b2*fd*r - 792*D1*Dd*b2*fd*s + 792*D1*Dd*b2*fd + 6336*D1*Dd*bd2*f*r*s - 792*D1*Dd*bd2*f*r - 792*D1*Dd*bd2*f*s + 2000*D1*Dd*f**3*r**2 + 10320*D1*Dd*f**3*r*s - 3580*D1*Dd*f**3*r - 2580*D1*Dd*f**3*s + 500*D1*Dd*f**3 - 21840*D1*Dd*f**2*fd*r**2 - 54720*D1*Dd*f**2*fd*r*s + 29540*D1*Dd*f**2*fd*r + 5400*D1*Dd*f**2*fd*s - 3950*D1*Dd*f**2*fd + 792*D1*Dd*f**2*r**2 + 3168*D1*Dd*f**2*r*s - 1188*D1*Dd*f**2*r - 792*D1*Dd*f**2*s + 198*D1*Dd*f**2 - 7920*D1*Dd*f*fd*r**2 - 12672*D1*Dd*f*fd*r*s + 10692*D1*Dd*f*fd*r + 4752*D1*Dd*f*fd*s - 2574*D1*Dd*f*fd + 12672*D1*Dd*f*g2*r*s - 3168*D1*Dd*f*g2*r - 3168*D1*Dd*f*g2*s - 27456*D1*Dd*f*gd2*r*s + 3432*D1*Dd*f*gd2*r + 3432*D1*Dd*f*gd2*s - 27456*D1*Dd*fd*g2*r*s + 23496*D1*Dd*fd*g2*r - 2904*D1*Dd*fd*g2*s - 3432*D1*Dd*fd*g2 + 8448*D1*Ddd*K*f**2*r*s - 2112*D1*Ddd*K*f**2*r - 2112*D1*Ddd*K*f**2*s + 3168*D1*Ddd*b2*f*r*s - 792*D1*Ddd*b2*f*r - 792*D1*Ddd*b2*f*s - 3640*D1*Ddd*f**3*r**2 - 9120*D1*Ddd*f**3*r*s + 4100*D1*Ddd*f**3*r + 2280*D1*Ddd*f**3*s - 910*D1*Ddd*f**3 - 1980*D1*Ddd*f**2*r**2 - 3168*D1*Ddd*f**2*r*s + 1782*D1*Ddd*f**2*r + 792*D1*Ddd*f**2*s - 495*D1*Ddd*f**2 - 13728*D1*Ddd*f*g2*r*s + 3432*D1*Ddd*f*g2*r + 3432*D1*Ddd*f*g2*s + 66*D1*bd1*(D1*(f**2*(2*r**2 + r*(22 - 16*s) + 1) - f*(-34*K*s + 2*fd*(26*r**2 + r*(3 - 64*s) + 16*s + 2) + 2*r**2 + 2*r*(24*K*s + 5*K - 4*s - 6) + 14*s + 1) + fd*(2*K*(4*r*(13*s - 8) - 7*s + 13) - 26*r**2 - 8*r*s + 29*r - 10*s - 2) - 28*g2*r*(4*s - 2) + 56*g2*s - 28*gd2*(-4*r*s + r + s)) - Dd*(f**2*(104*r**2 + r*(74 - 256*s) + 56*s - 23) + f*(K*(-416*r*s + 4*r + 204*s - 26) + 104*r**2 + 32*r*s - 34*r - 60*s + 15) - 56*g2*(r*(8*s - 3) - 3*s + 1))) + 25344*Dd**2*K*f**2*r*s - 6336*Dd**2*K*f**2*r - 6336*Dd**2*K*f**2*s + 2112*Dd**2*K*f**2 + 9504*Dd**2*b2*f*r*s - 2376*Dd**2*b2*f*r - 2376*Dd**2*b2*f*s + 792*Dd**2*b2*f - 10920*Dd**2*f**3*r**2 - 27360*Dd**2*f**3*r*s + 12300*Dd**2*f**3*r + 6840*Dd**2*f**3*s - 2280*Dd**2*f**3 - 5940*Dd**2*f**2*r**2 - 9504*Dd**2*f**2*r*s + 5346*Dd**2*f**2*r + 2376*Dd**2*f**2*s - 792*Dd**2*f**2 - 41184*Dd**2*f*g2*r*s + 10296*Dd**2*f*g2*r + 10296*Dd**2*f*g2*s - 3432*Dd**2*f*g2) + 1716*b2*(2*D1*Dd*f*(2*f*(4*r*s - r - s) - 5*fd*(8*r*s - 3*r - 3*s + 1)) + D1*bd1*(D1*(5*f*s*(r - 1) + 6*fd*(-2*r*s + r + s - 1)) - 6*Dd*f*(r*(8*s - 1) - 5*s + 1)) + D1*(D1*(-6*bdd1*f*s*(r - 1) + 4*f*fd*r*(2*s - 1) - 4*f*fd*s + 5*f*fdd*(-2*r*s + r + s) + 5*fd**2*(-2*r*s + r + s - 1)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k2) - 2*D1**2*Pk2*Pkd1*ct**3*k2**3*st**2*(132*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 - 210*D1**2*f**2*fd*r**2 + 140*D1**2*f**2*fd*r - 70*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 - 70*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 - 140*D1**2*f*fd**2*r + 264*D1*Dd*b1*f**2*r**2 - 132*D1*Dd*b1*f**2*r + 66*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r - 280*D1*Dd*f**3*r**2 + 140*D1*Dd*f**3*r - 70*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 - 490*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 + 140*D1*Ddd*f**3*r**2 - 70*D1*Ddd*f**3*r + 35*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r + 420*Dd**2*f**3*r**2 - 210*Dd**2*f**3*r)/(693*d**2*k1**2*k3**2) + D1**2*Pk2*Pkd1*ct**3*k2**3*(D1*f*r*(22*D1*bd1**2*(r - 1) + 5*D1*bdd1*f*r + 10*bd1*(-D1*(f*r - 2*fd*r + fd) + Dd*f*(4*r - 1))) - 11*b1**2*(D1**2*r**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*r*(1 - 4*r)) + D1*Ddd*f*(-4*r**2 + 2*r - 1) + 6*Dd**2*f*r*(1 - 2*r)) + b1*(11*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 5*D1**2*(f*(2*fd - fdd)*(2*r**2 - 2*r + 1) - 2*fd**2*r*(r - 1)) - 22*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(1 - 2*r) + Dd*f*(-8*r**2 + 6*r - 1)) - 5*D1*f*(2*Dd*(4*f*r**2 - 2*f*r + f - 8*fd*r**2 + 6*fd*r - fd) + Ddd*f*(-4*r**2 + 2*r - 1)) - 30*Dd**2*f**2*r*(1 - 2*r)))/(21*d**2*k1**2*k3**2) + D1**2*Pk2*Pkd1*ct**3*k2*(D1*f*r*(22*D1*bd1**2*(14*f + 11)*(r - 1) + 5*D1*bdd1*f*r*(14*f + 11) + 10*bd1*(-D1*f*r*(14*f + 11) + D1*fd*(14*f*(3*r - 1) + 22*r - 11) + Dd*f*(14*f + 11)*(4*r - 1))) - 11*b1**2*(D1**2*r**2*(-28*fd**2 + fd*(56*f + 22) - fdd*(28*f + 11)) + D1*(2*Dd*(14*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(44 - 112*fd) + r*(28*fd - 22) + 11) + 11*fd*r*(1 - 4*r)) - Ddd*f*(14*f + 11)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(14*f + 11)*(2*r - 1)) + b1*(11*D1**2*bdd1*f*(14*f + 11)*(2*r**2 - 2*r + 1) - 5*D1**2*(14*f**2*(2*fd - fdd)*(3*r**2 - 2*r + 1) + f*(28*fd**2*r*(2 - 3*r) + 22*fd*(2*r**2 - 2*r + 1) - 11*fdd*(2*r**2 - 2*r + 1)) - 22*fd**2*r*(r - 1)) - 22*D1*bd1*(D1*(14*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(22 - 56*fd) + r*(28*fd - 22) + 11) + 11*fd*r*(1 - 2*r)) - Dd*f*(14*f + 11)*(8*r**2 - 6*r + 1)) - 5*D1*f*(2*Dd*(14*f**2*(4*r**2 - 2*r + 1) - 14*f*fd*(12*r**2 - 7*r + 1) + 11*f*(4*r**2 - 2*r + 1) - 11*fd*(8*r**2 - 6*r + 1)) - Ddd*f*(14*f + 11)*(4*r**2 - 2*r + 1)) + 30*Dd**2*f**2*r*(14*f + 11)*(2*r - 1)))/(231*d**2*k1**2) + 4*D1**2*Pk2*Pkd1*ct**2*f*k1*k2**2*st**4*(33*D1**2*bd1*f*(2*C - 3)*(r - 1)*(r + s - 1) + 33*D1*b1*(2*C - 3)*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + (6*C - 11)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-24*r**2 - 24*r*s + 21*r + 7*s - 4)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + Dd**2*f**2*(-12*r**2 + r*(9 - 12*s) + 3*s - 1)))/(231*d**2*k3**4) - 8*D1**2*Pk2*Pkd1*ct**2*f*k1*st**4*(D1*Dd*f*(fd*(4*C - 9)*(r*(24*s - 7) - 7*s + 2) + (33*b1 + f*(18 - 8*C))*(r*(4*s - 1) - s)) + D1*(D1*(f*(33*bd1*s*(r - 1) + fdd*(4*C - 9)*(3*r*s - r - s)) + fd**2*(4*C - 9)*(r*(6*s - 2) - 2*s + 1) + fd*(33*b1*r*(2*s - 1) - f*(8*C - 18)*(3*r*s - r - s))) + Ddd*f**2*(4*C - 9)*(r*(4*s - 1) - s)) + Dd**2*f**2*(4*C - 9)*(3*r*(4*s - 1) - 3*s + 1))/(231*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct**2*f*k2**4*st**4*(33*D1**2*bd1*f*(r - 1)*(r + s - 1) + 5*D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + 33*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 5*D1*f*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-24*r**2 - 24*r*s + 21*r + 7*s - 4)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + 5*Dd**2*f**2*(-12*r**2 + r*(9 - 12*s) + 3*s - 1))/(231*d**2*k1*k3**4) - 40*D1**2*Pk2*Pkd1*ct**2*f*st**4*(39*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-6*r*s + r + 3*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 39*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + fd*r*(24*s - 7) - 3*fd*s + fd) - D1*(D1*r*(3*s - 1)*(2*f*fd - f*fdd - 2*fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(47*f*(4*r*s - r - s) - 60*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-39*bdd1*f*s*(r - 1) + 47*f*fd*(r*(4*s - 1) - s) + 30*f*fdd*(-4*r*s + r + s) - 30*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 30*Ddd*f**2*(-4*r*s + r + s)) - 30*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(3003*d**2*k1) + 2*D1**2*Pk2*Pkd1*ct**2*k1**3*st**2*(132*C*D1**2*b1*f*fd*r**2 + 132*C*D1**2*b1*f*fd*r*s - 66*C*D1**2*b1*f*fd*r - 132*C*D1**2*b1*f*fdd*r**2 - 132*C*D1**2*b1*f*fdd*r*s + 66*C*D1**2*b1*f*fdd*r - 132*C*D1**2*b1*fd**2*r**2 - 132*C*D1**2*b1*fd**2*r*s + 66*C*D1**2*b1*fd**2*r + 102*C*D1**2*f**2*fd*r**2 + 102*C*D1**2*f**2*fd*r*s - 102*C*D1**2*f**2*fd*r - 34*C*D1**2*f**2*fd*s + 34*C*D1**2*f**2*fd - 150*C*D1**2*f**2*fdd*r**2 - 150*C*D1**2*f**2*fdd*r*s + 150*C*D1**2*f**2*fdd*r + 50*C*D1**2*f**2*fdd*s - 50*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*r**2 - 300*C*D1**2*f*fd**2*r*s + 300*C*D1**2*f*fd**2*r + 100*C*D1**2*f*fd**2*s - 50*C*D1**2*f*fd**2 + 264*C*D1*Dd*b1*f**2*r**2 + 264*C*D1*Dd*b1*f**2*r*s - 198*C*D1*Dd*b1*f**2*r - 66*C*D1*Dd*b1*f**2*s + 66*C*D1*Dd*b1*f**2 - 1056*C*D1*Dd*b1*f*fd*r**2 - 1056*C*D1*Dd*b1*f*fd*r*s + 660*C*D1*Dd*b1*f*fd*r + 132*C*D1*Dd*b1*f*fd*s - 66*C*D1*Dd*b1*f*fd + 136*C*D1*Dd*f**3*r**2 + 136*C*D1*Dd*f**3*r*s - 102*C*D1*Dd*f**3*r - 34*C*D1*Dd*f**3*s + 34*C*D1*Dd*f**3 - 1200*C*D1*Dd*f**2*fd*r**2 - 1200*C*D1*Dd*f**2*fd*r*s + 1050*C*D1*Dd*f**2*fd*r + 350*C*D1*Dd*f**2*fd*s - 200*C*D1*Dd*f**2*fd - 264*C*D1*Ddd*b1*f**2*r**2 - 264*C*D1*Ddd*b1*f**2*r*s + 198*C*D1*Ddd*b1*f**2*r + 66*C*D1*Ddd*b1*f**2*s - 66*C*D1*Ddd*b1*f**2 - 200*C*D1*Ddd*f**3*r**2 - 200*C*D1*Ddd*f**3*r*s + 150*C*D1*Ddd*f**3*r + 50*C*D1*Ddd*f**3*s - 50*C*D1*Ddd*f**3 - 792*C*Dd**2*b1*f**2*r**2 - 792*C*Dd**2*b1*f**2*r*s + 594*C*Dd**2*b1*f**2*r + 198*C*Dd**2*b1*f**2*s - 66*C*Dd**2*b1*f**2 - 600*C*Dd**2*f**3*r**2 - 600*C*Dd**2*f**3*r*s + 450*C*Dd**2*f**3*r + 150*C*Dd**2*f**3*s - 50*C*Dd**2*f**3 - 858*D1**2*b1*f*fd*r**2 - 858*D1**2*b1*f*fd*r*s + 429*D1**2*b1*f*fd*r + 726*D1**2*b1*f*fdd*r**2 + 726*D1**2*b1*f*fdd*r*s - 363*D1**2*b1*f*fdd*r + 726*D1**2*b1*fd**2*r**2 + 726*D1**2*b1*fd**2*r*s - 363*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(2*C - 11)*(r - 1)*(r + s - 1) - 759*D1**2*f**2*fd*r**2 - 759*D1**2*f**2*fd*r*s + 759*D1**2*f**2*fd*r + 253*D1**2*f**2*fd*s - 253*D1**2*f**2*fd + 825*D1**2*f**2*fdd*r**2 + 825*D1**2*f**2*fdd*r*s - 825*D1**2*f**2*fdd*r - 275*D1**2*f**2*fdd*s + 275*D1**2*f**2*fdd + 1650*D1**2*f*fd**2*r**2 + 1650*D1**2*f*fd**2*r*s - 1650*D1**2*f*fd**2*r - 550*D1**2*f*fd**2*s + 275*D1**2*f*fd**2 - 1716*D1*Dd*b1*f**2*r**2 - 1716*D1*Dd*b1*f**2*r*s + 1287*D1*Dd*b1*f**2*r + 429*D1*Dd*b1*f**2*s - 429*D1*Dd*b1*f**2 + 5808*D1*Dd*b1*f*fd*r**2 + 5808*D1*Dd*b1*f*fd*r*s - 3630*D1*Dd*b1*f*fd*r - 726*D1*Dd*b1*f*fd*s + 363*D1*Dd*b1*f*fd - 1012*D1*Dd*f**3*r**2 - 1012*D1*Dd*f**3*r*s + 759*D1*Dd*f**3*r + 253*D1*Dd*f**3*s - 253*D1*Dd*f**3 + 6600*D1*Dd*f**2*fd*r**2 + 6600*D1*Dd*f**2*fd*r*s - 5775*D1*Dd*f**2*fd*r - 1925*D1*Dd*f**2*fd*s + 1100*D1*Dd*f**2*fd + 1452*D1*Ddd*b1*f**2*r**2 + 1452*D1*Ddd*b1*f**2*r*s - 1089*D1*Ddd*b1*f**2*r - 363*D1*Ddd*b1*f**2*s + 363*D1*Ddd*b1*f**2 + 1100*D1*Ddd*f**3*r**2 + 1100*D1*Ddd*f**3*r*s - 825*D1*Ddd*f**3*r - 275*D1*Ddd*f**3*s + 275*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(2*C - 13)*(r - 1)*(r + s - 1) - fd*(2*C - 11)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(2*C - 11)*(8*r**2 + r*(8*s - 11) - 5*s + 3)) + 4356*Dd**2*b1*f**2*r**2 + 4356*Dd**2*b1*f**2*r*s - 3267*Dd**2*b1*f**2*r - 1089*Dd**2*b1*f**2*s + 363*Dd**2*b1*f**2 + 3300*Dd**2*f**3*r**2 + 3300*Dd**2*f**3*r*s - 2475*Dd**2*f**3*r - 825*Dd**2*f**3*s + 275*Dd**2*f**3)/(693*d**2*k3**4) + 4*D1**2*Pk2*Pkd1*ct**2*k1**3*(33*b1**2*(2*C - 5)*(D1**2*r*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 6*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 6*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 33*b1*(-8*C*D1**2*f*fd*r - 8*C*D1**2*f*fd*s + 8*C*D1**2*f*fd + 10*C*D1**2*f*fdd*r + 10*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd + 10*C*D1**2*fd**2*r + 10*C*D1**2*fd**2*s + 40*C*D1*Dd*f*fd*r + 40*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd - 6*D1**2*bdd1*f*(2*C - 5)*(2*r - 1)*(r + s - 1) - 40*D1**2*f*fd*r**2 - 40*D1**2*f*fd*r*s + 40*D1**2*f*fd*r + 20*D1**2*f*fd*s - 20*D1**2*f*fd + 50*D1**2*f*fdd*r**2 + 50*D1**2*f*fdd*r*s - 50*D1**2*f*fdd*r - 25*D1**2*f*fdd*s + 25*D1**2*f*fdd + 50*D1**2*fd**2*r**2 + 50*D1**2*fd**2*r*s - 50*D1**2*fd**2*r - 25*D1**2*fd**2*s - 80*D1*Dd*f**2*r**2 - 80*D1*Dd*f**2*r*s + 60*D1*Dd*f**2*r + 20*D1*Dd*f**2*s - 20*D1*Dd*f**2 + 400*D1*Dd*f*fd*r**2 + 400*D1*Dd*f*fd*r*s - 350*D1*Dd*f*fd*r - 150*D1*Dd*f*fd*s + 75*D1*Dd*f*fd + 100*D1*Ddd*f**2*r**2 + 100*D1*Ddd*f**2*r*s - 75*D1*Ddd*f**2*r - 25*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 + D1*bd1*(2*C - 5)*(D1*(5*f*(2*r - 1)*(r + s - 1) + 6*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 12*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 300*Dd**2*f**2*r**2 + 300*Dd**2*f**2*r*s - 225*Dd**2*f**2*r - 75*Dd**2*f**2*s + 25*Dd**2*f**2) + f*(-10*C*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 28*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(23*f*(4*r**2 + r*(4*s - 3) - s + 1) - 28*fd*(24*r**2 + 3*r*(8*s - 7) - 7*s + 4)) - 28*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 28*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) - 198*D1**2*bd1**2*(2*C - 5)*(2*r - 1)*(r + s - 1) - 165*D1**2*bdd1*f*(2*C - 5*r)*(r + s - 1) + 33*D1*bd1*(8*C*D1*f*(r + s - 1) - 10*C*D1*fd*(r + s) - 20*C*Dd*f*(2*r + 2*s - 1) + 5*D1*(-4*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 25*Dd*f*(8*r**2 + r*(8*s - 7) - s + 1))))/(693*d**2*k3**4) - 4*D1**2*Pk2*Pkd1*ct**2*k1**3*st**2*(11*D1*bd1*f*(D1*(5*f*s*(r - 1) + 3*fd*(-4*r*s + r + 2*s - 1)) - 3*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 11*b1*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 3*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(5*f*fd - 3*f*fdd - 3*fd**2) + 3*Ddd*f**2*(4*r*s - r - s)) + 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(39*f*(4*r*s - r - s) - 25*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(39*f*fd*(r*(3*s - 1) - s) + f*(-33*bdd1*s*(r - 1) + 25*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(-4*r*s + r + s)) - 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k2**2*k3**2) - 2*D1**2*Pk2*Pkd1*ct**2*k1**3*(-396*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 33*D1*bd1*(-2*b1*(D1*(5*f*(-2*r*s + r + s) + 6*fd*r*(4*s - 1) - 6*fd*s) + 12*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(-8*f*(r*s + r - 2*s) + fd*(28*r*s + 3*r - 24*s + 7)) + Dd*f*(r*(56*s + 33) - 75*s + 7))) - 66*b1**2*(D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*r*(8*s - 1) - 6*fd*s) + D1*(D1*r*s*(-5*fd + 6*fdd) + 6*Ddd*f*(r*(4*s - 1) - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1*(D1*Dd*f*(8*f*(-4*r*s + r + s) + fd*(2*r*(56*s - 41) + 26*s + 7)) + D1*(12*D1*bdd1*f*(-2*r*s + r + s) + D1*(f*(-8*fd*(2*r*(s - 1) + s) + fdd*(r*(14*s - 17) + 10*s)) + fd**2*(r*(14*s - 17) + 10*s)) + 7*Ddd*f**2*(r*(4*s - 1) - s)) + 7*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(-5*D1*Dd*f*(89*f*(4*r*s - r - s) - 94*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(-445*f*fd*(r*(3*s - 1) - s) + f*(33*bdd1*(7*r*s + 10*r - 17*s) + 470*fdd*(3*r*s - r - s)) + 470*fd**2*(r*(6*s - 2) - 2*s + 1)) + 470*Ddd*f**2*(r*(4*s - 1) - s)) + 470*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k2**2*k3**2) + 2*D1**2*Pk2*Pkd1*ct**2*k1*k2**2*st**2*(11*b1**2*(2*C - 3)*(D1**2*r*(13*fd - 3*fdd)*(r + s) + D1*(Dd*(13*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 11*b1*(-76*C*D1**2*f*fd*r**2 - 76*C*D1**2*f*fd*r*s + 28*C*D1**2*f*fd*r - 10*C*D1**2*f*fd*s + 10*C*D1**2*f*fd + 60*C*D1**2*f*fdd*r**2 + 60*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 6*C*D1**2*f*fdd*s - 6*C*D1**2*f*fdd + 60*C*D1**2*fd**2*r**2 + 60*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 6*C*D1**2*fd**2*s - 152*C*D1*Dd*f**2*r**2 - 152*C*D1*Dd*f**2*r*s + 114*C*D1*Dd*f**2*r + 38*C*D1*Dd*f**2*s - 38*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*r**2 + 480*C*D1*Dd*f*fd*r*s - 276*C*D1*Dd*f*fd*r - 36*C*D1*Dd*f*fd*s + 18*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*r**2 + 120*C*D1*Ddd*f**2*r*s - 90*C*D1*Ddd*f**2*r - 30*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*r**2 + 360*C*Dd**2*f**2*r*s - 270*C*Dd**2*f**2*r - 90*C*Dd**2*f**2*s + 30*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(2*C - 3)*(2*r - 1)*(r + s - 1) - 52*D1**2*f*fd*r**2 - 52*D1**2*f*fd*r*s + 41*D1**2*f*fd*r + 15*D1**2*f*fd*s - 15*D1**2*f*fd + 36*D1**2*f*fdd*r**2 + 36*D1**2*f*fdd*r*s - 27*D1**2*f*fdd*r - 9*D1**2*f*fdd*s + 9*D1**2*f*fdd + 36*D1**2*fd**2*r**2 + 36*D1**2*fd**2*r*s - 27*D1**2*fd**2*r - 9*D1**2*fd**2*s - 104*D1*Dd*f**2*r**2 - 104*D1*Dd*f**2*r*s + 78*D1*Dd*f**2*r + 26*D1*Dd*f**2*s - 26*D1*Dd*f**2 + 288*D1*Dd*f*fd*r**2 + 288*D1*Dd*f*fd*r*s - 216*D1*Dd*f*fd*r - 72*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 72*D1*Ddd*f**2*r**2 + 72*D1*Ddd*f**2*r*s - 54*D1*Ddd*f**2*r - 18*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + D1*bd1*(2*C - 3)*(D1*(13*f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 216*Dd**2*f**2*r**2 + 216*Dd**2*f**2*r*s - 162*Dd**2*f**2*r - 54*Dd**2*f**2*s + 18*Dd**2*f**2) + f*(-1008*C*D1**2*f*fd*r**2 - 1008*C*D1**2*f*fd*r*s + 1008*C*D1**2*f*fd*r + 336*C*D1**2*f*fd*s - 336*C*D1**2*f*fd + 900*C*D1**2*f*fdd*r**2 + 900*C*D1**2*f*fdd*r*s - 900*C*D1**2*f*fdd*r - 300*C*D1**2*f*fdd*s + 300*C*D1**2*f*fdd + 1800*C*D1**2*fd**2*r**2 + 1800*C*D1**2*fd**2*r*s - 1800*C*D1**2*fd**2*r - 600*C*D1**2*fd**2*s + 300*C*D1**2*fd**2 - 1344*C*D1*Dd*f**2*r**2 - 1344*C*D1*Dd*f**2*r*s + 1008*C*D1*Dd*f**2*r + 336*C*D1*Dd*f**2*s - 336*C*D1*Dd*f**2 + 7200*C*D1*Dd*f*fd*r**2 + 7200*C*D1*Dd*f*fd*r*s - 6300*C*D1*Dd*f*fd*r - 2100*C*D1*Dd*f*fd*s + 1200*C*D1*Dd*f*fd + 1200*C*D1*Ddd*f**2*r**2 + 1200*C*D1*Ddd*f**2*r*s - 900*C*D1*Ddd*f**2*r - 300*C*D1*Ddd*f**2*s + 300*C*D1*Ddd*f**2 + 3600*C*Dd**2*f**2*r**2 + 3600*C*Dd**2*f**2*r*s - 2700*C*Dd**2*f**2*r - 900*C*Dd**2*f**2*s + 300*C*Dd**2*f**2 - 33*D1**2*bd1**2*(2*C - 3)*(2*r - 1)*(r + s - 1) + 33*D1**2*bdd1*f*(r + s - 1)*(2*C*(5*r - 6) + 6*r - 3) - 219*D1**2*f*fd*r**2 - 219*D1**2*f*fd*r*s + 219*D1**2*f*fd*r + 73*D1**2*f*fd*s - 73*D1**2*f*fd + 225*D1**2*f*fdd*r**2 + 225*D1**2*f*fdd*r*s - 225*D1**2*f*fdd*r - 75*D1**2*f*fdd*s + 75*D1**2*f*fdd + 450*D1**2*fd**2*r**2 + 450*D1**2*fd**2*r*s - 450*D1**2*fd**2*r - 150*D1**2*fd**2*s + 75*D1**2*fd**2 - 292*D1*Dd*f**2*r**2 - 292*D1*Dd*f**2*r*s + 219*D1*Dd*f**2*r + 73*D1*Dd*f**2*s - 73*D1*Dd*f**2 + 1800*D1*Dd*f*fd*r**2 + 1800*D1*Dd*f*fd*r*s - 1575*D1*Dd*f*fd*r - 525*D1*Dd*f*fd*s + 300*D1*Dd*f*fd + 300*D1*Ddd*f**2*r**2 + 300*D1*Ddd*f**2*r*s - 225*D1*Ddd*f**2*r - 75*D1*Ddd*f**2*s + 75*D1*Ddd*f**2 - 11*D1*bd1*(D1*(f*(r + s - 1)*(C*(38*r - 48) + 26*r - 11) - 3*fd*(2*C*(20*r**2 + 20*r*s - 26*r - 11*s + 5) + 24*r**2 + 24*r*s - 27*r - 9*s + 6)) - 6*Dd*f*(C*(40*r**2 + 40*r*s - 59*r - 29*s + 17) + 24*r**2 + 24*r*s - 27*r - 9*s + 6)) + 900*Dd**2*f**2*r**2 + 900*Dd**2*f**2*r*s - 675*Dd**2*f**2*r - 225*Dd**2*f**2*s + 75*Dd**2*f**2))/(231*d**2*k3**4) + D1**2*Pk2*Pkd1*ct**2*k1*k2**2*(8*C + 4)*(D1*f*(6*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-4*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + b1**2*(-D1**2*r*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(-5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*fd*(8*r**2 + 8*r*s - 3*r - s)) + 6*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 6*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(6*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 4*D1**2*f*fd*s - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r - 5*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*r - 5*D1**2*fd**2*s - 16*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 80*D1*Dd*f*fd*r*s - 70*D1*Dd*f*fd*r - 30*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 20*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r - 5*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-5*f*(2*r - 1)*(r + s - 1) + 6*fd*(4*r**2 + 4*r*s - 3*r - s)) + 12*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 60*Dd**2*f**2*r**2 + 60*Dd**2*f**2*r*s - 45*Dd**2*f**2*r - 15*Dd**2*f**2*s + 5*Dd**2*f**2))/(7*d**2*k3**4) + 2*D1**2*Pk2*Pkd1*ct**2*k1*st**2*(-11*D1**2*bd1**2*f*(4*C - 7)*(r*(2*s - 1) - s + 1) + 11*D1*bd1*(D1*b1*(f*(8*C - 21)*(r*(2*s - 1) - s) - fd*(4*C - 7)*(r*(4*s - 1) - s)) + D1*f*(f*(C*(-9*r**2 - 46*r*s + 10*r + 54*s - 9) + 18*r**2 + 9*r*s - 23*r - 22*s + 18) + fd*(2*C*(12*r**2 + 76*r*s - 29*r - 40*s + 19) - 60*r**2 - 68*r*s + 70*r + 41*s - 17)) - 2*Dd*b1*f*(4*C - 7)*(r*(8*s - 3) - 3*s + 1) + Dd*f**2*(C*(48*r**2 + r*(304*s - 82) - 206*s + 50) - 120*r**2 + r*(139 - 136*s) + 113*s - 47)) - 11*b1**2*(D1*Dd*(-f*(8*C - 21)*(r*(4*s - 1) - s) + fd*(4*C - 7)*(r*(8*s - 1) - s)) + D1*(D1*r*s*(fd*(21 - 8*C) + fdd*(4*C - 7)) + Ddd*f*(4*C - 7)*(r*(4*s - 1) - s)) + Dd**2*f*(4*C - 7)*(3*r*(4*s - 1) - 3*s + 1)) - 11*b1*(D1**2*(bdd1*f*(4*C - 7)*(r*(2*s - 1) - s) + f*(fd*(r**2*(18*C - 36) + 2*r*(46*C*s - 27*C - 9*s + 11) + s*(8*C - 13)) + fdd*(r**2*(30 - 12*C) + r*(-76*C*s + 42*C + 34*s - 24) + s*(7 - 4*C))) + fd**2*(r**2*(30 - 12*C) + r*(-76*C*s + 42*C + 34*s - 24) + s*(7 - 4*C))) + D1*f*(Dd*(f*(C*(36*r**2 + 8*r*(23*s - 8) - 46*s + 9) - 72*r**2 - 9*r*(4*s - 5) + 9*s - 18) + fd*(C*(-96*r**2 - 608*r*s + 268*r + 60*s - 38) + 240*r**2 + 272*r*s - 190*r - 6*s + 17)) + Ddd*f*(-2*C*(12*r**2 + 76*r*s - 25*r - 19*s + 3) + 60*r**2 + 68*r*s - 47*r - 17*s + 15)) + Dd**2*f**2*(-2*C*(36*r**2 + 3*r*(76*s - 25) - 57*s + 19) + 180*r**2 + 3*r*(68*s - 47) - 51*s + 17)) + f*(11*D1**2*bdd1*f*(C*(6*r**2 + 38*r*s - 8*r - 42*s + 6) - 15*r**2 - 17*r*s + 23*r + 24*s - 15) + D1**2*(f*(fd*(C*(-273*r**2 - 1206*r*s + 584*r + 402*s - 91) + 594*r**2 + 534*r*s - 574*r - 178*s + 198) + fdd*(2*C*(93*r**2 + 549*r*s - 245*r - 183*s + 31) - 495*r**2 - 696*r*s + 562*r + 232*s - 165)) + 2*fd**2*(C*(186*r**2 + 1098*r*s - 490*r - 366*s + 183) - 495*r**2 - 696*r*s + 562*r + 232*s - 116)) + D1*f*(Dd*(f*(C*(-364*r**2 - 1608*r*s + 584*r + 402*s - 91) + 792*r**2 + 712*r*s - 574*r - 178*s + 198) + 2*fd*(C*(744*r**2 + 4392*r*s - 1715*r - 1281*s + 428) - 1980*r**2 - 2784*r*s + 1967*r + 812*s - 397)) + Ddd*f*(2*C*(124*r**2 + 732*r*s - 245*r - 183*s + 31) - 660*r**2 - 928*r*s + 562*r + 232*s - 165)) + 2*Dd**2*f**2*(3*C*(124*r**2 + 732*r*s - 245*r - 183*s + 61) - 990*r**2 - 1392*r*s + 843*r + 348*s - 116)))/(231*d**2*k3**2) - 2*D1**2*Pk2*Pkd1*ct**2*k1*(33*b1**2*(D1**2*r*(-76*C*fdd*s + fd*r*(16*C - 28) + fd*s*(68*C - 87) + fdd*r*(56 - 29*C) + 96*fdd*s) + D1*(C*Ddd*f*(-116*r**2 + r*(134 - 304*s) + 76*s - 29) + Dd*f*(4*C*(16*r**2 + 68*r*s - 25*r - 17*s + 4) - 112*r**2 - 348*r*s + 143*r + 87*s - 28) + 2*Dd*fd*(r**2*(224 - 116*C) + r*(-304*C*s + 67*C + 384*s - 104) + s*(38*C - 48)) + 8*Ddd*f*(28*r**2 + r*(48*s - 26) - 12*s + 7)) + 2*Dd**2*f*(C*(-174*r**2 - 456*r*s + 201*r + 114*s - 38) + 336*r**2 + 576*r*s - 312*r - 144*s + 48)) + 33*b1*(16*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 28*C*D1**2*f*fd*r - 56*C*D1**2*f*fd*s + 22*C*D1**2*f*fd - 8*C*D1**2*f*fdd*r**2 + 16*C*D1**2*f*fdd*r*s - 14*C*D1**2*f*fdd*r + 64*C*D1**2*f*fdd*s - 29*C*D1**2*f*fdd - 8*C*D1**2*fd**2*r**2 + 16*C*D1**2*fd**2*r*s - 14*C*D1**2*fd**2*r + 64*C*D1**2*fd**2*s + 32*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s + 16*C*D1*Dd*f**2*s + 8*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r**2 + 128*C*D1*Dd*f*fd*r*s - 56*C*D1*Dd*f*fd*r + 240*C*D1*Dd*f*fd*s - 50*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 + 32*C*D1*Ddd*f**2*r*s - 8*C*D1*Ddd*f**2*s - 4*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 + 96*C*Dd**2*f**2*r*s - 24*C*Dd**2*f**2*s + 8*C*Dd**2*f**2 + D1**2*bdd1*f*(C*(-58*r**2 - 152*r*s + 134*r + 76*s - 29) + 112*r**2 + 192*r*s - 208*r - 96*s + 56) - 80*D1**2*f*fd*r**2 - 176*D1**2*f*fd*r*s + 96*D1**2*f*fd*r + 72*D1**2*f*fd*s - 40*D1**2*f*fd + 112*D1**2*f*fdd*r**2 + 196*D1**2*f*fdd*r*s - 129*D1**2*f*fdd*r - 81*D1**2*f*fdd*s + 56*D1**2*f*fdd + 112*D1**2*fd**2*r**2 + 196*D1**2*fd**2*r*s - 129*D1**2*fd**2*r - 81*D1**2*fd**2*s - 160*D1*Dd*f**2*r**2 - 352*D1*Dd*f**2*r*s + 168*D1*Dd*f**2*r + 88*D1*Dd*f**2*s - 40*D1*Dd*f**2 + 896*D1*Dd*f*fd*r**2 + 1568*D1*Dd*f*fd*r*s - 936*D1*Dd*f*fd*r - 520*D1*Dd*f*fd*s + 210*D1*Dd*f*fd + 224*D1*Ddd*f**2*r**2 + 392*D1*Ddd*f**2*r*s - 210*D1*Ddd*f**2*r - 98*D1*Ddd*f**2*s + 56*D1*Ddd*f**2 + D1*bd1*(D1*(f*(4*C*(8*r**2 + 34*r*s - 25*r - 17*s + 4) - 56*r**2 - 174*r*s + 143*r + 87*s - 28) + 2*fd*(r**2*(112 - 58*C) + r*(-152*C*s + 67*C + 192*s - 104) + s*(38*C - 48))) + 2*Dd*f*(C*(-232*r**2 - 608*r*s + 402*r + 228*s - 105) + 448*r**2 + 768*r*s - 624*r - 288*s + 152)) + 672*Dd**2*f**2*r**2 + 1176*Dd**2*f**2*r*s - 630*Dd**2*f**2*r - 294*Dd**2*f**2*s + 98*Dd**2*f**2) + f*(-5*C*(D1**2*(f*(4*fd*(87*r**2 + 297*r*s - 157*r - 99*s + 29) + fdd*(-471*r**2 - 1188*r*s + 710*r + 396*s - 157)) - 2*fd**2*(471*r**2 + 2*r*(594*s - 355) - 396*s + 198)) + D1*f*(2*Dd*(2*f*(116*r**2 + 396*r*s - 157*r - 99*s + 29) + fd*(-1884*r**2 - 4752*r*s + 2485*r + 1386*s - 553)) + Ddd*f*(-628*r**2 + r*(710 - 1584*s) + 396*s - 157)) - 6*Dd**2*f**2*(314*r**2 + r*(792*s - 355) - 198*s + 66)) - 66*D1**2*bd1**2*(C*(29*r**2 + 76*r*s - 67*r - 38*s + 38) - 56*r**2 - 8*r*(12*s - 13) + 48*s - 48) - 33*D1**2*bdd1*f*(C*(4*r**2 - 2*r*(4*s + 7) + 72*s - 25) - 56*r**2 + r*(81 - 98*s) + 17*s) - 5*D1*Dd*f*(89*f*(4*r*s - r - s) - 94*fd*(24*r*s - 7*r - 7*s + 2)) + 33*D1*bd1*(2*C*(D1*(f*(4*r**2 - 2*r*(4*s + 7) + 36*s - 7) + fd*(-8*r**2 + r*(16*s + 7) - 40*s + 4)) + Dd*f*(-16*r**2 + 4*r*(8*s + 7) - 148*s + 29)) + D1*(8*f*(-5*r**2 - 11*r*s + 9*r + 2*s) + fd*(224*r**2 + 392*r*s - 291*r - 115*s + 98)) + 2*Dd*f*(224*r**2 + r*(392*s - 267) - 83*s + 49)) - 5*D1*(D1*(89*f*fd*(3*r*s - r - s) + 94*f*fdd*(-3*r*s + r + s) - 94*fd**2*(6*r*s - 2*r - 2*s + 1)) + 94*Ddd*f**2*(-4*r*s + r + s)) + 470*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - 4*D1**2*Pk2*Pkd1*ct**2*k1*st**2*(-143*b1**2*(D1*Dd*(-f*(9*f + 13)*(r*(4*s - 1) - s) + 3*fd*(2*f*(16*r*s - 6*r - 2*s + 1) + 8*r*s - 5*r - s + 1)) - D1*(D1*r*(fd**2*(6 - 12*s) + fd*(18*f*s - 9*f + 13*s - 13) - 3*fdd*(4*f*s - 2*f + s - 1)) - 3*Ddd*f*(2*f + 1)*(r*(4*s - 1) - s)) + 3*Dd**2*f*(2*f + 1)*(3*r*(4*s - 1) - 3*s + 1)) + 13*b1*(D1*Dd*f*(f*(134*f + 55)*(r*(4*s - 1) - s) - 2*fd*(25*f*(48*r*s - 14*r - 10*s + 3) + 264*r*s - 99*r - 99*s + 33)) + 11*D1*bd1*(D1*(f*s*(9*f + 13)*(2*r - 1) - 3*fd*(2*f*(8*r*s - 2*r - 2*s + 1) + 4*r*s - 2*r - s + 1)) - 3*Dd*f*(2*f + 1)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(f*fd*(134*f*r*(3*s - 1) + 55*r*(2*s - 1) - s*(67*f + 55)) + f*(-33*bdd1*s*(2*f + 1)*(2*r - 1) + fdd*r*(-100*f*(3*s - 1) - 66*s + 33) + fdd*s*(50*f + 33)) + fd**2*(-50*f*(4*r*(3*s - 1) - 2*s + 1) - 66*r*s + 33*r + 33*s - 33)) - Ddd*f**2*(100*f + 33)*(r*(4*s - 1) - s)) - Dd**2*f**2*(100*f + 33)*(3*r*(4*s - 1) - 3*s + 1)) + f*(-429*D1**2*bd1**2*s*(2*f + 1)*(2*r - 1) + 13*D1*bd1*(D1*(67*f**2*s*(2*r - 1) - 50*f*fd*(2*r*(6*s - 1) - 4*s + 1) + 55*f*r*s + 33*fd*(-4*r*s + r + s)) + Dd*f*(-50*f*(16*r*s - 2*r - 6*s + 1) - 264*r*s + 33*r + 33*s)) + f*(5*D1*Dd*f*(131*f*(r*(4*s - 1) - s) - 196*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-429*bdd1*r*s + 655*f*fd*(r*(4*s - 1) - s) - 10*f*(65*bdd1*s*(2*r - 1) + 49*fdd*(4*r*s - r - s)) - 490*fd**2*(3*r*(4*s - 1) - 3*s + 1)) - 490*Ddd*f**2*(r*(4*s - 1) - s)) - 490*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(3003*d**2*k2**2) - 2*D1**2*Pk2*Pkd1*ct**2*k1*(-66*b1**3*(D1*Dd*(r*(-20*f*s + 5*f + 48*fd*s - 6*fd - 56*s + 14) + s*(5*f - 6*fd + 14)) + D1*(D1*r*s*(-5*fd + 6*fdd) + Ddd*(6*f + 7)*(4*r*s - r - s)) + Dd**2*(6*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1**2*(D1*Dd*(-f*(2*f + 9)*(r*(4*s - 1) - s) + fd*(f*(-4*r*(8*s + 17) + 44*s + 8) + 8*r*(8*s - 11) + 40*s + 8)) + 2*D1*bd1*(D1*(r*(15*f*s - 5*f - 36*fd*s + 6*fd + 42*s - 14) + s*(-5*f + 6*fd - 14)) - Dd*(6*f + 7)*(r*(24*s - 7) - 7*s + 2)) + D1*(-2*D1*bdd1*(6*f + 7)*(r*(3*s - 1) - s) - D1*(2*fd**2*(r*(2*s + 9) - 5*s) + fd*(r*(4*f*s - 18*f + 9*s - 19) + s*(8*f + 10)) + 2*fdd*(r*(2*f*s + 9*f - 4*s + 10) - s*(5*f + 6))) - 2*Ddd*f*(f - 4)*(r*(4*s - 1) - s)) - 2*Dd**2*f*(f - 4)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-66*D1**2*bd1**2*(6*f + 7)*(r*(6*s - 2) - 2*s + 1) + D1*Dd*f*(-8*f*(95*f + 66)*(r*(4*s - 1) - s) + fd*(5*f*(6*r*(568*s - 203) - 598*s + 241) + 1122*r*(8*s - 3) - 3366*s + 1122)) - 33*D1*bd1*(D1*(f*(2*r*(2*f*(s + 4) + 9*s + 5) - s*(10*f + 19)) + 4*fd*(f*(4*r*s - r - s - 2) - 8*r*s + 7*r - s - 2)) + 4*Dd*f*(f*(r*(8*s - 21) + 7*s + 3) - 8*r*(4*s + 1) + 24*s - 2)) + D1*(D1*(f*fd*(-6*r*(380*f*s - 165*f + 176*s - 88) + s*(265*f + 528)) - f*(132*bdd1*(r*(f*(s - 5) - 4*s - 3) + s*(2*f + 5)) + fdd*(-3*r*(710*f*s - 330*f + 374*s - 187) + s*(215*f + 561))) + fd**2*(5*f*(852*r*s - 396*r - 86*s + 99) + 1122*r*s - 561*r - 561*s + 561)) + Ddd*f**2*(710*f + 561)*(r*(4*s - 1) - s)) + Dd**2*f**2*(710*f + 561)*(3*r*(4*s - 1) - 3*s + 1)) + f*(-66*D1**2*bd1**2*(f*(2*r*(s - 5) + 4*s + 5) - 2*r*(4*s + 3) + 10*s) - D1*bd1*(D1*(5*f**2*(2*r*(76*s + 23) - 99*s) + f*(-5*fd*(852*r*s - 30*r - 340*s + 43) + 528*r*s) - 561*fd*(r*(4*s - 1) - s)) + Dd*f*(-5*f*(1136*r*s + 82*r - 538*s + 43) - 4488*r*s + 561*r + 561*s)) + f*(-420*D1*Dd*f*(f*r*(4*s - 1) - f*s - 2*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(bdd1*(5*f*(142*r*s + 56*r - 99*s) + 561*r*s) - 420*f*fd*(r*(4*s - 1) - s) + 420*f*fdd*(r*(4*s - 1) - s) + 420*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 420*Ddd*f**2*(r*(4*s - 1) - s)) + 420*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(693*d**2*k2**2) + 2*D1**2*Pk2*Pkd1*ct**2*k2**4*st**2*(D1*f*(3*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-5*f*r*(r + s - 1) + 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*D1*bdd1*f*r*(r + s - 1) + 3*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + b1**2*(-D1**2*r*(13*fd - 3*fdd)*(r + s) + D1*(Dd*(-13*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(8*r**2 + 8*r*s - 3*r - s)) + 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(3*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 10*D1**2*f*fd*r**2 - 10*D1**2*f*fd*r*s + 10*D1**2*f*fd*r + 5*D1**2*f*fd*s - 5*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 3*D1**2*fd**2*s - 20*D1*Dd*f**2*r**2 - 20*D1*Dd*f**2*r*s + 15*D1*Dd*f**2*r + 5*D1*Dd*f**2*s - 5*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 42*D1*Dd*f*fd*r - 18*D1*Dd*f*fd*s + 9*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s - 9*D1*Ddd*f**2*r - 3*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + D1*bd1*(D1*(-13*f*(2*r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 3*r - s)) + 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 36*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s - 27*Dd**2*f**2*r - 9*Dd**2*f**2*s + 3*Dd**2*f**2))/(21*d**2*k1*k3**4) - 2*D1**2*Pk2*Pkd1*ct**2*k2**2*st**4*(66*C*D1**2*b1*f*fdd*r**2 + 66*C*D1**2*b1*fd**2*r**2 + 66*C*D1**2*f**2*fd*r**2 - 44*C*D1**2*f**2*fd*r + 22*C*D1**2*f**2*fd - 33*C*D1**2*f**2*fdd*r**2 + 22*C*D1**2*f**2*fdd*r - 11*C*D1**2*f**2*fdd - 66*C*D1**2*f*fd**2*r**2 + 44*C*D1**2*f*fd**2*r + 528*C*D1*Dd*b1*f*fd*r**2 - 132*C*D1*Dd*b1*f*fd*r + 88*C*D1*Dd*f**3*r**2 - 44*C*D1*Dd*f**3*r + 22*C*D1*Dd*f**3 - 264*C*D1*Dd*f**2*fd*r**2 + 154*C*D1*Dd*f**2*fd*r - 22*C*D1*Dd*f**2*fd + 132*C*D1*Ddd*b1*f**2*r**2 - 66*C*D1*Ddd*b1*f**2*r + 33*C*D1*Ddd*b1*f**2 - 44*C*D1*Ddd*f**3*r**2 + 22*C*D1*Ddd*f**3*r - 11*C*D1*Ddd*f**3 + 396*C*Dd**2*b1*f**2*r**2 - 198*C*Dd**2*b1*f**2*r - 132*C*Dd**2*f**3*r**2 + 66*C*Dd**2*f**3*r + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 + 33*D1**2*bdd1*f**2*(C - 1)*(r - 1)**2 - 66*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r - 20*D1**2*f**2*fd*s - 22*D1**2*f**2*fd + 33*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s - 12*D1**2*f**2*fdd*r + 10*D1**2*f**2*fdd*s + 11*D1**2*f**2*fdd + 66*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s - 24*D1**2*f*fd**2*r + 20*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r*s - 66*D1*Dd*b1*f**2*r - 66*D1*Dd*b1*f**2*s - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r - 88*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s + 24*D1*Dd*f**3*r - 20*D1*Dd*f**3*s - 22*D1*Dd*f**3 + 264*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s - 84*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd*s + 2*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 + 44*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s - 12*D1*Ddd*f**3*r + 10*D1*Ddd*f**3*s + 11*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(D1*f*s + D1*fd*r*(2*C - 2) + Dd*f*(C - 1)*(4*r - 1)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r + 132*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s - 36*Dd**2*f**3*r + 30*Dd**2*f**3*s - 10*Dd**2*f**3)/(231*d**2*k1*k3**2) - 2*D1**2*Pk2*Pkd1*ct**2*k2**2*st**2*(77*D1*b1**2*(C - 1)*(D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) + 11*b1*(7*D1**2*bd1*f*(C - 1)*(2*r**2 - 2*r + 1) + D1**2*(f*(fd*(C*(26*r**2 - 14*r + 7) - 20*r**2 - 18*r*s + 23*r - 7) + fdd*(C*(-8*r**2 + 8*r - 4) + 14*r**2 + 18*r*s - 17*r + 4)) + fd**2*r*(-8*C*(r - 1) + 14*r + 18*s - 17)) + D1*f*(Dd*(f*(13*C*(4*r**2 - 2*r + 1) - 40*r**2 + r*(29 - 36*s) + 9*s - 10) + fd*(-8*C*(8*r**2 - 6*r + 1) + 112*r**2 + 6*r*(24*s - 19) - 18*s + 17)) + Ddd*f*(-4*C*(4*r**2 - 2*r + 1) + 28*r**2 + r*(36*s - 23) - 9*s + 7)) + 3*Dd**2*f**2*(-r**2*(16*C - 28) + r*(8*C + 36*s - 23) - 9*s + 3)) + f*(-42*C*D1**2*f*fd*r**2 + 28*C*D1**2*f*fd*r - 14*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 - 80*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd + 240*C*D1**2*fd**2*r**2 - 160*C*D1**2*fd**2*r - 56*C*D1*Dd*f**2*r**2 + 28*C*D1*Dd*f**2*r - 14*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 - 560*C*D1*Dd*f*fd*r + 80*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r**2 - 80*C*D1*Ddd*f**2*r + 40*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r**2 - 240*C*Dd**2*f**2*r - 11*D1**2*bdd1*f*(r**2*(4*C - 7) + r*(6 - 9*s) + 9*s - 3) - 219*D1**2*f*fd*r**2 - 249*D1**2*f*fd*r*s + 229*D1**2*f*fd*r + 83*D1**2*f*fd*s - 73*D1**2*f*fd + 159*D1**2*f*fdd*r**2 + 273*D1**2*f*fdd*r*s - 197*D1**2*f*fdd*r - 91*D1**2*f*fdd*s + 53*D1**2*f*fdd + 318*D1**2*fd**2*r**2 + 546*D1**2*fd**2*r*s - 394*D1**2*fd**2*r - 182*D1**2*fd**2*s + 91*D1**2*fd**2 - 292*D1*Dd*f**2*r**2 - 332*D1*Dd*f**2*r*s + 229*D1*Dd*f**2*r + 83*D1*Dd*f**2*s - 73*D1*Dd*f**2 + 1272*D1*Dd*f*fd*r**2 + 2184*D1*Dd*f*fd*r*s - 1379*D1*Dd*f*fd*r - 637*D1*Dd*f*fd*s + 288*D1*Dd*f*fd + 212*D1*Ddd*f**2*r**2 + 364*D1*Ddd*f**2*r*s - 197*D1*Ddd*f**2*r - 91*D1*Ddd*f**2*s + 53*D1*Ddd*f**2 + 11*D1*bd1*(D1*(f*(C*(13*r**2 - 12*r + 6) - 10*r**2 - 9*r*s + 6*r + 9*s - 3) + fd*(-r**2*(16*C - 28) + r*(8*C + 36*s - 29) - 18*s + 9)) + Dd*f*(-r**2*(32*C - 56) + r*(8*C + 72*s - 47) - 45*s + 15)) + 636*Dd**2*f**2*r**2 + 1092*Dd**2*f**2*r*s - 591*Dd**2*f**2*r - 273*Dd**2*f**2*s + 91*Dd**2*f**2))/(231*d**2*k1*k3**2) - 2*D1**2*Pk2*Pkd1*ct**2*k2**2*(D1*f*(2*D1*bd1**2*(r**2*(C + 3) - r*(C - 20*s + 13) - 10*s + 10) + D1*bdd1*f*r*(r*(5*C + 7) + 17*s - 17) + bd1*(D1*(2*f*r*(r*(C - 1) - 8*s + 8) + fd*(r**2*(20*C + 28) - 2*r*(5*C - 34*s + 24) - 17*s + 17)) + Dd*f*(r**2*(40*C + 56) + r*(-10*C + 136*s - 99) - 17*s + 17))) + b1**2*(D1**2*r*(fd*r*(12*C + 8) - 19*fd*s + fdd*r*(C + 3) + 20*fdd*s) + D1*(Dd*f*(12*C*(4*r**2 - 2*r + 1) + 32*r**2 + r*(3 - 76*s) + 19*s + 8) + 2*Dd*fd*(r**2*(4*C + 12) - r*(C - 80*s + 13) - 10*s) + Ddd*f*(4*C*r**2 - 2*C*r + C + 12*r**2 + 80*r*s - 26*r - 20*s + 3)) + 2*Dd**2*f*(r**2*(6*C + 18) - 3*r*(C - 40*s + 13) - 30*s + 10)) + b1*(4*C*D1**2*f*fd*r**2 - 4*C*D1**2*f*fd*r + 2*C*D1**2*f*fd + 10*C*D1**2*f*fdd*r**2 - 10*C*D1**2*f*fdd*r + 5*C*D1**2*f*fdd + 10*C*D1**2*fd**2*r**2 - 10*C*D1**2*fd**2*r + 8*C*D1*Dd*f**2*r**2 - 4*C*D1*Dd*f**2*r + 2*C*D1*Dd*f**2 + 80*C*D1*Dd*f*fd*r**2 - 60*C*D1*Dd*f*fd*r + 10*C*D1*Dd*f*fd + 20*C*D1*Ddd*f**2*r**2 - 10*C*D1*Ddd*f**2*r + 5*C*D1*Ddd*f**2 + 60*C*Dd**2*f**2*r**2 - 30*C*Dd**2*f**2*r + D1**2*bdd1*f*(2*C*r**2 - 2*C*r + C + 6*r**2 + 40*r*s - 26*r - 20*s + 3) - 4*D1**2*f*fd*r**2 - 32*D1**2*f*fd*r*s + 4*D1**2*f*fd*r + 16*D1**2*f*fd*s - 2*D1**2*f*fd + 14*D1**2*f*fdd*r**2 + 34*D1**2*f*fdd*r*s - 14*D1**2*f*fdd*r - 17*D1**2*f*fdd*s + 7*D1**2*f*fdd + 14*D1**2*fd**2*r**2 + 34*D1**2*fd**2*r*s - 14*D1**2*fd**2*r - 17*D1**2*fd**2*s - 8*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r + 16*D1*Dd*f**2*s - 2*D1*Dd*f**2 + 112*D1*Dd*f*fd*r**2 + 272*D1*Dd*f*fd*r*s - 118*D1*Dd*f*fd*r - 102*D1*Dd*f*fd*s + 31*D1*Dd*f*fd + 28*D1*Ddd*f**2*r**2 + 68*D1*Ddd*f**2*r*s - 31*D1*Ddd*f**2*r - 17*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 + D1*bd1*(D1*f*(12*C*(2*r**2 - 2*r + 1) + 16*r**2 - 38*r*s + 3*r + 19*s + 8) + 2*D1*fd*(r**2*(2*C + 6) - r*(C - 40*s + 13) - 10*s) + 2*Dd*f*(8*C*r**2 - 6*C*r + C + 24*r**2 + 160*r*s - 78*r - 60*s + 23)) + 84*Dd**2*f**2*r**2 + 204*Dd**2*f**2*r*s - 93*Dd**2*f**2*r - 51*Dd**2*f**2*s + 17*Dd**2*f**2))/(21*d**2*k1*k3**2) - D1**2*Pk2*Pkd1*ct**2*st**2*(-858*D1**2*bd1**2*f*(f*(r*(8*s - 2) - 4*s + 2) + s*(2*r - 1)) + 26*D1**2*bdd1*f**2*(5*f*(12*r**2 + r*(13*s - 6) - 33*s + 8) - 11*r*(r*(2*K - 2) + 3*s)) + 2*D1**2*(-5*f**3*(fd*(632*r**2 + 1300*r*s - 641*r - 325*s + 158) + fdd*(-576*r**2 - 1300*r*s + 613*r + 325*s - 144)) + f**2*(5*fd**2*(1728*r**2 + 3900*r*s - 1839*r - 975*s + 325) + r**2*(-1001*gd2 + 572*gdd2)) - 143*f*(7*fd*g2*(2*r**2 - 2*r + 1) + 8*fd*gd2*r*(1 - 2*r) - 4*fdd*g2*(2*r**2 - 2*r + 1)) + 1144*fd**2*g2*r*(r - 1)) - 13*D1*bd1*f*(D1*(f**2*(42*r**2 + r*(62*s + 78) - 330*s + 28) - f*(10*fd*(72*r**2 + r*(78*s - 49) - 79*s + 23) + 11*r*(r*(7*K - 7) + 10*s)) + 22*fd*(r**2*(8*K - 8) + r*(-4*K + 12*s + 1) - 3*s) + 154*g2*(r - 1)**2) - 2*Dd*f*(5*f*(96*r**2 + r*(104*s - 61) - 145*s + 39) - 11*r**2*(16*K - 16) - 11*r*(-4*K + 24*s + 1) + 33*s)) + 2*D1*f*(Dd*(-5*f**3*(632*r**2 + r*(1300*s - 641) - 325*s + 158) + 10*f**2*fd*(4*r - 1)*(576*r + 1300*s - 469) - 143*f*(7*g2*(4*r**2 - 2*r + 1) + 8*gd2*r*(1 - 4*r)) + 1144*fd*g2*(8*r**2 - 6*r + 1)) + Ddd*f*(5*f**2*(576*r**2 + 1300*r*s - 613*r - 325*s + 144) + 572*g2*(4*r**2 - 2*r + 1))) + 2*Dd**2*f**2*(5*f**2*(1728*r**2 + 3900*r*s - 1839*r - 975*s + 325) + 3432*g2*r*(2*r - 1)) + 143*b1**2*(D1**2*r*(fd**2*(12 - 48*s) + fd*(6*f*(2*r + 12*s - 3) + r*(7*K - 7) + 26*s - 26) - 6*fdd*(f*(8*s - 2) + s - 1)) + D1*(Dd*(6*f**2*(4*r**2 + 8*r*(3*s - 1) - 6*s + 1) - f*(-7*K*(4*r**2 - 2*r + 1) + 12*fd*(8*r - 1)*(4*s - 1) + 28*r**2 - 104*r*s + 12*r + 26*s + 7) - 6*fd*(r*(8*s - 5) - s + 1)) - 6*Ddd*f*(4*f + 1)*(r*(4*s - 1) - s)) - 6*Dd**2*f*(4*f + 1)*(3*r*(4*s - 1) - 3*s + 1)) + 13*b1*(D1**2*(-2*f**2*(66*bdd1*(4*r*s - r - 2*s) + fd*(63*r**2 + r*(93*s - 112) + 134*s + 7) - 5*fdd*(36*r**2 + 39*r*s - 31*r + 20*s + 4)) + f*(-132*bdd1*r*s + 66*bdd1*s + 20*fd**2*(36*r**2 + r*(39*s - 31) + 20*s - 5) + 11*fd*(7*K*(2*r**2 - 2*r + 1) - 14*r**2 + 20*r*s + 4*r - 10*s - 7) - 22*fdd*(K*(4*r**2 - 4*r + 2) - 4*r**2 + 6*r*s + r - 3*s - 2) - 154*gd2*r**2) - 22*fd*(fd*(r**2*(4*K - 4) + r*(-4*K + 6*s + 1) - 3*s + 3) + 7*g2*r**2)) + 11*D1*bd1*(D1*(6*f**2*(2*r**2 + r*(12*s - 5) - 6*s + 1) + f*(7*K*(2*r**2 - 2*r + 1) - 12*fd*(4*r - 1)*(4*s - 1) - 14*r**2 + 52*r*s + 14*r - 26*s - 7) - 6*fd*(r*(4*s - 2) - s + 1)) - 6*Dd*f*(2*f*(8*r - 3)*(4*s - 1) + 2*r*(8*s - 1) - 6*s + 1)) + D1*f*(Dd*(-2*f**2*(84*r**2 + r*(124*s - 73) - 31*s + 21) + f*(77*K*(4*r**2 - 2*r + 1) + 10*fd*(288*r**2 + r*(312*s - 235) + 41*s + 11) - 308*r**2 + 440*r*s + 44*r - 110*s - 77) - 44*fd*(2*K*(8*r**2 - 6*r + 1) - 16*r**2 + 24*r*s + 3*r - 9*s + 1) - 154*g2*(4*r**2 - 2*r + 1)) + 2*Ddd*f*(-11*K*(8*r**2 - 4*r + 2) + 5*f*(48*r**2 + r*(52*s - 37) - 13*s + 12) + 88*r**2 - 132*r*s - 11*r + 33*s + 22)) + 2*Dd**2*f**2*(5*f*(144*r**2 + 3*r*(52*s - 37) - 39*s + 13) - 33*r**2*(8*K - 8) - 33*r*(-4*K + 12*s + 1) + 99*s - 33)))/(3003*d**2*k1) - D1**2*Pk2*Pkd1*ct**2*(-88*D1**2*K*bd1**2*f*r**2 - 22*D1**2*K*bd1**2*f*r + 22*D1**2*K*bd1*f**2*r**2 + 220*D1**2*K*bd1*f*fd*r**2 - 110*D1**2*K*bd1*f*fd*r + 55*D1**2*K*bdd1*f**2*r**2 + 440*D1**2*bd1**2*f**2*r**2 + 1584*D1**2*bd1**2*f**2*r*s - 726*D1**2*bd1**2*f**2*r - 792*D1**2*bd1**2*f**2*s + 396*D1**2*bd1**2*f**2 + 132*D1**2*bd1**2*f*r**2 + 880*D1**2*bd1**2*f*r*s - 22*D1**2*bd1**2*f*r - 440*D1**2*bd1**2*f*s - 308*D1**2*bd1**2*g2*r**2 + 308*D1**2*bd1**2*g2*r + 22*D1**2*bd1*bd2*f*r**2 - 22*D1**2*bd1*bd2*f*r - 120*D1**2*bd1*f**3*r**2 - 660*D1**2*bd1*f**3*r*s + 330*D1**2*bd1*f**3*r + 1350*D1**2*bd1*f**2*fd*r**2 + 3960*D1**2*bd1*f**2*fd*r*s - 1770*D1**2*bd1*f**2*fd*r - 660*D1**2*bd1*f**2*fd*s + 330*D1**2*bd1*f**2*fd + 22*D1**2*bd1*f**2*r**2 - 352*D1**2*bd1*f**2*r*s + 220*D1**2*bd1*f*fd*r**2 + 1496*D1**2*bd1*f*fd*r*s - 484*D1**2*bd1*f*fd*r - 374*D1**2*bd1*f*fd*s - 176*D1**2*bd1*f*g2*r**2 + 528*D1**2*bd1*f*g2*r - 264*D1**2*bd1*f*g2 + 176*D1**2*bd1*f*gd2*r**2 + 44*D1**2*bd1*f*gd2*r + 176*D1**2*bd1*fd*g2*r**2 - 176*D1**2*bd1*fd*g2*r + 22*D1**2*bd2*f**2*r**2 + 220*D1**2*bd2*f*fd*r**2 - 110*D1**2*bd2*f*fd*r + 225*D1**2*bdd1*f**3*r**2 + 660*D1**2*bdd1*f**3*r*s - 330*D1**2*bdd1*f**3*r + 55*D1**2*bdd1*f**2*r**2 + 374*D1**2*bdd1*f**2*r*s + 88*D1**2*bdd1*f*g2*r**2 + 44*D1**2*bdd1*f*g2*r - 22*D1**2*bdd1*f*g2 + 55*D1**2*bdd2*f**2*r**2 - 44*D1**2*f**2*gd2*r**2 - 110*D1**2*f**2*gdd2*r**2 - 88*D1**2*f*fd*g2*r**2 + 88*D1**2*f*fd*g2*r - 44*D1**2*f*fd*g2 - 440*D1**2*f*fd*gd2*r**2 + 220*D1**2*f*fd*gd2*r - 220*D1**2*f*fdd*g2*r**2 + 220*D1**2*f*fdd*g2*r - 110*D1**2*f*fdd*g2 - 220*D1**2*fd**2*g2*r**2 + 220*D1**2*fd**2*g2*r + 440*D1*Dd*K*bd1*f**2*r**2 - 110*D1*Dd*K*bd1*f**2*r + 1800*D1*Dd*bd1*f**3*r**2 + 5280*D1*Dd*bd1*f**3*r*s - 2430*D1*Dd*bd1*f**3*r - 660*D1*Dd*bd1*f**3*s + 330*D1*Dd*bd1*f**3 + 440*D1*Dd*bd1*f**2*r**2 + 2992*D1*Dd*bd1*f**2*r*s - 484*D1*Dd*bd1*f**2*r - 374*D1*Dd*bd1*f**2*s + 704*D1*Dd*bd1*f*g2*r**2 - 44*D1*Dd*bd1*f*g2 + 440*D1*Dd*bd2*f**2*r**2 - 110*D1*Dd*bd2*f**2*r - 176*D1*Dd*f**2*g2*r**2 + 88*D1*Dd*f**2*g2*r - 44*D1*Dd*f**2*g2 - 880*D1*Dd*f**2*gd2*r**2 + 220*D1*Dd*f**2*gd2*r - 1760*D1*Dd*f*fd*g2*r**2 + 1320*D1*Dd*f*fd*g2*r - 220*D1*Dd*f*fd*g2 - 440*D1*Ddd*f**2*g2*r**2 + 220*D1*Ddd*f**2*g2*r - 110*D1*Ddd*f**2*g2 - 1320*Dd**2*f**2*g2*r**2 + 660*Dd**2*f**2*g2*r + 11*b1**3*(D1**2*r**2*(12*fd + fdd) + 2*D1*Dd*(-7*K*(4*r**2 - 2*r + 1) + 6*f*(4*r**2 - 2*r + 1) + 4*fd*r**2 - fd*r + 28*r**2 - 14*r + 7) + D1*Ddd*(7*K + f - 7)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(2*r - 1)*(7*K + f - 7)) + 11*b1**2*(8*D1**2*K*fd*r**2 + 8*D1**2*K*fd*r - 4*D1**2*K*fd - 4*D1**2*K*fdd*r**2 + 10*D1**2*K*fdd*r - 5*D1**2*K*fdd + D1**2*bdd1*(7*K + f - 7)*(3*r**2 - 2*r + 1) + 16*D1**2*f*fd*r**2 - 144*D1**2*f*fd*r*s + 32*D1**2*f*fd*r + 2*D1**2*f*fd + 40*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s - 46*D1**2*f*fdd*r + 5*D1**2*f*fdd + 40*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s - 46*D1**2*fd**2*r + 16*D1**2*fd*r**2 - 38*D1**2*fd*r*s + 30*D1**2*fd*r + 4*D1**2*fd + 6*D1**2*fdd*r**2 + 40*D1**2*fdd*r*s - 50*D1**2*fdd*r + 5*D1**2*fdd + 28*D1**2*gd2*r**2 - 14*D1**2*gdd2*r**2 + 32*D1*Dd*K*f*r**2 - 16*D1*Dd*K*f*r + 8*D1*Dd*K*f - 32*D1*Dd*K*fd*r**2 + 48*D1*Dd*K*fd*r - 10*D1*Dd*K*fd + 32*D1*Dd*f**2*r**2 - 288*D1*Dd*f**2*r*s + 56*D1*Dd*f**2*r + 72*D1*Dd*f**2*s + 8*D1*Dd*f**2 + 320*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 408*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s + 46*D1*Dd*f*fd + 64*D1*Dd*f*r**2 - 152*D1*Dd*f*r*s + 6*D1*Dd*f*r + 38*D1*Dd*f*s + 16*D1*Dd*f + 48*D1*Dd*fd*r**2 + 320*D1*Dd*fd*r*s - 252*D1*Dd*fd*r - 40*D1*Dd*fd*s + 50*D1*Dd*fd + 112*D1*Dd*g2*r**2 - 56*D1*Dd*g2*r + 28*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 + 28*D1*Dd*gd2*r - 16*D1*Ddd*K*f*r**2 + 8*D1*Ddd*K*f*r - 4*D1*Ddd*K*f + 80*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 112*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s + 20*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 160*D1*Ddd*f*r*s - 52*D1*Ddd*f*r - 40*D1*Ddd*f*s + 6*D1*Ddd*f - 56*D1*Ddd*g2*r**2 + 28*D1*Ddd*g2*r - 14*D1*Ddd*g2 + 2*D1*bd1*(D1*(-7*K*(3*r**2 - 2*r + 1) + 6*f*(3*r**2 - 2*r + 1) + 3*fd*r**2 - fd*r + 21*r**2 - 14*r + 7) + Dd*(7*K + f - 7)*(12*r**2 - 7*r + 1)) - 48*Dd**2*K*f*r**2 + 24*Dd**2*K*f*r + 240*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 336*Dd**2*f**2*r - 216*Dd**2*f**2*s + 72*Dd**2*f**2 + 72*Dd**2*f*r**2 + 480*Dd**2*f*r*s - 156*Dd**2*f*r - 120*Dd**2*f*s + 40*Dd**2*f - 168*Dd**2*g2*r**2 + 84*Dd**2*g2*r) + b1*(44*D1**2*K*f*fd*r**2 - 44*D1**2*K*f*fd*r + 22*D1**2*K*f*fd + 110*D1**2*K*f*fdd*r**2 - 110*D1**2*K*f*fdd*r + 55*D1**2*K*f*fdd + 110*D1**2*K*fd**2*r**2 - 110*D1**2*K*fd**2*r + 132*D1**2*b2*fd*r**2 + 11*D1**2*b2*fdd*r**2 + 22*D1**2*bd1**2*r*(3*r - 2)*(7*K + f - 7) + 132*D1**2*bd2*f*r**2 + 22*D1**2*bd2*fd*r**2 + 11*D1**2*bdd1*(f**2*(40*r**2 + 6*r*(24*s - 11) - 72*s + 15) + f*(-8*K*r**2 - 2*K*r + K + 12*r**2 + 80*r*s - 2*r - 40*s + 1) - 14*g2*(2*r**2 - 2*r + 1)) + 11*D1**2*bdd2*f*r**2 - 360*D1**2*f**2*fd*r**2 - 1980*D1**2*f**2*fd*r*s + 570*D1**2*f**2*fd*r + 660*D1**2*f**2*fd*s - 120*D1**2*f**2*fd + 675*D1**2*f**2*fdd*r**2 + 1980*D1**2*f**2*fdd*r*s - 780*D1**2*f**2*fdd*r - 660*D1**2*f**2*fdd*s + 225*D1**2*f**2*fdd + 1350*D1**2*f*fd**2*r**2 + 3960*D1**2*f*fd**2*r*s - 1560*D1**2*f*fd**2*r - 1320*D1**2*f*fd**2*s + 330*D1**2*f*fd**2 + 44*D1**2*f*fd*r**2 - 704*D1**2*f*fd*r*s + 308*D1**2*f*fd*r + 352*D1**2*f*fd*s + 22*D1**2*f*fd + 110*D1**2*f*fdd*r**2 + 748*D1**2*f*fdd*r*s - 484*D1**2*f*fdd*r - 374*D1**2*f*fdd*s + 55*D1**2*f*fdd - 176*D1**2*f*gd2*r**2 + 88*D1**2*f*gdd2*r**2 + 110*D1**2*fd**2*r**2 + 748*D1**2*fd**2*r*s - 484*D1**2*fd**2*r - 374*D1**2*fd**2*s + 374*D1**2*fd**2 - 176*D1**2*fd*g2*r**2 - 176*D1**2*fd*g2*r + 88*D1**2*fd*g2 + 176*D1**2*fd*gd2*r**2 - 220*D1**2*fd*gd2*r + 88*D1**2*fdd*g2*r**2 - 220*D1**2*fdd*g2*r + 110*D1**2*fdd*g2 + 88*D1*Dd*K*f**2*r**2 - 44*D1*Dd*K*f**2*r + 22*D1*Dd*K*f**2 + 880*D1*Dd*K*f*fd*r**2 - 660*D1*Dd*K*f*fd*r + 110*D1*Dd*K*f*fd + 528*D1*Dd*b2*f*r**2 - 264*D1*Dd*b2*f*r + 132*D1*Dd*b2*f + 88*D1*Dd*b2*fd*r**2 - 22*D1*Dd*b2*fd*r + 88*D1*Dd*bd2*f*r**2 - 22*D1*Dd*bd2*f*r - 480*D1*Dd*f**3*r**2 - 2640*D1*Dd*f**3*r*s + 900*D1*Dd*f**3*r + 660*D1*Dd*f**3*s - 120*D1*Dd*f**3 + 5400*D1*Dd*f**2*fd*r**2 + 15840*D1*Dd*f**2*fd*r*s - 6450*D1*Dd*f**2*fd*r - 4620*D1*Dd*f**2*fd*s + 1440*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r**2 - 1408*D1*Dd*f**2*r*s + 308*D1*Dd*f**2*r + 352*D1*Dd*f**2*s + 22*D1*Dd*f**2 + 880*D1*Dd*f*fd*r**2 + 5984*D1*Dd*f*fd*r*s - 2904*D1*Dd*f*fd*r - 2244*D1*Dd*f*fd*s + 858*D1*Dd*f*fd - 704*D1*Dd*f*g2*r**2 + 352*D1*Dd*f*g2*r - 176*D1*Dd*f*g2 + 704*D1*Dd*f*gd2*r**2 - 176*D1*Dd*f*gd2*r + 704*D1*Dd*fd*g2*r**2 - 1056*D1*Dd*fd*g2*r + 220*D1*Dd*fd*g2 + 220*D1*Ddd*K*f**2*r**2 - 110*D1*Ddd*K*f**2*r + 55*D1*Ddd*K*f**2 + 44*D1*Ddd*b2*f*r**2 - 22*D1*Ddd*b2*f*r + 11*D1*Ddd*b2*f + 900*D1*Ddd*f**3*r**2 + 2640*D1*Ddd*f**3*r*s - 1110*D1*Ddd*f**3*r - 660*D1*Ddd*f**3*s + 225*D1*Ddd*f**3 + 220*D1*Ddd*f**2*r**2 + 1496*D1*Ddd*f**2*r*s - 484*D1*Ddd*f**2*r - 374*D1*Ddd*f**2*s + 55*D1*Ddd*f**2 + 352*D1*Ddd*f*g2*r**2 - 176*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(f**2*(8*r**2 + r*(12 - 72*s) + 36*s + 3) + f*(2*K*(4*r**2 - 6*r + 3) + 2*fd*(40*r**2 + 8*r*(18*s - 7) - 36*s + 9) + 16*r**2 - 38*r*s - 12*r + 19*s + 6) + fd*(r**2*(12 - 8*K) + r*(9*K + 80*s - 51) - 20*s + 20) + 14*g2*(2*r**2 - 2*r + 1) + 14*gd2*r*(1 - 2*r)) + Dd*(f**2*(8*r - 3)*(20*r + 72*s - 23) + f*(-32*K*r**2 + 4*K*r + K + 48*r**2 + 320*r*s - 56*r - 120*s + 21) - 14*g2*(8*r**2 - 6*r + 1))) + 660*Dd**2*K*f**2*r**2 - 330*Dd**2*K*f**2*r + 132*Dd**2*b2*f*r**2 - 66*Dd**2*b2*f*r + 2700*Dd**2*f**3*r**2 + 7920*Dd**2*f**3*r*s - 3330*Dd**2*f**3*r - 1980*Dd**2*f**3*s + 660*Dd**2*f**3 + 660*Dd**2*f**2*r**2 + 4488*Dd**2*f**2*r*s - 1452*Dd**2*f**2*r - 1122*Dd**2*f**2*s + 374*Dd**2*f**2 + 1056*Dd**2*f*g2*r**2 - 528*Dd**2*f*g2*r) + 11*b2*(D1**2*bdd1*f*(r - 1)**2 + 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r + 2*D1**2*f*fd + 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 - 60*D1*Dd*f*fd*r + 10*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 - 10*D1*Ddd*f**2*r + 5*D1*Ddd*f**2 + 2*D1*bd1*(r - 1)*(6*D1*f*(r - 1) + D1*fd*r + Dd*f*(4*r - 1)) + 60*Dd**2*f**2*r**2 - 30*Dd**2*f**2*r))/(231*d**2*k1) - 4*D1**2*Pk2*Pkd1*ct*f*k1**2*k2*st**4*(11*D1**2*bd1*f*(r - 1)*(r + s - 1) + 6*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s - 6*D1**2*f*fd*r - 2*D1**2*f*fd*s + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 - 3*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + D1**2*f*fdd*s - D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 2*D1**2*fd**2*s - D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 - 24*D1*Dd*f*fd*r*s + 21*D1*Dd*f*fd*r + 7*D1*Dd*f*fd*s - 4*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 4*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r + D1*Ddd*f**2*s - D1*Ddd*f**2 + 11*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*s - 3*r - s + 1)) - 12*Dd**2*f**2*r**2 - 12*Dd**2*f**2*r*s + 9*Dd**2*f**2*r + 3*Dd**2*f**2*s - Dd**2*f**2)/(77*d**2*k3**4) - 16*D1**2*Pk2*Pkd1*ct*f*k1**2*st**4*(D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 7*r + 7*s - 2)) + D1*(D1*(2*f*fd*(3*r*s - r - s) + f*fdd*(-3*r*s + r + s) + fd**2*(-6*r*s + 2*r + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))/(231*d**2*k2*k3**2) - 4*D1**2*Pk2*Pkd1*ct*f*k2**3*st**4*(33*D1**2*bd1*f*(2*C + 1)*(r - 1)*(r + s - 1) + 33*D1*b1*(2*C + 1)*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + (10*C + 3)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(Dd*(f*(8*r**2 + 8*r*s - 6*r - 2*s + 2) + fd*(-24*r**2 - 24*r*s + 21*r + 7*s - 4)) + Ddd*f*(-4*r**2 + r*(3 - 4*s) + s - 1)) + Dd**2*f**2*(-12*r**2 + r*(9 - 12*s) + 3*s - 1)))/(231*d**2*k3**4) - 8*D1**2*Pk2*Pkd1*ct*f*st**4*(429*D1*b1**2*(D1*fd*r*(2*s - 1) + Dd*f*(4*r*s - r - s)) + 13*D1*bd1*f*(D1*(-5*fd*(18*r*s - 3*r - 7*s + 2) + s*(66*b1*r - 33*b1 + 30*f*r - 20*f)) - 5*Dd*f*(3*r*(8*s - 1) - 11*s + 2)) - 65*b1*(D1*Dd*f*(6*f*(-4*r*s + r + s) + fd*(72*r*s - 21*r - 13*s + 4)) + D1*(D1*(2*f*fd*(-9*r*s + 3*r + s) + f*fdd*(9*r*s - 3*r - s) + fd**2*(18*r*s - 6*r - 2*s + 1)) + 3*Ddd*f**2*(r*(4*s - 1) - s)) + 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(2*D1*Dd*f*(87*f*(4*r*s - r - s) - 100*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(174*f*fd*(r*(4*s - 1) - s) - 5*f*(13*bdd1*s*(3*r - 2) + 20*fdd*(4*r*s - r - s)) - 100*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 100*Ddd*f**2*(-4*r*s + r + s)) - 100*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(3003*d**2*k2) - 5*D1**2*Pk2*Pkd1*ct*f*k2*st**4*(390*D1**2*b1*f*fd*r**2 - 195*D1**2*b1*f*fdd*r**2 - 390*D1**2*b1*fd**2*r**2 - 65*D1**2*bdd1*f**2*(r - 1)**2 - 8*D1**2*f**2*fd*r**2 + 4*D1**2*f**2*fd*r - 2*D1**2*f**2*fd + 4*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 12*D1**2*f*fd**2*r**2 - 6*D1**2*f*fd**2*r + 520*D1*Dd*b1*f**2*r**2 - 260*D1*Dd*b1*f**2*r + 130*D1*Dd*b1*f**2 - 1560*D1*Dd*b1*f*fd*r**2 + 390*D1*Dd*b1*f*fd*r - 8*D1*Dd*f**3*r**2 + 4*D1*Dd*f**3*r - 2*D1*Dd*f**3 + 32*D1*Dd*f**2*fd*r**2 - 16*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd - 260*D1*Ddd*b1*f**2*r**2 + 130*D1*Ddd*b1*f**2*r - 65*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 130*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 780*Dd**2*b1*f**2*r**2 + 390*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(3003*d**2*k1**2) - 2*D1**2*Pk2*Pkd1*ct*k1**4*st**2*(66*D1**2*b1*f*fd*r**2 + 66*D1**2*b1*f*fd*r*s - 33*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 33*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 51*D1**2*f**2*fd*r**2 + 51*D1**2*f**2*fd*r*s - 51*D1**2*f**2*fd*r - 17*D1**2*f**2*fd*s + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 132*D1*Dd*b1*f**2*r*s - 99*D1*Dd*b1*f**2*r - 33*D1*Dd*b1*f**2*s + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 330*D1*Dd*b1*f*fd*r + 66*D1*Dd*b1*f*fd*s - 33*D1*Dd*b1*f*fd + 68*D1*Dd*f**3*r**2 + 68*D1*Dd*f**3*r*s - 51*D1*Dd*f**3*r - 17*D1*Dd*f**3*s + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 525*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s - 100*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 99*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 75*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(-8*r**2 + r*(11 - 8*s) + 5*s - 3)) - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 297*Dd**2*b1*f**2*r + 99*Dd**2*b1*f**2*s - 33*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 225*Dd**2*f**3*r + 75*Dd**2*f**3*s - 25*Dd**2*f**3)/(693*d**2*k2*k3**4) + 4*D1**2*Pk2*Pkd1*ct*k1**4*(D1*f*(6*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-4*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + b1**2*(-D1**2*r*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(-5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*fd*(8*r**2 + 8*r*s - 3*r - s)) + 6*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 6*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(6*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 4*D1**2*f*fd*s - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r - 5*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*r - 5*D1**2*fd**2*s - 16*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 80*D1*Dd*f*fd*r*s - 70*D1*Dd*f*fd*r - 30*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 20*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r - 5*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-5*f*(2*r - 1)*(r + s - 1) + 6*fd*(4*r**2 + 4*r*s - 3*r - s)) + 12*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 60*Dd**2*f**2*r**2 + 60*Dd**2*f**2*r*s - 45*Dd**2*f**2*r - 15*Dd**2*f**2*s + 5*Dd**2*f**2))/(21*d**2*k2*k3**4) - 2*D1**2*Pk2*Pkd1*ct*k1**2*k2*st**2*(33*b1**2*(D1**2*r*(13*fd - 3*fdd)*(r + s) + D1*(Dd*(13*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(-8*r**2 - 8*r*s + 3*r + s)) - 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) - 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + 33*b1*(44*C*D1**2*f*fd*r**2 + 44*C*D1**2*f*fd*r*s - 22*C*D1**2*f*fd*r - 36*C*D1**2*f*fdd*r**2 - 36*C*D1**2*f*fdd*r*s + 18*C*D1**2*f*fdd*r - 36*C*D1**2*fd**2*r**2 - 36*C*D1**2*fd**2*r*s + 18*C*D1**2*fd**2*r + 88*C*D1*Dd*f**2*r**2 + 88*C*D1*Dd*f**2*r*s - 66*C*D1*Dd*f**2*r - 22*C*D1*Dd*f**2*s + 22*C*D1*Dd*f**2 - 288*C*D1*Dd*f*fd*r**2 - 288*C*D1*Dd*f*fd*r*s + 180*C*D1*Dd*f*fd*r + 36*C*D1*Dd*f*fd*s - 18*C*D1*Dd*f*fd - 72*C*D1*Ddd*f**2*r**2 - 72*C*D1*Ddd*f**2*r*s + 54*C*D1*Ddd*f**2*r + 18*C*D1*Ddd*f**2*s - 18*C*D1*Ddd*f**2 - 216*C*Dd**2*f**2*r**2 - 216*C*Dd**2*f**2*r*s + 162*C*Dd**2*f**2*r + 54*C*Dd**2*f**2*s - 18*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) + 12*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s - 11*D1**2*f*fd*r - 5*D1**2*f*fd*s + 5*D1**2*f*fd - 8*D1**2*f*fdd*r**2 - 8*D1**2*f*fdd*r*s + 7*D1**2*f*fdd*r + 3*D1**2*f*fdd*s - 3*D1**2*f*fdd - 8*D1**2*fd**2*r**2 - 8*D1**2*fd**2*r*s + 7*D1**2*fd**2*r + 3*D1**2*fd**2*s + 24*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r - 6*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 64*D1*Dd*f*fd*r**2 - 64*D1*Dd*f*fd*r*s + 52*D1*Dd*f*fd*r + 20*D1*Dd*f*fd*s - 10*D1*Dd*f*fd - 16*D1*Ddd*f**2*r**2 - 16*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s - 4*D1*Ddd*f**2 + D1*bd1*(D1*(13*f*(2*r - 1)*(r + s - 1) + 3*fd*(-4*r**2 - 4*r*s + 3*r + s)) - 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) - 48*Dd**2*f**2*r**2 - 48*Dd**2*f**2*r*s + 36*Dd**2*f**2*r + 12*Dd**2*f**2*s - 4*Dd**2*f**2) + f*(1314*C*D1**2*f*fd*r**2 + 1314*C*D1**2*f*fd*r*s - 1314*C*D1**2*f*fd*r - 438*C*D1**2*f*fd*s + 438*C*D1**2*f*fd - 1350*C*D1**2*f*fdd*r**2 - 1350*C*D1**2*f*fdd*r*s + 1350*C*D1**2*f*fdd*r + 450*C*D1**2*f*fdd*s - 450*C*D1**2*f*fdd - 2700*C*D1**2*fd**2*r**2 - 2700*C*D1**2*fd**2*r*s + 2700*C*D1**2*fd**2*r + 900*C*D1**2*fd**2*s - 450*C*D1**2*fd**2 + 1752*C*D1*Dd*f**2*r**2 + 1752*C*D1*Dd*f**2*r*s - 1314*C*D1*Dd*f**2*r - 438*C*D1*Dd*f**2*s + 438*C*D1*Dd*f**2 - 10800*C*D1*Dd*f*fd*r**2 - 10800*C*D1*Dd*f*fd*r*s + 9450*C*D1*Dd*f*fd*r + 3150*C*D1*Dd*f*fd*s - 1800*C*D1*Dd*f*fd - 1800*C*D1*Ddd*f**2*r**2 - 1800*C*D1*Ddd*f**2*r*s + 1350*C*D1*Ddd*f**2*r + 450*C*D1*Ddd*f**2*s - 450*C*D1*Ddd*f**2 - 5400*C*Dd**2*f**2*r**2 - 5400*C*Dd**2*f**2*r*s + 4050*C*Dd**2*f**2*r + 1350*C*Dd**2*f**2*s - 450*C*Dd**2*f**2 - 99*D1**2*bd1**2*(2*r - 1)*(r + s - 1) - 33*D1**2*bdd1*f*(r + s - 1)*(18*C*(r - 1) + 4*r - 1) + 51*D1**2*f*fd*r**2 + 51*D1**2*f*fd*r*s - 51*D1**2*f*fd*r - 17*D1**2*f*fd*s + 17*D1**2*f*fd - 75*D1**2*f*fdd*r**2 - 75*D1**2*f*fdd*r*s + 75*D1**2*f*fdd*r + 25*D1**2*f*fdd*s - 25*D1**2*f*fdd - 150*D1**2*fd**2*r**2 - 150*D1**2*fd**2*r*s + 150*D1**2*fd**2*r + 50*D1**2*fd**2*s - 25*D1**2*fd**2 + 68*D1*Dd*f**2*r**2 + 68*D1*Dd*f**2*r*s - 51*D1*Dd*f**2*r - 17*D1*Dd*f**2*s + 17*D1*Dd*f**2 - 600*D1*Dd*f*fd*r**2 - 600*D1*Dd*f*fd*r*s + 525*D1*Dd*f*fd*r + 175*D1*Dd*f*fd*s - 100*D1*Dd*f*fd - 100*D1*Ddd*f**2*r**2 - 100*D1*Ddd*f**2*r*s + 75*D1*Ddd*f**2*r + 25*D1*Ddd*f**2*s - 25*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f*(r + s - 1)*(22*C*(r - 1) + 6*r - 1) - fd*(18*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 16*r**2 + 16*r*s - 17*r - 5*s + 4)) - 2*Dd*f*(9*C*(8*r**2 + 8*r*s - 11*r - 5*s + 3) + (4*r - 1)*(4*r + 4*s - 3))) - 300*Dd**2*f**2*r**2 - 300*Dd**2*f**2*r*s + 225*Dd**2*f**2*r + 75*Dd**2*f**2*s - 25*Dd**2*f**2))/(693*d**2*k3**4) + D1**2*Pk2*Pkd1*ct*k1**2*k2*(24*C + 4)*(D1*f*(6*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-4*f*r*(r + s - 1) + 5*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*bdd1*f*r*(r + s - 1) + 5*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + b1**2*(-D1**2*r*(5*fd - 6*fdd)*(r + s) + D1*(Dd*(-5*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 6*fd*(8*r**2 + 8*r*s - 3*r - s)) + 6*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 6*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(6*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 4*D1**2*f*fd*s - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r - 5*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*r - 5*D1**2*fd**2*s - 16*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 80*D1*Dd*f*fd*r*s - 70*D1*Dd*f*fd*r - 30*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 20*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r - 5*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-5*f*(2*r - 1)*(r + s - 1) + 6*fd*(4*r**2 + 4*r*s - 3*r - s)) + 12*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 60*Dd**2*f**2*r**2 + 60*Dd**2*f**2*r*s - 45*Dd**2*f**2*r - 15*Dd**2*f**2*s + 5*Dd**2*f**2))/(21*d**2*k3**4) + D1**2*Pk2*Pkd1*ct*k1**2*st**2*(132*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) - 66*D1*bd1*(2*D1*b1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) - 4*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) + f*(D1*(f*(-12*C*s - 3*r**2 + 2*r*(6*C*s - 2*s + 1) + 8*s - 3) + 2*fd*(4*C*(-4*r*s + r + 2*s - 1) + 5*r**2 + 12*r*s - 7*r - 7*s + 3)) + Dd*f*(-8*C*(8*r*s - r - 5*s + 1) + 20*r**2 + 48*r*s - 23*r - 38*s + 11))) + 132*b1**2*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) - 33*b1*(-2*D1**2*(2*bdd1*f*(r*(2*s - 1) - s) + f*(6*fd*r**2 - 4*fd*r*(C*(6*s - 3) - 2*s + 2) + 4*fd*s - 5*fdd*r**2 + 4*fdd*r*(C*(4*s - 2) - 3*s + 2) - 2*fdd*s) - fd**2*(5*r**2 - 4*r*(4*C*s - 2*C - 3*s + 2) + 2*s)) + D1*f*(-2*Dd*f*(12*r**2 - 2*r*(6*C*(4*s - 1) - 8*s + 5) + s*(12*C - 4) + 3) + 4*Dd*fd*(C*(-8*r*(8*s - 3) + 8*s - 4) + 20*r**2 + 3*r*(16*s - 9) - 2*s + 3) + Ddd*f*(20*r**2 + r*(C*(16 - 64*s) + 48*s - 22) + s*(16*C - 12) + 5)) + 2*Dd**2*f**2*(-8*C*(3*r*(4*s - 1) - 3*s + 1) + 30*r**2 + r*(72*s - 33) - 18*s + 6)) - f*(33*D1**2*bdd1*f*(5*r**2 - 2*r*(s*(8*C - 6) + 3) + s*(16*C - 16) + 5) + D1**2*(f*(-2*fd*(285*r**2 + r*(-268*C*(3*s - 1) + 552*s - 374) + s*(268*C - 184) + 95) + fdd*(483*r**2 - 2*r*(200*C*(3*s - 1) - 672*s + 385) + s*(400*C - 448) + 161)) + 2*fd**2*(-200*C*(r*(6*s - 2) - 2*s + 1) + 483*r**2 + 14*r*(96*s - 55) - 448*s + 224)) + D1*f*(2*Dd*(-f*(380*r**2 + r*(-268*C*(4*s - 1) + 736*s - 374) + s*(268*C - 184) + 95) + fd*(-200*C*(r*(24*s - 7) - 7*s + 2) + 1932*r**2 + 7*r*(768*s - 385) - 1568*s + 609)) + Ddd*f*(644*r**2 - 2*r*(200*C*(4*s - 1) - 896*s + 385) + s*(400*C - 448) + 161)) + 2*Dd**2*f**2*(-200*C*(3*r*(4*s - 1) - 3*s + 1) + 966*r**2 + 21*r*(128*s - 55) - 672*s + 224)))/(693*d**2*k2*k3**2) - D1**2*Pk2*Pkd1*ct*k1**2*(b1**2*(D1**2*r*(-26*fd*r + fd*s*(40*C - 88) + 41*fdd*r + fdd*s*(100 - 48*C)) + D1*(-2*Dd*(f*(20*C*s + 52*r**2 + r*(-80*C*s + 20*C + 176*s - 70) - 44*s + 13) + fd*(-24*C*s - 164*r**2 + r*(24*C*(8*s - 1) - 400*s + 91) + 50*s)) + Ddd*f*(48*C*s + 164*r**2 - 2*r*(96*C*s - 24*C - 200*s + 91) - 100*s + 41)) + 2*Dd**2*f*(-24*C*(3*r*(4*s - 1) - 3*s + 1) + 246*r**2 + 3*r*(200*s - 91) - 150*s + 50)) + b1*(-32*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s + 16*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s + 16*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s - 64*C*D1*Dd*f**2*r*s + 16*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s + 128*C*D1*Dd*f*fd*r*s - 208*C*D1*Dd*f*fd*r + 144*C*D1*Dd*f*fd*s + 8*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r*s - 8*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s + 96*C*Dd**2*f**2*r*s - 24*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s + 8*C*Dd**2*f**2 + D1**2*bdd1*f*(48*C*s + 82*r**2 + r*(-96*C*s + 48*C + 200*s - 182) - 100*s + 41) - 60*D1**2*f*fd*r**2 - 144*D1**2*f*fd*r*s + 60*D1**2*f*fd*r + 72*D1**2*f*fd*s - 30*D1**2*f*fd + 78*D1**2*f*fdd*r**2 + 168*D1**2*f*fdd*r*s - 78*D1**2*f*fdd*r - 84*D1**2*f*fdd*s + 39*D1**2*f*fdd + 78*D1**2*fd**2*r**2 + 168*D1**2*fd**2*r*s - 78*D1**2*fd**2*r - 84*D1**2*fd**2*s - 120*D1*Dd*f**2*r**2 - 288*D1*Dd*f**2*r*s + 132*D1*Dd*f**2*r + 72*D1*Dd*f**2*s - 30*D1*Dd*f**2 + 624*D1*Dd*f*fd*r**2 + 1344*D1*Dd*f*fd*r*s - 636*D1*Dd*f*fd*r - 504*D1*Dd*f*fd*s + 162*D1*Dd*f*fd + 156*D1*Ddd*f**2*r**2 + 336*D1*Ddd*f**2*r*s - 162*D1*Ddd*f**2*r - 84*D1*Ddd*f**2*s + 39*D1*Ddd*f**2 + 2*D1*bd1*(D1*(-f*(20*C*s + 26*r**2 + r*(-40*C*s + 20*C + 88*s - 70) - 44*s + 13) + fd*(82*r**2 + r*(-96*C*s + 24*C + 200*s - 91) + s*(24*C - 50))) + Dd*f*(-48*C*(8*r*s - 3*r - 3*s + 1) + 328*r**2 + 800*r*s - 546*r - 300*s + 141)) + 468*Dd**2*f**2*r**2 + 1008*Dd**2*f**2*r*s - 486*Dd**2*f**2*r - 252*Dd**2*f**2*s + 84*Dd**2*f**2) + f*(8*C*(-5*D1*Dd*f*(f*(r*(4*s - 1) - s) + fd*(r*(7 - 24*s) + 7*s - 2)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) + f*(bdd1*r*(s + 5) - 6*bdd1*s + 5*fdd*r*(3*s - 1) - 5*fdd*s) + 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(4*s - 1) - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 2*D1**2*bd1**2*(24*C*(r*(2*s - 1) - s + 1) - 41*r**2 + r*(91 - 100*s) + 50*s - 50) + 3*D1**2*bdd1*f*r*(13*r + 28*s - 28) + 2*D1*bd1*(D1*(24*C*f*s + 4*C*fd*(4*r*(s + 1) - 7*s + 1) - 15*f*r**2 - 4*f*r*(2*C*(s + 2) + 9*s - 9) + 3*fd*(26*r**2 + 56*r*s - 41*r - 14*s + 14)) + Dd*f*(4*C*(8*r*s + 19*r - 25*s + 1) + 156*r**2 + 336*r*s - 249*r - 42*s + 42))))/(21*d**2*k2*k3**2) + D1**2*Pk2*Pkd1*ct*k2**3*st**2*(4*C + 2)*(D1*f*(3*D1*bd1**2*(2*r - 1)*(r + s - 1) + D1*bd1*(-5*f*r*(r + s - 1) + 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*D1*bdd1*f*r*(r + s - 1) + 3*Dd*bd1*f*(8*r**2 + r*(8*s - 7) - s + 1)) + b1**2*(-D1**2*r*(13*fd - 3*fdd)*(r + s) + D1*(Dd*(-13*f*(4*r**2 + 4*r*s - 3*r - s + 1) + 3*fd*(8*r**2 + 8*r*s - 3*r - s)) + 3*Ddd*f*(4*r**2 + r*(4*s - 3) - s + 1)) + 3*Dd**2*f*(12*r**2 + 3*r*(4*s - 3) - 3*s + 1)) + b1*(3*D1**2*bdd1*f*(2*r - 1)*(r + s - 1) - 10*D1**2*f*fd*r**2 - 10*D1**2*f*fd*r*s + 10*D1**2*f*fd*r + 5*D1**2*f*fd*s - 5*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 3*D1**2*fd**2*s - 20*D1*Dd*f**2*r**2 - 20*D1*Dd*f**2*r*s + 15*D1*Dd*f**2*r + 5*D1*Dd*f**2*s - 5*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 42*D1*Dd*f*fd*r - 18*D1*Dd*f*fd*s + 9*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s - 9*D1*Ddd*f**2*r - 3*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + D1*bd1*(D1*(-13*f*(2*r - 1)*(r + s - 1) + 3*fd*(4*r**2 + 4*r*s - 3*r - s)) + 6*Dd*f*(8*r**2 + r*(8*s - 9) - 3*s + 2)) + 36*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s - 27*Dd**2*f**2*r - 9*Dd**2*f**2*s + 3*Dd**2*f**2))/(21*d**2*k3**4) + D1**2*Pk2*Pkd1*ct*k2*st**4*(-1056*C*D1**2*b1*f*fd*r*s + 528*C*D1**2*b1*f*fd*r - 96*C*D1**2*f**2*fd*r**2 - 288*C*D1**2*f**2*fd*r*s + 160*C*D1**2*f**2*fd*r + 96*C*D1**2*f**2*fd*s - 32*C*D1**2*f**2*fd + 48*C*D1**2*f**2*fdd*r**2 + 144*C*D1**2*f**2*fdd*r*s - 80*C*D1**2*f**2*fdd*r - 48*C*D1**2*f**2*fdd*s + 16*C*D1**2*f**2*fdd + 96*C*D1**2*f*fd**2*r**2 + 288*C*D1**2*f*fd**2*r*s - 160*C*D1**2*f*fd**2*r - 96*C*D1**2*f*fd**2*s + 48*C*D1**2*f*fd**2 - 2112*C*D1*Dd*b1*f**2*r*s + 528*C*D1*Dd*b1*f**2*r + 528*C*D1*Dd*b1*f**2*s - 128*C*D1*Dd*f**3*r**2 - 384*C*D1*Dd*f**3*r*s + 160*C*D1*Dd*f**3*r + 96*C*D1*Dd*f**3*s - 32*C*D1*Dd*f**3 + 384*C*D1*Dd*f**2*fd*r**2 + 1152*C*D1*Dd*f**2*fd*r*s - 560*C*D1*Dd*f**2*fd*r - 336*C*D1*Dd*f**2*fd*s + 128*C*D1*Dd*f**2*fd + 64*C*D1*Ddd*f**3*r**2 + 192*C*D1*Ddd*f**3*r*s - 80*C*D1*Ddd*f**3*r - 48*C*D1*Ddd*f**3*s + 16*C*D1*Ddd*f**3 + 192*C*Dd**2*f**3*r**2 + 576*C*Dd**2*f**3*r*s - 240*C*Dd**2*f**3*r - 144*C*Dd**2*f**3*s + 48*C*Dd**2*f**3 + 132*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*fd**2*r**2 + 33*D1**2*bdd1*f**2*(r - 1)**2 + 126*D1**2*f**2*fd*r**2 - 84*D1**2*f**2*fd*r + 42*D1**2*f**2*fd - 63*D1**2*f**2*fdd*r**2 + 42*D1**2*f**2*fdd*r - 21*D1**2*f**2*fdd - 126*D1**2*f*fd**2*r**2 + 84*D1**2*f*fd**2*r + 264*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 + 528*D1*Dd*b1*f*fd*r**2 - 132*D1*Dd*b1*f*fd*r + 168*D1*Dd*f**3*r**2 - 84*D1*Dd*f**3*r + 42*D1*Dd*f**3 - 504*D1*Dd*f**2*fd*r**2 + 294*D1*Dd*f**2*fd*r - 42*D1*Dd*f**2*fd + 132*D1*Ddd*b1*f**2*r**2 - 66*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2 - 84*D1*Ddd*f**3*r**2 + 42*D1*Ddd*f**3*r - 21*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(D1*f*(-8*C*s + r + 4*s - 1) + 2*D1*fd*r + Dd*f*(4*r - 1)) + 396*Dd**2*b1*f**2*r**2 - 198*Dd**2*b1*f**2*r - 252*Dd**2*f**3*r**2 + 126*Dd**2*f**3*r)/(231*d**2*k3**2) - D1**2*Pk2*Pkd1*ct*k2*st**2*(11*b1**2*(D1**2*r*(fd*r*(16*C - 28) + fd*s*(36*C - 36) + fdd*r*(7 - 8*C) - fdd*s*(4*C - 4)) + D1*(2*Dd*(2*f*(C*(16*r**2 + 36*r*s - 17*r - 9*s + 4) - 28*r**2 - 36*r*s + 23*r + 9*s - 7) + fd*(r**2*(28 - 32*C) + r*(-16*C*s + 10*C + 16*s - 9) + s*(2*C - 2))) + Ddd*f*(-4*C*(8*r**2 + r*(4*s - 5) - s + 2) + 28*r**2 + 2*r*(8*s - 9) - 4*s + 7)) + 2*Dd**2*f*(C*(-48*r**2 - 6*r*(4*s - 5) + 6*s - 2) + 42*r**2 + 3*r*(8*s - 9) - 6*s + 2)) + 11*b1*(32*C*D1**2*f*fd*r**2 - 40*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r - 4*C*D1**2*f*fd*s + 16*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r**2 + 40*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r + 4*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r**2 + 40*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r + 4*C*D1**2*fd**2*s + 64*C*D1*Dd*f**2*r**2 - 80*C*D1*Dd*f**2*r*s - 12*C*D1*Dd*f**2*r + 20*C*D1*Dd*f**2*s + 16*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r**2 + 320*C*D1*Dd*f*fd*r*s - 88*C*D1*Dd*f*fd*r - 24*C*D1*Dd*f*fd*s + 4*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r**2 + 80*C*D1*Ddd*f**2*r*s - 28*C*D1*Ddd*f**2*r - 20*C*D1*Ddd*f**2*s + 4*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r**2 + 240*C*Dd**2*f**2*r*s - 84*C*Dd**2*f**2*r - 60*C*Dd**2*f**2*s + 20*C*Dd**2*f**2 + D1**2*bdd1*f*(-4*C*(4*r**2 + 2*r*s - 5*r - s + 2) + 14*r**2 + 8*r*s - 18*r - 4*s + 7) - 48*D1**2*f*fd*r**2 - 32*D1**2*f*fd*r*s + 52*D1**2*f*fd*r + 4*D1**2*f*fd*s - 20*D1**2*f*fd + 28*D1**2*f*fdd*r**2 + 32*D1**2*f*fdd*r*s - 34*D1**2*f*fdd*r - 4*D1**2*f*fdd*s + 11*D1**2*f*fdd + 28*D1**2*fd**2*r**2 + 32*D1**2*fd**2*r*s - 34*D1**2*fd**2*r - 4*D1**2*fd**2*s - 96*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 64*D1*Dd*f**2*r + 16*D1*Dd*f**2*s - 24*D1*Dd*f**2 + 224*D1*Dd*f*fd*r**2 + 256*D1*Dd*f*fd*r*s - 224*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s + 38*D1*Dd*f*fd + 56*D1*Ddd*f**2*r**2 + 64*D1*Ddd*f**2*r*s - 44*D1*Ddd*f**2*r - 16*D1*Ddd*f**2*s + 14*D1*Ddd*f**2 + 2*D1*bd1*(D1*(2*f*(C*(8*r**2 + 18*r*s - 17*r - 9*s + 4) - 14*r**2 - 18*r*s + 23*r + 9*s - 7) + fd*(r**2*(14 - 16*C) + r*(-8*C*s + 10*C + 8*s - 9) + s*(2*C - 2))) + Dd*f*(-4*C*(16*r**2 + 8*r*s - 15*r - 3*s + 3) + 56*r**2 + 32*r*s - 54*r - 12*s + 11)) + 168*Dd**2*f**2*r**2 + 192*Dd**2*f**2*r*s - 132*Dd**2*f**2*r - 48*Dd**2*f**2*s + 16*Dd**2*f**2) + f*(-480*C*D1**2*f*fd*r**2 - 792*C*D1**2*f*fd*r*s + 584*C*D1**2*f*fd*r + 264*C*D1**2*f*fd*s - 160*C*D1**2*f*fd + 636*C*D1**2*f*fdd*r**2 + 792*C*D1**2*f*fdd*r*s - 688*C*D1**2*f*fdd*r - 264*C*D1**2*f*fdd*s + 212*C*D1**2*f*fdd + 1272*C*D1**2*fd**2*r**2 + 1584*C*D1**2*fd**2*r*s - 1376*C*D1**2*fd**2*r - 528*C*D1**2*fd**2*s + 264*C*D1**2*fd**2 - 640*C*D1*Dd*f**2*r**2 - 1056*C*D1*Dd*f**2*r*s + 584*C*D1*Dd*f**2*r + 264*C*D1*Dd*f**2*s - 160*C*D1*Dd*f**2 + 5088*C*D1*Dd*f*fd*r**2 + 6336*C*D1*Dd*f*fd*r*s - 4816*C*D1*Dd*f*fd*r - 1848*C*D1*Dd*f*fd*s + 952*C*D1*Dd*f*fd + 848*C*D1*Ddd*f**2*r**2 + 1056*C*D1*Ddd*f**2*r*s - 688*C*D1*Ddd*f**2*r - 264*C*D1*Ddd*f**2*s + 212*C*D1*Ddd*f**2 + 2544*C*Dd**2*f**2*r**2 + 3168*C*Dd**2*f**2*r*s - 2064*C*Dd**2*f**2*r - 792*C*Dd**2*f**2*s + 264*C*Dd**2*f**2 - 22*D1**2*bd1**2*(2*C*(4*r**2 + r*(2*s - 5) - s + 1) - 7*r**2 - 4*r*s + 9*r + 2*s - 2) + 11*D1**2*bdd1*f*(4*C*(r**2 + 5*r*(s - 1) - 6*s + 3) + 14*r**2 + 2*r*(8*s - 5) - 12*s + 3) - 156*D1**2*f*fd*r**2 - 300*D1**2*f*fd*r*s + 204*D1**2*f*fd*r + 100*D1**2*f*fd*s - 52*D1**2*f*fd + 111*D1**2*f*fdd*r**2 + 348*D1**2*f*fdd*r*s - 190*D1**2*f*fdd*r - 116*D1**2*f*fdd*s + 37*D1**2*f*fdd + 222*D1**2*fd**2*r**2 + 696*D1**2*fd**2*r*s - 380*D1**2*fd**2*r - 232*D1**2*fd**2*s + 116*D1**2*fd**2 - 208*D1*Dd*f**2*r**2 - 400*D1*Dd*f**2*r*s + 204*D1*Dd*f**2*r + 100*D1*Dd*f**2*s - 52*D1*Dd*f**2 + 888*D1*Dd*f*fd*r**2 + 2784*D1*Dd*f*fd*r*s - 1330*D1*Dd*f*fd*r - 812*D1*Dd*f*fd*s + 306*D1*Dd*f*fd + 148*D1*Ddd*f**2*r**2 + 464*D1*Ddd*f**2*r*s - 190*D1*Ddd*f**2*r - 116*D1*Ddd*f**2*s + 37*D1*Ddd*f**2 + 22*D1*bd1*(D1*(2*f*(6*C*s + r**2*(4*C - 6) - r*(5*C*s + C + 4*s - 3) + 3*s - 1) + fd*(2*C*(4*r**2 + 4*r*(5*s - 3) - 11*s + 5) + 28*r**2 + 32*r*s - 27*r - 14*s + 8)) + Dd*f*(2*C*(8*r**2 + 40*r*s - 27*r - 29*s + 11) + 56*r**2 + 64*r*s - 42*r - 32*s + 11)) + 444*Dd**2*f**2*r**2 + 1392*Dd**2*f**2*r*s - 570*Dd**2*f**2*r - 348*Dd**2*f**2*s + 116*Dd**2*f**2))/(231*d**2*k3**2) + D1**2*Pk2*Pkd1*ct*k2*(D1*f*(-2*D1*bd1**2*(4*C*(15*r**2 + 2*r*(7*s - 11) - 7*s + 7) + 17*r**2 + 52*r*s - 43*r - 26*s + 26) - D1*bdd1*f*r*(68*C*r + 48*C*(s - 1) + 19*r + 44*s - 44) - 2*bd1*(D1*(-f*r*(4*C*(5*r + 6*s - 6) + 7*r + 20*s - 20) + fd*(4*C*(34*r**2 + 24*r*s - 29*r - 6*s + 6) + 38*r**2 + 88*r*s - 63*r - 22*s + 22)) + Dd*f*(4*C*(68*r**2 + 48*r*s - 47*r - 6*s + 6) + 76*r**2 + 176*r*s - 129*r - 22*s + 22))) + b1**2*(D1**2*r*(fd*r*(8*C + 6) + fd*s*(56*C + 48) - fdd*(60*C*r + 56*C*s + 17*r + 52*s)) + D1*(2*Dd*(4*C*f*(4*r**2 + r*(28*s - 9) - 7*s + 1) + 3*f*(4*r**2 + 2*r*(16*s - 5) - 8*s + 1) + fd*r**2*(-240*C - 68) + fd*r*(C*(88 - 224*s) - 208*s + 43) + fd*s*(28*C + 26)) - Ddd*f*(4*C*(60*r**2 + 56*r*s - 44*r - 14*s + 15) + 68*r**2 + 208*r*s - 86*r - 52*s + 17)) - 2*Dd**2*f*(4*C*(90*r**2 + 84*r*s - 66*r - 21*s + 7) + 102*r**2 + 312*r*s - 129*r - 78*s + 26)) + b1*(80*C*D1**2*f*fd*r**2 + 96*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s + 40*C*D1**2*f*fd - 136*C*D1**2*f*fdd*r**2 - 96*C*D1**2*f*fdd*r*s + 136*C*D1**2*f*fdd*r + 48*C*D1**2*f*fdd*s - 68*C*D1**2*f*fdd - 136*C*D1**2*fd**2*r**2 - 96*C*D1**2*fd**2*r*s + 136*C*D1**2*fd**2*r + 48*C*D1**2*fd**2*s + 160*C*D1*Dd*f**2*r**2 + 192*C*D1*Dd*f**2*r*s - 128*C*D1*Dd*f**2*r - 48*C*D1*Dd*f**2*s + 40*C*D1*Dd*f**2 - 1088*C*D1*Dd*f*fd*r**2 - 768*C*D1*Dd*f*fd*r*s + 912*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s - 184*C*D1*Dd*f*fd - 272*C*D1*Ddd*f**2*r**2 - 192*C*D1*Ddd*f**2*r*s + 184*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s - 68*C*D1*Ddd*f**2 - 816*C*Dd**2*f**2*r**2 - 576*C*Dd**2*f**2*r*s + 552*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s - 48*C*Dd**2*f**2 - D1**2*bdd1*f*(4*C*(30*r**2 + 4*r*(7*s - 11) - 14*s + 15) + 34*r**2 + 2*r*(52*s - 43) - 52*s + 17) + 28*D1**2*f*fd*r**2 + 80*D1**2*f*fd*r*s - 28*D1**2*f*fd*r - 40*D1**2*f*fd*s + 14*D1**2*f*fd - 38*D1**2*f*fdd*r**2 - 88*D1**2*f*fdd*r*s + 38*D1**2*f*fdd*r + 44*D1**2*f*fdd*s - 19*D1**2*f*fdd - 38*D1**2*fd**2*r**2 - 88*D1**2*fd**2*r*s + 38*D1**2*fd**2*r + 44*D1**2*fd**2*s + 56*D1*Dd*f**2*r**2 + 160*D1*Dd*f**2*r*s - 68*D1*Dd*f**2*r - 40*D1*Dd*f**2*s + 14*D1*Dd*f**2 - 304*D1*Dd*f*fd*r**2 - 704*D1*Dd*f*fd*r*s + 316*D1*Dd*f*fd*r + 264*D1*Dd*f*fd*s - 82*D1*Dd*f*fd - 76*D1*Ddd*f**2*r**2 - 176*D1*Ddd*f**2*r*s + 82*D1*Ddd*f**2*r + 44*D1*Ddd*f**2*s - 19*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(4*C*(2*r**2 + r*(14*s - 9) - 7*s + 1) + 6*r**2 + 6*r*(8*s - 5) - 24*s + 3) + fd*(r**2*(-120*C - 34) + r*(C*(88 - 112*s) - 104*s + 43) + s*(28*C + 26))) - Dd*f*(4*C*(120*r**2 + 4*r*(28*s - 33) - 42*s + 29) + 136*r**2 + r*(416*s - 258) - 156*s + 69)) - 228*Dd**2*f**2*r**2 - 528*Dd**2*f**2*r*s + 246*Dd**2*f**2*r + 132*Dd**2*f**2*s - 44*Dd**2*f**2))/(21*d**2*k3**2) - D1**2*Pk2*Pkd1*ct*st**2*(-2288*D1**2*K*bd1**2*f*r*s + 1144*D1**2*K*bd1**2*f*s + 1716*D1**2*K*bd1*f**2*r*s - 4576*D1**2*K*bd1*f*fd*r*s + 1144*D1**2*K*bd1*f*fd*r + 1144*D1**2*K*bd1*f*fd*s - 1144*D1**2*K*bdd1*f**2*r*s + 858*D1**2*bd1**2*f**2*r**2 - 3432*D1**2*bd1**2*f**2*r*s + 1716*D1**2*bd1**2*f**2*r + 858*D1**2*bd1**2*f**2*s - 1716*D1**2*bd1**2*f**2 - 286*D1**2*bd1**2*f*r**2 - 1144*D1**2*bd1**2*f*r*s + 286*D1**2*bd1**2*f*r + 572*D1**2*bd1**2*f*s - 1716*D1**2*bd1*bd2*f*r*s + 858*D1**2*bd1*bd2*f*s - 1040*D1**2*bd1*f**3*r**2 - 2106*D1**2*bd1*f**3*r*s - 988*D1**2*bd1*f**3*r + 3432*D1**2*bd1*f**3*s - 520*D1**2*bd1*f**3 + 8268*D1**2*bd1*f**2*fd*r**2 + 19188*D1**2*bd1*f**2*fd*r*s - 6110*D1**2*bd1*f**2*fd*r - 10062*D1**2*bd1*f**2*fd*s + 2132*D1**2*bd1*f**2*fd - 572*D1**2*bd1*f**2*r**2 + 1144*D1**2*bd1*f**2*r*s + 1716*D1**2*bd1*f*fd*r**2 - 2288*D1**2*bd1*f*fd*r*s - 286*D1**2*bd1*f*fd*r + 572*D1**2*bd1*f*fd*s - 12584*D1**2*bd1*f*g2*r*s + 12584*D1**2*bd1*f*g2*s + 4576*D1**2*bd1*f*gd2*r*s - 2288*D1**2*bd1*f*gd2*s + 4576*D1**2*bd1*fd*g2*r*s - 2288*D1**2*bd1*fd*g2*r - 2288*D1**2*bd1*fd*g2*s + 2288*D1**2*bd1*fd*g2 + 1430*D1**2*bd2*f**2*r*s - 3432*D1**2*bd2*f*fd*r*s + 858*D1**2*bd2*f*fd*r + 858*D1**2*bd2*f*fd*s + 1378*D1**2*bdd1*f**3*r**2 + 3198*D1**2*bdd1*f**3*r*s - 78*D1**2*bdd1*f**3*r - 3432*D1**2*bdd1*f**3*s + 689*D1**2*bdd1*f**3 + 429*D1**2*bdd1*f**2*r**2 - 572*D1**2*bdd1*f**2*r*s + 2288*D1**2*bdd1*f*g2*r*s - 2288*D1**2*bdd1*f*g2*s - 858*D1**2*bdd2*f**2*r*s - 2880*D1**2*f**3*fd*r**2 - 10400*D1**2*f**3*fd*r*s + 4040*D1**2*f**3*fd*r + 2600*D1**2*f**3*fd*s - 720*D1**2*f**3*fd + 2740*D1**2*f**3*fdd*r**2 + 10400*D1**2*f**3*fdd*r*s - 3970*D1**2*f**3*fdd*r - 2600*D1**2*f**3*fdd*s + 685*D1**2*f**3*fdd + 8220*D1**2*f**2*fd**2*r**2 + 31200*D1**2*f**2*fd**2*r*s - 11910*D1**2*f**2*fd**2*r - 7800*D1**2*f**2*fd**2*s + 2600*D1**2*f**2*fd**2 - 3432*D1**2*f**2*gd2*r*s + 2288*D1**2*f**2*gdd2*r*s - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r + 3432*D1**2*f*fd*g2*s + 9152*D1**2*f*fd*gd2*r*s - 2288*D1**2*f*fd*gd2*r - 2288*D1**2*f*fd*gd2*s + 4576*D1**2*f*fdd*g2*r*s - 2288*D1**2*f*fdd*g2*r - 2288*D1**2*f*fdd*g2*s + 4576*D1**2*fd**2*g2*r*s - 2288*D1**2*fd**2*g2*r - 2288*D1**2*fd**2*g2*s + 2288*D1**2*fd**2*g2 - 9152*D1*Dd*K*bd1*f**2*r*s + 1144*D1*Dd*K*bd1*f**2*r + 1144*D1*Dd*K*bd1*f**2*s + 11024*D1*Dd*bd1*f**3*r**2 + 25584*D1*Dd*bd1*f**3*r*s - 6266*D1*Dd*bd1*f**3*r - 16926*D1*Dd*bd1*f**3*s + 3510*D1*Dd*bd1*f**3 + 3432*D1*Dd*bd1*f**2*r**2 - 4576*D1*Dd*bd1*f**2*r*s - 286*D1*Dd*bd1*f**2*r + 572*D1*Dd*bd1*f**2*s + 18304*D1*Dd*bd1*f*g2*r*s - 2288*D1*Dd*bd1*f*g2*r - 11440*D1*Dd*bd1*f*g2*s + 2288*D1*Dd*bd1*f*g2 - 6864*D1*Dd*bd2*f**2*r*s + 858*D1*Dd*bd2*f**2*r + 858*D1*Dd*bd2*f**2*s - 2880*D1*Dd*f**4*r**2 - 10400*D1*Dd*f**4*r*s + 4040*D1*Dd*f**4*r + 2600*D1*Dd*f**4*s - 720*D1*Dd*f**4 + 21920*D1*Dd*f**3*fd*r**2 + 83200*D1*Dd*f**3*fd*r*s - 31760*D1*Dd*f**3*fd*r - 20800*D1*Dd*f**3*fd*s + 6570*D1*Dd*f**3*fd - 13728*D1*Dd*f**2*g2*r*s + 3432*D1*Dd*f**2*g2*r + 3432*D1*Dd*f**2*g2*s + 18304*D1*Dd*f**2*gd2*r*s - 2288*D1*Dd*f**2*gd2*r - 2288*D1*Dd*f**2*gd2*s + 36608*D1*Dd*f*fd*g2*r*s - 13728*D1*Dd*f*fd*g2*r - 13728*D1*Dd*f*fd*g2*s + 4576*D1*Dd*f*fd*g2 + 2740*D1*Ddd*f**4*r**2 + 10400*D1*Ddd*f**4*r*s - 3970*D1*Ddd*f**4*r - 2600*D1*Ddd*f**4*s + 685*D1*Ddd*f**4 + 9152*D1*Ddd*f**2*g2*r*s - 2288*D1*Ddd*f**2*g2*r - 2288*D1*Ddd*f**2*g2*s + 8220*Dd**2*f**4*r**2 + 31200*Dd**2*f**4*r*s - 11910*Dd**2*f**4*r - 7800*Dd**2*f**4*s + 2600*Dd**2*f**4 + 27456*Dd**2*f**2*g2*r*s - 6864*Dd**2*f**2*g2*r - 6864*Dd**2*f**2*g2*s + 2288*Dd**2*f**2*g2 - 286*b1**3*(D1*Dd*(13*f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) + D1*(D1*r*s*(-13*fd + 3*fdd) + 3*Ddd*f*(r*(4*s - 1) - s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 143*b1**2*(D1**2*(44*K*fd*r*s - 44*K*fd*r - 8*K*fdd*r*s + 8*K*fdd*r + 26*bd1*f*(r*(3*s - 1) - s) + 6*bd1*fd*(-6*r*s + r + s) + 6*bdd1*f*(-3*r*s + r + s) + 56*f*fd*r*s + 2*f*fd*r - 10*f*fd*s + 6*f*fdd*r**2 - 24*f*fdd*r*s - 6*f*fdd*r + 6*f*fdd*s + 6*fd**2*r**2 - 24*fd**2*r*s - 6*fd**2*r + 6*fd**2*s - 12*fd*r**2 + 8*fd*r*s - 8*fd*r - fdd*r**2 - 4*fdd*r*s + 4*fdd*r) + D1*(2*Dd*(14*f**2*(r*(4*s - 1) - s) - f*(22*K*s + 3*bd1*(r*(24*s - 7) - 7*s + 2) - 24*fd*s - r**2*(24*fd - 24) + 2*r*(-44*K*s + 11*K + 48*fd*s + 3*fd - 8*s - 4) + 4*s + 6) + fd*(-4*K*(r*(8*s - 5) - s + 1) - 4*r**2 - 16*r*s + 11*r + 2*s - 2)) + Ddd*f*(8*K*s + 3*f*(4*r**2 + r*(2 - 16*s) + 4*s + 1) - 4*r**2 + r*(-32*K*s + 8*K - 16*s + 6) + 4*s - 1)) + 2*Dd**2*f*(-4*K*(12*r*s - 3*r - 3*s + 1) + 3*f*(6*r**2 + r*(3 - 24*s) + 6*s - 2) - 6*r**2 - 24*r*s + 9*r + 6*s - 2)) - 13*b1*(-264*D1**2*K*f*fd*r*s + 132*D1**2*K*f*fd*r + 132*D1**2*K*f*fd*s + 176*D1**2*K*f*fdd*r*s - 88*D1**2*K*f*fdd*r - 88*D1**2*K*f*fdd*s + 176*D1**2*K*fd**2*r*s - 88*D1**2*K*fd**2*r - 88*D1**2*K*fd**2*s + 88*D1**2*K*fd**2 - 286*D1**2*b2*fd*r*s + 286*D1**2*b2*fd*r + 66*D1**2*b2*fdd*r*s - 66*D1**2*b2*fdd*r + 66*D1**2*bd1**2*f*(r*(6*s - 2) - 2*s + 1) - 286*D1**2*bd2*f*r*s + 132*D1**2*bd2*fd*r*s - 66*D1**2*bd2*fd*r - 11*D1**2*bdd1*f*(8*K*s + 3*f*(2*r**2 + r*(4 - 8*s) + 2*s + 1) - 2*r**2 - 2*r*(8*K*s + 4*s - 1) + 4*s - 1) + 66*D1**2*bdd2*f*r*s + 240*D1**2*f**2*fd*r**2 + 486*D1**2*f**2*fd*r*s - 398*D1**2*f**2*fd*r + 102*D1**2*f**2*fd*s + 40*D1**2*f**2*fd - 318*D1**2*f**2*fdd*r**2 - 738*D1**2*f**2*fdd*r*s + 452*D1**2*f**2*fdd*r - 18*D1**2*f**2*fdd*s - 53*D1**2*f**2*fdd - 636*D1**2*f*fd**2*r**2 - 1476*D1**2*f*fd**2*r*s + 904*D1**2*f*fd**2*r - 36*D1**2*f*fd**2*s - 82*D1**2*f*fd**2 + 88*D1**2*f*fd*r**2 - 176*D1**2*f*fd*r*s + 88*D1**2*f*fd*s + 44*D1**2*f*fd - 66*D1**2*f*fdd*r**2 + 88*D1**2*f*fdd*r*s + 22*D1**2*f*fdd*r - 44*D1**2*f*fdd*s - 33*D1**2*f*fdd + 968*D1**2*f*gd2*r*s - 176*D1**2*f*gdd2*r*s - 66*D1**2*fd**2*r**2 + 88*D1**2*fd**2*r*s + 22*D1**2*fd**2*r - 44*D1**2*fd**2*s + 44*D1**2*fd**2 + 968*D1**2*fd*g2*r*s - 968*D1**2*fd*g2*r - 352*D1**2*fd*gd2*r*s + 176*D1**2*fd*gd2*r - 176*D1**2*fdd*g2*r*s + 176*D1**2*fdd*g2*r - 528*D1*Dd*K*f**2*r*s + 132*D1*Dd*K*f**2*r + 132*D1*Dd*K*f**2*s + 1408*D1*Dd*K*f*fd*r*s - 528*D1*Dd*K*f*fd*r - 528*D1*Dd*K*f*fd*s + 176*D1*Dd*K*f*fd - 1144*D1*Dd*b2*f*r*s + 286*D1*Dd*b2*f*r + 286*D1*Dd*b2*f*s + 528*D1*Dd*b2*fd*r*s - 330*D1*Dd*b2*fd*r - 66*D1*Dd*b2*fd*s + 66*D1*Dd*b2*fd + 528*D1*Dd*bd2*f*r*s - 66*D1*Dd*bd2*f*r - 66*D1*Dd*bd2*f*s + 320*D1*Dd*f**3*r**2 + 648*D1*Dd*f**3*r*s - 322*D1*Dd*f**3*r - 162*D1*Dd*f**3*s + 80*D1*Dd*f**3 - 2544*D1*Dd*f**2*fd*r**2 - 5904*D1*Dd*f**2*fd*r*s + 3182*D1*Dd*f**2*fd*r + 666*D1*Dd*f**2*fd*s - 434*D1*Dd*f**2*fd + 176*D1*Dd*f**2*r**2 - 352*D1*Dd*f**2*r*s + 88*D1*Dd*f**2*s + 44*D1*Dd*f**2 - 528*D1*Dd*f*fd*r**2 + 704*D1*Dd*f*fd*r*s + 132*D1*Dd*f*fd*r - 264*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 3872*D1*Dd*f*g2*r*s - 968*D1*Dd*f*g2*r - 968*D1*Dd*f*g2*s - 1408*D1*Dd*f*gd2*r*s + 176*D1*Dd*f*gd2*r + 176*D1*Dd*f*gd2*s - 1408*D1*Dd*fd*g2*r*s + 880*D1*Dd*fd*g2*r + 176*D1*Dd*fd*g2*s - 176*D1*Dd*fd*g2 + 352*D1*Ddd*K*f**2*r*s - 88*D1*Ddd*K*f**2*r - 88*D1*Ddd*K*f**2*s + 264*D1*Ddd*b2*f*r*s - 66*D1*Ddd*b2*f*r - 66*D1*Ddd*b2*f*s - 424*D1*Ddd*f**3*r**2 - 984*D1*Ddd*f**3*r*s + 458*D1*Ddd*f**3*r + 246*D1*Ddd*f**3*s - 106*D1*Ddd*f**3 - 132*D1*Ddd*f**2*r**2 + 176*D1*Ddd*f**2*r*s + 22*D1*Ddd*f**2*r - 44*D1*Ddd*f**2*s - 33*D1*Ddd*f**2 - 704*D1*Ddd*f*g2*r*s + 176*D1*Ddd*f*g2*r + 176*D1*Ddd*f*g2*s - 22*D1*bd1*(D1*(f**2*(r*(28*s - 15) - 9*s) + 2*f*(r**2*(6*fd - 6) + r*(22*K*s + fd*(3 - 24*s) + 4*s + 6) + s*(-11*K + 6*fd - 2) - 3) + fd*(4*K*(r*(2 - 4*s) + s - 1) - 2*r**2 - 8*r*s + 5*r + 2*s - 2)) + Dd*f*(K*(-64*r*s + 8*r + 24*s - 4) + 3*f*(4*r - 1)*(2*r - 8*s + 3) - 8*r**2 - 32*r*s + 10*r + 12*s - 3)) + 1056*Dd**2*K*f**2*r*s - 264*Dd**2*K*f**2*r - 264*Dd**2*K*f**2*s + 88*Dd**2*K*f**2 + 792*Dd**2*b2*f*r*s - 198*Dd**2*b2*f*r - 198*Dd**2*b2*f*s + 66*Dd**2*b2*f - 1272*Dd**2*f**3*r**2 - 2952*Dd**2*f**3*r*s + 1374*Dd**2*f**3*r + 738*Dd**2*f**3*s - 246*Dd**2*f**3 - 396*Dd**2*f**2*r**2 + 528*Dd**2*f**2*r*s + 66*Dd**2*f**2*r - 132*Dd**2*f**2*s + 44*Dd**2*f**2 - 2112*Dd**2*f*g2*r*s + 528*Dd**2*f*g2*r + 528*Dd**2*f*g2*s - 176*Dd**2*f*g2) + 286*b2*(D1*Dd*f*(5*f*(4*r*s - r - s) - 6*fd*(8*r*s - 3*r - 3*s + 1)) + D1*bd1*(D1*(13*f*s*(r - 1) + 3*fd*(-2*r*s + r + s - 1)) - 3*Dd*f*(r*(8*s - 1) - 5*s + 1)) + D1*(D1*(-3*bdd1*f*s*(r - 1) + 5*f*fd*r*(2*s - 1) - 5*f*fd*s + 3*f*fdd*(-2*r*s + r + s) + 3*fd**2*(-2*r*s + r + s - 1)) + 3*Ddd*f**2*(-4*r*s + r + s)) - 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(3003*d**2*k2) + D1**2*Pk2*Pkd1*ct*(-88*D1**2*K*bd1**2*f*r*s - 264*D1**2*K*bd1**2*f*r + 308*D1**2*K*bd1**2*f*s + 264*D1**2*K*bd1*f**2*r*s - 1056*D1**2*K*bd1*f*fd*r*s + 264*D1**2*K*bd1*f*fd*r + 264*D1**2*K*bd1*f*fd*s - 264*D1**2*K*bdd1*f**2*r*s - 748*D1**2*bd1**2*f**2*r**2 - 2112*D1**2*bd1**2*f**2*r*s + 1166*D1**2*bd1**2*f**2*r + 792*D1**2*bd1**2*f**2*s - 528*D1**2*bd1**2*f**2 - 374*D1**2*bd1**2*f*r**2 - 1144*D1**2*bd1**2*f*r*s + 264*D1**2*bd1**2*f*r + 308*D1**2*bd1**2*f*s - 1232*D1**2*bd1**2*g2*r*s + 616*D1**2*bd1**2*g2*r + 616*D1**2*bd1**2*g2*s - 616*D1**2*bd1**2*g2 - 616*D1**2*bd1*bd2*f*r*s + 308*D1**2*bd1*bd2*f*s + 150*D1**2*bd1*f**3*r**2 + 660*D1**2*bd1*f**3*r*s - 440*D1**2*bd1*f**3*r - 1110*D1**2*bd1*f**2*fd*r**2 - 3960*D1**2*bd1*f**2*fd*r*s + 1910*D1**2*bd1*f**2*fd*r + 660*D1**2*bd1*f**2*fd*s - 440*D1**2*bd1*f**2*fd + 264*D1**2*bd1*f**2*r*s - 1056*D1**2*bd1*f*fd*r*s + 264*D1**2*bd1*f*fd*r + 264*D1**2*bd1*f*fd*s - 176*D1**2*bd1*f*g2*r*s - 440*D1**2*bd1*f*g2*r + 616*D1**2*bd1*f*g2*s + 176*D1**2*bd1*f*gd2*r*s + 528*D1**2*bd1*f*gd2*r - 616*D1**2*bd1*f*gd2*s + 176*D1**2*bd1*fd*g2*r*s - 88*D1**2*bd1*fd*g2*r - 88*D1**2*bd1*fd*g2*s + 88*D1**2*bd1*fd*g2 + 264*D1**2*bd2*f**2*r*s - 1056*D1**2*bd2*f*fd*r*s + 264*D1**2*bd2*f*fd*r + 264*D1**2*bd2*f*fd*s - 185*D1**2*bdd1*f**3*r**2 - 660*D1**2*bdd1*f**3*r*s + 440*D1**2*bdd1*f**3*r - 264*D1**2*bdd1*f**2*r*s + 88*D1**2*bdd1*f*g2*r*s + 528*D1**2*bdd1*f*g2*r - 616*D1**2*bdd1*f*g2*s - 264*D1**2*bdd2*f**2*r*s - 528*D1**2*f**2*gd2*r*s + 528*D1**2*f**2*gdd2*r*s - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s + 2112*D1**2*f*fd*gd2*r*s - 528*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s + 1056*D1**2*f*fdd*g2*r*s - 528*D1**2*f*fdd*g2*r - 528*D1**2*f*fdd*g2*s + 1056*D1**2*fd**2*g2*r*s - 528*D1**2*fd**2*g2*r - 528*D1**2*fd**2*g2*s + 528*D1**2*fd**2*g2 - 2112*D1*Dd*K*bd1*f**2*r*s + 264*D1*Dd*K*bd1*f**2*r + 264*D1*Dd*K*bd1*f**2*s - 1480*D1*Dd*bd1*f**3*r**2 - 5280*D1*Dd*bd1*f**3*r*s + 2790*D1*Dd*bd1*f**3*r + 660*D1*Dd*bd1*f**3*s - 440*D1*Dd*bd1*f**3 - 2112*D1*Dd*bd1*f**2*r*s + 264*D1*Dd*bd1*f**2*r + 264*D1*Dd*bd1*f**2*s + 704*D1*Dd*bd1*f*g2*r*s + 2024*D1*Dd*bd1*f*g2*r - 2552*D1*Dd*bd1*f*g2*s + 88*D1*Dd*bd1*f*g2 - 2112*D1*Dd*bd2*f**2*r*s + 264*D1*Dd*bd2*f**2*r + 264*D1*Dd*bd2*f**2*s - 2112*D1*Dd*f**2*g2*r*s + 528*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s + 4224*D1*Dd*f**2*gd2*r*s - 528*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s + 8448*D1*Dd*f*fd*g2*r*s - 3168*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s + 1056*D1*Dd*f*fd*g2 + 2112*D1*Ddd*f**2*g2*r*s - 528*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s + 6336*Dd**2*f**2*g2*r*s - 1584*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s + 528*Dd**2*f**2*g2 + 11*b1**3*(D1**2*r*(2*fd*r + 28*fd*s - 15*fdd*r - 28*fdd*s) + D1*(2*Dd*(f*(4*r**2 + 8*r*(7*s - 2) - 14*s + 1) + fd*r*(29 - 112*s) + r**2*(28 - 60*fd) - 14*r*(K*(8*s - 2) - 8*s + 3) + s*(28*K + 14*fd - 28) + 7) - Ddd*(f*(60*r**2 + 2*r*(56*s - 29) - 28*s + 15) + 28*r**2 - 14*r*(K*(8*s - 2) - 8*s + 3) + 7*s*(4*K - 4) + 7)) - 2*Dd**2*(7*K*(-24*r*s + 6*r + 6*s - 2) + f*(90*r**2 + 3*r*(56*s - 29) - 42*s + 14) + 42*r**2 + 168*r*s - 63*r - 42*s + 14)) + 11*b1**2*(8*D1**2*K*fd*r*s - 28*D1**2*K*fd*r + 20*D1**2*K*fd*s - 4*D1**2*K*fdd*r*s + 28*D1**2*K*fdd*r - 24*D1**2*K*fdd*s - D1**2*bdd1*(f*(45*r**2 + r*(84*s - 58) - 28*s + 15) + 21*r**2 - 14*r*(K*(6*s - 2) - 6*s + 3) + 7*s*(4*K - 4) + 7) + 40*D1**2*f*fd*r**2 + 192*D1**2*f*fd*r*s - 44*D1**2*f*fd*r - 24*D1**2*f*fd*s + 10*D1**2*f*fd - 68*D1**2*f*fdd*r**2 - 192*D1**2*f*fdd*r*s + 58*D1**2*f*fdd*r + 24*D1**2*f*fdd*s - 17*D1**2*f*fdd - 68*D1**2*fd**2*r**2 - 192*D1**2*fd**2*r*s + 58*D1**2*fd**2*r + 24*D1**2*fd**2*s + 6*D1**2*fd*r**2 + 48*D1**2*fd*r*s - 40*D1**2*fd*r - 20*D1**2*fd*s + 6*D1**2*fd - 17*D1**2*fdd*r**2 - 52*D1**2*fdd*r*s + 62*D1**2*fdd*r + 24*D1**2*fdd*s - 17*D1**2*fdd + 112*D1**2*gd2*r*s - 56*D1**2*gdd2*r*s + 32*D1*Dd*K*f*r*s - 8*D1*Dd*K*f*r - 8*D1*Dd*K*f*s - 32*D1*Dd*K*fd*r*s + 116*D1*Dd*K*fd*r - 92*D1*Dd*K*fd*s - 4*D1*Dd*K*fd + 80*D1*Dd*f**2*r**2 + 384*D1*Dd*f**2*r*s - 136*D1*Dd*f**2*r - 96*D1*Dd*f**2*s + 20*D1*Dd*f**2 - 544*D1*Dd*f*fd*r**2 - 1536*D1*Dd*f*fd*r*s + 560*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s - 82*D1*Dd*f*fd + 24*D1*Dd*f*r**2 + 192*D1*Dd*f*r*s - 60*D1*Dd*f*r - 48*D1*Dd*f*s + 6*D1*Dd*f - 136*D1*Dd*fd*r**2 - 416*D1*Dd*fd*r*s + 334*D1*Dd*fd*r + 148*D1*Dd*fd*s - 86*D1*Dd*fd + 448*D1*Dd*g2*r*s - 112*D1*Dd*g2*r - 112*D1*Dd*g2*s - 448*D1*Dd*gd2*r*s + 56*D1*Dd*gd2*r + 56*D1*Dd*gd2*s - 16*D1*Ddd*K*f*r*s + 4*D1*Ddd*K*f*r + 4*D1*Ddd*K*f*s - 136*D1*Ddd*f**2*r**2 - 384*D1*Ddd*f**2*r*s + 164*D1*Ddd*f**2*r + 96*D1*Ddd*f**2*s - 34*D1*Ddd*f**2 - 68*D1*Ddd*f*r**2 - 208*D1*Ddd*f*r*s + 86*D1*Ddd*f*r + 52*D1*Ddd*f*s - 17*D1*Ddd*f - 224*D1*Ddd*g2*r*s + 56*D1*Ddd*g2*r + 56*D1*Ddd*g2*s + 2*D1*bd1*(D1*(f*(3*r**2 + 2*r*(21*s - 8) - 14*s + 1) + fd*r*(29 - 84*s) + r**2*(21 - 45*fd) + 14*r*(K*(2 - 6*s) + 6*s - 3) + s*(28*K + 14*fd - 28) + 7) - Dd*f*(180*r**2 + 7*r*(48*s - 29) - 98*s + 43) + 7*Dd*(2*K*(r*(24*s - 7) - 7*s + 2) - 12*r**2 + r*(21 - 48*s) + 14*s - 5)) - 48*Dd**2*K*f*r*s + 12*Dd**2*K*f*r + 12*Dd**2*K*f*s - 4*Dd**2*K*f - 408*Dd**2*f**2*r**2 - 1152*Dd**2*f**2*r*s + 492*Dd**2*f**2*r + 288*Dd**2*f**2*s - 96*Dd**2*f**2 - 204*Dd**2*f*r**2 - 624*Dd**2*f*r*s + 258*Dd**2*f*r + 156*Dd**2*f*s - 52*Dd**2*f - 672*Dd**2*g2*r*s + 168*Dd**2*g2*r + 168*Dd**2*g2*s - 56*Dd**2*g2) - b1*(88*D1**2*K*bdd1*f*r*s + 264*D1**2*K*bdd1*f*r - 308*D1**2*K*bdd1*f*s - 528*D1**2*K*f*fd*r*s + 264*D1**2*K*f*fd*r + 264*D1**2*K*f*fd*s + 528*D1**2*K*f*fdd*r*s - 264*D1**2*K*f*fdd*r - 264*D1**2*K*f*fdd*s + 528*D1**2*K*fd**2*r*s - 264*D1**2*K*fd**2*r - 264*D1**2*K*fd**2*s + 264*D1**2*K*fd**2 + 22*D1**2*bd1**2*(7*K*(-12*r*s + 4*r + 4*s - 2) + f*(45*r**2 + r*(84*s - 58) - 28*s + 14) + 21*r**2 + 84*r*s - 42*r - 28*s + 14) - 308*D1**2*bd2*f*r*s + 616*D1**2*bd2*fd*r*s - 308*D1**2*bd2*fd*r + 748*D1**2*bdd1*f**2*r**2 + 2112*D1**2*bdd1*f**2*r*s - 1166*D1**2*bdd1*f**2*r - 792*D1**2*bdd1*f**2*s + 187*D1**2*bdd1*f**2 + 374*D1**2*bdd1*f*r**2 + 1144*D1**2*bdd1*f*r*s - 264*D1**2*bdd1*f*r - 308*D1**2*bdd1*f*s + 1232*D1**2*bdd1*g2*r*s - 616*D1**2*bdd1*g2*r - 616*D1**2*bdd1*g2*s + 308*D1**2*bdd2*f*r*s - 450*D1**2*f**2*fd*r**2 - 1980*D1**2*f**2*fd*r*s + 520*D1**2*f**2*fd*r + 660*D1**2*f**2*fd*s - 150*D1**2*f**2*fd + 555*D1**2*f**2*fdd*r**2 + 1980*D1**2*f**2*fdd*r*s - 590*D1**2*f**2*fdd*r - 660*D1**2*f**2*fdd*s + 185*D1**2*f**2*fdd + 1110*D1**2*f*fd**2*r**2 + 3960*D1**2*f*fd**2*r*s - 1180*D1**2*f*fd**2*r - 1320*D1**2*f*fd**2*s + 220*D1**2*f*fd**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r + 264*D1**2*f*fd*s + 528*D1**2*f*fdd*r*s - 264*D1**2*f*fdd*r - 264*D1**2*f*fdd*s + 176*D1**2*f*gd2*r*s - 88*D1**2*f*gdd2*r*s + 528*D1**2*fd**2*r*s - 264*D1**2*fd**2*r - 264*D1**2*fd**2*s + 264*D1**2*fd**2 + 176*D1**2*fd*g2*r*s - 616*D1**2*fd*g2*r + 440*D1**2*fd*g2*s - 176*D1**2*fd*gd2*r*s + 616*D1**2*fd*gd2*r - 528*D1**2*fd*gd2*s - 88*D1**2*fdd*g2*r*s + 616*D1**2*fdd*g2*r - 528*D1**2*fdd*g2*s - 1056*D1*Dd*K*f**2*r*s + 264*D1*Dd*K*f**2*r + 264*D1*Dd*K*f**2*s + 4224*D1*Dd*K*f*fd*r*s - 1584*D1*Dd*K*f*fd*r - 1584*D1*Dd*K*f*fd*s + 528*D1*Dd*K*f*fd + 2464*D1*Dd*bd2*f*r*s - 308*D1*Dd*bd2*f*r - 308*D1*Dd*bd2*f*s - 600*D1*Dd*f**3*r**2 - 2640*D1*Dd*f**3*r*s + 960*D1*Dd*f**3*r + 660*D1*Dd*f**3*s - 150*D1*Dd*f**3 + 4440*D1*Dd*f**2*fd*r**2 + 15840*D1*Dd*f**2*fd*r*s - 5450*D1*Dd*f**2*fd*r - 4620*D1*Dd*f**2*fd*s + 1250*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*r*s + 264*D1*Dd*f**2*r + 264*D1*Dd*f**2*s + 4224*D1*Dd*f*fd*r*s - 1584*D1*Dd*f*fd*r - 1584*D1*Dd*f*fd*s + 528*D1*Dd*f*fd + 704*D1*Dd*f*g2*r*s - 176*D1*Dd*f*g2*r - 176*D1*Dd*f*g2*s - 704*D1*Dd*f*gd2*r*s + 88*D1*Dd*f*gd2*r + 88*D1*Dd*f*gd2*s - 704*D1*Dd*fd*g2*r*s + 2552*D1*Dd*fd*g2*r - 2024*D1*Dd*fd*g2*s - 88*D1*Dd*fd*g2 + 1056*D1*Ddd*K*f**2*r*s - 264*D1*Ddd*K*f**2*r - 264*D1*Ddd*K*f**2*s + 740*D1*Ddd*f**3*r**2 + 2640*D1*Ddd*f**3*r*s - 1030*D1*Ddd*f**3*r - 660*D1*Ddd*f**3*s + 185*D1*Ddd*f**3 + 1056*D1*Ddd*f**2*r*s - 264*D1*Ddd*f**2*r - 264*D1*Ddd*f**2*s - 352*D1*Ddd*f*g2*r*s + 88*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2*s - 22*D1*bd1*(D1*(f**2*(20*r**2 + r*(96*s - 46) - 36*s + 5) - 2*f*(2*fd*(34*r**2 + r*(96*s - 41) - 24*s + 6) - 3*r**2 - r*(4*K*s + 5*K + 24*s - 5) + s*(7*K + 7)) - 2*fd*(4*K*r*(s - 2) + 5*K*s + K + 17*r**2 + r*(52*s - 37) - 19*s + 13) + 28*g2*r*(4*s - 2) - 56*g2*s + 28*gd2*(-4*r*s + r + s)) - Dd*(f**2*(272*r**2 + 8*r*(96*s - 47) - 240*s + 89) + 2*f*(2*K*r*(8*s + 11) - 30*K*s + K + 68*r**2 + r*(208*s - 67) - 54*s + 13) + 56*g2*(r*(8*s - 3) - 3*s + 1))) + 3168*Dd**2*K*f**2*r*s - 792*Dd**2*K*f**2*r - 792*Dd**2*K*f**2*s + 264*Dd**2*K*f**2 + 2220*Dd**2*f**3*r**2 + 7920*Dd**2*f**3*r*s - 3090*Dd**2*f**3*r - 1980*Dd**2*f**3*s + 660*Dd**2*f**3 + 3168*Dd**2*f**2*r*s - 792*Dd**2*f**2*r - 792*Dd**2*f**2*s + 264*Dd**2*f**2 - 1056*Dd**2*f*g2*r*s + 264*Dd**2*f*g2*r + 264*Dd**2*f*g2*s - 88*Dd**2*f*g2 + 308*b2*(D1*Dd*(f*(-4*r*s + r + s) + fd*r*(8*s - 5) - fd*s + fd) - D1*(D1*r*(fd - fdd)*(s - 1) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1))) + 44*b2*(6*D1*Dd*f*(f*(4*r*s - r - s) + fd*(-16*r*s + 6*r + 6*s - 2)) + 7*D1*bd1*(D1*f*s*(r - 1) + D1*fd*(-2*r*s + r + s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) + D1*(D1*(-7*bdd1*f*s*(r - 1) + 6*f*fd*r*(2*s - 1) - 6*f*fd*s + 6*f*fdd*(-2*r*s + r + s) + 6*fd**2*(-2*r*s + r + s - 1)) + 6*Ddd*f**2*(-4*r*s + r + s)) - 6*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k2) - D1**2*Pk2*Pkd1*ct*k2**3*st**4*(132*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 - 6*D1**2*f**2*fd*r**2 + 4*D1**2*f**2*fd*r - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 264*D1*Dd*b1*f**2*r**2 - 132*D1*Dd*b1*f**2*r + 66*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r - 8*D1*Dd*f**3*r**2 + 4*D1*Dd*f**3*r - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(231*d**2*k1**2*k3**2) - D1**2*Pk2*Pkd1*ct*k2**3*st**2*(D1*f*r*(-6*D1*bd1**2*(r - 1) + D1*bdd1*f*r - 2*bd1*(D1*(f*r - 2*fd*r + fd) + Dd*(-4*f*r + f))) + 3*b1**2*(D1**2*r**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*r*(1 - 4*r)) + D1*Ddd*f*(-4*r**2 + 2*r - 1) + 6*Dd**2*f*r*(1 - 2*r)) + b1*(-3*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 4*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r - 2*D1**2*f*fd + 2*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r + D1**2*f*fdd + 2*D1**2*fd**2*r**2 - 2*D1**2*fd**2*r - 8*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r - 2*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 - 12*D1*Dd*f*fd*r + 2*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 - 2*D1*Ddd*f**2*r + D1*Ddd*f**2 + 6*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(1 - 2*r) + Dd*f*(-8*r**2 + 6*r - 1)) + 12*Dd**2*f**2*r**2 - 6*Dd**2*f**2*r))/(21*d**2*k1**2*k3**2) + D1**2*Pk2*Pkd1*ct*k2*st**2*(D1*f*r*(66*D1*bd1**2*(2*f + 1)*(r - 1) - D1*bdd1*f*r*(6*f + 11) + 2*bd1*(D1*f*r*(6*f + 11) + D1*fd*(f*(6 - 18*r) - 22*r + 11) - Dd*f*(6*f + 11)*(4*r - 1))) - 33*b1**2*(-D1**2*r**2*(4*f*fdd + 4*fd**2 + fd*(-8*f - 2) + fdd) + D1*(2*Dd*(f**2*(8*r**2 - 4*r + 2) + f*r**2*(4 - 16*fd) + f*r*(4*fd - 2) + f + fd*r*(1 - 4*r)) - Ddd*f*(2*f + 1)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(2*f + 1)*(2*r - 1)) + b1*(33*D1**2*bdd1*f*(2*f + 1)*(2*r**2 - 2*r + 1) + 36*D1**2*f**2*fd*r**2 - 24*D1**2*f**2*fd*r + 12*D1**2*f**2*fd - 18*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r - 6*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r**2 + 24*D1**2*f*fd**2*r + 44*D1**2*f*fd*r**2 - 44*D1**2*f*fd*r + 22*D1**2*f*fd - 22*D1**2*f*fdd*r**2 + 22*D1**2*f*fdd*r - 11*D1**2*f*fdd - 22*D1**2*fd**2*r**2 + 22*D1**2*fd**2*r + 48*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r + 12*D1*Dd*f**3 - 144*D1*Dd*f**2*fd*r**2 + 84*D1*Dd*f**2*fd*r - 12*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r**2 - 44*D1*Dd*f**2*r + 22*D1*Dd*f**2 - 176*D1*Dd*f*fd*r**2 + 132*D1*Dd*f*fd*r - 22*D1*Dd*f*fd - 24*D1*Ddd*f**3*r**2 + 12*D1*Ddd*f**3*r - 6*D1*Ddd*f**3 - 44*D1*Ddd*f**2*r**2 + 22*D1*Ddd*f**2*r - 11*D1*Ddd*f**2 - 66*D1*bd1*(D1*(f**2*(4*r**2 - 4*r + 2) + f*r**2*(2 - 8*fd) + f*r*(4*fd - 2) + f + fd*r*(1 - 2*r)) - Dd*f*(2*f + 1)*(8*r**2 - 6*r + 1)) - 72*Dd**2*f**3*r**2 + 36*Dd**2*f**3*r - 132*Dd**2*f**2*r**2 + 66*Dd**2*f**2*r))/(231*d**2*k1**2) + D1**2*Pk2*Pkd1*ct*k2*(2*D1**2*bd1**2*f*r**2*(3*f + 7) + 2*D1*b1*r*(3*D1*bd1**2*(3*f + 7)*(3*r - 2) + D1*bdd1*f*r*(3*f + 7) + 2*bd1*(-D1*f*r*(3*f + 7) + D1*fd*(6*f*r - 3*f + 7*r - 7) + Dd*f*(3*f + 7)*(4*r - 1))) - 3*b1**3*(3*D1**2*r**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*r**2 - 2*r + 1) - r**2*(12*fd - 28) + r*(3*fd - 14) + 7) - D1*Ddd*(3*f + 7)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(3*f + 7)*(2*r - 1)) + b1**2*(3*D1**2*bdd1*(3*f + 7)*(3*r**2 - 2*r + 1) - 12*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r - 6*D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r - 14*D1**2*fd*r**2 + 28*D1**2*fd*r - 14*D1**2*fd + 7*D1**2*fdd*r**2 - 14*D1**2*fdd*r + 7*D1**2*fdd - 24*D1*Dd*f**2*r**2 + 12*D1*Dd*f**2*r - 6*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd - 56*D1*Dd*f*r**2 + 28*D1*Dd*f*r - 14*D1*Dd*f + 56*D1*Dd*fd*r**2 - 70*D1*Dd*fd*r + 14*D1*Dd*fd + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 28*D1*Ddd*f*r**2 - 14*D1*Ddd*f*r + 7*D1*Ddd*f - 6*D1*bd1*(D1*(f*(9*r**2 - 6*r + 3) + r**2*(21 - 9*fd) + r*(3*fd - 14) + 7) - Dd*(3*f + 7)*(12*r**2 - 7*r + 1)) + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r + 84*Dd**2*f*r**2 - 42*Dd**2*f*r))/(21*d**2*k1**2) - 2*D1**2*Pk2*Pkd1*f*k1*st**4*(D1**2*(f*(-33*bd1*s*(r - 1) - 2*fd*(8*C*s + 6*r**2 + r*(-24*C*s + 8*C + 3*s - 5) - s + 2) + fdd*(8*C*s + 6*r**2 + r*(-24*C*s + 8*C + 3*s - 5) - s + 2)) + fd*(33*b1*r*(1 - 2*s) + fd*(-8*C*(6*r*s - 2*r - 2*s + 1) + 12*r**2 + 6*r*s - 10*r - 2*s + 1))) + D1*f*(Dd*(33*b1*(-4*r*s + r + s) - 2*f*(8*C*s + 8*r**2 + r*(-32*C*s + 8*C + 4*s - 5) - s + 2) + fd*(-8*C*(24*r*s - 7*r - 7*s + 2) + 48*r**2 + 24*r*s - 35*r - 7*s + 6)) + Ddd*f*(8*r**2 + r*(C*(8 - 32*s) + 4*s - 5) + s*(8*C - 1) + 2)) + Dd**2*f**2*(-8*C*(3*r*(4*s - 1) - 3*s + 1) + 24*r**2 + 3*r*(4*s - 5) - 3*s + 1))/(231*d**2*k3**2) - 8*D1**2*Pk2*Pkd1*f*k1*st**4*(13*D1*bd1*f*(D1*(2*f*s*(2*r - 1) + fd*(-12*r*s + 2*r + 4*s - 1)) - Dd*f*(2*r*(8*s - 1) - 6*s + 1)) - 13*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + fd*(48*r*s - 14*r - 10*s + 3)) + D1*(D1*(2*f*fd*(-6*r*s + 2*r + s) + f*fdd*(6*r*s - 2*r - s) + fd**2*(12*r*s - 4*r - 2*s + 1)) + 2*Ddd*f**2*(r*(4*s - 1) - s)) + 2*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(20*D1*Dd*f*(f*r*(4*s - 1) - f*s - fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(20*f*fd*(r*(4*s - 1) - s) + f*(13*bdd1*s*(1 - 2*r) + 10*fdd*(-4*r*s + r + s)) - 10*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 10*Ddd*f**2*(-4*r*s + r + s)) - 10*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(3003*d**2*k2**2) + 20*D1**2*Pk2*Pkd1*f*st**6*(13*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-6*r*s + r + 3*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 13*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + fd*r*(24*s - 7) - 3*fd*s + fd) - D1*(D1*r*(3*s - 1)*(2*f*fd - f*fdd - 2*fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(-6*D1*Dd*f*(f*r*(4*s - 1) - f*s - fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(6*f*fd*(-4*r*s + r + s) + f*(-13*bdd1*s*(r - 1) + 3*fdd*r*(4*s - 1) - 3*fdd*s) + fd**2*(9*r*(4*s - 1) - 9*s + 3)) + 3*Ddd*f**2*(r*(4*s - 1) - s)) + 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k1) + D1**2*Pk2*Pkd1*k1**3*st**2*(33*D1*bd1*f*(D1*f*s*(r - 1) + D1*fd*(-4*r*s + r + 2*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 33*b1*(D1*Dd*f*(f*(-4*r*s + r + s) + 2*fd*r*(8*s - 3) - 2*fd*s + fd) + D1*(D1*r*(2*s - 1)*(f*(-fd + fdd) + fd**2) - Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(17*f*(4*r*s - r - s) - 25*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(17*f*fd*(r*(3*s - 1) - s) + f*(-33*bdd1*s*(r - 1) + 25*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(-4*r*s + r + s)) - 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k2**2*k3**2) + 2*D1**2*Pk2*Pkd1*k1**3*(-6*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) - 5*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(D1*b1*(5*f*r*(2*s - 1) - 5*f*s + 6*fd*(-4*r*s + r + s)) + D1*f*(4*f*r*(s - 1) - 5*fd*(r*(4*s - 2) - s + 1)) - 12*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) - 5*Dd*f**2*(r*(8*s - 5) - s + 1)) + b1**2*(D1*Dd*(5*f*r*(4*s - 1) - 5*f*s + 6*fd*(-8*r*s + r + s)) + D1*(D1*r*s*(5*fd - 6*fdd) + 6*Ddd*f*(-4*r*s + r + s)) - 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(4*f*(r*(4*s - 1) - s) - 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(6*D1*bdd1*f*(-2*r*s + r + s) + D1*s*(2*r - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k2**2*k3**2) + D1**2*Pk2*Pkd1*k1*st**2*(33*b1**2*(D1**2*r*(fd*(4*r + 9*s) - fdd*(2*r + s)) + D1*(Dd*(f*(16*r**2 + 36*r*s - 17*r - 9*s + 4) + fd*(-16*r**2 - 8*r*s + 5*r + s)) + Ddd*f*(-8*r**2 + r*(5 - 4*s) + s - 2)) + Dd**2*f*(-24*r**2 - 3*r*(4*s - 5) + 3*s - 1)) + 33*b1*(4*C*D1**2*f*fd*r**2 + 24*C*D1**2*f*fd*r*s - 12*C*D1**2*f*fd*r - 8*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r*s + 12*C*D1**2*f*fdd*r - 8*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r*s + 12*C*D1**2*fd**2*r + 8*C*D1*Dd*f**2*r**2 + 48*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*r - 12*C*D1*Dd*f**2*s + 2*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r**2 - 192*C*D1*Dd*f*fd*r*s + 88*C*D1*Dd*f*fd*r + 24*C*D1*Dd*f*fd*s - 12*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 - 48*C*D1*Ddd*f**2*r*s + 20*C*D1*Ddd*f**2*r + 12*C*D1*Ddd*f**2*s - 4*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 - 144*C*Dd**2*f**2*r*s + 60*C*Dd**2*f**2*r + 36*C*Dd**2*f**2*s - 12*C*Dd**2*f**2 + D1**2*bdd1*f*(-4*r**2 - 2*r*s + 5*r + s - 2) + 8*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 9*D1**2*f*fd*r - D1**2*f*fd*s + 4*D1**2*f*fd - 4*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 5*D1**2*f*fdd*r + D1**2*f*fdd*s - 2*D1**2*f*fdd - 4*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 5*D1**2*fd**2*r + D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 10*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 32*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 32*D1*Dd*f*fd*r + 8*D1*Dd*f*fd*s - 6*D1*Dd*f*fd - 8*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r + 2*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + D1*bd1*(D1*(f*(8*r**2 + 18*r*s - 17*r - 9*s + 4) + fd*(-8*r**2 - 4*r*s + 5*r + s)) - 2*Dd*f*(16*r**2 + r*(8*s - 15) - 3*s + 3)) - 24*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r + 6*Dd**2*f**2*s - 2*Dd**2*f**2) + f*(438*C*D1**2*f*fd*r**2 + 1188*C*D1**2*f*fd*r*s - 688*C*D1**2*f*fd*r - 396*C*D1**2*f*fd*s + 146*C*D1**2*f*fd - 516*C*D1**2*f*fdd*r**2 - 1188*C*D1**2*f*fdd*r*s + 740*C*D1**2*f*fdd*r + 396*C*D1**2*f*fdd*s - 172*C*D1**2*f*fdd - 1032*C*D1**2*fd**2*r**2 - 2376*C*D1**2*fd**2*r*s + 1480*C*D1**2*fd**2*r + 792*C*D1**2*fd**2*s - 396*C*D1**2*fd**2 + 584*C*D1*Dd*f**2*r**2 + 1584*C*D1*Dd*f**2*r*s - 688*C*D1*Dd*f**2*r - 396*C*D1*Dd*f**2*s + 146*C*D1*Dd*f**2 - 4128*C*D1*Dd*f*fd*r**2 - 9504*C*D1*Dd*f*fd*r*s + 5180*C*D1*Dd*f*fd*r + 2772*C*D1*Dd*f*fd*s - 1136*C*D1*Dd*f*fd - 688*C*D1*Ddd*f**2*r**2 - 1584*C*D1*Ddd*f**2*r*s + 740*C*D1*Ddd*f**2*r + 396*C*D1*Ddd*f**2*s - 172*C*D1*Ddd*f**2 - 2064*C*Dd**2*f**2*r**2 - 4752*C*Dd**2*f**2*r*s + 2220*C*Dd**2*f**2*r + 1188*C*Dd**2*f**2*s - 396*C*Dd**2*f**2 - 33*D1**2*bd1**2*(4*r**2 + r*(2*s - 5) - s + 1) - 33*D1**2*bdd1*f*(4*C*(r - 1)*(r + 3*s - 1) + (r + s)*(2*r - 1)) + 51*D1**2*f*fd*r*s - 17*D1**2*f*fd*r - 17*D1**2*f*fd*s - 75*D1**2*f*fdd*r*s + 25*D1**2*f*fdd*r + 25*D1**2*f*fdd*s - 150*D1**2*fd**2*r*s + 50*D1**2*fd**2*r + 50*D1**2*fd**2*s - 25*D1**2*fd**2 + 68*D1*Dd*f**2*r*s - 17*D1*Dd*f**2*r - 17*D1*Dd*f**2*s - 600*D1*Dd*f*fd*r*s + 175*D1*Dd*f*fd*r + 175*D1*Dd*f*fd*s - 50*D1*Dd*f*fd - 100*D1*Ddd*f**2*r*s + 25*D1*Ddd*f**2*r + 25*D1*Ddd*f**2*s + 33*D1*bd1*(2*C*(D1*f*(r - 1)*(r + 6*s - 1) - 2*D1*fd*(4*r**2 + r*(12*s - 7) - 6*s + 3) - 2*Dd*f*(8*r - 5)*(r + 3*s - 1)) - D1*(f*(-4*r**2 - 2*r*s + r + s) + fd*(8*r**2 + 8*r*s - 7*r - 3*s + 2)) - 2*Dd*f*(8*r**2 + r*(8*s - 5) - 3*s + 1)) - 300*Dd**2*f**2*r*s + 75*Dd**2*f**2*r + 75*Dd**2*f**2*s - 25*Dd**2*f**2))/(693*d**2*k3**2) - 2*D1**2*Pk2*Pkd1*k1*(2*D1**2*bd1**2*f*(C*(29*r**2 + 28*r*s - 43*r - 14*s + 14) + r*(6*s - 3) - 3*s + 3) + D1**2*bdd1*f**2*r*(29*C*r + 24*C*(s - 1) + 5*s - 5) + D1*bd1*(b1*(-2*C*(D1*(2*f*(8*r**2 + 14*r*s - 15*r - 7*s + 4) + fd*(-58*r**2 - 56*r*s + 43*r + 14*s)) + Dd*f*(-232*r**2 + r*(258 - 224*s) + 84*s - 57)) + D1*(5*f*(-2*r*s + r + s) + 6*fd*r*(4*s - 1) - 6*fd*s) + 12*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(-2*f*r*(11*C*r + 12*C*(s - 1) + 2*s - 2) + fd*(2*C*(58*r**2 + 48*r*s - 53*r - 12*s + 12) + 5*r*(4*s - 2) - 5*s + 5)) + Dd*f*(2*C*(116*r**2 + 96*r*s - 89*r - 12*s + 12) + 5*r*(8*s - 5) - 5*s + 5))) + b1**2*(C*(D1**2*r*(-4*fd*(4*r + 7*s) + fdd*(29*r + 28*s)) + D1*(-2*Dd*(2*f*(16*r**2 + 28*r*s - 15*r - 7*s + 4) + fd*(-116*r**2 - 112*r*s + 43*r + 14*s)) + Ddd*f*(116*r**2 + 2*r*(56*s - 43) - 28*s + 29)) + 2*Dd**2*f*(174*r**2 + 3*r*(56*s - 43) - 42*s + 14)) + D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*r*(8*s - 1) - 6*fd*s) + D1*(D1*r*s*(-5*fd + 6*fdd) + 6*Ddd*f*(r*(4*s - 1) - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(C*(D1**2*(f*(fd*(-44*r**2 - 48*r*s + 44*r + 24*s - 22) + fdd*(58*r**2 + 48*r*s - 58*r - 24*s + 29)) + 2*fd**2*(29*r**2 + r*(24*s - 29) - 12*s)) + D1*f*(Dd*(f*(-88*r**2 + r*(68 - 96*s) + 24*s - 22) + 2*fd*(232*r**2 + 6*r*(32*s - 33) - 72*s + 41)) + Ddd*f*(116*r**2 + r*(96*s - 82) - 24*s + 29)) + 6*Dd**2*f**2*(58*r**2 + r*(48*s - 41) - 12*s + 4)) + D1**2*bdd1*f*(C*(58*r**2 + 56*r*s - 86*r - 28*s + 29) + 12*r*s - 6*r - 6*s) - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*s + 10*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*s + 10*D1**2*fd**2*r*s - 5*D1**2*fd**2*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r + 4*D1*Dd*f**2*s + 80*D1*Dd*f*fd*r*s - 10*D1*Dd*f*fd*r - 30*D1*Dd*f*fd*s + 5*D1*Dd*f*fd + 20*D1*Ddd*f**2*r*s - 5*D1*Ddd*f**2*r - 5*D1*Ddd*f**2*s + 60*Dd**2*f**2*r*s - 15*Dd**2*f**2*r - 15*Dd**2*f**2*s + 5*Dd**2*f**2))/(21*d**2*k3**2) + D1**2*Pk2*Pkd1*k1*st**2*(66*b1**3*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) - 33*b1**2*(D1*Dd*(f*(5*f - 9)*(r*(4*s - 1) - s) + fd*(-2*f*r*(8*s + 5) + 10*f*s + f + r*(8*s - 5) - s + 1)) + 2*D1*bd1*(D1*(f*r*(6*s - 2) - 2*f*s + fd*(-6*r*s + r + s)) + Dd*f*(r*(7 - 24*s) + 7*s - 2)) + D1*(2*D1*bdd1*f*(-3*r*s + r + s) + D1*(2*f*fdd*s + fd**2*(-r*(2*s + 3) + 2*s) + fd*(-4*f*s + r*(10*f*s + 3*f - 9*s + 9)) - fdd*r*(f*(2*s + 3) - s + 1)) - Ddd*f*(f - 1)*(r*(4*s - 1) - s)) - Dd**2*f*(f - 1)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(66*D1**2*bd1**2*f*(r*(6*s - 2) - 2*s + 1) + D1*Dd*f*(f*(98*f + 33)*(r*(4*s - 1) - s) + fd*(f*(-3552*r*s + 1236*r + 640*s - 247) - 528*r*s + 198*r + 198*s - 66)) - 33*D1*bd1*(D1*(f*(2*f*r*(5*s - 4) - f*s + s*(9 - 18*r)) + fd*(f*r*(2 - 8*s) + 2*f*s + f + r*(4*s - 2) - s + 1)) - Dd*f*(f*(2*r*(8*s - 9) + 2*s + 3) + r*(2 - 16*s) + 6*s - 1)) + D1*(D1*(f*fd*(3*r*(98*f*s - 66*f + 22*s - 11) + s*(f - 33)) + f*(33*bdd1*(f*(2*r*(s - 2) + s) - 2*r*s + s) + fdd*(r*(-444*f*s + 198*f - 66*s + 33) + s*(49*f + 33))) + fd**2*(f*(-888*r*s + 396*r + 98*s - 99) - 66*r*s + 33*r + 33*s - 33)) - Ddd*f**2*(148*f + 33)*(r*(4*s - 1) - s)) - Dd**2*f**2*(148*f + 33)*(3*r*(4*s - 1) - 3*s + 1)) + f*(33*D1**2*bd1**2*(f*(2*r*(s - 2) + s + 2) - 2*r*s + s) + D1*bd1*(D1*(f**2*(2*r*(49*s + 50) - 99*s) + f*(fd*(-888*r*s + 48*r + 346*s - 49) + 33*r*s) + 33*fd*(-4*r*s + r + s)) + Dd*f*(-f*(1184*r*s + 52*r - 544*s + 49) - 264*r*s + 33*r + 33*s)) - f*(-75*D1*Dd*f*(f*r*(4*s - 1) - f*s - 2*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(bdd1*(2*f*r*(74*s + 25) - 99*f*s + 33*r*s) - 75*f*fd*(r*(4*s - 1) - s) + 75*f*fdd*(r*(4*s - 1) - s) + 75*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 75*Ddd*f**2*(r*(4*s - 1) - s)) + 75*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(693*d**2*k2**2) + 2*D1**2*Pk2*Pkd1*k1*(D1*f*(-6*D1*bd1**2*(f*r*(4*s - 2) - f*s + f + r*(2*s - 1)) - 5*D1*bdd1*f**2*r*(s - 1) - 5*bd1*f*(D1*(-f*r*(s - 1) + fd*r*(6*s - 3) - fd*s + fd) + Dd*f*(r*(8*s - 5) - s + 1))) - 7*b1**3*(D1*Dd*(r*(-4*f*s + f + 8*fd*s - fd - 8*s + 2) + s*(f - fd + 2)) + D1*(D1*r*s*(-fd + fdd) + Ddd*(f + 1)*(4*r*s - r - s)) + Dd**2*(f + 1)*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(D1*Dd*(f*(12*f + 5)*(r*(4*s - 1) - s) - 6*fd*(f*(4*r - 1)*(8*s - 1) + 8*r*s - r - 5*s + 1)) + 7*D1*bd1*(D1*(r*(3*f*s - f - 6*fd*s + fd + 6*s - 2) + s*(-f + fd - 2)) - Dd*(f + 1)*(r*(24*s - 7) - 7*s + 2)) + D1*(-7*D1*bdd1*(f + 1)*(r*(3*s - 1) - s) + D1*s*(fd**2*(6 - 24*r) + fd*(24*f*r - 6*f + 5*r - 5) + 6*fdd*(-4*f*r + f - r + 1)) - 6*Ddd*f*(2*f + 1)*(r*(4*s - 1) - s)) - 6*Dd**2*f*(2*f + 1)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-7*D1**2*bd1**2*(f + 1)*(r*(6*s - 2) - 2*s + 1) + D1*bd1*(D1*(f*(-6*f*s + r*(12*f + 5)*(2*s - 1)) - 6*fd*(f*(4*r - 1)*(4*s - 1) + 4*r*s - r - 2*s + 1)) - 6*Dd*f*(f*(4*r - 1)*(8*s - 3) + 16*r*s - 6*r - 2*s + 1)) + f*(5*D1*Dd*f*(f*(4*r*s - r - s) + fd*(-24*r*s + 3*r + 7*s - 1)) + D1*(6*D1*bdd1*f*s - 6*D1*bdd1*r*(2*f + 1)*(2*s - 1) - 5*D1*s*(3*r - 1)*(f*(-fd + fdd) + 2*fd**2) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(21*d**2*k2**2) + 2*D1**2*Pk2*Pkd1*k2**2*st**4*(66*C*D1**2*b1*f*fdd*r**2 + 66*C*D1**2*b1*fd**2*r**2 + 33*C*D1**2*bdd1*f**2*(r - 1)**2 - 30*C*D1**2*f**2*fd*r**2 + 20*C*D1**2*f**2*fd*r - 10*C*D1**2*f**2*fd + 15*C*D1**2*f**2*fdd*r**2 - 10*C*D1**2*f**2*fdd*r + 5*C*D1**2*f**2*fdd + 30*C*D1**2*f*fd**2*r**2 - 20*C*D1**2*f*fd**2*r + 528*C*D1*Dd*b1*f*fd*r**2 - 132*C*D1*Dd*b1*f*fd*r - 40*C*D1*Dd*f**3*r**2 + 20*C*D1*Dd*f**3*r - 10*C*D1*Dd*f**3 + 120*C*D1*Dd*f**2*fd*r**2 - 70*C*D1*Dd*f**2*fd*r + 10*C*D1*Dd*f**2*fd + 132*C*D1*Ddd*b1*f**2*r**2 - 66*C*D1*Ddd*b1*f**2*r + 33*C*D1*Ddd*b1*f**2 + 20*C*D1*Ddd*f**3*r**2 - 10*C*D1*Ddd*f**3*r + 5*C*D1*Ddd*f**3 + 396*C*Dd**2*b1*f**2*r**2 - 198*C*Dd**2*b1*f**2*r + 60*C*Dd**2*f**3*r**2 - 30*C*Dd**2*f**3*r + 66*D1**2*b1*f*fd*r*s - 33*D1**2*b1*f*fd*r + 12*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r - 2*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 6*D1**2*f**2*fdd*r**2 - 3*D1**2*f**2*fdd*r*s + 5*D1**2*f**2*fdd*r + D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 12*D1**2*f*fd**2*r**2 - 6*D1**2*f*fd**2*r*s + 10*D1**2*f*fd**2*r + 2*D1**2*f*fd**2*s - D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r*s - 33*D1*Dd*b1*f**2*r - 33*D1*Dd*b1*f**2*s + 16*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 10*D1*Dd*f**3*r - 2*D1*Dd*f**3*s + 4*D1*Dd*f**3 - 48*D1*Dd*f**2*fd*r**2 - 24*D1*Dd*f**2*fd*r*s + 35*D1*Dd*f**2*fd*r + 7*D1*Dd*f**2*fd*s - 6*D1*Dd*f**2*fd - 8*D1*Ddd*f**3*r**2 - 4*D1*Ddd*f**3*r*s + 5*D1*Ddd*f**3*r + D1*Ddd*f**3*s - 2*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(4*C*D1*fd*r + 2*C*Dd*f*(4*r - 1) + D1*f*s) - 24*Dd**2*f**3*r**2 - 12*Dd**2*f**3*r*s + 15*Dd**2*f**3*r + 3*Dd**2*f**3*s - Dd**2*f**3)/(231*d**2*k1*k3**2) - D1**2*Pk2*Pkd1*k2**2*st**2*(D1*f*(D1*bd1**2*(r**2*(4 - 16*C) + r*(16*C + 2*s - 5) - s + 1) + D1*bdd1*f*r*(2*r + s - 1) + bd1*(D1*(f*r*(r*(2*C - 4) - s + 1) + fd*(4*r - 1)*(2*r + s - 1)) + Dd*f*(16*r**2 + r*(8*s - 9) - s + 1))) + b1**2*(D1**2*r*(fd*r*(2*C - 4) - 9*fd*s + fdd*r*(2 - 8*C) + fdd*s) + D1*(Dd*(f*(C*(8*r**2 - 4*r + 2) - 16*r**2 - 36*r*s + 17*r + 9*s - 4) - fd*(r**2*(64*C - 16) + r*(-16*C - 8*s + 5) + s)) - Ddd*f*(8*C*(4*r**2 - 2*r + 1) - 8*r**2 - 4*r*s + 5*r + s - 2)) + Dd**2*f*(r**2*(24 - 96*C) + 3*r*(16*C + 4*s - 5) - 3*s + 1)) + b1*(4*C*D1**2*f*fd*r**2 - 4*C*D1**2*f*fd*r + 2*C*D1**2*f*fd + 8*C*D1*Dd*f**2*r**2 - 4*C*D1*Dd*f**2*r + 2*C*D1*Dd*f**2 - D1**2*bdd1*f*(8*C*(2*r**2 - 2*r + 1) - 4*r**2 - 2*r*s + 5*r + s - 2) - 8*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + D1**2*f*fd*s - 4*D1**2*f*fd + 4*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r - D1**2*f*fdd*s + 2*D1**2*f*fdd + 4*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r*s - 4*D1**2*fd**2*r - D1**2*fd**2*s - 16*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r*s + 9*D1*Dd*f**2*r + D1*Dd*f**2*s - 4*D1*Dd*f**2 + 32*D1*Dd*f*fd*r**2 + 16*D1*Dd*f*fd*r*s - 26*D1*Dd*f*fd*r - 6*D1*Dd*f*fd*s + 5*D1*Dd*f*fd + 8*D1*Ddd*f**2*r**2 + 4*D1*Ddd*f**2*r*s - 5*D1*Ddd*f**2*r - D1*Ddd*f**2*s + 2*D1*Ddd*f**2 + D1*bd1*(D1*(f*(C*(4*r**2 - 4*r + 2) - 8*r**2 - 18*r*s + 17*r + 9*s - 4) - fd*(r**2*(32*C - 8) + r*(-16*C - 4*s + 5) + s)) + 2*Dd*f*(-8*C*(8*r**2 - 6*r + 1) + 16*r**2 + 8*r*s - 15*r - 3*s + 3)) + 24*Dd**2*f**2*r**2 + 12*Dd**2*f**2*r*s - 15*Dd**2*f**2*r - 3*Dd**2*f**2*s + Dd**2*f**2))/(21*d**2*k1*k3**2) + D1**2*Pk2*Pkd1*st**4*(429*b1**2*(2*D1**2*r**2*(f*fdd + fd**2) + D1*f*(4*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f**2*r*(2*r - 1)) + 13*b1*f*(33*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 90*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 28*D1**2*f*fd*r + 16*D1**2*f*fd*s - 10*D1**2*f*fd + 45*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s - 14*D1**2*f*fdd*r - 8*D1**2*f*fdd*s + 5*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 48*D1**2*fd**2*r*s - 28*D1**2*fd**2*r - 16*D1**2*fd**2*s + 4*D1**2*fd**2 - 120*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 76*D1*Dd*f**2*r + 16*D1*Dd*f**2*s - 30*D1*Dd*f**2 + 360*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s - 170*D1*Dd*f*fd*r - 56*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 60*D1*Ddd*f**2*r**2 + 32*D1*Ddd*f**2*r*s - 38*D1*Ddd*f**2*r - 8*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 66*D1*bd1*(2*r - 1)*(2*D1*fd*r + Dd*f*(4*r - 1)) + 180*Dd**2*f**2*r**2 + 96*Dd**2*f**2*r*s - 114*Dd**2*f**2*r - 24*Dd**2*f**2*s + 8*Dd**2*f**2) + f**2*(858*D1**2*bd1**2*r*(r - 1) + 13*D1**2*bdd1*f*(15*r**2 + 8*r*(s - 3) + 10) + 2*D1**2*(f*fd*(112*r**2 + r*(260*s - 121) - 65*s + 28) + f*fdd*(-108*r**2 + r*(119 - 260*s) + 65*s - 27) + fd**2*(-324*r**2 - 780*r*s + 357*r + 195*s - 65)) - 26*D1*bd1*(D1*(f*(15*r**2 + 8*r*(s - 3) + 10) + fd*(-45*r**2 + r*(43 - 24*s) + 4*s - 2)) + Dd*f*(-60*r**2 + r*(67 - 32*s) + 4*s - 12)) + 2*D1*f*(Dd*(f*(112*r**2 + 260*r*s - 121*r - 65*s + 28) - 8*fd*(4*r - 1)*(27*r + 65*s - 23)) + Ddd*f*(-108*r**2 + r*(119 - 260*s) + 65*s - 27)) + 2*Dd**2*f**2*(-324*r**2 - 780*r*s + 357*r + 195*s - 65)))/(3003*d**2*k1) - D1**2*Pk2*Pkd1*st**2*(D1*(11*D1*bd1**2*f*(3*f*(r*(4*s - 1) - 2*s + 1) + r**2*(-8*K - 8) + 2*r*(4*K + s + 4) - s) + 11*b2*(bd1*(r - 1)*(D1*f*(r - 1) - 8*D1*fd*r + 8*Dd*f*(1 - 4*r)) + f*(-4*D1*bdd1*(r - 1)**2 + D1*fd*(2*r**2 - 2*r + 1) + Dd*f*(4*r**2 - 2*r + 1))) + bd1*(D1*(-3*f**3*r*(13*r + 22*s - 11) + f**2*(3*fd*(72*r**2 + 4*r*(33*s - 17) - 22*s + 11) + 11*r*(K*r + r - s)) - 11*f*(8*bd2*r*(r - 1) - 4*fd*r*s + fd*r + fd*s + 2*g2*(r - 1)**2 - 16*gd2*r**2 + 16*gd2*r) + 176*fd*g2*r*(r - 1)) + Dd*f*(3*f**2*(96*r**2 + 2*r*(88*s - 45) - 22*s + 11) + 11*f*(r*(8*s - 1) - s) + 176*g2*(4*r**2 - 5*r + 1))) + f*(D1*bdd1*(f*r*(f*(36*r + 66*s - 33) + 11*s) + 88*g2*(r - 1)**2) + 11*D1*f*r**2*(bd2 - 2*gd2) - 22*D1*fd*g2*(2*r**2 - 2*r + 1) - 22*Dd*f*g2*(4*r**2 - 2*r + 1))) + 11*b1**3*(D1**2*r**2*(fd - 4*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 8*Dd*fd*r*(1 - 4*r) - 4*Ddd*f*(4*r**2 - 2*r + 1)) + 24*Dd**2*f*r*(1 - 2*r)) + 11*b1**2*(D1**2*K*fd*r**2 - 4*D1**2*K*fdd*r**2 - 4*D1**2*bdd1*f*(3*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s + D1**2*f*fd*r + D1**2*f*fd + 12*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r + 12*D1**2*fd**2*r*s - 3*D1**2*fd**2*r + D1**2*fd*r**2 - 9*D1**2*fd*r*s + 9*D1**2*fd*r - 4*D1**2*fdd*r**2 + D1**2*fdd*r*s - D1**2*fdd*r + 4*D1*Dd*K*f*r**2 - 2*D1*Dd*K*f*r + D1*Dd*K*f - 32*D1*Dd*K*fd*r**2 + 8*D1*Dd*K*fd*r + 16*D1*Dd*f**2*r**2 - 24*D1*Dd*f**2*r*s - 2*D1*Dd*f**2*r + 6*D1*Dd*f**2*s + 4*D1*Dd*f**2 + 96*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r - 12*D1*Dd*f*fd*s + 3*D1*Dd*f*fd + 4*D1*Dd*f*r**2 - 36*D1*Dd*f*r*s + 7*D1*Dd*f*r + 9*D1*Dd*f*s + D1*Dd*f - 32*D1*Dd*fd*r**2 + 8*D1*Dd*fd*r*s + 3*D1*Dd*fd*r - D1*Dd*fd*s + D1*Dd*fd - 16*D1*Ddd*K*f*r**2 + 8*D1*Ddd*K*f*r - 4*D1*Ddd*K*f + 24*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r - 6*D1*Ddd*f**2*s - 16*D1*Ddd*f*r**2 + 4*D1*Ddd*f*r*s + 7*D1*Ddd*f*r - D1*Ddd*f*s - 4*D1*Ddd*f + D1*bd1*(D1*f*(3*r**2 - 2*r + 1) + 8*D1*fd*r*(1 - 3*r) - 8*Dd*f*(12*r**2 - 7*r + 1)) - 48*Dd**2*K*f*r**2 + 24*Dd**2*K*f*r + 72*Dd**2*f**2*r*s - 18*Dd**2*f**2*r - 18*Dd**2*f**2*s + 6*Dd**2*f**2 - 48*Dd**2*f*r**2 + 12*Dd**2*f*r*s + 21*Dd**2*f*r - 3*Dd**2*f*s + Dd**2*f) + b1*(22*D1**2*K*f*fd*r**2 - 22*D1**2*K*f*fd*r + 11*D1**2*K*f*fd + 11*D1**2*b2*fd*r**2 - 44*D1**2*b2*fdd*r**2 - 88*D1**2*bd1**2*f*r*(3*r - 2) + 11*D1**2*bd2*f*r**2 - 88*D1**2*bd2*fd*r**2 + 11*D1**2*bdd1*f*(K*(-8*r**2 + 8*r - 4) - 6*f*s - 8*r**2 + r*(12*f*s - 3*f + 2*s + 8) - s - 4) - 44*D1**2*bdd2*f*r**2 - 117*D1**2*f**2*fd*r**2 - 198*D1**2*f**2*fd*r*s + 111*D1**2*f**2*fd*r + 66*D1**2*f**2*fd*s - 39*D1**2*f**2*fd + 108*D1**2*f**2*fdd*r**2 + 198*D1**2*f**2*fdd*r*s - 105*D1**2*f**2*fdd*r - 66*D1**2*f**2*fdd*s + 36*D1**2*f**2*fdd + 216*D1**2*f*fd**2*r**2 + 396*D1**2*f*fd**2*r*s - 210*D1**2*f*fd**2*r - 132*D1**2*f*fd**2*s + 33*D1**2*f*fd**2 + 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r*s - 11*D1**2*f*fd*r + 11*D1**2*f*fd*s + 11*D1**2*f*fd + 22*D1**2*f*fdd*r*s - 11*D1**2*f*fdd*r - 11*D1**2*f*fdd*s - 22*D1**2*f*gd2*r**2 + 88*D1**2*f*gdd2*r**2 + 22*D1**2*fd**2*r*s - 11*D1**2*fd**2*r - 11*D1**2*fd**2*s + 11*D1**2*fd**2 - 22*D1**2*fd*g2*r**2 + 176*D1**2*fd*gd2*r**2 + 88*D1**2*fdd*g2*r**2 + 44*D1*Dd*K*f**2*r**2 - 22*D1*Dd*K*f**2*r + 11*D1*Dd*K*f**2 + 44*D1*Dd*b2*f*r**2 - 22*D1*Dd*b2*f*r + 11*D1*Dd*b2*f - 352*D1*Dd*b2*fd*r**2 + 88*D1*Dd*b2*fd*r - 352*D1*Dd*bd2*f*r**2 + 88*D1*Dd*bd2*f*r - 156*D1*Dd*f**3*r**2 - 264*D1*Dd*f**3*r*s + 144*D1*Dd*f**3*r + 66*D1*Dd*f**3*s - 39*D1*Dd*f**3 + 864*D1*Dd*f**2*fd*r**2 + 1584*D1*Dd*f**2*fd*r*s - 834*D1*Dd*f**2*fd*r - 462*D1*Dd*f**2*fd*s + 171*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 - 44*D1*Dd*f**2*r*s - 11*D1*Dd*f**2*r + 11*D1*Dd*f**2*s + 11*D1*Dd*f**2 + 176*D1*Dd*f*fd*r*s - 66*D1*Dd*f*fd*r - 66*D1*Dd*f*fd*s + 22*D1*Dd*f*fd - 88*D1*Dd*f*g2*r**2 + 44*D1*Dd*f*g2*r - 22*D1*Dd*f*g2 + 704*D1*Dd*f*gd2*r**2 - 176*D1*Dd*f*gd2*r + 704*D1*Dd*fd*g2*r**2 - 176*D1*Dd*fd*g2*r - 176*D1*Ddd*b2*f*r**2 + 88*D1*Ddd*b2*f*r - 44*D1*Ddd*b2*f + 144*D1*Ddd*f**3*r**2 + 264*D1*Ddd*f**3*r*s - 138*D1*Ddd*f**3*r - 66*D1*Ddd*f**3*s + 36*D1*Ddd*f**3 + 44*D1*Ddd*f**2*r*s - 11*D1*Ddd*f**2*r - 11*D1*Ddd*f**2*s + 352*D1*Ddd*f*g2*r**2 - 176*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(f**2*(8*r**2 - 3*r*(4*s + 1) + 6*s + 3) + f*(2*K*r**2 - 2*K*r + K + 3*fd*(4*r - 1)*(4*s - 1) + 2*r**2 - 18*r*s - 2*r + 9*s + 1) + fd*(-r**2*(16*K + 16) + r*(8*K + 4*s + 6) - s + 1)) + Dd*f*(-8*K*(8*r**2 - 6*r + 1) + 3*f*(8*r - 3)*(4*s - 1) - 64*r**2 + 16*r*s + 46*r - 6*s - 7)) - 528*Dd**2*b2*f*r**2 + 264*Dd**2*b2*f*r + 432*Dd**2*f**3*r**2 + 792*Dd**2*f**3*r*s - 414*Dd**2*f**3*r - 198*Dd**2*f**3*s + 66*Dd**2*f**3 + 132*Dd**2*f**2*r*s - 33*Dd**2*f**2*r - 33*Dd**2*f**2*s + 11*Dd**2*f**2 + 1056*Dd**2*f*g2*r**2 - 528*Dd**2*f*g2*r))/(231*d**2*k1) - D1**2*Pk2*Pkd1*(D1*r*(2*D1*bd1**2*(3*f**2*(3*r + 4*s - 2) + f*(r*(5*K + 5) + 12*s - 6) + 14*g2*(r - 1)) - 10*D1*bdd1*f*g2*r + b2*(-14*D1*bd1**2*(r - 1) + 5*D1*bdd1*f*r + 2*bd1*(2*D1*f*r + 5*D1*fd*(r - 1) + 5*Dd*f*(4*r - 1))) + 2*bd1*(D1*f*r*(5*bd2 - 4*g2 - 10*gd2) - 10*D1*fd*g2*(r - 1) + 10*Dd*f*g2*(1 - 4*r))) + b1**3*(D1**2*r*(4*fd*r - 14*fd*s + 5*fdd*r + 14*fdd*s) + D1*(2*Dd*(7*K*(4*r**2 - 2*r + 1) + f*(8*r**2 + r*(3 - 28*s) + 7*s + 2) + 20*fd*r**2 + 56*fd*r*s - 12*fd*r - 7*fd*s + 28*r**2 - 56*r*s + 14*s + 7) + Ddd*(-28*K*r**2 + 14*K*r - 7*K + f*(20*r**2 + 8*r*(7*s - 3) - 14*s + 5) - 28*r**2 + 56*r*s - 14*s - 7)) + 2*Dd**2*(-21*K*r*(2*r - 1) + f*(30*r**2 + 12*r*(7*s - 3) - 21*s + 7) - 42*r**2 + 84*r*s - 21*s + 7)) + b1**2*(4*D1**2*K*fd*r**2 - 8*D1**2*K*fd*r + 4*D1**2*K*fd + 5*D1**2*K*fdd*r**2 - 10*D1**2*K*fdd*r + 5*D1**2*K*fdd + 14*D1**2*bd2*r**2 + D1**2*bdd1*(-21*K*r**2 + 14*K*r - 7*K + f*(15*r**2 + 6*r*(7*s - 4) - 14*s + 5) - 21*r**2 + 42*r*s - 14*s - 7) - 7*D1**2*bdd2*r**2 - 12*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 12*D1**2*f*fd*s - 6*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r - 12*D1**2*f*fdd*s + 9*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 18*D1**2*fd**2*r - 12*D1**2*fd**2*s + 4*D1**2*fd*r**2 - 10*D1**2*fd*r*s - 8*D1**2*fd*r + 10*D1**2*fd*s + 4*D1**2*fd + 5*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s - 10*D1**2*fdd*r - 12*D1**2*fdd*s + 5*D1**2*fdd - 28*D1**2*gd2*r**2 + 14*D1**2*gdd2*r**2 + 16*D1*Dd*K*f*r**2 - 8*D1*Dd*K*f*r + 4*D1*Dd*K*f + 40*D1*Dd*K*fd*r**2 - 50*D1*Dd*K*fd*r + 10*D1*Dd*K*fd + 56*D1*Dd*b2*r**2 - 28*D1*Dd*b2*r + 14*D1*Dd*b2 - 56*D1*Dd*bd2*r**2 + 14*D1*Dd*bd2*r - 24*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s - 132*D1*Dd*f*fd*r - 72*D1*Dd*f*fd*s + 30*D1*Dd*f*fd + 16*D1*Dd*f*r**2 - 40*D1*Dd*f*r*s + 2*D1*Dd*f*r + 10*D1*Dd*f*s + 4*D1*Dd*f + 40*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 62*D1*Dd*fd*r - 60*D1*Dd*fd*s + 22*D1*Dd*fd - 112*D1*Dd*g2*r**2 + 56*D1*Dd*g2*r - 28*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 - 28*D1*Dd*gd2*r + 20*D1*Ddd*K*f*r**2 - 10*D1*Ddd*K*f*r + 5*D1*Ddd*K*f - 28*D1*Ddd*b2*r**2 + 14*D1*Ddd*b2*r - 7*D1*Ddd*b2 + 36*D1*Ddd*f**2*r**2 + 48*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 20*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 22*D1*Ddd*f*r - 12*D1*Ddd*f*s + 5*D1*Ddd*f + 56*D1*Ddd*g2*r**2 - 28*D1*Ddd*g2*r + 14*D1*Ddd*g2 + 2*D1*bd1*(D1*(7*K*(3*r**2 - 2*r + 1) + f*(6*r**2 + r*(3 - 21*s) + 7*s + 2) + 15*fd*r**2 + 42*fd*r*s - 12*fd*r - 7*fd*s + 21*r**2 - 42*r*s + 14*s + 7) + Dd*(-84*K*r**2 + 49*K*r - 7*K + f*(60*r**2 + 84*r*(2*s - 1) - 49*s + 19) - 84*r**2 + 168*r*s - 49*s + 7)) + 60*Dd**2*K*f*r**2 - 30*Dd**2*K*f*r - 84*Dd**2*b2*r**2 + 42*Dd**2*b2*r + 108*Dd**2*f**2*r**2 + 144*Dd**2*f**2*r*s - 90*Dd**2*f**2*r - 36*Dd**2*f**2*s + 12*Dd**2*f**2 + 60*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 66*Dd**2*f*r - 36*Dd**2*f*s + 12*Dd**2*f + 168*Dd**2*g2*r**2 - 84*Dd**2*g2*r) + b1*(10*D1**2*K*bdd1*f*r**2 + 2*D1**2*bd1**2*(-7*K*r*(3*r - 2) + f*(15*r**2 + 6*r*(7*s - 4) - 14*s + 7) - 21*r**2 + 42*r*s - 14*s + 7) + 4*D1**2*bd2*f*r**2 + 10*D1**2*bd2*fd*r**2 - 10*D1**2*bd2*fd*r + 18*D1**2*bdd1*f**2*r**2 + 24*D1**2*bdd1*f**2*r*s - 12*D1**2*bdd1*f**2*r + 10*D1**2*bdd1*f*r**2 + 24*D1**2*bdd1*f*r*s - 12*D1**2*bdd1*f*r + 28*D1**2*bdd1*g2*r**2 - 28*D1**2*bdd1*g2*r + 14*D1**2*bdd1*g2 + 5*D1**2*bdd2*f*r**2 - 8*D1**2*f*gd2*r**2 - 10*D1**2*f*gdd2*r**2 - 8*D1**2*fd*g2*r**2 + 16*D1**2*fd*g2*r - 8*D1**2*fd*g2 - 20*D1**2*fd*gd2*r**2 + 20*D1**2*fd*gd2*r - 10*D1**2*fdd*g2*r**2 + 20*D1**2*fdd*g2*r - 10*D1**2*fdd*g2 + 40*D1*Dd*bd2*f*r**2 - 10*D1*Dd*bd2*f*r - 32*D1*Dd*f*g2*r**2 + 16*D1*Dd*f*g2*r - 8*D1*Dd*f*g2 - 80*D1*Dd*f*gd2*r**2 + 20*D1*Dd*f*gd2*r - 80*D1*Dd*fd*g2*r**2 + 100*D1*Dd*fd*g2*r - 20*D1*Dd*fd*g2 - 40*D1*Ddd*f*g2*r**2 + 20*D1*Ddd*f*g2*r - 10*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(2*fd*(3*f*(6*r**2 + r*(8*s - 5) - 2*s + 1) + r**2*(5*K + 5) + r*(-5*K + 12*s - 8) - 6*s + 3) - 14*g2*(2*r**2 - 2*r + 1) + r*(bd2*(7 - 14*r) - 6*f**2*(r + 2*s - 1) + f*(r*(4*K + 4) - 10*s + 5) + 14*gd2*(2*r - 1))) + 2*Dd*(3*f**2*(12*r**2 + r*(16*s - 9) - 2*s + 1) + f*(r**2*(20*K + 20) + r*(-5*K + 48*s - 23) - 6*s + 3) + 7*g2*(8*r**2 - 6*r + 1))) - 120*Dd**2*f*g2*r**2 + 60*Dd**2*f*g2*r + b2*(-7*D1**2*bdd1*(2*r**2 - 2*r + 1) + 4*D1**2*fd*r**2 - 8*D1**2*fd*r + 4*D1**2*fd + 5*D1**2*fdd*r**2 - 10*D1**2*fdd*r + 5*D1**2*fdd + 16*D1*Dd*f*r**2 - 8*D1*Dd*f*r + 4*D1*Dd*f + 40*D1*Dd*fd*r**2 - 50*D1*Dd*fd*r + 10*D1*Dd*fd + 20*D1*Ddd*f*r**2 - 10*D1*Ddd*f*r + 5*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 - 2*r + 1) + Dd*(-8*r**2 + 6*r - 1)) + 60*Dd**2*f*r**2 - 30*Dd**2*f*r)))/(21*d**2*k1) - D1**2*Pk2*Pkdd1*ct**6*k2**2*(2*C - 2)*(264*D1**2*b1*f*fd*r**2 - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 165*D1**2*bdd1*f**2*(r - 1)**2 + 345*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 + 660*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 + 1960*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 + 330*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r - 140*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) - 1980*Dd**2*b1*f**2*r**2 + 990*Dd**2*b1*f**2*r - 1680*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r)/(693*d**2*k3**2) + 5*D1**2*Pk2*Pkdd1*ct**5*f*k2*(897*D1**2*b1*f*fd*r**2 - 1092*D1**2*b1*f*fdd*r**2 - 2184*D1**2*b1*fd**2*r**2 - 364*D1**2*bdd1*f**2*(r - 1)**2 + 1064*D1**2*f**2*fd*r**2 - 532*D1**2*f**2*fd*r + 266*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r**2 + 630*D1**2*f**2*fdd*r - 315*D1**2*f**2*fdd - 3780*D1**2*f*fd**2*r**2 + 1890*D1**2*f*fd**2*r + 1196*D1*Dd*b1*f**2*r**2 - 598*D1*Dd*b1*f**2*r + 299*D1*Dd*b1*f**2 - 8736*D1*Dd*b1*f*fd*r**2 + 2184*D1*Dd*b1*f*fd*r + 1064*D1*Dd*f**3*r**2 - 532*D1*Dd*f**3*r + 266*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r**2 + 5040*D1*Dd*f**2*fd*r - 630*D1*Dd*f**2*fd - 1456*D1*Ddd*b1*f**2*r**2 + 728*D1*Ddd*b1*f**2*r - 364*D1*Ddd*b1*f**2 - 1260*D1*Ddd*f**3*r**2 + 630*D1*Ddd*f**3*r - 315*D1*Ddd*f**3 + 13*D1*bd1*f*(r - 1)*(23*D1*f*(r - 1) - 168*D1*fd*r + 56*Dd*f*(1 - 4*r)) - 4368*Dd**2*b1*f**2*r**2 + 2184*Dd**2*b1*f**2*r - 3780*Dd**2*f**3*r**2 + 1890*Dd**2*f**3*r)/(9009*d**2*k1) - D1**2*Pk2*Pkdd1*ct**5*k1*k2*(4*C - 5)*(264*D1**2*b1*f*fd*r**2 - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 165*D1**2*bdd1*f**2*(r - 1)**2 + 345*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 + 660*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 + 1960*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 + 330*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r - 140*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) - 1980*Dd**2*b1*f**2*r**2 + 990*Dd**2*b1*f**2*r - 1680*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r)/(693*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct**5*k2**3*(264*D1**2*b1*f*fd*r**2 - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 165*D1**2*bdd1*f**2*(r - 1)**2 + 345*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 + 660*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 + 1960*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 + 330*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r - 140*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) - 1980*Dd**2*b1*f**2*r**2 + 990*Dd**2*b1*f**2*r - 1680*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r)/(693*d**2*k1*k3**2) - D1**2*Pk2*Pkdd1*ct**4*k1**2*(2*C - 4)*(264*D1**2*b1*f*fd*r**2 - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 165*D1**2*bdd1*f**2*(r - 1)**2 + 345*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 + 660*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 + 1960*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 + 330*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r - 140*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) - 1980*Dd**2*b1*f**2*r**2 + 990*Dd**2*b1*f**2*r - 1680*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r)/(693*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**4*k2**2*st**2*(2*C - 2)*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(231*d**2*k3**2) - 2*D1**2*Pk2*Pkdd1*ct**4*k2**2*(33*b1**2*(C - 1)*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + 33*b1*(-8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd + 10*C*D1**2*f*fdd*r - 5*C*D1**2*f*fdd + 10*C*D1**2*fd**2*r + 40*C*D1*Dd*f*fd*r - 10*C*D1*Dd*f*fd - 6*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 16*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r - 4*D1**2*f*fd + 20*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r + 5*D1**2*f*fdd + 20*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r - 32*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r - 8*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r + 10*D1*Dd*f*fd + 40*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r + 10*D1*Ddd*f**2 + D1*bd1*(C - 1)*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) + 120*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r) + f*(-396*D1**2*bd1**2*r*(C - 1)*(r - 1) + 165*D1**2*bdd1*f*(-2*C*r + C + 2*r**2 - 2*r + 1) + 66*D1*bd1*(-2*D1*f*(-2*C*r + C + 2*r**2 - 2*r + 1) - 5*D1*fd*r*(C - 4*r + 3) - 5*Dd*f*(4*r - 1)*(C - 2*r + 1)) - (5*C + 5)*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 - 2*r + 1) + 56*fd**2*r*(2 - 3*r)) + D1*f*(23*Dd*f*(4*r**2 - 2*r + 1) - 56*Dd*fd*(12*r**2 - 7*r + 1) - 28*Ddd*f*(4*r**2 - 2*r + 1)) + 168*Dd**2*f**2*r*(1 - 2*r))))/(693*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**4*(-2145*D1**2*K*bdd1*f**2*r**2 + 858*D1**2*bd1**2*f*r*(r - 1)*(-6*K + 5*f + 6) + 5460*D1**2*bdd1*f**3*r**2 - 7280*D1**2*bdd1*f**3*r + 3640*D1**2*bdd1*f**3 + 2145*D1**2*bdd1*f**2*r**2 + 5148*D1**2*bdd1*f*g2*r**2 - 10296*D1**2*bdd1*f*g2*r + 5148*D1**2*bdd1*f*g2 - 10640*D1**2*f**3*fd*r**2 + 5320*D1**2*f**3*fd*r - 2660*D1**2*f**3*fd + 12600*D1**2*f**3*fdd*r**2 - 6300*D1**2*f**3*fdd*r + 3150*D1**2*f**3*fdd + 37800*D1**2*f**2*fd**2*r**2 - 18900*D1**2*f**2*fd**2*r - 3432*D1**2*f**2*gd2*r**2 + 4290*D1**2*f**2*gdd2*r**2 - 6864*D1**2*f*fd*g2*r**2 + 6864*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r**2 - 8580*D1**2*f*fd*gd2*r + 8580*D1**2*f*fdd*g2*r**2 - 8580*D1**2*f*fdd*g2*r + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r**2 - 8580*D1**2*fd**2*g2*r - 10640*D1*Dd*f**4*r**2 + 5320*D1*Dd*f**4*r - 2660*D1*Dd*f**4 + 100800*D1*Dd*f**3*fd*r**2 - 50400*D1*Dd*f**3*fd*r + 6300*D1*Dd*f**3*fd - 13728*D1*Dd*f**2*g2*r**2 + 6864*D1*Dd*f**2*g2*r - 3432*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r**2 - 8580*D1*Dd*f**2*gd2*r + 68640*D1*Dd*f*fd*g2*r**2 - 51480*D1*Dd*f*fd*g2*r + 8580*D1*Dd*f*fd*g2 + 12600*D1*Ddd*f**4*r**2 - 6300*D1*Ddd*f**4*r + 3150*D1*Ddd*f**4 + 17160*D1*Ddd*f**2*g2*r**2 - 8580*D1*Ddd*f**2*g2*r + 4290*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(115*f**3*(3*r**2 - 4*r + 2) - 4*f**2*r*(70*fd*(9*r - 7) + r*(33*K - 33)) + 66*f*(5*fd*r*(K - 1)*(2*r - 1) + 5*g2*(r - 1)**2 - 12*gd2*r*(r - 1)) - 792*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(140*f**2*(3*r - 2) - 165*f*r*(K - 1) + 396*g2*(r - 1))) + 37800*Dd**2*f**4*r**2 - 18900*Dd**2*f**4*r + 51480*Dd**2*f**2*g2*r**2 - 25740*Dd**2*f**2*g2*r - 429*b1**2*(D1**2*r**2*(-10*fd**2 + fd*(-5*K + 8*f + 5) - 2*fdd*(-3*K + 5*f + 3)) + D1*(Dd*(4*f**2*(4*r**2 - 2*r + 1) - 5*f*(K*(4*r**2 - 2*r + 1) + r**2*(16*fd - 4) + r*(2 - 4*fd) - 1) + 12*fd*r*(K - 1)*(4*r - 1)) - Ddd*f*(-6*K + 5*f + 6)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(2*r - 1)*(-6*K + 5*f + 6)) - 13*b1*(-264*D1**2*K*f*fd*r**2 + 264*D1**2*K*f*fd*r - 132*D1**2*K*f*fd + 330*D1**2*K*f*fdd*r**2 - 330*D1**2*K*f*fdd*r + 165*D1**2*K*f*fdd + 330*D1**2*K*fd**2*r**2 - 330*D1**2*K*fd**2*r - 33*D1**2*bdd1*f*(-6*K + 5*f + 6)*(2*r**2 - 2*r + 1) + 1035*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 2520*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 264*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 + 330*D1**2*f*fdd*r - 165*D1**2*f*fdd + 330*D1**2*f*gd2*r**2 - 396*D1**2*f*gdd2*r**2 - 330*D1**2*fd**2*r**2 + 330*D1**2*fd**2*r + 330*D1**2*fd*g2*r**2 - 792*D1**2*fd*gd2*r**2 - 396*D1**2*fdd*g2*r**2 - 528*D1*Dd*K*f**2*r**2 + 264*D1*Dd*K*f**2*r - 132*D1*Dd*K*f**2 + 2640*D1*Dd*K*f*fd*r**2 - 1980*D1*Dd*K*f*fd*r + 330*D1*Dd*K*f*fd + 1380*D1*Dd*f**3*r**2 - 690*D1*Dd*f**3*r + 345*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r**2 + 3640*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 + 1980*D1*Dd*f*fd*r - 330*D1*Dd*f*fd + 1320*D1*Dd*f*g2*r**2 - 660*D1*Dd*f*g2*r + 330*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 + 792*D1*Dd*f*gd2*r - 3168*D1*Dd*fd*g2*r**2 + 792*D1*Dd*fd*g2*r + 660*D1*Ddd*K*f**2*r**2 - 330*D1*Ddd*K*f**2*r + 165*D1*Ddd*K*f**2 - 1680*D1*Ddd*f**3*r**2 + 840*D1*Ddd*f**3*r - 420*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 + 330*D1*Ddd*f**2*r - 165*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 + 792*D1*Ddd*f*g2*r - 396*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(f**2*(8*r**2 - 8*r + 4) - 5*f*(K*(2*r**2 - 2*r + 1) + r**2*(8*fd - 2) + r*(2 - 4*fd) - 1) + 12*fd*r*(K - 1)*(2*r - 1)) - 2*Dd*f*(-6*K + 5*f + 6)*(8*r**2 - 6*r + 1)) + 1980*Dd**2*K*f**2*r**2 - 990*Dd**2*K*f**2*r - 5040*Dd**2*f**3*r**2 + 2520*Dd**2*f**3*r - 1980*Dd**2*f**2*r**2 + 990*Dd**2*f**2*r - 4752*Dd**2*f*g2*r**2 + 2376*Dd**2*f*g2*r))/(9009*d**2) + 5*D1**2*Pk2*Pkdd1*ct**3*f*k2*st**2*(663*D1**2*b1*f*fd*r**2 - 975*D1**2*b1*f*fdd*r**2 - 1950*D1**2*b1*fd**2*r**2 - 325*D1**2*bdd1*f**2*(r - 1)**2 + 660*D1**2*f**2*fd*r**2 - 330*D1**2*f**2*fd*r + 165*D1**2*f**2*fd - 980*D1**2*f**2*fdd*r**2 + 490*D1**2*f**2*fdd*r - 245*D1**2*f**2*fdd - 2940*D1**2*f*fd**2*r**2 + 1470*D1**2*f*fd**2*r + 884*D1*Dd*b1*f**2*r**2 - 442*D1*Dd*b1*f**2*r + 221*D1*Dd*b1*f**2 - 7800*D1*Dd*b1*f*fd*r**2 + 1950*D1*Dd*b1*f*fd*r + 660*D1*Dd*f**3*r**2 - 330*D1*Dd*f**3*r + 165*D1*Dd*f**3 - 7840*D1*Dd*f**2*fd*r**2 + 3920*D1*Dd*f**2*fd*r - 490*D1*Dd*f**2*fd - 1300*D1*Ddd*b1*f**2*r**2 + 650*D1*Ddd*b1*f**2*r - 325*D1*Ddd*b1*f**2 - 980*D1*Ddd*f**3*r**2 + 490*D1*Ddd*f**3*r - 245*D1*Ddd*f**3 + 13*D1*bd1*f*(r - 1)*(17*D1*f*(r - 1) - 150*D1*fd*r + 50*Dd*f*(1 - 4*r)) - 3900*Dd**2*b1*f**2*r**2 + 1950*Dd**2*b1*f**2*r - 2940*Dd**2*f**3*r**2 + 1470*Dd**2*f**3*r)/(9009*d**2*k1) + D1**2*Pk2*Pkdd1*ct**3*k1**3*(264*D1**2*b1*f*fd*r**2 - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 165*D1**2*bdd1*f**2*(r - 1)**2 + 345*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 + 660*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 + 1960*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 + 330*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r - 140*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) - 1980*Dd**2*b1*f**2*r**2 + 990*Dd**2*b1*f**2*r - 1680*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r)/(693*d**2*k2*k3**2) - D1**2*Pk2*Pkdd1*ct**3*k1*k2*st**2*(2*C - 3)*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(231*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**3*k1*k2*(33*b1**2*(4*C - 5)*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + 33*b1*(-32*C*D1**2*f*fd*r + 16*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r + 160*C*D1*Dd*f*fd*r - 40*C*D1*Dd*f*fd - 6*D1**2*bdd1*f*(4*C - 5)*(2*r**2 - 2*r + 1) - 48*D1**2*f*fd*r**2 + 40*D1**2*f*fd*r - 20*D1**2*f*fd + 60*D1**2*f*fdd*r**2 - 50*D1**2*f*fdd*r + 25*D1**2*f*fdd + 60*D1**2*fd**2*r**2 - 50*D1**2*fd**2*r - 96*D1*Dd*f**2*r**2 + 48*D1*Dd*f**2*r - 24*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 - 320*D1*Dd*f*fd*r + 50*D1*Dd*f*fd + 120*D1*Ddd*f**2*r**2 - 60*D1*Ddd*f**2*r + 30*D1*Ddd*f**2 + D1*bd1*(4*C - 5)*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) + 360*Dd**2*f**2*r**2 - 180*Dd**2*f**2*r) + f*(-396*D1**2*bd1**2*r*(4*C - 5)*(r - 1) - 165*D1**2*bdd1*f*(C*(8*r - 4) - 6*r**2 + 2*r - 1) + 66*D1*bd1*(2*D1*f*(C*(8*r - 4) - 6*r**2 + 2*r - 1) + 5*D1*fd*r*(-4*C + 12*r - 7) - 5*Dd*f*(4*r - 1)*(4*C - 6*r + 1)) - 5*(4*C + 1)*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 - 2*r + 1) + 56*fd**2*r*(2 - 3*r)) + D1*f*(23*Dd*f*(4*r**2 - 2*r + 1) - 56*Dd*fd*(12*r**2 - 7*r + 1) - 28*Ddd*f*(4*r**2 - 2*r + 1)) + 168*Dd**2*f**2*r*(1 - 2*r))))/(693*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct**3*k1*(429*b1**2*(D1**2*r**2*(-10*fd**2 + fd*(8*f + 5) - fdd*(10*f + 6)) + D1*(Dd*(4*f**2*(4*r**2 - 2*r + 1) - 5*f*(r**2*(16*fd - 4) + r*(2 - 4*fd) - 1) + 12*fd*r*(1 - 4*r)) - Ddd*f*(5*f + 6)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(5*f + 6)*(2*r - 1)) + 13*b1*(-33*D1**2*bdd1*f*(5*f + 6)*(2*r**2 - 2*r + 1) + 690*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 1680*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 264*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 + 330*D1**2*f*fdd*r - 165*D1**2*f*fdd - 330*D1**2*fd**2*r**2 + 330*D1**2*fd**2*r + 920*D1*Dd*f**3*r**2 - 460*D1*Dd*f**3*r + 230*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 + 2800*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 + 1980*D1*Dd*f*fd*r - 330*D1*Dd*f*fd - 1120*D1*Ddd*f**3*r**2 + 560*D1*Ddd*f**3*r - 280*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 + 330*D1*Ddd*f**2*r - 165*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f**2*(8*r**2 - 8*r + 4) - 5*f*(r**2*(8*fd - 2) + r*(2 - 4*fd) - 1) + 12*fd*r*(1 - 2*r)) - 2*Dd*f*(5*f + 6)*(8*r**2 - 6*r + 1)) - 3360*Dd**2*f**3*r**2 + 1680*Dd**2*f**3*r - 1980*Dd**2*f**2*r**2 + 990*Dd**2*f**2*r) + f*(-858*D1**2*bd1**2*r*(5*f + 6)*(r - 1) - 65*D1**2*bdd1*f*(28*f*(2*r**2 - 2*r + 1) + 33*r**2) + 13*D1*bd1*(D1*(115*f**2*(2*r**2 - 2*r + 1) - 4*f*r*(140*fd*(3*r - 2) - 33*r) + 330*fd*r*(1 - 2*r)) - 10*Dd*f*(4*r - 1)*(28*f*(2*r - 1) + 33*r)) + 35*f*(D1**2*(f*(38*fd - 45*fdd)*(4*r**2 - 2*r + 1) + 270*fd**2*r*(1 - 2*r)) + D1*f*(38*Dd*f*(4*r**2 - 2*r + 1) - 90*Dd*fd*(1 - 4*r)**2 - 45*Ddd*f*(4*r**2 - 2*r + 1)) + 270*Dd**2*f**2*r*(1 - 2*r))))/(9009*d**2*k2) + D1**2*Pk2*Pkdd1*ct**3*k2**3*st**2*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(231*d**2*k1*k3**2) + D1**2*Pk2*Pkdd1*ct**3*k2**3*(D1*f*r*(-12*D1*bd1**2*(r - 1) - 5*D1*bdd1*f*r + 2*bd1*(2*D1*f*r + D1*fd*(5 - 10*r) + 5*Dd*f*(1 - 4*r))) + b1**2*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + b1*(-6*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 60*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + D1*bd1*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(21*d**2*k1*k3**2) + D1**2*Pk2*Pkdd1*ct**3*k2*(D1*f*r*(-132*D1*bd1**2*(5*f + 3)*(r - 1) - 5*D1*bdd1*f*r*(56*f + 33) + 2*bd1*(D1*f*r*(115*f + 66) - 5*D1*fd*(56*f*(3*r - 1) + 66*r - 33) - 5*Dd*f*(56*f + 33)*(4*r - 1))) + 33*b1**2*(D1**2*r**2*(-20*fd**2 + fd*(16*f + 5) - fdd*(20*f + 6)) + D1*(Dd*(8*f**2*(4*r**2 - 2*r + 1) - 5*f*(r**2*(32*fd - 4) + r*(2 - 8*fd) - 1) + 12*fd*r*(1 - 4*r)) - 2*Ddd*f*(5*f + 3)*(4*r**2 - 2*r + 1)) - 12*Dd**2*f*r*(5*f + 3)*(2*r - 1)) + b1*(-66*D1**2*bdd1*f*(5*f + 3)*(2*r**2 - 2*r + 1) + 690*D1**2*f**2*fd*r**2 - 460*D1**2*f**2*fd*r + 230*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 + 560*D1**2*f**2*fdd*r - 280*D1**2*f**2*fdd - 1680*D1**2*f*fd**2*r**2 + 1120*D1**2*f*fd**2*r + 264*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 + 330*D1**2*f*fdd*r - 165*D1**2*f*fdd - 330*D1**2*fd**2*r**2 + 330*D1**2*fd**2*r + 920*D1*Dd*f**3*r**2 - 460*D1*Dd*f**3*r + 230*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 + 3920*D1*Dd*f**2*fd*r - 560*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 + 1980*D1*Dd*f*fd*r - 330*D1*Dd*f*fd - 1120*D1*Ddd*f**3*r**2 + 560*D1*Ddd*f**3*r - 280*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 + 330*D1*Ddd*f**2*r - 165*D1*Ddd*f**2 + 33*D1*bd1*(D1*(8*f**2*(2*r**2 - 2*r + 1) - 5*f*(r**2*(16*fd - 2) + r*(2 - 8*fd) - 1) + 12*fd*r*(1 - 2*r)) - 4*Dd*f*(5*f + 3)*(8*r**2 - 6*r + 1)) - 3360*Dd**2*f**3*r**2 + 1680*Dd**2*f**3*r - 1980*Dd**2*f**2*r**2 + 990*Dd**2*f**2*r))/(693*d**2*k1) - D1**2*Pk2*Pkdd1*ct**2*f*k2**2*st**4*(2*C - 2)*(33*D1**2*bd1*f*(r - 1)**2 + 6*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 6*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 + 14*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + 33*D1*b1*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r)/(231*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**2*k1**2*st**2*(C - 4)*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(693*d**2*k3**2) - 2*D1**2*Pk2*Pkdd1*ct**2*k1**2*(33*b1**2*(C - 2)*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + 33*b1*(-8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd + 10*C*D1**2*f*fdd*r - 5*C*D1**2*f*fdd + 10*C*D1**2*fd**2*r + 40*C*D1*Dd*f*fd*r - 10*C*D1*Dd*f*fd - 6*D1**2*bdd1*f*(C - 2)*(2*r**2 - 2*r + 1) - 16*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r - 8*D1**2*f*fd + 20*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r + 10*D1**2*f*fdd + 20*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r - 32*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r - 8*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 - 120*D1*Dd*f*fd*r + 20*D1*Dd*f*fd + 40*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r + 10*D1*Ddd*f**2 + D1*bd1*(C - 2)*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) + 120*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r) + f*(-5*C*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 - 2*r + 1) + 56*fd**2*r*(2 - 3*r)) + D1*f*(23*Dd*f*(4*r**2 - 2*r + 1) - 56*Dd*fd*(12*r**2 - 7*r + 1) - 28*Ddd*f*(4*r**2 - 2*r + 1)) + 168*Dd**2*f**2*r*(1 - 2*r)) - 396*D1**2*bd1**2*r*(C - 2)*(r - 1) + 165*D1**2*bdd1*f*(-2*C*r + C + 2*r**2) + 66*D1*bd1*(C*D1*(f*(4*r - 2) - 5*fd*r) + 5*C*Dd*f*(1 - 4*r) + 2*D1*r*(-2*f*r + 5*fd*(2*r - 1)) + 10*Dd*f*r*(4*r - 1))))/(693*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**2*k2**2*st**2*(11*b1**2*(C - 1)*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) + 11*b1*(-10*C*D1**2*f*fd*r**2 - 2*C*D1**2*f*fd*r + C*D1**2*f*fd + 10*C*D1**2*f*fdd*r**2 + 2*C*D1**2*f*fdd*r - C*D1**2*f*fdd + 10*C*D1**2*fd**2*r**2 + 2*C*D1**2*fd**2*r - 20*C*D1*Dd*f**2*r**2 + 10*C*D1*Dd*f**2*r - 5*C*D1*Dd*f**2 + 80*C*D1*Dd*f*fd*r**2 - 12*C*D1*Dd*f*fd*r - 2*C*D1*Dd*f*fd + 20*C*D1*Ddd*f**2*r**2 - 10*C*D1*Ddd*f**2*r + 5*C*D1*Ddd*f**2 + 60*C*Dd**2*f**2*r**2 - 30*C*Dd**2*f**2*r - D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 8*D1**2*f*fd*r**2 + 2*D1**2*f*fd*r - D1**2*f*fd + 8*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r + D1**2*f*fdd + 8*D1**2*fd**2*r**2 - 2*D1**2*fd**2*r - 16*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r - 4*D1*Dd*f**2 + 64*D1*Dd*f*fd*r**2 - 24*D1*Dd*f*fd*r + 2*D1*Dd*f*fd + 16*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r + 4*D1*Ddd*f**2 + D1*bd1*(C - 1)*(9*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 2*r) - 2*Dd*f*(8*r**2 - 6*r + 1)) + 48*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r) + f*(-22*D1**2*bd1**2*r*(C - 1)*(r - 1) + 11*D1**2*bdd1*f*(C*(5*r**2 - 12*r + 6) + 4*r**2 - 6*r + 3) - 11*D1*bd1*(D1*(f*(C*(5*r**2 - 12*r + 6) + 4*r**2 - 6*r + 3) + 2*fd*r*(C*(11 - 10*r) - 8*r + 7)) - 2*Dd*f*(4*r - 1)*(C*(5*r - 6) + 4*r - 3)) - (2*C + 1)*(D1**2*(f*(17*fd - 25*fdd)*(3*r**2 - 2*r + 1) + 50*fd**2*r*(2 - 3*r)) + D1*f*(17*Dd*f*(4*r**2 - 2*r + 1) - 50*Dd*fd*(12*r**2 - 7*r + 1) - 25*Ddd*f*(4*r**2 - 2*r + 1)) + 150*Dd**2*f**2*r*(1 - 2*r))))/(231*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct**2*k2**2*(2*C + 2)*(D1*f*r*(-12*D1*bd1**2*(r - 1) - 5*D1*bdd1*f*r + 2*bd1*(2*D1*f*r + D1*fd*(5 - 10*r) + 5*Dd*f*(1 - 4*r))) + b1**2*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + b1*(-6*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 60*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + D1*bd1*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(21*d**2*k3**2) - D1**2*Pk2*Pkdd1*ct**2*st**2*(-143*D1**2*K*bdd1*f**2*r**2 + 286*D1**2*bd1**2*f*r*(r - 1)*(-K + 6*f + 1) + 1950*D1**2*bdd1*f**3*r**2 - 2600*D1**2*bdd1*f**3*r + 1300*D1**2*bdd1*f**3 + 143*D1**2*bdd1*f**2*r**2 + 286*D1**2*bdd1*f*g2*r**2 - 572*D1**2*bdd1*f*g2*r + 286*D1**2*bdd1*f*g2 - 2640*D1**2*f**3*fd*r**2 + 1320*D1**2*f**3*fd*r - 660*D1**2*f**3*fd + 3920*D1**2*f**3*fdd*r**2 - 1960*D1**2*f**3*fdd*r + 980*D1**2*f**3*fdd + 11760*D1**2*f**2*fd**2*r**2 - 5880*D1**2*f**2*fd**2*r - 286*D1**2*f**2*gd2*r**2 + 286*D1**2*f**2*gdd2*r**2 - 572*D1**2*f*fd*g2*r**2 + 572*D1**2*f*fd*g2*r - 286*D1**2*f*fd*g2 + 1144*D1**2*f*fd*gd2*r**2 - 572*D1**2*f*fd*gd2*r + 572*D1**2*f*fdd*g2*r**2 - 572*D1**2*f*fdd*g2*r + 286*D1**2*f*fdd*g2 + 572*D1**2*fd**2*g2*r**2 - 572*D1**2*fd**2*g2*r - 2640*D1*Dd*f**4*r**2 + 1320*D1*Dd*f**4*r - 660*D1*Dd*f**4 + 31360*D1*Dd*f**3*fd*r**2 - 15680*D1*Dd*f**3*fd*r + 1960*D1*Dd*f**3*fd - 1144*D1*Dd*f**2*g2*r**2 + 572*D1*Dd*f**2*g2*r - 286*D1*Dd*f**2*g2 + 2288*D1*Dd*f**2*gd2*r**2 - 572*D1*Dd*f**2*gd2*r + 4576*D1*Dd*f*fd*g2*r**2 - 3432*D1*Dd*f*fd*g2*r + 572*D1*Dd*f*fd*g2 + 3920*D1*Ddd*f**4*r**2 - 1960*D1*Ddd*f**4*r + 980*D1*Ddd*f**4 + 1144*D1*Ddd*f**2*g2*r**2 - 572*D1*Ddd*f**2*g2*r + 286*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(34*f**3*(3*r**2 - 4*r + 2) + f**2*r*(-100*fd*(9*r - 7) + r*(11 - 11*K)) + 22*f*(fd*r*(K - 1)*(2*r - 1) + 9*g2*(r - 1)**2 - 2*gd2*r*(r - 1)) - 44*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(50*f**2*(3*r - 2) - 11*f*r*(K - 1) + 22*g2*(r - 1))) + 11760*Dd**2*f**4*r**2 - 5880*Dd**2*f**4*r + 3432*Dd**2*f**2*g2*r**2 - 1716*Dd**2*f**2*g2*r - 143*b1**2*(-D1**2*r**2*(12*fd**2 - 3*fd*(-3*K + 4*f + 3) + fdd*(-K + 12*f + 1)) + D1*(Dd*(6*f**2*(4*r**2 - 2*r + 1) - 3*f*(3*K*(4*r**2 - 2*r + 1) + r**2*(32*fd - 12) + r*(6 - 8*fd) - 3) + 2*fd*r*(K - 1)*(4*r - 1)) - Ddd*f*(-K + 6*f + 1)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(2*r - 1)*(-K + 6*f + 1)) - 13*b1*(-22*D1**2*K*f*fd*r**2 + 22*D1**2*K*f*fd*r - 11*D1**2*K*f*fd + 22*D1**2*K*f*fdd*r**2 - 22*D1**2*K*f*fdd*r + 11*D1**2*K*f*fdd + 22*D1**2*K*fd**2*r**2 - 22*D1**2*K*fd**2*r - 11*D1**2*bdd1*f*(-K + 6*f + 1)*(2*r**2 - 2*r + 1) + 306*D1**2*f**2*fd*r**2 - 68*D1**2*f**2*fd*r + 34*D1**2*f**2*fd - 450*D1**2*f**2*fdd*r**2 + 100*D1**2*f**2*fdd*r - 50*D1**2*f**2*fdd - 900*D1**2*f*fd**2*r**2 + 200*D1**2*f*fd**2*r + 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r + 11*D1**2*f*fd - 22*D1**2*f*fdd*r**2 + 22*D1**2*f*fdd*r - 11*D1**2*f*fdd + 198*D1**2*f*gd2*r**2 - 22*D1**2*f*gdd2*r**2 - 22*D1**2*fd**2*r**2 + 22*D1**2*fd**2*r + 198*D1**2*fd*g2*r**2 - 44*D1**2*fd*gd2*r**2 - 22*D1**2*fdd*g2*r**2 - 44*D1*Dd*K*f**2*r**2 + 22*D1*Dd*K*f**2*r - 11*D1*Dd*K*f**2 + 176*D1*Dd*K*f*fd*r**2 - 132*D1*Dd*K*f*fd*r + 22*D1*Dd*K*f*fd + 408*D1*Dd*f**3*r**2 - 204*D1*Dd*f**3*r + 102*D1*Dd*f**3 - 3600*D1*Dd*f**2*fd*r**2 + 1300*D1*Dd*f**2*fd*r - 100*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 - 22*D1*Dd*f**2*r + 11*D1*Dd*f**2 - 176*D1*Dd*f*fd*r**2 + 132*D1*Dd*f*fd*r - 22*D1*Dd*f*fd + 792*D1*Dd*f*g2*r**2 - 396*D1*Dd*f*g2*r + 198*D1*Dd*f*g2 - 176*D1*Dd*f*gd2*r**2 + 44*D1*Dd*f*gd2*r - 176*D1*Dd*fd*g2*r**2 + 44*D1*Dd*fd*g2*r + 44*D1*Ddd*K*f**2*r**2 - 22*D1*Ddd*K*f**2*r + 11*D1*Ddd*K*f**2 - 600*D1*Ddd*f**3*r**2 + 300*D1*Ddd*f**3*r - 150*D1*Ddd*f**3 - 44*D1*Ddd*f**2*r**2 + 22*D1*Ddd*f**2*r - 11*D1*Ddd*f**2 - 88*D1*Ddd*f*g2*r**2 + 44*D1*Ddd*f*g2*r - 22*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(6*f**2*(2*r**2 - 2*r + 1) - 3*f*(K*(6*r**2 - 6*r + 3) + r**2*(16*fd - 6) + r*(6 - 8*fd) - 3) + 2*fd*r*(K - 1)*(2*r - 1)) - 2*Dd*f*(-K + 6*f + 1)*(8*r**2 - 6*r + 1)) + 132*Dd**2*K*f**2*r**2 - 66*Dd**2*K*f**2*r - 1800*Dd**2*f**3*r**2 + 900*Dd**2*f**3*r - 132*Dd**2*f**2*r**2 + 66*Dd**2*f**2*r - 264*Dd**2*f*g2*r**2 + 132*Dd**2*f*g2*r))/(6006*d**2) + D1**2*Pk2*Pkdd1*ct**2*(132*D1**2*K*bd1**2*f*r + 44*D1**2*K*bd1*f**2*r**2 - 220*D1**2*K*bd1*f*fd*r**2 + 110*D1**2*K*bd1*f*fd*r - 55*D1**2*K*bdd1*f**2*r**2 - 440*D1**2*bd1**2*f**2*r**2 + 330*D1**2*bd1**2*f**2*r - 264*D1**2*bd1**2*f*r**2 + 132*D1**2*bd1**2*f*r - 308*D1**2*bd1**2*g2*r**2 + 308*D1**2*bd1**2*g2*r - 132*D1**2*bd1*bd2*f*r**2 + 132*D1**2*bd1*bd2*f*r + 115*D1**2*bd1*f**3*r**2 - 840*D1**2*bd1*f**2*fd*r**2 + 280*D1**2*bd1*f**2*fd*r + 44*D1**2*bd1*f**2*r**2 - 220*D1**2*bd1*f*fd*r**2 + 110*D1**2*bd1*f*fd*r + 220*D1**2*bd1*f*g2*r - 110*D1**2*bd1*f*g2 - 264*D1**2*bd1*f*gd2*r + 44*D1**2*bd2*f**2*r**2 - 220*D1**2*bd2*f*fd*r**2 + 110*D1**2*bd2*f*fd*r - 140*D1**2*bdd1*f**3*r**2 - 55*D1**2*bdd1*f**2*r**2 - 264*D1**2*bdd1*f*g2*r + 132*D1**2*bdd1*f*g2 - 55*D1**2*bdd2*f**2*r**2 - 88*D1**2*f**2*gd2*r**2 + 110*D1**2*f**2*gdd2*r**2 - 176*D1**2*f*fd*g2*r**2 + 176*D1**2*f*fd*g2*r - 88*D1**2*f*fd*g2 + 440*D1**2*f*fd*gd2*r**2 - 220*D1**2*f*fd*gd2*r + 220*D1**2*f*fdd*g2*r**2 - 220*D1**2*f*fdd*g2*r + 110*D1**2*f*fdd*g2 + 220*D1**2*fd**2*g2*r**2 - 220*D1**2*fd**2*g2*r - 440*D1*Dd*K*bd1*f**2*r**2 + 110*D1*Dd*K*bd1*f**2*r - 1120*D1*Dd*bd1*f**3*r**2 + 280*D1*Dd*bd1*f**3*r - 440*D1*Dd*bd1*f**2*r**2 + 110*D1*Dd*bd1*f**2*r - 1056*D1*Dd*bd1*f*g2*r + 264*D1*Dd*bd1*f*g2 - 440*D1*Dd*bd2*f**2*r**2 + 110*D1*Dd*bd2*f**2*r - 352*D1*Dd*f**2*g2*r**2 + 176*D1*Dd*f**2*g2*r - 88*D1*Dd*f**2*g2 + 880*D1*Dd*f**2*gd2*r**2 - 220*D1*Dd*f**2*gd2*r + 1760*D1*Dd*f*fd*g2*r**2 - 1320*D1*Dd*f*fd*g2*r + 220*D1*Dd*f*fd*g2 + 440*D1*Ddd*f**2*g2*r**2 - 220*D1*Ddd*f**2*g2*r + 110*D1*Ddd*f**2*g2 + 1320*Dd**2*f**2*g2*r**2 - 660*Dd**2*f**2*g2*r + 11*b1**3*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*(-7*K*(4*r**2 - 2*r + 1) - r**2*(24*fd - 28) + r*(6*fd - 14) + 7) - Ddd*(-7*K + 6*f + 7)*(4*r**2 - 2*r + 1)) - 6*Dd**2*r*(2*r - 1)*(-7*K + 6*f + 7)) + 11*b1**2*(10*D1**2*K*fd*r - 5*D1**2*K*fd - 12*D1**2*K*fdd*r + 6*D1**2*K*fdd - D1**2*bdd1*(-7*K + 6*f + 7)*(3*r**2 - 2*r + 1) + 32*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 40*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 40*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 10*D1**2*fd*r**2 - 10*D1**2*fd*r + 5*D1**2*fd - 12*D1**2*fdd*r**2 + 12*D1**2*fdd*r - 6*D1**2*fdd + 28*D1**2*gd2*r**2 - 14*D1**2*gdd2*r**2 - 48*D1*Dd*K*fd*r + 12*D1*Dd*K*fd + 64*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r + 16*D1*Dd*f**2 - 320*D1*Dd*f*fd*r**2 + 120*D1*Dd*f*fd*r - 10*D1*Dd*f*fd + 40*D1*Dd*f*r**2 - 20*D1*Dd*f*r + 10*D1*Dd*f - 96*D1*Dd*fd*r**2 + 72*D1*Dd*fd*r - 12*D1*Dd*fd + 112*D1*Dd*g2*r**2 - 56*D1*Dd*g2*r + 28*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 + 28*D1*Dd*gd2*r - 80*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r - 20*D1*Ddd*f**2 - 48*D1*Ddd*f*r**2 + 24*D1*Ddd*f*r - 12*D1*Ddd*f - 56*D1*Ddd*g2*r**2 + 28*D1*Ddd*g2*r - 14*D1*Ddd*g2 + D1*bd1*(5*D1*f*(3*r**2 - 2*r + 1) + 2*D1*(-7*K*(3*r**2 - 2*r + 1) - r**2*(18*fd - 21) + r*(6*fd - 14) + 7) - 2*Dd*(-7*K + 6*f + 7)*(12*r**2 - 7*r + 1)) - 240*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r - 144*Dd**2*f*r**2 + 72*Dd**2*f*r - 168*Dd**2*g2*r**2 + 84*Dd**2*g2*r) - b1*(-88*D1**2*K*f*fd*r**2 + 88*D1**2*K*f*fd*r - 44*D1**2*K*f*fd + 110*D1**2*K*f*fdd*r**2 - 110*D1**2*K*f*fdd*r + 55*D1**2*K*f*fdd + 110*D1**2*K*fd**2*r**2 - 110*D1**2*K*fd**2*r - 55*D1**2*b2*fd*r**2 + 66*D1**2*b2*fdd*r**2 + 22*D1**2*bd1**2*r*(3*r - 2)*(-7*K + 6*f + 7) - 55*D1**2*bd2*f*r**2 + 132*D1**2*bd2*fd*r**2 + 11*D1**2*bdd1*(5*f**2*(8*r**2 - 6*r + 3) + 6*f*(-2*K*r + K + 4*r**2 - 2*r + 1) + 14*g2*(2*r**2 - 2*r + 1)) + 66*D1**2*bdd2*f*r**2 - 345*D1**2*f**2*fd*r**2 + 230*D1**2*f**2*fd*r - 115*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 - 280*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 - 560*D1**2*f*fd**2*r - 88*D1**2*f*fd*r**2 + 88*D1**2*f*fd*r - 44*D1**2*f*fd + 110*D1**2*f*fdd*r**2 - 110*D1**2*f*fdd*r + 55*D1**2*f*fdd + 110*D1**2*fd**2*r**2 - 110*D1**2*fd**2*r + 220*D1**2*fd*g2*r - 110*D1**2*fd*g2 - 264*D1**2*fd*gd2*r - 264*D1**2*fdd*g2*r + 132*D1**2*fdd*g2 - 176*D1*Dd*K*f**2*r**2 + 88*D1*Dd*K*f**2*r - 44*D1*Dd*K*f**2 + 880*D1*Dd*K*f*fd*r**2 - 660*D1*Dd*K*f*fd*r + 110*D1*Dd*K*f*fd - 220*D1*Dd*b2*f*r**2 + 110*D1*Dd*b2*f*r - 55*D1*Dd*b2*f + 528*D1*Dd*b2*fd*r**2 - 132*D1*Dd*b2*fd*r + 528*D1*Dd*bd2*f*r**2 - 132*D1*Dd*bd2*f*r - 460*D1*Dd*f**3*r**2 + 230*D1*Dd*f**3*r - 115*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 - 1960*D1*Dd*f**2*fd*r + 280*D1*Dd*f**2*fd - 176*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r - 44*D1*Dd*f**2 + 880*D1*Dd*f*fd*r**2 - 660*D1*Dd*f*fd*r + 110*D1*Dd*f*fd - 1056*D1*Dd*fd*g2*r + 264*D1*Dd*fd*g2 + 220*D1*Ddd*K*f**2*r**2 - 110*D1*Ddd*K*f**2*r + 55*D1*Ddd*K*f**2 + 264*D1*Ddd*b2*f*r**2 - 132*D1*Ddd*b2*f*r + 66*D1*Ddd*b2*f + 560*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r + 140*D1*Ddd*f**3 + 220*D1*Ddd*f**2*r**2 - 110*D1*Ddd*f**2*r + 55*D1*Ddd*f**2 - 11*D1*bd1*(D1*(4*f**2*(8*r**2 - 6*r + 3) - 5*f*(K*(2*r - 1) + r**2*(32*fd - 4) + r*(2 - 16*fd) - 1) - 12*fd*r*(K + 4*r - 3) + 28*g2*(2*r**2 - 2*r + 1) + 28*gd2*r*(1 - 2*r)) - 2*Dd*(4*r - 1)*(5*f**2*(8*r - 3) - 6*f*(K - 4*r + 1) + 14*g2*(2*r - 1))) + 660*Dd**2*K*f**2*r**2 - 330*Dd**2*K*f**2*r + 792*Dd**2*b2*f*r**2 - 396*Dd**2*b2*f*r + 1680*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r + 660*Dd**2*f**2*r**2 - 330*Dd**2*f**2*r) + 11*b2*(-6*D1**2*bdd1*f*(r - 1)**2 + 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 60*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + D1*bd1*(r - 1)*(5*D1*f*(r - 1) - 12*D1*fd*r + 12*Dd*f*(1 - 4*r)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(231*d**2) + D1**2*Pk2*Pkdd1*ct*f*k1*k2*st**4*(33*D1**2*bd1*f*(r - 1)**2 + 6*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 6*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 + 14*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + 33*D1*b1*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r)/(231*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct*f*k2**3*st**4*(33*D1**2*bd1*f*(r - 1)**2 + 6*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 6*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 + 14*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + 33*D1*b1*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r)/(231*d**2*k1*k3**2) + 5*D1**2*Pk2*Pkdd1*ct*f*k2*st**4*(78*D1**2*b1*f*fd*r**2 - 39*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*fd**2*r**2 - 13*D1**2*bdd1*f**2*(r - 1)**2 + 28*D1**2*f**2*fd*r**2 - 14*D1**2*f**2*fd*r + 7*D1**2*f**2*fd - 40*D1**2*f**2*fdd*r**2 + 20*D1**2*f**2*fdd*r - 10*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r + 104*D1*Dd*b1*f**2*r**2 - 52*D1*Dd*b1*f**2*r + 26*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 + 78*D1*Dd*b1*f*fd*r + 28*D1*Dd*f**3*r**2 - 14*D1*Dd*f**3*r + 7*D1*Dd*f**3 - 320*D1*Dd*f**2*fd*r**2 + 160*D1*Dd*f**2*fd*r - 20*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 + 26*D1*Ddd*b1*f**2*r - 13*D1*Ddd*b1*f**2 - 40*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r - 10*D1*Ddd*f**3 + 26*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 156*Dd**2*b1*f**2*r**2 + 78*Dd**2*b1*f**2*r - 120*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r)/(3003*d**2*k1) + D1**2*Pk2*Pkdd1*ct*k1**3*st**2*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(1386*d**2*k2*k3**2) + D1**2*Pk2*Pkdd1*ct*k1**3*(D1*f*r*(-12*D1*bd1**2*(r - 1) - 5*D1*bdd1*f*r + 2*bd1*(2*D1*f*r + D1*fd*(5 - 10*r) + 5*Dd*f*(1 - 4*r))) + b1**2*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + b1*(-6*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 60*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + D1*bd1*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(21*d**2*k2*k3**2) + D1**2*Pk2*Pkdd1*ct*k1*k2*st**2*(33*b1**2*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) + 33*b1*(24*C*D1**2*f*fd*r**2 - 24*C*D1**2*f*fdd*r**2 - 24*C*D1**2*fd**2*r**2 + 48*C*D1*Dd*f**2*r**2 - 24*C*D1*Dd*f**2*r + 12*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 + 48*C*D1*Dd*f*fd*r - 48*C*D1*Ddd*f**2*r**2 + 24*C*D1*Ddd*f**2*r - 12*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r**2 + 72*C*Dd**2*f**2*r - D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 4*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 4*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 4*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 - 32*D1*Dd*f*fd*r**2 + 16*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 8*D1*Ddd*f**2*r**2 + 4*D1*Ddd*f**2*r - 2*D1*Ddd*f**2 + D1*bd1*(9*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 2*r) - 2*Dd*f*(8*r**2 - 6*r + 1)) - 24*Dd**2*f**2*r**2 + 12*Dd**2*f**2*r) + f*(-66*D1**2*bd1**2*r*(r - 1) - 33*D1**2*bdd1*f*(12*C*(r - 1)**2 + 2*r**2 - 2*r + 1) + 33*D1*bd1*(D1*(f*(12*C*(r - 1)**2 + 2*r**2 - 2*r + 1) + 2*fd*r*(-24*C*(r - 1) - 4*r + 3)) - 2*Dd*f*(4*r - 1)*(12*C*(r - 1) + 2*r - 1)) + (12*C + 1)*(D1**2*(f*(17*fd - 25*fdd)*(3*r**2 - 2*r + 1) + 50*fd**2*r*(2 - 3*r)) + D1*f*(17*Dd*f*(4*r**2 - 2*r + 1) - 50*Dd*fd*(12*r**2 - 7*r + 1) - 25*Ddd*f*(4*r**2 - 2*r + 1)) + 150*Dd**2*f**2*r*(1 - 2*r))))/(1386*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct*k1*k2*(4*C + 1)*(D1*f*r*(-12*D1*bd1**2*(r - 1) - 5*D1*bdd1*f*r + 2*bd1*(2*D1*f*r + D1*fd*(5 - 10*r) + 5*Dd*f*(1 - 4*r))) + b1**2*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + b1*(-6*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 60*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + D1*bd1*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(21*d**2*k3**2) + D1**2*Pk2*Pkdd1*ct*k1*st**2*(143*b1**2*(-D1**2*r**2*(6*f*fdd + 6*fd**2 + fd*(-6*f - 9) + fdd) + D1*(Dd*(3*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(36 - 48*fd) + r*(12*fd - 18) + 9) + 2*fd*r*(1 - 4*r)) - Ddd*f*(3*f + 1)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(3*f + 1)*(2*r - 1)) + 13*b1*(-11*D1**2*bdd1*f*(3*f + 1)*(2*r**2 - 2*r + 1) + 102*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 150*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 300*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r + 11*D1**2*f*fd - 22*D1**2*f*fdd*r**2 + 22*D1**2*f*fdd*r - 11*D1**2*f*fdd - 22*D1**2*fd**2*r**2 + 22*D1**2*fd**2*r + 136*D1*Dd*f**3*r**2 - 68*D1*Dd*f**3*r + 34*D1*Dd*f**3 - 1200*D1*Dd*f**2*fd*r**2 + 500*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 - 22*D1*Dd*f**2*r + 11*D1*Dd*f**2 - 176*D1*Dd*f*fd*r**2 + 132*D1*Dd*f*fd*r - 22*D1*Dd*f*fd - 200*D1*Ddd*f**3*r**2 + 100*D1*Ddd*f**3*r - 50*D1*Ddd*f**3 - 44*D1*Ddd*f**2*r**2 + 22*D1*Ddd*f**2*r - 11*D1*Ddd*f**2 + 11*D1*bd1*(D1*(f**2*(6*r**2 - 6*r + 3) - 3*f*(r**2*(8*fd - 6) + r*(6 - 4*fd) - 3) + 2*fd*r*(1 - 2*r)) - 2*Dd*f*(3*f + 1)*(8*r**2 - 6*r + 1)) - 600*Dd**2*f**3*r**2 + 300*Dd**2*f**3*r - 132*Dd**2*f**2*r**2 + 66*Dd**2*f**2*r) + f*(-286*D1**2*bd1**2*r*(3*f + 1)*(r - 1) + 13*D1*bd1*(D1*(17*f**2*(2*r**2 - 2*r + 1) + f*r*(-300*fd*r + 200*fd + 11*r) + 22*fd*r*(1 - 2*r)) - 2*Dd*f*(4*r - 1)*(25*f*(2*r - 1) + 11*r)) + f*(-13*D1**2*bdd1*(25*f*(2*r**2 - 2*r + 1) + 11*r**2) + 5*D1**2*(f*(33*fd - 49*fdd)*(4*r**2 - 2*r + 1) + 294*fd**2*r*(1 - 2*r)) + 5*D1*f*(33*Dd*f*(4*r**2 - 2*r + 1) - 98*Dd*fd*(1 - 4*r)**2 - 49*Ddd*f*(4*r**2 - 2*r + 1)) + 1470*Dd**2*f**2*r*(1 - 2*r))))/(6006*d**2*k2) - D1**2*Pk2*Pkdd1*ct*k1*(D1*f*r*(66*D1*bd1**2*(5*f*(2*r - 1) + 6*r) + 140*D1*bdd1*f**2*r + 5*bd1*f*(-23*D1*f*r + 56*D1*fd*(3*r - 1) + 56*Dd*f*(4*r - 1))) - 33*b1**3*(D1**2*r**2*(5*fd - 6*fdd) + D1*Dd*(5*f*(4*r**2 - 2*r + 1) - r**2*(48*fd - 56) + r*(12*fd - 28) + 14) - D1*Ddd*(6*f + 7)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(6*f + 7)*(2*r - 1)) - 33*b1**2*(-D1**2*bdd1*(6*f + 7)*(3*r**2 - 2*r + 1) + 16*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 20*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 20*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 5*D1**2*fd*r**2 - 10*D1**2*fd*r + 5*D1**2*fd - 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r - 6*D1**2*fdd + 32*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r + 8*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 + 80*D1*Dd*f*fd*r - 10*D1*Dd*f*fd + 20*D1*Dd*f*r**2 - 10*D1*Dd*f*r + 5*D1*Dd*f - 48*D1*Dd*fd*r**2 + 60*D1*Dd*fd*r - 12*D1*Dd*fd - 40*D1*Ddd*f**2*r**2 + 20*D1*Ddd*f**2*r - 10*D1*Ddd*f**2 - 24*D1*Ddd*f*r**2 + 12*D1*Ddd*f*r - 6*D1*Ddd*f + D1*bd1*(D1*(5*f*(3*r**2 - 2*r + 1) - r**2*(36*fd - 42) + r*(12*fd - 28) + 14) - 2*Dd*(6*f + 7)*(12*r**2 - 7*r + 1)) - 120*Dd**2*f**2*r**2 + 60*Dd**2*f**2*r - 72*Dd**2*f*r**2 + 36*Dd**2*f*r) + b1*(66*D1**2*bd1**2*r*(6*f + 7)*(3*r - 2) - 66*D1*bd1*(D1*(f**2*(8*r**2 - 4*r + 2) + 5*f*r*(-8*fd*r + 4*fd + r) - 12*fd*r*(r - 1)) - Dd*f*(4*r - 1)*(5*f*(4*r - 1) + 12*r)) + f*(33*D1**2*bdd1*(5*f*(4*r**2 - 2*r + 1) + 12*r**2) - 5*D1**2*(f*(23*fd - 28*fdd)*(3*r**2 - 2*r + 1) + 56*fd**2*r*(2 - 3*r)) - 5*D1*f*(23*Dd*f*(4*r**2 - 2*r + 1) - 56*Dd*fd*(12*r**2 - 7*r + 1) - 28*Ddd*f*(4*r**2 - 2*r + 1)) - 840*Dd**2*f**2*r*(1 - 2*r))))/(693*d**2*k2) + D1**2*Pk2*Pkdd1*ct*k2**3*st**2*(D1*f*r*(-2*D1*bd1**2*(r - 1) - D1*bdd1*f*r + bd1*(D1*f*r + D1*fd*(2 - 4*r) + Dd*f*(2 - 8*r))) + b1**2*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) + b1*(-D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 2*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 2*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 + 12*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + D1*bd1*(9*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 2*r) - 2*Dd*f*(8*r**2 - 6*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r))/(42*d**2*k1*k3**2) + D1**2*Pk2*Pkdd1*ct*k2*st**2*(D1*f*r*(-22*D1*bd1**2*(6*f + 1)*(r - 1) - D1*bdd1*f*r*(50*f + 11) + bd1*(D1*f*r*(34*f + 11) + D1*fd*(-100*f*(3*r - 1) - 44*r + 22) - 2*Dd*f*(50*f + 11)*(4*r - 1))) + 11*b1**2*(-D1**2*r**2*(12*f*fdd + 12*fd**2 + fd*(-12*f - 9) + fdd) + D1*(Dd*(6*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(36 - 96*fd) + r*(24*fd - 18) + 9) + 2*fd*r*(1 - 4*r)) - Ddd*f*(6*f + 1)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(6*f + 1)*(2*r - 1)) + b1*(-11*D1**2*bdd1*f*(6*f + 1)*(2*r**2 - 2*r + 1) + 102*D1**2*f**2*fd*r**2 - 68*D1**2*f**2*fd*r + 34*D1**2*f**2*fd - 150*D1**2*f**2*fdd*r**2 + 100*D1**2*f**2*fdd*r - 50*D1**2*f**2*fdd - 300*D1**2*f*fd**2*r**2 + 200*D1**2*f*fd**2*r + 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r + 11*D1**2*f*fd - 22*D1**2*f*fdd*r**2 + 22*D1**2*f*fdd*r - 11*D1**2*f*fdd - 22*D1**2*fd**2*r**2 + 22*D1**2*fd**2*r + 136*D1*Dd*f**3*r**2 - 68*D1*Dd*f**3*r + 34*D1*Dd*f**3 - 1200*D1*Dd*f**2*fd*r**2 + 700*D1*Dd*f**2*fd*r - 100*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 - 22*D1*Dd*f**2*r + 11*D1*Dd*f**2 - 176*D1*Dd*f*fd*r**2 + 132*D1*Dd*f*fd*r - 22*D1*Dd*f*fd - 200*D1*Ddd*f**3*r**2 + 100*D1*Ddd*f**3*r - 50*D1*Ddd*f**3 - 44*D1*Ddd*f**2*r**2 + 22*D1*Ddd*f**2*r - 11*D1*Ddd*f**2 + 11*D1*bd1*(D1*(6*f**2*(2*r**2 - 2*r + 1) - 3*f*(r**2*(16*fd - 6) + r*(6 - 8*fd) - 3) + 2*fd*r*(1 - 2*r)) - 2*Dd*f*(6*f + 1)*(8*r**2 - 6*r + 1)) - 600*Dd**2*f**3*r**2 + 300*Dd**2*f**3*r - 132*Dd**2*f**2*r**2 + 66*Dd**2*f**2*r))/(462*d**2*k1) - D1**2*Pk2*Pkdd1*ct*k2*(2*D1**2*bd1**2*f*r**2*(5*f + 6) + 2*D1*b1*r*(D1*bd1**2*(6*f + 7)*(3*r - 2) + D1*bdd1*f*r*(5*f + 6) + bd1*(-D1*f*r*(4*f + 5) + 2*D1*fd*(10*f*r - 5*f + 6*r - 6) + 2*Dd*f*(5*f + 6)*(4*r - 1))) + b1**3*(D1**2*r**2*(-5*fd + 6*fdd) - D1*Dd*(5*f*(4*r**2 - 2*r + 1) - r**2*(48*fd - 56) + r*(12*fd - 28) + 14) + D1*Ddd*(6*f + 7)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(6*f + 7)*(2*r - 1)) + b1**2*(D1**2*bdd1*(6*f + 7)*(3*r**2 - 2*r + 1) - 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r - 5*D1**2*fd*r**2 + 10*D1**2*fd*r - 5*D1**2*fd + 6*D1**2*fdd*r**2 - 12*D1**2*fdd*r + 6*D1**2*fdd - 16*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 - 60*D1*Dd*f*fd*r + 10*D1*Dd*f*fd - 20*D1*Dd*f*r**2 + 10*D1*Dd*f*r - 5*D1*Dd*f + 48*D1*Dd*fd*r**2 - 60*D1*Dd*fd*r + 12*D1*Dd*fd + 20*D1*Ddd*f**2*r**2 - 10*D1*Ddd*f**2*r + 5*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 - 12*D1*Ddd*f*r + 6*D1*Ddd*f + D1*bd1*(-D1*(5*f*(3*r**2 - 2*r + 1) - r**2*(36*fd - 42) + r*(12*fd - 28) + 14) + 2*Dd*(6*f + 7)*(12*r**2 - 7*r + 1)) + 60*Dd**2*f**2*r**2 - 30*Dd**2*f**2*r + 72*Dd**2*f*r**2 - 36*Dd**2*f*r))/(21*d**2*k1) + D1**2*Pk2*Pkdd1*f*st**4*(429*D1*b1**2*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) + 13*b1*(33*D1**2*bd1*f*(2*r**2 - 2*r + 1) + D1**2*(f*(2*fd - fdd)*(9*r**2 - 2*r + 1) + 2*fd**2*r*(2 - 9*r)) + D1*f*(6*Dd*f*(4*r**2 - 2*r + 1) - 2*Dd*fd*(36*r**2 - 13*r + 1) - 3*Ddd*f*(4*r**2 - 2*r + 1)) + 18*Dd**2*f**2*r*(1 - 2*r)) + f*(-13*D1**2*bdd1*f*(3*r**2 - 4*r + 2) + 2*D1**2*(f*(7*fd - 10*fdd)*(4*r**2 - 2*r + 1) + 60*fd**2*r*(1 - 2*r)) + 26*D1*bd1*(D1*f*(3*r**2 - 4*r + 2) + D1*fd*r*(7 - 9*r) + Dd*f*(-12*r**2 + 11*r - 2)) + 2*D1*f*(7*Dd*f*(4*r**2 - 2*r + 1) - 20*Dd*fd*(1 - 4*r)**2 - 10*Ddd*f*(4*r**2 - 2*r + 1)) + 120*Dd**2*f**2*r*(1 - 2*r)))/(3003*d**2) + D1**2*Pk2*Pkdd1*st**2*(-22*D1**2*K*bd1**2*f*r**2 + 22*D1**2*K*bd1**2*f*r + 11*D1**2*K*bd1*f**2*r**2 - 44*D1**2*K*bd1*f*fd*r**2 + 22*D1**2*K*bd1*f*fd*r - 11*D1**2*K*bdd1*f**2*r**2 - 88*D1**2*bd1**2*f**2*r**2 + 66*D1**2*bd1**2*f**2*r - 22*D1**2*bd1**2*f*r**2 + 22*D1**2*bd1**2*f*r - 22*D1**2*bd1*bd2*f*r**2 + 22*D1**2*bd1*bd2*f*r + 17*D1**2*bd1*f**3*r**2 - 150*D1**2*bd1*f**2*fd*r**2 + 50*D1**2*bd1*f**2*fd*r + 11*D1**2*bd1*f**2*r**2 - 44*D1**2*bd1*f*fd*r**2 + 22*D1**2*bd1*f*fd*r - 198*D1**2*bd1*f*g2*r**2 + 396*D1**2*bd1*f*g2*r - 198*D1**2*bd1*f*g2 + 44*D1**2*bd1*f*gd2*r**2 - 44*D1**2*bd1*f*gd2*r + 44*D1**2*bd1*fd*g2*r**2 - 44*D1**2*bd1*fd*g2*r + 11*D1**2*bd2*f**2*r**2 - 44*D1**2*bd2*f*fd*r**2 + 22*D1**2*bd2*f*fd*r - 25*D1**2*bdd1*f**3*r**2 - 11*D1**2*bdd1*f**2*r**2 + 22*D1**2*bdd1*f*g2*r**2 - 44*D1**2*bdd1*f*g2*r + 22*D1**2*bdd1*f*g2 - 11*D1**2*bdd2*f**2*r**2 - 22*D1**2*f**2*gd2*r**2 + 22*D1**2*f**2*gdd2*r**2 - 44*D1**2*f*fd*g2*r**2 + 44*D1**2*f*fd*g2*r - 22*D1**2*f*fd*g2 + 88*D1**2*f*fd*gd2*r**2 - 44*D1**2*f*fd*gd2*r + 44*D1**2*f*fdd*g2*r**2 - 44*D1**2*f*fdd*g2*r + 22*D1**2*f*fdd*g2 + 44*D1**2*fd**2*g2*r**2 - 44*D1**2*fd**2*g2*r - 88*D1*Dd*K*bd1*f**2*r**2 + 22*D1*Dd*K*bd1*f**2*r - 200*D1*Dd*bd1*f**3*r**2 + 50*D1*Dd*bd1*f**3*r - 88*D1*Dd*bd1*f**2*r**2 + 22*D1*Dd*bd1*f**2*r + 176*D1*Dd*bd1*f*g2*r**2 - 220*D1*Dd*bd1*f*g2*r + 44*D1*Dd*bd1*f*g2 - 88*D1*Dd*bd2*f**2*r**2 + 22*D1*Dd*bd2*f**2*r - 88*D1*Dd*f**2*g2*r**2 + 44*D1*Dd*f**2*g2*r - 22*D1*Dd*f**2*g2 + 176*D1*Dd*f**2*gd2*r**2 - 44*D1*Dd*f**2*gd2*r + 352*D1*Dd*f*fd*g2*r**2 - 264*D1*Dd*f*fd*g2*r + 44*D1*Dd*f*fd*g2 + 88*D1*Ddd*f**2*g2*r**2 - 44*D1*Ddd*f**2*g2*r + 22*D1*Ddd*f**2*g2 + 264*Dd**2*f**2*g2*r**2 - 132*Dd**2*f**2*g2*r + 11*b1**3*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) + 11*b1**2*(9*D1**2*K*fd*r**2 - D1**2*K*fdd*r**2 - D1**2*bdd1*f*(3*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 8*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 8*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r + 9*D1**2*fd*r**2 - D1**2*fdd*r**2 + 36*D1*Dd*K*f*r**2 - 18*D1*Dd*K*f*r + 9*D1*Dd*K*f - 8*D1*Dd*K*fd*r**2 + 2*D1*Dd*K*fd*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 64*D1*Dd*f*fd*r**2 + 24*D1*Dd*f*fd*r - 2*D1*Dd*f*fd + 36*D1*Dd*f*r**2 - 18*D1*Dd*f*r + 9*D1*Dd*f - 8*D1*Dd*fd*r**2 + 2*D1*Dd*fd*r - 4*D1*Ddd*K*f*r**2 + 2*D1*Ddd*K*f*r - D1*Ddd*K*f - 16*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r - 4*D1*Ddd*f**2 - 4*D1*Ddd*f*r**2 + 2*D1*Ddd*f*r - D1*Ddd*f + D1*bd1*(9*D1*f*(3*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 3*r) - 2*Dd*f*(12*r**2 - 7*r + 1)) - 12*Dd**2*K*f*r**2 + 6*Dd**2*K*f*r - 48*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r - 12*Dd**2*f*r**2 + 6*Dd**2*f*r) - b1*(-22*D1**2*K*f*fd*r**2 + 22*D1**2*K*f*fd*r - 11*D1**2*K*f*fd + 22*D1**2*K*f*fdd*r**2 - 22*D1**2*K*f*fdd*r + 11*D1**2*K*f*fdd + 22*D1**2*K*fd**2*r**2 - 22*D1**2*K*fd**2*r - 99*D1**2*b2*fd*r**2 + 11*D1**2*b2*fdd*r**2 + 22*D1**2*bd1**2*f*r*(3*r - 2) - 99*D1**2*bd2*f*r**2 + 22*D1**2*bd2*fd*r**2 + 11*D1**2*bdd1*f*(f*(8*r**2 - 6*r + 3) + (K + 1)*(2*r**2 - 2*r + 1)) + 11*D1**2*bdd2*f*r**2 - 51*D1**2*f**2*fd*r**2 + 34*D1**2*f**2*fd*r - 17*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 - 50*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 - 100*D1**2*f*fd**2*r - 22*D1**2*f*fd*r**2 + 22*D1**2*f*fd*r - 11*D1**2*f*fd + 22*D1**2*f*fdd*r**2 - 22*D1**2*f*fdd*r + 11*D1**2*f*fdd + 198*D1**2*f*gd2*r**2 - 22*D1**2*f*gdd2*r**2 + 22*D1**2*fd**2*r**2 - 22*D1**2*fd**2*r + 198*D1**2*fd*g2*r**2 - 44*D1**2*fd*gd2*r**2 - 22*D1**2*fdd*g2*r**2 - 44*D1*Dd*K*f**2*r**2 + 22*D1*Dd*K*f**2*r - 11*D1*Dd*K*f**2 + 176*D1*Dd*K*f*fd*r**2 - 132*D1*Dd*K*f*fd*r + 22*D1*Dd*K*f*fd - 396*D1*Dd*b2*f*r**2 + 198*D1*Dd*b2*f*r - 99*D1*Dd*b2*f + 88*D1*Dd*b2*fd*r**2 - 22*D1*Dd*b2*fd*r + 88*D1*Dd*bd2*f*r**2 - 22*D1*Dd*bd2*f*r - 68*D1*Dd*f**3*r**2 + 34*D1*Dd*f**3*r - 17*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 - 350*D1*Dd*f**2*fd*r + 50*D1*Dd*f**2*fd - 44*D1*Dd*f**2*r**2 + 22*D1*Dd*f**2*r - 11*D1*Dd*f**2 + 176*D1*Dd*f*fd*r**2 - 132*D1*Dd*f*fd*r + 22*D1*Dd*f*fd + 792*D1*Dd*f*g2*r**2 - 396*D1*Dd*f*g2*r + 198*D1*Dd*f*g2 - 176*D1*Dd*f*gd2*r**2 + 44*D1*Dd*f*gd2*r - 176*D1*Dd*fd*g2*r**2 + 44*D1*Dd*fd*g2*r + 44*D1*Ddd*K*f**2*r**2 - 22*D1*Ddd*K*f**2*r + 11*D1*Ddd*K*f**2 + 44*D1*Ddd*b2*f*r**2 - 22*D1*Ddd*b2*f*r + 11*D1*Ddd*b2*f + 100*D1*Ddd*f**3*r**2 - 50*D1*Ddd*f**3*r + 25*D1*Ddd*f**3 + 44*D1*Ddd*f**2*r**2 - 22*D1*Ddd*f**2*r + 11*D1*Ddd*f**2 - 88*D1*Ddd*f*g2*r**2 + 44*D1*Ddd*f*g2*r - 22*D1*Ddd*f*g2 - 11*D1*bd1*(D1*(f**2*(8*r**2 - 6*r + 3) + f*(9*K*(2*r**2 - 2*r + 1) + r**2*(18 - 32*fd) + r*(16*fd - 18) + 9) - 2*fd*r*(K + 1)*(2*r - 1)) - 2*Dd*f*(4*r - 1)*(f*(8*r - 3) + (K + 1)*(2*r - 1))) + 132*Dd**2*K*f**2*r**2 - 66*Dd**2*K*f**2*r + 132*Dd**2*b2*f*r**2 - 66*Dd**2*b2*f*r + 300*Dd**2*f**3*r**2 - 150*Dd**2*f**3*r + 132*Dd**2*f**2*r**2 - 66*Dd**2*f**2*r - 264*Dd**2*f*g2*r**2 + 132*Dd**2*f*g2*r) + 11*b2*(-D1**2*bdd1*f*(r - 1)**2 + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 2*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 2*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 + 12*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + D1*bd1*(r - 1)*(9*D1*f*(r - 1) - 2*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r))/(462*d**2) - D1**2*Pk2*Pkdd1*(D1*r*(2*D1*bd1**2*(f*r*(6*K + 5*f + 6) - 14*g2*(r - 1)) - 12*D1*bdd1*f*g2*r + b2*(14*D1*bd1**2*(r - 1) + 6*D1*bdd1*f*r + bd1*(-5*D1*f*r + 12*D1*fd*(r - 1) + 12*Dd*f*(4*r - 1))) + 2*bd1*(D1*f*r*(6*bd2 + 5*g2 - 12*gd2) - 12*D1*fd*g2*(r - 1) + 12*Dd*f*g2*(1 - 4*r))) + b1**3*(D1**2*r**2*(-5*fd + 6*fdd) + D1*(-5*Dd*f*(4*r**2 - 2*r + 1) - 2*Dd*(7*K*(4*r**2 - 2*r + 1) - r**2*(24*fd - 28) + r*(6*fd - 14) + 7) + Ddd*(7*K + 6*f + 7)*(4*r**2 - 2*r + 1)) + 6*Dd**2*r*(2*r - 1)*(7*K + 6*f + 7)) + b1**2*(-5*D1**2*K*fd*r**2 + 10*D1**2*K*fd*r - 5*D1**2*K*fd + 6*D1**2*K*fdd*r**2 - 12*D1**2*K*fdd*r + 6*D1**2*K*fdd - 14*D1**2*bd2*r**2 + D1**2*bdd1*(7*K + 6*f + 7)*(3*r**2 - 2*r + 1) + 7*D1**2*bdd2*r**2 - 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r - 5*D1**2*fd*r**2 + 10*D1**2*fd*r - 5*D1**2*fd + 6*D1**2*fdd*r**2 - 12*D1**2*fdd*r + 6*D1**2*fdd + 28*D1**2*gd2*r**2 - 14*D1**2*gdd2*r**2 - 20*D1*Dd*K*f*r**2 + 10*D1*Dd*K*f*r - 5*D1*Dd*K*f + 48*D1*Dd*K*fd*r**2 - 60*D1*Dd*K*fd*r + 12*D1*Dd*K*fd - 56*D1*Dd*b2*r**2 + 28*D1*Dd*b2*r - 14*D1*Dd*b2 + 56*D1*Dd*bd2*r**2 - 14*D1*Dd*bd2*r - 16*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 - 60*D1*Dd*f*fd*r + 10*D1*Dd*f*fd - 20*D1*Dd*f*r**2 + 10*D1*Dd*f*r - 5*D1*Dd*f + 48*D1*Dd*fd*r**2 - 60*D1*Dd*fd*r + 12*D1*Dd*fd + 112*D1*Dd*g2*r**2 - 56*D1*Dd*g2*r + 28*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 + 28*D1*Dd*gd2*r + 24*D1*Ddd*K*f*r**2 - 12*D1*Ddd*K*f*r + 6*D1*Ddd*K*f + 28*D1*Ddd*b2*r**2 - 14*D1*Ddd*b2*r + 7*D1*Ddd*b2 + 20*D1*Ddd*f**2*r**2 - 10*D1*Ddd*f**2*r + 5*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 - 12*D1*Ddd*f*r + 6*D1*Ddd*f - 56*D1*Ddd*g2*r**2 + 28*D1*Ddd*g2*r - 14*D1*Ddd*g2 + D1*bd1*(-5*D1*f*(3*r**2 - 2*r + 1) - 2*D1*(7*K*(3*r**2 - 2*r + 1) - r**2*(18*fd - 21) + r*(6*fd - 14) + 7) + 2*Dd*(7*K + 6*f + 7)*(12*r**2 - 7*r + 1)) + 72*Dd**2*K*f*r**2 - 36*Dd**2*K*f*r + 84*Dd**2*b2*r**2 - 42*Dd**2*b2*r + 60*Dd**2*f**2*r**2 - 30*Dd**2*f**2*r + 72*Dd**2*f*r**2 - 36*Dd**2*f*r - 168*Dd**2*g2*r**2 + 84*Dd**2*g2*r) + b1*(12*D1**2*K*bdd1*f*r**2 + 2*D1**2*bd1**2*r*(3*r - 2)*(7*K + 6*f + 7) - 5*D1**2*bd2*f*r**2 + 12*D1**2*bd2*fd*r**2 - 12*D1**2*bd2*fd*r + 10*D1**2*bdd1*f**2*r**2 + 12*D1**2*bdd1*f*r**2 - 28*D1**2*bdd1*g2*r**2 + 28*D1**2*bdd1*g2*r - 14*D1**2*bdd1*g2 + 6*D1**2*bdd2*f*r**2 + 10*D1**2*f*gd2*r**2 - 12*D1**2*f*gdd2*r**2 + 10*D1**2*fd*g2*r**2 - 20*D1**2*fd*g2*r + 10*D1**2*fd*g2 - 24*D1**2*fd*gd2*r**2 + 24*D1**2*fd*gd2*r - 12*D1**2*fdd*g2*r**2 + 24*D1**2*fdd*g2*r - 12*D1**2*fdd*g2 + 48*D1*Dd*bd2*f*r**2 - 12*D1*Dd*bd2*f*r + 40*D1*Dd*f*g2*r**2 - 20*D1*Dd*f*g2*r + 10*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r**2 + 24*D1*Dd*f*gd2*r - 96*D1*Dd*fd*g2*r**2 + 120*D1*Dd*fd*g2*r - 24*D1*Dd*fd*g2 - 48*D1*Ddd*f*g2*r**2 + 24*D1*Ddd*f*g2*r - 12*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(14*g2*(2*r**2 - 2*r + 1) + r*(-5*K*f*r + 7*bd2*(2*r - 1) - 4*f**2*r - 5*f*r + 2*fd*(5*f*(2*r - 1) + (6*K + 6)*(r - 1)) - 28*gd2*r + 14*gd2)) - 2*Dd*(4*r - 1)*(-f*r*(6*K + 5*f + 6) + 7*g2*(2*r - 1))) - 144*Dd**2*f*g2*r**2 + 72*Dd**2*f*g2*r + b2*(7*D1**2*bdd1*(2*r**2 - 2*r + 1) - 5*D1**2*fd*r**2 + 10*D1**2*fd*r - 5*D1**2*fd + 6*D1**2*fdd*r**2 - 12*D1**2*fdd*r + 6*D1**2*fdd - 20*D1*Dd*f*r**2 + 10*D1*Dd*f*r - 5*D1*Dd*f + 48*D1*Dd*fd*r**2 - 60*D1*Dd*fd*r + 12*D1*Dd*fd + 24*D1*Ddd*f*r**2 - 12*D1*Ddd*f*r + 6*D1*Ddd*f - 14*D1*bd1*(D1*(2*r**2 - 2*r + 1) + Dd*(-8*r**2 + 6*r - 1)) + 72*Dd**2*f*r**2 - 36*Dd**2*f*r)))/(21*d**2) - D1**2*Pkd1*Pkd2*ct**7*k2**2*(4*C - 4)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 1) - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) + 10*D1**2*Pkd1*Pkd2*ct**6*f*k2*(13*D1*bd1*f*(D1*(23*f*s*(r - 1) - 28*fd*(6*r*s - r - 3*s + 1)) - 28*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 13*b1*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(23*f*fd - 28*f*fdd - 56*fd**2) + 28*Ddd*f**2*(4*r*s - r - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 7*f*(2*D1*Dd*f*(19*f*(-4*r*s + r + s) + 45*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-38*f*fd*(r*(4*s - 1) - s) + f*(52*bdd1*s*(r - 1) + 45*fdd*(4*r*s - r - s)) + 45*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 45*Ddd*f**2*(r*(4*s - 1) - s)) + 45*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k1) - D1**2*Pkd1*Pkd2*ct**6*k1*k2*(8*C - 10)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 1) - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) + 2*D1**2*Pkd1*Pkd2*ct**6*k2**3*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 1) - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1*k3**2) - D1**2*Pkd1*Pkd2*ct**5*k1**2*(4*C - 8)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 1) - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - D1**2*Pkd1*Pkd2*ct**5*k2**2*st**2*(4*C - 4)*(33*D1*bd1*f*(D1*(7*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(7*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(7*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(151*f*(4*r*s - r - s) - 125*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(151*f*fd*(r*(3*s - 1) - s) - 5*f*(33*bdd1*s*(r - 1) + 25*fdd*(3*r*s - r - s)) - 125*fd**2*(r*(6*s - 2) - 2*s + 1)) + 125*Ddd*f**2*(-4*r*s + r + s)) - 125*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - 4*D1**2*Pkd1*Pkd2*ct**5*k2**2*(-198*D1**2*bd1**2*f*(C - 1)*(r*(2*s - 1) - s + 1) + 33*D1*bd1*(-b1*(C - 1)*(D1*(5*f*(-2*r*s + r + s) + 6*fd*r*(4*s - 1) - 6*fd*s) + 12*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(4*f*(-C*r + C*s - 2*r*s + r + s) + 5*fd*(r*(C + 8*s - 3) - s*(C + 3) + 2)) + 10*Dd*f*(r*(2*C + 8*s - 3) - s*(2*C + 3) + 1))) - 33*b1**2*(C - 1)*(D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*r*(8*s - 1) - 6*fd*s) + D1*(D1*r*s*(-5*fd + 6*fdd) + 6*Ddd*f*(r*(4*s - 1) - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1*(2*D1*Dd*f*(4*f*(-4*r*s + r + s) - 5*fd*(-2*C*s + 2*r*(C - 8*s + 2) + 4*s - 1)) - D1*(6*D1*bdd1*f*(C - 1)*(r*(2*s - 1) - s) - D1*(-C*s + r*(C - 4*s + 1) + s)*(4*f*fd - 5*f*fdd - 5*fd**2) + 10*Ddd*f**2*(-4*r*s + r + s)) + 10*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 5*f*(D1*Dd*f*(C + 1)*(23*f*(-4*r*s + r + s) + 28*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(-23*C - 23)*(r*(3*s - 1) - s) + f*(-33*bdd1*(-C*r + C*s - 2*r*s + r + s) + fdd*(28*C + 28)*(r*(3*s - 1) - s)) + fd**2*(28*C + 28)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(28*C + 28)*(r*(4*s - 1) - s)) + Dd**2*f**2*(28*C + 28)*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) + 2*D1**2*Pkd1*Pkd2*ct**5*(2145*D1**2*K*bdd1*f**2*r*s - 429*D1**2*bd1**2*f*s*(2*r - 1)*(-6*K + 5*f + 6) - 5460*D1**2*bdd1*f**3*r*s + 3640*D1**2*bdd1*f**3*s - 2145*D1**2*bdd1*f**2*r*s - 5148*D1**2*bdd1*f*g2*r*s + 5148*D1**2*bdd1*f*g2*s + 10640*D1**2*f**3*fd*r*s - 2660*D1**2*f**3*fd*r - 2660*D1**2*f**3*fd*s - 12600*D1**2*f**3*fdd*r*s + 3150*D1**2*f**3*fdd*r + 3150*D1**2*f**3*fdd*s - 37800*D1**2*f**2*fd**2*r*s + 9450*D1**2*f**2*fd**2*r + 9450*D1**2*f**2*fd**2*s - 3150*D1**2*f**2*fd**2 + 3432*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gdd2*r*s + 6864*D1**2*f*fd*g2*r*s - 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s - 17160*D1**2*f*fd*gd2*r*s + 4290*D1**2*f*fd*gd2*r + 4290*D1**2*f*fd*gd2*s - 8580*D1**2*f*fdd*g2*r*s + 4290*D1**2*f*fdd*g2*r + 4290*D1**2*f*fdd*g2*s - 8580*D1**2*fd**2*g2*r*s + 4290*D1**2*fd**2*g2*r + 4290*D1**2*fd**2*g2*s - 4290*D1**2*fd**2*g2 + 10640*D1*Dd*f**4*r*s - 2660*D1*Dd*f**4*r - 2660*D1*Dd*f**4*s - 100800*D1*Dd*f**3*fd*r*s + 25200*D1*Dd*f**3*fd*r + 25200*D1*Dd*f**3*fd*s - 6300*D1*Dd*f**3*fd + 13728*D1*Dd*f**2*g2*r*s - 3432*D1*Dd*f**2*g2*r - 3432*D1*Dd*f**2*g2*s - 34320*D1*Dd*f**2*gd2*r*s + 4290*D1*Dd*f**2*gd2*r + 4290*D1*Dd*f**2*gd2*s - 68640*D1*Dd*f*fd*g2*r*s + 25740*D1*Dd*f*fd*g2*r + 25740*D1*Dd*f*fd*g2*s - 8580*D1*Dd*f*fd*g2 - 12600*D1*Ddd*f**4*r*s + 3150*D1*Ddd*f**4*r + 3150*D1*Ddd*f**4*s - 17160*D1*Ddd*f**2*g2*r*s + 4290*D1*Ddd*f**2*g2*r + 4290*D1*Ddd*f**2*g2*s + 13*D1*bd1*(D1*(115*f**3*s*(3*r - 2) - 4*f**2*(35*fd*(18*r*s - 3*r - 7*s + 2) + r*s*(33*K - 33)) + 33*f*(5*fd*(K - 1)*(r*(4*s - 1) - s) + s*(10*g2*(r - 1) + 12*gd2*(1 - 2*r))) - 396*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-140*f**2*(24*r*s - 3*r - 11*s + 2) + 165*f*(K - 1)*(8*r*s - r - s) - 396*g2*(8*r*s - r - 5*s + 1))) - 37800*Dd**2*f**4*r*s + 9450*Dd**2*f**4*r + 9450*Dd**2*f**4*s - 3150*Dd**2*f**4 - 51480*Dd**2*f**2*g2*r*s + 12870*Dd**2*f**2*g2*r + 12870*Dd**2*f**2*g2*s - 4290*Dd**2*f**2*g2 - 429*b1**2*(D1*Dd*(-f*(r*(4*s - 1) - s)*(-5*K + 4*f + 5) + fd*(5*f*(16*r*s - 6*r - 2*s + 1) + (6 - 6*K)*(8*r*s - 5*r - s + 1))) + D1*(D1*r*(f*fd*(4 - 8*s) + 5*f*fdd*(2*s - 1) + 5*fd**2*(2*s - 1) + 5*fd*(K - 1)*(s - 1) + 6*fdd*(-K*s + K + s - 1)) + Ddd*f*(r*(4*s - 1) - s)*(-6*K + 5*f + 6)) + Dd**2*f*(-6*K + 5*f + 6)*(3*r*(4*s - 1) - 3*s + 1)) + 13*b1*(D1*Dd*(345*f**3*(r*(4*s - 1) - s) - 4*f**2*(35*fd*(3*r*(24*s - 7) - 13*s + 4) + (33*K - 33)*(r*(4*s - 1) - s)) + 66*f*(5*fd*(K - 1)*(r*(8*s - 3) - 3*s + 1) + 5*g2*(4*r*s - r - s) + 6*gd2*(-8*r*s + r + s)) - 396*fd*g2*(r*(8*s - 5) - s + 1)) + 33*D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) - 2*s + 1) + f*s*(2*r - 1)*(-5*K + 4*f + 5) + 6*fd*(K - 1)*(r*(4*s - 2) - s + 1)) - Dd*f*(-6*K + 5*f + 6)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(-5*f**2*(33*bdd1*s*(2*r - 1) + 28*fdd*(9*r*s - 3*r - s)) + 33*f*(5*fdd*(K - 1)*(r*(2*s - 1) - s) + s*(6*bdd1*(K - 1)*(2*r - 1) + 2*r*(5*gd2 - 6*gdd2))) - 5*fd**2*(28*f*(18*r*s - 6*r - 2*s + 1) + (33 - 33*K)*(2*r*s - r - s + 1)) + fd*(115*f**2*(r*(9*s - 3) - s) - 132*f*(K - 1)*(r*(2*s - 1) - s) + 66*r*(5*g2*(s - 1) + 6*gd2*(1 - 2*s))) - 396*fdd*g2*r*(s - 1)) - 3*Ddd*f*(r*(4*s - 1) - s)*(140*f**2 - 55*f*(K - 1) + 132*g2)) - 3*Dd**2*f*(140*f**2 - 55*f*(K - 1) + 132*g2)*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2) + 5*D1**2*Pkd1*Pkd2*ct**4*f*k2*st**2*(39*D1*bd1*f*(D1*(28*f*s*(r - 1) - 25*fd*(6*r*s - r - 3*s + 1)) - 25*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 39*b1*(D1*Dd*f*(28*f*(-4*r*s + r + s) + 25*fd*(24*r*s - 7*r - 3*s + 1)) + D1*(-D1*r*(3*s - 1)*(28*f*fd - 25*f*fdd - 50*fd**2) + 25*Ddd*f**2*(4*r*s - r - s)) + 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(-2*D1*Dd*f*(82*f*(4*r*s - r - s) - 147*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-164*f*fd*(r*(4*s - 1) - s) + 3*f*(65*bdd1*s*(r - 1) + 49*fdd*(4*r*s - r - s)) + 147*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 147*Ddd*f**2*(r*(4*s - 1) - s)) + 147*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k1) + 2*D1**2*Pkd1*Pkd2*ct**4*k1**3*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 1) - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k2*k3**2) - 2*D1**2*Pkd1*Pkd2*ct**4*k1*k2*st**2*(33*D1*bd1*f*(D1*(f*s*(18*C - 25)*(r - 1) - fd*(12*C - 17)*(4*r*s - r - 2*s + 1)) - Dd*f*(12*C - 17)*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(-f*(18*C - 25)*(r*(4*s - 1) - s) + fd*(12*C - 17)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(18*C - 25) + f*fdd*(17 - 12*C) + fd**2*(17 - 12*C)) + Ddd*f**2*(12*C - 17)*(r*(4*s - 1) - s)) + Dd**2*f**2*(12*C - 17)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(402*C - 553)*(r*(4*s - 1) - s) - fd*(300*C - 425)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(402*C - 553)*(r*(3*s - 1) - s) - f*(12*C - 17)*(33*bdd1*s*(r - 1) + 25*fdd*(r*(3*s - 1) - s)) - fd**2*(300*C - 425)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(425 - 300*C)*(r*(4*s - 1) - s)) + Dd**2*f**2*(425 - 300*C)*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - 2*D1**2*Pkd1*Pkd2*ct**4*k1*k2*(-198*D1**2*bd1**2*f*(4*C - 5)*(r*(2*s - 1) - s + 1) + 33*D1*bd1*(-b1*(4*C - 5)*(D1*(5*f*(-2*r*s + r + s) + 6*fd*r*(4*s - 1) - 6*fd*s) + 12*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(4*f*(4*C*s + r*(-4*C - 6*s + 5) + s) + 5*fd*(-4*C*s + r*(4*C + 24*s - 11) - 7*s + 6)) + 10*Dd*f*(-8*C*s + r*(8*C + 24*s - 13) - 5*s + 3))) - 33*b1**2*(4*C - 5)*(D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*r*(8*s - 1) - 6*fd*s) + D1*(D1*r*s*(-5*fd + 6*fdd) + 6*Ddd*f*(r*(4*s - 1) - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1*(2*D1*Dd*f*(12*f*(-4*r*s + r + s) - 5*fd*(8*r*(C - 6*s + 1) - s*(8*C - 16) - 3)) + D1*(-6*D1*bdd1*f*(4*C - 5)*(r*(2*s - 1) - s) + D1*(4*f*fd - 5*f*fdd - 5*fd**2)*(4*C*r - 4*C*s - 12*r*s + r + 5*s) + 30*Ddd*f**2*(r*(4*s - 1) - s)) + 30*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 5*f*(D1*Dd*f*(4*C + 1)*(23*f*(-4*r*s + r + s) + 28*fd*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(-92*C - 23)*(r*(3*s - 1) - s) + f*(-33*bdd1*(4*C*s + r*(-4*C - 6*s + 5) + s) + fdd*(112*C + 28)*(r*(3*s - 1) - s)) + fd**2*(112*C + 28)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(112*C + 28)*(r*(4*s - 1) - s)) + Dd**2*f**2*(112*C + 28)*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) + 2*D1**2*Pkd1*Pkd2*ct**4*k1*(-429*b1**2*(D1*Dd*(-f*(4*f + 5)*(r*(4*s - 1) - s) + fd*(5*f*(2*r*(8*s - 3) - 2*s + 1) + 6*r*(8*s - 5) - 6*s + 6)) + D1*(D1*r*(5*fd**2*(2*s - 1) + fd*(-8*f*s + 4*f - 5*s + 5) + fdd*(10*f*s - 5*f + 6*s - 6)) + Ddd*f*(5*f + 6)*(r*(4*s - 1) - s)) + Dd**2*f*(5*f + 6)*(3*r*(4*s - 1) - 3*s + 1)) + 13*b1*(2*D1*Dd*f*(f*(115*f + 66)*(r*(4*s - 1) - s) - 5*fd*(14*f*(48*r*s - 14*r - 10*s + 3) + 264*r*s - 99*r - 99*s + 33)) + 33*D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) - 2*s + 1) + f*s*(4*f + 5)*(2*r - 1) + 6*fd*(r*(2 - 4*s) + s - 1)) - Dd*f*(5*f + 6)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(f*fd*(230*f*r*(3*s - 1) + 132*r*(2*s - 1) - s*(115*f + 132)) + f*(-33*bdd1*s*(5*f + 6)*(2*r - 1) - 5*fdd*r*(56*f*(3*s - 1) + 66*s - 33) + fdd*s*(140*f + 165)) - 5*fd**2*(28*f*(4*r*(3*s - 1) - 2*s + 1) + 33*r*(2*s - 1) - 33*s + 33)) - 5*Ddd*f**2*(56*f + 33)*(r*(4*s - 1) - s)) - 5*Dd**2*f**2*(56*f + 33)*(3*r*(4*s - 1) - 3*s + 1)) + f*(-429*D1**2*bd1**2*s*(5*f + 6)*(2*r - 1) + 13*D1*bd1*(D1*(115*f**2*s*(2*r - 1) - 140*f*fd*(2*r*(6*s - 1) - 4*s + 1) + 132*f*r*s + 165*fd*(-4*r*s + r + s)) - 5*Dd*f*(28*f*(16*r*s - 2*r - 6*s + 1) + 264*r*s - 33*r - 33*s)) - 5*f*(-14*D1*Dd*f*(19*f*(r*(4*s - 1) - s) - 45*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(429*bdd1*r*s - 266*f*fd*(r*(4*s - 1) - s) + 7*f*(52*bdd1*s*(2*r - 1) + 45*fdd*(4*r*s - r - s)) + 315*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 315*Ddd*f**2*(r*(4*s - 1) - s)) + 315*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(9009*d**2*k2) + 2*D1**2*Pkd1*Pkd2*ct**4*k2**3*st**2*(33*D1*bd1*f*(D1*(7*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 33*b1*(D1*Dd*f*(7*f*(-4*r*s + r + s) + 5*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(7*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(151*f*(4*r*s - r - s) - 125*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(151*f*fd*(r*(3*s - 1) - s) - 5*f*(33*bdd1*s*(r - 1) + 25*fdd*(3*r*s - r - s)) - 125*fd**2*(r*(6*s - 2) - 2*s + 1)) + 125*Ddd*f**2*(-4*r*s + r + s)) - 125*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1*k3**2) + 2*D1**2*Pkd1*Pkd2*ct**4*k2**3*(-6*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) - 5*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(D1*b1*(5*f*r*(2*s - 1) - 5*f*s + 6*fd*(-4*r*s + r + s)) + D1*f*(4*f*r*(s - 1) - 5*fd*(r*(4*s - 2) - s + 1)) - 12*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) - 5*Dd*f**2*(r*(8*s - 5) - s + 1)) + b1**2*(D1*Dd*(5*f*r*(4*s - 1) - 5*f*s + 6*fd*(-8*r*s + r + s)) + D1*(D1*r*s*(5*fd - 6*fdd) + 6*Ddd*f*(-4*r*s + r + s)) - 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(4*f*(r*(4*s - 1) - s) - 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(6*D1*bdd1*f*(-2*r*s + r + s) + D1*s*(2*r - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k1*k3**2) + 2*D1**2*Pkd1*Pkd2*ct**4*k2*(D1*f*(-33*D1*bd1**2*(5*f*(4*r*s - r - 2*s + 1) + s*(12*r - 6)) - 5*D1*bdd1*f*r*(28*f*(2*s - 1) + 33*s) + bd1*(D1*(115*f**2*r*(2*s - 1) - 140*f*fd*(4*r*(3*s - 1) - 2*s + 1) + 132*f*r*s + 165*fd*(-4*r*s + r + s)) - 5*Dd*f*(28*f*(16*r*s - 6*r - 2*s + 1) + 264*r*s - 33*r - 33*s))) - 33*b1**2*(D1*Dd*(-f*(8*f + 5)*(r*(4*s - 1) - s) + fd*(5*f*(8*r - 1)*(4*s - 1) + 6*r*(8*s - 5) - 6*s + 6)) - D1*(D1*r*(fd**2*(5 - 20*s) + fd*(16*f*s - 4*f + 5*s - 5) + fdd*(-20*f*s + 5*f - 6*s + 6)) - 2*Ddd*f*(5*f + 3)*(r*(4*s - 1) - s)) + 2*Dd**2*f*(5*f + 3)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(2*D1*Dd*f*(f*(115*f + 66)*(r*(4*s - 1) - s) - 5*fd*(14*f*(48*r*s - 10*r - 14*s + 3) + 264*r*s - 99*r - 99*s + 33)) + 33*D1*bd1*(D1*(4*f**2*(r*(4*s - 1) - 2*s) - 5*f*fd*(4*r - 1)*(4*s - 1) + 5*f*s*(2*r - 1) + 6*fd*(r*(2 - 4*s) + s - 1)) + Dd*f*(-5*f*(8*r - 3)*(4*s - 1) - 96*r*s + 12*r + 36*s - 6)) + D1*(D1*(f*fd*(115*f*r*(6*s - 1) + 132*r*(2*s - 1) + s*(-230*f - 132)) + f*(-33*bdd1*(5*f*(4*r*s - r - 2*s) + s*(12*r - 6)) + 5*fdd*(r*(-168*f*s + 28*f - 66*s + 33) + s*(56*f + 33))) - 5*fd**2*(28*f*(2*r*(6*s - 1) - 4*s + 1) + 33*r*(2*s - 1) - 33*s + 33)) - 5*Ddd*f**2*(56*f + 33)*(r*(4*s - 1) - s)) - 5*Dd**2*f**2*(56*f + 33)*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k1) - D1**2*Pkd1*Pkd2*ct**3*f*k2**2*st**4*(4*C - 4)*(D1*Dd*f*(-5*fd*(24*r*s - 7*r - 7*s + 2) + (33*b1 + 10*f)*(4*r*s - r - s)) + D1*(D1*(f*(33*bd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1) + fd*(33*b1*r*(2*s - 1) + 10*f*(3*r*s - r - s))) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))/(231*d**2*k3**2) - 2*D1**2*Pkd1*Pkd2*ct**3*k1**2*st**2*(11*D1*bd1*f*(D1*(f*s*(5*C - 14)*(r - 1) - fd*(3*C - 9)*(r*(4*s - 1) - 2*s + 1)) + Dd*f*(9 - 3*C)*(r*(8*s - 1) - 5*s + 1)) - 11*b1*(D1*Dd*f*(-f*(5*C - 14)*(r*(4*s - 1) - s) + fd*(3*C - 9)*(2*r*(8*s - 3) - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(5*C - 14) - f*fdd*(3*C - 9) - fd**2*(3*C - 9)) + Ddd*f**2*(3*C - 9)*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*C - 9)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(39*C - 106)*(r*(4*s - 1) - s) - fd*(25*C - 75)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(39*C - 106)*(r*(3*s - 1) - s) - f*(C - 3)*(33*bdd1*s*(r - 1) + 25*fdd*(r*(3*s - 1) - s)) - fd**2*(25*C - 75)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(75 - 25*C)*(r*(4*s - 1) - s)) + Dd**2*f**2*(75 - 25*C)*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k3**2) - 4*D1**2*Pkd1*Pkd2*ct**3*k1**2*(-198*D1**2*bd1**2*f*(C - 2)*(r*(2*s - 1) - s + 1) + 33*D1*bd1*(-b1*(C - 2)*(D1*(5*f*(-2*r*s + r + s) + 6*fd*r*(4*s - 1) - 6*fd*s) + 12*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(4*f*(C*s - r*(C + 2*s - 2)) + 5*fd*(r*(C + 8*s - 4) - s*(C + 2) + 2)) - 10*Dd*f*(2*C*s + r*(-2*C - 8*s + 5) + s - 1))) - 33*b1**2*(C - 2)*(D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*r*(8*s - 1) - 6*fd*s) + D1*(D1*r*s*(-5*fd + 6*fdd) + 6*Ddd*f*(r*(4*s - 1) - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1*(2*D1*Dd*f*(4*f*(-4*r*s + r + s) - 5*fd*(-2*C*s + 2*r*(C - 8*s + 1) + 6*s - 1)) + D1*(-6*D1*bdd1*f*(C - 2)*(r*(2*s - 1) - s) + D1*(C*(r - s) + s*(2 - 4*r))*(4*f*fd - 5*f*fdd - 5*fd**2) + 10*Ddd*f**2*(r*(4*s - 1) - s)) + 10*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 5*f*(C*(D1*Dd*f*(23*f*(-4*r*s + r + s) + 28*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*(r - s) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 1) - s)) + 28*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + 66*D1**2*bdd1*f*r*(s - 1)))/(693*d**2*k3**2) - 2*D1**2*Pkd1*Pkd2*ct**3*k2**2*st**2*(-99*D1**2*bd1**2*f*(C - 1)*(r*(2*s - 1) - s + 1) + 33*D1*bd1*(-b1*(C - 1)*(D1*(13*f*(-2*r*s + r + s) + 3*fd*r*(4*s - 1) - 3*fd*s) + 6*Dd*f*(r*(8*s - 3) - 3*s + 1)) + f*(D1*(C*fd*(4*r*(7*s - 1) - 17*s + 7) - f*r*(C*(9*s + 5) + 14*s - 5) + f*s*(14*C + 9) + 3*fd*(4*r*(3*s - 1) - 5*s + 3)) + Dd*f*(C*(56*r*s + 5*r - 47*s + 7) + 72*r*s - 21*r - 33*s + 9))) - 33*b1**2*(C - 1)*(D1*Dd*(13*f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) + D1*(D1*r*s*(-13*fd + 3*fdd) + 3*Ddd*f*(r*(4*s - 1) - s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1*(D1*Dd*f*(-f*(9*C + 14)*(r*(4*s - 1) - s) + fd*(C*(2*r*(56*s - 27) - 2*s + 7) + 6*r*(24*s - 7) - 30*s + 9)) - D1*(3*D1*bdd1*f*(C - 1)*(r*(2*s - 1) - s) + D1*(f*(fd*r*(2*C*(9*s - 7) + 28*s - 9) + fd*s*(5*C - 5) - 2*fdd*r*(C*(7*s - 5) + 9*s - 3) - fdd*s*(3*C - 3)) + fd**2*(-2*r*(7*C*s - 5*C + 9*s - 3) + s*(3 - 3*C))) - Ddd*f**2*(7*C + 9)*(r*(4*s - 1) - s)) + Dd**2*f**2*(7*C + 9)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(-f*(302*C + 201)*(r*(4*s - 1) - s) + fd*(250*C + 150)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(-f*fd*(302*C + 201)*(r*(3*s - 1) - s) + f*(33*bdd1*(r*(7*C*s + 3*C + 9*s - 3) + s*(-10*C - 6)) + fdd*(250*C + 150)*(r*(3*s - 1) - s)) + fd**2*(250*C + 150)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(250*C + 150)*(r*(4*s - 1) - s)) + Dd**2*f**2*(250*C + 150)*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k3**2) - D1**2*Pkd1*Pkd2*ct**3*k2**2*(4*C + 4)*(6*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 5*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(D1*b1*(5*f*(-2*r*s + r + s) + 6*fd*r*(4*s - 1) - 6*fd*s) + D1*f*(-4*f*r*(s - 1) + 5*fd*(r*(4*s - 2) - s + 1)) + 12*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) + 5*Dd*f**2*(r*(8*s - 5) - s + 1)) + b1**2*(D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*r*(8*s - 1) - 6*fd*s) + D1*(D1*r*s*(-5*fd + 6*fdd) + 6*Ddd*f*(r*(4*s - 1) - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(6*D1*bdd1*f*(r*(2*s - 1) - s) - D1*s*(2*r - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct**3*st**2*(1287*D1**2*K*bdd1*f**2*r*s - 429*D1**2*bd1**2*f*s*(2*r - 1)*(-3*K + 10*f + 3) - 9750*D1**2*bdd1*f**3*r*s + 6500*D1**2*bdd1*f**3*s - 1287*D1**2*bdd1*f**2*r*s - 2574*D1**2*bdd1*f*g2*r*s + 2574*D1**2*bdd1*f*g2*s + 23600*D1**2*f**3*fd*r*s - 5900*D1**2*f**3*fd*r - 5900*D1**2*f**3*fd*s - 19600*D1**2*f**3*fdd*r*s + 4900*D1**2*f**3*fdd*r + 4900*D1**2*f**3*fdd*s - 58800*D1**2*f**2*fd**2*r*s + 14700*D1**2*f**2*fd**2*r + 14700*D1**2*f**2*fd**2*s - 4900*D1**2*f**2*fd**2 + 4290*D1**2*f**2*gd2*r*s - 2574*D1**2*f**2*gdd2*r*s + 8580*D1**2*f*fd*g2*r*s - 4290*D1**2*f*fd*g2*r - 4290*D1**2*f*fd*g2*s - 10296*D1**2*f*fd*gd2*r*s + 2574*D1**2*f*fd*gd2*r + 2574*D1**2*f*fd*gd2*s - 5148*D1**2*f*fdd*g2*r*s + 2574*D1**2*f*fdd*g2*r + 2574*D1**2*f*fdd*g2*s - 5148*D1**2*fd**2*g2*r*s + 2574*D1**2*fd**2*g2*r + 2574*D1**2*fd**2*g2*s - 2574*D1**2*fd**2*g2 + 23600*D1*Dd*f**4*r*s - 5900*D1*Dd*f**4*r - 5900*D1*Dd*f**4*s - 156800*D1*Dd*f**3*fd*r*s + 39200*D1*Dd*f**3*fd*r + 39200*D1*Dd*f**3*fd*s - 9800*D1*Dd*f**3*fd + 17160*D1*Dd*f**2*g2*r*s - 4290*D1*Dd*f**2*g2*r - 4290*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*gd2*r*s + 2574*D1*Dd*f**2*gd2*r + 2574*D1*Dd*f**2*gd2*s - 41184*D1*Dd*f*fd*g2*r*s + 15444*D1*Dd*f*fd*g2*r + 15444*D1*Dd*f*fd*g2*s - 5148*D1*Dd*f*fd*g2 - 19600*D1*Ddd*f**4*r*s + 4900*D1*Ddd*f**4*r + 4900*D1*Ddd*f**4*s - 10296*D1*Ddd*f**2*g2*r*s + 2574*D1*Ddd*f**2*g2*r + 2574*D1*Ddd*f**2*g2*s + 13*D1*bd1*(D1*(302*f**3*s*(3*r - 2) - 5*f**2*(50*fd*(18*r*s - 3*r - 7*s + 2) + r*s*(33*K - 33)) + 33*f*(3*fd*(K - 1)*(r*(4*s - 1) - s) + s*(26*g2*(r - 1) - 12*gd2*r + 6*gd2)) - 198*fd*g2*(r*(2*s - 1) - s + 1)) + Dd*f*(-250*f**2*(24*r*s - 3*r - 11*s + 2) + 99*f*(K - 1)*(8*r*s - r - s) - 198*g2*(8*r*s - r - 5*s + 1))) - 58800*Dd**2*f**4*r*s + 14700*Dd**2*f**4*r + 14700*Dd**2*f**4*s - 4900*Dd**2*f**4 - 30888*Dd**2*f**2*g2*r*s + 7722*Dd**2*f**2*g2*r + 7722*Dd**2*f**2*g2*s - 2574*Dd**2*f**2*g2 - 429*b1**2*(D1*Dd*(-f*(r*(4*s - 1) - s)*(-13*K + 14*f + 13) + fd*(10*f*(16*r*s - 6*r - 2*s + 1) + (3 - 3*K)*(8*r*s - 5*r - s + 1))) + D1*(D1*r*(f*fd*(14 - 28*s) + 10*f*fdd*(2*s - 1) + 10*fd**2*(2*s - 1) + 13*fd*(K - 1)*(s - 1) + 3*fdd*(-K*s + K + s - 1)) + Ddd*f*(r*(4*s - 1) - s)*(-3*K + 10*f + 3)) + Dd**2*f*(-3*K + 10*f + 3)*(3*r*(4*s - 1) - 3*s + 1)) + 13*b1*(D1*Dd*(906*f**3*(r*(4*s - 1) - s) - 5*f**2*(50*fd*(3*r*(24*s - 7) - 13*s + 4) + (33*K - 33)*(r*(4*s - 1) - s)) + 66*f*(3*fd*(K - 1)*(r*(8*s - 3) - 3*s + 1) + 13*g2*(4*r*s - r - s) + 3*gd2*(-8*r*s + r + s)) - 198*fd*g2*(r*(8*s - 5) - s + 1)) + 33*D1*bd1*(D1*(-10*f*fd*(r*(8*s - 2) - 2*s + 1) + f*s*(2*r - 1)*(-13*K + 14*f + 13) + 3*fd*(K - 1)*(r*(4*s - 2) - s + 1)) - Dd*f*(-3*K + 10*f + 3)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(-10*f**2*(33*bdd1*s*(2*r - 1) + 25*fdd*(9*r*s - 3*r - s)) + 33*f*(3*fdd*(K - 1)*(r*(2*s - 1) - s) + s*(3*bdd1*(K - 1)*(2*r - 1) + 26*gd2*r - 6*gdd2*r)) + fd**2*(-250*f*(18*r*s - 6*r - 2*s + 1) + (99*K - 99)*(2*r*s - r - s + 1)) + fd*(302*f**2*(r*(9*s - 3) - s) - 165*f*(K - 1)*(r*(2*s - 1) - s) + 66*r*(13*g2*(s - 1) - 6*gd2*s + 3*gd2)) - 198*fdd*g2*r*(s - 1)) - 3*Ddd*f*(r*(4*s - 1) - s)*(250*f**2 - 33*f*(K - 1) + 66*g2)) - 3*Dd**2*f*(250*f**2 - 33*f*(K - 1) + 66*g2)*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2) + 2*D1**2*Pkd1*Pkd2*ct**3*(-198*D1**2*K*bd1**2*f*r + 198*D1**2*K*bd1**2*f*s + 132*D1**2*K*bd1*f**2*r*s - 660*D1**2*K*bd1*f*fd*r*s + 165*D1**2*K*bd1*f*fd*r + 165*D1**2*K*bd1*f*fd*s - 165*D1**2*K*bdd1*f**2*r*s - 1320*D1**2*bd1**2*f**2*r*s + 495*D1**2*bd1**2*f**2*r + 495*D1**2*bd1**2*f**2*s - 330*D1**2*bd1**2*f**2 - 792*D1**2*bd1**2*f*r*s + 198*D1**2*bd1**2*f*r + 198*D1**2*bd1**2*f*s - 924*D1**2*bd1**2*g2*r*s + 462*D1**2*bd1**2*g2*r + 462*D1**2*bd1**2*g2*s - 462*D1**2*bd1**2*g2 - 396*D1**2*bd1*bd2*f*r*s + 198*D1**2*bd1*bd2*f*s + 345*D1**2*bd1*f**3*r*s - 230*D1**2*bd1*f**3*r - 2520*D1**2*bd1*f**2*fd*r*s + 980*D1**2*bd1*f**2*fd*r + 420*D1**2*bd1*f**2*fd*s - 280*D1**2*bd1*f**2*fd + 132*D1**2*bd1*f**2*r*s - 660*D1**2*bd1*f*fd*r*s + 165*D1**2*bd1*f*fd*r + 165*D1**2*bd1*f*fd*s - 330*D1**2*bd1*f*g2*r + 330*D1**2*bd1*f*g2*s + 396*D1**2*bd1*f*gd2*r - 396*D1**2*bd1*f*gd2*s + 132*D1**2*bd2*f**2*r*s - 660*D1**2*bd2*f*fd*r*s + 165*D1**2*bd2*f*fd*r + 165*D1**2*bd2*f*fd*s - 420*D1**2*bdd1*f**3*r*s + 280*D1**2*bdd1*f**3*r - 165*D1**2*bdd1*f**2*r*s + 396*D1**2*bdd1*f*g2*r - 396*D1**2*bdd1*f*g2*s - 165*D1**2*bdd2*f**2*r*s - 264*D1**2*f**2*gd2*r*s + 330*D1**2*f**2*gdd2*r*s - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s + 1320*D1**2*f*fd*gd2*r*s - 330*D1**2*f*fd*gd2*r - 330*D1**2*f*fd*gd2*s + 660*D1**2*f*fdd*g2*r*s - 330*D1**2*f*fdd*g2*r - 330*D1**2*f*fdd*g2*s + 660*D1**2*fd**2*g2*r*s - 330*D1**2*fd**2*g2*r - 330*D1**2*fd**2*g2*s + 330*D1**2*fd**2*g2 - 1320*D1*Dd*K*bd1*f**2*r*s + 165*D1*Dd*K*bd1*f**2*r + 165*D1*Dd*K*bd1*f**2*s - 3360*D1*Dd*bd1*f**3*r*s + 1540*D1*Dd*bd1*f**3*r + 420*D1*Dd*bd1*f**3*s - 280*D1*Dd*bd1*f**3 - 1320*D1*Dd*bd1*f**2*r*s + 165*D1*Dd*bd1*f**2*r + 165*D1*Dd*bd1*f**2*s + 1584*D1*Dd*bd1*f*g2*r - 1584*D1*Dd*bd1*f*g2*s - 1320*D1*Dd*bd2*f**2*r*s + 165*D1*Dd*bd2*f**2*r + 165*D1*Dd*bd2*f**2*s - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r + 264*D1*Dd*f**2*g2*s + 2640*D1*Dd*f**2*gd2*r*s - 330*D1*Dd*f**2*gd2*r - 330*D1*Dd*f**2*gd2*s + 5280*D1*Dd*f*fd*g2*r*s - 1980*D1*Dd*f*fd*g2*r - 1980*D1*Dd*f*fd*g2*s + 660*D1*Dd*f*fd*g2 + 1320*D1*Ddd*f**2*g2*r*s - 330*D1*Ddd*f**2*g2*r - 330*D1*Ddd*f**2*g2*s + 3960*Dd**2*f**2*g2*r*s - 990*Dd**2*f**2*g2*r - 990*Dd**2*f**2*g2*s + 330*Dd**2*f**2*g2 - 33*b1**3*(D1*Dd*(r*(f*(5 - 20*s) + 6*fd*(8*s - 1) + (14*K - 14)*(4*s - 1)) + s*(-14*K + 5*f - 6*fd + 14)) + D1*(D1*r*s*(-5*fd + 6*fdd) + Ddd*(r*(4*s - 1) - s)*(-7*K + 6*f + 7)) + Dd**2*(-7*K + 6*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1**2*(-2*D1*Dd*(8*f**2*(-4*r*s + r + s) + 5*f*fd*(r*(32*s - 6) - 6*s + 1) + 5*f*(-4*r*s + r + s) - 6*fd*(r*(2*K - 8*s + 3) + s*(3 - 2*K) - 1) - 7*g2*(r*(8*s - 2) - 2*s) - 7*gd2*(-8*r*s + r + s)) + D1*bd1*(D1*(r*(-42*K*s + 14*K + 5*f*(3*s - 1) + fd*(6 - 36*s) + 42*s - 14) + s*(14*K - 5*f + 6*fd - 14)) - Dd*(-7*K + 6*f + 7)*(r*(24*s - 7) - 7*s + 2)) + D1*(-D1*bdd1*(r*(3*s - 1) - s)*(-7*K + 6*f + 7) + D1*(f*fdd*r*(5 - 40*s) + 5*fd**2*(-8*r*s + r + s) + fd*r*(-5*K + 4*f*(8*s - 1) + 10*s - 5) + fd*s*(5*K - 4*f - 5) + 6*fdd*r*(K - 2*s + 1) + fdd*s*(-6*K + 5*f + 6) + r*s*(28*gd2 - 14*gdd2)) - 2*Ddd*(r*(4*s - 1) - s)*(10*f**2 + 6*f + 7*g2)) - 2*Dd**2*(10*f**2 + 6*f + 7*g2)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-198*D1**2*K*bdd1*f*r + 198*D1**2*K*bdd1*f*s + 264*D1**2*K*f*fd*r*s - 132*D1**2*K*f*fd*r - 132*D1**2*K*f*fd*s - 330*D1**2*K*f*fdd*r*s + 165*D1**2*K*f*fdd*r + 165*D1**2*K*f*fdd*s - 330*D1**2*K*fd**2*r*s + 165*D1**2*K*fd**2*r + 165*D1**2*K*fd**2*s - 165*D1**2*K*fd**2 - 33*D1**2*bd1**2*(-7*K + 6*f + 7)*(r*(6*s - 2) - 2*s + 1) + 165*D1**2*bd2*f*r*s - 396*D1**2*bd2*fd*r*s + 198*D1**2*bd2*fd*r - 1320*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*r + 495*D1**2*bdd1*f**2*s - 792*D1**2*bdd1*f*r*s + 198*D1**2*bdd1*f*r + 198*D1**2*bdd1*f*s - 924*D1**2*bdd1*g2*r*s + 462*D1**2*bdd1*g2*r + 462*D1**2*bdd1*g2*s - 198*D1**2*bdd2*f*r*s + 1035*D1**2*f**2*fd*r*s - 115*D1**2*f**2*fd*r - 345*D1**2*f**2*fd*s - 1260*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s - 2520*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 264*D1**2*f*fd*r*s - 132*D1**2*f*fd*r - 132*D1**2*f*fd*s - 330*D1**2*f*fdd*r*s + 165*D1**2*f*fdd*r + 165*D1**2*f*fdd*s - 330*D1**2*fd**2*r*s + 165*D1**2*fd**2*r + 165*D1**2*fd**2*s - 165*D1**2*fd**2 + 330*D1**2*fd*g2*r - 330*D1**2*fd*g2*s - 396*D1**2*fd*gd2*r + 396*D1**2*fd*gd2*s - 396*D1**2*fdd*g2*r + 396*D1**2*fdd*g2*s + 528*D1*Dd*K*f**2*r*s - 132*D1*Dd*K*f**2*r - 132*D1*Dd*K*f**2*s - 2640*D1*Dd*K*f*fd*r*s + 990*D1*Dd*K*f*fd*r + 990*D1*Dd*K*f*fd*s - 330*D1*Dd*K*f*fd - 1584*D1*Dd*bd2*f*r*s + 198*D1*Dd*bd2*f*r + 198*D1*Dd*bd2*f*s + 1380*D1*Dd*f**3*r*s - 345*D1*Dd*f**3*r - 345*D1*Dd*f**3*s - 10080*D1*Dd*f**2*fd*r*s + 1820*D1*Dd*f**2*fd*r + 2940*D1*Dd*f**2*fd*s - 560*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r*s - 132*D1*Dd*f**2*r - 132*D1*Dd*f**2*s - 2640*D1*Dd*f*fd*r*s + 990*D1*Dd*f*fd*r + 990*D1*Dd*f*fd*s - 330*D1*Dd*f*fd - 1584*D1*Dd*fd*g2*r + 1584*D1*Dd*fd*g2*s - 660*D1*Ddd*K*f**2*r*s + 165*D1*Ddd*K*f**2*r + 165*D1*Ddd*K*f**2*s - 1680*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s - 660*D1*Ddd*f**2*r*s + 165*D1*Ddd*f**2*r + 165*D1*Ddd*f**2*s + 33*D1*bd1*(-D1*(-4*f**2*(r*(8*s - 3) - 3*s) + 5*f*(-K*r + K*s - 4*r*s + r + s) + 2*fd*(3*K*s + 5*f*(4*r - 1)*(4*s - 1) - 3*r*(K - 8*s + 3) - 9*s + 6) - 14*g2*r*(4*s - 2) + 28*g2*s - 14*gd2*(-4*r*s + r + s)) - 2*Dd*(5*f**2*(2*r*(16*s - 5) - 10*s + 3) + 6*f*(2*r*(K + 8*s - 2) - s*(2*K + 4) + 1) + 14*g2*(r*(8*s - 3) - 3*s + 1))) - 1980*Dd**2*K*f**2*r*s + 495*Dd**2*K*f**2*r + 495*Dd**2*K*f**2*s - 165*Dd**2*K*f**2 - 5040*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r + 1260*Dd**2*f**3*s - 420*Dd**2*f**3 - 1980*Dd**2*f**2*r*s + 495*Dd**2*f**2*r + 495*Dd**2*f**2*s - 165*Dd**2*f**2 - 33*b2*(D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*(8*r*s - 5*r - s + 1)) + D1*(-D1*r*(5*fd - 6*fdd)*(s - 1) + 6*Ddd*f*(4*r*s - r - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1))) + 33*b2*(2*D1*Dd*f*(2*f*(4*r*s - r - s) - 5*fd*(8*r*s - 3*r - 3*s + 1)) + D1*bd1*(D1*(5*f*s*(r - 1) + 6*fd*(-2*r*s + r + s - 1)) - 6*Dd*f*(r*(8*s - 1) - 5*s + 1)) + D1*(D1*(-6*bdd1*f*s*(r - 1) + 4*f*fd*r*(2*s - 1) - 4*f*fd*s + 5*f*fdd*(-2*r*s + r + s) + 5*fd**2*(-2*r*s + r + s - 1)) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2) + 2*D1**2*Pkd1*Pkd2*ct**2*f*k1*k2*st**4*(D1*Dd*f*(fd*(4*C - 9)*(r*(24*s - 7) - 7*s + 2) + (33*b1 + f*(18 - 8*C))*(r*(4*s - 1) - s)) + D1*(D1*(f*(33*bd1*s*(r - 1) + fdd*(4*C - 9)*(3*r*s - r - s)) + fd**2*(4*C - 9)*(r*(6*s - 2) - 2*s + 1) + fd*(33*b1*r*(2*s - 1) - f*(8*C - 18)*(3*r*s - r - s))) + Ddd*f**2*(4*C - 9)*(r*(4*s - 1) - s)) + Dd**2*f**2*(4*C - 9)*(3*r*(4*s - 1) - 3*s + 1))/(231*d**2*k3**2) + 2*D1**2*Pkd1*Pkd2*ct**2*f*k2**3*st**4*(D1*Dd*f*(-5*fd*(24*r*s - 7*r - 7*s + 2) + (33*b1 + 10*f)*(4*r*s - r - s)) + D1*(D1*(f*(33*bd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1) + fd*(33*b1*r*(2*s - 1) + 10*f*(3*r*s - r - s))) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))/(231*d**2*k1*k3**2) + 10*D1**2*Pkd1*Pkd2*ct**2*f*k2*st**4*(39*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-6*r*s + r + 3*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 39*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + fd*r*(24*s - 7) - 3*fd*s + fd) - D1*(D1*r*(3*s - 1)*(2*f*fd - f*fdd - 2*fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(47*f*(4*r*s - r - s) - 60*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-39*bdd1*f*s*(r - 1) + 47*f*fd*(r*(4*s - 1) - s) + 30*f*fdd*(-4*r*s + r + s) - 30*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 30*Ddd*f**2*(-4*r*s + r + s)) - 30*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(3003*d**2*k1) + D1**2*Pkd1*Pkd2*ct**2*k1**3*st**2*(11*D1*bd1*f*(D1*(5*f*s*(r - 1) + 3*fd*(-4*r*s + r + 2*s - 1)) - 3*Dd*f*(r*(8*s - 1) - 5*s + 1)) - 11*b1*(D1*Dd*f*(5*f*(-4*r*s + r + s) + 3*fd*(16*r*s - 6*r - 2*s + 1)) + D1*(-D1*r*(2*s - 1)*(5*f*fd - 3*f*fdd - 3*fd**2) + 3*Ddd*f**2*(4*r*s - r - s)) + 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(39*f*(4*r*s - r - s) - 25*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(39*f*fd*(r*(3*s - 1) - s) + f*(-33*bdd1*s*(r - 1) + 25*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(-4*r*s + r + s)) - 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k2*k3**2) + 2*D1**2*Pkd1*Pkd2*ct**2*k1**3*(-6*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) - 5*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(D1*b1*(5*f*r*(2*s - 1) - 5*f*s + 6*fd*(-4*r*s + r + s)) + D1*f*(4*f*r*(s - 1) - 5*fd*(r*(4*s - 2) - s + 1)) - 12*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) - 5*Dd*f**2*(r*(8*s - 5) - s + 1)) + b1**2*(D1*Dd*(5*f*r*(4*s - 1) - 5*f*s + 6*fd*(-8*r*s + r + s)) + D1*(D1*r*s*(5*fd - 6*fdd) + 6*Ddd*f*(-4*r*s + r + s)) - 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(4*f*(r*(4*s - 1) - s) - 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(6*D1*bdd1*f*(-2*r*s + r + s) + D1*s*(2*r - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(-4*r*s + r + s)) - 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k2*k3**2) + D1**2*Pkd1*Pkd2*ct**2*k1*k2*st**2*(11*D1**2*bd1**2*f*(4*C - 7)*(r*(2*s - 1) - s + 1) - 11*D1*bd1*(D1*b1*(f*(8*C - 21)*(r*(2*s - 1) - s) - fd*(4*C - 7)*(r*(4*s - 1) - s)) + D1*f*(f*(-r*(28*C*s + 8*C + 18*s - 13) + s*(36*C + 5)) + fd*(4*C*(20*r*s - 4*r - 11*s + 5) + 40*r*s - 17*r - 13*s + 10)) - 2*Dd*b1*f*(4*C - 7)*(r*(8*s - 3) - 3*s + 1) + 2*Dd*f**2*(2*C*(r*(40*s - 1) - 29*s + 5) + r*(40*s - 19) - 11*s + 5)) + 11*b1**2*(D1*Dd*(-f*(8*C - 21)*(r*(4*s - 1) - s) + fd*(4*C - 7)*(r*(8*s - 1) - s)) + D1*(D1*r*s*(fd*(21 - 8*C) + fdd*(4*C - 7)) + Ddd*f*(4*C - 7)*(r*(4*s - 1) - s)) + Dd**2*f*(4*C - 7)*(3*r*(4*s - 1) - 3*s + 1)) - 11*b1*(-2*D1*Dd*f*(f*(14*C + 9)*(r*(4*s - 1) - s) + fd*(-2*C*(80*r*s - 34*r - 6*s + 5) - 80*r*s + 16*r + 24*s - 5)) - D1*(D1*bdd1*f*(4*C - 7)*(r*(2*s - 1) - s) + D1*(f*(fd*r*(4*C*(14*s - 9) + 36*s - 5) + fd*s*(8*C - 13) + fdd*r*(-8*C*(5*s - 3) - 20*s + 3) + fdd*s*(7 - 4*C)) + fd**2*(r*(-40*C*s + 24*C - 20*s + 3) + s*(7 - 4*C))) - Ddd*f**2*(20*C + 10)*(r*(4*s - 1) - s)) + Dd**2*f**2*(20*C + 10)*(3*r*(4*s - 1) - 3*s + 1)) + f*(D1*Dd*f*(f*(268*C + 39)*(r*(4*s - 1) - s) - fd*(200*C + 25)*(r*(24*s - 7) - 7*s + 2)) + D1*(D1*(f*fd*(268*C + 39)*(r*(3*s - 1) - s) + f*(-11*bdd1*(-24*C*s + r*(20*C*s + 4*C + 10*s - 7) - 3*s) + fdd*(-200*C - 25)*(r*(3*s - 1) - s)) - fd**2*(200*C + 25)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(-200*C - 25)*(r*(4*s - 1) - s)) + Dd**2*f**2*(-200*C - 25)*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k3**2) - D1**2*Pkd1*Pkd2*ct**2*k1*k2*(8*C + 2)*(6*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 5*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(D1*b1*(5*f*(-2*r*s + r + s) + 6*fd*r*(4*s - 1) - 6*fd*s) + D1*f*(-4*f*r*(s - 1) + 5*fd*(r*(4*s - 2) - s + 1)) + 12*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) + 5*Dd*f**2*(r*(8*s - 5) - s + 1)) + b1**2*(D1*Dd*(5*f*(-4*r*s + r + s) + 6*fd*r*(8*s - 1) - 6*fd*s) + D1*(D1*r*s*(-5*fd + 6*fdd) + 6*Ddd*f*(r*(4*s - 1) - s)) + 6*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + 5*fd*(2*r*(8*s - 1) - 6*s + 1)) + D1*(6*D1*bdd1*f*(r*(2*s - 1) - s) - D1*s*(2*r - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - r - s)) + 5*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct**2*k1*st**2*(-143*b1**2*(D1*Dd*(-f*(9*f + 13)*(r*(4*s - 1) - s) + 3*fd*(2*f*(16*r*s - 6*r - 2*s + 1) + 8*r*s - 5*r - s + 1)) - D1*(D1*r*(fd**2*(6 - 12*s) + fd*(18*f*s - 9*f + 13*s - 13) - 3*fdd*(4*f*s - 2*f + s - 1)) - 3*Ddd*f*(2*f + 1)*(r*(4*s - 1) - s)) + 3*Dd**2*f*(2*f + 1)*(3*r*(4*s - 1) - 3*s + 1)) + 13*b1*(D1*Dd*f*(f*(134*f + 55)*(r*(4*s - 1) - s) - 2*fd*(25*f*(48*r*s - 14*r - 10*s + 3) + 264*r*s - 99*r - 99*s + 33)) + 11*D1*bd1*(D1*(f*s*(9*f + 13)*(2*r - 1) - 3*fd*(2*f*(8*r*s - 2*r - 2*s + 1) + 4*r*s - 2*r - s + 1)) - 3*Dd*f*(2*f + 1)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(D1*(f*fd*(134*f*r*(3*s - 1) + 55*r*(2*s - 1) - s*(67*f + 55)) + f*(-33*bdd1*s*(2*f + 1)*(2*r - 1) + fdd*r*(-100*f*(3*s - 1) - 66*s + 33) + fdd*s*(50*f + 33)) + fd**2*(-50*f*(4*r*(3*s - 1) - 2*s + 1) - 66*r*s + 33*r + 33*s - 33)) - Ddd*f**2*(100*f + 33)*(r*(4*s - 1) - s)) - Dd**2*f**2*(100*f + 33)*(3*r*(4*s - 1) - 3*s + 1)) + f*(-429*D1**2*bd1**2*s*(2*f + 1)*(2*r - 1) + 13*D1*bd1*(D1*(67*f**2*s*(2*r - 1) - 50*f*fd*(2*r*(6*s - 1) - 4*s + 1) + 55*f*r*s + 33*fd*(-4*r*s + r + s)) + Dd*f*(-50*f*(16*r*s - 2*r - 6*s + 1) - 264*r*s + 33*r + 33*s)) + f*(5*D1*Dd*f*(131*f*(r*(4*s - 1) - s) - 196*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(-429*bdd1*r*s + 655*f*fd*(r*(4*s - 1) - s) - 10*f*(65*bdd1*s*(2*r - 1) + 49*fdd*(4*r*s - r - s)) - 490*fd**2*(3*r*(4*s - 1) - 3*s + 1)) - 490*Ddd*f**2*(r*(4*s - 1) - s)) - 490*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(3003*d**2*k2) + 2*D1**2*Pkd1*Pkd2*ct**2*k1*(D1*f*(-33*D1*bd1**2*(5*f*(4*r*s - 2*r - s + 1) + 6*r*(2*s - 1)) - 140*D1*bdd1*f**2*r*(s - 1) - 5*bd1*f*(D1*(-23*f*r*(s - 1) + 28*fd*(6*r*s - 3*r - s + 1)) + 28*Dd*f*(r*(8*s - 5) - s + 1))) - 33*b1**3*(D1*Dd*(r*(-20*f*s + 5*f + 48*fd*s - 6*fd - 56*s + 14) + s*(5*f - 6*fd + 14)) + D1*(D1*r*s*(-5*fd + 6*fdd) + Ddd*(6*f + 7)*(4*r*s - r - s)) + Dd**2*(6*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1**2*(D1*Dd*(f*(8*f + 5)*(r*(4*s - 1) - s) + fd*(-5*f*(4*r - 1)*(8*s - 1) - 48*r*s + 6*r + 30*s - 6)) + D1*bd1*(D1*(r*(15*f*s - 5*f - 36*fd*s + 6*fd + 42*s - 14) + s*(-5*f + 6*fd - 14)) - Dd*(6*f + 7)*(r*(24*s - 7) - 7*s + 2)) + D1*(-D1*bdd1*(6*f + 7)*(r*(3*s - 1) - s) + D1*s*(fd**2*(5 - 20*r) + fd*(16*f*r - 4*f + 5*r - 5) + fdd*(-20*f*r + 5*f - 6*r + 6)) - 2*Ddd*f*(5*f + 3)*(r*(4*s - 1) - s)) - 2*Dd**2*f*(5*f + 3)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-33*D1**2*bd1**2*(6*f + 7)*(r*(6*s - 2) - 2*s + 1) + 33*D1*bd1*(D1*(-4*f**2*s - 5*f*fd*(4*r - 1)*(4*s - 1) + f*r*(8*f + 5)*(2*s - 1) + 6*fd*(-4*r*s + r + 2*s - 1)) + Dd*f*(-5*f*(4*r - 1)*(8*s - 3) - 96*r*s + 36*r + 12*s - 6)) + f*(5*D1*Dd*f*(23*f*(4*r*s - r - s) - 28*fd*(24*r*s - 3*r - 7*s + 1)) + D1*(165*D1*bdd1*f*s - 66*D1*bdd1*r*(5*f + 3)*(2*s - 1) + 5*D1*s*(3*r - 1)*(23*f*fd - 28*f*fdd - 56*fd**2) - 140*Ddd*f**2*(r*(4*s - 1) - s)) - 140*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))))/(693*d**2*k2) + D1**2*Pkd1*Pkd2*ct**2*k2**3*st**2*(3*D1**2*bd1**2*f*(-2*r*s + r + s - 1) - 3*D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*(D1*b1*(13*f*(r*(2*s - 1) - s) + 3*fd*(-4*r*s + r + s)) + D1*f*(5*f*r*(s - 1) + 3*fd*(r*(2 - 4*s) + s - 1)) - 6*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) - 3*Dd*f**2*(r*(8*s - 5) - s + 1)) + b1**2*(D1*Dd*(13*f*(4*r*s - r - s) + 3*fd*(-8*r*s + r + s)) + D1*(D1*r*s*(13*fd - 3*fdd) + 3*Ddd*f*(-4*r*s + r + s)) - 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(5*f*(r*(4*s - 1) - s) + fd*(r*(6 - 48*s) + 18*s - 3)) + D1*(3*D1*bdd1*f*(-2*r*s + r + s) + D1*s*(2*r - 1)*(5*f*fd - 3*f*fdd - 3*fd**2) + 3*Ddd*f**2*(-4*r*s + r + s)) - 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k1*k3**2) + D1**2*Pkd1*Pkd2*ct**2*k2*st**2*(D1*f*(-33*D1*bd1**2*(f*(8*r*s - 2*r - 4*s + 2) + s*(2*r - 1)) + D1*bdd1*f*r*(-50*f*(2*s - 1) - 33*s) + bd1*(D1*(67*f**2*r*(2*s - 1) - 50*f*fd*(4*r*(3*s - 1) - 2*s + 1) + 55*f*r*s + 33*fd*(-4*r*s + r + s)) + Dd*f*(-50*f*(16*r*s - 6*r - 2*s + 1) - 264*r*s + 33*r + 33*s))) - 11*b1**2*(D1*Dd*(-f*(18*f + 13)*(r*(4*s - 1) - s) + 3*fd*(2*f*(8*r - 1)*(4*s - 1) + 8*r*s - 5*r - s + 1)) - D1*(D1*r*(fd**2*(6 - 24*s) + fd*(36*f*s - 9*f + 13*s - 13) - 3*fdd*(8*f*s - 2*f + s - 1)) - 3*Ddd*f*(4*f + 1)*(r*(4*s - 1) - s)) + 3*Dd**2*f*(4*f + 1)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(f*(134*f + 55)*(r*(4*s - 1) - s) - 2*fd*(25*f*(48*r*s - 10*r - 14*s + 3) + 264*r*s - 99*r - 99*s + 33)) + 11*D1*bd1*(D1*(f*(9*f*(4*r*s - r - 2*s) + s*(26*r - 13)) - 3*fd*(2*f*(4*r - 1)*(4*s - 1) + 4*r*s - 2*r - s + 1)) - 3*Dd*f*(2*f*(8*r - 3)*(4*s - 1) + 16*r*s - 2*r - 6*s + 1)) + D1*(D1*(f*fd*(67*f*r*(6*s - 1) + 55*r*(2*s - 1) - s*(134*f + 55)) + f*(-33*bdd1*(f*r*(8*s - 2) - 4*f*s + s*(2*r - 1)) + fdd*(r*(-50*f*(6*s - 1) - 66*s + 33) + s*(100*f + 33))) + fd**2*(-50*f*(2*r*(6*s - 1) - 4*s + 1) - 66*r*s + 33*r + 33*s - 33)) - Ddd*f**2*(100*f + 33)*(r*(4*s - 1) - s)) - Dd**2*f**2*(100*f + 33)*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k1) + 2*D1**2*Pkd1*Pkd2*ct**2*k2*(-D1**2*bd1**2*f*r*(5*f + 6)*(2*s - 1) + D1*b1*(-D1*bd1**2*(6*f + 7)*(r*(6*s - 2) - 2*s + 1) - D1*bdd1*f*r*(5*f + 6)*(2*s - 1) + bd1*(D1*(-5*f*fd*(r*(8*s - 2) - 2*s + 1) + f*r*(4*f + 5)*(2*s - 1) + 6*fd*(-4*r*s + r + 2*s - 1)) - Dd*f*(5*f + 6)*(2*r*(8*s - 3) - 2*s + 1))) + b1**3*(D1*Dd*(r*(20*f*s - 5*f - 48*fd*s + 6*fd + 56*s - 14) + s*(-5*f + 6*fd - 14)) + D1*(D1*r*s*(5*fd - 6*fdd) - Ddd*(6*f + 7)*(4*r*s - r - s)) - Dd**2*(6*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(D1*Dd*(f*(4*f + 5)*(r*(4*s - 1) - s) + fd*(-5*f*(16*r*s - 2*r - 6*s + 1) - 48*r*s + 6*r + 30*s - 6)) + D1*bd1*(D1*(r*(15*f*s - 5*f - 36*fd*s + 6*fd + 42*s - 14) + s*(-5*f + 6*fd - 14)) - Dd*(6*f + 7)*(r*(24*s - 7) - 7*s + 2)) + D1*(-D1*bdd1*(6*f + 7)*(r*(3*s - 1) - s) + D1*s*(fd**2*(5 - 10*r) + fd*(8*f*r - 4*f + 5*r - 5) + fdd*(-10*f*r + 5*f - 6*r + 6)) - Ddd*f*(5*f + 6)*(r*(4*s - 1) - s)) - Dd**2*f*(5*f + 6)*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k1) + 4*D1**2*Pkd1*Pkd2*ct*f*k1**2*st**4*(D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 7*r + 7*s - 2)) + D1*(D1*(2*f*fd*(3*r*s - r - s) + f*fdd*(-3*r*s + r + s) + fd**2*(-6*r*s + 2*r + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1))/(231*d**2*k3**2) + 4*D1**2*Pkd1*Pkd2*ct*f*k2**2*st**4*(D1*Dd*f*(-fd*(5*C + 1)*(r*(24*s - 7) - 7*s + 2) + (r*(4*s - 1) - s)*(33*C*b1 + 10*C*f + 2*f)) + D1*(D1*(f*(33*C*bd1*s*(r - 1) - fdd*(5*C + 1)*(3*r*s - r - s)) - fd**2*(5*C + 1)*(r*(6*s - 2) - 2*s + 1) + fd*(33*C*b1*r*(2*s - 1) + f*(10*C + 2)*(3*r*s - r - s))) - Ddd*f**2*(5*C + 1)*(r*(4*s - 1) - s)) - Dd**2*f**2*(5*C + 1)*(3*r*(4*s - 1) - 3*s + 1))/(231*d**2*k3**2) + 2*D1**2*Pkd1*Pkd2*ct*f*st**4*(429*D1*b1**2*(D1*fd*r*(2*s - 1) + Dd*f*(4*r*s - r - s)) + 13*D1*bd1*f*(D1*(-5*fd*(18*r*s - 3*r - 7*s + 2) + s*(66*b1*r - 33*b1 + 30*f*r - 20*f)) - 5*Dd*f*(3*r*(8*s - 1) - 11*s + 2)) - 65*b1*(D1*Dd*f*(6*f*(-4*r*s + r + s) + fd*(72*r*s - 21*r - 13*s + 4)) + D1*(D1*(2*f*fd*(-9*r*s + 3*r + s) + f*fdd*(9*r*s - 3*r - s) + fd**2*(18*r*s - 6*r - 2*s + 1)) + 3*Ddd*f**2*(r*(4*s - 1) - s)) + 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(2*D1*Dd*f*(87*f*(4*r*s - r - s) - 100*fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(174*f*fd*(r*(4*s - 1) - s) - 5*f*(13*bdd1*s*(3*r - 2) + 20*fdd*(4*r*s - r - s)) - 100*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 100*Ddd*f**2*(-4*r*s + r + s)) - 100*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(3003*d**2) + 2*D1**2*Pkd1*Pkd2*ct*k1**2*st**2*(-11*D1**2*bd1**2*f*(r*(2*s - 1) - s + 1) + 11*D1*bd1*(D1*b1*(f*r*(4*s - 2) - 2*f*s + fd*(-4*r*s + r + s)) + D1*f*(f*(-5*C*s + r*(5*C*s + 2*s - 2)) + fd*(3*C*(-4*r*s + r + 2*s - 1) - 4*r*s + 2*r + s - 1)) - 2*Dd*b1*f*(r*(8*s - 3) - 3*s + 1) + Dd*f**2*(-3*C*(r*(8*s - 1) - 5*s + 1) + r*(5 - 8*s) + s - 1)) - 11*b1**2*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) - 11*b1*(D1*Dd*f*(-f*(5*C + 2)*(r*(4*s - 1) - s) + fd*(3*C*(16*r*s - 6*r - 2*s + 1) + 16*r*s - 2*r - 6*s + 1)) - D1*(D1*bdd1*f*(-2*r*s + r + s) + D1*(C*r*(2*s - 1)*(5*f*fd - 3*f*fdd - 3*fd**2) + s*(2*r - 1)*(2*f*fd - f*fdd - fd**2)) - Ddd*f**2*(3*C + 1)*(r*(4*s - 1) - s)) + Dd**2*f**2*(3*C + 1)*(3*r*(4*s - 1) - 3*s + 1)) + f*(C*(D1*Dd*f*(39*f*(4*r*s - r - s) - 25*fd*(24*r*s - 7*r - 7*s + 2)) + D1*(D1*(39*f*fd*(r*(3*s - 1) - s) + f*(-33*bdd1*s*(r - 1) + 25*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(-4*r*s + r + s)) - 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) - 11*D1**2*bdd1*f*r*(s - 1)))/(231*d**2*k3**2) + 2*D1**2*Pkd1*Pkd2*ct*k2**2*st**2*(-D1**2*bd1**2*f*(3*C + 1)*(r*(2*s - 1) - s + 1) - D1**2*bdd1*f**2*r*(3*C + 1)*(s - 1) + D1*bd1*(D1*b1*(f*(13*C + 2)*(r*(2*s - 1) - s) - fd*(3*C + 1)*(r*(4*s - 1) - s)) + D1*f*(f*r*(5*C + 2)*(s - 1) - fd*(3*C + 1)*(r*(4*s - 2) - s + 1)) - 2*Dd*b1*f*(3*C + 1)*(r*(8*s - 3) - 3*s + 1) - Dd*f**2*(3*C + 1)*(r*(8*s - 5) - s + 1)) + b1**2*(D1*Dd*(f*(13*C + 2)*(4*r*s - r - s) - fd*(3*C + 1)*(8*r*s - r - s)) + D1*(D1*r*s*(13*C*fd - 3*C*fdd + 2*fd - fdd) - Ddd*f*(3*C + 1)*(4*r*s - r - s)) - Dd**2*f*(3*C + 1)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(D1*Dd*f*(f*(5*C + 2)*(r*(4*s - 1) - s) - fd*(3*C + 1)*(2*r*(8*s - 1) - 6*s + 1)) + D1*(-D1*bdd1*f*(3*C + 1)*(r*(2*s - 1) - s) - D1*s*(2*r - 1)*(f*(3*C*fdd - fd*(5*C + 2) + fdd) + fd**2*(3*C + 1)) - Ddd*f**2*(3*C + 1)*(r*(4*s - 1) - s)) - Dd**2*f**2*(3*C + 1)*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k3**2) + D1**2*Pkd1*Pkd2*ct*st**2*(-66*D1**2*K*bd1**2*f*r*s + 33*D1**2*K*bd1**2*f*s + 55*D1**2*K*bd1*f**2*r*s - 132*D1**2*K*bd1*f*fd*r*s + 33*D1**2*K*bd1*f*fd*r + 33*D1**2*K*bd1*f*fd*s - 33*D1**2*K*bdd1*f**2*r*s - 264*D1**2*bd1**2*f**2*r*s + 99*D1**2*bd1**2*f**2*r + 99*D1**2*bd1**2*f**2*s - 66*D1**2*bd1**2*f**2 - 66*D1**2*bd1**2*f*r*s + 33*D1**2*bd1**2*f*s - 66*D1**2*bd1*bd2*f*r*s + 33*D1**2*bd1*bd2*f*s + 117*D1**2*bd1*f**3*r*s - 78*D1**2*bd1*f**3*r - 450*D1**2*bd1*f**2*fd*r*s + 175*D1**2*bd1*f**2*fd*r + 75*D1**2*bd1*f**2*fd*s - 50*D1**2*bd1*f**2*fd + 55*D1**2*bd1*f**2*r*s - 132*D1**2*bd1*f*fd*r*s + 33*D1**2*bd1*f*fd*r + 33*D1**2*bd1*f*fd*s - 286*D1**2*bd1*f*g2*r*s + 286*D1**2*bd1*f*g2*s + 132*D1**2*bd1*f*gd2*r*s - 66*D1**2*bd1*f*gd2*s + 132*D1**2*bd1*fd*g2*r*s - 66*D1**2*bd1*fd*g2*r - 66*D1**2*bd1*fd*g2*s + 66*D1**2*bd1*fd*g2 + 55*D1**2*bd2*f**2*r*s - 132*D1**2*bd2*f*fd*r*s + 33*D1**2*bd2*f*fd*r + 33*D1**2*bd2*f*fd*s - 75*D1**2*bdd1*f**3*r*s + 50*D1**2*bdd1*f**3*r - 33*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f*g2*r*s - 66*D1**2*bdd1*f*g2*s - 33*D1**2*bdd2*f**2*r*s - 110*D1**2*f**2*gd2*r*s + 66*D1**2*f**2*gdd2*r*s - 220*D1**2*f*fd*g2*r*s + 110*D1**2*f*fd*g2*r + 110*D1**2*f*fd*g2*s + 264*D1**2*f*fd*gd2*r*s - 66*D1**2*f*fd*gd2*r - 66*D1**2*f*fd*gd2*s + 132*D1**2*f*fdd*g2*r*s - 66*D1**2*f*fdd*g2*r - 66*D1**2*f*fdd*g2*s + 132*D1**2*fd**2*g2*r*s - 66*D1**2*fd**2*g2*r - 66*D1**2*fd**2*g2*s + 66*D1**2*fd**2*g2 - 264*D1*Dd*K*bd1*f**2*r*s + 33*D1*Dd*K*bd1*f**2*r + 33*D1*Dd*K*bd1*f**2*s - 600*D1*Dd*bd1*f**3*r*s + 275*D1*Dd*bd1*f**3*r + 75*D1*Dd*bd1*f**3*s - 50*D1*Dd*bd1*f**3 - 264*D1*Dd*bd1*f**2*r*s + 33*D1*Dd*bd1*f**2*r + 33*D1*Dd*bd1*f**2*s + 528*D1*Dd*bd1*f*g2*r*s - 66*D1*Dd*bd1*f*g2*r - 330*D1*Dd*bd1*f*g2*s + 66*D1*Dd*bd1*f*g2 - 264*D1*Dd*bd2*f**2*r*s + 33*D1*Dd*bd2*f**2*r + 33*D1*Dd*bd2*f**2*s - 440*D1*Dd*f**2*g2*r*s + 110*D1*Dd*f**2*g2*r + 110*D1*Dd*f**2*g2*s + 528*D1*Dd*f**2*gd2*r*s - 66*D1*Dd*f**2*gd2*r - 66*D1*Dd*f**2*gd2*s + 1056*D1*Dd*f*fd*g2*r*s - 396*D1*Dd*f*fd*g2*r - 396*D1*Dd*f*fd*g2*s + 132*D1*Dd*f*fd*g2 + 264*D1*Ddd*f**2*g2*r*s - 66*D1*Ddd*f**2*g2*r - 66*D1*Ddd*f**2*g2*s + 792*Dd**2*f**2*g2*r*s - 198*Dd**2*f**2*g2*r - 198*Dd**2*f**2*g2*s + 66*Dd**2*f**2*g2 - 11*b1**3*(D1*Dd*(13*f*(-4*r*s + r + s) + 3*fd*r*(8*s - 1) - 3*fd*s) + D1*(D1*r*s*(-13*fd + 3*fdd) + 3*Ddd*f*(r*(4*s - 1) - s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 11*b1**2*(D1*Dd*(f*(r*(4*s - 1) - s)*(13*K + 20*f + 13) - 3*fd*(2*f*(32*r*s - 6*r - 6*s + 1) + (K + 1)*(8*r*s - 5*r - s + 1))) + D1*bd1*(D1*(13*f*(3*r*s - r - s) + 3*fd*(-6*r*s + r + s)) - 3*Dd*f*(r*(24*s - 7) - 7*s + 2)) + D1*(3*D1*bdd1*f*(-3*r*s + r + s) + D1*(3*fd**2*(-8*r*s + r + s) + fd*(5*f*r*(8*s - 1) - 5*f*s + r*(13*K + 13)*(s - 1)) + 3*fdd*(f*s + r*(-8*f*s + f - (K + 1)*(s - 1)))) - 3*Ddd*f*(r*(4*s - 1) - s)*(K + 4*f + 1)) - 3*Dd**2*f*(K + 4*f + 1)*(3*r*(4*s - 1) - 3*s + 1)) + b1*(-66*D1**2*K*bdd1*f*r*s + 33*D1**2*K*bdd1*f*s + 110*D1**2*K*f*fd*r*s - 55*D1**2*K*f*fd*r - 55*D1**2*K*f*fd*s - 66*D1**2*K*f*fdd*r*s + 33*D1**2*K*f*fdd*r + 33*D1**2*K*f*fdd*s - 66*D1**2*K*fd**2*r*s + 33*D1**2*K*fd**2*r + 33*D1**2*K*fd**2*s - 33*D1**2*K*fd**2 - 33*D1**2*bd1**2*f*(r*(6*s - 2) - 2*s + 1) + 143*D1**2*bd2*f*r*s - 66*D1**2*bd2*fd*r*s + 33*D1**2*bd2*fd*r - 264*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*r + 99*D1**2*bdd1*f**2*s - 66*D1**2*bdd1*f*r*s + 33*D1**2*bdd1*f*s - 33*D1**2*bdd2*f*r*s + 351*D1**2*f**2*fd*r*s - 39*D1**2*f**2*fd*r - 117*D1**2*f**2*fd*s - 225*D1**2*f**2*fdd*r*s + 25*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s - 450*D1**2*f*fd**2*r*s + 50*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 110*D1**2*f*fd*r*s - 55*D1**2*f*fd*r - 55*D1**2*f*fd*s - 66*D1**2*f*fdd*r*s + 33*D1**2*f*fdd*r + 33*D1**2*f*fdd*s - 286*D1**2*f*gd2*r*s + 66*D1**2*f*gdd2*r*s - 66*D1**2*fd**2*r*s + 33*D1**2*fd**2*r + 33*D1**2*fd**2*s - 33*D1**2*fd**2 - 286*D1**2*fd*g2*r*s + 286*D1**2*fd*g2*r + 132*D1**2*fd*gd2*r*s - 66*D1**2*fd*gd2*r + 66*D1**2*fdd*g2*r*s - 66*D1**2*fdd*g2*r + 220*D1*Dd*K*f**2*r*s - 55*D1*Dd*K*f**2*r - 55*D1*Dd*K*f**2*s - 528*D1*Dd*K*f*fd*r*s + 198*D1*Dd*K*f*fd*r + 198*D1*Dd*K*f*fd*s - 66*D1*Dd*K*f*fd - 264*D1*Dd*bd2*f*r*s + 33*D1*Dd*bd2*f*r + 33*D1*Dd*bd2*f*s + 468*D1*Dd*f**3*r*s - 117*D1*Dd*f**3*r - 117*D1*Dd*f**3*s - 1800*D1*Dd*f**2*fd*r*s + 325*D1*Dd*f**2*fd*r + 525*D1*Dd*f**2*fd*s - 100*D1*Dd*f**2*fd + 220*D1*Dd*f**2*r*s - 55*D1*Dd*f**2*r - 55*D1*Dd*f**2*s - 528*D1*Dd*f*fd*r*s + 198*D1*Dd*f*fd*r + 198*D1*Dd*f*fd*s - 66*D1*Dd*f*fd - 1144*D1*Dd*f*g2*r*s + 286*D1*Dd*f*g2*r + 286*D1*Dd*f*g2*s + 528*D1*Dd*f*gd2*r*s - 66*D1*Dd*f*gd2*r - 66*D1*Dd*f*gd2*s + 528*D1*Dd*fd*g2*r*s - 330*D1*Dd*fd*g2*r - 66*D1*Dd*fd*g2*s + 66*D1*Dd*fd*g2 - 132*D1*Ddd*K*f**2*r*s + 33*D1*Ddd*K*f**2*r + 33*D1*Ddd*K*f**2*s - 300*D1*Ddd*f**3*r*s + 75*D1*Ddd*f**3*r + 75*D1*Ddd*f**3*s - 132*D1*Ddd*f**2*r*s + 33*D1*Ddd*f**2*r + 33*D1*Ddd*f**2*s + 264*D1*Ddd*f*g2*r*s - 66*D1*Ddd*f*g2*r - 66*D1*Ddd*f*g2*s + 11*D1*bd1*(D1*(f*(5*f*(8*r*s - 3*r - 3*s) + s*(13*K + 13)*(2*r - 1)) - 3*fd*(2*f*(4*r - 1)*(4*s - 1) + (K + 1)*(4*r*s - 2*r - s + 1))) - 3*Dd*f*(f*(64*r*s - 20*r - 20*s + 6) + (K + 1)*(16*r*s - 2*r - 6*s + 1))) - 396*Dd**2*K*f**2*r*s + 99*Dd**2*K*f**2*r + 99*Dd**2*K*f**2*s - 33*Dd**2*K*f**2 - 900*Dd**2*f**3*r*s + 225*Dd**2*f**3*r + 225*Dd**2*f**3*s - 75*Dd**2*f**3 - 396*Dd**2*f**2*r*s + 99*Dd**2*f**2*r + 99*Dd**2*f**2*s - 33*Dd**2*f**2 + 792*Dd**2*f*g2*r*s - 198*Dd**2*f*g2*r - 198*Dd**2*f*g2*s + 66*Dd**2*f*g2 - 11*b2*(D1*Dd*(13*f*(-4*r*s + r + s) + 3*fd*(8*r*s - 5*r - s + 1)) + D1*(-D1*r*(13*fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - r - s)) + 3*Dd**2*f*(3*r*(4*s - 1) - 3*s + 1))) + 11*b2*(D1*Dd*f*(5*f*(4*r*s - r - s) - 6*fd*(8*r*s - 3*r - 3*s + 1)) + D1*bd1*(D1*(13*f*s*(r - 1) + 3*fd*(-2*r*s + r + s - 1)) - 3*Dd*f*(r*(8*s - 1) - 5*s + 1)) + D1*(D1*(-3*bdd1*f*s*(r - 1) + 5*f*fd*r*(2*s - 1) - 5*f*fd*s + 3*f*fdd*(-2*r*s + r + s) + 3*fd**2*(-2*r*s + r + s - 1)) + 3*Ddd*f**2*(-4*r*s + r + s)) - 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2) + 2*D1**2*Pkd1*Pkd2*ct*(D1*(D1*bd1**2*(-f*r*(2*s - 1)*(6*K + 5*f + 6) + 14*g2*(2*r*s - r - s + 1)) + 12*D1*bdd1*f*g2*r*(s - 1) + b2*(-7*D1*bd1**2*(r*(2*s - 1) - s + 1) - 6*D1*bdd1*f*r*(s - 1) + bd1*(D1*(5*f*r*(s - 1) + 6*fd*(-2*r*s + r + s - 1)) - 6*Dd*f*(r*(8*s - 5) - s + 1))) + 2*bd1*(D1*(f*r*(-6*bd2*s + 3*bd2 - 5*g2*s + 5*g2 + 12*gd2*s - 6*gd2) + 6*fd*g2*(2*r*s - r - s + 1)) + 6*Dd*f*g2*(r*(8*s - 5) - s + 1))) + b1**3*(D1*Dd*(5*f*r*(4*s - 1) - 5*f*s + fd*r*(6 - 48*s) + 6*fd*s + r*(14*K + 14)*(4*s - 1) - s*(14*K + 14)) + D1*(D1*r*s*(5*fd - 6*fdd) - Ddd*(r*(4*s - 1) - s)*(7*K + 6*f + 7)) - Dd**2*(7*K + 6*f + 7)*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(-21*D1**2*K*bdd1*r*s + 7*D1**2*K*bdd1*r + 7*D1**2*K*bdd1*s + 5*D1**2*K*fd*r*s - 5*D1**2*K*fd*s - 6*D1**2*K*fdd*r*s + 6*D1**2*K*fdd*s + 14*D1**2*bd2*r*s - 18*D1**2*bdd1*f*r*s + 6*D1**2*bdd1*f*r + 6*D1**2*bdd1*f*s - 21*D1**2*bdd1*r*s + 7*D1**2*bdd1*r + 7*D1**2*bdd1*s - 7*D1**2*bdd2*r*s + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*s - 10*D1**2*f*fdd*r*s + 5*D1**2*f*fdd*s - 10*D1**2*fd**2*r*s + 5*D1**2*fd**2*s + 5*D1**2*fd*r*s - 5*D1**2*fd*s - 6*D1**2*fdd*r*s + 6*D1**2*fdd*s - 28*D1**2*gd2*r*s + 14*D1**2*gdd2*r*s + 20*D1*Dd*K*f*r*s - 5*D1*Dd*K*f*r - 5*D1*Dd*K*f*s - 48*D1*Dd*K*fd*r*s + 6*D1*Dd*K*fd*r + 30*D1*Dd*K*fd*s - 6*D1*Dd*K*fd - 56*D1*Dd*bd2*r*s + 7*D1*Dd*bd2*r + 7*D1*Dd*bd2*s + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r - 4*D1*Dd*f**2*s - 80*D1*Dd*f*fd*r*s + 10*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 5*D1*Dd*f*fd + 20*D1*Dd*f*r*s - 5*D1*Dd*f*r - 5*D1*Dd*f*s - 48*D1*Dd*fd*r*s + 6*D1*Dd*fd*r + 30*D1*Dd*fd*s - 6*D1*Dd*fd - 112*D1*Dd*g2*r*s + 28*D1*Dd*g2*r + 28*D1*Dd*g2*s + 112*D1*Dd*gd2*r*s - 14*D1*Dd*gd2*r - 14*D1*Dd*gd2*s - 24*D1*Ddd*K*f*r*s + 6*D1*Ddd*K*f*r + 6*D1*Ddd*K*f*s - 20*D1*Ddd*f**2*r*s + 5*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 24*D1*Ddd*f*r*s + 6*D1*Ddd*f*r + 6*D1*Ddd*f*s + 56*D1*Ddd*g2*r*s - 14*D1*Ddd*g2*r - 14*D1*Ddd*g2*s + D1*bd1*(D1*(5*f*r*(3*s - 1) - 5*f*s + fd*r*(6 - 36*s) + 6*fd*s + r*(14*K + 14)*(3*s - 1) - s*(14*K + 14)) - Dd*(7*K + 6*f + 7)*(r*(24*s - 7) - 7*s + 2)) - 72*Dd**2*K*f*r*s + 18*Dd**2*K*f*r + 18*Dd**2*K*f*s - 6*Dd**2*K*f - 60*Dd**2*f**2*r*s + 15*Dd**2*f**2*r + 15*Dd**2*f**2*s - 5*Dd**2*f**2 - 72*Dd**2*f*r*s + 18*Dd**2*f*r + 18*Dd**2*f*s - 6*Dd**2*f + 168*Dd**2*g2*r*s - 42*Dd**2*g2*r - 42*Dd**2*g2*s + 14*Dd**2*g2 - 7*b2*(2*D1*Dd*(-4*r*s + r + s) + D1*Ddd*(r*(4*s - 1) - s) + Dd**2*(3*r*(4*s - 1) - 3*s + 1))) + b1*(-12*D1**2*K*bdd1*f*r*s + 6*D1**2*K*bdd1*f*r - 14*D1**2*b2*bdd1*r*s + 7*D1**2*b2*bdd1*r + 7*D1**2*b2*bdd1*s + 5*D1**2*b2*fd*r*s - 5*D1**2*b2*fd*s - 6*D1**2*b2*fdd*r*s + 6*D1**2*b2*fdd*s - D1**2*bd1**2*(7*K + 6*f + 7)*(r*(6*s - 2) - 2*s + 1) + 5*D1**2*bd2*f*r*s - 12*D1**2*bd2*fd*r*s + 6*D1**2*bd2*fd*s - 10*D1**2*bdd1*f**2*r*s + 5*D1**2*bdd1*f**2*r - 12*D1**2*bdd1*f*r*s + 6*D1**2*bdd1*f*r + 28*D1**2*bdd1*g2*r*s - 14*D1**2*bdd1*g2*r - 14*D1**2*bdd1*g2*s - 6*D1**2*bdd2*f*r*s - 10*D1**2*f*gd2*r*s + 12*D1**2*f*gdd2*r*s - 10*D1**2*fd*g2*r*s + 10*D1**2*fd*g2*s + 24*D1**2*fd*gd2*r*s - 12*D1**2*fd*gd2*s + 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s + 20*D1*Dd*b2*f*r*s - 5*D1*Dd*b2*f*r - 5*D1*Dd*b2*f*s - 48*D1*Dd*b2*fd*r*s + 6*D1*Dd*b2*fd*r + 30*D1*Dd*b2*fd*s - 6*D1*Dd*b2*fd - 48*D1*Dd*bd2*f*r*s + 6*D1*Dd*bd2*f*r + 6*D1*Dd*bd2*f*s - 40*D1*Dd*f*g2*r*s + 10*D1*Dd*f*g2*r + 10*D1*Dd*f*g2*s + 96*D1*Dd*f*gd2*r*s - 12*D1*Dd*f*gd2*r - 12*D1*Dd*f*gd2*s + 96*D1*Dd*fd*g2*r*s - 12*D1*Dd*fd*g2*r - 60*D1*Dd*fd*g2*s + 12*D1*Dd*fd*g2 - 24*D1*Ddd*b2*f*r*s + 6*D1*Ddd*b2*f*r + 6*D1*Ddd*b2*f*s + 48*D1*Ddd*f*g2*r*s - 12*D1*Ddd*f*g2*r - 12*D1*Ddd*f*g2*s + D1*bd1*(D1*(10*K*f*r*s - 5*K*f*r + 7*bd2*(-4*r*s + r + s) + 8*f**2*r*s - 4*f**2*r - 5*f*fd*(r*(8*s - 2) - 2*s + 1) + 10*f*r*s - 5*f*r - 6*fd*(K + 1)*(r*(4*s - 1) - 2*s + 1) - 56*g2*r*s + 28*g2*r + 28*g2*s + 56*gd2*r*s - 14*gd2*r - 14*gd2*s) + Dd*(-5*f**2*(2*r*(8*s - 3) - 2*s + 1) - 6*f*(K + 1)*(2*r*(8*s - 3) - 2*s + 1) + 28*g2*(r*(8*s - 3) - 3*s + 1)) - 14*b2*(D1*(-2*r*s + r + s) + Dd*r*(8*s - 3) - 3*Dd*s + Dd)) - 72*Dd**2*b2*f*r*s + 18*Dd**2*b2*f*r + 18*Dd**2*b2*f*s - 6*Dd**2*b2*f + 144*Dd**2*f*g2*r*s - 36*Dd**2*f*g2*r - 36*Dd**2*f*g2*s + 12*Dd**2*f*g2))/(21*d**2) + 2*D1**2*Pkd1*Pkd2*f*k1*st**4*(13*D1*bd1*f*(D1*(2*f*s*(2*r - 1) + fd*(-12*r*s + 2*r + 4*s - 1)) - Dd*f*(2*r*(8*s - 1) - 6*s + 1)) - 13*b1*(D1*Dd*f*(4*f*(-4*r*s + r + s) + fd*(48*r*s - 14*r - 10*s + 3)) + D1*(D1*(2*f*fd*(-6*r*s + 2*r + s) + f*fdd*(6*r*s - 2*r - s) + fd**2*(12*r*s - 4*r - 2*s + 1)) + 2*Ddd*f**2*(r*(4*s - 1) - s)) + 2*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(20*D1*Dd*f*(f*r*(4*s - 1) - f*s - fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(20*f*fd*(r*(4*s - 1) - s) + f*(13*bdd1*s*(1 - 2*r) + 10*fdd*(-4*r*s + r + s)) - 10*fd**2*(3*r*(4*s - 1) - 3*s + 1)) + 10*Ddd*f**2*(-4*r*s + r + s)) - 10*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(3003*d**2*k2) - 5*D1**2*Pkd1*Pkd2*f*k2*st**6*(13*D1*bd1*f*(2*D1*f*s*(r - 1) + D1*fd*(-6*r*s + r + 3*s - 1) + Dd*f*(-8*r*s + r + 5*s - 1)) - 13*b1*(D1*Dd*f*(2*f*(-4*r*s + r + s) + fd*r*(24*s - 7) - 3*fd*s + fd) - D1*(D1*r*(3*s - 1)*(2*f*fd - f*fdd - 2*fd**2) + Ddd*f**2*(-4*r*s + r + s)) + Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + f*(-6*D1*Dd*f*(f*r*(4*s - 1) - f*s - fd*(4*r - 1)*(4*s - 1)) + D1*(D1*(6*f*fd*(-4*r*s + r + s) + f*(-13*bdd1*s*(r - 1) + 3*fdd*r*(4*s - 1) - 3*fdd*s) + fd**2*(9*r*(4*s - 1) - 9*s + 3)) + 3*Ddd*f**2*(r*(4*s - 1) - s)) + 3*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(9009*d**2*k1) + 2*D1**2*Pkd1*Pkd2*f*k2*st**4*(D1**2*bdd1*f**2*r*(1 - 2*s) + D1*bd1*f*(D1*(2*f*r*(2*s - 1) + fd*(-12*r*s + 4*r + 2*s - 1)) - Dd*f*(2*r*(8*s - 3) - 2*s + 1)) + b1*(D1*Dd*f*(4*f*(4*r*s - r - s) + fd*(-48*r*s + 10*r + 14*s - 3)) + D1*(D1*(2*f*fd*(6*r*s - r - 2*s) + f*fdd*(-6*r*s + r + 2*s) + fd**2*(-12*r*s + 2*r + 4*s - 1)) + 2*Ddd*f**2*(-4*r*s + r + s)) - 2*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(231*d**2*k1) + D1**2*Pkd1*Pkd2*k1*st**2*(D1*f**2*(-33*D1*bd1**2*(r*(4*s - 2) - s + 1) - 25*D1*bdd1*f*r*(s - 1) - 25*bd1*(D1*(-2*f*r*(s - 1) + fd*r*(6*s - 3) - fd*s + fd) + Dd*f*(r*(8*s - 5) - s + 1))) - 33*b1**3*(-D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) - D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) + Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + 33*b1**2*(D1*Dd*f*(4*f*r*(4*s - 1) - 4*f*s - fd*(4*r - 1)*(8*s - 1)) + D1*bd1*(D1*(f*r*(6*s - 2) - 2*f*s + fd*(-6*r*s + r + s)) + Dd*f*(r*(7 - 24*s) + 7*s - 2)) + D1*(D1*bdd1*f*(-3*r*s + r + s) + D1*s*(4*r - 1)*(2*f*fd - f*fdd - fd**2) + 2*Ddd*f**2*(-4*r*s + r + s)) - 2*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)) + b1*f*(-33*D1**2*bd1**2*(r*(6*s - 2) - 2*s + 1) + 25*D1*Dd*f*(2*f*(4*r*s - r - s) + fd*(-24*r*s + 3*r + 7*s - 1)) + 33*D1*bd1*(-D1*(2*f*(-4*r*s + 2*r + s) + fd*(4*r - 1)*(4*s - 1)) - Dd*f*(4*r - 1)*(8*s - 3)) + D1*(-33*D1*bdd1*f*(r*(4*s - 2) - s) + 25*D1*s*(3*r - 1)*(2*f*fd - f*fdd - 2*fd**2) + 25*Ddd*f**2*(-4*r*s + r + s)) - 25*Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(693*d**2*k2) + D1**2*Pkd1*Pkd2*k2*st**2*(D1**2*bd1**2*f**2*r*(1 - 2*s) - D1*b1*f*(D1*bd1**2*(r*(6*s - 2) - 2*s + 1) + D1*bdd1*f*r*(2*s - 1) + bd1*(D1*(2*f*r*(1 - 2*s) + fd*r*(8*s - 2) - 2*fd*s + fd) + Dd*f*(2*r*(8*s - 3) - 2*s + 1))) + b1**3*(D1*Dd*(f*r*(8*s - 2) - 2*f*s + fd*(-8*r*s + r + s)) + D1*(D1*r*s*(2*fd - fdd) + Ddd*f*(-4*r*s + r + s)) - Dd**2*f*(3*r*(4*s - 1) - 3*s + 1)) + b1**2*(D1*Dd*f*(2*f*(r*(4*s - 1) - s) + fd*(r*(2 - 16*s) + 6*s - 1)) + D1*bd1*(D1*(f*r*(6*s - 2) - 2*f*s + fd*(-6*r*s + r + s)) + Dd*f*(r*(7 - 24*s) + 7*s - 2)) + D1*(D1*bdd1*f*(-3*r*s + r + s) + D1*s*(2*r - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + s)) - Dd**2*f**2*(3*r*(4*s - 1) - 3*s + 1)))/(21*d**2*k1)
        perm13 = 40*D1**3*Pk1*Pk3*ct**5*f**2*k2**7*(33*D1*bd1*f*(r + s - 1)**2 + 33*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 28*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(231*d**2*k1*k3**8) - 8*D1**3*Pk1*Pk3*ct**4*k2**6*(11*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7 - 7*K)*(r + s)**2) + Dd*f*(-7*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 22*b1*(D1*bd1*f*(-7*K + 6*f + 7)*(r + s - 1)**2 + D1*(-5*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-3*fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*gd2*(r + s - 1)**2) + 7*fd*g2*(r + s)**2) - Dd*f*(5*f**2 + 3*f*(K - 1) - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 2*f*(11*D1*bd1*(5*f**2 + 3*f*(K - 1) - 7*g2)*(r + s - 1)**2 + 2*D1*(35*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 33*f*gd2*(r + s - 1)**2 - 33*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*Dd*f*(35*f**2 - 33*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(77*d**2*k3**8) + 40*D1**3*Pk1*Pk3*ct**3*f**2*k2**7*st**2*(33*D1*bd1*f*(r + s - 1)**2 + 33*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 25*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(231*d**2*k1*k3**8) - 8*D1**3*Pk1*Pk3*ct**3*k1*k2**5*(22*D1*bd1*f*(f*(9 - 12*K) + 28*g2)*(r + s - 1)**2 + 11*b1**2*(D1*fd*(18*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (21 - 28*K)*(r + s)**2) + Dd*f*(-28*K + 18*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 22*b1*(D1*bd1*f*(-28*K + 18*f + 21)*(r + s - 1)**2 + D1*(-3*f*fd*(4*K - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*f*gd2*(r + s - 1)**2 + 28*fd*g2*(r + s)**2) - Dd*f*(3*f*(4*K - 3) - 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 4*f*(D1*(35*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 132*f*gd2*(r + s - 1)**2 - 132*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(35*f**2 - 132*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(77*d**2*k3**8) + 8*D1**3*Pk1*Pk3*ct**3*k2**5*(b1**2*(D1*fd*(6*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s)*(-14*K*r + 21*r + 7*s)) + Dd*f*(-7*K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 12*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 84*r**2 + 112*r*s - 98*r + 28*s**2 - 56*s + 35)) + b1*(2*D1*bd1*f*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s - 1)*(-14*K*r + 7*K + 21*r + 7*s - 14)) + D1*(5*f**2*fd*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - 6*f*fd*(K*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 6*r**2 - 8*r*s + 6*r - 2*s**2 + 4*s - 3) + 28*f*gd2*r*(r + s - 1) + 28*fd*g2*r*(r + s)) + 2*Dd*f*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*f*(K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 12*r**2 - 16*r*s + 14*r - 4*s**2 + 8*s - 5) + 14*g2*(4*r**2 + 4*r*(s - 1) - s + 1))) + f*(D1*bd1*(5*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*f*(r + s - 1)*(r*(2*K - 3) - s + 1) + 28*g2*(r - 1)*(r + s - 1)) + 24*D1*(f*gd2*r*(r + s - 1) + fd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 24*Dd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)))/(21*d**2*k1*k3**6) - 8*D1**3*Pk1*Pk3*ct**2*k1**2*k2**4*(99*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7 - 14*K)*(r + s)**2) + Dd*f*(-14*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 66*b1*(3*D1*bd1*f*(-14*K + 6*f + 7)*(r + s - 1)**2 + D1*(5*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*f*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 42*f*gd2*(r + s - 1)**2 + 42*fd*g2*(r + s)**2) + Dd*f*(5*f**2 + f*(9 - 18*K) + 42*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*f*(33*D1*bd1*(5*f**2 + f*(9 - 18*K) + 42*g2)*(r + s - 1)**2 + 2*D1*(-35*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 594*f*gd2*(r + s - 1)**2 + 594*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd*f*(35*f**2 - 594*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(231*d**2*k3**8) - 4*D1**3*Pk1*Pk3*ct**2*k2**6*st**2*(11*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7*K - 7)*(r + s)**2) + Dd*f*(7*K + 6*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 11*b1*(2*D1*bd1*f*(7*K + 6*f - 7)*(r + s - 1)**2 - D1*(12*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*gd2*(r + s - 1)**2) + 14*fd*g2*(r + s)**2) - Dd*f*(12*f**2 + f*(K - 1) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - f*(11*D1*bd1*(12*f**2 + f*(K - 1) + 14*g2)*(r + s - 1)**2 + 2*D1*(75*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 11*f*gd2*(r + s - 1)**2 - 11*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*Dd*f*(75*f**2 - 11*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(77*d**2*k3**8) - 8*D1**3*Pk1*Pk3*ct**2*k2**4*(7*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1**2*(7*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*D1*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*D1*fd*(-K*(6*r**2 + 6*r*s + 2*r + 2*s - 1) + 6*r**2 + 7*r*s + 2*r + s**2 + 2*s - 1) - 12*Dd*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 7*Dd*f*(6*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 24*r**2 - 28*r*s + 26*r - 4*s**2 + 11*s - 8)) - b1*(-84*D1*K*f*fd*r**2 - 96*D1*K*f*fd*r*s + 84*D1*K*f*fd*r - 12*D1*K*f*fd*s**2 + 48*D1*K*f*fd*s - 42*D1*K*f*fd - 7*D1*b2*fd*r**2 - 14*D1*b2*fd*r*s - 7*D1*b2*fd*s**2 + D1*bd1*f*(-7*K*(12*r**2 + 4*r*(3*s - 5) - 8*s + 7) + 24*f*(r + s - 1)**2 + 84*r**2 + 98*r*s - 147*r + 14*s**2 - 77*s + 56) - 7*D1*bd2*f*(r + s - 1)**2 + 45*D1*f**2*fd*r**2 + 90*D1*f**2*fd*r*s - 70*D1*f**2*fd*r + 45*D1*f**2*fd*s**2 - 70*D1*f**2*fd*s + 35*D1*f**2*fd + 84*D1*f*fd*r**2 + 108*D1*f*fd*r*s - 84*D1*f*fd*r + 24*D1*f*fd*s**2 - 54*D1*f*fd*s + 42*D1*f*fd + 84*D1*f*gd2*r**2 + 84*D1*f*gd2*r*s - 84*D1*f*gd2*r + 84*D1*fd*g2*r**2 + 84*D1*fd*g2*r*s + 28*D1*fd*g2*r + 28*D1*fd*g2*s - 14*D1*fd*g2 - 168*Dd*K*f**2*r**2 - 192*Dd*K*f**2*r*s + 180*Dd*K*f**2*r - 24*Dd*K*f**2*s**2 + 72*Dd*K*f**2*s - 54*Dd*K*f**2 - 28*Dd*b2*f*r**2 - 56*Dd*b2*f*r*s + 42*Dd*b2*f*r - 28*Dd*b2*f*s**2 + 42*Dd*b2*f*s - 21*Dd*b2*f + 60*Dd*f**3*r**2 + 120*Dd*f**3*r*s - 90*Dd*f**3*r + 60*Dd*f**3*s**2 - 90*Dd*f**3*s + 45*Dd*f**3 + 168*Dd*f**2*r**2 + 216*Dd*f**2*r*s - 192*Dd*f**2*r + 48*Dd*f**2*s**2 - 102*Dd*f**2*s + 66*Dd*f**2 + 336*Dd*f*g2*r**2 + 336*Dd*f*g2*r*s - 336*Dd*f*g2*r - 84*Dd*f*g2*s + 84*Dd*f*g2) + f*(-D1*bd1*(5*f**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*f*(r + s - 1)*(K*(7*r + s - 1) - 7*r - 2*s + 2) + 14*g2*(6*r**2 + 2*r*(3*s - 7) - 8*s + 7)) + 6*D1*bd2*f*(r + s - 1)**2 - 12*D1*(f*gd2*(7*r**2 + 8*r*(s - 1) + (s - 1)**2) + fd*g2*(14*r**2 + 2*r*(8*s - 7) + 2*s**2 - 8*s + 7)) - 12*Dd*f*g2*(28*r**2 + r*(32*s - 30) + (3 - 2*s)**2) + b2*(7*D1*bd1*(r + s - 1)**2 + 6*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(21*d**2*k3**6) + 2*D1**3*Pk1*Pk3*ct**2*k2**4*(7*b1**2*(D1*fd*r*(r*(K - 3) - 2*s) + Dd*f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3)) + b1*(7*D1*bd1*f*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 8*r + 2*s - 3) + 2*D1*(3*f*fd*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 6*r + 2*s - 3) - 7*f*gd2*r**2 - 7*fd*g2*r**2) + 2*Dd*f*(3*f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3) - 7*g2*(4*r**2 - 2*r + 1))) + 2*f*(D1*bd1*(3*f*r*(r*(K - 3) - 2*s + 2) - 7*g2*(r - 1)**2) - 6*D1*f*gd2*r**2 - 6*D1*fd*g2*(2*r**2 - 2*r + 1) - 6*Dd*f*g2*(4*r**2 - 2*r + 1)))/(21*d**2*k1**2*k3**4) - 4*D1**3*Pk1*Pk3*ct**2*st**2*(D1*bd1*f**2*r*s + 7*b1**2*(D1*fd*r*(s - 1) + Dd*f*(4*r*s - 2*r - s)) + b1*f*(7*D1*bd1*s*(2*r - 1) + D1*fd*(r*(2*s - 1) - s) + Dd*f*r*(4*s - 2) - Dd*f*s))/(21*d**2*k1**2) + 40*D1**3*Pk1*Pk3*ct*f**3*k2**7*st**4*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)/(77*d**2*k1*k3**8) - 8*D1**3*Pk1*Pk3*ct*k1**3*k2**3*(b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7 - 28*K)*(r + s)**2) + Dd*f*(-28*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(2*D1*bd1*f*(-28*K + 6*f + 7)*(r + s - 1)**2 + D1*(5*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*f*fd*(4*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 56*f*gd2*(r + s - 1)**2 + 56*fd*g2*(r + s)**2) + Dd*f*(5*f**2 + f*(6 - 24*K) + 56*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*bd1*(5*f**2 + f*(6 - 24*K) + 56*g2)*(r + s - 1)**2 + 48*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 48*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**8) - 4*D1**3*Pk1*Pk3*ct*k1*k2**5*st**2*(11*b1**2*(D1*fd*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (14*K - 7)*(r + s)**2) + Dd*f*(14*K + 9*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 11*b1*(2*D1*bd1*f*(14*K + 9*f - 7)*(r + s - 1)**2 - D1*(f*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*f*gd2*(r + s - 1)**2 + 28*fd*g2*(r + s)**2) - Dd*f*(f*(2*K - 1) + 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(-11*D1*bd1*(f*(2*K - 1) + 28*g2)*(r + s - 1)**2 + D1*(-75*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 44*f*gd2*(r + s - 1)**2 + 44*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(75*f**2 - 44*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(77*d**2*k3**8) - 8*D1**3*Pk1*Pk3*ct*k1*k2**3*(7*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1**2*(7*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(7*K*(6*r**2 + 6*r*s + 4*r + 4*s - 2) - 6*f*(2*r + 2*s - 1) - 28*r**2 - 28*r*s - 14*r - 14*s + 7) + 14*Dd*f*(3*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*(96*D1*K*f*fd*r**2 + 120*D1*K*f*fd*r*s - 96*D1*K*f*fd*r + 24*D1*K*f*fd*s**2 - 60*D1*K*f*fd*s + 48*D1*K*f*fd + 14*D1*b2*fd*r**2 + 28*D1*b2*fd*r*s + 14*D1*b2*fd*s**2 + D1*bd1*f*(14*K*(6*r**2 + 6*r*s - 11*r - 5*s + 4) + 6*f*(2*r + 2*s - 1) - 56*r**2 - 56*r*s + 98*r + 42*s - 35) + 14*D1*bd2*f*(r + s - 1)**2 - 15*D1*f**2*fd*r**2 - 30*D1*f**2*fd*r*s + 20*D1*f**2*fd*r - 15*D1*f**2*fd*s**2 + 20*D1*f**2*fd*s - 10*D1*f**2*fd - 60*D1*f*fd*r**2 - 72*D1*f*fd*r*s + 60*D1*f*fd*r - 12*D1*f*fd*s**2 + 36*D1*f*fd*s - 30*D1*f*fd - 84*D1*f*gd2*r**2 - 84*D1*f*gd2*r*s + 84*D1*f*gd2*r - 84*D1*fd*g2*r**2 - 84*D1*fd*g2*r*s - 56*D1*fd*g2*r - 56*D1*fd*g2*s + 28*D1*fd*g2 + 192*Dd*K*f**2*r**2 + 240*Dd*K*f**2*r*s - 216*Dd*K*f**2*r + 48*Dd*K*f**2*s**2 - 108*Dd*K*f**2*s + 72*Dd*K*f**2 + 56*Dd*b2*f*r**2 + 112*Dd*b2*f*r*s - 84*Dd*b2*f*r + 56*Dd*b2*f*s**2 - 84*Dd*b2*f*s + 42*Dd*b2*f - 20*Dd*f**3*r**2 - 40*Dd*f**3*r*s + 30*Dd*f**3*r - 20*Dd*f**3*s**2 + 30*Dd*f**3*s - 15*Dd*f**3 - 120*Dd*f**2*r**2 - 144*Dd*f**2*r*s + 132*Dd*f**2*r - 24*Dd*f**2*s**2 + 60*Dd*f**2*s - 42*Dd*f**2 - 336*Dd*f*g2*r**2 - 336*Dd*f*g2*r*s + 336*Dd*f*g2*r + 84*Dd*f*g2*s - 84*Dd*f*g2) + f*(-D1*bd1*(5*f**2*(r + s - 1)**2 - 6*f*(r + s - 1)*(2*K*(4*r + s - 1) - 5*r - s + 1) + 28*g2*(3*r**2 + r*(3*s - 8) - 5*s + 4)) + 12*D1*bd2*f*(r + s - 1)**2 - 24*D1*(f*gd2*(4*r**2 + 5*r*(s - 1) + (s - 1)**2) + fd*g2*(8*r**2 + 2*r*(5*s - 4) + 2*s**2 - 5*s + 4)) - 24*Dd*f*g2*(16*r**2 + 2*r*(10*s - 9) + 4*s**2 - 9*s + 6) + 2*b2*(7*D1*bd1*(r + s - 1)**2 + 6*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(21*d**2*k3**6) + 4*D1**3*Pk1*Pk3*ct*k2**5*st**2*(b1**2*(D1*fd*(3*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s)*(14*K*r - 21*r - 7*s)) + Dd*f*(7*K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 84*r**2 - 112*r*s + 98*r - 28*s**2 + 56*s - 35)) + b1*(D1*bd1*f*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (r + s - 1)*(14*K*(2*r - 1) - 42*r - 14*s + 28)) + D1*(3*f**2*fd*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + f*(fd*(K*(-4*r**2 - 4*r*s + 4*r + 2*s - 2) + 6*r**2 + 8*r*s - 6*r + 2*s**2 - 4*s + 3) - 28*gd2*r*(r + s - 1)) - 28*fd*g2*r*(r + s)) + Dd*f*(6*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(K*(-8*r**2 - 8*r*s + 8*r + 2*s - 2) + 12*r**2 + 2*r*(8*s - 7) + 4*s**2 - 8*s + 5) - 28*g2*(4*r**2 + 4*r*(s - 1) - s + 1))) + f*(D1*bd1*(3*f**2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - f*(r + s - 1)*(2*K*r - 3*r - s + 1) - 28*g2*(r - 1)*(r + s - 1)) + 4*D1*(f*gd2*r*(r + s - 1) + fd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 4*Dd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)))/(21*d**2*k1*k3**6) - 4*D1**3*Pk1*Pk3*ct*k2**3*(7*b1**2*(D1*fd*(K*(r**2 + 2*r*(s - 2) - 2*s + 2) + r**2 + 4*r + 2*s - 2) + Dd*f*(K*(4*r**2 + 8*r*s - 6*r - 2*s + 1) + 4*r**2 - 2*r + 1)) + b1*(7*D1*bd1*f*(K*(2*r**2 + 4*r*s - 1) + 2*r**2 - 6*r - 2*s + 3) - 2*D1*(f*(3*fd*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 6*r + 2*s - 3) + 7*gd2*r*(r + 2*s - 2)) + 7*fd*g2*(r**2 + 2*r*(s - 2) - 2*s + 2)) - 2*Dd*f*(3*f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3) + 7*g2*(4*r**2 + 8*r*s - 6*r - 2*s + 1))) - 2*f*(D1*bd1*(3*f*r*(r*(K - 3) - 2*s + 2) + 7*g2*(r**2 + 2*r*(s + 1) - 1)) - 6*D1*f*gd2*r**2 - 6*D1*fd*g2*(2*r**2 - 2*r + 1) - 6*Dd*f*g2*(4*r**2 - 2*r + 1)))/(21*d**2*k1*k3**4) + 24*D1**3*Pk1*Pk3*f*k2**6*st**4*(22*D1*b1*bd1*f*(r + s - 1)**2 + 11*b1**2*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f**2*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(77*d**2*k3**8) + 8*D1**3*Pk1*Pk3*k1**4*k2**2*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + 3*K*f - 7*g2) + 7*K*b1**2*(D1*fd*(r + s)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*b1*(-D1*(-3*K*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*f*gd2*(r + s - 1)**2 + 7*fd*g2*(r + s)**2) + Dd*f*(3*K*f - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*f*(D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**8) - 4*D1**3*Pk1*Pk3*k1**2*k2**4*st**2*(33*b1**2*(D1*fd*(7*K*(r + s)**2 + 3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(7*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 33*b1*(2*D1*bd1*f*(7*K + 3*f)*(r + s - 1)**2 + D1*(2*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - f*(K*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 14*gd2*(r + s - 1)**2) - 14*fd*g2*(r + s)**2) + Dd*f*(-K*f + 2*f**2 - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(33*D1*bd1*(r + s - 1)**2*(-K*f + 2*f**2 - 14*g2) + D1*(-25*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*f*gd2*(r + s - 1)**2 + 66*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(25*f**2 - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(231*d**2*k3**8) - 8*D1**3*Pk1*Pk3*k1**2*k2**2*(7*b1**2*(D1*fd*(K*(2*r**2 + 2*r*(s + 1) + 2*s - 1) - r*(r + s)) + Dd*f*(2*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*(36*D1*K*f*fd*r**2 + 48*D1*K*f*fd*r*s - 36*D1*K*f*fd*r + 12*D1*K*f*fd*s**2 - 24*D1*K*f*fd*s + 18*D1*K*f*fd + 7*D1*b2*fd*r**2 + 14*D1*b2*fd*r*s + 7*D1*b2*fd*s**2 + 7*D1*bd1*f*(K*(4*r**2 + 4*r*(s - 2) - 4*s + 3) - (2*r - 1)*(r + s - 1)) + 7*D1*bd2*f*(r + s - 1)**2 - 12*D1*f*fd*r**2 - 12*D1*f*fd*r*s + 12*D1*f*fd*r + 6*D1*f*fd*s - 6*D1*f*fd - 28*D1*f*gd2*r**2 - 28*D1*f*gd2*r*s + 28*D1*f*gd2*r - 28*D1*fd*g2*r**2 - 28*D1*fd*g2*r*s - 28*D1*fd*g2*r - 28*D1*fd*g2*s + 14*D1*fd*g2 + 72*Dd*K*f**2*r**2 + 96*Dd*K*f**2*r*s - 84*Dd*K*f**2*r + 24*Dd*K*f**2*s**2 - 48*Dd*K*f**2*s + 30*Dd*K*f**2 + 28*Dd*b2*f*r**2 + 56*Dd*b2*f*r*s - 42*Dd*b2*f*r + 28*Dd*b2*f*s**2 - 42*Dd*b2*f*s + 21*Dd*b2*f - 24*Dd*f**2*r**2 - 24*Dd*f**2*r*s + 24*Dd*f**2*r + 6*Dd*f**2*s - 6*Dd*f**2 - 112*Dd*f*g2*r**2 - 112*Dd*f*g2*r*s + 112*Dd*f*g2*r + 28*Dd*f*g2*s - 28*Dd*f*g2) + f*(7*D1*b2*bd1*(r + s - 1)**2 + 6*D1*b2*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*D1*bd1*(3*f*(K*(3*r + s - 1) - r)*(r + s - 1) - 7*g2*(2*r**2 + 2*r*(s - 3) - 4*s + 3)) + 6*D1*bd2*f*(r + s - 1)**2 - 12*D1*(f*gd2*(3*r**2 + 4*r*(s - 1) + (s - 1)**2) + fd*g2*(6*r**2 + r*(8*s - 6) + 2*s**2 - 4*s + 3)) + 6*Dd*b2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*Dd*f*g2*(12*r**2 + 2*r*(8*s - 7) + 4*s**2 - 8*s + 5)))/(21*d**2*k3**6) + 4*D1**3*Pk1*Pk3*k2**4*st**2*(7*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1**2*(7*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(f*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) + (7*r + 7*s)*(3*K*r + K*s - r)) + Dd*f*(7*K*(12*r**2 + 2*r*(8*s - 7) + 4*s**2 - 8*s + 5) + 2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 28*r**2 - 28*r*s + 28*r + 7*s - 7)) + b1*(-6*D1*K*f*fd*r**2 - 8*D1*K*f*fd*r*s + 6*D1*K*f*fd*r - 2*D1*K*f*fd*s**2 + 4*D1*K*f*fd*s - 3*D1*K*f*fd + 7*D1*b2*fd*r**2 + 14*D1*b2*fd*r*s + 7*D1*b2*fd*s**2 + D1*bd1*f*(r + s - 1)*(14*K*(3*r + s - 2) + 4*f*(r + s - 1) - 14*r + 7) + 7*D1*bd2*f*(r + s - 1)**2 + 9*D1*f**2*fd*r**2 + 18*D1*f**2*fd*r*s - 14*D1*f**2*fd*r + 9*D1*f**2*fd*s**2 - 14*D1*f**2*fd*s + 7*D1*f**2*fd + 2*D1*f*fd*r**2 + 2*D1*f*fd*r*s - 2*D1*f*fd*r - D1*f*fd*s + D1*f*fd - 42*D1*f*gd2*r**2 - 56*D1*f*gd2*r*s + 56*D1*f*gd2*r - 14*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 14*D1*f*gd2 - 42*D1*fd*g2*r**2 - 56*D1*fd*g2*r*s - 14*D1*fd*g2*s**2 - 12*Dd*K*f**2*r**2 - 16*Dd*K*f**2*r*s + 14*Dd*K*f**2*r - 4*Dd*K*f**2*s**2 + 8*Dd*K*f**2*s - 5*Dd*K*f**2 + 28*Dd*b2*f*r**2 + 56*Dd*b2*f*r*s - 42*Dd*b2*f*r + 28*Dd*b2*f*s**2 - 42*Dd*b2*f*s + 21*Dd*b2*f + 12*Dd*f**3*r**2 + 24*Dd*f**3*r*s - 18*Dd*f**3*r + 12*Dd*f**3*s**2 - 18*Dd*f**3*s + 9*Dd*f**3 + 4*Dd*f**2*r**2 + 4*Dd*f**2*r*s - 4*Dd*f**2*r - Dd*f**2*s + Dd*f**2 - 168*Dd*f*g2*r**2 - 224*Dd*f*g2*r*s + 196*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 112*Dd*f*g2*s - 70*Dd*f*g2) + f*(-3*D1*K*bd1*f*r**2 - 4*D1*K*bd1*f*r*s + 4*D1*K*bd1*f*r - D1*K*bd1*f*s**2 + 2*D1*K*bd1*f*s - D1*K*bd1*f + 3*D1*bd1*f**2*r**2 + 6*D1*bd1*f**2*r*s - 4*D1*bd1*f**2*r + 3*D1*bd1*f**2*s**2 - 4*D1*bd1*f**2*s + 2*D1*bd1*f**2 + D1*bd1*f*r**2 + D1*bd1*f*r*s - D1*bd1*f*r - 42*D1*bd1*g2*r**2 - 56*D1*bd1*g2*r*s + 84*D1*bd1*g2*r - 14*D1*bd1*g2*s**2 + 56*D1*bd1*g2*s - 42*D1*bd1*g2 - D1*bd2*f*(r + s - 1)**2 + 6*D1*f*gd2*r**2 + 8*D1*f*gd2*r*s - 8*D1*f*gd2*r + 2*D1*f*gd2*s**2 - 4*D1*f*gd2*s + 2*D1*f*gd2 + 12*D1*fd*g2*r**2 + 16*D1*fd*g2*r*s - 12*D1*fd*g2*r + 4*D1*fd*g2*s**2 - 8*D1*fd*g2*s + 6*D1*fd*g2 + 24*Dd*f*g2*r**2 + 32*Dd*f*g2*r*s - 28*Dd*f*g2*r + 8*Dd*f*g2*s**2 - 16*Dd*f*g2*s + 10*Dd*f*g2 + b2*(7*D1*bd1*(r + s - 1)**2 - D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))))/(21*d**2*k3**6) - 2*D1**3*Pk1*Pk3*k2**2*(7*b1**2*(D1*fd*(K*(3*r**2 + 4*r*(s - 2) - 4*s + 4) + r**2 + 4*r + 2*s - 2) + Dd*f*(K*(12*r**2 + 2*r*(8*s - 7) - 4*s + 3) + 4*r**2 - 2*r + 1)) + b1*(7*D1*bd1*f*(K*(6*r**2 + 8*r*s - 2*r - 1) + 2*r**2 - 6*r - 2*s + 3) - 2*D1*(f*(3*fd*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 6*r + 2*s - 3) + 7*gd2*r*(3*r + 4*s - 4)) + 7*fd*g2*(3*r**2 + 4*r*(s - 2) - 4*s + 4)) - 2*Dd*f*(3*f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3) + 7*g2*(12*r**2 + 2*r*(8*s - 7) - 4*s + 3))) - 2*f*(D1*bd1*(3*f*r*(r*(K - 3) - 2*s + 2) + 7*g2*(3*r**2 + r*(4*s + 2) - 1)) - 6*D1*f*gd2*r**2 - 6*D1*fd*g2*(2*r**2 - 2*r + 1) - 6*Dd*f*g2*(4*r**2 - 2*r + 1)))/(21*d**2*k3**4) + D1**3*Pk1*Pk3*k2**4*st**2*(-7*b1**2*(D1*fd*r*(r*(K - 3) - 2*s) + Dd*f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3)) + b1*(-7*D1*bd1*f*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 8*r + 2*s - 3) + D1*(f*fd*(2*K*r**2 - 2*K*r + K - 6*r**2 - 4*r*s + 6*r + 2*s - 3) + 14*f*gd2*r**2 + 14*fd*g2*r**2) + Dd*f*(f*(4*K*r**2 - 2*K*r + K - 12*r**2 - 8*r*s + 10*r + 2*s - 3) + 14*g2*(4*r**2 - 2*r + 1))) + f*(D1*bd1*(f*r*(r*(K - 3) - 2*s + 2) + 14*g2*(r - 1)**2) - 2*D1*f*gd2*r**2 - 2*D1*fd*g2*(2*r**2 - 2*r + 1) - 2*Dd*f*g2*(4*r**2 - 2*r + 1)))/(21*d**2*k1**2*k3**4) + 2*D1**3*Pk1*Pk3*k2**2*(-2*D1*bd1*f*g2*r**2 + b1**2*(K - 1)*(D1*fd*(r - 1)**2 + Dd*f*(4*r**2 - 2*r + 1)) - 2*b1*(D1*f*r**2*(-K*bd1 + bd1 + gd2) + D1*fd*g2*(r - 1)**2 + Dd*f*g2*(4*r**2 - 2*r + 1)))/(3*d**2*k1**2*k3**2) + 2*D1**3*Pk1*Pkd3*b1*k2**2*(D1*b1*fd*(r - 1)*(r + s - 1) + D1*bd1*f*r*(2*r + 2*s - 1) + Dd*b1*f*(4*r**2 + 4*r*(s - 1) - s + 1))/(3*d**2*k1**2*k3) - 5*D1**3*Pk1*Pkd3*ct**5*f**2*k2**7*(33*D1*bd1*f*(r + s - 1)**2 + 33*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 28*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(77*d**2*k1*k3**7) + 3*D1**3*Pk1*Pkd3*ct**4*k2**6*(11*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7 - 7*K)*(r + s)**2) + Dd*f*(-7*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 22*b1*(D1*bd1*f*(-7*K + 6*f + 7)*(r + s - 1)**2 + D1*(-5*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-3*fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*gd2*(r + s - 1)**2) + 7*fd*g2*(r + s)**2) - Dd*f*(5*f**2 + 3*f*(K - 1) - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 2*f*(11*D1*bd1*(5*f**2 + 3*f*(K - 1) - 7*g2)*(r + s - 1)**2 + 2*D1*(35*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 33*f*gd2*(r + s - 1)**2 - 33*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*Dd*f*(35*f**2 - 33*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(77*d**2*k3**7) - 5*D1**3*Pk1*Pkd3*ct**3*f**2*k2**7*st**2*(33*D1*bd1*f*(r + s - 1)**2 + 33*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 25*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(77*d**2*k1*k3**7) + 3*D1**3*Pk1*Pkd3*ct**3*k1*k2**5*(22*D1*bd1*f*(f*(9 - 12*K) + 28*g2)*(r + s - 1)**2 + 11*b1**2*(D1*fd*(18*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (21 - 28*K)*(r + s)**2) + Dd*f*(-28*K + 18*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 22*b1*(D1*bd1*f*(-28*K + 18*f + 21)*(r + s - 1)**2 + D1*(-3*f*fd*(4*K - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*f*gd2*(r + s - 1)**2 + 28*fd*g2*(r + s)**2) - Dd*f*(3*f*(4*K - 3) - 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 4*f*(D1*(35*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 132*f*gd2*(r + s - 1)**2 - 132*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(35*f**2 - 132*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(77*d**2*k3**7) - D1**3*Pk1*Pkd3*ct**3*k2**5*(b1**2*(D1*fd*(30*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s)*(-28*K*r + 63*r + 35*s)) + Dd*f*(-28*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 60*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 252*r**2 + 392*r*s - 322*r + 140*s**2 - 238*s + 133)) + b1*(2*D1*bd1*f*(15*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (r + s - 1)*(-7*K*(4*r - 2) + 63*r + 35*s - 49)) + D1*(25*f**2*fd*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - 6*f*fd*(K*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 18*r**2 + r*(18 - 28*s) - 10*s**2 + 14*s - 9) + 56*f*gd2*r*(r + s - 1) + 56*fd*g2*r*(r + s)) + 2*Dd*f*(25*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*f*(4*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 36*r**2 - 56*r*s + 46*r - 20*s**2 + 34*s - 19) + 28*g2*(4*r**2 + 4*r*(s - 1) - s + 1))) + f*(D1*bd1*(25*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*f*(r + s - 1)*(r*(4*K - 9) - 5*s + 5) + 56*g2*(r - 1)*(r + s - 1)) + 48*D1*(f*gd2*r*(r + s - 1) + fd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 48*Dd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)))/(21*d**2*k1*k3**5) + D1**3*Pk1*Pkd3*ct**2*k1**2*k2**4*(99*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7 - 14*K)*(r + s)**2) + Dd*f*(-14*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 66*b1*(3*D1*bd1*f*(-14*K + 6*f + 7)*(r + s - 1)**2 + D1*(5*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*f*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 42*f*gd2*(r + s - 1)**2 + 42*fd*g2*(r + s)**2) + Dd*f*(5*f**2 + f*(9 - 18*K) + 42*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*f*(33*D1*bd1*(5*f**2 + f*(9 - 18*K) + 42*g2)*(r + s - 1)**2 + 2*D1*(-35*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 594*f*gd2*(r + s - 1)**2 + 594*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd*f*(35*f**2 - 594*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(77*d**2*k3**7) + 3*D1**3*Pk1*Pkd3*ct**2*k2**6*st**2*(11*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7*K - 7)*(r + s)**2) + Dd*f*(7*K + 6*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 11*b1*(2*D1*bd1*f*(7*K + 6*f - 7)*(r + s - 1)**2 - D1*(12*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*gd2*(r + s - 1)**2) + 14*fd*g2*(r + s)**2) - Dd*f*(12*f**2 + f*(K - 1) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - f*(11*D1*bd1*(12*f**2 + f*(K - 1) + 14*g2)*(r + s - 1)**2 + 2*D1*(75*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 11*f*gd2*(r + s - 1)**2 - 11*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*Dd*f*(75*f**2 - 11*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(154*d**2*k3**7) + D1**3*Pk1*Pkd3*ct**2*k2**4*(35*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1**2*(35*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - D1*fd*(-7*K*(12*r**2 + 2*r*(6*s + 5) + 10*s - 5) + 60*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 105*r**2 + 35*r*(4*s + 2) + 35*s**2 + 70*s - 35) - Dd*f*(-84*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 60*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 420*r**2 + 70*r*(8*s - 7) + 140*s**2 - 280*s + 175)) - b1*(-204*D1*K*f*fd*r**2 - 264*D1*K*f*fd*r*s + 204*D1*K*f*fd*r - 60*D1*K*f*fd*s**2 + 132*D1*K*f*fd*s - 102*D1*K*f*fd - 35*D1*b2*fd*r**2 - 70*D1*b2*fd*r*s - 35*D1*b2*fd*s**2 + D1*bd1*f*(-7*K*(24*r**2 + r*(24*s - 46) - 22*s + 17) + 120*f*(r + s - 1)**2 + 210*r**2 + 140*r*(2*s - 3) + 70*s**2 - 280*s + 175) - 35*D1*bd2*f*(r + s - 1)**2 + 225*D1*f**2*fd*r**2 + 450*D1*f**2*fd*r*s - 350*D1*f**2*fd*r + 225*D1*f**2*fd*s**2 - 350*D1*f**2*fd*s + 175*D1*f**2*fd + 240*D1*f*fd*r**2 + 360*D1*f*fd*r*s - 240*D1*f*fd*r + 120*D1*f*fd*s**2 - 180*D1*f*fd*s + 120*D1*f*fd + 168*D1*f*gd2*r**2 + 168*D1*f*gd2*r*s - 168*D1*f*gd2*r + 168*D1*fd*g2*r**2 + 168*D1*fd*g2*r*s + 140*D1*fd*g2*r + 140*D1*fd*g2*s - 70*D1*fd*g2 - 408*Dd*K*f**2*r**2 - 528*Dd*K*f**2*r*s + 468*Dd*K*f**2*r - 120*Dd*K*f**2*s**2 + 252*Dd*K*f**2*s - 162*Dd*K*f**2 - 140*Dd*b2*f*r**2 - 280*Dd*b2*f*r*s + 210*Dd*b2*f*r - 140*Dd*b2*f*s**2 + 210*Dd*b2*f*s - 105*Dd*b2*f + 300*Dd*f**3*r**2 + 600*Dd*f**3*r*s - 450*Dd*f**3*r + 300*Dd*f**3*s**2 - 450*Dd*f**3*s + 225*Dd*f**3 + 480*Dd*f**2*r**2 + 720*Dd*f**2*r*s - 600*Dd*f**2*r + 240*Dd*f**2*s**2 - 420*Dd*f**2*s + 240*Dd*f**2 + 672*Dd*f*g2*r**2 + 672*Dd*f*g2*r*s - 672*Dd*f*g2*r - 168*Dd*f*g2*s + 168*Dd*f*g2) + f*(-D1*bd1*(25*f**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*f*(r + s - 1)*(K*(17*r + 5*s - 5) - 20*r - 10*s + 10) + 14*g2*(12*r**2 + 2*r*(6*s - 17) - 22*s + 17)) + 30*D1*bd2*f*(r + s - 1)**2 - 12*D1*(f*gd2*(17*r**2 + 22*r*(s - 1) + 5*(s - 1)**2) + fd*g2*(34*r**2 + r*(44*s - 34) + 10*s**2 - 22*s + 17)) - 12*Dd*f*g2*(68*r**2 + r*(88*s - 78) + 20*s**2 - 42*s + 27) + 5*b2*(7*D1*bd1*(r + s - 1)**2 + 6*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(21*d**2*k3**5) + 2*D1**3*Pk1*Pkd3*ct**2*k2**4*(6*D1*bd1*f**2*r*(r + s - 1) + 7*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*f*(7*D1*bd1*(2*r - 1)*(r + s - 1) + 6*D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + 6*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)))/(21*d**2*k1**2*k3**3) + 2*D1**3*Pk1*Pkd3*ct**2*k2**2*st**2*(D1*bd1*f**2*r*(r + s) + 7*b1**2*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*f*(7*D1*bd1*(2*r**2 + 2*r*(s - 1) - s + 1) + D1*fd*(2*r - 1)*(r + s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)))/(21*d**2*k1**2*k3) - 15*D1**3*Pk1*Pkd3*ct*f**3*k2**7*st**4*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)/(77*d**2*k1*k3**7) + 3*D1**3*Pk1*Pkd3*ct*k1**3*k2**3*(b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7 - 28*K)*(r + s)**2) + Dd*f*(-28*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(2*D1*bd1*f*(-28*K + 6*f + 7)*(r + s - 1)**2 + D1*(5*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*f*fd*(4*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 56*f*gd2*(r + s - 1)**2 + 56*fd*g2*(r + s)**2) + Dd*f*(5*f**2 + f*(6 - 24*K) + 56*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*bd1*(5*f**2 + f*(6 - 24*K) + 56*g2)*(r + s - 1)**2 + 48*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 48*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**7) + 3*D1**3*Pk1*Pkd3*ct*k1*k2**5*st**2*(11*b1**2*(D1*fd*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (14*K - 7)*(r + s)**2) + Dd*f*(14*K + 9*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 11*b1*(2*D1*bd1*f*(14*K + 9*f - 7)*(r + s - 1)**2 - D1*(f*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*f*gd2*(r + s - 1)**2 + 28*fd*g2*(r + s)**2) - Dd*f*(f*(2*K - 1) + 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(-11*D1*bd1*(f*(2*K - 1) + 28*g2)*(r + s - 1)**2 + D1*(-75*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 44*f*gd2*(r + s - 1)**2 + 44*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(75*f**2 - 44*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(154*d**2*k3**7) + D1**3*Pk1*Pkd3*ct*k1*k2**3*(35*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1**2*(35*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(14*K*(6*r**2 + 2*r*(3*s + 5) + 10*s - 5) - 30*f*(2*r + 2*s - 1) - 56*r**2 - 14*r*(4*s + 5) - 70*s + 35) + 28*Dd*f*(3*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*(264*D1*K*f*fd*r**2 + 384*D1*K*f*fd*r*s - 264*D1*K*f*fd*r + 120*D1*K*f*fd*s**2 - 192*D1*K*f*fd*s + 132*D1*K*f*fd + 70*D1*b2*fd*r**2 + 140*D1*b2*fd*r*s + 70*D1*b2*fd*s**2 + D1*bd1*f*(7*K*(24*r**2 + 8*r*(3*s - 7) - 32*s + 22) + 30*f*(2*r + 2*s - 1) - 112*r**2 - 112*r*s + 238*r + 126*s - 91) + 70*D1*bd2*f*(r + s - 1)**2 - 75*D1*f**2*fd*r**2 - 150*D1*f**2*fd*r*s + 100*D1*f**2*fd*r - 75*D1*f**2*fd*s**2 + 100*D1*f**2*fd*s - 50*D1*f**2*fd - 156*D1*f*fd*r**2 - 216*D1*f*fd*r*s + 156*D1*f*fd*r - 60*D1*f*fd*s**2 + 108*D1*f*fd*s - 78*D1*f*fd - 168*D1*f*gd2*r**2 - 168*D1*f*gd2*r*s + 168*D1*f*gd2*r - 168*D1*fd*g2*r**2 - 168*D1*fd*g2*r*s - 280*D1*fd*g2*r - 280*D1*fd*g2*s + 140*D1*fd*g2 + 528*Dd*K*f**2*r**2 + 768*Dd*K*f**2*r*s - 648*Dd*K*f**2*r + 240*Dd*K*f**2*s**2 - 432*Dd*K*f**2*s + 252*Dd*K*f**2 + 280*Dd*b2*f*r**2 + 560*Dd*b2*f*r*s - 420*Dd*b2*f*r + 280*Dd*b2*f*s**2 - 420*Dd*b2*f*s + 210*Dd*b2*f - 100*Dd*f**3*r**2 - 200*Dd*f**3*r*s + 150*Dd*f**3*r - 100*Dd*f**3*s**2 + 150*Dd*f**3*s - 75*Dd*f**3 - 312*Dd*f**2*r**2 - 432*Dd*f**2*r*s + 372*Dd*f**2*r - 120*Dd*f**2*s**2 + 228*Dd*f**2*s - 138*Dd*f**2 - 672*Dd*f*g2*r**2 - 672*Dd*f*g2*r*s + 672*Dd*f*g2*r + 168*Dd*f*g2*s - 168*Dd*f*g2) + f*(-D1*bd1*(25*f**2*(r + s - 1)**2 - 6*f*(r + s - 1)*(2*K*(11*r + 5*s - 5) - 13*r - 5*s + 5) + 28*g2*(6*r**2 + r*(6*s - 22) - 16*s + 11)) + 60*D1*bd2*f*(r + s - 1)**2 - 24*D1*(f*gd2*(11*r**2 + 16*r*(s - 1) + 5*(s - 1)**2) + fd*g2*(22*r**2 + r*(32*s - 22) + 10*s**2 - 16*s + 11)) - 24*Dd*f*g2*(44*r**2 + r*(64*s - 54) + 20*s**2 - 36*s + 21) + 10*b2*(7*D1*bd1*(r + s - 1)**2 + 6*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(21*d**2*k3**5) - D1**3*Pk1*Pkd3*ct*k2**5*st**2*(b1**2*(D1*fd*(15*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s)*(28*K*r - 63*r - 35*s)) + Dd*f*(28*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 30*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 252*r**2 - 392*r*s + 322*r - 140*s**2 + 238*s - 133)) + b1*(D1*bd1*f*(15*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s - 1)*(56*K*r - 28*K - 126*r - 70*s + 98)) + D1*(15*f**2*fd*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + f*(fd*(K*(-8*r**2 - 8*r*s + 8*r + 4*s - 4) + 18*r**2 + 28*r*s - 18*r + 10*s**2 - 14*s + 9) - 56*gd2*r*(r + s - 1)) - 56*fd*g2*r*(r + s)) + Dd*f*(30*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-4*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 36*r**2 + 56*r*s - 46*r + 20*s**2 - 34*s + 19) - 56*g2*(4*r**2 + 4*r*(s - 1) - s + 1))) + f*(D1*bd1*(15*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - f*(r + s - 1)*(r*(4*K - 9) - 5*s + 5) - 56*g2*(r - 1)*(r + s - 1)) + 8*D1*(f*gd2*r*(r + s - 1) + fd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 8*Dd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)))/(42*d**2*k1*k3**5) - D1**3*Pk1*Pkd3*ct*k2**3*(-8*D1*bd1*f*r*(3*f*(r + s - 1) - 7*g2*(r + s)) + 7*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1**2*(7*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(-28*K*(r - 1)*(r + s - 1) + 12*f*(r + s - 1)**2 + 7*r**2 + 14*r*s - 70*r + 7*s**2 - 42*s + 35) + Dd*f*(-28*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21)) + b1*(D1*bd1*f*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*r**2*(8*K - 2) - 7*r*(8*K*s - 4*K - 4*s - 6) + 14*s**2 + 14*s - 21) - 8*D1*(f*fd*(6*r**2 + 6*r*(s - 1) - 3*s + 3) - 7*f*gd2*r*(r + s - 1) - 7*fd*g2*(r - 1)*(r + s - 1)) - 8*Dd*f*(3*f - 7*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)))/(21*d**2*k1*k3**3) - 9*D1**3*Pk1*Pkd3*f*k2**6*st**4*(22*D1*b1*bd1*f*(r + s - 1)**2 + 11*b1**2*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f**2*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(77*d**2*k3**7) - 3*D1**3*Pk1*Pkd3*k1**4*k2**2*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + 3*K*f - 7*g2) + 7*K*b1**2*(D1*fd*(r + s)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*b1*(-D1*(-3*K*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*f*gd2*(r + s - 1)**2 + 7*fd*g2*(r + s)**2) + Dd*f*(3*K*f - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*f*(D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**7) + D1**3*Pk1*Pkd3*k1**2*k2**4*st**2*(33*b1**2*(D1*fd*(7*K*(r + s)**2 + 3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(7*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 33*b1*(2*D1*bd1*f*(7*K + 3*f)*(r + s - 1)**2 + D1*(2*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - f*(K*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 14*gd2*(r + s - 1)**2) - 14*fd*g2*(r + s)**2) + Dd*f*(-K*f + 2*f**2 - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(33*D1*bd1*(r + s - 1)**2*(-K*f + 2*f**2 - 14*g2) + D1*(-25*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*f*gd2*(r + s - 1)**2 + 66*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(25*f**2 - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(154*d**2*k3**7) + D1**3*Pk1*Pkd3*k1**2*k2**2*(7*b1**2*(D1*fd*(K*(4*r**2 + 4*r*s + 10*r + 10*s - 5) - 2*r*(r + s)) + 2*Dd*f*(2*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*(108*D1*K*f*fd*r**2 + 168*D1*K*f*fd*r*s - 108*D1*K*f*fd*r + 60*D1*K*f*fd*s**2 - 84*D1*K*f*fd*s + 54*D1*K*f*fd + 35*D1*b2*fd*r**2 + 70*D1*b2*fd*r*s + 35*D1*b2*fd*s**2 + 7*D1*bd1*f*(K*(8*r**2 + 8*r*s - 22*r - 14*s + 9) + (2 - 4*r)*(r + s - 1)) + 35*D1*bd2*f*(r + s - 1)**2 - 24*D1*f*fd*r**2 - 24*D1*f*fd*r*s + 24*D1*f*fd*r + 12*D1*f*fd*s - 12*D1*f*fd - 56*D1*f*gd2*r**2 - 56*D1*f*gd2*r*s + 56*D1*f*gd2*r - 56*D1*fd*g2*r**2 - 56*D1*fd*g2*r*s - 140*D1*fd*g2*r - 140*D1*fd*g2*s + 70*D1*fd*g2 + 216*Dd*K*f**2*r**2 + 336*Dd*K*f**2*r*s - 276*Dd*K*f**2*r + 120*Dd*K*f**2*s**2 - 204*Dd*K*f**2*s + 114*Dd*K*f**2 + 140*Dd*b2*f*r**2 + 280*Dd*b2*f*r*s - 210*Dd*b2*f*r + 140*Dd*b2*f*s**2 - 210*Dd*b2*f*s + 105*Dd*b2*f - 48*Dd*f**2*r**2 - 48*Dd*f**2*r*s + 48*Dd*f**2*r + 12*Dd*f**2*s - 12*Dd*f**2 - 224*Dd*f*g2*r**2 - 224*Dd*f*g2*r*s + 224*Dd*f*g2*r + 56*Dd*f*g2*s - 56*Dd*f*g2) + f*(2*D1*bd1*(3*f*(K*(9*r + 5*s - 5) - 2*r)*(r + s - 1) - 7*g2*(4*r**2 + 2*r*(2*s - 9) - 14*s + 9)) + 30*D1*bd2*f*(r + s - 1)**2 - 12*D1*(f*gd2*(9*r**2 + 14*r*(s - 1) + 5*(s - 1)**2) + fd*g2*(18*r**2 + 2*r*(14*s - 9) + 10*s**2 - 14*s + 9)) - 12*Dd*f*g2*(36*r**2 + r*(56*s - 46) + 20*s**2 - 34*s + 19) + 5*b2*(7*D1*bd1*(r + s - 1)**2 + 6*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(21*d**2*k3**5) - D1**3*Pk1*Pkd3*k2**4*st**2*(35*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1**2*(35*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(10*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + (7*r + 7*s)*(9*K*r + 5*K*s - 2*r)) + Dd*f*(7*K*(36*r**2 + 56*r*s - 46*r + 20*s**2 - 34*s + 19) + 10*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 56*r**2 - 56*r*s + 56*r + 14*s - 14)) + b1*(-18*D1*K*f*fd*r**2 - 28*D1*K*f*fd*r*s + 18*D1*K*f*fd*r - 10*D1*K*f*fd*s**2 + 14*D1*K*f*fd*s - 9*D1*K*f*fd + 35*D1*b2*fd*r**2 + 70*D1*b2*fd*r*s + 35*D1*b2*fd*s**2 + 2*D1*bd1*f*(r + s - 1)*(7*K*(9*r + 5*s - 7) + 10*f*(r + s - 1) - 14*r + 7) + 35*D1*bd2*f*(r + s - 1)**2 + 45*D1*f**2*fd*r**2 + 90*D1*f**2*fd*r*s - 70*D1*f**2*fd*r + 45*D1*f**2*fd*s**2 - 70*D1*f**2*fd*s + 35*D1*f**2*fd + 4*D1*f*fd*r**2 + 4*D1*f*fd*r*s - 4*D1*f*fd*r - 2*D1*f*fd*s + 2*D1*f*fd - 126*D1*f*gd2*r**2 - 196*D1*f*gd2*r*s + 196*D1*f*gd2*r - 70*D1*f*gd2*s**2 + 140*D1*f*gd2*s - 70*D1*f*gd2 - 126*D1*fd*g2*r**2 - 196*D1*fd*g2*r*s - 70*D1*fd*g2*s**2 - 36*Dd*K*f**2*r**2 - 56*Dd*K*f**2*r*s + 46*Dd*K*f**2*r - 20*Dd*K*f**2*s**2 + 34*Dd*K*f**2*s - 19*Dd*K*f**2 + 140*Dd*b2*f*r**2 + 280*Dd*b2*f*r*s - 210*Dd*b2*f*r + 140*Dd*b2*f*s**2 - 210*Dd*b2*f*s + 105*Dd*b2*f + 60*Dd*f**3*r**2 + 120*Dd*f**3*r*s - 90*Dd*f**3*r + 60*Dd*f**3*s**2 - 90*Dd*f**3*s + 45*Dd*f**3 + 8*Dd*f**2*r**2 + 8*Dd*f**2*r*s - 8*Dd*f**2*r - 2*Dd*f**2*s + 2*Dd*f**2 - 504*Dd*f*g2*r**2 - 784*Dd*f*g2*r*s + 644*Dd*f*g2*r - 280*Dd*f*g2*s**2 + 476*Dd*f*g2*s - 266*Dd*f*g2) + f*(-9*D1*K*bd1*f*r**2 - 14*D1*K*bd1*f*r*s + 14*D1*K*bd1*f*r - 5*D1*K*bd1*f*s**2 + 10*D1*K*bd1*f*s - 5*D1*K*bd1*f + 15*D1*bd1*f**2*r**2 + 30*D1*bd1*f**2*r*s - 20*D1*bd1*f**2*r + 15*D1*bd1*f**2*s**2 - 20*D1*bd1*f**2*s + 10*D1*bd1*f**2 + 2*D1*bd1*f*r**2 + 2*D1*bd1*f*r*s - 2*D1*bd1*f*r - 126*D1*bd1*g2*r**2 - 196*D1*bd1*g2*r*s + 252*D1*bd1*g2*r - 70*D1*bd1*g2*s**2 + 196*D1*bd1*g2*s - 126*D1*bd1*g2 - 5*D1*bd2*f*(r + s - 1)**2 + 18*D1*f*gd2*r**2 + 28*D1*f*gd2*r*s - 28*D1*f*gd2*r + 10*D1*f*gd2*s**2 - 20*D1*f*gd2*s + 10*D1*f*gd2 + 36*D1*fd*g2*r**2 + 56*D1*fd*g2*r*s - 36*D1*fd*g2*r + 20*D1*fd*g2*s**2 - 28*D1*fd*g2*s + 18*D1*fd*g2 + 72*Dd*f*g2*r**2 + 112*Dd*f*g2*r*s - 92*Dd*f*g2*r + 40*Dd*f*g2*s**2 - 68*Dd*f*g2*s + 38*Dd*f*g2 + 5*b2*(7*D1*bd1*(r + s - 1)**2 - D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))))/(42*d**2*k3**5) + D1**3*Pk1*Pkd3*k2**2*(D1*bd1*f*(12*f*r*(r + s - 1) + (7*r + 7*s)*(b2*(r + s) - 2*g2*(5*r + s))) + 7*b1**2*(D1*fd*(K*(5*r**2 + 6*r*s - 10*r + s**2 - 6*s + 5) + 4*r + 2*s - 2) + Dd*K*f*(20*r**2 + r*(24*s - 22) + 4*s**2 - 10*s + 7)) + b1*(7*D1*b2*fd*r**2 + 14*D1*b2*fd*r*s - 14*D1*b2*fd*r + 7*D1*b2*fd*s**2 - 14*D1*b2*fd*s + 7*D1*b2*fd + 7*D1*bd1*f*(K*(10*r**2 + 12*r*s - 6*r + 2*s**2 - 2*s + 1) - 4*r - 2*s + 2) + 7*D1*bd2*f*(r + s - 1)**2 + 24*D1*f*fd*r**2 + 24*D1*f*fd*r*s - 24*D1*f*fd*r - 12*D1*f*fd*s + 12*D1*f*fd - 70*D1*f*gd2*r**2 - 84*D1*f*gd2*r*s + 84*D1*f*gd2*r - 14*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 14*D1*f*gd2 - 70*D1*fd*g2*r**2 - 84*D1*fd*g2*r*s + 140*D1*fd*g2*r - 14*D1*fd*g2*s**2 + 84*D1*fd*g2*s - 70*D1*fd*g2 + 28*Dd*b2*f*r**2 + 56*Dd*b2*f*r*s - 42*Dd*b2*f*r + 28*Dd*b2*f*s**2 - 42*Dd*b2*f*s + 21*Dd*b2*f + 48*Dd*f**2*r**2 + 48*Dd*f**2*r*s - 48*Dd*f**2*r - 12*Dd*f**2*s + 12*Dd*f**2 - 280*Dd*f*g2*r**2 - 336*Dd*f*g2*r*s + 308*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 140*Dd*f*g2*s - 98*Dd*f*g2))/(21*d**2*k3**3) + D1**3*Pk1*Pkd3*k2**4*st**2*(D1*bd1*f**2*r*(r + s - 1) - 7*b1**2*(D1*fd*r*(r + s) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + b1*f*(-7*D1*bd1*(2*r - 1)*(r + s - 1) + D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)))/(21*d**2*k1**2*k3**3) + D1**3*Pk1*Pkdd3*b1*ct*k2**3*(D1*bd1*f*(7*b1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (6*f + 7)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + b1*(D1*fd*(7*b1 + 12*f + 7)*(r + s - 1)**2 + Dd*f*(7*b1 + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(21*d**2*k1*k3**2) + 5*D1**3*Pk1*Pkdd3*ct**5*f**2*k2**7*(33*D1*bd1*f*(r + s - 1)**2 + 33*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 28*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(693*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct**4*k2**6*(11*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7 - 7*K)*(r + s)**2) + Dd*f*(-7*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 22*b1*(D1*bd1*f*(-7*K + 6*f + 7)*(r + s - 1)**2 + D1*(-5*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-3*fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*gd2*(r + s - 1)**2) + 7*fd*g2*(r + s)**2) - Dd*f*(5*f**2 + 3*f*(K - 1) - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 2*f*(11*D1*bd1*(5*f**2 + 3*f*(K - 1) - 7*g2)*(r + s - 1)**2 + 2*D1*(35*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 33*f*gd2*(r + s - 1)**2 - 33*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*Dd*f*(35*f**2 - 33*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(231*d**2*k3**6) + 5*D1**3*Pk1*Pkdd3*ct**3*f**2*k2**7*st**2*(33*D1*bd1*f*(r + s - 1)**2 + 33*b1*(D1*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 25*f*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(693*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct**3*k1*k2**5*(22*D1*bd1*f*(f*(9 - 12*K) + 28*g2)*(r + s - 1)**2 + 11*b1**2*(D1*fd*(18*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (21 - 28*K)*(r + s)**2) + Dd*f*(-28*K + 18*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 22*b1*(D1*bd1*f*(-28*K + 18*f + 21)*(r + s - 1)**2 + D1*(-3*f*fd*(4*K - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*f*gd2*(r + s - 1)**2 + 28*fd*g2*(r + s)**2) - Dd*f*(3*f*(4*K - 3) - 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 4*f*(D1*(35*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 132*f*gd2*(r + s - 1)**2 - 132*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(35*f**2 - 132*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(231*d**2*k3**6) + D1**3*Pk1*Pkdd3*ct**3*k2**5*(D1*bd1*f**2*(5*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*(r + s - 1)**2) + b1**2*(D1*fd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 7*(r + s)**2) + Dd*f*(12*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*f*(2*D1*bd1*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 7*(r + s - 1)**2) + D1*fd*(5*f*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 12*r**2 + 6*r*(4*s - 2) + 12*s**2 - 12*s + 6) + 2*Dd*f*(5*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(21*d**2*k1*k3**4) - D1**3*Pk1*Pkdd3*ct**2*k1**2*k2**4*(99*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7 - 14*K)*(r + s)**2) + Dd*f*(-14*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 66*b1*(3*D1*bd1*f*(-14*K + 6*f + 7)*(r + s - 1)**2 + D1*(5*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*f*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 42*f*gd2*(r + s - 1)**2 + 42*fd*g2*(r + s)**2) + Dd*f*(5*f**2 + f*(9 - 18*K) + 42*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*f*(33*D1*bd1*(5*f**2 + f*(9 - 18*K) + 42*g2)*(r + s - 1)**2 + 2*D1*(-35*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 594*f*gd2*(r + s - 1)**2 + 594*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*Dd*f*(35*f**2 - 594*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(693*d**2*k3**6) + D1**3*Pk1*Pkdd3*ct**2*k2**6*st**2*(-11*b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7*K - 7)*(r + s)**2) + Dd*f*(7*K + 6*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 11*b1*(2*D1*bd1*f*(7*K + 6*f - 7)*(r + s - 1)**2 - D1*(12*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(fd*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*gd2*(r + s - 1)**2) + 14*fd*g2*(r + s)**2) - Dd*f*(12*f**2 + f*(K - 1) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(11*D1*bd1*(12*f**2 + f*(K - 1) + 14*g2)*(r + s - 1)**2 + 2*D1*(75*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 11*f*gd2*(r + s - 1)**2 - 11*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 2*Dd*f*(75*f**2 - 11*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(462*d**2*k3**6) + D1**3*Pk1*Pkdd3*ct**2*k2**4*(-7*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1**2*(-7*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(-14*K*r - 14*K*s + 7*K + 12*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 7*r**2 + 14*r*s + 14*r + 7*s**2 + 14*s - 7) + Dd*f*(12*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(-12*D1*K*f*fd*r**2 - 24*D1*K*f*fd*r*s + 12*D1*K*f*fd*r - 12*D1*K*f*fd*s**2 + 12*D1*K*f*fd*s - 6*D1*K*f*fd - 7*D1*b2*fd*r**2 - 14*D1*b2*fd*r*s - 7*D1*b2*fd*s**2 + D1*bd1*f*(7*K*(2*r + 2*s - 1) + 24*f*(r + s - 1)**2 + 14*r**2 + 28*r*s - 42*r + 14*s**2 - 42*s + 21) - 7*D1*bd2*f*(r + s - 1)**2 + 45*D1*f**2*fd*r**2 + 90*D1*f**2*fd*r*s - 70*D1*f**2*fd*r + 45*D1*f**2*fd*s**2 - 70*D1*f**2*fd*s + 35*D1*f**2*fd + 24*D1*f*fd*r**2 + 48*D1*f*fd*r*s - 24*D1*f*fd*r + 24*D1*f*fd*s**2 - 24*D1*f*fd*s + 12*D1*f*fd + 28*D1*fd*g2*r + 28*D1*fd*g2*s - 14*D1*fd*g2 - 24*Dd*K*f**2*r**2 - 48*Dd*K*f**2*r*s + 36*Dd*K*f**2*r - 24*Dd*K*f**2*s**2 + 36*Dd*K*f**2*s - 18*Dd*K*f**2 - 28*Dd*b2*f*r**2 - 56*Dd*b2*f*r*s + 42*Dd*b2*f*r - 28*Dd*b2*f*s**2 + 42*Dd*b2*f*s - 21*Dd*b2*f + 60*Dd*f**3*r**2 + 120*Dd*f**3*r*s - 90*Dd*f**3*r + 60*Dd*f**3*s**2 - 90*Dd*f**3*s + 45*Dd*f**3 + 48*Dd*f**2*r**2 + 96*Dd*f**2*r*s - 72*Dd*f**2*r + 48*Dd*f**2*s**2 - 72*Dd*f**2*s + 36*Dd*f**2) + f*(D1*bd1*(5*f**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*f*(K - 2)*(r + s - 1)**2 - 14*g2*(2*r + 2*s - 1)) - 6*D1*bd2*f*(r + s - 1)**2 + 12*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 12*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - b2*(7*D1*bd1*(r + s - 1)**2 + 6*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(21*d**2*k3**4) + 5*D1**3*Pk1*Pkdd3*ct*f**3*k2**7*st**4*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)/(231*d**2*k1*k3**6) - D1**3*Pk1*Pkdd3*ct*k1**3*k2**3*(b1**2*(D1*fd*(6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (7 - 28*K)*(r + s)**2) + Dd*f*(-28*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(2*D1*bd1*f*(-28*K + 6*f + 7)*(r + s - 1)**2 + D1*(5*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*f*fd*(4*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 56*f*gd2*(r + s - 1)**2 + 56*fd*g2*(r + s)**2) + Dd*f*(5*f**2 + f*(6 - 24*K) + 56*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(D1*bd1*(5*f**2 + f*(6 - 24*K) + 56*g2)*(r + s - 1)**2 + 48*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 48*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(21*d**2*k3**6) + D1**3*Pk1*Pkdd3*ct*k1*k2**5*st**2*(-11*b1**2*(D1*fd*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (14*K - 7)*(r + s)**2) + Dd*f*(14*K + 9*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 11*b1*(2*D1*bd1*f*(14*K + 9*f - 7)*(r + s - 1)**2 - D1*(f*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*f*gd2*(r + s - 1)**2 + 28*fd*g2*(r + s)**2) - Dd*f*(f*(2*K - 1) + 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(11*D1*bd1*(f*(2*K - 1) + 28*g2)*(r + s - 1)**2 + D1*(75*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 44*f*gd2*(r + s - 1)**2 - 44*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(75*f**2 - 44*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(462*d**2*k3**6) - D1**3*Pk1*Pkdd3*ct*k1*k2**3*(D1*b1**2*(7*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fd*(-14*K + 6*f + 7)*(2*r + 2*s - 1)) + 7*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(24*D1*K*f*fd*r**2 + 48*D1*K*f*fd*r*s - 24*D1*K*f*fd*r + 24*D1*K*f*fd*s**2 - 24*D1*K*f*fd*s + 12*D1*K*f*fd + 14*D1*b2*fd*r**2 + 28*D1*b2*fd*r*s + 14*D1*b2*fd*s**2 + D1*bd1*f*(-14*K + 6*f + 7)*(2*r + 2*s - 1) + 14*D1*bd2*f*(r + s - 1)**2 - 15*D1*f**2*fd*r**2 - 30*D1*f**2*fd*r*s + 20*D1*f**2*fd*r - 15*D1*f**2*fd*s**2 + 20*D1*f**2*fd*s - 10*D1*f**2*fd - 12*D1*f*fd*r**2 - 24*D1*f*fd*r*s + 12*D1*f*fd*r - 12*D1*f*fd*s**2 + 12*D1*f*fd*s - 6*D1*f*fd - 56*D1*fd*g2*r - 56*D1*fd*g2*s + 28*D1*fd*g2 + 48*Dd*K*f**2*r**2 + 96*Dd*K*f**2*r*s - 72*Dd*K*f**2*r + 48*Dd*K*f**2*s**2 - 72*Dd*K*f**2*s + 36*Dd*K*f**2 + 56*Dd*b2*f*r**2 + 112*Dd*b2*f*r*s - 84*Dd*b2*f*r + 56*Dd*b2*f*s**2 - 84*Dd*b2*f*s + 42*Dd*b2*f - 20*Dd*f**3*r**2 - 40*Dd*f**3*r*s + 30*Dd*f**3*r - 20*Dd*f**3*s**2 + 30*Dd*f**3*s - 15*Dd*f**3 - 24*Dd*f**2*r**2 - 48*Dd*f**2*r*s + 36*Dd*f**2*r - 24*Dd*f**2*s**2 + 36*Dd*f**2*s - 18*Dd*f**2) + f*(D1*bd1*(-5*f**2*(r + s - 1)**2 + 6*f*(2*K - 1)*(r + s - 1)**2 + 28*g2*(2*r + 2*s - 1)) + 12*D1*bd2*f*(r + s - 1)**2 - 24*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) - 24*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*b2*(7*D1*bd1*(r + s - 1)**2 + 6*D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))))/(21*d**2*k3**4) + D1**3*Pk1*Pkdd3*ct*k2**5*st**2*(D1*bd1*f**2*(3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s - 1)**2) + b1**2*(D1*fd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*(r + s)**2) + Dd*f*(6*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*f*(D1*bd1*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 14*(r + s - 1)**2) + D1*fd*(3*f*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(6*f + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(42*d**2*k1*k3**4) + D1**3*Pk1*Pkdd3*f*k2**6*st**4*(22*D1*b1*bd1*f*(r + s - 1)**2 + 11*b1**2*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f**2*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))/(77*d**2*k3**6) + D1**3*Pk1*Pkdd3*k1**4*k2**2*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + 3*K*f - 7*g2) + 7*K*b1**2*(D1*fd*(r + s)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*b1*(-D1*(-3*K*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*f*gd2*(r + s - 1)**2 + 7*fd*g2*(r + s)**2) + Dd*f*(3*K*f - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*f*(D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(21*d**2*k3**6) - D1**3*Pk1*Pkdd3*k1**2*k2**4*st**2*(33*b1**2*(D1*fd*(7*K*(r + s)**2 + 3*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(7*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 33*b1*(2*D1*bd1*f*(7*K + 3*f)*(r + s - 1)**2 + D1*(2*f**2*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - f*(K*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 14*gd2*(r + s - 1)**2) - 14*fd*g2*(r + s)**2) + Dd*f*(-K*f + 2*f**2 - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + f*(33*D1*bd1*(r + s - 1)**2*(-K*f + 2*f**2 - 14*g2) + D1*(-25*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*f*gd2*(r + s - 1)**2 + 66*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(25*f**2 - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(1386*d**2*k3**6) - D1**3*Pk1*Pkdd3*k1**2*k2**2*(7*D1*K*b1**2*fd*(2*r + 2*s - 1) + b1*(7*D1*bd2*f*(r + s - 1)**2 + D1*(-7*K*bd1*f*(2*r + 2*s - 1) + 6*K*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*fd*g2*(2*r + 2*s - 1)) + 6*Dd*K*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b2*(7*D1*bd1*f*(r + s - 1)**2 + 7*b1*(D1*fd*(r + s)**2 + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + 6*f*(D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 2*f*(D1*bd1*(3*K*f*(r + s - 1)**2 + 7*g2*(2*r + 2*s - 1)) + 3*D1*bd2*f*(r + s - 1)**2 - 6*D1*(f*gd2*(r + s - 1)**2 + fd*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) - 6*Dd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(21*d**2*k3**4) + D1**3*Pk1*Pkdd3*k2**4*st**2*(7*b1**3*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1**2*(7*D1*bd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*fd*(7*K*(r + s)**2 + f*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2)) + Dd*f*(7*K + 2*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(14*D1*K*bd1*f*r**2 + 28*D1*K*bd1*f*r*s - 28*D1*K*bd1*f*r + 14*D1*K*bd1*f*s**2 - 28*D1*K*bd1*f*s + 14*D1*K*bd1*f - 2*D1*K*f*fd*r**2 - 4*D1*K*f*fd*r*s + 2*D1*K*f*fd*r - 2*D1*K*f*fd*s**2 + 2*D1*K*f*fd*s - D1*K*f*fd + 4*D1*bd1*f**2*r**2 + 8*D1*bd1*f**2*r*s - 8*D1*bd1*f**2*r + 4*D1*bd1*f**2*s**2 - 8*D1*bd1*f**2*s + 4*D1*bd1*f**2 + 7*D1*bd2*f*(r + s - 1)**2 + 9*D1*f**2*fd*r**2 + 18*D1*f**2*fd*r*s - 14*D1*f**2*fd*r + 9*D1*f**2*fd*s**2 - 14*D1*f**2*fd*s + 7*D1*f**2*fd - 14*D1*f*gd2*r**2 - 28*D1*f*gd2*r*s + 28*D1*f*gd2*r - 14*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 14*D1*f*gd2 - 14*D1*fd*g2*r**2 - 28*D1*fd*g2*r*s - 14*D1*fd*g2*s**2 - 4*Dd*K*f**2*r**2 - 8*Dd*K*f**2*r*s + 6*Dd*K*f**2*r - 4*Dd*K*f**2*s**2 + 6*Dd*K*f**2*s - 3*Dd*K*f**2 + 12*Dd*f**3*r**2 + 24*Dd*f**3*r*s - 18*Dd*f**3*r + 12*Dd*f**3*s**2 - 18*Dd*f**3*s + 9*Dd*f**3 - 56*Dd*f*g2*r**2 - 112*Dd*f*g2*r*s + 84*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 84*Dd*f*g2*s - 42*Dd*f*g2 + 7*b2*(D1*fd*(r + s)**2 + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + f*(-D1*K*bd1*f*r**2 - 2*D1*K*bd1*f*r*s + 2*D1*K*bd1*f*r - D1*K*bd1*f*s**2 + 2*D1*K*bd1*f*s - D1*K*bd1*f + 3*D1*bd1*f**2*r**2 + 6*D1*bd1*f**2*r*s - 4*D1*bd1*f**2*r + 3*D1*bd1*f**2*s**2 - 4*D1*bd1*f**2*s + 2*D1*bd1*f**2 - 14*D1*bd1*g2*r**2 - 28*D1*bd1*g2*r*s + 28*D1*bd1*g2*r - 14*D1*bd1*g2*s**2 + 28*D1*bd1*g2*s - 14*D1*bd1*g2 - D1*bd2*f*(r + s - 1)**2 + 2*D1*f*gd2*r**2 + 4*D1*f*gd2*r*s - 4*D1*f*gd2*r + 2*D1*f*gd2*s**2 - 4*D1*f*gd2*s + 2*D1*f*gd2 + 4*D1*fd*g2*r**2 + 8*D1*fd*g2*r*s - 4*D1*fd*g2*r + 4*D1*fd*g2*s**2 - 4*D1*fd*g2*s + 2*D1*fd*g2 + 8*Dd*f*g2*r**2 + 16*Dd*f*g2*r*s - 12*Dd*f*g2*r + 8*Dd*f*g2*s**2 - 12*Dd*f*g2*s + 6*Dd*f*g2 + b2*(7*D1*bd1*(r + s - 1)**2 - D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))))/(42*d**2*k3**4) - D1**3*Pk1*Pkdd3*k2**2*(D1*bd1*f*(b2 - 2*g2)*(r + s)**2 + K*b1**2*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + b1*(2*D1*K*bd1*f*r**2 + 4*D1*K*bd1*f*r*s - 2*D1*K*bd1*f*r + 2*D1*K*bd1*f*s**2 - 2*D1*K*bd1*f*s + D1*K*bd1*f + D1*b2*fd*(r + s - 1)**2 + D1*bd2*f*(r + s - 1)**2 - 2*D1*f*gd2*r**2 - 4*D1*f*gd2*r*s + 4*D1*f*gd2*r - 2*D1*f*gd2*s**2 + 4*D1*f*gd2*s - 2*D1*f*gd2 - 2*D1*fd*g2*r**2 - 4*D1*fd*g2*r*s + 4*D1*fd*g2*r - 2*D1*fd*g2*s**2 + 4*D1*fd*g2*s - 2*D1*fd*g2 + Dd*b2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*Dd*f*g2*r**2 - 16*Dd*f*g2*r*s + 12*Dd*f*g2*r - 8*Dd*f*g2*s**2 + 12*Dd*f*g2*s - 6*Dd*f*g2))/(3*d**2*k3**2) - D1**2*Pk1*Pk3*ct**8*k2**6*(80*C - 80)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 168*D1**2*f**2*fd*r**2 + 336*D1**2*f**2*fd*r*s - 224*D1**2*f**2*fd*r + 168*D1**2*f**2*fd*s**2 - 224*D1**2*f**2*fd*s + 112*D1**2*f**2*fd - 84*D1**2*f**2*fdd*r**2 - 168*D1**2*f**2*fdd*r*s + 112*D1**2*f**2*fdd*r - 84*D1**2*f**2*fdd*s**2 + 112*D1**2*f**2*fdd*s - 56*D1**2*f**2*fdd - 168*D1**2*f*fd**2*r**2 - 336*D1**2*f*fd**2*r*s + 224*D1**2*f*fd**2*r - 168*D1**2*f*fd**2*s**2 + 224*D1**2*f*fd**2*s - 56*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 224*D1*Dd*f**3*r**2 + 448*D1*Dd*f**3*r*s - 336*D1*Dd*f**3*r + 224*D1*Dd*f**3*s**2 - 336*D1*Dd*f**3*s + 168*D1*Dd*f**3 - 672*D1*Dd*f**2*fd*r**2 - 1344*D1*Dd*f**2*fd*r*s + 952*D1*Dd*f**2*fd*r - 672*D1*Dd*f**2*fd*s**2 + 952*D1*Dd*f**2*fd*s - 336*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 112*D1*Ddd*f**3*r**2 - 224*D1*Ddd*f**3*r*s + 168*D1*Ddd*f**3*r - 112*D1*Ddd*f**3*s**2 + 168*D1*Ddd*f**3*s - 84*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 336*Dd**2*f**3*r**2 - 672*Dd**2*f**3*r*s + 504*Dd**2*f**3*r - 336*Dd**2*f**3*s**2 + 504*Dd**2*f**3*s - 168*Dd**2*f**3)/(231*d**2*k3**8) - D1**2*Pk1*Pk3*ct**8*k2**4*(160*C - 160)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 56*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 28*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 28*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**6) - D1**2*Pk1*Pk3*ct**8*k2**2*(80*C - 80)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 4*D1*f*(28*Dd*f*(2*s**2 - 2*s + 1) - Dd*(2*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(2*s**2 - 2*s + 1)) - 56*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k3**4) - 40*D1**2*Pk1*Pk3*ct**7*f*k2**7*(312*D1**2*b1*f*fd*r**2 + 624*D1**2*b1*f*fd*r*s - 416*D1**2*b1*f*fd*r + 312*D1**2*b1*f*fd*s**2 - 416*D1**2*b1*f*fd*s + 208*D1**2*b1*f*fd - 156*D1**2*b1*f*fdd*r**2 - 312*D1**2*b1*f*fdd*r*s + 208*D1**2*b1*f*fdd*r - 156*D1**2*b1*f*fdd*s**2 + 208*D1**2*b1*f*fdd*s - 104*D1**2*b1*f*fdd - 312*D1**2*b1*fd**2*r**2 - 624*D1**2*b1*fd**2*r*s + 416*D1**2*b1*fd**2*r - 312*D1**2*b1*fd**2*s**2 + 416*D1**2*b1*fd**2*s - 104*D1**2*b1*fd**2 - 52*D1**2*bdd1*f**2*(r + s - 1)**2 + 360*D1**2*f**2*fd*r**2 + 720*D1**2*f**2*fd*r*s - 540*D1**2*f**2*fd*r + 360*D1**2*f**2*fd*s**2 - 540*D1**2*f**2*fd*s + 270*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r**2 - 360*D1**2*f**2*fdd*r*s + 270*D1**2*f**2*fdd*r - 180*D1**2*f**2*fdd*s**2 + 270*D1**2*f**2*fdd*s - 135*D1**2*f**2*fdd - 540*D1**2*f*fd**2*r**2 - 1080*D1**2*f*fd**2*r*s + 810*D1**2*f*fd**2*r - 540*D1**2*f*fd**2*s**2 + 810*D1**2*f*fd**2*s - 270*D1**2*f*fd**2 + 416*D1*Dd*b1*f**2*r**2 + 832*D1*Dd*b1*f**2*r*s - 624*D1*Dd*b1*f**2*r + 416*D1*Dd*b1*f**2*s**2 - 624*D1*Dd*b1*f**2*s + 312*D1*Dd*b1*f**2 - 1248*D1*Dd*b1*f*fd*r**2 - 2496*D1*Dd*b1*f*fd*r*s + 1768*D1*Dd*b1*f*fd*r - 1248*D1*Dd*b1*f*fd*s**2 + 1768*D1*Dd*b1*f*fd*s - 624*D1*Dd*b1*f*fd + 360*D1*Dd*f**3*r**2 + 720*D1*Dd*f**3*r*s - 540*D1*Dd*f**3*r + 360*D1*Dd*f**3*s**2 - 540*D1*Dd*f**3*s + 270*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r**2 - 2880*D1*Dd*f**2*fd*r*s + 2160*D1*Dd*f**2*fd*r - 1440*D1*Dd*f**2*fd*s**2 + 2160*D1*Dd*f**2*fd*s - 810*D1*Dd*f**2*fd - 208*D1*Ddd*b1*f**2*r**2 - 416*D1*Ddd*b1*f**2*r*s + 312*D1*Ddd*b1*f**2*r - 208*D1*Ddd*b1*f**2*s**2 + 312*D1*Ddd*b1*f**2*s - 156*D1*Ddd*b1*f**2 - 180*D1*Ddd*f**3*r**2 - 360*D1*Ddd*f**3*r*s + 270*D1*Ddd*f**3*r - 180*D1*Ddd*f**3*s**2 + 270*D1*Ddd*f**3*s - 135*D1*Ddd*f**3 + 104*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 624*Dd**2*b1*f**2*r**2 - 1248*Dd**2*b1*f**2*r*s + 936*Dd**2*b1*f**2*r - 624*Dd**2*b1*f**2*s**2 + 936*Dd**2*b1*f**2*s - 312*Dd**2*b1*f**2 - 540*Dd**2*f**3*r**2 - 1080*Dd**2*f**3*r*s + 810*Dd**2*f**3*r - 540*Dd**2*f**3*s**2 + 810*Dd**2*f**3*s - 270*Dd**2*f**3)/(429*d**2*k1*k3**8) - 8*D1**2*Pk1*Pk3*ct**7*k1*k2**5*(6336*C*D1**2*b1*f*fd*r**2 + 12672*C*D1**2*b1*f*fd*r*s - 6336*C*D1**2*b1*f*fd*r + 6336*C*D1**2*b1*f*fd*s**2 - 6336*C*D1**2*b1*f*fd*s + 3168*C*D1**2*b1*f*fd - 3960*C*D1**2*b1*f*fdd*r**2 - 7920*C*D1**2*b1*f*fdd*r*s + 3960*C*D1**2*b1*f*fdd*r - 3960*C*D1**2*b1*f*fdd*s**2 + 3960*C*D1**2*b1*f*fdd*s - 1980*C*D1**2*b1*f*fdd - 3960*C*D1**2*b1*fd**2*r**2 - 7920*C*D1**2*b1*fd**2*r*s + 3960*C*D1**2*b1*fd**2*r - 3960*C*D1**2*b1*fd**2*s**2 + 3960*C*D1**2*b1*fd**2*s + 8100*C*D1**2*f**2*fd*r**2 + 16200*C*D1**2*f**2*fd*r*s - 10800*C*D1**2*f**2*fd*r + 8100*C*D1**2*f**2*fd*s**2 - 10800*C*D1**2*f**2*fd*s + 5400*C*D1**2*f**2*fd - 5040*C*D1**2*f**2*fdd*r**2 - 10080*C*D1**2*f**2*fdd*r*s + 6720*C*D1**2*f**2*fdd*r - 5040*C*D1**2*f**2*fdd*s**2 + 6720*C*D1**2*f**2*fdd*s - 3360*C*D1**2*f**2*fdd - 10080*C*D1**2*f*fd**2*r**2 - 20160*C*D1**2*f*fd**2*r*s + 13440*C*D1**2*f*fd**2*r - 10080*C*D1**2*f*fd**2*s**2 + 13440*C*D1**2*f*fd**2*s - 3360*C*D1**2*f*fd**2 + 12672*C*D1*Dd*b1*f**2*r**2 + 25344*C*D1*Dd*b1*f**2*r*s - 19008*C*D1*Dd*b1*f**2*r + 12672*C*D1*Dd*b1*f**2*s**2 - 19008*C*D1*Dd*b1*f**2*s + 9504*C*D1*Dd*b1*f**2 - 31680*C*D1*Dd*b1*f*fd*r**2 - 63360*C*D1*Dd*b1*f*fd*r*s + 39600*C*D1*Dd*b1*f*fd*r - 31680*C*D1*Dd*b1*f*fd*s**2 + 39600*C*D1*Dd*b1*f*fd*s - 11880*C*D1*Dd*b1*f*fd + 10800*C*D1*Dd*f**3*r**2 + 21600*C*D1*Dd*f**3*r*s - 16200*C*D1*Dd*f**3*r + 10800*C*D1*Dd*f**3*s**2 - 16200*C*D1*Dd*f**3*s + 8100*C*D1*Dd*f**3 - 40320*C*D1*Dd*f**2*fd*r**2 - 80640*C*D1*Dd*f**2*fd*r*s + 57120*C*D1*Dd*f**2*fd*r - 40320*C*D1*Dd*f**2*fd*s**2 + 57120*C*D1*Dd*f**2*fd*s - 20160*C*D1*Dd*f**2*fd - 7920*C*D1*Ddd*b1*f**2*r**2 - 15840*C*D1*Ddd*b1*f**2*r*s + 11880*C*D1*Ddd*b1*f**2*r - 7920*C*D1*Ddd*b1*f**2*s**2 + 11880*C*D1*Ddd*b1*f**2*s - 5940*C*D1*Ddd*b1*f**2 - 6720*C*D1*Ddd*f**3*r**2 - 13440*C*D1*Ddd*f**3*r*s + 10080*C*D1*Ddd*f**3*r - 6720*C*D1*Ddd*f**3*s**2 + 10080*C*D1*Ddd*f**3*s - 5040*C*D1*Ddd*f**3 - 23760*C*Dd**2*b1*f**2*r**2 - 47520*C*Dd**2*b1*f**2*r*s + 35640*C*Dd**2*b1*f**2*r - 23760*C*Dd**2*b1*f**2*s**2 + 35640*C*Dd**2*b1*f**2*s - 11880*C*Dd**2*b1*f**2 - 20160*C*Dd**2*f**3*r**2 - 40320*C*Dd**2*f**3*r*s + 30240*C*Dd**2*f**3*r - 20160*C*Dd**2*f**3*s**2 + 30240*C*Dd**2*f**3*s - 10080*C*Dd**2*f**3 - 5676*D1**2*b1*f*fd*r**2 - 11352*D1**2*b1*f*fd*r*s + 5676*D1**2*b1*f*fd*r - 5676*D1**2*b1*f*fd*s**2 + 5676*D1**2*b1*f*fd*s - 2838*D1**2*b1*f*fd + 3630*D1**2*b1*f*fdd*r**2 + 7260*D1**2*b1*f*fdd*r*s - 3630*D1**2*b1*f*fdd*r + 3630*D1**2*b1*f*fdd*s**2 - 3630*D1**2*b1*f*fdd*s + 1815*D1**2*b1*f*fdd + 3630*D1**2*b1*fd**2*r**2 + 7260*D1**2*b1*fd**2*r*s - 3630*D1**2*b1*fd**2*r + 3630*D1**2*b1*fd**2*s**2 - 3630*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(12*C - 11)*(r + s - 1)**2 - 7260*D1**2*f**2*fd*r**2 - 14520*D1**2*f**2*fd*r*s + 9680*D1**2*f**2*fd*r - 7260*D1**2*f**2*fd*s**2 + 9680*D1**2*f**2*fd*s - 4840*D1**2*f**2*fd + 4620*D1**2*f**2*fdd*r**2 + 9240*D1**2*f**2*fdd*r*s - 6160*D1**2*f**2*fdd*r + 4620*D1**2*f**2*fdd*s**2 - 6160*D1**2*f**2*fdd*s + 3080*D1**2*f**2*fdd + 9240*D1**2*f*fd**2*r**2 + 18480*D1**2*f*fd**2*r*s - 12320*D1**2*f*fd**2*r + 9240*D1**2*f*fd**2*s**2 - 12320*D1**2*f*fd**2*s + 3080*D1**2*f*fd**2 - 11352*D1*Dd*b1*f**2*r**2 - 22704*D1*Dd*b1*f**2*r*s + 17028*D1*Dd*b1*f**2*r - 11352*D1*Dd*b1*f**2*s**2 + 17028*D1*Dd*b1*f**2*s - 8514*D1*Dd*b1*f**2 + 29040*D1*Dd*b1*f*fd*r**2 + 58080*D1*Dd*b1*f*fd*r*s - 36300*D1*Dd*b1*f*fd*r + 29040*D1*Dd*b1*f*fd*s**2 - 36300*D1*Dd*b1*f*fd*s + 10890*D1*Dd*b1*f*fd - 9680*D1*Dd*f**3*r**2 - 19360*D1*Dd*f**3*r*s + 14520*D1*Dd*f**3*r - 9680*D1*Dd*f**3*s**2 + 14520*D1*Dd*f**3*s - 7260*D1*Dd*f**3 + 36960*D1*Dd*f**2*fd*r**2 + 73920*D1*Dd*f**2*fd*r*s - 52360*D1*Dd*f**2*fd*r + 36960*D1*Dd*f**2*fd*s**2 - 52360*D1*Dd*f**2*fd*s + 18480*D1*Dd*f**2*fd + 7260*D1*Ddd*b1*f**2*r**2 + 14520*D1*Ddd*b1*f**2*r*s - 10890*D1*Ddd*b1*f**2*r + 7260*D1*Ddd*b1*f**2*s**2 - 10890*D1*Ddd*b1*f**2*s + 5445*D1*Ddd*b1*f**2 + 6160*D1*Ddd*f**3*r**2 + 12320*D1*Ddd*f**3*r*s - 9240*D1*Ddd*f**3*r + 6160*D1*Ddd*f**3*s**2 - 9240*D1*Ddd*f**3*s + 4620*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(48*C - 43)*(r + s - 1) - D1*fd*(60*C - 55)*(2*r + 2*s - 1) - Dd*f*(60*C - 55)*(4*r + 4*s - 3)) + 21780*Dd**2*b1*f**2*r**2 + 43560*Dd**2*b1*f**2*r*s - 32670*Dd**2*b1*f**2*r + 21780*Dd**2*b1*f**2*s**2 - 32670*Dd**2*b1*f**2*s + 10890*Dd**2*b1*f**2 + 18480*Dd**2*f**3*r**2 + 36960*Dd**2*f**3*r*s - 27720*Dd**2*f**3*r + 18480*Dd**2*f**3*s**2 - 27720*Dd**2*f**3*s + 9240*Dd**2*f**3)/(231*d**2*k3**8) - 16*D1**2*Pk1*Pk3*ct**7*k1*k2**3*(33*b1*(D1**2*(f*(fd*(88*C - 78) + fdd*(45 - 50*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(45 - 50*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(88*C - 78)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(45 - 50*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(45 - 50*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(45 - 50*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(494*C - 438)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (10*C - 9)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(252 - 280*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(88*C - 78)*(r + s - 1) - fd*(50*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(45 - 50*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 10*D1*f*(Dd*(f*(247*C - 219)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(140*C - 126)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(126 - 140*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(252 - 280*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**6) - D1**2*Pk1*Pk3*ct**7*k1*k2*(320*C - 280)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 4*D1*f*(28*Dd*f*(2*s**2 - 2*s + 1) - Dd*(2*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(2*s**2 - 2*s + 1)) - 56*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k3**4) + 8*D1**2*Pk1*Pk3*ct**7*k2**5*(1584*C*D1**2*b1*f*fd*r**2 + 1584*C*D1**2*b1*f*fd*r*s - 792*C*D1**2*b1*f*fd*r + 2580*C*D1**2*f**2*fd*r**2 + 2580*C*D1**2*f**2*fd*r*s - 2580*C*D1**2*f**2*fd*r - 860*C*D1**2*f**2*fd*s + 860*C*D1**2*f**2*fd - 300*C*D1**2*f**2*fdd*r**2 - 300*C*D1**2*f**2*fdd*r*s + 300*C*D1**2*f**2*fdd*r + 100*C*D1**2*f**2*fdd*s - 100*C*D1**2*f**2*fdd - 600*C*D1**2*f*fd**2*r**2 - 600*C*D1**2*f*fd**2*r*s + 600*C*D1**2*f*fd**2*r + 200*C*D1**2*f*fd**2*s - 100*C*D1**2*f*fd**2 + 3168*C*D1*Dd*b1*f**2*r**2 + 3168*C*D1*Dd*b1*f**2*r*s - 3168*C*D1*Dd*b1*f**2*r - 792*C*D1*Dd*b1*f**2*s + 792*C*D1*Dd*b1*f**2 + 3440*C*D1*Dd*f**3*r**2 + 3440*C*D1*Dd*f**3*r*s - 3440*C*D1*Dd*f**3*r - 860*C*D1*Dd*f**3*s + 860*C*D1*Dd*f**3 - 2400*C*D1*Dd*f**2*fd*r**2 - 2400*C*D1*Dd*f**2*fd*r*s + 2400*C*D1*Dd*f**2*fd*r + 700*C*D1*Dd*f**2*fd*s - 500*C*D1*Dd*f**2*fd - 400*C*D1*Ddd*f**3*r**2 - 400*C*D1*Ddd*f**3*r*s + 400*C*D1*Ddd*f**3*r + 100*C*D1*Ddd*f**3*s - 100*C*D1*Ddd*f**3 - 1200*C*Dd**2*f**3*r**2 - 1200*C*Dd**2*f**3*r*s + 1200*C*Dd**2*f**3*r + 300*C*Dd**2*f**3*s - 200*C*Dd**2*f**3 - 2244*D1**2*b1*f*fd*r**2 - 2904*D1**2*b1*f*fd*r*s + 1452*D1**2*b1*f*fd*r - 660*D1**2*b1*f*fd*s**2 + 660*D1**2*b1*f*fd*s - 330*D1**2*b1*f*fd + 330*D1**2*b1*f*fdd*r**2 + 660*D1**2*b1*f*fdd*r*s - 330*D1**2*b1*f*fdd*r + 330*D1**2*b1*f*fdd*s**2 - 330*D1**2*b1*f*fdd*s + 165*D1**2*b1*f*fdd + 330*D1**2*b1*fd**2*r**2 + 660*D1**2*b1*fd**2*r*s - 330*D1**2*b1*fd**2*r + 330*D1**2*b1*fd**2*s**2 - 330*D1**2*b1*fd**2*s + 165*D1**2*bdd1*f**2*(r + s - 1)**2 - 3420*D1**2*f**2*fd*r**2 - 4260*D1**2*f**2*fd*r*s + 3700*D1**2*f**2*fd*r - 840*D1**2*f**2*fd*s**2 + 1980*D1**2*f**2*fd*s - 1420*D1**2*f**2*fd + 720*D1**2*f**2*fdd*r**2 + 1140*D1**2*f**2*fdd*r*s - 860*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 660*D1**2*f**2*fdd*s + 380*D1**2*f**2*fdd + 1440*D1**2*f*fd**2*r**2 + 2280*D1**2*f*fd**2*r*s - 1720*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1320*D1**2*f*fd**2*s + 380*D1**2*f*fd**2 - 4488*D1*Dd*b1*f**2*r**2 - 5808*D1*Dd*b1*f**2*r*s + 5148*D1*Dd*b1*f**2*r - 1320*D1*Dd*b1*f**2*s**2 + 2772*D1*Dd*b1*f**2*s - 1782*D1*Dd*b1*f**2 + 2640*D1*Dd*b1*f*fd*r**2 + 5280*D1*Dd*b1*f*fd*r*s - 3300*D1*Dd*b1*f*fd*r + 2640*D1*Dd*b1*f*fd*s**2 - 3300*D1*Dd*b1*f*fd*s + 990*D1*Dd*b1*f*fd - 4560*D1*Dd*f**3*r**2 - 5680*D1*Dd*f**3*r*s + 5120*D1*Dd*f**3*r - 1120*D1*Dd*f**3*s**2 + 2540*D1*Dd*f**3*s - 1700*D1*Dd*f**3 + 5760*D1*Dd*f**2*fd*r**2 + 9120*D1*Dd*f**2*fd*r*s - 7160*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 5460*D1*Dd*f**2*fd*s + 2180*D1*Dd*f**2*fd + 660*D1*Ddd*b1*f**2*r**2 + 1320*D1*Ddd*b1*f**2*r*s - 990*D1*Ddd*b1*f**2*r + 660*D1*Ddd*b1*f**2*s**2 - 990*D1*Ddd*b1*f**2*s + 495*D1*Ddd*b1*f**2 + 960*D1*Ddd*f**3*r**2 + 1520*D1*Ddd*f**3*r*s - 1240*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 940*D1*Ddd*f**3*s + 520*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(12*C*(r - 1) - 17*r - 5*s + 17) + 5*D1*fd*(2*r + 2*s - 1) + 5*Dd*f*(4*r + 4*s - 3)) + 1980*Dd**2*b1*f**2*r**2 + 3960*Dd**2*b1*f**2*r*s - 2970*Dd**2*b1*f**2*r + 1980*Dd**2*b1*f**2*s**2 - 2970*Dd**2*b1*f**2*s + 990*Dd**2*b1*f**2 + 2880*Dd**2*f**3*r**2 + 4560*Dd**2*f**3*r*s - 3720*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2820*Dd**2*f**3*s + 1040*Dd**2*f**3)/(693*d**2*k1*k3**6) + 8*D1**2*Pk1*Pk3*ct**7*k2**3*(33*b1*(D1**2*(f*(2*fd*(r*(6*C - 11)*(2*s - 1) - 10*s**2 + 10*s - 5) + 5*fdd*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 5*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(2*f*(-6*C*s + r*(12*C - 22)*(2*s - 1) - 20*s**2 + 31*s - 10) + 5*fd*(2*s - 1)*(8*r + 8*s - 5)) + 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(33*bdd1*s*(r + s - 1) + 2*fd*(-43*C*s + r*(43*C - 71)*(3*s - 1) - 84*s**2 + 127*s - 28) + 2*fdd*(5*C*s - r*(5*C - 19)*(3*s - 1) + 42*s**2 - 47*s + 14)) + 2*fd**2*(-5*C*(r*(6*s - 2) - 2*s + 1) + 38*r*(3*s - 1) + 84*s**2 - 94*s + 19)) + 33*D1*bd1*(D1*(2*f*s*(6*C*(r - 1) - 11*r - 5*s + 11) + 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + 5*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 10*D1*f*(Dd*(f*(r*(86*C - 142)*(2*s - 1) - 112*s**2 + s*(183 - 43*C) - 56) + fd*(-5*C*(2*r*(12*s - 5) - 7*s + 3) + 38*r*(12*s - 5) + 336*s**2 - 413*s + 113)) + Ddd*f*(-r*(10*C - 38)*(2*s - 1) + 56*s**2 + s*(5*C - 75) + 28)) + 10*Dd**2*f**2*(-5*C*(6*r*(2*s - 1) - 3*s + 2) + 114*r*(2*s - 1) + 168*s**2 - 225*s + 66)))/(693*d**2*k1*k3**4) - 40*D1**2*Pk1*Pk3*ct**7*k2*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 4*D1*f*(28*Dd*f*(2*s**2 - 2*s + 1) - Dd*(2*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(2*s**2 - 2*s + 1)) - 56*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k1*k3**2) + 40*D1**2*Pk1*Pk3*ct**6*f*k2**6*(-507*D1**2*b1*f*fd*r**2 - 507*D1**2*b1*f*fd*r*s + 338*D1**2*b1*f*fd*r + 897*D1**2*b1*f*fdd*r**2 + 897*D1**2*b1*f*fdd*r*s - 598*D1**2*b1*f*fdd*r + 1794*D1**2*b1*fd**2*r**2 + 1794*D1**2*b1*fd**2*r*s - 1196*D1**2*b1*fd**2*r + 299*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 112*D1**2*f**2*fd*r**2 + 112*D1**2*f**2*fd*r*s - 112*D1**2*f**2*fd*r - 28*D1**2*f**2*fd*s + 28*D1**2*f**2*fd + 672*D1**2*f**2*fdd*r**2 + 672*D1**2*f**2*fdd*r*s - 672*D1**2*f**2*fdd*r - 168*D1**2*f**2*fdd*s + 168*D1**2*f**2*fdd + 2016*D1**2*f*fd**2*r**2 + 2016*D1**2*f*fd**2*r*s - 2016*D1**2*f*fd**2*r - 504*D1**2*f*fd**2*s + 336*D1**2*f*fd**2 - 676*D1*Dd*b1*f**2*r**2 - 676*D1*Dd*b1*f**2*r*s + 676*D1*Dd*b1*f**2*r + 169*D1*Dd*b1*f**2*s - 169*D1*Dd*b1*f**2 + 7176*D1*Dd*b1*f*fd*r**2 + 7176*D1*Dd*b1*f*fd*r*s - 5980*D1*Dd*b1*f*fd*r - 897*D1*Dd*b1*f*fd*s + 598*D1*Dd*b1*f*fd + 112*D1*Dd*f**3*r**2 + 112*D1*Dd*f**3*r*s - 112*D1*Dd*f**3*r - 28*D1*Dd*f**3*s + 28*D1*Dd*f**3 + 5376*D1*Dd*f**2*fd*r**2 + 5376*D1*Dd*f**2*fd*r*s - 5376*D1*Dd*f**2*fd*r - 1344*D1*Dd*f**2*fd*s + 1008*D1*Dd*f**2*fd + 1196*D1*Ddd*b1*f**2*r**2 + 1196*D1*Ddd*b1*f**2*r*s - 1196*D1*Ddd*b1*f**2*r - 299*D1*Ddd*b1*f**2*s + 299*D1*Ddd*b1*f**2 + 672*D1*Ddd*f**3*r**2 + 672*D1*Ddd*f**3*r*s - 672*D1*Ddd*f**3*r - 168*D1*Ddd*f**3*s + 168*D1*Ddd*f**3 - 13*D1*bd1*f*(D1*(13*f*(r - 1)*(r + s - 1) - 23*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 23*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 3588*Dd**2*b1*f**2*r**2 + 3588*Dd**2*b1*f**2*r*s - 3588*Dd**2*b1*f**2*r - 897*Dd**2*b1*f**2*s + 598*Dd**2*b1*f**2 + 2016*Dd**2*f**3*r**2 + 2016*Dd**2*f**3*r*s - 2016*Dd**2*f**3*r - 504*Dd**2*f**3*s + 336*Dd**2*f**3)/(9009*d**2*k1**2*k3**6) - 8*D1**2*Pk1*Pk3*ct**6*k1**2*k2**4*(12672*C*D1**2*b1*f*fd*r**2 + 25344*C*D1**2*b1*f*fd*r*s - 12672*C*D1**2*b1*f*fd*r + 12672*C*D1**2*b1*f*fd*s**2 - 12672*C*D1**2*b1*f*fd*s + 6336*C*D1**2*b1*f*fd - 9900*C*D1**2*b1*f*fdd*r**2 - 19800*C*D1**2*b1*f*fdd*r*s + 9900*C*D1**2*b1*f*fdd*r - 9900*C*D1**2*b1*f*fdd*s**2 + 9900*C*D1**2*b1*f*fdd*s - 4950*C*D1**2*b1*f*fdd - 9900*C*D1**2*b1*fd**2*r**2 - 19800*C*D1**2*b1*fd**2*r*s + 9900*C*D1**2*b1*fd**2*r - 9900*C*D1**2*b1*fd**2*s**2 + 9900*C*D1**2*b1*fd**2*s + 16290*C*D1**2*f**2*fd*r**2 + 32580*C*D1**2*f**2*fd*r*s - 21720*C*D1**2*f**2*fd*r + 16290*C*D1**2*f**2*fd*s**2 - 21720*C*D1**2*f**2*fd*s + 10860*C*D1**2*f**2*fd - 12600*C*D1**2*f**2*fdd*r**2 - 25200*C*D1**2*f**2*fdd*r*s + 16800*C*D1**2*f**2*fdd*r - 12600*C*D1**2*f**2*fdd*s**2 + 16800*C*D1**2*f**2*fdd*s - 8400*C*D1**2*f**2*fdd - 25200*C*D1**2*f*fd**2*r**2 - 50400*C*D1**2*f*fd**2*r*s + 33600*C*D1**2*f*fd**2*r - 25200*C*D1**2*f*fd**2*s**2 + 33600*C*D1**2*f*fd**2*s - 8400*C*D1**2*f*fd**2 + 25344*C*D1*Dd*b1*f**2*r**2 + 50688*C*D1*Dd*b1*f**2*r*s - 38016*C*D1*Dd*b1*f**2*r + 25344*C*D1*Dd*b1*f**2*s**2 - 38016*C*D1*Dd*b1*f**2*s + 19008*C*D1*Dd*b1*f**2 - 79200*C*D1*Dd*b1*f*fd*r**2 - 158400*C*D1*Dd*b1*f*fd*r*s + 99000*C*D1*Dd*b1*f*fd*r - 79200*C*D1*Dd*b1*f*fd*s**2 + 99000*C*D1*Dd*b1*f*fd*s - 29700*C*D1*Dd*b1*f*fd + 21720*C*D1*Dd*f**3*r**2 + 43440*C*D1*Dd*f**3*r*s - 32580*C*D1*Dd*f**3*r + 21720*C*D1*Dd*f**3*s**2 - 32580*C*D1*Dd*f**3*s + 16290*C*D1*Dd*f**3 - 100800*C*D1*Dd*f**2*fd*r**2 - 201600*C*D1*Dd*f**2*fd*r*s + 142800*C*D1*Dd*f**2*fd*r - 100800*C*D1*Dd*f**2*fd*s**2 + 142800*C*D1*Dd*f**2*fd*s - 50400*C*D1*Dd*f**2*fd - 19800*C*D1*Ddd*b1*f**2*r**2 - 39600*C*D1*Ddd*b1*f**2*r*s + 29700*C*D1*Ddd*b1*f**2*r - 19800*C*D1*Ddd*b1*f**2*s**2 + 29700*C*D1*Ddd*b1*f**2*s - 14850*C*D1*Ddd*b1*f**2 - 16800*C*D1*Ddd*f**3*r**2 - 33600*C*D1*Ddd*f**3*r*s + 25200*C*D1*Ddd*f**3*r - 16800*C*D1*Ddd*f**3*s**2 + 25200*C*D1*Ddd*f**3*s - 12600*C*D1*Ddd*f**3 - 59400*C*Dd**2*b1*f**2*r**2 - 118800*C*Dd**2*b1*f**2*r*s + 89100*C*Dd**2*b1*f**2*r - 59400*C*Dd**2*b1*f**2*s**2 + 89100*C*Dd**2*b1*f**2*s - 29700*C*Dd**2*b1*f**2 - 50400*C*Dd**2*f**3*r**2 - 100800*C*Dd**2*f**3*r*s + 75600*C*Dd**2*f**3*r - 50400*C*Dd**2*f**3*s**2 + 75600*C*Dd**2*f**3*s - 25200*C*Dd**2*f**3 - 10164*D1**2*b1*f*fd*r**2 - 20328*D1**2*b1*f*fd*r*s + 10164*D1**2*b1*f*fd*r - 10164*D1**2*b1*f*fd*s**2 + 10164*D1**2*b1*f*fd*s - 5082*D1**2*b1*f*fd + 8250*D1**2*b1*f*fdd*r**2 + 16500*D1**2*b1*f*fdd*r*s - 8250*D1**2*b1*f*fdd*r + 8250*D1**2*b1*f*fdd*s**2 - 8250*D1**2*b1*f*fdd*s + 4125*D1**2*b1*f*fdd + 8250*D1**2*b1*fd**2*r**2 + 16500*D1**2*b1*fd**2*r*s - 8250*D1**2*b1*fd**2*r + 8250*D1**2*b1*fd**2*s**2 - 8250*D1**2*b1*fd**2*s - 825*D1**2*bdd1*f**2*(6*C - 5)*(r + s - 1)**2 - 13080*D1**2*f**2*fd*r**2 - 26160*D1**2*f**2*fd*r*s + 17440*D1**2*f**2*fd*r - 13080*D1**2*f**2*fd*s**2 + 17440*D1**2*f**2*fd*s - 8720*D1**2*f**2*fd + 10500*D1**2*f**2*fdd*r**2 + 21000*D1**2*f**2*fdd*r*s - 14000*D1**2*f**2*fdd*r + 10500*D1**2*f**2*fdd*s**2 - 14000*D1**2*f**2*fdd*s + 7000*D1**2*f**2*fdd + 21000*D1**2*f*fd**2*r**2 + 42000*D1**2*f*fd**2*r*s - 28000*D1**2*f*fd**2*r + 21000*D1**2*f*fd**2*s**2 - 28000*D1**2*f*fd**2*s + 7000*D1**2*f*fd**2 - 20328*D1*Dd*b1*f**2*r**2 - 40656*D1*Dd*b1*f**2*r*s + 30492*D1*Dd*b1*f**2*r - 20328*D1*Dd*b1*f**2*s**2 + 30492*D1*Dd*b1*f**2*s - 15246*D1*Dd*b1*f**2 + 66000*D1*Dd*b1*f*fd*r**2 + 132000*D1*Dd*b1*f*fd*r*s - 82500*D1*Dd*b1*f*fd*r + 66000*D1*Dd*b1*f*fd*s**2 - 82500*D1*Dd*b1*f*fd*s + 24750*D1*Dd*b1*f*fd - 17440*D1*Dd*f**3*r**2 - 34880*D1*Dd*f**3*r*s + 26160*D1*Dd*f**3*r - 17440*D1*Dd*f**3*s**2 + 26160*D1*Dd*f**3*s - 13080*D1*Dd*f**3 + 84000*D1*Dd*f**2*fd*r**2 + 168000*D1*Dd*f**2*fd*r*s - 119000*D1*Dd*f**2*fd*r + 84000*D1*Dd*f**2*fd*s**2 - 119000*D1*Dd*f**2*fd*s + 42000*D1*Dd*f**2*fd + 16500*D1*Ddd*b1*f**2*r**2 + 33000*D1*Ddd*b1*f**2*r*s - 24750*D1*Ddd*b1*f**2*r + 16500*D1*Ddd*b1*f**2*s**2 - 24750*D1*Ddd*b1*f**2*s + 12375*D1*Ddd*b1*f**2 + 14000*D1*Ddd*f**3*r**2 + 28000*D1*Ddd*f**3*r*s - 21000*D1*Ddd*f**3*r + 14000*D1*Ddd*f**3*s**2 - 21000*D1*Ddd*f**3*s + 10500*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(96*C - 77)*(r + s - 1) - D1*fd*(150*C - 125)*(2*r + 2*s - 1) - Dd*f*(150*C - 125)*(4*r + 4*s - 3)) + 49500*Dd**2*b1*f**2*r**2 + 99000*Dd**2*b1*f**2*r*s - 74250*Dd**2*b1*f**2*r + 49500*Dd**2*b1*f**2*s**2 - 74250*Dd**2*b1*f**2*s + 24750*Dd**2*b1*f**2 + 42000*Dd**2*f**3*r**2 + 84000*Dd**2*f**3*r*s - 63000*Dd**2*f**3*r + 42000*Dd**2*f**3*s**2 - 63000*Dd**2*f**3*s + 21000*Dd**2*f**3)/(231*d**2*k3**8) - 16*D1**2*Pk1*Pk3*ct**6*k1**2*k2**2*(66*b1*(D1**2*(f*(fd*(76*C - 59) + fdd*(40 - 50*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(40 - 50*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(76*C - 59)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(40 - 50*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(40 - 50*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(40 - 50*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(856*C - 665)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 16)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(448 - 560*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 66*D1*bd1*(D1*(f*s*(76*C - 59)*(r + s - 1) - fd*(50*C - 40)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(40 - 50*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(856*C - 665)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(560*C - 448)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(448 - 560*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(448 - 560*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**6) - D1**2*Pk1*Pk3*ct**6*k1**2*(160*C - 120)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 4*D1*f*(28*Dd*f*(2*s**2 - 2*s + 1) - Dd*(2*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(2*s**2 - 2*s + 1)) - 56*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(231*d**2*k3**4) - D1**2*Pk1*Pk3*ct**6*k2**6*st**2*(40*C - 40)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 150*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 - 200*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 200*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 150*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3)/(77*d**2*k3**8) + 8*D1**2*Pk1*Pk3*ct**6*k2**6*(12870*C*D1**2*f**2*fd*r**2 + 25740*C*D1**2*f**2*fd*r*s - 17160*C*D1**2*f**2*fd*r + 12870*C*D1**2*f**2*fd*s**2 - 17160*C*D1**2*f**2*fd*s + 8580*C*D1**2*f**2*fd + 17160*C*D1*Dd*f**3*r**2 + 34320*C*D1*Dd*f**3*r*s - 25740*C*D1*Dd*f**3*r + 17160*C*D1*Dd*f**3*s**2 - 25740*C*D1*Dd*f**3*s + 12870*C*D1*Dd*f**3 + 2145*D1**2*K*bdd1*f**2*r**2 + 4290*D1**2*K*bdd1*f**2*r*s - 4290*D1**2*K*bdd1*f**2*r + 2145*D1**2*K*bdd1*f**2*s**2 - 4290*D1**2*K*bdd1*f**2*s + 2145*D1**2*K*bdd1*f**2 - 858*D1**2*bd1**2*f*(-6*K + 5*f + 6)*(r + s - 1)**2 + 7280*D1**2*bdd1*f**3*r**2 + 14560*D1**2*bdd1*f**3*r*s - 14560*D1**2*bdd1*f**3*r + 7280*D1**2*bdd1*f**3*s**2 - 14560*D1**2*bdd1*f**3*s + 7280*D1**2*bdd1*f**3 - 2145*D1**2*bdd1*f**2*r**2 - 4290*D1**2*bdd1*f**2*r*s + 4290*D1**2*bdd1*f**2*r - 2145*D1**2*bdd1*f**2*s**2 + 4290*D1**2*bdd1*f**2*s - 2145*D1**2*bdd1*f**2 - 5148*D1**2*bdd1*f*g2*r**2 - 10296*D1**2*bdd1*f*g2*r*s + 10296*D1**2*bdd1*f*g2*r - 5148*D1**2*bdd1*f*g2*s**2 + 10296*D1**2*bdd1*f*g2*s - 5148*D1**2*bdd1*f*g2 - 48440*D1**2*f**3*fd*r**2 - 96880*D1**2*f**3*fd*r*s + 72660*D1**2*f**3*fd*r - 48440*D1**2*f**3*fd*s**2 + 72660*D1**2*f**3*fd*s - 36330*D1**2*f**3*fd + 31500*D1**2*f**3*fdd*r**2 + 63000*D1**2*f**3*fdd*r*s - 47250*D1**2*f**3*fdd*r + 31500*D1**2*f**3*fdd*s**2 - 47250*D1**2*f**3*fdd*s + 23625*D1**2*f**3*fdd + 94500*D1**2*f**2*fd**2*r**2 + 189000*D1**2*f**2*fd**2*r*s - 141750*D1**2*f**2*fd**2*r + 94500*D1**2*f**2*fd**2*s**2 - 141750*D1**2*f**2*fd**2*s + 47250*D1**2*f**2*fd**2 - 12870*D1**2*f**2*fd*r**2 - 25740*D1**2*f**2*fd*r*s + 17160*D1**2*f**2*fd*r - 12870*D1**2*f**2*fd*s**2 + 17160*D1**2*f**2*fd*s - 8580*D1**2*f**2*fd + 8580*D1**2*f**2*gd2*r**2 + 17160*D1**2*f**2*gd2*r*s - 17160*D1**2*f**2*gd2*r + 8580*D1**2*f**2*gd2*s**2 - 17160*D1**2*f**2*gd2*s + 8580*D1**2*f**2*gd2 - 4290*D1**2*f**2*gdd2*r**2 - 8580*D1**2*f**2*gdd2*r*s + 8580*D1**2*f**2*gdd2*r - 4290*D1**2*f**2*gdd2*s**2 + 8580*D1**2*f**2*gdd2*s - 4290*D1**2*f**2*gdd2 + 17160*D1**2*f*fd*g2*r**2 + 34320*D1**2*f*fd*g2*r*s - 17160*D1**2*f*fd*g2*r + 17160*D1**2*f*fd*g2*s**2 - 17160*D1**2*f*fd*g2*s + 8580*D1**2*f*fd*g2 - 17160*D1**2*f*fd*gd2*r**2 - 34320*D1**2*f*fd*gd2*r*s + 25740*D1**2*f*fd*gd2*r - 17160*D1**2*f*fd*gd2*s**2 + 25740*D1**2*f*fd*gd2*s - 8580*D1**2*f*fd*gd2 - 8580*D1**2*f*fdd*g2*r**2 - 17160*D1**2*f*fdd*g2*r*s + 8580*D1**2*f*fdd*g2*r - 8580*D1**2*f*fdd*g2*s**2 + 8580*D1**2*f*fdd*g2*s - 4290*D1**2*f*fdd*g2 - 8580*D1**2*fd**2*g2*r**2 - 17160*D1**2*fd**2*g2*r*s + 8580*D1**2*fd**2*g2*r - 8580*D1**2*fd**2*g2*s**2 + 8580*D1**2*fd**2*g2*s - 48440*D1*Dd*f**4*r**2 - 96880*D1*Dd*f**4*r*s + 72660*D1*Dd*f**4*r - 48440*D1*Dd*f**4*s**2 + 72660*D1*Dd*f**4*s - 36330*D1*Dd*f**4 + 252000*D1*Dd*f**3*fd*r**2 + 504000*D1*Dd*f**3*fd*r*s - 378000*D1*Dd*f**3*fd*r + 252000*D1*Dd*f**3*fd*s**2 - 378000*D1*Dd*f**3*fd*s + 141750*D1*Dd*f**3*fd - 17160*D1*Dd*f**3*r**2 - 34320*D1*Dd*f**3*r*s + 25740*D1*Dd*f**3*r - 17160*D1*Dd*f**3*s**2 + 25740*D1*Dd*f**3*s - 12870*D1*Dd*f**3 + 34320*D1*Dd*f**2*g2*r**2 + 68640*D1*Dd*f**2*g2*r*s - 51480*D1*Dd*f**2*g2*r + 34320*D1*Dd*f**2*g2*s**2 - 51480*D1*Dd*f**2*g2*s + 25740*D1*Dd*f**2*g2 - 34320*D1*Dd*f**2*gd2*r**2 - 68640*D1*Dd*f**2*gd2*r*s + 60060*D1*Dd*f**2*gd2*r - 34320*D1*Dd*f**2*gd2*s**2 + 60060*D1*Dd*f**2*gd2*s - 25740*D1*Dd*f**2*gd2 - 68640*D1*Dd*f*fd*g2*r**2 - 137280*D1*Dd*f*fd*g2*r*s + 85800*D1*Dd*f*fd*g2*r - 68640*D1*Dd*f*fd*g2*s**2 + 85800*D1*Dd*f*fd*g2*s - 25740*D1*Dd*f*fd*g2 + 31500*D1*Ddd*f**4*r**2 + 63000*D1*Ddd*f**4*r*s - 47250*D1*Ddd*f**4*r + 31500*D1*Ddd*f**4*s**2 - 47250*D1*Ddd*f**4*s + 23625*D1*Ddd*f**4 - 17160*D1*Ddd*f**2*g2*r**2 - 34320*D1*Ddd*f**2*g2*r*s + 25740*D1*Ddd*f**2*g2*r - 17160*D1*Ddd*f**2*g2*s**2 + 25740*D1*Ddd*f**2*g2*s - 12870*D1*Ddd*f**2*g2 - 26*D1*bd1*(D1*(395*f**3*(r + s - 1) + f**2*(-198*C*(r + s - 1) - 560*fd*(3*r + 3*s - 2) + (165*K + 33)*(r + s - 1)) - 33*f*(5*fd*(K - 1)*(2*r + 2*s - 1) + (12*g2 - 12*gd2)*(r + s - 1)) + 396*fd*g2*(r + s)) - Dd*f*(560*f**2 + 165*f*(K - 1) - 396*g2)*(4*r + 4*s - 3))*(r + s - 1) + 94500*Dd**2*f**4*r**2 + 189000*Dd**2*f**4*r*s - 141750*Dd**2*f**4*r + 94500*Dd**2*f**4*s**2 - 141750*Dd**2*f**4*s + 47250*Dd**2*f**4 - 51480*Dd**2*f**2*g2*r**2 - 102960*Dd**2*f**2*g2*r*s + 77220*Dd**2*f**2*g2*r - 51480*Dd**2*f**2*g2*s**2 + 77220*Dd**2*f**2*g2*s - 25740*Dd**2*f**2*g2 + 429*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(5*fd**2*(r + s - 1) + 6*fd*(K - 1)*(r + s) - 3*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (6*K - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-6*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-6*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(792*C*D1**2*f*fd*r**2 + 1584*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 792*C*D1**2*f*fd*s**2 - 792*C*D1**2*f*fd*s + 396*C*D1**2*f*fd + 1584*C*D1*Dd*f**2*r**2 + 3168*C*D1*Dd*f**2*r*s - 2376*C*D1*Dd*f**2*r + 1584*C*D1*Dd*f**2*s**2 - 2376*C*D1*Dd*f**2*s + 1188*C*D1*Dd*f**2 - 660*D1**2*K*f*fd*r**2 - 1320*D1**2*K*f*fd*r*s + 660*D1**2*K*f*fd*r - 660*D1**2*K*f*fd*s**2 + 660*D1**2*K*f*fd*s - 330*D1**2*K*f*fd + 330*D1**2*K*f*fdd*r**2 + 660*D1**2*K*f*fdd*r*s - 330*D1**2*K*f*fdd*r + 330*D1**2*K*f*fdd*s**2 - 330*D1**2*K*f*fdd*s + 165*D1**2*K*f*fdd + 330*D1**2*K*fd**2*r**2 + 660*D1**2*K*fd**2*r*s - 330*D1**2*K*fd**2*r + 330*D1**2*K*fd**2*s**2 - 330*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(-6*K + 5*f + 6)*(r + s - 1)**2 - 2370*D1**2*f**2*fd*r**2 - 4740*D1**2*f**2*fd*r*s + 3160*D1**2*f**2*fd*r - 2370*D1**2*f**2*fd*s**2 + 3160*D1**2*f**2*fd*s - 1580*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*r**2 + 3360*D1**2*f**2*fdd*r*s - 2240*D1**2*f**2*fdd*r + 1680*D1**2*f**2*fdd*s**2 - 2240*D1**2*f**2*fdd*s + 1120*D1**2*f**2*fdd + 3360*D1**2*f*fd**2*r**2 + 6720*D1**2*f*fd**2*r*s - 4480*D1**2*f*fd**2*r + 3360*D1**2*f*fd**2*s**2 - 4480*D1**2*f*fd**2*s + 1120*D1**2*f*fd**2 - 132*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r*s + 132*D1**2*f*fd*r - 132*D1**2*f*fd*s**2 + 132*D1**2*f*fd*s - 66*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 660*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r - 330*D1**2*f*fdd*s**2 + 330*D1**2*f*fdd*s - 165*D1**2*f*fdd + 792*D1**2*f*gd2*r**2 + 1584*D1**2*f*gd2*r*s - 1584*D1**2*f*gd2*r + 792*D1**2*f*gd2*s**2 - 1584*D1**2*f*gd2*s + 792*D1**2*f*gd2 - 396*D1**2*f*gdd2*r**2 - 792*D1**2*f*gdd2*r*s + 792*D1**2*f*gdd2*r - 396*D1**2*f*gdd2*s**2 + 792*D1**2*f*gdd2*s - 396*D1**2*f*gdd2 - 330*D1**2*fd**2*r**2 - 660*D1**2*fd**2*r*s + 330*D1**2*fd**2*r - 330*D1**2*fd**2*s**2 + 330*D1**2*fd**2*s + 792*D1**2*fd*g2*r**2 + 1584*D1**2*fd*g2*r*s + 792*D1**2*fd*g2*s**2 - 792*D1**2*fd*gd2*r**2 - 1584*D1**2*fd*gd2*r*s + 792*D1**2*fd*gd2*r - 792*D1**2*fd*gd2*s**2 + 792*D1**2*fd*gd2*s - 396*D1**2*fdd*g2*r**2 - 792*D1**2*fdd*g2*r*s - 396*D1**2*fdd*g2*s**2 - 1320*D1*Dd*K*f**2*r**2 - 2640*D1*Dd*K*f**2*r*s + 1980*D1*Dd*K*f**2*r - 1320*D1*Dd*K*f**2*s**2 + 1980*D1*Dd*K*f**2*s - 990*D1*Dd*K*f**2 + 2640*D1*Dd*K*f*fd*r**2 + 5280*D1*Dd*K*f*fd*r*s - 3300*D1*Dd*K*f*fd*r + 2640*D1*Dd*K*f*fd*s**2 - 3300*D1*Dd*K*f*fd*s + 990*D1*Dd*K*f*fd - 3160*D1*Dd*f**3*r**2 - 6320*D1*Dd*f**3*r*s + 4740*D1*Dd*f**3*r - 3160*D1*Dd*f**3*s**2 + 4740*D1*Dd*f**3*s - 2370*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*r**2 + 26880*D1*Dd*f**2*fd*r*s - 19040*D1*Dd*f**2*fd*r + 13440*D1*Dd*f**2*fd*s**2 - 19040*D1*Dd*f**2*fd*s + 6720*D1*Dd*f**2*fd - 264*D1*Dd*f**2*r**2 - 528*D1*Dd*f**2*r*s + 396*D1*Dd*f**2*r - 264*D1*Dd*f**2*s**2 + 396*D1*Dd*f**2*s - 198*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 5280*D1*Dd*f*fd*r*s + 3300*D1*Dd*f*fd*r - 2640*D1*Dd*f*fd*s**2 + 3300*D1*Dd*f*fd*s - 990*D1*Dd*f*fd + 3168*D1*Dd*f*g2*r**2 + 6336*D1*Dd*f*g2*r*s - 4752*D1*Dd*f*g2*r + 3168*D1*Dd*f*g2*s**2 - 4752*D1*Dd*f*g2*s + 2376*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 6336*D1*Dd*f*gd2*r*s + 5544*D1*Dd*f*gd2*r - 3168*D1*Dd*f*gd2*s**2 + 5544*D1*Dd*f*gd2*s - 2376*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 6336*D1*Dd*fd*g2*r*s + 2376*D1*Dd*fd*g2*r - 3168*D1*Dd*fd*g2*s**2 + 2376*D1*Dd*fd*g2*s + 660*D1*Ddd*K*f**2*r**2 + 1320*D1*Ddd*K*f**2*r*s - 990*D1*Ddd*K*f**2*r + 660*D1*Ddd*K*f**2*s**2 - 990*D1*Ddd*K*f**2*s + 495*D1*Ddd*K*f**2 + 2240*D1*Ddd*f**3*r**2 + 4480*D1*Ddd*f**3*r*s - 3360*D1*Ddd*f**3*r + 2240*D1*Ddd*f**3*s**2 - 3360*D1*Ddd*f**3*s + 1680*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 - 1320*D1*Ddd*f**2*r*s + 990*D1*Ddd*f**2*r - 660*D1*Ddd*f**2*s**2 + 990*D1*Ddd*f**2*s - 495*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 3168*D1*Ddd*f*g2*r*s + 2376*D1*Ddd*f*g2*r - 1584*D1*Ddd*f*g2*s**2 + 2376*D1*Ddd*f*g2*s - 1188*D1*Ddd*f*g2 + 132*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 6*f*(K - 1)*(r + s - 1) + 6*fd*(K - 1)*(r + s)) - Dd*f*(-6*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 1980*Dd**2*K*f**2*r**2 + 3960*Dd**2*K*f**2*r*s - 2970*Dd**2*K*f**2*r + 1980*Dd**2*K*f**2*s**2 - 2970*Dd**2*K*f**2*s + 990*Dd**2*K*f**2 + 6720*Dd**2*f**3*r**2 + 13440*Dd**2*f**3*r*s - 10080*Dd**2*f**3*r + 6720*Dd**2*f**3*s**2 - 10080*Dd**2*f**3*s + 3360*Dd**2*f**3 - 1980*Dd**2*f**2*r**2 - 3960*Dd**2*f**2*r*s + 2970*Dd**2*f**2*r - 1980*Dd**2*f**2*s**2 + 2970*Dd**2*f**2*s - 990*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 9504*Dd**2*f*g2*r*s + 7128*Dd**2*f*g2*r - 4752*Dd**2*f*g2*s**2 + 7128*Dd**2*f*g2*s - 2376*Dd**2*f*g2))/(3003*d**2*k3**8) - D1**2*Pk1*Pk3*ct**6*k2**4*st**2*(80*C - 80)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 50*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 25*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 25*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**6) - 8*D1**2*Pk1*Pk3*ct**6*k2**4*(396*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-212*C*D1**2*f*fd*r**2 - 376*C*D1**2*f*fd*r*s + 148*C*D1**2*f*fd*r - 164*C*D1**2*f*fd*s**2 + 124*C*D1**2*f*fd*s - 62*C*D1**2*f*fd + 100*C*D1**2*f*fdd*r**2 + 248*C*D1**2*f*fdd*r*s - 104*C*D1**2*f*fdd*r + 148*C*D1**2*f*fdd*s**2 - 128*C*D1**2*f*fdd*s + 64*C*D1**2*f*fdd + 100*C*D1**2*fd**2*r**2 + 248*C*D1**2*fd**2*r*s - 104*C*D1**2*fd**2*r + 148*C*D1**2*fd**2*s**2 - 128*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 424*C*D1*Dd*f**2*r**2 - 752*C*D1*Dd*f**2*r*s + 588*C*D1*Dd*f**2*r - 328*C*D1*Dd*f**2*s**2 + 516*C*D1*Dd*f**2*s - 270*C*D1*Dd*f**2 + 800*C*D1*Dd*f*fd*r**2 + 1984*C*D1*Dd*f*fd*r*s - 1112*C*D1*Dd*f*fd*r + 1184*C*D1*Dd*f*fd*s**2 - 1352*C*D1*Dd*f*fd*s + 360*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*r**2 + 496*C*D1*Ddd*f**2*r*s - 348*C*D1*Ddd*f**2*r + 296*C*D1*Ddd*f**2*s**2 - 420*C*D1*Ddd*f**2*s + 198*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*r**2 + 1488*C*Dd**2*f**2*r*s - 1044*C*Dd**2*f**2*r + 888*C*Dd**2*f**2*s**2 - 1260*C*Dd**2*f**2*s + 396*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 228*D1**2*f*fd*r**2 + 428*D1**2*f*fd*r*s - 174*D1**2*f*fd*r + 200*D1**2*f*fd*s**2 - 160*D1**2*f*fd*s + 80*D1**2*f*fd - 120*D1**2*f*fdd*r**2 - 298*D1**2*f*fdd*r*s + 129*D1**2*f*fdd*r - 178*D1**2*f*fdd*s**2 + 158*D1**2*f*fdd*s - 79*D1**2*f*fdd - 120*D1**2*fd**2*r**2 - 298*D1**2*fd**2*r*s + 129*D1**2*fd**2*r - 178*D1**2*fd**2*s**2 + 158*D1**2*fd**2*s + 20*D1**2*fd**2 + 456*D1*Dd*f**2*r**2 + 856*D1*Dd*f**2*r*s - 656*D1*Dd*f**2*r + 400*D1*Dd*f**2*s**2 - 614*D1*Dd*f**2*s + 314*D1*Dd*f**2 - 960*D1*Dd*f*fd*r**2 - 2384*D1*Dd*f*fd*r*s + 1352*D1*Dd*f*fd*r - 1424*D1*Dd*f*fd*s**2 + 1642*D1*Dd*f*fd*s - 445*D1*Dd*f*fd - 240*D1*Ddd*f**2*r**2 - 596*D1*Ddd*f**2*r*s + 418*D1*Ddd*f**2*r - 356*D1*Ddd*f**2*s**2 + 505*D1*Ddd*f**2*s - 238*D1*Ddd*f**2 + 24*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 720*Dd**2*f**2*r**2 - 1788*Dd**2*f**2*r*s + 1254*Dd**2*f**2*r - 1068*Dd**2*f**2*s**2 + 1515*Dd**2*f**2*s - 476*Dd**2*f**2) + f*(-792*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(2*C*(25*r**2 + r*(62*s - 60) + 37*s**2 - 72*s + 30) - 60*r**2 + r*(140 - 149*s) - 89*s**2 + 169*s - 70) - 5*D1**2*(f*(fd*(C*(2697*r**2 + 6*r*(733*s - 544) + 1701*s**2 - 2600*s + 1466) - 2775*r**2 - 6*r*(797*s - 574) - 2007*s**2 + 2932*s - 1594) + fdd*(-C*(1299*r**2 + 6*r*(449*s - 294) + 1395*s**2 - 1828*s + 898) + 1437*r**2 + 6*r*(514*s - 331) + 1647*s**2 - 2126*s + 1028)) + 2*fd**2*(-C*(1299*r**2 + 6*r*(449*s - 294) + 1395*s**2 - 1828*s + 449) + 1437*r**2 + 6*r*(514*s - 331) + 1647*s**2 - 2126*s + 514)) - 33*D1*bd1*(D1*(2*f*(C*(53*r**2 + 94*r*s - 126*r + 41*s**2 - 114*s + 63) - 57*r**2 - 107*r*s + 134*r - 50*s**2 + 127*s - 67) + fd*(-8*C*(25*r**2 + 62*r*s - 43*r + 37*s**2 - 52*s + 18) + 240*r**2 + 596*r*s - 409*r + 356*s**2 - 496*s + 169)) + Dd*f*(-4*C*(100*r**2 + 248*r*s - 207*r + 148*s**2 - 249*s + 102) + 480*r**2 + 1192*r*s - 978*r + 712*s**2 - 1181*s + 478)) - 5*D1*f*(Dd*(f*(C*(3596*r**2 + 5864*r*s - 4730*r + 2268*s**2 - 3734*s + 2033) - 3700*r**2 - 6376*r*s + 5038*r - 2676*s**2 + 4270*s - 2263) - 2*fd*(C*(5196*r**2 + 10776*r*s - 7521*r + 5580*s**2 - 7793*s + 2710) - 5748*r**2 - 12336*r*s + 8493*r - 6588*s**2 + 9088*s - 3119)) + Ddd*f*(-C*(1732*r**2 + 3592*r*s - 2662*r + 1860*s**2 - 2758*s + 1363) + 1916*r**2 + 4112*r*s - 3014*r + 2196*s**2 - 3224*s + 1577)) - 10*Dd**2*f**2*(-C*(2598*r**2 + r*(5388*s - 3993) + 2790*s**2 - 4137*s + 1363) + 2874*r**2 + r*(6168*s - 4521) + 3294*s**2 - 4836*s + 1577)))/(693*d**2*k3**6) - D1**2*Pk1*Pk3*ct**6*k2**2*st**2*(40*C - 40)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + 2*D1*f*(50*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(2*s**2 - 2*s + 1)) - 50*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(231*d**2*k3**4) - 4*D1**2*Pk1*Pk3*ct**6*k2**2*(792*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 33*b1*(D1**2*(f*(-24*bdd1*s*(C - 1)*(2*r + 2*s - 1) - 2*fd*(C*(56*r*(2*s - 1) + 82*s**2 - 62*s + 41) - 65*r*(2*s - 1) - 110*s**2 + 90*s - 55) + fdd*(2*C*(44*r*s - 22*r + 74*s**2 - 64*s + 37) - 118*r*s + 59*r - 188*s**2 + 168*s - 94)) + fd**2*(4*C*(11*r*(2*s - 1) + 37*s**2 - 32*s - 5) - 59*r*(2*s - 1) - 188*s**2 + 168*s + 20)) - 24*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(-4*C*(56*r*(2*s - 1) + 82*s**2 - 110*s + 41) + 260*r*(2*s - 1) + 440*s**2 - 570*s + 220) + fd*(2*s - 1)*(4*C*(88*r + 148*s - 75) - 472*r - 752*s + 395)) + Ddd*f*(4*C*(44*r*s - 22*r + 74*s**2 - 85*s + 37) - 236*r*s + 118*r - 376*s**2 + 435*s - 188)) + Dd**2*f**2*(4*C*(66*r*(2*s - 1) + 222*s**2 - 255*s + 59) - 354*r*(2*s - 1) - 1128*s**2 + 1305*s - 306)) + f*(-792*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1**2*(f*(33*bdd1*s*(C*(44*r + 74*s - 64) - 59*r - 94*s + 79) - 5*fd*(C*(1004*r*(3*s - 1) + 2037*s**2 - 2362*s + 679) - 1086*r*(3*s - 1) - 2511*s**2 + 2760*s - 837) + 5*fdd*(C*(436*r*(3*s - 1) + 1563*s**2 - 1478*s + 521) - 510*r*(3*s - 1) - 1899*s**2 + 1776*s - 633)) + 10*fd**2*(C*(436*r*(3*s - 1) + 1563*s**2 - 1478*s + 218) - 510*r*(3*s - 1) - 1899*s**2 + 1776*s - 255)) - 33*D1*bd1*(D1*(2*f*s*(C*(56*r + 41*s - 76) - 65*r - 55*s + 85) + fd*(-4*C*(11*r*(4*s - 1) + 74*s**2 - 64*s + 16) + 59*r*(4*s - 1) + 376*s**2 - 326*s + 79)) + Dd*f*(-4*C*(22*r*(4*s - 1) + 148*s**2 - 149*s + 32) + 118*r*(4*s - 1) + 752*s**2 - 751*s + 158)) - 10*D1*f*(C*Ddd*f*(-436*r*(2*s - 1) - 1042*s**2 + 1260*s - 521) + Dd*f*(C*(1004*r*(2*s - 1) + 1358*s**2 - 1860*s + 679) - 1086*r*(2*s - 1) - 1674*s**2 + 2217*s - 837) + Dd*fd*(-4*C*(109*r*(12*s - 5) + 1563*s**2 - 1684*s + 424) + 510*r*(12*s - 5) + 7596*s**2 - 8115*s + 2031) + 3*Ddd*f*(170*r*(2*s - 1) + 422*s**2 - 507*s + 211)) + 30*Dd**2*f**2*(C*(436*r*(2*s - 1) + 1042*s**2 - 1260*s + 319) - 510*r*(2*s - 1) - 1266*s**2 + 1521*s - 381)))/(693*d**2*k3**4) - 8*D1**2*Pk1*Pk3*ct**6*(396*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + 33*b1*(D1**2*(f*(10*fd*(2*s**2 - 2*s + 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(C - 1)*(48*bd1 - 24*bdd1)) - 2*fd*s*(s - 1)*(24*bd1*(C - 1) + 5*fd)) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(24*bd1*s*(C - 1) + 5*fd*(2*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(-5*f*(fd*(112*C - 168)*(3*s**2 - 2*s + 1) - fdd*(56*C - 84)*(3*s**2 - 2*s + 1) + s**2*(-66*bd1 + 33*bdd1)) + 2*s*(-396*bd1**2*s*(C - 1) - 165*bd1*fd*(2*s - 1) + fd**2*(280*C - 420)*(3*s - 2))) - 20*D1*f*(Dd*f*(56*C - 84)*(2*s**2 - 2*s + 1) - Dd*(2*s - 1)*(-33*bd1*s + fd*(56*C - 84)*(3*s - 1)) - Ddd*f*(28*C - 42)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(560*C - 840)*(6*s**2 - 6*s + 1)))/(693*d**2*k3**2) - 4*D1**2*Pk1*Pk3*ct**6*k2**4*(1056*C*D1**2*b1*f*fd*r**2 + 66*C*D1**2*b1*f*fdd*r**2 + 66*C*D1**2*b1*fd**2*r**2 + 1824*C*D1**2*f**2*fd*r**2 - 1216*C*D1**2*f**2*fd*r + 608*C*D1**2*f**2*fd + 276*C*D1**2*f**2*fdd*r**2 - 184*C*D1**2*f**2*fdd*r + 92*C*D1**2*f**2*fdd + 552*C*D1**2*f*fd**2*r**2 - 368*C*D1**2*f*fd**2*r + 2112*C*D1*Dd*b1*f**2*r**2 - 1056*C*D1*Dd*b1*f**2*r + 528*C*D1*Dd*b1*f**2 + 528*C*D1*Dd*b1*f*fd*r**2 - 132*C*D1*Dd*b1*f*fd*r + 2432*C*D1*Dd*f**3*r**2 - 1216*C*D1*Dd*f**3*r + 608*C*D1*Dd*f**3 + 2208*C*D1*Dd*f**2*fd*r**2 - 1288*C*D1*Dd*f**2*fd*r + 184*C*D1*Dd*f**2*fd + 132*C*D1*Ddd*b1*f**2*r**2 - 66*C*D1*Ddd*b1*f**2*r + 33*C*D1*Ddd*b1*f**2 + 368*C*D1*Ddd*f**3*r**2 - 184*C*D1*Ddd*f**3*r + 92*C*D1*Ddd*f**3 + 396*C*Dd**2*b1*f**2*r**2 - 198*C*Dd**2*b1*f**2*r + 1104*C*Dd**2*f**3*r**2 - 552*C*Dd**2*f**3*r - 1188*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r - 396*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 396*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r + 33*D1**2*bdd1*f**2*(r - 1)*(C*(r - 1) - 6*r - 5*s + 6) - 2274*D1**2*f**2*fd*r**2 - 450*D1**2*f**2*fd*r*s + 1666*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s - 758*D1**2*f**2*fd - 546*D1**2*f**2*fdd*r**2 - 270*D1**2*f**2*fdd*r*s + 454*D1**2*f**2*fdd*r + 90*D1**2*f**2*fdd*s - 182*D1**2*f**2*fdd - 1092*D1**2*f*fd**2*r**2 - 540*D1**2*f*fd**2*r*s + 908*D1**2*f*fd**2*r + 180*D1**2*f*fd**2*s - 90*D1**2*f*fd**2 - 2376*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 1320*D1*Dd*b1*f**2*r + 66*D1*Dd*b1*f**2*s - 594*D1*Dd*b1*f**2 - 3168*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 2112*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd - 3032*D1*Dd*f**3*r**2 - 600*D1*Dd*f**3*r*s + 1816*D1*Dd*f**3*r + 150*D1*Dd*f**3*s - 758*D1*Dd*f**3 - 4368*D1*Dd*f**2*fd*r**2 - 2160*D1*Dd*f**2*fd*r*s + 3448*D1*Dd*f**2*fd*r + 630*D1*Dd*f**2*fd*s - 634*D1*Dd*f**2*fd - 792*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 726*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 198*D1*Ddd*b1*f**2 - 728*D1*Ddd*f**3*r**2 - 360*D1*Ddd*f**3*r*s + 544*D1*Ddd*f**3*r + 90*D1*Ddd*f**3*s - 182*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(2*f*(r - 1)*(8*C*(r - 1) - 9*r - s + 9) + fd*(r**2*(4*C - 24) + r*(-4*C - 20*s + 29) + 10*s - 5)) + Dd*f*(2*C*(4*r**2 - 5*r + 1) - 48*r**2 - 40*r*s + 70*r + 25*s - 22)) - 2376*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 2178*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 2184*Dd**2*f**3*r**2 - 1080*Dd**2*f**3*r*s + 1632*Dd**2*f**3*r + 270*Dd**2*f**3*s - 180*Dd**2*f**3)/(693*d**2*k1**2*k3**4) + 4*D1**2*Pk1*Pk3*ct**6*k2**2*(11*D1*bd1*f*(D1*(2*f*s*(r - 1) + 5*fd*(4*r*s - r - 2*s + 1)) + 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) + 11*b1*(D1*Dd*f*(4*f*r*(2*s - 1) - 2*f*s + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(D1*r*(2*s - 1)*(2*f*fd + 5*f*fdd + 5*fd**2) + 5*Ddd*f**2*(r*(4*s - 2) - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + 5*f*(2*D1*Dd*f*(5*f*(r*(4*s - 2) - s) + 3*fd*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(10*f*fd*(r*(3*s - 1) - s) + f*(11*bdd1*s*(r - 1) + 6*fdd*r*(3*s - 1) - 6*fdd*s) + 6*fd**2*(r*(6*s - 2) - 2*s + 1)) + 6*Ddd*f**2*(r*(4*s - 2) - s)) + 6*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(231*d**2*k1**2*k3**2) - 20*D1**2*Pk1*Pk3*ct**5*f*k2**7*st**2*(390*D1**2*b1*f*fd*r**2 + 780*D1**2*b1*f*fd*r*s - 520*D1**2*b1*f*fd*r + 390*D1**2*b1*f*fd*s**2 - 520*D1**2*b1*f*fd*s + 260*D1**2*b1*f*fd - 195*D1**2*b1*f*fdd*r**2 - 390*D1**2*b1*f*fdd*r*s + 260*D1**2*b1*f*fdd*r - 195*D1**2*b1*f*fdd*s**2 + 260*D1**2*b1*f*fdd*s - 130*D1**2*b1*f*fdd - 390*D1**2*b1*fd**2*r**2 - 780*D1**2*b1*fd**2*r*s + 520*D1**2*b1*fd**2*r - 390*D1**2*b1*fd**2*s**2 + 520*D1**2*b1*fd**2*s - 130*D1**2*b1*fd**2 - 65*D1**2*bdd1*f**2*(r + s - 1)**2 + 392*D1**2*f**2*fd*r**2 + 784*D1**2*f**2*fd*r*s - 588*D1**2*f**2*fd*r + 392*D1**2*f**2*fd*s**2 - 588*D1**2*f**2*fd*s + 294*D1**2*f**2*fd - 196*D1**2*f**2*fdd*r**2 - 392*D1**2*f**2*fdd*r*s + 294*D1**2*f**2*fdd*r - 196*D1**2*f**2*fdd*s**2 + 294*D1**2*f**2*fdd*s - 147*D1**2*f**2*fdd - 588*D1**2*f*fd**2*r**2 - 1176*D1**2*f*fd**2*r*s + 882*D1**2*f*fd**2*r - 588*D1**2*f*fd**2*s**2 + 882*D1**2*f*fd**2*s - 294*D1**2*f*fd**2 + 520*D1*Dd*b1*f**2*r**2 + 1040*D1*Dd*b1*f**2*r*s - 780*D1*Dd*b1*f**2*r + 520*D1*Dd*b1*f**2*s**2 - 780*D1*Dd*b1*f**2*s + 390*D1*Dd*b1*f**2 - 1560*D1*Dd*b1*f*fd*r**2 - 3120*D1*Dd*b1*f*fd*r*s + 2210*D1*Dd*b1*f*fd*r - 1560*D1*Dd*b1*f*fd*s**2 + 2210*D1*Dd*b1*f*fd*s - 780*D1*Dd*b1*f*fd + 392*D1*Dd*f**3*r**2 + 784*D1*Dd*f**3*r*s - 588*D1*Dd*f**3*r + 392*D1*Dd*f**3*s**2 - 588*D1*Dd*f**3*s + 294*D1*Dd*f**3 - 1568*D1*Dd*f**2*fd*r**2 - 3136*D1*Dd*f**2*fd*r*s + 2352*D1*Dd*f**2*fd*r - 1568*D1*Dd*f**2*fd*s**2 + 2352*D1*Dd*f**2*fd*s - 882*D1*Dd*f**2*fd - 260*D1*Ddd*b1*f**2*r**2 - 520*D1*Ddd*b1*f**2*r*s + 390*D1*Ddd*b1*f**2*r - 260*D1*Ddd*b1*f**2*s**2 + 390*D1*Ddd*b1*f**2*s - 195*D1*Ddd*b1*f**2 - 196*D1*Ddd*f**3*r**2 - 392*D1*Ddd*f**3*r*s + 294*D1*Ddd*f**3*r - 196*D1*Ddd*f**3*s**2 + 294*D1*Ddd*f**3*s - 147*D1*Ddd*f**3 + 130*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 780*Dd**2*b1*f**2*r**2 - 1560*Dd**2*b1*f**2*r*s + 1170*Dd**2*b1*f**2*r - 780*Dd**2*b1*f**2*s**2 + 1170*Dd**2*b1*f**2*s - 390*Dd**2*b1*f**2 - 588*Dd**2*f**3*r**2 - 1176*Dd**2*f**3*r*s + 882*Dd**2*f**3*r - 588*Dd**2*f**3*s**2 + 882*Dd**2*f**3*s - 294*Dd**2*f**3)/(143*d**2*k1*k3**8) - 10*D1**2*Pk1*Pk3*ct**5*f*k2**5*(2301*D1**2*b1*f*fd*r**2 - 507*D1**2*b1*f*fdd*r**2 - 1014*D1**2*b1*fd**2*r**2 - 169*D1**2*bdd1*f**2*(r - 1)**2 + 3356*D1**2*f**2*fd*r**2 - 1678*D1**2*f**2*fd*r + 839*D1**2*f**2*fd + 116*D1**2*f**2*fdd*r**2 - 58*D1**2*f**2*fdd*r + 29*D1**2*f**2*fdd + 348*D1**2*f*fd**2*r**2 - 174*D1**2*f*fd**2*r + 3068*D1*Dd*b1*f**2*r**2 - 1534*D1*Dd*b1*f**2*r + 767*D1*Dd*b1*f**2 - 4056*D1*Dd*b1*f*fd*r**2 + 1014*D1*Dd*b1*f*fd*r + 3356*D1*Dd*f**3*r**2 - 1678*D1*Dd*f**3*r + 839*D1*Dd*f**3 + 928*D1*Dd*f**2*fd*r**2 - 464*D1*Dd*f**2*fd*r + 58*D1*Dd*f**2*fd - 676*D1*Ddd*b1*f**2*r**2 + 338*D1*Ddd*b1*f**2*r - 169*D1*Ddd*b1*f**2 + 116*D1*Ddd*f**3*r**2 - 58*D1*Ddd*f**3*r + 29*D1*Ddd*f**3 + 13*D1*bd1*f*(r - 1)*(59*D1*f*(r - 1) - 78*D1*fd*r + 26*Dd*f*(1 - 4*r)) - 2028*Dd**2*b1*f**2*r**2 + 1014*Dd**2*b1*f**2*r + 348*Dd**2*f**3*r**2 - 174*Dd**2*f**3*r)/(9009*d**2*k1**3*k3**4) - 8*D1**2*Pk1*Pk3*ct**5*k1**3*k2**3*(13728*C*D1**2*b1*f*fd*r**2 + 27456*C*D1**2*b1*f*fd*r*s - 13728*C*D1**2*b1*f*fd*r + 13728*C*D1**2*b1*f*fd*s**2 - 13728*C*D1**2*b1*f*fd*s + 6864*C*D1**2*b1*f*fd - 13200*C*D1**2*b1*f*fdd*r**2 - 26400*C*D1**2*b1*f*fdd*r*s + 13200*C*D1**2*b1*f*fdd*r - 13200*C*D1**2*b1*f*fdd*s**2 + 13200*C*D1**2*b1*f*fdd*s - 6600*C*D1**2*b1*f*fdd - 13200*C*D1**2*b1*fd**2*r**2 - 26400*C*D1**2*b1*fd**2*r*s + 13200*C*D1**2*b1*fd**2*r - 13200*C*D1**2*b1*fd**2*s**2 + 13200*C*D1**2*b1*fd**2*s + 17760*C*D1**2*f**2*fd*r**2 + 35520*C*D1**2*f**2*fd*r*s - 23680*C*D1**2*f**2*fd*r + 17760*C*D1**2*f**2*fd*s**2 - 23680*C*D1**2*f**2*fd*s + 11840*C*D1**2*f**2*fd - 16800*C*D1**2*f**2*fdd*r**2 - 33600*C*D1**2*f**2*fdd*r*s + 22400*C*D1**2*f**2*fdd*r - 16800*C*D1**2*f**2*fdd*s**2 + 22400*C*D1**2*f**2*fdd*s - 11200*C*D1**2*f**2*fdd - 33600*C*D1**2*f*fd**2*r**2 - 67200*C*D1**2*f*fd**2*r*s + 44800*C*D1**2*f*fd**2*r - 33600*C*D1**2*f*fd**2*s**2 + 44800*C*D1**2*f*fd**2*s - 11200*C*D1**2*f*fd**2 + 27456*C*D1*Dd*b1*f**2*r**2 + 54912*C*D1*Dd*b1*f**2*r*s - 41184*C*D1*Dd*b1*f**2*r + 27456*C*D1*Dd*b1*f**2*s**2 - 41184*C*D1*Dd*b1*f**2*s + 20592*C*D1*Dd*b1*f**2 - 105600*C*D1*Dd*b1*f*fd*r**2 - 211200*C*D1*Dd*b1*f*fd*r*s + 132000*C*D1*Dd*b1*f*fd*r - 105600*C*D1*Dd*b1*f*fd*s**2 + 132000*C*D1*Dd*b1*f*fd*s - 39600*C*D1*Dd*b1*f*fd + 23680*C*D1*Dd*f**3*r**2 + 47360*C*D1*Dd*f**3*r*s - 35520*C*D1*Dd*f**3*r + 23680*C*D1*Dd*f**3*s**2 - 35520*C*D1*Dd*f**3*s + 17760*C*D1*Dd*f**3 - 134400*C*D1*Dd*f**2*fd*r**2 - 268800*C*D1*Dd*f**2*fd*r*s + 190400*C*D1*Dd*f**2*fd*r - 134400*C*D1*Dd*f**2*fd*s**2 + 190400*C*D1*Dd*f**2*fd*s - 67200*C*D1*Dd*f**2*fd - 26400*C*D1*Ddd*b1*f**2*r**2 - 52800*C*D1*Ddd*b1*f**2*r*s + 39600*C*D1*Ddd*b1*f**2*r - 26400*C*D1*Ddd*b1*f**2*s**2 + 39600*C*D1*Ddd*b1*f**2*s - 19800*C*D1*Ddd*b1*f**2 - 22400*C*D1*Ddd*f**3*r**2 - 44800*C*D1*Ddd*f**3*r*s + 33600*C*D1*Ddd*f**3*r - 22400*C*D1*Ddd*f**3*s**2 + 33600*C*D1*Ddd*f**3*s - 16800*C*D1*Ddd*f**3 - 79200*C*Dd**2*b1*f**2*r**2 - 158400*C*Dd**2*b1*f**2*r*s + 118800*C*Dd**2*b1*f**2*r - 79200*C*Dd**2*b1*f**2*s**2 + 118800*C*Dd**2*b1*f**2*s - 39600*C*Dd**2*b1*f**2 - 67200*C*Dd**2*f**3*r**2 - 134400*C*Dd**2*f**3*r*s + 100800*C*Dd**2*f**3*r - 67200*C*Dd**2*f**3*s**2 + 100800*C*Dd**2*f**3*s - 33600*C*Dd**2*f**3 - 9900*D1**2*b1*f*fd*r**2 - 19800*D1**2*b1*f*fd*r*s + 9900*D1**2*b1*f*fd*r - 9900*D1**2*b1*f*fd*s**2 + 9900*D1**2*b1*f*fd*s - 4950*D1**2*b1*f*fd + 9900*D1**2*b1*f*fdd*r**2 + 19800*D1**2*b1*f*fdd*r*s - 9900*D1**2*b1*f*fdd*r + 9900*D1**2*b1*f*fdd*s**2 - 9900*D1**2*b1*f*fdd*s + 4950*D1**2*b1*f*fdd + 9900*D1**2*b1*fd**2*r**2 + 19800*D1**2*b1*fd**2*r*s - 9900*D1**2*b1*fd**2*r + 9900*D1**2*b1*fd**2*s**2 - 9900*D1**2*b1*fd**2*s - 1650*D1**2*bdd1*f**2*(4*C - 3)*(r + s - 1)**2 - 12825*D1**2*f**2*fd*r**2 - 25650*D1**2*f**2*fd*r*s + 17100*D1**2*f**2*fd*r - 12825*D1**2*f**2*fd*s**2 + 17100*D1**2*f**2*fd*s - 8550*D1**2*f**2*fd + 12600*D1**2*f**2*fdd*r**2 + 25200*D1**2*f**2*fdd*r*s - 16800*D1**2*f**2*fdd*r + 12600*D1**2*f**2*fdd*s**2 - 16800*D1**2*f**2*fdd*s + 8400*D1**2*f**2*fdd + 25200*D1**2*f*fd**2*r**2 + 50400*D1**2*f*fd**2*r*s - 33600*D1**2*f*fd**2*r + 25200*D1**2*f*fd**2*s**2 - 33600*D1**2*f*fd**2*s + 8400*D1**2*f*fd**2 - 19800*D1*Dd*b1*f**2*r**2 - 39600*D1*Dd*b1*f**2*r*s + 29700*D1*Dd*b1*f**2*r - 19800*D1*Dd*b1*f**2*s**2 + 29700*D1*Dd*b1*f**2*s - 14850*D1*Dd*b1*f**2 + 79200*D1*Dd*b1*f*fd*r**2 + 158400*D1*Dd*b1*f*fd*r*s - 99000*D1*Dd*b1*f*fd*r + 79200*D1*Dd*b1*f*fd*s**2 - 99000*D1*Dd*b1*f*fd*s + 29700*D1*Dd*b1*f*fd - 17100*D1*Dd*f**3*r**2 - 34200*D1*Dd*f**3*r*s + 25650*D1*Dd*f**3*r - 17100*D1*Dd*f**3*s**2 + 25650*D1*Dd*f**3*s - 12825*D1*Dd*f**3 + 100800*D1*Dd*f**2*fd*r**2 + 201600*D1*Dd*f**2*fd*r*s - 142800*D1*Dd*f**2*fd*r + 100800*D1*Dd*f**2*fd*s**2 - 142800*D1*Dd*f**2*fd*s + 50400*D1*Dd*f**2*fd + 19800*D1*Ddd*b1*f**2*r**2 + 39600*D1*Ddd*b1*f**2*r*s - 29700*D1*Ddd*b1*f**2*r + 19800*D1*Ddd*b1*f**2*s**2 - 29700*D1*Ddd*b1*f**2*s + 14850*D1*Ddd*b1*f**2 + 16800*D1*Ddd*f**3*r**2 + 33600*D1*Ddd*f**3*r*s - 25200*D1*Ddd*f**3*r + 16800*D1*Ddd*f**3*s**2 - 25200*D1*Ddd*f**3*s + 12600*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(104*C - 75)*(r + s - 1) - D1*fd*(200*C - 150)*(2*r + 2*s - 1) - Dd*f*(200*C - 150)*(4*r + 4*s - 3)) + 59400*Dd**2*b1*f**2*r**2 + 118800*Dd**2*b1*f**2*r*s - 89100*Dd**2*b1*f**2*r + 59400*Dd**2*b1*f**2*s**2 - 89100*Dd**2*b1*f**2*s + 29700*Dd**2*b1*f**2 + 50400*Dd**2*f**3*r**2 + 100800*Dd**2*f**3*r*s - 75600*Dd**2*f**3*r + 50400*Dd**2*f**3*s**2 - 75600*Dd**2*f**3*s + 25200*Dd**2*f**3)/(231*d**2*k3**8) - 16*D1**2*Pk1*Pk3*ct**5*k1**3*k2*(66*b1*(D1**2*(f*(fd*(64*C - 43) + fdd*(35 - 50*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(35 - 50*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(64*C - 43)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(35 - 50*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(35 - 50*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(35 - 50*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(724*C - 487)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 14)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(392 - 560*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 66*D1*bd1*(D1*(f*s*(64*C - 43)*(r + s - 1) - fd*(50*C - 35)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(35 - 50*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(724*C - 487)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(560*C - 392)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(392 - 560*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(392 - 560*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**6) - D1**2*Pk1*Pk3*ct**5*k1**3*(320*C - 200)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 4*D1*f*(28*Dd*f*(2*s**2 - 2*s + 1) - Dd*(2*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(2*s**2 - 2*s + 1)) - 56*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k2*k3**4) - 4*D1**2*Pk1*Pk3*ct**5*k1*k2**5*st**2*(16896*C*D1**2*b1*f*fd*r**2 + 33792*C*D1**2*b1*f*fd*r*s - 16896*C*D1**2*b1*f*fd*r + 16896*C*D1**2*b1*f*fd*s**2 - 16896*C*D1**2*b1*f*fd*s + 8448*C*D1**2*b1*f*fd - 9240*C*D1**2*b1*f*fdd*r**2 - 18480*C*D1**2*b1*f*fdd*r*s + 9240*C*D1**2*b1*f*fdd*r - 9240*C*D1**2*b1*f*fdd*s**2 + 9240*C*D1**2*b1*f*fdd*s - 4620*C*D1**2*b1*f*fdd - 9240*C*D1**2*b1*fd**2*r**2 - 18480*C*D1**2*b1*fd**2*r*s + 9240*C*D1**2*b1*fd**2*r - 9240*C*D1**2*b1*fd**2*s**2 + 9240*C*D1**2*b1*fd**2*s + 18624*C*D1**2*f**2*fd*r**2 + 37248*C*D1**2*f**2*fd*r*s - 24832*C*D1**2*f**2*fd*r + 18624*C*D1**2*f**2*fd*s**2 - 24832*C*D1**2*f**2*fd*s + 12416*C*D1**2*f**2*fd - 10500*C*D1**2*f**2*fdd*r**2 - 21000*C*D1**2*f**2*fdd*r*s + 14000*C*D1**2*f**2*fdd*r - 10500*C*D1**2*f**2*fdd*s**2 + 14000*C*D1**2*f**2*fdd*s - 7000*C*D1**2*f**2*fdd - 21000*C*D1**2*f*fd**2*r**2 - 42000*C*D1**2*f*fd**2*r*s + 28000*C*D1**2*f*fd**2*r - 21000*C*D1**2*f*fd**2*s**2 + 28000*C*D1**2*f*fd**2*s - 7000*C*D1**2*f*fd**2 + 33792*C*D1*Dd*b1*f**2*r**2 + 67584*C*D1*Dd*b1*f**2*r*s - 50688*C*D1*Dd*b1*f**2*r + 33792*C*D1*Dd*b1*f**2*s**2 - 50688*C*D1*Dd*b1*f**2*s + 25344*C*D1*Dd*b1*f**2 - 73920*C*D1*Dd*b1*f*fd*r**2 - 147840*C*D1*Dd*b1*f*fd*r*s + 92400*C*D1*Dd*b1*f*fd*r - 73920*C*D1*Dd*b1*f*fd*s**2 + 92400*C*D1*Dd*b1*f*fd*s - 27720*C*D1*Dd*b1*f*fd + 24832*C*D1*Dd*f**3*r**2 + 49664*C*D1*Dd*f**3*r*s - 37248*C*D1*Dd*f**3*r + 24832*C*D1*Dd*f**3*s**2 - 37248*C*D1*Dd*f**3*s + 18624*C*D1*Dd*f**3 - 84000*C*D1*Dd*f**2*fd*r**2 - 168000*C*D1*Dd*f**2*fd*r*s + 119000*C*D1*Dd*f**2*fd*r - 84000*C*D1*Dd*f**2*fd*s**2 + 119000*C*D1*Dd*f**2*fd*s - 42000*C*D1*Dd*f**2*fd - 18480*C*D1*Ddd*b1*f**2*r**2 - 36960*C*D1*Ddd*b1*f**2*r*s + 27720*C*D1*Ddd*b1*f**2*r - 18480*C*D1*Ddd*b1*f**2*s**2 + 27720*C*D1*Ddd*b1*f**2*s - 13860*C*D1*Ddd*b1*f**2 - 14000*C*D1*Ddd*f**3*r**2 - 28000*C*D1*Ddd*f**3*r*s + 21000*C*D1*Ddd*f**3*r - 14000*C*D1*Ddd*f**3*s**2 + 21000*C*D1*Ddd*f**3*s - 10500*C*D1*Ddd*f**3 - 55440*C*Dd**2*b1*f**2*r**2 - 110880*C*Dd**2*b1*f**2*r*s + 83160*C*Dd**2*b1*f**2*r - 55440*C*Dd**2*b1*f**2*s**2 + 83160*C*Dd**2*b1*f**2*s - 27720*C*Dd**2*b1*f**2 - 42000*C*Dd**2*f**3*r**2 - 84000*C*Dd**2*f**3*r*s + 63000*C*Dd**2*f**3*r - 42000*C*Dd**2*f**3*s**2 + 63000*C*Dd**2*f**3*s - 21000*C*Dd**2*f**3 - 14916*D1**2*b1*f*fd*r**2 - 29832*D1**2*b1*f*fd*r*s + 14916*D1**2*b1*f*fd*r - 14916*D1**2*b1*f*fd*s**2 + 14916*D1**2*b1*f*fd*s - 7458*D1**2*b1*f*fd + 8250*D1**2*b1*f*fdd*r**2 + 16500*D1**2*b1*f*fdd*r*s - 8250*D1**2*b1*f*fdd*r + 8250*D1**2*b1*f*fdd*s**2 - 8250*D1**2*b1*f*fdd*s + 4125*D1**2*b1*f*fdd + 8250*D1**2*b1*fd**2*r**2 + 16500*D1**2*b1*fd**2*r*s - 8250*D1**2*b1*fd**2*r + 8250*D1**2*b1*fd**2*s**2 - 8250*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(28*C - 25)*(r + s - 1)**2 - 16374*D1**2*f**2*fd*r**2 - 32748*D1**2*f**2*fd*r*s + 21832*D1**2*f**2*fd*r - 16374*D1**2*f**2*fd*s**2 + 21832*D1**2*f**2*fd*s - 10916*D1**2*f**2*fd + 9375*D1**2*f**2*fdd*r**2 + 18750*D1**2*f**2*fdd*r*s - 12500*D1**2*f**2*fdd*r + 9375*D1**2*f**2*fdd*s**2 - 12500*D1**2*f**2*fdd*s + 6250*D1**2*f**2*fdd + 18750*D1**2*f*fd**2*r**2 + 37500*D1**2*f*fd**2*r*s - 25000*D1**2*f*fd**2*r + 18750*D1**2*f*fd**2*s**2 - 25000*D1**2*f*fd**2*s + 6250*D1**2*f*fd**2 - 29832*D1*Dd*b1*f**2*r**2 - 59664*D1*Dd*b1*f**2*r*s + 44748*D1*Dd*b1*f**2*r - 29832*D1*Dd*b1*f**2*s**2 + 44748*D1*Dd*b1*f**2*s - 22374*D1*Dd*b1*f**2 + 66000*D1*Dd*b1*f*fd*r**2 + 132000*D1*Dd*b1*f*fd*r*s - 82500*D1*Dd*b1*f*fd*r + 66000*D1*Dd*b1*f*fd*s**2 - 82500*D1*Dd*b1*f*fd*s + 24750*D1*Dd*b1*f*fd - 21832*D1*Dd*f**3*r**2 - 43664*D1*Dd*f**3*r*s + 32748*D1*Dd*f**3*r - 21832*D1*Dd*f**3*s**2 + 32748*D1*Dd*f**3*s - 16374*D1*Dd*f**3 + 75000*D1*Dd*f**2*fd*r**2 + 150000*D1*Dd*f**2*fd*r*s - 106250*D1*Dd*f**2*fd*r + 75000*D1*Dd*f**2*fd*s**2 - 106250*D1*Dd*f**2*fd*s + 37500*D1*Dd*f**2*fd + 16500*D1*Ddd*b1*f**2*r**2 + 33000*D1*Ddd*b1*f**2*r*s - 24750*D1*Ddd*b1*f**2*r + 16500*D1*Ddd*b1*f**2*s**2 - 24750*D1*Ddd*b1*f**2*s + 12375*D1*Ddd*b1*f**2 + 12500*D1*Ddd*f**3*r**2 + 25000*D1*Ddd*f**3*r*s - 18750*D1*Ddd*f**3*r + 12500*D1*Ddd*f**3*s**2 - 18750*D1*Ddd*f**3*s + 9375*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(128*C - 113)*(r + s - 1) - D1*fd*(140*C - 125)*(2*r + 2*s - 1) - Dd*f*(140*C - 125)*(4*r + 4*s - 3)) + 49500*Dd**2*b1*f**2*r**2 + 99000*Dd**2*b1*f**2*r*s - 74250*Dd**2*b1*f**2*r + 49500*Dd**2*b1*f**2*s**2 - 74250*Dd**2*b1*f**2*s + 24750*Dd**2*b1*f**2 + 37500*Dd**2*f**3*r**2 + 75000*Dd**2*f**3*r*s - 56250*Dd**2*f**3*r + 37500*Dd**2*f**3*s**2 - 56250*Dd**2*f**3*s + 18750*Dd**2*f**3)/(231*d**2*k3**8) + 8*D1**2*Pk1*Pk3*ct**5*k1*k2**5*(51480*C*D1**2*f**2*fd*r**2 + 102960*C*D1**2*f**2*fd*r*s - 68640*C*D1**2*f**2*fd*r + 51480*C*D1**2*f**2*fd*s**2 - 68640*C*D1**2*f**2*fd*s + 34320*C*D1**2*f**2*fd + 68640*C*D1*Dd*f**3*r**2 + 137280*C*D1*Dd*f**3*r*s - 102960*C*D1*Dd*f**3*r + 68640*C*D1*Dd*f**3*s**2 - 102960*C*D1*Dd*f**3*s + 51480*C*D1*Dd*f**3 + 12870*D1**2*K*bdd1*f**2*r**2 + 25740*D1**2*K*bdd1*f**2*r*s - 25740*D1**2*K*bdd1*f**2*r + 12870*D1**2*K*bdd1*f**2*s**2 - 25740*D1**2*K*bdd1*f**2*s + 12870*D1**2*K*bdd1*f**2 - 858*D1**2*bd1**2*f*(-36*K + 25*f + 30)*(r + s - 1)**2 + 9100*D1**2*bdd1*f**3*r**2 + 18200*D1**2*bdd1*f**3*r*s - 18200*D1**2*bdd1*f**3*r + 9100*D1**2*bdd1*f**3*s**2 - 18200*D1**2*bdd1*f**3*s + 9100*D1**2*bdd1*f**3 - 10725*D1**2*bdd1*f**2*r**2 - 21450*D1**2*bdd1*f**2*r*s + 21450*D1**2*bdd1*f**2*r - 10725*D1**2*bdd1*f**2*s**2 + 21450*D1**2*bdd1*f**2*s - 10725*D1**2*bdd1*f**2 - 30888*D1**2*bdd1*f*g2*r**2 - 61776*D1**2*bdd1*f*g2*r*s + 61776*D1**2*bdd1*f*g2*r - 30888*D1**2*bdd1*f*g2*s**2 + 61776*D1**2*bdd1*f*g2*s - 30888*D1**2*bdd1*f*g2 - 75040*D1**2*f**3*fd*r**2 - 150080*D1**2*f**3*fd*r*s + 112560*D1**2*f**3*fd*r - 75040*D1**2*f**3*fd*s**2 + 112560*D1**2*f**3*fd*s - 56280*D1**2*f**3*fd + 63000*D1**2*f**3*fdd*r**2 + 126000*D1**2*f**3*fdd*r*s - 94500*D1**2*f**3*fdd*r + 63000*D1**2*f**3*fdd*s**2 - 94500*D1**2*f**3*fdd*s + 47250*D1**2*f**3*fdd + 189000*D1**2*f**2*fd**2*r**2 + 378000*D1**2*f**2*fd**2*r*s - 283500*D1**2*f**2*fd**2*r + 189000*D1**2*f**2*fd**2*s**2 - 283500*D1**2*f**2*fd**2*s + 94500*D1**2*f**2*fd**2 - 45045*D1**2*f**2*fd*r**2 - 90090*D1**2*f**2*fd*r*s + 60060*D1**2*f**2*fd*r - 45045*D1**2*f**2*fd*s**2 + 60060*D1**2*f**2*fd*s - 30030*D1**2*f**2*fd + 41184*D1**2*f**2*gd2*r**2 + 82368*D1**2*f**2*gd2*r*s - 82368*D1**2*f**2*gd2*r + 41184*D1**2*f**2*gd2*s**2 - 82368*D1**2*f**2*gd2*s + 41184*D1**2*f**2*gd2 - 25740*D1**2*f**2*gdd2*r**2 - 51480*D1**2*f**2*gdd2*r*s + 51480*D1**2*f**2*gdd2*r - 25740*D1**2*f**2*gdd2*s**2 + 51480*D1**2*f**2*gdd2*s - 25740*D1**2*f**2*gdd2 + 82368*D1**2*f*fd*g2*r**2 + 164736*D1**2*f*fd*g2*r*s - 82368*D1**2*f*fd*g2*r + 82368*D1**2*f*fd*g2*s**2 - 82368*D1**2*f*fd*g2*s + 41184*D1**2*f*fd*g2 - 102960*D1**2*f*fd*gd2*r**2 - 205920*D1**2*f*fd*gd2*r*s + 154440*D1**2*f*fd*gd2*r - 102960*D1**2*f*fd*gd2*s**2 + 154440*D1**2*f*fd*gd2*s - 51480*D1**2*f*fd*gd2 - 51480*D1**2*f*fdd*g2*r**2 - 102960*D1**2*f*fdd*g2*r*s + 51480*D1**2*f*fdd*g2*r - 51480*D1**2*f*fdd*g2*s**2 + 51480*D1**2*f*fdd*g2*s - 25740*D1**2*f*fdd*g2 - 51480*D1**2*fd**2*g2*r**2 - 102960*D1**2*fd**2*g2*r*s + 51480*D1**2*fd**2*g2*r - 51480*D1**2*fd**2*g2*s**2 + 51480*D1**2*fd**2*g2*s - 75040*D1*Dd*f**4*r**2 - 150080*D1*Dd*f**4*r*s + 112560*D1*Dd*f**4*r - 75040*D1*Dd*f**4*s**2 + 112560*D1*Dd*f**4*s - 56280*D1*Dd*f**4 + 504000*D1*Dd*f**3*fd*r**2 + 1008000*D1*Dd*f**3*fd*r*s - 756000*D1*Dd*f**3*fd*r + 504000*D1*Dd*f**3*fd*s**2 - 756000*D1*Dd*f**3*fd*s + 283500*D1*Dd*f**3*fd - 60060*D1*Dd*f**3*r**2 - 120120*D1*Dd*f**3*r*s + 90090*D1*Dd*f**3*r - 60060*D1*Dd*f**3*s**2 + 90090*D1*Dd*f**3*s - 45045*D1*Dd*f**3 + 164736*D1*Dd*f**2*g2*r**2 + 329472*D1*Dd*f**2*g2*r*s - 247104*D1*Dd*f**2*g2*r + 164736*D1*Dd*f**2*g2*s**2 - 247104*D1*Dd*f**2*g2*s + 123552*D1*Dd*f**2*g2 - 205920*D1*Dd*f**2*gd2*r**2 - 411840*D1*Dd*f**2*gd2*r*s + 360360*D1*Dd*f**2*gd2*r - 205920*D1*Dd*f**2*gd2*s**2 + 360360*D1*Dd*f**2*gd2*s - 154440*D1*Dd*f**2*gd2 - 411840*D1*Dd*f*fd*g2*r**2 - 823680*D1*Dd*f*fd*g2*r*s + 514800*D1*Dd*f*fd*g2*r - 411840*D1*Dd*f*fd*g2*s**2 + 514800*D1*Dd*f*fd*g2*s - 154440*D1*Dd*f*fd*g2 + 63000*D1*Ddd*f**4*r**2 + 126000*D1*Ddd*f**4*r*s - 94500*D1*Ddd*f**4*r + 63000*D1*Ddd*f**4*s**2 - 94500*D1*Ddd*f**4*s + 47250*D1*Ddd*f**4 - 102960*D1*Ddd*f**2*g2*r**2 - 205920*D1*Ddd*f**2*g2*r*s + 154440*D1*Ddd*f**2*g2*r - 102960*D1*Ddd*f**2*g2*s**2 + 154440*D1*Ddd*f**2*g2*s - 77220*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(575*f**3*(r + s - 1) - 4*f**2*(396*C*(r + s - 1) + 350*fd*(3*r + 3*s - 2) - (396*K + 33)*(r + s - 1)) - 66*f*(5*fd*(6*K - 5)*(2*r + 2*s - 1) + (58*g2 - 72*gd2)*(r + s - 1)) + 4752*fd*g2*(r + s)) - 2*Dd*f*(700*f**2 + 165*f*(6*K - 5) - 2376*g2)*(4*r + 4*s - 3))*(r + s - 1) + 189000*Dd**2*f**4*r**2 + 378000*Dd**2*f**4*r*s - 283500*Dd**2*f**4*r + 189000*Dd**2*f**4*s**2 - 283500*Dd**2*f**4*s + 94500*Dd**2*f**4 - 308880*Dd**2*f**2*g2*r**2 - 617760*Dd**2*f**2*g2*r*s + 463320*Dd**2*f**2*g2*r - 308880*Dd**2*f**2*g2*s**2 + 463320*Dd**2*f**2*g2*s - 154440*Dd**2*f**2*g2 + 429*b1**2*(D1**2*(f*(38*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(25*fd**2*(r + s - 1) + fd*(29*K - 23)*(r + s) - 3*fdd*(6*K - 5)*(r + s))) + D1*(2*Dd*(19*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(25*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (29*K - 23)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(6*K - 5)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-36*K + 25*f + 30)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-36*K + 25*f + 30)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(3168*C*D1**2*f*fd*r**2 + 6336*C*D1**2*f*fd*r*s - 3168*C*D1**2*f*fd*r + 3168*C*D1**2*f*fd*s**2 - 3168*C*D1**2*f*fd*s + 1584*C*D1**2*f*fd + 6336*C*D1*Dd*f**2*r**2 + 12672*C*D1*Dd*f**2*r*s - 9504*C*D1*Dd*f**2*r + 6336*C*D1*Dd*f**2*s**2 - 9504*C*D1*Dd*f**2*s + 4752*C*D1*Dd*f**2 - 3168*D1**2*K*f*fd*r**2 - 6336*D1**2*K*f*fd*r*s + 3168*D1**2*K*f*fd*r - 3168*D1**2*K*f*fd*s**2 + 3168*D1**2*K*f*fd*s - 1584*D1**2*K*f*fd + 1980*D1**2*K*f*fdd*r**2 + 3960*D1**2*K*f*fdd*r*s - 1980*D1**2*K*f*fdd*r + 1980*D1**2*K*f*fdd*s**2 - 1980*D1**2*K*f*fdd*s + 990*D1**2*K*f*fdd + 1980*D1**2*K*fd**2*r**2 + 3960*D1**2*K*fd**2*r*s - 1980*D1**2*K*fd**2*r + 1980*D1**2*K*fd**2*s**2 - 1980*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(-36*K + 25*f + 30)*(r + s - 1)**2 - 1725*D1**2*f**2*fd*r**2 - 3450*D1**2*f**2*fd*r*s + 2300*D1**2*f**2*fd*r - 1725*D1**2*f**2*fd*s**2 + 2300*D1**2*f**2*fd*s - 1150*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd - 1650*D1**2*f*fdd*r**2 - 3300*D1**2*f*fdd*r*s + 1650*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1650*D1**2*f*fdd*s - 825*D1**2*f*fdd + 3828*D1**2*f*gd2*r**2 + 7656*D1**2*f*gd2*r*s - 7656*D1**2*f*gd2*r + 3828*D1**2*f*gd2*s**2 - 7656*D1**2*f*gd2*s + 3828*D1**2*f*gd2 - 2376*D1**2*f*gdd2*r**2 - 4752*D1**2*f*gdd2*r*s + 4752*D1**2*f*gdd2*r - 2376*D1**2*f*gdd2*s**2 + 4752*D1**2*f*gdd2*s - 2376*D1**2*f*gdd2 - 1650*D1**2*fd**2*r**2 - 3300*D1**2*fd**2*r*s + 1650*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1650*D1**2*fd**2*s + 3828*D1**2*fd*g2*r**2 + 7656*D1**2*fd*g2*r*s + 3828*D1**2*fd*g2*s**2 - 4752*D1**2*fd*gd2*r**2 - 9504*D1**2*fd*gd2*r*s + 4752*D1**2*fd*gd2*r - 4752*D1**2*fd*gd2*s**2 + 4752*D1**2*fd*gd2*s - 2376*D1**2*fdd*g2*r**2 - 4752*D1**2*fdd*g2*r*s - 2376*D1**2*fdd*g2*s**2 - 6336*D1*Dd*K*f**2*r**2 - 12672*D1*Dd*K*f**2*r*s + 9504*D1*Dd*K*f**2*r - 6336*D1*Dd*K*f**2*s**2 + 9504*D1*Dd*K*f**2*s - 4752*D1*Dd*K*f**2 + 15840*D1*Dd*K*f*fd*r**2 + 31680*D1*Dd*K*f*fd*r*s - 19800*D1*Dd*K*f*fd*r + 15840*D1*Dd*K*f*fd*s**2 - 19800*D1*Dd*K*f*fd*s + 5940*D1*Dd*K*f*fd - 2300*D1*Dd*f**3*r**2 - 4600*D1*Dd*f**3*r*s + 3450*D1*Dd*f**3*r - 2300*D1*Dd*f**3*s**2 + 3450*D1*Dd*f**3*s - 1725*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 23800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 23800*D1*Dd*f**2*fd*s + 8400*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 - 13200*D1*Dd*f*fd*r**2 - 26400*D1*Dd*f*fd*r*s + 16500*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 16500*D1*Dd*f*fd*s - 4950*D1*Dd*f*fd + 15312*D1*Dd*f*g2*r**2 + 30624*D1*Dd*f*g2*r*s - 22968*D1*Dd*f*g2*r + 15312*D1*Dd*f*g2*s**2 - 22968*D1*Dd*f*g2*s + 11484*D1*Dd*f*g2 - 19008*D1*Dd*f*gd2*r**2 - 38016*D1*Dd*f*gd2*r*s + 33264*D1*Dd*f*gd2*r - 19008*D1*Dd*f*gd2*s**2 + 33264*D1*Dd*f*gd2*s - 14256*D1*Dd*f*gd2 - 19008*D1*Dd*fd*g2*r**2 - 38016*D1*Dd*fd*g2*r*s + 14256*D1*Dd*fd*g2*r - 19008*D1*Dd*fd*g2*s**2 + 14256*D1*Dd*fd*g2*s + 3960*D1*Ddd*K*f**2*r**2 + 7920*D1*Ddd*K*f**2*r*s - 5940*D1*Ddd*K*f**2*r + 3960*D1*Ddd*K*f**2*s**2 - 5940*D1*Ddd*K*f**2*s + 2970*D1*Ddd*K*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 - 3300*D1*Ddd*f**2*r**2 - 6600*D1*Ddd*f**2*r*s + 4950*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 4950*D1*Ddd*f**2*s - 2475*D1*Ddd*f**2 - 9504*D1*Ddd*f*g2*r**2 - 19008*D1*Ddd*f*g2*r*s + 14256*D1*Ddd*f*g2*r - 9504*D1*Ddd*f*g2*s**2 + 14256*D1*Ddd*f*g2*s - 7128*D1*Ddd*f*g2 + 132*D1*bd1*(D1*(19*f**2*(r + s - 1) - 25*f*fd*(2*r + 2*s - 1) - f*(29*K - 23)*(r + s - 1) + 6*fd*(6*K - 5)*(r + s)) - Dd*f*(-36*K + 25*f + 30)*(4*r + 4*s - 3))*(r + s - 1) + 11880*Dd**2*K*f**2*r**2 + 23760*Dd**2*K*f**2*r*s - 17820*Dd**2*K*f**2*r + 11880*Dd**2*K*f**2*s**2 - 17820*Dd**2*K*f**2*s + 5940*Dd**2*K*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3 - 9900*Dd**2*f**2*r**2 - 19800*Dd**2*f**2*r*s + 14850*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 14850*Dd**2*f**2*s - 4950*Dd**2*f**2 - 28512*Dd**2*f*g2*r**2 - 57024*Dd**2*f*g2*r*s + 42768*Dd**2*f*g2*r - 28512*Dd**2*f*g2*s**2 + 42768*Dd**2*f*g2*s - 14256*Dd**2*f*g2))/(3003*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**5*k1*k2**3*st**2*(33*b1*(D1**2*(f*(fd*(76*C - 66) + fdd*(35 - 40*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(35 - 40*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(76*C - 66)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(35 - 40*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(35 - 40*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(35 - 40*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(1868*C - 1618)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (40*C - 35)*(33*bdd1*s*(r + s - 1) + 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(875 - 1000*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(76*C - 66)*(r + s - 1) - fd*(40*C - 35)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(35 - 40*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(1868*C - 1618)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(1000*C - 875)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(875 - 1000*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(875 - 1000*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**5*k1*k2**3*(132*b1**2*(D1**2*(fd*(34*C - 28) + fdd*(21 - 24*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(17*C - 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(21 - 24*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(21 - 24*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(144*C - 126)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(-416*C*D1**2*f*fd*r**2 - 1120*C*D1**2*f*fd*r*s + 448*C*D1**2*f*fd*r - 704*C*D1**2*f*fd*s**2 + 592*C*D1**2*f*fd*s - 296*C*D1**2*f*fd + 400*C*D1**2*f*fdd*r**2 + 1040*C*D1**2*f*fdd*r*s - 440*C*D1**2*f*fdd*r + 640*C*D1**2*f*fdd*s**2 - 560*C*D1**2*f*fdd*s + 280*C*D1**2*f*fdd + 400*C*D1**2*fd**2*r**2 + 1040*C*D1**2*fd**2*r*s - 440*C*D1**2*fd**2*r + 640*C*D1**2*fd**2*s**2 - 560*C*D1**2*fd**2*s - 80*C*D1**2*fd**2 - 832*C*D1*Dd*f**2*r**2 - 2240*C*D1*Dd*f**2*r*s + 1536*C*D1*Dd*f**2*r - 1408*C*D1*Dd*f**2*s**2 + 1968*C*D1*Dd*f**2*s - 912*C*D1*Dd*f**2 + 3200*C*D1*Dd*f*fd*r**2 + 8320*C*D1*Dd*f*fd*r*s - 4640*C*D1*Dd*f*fd*r + 5120*C*D1*Dd*f*fd*s**2 - 5840*C*D1*Dd*f*fd*s + 1560*C*D1*Dd*f*fd + 800*C*D1*Ddd*f**2*r**2 + 2080*C*D1*Ddd*f**2*r*s - 1440*C*D1*Ddd*f**2*r + 1280*C*D1*Ddd*f**2*s**2 - 1800*C*D1*Ddd*f**2*s + 840*C*D1*Ddd*f**2 + 2400*C*Dd**2*f**2*r**2 + 6240*C*Dd**2*f**2*r*s - 4320*C*Dd**2*f**2*r + 3840*C*Dd**2*f**2*s**2 - 5400*C*Dd**2*f**2*s + 1680*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(8*C - 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 358*D1**2*f*fd*r**2 + 1012*D1**2*f*fd*r*s - 414*D1**2*f*fd*r + 654*D1**2*f*fd*s**2 - 562*D1**2*f*fd*s + 281*D1**2*f*fd - 350*D1**2*f*fdd*r**2 - 956*D1**2*f*fdd*r*s + 408*D1**2*f*fdd*r - 606*D1**2*f*fdd*s**2 + 536*D1**2*f*fdd*s - 268*D1**2*f*fdd - 350*D1**2*fd**2*r**2 - 956*D1**2*fd**2*r*s + 408*D1**2*fd**2*r - 606*D1**2*fd**2*s**2 + 536*D1**2*fd**2*s + 70*D1**2*fd**2 + 716*D1*Dd*f**2*r**2 + 2024*D1*Dd*f**2*r*s - 1370*D1*Dd*f**2*r + 1308*D1*Dd*f**2*s**2 - 1814*D1*Dd*f**2*s + 833*D1*Dd*f**2 - 2800*D1*Dd*f*fd*r**2 - 7648*D1*Dd*f*fd*r*s + 4244*D1*Dd*f*fd*r - 4848*D1*Dd*f*fd*s**2 + 5524*D1*Dd*f*fd*s - 1480*D1*Dd*f*fd - 700*D1*Ddd*f**2*r**2 - 1912*D1*Ddd*f**2*r*s + 1306*D1*Ddd*f**2*r - 1212*D1*Ddd*f**2*s**2 + 1690*D1*Ddd*f**2*s - 781*D1*Ddd*f**2 + 4*D1*bd1*(D1*(f*(17*C - 14)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(21 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(21 - 24*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2100*Dd**2*f**2*r**2 - 5736*Dd**2*f**2*r*s + 3918*Dd**2*f**2*r - 3636*Dd**2*f**2*s**2 + 5070*Dd**2*f**2*s - 1562*Dd**2*f**2) + f*(-792*D1**2*bd1**2*(8*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 66*D1**2*bdd1*f*(40*C*(5*r**2 + r*(13*s - 12) + 8*s**2 - 15*s + 6) - 175*r**2 + r*(420 - 478*s) - 303*s**2 + 548*s - 210) - 5*D1**2*(f*(fd*(56*C*(201*r**2 + 6*r*(74*s - 47) + 243*s**2 - 310*s + 148) - 9471*r**2 + r*(13624 - 21930*s) - 12459*s**2 + 15616*s - 7310) + fdd*(-8*C*(1149*r**2 + 3*r*(881*s - 549) + 1494*s**2 - 1877*s + 881) + 7953*r**2 + 2*r*(9591*s - 5848) + 11229*s**2 - 13880*s + 6394)) + 2*fd**2*(-4*C*(2298*r**2 + 6*r*(881*s - 549) + 2988*s**2 - 3754*s + 881) + 7953*r**2 + 2*r*(9591*s - 5848) + 11229*s**2 - 13880*s + 3197)) - 66*D1*bd1*(D1*(f*(8*C*(26*r**2 + 70*r*s - 66*r + 44*s**2 - 84*s + 33) - 179*r**2 - 506*r*s + 450*r - 327*s**2 + 598*s - 225) - 4*fd*(10*C*(20*r**2 + 52*r*s - 35*r + 32*s**2 - 44*s + 15) - 175*r**2 - 478*r*s + 312*r - 303*s**2 + 408*s - 137)) - 2*Dd*f*(20*C*(40*r**2 + 104*r*s - 84*r + 64*s**2 - 105*s + 42) - 700*r**2 - 1912*r*s + 1493*r - 1212*s**2 + 1941*s - 758)) - 5*D1*f*(Dd*(f*(56*C*(268*r**2 + 592*r*s - 430*r + 324*s**2 - 472*s + 229) - 12628*r**2 - 29240*r*s + 20934*r - 16612*s**2 + 23922*s - 11463) - 2*fd*(4*C*(9192*r**2 + 21144*r*s - 14172*r + 11952*s**2 - 16127*s + 5401) - 31812*r**2 - 76728*r*s + 50527*r - 44916*s**2 + 59809*s - 19728)) + Ddd*f*(-8*C*(1532*r**2 + 4*r*(881*s - 632) + 1992*s**2 - 2873*s + 1379) + 10604*r**2 + 25576*r*s - 18090*r + 14972*s**2 - 21366*s + 10137)) - 10*Dd**2*f**2*(-4*C*(4596*r**2 + 12*r*(881*s - 632) + 5976*s**2 - 8619*s + 2758) + 15906*r**2 + 3*r*(12788*s - 9045) + 22458*s**2 - 32049*s + 10137)))/(693*d**2*k3**6) - D1**2*Pk1*Pk3*ct**5*k1*k2*st**2*(400*C - 340)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + 2*D1*f*(50*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(2*s**2 - 2*s + 1)) - 50*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k3**4) - 2*D1**2*Pk1*Pk3*ct**5*k1*k2*(264*b1**2*(D1**2*(s - 1)*(fd*(29*C - 23) + fdd*(15 - 18*C))*(r + s - 1) + D1*(Dd*(f*(29*C - 23)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(18*C - 15)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(15 - 18*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(18*C - 15)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 66*b1*(D1**2*(f*(12*C*fdd*(11*r*(2*s - 1) + 42*s**2 - 37*s + 21) - 12*bdd1*s*(6*C - 5)*(2*r + 2*s - 1) + fd*(-96*C*(r*(4*s - 2) + 6*s**2 - 5*s + 3) + 160*r*(2*s - 1) + 518*s**2 - 442*s + 259) - 10*fdd*(11*r*(2*s - 1) + 46*s**2 - 41*s + 23)) + 2*fd**2*(6*C*(11*r*(2*s - 1) + 42*s**2 - 37*s - 5) + 5*r*(11 - 22*s) - 230*s**2 + 205*s + 25)) + 4*D1*bd1*(D1*(f*s*(29*C - 23)*(2*r + 2*s - 1) - fd*(18*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(30 - 36*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(-6*C*Ddd*f*(22*r*(2*s - 1) + 84*s**2 - 95*s + 42) + Dd*f*(96*C*(r*(4*s - 2) + 6*s**2 - 7*s + 3) - 160*r*(2*s - 1) - 518*s**2 + 598*s - 259) - Dd*fd*(2*s - 1)*(6*C*(88*r + 168*s - 85) - 440*r - 920*s + 465) + 5*Ddd*f*(22*r*(2*s - 1) + 92*s**2 - 103*s + 46)) + 2*Dd**2*f**2*(6*C*(66*r*(2*s - 1) + 252*s**2 - 285*s + 64) - 330*r*(2*s - 1) - 1380*s**2 + 1545*s - 340)) + f*(-792*D1**2*bd1**2*s*(6*C - 5)*(2*r + 2*s - 1) + D1**2*(f*(132*bdd1*s*(6*C*(11*r + 21*s - 16) - 55*r - 115*s + 80) - 5*fd*(48*C*(77*r*(3*s - 1) + 267*s**2 - 255*s + 89) - 2996*r*(3*s - 1) - 11193*s**2 + 10458*s - 3731) + 5*fdd*(216*C*(11*r*(3*s - 1) + 48*s**2 - 43*s + 16) - 1960*r*(3*s - 1) - 9309*s**2 + 8166*s - 3103)) + 10*fd**2*(108*C*(22*r*(3*s - 1) + 96*s**2 - 86*s + 11) - 1960*r*(3*s - 1) - 9309*s**2 + 8166*s - 980)) - 66*D1*bd1*(-12*C*Dd*f*(22*r*(4*s - 1) + 168*s**2 - 159*s + 32) + D1*f*s*(96*C*(2*r + 3*s - 3) - 160*r - 259*s + 236) - 2*D1*fd*(6*C*(11*r*(4*s - 1) + 84*s**2 - 69*s + 16) - 55*r*(4*s - 1) - 460*s**2 + 365*s - 80) + 10*Dd*f*(22*r*(4*s - 1) + 184*s**2 - 167*s + 32)) - 10*D1*f*(Dd*(f*(24*C*(154*r*(2*s - 1) + 356*s**2 - 433*s + 178) - 2996*r*(2*s - 1) - 7462*s**2 + 8960*s - 3731) + 2*fd*(-54*C*(22*r*(12*s - 5) + 384*s**2 - 397*s + 97) + 980*r*(12*s - 5) + 18618*s**2 - 18945*s + 4573)) + Ddd*f*(-108*C*(22*r*(2*s - 1) + 64*s**2 - 75*s + 32) + 1960*r*(2*s - 1) + 6206*s**2 - 7186*s + 3103)) + 10*Dd**2*f**2*(324*C*(22*r*(2*s - 1) + 64*s**2 - 75*s + 18) - 5880*r*(2*s - 1) - 18618*s**2 + 21558*s - 5063)))/(693*d**2*k3**4) - D1**2*Pk1*Pk3*ct**5*k1*(64*C - 48)*(198*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s))) + 99*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) - 2*f*(D1**2*(35*f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + s*(99*bd1**2*s - 70*fd**2*(3*s - 2))) + 70*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 70*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k2*k3**2) + 4*D1**2*Pk1*Pk3*ct**5*k2**5*st**2*(4224*C*D1**2*b1*f*fd*r**2 + 4224*C*D1**2*b1*f*fd*r*s - 2112*C*D1**2*b1*f*fd*r - 1320*C*D1**2*b1*f*fdd*r**2 - 1320*C*D1**2*b1*f*fdd*r*s + 660*C*D1**2*b1*f*fdd*r - 1320*C*D1**2*b1*fd**2*r**2 - 1320*C*D1**2*b1*fd**2*r*s + 660*C*D1**2*b1*fd**2*r + 5712*C*D1**2*f**2*fd*r**2 + 5712*C*D1**2*f**2*fd*r*s - 5712*C*D1**2*f**2*fd*r - 1904*C*D1**2*f**2*fd*s + 1904*C*D1**2*f**2*fd - 2460*C*D1**2*f**2*fdd*r**2 - 2460*C*D1**2*f**2*fdd*r*s + 2460*C*D1**2*f**2*fdd*r + 820*C*D1**2*f**2*fdd*s - 820*C*D1**2*f**2*fdd - 4920*C*D1**2*f*fd**2*r**2 - 4920*C*D1**2*f*fd**2*r*s + 4920*C*D1**2*f*fd**2*r + 1640*C*D1**2*f*fd**2*s - 820*C*D1**2*f*fd**2 + 8448*C*D1*Dd*b1*f**2*r**2 + 8448*C*D1*Dd*b1*f**2*r*s - 8448*C*D1*Dd*b1*f**2*r - 2112*C*D1*Dd*b1*f**2*s + 2112*C*D1*Dd*b1*f**2 - 10560*C*D1*Dd*b1*f*fd*r**2 - 10560*C*D1*Dd*b1*f*fd*r*s + 7920*C*D1*Dd*b1*f*fd*r + 1320*C*D1*Dd*b1*f*fd*s - 660*C*D1*Dd*b1*f*fd + 7616*C*D1*Dd*f**3*r**2 + 7616*C*D1*Dd*f**3*r*s - 7616*C*D1*Dd*f**3*r - 1904*C*D1*Dd*f**3*s + 1904*C*D1*Dd*f**3 - 19680*C*D1*Dd*f**2*fd*r**2 - 19680*C*D1*Dd*f**2*fd*r*s + 19680*C*D1*Dd*f**2*fd*r + 5740*C*D1*Dd*f**2*fd*s - 4100*C*D1*Dd*f**2*fd - 2640*C*D1*Ddd*b1*f**2*r**2 - 2640*C*D1*Ddd*b1*f**2*r*s + 2640*C*D1*Ddd*b1*f**2*r + 660*C*D1*Ddd*b1*f**2*s - 660*C*D1*Ddd*b1*f**2 - 3280*C*D1*Ddd*f**3*r**2 - 3280*C*D1*Ddd*f**3*r*s + 3280*C*D1*Ddd*f**3*r + 820*C*D1*Ddd*f**3*s - 820*C*D1*Ddd*f**3 - 7920*C*Dd**2*b1*f**2*r**2 - 7920*C*Dd**2*b1*f**2*r*s + 7920*C*Dd**2*b1*f**2*r + 1980*C*Dd**2*b1*f**2*s - 1320*C*Dd**2*b1*f**2 - 9840*C*Dd**2*f**3*r**2 - 9840*C*Dd**2*f**3*r*s + 9840*C*Dd**2*f**3*r + 2460*C*Dd**2*f**3*s - 1640*C*Dd**2*f**3 - 6204*D1**2*b1*f*fd*r**2 - 8184*D1**2*b1*f*fd*r*s + 4092*D1**2*b1*f*fd*r - 1980*D1**2*b1*f*fd*s**2 + 1980*D1**2*b1*f*fd*s - 990*D1**2*b1*f*fd + 2310*D1**2*b1*f*fdd*r**2 + 3300*D1**2*b1*f*fdd*r*s - 1650*D1**2*b1*f*fdd*r + 990*D1**2*b1*f*fdd*s**2 - 990*D1**2*b1*f*fdd*s + 495*D1**2*b1*f*fdd + 2310*D1**2*b1*fd**2*r**2 + 3300*D1**2*b1*fd**2*r*s - 1650*D1**2*b1*fd**2*r + 990*D1**2*b1*fd**2*s**2 - 990*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)*(4*C*(r - 1) - 7*r - 3*s + 7) - 7962*D1**2*f**2*fd*r**2 - 10212*D1**2*f**2*fd*r*s + 8712*D1**2*f**2*fd*r - 2250*D1**2*f**2*fd*s**2 + 4904*D1**2*f**2*fd*s - 3404*D1**2*f**2*fd + 3585*D1**2*f**2*fdd*r**2 + 4710*D1**2*f**2*fdd*r*s - 3960*D1**2*f**2*fdd*r + 1125*D1**2*f**2*fdd*s**2 - 2320*D1**2*f**2*fdd*s + 1570*D1**2*f**2*fdd + 7170*D1**2*f*fd**2*r**2 + 9420*D1**2*f*fd**2*r*s - 7920*D1**2*f*fd**2*r + 2250*D1**2*f*fd**2*s**2 - 4640*D1**2*f*fd**2*s + 1570*D1**2*f*fd**2 - 12408*D1*Dd*b1*f**2*r**2 - 16368*D1*Dd*b1*f**2*r*s + 14388*D1*Dd*b1*f**2*r - 3960*D1*Dd*b1*f**2*s**2 + 8052*D1*Dd*b1*f**2*s - 5082*D1*Dd*b1*f**2 + 18480*D1*Dd*b1*f*fd*r**2 + 26400*D1*Dd*b1*f*fd*r*s - 17820*D1*Dd*b1*f*fd*r + 7920*D1*Dd*b1*f*fd*s**2 - 11220*D1*Dd*b1*f*fd*s + 3630*D1*Dd*b1*f*fd - 10616*D1*Dd*f**3*r**2 - 13616*D1*Dd*f**3*r*s + 12116*D1*Dd*f**3*r - 3000*D1*Dd*f**3*s**2 + 6404*D1*Dd*f**3*s - 4154*D1*Dd*f**3 + 28680*D1*Dd*f**2*fd*r**2 + 37680*D1*Dd*f**2*fd*r*s - 32430*D1*Dd*f**2*fd*r + 9000*D1*Dd*f**2*fd*s**2 - 18490*D1*Dd*f**2*fd*s + 8600*D1*Dd*f**2*fd + 4620*D1*Ddd*b1*f**2*r**2 + 6600*D1*Ddd*b1*f**2*r*s - 5610*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s**2 - 3630*D1*Ddd*b1*f**2*s + 2145*D1*Ddd*b1*f**2 + 4780*D1*Ddd*f**3*r**2 + 6280*D1*Ddd*f**3*r*s - 5530*D1*Ddd*f**3*r + 1500*D1*Ddd*f**3*s**2 - 3070*D1*Ddd*f**3*s + 1945*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1)*(32*C*(r - 1) - 47*r - 15*s + 47) - 5*fd*(2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 14*r**2 - 20*r*s + 19*r - 6*s**2 + 13*s - 5)) - 5*Dd*f*(2*C*(8*r**2 + 8*r*s - 12*r - 5*s + 4) - 28*r**2 - 40*r*s + 45*r - 12*s**2 + 31*s - 17)) + 13860*Dd**2*b1*f**2*r**2 + 19800*Dd**2*b1*f**2*r*s - 16830*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s**2 - 10890*Dd**2*b1*f**2*s + 4290*Dd**2*b1*f**2 + 14340*Dd**2*f**3*r**2 + 18840*Dd**2*f**3*r*s - 16590*Dd**2*f**3*r + 4500*Dd**2*f**3*s**2 - 9210*Dd**2*f**3*s + 3890*Dd**2*f**3)/(693*d**2*k1*k3**6) - 4*D1**2*Pk1*Pk3*ct**5*k2**5*(51480*C*D1**2*f**2*fd*r**2 + 51480*C*D1**2*f**2*fd*r*s - 51480*C*D1**2*f**2*fd*r - 17160*C*D1**2*f**2*fd*s + 17160*C*D1**2*f**2*fd + 68640*C*D1*Dd*f**3*r**2 + 68640*C*D1*Dd*f**3*r*s - 68640*C*D1*Dd*f**3*r - 17160*C*D1*Dd*f**3*s + 17160*C*D1*Dd*f**3 + 1716*D1**2*K*bdd1*f**2*r**2 + 1716*D1**2*K*bdd1*f**2*r*s - 1716*D1**2*K*bdd1*f**2*r - 1716*D1**2*bd1**2*f*(r + s - 1)*(5*f*(2*r + 2*s - 1) + 6*r + 6*s - 6) - 5525*D1**2*bdd1*f**3*r**2 + 10790*D1**2*bdd1*f**3*r*s + 2470*D1**2*bdd1*f**3*r + 16315*D1**2*bdd1*f**3*s**2 - 19370*D1**2*bdd1*f**3*s - 585*D1**2*bdd1*f**3 - 6006*D1**2*bdd1*f**2*r**2 - 10296*D1**2*bdd1*f**2*r*s + 10296*D1**2*bdd1*f**2*r - 4290*D1**2*bdd1*f**2*s**2 + 8580*D1**2*bdd1*f**2*s - 4290*D1**2*bdd1*f**2 - 40880*D1**2*f**3*fd*r**2 - 106400*D1**2*f**3*fd*r*s + 73640*D1**2*f**3*fd*r - 65520*D1**2*f**3*fd*s**2 + 92120*D1**2*f**3*fd*s - 42980*D1**2*f**3*fd + 24080*D1**2*f**3*fdd*r**2 + 104160*D1**2*f**3*fdd*r*s - 64120*D1**2*f**3*fdd*r + 80080*D1**2*f**3*fdd*s**2 - 106120*D1**2*f**3*fdd*s + 46060*D1**2*f**3*fdd + 72240*D1**2*f**2*fd**2*r**2 + 312480*D1**2*f**2*fd**2*r*s - 192360*D1**2*f**2*fd**2*r + 240240*D1**2*f**2*fd**2*s**2 - 318360*D1**2*f**2*fd**2*s + 92120*D1**2*f**2*fd**2 - 64350*D1**2*f**2*fd*r**2 - 77220*D1**2*f**2*fd*r*s + 68640*D1**2*f**2*fd*r - 12870*D1**2*f**2*fd*s**2 + 34320*D1**2*f**2*fd*s - 25740*D1**2*f**2*fd + 27456*D1**2*f**2*gd2*r**2 + 27456*D1**2*f**2*gd2*r*s - 27456*D1**2*f**2*gd2*r - 3432*D1**2*f**2*gdd2*r**2 - 3432*D1**2*f**2*gdd2*r*s + 3432*D1**2*f**2*gdd2*r + 54912*D1**2*f*fd*g2*r**2 + 54912*D1**2*f*fd*g2*r*s - 54912*D1**2*f*fd*g2*r - 27456*D1**2*f*fd*g2*s + 27456*D1**2*f*fd*g2 - 13728*D1**2*f*fd*gd2*r**2 - 13728*D1**2*f*fd*gd2*r*s + 13728*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s - 3432*D1**2*f*fd*gd2 - 6864*D1**2*f*fdd*g2*r**2 - 6864*D1**2*f*fdd*g2*r*s + 6864*D1**2*f*fdd*g2*r + 3432*D1**2*f*fdd*g2*s - 3432*D1**2*f*fdd*g2 - 6864*D1**2*fd**2*g2*r**2 - 6864*D1**2*fd**2*g2*r*s + 6864*D1**2*fd**2*g2*r + 3432*D1**2*fd**2*g2*s - 40880*D1*Dd*f**4*r**2 - 106400*D1*Dd*f**4*r*s + 73640*D1*Dd*f**4*r - 65520*D1*Dd*f**4*s**2 + 92120*D1*Dd*f**4*s - 42980*D1*Dd*f**4 + 192640*D1*Dd*f**3*fd*r**2 + 833280*D1*Dd*f**3*fd*r*s - 512960*D1*Dd*f**3*fd*r + 640640*D1*Dd*f**3*fd*s**2 - 848960*D1*Dd*f**3*fd*s + 276360*D1*Dd*f**3*fd - 85800*D1*Dd*f**3*r**2 - 102960*D1*Dd*f**3*r*s + 94380*D1*Dd*f**3*r - 17160*D1*Dd*f**3*s**2 + 42900*D1*Dd*f**3*s - 30030*D1*Dd*f**3 + 109824*D1*Dd*f**2*g2*r**2 + 109824*D1*Dd*f**2*g2*r*s - 109824*D1*Dd*f**2*g2*r - 27456*D1*Dd*f**2*g2*s + 27456*D1*Dd*f**2*g2 - 27456*D1*Dd*f**2*gd2*r**2 - 27456*D1*Dd*f**2*gd2*r*s + 27456*D1*Dd*f**2*gd2*r + 3432*D1*Dd*f**2*gd2*s - 3432*D1*Dd*f**2*gd2 - 54912*D1*Dd*f*fd*g2*r**2 - 54912*D1*Dd*f*fd*g2*r*s + 54912*D1*Dd*f*fd*g2*r + 20592*D1*Dd*f*fd*g2*s - 13728*D1*Dd*f*fd*g2 + 24080*D1*Ddd*f**4*r**2 + 104160*D1*Ddd*f**4*r*s - 64120*D1*Ddd*f**4*r + 80080*D1*Ddd*f**4*s**2 - 106120*D1*Ddd*f**4*s + 46060*D1*Ddd*f**4 - 13728*D1*Ddd*f**2*g2*r**2 - 13728*D1*Ddd*f**2*g2*r*s + 13728*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s - 3432*D1*Ddd*f**2*g2 + 13*D1*bd1*f*(D1*(5*f**2*(203*r**2 + 2*r*(65*s - 71) - 73*s**2 + 134*s + 51) + 2*f*(792*C*(r - 1)*(r + s - 1) - 5*fd*(255*r**2 - 498*r*s + 43*r - 753*s**2 + 883*s - 288) - (r + s - 1)*(528*K*r + 132*r - 132*s - 660)) + 132*fd*(K*(4*r**2 + 4*r*(s - 1) - s + 1) - 14*r**2 - 24*r*s + 19*r - 10*s**2 + 16*s - 6) + 1848*g2*(r - 1)*(r + s - 1)) - 2*Dd*f*(-66*K*(8*r**2 + 8*r*(s - 1) - s + 1) + 5*f*(340*r**2 + r*(5 - 664*s) - 1004*s**2 + 1181*s - 279) + 1848*r**2 + 3168*r*s - 2838*r + 1320*s**2 - 2376*s + 1056)) + 72240*Dd**2*f**4*r**2 + 312480*Dd**2*f**4*r*s - 192360*Dd**2*f**4*r + 240240*Dd**2*f**4*s**2 - 318360*Dd**2*f**4*s + 92120*Dd**2*f**4 - 41184*Dd**2*f**2*g2*r**2 - 41184*Dd**2*f**2*g2*r*s + 41184*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s - 6864*Dd**2*f**2*g2 + 858*b1**2*(D1**2*(5*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*fd*(r + s)*(r*(7*K - 13) - 6*s) - 6*fdd*(r + s)**2) + 2*D1*(Dd*(10*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-7*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*fd*(4*r + 4*s - 3)**2 + 52*r**2 + 76*r*s - 64*r + 24*s**2 - 43*s + 25) - 6*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(5*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(5*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(3168*C*D1**2*f*fd*r**2 + 3168*C*D1**2*f*fd*r*s - 1584*C*D1**2*f*fd*r + 6336*C*D1*Dd*f**2*r**2 + 6336*C*D1*Dd*f**2*r*s - 6336*C*D1*Dd*f**2*r - 1584*C*D1*Dd*f**2*s + 1584*C*D1*Dd*f**2 - 2112*D1**2*K*f*fd*r**2 - 2112*D1**2*K*f*fd*r*s + 2112*D1**2*K*f*fd*r + 1056*D1**2*K*f*fd*s - 1056*D1**2*K*f*fd + 264*D1**2*K*f*fdd*r**2 + 264*D1**2*K*f*fdd*r*s - 264*D1**2*K*f*fdd*r - 132*D1**2*K*f*fdd*s + 132*D1**2*K*f*fdd + 264*D1**2*K*fd**2*r**2 + 264*D1**2*K*fd**2*r*s - 264*D1**2*K*fd**2*r - 132*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 12*(r + s - 1)**2) + 3045*D1**2*f**2*fd*r**2 + 1950*D1**2*f**2*fd*r*s - 2620*D1**2*f**2*fd*r - 1095*D1**2*f**2*fd*s**2 + 140*D1**2*f**2*fd*s + 30*D1**2*f**2*fd - 1275*D1**2*f**2*fdd*r**2 + 2490*D1**2*f**2*fdd*r*s - 1000*D1**2*f**2*fdd*r + 3765*D1**2*f**2*fdd*s**2 - 4360*D1**2*f**2*fdd*s + 2130*D1**2*f**2*fdd - 2550*D1**2*f*fd**2*r**2 + 4980*D1**2*f*fd**2*r*s - 2000*D1**2*f*fd**2*r + 7530*D1**2*f*fd**2*s**2 - 8720*D1**2*f*fd**2*s + 1290*D1**2*f*fd**2 - 528*D1**2*f*fd*r**2 - 1056*D1**2*f*fd*r + 528*D1**2*f*fd*s**2 - 1584*D1**2*f*fd*s + 1320*D1**2*f*fd - 924*D1**2*f*fdd*r**2 - 1584*D1**2*f*fdd*r*s + 924*D1**2*f*fdd*r - 660*D1**2*f*fdd*s**2 + 792*D1**2*f*fdd*s - 462*D1**2*f*fdd + 1848*D1**2*f*gd2*r**2 + 1848*D1**2*f*gd2*r*s - 1848*D1**2*f*gd2*r - 924*D1**2*fd**2*r**2 - 1584*D1**2*fd**2*r*s + 924*D1**2*fd**2*r - 660*D1**2*fd**2*s**2 + 792*D1**2*fd**2*s + 1848*D1**2*fd*g2*r**2 + 1848*D1**2*fd*g2*r*s - 4224*D1*Dd*K*f**2*r**2 - 4224*D1*Dd*K*f**2*r*s + 4224*D1*Dd*K*f**2*r + 1056*D1*Dd*K*f**2*s - 1056*D1*Dd*K*f**2 + 2112*D1*Dd*K*f*fd*r**2 + 2112*D1*Dd*K*f*fd*r*s - 2112*D1*Dd*K*f*fd*r - 792*D1*Dd*K*f*fd*s + 528*D1*Dd*K*f*fd + 4060*D1*Dd*f**3*r**2 + 2600*D1*Dd*f**3*r*s - 3330*D1*Dd*f**3*r - 1460*D1*Dd*f**3*s**2 + 810*D1*Dd*f**3*s + 285*D1*Dd*f**3 - 10200*D1*Dd*f**2*fd*r**2 + 19920*D1*Dd*f**2*fd*r*s - 6430*D1*Dd*f**2*fd*r + 30120*D1*Dd*f**2*fd*s**2 - 34990*D1*Dd*f**2*fd*s + 9720*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r + 1056*D1*Dd*f**2*s**2 - 1056*D1*Dd*f**2*s + 264*D1*Dd*f**2 - 7392*D1*Dd*f*fd*r**2 - 12672*D1*Dd*f*fd*r*s + 8712*D1*Dd*f*fd*r - 5280*D1*Dd*f*fd*s**2 + 7392*D1*Dd*f*fd*s - 2508*D1*Dd*f*fd + 7392*D1*Dd*f*g2*r**2 + 7392*D1*Dd*f*g2*r*s - 7392*D1*Dd*f*g2*r - 1848*D1*Dd*f*g2*s + 1848*D1*Dd*f*g2 + 528*D1*Ddd*K*f**2*r**2 + 528*D1*Ddd*K*f**2*r*s - 528*D1*Ddd*K*f**2*r - 132*D1*Ddd*K*f**2*s + 132*D1*Ddd*K*f**2 - 1700*D1*Ddd*f**3*r**2 + 3320*D1*Ddd*f**3*r*s - 810*D1*Ddd*f**3*r + 5020*D1*Ddd*f**3*s**2 - 5850*D1*Ddd*f**3*s + 2085*D1*Ddd*f**3 - 1848*D1*Ddd*f**2*r**2 - 3168*D1*Ddd*f**2*r*s + 2508*D1*Ddd*f**2*r - 1320*D1*Ddd*f**2*s**2 + 2112*D1*Ddd*f**2*s - 1122*D1*Ddd*f**2 + 132*D1*bd1*(D1*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(r + s - 1)*(14*K*r - 7*K + 20*fd*(2*r + 2*s - 1) - 26*r - 12*s + 19) - 12*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 12*r + 12*s - 12)) + 1584*Dd**2*K*f**2*r**2 + 1584*Dd**2*K*f**2*r*s - 1584*Dd**2*K*f**2*r - 396*Dd**2*K*f**2*s + 264*Dd**2*K*f**2 - 5100*Dd**2*f**3*r**2 + 9960*Dd**2*f**3*r*s - 2430*Dd**2*f**3*r + 15060*Dd**2*f**3*s**2 - 17550*Dd**2*f**3*s + 4170*Dd**2*f**3 - 5544*Dd**2*f**2*r**2 - 9504*Dd**2*f**2*r*s + 7524*Dd**2*f**2*r - 3960*Dd**2*f**2*s**2 + 6336*Dd**2*f**2*s - 2244*Dd**2*f**2))/(9009*d**2*k1*k3**6) + 4*D1**2*Pk1*Pk3*ct**5*k2**3*st**2*(33*b1*(D1**2*(f*(2*fd*(r*(16*C - 31)*(2*s - 1) - 30*s**2 + 30*s - 15) - 5*fdd*(r*(2*C - 5)*(2*s - 1) - 6*s**2 + 6*s - 3)) - 5*fd**2*(r*(2*C - 5)*(2*s - 1) + s*(6 - 6*s))) + D1*f*(Dd*(2*f*(-16*C*s + r*(32*C - 62)*(2*s - 1) - 60*s**2 + 91*s - 30) - 5*fd*(2*s - 1)*(2*C*(8*r - 1) - 40*r - 24*s + 17)) + 5*Ddd*f*(2*C*s - r*(4*C - 10)*(2*s - 1) + 12*s**2 - 17*s + 6)) - 5*Dd**2*f**2*(2*C*(6*r*(2*s - 1) - 3*s + 2) + r*(30 - 60*s) - 36*s**2 + 51*s - 16)) + f*(D1**2*(f*(-165*bdd1*s*(2*C*(r - 1) - 5*r - 3*s + 5) + 2*fd*(-476*C*s + r*(476*C - 851)*(3*s - 1) - 1125*s**2 + 1601*s - 375) - 5*fdd*(-82*C*s + r*(82*C - 157)*(3*s - 1) - 225*s**2 + 307*s - 75)) - 5*fd**2*(82*C*(6*r*s - 2*r - 2*s + 1) - 942*r*s + 314*r - 450*s**2 + 614*s - 157)) + 33*D1*bd1*(D1*(2*f*s*(16*C*(r - 1) - 31*r - 15*s + 31) - 5*fd*(C*(8*r*s - 2*r - 4*s + 2) - 20*r*s + 5*r - 12*s**2 + 16*s - 5)) - 5*Dd*f*(2*C*(8*r*s - 2*r - 5*s + 2) - 40*r*s + 10*r - 24*s**2 + 37*s - 10)) + D1*f*(Dd*(2*f*(r*(952*C - 1702)*(2*s - 1) - 1500*s**2 + s*(2351 - 476*C) - 750) - 5*fd*(82*C*(2*r*(12*s - 5) - 7*s + 3) - 314*r*(12*s - 5) - 1800*s**2 + 2599*s - 771)) - 5*Ddd*f*(r*(164*C - 314)*(2*s - 1) - 300*s**2 + s*(457 - 82*C) - 150)) - 5*Dd**2*f**2*(82*C*(6*r*(2*s - 1) - 3*s + 2) - 942*r*(2*s - 1) - 900*s**2 + 1371*s - 464)))/(693*d**2*k1*k3**4) + 2*D1**2*Pk1*Pk3*ct**5*k2**3*(1848*D1*b1**2*(C - 1)*(D1*fd*r*(r + s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 66*b1*(28*D1**2*bd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + D1**2*(f*(fd*(4*C*(14*r*s - 23*r - 8*s + 8) + 18*r**2 + 36*r*s + 46*r + 74*s**2 - 42*s + 5) - 2*fdd*(C*(6*r**2 + 2*r*s - 5*r - 2*s + 2) - 6*r**2 + 30*r*s - 11*r + 32*s**2 - 30*s + 14)) + 2*fd**2*(C*(-6*r**2 - 2*r*s + 5*r + 2*s - 2) + 6*r**2 - 30*r*s + 11*r - 32*s**2 + 30*s + 2)) + D1*f*(Dd*(f*(36*r**2 + 2*r*(56*C*s - 28*C + 36*s - 27) + 148*s**2 - s*(28*C + 166) + 83) - 2*fd*(C*(48*r**2 + 4*r*(4*s - 9) - 10*s + 9) - 48*r**2 + 4*r*(60*s - 23) + 256*s**2 - 278*s + 71)) - 2*Ddd*f*(C*(12*r**2 + 4*r*(s - 2) - s + 3) - 12*r**2 + 12*r*(5*s - 2) + 64*s**2 - 79*s + 29)) - 2*Dd**2*f**2*(C*(36*r**2 + 12*r*(s - 2) - 3*s + 2) - 36*r**2 + 36*r*(5*s - 2) + 192*s**2 - 237*s + 62)) - f*(12444*C*D1**2*f*fd*r**2 + 4584*C*D1**2*f*fd*r*s - 9824*C*D1**2*f*fd*r - 1528*C*D1**2*f*fd*s + 4148*C*D1**2*f*fd - 84*C*D1**2*f*fdd*r**2 - 3084*C*D1**2*f*fdd*r*s + 1084*C*D1**2*f*fdd*r + 1028*C*D1**2*f*fdd*s - 28*C*D1**2*f*fdd - 168*C*D1**2*fd**2*r**2 - 6168*C*D1**2*fd**2*r*s + 2168*C*D1**2*fd**2*r + 2056*C*D1**2*fd**2*s - 1028*C*D1**2*fd**2 + 16592*C*D1*Dd*f**2*r**2 + 6112*C*D1*Dd*f**2*r*s - 11352*C*D1*Dd*f**2*r - 1528*C*D1*Dd*f**2*s + 4148*C*D1*Dd*f**2 - 672*C*D1*Dd*f*fd*r**2 - 24672*C*D1*Dd*f*fd*r*s + 10672*C*D1*Dd*f*fd*r + 7196*C*D1*Dd*f*fd*s - 3140*C*D1*Dd*f*fd - 112*C*D1*Ddd*f**2*r**2 - 4112*C*D1*Ddd*f**2*r*s + 2112*C*D1*Ddd*f**2*r + 1028*C*D1*Ddd*f**2*s - 28*C*D1*Ddd*f**2 - 336*C*Dd**2*f**2*r**2 - 12336*C*Dd**2*f**2*r*s + 6336*C*Dd**2*f**2*r + 3084*C*Dd**2*f**2*s - 2056*C*Dd**2*f**2 + 132*D1**2*bdd1*f*(C*(3*r**2 + r*(s - 2) + s + 1) - 3*r**2 + r*(15*s + 2) + 16*s**2 - 17*s - 1) - 14250*D1**2*f*fd*r**2 - 13314*D1**2*f*fd*r*s + 13938*D1**2*f*fd*r - 6135*D1**2*f*fd*s**2 + 8528*D1**2*f*fd*s - 6795*D1**2*f*fd + 690*D1**2*f*fdd*r**2 + 8934*D1**2*f*fdd*r*s - 3438*D1**2*f*fdd*r + 5295*D1**2*f*fdd*s**2 - 6508*D1**2*f*fdd*s + 1995*D1**2*f*fdd + 1380*D1**2*fd**2*r**2 + 17868*D1**2*fd**2*r*s - 6876*D1**2*fd**2*r + 10590*D1**2*fd**2*s**2 - 13016*D1**2*fd**2*s + 2978*D1**2*fd**2 - 19000*D1*Dd*f**2*r**2 - 17752*D1*Dd*f**2*r*s + 18376*D1*Dd*f**2*r - 8180*D1*Dd*f**2*s**2 + 12618*D1*Dd*f**2*s - 8840*D1*Dd*f**2 + 5520*D1*Dd*f*fd*r**2 + 71472*D1*Dd*f*fd*r*s - 33000*D1*Dd*f*fd*r + 42360*D1*Dd*f*fd*s**2 - 56146*D1*Dd*f*fd*s + 16454*D1*Dd*f*fd + 920*D1*Ddd*f**2*r**2 + 11912*D1*Ddd*f**2*r*s - 6416*D1*Ddd*f**2*r + 7060*D1*Ddd*f**2*s**2 - 10038*D1*Ddd*f**2*s + 3760*D1*Ddd*f**2 - 66*D1*bd1*(D1*(f*(4*C*(7*r*s + 16*r + s - 8) + 9*r**2 + 18*r*s - 82*r + 37*s**2 - 50*s + 41) - 2*fd*(C*(12*r**2 + 4*r*s - 9*r - 1) - 12*r**2 + 60*r*s - 7*r + 64*s**2 - 64*s + 17)) - 2*Dd*f*(r**2*(24*C - 24) + 8*r*(C*(s - 2) + 15*s - 2) + 128*s**2 + s*(3*C - 147) + 32)) + 2760*Dd**2*f**2*r**2 + 35736*Dd**2*f**2*r*s - 19248*Dd**2*f**2*r + 21180*Dd**2*f**2*s**2 - 30114*Dd**2*f**2*s + 9486*Dd**2*f**2))/(693*d**2*k1*k3**4) - 20*D1**2*Pk1*Pk3*ct**5*k2*st**2*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + 2*D1*f*(50*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(2*s**2 - 2*s + 1)) - 50*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(231*d**2*k1*k3**2) + 2*D1**2*Pk1*Pk3*ct**5*k2*(1848*D1*b1**2*(C - 1)*(D1*fd*r*(s - 1) + Dd*f*(r*(4*s - 2) - s)) + 66*b1*(D1**2*(f*(28*bd1*s*(C - 1)*(2*r - 1) + fd*(r*(32*C - 16)*(2*s - 1) + 74*s**2 - s*(32*C + 42) + 37) - 2*fdd*(r*(2*C - 1)*(2*s - 1) + 32*s**2 - s*(2*C + 30) + 16)) - 2*fd**2*(C*(r*(4*s - 2) - 2*s + 2) - 2*r*s + r + 32*s**2 - 30*s - 2)) + 2*D1*f*(Dd*(f*(r*(32*C - 16)*(2*s - 1) + 74*s**2 - s*(16*C + 66) + 37) - fd*(2*s - 1)*(2*C*(8*r - 3) - 8*r + 128*s - 59)) + Ddd*f*(r*(C*(4 - 8*s) + 4*s - 2) - 64*s**2 + s*(2*C + 63) - 32)) - 2*Dd**2*f**2*(2*C*(6*r*(2*s - 1) - 3*s + 2) + 3*r*(2 - 4*s) + 192*s**2 - 189*s + 30)) - f*(D1**2*(f*(132*bdd1*s*(r*(2*C - 1) + 16*s - 1) + 5*fd*(-80*C*s + r*(80*C - 292)*(3*s - 1) - 1227*s**2 + 1110*s - 409) - 5*fdd*(-40*C*s + r*(40*C - 80)*(3*s - 1) - 1059*s**2 + 786*s - 353)) - 10*fd**2*(20*C*(r*(6*s - 2) - 2*s + 1) - 80*r*(3*s - 1) - 1059*s**2 + 786*s - 40)) - 66*D1*bd1*(D1*(f*s*(r*(32*C - 16) + 37*s - 16) - 2*fd*(r*(2*C - 1)*(4*s - 1) + 64*s**2 - s*(2*C + 32) + 1)) - 2*Dd*f*(r*(4*C - 2)*(4*s - 1) + 128*s**2 - s*(2*C + 67) + 2)) + 10*D1*f*(Dd*(f*(r*(80*C - 292)*(2*s - 1) - 818*s**2 + s*(964 - 40*C) - 409) + 2*fd*(-10*C*(2*r*(12*s - 5) - 7*s + 3) + 40*r*(12*s - 5) + 2118*s**2 - 1905*s + 413)) + Ddd*f*(-r*(40*C - 80)*(2*s - 1) + 706*s**2 + s*(20*C - 746) + 353)) - 10*Dd**2*f**2*(20*C*(6*r*(2*s - 1) - 3*s + 2) - 240*r*(2*s - 1) - 2118*s**2 + 2238*s - 433)))/(693*d**2*k1*k3**2) - 8*D1**2*Pk1*Pk3*ct**5*(D1*f*s*(-12*D1*bd1**2*s - 5*D1*bdd1*f*s + 10*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*f*(2 - 4*s))) + 6*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(10*fd*(2*s**2 - 2*s + 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(24*bd1 - 12*bdd1)) - 2*fd*s*(12*bd1 + 5*fd)*(s - 1)) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(12*bd1*s + 5*fd*(2*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k1*k2) - 4*D1**2*Pk1*Pk3*ct**5*k2**3*(462*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*fd**2*r**2 - 66*D1**2*bdd1*f**2*(r - 1)**2 + 687*D1**2*f**2*fd*r**2 - 458*D1**2*f**2*fd*r + 229*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 924*D1*Dd*b1*f**2*r**2 - 462*D1*Dd*b1*f**2*r + 231*D1*Dd*b1*f**2 - 1056*D1*Dd*b1*f*fd*r**2 + 264*D1*Dd*b1*f*fd*r + 916*D1*Dd*f**3*r**2 - 458*D1*Dd*f**3*r + 229*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd - 264*D1*Ddd*b1*f**2*r**2 + 132*D1*Ddd*b1*f**2*r - 66*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(7*D1*f*(r - 1) - 8*D1*fd*r + 4*Dd*f*(1 - 4*r)) - 792*Dd**2*b1*f**2*r**2 + 396*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(693*d**2*k1**3*k3**2) - D1**2*Pk1*Pk3*ct**4*f*k2**6*st**4*(240*C - 240)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**8) - D1**2*Pk1*Pk3*ct**4*f*k2**4*st**4*(160*C - 160)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4))/(77*d**2*k3**6) - D1**2*Pk1*Pk3*ct**4*f*k2**2*st**4*(80*C - 80)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + 2*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1))/(77*d**2*k3**4) - 20*D1**2*Pk1*Pk3*ct**4*f*k2**6*st**2*(2691*D1**2*b1*f*fd*r**2 + 2691*D1**2*b1*f*fd*r*s - 1794*D1**2*b1*f*fd*r - 1989*D1**2*b1*f*fdd*r**2 - 1989*D1**2*b1*f*fdd*r*s + 1326*D1**2*b1*f*fdd*r - 3978*D1**2*b1*fd**2*r**2 - 3978*D1**2*b1*fd**2*r*s + 2652*D1**2*b1*fd**2*r - 663*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 1420*D1**2*f**2*fd*r**2 + 1420*D1**2*f**2*fd*r*s - 1420*D1**2*f**2*fd*r - 355*D1**2*f**2*fd*s + 355*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 60*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s - 15*D1**2*f**2*fdd - 180*D1**2*f*fd**2*r**2 - 180*D1**2*f*fd**2*r*s + 180*D1**2*f*fd**2*r + 45*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 3588*D1*Dd*b1*f**2*r**2 + 3588*D1*Dd*b1*f**2*r*s - 3588*D1*Dd*b1*f**2*r - 897*D1*Dd*b1*f**2*s + 897*D1*Dd*b1*f**2 - 15912*D1*Dd*b1*f*fd*r**2 - 15912*D1*Dd*b1*f*fd*r*s + 13260*D1*Dd*b1*f*fd*r + 1989*D1*Dd*b1*f*fd*s - 1326*D1*Dd*b1*f*fd + 1420*D1*Dd*f**3*r**2 + 1420*D1*Dd*f**3*r*s - 1420*D1*Dd*f**3*r - 355*D1*Dd*f**3*s + 355*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 480*D1*Dd*f**2*fd*r*s + 480*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s - 90*D1*Dd*f**2*fd - 2652*D1*Ddd*b1*f**2*r**2 - 2652*D1*Ddd*b1*f**2*r*s + 2652*D1*Ddd*b1*f**2*r + 663*D1*Ddd*b1*f**2*s - 663*D1*Ddd*b1*f**2 - 60*D1*Ddd*f**3*r**2 - 60*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r + 15*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 + 39*D1*bd1*f*(D1*(23*f*(r - 1)*(r + s - 1) - 17*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 17*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 7956*Dd**2*b1*f**2*r**2 - 7956*Dd**2*b1*f**2*r*s + 7956*Dd**2*b1*f**2*r + 1989*Dd**2*b1*f**2*s - 1326*Dd**2*b1*f**2 - 180*Dd**2*f**3*r**2 - 180*Dd**2*f**3*r*s + 180*Dd**2*f**3*r + 45*Dd**2*f**3*s - 30*Dd**2*f**3)/(9009*d**2*k1**2*k3**6) - 8*D1**2*Pk1*Pk3*ct**4*k1**4*k2**2*(8712*C*D1**2*b1*f*fd*r**2 + 17424*C*D1**2*b1*f*fd*r*s - 8712*C*D1**2*b1*f*fd*r + 8712*C*D1**2*b1*f*fd*s**2 - 8712*C*D1**2*b1*f*fd*s + 4356*C*D1**2*b1*f*fd - 9900*C*D1**2*b1*f*fdd*r**2 - 19800*C*D1**2*b1*f*fdd*r*s + 9900*C*D1**2*b1*f*fdd*r - 9900*C*D1**2*b1*f*fdd*s**2 + 9900*C*D1**2*b1*f*fdd*s - 4950*C*D1**2*b1*f*fdd - 9900*C*D1**2*b1*fd**2*r**2 - 19800*C*D1**2*b1*fd**2*r*s + 9900*C*D1**2*b1*fd**2*r - 9900*C*D1**2*b1*fd**2*s**2 + 9900*C*D1**2*b1*fd**2*s + 11340*C*D1**2*f**2*fd*r**2 + 22680*C*D1**2*f**2*fd*r*s - 15120*C*D1**2*f**2*fd*r + 11340*C*D1**2*f**2*fd*s**2 - 15120*C*D1**2*f**2*fd*s + 7560*C*D1**2*f**2*fd - 12600*C*D1**2*f**2*fdd*r**2 - 25200*C*D1**2*f**2*fdd*r*s + 16800*C*D1**2*f**2*fdd*r - 12600*C*D1**2*f**2*fdd*s**2 + 16800*C*D1**2*f**2*fdd*s - 8400*C*D1**2*f**2*fdd - 25200*C*D1**2*f*fd**2*r**2 - 50400*C*D1**2*f*fd**2*r*s + 33600*C*D1**2*f*fd**2*r - 25200*C*D1**2*f*fd**2*s**2 + 33600*C*D1**2*f*fd**2*s - 8400*C*D1**2*f*fd**2 + 17424*C*D1*Dd*b1*f**2*r**2 + 34848*C*D1*Dd*b1*f**2*r*s - 26136*C*D1*Dd*b1*f**2*r + 17424*C*D1*Dd*b1*f**2*s**2 - 26136*C*D1*Dd*b1*f**2*s + 13068*C*D1*Dd*b1*f**2 - 79200*C*D1*Dd*b1*f*fd*r**2 - 158400*C*D1*Dd*b1*f*fd*r*s + 99000*C*D1*Dd*b1*f*fd*r - 79200*C*D1*Dd*b1*f*fd*s**2 + 99000*C*D1*Dd*b1*f*fd*s - 29700*C*D1*Dd*b1*f*fd + 15120*C*D1*Dd*f**3*r**2 + 30240*C*D1*Dd*f**3*r*s - 22680*C*D1*Dd*f**3*r + 15120*C*D1*Dd*f**3*s**2 - 22680*C*D1*Dd*f**3*s + 11340*C*D1*Dd*f**3 - 100800*C*D1*Dd*f**2*fd*r**2 - 201600*C*D1*Dd*f**2*fd*r*s + 142800*C*D1*Dd*f**2*fd*r - 100800*C*D1*Dd*f**2*fd*s**2 + 142800*C*D1*Dd*f**2*fd*s - 50400*C*D1*Dd*f**2*fd - 19800*C*D1*Ddd*b1*f**2*r**2 - 39600*C*D1*Ddd*b1*f**2*r*s + 29700*C*D1*Ddd*b1*f**2*r - 19800*C*D1*Ddd*b1*f**2*s**2 + 29700*C*D1*Ddd*b1*f**2*s - 14850*C*D1*Ddd*b1*f**2 - 16800*C*D1*Ddd*f**3*r**2 - 33600*C*D1*Ddd*f**3*r*s + 25200*C*D1*Ddd*f**3*r - 16800*C*D1*Ddd*f**3*s**2 + 25200*C*D1*Ddd*f**3*s - 12600*C*D1*Ddd*f**3 - 59400*C*Dd**2*b1*f**2*r**2 - 118800*C*Dd**2*b1*f**2*r*s + 89100*C*Dd**2*b1*f**2*r - 59400*C*Dd**2*b1*f**2*s**2 + 89100*C*Dd**2*b1*f**2*s - 29700*C*Dd**2*b1*f**2 - 50400*C*Dd**2*f**3*r**2 - 100800*C*Dd**2*f**3*r*s + 75600*C*Dd**2*f**3*r - 50400*C*Dd**2*f**3*s**2 + 75600*C*Dd**2*f**3*s - 25200*C*Dd**2*f**3 - 5676*D1**2*b1*f*fd*r**2 - 11352*D1**2*b1*f*fd*r*s + 5676*D1**2*b1*f*fd*r - 5676*D1**2*b1*f*fd*s**2 + 5676*D1**2*b1*f*fd*s - 2838*D1**2*b1*f*fd + 6600*D1**2*b1*f*fdd*r**2 + 13200*D1**2*b1*f*fdd*r*s - 6600*D1**2*b1*f*fdd*r + 6600*D1**2*b1*f*fdd*s**2 - 6600*D1**2*b1*f*fdd*s + 3300*D1**2*b1*f*fdd + 6600*D1**2*b1*fd**2*r**2 + 13200*D1**2*b1*fd**2*r*s - 6600*D1**2*b1*fd**2*r + 6600*D1**2*b1*fd**2*s**2 - 6600*D1**2*b1*fd**2*s - 1650*D1**2*bdd1*f**2*(3*C - 2)*(r + s - 1)**2 - 7395*D1**2*f**2*fd*r**2 - 14790*D1**2*f**2*fd*r*s + 9860*D1**2*f**2*fd*r - 7395*D1**2*f**2*fd*s**2 + 9860*D1**2*f**2*fd*s - 4930*D1**2*f**2*fd + 8400*D1**2*f**2*fdd*r**2 + 16800*D1**2*f**2*fdd*r*s - 11200*D1**2*f**2*fdd*r + 8400*D1**2*f**2*fdd*s**2 - 11200*D1**2*f**2*fdd*s + 5600*D1**2*f**2*fdd + 16800*D1**2*f*fd**2*r**2 + 33600*D1**2*f*fd**2*r*s - 22400*D1**2*f*fd**2*r + 16800*D1**2*f*fd**2*s**2 - 22400*D1**2*f*fd**2*s + 5600*D1**2*f*fd**2 - 11352*D1*Dd*b1*f**2*r**2 - 22704*D1*Dd*b1*f**2*r*s + 17028*D1*Dd*b1*f**2*r - 11352*D1*Dd*b1*f**2*s**2 + 17028*D1*Dd*b1*f**2*s - 8514*D1*Dd*b1*f**2 + 52800*D1*Dd*b1*f*fd*r**2 + 105600*D1*Dd*b1*f*fd*r*s - 66000*D1*Dd*b1*f*fd*r + 52800*D1*Dd*b1*f*fd*s**2 - 66000*D1*Dd*b1*f*fd*s + 19800*D1*Dd*b1*f*fd - 9860*D1*Dd*f**3*r**2 - 19720*D1*Dd*f**3*r*s + 14790*D1*Dd*f**3*r - 9860*D1*Dd*f**3*s**2 + 14790*D1*Dd*f**3*s - 7395*D1*Dd*f**3 + 67200*D1*Dd*f**2*fd*r**2 + 134400*D1*Dd*f**2*fd*r*s - 95200*D1*Dd*f**2*fd*r + 67200*D1*Dd*f**2*fd*s**2 - 95200*D1*Dd*f**2*fd*s + 33600*D1*Dd*f**2*fd + 13200*D1*Ddd*b1*f**2*r**2 + 26400*D1*Ddd*b1*f**2*r*s - 19800*D1*Ddd*b1*f**2*r + 13200*D1*Ddd*b1*f**2*s**2 - 19800*D1*Ddd*b1*f**2*s + 9900*D1*Ddd*b1*f**2 + 11200*D1*Ddd*f**3*r**2 + 22400*D1*Ddd*f**3*r*s - 16800*D1*Ddd*f**3*r + 11200*D1*Ddd*f**3*s**2 - 16800*D1*Ddd*f**3*s + 8400*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(66*C - 43)*(r + s - 1) - D1*fd*(150*C - 100)*(2*r + 2*s - 1) - Dd*f*(150*C - 100)*(4*r + 4*s - 3)) + 39600*Dd**2*b1*f**2*r**2 + 79200*Dd**2*b1*f**2*r*s - 59400*Dd**2*b1*f**2*r + 39600*Dd**2*b1*f**2*s**2 - 59400*Dd**2*b1*f**2*s + 19800*Dd**2*b1*f**2 + 33600*Dd**2*f**3*r**2 + 67200*Dd**2*f**3*r*s - 50400*Dd**2*f**3*r + 33600*Dd**2*f**3*s**2 - 50400*Dd**2*f**3*s + 16800*Dd**2*f**3)/(231*d**2*k3**8) - 16*D1**2*Pk1*Pk3*ct**4*k1**4*(66*b1*(D1**2*(f*(fd*(26*C - 15) + fdd*(15 - 25*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(15 - 25*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(26*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(15 - 25*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(15 - 25*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(15 - 25*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(296*C - 171)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (10*C - 6)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(168 - 280*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 66*D1*bd1*(D1*(f*s*(26*C - 15)*(r + s - 1) - fd*(25*C - 15)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(15 - 25*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(296*C - 171)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(280*C - 168)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(168 - 280*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(168 - 280*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**6) - D1**2*Pk1*Pk3*ct**4*k1**4*(80*C - 40)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(56*fd*(3*s**2 - 2*s + 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) + 4*D1*f*(28*Dd*f*(2*s**2 - 2*s + 1) - Dd*(2*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) - 14*Ddd*f*(2*s**2 - 2*s + 1)) - 56*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k2**2*k3**4) - 4*D1**2*Pk1*Pk3*ct**4*k1**2*k2**4*st**2*(29040*C*D1**2*b1*f*fd*r**2 + 58080*C*D1**2*b1*f*fd*r*s - 29040*C*D1**2*b1*f*fd*r + 29040*C*D1**2*b1*f*fd*s**2 - 29040*C*D1**2*b1*f*fd*s + 14520*C*D1**2*b1*f*fd - 17292*C*D1**2*b1*f*fdd*r**2 - 34584*C*D1**2*b1*f*fdd*r*s + 17292*C*D1**2*b1*f*fdd*r - 17292*C*D1**2*b1*f*fdd*s**2 + 17292*C*D1**2*b1*f*fdd*s - 8646*C*D1**2*b1*f*fdd - 17292*C*D1**2*b1*fd**2*r**2 - 34584*C*D1**2*b1*fd**2*r*s + 17292*C*D1**2*b1*fd**2*r - 17292*C*D1**2*b1*fd**2*s**2 + 17292*C*D1**2*b1*fd**2*s + 30984*C*D1**2*f**2*fd*r**2 + 61968*C*D1**2*f**2*fd*r*s - 41312*C*D1**2*f**2*fd*r + 30984*C*D1**2*f**2*fd*s**2 - 41312*C*D1**2*f**2*fd*s + 20656*C*D1**2*f**2*fd - 19650*C*D1**2*f**2*fdd*r**2 - 39300*C*D1**2*f**2*fdd*r*s + 26200*C*D1**2*f**2*fdd*r - 19650*C*D1**2*f**2*fdd*s**2 + 26200*C*D1**2*f**2*fdd*s - 13100*C*D1**2*f**2*fdd - 39300*C*D1**2*f*fd**2*r**2 - 78600*C*D1**2*f*fd**2*r*s + 52400*C*D1**2*f*fd**2*r - 39300*C*D1**2*f*fd**2*s**2 + 52400*C*D1**2*f*fd**2*s - 13100*C*D1**2*f*fd**2 + 58080*C*D1*Dd*b1*f**2*r**2 + 116160*C*D1*Dd*b1*f**2*r*s - 87120*C*D1*Dd*b1*f**2*r + 58080*C*D1*Dd*b1*f**2*s**2 - 87120*C*D1*Dd*b1*f**2*s + 43560*C*D1*Dd*b1*f**2 - 138336*C*D1*Dd*b1*f*fd*r**2 - 276672*C*D1*Dd*b1*f*fd*r*s + 172920*C*D1*Dd*b1*f*fd*r - 138336*C*D1*Dd*b1*f*fd*s**2 + 172920*C*D1*Dd*b1*f*fd*s - 51876*C*D1*Dd*b1*f*fd + 41312*C*D1*Dd*f**3*r**2 + 82624*C*D1*Dd*f**3*r*s - 61968*C*D1*Dd*f**3*r + 41312*C*D1*Dd*f**3*s**2 - 61968*C*D1*Dd*f**3*s + 30984*C*D1*Dd*f**3 - 157200*C*D1*Dd*f**2*fd*r**2 - 314400*C*D1*Dd*f**2*fd*r*s + 222700*C*D1*Dd*f**2*fd*r - 157200*C*D1*Dd*f**2*fd*s**2 + 222700*C*D1*Dd*f**2*fd*s - 78600*C*D1*Dd*f**2*fd - 34584*C*D1*Ddd*b1*f**2*r**2 - 69168*C*D1*Ddd*b1*f**2*r*s + 51876*C*D1*Ddd*b1*f**2*r - 34584*C*D1*Ddd*b1*f**2*s**2 + 51876*C*D1*Ddd*b1*f**2*s - 25938*C*D1*Ddd*b1*f**2 - 26200*C*D1*Ddd*f**3*r**2 - 52400*C*D1*Ddd*f**3*r*s + 39300*C*D1*Ddd*f**3*r - 26200*C*D1*Ddd*f**3*s**2 + 39300*C*D1*Ddd*f**3*s - 19650*C*D1*Ddd*f**3 - 103752*C*Dd**2*b1*f**2*r**2 - 207504*C*Dd**2*b1*f**2*r*s + 155628*C*Dd**2*b1*f**2*r - 103752*C*Dd**2*b1*f**2*s**2 + 155628*C*Dd**2*b1*f**2*s - 51876*C*Dd**2*b1*f**2 - 78600*C*Dd**2*f**3*r**2 - 157200*C*Dd**2*f**3*r*s + 117900*C*Dd**2*f**3*r - 78600*C*Dd**2*f**3*s**2 + 117900*C*Dd**2*f**3*s - 39300*C*Dd**2*f**3 - 22572*D1**2*b1*f*fd*r**2 - 45144*D1**2*b1*f*fd*r*s + 22572*D1**2*b1*f*fd*r - 22572*D1**2*b1*f*fd*s**2 + 22572*D1**2*b1*f*fd*s - 11286*D1**2*b1*f*fd + 13662*D1**2*b1*f*fdd*r**2 + 27324*D1**2*b1*f*fdd*r*s - 13662*D1**2*b1*f*fdd*r + 13662*D1**2*b1*f*fdd*s**2 - 13662*D1**2*b1*f*fdd*s + 6831*D1**2*b1*f*fdd + 13662*D1**2*b1*fd**2*r**2 + 27324*D1**2*b1*fd**2*r*s - 13662*D1**2*b1*fd**2*r + 13662*D1**2*b1*fd**2*s**2 - 13662*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(262*C - 207)*(r + s - 1)**2 - 23922*D1**2*f**2*fd*r**2 - 47844*D1**2*f**2*fd*r*s + 31896*D1**2*f**2*fd*r - 23922*D1**2*f**2*fd*s**2 + 31896*D1**2*f**2*fd*s - 15948*D1**2*f**2*fd + 15525*D1**2*f**2*fdd*r**2 + 31050*D1**2*f**2*fdd*r*s - 20700*D1**2*f**2*fdd*r + 15525*D1**2*f**2*fdd*s**2 - 20700*D1**2*f**2*fdd*s + 10350*D1**2*f**2*fdd + 31050*D1**2*f*fd**2*r**2 + 62100*D1**2*f*fd**2*r*s - 41400*D1**2*f*fd**2*r + 31050*D1**2*f*fd**2*s**2 - 41400*D1**2*f*fd**2*s + 10350*D1**2*f*fd**2 - 45144*D1*Dd*b1*f**2*r**2 - 90288*D1*Dd*b1*f**2*r*s + 67716*D1*Dd*b1*f**2*r - 45144*D1*Dd*b1*f**2*s**2 + 67716*D1*Dd*b1*f**2*s - 33858*D1*Dd*b1*f**2 + 109296*D1*Dd*b1*f*fd*r**2 + 218592*D1*Dd*b1*f*fd*r*s - 136620*D1*Dd*b1*f*fd*r + 109296*D1*Dd*b1*f*fd*s**2 - 136620*D1*Dd*b1*f*fd*s + 40986*D1*Dd*b1*f*fd - 31896*D1*Dd*f**3*r**2 - 63792*D1*Dd*f**3*r*s + 47844*D1*Dd*f**3*r - 31896*D1*Dd*f**3*s**2 + 47844*D1*Dd*f**3*s - 23922*D1*Dd*f**3 + 124200*D1*Dd*f**2*fd*r**2 + 248400*D1*Dd*f**2*fd*r*s - 175950*D1*Dd*f**2*fd*r + 124200*D1*Dd*f**2*fd*s**2 - 175950*D1*Dd*f**2*fd*s + 62100*D1*Dd*f**2*fd + 27324*D1*Ddd*b1*f**2*r**2 + 54648*D1*Ddd*b1*f**2*r*s - 40986*D1*Ddd*b1*f**2*r + 27324*D1*Ddd*b1*f**2*s**2 - 40986*D1*Ddd*b1*f**2*s + 20493*D1*Ddd*b1*f**2 + 20700*D1*Ddd*f**3*r**2 + 41400*D1*Ddd*f**3*r*s - 31050*D1*Ddd*f**3*r + 20700*D1*Ddd*f**3*s**2 - 31050*D1*Ddd*f**3*s + 15525*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(220*C - 171)*(r + s - 1) - D1*fd*(262*C - 207)*(2*r + 2*s - 1) - Dd*f*(262*C - 207)*(4*r + 4*s - 3)) + 81972*Dd**2*b1*f**2*r**2 + 163944*Dd**2*b1*f**2*r*s - 122958*Dd**2*b1*f**2*r + 81972*Dd**2*b1*f**2*s**2 - 122958*Dd**2*b1*f**2*s + 40986*Dd**2*b1*f**2 + 62100*Dd**2*f**3*r**2 + 124200*Dd**2*f**3*r*s - 93150*Dd**2*f**3*r + 62100*Dd**2*f**3*s**2 - 93150*Dd**2*f**3*s + 31050*Dd**2*f**3)/(231*d**2*k3**8) + 8*D1**2*Pk1*Pk3*ct**4*k1**2*k2**4*(25740*C*D1**2*f**2*fd*r**2 + 51480*C*D1**2*f**2*fd*r*s - 34320*C*D1**2*f**2*fd*r + 25740*C*D1**2*f**2*fd*s**2 - 34320*C*D1**2*f**2*fd*s + 17160*C*D1**2*f**2*fd + 34320*C*D1*Dd*f**3*r**2 + 68640*C*D1*Dd*f**3*r*s - 51480*C*D1*Dd*f**3*r + 34320*C*D1*Dd*f**3*s**2 - 51480*C*D1*Dd*f**3*s + 25740*C*D1*Dd*f**3 + 10725*D1**2*K*bdd1*f**2*r**2 + 21450*D1**2*K*bdd1*f**2*r*s - 21450*D1**2*K*bdd1*f**2*r + 10725*D1**2*K*bdd1*f**2*s**2 - 21450*D1**2*K*bdd1*f**2*s + 10725*D1**2*K*bdd1*f**2 - 2860*D1**2*bd1**2*f*(-9*K + 5*f + 6)*(r + s - 1)**2 - 7150*D1**2*bdd1*f**2*r**2 - 14300*D1**2*bdd1*f**2*r*s + 14300*D1**2*bdd1*f**2*r - 7150*D1**2*bdd1*f**2*s**2 + 14300*D1**2*bdd1*f**2*s - 7150*D1**2*bdd1*f**2 - 25740*D1**2*bdd1*f*g2*r**2 - 51480*D1**2*bdd1*f*g2*r*s + 51480*D1**2*bdd1*f*g2*r - 25740*D1**2*bdd1*f*g2*s**2 + 51480*D1**2*bdd1*f*g2*s - 25740*D1**2*bdd1*f*g2 - 20160*D1**2*f**3*fd*r**2 - 40320*D1**2*f**3*fd*r*s + 30240*D1**2*f**3*fd*r - 20160*D1**2*f**3*fd*s**2 + 30240*D1**2*f**3*fd*s - 15120*D1**2*f**3*fd + 21000*D1**2*f**3*fdd*r**2 + 42000*D1**2*f**3*fdd*r*s - 31500*D1**2*f**3*fdd*r + 21000*D1**2*f**3*fdd*s**2 - 31500*D1**2*f**3*fdd*s + 15750*D1**2*f**3*fdd + 63000*D1**2*f**2*fd**2*r**2 + 126000*D1**2*f**2*fd**2*r*s - 94500*D1**2*f**2*fd**2*r + 63000*D1**2*f**2*fd**2*s**2 - 94500*D1**2*f**2*fd**2*s + 31500*D1**2*f**2*fd**2 - 19305*D1**2*f**2*fd*r**2 - 38610*D1**2*f**2*fd*r*s + 25740*D1**2*f**2*fd*r - 19305*D1**2*f**2*fd*s**2 + 25740*D1**2*f**2*fd*s - 12870*D1**2*f**2*fd + 27456*D1**2*f**2*gd2*r**2 + 54912*D1**2*f**2*gd2*r*s - 54912*D1**2*f**2*gd2*r + 27456*D1**2*f**2*gd2*s**2 - 54912*D1**2*f**2*gd2*s + 27456*D1**2*f**2*gd2 - 21450*D1**2*f**2*gdd2*r**2 - 42900*D1**2*f**2*gdd2*r*s + 42900*D1**2*f**2*gdd2*r - 21450*D1**2*f**2*gdd2*s**2 + 42900*D1**2*f**2*gdd2*s - 21450*D1**2*f**2*gdd2 + 54912*D1**2*f*fd*g2*r**2 + 109824*D1**2*f*fd*g2*r*s - 54912*D1**2*f*fd*g2*r + 54912*D1**2*f*fd*g2*s**2 - 54912*D1**2*f*fd*g2*s + 27456*D1**2*f*fd*g2 - 85800*D1**2*f*fd*gd2*r**2 - 171600*D1**2*f*fd*gd2*r*s + 128700*D1**2*f*fd*gd2*r - 85800*D1**2*f*fd*gd2*s**2 + 128700*D1**2*f*fd*gd2*s - 42900*D1**2*f*fd*gd2 - 42900*D1**2*f*fdd*g2*r**2 - 85800*D1**2*f*fdd*g2*r*s + 42900*D1**2*f*fdd*g2*r - 42900*D1**2*f*fdd*g2*s**2 + 42900*D1**2*f*fdd*g2*s - 21450*D1**2*f*fdd*g2 - 42900*D1**2*fd**2*g2*r**2 - 85800*D1**2*fd**2*g2*r*s + 42900*D1**2*fd**2*g2*r - 42900*D1**2*fd**2*g2*s**2 + 42900*D1**2*fd**2*g2*s - 20160*D1*Dd*f**4*r**2 - 40320*D1*Dd*f**4*r*s + 30240*D1*Dd*f**4*r - 20160*D1*Dd*f**4*s**2 + 30240*D1*Dd*f**4*s - 15120*D1*Dd*f**4 + 168000*D1*Dd*f**3*fd*r**2 + 336000*D1*Dd*f**3*fd*r*s - 252000*D1*Dd*f**3*fd*r + 168000*D1*Dd*f**3*fd*s**2 - 252000*D1*Dd*f**3*fd*s + 94500*D1*Dd*f**3*fd - 25740*D1*Dd*f**3*r**2 - 51480*D1*Dd*f**3*r*s + 38610*D1*Dd*f**3*r - 25740*D1*Dd*f**3*s**2 + 38610*D1*Dd*f**3*s - 19305*D1*Dd*f**3 + 109824*D1*Dd*f**2*g2*r**2 + 219648*D1*Dd*f**2*g2*r*s - 164736*D1*Dd*f**2*g2*r + 109824*D1*Dd*f**2*g2*s**2 - 164736*D1*Dd*f**2*g2*s + 82368*D1*Dd*f**2*g2 - 171600*D1*Dd*f**2*gd2*r**2 - 343200*D1*Dd*f**2*gd2*r*s + 300300*D1*Dd*f**2*gd2*r - 171600*D1*Dd*f**2*gd2*s**2 + 300300*D1*Dd*f**2*gd2*s - 128700*D1*Dd*f**2*gd2 - 343200*D1*Dd*f*fd*g2*r**2 - 686400*D1*Dd*f*fd*g2*r*s + 429000*D1*Dd*f*fd*g2*r - 343200*D1*Dd*f*fd*g2*s**2 + 429000*D1*Dd*f*fd*g2*s - 128700*D1*Dd*f*fd*g2 + 21000*D1*Ddd*f**4*r**2 + 42000*D1*Ddd*f**4*r*s - 31500*D1*Ddd*f**4*r + 21000*D1*Ddd*f**4*s**2 - 31500*D1*Ddd*f**4*s + 15750*D1*Ddd*f**4 - 85800*D1*Ddd*f**2*g2*r**2 - 171600*D1*Ddd*f**2*g2*r*s + 128700*D1*Ddd*f**2*g2*r - 85800*D1*Ddd*f**2*g2*s**2 + 128700*D1*Ddd*f**2*g2*s - 64350*D1*Ddd*f**2*g2 + 286*D1*bd1*(D1*(5*f**3*(r + s - 1) + 2*f**2*(18*C - 24*K + 1)*(r + s - 1) + 25*f*fd*(3*K - 2)*(2*r + 2*s - 1) + 9*f*(13*g2 - 20*gd2)*(r + s - 1) - 180*fd*g2*(r + s)) + 5*Dd*f*(5*f*(3*K - 2) - 36*g2)*(4*r + 4*s - 3))*(r + s - 1) + 63000*Dd**2*f**4*r**2 + 126000*Dd**2*f**4*r*s - 94500*Dd**2*f**4*r + 63000*Dd**2*f**4*s**2 - 94500*Dd**2*f**4*s + 31500*Dd**2*f**4 - 257400*Dd**2*f**2*g2*r**2 - 514800*Dd**2*f**2*g2*r*s + 386100*Dd**2*f**2*g2*r - 257400*Dd**2*f**2*g2*s**2 + 386100*Dd**2*f**2*g2*s - 128700*Dd**2*f**2*g2 + 143*b1**2*(D1**2*(2*f*(29*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(117*K - 71)*(r + s) - 30*fdd*(3*K - 2)*(r + s))) + D1*(Dd*(58*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (117*K - 71)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*fd*(3*K - 2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 10*Ddd*f*(-9*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f*(-9*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 143*b1*(144*C*D1**2*f*fd*r**2 + 288*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*r + 144*C*D1**2*f*fd*s**2 - 144*C*D1**2*f*fd*s + 72*C*D1**2*f*fd + 288*C*D1*Dd*f**2*r**2 + 576*C*D1*Dd*f**2*r*s - 432*C*D1*Dd*f**2*r + 288*C*D1*Dd*f**2*s**2 - 432*C*D1*Dd*f**2*s + 216*C*D1*Dd*f**2 - 192*D1**2*K*f*fd*r**2 - 384*D1**2*K*f*fd*r*s + 192*D1**2*K*f*fd*r - 192*D1**2*K*f*fd*s**2 + 192*D1**2*K*f*fd*s - 96*D1**2*K*f*fd + 150*D1**2*K*f*fdd*r**2 + 300*D1**2*K*f*fdd*r*s - 150*D1**2*K*f*fdd*r + 150*D1**2*K*f*fdd*s**2 - 150*D1**2*K*f*fdd*s + 75*D1**2*K*f*fdd + 150*D1**2*K*fd**2*r**2 + 300*D1**2*K*fd**2*r*s - 150*D1**2*K*fd**2*r + 150*D1**2*K*fd**2*s**2 - 150*D1**2*K*fd**2*s - 20*D1**2*bdd1*f*(-9*K + 5*f + 6)*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 100*D1**2*f*fdd*r**2 - 200*D1**2*f*fdd*r*s + 100*D1**2*f*fdd*r - 100*D1**2*f*fdd*s**2 + 100*D1**2*f*fdd*s - 50*D1**2*f*fdd + 234*D1**2*f*gd2*r**2 + 468*D1**2*f*gd2*r*s - 468*D1**2*f*gd2*r + 234*D1**2*f*gd2*s**2 - 468*D1**2*f*gd2*s + 234*D1**2*f*gd2 - 180*D1**2*f*gdd2*r**2 - 360*D1**2*f*gdd2*r*s + 360*D1**2*f*gdd2*r - 180*D1**2*f*gdd2*s**2 + 360*D1**2*f*gdd2*s - 180*D1**2*f*gdd2 - 100*D1**2*fd**2*r**2 - 200*D1**2*fd**2*r*s + 100*D1**2*fd**2*r - 100*D1**2*fd**2*s**2 + 100*D1**2*fd**2*s + 234*D1**2*fd*g2*r**2 + 468*D1**2*fd*g2*r*s + 234*D1**2*fd*g2*s**2 - 360*D1**2*fd*gd2*r**2 - 720*D1**2*fd*gd2*r*s + 360*D1**2*fd*gd2*r - 360*D1**2*fd*gd2*s**2 + 360*D1**2*fd*gd2*s - 180*D1**2*fdd*g2*r**2 - 360*D1**2*fdd*g2*r*s - 180*D1**2*fdd*g2*s**2 - 384*D1*Dd*K*f**2*r**2 - 768*D1*Dd*K*f**2*r*s + 576*D1*Dd*K*f**2*r - 384*D1*Dd*K*f**2*s**2 + 576*D1*Dd*K*f**2*s - 288*D1*Dd*K*f**2 + 1200*D1*Dd*K*f*fd*r**2 + 2400*D1*Dd*K*f*fd*r*s - 1500*D1*Dd*K*f*fd*r + 1200*D1*Dd*K*f*fd*s**2 - 1500*D1*Dd*K*f*fd*s + 450*D1*Dd*K*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 800*D1*Dd*f*fd*r**2 - 1600*D1*Dd*f*fd*r*s + 1000*D1*Dd*f*fd*r - 800*D1*Dd*f*fd*s**2 + 1000*D1*Dd*f*fd*s - 300*D1*Dd*f*fd + 936*D1*Dd*f*g2*r**2 + 1872*D1*Dd*f*g2*r*s - 1404*D1*Dd*f*g2*r + 936*D1*Dd*f*g2*s**2 - 1404*D1*Dd*f*g2*s + 702*D1*Dd*f*g2 - 1440*D1*Dd*f*gd2*r**2 - 2880*D1*Dd*f*gd2*r*s + 2520*D1*Dd*f*gd2*r - 1440*D1*Dd*f*gd2*s**2 + 2520*D1*Dd*f*gd2*s - 1080*D1*Dd*f*gd2 - 1440*D1*Dd*fd*g2*r**2 - 2880*D1*Dd*fd*g2*r*s + 1080*D1*Dd*fd*g2*r - 1440*D1*Dd*fd*g2*s**2 + 1080*D1*Dd*fd*g2*s + 300*D1*Ddd*K*f**2*r**2 + 600*D1*Ddd*K*f**2*r*s - 450*D1*Ddd*K*f**2*r + 300*D1*Ddd*K*f**2*s**2 - 450*D1*Ddd*K*f**2*s + 225*D1*Ddd*K*f**2 - 200*D1*Ddd*f**2*r**2 - 400*D1*Ddd*f**2*r*s + 300*D1*Ddd*f**2*r - 200*D1*Ddd*f**2*s**2 + 300*D1*Ddd*f**2*s - 150*D1*Ddd*f**2 - 720*D1*Ddd*f*g2*r**2 - 1440*D1*Ddd*f*g2*r*s + 1080*D1*Ddd*f*g2*r - 720*D1*Ddd*f*g2*s**2 + 1080*D1*Ddd*f*g2*s - 540*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(58*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(117*K - 71)*(r + s - 1) + 60*fd*(3*K - 2)*(r + s)) - 20*Dd*f*(-9*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 900*Dd**2*K*f**2*r**2 + 1800*Dd**2*K*f**2*r*s - 1350*Dd**2*K*f**2*r + 900*Dd**2*K*f**2*s**2 - 1350*Dd**2*K*f**2*s + 450*Dd**2*K*f**2 - 600*Dd**2*f**2*r**2 - 1200*Dd**2*f**2*r*s + 900*Dd**2*f**2*r - 600*Dd**2*f**2*s**2 + 900*Dd**2*f**2*s - 300*Dd**2*f**2 - 2160*Dd**2*f*g2*r**2 - 4320*Dd**2*f*g2*r*s + 3240*Dd**2*f*g2*r - 2160*Dd**2*f*g2*s**2 + 3240*Dd**2*f*g2*s - 1080*Dd**2*f*g2))/(1001*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**4*k1**2*k2**2*st**2*(33*b1*(D1**2*(f*(fd*(112*C - 84) + fdd*(47 - 62*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - fd**2*(62*C - 47)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(112*C - 84)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(62*C - 47)*(2*s - 1)*(8*r + 8*s - 5)) - Ddd*f*(62*C - 47)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f**2*(62*C - 47)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(2704*C - 2020)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (62*C - 47)*(33*bdd1*s*(r + s - 1) + 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(1175 - 1550*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(112*C - 84)*(r + s - 1) - fd*(62*C - 47)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(62*C - 47)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(2704*C - 2020)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(1550*C - 1175)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(1175 - 1550*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(1175 - 1550*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**4*k1**2*k2**2*(132*b1**2*(D1**2*(fd*(37*C - 26) + fdd*(27 - 36*C))*(r + s - 1)**2 + D1*(Dd*(f*(37*C - 26)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(54 - 72*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(27 - 36*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(216*C - 162)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(-456*C*D1**2*f*fd*r**2 - 1632*C*D1**2*f*fd*r*s + 696*C*D1**2*f*fd*r - 1176*C*D1**2*f*fd*s**2 + 1056*C*D1**2*f*fd*s - 528*C*D1**2*f*fd + 600*C*D1**2*f*fdd*r**2 + 1680*C*D1**2*f*fdd*r*s - 720*C*D1**2*f*fdd*r + 1080*C*D1**2*f*fdd*s**2 - 960*C*D1**2*f*fdd*s + 480*C*D1**2*f*fdd + 600*C*D1**2*fd**2*r**2 + 1680*C*D1**2*fd**2*r*s - 720*C*D1**2*fd**2*r + 1080*C*D1**2*fd**2*s**2 - 960*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 - 912*C*D1*Dd*f**2*r**2 - 3264*C*D1*Dd*f**2*r*s + 2088*C*D1*Dd*f**2*r - 2352*C*D1*Dd*f**2*s**2 + 3168*C*D1*Dd*f**2*s - 1404*C*D1*Dd*f**2 + 4800*C*D1*Dd*f*fd*r**2 + 13440*C*D1*Dd*f*fd*r*s - 7440*C*D1*Dd*f*fd*r + 8640*C*D1*Dd*f*fd*s**2 - 9840*C*D1*Dd*f*fd*s + 2640*C*D1*Dd*f*fd + 1200*C*D1*Ddd*f**2*r**2 + 3360*C*D1*Ddd*f**2*r*s - 2280*C*D1*Ddd*f**2*r + 2160*C*D1*Ddd*f**2*s**2 - 3000*C*D1*Ddd*f**2*s + 1380*C*D1*Ddd*f**2 + 3600*C*Dd**2*f**2*r**2 + 10080*C*Dd**2*f**2*r*s - 6840*C*Dd**2*f**2*r + 6480*C*Dd**2*f**2*s**2 - 9000*C*Dd**2*f**2*s + 2760*C*Dd**2*f**2 - 18*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 326*D1**2*f*fd*r**2 + 1264*D1**2*f*fd*r*s - 548*D1**2*f*fd*r + 938*D1**2*f*fd*s**2 - 854*D1**2*f*fd*s + 427*D1**2*f*fd - 430*D1**2*f*fdd*r**2 - 1304*D1**2*f*fdd*r*s + 562*D1**2*f*fdd*r - 874*D1**2*f*fdd*s**2 + 784*D1**2*f*fdd*s - 392*D1**2*f*fdd - 430*D1**2*fd**2*r**2 - 1304*D1**2*fd**2*r*s + 562*D1**2*fd**2*r - 874*D1**2*fd**2*s**2 + 784*D1**2*fd**2*s + 90*D1**2*fd**2 + 652*D1*Dd*f**2*r**2 + 2528*D1*Dd*f**2*r*s - 1590*D1*Dd*f**2*r + 1876*D1*Dd*f**2*s**2 - 2508*D1*Dd*f**2*s + 1101*D1*Dd*f**2 - 3440*D1*Dd*f*fd*r**2 - 10432*D1*Dd*f*fd*r*s + 5716*D1*Dd*f*fd*r - 6992*D1*Dd*f*fd*s**2 + 7936*D1*Dd*f*fd*s - 2130*D1*Dd*f*fd - 860*D1*Ddd*f**2*r**2 - 2608*D1*Ddd*f**2*r*s + 1734*D1*Ddd*f**2*r - 1748*D1*Ddd*f**2*s**2 + 2400*D1*Ddd*f**2*s - 1089*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(37*C - 26)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(54 - 72*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(54 - 72*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2580*Dd**2*f**2*r**2 - 7824*Dd**2*f**2*r*s + 5202*Dd**2*f**2*r - 5244*Dd**2*f**2*s**2 + 7200*Dd**2*f**2*s - 2178*Dd**2*f**2) + f*(-2376*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 66*D1**2*bdd1*f*(60*C*(5*r**2 + 2*r*(7*s - 6) + 9*s**2 - 16*s + 6) - 215*r**2 - 652*r*s + 520*r - 437*s**2 + 742*s - 260) - 5*D1**2*(f*(fd*(40*C*(303*r**2 + 843*r*s - 483*r + 540*s**2 - 641*s + 281) - 8595*r**2 - 25644*r*s + 14278*r - 17049*s**2 + 19914*s - 8548) + fdd*(-28*C*(471*r**2 + 1182*r*s - 708*r + 711*s**2 - 868*s + 394) + 9495*r**2 + 25494*r*s - 14828*r + 15999*s**2 - 19164*s + 8498)) + 2*fd**2*(-28*C*(471*r**2 + 1182*r*s - 708*r + 711*s**2 - 868*s + 197) + 9495*r**2 + 25494*r*s - 14828*r + 15999*s**2 - 19164*s + 4249)) - 66*D1*bd1*(D1*(f*(12*C*(19*r**2 + 68*r*s - 48*r + 49*s**2 - 78*s + 24) - 163*r**2 - 632*r*s + 410*r - 469*s**2 + 716*s - 205) + 2*fd*(-120*C*(5*r**2 + r*(14*s - 9) + (2 - 3*s)**2) + 430*r**2 + 1304*r*s - 801*r + 874*s**2 - 1134*s + 371)) + 2*Dd*f*(-60*C*(20*r**2 + 56*r*s - 43*r + 36*s**2 - 57*s + 22) + 860*r**2 + 2608*r*s - 1907*r + 1748*s**2 - 2684*s + 1002)) - 5*D1*f*(Dd*(f*(40*C*(404*r**2 + 1124*r*s - 764*r + 720*s**2 - 1001*s + 461) - 11460*r**2 - 34192*r*s + 22826*r - 22732*s**2 + 31280*s - 14231) - 2*fd*(28*C*(1884*r**2 + 4728*r*s - 3069*r + 2844*s**2 - 3749*s + 1222) - 37980*r**2 - 101976*r*s + 64645*r - 63996*s**2 + 83073*s - 26578)) + Ddd*f*(-28*C*(628*r**2 + 2*r*(788*s - 551) + 948*s**2 - 1342*s + 631) + 12660*r**2 + 33992*r*s - 23326*r + 21332*s**2 - 29830*s + 13831)) - 10*Dd**2*f**2*(-28*C*(942*r**2 + 3*r*(788*s - 551) + 1422*s**2 - 2013*s + 631) + 18990*r**2 + 50988*r*s - 34989*r + 31998*s**2 - 44745*s + 13831)))/(693*d**2*k3**6) - D1**2*Pk1*Pk3*ct**4*k1**2*st**2*(488*C - 348)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + 2*D1*f*(50*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(2*s**2 - 2*s + 1)) - 50*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k3**4) - 2*D1**2*Pk1*Pk3*ct**4*k1**2*(132*b1**2*(D1**2*(s - 1)*(fd*(44*C - 27) + fdd*(24 - 36*C))*(r + s - 1) + D1*(Dd*(f*(44*C - 27)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(36*C - 24)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(24 - 36*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(36*C - 24)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 66*b1*(D1**2*(f*(-24*bdd1*s*(3*C - 2)*(2*r + 2*s - 1) + fd*(-12*C*(12*r*(2*s - 1) + 62*s**2 - 56*s + 31) + 94*r*(2*s - 1) + 554*s**2 - 510*s + 277) + fdd*(12*C*(11*r*(2*s - 1) + 52*s**2 - 47*s + 26) - 83*r*(2*s - 1) - 466*s**2 + 426*s - 233)) + fd**2*(12*C*(11*r*(2*s - 1) + 52*s**2 - 47*s - 5) - 83*r*(2*s - 1) - 466*s**2 + 426*s + 40)) + 2*D1*bd1*(D1*(f*s*(44*C - 27)*(2*r + 2*s - 1) - fd*(36*C - 24)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(48 - 72*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(-2*f*(12*C*(24*r*s - 12*r + 62*s**2 - 68*s + 31) - 188*r*s + 94*r - 554*s**2 + 601*s - 277) + fd*(2*s - 1)*(12*C*(88*r + 208*s - 105) - 664*r - 1864*s + 935)) + Ddd*f*(12*C*(44*r*s - 22*r + 104*s**2 - 115*s + 52) - 332*r*s + 166*r - 932*s**2 + 1015*s - 466)) + Dd**2*f**2*(12*C*(66*r*(2*s - 1) + 312*s**2 - 345*s + 74) - 498*r*(2*s - 1) - 2796*s**2 + 3045*s - 632)) + f*(-1584*D1**2*bd1**2*s*(3*C - 2)*(2*r + 2*s - 1) + D1**2*(f*(66*bdd1*s*(12*C*(11*r + 26*s - 16) - 83*r - 233*s + 123) - 5*fd*(4*C*(686*r*(3*s - 1) + 3699*s**2 - 3152*s + 1233) - 1748*r*(3*s - 1) - 10701*s**2 + 8882*s - 3567) + 5*fdd*(28*C*(82*r*(3*s - 1) + 441*s**2 - 376*s + 147) - 1468*r*(3*s - 1) - 9063*s**2 + 7510*s - 3021)) + 10*fd**2*(28*C*(82*r*(3*s - 1) + 441*s**2 - 376*s + 41) - 1468*r*(3*s - 1) - 9063*s**2 + 7510*s - 734)) - 66*D1*bd1*(D1*(f*s*(12*C*(12*r + 31*s - 18) - 94*r - 277*s + 138) + fd*(-12*C*(11*r*(4*s - 1) + 104*s**2 - 79*s + 16) + 83*r*(4*s - 1) + 932*s**2 - 672*s + 123)) + Dd*f*(-12*C*(22*r*(4*s - 1) + 208*s**2 - 179*s + 32) + 166*r*(4*s - 1) + 1864*s**2 - 1507*s + 246)) - 10*D1*f*(Dd*(f*(4*C*(686*r*(2*s - 1) + 2466*s**2 - 2809*s + 1233) - 1748*r*(2*s - 1) - 7134*s**2 + 8008*s - 3567) - 4*fd*(7*C*(82*r*(12*s - 5) + 1764*s**2 - 1757*s + 417) - 367*r*(12*s - 5) - 9063*s**2 + 8837*s - 2061)) + Ddd*f*(-28*C*(82*r*(2*s - 1) + 294*s**2 - 335*s + 147) + 1468*r*(2*s - 1) + 6042*s**2 - 6776*s + 3021)) + 10*Dd**2*f**2*(28*C*(246*r*(2*s - 1) + 882*s**2 - 1005*s + 229) - 4404*r*(2*s - 1) - 18126*s**2 + 20328*s - 4489)))/(693*d**2*k3**4) - D1**2*Pk1*Pk3*ct**4*k1**2*(32*C - 16)*(198*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s))) + 99*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) - 2*f*(D1**2*(35*f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + s*(99*bd1**2*s - 70*fd**2*(3*s - 2))) + 70*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 70*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k2**2*k3**2) + 4*D1**2*Pk1*Pk3*ct**4*k2**6*st**2*(15444*C*D1**2*f**2*fd*r**2 + 30888*C*D1**2*f**2*fd*r*s - 20592*C*D1**2*f**2*fd*r + 15444*C*D1**2*f**2*fd*s**2 - 20592*C*D1**2*f**2*fd*s + 10296*C*D1**2*f**2*fd + 20592*C*D1*Dd*f**3*r**2 + 41184*C*D1*Dd*f**3*r*s - 30888*C*D1*Dd*f**3*r + 20592*C*D1*Dd*f**3*s**2 - 30888*C*D1*Dd*f**3*s + 15444*C*D1*Dd*f**3 + 2574*D1**2*K*bdd1*f**2*r**2 + 5148*D1**2*K*bdd1*f**2*r*s - 5148*D1**2*K*bdd1*f**2*r + 2574*D1**2*K*bdd1*f**2*s**2 - 5148*D1**2*K*bdd1*f**2*s + 2574*D1**2*K*bdd1*f**2 - 2574*D1**2*bd1**2*f*(-2*K + 5*f + 2)*(r + s - 1)**2 + 19500*D1**2*bdd1*f**3*r**2 + 39000*D1**2*bdd1*f**3*r*s - 39000*D1**2*bdd1*f**3*r + 19500*D1**2*bdd1*f**3*s**2 - 39000*D1**2*bdd1*f**3*s + 19500*D1**2*bdd1*f**3 - 2574*D1**2*bdd1*f**2*r**2 - 5148*D1**2*bdd1*f**2*r*s + 5148*D1**2*bdd1*f**2*r - 2574*D1**2*bdd1*f**2*s**2 + 5148*D1**2*bdd1*f**2*s - 2574*D1**2*bdd1*f**2 - 5148*D1**2*bdd1*f*g2*r**2 - 10296*D1**2*bdd1*f*g2*r*s + 10296*D1**2*bdd1*f*g2*r - 5148*D1**2*bdd1*f*g2*s**2 + 10296*D1**2*bdd1*f*g2*s - 5148*D1**2*bdd1*f*g2 - 121000*D1**2*f**3*fd*r**2 - 242000*D1**2*f**3*fd*r*s + 181500*D1**2*f**3*fd*r - 121000*D1**2*f**3*fd*s**2 + 181500*D1**2*f**3*fd*s - 90750*D1**2*f**3*fd + 73500*D1**2*f**3*fdd*r**2 + 147000*D1**2*f**3*fdd*r*s - 110250*D1**2*f**3*fdd*r + 73500*D1**2*f**3*fdd*s**2 - 110250*D1**2*f**3*fdd*s + 55125*D1**2*f**3*fdd + 220500*D1**2*f**2*fd**2*r**2 + 441000*D1**2*f**2*fd**2*r*s - 330750*D1**2*f**2*fd**2*r + 220500*D1**2*f**2*fd**2*s**2 - 330750*D1**2*f**2*fd**2*s + 110250*D1**2*f**2*fd**2 - 15444*D1**2*f**2*fd*r**2 - 30888*D1**2*f**2*fd*r*s + 20592*D1**2*f**2*fd*r - 15444*D1**2*f**2*fd*s**2 + 20592*D1**2*f**2*fd*s - 10296*D1**2*f**2*fd + 10296*D1**2*f**2*gd2*r**2 + 20592*D1**2*f**2*gd2*r*s - 20592*D1**2*f**2*gd2*r + 10296*D1**2*f**2*gd2*s**2 - 20592*D1**2*f**2*gd2*s + 10296*D1**2*f**2*gd2 - 5148*D1**2*f**2*gdd2*r**2 - 10296*D1**2*f**2*gdd2*r*s + 10296*D1**2*f**2*gdd2*r - 5148*D1**2*f**2*gdd2*s**2 + 10296*D1**2*f**2*gdd2*s - 5148*D1**2*f**2*gdd2 + 20592*D1**2*f*fd*g2*r**2 + 41184*D1**2*f*fd*g2*r*s - 20592*D1**2*f*fd*g2*r + 20592*D1**2*f*fd*g2*s**2 - 20592*D1**2*f*fd*g2*s + 10296*D1**2*f*fd*g2 - 20592*D1**2*f*fd*gd2*r**2 - 41184*D1**2*f*fd*gd2*r*s + 30888*D1**2*f*fd*gd2*r - 20592*D1**2*f*fd*gd2*s**2 + 30888*D1**2*f*fd*gd2*s - 10296*D1**2*f*fd*gd2 - 10296*D1**2*f*fdd*g2*r**2 - 20592*D1**2*f*fdd*g2*r*s + 10296*D1**2*f*fdd*g2*r - 10296*D1**2*f*fdd*g2*s**2 + 10296*D1**2*f*fdd*g2*s - 5148*D1**2*f*fdd*g2 - 10296*D1**2*fd**2*g2*r**2 - 20592*D1**2*fd**2*g2*r*s + 10296*D1**2*fd**2*g2*r - 10296*D1**2*fd**2*g2*s**2 + 10296*D1**2*fd**2*g2*s - 121000*D1*Dd*f**4*r**2 - 242000*D1*Dd*f**4*r*s + 181500*D1*Dd*f**4*r - 121000*D1*Dd*f**4*s**2 + 181500*D1*Dd*f**4*s - 90750*D1*Dd*f**4 + 588000*D1*Dd*f**3*fd*r**2 + 1176000*D1*Dd*f**3*fd*r*s - 882000*D1*Dd*f**3*fd*r + 588000*D1*Dd*f**3*fd*s**2 - 882000*D1*Dd*f**3*fd*s + 330750*D1*Dd*f**3*fd - 20592*D1*Dd*f**3*r**2 - 41184*D1*Dd*f**3*r*s + 30888*D1*Dd*f**3*r - 20592*D1*Dd*f**3*s**2 + 30888*D1*Dd*f**3*s - 15444*D1*Dd*f**3 + 41184*D1*Dd*f**2*g2*r**2 + 82368*D1*Dd*f**2*g2*r*s - 61776*D1*Dd*f**2*g2*r + 41184*D1*Dd*f**2*g2*s**2 - 61776*D1*Dd*f**2*g2*s + 30888*D1*Dd*f**2*g2 - 41184*D1*Dd*f**2*gd2*r**2 - 82368*D1*Dd*f**2*gd2*r*s + 72072*D1*Dd*f**2*gd2*r - 41184*D1*Dd*f**2*gd2*s**2 + 72072*D1*Dd*f**2*gd2*s - 30888*D1*Dd*f**2*gd2 - 82368*D1*Dd*f*fd*g2*r**2 - 164736*D1*Dd*f*fd*g2*r*s + 102960*D1*Dd*f*fd*g2*r - 82368*D1*Dd*f*fd*g2*s**2 + 102960*D1*Dd*f*fd*g2*s - 30888*D1*Dd*f*fd*g2 + 73500*D1*Ddd*f**4*r**2 + 147000*D1*Ddd*f**4*r*s - 110250*D1*Ddd*f**4*r + 73500*D1*Ddd*f**4*s**2 - 110250*D1*Ddd*f**4*s + 55125*D1*Ddd*f**4 - 20592*D1*Ddd*f**2*g2*r**2 - 41184*D1*Ddd*f**2*g2*r*s + 30888*D1*Ddd*f**2*g2*r - 20592*D1*Ddd*f**2*g2*s**2 + 30888*D1*Ddd*f**2*g2*s - 15444*D1*Ddd*f**2*g2 + 156*D1*bd1*(r + s - 1)*(33*C*D1*f**2*(r + s - 1) - D1*(195*f**3*(r + s - 1) + f**2*(33*K*(r + s - 1) - 250*fd*(3*r + 3*s - 2)) - 33*f*(fd*(K - 1)*(2*r + 2*s - 1) + (2*g2 - 2*gd2)*(r + s - 1)) + 66*fd*g2*(r + s)) + Dd*f*(250*f**2 + 33*f*(K - 1) - 66*g2)*(4*r + 4*s - 3)) + 220500*Dd**2*f**4*r**2 + 441000*Dd**2*f**4*r*s - 330750*Dd**2*f**4*r + 220500*Dd**2*f**4*s**2 - 330750*Dd**2*f**4*s + 110250*Dd**2*f**4 - 61776*Dd**2*f**2*g2*r**2 - 123552*Dd**2*f**2*g2*r*s + 92664*Dd**2*f**2*g2*r - 61776*Dd**2*f**2*g2*s**2 + 92664*Dd**2*f**2*g2*s - 30888*Dd**2*f**2*g2 + 1287*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(5*fd**2*(r + s - 1) + 2*fd*(K - 1)*(r + s) - fdd*(K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (2*K - 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-2*K + 5*f + 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-2*K + 5*f + 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 78*b1*(132*C*D1**2*f*fd*r**2 + 264*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*r + 132*C*D1**2*f*fd*s**2 - 132*C*D1**2*f*fd*s + 66*C*D1**2*f*fd + 264*C*D1*Dd*f**2*r**2 + 528*C*D1*Dd*f**2*r*s - 396*C*D1*Dd*f**2*r + 264*C*D1*Dd*f**2*s**2 - 396*C*D1*Dd*f**2*s + 198*C*D1*Dd*f**2 - 132*D1**2*K*f*fd*r**2 - 264*D1**2*K*f*fd*r*s + 132*D1**2*K*f*fd*r - 132*D1**2*K*f*fd*s**2 + 132*D1**2*K*f*fd*s - 66*D1**2*K*f*fd + 66*D1**2*K*f*fdd*r**2 + 132*D1**2*K*f*fdd*r*s - 66*D1**2*K*f*fdd*r + 66*D1**2*K*f*fdd*s**2 - 66*D1**2*K*f*fdd*s + 33*D1**2*K*f*fdd + 66*D1**2*K*fd**2*r**2 + 132*D1**2*K*fd**2*r*s - 66*D1**2*K*fd**2*r + 66*D1**2*K*fd**2*s**2 - 66*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(-2*K + 5*f + 2)*(r + s - 1)**2 - 1170*D1**2*f**2*fd*r**2 - 2340*D1**2*f**2*fd*r*s + 1560*D1**2*f**2*fd*r - 1170*D1**2*f**2*fd*s**2 + 1560*D1**2*f**2*fd*s - 780*D1**2*f**2*fd + 750*D1**2*f**2*fdd*r**2 + 1500*D1**2*f**2*fdd*r*s - 1000*D1**2*f**2*fdd*r + 750*D1**2*f**2*fdd*s**2 - 1000*D1**2*f**2*fdd*s + 500*D1**2*f**2*fdd + 1500*D1**2*f*fd**2*r**2 + 3000*D1**2*f*fd**2*r*s - 2000*D1**2*f*fd**2*r + 1500*D1**2*f*fd**2*s**2 - 2000*D1**2*f*fd**2*s + 500*D1**2*f*fd**2 - 66*D1**2*f*fdd*r**2 - 132*D1**2*f*fdd*r*s + 66*D1**2*f*fdd*r - 66*D1**2*f*fdd*s**2 + 66*D1**2*f*fdd*s - 33*D1**2*f*fdd + 132*D1**2*f*gd2*r**2 + 264*D1**2*f*gd2*r*s - 264*D1**2*f*gd2*r + 132*D1**2*f*gd2*s**2 - 264*D1**2*f*gd2*s + 132*D1**2*f*gd2 - 66*D1**2*f*gdd2*r**2 - 132*D1**2*f*gdd2*r*s + 132*D1**2*f*gdd2*r - 66*D1**2*f*gdd2*s**2 + 132*D1**2*f*gdd2*s - 66*D1**2*f*gdd2 - 66*D1**2*fd**2*r**2 - 132*D1**2*fd**2*r*s + 66*D1**2*fd**2*r - 66*D1**2*fd**2*s**2 + 66*D1**2*fd**2*s + 132*D1**2*fd*g2*r**2 + 264*D1**2*fd*g2*r*s + 132*D1**2*fd*g2*s**2 - 132*D1**2*fd*gd2*r**2 - 264*D1**2*fd*gd2*r*s + 132*D1**2*fd*gd2*r - 132*D1**2*fd*gd2*s**2 + 132*D1**2*fd*gd2*s - 66*D1**2*fdd*g2*r**2 - 132*D1**2*fdd*g2*r*s - 66*D1**2*fdd*g2*s**2 - 264*D1*Dd*K*f**2*r**2 - 528*D1*Dd*K*f**2*r*s + 396*D1*Dd*K*f**2*r - 264*D1*Dd*K*f**2*s**2 + 396*D1*Dd*K*f**2*s - 198*D1*Dd*K*f**2 + 528*D1*Dd*K*f*fd*r**2 + 1056*D1*Dd*K*f*fd*r*s - 660*D1*Dd*K*f*fd*r + 528*D1*Dd*K*f*fd*s**2 - 660*D1*Dd*K*f*fd*s + 198*D1*Dd*K*f*fd - 1560*D1*Dd*f**3*r**2 - 3120*D1*Dd*f**3*r*s + 2340*D1*Dd*f**3*r - 1560*D1*Dd*f**3*s**2 + 2340*D1*Dd*f**3*s - 1170*D1*Dd*f**3 + 6000*D1*Dd*f**2*fd*r**2 + 12000*D1*Dd*f**2*fd*r*s - 8500*D1*Dd*f**2*fd*r + 6000*D1*Dd*f**2*fd*s**2 - 8500*D1*Dd*f**2*fd*s + 3000*D1*Dd*f**2*fd - 528*D1*Dd*f*fd*r**2 - 1056*D1*Dd*f*fd*r*s + 660*D1*Dd*f*fd*r - 528*D1*Dd*f*fd*s**2 + 660*D1*Dd*f*fd*s - 198*D1*Dd*f*fd + 528*D1*Dd*f*g2*r**2 + 1056*D1*Dd*f*g2*r*s - 792*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s**2 - 792*D1*Dd*f*g2*s + 396*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r**2 - 1056*D1*Dd*f*gd2*r*s + 924*D1*Dd*f*gd2*r - 528*D1*Dd*f*gd2*s**2 + 924*D1*Dd*f*gd2*s - 396*D1*Dd*f*gd2 - 528*D1*Dd*fd*g2*r**2 - 1056*D1*Dd*fd*g2*r*s + 396*D1*Dd*fd*g2*r - 528*D1*Dd*fd*g2*s**2 + 396*D1*Dd*fd*g2*s + 132*D1*Ddd*K*f**2*r**2 + 264*D1*Ddd*K*f**2*r*s - 198*D1*Ddd*K*f**2*r + 132*D1*Ddd*K*f**2*s**2 - 198*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 + 1000*D1*Ddd*f**3*r**2 + 2000*D1*Ddd*f**3*r*s - 1500*D1*Ddd*f**3*r + 1000*D1*Ddd*f**3*s**2 - 1500*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 - 132*D1*Ddd*f**2*r**2 - 264*D1*Ddd*f**2*r*s + 198*D1*Ddd*f**2*r - 132*D1*Ddd*f**2*s**2 + 198*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 - 264*D1*Ddd*f*g2*r**2 - 528*D1*Ddd*f*g2*r*s + 396*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2*s**2 + 396*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 2*f*(K - 1)*(r + s - 1) + 2*fd*(K - 1)*(r + s)) - Dd*f*(-2*K + 5*f + 2)*(4*r + 4*s - 3))*(r + s - 1) + 396*Dd**2*K*f**2*r**2 + 792*Dd**2*K*f**2*r*s - 594*Dd**2*K*f**2*r + 396*Dd**2*K*f**2*s**2 - 594*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 + 3000*Dd**2*f**3*r**2 + 6000*Dd**2*f**3*r*s - 4500*Dd**2*f**3*r + 3000*Dd**2*f**3*s**2 - 4500*Dd**2*f**3*s + 1500*Dd**2*f**3 - 396*Dd**2*f**2*r**2 - 792*Dd**2*f**2*r*s + 594*Dd**2*f**2*r - 396*Dd**2*f**2*s**2 + 594*Dd**2*f**2*s - 198*Dd**2*f**2 - 792*Dd**2*f*g2*r**2 - 1584*Dd**2*f*g2*r*s + 1188*Dd**2*f*g2*r - 792*Dd**2*f*g2*s**2 + 1188*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(3003*d**2*k3**8) - 4*D1**2*Pk1*Pk3*ct**4*k2**4*st**2*(396*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-588*C*D1**2*f*fd*r**2 - 904*C*D1**2*f*fd*r*s + 404*C*D1**2*f*fd*r - 316*C*D1**2*f*fd*s**2 + 268*C*D1**2*f*fd*s - 134*C*D1**2*f*fd + 312*C*D1**2*f*fdd*r**2 + 536*C*D1**2*f*fdd*r*s - 244*C*D1**2*f*fdd*r + 224*C*D1**2*f*fdd*s**2 - 200*C*D1**2*f*fdd*s + 100*C*D1**2*f*fdd + 312*C*D1**2*fd**2*r**2 + 536*C*D1**2*fd**2*r*s - 244*C*D1**2*fd**2*r + 224*C*D1**2*fd**2*s**2 - 200*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 1176*C*D1*Dd*f**2*r**2 - 1808*C*D1*Dd*f**2*r*s + 1492*C*D1*Dd*f**2*r - 632*C*D1*Dd*f**2*s**2 + 1084*C*D1*Dd*f**2*s - 610*C*D1*Dd*f**2 + 2496*C*D1*Dd*f*fd*r**2 + 4288*C*D1*Dd*f*fd*r*s - 2672*C*D1*Dd*f*fd*r + 1792*C*D1*Dd*f*fd*s**2 - 2232*C*D1*Dd*f*fd*s + 644*C*D1*Dd*f*fd + 624*C*D1*Ddd*f**2*r**2 + 1072*C*D1*Ddd*f**2*r*s - 848*C*D1*Ddd*f**2*r + 448*C*D1*Ddd*f**2*s**2 - 716*C*D1*Ddd*f**2*s + 380*C*D1*Ddd*f**2 + 1872*C*Dd**2*f**2*r**2 + 3216*C*Dd**2*f**2*r*s - 2544*C*Dd**2*f**2*r + 1344*C*Dd**2*f**2*s**2 - 2148*C*Dd**2*f**2*s + 760*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 604*D1**2*f*fd*r**2 + 996*D1**2*f*fd*r*s - 450*D1**2*f*fd*r + 392*D1**2*f*fd*s**2 - 344*D1**2*f*fd*s + 172*D1**2*f*fd - 332*D1**2*f*fdd*r**2 - 606*D1**2*f*fdd*r*s + 279*D1**2*f*fdd*r - 274*D1**2*f*fdd*s**2 + 250*D1**2*f*fdd*s - 125*D1**2*f*fdd - 332*D1**2*fd**2*r**2 - 606*D1**2*fd**2*r*s + 279*D1**2*fd**2*r - 274*D1**2*fd**2*s**2 + 250*D1**2*fd**2*s + 24*D1**2*fd**2 + 1208*D1*Dd*f**2*r**2 + 1992*D1*Dd*f**2*r*s - 1600*D1*Dd*f**2*r + 784*D1*Dd*f**2*s**2 - 1282*D1*Dd*f**2*s + 694*D1*Dd*f**2 - 2656*D1*Dd*f*fd*r**2 - 4848*D1*Dd*f*fd*r*s + 2992*D1*Dd*f*fd*r - 2192*D1*Dd*f*fd*s**2 + 2702*D1*Dd*f*fd*s - 779*D1*Dd*f*fd - 664*D1*Ddd*f**2*r**2 - 1212*D1*Ddd*f**2*r*s + 938*D1*Ddd*f**2*r - 548*D1*Ddd*f**2*s**2 + 851*D1*Ddd*f**2*s - 440*D1*Ddd*f**2 + 24*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 1992*Dd**2*f**2*r**2 - 3636*Dd**2*f**2*r*s + 2814*Dd**2*f**2*r - 1644*Dd**2*f**2*s**2 + 2553*Dd**2*f**2*s - 880*Dd**2*f**2) + f*(-26610*C*D1**2*f*fd*r**2 - 41268*C*D1**2*f*fd*r*s + 31496*C*D1**2*f*fd*r - 14658*C*D1**2*f*fd*s**2 + 23528*C*D1**2*f*fd*s - 13756*C*D1**2*f*fd + 16968*C*D1**2*f*fdd*r**2 + 27564*C*D1**2*f*fdd*r*s - 20500*C*D1**2*f*fdd*r + 10596*C*D1**2*f*fdd*s**2 - 16252*C*D1**2*f*fdd*s + 9188*C*D1**2*f*fdd + 33936*C*D1**2*fd**2*r**2 + 55128*C*D1**2*fd**2*r*s - 41000*C*D1**2*fd**2*r + 21192*C*D1**2*fd**2*s**2 - 32504*C*D1**2*fd**2*s + 9188*C*D1**2*fd**2 - 35480*C*D1*Dd*f**2*r**2 - 55024*C*D1*Dd*f**2*r*s + 45252*C*D1*Dd*f**2*r - 19544*C*D1*Dd*f**2*s**2 + 33300*C*D1*Dd*f**2*s - 18642*C*D1*Dd*f**2 + 135744*C*D1*Dd*f*fd*r**2 + 220512*C*D1*Dd*f*fd*r*s - 171064*C*D1*Dd*f*fd*r + 84768*C*D1*Dd*f*fd*s**2 - 134956*C*D1*Dd*f*fd*s + 53004*C*D1*Dd*f*fd + 22624*C*D1*Ddd*f**2*r**2 + 36752*C*D1*Ddd*f**2*r*s - 29688*C*D1*Ddd*f**2*r + 14128*C*D1*Ddd*f**2*s**2 - 23316*C*D1*Ddd*f**2*s + 12720*C*D1*Ddd*f**2 + 67872*C*Dd**2*f**2*r**2 + 110256*C*Dd**2*f**2*r*s - 89064*C*Dd**2*f**2*r + 42384*C*Dd**2*f**2*s**2 - 69948*C*Dd**2*f**2*s + 25440*C*Dd**2*f**2 - 792*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(4*C*(39*r**2 + 67*r*s - 84*r + 28*s**2 - 73*s + 42) - 166*r**2 - 303*r*s + 356*r - 137*s**2 + 327*s - 178) + 26754*D1**2*f*fd*r**2 + 43974*D1**2*f*fd*r*s - 32494*D1**2*f*fd*r + 17220*D1**2*f*fd*s**2 - 26138*D1**2*f*fd*s + 14658*D1**2*f*fd - 17238*D1**2*f*fdd*r**2 - 29709*D1**2*f*fdd*r*s + 21395*D1**2*f*fdd*r - 12471*D1**2*f*fdd*s**2 + 18217*D1**2*f*fdd*s - 9903*D1**2*f*fdd - 34476*D1**2*fd**2*r**2 - 59418*D1**2*fd**2*r*s + 42790*D1**2*fd**2*r - 24942*D1**2*fd**2*s**2 + 36434*D1**2*fd**2*s - 9903*D1**2*fd**2 + 35672*D1*Dd*f**2*r**2 + 58632*D1*Dd*f**2*r*s - 47152*D1*Dd*f**2*r + 22960*D1*Dd*f**2*s**2 - 37618*D1*Dd*f**2*s + 20398*D1*Dd*f**2 - 137904*D1*Dd*f*fd*r**2 - 237672*D1*Dd*f*fd*r*s + 179474*D1*Dd*f*fd*r - 99768*D1*Dd*f*fd*s**2 + 152461*D1*Dd*f*fd*s - 57829*D1*Dd*f*fd - 22984*D1*Ddd*f**2*r**2 - 39612*D1*Ddd*f**2*r*s + 31298*D1*Ddd*f**2*r - 16628*D1*Ddd*f**2*s**2 + 26531*D1*Ddd*f**2*s - 14060*D1*Ddd*f**2 - 33*D1*bd1*(D1*(2*f*(C*(147*r**2 + 226*r*s - 318*r + 79*s**2 - 250*s + 159) - 151*r**2 - 249*r*s + 326*r - 98*s**2 + 273*s - 163) + fd*(-4*C*(156*r**2 + 268*r*s - 229*r + 112*s**2 - 196*s + 73) + 664*r**2 + 1212*r*s - 991*r + 548*s**2 - 904*s + 327)) + Dd*f*(-4*C*(312*r**2 + 536*r*s - 548*r + 224*s**2 - 471*s + 230) + 1328*r**2 + 2424*r*s - 2362*r + 1096*s**2 - 2159*s + 1010)) - 68952*Dd**2*f**2*r**2 - 118836*Dd**2*f**2*r*s + 93894*Dd**2*f**2*r - 49884*Dd**2*f**2*s**2 + 79593*Dd**2*f**2*s - 28120*Dd**2*f**2))/(693*d**2*k3**6) + 4*D1**2*Pk1*Pk3*ct**4*k2**4*(-180180*C*D1**2*f**2*fd*r**2 - 205920*C*D1**2*f**2*fd*r*s + 188760*C*D1**2*f**2*fd*r - 25740*C*D1**2*f**2*fd*s**2 + 85800*C*D1**2*f**2*fd*s - 68640*C*D1**2*f**2*fd - 240240*C*D1*Dd*f**3*r**2 - 274560*C*D1*Dd*f**3*r*s + 257400*C*D1*Dd*f**3*r - 34320*C*D1*Dd*f**3*s**2 + 102960*C*D1*Dd*f**3*s - 77220*C*D1*Dd*f**3 - 34320*D1**2*K*bdd1*f**2*r**2 - 60060*D1**2*K*bdd1*f**2*r*s + 60060*D1**2*K*bdd1*f**2*r - 25740*D1**2*K*bdd1*f**2*s**2 + 51480*D1**2*K*bdd1*f**2*s - 25740*D1**2*K*bdd1*f**2 + 858*D1**2*bd1**2*(r + s - 1)*(2*f**2*(51*r + 57*s - 44) + f*(K*(-59*r - 59*s + 71) + 83*r + 95*s - 101) - 28*g2*(r + s)) + 8580*D1**2*bd2*f**2*r**2 + 17160*D1**2*bd2*f**2*r*s - 17160*D1**2*bd2*f**2*r + 8580*D1**2*bd2*f**2*s**2 - 17160*D1**2*bd2*f**2*s + 8580*D1**2*bd2*f**2 - 17160*D1**2*bd2*f*fd*r**2 - 34320*D1**2*bd2*f*fd*r*s + 25740*D1**2*bd2*f*fd*r - 17160*D1**2*bd2*f*fd*s**2 + 25740*D1**2*bd2*f*fd*s - 8580*D1**2*bd2*f*fd + 18590*D1**2*bdd1*f**3*r**2 - 15990*D1**2*bdd1*f**3*r*s - 14430*D1**2*bdd1*f**3*r - 34580*D1**2*bdd1*f**3*s**2 + 38740*D1**2*bdd1*f**3*s + 6760*D1**2*bdd1*f**3 + 41184*D1**2*bdd1*f**2*r**2 + 79794*D1**2*bdd1*f**2*r*s - 79794*D1**2*bdd1*f**2*r + 38610*D1**2*bdd1*f**2*s**2 - 77220*D1**2*bdd1*f**2*s + 38610*D1**2*bdd1*f**2 + 50622*D1**2*bdd1*f*g2*r**2 + 101244*D1**2*bdd1*f*g2*r*s - 121836*D1**2*bdd1*f*g2*r + 50622*D1**2*bdd1*f*g2*s**2 - 121836*D1**2*bdd1*f*g2*s + 60918*D1**2*bdd1*f*g2 - 4290*D1**2*bdd2*f**2*r**2 - 8580*D1**2*bdd2*f**2*r*s + 8580*D1**2*bdd2*f**2*r - 4290*D1**2*bdd2*f**2*s**2 + 8580*D1**2*bdd2*f**2*s - 4290*D1**2*bdd2*f**2 + 115920*D1**2*f**3*fd*r**2 + 341600*D1**2*f**3*fd*r*s - 228760*D1**2*f**3*fd*r + 225680*D1**2*f**3*fd*s**2 - 311080*D1**2*f**3*fd*s + 141820*D1**2*f**3*fd - 112560*D1**2*f**3*fdd*r**2 - 381920*D1**2*f**3*fdd*r*s + 247240*D1**2*f**3*fdd*r - 269360*D1**2*f**3*fdd*s**2 + 364840*D1**2*f**3*fdd*s - 162820*D1**2*f**3*fdd - 337680*D1**2*f**2*fd**2*r**2 - 1145760*D1**2*f**2*fd**2*r*s + 741720*D1**2*f**2*fd**2*r - 808080*D1**2*f**2*fd**2*s**2 + 1094520*D1**2*f**2*fd**2*s - 325640*D1**2*f**2*fd**2 + 180180*D1**2*f**2*fd*r**2 + 218790*D1**2*f**2*fd*r*s - 193050*D1**2*f**2*fd*r + 38610*D1**2*f**2*fd*s**2 - 98670*D1**2*f**2*fd*s + 72930*D1**2*f**2*fd - 142428*D1**2*f**2*gd2*r**2 - 188760*D1**2*f**2*gd2*r*s + 188760*D1**2*f**2*gd2*r - 46332*D1**2*f**2*gd2*s**2 + 92664*D1**2*f**2*gd2*s - 46332*D1**2*f**2*gd2 + 68640*D1**2*f**2*gdd2*r**2 + 120120*D1**2*f**2*gdd2*r*s - 120120*D1**2*f**2*gdd2*r + 51480*D1**2*f**2*gdd2*s**2 - 102960*D1**2*f**2*gdd2*s + 51480*D1**2*f**2*gdd2 - 284856*D1**2*f*fd*g2*r**2 - 377520*D1**2*f*fd*g2*r*s + 284856*D1**2*f*fd*g2*r - 92664*D1**2*f*fd*g2*s**2 + 188760*D1**2*f*fd*g2*s - 142428*D1**2*f*fd*g2 + 274560*D1**2*f*fd*gd2*r**2 + 480480*D1**2*f*fd*gd2*r*s - 377520*D1**2*f*fd*gd2*r + 205920*D1**2*f*fd*gd2*s**2 - 326040*D1**2*f*fd*gd2*s + 120120*D1**2*f*fd*gd2 + 137280*D1**2*f*fdd*g2*r**2 + 240240*D1**2*f*fdd*g2*r*s - 137280*D1**2*f*fdd*g2*r + 102960*D1**2*f*fdd*g2*s**2 - 120120*D1**2*f*fdd*g2*s + 68640*D1**2*f*fdd*g2 + 137280*D1**2*fd**2*g2*r**2 + 240240*D1**2*fd**2*g2*r*s - 137280*D1**2*fd**2*g2*r + 102960*D1**2*fd**2*g2*s**2 - 120120*D1**2*fd**2*g2*s - 34320*D1*Dd*bd2*f**2*r**2 - 68640*D1*Dd*bd2*f**2*r*s + 60060*D1*Dd*bd2*f**2*r - 34320*D1*Dd*bd2*f**2*s**2 + 60060*D1*Dd*bd2*f**2*s - 25740*D1*Dd*bd2*f**2 + 115920*D1*Dd*f**4*r**2 + 341600*D1*Dd*f**4*r*s - 228760*D1*Dd*f**4*r + 225680*D1*Dd*f**4*s**2 - 311080*D1*Dd*f**4*s + 141820*D1*Dd*f**4 - 900480*D1*Dd*f**3*fd*r**2 - 3055360*D1*Dd*f**3*fd*r*s + 1977920*D1*Dd*f**3*fd*r - 2154880*D1*Dd*f**3*fd*s**2 + 2918720*D1*Dd*f**3*fd*s - 976920*D1*Dd*f**3*fd + 240240*D1*Dd*f**3*r**2 + 291720*D1*Dd*f**3*r*s - 265980*D1*Dd*f**3*r + 51480*D1*Dd*f**3*s**2 - 124410*D1*Dd*f**3*s + 85800*D1*Dd*f**3 - 569712*D1*Dd*f**2*g2*r**2 - 755040*D1*Dd*f**2*g2*r*s + 662376*D1*Dd*f**2*g2*r - 185328*D1*Dd*f**2*g2*s**2 + 374088*D1*Dd*f**2*g2*s - 235092*D1*Dd*f**2*g2 + 549120*D1*Dd*f**2*gd2*r**2 + 960960*D1*Dd*f**2*gd2*r*s - 858000*D1*Dd*f**2*gd2*r + 411840*D1*Dd*f**2*gd2*s**2 - 737880*D1*Dd*f**2*gd2*s + 326040*D1*Dd*f**2*gd2 + 1098240*D1*Dd*f*fd*g2*r**2 + 1921920*D1*Dd*f*fd*g2*r*s - 1304160*D1*Dd*f*fd*g2*r + 823680*D1*Dd*f*fd*g2*s**2 - 1132560*D1*Dd*f*fd*g2*s + 377520*D1*Dd*f*fd*g2 - 112560*D1*Ddd*f**4*r**2 - 381920*D1*Ddd*f**4*r*s + 247240*D1*Ddd*f**4*r - 269360*D1*Ddd*f**4*s**2 + 364840*D1*Ddd*f**4*s - 162820*D1*Ddd*f**4 + 274560*D1*Ddd*f**2*g2*r**2 + 480480*D1*Ddd*f**2*g2*r*s - 377520*D1*Ddd*f**2*g2*r + 205920*D1*Ddd*f**2*g2*s**2 - 326040*D1*Ddd*f**2*g2*s + 171600*D1*Ddd*f**2*g2 - 26*D1*bd1*(396*D1*bd2*f*(r + s - 1)**2 + D1*(5*f**3*(253*r**2 + 3*r*(39*s - 85) - 136*s**2 + 134*s + 104) + f**2*(396*C*(6*r**2 + 2*r*(3*s - 7) - 8*s + 7) - 33*K*(83*r**2 + 110*r*(s - 1) + 27*(s - 1)**2) - 5*fd*(858*r**2 - 2*r*(369*s + 131) - 1596*s**2 + 1783*s - 589) + 495*r**2 + 594*r*(3*s + 2) + 1287*s**2 + 396*s - 1287) + 33*f*(fd*(10*K*(16*r**2 + 28*r*s - 22*r + 12*s**2 - 19*s + 7) - 192*r**2 - 372*r*s + 282*r - 180*s**2 + 273*s - 93) + g2*(125*r**2 + 2*r*(83*s - 149) + 41*s**2 - 214*s + 149) - 2*gd2*(59*r**2 + 2*r*(59*s - 65) + 59*s**2 - 130*s + 71)) - 3894*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + Dd*f*(-5*f**2*(1144*r**2 - 4*r*(246*s + 121) - 2128*s**2 + 2379*s - 485) + 33*f*(10*K*(32*r**2 + 56*r*s - 50*r + 24*s**2 - 43*s + 19) - 384*r**2 - 744*r*s + 654*r - 360*s**2 + 633*s - 273) - 66*g2*(236*r**2 + r*(472*s - 461) + 236*s**2 - 461*s + 213))) - 337680*Dd**2*f**4*r**2 - 1145760*Dd**2*f**4*r*s + 741720*Dd**2*f**4*r - 808080*Dd**2*f**4*s**2 + 1094520*Dd**2*f**4*s - 325640*Dd**2*f**4 + 823680*Dd**2*f**2*g2*r**2 + 1441440*Dd**2*f**2*g2*r*s - 1132560*Dd**2*f**2*g2*r + 617760*Dd**2*f**2*g2*s**2 - 978120*Dd**2*f**2*g2*s + 343200*Dd**2*f**2*g2 + 858*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (7*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-7*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-7*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(28*C*D1**2*fd*r**2 + 56*C*D1**2*fd*r*s - 56*C*D1**2*fd*r + 28*C*D1**2*fd*s**2 - 56*C*D1**2*fd*s + 28*C*D1**2*fd + 112*C*D1*Dd*f*r**2 + 224*C*D1*Dd*f*r*s - 168*C*D1*Dd*f*r + 112*C*D1*Dd*f*s**2 - 168*C*D1*Dd*f*s + 84*C*D1*Dd*f + 125*D1**2*K*fd*r**2 + 166*D1**2*K*fd*r*s + 48*D1**2*K*fd*r + 41*D1**2*K*fd*s**2 + 48*D1**2*K*fd*s - 24*D1**2*K*fd - 59*D1**2*K*fdd*r**2 - 118*D1**2*K*fdd*r*s - 24*D1**2*K*fdd*r - 59*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 2*D1**2*bdd1*(-7*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 204*D1**2*f*fd*r**2 - 432*D1**2*f*fd*r*s + 248*D1**2*f*fd*r - 228*D1**2*f*fd*s**2 + 260*D1**2*f*fd*s - 130*D1**2*f*fd + 204*D1**2*f*fdd*r**2 + 432*D1**2*f*fdd*r*s - 256*D1**2*f*fdd*r + 228*D1**2*f*fdd*s**2 - 268*D1**2*f*fdd*s + 134*D1**2*f*fdd + 204*D1**2*fd**2*r**2 + 432*D1**2*fd**2*r*s - 256*D1**2*fd**2*r + 228*D1**2*fd**2*s**2 - 268*D1**2*fd**2*s + 40*D1**2*fd**2 - 173*D1**2*fd*r**2 - 286*D1**2*fd*r*s + 8*D1**2*fd*r - 113*D1**2*fd*s**2 + 8*D1**2*fd*s - 4*D1**2*fd + 83*D1**2*fdd*r**2 + 178*D1**2*fdd*r*s + 24*D1**2*fdd*r + 95*D1**2*fdd*s**2 + 24*D1**2*fdd*s - 12*D1**2*fdd + 56*D1**2*gd2*r**2 + 112*D1**2*gd2*r*s - 112*D1**2*gd2*r + 56*D1**2*gd2*s**2 - 112*D1**2*gd2*s + 56*D1**2*gd2 - 28*D1**2*gdd2*r**2 - 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*r - 28*D1**2*gdd2*s**2 + 56*D1**2*gdd2*s - 28*D1**2*gdd2 + 500*D1*Dd*K*f*r**2 + 664*D1*Dd*K*f*r*s - 582*D1*Dd*K*f*r + 164*D1*Dd*K*f*s**2 - 330*D1*Dd*K*f*s + 207*D1*Dd*K*f - 472*D1*Dd*K*fd*r**2 - 944*D1*Dd*K*fd*r*s + 258*D1*Dd*K*fd*r - 472*D1*Dd*K*fd*s**2 + 258*D1*Dd*K*fd*s + 72*D1*Dd*K*fd - 408*D1*Dd*f**2*r**2 - 864*D1*Dd*f**2*r*s + 636*D1*Dd*f**2*r - 456*D1*Dd*f**2*s**2 + 672*D1*Dd*f**2*s - 330*D1*Dd*f**2 + 1632*D1*Dd*f*fd*r**2 + 3456*D1*Dd*f*fd*r*s - 2296*D1*Dd*f*fd*r + 1824*D1*Dd*f*fd*s**2 - 2416*D1*Dd*f*fd*s + 792*D1*Dd*f*fd - 692*D1*Dd*f*r**2 - 1144*D1*Dd*f*r*s + 918*D1*Dd*f*r - 452*D1*Dd*f*s**2 + 738*D1*Dd*f*s - 399*D1*Dd*f + 664*D1*Dd*fd*r**2 + 1424*D1*Dd*fd*r*s - 426*D1*Dd*fd*r + 760*D1*Dd*fd*s**2 - 462*D1*Dd*fd*s - 72*D1*Dd*fd + 224*D1*Dd*g2*r**2 + 448*D1*Dd*g2*r*s - 336*D1*Dd*g2*r + 224*D1*Dd*g2*s**2 - 336*D1*Dd*g2*s + 168*D1*Dd*g2 - 224*D1*Dd*gd2*r**2 - 448*D1*Dd*gd2*r*s + 392*D1*Dd*gd2*r - 224*D1*Dd*gd2*s**2 + 392*D1*Dd*gd2*s - 168*D1*Dd*gd2 - 236*D1*Ddd*K*f*r**2 - 472*D1*Ddd*K*f*r*s + 354*D1*Ddd*K*f*r - 236*D1*Ddd*K*f*s**2 + 354*D1*Ddd*K*f*s - 177*D1*Ddd*K*f + 408*D1*Ddd*f**2*r**2 + 864*D1*Ddd*f**2*r*s - 636*D1*Ddd*f**2*r + 456*D1*Ddd*f**2*s**2 - 672*D1*Ddd*f**2*s + 330*D1*Ddd*f**2 + 332*D1*Ddd*f*r**2 + 712*D1*Ddd*f*r*s - 522*D1*Ddd*f*r + 380*D1*Ddd*f*s**2 - 558*D1*Ddd*f*s + 273*D1*Ddd*f - 112*D1*Ddd*g2*r**2 - 224*D1*Ddd*g2*r*s + 168*D1*Ddd*g2*r - 112*D1*Ddd*g2*s**2 + 168*D1*Ddd*g2*s - 84*D1*Ddd*g2 + 4*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (7*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-7*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 708*Dd**2*K*f*r**2 - 1416*Dd**2*K*f*r*s + 1062*Dd**2*K*f*r - 708*Dd**2*K*f*s**2 + 1062*Dd**2*K*f*s - 354*Dd**2*K*f + 1224*Dd**2*f**2*r**2 + 2592*Dd**2*f**2*r*s - 1908*Dd**2*f**2*r + 1368*Dd**2*f**2*s**2 - 2016*Dd**2*f**2*s + 660*Dd**2*f**2 + 996*Dd**2*f*r**2 + 2136*Dd**2*f*r*s - 1566*Dd**2*f*r + 1140*Dd**2*f*s**2 - 1674*Dd**2*f*s + 546*Dd**2*f - 336*Dd**2*g2*r**2 - 672*Dd**2*g2*r*s + 504*Dd**2*g2*r - 336*Dd**2*g2*s**2 + 504*Dd**2*g2*s - 168*Dd**2*g2) - 26*b1*(4752*C*D1**2*f*fd*r**2 + 4752*C*D1**2*f*fd*r*s - 1584*C*D1**2*f*fd*r + 792*C*D1**2*f*fd*s - 396*C*D1**2*f*fd + 9504*C*D1*Dd*f**2*r**2 + 9504*C*D1*Dd*f**2*r*s - 9504*C*D1*Dd*f**2*r - 2376*C*D1*Dd*f**2*s + 2376*C*D1*Dd*f**2 + 1947*D1**2*K*bdd1*f*r**2 + 3894*D1**2*K*bdd1*f*r*s - 4290*D1**2*K*bdd1*f*r + 1947*D1**2*K*bdd1*f*s**2 - 4290*D1**2*K*bdd1*f*s + 2145*D1**2*K*bdd1*f - 5478*D1**2*K*f*fd*r**2 - 7260*D1**2*K*f*fd*r*s + 5478*D1**2*K*f*fd*r - 1782*D1**2*K*f*fd*s**2 + 3630*D1**2*K*f*fd*s - 2739*D1**2*K*f*fd + 2640*D1**2*K*f*fdd*r**2 + 4620*D1**2*K*f*fdd*r*s - 2640*D1**2*K*f*fdd*r + 1980*D1**2*K*f*fdd*s**2 - 2310*D1**2*K*f*fdd*s + 1320*D1**2*K*f*fdd + 2640*D1**2*K*fd**2*r**2 + 4620*D1**2*K*fd**2*r*s - 2640*D1**2*K*fd**2*r + 1980*D1**2*K*fd**2*s**2 - 2310*D1**2*K*fd**2*s - 396*D1**2*b2*fd*r**2 - 792*D1**2*b2*fd*r*s - 396*D1**2*b2*fd*s**2 + 198*D1**2*b2*fdd*r**2 + 396*D1**2*b2*fdd*r*s + 198*D1**2*b2*fdd*s**2 + 66*D1**2*bd1**2*(-7*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 3366*D1**2*bdd1*f**2*r**2 - 7128*D1**2*bdd1*f**2*r*s + 6270*D1**2*bdd1*f**2*r - 3762*D1**2*bdd1*f**2*s**2 + 6666*D1**2*bdd1*f**2*s - 3234*D1**2*bdd1*f**2 - 2739*D1**2*bdd1*f*r**2 - 5874*D1**2*bdd1*f*r*s + 6072*D1**2*bdd1*f*r - 3135*D1**2*bdd1*f*s**2 + 6468*D1**2*bdd1*f*s - 3135*D1**2*bdd1*f + 924*D1**2*bdd1*g2*r**2 + 1848*D1**2*bdd1*g2*r*s - 924*D1**2*bdd1*g2*r + 924*D1**2*bdd1*g2*s**2 - 924*D1**2*bdd1*g2*s + 462*D1**2*bdd1*g2 + 198*D1**2*bdd2*f*r**2 + 396*D1**2*bdd2*f*r*s - 396*D1**2*bdd2*f*r + 198*D1**2*bdd2*f*s**2 - 396*D1**2*bdd2*f*s + 198*D1**2*bdd2*f + 3795*D1**2*f**2*fd*r**2 + 1755*D1**2*f**2*fd*r*s - 2425*D1**2*f**2*fd*r - 2040*D1**2*f**2*fd*s**2 + 1465*D1**2*f**2*fd*s - 615*D1**2*f**2*fd - 2145*D1**2*f**2*fdd*r**2 + 1845*D1**2*f**2*fdd*r*s - 355*D1**2*f**2*fdd*r + 3990*D1**2*f**2*fdd*s**2 - 4445*D1**2*f**2*fdd*s + 2205*D1**2*f**2*fdd - 4290*D1**2*f*fd**2*r**2 + 3690*D1**2*f*fd**2*r*s - 710*D1**2*f*fd**2*r + 7980*D1**2*f*fd**2*s**2 - 8890*D1**2*f*fd**2*s + 945*D1**2*f*fd**2 + 990*D1**2*f*fd*r**2 + 3564*D1**2*f*fd*r*s - 3960*D1**2*f*fd*r + 2574*D1**2*f*fd*s**2 - 4752*D1**2*f*fd*s + 3069*D1**2*f*fd - 3168*D1**2*f*fdd*r**2 - 6138*D1**2*f*fdd*r*s + 3168*D1**2*f*fdd*r - 2970*D1**2*f*fdd*s**2 + 3069*D1**2*f*fdd*s - 1584*D1**2*f*fdd + 4125*D1**2*f*gd2*r**2 + 5478*D1**2*f*gd2*r*s - 5478*D1**2*f*gd2*r + 1353*D1**2*f*gd2*s**2 - 2706*D1**2*f*gd2*s + 1353*D1**2*f*gd2 - 1947*D1**2*f*gdd2*r**2 - 3894*D1**2*f*gdd2*r*s + 3894*D1**2*f*gdd2*r - 1947*D1**2*f*gdd2*s**2 + 3894*D1**2*f*gdd2*s - 1947*D1**2*f*gdd2 - 3168*D1**2*fd**2*r**2 - 6138*D1**2*fd**2*r*s + 3168*D1**2*fd**2*r - 2970*D1**2*fd**2*s**2 + 3069*D1**2*fd**2*s + 4125*D1**2*fd*g2*r**2 + 5478*D1**2*fd*g2*r*s + 1584*D1**2*fd*g2*r + 1353*D1**2*fd*g2*s**2 + 1584*D1**2*fd*g2*s - 792*D1**2*fd*g2 - 3894*D1**2*fd*gd2*r**2 - 7788*D1**2*fd*gd2*r*s + 3102*D1**2*fd*gd2*r - 3894*D1**2*fd*gd2*s**2 + 3102*D1**2*fd*gd2*s + 792*D1**2*fd*gd2 - 1947*D1**2*fdd*g2*r**2 - 3894*D1**2*fdd*g2*r*s - 792*D1**2*fdd*g2*r - 1947*D1**2*fdd*g2*s**2 - 792*D1**2*fdd*g2*s + 396*D1**2*fdd*g2 - 10956*D1*Dd*K*f**2*r**2 - 14520*D1*Dd*K*f**2*r*s + 12738*D1*Dd*K*f**2*r - 3564*D1*Dd*K*f**2*s**2 + 7194*D1*Dd*K*f**2*s - 4521*D1*Dd*K*f**2 + 21120*D1*Dd*K*f*fd*r**2 + 36960*D1*Dd*K*f*fd*r*s - 25080*D1*Dd*K*f*fd*r + 15840*D1*Dd*K*f*fd*s**2 - 21780*D1*Dd*K*f*fd*s + 7260*D1*Dd*K*f*fd - 1584*D1*Dd*b2*f*r**2 - 3168*D1*Dd*b2*f*r*s + 2376*D1*Dd*b2*f*r - 1584*D1*Dd*b2*f*s**2 + 2376*D1*Dd*b2*f*s - 1188*D1*Dd*b2*f + 1584*D1*Dd*b2*fd*r**2 + 3168*D1*Dd*b2*fd*r*s - 1188*D1*Dd*b2*fd*r + 1584*D1*Dd*b2*fd*s**2 - 1188*D1*Dd*b2*fd*s + 5060*D1*Dd*f**3*r**2 + 2340*D1*Dd*f**3*r*s - 3700*D1*Dd*f**3*r - 2720*D1*Dd*f**3*s**2 + 2135*D1*Dd*f**3*s - 95*D1*Dd*f**3 - 17160*D1*Dd*f**2*fd*r**2 + 14760*D1*Dd*f**2*fd*r*s - 820*D1*Dd*f**2*fd*r + 31920*D1*Dd*f**2*fd*s**2 - 35585*D1*Dd*f**2*fd*s + 9245*D1*Dd*f**2*fd + 1980*D1*Dd*f**2*r**2 + 7128*D1*Dd*f**2*r*s - 4554*D1*Dd*f**2*r + 5148*D1*Dd*f**2*s**2 - 6930*D1*Dd*f**2*s + 3069*D1*Dd*f**2 - 25344*D1*Dd*f*fd*r**2 - 49104*D1*Dd*f*fd*r*s + 31284*D1*Dd*f*fd*r - 23760*D1*Dd*f*fd*s**2 + 30294*D1*Dd*f*fd*s - 9306*D1*Dd*f*fd + 16500*D1*Dd*f*g2*r**2 + 21912*D1*Dd*f*g2*r*s - 19206*D1*Dd*f*g2*r + 5412*D1*Dd*f*g2*s**2 - 10890*D1*Dd*f*g2*s + 6831*D1*Dd*f*g2 - 15576*D1*Dd*f*gd2*r**2 - 31152*D1*Dd*f*gd2*r*s + 27258*D1*Dd*f*gd2*r - 15576*D1*Dd*f*gd2*s**2 + 27258*D1*Dd*f*gd2*s - 11682*D1*Dd*f*gd2 - 15576*D1*Dd*fd*g2*r**2 - 31152*D1*Dd*fd*g2*r*s + 8514*D1*Dd*fd*g2*r - 15576*D1*Dd*fd*g2*s**2 + 8514*D1*Dd*fd*g2*s + 2376*D1*Dd*fd*g2 + 5280*D1*Ddd*K*f**2*r**2 + 9240*D1*Ddd*K*f**2*r*s - 7260*D1*Ddd*K*f**2*r + 3960*D1*Ddd*K*f**2*s**2 - 6270*D1*Ddd*K*f**2*s + 3300*D1*Ddd*K*f**2 + 792*D1*Ddd*b2*f*r**2 + 1584*D1*Ddd*b2*f*r*s - 1188*D1*Ddd*b2*f*r + 792*D1*Ddd*b2*f*s**2 - 1188*D1*Ddd*b2*f*s + 594*D1*Ddd*b2*f - 2860*D1*Ddd*f**3*r**2 + 2460*D1*Ddd*f**3*r*s + 200*D1*Ddd*f**3*r + 5320*D1*Ddd*f**3*s**2 - 5935*D1*Ddd*f**3*s + 1945*D1*Ddd*f**3 - 6336*D1*Ddd*f**2*r**2 - 12276*D1*Ddd*f**2*r*s + 9306*D1*Ddd*f**2*r - 5940*D1*Ddd*f**2*s**2 + 9009*D1*Ddd*f**2*s - 4554*D1*Ddd*f**2 - 7788*D1*Ddd*f*g2*r**2 - 15576*D1*Ddd*f*g2*r*s + 11682*D1*Ddd*f*g2*r - 7788*D1*Ddd*f*g2*s**2 + 11682*D1*Ddd*f*g2*s - 5841*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(2*f**2*(51*r**2 + r*(108*s - 97) + 57*s**2 - 103*s + 50) - f*(14*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 125*K*r**2 + 166*K*r*s - 232*K*r + 41*K*s**2 - 148*K*s + 95*K + 6*fd*(68*r**2 + 2*r*(72*s - 53) + 76*s**2 - 112*s + 37) - 173*r**2 - 286*r*s + 312*r - 113*s**2 + 252*s - 141) + 2*fd*(K*(59*r**2 + r*(118*s - 53) + 59*s**2 - 53*s - 6) - 83*r**2 + r*(80 - 178*s) - 95*s**2 + 86*s + 6) - 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f**2*(408*r**2 + r*(864*s - 698) + 456*s**2 - 740*s + 297) + f*(-K*(236*r**2 + 472*r*s - 437*r + 236*s**2 - 437*s + 195) + 332*r**2 + 712*r*s - 629*r + 380*s**2 - 671*s + 288) - 14*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 396*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 15840*Dd**2*K*f**2*r**2 + 27720*Dd**2*K*f**2*r*s - 21780*Dd**2*K*f**2*r + 11880*Dd**2*K*f**2*s**2 - 18810*Dd**2*K*f**2*s + 6600*Dd**2*K*f**2 + 2376*Dd**2*b2*f*r**2 + 4752*Dd**2*b2*f*r*s - 3564*Dd**2*b2*f*r + 2376*Dd**2*b2*f*s**2 - 3564*Dd**2*b2*f*s + 1188*Dd**2*b2*f - 8580*Dd**2*f**3*r**2 + 7380*Dd**2*f**3*r*s + 600*Dd**2*f**3*r + 15960*Dd**2*f**3*s**2 - 17805*Dd**2*f**3*s + 3890*Dd**2*f**3 - 19008*Dd**2*f**2*r**2 - 36828*Dd**2*f**2*r*s + 27918*Dd**2*f**2*r - 17820*Dd**2*f**2*s**2 + 27027*Dd**2*f**2*s - 9108*Dd**2*f**2 - 23364*Dd**2*f*g2*r**2 - 46728*Dd**2*f*g2*r*s + 35046*Dd**2*f*g2*r - 23364*Dd**2*f*g2*s**2 + 35046*Dd**2*f*g2*s - 11682*Dd**2*f*g2) + 858*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 5*D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 12*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 5*D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(9009*d**2*k3**6) - 2*D1**2*Pk1*Pk3*ct**4*k2**2*st**2*(792*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 33*b1*(D1**2*(f*(-24*bdd1*s*(C - 1)*(2*r + 2*s - 1) + fd*(-2*C*(152*r*(2*s - 1) + 194*s**2 - 170*s + 97) + 322*r*(2*s - 1) + 484*s**2 - 436*s + 242) + fdd*(2*C*(76*r*(2*s - 1) + 130*s**2 - 118*s + 65) - 167*r*(2*s - 1) - 320*s**2 + 296*s - 160)) + fd**2*(4*C*(38*r*(2*s - 1) + 65*s**2 - 59*s - 6) - 167*r*(2*s - 1) - 320*s**2 + 296*s + 24)) - 24*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(-2*f*(2*C*(152*r*(2*s - 1) + 194*s**2 - 270*s + 97) - 644*r*s + 322*r - 484*s**2 + 645*s - 242) + fd*(2*s - 1)*(16*C*(76*r + 65*s - 39) - 1336*r - 1280*s + 759)) + Ddd*f*(4*C*(76*r*(2*s - 1) + 130*s**2 - 168*s + 65) - 668*r*s + 334*r - 640*s**2 + 807*s - 320)) + 3*Dd**2*f**2*(4*C*(76*r*(2*s - 1) + 130*s**2 - 168*s + 47) - 334*r*(2*s - 1) - 640*s**2 + 807*s - 218)) + f*(-792*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1**2*(f*(33*bdd1*s*(2*C*(76*r + 65*s - 88) - 167*r - 160*s + 191) + fd*(-2*C*(4692*r*(3*s - 1) + 9579*s**2 - 11078*s + 3193) + 9682*r*(3*s - 1) + 22470*s**2 - 24662*s + 7490) + fdd*(2*C*(2808*r*(3*s - 1) + 6423*s**2 - 7090*s + 2141) - 5831*r*(3*s - 1) - 15096*s**2 + 15895*s - 5032)) + fd**2*(4*C*(2808*r*(3*s - 1) + 6423*s**2 - 7090*s + 1404) - 11662*r*(3*s - 1) - 30192*s**2 + 31790*s - 5831)) - 33*D1*bd1*(D1*(2*f*s*(C*(152*r + 97*s - 176) - 161*r - 121*s + 185) + fd*(-4*C*(38*r*(4*s - 1) + 130*s**2 - 147*s + 44) + 167*r*(4*s - 1) + 640*s**2 - 678*s + 191)) + Dd*f*(-16*C*(19*r*(4*s - 1) + 65*s**2 - 86*s + 22) + 334*r*(4*s - 1) + 1280*s**2 - 1571*s + 382)) + D1*f*(4*C*Ddd*f*(2808*r*(2*s - 1) + 4282*s**2 - 5686*s + 2141) - 2*Dd*f*(2*C*(4692*r*(2*s - 1) + 6386*s**2 - 8732*s + 3193) - 9682*r*(2*s - 1) - 14980*s**2 + 19821*s - 7490) + Dd*fd*(8*C*(1404*r*(12*s - 5) + 12846*s**2 - 15619*s + 4247) - 11662*r*(12*s - 5) - 120768*s**2 + 141457*s - 37621) - 17*Ddd*f*(686*r*(2*s - 1) + 1184*s**2 - 1527*s + 592)) + Dd**2*f**2*(4*C*(8424*r*(2*s - 1) + 12846*s**2 - 17058*s + 4949) - 34986*r*(2*s - 1) - 60384*s**2 + 77877*s - 21726)))/(693*d**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**4*k2**2*(66*b1**2*(D1**2*(fd*(41*C*r + 69*C*(s - 1) - 29*r - 69*s + 69) + fdd*(C*(-31*r - 59*s + 59) + 25*r + 59*s - 59))*(r + s - 1) + D1*(Dd*(f*(C*(164*r**2 + 440*r*s - 302*r + 276*s**2 - 386*s + 179) - 116*r**2 - 392*r*s + 254*r - 276*s**2 + 374*s - 167) + 2*fd*(-C*(124*r**2 + 360*r*s - 301*r + 236*s**2 - 399*s + 163) + 100*r**2 + 336*r*s - 277*r + 236*s**2 - 396*s + 160)) + Ddd*f*(-C*(124*r**2 + 360*r*s - 242*r + 236*s**2 - 326*s + 149) + 100*r**2 + 336*r*s - 218*r + 236*s**2 - 320*s + 143)) + 2*Dd**2*f*(-C*(186*r**2 + r*(540*s - 363) + 354*s**2 - 489*s + 149) + 150*r**2 + r*(504*s - 327) + 354*s**2 - 480*s + 143)) + 66*b1*(-2*C*D1**2*f*fd*r**2 - 204*C*D1**2*f*fd*r*s - 14*C*D1**2*f*fd*r - 204*C*D1**2*f*fd*s**2 + 88*C*D1**2*f*fd*s - 44*C*D1**2*f*fd + 56*C*D1**2*f*fdd*r**2 + 252*C*D1**2*f*fdd*r*s - 50*C*D1**2*f*fdd*r + 198*C*D1**2*f*fdd*s**2 - 110*C*D1**2*f*fdd*s + 61*C*D1**2*f*fdd + 56*C*D1**2*fd**2*r**2 + 252*C*D1**2*fd**2*r*s - 50*C*D1**2*fd**2*r + 198*C*D1**2*fd**2*s**2 - 110*C*D1**2*fd**2*s - 88*C*D1**2*fd**2 - 4*C*D1*Dd*f**2*r**2 - 408*C*D1*Dd*f**2*r*s + 206*C*D1*Dd*f**2*r - 408*C*D1*Dd*f**2*s**2 + 510*C*D1*Dd*f**2*s - 205*C*D1*Dd*f**2 + 448*C*D1*Dd*f*fd*r**2 + 2016*C*D1*Dd*f*fd*r*s - 816*C*D1*Dd*f*fd*r + 1584*C*D1*Dd*f*fd*s**2 - 1484*C*D1*Dd*f*fd*s + 270*C*D1*Dd*f*fd + 112*C*D1*Ddd*f**2*r**2 + 504*C*D1*Ddd*f**2*r*s - 308*C*D1*Ddd*f**2*r + 396*C*D1*Ddd*f**2*s**2 - 522*C*D1*Ddd*f**2*s + 226*C*D1*Ddd*f**2 + 336*C*Dd**2*f**2*r**2 + 1512*C*Dd**2*f**2*r*s - 924*C*Dd**2*f**2*r + 1188*C*Dd**2*f**2*s**2 - 1566*C*Dd**2*f**2*s + 450*C*Dd**2*f**2 + D1**2*bdd1*f*(-C*(62*r**2 + 180*r*s - 62*r + 118*s**2 - 90*s + 31) + 50*r**2 + 168*r*s - 50*r + 118*s**2 - 84*s + 25) + 30*D1**2*f*fd*r**2 + 322*D1**2*f*fd*r*s - 73*D1**2*f*fd*r + 318*D1**2*f*fd*s**2 - 216*D1**2*f*fd*s + 115*D1**2*f*fd - 52*D1**2*f*fdd*r**2 - 344*D1**2*f*fdd*r*s + 110*D1**2*f*fdd*r - 306*D1**2*f*fdd*s**2 + 225*D1**2*f*fdd*s - 122*D1**2*f*fdd - 52*D1**2*fd**2*r**2 - 344*D1**2*fd**2*r*s + 110*D1**2*fd**2*r - 306*D1**2*fd**2*s**2 + 225*D1**2*fd**2*s + 81*D1**2*fd**2 + 60*D1*Dd*f**2*r**2 + 644*D1*Dd*f**2*r*s - 352*D1*Dd*f**2*r + 636*D1*Dd*f**2*s**2 - 797*D1*Dd*f**2*s + 333*D1*Dd*f**2 - 416*D1*Dd*f*fd*r**2 - 2752*D1*Dd*f*fd*r*s + 1232*D1*Dd*f*fd*r - 2448*D1*Dd*f*fd*s**2 + 2468*D1*Dd*f*fd*s - 560*D1*Dd*f*fd - 104*D1*Ddd*f**2*r**2 - 688*D1*Ddd*f**2*r*s + 396*D1*Ddd*f**2*r - 612*D1*Ddd*f**2*s**2 + 784*D1*Ddd*f**2*s - 332*D1*Ddd*f**2 + D1*bd1*(D1*(f*(C*(82*r**2 + 220*r*s - 82*r + 138*s**2 - 110*s + 41) - 58*r**2 - 196*r*s + 58*r - 138*s**2 + 98*s - 29) + 2*fd*(-C*(62*r**2 + 180*r*s - 121*r + 118*s**2 - 163*s + 45) + 50*r**2 + 168*r*s - 109*r + 118*s**2 - 160*s + 42)) + 2*Dd*f*(-C*(248*r**2 + 720*r*s - 366*r + 472*s**2 - 506*s + 121) + 200*r**2 + 672*r*s - 318*r + 472*s**2 - 488*s + 109)) - 312*Dd**2*f**2*r**2 - 2064*Dd**2*f**2*r*s + 1188*Dd**2*f**2*r - 1836*Dd**2*f**2*s**2 + 2352*Dd**2*f**2*s - 650*Dd**2*f**2) + f*(-25242*C*D1**2*f*fd*r**2 - 48792*C*D1**2*f*fd*r*s + 33092*C*D1**2*f*fd*r - 26628*C*D1**2*f*fd*s**2 + 34016*C*D1**2*f*fd*s - 17290*C*D1**2*f*fd + 14502*C*D1**2*f*fdd*r**2 + 44592*C*D1**2*f*fdd*r*s - 24532*C*D1**2*f*fdd*r + 24798*C*D1**2*f*fdd*s**2 - 31396*C*D1**2*f*fdd*s + 13100*C*D1**2*f*fdd + 29004*C*D1**2*fd**2*r**2 + 89184*C*D1**2*fd**2*r*s - 49064*C*D1**2*fd**2*r + 49596*C*D1**2*fd**2*s**2 - 62792*C*D1**2*fd**2*s + 14864*C*D1**2*fd**2 - 33656*C*D1*Dd*f**2*r**2 - 65056*C*D1*Dd*f**2*r*s + 49356*C*D1*Dd*f**2*r - 35504*C*D1*Dd*f**2*s**2 + 51768*C*D1*Dd*f**2*s - 26166*C*D1*Dd*f**2 + 116016*C*D1*Dd*f*fd*r**2 + 356736*C*D1*Dd*f*fd*r*s - 216316*C*D1*Dd*f*fd*r + 198384*C*D1*Dd*f*fd*s**2 - 269368*C*D1*Dd*f*fd*s + 87324*C*D1*Dd*f*fd + 19336*C*D1*Ddd*f**2*r**2 + 59456*C*D1*Ddd*f**2*r*s - 39396*C*D1*Ddd*f**2*r + 33064*C*D1*Ddd*f**2*s**2 - 47928*C*D1*Ddd*f**2*s + 21366*C*D1*Ddd*f**2 + 58008*C*Dd**2*f**2*r**2 + 178368*C*Dd**2*f**2*r*s - 118188*C*Dd**2*f**2*r + 99192*C*Dd**2*f**2*s**2 - 143784*C*Dd**2*f**2*s + 46260*C*Dd**2*f**2 - 132*D1**2*bd1**2*(r**2*(31*C - 25) + r*(90*C*s - 31*C - 84*s + 25) + s*(59*C*s - 45*C - 59*s + 42)) + 66*D1**2*bdd1*f*(C*(28*r**2 + 6*r*(21*s - 22) + 99*s**2 - 214*s + 66) - 26*r**2 - 172*r*s + 114*r - 153*s**2 + 253*s - 57) + 22089*D1**2*f*fd*r**2 + 55125*D1**2*f*fd*r*s - 33101*D1**2*f*fd*r + 36123*D1**2*f*fd*s**2 - 42457*D1**2*f*fd*s + 19404*D1**2*f*fd - 12579*D1**2*f*fdd*r**2 - 50085*D1**2*f*fdd*r*s + 25081*D1**2*f*fdd*r - 33753*D1**2*f*fdd*s**2 + 39197*D1**2*f*fdd*s - 15444*D1**2*f*fdd - 25158*D1**2*fd**2*r**2 - 100170*D1**2*fd**2*r*s + 50162*D1**2*fd**2*r - 67506*D1**2*fd**2*s**2 + 78394*D1**2*fd**2*s - 16695*D1**2*fd**2 + 29452*D1*Dd*f**2*r**2 + 73500*D1*Dd*f**2*r*s - 51476*D1*Dd*f**2*r + 48164*D1*Dd*f**2*s**2 - 66539*D1*Dd*f**2*s + 31445*D1*Dd*f**2 - 100632*D1*Dd*f*fd*r**2 - 400680*D1*Dd*f*fd*r*s + 225652*D1*Dd*f*fd*r - 270024*D1*Dd*f*fd*s**2 + 341885*D1*Dd*f*fd*s - 103475*D1*Dd*f*fd - 16772*D1*Ddd*f**2*r**2 - 66780*D1*Ddd*f**2*r*s + 41776*D1*Ddd*f**2*r - 45004*D1*Ddd*f**2*s**2 + 61699*D1*Ddd*f**2*s - 26695*D1*Ddd*f**2 - 66*D1*bd1*(-2*C*Dd*f*(112*r**2 + r*(504*s - 418) + 396*s**2 - 689*s + 280) + D1*f*(C*(r**2 + 2*r*(51*s - 59) + 102*s**2 - 218*s + 59) - 15*r**2 - 161*r*s + 118*r - 159*s**2 + 263*s - 59) + D1*fd*(-2*C*(56*r**2 + 252*r*s - 157*r + 198*s**2 - 269*s + 107) + 104*r**2 + 688*r*s - 338*r + 612*s**2 - 731*s + 253) + 4*Dd*f*(52*r**2 + r*(344*s - 213) + 306*s**2 - 449*s + 155)) - 50316*Dd**2*f**2*r**2 - 200340*Dd**2*f**2*r*s + 125328*Dd**2*f**2*r - 135012*Dd**2*f**2*s**2 + 185097*Dd**2*f**2*s - 55892*Dd**2*f**2))/(693*d**2*k3**4) - 4*D1**2*Pk1*Pk3*ct**4*st**2*(396*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) - 33*b1*(D1**2*(f*(fd*(36*C - 46)*(2*s**2 - 2*s + 1) - fdd*(18*C - 23)*(2*s**2 - 2*s + 1) + s**2*(C - 1)*(-48*bd1 + 24*bdd1)) + 2*fd*s*(s - 1)*(24*bd1*(C - 1) + fd*(23 - 18*C))) + 2*D1*f*(Dd*f*(36*C - 46)*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(-24*bd1*s*(C - 1) + fd*(18*C - 23)*(2*s - 1)) - Ddd*f*(18*C - 23)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(46 - 36*C)*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(-fd*(1500*C - 1750)*(3*s**2 - 2*s + 1) + fdd*(750*C - 875)*(3*s**2 - 2*s + 1) + s**2*(18*C - 23)*(-66*bd1 + 33*bdd1)) + 2*s*(-396*bd1**2*s*(C - 1) + 33*bd1*fd*(18*C - 23)*(2*s - 1) + fd**2*(750*C - 875)*(3*s - 2))) - 2*D1*f*(Dd*f*(1500*C - 1750)*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s*(18*C - 23) + fd*(750*C - 875)*(3*s - 1)) - Ddd*f*(750*C - 875)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(1500*C - 1750)*(6*s**2 - 6*s + 1)))/(693*d**2*k3**2) + 2*D1**2*Pk1*Pk3*ct**4*(66*b1**2*(D1**2*(s - 1)*(fd*(48*C*r + 69*C*(s - 1) - 36*r - 69*s + 69) + fdd*(C*(-24*r - 59*s + 59) + 18*r + 59*s - 59)) + 2*D1*(Dd*(3*f*(C*(32*r*s - 16*r + 46*s**2 - 54*s + 23) - 24*r*s + 12*r - 46*s**2 + 52*s - 23) + fd*(-2*C*(48*r*s - 36*r + 118*s**2 - 183*s + 65) + 72*r*s - 54*r + 236*s**2 - 363*s + 127)) + Ddd*f*(C*(-48*r*s + 24*r - 118*s**2 + 130*s - 59) + 36*r*s - 18*r + 118*s**2 - 127*s + 59)) - 2*Dd**2*f*(C*(72*r*(2*s - 1) + 354*s**2 - 390*s + 83) - 54*r*(2*s - 1) - 354*s**2 + 381*s - 77)) + 66*b1*(D1**2*(f*(2*bdd1*s*(C*(-24*r - 59*s + 12) + 18*r + 59*s - 9) + fd*(-8*C*(r*(4 - 8*s) + 2*s**2 + 5*s + 1) - 32*r*s + 16*r + 74*s**2 - 32*s + 37) + fdd*(4*C*(-2*r*s + r + 2*s**2 + 5*s + 1) + 4*r*s - 2*r - 58*s**2 + 37*s - 29)) + fd**2*(4*C*(-2*r*s + r + 2*s**2 + 5*s - 7) + r*(4*s - 2) - 58*s**2 + 37*s + 21)) + 2*D1*bd1*(D1*(3*f*s*(C*(16*r + 23*s - 8) - 12*r - 23*s + 6) + fd*(-2*C*(24*r*s - 12*r + 59*s**2 - 65*s + 6) + 36*r*s - 18*r + 118*s**2 - 127*s + 9)) - 2*Dd*f*(2*C*(48*r*s - 12*r + 118*s**2 - 77*s + 6) - 72*r*s + 18*r - 236*s**2 + 145*s - 9)) + 2*D1*f*(Dd*(f*(-8*C*(r*(4 - 8*s) + 2*s**2 + 1) - 32*r*s + 16*r + 74*s**2 - 66*s + 37) + 2*fd*(2*s - 1)*(C*(-8*r + 8*s + 11) + 4*r - 58*s + 18)) + Ddd*f*(C*(-8*r*s + 4*r + 8*s**2 - 6*s + 4) + 4*r*s - 2*r - 58*s**2 + 57*s - 29)) - 6*Dd**2*f**2*(r*(4*C - 2)*(2*s - 1) + s**2*(58 - 8*C) + s*(6*C - 57) + 9)) + f*(-132*D1**2*bd1**2*s*(C*(24*r + 59*s - 12) - 18*r - 59*s + 9) + D1**2*(f*(66*bdd1*s*(-4*C*(r - s + 6) + 2*r - 29*s + 19) - 5*fd*(2*C*(212*r*(3*s - 1) + 1089*s**2 - 938*s + 363) - 404*r*(3*s - 1) - 3147*s**2 + 2502*s - 1049) + 5*fdd*(2*C*(172*r*(3*s - 1) + 891*s**2 - 766*s + 297) - 268*r*(3*s - 1) - 2613*s**2 + 2010*s - 871)) + 10*fd**2*(2*C*(172*r*(3*s - 1) + 891*s**2 - 766*s + 86) - 268*r*(3*s - 1) - 2613*s**2 + 2010*s - 134)) + 66*D1*bd1*(D1*(f*s*(8*C*(4*r - s + 3) - 16*r + 37*s - 26) + fd*(4*C*(-4*r*s + r + 4*s**2 - 7*s + 6) + 8*r*s - 2*r - 116*s**2 + 75*s - 19)) - 2*Dd*f*(2*C*(8*r*s - 2*r - 8*s**2 + 27*s - 12) - 8*r*s + 2*r + 116*s**2 - 95*s + 19)) - 10*D1*f*(Dd*(-8*C*fd*(43*r*(12*s - 5) + 891*s**2 - 893*s + 213) + f*(2*C*(212*r*(2*s - 1) + 726*s**2 - 832*s + 363) - 808*r*s + 404*r - 2098*s**2 + 2300*s - 1049) + 268*fd*(r*(12*s - 5) + 39*s**2 - 36*s + 8)) + Ddd*f*(-2*C*(172*r*(2*s - 1) + 594*s**2 - 680*s + 297) + 67*r*(8*s - 4) + 1742*s**2 - 1876*s + 871)) + 10*Dd**2*f**2*(2*C*(516*r*(2*s - 1) + 1782*s**2 - 2040*s + 469) - 804*r*(2*s - 1) - 5226*s**2 + 5628*s - 1139)))/(693*d**2*k3**2) + D1**2*Pk1*Pk3*ct**4*(16*C - 8)*(D1*f*s*(-12*D1*bd1**2*s - 5*D1*bdd1*f*s + 10*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*f*(2 - 4*s))) + 6*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(10*fd*(2*s**2 - 2*s + 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(24*bd1 - 12*bdd1)) - 2*fd*s*(12*bd1 + 5*fd)*(s - 1)) + 2*D1*f*(10*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(12*bd1*s + 5*fd*(2*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k2**2) - 2*D1**2*Pk1*Pk3*ct**4*k2**4*st**2*(264*C*D1**2*b1*f*fd*r**2 + 462*C*D1**2*b1*f*fdd*r**2 + 462*C*D1**2*b1*fd**2*r**2 - 336*C*D1**2*f**2*fd*r**2 + 224*C*D1**2*f**2*fd*r - 112*C*D1**2*f**2*fd + 861*C*D1**2*f**2*fdd*r**2 - 574*C*D1**2*f**2*fdd*r + 287*C*D1**2*f**2*fdd + 1722*C*D1**2*f*fd**2*r**2 - 1148*C*D1**2*f*fd**2*r + 528*C*D1*Dd*b1*f**2*r**2 - 264*C*D1*Dd*b1*f**2*r + 132*C*D1*Dd*b1*f**2 + 3696*C*D1*Dd*b1*f*fd*r**2 - 924*C*D1*Dd*b1*f*fd*r - 448*C*D1*Dd*f**3*r**2 + 224*C*D1*Dd*f**3*r - 112*C*D1*Dd*f**3 + 6888*C*D1*Dd*f**2*fd*r**2 - 4018*C*D1*Dd*f**2*fd*r + 574*C*D1*Dd*f**2*fd + 924*C*D1*Ddd*b1*f**2*r**2 - 462*C*D1*Ddd*b1*f**2*r + 231*C*D1*Ddd*b1*f**2 + 1148*C*D1*Ddd*f**3*r**2 - 574*C*D1*Ddd*f**3*r + 287*C*D1*Ddd*f**3 + 2772*C*Dd**2*b1*f**2*r**2 - 1386*C*Dd**2*b1*f**2*r + 3444*C*Dd**2*f**3*r**2 - 1722*C*Dd**2*f**3*r - 396*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r - 792*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 792*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r + 33*D1**2*bdd1*f**2*(r - 1)*(7*C*(r - 1) - 12*r - 5*s + 12) - 270*D1**2*f**2*fd*r**2 - 606*D1**2*f**2*fd*r*s + 382*D1**2*f**2*fd*r + 202*D1**2*f**2*fd*s - 90*D1**2*f**2*fd - 756*D1**2*f**2*fdd*r**2 + 105*D1**2*f**2*fdd*r*s + 469*D1**2*f**2*fdd*r - 35*D1**2*f**2*fdd*s - 252*D1**2*f**2*fdd - 1512*D1**2*f*fd**2*r**2 + 210*D1**2*f*fd**2*r*s + 938*D1**2*f*fd**2*r - 70*D1**2*f*fd**2*s + 35*D1**2*f*fd**2 - 792*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 528*D1*Dd*b1*f**2*r + 66*D1*Dd*b1*f**2*s - 198*D1*Dd*b1*f**2 - 6336*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 2904*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd - 360*D1*Dd*f**3*r**2 - 808*D1*Dd*f**3*r*s + 584*D1*Dd*f**3*r + 202*D1*Dd*f**3*s - 90*D1*Dd*f**3 - 6048*D1*Dd*f**2*fd*r**2 + 840*D1*Dd*f**2*fd*r*s + 3178*D1*Dd*f**2*fd*r - 245*D1*Dd*f**2*fd*s - 399*D1*Dd*f**2*fd - 1584*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 1122*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 396*D1*Ddd*b1*f**2 - 1008*D1*Ddd*f**3*r**2 + 140*D1*Ddd*f**3*r*s + 434*D1*Ddd*f**3*r - 35*D1*Ddd*f**3*s - 252*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(2*f*(r - 1)*(2*C*(r - 1) - 3*r - s + 3) + fd*(r**2*(28*C - 48) + r*(-28*C - 20*s + 53) + 10*s - 5)) + Dd*f*(14*C*(4*r**2 - 5*r + 1) - 96*r**2 - 40*r*s + 130*r + 25*s - 34)) - 4752*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 3366*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 3024*Dd**2*f**3*r**2 + 420*Dd**2*f**3*r*s + 1302*Dd**2*f**3*r - 105*Dd**2*f**3*s + 70*Dd**2*f**3)/(693*d**2*k1**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**4*k2**4*(12870*C*D1**2*f**2*fd*r**2 - 8580*C*D1**2*f**2*fd*r + 4290*C*D1**2*f**2*fd + 17160*C*D1*Dd*f**3*r**2 - 8580*C*D1*Dd*f**3*r + 4290*C*D1*Dd*f**3 - 1716*D1**2*K*bdd1*f**2*r**2 + 858*D1**2*bd1**2*f*(4*f*(4*r**2 + r*(4*s - 5) - 2*s + 1) - r**2*(K - 13) + r*(K + 12*s - 19) - 6*s + 6) + 1638*D1**2*bdd1*f**3*r**2 - 5200*D1**2*bdd1*f**3*r*s + 3536*D1**2*bdd1*f**3*r + 8580*D1**2*bdd1*f**3*s - 2613*D1**2*bdd1*f**3 + 4290*D1**2*bdd1*f**2*r**2 + 2574*D1**2*bdd1*f**2*r*s - 2574*D1**2*bdd1*f**2*r + 858*D1**2*bdd1*f*g2*r**2 - 1716*D1**2*bdd1*f*g2*r + 858*D1**2*bdd1*f*g2 - 40200*D1**2*f**3*fd*r**2 + 16900*D1**2*f**3*fd*r*s + 11650*D1**2*f**3*fd*r - 4225*D1**2*f**3*fd*s - 10050*D1**2*f**3*fd - 11880*D1**2*f**3*fdd*r**2 - 16900*D1**2*f**3*fdd*r*s + 14390*D1**2*f**3*fdd*r + 4225*D1**2*f**3*fdd*s - 2970*D1**2*f**3*fdd - 35640*D1**2*f**2*fd**2*r**2 - 50700*D1**2*f**2*fd**2*r*s + 43170*D1**2*f**2*fd**2*r + 12675*D1**2*f**2*fd**2*s - 8450*D1**2*f**2*fd**2 - 25740*D1**2*f**2*fd*r**2 - 12870*D1**2*f**2*fd*r*s + 21450*D1**2*f**2*fd*r + 4290*D1**2*f**2*fd*s - 8580*D1**2*f**2*fd + 18018*D1**2*f**2*gd2*r**2 + 3432*D1**2*f**2*gdd2*r**2 + 36036*D1**2*f*fd*g2*r**2 - 36036*D1**2*f*fd*g2*r + 18018*D1**2*f*fd*g2 + 13728*D1**2*f*fd*gd2*r**2 - 6864*D1**2*f*fd*gd2*r + 6864*D1**2*f*fdd*g2*r**2 - 6864*D1**2*f*fdd*g2*r + 3432*D1**2*f*fdd*g2 + 6864*D1**2*fd**2*g2*r**2 - 6864*D1**2*fd**2*g2*r - 40200*D1*Dd*f**4*r**2 + 16900*D1*Dd*f**4*r*s + 11650*D1*Dd*f**4*r - 4225*D1*Dd*f**4*s - 10050*D1*Dd*f**4 - 95040*D1*Dd*f**3*fd*r**2 - 135200*D1*Dd*f**3*fd*r*s + 115120*D1*Dd*f**3*fd*r + 33800*D1*Dd*f**3*fd*s - 22840*D1*Dd*f**3*fd - 34320*D1*Dd*f**3*r**2 - 17160*D1*Dd*f**3*r*s + 25740*D1*Dd*f**3*r + 4290*D1*Dd*f**3*s - 8580*D1*Dd*f**3 + 72072*D1*Dd*f**2*g2*r**2 - 36036*D1*Dd*f**2*g2*r + 18018*D1*Dd*f**2*g2 + 27456*D1*Dd*f**2*gd2*r**2 - 6864*D1*Dd*f**2*gd2*r + 54912*D1*Dd*f*fd*g2*r**2 - 41184*D1*Dd*f*fd*g2*r + 6864*D1*Dd*f*fd*g2 - 11880*D1*Ddd*f**4*r**2 - 16900*D1*Ddd*f**4*r*s + 14390*D1*Ddd*f**4*r + 4225*D1*Ddd*f**4*s - 2970*D1*Ddd*f**4 + 13728*D1*Ddd*f**2*g2*r**2 - 6864*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(f**3*(186*r**2 - 4*r*(200*s + 227) + 660*s + 489) - f**2*(396*C*(r - 1)**2 + 2*fd*(378*r**2 - 6*r*(200*s - 91) + 860*s - 595) - 99*r**2*(7*K - 3) + 1188*r + 396*s - 792) + 66*f*(fd*(r**2*(8*K - 20) - 4*r*(K + 3*s - 4) + 3*s - 3) - (r - 1)*(19*g2*(r - 1) + 2*gd2*r)) - 132*fd*g2*r*(r - 1)) - 2*Dd*f*(2*f**2*(252*r**2 + r*(409 - 800*s) + 760*s - 398) - 33*f*(r**2*(16*K - 40) - 4*r*(K + 6*s - 7) + 3*s - 3) + 66*g2*(4*r**2 - 5*r + 1))) - 35640*Dd**2*f**4*r**2 - 50700*Dd**2*f**4*r*s + 43170*Dd**2*f**4*r + 12675*Dd**2*f**4*s - 8450*Dd**2*f**4 + 41184*Dd**2*f**2*g2*r**2 - 20592*Dd**2*f**2*g2*r - 429*b1**2*(D1**2*r*(4*f*(fd - 2*fdd)*(4*r + 4*s - 3) - 8*fd**2*(4*r + 4*s - 3) + fd*r*(19*K - 23) - 4*fd*s + fdd*r*(K - 13) - 12*fdd*s) + D1*(Dd*(8*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(19*K*(4*r**2 - 2*r + 1) - 8*fd*(8*r - 1)*(4*r + 4*s - 3) - 92*r**2 - 16*r*s + 54*r + 4*s - 23) + 2*fd*(r**2*(4*K - 52) - r*(K + 48*s - 25) + 6*s)) + Ddd*f*(4*K*r**2 - 2*K*r + K - 16*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 52*r**2 - 48*r*s + 50*r + 12*s - 13)) - 2*Dd**2*f*(8*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - 3*r**2*(2*K - 26) + 3*r*(K + 24*s - 25) - 18*s + 12)) - 13*b1*(-792*C*D1**2*f*fd*r**2 - 1584*C*D1*Dd*f**2*r**2 + 792*C*D1*Dd*f**2*r - 396*C*D1*Dd*f**2 + 1386*D1**2*K*f*fd*r**2 - 1386*D1**2*K*f*fd*r + 693*D1**2*K*f*fd + 264*D1**2*K*f*fdd*r**2 - 264*D1**2*K*f*fdd*r + 132*D1**2*K*f*fdd + 264*D1**2*K*fd**2*r**2 - 264*D1**2*K*fd**2*r - 33*D1**2*bdd1*f*(K*(-2*r**2 + 2*r - 1) + 8*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + 26*r**2 + 24*r*s - 38*r - 12*s + 13) + 558*D1**2*f**2*fd*r**2 - 2400*D1**2*f**2*fd*r*s + 2136*D1**2*f**2*fd*r + 140*D1**2*f**2*fd*s - 303*D1**2*f**2*fd - 378*D1**2*f**2*fdd*r**2 + 1200*D1**2*f**2*fdd*r*s - 276*D1**2*f**2*fdd*r + 260*D1**2*f**2*fdd*s - 327*D1**2*f**2*fdd - 756*D1**2*f*fd**2*r**2 + 2400*D1**2*f*fd**2*r*s - 552*D1**2*f*fd**2*r + 520*D1**2*f*fd**2*s - 390*D1**2*f*fd**2 - 594*D1**2*f*fd*r**2 + 1782*D1**2*f*fd*r + 396*D1**2*f*fd*s - 1089*D1**2*f*fd - 660*D1**2*f*fdd*r**2 - 396*D1**2*f*fdd*r*s + 660*D1**2*f*fdd*r + 198*D1**2*f*fdd*s - 330*D1**2*f*fdd - 1254*D1**2*f*gd2*r**2 - 66*D1**2*f*gdd2*r**2 - 660*D1**2*fd**2*r**2 - 396*D1**2*fd**2*r*s + 660*D1**2*fd**2*r + 198*D1**2*fd**2*s - 1254*D1**2*fd*g2*r**2 - 132*D1**2*fd*gd2*r**2 - 66*D1**2*fdd*g2*r**2 + 2772*D1*Dd*K*f**2*r**2 - 1386*D1*Dd*K*f**2*r + 693*D1*Dd*K*f**2 + 2112*D1*Dd*K*f*fd*r**2 - 1584*D1*Dd*K*f*fd*r + 264*D1*Dd*K*f*fd + 744*D1*Dd*f**3*r**2 - 3200*D1*Dd*f**3*r*s + 1228*D1*Dd*f**3*r + 800*D1*Dd*f**3*s + 186*D1*Dd*f**3 - 3024*D1*Dd*f**2*fd*r**2 + 9600*D1*Dd*f**2*fd*r*s - 2748*D1*Dd*f**2*fd*r - 160*D1*Dd*f**2*fd*s - 244*D1*Dd*f**2*fd - 1188*D1*Dd*f**2*r**2 + 594*D1*Dd*f**2*r - 297*D1*Dd*f**2 - 5280*D1*Dd*f*fd*r**2 - 3168*D1*Dd*f*fd*r*s + 4752*D1*Dd*f*fd*r + 1188*D1*Dd*f*fd*s - 1056*D1*Dd*f*fd - 5016*D1*Dd*f*g2*r**2 + 2508*D1*Dd*f*g2*r - 1254*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r**2 + 132*D1*Dd*f*gd2*r - 528*D1*Dd*fd*g2*r**2 + 132*D1*Dd*fd*g2*r + 528*D1*Ddd*K*f**2*r**2 - 264*D1*Ddd*K*f**2*r + 132*D1*Ddd*K*f**2 - 504*D1*Ddd*f**3*r**2 + 1600*D1*Ddd*f**3*r*s - 548*D1*Ddd*f**3*r - 400*D1*Ddd*f**3*s - 126*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*r**2 - 792*D1*Ddd*f**2*r*s + 1056*D1*Ddd*f**2*r + 198*D1*Ddd*f**2*s - 330*D1*Ddd*f**2 - 264*D1*Ddd*f*g2*r**2 + 132*D1*Ddd*f*g2*r - 66*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(4*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(19*K*(2*r**2 - 2*r + 1) - 8*fd*(4*r - 1)*(4*r + 4*s - 3) - 46*r**2 - 8*r*s + 50*r + 4*s - 23) + 2*fd*(r**2*(2*K - 26) - r*(K + 24*s - 19) + 6*s)) - 2*Dd*f*(K*(-8*r**2 + 6*r - 1) + 4*f*(8*r - 3)*(4*r + 4*s - 3) + 104*r**2 + 96*r*s - 126*r - 36*s + 31)) + 1584*Dd**2*K*f**2*r**2 - 792*Dd**2*K*f**2*r - 1512*Dd**2*f**3*r**2 + 4800*Dd**2*f**3*r*s - 1644*Dd**2*f**3*r - 1200*Dd**2*f**3*s + 800*Dd**2*f**3 - 3960*Dd**2*f**2*r**2 - 2376*Dd**2*f**2*r*s + 3168*Dd**2*f**2*r + 594*Dd**2*f**2*s - 396*Dd**2*f**2 - 792*Dd**2*f*g2*r**2 + 396*Dd**2*f*g2*r))/(9009*d**2*k1**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**4*k2**2*st**2*(33*D1*bd1*f*(D1*(2*f*s*(r - 1) + 5*fd*(4*r*s - r - 2*s + 1)) + 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) + 33*b1*(D1*Dd*f*(4*f*r*(2*s - 1) - 2*f*s + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(D1*r*(2*s - 1)*(2*f*fd + 5*f*fdd + 5*fd**2) + 5*Ddd*f**2*(r*(4*s - 2) - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(202*f*(4*r*s - 2*r - s) - 35*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(202*f*fd*(r*(3*s - 1) - s) + 5*f*(33*bdd1*s*(r - 1) + 7*fdd*(-3*r*s + r + s)) - 35*fd**2*(r*(6*s - 2) - 2*s + 1)) + 35*Ddd*f**2*(r*(2 - 4*s) + s)) - 35*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k1**2*k3**2) - 2*D1**2*Pk1*Pk3*ct**4*k2**2*(66*b1**2*(C - 1)*(D1**2*r**2*(19*fd + fdd) + D1*(19*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + 66*b1*(42*C*D1**2*f*fd*r**2 - 42*C*D1**2*f*fd*r + 21*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r**2 - 8*C*D1**2*f*fdd*r + 4*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r**2 - 8*C*D1**2*fd**2*r + 84*C*D1*Dd*f**2*r**2 - 42*C*D1*Dd*f**2*r + 21*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r**2 - 48*C*D1*Dd*f*fd*r + 8*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r**2 - 8*C*D1*Ddd*f**2*r + 4*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r**2 - 24*C*Dd**2*f**2*r + D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 26*D1**2*f*fd*r**2 - 26*D1**2*f*fd*r*s + 55*D1**2*f*fd*r - 21*D1**2*f*fd - 4*D1**2*f*fdd*r**2 + 28*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 4*D1**2*f*fdd - 4*D1**2*fd**2*r**2 + 28*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 52*D1*Dd*f**2*r**2 - 52*D1*Dd*f**2*r*s + 52*D1*Dd*f**2*r + 13*D1*Dd*f**2*s - 13*D1*Dd*f**2 - 32*D1*Dd*f*fd*r**2 + 224*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r - 28*D1*Dd*f*fd*s + 6*D1*Dd*f*fd - 8*D1*Ddd*f**2*r**2 + 56*D1*Ddd*f**2*r*s - 24*D1*Ddd*f**2*r - 14*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + D1*bd1*(C - 1)*(19*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) - 24*Dd**2*f**2*r**2 + 168*Dd**2*f**2*r*s - 72*Dd**2*f**2*r - 42*Dd**2*f**2*s + 28*Dd**2*f**2) + f*(-978*C*D1**2*f*fd*r**2 + 652*C*D1**2*f*fd*r - 326*C*D1**2*f*fd - 402*C*D1**2*f*fdd*r**2 + 268*C*D1**2*f*fdd*r - 134*C*D1**2*f*fdd - 804*C*D1**2*fd**2*r**2 + 536*C*D1**2*fd**2*r - 1304*C*D1*Dd*f**2*r**2 + 652*C*D1*Dd*f**2*r - 326*C*D1*Dd*f**2 - 3216*C*D1*Dd*f*fd*r**2 + 1876*C*D1*Dd*f*fd*r - 268*C*D1*Dd*f*fd - 536*C*D1*Ddd*f**2*r**2 + 268*C*D1*Ddd*f**2*r - 134*C*D1*Ddd*f**2 - 1608*C*Dd**2*f**2*r**2 + 804*C*Dd**2*f**2*r + 132*D1**2*bd1**2*r*(C - 1)*(r - 1) + 132*D1**2*bdd1*f*(r**2*(2*C - 1) + r*(7*s - 2) - 7*s + 1) + 2643*D1**2*f*fd*r**2 - 1083*D1**2*f*fd*r*s - 1401*D1**2*f*fd*r + 361*D1**2*f*fd*s + 881*D1**2*f*fd + 807*D1**2*f*fdd*r**2 + 1383*D1**2*f*fdd*r*s - 999*D1**2*f*fdd*r - 461*D1**2*f*fdd*s + 269*D1**2*f*fdd + 1614*D1**2*fd**2*r**2 + 2766*D1**2*fd**2*r*s - 1998*D1**2*fd**2*r - 922*D1**2*fd**2*s + 461*D1**2*fd**2 + 3524*D1*Dd*f**2*r**2 - 1444*D1*Dd*f**2*r*s - 1040*D1*Dd*f**2*r + 361*D1*Dd*f**2*s + 881*D1*Dd*f**2 + 6456*D1*Dd*f*fd*r**2 + 11064*D1*Dd*f*fd*r*s - 8376*D1*Dd*f*fd*r - 3227*D1*Dd*f*fd*s + 1921*D1*Dd*f*fd + 1076*D1*Ddd*f**2*r**2 + 1844*D1*Ddd*f**2*r*s - 1460*D1*Ddd*f**2*r - 461*D1*Ddd*f**2*s + 269*D1*Ddd*f**2 + 66*D1*bd1*(D1*(f*(r**2*(21*C - 13) - r*(13*s + 16) + 13*s + 8) + 2*fd*(r**2*(8*C - 4) + r*(-4*C + 28*s - 7) - 14*s + 7)) + 2*Dd*f*(r**2*(16*C - 8) - 4*r*(C - 14*s + 5) - 35*s + 16)) + 3228*Dd**2*f**2*r**2 + 5532*Dd**2*f**2*r*s - 4380*Dd**2*f**2*r - 1383*Dd**2*f**2*s + 922*Dd**2*f**2))/(693*d**2*k1**2*k3**2) + 4*D1**2*Pk1*Pk3*ct**4*(3*D1*f*(2*D1*bd1**2*s*(2*r - 1) + D1*bd1*(2*f*r*s + fd*r*(4*s - 1) - fd*s) + D1*bdd1*f*r*s + Dd*bd1*f*(r*(8*s - 2) - s)) + 2*b1**2*(D1*Dd*(f*(4*r*s - 2*r - s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(D1*r*(fd + 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(3*D1*Dd*f*(4*f*r*(2*s - 1) - 2*f*s + fd*(8*r - 3)*(2*s - 1)) + 2*D1*bd1*(D1*(f*s*(2*r - 1) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + 3*D1*(D1*(2*f*fd*(r*(2*s - 1) - s) + f*(2*bdd1*s*(2*r - 1) + fdd*r*(2*s - 1) - fdd*s) + fd**2*(r*(2*s - 1) - s + 1)) + Ddd*f**2*(r*(4*s - 2) - s)) + 3*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(21*d**2*k1**2) - 8*D1**2*Pk1*Pk3*ct**3*f*k1*k2**5*st**4*(132*D1**2*bd1*f*(C - 1)*(r + s - 1)**2 + 132*D1*b1*(C - 1)*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + (100*C - 85)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**8) - 16*D1**2*Pk1*Pk3*ct**3*f*k1*k2**3*st**4*(D1**2*(f*(22*bd1*s*(C - 1)*(r + s - 1) + fd*(60*C - 50)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(30*C - 25)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(25 - 30*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 22*D1*b1*(C - 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + D1*f*(30*C - 25)*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(25 - 30*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4))/(77*d**2*k3**6) - D1**2*Pk1*Pk3*ct**3*f*k1*k2*st**4*(640*C - 520)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + 2*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1))/(231*d**2*k3**4) - 40*D1**2*Pk1*Pk3*ct**3*f*k2**7*st**4*(78*D1**2*b1*f*fd*r**2 + 156*D1**2*b1*f*fd*r*s - 104*D1**2*b1*f*fd*r + 78*D1**2*b1*f*fd*s**2 - 104*D1**2*b1*f*fd*s + 52*D1**2*b1*f*fd - 39*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*f*fdd*r*s + 52*D1**2*b1*f*fdd*r - 39*D1**2*b1*f*fdd*s**2 + 52*D1**2*b1*f*fdd*s - 26*D1**2*b1*f*fdd - 78*D1**2*b1*fd**2*r**2 - 156*D1**2*b1*fd**2*r*s + 104*D1**2*b1*fd**2*r - 78*D1**2*b1*fd**2*s**2 + 104*D1**2*b1*fd**2*s - 26*D1**2*b1*fd**2 - 13*D1**2*bdd1*f**2*(r + s - 1)**2 + 80*D1**2*f**2*fd*r**2 + 160*D1**2*f**2*fd*r*s - 120*D1**2*f**2*fd*r + 80*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 40*D1**2*f**2*fdd*r**2 - 80*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 40*D1**2*f**2*fdd*s**2 + 60*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 180*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 180*D1**2*f*fd**2*s - 60*D1**2*f*fd**2 + 104*D1*Dd*b1*f**2*r**2 + 208*D1*Dd*b1*f**2*r*s - 156*D1*Dd*b1*f**2*r + 104*D1*Dd*b1*f**2*s**2 - 156*D1*Dd*b1*f**2*s + 78*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 - 624*D1*Dd*b1*f*fd*r*s + 442*D1*Dd*b1*f*fd*r - 312*D1*Dd*b1*f*fd*s**2 + 442*D1*Dd*b1*f*fd*s - 156*D1*Dd*b1*f*fd + 80*D1*Dd*f**3*r**2 + 160*D1*Dd*f**3*r*s - 120*D1*Dd*f**3*r + 80*D1*Dd*f**3*s**2 - 120*D1*Dd*f**3*s + 60*D1*Dd*f**3 - 320*D1*Dd*f**2*fd*r**2 - 640*D1*Dd*f**2*fd*r*s + 480*D1*Dd*f**2*fd*r - 320*D1*Dd*f**2*fd*s**2 + 480*D1*Dd*f**2*fd*s - 180*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 - 104*D1*Ddd*b1*f**2*r*s + 78*D1*Ddd*b1*f**2*r - 52*D1*Ddd*b1*f**2*s**2 + 78*D1*Ddd*b1*f**2*s - 39*D1*Ddd*b1*f**2 - 40*D1*Ddd*f**3*r**2 - 80*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 40*D1*Ddd*f**3*s**2 + 60*D1*Ddd*f**3*s - 30*D1*Ddd*f**3 + 26*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 156*Dd**2*b1*f**2*r**2 - 312*Dd**2*b1*f**2*r*s + 234*Dd**2*b1*f**2*r - 156*Dd**2*b1*f**2*s**2 + 234*Dd**2*b1*f**2*s - 78*Dd**2*b1*f**2 - 120*Dd**2*f**3*r**2 - 240*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 120*Dd**2*f**3*s**2 + 180*Dd**2*f**3*s - 60*Dd**2*f**3)/(143*d**2*k1*k3**8) - 8*D1**2*Pk1*Pk3*ct**3*f*k2**5*st**4*(132*D1**2*bd1*f*(C - 1)*(r - 1)*(r + s - 1) - 5*D1**2*(f*(2*fd - fdd)*(4*C*(3*r**2 + 3*r*(s - 1) - s + 1) - 21*r**2 - 6*r*(5*s - 4) - 9*s**2 + 16*s - 10) + 2*fd**2*(-2*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 21*r**2 + 6*r*(5*s - 4) + 9*s**2 - 16*s + 5)) + 132*D1*b1*(C - 1)*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*D1*f*(2*Dd*(f*(4*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 28*r**2 - 40*r*s + 34*r - 12*s**2 + 22*s - 13) + fd*(-2*C*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 84*r**2 + 120*r*s - 99*r + 36*s**2 - 65*s + 28)) + Ddd*f*(-4*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 28*r**2 + 40*r*s - 34*r + 12*s**2 - 22*s + 13)) - 10*Dd**2*f**2*(C*(-24*r**2 - 24*r*(s - 1) + 6*s - 4) + 42*r**2 + r*(60*s - 51) + 18*s**2 - 33*s + 13))/(231*d**2*k1*k3**6) + 8*D1**2*Pk1*Pk3*ct**3*f*k2**3*st**4*(D1**2*(f*(-66*bd1*s*(C - 1)*(r - 1) + 10*fd*(-2*C*s + r*(2*C - 5)*(3*s - 1) - 9*s**2 + 11*s - 3) - 5*fdd*(-2*C*s + r*(2*C - 5)*(3*s - 1) - 9*s**2 + 11*s - 3)) + fd*(-66*b1*r*(C - 1)*(2*s - 1) - 5*fd*(2*C*(6*r*s - 2*r - 2*s + 1) - 30*r*s + 10*r - 18*s**2 + 22*s - 5))) + D1*f*(Dd*(-66*b1*(C - 1)*(r*(4*s - 2) - s) + 10*f*(-2*C*s + r*(4*C - 10)*(2*s - 1) - 12*s**2 + 17*s - 6) - 5*fd*(2*C*(24*r*s - 10*r - 7*s + 3) - 120*r*s + 50*r - 72*s**2 + 95*s - 27)) + 5*Ddd*f*(-r*(4*C - 10)*(2*s - 1) + 12*s**2 + s*(2*C - 17) + 6)) - 5*Dd**2*f**2*(2*C*(6*r*(2*s - 1) - 3*s + 2) + r*(30 - 60*s) - 36*s**2 + 51*s - 16))/(231*d**2*k1*k3**4) - 40*D1**2*Pk1*Pk3*ct**3*f*k2*st**4*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + 2*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1))/(77*d**2*k1*k3**2) - 10*D1**2*Pk1*Pk3*ct**3*f*k2**5*st**2*(1365*D1**2*b1*f*fd*r**2 - 39*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*fd**2*r**2 - 13*D1**2*bdd1*f**2*(r - 1)**2 + 68*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd + 1292*D1**2*f**2*fdd*r**2 - 646*D1**2*f**2*fdd*r + 323*D1**2*f**2*fdd + 3876*D1**2*f*fd**2*r**2 - 1938*D1**2*f*fd**2*r + 1820*D1*Dd*b1*f**2*r**2 - 910*D1*Dd*b1*f**2*r + 455*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 + 78*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 + 10336*D1*Dd*f**2*fd*r**2 - 5168*D1*Dd*f**2*fd*r + 646*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 + 26*D1*Ddd*b1*f**2*r - 13*D1*Ddd*b1*f**2 + 1292*D1*Ddd*f**3*r**2 - 646*D1*Ddd*f**3*r + 323*D1*Ddd*f**3 + 13*D1*bd1*f*(r - 1)*(35*D1*f*(r - 1) - 6*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 156*Dd**2*b1*f**2*r**2 + 78*Dd**2*b1*f**2*r + 3876*Dd**2*f**3*r**2 - 1938*Dd**2*f**3*r)/(9009*d**2*k1**3*k3**4) - D1**2*Pk1*Pk3*ct**3*k1**5*k2*(96*C - 56)*(264*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r + 264*D1**2*b1*f*fd*s**2 - 264*D1**2*b1*f*fd*s + 132*D1**2*b1*f*fd - 330*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 330*D1**2*b1*f*fdd*s**2 + 330*D1**2*b1*f*fdd*s - 165*D1**2*b1*f*fdd - 330*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r - 330*D1**2*b1*fd**2*s**2 + 330*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)**2 + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 792*D1*Dd*b1*f**2*r + 528*D1*Dd*b1*f**2*s**2 - 792*D1*Dd*b1*f**2*s + 396*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 3300*D1*Dd*b1*f*fd*r - 2640*D1*Dd*b1*f*fd*s**2 + 3300*D1*Dd*b1*f*fd*s - 990*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 690*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 690*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 990*D1*Ddd*b1*f**2*r - 660*D1*Ddd*b1*f**2*s**2 + 990*D1*Ddd*b1*f**2*s - 495*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 1980*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 2970*Dd**2*b1*f**2*r - 1980*Dd**2*b1*f**2*s**2 + 2970*Dd**2*b1*f**2*s - 990*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3)/(231*d**2*k3**8) - D1**2*Pk1*Pk3*ct**3*k1**5*(32*C - 16)*(33*b1*(D1**2*(f*(4*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(4*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(2*s - 1)*(8*r + 8*s - 5)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-5*D1**2*(f*(33*bdd1*s*(r + s - 1) - 23*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(4*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) - 5*D1*f*(Dd*(-23*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 28*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) + 28*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 140*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k2*k3**6) - 8*D1**2*Pk1*Pk3*ct**3*k1**3*k2**3*st**2*(12672*C*D1**2*b1*f*fd*r**2 + 25344*C*D1**2*b1*f*fd*r*s - 12672*C*D1**2*b1*f*fd*r + 12672*C*D1**2*b1*f*fd*s**2 - 12672*C*D1**2*b1*f*fd*s + 6336*C*D1**2*b1*f*fd - 8184*C*D1**2*b1*f*fdd*r**2 - 16368*C*D1**2*b1*f*fdd*r*s + 8184*C*D1**2*b1*f*fdd*r - 8184*C*D1**2*b1*f*fdd*s**2 + 8184*C*D1**2*b1*f*fdd*s - 4092*C*D1**2*b1*f*fdd - 8184*C*D1**2*b1*fd**2*r**2 - 16368*C*D1**2*b1*fd**2*r*s + 8184*C*D1**2*b1*fd**2*r - 8184*C*D1**2*b1*fd**2*s**2 + 8184*C*D1**2*b1*fd**2*s + 13056*C*D1**2*f**2*fd*r**2 + 26112*C*D1**2*f**2*fd*r*s - 17408*C*D1**2*f**2*fd*r + 13056*C*D1**2*f**2*fd*s**2 - 17408*C*D1**2*f**2*fd*s + 8704*C*D1**2*f**2*fd - 9300*C*D1**2*f**2*fdd*r**2 - 18600*C*D1**2*f**2*fdd*r*s + 12400*C*D1**2*f**2*fdd*r - 9300*C*D1**2*f**2*fdd*s**2 + 12400*C*D1**2*f**2*fdd*s - 6200*C*D1**2*f**2*fdd - 18600*C*D1**2*f*fd**2*r**2 - 37200*C*D1**2*f*fd**2*r*s + 24800*C*D1**2*f*fd**2*r - 18600*C*D1**2*f*fd**2*s**2 + 24800*C*D1**2*f*fd**2*s - 6200*C*D1**2*f*fd**2 + 25344*C*D1*Dd*b1*f**2*r**2 + 50688*C*D1*Dd*b1*f**2*r*s - 38016*C*D1*Dd*b1*f**2*r + 25344*C*D1*Dd*b1*f**2*s**2 - 38016*C*D1*Dd*b1*f**2*s + 19008*C*D1*Dd*b1*f**2 - 65472*C*D1*Dd*b1*f*fd*r**2 - 130944*C*D1*Dd*b1*f*fd*r*s + 81840*C*D1*Dd*b1*f*fd*r - 65472*C*D1*Dd*b1*f*fd*s**2 + 81840*C*D1*Dd*b1*f*fd*s - 24552*C*D1*Dd*b1*f*fd + 17408*C*D1*Dd*f**3*r**2 + 34816*C*D1*Dd*f**3*r*s - 26112*C*D1*Dd*f**3*r + 17408*C*D1*Dd*f**3*s**2 - 26112*C*D1*Dd*f**3*s + 13056*C*D1*Dd*f**3 - 74400*C*D1*Dd*f**2*fd*r**2 - 148800*C*D1*Dd*f**2*fd*r*s + 105400*C*D1*Dd*f**2*fd*r - 74400*C*D1*Dd*f**2*fd*s**2 + 105400*C*D1*Dd*f**2*fd*s - 37200*C*D1*Dd*f**2*fd - 16368*C*D1*Ddd*b1*f**2*r**2 - 32736*C*D1*Ddd*b1*f**2*r*s + 24552*C*D1*Ddd*b1*f**2*r - 16368*C*D1*Ddd*b1*f**2*s**2 + 24552*C*D1*Ddd*b1*f**2*s - 12276*C*D1*Ddd*b1*f**2 - 12400*C*D1*Ddd*f**3*r**2 - 24800*C*D1*Ddd*f**3*r*s + 18600*C*D1*Ddd*f**3*r - 12400*C*D1*Ddd*f**3*s**2 + 18600*C*D1*Ddd*f**3*s - 9300*C*D1*Ddd*f**3 - 49104*C*Dd**2*b1*f**2*r**2 - 98208*C*Dd**2*b1*f**2*r*s + 73656*C*Dd**2*b1*f**2*r - 49104*C*Dd**2*b1*f**2*s**2 + 73656*C*Dd**2*b1*f**2*s - 24552*C*Dd**2*b1*f**2 - 37200*C*Dd**2*f**3*r**2 - 74400*C*Dd**2*f**3*r*s + 55800*C*Dd**2*f**3*r - 37200*C*Dd**2*f**3*s**2 + 55800*C*Dd**2*f**3*s - 18600*C*Dd**2*f**3 - 8646*D1**2*b1*f*fd*r**2 - 17292*D1**2*b1*f*fd*r*s + 8646*D1**2*b1*f*fd*r - 8646*D1**2*b1*f*fd*s**2 + 8646*D1**2*b1*f*fd*s - 4323*D1**2*b1*f*fd + 5676*D1**2*b1*f*fdd*r**2 + 11352*D1**2*b1*f*fdd*r*s - 5676*D1**2*b1*f*fdd*r + 5676*D1**2*b1*f*fdd*s**2 - 5676*D1**2*b1*f*fdd*s + 2838*D1**2*b1*f*fdd + 5676*D1**2*b1*fd**2*r**2 + 11352*D1**2*b1*fd**2*r*s - 5676*D1**2*b1*fd**2*r + 5676*D1**2*b1*fd**2*s**2 - 5676*D1**2*b1*fd**2*s - 66*D1**2*bdd1*f**2*(62*C - 43)*(r + s - 1)**2 - 8841*D1**2*f**2*fd*r**2 - 17682*D1**2*f**2*fd*r*s + 11788*D1**2*f**2*fd*r - 8841*D1**2*f**2*fd*s**2 + 11788*D1**2*f**2*fd*s - 5894*D1**2*f**2*fd + 6450*D1**2*f**2*fdd*r**2 + 12900*D1**2*f**2*fdd*r*s - 8600*D1**2*f**2*fdd*r + 6450*D1**2*f**2*fdd*s**2 - 8600*D1**2*f**2*fdd*s + 4300*D1**2*f**2*fdd + 12900*D1**2*f*fd**2*r**2 + 25800*D1**2*f*fd**2*r*s - 17200*D1**2*f*fd**2*r + 12900*D1**2*f*fd**2*s**2 - 17200*D1**2*f*fd**2*s + 4300*D1**2*f*fd**2 - 17292*D1*Dd*b1*f**2*r**2 - 34584*D1*Dd*b1*f**2*r*s + 25938*D1*Dd*b1*f**2*r - 17292*D1*Dd*b1*f**2*s**2 + 25938*D1*Dd*b1*f**2*s - 12969*D1*Dd*b1*f**2 + 45408*D1*Dd*b1*f*fd*r**2 + 90816*D1*Dd*b1*f*fd*r*s - 56760*D1*Dd*b1*f*fd*r + 45408*D1*Dd*b1*f*fd*s**2 - 56760*D1*Dd*b1*f*fd*s + 17028*D1*Dd*b1*f*fd - 11788*D1*Dd*f**3*r**2 - 23576*D1*Dd*f**3*r*s + 17682*D1*Dd*f**3*r - 11788*D1*Dd*f**3*s**2 + 17682*D1*Dd*f**3*s - 8841*D1*Dd*f**3 + 51600*D1*Dd*f**2*fd*r**2 + 103200*D1*Dd*f**2*fd*r*s - 73100*D1*Dd*f**2*fd*r + 51600*D1*Dd*f**2*fd*s**2 - 73100*D1*Dd*f**2*fd*s + 25800*D1*Dd*f**2*fd + 11352*D1*Ddd*b1*f**2*r**2 + 22704*D1*Ddd*b1*f**2*r*s - 17028*D1*Ddd*b1*f**2*r + 11352*D1*Ddd*b1*f**2*s**2 - 17028*D1*Ddd*b1*f**2*s + 8514*D1*Ddd*b1*f**2 + 8600*D1*Ddd*f**3*r**2 + 17200*D1*Ddd*f**3*r*s - 12900*D1*Ddd*f**3*r + 8600*D1*Ddd*f**3*s**2 - 12900*D1*Ddd*f**3*s + 6450*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(192*C - 131)*(r + s - 1) - D1*fd*(248*C - 172)*(2*r + 2*s - 1) - Dd*f*(248*C - 172)*(4*r + 4*s - 3)) + 34056*Dd**2*b1*f**2*r**2 + 68112*Dd**2*b1*f**2*r*s - 51084*Dd**2*b1*f**2*r + 34056*Dd**2*b1*f**2*s**2 - 51084*Dd**2*b1*f**2*s + 17028*Dd**2*b1*f**2 + 25800*Dd**2*f**3*r**2 + 51600*Dd**2*f**3*r*s - 38700*Dd**2*f**3*r + 25800*Dd**2*f**3*s**2 - 38700*Dd**2*f**3*s + 12900*Dd**2*f**3)/(231*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**3*k1**3*k2**3*(-51480*C*D1**2*f**2*fd*r**2 - 102960*C*D1**2*f**2*fd*r*s + 68640*C*D1**2*f**2*fd*r - 51480*C*D1**2*f**2*fd*s**2 + 68640*C*D1**2*f**2*fd*s - 34320*C*D1**2*f**2*fd - 68640*C*D1*Dd*f**3*r**2 - 137280*C*D1*Dd*f**3*r*s + 102960*C*D1*Dd*f**3*r - 68640*C*D1*Dd*f**3*s**2 + 102960*C*D1*Dd*f**3*s - 51480*C*D1*Dd*f**3 - 42900*D1**2*K*bdd1*f**2*r**2 - 85800*D1**2*K*bdd1*f**2*r*s + 85800*D1**2*K*bdd1*f**2*r - 42900*D1**2*K*bdd1*f**2*s**2 + 85800*D1**2*K*bdd1*f**2*s - 42900*D1**2*K*bdd1*f**2 + 8580*D1**2*bd1**2*f*(-12*K + 5*f + 6)*(r + s - 1)**2 + 9100*D1**2*bdd1*f**3*r**2 + 18200*D1**2*bdd1*f**3*r*s - 18200*D1**2*bdd1*f**3*r + 9100*D1**2*bdd1*f**3*s**2 - 18200*D1**2*bdd1*f**3*s + 9100*D1**2*bdd1*f**3 + 21450*D1**2*bdd1*f**2*r**2 + 42900*D1**2*bdd1*f**2*r*s - 42900*D1**2*bdd1*f**2*r + 21450*D1**2*bdd1*f**2*s**2 - 42900*D1**2*bdd1*f**2*s + 21450*D1**2*bdd1*f**2 + 102960*D1**2*bdd1*f*g2*r**2 + 205920*D1**2*bdd1*f*g2*r*s - 205920*D1**2*bdd1*f*g2*r + 102960*D1**2*bdd1*f*g2*s**2 - 205920*D1**2*bdd1*f*g2*s + 102960*D1**2*bdd1*f*g2 + 26600*D1**2*f**3*fd*r**2 + 53200*D1**2*f**3*fd*r*s - 39900*D1**2*f**3*fd*r + 26600*D1**2*f**3*fd*s**2 - 39900*D1**2*f**3*fd*s + 19950*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 + 32175*D1**2*f**2*fd*r**2 + 64350*D1**2*f**2*fd*r*s - 42900*D1**2*f**2*fd*r + 32175*D1**2*f**2*fd*s**2 - 42900*D1**2*f**2*fd*s + 21450*D1**2*f**2*fd - 89232*D1**2*f**2*gd2*r**2 - 178464*D1**2*f**2*gd2*r*s + 178464*D1**2*f**2*gd2*r - 89232*D1**2*f**2*gd2*s**2 + 178464*D1**2*f**2*gd2*s - 89232*D1**2*f**2*gd2 + 85800*D1**2*f**2*gdd2*r**2 + 171600*D1**2*f**2*gdd2*r*s - 171600*D1**2*f**2*gdd2*r + 85800*D1**2*f**2*gdd2*s**2 - 171600*D1**2*f**2*gdd2*s + 85800*D1**2*f**2*gdd2 - 178464*D1**2*f*fd*g2*r**2 - 356928*D1**2*f*fd*g2*r*s + 178464*D1**2*f*fd*g2*r - 178464*D1**2*f*fd*g2*s**2 + 178464*D1**2*f*fd*g2*s - 89232*D1**2*f*fd*g2 + 343200*D1**2*f*fd*gd2*r**2 + 686400*D1**2*f*fd*gd2*r*s - 514800*D1**2*f*fd*gd2*r + 343200*D1**2*f*fd*gd2*s**2 - 514800*D1**2*f*fd*gd2*s + 171600*D1**2*f*fd*gd2 + 171600*D1**2*f*fdd*g2*r**2 + 343200*D1**2*f*fdd*g2*r*s - 171600*D1**2*f*fdd*g2*r + 171600*D1**2*f*fdd*g2*s**2 - 171600*D1**2*f*fdd*g2*s + 85800*D1**2*f*fdd*g2 + 171600*D1**2*fd**2*g2*r**2 + 343200*D1**2*fd**2*g2*r*s - 171600*D1**2*fd**2*g2*r + 171600*D1**2*fd**2*g2*s**2 - 171600*D1**2*fd**2*g2*s + 26600*D1*Dd*f**4*r**2 + 53200*D1*Dd*f**4*r*s - 39900*D1*Dd*f**4*r + 26600*D1*Dd*f**4*s**2 - 39900*D1*Dd*f**4*s + 19950*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd + 42900*D1*Dd*f**3*r**2 + 85800*D1*Dd*f**3*r*s - 64350*D1*Dd*f**3*r + 42900*D1*Dd*f**3*s**2 - 64350*D1*Dd*f**3*s + 32175*D1*Dd*f**3 - 356928*D1*Dd*f**2*g2*r**2 - 713856*D1*Dd*f**2*g2*r*s + 535392*D1*Dd*f**2*g2*r - 356928*D1*Dd*f**2*g2*s**2 + 535392*D1*Dd*f**2*g2*s - 267696*D1*Dd*f**2*g2 + 686400*D1*Dd*f**2*gd2*r**2 + 1372800*D1*Dd*f**2*gd2*r*s - 1201200*D1*Dd*f**2*gd2*r + 686400*D1*Dd*f**2*gd2*s**2 - 1201200*D1*Dd*f**2*gd2*s + 514800*D1*Dd*f**2*gd2 + 1372800*D1*Dd*f*fd*g2*r**2 + 2745600*D1*Dd*f*fd*g2*r*s - 1716000*D1*Dd*f*fd*g2*r + 1372800*D1*Dd*f*fd*g2*s**2 - 1716000*D1*Dd*f*fd*g2*s + 514800*D1*Dd*f*fd*g2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 343200*D1*Ddd*f**2*g2*r**2 + 686400*D1*Ddd*f**2*g2*r*s - 514800*D1*Ddd*f**2*g2*r + 343200*D1*Ddd*f**2*g2*s**2 - 514800*D1*Ddd*f**2*g2*s + 257400*D1*Ddd*f**2*g2 - 52*D1*bd1*(D1*(185*f**3*(r + s - 1) + 2*f**2*(198*C*(r + s - 1) - 175*fd*(3*r + 3*s - 2) - (429*K - 66)*(r + s - 1)) + 33*f*(25*fd*(2*K - 1)*(2*r + 2*s - 1) + (64*g2 - 120*gd2)*(r + s - 1)) - 3960*fd*g2*(r + s)) - 5*Dd*f*(70*f**2 - 165*f*(2*K - 1) + 792*g2)*(4*r + 4*s - 3))*(r + s - 1) - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 1029600*Dd**2*f**2*g2*r**2 + 2059200*Dd**2*f**2*g2*r*s - 1544400*Dd**2*f**2*g2*r + 1029600*Dd**2*f**2*g2*s**2 - 1544400*Dd**2*f**2*g2*s + 514800*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(2*f*(23*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(128*K - 57)*(r + s) - 60*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(46*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (128*K - 57)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 120*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 10*Ddd*f*(-12*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f*(-12*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 26*b1*(1584*C*D1**2*f*fd*r**2 + 3168*C*D1**2*f*fd*r*s - 1584*C*D1**2*f*fd*r + 1584*C*D1**2*f*fd*s**2 - 1584*C*D1**2*f*fd*s + 792*C*D1**2*f*fd + 3168*C*D1*Dd*f**2*r**2 + 6336*C*D1*Dd*f**2*r*s - 4752*C*D1*Dd*f**2*r + 3168*C*D1*Dd*f**2*s**2 - 4752*C*D1*Dd*f**2*s + 2376*C*D1*Dd*f**2 - 3432*D1**2*K*f*fd*r**2 - 6864*D1**2*K*f*fd*r*s + 3432*D1**2*K*f*fd*r - 3432*D1**2*K*f*fd*s**2 + 3432*D1**2*K*f*fd*s - 1716*D1**2*K*f*fd + 3300*D1**2*K*f*fdd*r**2 + 6600*D1**2*K*f*fdd*r*s - 3300*D1**2*K*f*fdd*r + 3300*D1**2*K*f*fdd*s**2 - 3300*D1**2*K*f*fdd*s + 1650*D1**2*K*f*fdd + 3300*D1**2*K*fd**2*r**2 + 6600*D1**2*K*fd**2*r*s - 3300*D1**2*K*fd**2*r + 3300*D1**2*K*fd**2*s**2 - 3300*D1**2*K*fd**2*s - 330*D1**2*bdd1*f*(-12*K + 5*f + 6)*(r + s - 1)**2 + 1110*D1**2*f**2*fd*r**2 + 2220*D1**2*f**2*fd*r*s - 1480*D1**2*f**2*fd*r + 1110*D1**2*f**2*fd*s**2 - 1480*D1**2*f**2*fd*s + 740*D1**2*f**2*fd - 1050*D1**2*f**2*fdd*r**2 - 2100*D1**2*f**2*fdd*r*s + 1400*D1**2*f**2*fdd*r - 1050*D1**2*f**2*fdd*s**2 + 1400*D1**2*f**2*fdd*s - 700*D1**2*f**2*fdd - 2100*D1**2*f*fd**2*r**2 - 4200*D1**2*f*fd**2*r*s + 2800*D1**2*f*fd**2*r - 2100*D1**2*f*fd**2*s**2 + 2800*D1**2*f*fd**2*s - 700*D1**2*f*fd**2 + 528*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 528*D1**2*f*fd*r + 528*D1**2*f*fd*s**2 - 528*D1**2*f*fd*s + 264*D1**2*f*fd - 1650*D1**2*f*fdd*r**2 - 3300*D1**2*f*fdd*r*s + 1650*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1650*D1**2*f*fdd*s - 825*D1**2*f*fdd + 4224*D1**2*f*gd2*r**2 + 8448*D1**2*f*gd2*r*s - 8448*D1**2*f*gd2*r + 4224*D1**2*f*gd2*s**2 - 8448*D1**2*f*gd2*s + 4224*D1**2*f*gd2 - 3960*D1**2*f*gdd2*r**2 - 7920*D1**2*f*gdd2*r*s + 7920*D1**2*f*gdd2*r - 3960*D1**2*f*gdd2*s**2 + 7920*D1**2*f*gdd2*s - 3960*D1**2*f*gdd2 - 1650*D1**2*fd**2*r**2 - 3300*D1**2*fd**2*r*s + 1650*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1650*D1**2*fd**2*s + 4224*D1**2*fd*g2*r**2 + 8448*D1**2*fd*g2*r*s + 4224*D1**2*fd*g2*s**2 - 7920*D1**2*fd*gd2*r**2 - 15840*D1**2*fd*gd2*r*s + 7920*D1**2*fd*gd2*r - 7920*D1**2*fd*gd2*s**2 + 7920*D1**2*fd*gd2*s - 3960*D1**2*fdd*g2*r**2 - 7920*D1**2*fdd*g2*r*s - 3960*D1**2*fdd*g2*s**2 - 6864*D1*Dd*K*f**2*r**2 - 13728*D1*Dd*K*f**2*r*s + 10296*D1*Dd*K*f**2*r - 6864*D1*Dd*K*f**2*s**2 + 10296*D1*Dd*K*f**2*s - 5148*D1*Dd*K*f**2 + 26400*D1*Dd*K*f*fd*r**2 + 52800*D1*Dd*K*f*fd*r*s - 33000*D1*Dd*K*f*fd*r + 26400*D1*Dd*K*f*fd*s**2 - 33000*D1*Dd*K*f*fd*s + 9900*D1*Dd*K*f*fd + 1480*D1*Dd*f**3*r**2 + 2960*D1*Dd*f**3*r*s - 2220*D1*Dd*f**3*r + 1480*D1*Dd*f**3*s**2 - 2220*D1*Dd*f**3*s + 1110*D1*Dd*f**3 - 8400*D1*Dd*f**2*fd*r**2 - 16800*D1*Dd*f**2*fd*r*s + 11900*D1*Dd*f**2*fd*r - 8400*D1*Dd*f**2*fd*s**2 + 11900*D1*Dd*f**2*fd*s - 4200*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 1584*D1*Dd*f**2*r + 1056*D1*Dd*f**2*s**2 - 1584*D1*Dd*f**2*s + 792*D1*Dd*f**2 - 13200*D1*Dd*f*fd*r**2 - 26400*D1*Dd*f*fd*r*s + 16500*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 16500*D1*Dd*f*fd*s - 4950*D1*Dd*f*fd + 16896*D1*Dd*f*g2*r**2 + 33792*D1*Dd*f*g2*r*s - 25344*D1*Dd*f*g2*r + 16896*D1*Dd*f*g2*s**2 - 25344*D1*Dd*f*g2*s + 12672*D1*Dd*f*g2 - 31680*D1*Dd*f*gd2*r**2 - 63360*D1*Dd*f*gd2*r*s + 55440*D1*Dd*f*gd2*r - 31680*D1*Dd*f*gd2*s**2 + 55440*D1*Dd*f*gd2*s - 23760*D1*Dd*f*gd2 - 31680*D1*Dd*fd*g2*r**2 - 63360*D1*Dd*fd*g2*r*s + 23760*D1*Dd*fd*g2*r - 31680*D1*Dd*fd*g2*s**2 + 23760*D1*Dd*fd*g2*s + 6600*D1*Ddd*K*f**2*r**2 + 13200*D1*Ddd*K*f**2*r*s - 9900*D1*Ddd*K*f**2*r + 6600*D1*Ddd*K*f**2*s**2 - 9900*D1*Ddd*K*f**2*s + 4950*D1*Ddd*K*f**2 - 1400*D1*Ddd*f**3*r**2 - 2800*D1*Ddd*f**3*r*s + 2100*D1*Ddd*f**3*r - 1400*D1*Ddd*f**3*s**2 + 2100*D1*Ddd*f**3*s - 1050*D1*Ddd*f**3 - 3300*D1*Ddd*f**2*r**2 - 6600*D1*Ddd*f**2*r*s + 4950*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 4950*D1*Ddd*f**2*s - 2475*D1*Ddd*f**2 - 15840*D1*Ddd*f*g2*r**2 - 31680*D1*Ddd*f*g2*r*s + 23760*D1*Ddd*f*g2*r - 15840*D1*Ddd*f*g2*s**2 + 23760*D1*Ddd*f*g2*s - 11880*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(46*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(128*K - 57)*(r + s - 1) + 120*fd*(2*K - 1)*(r + s)) - 20*Dd*f*(-12*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 19800*Dd**2*K*f**2*r**2 + 39600*Dd**2*K*f**2*r*s - 29700*Dd**2*K*f**2*r + 19800*Dd**2*K*f**2*s**2 - 29700*Dd**2*K*f**2*s + 9900*Dd**2*K*f**2 - 4200*Dd**2*f**3*r**2 - 8400*Dd**2*f**3*r*s + 6300*Dd**2*f**3*r - 4200*Dd**2*f**3*s**2 + 6300*Dd**2*f**3*s - 2100*Dd**2*f**3 - 9900*Dd**2*f**2*r**2 - 19800*Dd**2*f**2*r*s + 14850*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 14850*Dd**2*f**2*s - 4950*Dd**2*f**2 - 47520*Dd**2*f*g2*r**2 - 95040*Dd**2*f*g2*r*s + 71280*Dd**2*f*g2*r - 47520*Dd**2*f*g2*s**2 + 71280*Dd**2*f*g2*s - 23760*Dd**2*f*g2))/(3003*d**2*k3**8) - 16*D1**2*Pk1*Pk3*ct**3*k1**3*k2*st**2*(11*b1*(D1**2*(f*(fd*(119*C - 77) + fdd*(45 - 69*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(45 - 69*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(119*C - 77)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(45 - 69*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(45 - 69*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(45 - 69*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(941*C - 607)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (23*C - 15)*(33*bdd1*s*(r + s - 1) + 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(375 - 575*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(D1*(f*s*(119*C - 77)*(r + s - 1) - fd*(69*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(45 - 69*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(941*C - 607)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(575*C - 375)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(375 - 575*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(375 - 575*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**3*k1**3*k2*(66*b1**2*(8*C - 5)*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(-272*C*D1**2*f*fd*r**2 - 1216*C*D1**2*f*fd*r*s + 544*C*D1**2*f*fd*r - 944*C*D1**2*f*fd*s**2 + 880*C*D1**2*f*fd*s - 440*C*D1**2*f*fd + 400*C*D1**2*f*fdd*r**2 + 1280*C*D1**2*f*fdd*r*s - 560*C*D1**2*f*fdd*r + 880*C*D1**2*f*fdd*s**2 - 800*C*D1**2*f*fdd*s + 400*C*D1**2*f*fdd + 400*C*D1**2*fd**2*r**2 + 1280*C*D1**2*fd**2*r*s - 560*C*D1**2*fd**2*r + 880*C*D1**2*fd**2*s**2 - 800*C*D1**2*fd**2*s - 80*C*D1**2*fd**2 - 544*C*D1*Dd*f**2*r**2 - 2432*C*D1*Dd*f**2*r*s + 1488*C*D1*Dd*f**2*r - 1888*C*D1*Dd*f**2*s**2 + 2496*C*D1*Dd*f**2*s - 1080*C*D1*Dd*f**2 + 3200*C*D1*Dd*f*fd*r**2 + 10240*C*D1*Dd*f*fd*r*s - 5600*C*D1*Dd*f*fd*r + 7040*C*D1*Dd*f*fd*s**2 - 8000*C*D1*Dd*f*fd*s + 2160*C*D1*Dd*f*fd + 800*C*D1*Ddd*f**2*r**2 + 2560*C*D1*Ddd*f**2*r*s - 1680*C*D1*Ddd*f**2*r + 1760*C*D1*Ddd*f**2*s**2 - 2400*C*D1*Ddd*f**2*s + 1080*C*D1*Ddd*f**2 + 2400*C*Dd**2*f**2*r**2 + 7680*C*Dd**2*f**2*r*s - 5040*C*Dd**2*f**2*r + 5280*C*Dd**2*f**2*s**2 - 7200*C*Dd**2*f**2*s + 2160*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(8*C - 5)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 162*D1**2*f*fd*r**2 + 812*D1**2*f*fd*r*s - 366*D1**2*f*fd*r + 650*D1**2*f*fd*s**2 - 610*D1**2*f*fd*s + 305*D1**2*f*fd - 240*D1**2*f*fdd*r**2 - 856*D1**2*f*fdd*r*s + 378*D1**2*f*fdd*r - 616*D1**2*f*fdd*s**2 + 566*D1**2*f*fdd*s - 283*D1**2*f*fdd - 240*D1**2*fd**2*r**2 - 856*D1**2*fd**2*r*s + 378*D1**2*fd**2*r - 616*D1**2*fd**2*s**2 + 566*D1**2*fd**2*s + 50*D1**2*fd**2 + 324*D1*Dd*f**2*r**2 + 1624*D1*Dd*f**2*r*s - 974*D1*Dd*f**2*r + 1300*D1*Dd*f**2*s**2 - 1706*D1*Dd*f**2*s + 731*D1*Dd*f**2 - 1920*D1*Dd*f*fd*r**2 - 6848*D1*Dd*f*fd*r*s + 3704*D1*Dd*f*fd*r - 4928*D1*Dd*f*fd*s**2 + 5584*D1*Dd*f*fd*s - 1510*D1*Dd*f*fd - 480*D1*Ddd*f**2*r**2 - 1712*D1*Ddd*f**2*r*s + 1096*D1*Ddd*f**2*r - 1232*D1*Ddd*f**2*s**2 + 1660*D1*Ddd*f**2*s - 736*D1*Ddd*f**2 + D1*bd1*(8*C - 5)*(D1*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 12*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 1440*Dd**2*f**2*r**2 - 5136*Dd**2*f**2*r*s + 3288*Dd**2*f**2*r - 3696*Dd**2*f**2*s**2 + 4980*Dd**2*f**2*s - 1472*Dd**2*f**2) + f*(-792*D1**2*bd1**2*(8*C - 5)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 66*D1**2*bdd1*f*(40*C*(5*r**2 + 4*r*(4*s - 3) + 11*s**2 - 18*s + 6) - 120*r**2 + r*(290 - 428*s) - 308*s**2 + 478*s - 145) - 5*D1**2*(f*(fd*(8*C*(861*r**2 + 6*r*(493*s - 260) + 2097*s**2 - 2384*s + 986) - 4137*r**2 - 15630*r*s + 7968*r - 11493*s**2 + 12872*s - 5210) + fdd*(-8*C*(1074*r**2 + 3063*r*s - 1737*r + 1989*s**2 - 2347*s + 1021) + 5187*r**2 + 16230*r*s - 8868*r + 11043*s**2 - 12772*s + 5410)) + 2*fd**2*(-4*C*(2148*r**2 + 6126*r*s - 3474*r + 3978*s**2 - 4694*s + 1021) + 5187*r**2 + 16230*r*s - 8868*r + 11043*s**2 - 12772*s + 2705)) - 66*D1*bd1*(D1*(f*(8*C*(17*r**2 + 76*r*s - 42*r + 59*s**2 - 84*s + 21) - 81*r**2 - 406*r*s + 202*r - 325*s**2 + 446*s - 101) - 2*fd*(40*C*(10*r**2 + 32*r*s - 19*r + 22*s**2 - 28*s + 9) - 240*r**2 - 856*r*s + 479*r - 616*s**2 + 761*s - 239)) + 2*Dd*f*(-40*C*(20*r**2 + r*(64*s - 45) + 44*s**2 - 66*s + 24) + 480*r**2 + 8*r*(214*s - 141) + 1232*s**2 - 1786*s + 623)) - 5*D1*f*(Dd*(f*(8*C*(1148*r**2 + 3944*r*s - 2546*r + 2796*s**2 - 3782*s + 1685) - 5516*r**2 - 20840*r*s + 13178*r - 15324*s**2 + 20534*s - 9041) - 2*fd*(4*C*(8592*r**2 + 6*r*(4084*s - 2537) + 15912*s**2 - 20407*s + 6431) - 20748*r**2 - 64920*r*s + 39153*r - 44172*s**2 + 55745*s - 17206)) + Ddd*f*(-8*C*(1432*r**2 + 4084*r*s - 2758*r + 2652*s**2 - 3673*s + 1684) + 6916*r**2 + 21640*r*s - 14278*r + 14724*s**2 - 20134*s + 9091)) - 10*Dd**2*f**2*(-4*C*(4296*r**2 + 12252*r*s - 8274*r + 7956*s**2 - 11019*s + 3368) + 10374*r**2 + 32460*r*s - 21417*r + 22086*s**2 - 30201*s + 9091)))/(693*d**2*k3**6) - D1**2*Pk1*Pk3*ct**3*k1**3*st**2*(256*C - 152)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + 2*D1*f*(50*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(2*s**2 - 2*s + 1)) - 50*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k2*k3**4) - 2*D1**2*Pk1*Pk3*ct**3*k1**3*(132*b1**2*(2*C - 1)*(D1**2*(5*fd - 6*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 6*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 6*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 6*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 66*b1*(D1**2*(f*(-12*bdd1*s*(2*C - 1)*(2*r + 2*s - 1) + fd*(-8*C*(10*r*s - 5*r + 52*s**2 - 50*s + 26) + 40*r*s - 20*r + 258*s**2 - 250*s + 129) + 2*fdd*(2*C*(22*r*s - 11*r + 82*s**2 - 77*s + 41) - 22*r*s + 11*r - 102*s**2 + 97*s - 51)) + 2*fd**2*(2*C*(22*r*s - 11*r + 82*s**2 - 77*s - 5) - 22*r*s + 11*r - 102*s**2 + 97*s + 5)) - 2*D1*bd1*(2*C - 1)*(D1*(-5*f*s*(2*r + 2*s - 1) + 6*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 12*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(4*C*(20*r*s - 10*r + 104*s**2 - 109*s + 52) - 40*r*s + 20*r - 258*s**2 + 268*s - 129) - fd*(2*s - 1)*(2*C*(88*r + 328*s - 165) - 88*r - 408*s + 205)) + Ddd*f*(-2*C*(44*r*s - 22*r + 164*s**2 - 175*s + 82) + 44*r*s - 22*r + 204*s**2 - 215*s + 102)) + 2*Dd**2*f**2*(2*C*(66*r*(2*s - 1) + 492*s**2 - 525*s + 104) - 66*r*(2*s - 1) - 612*s**2 + 645*s - 124)) + f*(-792*D1**2*bd1**2*s*(2*C - 1)*(2*r + 2*s - 1) + D1**2*(f*(132*bdd1*s*(C*(22*r + 82*s - 32) - 11*r - 51*s + 16) - 5*fd*(8*C*(89*r*(3*s - 1) + 930*s**2 - 709*s + 310) - 356*r*(3*s - 1) - 4551*s**2 + 3390*s - 1517) + 5*fdd*(16*C*(47*r*(3*s - 1) + 381*s**2 - 301*s + 127) - 376*r*(3*s - 1) - 3711*s**2 + 2850*s - 1237)) + 10*fd**2*(8*C*(94*r*(3*s - 1) + 762*s**2 - 602*s + 47) - 376*r*(3*s - 1) - 3711*s**2 + 2850*s - 188)) - 66*D1*bd1*(D1*(f*s*(8*C*(5*r + 26*s - 7) - 20*r - 129*s + 28) + fd*(-4*C*(44*r*s - 11*r + 164*s**2 - 109*s + 16) + 88*r*s - 22*r + 408*s**2 - 258*s + 32)) - 2*Dd*f*(2*C*(88*r*s - 22*r + 328*s**2 - 239*s + 32) - 88*r*s + 22*r - 408*s**2 + 279*s - 32)) - 10*D1*f*(Dd*(f*(4*C*(178*r*(2*s - 1) + 1240*s**2 - 1329*s + 620) - 356*r*(2*s - 1) - 3034*s**2 + 3212*s - 1517) + 2*fd*(-4*C*(94*r*(12*s - 5) + 3048*s**2 - 2869*s + 649) + 188*r*(12*s - 5) + 7422*s**2 - 6843*s + 1519)) + Ddd*f*(-8*C*(94*r*(2*s - 1) + 508*s**2 - 555*s + 254) + 376*r*(2*s - 1) + 2474*s**2 - 2662*s + 1237)) + 10*Dd**2*f**2*(24*C*(94*r*(2*s - 1) + 508*s**2 - 555*s + 116) - 1128*r*(2*s - 1) - 7422*s**2 + 7986*s - 1613)))/(693*d**2*k2*k3**4) + 8*D1**2*Pk1*Pk3*ct**3*k1*k2**5*st**2*(23166*C*D1**2*f**2*fd*r**2 + 46332*C*D1**2*f**2*fd*r*s - 30888*C*D1**2*f**2*fd*r + 23166*C*D1**2*f**2*fd*s**2 - 30888*C*D1**2*f**2*fd*s + 15444*C*D1**2*f**2*fd + 30888*C*D1*Dd*f**3*r**2 + 61776*C*D1*Dd*f**3*r*s - 46332*C*D1*Dd*f**3*r + 30888*C*D1*Dd*f**3*s**2 - 46332*C*D1*Dd*f**3*s + 23166*C*D1*Dd*f**3 + 5148*D1**2*K*bdd1*f**2*r**2 + 10296*D1**2*K*bdd1*f**2*r*s - 10296*D1**2*K*bdd1*f**2*r + 5148*D1**2*K*bdd1*f**2*s**2 - 10296*D1**2*K*bdd1*f**2*s + 5148*D1**2*K*bdd1*f**2 - 858*D1**2*bd1**2*f*(-12*K + 25*f + 9)*(r + s - 1)**2 + 8125*D1**2*bdd1*f**3*r**2 + 16250*D1**2*bdd1*f**3*r*s - 16250*D1**2*bdd1*f**3*r + 8125*D1**2*bdd1*f**3*s**2 - 16250*D1**2*bdd1*f**3*s + 8125*D1**2*bdd1*f**3 - 3861*D1**2*bdd1*f**2*r**2 - 7722*D1**2*bdd1*f**2*r*s + 7722*D1**2*bdd1*f**2*r - 3861*D1**2*bdd1*f**2*s**2 + 7722*D1**2*bdd1*f**2*s - 3861*D1**2*bdd1*f**2 - 10296*D1**2*bdd1*f*g2*r**2 - 20592*D1**2*bdd1*f*g2*r*s + 20592*D1**2*bdd1*f*g2*r - 10296*D1**2*bdd1*f*g2*s**2 + 20592*D1**2*bdd1*f*g2*s - 10296*D1**2*bdd1*f*g2 - 68100*D1**2*f**3*fd*r**2 - 136200*D1**2*f**3*fd*r*s + 102150*D1**2*f**3*fd*r - 68100*D1**2*f**3*fd*s**2 + 102150*D1**2*f**3*fd*s - 51075*D1**2*f**3*fd + 49000*D1**2*f**3*fdd*r**2 + 98000*D1**2*f**3*fdd*r*s - 73500*D1**2*f**3*fdd*r + 49000*D1**2*f**3*fdd*s**2 - 73500*D1**2*f**3*fdd*s + 36750*D1**2*f**3*fdd + 147000*D1**2*f**2*fd**2*r**2 + 294000*D1**2*f**2*fd**2*r*s - 220500*D1**2*f**2*fd**2*r + 147000*D1**2*f**2*fd**2*s**2 - 220500*D1**2*f**2*fd**2*s + 73500*D1**2*f**2*fd**2 - 19305*D1**2*f**2*fd*r**2 - 38610*D1**2*f**2*fd*r*s + 25740*D1**2*f**2*fd*r - 19305*D1**2*f**2*fd*s**2 + 25740*D1**2*f**2*fd*s - 12870*D1**2*f**2*fd + 19734*D1**2*f**2*gd2*r**2 + 39468*D1**2*f**2*gd2*r*s - 39468*D1**2*f**2*gd2*r + 19734*D1**2*f**2*gd2*s**2 - 39468*D1**2*f**2*gd2*s + 19734*D1**2*f**2*gd2 - 10296*D1**2*f**2*gdd2*r**2 - 20592*D1**2*f**2*gdd2*r*s + 20592*D1**2*f**2*gdd2*r - 10296*D1**2*f**2*gdd2*s**2 + 20592*D1**2*f**2*gdd2*s - 10296*D1**2*f**2*gdd2 + 39468*D1**2*f*fd*g2*r**2 + 78936*D1**2*f*fd*g2*r*s - 39468*D1**2*f*fd*g2*r + 39468*D1**2*f*fd*g2*s**2 - 39468*D1**2*f*fd*g2*s + 19734*D1**2*f*fd*g2 - 41184*D1**2*f*fd*gd2*r**2 - 82368*D1**2*f*fd*gd2*r*s + 61776*D1**2*f*fd*gd2*r - 41184*D1**2*f*fd*gd2*s**2 + 61776*D1**2*f*fd*gd2*s - 20592*D1**2*f*fd*gd2 - 20592*D1**2*f*fdd*g2*r**2 - 41184*D1**2*f*fdd*g2*r*s + 20592*D1**2*f*fdd*g2*r - 20592*D1**2*f*fdd*g2*s**2 + 20592*D1**2*f*fdd*g2*s - 10296*D1**2*f*fdd*g2 - 20592*D1**2*fd**2*g2*r**2 - 41184*D1**2*fd**2*g2*r*s + 20592*D1**2*fd**2*g2*r - 20592*D1**2*fd**2*g2*s**2 + 20592*D1**2*fd**2*g2*s - 68100*D1*Dd*f**4*r**2 - 136200*D1*Dd*f**4*r*s + 102150*D1*Dd*f**4*r - 68100*D1*Dd*f**4*s**2 + 102150*D1*Dd*f**4*s - 51075*D1*Dd*f**4 + 392000*D1*Dd*f**3*fd*r**2 + 784000*D1*Dd*f**3*fd*r*s - 588000*D1*Dd*f**3*fd*r + 392000*D1*Dd*f**3*fd*s**2 - 588000*D1*Dd*f**3*fd*s + 220500*D1*Dd*f**3*fd - 25740*D1*Dd*f**3*r**2 - 51480*D1*Dd*f**3*r*s + 38610*D1*Dd*f**3*r - 25740*D1*Dd*f**3*s**2 + 38610*D1*Dd*f**3*s - 19305*D1*Dd*f**3 + 78936*D1*Dd*f**2*g2*r**2 + 157872*D1*Dd*f**2*g2*r*s - 118404*D1*Dd*f**2*g2*r + 78936*D1*Dd*f**2*g2*s**2 - 118404*D1*Dd*f**2*g2*s + 59202*D1*Dd*f**2*g2 - 82368*D1*Dd*f**2*gd2*r**2 - 164736*D1*Dd*f**2*gd2*r*s + 144144*D1*Dd*f**2*gd2*r - 82368*D1*Dd*f**2*gd2*s**2 + 144144*D1*Dd*f**2*gd2*s - 61776*D1*Dd*f**2*gd2 - 164736*D1*Dd*f*fd*g2*r**2 - 329472*D1*Dd*f*fd*g2*r*s + 205920*D1*Dd*f*fd*g2*r - 164736*D1*Dd*f*fd*g2*s**2 + 205920*D1*Dd*f*fd*g2*s - 61776*D1*Dd*f*fd*g2 + 49000*D1*Ddd*f**4*r**2 + 98000*D1*Ddd*f**4*r*s - 73500*D1*Ddd*f**4*r + 49000*D1*Ddd*f**4*s**2 - 73500*D1*Ddd*f**4*s + 36750*D1*Ddd*f**4 - 41184*D1*Ddd*f**2*g2*r**2 - 82368*D1*Ddd*f**2*g2*r*s + 61776*D1*Ddd*f**2*g2*r - 41184*D1*Ddd*f**2*g2*s**2 + 61776*D1*Ddd*f**2*g2*s - 30888*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(689*f**3*(r + s - 1) - f**2*(594*C*(r + s - 1) + 1250*fd*(3*r + 3*s - 2) - (759*K - 66)*(r + s - 1)) - 66*f*(3*fd*(4*K - 3)*(2*r + 2*s - 1) + (31*g2 - 24*gd2)*(r + s - 1)) + 1584*fd*g2*(r + s)) - 2*Dd*f*(625*f**2 + 99*f*(4*K - 3) - 792*g2)*(4*r + 4*s - 3))*(r + s - 1) + 147000*Dd**2*f**4*r**2 + 294000*Dd**2*f**4*r*s - 220500*Dd**2*f**4*r + 147000*Dd**2*f**4*s**2 - 220500*Dd**2*f**4*s + 73500*Dd**2*f**4 - 123552*Dd**2*f**2*g2*r**2 - 247104*Dd**2*f**2*g2*r*s + 185328*Dd**2*f**2*g2*r - 123552*Dd**2*f**2*g2*s**2 + 185328*Dd**2*f**2*g2*s - 61776*Dd**2*f**2*g2 + 429*b1**2*(D1**2*(f*(44*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + fd*(31*K - 25)*(r + s) - 3*fdd*(4*K - 3)*(r + s))) + D1*(Dd*(44*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(50*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (31*K - 25)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(4*K - 3)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-12*K + 25*f + 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-12*K + 25*f + 9)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(1188*C*D1**2*f*fd*r**2 + 2376*C*D1**2*f*fd*r*s - 1188*C*D1**2*f*fd*r + 1188*C*D1**2*f*fd*s**2 - 1188*C*D1**2*f*fd*s + 594*C*D1**2*f*fd + 2376*C*D1*Dd*f**2*r**2 + 4752*C*D1*Dd*f**2*r*s - 3564*C*D1*Dd*f**2*r + 2376*C*D1*Dd*f**2*s**2 - 3564*C*D1*Dd*f**2*s + 1782*C*D1*Dd*f**2 - 1518*D1**2*K*f*fd*r**2 - 3036*D1**2*K*f*fd*r*s + 1518*D1**2*K*f*fd*r - 1518*D1**2*K*f*fd*s**2 + 1518*D1**2*K*f*fd*s - 759*D1**2*K*f*fd + 792*D1**2*K*f*fdd*r**2 + 1584*D1**2*K*f*fdd*r*s - 792*D1**2*K*f*fdd*r + 792*D1**2*K*f*fdd*s**2 - 792*D1**2*K*f*fdd*s + 396*D1**2*K*f*fdd + 792*D1**2*K*fd**2*r**2 + 1584*D1**2*K*fd**2*r*s - 792*D1**2*K*fd**2*r + 792*D1**2*K*fd**2*s**2 - 792*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(-12*K + 25*f + 9)*(r + s - 1)**2 - 2067*D1**2*f**2*fd*r**2 - 4134*D1**2*f**2*fd*r*s + 2756*D1**2*f**2*fd*r - 2067*D1**2*f**2*fd*s**2 + 2756*D1**2*f**2*fd*s - 1378*D1**2*f**2*fd + 1875*D1**2*f**2*fdd*r**2 + 3750*D1**2*f**2*fdd*r*s - 2500*D1**2*f**2*fdd*r + 1875*D1**2*f**2*fdd*s**2 - 2500*D1**2*f**2*fdd*s + 1250*D1**2*f**2*fdd + 3750*D1**2*f*fd**2*r**2 + 7500*D1**2*f*fd**2*r*s - 5000*D1**2*f*fd**2*r + 3750*D1**2*f*fd**2*s**2 - 5000*D1**2*f*fd**2*s + 1250*D1**2*f*fd**2 + 132*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 132*D1**2*f*fd*r + 132*D1**2*f*fd*s**2 - 132*D1**2*f*fd*s + 66*D1**2*f*fd - 594*D1**2*f*fdd*r**2 - 1188*D1**2*f*fdd*r*s + 594*D1**2*f*fdd*r - 594*D1**2*f*fdd*s**2 + 594*D1**2*f*fdd*s - 297*D1**2*f*fdd + 2046*D1**2*f*gd2*r**2 + 4092*D1**2*f*gd2*r*s - 4092*D1**2*f*gd2*r + 2046*D1**2*f*gd2*s**2 - 4092*D1**2*f*gd2*s + 2046*D1**2*f*gd2 - 792*D1**2*f*gdd2*r**2 - 1584*D1**2*f*gdd2*r*s + 1584*D1**2*f*gdd2*r - 792*D1**2*f*gdd2*s**2 + 1584*D1**2*f*gdd2*s - 792*D1**2*f*gdd2 - 594*D1**2*fd**2*r**2 - 1188*D1**2*fd**2*r*s + 594*D1**2*fd**2*r - 594*D1**2*fd**2*s**2 + 594*D1**2*fd**2*s + 2046*D1**2*fd*g2*r**2 + 4092*D1**2*fd*g2*r*s + 2046*D1**2*fd*g2*s**2 - 1584*D1**2*fd*gd2*r**2 - 3168*D1**2*fd*gd2*r*s + 1584*D1**2*fd*gd2*r - 1584*D1**2*fd*gd2*s**2 + 1584*D1**2*fd*gd2*s - 792*D1**2*fdd*g2*r**2 - 1584*D1**2*fdd*g2*r*s - 792*D1**2*fdd*g2*s**2 - 3036*D1*Dd*K*f**2*r**2 - 6072*D1*Dd*K*f**2*r*s + 4554*D1*Dd*K*f**2*r - 3036*D1*Dd*K*f**2*s**2 + 4554*D1*Dd*K*f**2*s - 2277*D1*Dd*K*f**2 + 6336*D1*Dd*K*f*fd*r**2 + 12672*D1*Dd*K*f*fd*r*s - 7920*D1*Dd*K*f*fd*r + 6336*D1*Dd*K*f*fd*s**2 - 7920*D1*Dd*K*f*fd*s + 2376*D1*Dd*K*f*fd - 2756*D1*Dd*f**3*r**2 - 5512*D1*Dd*f**3*r*s + 4134*D1*Dd*f**3*r - 2756*D1*Dd*f**3*s**2 + 4134*D1*Dd*f**3*s - 2067*D1*Dd*f**3 + 15000*D1*Dd*f**2*fd*r**2 + 30000*D1*Dd*f**2*fd*r*s - 21250*D1*Dd*f**2*fd*r + 15000*D1*Dd*f**2*fd*s**2 - 21250*D1*Dd*f**2*fd*s + 7500*D1*Dd*f**2*fd + 264*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 396*D1*Dd*f**2*r + 264*D1*Dd*f**2*s**2 - 396*D1*Dd*f**2*s + 198*D1*Dd*f**2 - 4752*D1*Dd*f*fd*r**2 - 9504*D1*Dd*f*fd*r*s + 5940*D1*Dd*f*fd*r - 4752*D1*Dd*f*fd*s**2 + 5940*D1*Dd*f*fd*s - 1782*D1*Dd*f*fd + 8184*D1*Dd*f*g2*r**2 + 16368*D1*Dd*f*g2*r*s - 12276*D1*Dd*f*g2*r + 8184*D1*Dd*f*g2*s**2 - 12276*D1*Dd*f*g2*s + 6138*D1*Dd*f*g2 - 6336*D1*Dd*f*gd2*r**2 - 12672*D1*Dd*f*gd2*r*s + 11088*D1*Dd*f*gd2*r - 6336*D1*Dd*f*gd2*s**2 + 11088*D1*Dd*f*gd2*s - 4752*D1*Dd*f*gd2 - 6336*D1*Dd*fd*g2*r**2 - 12672*D1*Dd*fd*g2*r*s + 4752*D1*Dd*fd*g2*r - 6336*D1*Dd*fd*g2*s**2 + 4752*D1*Dd*fd*g2*s + 1584*D1*Ddd*K*f**2*r**2 + 3168*D1*Ddd*K*f**2*r*s - 2376*D1*Ddd*K*f**2*r + 1584*D1*Ddd*K*f**2*s**2 - 2376*D1*Ddd*K*f**2*s + 1188*D1*Ddd*K*f**2 + 2500*D1*Ddd*f**3*r**2 + 5000*D1*Ddd*f**3*r*s - 3750*D1*Ddd*f**3*r + 2500*D1*Ddd*f**3*s**2 - 3750*D1*Ddd*f**3*s + 1875*D1*Ddd*f**3 - 1188*D1*Ddd*f**2*r**2 - 2376*D1*Ddd*f**2*r*s + 1782*D1*Ddd*f**2*r - 1188*D1*Ddd*f**2*s**2 + 1782*D1*Ddd*f**2*s - 891*D1*Ddd*f**2 - 3168*D1*Ddd*f*g2*r**2 - 6336*D1*Ddd*f*g2*r*s + 4752*D1*Ddd*f*g2*r - 3168*D1*Ddd*f*g2*s**2 + 4752*D1*Ddd*f*g2*s - 2376*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(44*f**2*(r + s - 1) - 50*f*fd*(2*r + 2*s - 1) - f*(31*K - 25)*(r + s - 1) + 6*fd*(4*K - 3)*(r + s)) - 2*Dd*f*(-12*K + 25*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 4752*Dd**2*K*f**2*r**2 + 9504*Dd**2*K*f**2*r*s - 7128*Dd**2*K*f**2*r + 4752*Dd**2*K*f**2*s**2 - 7128*Dd**2*K*f**2*s + 2376*Dd**2*K*f**2 + 7500*Dd**2*f**3*r**2 + 15000*Dd**2*f**3*r*s - 11250*Dd**2*f**3*r + 7500*Dd**2*f**3*s**2 - 11250*Dd**2*f**3*s + 3750*Dd**2*f**3 - 3564*Dd**2*f**2*r**2 - 7128*Dd**2*f**2*r*s + 5346*Dd**2*f**2*r - 3564*Dd**2*f**2*s**2 + 5346*Dd**2*f**2*s - 1782*Dd**2*f**2 - 9504*Dd**2*f*g2*r**2 - 19008*Dd**2*f*g2*r*s + 14256*Dd**2*f*g2*r - 9504*Dd**2*f*g2*s**2 + 14256*Dd**2*f*g2*s - 4752*Dd**2*f*g2))/(3003*d**2*k3**8) - 4*D1**2*Pk1*Pk3*ct**3*k1*k2**3*st**2*(66*b1**2*(D1**2*(fd*(50*C - 44) + fdd*(15 - 18*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(25*C - 22)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(15 - 18*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(15 - 18*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(108*C - 90)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-940*C*D1**2*f*fd*r**2 - 1800*C*D1**2*f*fd*r*s + 764*C*D1**2*f*fd*r - 860*C*D1**2*f*fd*s**2 + 724*C*D1**2*f*fd*s - 362*C*D1**2*f*fd + 660*C*D1**2*f*fdd*r**2 + 1320*C*D1**2*f*fdd*r*s - 588*C*D1**2*f*fdd*r + 660*C*D1**2*f*fdd*s**2 - 588*C*D1**2*f*fdd*s + 294*C*D1**2*f*fdd + 660*C*D1**2*fd**2*r**2 + 1320*C*D1**2*fd**2*r*s - 588*C*D1**2*fd**2*r + 660*C*D1**2*fd**2*s**2 - 588*C*D1**2*fd**2*s - 72*C*D1**2*fd**2 - 1880*C*D1*Dd*f**2*r**2 - 3600*C*D1*Dd*f**2*r*s + 2740*C*D1*Dd*f**2*r - 1720*C*D1*Dd*f**2*s**2 + 2620*C*D1*Dd*f**2*s - 1330*C*D1*Dd*f**2 + 5280*C*D1*Dd*f*fd*r**2 + 10560*C*D1*Dd*f*fd*r*s - 6312*C*D1*Dd*f*fd*r + 5280*C*D1*Dd*f*fd*s**2 - 6312*C*D1*Dd*f*fd*s + 1764*C*D1*Dd*f*fd + 1320*C*D1*Ddd*f**2*r**2 + 2640*C*D1*Ddd*f**2*r*s - 1980*C*D1*Ddd*f**2*r + 1320*C*D1*Ddd*f**2*s**2 - 1980*C*D1*Ddd*f**2*s + 990*C*D1*Ddd*f**2 + 3960*C*Dd**2*f**2*r**2 + 7920*C*Dd**2*f**2*r*s - 5940*C*Dd**2*f**2*r + 3960*C*Dd**2*f**2*s**2 - 5940*C*Dd**2*f**2*s + 1980*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(6*C - 5)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 754*D1**2*f*fd*r**2 + 1516*D1**2*f*fd*r*s - 646*D1**2*f*fd*r + 762*D1**2*f*fd*s**2 - 650*D1**2*f*fd*s + 325*D1**2*f*fd - 534*D1**2*f*fdd*r**2 - 1124*D1**2*f*fdd*r*s + 502*D1**2*f*fdd*r - 590*D1**2*f*fdd*s**2 + 530*D1**2*f*fdd*s - 265*D1**2*f*fdd - 534*D1**2*fd**2*r**2 - 1124*D1**2*fd**2*r*s + 502*D1**2*fd**2*r - 590*D1**2*fd**2*s**2 + 530*D1**2*fd**2*s + 60*D1**2*fd**2 + 1508*D1*Dd*f**2*r**2 + 3032*D1*Dd*f**2*r*s - 2270*D1*Dd*f**2*r + 1524*D1*Dd*f**2*s**2 - 2282*D1*Dd*f**2*s + 1139*D1*Dd*f**2 - 4272*D1*Dd*f*fd*r**2 - 8992*D1*Dd*f*fd*r*s + 5324*D1*Dd*f*fd*r - 4720*D1*Dd*f*fd*s**2 + 5604*D1*Dd*f*fd*s - 1562*D1*Dd*f*fd - 1068*D1*Ddd*f**2*r**2 - 2248*D1*Ddd*f**2*r*s + 1658*D1*Ddd*f**2*r - 1180*D1*Ddd*f**2*s**2 + 1742*D1*Ddd*f**2*s - 857*D1*Ddd*f**2 + 4*D1*bd1*(D1*(f*(25*C - 22)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(15 - 18*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(15 - 18*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 3204*Dd**2*f**2*r**2 - 6744*Dd**2*f**2*r*s + 4974*Dd**2*f**2*r - 3540*Dd**2*f**2*s**2 + 5226*Dd**2*f**2*s - 1714*Dd**2*f**2) + f*(-43446*C*D1**2*f*fd*r**2 - 83532*C*D1**2*f*fd*r*s + 56808*C*D1**2*f*fd*r - 40086*C*D1**2*f*fd*s**2 + 54568*C*D1**2*f*fd*s - 27844*C*D1**2*f*fd + 34890*C*D1**2*f*fdd*r**2 + 66516*C*D1**2*f*fdd*r*s - 45432*C*D1**2*f*fdd*r + 31626*C*D1**2*f*fdd*s**2 - 43256*C*D1**2*f*fdd*s + 22172*C*D1**2*f*fdd + 69780*C*D1**2*fd**2*r**2 + 133032*C*D1**2*fd**2*r*s - 90864*C*D1**2*fd**2*r + 63252*C*D1**2*fd**2*s**2 - 86512*C*D1**2*fd**2*s + 22172*C*D1**2*fd**2 - 57928*C*D1*Dd*f**2*r**2 - 111376*C*D1*Dd*f**2*r*s + 84652*C*D1*Dd*f**2*r - 53448*C*D1*Dd*f**2*s**2 + 81292*C*D1*Dd*f**2*s - 41206*C*D1*Dd*f**2 + 279120*C*D1*Dd*f*fd*r**2 + 532128*C*D1*Dd*f*fd*r*s - 384540*C*D1*Dd*f*fd*r + 253008*C*D1*Dd*f*fd*s**2 - 366044*C*D1*Dd*f*fd*s + 131944*C*D1*Dd*f*fd + 46520*C*D1*Ddd*f**2*r**2 + 88688*C*D1*Ddd*f**2*r*s - 67604*C*D1*Ddd*f**2*r + 42168*C*D1*Ddd*f**2*s**2 - 64340*C*D1*Ddd*f**2*s + 32714*C*D1*Ddd*f**2 + 139560*C*Dd**2*f**2*r**2 + 266064*C*Dd**2*f**2*r*s - 202812*C*Dd**2*f**2*r + 126504*C*Dd**2*f**2*s**2 - 193020*C*Dd**2*f**2*s + 65428*C*Dd**2*f**2 - 396*D1**2*bd1**2*(6*C - 5)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(6*C*(55*r**2 + 2*r*(55*s - 61) + 55*s**2 - 122*s + 61) - 267*r**2 - 562*r*s + 594*r - 295*s**2 + 622*s - 297) + 34935*D1**2*f*fd*r**2 + 69654*D1**2*f*fd*r*s - 46508*D1**2*f*fd*r + 34719*D1**2*f*fd*s**2 - 46364*D1**2*f*fd*s + 23218*D1**2*f*fd - 28011*D1**2*f*fdd*r**2 - 55914*D1**2*f*fdd*r*s + 37312*D1**2*f*fdd*r - 27903*D1**2*f*fdd*s**2 + 37240*D1**2*f*fdd*s - 18638*D1**2*f*fdd - 56022*D1**2*fd**2*r**2 - 111828*D1**2*fd**2*r*s + 74624*D1**2*fd**2*r - 55806*D1**2*fd**2*s**2 + 74480*D1**2*fd**2*s - 18638*D1**2*fd**2 + 46580*D1*Dd*f**2*r**2 + 92872*D1*Dd*f**2*r*s - 69726*D1*Dd*f**2*r + 46292*D1*Dd*f**2*s**2 - 69510*D1*Dd*f**2*s + 34791*D1*Dd*f**2 - 224088*D1*Dd*f*fd*r**2 - 447312*D1*Dd*f*fd*r*s + 317098*D1*Dd*f*fd*r - 223224*D1*Dd*f*fd*s**2 + 316486*D1*Dd*f*fd*s - 111792*D1*Dd*f*fd - 37348*D1*Ddd*f**2*r**2 - 74552*D1*Ddd*f**2*r*s + 55950*D1*Ddd*f**2*r - 37204*D1*Ddd*f**2*s**2 + 55842*D1*Ddd*f**2*s - 27939*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(2*C*(235*r**2 + 450*r*s - 538*r + 215*s**2 - 518*s + 269) - 377*r**2 - 758*r*s + 866*r - 381*s**2 + 870*s - 433) - 2*fd*(6*C*(110*r**2 + 220*r*s - 171*r + 110*s**2 - 171*s + 61) - 534*r**2 - 1124*r*s + 845*r - 590*s**2 + 887*s - 311)) + 2*Dd*f*(-6*C*(220*r**2 + 440*r*s - 409*r + 220*s**2 - 409*s + 183) + 1068*r**2 + 2248*r*s - 2017*r + 1180*s**2 - 2115*s + 919)) - 112044*Dd**2*f**2*r**2 - 223656*Dd**2*f**2*r*s + 167850*Dd**2*f**2*r - 111612*Dd**2*f**2*s**2 + 167526*Dd**2*f**2*s - 55878*Dd**2*f**2))/(693*d**2*k3**6) + 4*D1**2*Pk1*Pk3*ct**3*k1*k2**3*(-205920*C*D1**2*f**2*fd*r**2 - 257400*C*D1**2*f**2*fd*r*s + 223080*C*D1**2*f**2*fd*r - 51480*C*D1**2*f**2*fd*s**2 + 120120*C*D1**2*f**2*fd*s - 85800*C*D1**2*f**2*fd - 274560*C*D1*Dd*f**3*r**2 - 343200*C*D1*Dd*f**3*r*s + 308880*C*D1*Dd*f**3*r - 68640*C*D1*Dd*f**3*s**2 + 154440*C*D1*Dd*f**3*s - 102960*C*D1*Dd*f**3 - 120120*D1**2*K*bdd1*f**2*r**2 - 223080*D1**2*K*bdd1*f**2*r*s + 223080*D1**2*K*bdd1*f**2*r - 102960*D1**2*K*bdd1*f**2*s**2 + 205920*D1**2*K*bdd1*f**2*s - 102960*D1**2*K*bdd1*f**2 + 858*D1**2*bd1**2*(r + s - 1)*(-4*K*f*(59*r + 59*s - 71) + 6*f**2*(31*r + 39*s - 35) + 3*f*(59*r + 75*s - 79) - 112*g2*(r + s)) + 24024*D1**2*bd2*f**2*r**2 + 48048*D1**2*bd2*f**2*r*s - 48048*D1**2*bd2*f**2*r + 24024*D1**2*bd2*f**2*s**2 - 48048*D1**2*bd2*f**2*s + 24024*D1**2*bd2*f**2 - 68640*D1**2*bd2*f*fd*r**2 - 137280*D1**2*bd2*f*fd*r*s + 102960*D1**2*bd2*f*fd*r - 68640*D1**2*bd2*f*fd*s**2 + 102960*D1**2*bd2*f*fd*s - 34320*D1**2*bd2*f*fd + 52520*D1**2*bdd1*f**3*r**2 + 50960*D1**2*bdd1*f**3*r*s - 92560*D1**2*bdd1*f**3*r - 1560*D1**2*bdd1*f**3*s**2 - 38480*D1**2*bdd1*f**3*s + 50960*D1**2*bdd1*f**3 + 87516*D1**2*bdd1*f**2*r**2 + 181896*D1**2*bdd1*f**2*r*s - 181896*D1**2*bdd1*f**2*r + 94380*D1**2*bdd1*f**2*s**2 - 188760*D1**2*bdd1*f**2*s + 94380*D1**2*bdd1*f**2 + 202488*D1**2*bdd1*f*g2*r**2 + 404976*D1**2*bdd1*f*g2*r*s - 487344*D1**2*bdd1*f*g2*r + 202488*D1**2*bdd1*f*g2*s**2 - 487344*D1**2*bdd1*f*g2*s + 243672*D1**2*bdd1*f*g2 - 17160*D1**2*bdd2*f**2*r**2 - 34320*D1**2*bdd2*f**2*r*s + 34320*D1**2*bdd2*f**2*r - 17160*D1**2*bdd2*f**2*s**2 + 34320*D1**2*bdd2*f**2*s - 17160*D1**2*bdd2*f**2 + 113680*D1**2*f**3*fd*r**2 + 397600*D1**2*f**3*fd*r*s - 255640*D1**2*f**3*fd*r + 283920*D1**2*f**3*fd*s**2 - 383320*D1**2*f**3*fd*s + 170380*D1**2*f**3*fd - 126000*D1**2*f**3*fdd*r**2 - 453600*D1**2*f**3*fdd*r*s + 289800*D1**2*f**3*fdd*r - 327600*D1**2*f**3*fdd*s**2 + 441000*D1**2*f**3*fdd*s - 195300*D1**2*f**3*fdd - 378000*D1**2*f**2*fd**2*r**2 - 1360800*D1**2*f**2*fd**2*r*s + 869400*D1**2*f**2*fd**2*r - 982800*D1**2*f**2*fd**2*s**2 + 1323000*D1**2*f**2*fd**2*s - 390600*D1**2*f**2*fd**2 + 167310*D1**2*f**2*fd*r**2 + 205920*D1**2*f**2*fd*r*s - 180180*D1**2*f**2*fd*r + 38610*D1**2*f**2*fd*s**2 - 94380*D1**2*f**2*fd*s + 68640*D1**2*f**2*fd - 295152*D1**2*f**2*gd2*r**2 - 459888*D1**2*f**2*gd2*r*s + 459888*D1**2*f**2*gd2*r - 164736*D1**2*f**2*gd2*s**2 + 329472*D1**2*f**2*gd2*s - 164736*D1**2*f**2*gd2 + 240240*D1**2*f**2*gdd2*r**2 + 446160*D1**2*f**2*gdd2*r*s - 446160*D1**2*f**2*gdd2*r + 205920*D1**2*f**2*gdd2*s**2 - 411840*D1**2*f**2*gdd2*s + 205920*D1**2*f**2*gdd2 - 590304*D1**2*f*fd*g2*r**2 - 919776*D1**2*f*fd*g2*r*s + 590304*D1**2*f*fd*g2*r - 329472*D1**2*f*fd*g2*s**2 + 459888*D1**2*f*fd*g2*s - 295152*D1**2*f*fd*g2 + 960960*D1**2*f*fd*gd2*r**2 + 1784640*D1**2*f*fd*gd2*r*s - 1372800*D1**2*f*fd*gd2*r + 823680*D1**2*f*fd*gd2*s**2 - 1269840*D1**2*f*fd*gd2*s + 446160*D1**2*f*fd*gd2 + 480480*D1**2*f*fdd*g2*r**2 + 892320*D1**2*f*fdd*g2*r*s - 480480*D1**2*f*fdd*g2*r + 411840*D1**2*f*fdd*g2*s**2 - 446160*D1**2*f*fdd*g2*s + 240240*D1**2*f*fdd*g2 + 480480*D1**2*fd**2*g2*r**2 + 892320*D1**2*fd**2*g2*r*s - 480480*D1**2*fd**2*g2*r + 411840*D1**2*fd**2*g2*s**2 - 446160*D1**2*fd**2*g2*s - 137280*D1*Dd*bd2*f**2*r**2 - 274560*D1*Dd*bd2*f**2*r*s + 240240*D1*Dd*bd2*f**2*r - 137280*D1*Dd*bd2*f**2*s**2 + 240240*D1*Dd*bd2*f**2*s - 102960*D1*Dd*bd2*f**2 + 113680*D1*Dd*f**4*r**2 + 397600*D1*Dd*f**4*r*s - 255640*D1*Dd*f**4*r + 283920*D1*Dd*f**4*s**2 - 383320*D1*Dd*f**4*s + 170380*D1*Dd*f**4 - 1008000*D1*Dd*f**3*fd*r**2 - 3628800*D1*Dd*f**3*fd*r*s + 2318400*D1*Dd*f**3*fd*r - 2620800*D1*Dd*f**3*fd*s**2 + 3528000*D1*Dd*f**3*fd*s - 1171800*D1*Dd*f**3*fd + 223080*D1*Dd*f**3*r**2 + 274560*D1*Dd*f**3*r*s - 248820*D1*Dd*f**3*r + 51480*D1*Dd*f**3*s**2 - 120120*D1*Dd*f**3*s + 81510*D1*Dd*f**3 - 1180608*D1*Dd*f**2*g2*r**2 - 1839552*D1*Dd*f**2*g2*r*s + 1510080*D1*Dd*f**2*g2*r - 658944*D1*Dd*f**2*g2*s**2 + 1118832*D1*Dd*f**2*g2*s - 624624*D1*Dd*f**2*g2 + 1921920*D1*Dd*f**2*gd2*r**2 + 3569280*D1*Dd*f**2*gd2*r*s - 3157440*D1*Dd*f**2*gd2*r + 1647360*D1*Dd*f**2*gd2*s**2 - 2917200*D1*Dd*f**2*gd2*s + 1269840*D1*Dd*f**2*gd2 + 3843840*D1*Dd*f*fd*g2*r**2 + 7138560*D1*Dd*f*fd*g2*r*s - 4667520*D1*Dd*f*fd*g2*r + 3294720*D1*Dd*f*fd*g2*s**2 - 4324320*D1*Dd*f*fd*g2*s + 1372800*D1*Dd*f*fd*g2 - 126000*D1*Ddd*f**4*r**2 - 453600*D1*Ddd*f**4*r*s + 289800*D1*Ddd*f**4*r - 327600*D1*Ddd*f**4*s**2 + 441000*D1*Ddd*f**4*s - 195300*D1*Ddd*f**4 + 960960*D1*Ddd*f**2*g2*r**2 + 1784640*D1*Ddd*f**2*g2*r*s - 1372800*D1*Ddd*f**2*g2*r + 823680*D1*Ddd*f**2*g2*s**2 - 1269840*D1*Ddd*f**2*g2*s + 652080*D1*Ddd*f**2*g2 - 26*D1*bd1*(1584*D1*bd2*f*(r + s - 1)**2 + D1*(5*f**3*(412*r**2 + r*(388*s - 698) - 24*s**2 - 262*s + 355) + f**2*(792*C*(3*r**2 + r*(3*s - 8) - 5*s + 4) - 132*K*(43*r**2 + 67*r*(s - 1) + 24*(s - 1)**2) - 40*fd*(303*r**2 + r*(294*s - 377) - 9*s**2 - 117*s + 65) + 1881*r**2 + 4686*r*s - 1518*r + 2805*s**2 - 2442*s + 231) + 132*f*(fd*(5*K*(28*r**2 + 52*r*s - 40*r + 24*s**2 - 37*s + 13) - 102*r**2 - 212*r*s + 157*r - 110*s**2 + 163*s - 53) + g2*(62*r**2 + r*(103*s - 158) + 41*s**2 - 137*s + 79) - 2*gd2*(59*r**2 + 2*r*(59*s - 65) + 59*s**2 - 130*s + 71)) - 15576*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 4*Dd*f*(10*f**2*(404*r**2 + r*(392*s - 555) - 12*s**2 - 191*s + 163) - 33*f*(5*K*(56*r**2 + 104*r*s - 92*r + 48*s**2 - 85*s + 37) - 204*r**2 - 424*r*s + 369*r - 220*s**2 + 383*s - 163) + 66*g2*(236*r**2 + r*(472*s - 461) + 236*s**2 - 461*s + 213))) - 378000*Dd**2*f**4*r**2 - 1360800*Dd**2*f**4*r*s + 869400*Dd**2*f**4*r - 982800*Dd**2*f**4*s**2 + 1323000*Dd**2*f**4*s - 390600*Dd**2*f**4 + 2882880*Dd**2*f**2*g2*r**2 + 5353920*Dd**2*f**2*g2*r*s - 4118400*Dd**2*f**2*g2*r + 2471040*Dd**2*f**2*g2*s**2 - 3809520*Dd**2*f**2*g2*s + 1304160*Dd**2*f**2*g2 + 858*b1**3*(2*D1**2*(11*fd - 9*fdd)*(r + s - 1)**2 + D1*(2*Dd*(11*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (28*K - 21)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-28*K + 18*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-28*K + 18*f + 21)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(56*C*D1**2*fd*r**2 + 112*C*D1**2*fd*r*s - 112*C*D1**2*fd*r + 56*C*D1**2*fd*s**2 - 112*C*D1**2*fd*s + 56*C*D1**2*fd + 224*C*D1*Dd*f*r**2 + 448*C*D1*Dd*f*r*s - 336*C*D1*Dd*f*r + 224*C*D1*Dd*f*s**2 - 336*C*D1*Dd*f*s + 168*C*D1*Dd*f + 248*D1**2*K*fd*r**2 + 412*D1**2*K*fd*r*s + 136*D1**2*K*fd*r + 164*D1**2*K*fd*s**2 + 136*D1**2*K*fd*s - 68*D1**2*K*fd - 236*D1**2*K*fdd*r**2 - 472*D1**2*K*fdd*r*s - 96*D1**2*K*fdd*r - 236*D1**2*K*fdd*s**2 - 96*D1**2*K*fdd*s + 48*D1**2*K*fdd - 2*D1**2*bdd1*(-28*K + 18*f + 21)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 276*D1**2*f*fd*r**2 - 648*D1**2*f*fd*r*s + 300*D1**2*f*fd*r - 372*D1**2*f*fd*s**2 + 348*D1**2*f*fd*s - 174*D1**2*f*fd + 372*D1**2*f*fdd*r**2 + 840*D1**2*f*fdd*r*s - 420*D1**2*f*fdd*r + 468*D1**2*f*fdd*s**2 - 468*D1**2*f*fdd*s + 234*D1**2*f*fdd + 372*D1**2*fd**2*r**2 + 840*D1**2*fd**2*r*s - 420*D1**2*fd**2*r + 468*D1**2*fd**2*s**2 - 468*D1**2*fd**2*s - 221*D1**2*fd*r**2 - 426*D1**2*fd*r*s - 4*D1**2*fd*r - 205*D1**2*fd*s**2 - 4*D1**2*fd*s + 2*D1**2*fd + 177*D1**2*fdd*r**2 + 402*D1**2*fdd*r*s + 72*D1**2*fdd*r + 225*D1**2*fdd*s**2 + 72*D1**2*fdd*s - 36*D1**2*fdd + 224*D1**2*gd2*r**2 + 448*D1**2*gd2*r*s - 448*D1**2*gd2*r + 224*D1**2*gd2*s**2 - 448*D1**2*gd2*s + 224*D1**2*gd2 - 112*D1**2*gdd2*r**2 - 224*D1**2*gdd2*r*s + 224*D1**2*gdd2*r - 112*D1**2*gdd2*s**2 + 224*D1**2*gdd2*s - 112*D1**2*gdd2 + 992*D1*Dd*K*f*r**2 + 1648*D1*Dd*K*f*r*s - 1320*D1*Dd*K*f*r + 656*D1*Dd*K*f*s**2 - 1068*D1*Dd*K*f*s + 576*D1*Dd*K*f - 1888*D1*Dd*K*fd*r**2 - 3776*D1*Dd*K*fd*r*s + 1032*D1*Dd*K*fd*r - 1888*D1*Dd*K*fd*s**2 + 1032*D1*Dd*K*fd*s + 288*D1*Dd*K*fd - 552*D1*Dd*f**2*r**2 - 1296*D1*Dd*f**2*r*s + 924*D1*Dd*f**2*r - 744*D1*Dd*f**2*s**2 + 1068*D1*Dd*f**2*s - 510*D1*Dd*f**2 + 2976*D1*Dd*f*fd*r**2 + 6720*D1*Dd*f*fd*r*s - 4104*D1*Dd*f*fd*r + 3744*D1*Dd*f*fd*s**2 - 4584*D1*Dd*f*fd*s + 1356*D1*Dd*f*fd - 884*D1*Dd*f*r**2 - 1704*D1*Dd*f*r*s + 1294*D1*Dd*f*r - 820*D1*Dd*f*s**2 + 1246*D1*Dd*f*s - 631*D1*Dd*f + 1416*D1*Dd*fd*r**2 + 3216*D1*Dd*fd*r*s - 870*D1*Dd*fd*r + 1800*D1*Dd*fd*s**2 - 1014*D1*Dd*fd*s - 216*D1*Dd*fd + 896*D1*Dd*g2*r**2 + 1792*D1*Dd*g2*r*s - 1344*D1*Dd*g2*r + 896*D1*Dd*g2*s**2 - 1344*D1*Dd*g2*s + 672*D1*Dd*g2 - 896*D1*Dd*gd2*r**2 - 1792*D1*Dd*gd2*r*s + 1568*D1*Dd*gd2*r - 896*D1*Dd*gd2*s**2 + 1568*D1*Dd*gd2*s - 672*D1*Dd*gd2 - 944*D1*Ddd*K*f*r**2 - 1888*D1*Ddd*K*f*r*s + 1416*D1*Ddd*K*f*r - 944*D1*Ddd*K*f*s**2 + 1416*D1*Ddd*K*f*s - 708*D1*Ddd*K*f + 744*D1*Ddd*f**2*r**2 + 1680*D1*Ddd*f**2*r*s - 1212*D1*Ddd*f**2*r + 936*D1*Ddd*f**2*s**2 - 1356*D1*Ddd*f**2*s + 654*D1*Ddd*f**2 + 708*D1*Ddd*f*r**2 + 1608*D1*Ddd*f*r*s - 1158*D1*Ddd*f*r + 900*D1*Ddd*f*s**2 - 1302*D1*Ddd*f*s + 627*D1*Ddd*f - 448*D1*Ddd*g2*r**2 - 896*D1*Ddd*g2*r*s + 672*D1*Ddd*g2*r - 448*D1*Ddd*g2*s**2 + 672*D1*Ddd*g2*s - 336*D1*Ddd*g2 + 4*D1*bd1*(D1*(11*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (28*K - 21)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-28*K + 18*f + 21)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 2832*Dd**2*K*f*r**2 - 5664*Dd**2*K*f*r*s + 4248*Dd**2*K*f*r - 2832*Dd**2*K*f*s**2 + 4248*Dd**2*K*f*s - 1416*Dd**2*K*f + 2232*Dd**2*f**2*r**2 + 5040*Dd**2*f**2*r*s - 3636*Dd**2*f**2*r + 2808*Dd**2*f**2*s**2 - 4068*Dd**2*f**2*s + 1308*Dd**2*f**2 + 2124*Dd**2*f*r**2 + 4824*Dd**2*f*r*s - 3474*Dd**2*f*r + 2700*Dd**2*f*s**2 - 3906*Dd**2*f*s + 1254*Dd**2*f - 1344*Dd**2*g2*r**2 - 2688*Dd**2*g2*r*s + 2016*Dd**2*g2*r - 1344*Dd**2*g2*s**2 + 2016*Dd**2*g2*s - 672*Dd**2*g2) - 26*b1*(4752*C*D1**2*f*fd*r**2 + 4752*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 1584*C*D1**2*f*fd*s - 792*C*D1**2*f*fd + 9504*C*D1*Dd*f**2*r**2 + 9504*C*D1*Dd*f**2*r*s - 9504*C*D1*Dd*f**2*r - 2376*C*D1*Dd*f**2*s + 2376*C*D1*Dd*f**2 + 7788*D1**2*K*bdd1*f*r**2 + 15576*D1**2*K*bdd1*f*r*s - 17160*D1**2*K*bdd1*f*r + 7788*D1**2*K*bdd1*f*s**2 - 17160*D1**2*K*bdd1*f*s + 8580*D1**2*K*bdd1*f - 11352*D1**2*K*f*fd*r**2 - 17688*D1**2*K*f*fd*r*s + 11352*D1**2*K*f*fd*r - 6336*D1**2*K*f*fd*s**2 + 8844*D1**2*K*f*fd*s - 5676*D1**2*K*f*fd + 9240*D1**2*K*f*fdd*r**2 + 17160*D1**2*K*f*fdd*r*s - 9240*D1**2*K*f*fdd*r + 7920*D1**2*K*f*fdd*s**2 - 8580*D1**2*K*f*fdd*s + 4620*D1**2*K*f*fdd + 9240*D1**2*K*fd**2*r**2 + 17160*D1**2*K*fd**2*r*s - 9240*D1**2*K*fd**2*r + 7920*D1**2*K*fd**2*s**2 - 8580*D1**2*K*fd**2*s - 1122*D1**2*b2*fd*r**2 - 2244*D1**2*b2*fd*r*s - 1122*D1**2*b2*fd*s**2 + 792*D1**2*b2*fdd*r**2 + 1584*D1**2*b2*fdd*r*s + 792*D1**2*b2*fdd*s**2 + 66*D1**2*bd1**2*(-28*K + 18*f + 21)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 6138*D1**2*bdd1*f**2*r**2 - 13860*D1**2*bdd1*f**2*r*s + 13068*D1**2*bdd1*f**2*r - 7722*D1**2*bdd1*f**2*s**2 + 14652*D1**2*bdd1*f**2*s - 6930*D1**2*bdd1*f**2 - 5841*D1**2*bdd1*f*r**2 - 13266*D1**2*bdd1*f*r*s + 13662*D1**2*bdd1*f*r - 7425*D1**2*bdd1*f*s**2 + 15246*D1**2*bdd1*f*s - 7227*D1**2*bdd1*f + 3696*D1**2*bdd1*g2*r**2 + 7392*D1**2*bdd1*g2*r*s - 3696*D1**2*bdd1*g2*r + 3696*D1**2*bdd1*g2*s**2 - 3696*D1**2*bdd1*g2*s + 1848*D1**2*bdd1*g2 + 792*D1**2*bdd2*f*r**2 + 1584*D1**2*bdd2*f*r*s - 1584*D1**2*bdd2*f*r + 792*D1**2*bdd2*f*s**2 - 1584*D1**2*bdd2*f*s + 792*D1**2*bdd2*f + 6180*D1**2*f**2*fd*r**2 + 5820*D1**2*f**2*fd*r*s - 4510*D1**2*f**2*fd*r - 360*D1**2*f**2*fd*s**2 - 150*D1**2*f**2*fd*s + 45*D1**2*f**2*fd - 6060*D1**2*f**2*fdd*r**2 - 5880*D1**2*f**2*fdd*r*s + 4400*D1**2*f**2*fdd*r + 180*D1**2*f**2*fdd*s**2 + 240*D1**2*f**2*fdd*s + 60*D1**2*f**2*fdd - 12120*D1**2*f*fd**2*r**2 - 11760*D1**2*f*fd**2*r*s + 8800*D1**2*f*fd**2*r + 360*D1**2*f*fd**2*s**2 + 480*D1**2*f*fd**2*s - 1200*D1**2*f*fd**2 + 3762*D1**2*f*fd*r**2 + 9372*D1**2*f*fd*r*s - 6930*D1**2*f*fd*r + 5610*D1**2*f*fd*s**2 - 7854*D1**2*f*fd*s + 4455*D1**2*f*fd - 6732*D1**2*f*fdd*r**2 - 13992*D1**2*f*fdd*r*s + 6732*D1**2*f*fdd*r - 7260*D1**2*f*fdd*s**2 + 6996*D1**2*f*fdd*s - 3366*D1**2*f*fdd + 8184*D1**2*f*gd2*r**2 + 13596*D1**2*f*gd2*r*s - 13596*D1**2*f*gd2*r + 5412*D1**2*f*gd2*s**2 - 10824*D1**2*f*gd2*s + 5412*D1**2*f*gd2 - 7788*D1**2*f*gdd2*r**2 - 15576*D1**2*f*gdd2*r*s + 15576*D1**2*f*gdd2*r - 7788*D1**2*f*gdd2*s**2 + 15576*D1**2*f*gdd2*s - 7788*D1**2*f*gdd2 - 6732*D1**2*fd**2*r**2 - 13992*D1**2*fd**2*r*s + 6732*D1**2*fd**2*r - 7260*D1**2*fd**2*s**2 + 6996*D1**2*fd**2*s + 8184*D1**2*fd*g2*r**2 + 13596*D1**2*fd*g2*r*s + 4488*D1**2*fd*g2*r + 5412*D1**2*fd*g2*s**2 + 4488*D1**2*fd*g2*s - 2244*D1**2*fd*g2 - 15576*D1**2*fd*gd2*r**2 - 31152*D1**2*fd*gd2*r*s + 12408*D1**2*fd*gd2*r - 15576*D1**2*fd*gd2*s**2 + 12408*D1**2*fd*gd2*s + 3168*D1**2*fd*gd2 - 7788*D1**2*fdd*g2*r**2 - 15576*D1**2*fdd*g2*r*s - 3168*D1**2*fdd*g2*r - 7788*D1**2*fdd*g2*s**2 - 3168*D1**2*fdd*g2*s + 1584*D1**2*fdd*g2 - 22704*D1*Dd*K*f**2*r**2 - 35376*D1*Dd*K*f**2*r*s + 29040*D1*Dd*K*f**2*r - 12672*D1*Dd*K*f**2*s**2 + 21516*D1*Dd*K*f**2*s - 12012*D1*Dd*K*f**2 + 73920*D1*Dd*K*f*fd*r**2 + 137280*D1*Dd*K*f*fd*r*s - 89760*D1*Dd*K*f*fd*r + 63360*D1*Dd*K*f*fd*s**2 - 83160*D1*Dd*K*f*fd*s + 26400*D1*Dd*K*f*fd - 4488*D1*Dd*b2*f*r**2 - 8976*D1*Dd*b2*f*r*s + 6732*D1*Dd*b2*f*r - 4488*D1*Dd*b2*f*s**2 + 6732*D1*Dd*b2*f*s - 3366*D1*Dd*b2*f + 6336*D1*Dd*b2*fd*r**2 + 12672*D1*Dd*b2*fd*r*s - 4752*D1*Dd*b2*fd*r + 6336*D1*Dd*b2*fd*s**2 - 4752*D1*Dd*b2*fd*s + 8240*D1*Dd*f**3*r**2 + 7760*D1*Dd*f**3*r*s - 8000*D1*Dd*f**3*r - 480*D1*Dd*f**3*s**2 - 1460*D1*Dd*f**3*s + 1820*D1*Dd*f**3 - 48480*D1*Dd*f**2*fd*r**2 - 47040*D1*Dd*f**2*fd*r*s + 41480*D1*Dd*f**2*fd*r + 1440*D1*Dd*f**2*fd*s**2 + 6120*D1*Dd*f**2*fd*s - 4880*D1*Dd*f**2*fd + 7524*D1*Dd*f**2*r**2 + 18744*D1*Dd*f**2*r*s - 13134*D1*Dd*f**2*r + 11220*D1*Dd*f**2*s**2 - 15906*D1*Dd*f**2*s + 7491*D1*Dd*f**2 - 53856*D1*Dd*f*fd*r**2 - 111936*D1*Dd*f*fd*r*s + 68376*D1*Dd*f*fd*r - 58080*D1*Dd*f*fd*s**2 + 71016*D1*Dd*f*fd*s - 20724*D1*Dd*f*fd + 32736*D1*Dd*f*g2*r**2 + 54384*D1*Dd*f*g2*r*s - 43560*D1*Dd*f*g2*r + 21648*D1*Dd*f*g2*s**2 - 35244*D1*Dd*f*g2*s + 19008*D1*Dd*f*g2 - 62304*D1*Dd*f*gd2*r**2 - 124608*D1*Dd*f*gd2*r*s + 109032*D1*Dd*f*gd2*r - 62304*D1*Dd*f*gd2*s**2 + 109032*D1*Dd*f*gd2*s - 46728*D1*Dd*f*gd2 - 62304*D1*Dd*fd*g2*r**2 - 124608*D1*Dd*fd*g2*r*s + 34056*D1*Dd*fd*g2*r - 62304*D1*Dd*fd*g2*s**2 + 34056*D1*Dd*fd*g2*s + 9504*D1*Dd*fd*g2 + 18480*D1*Ddd*K*f**2*r**2 + 34320*D1*Ddd*K*f**2*r*s - 26400*D1*Ddd*K*f**2*r + 15840*D1*Ddd*K*f**2*s**2 - 24420*D1*Ddd*K*f**2*s + 12540*D1*Ddd*K*f**2 + 3168*D1*Ddd*b2*f*r**2 + 6336*D1*Ddd*b2*f*r*s - 4752*D1*Ddd*b2*f*r + 3168*D1*Ddd*b2*f*s**2 - 4752*D1*Ddd*b2*f*s + 2376*D1*Ddd*b2*f - 8080*D1*Ddd*f**3*r**2 - 7840*D1*Ddd*f**3*r*s + 7960*D1*Ddd*f**3*r + 240*D1*Ddd*f**3*s**2 + 1720*D1*Ddd*f**3*s - 1900*D1*Ddd*f**3 - 13464*D1*Ddd*f**2*r**2 - 27984*D1*Ddd*f**2*r*s + 20724*D1*Ddd*f**2*r - 14520*D1*Ddd*f**2*s**2 + 21516*D1*Ddd*f**2*s - 10626*D1*Ddd*f**2 - 31152*D1*Ddd*f*g2*r**2 - 62304*D1*Ddd*f*g2*r*s + 46728*D1*Ddd*f*g2*r - 31152*D1*Ddd*f*g2*s**2 + 46728*D1*Ddd*f*g2*s - 23364*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(8*K*fd*(59*r**2 + r*(118*s - 53) + 59*s**2 - 53*s - 6) + 6*f**2*(23*r**2 + r*(54*s - 52) + 31*s**2 - 60*s + 28) - f*(28*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 248*K*r**2 + 412*K*r*s - 522*K*r + 164*K*s**2 - 438*K*s + 240*K + 12*fd*(62*r**2 + 140*r*s - 101*r + 78*s**2 - 113*s + 37) - 221*r**2 - 426*r*s + 436*r - 205*s**2 + 420*s - 214) - 6*fd*(59*r**2 + r*(134*s - 57) + 75*s**2 - 65*s - 6) - 112*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 112*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(6*f**2*(124*r**2 + r*(280*s - 233) + 156*s**2 - 261*s + 107) + f*(-4*K*(236*r**2 + r*(472*s - 437) + 236*s**2 - 437*s + 195) + 708*r**2 + 201*r*(8*s - 7) + 900*s**2 - 1575*s + 669) - 56*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 66*D1*bd2*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) + 55440*Dd**2*K*f**2*r**2 + 102960*Dd**2*K*f**2*r*s - 79200*Dd**2*K*f**2*r + 47520*Dd**2*K*f**2*s**2 - 73260*Dd**2*K*f**2*s + 25080*Dd**2*K*f**2 + 9504*Dd**2*b2*f*r**2 + 19008*Dd**2*b2*f*r*s - 14256*Dd**2*b2*f*r + 9504*Dd**2*b2*f*s**2 - 14256*Dd**2*b2*f*s + 4752*Dd**2*b2*f - 24240*Dd**2*f**3*r**2 - 23520*Dd**2*f**3*r*s + 23880*Dd**2*f**3*r + 720*Dd**2*f**3*s**2 + 5160*Dd**2*f**3*s - 3800*Dd**2*f**3 - 40392*Dd**2*f**2*r**2 - 83952*Dd**2*f**2*r*s + 62172*Dd**2*f**2*r - 43560*Dd**2*f**2*s**2 + 64548*Dd**2*f**2*s - 21252*Dd**2*f**2 - 93456*Dd**2*f*g2*r**2 - 186912*Dd**2*f*g2*r*s + 140184*Dd**2*f*g2*r - 93456*Dd**2*f*g2*s**2 + 140184*Dd**2*f*g2*s - 46728*Dd**2*f*g2) + 1716*b2*(-12*D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*(-f*(7*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bd1*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) - 2*D1*f*(Dd*(-7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(9009*d**2*k3**6) - 2*D1**2*Pk1*Pk3*ct**3*k1*k2*st**2*(132*b1**2*(D1**2*(s - 1)*(fd*(37*C - 31) + fdd*(12 - 15*C))*(r + s - 1) + D1*(Dd*(f*(37*C - 31)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(15*C - 12)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(12 - 15*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(15*C - 12)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 33*b1*(D1**2*(f*(-12*bdd1*s*(5*C - 4)*(2*r + 2*s - 1) + fd*(C*(-404*r*(2*s - 1) - 828*s**2 + 712*s - 414) + 300*r*(2*s - 1) + 686*s**2 - 594*s + 343) + fdd*(C*(252*r*(2*s - 1) + 596*s**2 - 536*s + 298) - 188*r*(2*s - 1) - 498*s**2 + 450*s - 249)) + 2*fd**2*(2*C*(63*r*(2*s - 1) + 149*s**2 - 134*s - 15) - 94*r*(2*s - 1) - 249*s**2 + 225*s + 24)) + 4*D1*bd1*(D1*(f*s*(37*C - 31)*(2*r + 2*s - 1) - fd*(15*C - 12)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(24 - 30*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(2*C*(202*r*(2*s - 1) + 414*s**2 - 515*s + 207) - 600*r*s + 300*r - 686*s**2 + 836*s - 343) - 2*fd*(2*s - 1)*(C*(504*r + 596*s - 331) - 376*r - 498*s + 272)) + Ddd*f*(C*(-252*r*(2*s - 1) - 596*s**2 + 722*s - 298) + 188*r*(2*s - 1) + 498*s**2 - 592*s + 249)) + 2*Dd**2*f**2*(2*C*(378*r*(2*s - 1) + 894*s**2 - 1083*s + 275) - 564*r*(2*s - 1) - 1494*s**2 + 1776*s - 437)) + f*(-396*D1**2*bd1**2*s*(5*C - 4)*(2*r + 2*s - 1) + D1**2*(f*(33*bdd1*s*(C*(252*r + 298*s - 312) - 188*r - 249*s + 236) + fd*(-2*C*(6560*r*(3*s - 1) + 21243*s**2 - 20722*s + 7081) + 9876*r*(3*s - 1) + 34713*s**2 - 33018*s + 11571) + fdd*(14*C*(676*r*(3*s - 1) + 2175*s**2 - 2126*s + 725) - 7116*r*(3*s - 1) - 25227*s**2 + 23934*s - 8409)) + 2*fd**2*(14*C*(676*r*(3*s - 1) + 2175*s**2 - 2126*s + 338) - 7116*r*(3*s - 1) - 25227*s**2 + 23934*s - 3558)) - 33*D1*bd1*(D1*(f*s*(C*(404*r + 414*s - 520) - 300*r - 343*s + 392) - 2*fd*(2*C*(63*r*(4*s - 1) + 298*s**2 - 290*s + 78) - 376*r*s + 94*r - 498*s**2 + 461*s - 118)) - 4*Dd*f*(C*(126*r*(4*s - 1) + 596*s**2 - 673*s + 156) - 376*r*s + 94*r - 498*s**2 + 532*s - 118)) - 2*D1*f*(Dd*(-56*C*fd*(169*r*(12*s - 5) + 2175*s**2 - 2404*s + 616) + f*(2*C*(6560*r*(2*s - 1) + 14162*s**2 - 17442*s + 7081) - 9876*r*(2*s - 1) - 23142*s**2 + 28080*s - 11571) + 12*fd*(593*r*(12*s - 5) + 8409*s**2 - 9083*s + 2291)) + Ddd*f*(-14*C*(676*r*(2*s - 1) + 1450*s**2 - 1788*s + 725) + 7116*r*(2*s - 1) + 16818*s**2 - 20376*s + 8409)) + 6*Dd**2*f**2*(14*C*(676*r*(2*s - 1) + 1450*s**2 - 1788*s + 467) - 7116*r*(2*s - 1) - 16818*s**2 + 20376*s - 5175)))/(693*d**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**3*k1*k2*(33*b1**2*(D1**2*(fd*(52*C*r + 332*C*(s - 1) - 29*r - 273*s + 273) + fdd*(-4*C*(31*r + 73*s - 73) + 81*r + 245*s - 245))*(r + s - 1) + D1*(Dd*(f*(4*C*(52*r**2 + 384*r*s - 218*r + 332*s**2 - 428*s + 179) - 116*r**2 - 1208*r*s + 662*r - 1092*s**2 + 1394*s - 575) + 2*fd*(-4*C*(124*r**2 + 416*r*s - 343*r + 292*s**2 - 490*s + 198) + 324*r**2 + 1304*r*s - 1059*r + 980*s**2 - 1633*s + 653)) + Ddd*f*(-4*C*(124*r**2 + 416*r*s - 270*r + 292*s**2 - 396*s + 177) + 324*r**2 + 1304*r*s - 814*r + 980*s**2 - 1306*s + 571)) + 2*Dd**2*f*(-12*C*(62*r**2 + r*(208*s - 135) + 146*s**2 - 198*s + 59) + 486*r**2 + 3*r*(652*s - 407) + 1470*s**2 - 1959*s + 571)) + 33*b1*(-168*C*D1**2*f*fd*r**2 - 1264*C*D1**2*f*fd*r*s + 456*C*D1**2*f*fd*r - 1080*C*D1**2*f*fd*s**2 + 712*C*D1**2*f*fd*s - 452*C*D1**2*f*fd + 280*C*D1**2*f*fdd*r**2 + 1240*C*D1**2*f*fdd*r*s - 364*C*D1**2*f*fdd*r + 1056*C*D1**2*f*fdd*s**2 - 680*C*D1**2*f*fdd*s + 400*C*D1**2*f*fdd + 280*C*D1**2*fd**2*r**2 + 1240*C*D1**2*fd**2*r*s - 364*C*D1**2*fd**2*r + 1056*C*D1**2*fd**2*s**2 - 680*C*D1**2*fd**2*s - 376*C*D1**2*fd**2 - 336*C*D1*Dd*f**2*r**2 - 2528*C*D1*Dd*f**2*r*s + 1432*C*D1*Dd*f**2*r - 2160*C*D1*Dd*f**2*s**2 + 2792*C*D1*Dd*f**2*s - 1164*C*D1*Dd*f**2 + 2240*C*D1*Dd*f*fd*r**2 + 9920*C*D1*Dd*f*fd*r*s - 4496*C*D1*Dd*f*fd*r + 8448*C*D1*Dd*f*fd*s**2 - 8184*C*D1*Dd*f*fd*s + 1724*C*D1*Dd*f*fd + 560*C*D1*Ddd*f**2*r**2 + 2480*C*D1*Ddd*f**2*r*s - 1520*C*D1*Ddd*f**2*r + 2112*C*D1*Ddd*f**2*s**2 - 2732*C*D1*Ddd*f**2*s + 1196*C*D1*Ddd*f**2 + 1680*C*Dd**2*f**2*r**2 + 7440*C*Dd**2*f**2*r*s - 4560*C*Dd**2*f**2*r + 6336*C*Dd**2*f**2*s**2 - 8196*C*Dd**2*f**2*s + 2296*C*Dd**2*f**2 + D1**2*bdd1*f*(-4*C*(62*r**2 + 208*r*s - 62*r + 146*s**2 - 104*s + 31) + 162*r**2 + 652*r*s - 162*r + 490*s**2 - 326*s + 81) + 122*D1**2*f*fd*r**2 + 1044*D1**2*f*fd*r*s - 414*D1**2*f*fd*r + 1012*D1**2*f*fd*s**2 - 728*D1**2*f*fd*s + 452*D1**2*f*fd - 178*D1**2*f*fdd*r**2 - 1028*D1**2*f*fdd*r*s + 346*D1**2*f*fdd*r - 1004*D1**2*f*fdd*s**2 + 712*D1**2*f*fdd*s - 418*D1**2*f*fdd - 178*D1**2*fd**2*r**2 - 1028*D1**2*fd**2*r*s + 346*D1**2*fd**2*r - 1004*D1**2*fd**2*s**2 + 712*D1**2*fd**2*s + 292*D1**2*fd**2 + 244*D1*Dd*f**2*r**2 + 2088*D1*Dd*f**2*r*s - 1166*D1*Dd*f**2*r + 2024*D1*Dd*f**2*s**2 - 2546*D1*Dd*f**2*s + 1073*D1*Dd*f**2 - 1424*D1*Dd*f*fd*r**2 - 8224*D1*Dd*f*fd*r*s + 3796*D1*Dd*f*fd*r - 8032*D1*Dd*f*fd*s**2 + 7892*D1*Dd*f*fd*s - 1770*D1*Dd*f*fd - 356*D1*Ddd*f**2*r**2 - 2056*D1*Ddd*f**2*r*s + 1206*D1*Ddd*f**2*r - 2008*D1*Ddd*f**2*s**2 + 2522*D1*Ddd*f**2*s - 1093*D1*Ddd*f**2 + D1*bd1*(D1*(f*(4*C*(26*r**2 + 192*r*s - 26*r + 166*s**2 - 96*s + 13) - 58*r**2 - 604*r*s + 58*r - 546*s**2 + 302*s - 29) - 2*fd*(4*C*(62*r**2 + 208*r*s - 135*r + 146*s**2 - 198*s + 52) - 162*r**2 - 652*r*s + 407*r - 490*s**2 + 653*s - 163)) + 2*Dd*f*(-4*C*(248*r**2 + 832*r*s - 394*r + 584*s**2 - 604*s + 135) + 648*r**2 + 2608*r*s - 1138*r + 1960*s**2 - 1958*s + 407)) - 1068*Dd**2*f**2*r**2 - 6168*Dd**2*f**2*r*s + 3618*Dd**2*f**2*r - 6024*Dd**2*f**2*s**2 + 7566*Dd**2*f**2*s - 2032*Dd**2*f**2) + f*(-27744*C*D1**2*f*fd*r**2 - 97296*C*D1**2*f*fd*r*s + 50928*C*D1**2*f*fd*r - 68304*C*D1**2*f*fd*s**2 + 77968*C*D1**2*f*fd*s - 32016*C*D1**2*f*fd + 26544*C*D1**2*f*fdd*r**2 + 93396*C*D1**2*f*fdd*r*s - 48828*C*D1**2*f*fdd*r + 64644*C*D1**2*f*fdd*s**2 - 74228*C*D1**2*f*fdd*s + 30396*C*D1**2*f*fdd + 53088*C*D1**2*fd**2*r**2 + 186792*C*D1**2*fd**2*r*s - 97656*C*D1**2*fd**2*r + 129288*C*D1**2*fd**2*s**2 - 148456*C*D1**2*fd**2*s + 31132*C*D1**2*fd**2 - 36992*C*D1*Dd*f**2*r**2 - 129728*C*D1*Dd*f**2*r*s + 83360*C*D1*Dd*f**2*r - 91072*C*D1*Dd*f**2*s**2 + 123504*C*D1*Dd*f**2*s - 54784*C*D1*Dd*f**2 + 212352*C*D1*Dd*f*fd*r**2 + 747168*C*D1*Dd*f*fd*r*s - 435192*C*D1*Dd*f*fd*r + 517152*C*D1*Dd*f*fd*s**2 - 648884*C*D1*Dd*f*fd*s + 197284*C*D1*Dd*f*fd + 35392*C*D1*Ddd*f**2*r**2 + 124528*C*D1*Ddd*f**2*r*s - 79960*C*D1*Ddd*f**2*r + 86192*C*D1*Ddd*f**2*s**2 - 117324*C*D1*Ddd*f**2*s + 51944*C*D1*Ddd*f**2 + 106176*C*Dd**2*f**2*r**2 + 373584*C*Dd**2*f**2*r*s - 239880*C*Dd**2*f**2*r + 258576*C*Dd**2*f**2*s**2 - 351972*C*Dd**2*f**2*s + 105360*C*Dd**2*f**2 - 66*D1**2*bd1**2*(r**2*(124*C - 81) + r*(4*C*(104*s - 31) - 326*s + 81) + s*(4*C*(73*s - 52) - 245*s + 163)) + 33*D1**2*bdd1*f*(4*C*(35*r**2 + 155*r*s - 134*r + 132*s**2 - 249*s + 67) - 89*r**2 - 514*r*s + 346*r - 502*s**2 + 806*s - 173) + 18036*D1**2*f*fd*r**2 + 77472*D1**2*f*fd*r*s - 37848*D1**2*f*fd*r + 61365*D1**2*f*fd*s**2 - 66734*D1**2*f*fd*s + 26467*D1**2*f*fd - 17136*D1**2*f*fdd*r**2 - 74772*D1**2*f*fdd*r*s + 36348*D1**2*f*fdd*r - 59145*D1**2*f*fdd*s**2 + 64354*D1**2*f*fdd*s - 25427*D1**2*f*fdd - 34272*D1**2*fd**2*r**2 - 149544*D1**2*fd**2*r*s + 72696*D1**2*fd**2*r - 118290*D1**2*fd**2*s**2 + 128708*D1**2*fd**2*s - 24924*D1**2*fd**2 + 24048*D1*Dd*f**2*r**2 + 103296*D1*Dd*f**2*r*s - 63672*D1*Dd*f**2*r + 81820*D1*Dd*f**2*s**2 - 107644*D1*Dd*f**2*s + 46922*D1*Dd*f**2 - 137088*D1*Dd*f*fd*r**2 - 598176*D1*Dd*f*fd*r*s + 329208*D1*Dd*f*fd*r - 473160*D1*Dd*f*fd*s**2 + 568768*D1*Dd*f*fd*s - 165056*D1*Dd*f*fd - 22848*D1*Ddd*f**2*r**2 - 99696*D1*Ddd*f**2*r*s + 61272*D1*Ddd*f**2*r - 78860*D1*Ddd*f**2*s**2 + 103784*D1*Ddd*f**2*s - 45142*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(4*C*(21*r**2 + 158*r*s - 86*r + 135*s**2 - 250*s + 43) - 61*r**2 - 522*r*s + 230*r - 506*s**2 + 806*s - 115) + 2*fd*(-2*C*(140*r**2 + 620*r*s - 359*r + 528*s**2 - 668*s + 249) + 178*r**2 + 1028*r*s - 519*r + 1004*s**2 - 1162*s + 403)) + 2*Dd*f*(-2*C*(280*r**2 + 1240*r*s - 916*r + 1056*s**2 - 1679*s + 632) + 356*r**2 + 2056*r*s - 1295*r + 2008*s**2 - 2873*s + 979)) - 68544*Dd**2*f**2*r**2 - 299088*Dd**2*f**2*r*s + 183816*Dd**2*f**2*r - 236580*Dd**2*f**2*s**2 + 311352*Dd**2*f**2*s - 89278*Dd**2*f**2))/(693*d**2*k3**4) - 8*D1**2*Pk1*Pk3*ct**3*k1*st**2*(99*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) - 66*b1*(D1**2*(f*(fd*(8*C - 4)*(2*s**2 - 2*s + 1) - fdd*(4*C - 2)*(2*s**2 - 2*s + 1) + s**2*(4*C - 3)*(-6*bd1 + 3*bdd1)) + 2*fd*s*(s - 1)*(3*bd1*(4*C - 3) + fd*(2 - 4*C))) + 4*D1*f*(Dd*f*(4*C - 2)*(2*s**2 - 2*s + 1) - Dd*(2*s - 1)*(3*bd1*s*(3 - 4*C) + fd*(4*C - 2)*(2*s - 1)) - Ddd*f*(2*C - 1)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(4 - 8*C)*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(-fd*(1000*C - 650)*(3*s**2 - 2*s + 1) + fdd*(500*C - 325)*(3*s**2 - 2*s + 1) + s**2*(2*C - 1)*(-264*bd1 + 132*bdd1)) + 2*s*(-99*bd1**2*s*(4*C - 3) + 132*bd1*fd*(2*C - 1)*(2*s - 1) + fd**2*(500*C - 325)*(3*s - 2))) - 2*D1*f*(Dd*f*(1000*C - 650)*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(132*bd1*s*(2*C - 1) + fd*(500*C - 325)*(3*s - 1)) - Ddd*f*(500*C - 325)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(1000*C - 650)*(6*s**2 - 6*s + 1)))/(693*d**2*k2*k3**2) + 2*D1**2*Pk1*Pk3*ct**3*k1*(33*b1**2*(D1**2*(s - 1)*(fd*(40*C*r + 236*C*(s - 1) - 20*r - 177*s + 177) + fdd*(-48*C*r - 188*C*(s - 1) + 24*r + 141*s - 141)) + 2*D1*(-4*C*Ddd*f*(12*r*(2*s - 1) + 94*s**2 - 100*s + 47) + Dd*f*(4*C*(10*r*(2*s - 1) + 118*s**2 - 123*s + 59) + r*(20 - 40*s) - 354*s**2 + 364*s - 177) + 2*Dd*fd*(-8*C*(3*r*(4*s - 3) + 47*s**2 - 72*s + 25) + 12*r*(4*s - 3) + 282*s**2 - 429*s + 147) + 3*Ddd*f*(8*r*(2*s - 1) + 94*s**2 - 98*s + 47)) + 2*Dd**2*f*(-4*C*(36*r*(2*s - 1) + 282*s**2 - 300*s + 59) + 72*r*(2*s - 1) + 846*s**2 - 882*s + 165)) + 66*b1*(D1**2*(f*(bdd1*s*(-4*C*(12*r + 47*s - 6) + 24*r + 141*s - 12) + fd*(4 - 8*C)*(2*s**2 + s + 1) + fdd*(4*C - 2)*(2*s**2 + 4*s + 1)) + fd**2*(8*C - 4)*(s**2 + 2*s - 3)) + D1*bd1*(-16*C*Dd*f*(6*r*(4*s - 1) + 94*s**2 - 56*s + 3) + D1*f*s*(4*C*(10*r + 59*s - 5) - 20*r - 177*s + 10) + D1*fd*(-8*C*(6*r*(2*s - 1) + 47*s**2 - 50*s + 3) + 6*r*(8*s - 4) + 282*s**2 - 294*s + 12) + 12*Dd*f*(4*r*(4*s - 1) + 94*s**2 - 53*s + 2)) - D1*f*(8*C - 4)*(2*Dd*f*(2*s**2 - 2*s + 1) - 4*Dd*fd*(2*s**2 + s - 1) + Ddd*f*(-2*s**2 + 2*s - 1)) + Dd**2*f**2*(8*C - 4)*(6*s**2 - 6*s + 1)) + f*(-66*D1**2*bd1**2*s*(4*C*(12*r + 47*s - 6) - 24*r - 141*s + 12) + D1**2*(f*(132*bdd1*s*(2*C - 1)*(s - 6) - 5*fd*(4*C*(86*r*(3*s - 1) + 891*s**2 - 680*s + 297) - 516*r*s + 172*r - 2613*s**2 + 1914*s - 871) + 5*fdd*(4*C*(76*r*(3*s - 1) + 693*s**2 - 538*s + 231) - 456*r*s + 152*r - 2049*s**2 + 1518*s - 683)) + 10*fd**2*(4*C*(76*r*(3*s - 1) + 693*s**2 - 538*s + 38) - 152*r*(3*s - 1) - 2049*s**2 + 1518*s - 76)) + 264*D1*bd1*(2*C - 1)*(-D1*f*s*(s - 3) + D1*fd*(2*s**2 - 4*s + 3) + 2*Dd*f*(2*s**2 - 7*s + 3)) - 10*D1*f*(Dd*(f*(4*C*(86*r*(2*s - 1) + 594*s**2 - 637*s + 297) - 344*r*s + 172*r - 1742*s**2 + 1828*s - 871) - 2*fd*(8*C*(228*r*s - 95*r + 693*s**2 - 644*s + 144) - 912*r*s + 380*r - 4098*s**2 + 3681*s - 797)) + Ddd*f*(-4*C*(76*r*(2*s - 1) + 462*s**2 - 500*s + 231) + 152*r*(2*s - 1) + 1366*s**2 - 1442*s + 683)) + 10*Dd**2*f**2*(4*C*(228*r*(2*s - 1) + 1386*s**2 - 1500*s + 307) - 456*r*(2*s - 1) - 4098*s**2 + 4326*s - 835)))/(693*d**2*k2*k3**2) + 4*D1**2*Pk1*Pk3*ct**3*k2**5*st**2*(-30888*C*D1**2*f**2*fd*r**2 - 30888*C*D1**2*f**2*fd*r*s + 30888*C*D1**2*f**2*fd*r + 10296*C*D1**2*f**2*fd*s - 10296*C*D1**2*f**2*fd - 41184*C*D1*Dd*f**3*r**2 - 41184*C*D1*Dd*f**3*r*s + 41184*C*D1*Dd*f**3*r + 10296*C*D1*Dd*f**3*s - 10296*C*D1*Dd*f**3 - 2574*D1**2*K*bdd1*f**2*r**2 - 2574*D1**2*K*bdd1*f**2*r*s + 2574*D1**2*K*bdd1*f**2*r + 858*D1**2*bd1**2*f*(r + s - 1)*(-6*K*r + 3*K + 10*f*(2*r + 2*s - 1) + 12*r + 6*s - 9) + 2405*D1**2*bdd1*f**3*r**2 - 14690*D1**2*bdd1*f**3*r*s + 3770*D1**2*bdd1*f**3*r - 17095*D1**2*bdd1*f**3*s**2 + 23270*D1**2*bdd1*f**3*s - 2925*D1**2*bdd1*f**3 + 5148*D1**2*bdd1*f**2*r**2 + 7722*D1**2*bdd1*f**2*r*s - 7722*D1**2*bdd1*f**2*r + 2574*D1**2*bdd1*f**2*s**2 - 5148*D1**2*bdd1*f**2*s + 2574*D1**2*bdd1*f**2 + 5148*D1**2*bdd1*f*g2*r**2 + 5148*D1**2*bdd1*f*g2*r*s - 10296*D1**2*bdd1*f*g2*r - 5148*D1**2*bdd1*f*g2*s + 5148*D1**2*bdd1*f*g2 + 20500*D1**2*f**3*fd*r**2 + 79000*D1**2*f**3*fd*r*s - 49750*D1**2*f**3*fd*r + 58500*D1**2*f**3*fd*s**2 - 78250*D1**2*f**3*fd*s + 34375*D1**2*f**3*fd - 44700*D1**2*f**3*fdd*r**2 - 116200*D1**2*f**3*fdd*r*s + 80450*D1**2*f**3*fdd*r - 71500*D1**2*f**3*fdd*s**2 + 100550*D1**2*f**3*fdd*s - 46925*D1**2*f**3*fdd - 134100*D1**2*f**2*fd**2*r**2 - 348600*D1**2*f**2*fd**2*r*s + 241350*D1**2*f**2*fd**2*r - 214500*D1**2*f**2*fd**2*s**2 + 301650*D1**2*f**2*fd**2*s - 93850*D1**2*f**2*fd**2 + 38610*D1**2*f**2*fd*r**2 + 46332*D1**2*f**2*fd*r*s - 41184*D1**2*f**2*fd*r + 7722*D1**2*f**2*fd*s**2 - 20592*D1**2*f**2*fd*s + 15444*D1**2*f**2*fd - 8580*D1**2*f**2*gd2*r**2 - 8580*D1**2*f**2*gd2*r*s + 8580*D1**2*f**2*gd2*r + 5148*D1**2*f**2*gdd2*r**2 + 5148*D1**2*f**2*gdd2*r*s - 5148*D1**2*f**2*gdd2*r - 17160*D1**2*f*fd*g2*r**2 - 17160*D1**2*f*fd*g2*r*s + 17160*D1**2*f*fd*g2*r + 8580*D1**2*f*fd*g2*s - 8580*D1**2*f*fd*g2 + 20592*D1**2*f*fd*gd2*r**2 + 20592*D1**2*f*fd*gd2*r*s - 20592*D1**2*f*fd*gd2*r - 5148*D1**2*f*fd*gd2*s + 5148*D1**2*f*fd*gd2 + 10296*D1**2*f*fdd*g2*r**2 + 10296*D1**2*f*fdd*g2*r*s - 10296*D1**2*f*fdd*g2*r - 5148*D1**2*f*fdd*g2*s + 5148*D1**2*f*fdd*g2 + 10296*D1**2*fd**2*g2*r**2 + 10296*D1**2*fd**2*g2*r*s - 10296*D1**2*fd**2*g2*r - 5148*D1**2*fd**2*g2*s + 20500*D1*Dd*f**4*r**2 + 79000*D1*Dd*f**4*r*s - 49750*D1*Dd*f**4*r + 58500*D1*Dd*f**4*s**2 - 78250*D1*Dd*f**4*s + 34375*D1*Dd*f**4 - 357600*D1*Dd*f**3*fd*r**2 - 929600*D1*Dd*f**3*fd*r*s + 643600*D1*Dd*f**3*fd*r - 572000*D1*Dd*f**3*fd*s**2 + 804400*D1*Dd*f**3*fd*s - 281550*D1*Dd*f**3*fd + 51480*D1*Dd*f**3*r**2 + 61776*D1*Dd*f**3*r*s - 56628*D1*Dd*f**3*r + 10296*D1*Dd*f**3*s**2 - 25740*D1*Dd*f**3*s + 18018*D1*Dd*f**3 - 34320*D1*Dd*f**2*g2*r**2 - 34320*D1*Dd*f**2*g2*r*s + 34320*D1*Dd*f**2*g2*r + 8580*D1*Dd*f**2*g2*s - 8580*D1*Dd*f**2*g2 + 41184*D1*Dd*f**2*gd2*r**2 + 41184*D1*Dd*f**2*gd2*r*s - 41184*D1*Dd*f**2*gd2*r - 5148*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 82368*D1*Dd*f*fd*g2*r**2 + 82368*D1*Dd*f*fd*g2*r*s - 82368*D1*Dd*f*fd*g2*r - 30888*D1*Dd*f*fd*g2*s + 20592*D1*Dd*f*fd*g2 - 44700*D1*Ddd*f**4*r**2 - 116200*D1*Ddd*f**4*r*s + 80450*D1*Ddd*f**4*r - 71500*D1*Ddd*f**4*s**2 + 100550*D1*Ddd*f**4*s - 46925*D1*Ddd*f**4 + 20592*D1*Ddd*f**2*g2*r**2 + 20592*D1*Ddd*f**2*g2*r*s - 20592*D1*Ddd*f**2*g2*r - 5148*D1*Ddd*f**2*g2*s + 5148*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(f**3*(1063*r**2 + 2*r*(289*s - 535) - 485*s**2 + 478*s + 507) + 2*f**2*(396*C*(r - 1)*(r + s - 1) - 5*fd*(111*r**2 - 678*r*s + 247*r - 789*s**2 + 997*s - 342) - (r + s - 1)*(165*K*r + 132*r - 99*s - 297)) + 66*f*(3*fd*(K*(4*r**2 + 4*r*(s - 1) - s + 1) - 8*r**2 - 12*r*s + 10*r - 4*s**2 + 7*s - 3) + (-2*g2*(r - 1) - 6*gd2*(2*r - 1))*(r + s - 1)) - 396*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 2*Dd*f*(5*f**2*(148*r**2 + r*(305 - 904*s) - 1052*s**2 + 1355*s - 387) - 99*f*(K*(8*r**2 + 8*r*(s - 1) - s + 1) - 16*r**2 - 24*r*s + 22*r - 8*s**2 + 15*s - 7) + 198*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 134100*Dd**2*f**4*r**2 - 348600*Dd**2*f**4*r*s + 241350*Dd**2*f**4*r - 214500*Dd**2*f**4*s**2 + 301650*Dd**2*f**4*s - 93850*Dd**2*f**4 + 61776*Dd**2*f**2*g2*r**2 + 61776*Dd**2*f**2*g2*r*s - 61776*Dd**2*f**2*g2*r - 15444*Dd**2*f**2*g2*s + 10296*Dd**2*f**2*g2 - 858*b1**2*(D1**2*(5*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(r + s)*(r*(K + 5) + 6*s) + 3*fdd*(r + s)*(r*(K - 2) - s)) + D1*(20*Dd*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + Dd*f*(K*(4*r**2 + 4*r*(s - 1) - s + 1) - 10*fd*(4*r + 4*s - 3)**2 + 20*r**2 + 44*r*s - 32*r + 24*s**2 - 35*s + 17) + 3*Dd*fd*(r**2*(8*K - 16) + 2*r*(K*(4*s - 2) - 12*s + 5) - s*(K + 8*s - 7)) - 10*Ddd*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 3*Ddd*f*(K*(4*r**2 + 4*r*(s - 1) - s + 1) - 8*r**2 - 2*r*(6*s - 5) - 4*s**2 + 7*s - 4)) - 3*Dd**2*f*(K*(-12*r**2 - 12*r*(s - 1) + 3*s - 2) + 20*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 24*r**2 + 36*r*s - 30*r + 12*s**2 - 21*s + 8)) - 13*b1*(1584*C*D1**2*f*fd*r**2 + 1584*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 3168*C*D1*Dd*f**2*r**2 + 3168*C*D1*Dd*f**2*r*s - 3168*C*D1*Dd*f**2*r - 792*C*D1*Dd*f**2*s + 792*C*D1*Dd*f**2 - 660*D1**2*K*f*fd*r**2 - 660*D1**2*K*f*fd*r*s + 660*D1**2*K*f*fd*r + 330*D1**2*K*f*fd*s - 330*D1**2*K*f*fd + 396*D1**2*K*f*fdd*r**2 + 396*D1**2*K*f*fdd*r*s - 396*D1**2*K*f*fdd*r - 198*D1**2*K*f*fdd*s + 198*D1**2*K*f*fdd + 396*D1**2*K*fd**2*r**2 + 396*D1**2*K*fd**2*r*s - 396*D1**2*K*fd**2*r - 198*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s - 1)*(-6*K*r + 3*K + 12*r + 6*s - 9)) + 3189*D1**2*f**2*fd*r**2 + 1734*D1**2*f**2*fd*r*s - 2212*D1**2*f**2*fd*r - 1455*D1**2*f**2*fd*s**2 + 884*D1**2*f**2*fd*s - 414*D1**2*f**2*fd - 555*D1**2*f**2*fdd*r**2 + 3390*D1**2*f**2*fdd*r*s - 1600*D1**2*f**2*fdd*r + 3945*D1**2*f**2*fdd*s**2 - 4600*D1**2*f**2*fdd*s + 2220*D1**2*f**2*fdd - 1110*D1**2*f*fd**2*r**2 + 6780*D1**2*f*fd**2*r*s - 3200*D1**2*f*fd**2*r + 7890*D1**2*f*fd**2*s**2 - 9200*D1**2*f*fd**2*s + 1470*D1**2*f*fd**2 - 528*D1**2*f*fd*r**2 - 132*D1**2*f*fd*r*s - 264*D1**2*f*fd*r + 396*D1**2*f*fd*s**2 - 726*D1**2*f*fd*s + 528*D1**2*f*fd - 792*D1**2*f*fdd*r**2 - 1188*D1**2*f*fdd*r*s + 792*D1**2*f*fdd*r - 396*D1**2*f*fdd*s**2 + 594*D1**2*f*fdd*s - 396*D1**2*f*fdd - 132*D1**2*f*gd2*r**2 - 132*D1**2*f*gd2*r*s + 132*D1**2*f*gd2*r - 396*D1**2*f*gdd2*r**2 - 396*D1**2*f*gdd2*r*s + 396*D1**2*f*gdd2*r - 792*D1**2*fd**2*r**2 - 1188*D1**2*fd**2*r*s + 792*D1**2*fd**2*r - 396*D1**2*fd**2*s**2 + 594*D1**2*fd**2*s - 132*D1**2*fd*g2*r**2 - 132*D1**2*fd*g2*r*s - 792*D1**2*fd*gd2*r**2 - 792*D1**2*fd*gd2*r*s + 396*D1**2*fd*gd2*r - 396*D1**2*fdd*g2*r**2 - 396*D1**2*fdd*g2*r*s - 1320*D1*Dd*K*f**2*r**2 - 1320*D1*Dd*K*f**2*r*s + 1320*D1*Dd*K*f**2*r + 330*D1*Dd*K*f**2*s - 330*D1*Dd*K*f**2 + 3168*D1*Dd*K*f*fd*r**2 + 3168*D1*Dd*K*f*fd*r*s - 3168*D1*Dd*K*f*fd*r - 1188*D1*Dd*K*f*fd*s + 792*D1*Dd*K*f*fd + 4252*D1*Dd*f**3*r**2 + 2312*D1*Dd*f**3*r*s - 3282*D1*Dd*f**3*r - 1940*D1*Dd*f**3*s**2 + 1362*D1*Dd*f**3*s + 93*D1*Dd*f**3 - 4440*D1*Dd*f**2*fd*r**2 + 27120*D1*Dd*f**2*fd*r*s - 12070*D1*Dd*f**2*fd*r + 31560*D1*Dd*f**2*fd*s**2 - 37570*D1*Dd*f**2*fd*s + 10800*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r*s + 660*D1*Dd*f**2*r + 792*D1*Dd*f**2*s**2 - 726*D1*Dd*f**2*s + 132*D1*Dd*f**2 - 6336*D1*Dd*f*fd*r**2 - 9504*D1*Dd*f*fd*r*s + 7128*D1*Dd*f*fd*r - 3168*D1*Dd*f*fd*s**2 + 5148*D1*Dd*f*fd*s - 1980*D1*Dd*f*fd - 528*D1*Dd*f*g2*r**2 - 528*D1*Dd*f*g2*r*s + 528*D1*Dd*f*g2*r + 132*D1*Dd*f*g2*s - 132*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 3168*D1*Dd*f*gd2*r*s + 3168*D1*Dd*f*gd2*r + 396*D1*Dd*f*gd2*s - 396*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 3168*D1*Dd*fd*g2*r*s + 1584*D1*Dd*fd*g2*r + 396*D1*Dd*fd*g2*s + 792*D1*Ddd*K*f**2*r**2 + 792*D1*Ddd*K*f**2*r*s - 792*D1*Ddd*K*f**2*r - 198*D1*Ddd*K*f**2*s + 198*D1*Ddd*K*f**2 - 740*D1*Ddd*f**3*r**2 + 4520*D1*Ddd*f**3*r*s - 1890*D1*Ddd*f**3*r + 5260*D1*Ddd*f**3*s**2 - 6390*D1*Ddd*f**3*s + 2445*D1*Ddd*f**3 - 1584*D1*Ddd*f**2*r**2 - 2376*D1*Ddd*f**2*r*s + 1980*D1*Ddd*f**2*r - 792*D1*Ddd*f**2*s**2 + 1386*D1*Ddd*f**2*s - 792*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 1584*D1*Ddd*f*g2*r*s + 1584*D1*Ddd*f*g2*r + 396*D1*Ddd*f*g2*s - 396*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(10*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(r + s - 1)*(-2*K*r + K + 40*fd*(2*r + 2*s - 1) - 10*r - 12*s + 11) + 3*fd*(r**2*(4*K - 8) + r*(4*K*s - 3*K - 12*s + 7) - s*(K + 4*s - 5))) - Dd*f*(-3*K*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 10*f*(4*r + 4*s - 3)**2 + 96*r**2 + 144*r*s - 144*r + 48*s**2 - 102*s + 51)) + 2376*Dd**2*K*f**2*r**2 + 2376*Dd**2*K*f**2*r*s - 2376*Dd**2*K*f**2*r - 594*Dd**2*K*f**2*s + 396*Dd**2*K*f**2 - 2220*Dd**2*f**3*r**2 + 13560*Dd**2*f**3*r*s - 5670*Dd**2*f**3*r + 15780*Dd**2*f**3*s**2 - 19170*Dd**2*f**3*s + 4890*Dd**2*f**3 - 4752*Dd**2*f**2*r**2 - 7128*Dd**2*f**2*r*s + 5940*Dd**2*f**2*r - 2376*Dd**2*f**2*s**2 + 4158*Dd**2*f**2*s - 1584*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 4752*Dd**2*f*g2*r*s + 4752*Dd**2*f*g2*r + 1188*Dd**2*f*g2*s - 792*Dd**2*f*g2))/(9009*d**2*k1*k3**6) - 2*D1**2*Pk1*Pk3*ct**3*k2**3*st**2*(132*b1**2*(C - 1)*(D1**2*r*(fd + 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) + 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1*(-20*C*D1**2*f*fd*r**2 + 40*C*D1**2*f*fd*r*s + 20*C*D1**2*f*fd*r + 20*C*D1**2*f*fd*s - 20*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r**2 - 40*C*D1**2*f*fdd*r*s - 4*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r**2 - 40*C*D1**2*fd**2*r*s - 4*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 - 40*C*D1*Dd*f**2*r**2 + 80*C*D1*Dd*f**2*r*s - 20*C*D1*Dd*f**2*r - 20*C*D1*Dd*f**2*s - 10*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*r**2 - 320*C*D1*Dd*f*fd*r*s + 24*C*D1*Dd*f*fd*r - 8*C*D1*Dd*f*fd*s + 28*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*r**2 - 80*C*D1*Ddd*f**2*r*s + 20*C*D1*Ddd*f**2*r + 20*C*D1*Ddd*f**2*s + 10*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*r**2 - 240*C*Dd**2*f**2*r*s + 60*C*Dd**2*f**2*r + 60*C*Dd**2*f**2*s - 40*C*Dd**2*f**2 + 12*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) - 10*D1**2*f*fd*r**2 - 164*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 94*D1**2*f*fd*s**2 + 74*D1**2*f*fd*s - 27*D1**2*f*fd - 2*D1**2*f*fdd*r**2 + 132*D1**2*f*fdd*r*s - 42*D1**2*f*fdd*r + 74*D1**2*f*fdd*s**2 - 62*D1**2*f*fdd*s + 25*D1**2*f*fdd - 2*D1**2*fd**2*r**2 + 132*D1**2*fd**2*r*s - 42*D1**2*fd**2*r + 74*D1**2*fd**2*s**2 - 62*D1**2*fd**2*s - 12*D1**2*fd**2 - 20*D1*Dd*f**2*r**2 - 328*D1*Dd*f**2*r*s + 174*D1*Dd*f**2*r - 188*D1*Dd*f**2*s**2 + 270*D1*Dd*f**2*s - 99*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 + 1056*D1*Dd*f*fd*r*s - 428*D1*Dd*f*fd*r + 592*D1*Dd*f*fd*s**2 - 676*D1*Dd*f*fd*s + 166*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 264*D1*Ddd*f**2*r*s - 130*D1*Ddd*f**2*r + 148*D1*Ddd*f**2*s**2 - 214*D1*Ddd*f**2*s + 73*D1*Ddd*f**2 + 4*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 12*Dd**2*f**2*r**2 + 792*Dd**2*f**2*r*s - 390*Dd**2*f**2*r + 444*Dd**2*f**2*s**2 - 642*Dd**2*f**2*s + 206*Dd**2*f**2) + f*(738*C*D1**2*f*fd*r**2 + 5640*C*D1**2*f*fd*r*s - 2372*C*D1**2*f*fd*r - 1880*C*D1**2*f*fd*s + 246*C*D1**2*f*fd - 1062*C*D1**2*f*fdd*r**2 - 4800*C*D1**2*f*fdd*r*s + 2308*C*D1**2*f*fdd*r + 1600*C*D1**2*f*fdd*s - 354*C*D1**2*f*fdd - 2124*C*D1**2*fd**2*r**2 - 9600*C*D1**2*fd**2*r*s + 4616*C*D1**2*fd**2*r + 3200*C*D1**2*fd**2*s - 1600*C*D1**2*fd**2 + 984*C*D1*Dd*f**2*r**2 + 7520*C*D1*Dd*f**2*r*s - 4252*C*D1*Dd*f**2*r - 1880*C*D1*Dd*f**2*s + 246*C*D1*Dd*f**2 - 8496*C*D1*Dd*f*fd*r**2 - 38400*C*D1*Dd*f*fd*r*s + 20956*C*D1*Dd*f*fd*r + 11200*C*D1*Dd*f*fd*s - 5508*C*D1*Dd*f*fd - 1416*C*D1*Ddd*f**2*r**2 - 6400*C*D1*Ddd*f**2*r*s + 3908*C*D1*Ddd*f**2*r + 1600*C*D1*Ddd*f**2*s - 354*C*D1*Ddd*f**2 - 4248*C*Dd**2*f**2*r**2 - 19200*C*Dd**2*f**2*r*s + 11724*C*Dd**2*f**2*r + 4800*C*Dd**2*f**2*s - 3200*C*Dd**2*f**2 + 396*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(2*C*(5*r**2 - 10*r*s + 2*r + 16*s - 1) - r**2 + 66*r*s - 22*r + 37*s**2 - 78*s + 11) - 2781*D1**2*f*fd*r**2 - 11958*D1**2*f*fd*r*s + 5840*D1**2*f*fd*r - 4173*D1**2*f*fd*s**2 + 6768*D1**2*f*fd*s - 2318*D1**2*f*fd + 2529*D1**2*f*fdd*r**2 + 9642*D1**2*f*fdd*r*s - 4900*D1**2*f*fdd*r + 3423*D1**2*f*fdd*s**2 - 5496*D1**2*f*fdd*s + 1984*D1**2*f*fdd + 5058*D1**2*fd**2*r**2 + 19284*D1**2*fd**2*r*s - 9800*D1**2*fd**2*r + 6846*D1**2*fd**2*s**2 - 10992*D1**2*fd**2*s + 3214*D1**2*fd**2 - 3708*D1*Dd*f**2*r**2 - 15944*D1*Dd*f**2*r*s + 9826*D1*Dd*f**2*r - 5564*D1*Dd*f**2*s**2 + 9550*D1*Dd*f**2*s - 3709*D1*Dd*f**2 + 20232*D1*Dd*f*fd*r**2 + 77136*D1*Dd*f*fd*r*s - 43942*D1*Dd*f*fd*r + 27384*D1*Dd*f*fd*s**2 - 45318*D1*Dd*f*fd*s + 15892*D1*Dd*f*fd + 3372*D1*Ddd*f**2*r**2 + 12856*D1*Ddd*f**2*r*s - 8114*D1*Ddd*f**2*r + 4564*D1*Ddd*f**2*s**2 - 7778*D1*Ddd*f**2*s + 3125*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(10*C*(r**2 - 2*r*s + 2*r + 4*s - 1) + 5*r**2 + 82*r*s - 50*r + 47*s**2 - 102*s + 25) - 2*fd*(2*C*(10*r**2 - 20*r*s + r + 13*s - 8) - 2*r**2 + 132*r*s - 43*r + 74*s**2 - 109*s + 39)) - 2*Dd*f*(2*C*(20*r**2 - 40*r*s + 9*r + 37*s - 17) - 4*r**2 + 264*r*s - 109*r + 148*s**2 - 263*s + 89)) + 10116*Dd**2*f**2*r**2 + 38568*Dd**2*f**2*r*s - 24342*Dd**2*f**2*r + 13692*Dd**2*f**2*s**2 - 23334*Dd**2*f**2*s + 8710*Dd**2*f**2))/(693*d**2*k1*k3**4) - 2*D1**2*Pk1*Pk3*ct**3*k2**3*(-25740*C*D1**2*f**2*fd*r**2 + 17160*C*D1**2*f**2*fd*r - 8580*C*D1**2*f**2*fd - 34320*C*D1*Dd*f**3*r**2 + 17160*C*D1*Dd*f**3*r - 8580*C*D1*Dd*f**3 + 858*D1**2*K*bdd1*f**2*r**2 - 6006*D1**2*K*bdd1*f**2*r*s + 6006*D1**2*K*bdd1*f**2*r + 6864*D1**2*b2*f*fd*r**2 + 6864*D1**2*b2*f*fd*r*s - 6864*D1**2*b2*f*fd*r - 3432*D1**2*b2*f*fd*s + 3432*D1**2*b2*f*fd - 3432*D1**2*b2*f*fdd*r**2 - 3432*D1**2*b2*f*fdd*r*s + 3432*D1**2*b2*f*fdd*r + 1716*D1**2*b2*f*fdd*s - 1716*D1**2*b2*f*fdd - 3432*D1**2*b2*fd**2*r**2 - 3432*D1**2*b2*fd**2*r*s + 3432*D1**2*b2*fd**2*r + 1716*D1**2*b2*fd**2*s + 858*D1**2*bd1**2*f*(K*(6*r**2 + 2*r*s - 3*r + s - 1) + f*(4*r**2 + r*(88*s - 30) + 84*s**2 - 88*s + 24) - 7*r**2 + 44*r*s - 19*r + 47*s**2 - 71*s + 24) + 3432*D1**2*bd2*f**2*r**2 + 3432*D1**2*bd2*f**2*r*s - 3432*D1**2*bd2*f**2*r - 6864*D1**2*bd2*f*fd*r**2 - 6864*D1**2*bd2*f*fd*r*s + 6864*D1**2*bd2*f*fd*r + 1716*D1**2*bd2*f*fd*s - 1716*D1**2*bd2*f*fd + 8710*D1**2*bdd1*f**3*r**2 + 31876*D1**2*bdd1*f**3*r*s - 24180*D1**2*bdd1*f**3*r + 4290*D1**2*bdd1*f**3*s**2 - 19734*D1**2*bdd1*f**3*s + 15054*D1**2*bdd1*f**3 + 3003*D1**2*bdd1*f**2*r**2 + 26598*D1**2*bdd1*f**2*r*s - 26598*D1**2*bdd1*f**2*r + 17160*D1**2*bdd1*f**2*s**2 - 34320*D1**2*bdd1*f**2*s + 17160*D1**2*bdd1*f**2 - 5148*D1**2*bdd1*f*g2*r**2 - 1716*D1**2*bdd1*f*g2*r*s + 3432*D1**2*bdd1*f*g2*r - 1716*D1**2*bdd1*f*g2*s - 1716*D1**2*bdd1*f*g2 - 1716*D1**2*bdd2*f**2*r**2 - 1716*D1**2*bdd2*f**2*r*s + 1716*D1**2*bdd2*f**2*r + 55800*D1**2*f**3*fd*r**2 + 62400*D1**2*f**3*fd*r*s - 59100*D1**2*f**3*fd*r + 85800*D1**2*f**3*fd*s**2 - 101400*D1**2*f**3*fd*s + 56850*D1**2*f**3*fd - 3720*D1**2*f**3*fdd*r**2 - 62400*D1**2*f**3*fdd*r*s + 33060*D1**2*f**3*fdd*r - 85800*D1**2*f**3*fdd*s**2 + 101400*D1**2*f**3*fdd*s - 43830*D1**2*f**3*fdd - 11160*D1**2*f**2*fd**2*r**2 - 187200*D1**2*f**2*fd**2*r*s + 99180*D1**2*f**2*fd**2*r - 257400*D1**2*f**2*fd**2*s**2 + 304200*D1**2*f**2*fd**2*s - 74100*D1**2*f**2*fd**2 + 51480*D1**2*f**2*fd*r**2 + 25740*D1**2*f**2*fd*r*s - 42900*D1**2*f**2*fd*r - 8580*D1**2*f**2*fd*s + 17160*D1**2*f**2*fd - 61776*D1**2*f**2*gd2*r**2 - 1716*D1**2*f**2*gdd2*r**2 + 12012*D1**2*f**2*gdd2*r*s - 12012*D1**2*f**2*gdd2*r - 123552*D1**2*f*fd*g2*r**2 + 123552*D1**2*f*fd*g2*r - 61776*D1**2*f*fd*g2 - 6864*D1**2*f*fd*gd2*r**2 + 48048*D1**2*f*fd*gd2*r*s - 20592*D1**2*f*fd*gd2*r - 12012*D1**2*f*fd*gd2*s + 12012*D1**2*f*fd*gd2 - 3432*D1**2*f*fdd*g2*r**2 + 24024*D1**2*f*fdd*g2*r*s + 3432*D1**2*f*fdd*g2*r - 12012*D1**2*f*fdd*g2*s - 1716*D1**2*f*fdd*g2 - 3432*D1**2*fd**2*g2*r**2 + 24024*D1**2*fd**2*g2*r*s + 3432*D1**2*fd**2*g2*r - 12012*D1**2*fd**2*g2*s + 13728*D1*Dd*b2*f**2*r**2 + 13728*D1*Dd*b2*f**2*r*s - 13728*D1*Dd*b2*f**2*r - 3432*D1*Dd*b2*f**2*s + 3432*D1*Dd*b2*f**2 - 27456*D1*Dd*b2*f*fd*r**2 - 27456*D1*Dd*b2*f*fd*r*s + 27456*D1*Dd*b2*f*fd*r + 10296*D1*Dd*b2*f*fd*s - 6864*D1*Dd*b2*f*fd - 13728*D1*Dd*bd2*f**2*r**2 - 13728*D1*Dd*bd2*f**2*r*s + 13728*D1*Dd*bd2*f**2*r + 1716*D1*Dd*bd2*f**2*s - 1716*D1*Dd*bd2*f**2 + 55800*D1*Dd*f**4*r**2 + 62400*D1*Dd*f**4*r*s - 59100*D1*Dd*f**4*r + 85800*D1*Dd*f**4*s**2 - 101400*D1*Dd*f**4*s + 56850*D1*Dd*f**4 - 29760*D1*Dd*f**3*fd*r**2 - 499200*D1*Dd*f**3*fd*r*s + 264480*D1*Dd*f**3*fd*r - 686400*D1*Dd*f**3*fd*s**2 + 811200*D1*Dd*f**3*fd*s - 235860*D1*Dd*f**3*fd + 68640*D1*Dd*f**3*r**2 + 34320*D1*Dd*f**3*r*s - 51480*D1*Dd*f**3*r - 8580*D1*Dd*f**3*s + 17160*D1*Dd*f**3 - 247104*D1*Dd*f**2*g2*r**2 + 123552*D1*Dd*f**2*g2*r - 61776*D1*Dd*f**2*g2 - 13728*D1*Dd*f**2*gd2*r**2 + 96096*D1*Dd*f**2*gd2*r*s - 68640*D1*Dd*f**2*gd2*r - 12012*D1*Dd*f**2*gd2*s + 12012*D1*Dd*f**2*gd2 - 27456*D1*Dd*f*fd*g2*r**2 + 192192*D1*Dd*f*fd*g2*r*s - 27456*D1*Dd*f*fd*g2*r - 72072*D1*Dd*f*fd*g2*s + 20592*D1*Dd*f*fd*g2 - 6864*D1*Ddd*b2*f**2*r**2 - 6864*D1*Ddd*b2*f**2*r*s + 6864*D1*Ddd*b2*f**2*r + 1716*D1*Ddd*b2*f**2*s - 1716*D1*Ddd*b2*f**2 - 3720*D1*Ddd*f**4*r**2 - 62400*D1*Ddd*f**4*r*s + 33060*D1*Ddd*f**4*r - 85800*D1*Ddd*f**4*s**2 + 101400*D1*Ddd*f**4*s - 43830*D1*Ddd*f**4 - 6864*D1*Ddd*f**2*g2*r**2 + 48048*D1*Ddd*f**2*g2*r*s - 20592*D1*Ddd*f**2*g2*r - 12012*D1*Ddd*f**2*g2*s - 1716*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(2*f**3*(505*r**2 + 2*r*(533*s - 105) - 165*s**2 - 429*s + 69) - f**2*(792*C*(r**2 + 2*r*(s + 1) - 1) + 4*fd*(1005*r**2 + r*(3678*s - 2491) + 495*s**2 - 1702*s + 645) + 33*r**2*(72*K - 97) - 396*r*(7*s + 3) - 858*s**2 + 924*s + 726) - 66*f*(fd*(K*(4*r**2 - 28*r*s + 12*r + 7*s - 7) + 14*r**2 + 124*r*s - 69*r + 80*s**2 - 111*s + 31) - 2*g2*(r**2 - 30*r*s - 38*r + 12*s + 19) - 2*gd2*(6*r**2 + 2*r*s - 3*r + s - 1)) + 132*fd*g2*(6*r**2 + 2*r*(s - 3) - s)) - 2*Dd*f*(2*f**2*(1340*r**2 + r*(4904*s - 3421) + 660*s**2 - 2461*s + 1224) + 33*f*(K*(8*r**2 - 56*r*s + 40*r + 7*s - 7) + 28*r**2 + 248*r*s - 193*r + 160*s**2 - 271*s + 111) - 66*g2*(24*r**2 + 8*r*(s - 2) + 3*s))) - 20592*Dd**2*b2*f**2*r**2 - 20592*Dd**2*b2*f**2*r*s + 20592*Dd**2*b2*f**2*r + 5148*Dd**2*b2*f**2*s - 3432*Dd**2*b2*f**2 - 11160*Dd**2*f**4*r**2 - 187200*Dd**2*f**4*r*s + 99180*Dd**2*f**4*r - 257400*Dd**2*f**4*s**2 + 304200*Dd**2*f**4*s - 74100*Dd**2*f**4 - 20592*Dd**2*f**2*g2*r**2 + 144144*Dd**2*f**2*g2*r*s - 61776*Dd**2*f**2*g2*r - 36036*Dd**2*f**2*g2*s + 24024*Dd**2*f**2*g2 + 429*b1**2*(D1**2*(4*fd**2*(2*r**2 + r*(44*s - 31) + 42*s**2 - 62*s + 20) + fd*(56*C*r**2 + 56*C*r*s - 56*C*r + 2*K*(r**2 - 30*r*s + 36*r + 18*s - 18) + 2*f*(4*r**2 + r*(34 - 56*s) - 60*s**2 + 86*s - 41) - 77*r**2 - 46*r*s - 16*r - 31*s**2 - 36*s + 36) + fdd*(2*K*(3*r**2 + r*(s - 4) - 2*s + 2) + 2*f*(4*r**2 + r*(88*s - 62) + 84*s**2 - 124*s + 61) - 7*r**2 + 44*r*s + 8*r + 47*s**2 + 4*s - 4)) + D1*(Dd*(4*f**2*(4*r**2 + r*(26 - 56*s) - 60*s**2 + 74*s - 29) + f*(56*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 8*K*r**2 - 240*K*r*s + 116*K*r + 60*K*s + 2*K + 4*fd*(16*r**2 + 8*r*(44*s - 27) + 336*s**2 - 460*s + 155) - 308*r**2 - 184*r*s + 246*r - 124*s**2 + 170*s - 139) + 2*fd*(K*(24*r**2 + 8*r*(s - 3) - 9*s + 8) - 28*r**2 + 176*r*s - 21*r + 188*s**2 - 108*s - 8)) + Ddd*f*(2*K*(12*r**2 + 4*r*(s - 2) - s + 3) + 4*f*(4*r**2 + r*(88*s - 46) + 84*s**2 - 106*s + 43) - 28*r**2 + 176*r*s - 74*r + 188*s**2 - 232*s + 87)) + 2*Dd**2*f*(K*(36*r**2 + 12*r*(s - 2) - 3*s + 2) + 4*f*(6*r**2 + 3*r*(44*s - 23) + 126*s**2 - 159*s + 43) - 42*r**2 + 264*r*s - 111*r + 282*s**2 - 348*s + 91)) + 13*b1*(1584*C*D1**2*f*fd*r**2 + 3168*C*D1**2*f*fd*r*s - 4752*C*D1**2*f*fd*r - 1584*C*D1**2*f*fd*s + 1584*C*D1**2*f*fd + 3168*C*D1*Dd*f**2*r**2 + 6336*C*D1*Dd*f**2*r*s - 4752*C*D1*Dd*f**2*r - 1584*C*D1*Dd*f**2*s + 792*C*D1*Dd*f**2 + 4752*D1**2*K*f*fd*r**2 - 4752*D1**2*K*f*fd*r + 2376*D1**2*K*f*fd + 132*D1**2*K*f*fdd*r**2 - 924*D1**2*K*f*fdd*r*s - 132*D1**2*K*f*fdd*r + 462*D1**2*K*f*fdd*s + 66*D1**2*K*f*fdd + 132*D1**2*K*fd**2*r**2 - 924*D1**2*K*fd**2*r*s - 132*D1**2*K*fd**2*r + 462*D1**2*K*fd**2*s + 66*D1**2*bdd1*f*(K*(6*r**2 + 2*r*s - 3*r + s + 1) + f*(4*r**2 + r*(88*s - 30) + 84*s**2 - 88*s + 25) - 7*r**2 + 44*r*s - 19*r + 47*s**2 - 71*s + 22) - 3030*D1**2*f**2*fd*r**2 - 6396*D1**2*f**2*fd*r*s + 5864*D1**2*f**2*fd*r + 990*D1**2*f**2*fd*s**2 - 46*D1**2*f**2*fd*s - 212*D1**2*f**2*fd + 2010*D1**2*f**2*fdd*r**2 + 7356*D1**2*f**2*fdd*r*s - 4384*D1**2*f**2*fdd*r + 990*D1**2*f**2*fdd*s**2 - 2254*D1**2*f**2*fdd*s + 172*D1**2*f**2*fdd + 4020*D1**2*f*fd**2*r**2 + 14712*D1**2*f*fd**2*r*s - 8768*D1**2*f*fd**2*r + 1980*D1**2*f*fd**2*s**2 - 4508*D1**2*f*fd**2*s + 2984*D1**2*f*fd**2 - 6402*D1**2*f*fd*r**2 - 5544*D1**2*f*fd*r*s + 10362*D1**2*f*fd*r - 1716*D1**2*f*fd*s**2 + 3564*D1**2*f*fd*s - 4785*D1**2*f*fd + 462*D1**2*f*fdd*r**2 + 4092*D1**2*f*fdd*r*s - 462*D1**2*f*fdd*r + 2640*D1**2*f*fdd*s**2 - 2046*D1**2*f*fdd*s + 231*D1**2*f*fdd - 132*D1**2*f*gd2*r**2 + 3960*D1**2*f*gd2*r*s - 3960*D1**2*f*gd2*r - 396*D1**2*f*gdd2*r**2 - 132*D1**2*f*gdd2*r*s + 132*D1**2*f*gdd2*r + 462*D1**2*fd**2*r**2 + 4092*D1**2*fd**2*r*s - 462*D1**2*fd**2*r + 2640*D1**2*fd**2*s**2 - 2046*D1**2*fd**2*s - 132*D1**2*fd*g2*r**2 + 3960*D1**2*fd*g2*r*s - 4752*D1**2*fd*g2*r - 2376*D1**2*fd*g2*s + 2376*D1**2*fd*g2 - 792*D1**2*fd*gd2*r**2 - 264*D1**2*fd*gd2*r*s + 660*D1**2*fd*gd2*r + 264*D1**2*fd*gd2*s - 264*D1**2*fd*gd2 - 396*D1**2*fdd*g2*r**2 - 132*D1**2*fdd*g2*r*s + 528*D1**2*fdd*g2*r + 264*D1**2*fdd*g2*s - 264*D1**2*fdd*g2 + 9504*D1*Dd*K*f**2*r**2 - 4752*D1*Dd*K*f**2*r + 2376*D1*Dd*K*f**2 + 1056*D1*Dd*K*f*fd*r**2 - 7392*D1*Dd*K*f*fd*r*s + 1056*D1*Dd*K*f*fd*r + 2772*D1*Dd*K*f*fd*s - 792*D1*Dd*K*f*fd - 4040*D1*Dd*f**3*r**2 - 8528*D1*Dd*f**3*r*s + 6284*D1*Dd*f**3*r + 1320*D1*Dd*f**3*s**2 + 812*D1*Dd*f**3*s - 350*D1*Dd*f**3 + 16080*D1*Dd*f**2*fd*r**2 + 58848*D1*Dd*f**2*fd*r*s - 36268*D1*Dd*f**2*fd*r + 7920*D1*Dd*f**2*fd*s**2 - 20332*D1*Dd*f**2*fd*s + 8892*D1*Dd*f**2*fd - 12804*D1*Dd*f**2*r**2 - 11088*D1*Dd*f**2*r*s + 11946*D1*Dd*f**2*r - 3432*D1*Dd*f**2*s**2 + 6204*D1*Dd*f**2*s - 4917*D1*Dd*f**2 + 3696*D1*Dd*f*fd*r**2 + 32736*D1*Dd*f*fd*r*s - 10956*D1*Dd*f*fd*r + 21120*D1*Dd*f*fd*s**2 - 22836*D1*Dd*f*fd*s + 4554*D1*Dd*f*fd - 528*D1*Dd*f*g2*r**2 + 15840*D1*Dd*f*g2*r*s - 7656*D1*Dd*f*g2*r - 3960*D1*Dd*f*g2*s - 132*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 1056*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r + 132*D1*Dd*f*gd2*s - 132*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 1056*D1*Dd*fd*g2*r*s + 3168*D1*Dd*fd*g2*r + 1188*D1*Dd*fd*g2*s - 1056*D1*Dd*fd*g2 + 264*D1*Ddd*K*f**2*r**2 - 1848*D1*Ddd*K*f**2*r*s + 792*D1*Ddd*K*f**2*r + 462*D1*Ddd*K*f**2*s + 66*D1*Ddd*K*f**2 + 2680*D1*Ddd*f**3*r**2 + 9808*D1*Ddd*f**3*r*s - 6244*D1*Ddd*f**3*r + 1320*D1*Ddd*f**3*s**2 - 3772*D1*Ddd*f**3*s + 1330*D1*Ddd*f**3 + 924*D1*Ddd*f**2*r**2 + 8184*D1*Ddd*f**2*r*s - 4554*D1*Ddd*f**2*r + 5280*D1*Ddd*f**2*s**2 - 7326*D1*Ddd*f**2*s + 2871*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 528*D1*Ddd*f*g2*r*s + 1056*D1*Ddd*f*g2*r + 132*D1*Ddd*f*g2*s - 396*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f**2*(4*r**2 + r*(18 - 56*s) - 60*s**2 + 62*s - 17) + f*(28*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*K*r**2 - 60*K*r*s - 8*K*r + 12*K*s + 19*K + 4*fd*(4*r**2 + 88*r*s - 46*r + 84*s**2 - 106*s + 27) - 77*r**2 - 46*r*s + 108*r - 31*s**2 + 72*s - 72) + fd*(K*(12*r**2 + r*(4*s - 11) - 3*s + 2) - 14*r**2 + 11*r*(8*s - 1) + 94*s**2 - 67*s - 2)) + Dd*f*(K*(48*r**2 + 4*r*(4*s - 7) + 2*s + 1) + f*(32*r**2 + 16*r*(44*s - 19) + 672*s**2 - 776*s + 206) - 56*r**2 + 352*r*s - 150*r + 376*s**2 - 516*s + 161)) + 792*Dd**2*K*f**2*r**2 - 5544*Dd**2*K*f**2*r*s + 2376*Dd**2*K*f**2*r + 1386*Dd**2*K*f**2*s - 924*Dd**2*K*f**2 + 8040*Dd**2*f**3*r**2 + 29424*Dd**2*f**3*r*s - 18732*Dd**2*f**3*r + 3960*Dd**2*f**3*s**2 - 11316*Dd**2*f**3*s + 5564*Dd**2*f**3 + 2772*Dd**2*f**2*r**2 + 24552*Dd**2*f**2*r*s - 13662*Dd**2*f**2*r + 15840*Dd**2*f**2*s**2 - 21978*Dd**2*f**2*s + 6732*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 1584*Dd**2*f*g2*r*s + 3168*Dd**2*f*g2*r + 396*Dd**2*f*g2*s - 264*Dd**2*f*g2))/(9009*d**2*k1*k3**4) - 2*D1**2*Pk1*Pk3*ct**3*k2*st**2*(132*b1**2*(C - 1)*(D1*Dd*(f*(4*r*s - 2*r - s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(D1*r*(fd + 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 33*b1*(D1**2*(f*(12*bdd1*s*(C - 1)*(2*r - 1) + fd*(-r*(20*C - 4)*(2*s - 1) - 94*s**2 + s*(20*C + 74) - 47) + fdd*(r*(12*C - 4)*(2*s - 1) + 74*s**2 - s*(12*C + 62) + 37)) + 2*fd**2*(6*C*(r*(2*s - 1) - s + 1) + r*(2 - 4*s) + 37*s**2 - 31*s - 6)) + 4*D1*bd1*(C - 1)*(D1*(f*s*(2*r - 1) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) - 2*D1*f*(Dd*(f*(r*(20*C - 4)*(2*s - 1) + 94*s**2 - s*(10*C + 92) + 47) - 2*fd*(2*s - 1)*(3*C*(8*r - 3) - 8*r + 74*s - 30)) + Ddd*f*(-r*(12*C - 4)*(2*s - 1) - 74*s**2 + s*(6*C + 72) - 37)) + 6*Dd**2*f**2*(2*C*(6*r*(2*s - 1) - 3*s + 2) + r*(4 - 8*s) + 74*s**2 - 72*s + 11)) + f*(396*D1**2*bd1**2*s*(C - 1)*(2*r - 1) + D1**2*(f*(33*bdd1*s*(r*(12*C - 4) + 37*s - 8) + fd*(-112*C*s + r*(112*C - 636)*(3*s - 1) - 4173*s**2 + 3418*s - 1391) + fdd*(320*C*s - r*(320*C - 648)*(3*s - 1) + 3423*s**2 - 2930*s + 1141)) + 2*fd**2*(-160*C*(r*(6*s - 2) - 2*s + 1) + 648*r*(3*s - 1) + 3423*s**2 - 2930*s + 324)) - 33*D1*bd1*(D1*(f*s*(r*(20*C - 4) + 47*s - 16) - 2*fd*(-6*C*s + r*(6*C - 2)*(4*s - 1) + 74*s**2 - 39*s + 4)) - 4*Dd*f*(-3*C*s + r*(6*C - 2)*(4*s - 1) + 74*s**2 - 44*s + 4)) + 2*D1*f*(Dd*(f*(r*(112*C - 636)*(2*s - 1) - 2782*s**2 + s*(3100 - 56*C) - 1391) + 2*fd*(-80*C*(2*r*(12*s - 5) - 7*s + 3) + 324*r*(12*s - 5) + 6846*s**2 - 6839*s + 1627)) + Ddd*f*(-r*(320*C - 648)*(2*s - 1) + 2282*s**2 + s*(160*C - 2606) + 1141)) + 2*Dd**2*f**2*(-160*C*(6*r*(2*s - 1) - 3*s + 2) + 1944*r*(2*s - 1) + 6846*s**2 - 7818*s + 1789)))/(693*d**2*k1*k3**2) - 2*D1**2*Pk1*Pk3*ct**3*k2*(-132*b1**2*(C - 1)*(D1*Dd*(2*f*(-4*r*s + 2*r + s) + fd*(8*r*s - 6*r - s + 1)) - D1*(D1*r*(2*fd - fdd)*(s - 1) + Ddd*f*(-4*r*s + 2*r + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 33*b1*(D1**2*(f*(4*bdd1*s*(-2*C*r + C + 2*r - 1) + fd*(4*C*(18*r**2 + 2*r*(8*s - 13) - 8*s + 9) - 36*r**2 - 36*r*(s - 2) + 132*s**2 - 100*s + 39) + fdd*(4*C*(2*r**2 + r*(3 - 10*s) + 5*s + 1) - 4*r**2 + 4*r*(5*s - 1) - 132*s**2 + 112*s - 69)) + 4*fd**2*(C*(2*r**2 - 10*r*s + 3*r + 5*s - 5) - r**2 + r*(5*s - 1) - 33*s**2 + 28*s + 5)) - 4*D1*bd1*(C - 1)*(D1*(2*f*s*(1 - 2*r) + fd*r*(4*s - 2) - fd*s + fd) + 2*Dd*f*(r*(8*s - 2) - 3*s + 1)) + 2*D1*f*(Dd*(f*(2*C*(36*r**2 + 32*r*s - 34*r - 8*s + 9) - 36*r**2 - 36*r*s + 36*r + 132*s**2 - 123*s + 57) + 2*fd*(C*(16*r**2 - 80*r*s + 28*r + 30*s - 13) - 8*r**2 + 40*r*s - 12*r - 264*s**2 + 239*s - 55)) + Ddd*f*(2*C*(4*r**2 - 20*r*s + 8*r + 5*s + 1) - 4*r**2 + 20*r*s - 8*r - 132*s**2 + 127*s - 67)) + 2*Dd**2*f**2*(2*C*(12*r**2 - 60*r*s + 24*r + 15*s - 10) - 12*r**2 + 12*r*(5*s - 2) - 396*s**2 + 381*s - 56)) - f*(132*D1**2*bd1**2*s*(C - 1)*(2*r - 1) - 33*D1**2*bdd1*f*(r**2*(4*C - 2) - 2*r*(s*(10*C - 5) + 1) - 66*s**2 + 10*s + 1) + 2*D1**2*(f*(fd*(2*C*(687*r**2 + 396*r*s - 590*r - 132*s + 229) - 1374*r**2 - 1887*r*s + 1545*r - 2772*s**2 + 2477*s - 1382) + fdd*(C*(6*r**2 - 792*r*s + 260*r + 264*s + 2) - 6*r**2 + 1587*r*s - 525*r + 2772*s**2 - 2377*s + 922)) + fd**2*(4*C*(3*r**2 - 396*r*s + 130*r + 132*s - 66) - 12*r**2 + 6*r*(529*s - 175) + 5544*s**2 - 4754*s + 529)) - 33*D1*bd1*(D1*(f*(r**2*(36*C - 18) + 2*r*(16*C*s - 9*s - 9) + 66*s**2 - 14*s + 9) + 2*fd*(10*C*s + r**2*(8*C - 4) + r*(-40*C*s + 6*C + 20*s - 4) - 132*s**2 + 66*s - 5)) + 2*Dd*f*(10*C*s + r**2*(16*C - 8) - 4*r*(20*C*s - 4*C - 10*s + 3) - 264*s**2 + 147*s - 9)) + 2*D1*f*(Dd*(f*(2*C*(916*r**2 + r*(528*s - 722) - 132*s + 229) - 1832*r**2 + r*(2174 - 2516*s) - 3696*s**2 + 4325*s - 2306) + fd*(4*C*(12*r**2 + r*(653 - 1584*s) + 462*s - 197) - 48*r**2 + 6*r*(2116*s - 877) + 22176*s**2 - 22183*s + 5279)) + Ddd*f*(2*C*(4*r**2 + r*(262 - 528*s) + 132*s + 1) - 8*r**2 + 2*r*(1058*s - 527) + 3696*s**2 - 4225*s + 1846)) + 2*Dd**2*f**2*(12*C*(2*r**2 + r*(131 - 264*s) + 66*s - 44) - 24*r**2 + 6*r*(1058*s - 527) + 11088*s**2 - 12675*s + 2906)))/(693*d**2*k1*k3**2) - 8*D1**2*Pk1*Pk3*ct**3*st**2*(D1*f*s*(-2*D1*bd1**2*s - D1*bdd1*f*s + 2*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*f*(2 - 4*s))) + b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(fd*(4*s**2 - 4*s + 2) + fdd*(-2*s**2 + 2*s - 1) + s**2*(4*bd1 - 2*bdd1)) - 2*fd*s*(2*bd1 + fd)*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(2*bd1*s + fd*(2*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(7*d**2*k1*k2) + 2*D1**2*Pk1*Pk3*ct**3*(-2*D1*f*(47*D1*bd1**2*s**2 + 2*D1*bdd1*f*s*(-2*C*r + r + 10*s) + bd1*(D1*f*s*(r*(8*C - 4) - 25*s) - 2*D1*fd*(r*(2*C - 1)*(4*s - 1) + s*(-2*C - 40*s + 21)) - Dd*f*r*(8*C - 4)*(4*s - 1) + 2*Dd*f*s*(2*C + 80*s - 41))) + b1**2*(D1**2*(59*fd - 47*fdd)*(s - 1)**2 + 2*D1*(59*Dd*f*(2*s**2 - 2*s + 1) - 94*Dd*fd*(2*s**2 - 3*s + 1) - 47*Ddd*f*(2*s**2 - 2*s + 1)) - 94*Dd**2*f*(6*s**2 - 6*s + 1)) - 2*b1*(D1**2*(f*(fd*(-8*C*s + r*(8*C - 4)*(2*s - 1) - 50*s**2 + 54*s - 25) + fdd*(4*C*s + r*(-8*C*s + 4*C + 4*s - 2) + 40*s**2 - 42*s + 20) + s**2*(-59*bd1 + 47*bdd1)) + 2*fd*(47*bd1*s*(s - 1) + fd*(2*C*(-2*r*s + r + s - 1) + 2*r*s - r + 20*s**2 - 21*s + 1))) + 2*D1*f*(Dd*(f*(-4*C*s + r*(8*C - 4)*(2*s - 1) - 50*s**2 + 52*s - 25) + (2*s - 1)*(94*bd1*s + fd*(-16*C*r + 6*C + 8*r + 80*s - 43))) + Ddd*f*(2*C*s + r*(-8*C*s + 4*C + 4*s - 2) + 40*s**2 - 41*s + 20)) + 2*Dd**2*f**2*(C*(r*(12 - 24*s) + 6*s - 4) + 6*r*(2*s - 1) + 120*s**2 - 123*s + 22)))/(21*d**2*k1*k2) - 2*D1**2*Pk1*Pk3*ct**3*k2**3*st**2*(66*D1**2*b1*f*fd*r**2 + 66*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*fd**2*r**2 + 33*D1**2*bdd1*f**2*(r - 1)**2 - 471*D1**2*f**2*fd*r**2 + 314*D1**2*f**2*fd*r - 157*D1**2*f**2*fd + 483*D1**2*f**2*fdd*r**2 - 322*D1**2*f**2*fdd*r + 161*D1**2*f**2*fdd + 966*D1**2*f*fd**2*r**2 - 644*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 + 528*D1*Dd*b1*f*fd*r**2 - 132*D1*Dd*b1*f*fd*r - 628*D1*Dd*f**3*r**2 + 314*D1*Dd*f**3*r - 157*D1*Dd*f**3 + 3864*D1*Dd*f**2*fd*r**2 - 2254*D1*Dd*f**2*fd*r + 322*D1*Dd*f**2*fd + 132*D1*Ddd*b1*f**2*r**2 - 66*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2 + 644*D1*Ddd*f**3*r**2 - 322*D1*Ddd*f**3*r + 161*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) + 4*D1*fd*r + 2*Dd*f*(4*r - 1)) + 396*Dd**2*b1*f**2*r**2 - 198*Dd**2*b1*f**2*r + 1932*Dd**2*f**3*r**2 - 966*Dd**2*f**3*r)/(693*d**2*k1**3*k3**2) - 2*D1**2*Pk1*Pk3*ct**3*k2**3*(D1*f*r*(-22*D1*bd1**2*(4*f + 5)*(r - 1) + D1*bdd1*f*r*(24*f + 11) + bd1*(3*D1*f*r*(72*f + 55) + 2*D1*fd*(24*f*(3*r - 1) + 22*r - 11) + 2*Dd*f*(24*f + 11)*(4*r - 1))) + 11*b1**2*(D1**2*r**2*(-8*fd**2 + fd*(40*f + 17) - fdd*(8*f + 5)) + D1*(Dd*(20*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(68 - 64*fd) + r*(16*fd - 34) + 17) + 10*fd*r*(1 - 4*r)) - Ddd*f*(4*f + 5)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(4*f + 5)*(2*r - 1)) + b1*(-11*D1**2*bdd1*f*(4*f + 5)*(2*r**2 - 2*r + 1) + 648*D1**2*f**2*fd*r**2 - 432*D1**2*f**2*fd*r + 216*D1**2*f**2*fd + 72*D1**2*f**2*fdd*r**2 - 48*D1**2*f**2*fdd*r + 24*D1**2*f**2*fdd + 144*D1**2*f*fd**2*r**2 - 96*D1**2*f*fd**2*r + 330*D1**2*f*fd*r**2 - 330*D1**2*f*fd*r + 165*D1**2*f*fd + 22*D1**2*f*fdd*r**2 - 22*D1**2*f*fdd*r + 11*D1**2*f*fdd + 22*D1**2*fd**2*r**2 - 22*D1**2*fd**2*r + 864*D1*Dd*f**3*r**2 - 432*D1*Dd*f**3*r + 216*D1*Dd*f**3 + 576*D1*Dd*f**2*fd*r**2 - 336*D1*Dd*f**2*fd*r + 48*D1*Dd*f**2*fd + 660*D1*Dd*f**2*r**2 - 330*D1*Dd*f**2*r + 165*D1*Dd*f**2 + 176*D1*Dd*f*fd*r**2 - 132*D1*Dd*f*fd*r + 22*D1*Dd*f*fd + 96*D1*Ddd*f**3*r**2 - 48*D1*Ddd*f**3*r + 24*D1*Ddd*f**3 + 44*D1*Ddd*f**2*r**2 - 22*D1*Ddd*f**2*r + 11*D1*Ddd*f**2 + 11*D1*bd1*(D1*(20*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(34 - 32*fd) + r*(16*fd - 34) + 17) + 10*fd*r*(1 - 2*r)) - 2*Dd*f*(4*f + 5)*(8*r**2 - 6*r + 1)) + 288*Dd**2*f**3*r**2 - 144*Dd**2*f**3*r + 132*Dd**2*f**2*r**2 - 66*Dd**2*f**2*r))/(231*d**2*k1**3*k3**2) - 2*D1**2*Pk1*Pk3*ct**3*k2*(D1*f*r*(-10*D1*bd1**2*(r - 1) + D1*bdd1*f*r + bd1*(15*D1*f*r + D1*fd*(4*r - 2) + 2*Dd*f*(4*r - 1))) + b1**2*(D1**2*r**2*(17*fd - 5*fdd) + D1*(17*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*r*(1 - 4*r) - 5*Ddd*f*(4*r**2 - 2*r + 1)) + 30*Dd**2*f*r*(1 - 2*r)) + b1*(-5*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 30*D1**2*f*fd*r**2 - 30*D1**2*f*fd*r + 15*D1**2*f*fd + 2*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r + D1**2*f*fdd + 2*D1**2*fd**2*r**2 - 2*D1**2*fd**2*r + 60*D1*Dd*f**2*r**2 - 30*D1*Dd*f**2*r + 15*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 - 12*D1*Dd*f*fd*r + 2*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 - 2*D1*Ddd*f**2*r + D1*Ddd*f**2 + D1*bd1*(17*D1*f*(2*r**2 - 2*r + 1) + 10*D1*fd*r*(1 - 2*r) - 10*Dd*f*(8*r**2 - 6*r + 1)) + 12*Dd**2*f**2*r**2 - 6*Dd**2*f**2*r))/(21*d**2*k1**3) - 8*D1**2*Pk1*Pk3*ct**2*f*k1**2*k2**4*st**4*(66*D1**2*bd1*f*(5*C - 4)*(r + s - 1)**2 + 66*D1*b1*(5*C - 4)*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + (122*C - 87)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**8) - 16*D1**2*Pk1*Pk3*ct**2*f*k1**2*k2**2*st**4*(D1**2*(f*(11*bd1*s*(4*C - 3)*(r + s - 1) + fd*(64*C - 44)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(32*C - 22)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(22 - 32*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*b1*(4*C - 3)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + D1*f*(32*C - 22)*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(22 - 32*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4))/(77*d**2*k3**6) - D1**2*Pk1*Pk3*ct**2*f*k1**2*st**4*(576*C - 376)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + 2*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1))/(231*d**2*k3**4) - 40*D1**2*Pk1*Pk3*ct**2*f*k2**6*st**4*(468*D1**2*b1*f*fd*r**2 + 468*D1**2*b1*f*fd*r*s - 312*D1**2*b1*f*fd*r - 234*D1**2*b1*f*fdd*r**2 - 234*D1**2*b1*f*fdd*r*s + 156*D1**2*b1*f*fdd*r - 468*D1**2*b1*fd**2*r**2 - 468*D1**2*b1*fd**2*r*s + 312*D1**2*b1*fd**2*r - 78*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 284*D1**2*f**2*fd*r**2 + 284*D1**2*f**2*fd*r*s - 284*D1**2*f**2*fd*r - 71*D1**2*f**2*fd*s + 71*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s - 3*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 36*D1**2*f*fd**2*r + 9*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 + 624*D1*Dd*b1*f**2*r**2 + 624*D1*Dd*b1*f**2*r*s - 624*D1*Dd*b1*f**2*r - 156*D1*Dd*b1*f**2*s + 156*D1*Dd*b1*f**2 - 1872*D1*Dd*b1*f*fd*r**2 - 1872*D1*Dd*b1*f*fd*r*s + 1560*D1*Dd*b1*f*fd*r + 234*D1*Dd*b1*f*fd*s - 156*D1*Dd*b1*f*fd + 284*D1*Dd*f**3*r**2 + 284*D1*Dd*f**3*r*s - 284*D1*Dd*f**3*r - 71*D1*Dd*f**3*s + 71*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 96*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s - 18*D1*Dd*f**2*fd - 312*D1*Ddd*b1*f**2*r**2 - 312*D1*Ddd*b1*f**2*r*s + 312*D1*Ddd*b1*f**2*r + 78*D1*Ddd*b1*f**2*s - 78*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 12*D1*Ddd*f**3*r*s + 12*D1*Ddd*f**3*r + 3*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 78*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 936*Dd**2*b1*f**2*r**2 - 936*Dd**2*b1*f**2*r*s + 936*Dd**2*b1*f**2*r + 234*Dd**2*b1*f**2*s - 156*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 36*Dd**2*f**3*r*s + 36*Dd**2*f**3*r + 9*Dd**2*f**3*s - 6*Dd**2*f**3)/(3003*d**2*k1**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**2*f*k2**2*st**4*(D1*Dd*f*(-5*fd*(2*r*(12*s - 5) - 7*s + 3) + (66*b1 + 10*f)*(r*(4*s - 2) - s)) + D1*(D1*(f*(66*bd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1) + 2*fd*(33*b1*r*(2*s - 1) + 5*f*r*(3*s - 1) - 5*f*s)) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2))/(231*d**2*k1**2*k3**2) - D1**2*Pk1*Pk3*ct**2*k1**6*(16*C - 8)*(264*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r + 264*D1**2*b1*f*fd*s**2 - 264*D1**2*b1*f*fd*s + 132*D1**2*b1*f*fd - 330*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 330*D1**2*b1*f*fdd*s**2 + 330*D1**2*b1*f*fdd*s - 165*D1**2*b1*f*fdd - 330*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r - 330*D1**2*b1*fd**2*s**2 + 330*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)**2 + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 792*D1*Dd*b1*f**2*r + 528*D1*Dd*b1*f**2*s**2 - 792*D1*Dd*b1*f**2*s + 396*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 3300*D1*Dd*b1*f*fd*r - 2640*D1*Dd*b1*f*fd*s**2 + 3300*D1*Dd*b1*f*fd*s - 990*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 690*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 690*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 990*D1*Ddd*b1*f**2*r - 660*D1*Ddd*b1*f**2*s**2 + 990*D1*Ddd*b1*f**2*s - 495*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 1980*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 2970*Dd**2*b1*f**2*r - 1980*Dd**2*b1*f**2*s**2 + 2970*Dd**2*b1*f**2*s - 990*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3)/(231*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**2*k1**4*k2**2*st**2*(5742*C*D1**2*b1*f*fd*r**2 + 11484*C*D1**2*b1*f*fd*r*s - 5742*C*D1**2*b1*f*fd*r + 5742*C*D1**2*b1*f*fd*s**2 - 5742*C*D1**2*b1*f*fd*s + 2871*C*D1**2*b1*f*fd - 4026*C*D1**2*b1*f*fdd*r**2 - 8052*C*D1**2*b1*f*fdd*r*s + 4026*C*D1**2*b1*f*fdd*r - 4026*C*D1**2*b1*f*fdd*s**2 + 4026*C*D1**2*b1*f*fdd*s - 2013*C*D1**2*b1*f*fdd - 4026*C*D1**2*b1*fd**2*r**2 - 8052*C*D1**2*b1*fd**2*r*s + 4026*C*D1**2*b1*fd**2*r - 4026*C*D1**2*b1*fd**2*s**2 + 4026*C*D1**2*b1*fd**2*s + 5685*C*D1**2*f**2*fd*r**2 + 11370*C*D1**2*f**2*fd*r*s - 7580*C*D1**2*f**2*fd*r + 5685*C*D1**2*f**2*fd*s**2 - 7580*C*D1**2*f**2*fd*s + 3790*C*D1**2*f**2*fd - 4575*C*D1**2*f**2*fdd*r**2 - 9150*C*D1**2*f**2*fdd*r*s + 6100*C*D1**2*f**2*fdd*r - 4575*C*D1**2*f**2*fdd*s**2 + 6100*C*D1**2*f**2*fdd*s - 3050*C*D1**2*f**2*fdd - 9150*C*D1**2*f*fd**2*r**2 - 18300*C*D1**2*f*fd**2*r*s + 12200*C*D1**2*f*fd**2*r - 9150*C*D1**2*f*fd**2*s**2 + 12200*C*D1**2*f*fd**2*s - 3050*C*D1**2*f*fd**2 + 11484*C*D1*Dd*b1*f**2*r**2 + 22968*C*D1*Dd*b1*f**2*r*s - 17226*C*D1*Dd*b1*f**2*r + 11484*C*D1*Dd*b1*f**2*s**2 - 17226*C*D1*Dd*b1*f**2*s + 8613*C*D1*Dd*b1*f**2 - 32208*C*D1*Dd*b1*f*fd*r**2 - 64416*C*D1*Dd*b1*f*fd*r*s + 40260*C*D1*Dd*b1*f*fd*r - 32208*C*D1*Dd*b1*f*fd*s**2 + 40260*C*D1*Dd*b1*f*fd*s - 12078*C*D1*Dd*b1*f*fd + 7580*C*D1*Dd*f**3*r**2 + 15160*C*D1*Dd*f**3*r*s - 11370*C*D1*Dd*f**3*r + 7580*C*D1*Dd*f**3*s**2 - 11370*C*D1*Dd*f**3*s + 5685*C*D1*Dd*f**3 - 36600*C*D1*Dd*f**2*fd*r**2 - 73200*C*D1*Dd*f**2*fd*r*s + 51850*C*D1*Dd*f**2*fd*r - 36600*C*D1*Dd*f**2*fd*s**2 + 51850*C*D1*Dd*f**2*fd*s - 18300*C*D1*Dd*f**2*fd - 8052*C*D1*Ddd*b1*f**2*r**2 - 16104*C*D1*Ddd*b1*f**2*r*s + 12078*C*D1*Ddd*b1*f**2*r - 8052*C*D1*Ddd*b1*f**2*s**2 + 12078*C*D1*Ddd*b1*f**2*s - 6039*C*D1*Ddd*b1*f**2 - 6100*C*D1*Ddd*f**3*r**2 - 12200*C*D1*Ddd*f**3*r*s + 9150*C*D1*Ddd*f**3*r - 6100*C*D1*Ddd*f**3*s**2 + 9150*C*D1*Ddd*f**3*s - 4575*C*D1*Ddd*f**3 - 24156*C*Dd**2*b1*f**2*r**2 - 48312*C*Dd**2*b1*f**2*r*s + 36234*C*Dd**2*b1*f**2*r - 24156*C*Dd**2*b1*f**2*s**2 + 36234*C*Dd**2*b1*f**2*s - 12078*C*Dd**2*b1*f**2 - 18300*C*Dd**2*f**3*r**2 - 36600*C*Dd**2*f**3*r*s + 27450*C*Dd**2*f**3*r - 18300*C*Dd**2*f**3*s**2 + 27450*C*Dd**2*f**3*s - 9150*C*Dd**2*f**3 - 3432*D1**2*b1*f*fd*r**2 - 6864*D1**2*b1*f*fd*r*s + 3432*D1**2*b1*f*fd*r - 3432*D1**2*b1*f*fd*s**2 + 3432*D1**2*b1*f*fd*s - 1716*D1**2*b1*f*fd + 2442*D1**2*b1*f*fdd*r**2 + 4884*D1**2*b1*f*fdd*r*s - 2442*D1**2*b1*f*fdd*r + 2442*D1**2*b1*f*fdd*s**2 - 2442*D1**2*b1*f*fdd*s + 1221*D1**2*b1*f*fdd + 2442*D1**2*b1*fd**2*r**2 + 4884*D1**2*b1*fd**2*r*s - 2442*D1**2*b1*fd**2*r + 2442*D1**2*b1*fd**2*s**2 - 2442*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(61*C - 37)*(r + s - 1)**2 - 3372*D1**2*f**2*fd*r**2 - 6744*D1**2*f**2*fd*r*s + 4496*D1**2*f**2*fd*r - 3372*D1**2*f**2*fd*s**2 + 4496*D1**2*f**2*fd*s - 2248*D1**2*f**2*fd + 2775*D1**2*f**2*fdd*r**2 + 5550*D1**2*f**2*fdd*r*s - 3700*D1**2*f**2*fdd*r + 2775*D1**2*f**2*fdd*s**2 - 3700*D1**2*f**2*fdd*s + 1850*D1**2*f**2*fdd + 5550*D1**2*f*fd**2*r**2 + 11100*D1**2*f*fd**2*r*s - 7400*D1**2*f*fd**2*r + 5550*D1**2*f*fd**2*s**2 - 7400*D1**2*f*fd**2*s + 1850*D1**2*f*fd**2 - 6864*D1*Dd*b1*f**2*r**2 - 13728*D1*Dd*b1*f**2*r*s + 10296*D1*Dd*b1*f**2*r - 6864*D1*Dd*b1*f**2*s**2 + 10296*D1*Dd*b1*f**2*s - 5148*D1*Dd*b1*f**2 + 19536*D1*Dd*b1*f*fd*r**2 + 39072*D1*Dd*b1*f*fd*r*s - 24420*D1*Dd*b1*f*fd*r + 19536*D1*Dd*b1*f*fd*s**2 - 24420*D1*Dd*b1*f*fd*s + 7326*D1*Dd*b1*f*fd - 4496*D1*Dd*f**3*r**2 - 8992*D1*Dd*f**3*r*s + 6744*D1*Dd*f**3*r - 4496*D1*Dd*f**3*s**2 + 6744*D1*Dd*f**3*s - 3372*D1*Dd*f**3 + 22200*D1*Dd*f**2*fd*r**2 + 44400*D1*Dd*f**2*fd*r*s - 31450*D1*Dd*f**2*fd*r + 22200*D1*Dd*f**2*fd*s**2 - 31450*D1*Dd*f**2*fd*s + 11100*D1*Dd*f**2*fd + 4884*D1*Ddd*b1*f**2*r**2 + 9768*D1*Ddd*b1*f**2*r*s - 7326*D1*Ddd*b1*f**2*r + 4884*D1*Ddd*b1*f**2*s**2 - 7326*D1*Ddd*b1*f**2*s + 3663*D1*Ddd*b1*f**2 + 3700*D1*Ddd*f**3*r**2 + 7400*D1*Ddd*f**3*r*s - 5550*D1*Ddd*f**3*r + 3700*D1*Ddd*f**3*s**2 - 5550*D1*Ddd*f**3*s + 2775*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(87*C - 52)*(r + s - 1) - D1*fd*(122*C - 74)*(2*r + 2*s - 1) - Dd*f*(122*C - 74)*(4*r + 4*s - 3)) + 14652*Dd**2*b1*f**2*r**2 + 29304*Dd**2*b1*f**2*r*s - 21978*Dd**2*b1*f**2*r + 14652*Dd**2*b1*f**2*s**2 - 21978*Dd**2*b1*f**2*s + 7326*Dd**2*b1*f**2 + 11100*Dd**2*f**3*r**2 + 22200*Dd**2*f**3*r*s - 16650*Dd**2*f**3*r + 11100*Dd**2*f**3*s**2 - 16650*Dd**2*f**3*s + 5550*Dd**2*f**3)/(231*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct**2*k1**4*k2**2*(-12870*C*D1**2*f**2*fd*r**2 - 25740*C*D1**2*f**2*fd*r*s + 17160*C*D1**2*f**2*fd*r - 12870*C*D1**2*f**2*fd*s**2 + 17160*C*D1**2*f**2*fd*s - 8580*C*D1**2*f**2*fd - 17160*C*D1*Dd*f**3*r**2 - 34320*C*D1*Dd*f**3*r*s + 25740*C*D1*Dd*f**3*r - 17160*C*D1*Dd*f**3*s**2 + 25740*C*D1*Dd*f**3*s - 12870*C*D1*Dd*f**3 - 32175*D1**2*K*bdd1*f**2*r**2 - 64350*D1**2*K*bdd1*f**2*r*s + 64350*D1**2*K*bdd1*f**2*r - 32175*D1**2*K*bdd1*f**2*s**2 + 64350*D1**2*K*bdd1*f**2*s - 32175*D1**2*K*bdd1*f**2 + 4290*D1**2*bd1**2*f*(-18*K + 5*f + 6)*(r + s - 1)**2 + 7280*D1**2*bdd1*f**3*r**2 + 14560*D1**2*bdd1*f**3*r*s - 14560*D1**2*bdd1*f**3*r + 7280*D1**2*bdd1*f**3*s**2 - 14560*D1**2*bdd1*f**3*s + 7280*D1**2*bdd1*f**3 + 10725*D1**2*bdd1*f**2*r**2 + 21450*D1**2*bdd1*f**2*r*s - 21450*D1**2*bdd1*f**2*r + 10725*D1**2*bdd1*f**2*s**2 - 21450*D1**2*bdd1*f**2*s + 10725*D1**2*bdd1*f**2 + 77220*D1**2*bdd1*f*g2*r**2 + 154440*D1**2*bdd1*f*g2*r*s - 154440*D1**2*bdd1*f*g2*r + 77220*D1**2*bdd1*f*g2*s**2 - 154440*D1**2*bdd1*f*g2*s + 77220*D1**2*bdd1*f*g2 + 5320*D1**2*f**3*fd*r**2 + 10640*D1**2*f**3*fd*r*s - 7980*D1**2*f**3*fd*r + 5320*D1**2*f**3*fd*s**2 - 7980*D1**2*f**3*fd*s + 3990*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 + 6435*D1**2*f**2*fd*r**2 + 12870*D1**2*f**2*fd*r*s - 8580*D1**2*f**2*fd*r + 6435*D1**2*f**2*fd*s**2 - 8580*D1**2*f**2*fd*s + 4290*D1**2*f**2*fd - 56628*D1**2*f**2*gd2*r**2 - 113256*D1**2*f**2*gd2*r*s + 113256*D1**2*f**2*gd2*r - 56628*D1**2*f**2*gd2*s**2 + 113256*D1**2*f**2*gd2*s - 56628*D1**2*f**2*gd2 + 64350*D1**2*f**2*gdd2*r**2 + 128700*D1**2*f**2*gdd2*r*s - 128700*D1**2*f**2*gdd2*r + 64350*D1**2*f**2*gdd2*s**2 - 128700*D1**2*f**2*gdd2*s + 64350*D1**2*f**2*gdd2 - 113256*D1**2*f*fd*g2*r**2 - 226512*D1**2*f*fd*g2*r*s + 113256*D1**2*f*fd*g2*r - 113256*D1**2*f*fd*g2*s**2 + 113256*D1**2*f*fd*g2*s - 56628*D1**2*f*fd*g2 + 257400*D1**2*f*fd*gd2*r**2 + 514800*D1**2*f*fd*gd2*r*s - 386100*D1**2*f*fd*gd2*r + 257400*D1**2*f*fd*gd2*s**2 - 386100*D1**2*f*fd*gd2*s + 128700*D1**2*f*fd*gd2 + 128700*D1**2*f*fdd*g2*r**2 + 257400*D1**2*f*fdd*g2*r*s - 128700*D1**2*f*fdd*g2*r + 128700*D1**2*f*fdd*g2*s**2 - 128700*D1**2*f*fdd*g2*s + 64350*D1**2*f*fdd*g2 + 128700*D1**2*fd**2*g2*r**2 + 257400*D1**2*fd**2*g2*r*s - 128700*D1**2*fd**2*g2*r + 128700*D1**2*fd**2*g2*s**2 - 128700*D1**2*fd**2*g2*s + 5320*D1*Dd*f**4*r**2 + 10640*D1*Dd*f**4*r*s - 7980*D1*Dd*f**4*r + 5320*D1*Dd*f**4*s**2 - 7980*D1*Dd*f**4*s + 3990*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd + 8580*D1*Dd*f**3*r**2 + 17160*D1*Dd*f**3*r*s - 12870*D1*Dd*f**3*r + 8580*D1*Dd*f**3*s**2 - 12870*D1*Dd*f**3*s + 6435*D1*Dd*f**3 - 226512*D1*Dd*f**2*g2*r**2 - 453024*D1*Dd*f**2*g2*r*s + 339768*D1*Dd*f**2*g2*r - 226512*D1*Dd*f**2*g2*s**2 + 339768*D1*Dd*f**2*g2*s - 169884*D1*Dd*f**2*g2 + 514800*D1*Dd*f**2*gd2*r**2 + 1029600*D1*Dd*f**2*gd2*r*s - 900900*D1*Dd*f**2*gd2*r + 514800*D1*Dd*f**2*gd2*s**2 - 900900*D1*Dd*f**2*gd2*s + 386100*D1*Dd*f**2*gd2 + 1029600*D1*Dd*f*fd*g2*r**2 + 2059200*D1*Dd*f*fd*g2*r*s - 1287000*D1*Dd*f*fd*g2*r + 1029600*D1*Dd*f*fd*g2*s**2 - 1287000*D1*Dd*f*fd*g2*s + 386100*D1*Dd*f*fd*g2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 257400*D1*Ddd*f**2*g2*r**2 + 514800*D1*Ddd*f**2*g2*r*s - 386100*D1*Ddd*f**2*g2*r + 257400*D1*Ddd*f**2*g2*s**2 - 386100*D1*Ddd*f**2*g2*s + 193050*D1*Ddd*f**2*g2 - 26*D1*bd1*(D1*(230*f**3*(r + s - 1) + f**2*(198*C*(r + s - 1) - 560*fd*(3*r + 3*s - 2) - (1089*K - 231)*(r + s - 1)) + 33*f*(25*fd*(3*K - 1)*(2*r + 2*s - 1) + (82*g2 - 180*gd2)*(r + s - 1)) - 5940*fd*g2*(r + s)) - 5*Dd*f*(112*f**2 - 165*f*(3*K - 1) + 1188*g2)*(4*r + 4*s - 3))*(r + s - 1) - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 772200*Dd**2*f**2*g2*r**2 + 1544400*Dd**2*f**2*g2*r*s - 1158300*Dd**2*f**2*g2*r + 772200*Dd**2*f**2*g2*s**2 - 1158300*Dd**2*f**2*g2*s + 386100*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(5*f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + fd*(82*K - 25)*(r + s) - 30*fdd*(3*K - 1)*(r + s))) + D1*(Dd*(20*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(50*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (82*K - 25)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*fd*(3*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 5*Ddd*f*(-18*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f*(-18*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 13*b1*(792*C*D1**2*f*fd*r**2 + 1584*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 792*C*D1**2*f*fd*s**2 - 792*C*D1**2*f*fd*s + 396*C*D1**2*f*fd + 1584*C*D1*Dd*f**2*r**2 + 3168*C*D1*Dd*f**2*r*s - 2376*C*D1*Dd*f**2*r + 1584*C*D1*Dd*f**2*s**2 - 2376*C*D1*Dd*f**2*s + 1188*C*D1*Dd*f**2 - 4356*D1**2*K*f*fd*r**2 - 8712*D1**2*K*f*fd*r*s + 4356*D1**2*K*f*fd*r - 4356*D1**2*K*f*fd*s**2 + 4356*D1**2*K*f*fd*s - 2178*D1**2*K*f*fd + 4950*D1**2*K*f*fdd*r**2 + 9900*D1**2*K*f*fdd*r*s - 4950*D1**2*K*f*fdd*r + 4950*D1**2*K*f*fdd*s**2 - 4950*D1**2*K*f*fdd*s + 2475*D1**2*K*f*fdd + 4950*D1**2*K*fd**2*r**2 + 9900*D1**2*K*fd**2*r*s - 4950*D1**2*K*fd**2*r + 4950*D1**2*K*fd**2*s**2 - 4950*D1**2*K*fd**2*s - 330*D1**2*bdd1*f*(-18*K + 5*f + 6)*(r + s - 1)**2 + 1380*D1**2*f**2*fd*r**2 + 2760*D1**2*f**2*fd*r*s - 1840*D1**2*f**2*fd*r + 1380*D1**2*f**2*fd*s**2 - 1840*D1**2*f**2*fd*s + 920*D1**2*f**2*fd - 1680*D1**2*f**2*fdd*r**2 - 3360*D1**2*f**2*fdd*r*s + 2240*D1**2*f**2*fdd*r - 1680*D1**2*f**2*fdd*s**2 + 2240*D1**2*f**2*fdd*s - 1120*D1**2*f**2*fdd - 3360*D1**2*f*fd**2*r**2 - 6720*D1**2*f*fd**2*r*s + 4480*D1**2*f*fd**2*r - 3360*D1**2*f*fd**2*s**2 + 4480*D1**2*f*fd**2*s - 1120*D1**2*f*fd**2 + 924*D1**2*f*fd*r**2 + 1848*D1**2*f*fd*r*s - 924*D1**2*f*fd*r + 924*D1**2*f*fd*s**2 - 924*D1**2*f*fd*s + 462*D1**2*f*fd - 1650*D1**2*f*fdd*r**2 - 3300*D1**2*f*fdd*r*s + 1650*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1650*D1**2*f*fdd*s - 825*D1**2*f*fdd + 5412*D1**2*f*gd2*r**2 + 10824*D1**2*f*gd2*r*s - 10824*D1**2*f*gd2*r + 5412*D1**2*f*gd2*s**2 - 10824*D1**2*f*gd2*s + 5412*D1**2*f*gd2 - 5940*D1**2*f*gdd2*r**2 - 11880*D1**2*f*gdd2*r*s + 11880*D1**2*f*gdd2*r - 5940*D1**2*f*gdd2*s**2 + 11880*D1**2*f*gdd2*s - 5940*D1**2*f*gdd2 - 1650*D1**2*fd**2*r**2 - 3300*D1**2*fd**2*r*s + 1650*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1650*D1**2*fd**2*s + 5412*D1**2*fd*g2*r**2 + 10824*D1**2*fd*g2*r*s + 5412*D1**2*fd*g2*s**2 - 11880*D1**2*fd*gd2*r**2 - 23760*D1**2*fd*gd2*r*s + 11880*D1**2*fd*gd2*r - 11880*D1**2*fd*gd2*s**2 + 11880*D1**2*fd*gd2*s - 5940*D1**2*fdd*g2*r**2 - 11880*D1**2*fdd*g2*r*s - 5940*D1**2*fdd*g2*s**2 - 8712*D1*Dd*K*f**2*r**2 - 17424*D1*Dd*K*f**2*r*s + 13068*D1*Dd*K*f**2*r - 8712*D1*Dd*K*f**2*s**2 + 13068*D1*Dd*K*f**2*s - 6534*D1*Dd*K*f**2 + 39600*D1*Dd*K*f*fd*r**2 + 79200*D1*Dd*K*f*fd*r*s - 49500*D1*Dd*K*f*fd*r + 39600*D1*Dd*K*f*fd*s**2 - 49500*D1*Dd*K*f*fd*s + 14850*D1*Dd*K*f*fd + 1840*D1*Dd*f**3*r**2 + 3680*D1*Dd*f**3*r*s - 2760*D1*Dd*f**3*r + 1840*D1*Dd*f**3*s**2 - 2760*D1*Dd*f**3*s + 1380*D1*Dd*f**3 - 13440*D1*Dd*f**2*fd*r**2 - 26880*D1*Dd*f**2*fd*r*s + 19040*D1*Dd*f**2*fd*r - 13440*D1*Dd*f**2*fd*s**2 + 19040*D1*Dd*f**2*fd*s - 6720*D1*Dd*f**2*fd + 1848*D1*Dd*f**2*r**2 + 3696*D1*Dd*f**2*r*s - 2772*D1*Dd*f**2*r + 1848*D1*Dd*f**2*s**2 - 2772*D1*Dd*f**2*s + 1386*D1*Dd*f**2 - 13200*D1*Dd*f*fd*r**2 - 26400*D1*Dd*f*fd*r*s + 16500*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 16500*D1*Dd*f*fd*s - 4950*D1*Dd*f*fd + 21648*D1*Dd*f*g2*r**2 + 43296*D1*Dd*f*g2*r*s - 32472*D1*Dd*f*g2*r + 21648*D1*Dd*f*g2*s**2 - 32472*D1*Dd*f*g2*s + 16236*D1*Dd*f*g2 - 47520*D1*Dd*f*gd2*r**2 - 95040*D1*Dd*f*gd2*r*s + 83160*D1*Dd*f*gd2*r - 47520*D1*Dd*f*gd2*s**2 + 83160*D1*Dd*f*gd2*s - 35640*D1*Dd*f*gd2 - 47520*D1*Dd*fd*g2*r**2 - 95040*D1*Dd*fd*g2*r*s + 35640*D1*Dd*fd*g2*r - 47520*D1*Dd*fd*g2*s**2 + 35640*D1*Dd*fd*g2*s + 9900*D1*Ddd*K*f**2*r**2 + 19800*D1*Ddd*K*f**2*r*s - 14850*D1*Ddd*K*f**2*r + 9900*D1*Ddd*K*f**2*s**2 - 14850*D1*Ddd*K*f**2*s + 7425*D1*Ddd*K*f**2 - 2240*D1*Ddd*f**3*r**2 - 4480*D1*Ddd*f**3*r*s + 3360*D1*Ddd*f**3*r - 2240*D1*Ddd*f**3*s**2 + 3360*D1*Ddd*f**3*s - 1680*D1*Ddd*f**3 - 3300*D1*Ddd*f**2*r**2 - 6600*D1*Ddd*f**2*r*s + 4950*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 4950*D1*Ddd*f**2*s - 2475*D1*Ddd*f**2 - 23760*D1*Ddd*f*g2*r**2 - 47520*D1*Ddd*f*g2*r*s + 35640*D1*Ddd*f*g2*r - 23760*D1*Ddd*f*g2*s**2 + 35640*D1*Ddd*f*g2*s - 17820*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(20*f**2*(r + s - 1) - 50*f*fd*(2*r + 2*s - 1) - f*(82*K - 25)*(r + s - 1) + 60*fd*(3*K - 1)*(r + s)) - 10*Dd*f*(-18*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 29700*Dd**2*K*f**2*r**2 + 59400*Dd**2*K*f**2*r*s - 44550*Dd**2*K*f**2*r + 29700*Dd**2*K*f**2*s**2 - 44550*Dd**2*K*f**2*s + 14850*Dd**2*K*f**2 - 6720*Dd**2*f**3*r**2 - 13440*Dd**2*f**3*r*s + 10080*Dd**2*f**3*r - 6720*Dd**2*f**3*s**2 + 10080*Dd**2*f**3*s - 3360*Dd**2*f**3 - 9900*Dd**2*f**2*r**2 - 19800*Dd**2*f**2*r*s + 14850*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 14850*Dd**2*f**2*s - 4950*Dd**2*f**2 - 71280*Dd**2*f*g2*r**2 - 142560*Dd**2*f*g2*r*s + 106920*Dd**2*f*g2*r - 71280*Dd**2*f*g2*s**2 + 106920*Dd**2*f*g2*s - 35640*Dd**2*f*g2))/(3003*d**2*k3**8) - D1**2*Pk1*Pk3*ct**2*k1**4*st**2*(128*C - 72)*(11*b1*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(2*s - 1)*(8*r + 8*s - 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(39*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 25*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 25*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 25*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**6) - 4*D1**2*Pk1*Pk3*ct**2*k1**4*(66*b1**2*(2*C - 1)*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(-68*C*D1**2*f*fd*r**2 - 424*C*D1**2*f*fd*r*s + 196*C*D1**2*f*fd*r - 356*C*D1**2*f*fd*s**2 + 340*C*D1**2*f*fd*s - 170*C*D1**2*f*fd + 100*C*D1**2*f*fdd*r**2 + 440*C*D1**2*f*fdd*r*s - 200*C*D1**2*f*fdd*r + 340*C*D1**2*f*fdd*s**2 - 320*C*D1**2*f*fdd*s + 160*C*D1**2*f*fdd + 100*C*D1**2*fd**2*r**2 + 440*C*D1**2*fd**2*r*s - 200*C*D1**2*fd**2*r + 340*C*D1**2*fd**2*s**2 - 320*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 136*C*D1*Dd*f**2*r**2 - 848*C*D1*Dd*f**2*r*s + 492*C*D1*Dd*f**2*r - 712*C*D1*Dd*f**2*s**2 + 924*C*D1*Dd*f**2*s - 390*C*D1*Dd*f**2 + 800*C*D1*Dd*f*fd*r**2 + 3520*C*D1*Dd*f*fd*r*s - 1880*C*D1*Dd*f*fd*r + 2720*C*D1*Dd*f*fd*s**2 - 3080*C*D1*Dd*f*fd*s + 840*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*r**2 + 880*C*D1*Ddd*f**2*r*s - 540*C*D1*Ddd*f**2*r + 680*C*D1*Ddd*f**2*s**2 - 900*C*D1*Ddd*f**2*s + 390*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*r**2 + 2640*C*Dd**2*f**2*r*s - 1620*C*Dd**2*f**2*r + 2040*C*Dd**2*f**2*s**2 - 2700*C*Dd**2*f**2*s + 780*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 34*D1**2*f*fd*r**2 + 244*D1**2*f*fd*r*s - 114*D1**2*f*fd*r + 210*D1**2*f*fd*s**2 - 202*D1**2*f*fd*s + 101*D1**2*f*fd - 50*D1**2*f*fdd*r**2 - 254*D1**2*f*fdd*r*s + 117*D1**2*f*fdd*r - 204*D1**2*f*fdd*s**2 + 194*D1**2*f*fdd*s - 97*D1**2*f*fdd - 50*D1**2*fd**2*r**2 - 254*D1**2*fd**2*r*s + 117*D1**2*fd**2*r - 204*D1**2*fd**2*s**2 + 194*D1**2*fd**2*s + 10*D1**2*fd**2 + 68*D1*Dd*f**2*r**2 + 488*D1*Dd*f**2*r*s - 278*D1*Dd*f**2*r + 420*D1*Dd*f**2*s**2 - 542*D1*Dd*f**2*s + 227*D1*Dd*f**2 - 400*D1*Dd*f*fd*r**2 - 2032*D1*Dd*f*fd*r*s + 1076*D1*Dd*f*fd*r - 1632*D1*Dd*f*fd*s**2 + 1846*D1*Dd*f*fd*s - 505*D1*Dd*f*fd - 100*D1*Ddd*f**2*r**2 - 508*D1*Ddd*f**2*r*s + 304*D1*Ddd*f**2*r - 408*D1*Ddd*f**2*s**2 + 535*D1*Ddd*f**2*s - 229*D1*Ddd*f**2 + D1*bd1*(2*C - 1)*(D1*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 12*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 300*Dd**2*f**2*r**2 - 1524*Dd**2*f**2*r*s + 912*Dd**2*f**2*r - 1224*Dd**2*f**2*s**2 + 1605*Dd**2*f**2*s - 458*Dd**2*f**2) + f*(-792*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 66*D1**2*bdd1*f*(10*C*(5*r**2 + 2*r*(11*s - 6) + 17*s**2 - 24*s + 6) - 25*r**2 + r*(60 - 127*s) - 102*s**2 + 137*s - 30) - 5*D1**2*(f*(fd*(2*C*(831*r**2 + 6*r*(653*s - 310) + 3087*s**2 - 3364*s + 1306) - 831*r**2 - 4452*r*s + 2038*r - 3621*s**2 + 3898*s - 1484) + fdd*(-2*C*(1059*r**2 + 6*r*(673*s - 342) + 2979*s**2 - 3332*s + 1346) + 1059*r**2 + 4602*r*s - 2240*r + 3543*s**2 - 3896*s + 1534)) - 2*fd**2*(2*C*(1059*r**2 + 6*r*(673*s - 342) + 2979*s**2 - 3332*s + 673) - 1059*r**2 - 4602*r*s + 2240*r - 3543*s**2 + 3896*s - 767)) - 66*D1*bd1*(D1*(f*(2*C*(17*r**2 + 106*r*s - 42*r + 89*s**2 - 114*s + 21) - 17*r**2 - 122*r*s + 42*r - 105*s**2 + 130*s - 21) + fd*(-40*C*(5*r**2 + 22*r*s - 11*r + 17*s**2 - 20*s + 6) + 100*r**2 + 508*r*s - 237*r + 408*s**2 - 468*s + 137)) + Dd*f*(-20*C*(20*r**2 + r*(88*s - 51) + 68*s**2 - 93*s + 30) + 200*r**2 + 8*r*(127*s - 68) + 816*s**2 - 1083*s + 334)) - 5*D1*f*(Dd*(f*(2*C*(1108*r**2 + 5224*r*s - 3166*r + 4116*s**2 - 5422*s + 2335) - 1108*r**2 - 5936*r*s + 3522*r - 4828*s**2 + 6312*s - 2691) + 2*fd*(-2*C*(4236*r**2 + 16152*r*s - 9201*r + 11916*s**2 - 14641*s + 4358) + 4236*r**2 + 18408*r*s - 10141*r + 14172*s**2 - 17179*s + 5016)) + Ddd*f*(-2*C*(1412*r**2 + 5384*r*s - 3398*r + 3972*s**2 - 5318*s + 2339) + 1412*r**2 + 6136*r*s - 3774*r + 4724*s**2 - 6258*s + 2715)) + 10*Dd**2*f**2*(2*C*(2118*r**2 + 8076*r*s - 5097*r + 5958*s**2 - 7977*s + 2339) - 2118*r**2 - 9204*r*s + 5661*r - 7086*s**2 + 9387*s - 2715)))/(693*d**2*k3**6) - D1**2*Pk1*Pk3*ct**2*k1**4*st**2*(16*C - 8)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(50*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + 2*D1*f*(50*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(2*s**2 - 2*s + 1)) - 50*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(231*d**2*k2**2*k3**4) + D1**2*Pk1*Pk3*ct**2*k1**4*(4*C - 2)*(6*b1*(D1**2*(f*(7*fd - 5*fdd)*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1)) + 2*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(1 - 2*s)**2 - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(35*fd*(3*s**2 - 2*s + 1) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(42*bd1 - 30*bdd1)) + 10*fd*s*(bd1*(6 - 12*s) + 5*fd*(2 - 3*s))) + 10*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(6*bd1*s + 5*fd*(3*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 50*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k2**2*k3**4) + 4*D1**2*Pk1*Pk3*ct**2*k1**2*k2**4*st**2*(-1716*D1**2*bd1**2*f*(-6*K + 10*f + 3)*(r + s - 1)**2 - 2574*D1**2*bdd1*f*(r + s - 1)**2*(-2*K*f + f + 4*g2) + 2*D1**2*(-50*f**3*(59*fd - 49*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(14700*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(2717*C - 1859)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (9581*gd2 - 5148*gdd2)*(r + s - 1)**2) + 143*f*(fd*(67*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 72*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 36*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 10296*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 143*D1*bd1*(D1*(12*f**3*(r + s - 1) + f**2*(38*C - 67*K + 7)*(r + s - 1) + 36*f*fd*(2*K - 1)*(2*r + 2*s - 1) + 2*f*(107*g2 - 72*gd2)*(r + s - 1) - 144*fd*g2*(r + s)) + 36*Dd*f*(f*(2*K - 1) - 4*g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(2950*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(2717*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4900*fd*(4*r + 4*s - 3)**2 - 7436*r**2 - 1859*r*(8*s - 6) - 7436*s**2 + 11154*s - 5577) - 143*f*(67*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 72*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 10296*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2*Ddd*f*(1225*f**2 - 2574*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 24*Dd**2*f**2*(1225*f**2 - 2574*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 143*b1**2*(D1**2*(12*f*(8*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(120*fd**2*(r + s - 1) + fd*(107*K - 57)*(r + s) - 18*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(96*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(120*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (107*K - 57)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 36*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-6*K + 10*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-6*K + 10*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 143*b1*(76*C*D1**2*f*fd*r**2 + 152*C*D1**2*f*fd*r*s - 76*C*D1**2*f*fd*r + 76*C*D1**2*f*fd*s**2 - 76*C*D1**2*f*fd*s + 38*C*D1**2*f*fd + 152*C*D1*Dd*f**2*r**2 + 304*C*D1*Dd*f**2*r*s - 228*C*D1*Dd*f**2*r + 152*C*D1*Dd*f**2*s**2 - 228*C*D1*Dd*f**2*s + 114*C*D1*Dd*f**2 - 134*D1**2*K*f*fd*r**2 - 268*D1**2*K*f*fd*r*s + 134*D1**2*K*f*fd*r - 134*D1**2*K*f*fd*s**2 + 134*D1**2*K*f*fd*s - 67*D1**2*K*f*fd + 72*D1**2*K*f*fdd*r**2 + 144*D1**2*K*f*fdd*r*s - 72*D1**2*K*f*fdd*r + 72*D1**2*K*f*fdd*s**2 - 72*D1**2*K*f*fdd*s + 36*D1**2*K*f*fdd + 72*D1**2*K*fd**2*r**2 + 144*D1**2*K*fd**2*r*s - 72*D1**2*K*fd**2*r + 72*D1**2*K*fd**2*s**2 - 72*D1**2*K*fd**2*s - 12*D1**2*bdd1*f*(-6*K + 10*f + 3)*(r + s - 1)**2 + 36*D1**2*f**2*fd*r**2 + 72*D1**2*f**2*fd*r*s - 48*D1**2*f**2*fd*r + 36*D1**2*f**2*fd*s**2 - 48*D1**2*f**2*fd*s + 24*D1**2*f**2*fd + 14*D1**2*f*fd*r**2 + 28*D1**2*f*fd*r*s - 14*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 - 14*D1**2*f*fd*s + 7*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd + 214*D1**2*f*gd2*r**2 + 428*D1**2*f*gd2*r*s - 428*D1**2*f*gd2*r + 214*D1**2*f*gd2*s**2 - 428*D1**2*f*gd2*s + 214*D1**2*f*gd2 - 72*D1**2*f*gdd2*r**2 - 144*D1**2*f*gdd2*r*s + 144*D1**2*f*gdd2*r - 72*D1**2*f*gdd2*s**2 + 144*D1**2*f*gdd2*s - 72*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 214*D1**2*fd*g2*r**2 + 428*D1**2*fd*g2*r*s + 214*D1**2*fd*g2*s**2 - 144*D1**2*fd*gd2*r**2 - 288*D1**2*fd*gd2*r*s + 144*D1**2*fd*gd2*r - 144*D1**2*fd*gd2*s**2 + 144*D1**2*fd*gd2*s - 72*D1**2*fdd*g2*r**2 - 144*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*s**2 - 268*D1*Dd*K*f**2*r**2 - 536*D1*Dd*K*f**2*r*s + 402*D1*Dd*K*f**2*r - 268*D1*Dd*K*f**2*s**2 + 402*D1*Dd*K*f**2*s - 201*D1*Dd*K*f**2 + 576*D1*Dd*K*f*fd*r**2 + 1152*D1*Dd*K*f*fd*r*s - 720*D1*Dd*K*f*fd*r + 576*D1*Dd*K*f*fd*s**2 - 720*D1*Dd*K*f*fd*s + 216*D1*Dd*K*f*fd + 48*D1*Dd*f**3*r**2 + 96*D1*Dd*f**3*r*s - 72*D1*Dd*f**3*r + 48*D1*Dd*f**3*s**2 - 72*D1*Dd*f**3*s + 36*D1*Dd*f**3 + 28*D1*Dd*f**2*r**2 + 56*D1*Dd*f**2*r*s - 42*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 - 42*D1*Dd*f**2*s + 21*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 856*D1*Dd*f*g2*r**2 + 1712*D1*Dd*f*g2*r*s - 1284*D1*Dd*f*g2*r + 856*D1*Dd*f*g2*s**2 - 1284*D1*Dd*f*g2*s + 642*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r**2 - 1152*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r - 576*D1*Dd*f*gd2*s**2 + 1008*D1*Dd*f*gd2*s - 432*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r**2 - 1152*D1*Dd*fd*g2*r*s + 432*D1*Dd*fd*g2*r - 576*D1*Dd*fd*g2*s**2 + 432*D1*Dd*fd*g2*s + 144*D1*Ddd*K*f**2*r**2 + 288*D1*Ddd*K*f**2*r*s - 216*D1*Ddd*K*f**2*r + 144*D1*Ddd*K*f**2*s**2 - 216*D1*Ddd*K*f**2*s + 108*D1*Ddd*K*f**2 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r**2 - 576*D1*Ddd*f*g2*r*s + 432*D1*Ddd*f*g2*r - 288*D1*Ddd*f*g2*s**2 + 432*D1*Ddd*f*g2*s - 216*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(96*f**2*(r + s - 1) - 120*f*fd*(2*r + 2*s - 1) - f*(107*K - 57)*(r + s - 1) + 36*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-6*K + 10*f + 3)*(4*r + 4*s - 3))*(r + s - 1) + 432*Dd**2*K*f**2*r**2 + 864*Dd**2*K*f**2*r*s - 648*Dd**2*K*f**2*r + 432*Dd**2*K*f**2*s**2 - 648*Dd**2*K*f**2*s + 216*Dd**2*K*f**2 - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 - 864*Dd**2*f*g2*r**2 - 1728*Dd**2*f*g2*r*s + 1296*Dd**2*f*g2*r - 864*Dd**2*f*g2*s**2 + 1296*Dd**2*f*g2*s - 432*Dd**2*f*g2))/(1001*d**2*k3**8) - 4*D1**2*Pk1*Pk3*ct**2*k1**2*k2**2*st**2*(66*b1**2*(D1**2*(fd*(73*C - 54) + fdd*(13 - 19*C))*(r + s - 1)**2 + D1*(Dd*(f*(73*C - 54)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(26 - 38*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(19*C - 13)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(114*C - 78)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-662*C*D1**2*f*fd*r**2 - 1508*C*D1**2*f*fd*r*s + 622*C*D1**2*f*fd*r - 846*C*D1**2*f*fd*s**2 + 714*C*D1**2*f*fd*s - 357*C*D1**2*f*fd + 562*C*D1**2*f*fdd*r**2 + 1252*C*D1**2*f*fdd*r*s - 550*C*D1**2*f*fdd*r + 690*C*D1**2*f*fdd*s**2 - 614*C*D1**2*f*fdd*s + 307*C*D1**2*f*fdd + 562*C*D1**2*fd**2*r**2 + 1252*C*D1**2*fd**2*r*s - 550*C*D1**2*fd**2*r + 690*C*D1**2*fd**2*s**2 - 614*C*D1**2*fd**2*s - 76*C*D1**2*fd**2 - 1324*C*D1*Dd*f**2*r**2 - 3016*C*D1*Dd*f**2*r*s + 2170*C*D1*Dd*f**2*r - 1692*C*D1*Dd*f**2*s**2 + 2446*C*D1*Dd*f**2*s - 1177*C*D1*Dd*f**2 + 4496*C*D1*Dd*f*fd*r**2 + 10016*C*D1*Dd*f*fd*r*s - 5828*C*D1*Dd*f*fd*r + 5520*C*D1*Dd*f*fd*s**2 - 6468*C*D1*Dd*f*fd*s + 1778*C*D1*Dd*f*fd + 1124*C*D1*Ddd*f**2*r**2 + 2504*C*D1*Ddd*f**2*r*s - 1814*C*D1*Ddd*f**2*r + 1380*C*D1*Ddd*f**2*s**2 - 2006*C*D1*Ddd*f**2*s + 971*C*D1*Ddd*f**2 + 3372*C*Dd**2*f**2*r**2 + 7512*C*Dd**2*f**2*r*s - 5442*C*Dd**2*f**2*r + 4140*C*Dd**2*f**2*s**2 - 6018*C*Dd**2*f**2*s + 1942*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(19*C - 13)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 438*D1**2*f*fd*r**2 + 1060*D1**2*f*fd*r*s - 442*D1**2*f*fd*r + 622*D1**2*f*fd*s**2 - 534*D1**2*f*fd*s + 267*D1**2*f*fd - 370*D1**2*f*fdd*r**2 - 880*D1**2*f*fdd*r*s + 388*D1**2*f*fdd*r - 510*D1**2*f*fdd*s**2 + 458*D1**2*f*fdd*s - 229*D1**2*f*fdd - 370*D1**2*fd**2*r**2 - 880*D1**2*fd**2*r*s + 388*D1**2*fd**2*r - 510*D1**2*fd**2*s**2 + 458*D1**2*fd**2*s + 52*D1**2*fd**2 + 876*D1*Dd*f**2*r**2 + 2120*D1*Dd*f**2*r*s - 1498*D1*Dd*f**2*r + 1244*D1*Dd*f**2*s**2 - 1774*D1*Dd*f**2*s + 841*D1*Dd*f**2 - 2960*D1*Dd*f*fd*r**2 - 7040*D1*Dd*f*fd*r*s + 4052*D1*Dd*f*fd*r - 4080*D1*Dd*f*fd*s**2 + 4752*D1*Dd*f*fd*s - 1304*D1*Dd*f*fd - 740*D1*Ddd*f**2*r**2 - 1760*D1*Ddd*f**2*r*s + 1250*D1*Ddd*f**2*r - 1020*D1*Ddd*f**2*s**2 + 1460*D1*Ddd*f**2*s - 695*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(73*C - 54)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(26 - 38*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(26 - 38*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2220*Dd**2*f**2*r**2 - 5280*Dd**2*f**2*r*s + 3750*Dd**2*f**2*r - 3060*Dd**2*f**2*s**2 + 4380*Dd**2*f**2*s - 1390*Dd**2*f**2) + f*(-31695*C*D1**2*f*fd*r**2 - 71466*C*D1**2*f*fd*r*s + 44952*C*D1**2*f*fd*r - 39771*C*D1**2*f*fd*s**2 + 50336*C*D1**2*f*fd*s - 23822*C*D1**2*f*fd + 29757*C*D1**2*f*fdd*r**2 + 63354*C*D1**2*f*fdd*r*s - 40956*C*D1**2*f*fdd*r + 33597*C*D1**2*f*fdd*s**2 - 43516*C*D1**2*f*fdd*s + 21118*C*D1**2*f*fdd + 59514*C*D1**2*fd**2*r**2 + 126708*C*D1**2*fd**2*r*s - 81912*C*D1**2*fd**2*r + 67194*C*D1**2*fd**2*s**2 - 87032*C*D1**2*fd**2*s + 21118*C*D1**2*fd**2 - 42260*C*D1*Dd*f**2*r**2 - 95288*C*D1*Dd*f**2*r*s + 68774*C*D1*Dd*f**2*r - 53028*C*D1*Dd*f**2*s**2 + 76850*C*D1*Dd*f**2*s - 37079*C*D1*Dd*f**2 + 238056*C*D1*Dd*f*fd*r**2 + 506832*C*D1*Dd*f*fd*r*s - 350046*C*D1*Dd*f*fd*r + 268776*C*D1*Dd*f*fd*s**2 - 371806*C*D1*Dd*f*fd*s + 127988*C*D1*Dd*f*fd + 39676*C*D1*Ddd*f**2*r**2 + 84472*C*D1*Ddd*f**2*r*s - 62074*C*D1*Ddd*f**2*r + 44796*C*D1*Ddd*f**2*s**2 - 65914*C*D1*Ddd*f**2*s + 32317*C*D1*Ddd*f**2 + 119028*C*Dd**2*f**2*r**2 + 253416*C*Dd**2*f**2*r*s - 186222*C*Dd**2*f**2*r + 134388*C*Dd**2*f**2*s**2 - 197742*C*Dd**2*f**2*s + 64634*C*Dd**2*f**2 - 132*D1**2*bd1**2*(19*C - 13)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(C*(281*r**2 + 626*r*s - 638*r + 345*s**2 - 702*s + 319) - 185*r**2 - 440*r*s + 422*r - 255*s**2 + 492*s - 211) + 21165*D1**2*f*fd*r**2 + 49686*D1**2*f*fd*r*s - 30672*D1**2*f*fd*r + 28521*D1**2*f*fd*s**2 - 35576*D1**2*f*fd*s + 16562*D1**2*f*fd - 19641*D1**2*f*fdd*r**2 - 44148*D1**2*f*fdd*r*s + 27810*D1**2*f*fdd*r - 24507*D1**2*f*fdd*s**2 + 31054*D1**2*f*fdd*s - 14716*D1**2*f*fdd - 39282*D1**2*fd**2*r**2 - 88296*D1**2*fd**2*r*s + 55620*D1**2*fd**2*r - 49014*D1**2*fd**2*s**2 + 62108*D1**2*fd**2*s - 14716*D1**2*fd**2 + 28220*D1*Dd*f**2*r**2 + 66248*D1*Dd*f**2*r*s - 47234*D1*Dd*f**2*r + 38028*D1*Dd*f**2*s**2 - 54590*D1*Dd*f**2*s + 26069*D1*Dd*f**2 - 157128*D1*Dd*f*fd*r**2 - 353184*D1*Dd*f*fd*r*s + 238818*D1*Dd*f*fd*r - 196056*D1*Dd*f*fd*s**2 + 266392*D1*Dd*f*fd*s - 89918*D1*Dd*f*fd - 26188*D1*Ddd*f**2*r**2 - 58864*D1*Ddd*f**2*r*s + 42526*D1*Ddd*f**2*r - 32676*D1*Ddd*f**2*s**2 + 47392*D1*Ddd*f**2*s - 22885*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(C*(331*r**2 + 754*r*s - 794*r + 423*s**2 - 886*s + 397) - 219*r**2 - 530*r*s + 526*r - 311*s**2 + 618*s - 263) - 2*fd*(C*(562*r**2 + 1252*r*s - 913*r + 690*s**2 - 1009*s + 351) - 370*r**2 - 880*r*s + 616*r - 510*s**2 + 721*s - 246)) + 2*Dd*f*(-C*(1124*r**2 + 2504*r*s - 2183*r + 1380*s**2 - 2407*s + 1021) + 740*r**2 + 1760*r*s - 1469*r + 1020*s**2 - 1714*s + 703)) - 78564*Dd**2*f**2*r**2 - 176592*Dd**2*f**2*r*s + 127578*Dd**2*f**2*r - 98028*Dd**2*f**2*s**2 + 142176*Dd**2*f**2*s - 45770*Dd**2*f**2))/(693*d**2*k3**6) + 4*D1**2*Pk1*Pk3*ct**2*k1**2*k2**2*(-77220*C*D1**2*f**2*fd*r**2 - 102960*C*D1**2*f**2*fd*r*s + 85800*C*D1**2*f**2*fd*r - 25740*C*D1**2*f**2*fd*s**2 + 51480*C*D1**2*f**2*fd*s - 34320*C*D1**2*f**2*fd - 102960*C*D1*Dd*f**3*r**2 - 137280*C*D1*Dd*f**3*r*s + 120120*C*D1*Dd*f**3*r - 34320*C*D1*Dd*f**3*s**2 + 68640*C*D1*Dd*f**3*s - 42900*C*D1*Dd*f**3 - 171600*D1**2*K*bdd1*f**2*r**2 - 326040*D1**2*K*bdd1*f**2*r*s + 326040*D1**2*K*bdd1*f**2*r - 154440*D1**2*K*bdd1*f**2*s**2 + 308880*D1**2*K*bdd1*f**2*s - 154440*D1**2*K*bdd1*f**2 + 858*D1**2*bd1**2*(r + s - 1)*(2*f**2*(73*r + 109*s - 101) - 3*f*(2*K*(59*r + 59*s - 71) - 51*r - 75*s + 75) - 168*g2*(r + s)) + 25740*D1**2*bd2*f**2*r**2 + 51480*D1**2*bd2*f**2*r*s - 51480*D1**2*bd2*f**2*r + 25740*D1**2*bd2*f**2*s**2 - 51480*D1**2*bd2*f**2*s + 25740*D1**2*bd2*f**2 - 102960*D1**2*bd2*f*fd*r**2 - 205920*D1**2*bd2*f*fd*r*s + 154440*D1**2*bd2*f*fd*r - 102960*D1**2*bd2*f*fd*s**2 + 154440*D1**2*bd2*f*fd*s - 51480*D1**2*bd2*f*fd + 56420*D1**2*bdd1*f**3*r**2 + 96070*D1**2*bdd1*f**3*r*s - 126100*D1**2*bdd1*f**3*r + 39650*D1**2*bdd1*f**3*s**2 - 109330*D1**2*bdd1*f**3*s + 73320*D1**2*bdd1*f**3 + 75504*D1**2*bdd1*f**2*r**2 + 169884*D1**2*bdd1*f**2*r*s - 169884*D1**2*bdd1*f**2*r + 94380*D1**2*bdd1*f**2*s**2 - 188760*D1**2*bdd1*f**2*s + 94380*D1**2*bdd1*f**2 + 303732*D1**2*bdd1*f*g2*r**2 + 607464*D1**2*bdd1*f*g2*r*s - 731016*D1**2*bdd1*f*g2*r + 303732*D1**2*bdd1*f*g2*s**2 - 731016*D1**2*bdd1*f*g2*s + 365508*D1**2*bdd1*f*g2 - 25740*D1**2*bdd2*f**2*r**2 - 51480*D1**2*bdd2*f**2*r*s + 51480*D1**2*bdd2*f**2*r - 25740*D1**2*bdd2*f**2*s**2 + 51480*D1**2*bdd2*f**2*s - 25740*D1**2*bdd2*f**2 + 37520*D1**2*f**3*fd*r**2 + 190400*D1**2*f**3*fd*r*s - 113960*D1**2*f**3*fd*r + 152880*D1**2*f**3*fd*s**2 - 200480*D1**2*f**3*fd*s + 85820*D1**2*f**3*fd - 44240*D1**2*f**3*fdd*r**2 - 211680*D1**2*f**3*fdd*r*s + 127960*D1**2*f**3*fdd*r - 167440*D1**2*f**3*fdd*s**2 + 220360*D1**2*f**3*fdd*s - 94780*D1**2*f**3*fdd - 132720*D1**2*f**2*fd**2*r**2 - 635040*D1**2*f**2*fd**2*r*s + 383880*D1**2*f**2*fd**2*r - 502320*D1**2*f**2*fd**2*s**2 + 661080*D1**2*f**2*fd**2*s - 189560*D1**2*f**2*fd**2 + 51480*D1**2*f**2*fd*r**2 + 64350*D1**2*f**2*fd*r*s - 55770*D1**2*f**2*fd*r + 12870*D1**2*f**2*fd*s**2 - 30030*D1**2*f**2*fd*s + 21450*D1**2*f**2*fd - 315744*D1**2*f**2*gd2*r**2 - 542256*D1**2*f**2*gd2*r*s + 542256*D1**2*f**2*gd2*r - 226512*D1**2*f**2*gd2*s**2 + 453024*D1**2*f**2*gd2*s - 226512*D1**2*f**2*gd2 + 343200*D1**2*f**2*gdd2*r**2 + 652080*D1**2*f**2*gdd2*r*s - 652080*D1**2*f**2*gdd2*r + 308880*D1**2*f**2*gdd2*s**2 - 617760*D1**2*f**2*gdd2*s + 308880*D1**2*f**2*gdd2 - 631488*D1**2*f*fd*g2*r**2 - 1084512*D1**2*f*fd*g2*r*s + 631488*D1**2*f*fd*g2*r - 453024*D1**2*f*fd*g2*s**2 + 542256*D1**2*f*fd*g2*s - 315744*D1**2*f*fd*g2 + 1372800*D1**2*f*fd*gd2*r**2 + 2608320*D1**2*f*fd*gd2*r*s - 1990560*D1**2*f*fd*gd2*r + 1235520*D1**2*f*fd*gd2*s**2 - 1887600*D1**2*f*fd*gd2*s + 652080*D1**2*f*fd*gd2 + 686400*D1**2*f*fdd*g2*r**2 + 1304160*D1**2*f*fdd*g2*r*s - 686400*D1**2*f*fdd*g2*r + 617760*D1**2*f*fdd*g2*s**2 - 652080*D1**2*f*fdd*g2*s + 343200*D1**2*f*fdd*g2 + 686400*D1**2*fd**2*g2*r**2 + 1304160*D1**2*fd**2*g2*r*s - 686400*D1**2*fd**2*g2*r + 617760*D1**2*fd**2*g2*s**2 - 652080*D1**2*fd**2*g2*s - 205920*D1*Dd*bd2*f**2*r**2 - 411840*D1*Dd*bd2*f**2*r*s + 360360*D1*Dd*bd2*f**2*r - 205920*D1*Dd*bd2*f**2*s**2 + 360360*D1*Dd*bd2*f**2*s - 154440*D1*Dd*bd2*f**2 + 37520*D1*Dd*f**4*r**2 + 190400*D1*Dd*f**4*r*s - 113960*D1*Dd*f**4*r + 152880*D1*Dd*f**4*s**2 - 200480*D1*Dd*f**4*s + 85820*D1*Dd*f**4 - 353920*D1*Dd*f**3*fd*r**2 - 1693440*D1*Dd*f**3*fd*r*s + 1023680*D1*Dd*f**3*fd*r - 1339520*D1*Dd*f**3*fd*s**2 + 1762880*D1*Dd*f**3*fd*s - 568680*D1*Dd*f**3*fd + 68640*D1*Dd*f**3*r**2 + 85800*D1*Dd*f**3*r*s - 77220*D1*Dd*f**3*r + 17160*D1*Dd*f**3*s**2 - 38610*D1*Dd*f**3*s + 25740*D1*Dd*f**3 - 1262976*D1*Dd*f**2*g2*r**2 - 2169024*D1*Dd*f**2*g2*r*s + 1716000*D1*Dd*f**2*g2*r - 906048*D1*Dd*f**2*g2*s**2 + 1448304*D1*Dd*f**2*g2*s - 768768*D1*Dd*f**2*g2 + 2745600*D1*Dd*f**2*gd2*r**2 + 5216640*D1*Dd*f**2*gd2*r*s - 4598880*D1*Dd*f**2*gd2*r + 2471040*D1*Dd*f**2*gd2*s**2 - 4358640*D1*Dd*f**2*gd2*s + 1887600*D1*Dd*f**2*gd2 + 5491200*D1*Dd*f*fd*g2*r**2 + 10433280*D1*Dd*f*fd*g2*r*s - 6726720*D1*Dd*f*fd*g2*r + 4942080*D1*Dd*f*fd*g2*s**2 - 6383520*D1*Dd*f*fd*g2*s + 1990560*D1*Dd*f*fd*g2 - 44240*D1*Ddd*f**4*r**2 - 211680*D1*Ddd*f**4*r*s + 127960*D1*Ddd*f**4*r - 167440*D1*Ddd*f**4*s**2 + 220360*D1*Ddd*f**4*s - 94780*D1*Ddd*f**4 + 1372800*D1*Ddd*f**2*g2*r**2 + 2608320*D1*Ddd*f**2*g2*r*s - 1990560*D1*Ddd*f**2*g2*r + 1235520*D1*Ddd*f**2*g2*s**2 - 1887600*D1*Ddd*f**2*g2*s + 960960*D1*Ddd*f**2*g2 - 26*D1*bd1*(2376*D1*bd2*f*(r + s - 1)**2 + D1*(5*f**3*(373*r**2 + r*(587*s - 818) + 214*s**2 - 659*s + 468) + f**2*(396*C*(2*r**2 + 2*r*(s - 3) - 4*s + 3) - 132*K*(46*r**2 + 79*r*(s - 1) + 33*(s - 1)**2) - 5*fd*(2604*r**2 + r*(4434*s - 4286) + 1830*s**2 - 3641*s + 1524) + 1947*r**2 + 4554*r*s - 3564*r + 2607*s**2 - 4224*s + 1815) + 66*f*(fd*(10*K*(40*r**2 + 76*r*s - 58*r + 36*s**2 - 55*s + 19) - 176*r**2 - 396*r*s + 286*r - 220*s**2 + 319*s - 99) + g2*(137*r**2 + 4*r*(65*s - 87) + 123*s**2 - 334*s + 174) - 6*gd2*(59*r**2 + 2*r*(59*s - 65) + 59*s**2 - 130*s + 71)) - 23364*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(-660*K*f*(80*r**2 + 2*r*(76*s - 67) + 72*s**2 - 127*s + 55) + 5*f**2*(3472*r**2 + r*(5912*s - 6226) + 2440*s**2 - 5323*s + 2652) + 726*f*(32*r**2 + r*(72*s - 62) + 40*s**2 - 69*s + 29) + 396*g2*(236*r**2 + r*(472*s - 461) + 236*s**2 - 461*s + 213))) - 132720*Dd**2*f**4*r**2 - 635040*Dd**2*f**4*r*s + 383880*Dd**2*f**4*r - 502320*Dd**2*f**4*s**2 + 661080*Dd**2*f**4*s - 189560*Dd**2*f**4 + 4118400*Dd**2*f**2*g2*r**2 + 7824960*Dd**2*f**2*g2*r*s - 5971680*Dd**2*f**2*g2*r + 3706560*Dd**2*f**2*g2*s**2 - 5662800*Dd**2*f**2*g2*s + 1921920*Dd**2*f**2*g2 + 2574*b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(28*C*D1**2*fd*r**2 + 56*C*D1**2*fd*r*s - 56*C*D1**2*fd*r + 28*C*D1**2*fd*s**2 - 56*C*D1**2*fd*s + 28*C*D1**2*fd + 112*C*D1*Dd*f*r**2 + 224*C*D1*Dd*f*r*s - 168*C*D1*Dd*f*r + 112*C*D1*Dd*f*s**2 - 168*C*D1*Dd*f*s + 84*C*D1*Dd*f + 274*D1**2*K*fd*r**2 + 520*D1**2*K*fd*r*s + 148*D1**2*K*fd*r + 246*D1**2*K*fd*s**2 + 148*D1**2*K*fd*s - 74*D1**2*K*fd - 354*D1**2*K*fdd*r**2 - 708*D1**2*K*fdd*r*s - 144*D1**2*K*fdd*r - 354*D1**2*K*fdd*s**2 - 144*D1**2*K*fdd*s + 72*D1**2*K*fdd - 6*D1**2*bdd1*(-14*K + 6*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 212*D1**2*f*fd*r**2 - 568*D1**2*f*fd*r*s + 252*D1**2*f*fd*r - 356*D1**2*f*fd*s**2 + 324*D1**2*f*fd*s - 162*D1**2*f*fd + 292*D1**2*f*fdd*r**2 + 728*D1**2*f*fdd*r*s - 324*D1**2*f*fdd*r + 436*D1**2*f*fdd*s**2 - 396*D1**2*f*fdd*s + 198*D1**2*f*fdd + 292*D1**2*fd**2*r**2 + 728*D1**2*fd**2*r*s - 324*D1**2*fd**2*r + 436*D1**2*fd**2*s**2 - 396*D1**2*fd**2*s - 40*D1**2*fd**2 - 131*D1**2*fd*r**2 - 308*D1**2*fd*r*s - 32*D1**2*fd*r - 177*D1**2*fd*s**2 - 32*D1**2*fd*s + 16*D1**2*fd + 153*D1**2*fdd*r**2 + 378*D1**2*fdd*r*s + 72*D1**2*fdd*r + 225*D1**2*fdd*s**2 + 72*D1**2*fdd*s - 36*D1**2*fdd + 336*D1**2*gd2*r**2 + 672*D1**2*gd2*r*s - 672*D1**2*gd2*r + 336*D1**2*gd2*s**2 - 672*D1**2*gd2*s + 336*D1**2*gd2 - 168*D1**2*gdd2*r**2 - 336*D1**2*gdd2*r*s + 336*D1**2*gdd2*r - 168*D1**2*gdd2*s**2 + 336*D1**2*gdd2*s - 168*D1**2*gdd2 + 1096*D1*Dd*K*f*r**2 + 2080*D1*Dd*K*f*r*s - 1588*D1*Dd*K*f*r + 984*D1*Dd*K*f*s**2 - 1504*D1*Dd*K*f*s + 766*D1*Dd*K*f - 2832*D1*Dd*K*fd*r**2 - 5664*D1*Dd*K*fd*r*s + 1548*D1*Dd*K*fd*r - 2832*D1*Dd*K*fd*s**2 + 1548*D1*Dd*K*fd*s + 432*D1*Dd*K*fd - 424*D1*Dd*f**2*r**2 - 1136*D1*Dd*f**2*r*s + 780*D1*Dd*f**2*r - 712*D1*Dd*f**2*s**2 + 996*D1*Dd*f**2*s - 462*D1*Dd*f**2 + 2336*D1*Dd*f*fd*r**2 + 5824*D1*Dd*f*fd*r*s - 3336*D1*Dd*f*fd*r + 3488*D1*Dd*f*fd*s**2 - 4056*D1*Dd*f*fd*s + 1116*D1*Dd*f*fd - 524*D1*Dd*f*r**2 - 1232*D1*Dd*f*r*s + 878*D1*Dd*f*r - 708*D1*Dd*f*s**2 + 1016*D1*Dd*f*s - 485*D1*Dd*f + 1224*D1*Dd*fd*r**2 + 3024*D1*Dd*fd*r*s - 774*D1*Dd*fd*r + 1800*D1*Dd*fd*s**2 - 990*D1*Dd*fd*s - 216*D1*Dd*fd + 1344*D1*Dd*g2*r**2 + 2688*D1*Dd*g2*r*s - 2016*D1*Dd*g2*r + 1344*D1*Dd*g2*s**2 - 2016*D1*Dd*g2*s + 1008*D1*Dd*g2 - 1344*D1*Dd*gd2*r**2 - 2688*D1*Dd*gd2*r*s + 2352*D1*Dd*gd2*r - 1344*D1*Dd*gd2*s**2 + 2352*D1*Dd*gd2*s - 1008*D1*Dd*gd2 - 1416*D1*Ddd*K*f*r**2 - 2832*D1*Ddd*K*f*r*s + 2124*D1*Ddd*K*f*r - 1416*D1*Ddd*K*f*s**2 + 2124*D1*Ddd*K*f*s - 1062*D1*Ddd*K*f + 584*D1*Ddd*f**2*r**2 + 1456*D1*Ddd*f**2*r*s - 1020*D1*Ddd*f**2*r + 872*D1*Ddd*f**2*s**2 - 1236*D1*Ddd*f**2*s + 582*D1*Ddd*f**2 + 612*D1*Ddd*f*r**2 + 1512*D1*Ddd*f*r*s - 1062*D1*Ddd*f*r + 900*D1*Ddd*f*s**2 - 1278*D1*Ddd*f*s + 603*D1*Ddd*f - 672*D1*Ddd*g2*r**2 - 1344*D1*Ddd*g2*r*s + 1008*D1*Ddd*g2*r - 672*D1*Ddd*g2*s**2 + 1008*D1*Ddd*g2*s - 504*D1*Ddd*g2 + 6*D1*bd1*(D1*(5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-14*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 4248*Dd**2*K*f*r**2 - 8496*Dd**2*K*f*r*s + 6372*Dd**2*K*f*r - 4248*Dd**2*K*f*s**2 + 6372*Dd**2*K*f*s - 2124*Dd**2*K*f + 1752*Dd**2*f**2*r**2 + 4368*Dd**2*f**2*r*s - 3060*Dd**2*f**2*r + 2616*Dd**2*f**2*s**2 - 3708*Dd**2*f**2*s + 1164*Dd**2*f**2 + 1836*Dd**2*f*r**2 + 4536*Dd**2*f*r*s - 3186*Dd**2*f*r + 2700*Dd**2*f*s**2 - 3834*Dd**2*f*s + 1206*Dd**2*f - 2016*Dd**2*g2*r**2 - 4032*Dd**2*g2*r*s + 3024*Dd**2*g2*r - 2016*Dd**2*g2*s**2 + 3024*Dd**2*g2*s - 1008*Dd**2*g2) - 26*b1*(1584*C*D1**2*f*fd*r**2 + 1584*C*D1**2*f*fd*r*s + 792*C*D1**2*f*fd*s - 396*C*D1**2*f*fd + 3168*C*D1*Dd*f**2*r**2 + 3168*C*D1*Dd*f**2*r*s - 3168*C*D1*Dd*f**2*r - 792*C*D1*Dd*f**2*s + 792*C*D1*Dd*f**2 + 11682*D1**2*K*bdd1*f*r**2 + 23364*D1**2*K*bdd1*f*r*s - 25740*D1**2*K*bdd1*f*r + 11682*D1**2*K*bdd1*f*s**2 - 25740*D1**2*K*bdd1*f*s + 12870*D1**2*K*bdd1*f - 12144*D1**2*K*f*fd*r**2 - 20856*D1**2*K*f*fd*r*s + 12144*D1**2*K*f*fd*r - 8712*D1**2*K*f*fd*s**2 + 10428*D1**2*K*f*fd*s - 6072*D1**2*K*f*fd + 13200*D1**2*K*f*fdd*r**2 + 25080*D1**2*K*f*fdd*r*s - 13200*D1**2*K*f*fdd*r + 11880*D1**2*K*f*fdd*s**2 - 12540*D1**2*K*f*fdd*s + 6600*D1**2*K*f*fdd + 13200*D1**2*K*fd**2*r**2 + 25080*D1**2*K*fd**2*r*s - 13200*D1**2*K*fd**2*r + 11880*D1**2*K*fd**2*s**2 - 12540*D1**2*K*fd**2*s - 1221*D1**2*b2*fd*r**2 - 2442*D1**2*b2*fd*r*s - 1221*D1**2*b2*fd*s**2 + 1188*D1**2*b2*fdd*r**2 + 2376*D1**2*b2*fdd*r*s + 1188*D1**2*b2*fdd*s**2 + 198*D1**2*bd1**2*(-14*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 4818*D1**2*bdd1*f**2*r**2 - 12012*D1**2*bdd1*f**2*r*s + 11484*D1**2*bdd1*f**2*r - 7194*D1**2*bdd1*f**2*s**2 + 13860*D1**2*bdd1*f**2*s - 6336*D1**2*bdd1*f**2 - 5049*D1**2*bdd1*f*r**2 - 12474*D1**2*bdd1*f*r*s + 12474*D1**2*bdd1*f*r - 7425*D1**2*bdd1*f*s**2 + 14850*D1**2*bdd1*f*s - 6831*D1**2*bdd1*f + 5544*D1**2*bdd1*g2*r**2 + 11088*D1**2*bdd1*g2*r*s - 5544*D1**2*bdd1*g2*r + 5544*D1**2*bdd1*g2*s**2 - 5544*D1**2*bdd1*g2*s + 2772*D1**2*bdd1*g2 + 1188*D1**2*bdd2*f*r**2 + 2376*D1**2*bdd2*f*r*s - 2376*D1**2*bdd2*f*r + 1188*D1**2*bdd2*f*s**2 - 2376*D1**2*bdd2*f*s + 1188*D1**2*bdd2*f + 5595*D1**2*f**2*fd*r**2 + 8805*D1**2*f**2*fd*r*s - 5510*D1**2*f**2*fd*r + 3210*D1**2*f**2*fd*s**2 - 3920*D1**2*f**2*fd*s + 1665*D1**2*f**2*fd - 6510*D1**2*f**2*fdd*r**2 - 11085*D1**2*f**2*fdd*r*s + 6880*D1**2*f**2*fdd*r - 4575*D1**2*f**2*fdd*s**2 + 5590*D1**2*f**2*fdd*s - 2400*D1**2*f**2*fdd - 13020*D1**2*f*fd**2*r**2 - 22170*D1**2*f*fd**2*r*s + 13760*D1**2*f*fd**2*r - 9150*D1**2*f*fd**2*s**2 + 11180*D1**2*f*fd**2*s - 2820*D1**2*f*fd**2 + 3894*D1**2*f*fd*r**2 + 9108*D1**2*f*fd*r*s - 4884*D1**2*f*fd*r + 5214*D1**2*f*fd*s**2 - 5544*D1**2*f*fd*s + 2739*D1**2*f*fd - 5808*D1**2*f*fdd*r**2 - 13068*D1**2*f*fdd*r*s + 5808*D1**2*f*fdd*r - 7260*D1**2*f*fdd*s**2 + 6534*D1**2*f*fdd*s - 2904*D1**2*f*fdd + 9042*D1**2*f*gd2*r**2 + 17160*D1**2*f*gd2*r*s - 17160*D1**2*f*gd2*r + 8118*D1**2*f*gd2*s**2 - 16236*D1**2*f*gd2*s + 8118*D1**2*f*gd2 - 11682*D1**2*f*gdd2*r**2 - 23364*D1**2*f*gdd2*r*s + 23364*D1**2*f*gdd2*r - 11682*D1**2*f*gdd2*s**2 + 23364*D1**2*f*gdd2*s - 11682*D1**2*f*gdd2 - 5808*D1**2*fd**2*r**2 - 13068*D1**2*fd**2*r*s + 5808*D1**2*fd**2*r - 7260*D1**2*fd**2*s**2 + 6534*D1**2*fd**2*s + 9042*D1**2*fd*g2*r**2 + 17160*D1**2*fd*g2*r*s + 4884*D1**2*fd*g2*r + 8118*D1**2*fd*g2*s**2 + 4884*D1**2*fd*g2*s - 2442*D1**2*fd*g2 - 23364*D1**2*fd*gd2*r**2 - 46728*D1**2*fd*gd2*r*s + 18612*D1**2*fd*gd2*r - 23364*D1**2*fd*gd2*s**2 + 18612*D1**2*fd*gd2*s + 4752*D1**2*fd*gd2 - 11682*D1**2*fdd*g2*r**2 - 23364*D1**2*fdd*g2*r*s - 4752*D1**2*fdd*g2*r - 11682*D1**2*fdd*g2*s**2 - 4752*D1**2*fdd*g2*s + 2376*D1**2*fdd*g2 - 24288*D1*Dd*K*f**2*r**2 - 41712*D1*Dd*K*f**2*r*s + 33000*D1*Dd*K*f**2*r - 17424*D1*Dd*K*f**2*s**2 + 27852*D1*Dd*K*f**2*s - 14784*D1*Dd*K*f**2 + 105600*D1*Dd*K*f*fd*r**2 + 200640*D1*Dd*K*f*fd*r*s - 129360*D1*Dd*K*f*fd*r + 95040*D1*Dd*K*f*fd*s**2 - 122760*D1*Dd*K*f*fd*s + 38280*D1*Dd*K*f*fd - 4884*D1*Dd*b2*f*r**2 - 9768*D1*Dd*b2*f*r*s + 7326*D1*Dd*b2*f*r - 4884*D1*Dd*b2*f*s**2 + 7326*D1*Dd*b2*f*s - 3663*D1*Dd*b2*f + 9504*D1*Dd*b2*fd*r**2 + 19008*D1*Dd*b2*fd*r*s - 7128*D1*Dd*b2*fd*r + 9504*D1*Dd*b2*fd*s**2 - 7128*D1*Dd*b2*fd*s + 7460*D1*Dd*f**3*r**2 + 11740*D1*Dd*f**3*r*s - 9600*D1*Dd*f**3*r + 4280*D1*Dd*f**3*s**2 - 7215*D1*Dd*f**3*s + 4005*D1*Dd*f**3 - 52080*D1*Dd*f**2*fd*r**2 - 88680*D1*Dd*f**2*fd*r*s + 62710*D1*Dd*f**2*fd*r - 36600*D1*Dd*f**2*fd*s**2 + 51745*D1*Dd*f**2*fd*s - 18060*D1*Dd*f**2*fd + 7788*D1*Dd*f**2*r**2 + 18216*D1*Dd*f**2*r*s - 13002*D1*Dd*f**2*r + 10428*D1*Dd*f**2*s**2 - 14982*D1*Dd*f**2*s + 7161*D1*Dd*f**2 - 46464*D1*Dd*f*fd*r**2 - 104544*D1*Dd*f*fd*r*s + 60984*D1*Dd*f*fd*r - 58080*D1*Dd*f*fd*s**2 + 68244*D1*Dd*f*fd*s - 18876*D1*Dd*f*fd + 36168*D1*Dd*f*g2*r**2 + 68640*D1*Dd*f*g2*r*s - 52404*D1*Dd*f*g2*r + 32472*D1*Dd*f*g2*s**2 - 49632*D1*Dd*f*g2*s + 25278*D1*Dd*f*g2 - 93456*D1*Dd*f*gd2*r**2 - 186912*D1*Dd*f*gd2*r*s + 163548*D1*Dd*f*gd2*r - 93456*D1*Dd*f*gd2*s**2 + 163548*D1*Dd*f*gd2*s - 70092*D1*Dd*f*gd2 - 93456*D1*Dd*fd*g2*r**2 - 186912*D1*Dd*fd*g2*r*s + 51084*D1*Dd*fd*g2*r - 93456*D1*Dd*fd*g2*s**2 + 51084*D1*Dd*fd*g2*s + 14256*D1*Dd*fd*g2 + 26400*D1*Ddd*K*f**2*r**2 + 50160*D1*Ddd*K*f**2*r*s - 38280*D1*Ddd*K*f**2*r + 23760*D1*Ddd*K*f**2*s**2 - 36300*D1*Ddd*K*f**2*s + 18480*D1*Ddd*K*f**2 + 4752*D1*Ddd*b2*f*r**2 + 9504*D1*Ddd*b2*f*r*s - 7128*D1*Ddd*b2*f*r + 4752*D1*Ddd*b2*f*s**2 - 7128*D1*Ddd*b2*f*s + 3564*D1*Ddd*b2*f - 8680*D1*Ddd*f**3*r**2 - 14780*D1*Ddd*f**3*r*s + 11730*D1*Ddd*f**3*r - 6100*D1*Ddd*f**3*s**2 + 9795*D1*Ddd*f**3*s - 5220*D1*Ddd*f**3 - 11616*D1*Ddd*f**2*r**2 - 26136*D1*Ddd*f**2*r*s + 18876*D1*Ddd*f**2*r - 14520*D1*Ddd*f**2*s**2 + 21054*D1*Ddd*f**2*s - 10164*D1*Ddd*f**2 - 46728*D1*Ddd*f*g2*r**2 - 93456*D1*Ddd*f*g2*r*s + 70092*D1*Ddd*f*g2*r - 46728*D1*Ddd*f*g2*s**2 + 70092*D1*Ddd*f*g2*s - 35046*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(2*f**2*(53*r**2 + 2*r*(71*s - 66) + 89*s**2 - 168*s + 75) - f*(14*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 274*K*r**2 + 520*K*r*s - 608*K*r + 246*K*s**2 - 580*K*s + 297*K + 4*fd*(146*r**2 + 364*r*s - 255*r + 218*s**2 - 309*s + 100) - 131*r**2 - 308*r*s + 301*r - 177*s**2 + 347*s - 162) + 6*fd*(2*K*(59*r**2 + 118*r*s - 53*r + 59*s**2 - 53*s - 6) - 51*r**2 - 126*r*s + 51*r - 75*s**2 + 63*s + 6) - 168*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 168*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*(-6*K*f*(236*r**2 + r*(472*s - 437) + 236*s**2 - 437*s + 195) + 2*f**2*(292*r**2 + r*(728*s - 603) + 436*s**2 - 729*s + 297) + 9*f*(68*r**2 + r*(168*s - 143) + 100*s**2 - 171*s + 71) - 84*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 33*D1*bd2*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) + 79200*Dd**2*K*f**2*r**2 + 150480*Dd**2*K*f**2*r*s - 114840*Dd**2*K*f**2*r + 71280*Dd**2*K*f**2*s**2 - 108900*Dd**2*K*f**2*s + 36960*Dd**2*K*f**2 + 14256*Dd**2*b2*f*r**2 + 28512*Dd**2*b2*f*r*s - 21384*Dd**2*b2*f*r + 14256*Dd**2*b2*f*s**2 - 21384*Dd**2*b2*f*s + 7128*Dd**2*b2*f - 26040*Dd**2*f**3*r**2 - 44340*Dd**2*f**3*r*s + 35190*Dd**2*f**3*r - 18300*Dd**2*f**3*s**2 + 29385*Dd**2*f**3*s - 10440*Dd**2*f**3 - 34848*Dd**2*f**2*r**2 - 78408*Dd**2*f**2*r*s + 56628*Dd**2*f**2*r - 43560*Dd**2*f**2*s**2 + 63162*Dd**2*f**2*s - 20328*Dd**2*f**2 - 140184*Dd**2*f*g2*r**2 - 280368*Dd**2*f*g2*r*s + 210276*Dd**2*f*g2*r - 140184*Dd**2*f*g2*s**2 + 210276*Dd**2*f*g2*s - 70092*Dd**2*f*g2) + 858*b2*(-36*D1**2*bdd1*f*(r + s - 1)**2 + 30*D1**2*(f*(fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bd1*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) + 30*D1*f*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(9009*d**2*k3**6) - 2*D1**2*Pk1*Pk3*ct**2*k1**2*st**2*(22*b1**2*(D1**2*(s - 1)*(fd*(76*C - 51) + fdd*(15 - 24*C))*(r + s - 1) + D1*(Dd*(f*(76*C - 51)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(24*C - 15)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(15 - 24*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(24*C - 15)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 11*b1*(D1**2*(f*(-6*bdd1*s*(8*C - 5)*(2*r + 2*s - 1) + fd*(C*(-200*r*(2*s - 1) - 610*s**2 + 522*s - 305) + 118*r*(2*s - 1) + 422*s**2 - 368*s + 211) + fdd*(C*(144*r*(2*s - 1) + 454*s**2 - 406*s + 227) - 84*r*(2*s - 1) - 310*s**2 + 280*s - 155)) + 2*fd**2*(C*(72*r*(2*s - 1) + 227*s**2 - 203*s - 24) + r*(42 - 84*s) - 155*s**2 + 140*s + 15)) + 2*D1*bd1*(D1*(f*s*(76*C - 51)*(2*r + 2*s - 1) - fd*(24*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(30 - 48*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(5*C*(80*r*s - 40*r + 122*s**2 - 142*s + 61) - 236*r*s + 118*r - 422*s**2 + 481*s - 211) - 2*fd*(2*s - 1)*(C*(288*r + 454*s - 239) - 168*r - 310*s + 161)) + Ddd*f*(C*(-144*r*(2*s - 1) - 454*s**2 + 526*s - 227) + 84*r*(2*s - 1) + 310*s**2 - 352*s + 155)) + 2*Dd**2*f**2*(C*(432*r*(2*s - 1) + 1362*s**2 - 1578*s + 371) - 252*r*(2*s - 1) - 930*s**2 + 1056*s - 239)) + f*(-66*D1**2*bd1**2*s*(8*C - 5)*(2*r + 2*s - 1) + D1**2*(f*(11*bdd1*s*(C*(144*r + 227*s - 192) - 84*r - 155*s + 114) + fd*(C*(-2344*r*(3*s - 1) - 10857*s**2 + 9582*s - 3619) + 1404*r*(3*s - 1) + 7305*s**2 - 6274*s + 2435) + fdd*(3*C*(640*r*(3*s - 1) + 2673*s**2 - 2422*s + 891) - 1142*r*(3*s - 1) - 5385*s**2 + 4732*s - 1795)) + 2*fd**2*(3*C*(640*r*(3*s - 1) + 2673*s**2 - 2422*s + 320) - 1142*r*(3*s - 1) - 5385*s**2 + 4732*s - 571)) - 11*D1*bd1*(D1*(f*s*(C*(200*r + 305*s - 288) - 118*r - 211*s + 172) - 2*fd*(C*(72*r*(4*s - 1) + 454*s**2 - 395*s + 96) - 168*r*s + 42*r - 310*s**2 + 254*s - 57)) - 4*Dd*f*(C*(72*r*(4*s - 1) + 454*s**2 - 455*s + 96) - 168*r*s + 42*r - 310*s**2 + 290*s - 57)) - 2*D1*f*(Dd*(f*(C*(2344*r*(2*s - 1) + 7238*s**2 - 8410*s + 3619) - 1404*r*(2*s - 1) - 4870*s**2 + 5572*s - 2435) + fd*(-6*C*(320*r*(12*s - 5) + 5346*s**2 - 5575*s + 1371) + 1142*r*(12*s - 5) + 21540*s**2 - 21947*s + 5303)) + Ddd*f*(-3*C*(640*r*(2*s - 1) + 1782*s**2 - 2102*s + 891) + 1142*r*(2*s - 1) + 3590*s**2 - 4161*s + 1795)) + 6*Dd**2*f**2*(C*(1920*r*(2*s - 1) + 5346*s**2 - 6306*s + 1531) - 1142*r*(2*s - 1) - 3590*s**2 + 4161*s - 979)))/(231*d**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**2*k1**2*(33*b1**2*(D1**2*(fd*(26*C*r + 250*C*(s - 1) - 13*r - 163*s + 163) + fdd*(-62*C*r - 230*C*(s - 1) + 31*r + 155*s - 155))*(r + s - 1) + D1*(Dd*(-4*C*fd*(124*r**2 + r*(584*s - 469) + 460*s**2 - 763*s + 303) + f*(2*C*(52*r**2 + 552*r*s - 302*r + 500*s**2 - 638*s + 263) - 52*r**2 - 704*r*s + 378*r - 652*s**2 + 828*s - 339) + 62*fd*(4*r**2 + r*(24*s - 19) + 20*s**2 - 33*s + 13)) + Ddd*f*(-2*C*(124*r**2 + 584*r*s - 354*r + 460*s**2 - 606*s + 261) + 124*r**2 + 744*r*s - 434*r + 620*s**2 - 806*s + 341)) + 2*Dd**2*f*(-6*C*(62*r**2 + r*(292*s - 177) + 230*s**2 - 303*s + 87) + 186*r**2 + 93*r*(12*s - 7) + 930*s**2 - 1209*s + 341)) + 33*b1*(-100*C*D1**2*f*fd*r**2 - 952*C*D1**2*f*fd*r*s + 404*C*D1**2*f*fd*r - 964*C*D1**2*f*fd*s**2 + 716*C*D1**2*f*fd*s - 446*C*D1**2*f*fd + 148*C*D1**2*f*fdd*r**2 + 936*C*D1**2*f*fdd*r*s - 348*C*D1**2*f*fdd*r + 952*C*D1**2*f*fdd*s**2 - 696*C*D1**2*f*fdd*s + 416*C*D1**2*f*fdd + 148*C*D1**2*fd**2*r**2 + 936*C*D1**2*fd**2*r*s - 348*C*D1**2*fd**2*r + 952*C*D1**2*fd**2*s**2 - 696*C*D1**2*fd**2*s - 256*C*D1**2*fd**2 - 200*C*D1*Dd*f**2*r**2 - 1904*C*D1*Dd*f**2*r*s + 1052*C*D1*Dd*f**2*r - 1928*C*D1*Dd*f**2*s**2 + 2404*C*D1*Dd*f**2*s - 1014*C*D1*Dd*f**2 + 1184*C*D1*Dd*f*fd*r**2 + 7488*C*D1*Dd*f*fd*r*s - 3560*C*D1*Dd*f*fd*r + 7616*C*D1*Dd*f*fd*s**2 - 7528*C*D1*Dd*f*fd*s + 1740*C*D1*Dd*f*fd + 296*C*D1*Ddd*f**2*r**2 + 1872*C*D1*Ddd*f**2*r*s - 1084*C*D1*Ddd*f**2*r + 1904*C*D1*Ddd*f**2*s**2 - 2372*C*D1*Ddd*f**2*s + 1026*C*D1*Ddd*f**2 + 888*C*Dd**2*f**2*r**2 + 5616*C*Dd**2*f**2*r*s - 3252*C*Dd**2*f**2*r + 5712*C*Dd**2*f**2*s**2 - 7116*C*Dd**2*f**2*s + 1888*C*Dd**2*f**2 + D1**2*bdd1*f*(-2*C*(62*r**2 + 292*r*s - 62*r + 230*s**2 - 146*s + 31) + 62*r**2 + 372*r*s - 62*r + 310*s**2 - 186*s + 31) + 50*D1**2*f*fd*r**2 + 592*D1**2*f*fd*r*s - 260*D1**2*f*fd*r + 708*D1**2*f*fd*s**2 - 552*D1**2*f*fd*s + 336*D1**2*f*fd - 74*D1**2*f*fdd*r**2 - 584*D1**2*f*fdd*r*s + 232*D1**2*f*fdd*r - 704*D1**2*f*fdd*s**2 + 542*D1**2*f*fdd*s - 322*D1**2*f*fdd - 74*D1**2*fd**2*r**2 - 584*D1**2*fd**2*r*s + 232*D1**2*fd**2*r - 704*D1**2*fd**2*s**2 + 542*D1**2*fd**2*s + 162*D1**2*fd**2 + 100*D1*Dd*f**2*r**2 + 1184*D1*Dd*f**2*r*s - 642*D1*Dd*f**2*r + 1416*D1*Dd*f**2*s**2 - 1712*D1*Dd*f**2*s + 733*D1*Dd*f**2 - 592*D1*Dd*f*fd*r**2 - 4672*D1*Dd*f*fd*r*s + 2244*D1*Dd*f*fd*r - 5632*D1*Dd*f*fd*s**2 + 5568*D1*Dd*f*fd*s - 1316*D1*Dd*f*fd - 148*D1*Ddd*f**2*r**2 - 1168*D1*Ddd*f**2*r*s + 658*D1*Ddd*f**2*r - 1408*D1*Ddd*f**2*s**2 + 1700*D1*Ddd*f**2*s - 741*D1*Ddd*f**2 + D1*bd1*(-4*C*D1*fd*(62*r**2 + r*(292*s - 177) + 230*s**2 - 303*s + 73) - 4*C*Dd*f*(248*r**2 + 2*r*(584*s - 239) + 920*s**2 - 898*s + 177) + D1*f*(C*(52*r**2 + 552*r*s - 52*r + 500*s**2 - 276*s + 26) - 26*r**2 - 352*r*s + 26*r - 326*s**2 + 176*s - 13) + 62*D1*fd*(2*r**2 + r*(12*s - 7) + 10*s**2 - 13*s + 3) + 62*Dd*f*(8*r**2 + 6*r*(8*s - 3) + 40*s**2 - 38*s + 7)) - 444*Dd**2*f**2*r**2 - 3504*Dd**2*f**2*r*s + 1974*Dd**2*f**2*r - 4224*Dd**2*f**2*s**2 + 5100*Dd**2*f**2*s - 1288*Dd**2*f**2) + f*(-11298*C*D1**2*f*fd*r**2 - 66552*C*D1**2*f*fd*r*s + 29716*C*D1**2*f*fd*r - 57912*C*D1**2*f*fd*s**2 + 60792*C*D1**2*f*fd*s - 23070*C*D1**2*f*fd + 12678*C*D1**2*f*fdd*r**2 + 65352*C*D1**2*f*fdd*r*s - 30236*C*D1**2*f*fdd*r + 56082*C*D1**2*f*fdd*s**2 - 59172*C*D1**2*f*fdd*s + 22920*C*D1**2*f*fdd + 25356*C*D1**2*fd**2*r**2 + 130704*C*D1**2*fd**2*r*s - 60472*C*D1**2*fd**2*r + 112164*C*D1**2*fd**2*s**2 - 118344*C*D1**2*fd**2*s + 21784*C*D1**2*fd**2 - 15064*C*D1*Dd*f**2*r**2 - 88736*C*D1*Dd*f**2*r*s + 51900*C*D1*Dd*f**2*r - 77216*C*D1*Dd*f**2*s**2 + 99400*C*D1*Dd*f**2*s - 42374*C*D1*Dd*f**2 + 101424*C*D1*Dd*f*fd*r**2 + 522816*C*D1*Dd*f*fd*r*s - 277004*C*D1*Dd*f*fd*r + 448656*C*D1*Dd*f*fd*s**2 - 526368*C*D1*Dd*f*fd*s + 148580*C*D1*Dd*f*fd + 16904*C*D1*Ddd*f**2*r**2 + 87136*C*D1*Ddd*f**2*r*s - 52020*C*D1*Ddd*f**2*r + 74776*C*D1*Ddd*f**2*s**2 - 96560*C*D1*Ddd*f**2*s + 41614*C*D1*Ddd*f**2 + 50712*C*Dd**2*f**2*r**2 + 261408*C*Dd**2*f**2*r*s - 156060*C*Dd**2*f**2*r + 224328*C*Dd**2*f**2*s**2 - 289680*C*Dd**2*f**2*s + 80956*C*Dd**2*f**2 - 66*D1**2*bd1**2*(r**2*(62*C - 31) + r*(292*C*s - 62*C - 186*s + 31) + s*(230*C*s - 146*C - 155*s + 93)) + 33*D1**2*bdd1*f*(2*C*(37*r**2 + 234*r*s - 134*r + 238*s**2 - 362*s + 67) - 37*r**2 - 292*r*s + 134*r - 352*s**2 + 454*s - 67) + 5649*D1**2*f*fd*r**2 + 41493*D1**2*f*fd*r*s - 17597*D1**2*f*fd*r + 41079*D1**2*f*fd*s**2 - 41217*D1**2*f*fd*s + 15576*D1**2*f*fd - 6339*D1**2*f*fdd*r**2 - 40893*D1**2*f*fdd*r*s + 17857*D1**2*f*fdd*r - 40389*D1**2*f*fdd*s**2 + 40557*D1**2*f*fdd*s - 15576*D1**2*f*fdd - 12678*D1**2*fd**2*r**2 - 81786*D1**2*fd**2*r*s + 35714*D1**2*fd**2*r - 80778*D1**2*fd**2*s**2 + 81114*D1**2*fd**2*s - 13631*D1**2*fd**2 + 7532*D1*Dd*f**2*r**2 + 55324*D1*Dd*f**2*r*s - 31428*D1*Dd*f**2*r + 54772*D1*Dd*f**2*s**2 - 68603*D1*Dd*f**2*s + 29269*D1*Dd*f**2 - 50712*D1*Dd*f*fd*r**2 - 327144*D1*Dd*f*fd*r*s + 165892*D1*Dd*f*fd*r - 323112*D1*Dd*f*fd*s**2 + 364677*D1*Dd*f*fd*s - 98971*D1*Dd*f*fd - 8452*D1*Ddd*f**2*r**2 - 54524*D1*Ddd*f**2*r*s + 31488*D1*Ddd*f**2*r - 53852*D1*Ddd*f**2*s**2 + 67483*D1*Ddd*f**2*s - 29039*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(2*C*(25*r**2 + 238*r*s - 86*r + 241*s**2 - 362*s + 43) - 25*r**2 - 296*r*s + 86*r - 354*s**2 + 452*s - 43) - 2*fd*(2*C*(74*r**2 + 468*r*s - 221*r + 476*s**2 - 536*s + 181) - 74*r**2 - 584*r*s + 250*r - 704*s**2 + 725*s - 227)) + 2*Dd*f*(-2*C*(148*r**2 + 936*r*s - 539*r + 952*s**2 - 1317*s + 429) + 148*r**2 + 1168*r*s - 597*r + 1408*s**2 - 1758*s + 521)) - 25356*Dd**2*f**2*r**2 - 163572*Dd**2*f**2*r*s + 94464*Dd**2*f**2*r - 161556*Dd**2*f**2*s**2 + 202449*Dd**2*f**2*s - 54188*Dd**2*f**2))/(693*d**2*k3**4) - D1**2*Pk1*Pk3*ct**2*k1**2*st**2*(16*C - 8)*(66*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s))) + 33*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(-66*bd1**2*s**2 - 25*f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 50*fd**2*s*(3*s - 2)) - 50*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) + 50*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(231*d**2*k2**2*k3**2) + D1**2*Pk1*Pk3*ct**2*k1**2*(4*C - 2)*(14*D1*b1*s*(-5*D1*bdd1*f*s + bd1*(7*D1*f*s - 10*D1*fd*(s - 1) + 20*Dd*f*(1 - 2*s))) + 7*b1**2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + 2*D1*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(2*s**2 - 3*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f*(6*s**2 - 6*s + 1)) - 5*f*(D1**2*(f*(7*fd - 5*fdd)*(3*s**2 - 2*s + 1) + 2*s*(7*bd1**2*s - 5*fd**2*(3*s - 2))) + 2*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(6*s**2 - 5*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k2**2*k3**2) + D1**2*Pk1*Pk3*ct**2*k2**6*st**6*(40*C - 40)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(231*d**2*k3**8) + 8*D1**2*Pk1*Pk3*ct**2*k2**6*st**4*(-858*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 78*D1*bd1*(D1*(20*f**3*(r + s - 1) + f**2*(11*C*(r + s - 1) - 20*fd*(3*r + 3*s - 2) - 11*r - 11*s + 11) + 22*f*(g2 - gd2)*(r + s - 1) - 22*fd*g2*(r + s)) - 2*Dd*f*(10*f**2 + 11*g2)*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 78*b1*(-22*C*D1**2*f*fd*r**2 - 44*C*D1**2*f*fd*r*s + 22*C*D1**2*f*fd*r - 22*C*D1**2*f*fd*s**2 + 22*C*D1**2*f*fd*s - 11*C*D1**2*f*fd - 44*C*D1*Dd*f**2*r**2 - 88*C*D1*Dd*f**2*r*s + 66*C*D1*Dd*f**2*r - 44*C*D1*Dd*f**2*s**2 + 66*C*D1*Dd*f**2*s - 33*C*D1*Dd*f**2 - 11*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 60*D1**2*f**2*fd*r**2 - 120*D1**2*f**2*fd*r*s + 80*D1**2*f**2*fd*r - 60*D1**2*f**2*fd*s**2 + 80*D1**2*f**2*fd*s - 40*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r**2 + 60*D1**2*f**2*fdd*r*s - 40*D1**2*f**2*fdd*r + 30*D1**2*f**2*fdd*s**2 - 40*D1**2*f**2*fdd*s + 20*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 + 120*D1**2*f*fd**2*r*s - 80*D1**2*f*fd**2*r + 60*D1**2*f*fd**2*s**2 - 80*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 22*D1**2*f*gd2*r**2 - 44*D1**2*f*gd2*r*s + 44*D1**2*f*gd2*r - 22*D1**2*f*gd2*s**2 + 44*D1**2*f*gd2*s - 22*D1**2*f*gd2 + 11*D1**2*f*gdd2*r**2 + 22*D1**2*f*gdd2*r*s - 22*D1**2*f*gdd2*r + 11*D1**2*f*gdd2*s**2 - 22*D1**2*f*gdd2*s + 11*D1**2*f*gdd2 - 22*D1**2*fd*g2*r**2 - 44*D1**2*fd*g2*r*s - 22*D1**2*fd*g2*s**2 + 22*D1**2*fd*gd2*r**2 + 44*D1**2*fd*gd2*r*s - 22*D1**2*fd*gd2*r + 22*D1**2*fd*gd2*s**2 - 22*D1**2*fd*gd2*s + 11*D1**2*fdd*g2*r**2 + 22*D1**2*fdd*g2*r*s + 11*D1**2*fdd*g2*s**2 - 80*D1*Dd*f**3*r**2 - 160*D1*Dd*f**3*r*s + 120*D1*Dd*f**3*r - 80*D1*Dd*f**3*s**2 + 120*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r**2 + 480*D1*Dd*f**2*fd*r*s - 340*D1*Dd*f**2*fd*r + 240*D1*Dd*f**2*fd*s**2 - 340*D1*Dd*f**2*fd*s + 120*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 88*D1*Dd*f*g2*r**2 - 176*D1*Dd*f*g2*r*s + 132*D1*Dd*f*g2*r - 88*D1*Dd*f*g2*s**2 + 132*D1*Dd*f*g2*s - 66*D1*Dd*f*g2 + 88*D1*Dd*f*gd2*r**2 + 176*D1*Dd*f*gd2*r*s - 154*D1*Dd*f*gd2*r + 88*D1*Dd*f*gd2*s**2 - 154*D1*Dd*f*gd2*s + 66*D1*Dd*f*gd2 + 88*D1*Dd*fd*g2*r**2 + 176*D1*Dd*fd*g2*r*s - 66*D1*Dd*fd*g2*r + 88*D1*Dd*fd*g2*s**2 - 66*D1*Dd*fd*g2*s + 40*D1*Ddd*f**3*r**2 + 80*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 40*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + 44*D1*Ddd*f*g2*r**2 + 88*D1*Ddd*f*g2*r*s - 66*D1*Ddd*f*g2*r + 44*D1*Ddd*f*g2*s**2 - 66*D1*Ddd*f*g2*s + 33*D1*Ddd*f*g2 + 22*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 120*Dd**2*f**3*r**2 + 240*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 120*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 60*Dd**2*f**3 + 132*Dd**2*f*g2*r**2 + 264*Dd**2*f*g2*r*s - 198*Dd**2*f*g2*r + 132*Dd**2*f*g2*s**2 - 198*Dd**2*f*g2*s + 66*Dd**2*f*g2) - 2*f*(-39*D1**2*bdd1*(10*f**2 + 11*g2)*(r + s - 1)**2 + 5*f*(D1**2*(f*(137*fd - 75*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 450*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(137*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 150*fd*(4*r + 4*s - 3)**2) - 75*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 450*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(1001*d**2*k3**8) + D1**2*Pk1*Pk3*ct**2*k2**4*st**6*(80*C - 80)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(693*d**2*k3**6) + 8*D1**2*Pk1*Pk3*ct**2*k2**4*st**4*(66*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-6*C*D1**2*f*fd*r**2 - 20*C*D1**2*f*fd*r*s + 10*C*D1**2*f*fd*r - 14*C*D1**2*f*fd*s**2 + 14*C*D1**2*f*fd*s - 7*C*D1**2*f*fd + 10*C*D1**2*f*fdd*r**2 + 28*C*D1**2*f*fdd*r*s - 14*C*D1**2*f*fdd*r + 18*C*D1**2*f*fdd*s**2 - 18*C*D1**2*f*fdd*s + 9*C*D1**2*f*fdd + 10*C*D1**2*fd**2*r**2 + 28*C*D1**2*fd**2*r*s - 14*C*D1**2*fd**2*r + 18*C*D1**2*fd**2*s**2 - 18*C*D1**2*fd**2*s - 12*C*D1*Dd*f**2*r**2 - 40*C*D1*Dd*f**2*r*s + 26*C*D1*Dd*f**2*r - 28*C*D1*Dd*f**2*s**2 + 38*C*D1*Dd*f**2*s - 17*C*D1*Dd*f**2 + 80*C*D1*Dd*f*fd*r**2 + 224*C*D1*Dd*f*fd*r*s - 132*C*D1*Dd*f*fd*r + 144*C*D1*Dd*f*fd*s**2 - 172*C*D1*Dd*f*fd*s + 50*C*D1*Dd*f*fd + 20*C*D1*Ddd*f**2*r**2 + 56*C*D1*Ddd*f**2*r*s - 38*C*D1*Ddd*f**2*r + 36*C*D1*Ddd*f**2*s**2 - 50*C*D1*Ddd*f**2*s + 23*C*D1*Ddd*f**2 + 60*C*Dd**2*f**2*r**2 + 168*C*Dd**2*f**2*r*s - 114*C*Dd**2*f**2*r + 108*C*Dd**2*f**2*s**2 - 150*C*Dd**2*f**2*s + 46*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s - 6*D1**2*f*fd*r + 10*D1**2*f*fd*s**2 - 10*D1**2*f*fd*s + 5*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 4*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s - 14*D1*Dd*f**2*r + 20*D1*Dd*f**2*s**2 - 26*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 132*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 172*D1*Dd*f*fd*s - 50*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 38*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 50*D1*Ddd*f**2*s - 23*D1*Ddd*f**2 + 4*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 60*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 114*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 150*Dd**2*f**2*s - 46*Dd**2*f**2) + f*(516*C*D1**2*f*fd*r**2 + 816*C*D1**2*f*fd*r*s - 616*C*D1**2*f*fd*r + 300*C*D1**2*f*fd*s**2 - 472*C*D1**2*f*fd*s + 272*C*D1**2*f*fd - 258*C*D1**2*f*fdd*r**2 - 408*C*D1**2*f*fdd*r*s + 308*C*D1**2*f*fdd*r - 150*C*D1**2*f*fdd*s**2 + 236*C*D1**2*f*fdd*s - 136*C*D1**2*f*fdd - 516*C*D1**2*fd**2*r**2 - 816*C*D1**2*fd**2*r*s + 616*C*D1**2*fd**2*r - 300*C*D1**2*fd**2*s**2 + 472*C*D1**2*fd**2*s - 136*C*D1**2*fd**2 + 688*C*D1*Dd*f**2*r**2 + 1088*C*D1*Dd*f**2*r*s - 888*C*D1*Dd*f**2*r + 400*C*D1*Dd*f**2*s**2 - 672*C*D1*Dd*f**2*s + 372*C*D1*Dd*f**2 - 2064*C*D1*Dd*f*fd*r**2 - 3264*C*D1*Dd*f*fd*r*s + 2564*C*D1*Dd*f*fd*r - 1200*C*D1*Dd*f*fd*s**2 + 1952*C*D1*Dd*f*fd*s - 780*C*D1*Dd*f*fd - 344*C*D1*Ddd*f**2*r**2 - 544*C*D1*Ddd*f**2*r*s + 444*C*D1*Ddd*f**2*r - 200*C*D1*Ddd*f**2*s**2 + 336*C*D1*Ddd*f**2*s - 186*C*D1*Ddd*f**2 - 1032*C*Dd**2*f**2*r**2 - 1632*C*Dd**2*f**2*r*s + 1332*C*Dd**2*f**2*r - 600*C*Dd**2*f**2*s**2 + 1008*C*Dd**2*f**2*s - 372*C*Dd**2*f**2 - 132*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(C - 1)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) - 516*D1**2*f*fd*r**2 - 846*D1**2*f*fd*r*s + 626*D1**2*f*fd*r - 330*D1**2*f*fd*s**2 + 502*D1**2*f*fd*s - 282*D1**2*f*fd + 258*D1**2*f*fdd*r**2 + 423*D1**2*f*fdd*r*s - 313*D1**2*f*fdd*r + 165*D1**2*f*fdd*s**2 - 251*D1**2*f*fdd*s + 141*D1**2*f*fdd + 516*D1**2*fd**2*r**2 + 846*D1**2*fd**2*r*s - 626*D1**2*fd**2*r + 330*D1**2*fd**2*s**2 - 502*D1**2*fd**2*s + 141*D1**2*fd**2 - 688*D1*Dd*f**2*r**2 - 1128*D1*Dd*f**2*r*s + 908*D1*Dd*f**2*r - 440*D1*Dd*f**2*s**2 + 722*D1*Dd*f**2*s - 392*D1*Dd*f**2 + 2064*D1*Dd*f*fd*r**2 + 3384*D1*Dd*f*fd*r*s - 2614*D1*Dd*f*fd*r + 1320*D1*Dd*f*fd*s**2 - 2087*D1*Dd*f*fd*s + 815*D1*Dd*f*fd + 344*D1*Ddd*f**2*r**2 + 564*D1*Ddd*f**2*r*s - 454*D1*Ddd*f**2*r + 220*D1*Ddd*f**2*s**2 - 361*D1*Ddd*f**2*s + 196*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(r + s - 1)*(C*(3*r + 7*s - 3) - r - 5*s + 1) - fd*(2*C - 2)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7)) + Dd*f*(2 - 2*C)*(20*r**2 + r*(56*s - 39) + 36*s**2 - 53*s + 19)) + 1032*Dd**2*f**2*r**2 + 1692*Dd**2*f**2*r*s - 1362*Dd**2*f**2*r + 660*Dd**2*f**2*s**2 - 1083*Dd**2*f**2*s + 392*Dd**2*f**2))/(231*d**2*k3**6) + 2*D1**2*Pk1*Pk3*ct**2*k2**4*st**2*(-16588*C*D1**2*bd1*f**2*r**2 - 19448*C*D1**2*bd1*f**2*r*s + 34320*C*D1**2*bd1*f**2*r - 2860*C*D1**2*bd1*f**2*s**2 + 20592*C*D1**2*bd1*f**2*s - 17160*C*D1**2*bd1*f**2 - 51480*C*D1**2*f**2*fd*r**2 - 61776*C*D1**2*f**2*fd*r*s + 54912*C*D1**2*f**2*fd*r - 10296*C*D1**2*f**2*fd*s**2 + 27456*C*D1**2*f**2*fd*s - 20592*C*D1**2*f**2*fd - 68640*C*D1*Dd*f**3*r**2 - 82368*C*D1*Dd*f**3*r*s + 75504*C*D1*Dd*f**3*r - 13728*C*D1*Dd*f**3*s**2 + 34320*C*D1*Dd*f**3*s - 24024*C*D1*Dd*f**3 - 6578*D1**2*K*bd1**2*f*r**2 - 2860*D1**2*K*bd1**2*f*r*s + 8580*D1**2*K*bd1**2*f*r + 3718*D1**2*K*bd1**2*f*s**2 - 1716*D1**2*K*bd1**2*f*s - 2002*D1**2*K*bd1**2*f + 14157*D1**2*K*bd1*f**2*r**2 + 20878*D1**2*K*bd1*f**2*r*s - 20878*D1**2*K*bd1*f**2*r + 6721*D1**2*K*bd1*f**2*s**2 - 13442*D1**2*K*bd1*f**2*s + 6721*D1**2*K*bd1*f**2 - 37180*D1**2*K*bd1*f*fd*r**2 - 53768*D1**2*K*bd1*f*fd*r*s + 45474*D1**2*K*bd1*f*fd*r - 16588*D1**2*K*bd1*f*fd*s**2 + 30030*D1**2*K*bd1*f*fd*s - 13442*D1**2*K*bd1*f*fd - 9295*D1**2*K*bdd1*f**2*r**2 - 13442*D1**2*K*bdd1*f**2*r*s + 13442*D1**2*K*bdd1*f**2*r - 4147*D1**2*K*bdd1*f**2*s**2 + 8294*D1**2*K*bdd1*f**2*s - 4147*D1**2*K*bdd1*f**2 + 32604*D1**2*bd1**2*f**2*r**2 + 68640*D1**2*bd1**2*f**2*r*s - 60060*D1**2*bd1**2*f**2*r + 36036*D1**2*bd1**2*f**2*s**2 - 63492*D1**2*bd1**2*f**2*s + 27456*D1**2*bd1**2*f**2 + 6578*D1**2*bd1**2*f*r**2 + 6292*D1**2*bd1**2*f*r*s - 10296*D1**2*bd1**2*f*r - 286*D1**2*bd1**2*f*s**2 - 3432*D1**2*bd1**2*f*s + 3718*D1**2*bd1**2*f + 8008*D1**2*bd1**2*g2*r**2 + 16016*D1**2*bd1**2*g2*r*s - 8008*D1**2*bd1**2*g2*r + 8008*D1**2*bd1**2*g2*s**2 - 8008*D1**2*bd1**2*g2*s - 3432*D1**2*bd1*bd2*f*r**2 - 6864*D1**2*bd1*bd2*f*r*s + 6864*D1**2*bd1*bd2*f*r - 3432*D1**2*bd1*bd2*f*s**2 + 6864*D1**2*bd1*bd2*f*s - 3432*D1**2*bd1*bd2*f - 13156*D1**2*bd1*f**3*r**2 - 7332*D1**2*bd1*f**3*r*s + 14352*D1**2*bd1*f**3*r + 5824*D1**2*bd1*f**3*s**2 - 4628*D1**2*bd1*f**3*s - 7280*D1**2*bd1*f**3 + 34320*D1**2*bd1*f**2*fd*r**2 - 55224*D1**2*bd1*f**2*fd*r*s + 2912*D1**2*bd1*f**2*fd*r - 89544*D1**2*bd1*f**2*fd*s**2 + 106132*D1**2*bd1*f**2*fd*s - 35620*D1**2*bd1*f**2*fd + 143*D1**2*bd1*f**2*r**2 - 6578*D1**2*bd1*f**2*r*s - 6578*D1**2*bd1*f**2*r - 6721*D1**2*bd1*f**2*s**2 + 286*D1**2*bd1*f**2*s + 5863*D1**2*bd1*f**2 + 37180*D1**2*bd1*f*fd*r**2 + 60632*D1**2*bd1*f*fd*r*s - 48906*D1**2*bd1*f*fd*r + 23452*D1**2*bd1*f*fd*s**2 - 38610*D1**2*bd1*f*fd*s + 15158*D1**2*bd1*f*fd - 27170*D1**2*bd1*f*g2*r**2 - 41756*D1**2*bd1*f*g2*r*s + 56628*D1**2*bd1*f*g2*r - 14586*D1**2*bd1*f*g2*s**2 + 44044*D1**2*bd1*f*g2*s - 28314*D1**2*bd1*f*g2 + 13156*D1**2*bd1*f*gd2*r**2 + 5720*D1**2*bd1*f*gd2*r*s - 17160*D1**2*bd1*f*gd2*r - 7436*D1**2*bd1*f*gd2*s**2 + 3432*D1**2*bd1*f*gd2*s + 4004*D1**2*bd1*f*gd2 + 13156*D1**2*bd1*fd*g2*r**2 + 5720*D1**2*bd1*fd*g2*r*s - 13156*D1**2*bd1*fd*g2*r - 7436*D1**2*bd1*fd*g2*s**2 - 2860*D1**2*bd1*fd*g2*s + 3432*D1**2*bd2*f**2*r**2 + 6864*D1**2*bd2*f**2*r*s - 6864*D1**2*bd2*f**2*r + 3432*D1**2*bd2*f**2*s**2 - 6864*D1**2*bd2*f**2*s + 3432*D1**2*bd2*f**2 - 6864*D1**2*bd2*f*fd*r**2 - 13728*D1**2*bd2*f*fd*r*s + 10296*D1**2*bd2*f*fd*r - 6864*D1**2*bd2*f*fd*s**2 + 10296*D1**2*bd2*f*fd*s - 3432*D1**2*bd2*f*fd + 5720*D1**2*bdd1*f**3*r**2 - 9204*D1**2*bdd1*f**3*r*s - 2028*D1**2*bdd1*f**3*r - 14924*D1**2*bdd1*f**3*s**2 + 18616*D1**2*bdd1*f**3*s + 208*D1**2*bdd1*f**3 + 9295*D1**2*bdd1*f**2*r**2 + 15158*D1**2*bdd1*f**2*r*s - 15158*D1**2*bdd1*f**2*r + 5863*D1**2*bdd1*f**2*s**2 - 11726*D1**2*bdd1*f**2*s + 5863*D1**2*bdd1*f**2 + 6578*D1**2*bdd1*f*g2*r**2 + 2860*D1**2*bdd1*f*g2*r*s - 14300*D1**2*bdd1*f*g2*r - 3718*D1**2*bdd1*f*g2*s**2 - 4004*D1**2*bdd1*f*g2*s + 7150*D1**2*bdd1*f*g2 - 1716*D1**2*bdd2*f**2*r**2 - 3432*D1**2*bdd2*f**2*r*s + 3432*D1**2*bdd2*f**2*r - 1716*D1**2*bdd2*f**2*s**2 + 3432*D1**2*bdd2*f**2*s - 1716*D1**2*bdd2*f**2 + 38040*D1**2*f**3*fd*r**2 + 118640*D1**2*f**3*fd*r*s - 78340*D1**2*f**3*fd*r + 80600*D1**2*f**3*fd*s**2 - 110260*D1**2*f**3*fd*s + 49810*D1**2*f**3*fd - 54120*D1**2*f**3*fdd*r**2 - 150320*D1**2*f**3*fdd*r*s + 102220*D1**2*f**3*fdd*r - 96200*D1**2*f**3*fdd*s**2 + 133780*D1**2*f**3*fdd*s - 61630*D1**2*f**3*fdd - 162360*D1**2*f**2*fd**2*r**2 - 450960*D1**2*f**2*fd**2*r*s + 306660*D1**2*f**2*fd**2*r - 288600*D1**2*f**2*fd**2*s**2 + 401340*D1**2*f**2*fd**2*s - 123260*D1**2*f**2*fd**2 + 46332*D1**2*f**2*fd*r**2 + 56628*D1**2*f**2*fd*r*s - 49764*D1**2*f**2*fd*r + 10296*D1**2*f**2*fd*s**2 - 25740*D1**2*f**2*fd*s + 18876*D1**2*f**2*fd - 28314*D1**2*f**2*gd2*r**2 - 41756*D1**2*f**2*gd2*r*s + 41756*D1**2*f**2*gd2*r - 13442*D1**2*f**2*gd2*s**2 + 26884*D1**2*f**2*gd2*s - 13442*D1**2*f**2*gd2 + 18590*D1**2*f**2*gdd2*r**2 + 26884*D1**2*f**2*gdd2*r*s - 26884*D1**2*f**2*gdd2*r + 8294*D1**2*f**2*gdd2*s**2 - 16588*D1**2*f**2*gdd2*s + 8294*D1**2*f**2*gdd2 - 56628*D1**2*f*fd*g2*r**2 - 83512*D1**2*f*fd*g2*r*s + 56628*D1**2*f*fd*g2*r - 26884*D1**2*f*fd*g2*s**2 + 41756*D1**2*f*fd*g2*s - 28314*D1**2*f*fd*g2 + 74360*D1**2*f*fd*gd2*r**2 + 107536*D1**2*f*fd*gd2*r*s - 90948*D1**2*f*fd*gd2*r + 33176*D1**2*f*fd*gd2*s**2 - 60060*D1**2*f*fd*gd2*s + 26884*D1**2*f*fd*gd2 + 37180*D1**2*f*fdd*g2*r**2 + 53768*D1**2*f*fdd*g2*r*s - 37180*D1**2*f*fdd*g2*r + 16588*D1**2*f*fdd*g2*s**2 - 26884*D1**2*f*fdd*g2*s + 18590*D1**2*f*fdd*g2 + 37180*D1**2*fd**2*g2*r**2 + 53768*D1**2*fd**2*g2*r*s - 37180*D1**2*fd**2*g2*r + 16588*D1**2*fd**2*g2*s**2 - 26884*D1**2*fd**2*g2*s - 74360*D1*Dd*K*bd1*f**2*r**2 - 107536*D1*Dd*K*bd1*f**2*r*s + 99242*D1*Dd*K*bd1*f**2*r - 33176*D1*Dd*K*bd1*f**2*s**2 + 63206*D1*Dd*K*bd1*f**2*s - 30030*D1*Dd*K*bd1*f**2 + 45760*D1*Dd*bd1*f**3*r**2 - 73632*D1*Dd*bd1*f**3*r*s - 1144*D1*Dd*bd1*f**3*r - 119392*D1*Dd*bd1*f**3*s**2 + 143364*D1*Dd*bd1*f**3*s - 35204*D1*Dd*bd1*f**3 + 74360*D1*Dd*bd1*f**2*r**2 + 121264*D1*Dd*bd1*f**2*r*s - 109538*D1*Dd*bd1*f**2*r + 46904*D1*Dd*bd1*f**2*s**2 - 85514*D1*Dd*bd1*f**2*s + 38610*D1*Dd*bd1*f**2 + 52624*D1*Dd*bd1*f*g2*r**2 + 22880*D1*Dd*bd1*f*g2*r*s - 76076*D1*Dd*bd1*f*g2*r - 29744*D1*Dd*bd1*f*g2*s**2 - 4004*D1*Dd*bd1*f*g2*s + 22308*D1*Dd*bd1*f*g2 - 13728*D1*Dd*bd2*f**2*r**2 - 27456*D1*Dd*bd2*f**2*r*s + 24024*D1*Dd*bd2*f**2*r - 13728*D1*Dd*bd2*f**2*s**2 + 24024*D1*Dd*bd2*f**2*s - 10296*D1*Dd*bd2*f**2 + 38040*D1*Dd*f**4*r**2 + 118640*D1*Dd*f**4*r*s - 78340*D1*Dd*f**4*r + 80600*D1*Dd*f**4*s**2 - 110260*D1*Dd*f**4*s + 49810*D1*Dd*f**4 - 432960*D1*Dd*f**3*fd*r**2 - 1202560*D1*Dd*f**3*fd*r*s + 817760*D1*Dd*f**3*fd*r - 769600*D1*Dd*f**3*fd*s**2 + 1070240*D1*Dd*f**3*fd*s - 369780*D1*Dd*f**3*fd + 61776*D1*Dd*f**3*r**2 + 75504*D1*Dd*f**3*r*s - 68640*D1*Dd*f**3*r + 13728*D1*Dd*f**3*s**2 - 32604*D1*Dd*f**3*s + 22308*D1*Dd*f**3 - 113256*D1*Dd*f**2*g2*r**2 - 167024*D1*Dd*f**2*g2*r*s + 140140*D1*Dd*f**2*g2*r - 53768*D1*Dd*f**2*g2*s**2 + 95524*D1*Dd*f**2*g2*s - 55198*D1*Dd*f**2*g2 + 148720*D1*Dd*f**2*gd2*r**2 + 215072*D1*Dd*f**2*gd2*r*s - 198484*D1*Dd*f**2*gd2*r + 66352*D1*Dd*f**2*gd2*s**2 - 126412*D1*Dd*f**2*gd2*s + 60060*D1*Dd*f**2*gd2 + 297440*D1*Dd*f*fd*g2*r**2 + 430144*D1*Dd*f*fd*g2*r*s - 330616*D1*Dd*f*fd*g2*r + 132704*D1*Dd*f*fd*g2*s**2 - 227656*D1*Dd*f*fd*g2*s + 90948*D1*Dd*f*fd*g2 - 54120*D1*Ddd*f**4*r**2 - 150320*D1*Ddd*f**4*r*s + 102220*D1*Ddd*f**4*r - 96200*D1*Ddd*f**4*s**2 + 133780*D1*Ddd*f**4*s - 61630*D1*Ddd*f**4 + 74360*D1*Ddd*f**2*g2*r**2 + 107536*D1*Ddd*f**2*g2*r*s - 90948*D1*Ddd*f**2*g2*r + 33176*D1*Ddd*f**2*g2*s**2 - 60060*D1*Ddd*f**2*g2*s + 35178*D1*Ddd*f**2*g2 - 162360*Dd**2*f**4*r**2 - 450960*Dd**2*f**4*r*s + 306660*Dd**2*f**4*r - 288600*Dd**2*f**4*s**2 + 401340*Dd**2*f**4*s - 123260*Dd**2*f**4 + 223080*Dd**2*f**2*g2*r**2 + 322608*Dd**2*f**2*g2*r*s - 272844*Dd**2*f**2*g2*r + 99528*Dd**2*f**2*g2*s**2 - 180180*Dd**2*f**2*g2*s + 70356*Dd**2*f**2*g2 + 286*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (7*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(7*K + 6*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(7*K + 6*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 143*b1**2*(-28*C*D1**2*fd*r**2 - 56*C*D1**2*fd*r*s + 56*C*D1**2*fd*r - 28*C*D1**2*fd*s**2 + 56*C*D1**2*fd*s - 28*C*D1**2*fd - 112*C*D1*Dd*f*r**2 - 224*C*D1*Dd*f*r*s + 168*C*D1*Dd*f*r - 112*C*D1*Dd*f*s**2 + 168*C*D1*Dd*f*s - 84*C*D1*Dd*f + 95*D1**2*K*fd*r**2 + 146*D1**2*K*fd*r*s + 8*D1**2*K*fd*r + 51*D1**2*K*fd*s**2 + 8*D1**2*K*fd*s - 4*D1**2*K*fd - 23*D1**2*K*fdd*r**2 - 10*D1**2*K*fdd*r*s - 4*D1**2*K*fdd*r + 13*D1**2*K*fdd*s**2 - 4*D1**2*K*fdd*s + 2*D1**2*K*fdd - 2*D1**2*bdd1*(7*K + 6*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 300*D1**2*f*fd*r**2 - 624*D1**2*f*fd*r*s + 384*D1**2*f*fd*r - 324*D1**2*f*fd*s**2 + 396*D1**2*f*fd*s - 198*D1**2*f*fd + 228*D1**2*f*fdd*r**2 + 480*D1**2*f*fdd*r*s - 288*D1**2*f*fdd*r + 252*D1**2*f*fdd*s**2 - 300*D1**2*f*fdd*s + 150*D1**2*f*fdd + 228*D1**2*fd**2*r**2 + 480*D1**2*fd**2*r*s - 288*D1**2*fd**2*r + 252*D1**2*fd**2*s**2 - 300*D1**2*fd**2*s + 48*D1**2*fd**2 - 95*D1**2*fd*r**2 - 170*D1**2*fd*r*s - 64*D1**2*fd*r - 75*D1**2*fd*s**2 - 64*D1**2*fd*s + 32*D1**2*fd + 23*D1**2*fdd*r**2 + 22*D1**2*fdd*r*s + 4*D1**2*fdd*r - D1**2*fdd*s**2 + 4*D1**2*fdd*s - 2*D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 + 380*D1*Dd*K*f*r**2 + 584*D1*Dd*K*f*r*s - 482*D1*Dd*K*f*r + 204*D1*Dd*K*f*s**2 - 350*D1*Dd*K*f*s + 197*D1*Dd*K*f - 184*D1*Dd*K*fd*r**2 - 80*D1*Dd*K*fd*r*s + 50*D1*Dd*K*fd*r + 104*D1*Dd*K*fd*s**2 - 58*D1*Dd*K*fd*s + 12*D1*Dd*K*fd - 600*D1*Dd*f**2*r**2 - 1248*D1*Dd*f**2*r*s + 924*D1*Dd*f**2*r - 648*D1*Dd*f**2*s**2 + 960*D1*Dd*f**2*s - 474*D1*Dd*f**2 + 1824*D1*Dd*f*fd*r**2 + 3840*D1*Dd*f*fd*r*s - 2568*D1*Dd*f*fd*r + 2016*D1*Dd*f*fd*s**2 - 2688*D1*Dd*f*fd*s + 888*D1*Dd*f*fd - 380*D1*Dd*f*r**2 - 680*D1*Dd*f*r*s + 530*D1*Dd*f*r - 300*D1*Dd*f*s**2 + 470*D1*Dd*f*s - 245*D1*Dd*f + 184*D1*Dd*fd*r**2 + 176*D1*Dd*fd*r*s - 74*D1*Dd*fd*r - 8*D1*Dd*fd*s**2 - 2*D1*Dd*fd*s - 12*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 - 92*D1*Ddd*K*f*r**2 - 40*D1*Ddd*K*f*r*s + 66*D1*Ddd*K*f*r + 52*D1*Ddd*K*f*s**2 - 42*D1*Ddd*K*f*s + 3*D1*Ddd*K*f + 456*D1*Ddd*f**2*r**2 + 960*D1*Ddd*f**2*r*s - 708*D1*Ddd*f**2*r + 504*D1*Ddd*f**2*s**2 - 744*D1*Ddd*f**2*s + 366*D1*Ddd*f**2 + 92*D1*Ddd*f*r**2 + 88*D1*Ddd*f*r*s - 90*D1*Ddd*f*r - 4*D1*Ddd*f*s**2 - 18*D1*Ddd*f*s + 21*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + 4*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (7*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(7*K + 6*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 276*Dd**2*K*f*r**2 - 120*Dd**2*K*f*r*s + 198*Dd**2*K*f*r + 156*Dd**2*K*f*s**2 - 126*Dd**2*K*f*s + 6*Dd**2*K*f + 1368*Dd**2*f**2*r**2 + 2880*Dd**2*f**2*r*s - 2124*Dd**2*f**2*r + 1512*Dd**2*f**2*s**2 - 2232*Dd**2*f**2*s + 732*Dd**2*f**2 + 276*Dd**2*f*r**2 + 264*Dd**2*f*r*s - 270*Dd**2*f*r - 12*Dd**2*f*s**2 - 54*Dd**2*f*s + 42*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) - 13*b1*(2552*C*D1**2*f*fd*r**2 + 2992*C*D1**2*f*fd*r*s - 1408*C*D1**2*f*fd*r + 440*C*D1**2*f*fd*s**2 - 352*C*D1**2*f*fd*s + 176*C*D1**2*f*fd + 5104*C*D1*Dd*f**2*r**2 + 5984*C*D1*Dd*f**2*r*s - 5544*C*D1*Dd*f**2*r + 880*C*D1*Dd*f**2*s**2 - 2376*C*D1*Dd*f**2*s + 1716*C*D1*Dd*f**2 + 506*D1**2*K*bdd1*f*r**2 + 220*D1**2*K*bdd1*f*r*s - 660*D1**2*K*bdd1*f*r - 286*D1**2*K*bdd1*f*s**2 + 132*D1**2*K*bdd1*f*s + 132*D1**2*K*bdd1*f - 2178*D1**2*K*f*fd*r**2 - 3212*D1**2*K*f*fd*r*s + 2178*D1**2*K*f*fd*r - 1034*D1**2*K*f*fd*s**2 + 1606*D1**2*K*f*fd*s - 1089*D1**2*K*f*fd + 1430*D1**2*K*f*fdd*r**2 + 2068*D1**2*K*f*fdd*r*s - 1430*D1**2*K*f*fdd*r + 638*D1**2*K*f*fdd*s**2 - 1034*D1**2*K*f*fdd*s + 715*D1**2*K*f*fdd + 1430*D1**2*K*fd**2*r**2 + 2068*D1**2*K*fd**2*r*s - 1430*D1**2*K*fd**2*r + 638*D1**2*K*fd**2*s**2 - 1034*D1**2*K*fd**2*s - 264*D1**2*b2*fd*r**2 - 528*D1**2*b2*fd*r*s - 264*D1**2*b2*fd*s**2 + 132*D1**2*b2*fdd*r**2 + 264*D1**2*b2*fdd*r*s + 132*D1**2*b2*fdd*s**2 + 44*D1**2*bd1**2*(7*K + 6*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2508*D1**2*bdd1*f**2*r**2 - 5280*D1**2*bdd1*f**2*r*s + 4620*D1**2*bdd1*f**2*r - 2772*D1**2*bdd1*f**2*s**2 + 4884*D1**2*bdd1*f**2*s - 2376*D1**2*bdd1*f**2 - 506*D1**2*bdd1*f*r**2 - 484*D1**2*bdd1*f*r*s + 792*D1**2*bdd1*f*r + 22*D1**2*bdd1*f*s**2 + 264*D1**2*bdd1*f*s - 264*D1**2*bdd1*f - 616*D1**2*bdd1*g2*r**2 - 1232*D1**2*bdd1*g2*r*s + 616*D1**2*bdd1*g2*r - 616*D1**2*bdd1*g2*s**2 + 616*D1**2*bdd1*g2*s - 308*D1**2*bdd1*g2 + 132*D1**2*bdd2*f*r**2 + 264*D1**2*bdd2*f*r*s - 264*D1**2*bdd2*f*r + 132*D1**2*bdd2*f*s**2 - 264*D1**2*bdd2*f*s + 132*D1**2*bdd2*f + 3036*D1**2*f**2*fd*r**2 + 1692*D1**2*f**2*fd*r*s - 2048*D1**2*f**2*fd*r - 1344*D1**2*f**2*fd*s**2 + 872*D1**2*f**2*fd*s - 444*D1**2*f**2*fd - 1320*D1**2*f**2*fdd*r**2 + 2124*D1**2*f**2*fdd*r*s - 692*D1**2*f**2*fdd*r + 3444*D1**2*f**2*fdd*s**2 - 3868*D1**2*f**2*fdd*s + 1872*D1**2*f**2*fdd - 2640*D1**2*f*fd**2*r**2 + 4248*D1**2*f*fd**2*r*s - 1384*D1**2*f*fd**2*r + 6888*D1**2*f*fd**2*s**2 - 7736*D1**2*f*fd**2*s + 972*D1**2*f*fd**2 - 22*D1**2*f*fd*r**2 + 1012*D1**2*f*fd*r*s - 990*D1**2*f*fd*r + 1034*D1**2*f*fd*s**2 - 1518*D1**2*f*fd*s + 957*D1**2*f*fd - 1430*D1**2*f*fdd*r**2 - 2332*D1**2*f*fdd*r*s + 1430*D1**2*f*fdd*r - 902*D1**2*f*fdd*s**2 + 1166*D1**2*f*fdd*s - 715*D1**2*f*fdd + 2090*D1**2*f*gd2*r**2 + 3212*D1**2*f*gd2*r*s - 3212*D1**2*f*gd2*r + 1122*D1**2*f*gd2*s**2 - 2244*D1**2*f*gd2*s + 1122*D1**2*f*gd2 - 506*D1**2*f*gdd2*r**2 - 220*D1**2*f*gdd2*r*s + 220*D1**2*f*gdd2*r + 286*D1**2*f*gdd2*s**2 - 572*D1**2*f*gdd2*s + 286*D1**2*f*gdd2 - 1430*D1**2*fd**2*r**2 - 2332*D1**2*fd**2*r*s + 1430*D1**2*fd**2*r - 902*D1**2*fd**2*s**2 + 1166*D1**2*fd**2*s + 2090*D1**2*fd*g2*r**2 + 3212*D1**2*fd*g2*r*s + 176*D1**2*fd*g2*r + 1122*D1**2*fd*g2*s**2 + 176*D1**2*fd*g2*s - 88*D1**2*fd*g2 - 1012*D1**2*fd*gd2*r**2 - 440*D1**2*fd*gd2*r*s + 132*D1**2*fd*gd2*r + 572*D1**2*fd*gd2*s**2 - 660*D1**2*fd*gd2*s + 88*D1**2*fd*gd2 - 506*D1**2*fdd*g2*r**2 - 220*D1**2*fdd*g2*r*s - 88*D1**2*fdd*g2*r + 286*D1**2*fdd*g2*s**2 - 88*D1**2*fdd*g2*s + 44*D1**2*fdd*g2 - 4356*D1*Dd*K*f**2*r**2 - 6424*D1*Dd*K*f**2*r*s + 5390*D1*Dd*K*f**2*r - 2068*D1*Dd*K*f**2*s**2 + 3674*D1*Dd*K*f**2*s - 2123*D1*Dd*K*f**2 + 11440*D1*Dd*K*f*fd*r**2 + 16544*D1*Dd*K*f*fd*r*s - 12716*D1*Dd*K*f*fd*r + 5104*D1*Dd*K*f*fd*s**2 - 8756*D1*Dd*K*f*fd*s + 3498*D1*Dd*K*f*fd - 1056*D1*Dd*b2*f*r**2 - 2112*D1*Dd*b2*f*r*s + 1584*D1*Dd*b2*f*r - 1056*D1*Dd*b2*f*s**2 + 1584*D1*Dd*b2*f*s - 792*D1*Dd*b2*f + 1056*D1*Dd*b2*fd*r**2 + 2112*D1*Dd*b2*fd*r*s - 792*D1*Dd*b2*fd*r + 1056*D1*Dd*b2*fd*s**2 - 792*D1*Dd*b2*fd*s + 4048*D1*Dd*f**3*r**2 + 2256*D1*Dd*f**3*r*s - 3152*D1*Dd*f**3*r - 1792*D1*Dd*f**3*s**2 + 1228*D1*Dd*f**3*s + 116*D1*Dd*f**3 - 10560*D1*Dd*f**2*fd*r**2 + 16992*D1*Dd*f**2*fd*r*s - 4376*D1*Dd*f**2*fd*r + 27552*D1*Dd*f**2*fd*s**2 - 31372*D1*Dd*f**2*fd*s + 8428*D1*Dd*f**2*fd - 44*D1*Dd*f**2*r**2 + 2024*D1*Dd*f**2*r*s - 990*D1*Dd*f**2*r + 2068*D1*Dd*f**2*s**2 - 2574*D1*Dd*f**2*s + 1023*D1*Dd*f**2 - 11440*D1*Dd*f*fd*r**2 - 18656*D1*Dd*f*fd*r*s + 13244*D1*Dd*f*fd*r - 7216*D1*Dd*f*fd*s**2 + 10604*D1*Dd*f*fd*s - 3762*D1*Dd*f*fd + 8360*D1*Dd*f*g2*r**2 + 12848*D1*Dd*f*g2*r*s - 10604*D1*Dd*f*g2*r + 4488*D1*Dd*f*g2*s**2 - 7700*D1*Dd*f*g2*s + 4334*D1*Dd*f*g2 - 4048*D1*Dd*f*gd2*r**2 - 1760*D1*Dd*f*gd2*r*s + 2332*D1*Dd*f*gd2*r + 2288*D1*Dd*f*gd2*s**2 - 3212*D1*Dd*f*gd2*s + 924*D1*Dd*f*gd2 - 4048*D1*Dd*fd*g2*r**2 - 1760*D1*Dd*fd*g2*r*s + 1100*D1*Dd*fd*g2*r + 2288*D1*Dd*fd*g2*s**2 - 1276*D1*Dd*fd*g2*s + 264*D1*Dd*fd*g2 + 2860*D1*Ddd*K*f**2*r**2 + 4136*D1*Ddd*K*f**2*r*s - 3498*D1*Ddd*K*f**2*r + 1276*D1*Ddd*K*f**2*s**2 - 2310*D1*Ddd*K*f**2*s + 1353*D1*Ddd*K*f**2 + 528*D1*Ddd*b2*f*r**2 + 1056*D1*Ddd*b2*f*r*s - 792*D1*Ddd*b2*f*r + 528*D1*Ddd*b2*f*s**2 - 792*D1*Ddd*b2*f*s + 396*D1*Ddd*b2*f - 1760*D1*Ddd*f**3*r**2 + 2832*D1*Ddd*f**3*r*s - 536*D1*Ddd*f**3*r + 4592*D1*Ddd*f**3*s**2 - 5300*D1*Ddd*f**3*s + 1856*D1*Ddd*f**3 - 2860*D1*Ddd*f**2*r**2 - 4664*D1*Ddd*f**2*r*s + 3762*D1*Ddd*f**2*r - 1804*D1*Ddd*f**2*s**2 + 2970*D1*Ddd*f**2*s - 1617*D1*Ddd*f**2 - 2024*D1*Ddd*f*g2*r**2 - 880*D1*Ddd*f*g2*r*s + 1452*D1*Ddd*f*g2*r + 1144*D1*Ddd*f*g2*s**2 - 924*D1*Ddd*f*g2*s + 66*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(6*f**2*(25*r**2 + r*(52*s - 45) + 27*s**2 - 47*s + 23) + f*(14*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 95*K*r**2 - 146*K*r*s + 172*K*r - 51*K*s**2 + 128*K*s - 75*K - 6*fd*(76*r**2 + 2*r*(80*s - 59) + 84*s**2 - 124*s + 41) + 95*r**2 + 170*r*s - 212*r + 75*s**2 - 192*s + 101) + 2*fd*(K*(23*r**2 + r*(10*s - 13) - 13*s**2 + 5*s - 1) - 23*r**2 + r*(16 - 22*s) + s**2 + 4*s + 1) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f**2*(456*r**2 + r*(960*s - 774) + 504*s**2 - 816*s + 327) - f*(K*(92*r**2 + 40*r*s - 93*r - 52*s**2 + 33*s + 9) - 92*r**2 - 88*r*s + 117*r + 4*s**2 + 33*s - 30) + 14*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 264*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 8580*Dd**2*K*f**2*r**2 + 12408*Dd**2*K*f**2*r*s - 10494*Dd**2*K*f**2*r + 3828*Dd**2*K*f**2*s**2 - 6930*Dd**2*K*f**2*s + 2706*Dd**2*K*f**2 + 1584*Dd**2*b2*f*r**2 + 3168*Dd**2*b2*f*r*s - 2376*Dd**2*b2*f*r + 1584*Dd**2*b2*f*s**2 - 2376*Dd**2*b2*f*s + 792*Dd**2*b2*f - 5280*Dd**2*f**3*r**2 + 8496*Dd**2*f**3*r*s - 1608*Dd**2*f**3*r + 13776*Dd**2*f**3*s**2 - 15900*Dd**2*f**3*s + 3712*Dd**2*f**3 - 8580*Dd**2*f**2*r**2 - 13992*Dd**2*f**2*r*s + 11286*Dd**2*f**2*r - 5412*Dd**2*f**2*s**2 + 8910*Dd**2*f**2*s - 3234*Dd**2*f**2 - 6072*Dd**2*f*g2*r**2 - 2640*Dd**2*f*g2*r*s + 4356*Dd**2*f*g2*r + 3432*Dd**2*f*g2*s**2 - 2772*Dd**2*f*g2*s + 132*Dd**2*f*g2) + 1716*b2*(-D1**2*bdd1*f*(r + s - 1)**2 + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd*s - 6*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 2*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2))/(3003*d**2*k3**6) + D1**2*Pk1*Pk3*ct**2*k2**2*st**6*(40*C - 40)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k3**4) + 4*D1**2*Pk1*Pk3*ct**2*k2**2*st**4*(132*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 33*b1*(D1**2*(f*(fd*(C*(-8*r*s + 4*r - 14*s**2 + 14*s - 7) + 4*r*s - 2*r + 10*s**2 - 10*s + 5) + (C - 1)*(-4*bdd1*s*(2*r + 2*s - 1) + fdd*(8*r*s - 4*r + 18*s**2 - 18*s + 9))) + fd**2*(2*C - 2)*(r*(4*s - 2) + s*(9*s - 9))) - 4*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(C*(8*r*s - 4*r + 14*s**2 - 16*s + 7) - 4*r*s + 2*r - 10*s**2 + 11*s - 5) + fd*(4 - 4*C)*(2*s - 1)*(4*r + 9*s - 5)) - Ddd*f*(C - 1)*(r*(8*s - 4) + 18*s**2 - 20*s + 9)) + Dd**2*f**2*(2*C - 2)*(12*r*(2*s - 1) + 54*s**2 - 60*s + 13)) + f*(-132*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1**2*(f*(33*bdd1*s*(C - 1)*(4*r + 9*s - 4) + 2*fd*(8*C*(13*r*(3*s - 1) + 30*s**2 - 33*s + 10) - 99*r*(3*s - 1) - 240*s**2 + 259*s - 80) + fdd*(-8*C*(13*r*(3*s - 1) + 30*s**2 - 33*s + 10) + 99*r*(3*s - 1) + 240*s**2 - 259*s + 80)) + fd**2*(-8*C*(26*r*(3*s - 1) + 60*s**2 - 66*s + 13) + 198*r*(3*s - 1) + 480*s**2 - 518*s + 99)) - 33*D1*bd1*(D1*(f*s*(C*(4*r + 7*s - 4) - 2*r - 5*s + 2) - fd*(2*C - 2)*(r*(8*s - 2) + 18*s**2 - 13*s + 2)) + Dd*f*(8 - 8*C)*(r*(4*s - 1) + 9*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(16*C*(26*r*(2*s - 1) + 40*s**2 - 53*s + 20) - 396*r*(2*s - 1) - 640*s**2 + 838*s - 320) + fd*(-8*C*(26*r*(12*s - 5) + 240*s**2 - 291*s + 79) + 198*r*(12*s - 5) + 1920*s**2 - 2293*s + 617)) + Ddd*f*(-8*C*(26*r*(2*s - 1) + 40*s**2 - 53*s + 20) + 198*r*(2*s - 1) + 320*s**2 - 419*s + 160)) + Dd**2*f**2*(-8*C*(78*r*(2*s - 1) + 120*s**2 - 159*s + 46) + 594*r*(2*s - 1) + 960*s**2 - 1257*s + 358)))/(231*d**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**2*k2**2*st**2*(11*b1**2*(D1**2*(fd*(C*(71*r + 3*s - 3) - 59*r - 3*s + 3) + fdd*(-25*C*r + 23*C*(s - 1) + 19*r - 23*s + 23))*(r + s - 1) + D1*(Dd*(f*(C*(284*r**2 + 296*r*s - 290*r + 12*s**2 - 86*s + 77) - 236*r**2 - 248*r*s + 242*r - 12*s**2 + 74*s - 65) - 2*fd*(C*(100*r**2 + 8*r*s - 31*r - 92*s**2 + 137*s - 45) - 76*r**2 + 16*r*s + 7*r + 92*s**2 - 140*s + 48)) - Ddd*f*(C*(100*r**2 + 8*r*s - 54*r - 92*s**2 + 90*s - 21) - 76*r**2 + 16*r*s + 30*r + 92*s**2 - 96*s + 27)) - 6*Dd**2*f*(C*(50*r**2 + r*(4*s - 27) - 46*s**2 + 45*s - 7) - 38*r**2 + r*(8*s + 15) + 46*s**2 - 48*s + 9)) + 11*b1*(26*C*D1**2*f*fd*r**2 - 176*C*D1**2*f*fd*r*s - 6*C*D1**2*f*fd*r - 54*C*D1**2*f*fd*s**2 - 20*C*D1**2*f*fd*s + 20*C*D1**2*f*fd + 50*C*D1**2*f*fdd*r**2 + 200*C*D1**2*f*fdd*r*s - 34*C*D1**2*f*fdd*r + 50*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd + 50*C*D1**2*fd**2*r**2 + 200*C*D1**2*fd**2*r*s - 34*C*D1**2*fd**2*r + 50*C*D1**2*fd**2*s**2 - 50*C*D1**2*fd**2 + 52*C*D1*Dd*f**2*r**2 - 352*C*D1*Dd*f**2*r*s + 150*C*D1*Dd*f**2*r - 108*C*D1*Dd*f**2*s**2 + 196*C*D1*Dd*f**2*s - 41*C*D1*Dd*f**2 + 400*C*D1*Dd*f*fd*r**2 + 1600*C*D1*Dd*f*fd*r*s - 636*C*D1*Dd*f*fd*r + 400*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 34*C*D1*Dd*f*fd + 100*C*D1*Ddd*f**2*r**2 + 400*C*D1*Ddd*f**2*r*s - 250*C*D1*Ddd*f**2*r + 100*C*D1*Ddd*f**2*s**2 - 200*C*D1*Ddd*f**2*s + 75*C*D1*Ddd*f**2 + 300*C*Dd**2*f**2*r**2 + 1200*C*Dd**2*f**2*r*s - 750*C*Dd**2*f**2*r + 300*C*Dd**2*f**2*s**2 - 600*C*Dd**2*f**2*s + 250*C*Dd**2*f**2 + D1**2*bdd1*f*(C*(-50*r**2 - 4*r*s + 50*r + 46*s**2 + 2*s - 25) + 38*r**2 - 8*r*s - 38*r - 46*s**2 + 4*s + 19) + 238*D1**2*f*fd*r*s - 41*D1**2*f*fd*r + 114*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s + 18*D1**2*f*fd - 44*D1**2*f*fdd*r**2 - 230*D1**2*f*fdd*r*s + 61*D1**2*f*fdd*r - 98*D1**2*f*fdd*s**2 + 54*D1**2*f*fdd*s - 22*D1**2*f*fdd - 44*D1**2*fd**2*r**2 - 230*D1**2*fd**2*r*s + 61*D1**2*fd**2*r - 98*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s + 44*D1**2*fd**2 + 476*D1*Dd*f**2*r*s - 238*D1*Dd*f**2*r + 228*D1*Dd*f**2*s**2 - 347*D1*Dd*f**2*s + 114*D1*Dd*f**2 - 352*D1*Dd*f*fd*r**2 - 1840*D1*Dd*f*fd*r*s + 792*D1*Dd*f*fd*r - 784*D1*Dd*f*fd*s**2 + 838*D1*Dd*f*fd*s - 169*D1*Dd*f*fd - 88*D1*Ddd*f**2*r**2 - 460*D1*Ddd*f**2*r*s + 274*D1*Ddd*f**2*r - 196*D1*Ddd*f**2*s**2 + 311*D1*Ddd*f**2*s - 120*D1*Ddd*f**2 + D1*bd1*(D1*(f*(C*(142*r**2 + 2*r*(74*s - 71) + 6*s**2 - 74*s + 71) - 118*r**2 - 124*r*s + 118*r - 6*s**2 + 62*s - 59) - 2*fd*(C*(50*r**2 + 4*r*s - 27*r - 46*s**2 + 45*s + 1) - 38*r**2 + 8*r*s + 15*r + 46*s**2 - 48*s + 2)) - 2*Dd*f*(C*(200*r**2 + 2*r*(8*s - 77) - 184*s**2 + 86*s + 27) - 152*r**2 + 32*r*s + 106*r + 184*s**2 - 104*s - 15)) - 264*Dd**2*f**2*r**2 - 1380*Dd**2*f**2*r*s + 822*Dd**2*f**2*r - 588*Dd**2*f**2*s**2 + 933*Dd**2*f**2*s - 328*Dd**2*f**2) + f*(-2040*C*D1**2*f*fd*r**2 - 8058*C*D1**2*f*fd*r*s + 4046*C*D1**2*f*fd*r - 3270*C*D1**2*f*fd*s**2 + 4866*C*D1**2*f*fd*s - 1770*C*D1**2*f*fd + 2802*C*D1**2*f*fdd*r**2 + 7494*C*D1**2*f*fdd*r*s - 4366*C*D1**2*f*fdd*r + 2922*C*D1**2*f*fdd*s**2 - 4446*C*D1**2*f*fdd*s + 1908*C*D1**2*f*fdd + 5604*C*D1**2*fd**2*r**2 + 14988*C*D1**2*fd**2*r*s - 8732*C*D1**2*fd**2*r + 5844*C*D1**2*fd**2*s**2 - 8892*C*D1**2*fd**2*s + 2498*C*D1**2*fd**2 - 2720*C*D1*Dd*f**2*r**2 - 10744*C*D1*Dd*f**2*r*s + 6732*C*D1*Dd*f**2*r - 4360*C*D1*Dd*f**2*s**2 + 7046*C*D1*Dd*f**2*s - 2860*C*D1*Dd*f**2 + 22416*C*D1*Dd*f*fd*r**2 + 59952*C*D1*Dd*f*fd*r*s - 38056*C*D1*Dd*f*fd*r + 23376*C*D1*Dd*f*fd*s**2 - 36966*C*D1*Dd*f*fd*s + 13258*C*D1*Dd*f*fd + 3736*C*D1*Ddd*f**2*r**2 + 9992*C*D1*Ddd*f**2*r*s - 6864*C*D1*Ddd*f**2*r + 3896*C*D1*Ddd*f**2*s**2 - 6394*C*D1*Ddd*f**2*s + 2882*C*D1*Ddd*f**2 + 11208*C*Dd**2*f**2*r**2 + 29976*C*Dd**2*f**2*r*s - 20592*C*Dd**2*f**2*r + 11688*C*Dd**2*f**2*s**2 - 19182*C*Dd**2*f**2*s + 6944*C*Dd**2*f**2 - 22*D1**2*bd1**2*(r**2*(25*C - 19) + r*(2*C*s - 25*C + 4*s + 19) - s*(23*C*s + C - 23*s + 2)) + 11*D1**2*bdd1*f*(C*(25*r**2 + 4*r*(25*s - 29) + 25*s**2 - 150*s + 58) - 22*r**2 - 115*r*s + 98*r - 49*s**2 + 159*s - 49) + 1983*D1**2*f*fd*r**2 + 8409*D1**2*f*fd*r*s - 4125*D1**2*f*fd*r + 3972*D1**2*f*fd*s**2 - 5451*D1**2*f*fd*s + 1985*D1**2*f*fd - 2361*D1**2*f*fdd*r**2 - 7455*D1**2*f*fdd*r*s + 4059*D1**2*f*fdd*r - 3570*D1**2*f*fdd*s**2 + 4865*D1**2*f*fdd*s - 1977*D1**2*f*fdd - 4722*D1**2*fd**2*r**2 - 14910*D1**2*fd**2*r*s + 8118*D1**2*fd**2*r - 7140*D1**2*fd**2*s**2 + 9730*D1**2*fd**2*s - 2485*D1**2*fd**2 + 2644*D1*Dd*f**2*r**2 + 11212*D1*Dd*f**2*r*s - 6928*D1*Dd*f**2*r + 5296*D1*Dd*f**2*s**2 - 8099*D1*Dd*f**2*s + 3309*D1*Dd*f**2 - 18888*D1*Dd*f*fd*r**2 - 59640*D1*Dd*f*fd*r*s + 35868*D1*Dd*f*fd*r - 28560*D1*Dd*f*fd*s**2 + 41195*D1*Dd*f*fd*s - 13789*D1*Dd*f*fd - 3148*D1*Ddd*f**2*r**2 - 9940*D1*Ddd*f**2*r*s + 6544*D1*Ddd*f**2*r - 4760*D1*Ddd*f**2*s**2 + 7245*D1*Ddd*f**2*s - 3167*D1*Ddd*f**2 + 11*D1*bd1*(D1*(f*(C*(13*r**2 - 88*r*s + 68*r - 27*s**2 + 162*s - 34) + 119*r*s - 78*r + 57*s**2 - 185*s + 39) + fd*(2*C*(50*r**2 + 200*r*s - 133*r + 50*s**2 - 150*s + 75) - 88*r**2 - 460*r*s + 257*r - 196*s**2 + 372*s - 159)) + Dd*f*(C*(200*r**2 + 800*r*s - 714*r + 200*s**2 - 800*s + 416) - 176*r**2 - 920*r*s + 666*r - 392*s**2 + 947*s - 416)) - 9444*Dd**2*f**2*r**2 - 29820*Dd**2*f**2*r*s + 19632*Dd**2*f**2*r - 14280*Dd**2*f**2*s**2 + 21735*Dd**2*f**2*s - 7350*Dd**2*f**2))/(231*d**2*k3**4) - 2*D1**2*Pk1*Pk3*ct**2*k2**2*(15444*C*D1**2*bd1*f**2*r**2 + 20592*C*D1**2*bd1*f**2*r*s + 10296*C*D1**2*bd1*f**2*r - 5148*C*D1**2*bd1*f**2 - 12870*C*D1**2*f**2*fd*r**2 + 8580*C*D1**2*f**2*fd*r - 4290*C*D1**2*f**2*fd - 17160*C*D1*Dd*f**3*r**2 + 8580*C*D1*Dd*f**3*r - 4290*C*D1*Dd*f**3 - 22308*D1**2*K*bd1**2*f*r**2 - 60060*D1**2*K*bd1**2*f*r*s + 89232*D1**2*K*bd1**2*f*r - 32604*D1**2*K*bd1**2*f*s**2 + 94380*D1**2*K*bd1**2*f*s - 61776*D1**2*K*bd1**2*f + 63921*D1**2*K*bd1*f**2*r**2 + 45474*D1**2*K*bd1*f**2*r*s - 45474*D1**2*K*bd1*f**2*r + 22737*D1**2*K*bd1*f**2*s**2 - 45474*D1**2*K*bd1*f**2*s + 22737*D1**2*K*bd1*f**2 - 144144*D1**2*K*bd1*f*fd*r**2 - 298584*D1**2*K*bd1*f*fd*r*s + 221364*D1**2*K*bd1*f*fd*r - 113256*D1**2*K*bd1*f*fd*s**2 + 187902*D1**2*K*bd1*f*fd*s - 74646*D1**2*K*bd1*f*fd - 36036*D1**2*K*bdd1*f**2*r**2 - 74646*D1**2*K*bdd1*f**2*r*s + 74646*D1**2*K*bdd1*f**2*r - 28314*D1**2*K*bdd1*f**2*s**2 + 56628*D1**2*K*bdd1*f**2*s - 28314*D1**2*K*bdd1*f**2 + 35178*D1**2*bd1**2*f**2*r**2 + 184470*D1**2*bd1**2*f**2*r*s - 117117*D1**2*bd1**2*f**2*r + 149292*D1**2*bd1**2*f**2*s**2 - 208923*D1**2*bd1**2*f**2*s + 83655*D1**2*bd1**2*f**2 + 17160*D1**2*bd1**2*f*r**2 + 115830*D1**2*bd1**2*f*r*s - 98241*D1**2*bd1**2*f*r + 93522*D1**2*bd1**2*f*s**2 - 176319*D1**2*bd1**2*f*s + 82797*D1**2*bd1**2*f - 48048*D1**2*bd1**2*g2*r**2 - 96096*D1**2*bd1**2*g2*r*s + 48048*D1**2*bd1**2*g2*r - 48048*D1**2*bd1**2*g2*s**2 + 48048*D1**2*bd1**2*g2*s - 30030*D1**2*bd1*bd2*f*r**2 - 60060*D1**2*bd1*bd2*f*r*s + 60060*D1**2*bd1*bd2*f*r - 30030*D1**2*bd1*bd2*f*s**2 + 60060*D1**2*bd1*bd2*f*s - 30030*D1**2*bd1*bd2*f - 31473*D1**2*bd1*f**3*r**2 - 63700*D1**2*bd1*f**3*r*s + 59410*D1**2*bd1*f**3*r - 14157*D1**2*bd1*f**3*s**2 + 51480*D1**2*bd1*f**3*s - 34775*D1**2*bd1*f**3 + 167778*D1**2*bd1*f**2*fd*r**2 + 474240*D1**2*bd1*f**2*fd*r*s - 363506*D1**2*bd1*f**2*fd*r + 162162*D1**2*bd1*f**2*fd*s**2 - 324428*D1**2*bd1*f**2*fd*s + 119340*D1**2*bd1*f**2*fd - 54054*D1**2*bd1*f**2*r**2 - 70356*D1**2*bd1*f**2*r*s + 39468*D1**2*bd1*f**2*r - 40755*D1**2*bd1*f**2*s**2 + 76362*D1**2*bd1*f**2*s - 30459*D1**2*bd1*f**2 + 108108*D1**2*bd1*f*fd*r**2 + 360360*D1**2*bd1*f*fd*r*s - 234234*D1**2*bd1*f*fd*r + 216216*D1**2*bd1*f*fd*s**2 - 306306*D1**2*bd1*f*fd*s + 90090*D1**2*bd1*f*fd + 3432*D1**2*bd1*f*g2*r**2 + 36036*D1**2*bd1*f*g2*r*s + 104676*D1**2*bd1*f*g2*r - 35178*D1**2*bd1*f*g2*s**2 + 30888*D1**2*bd1*f*g2*s - 52338*D1**2*bd1*f*g2 + 44616*D1**2*bd1*f*gd2*r**2 + 120120*D1**2*bd1*f*gd2*r*s - 178464*D1**2*bd1*f*gd2*r + 65208*D1**2*bd1*f*gd2*s**2 - 188760*D1**2*bd1*f*gd2*s + 123552*D1**2*bd1*f*gd2 + 44616*D1**2*bd1*fd*g2*r**2 + 120120*D1**2*bd1*fd*g2*r*s - 44616*D1**2*bd1*fd*g2*r + 65208*D1**2*bd1*fd*g2*s**2 - 60060*D1**2*bd1*fd*g2*s + 18018*D1**2*bd2*f**2*r**2 + 25740*D1**2*bd2*f**2*r*s - 25740*D1**2*bd2*f**2*r + 7722*D1**2*bd2*f**2*s**2 - 15444*D1**2*bd2*f**2*s + 7722*D1**2*bd2*f**2 - 72072*D1**2*bd2*f*fd*r**2 - 123552*D1**2*bd2*f*fd*r*s + 97812*D1**2*bd2*f*fd*r - 51480*D1**2*bd2*f*fd*s**2 + 82368*D1**2*bd2*f*fd*s - 30888*D1**2*bd2*f*fd + 27963*D1**2*bdd1*f**3*r**2 + 79040*D1**2*bdd1*f**3*r*s - 74750*D1**2*bdd1*f**3*r + 27027*D1**2*bdd1*f**3*s**2 - 68640*D1**2*bdd1*f**3*s + 46345*D1**2*bdd1*f**3 + 27027*D1**2*bdd1*f**2*r**2 + 90090*D1**2*bdd1*f**2*r*s - 90090*D1**2*bdd1*f**2*r + 54054*D1**2*bdd1*f**2*s**2 - 108108*D1**2*bdd1*f**2*s + 54054*D1**2*bdd1*f**2 + 22308*D1**2*bdd1*f*g2*r**2 + 60060*D1**2*bdd1*f*g2*r*s - 118404*D1**2*bdd1*f*g2*r + 32604*D1**2*bdd1*f*g2*s**2 - 123552*D1**2*bdd1*f*g2*s + 59202*D1**2*bdd1*f*g2 - 18018*D1**2*bdd2*f**2*r**2 - 30888*D1**2*bdd2*f**2*r*s + 30888*D1**2*bdd2*f**2*r - 12870*D1**2*bdd2*f**2*s**2 + 25740*D1**2*bdd2*f**2*s - 12870*D1**2*bdd2*f**2 + 32380*D1**2*f**3*fd*r**2 + 124020*D1**2*f**3*fd*r*s - 78200*D1**2*f**3*fd*r + 154440*D1**2*f**3*fd*s**2 - 185445*D1**2*f**3*fd*s + 85315*D1**2*f**3*fd - 15020*D1**2*f**3*fdd*r**2 - 124020*D1**2*f**3*fdd*r*s + 69520*D1**2*f**3*fdd*r - 154440*D1**2*f**3*fdd*s**2 + 185445*D1**2*f**3*fdd*s - 80975*D1**2*f**3*fdd - 45060*D1**2*f**2*fd**2*r**2 - 372060*D1**2*f**2*fd**2*r*s + 208560*D1**2*f**2*fd**2*r - 463320*D1**2*f**2*fd**2*s**2 + 556335*D1**2*f**2*fd**2*s - 139230*D1**2*f**2*fd**2 + 25740*D1**2*f**2*fd*r**2 + 12870*D1**2*f**2*fd*r*s - 21450*D1**2*f**2*fd*r - 4290*D1**2*f**2*fd*s + 8580*D1**2*f**2*fd - 127842*D1**2*f**2*gd2*r**2 - 90948*D1**2*f**2*gd2*r*s + 90948*D1**2*f**2*gd2*r - 45474*D1**2*f**2*gd2*s**2 + 90948*D1**2*f**2*gd2*s - 45474*D1**2*f**2*gd2 + 72072*D1**2*f**2*gdd2*r**2 + 149292*D1**2*f**2*gdd2*r*s - 149292*D1**2*f**2*gdd2*r + 56628*D1**2*f**2*gdd2*s**2 - 113256*D1**2*f**2*gdd2*s + 56628*D1**2*f**2*gdd2 - 255684*D1**2*f*fd*g2*r**2 - 181896*D1**2*f*fd*g2*r*s + 255684*D1**2*f*fd*g2*r - 90948*D1**2*f*fd*g2*s**2 + 90948*D1**2*f*fd*g2*s - 127842*D1**2*f*fd*g2 + 288288*D1**2*f*fd*gd2*r**2 + 597168*D1**2*f*fd*gd2*r*s - 442728*D1**2*f*fd*gd2*r + 226512*D1**2*f*fd*gd2*s**2 - 375804*D1**2*f*fd*gd2*s + 149292*D1**2*f*fd*gd2 + 144144*D1**2*f*fdd*g2*r**2 + 298584*D1**2*f*fdd*g2*r*s - 144144*D1**2*f*fdd*g2*r + 113256*D1**2*f*fdd*g2*s**2 - 149292*D1**2*f*fdd*g2*s + 72072*D1**2*f*fdd*g2 + 144144*D1**2*fd**2*g2*r**2 + 298584*D1**2*fd**2*g2*r*s - 144144*D1**2*fd**2*g2*r + 113256*D1**2*fd**2*g2*s**2 - 149292*D1**2*fd**2*g2*s - 288288*D1*Dd*K*bd1*f**2*r**2 - 597168*D1*Dd*K*bd1*f**2*r*s + 519948*D1*Dd*K*bd1*f**2*r - 226512*D1*Dd*K*bd1*f**2*s**2 + 414414*D1*Dd*K*bd1*f**2*s - 187902*D1*Dd*K*bd1*f**2 + 223704*D1*Dd*bd1*f**3*r**2 + 632320*D1*Dd*bd1*f**3*r*s - 513006*D1*Dd*bd1*f**3*r + 216216*D1*Dd*bd1*f**3*s**2 - 461708*D1*Dd*bd1*f**3*s + 212030*D1*Dd*bd1*f**3 + 216216*D1*Dd*bd1*f**2*r**2 + 720720*D1*Dd*bd1*f**2*r*s - 594594*D1*Dd*bd1*f**2*r + 432432*D1*Dd*bd1*f**2*s**2 - 738738*D1*Dd*bd1*f**2*s + 306306*D1*Dd*bd1*f**2 + 178464*D1*Dd*bd1*f*g2*r**2 + 480480*D1*Dd*bd1*f*g2*r*s - 638352*D1*Dd*bd1*f*g2*r + 260832*D1*Dd*bd1*f*g2*s**2 - 684684*D1*Dd*bd1*f*g2*s + 365508*D1*Dd*bd1*f*g2 - 144144*D1*Dd*bd2*f**2*r**2 - 247104*D1*Dd*bd2*f**2*r*s + 221364*D1*Dd*bd2*f**2*r - 102960*D1*Dd*bd2*f**2*s**2 + 185328*D1*Dd*bd2*f**2*s - 82368*D1*Dd*bd2*f**2 + 32380*D1*Dd*f**4*r**2 + 124020*D1*Dd*f**4*r*s - 78200*D1*Dd*f**4*r + 154440*D1*Dd*f**4*s**2 - 185445*D1*Dd*f**4*s + 85315*D1*Dd*f**4 - 120160*D1*Dd*f**3*fd*r**2 - 992160*D1*Dd*f**3*fd*r*s + 556160*D1*Dd*f**3*fd*r - 1235520*D1*Dd*f**3*fd*s**2 + 1483560*D1*Dd*f**3*fd*s - 440410*D1*Dd*f**3*fd + 34320*D1*Dd*f**3*r**2 + 17160*D1*Dd*f**3*r*s - 25740*D1*Dd*f**3*r - 4290*D1*Dd*f**3*s + 8580*D1*Dd*f**3 - 511368*D1*Dd*f**2*g2*r**2 - 363792*D1*Dd*f**2*g2*r*s + 437580*D1*Dd*f**2*g2*r - 181896*D1*Dd*f**2*g2*s**2 + 272844*D1*Dd*f**2*g2*s - 218790*D1*Dd*f**2*g2 + 576576*D1*Dd*f**2*gd2*r**2 + 1194336*D1*Dd*f**2*gd2*r*s - 1039896*D1*Dd*f**2*gd2*r + 453024*D1*Dd*f**2*gd2*s**2 - 828828*D1*Dd*f**2*gd2*s + 375804*D1*Dd*f**2*gd2 + 1153152*D1*Dd*f*fd*g2*r**2 + 2388672*D1*Dd*f*fd*g2*r*s - 1462032*D1*Dd*f*fd*g2*r + 906048*D1*Dd*f*fd*g2*s**2 - 1348776*D1*Dd*f*fd*g2*s + 442728*D1*Dd*f*fd*g2 - 15020*D1*Ddd*f**4*r**2 - 124020*D1*Ddd*f**4*r*s + 69520*D1*Ddd*f**4*r - 154440*D1*Ddd*f**4*s**2 + 185445*D1*Ddd*f**4*s - 80975*D1*Ddd*f**4 + 288288*D1*Ddd*f**2*g2*r**2 + 597168*D1*Ddd*f**2*g2*r*s - 442728*D1*Ddd*f**2*g2*r + 226512*D1*Ddd*f**2*g2*s**2 - 375804*D1*Ddd*f**2*g2*s + 185328*D1*Ddd*f**2*g2 - 45060*Dd**2*f**4*r**2 - 372060*Dd**2*f**4*r*s + 208560*Dd**2*f**4*r - 463320*Dd**2*f**4*s**2 + 556335*Dd**2*f**4*s - 139230*Dd**2*f**4 + 864864*Dd**2*f**2*g2*r**2 + 1791504*Dd**2*f**2*g2*r*s - 1328184*Dd**2*f**2*g2*r + 679536*Dd**2*f**2*g2*s**2 - 1127412*Dd**2*f**2*g2*s + 411840*Dd**2*f**2*g2 + 3003*b1**3*(D1**2*(fd*(r + 3*s - 3) + fdd*(-3*r - 5*s + 5))*(r + s - 1) + D1*(Dd*f*(4*r**2 + 2*r*(8*s - 5) + 12*s**2 - 16*s + 7) - 2*Dd*(4*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + fd*(12*r**2 + r*(32*s - 27) + 20*s**2 - 34*s + 14) - 8*r**2 - 24*r*s + 16*r - 16*s**2 + 22*s - 10) - Ddd*f*(12*r**2 + r*(32*s - 22) + 20*s**2 - 28*s + 13) - 2*Ddd*(-2*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4*r**2 + 4*r*(3*s - 2) + 8*s**2 - 11*s + 5)) - 2*Dd**2*(-12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(18*r**2 + r*(48*s - 33) + 30*s**2 - 42*s + 13) + 12*r**2 + 36*r*s - 24*r + 24*s**2 - 33*s + 10)) + 429*b1**2*(56*C*D1**2*fd*r**2 + 56*C*D1**2*fd*r*s - 56*C*D1**2*fd*r + 224*C*D1*Dd*f*r**2 + 224*C*D1*Dd*f*r*s - 224*C*D1*Dd*f*r - 56*C*D1*Dd*f*s + 56*C*D1*Dd*f - 4*D1**2*K*fd*r**2 - 42*D1**2*K*fd*r*s + 130*D1**2*K*fd*r + 41*D1**2*K*fd*s**2 + 78*D1**2*K*fd*s - 65*D1**2*K*fd - 26*D1**2*K*fdd*r**2 - 70*D1**2*K*fdd*r*s - 86*D1**2*K*fdd*r - 38*D1**2*K*fdd*s**2 - 74*D1**2*K*fdd*s + 43*D1**2*K*fdd - 7*D1**2*bdd1*(-4*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(9*r**2 + 2*r*(12*s - 7) + 15*s**2 - 18*s + 8) + 6*r**2 + 18*r*s - 10*r + 12*s**2 - 14*s + 6) - 50*D1**2*f*fd*r**2 - 350*D1**2*f*fd*r*s + 187*D1**2*f*fd*r - 300*D1**2*f*fd*s**2 + 368*D1**2*f*fd*s - 182*D1**2*f*fd + 82*D1**2*f*fdd*r**2 + 430*D1**2*f*fdd*r*s - 239*D1**2*f*fdd*r + 348*D1**2*f*fdd*s**2 - 424*D1**2*f*fdd*s + 214*D1**2*f*fdd + 82*D1**2*fd**2*r**2 + 430*D1**2*fd**2*r*s - 239*D1**2*fd**2*r + 348*D1**2*fd**2*s**2 - 424*D1**2*fd**2*s + 76*D1**2*fd**2 - 68*D1**2*fd*r**2 - 81*D1**2*fd*r*s - 24*D1**2*fd*r - 92*D1**2*fd*s**2 - 46*D1**2*fd*s + 33*D1**2*fd + 20*D1**2*fdd*r**2 + 135*D1**2*fdd*r*s + 54*D1**2*fdd*r + 109*D1**2*fdd*s**2 + 58*D1**2*fdd*s - 27*D1**2*fdd + 112*D1**2*gd2*r**2 + 224*D1**2*gd2*r*s - 224*D1**2*gd2*r + 112*D1**2*gd2*s**2 - 224*D1**2*gd2*s + 112*D1**2*gd2 - 56*D1**2*gdd2*r**2 - 112*D1**2*gdd2*r*s + 112*D1**2*gdd2*r - 56*D1**2*gdd2*s**2 + 112*D1**2*gdd2*s - 56*D1**2*gdd2 - 16*D1*Dd*K*f*r**2 - 168*D1*Dd*K*f*r*s + 92*D1*Dd*K*f*r + 164*D1*Dd*K*f*s**2 - 122*D1*Dd*K*f*s + 78*D1*Dd*K*f - 208*D1*Dd*K*fd*r**2 - 560*D1*Dd*K*fd*r*s - 152*D1*Dd*K*fd*r - 304*D1*Dd*K*fd*s**2 - 74*D1*Dd*K*fd*s + 234*D1*Dd*K*fd - 100*D1*Dd*f**2*r**2 - 700*D1*Dd*f**2*r*s + 400*D1*Dd*f**2*r - 600*D1*Dd*f**2*s**2 + 775*D1*Dd*f**2*s - 325*D1*Dd*f**2 + 656*D1*Dd*f*fd*r**2 + 3440*D1*Dd*f*fd*r*s - 1980*D1*Dd*f*fd*r + 2784*D1*Dd*f*fd*s**2 - 3518*D1*Dd*f*fd*s + 1087*D1*Dd*f*fd - 272*D1*Dd*f*r**2 - 324*D1*Dd*f*r*s + 298*D1*Dd*f*r - 368*D1*Dd*f*s**2 + 449*D1*Dd*f*s - 252*D1*Dd*f + 160*D1*Dd*fd*r**2 + 1080*D1*Dd*fd*r*s - 94*D1*Dd*fd*r + 872*D1*Dd*fd*s**2 - 339*D1*Dd*fd*s - 170*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 896*D1*Dd*g2*r*s - 672*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 672*D1*Dd*g2*s + 336*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 896*D1*Dd*gd2*r*s + 784*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 784*D1*Dd*gd2*s - 336*D1*Dd*gd2 - 104*D1*Ddd*K*f*r**2 - 280*D1*Ddd*K*f*r*s + 192*D1*Ddd*K*f*r - 152*D1*Ddd*K*f*s**2 + 222*D1*Ddd*K*f*s - 102*D1*Ddd*K*f + 164*D1*Ddd*f**2*r**2 + 860*D1*Ddd*f**2*r*s - 512*D1*Ddd*f**2*r + 696*D1*Ddd*f**2*s**2 - 911*D1*Ddd*f**2*s + 389*D1*Ddd*f**2 + 80*D1*Ddd*f*r**2 + 540*D1*Ddd*f*r*s - 310*D1*Ddd*f*r + 436*D1*Ddd*f*s**2 - 571*D1*Ddd*f*s + 238*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 448*D1*Ddd*g2*r*s + 336*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 336*D1*Ddd*g2*s - 168*D1*Ddd*g2 + 7*D1*bd1*(D1*(-8*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(3*r**2 + 6*r*(2*s - 1) + 9*s**2 - 10*s + 4) - 2*fd*(9*r**2 + 24*r*s - 19*r + 15*s**2 - 24*s + 9) + 12*r**2 + 36*r*s - 20*r + 24*s**2 - 28*s + 12) - 2*Dd*(-4*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(36*r**2 + r*(96*s - 61) + 60*s**2 - 78*s + 25) + 24*r**2 + 72*r*s - 44*r + 48*s**2 - 61*s + 19)) - 312*Dd**2*K*f*r**2 - 840*Dd**2*K*f*r*s + 576*Dd**2*K*f*r - 456*Dd**2*K*f*s**2 + 666*Dd**2*K*f*s - 216*Dd**2*K*f + 492*Dd**2*f**2*r**2 + 2580*Dd**2*f**2*r*s - 1536*Dd**2*f**2*r + 2088*Dd**2*f**2*s**2 - 2733*Dd**2*f**2*s + 778*Dd**2*f**2 + 240*Dd**2*f*r**2 + 1620*Dd**2*f*r*s - 930*Dd**2*f*r + 1308*Dd**2*f*s**2 - 1713*Dd**2*f*s + 488*Dd**2*f - 672*Dd**2*g2*r**2 - 1344*Dd**2*g2*r*s + 1008*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 1008*Dd**2*g2*s - 336*Dd**2*g2) - 13*b1*(-2376*C*D1**2*f*fd*r**2 - 3168*C*D1**2*f*fd*r*s + 4752*C*D1**2*f*fd*r + 1584*C*D1**2*f*fd*s - 1584*C*D1**2*f*fd - 4752*C*D1*Dd*f**2*r**2 - 6336*C*D1*Dd*f**2*r*s + 5544*C*D1*Dd*f**2*r + 1584*C*D1*Dd*f**2*s - 1188*C*D1*Dd*f**2 + 1716*D1**2*K*bdd1*f*r**2 + 4620*D1**2*K*bdd1*f*r*s - 6864*D1**2*K*bdd1*f*r + 2508*D1**2*K*bdd1*f*s**2 - 7260*D1**2*K*bdd1*f*s + 3531*D1**2*K*bdd1*f - 9834*D1**2*K*f*fd*r**2 - 6996*D1**2*K*f*fd*r*s + 9834*D1**2*K*f*fd*r - 3498*D1**2*K*f*fd*s**2 + 3498*D1**2*K*f*fd*s - 4917*D1**2*K*f*fd + 5544*D1**2*K*f*fdd*r**2 + 11484*D1**2*K*f*fdd*r*s - 5544*D1**2*K*f*fdd*r + 4356*D1**2*K*f*fdd*s**2 - 5742*D1**2*K*f*fdd*s + 2772*D1**2*K*f*fdd + 5544*D1**2*K*fd**2*r**2 + 11484*D1**2*K*fd**2*r*s - 5544*D1**2*K*fd**2*r + 4356*D1**2*K*fd**2*s**2 - 5742*D1**2*K*fd**2*s - 693*D1**2*b2*fd*r**2 - 1386*D1**2*b2*fd*r*s - 693*D1**2*b2*fd*s**2 + 1155*D1**2*b2*fdd*r**2 + 2310*D1**2*b2*fdd*r*s + 1155*D1**2*b2*fdd*s**2 + 462*D1**2*bd1**2*(-4*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(9*r**2 + 2*r*(12*s - 7) + 15*s**2 - 18*s + 4) + 6*r**2 + 18*r*s - 10*r + 12*s**2 - 14*s + 3) - 2706*D1**2*bdd1*f**2*r**2 - 14190*D1**2*bdd1*f**2*r*s + 9009*D1**2*bdd1*f**2*r - 11484*D1**2*bdd1*f**2*s**2 + 16071*D1**2*bdd1*f**2*s - 5775*D1**2*bdd1*f**2 - 1320*D1**2*bdd1*f*r**2 - 8910*D1**2*bdd1*f*r*s + 7557*D1**2*bdd1*f*r - 7194*D1**2*bdd1*f*s**2 + 13563*D1**2*bdd1*f*s - 5148*D1**2*bdd1*f + 3696*D1**2*bdd1*g2*r**2 + 7392*D1**2*bdd1*g2*r*s - 3696*D1**2*bdd1*g2*r + 3696*D1**2*bdd1*g2*s**2 - 3696*D1**2*bdd1*g2*s + 1848*D1**2*bdd1*g2 + 1155*D1**2*bdd2*f*r**2 + 2310*D1**2*bdd2*f*r*s - 2310*D1**2*bdd2*f*r + 1155*D1**2*bdd2*f*s**2 - 2310*D1**2*bdd2*f*s + 1155*D1**2*bdd2*f + 7263*D1**2*f**2*fd*r**2 + 14700*D1**2*f**2*fd*r*s - 10072*D1**2*f**2*fd*r + 3267*D1**2*f**2*fd*s**2 - 5296*D1**2*f**2*fd*s + 1924*D1**2*f**2*fd - 6453*D1**2*f**2*fdd*r**2 - 18240*D1**2*f**2*fdd*r*s + 10712*D1**2*f**2*fdd*r - 6237*D1**2*f**2*fdd*s**2 + 9116*D1**2*f**2*fdd*s - 2744*D1**2*f**2*fdd - 12906*D1**2*f*fd**2*r**2 - 36480*D1**2*f*fd**2*r*s + 21424*D1**2*f*fd**2*r - 12474*D1**2*f*fd**2*s**2 + 18232*D1**2*f*fd**2*s - 7138*D1**2*f*fd**2 + 8316*D1**2*f*fd*r**2 + 10824*D1**2*f*fd*r*s - 10692*D1**2*f*fd*r + 6270*D1**2*f*fd*s**2 - 5808*D1**2*f*fd*s + 4950*D1**2*f*fd - 4158*D1**2*f*fdd*r**2 - 13860*D1**2*f*fdd*r*s + 4158*D1**2*f*fdd*r - 8316*D1**2*f*fdd*s**2 + 6930*D1**2*f*fdd*s - 2079*D1**2*f*fdd - 264*D1**2*f*gd2*r**2 - 2772*D1**2*f*gd2*r*s + 2772*D1**2*f*gd2*r + 2706*D1**2*f*gd2*s**2 - 5412*D1**2*f*gd2*s + 2706*D1**2*f*gd2 - 1716*D1**2*f*gdd2*r**2 - 4620*D1**2*f*gdd2*r*s + 4620*D1**2*f*gdd2*r - 2508*D1**2*f*gdd2*s**2 + 5016*D1**2*f*gdd2*s - 2508*D1**2*f*gdd2 - 4158*D1**2*fd**2*r**2 - 13860*D1**2*fd**2*r*s + 4158*D1**2*fd**2*r - 8316*D1**2*fd**2*s**2 + 6930*D1**2*fd**2*s - 264*D1**2*fd*g2*r**2 - 2772*D1**2*fd*g2*r*s + 8580*D1**2*fd*g2*r + 2706*D1**2*fd*g2*s**2 + 5148*D1**2*fd*g2*s - 4290*D1**2*fd*g2 - 3432*D1**2*fd*gd2*r**2 - 9240*D1**2*fd*gd2*r*s - 1056*D1**2*fd*gd2*r - 5016*D1**2*fd*gd2*s**2 + 132*D1**2*fd*gd2*s + 4884*D1**2*fd*gd2 - 1716*D1**2*fdd*g2*r**2 - 4620*D1**2*fdd*g2*r*s - 5676*D1**2*fdd*g2*r - 2508*D1**2*fdd*g2*s**2 - 4884*D1**2*fdd*g2*s + 2838*D1**2*fdd*g2 - 19668*D1*Dd*K*f**2*r**2 - 13992*D1*Dd*K*f**2*r*s + 16830*D1*Dd*K*f**2*r - 6996*D1*Dd*K*f**2*s**2 + 10494*D1*Dd*K*f**2*s - 8415*D1*Dd*K*f**2 + 44352*D1*Dd*K*f*fd*r**2 + 91872*D1*Dd*K*f*fd*r*s - 56232*D1*Dd*K*f*fd*r + 34848*D1*Dd*K*f*fd*s**2 - 51876*D1*Dd*K*f*fd*s + 17028*D1*Dd*K*f*fd - 2772*D1*Dd*b2*f*r**2 - 5544*D1*Dd*b2*f*r*s + 4158*D1*Dd*b2*f*r - 2772*D1*Dd*b2*f*s**2 + 4158*D1*Dd*b2*f*s - 2079*D1*Dd*b2*f + 9240*D1*Dd*b2*fd*r**2 + 18480*D1*Dd*b2*fd*r*s - 6930*D1*Dd*b2*fd*r + 9240*D1*Dd*b2*fd*s**2 - 6930*D1*Dd*b2*fd*s + 9684*D1*Dd*f**3*r**2 + 19600*D1*Dd*f**3*r*s - 14642*D1*Dd*f**3*r + 4356*D1*Dd*f**3*s**2 - 9256*D1*Dd*f**3*s + 4599*D1*Dd*f**3 - 51624*D1*Dd*f**2*fd*r**2 - 145920*D1*Dd*f**2*fd*r*s + 92234*D1*Dd*f**2*fd*r - 49896*D1*Dd*f**2*fd*s**2 + 79652*D1*Dd*f**2*fd*s - 28944*D1*Dd*f**2*fd + 16632*D1*Dd*f**2*r**2 + 21648*D1*Dd*f**2*r*s - 19140*D1*Dd*f**2*r + 12540*D1*Dd*f**2*s**2 - 17952*D1*Dd*f**2*s + 10428*D1*Dd*f**2 - 33264*D1*Dd*f*fd*r**2 - 110880*D1*Dd*f*fd*r*s + 52668*D1*Dd*f*fd*r - 66528*D1*Dd*f*fd*s**2 + 74844*D1*Dd*f*fd*s - 18018*D1*Dd*f*fd - 1056*D1*Dd*f*g2*r**2 - 11088*D1*Dd*f*g2*r*s + 6072*D1*Dd*f*g2*r + 10824*D1*Dd*f*g2*s**2 - 8052*D1*Dd*f*g2*s + 5148*D1*Dd*f*g2 - 13728*D1*Dd*f*gd2*r**2 - 36960*D1*Dd*f*gd2*r*s + 31152*D1*Dd*f*gd2*r - 20064*D1*Dd*f*gd2*s**2 + 34716*D1*Dd*f*gd2*s - 14652*D1*Dd*f*gd2 - 13728*D1*Dd*fd*g2*r**2 - 36960*D1*Dd*fd*g2*r*s - 10032*D1*Dd*fd*g2*r - 20064*D1*Dd*fd*g2*s**2 - 4884*D1*Dd*fd*g2*s + 15444*D1*Dd*fd*g2 + 11088*D1*Ddd*K*f**2*r**2 + 22968*D1*Ddd*K*f**2*r*s - 17028*D1*Ddd*K*f**2*r + 8712*D1*Ddd*K*f**2*s**2 - 14454*D1*Ddd*K*f**2*s + 7128*D1*Ddd*K*f**2 + 4620*D1*Ddd*b2*f*r**2 + 9240*D1*Ddd*b2*f*r*s - 6930*D1*Ddd*b2*f*r + 4620*D1*Ddd*b2*f*s**2 - 6930*D1*Ddd*b2*f*s + 3465*D1*Ddd*b2*f - 8604*D1*Ddd*f**3*r**2 - 24320*D1*Ddd*f**3*r*s + 16462*D1*Ddd*f**3*r - 8316*D1*Ddd*f**3*s**2 + 14396*D1*Ddd*f**3*s - 6309*D1*Ddd*f**3 - 8316*D1*Ddd*f**2*r**2 - 27720*D1*Ddd*f**2*r*s + 18018*D1*Ddd*f**2*r - 16632*D1*Ddd*f**2*s**2 + 23562*D1*Ddd*f**2*s - 10395*D1*Ddd*f**2 - 6864*D1*Ddd*f*g2*r**2 - 18480*D1*Ddd*f*g2*r*s + 12672*D1*Ddd*f*g2*r - 10032*D1*Ddd*f*g2*s**2 + 14652*D1*Ddd*f*g2*s - 6732*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(f**2*(50*r**2 + r*(350*s - 213) + 300*s**2 - 407*s + 143) + f*(-56*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 8*K*r**2 + 84*K*r*s + 80*K*r - 82*K*s**2 + 118*K*s - 102*K - fd*(328*r**2 + 8*r*(215*s - 128) + 1392*s**2 - 1822*s + 507) + 136*r**2 + 162*r*s - 241*r + 184*s**2 - 311*s + 193) + fd*(2*K*(52*r**2 + 2*r*(70*s - 9) + 76*s**2 - 36*s - 37) - 80*r**2 + r*(121 - 540*s) - 436*s**2 + 295*s + 58) - 112*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 112*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*(-f**2*(656*r**2 + 4*r*(860*s - 529) + 2784*s**2 - 3770*s + 1247) + f*(4*K*(104*r**2 + 8*r*(35*s - 38) + 152*s**2 - 331*s + 162) - 320*r**2 - 48*r*(45*s - 32) - 1744*s**2 + 2786*s - 1051) + 112*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 231*D1*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 33264*Dd**2*K*f**2*r**2 + 68904*Dd**2*K*f**2*r*s - 51084*Dd**2*K*f**2*r + 26136*Dd**2*K*f**2*s**2 - 43362*Dd**2*K*f**2*s + 15840*Dd**2*K*f**2 + 13860*Dd**2*b2*f*r**2 + 27720*Dd**2*b2*f*r*s - 20790*Dd**2*b2*f*r + 13860*Dd**2*b2*f*s**2 - 20790*Dd**2*b2*f*s + 6930*Dd**2*b2*f - 25812*Dd**2*f**3*r**2 - 72960*Dd**2*f**3*r*s + 49386*Dd**2*f**3*r - 24948*Dd**2*f**3*s**2 + 43188*Dd**2*f**3*s - 16318*Dd**2*f**3 - 24948*Dd**2*f**2*r**2 - 83160*Dd**2*f**2*r*s + 54054*Dd**2*f**2*r - 49896*Dd**2*f**2*s**2 + 70686*Dd**2*f**2*s - 22176*Dd**2*f**2 - 20592*Dd**2*f*g2*r**2 - 55440*Dd**2*f*g2*r*s + 38016*Dd**2*f*g2*r - 30096*Dd**2*f*g2*s**2 + 43956*Dd**2*f*g2*s - 14256*Dd**2*f*g2) + 429*b2*(-35*D1**2*bdd1*f*(r + s - 1)**2 + 6*D1**2*(f*(fd*(14*r**2 + 20*r*s - 14*r + 6*s**2 - 10*s + 7) - fdd*(14*r**2 + 24*r*s - 14*r + 10*s**2 - 12*s + 7)) - 2*fd**2*(7*r**2 + r*(12*s - 7) + s*(5*s - 6))) + 7*D1*bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 6*D1*f*(Dd*(f*(28*r**2 + 40*r*s - 34*r + 12*s**2 - 22*s + 13) - 2*fd*(56*r**2 + 96*r*s - 66*r + 40*s**2 - 56*s + 19)) - Ddd*f*(28*r**2 + r*(48*s - 38) + 20*s**2 - 32*s + 17)) - 12*Dd**2*f**2*(42*r**2 + r*(72*s - 57) + 30*s**2 - 48*s + 17)))/(9009*d**2*k3**4) + 8*D1**2*Pk1*Pk3*ct**2*st**4*(-132*D1*b1*s*(C - 1)*(D1*bdd1*f*s + 2*bd1*(-D1*f*s + D1*fd*(s - 1) + 2*Dd*f*(2*s - 1))) + 66*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(30*C - 25)*(2*fd - fdd)*(3*s**2 - 2*s + 1) - 2*s*(66*bd1**2*s*(C - 1) + fd**2*(30*C - 25)*(3*s - 2))) + D1*f*(60*C - 50)*(2*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-6*s**2 + 5*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) + Dd**2*f**2*(50 - 60*C)*(6*s**2 - 6*s + 1)))/(231*d**2*k3**2) + 2*D1**2*Pk1*Pk3*ct**2*st**2*(11*b1**2*(D1**2*(s - 1)*(3*fd*(C*(16*r + s - 1) - 12*r - s + 1) + fdd*(-24*C*r + 23*C*(s - 1) + 18*r - 23*s + 23)) + 2*D1*(Dd*(3*f*(C*(32*r*s - 16*r + 2*s**2 - 10*s + 1) - 24*r*s + 12*r - 2*s**2 + 8*s - 1) + fd*(C*(-96*r*s + 72*r + 92*s**2 - 126*s + 34) + 72*r*s - 54*r - 92*s**2 + 129*s - 37)) + Ddd*f*(C*(-48*r*s + 24*r + 46*s**2 - 34*s + 23) + 36*r*s - 18*r - 46*s**2 + 37*s - 23)) - 2*Dd**2*f*(C*(72*r*(2*s - 1) - 138*s**2 + 102*s + 1) - 54*r*(2*s - 1) + 138*s**2 - 111*s + 5)) + 11*b1*(D1**2*(f*(2*bdd1*s*(C*(-24*r + 23*s + 12) + 18*r - 23*s - 9) + fd*(C*(16*r*s - 8*r - 78*s**2 + 46*s - 39) - 8*r*s + 4*r + 102*s**2 - 78*s + 51) + fdd*(C*(74*s**2 - 50*s + 37) - 86*s**2 + 68*s - 43)) + 2*fd**2*(s - 1)*(C*(37*s + 12) - 43*s - 9)) + 2*D1*bd1*(D1*(3*f*s*(C*(16*r + s - 8) - 12*r - s + 6) + fd*(-2*C*(24*r*s - 12*r - 23*s**2 + 17*s + 6) + 36*r*s - 18*r - 46*s**2 + 37*s + 9)) - 2*Dd*f*(2*C*(48*r*s - 12*r - 46*s**2 + 5*s + 6) - 72*r*s + 18*r + 92*s**2 - 19*s - 9)) + 2*D1*f*(Dd*f*(C*(8*r*(2*s - 1) - 78*s**2 + 74*s - 39) + r*(4 - 8*s) + 102*s**2 - 100*s + 51) + 2*Dd*fd*(2*s - 1)*(C*(74*s - 25) - 86*s + 34) + Ddd*f*(37*C - 43)*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(74*C - 86)*(6*s**2 - 6*s + 1)) + f*(22*D1**2*bd1**2*s*(C*(-24*r + 23*s + 12) + 18*r - 23*s - 9) + D1**2*(f*(11*bdd1*s*(C*(37*s - 24) - 43*s + 18) - 2*fd*(C*(128*r*(3*s - 1) + 1089*s**2 - 854*s + 363) - 306*r*s + 102*r - 1191*s**2 + 896*s - 397) + 2*fdd*(C*(196*r*(3*s - 1) + 891*s**2 - 790*s + 297) - 417*r*s + 139*r - 942*s**2 + 767*s - 314)) + 2*fd**2*(2*C*(196*r*(3*s - 1) + 891*s**2 - 790*s + 98) - 278*r*(3*s - 1) - 1884*s**2 + 1534*s - 139)) - 11*D1*bd1*(D1*(f*s*(C*(-8*r + 39*s - 24) + 4*r - 51*s + 20) - 2*fd*(C*(74*s**2 - 49*s + 12) - 86*s**2 + 52*s - 9)) - 4*Dd*f*(2*s - 1)*(C*(37*s - 12) - 43*s + 9)) - 2*D1*f*(Dd*(2*f*(C*(128*r*(2*s - 1) + 726*s**2 - 790*s + 363) - 102*r*(2*s - 1) - 794*s**2 + 845*s - 397) + fd*(-8*C*(49*r*(12*s - 5) + 891*s**2 - 914*s + 222) + 278*r*(12*s - 5) + 7536*s**2 - 7253*s + 1673)) + Ddd*f*(-2*C*(196*r*(2*s - 1) + 594*s**2 - 692*s + 297) + 278*r*(2*s - 1) + 1256*s**2 - 1395*s + 628)) + 2*Dd**2*f**2*(2*C*(588*r*(2*s - 1) + 1782*s**2 - 2076*s + 493) - 834*r*(2*s - 1) - 3768*s**2 + 4185*s - 906)))/(231*d**2*k3**2) + 2*D1**2*Pk1*Pk3*ct**2*(33*b1**2*(D1**2*(fd*(2*C*(7*r**2 - 42*r*(s - 1) - 33*(s - 1)**2) - 7*r**2 + 63*r*(s - 1) + 66*(s - 1)**2) + fdd*(2*C*(7*r**2 + 42*r*(s - 1) + 34*(s - 1)**2) - 7*r**2 - 63*r*(s - 1) - 68*(s - 1)**2)) + D1*(Dd*(f*(2*C*(28*r**2 + r*(70 - 168*s) - 132*s**2 + 174*s - 59) - 28*r**2 + 28*r*(9*s - 4) + 264*s**2 - 327*s + 125) + fd*(4*C*(28*r**2 + 7*r*(24*s - 19) + 136*s**2 - 225*s + 89) - 56*r**2 - 56*r*(9*s - 7) - 544*s**2 + 879*s - 335)) + Ddd*f*(2*C*(28*r**2 + 14*r*(12*s - 7) + 136*s**2 - 178*s + 75) - 28*r**2 - 28*r*(9*s - 5) - 272*s**2 + 335*s - 143)) + Dd**2*f*(4*C*(42*r**2 + 21*r*(12*s - 7) + 204*s**2 - 267*s + 76) - 84*r**2 - 84*r*(9*s - 5) - 816*s**2 + 1005*s - 262)) + 33*b1*(-40*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r + 28*C*D1**2*f*fd*s**2 + 76*C*D1**2*f*fd*s + 24*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 2*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s + 96*C*D1**2*fd**2 - 80*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r + 56*C*D1*Dd*f**2*s**2 - 36*C*D1*Dd*f**2*s + 28*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r*s - 208*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 - 216*C*D1*Dd*f*fd*s + 184*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 36*C*D1*Ddd*f**2*s - 24*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 108*C*Dd**2*f**2*s + D1**2*bdd1*f*(2*C*(14*r**2 + 14*r*(6*s - 1) + 68*s**2 - 42*s + 7) - 14*r**2 - 14*r*(9*s - 1) - 136*s**2 + 63*s - 7) + 20*D1**2*f*fd*r*s - 24*D1**2*f*fd*r - 100*D1**2*f*fd*s**2 + 22*D1**2*f*fd*s - 43*D1**2*f*fd - 12*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*r + 96*D1**2*f*fdd*s**2 - 24*D1**2*f*fdd*s + 41*D1**2*f*fdd - 12*D1**2*fd**2*r*s + 20*D1**2*fd**2*r + 96*D1**2*fd**2*s**2 - 24*D1**2*fd**2*s - 72*D1**2*fd**2 + 40*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r - 200*D1*Dd*f**2*s**2 + 190*D1*Dd*f**2*s - 100*D1*Dd*f**2 - 96*D1*Dd*f*fd*r*s + 104*D1*Dd*f*fd*r + 768*D1*Dd*f*fd*s**2 - 468*D1*Dd*f*fd*s + 28*D1*Dd*f*fd - 24*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r + 192*D1*Ddd*f**2*s**2 - 186*D1*Ddd*f**2*s + 96*D1*Ddd*f**2 + D1*bd1*(D1*(f*(2*C*(14*r**2 - 14*r*(6*s + 1) - 66*s**2 + 42*s + 7) - 14*r**2 + 14*r*(9*s + 1) + 132*s**2 - 63*s - 7) + fd*(4*C*(14*r**2 + 7*r*(12*s - 7) + 68*s**2 - 89*s + 21) - 28*r**2 - 28*r*(9*s - 5) - 272*s**2 + 335*s - 63)) + 2*Dd*f*(2*C*(56*r**2 + 42*r*(8*s - 3) + 272*s**2 - 262*s + 49) - 56*r**2 - 168*r*(3*s - 1) - 544*s**2 + 461*s - 70)) - 72*Dd**2*f**2*r*s + 36*Dd**2*f**2*r + 576*Dd**2*f**2*s**2 - 558*Dd**2*f**2*s + 84*Dd**2*f**2) + f*(2958*C*D1**2*f*fd*r**2 + 9504*C*D1**2*f*fd*r*s - 5140*C*D1**2*f*fd*r + 7128*C*D1**2*f*fd*s**2 - 7920*C*D1**2*f*fd*s + 3362*C*D1**2*f*fd - 1578*C*D1**2*f*fdd*r**2 - 9504*C*D1**2*f*fdd*r*s + 4220*C*D1**2*f*fdd*r - 7128*C*D1**2*f*fdd*s**2 + 7920*C*D1**2*f*fdd*s - 2902*C*D1**2*f*fdd - 3156*C*D1**2*fd**2*r**2 - 19008*C*D1**2*fd**2*r*s + 8440*C*D1**2*fd**2*r - 14256*C*D1**2*fd**2*s**2 + 15840*C*D1**2*fd**2*s - 3168*C*D1**2*fd**2 + 3944*C*D1*Dd*f**2*r**2 + 12672*C*D1*Dd*f**2*r*s - 8308*C*D1*Dd*f**2*r + 9504*C*D1*Dd*f**2*s**2 - 12672*C*D1*Dd*f**2*s + 5738*C*D1*Dd*f**2 - 12624*C*D1*Dd*f*fd*r**2 - 76032*C*D1*Dd*f*fd*r*s + 39044*C*D1*Dd*f*fd*r - 57024*C*D1*Dd*f*fd*s**2 + 69696*C*D1*Dd*f*fd*s - 20060*C*D1*Dd*f*fd - 2104*C*D1*Ddd*f**2*r**2 - 12672*C*D1*Ddd*f**2*r*s + 7388*C*D1*Ddd*f**2*r - 9504*C*D1*Ddd*f**2*s**2 + 12672*C*D1*Ddd*f**2*s - 5278*C*D1*Ddd*f**2 - 6312*C*Dd**2*f**2*r**2 - 38016*C*Dd**2*f**2*r*s + 22164*C*Dd**2*f**2*r - 28512*C*Dd**2*f**2*s**2 + 38016*C*Dd**2*f**2*s - 11088*C*Dd**2*f**2 + 33*D1**2*bd1**2*(r**2*(28*C - 14) + 14*r*(2*C*(6*s - 1) - 9*s + 1) + s*(4*C*(34*s - 21) - 136*s + 63)) + 33*D1**2*bdd1*f*(2*C*(2*r*(3*s + 7) - 6*s**2 + 42*s - 7) - 2*r*(3*s + 7) + 48*s**2 - 66*s + 7) - 1479*D1**2*f*fd*r**2 - 7629*D1**2*f*fd*r*s + 3529*D1**2*f*fd*r - 10098*D1**2*f*fd*s**2 + 9275*D1**2*f*fd*s - 3859*D1**2*f*fd + 789*D1**2*f*fdd*r**2 + 7329*D1**2*f*fdd*r*s - 2969*D1**2*f*fdd*r + 10098*D1**2*f*fdd*s**2 - 9175*D1**2*f*fdd*s + 3629*D1**2*f*fdd + 1578*D1**2*fd**2*r**2 + 14658*D1**2*fd**2*r*s - 5938*D1**2*fd**2*r + 20196*D1**2*fd**2*s**2 - 18350*D1**2*fd**2*s + 2443*D1**2*fd**2 - 1972*D1*Dd*f**2*r**2 - 10172*D1*Dd*f**2*r*s + 6072*D1*Dd*f**2*r - 13464*D1*Dd*f**2*s**2 + 16007*D1*Dd*f**2*s - 7225*D1*Dd*f**2 + 6312*D1*Dd*f*fd*r**2 + 58632*D1*Dd*f*fd*r*s - 28112*D1*Dd*f*fd*r + 80784*D1*Dd*f*fd*s**2 - 84421*D1*Dd*f*fd*s + 21319*D1*Dd*f*fd + 1052*D1*Ddd*f**2*r**2 + 9772*D1*Ddd*f**2*r*s - 5412*D1*Ddd*f**2*r + 13464*D1*Ddd*f**2*s**2 - 15907*D1*Ddd*f**2*s + 6995*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(4*C*r*(5*s + 7) - 14*C*(s**2 - 6*s + 1) - 2*r*(5*s + 7) + 50*s**2 - 68*s + 7) + 2*fd*(-8*C*r*(3*s + 1) + 6*C*(4*s**2 - 8*s + 7) + 12*r*s + 4*r - 96*s**2 + 78*s - 33)) + 2*Dd*f*(2*C*(-2*r*(12*s + 11) + 24*s**2 - 93*s + 49) + r*(24*s + 22) - 192*s**2 + 225*s - 73)) + 3156*Dd**2*f**2*r**2 + 29316*Dd**2*f**2*r*s - 16236*Dd**2*f**2*r + 40392*Dd**2*f**2*s**2 - 47721*Dd**2*f**2*s + 11618*Dd**2*f**2))/(693*d**2*k3**2) + D1**2*Pk1*Pk3*ct**2*st**2*(16*C - 8)*(D1*f*s*(-2*D1*bd1**2*s - D1*bdd1*f*s + 2*bd1*(D1*(f*s - 2*fd*s + fd) + Dd*f*(2 - 4*s))) + b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(fd*(4*s**2 - 4*s + 2) + fdd*(-2*s**2 + 2*s - 1) + s**2*(4*bd1 - 2*bdd1)) - 2*fd*s*(2*bd1 + fd)*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(2*bd1*s + fd*(2*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(7*d**2*k2**2) - D1**2*Pk1*Pk3*ct**2*(4*C - 2)*(2*D1*f*s*(-35*D1*bd1**2*s + 3*D1*bd1*(7*f*s + fd*(10 - 20*s)) - 15*D1*bdd1*f*s + 60*Dd*bd1*f*(1 - 2*s)) + 7*b1**2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + 2*D1*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(2*s**2 - 3*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f*(6*s**2 - 6*s + 1)) + 2*b1*(D1**2*(f*(21*fd*(2*s**2 - 2*s + 1) - 15*fdd*(2*s**2 - 2*s + 1) + s**2*(49*bd1 - 35*bdd1)) - 10*fd*s*(7*bd1 + 3*fd)*(s - 1)) + 2*D1*f*(21*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*(2*s - 1)*(7*bd1*s + fd*(6*s - 3)) - 15*Ddd*f*(2*s**2 - 2*s + 1)) - 30*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k2**2) + 4*D1**2*Pk1*Pk3*ct**2*k2**4*st**4*(66*C*D1**2*b1*f*fd*r**2 + 66*C*D1**2*b1*f*fdd*r**2 + 66*C*D1**2*b1*fd**2*r**2 + 177*C*D1**2*f**2*fd*r**2 - 118*C*D1**2*f**2*fd*r + 59*C*D1**2*f**2*fd - 138*C*D1**2*f**2*fdd*r**2 + 92*C*D1**2*f**2*fdd*r - 46*C*D1**2*f**2*fdd - 276*C*D1**2*f*fd**2*r**2 + 184*C*D1**2*f*fd**2*r + 132*C*D1*Dd*b1*f**2*r**2 - 66*C*D1*Dd*b1*f**2*r + 33*C*D1*Dd*b1*f**2 + 528*C*D1*Dd*b1*f*fd*r**2 - 132*C*D1*Dd*b1*f*fd*r + 236*C*D1*Dd*f**3*r**2 - 118*C*D1*Dd*f**3*r + 59*C*D1*Dd*f**3 - 1104*C*D1*Dd*f**2*fd*r**2 + 644*C*D1*Dd*f**2*fd*r - 92*C*D1*Dd*f**2*fd + 132*C*D1*Ddd*b1*f**2*r**2 - 66*C*D1*Ddd*b1*f**2*r + 33*C*D1*Ddd*b1*f**2 - 184*C*D1*Ddd*f**3*r**2 + 92*C*D1*Ddd*f**3*r - 46*C*D1*Ddd*f**3 + 396*C*Dd**2*b1*f**2*r**2 - 198*C*Dd**2*b1*f**2*r - 552*C*Dd**2*f**3*r**2 + 276*C*Dd**2*f**3*r - 198*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 + 33*D1**2*bdd1*f**2*(C - 1)*(r - 1)**2 - 207*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 148*D1**2*f**2*fd*r + 10*D1**2*f**2*fd*s - 69*D1**2*f**2*fd + 153*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 107*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd*s + 51*D1**2*f**2*fdd + 306*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 214*D1**2*f*fd**2*r - 10*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 - 396*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 330*D1*Dd*b1*f**2*r + 66*D1*Dd*b1*f**2*s - 99*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r - 276*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 158*D1*Dd*f**3*r + 10*D1*Dd*f**3*s - 69*D1*Dd*f**3 + 1224*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 764*D1*Dd*f**2*fd*r - 35*D1*Dd*f**2*fd*s + 117*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 + 204*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 112*D1*Ddd*f**3*r - 5*D1*Ddd*f**3*s + 51*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(C*(r - 1) - 3*r - 2*s + 3) + D1*fd*r*(4*C - 4) + Dd*f*(2*C - 2)*(4*r - 1)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r + 612*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 336*Dd**2*f**3*r - 15*Dd**2*f**3*s + 10*Dd**2*f**3)/(231*d**2*k1**2*k3**4) - D1**2*Pk1*Pk3*ct**2*k2**4*st**2*(-5148*C*D1**2*f**2*fd*r**2 + 3432*C*D1**2*f**2*fd*r - 1716*C*D1**2*f**2*fd - 6864*C*D1*Dd*f**3*r**2 + 3432*C*D1*Dd*f**3*r - 1716*C*D1*Dd*f**3 + 1573*D1**2*K*bdd1*f**2*r**2 - 286*D1**2*bd1**2*f*(6*f*(4*r**2 + r*(4*s - 5) - 2*s + 1) + r*(5*K - 5)*(r - 1)) + 1560*D1**2*bdd1*f**3*r**2 + 4186*D1**2*bdd1*f**3*r*s - 4940*D1**2*bdd1*f**3*r - 4290*D1**2*bdd1*f**3*s + 2496*D1**2*bdd1*f**3 - 1573*D1**2*bdd1*f**2*r**2 + 1430*D1**2*bdd1*f*g2*r**2 - 2860*D1**2*bdd1*f*g2*r + 1430*D1**2*bdd1*f*g2 + 96*D1**2*f**3*fd*r**2 - 520*D1**2*f**3*fd*r*s + 212*D1**2*f**3*fd*r + 130*D1**2*f**3*fd*s + 24*D1**2*f**3*fd + 8064*D1**2*f**3*fdd*r**2 + 520*D1**2*f**3*fdd*r*s - 4292*D1**2*f**3*fdd*r - 130*D1**2*f**3*fdd*s + 2016*D1**2*f**3*fdd + 24192*D1**2*f**2*fd**2*r**2 + 1560*D1**2*f**2*fd**2*r*s - 12876*D1**2*f**2*fd**2*r - 390*D1**2*f**2*fd**2*s + 260*D1**2*f**2*fd**2 + 10296*D1**2*f**2*fd*r**2 + 5148*D1**2*f**2*fd*r*s - 8580*D1**2*f**2*fd*r - 1716*D1**2*f**2*fd*s + 3432*D1**2*f**2*fd + 4862*D1**2*f**2*gd2*r**2 - 3146*D1**2*f**2*gdd2*r**2 + 9724*D1**2*f*fd*g2*r**2 - 9724*D1**2*f*fd*g2*r + 4862*D1**2*f*fd*g2 - 12584*D1**2*f*fd*gd2*r**2 + 6292*D1**2*f*fd*gd2*r - 6292*D1**2*f*fdd*g2*r**2 + 6292*D1**2*f*fdd*g2*r - 3146*D1**2*f*fdd*g2 - 6292*D1**2*fd**2*g2*r**2 + 6292*D1**2*fd**2*g2*r + 96*D1*Dd*f**4*r**2 - 520*D1*Dd*f**4*r*s + 212*D1*Dd*f**4*r + 130*D1*Dd*f**4*s + 24*D1*Dd*f**4 + 64512*D1*Dd*f**3*fd*r**2 + 4160*D1*Dd*f**3*fd*r*s - 34336*D1*Dd*f**3*fd*r - 1040*D1*Dd*f**3*fd*s + 4552*D1*Dd*f**3*fd + 13728*D1*Dd*f**3*r**2 + 6864*D1*Dd*f**3*r*s - 10296*D1*Dd*f**3*r - 1716*D1*Dd*f**3*s + 3432*D1*Dd*f**3 + 19448*D1*Dd*f**2*g2*r**2 - 9724*D1*Dd*f**2*g2*r + 4862*D1*Dd*f**2*g2 - 25168*D1*Dd*f**2*gd2*r**2 + 6292*D1*Dd*f**2*gd2*r - 50336*D1*Dd*f*fd*g2*r**2 + 37752*D1*Dd*f*fd*g2*r - 6292*D1*Dd*f*fd*g2 + 8064*D1*Ddd*f**4*r**2 + 520*D1*Ddd*f**4*r*s - 4292*D1*Ddd*f**4*r - 130*D1*Ddd*f**4*s + 2016*D1*Ddd*f**4 - 12584*D1*Ddd*f**2*g2*r**2 + 6292*D1*Ddd*f**2*g2*r - 3146*D1*Ddd*f**2*g2 + 13*D1*bd1*(D1*(2*f**3*(144*r**2 - r*(25*s + 82) + 165*s + 6) + f**2*(-132*C*(r - 1)**2 + 2*fd*(360*r**2 + r*(966*s - 822) - 491*s + 328) - 11*r**2*(17*K - 45) - 11*r*(52 - 16*s) - 132*s + 264) + 22*f*(11*fd*r*(K - 1)*(2*r - 1) + 11*g2*(r - 1)**2 + 10*gd2*r*(r - 1)) + 220*fd*g2*r*(r - 1)) + 2*Dd*f*(f**2*(480*r**2 + 2*r*(644*s - 601) - 821*s + 520) + 121*f*r*(K - 1)*(4*r - 1) + 110*g2*(4*r**2 - 5*r + 1))) + 24192*Dd**2*f**4*r**2 + 1560*Dd**2*f**4*r*s - 12876*Dd**2*f**4*r - 390*Dd**2*f**4*s + 260*Dd**2*f**4 - 37752*Dd**2*f**2*g2*r**2 + 18876*Dd**2*f**2*g2*r + 143*b1**2*(D1**2*r*(12*f*(2*fd - fdd)*(4*r + 4*s - 3) - 12*fd**2*(4*r + 4*s - 3) + fd*(-11*K*r + 39*r + 28*s) - 5*fdd*r*(K - 1)) + D1*(Dd*(48*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-11*K*(4*r**2 - 2*r + 1) - 12*fd*(8*r - 1)*(4*r + 4*s - 3) + 156*r**2 + 112*r*s - 134*r - 28*s + 39) - 10*fd*r*(K - 1)*(4*r - 1)) + Ddd*f*(-24*f*(4*r**2 + 4*r*(s - 1) - s + 1) + (5 - 5*K)*(4*r**2 - 2*r + 1))) - 6*Dd**2*f*(4*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + r*(5*K - 5)*(2*r - 1))) + 13*b1*(-264*C*D1**2*f*fd*r**2 - 528*C*D1*Dd*f**2*r**2 + 264*C*D1*Dd*f**2*r - 132*C*D1*Dd*f**2 - 374*D1**2*K*f*fd*r**2 + 374*D1**2*K*f*fd*r - 187*D1**2*K*f*fd + 242*D1**2*K*f*fdd*r**2 - 242*D1**2*K*f*fdd*r + 121*D1**2*K*f*fdd + 242*D1**2*K*fd**2*r**2 - 242*D1**2*K*fd**2*r - 11*D1**2*bdd1*f*(12*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + (5*K - 5)*(2*r**2 - 2*r + 1)) + 864*D1**2*f**2*fd*r**2 - 150*D1**2*f**2*fd*r*s - 312*D1**2*f**2*fd*r - 280*D1**2*f**2*fd*s + 276*D1**2*f**2*fd + 360*D1**2*f**2*fdd*r**2 + 966*D1**2*f**2*fdd*r*s - 504*D1**2*f**2*fdd*r + 8*D1**2*f**2*fdd*s - 72*D1**2*f**2*fdd + 720*D1**2*f*fd**2*r**2 + 1932*D1**2*f*fd**2*r*s - 1008*D1**2*f*fd**2*r + 16*D1**2*f*fd**2*s - 12*D1**2*f*fd**2 + 990*D1**2*f*fd*r**2 + 352*D1**2*f*fd*r*s - 594*D1**2*f*fd*r - 44*D1**2*f*fd*s + 231*D1**2*f*fd - 242*D1**2*f*fdd*r**2 + 242*D1**2*f*fdd*r - 121*D1**2*f*fdd + 242*D1**2*f*gd2*r**2 + 110*D1**2*f*gdd2*r**2 - 242*D1**2*fd**2*r**2 + 242*D1**2*fd**2*r + 242*D1**2*fd*g2*r**2 + 220*D1**2*fd*gd2*r**2 + 110*D1**2*fdd*g2*r**2 - 748*D1*Dd*K*f**2*r**2 + 374*D1*Dd*K*f**2*r - 187*D1*Dd*K*f**2 + 1936*D1*Dd*K*f*fd*r**2 - 1452*D1*Dd*K*f*fd*r + 242*D1*Dd*K*f*fd + 1152*D1*Dd*f**3*r**2 - 200*D1*Dd*f**3*r*s - 476*D1*Dd*f**3*r + 50*D1*Dd*f**3*s + 288*D1*Dd*f**3 + 2880*D1*Dd*f**2*fd*r**2 + 7728*D1*Dd*f**2*fd*r*s - 4668*D1*Dd*f**2*fd*r - 934*D1*Dd*f**2*fd*s + 488*D1*Dd*f**2*fd + 1980*D1*Dd*f**2*r**2 + 704*D1*Dd*f**2*r*s - 1342*D1*Dd*f**2*r - 176*D1*Dd*f**2*s + 495*D1*Dd*f**2 - 1936*D1*Dd*f*fd*r**2 + 1452*D1*Dd*f*fd*r - 242*D1*Dd*f*fd + 968*D1*Dd*f*g2*r**2 - 484*D1*Dd*f*g2*r + 242*D1*Dd*f*g2 + 880*D1*Dd*f*gd2*r**2 - 220*D1*Dd*f*gd2*r + 880*D1*Dd*fd*g2*r**2 - 220*D1*Dd*fd*g2*r + 484*D1*Ddd*K*f**2*r**2 - 242*D1*Ddd*K*f**2*r + 121*D1*Ddd*K*f**2 + 480*D1*Ddd*f**3*r**2 + 1288*D1*Ddd*f**3*r*s - 884*D1*Ddd*f**3*r - 322*D1*Ddd*f**3*s + 120*D1*Ddd*f**3 - 484*D1*Ddd*f**2*r**2 + 242*D1*Ddd*f**2*r - 121*D1*Ddd*f**2 + 440*D1*Ddd*f*g2*r**2 - 220*D1*Ddd*f*g2*r + 110*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(24*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(-11*K*(2*r**2 - 2*r + 1) - 12*fd*(4*r - 1)*(4*r + 4*s - 3) + 78*r**2 + 56*r*s - 106*r - 28*s + 39) - 10*fd*r*(K - 1)*(2*r - 1)) - 2*Dd*f*(6*f*(8*r - 3)*(4*r + 4*s - 3) + (5*K - 5)*(8*r**2 - 6*r + 1))) + 1452*Dd**2*K*f**2*r**2 - 726*Dd**2*K*f**2*r + 1440*Dd**2*f**3*r**2 + 3864*Dd**2*f**3*r*s - 2652*Dd**2*f**3*r - 966*Dd**2*f**3*s + 644*Dd**2*f**3 - 1452*Dd**2*f**2*r**2 + 726*Dd**2*f**2*r + 1320*Dd**2*f*g2*r**2 - 660*Dd**2*f*g2*r))/(3003*d**2*k1**2*k3**4) + 2*D1**2*Pk1*Pk3*ct**2*k2**2*st**2*(11*b1**2*(C - 1)*(D1**2*r**2*(11*fd + 5*fdd) + D1*(11*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*r*(4*r - 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) + 30*Dd**2*f*r*(2*r - 1)) + 11*b1*(34*C*D1**2*f*fd*r**2 - 34*C*D1**2*f*fd*r + 17*C*D1**2*f*fd - 22*C*D1**2*f*fdd*r**2 + 22*C*D1**2*f*fdd*r - 11*C*D1**2*f*fdd - 22*C*D1**2*fd**2*r**2 + 22*C*D1**2*fd**2*r + 68*C*D1*Dd*f**2*r**2 - 34*C*D1*Dd*f**2*r + 17*C*D1*Dd*f**2 - 176*C*D1*Dd*f*fd*r**2 + 132*C*D1*Dd*f*fd*r - 22*C*D1*Dd*f*fd - 44*C*D1*Ddd*f**2*r**2 + 22*C*D1*Ddd*f**2*r - 11*C*D1*Ddd*f**2 - 132*C*Dd**2*f**2*r**2 + 66*C*Dd**2*f**2*r + 5*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) - 28*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s + 31*D1**2*f*fd*r - 17*D1**2*f*fd + 16*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s - 19*D1**2*f*fdd*r + 11*D1**2*f*fdd + 16*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s - 19*D1**2*fd**2*r - 56*D1*Dd*f**2*r**2 + 12*D1*Dd*f**2*r*s + 22*D1*Dd*f**2*r - 3*D1*Dd*f**2*s - 14*D1*Dd*f**2 + 128*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s - 96*D1*Dd*f*fd*r + 6*D1*Dd*f*fd*s + 19*D1*Dd*f*fd + 32*D1*Ddd*f**2*r**2 - 12*D1*Ddd*f**2*r*s - 10*D1*Ddd*f**2*r + 3*D1*Ddd*f**2*s + 8*D1*Ddd*f**2 + D1*bd1*(C - 1)*(11*D1*f*(2*r**2 - 2*r + 1) + 10*D1*fd*r*(2*r - 1) + 10*Dd*f*(8*r**2 - 6*r + 1)) + 96*Dd**2*f**2*r**2 - 36*Dd**2*f**2*r*s - 30*Dd**2*f**2*r + 9*Dd**2*f**2*s - 6*Dd**2*f**2) + f*(12*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd + 192*C*D1**2*f*fdd*r**2 - 128*C*D1**2*f*fdd*r + 64*C*D1**2*f*fdd + 384*C*D1**2*fd**2*r**2 - 256*C*D1**2*fd**2*r + 16*C*D1*Dd*f**2*r**2 - 8*C*D1*Dd*f**2*r + 4*C*D1*Dd*f**2 + 1536*C*D1*Dd*f*fd*r**2 - 896*C*D1*Dd*f*fd*r + 128*C*D1*Dd*f*fd + 256*C*D1*Ddd*f**2*r**2 - 128*C*D1*Ddd*f**2*r + 64*C*D1*Ddd*f**2 + 768*C*Dd**2*f**2*r**2 - 384*C*Dd**2*f**2*r + 110*D1**2*bd1**2*r*(C - 1)*(r - 1) - 11*D1**2*bdd1*f*(r**2*(11*C - 8) + 3*r*(s - 2) - 3*s + 3) + 285*D1**2*f*fd*r**2 - 93*D1**2*f*fd*r*s - 159*D1**2*f*fd*r + 31*D1**2*f*fd*s + 95*D1**2*f*fd - 291*D1**2*f*fdd*r**2 - 3*D1**2*f*fdd*r*s + 195*D1**2*f*fdd*r + D1**2*f*fdd*s - 97*D1**2*f*fdd - 582*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 390*D1**2*fd**2*r + 2*D1**2*fd**2*s - D1**2*fd**2 + 380*D1*Dd*f**2*r**2 - 124*D1*Dd*f**2*r*s - 128*D1*Dd*f**2*r + 31*D1*Dd*f**2*s + 95*D1*Dd*f**2 - 2328*D1*Dd*f*fd*r**2 - 24*D1*Dd*f*fd*r*s + 1368*D1*Dd*f*fd*r + 7*D1*Dd*f*fd*s - 197*D1*Dd*f*fd - 388*D1*Ddd*f**2*r**2 - 4*D1*Ddd*f**2*r*s + 196*D1*Ddd*f**2*r + D1*Ddd*f**2*s - 97*D1*Ddd*f**2 + 11*D1*bd1*(D1*(f*(r**2*(17*C - 14) + 3*r*(s - 2) - 3*s + 3) + fd*(r**2*(32 - 44*C) + r*(22*C - 12*s - 7) + 6*s - 3)) + Dd*f*(r**2*(64 - 88*C) + 2*r*(11*C - 12*s + 7) + 15*s - 12)) - 1164*Dd**2*f**2*r**2 - 12*Dd**2*f**2*r*s + 588*Dd**2*f**2*r + 3*Dd**2*f**2*s - 2*Dd**2*f**2))/(231*d**2*k1**2*k3**2) - 2*D1**2*Pk1*Pk3*ct**2*k2**2*(-33*D1**2*K*bdd1*f**2*r**2 - 110*D1**2*b2*f*fd*r**2 + 110*D1**2*b2*f*fd*r - 55*D1**2*b2*f*fd - 66*D1**2*b2*f*fdd*r**2 + 66*D1**2*b2*f*fdd*r - 33*D1**2*b2*f*fdd - 66*D1**2*b2*fd**2*r**2 + 66*D1**2*b2*fd**2*r + 11*D1**2*bd1**2*(3*f**2*(4*r**2 + r*(20*s - 11) - 10*s + 5) + f*(r**2*(24*K - 16) + r*(38*s - 27) - 19*s + 19) + 28*g2*r*(r - 1)) - 55*D1**2*bd2*f**2*r**2 - 132*D1**2*bd2*f*fd*r**2 + 66*D1**2*bd2*f*fd*r + 102*D1**2*bdd1*f**3*r**2 + 132*D1**2*bdd1*f**3*r*s - 66*D1**2*bdd1*f**3*r + 110*D1**2*bdd1*f**2*r**2 + 110*D1**2*bdd1*f**2*r*s - 110*D1**2*bdd1*f**2*r - 264*D1**2*bdd1*f*g2*r**2 - 33*D1**2*bdd2*f**2*r**2 + 110*D1**2*f**2*gd2*r**2 + 66*D1**2*f**2*gdd2*r**2 + 220*D1**2*f*fd*g2*r**2 - 220*D1**2*f*fd*g2*r + 110*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 - 132*D1**2*f*fd*gd2*r + 132*D1**2*f*fdd*g2*r**2 - 132*D1**2*f*fdd*g2*r + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 - 132*D1**2*fd**2*g2*r - 220*D1*Dd*b2*f**2*r**2 + 110*D1*Dd*b2*f**2*r - 55*D1*Dd*b2*f**2 - 528*D1*Dd*b2*f*fd*r**2 + 396*D1*Dd*b2*f*fd*r - 66*D1*Dd*b2*f*fd - 264*D1*Dd*bd2*f**2*r**2 + 66*D1*Dd*bd2*f**2*r + 440*D1*Dd*f**2*g2*r**2 - 220*D1*Dd*f**2*g2*r + 110*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f*fd*g2*r**2 - 792*D1*Dd*f*fd*g2*r + 132*D1*Dd*f*fd*g2 - 132*D1*Ddd*b2*f**2*r**2 + 66*D1*Ddd*b2*f**2*r - 33*D1*Ddd*b2*f**2 + 264*D1*Ddd*f**2*g2*r**2 - 132*D1*Ddd*f**2*g2*r + 66*D1*Ddd*f**2*g2 + D1*bd1*(D1*(6*f**3*r*(43*r - 22*s + 11) + f**2*(6*fd*(102*r**2 + 4*r*(33*s - 25) - 22*s + 11) - 11*r*(r*(12*C + 5*K - 34) + 18*s - 18)) - 22*f*(fd*(r**2*(6*K - 20) + r*(-3*K - 20*s + 20) + 5*s - 5) + r**2*(18*g2 + 24*gd2)) - 528*fd*g2*r*(r - 1)) + 2*Dd*f*(f**2*(408*r**2 + 6*r*(88*s - 61) - 66*s + 33) - 11*f*(r**2*(12*K - 40) + r*(-3*K - 40*s + 40) + 5*s - 5) + 264*g2*r*(1 - 4*r))) - 396*Dd**2*b2*f**2*r**2 + 198*Dd**2*b2*f**2*r + 792*Dd**2*f**2*g2*r**2 - 396*Dd**2*f**2*g2*r + 77*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(1 - 2*r)) + 11*b1**2*(-14*C*D1**2*fd*r**2 - 56*C*D1*Dd*f*r**2 + 28*C*D1*Dd*f*r - 14*C*D1*Dd*f + 18*D1**2*K*fd*r**2 - 36*D1**2*K*fd*r + 18*D1**2*K*fd + 12*D1**2*K*fdd*r**2 - 24*D1**2*K*fdd*r + 12*D1**2*K*fdd - 7*D1**2*bdd1*(K - 1)*(3*r**2 - 2*r + 1) + 20*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s + 55*D1**2*f*fd*r - 5*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 39*D1**2*f*fdd*r - 3*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 39*D1**2*fd**2*r + 16*D1**2*fd*r**2 - 31*D1**2*fd*r*s + 36*D1**2*fd*r - 18*D1**2*fd - 8*D1**2*fdd*r**2 + 19*D1**2*fdd*r*s + 24*D1**2*fdd*r - 12*D1**2*fdd - 28*D1**2*gd2*r**2 + 14*D1**2*gdd2*r**2 + 72*D1*Dd*K*f*r**2 - 36*D1*Dd*K*f*r + 18*D1*Dd*K*f + 96*D1*Dd*K*fd*r**2 - 120*D1*Dd*K*fd*r + 24*D1*Dd*K*fd + 40*D1*Dd*f**2*r**2 - 120*D1*Dd*f**2*r*s + 40*D1*Dd*f**2*r + 30*D1*Dd*f**2*s + 10*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 300*D1*Dd*f*fd*r - 60*D1*Dd*f*fd*s + 39*D1*Dd*f*fd + 64*D1*Dd*f*r**2 - 124*D1*Dd*f*r*s + 30*D1*Dd*f*r + 31*D1*Dd*f*s + 16*D1*Dd*f - 64*D1*Dd*fd*r**2 + 152*D1*Dd*fd*r*s + 74*D1*Dd*fd*r - 19*D1*Dd*fd*s - 24*D1*Dd*fd - 112*D1*Dd*g2*r**2 + 56*D1*Dd*g2*r - 28*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 - 28*D1*Dd*gd2*r + 48*D1*Ddd*K*f*r**2 - 24*D1*Ddd*K*f*r + 12*D1*Ddd*K*f + 24*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 72*D1*Ddd*f**2*r - 30*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 - 32*D1*Ddd*f*r**2 + 76*D1*Ddd*f*r*s - 22*D1*Ddd*f*r - 19*D1*Ddd*f*s - 8*D1*Ddd*f + 56*D1*Ddd*g2*r**2 - 28*D1*Ddd*g2*r + 14*D1*Ddd*g2 + 14*D1*bd1*(K - 1)*(D1*(3*r**2 - 2*r + 1) + Dd*(-12*r**2 + 7*r - 1)) + 144*Dd**2*K*f*r**2 - 72*Dd**2*K*f*r + 72*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 216*Dd**2*f**2*r - 90*Dd**2*f**2*s + 60*Dd**2*f**2 - 96*Dd**2*f*r**2 + 228*Dd**2*f*r*s - 66*Dd**2*f*r - 57*Dd**2*f*s + 38*Dd**2*f + 168*Dd**2*g2*r**2 - 84*Dd**2*g2*r) + b1*(-264*C*D1**2*f*fd*r**2 + 264*C*D1**2*f*fd*r - 132*C*D1**2*f*fd - 528*C*D1*Dd*f**2*r**2 + 264*C*D1*Dd*f**2*r - 132*C*D1*Dd*f**2 - 110*D1**2*K*f*fd*r**2 + 110*D1**2*K*f*fd*r - 55*D1**2*K*f*fd - 66*D1**2*K*f*fdd*r**2 + 66*D1**2*K*f*fdd*r - 33*D1**2*K*f*fdd - 66*D1**2*K*fd**2*r**2 + 66*D1**2*K*fd**2*r - 154*D1**2*bd1**2*r*(K - 1)*(3*r - 2) + 11*D1**2*bdd1*(3*f**2*(4*r**2 + r*(20*s - 11) - 10*s + 3) + f*(r**2*(24*K - 16) + r*(38*s - 27) - 19*s + 4) + 14*g2*(2*r**2 - 2*r + 1)) + 774*D1**2*f**2*fd*r**2 - 396*D1**2*f**2*fd*r*s - 318*D1**2*f**2*fd*r + 132*D1**2*f**2*fd*s + 258*D1**2*f**2*fd + 306*D1**2*f**2*fdd*r**2 + 396*D1**2*f**2*fdd*r*s - 402*D1**2*f**2*fdd*r - 132*D1**2*f**2*fdd*s + 102*D1**2*f**2*fdd + 612*D1**2*f*fd**2*r**2 + 792*D1**2*f*fd**2*r*s - 804*D1**2*f*fd**2*r - 264*D1**2*f*fd**2*s + 198*D1**2*f*fd**2 + 748*D1**2*f*fd*r**2 - 396*D1**2*f*fd*r*s - 748*D1**2*f*fd*r + 198*D1**2*f*fd*s + 374*D1**2*f*fd + 220*D1**2*f*fdd*r**2 + 220*D1**2*f*fdd*r*s - 220*D1**2*f*fdd*r - 110*D1**2*f*fdd*s + 110*D1**2*f*fdd - 396*D1**2*f*gd2*r**2 - 264*D1**2*f*gdd2*r**2 + 220*D1**2*fd**2*r**2 + 220*D1**2*fd**2*r*s - 220*D1**2*fd**2*r - 110*D1**2*fd**2*s - 396*D1**2*fd*g2*r**2 + 792*D1**2*fd*g2*r - 396*D1**2*fd*g2 - 528*D1**2*fd*gd2*r**2 + 528*D1**2*fd*gd2*r - 264*D1**2*fdd*g2*r**2 + 528*D1**2*fdd*g2*r - 264*D1**2*fdd*g2 - 220*D1*Dd*K*f**2*r**2 + 110*D1*Dd*K*f**2*r - 55*D1*Dd*K*f**2 - 528*D1*Dd*K*f*fd*r**2 + 396*D1*Dd*K*f*fd*r - 66*D1*Dd*K*f*fd + 1032*D1*Dd*f**3*r**2 - 528*D1*Dd*f**3*r*s - 252*D1*Dd*f**3*r + 132*D1*Dd*f**3*s + 258*D1*Dd*f**3 + 2448*D1*Dd*f**2*fd*r**2 + 3168*D1*Dd*f**2*fd*r*s - 3012*D1*Dd*f**2*fd*r - 924*D1*Dd*f**2*fd*s + 666*D1*Dd*f**2*fd + 1496*D1*Dd*f**2*r**2 - 792*D1*Dd*f**2*r*s - 352*D1*Dd*f**2*r + 198*D1*Dd*f**2*s + 374*D1*Dd*f**2 + 1760*D1*Dd*f*fd*r**2 + 1760*D1*Dd*f*fd*r*s - 1760*D1*Dd*f*fd*r - 660*D1*Dd*f*fd*s + 440*D1*Dd*f*fd - 1584*D1*Dd*f*g2*r**2 + 792*D1*Dd*f*g2*r - 396*D1*Dd*f*g2 - 2112*D1*Dd*f*gd2*r**2 + 528*D1*Dd*f*gd2*r - 2112*D1*Dd*fd*g2*r**2 + 2640*D1*Dd*fd*g2*r - 528*D1*Dd*fd*g2 - 132*D1*Ddd*K*f**2*r**2 + 66*D1*Ddd*K*f**2*r - 33*D1*Ddd*K*f**2 + 408*D1*Ddd*f**3*r**2 + 528*D1*Ddd*f**3*r*s - 468*D1*Ddd*f**3*r - 132*D1*Ddd*f**3*s + 102*D1*Ddd*f**3 + 440*D1*Ddd*f**2*r**2 + 440*D1*Ddd*f**2*r*s - 440*D1*Ddd*f**2*r - 110*D1*Ddd*f**2*s + 110*D1*Ddd*f**2 - 1056*D1*Ddd*f*g2*r**2 + 528*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(48*K*fd*r**2 - 48*K*fd*r + 5*f**2*(4*r**2 - 3*r*(4*s + 1) + 6*s + 3) + f*(-14*C*(2*r**2 - 2*r + 1) + 36*K*r**2 + 3*fd*(16*r**2 + 80*r*s - 48*r - 20*s + 15) + 32*r**2 - 62*r*s - 37*r + 31*s + 34) - 32*fd*r**2 + 76*fd*r*s + 21*fd*r - 19*fd*s - 56*g2*r**2 + 56*g2*r - 28*g2 + 56*gd2*r**2 - 28*gd2*r) + Dd*(3*f**2*(32*r**2 + 4*r*(40*s - 23) - 60*s + 31) + f*(r**2*(192*K - 128) - 8*r*(6*K - 38*s + 19) - 114*s + 65) + 28*g2*(8*r**2 - 6*r + 1))) - 396*Dd**2*K*f**2*r**2 + 198*Dd**2*K*f**2*r + 1224*Dd**2*f**3*r**2 + 1584*Dd**2*f**3*r*s - 1404*Dd**2*f**3*r - 396*Dd**2*f**3*s + 264*Dd**2*f**3 + 1320*Dd**2*f**2*r**2 + 1320*Dd**2*f**2*r*s - 1320*Dd**2*f**2*r - 330*Dd**2*f**2*s + 220*Dd**2*f**2 - 3168*Dd**2*f*g2*r**2 + 1584*Dd**2*f*g2*r))/(231*d**2*k1**2*k3**2) + 2*D1**2*Pk1*Pk3*ct**2*(D1*f*(19*D1*bd1**2*s*(1 - 2*r) + D1*bdd1*f*r*(r*(6*C - 3) - 10*s) + bd1*(D1*(f*r*(r*(10*C - 5) + 6*s) + 2*fd*(r**2*(12*C - 6) + r*(-6*C - 20*s + 8) + 5*s)) + 2*Dd*f*(r**2*(24*C - 12) + r*(-6*C - 40*s + 13) + 5*s))) + b1**2*(D1*Dd*(17*f*(4*r*s - 2*r - s) - 19*fd*(8*r*s - 6*r - s + 1)) + D1*(D1*r*(17*fd - 19*fdd)*(s - 1) + 19*Ddd*f*(-4*r*s + 2*r + s)) - 19*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(D1**2*(f*(19*bdd1*s*(1 - 2*r) + fd*(10*C*(2*r**2 - 2*r + 1) - 10*r**2 + 12*r*s + 4*r - 6*s - 5) + fdd*(6*C*(2*r**2 - 2*r + 1) - 6*r**2 - 20*r*s + 16*r + 10*s - 3)) + 2*fd**2*(r**2*(6*C - 3) - 2*r*(3*C + 5*s - 4) + 5*s - 5)) + D1*bd1*(D1*(17*f*s*(2*r - 1) - 19*fd*(4*r*s - 2*r - s + 1)) - 38*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*f*(Dd*(f*(10*C*(4*r**2 - 2*r + 1) - 20*r**2 + 24*r*s - 2*r - 6*s - 5) + 4*fd*(3*C*(8*r**2 - 6*r + 1) - 12*r**2 - 40*r*s + 29*r + 15*s - 9)) + Ddd*f*(6*C*(4*r**2 - 2*r + 1) - 12*r**2 - 40*r*s + 26*r + 10*s - 3)) + 2*Dd**2*f**2*(r**2*(36*C - 18) - 3*r*(6*C + 20*s - 13) + 15*s - 10)))/(21*d**2*k1**2) - 8*D1**2*Pk1*Pk3*ct*f*k1**3*k2**3*st**4*(33*D1**2*bd1*f*(8*C - 5)*(r + s - 1)**2 + 33*D1*b1*(8*C - 5)*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + (64*C - 38)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**8) - 16*D1**2*Pk1*Pk3*ct*f*k1**3*k2*st**4*(D1**2*(f*(11*bd1*s*(2*C - 1)*(r + s - 1) + fd*(28*C - 16)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(14*C - 8)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(8 - 14*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*b1*(2*C - 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + D1*f*(14*C - 8)*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(8 - 14*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4))/(77*d**2*k3**6) - D1**2*Pk1*Pk3*ct*f*k1**3*st**4*(192*C - 104)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + 2*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1))/(231*d**2*k2*k3**4) + 20*D1**2*Pk1*Pk3*ct*f*k2**7*st**6*(78*D1**2*b1*f*fd*r**2 + 156*D1**2*b1*f*fd*r*s - 104*D1**2*b1*f*fd*r + 78*D1**2*b1*f*fd*s**2 - 104*D1**2*b1*f*fd*s + 52*D1**2*b1*f*fd - 39*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*f*fdd*r*s + 52*D1**2*b1*f*fdd*r - 39*D1**2*b1*f*fdd*s**2 + 52*D1**2*b1*f*fdd*s - 26*D1**2*b1*f*fdd - 78*D1**2*b1*fd**2*r**2 - 156*D1**2*b1*fd**2*r*s + 104*D1**2*b1*fd**2*r - 78*D1**2*b1*fd**2*s**2 + 104*D1**2*b1*fd**2*s - 26*D1**2*b1*fd**2 - 13*D1**2*bdd1*f**2*(r + s - 1)**2 - 24*D1**2*f**2*fd*r**2 - 48*D1**2*f**2*fd*r*s + 36*D1**2*f**2*fd*r - 24*D1**2*f**2*fd*s**2 + 36*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 24*D1**2*f**2*fdd*r*s - 18*D1**2*f**2*fdd*r + 12*D1**2*f**2*fdd*s**2 - 18*D1**2*f**2*fdd*s + 9*D1**2*f**2*fdd + 36*D1**2*f*fd**2*r**2 + 72*D1**2*f*fd**2*r*s - 54*D1**2*f*fd**2*r + 36*D1**2*f*fd**2*s**2 - 54*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 + 104*D1*Dd*b1*f**2*r**2 + 208*D1*Dd*b1*f**2*r*s - 156*D1*Dd*b1*f**2*r + 104*D1*Dd*b1*f**2*s**2 - 156*D1*Dd*b1*f**2*s + 78*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 - 624*D1*Dd*b1*f*fd*r*s + 442*D1*Dd*b1*f*fd*r - 312*D1*Dd*b1*f*fd*s**2 + 442*D1*Dd*b1*f*fd*s - 156*D1*Dd*b1*f*fd - 24*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 36*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 192*D1*Dd*f**2*fd*r*s - 144*D1*Dd*f**2*fd*r + 96*D1*Dd*f**2*fd*s**2 - 144*D1*Dd*f**2*fd*s + 54*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 - 104*D1*Ddd*b1*f**2*r*s + 78*D1*Ddd*b1*f**2*r - 52*D1*Ddd*b1*f**2*s**2 + 78*D1*Ddd*b1*f**2*s - 39*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*r**2 + 24*D1*Ddd*f**3*r*s - 18*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 18*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 + 26*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 156*Dd**2*b1*f**2*r**2 - 312*Dd**2*b1*f**2*r*s + 234*Dd**2*b1*f**2*r - 156*Dd**2*b1*f**2*s**2 + 234*Dd**2*b1*f**2*s - 78*Dd**2*b1*f**2 + 36*Dd**2*f**3*r**2 + 72*Dd**2*f**3*r*s - 54*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 54*Dd**2*f**3*s + 18*Dd**2*f**3)/(429*d**2*k1*k3**8) + 20*D1**2*Pk1*Pk3*ct*f*k2**5*st**4*(-156*D1**2*b1*f*fd*r**2 + 78*D1**2*b1*f*fdd*r**2 + 156*D1**2*b1*fd**2*r**2 + 26*D1**2*bdd1*f**2*(r - 1)**2 + 92*D1**2*f**2*fd*r**2 - 46*D1**2*f**2*fd*r + 23*D1**2*f**2*fd - 124*D1**2*f**2*fdd*r**2 + 62*D1**2*f**2*fdd*r - 31*D1**2*f**2*fdd - 372*D1**2*f*fd**2*r**2 + 186*D1**2*f*fd**2*r - 208*D1*Dd*b1*f**2*r**2 + 104*D1*Dd*b1*f**2*r - 52*D1*Dd*b1*f**2 + 624*D1*Dd*b1*f*fd*r**2 - 156*D1*Dd*b1*f*fd*r + 92*D1*Dd*f**3*r**2 - 46*D1*Dd*f**3*r + 23*D1*Dd*f**3 - 992*D1*Dd*f**2*fd*r**2 + 496*D1*Dd*f**2*fd*r - 62*D1*Dd*f**2*fd + 104*D1*Ddd*b1*f**2*r**2 - 52*D1*Ddd*b1*f**2*r + 26*D1*Ddd*b1*f**2 - 124*D1*Ddd*f**3*r**2 + 62*D1*Ddd*f**3*r - 31*D1*Ddd*f**3 - 52*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) + 312*Dd**2*b1*f**2*r**2 - 156*Dd**2*b1*f**2*r - 372*Dd**2*f**3*r**2 + 186*Dd**2*f**3*r)/(3003*d**2*k1**3*k3**4) - 4*D1**2*Pk1*Pk3*ct*k1**5*k2*st**2*(2376*C*D1**2*b1*f*fd*r**2 + 4752*C*D1**2*b1*f*fd*r*s - 2376*C*D1**2*b1*f*fd*r + 2376*C*D1**2*b1*f*fd*s**2 - 2376*C*D1**2*b1*f*fd*s + 1188*C*D1**2*b1*f*fd - 1848*C*D1**2*b1*f*fdd*r**2 - 3696*C*D1**2*b1*f*fdd*r*s + 1848*C*D1**2*b1*f*fdd*r - 1848*C*D1**2*b1*f*fdd*s**2 + 1848*C*D1**2*b1*f*fdd*s - 924*C*D1**2*b1*f*fdd - 1848*C*D1**2*b1*fd**2*r**2 - 3696*C*D1**2*b1*fd**2*r*s + 1848*C*D1**2*b1*fd**2*r - 1848*C*D1**2*b1*fd**2*s**2 + 1848*C*D1**2*b1*fd**2*s + 2220*C*D1**2*f**2*fd*r**2 + 4440*C*D1**2*f**2*fd*r*s - 2960*C*D1**2*f**2*fd*r + 2220*C*D1**2*f**2*fd*s**2 - 2960*C*D1**2*f**2*fd*s + 1480*C*D1**2*f**2*fd - 2100*C*D1**2*f**2*fdd*r**2 - 4200*C*D1**2*f**2*fdd*r*s + 2800*C*D1**2*f**2*fdd*r - 2100*C*D1**2*f**2*fdd*s**2 + 2800*C*D1**2*f**2*fdd*s - 1400*C*D1**2*f**2*fdd - 4200*C*D1**2*f*fd**2*r**2 - 8400*C*D1**2*f*fd**2*r*s + 5600*C*D1**2*f*fd**2*r - 4200*C*D1**2*f*fd**2*s**2 + 5600*C*D1**2*f*fd**2*s - 1400*C*D1**2*f*fd**2 + 4752*C*D1*Dd*b1*f**2*r**2 + 9504*C*D1*Dd*b1*f**2*r*s - 7128*C*D1*Dd*b1*f**2*r + 4752*C*D1*Dd*b1*f**2*s**2 - 7128*C*D1*Dd*b1*f**2*s + 3564*C*D1*Dd*b1*f**2 - 14784*C*D1*Dd*b1*f*fd*r**2 - 29568*C*D1*Dd*b1*f*fd*r*s + 18480*C*D1*Dd*b1*f*fd*r - 14784*C*D1*Dd*b1*f*fd*s**2 + 18480*C*D1*Dd*b1*f*fd*s - 5544*C*D1*Dd*b1*f*fd + 2960*C*D1*Dd*f**3*r**2 + 5920*C*D1*Dd*f**3*r*s - 4440*C*D1*Dd*f**3*r + 2960*C*D1*Dd*f**3*s**2 - 4440*C*D1*Dd*f**3*s + 2220*C*D1*Dd*f**3 - 16800*C*D1*Dd*f**2*fd*r**2 - 33600*C*D1*Dd*f**2*fd*r*s + 23800*C*D1*Dd*f**2*fd*r - 16800*C*D1*Dd*f**2*fd*s**2 + 23800*C*D1*Dd*f**2*fd*s - 8400*C*D1*Dd*f**2*fd - 3696*C*D1*Ddd*b1*f**2*r**2 - 7392*C*D1*Ddd*b1*f**2*r*s + 5544*C*D1*Ddd*b1*f**2*r - 3696*C*D1*Ddd*b1*f**2*s**2 + 5544*C*D1*Ddd*b1*f**2*s - 2772*C*D1*Ddd*b1*f**2 - 2800*C*D1*Ddd*f**3*r**2 - 5600*C*D1*Ddd*f**3*r*s + 4200*C*D1*Ddd*f**3*r - 2800*C*D1*Ddd*f**3*s**2 + 4200*C*D1*Ddd*f**3*s - 2100*C*D1*Ddd*f**3 - 11088*C*Dd**2*b1*f**2*r**2 - 22176*C*Dd**2*b1*f**2*r*s + 16632*C*Dd**2*b1*f**2*r - 11088*C*Dd**2*b1*f**2*s**2 + 16632*C*Dd**2*b1*f**2*s - 5544*C*Dd**2*b1*f**2 - 8400*C*Dd**2*f**3*r**2 - 16800*C*Dd**2*f**3*r*s + 12600*C*Dd**2*f**3*r - 8400*C*Dd**2*f**3*s**2 + 12600*C*Dd**2*f**3*s - 4200*C*Dd**2*f**3 - 1254*D1**2*b1*f*fd*r**2 - 2508*D1**2*b1*f*fd*r*s + 1254*D1**2*b1*f*fd*r - 1254*D1**2*b1*f*fd*s**2 + 1254*D1**2*b1*f*fd*s - 627*D1**2*b1*f*fd + 990*D1**2*b1*f*fdd*r**2 + 1980*D1**2*b1*f*fdd*r*s - 990*D1**2*b1*f*fdd*r + 990*D1**2*b1*f*fdd*s**2 - 990*D1**2*b1*f*fdd*s + 495*D1**2*b1*f*fdd + 990*D1**2*b1*fd**2*r**2 + 1980*D1**2*b1*fd**2*r*s - 990*D1**2*b1*fd**2*r + 990*D1**2*b1*fd**2*s**2 - 990*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(28*C - 15)*(r + s - 1)**2 - 1161*D1**2*f**2*fd*r**2 - 2322*D1**2*f**2*fd*r*s + 1548*D1**2*f**2*fd*r - 1161*D1**2*f**2*fd*s**2 + 1548*D1**2*f**2*fd*s - 774*D1**2*f**2*fd + 1125*D1**2*f**2*fdd*r**2 + 2250*D1**2*f**2*fdd*r*s - 1500*D1**2*f**2*fdd*r + 1125*D1**2*f**2*fdd*s**2 - 1500*D1**2*f**2*fdd*s + 750*D1**2*f**2*fdd + 2250*D1**2*f*fd**2*r**2 + 4500*D1**2*f*fd**2*r*s - 3000*D1**2*f*fd**2*r + 2250*D1**2*f*fd**2*s**2 - 3000*D1**2*f*fd**2*s + 750*D1**2*f*fd**2 - 2508*D1*Dd*b1*f**2*r**2 - 5016*D1*Dd*b1*f**2*r*s + 3762*D1*Dd*b1*f**2*r - 2508*D1*Dd*b1*f**2*s**2 + 3762*D1*Dd*b1*f**2*s - 1881*D1*Dd*b1*f**2 + 7920*D1*Dd*b1*f*fd*r**2 + 15840*D1*Dd*b1*f*fd*r*s - 9900*D1*Dd*b1*f*fd*r + 7920*D1*Dd*b1*f*fd*s**2 - 9900*D1*Dd*b1*f*fd*s + 2970*D1*Dd*b1*f*fd - 1548*D1*Dd*f**3*r**2 - 3096*D1*Dd*f**3*r*s + 2322*D1*Dd*f**3*r - 1548*D1*Dd*f**3*s**2 + 2322*D1*Dd*f**3*s - 1161*D1*Dd*f**3 + 9000*D1*Dd*f**2*fd*r**2 + 18000*D1*Dd*f**2*fd*r*s - 12750*D1*Dd*f**2*fd*r + 9000*D1*Dd*f**2*fd*s**2 - 12750*D1*Dd*f**2*fd*s + 4500*D1*Dd*f**2*fd + 1980*D1*Ddd*b1*f**2*r**2 + 3960*D1*Ddd*b1*f**2*r*s - 2970*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s**2 - 2970*D1*Ddd*b1*f**2*s + 1485*D1*Ddd*b1*f**2 + 1500*D1*Ddd*f**3*r**2 + 3000*D1*Ddd*f**3*r*s - 2250*D1*Ddd*f**3*r + 1500*D1*Ddd*f**3*s**2 - 2250*D1*Ddd*f**3*s + 1125*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(36*C - 19)*(r + s - 1) - D1*fd*(56*C - 30)*(2*r + 2*s - 1) - Dd*f*(56*C - 30)*(4*r + 4*s - 3)) + 5940*Dd**2*b1*f**2*r**2 + 11880*Dd**2*b1*f**2*r*s - 8910*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s**2 - 8910*Dd**2*b1*f**2*s + 2970*Dd**2*b1*f**2 + 4500*Dd**2*f**3*r**2 + 9000*Dd**2*f**3*r*s - 6750*Dd**2*f**3*r + 4500*Dd**2*f**3*s**2 - 6750*Dd**2*f**3*s + 2250*Dd**2*f**3)/(231*d**2*k3**8) - 8*D1**2*Pk1*Pk3*ct*k1**5*k2*(-990*D1**2*K*bdd1*f**2*r**2 - 1980*D1**2*K*bdd1*f**2*r*s + 1980*D1**2*K*bdd1*f**2*r - 990*D1**2*K*bdd1*f**2*s**2 + 1980*D1**2*K*bdd1*f**2*s - 990*D1**2*K*bdd1*f**2 + 66*D1**2*bd1**2*f*(-36*K + 5*f + 6)*(r + s - 1)**2 + 140*D1**2*bdd1*f**3*r**2 + 280*D1**2*bdd1*f**3*r*s - 280*D1**2*bdd1*f**3*r + 140*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 140*D1**2*bdd1*f**3 + 165*D1**2*bdd1*f**2*r**2 + 330*D1**2*bdd1*f**2*r*s - 330*D1**2*bdd1*f**2*r + 165*D1**2*bdd1*f**2*s**2 - 330*D1**2*bdd1*f**2*s + 165*D1**2*bdd1*f**2 + 2376*D1**2*bdd1*f*g2*r**2 + 4752*D1**2*bdd1*f*g2*r*s - 4752*D1**2*bdd1*f*g2*r + 2376*D1**2*bdd1*f*g2*s**2 - 4752*D1**2*bdd1*f*g2*s + 2376*D1**2*bdd1*f*g2 - 1584*D1**2*f**2*gd2*r**2 - 3168*D1**2*f**2*gd2*r*s + 3168*D1**2*f**2*gd2*r - 1584*D1**2*f**2*gd2*s**2 + 3168*D1**2*f**2*gd2*s - 1584*D1**2*f**2*gd2 + 1980*D1**2*f**2*gdd2*r**2 + 3960*D1**2*f**2*gdd2*r*s - 3960*D1**2*f**2*gdd2*r + 1980*D1**2*f**2*gdd2*s**2 - 3960*D1**2*f**2*gdd2*s + 1980*D1**2*f**2*gdd2 - 3168*D1**2*f*fd*g2*r**2 - 6336*D1**2*f*fd*g2*r*s + 3168*D1**2*f*fd*g2*r - 3168*D1**2*f*fd*g2*s**2 + 3168*D1**2*f*fd*g2*s - 1584*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r**2 + 15840*D1**2*f*fd*gd2*r*s - 11880*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 11880*D1**2*f*fd*gd2*s + 3960*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r**2 + 7920*D1**2*f*fdd*g2*r*s - 3960*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r**2 + 7920*D1**2*fd**2*g2*r*s - 3960*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s - 6336*D1*Dd*f**2*g2*r**2 - 12672*D1*Dd*f**2*g2*r*s + 9504*D1*Dd*f**2*g2*r - 6336*D1*Dd*f**2*g2*s**2 + 9504*D1*Dd*f**2*g2*s - 4752*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r**2 + 31680*D1*Dd*f**2*gd2*r*s - 27720*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 27720*D1*Dd*f**2*gd2*s + 11880*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r**2 + 63360*D1*Dd*f*fd*g2*r*s - 39600*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 39600*D1*Dd*f*fd*g2*s + 11880*D1*Dd*f*fd*g2 + 7920*D1*Ddd*f**2*g2*r**2 + 15840*D1*Ddd*f**2*g2*r*s - 11880*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 11880*D1*Ddd*f**2*g2*s + 5940*D1*Ddd*f**2*g2 - D1*bd1*(D1*(115*f**3*(r + s - 1) - 4*f**2*(70*fd*(3*r + 3*s - 2) + (198*K - 33)*(r + s - 1)) + 66*f*(5*fd*(6*K - 1)*(2*r + 2*s - 1) + (30*g2 - 72*gd2)*(r + s - 1)) - 4752*fd*g2*(r + s)) - 2*Dd*f*(140*f**2 - 165*f*(6*K - 1) + 2376*g2)*(4*r + 4*s - 3))*(r + s - 1) + 23760*Dd**2*f**2*g2*r**2 + 47520*Dd**2*f**2*g2*r*s - 35640*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 35640*Dd**2*f**2*g2*s + 11880*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 5*fd*(6*K - 1)*(r + s) - 6*fdd*(6*K - 1)*(r + s))) + D1*(Dd*(4*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(2*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (6*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(6*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-36*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-36*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(1584*D1**2*K*f*fd*r**2 + 3168*D1**2*K*f*fd*r*s - 1584*D1**2*K*f*fd*r + 1584*D1**2*K*f*fd*s**2 - 1584*D1**2*K*f*fd*s + 792*D1**2*K*f*fd - 1980*D1**2*K*f*fdd*r**2 - 3960*D1**2*K*f*fdd*r*s + 1980*D1**2*K*f*fdd*r - 1980*D1**2*K*f*fdd*s**2 + 1980*D1**2*K*f*fdd*s - 990*D1**2*K*f*fdd - 1980*D1**2*K*fd**2*r**2 - 3960*D1**2*K*fd**2*r*s + 1980*D1**2*K*fd**2*r - 1980*D1**2*K*fd**2*s**2 + 1980*D1**2*K*fd**2*s + 66*D1**2*bdd1*f*(-36*K + 5*f + 6)*(r + s - 1)**2 - 345*D1**2*f**2*fd*r**2 - 690*D1**2*f**2*fd*r*s + 460*D1**2*f**2*fd*r - 345*D1**2*f**2*fd*s**2 + 460*D1**2*f**2*fd*s - 230*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd + 330*D1**2*f*fdd*r**2 + 660*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 330*D1**2*f*fdd*s**2 - 330*D1**2*f*fdd*s + 165*D1**2*f*fdd - 1980*D1**2*f*gd2*r**2 - 3960*D1**2*f*gd2*r*s + 3960*D1**2*f*gd2*r - 1980*D1**2*f*gd2*s**2 + 3960*D1**2*f*gd2*s - 1980*D1**2*f*gd2 + 2376*D1**2*f*gdd2*r**2 + 4752*D1**2*f*gdd2*r*s - 4752*D1**2*f*gdd2*r + 2376*D1**2*f*gdd2*s**2 - 4752*D1**2*f*gdd2*s + 2376*D1**2*f*gdd2 + 330*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 330*D1**2*fd**2*s**2 - 330*D1**2*fd**2*s - 1980*D1**2*fd*g2*r**2 - 3960*D1**2*fd*g2*r*s - 1980*D1**2*fd*g2*s**2 + 4752*D1**2*fd*gd2*r**2 + 9504*D1**2*fd*gd2*r*s - 4752*D1**2*fd*gd2*r + 4752*D1**2*fd*gd2*s**2 - 4752*D1**2*fd*gd2*s + 2376*D1**2*fdd*g2*r**2 + 4752*D1**2*fdd*g2*r*s + 2376*D1**2*fdd*g2*s**2 + 3168*D1*Dd*K*f**2*r**2 + 6336*D1*Dd*K*f**2*r*s - 4752*D1*Dd*K*f**2*r + 3168*D1*Dd*K*f**2*s**2 - 4752*D1*Dd*K*f**2*s + 2376*D1*Dd*K*f**2 - 15840*D1*Dd*K*f*fd*r**2 - 31680*D1*Dd*K*f*fd*r*s + 19800*D1*Dd*K*f*fd*r - 15840*D1*Dd*K*f*fd*s**2 + 19800*D1*Dd*K*f*fd*s - 5940*D1*Dd*K*f*fd - 460*D1*Dd*f**3*r**2 - 920*D1*Dd*f**3*r*s + 690*D1*Dd*f**3*r - 460*D1*Dd*f**3*s**2 + 690*D1*Dd*f**3*s - 345*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 + 5280*D1*Dd*f*fd*r*s - 3300*D1*Dd*f*fd*r + 2640*D1*Dd*f*fd*s**2 - 3300*D1*Dd*f*fd*s + 990*D1*Dd*f*fd - 7920*D1*Dd*f*g2*r**2 - 15840*D1*Dd*f*g2*r*s + 11880*D1*Dd*f*g2*r - 7920*D1*Dd*f*g2*s**2 + 11880*D1*Dd*f*g2*s - 5940*D1*Dd*f*g2 + 19008*D1*Dd*f*gd2*r**2 + 38016*D1*Dd*f*gd2*r*s - 33264*D1*Dd*f*gd2*r + 19008*D1*Dd*f*gd2*s**2 - 33264*D1*Dd*f*gd2*s + 14256*D1*Dd*f*gd2 + 19008*D1*Dd*fd*g2*r**2 + 38016*D1*Dd*fd*g2*r*s - 14256*D1*Dd*fd*g2*r + 19008*D1*Dd*fd*g2*s**2 - 14256*D1*Dd*fd*g2*s - 3960*D1*Ddd*K*f**2*r**2 - 7920*D1*Ddd*K*f**2*r*s + 5940*D1*Ddd*K*f**2*r - 3960*D1*Ddd*K*f**2*s**2 + 5940*D1*Ddd*K*f**2*s - 2970*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 + 1320*D1*Ddd*f**2*r*s - 990*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s**2 - 990*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 + 9504*D1*Ddd*f*g2*r**2 + 19008*D1*Ddd*f*g2*r*s - 14256*D1*Ddd*f*g2*r + 9504*D1*Ddd*f*g2*s**2 - 14256*D1*Ddd*f*g2*s + 7128*D1*Ddd*f*g2 - 66*D1*bd1*(D1*(4*f**2*(r + s - 1) - 5*f*(fd*(4*r + 4*s - 2) + (6*K - 1)*(r + s - 1)) + 12*fd*(6*K - 1)*(r + s)) - 2*Dd*f*(-36*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) - 11880*Dd**2*K*f**2*r**2 - 23760*Dd**2*K*f**2*r*s + 17820*Dd**2*K*f**2*r - 11880*Dd**2*K*f**2*s**2 + 17820*Dd**2*K*f**2*s - 5940*Dd**2*K*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 1980*Dd**2*f**2*r**2 + 3960*Dd**2*f**2*r*s - 2970*Dd**2*f**2*r + 1980*Dd**2*f**2*s**2 - 2970*Dd**2*f**2*s + 990*Dd**2*f**2 + 28512*Dd**2*f*g2*r**2 + 57024*Dd**2*f*g2*r*s - 42768*Dd**2*f*g2*r + 28512*Dd**2*f*g2*s**2 - 42768*Dd**2*f*g2*s + 14256*Dd**2*f*g2))/(231*d**2*k3**8) - D1**2*Pk1*Pk3*ct*k1**5*st**2*(16*C - 8)*(11*b1*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(2*s - 1)*(8*r + 8*s - 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(39*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 25*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 25*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 25*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k2*k3**6) + D1**2*Pk1*Pk3*ct*k1**5*(32*C - 16)*(6*b1*(D1**2*(f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-6*bdd1*s*(r + s - 1) + 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 6*D1*bd1*(D1*(f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 5*D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k2*k3**6) - 4*D1**2*Pk1*Pk3*ct*k1**3*k2**3*st**2*(-20592*C*D1**2*f**2*fd*r**2 - 41184*C*D1**2*f**2*fd*r*s + 27456*C*D1**2*f**2*fd*r - 20592*C*D1**2*f**2*fd*s**2 + 27456*C*D1**2*f**2*fd*s - 13728*C*D1**2*f**2*fd - 27456*C*D1*Dd*f**3*r**2 - 54912*C*D1*Dd*f**3*r*s + 41184*C*D1*Dd*f**3*r - 27456*C*D1*Dd*f**3*s**2 + 41184*C*D1*Dd*f**3*s - 20592*C*D1*Dd*f**3 - 10296*D1**2*K*bdd1*f**2*r**2 - 20592*D1**2*K*bdd1*f**2*r*s + 20592*D1**2*K*bdd1*f**2*r - 10296*D1**2*K*bdd1*f**2*s**2 + 20592*D1**2*K*bdd1*f**2*s - 10296*D1**2*K*bdd1*f**2 + 5148*D1**2*bd1**2*f*(-4*K + 5*f + 1)*(r + s - 1)**2 + 4875*D1**2*bdd1*f**3*r**2 + 9750*D1**2*bdd1*f**3*r*s - 9750*D1**2*bdd1*f**3*r + 4875*D1**2*bdd1*f**3*s**2 - 9750*D1**2*bdd1*f**3*s + 4875*D1**2*bdd1*f**3 + 2574*D1**2*bdd1*f**2*r**2 + 5148*D1**2*bdd1*f**2*r*s - 5148*D1**2*bdd1*f**2*r + 2574*D1**2*bdd1*f**2*s**2 - 5148*D1**2*bdd1*f**2*s + 2574*D1**2*bdd1*f**2 + 20592*D1**2*bdd1*f*g2*r**2 + 41184*D1**2*bdd1*f*g2*r*s - 41184*D1**2*bdd1*f*g2*r + 20592*D1**2*bdd1*f*g2*s**2 - 41184*D1**2*bdd1*f*g2*s + 20592*D1**2*bdd1*f*g2 + 15100*D1**2*f**3*fd*r**2 + 30200*D1**2*f**3*fd*r*s - 22650*D1**2*f**3*fd*r + 15100*D1**2*f**3*fd*s**2 - 22650*D1**2*f**3*fd*s + 11325*D1**2*f**3*fd - 14700*D1**2*f**3*fdd*r**2 - 29400*D1**2*f**3*fdd*r*s + 22050*D1**2*f**3*fdd*r - 14700*D1**2*f**3*fdd*s**2 + 22050*D1**2*f**3*fdd*s - 11025*D1**2*f**3*fdd - 44100*D1**2*f**2*fd**2*r**2 - 88200*D1**2*f**2*fd**2*r*s + 66150*D1**2*f**2*fd**2*r - 44100*D1**2*f**2*fd**2*s**2 + 66150*D1**2*f**2*fd**2*s - 22050*D1**2*f**2*fd**2 + 11583*D1**2*f**2*fd*r**2 + 23166*D1**2*f**2*fd*r*s - 15444*D1**2*f**2*fd*r + 11583*D1**2*f**2*fd*s**2 - 15444*D1**2*f**2*fd*s + 7722*D1**2*f**2*fd - 37752*D1**2*f**2*gd2*r**2 - 75504*D1**2*f**2*gd2*r*s + 75504*D1**2*f**2*gd2*r - 37752*D1**2*f**2*gd2*s**2 + 75504*D1**2*f**2*gd2*s - 37752*D1**2*f**2*gd2 + 20592*D1**2*f**2*gdd2*r**2 + 41184*D1**2*f**2*gdd2*r*s - 41184*D1**2*f**2*gdd2*r + 20592*D1**2*f**2*gdd2*s**2 - 41184*D1**2*f**2*gdd2*s + 20592*D1**2*f**2*gdd2 - 75504*D1**2*f*fd*g2*r**2 - 151008*D1**2*f*fd*g2*r*s + 75504*D1**2*f*fd*g2*r - 75504*D1**2*f*fd*g2*s**2 + 75504*D1**2*f*fd*g2*s - 37752*D1**2*f*fd*g2 + 82368*D1**2*f*fd*gd2*r**2 + 164736*D1**2*f*fd*gd2*r*s - 123552*D1**2*f*fd*gd2*r + 82368*D1**2*f*fd*gd2*s**2 - 123552*D1**2*f*fd*gd2*s + 41184*D1**2*f*fd*gd2 + 41184*D1**2*f*fdd*g2*r**2 + 82368*D1**2*f*fdd*g2*r*s - 41184*D1**2*f*fdd*g2*r + 41184*D1**2*f*fdd*g2*s**2 - 41184*D1**2*f*fdd*g2*s + 20592*D1**2*f*fdd*g2 + 41184*D1**2*fd**2*g2*r**2 + 82368*D1**2*fd**2*g2*r*s - 41184*D1**2*fd**2*g2*r + 41184*D1**2*fd**2*g2*s**2 - 41184*D1**2*fd**2*g2*s + 15100*D1*Dd*f**4*r**2 + 30200*D1*Dd*f**4*r*s - 22650*D1*Dd*f**4*r + 15100*D1*Dd*f**4*s**2 - 22650*D1*Dd*f**4*s + 11325*D1*Dd*f**4 - 117600*D1*Dd*f**3*fd*r**2 - 235200*D1*Dd*f**3*fd*r*s + 176400*D1*Dd*f**3*fd*r - 117600*D1*Dd*f**3*fd*s**2 + 176400*D1*Dd*f**3*fd*s - 66150*D1*Dd*f**3*fd + 15444*D1*Dd*f**3*r**2 + 30888*D1*Dd*f**3*r*s - 23166*D1*Dd*f**3*r + 15444*D1*Dd*f**3*s**2 - 23166*D1*Dd*f**3*s + 11583*D1*Dd*f**3 - 151008*D1*Dd*f**2*g2*r**2 - 302016*D1*Dd*f**2*g2*r*s + 226512*D1*Dd*f**2*g2*r - 151008*D1*Dd*f**2*g2*s**2 + 226512*D1*Dd*f**2*g2*s - 113256*D1*Dd*f**2*g2 + 164736*D1*Dd*f**2*gd2*r**2 + 329472*D1*Dd*f**2*gd2*r*s - 288288*D1*Dd*f**2*gd2*r + 164736*D1*Dd*f**2*gd2*s**2 - 288288*D1*Dd*f**2*gd2*s + 123552*D1*Dd*f**2*gd2 + 329472*D1*Dd*f*fd*g2*r**2 + 658944*D1*Dd*f*fd*g2*r*s - 411840*D1*Dd*f*fd*g2*r + 329472*D1*Dd*f*fd*g2*s**2 - 411840*D1*Dd*f*fd*g2*s + 123552*D1*Dd*f*fd*g2 - 14700*D1*Ddd*f**4*r**2 - 29400*D1*Ddd*f**4*r*s + 22050*D1*Ddd*f**4*r - 14700*D1*Ddd*f**4*s**2 + 22050*D1*Ddd*f**4*s - 11025*D1*Ddd*f**4 + 82368*D1*Ddd*f**2*g2*r**2 + 164736*D1*Ddd*f**2*g2*r*s - 123552*D1*Ddd*f**2*g2*r + 82368*D1*Ddd*f**2*g2*s**2 - 123552*D1*Ddd*f**2*g2*s + 61776*D1*Ddd*f**2*g2 - 78*D1*bd1*(D1*(103*f**3*(r + s - 1) + f**2*(88*C*(r + s - 1) - 125*fd*(3*r + 3*s - 2) - (242*K - 11)*(r + s - 1)) + 22*f*(3*fd*(4*K - 1)*(2*r + 2*s - 1) + (38*g2 - 24*gd2)*(r + s - 1)) - 528*fd*g2*(r + s)) - Dd*f*(125*f**2 - 66*f*(4*K - 1) + 528*g2)*(4*r + 4*s - 3))*(r + s - 1) - 44100*Dd**2*f**4*r**2 - 88200*Dd**2*f**4*r*s + 66150*Dd**2*f**4*r - 44100*Dd**2*f**4*s**2 + 66150*Dd**2*f**4*s - 22050*Dd**2*f**4 + 247104*Dd**2*f**2*g2*r**2 + 494208*Dd**2*f**2*g2*r*s - 370656*Dd**2*f**2*g2*r + 247104*Dd**2*f**2*g2*s**2 - 370656*Dd**2*f**2*g2*s + 123552*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(15*f*(3*fd - 2*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(60*fd**2*(r + s - 1) + 19*fd*(4*K - 1)*(r + s) - 6*fdd*(4*K - 1)*(r + s))) + D1*(Dd*(45*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (76*K - 19)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(4*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-4*K + 5*f + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-4*K + 5*f + 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 39*b1*(352*C*D1**2*f*fd*r**2 + 704*C*D1**2*f*fd*r*s - 352*C*D1**2*f*fd*r + 352*C*D1**2*f*fd*s**2 - 352*C*D1**2*f*fd*s + 176*C*D1**2*f*fd + 704*C*D1*Dd*f**2*r**2 + 1408*C*D1*Dd*f**2*r*s - 1056*C*D1*Dd*f**2*r + 704*C*D1*Dd*f**2*s**2 - 1056*C*D1*Dd*f**2*s + 528*C*D1*Dd*f**2 - 968*D1**2*K*f*fd*r**2 - 1936*D1**2*K*f*fd*r*s + 968*D1**2*K*f*fd*r - 968*D1**2*K*f*fd*s**2 + 968*D1**2*K*f*fd*s - 484*D1**2*K*f*fd + 528*D1**2*K*f*fdd*r**2 + 1056*D1**2*K*f*fdd*r*s - 528*D1**2*K*f*fdd*r + 528*D1**2*K*f*fdd*s**2 - 528*D1**2*K*f*fdd*s + 264*D1**2*K*f*fdd + 528*D1**2*K*fd**2*r**2 + 1056*D1**2*K*fd**2*r*s - 528*D1**2*K*fd**2*r + 528*D1**2*K*fd**2*s**2 - 528*D1**2*K*fd**2*s - 132*D1**2*bdd1*f*(-4*K + 5*f + 1)*(r + s - 1)**2 + 618*D1**2*f**2*fd*r**2 + 1236*D1**2*f**2*fd*r*s - 824*D1**2*f**2*fd*r + 618*D1**2*f**2*fd*s**2 - 824*D1**2*f**2*fd*s + 412*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 750*D1**2*f**2*fdd*r*s + 500*D1**2*f**2*fdd*r - 375*D1**2*f**2*fdd*s**2 + 500*D1**2*f**2*fdd*s - 250*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 1500*D1**2*f*fd**2*r*s + 1000*D1**2*f*fd**2*r - 750*D1**2*f*fd**2*s**2 + 1000*D1**2*f*fd**2*s - 250*D1**2*f*fd**2 + 44*D1**2*f*fd*r**2 + 88*D1**2*f*fd*r*s - 44*D1**2*f*fd*r + 44*D1**2*f*fd*s**2 - 44*D1**2*f*fd*s + 22*D1**2*f*fd - 132*D1**2*f*fdd*r**2 - 264*D1**2*f*fdd*r*s + 132*D1**2*f*fdd*r - 132*D1**2*f*fdd*s**2 + 132*D1**2*f*fdd*s - 66*D1**2*f*fdd + 1672*D1**2*f*gd2*r**2 + 3344*D1**2*f*gd2*r*s - 3344*D1**2*f*gd2*r + 1672*D1**2*f*gd2*s**2 - 3344*D1**2*f*gd2*s + 1672*D1**2*f*gd2 - 528*D1**2*f*gdd2*r**2 - 1056*D1**2*f*gdd2*r*s + 1056*D1**2*f*gdd2*r - 528*D1**2*f*gdd2*s**2 + 1056*D1**2*f*gdd2*s - 528*D1**2*f*gdd2 - 132*D1**2*fd**2*r**2 - 264*D1**2*fd**2*r*s + 132*D1**2*fd**2*r - 132*D1**2*fd**2*s**2 + 132*D1**2*fd**2*s + 1672*D1**2*fd*g2*r**2 + 3344*D1**2*fd*g2*r*s + 1672*D1**2*fd*g2*s**2 - 1056*D1**2*fd*gd2*r**2 - 2112*D1**2*fd*gd2*r*s + 1056*D1**2*fd*gd2*r - 1056*D1**2*fd*gd2*s**2 + 1056*D1**2*fd*gd2*s - 528*D1**2*fdd*g2*r**2 - 1056*D1**2*fdd*g2*r*s - 528*D1**2*fdd*g2*s**2 - 1936*D1*Dd*K*f**2*r**2 - 3872*D1*Dd*K*f**2*r*s + 2904*D1*Dd*K*f**2*r - 1936*D1*Dd*K*f**2*s**2 + 2904*D1*Dd*K*f**2*s - 1452*D1*Dd*K*f**2 + 4224*D1*Dd*K*f*fd*r**2 + 8448*D1*Dd*K*f*fd*r*s - 5280*D1*Dd*K*f*fd*r + 4224*D1*Dd*K*f*fd*s**2 - 5280*D1*Dd*K*f*fd*s + 1584*D1*Dd*K*f*fd + 824*D1*Dd*f**3*r**2 + 1648*D1*Dd*f**3*r*s - 1236*D1*Dd*f**3*r + 824*D1*Dd*f**3*s**2 - 1236*D1*Dd*f**3*s + 618*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 6000*D1*Dd*f**2*fd*r*s + 4250*D1*Dd*f**2*fd*r - 3000*D1*Dd*f**2*fd*s**2 + 4250*D1*Dd*f**2*fd*s - 1500*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r**2 + 176*D1*Dd*f**2*r*s - 132*D1*Dd*f**2*r + 88*D1*Dd*f**2*s**2 - 132*D1*Dd*f**2*s + 66*D1*Dd*f**2 - 1056*D1*Dd*f*fd*r**2 - 2112*D1*Dd*f*fd*r*s + 1320*D1*Dd*f*fd*r - 1056*D1*Dd*f*fd*s**2 + 1320*D1*Dd*f*fd*s - 396*D1*Dd*f*fd + 6688*D1*Dd*f*g2*r**2 + 13376*D1*Dd*f*g2*r*s - 10032*D1*Dd*f*g2*r + 6688*D1*Dd*f*g2*s**2 - 10032*D1*Dd*f*g2*s + 5016*D1*Dd*f*g2 - 4224*D1*Dd*f*gd2*r**2 - 8448*D1*Dd*f*gd2*r*s + 7392*D1*Dd*f*gd2*r - 4224*D1*Dd*f*gd2*s**2 + 7392*D1*Dd*f*gd2*s - 3168*D1*Dd*f*gd2 - 4224*D1*Dd*fd*g2*r**2 - 8448*D1*Dd*fd*g2*r*s + 3168*D1*Dd*fd*g2*r - 4224*D1*Dd*fd*g2*s**2 + 3168*D1*Dd*fd*g2*s + 1056*D1*Ddd*K*f**2*r**2 + 2112*D1*Ddd*K*f**2*r*s - 1584*D1*Ddd*K*f**2*r + 1056*D1*Ddd*K*f**2*s**2 - 1584*D1*Ddd*K*f**2*s + 792*D1*Ddd*K*f**2 - 500*D1*Ddd*f**3*r**2 - 1000*D1*Ddd*f**3*r*s + 750*D1*Ddd*f**3*r - 500*D1*Ddd*f**3*s**2 + 750*D1*Ddd*f**3*s - 375*D1*Ddd*f**3 - 264*D1*Ddd*f**2*r**2 - 528*D1*Ddd*f**2*r*s + 396*D1*Ddd*f**2*r - 264*D1*Ddd*f**2*s**2 + 396*D1*Ddd*f**2*s - 198*D1*Ddd*f**2 - 2112*D1*Ddd*f*g2*r**2 - 4224*D1*Ddd*f*g2*r*s + 3168*D1*Ddd*f*g2*r - 2112*D1*Ddd*f*g2*s**2 + 3168*D1*Ddd*f*g2*s - 1584*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(45*f**2*(r + s - 1) - 60*f*fd*(2*r + 2*s - 1) - 19*f*(4*K - 1)*(r + s - 1) + 12*fd*(4*K - 1)*(r + s)) - 12*Dd*f*(-4*K + 5*f + 1)*(4*r + 4*s - 3))*(r + s - 1) + 3168*Dd**2*K*f**2*r**2 + 6336*Dd**2*K*f**2*r*s - 4752*Dd**2*K*f**2*r + 3168*Dd**2*K*f**2*s**2 - 4752*Dd**2*K*f**2*s + 1584*Dd**2*K*f**2 - 1500*Dd**2*f**3*r**2 - 3000*Dd**2*f**3*r*s + 2250*Dd**2*f**3*r - 1500*Dd**2*f**3*s**2 + 2250*Dd**2*f**3*s - 750*Dd**2*f**3 - 792*Dd**2*f**2*r**2 - 1584*Dd**2*f**2*r*s + 1188*Dd**2*f**2*r - 792*Dd**2*f**2*s**2 + 1188*Dd**2*f**2*s - 396*Dd**2*f**2 - 6336*Dd**2*f*g2*r**2 - 12672*Dd**2*f*g2*r*s + 9504*Dd**2*f*g2*r - 6336*Dd**2*f*g2*s**2 + 9504*Dd**2*f*g2*s - 3168*Dd**2*f*g2))/(3003*d**2*k3**8) - 2*D1**2*Pk1*Pk3*ct*k1**3*k2*st**2*(66*b1**2*(D1**2*(fd*(88*C - 53) + fdd*(9 - 16*C))*(r + s - 1)**2 + D1*(Dd*(f*(88*C - 53)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(18 - 32*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(16*C - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(96*C - 54)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-384*C*D1**2*f*fd*r**2 - 1072*C*D1**2*f*fd*r*s + 440*C*D1**2*f*fd*r - 688*C*D1**2*f*fd*s**2 + 592*C*D1**2*f*fd*s - 296*C*D1**2*f*fd + 384*C*D1**2*f*fdd*r**2 + 976*C*D1**2*f*fdd*r*s - 424*C*D1**2*f*fdd*r + 592*C*D1**2*f*fdd*s**2 - 528*C*D1**2*f*fdd*s + 264*C*D1**2*f*fdd + 384*C*D1**2*fd**2*r**2 + 976*C*D1**2*fd**2*r*s - 424*C*D1**2*fd**2*r + 592*C*D1**2*fd**2*s**2 - 528*C*D1**2*fd**2*s - 64*C*D1**2*fd**2 - 768*C*D1*Dd*f**2*r**2 - 2144*C*D1*Dd*f**2*r*s + 1456*C*D1*Dd*f**2*r - 1376*C*D1*Dd*f**2*s**2 + 1912*C*D1*Dd*f**2*s - 880*C*D1*Dd*f**2 + 3072*C*D1*Dd*f*fd*r**2 + 7808*C*D1*Dd*f*fd*r*s - 4416*C*D1*Dd*f*fd*r + 4736*C*D1*Dd*f*fd*s**2 - 5456*C*D1*Dd*f*fd*s + 1480*C*D1*Dd*f*fd + 768*C*D1*Ddd*f**2*r**2 + 1952*C*D1*Ddd*f**2*r*s - 1360*C*D1*Ddd*f**2*r + 1184*C*D1*Ddd*f**2*s**2 - 1672*C*D1*Ddd*f**2*s + 784*C*D1*Ddd*f**2 + 2304*C*Dd**2*f**2*r**2 + 5856*C*Dd**2*f**2*r*s - 4080*C*Dd**2*f**2*r + 3552*C*Dd**2*f**2*s**2 - 5016*C*Dd**2*f**2*s + 1568*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(16*C - 9)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 218*D1**2*f*fd*r**2 + 652*D1**2*f*fd*r*s - 274*D1**2*f*fd*r + 434*D1**2*f*fd*s**2 - 382*D1**2*f*fd*s + 191*D1**2*f*fd - 214*D1**2*f*fdd*r**2 - 588*D1**2*f*fdd*r*s + 258*D1**2*f*fdd*r - 374*D1**2*f*fdd*s**2 + 338*D1**2*f*fdd*s - 169*D1**2*f*fdd - 214*D1**2*fd**2*r**2 - 588*D1**2*fd**2*r*s + 258*D1**2*fd**2*r - 374*D1**2*fd**2*s**2 + 338*D1**2*fd**2*s + 36*D1**2*fd**2 + 436*D1*Dd*f**2*r**2 + 1304*D1*Dd*f**2*r*s - 870*D1*Dd*f**2*r + 868*D1*Dd*f**2*s**2 - 1194*D1*Dd*f**2*s + 543*D1*Dd*f**2 - 1712*D1*Dd*f*fd*r**2 - 4704*D1*Dd*f*fd*r*s + 2636*D1*Dd*f*fd*r - 2992*D1*Dd*f*fd*s**2 + 3436*D1*Dd*f*fd*s - 934*D1*Dd*f*fd - 428*D1*Ddd*f**2*r**2 - 1176*D1*Ddd*f**2*r*s + 802*D1*Ddd*f**2*r - 748*D1*Ddd*f**2*s**2 + 1042*D1*Ddd*f**2*s - 481*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(88*C - 53)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(18 - 32*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(18 - 32*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 1284*Dd**2*f**2*r**2 - 3528*Dd**2*f**2*r*s + 2406*Dd**2*f**2*r - 2244*Dd**2*f**2*s**2 + 3126*Dd**2*f**2*s - 962*Dd**2*f**2) + f*(-19488*C*D1**2*f*fd*r**2 - 52152*C*D1**2*f*fd*r*s + 30376*C*D1**2*f*fd*r - 32664*C*D1**2*f*fd*s**2 + 39160*C*D1**2*f*fd*s - 17384*C*D1**2*f*fd + 20832*C*D1**2*f*fdd*r**2 + 50232*C*D1**2*f*fdd*r*s - 30632*C*D1**2*f*fdd*r + 29400*C*D1**2*f*fdd*s**2 - 36344*C*D1**2*f*fdd*s + 16744*C*D1**2*f*fdd + 41664*C*D1**2*fd**2*r**2 + 100464*C*D1**2*fd**2*r*s - 61264*C*D1**2*fd**2*r + 58800*C*D1**2*fd**2*s**2 - 72688*C*D1**2*fd**2*s + 16744*C*D1**2*fd**2 - 25984*C*D1*Dd*f**2*r**2 - 69536*C*D1*Dd*f**2*r*s + 47760*C*D1*Dd*f**2*r - 43552*C*D1*Dd*f**2*s**2 + 60936*C*D1*Dd*f**2*s - 28272*C*D1*Dd*f**2 + 166656*C*D1*Dd*f*fd*r**2 + 401856*C*D1*Dd*f*fd*r*s - 264656*C*D1*Dd*f*fd*r + 235200*C*D1*Dd*f*fd*s**2 - 313208*C*D1*Dd*f*fd*s + 103320*C*D1*Dd*f*fd + 27776*C*D1*Ddd*f**2*r**2 + 66976*C*D1*Ddd*f**2*r*s - 47376*C*D1*Ddd*f**2*r + 39200*C*D1*Ddd*f**2*s**2 - 55944*C*D1*Ddd*f**2*s + 26544*C*D1*Ddd*f**2 + 83328*C*Dd**2*f**2*r**2 + 200928*C*Dd**2*f**2*r*s - 142128*C*Dd**2*f**2*r + 117600*C*Dd**2*f**2*s**2 - 167832*C*Dd**2*f**2*s + 53088*C*Dd**2*f**2 - 132*D1**2*bd1**2*(16*C - 9)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(8*C*(24*r**2 + 61*r*s - 56*r + 37*s**2 - 69*s + 28) - 107*r**2 - 294*r*s + 250*r - 187*s**2 + 330*s - 125) + 11037*D1**2*f*fd*r**2 + 30870*D1**2*f*fd*r*s - 17648*D1**2*f*fd*r + 19833*D1**2*f*fd*s**2 - 23512*D1**2*f*fd*s + 10290*D1**2*f*fd - 11607*D1**2*f*fdd*r**2 - 29790*D1**2*f*fdd*r*s + 17668*D1**2*f*fdd*r - 18183*D1**2*f*fdd*s**2 + 22052*D1**2*f*fdd*s - 9930*D1**2*f*fdd - 23214*D1**2*fd**2*r**2 - 59580*D1**2*fd**2*r*s + 35336*D1**2*fd**2*r - 36366*D1**2*fd**2*s**2 + 44104*D1**2*fd**2*s - 9930*D1**2*fd**2 + 14716*D1*Dd*f**2*r**2 + 41160*D1*Dd*f**2*r*s - 27938*D1*Dd*f**2*r + 26444*D1*Dd*f**2*s**2 - 36734*D1*Dd*f**2*s + 16901*D1*Dd*f**2 - 92856*D1*Dd*f*fd*r**2 - 238320*D1*Dd*f*fd*r*s + 153466*D1*Dd*f*fd*r - 145464*D1*Dd*f*fd*s**2 + 190730*D1*Dd*f*fd*s - 61772*D1*Dd*f*fd - 15476*D1*Ddd*f**2*r**2 - 39720*D1*Ddd*f**2*r*s + 27598*D1*Ddd*f**2*r - 24244*D1*Ddd*f**2*s**2 + 34174*D1*Ddd*f**2*s - 15991*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(8*C*(24*r**2 + 67*r*s - 60*r + 43*s**2 - 79*s + 30) - 109*r**2 - 326*r*s + 270*r - 217*s**2 + 378*s - 135) - 2*fd*(4*C*(96*r**2 + 244*r*s - 165*r + 148*s**2 - 204*s + 69) - 214*r**2 - 588*r*s + 379*r - 374*s**2 + 499*s - 165)) - 2*Dd*f*(4*C*(192*r**2 + 488*r*s - 394*r + 296*s**2 - 485*s + 194) - 428*r**2 - 1176*r*s + 901*r - 748*s**2 + 1181*s - 455)) - 46428*Dd**2*f**2*r**2 - 119160*Dd**2*f**2*r*s + 82794*Dd**2*f**2*r - 72732*Dd**2*f**2*s**2 + 102522*Dd**2*f**2*s - 31982*Dd**2*f**2))/(693*d**2*k3**6) + 4*D1**2*Pk1*Pk3*ct*k1**3*k2*(-15576*D1**2*K*bd1**2*f*r**2 - 31152*D1**2*K*bd1**2*f*r*s + 34320*D1**2*K*bd1**2*f*r - 15576*D1**2*K*bd1**2*f*s**2 + 34320*D1**2*K*bd1**2*f*s - 18744*D1**2*K*bd1**2*f + 6864*D1**2*K*bd1*f**2*r**2 + 12408*D1**2*K*bd1*f**2*r*s - 12408*D1**2*K*bd1*f**2*r + 5544*D1**2*K*bd1*f**2*s**2 - 11088*D1**2*K*bd1*f**2*s + 5544*D1**2*K*bd1*f**2 - 34320*D1**2*K*bd1*f*fd*r**2 - 66000*D1**2*K*bd1*f*fd*r*s + 50160*D1**2*K*bd1*f*fd*r - 31680*D1**2*K*bd1*f*fd*s**2 + 48180*D1**2*K*bd1*f*fd*s - 16500*D1**2*K*bd1*f*fd - 8580*D1**2*K*bdd1*f**2*r**2 - 16500*D1**2*K*bdd1*f**2*r*s + 16500*D1**2*K*bdd1*f**2*r - 7920*D1**2*K*bdd1*f**2*s**2 + 15840*D1**2*K*bdd1*f**2*s - 7920*D1**2*K*bdd1*f**2 + 2772*D1**2*bd1**2*f**2*r**2 + 8712*D1**2*bd1**2*f**2*r*s - 7788*D1**2*bd1**2*f**2*r + 5940*D1**2*bd1**2*f**2*s**2 - 10956*D1**2*bd1**2*f**2*s + 5016*D1**2*bd1**2*f**2 + 3102*D1**2*bd1**2*f*r**2 + 9372*D1**2*bd1**2*f*r*s - 8580*D1**2*bd1**2*f*r + 6270*D1**2*bd1**2*f*s**2 - 11748*D1**2*bd1**2*f*s + 5478*D1**2*bd1**2*f - 7392*D1**2*bd1**2*g2*r**2 - 14784*D1**2*bd1**2*g2*r*s + 7392*D1**2*bd1**2*g2*r - 7392*D1**2*bd1**2*g2*s**2 + 7392*D1**2*bd1**2*g2*s - 3168*D1**2*bd1*bd2*f*r**2 - 6336*D1**2*bd1*bd2*f*r*s + 6336*D1**2*bd1*bd2*f*r - 3168*D1**2*bd1*bd2*f*s**2 + 6336*D1**2*bd1*bd2*f*s - 3168*D1**2*bd1*bd2*f - 1255*D1**2*bd1*f**3*r**2 - 2970*D1**2*bd1*f**3*r*s + 3630*D1**2*bd1*f**3*r - 1715*D1**2*bd1*f**3*s**2 + 4090*D1**2*bd1*f**3*s - 2375*D1**2*bd1*f**3 + 9210*D1**2*bd1*f**2*fd*r**2 + 21780*D1**2*bd1*f**2*fd*r*s - 18910*D1**2*bd1*f**2*fd*r + 12570*D1**2*bd1*f**2*fd*s**2 - 21710*D1**2*bd1*f**2*fd*s + 8480*D1**2*bd1*f**2*fd - 1386*D1**2*bd1*f**2*r**2 - 3564*D1**2*bd1*f**2*r*s + 3564*D1**2*bd1*f**2*r - 2178*D1**2*bd1*f**2*s**2 + 4356*D1**2*bd1*f**2*s - 2178*D1**2*bd1*f**2 + 7128*D1**2*bd1*f*fd*r**2 + 19008*D1**2*bd1*f*fd*r*s - 13068*D1**2*bd1*f*fd*r + 11880*D1**2*bd1*f*fd*s**2 - 16632*D1**2*bd1*f*fd*s + 4752*D1**2*bd1*f*fd - 10824*D1**2*bd1*f*g2*r**2 - 21648*D1**2*bd1*f*g2*r*s + 26928*D1**2*bd1*f*g2*r - 10824*D1**2*bd1*f*g2*s**2 + 26928*D1**2*bd1*f*g2*s - 13464*D1**2*bd1*f*g2 + 31152*D1**2*bd1*f*gd2*r**2 + 62304*D1**2*bd1*f*gd2*r*s - 68640*D1**2*bd1*f*gd2*r + 31152*D1**2*bd1*f*gd2*s**2 - 68640*D1**2*bd1*f*gd2*s + 37488*D1**2*bd1*f*gd2 + 31152*D1**2*bd1*fd*g2*r**2 + 62304*D1**2*bd1*fd*g2*r*s - 31152*D1**2*bd1*fd*g2*r + 31152*D1**2*bd1*fd*g2*s**2 - 31152*D1**2*bd1*fd*g2*s + 1056*D1**2*bd2*f**2*r**2 + 2112*D1**2*bd2*f**2*r*s - 2112*D1**2*bd2*f**2*r + 1056*D1**2*bd2*f**2*s**2 - 2112*D1**2*bd2*f**2*s + 1056*D1**2*bd2*f**2 - 5280*D1**2*bd2*f*fd*r**2 - 10560*D1**2*bd2*f*fd*r*s + 7920*D1**2*bd2*f*fd*r - 5280*D1**2*bd2*f*fd*s**2 + 7920*D1**2*bd2*f*fd*s - 2640*D1**2*bd2*f*fd + 1535*D1**2*bdd1*f**3*r**2 + 3630*D1**2*bdd1*f**3*r*s - 4290*D1**2*bdd1*f**3*r + 2095*D1**2*bdd1*f**3*s**2 - 4850*D1**2*bdd1*f**3*s + 2755*D1**2*bdd1*f**3 + 1782*D1**2*bdd1*f**2*r**2 + 4752*D1**2*bdd1*f**2*r*s - 4752*D1**2*bdd1*f**2*r + 2970*D1**2*bdd1*f**2*s**2 - 5940*D1**2*bdd1*f**2*s + 2970*D1**2*bdd1*f**2 + 15576*D1**2*bdd1*f*g2*r**2 + 31152*D1**2*bdd1*f*g2*r*s - 37488*D1**2*bdd1*f*g2*r + 15576*D1**2*bdd1*f*g2*s**2 - 37488*D1**2*bdd1*f*g2*s + 18744*D1**2*bdd1*f*g2 - 1320*D1**2*bdd2*f**2*r**2 - 2640*D1**2*bdd2*f**2*r*s + 2640*D1**2*bdd2*f**2*r - 1320*D1**2*bdd2*f**2*s**2 + 2640*D1**2*bdd2*f**2*s - 1320*D1**2*bdd2*f**2 + 2240*D1**2*f**3*fd*r*s - 1120*D1**2*f**3*fd*r + 2240*D1**2*f**3*fd*s**2 - 2800*D1**2*f**3*fd*s + 1120*D1**2*f**3*fd - 2240*D1**2*f**3*fdd*r*s + 1120*D1**2*f**3*fdd*r - 2240*D1**2*f**3*fdd*s**2 + 2800*D1**2*f**3*fdd*s - 1120*D1**2*f**3*fdd - 6720*D1**2*f**2*fd**2*r*s + 3360*D1**2*f**2*fd**2*r - 6720*D1**2*f**2*fd**2*s**2 + 8400*D1**2*f**2*fd**2*s - 2240*D1**2*f**2*fd**2 - 13728*D1**2*f**2*gd2*r**2 - 24816*D1**2*f**2*gd2*r*s + 24816*D1**2*f**2*gd2*r - 11088*D1**2*f**2*gd2*s**2 + 22176*D1**2*f**2*gd2*s - 11088*D1**2*f**2*gd2 + 17160*D1**2*f**2*gdd2*r**2 + 33000*D1**2*f**2*gdd2*r*s - 33000*D1**2*f**2*gdd2*r + 15840*D1**2*f**2*gdd2*s**2 - 31680*D1**2*f**2*gdd2*s + 15840*D1**2*f**2*gdd2 - 27456*D1**2*f*fd*g2*r**2 - 49632*D1**2*f*fd*g2*r*s + 27456*D1**2*f*fd*g2*r - 22176*D1**2*f*fd*g2*s**2 + 24816*D1**2*f*fd*g2*s - 13728*D1**2*f*fd*g2 + 68640*D1**2*f*fd*gd2*r**2 + 132000*D1**2*f*fd*gd2*r*s - 100320*D1**2*f*fd*gd2*r + 63360*D1**2*f*fd*gd2*s**2 - 96360*D1**2*f*fd*gd2*s + 33000*D1**2*f*fd*gd2 + 34320*D1**2*f*fdd*g2*r**2 + 66000*D1**2*f*fdd*g2*r*s - 34320*D1**2*f*fdd*g2*r + 31680*D1**2*f*fdd*g2*s**2 - 33000*D1**2*f*fdd*g2*s + 17160*D1**2*f*fdd*g2 + 34320*D1**2*fd**2*g2*r**2 + 66000*D1**2*fd**2*g2*r*s - 34320*D1**2*fd**2*g2*r + 31680*D1**2*fd**2*g2*s**2 - 33000*D1**2*fd**2*g2*s - 68640*D1*Dd*K*bd1*f**2*r**2 - 132000*D1*Dd*K*bd1*f**2*r*s + 116160*D1*Dd*K*bd1*f**2*r - 63360*D1*Dd*K*bd1*f**2*s**2 + 111540*D1*Dd*K*bd1*f**2*s - 48180*D1*Dd*K*bd1*f**2 + 12280*D1*Dd*bd1*f**3*r**2 + 29040*D1*Dd*bd1*f**3*r*s - 27490*D1*Dd*bd1*f**3*r + 16760*D1*Dd*bd1*f**3*s**2 - 31410*D1*Dd*bd1*f**3*s + 13990*D1*Dd*bd1*f**3 + 14256*D1*Dd*bd1*f**2*r**2 + 38016*D1*Dd*bd1*f**2*r*s - 32076*D1*Dd*bd1*f**2*r + 23760*D1*Dd*bd1*f**2*s**2 - 40392*D1*Dd*bd1*f**2*s + 16632*D1*Dd*bd1*f**2 + 124608*D1*Dd*bd1*f*g2*r**2 + 249216*D1*Dd*bd1*f*g2*r*s - 243408*D1*Dd*bd1*f*g2*r + 124608*D1*Dd*bd1*f*g2*s**2 - 243408*D1*Dd*bd1*f*g2*s + 112464*D1*Dd*bd1*f*g2 - 10560*D1*Dd*bd2*f**2*r**2 - 21120*D1*Dd*bd2*f**2*r*s + 18480*D1*Dd*bd2*f**2*r - 10560*D1*Dd*bd2*f**2*s**2 + 18480*D1*Dd*bd2*f**2*s - 7920*D1*Dd*bd2*f**2 + 2240*D1*Dd*f**4*r*s - 1120*D1*Dd*f**4*r + 2240*D1*Dd*f**4*s**2 - 2800*D1*Dd*f**4*s + 1120*D1*Dd*f**4 - 17920*D1*Dd*f**3*fd*r*s + 8960*D1*Dd*f**3*fd*r - 17920*D1*Dd*f**3*fd*s**2 + 22400*D1*Dd*f**3*fd*s - 6720*D1*Dd*f**3*fd - 54912*D1*Dd*f**2*g2*r**2 - 99264*D1*Dd*f**2*g2*r*s + 77088*D1*Dd*f**2*g2*r - 44352*D1*Dd*f**2*g2*s**2 + 69168*D1*Dd*f**2*g2*s - 35904*D1*Dd*f**2*g2 + 137280*D1*Dd*f**2*gd2*r**2 + 264000*D1*Dd*f**2*gd2*r*s - 232320*D1*Dd*f**2*gd2*r + 126720*D1*Dd*f**2*gd2*s**2 - 223080*D1*Dd*f**2*gd2*s + 96360*D1*Dd*f**2*gd2 + 274560*D1*Dd*f*fd*g2*r**2 + 528000*D1*Dd*f*fd*g2*r*s - 337920*D1*Dd*f*fd*g2*r + 253440*D1*Dd*f*fd*g2*s**2 - 324720*D1*Dd*f*fd*g2*s + 100320*D1*Dd*f*fd*g2 - 2240*D1*Ddd*f**4*r*s + 1120*D1*Ddd*f**4*r - 2240*D1*Ddd*f**4*s**2 + 2800*D1*Ddd*f**4*s - 1120*D1*Ddd*f**4 + 68640*D1*Ddd*f**2*g2*r**2 + 132000*D1*Ddd*f**2*g2*r*s - 100320*D1*Ddd*f**2*g2*r + 63360*D1*Ddd*f**2*g2*s**2 - 96360*D1*Ddd*f**2*g2*s + 48840*D1*Ddd*f**2*g2 - 6720*Dd**2*f**4*r*s + 3360*Dd**2*f**4*r - 6720*Dd**2*f**4*s**2 + 8400*Dd**2*f**4*s - 2240*Dd**2*f**4 + 205920*Dd**2*f**2*g2*r**2 + 396000*Dd**2*f**2*g2*r*s - 300960*Dd**2*f**2*g2*r + 190080*Dd**2*f**2*g2*s**2 - 289080*Dd**2*f**2*g2*s + 97680*Dd**2*f**2*g2 + 66*b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(28*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-28*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-28*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(164*D1**2*K*fd*r**2 + 328*D1**2*K*fd*r*s + 80*D1**2*K*fd*r + 164*D1**2*K*fd*s**2 + 80*D1**2*K*fd*s - 40*D1**2*K*fd - 236*D1**2*K*fdd*r**2 - 472*D1**2*K*fdd*r*s - 96*D1**2*K*fdd*r - 236*D1**2*K*fdd*s**2 - 96*D1**2*K*fdd*s + 48*D1**2*K*fdd - 2*D1**2*bdd1*(-28*K + 6*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 60*D1**2*f*fd*r**2 - 216*D1**2*f*fd*r*s + 92*D1**2*f*fd*r - 156*D1**2*f*fd*s**2 + 140*D1**2*f*fd*s - 70*D1**2*f*fd + 84*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 112*D1**2*f*fdd*r + 180*D1**2*f*fdd*s**2 - 160*D1**2*f*fdd*s + 80*D1**2*f*fdd + 84*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 112*D1**2*fd**2*r + 180*D1**2*fd**2*s**2 - 160*D1**2*fd**2*s - 20*D1**2*fd**2 - 31*D1**2*fd*r**2 - 102*D1**2*fd*r*s - 20*D1**2*fd*r - 71*D1**2*fd*s**2 - 20*D1**2*fd*s + 10*D1**2*fd + 47*D1**2*fdd*r**2 + 142*D1**2*fdd*r*s + 24*D1**2*fdd*r + 95*D1**2*fdd*s**2 + 24*D1**2*fdd*s - 12*D1**2*fdd + 224*D1**2*gd2*r**2 + 448*D1**2*gd2*r*s - 448*D1**2*gd2*r + 224*D1**2*gd2*s**2 - 448*D1**2*gd2*s + 224*D1**2*gd2 - 112*D1**2*gdd2*r**2 - 224*D1**2*gdd2*r*s + 224*D1**2*gdd2*r - 112*D1**2*gdd2*s**2 + 224*D1**2*gdd2*s - 112*D1**2*gdd2 + 656*D1*Dd*K*f*r**2 + 1312*D1*Dd*K*f*r*s - 984*D1*Dd*K*f*r + 656*D1*Dd*K*f*s**2 - 984*D1*Dd*K*f*s + 492*D1*Dd*K*f - 1888*D1*Dd*K*fd*r**2 - 3776*D1*Dd*K*fd*r*s + 1032*D1*Dd*K*fd*r - 1888*D1*Dd*K*fd*s**2 + 1032*D1*Dd*K*fd*s + 288*D1*Dd*K*fd - 120*D1*Dd*f**2*r**2 - 432*D1*Dd*f**2*r*s + 276*D1*Dd*f**2*r - 312*D1*Dd*f**2*s**2 + 420*D1*Dd*f**2*s - 186*D1*Dd*f**2 + 672*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 1144*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 1624*D1*Dd*f*fd*s + 432*D1*Dd*f*fd - 124*D1*Dd*f*r**2 - 408*D1*Dd*f*r*s + 266*D1*Dd*f*r - 284*D1*Dd*f*s**2 + 386*D1*Dd*f*s - 173*D1*Dd*f + 376*D1*Dd*fd*r**2 + 1136*D1*Dd*fd*r*s - 282*D1*Dd*fd*r + 760*D1*Dd*fd*s**2 - 426*D1*Dd*fd*s - 72*D1*Dd*fd + 896*D1*Dd*g2*r**2 + 1792*D1*Dd*g2*r*s - 1344*D1*Dd*g2*r + 896*D1*Dd*g2*s**2 - 1344*D1*Dd*g2*s + 672*D1*Dd*g2 - 896*D1*Dd*gd2*r**2 - 1792*D1*Dd*gd2*r*s + 1568*D1*Dd*gd2*r - 896*D1*Dd*gd2*s**2 + 1568*D1*Dd*gd2*s - 672*D1*Dd*gd2 - 944*D1*Ddd*K*f*r**2 - 1888*D1*Ddd*K*f*r*s + 1416*D1*Ddd*K*f*r - 944*D1*Ddd*K*f*s**2 + 1416*D1*Ddd*K*f*s - 708*D1*Ddd*K*f + 168*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 348*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 492*D1*Ddd*f**2*s + 222*D1*Ddd*f**2 + 188*D1*Ddd*f*r**2 + 568*D1*Ddd*f*r*s - 378*D1*Ddd*f*r + 380*D1*Ddd*f*s**2 - 522*D1*Ddd*f*s + 237*D1*Ddd*f - 448*D1*Ddd*g2*r**2 - 896*D1*Ddd*g2*r*s + 672*D1*Ddd*g2*r - 448*D1*Ddd*g2*s**2 + 672*D1*Ddd*g2*s - 336*D1*Ddd*g2 + 2*D1*bd1*(D1*(5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(28*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-28*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 2832*Dd**2*K*f*r**2 - 5664*Dd**2*K*f*r*s + 4248*Dd**2*K*f*r - 2832*Dd**2*K*f*s**2 + 4248*Dd**2*K*f*s - 1416*Dd**2*K*f + 504*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 1044*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1476*Dd**2*f**2*s + 444*Dd**2*f**2 + 564*Dd**2*f*r**2 + 1704*Dd**2*f*r*s - 1134*Dd**2*f*r + 1140*Dd**2*f*s**2 - 1566*Dd**2*f*s + 474*Dd**2*f - 1344*Dd**2*g2*r**2 - 2688*Dd**2*g2*r*s + 2016*Dd**2*g2*r - 1344*Dd**2*g2*s**2 + 2016*Dd**2*g2*s - 672*Dd**2*g2) + b1*(-15576*D1**2*K*bdd1*f*r**2 - 31152*D1**2*K*bdd1*f*r*s + 34320*D1**2*K*bdd1*f*r - 15576*D1**2*K*bdd1*f*s**2 + 34320*D1**2*K*bdd1*f*s - 17160*D1**2*K*bdd1*f + 13728*D1**2*K*f*fd*r**2 + 24816*D1**2*K*f*fd*r*s - 13728*D1**2*K*f*fd*r + 11088*D1**2*K*f*fd*s**2 - 12408*D1**2*K*f*fd*s + 6864*D1**2*K*f*fd - 17160*D1**2*K*f*fdd*r**2 - 33000*D1**2*K*f*fdd*r*s + 17160*D1**2*K*f*fdd*r - 15840*D1**2*K*f*fdd*s**2 + 16500*D1**2*K*f*fdd*s - 8580*D1**2*K*f*fdd - 17160*D1**2*K*fd**2*r**2 - 33000*D1**2*K*fd**2*r*s + 17160*D1**2*K*fd**2*r - 15840*D1**2*K*fd**2*s**2 + 16500*D1**2*K*fd**2*s + 1320*D1**2*b2*fd*r**2 + 2640*D1**2*b2*fd*r*s + 1320*D1**2*b2*fd*s**2 - 1584*D1**2*b2*fdd*r**2 - 3168*D1**2*b2*fdd*r*s - 1584*D1**2*b2*fdd*s**2 - 132*D1**2*bd1**2*(-28*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2772*D1**2*bdd1*f**2*r**2 + 8712*D1**2*bdd1*f**2*r*s - 7788*D1**2*bdd1*f**2*r + 5940*D1**2*bdd1*f**2*s**2 - 10956*D1**2*bdd1*f**2*s + 4686*D1**2*bdd1*f**2 + 3102*D1**2*bdd1*f*r**2 + 9372*D1**2*bdd1*f*r*s - 8580*D1**2*bdd1*f*r + 6270*D1**2*bdd1*f*s**2 - 11748*D1**2*bdd1*f*s + 5082*D1**2*bdd1*f - 7392*D1**2*bdd1*g2*r**2 - 14784*D1**2*bdd1*g2*r*s + 7392*D1**2*bdd1*g2*r - 7392*D1**2*bdd1*g2*s**2 + 7392*D1**2*bdd1*g2*s - 3696*D1**2*bdd1*g2 - 1584*D1**2*bdd2*f*r**2 - 3168*D1**2*bdd2*f*r*s + 3168*D1**2*bdd2*f*r - 1584*D1**2*bdd2*f*s**2 + 3168*D1**2*bdd2*f*s - 1584*D1**2*bdd2*f - 3765*D1**2*f**2*fd*r**2 - 8910*D1**2*f**2*fd*r*s + 4820*D1**2*f**2*fd*r - 5145*D1**2*f**2*fd*s**2 + 5740*D1**2*f**2*fd*s - 2310*D1**2*f**2*fd + 4605*D1**2*f**2*fdd*r**2 + 10890*D1**2*f**2*fdd*r*s - 6040*D1**2*f**2*fdd*r + 6285*D1**2*f**2*fdd*s**2 - 7160*D1**2*f**2*fdd*s + 2970*D1**2*f**2*fdd + 9210*D1**2*f*fd**2*r**2 + 21780*D1**2*f*fd**2*r*s - 12080*D1**2*f*fd**2*r + 12570*D1**2*f*fd**2*s**2 - 14320*D1**2*f*fd**2*s + 2970*D1**2*f*fd**2 - 2772*D1**2*f*fd*r**2 - 7128*D1**2*f*fd*r*s + 2772*D1**2*f*fd*r - 4356*D1**2*f*fd*s**2 + 3564*D1**2*f*fd*s - 1386*D1**2*f*fd + 3564*D1**2*f*fdd*r**2 + 9504*D1**2*f*fdd*r*s - 3564*D1**2*f*fdd*r + 5940*D1**2*f*fdd*s**2 - 4752*D1**2*f*fdd*s + 1782*D1**2*f*fdd - 10824*D1**2*f*gd2*r**2 - 21648*D1**2*f*gd2*r*s + 21648*D1**2*f*gd2*r - 10824*D1**2*f*gd2*s**2 + 21648*D1**2*f*gd2*s - 10824*D1**2*f*gd2 + 15576*D1**2*f*gdd2*r**2 + 31152*D1**2*f*gdd2*r*s - 31152*D1**2*f*gdd2*r + 15576*D1**2*f*gdd2*s**2 - 31152*D1**2*f*gdd2*s + 15576*D1**2*f*gdd2 + 3564*D1**2*fd**2*r**2 + 9504*D1**2*fd**2*r*s - 3564*D1**2*fd**2*r + 5940*D1**2*fd**2*s**2 - 4752*D1**2*fd**2*s - 10824*D1**2*fd*g2*r**2 - 21648*D1**2*fd*g2*r*s - 5280*D1**2*fd*g2*r - 10824*D1**2*fd*g2*s**2 - 5280*D1**2*fd*g2*s + 2640*D1**2*fd*g2 + 31152*D1**2*fd*gd2*r**2 + 62304*D1**2*fd*gd2*r*s - 24816*D1**2*fd*gd2*r + 31152*D1**2*fd*gd2*s**2 - 24816*D1**2*fd*gd2*s - 6336*D1**2*fd*gd2 + 15576*D1**2*fdd*g2*r**2 + 31152*D1**2*fdd*g2*r*s + 6336*D1**2*fdd*g2*r + 15576*D1**2*fdd*g2*s**2 + 6336*D1**2*fdd*g2*s - 3168*D1**2*fdd*g2 + 27456*D1*Dd*K*f**2*r**2 + 49632*D1*Dd*K*f**2*r*s - 38544*D1*Dd*K*f**2*r + 22176*D1*Dd*K*f**2*s**2 - 34584*D1*Dd*K*f**2*s + 17952*D1*Dd*K*f**2 - 137280*D1*Dd*K*f*fd*r**2 - 264000*D1*Dd*K*f*fd*r*s + 168960*D1*Dd*K*f*fd*r - 126720*D1*Dd*K*f*fd*s**2 + 162360*D1*Dd*K*f*fd*s - 50160*D1*Dd*K*f*fd + 5280*D1*Dd*b2*f*r**2 + 10560*D1*Dd*b2*f*r*s - 7920*D1*Dd*b2*f*r + 5280*D1*Dd*b2*f*s**2 - 7920*D1*Dd*b2*f*s + 3960*D1*Dd*b2*f - 12672*D1*Dd*b2*fd*r**2 - 25344*D1*Dd*b2*fd*r*s + 9504*D1*Dd*b2*fd*r - 12672*D1*Dd*b2*fd*s**2 + 9504*D1*Dd*b2*fd*s - 5020*D1*Dd*f**3*r**2 - 11880*D1*Dd*f**3*r*s + 8450*D1*Dd*f**3*r - 6860*D1*Dd*f**3*s**2 + 9830*D1*Dd*f**3*s - 4685*D1*Dd*f**3 + 36840*D1*Dd*f**2*fd*r**2 + 87120*D1*Dd*f**2*fd*r*s - 55150*D1*Dd*f**2*fd*r + 50280*D1*Dd*f**2*fd*s**2 - 64670*D1*Dd*f**2*fd*s + 20360*D1*Dd*f**2*fd - 5544*D1*Dd*f**2*r**2 - 14256*D1*Dd*f**2*r*s + 9900*D1*Dd*f**2*r - 8712*D1*Dd*f**2*s**2 + 12276*D1*Dd*f**2*s - 5742*D1*Dd*f**2 + 28512*D1*Dd*f*fd*r**2 + 76032*D1*Dd*f*fd*r*s - 40392*D1*Dd*f*fd*r + 47520*D1*Dd*f*fd*s**2 - 52272*D1*Dd*f*fd*s + 13068*D1*Dd*f*fd - 43296*D1*Dd*f*g2*r**2 - 86592*D1*Dd*f*g2*r*s + 64944*D1*Dd*f*g2*r - 43296*D1*Dd*f*g2*s**2 + 64944*D1*Dd*f*g2*s - 32472*D1*Dd*f*g2 + 124608*D1*Dd*f*gd2*r**2 + 249216*D1*Dd*f*gd2*r*s - 218064*D1*Dd*f*gd2*r + 124608*D1*Dd*f*gd2*s**2 - 218064*D1*Dd*f*gd2*s + 93456*D1*Dd*f*gd2 + 124608*D1*Dd*fd*g2*r**2 + 249216*D1*Dd*fd*g2*r*s - 68112*D1*Dd*fd*g2*r + 124608*D1*Dd*fd*g2*s**2 - 68112*D1*Dd*fd*g2*s - 19008*D1*Dd*fd*g2 - 34320*D1*Ddd*K*f**2*r**2 - 66000*D1*Ddd*K*f**2*r*s + 50160*D1*Ddd*K*f**2*r - 31680*D1*Ddd*K*f**2*s**2 + 48180*D1*Ddd*K*f**2*s - 24420*D1*Ddd*K*f**2 - 6336*D1*Ddd*b2*f*r**2 - 12672*D1*Ddd*b2*f*r*s + 9504*D1*Ddd*b2*f*r - 6336*D1*Ddd*b2*f*s**2 + 9504*D1*Ddd*b2*f*s - 4752*D1*Ddd*b2*f + 6140*D1*Ddd*f**3*r**2 + 14520*D1*Ddd*f**3*r*s - 10330*D1*Ddd*f**3*r + 8380*D1*Ddd*f**3*s**2 - 12010*D1*Ddd*f**3*s + 5725*D1*Ddd*f**3 + 7128*D1*Ddd*f**2*r**2 + 19008*D1*Ddd*f**2*r*s - 13068*D1*Ddd*f**2*r + 11880*D1*Ddd*f**2*s**2 - 16632*D1*Ddd*f**2*s + 7722*D1*Ddd*f**2 + 62304*D1*Ddd*f*g2*r**2 + 124608*D1*Ddd*f*g2*r*s - 93456*D1*Ddd*f*g2*r + 62304*D1*Ddd*f*g2*s**2 - 93456*D1*Ddd*f*g2*s + 46728*D1*Ddd*f*g2 - 66*D1*bd1*(D1*(2*f**2*(15*r**2 + r*(54*s - 46) + 39*s**2 - 70*s + 29) - f*(4*K*(41*r**2 + 82*r*s - 92*r + 41*s**2 - 92*s + 46) + 12*fd*(14*r**2 + r*(44*s - 29) + 30*s**2 - 41*s + 13) - 31*r**2 - 102*r*s + 92*r - 71*s**2 + 132*s - 56) + 2*fd*(4*K*(59*r**2 + 118*r*s - 53*r + 59*s**2 - 53*s - 6) - 47*r**2 - 142*r*s + 53*r - 95*s**2 + 77*s + 6) - 112*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 112*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*(f**2*(168*r**2 + r*(528*s - 410) + 360*s**2 - 578*s + 225) + f*(-4*K*(236*r**2 + 472*r*s - 437*r + 236*s**2 - 437*s + 195) + 188*r**2 + 568*r*s - 449*r + 380*s**2 - 617*s + 243) - 56*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 264*D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 102960*Dd**2*K*f**2*r**2 - 198000*Dd**2*K*f**2*r*s + 150480*Dd**2*K*f**2*r - 95040*Dd**2*K*f**2*s**2 + 144540*Dd**2*K*f**2*s - 48840*Dd**2*K*f**2 - 19008*Dd**2*b2*f*r**2 - 38016*Dd**2*b2*f*r*s + 28512*Dd**2*b2*f*r - 19008*Dd**2*b2*f*s**2 + 28512*Dd**2*b2*f*s - 9504*Dd**2*b2*f + 18420*Dd**2*f**3*r**2 + 43560*Dd**2*f**3*r*s - 30990*Dd**2*f**3*r + 25140*Dd**2*f**3*s**2 - 36030*Dd**2*f**3*s + 11450*Dd**2*f**3 + 21384*Dd**2*f**2*r**2 + 57024*Dd**2*f**2*r*s - 39204*Dd**2*f**2*r + 35640*Dd**2*f**2*s**2 - 49896*Dd**2*f**2*s + 15444*Dd**2*f**2 + 186912*Dd**2*f*g2*r**2 + 373824*Dd**2*f*g2*r*s - 280368*Dd**2*f*g2*r + 186912*Dd**2*f*g2*s**2 - 280368*Dd**2*f*g2*s + 93456*Dd**2*f*g2) + 264*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 100*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2))/(693*d**2*k3**6) + D1**2*Pk1*Pk3*ct*k1**3*st**2*(-44*b1**2*(2*C - 1)*(D1**2*(13*fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(13*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) - 11*b1*(D1**2*(f*(8*C*fdd*(6*r*(2*s - 1) + 32*s**2 - 29*s + 16) - 12*bdd1*s*(2*C - 1)*(2*r + 2*s - 1) + fd*(-8*C*(16*r*s - 8*r + 44*s**2 - 39*s + 22) + 64*r*s - 32*r + 210*s**2 - 190*s + 105) - 3*fdd*(8*r*(2*s - 1) + 50*s**2 - 46*s + 25)) + 2*fd**2*(4*C*(6*r*(2*s - 1) + 32*s**2 - 29*s - 3) + r*(12 - 24*s) - 75*s**2 + 69*s + 6)) - 4*D1*bd1*(2*C - 1)*(D1*(-13*f*s*(2*r + 2*s - 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 6*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(-8*C*Ddd*f*(6*r*(2*s - 1) + 32*s**2 - 35*s + 16) + Dd*f*(16*C*(r*(8*s - 4) + 22*s**2 - 24*s + 11) + r*(32 - 64*s) - 210*s**2 + 226*s - 105) - 2*Dd*fd*(2*s - 1)*(32*C*(3*r + 8*s - 4) - 48*r - 150*s + 75) + 3*Ddd*f*(8*r*(2*s - 1) + 50*s**2 - 54*s + 25)) + 2*Dd**2*f**2*(8*C*(18*r*(2*s - 1) + 96*s**2 - 105*s + 22) - 72*r*(2*s - 1) - 450*s**2 + 486*s - 99)) + f*(132*D1**2*bd1**2*s*(2*C - 1)*(2*r + 2*s - 1) + D1**2*(f*(-11*bdd1*s*(8*C*(6*r + 16*s - 9) - 24*r - 75*s + 36) + 5*fd*(8*C*(21*r*(3*s - 1) + 159*s**2 - 127*s + 53) - 84*r*(3*s - 1) - 729*s**2 + 570*s - 243) + fdd*(-8*C*(91*r*(3*s - 1) + 579*s**2 - 477*s + 193) + 364*r*(3*s - 1) + 2631*s**2 - 2118*s + 877)) + 2*fd**2*(-4*C*(182*r*(3*s - 1) + 1158*s**2 - 954*s + 91) + 364*r*(3*s - 1) + 2631*s**2 - 2118*s + 182)) + 11*D1*bd1*(-16*C*Dd*f*(6*r*(4*s - 1) + 64*s**2 - 53*s + 9) + D1*f*s*(8*C*(8*r + 22*s - 13) - 32*r - 105*s + 52) + D1*fd*(-8*C*(6*r*(4*s - 1) + 64*s**2 - 47*s + 9) + 24*r*(4*s - 1) + 300*s**2 - 210*s + 36) + 12*Dd*f*(4*r*(4*s - 1) + 50*s**2 - 39*s + 6)) + 2*D1*f*(Dd*(5*f*(4*C*(42*r*(2*s - 1) + 212*s**2 - 233*s + 106) - 84*r*(2*s - 1) - 486*s**2 + 528*s - 243) - 4*fd*(C*(182*r*(12*s - 5) + 4632*s**2 - 4497*s + 1045) - 91*r*(12*s - 5) - 2631*s**2 + 2511*s - 575)) + Ddd*f*(-4*C*(182*r*(2*s - 1) + 772*s**2 - 863*s + 386) + 364*r*(2*s - 1) + 1754*s**2 - 1936*s + 877)) + 2*Dd**2*f**2*(-4*C*(546*r*(2*s - 1) + 2316*s**2 - 2589*s + 568) + 1092*r*(2*s - 1) + 5262*s**2 - 5808*s + 1241)))/(231*d**2*k2*k3**4) + 2*D1**2*Pk1*Pk3*ct*k1**3*(28*b1**2*(2*C - 1)*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(-28*bdd1*s*(2*C - 1)*(2*r + 2*s - 1) + fd*(-8*C*(26*r*s - 13*r + 40*s**2 - 34*s + 20) + 104*r*s - 52*r + 198*s**2 - 174*s + 99) + fdd*(8*C*(26*r*s - 13*r + 40*s**2 - 34*s + 20) - 104*r*s + 52*r - 198*s**2 + 174*s - 99)) + 2*fd**2*(4*C*(13*r*(2*s - 1) + 40*s**2 - 34*s - 6) + r*(26 - 52*s) - 99*s**2 + 87*s + 12)) - 28*D1*bd1*(2*C - 1)*(D1*(f*s*(-2*r - 2*s + 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(4*C*(52*r*s - 26*r + 80*s**2 - 93*s + 40) - 104*r*s + 52*r - 198*s**2 + 224*s - 99) - 4*fd*(2*s - 1)*(C*(104*r + 160*s - 81) - 52*r - 99*s + 50)) + Ddd*f*(-4*C*(26*r*(2*s - 1) + 80*s**2 - 93*s + 40) + 52*r*(2*s - 1) + 198*s**2 - 224*s + 99)) + 2*Dd**2*f**2*(12*C*(26*r*(2*s - 1) + 80*s**2 - 93*s + 22) - 156*r*(2*s - 1) - 594*s**2 + 672*s - 151)) + f*(-28*D1**2*bd1**2*s*(2*C - 1)*(2*r + 2*s - 1) + D1**2*(f*(bdd1*s*(8*C*(13*r + 20*s - 19) - 52*r - 99*s + 76) - 4*fd*(2*C*(51*r*s - 17*r + 66*s**2 - 61*s + 22) - 51*r*s + 17*r - 78*s**2 + 69*s - 26) + 4*fdd*(2*C*(51*r*s - 17*r + 66*s**2 - 61*s + 22) - 51*r*s + 17*r - 78*s**2 + 69*s - 26)) + 4*fd**2*(C*(68*r*(3*s - 1) + 264*s**2 - 244*s + 34) - 34*r*(3*s - 1) - 156*s**2 + 138*s - 17)) + D1*bd1*(D1*(f*s*(-8*C*(13*r + 20*s - 19) + 52*r + 99*s - 76) + 2*fd*(4*C*(52*r*s - 13*r + 80*s**2 - 72*s + 19) - 104*r*s + 26*r - 198*s**2 + 163*s - 38)) + 8*Dd*f*(C*(26*r*(4*s - 1) + 160*s**2 - 169*s + 38) - 52*r*s + 13*r - 99*s**2 + 94*s - 19)) - 4*D1*f*(Dd*(f*(2*C*(34*r*(2*s - 1) + 88*s**2 - 105*s + 44) + r*(34 - 68*s) - 104*s**2 + 121*s - 52) + fd*(-2*C*(34*r*(12*s - 5) + 528*s**2 - 559*s + 139) + 34*r*(12*s - 5) + 624*s**2 - 639*s + 155)) + Ddd*f*(-2*C*(34*r*(2*s - 1) + 88*s**2 - 105*s + 44) + 34*r*(2*s - 1) + 104*s**2 - 121*s + 52)) + 4*Dd**2*f**2*(6*C*(34*r*(2*s - 1) + 88*s**2 - 105*s + 26) - 102*r*(2*s - 1) - 312*s**2 + 363*s - 86)))/(21*d**2*k2*k3**4) + D1**2*Pk1*Pk3*ct*k1*k2**5*st**6*(80*C - 60)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(231*d**2*k3**8) + 8*D1**2*Pk1*Pk3*ct*k1*k2**5*st**4*(-858*D1**2*bd1**2*f*(2*K - 1)*(r + s - 1)**2 - 13*D1*bd1*(D1*(50*f**3*(r + s - 1) + f**2*(132*C*(r + s - 1) - 50*fd*(3*r + 3*s - 2) - 99*r - 99*s + 99) + 264*f*(g2 - gd2)*(r + s - 1) - 264*fd*g2*(r + s)) - 2*Dd*f*(25*f**2 + 132*g2)*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*(D1**2*(2*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (2*K - 1)*(2*fd - fdd)*(r + s)**2) + D1*(2*Dd*(f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(2*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(2*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(-264*C*D1**2*f*fd*r**2 - 528*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*r - 264*C*D1**2*f*fd*s**2 + 264*C*D1**2*f*fd*s - 132*C*D1**2*f*fd - 528*C*D1*Dd*f**2*r**2 - 1056*C*D1*Dd*f**2*r*s + 792*C*D1*Dd*f**2*r - 528*C*D1*Dd*f**2*s**2 + 792*C*D1*Dd*f**2*s - 396*C*D1*Dd*f**2 - 66*D1**2*bdd1*f*(2*K - 1)*(r + s - 1)**2 - 150*D1**2*f**2*fd*r**2 - 300*D1**2*f**2*fd*r*s + 200*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 200*D1**2*f**2*fd*s - 100*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 + 198*D1**2*f*fd*r**2 + 396*D1**2*f*fd*r*s - 198*D1**2*f*fd*r + 198*D1**2*f*fd*s**2 - 198*D1**2*f*fd*s + 99*D1**2*f*fd - 264*D1**2*f*gd2*r**2 - 528*D1**2*f*gd2*r*s + 528*D1**2*f*gd2*r - 264*D1**2*f*gd2*s**2 + 528*D1**2*f*gd2*s - 264*D1**2*f*gd2 + 132*D1**2*f*gdd2*r**2 + 264*D1**2*f*gdd2*r*s - 264*D1**2*f*gdd2*r + 132*D1**2*f*gdd2*s**2 - 264*D1**2*f*gdd2*s + 132*D1**2*f*gdd2 - 264*D1**2*fd*g2*r**2 - 528*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*s**2 + 264*D1**2*fd*gd2*r**2 + 528*D1**2*fd*gd2*r*s - 264*D1**2*fd*gd2*r + 264*D1**2*fd*gd2*s**2 - 264*D1**2*fd*gd2*s + 132*D1**2*fdd*g2*r**2 + 264*D1**2*fdd*g2*r*s + 132*D1**2*fdd*g2*s**2 - 200*D1*Dd*f**3*r**2 - 400*D1*Dd*f**3*r*s + 300*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 300*D1*Dd*f**3*s - 150*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 850*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 850*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd + 396*D1*Dd*f**2*r**2 + 792*D1*Dd*f**2*r*s - 594*D1*Dd*f**2*r + 396*D1*Dd*f**2*s**2 - 594*D1*Dd*f**2*s + 297*D1*Dd*f**2 - 1056*D1*Dd*f*g2*r**2 - 2112*D1*Dd*f*g2*r*s + 1584*D1*Dd*f*g2*r - 1056*D1*Dd*f*g2*s**2 + 1584*D1*Dd*f*g2*s - 792*D1*Dd*f*g2 + 1056*D1*Dd*f*gd2*r**2 + 2112*D1*Dd*f*gd2*r*s - 1848*D1*Dd*f*gd2*r + 1056*D1*Dd*f*gd2*s**2 - 1848*D1*Dd*f*gd2*s + 792*D1*Dd*f*gd2 + 1056*D1*Dd*fd*g2*r**2 + 2112*D1*Dd*fd*g2*r*s - 792*D1*Dd*fd*g2*r + 1056*D1*Dd*fd*g2*s**2 - 792*D1*Dd*fd*g2*s + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 528*D1*Ddd*f*g2*r**2 + 1056*D1*Ddd*f*g2*r*s - 792*D1*Ddd*f*g2*r + 528*D1*Ddd*f*g2*s**2 - 792*D1*Ddd*f*g2*s + 396*D1*Ddd*f*g2 + 132*D1*bd1*(D1*(f**2*(r + s - 1) + f*(2*K - 1)*(r + s - 1) - fd*(2*K - 1)*(r + s)) - Dd*f*(2*K - 1)*(4*r + 4*s - 3))*(r + s - 1) + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 + 1584*Dd**2*f*g2*r**2 + 3168*Dd**2*f*g2*r*s - 2376*Dd**2*f*g2*r + 1584*Dd**2*f*g2*s**2 - 2376*Dd**2*f*g2*s + 792*Dd**2*f*g2) + f*(13*D1**2*bdd1*(25*f**2 + 132*g2)*(r + s - 1)**2 + f*(D1**2*(-f*(857*fd - 500*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 3000*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(-857*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 1000*fd*(4*r + 4*s - 3)**2) + 500*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 3000*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(1001*d**2*k3**8) + D1**2*Pk1*Pk3*ct*k1*k2**3*st**6*(160*C - 120)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(693*d**2*k3**6) + 4*D1**2*Pk1*Pk3*ct*k1*k2**3*st**4*(66*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(24*C*D1**2*f*fd*r**2 - 16*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*r - 40*C*D1**2*f*fd*s**2 + 40*C*D1**2*f*fd*s - 20*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 112*C*D1**2*f*fdd*r*s - 56*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 36*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 112*C*D1**2*fd**2*r*s - 56*C*D1**2*fd**2*r + 72*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s + 48*C*D1*Dd*f**2*r**2 - 32*C*D1*Dd*f**2*r*s - 8*C*D1*Dd*f**2*r - 80*C*D1*Dd*f**2*s**2 + 88*C*D1*Dd*f**2*s - 28*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 896*C*D1*Dd*f*fd*r*s - 528*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 688*C*D1*Dd*f*fd*s + 200*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 224*C*D1*Ddd*f**2*r*s - 152*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 200*C*D1*Ddd*f**2*s + 92*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 672*C*Dd**2*f**2*r*s - 456*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 600*C*Dd**2*f**2*s + 184*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 14*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s - 6*D1**2*f*fd*r + 26*D1**2*f*fd*s**2 - 26*D1**2*f*fd*s + 13*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 84*D1**2*f*fdd*r*s + 42*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 54*D1**2*f*fdd*s - 27*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 84*D1**2*fd**2*r*s + 42*D1**2*fd**2*r - 54*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s - 28*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r + 52*D1*Dd*f**2*s**2 - 58*D1*Dd*f**2*s + 19*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 672*D1*Dd*f*fd*r*s + 396*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 516*D1*Dd*f*fd*s - 150*D1*Dd*f*fd - 60*D1*Ddd*f**2*r**2 - 168*D1*Ddd*f**2*r*s + 114*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 150*D1*Ddd*f**2*s - 69*D1*Ddd*f**2 + 4*D1*bd1*(4*C - 3)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 180*Dd**2*f**2*r**2 - 504*Dd**2*f**2*r*s + 342*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 450*Dd**2*f**2*s - 138*Dd**2*f**2) + f*(-132*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(4*C - 3)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) + 2*D1**2*(f*(2*fd - fdd)*(8*C*(33*r**2 + 6*r*(10*s - 7) + 27*s**2 - 38*s + 20) - 195*r**2 + r*(248 - 354*s) - 159*s**2 + 224*s - 118) + 2*fd**2*(-8*C*(33*r**2 + 6*r*(10*s - 7) + 27*s**2 - 38*s + 10) + 195*r**2 + r*(354*s - 248) + 159*s**2 - 224*s + 59)) + 33*D1*bd1*(D1*(f*(r + s - 1)*(4*C*(3*r - 5*s - 3) - 7*r + 13*s + 7) + fd*(8*C - 6)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7)) + Dd*f*(8*C - 6)*(20*r**2 + r*(56*s - 39) + 36*s**2 - 53*s + 19)) + 2*D1*f*(2*Dd*(f*(8*C*(44*r**2 + 80*r*s - 62*r + 36*s**2 - 56*s + 29) - 260*r**2 - 472*r*s + 366*r - 212*s**2 + 330*s - 171) + fd*(-8*C*(132*r**2 + 3*r*(80*s - 59) + 108*s**2 - 160*s + 59) + 780*r**2 + 1416*r*s - 1045*r + 636*s**2 - 943*s + 348)) + Ddd*f*(-8*C*(44*r**2 + 80*r*s - 62*r + 36*s**2 - 56*s + 29) + 260*r**2 + 472*r*s - 366*r + 212*s**2 - 330*s + 171)) - 4*Dd**2*f**2*(8*C*(66*r**2 + 3*r*(40*s - 31) + 54*s**2 - 84*s + 29) - 390*r**2 - 3*r*(236*s - 183) - 318*s**2 + 495*s - 171)))/(231*d**2*k3**6) + 2*D1**2*Pk1*Pk3*ct*k1*k2**3*st**2*(-30888*C*D1**2*bd1*f**2*r**2 - 37752*C*D1**2*bd1*f**2*r*s + 68640*C*D1**2*bd1*f**2*r - 6864*C*D1**2*bd1*f**2*s**2 + 44616*C*D1**2*bd1*f**2*s - 34320*C*D1**2*bd1*f**2 - 102960*C*D1**2*f**2*fd*r**2 - 133848*C*D1**2*f**2*fd*r*s + 113256*C*D1**2*f**2*fd*r - 30888*C*D1**2*f**2*fd*s**2 + 65208*C*D1**2*f**2*fd*s - 44616*C*D1**2*f**2*fd - 137280*C*D1*Dd*f**3*r**2 - 178464*C*D1*Dd*f**3*r*s + 157872*C*D1*Dd*f**3*r - 41184*C*D1*Dd*f**3*s**2 + 85800*C*D1*Dd*f**3*s - 54912*C*D1*Dd*f**3 - 8580*D1**2*K*bd1**2*f*r**2 + 13728*D1**2*K*bd1**2*f*r*s + 5148*D1**2*K*bd1**2*f*r + 22308*D1**2*K*bd1**2*f*s**2 - 25740*D1**2*K*bd1**2*f*s + 3432*D1**2*K*bd1**2*f + 59202*D1**2*K*bd1*f**2*r**2 + 97812*D1**2*K*bd1*f**2*r*s - 97812*D1**2*K*bd1*f**2*r + 38610*D1**2*K*bd1*f**2*s**2 - 77220*D1**2*K*bd1*f**2*s + 38610*D1**2*K*bd1*f**2 - 161304*D1**2*K*bd1*f*fd*r**2 - 260832*D1**2*K*bd1*f*fd*r*s + 211068*D1**2*K*bd1*f*fd*r - 99528*D1**2*K*bd1*f*fd*s**2 + 164736*D1**2*K*bd1*f*fd*s - 65208*D1**2*K*bd1*f*fd - 40326*D1**2*K*bdd1*f**2*r**2 - 65208*D1**2*K*bdd1*f**2*r*s + 65208*D1**2*K*bdd1*f**2*r - 24882*D1**2*K*bdd1*f**2*s**2 + 49764*D1**2*K*bdd1*f**2*s - 24882*D1**2*K*bdd1*f**2 + 84942*D1**2*bd1**2*f**2*r**2 + 190476*D1**2*bd1**2*f**2*r*s - 180180*D1**2*bd1**2*f**2*r + 105534*D1**2*bd1**2*f**2*s**2 - 200772*D1**2*bd1**2*f**2*s + 95238*D1**2*bd1**2*f**2 + 4290*D1**2*bd1**2*f*r**2 - 1716*D1**2*bd1**2*f*r*s - 5148*D1**2*bd1**2*f*r - 6006*D1**2*bd1**2*f*s**2 + 5148*D1**2*bd1**2*f*s + 858*D1**2*bd1**2*f + 48048*D1**2*bd1**2*g2*r**2 + 96096*D1**2*bd1**2*g2*r*s - 48048*D1**2*bd1**2*g2*r + 48048*D1**2*bd1**2*g2*s**2 - 48048*D1**2*bd1**2*g2*s - 20592*D1**2*bd1*bd2*f*r**2 - 41184*D1**2*bd1*bd2*f*r*s + 41184*D1**2*bd1*bd2*f*r - 20592*D1**2*bd1*bd2*f*s**2 + 41184*D1**2*bd1*bd2*f*s - 20592*D1**2*bd1*bd2*f - 33228*D1**2*bd1*f**3*r**2 - 37440*D1**2*bd1*f**3*r*s + 57252*D1**2*bd1*f**3*r - 4212*D1**2*bd1*f**3*s**2 + 28236*D1**2*bd1*f**3*s - 31434*D1**2*bd1*f**3 + 182052*D1**2*bd1*f**2*fd*r**2 + 163800*D1**2*bd1*f**2*fd*r*s - 218868*D1**2*bd1*f**2*fd*r - 18252*D1**2*bd1*f**2*fd*s**2 - 51948*D1**2*bd1*f**2*fd*s + 34008*D1**2*bd1*f**2*fd - 9867*D1**2*bd1*f**2*r**2 - 30030*D1**2*bd1*f**2*r*s + 6006*D1**2*bd1*f**2*r - 20163*D1**2*bd1*f**2*s**2 + 16302*D1**2*bd1*f**2*s + 1287*D1**2*bd1*f**2 + 80652*D1**2*bd1*f*fd*r**2 + 140712*D1**2*bd1*f*fd*r*s - 110682*D1**2*bd1*f*fd*r + 60060*D1**2*bd1*f*fd*s**2 - 95238*D1**2*bd1*f*fd*s + 35178*D1**2*bd1*f*fd - 173316*D1**2*bd1*f*g2*r**2 - 284856*D1**2*bd1*f*g2*r*s + 360360*D1**2*bd1*f*g2*r - 111540*D1**2*bd1*f*g2*s**2 + 298584*D1**2*bd1*f*g2*s - 180180*D1**2*bd1*f*g2 + 17160*D1**2*bd1*f*gd2*r**2 - 27456*D1**2*bd1*f*gd2*r*s - 10296*D1**2*bd1*f*gd2*r - 44616*D1**2*bd1*f*gd2*s**2 + 51480*D1**2*bd1*f*gd2*s - 6864*D1**2*bd1*f*gd2 + 17160*D1**2*bd1*fd*g2*r**2 - 27456*D1**2*bd1*fd*g2*r*s - 17160*D1**2*bd1*fd*g2*r - 44616*D1**2*bd1*fd*g2*s**2 + 13728*D1**2*bd1*fd*g2*s + 18876*D1**2*bd2*f**2*r**2 + 37752*D1**2*bd2*f**2*r*s - 37752*D1**2*bd2*f**2*r + 18876*D1**2*bd2*f**2*s**2 - 37752*D1**2*bd2*f**2*s + 18876*D1**2*bd2*f**2 - 41184*D1**2*bd2*f*fd*r**2 - 82368*D1**2*bd2*f*fd*r*s + 61776*D1**2*bd2*f*fd*r - 41184*D1**2*bd2*f*fd*s**2 + 61776*D1**2*bd2*f*fd*s - 20592*D1**2*bd2*f*fd + 30342*D1**2*bdd1*f**3*r**2 + 27300*D1**2*bdd1*f**3*r*s - 51792*D1**2*bdd1*f**3*r - 3042*D1**2*bdd1*f**3*s**2 - 18408*D1**2*bdd1*f**3*s + 27300*D1**2*bdd1*f**3 + 20163*D1**2*bdd1*f**2*r**2 + 35178*D1**2*bdd1*f**2*r*s - 35178*D1**2*bdd1*f**2*r + 15015*D1**2*bdd1*f**2*s**2 - 30030*D1**2*bdd1*f**2*s + 15015*D1**2*bdd1*f**2 + 8580*D1**2*bdd1*f*g2*r**2 - 13728*D1**2*bdd1*f*g2*r*s - 24024*D1**2*bdd1*f*g2*r - 22308*D1**2*bdd1*f*g2*s**2 + 6864*D1**2*bdd1*f*g2*s + 12012*D1**2*bdd1*f*g2 - 10296*D1**2*bdd2*f**2*r**2 - 20592*D1**2*bdd2*f**2*r*s + 20592*D1**2*bdd2*f**2*r - 10296*D1**2*bdd2*f**2*s**2 + 20592*D1**2*bdd2*f**2*s - 10296*D1**2*bdd2*f**2 + 67940*D1**2*f**3*fd*r**2 + 220040*D1**2*f**3*fd*r*s - 143990*D1**2*f**3*fd*r + 152100*D1**2*f**3*fd*s**2 - 207110*D1**2*f**3*fd*s + 93035*D1**2*f**3*fd - 81420*D1**2*f**3*fdd*r**2 - 256920*D1**2*f**3*fdd*r*s + 169170*D1**2*f**3*fdd*r - 175500*D1**2*f**3*fdd*s**2 + 239730*D1**2*f**3*fdd*s - 108105*D1**2*f**3*fdd - 244260*D1**2*f**2*fd**2*r**2 - 770760*D1**2*f**2*fd**2*r*s + 507510*D1**2*f**2*fd**2*r - 526500*D1**2*f**2*fd**2*s**2 + 719190*D1**2*f**2*fd**2*s - 216210*D1**2*f**2*fd**2 + 74646*D1**2*f**2*fd*r**2 + 92664*D1**2*f**2*fd*r*s - 80652*D1**2*f**2*fd*r + 18018*D1**2*f**2*fd*s**2 - 42900*D1**2*f**2*fd*s + 30888*D1**2*f**2*fd - 118404*D1**2*f**2*gd2*r**2 - 195624*D1**2*f**2*gd2*r*s + 195624*D1**2*f**2*gd2*r - 77220*D1**2*f**2*gd2*s**2 + 154440*D1**2*f**2*gd2*s - 77220*D1**2*f**2*gd2 + 80652*D1**2*f**2*gdd2*r**2 + 130416*D1**2*f**2*gdd2*r*s - 130416*D1**2*f**2*gdd2*r + 49764*D1**2*f**2*gdd2*s**2 - 99528*D1**2*f**2*gdd2*s + 49764*D1**2*f**2*gdd2 - 236808*D1**2*f*fd*g2*r**2 - 391248*D1**2*f*fd*g2*r*s + 236808*D1**2*f*fd*g2*r - 154440*D1**2*f*fd*g2*s**2 + 195624*D1**2*f*fd*g2*s - 118404*D1**2*f*fd*g2 + 322608*D1**2*f*fd*gd2*r**2 + 521664*D1**2*f*fd*gd2*r*s - 422136*D1**2*f*fd*gd2*r + 199056*D1**2*f*fd*gd2*s**2 - 329472*D1**2*f*fd*gd2*s + 130416*D1**2*f*fd*gd2 + 161304*D1**2*f*fdd*g2*r**2 + 260832*D1**2*f*fdd*g2*r*s - 161304*D1**2*f*fdd*g2*r + 99528*D1**2*f*fdd*g2*s**2 - 130416*D1**2*f*fdd*g2*s + 80652*D1**2*f*fdd*g2 + 161304*D1**2*fd**2*g2*r**2 + 260832*D1**2*fd**2*g2*r*s - 161304*D1**2*fd**2*g2*r + 99528*D1**2*fd**2*g2*s**2 - 130416*D1**2*fd**2*g2*s - 322608*D1*Dd*K*bd1*f**2*r**2 - 521664*D1*Dd*K*bd1*f**2*r*s + 471900*D1*Dd*K*bd1*f**2*r - 199056*D1*Dd*K*bd1*f**2*s**2 + 363792*D1*Dd*K*bd1*f**2*s - 164736*D1*Dd*K*bd1*f**2 + 242736*D1*Dd*bd1*f**3*r**2 + 218400*D1*Dd*bd1*f**3*r*s - 322452*D1*Dd*bd1*f**3*r - 24336*D1*Dd*bd1*f**3*s**2 - 88764*D1*Dd*bd1*f**3*s + 88608*D1*Dd*bd1*f**3 + 161304*D1*Dd*bd1*f**2*r**2 + 281424*D1*Dd*bd1*f**2*r*s - 251394*D1*Dd*bd1*f**2*r + 120120*D1*Dd*bd1*f**2*s**2 - 215358*D1*Dd*bd1*f**2*s + 95238*D1*Dd*bd1*f**2 + 68640*D1*Dd*bd1*f*g2*r**2 - 109824*D1*Dd*bd1*f*g2*r*s - 85800*D1*Dd*bd1*f*g2*r - 178464*D1*Dd*bd1*f*g2*s**2 + 130416*D1*Dd*bd1*f*g2*s + 10296*D1*Dd*bd1*f*g2 - 82368*D1*Dd*bd2*f**2*r**2 - 164736*D1*Dd*bd2*f**2*r*s + 144144*D1*Dd*bd2*f**2*r - 82368*D1*Dd*bd2*f**2*s**2 + 144144*D1*Dd*bd2*f**2*s - 61776*D1*Dd*bd2*f**2 + 67940*D1*Dd*f**4*r**2 + 220040*D1*Dd*f**4*r*s - 143990*D1*Dd*f**4*r + 152100*D1*Dd*f**4*s**2 - 207110*D1*Dd*f**4*s + 93035*D1*Dd*f**4 - 651360*D1*Dd*f**3*fd*r**2 - 2055360*D1*Dd*f**3*fd*r*s + 1353360*D1*Dd*f**3*fd*r - 1404000*D1*Dd*f**3*fd*s**2 + 1917840*D1*Dd*f**3*fd*s - 648630*D1*Dd*f**3*fd + 99528*D1*Dd*f**3*r**2 + 123552*D1*Dd*f**3*r*s - 111540*D1*Dd*f**3*r + 24024*D1*Dd*f**3*s**2 - 54912*D1*Dd*f**3*s + 36894*D1*Dd*f**3 - 473616*D1*Dd*f**2*g2*r**2 - 782496*D1*Dd*f**2*g2*r*s + 628056*D1*Dd*f**2*g2*r - 308880*D1*Dd*f**2*g2*s**2 + 504504*D1*Dd*f**2*g2*s - 272844*D1*Dd*f**2*g2 + 645216*D1*Dd*f**2*gd2*r**2 + 1043328*D1*Dd*f**2*gd2*r*s - 943800*D1*Dd*f**2*gd2*r + 398112*D1*Dd*f**2*gd2*s**2 - 727584*D1*Dd*f**2*gd2*s + 329472*D1*Dd*f**2*gd2 + 1290432*D1*Dd*f*fd*g2*r**2 + 2086656*D1*Dd*f*fd*g2*r*s - 1489488*D1*Dd*f*fd*g2*r + 796224*D1*Dd*f*fd*g2*s**2 - 1180608*D1*Dd*f*fd*g2*s + 422136*D1*Dd*f*fd*g2 - 81420*D1*Ddd*f**4*r**2 - 256920*D1*Ddd*f**4*r*s + 169170*D1*Ddd*f**4*r - 175500*D1*Ddd*f**4*s**2 + 239730*D1*Ddd*f**4*s - 108105*D1*Ddd*f**4 + 322608*D1*Ddd*f**2*g2*r**2 + 521664*D1*Ddd*f**2*g2*r*s - 422136*D1*Ddd*f**2*g2*r + 199056*D1*Ddd*f**2*g2*s**2 - 329472*D1*Ddd*f**2*g2*s + 180180*D1*Ddd*f**2*g2 - 244260*Dd**2*f**4*r**2 - 770760*Dd**2*f**4*r*s + 507510*Dd**2*f**4*r - 526500*Dd**2*f**4*s**2 + 719190*Dd**2*f**4*s - 216210*Dd**2*f**4 + 967824*Dd**2*f**2*g2*r**2 + 1564992*Dd**2*f**2*g2*r*s - 1266408*Dd**2*f**2*g2*r + 597168*Dd**2*f**2*g2*s**2 - 988416*Dd**2*f**2*g2*s + 360360*Dd**2*f**2*g2 + 858*b1**3*(D1**2*(32*fd - 9*fdd)*(r + s - 1)**2 + D1*(2*Dd*(16*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 9*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(14*K + 9*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(14*K + 9*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(-56*C*D1**2*fd*r**2 - 112*C*D1**2*fd*r*s + 112*C*D1**2*fd*r - 56*C*D1**2*fd*s**2 + 112*C*D1**2*fd*s - 56*C*D1**2*fd - 224*C*D1*Dd*f*r**2 - 448*C*D1*Dd*f*r*s + 336*C*D1*Dd*f*r - 224*C*D1*Dd*f*s**2 + 336*C*D1*Dd*f*s - 168*C*D1*Dd*f + 202*D1**2*K*fd*r**2 + 332*D1**2*K*fd*r*s + 16*D1**2*K*fd*r + 130*D1**2*K*fd*s**2 + 16*D1**2*K*fd*s - 8*D1**2*K*fd - 10*D1**2*K*fdd*r**2 + 16*D1**2*K*fdd*r*s - 8*D1**2*K*fdd*r + 26*D1**2*K*fdd*s**2 - 8*D1**2*K*fdd*s + 4*D1**2*K*fdd - 2*D1**2*bdd1*(14*K + 9*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 194*D1**2*f*fd*r**2 - 436*D1**2*f*fd*r*s + 206*D1**2*f*fd*r - 242*D1**2*f*fd*s**2 + 230*D1**2*f*fd*s - 115*D1**2*f*fd + 198*D1**2*f*fdd*r**2 + 444*D1**2*f*fdd*r*s - 222*D1**2*f*fdd*r + 246*D1**2*f*fdd*s**2 - 246*D1**2*f*fdd*s + 123*D1**2*f*fdd + 198*D1**2*fd**2*r**2 + 444*D1**2*fd**2*r*s - 222*D1**2*fd**2*r + 246*D1**2*fd**2*s**2 - 246*D1**2*fd**2*s - 45*D1**2*fd*r**2 - 94*D1**2*fd*r*s - 92*D1**2*fd*r - 49*D1**2*fd*s**2 - 92*D1**2*fd*s + 46*D1**2*fd + 5*D1**2*fdd*r**2 - 2*D1**2*fdd*r*s + 4*D1**2*fdd*r - 7*D1**2*fdd*s**2 + 4*D1**2*fdd*s - 2*D1**2*fdd - 112*D1**2*gd2*r**2 - 224*D1**2*gd2*r*s + 224*D1**2*gd2*r - 112*D1**2*gd2*s**2 + 224*D1**2*gd2*s - 112*D1**2*gd2 + 56*D1**2*gdd2*r**2 + 112*D1**2*gdd2*r*s - 112*D1**2*gdd2*r + 56*D1**2*gdd2*s**2 - 112*D1**2*gdd2*s + 56*D1**2*gdd2 + 808*D1*Dd*K*f*r**2 + 1328*D1*Dd*K*f*r*s - 1068*D1*Dd*K*f*r + 520*D1*Dd*K*f*s**2 - 852*D1*Dd*K*f*s + 462*D1*Dd*K*f - 80*D1*Dd*K*fd*r**2 + 128*D1*Dd*K*fd*r*s - 44*D1*Dd*K*fd*r + 208*D1*Dd*K*fd*s**2 - 152*D1*Dd*K*fd*s + 24*D1*Dd*K*fd - 388*D1*Dd*f**2*r**2 - 872*D1*Dd*f**2*r*s + 630*D1*Dd*f**2*r - 484*D1*Dd*f**2*s**2 + 702*D1*Dd*f**2*s - 339*D1*Dd*f**2 + 1584*D1*Dd*f*fd*r**2 + 3552*D1*Dd*f*fd*r*s - 2172*D1*Dd*f*fd*r + 1968*D1*Dd*f*fd*s**2 - 2412*D1*Dd*f*fd*s + 714*D1*Dd*f*fd - 180*D1*Dd*f*r**2 - 376*D1*Dd*f*r*s + 278*D1*Dd*f*r - 196*D1*Dd*f*s**2 + 290*D1*Dd*f*s - 143*D1*Dd*f + 40*D1*Dd*fd*r**2 - 16*D1*Dd*fd*r*s + 10*D1*Dd*fd*r - 56*D1*Dd*fd*s**2 + 46*D1*Dd*fd*s - 12*D1*Dd*fd - 448*D1*Dd*g2*r**2 - 896*D1*Dd*g2*r*s + 672*D1*Dd*g2*r - 448*D1*Dd*g2*s**2 + 672*D1*Dd*g2*s - 336*D1*Dd*g2 + 448*D1*Dd*gd2*r**2 + 896*D1*Dd*gd2*r*s - 784*D1*Dd*gd2*r + 448*D1*Dd*gd2*s**2 - 784*D1*Dd*gd2*s + 336*D1*Dd*gd2 - 40*D1*Ddd*K*f*r**2 + 64*D1*Ddd*K*f*r*s - 12*D1*Ddd*K*f*r + 104*D1*Ddd*K*f*s**2 - 120*D1*Ddd*K*f*s + 42*D1*Ddd*K*f + 396*D1*Ddd*f**2*r**2 + 888*D1*Ddd*f**2*r*s - 642*D1*Ddd*f**2*r + 492*D1*Ddd*f**2*s**2 - 714*D1*Ddd*f**2*s + 345*D1*Ddd*f**2 + 20*D1*Ddd*f*r**2 - 8*D1*Ddd*f*r*s - 6*D1*Ddd*f*r - 28*D1*Ddd*f*s**2 + 30*D1*Ddd*f*s - 9*D1*Ddd*f + 224*D1*Ddd*g2*r**2 + 448*D1*Ddd*g2*r*s - 336*D1*Ddd*g2*r + 224*D1*Ddd*g2*s**2 - 336*D1*Ddd*g2*s + 168*D1*Ddd*g2 + 4*D1*bd1*(D1*(16*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(14*K + 9*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 120*Dd**2*K*f*r**2 + 192*Dd**2*K*f*r*s - 36*Dd**2*K*f*r + 312*Dd**2*K*f*s**2 - 360*Dd**2*K*f*s + 84*Dd**2*K*f + 1188*Dd**2*f**2*r**2 + 2664*Dd**2*f**2*r*s - 1926*Dd**2*f**2*r + 1476*Dd**2*f**2*s**2 - 2142*Dd**2*f**2*s + 690*Dd**2*f**2 + 60*Dd**2*f*r**2 - 24*Dd**2*f*r*s - 18*Dd**2*f*r - 84*Dd**2*f*s**2 + 90*Dd**2*f*s - 18*Dd**2*f + 672*Dd**2*g2*r**2 + 1344*Dd**2*g2*r*s - 1008*Dd**2*g2*r + 672*Dd**2*g2*s**2 - 1008*Dd**2*g2*s + 336*Dd**2*g2) - 39*b1*(1584*C*D1**2*f*fd*r**2 + 1936*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 352*C*D1**2*f*fd*s**2 - 176*C*D1**2*f*fd*s + 88*C*D1**2*f*fd + 3168*C*D1*Dd*f**2*r**2 + 3872*C*D1*Dd*f**2*r*s - 3520*C*D1*Dd*f**2*r + 704*C*D1*Dd*f**2*s**2 - 1672*C*D1*Dd*f**2*s + 1144*C*D1*Dd*f**2 + 220*D1**2*K*bdd1*f*r**2 - 352*D1**2*K*bdd1*f*r*s - 132*D1**2*K*bdd1*f*r - 572*D1**2*K*bdd1*f*s**2 + 660*D1**2*K*bdd1*f*s - 132*D1**2*K*bdd1*f - 3036*D1**2*K*f*fd*r**2 - 5016*D1**2*K*f*fd*r*s + 3036*D1**2*K*f*fd*r - 1980*D1**2*K*f*fd*s**2 + 2508*D1**2*K*f*fd*s - 1518*D1**2*K*f*fd + 2068*D1**2*K*f*fdd*r**2 + 3344*D1**2*K*f*fdd*r*s - 2068*D1**2*K*f*fdd*r + 1276*D1**2*K*f*fdd*s**2 - 1672*D1**2*K*f*fdd*s + 1034*D1**2*K*f*fdd + 2068*D1**2*K*fd**2*r**2 + 3344*D1**2*K*fd**2*r*s - 2068*D1**2*K*fd**2*r + 1276*D1**2*K*fd**2*s**2 - 1672*D1**2*K*fd**2*s - 836*D1**2*b2*fd*r**2 - 1672*D1**2*b2*fd*r*s - 836*D1**2*b2*fd*s**2 + 264*D1**2*b2*fdd*r**2 + 528*D1**2*b2*fdd*r*s + 264*D1**2*b2*fdd*s**2 + 44*D1**2*bd1**2*(14*K + 9*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2178*D1**2*bdd1*f**2*r**2 - 4884*D1**2*bdd1*f**2*r*s + 4620*D1**2*bdd1*f**2*r - 2706*D1**2*bdd1*f**2*s**2 + 5148*D1**2*bdd1*f**2*s - 2442*D1**2*bdd1*f**2 - 110*D1**2*bdd1*f*r**2 + 44*D1**2*bdd1*f*r*s + 132*D1**2*bdd1*f*r + 154*D1**2*bdd1*f*s**2 - 132*D1**2*bdd1*f*s - 1232*D1**2*bdd1*g2*r**2 - 2464*D1**2*bdd1*g2*r*s + 1232*D1**2*bdd1*g2*r - 1232*D1**2*bdd1*g2*s**2 + 1232*D1**2*bdd1*g2*s - 616*D1**2*bdd1*g2 + 264*D1**2*bdd2*f*r**2 + 528*D1**2*bdd2*f*r*s - 528*D1**2*bdd2*f*r + 264*D1**2*bdd2*f*s**2 - 528*D1**2*bdd2*f*s + 264*D1**2*bdd2*f + 2556*D1**2*f**2*fd*r**2 + 2880*D1**2*f**2*fd*r*s - 2156*D1**2*f**2*fd*r + 324*D1**2*f**2*fd*s**2 - 668*D1**2*f**2*fd*s + 262*D1**2*f**2*fd - 2334*D1**2*f**2*fdd*r**2 - 2100*D1**2*f**2*fdd*r*s + 1628*D1**2*f**2*fdd*r + 234*D1**2*f**2*fdd*s**2 - 84*D1**2*f**2*fdd*s + 78*D1**2*f**2*fdd - 4668*D1**2*f*fd**2*r**2 - 4200*D1**2*f*fd**2*r*s + 3256*D1**2*f*fd**2*r + 468*D1**2*f*fd**2*s**2 - 168*D1**2*f*fd**2*s - 372*D1**2*f*fd**2 + 506*D1**2*f*fd*r**2 + 1540*D1**2*f*fd*r*s - 1122*D1**2*f*fd*r + 1034*D1**2*f*fd*s**2 - 1386*D1**2*f*fd*s + 803*D1**2*f*fd - 1034*D1**2*f*fdd*r**2 - 1804*D1**2*f*fdd*r*s + 1034*D1**2*f*fdd*r - 770*D1**2*f*fdd*s**2 + 902*D1**2*f*fdd*s - 517*D1**2*f*fdd + 4444*D1**2*f*gd2*r**2 + 7304*D1**2*f*gd2*r*s - 7304*D1**2*f*gd2*r + 2860*D1**2*f*gd2*s**2 - 5720*D1**2*f*gd2*s + 2860*D1**2*f*gd2 - 220*D1**2*f*gdd2*r**2 + 352*D1**2*f*gdd2*r*s - 352*D1**2*f*gdd2*r + 572*D1**2*f*gdd2*s**2 - 1144*D1**2*f*gdd2*s + 572*D1**2*f*gdd2 - 1034*D1**2*fd**2*r**2 - 1804*D1**2*fd**2*r*s + 1034*D1**2*fd**2*r - 770*D1**2*fd**2*s**2 + 902*D1**2*fd**2*s + 4444*D1**2*fd*g2*r**2 + 7304*D1**2*fd*g2*r*s + 352*D1**2*fd*g2*r + 2860*D1**2*fd*g2*s**2 + 352*D1**2*fd*g2*s - 176*D1**2*fd*g2 - 440*D1**2*fd*gd2*r**2 + 704*D1**2*fd*gd2*r*s - 528*D1**2*fd*gd2*r + 1144*D1**2*fd*gd2*s**2 - 1320*D1**2*fd*gd2*s + 176*D1**2*fd*gd2 - 220*D1**2*fdd*g2*r**2 + 352*D1**2*fdd*g2*r*s - 176*D1**2*fdd*g2*r + 572*D1**2*fdd*g2*s**2 - 176*D1**2*fdd*g2*s + 88*D1**2*fdd*g2 - 6072*D1*Dd*K*f**2*r**2 - 10032*D1*Dd*K*f**2*r*s + 8052*D1*Dd*K*f**2*r - 3960*D1*Dd*K*f**2*s**2 + 6468*D1*Dd*K*f**2*s - 3498*D1*Dd*K*f**2 + 16544*D1*Dd*K*f*fd*r**2 + 26752*D1*Dd*K*f*fd*r*s - 19096*D1*Dd*K*f*fd*r + 10208*D1*Dd*K*f*fd*s**2 - 15136*D1*Dd*K*f*fd*s + 5412*D1*Dd*K*f*fd - 3344*D1*Dd*b2*f*r**2 - 6688*D1*Dd*b2*f*r*s + 5016*D1*Dd*b2*f*r - 3344*D1*Dd*b2*f*s**2 + 5016*D1*Dd*b2*f*s - 2508*D1*Dd*b2*f + 2112*D1*Dd*b2*fd*r**2 + 4224*D1*Dd*b2*fd*r*s - 1584*D1*Dd*b2*fd*r + 2112*D1*Dd*b2*fd*s**2 - 1584*D1*Dd*b2*fd*s + 3408*D1*Dd*f**3*r**2 + 3840*D1*Dd*f**3*r*s - 3624*D1*Dd*f**3*r + 432*D1*Dd*f**3*s**2 - 1392*D1*Dd*f**3*s + 1068*D1*Dd*f**3 - 18672*D1*Dd*f**2*fd*r**2 - 16800*D1*Dd*f**2*fd*r*s + 15380*D1*Dd*f**2*fd*r + 1872*D1*Dd*f**2*fd*s**2 + 828*D1*Dd*f**2*fd*s - 1460*D1*Dd*f**2*fd + 1012*D1*Dd*f**2*r**2 + 3080*D1*Dd*f**2*r*s - 2046*D1*Dd*f**2*r + 2068*D1*Dd*f**2*s**2 - 2838*D1*Dd*f**2*s + 1287*D1*Dd*f**2 - 8272*D1*Dd*f*fd*r**2 - 14432*D1*Dd*f*fd*r*s + 9812*D1*Dd*f*fd*r - 6160*D1*Dd*f*fd*s**2 + 8492*D1*Dd*f*fd*s - 2838*D1*Dd*f*fd + 17776*D1*Dd*f*g2*r**2 + 29216*D1*Dd*f*g2*r*s - 23496*D1*Dd*f*g2*r + 11440*D1*Dd*f*g2*s**2 - 18744*D1*Dd*f*g2*s + 10164*D1*Dd*f*g2 - 1760*D1*Dd*f*gd2*r**2 + 2816*D1*Dd*f*gd2*r*s - 1672*D1*Dd*f*gd2*r + 4576*D1*Dd*f*gd2*s**2 - 7216*D1*Dd*f*gd2*s + 2640*D1*Dd*f*gd2 - 1760*D1*Dd*fd*g2*r**2 + 2816*D1*Dd*fd*g2*r*s - 968*D1*Dd*fd*g2*r + 4576*D1*Dd*fd*g2*s**2 - 3344*D1*Dd*fd*g2*s + 528*D1*Dd*fd*g2 + 4136*D1*Ddd*K*f**2*r**2 + 6688*D1*Ddd*K*f**2*r*s - 5412*D1*Ddd*K*f**2*r + 2552*D1*Ddd*K*f**2*s**2 - 4224*D1*Ddd*K*f**2*s + 2310*D1*Ddd*K*f**2 + 1056*D1*Ddd*b2*f*r**2 + 2112*D1*Ddd*b2*f*r*s - 1584*D1*Ddd*b2*f*r + 1056*D1*Ddd*b2*f*s**2 - 1584*D1*Ddd*b2*f*s + 792*D1*Ddd*b2*f - 3112*D1*Ddd*f**3*r**2 - 2800*D1*Ddd*f**3*r*s + 2956*D1*Ddd*f**3*r + 312*D1*Ddd*f**3*s**2 + 388*D1*Ddd*f**3*s - 622*D1*Ddd*f**3 - 2068*D1*Ddd*f**2*r**2 - 3608*D1*Ddd*f**2*r*s + 2838*D1*Ddd*f**2*r - 1540*D1*Ddd*f**2*s**2 + 2442*D1*Ddd*f**2*s - 1287*D1*Ddd*f**2 - 880*D1*Ddd*f*g2*r**2 + 1408*D1*Ddd*f*g2*r*s - 264*D1*Ddd*f*g2*r + 2288*D1*Ddd*f*g2*s**2 - 2640*D1*Ddd*f*g2*s + 924*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(f**2*(97*r**2 + r*(218*s - 212) + 121*s**2 - 236*s + 112) + f*(28*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 202*K*r**2 - 332*K*r*s + 376*K*r - 130*K*s**2 + 304*K*s - 170*K - 6*fd*(66*r**2 + 148*r*s - 107*r + 82*s**2 - 119*s + 39) + 45*r**2 + 94*r*s - 138*r + 49*s**2 - 142*s + 70) + 2*fd*(K*(10*r**2 - 16*r*s + r - 26*s**2 + 19*s - 2) - 5*r**2 + 2*r*s + r + 7*s**2 - 5*s + 1) + 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f**2*(396*r**2 + r*(888*s - 741) + 492*s**2 - 825*s + 339) + f*(K*(-40*r**2 + 64*r*s + 6*r + 104*s**2 - 120*s + 27) + 20*r**2 - 8*r*s - 15*r - 28*s**2 + 27*s - 3) + 28*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 44*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 12408*Dd**2*K*f**2*r**2 + 20064*Dd**2*K*f**2*r*s - 16236*Dd**2*K*f**2*r + 7656*Dd**2*K*f**2*s**2 - 12672*Dd**2*K*f**2*s + 4620*Dd**2*K*f**2 + 3168*Dd**2*b2*f*r**2 + 6336*Dd**2*b2*f*r*s - 4752*Dd**2*b2*f*r + 3168*Dd**2*b2*f*s**2 - 4752*Dd**2*b2*f*s + 1584*Dd**2*b2*f - 9336*Dd**2*f**3*r**2 - 8400*Dd**2*f**3*r*s + 8868*Dd**2*f**3*r + 936*Dd**2*f**3*s**2 + 1164*Dd**2*f**3*s - 1244*Dd**2*f**3 - 6204*Dd**2*f**2*r**2 - 10824*Dd**2*f**2*r*s + 8514*Dd**2*f**2*r - 4620*Dd**2*f**2*s**2 + 7326*Dd**2*f**2*s - 2574*Dd**2*f**2 - 2640*Dd**2*f*g2*r**2 + 4224*Dd**2*f*g2*r*s - 792*Dd**2*f*g2*r + 6864*Dd**2*f*g2*s**2 - 7920*Dd**2*f*g2*s + 1848*Dd**2*f*g2) + 1716*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 12*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 12*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 120*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 36*Dd**2*f**2))/(9009*d**2*k3**6) + D1**2*Pk1*Pk3*ct*k1*k2*st**6*(80*C - 60)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k3**4) + 2*D1**2*Pk1*Pk3*ct*k1*k2*st**4*(132*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 33*b1*(D1**2*(f*(fd*(-28*C*(2*s**2 - 2*s + 1) + 8*r*s - 4*r + 46*s**2 - 46*s + 23) + (4*C - 3)*(-4*bdd1*s*(2*r + 2*s - 1) + fdd*(8*r*s - 4*r + 18*s**2 - 18*s + 9))) + fd**2*(8*C - 6)*(r*(4*s - 2) + s*(9*s - 9))) - 4*D1*bd1*(4*C - 3)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(28*C*(2*s**2 - 2*s + 1) - 8*r*s + 4*r - 46*s**2 + 48*s - 23) + fd*(12 - 16*C)*(2*s - 1)*(4*r + 9*s - 5)) - Ddd*f*(4*C - 3)*(r*(8*s - 4) + 18*s**2 - 20*s + 9)) + Dd**2*f**2*(8*C - 6)*(12*r*(2*s - 1) + 54*s**2 - 60*s + 13)) + f*(-132*D1**2*bd1**2*s*(4*C - 3)*(2*r + 2*s - 1) + D1**2*(f*(33*bdd1*s*(4*C - 3)*(4*r + 9*s - 4) + 4*fd*(88*C*(3*r*s - r + 3*s**2 - 3*s + 1) - 174*r*s + 58*r - 177*s**2 + 176*s - 59) - 2*fdd*(88*C*(3*r*s - r + 3*s**2 - 3*s + 1) - 174*r*s + 58*r - 177*s**2 + 176*s - 59)) - 4*fd**2*(44*C*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 58*r*(3*s - 1) - 177*s**2 + 176*s - 29)) - 33*D1*bd1*(D1*(f*s*(28*C*s - 4*r - 23*s + 4) - fd*(8*C - 6)*(r*(8*s - 2) + 18*s**2 - 13*s + 2)) + Dd*f*(24 - 32*C)*(r*(4*s - 1) + 9*s**2 - 7*s + 1)) + 4*D1*f*(Dd*(2*f*(44*C*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 58*r*(2*s - 1) - 118*s**2 + 147*s - 59) + fd*(-44*C*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7) + 58*r*(12*s - 5) + 708*s**2 - 793*s + 205)) + Ddd*f*(-44*C*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + 58*r*(2*s - 1) + 118*s**2 - 147*s + 59)) - 4*Dd**2*f**2*(44*C*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4) - 174*r*(2*s - 1) - 354*s**2 + 441*s - 117)))/(231*d**2*k3**4) + D1**2*Pk1*Pk3*ct*k1*k2*st**2*(33*b1**2*(D1**2*(fd*(4*C*(59*r - 5*s + 5) - 151*r - 3*s + 3) + fdd*(-4*C*(5*r - 27*s + 27) + 9*r - 79*s + 79))*(r + s - 1) + D1*(Dd*(f*(4*C*(236*r**2 + 216*r*s - 226*r - 20*s**2 - 34*s + 49) - 604*r**2 - 616*r*s + 610*r - 12*s**2 + 166*s - 157) + 2*fd*(-4*C*(20*r**2 - 88*r*s + 61*r - 108*s**2 + 173*s - 65) + 36*r**2 - 280*r*s + 201*r - 316*s**2 + 509*s - 193)) + Ddd*f*(-4*C*(20*r**2 - 88*r*s + 34*r - 108*s**2 + 130*s - 49) + 36*r**2 - 280*r*s + 122*r - 316*s**2 + 386*s - 149)) - 2*Dd**2*f*(4*C*(30*r**2 - 132*r*s + 51*r - 162*s**2 + 195*s - 49) - 54*r**2 + 420*r*s - 183*r + 474*s**2 - 579*s + 149)) + 33*b1*(32*C*D1**2*f*fd*r**2 - 176*C*D1**2*f*fd*r*s - 32*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 144*C*D1**2*f*fd*s + 64*C*D1**2*f*fd + 80*C*D1**2*f*fdd*r**2 + 224*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r - 8*C*D1**2*f*fdd*s**2 + 112*C*D1**2*f*fdd*s - 56*C*D1**2*f*fdd + 80*C*D1**2*fd**2*r**2 + 224*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r - 8*C*D1**2*fd**2*s**2 + 112*C*D1**2*fd**2*s - 104*C*D1**2*fd**2 + 64*C*D1*Dd*f**2*r**2 - 352*C*D1*Dd*f**2*r*s + 144*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 + 72*C*D1*Dd*f**2*s + 24*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*r**2 + 1792*C*D1*Dd*f*fd*r*s - 640*C*D1*Dd*f*fd*r - 64*C*D1*Dd*f*fd*s**2 + 256*C*D1*Dd*f*fd*s - 216*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r**2 + 448*C*D1*Ddd*f**2*r*s - 304*C*D1*Ddd*f**2*r - 16*C*D1*Ddd*f**2*s**2 - 96*C*D1*Ddd*f**2*s + 32*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r**2 + 1344*C*Dd**2*f**2*r*s - 912*C*Dd**2*f**2*r - 48*C*Dd**2*f**2*s**2 - 288*C*Dd**2*f**2*s + 216*C*Dd**2*f**2 + D1**2*bdd1*f*(-4*C*(10*r**2 - 2*r*(22*s + 5) - 54*s**2 + 22*s + 5) + 18*r**2 - 2*r*(70*s + 9) - 158*s**2 + 70*s + 9) - 18*D1**2*f*fd*r**2 + 136*D1**2*f*fd*r*s + 10*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 + 86*D1**2*f*fd*s - 33*D1**2*f*fd - 38*D1**2*f*fdd*r**2 - 152*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 - 62*D1**2*f*fdd*s + 27*D1**2*f*fdd - 38*D1**2*fd**2*r**2 - 152*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 - 62*D1**2*fd**2*s + 74*D1**2*fd**2 - 36*D1*Dd*f**2*r**2 + 272*D1*Dd*f**2*r*s - 118*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 92*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 304*D1*Dd*f*fd*r**2 - 1216*D1*Dd*f*fd*r*s + 420*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 - 48*D1*Dd*f*fd*s + 114*D1*Dd*f*fd - 76*D1*Ddd*f**2*r**2 - 304*D1*Ddd*f**2*r*s + 190*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 100*D1*Ddd*f**2*s - 31*D1*Ddd*f**2 + D1*bd1*(D1*(f*(4*C*(118*r**2 + 2*r*(54*s - 59) - 10*s**2 - 54*s + 59) - 302*r**2 - 308*r*s + 302*r - 6*s**2 + 154*s - 151) + 2*fd*(-4*C*(10*r**2 - 44*r*s + 17*r - 54*s**2 + 65*s - 11) + 18*r**2 - 140*r*s + 61*r - 158*s**2 + 193*s - 35)) - 2*Dd*f*(4*C*(40*r**2 - 176*r*s + 14*r - 216*s**2 + 174*s - 17) - 72*r**2 + 560*r*s - 86*r + 632*s**2 - 526*s + 61)) - 228*Dd**2*f**2*r**2 - 912*Dd**2*f**2*r*s + 570*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 300*Dd**2*f**2*s - 164*Dd**2*f**2) - f*(11364*C*D1**2*f*fd*r**2 + 45552*C*D1**2*f*fd*r*s - 22760*C*D1**2*f*fd*r + 25560*C*D1**2*f*fd*s**2 - 32224*C*D1**2*f*fd*s + 12308*C*D1**2*f*fd - 14196*C*D1**2*f*fdd*r**2 - 43368*C*D1**2*f*fdd*r*s + 23920*C*D1**2*f*fdd*r - 23472*C*D1**2*f*fdd*s**2 + 30104*C*D1**2*f*fdd*s - 12556*C*D1**2*f*fdd - 28392*C*D1**2*fd**2*r**2 - 86736*C*D1**2*fd**2*r*s + 47840*C*D1**2*fd**2*r - 46944*C*D1**2*fd**2*s**2 + 60208*C*D1**2*fd**2*s - 14456*C*D1**2*fd**2 + 15152*C*D1*Dd*f**2*r**2 + 60736*C*D1*Dd*f**2*r*s - 37944*C*D1*Dd*f**2*r + 34080*C*D1*Dd*f**2*s**2 - 49264*C*D1*Dd*f**2*s + 20828*C*D1*Dd*f**2 - 113568*C*D1*Dd*f*fd*r**2 - 346944*C*D1*Dd*f*fd*r*s + 210808*C*D1*Dd*f*fd*r - 187776*C*D1*Dd*f*fd*s**2 + 257672*C*D1*Dd*f*fd*s - 84128*C*D1*Dd*f*fd - 18928*C*D1*Ddd*f**2*r**2 - 57824*C*D1*Ddd*f**2*r*s + 38376*C*D1*Ddd*f**2*r - 31296*C*D1*Ddd*f**2*s**2 + 45752*C*D1*Ddd*f**2*s - 20380*C*D1*Ddd*f**2 - 56784*C*Dd**2*f**2*r**2 - 173472*C*Dd**2*f**2*r*s + 115128*C*Dd**2*f**2*r - 93888*C*Dd**2*f**2*s**2 + 137256*C*Dd**2*f**2*s - 44560*C*Dd**2*f**2 + 66*D1**2*bd1**2*(r**2*(20*C - 9) + r*(-4*C*(22*s + 5) + 70*s + 9) + s*(C*(44 - 108*s) + 79*s - 35)) - 33*D1**2*bdd1*f*(4*C*(10*r**2 + 28*r*s - 46*r - s**2 - 54*s + 23) - 19*r**2 - 76*r*s + 104*r - 6*s**2 + 150*s - 52) - 7260*D1**2*f*fd*r**2 - 32778*D1**2*f*fd*r*s + 15766*D1**2*f*fd*r - 19251*D1**2*f*fd*s**2 + 23760*D1**2*f*fd*s - 8837*D1**2*f*fd + 8580*D1**2*f*fdd*r**2 + 30546*D1**2*f*fdd*r*s - 15902*D1**2*f*fdd*r + 18189*D1**2*f*fdd*s**2 - 22308*D1**2*f*fdd*s + 8923*D1**2*f*fdd + 17160*D1**2*fd**2*r**2 + 61092*D1**2*fd**2*r*s - 31804*D1**2*fd**2*r + 36378*D1**2*fd**2*s**2 - 44616*D1**2*fd**2*s + 10182*D1**2*fd**2 - 9680*D1*Dd*f**2*r**2 - 43704*D1*Dd*f**2*r*s + 26692*D1*Dd*f**2*r - 25668*D1*Dd*f**2*s**2 + 36594*D1*Dd*f**2*s - 15254*D1*Dd*f**2 + 68640*D1*Dd*f*fd*r**2 + 244368*D1*Dd*f*fd*r*s - 141860*D1*Dd*f*fd*r + 145512*D1*Dd*f*fd*s**2 - 192534*D1*Dd*f*fd*s + 60518*D1*Dd*f*fd + 11440*D1*Ddd*f**2*r**2 + 40728*D1*Ddd*f**2*r*s - 26084*D1*Ddd*f**2*r + 24252*D1*Ddd*f**2*s**2 - 34434*D1*Ddd*f**2*s + 14986*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(4*C*(4*r**2 - 22*r*(s - 1) + s**2 + 56*s - 11) - 9*r**2 + 68*r*s - 60*r + 6*s**2 - 166*s + 30) + 2*fd*(4*C*(20*r**2 + 56*r*s - 47*r - 2*s**2 - 40*s + 27) - 38*r**2 - 152*r*s + 109*r - 12*s**2 + 119*s - 75)) + 2*Dd*f*(4*C*(40*r**2 + 2*r*(56*s - 65) - 4*s**2 - 120*s + 77) - 76*r**2 - 304*r*s + 303*r - 24*s**2 + 350*s - 202)) + 34320*Dd**2*f**2*r**2 + 122184*Dd**2*f**2*r*s - 78252*Dd**2*f**2*r + 72756*Dd**2*f**2*s**2 - 103302*Dd**2*f**2*s + 32490*Dd**2*f**2))/(693*d**2*k3**4) - 2*D1**2*Pk1*Pk3*ct*k1*k2*(-4356*D1**2*K*bd1**2*f*r**2 - 9636*D1**2*K*bd1**2*f*r*s + 14058*D1**2*K*bd1**2*f*r - 5016*D1**2*K*bd1**2*f*s**2 + 14322*D1**2*K*bd1**2*f*s - 9306*D1**2*K*bd1**2*f + 5478*D1**2*K*bd1*f**2*r**2 + 6996*D1**2*K*bd1*f**2*r*s - 6996*D1**2*K*bd1*f**2*r + 3498*D1**2*K*bd1*f**2*s**2 - 6996*D1**2*K*bd1*f**2*s + 3498*D1**2*K*bd1*f**2 - 20856*D1**2*K*bd1*f*fd*r**2 - 40392*D1**2*K*bd1*f*fd*r*s + 30624*D1**2*K*bd1*f*fd*r - 17424*D1**2*K*bd1*f*fd*s**2 + 27522*D1**2*K*bd1*f*fd*s - 10098*D1**2*K*bd1*f*fd - 5214*D1**2*K*bdd1*f**2*r**2 - 10098*D1**2*K*bdd1*f**2*r*s + 10098*D1**2*K*bdd1*f**2*r - 4356*D1**2*K*bdd1*f**2*s**2 + 8712*D1**2*K*bdd1*f**2*s - 4356*D1**2*K*bdd1*f**2 + 1386*D1**2*bd1**2*f**2*r**2 + 8712*D1**2*bd1**2*f**2*r*s - 6402*D1**2*bd1**2*f**2*r + 7326*D1**2*bd1**2*f**2*s**2 - 12210*D1**2*bd1**2*f**2*s + 5676*D1**2*bd1**2*f**2 + 924*D1**2*bd1**2*f*r**2 + 6600*D1**2*bd1**2*f*r*s - 5742*D1**2*bd1**2*f*r + 5412*D1**2*bd1**2*f*s**2 - 10890*D1**2*bd1**2*f*s + 5478*D1**2*bd1**2*f - 7392*D1**2*bd1**2*g2*r**2 - 14784*D1**2*bd1**2*g2*r*s + 7392*D1**2*bd1**2*g2*r - 7392*D1**2*bd1**2*g2*s**2 + 7392*D1**2*bd1**2*g2*s - 4620*D1**2*bd1*bd2*f*r**2 - 9240*D1**2*bd1*bd2*f*r*s + 9240*D1**2*bd1*bd2*f*r - 4620*D1**2*bd1*bd2*f*s**2 + 9240*D1**2*bd1*bd2*f*s - 4620*D1**2*bd1*bd2*f - 1520*D1**2*bd1*f**3*r**2 - 4558*D1**2*bd1*f**3*r*s + 4822*D1**2*bd1*f**3*r - 2145*D1**2*bd1*f**3*s**2 + 5610*D1**2*bd1*f**3*s - 3267*D1**2*bd1*f**3 + 8520*D1**2*bd1*f**2*fd*r**2 + 30108*D1**2*bd1*f**2*fd*r*s - 23440*D1**2*bd1*f**2*fd*r + 14850*D1**2*bd1*f**2*fd*s**2 - 27458*D1**2*bd1*f**2*fd*s + 10628*D1**2*bd1*f**2*fd - 1650*D1**2*bd1*f**2*r**2 - 3630*D1**2*bd1*f**2*r*s + 3630*D1**2*bd1*f**2*r - 3069*D1**2*bd1*f**2*s**2 + 6138*D1**2*bd1*f**2*s - 3069*D1**2*bd1*f**2 + 6072*D1**2*bd1*f*fd*r**2 + 22704*D1**2*bd1*f*fd*r*s - 14388*D1**2*bd1*f*fd*r + 14916*D1**2*bd1*f*fd*s**2 - 20592*D1**2*bd1*f*fd*s + 5676*D1**2*bd1*f*fd - 2244*D1**2*bd1*f*g2*r**2 - 4488*D1**2*bd1*f*g2*r*s + 11088*D1**2*bd1*f*g2*r - 5412*D1**2*bd1*f*g2*s**2 + 9504*D1**2*bd1*f*g2*s - 5544*D1**2*bd1*f*g2 + 8712*D1**2*bd1*f*gd2*r**2 + 19272*D1**2*bd1*f*gd2*r*s - 28116*D1**2*bd1*f*gd2*r + 10032*D1**2*bd1*f*gd2*s**2 - 28644*D1**2*bd1*f*gd2*s + 18612*D1**2*bd1*f*gd2 + 8712*D1**2*bd1*fd*g2*r**2 + 19272*D1**2*bd1*fd*g2*r*s - 8712*D1**2*bd1*fd*g2*r + 10032*D1**2*bd1*fd*g2*s**2 - 9636*D1**2*bd1*fd*g2*s + 1980*D1**2*bd2*f**2*r**2 + 3168*D1**2*bd2*f**2*r*s - 3168*D1**2*bd2*f**2*r + 1188*D1**2*bd2*f**2*s**2 - 2376*D1**2*bd2*f**2*s + 1188*D1**2*bd2*f**2 - 9504*D1**2*bd2*f*fd*r**2 - 17424*D1**2*bd2*f*fd*r*s + 13464*D1**2*bd2*f*fd*r - 7920*D1**2*bd2*f*fd*s**2 + 12276*D1**2*bd2*f*fd*s - 4356*D1**2*bd2*f*fd + 1420*D1**2*bdd1*f**3*r**2 + 5018*D1**2*bdd1*f**3*r*s - 5282*D1**2*bdd1*f**3*r + 2475*D1**2*bdd1*f**3*s**2 - 6270*D1**2*bdd1*f**3*s + 3597*D1**2*bdd1*f**3 + 1518*D1**2*bdd1*f**2*r**2 + 5676*D1**2*bdd1*f**2*r*s - 5676*D1**2*bdd1*f**2*r + 3729*D1**2*bdd1*f**2*s**2 - 7458*D1**2*bdd1*f**2*s + 3729*D1**2*bdd1*f**2 + 4356*D1**2*bdd1*f*g2*r**2 + 9636*D1**2*bdd1*f*g2*r*s - 18480*D1**2*bdd1*f*g2*r + 5016*D1**2*bdd1*f*g2*s**2 - 18612*D1**2*bdd1*f*g2*s + 9240*D1**2*bdd1*f*g2 - 2376*D1**2*bdd2*f**2*r**2 - 4356*D1**2*bdd2*f**2*r*s + 4356*D1**2*bdd2*f**2*r - 1980*D1**2*bdd2*f**2*s**2 + 3960*D1**2*bdd2*f**2*s - 1980*D1**2*bdd2*f**2 + 3440*D1**2*f**3*fd*r*s - 1720*D1**2*f**3*fd*r + 5940*D1**2*f**3*fd*s**2 - 6800*D1**2*f**3*fd*s + 2970*D1**2*f**3*fd - 3440*D1**2*f**3*fdd*r*s + 1720*D1**2*f**3*fdd*r - 5940*D1**2*f**3*fdd*s**2 + 6800*D1**2*f**3*fdd*s - 2970*D1**2*f**3*fdd - 10320*D1**2*f**2*fd**2*r*s + 5160*D1**2*f**2*fd**2*r - 17820*D1**2*f**2*fd**2*s**2 + 20400*D1**2*f**2*fd**2*s - 4690*D1**2*f**2*fd**2 - 10956*D1**2*f**2*gd2*r**2 - 13992*D1**2*f**2*gd2*r*s + 13992*D1**2*f**2*gd2*r - 6996*D1**2*f**2*gd2*s**2 + 13992*D1**2*f**2*gd2*s - 6996*D1**2*f**2*gd2 + 10428*D1**2*f**2*gdd2*r**2 + 20196*D1**2*f**2*gdd2*r*s - 20196*D1**2*f**2*gdd2*r + 8712*D1**2*f**2*gdd2*s**2 - 17424*D1**2*f**2*gdd2*s + 8712*D1**2*f**2*gdd2 - 21912*D1**2*f*fd*g2*r**2 - 27984*D1**2*f*fd*g2*r*s + 21912*D1**2*f*fd*g2*r - 13992*D1**2*f*fd*g2*s**2 + 13992*D1**2*f*fd*g2*s - 10956*D1**2*f*fd*g2 + 41712*D1**2*f*fd*gd2*r**2 + 80784*D1**2*f*fd*gd2*r*s - 61248*D1**2*f*fd*gd2*r + 34848*D1**2*f*fd*gd2*s**2 - 55044*D1**2*f*fd*gd2*s + 20196*D1**2*f*fd*gd2 + 20856*D1**2*f*fdd*g2*r**2 + 40392*D1**2*f*fdd*g2*r*s - 20856*D1**2*f*fdd*g2*r + 17424*D1**2*f*fdd*g2*s**2 - 20196*D1**2*f*fdd*g2*s + 10428*D1**2*f*fdd*g2 + 20856*D1**2*fd**2*g2*r**2 + 40392*D1**2*fd**2*g2*r*s - 20856*D1**2*fd**2*g2*r + 17424*D1**2*fd**2*g2*s**2 - 20196*D1**2*fd**2*g2*s - 41712*D1*Dd*K*bd1*f**2*r**2 - 80784*D1*Dd*K*bd1*f**2*r*s + 71016*D1*Dd*K*bd1*f**2*r - 34848*D1*Dd*K*bd1*f**2*s**2 + 62370*D1*Dd*K*bd1*f**2*s - 27522*D1*Dd*K*bd1*f**2 + 11360*D1*Dd*bd1*f**3*r**2 + 40144*D1*Dd*bd1*f**3*r*s - 34004*D1*Dd*bd1*f**3*r + 19800*D1*Dd*bd1*f**3*s**2 - 39998*D1*Dd*bd1*f**3*s + 17822*D1*Dd*bd1*f**3 + 12144*D1*Dd*bd1*f**2*r**2 + 45408*D1*Dd*bd1*f**2*r*s - 37092*D1*Dd*bd1*f**2*r + 29832*D1*Dd*bd1*f**2*s**2 - 50424*D1*Dd*bd1*f**2*s + 20592*D1*Dd*bd1*f**2 + 34848*D1*Dd*bd1*f*g2*r**2 + 77088*D1*Dd*bd1*f*g2*r*s - 101904*D1*Dd*bd1*f*g2*r + 40128*D1*Dd*bd1*f*g2*s**2 - 104148*D1*Dd*bd1*f*g2*s + 55704*D1*Dd*bd1*f*g2 - 19008*D1*Dd*bd2*f**2*r**2 - 34848*D1*Dd*bd2*f**2*r*s + 30888*D1*Dd*bd2*f**2*r - 15840*D1*Dd*bd2*f**2*s**2 + 28116*D1*Dd*bd2*f**2*s - 12276*D1*Dd*bd2*f**2 + 3440*D1*Dd*f**4*r*s - 1720*D1*Dd*f**4*r + 5940*D1*Dd*f**4*s**2 - 6800*D1*Dd*f**4*s + 2970*D1*Dd*f**4 - 27520*D1*Dd*f**3*fd*r*s + 13760*D1*Dd*f**3*fd*r - 47520*D1*Dd*f**3*fd*s**2 + 54400*D1*Dd*f**3*fd*s - 15320*D1*Dd*f**3*fd - 43824*D1*Dd*f**2*g2*r**2 - 55968*D1*Dd*f**2*g2*r*s + 49896*D1*Dd*f**2*g2*r - 27984*D1*Dd*f**2*g2*s**2 + 41976*D1*Dd*f**2*g2*s - 24948*D1*Dd*f**2*g2 + 83424*D1*Dd*f**2*gd2*r**2 + 161568*D1*Dd*f**2*gd2*r*s - 142032*D1*Dd*f**2*gd2*r + 69696*D1*Dd*f**2*gd2*s**2 - 124740*D1*Dd*f**2*gd2*s + 55044*D1*Dd*f**2*gd2 + 166848*D1*Dd*f*fd*g2*r**2 + 323136*D1*Dd*f*fd*g2*r*s - 205920*D1*Dd*f*fd*g2*r + 139392*D1*Dd*f*fd*g2*s**2 - 190872*D1*Dd*f*fd*g2*s + 61248*D1*Dd*f*fd*g2 - 3440*D1*Ddd*f**4*r*s + 1720*D1*Ddd*f**4*r - 5940*D1*Ddd*f**4*s**2 + 6800*D1*Ddd*f**4*s - 2970*D1*Ddd*f**4 + 41712*D1*Ddd*f**2*g2*r**2 + 80784*D1*Ddd*f**2*g2*r*s - 61248*D1*Ddd*f**2*g2*r + 34848*D1*Ddd*f**2*g2*s**2 - 55044*D1*Ddd*f**2*g2*s + 27852*D1*Ddd*f**2*g2 - 10320*Dd**2*f**4*r*s + 5160*Dd**2*f**4*r - 17820*Dd**2*f**4*s**2 + 20400*Dd**2*f**4*s - 4690*Dd**2*f**4 + 125136*Dd**2*f**2*g2*r**2 + 242352*Dd**2*f**2*g2*r*s - 183744*Dd**2*f**2*g2*r + 104544*Dd**2*f**2*g2*s**2 - 165132*Dd**2*f**2*g2*s + 57816*Dd**2*f**2*g2 + 231*b1**3*(D1**2*(fd*(r + 5*s - 5) + fdd*(-3*r - 7*s + 7))*(r + s - 1) + D1*(Dd*(-16*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*r**2 + 2*r*(12*s - 7) + 20*s**2 - 26*s + 11) - 2*fd*(12*r**2 + r*(40*s - 33) + 28*s**2 - 47*s + 19) + 16*r**2 + 8*r*(8*s - 5) + 48*s**2 - 64*s + 28) - Ddd*(-8*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(12*r**2 + r*(40*s - 26) + 28*s**2 - 38*s + 17) + 8*r**2 + 32*r*s - 20*r + 24*s**2 - 32*s + 14)) - 2*Dd**2*(-24*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + f*(18*r**2 + r*(60*s - 39) + 42*s**2 - 57*s + 17) + 12*r**2 + 6*r*(8*s - 5) + 36*s**2 - 48*s + 14)) + 33*b1**2*(34*D1**2*K*fd*r**2 + 68*D1**2*K*fd*r*s + 100*D1**2*K*fd*r + 82*D1**2*K*fd*s**2 + 76*D1**2*K*fd*s - 50*D1**2*K*fd - 66*D1**2*K*fdd*r**2 - 146*D1**2*K*fdd*r*s - 148*D1**2*K*fdd*r - 76*D1**2*K*fdd*s**2 - 136*D1**2*K*fdd*s + 74*D1**2*K*fdd - 7*D1**2*bdd1*(-8*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(9*r**2 + 2*r*(15*s - 8) + 21*s**2 - 24*s + 10) + 6*r**2 + 24*r*s - 12*r + 18*s**2 - 20*s + 8) - 42*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r*s + 128*D1**2*f*fd*r - 222*D1**2*f*fd*s**2 + 226*D1**2*f*fd*s - 121*D1**2*f*fd + 42*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 112*D1**2*f*fdd*r + 222*D1**2*f*fdd*s**2 - 206*D1**2*f*fdd*s + 113*D1**2*f*fdd + 42*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 112*D1**2*fd**2*r + 222*D1**2*fd**2*s**2 - 206*D1**2*fd**2*s - 16*D1**2*fd**2 - 14*D1**2*fd*r**2 - 46*D1**2*fd*r*s - 22*D1**2*fd*r - 80*D1**2*fd*s**2 - 34*D1**2*fd*s + 11*D1**2*fd + 14*D1**2*fdd*r**2 + 100*D1**2*fdd*r*s + 46*D1**2*fdd*r + 82*D1**2*fdd*s**2 + 66*D1**2*fdd*s - 23*D1**2*fdd + 224*D1**2*gd2*r**2 + 448*D1**2*gd2*r*s - 448*D1**2*gd2*r + 224*D1**2*gd2*s**2 - 448*D1**2*gd2*s + 224*D1**2*gd2 - 112*D1**2*gdd2*r**2 - 224*D1**2*gdd2*r*s + 224*D1**2*gdd2*r - 112*D1**2*gdd2*s**2 + 224*D1**2*gdd2*s - 112*D1**2*gdd2 + 136*D1*Dd*K*f*r**2 + 272*D1*Dd*K*f*r*s - 204*D1*Dd*K*f*r + 328*D1*Dd*K*f*s**2 - 396*D1*Dd*K*f*s + 198*D1*Dd*K*f - 528*D1*Dd*K*fd*r**2 - 1168*D1*Dd*K*fd*r*s - 168*D1*Dd*K*fd*r - 608*D1*Dd*K*fd*s**2 - 94*D1*Dd*K*fd*s + 420*D1*Dd*K*fd - 84*D1*Dd*f**2*r**2 - 528*D1*Dd*f**2*r*s + 306*D1*Dd*f**2*r - 444*D1*Dd*f**2*s**2 + 576*D1*Dd*f**2*s - 243*D1*Dd*f**2 + 336*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 1060*D1*Dd*f*fd*r + 1776*D1*Dd*f*fd*s**2 - 1976*D1*Dd*f*fd*s + 524*D1*Dd*f*fd - 56*D1*Dd*f*r**2 - 184*D1*Dd*f*r*s + 120*D1*Dd*f*r - 320*D1*Dd*f*s**2 + 366*D1*Dd*f*s - 174*D1*Dd*f + 112*D1*Dd*fd*r**2 + 800*D1*Dd*fd*r*s - 44*D1*Dd*fd*r + 656*D1*Dd*fd*s**2 - 164*D1*Dd*fd*s - 178*D1*Dd*fd + 896*D1*Dd*g2*r**2 + 1792*D1*Dd*g2*r*s - 1344*D1*Dd*g2*r + 896*D1*Dd*g2*s**2 - 1344*D1*Dd*g2*s + 672*D1*Dd*g2 - 896*D1*Dd*gd2*r**2 - 1792*D1*Dd*gd2*r*s + 1568*D1*Dd*gd2*r - 896*D1*Dd*gd2*s**2 + 1568*D1*Dd*gd2*s - 672*D1*Dd*gd2 - 264*D1*Ddd*K*f*r**2 - 584*D1*Ddd*K*f*r*s + 424*D1*Ddd*K*f*r - 304*D1*Ddd*K*f*s**2 + 450*D1*Ddd*K*f*s - 218*D1*Ddd*K*f + 84*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 306*D1*Ddd*f**2*r + 444*D1*Ddd*f**2*s**2 - 576*D1*Ddd*f**2*s + 243*D1*Ddd*f**2 + 56*D1*Ddd*f*r**2 + 400*D1*Ddd*f*r*s - 228*D1*Ddd*f*r + 328*D1*Ddd*f*s**2 - 428*D1*Ddd*f*s + 178*D1*Ddd*f - 448*D1*Ddd*g2*r**2 - 896*D1*Ddd*g2*r*s + 672*D1*Ddd*g2*r - 448*D1*Ddd*g2*s**2 + 672*D1*Ddd*g2*s - 336*D1*Ddd*g2 + 7*D1*bd1*(D1*(-16*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(3*r**2 + 2*r*(9*s - 4) + 15*s**2 - 16*s + 6) - 2*fd*(9*r**2 + 30*r*s - 23*r + 21*s**2 - 33*s + 12) + 12*r**2 + 48*r*s - 24*r + 36*s**2 - 40*s + 16) - 2*Dd*(-8*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + f*(36*r**2 + r*(120*s - 71) + 84*s**2 - 105*s + 32) + 24*r**2 + 96*r*s - 54*r + 72*s**2 - 88*s + 26)) - 792*Dd**2*K*f*r**2 - 1752*Dd**2*K*f*r*s + 1272*Dd**2*K*f*r - 912*Dd**2*K*f*s**2 + 1350*Dd**2*K*f*s - 444*Dd**2*K*f + 252*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 918*Dd**2*f**2*r + 1332*Dd**2*f**2*s**2 - 1728*Dd**2*f**2*s + 486*Dd**2*f**2 + 168*Dd**2*f*r**2 + 1200*Dd**2*f*r*s - 684*Dd**2*f*r + 984*Dd**2*f*s**2 - 1284*Dd**2*f*s + 364*Dd**2*f - 1344*Dd**2*g2*r**2 - 2688*Dd**2*g2*r*s + 2016*Dd**2*g2*r - 1344*Dd**2*g2*s**2 + 2016*Dd**2*g2*s - 672*Dd**2*g2) + b1*(-4356*D1**2*K*bdd1*f*r**2 - 9636*D1**2*K*bdd1*f*r*s + 14058*D1**2*K*bdd1*f*r - 5016*D1**2*K*bdd1*f*s**2 + 14322*D1**2*K*bdd1*f*s - 7128*D1**2*K*bdd1*f + 10956*D1**2*K*f*fd*r**2 + 13992*D1**2*K*f*fd*r*s - 10956*D1**2*K*f*fd*r + 6996*D1**2*K*f*fd*s**2 - 6996*D1**2*K*f*fd*s + 5478*D1**2*K*f*fd - 10428*D1**2*K*f*fdd*r**2 - 20196*D1**2*K*f*fdd*r*s + 10428*D1**2*K*f*fdd*r - 8712*D1**2*K*f*fdd*s**2 + 10098*D1**2*K*f*fdd*s - 5214*D1**2*K*f*fdd - 10428*D1**2*K*fd**2*r**2 - 20196*D1**2*K*fd**2*r*s + 10428*D1**2*K*fd**2*r - 8712*D1**2*K*fd**2*s**2 + 10098*D1**2*K*fd**2*s + 1386*D1**2*b2*fd*r**2 + 2772*D1**2*b2*fd*r*s + 1386*D1**2*b2*fd*s**2 - 2310*D1**2*b2*fdd*r**2 - 4620*D1**2*b2*fdd*r*s - 2310*D1**2*b2*fdd*s**2 - 462*D1**2*bd1**2*(-8*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(9*r**2 + 2*r*(15*s - 8) + 21*s**2 - 24*s + 5) + 6*r**2 + 24*r*s - 12*r + 18*s**2 - 20*s + 4) + 1386*D1**2*bdd1*f**2*r**2 + 8712*D1**2*bdd1*f**2*r*s - 6402*D1**2*bdd1*f**2*r + 7326*D1**2*bdd1*f**2*s**2 - 12210*D1**2*bdd1*f**2*s + 4290*D1**2*bdd1*f**2 + 924*D1**2*bdd1*f*r**2 + 6600*D1**2*bdd1*f*r*s - 5742*D1**2*bdd1*f*r + 5412*D1**2*bdd1*f*s**2 - 10890*D1**2*bdd1*f*s + 3927*D1**2*bdd1*f - 7392*D1**2*bdd1*g2*r**2 - 14784*D1**2*bdd1*g2*r*s + 7392*D1**2*bdd1*g2*r - 7392*D1**2*bdd1*g2*s**2 + 7392*D1**2*bdd1*g2*s - 3696*D1**2*bdd1*g2 - 2310*D1**2*bdd2*f*r**2 - 4620*D1**2*bdd2*f*r*s + 4620*D1**2*bdd2*f*r - 2310*D1**2*bdd2*f*s**2 + 4620*D1**2*bdd2*f*s - 2310*D1**2*bdd2*f - 4560*D1**2*f**2*fd*r**2 - 13674*D1**2*f**2*fd*r*s + 7334*D1**2*f**2*fd*r - 6435*D1**2*f**2*fd*s**2 + 7528*D1**2*f**2*fd*s - 2543*D1**2*f**2*fd + 4260*D1**2*f**2*fdd*r**2 + 15054*D1**2*f**2*fdd*r*s - 7594*D1**2*f**2*fdd*r + 7425*D1**2*f**2*fdd*s**2 - 8648*D1**2*f**2*fdd*s + 2773*D1**2*f**2*fdd + 8520*D1**2*f*fd**2*r**2 + 30108*D1**2*f*fd**2*r*s - 15188*D1**2*f*fd**2*r + 14850*D1**2*f*fd**2*s**2 - 17296*D1**2*f*fd**2*s + 4358*D1**2*f*fd**2 - 3300*D1**2*f*fd*r**2 - 7260*D1**2*f*fd*r*s + 3300*D1**2*f*fd*r - 6138*D1**2*f*fd*s**2 + 3630*D1**2*f*fd*s - 1650*D1**2*f*fd + 3036*D1**2*f*fdd*r**2 + 11352*D1**2*f*fdd*r*s - 3036*D1**2*f*fdd*r + 7458*D1**2*f*fdd*s**2 - 5676*D1**2*f*fdd*s + 1518*D1**2*f*fdd - 2244*D1**2*f*gd2*r**2 - 4488*D1**2*f*gd2*r*s + 4488*D1**2*f*gd2*r - 5412*D1**2*f*gd2*s**2 + 10824*D1**2*f*gd2*s - 5412*D1**2*f*gd2 + 4356*D1**2*f*gdd2*r**2 + 9636*D1**2*f*gdd2*r*s - 9636*D1**2*f*gdd2*r + 5016*D1**2*f*gdd2*s**2 - 10032*D1**2*f*gdd2*s + 5016*D1**2*f*gdd2 + 3036*D1**2*fd**2*r**2 + 11352*D1**2*fd**2*r*s - 3036*D1**2*fd**2*r + 7458*D1**2*fd**2*s**2 - 5676*D1**2*fd**2*s - 2244*D1**2*fd*g2*r**2 - 4488*D1**2*fd*g2*r*s - 6600*D1**2*fd*g2*r - 5412*D1**2*fd*g2*s**2 - 5016*D1**2*fd*g2*s + 3300*D1**2*fd*g2 + 8712*D1**2*fd*gd2*r**2 + 19272*D1**2*fd*gd2*r*s + 132*D1**2*fd*gd2*r + 10032*D1**2*fd*gd2*s**2 - 1056*D1**2*fd*gd2*s - 8976*D1**2*fd*gd2 + 4356*D1**2*fdd*g2*r**2 + 9636*D1**2*fdd*g2*r*s + 9768*D1**2*fdd*g2*r + 5016*D1**2*fdd*g2*s**2 + 8976*D1**2*fdd*g2*s - 4884*D1**2*fdd*g2 + 21912*D1*Dd*K*f**2*r**2 + 27984*D1*Dd*K*f**2*r*s - 24948*D1*Dd*K*f**2*r + 13992*D1*Dd*K*f**2*s**2 - 20988*D1*Dd*K*f**2*s + 12474*D1*Dd*K*f**2 - 83424*D1*Dd*K*f*fd*r**2 - 161568*D1*Dd*K*f*fd*r*s + 102960*D1*Dd*K*f*fd*r - 69696*D1*Dd*K*f*fd*s**2 + 95436*D1*Dd*K*f*fd*s - 30624*D1*Dd*K*f*fd + 5544*D1*Dd*b2*f*r**2 + 11088*D1*Dd*b2*f*r*s - 8316*D1*Dd*b2*f*r + 5544*D1*Dd*b2*f*s**2 - 8316*D1*Dd*b2*f*s + 4158*D1*Dd*b2*f - 18480*D1*Dd*b2*fd*r**2 - 36960*D1*Dd*b2*fd*r*s + 13860*D1*Dd*b2*fd*r - 18480*D1*Dd*b2*fd*s**2 + 13860*D1*Dd*b2*fd*s - 6080*D1*Dd*f**3*r**2 - 18232*D1*Dd*f**3*r*s + 12156*D1*Dd*f**3*r - 8580*D1*Dd*f**3*s**2 + 13138*D1*Dd*f**3*s - 5810*D1*Dd*f**3 + 34080*D1*Dd*f**2*fd*r**2 + 120432*D1*Dd*f**2*fd*r*s - 69004*D1*Dd*f**2*fd*r + 59400*D1*Dd*f**2*fd*s**2 - 79346*D1*Dd*f**2*fd*s + 24890*D1*Dd*f**2*fd - 6600*D1*Dd*f**2*r**2 - 14520*D1*Dd*f**2*r*s + 10560*D1*Dd*f**2*r - 12276*D1*Dd*f**2*s**2 + 15906*D1*Dd*f**2*s - 7788*D1*Dd*f**2 + 24288*D1*Dd*f*fd*r**2 + 90816*D1*Dd*f*fd*r*s - 40920*D1*Dd*f*fd*r + 59664*D1*Dd*f*fd*s**2 - 63888*D1*Dd*f*fd*s + 14388*D1*Dd*f*fd - 8976*D1*Dd*f*g2*r**2 - 17952*D1*Dd*f*g2*r*s + 13464*D1*Dd*f*g2*r - 21648*D1*Dd*f*g2*s**2 + 26136*D1*Dd*f*g2*s - 13068*D1*Dd*f*g2 + 34848*D1*Dd*f*gd2*r**2 + 77088*D1*Dd*f*gd2*r*s - 66528*D1*Dd*f*gd2*r + 40128*D1*Dd*f*gd2*s**2 - 69828*D1*Dd*f*gd2*s + 29700*D1*Dd*f*gd2 + 34848*D1*Dd*fd*g2*r**2 + 77088*D1*Dd*fd*g2*r*s + 11088*D1*Dd*fd*g2*r + 40128*D1*Dd*fd*g2*s**2 + 6204*D1*Dd*fd*g2*s - 27720*D1*Dd*fd*g2 - 20856*D1*Ddd*K*f**2*r**2 - 40392*D1*Ddd*K*f**2*r*s + 30624*D1*Ddd*K*f**2*r - 17424*D1*Ddd*K*f**2*s**2 + 27522*D1*Ddd*K*f**2*s - 13926*D1*Ddd*K*f**2 - 9240*D1*Ddd*b2*f*r**2 - 18480*D1*Ddd*b2*f*r*s + 13860*D1*Ddd*b2*f*r - 9240*D1*Ddd*b2*f*s**2 + 13860*D1*Ddd*b2*f*s - 6930*D1*Ddd*b2*f + 5680*D1*Ddd*f**3*r**2 + 20072*D1*Ddd*f**3*r*s - 12876*D1*Ddd*f**3*r + 9900*D1*Ddd*f**3*s**2 - 14918*D1*Ddd*f**3*s + 6370*D1*Ddd*f**3 + 6072*D1*Ddd*f**2*r**2 + 22704*D1*Ddd*f**2*r*s - 14388*D1*Ddd*f**2*r + 14916*D1*Ddd*f**2*s**2 - 20592*D1*Ddd*f**2*s + 8976*D1*Ddd*f**2 + 17424*D1*Ddd*f*g2*r**2 + 38544*D1*Ddd*f*g2*r*s - 27984*D1*Ddd*f*g2*r + 20064*D1*Ddd*f*g2*s**2 - 29700*D1*Ddd*f*g2*s + 14388*D1*Ddd*f*g2 - 33*D1*bd1*(D1*(2*f**2*(21*r**2 + r*(132*s - 89) + 111*s**2 - 175*s + 61) - f*(2*K*(34*r**2 + 68*r*s - 118*r + 82*s**2 - 154*s + 83) + 6*fd*(28*r**2 + 2*r*(88*s - 51) + 148*s**2 - 192*s + 55) - 28*r**2 - 92*r*s + 96*r - 160*s**2 + 240*s - 105) + 2*fd*(K*(132*r**2 + r*(292*s - 65) + 152*s**2 - 81*s - 68) - 28*r**2 + r*(41 - 200*s) - 164*s**2 + 99*s + 33) - 224*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 224*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f**2*(168*r**2 + 2*r*(528*s - 347) + 888*s**2 - 1316*s + 467) + f*(-K*(528*r**2 + 4*r*(292*s - 319) + 608*s**2 - 1318*s + 647) + 112*r**2 + 800*r*s - 576*r + 656*s**2 - 1088*s + 417) - 112*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 462*D1*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) - 62568*Dd**2*K*f**2*r**2 - 121176*Dd**2*K*f**2*r*s + 91872*Dd**2*K*f**2*r - 52272*Dd**2*K*f**2*s**2 + 82566*Dd**2*K*f**2*s - 28908*Dd**2*K*f**2 - 27720*Dd**2*b2*f*r**2 - 55440*Dd**2*b2*f*r*s + 41580*Dd**2*b2*f*r - 27720*Dd**2*b2*f*s**2 + 41580*Dd**2*b2*f*s - 13860*Dd**2*b2*f + 17040*Dd**2*f**3*r**2 + 60216*Dd**2*f**3*r*s - 38628*Dd**2*f**3*r + 29700*Dd**2*f**3*s**2 - 44754*Dd**2*f**3*s + 14986*Dd**2*f**3 + 18216*Dd**2*f**2*r**2 + 68112*Dd**2*f**2*r*s - 43164*Dd**2*f**2*r + 44748*Dd**2*f**2*s**2 - 61776*Dd**2*f**2*s + 18810*Dd**2*f**2 + 52272*Dd**2*f*g2*r**2 + 115632*Dd**2*f*g2*r*s - 83952*Dd**2*f*g2*r + 60192*Dd**2*f*g2*s**2 - 89100*Dd**2*f*g2*s + 29304*Dd**2*f*g2) + 66*b2*(-35*D1**2*bdd1*f*(r + s - 1)**2 + 6*D1**2*(f*(fd*(10*r**2 + 2*r*(8*s - 5) + 6*s**2 - 8*s + 5) - fdd*(12*r**2 + 2*r*(11*s - 6) + 10*s**2 - 11*s + 6)) + fd**2*(-12*r**2 + r*(12 - 22*s) + s*(11 - 10*s))) + 7*D1*bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 6*D1*f*(Dd*(f*(20*r**2 + 32*r*s - 26*r + 12*s**2 - 20*s + 11) - 2*fd*(48*r**2 + 88*r*s - 58*r + 40*s**2 - 53*s + 17)) - Ddd*f*(24*r**2 + r*(44*s - 34) + 20*s**2 - 31*s + 16)) - 6*Dd**2*f**2*(72*r**2 + 6*r*(22*s - 17) + 60*s**2 - 93*s + 32)))/(693*d**2*k3**4) + 8*D1**2*Pk1*Pk3*ct*k1*st**4*(-66*D1*b1*s*(4*C - 3)*(D1*bdd1*f*s + 2*bd1*(-D1*f*s + D1*fd*(s - 1) + 2*Dd*f*(2*s - 1))) + 33*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(66*bd1**2*s**2*(3 - 4*C) + f*(20*C - 11)*(2*fd - fdd)*(3*s**2 - 2*s + 1) - fd**2*s*(40*C - 22)*(3*s - 2)) + D1*f*(40*C - 22)*(2*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-6*s**2 + 5*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) + Dd**2*f**2*(22 - 40*C)*(6*s**2 - 6*s + 1)))/(231*d**2*k2*k3**2) + D1**2*Pk1*Pk3*ct*k1*st**2*(11*b1**2*(D1**2*(s - 1)*(fd*(4*C*(26*r - 23*s + 23) - 52*r + 69*s - 69) + fdd*(-4*C*(6*r - 29*s + 29) + 12*r - 87*s + 87)) + 2*D1*(4*C*Ddd*f*(r*(6 - 12*s) + 58*s**2 - 55*s + 29) + Dd*f*(4*C*(52*r*s - 26*r - 46*s**2 + 33*s - 23) - 104*r*s + 52*r + 138*s**2 - 112*s + 69) - 4*Dd*fd*(C*(6*r*(4*s - 3) - 116*s**2 + 171*s - 55) - 12*r*s + 9*r + 87*s**2 - 129*s + 42) + 3*Ddd*f*(r*(8*s - 4) - 58*s**2 + 56*s - 29)) - 2*Dd**2*f*(4*C*(36*r*s - 18*r - 174*s**2 + 165*s - 23) - 72*r*s + 36*r + 522*s**2 - 504*s + 75)) + 22*b1*(D1**2*(f*(bdd1*s*(-4*C*(6*r - 29*s - 3) + 12*r - 87*s - 6) - fd*(4*C - 2)*(10*s**2 - 7*s + 5) + fdd*(4*C - 2)*(10*s**2 - 7*s + 5)) + fd**2*(4*C - 2)*(10*s**2 - 7*s - 3)) + D1*bd1*(-8*C*Dd*f*(6*r*(4*s - 1) - 116*s**2 + 49*s + 3) + D1*f*s*(4*C*(26*r - 23*s - 13) - 52*r + 69*s + 26) - 2*D1*fd*(2*C*(6*r*(2*s - 1) - 58*s**2 + 55*s + 3) + r*(6 - 12*s) + 87*s**2 - 84*s - 3) + 12*Dd*f*(r*(8*s - 2) - 58*s**2 + 26*s + 1)) - D1*f*(8*C - 4)*(5*Dd*f*(2*s**2 - 2*s + 1) + Dd*fd*(-40*s**2 + 34*s - 7) - 5*Ddd*f*(2*s**2 - 2*s + 1)) + Dd**2*f**2*(40*C - 20)*(6*s**2 - 6*s + 1)) + f*(22*D1**2*bd1**2*s*(-4*C*(6*r - 29*s - 3) + 12*r - 87*s - 6) + D1**2*(f*(44*bdd1*s*(2*C - 1)*(5*s - 3) + fd*(-108*C*(r*(6*s - 2) + 33*s**2 - 24*s + 11) + 108*r*(3*s - 1) + 2247*s**2 - 1606*s + 749) + fdd*(4*C*(82*r*(3*s - 1) + 693*s**2 - 544*s + 231) - 164*r*(3*s - 1) - 1701*s**2 + 1298*s - 567)) + 2*fd**2*(4*C*(82*r*(3*s - 1) + 693*s**2 - 544*s + 41) - 164*r*(3*s - 1) - 1701*s**2 + 1298*s - 82)) + 44*D1*bd1*(2*C - 1)*(D1*f*s*(3 - 5*s) + D1*fd*(20*s**2 - 13*s + 3) + 2*Dd*f*(20*s**2 - 16*s + 3)) - 2*D1*f*(Dd*(f*(108*C*(4*r*s - 2*r + 22*s**2 - 23*s + 11) - 216*r*s + 108*r - 1498*s**2 + 1552*s - 749) - 4*fd*(C*(82*r*(12*s - 5) + 2772*s**2 - 2597*s + 585) - 492*r*s + 205*r - 1701*s**2 + 1561*s - 345)) + Ddd*f*(-4*C*(82*r*(2*s - 1) + 462*s**2 - 503*s + 231) + 164*r*(2*s - 1) + 1134*s**2 - 1216*s + 567)) + 2*Dd**2*f**2*(4*C*(246*r*(2*s - 1) + 1386*s**2 - 1509*s + 313) - 492*r*(2*s - 1) - 3402*s**2 + 3648*s - 731)))/(231*d**2*k2*k3**2) - 4*D1**2*Pk1*Pk3*ct*k1*(7*b1**2*(D1**2*(fd - fdd)*(s - 1)*(4*C*(r + s - 1) - 2*r - 3*s + 3) + 2*D1*(Dd*(f*(2*C*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 4*r*s + 2*r - 6*s**2 + 7*s - 3) + fd*(-2*C*(8*r*s - 6*r + 8*s**2 - 13*s + 5) + 8*r*s - 6*r + 12*s**2 - 19*s + 7)) + Ddd*f*(-2*C*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 4*r*s - 2*r + 6*s**2 - 7*s + 3)) + 2*Dd**2*f*(-2*C*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4) + 6*r*(2*s - 1) + 18*s**2 - 21*s + 5)) + 2*b1*(D1**2*(f*(-7*bdd1*s*(C*(4*r + 4*s - 2) - 2*r - 3*s + 1) - fd*(2*C - 1)*(2*s**2 + 5*s + 1) + fdd*(2*C - 1)*(2*s**2 + 5*s + 1)) + fd**2*(2*C - 1)*(2*s**2 + 5*s - 7)) + 7*D1*bd1*(D1*(f*s*(C*(4*r + 4*s - 2) - 2*r - 3*s + 1) + fd*(-2*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + 4*r*s - 2*r + 6*s**2 - 7*s + 1)) - 2*Dd*f*(2*C*(8*r*s - 2*r + 8*s**2 - 7*s + 1) - 8*r*s + 2*r - 12*s**2 + 9*s - 1)) - D1*f*(4*C - 2)*(Dd*f*(2*s**2 - 2*s + 1) + Dd*fd*(-8*s**2 - 6*s + 5) + Ddd*f*(-2*s**2 + 2*s - 1)) + Dd**2*f**2*(4*C - 2)*(6*s**2 - 6*s + 1)) - 2*f*(7*D1**2*bd1**2*s*(C*(4*r + 4*s - 2) - 2*r - 3*s + 1) + D1**2*(f*(-bdd1*s*(2*C - 1)*(s - 7) + fd*(2*C*(21*r*s - 7*r + 27*s**2 - 25*s + 9) - 21*r*s + 7*r - 39*s**2 + 33*s - 13) + fdd*(-2*C*(21*r*s - 7*r + 27*s**2 - 25*s + 9) + 21*r*s - 7*r + 39*s**2 - 33*s + 13)) + fd**2*(-2*C*(14*r*(3*s - 1) + 54*s**2 - 50*s + 7) + 14*r*(3*s - 1) + 78*s**2 - 66*s + 7)) - D1*bd1*(2*C - 1)*(-D1*f*s*(s - 7) + D1*fd*(4*s**2 - 9*s + 7) + 2*Dd*f*(4*s**2 - 16*s + 7)) + D1*f*(Dd*(f*(C*(56*r*s - 28*r + 72*s**2 - 86*s + 36) - 28*r*s + 14*r - 52*s**2 + 59*s - 26) + fd*(-2*C*(168*r*s - 70*r + 216*s**2 - 229*s + 57) + 168*r*s - 70*r + 312*s**2 - 309*s + 73)) + Ddd*f*(C*(-56*r*s + 28*r - 72*s**2 + 86*s - 36) + 28*r*s - 14*r + 52*s**2 - 59*s + 26)) + Dd**2*f**2*(-2*C*(42*r*(2*s - 1) + 108*s**2 - 129*s + 32) + 42*r*(2*s - 1) + 156*s**2 - 177*s + 40)))/(21*d**2*k2*k3**2) - 20*D1**2*Pk1*Pk3*ct*k2**5*st**6*(528*C*D1**2*b1*f*fd*r**2 + 528*C*D1**2*b1*f*fd*r*s - 264*C*D1**2*b1*f*fd*r - 264*C*D1**2*b1*f*fdd*r**2 - 264*C*D1**2*b1*f*fdd*r*s + 132*C*D1**2*b1*f*fdd*r - 264*C*D1**2*b1*fd**2*r**2 - 264*C*D1**2*b1*fd**2*r*s + 132*C*D1**2*b1*fd**2*r + 24*C*D1**2*f**2*fd*r**2 + 24*C*D1**2*f**2*fd*r*s - 24*C*D1**2*f**2*fd*r - 8*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r**2 - 12*C*D1**2*f**2*fdd*r*s + 12*C*D1**2*f**2*fdd*r + 4*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r**2 - 24*C*D1**2*f*fd**2*r*s + 24*C*D1**2*f*fd**2*r + 8*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 1056*C*D1*Dd*b1*f**2*r**2 + 1056*C*D1*Dd*b1*f**2*r*s - 1056*C*D1*Dd*b1*f**2*r - 264*C*D1*Dd*b1*f**2*s + 264*C*D1*Dd*b1*f**2 - 2112*C*D1*Dd*b1*f*fd*r**2 - 2112*C*D1*Dd*b1*f*fd*r*s + 1584*C*D1*Dd*b1*f*fd*r + 264*C*D1*Dd*b1*f*fd*s - 132*C*D1*Dd*b1*f*fd + 32*C*D1*Dd*f**3*r**2 + 32*C*D1*Dd*f**3*r*s - 32*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r**2 - 96*C*D1*Dd*f**2*fd*r*s + 96*C*D1*Dd*f**2*fd*r + 28*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 528*C*D1*Ddd*b1*f**2*r**2 - 528*C*D1*Ddd*b1*f**2*r*s + 528*C*D1*Ddd*b1*f**2*r + 132*C*D1*Ddd*b1*f**2*s - 132*C*D1*Ddd*b1*f**2 - 16*C*D1*Ddd*f**3*r**2 - 16*C*D1*Ddd*f**3*r*s + 16*C*D1*Ddd*f**3*r + 4*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 1584*C*Dd**2*b1*f**2*r**2 - 1584*C*Dd**2*b1*f**2*r*s + 1584*C*Dd**2*b1*f**2*r + 396*C*Dd**2*b1*f**2*s - 264*C*Dd**2*b1*f**2 - 48*C*Dd**2*f**3*r**2 - 48*C*Dd**2*f**3*r*s + 48*C*Dd**2*f**3*r + 12*C*Dd**2*f**3*s - 8*C*Dd**2*f**3 - 660*D1**2*b1*f*fd*r**2 - 792*D1**2*b1*f*fd*r*s + 396*D1**2*b1*f*fd*r - 132*D1**2*b1*f*fd*s**2 + 132*D1**2*b1*f*fd*s - 66*D1**2*b1*f*fd + 330*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s**2 - 66*D1**2*b1*f*fdd*s + 33*D1**2*b1*f*fdd + 330*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)*(4*C*(r - 1) - 5*r - s + 5) - 30*D1**2*f**2*fd*r**2 - 36*D1**2*f**2*fd*r*s + 32*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 16*D1**2*f**2*fd*s - 12*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r**2 + 18*D1**2*f**2*fdd*r*s - 16*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 8*D1**2*f**2*fdd*s + 6*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r**2 + 36*D1**2*f*fd**2*r*s - 32*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 16*D1**2*f*fd**2*s + 6*D1**2*f*fd**2 - 1320*D1*Dd*b1*f**2*r**2 - 1584*D1*Dd*b1*f**2*r*s + 1452*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s**2 + 660*D1*Dd*b1*f**2*s - 462*D1*Dd*b1*f**2 + 2640*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 2244*D1*Dd*b1*f*fd*r + 528*D1*Dd*b1*f*fd*s**2 - 924*D1*Dd*b1*f*fd*s + 330*D1*Dd*b1*f*fd - 40*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 44*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 14*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r**2 + 144*D1*Dd*f**2*fd*r*s - 130*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 62*D1*Dd*f**2*fd*s + 32*D1*Dd*f**2*fd + 660*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 726*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s**2 - 330*D1*Ddd*b1*f**2*s + 231*D1*Ddd*b1*f**2 + 20*D1*Ddd*f**3*r**2 + 24*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 10*D1*Ddd*f**3*s + 7*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1)*(4*C*(r - 1) - 5*r - s + 5) + fd*(-2*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 10*r**2 + 12*r*s - 13*r + 2*s**2 - 7*s + 3)) + Dd*f*(-2*C*(8*r**2 + 8*r*s - 12*r - 5*s + 4) + 20*r**2 + 24*r*s - 31*r + 4*s**2 - 17*s + 11)) + 1980*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 2178*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s**2 - 990*Dd**2*b1*f**2*s + 462*Dd**2*b1*f**2 + 60*Dd**2*f**3*r**2 + 72*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 30*Dd**2*f**3*s + 14*Dd**2*f**3)/(693*d**2*k1*k3**6) - 4*D1**2*Pk1*Pk3*ct*k2**5*st**4*(-1716*D1**2*bd1**2*f*(r + s - 1)*(K*(2*r - 1) - 3*r - s + 2) + 26*D1*bd1*(D1*(10*f**3*(8*r**2 + 2*r*(5*s - 8) + 2*s**2 - 10*s + 9) + f**2*(-132*C*(r - 1)*(r + s - 1) - 10*fd*(24*r**2 + 30*r*s - 34*r + 6*s**2 - 19*s + 9) + 165*r**2 + 198*r*s - 330*r + 33*s**2 - 198*s + 165) - 132*f*(r + s - 1)*(2*g2*(r - 1) - 2*gd2*r + gd2) + 132*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 2*Dd*f*(5*f**2*(32*r**2 + 10*r*(4*s - 5) + 8*s**2 - 29*s + 18) - 66*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 858*b1**2*(D1**2*(2*fd - fdd)*(r + s)*(r*(2*K - 3) - s) + D1*(2*Dd*(f*(K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 12*r**2 - 16*r*s + 14*r - 4*s**2 + 8*s - 5) + fd*(r**2*(12 - 8*K) + r*(-8*K*s + 4*K + 16*s - 7) + s*(K + 4*s - 4))) + Ddd*f*(K*(-8*r**2 - 8*r*s + 8*r + 2*s - 2) + 12*r**2 + 2*r*(8*s - 7) + 4*s**2 - 8*s + 5)) + 2*Dd**2*f*(K*(-12*r**2 - 12*r*(s - 1) + 3*s - 2) + 18*r**2 + 3*r*(8*s - 7) + 6*s**2 - 12*s + 5)) + 26*b1*(-264*C*D1**2*f*fd*r**2 - 264*C*D1**2*f*fd*r*s + 132*C*D1**2*f*fd*r - 528*C*D1*Dd*f**2*r**2 - 528*C*D1*Dd*f**2*r*s + 528*C*D1*Dd*f**2*r + 132*C*D1*Dd*f**2*s - 132*C*D1*Dd*f**2 - 66*D1**2*bdd1*f*(r + s - 1)*(2*K*r - K - 3*r - s + 2) + 240*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 60*D1**2*f**2*fd*s**2 - 80*D1**2*f**2*fd*s + 30*D1**2*f**2*fd - 120*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 30*D1**2*f**2*fdd*s**2 + 40*D1**2*f**2*fdd*s - 15*D1**2*f**2*fdd - 240*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s**2 + 80*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 330*D1**2*f*fd*r**2 + 396*D1**2*f*fd*r*s - 198*D1**2*f*fd*r + 66*D1**2*f*fd*s**2 - 66*D1**2*f*fd*s + 33*D1**2*f*fd - 264*D1**2*f*gd2*r**2 - 264*D1**2*f*gd2*r*s + 264*D1**2*f*gd2*r + 132*D1**2*f*gdd2*r**2 + 132*D1**2*f*gdd2*r*s - 132*D1**2*f*gdd2*r - 264*D1**2*fd*g2*r**2 - 264*D1**2*fd*g2*r*s + 264*D1**2*fd*gd2*r**2 + 264*D1**2*fd*gd2*r*s - 132*D1**2*fd*gd2*r + 132*D1**2*fdd*g2*r**2 + 132*D1**2*fdd*g2*r*s + 320*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 360*D1*Dd*f**3*r + 80*D1*Dd*f**3*s**2 - 180*D1*Dd*f**3*s + 120*D1*Dd*f**3 - 960*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 940*D1*Dd*f**2*fd*r - 240*D1*Dd*f**2*fd*s**2 + 430*D1*Dd*f**2*fd*s - 180*D1*Dd*f**2*fd + 660*D1*Dd*f**2*r**2 + 792*D1*Dd*f**2*r*s - 726*D1*Dd*f**2*r + 132*D1*Dd*f**2*s**2 - 330*D1*Dd*f**2*s + 231*D1*Dd*f**2 - 1056*D1*Dd*f*g2*r**2 - 1056*D1*Dd*f*g2*r*s + 1056*D1*Dd*f*g2*r + 264*D1*Dd*f*g2*s - 264*D1*Dd*f*g2 + 1056*D1*Dd*f*gd2*r**2 + 1056*D1*Dd*f*gd2*r*s - 1056*D1*Dd*f*gd2*r - 132*D1*Dd*f*gd2*s + 132*D1*Dd*f*gd2 + 1056*D1*Dd*fd*g2*r**2 + 1056*D1*Dd*fd*g2*r*s - 528*D1*Dd*fd*g2*r - 132*D1*Dd*fd*g2*s - 160*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 180*D1*Ddd*f**3*r - 40*D1*Ddd*f**3*s**2 + 90*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 + 528*D1*Ddd*f*g2*r**2 + 528*D1*Ddd*f*g2*r*s - 528*D1*Ddd*f*g2*r - 132*D1*Ddd*f*g2*s + 132*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(2*f*(r + s - 1)*(K*(2*r - 1) - 3*r - s + 2) + fd*(r**2*(6 - 4*K) + r*(-4*K*s + 3*K + 8*s - 5) + s*(K + 2*s - 3))) + Dd*f*(K*(-16*r**2 - 16*r*s + 20*r + 6*s - 5) + 24*r**2 + 32*r*s - 34*r + 8*s**2 - 20*s + 11)) - 480*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 540*Dd**2*f**3*r - 120*Dd**2*f**3*s**2 + 270*Dd**2*f**3*s - 120*Dd**2*f**3 + 1584*Dd**2*f*g2*r**2 + 1584*Dd**2*f*g2*r*s - 1584*Dd**2*f*g2*r - 396*Dd**2*f*g2*s + 264*Dd**2*f*g2) + f*(-26*D1**2*bdd1*(5*f**2*(8*r**2 + 2*r*(5*s - 8) + 2*s**2 - 10*s + 9) - 132*g2*(r - 1)*(r + s - 1)) + f*(D1**2*(f*(3*fd*(644*r**2 - 2*r*(68*s + 127) - 780*s**2 + 814*s - 229) + 5*fdd*(332*r**2 + r*(904*s - 618) + 572*s**2 - 798*s + 369)) + 30*fd**2*(166*r**2 + r*(452*s - 309) + 286*s**2 - 399*s + 123)) + D1*f*(Dd*(3*f*(644*r**2 - 2*r*(68*s + 127) - 780*s**2 + 814*s - 229) + 10*fd*(1328*r**2 + 8*r*(452*s - 309) + 2288*s**2 - 3192*s + 1107)) + 5*Ddd*f*(332*r**2 + r*(904*s - 618) + 572*s**2 - 798*s + 369)) + 30*Dd**2*f**2*(166*r**2 + r*(452*s - 309) + 286*s**2 - 399*s + 123))))/(3003*d**2*k1*k3**6) - 20*D1**2*Pk1*Pk3*ct*k2**3*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*C - 3)*(2*s - 1) - 2*s**2 + 2*s - 1) + fd**2*(r*(C*(2 - 4*s) + 6*s - 3) + s*(2*s - 2))) + D1*f*(Dd*(2*f*(-2*C*s + r*(4*C - 6)*(2*s - 1) - 4*s**2 + 7*s - 2) - fd*(2*s - 1)*(2*C*(8*r - 1) - 24*r - 8*s + 7)) + Ddd*f*(2*C*s - r*(4*C - 6)*(2*s - 1) + 4*s**2 - 7*s + 2)) + Dd**2*f**2*(C*(r*(12 - 24*s) + 6*s - 4) + 18*r*(2*s - 1) + 12*s**2 - 21*s + 8)) + f*(D1**2*(f*(33*bdd1*s*(-2*C*(r - 1) + 3*r + s - 3) + 2*fd*(-2*C*s + r*(2*C - 3)*(3*s - 1) - 3*s**2 + 5*s - 1) + fdd*(2*C*s + r*(-6*C*s + 2*C + 9*s - 3) + 3*s**2 - 5*s + 1)) + fd**2*(C*(r*(4 - 12*s) + 4*s - 2) + 6*r*(3*s - 1) + 6*s**2 - 10*s + 3)) + 33*D1*bd1*(D1*(2*f*s*(2*C*(r - 1) - 3*r - s + 3) + fd*(C*(-8*r*s + 2*r + 4*s - 2) + 12*r*s - 3*r + 4*s**2 - 8*s + 3)) + Dd*f*(-2*C*(8*r*s - 2*r - 5*s + 2) + 24*r*s - 6*r + 8*s**2 - 19*s + 6)) + D1*f*(Dd*(2*f*(-2*C*s + r*(4*C - 6)*(2*s - 1) - 4*s**2 + 7*s - 2) + fd*(C*(-48*r*s + 20*r + 14*s - 6) + 72*r*s - 30*r + 24*s**2 - 41*s + 13)) + Ddd*f*(2*C*s - r*(4*C - 6)*(2*s - 1) + 4*s**2 - 7*s + 2)) + Dd**2*f**2*(C*(r*(12 - 24*s) + 6*s - 4) + 18*r*(2*s - 1) + 12*s**2 - 21*s + 8)))/(693*d**2*k1*k3**4) - 2*D1**2*Pk1*Pk3*ct*k2**3*st**4*(264*b1**2*(C - 1)*(D1**2*r*(2*fd - fdd)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-8*r**2 - 8*r*(s - 1) + s - 1)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + 33*b1*(-16*C*D1**2*f*fd*r**2 - 48*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r + 16*C*D1**2*f*fdd*r**2 + 40*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*r + 16*C*D1**2*fd**2*r**2 + 40*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*r - 32*C*D1*Dd*f**2*r**2 - 96*C*D1*Dd*f**2*r*s + 64*C*D1*Dd*f**2*r + 24*C*D1*Dd*f**2*s - 8*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r**2 + 320*C*D1*Dd*f*fd*r*s - 192*C*D1*Dd*f*fd*r - 40*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r**2 + 80*C*D1*Ddd*f**2*r*s - 56*C*D1*Ddd*f**2*r - 20*C*D1*Ddd*f**2*s + 8*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r**2 + 240*C*Dd**2*f**2*r*s - 168*C*Dd**2*f**2*r - 60*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 - 8*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 26*D1**2*f*fd*r**2 + 76*D1**2*f*fd*r*s - 38*D1**2*f*fd*r + 18*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 9*D1**2*f*fd - 26*D1**2*f*fdd*r**2 - 68*D1**2*f*fdd*r*s + 34*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 26*D1**2*fd**2*r**2 - 68*D1**2*fd**2*r*s + 34*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 52*D1*Dd*f**2*r**2 + 152*D1*Dd*f**2*r*s - 102*D1*Dd*f**2*r + 36*D1*Dd*f**2*s**2 - 74*D1*Dd*f**2*s + 31*D1*Dd*f**2 - 208*D1*Dd*f*fd*r**2 - 544*D1*Dd*f*fd*r*s + 324*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 212*D1*Dd*f*fd*s - 70*D1*Dd*f*fd - 52*D1*Ddd*f**2*r**2 - 136*D1*Ddd*f**2*r*s + 94*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 70*D1*Ddd*f**2*s - 31*D1*Ddd*f**2 + 8*D1*bd1*(C - 1)*(D1*(f*(4*r**2 + 4*r*(s - 1) - 2*s + 2) + fd*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 156*Dd**2*f**2*r**2 - 408*Dd**2*f**2*r*s + 282*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 210*Dd**2*f**2*s - 86*Dd**2*f**2) + f*(-852*C*D1**2*f*fd*r**2 - 216*C*D1**2*f*fd*r*s + 640*C*D1**2*f*fd*r + 72*C*D1**2*f*fd*s - 284*C*D1**2*f*fd + 624*C*D1**2*f*fdd*r**2 + 108*C*D1**2*f*fdd*r*s - 452*C*D1**2*f*fdd*r - 36*C*D1**2*f*fdd*s + 208*C*D1**2*f*fdd + 1248*C*D1**2*fd**2*r**2 + 216*C*D1**2*fd**2*r*s - 904*C*D1**2*fd**2*r - 72*C*D1**2*fd**2*s + 36*C*D1**2*fd**2 - 1136*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 712*C*D1*Dd*f**2*r + 72*C*D1*Dd*f**2*s - 284*C*D1*Dd*f**2 + 4992*C*D1*Dd*f*fd*r**2 + 864*C*D1*Dd*f*fd*r*s - 3272*C*D1*Dd*f*fd*r - 252*C*D1*Dd*f*fd*s + 524*C*D1*Dd*f*fd + 832*C*D1*Ddd*f**2*r**2 + 144*C*D1*Ddd*f**2*r*s - 488*C*D1*Ddd*f**2*r - 36*C*D1*Ddd*f**2*s + 208*C*D1*Ddd*f**2 + 2496*C*Dd**2*f**2*r**2 + 432*C*Dd**2*f**2*r*s - 1464*C*Dd**2*f**2*r - 108*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 264*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(4*C*(r - 1)*(2*r + 5*s - 2) - 13*r**2 - 34*r*s + 26*r - 9*s**2 + 34*s - 13) + 561*D1**2*f*fd*r**2 - 374*D1**2*f*fd*r - 60*D1**2*f*fd*s**2 + 40*D1**2*f*fd*s + 167*D1**2*f*fd - 429*D1**2*f*fdd*r**2 + 286*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s - 133*D1**2*f*fdd - 858*D1**2*fd**2*r**2 + 572*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 40*D1**2*fd**2*s + 748*D1*Dd*f**2*r**2 - 374*D1*Dd*f**2*r - 80*D1*Dd*f**2*s**2 + 80*D1*Dd*f**2*s + 147*D1*Dd*f**2 - 3432*D1*Dd*f*fd*r**2 + 2002*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 200*D1*Dd*f*fd*s - 246*D1*Dd*f*fd - 572*D1*Ddd*f**2*r**2 + 286*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 40*D1*Ddd*f**2*s - 123*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(8*C*(r - 1)*(r + 3*s - 1) - 13*r**2 - 38*r*s + 26*r - 9*s**2 + 38*s - 13) + 2*fd*(-2*C*(8*r**2 + 20*r*s - 13*r - 10*s + 5) + 26*r**2 + 68*r*s - 43*r + 18*s**2 - 43*s + 17)) - 2*Dd*f*(C*(32*r**2 + 80*r*s - 60*r - 50*s + 28) - 52*r**2 - 136*r*s + 99*r - 36*s**2 + 103*s - 47)) - 1716*Dd**2*f**2*r**2 + 858*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 120*Dd**2*f**2*s + 20*Dd**2*f**2))/(231*d**2*k1*k3**4) - D1**2*Pk1*Pk3*ct*k2**3*st**2*(-5148*C*D1**2*f**2*fd*r**2 + 3432*C*D1**2*f**2*fd*r - 1716*C*D1**2*f**2*fd - 6864*C*D1*Dd*f**3*r**2 + 3432*C*D1*Dd*f**3*r - 1716*C*D1*Dd*f**3 + 2002*D1**2*K*bdd1*f**2*r**2 - 1144*D1**2*K*bdd1*f**2*r*s + 1144*D1**2*K*bdd1*f**2*r - 2288*D1**2*b2*f*fd*r**2 - 2288*D1**2*b2*f*fd*r*s + 2288*D1**2*b2*f*fd*r + 1144*D1**2*b2*f*fd*s - 1144*D1**2*b2*f*fd - 286*D1**2*bd1**2*(3*f**2*(2*r**2 - 12*r*s + r - 14*s**2 + 13*s - 3) + f*(K*(-34*r**2 + r*(52 - 44*s) + 20*s - 20) + 63*r**2 + 2*r*(51*s - 55) + 29*s**2 - 78*s + 49) + 28*g2*(-2*r**2 - 2*r*(s - 1) + s)) - 1144*D1**2*bd2*f**2*r**2 - 1144*D1**2*bd2*f**2*r*s + 1144*D1**2*bd2*f**2*r + 3302*D1**2*bdd1*f**3*r**2 + 9308*D1**2*bdd1*f**3*r*s - 7566*D1**2*bdd1*f**3*r + 1716*D1**2*bdd1*f**3*s**2 - 6006*D1**2*bdd1*f**3*s + 4251*D1**2*bdd1*f**3 + 715*D1**2*bdd1*f**2*r**2 + 4290*D1**2*bdd1*f**2*r*s - 4290*D1**2*bdd1*f**2*r + 1573*D1**2*bdd1*f**2*s**2 - 3146*D1**2*bdd1*f**2*s + 1573*D1**2*bdd1*f**2 - 9724*D1**2*bdd1*f*g2*r**2 - 12584*D1**2*bdd1*f*g2*r*s + 17160*D1**2*bdd1*f*g2*r + 11440*D1**2*bdd1*f*g2*s - 8580*D1**2*bdd1*f*g2 + 5040*D1**2*f**3*fd*r**2 + 19968*D1**2*f**3*fd*r*s - 12504*D1**2*f**3*fd*r + 17160*D1**2*f**3*fd*s**2 - 22152*D1**2*f**3*fd*s + 9840*D1**2*f**3*fd - 960*D1**2*f**3*fdd*r**2 - 19968*D1**2*f**3*fdd*r*s + 10464*D1**2*f**3*fdd*r - 17160*D1**2*f**3*fdd*s**2 + 22152*D1**2*f**3*fdd*s - 8820*D1**2*f**3*fdd - 2880*D1**2*f**2*fd**2*r**2 - 59904*D1**2*f**2*fd**2*r*s + 31392*D1**2*f**2*fd**2*r - 51480*D1**2*f**2*fd**2*s**2 + 66456*D1**2*f**2*fd**2*s - 18564*D1**2*f**2*fd**2 + 10296*D1**2*f**2*fd*r**2 + 5148*D1**2*f**2*fd*r*s - 8580*D1**2*f**2*fd*r - 1716*D1**2*f**2*fd*s + 3432*D1**2*f**2*fd + 10296*D1**2*f**2*gd2*r**2 - 4004*D1**2*f**2*gdd2*r**2 + 2288*D1**2*f**2*gdd2*r*s - 2288*D1**2*f**2*gdd2*r + 20592*D1**2*f*fd*g2*r**2 - 20592*D1**2*f*fd*g2*r + 10296*D1**2*f*fd*g2 - 16016*D1**2*f*fd*gd2*r**2 + 9152*D1**2*f*fd*gd2*r*s + 3432*D1**2*f*fd*gd2*r - 2288*D1**2*f*fd*gd2*s + 2288*D1**2*f*fd*gd2 - 8008*D1**2*f*fdd*g2*r**2 + 4576*D1**2*f*fdd*g2*r*s + 8008*D1**2*f*fdd*g2*r - 2288*D1**2*f*fdd*g2*s - 4004*D1**2*f*fdd*g2 - 8008*D1**2*fd**2*g2*r**2 + 4576*D1**2*fd**2*g2*r*s + 8008*D1**2*fd**2*g2*r - 2288*D1**2*fd**2*g2*s - 4576*D1*Dd*b2*f**2*r**2 - 4576*D1*Dd*b2*f**2*r*s + 4576*D1*Dd*b2*f**2*r + 1144*D1*Dd*b2*f**2*s - 1144*D1*Dd*b2*f**2 + 5040*D1*Dd*f**4*r**2 + 19968*D1*Dd*f**4*r*s - 12504*D1*Dd*f**4*r + 17160*D1*Dd*f**4*s**2 - 22152*D1*Dd*f**4*s + 9840*D1*Dd*f**4 - 7680*D1*Dd*f**3*fd*r**2 - 159744*D1*Dd*f**3*fd*r*s + 83712*D1*Dd*f**3*fd*r - 137280*D1*Dd*f**3*fd*s**2 + 177216*D1*Dd*f**3*fd*s - 54768*D1*Dd*f**3*fd + 13728*D1*Dd*f**3*r**2 + 6864*D1*Dd*f**3*r*s - 10296*D1*Dd*f**3*r - 1716*D1*Dd*f**3*s + 3432*D1*Dd*f**3 + 41184*D1*Dd*f**2*g2*r**2 - 20592*D1*Dd*f**2*g2*r + 10296*D1*Dd*f**2*g2 - 32032*D1*Dd*f**2*gd2*r**2 + 18304*D1*Dd*f**2*gd2*r*s - 5720*D1*Dd*f**2*gd2*r - 2288*D1*Dd*f**2*gd2*s + 2288*D1*Dd*f**2*gd2 - 64064*D1*Dd*f*fd*g2*r**2 + 36608*D1*Dd*f*fd*g2*r*s + 38896*D1*Dd*f*fd*g2*r - 13728*D1*Dd*f*fd*g2*s - 3432*D1*Dd*f*fd*g2 - 960*D1*Ddd*f**4*r**2 - 19968*D1*Ddd*f**4*r*s + 10464*D1*Ddd*f**4*r - 17160*D1*Ddd*f**4*s**2 + 22152*D1*Ddd*f**4*s - 8820*D1*Ddd*f**4 - 16016*D1*Ddd*f**2*g2*r**2 + 9152*D1*Ddd*f**2*g2*r*s + 3432*D1*Ddd*f**2*g2*r - 2288*D1*Ddd*f**2*g2*s - 4004*D1*Ddd*f**2*g2 + 13*D1*bd1*(D1*(f**3*(86*r**2 + r*(86 - 244*s) + 330*s - 159) + f**2*(-44*C*(r**2 - 2*r*(s + 3) + 3) + 4*fd*(381*r**2 + 2*r*(537*s - 388) + 198*s**2 - 542*s + 213) - 11*r**2*(36*K - 25) - 22*r*(13*s + 9) - 143*s**2 + 154*s + 121) + 22*f*(fd*(2*K*(14*r**2 - 8*r*s - 3*r + 2*s - 2) + 10*r**2 + 60*r*s - 35*r + 22*s**2 - 37*s + 15) + 8*g2*(5*r**2 + 4*r*(s - 2) - 3*s + 4) - 4*gd2*(17*r**2 + 22*r*s - 26*r - 10*s + 10)) - 88*fd*g2*(17*r**2 + r*(22*s - 17) - 11*s)) + 2*Dd*f*(f**2*(1016*r**2 + r*(2864*s - 2134) + 528*s**2 - 1546*s + 753) + 11*f*(2*K*(28*r**2 - 16*r*s + 5*r + 2*s - 2) + 20*r**2 + 120*r*s - 95*r + 44*s**2 - 81*s + 37) - 44*g2*(68*r**2 + 11*r*(8*s - 9) - 51*s + 35))) - 2880*Dd**2*f**4*r**2 - 59904*Dd**2*f**4*r*s + 31392*Dd**2*f**4*r - 51480*Dd**2*f**4*s**2 + 66456*Dd**2*f**4*s - 18564*Dd**2*f**4 - 48048*Dd**2*f**2*g2*r**2 + 27456*Dd**2*f**2*g2*r*s + 10296*Dd**2*f**2*g2*r - 6864*Dd**2*f**2*g2*s + 4576*Dd**2*f**2*g2 + 4004*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + 4*r*(s - 1) - s + 1) + Dd**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + 143*b1**2*(-56*C*D1**2*fd*r**2 - 56*C*D1**2*fd*r*s + 56*C*D1**2*fd*r - 224*C*D1*Dd*f*r**2 - 224*C*D1*Dd*f*r*s + 224*C*D1*Dd*f*r + 56*C*D1*Dd*f*s - 56*C*D1*Dd*f - 40*D1**2*K*fd*r**2 - 32*D1**2*K*fd*r*s + 16*D1**2*K*fd*r + 8*D1**2*K*fd*s - 8*D1**2*K*fd + 34*D1**2*K*fdd*r**2 + 44*D1**2*K*fdd*r*s - 8*D1**2*K*fdd*r - 4*D1**2*K*fdd*s + 4*D1**2*K*fdd - 28*D1**2*bdd1*(K - 1)*(3*r**2 + 3*r*(s - 1) - s + 1) + 68*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s + 10*D1**2*f*fd*r - 60*D1**2*f*fd*s**2 + 98*D1**2*f*fd*s - 53*D1**2*f*fd - 12*D1**2*f*fdd*r**2 + 72*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r + 84*D1**2*f*fdd*s**2 - 126*D1**2*f*fdd*s + 63*D1**2*f*fdd - 12*D1**2*fd**2*r**2 + 72*D1**2*fd**2*r*s - 54*D1**2*fd**2*r + 84*D1**2*fd**2*s**2 - 126*D1**2*fd**2*s + 42*D1**2*fd**2 + 119*D1**2*fd*r**2 + 106*D1**2*fd*r*s - 72*D1**2*fd*r - 5*D1**2*fd*s**2 - 8*D1**2*fd*s + 8*D1**2*fd - 63*D1**2*fdd*r**2 - 102*D1**2*fdd*r*s + 8*D1**2*fdd*r - 29*D1**2*fdd*s**2 + 4*D1**2*fdd*s - 4*D1**2*fdd - 112*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r + 56*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r - 160*D1*Dd*K*f*r**2 - 128*D1*Dd*K*f*r*s + 144*D1*Dd*K*f*r + 32*D1*Dd*K*f*s - 40*D1*Dd*K*f + 272*D1*Dd*K*fd*r**2 + 352*D1*Dd*K*fd*r*s - 188*D1*Dd*K*fd*r - 60*D1*Dd*K*fd*s + 16*D1*Dd*K*fd + 136*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 76*D1*Dd*f**2*r - 120*D1*Dd*f**2*s**2 + 116*D1*Dd*f**2*s - 26*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 + 576*D1*Dd*f*fd*r*s - 336*D1*Dd*f*fd*r + 672*D1*Dd*f*fd*s**2 - 912*D1*Dd*f*fd*s + 306*D1*Dd*f*fd + 476*D1*Dd*f*r**2 + 424*D1*Dd*f*r*s - 450*D1*Dd*f*r - 20*D1*Dd*f*s**2 - 86*D1*Dd*f*s + 109*D1*Dd*f - 504*D1*Dd*fd*r**2 - 816*D1*Dd*fd*r*s + 362*D1*Dd*fd*r - 232*D1*Dd*fd*s**2 + 234*D1*Dd*fd*s - 16*D1*Dd*fd - 448*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 448*D1*Dd*g2*r + 112*D1*Dd*g2*s - 112*D1*Dd*g2 + 448*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 448*D1*Dd*gd2*r - 56*D1*Dd*gd2*s + 56*D1*Dd*gd2 + 136*D1*Ddd*K*f*r**2 + 176*D1*Ddd*K*f*r*s - 156*D1*Ddd*K*f*r - 44*D1*Ddd*K*f*s + 34*D1*Ddd*K*f - 24*D1*Ddd*f**2*r**2 + 144*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 168*D1*Ddd*f**2*s**2 - 204*D1*Ddd*f**2*s + 78*D1*Ddd*f**2 - 252*D1*Ddd*f*r**2 - 408*D1*Ddd*f*r*s + 330*D1*Ddd*f*r - 116*D1*Ddd*f*s**2 + 218*D1*Ddd*f*s - 121*D1*Ddd*f + 224*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 224*D1*Ddd*g2*r - 56*D1*Ddd*g2*s + 56*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(6*r**2 + 6*r*(s - 1) - 2*s + 2) + Dd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + 408*Dd**2*K*f*r**2 + 528*Dd**2*K*f*r*s - 468*Dd**2*K*f*r - 132*Dd**2*K*f*s + 88*Dd**2*K*f - 72*Dd**2*f**2*r**2 + 432*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 504*Dd**2*f**2*s**2 - 612*Dd**2*f**2*s + 156*Dd**2*f**2 - 756*Dd**2*f*r**2 - 1224*Dd**2*f*r*s + 990*Dd**2*f*r - 348*Dd**2*f*s**2 + 654*Dd**2*f*s - 262*Dd**2*f + 672*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 672*Dd**2*g2*r - 168*Dd**2*g2*s + 112*Dd**2*g2) - 13*b1*(88*C*D1**2*f*fd*r**2 - 176*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*r + 88*C*D1**2*f*fd*s - 88*C*D1**2*f*fd + 176*C*D1*Dd*f**2*r**2 - 352*C*D1*Dd*f**2*r*s + 88*C*D1*Dd*f**2*r + 88*C*D1*Dd*f**2*s + 44*C*D1*Dd*f**2 + 792*D1**2*K*f*fd*r**2 - 792*D1**2*K*f*fd*r + 396*D1**2*K*f*fd - 308*D1**2*K*f*fdd*r**2 + 176*D1**2*K*f*fdd*r*s + 308*D1**2*K*f*fdd*r - 88*D1**2*K*f*fdd*s - 154*D1**2*K*f*fdd - 308*D1**2*K*fd**2*r**2 + 176*D1**2*K*fd**2*r*s + 308*D1**2*K*fd**2*r - 88*D1**2*K*fd**2*s + 308*D1**2*bd1**2*(K - 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 11*D1**2*bdd1*(3*f**2*(4*r**2 + r*(2 - 24*s) - 28*s**2 + 26*s - 5) - 2*f*(K*(34*r**2 + 44*r*s - 52*r - 20*s + 15) - 63*r**2 - 102*r*s + 110*r - 29*s**2 + 78*s - 44) - 56*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 258*D1**2*f**2*fd*r**2 + 732*D1**2*f**2*fd*r*s - 230*D1**2*f**2*fd*r + 86*D1**2*f**2*fd*s - 245*D1**2*f**2*fd - 762*D1**2*f**2*fdd*r**2 - 2148*D1**2*f**2*fdd*r*s + 1358*D1**2*f**2*fdd*r - 396*D1**2*f**2*fdd*s**2 + 782*D1**2*f**2*fdd*s - 191*D1**2*f**2*fdd - 1524*D1**2*f*fd**2*r**2 - 4296*D1**2*f*fd**2*r*s + 2716*D1**2*f*fd**2*r - 792*D1**2*f*fd**2*s**2 + 1564*D1**2*f*fd**2*s - 844*D1**2*f*fd**2 - 550*D1**2*f*fd*r**2 + 572*D1**2*f*fd*r*s + 66*D1**2*f*fd*r + 286*D1**2*f*fd*s**2 - 418*D1**2*f*fd*s - 11*D1**2*f*fd - 110*D1**2*f*fdd*r**2 - 660*D1**2*f*fdd*r*s + 110*D1**2*f*fdd*r - 242*D1**2*f*fdd*s**2 + 330*D1**2*f*fdd*s - 55*D1**2*f*fdd - 880*D1**2*f*gd2*r**2 - 704*D1**2*f*gd2*r*s + 704*D1**2*f*gd2*r + 748*D1**2*f*gdd2*r**2 + 968*D1**2*f*gdd2*r*s - 968*D1**2*f*gdd2*r - 110*D1**2*fd**2*r**2 - 660*D1**2*fd**2*r*s + 110*D1**2*fd**2*r - 242*D1**2*fd**2*s**2 + 330*D1**2*fd**2*s - 880*D1**2*fd*g2*r**2 - 704*D1**2*fd*g2*r*s + 352*D1**2*fd*g2*r + 176*D1**2*fd*g2*s - 176*D1**2*fd*g2 + 1496*D1**2*fd*gd2*r**2 + 1936*D1**2*fd*gd2*r*s - 1144*D1**2*fd*gd2*r - 88*D1**2*fd*gd2*s + 88*D1**2*fd*gd2 + 748*D1**2*fdd*g2*r**2 + 968*D1**2*fdd*g2*r*s - 176*D1**2*fdd*g2*r - 88*D1**2*fdd*g2*s + 88*D1**2*fdd*g2 + 1584*D1*Dd*K*f**2*r**2 - 792*D1*Dd*K*f**2*r + 396*D1*Dd*K*f**2 - 2464*D1*Dd*K*f*fd*r**2 + 1408*D1*Dd*K*f*fd*r*s + 1496*D1*Dd*K*f*fd*r - 528*D1*Dd*K*f*fd*s - 132*D1*Dd*K*f*fd - 344*D1*Dd*f**3*r**2 + 976*D1*Dd*f**3*r*s - 316*D1*Dd*f**3*r - 244*D1*Dd*f**3*s - 86*D1*Dd*f**3 - 6096*D1*Dd*f**2*fd*r**2 - 17184*D1*Dd*f**2*fd*r*s + 11252*D1*Dd*f**2*fd*r - 3168*D1*Dd*f**2*fd*s**2 + 6860*D1*Dd*f**2*fd*s - 2922*D1*Dd*f**2*fd - 1100*D1*Dd*f**2*r**2 + 1144*D1*Dd*f**2*r*s - 22*D1*Dd*f**2*r + 572*D1*Dd*f**2*s**2 - 858*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 880*D1*Dd*f*fd*r**2 - 5280*D1*Dd*f*fd*r*s + 1980*D1*Dd*f*fd*r - 1936*D1*Dd*f*fd*s**2 + 2948*D1*Dd*f*fd*s - 770*D1*Dd*f*fd - 3520*D1*Dd*f*g2*r**2 - 2816*D1*Dd*f*g2*r*s + 3168*D1*Dd*f*g2*r + 704*D1*Dd*f*g2*s - 880*D1*Dd*f*g2 + 5984*D1*Dd*f*gd2*r**2 + 7744*D1*Dd*f*gd2*r*s - 7304*D1*Dd*f*gd2*r - 968*D1*Dd*f*gd2*s + 968*D1*Dd*f*gd2 + 5984*D1*Dd*fd*g2*r**2 + 7744*D1*Dd*fd*g2*r*s - 4136*D1*Dd*fd*g2*r - 1320*D1*Dd*fd*g2*s + 352*D1*Dd*fd*g2 - 616*D1*Ddd*K*f**2*r**2 + 352*D1*Ddd*K*f**2*r*s + 132*D1*Ddd*K*f**2*r - 88*D1*Ddd*K*f**2*s - 154*D1*Ddd*K*f**2 - 1016*D1*Ddd*f**3*r**2 - 2864*D1*Ddd*f**3*r*s + 1940*D1*Ddd*f**3*r - 528*D1*Ddd*f**3*s**2 + 1244*D1*Ddd*f**3*s - 518*D1*Ddd*f**3 - 220*D1*Ddd*f**2*r**2 - 1320*D1*Ddd*f**2*r*s + 770*D1*Ddd*f**2*r - 484*D1*Ddd*f**2*s**2 + 814*D1*Ddd*f**2*s - 297*D1*Ddd*f**2 + 2992*D1*Ddd*f*g2*r**2 + 3872*D1*Ddd*f*g2*r*s - 3432*D1*Ddd*f*g2*r - 968*D1*Ddd*f*g2*s + 748*D1*Ddd*f*g2 - 11*D1*bd1*(D1*(f**2*(68*r**2 + r*(8*s - 86) - 60*s**2 + 18*s + 27) - 2*f*(28*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 40*K*r**2 + 32*K*r*s - 48*K*r - 12*K*s + 16*K + 12*fd*(2*r**2 - 12*r*s + 5*r - 14*s**2 + 17*s - 4) - 119*r**2 - 106*r*s + 136*r + 5*s**2 + 44*s - 53) + 4*fd*(K*(34*r**2 + r*(44*s - 30) - 12*s + 1) - 63*r**2 + r*(59 - 102*s) - 29*s**2 + 41*s - 1) - 56*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 56*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*(3*f**2*(16*r**2 + r*(24 - 96*s) - 112*s**2 + 120*s - 27) + f*(-4*K*(68*r**2 + 88*r*s - 91*r - 31*s + 23) + 504*r**2 + 816*r*s - 770*r + 232*s**2 - 530*s + 266) - 56*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 1848*Dd**2*K*f**2*r**2 + 1056*Dd**2*K*f**2*r*s + 396*Dd**2*K*f**2*r - 264*Dd**2*K*f**2*s + 176*Dd**2*K*f**2 - 3048*Dd**2*f**3*r**2 - 8592*Dd**2*f**3*r*s + 5820*Dd**2*f**3*r - 1584*Dd**2*f**3*s**2 + 3732*Dd**2*f**3*s - 1696*Dd**2*f**3 - 660*Dd**2*f**2*r**2 - 3960*Dd**2*f**2*r*s + 2310*Dd**2*f**2*r - 1452*Dd**2*f**2*s**2 + 2442*Dd**2*f**2*s - 902*Dd**2*f**2 + 8976*Dd**2*f*g2*r**2 + 11616*Dd**2*f*g2*r*s - 10296*Dd**2*f*g2*r - 2904*Dd**2*f*g2*s + 1936*Dd**2*f*g2))/(3003*d**2*k1*k3**4) + 20*D1**2*Pk1*Pk3*ct*k2*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k1*k3**2) - 2*D1**2*Pk1*Pk3*ct*k2*st**4*(-264*b1**2*(C - 1)*(D1*Dd*(2*f*(-4*r*s + 2*r + s) + fd*(8*r*s - 6*r - s + 1)) - D1*(D1*r*(2*fd - fdd)*(s - 1) + Ddd*f*(-4*r*s + 2*r + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 33*b1*(D1**2*(f*(8*bdd1*s*(-2*C*r + C + 2*r - 1) + fd*(8*r*s - 4*r + 18*s**2 - 18*s + 9) + fdd*(-8*r*s + 4*r - 18*s**2 + 18*s - 9)) + 2*fd**2*(r*(2 - 4*s) - s*(9*s - 9))) - 8*D1*bd1*(C - 1)*(D1*(2*f*s*(1 - 2*r) + fd*r*(4*s - 2) - fd*s + fd) + 2*Dd*f*(r*(8*s - 2) - 3*s + 1)) + 2*D1*f*(Dd*(f*(8*r*s - 4*r + 18*s**2 - 20*s + 9) - 4*fd*(2*s - 1)*(4*r + 9*s - 5)) + Ddd*f*(r*(4 - 8*s) - 18*s**2 + 20*s - 9)) - 2*Dd**2*f**2*(12*r*(2*s - 1) + 54*s**2 - 60*s + 13)) - f*(264*D1**2*bd1**2*s*(C - 1)*(2*r - 1) + D1**2*(f*(33*bdd1*s*(4*r + 9*s - 4) + 4*fd*(-20*C*s + r*(20*C - 8)*(3*s - 1) + 15*s**2 - 2*s + 5) - 2*fdd*(-20*C*s + r*(20*C - 8)*(3*s - 1) + 15*s**2 - 2*s + 5)) + 4*fd**2*(-10*C*(r*(6*s - 2) - 2*s + 1) + 8*r*(3*s - 1) - 15*s**2 + 2*s + 4)) - 33*D1*bd1*(D1*(f*s*(4*r + 9*s - 4) - 2*fd*(8*r*s - 2*r + 18*s**2 - 13*s + 2)) - 8*Dd*f*(r*(4*s - 1) + 9*s**2 - 7*s + 1)) + 4*D1*f*(2*Dd*(f*(r*(20*C - 8)*(2*s - 1) + 10*s**2 - s*(10*C + 6) + 5) + fd*(-5*C*(2*r*(12*s - 5) - 7*s + 3) + 4*r*(12*s - 5) - 30*s**2 + 11*s + 1)) + Ddd*f*(-r*(20*C - 8)*(2*s - 1) - 10*s**2 + s*(10*C + 6) - 5)) - 4*Dd**2*f**2*(10*C*(6*r*(2*s - 1) - 3*s + 2) - 24*r*(2*s - 1) + 30*s**2 - 18*s - 3)))/(231*d**2*k1*k3**2) + 2*D1**2*Pk1*Pk3*ct*k2*st**2*(-44*b1**2*(C - 1)*(D1*Dd*(13*f*(-4*r*s + 2*r + s) + 10*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(13*fd - 10*fdd)*(s - 1) + 10*Ddd*f*(4*r*s - 2*r - s)) + 10*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 11*b1*(D1**2*(4*C*f*(-10*bdd1*s*(2*r - 1) + fd*(10*r**2 - r*(6*s + 7) + 3*s + 5) - 2*fdd*(4*r**2 - 2*r*s - 3*r + s + 2)) - 8*C*fd**2*(4*r**2 - r*(2*s + 3) + s - 1) + 40*bdd1*f*s*(2*r - 1) - 20*f*fd*r**2 + 60*f*fd*r*s + 6*f*fd*s*(5*s - 7) + f*fdd*(16*r**2 + r*(2 - 52*s) - 30*s**2 + 38*s - 3) + 2*fd**2*(8*r**2 - 26*r*s + r - 15*s**2 + 19*s - 4)) - 4*D1*bd1*(C - 1)*(D1*(13*f*s*(1 - 2*r) + 10*fd*(4*r*s - 2*r - s + 1)) + 20*Dd*f*(r*(8*s - 2) - 3*s + 1)) + 2*D1*f*(Dd*(f*(2*C*(20*r**2 - 4*r*(3*s + 1) + 3*s + 5) - 20*r**2 - 5*r*(4 - 12*s) + 30*s**2 - 45*s + 10) + fd*(-4*C*(32*r**2 - 16*r*(s + 1) + 6*s + 1) + 64*r**2 - 208*r*s + 40*r - 120*s**2 + 162*s - 39)) + Ddd*f*(-4*C*(8*r**2 - 4*r*s - 2*r + s + 2) + 16*r**2 - 52*r*s + 18*r - 30*s**2 + 43*s - 11)) + 2*Dd**2*f**2*(C*(-96*r**2 + 24*r*(2*s + 1) - 12*s + 8) + 48*r**2 - 6*r*(26*s - 9) - 90*s**2 + 129*s - 41)) + f*(12*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd + 192*C*D1**2*f*fdd*r**2 - 128*C*D1**2*f*fdd*r + 64*C*D1**2*f*fdd + 384*C*D1**2*fd**2*r**2 - 256*C*D1**2*fd**2*r + 16*C*D1*Dd*f**2*r**2 - 8*C*D1*Dd*f**2*r + 4*C*D1*Dd*f**2 + 1536*C*D1*Dd*f*fd*r**2 - 896*C*D1*Dd*f*fd*r + 128*C*D1*Dd*f*fd + 256*C*D1*Ddd*f**2*r**2 - 128*C*D1*Ddd*f**2*r + 64*C*D1*Ddd*f**2 + 768*C*Dd**2*f**2*r**2 - 384*C*Dd**2*f**2*r - 440*D1**2*bd1**2*s*(C - 1)*(2*r - 1) - 11*D1**2*bdd1*f*(r**2*(16*C - 8) + r*(-8*C*s + 26*s - 8) + 15*s**2 - 18*s + 4) + 60*D1**2*f*fd*r**2 - 390*D1**2*f*fd*r*s + 90*D1**2*f*fd*r - 297*D1**2*f*fd*s**2 + 328*D1**2*f*fd*s - 79*D1**2*f*fd - 96*D1**2*f*fdd*r**2 + 294*D1**2*f*fdd*r*s - 34*D1**2*f*fdd*r + 297*D1**2*f*fdd*s**2 - 296*D1**2*f*fdd*s + 67*D1**2*f*fdd - 192*D1**2*fd**2*r**2 + 588*D1**2*fd**2*r*s - 68*D1**2*fd**2*r + 594*D1**2*fd**2*s**2 - 592*D1**2*fd**2*s + 98*D1**2*fd**2 + 80*D1*Dd*f**2*r**2 - 520*D1*Dd*f**2*r*s + 220*D1*Dd*f**2*r - 396*D1*Dd*f**2*s**2 + 526*D1*Dd*f**2*s - 178*D1*Dd*f**2 - 768*D1*Dd*f*fd*r**2 + 2352*D1*Dd*f*fd*r*s - 532*D1*Dd*f*fd*r + 2376*D1*Dd*f*fd*s**2 - 2666*D1*Dd*f*fd*s + 626*D1*Dd*f*fd - 128*D1*Ddd*f**2*r**2 + 392*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 396*D1*Ddd*f**2*s**2 - 494*D1*Ddd*f**2*s + 166*D1*Ddd*f**2 + 11*D1*bd1*(D1*(f*(r**2*(20*C - 10) - 2*r*(6*C*s - 15*s + 5) + 15*s**2 - 18*s + 5) + 2*fd*(-4*C*s + r**2*(16 - 32*C) + r*(4*C*(4*s + 3) - 52*s + 9) - 30*s**2 + 37*s - 9)) - 2*Dd*f*(4*C*s + r**2*(64*C - 32) - 2*r*(16*C*s + 4*C - 52*s + 17) + 60*s**2 - 79*s + 22)) - 384*Dd**2*f**2*r**2 + 1176*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 1188*Dd**2*f**2*s**2 - 1482*Dd**2*f**2*s + 394*Dd**2*f**2))/(231*d**2*k1*k3**2) + 2*D1**2*Pk1*Pk3*ct*k2*(22*D1**2*K*bdd1*f**2*r**2 - 44*D1**2*K*bdd1*f**2*r*s + 44*D1**2*K*bdd1*f**2*r + 308*D1**2*b2*f*fd*r**2 + 88*D1**2*b2*f*fd*r*s - 308*D1**2*b2*f*fd*r - 44*D1**2*b2*f*fd*s + 154*D1**2*b2*f*fd + 44*D1**2*b2*f*fdd*r**2 - 88*D1**2*b2*f*fdd*r*s - 44*D1**2*b2*f*fdd*r + 44*D1**2*b2*f*fdd*s + 22*D1**2*b2*f*fdd + 44*D1**2*b2*fd**2*r**2 - 88*D1**2*b2*fd**2*r*s - 44*D1**2*b2*fd**2*r + 44*D1**2*b2*fd**2*s + 22*D1**2*bd1**2*(f**2*(r*(8*s - 1) + 42*s**2 - 27*s + 4) - f*(18*K*r**2 + r*(-6*K*s + 3*K + 16*s - 17) - 14*s**2 + 9*s + 5) + 14*g2*s*(2*r - 1)) + 154*D1**2*bd2*f**2*r**2 + 44*D1**2*bd2*f**2*r*s - 44*D1**2*bd2*f**2*r + 88*D1**2*bd2*f*fd*r**2 - 176*D1**2*bd2*f*fd*r*s + 44*D1**2*bd2*f*fd*r + 44*D1**2*bd2*f*fd*s - 44*D1**2*bd2*f*fd + 10*D1**2*bdd1*f**3*r**2 + 264*D1**2*bdd1*f**3*r*s - 176*D1**2*bdd1*f**3*r + 396*D1**2*bdd1*f**3*s**2 - 396*D1**2*bdd1*f**3*s + 198*D1**2*bdd1*f**3 - 22*D1**2*bdd1*f**2*r**2 + 154*D1**2*bdd1*f**2*r*s - 154*D1**2*bdd1*f**2*r + 209*D1**2*bdd1*f**2*s**2 - 418*D1**2*bdd1*f**2*s + 209*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r**2 - 132*D1**2*bdd1*f*g2*r*s + 22*D1**2*bdd2*f**2*r**2 - 44*D1**2*bdd2*f**2*r*s + 44*D1**2*bdd2*f**2*r - 308*D1**2*f**2*gd2*r**2 - 88*D1**2*f**2*gd2*r*s + 88*D1**2*f**2*gd2*r - 44*D1**2*f**2*gdd2*r**2 + 88*D1**2*f**2*gdd2*r*s - 88*D1**2*f**2*gdd2*r - 616*D1**2*f*fd*g2*r**2 - 176*D1**2*f*fd*g2*r*s + 616*D1**2*f*fd*g2*r + 88*D1**2*f*fd*g2*s - 308*D1**2*f*fd*g2 - 176*D1**2*f*fd*gd2*r**2 + 352*D1**2*f*fd*gd2*r*s - 88*D1**2*f*fd*gd2*r - 88*D1**2*f*fd*gd2*s + 88*D1**2*f*fd*gd2 - 88*D1**2*f*fdd*g2*r**2 + 176*D1**2*f*fdd*g2*r*s + 88*D1**2*f*fdd*g2*r - 88*D1**2*f*fdd*g2*s - 44*D1**2*f*fdd*g2 - 88*D1**2*fd**2*g2*r**2 + 176*D1**2*fd**2*g2*r*s + 88*D1**2*fd**2*g2*r - 88*D1**2*fd**2*g2*s + 616*D1*Dd*b2*f**2*r**2 + 176*D1*Dd*b2*f**2*r*s - 396*D1*Dd*b2*f**2*r - 44*D1*Dd*b2*f**2*s + 154*D1*Dd*b2*f**2 + 352*D1*Dd*b2*f*fd*r**2 - 704*D1*Dd*b2*f*fd*r*s - 88*D1*Dd*b2*f*fd*r + 264*D1*Dd*b2*f*fd*s - 44*D1*Dd*b2*f*fd + 176*D1*Dd*bd2*f**2*r**2 - 352*D1*Dd*bd2*f**2*r*s + 220*D1*Dd*bd2*f**2*r + 44*D1*Dd*bd2*f**2*s - 44*D1*Dd*bd2*f**2 - 1232*D1*Dd*f**2*g2*r**2 - 352*D1*Dd*f**2*g2*r*s + 792*D1*Dd*f**2*g2*r + 88*D1*Dd*f**2*g2*s - 308*D1*Dd*f**2*g2 - 352*D1*Dd*f**2*gd2*r**2 + 704*D1*Dd*f**2*gd2*r*s - 440*D1*Dd*f**2*gd2*r - 88*D1*Dd*f**2*gd2*s + 88*D1*Dd*f**2*gd2 - 704*D1*Dd*f*fd*g2*r**2 + 1408*D1*Dd*f*fd*g2*r*s + 176*D1*Dd*f*fd*g2*r - 528*D1*Dd*f*fd*g2*s + 88*D1*Dd*f*fd*g2 + 88*D1*Ddd*b2*f**2*r**2 - 176*D1*Ddd*b2*f**2*r*s + 44*D1*Ddd*b2*f**2*r + 44*D1*Ddd*b2*f**2*s + 22*D1*Ddd*b2*f**2 - 176*D1*Ddd*f**2*g2*r**2 + 352*D1*Ddd*f**2*g2*r*s - 88*D1*Ddd*f**2*g2*r - 88*D1*Ddd*f**2*g2*s - 44*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-2*f**3*(65*r**2 + 44*r*(3*s - 2) + 198*s**2 - 198*s + 99) + f**2*(60*fd*r**2 + 36*fd*r*(44*s - 25) + 44*fd*(54*s**2 - 60*s + 13) + r**2*(154*K - 154) + r*(44*K + 22)*(s - 1) - 209*(s - 1)**2) + 22*f*(fd*(2*K*(2*r**2 - 4*r*s + r + s - 1) - 4*r**2 + 4*r*(7*s - 3) + 38*s**2 - 45*s + 7) + 2*r*(g2*(3*r - 8*s) + 3*gd2*(6*r - 2*s + 1))) + 132*fd*g2*(6*r**2 - 2*r*(s + 3) + s)) + 2*Dd*f*(2*f**2*(20*r**2 + 528*r*s - 313*r + 792*s**2 - 858*s + 242) + 11*f*(2*K*(4*r**2 + r*(5 - 8*s) + s - 1) - 8*r**2 + 8*r*(7*s - 5) + 76*s**2 - 121*s + 45) + 66*g2*(24*r**2 - 4*r*(2*s + 1) + s))) + 264*Dd**2*b2*f**2*r**2 - 528*Dd**2*b2*f**2*r*s + 132*Dd**2*b2*f**2*r + 132*Dd**2*b2*f**2*s - 88*Dd**2*b2*f**2 - 528*Dd**2*f**2*g2*r**2 + 1056*Dd**2*f**2*g2*r*s - 264*Dd**2*f**2*g2*r - 264*Dd**2*f**2*g2*s + 176*Dd**2*f**2*g2 - 154*b1**3*(K - 1)*(2*D1*Dd*(r*(2 - 4*s) + s) + D1*Ddd*(r*(4*s - 2) - s) + Dd**2*(6*r*(2*s - 1) - 3*s + 2)) + 11*b1**2*(D1**2*(-14*bdd1*(K - 1)*(r*(3*s - 1) - s) + 2*fd**2*(r*(8*s - 7) + 42*s**2 - 61*s + 19) - fd*(2*K*(r - 1)*(3*r - 8*s - 3) + 2*f*(8*r*s + r + 42*s**2 - 61*s + 28) - 18*r*s + 6*r + 14*s**2 - 16*s - 3) + fdd*(-6*K*(r - 1)*(3*r - s - 3) + 2*f*(r*(8*s - 7) + 42*s**2 - 61*s + 32) - 16*r*s - 18*r + 14*s**2 + 6*s + 9) - 14*r*(4*gd2 - 2*gdd2)*(s - 1)) - 14*D1*bd1*(K - 1)*(2*D1*(-3*r*s + r + s) + Dd*(2*r*(12*s - 5) - 7*s + 3)) - 2*D1*(Dd*(2*f**2*(r*(8*s - 4) + 42*s**2 - 44*s + 21) + f*(K*(12*r**2 - 32*r*s + 10*r + 8*s + 3) + fd*(r*(44 - 64*s) - 336*s**2 + 420*s - 129) - 36*r*s + 18*r + 28*s**2 - 19*s + 14) + fd*(3*K*(24*r**2 - 4*r*(2*s + 7) + 5*s + 4) + 4*r*(16*s + 5) - 56*s**2 + 8*s - 3) - 28*g2*(r*(2 - 4*s) + s) - 14*gd2*(r*(8*s - 6) - s + 1)) + Ddd*(-2*f**2*(r*(8*s - 4) + 42*s**2 - 44*s + 21) + f*(3*K*(12*r**2 - 4*r*(s + 1) + s + 3) + 16*r*(2*s - 1) - 28*s**2 + 20*s - 14) + 14*g2*(r*(2 - 4*s) + s))) + 2*Dd**2*(f**2*(24*r*(2*s - 1) + 252*s**2 - 264*s + 50) + f*(K*(-108*r**2 + 36*r*(s + 1) - 9*s + 6) - 96*r*s + 48*r + 84*s**2 - 60*s - 2) + 14*g2*(6*r*(2*s - 1) - 3*s + 2))) + b1*(-154*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) - 2*s + 1) + 11*D1**2*bdd1*(2*f**2*(r*(8*s - 1) + 42*s**2 - 27*s + 10) + f*(-36*K*r**2 + 2*r*(6*K*s - 3*K - 16*s + 17) + 28*s**2 - 18*s + 5) + 28*g2*s*(2*r - 1)) - 2*D1**2*(f**2*(fd*(195*r**2 + 18*r*(22*s - 17) + 594*s**2 - 726*s + 362) - fdd*(15*r**2 + 6*r*(66*s - 31) + 594*s**2 - 726*s + 302)) - f*(2*fd**2*(15*r**2 + 6*r*(66*s - 31) + 594*s**2 - 726*s + 187) + 11*fd*(K*(14*r**2 + 2*r*(2*s - 7) - 2*s + 7) - 14*r**2 + 2*r*(s + 7) - 19*s**2 - s - 7) + 11*fdd*(K*(2*r**2 - 4*r*s - 2*r + 2*s + 1) - 2*r**2 + 14*r*s + 2*r + 19*s**2 - 7*s - 1) + 22*r*(gd2*(3*r - 8*s + 8) + 3*gdd2*(3*r - s + 1))) - 11*fd**2*(r**2*(2*K - 2) - 2*r*(2*K*s + K - 7*s - 1) + s*(2*K + 19*s - 7)) - 22*fd*(g2*(r - 1)*(3*r - 8*s - 3) + 3*gd2*(6*r**2 - 2*r*s - 5*r + s - 1)) - 66*fdd*g2*(r - 1)*(3*r - s - 3)) - 11*D1*bd1*(D1*(2*f**2*(r*(8*s - 9) + 42*s**2 - 27*s + 14) + f*(12*K*r**2 + fd*(r*(32 - 64*s) - 336*s**2 + 352*s - 54) - 4*r*(8*K*s - 4*K + 9*s - 3) + 28*s**2 + 6*s + 17) + 2*fd*(3*K*(12*r**2 - r*(4*s + 11) + 2*s - 1) + 32*r*s + r - 28*s**2 + 3*s + 3) + 56*g2*s*(2*r - 1) + 28*gd2*(r*(2 - 4*s) + s - 1)) - 2*Dd*(f**2*(4*r*(16*s - 5) + 336*s**2 - 284*s + 55) + f*(K*(-144*r**2 + 48*r*s + 12*r - 6*s + 3) - 128*r*s + 100*r + 112*s**2 - 76*s + 1) + 28*g2*(r*(8*s - 2) - 3*s + 1))) - 2*D1*(Dd*(f**3*(260*r**2 + r*(528*s - 394) + 792*s**2 - 924*s + 461) - f**2*(11*K*(28*r**2 + 2*r*(4*s - 9) - 2*s + 7) + 6*fd*(20*r**2 + 3*r*(176*s - 87) + 792*s**2 - 946*s + 273) - 308*r**2 + 44*r*(s + 3) - 418*s**2 + 407*s - 286) - 22*f*(fd*(K*(8*r**2 - 2*r*(8*s + 1) + 6*s - 1) - 8*r**2 + 56*r*s - 8*r + 76*s**2 - 59*s + 6) + g2*(12*r**2 - 32*r*s + 10*r + 8*s + 3) + 3*gd2*(24*r**2 - 8*r*s + s - 1)) - 66*fd*g2*(24*r**2 - 4*r*(2*s + 7) + 5*s + 4)) - Ddd*f*(f**2*(20*r**2 + r*(528*s - 274) + 792*s**2 - 924*s + 401) + 11*f*(K*(4*r**2 + r*(2 - 8*s) + 2*s + 1) - 4*r**2 + 4*r*(7*s - 3) + 38*s**2 - 45*s + 18) + 66*g2*(12*r**2 - 4*r*(s + 1) + s + 3))) + 2*Dd**2*f*(6*f**2*(10*r**2 + r*(264*s - 137) + 396*s**2 - 462*s + 110) + 11*f*(2*K*(6*r**2 + r*(3 - 12*s) + 3*s - 2) - 12*r**2 + 12*r*(7*s - 3) + 114*s**2 - 135*s + 33) + 66*g2*(36*r**2 - 12*r*(s + 1) + 3*s - 2))))/(231*d**2*k1*k3**2) + 8*D1**2*Pk1*Pk3*ct*st**4*(-2*D1**2*bd1**2*f*s**2 + 2*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s))) + b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)))/(7*d**2*k1*k2) + D1**2*Pk1*Pk3*ct*st**2*(D1*f*s*(58*D1*bd1**2*s + D1*bd1*(f*r*(16*C - 8) + 17*f*s + fd*(22 - 44*s)) - 11*D1*bdd1*f*s + 44*Dd*bd1*f*(1 - 2*s)) + b1**2*(-D1**2*(23*fd - 29*fdd)*(s - 1)**2 + 2*D1*(-23*Dd*f*(2*s**2 - 2*s + 1) + 58*Dd*fd*(2*s**2 - 3*s + 1) + 29*Ddd*f*(2*s**2 - 2*s + 1)) + 58*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(fd*(r*(16*C - 8)*(2*s - 1) + 34*s**2 - s*(16*C + 26) + 17) - 11*fdd*(2*s**2 - 2*s + 1) + s**2*(-46*bd1 + 58*bdd1)) + fd*s*(116*bd1 - 22*fd)*(s - 1)) + 2*D1*f*(Dd*f*(r*(16*C - 8)*(2*s - 1) + 34*s**2 - s*(8*C + 30) + 17) + 2*Dd*(2*s - 1)*(58*bd1*s + fd*(11 - 22*s)) - 11*Ddd*f*(2*s**2 - 2*s + 1)) - 22*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k1*k2) - 2*D1**2*Pk1*Pk3*ct*(-D1*f*(28*D1*bd1**2*s**2 + D1*bdd1*f*s*(r*(4 - 8*C) + 19*s) + bd1*(D1*f*s*(r*(8*C - 4) - 19*s) + D1*fd*(r*(4 - 8*C)*(4*s - 1) + 2*s*(4*C + 38*s - 21)) - Dd*f*r*(16*C - 8)*(4*s - 1) + 8*Dd*f*s*(C + 19*s - 10))) + 14*b1**2*(D1**2*(fd - fdd)*(s - 1)**2 + 2*D1*(Dd*(2*f*s**2 - 2*f*s + f - 4*fd*s**2 + 6*fd*s - 2*fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) - b1*(D1**2*(f*(fd*(-8*C*s + r*(8*C - 4)*(2*s - 1) - 38*s**2 + 42*s - 19) + fdd*(8*C*s - r*(8*C - 4)*(2*s - 1) + 38*s**2 - 42*s + 19) + s**2*(-28*bd1 + 28*bdd1)) + 2*fd*(28*bd1*s*(s - 1) + fd*(4*C*(-2*r*s + r + s - 1) + 4*r*s - 2*r + 19*s**2 - 21*s + 2))) + 2*D1*f*(Dd*(f*(-4*C*s + r*(8*C - 4)*(2*s - 1) - 38*s**2 + 40*s - 19) + (8*s - 4)*(14*bd1*s + fd*(-8*C*r + 3*C + 4*r + 19*s - 11))) + Ddd*f*(-r*(8*C - 4)*(2*s - 1) + 38*s**2 + s*(4*C - 40) + 19)) + 2*Dd**2*f**2*(-4*C*(6*r*(2*s - 1) - 3*s + 2) + 12*r*(2*s - 1) + 114*s**2 - 120*s + 23)))/(21*d**2*k1*k2) - 2*D1**2*Pk1*Pk3*ct*k2**3*st**4*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 - 147*D1**2*f**2*fd*r**2 + 98*D1**2*f**2*fd*r - 49*D1**2*f**2*fd + 123*D1**2*f**2*fdd*r**2 - 82*D1**2*f**2*fdd*r + 41*D1**2*f**2*fdd + 246*D1**2*f*fd**2*r**2 - 164*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r - 196*D1*Dd*f**3*r**2 + 98*D1*Dd*f**3*r - 49*D1*Dd*f**3 + 984*D1*Dd*f**2*fd*r**2 - 574*D1*Dd*f**2*fd*r + 82*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 + 164*D1*Ddd*f**3*r**2 - 82*D1*Ddd*f**3*r + 41*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r + 492*Dd**2*f**3*r**2 - 246*Dd**2*f**3*r)/(231*d**2*k1**3*k3**2) + D1**2*Pk1*Pk3*ct*k2**3*st**2*(D1*f*r*(22*D1*bd1**2*(6*f + 5)*(r - 1) - D1*bdd1*f*r*(126*f + 121) + bd1*(3*D1*f*r*(18*f + 55) + D1*fd*(-252*f*(3*r - 1) - 484*r + 242) - 2*Dd*f*(126*f + 121)*(4*r - 1))) - 11*b1**2*(D1**2*r**2*(-12*fd**2 + fd*(36*f + 3) - fdd*(12*f + 5)) + D1*(Dd*(18*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(12 - 96*fd) + r*(24*fd - 6) + 3) + 10*fd*r*(1 - 4*r)) - Ddd*f*(6*f + 5)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(6*f + 5)*(2*r - 1)) + b1*(11*D1**2*bdd1*f*(6*f + 5)*(2*r**2 - 2*r + 1) + 162*D1**2*f**2*fd*r**2 - 108*D1**2*f**2*fd*r + 54*D1**2*f**2*fd - 378*D1**2*f**2*fdd*r**2 + 252*D1**2*f**2*fdd*r - 126*D1**2*f**2*fdd - 756*D1**2*f*fd**2*r**2 + 504*D1**2*f*fd**2*r + 330*D1**2*f*fd*r**2 - 330*D1**2*f*fd*r + 165*D1**2*f*fd - 242*D1**2*f*fdd*r**2 + 242*D1**2*f*fdd*r - 121*D1**2*f*fdd - 242*D1**2*fd**2*r**2 + 242*D1**2*fd**2*r + 216*D1*Dd*f**3*r**2 - 108*D1*Dd*f**3*r + 54*D1*Dd*f**3 - 3024*D1*Dd*f**2*fd*r**2 + 1764*D1*Dd*f**2*fd*r - 252*D1*Dd*f**2*fd + 660*D1*Dd*f**2*r**2 - 330*D1*Dd*f**2*r + 165*D1*Dd*f**2 - 1936*D1*Dd*f*fd*r**2 + 1452*D1*Dd*f*fd*r - 242*D1*Dd*f*fd - 504*D1*Ddd*f**3*r**2 + 252*D1*Ddd*f**3*r - 126*D1*Ddd*f**3 - 484*D1*Ddd*f**2*r**2 + 242*D1*Ddd*f**2*r - 121*D1*Ddd*f**2 - 11*D1*bd1*(D1*(18*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(6 - 48*fd) + r*(24*fd - 6) + 3) + 10*fd*r*(1 - 2*r)) - 2*Dd*f*(6*f + 5)*(8*r**2 - 6*r + 1)) - 1512*Dd**2*f**3*r**2 + 756*Dd**2*f**3*r - 1452*Dd**2*f**2*r**2 + 726*Dd**2*f**2*r))/(231*d**2*k1**3*k3**2) + D1**2*Pk1*Pk3*ct*k2*st**2*(D1*f*r*(10*D1*bd1**2*(r - 1) + D1*bd1*(15*f*r + fd*(22 - 44*r)) - 11*D1*bdd1*f*r + 22*Dd*bd1*f*(1 - 4*r)) + b1**2*(D1**2*r**2*(-3*fd + 5*fdd) + D1*(-3*Dd*f*(4*r**2 - 2*r + 1) + 10*Dd*fd*r*(4*r - 1) + 5*Ddd*f*(4*r**2 - 2*r + 1)) + 30*Dd**2*f*r*(2*r - 1)) + b1*(5*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 30*D1**2*f*fd*r**2 - 30*D1**2*f*fd*r + 15*D1**2*f*fd - 22*D1**2*f*fdd*r**2 + 22*D1**2*f*fdd*r - 11*D1**2*f*fdd - 22*D1**2*fd**2*r**2 + 22*D1**2*fd**2*r + 60*D1*Dd*f**2*r**2 - 30*D1*Dd*f**2*r + 15*D1*Dd*f**2 - 176*D1*Dd*f*fd*r**2 + 132*D1*Dd*f*fd*r - 22*D1*Dd*f*fd - 44*D1*Ddd*f**2*r**2 + 22*D1*Ddd*f**2*r - 11*D1*Ddd*f**2 + D1*bd1*(D1*f*(-6*r**2 + 6*r - 3) + 10*D1*fd*r*(2*r - 1) + 10*Dd*f*(8*r**2 - 6*r + 1)) - 132*Dd**2*f**2*r**2 + 66*Dd**2*f**2*r))/(21*d**2*k1**3) - 2*D1**2*Pk1*Pk3*ct*k2*(2*D1**2*bd1**2*f*r**2*(3*f + 8) - 2*D1*b1*r*(D1*bd1**2*(3*f + 14)*(3*r - 2) - D1*bdd1*f*r*(3*f + 8) - bd1*(3*D1*f*r*(3*f + 4) + 2*D1*fd*(6*f*r - 3*f + 8*r - 8) + 2*Dd*f*(3*f + 8)*(4*r - 1))) + b1**3*(D1**2*r**2*(13*fd - 3*fdd) + D1*Dd*(13*f*(4*r**2 - 2*r + 1) - r**2*(24*fd - 112) + r*(6*fd - 56) + 28) - D1*Ddd*(3*f + 14)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(3*f + 14)*(2*r - 1)) + b1**2*(-D1**2*bdd1*(3*f + 14)*(3*r**2 - 2*r + 1) + 18*D1**2*f*fd*r**2 - 18*D1**2*f*fd*r + 9*D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 12*D1**2*fd*r**2 - 24*D1**2*fd*r + 12*D1**2*fd + 8*D1**2*fdd*r**2 - 16*D1**2*fdd*r + 8*D1**2*fdd + 36*D1*Dd*f**2*r**2 - 18*D1*Dd*f**2*r + 9*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd + 48*D1*Dd*f*r**2 - 24*D1*Dd*f*r + 12*D1*Dd*f + 64*D1*Dd*fd*r**2 - 80*D1*Dd*fd*r + 16*D1*Dd*fd + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 32*D1*Ddd*f*r**2 - 16*D1*Ddd*f*r + 8*D1*Ddd*f + D1*bd1*(D1*(13*f*(3*r**2 - 2*r + 1) + r**2*(84 - 18*fd) + r*(6*fd - 56) + 28) - 2*Dd*(3*f + 14)*(12*r**2 - 7*r + 1)) + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r + 96*Dd**2*f*r**2 - 48*Dd**2*f*r))/(21*d**2*k1**3) - D1**2*Pk1*Pk3*f*k1**4*k2**2*st**4*(48*C - 24)*(11*D1**2*bd1*f*(r + s - 1)**2 + 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 11*D1*b1*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**8) - D1**2*Pk1*Pk3*f*k1**4*st**4*(32*C - 16)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4))/(77*d**2*k3**6) - D1**2*Pk1*Pk3*f*k1**4*st**4*(16*C - 8)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + 2*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1))/(231*d**2*k2**2*k3**4) + D1**2*Pk1*Pk3*f*k1**2*(8*C - 4)*(D1**2*(f*(fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + 2*D1*f*(Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(6*s**2 - 5*s + 1) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1))/(7*d**2*k2**2*k3**2) - 20*D1**2*Pk1*Pk3*f*k2**6*st**6*(1131*D1**2*b1*f*fd*r**2 + 1131*D1**2*b1*f*fd*r*s - 754*D1**2*b1*f*fd*r - 1209*D1**2*b1*f*fdd*r**2 - 1209*D1**2*b1*f*fdd*r*s + 806*D1**2*b1*f*fdd*r - 2418*D1**2*b1*fd**2*r**2 - 2418*D1**2*b1*fd**2*r*s + 1612*D1**2*b1*fd**2*r - 403*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 252*D1**2*f**2*fd*r**2 + 252*D1**2*f**2*fd*r*s - 252*D1**2*f**2*fd*r - 63*D1**2*f**2*fd*s + 63*D1**2*f**2*fd - 204*D1**2*f**2*fdd*r**2 - 204*D1**2*f**2*fdd*r*s + 204*D1**2*f**2*fdd*r + 51*D1**2*f**2*fdd*s - 51*D1**2*f**2*fdd - 612*D1**2*f*fd**2*r**2 - 612*D1**2*f*fd**2*r*s + 612*D1**2*f*fd**2*r + 153*D1**2*f*fd**2*s - 102*D1**2*f*fd**2 + 1508*D1*Dd*b1*f**2*r**2 + 1508*D1*Dd*b1*f**2*r*s - 1508*D1*Dd*b1*f**2*r - 377*D1*Dd*b1*f**2*s + 377*D1*Dd*b1*f**2 - 9672*D1*Dd*b1*f*fd*r**2 - 9672*D1*Dd*b1*f*fd*r*s + 8060*D1*Dd*b1*f*fd*r + 1209*D1*Dd*b1*f*fd*s - 806*D1*Dd*b1*f*fd + 252*D1*Dd*f**3*r**2 + 252*D1*Dd*f**3*r*s - 252*D1*Dd*f**3*r - 63*D1*Dd*f**3*s + 63*D1*Dd*f**3 - 1632*D1*Dd*f**2*fd*r**2 - 1632*D1*Dd*f**2*fd*r*s + 1632*D1*Dd*f**2*fd*r + 408*D1*Dd*f**2*fd*s - 306*D1*Dd*f**2*fd - 1612*D1*Ddd*b1*f**2*r**2 - 1612*D1*Ddd*b1*f**2*r*s + 1612*D1*Ddd*b1*f**2*r + 403*D1*Ddd*b1*f**2*s - 403*D1*Ddd*b1*f**2 - 204*D1*Ddd*f**3*r**2 - 204*D1*Ddd*f**3*r*s + 204*D1*Ddd*f**3*r + 51*D1*Ddd*f**3*s - 51*D1*Ddd*f**3 + 13*D1*bd1*f*(D1*(29*f*(r - 1)*(r + s - 1) - 31*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 31*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 4836*Dd**2*b1*f**2*r**2 - 4836*Dd**2*b1*f**2*r*s + 4836*Dd**2*b1*f**2*r + 1209*Dd**2*b1*f**2*s - 806*Dd**2*b1*f**2 - 612*Dd**2*f**3*r**2 - 612*Dd**2*f**3*r*s + 612*Dd**2*f**3*r + 153*Dd**2*f**3*s - 102*Dd**2*f**3)/(9009*d**2*k1**2*k3**6) - D1**2*Pk1*Pk3*k1**6*st**2*(8*C - 4)*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 66*D1**2*b1*f*fd*s + 33*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 51*D1**2*f**2*fd*r**2 + 102*D1**2*f**2*fd*r*s - 68*D1**2*f**2*fd*r + 51*D1**2*f**2*fd*s**2 - 68*D1**2*f**2*fd*s + 34*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 198*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2*s**2 - 198*D1*Dd*b1*f**2*s + 99*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 68*D1*Dd*f**3*r**2 + 136*D1*Dd*f**3*r*s - 102*D1*Dd*f**3*r + 68*D1*Dd*f**3*s**2 - 102*D1*Dd*f**3*s + 51*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3)/(231*d**2*k3**8) - 8*D1**2*Pk1*Pk3*k1**6*(5*D1**2*K*b1**2*fd*r**2 + 10*D1**2*K*b1**2*fd*r*s + 5*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r**2 - 12*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 + 8*D1**2*K*b1*f*fd*r**2 + 16*D1**2*K*b1*f*fd*r*s - 8*D1**2*K*b1*f*fd*r + 8*D1**2*K*b1*f*fd*s**2 - 8*D1**2*K*b1*f*fd*s + 4*D1**2*K*b1*f*fd - 10*D1**2*K*b1*f*fdd*r**2 - 20*D1**2*K*b1*f*fdd*r*s + 10*D1**2*K*b1*f*fdd*r - 10*D1**2*K*b1*f*fdd*s**2 + 10*D1**2*K*b1*f*fdd*s - 5*D1**2*K*b1*f*fdd - 10*D1**2*K*b1*fd**2*r**2 - 20*D1**2*K*b1*fd**2*r*s + 10*D1**2*K*b1*fd**2*r - 10*D1**2*K*b1*fd**2*s**2 + 10*D1**2*K*b1*fd**2*s - 12*D1**2*K*bd1**2*f*(r + s - 1)**2 - 10*D1**2*b1*f*gd2*r**2 - 20*D1**2*b1*f*gd2*r*s + 20*D1**2*b1*f*gd2*r - 10*D1**2*b1*f*gd2*s**2 + 20*D1**2*b1*f*gd2*s - 10*D1**2*b1*f*gd2 + 12*D1**2*b1*f*gdd2*r**2 + 24*D1**2*b1*f*gdd2*r*s - 24*D1**2*b1*f*gdd2*r + 12*D1**2*b1*f*gdd2*s**2 - 24*D1**2*b1*f*gdd2*s + 12*D1**2*b1*f*gdd2 - 10*D1**2*b1*fd*g2*r**2 - 20*D1**2*b1*fd*g2*r*s - 10*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r**2 + 48*D1**2*b1*fd*gd2*r*s - 24*D1**2*b1*fd*gd2*r + 24*D1**2*b1*fd*gd2*s**2 - 24*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r**2 + 24*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(12*K*b1 + 5*K*f - 12*g2) - 8*D1**2*f**2*gd2*r**2 - 16*D1**2*f**2*gd2*r*s + 16*D1**2*f**2*gd2*r - 8*D1**2*f**2*gd2*s**2 + 16*D1**2*f**2*gd2*s - 8*D1**2*f**2*gd2 + 10*D1**2*f**2*gdd2*r**2 + 20*D1**2*f**2*gdd2*r*s - 20*D1**2*f**2*gdd2*r + 10*D1**2*f**2*gdd2*s**2 - 20*D1**2*f**2*gdd2*s + 10*D1**2*f**2*gdd2 - 16*D1**2*f*fd*g2*r**2 - 32*D1**2*f*fd*g2*r*s + 16*D1**2*f*fd*g2*r - 16*D1**2*f*fd*g2*s**2 + 16*D1**2*f*fd*g2*s - 8*D1**2*f*fd*g2 + 40*D1**2*f*fd*gd2*r**2 + 80*D1**2*f*fd*gd2*r*s - 60*D1**2*f*fd*gd2*r + 40*D1**2*f*fd*gd2*s**2 - 60*D1**2*f*fd*gd2*s + 20*D1**2*f*fd*gd2 + 20*D1**2*f*fdd*g2*r**2 + 40*D1**2*f*fdd*g2*r*s - 20*D1**2*f*fdd*g2*r + 20*D1**2*f*fdd*g2*s**2 - 20*D1**2*f*fdd*g2*s + 10*D1**2*f*fdd*g2 + 20*D1**2*fd**2*g2*r**2 + 40*D1**2*fd**2*g2*r*s - 20*D1**2*fd**2*g2*r + 20*D1**2*fd**2*g2*s**2 - 20*D1**2*fd**2*g2*s + 20*D1*Dd*K*b1**2*f*r**2 + 40*D1*Dd*K*b1**2*f*r*s - 30*D1*Dd*K*b1**2*f*r + 20*D1*Dd*K*b1**2*f*s**2 - 30*D1*Dd*K*b1**2*f*s + 15*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 96*D1*Dd*K*b1**2*fd*r*s + 36*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 36*D1*Dd*K*b1**2*fd*s + 16*D1*Dd*K*b1*f**2*r**2 + 32*D1*Dd*K*b1*f**2*r*s - 24*D1*Dd*K*b1*f**2*r + 16*D1*Dd*K*b1*f**2*s**2 - 24*D1*Dd*K*b1*f**2*s + 12*D1*Dd*K*b1*f**2 - 80*D1*Dd*K*b1*f*fd*r**2 - 160*D1*Dd*K*b1*f*fd*r*s + 100*D1*Dd*K*b1*f*fd*r - 80*D1*Dd*K*b1*f*fd*s**2 + 100*D1*Dd*K*b1*f*fd*s - 30*D1*Dd*K*b1*f*fd - 40*D1*Dd*b1*f*g2*r**2 - 80*D1*Dd*b1*f*g2*r*s + 60*D1*Dd*b1*f*g2*r - 40*D1*Dd*b1*f*g2*s**2 + 60*D1*Dd*b1*f*g2*s - 30*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 192*D1*Dd*b1*f*gd2*r*s - 168*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 168*D1*Dd*b1*f*gd2*s + 72*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 192*D1*Dd*b1*fd*g2*r*s - 72*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 72*D1*Dd*b1*fd*g2*s - 32*D1*Dd*f**2*g2*r**2 - 64*D1*Dd*f**2*g2*r*s + 48*D1*Dd*f**2*g2*r - 32*D1*Dd*f**2*g2*s**2 + 48*D1*Dd*f**2*g2*s - 24*D1*Dd*f**2*g2 + 80*D1*Dd*f**2*gd2*r**2 + 160*D1*Dd*f**2*gd2*r*s - 140*D1*Dd*f**2*gd2*r + 80*D1*Dd*f**2*gd2*s**2 - 140*D1*Dd*f**2*gd2*s + 60*D1*Dd*f**2*gd2 + 160*D1*Dd*f*fd*g2*r**2 + 320*D1*Dd*f*fd*g2*r*s - 200*D1*Dd*f*fd*g2*r + 160*D1*Dd*f*fd*g2*s**2 - 200*D1*Dd*f*fd*g2*s + 60*D1*Dd*f*fd*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 48*D1*Ddd*K*b1**2*f*r*s + 36*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 36*D1*Ddd*K*b1**2*f*s - 18*D1*Ddd*K*b1**2*f - 20*D1*Ddd*K*b1*f**2*r**2 - 40*D1*Ddd*K*b1*f**2*r*s + 30*D1*Ddd*K*b1*f**2*r - 20*D1*Ddd*K*b1*f**2*s**2 + 30*D1*Ddd*K*b1*f**2*s - 15*D1*Ddd*K*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 96*D1*Ddd*b1*f*g2*r*s - 72*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 72*D1*Ddd*b1*f*g2*s + 36*D1*Ddd*b1*f*g2 + 40*D1*Ddd*f**2*g2*r**2 + 80*D1*Ddd*f**2*g2*r*s - 60*D1*Ddd*f**2*g2*r + 40*D1*Ddd*f**2*g2*s**2 - 60*D1*Ddd*f**2*g2*s + 30*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(2*K*f**2*(r + s - 1) + f*(5*K*(b1*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 5*g2*(r + s - 1) + 12*gd2*(r + s - 1)) + 12*fd*(r + s)*(-K*b1 + g2)) + Dd*f*(4*r + 4*s - 3)*(-12*K*b1 - 5*K*f + 12*g2))*(r + s - 1) - 72*Dd**2*K*b1**2*f*r**2 - 144*Dd**2*K*b1**2*f*r*s + 108*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 108*Dd**2*K*b1**2*f*s - 36*Dd**2*K*b1**2*f - 60*Dd**2*K*b1*f**2*r**2 - 120*Dd**2*K*b1*f**2*r*s + 90*Dd**2*K*b1*f**2*r - 60*Dd**2*K*b1*f**2*s**2 + 90*Dd**2*K*b1*f**2*s - 30*Dd**2*K*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 288*Dd**2*b1*f*g2*r*s - 216*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 216*Dd**2*b1*f*g2*s + 72*Dd**2*b1*f*g2 + 120*Dd**2*f**2*g2*r**2 + 240*Dd**2*f**2*g2*r*s - 180*Dd**2*f**2*g2*r + 120*Dd**2*f**2*g2*s**2 - 180*Dd**2*f**2*g2*s + 60*Dd**2*f**2*g2)/(7*d**2*k3**8) - 4*D1**2*Pk1*Pk3*k1**4*k2**2*st**2*(-2574*C*D1**2*f**2*fd*r**2 - 5148*C*D1**2*f**2*fd*r*s + 3432*C*D1**2*f**2*fd*r - 2574*C*D1**2*f**2*fd*s**2 + 3432*C*D1**2*f**2*fd*s - 1716*C*D1**2*f**2*fd - 3432*C*D1*Dd*f**3*r**2 - 6864*C*D1*Dd*f**3*r*s + 5148*C*D1*Dd*f**3*r - 3432*C*D1*Dd*f**3*s**2 + 5148*C*D1*Dd*f**3*s - 2574*C*D1*Dd*f**3 - 2574*D1**2*K*bdd1*f**2*r**2 - 5148*D1**2*K*bdd1*f**2*r*s + 5148*D1**2*K*bdd1*f**2*r - 2574*D1**2*K*bdd1*f**2*s**2 + 5148*D1**2*K*bdd1*f**2*s - 2574*D1**2*K*bdd1*f**2 + 858*D1**2*bd1**2*f*(-6*K + 5*f)*(r + s - 1)**2 + 1300*D1**2*bdd1*f**3*r**2 + 2600*D1**2*bdd1*f**3*r*s - 2600*D1**2*bdd1*f**3*r + 1300*D1**2*bdd1*f**3*s**2 - 2600*D1**2*bdd1*f**3*s + 1300*D1**2*bdd1*f**3 + 5148*D1**2*bdd1*f*g2*r**2 + 10296*D1**2*bdd1*f*g2*r*s - 10296*D1**2*bdd1*f*g2*r + 5148*D1**2*bdd1*f*g2*s**2 - 10296*D1**2*bdd1*f*g2*s + 5148*D1**2*bdd1*f*g2 + 660*D1**2*f**3*fd*r**2 + 1320*D1**2*f**3*fd*r*s - 990*D1**2*f**3*fd*r + 660*D1**2*f**3*fd*s**2 - 990*D1**2*f**3*fd*s + 495*D1**2*f**3*fd - 980*D1**2*f**3*fdd*r**2 - 1960*D1**2*f**3*fdd*r*s + 1470*D1**2*f**3*fdd*r - 980*D1**2*f**3*fdd*s**2 + 1470*D1**2*f**3*fdd*s - 735*D1**2*f**3*fdd - 2940*D1**2*f**2*fd**2*r**2 - 5880*D1**2*f**2*fd**2*r*s + 4410*D1**2*f**2*fd**2*r - 2940*D1**2*f**2*fd**2*s**2 + 4410*D1**2*f**2*fd**2*s - 1470*D1**2*f**2*fd**2 + 1287*D1**2*f**2*fd*r**2 + 2574*D1**2*f**2*fd*r*s - 1716*D1**2*f**2*fd*r + 1287*D1**2*f**2*fd*s**2 - 1716*D1**2*f**2*fd*s + 858*D1**2*f**2*fd - 9438*D1**2*f**2*gd2*r**2 - 18876*D1**2*f**2*gd2*r*s + 18876*D1**2*f**2*gd2*r - 9438*D1**2*f**2*gd2*s**2 + 18876*D1**2*f**2*gd2*s - 9438*D1**2*f**2*gd2 + 5148*D1**2*f**2*gdd2*r**2 + 10296*D1**2*f**2*gdd2*r*s - 10296*D1**2*f**2*gdd2*r + 5148*D1**2*f**2*gdd2*s**2 - 10296*D1**2*f**2*gdd2*s + 5148*D1**2*f**2*gdd2 - 18876*D1**2*f*fd*g2*r**2 - 37752*D1**2*f*fd*g2*r*s + 18876*D1**2*f*fd*g2*r - 18876*D1**2*f*fd*g2*s**2 + 18876*D1**2*f*fd*g2*s - 9438*D1**2*f*fd*g2 + 20592*D1**2*f*fd*gd2*r**2 + 41184*D1**2*f*fd*gd2*r*s - 30888*D1**2*f*fd*gd2*r + 20592*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 10296*D1**2*f*fd*gd2 + 10296*D1**2*f*fdd*g2*r**2 + 20592*D1**2*f*fdd*g2*r*s - 10296*D1**2*f*fdd*g2*r + 10296*D1**2*f*fdd*g2*s**2 - 10296*D1**2*f*fdd*g2*s + 5148*D1**2*f*fdd*g2 + 10296*D1**2*fd**2*g2*r**2 + 20592*D1**2*fd**2*g2*r*s - 10296*D1**2*fd**2*g2*r + 10296*D1**2*fd**2*g2*s**2 - 10296*D1**2*fd**2*g2*s + 660*D1*Dd*f**4*r**2 + 1320*D1*Dd*f**4*r*s - 990*D1*Dd*f**4*r + 660*D1*Dd*f**4*s**2 - 990*D1*Dd*f**4*s + 495*D1*Dd*f**4 - 7840*D1*Dd*f**3*fd*r**2 - 15680*D1*Dd*f**3*fd*r*s + 11760*D1*Dd*f**3*fd*r - 7840*D1*Dd*f**3*fd*s**2 + 11760*D1*Dd*f**3*fd*s - 4410*D1*Dd*f**3*fd + 1716*D1*Dd*f**3*r**2 + 3432*D1*Dd*f**3*r*s - 2574*D1*Dd*f**3*r + 1716*D1*Dd*f**3*s**2 - 2574*D1*Dd*f**3*s + 1287*D1*Dd*f**3 - 37752*D1*Dd*f**2*g2*r**2 - 75504*D1*Dd*f**2*g2*r*s + 56628*D1*Dd*f**2*g2*r - 37752*D1*Dd*f**2*g2*s**2 + 56628*D1*Dd*f**2*g2*s - 28314*D1*Dd*f**2*g2 + 41184*D1*Dd*f**2*gd2*r**2 + 82368*D1*Dd*f**2*gd2*r*s - 72072*D1*Dd*f**2*gd2*r + 41184*D1*Dd*f**2*gd2*s**2 - 72072*D1*Dd*f**2*gd2*s + 30888*D1*Dd*f**2*gd2 + 82368*D1*Dd*f*fd*g2*r**2 + 164736*D1*Dd*f*fd*g2*r*s - 102960*D1*Dd*f*fd*g2*r + 82368*D1*Dd*f*fd*g2*s**2 - 102960*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 980*D1*Ddd*f**4*r**2 - 1960*D1*Ddd*f**4*r*s + 1470*D1*Ddd*f**4*r - 980*D1*Ddd*f**4*s**2 + 1470*D1*Ddd*f**4*s - 735*D1*Ddd*f**4 + 20592*D1*Ddd*f**2*g2*r**2 + 41184*D1*Ddd*f**2*g2*r*s - 30888*D1*Ddd*f**2*g2*r + 20592*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 15444*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(134*f**3*(r + s - 1) + f**2*(66*C*(r + s - 1) - 363*K*r - 363*K*s + 363*K + 462*b1*(r + s - 1) - 600*fd*r - 600*fd*s + 400*fd - 33*r - 33*s + 33) - 66*f*(19*K*b1*(r + s - 1) - 6*K*fd*(2*r + 2*s - 1) + 10*b1*fd*(2*r + 2*s - 1) - 19*g2*(r + s - 1) + 12*gd2*(r + s - 1)) - 792*fd*(r + s)*(-K*b1 + g2)) - 4*Dd*f*(4*r + 4*s - 3)*(-99*K*f + 33*b1*(-6*K + 5*f) + 50*f**2 + 198*g2))*(r + s - 1) - 2940*Dd**2*f**4*r**2 - 5880*Dd**2*f**4*r*s + 4410*Dd**2*f**4*r - 2940*Dd**2*f**4*s**2 + 4410*Dd**2*f**4*s - 1470*Dd**2*f**4 + 61776*Dd**2*f**2*g2*r**2 + 123552*Dd**2*f**2*g2*r*s - 92664*Dd**2*f**2*g2*r + 61776*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 30888*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(f*(7*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(19*K*fd*(r + s) - 6*K*fdd*(r + s) + 10*fd**2*(r + s - 1))) + D1*(Dd*(12*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 7*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(19*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - Ddd*f*(-6*K + 5*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-6*K + 5*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(66*D1**2*bdd1*f*(-6*K + 5*f)*(r + s - 1)**2 + D1**2*(-2*f**2*(67*fd - 50*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-198*K*fdd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 200*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 33*fd*(2*C - 11*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 1254*gd2*(r + s - 1)**2 + 396*gdd2*(r + s - 1)**2) + (-66*r - 66*s)*(6*K*fd**2*(r + s - 1) + 19*fd*g2*(r + s) - 12*fd*gd2*(r + s - 1) - 6*fdd*g2*(r + s))) + D1*(Dd*(-134*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-66*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 200*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + (363*K + 33)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 66*f*(19*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*fd*(-2*r - 2*s + 1) + 2*gd2*(r + s - 1))*(-24*r - 24*s + 18)) + 792*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 2*Ddd*f*(-99*K*f + 50*f**2 + 198*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f*(-99*K*f + 50*f**2 + 198*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(3003*d**2*k3**8) - 2*D1**2*Pk1*Pk3*k1**4*st**2*(66*b1**2*(2*C - 1)*(D1**2*(9*fd - fdd)*(r + s - 1)**2 + D1*(Dd*(9*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-28*C*D1**2*f*fd*r**2 - 120*C*D1**2*f*fd*r*s + 52*C*D1**2*f*fd*r - 92*C*D1**2*f*fd*s**2 + 84*C*D1**2*f*fd*s - 42*C*D1**2*f*fd + 36*C*D1**2*f*fdd*r**2 + 120*C*D1**2*f*fdd*r*s - 52*C*D1**2*f*fdd*r + 84*C*D1**2*f*fdd*s**2 - 76*C*D1**2*f*fdd*s + 38*C*D1**2*f*fdd + 36*C*D1**2*fd**2*r**2 + 120*C*D1**2*fd**2*r*s - 52*C*D1**2*fd**2*r + 84*C*D1**2*fd**2*s**2 - 76*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 - 56*C*D1*Dd*f**2*r**2 - 240*C*D1*Dd*f**2*r*s + 148*C*D1*Dd*f**2*r - 184*C*D1*Dd*f**2*s**2 + 244*C*D1*Dd*f**2*s - 106*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r**2 + 960*C*D1*Dd*f*fd*r*s - 520*C*D1*Dd*f*fd*r + 672*C*D1*Dd*f*fd*s**2 - 760*C*D1*Dd*f*fd*s + 204*C*D1*Dd*f*fd + 72*C*D1*Ddd*f**2*r**2 + 240*C*D1*Ddd*f**2*r*s - 156*C*D1*Ddd*f**2*r + 168*C*D1*Ddd*f**2*s**2 - 228*C*D1*Ddd*f**2*s + 102*C*D1*Ddd*f**2 + 216*C*Dd**2*f**2*r**2 + 720*C*Dd**2*f**2*r*s - 468*C*Dd**2*f**2*r + 504*C*Dd**2*f**2*s**2 - 684*C*Dd**2*f**2*s + 204*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 14*D1**2*f*fd*r**2 + 64*D1**2*f*fd*r*s - 28*D1**2*f*fd*r + 50*D1**2*f*fd*s**2 - 46*D1**2*f*fd*s + 23*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 64*D1**2*f*fdd*r*s + 28*D1**2*f*fdd*r - 46*D1**2*f*fdd*s**2 + 42*D1**2*f*fdd*s - 21*D1**2*f*fdd - 18*D1**2*fd**2*r**2 - 64*D1**2*fd**2*r*s + 28*D1**2*fd**2*r - 46*D1**2*fd**2*s**2 + 42*D1**2*fd**2*s + 4*D1**2*fd**2 + 28*D1*Dd*f**2*r**2 + 128*D1*Dd*f**2*r*s - 78*D1*Dd*f**2*r + 100*D1*Dd*f**2*s**2 - 132*D1*Dd*f**2*s + 57*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 512*D1*Dd*f*fd*r*s + 276*D1*Dd*f*fd*r - 368*D1*Dd*f*fd*s**2 + 416*D1*Dd*f*fd*s - 112*D1*Dd*f*fd - 36*D1*Ddd*f**2*r**2 - 128*D1*Ddd*f**2*r*s + 82*D1*Ddd*f**2*r - 92*D1*Ddd*f**2*s**2 + 124*D1*Ddd*f**2*s - 55*D1*Ddd*f**2 + 2*D1*bd1*(2*C - 1)*(D1*(9*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 108*Dd**2*f**2*r**2 - 384*Dd**2*f**2*r*s + 246*Dd**2*f**2*r - 276*Dd**2*f**2*s**2 + 372*Dd**2*f**2*s - 110*Dd**2*f**2) + f*(-1590*C*D1**2*f*fd*r**2 - 5964*C*D1**2*f*fd*r*s + 3048*C*D1**2*f*fd*r - 4374*C*D1**2*f*fd*s**2 + 4904*C*D1**2*f*fd*s - 1988*C*D1**2*f*fd + 2082*C*D1**2*f*fdd*r**2 + 6348*C*D1**2*f*fdd*r*s - 3504*C*D1**2*f*fdd*r + 4266*C*D1**2*f*fdd*s**2 - 4960*C*D1**2*f*fdd*s + 2116*C*D1**2*f*fdd + 4164*C*D1**2*fd**2*r**2 + 12696*C*D1**2*fd**2*r*s - 7008*C*D1**2*fd**2*r + 8532*C*D1**2*fd**2*s**2 - 9920*C*D1**2*fd**2*s + 2116*C*D1**2*fd**2 - 2120*C*D1*Dd*f**2*r**2 - 7952*C*D1*Dd*f**2*r*s + 5036*C*D1*Dd*f**2*r - 5832*C*D1*Dd*f**2*s**2 + 7820*C*D1*Dd*f**2*s - 3446*C*D1*Dd*f**2 + 16656*C*D1*Dd*f*fd*r**2 + 50784*C*D1*Dd*f*fd*r*s - 30876*C*D1*Dd*f*fd*r + 34128*C*D1*Dd*f*fd*s**2 - 43252*C*D1*Dd*f*fd*s + 13424*C*D1*Dd*f*fd + 2776*C*D1*Ddd*f**2*r**2 + 8464*C*D1*Ddd*f**2*r*s - 5620*C*D1*Ddd*f**2*r + 5688*C*D1*Ddd*f**2*s**2 - 7804*C*D1*Ddd*f**2*s + 3538*C*D1*Ddd*f**2 + 8328*C*Dd**2*f**2*r**2 + 25392*C*Dd**2*f**2*r*s - 16860*C*Dd**2*f**2*r + 17064*C*Dd**2*f**2*s**2 - 23412*C*Dd**2*f**2*s + 7076*C*Dd**2*f**2 - 132*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(2*C*(9*r**2 + 30*r*s - 22*r + 21*s**2 - 34*s + 11) - 9*r**2 - 32*r*s + 22*r - 23*s**2 + 36*s - 11) + 795*D1**2*f*fd*r**2 + 3084*D1**2*f*fd*r*s - 1558*D1**2*f*fd*r + 2289*D1**2*f*fd*s**2 - 2554*D1**2*f*fd*s + 1028*D1**2*f*fd - 1041*D1**2*f*fdd*r**2 - 3324*D1**2*f*fdd*r*s + 1802*D1**2*f*fdd*r - 2283*D1**2*f*fdd*s**2 + 2630*D1**2*f*fdd*s - 1108*D1**2*f*fdd - 2082*D1**2*fd**2*r**2 - 6648*D1**2*fd**2*r*s + 3604*D1**2*fd**2*r - 4566*D1**2*fd**2*s**2 + 5260*D1**2*fd**2*s - 1108*D1**2*fd**2 + 1060*D1*Dd*f**2*r**2 + 4112*D1*Dd*f**2*r*s - 2586*D1*Dd*f**2*r + 3052*D1*Dd*f**2*s**2 - 4080*D1*Dd*f**2*s + 1791*D1*Dd*f**2 - 8328*D1*Dd*f*fd*r**2 - 26592*D1*Dd*f*fd*r*s + 15938*D1*Dd*f*fd*r - 18264*D1*Dd*f*fd*s**2 + 22976*D1*Dd*f*fd*s - 7062*D1*Dd*f*fd - 1388*D1*Ddd*f**2*r**2 - 4432*D1*Ddd*f**2*r*s + 2910*D1*Ddd*f**2*r - 3044*D1*Ddd*f**2*s**2 + 4152*D1*Ddd*f**2*s - 1869*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(2*C*(7*r**2 + 6*r*(5*s - 3) + 23*s**2 - 34*s + 9) - 7*r**2 - 32*r*s + 18*r - 25*s**2 + 36*s - 9) - 2*fd*(2*C*(18*r**2 + 60*r*s - 35*r + 42*s**2 - 53*s + 17) - 18*r**2 - 64*r*s + 36*r - 46*s**2 + 57*s - 18)) - 2*Dd*f*(2*C*(36*r**2 + 120*r*s - 83*r + 84*s**2 - 125*s + 45) - 36*r**2 - 128*r*s + 85*r - 92*s**2 + 134*s - 47)) - 4164*Dd**2*f**2*r**2 - 13296*Dd**2*f**2*r*s + 8730*Dd**2*f**2*r - 9132*Dd**2*f**2*s**2 + 12456*Dd**2*f**2*s - 3738*Dd**2*f**2))/(693*d**2*k3**6) - 4*D1**2*Pk1*Pk3*k1**4*(64*D1**2*K*bdd1*f**2*r**2 + 124*D1**2*K*bdd1*f**2*r*s - 124*D1**2*K*bdd1*f**2*r + 60*D1**2*K*bdd1*f**2*s**2 - 120*D1**2*K*bdd1*f**2*s + 60*D1**2*K*bdd1*f**2 + 2*D1**2*bd1**2*(r + s - 1)*(f**2*(6 - 12*s) + f*(K*(59*r + 59*s - 71) - 12*s + 6) + 28*g2*(r + s)) - 8*D1**2*bd2*f**2*r**2 - 16*D1**2*bd2*f**2*r*s + 16*D1**2*bd2*f**2*r - 8*D1**2*bd2*f**2*s**2 + 16*D1**2*bd2*f**2*s - 8*D1**2*bd2*f**2 + 40*D1**2*bd2*f*fd*r**2 + 80*D1**2*bd2*f*fd*r*s - 60*D1**2*bd2*f*fd*r + 40*D1**2*bd2*f*fd*s**2 - 60*D1**2*bd2*f*fd*s + 20*D1**2*bd2*f*fd - 10*D1**2*bdd1*f**3*r*s + 10*D1**2*bdd1*f**3*r - 10*D1**2*bdd1*f**3*s**2 + 20*D1**2*bdd1*f**3*s - 10*D1**2*bdd1*f**3 - 10*D1**2*bdd1*f**2*r*s + 10*D1**2*bdd1*f**2*r - 10*D1**2*bdd1*f**2*s**2 + 20*D1**2*bdd1*f**2*s - 10*D1**2*bdd1*f**2 - 118*D1**2*bdd1*f*g2*r**2 - 236*D1**2*bdd1*f*g2*r*s + 284*D1**2*bdd1*f*g2*r - 118*D1**2*bdd1*f*g2*s**2 + 284*D1**2*bdd1*f*g2*s - 142*D1**2*bdd1*f*g2 + 10*D1**2*bdd2*f**2*r**2 + 20*D1**2*bdd2*f**2*r*s - 20*D1**2*bdd2*f**2*r + 10*D1**2*bdd2*f**2*s**2 - 20*D1**2*bdd2*f**2*s + 10*D1**2*bdd2*f**2 + 100*D1**2*f**2*gd2*r**2 + 184*D1**2*f**2*gd2*r*s - 184*D1**2*f**2*gd2*r + 84*D1**2*f**2*gd2*s**2 - 168*D1**2*f**2*gd2*s + 84*D1**2*f**2*gd2 - 128*D1**2*f**2*gdd2*r**2 - 248*D1**2*f**2*gdd2*r*s + 248*D1**2*f**2*gdd2*r - 120*D1**2*f**2*gdd2*s**2 + 240*D1**2*f**2*gdd2*s - 120*D1**2*f**2*gdd2 + 200*D1**2*f*fd*g2*r**2 + 368*D1**2*f*fd*g2*r*s - 200*D1**2*f*fd*g2*r + 168*D1**2*f*fd*g2*s**2 - 184*D1**2*f*fd*g2*s + 100*D1**2*f*fd*g2 - 512*D1**2*f*fd*gd2*r**2 - 992*D1**2*f*fd*gd2*r*s + 752*D1**2*f*fd*gd2*r - 480*D1**2*f*fd*gd2*s**2 + 728*D1**2*f*fd*gd2*s - 248*D1**2*f*fd*gd2 - 256*D1**2*f*fdd*g2*r**2 - 496*D1**2*f*fdd*g2*r*s + 256*D1**2*f*fdd*g2*r - 240*D1**2*f*fdd*g2*s**2 + 248*D1**2*f*fdd*g2*s - 128*D1**2*f*fdd*g2 - 256*D1**2*fd**2*g2*r**2 - 496*D1**2*fd**2*g2*r*s + 256*D1**2*fd**2*g2*r - 240*D1**2*fd**2*g2*s**2 + 248*D1**2*fd**2*g2*s + 80*D1*Dd*bd2*f**2*r**2 + 160*D1*Dd*bd2*f**2*r*s - 140*D1*Dd*bd2*f**2*r + 80*D1*Dd*bd2*f**2*s**2 - 140*D1*Dd*bd2*f**2*s + 60*D1*Dd*bd2*f**2 + 400*D1*Dd*f**2*g2*r**2 + 736*D1*Dd*f**2*g2*r*s - 568*D1*Dd*f**2*g2*r + 336*D1*Dd*f**2*g2*s**2 - 520*D1*Dd*f**2*g2*s + 268*D1*Dd*f**2*g2 - 1024*D1*Dd*f**2*gd2*r**2 - 1984*D1*Dd*f**2*gd2*r*s + 1744*D1*Dd*f**2*gd2*r - 960*D1*Dd*f**2*gd2*s**2 + 1688*D1*Dd*f**2*gd2*s - 728*D1*Dd*f**2*gd2 - 2048*D1*Dd*f*fd*g2*r**2 - 3968*D1*Dd*f*fd*g2*r*s + 2528*D1*Dd*f*fd*g2*r - 1920*D1*Dd*f*fd*g2*s**2 + 2448*D1*Dd*f*fd*g2*s - 752*D1*Dd*f*fd*g2 - 512*D1*Ddd*f**2*g2*r**2 - 992*D1*Ddd*f**2*g2*r*s + 752*D1*Ddd*f**2*g2*r - 480*D1*Ddd*f**2*g2*s**2 + 728*D1*Ddd*f**2*g2*s - 368*D1*Ddd*f**2*g2 - 2*D1*bd1*(-12*D1*bd2*f*(r + s - 1)**2 + D1*(-5*f**3*(s - 1)*(r + s - 1) + f**2*(5*fd*(r*(6*s - 4) + 6*s**2 - 9*s + 3) + (r + s - 1)*(25*K*r + 21*K*(s - 1) - 4*s + 4)) + f*(fd*(-2*K*(64*r**2 + 124*r*s - 94*r + 60*s**2 - 91*s + 31) + 20*r*s - 10*r + 20*s**2 - 25*s + 5) - g2*(41*r**2 + 2*r*(41*s - 51) + 41*s**2 - 102*s + 51) + 2*gd2*(59*r**2 + 2*r*(59*s - 65) + 59*s**2 - 130*s + 71)) + 118*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + Dd*f*(5*f**2*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + f*(-2*K*(128*r**2 + 248*r*s - 218*r + 120*s**2 - 211*s + 91) + 40*r*s - 30*r + 40*s**2 - 65*s + 25) + 2*g2*(236*r**2 + r*(472*s - 461) + 236*s**2 - 461*s + 213))) - 1536*Dd**2*f**2*g2*r**2 - 2976*Dd**2*f**2*g2*r*s + 2256*Dd**2*f**2*g2*r - 1440*Dd**2*f**2*g2*s**2 + 2184*Dd**2*f**2*g2*s - 736*Dd**2*f**2*g2 + 14*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(84*K*bd1*r**2 + 168*K*bd1*r*s - 112*K*bd1*r + 84*K*bd1*s**2 - 112*K*bd1*s + 56*K*bd1 - 42*K*bdd1*r**2 - 84*K*bdd1*r*s + 56*K*bdd1*r - 42*K*bdd1*s**2 + 56*K*bdd1*s - 28*K*bdd1 - 41*K*fd*r**2 - 82*K*fd*r*s - 20*K*fd*r - 41*K*fd*s**2 - 20*K*fd*s + 10*K*fd + 59*K*fdd*r**2 + 118*K*fdd*r*s + 24*K*fdd*r + 59*K*fdd*s**2 + 24*K*fdd*s - 12*K*fdd + 12*f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 24*fd**2*r*s + 12*fd**2*r - 24*fd**2*s**2 + 24*fd**2*s + 10*fd*r*s + 10*fd*s**2 - 12*fdd*r*s - 12*fdd*s**2 - 56*gd2*(r + s - 1)**2 + 28*gdd2*r**2 + 56*gdd2*r*s - 56*gdd2*r + 28*gdd2*s**2 - 56*gdd2*s + 28*gdd2) + D1*(Dd*(-336*K*bd1*r**2 - 672*K*bd1*r*s + 476*K*bd1*r - 336*K*bd1*s**2 + 476*K*bd1*s - 168*K*bd1 + 472*K*fd*r**2 + 944*K*fd*r*s - 258*K*fd*r + 472*K*fd*s**2 - 258*K*fd*s - 72*K*fd + 12*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - f*(41*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 12*fd*(2*s - 1)*(8*r + 8*s - 5) - 40*r*s + 20*r - 40*s**2 + 50*s - 20) - 96*fd*r*s + 24*fd*r - 96*fd*s**2 + 60*fd*s - 56*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 56*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*(-12*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(59*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 48*r*s + 24*r - 48*s**2 + 60*s - 24) + 28*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) - 6*Dd**2*(2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4) + f*(-59*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 24*r*s - 12*r + 24*s**2 - 30*s + 8) - 28*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - 2*b1*(14*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 59*D1**2*K*bdd1*f*r**2 - 118*D1**2*K*bdd1*f*r*s + 130*D1**2*K*bdd1*f*r - 59*D1**2*K*bdd1*f*s**2 + 130*D1**2*K*bdd1*f*s - 65*D1**2*K*bdd1*f + 50*D1**2*K*f*fd*r**2 + 92*D1**2*K*f*fd*r*s - 50*D1**2*K*f*fd*r + 42*D1**2*K*f*fd*s**2 - 46*D1**2*K*f*fd*s + 25*D1**2*K*f*fd - 64*D1**2*K*f*fdd*r**2 - 124*D1**2*K*f*fdd*r*s + 64*D1**2*K*f*fdd*r - 60*D1**2*K*f*fdd*s**2 + 62*D1**2*K*f*fdd*s - 32*D1**2*K*f*fdd - 64*D1**2*K*fd**2*r**2 - 124*D1**2*K*fd**2*r*s + 64*D1**2*K*fd**2*r - 60*D1**2*K*fd**2*s**2 + 62*D1**2*K*fd**2*s + 5*D1**2*b2*fd*r**2 + 10*D1**2*b2*fd*r*s + 5*D1**2*b2*fd*s**2 - 6*D1**2*b2*fdd*r**2 - 12*D1**2*b2*fdd*r*s - 6*D1**2*b2*fdd*s**2 + 12*D1**2*bdd1*f**2*r*s - 6*D1**2*bdd1*f**2*r + 12*D1**2*bdd1*f**2*s**2 - 18*D1**2*bdd1*f**2*s + 6*D1**2*bdd1*f**2 + 12*D1**2*bdd1*f*r*s - 6*D1**2*bdd1*f*r + 12*D1**2*bdd1*f*s**2 - 18*D1**2*bdd1*f*s + 6*D1**2*bdd1*f - 28*D1**2*bdd1*g2*r**2 - 56*D1**2*bdd1*g2*r*s + 28*D1**2*bdd1*g2*r - 28*D1**2*bdd1*g2*s**2 + 28*D1**2*bdd1*g2*s - 14*D1**2*bdd1*g2 - 6*D1**2*bdd2*f*r**2 - 12*D1**2*bdd2*f*r*s + 12*D1**2*bdd2*f*r - 6*D1**2*bdd2*f*s**2 + 12*D1**2*bdd2*f*s - 6*D1**2*bdd2*f - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 15*D1**2*f**2*fdd*r*s - 5*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 15*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 30*D1**2*f*fd**2*r*s - 10*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 30*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 - 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s + 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*s**2 - 5*D1**2*f*fdd*s - 41*D1**2*f*gd2*r**2 - 82*D1**2*f*gd2*r*s + 82*D1**2*f*gd2*r - 41*D1**2*f*gd2*s**2 + 82*D1**2*f*gd2*s - 41*D1**2*f*gd2 + 59*D1**2*f*gdd2*r**2 + 118*D1**2*f*gdd2*r*s - 118*D1**2*f*gdd2*r + 59*D1**2*f*gdd2*s**2 - 118*D1**2*f*gdd2*s + 59*D1**2*f*gdd2 + 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*s**2 - 5*D1**2*fd**2*s - 41*D1**2*fd*g2*r**2 - 82*D1**2*fd*g2*r*s - 20*D1**2*fd*g2*r - 41*D1**2*fd*g2*s**2 - 20*D1**2*fd*g2*s + 10*D1**2*fd*g2 + 118*D1**2*fd*gd2*r**2 + 236*D1**2*fd*gd2*r*s - 94*D1**2*fd*gd2*r + 118*D1**2*fd*gd2*s**2 - 94*D1**2*fd*gd2*s - 24*D1**2*fd*gd2 + 59*D1**2*fdd*g2*r**2 + 118*D1**2*fdd*g2*r*s + 24*D1**2*fdd*g2*r + 59*D1**2*fdd*g2*s**2 + 24*D1**2*fdd*g2*s - 12*D1**2*fdd*g2 + 100*D1*Dd*K*f**2*r**2 + 184*D1*Dd*K*f**2*r*s - 142*D1*Dd*K*f**2*r + 84*D1*Dd*K*f**2*s**2 - 130*D1*Dd*K*f**2*s + 67*D1*Dd*K*f**2 - 512*D1*Dd*K*f*fd*r**2 - 992*D1*Dd*K*f*fd*r*s + 632*D1*Dd*K*f*fd*r - 480*D1*Dd*K*f*fd*s**2 + 612*D1*Dd*K*f*fd*s - 188*D1*Dd*K*f*fd + 20*D1*Dd*b2*f*r**2 + 40*D1*Dd*b2*f*r*s - 30*D1*Dd*b2*f*r + 20*D1*Dd*b2*f*s**2 - 30*D1*Dd*b2*f*s + 15*D1*Dd*b2*f - 48*D1*Dd*b2*fd*r**2 - 96*D1*Dd*b2*fd*r*s + 36*D1*Dd*b2*fd*r - 48*D1*Dd*b2*fd*s**2 + 36*D1*Dd*b2*fd*s - 20*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 25*D1*Dd*f**3*s - 10*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*r*s - 50*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 135*D1*Dd*f**2*fd*s + 35*D1*Dd*f**2*fd - 16*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 20*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 80*D1*Dd*f*fd*r*s - 20*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 70*D1*Dd*f*fd*s + 10*D1*Dd*f*fd - 164*D1*Dd*f*g2*r**2 - 328*D1*Dd*f*g2*r*s + 246*D1*Dd*f*g2*r - 164*D1*Dd*f*g2*s**2 + 246*D1*Dd*f*g2*s - 123*D1*Dd*f*g2 + 472*D1*Dd*f*gd2*r**2 + 944*D1*Dd*f*gd2*r*s - 826*D1*Dd*f*gd2*r + 472*D1*Dd*f*gd2*s**2 - 826*D1*Dd*f*gd2*s + 354*D1*Dd*f*gd2 + 472*D1*Dd*fd*g2*r**2 + 944*D1*Dd*fd*g2*r*s - 258*D1*Dd*fd*g2*r + 472*D1*Dd*fd*g2*s**2 - 258*D1*Dd*fd*g2*s - 72*D1*Dd*fd*g2 - 128*D1*Ddd*K*f**2*r**2 - 248*D1*Ddd*K*f**2*r*s + 188*D1*Ddd*K*f**2*r - 120*D1*Ddd*K*f**2*s**2 + 182*D1*Ddd*K*f**2*s - 92*D1*Ddd*K*f**2 - 24*D1*Ddd*b2*f*r**2 - 48*D1*Ddd*b2*f*r*s + 36*D1*Ddd*b2*f*r - 24*D1*Ddd*b2*f*s**2 + 36*D1*Ddd*b2*f*s - 18*D1*Ddd*b2*f + 20*D1*Ddd*f**3*r*s - 10*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 25*D1*Ddd*f**3*s + 10*D1*Ddd*f**3 + 20*D1*Ddd*f**2*r*s - 10*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 25*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 + 236*D1*Ddd*f*g2*r**2 + 472*D1*Ddd*f*g2*r*s - 354*D1*Ddd*f*g2*r + 236*D1*Ddd*f*g2*s**2 - 354*D1*Ddd*f*g2*s + 177*D1*Ddd*f*g2 + D1*bd1*(D1*(-6*f**2*(2*s - 1)*(r + s - 1) + f*(K*(41*r**2 + 82*r*s - 92*r + 41*s**2 - 92*s + 46) + 6*fd*(2*s - 1)*(4*r + 4*s - 3) + (2*s - 1)*(-5*r - 5*s + 5)) - 2*fd*(K*(59*r**2 + r*(118*s - 53) + 59*s**2 - 53*s - 6) - 12*r*s + 3*r + 3*s*(3 - 4*s)) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(3*f**2*(2*s - 1)*(8*r + 8*s - 7) + f*(-K*(236*r**2 + 472*r*s - 437*r + 236*s**2 - 437*s + 195) + (6*s - 3)*(8*r + 8*s - 7)) - 14*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 384*Dd**2*K*f**2*r**2 - 744*Dd**2*K*f**2*r*s + 564*Dd**2*K*f**2*r - 360*Dd**2*K*f**2*s**2 + 546*Dd**2*K*f**2*s - 184*Dd**2*K*f**2 - 72*Dd**2*b2*f*r**2 - 144*Dd**2*b2*f*r*s + 108*Dd**2*b2*f*r - 72*Dd**2*b2*f*s**2 + 108*Dd**2*b2*f*s - 36*Dd**2*b2*f + 60*Dd**2*f**3*r*s - 30*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 75*Dd**2*f**3*s + 20*Dd**2*f**3 + 60*Dd**2*f**2*r*s - 30*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 75*Dd**2*f**2*s + 20*Dd**2*f**2 + 708*Dd**2*f*g2*r**2 + 1416*Dd**2*f*g2*r*s - 1062*Dd**2*f*g2*r + 708*Dd**2*f*g2*s**2 - 1062*Dd**2*f*g2*s + 354*Dd**2*f*g2) - 2*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 100*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2))/(21*d**2*k3**6) + D1**2*Pk1*Pk3*k1**4*st**2*(2*C - 1)*(b1*(D1**2*(f*(7*fd - 5*fdd)*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1)) + 2*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(1 - 2*s)**2 - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(7*fd*(3*s**2 - 2*s + 1) - 5*fdd*(3*s**2 - 2*s + 1) + s**2*(7*bd1 - 5*bdd1)) + 10*fd*s*(-2*bd1*s + bd1 + fd*(2 - 3*s))) + 2*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*(2*s - 1)*(bd1*s + fd*(3*s - 1)) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k2**2*k3**4) - D1**2*Pk1*Pk3*k1**4*(4*C - 2)*(7*b1*(D1**2*(f*(fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(6*fd*(3*s**2 - 2*s + 1) - 6*fdd*(3*s**2 - 2*s + 1) + s**2*(7*bd1 - 7*bdd1)) + 2*fd*s*(bd1*(7 - 14*s) + 6*fd*(2 - 3*s))) + 4*D1*f*(Dd*f*(6*s**2 - 6*s + 3) - Dd*(2*s - 1)*(7*bd1*s + 6*fd*(3*s - 1)) - 3*Ddd*f*(2*s**2 - 2*s + 1)) - 12*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k2**2*k3**4) + D1**2*Pk1*Pk3*k1**2*k2**4*st**6*(40*C - 20)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(231*d**2*k3**8) + 8*D1**2*Pk1*Pk3*k1**2*k2**4*st**4*(-858*D1**2*K*bd1**2*f*(r + s - 1)**2 + D1**2*f*(858*bdd1*g2*(r + s - 1)**2 - f**2*(161*fd - 100*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 600*f*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*D1*bd1*(D1*(f**2*(-2*C + 2*b1 + 1)*(r + s - 1) - 4*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 4*fd*(r + s)*(-K*b1 + g2)) + 4*Dd*f*(-K*b1 + g2)*(4*r + 4*s - 3))*(r + s - 1) + D1*f**3*(Dd*(-161*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 200*fd*(4*r + 4*s - 3)**2) + 100*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 600*Dd**2*f**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 429*b1**2*(D1**2*(K*(2*fd - fdd)*(r + s)**2 + f*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + D1*(Dd*(2*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 429*b1*(D1**2*(f*(fd*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s - 1)**2*(2*K*bdd1 + 4*gd2 - 2*gdd2)) + (-2*r - 2*s)*(-2*fd*g2*(r + s) + 2*fd*gd2*(r + s - 1) + fdd*g2*(r + s))) + D1*(Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4*f*(g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 4*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(1001*d**2*k3**8) + D1**2*Pk1*Pk3*k1**2*k2**2*st**6*(80*C - 40)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(693*d**2*k3**6) + 4*D1**2*Pk1*Pk3*k1**2*k2**2*st**4*(22*b1**2*(2*C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(12*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r*s + 4*C*D1**2*f*fd*r - 20*C*D1**2*f*fd*s**2 + 20*C*D1**2*f*fd*s - 10*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r**2 + 56*C*D1**2*f*fdd*r*s - 28*C*D1**2*f*fdd*r + 36*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 18*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r**2 + 56*C*D1**2*fd**2*r*s - 28*C*D1**2*fd**2*r + 36*C*D1**2*fd**2*s**2 - 36*C*D1**2*fd**2*s + 24*C*D1*Dd*f**2*r**2 - 16*C*D1*Dd*f**2*r*s - 4*C*D1*Dd*f**2*r - 40*C*D1*Dd*f**2*s**2 + 44*C*D1*Dd*f**2*s - 14*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*r**2 + 448*C*D1*Dd*f*fd*r*s - 264*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 344*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*r**2 + 112*C*D1*Ddd*f**2*r*s - 76*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s**2 - 100*C*D1*Ddd*f**2*s + 46*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*r**2 + 336*C*Dd**2*f**2*r*s - 228*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s**2 - 300*C*Dd**2*f**2*s + 92*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*D1**2*f*fd*r**2 + 6*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s + 3*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s - 12*D1*Dd*f**2*r**2 + 6*D1*Dd*f**2*r + 12*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 132*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 172*D1*Dd*f*fd*s - 50*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 38*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 50*D1*Ddd*f**2*s - 23*D1*Ddd*f**2 + 4*D1*bd1*(2*C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 60*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 114*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 150*Dd**2*f**2*s - 46*Dd**2*f**2) + f*(-44*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 11*D1**2*bdd1*f*(2*C - 1)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) + 11*D1*bd1*(D1*(f*(r + s - 1)*(2*C*(3*r - 5*s - 3) - 3*r + 3*s + 3) + fd*(4*C - 2)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7)) + Dd*f*(4*C - 2)*(20*r**2 + r*(56*s - 39) + 36*s**2 - 53*s + 19)) + (16*C - 10)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(77*d**2*k3**6) + 2*D1**2*Pk1*Pk3*k1**2*k2**2*st**2*(-3432*C*D1**2*bd1*f**2*r**2 - 3432*C*D1**2*bd1*f**2*r*s + 10296*C*D1**2*bd1*f**2*r + 6864*C*D1**2*bd1*f**2*s - 5148*C*D1**2*bd1*f**2 - 15444*C*D1**2*f**2*fd*r**2 - 20592*C*D1**2*f**2*fd*r*s + 17160*C*D1**2*f**2*fd*r - 5148*C*D1**2*f**2*fd*s**2 + 10296*C*D1**2*f**2*fd*s - 6864*C*D1**2*f**2*fd - 20592*C*D1*Dd*f**3*r**2 - 27456*C*D1*Dd*f**3*r*s + 24024*C*D1*Dd*f**3*r - 6864*C*D1*Dd*f**3*s**2 + 13728*C*D1*Dd*f**3*s - 8580*C*D1*Dd*f**3 + 858*D1**2*K*bd1**2*f*r**2 + 12012*D1**2*K*bd1**2*f*r*s - 5148*D1**2*K*bd1**2*f*r + 11154*D1**2*K*bd1**2*f*s**2 - 15444*D1**2*K*bd1**2*f*s + 4290*D1**2*K*bd1**2*f + 26169*D1**2*K*bd1*f**2*r**2 + 45474*D1**2*K*bd1*f**2*r*s - 45474*D1**2*K*bd1*f**2*r + 19305*D1**2*K*bd1*f**2*s**2 - 38610*D1**2*K*bd1*f**2*s + 19305*D1**2*K*bd1*f**2 - 70356*D1**2*K*bd1*f*fd*r**2 - 120120*D1**2*K*bd1*f*fd*r*s + 95238*D1**2*K*bd1*f*fd*r - 49764*D1**2*K*bd1*f*fd*s**2 + 79794*D1**2*K*bd1*f*fd*s - 30030*D1**2*K*bd1*f*fd - 17589*D1**2*K*bdd1*f**2*r**2 - 30030*D1**2*K*bdd1*f**2*r*s + 30030*D1**2*K*bdd1*f**2*r - 12441*D1**2*K*bdd1*f**2*s**2 + 24882*D1**2*K*bdd1*f**2*s - 12441*D1**2*K*bdd1*f**2 + 21450*D1**2*bd1**2*f**2*r**2 + 53196*D1**2*bd1**2*f**2*r*s - 51480*D1**2*bd1**2*f**2*r + 31746*D1**2*bd1**2*f**2*s**2 - 61776*D1**2*bd1**2*f**2*s + 30030*D1**2*bd1**2*f**2 + 5148*D1**2*bd1**2*f*r**2 + 10296*D1**2*bd1**2*f*r*s - 10296*D1**2*bd1**2*f*r + 5148*D1**2*bd1**2*f*s**2 - 10296*D1**2*bd1**2*f*s + 5148*D1**2*bd1**2*f + 24024*D1**2*bd1**2*g2*r**2 + 48048*D1**2*bd1**2*g2*r*s - 24024*D1**2*bd1**2*g2*r + 24024*D1**2*bd1**2*g2*s**2 - 24024*D1**2*bd1**2*g2*s - 10296*D1**2*bd1*bd2*f*r**2 - 20592*D1**2*bd1*bd2*f*r*s + 20592*D1**2*bd1*bd2*f*r - 10296*D1**2*bd1*bd2*f*s**2 + 20592*D1**2*bd1*bd2*f*s - 10296*D1**2*bd1*bd2*f - 9854*D1**2*bd1*f**3*r**2 - 16354*D1**2*bd1*f**3*r*s + 22360*D1**2*bd1*f**3*r - 6500*D1**2*bd1*f**3*s**2 + 19006*D1**2*bd1*f**3*s - 12948*D1**2*bd1*f**3 + 68172*D1**2*bd1*f**2*fd*r**2 + 113412*D1**2*bd1*f**2*fd*r*s - 110344*D1**2*bd1*f**2*fd*r + 45240*D1**2*bd1*f**2*fd*s**2 - 91234*D1**2*bd1*f**2*fd*s + 38688*D1**2*bd1*f**2*fd - 2574*D1**2*bd1*f**2*r**2 - 6864*D1**2*bd1*f**2*r*s + 2574*D1**2*bd1*f**2*r - 4290*D1**2*bd1*f**2*s**2 + 4290*D1**2*bd1*f**2*s - 858*D1**2*bd1*f**2 + 10296*D1**2*bd1*f*fd*r**2 + 20592*D1**2*bd1*f*fd*r*s - 15444*D1**2*bd1*f*fd*r + 10296*D1**2*bd1*f*fd*s**2 - 15444*D1**2*bd1*f*fd*s + 5148*D1**2*bd1*f*fd - 76362*D1**2*bd1*f*g2*r**2 - 132132*D1**2*bd1*f*g2*r*s + 159588*D1**2*bd1*f*g2*r - 55770*D1**2*bd1*f*g2*s**2 + 138996*D1**2*bd1*f*g2*s - 79794*D1**2*bd1*f*g2 - 1716*D1**2*bd1*f*gd2*r**2 - 24024*D1**2*bd1*f*gd2*r*s + 10296*D1**2*bd1*f*gd2*r - 22308*D1**2*bd1*f*gd2*s**2 + 30888*D1**2*bd1*f*gd2*s - 8580*D1**2*bd1*f*gd2 - 1716*D1**2*bd1*fd*g2*r**2 - 24024*D1**2*bd1*fd*g2*r*s + 1716*D1**2*bd1*fd*g2*r - 22308*D1**2*bd1*fd*g2*s**2 + 12012*D1**2*bd1*fd*g2*s + 9438*D1**2*bd2*f**2*r**2 + 18876*D1**2*bd2*f**2*r*s - 18876*D1**2*bd2*f**2*r + 9438*D1**2*bd2*f**2*s**2 - 18876*D1**2*bd2*f**2*s + 9438*D1**2*bd2*f**2 - 20592*D1**2*bd2*f*fd*r**2 - 41184*D1**2*bd2*f*fd*r*s + 30888*D1**2*bd2*f*fd*r - 20592*D1**2*bd2*f*fd*s**2 + 30888*D1**2*bd2*f*fd*s - 10296*D1**2*bd2*f*fd + 11362*D1**2*bdd1*f**3*r**2 + 18902*D1**2*bdd1*f**3*r*s - 24908*D1**2*bdd1*f**3*r + 7540*D1**2*bdd1*f**3*s**2 - 21086*D1**2*bdd1*f**3*s + 14196*D1**2*bdd1*f**3 + 2574*D1**2*bdd1*f**2*r**2 + 5148*D1**2*bdd1*f**2*r*s - 5148*D1**2*bdd1*f**2*r + 2574*D1**2*bdd1*f**2*s**2 - 5148*D1**2*bdd1*f**2*s + 2574*D1**2*bdd1*f**2 - 858*D1**2*bdd1*f*g2*r**2 - 12012*D1**2*bdd1*f*g2*r*s - 1716*D1**2*bdd1*f*g2*r - 11154*D1**2*bdd1*f*g2*s**2 + 8580*D1**2*bdd1*f*g2*s + 858*D1**2*bdd1*f*g2 - 5148*D1**2*bdd2*f**2*r**2 - 10296*D1**2*bdd2*f**2*r*s + 10296*D1**2*bdd2*f**2*r - 5148*D1**2*bdd2*f**2*s**2 + 10296*D1**2*bdd2*f**2*s - 5148*D1**2*bdd2*f**2 + 9020*D1**2*f**3*fd*r**2 + 36320*D1**2*f**3*fd*r*s - 22670*D1**2*f**3*fd*r + 27300*D1**2*f**3*fd*s**2 - 36380*D1**2*f**3*fd*s + 15905*D1**2*f**3*fd - 9060*D1**2*f**3*fdd*r**2 - 38960*D1**2*f**3*fdd*r*s + 24010*D1**2*f**3*fdd*r - 29900*D1**2*f**3*fdd*s**2 + 39640*D1**2*f**3*fdd*s - 17215*D1**2*f**3*fdd - 27180*D1**2*f**2*fd**2*r**2 - 116880*D1**2*f**2*fd**2*r*s + 72030*D1**2*f**2*fd**2*r - 89700*D1**2*f**2*fd**2*s**2 + 118920*D1**2*f**2*fd**2*s - 34430*D1**2*f**2*fd**2 + 10296*D1**2*f**2*fd*r**2 + 12870*D1**2*f**2*fd*r*s - 11154*D1**2*f**2*fd*r + 2574*D1**2*f**2*fd*s**2 - 6006*D1**2*f**2*fd*s + 4290*D1**2*f**2*fd - 52338*D1**2*f**2*gd2*r**2 - 90948*D1**2*f**2*gd2*r*s + 90948*D1**2*f**2*gd2*r - 38610*D1**2*f**2*gd2*s**2 + 77220*D1**2*f**2*gd2*s - 38610*D1**2*f**2*gd2 + 35178*D1**2*f**2*gdd2*r**2 + 60060*D1**2*f**2*gdd2*r*s - 60060*D1**2*f**2*gdd2*r + 24882*D1**2*f**2*gdd2*s**2 - 49764*D1**2*f**2*gdd2*s + 24882*D1**2*f**2*gdd2 - 104676*D1**2*f*fd*g2*r**2 - 181896*D1**2*f*fd*g2*r*s + 104676*D1**2*f*fd*g2*r - 77220*D1**2*f*fd*g2*s**2 + 90948*D1**2*f*fd*g2*s - 52338*D1**2*f*fd*g2 + 140712*D1**2*f*fd*gd2*r**2 + 240240*D1**2*f*fd*gd2*r*s - 190476*D1**2*f*fd*gd2*r + 99528*D1**2*f*fd*gd2*s**2 - 159588*D1**2*f*fd*gd2*s + 60060*D1**2*f*fd*gd2 + 70356*D1**2*f*fdd*g2*r**2 + 120120*D1**2*f*fdd*g2*r*s - 70356*D1**2*f*fdd*g2*r + 49764*D1**2*f*fdd*g2*s**2 - 60060*D1**2*f*fdd*g2*s + 35178*D1**2*f*fdd*g2 + 70356*D1**2*fd**2*g2*r**2 + 120120*D1**2*fd**2*g2*r*s - 70356*D1**2*fd**2*g2*r + 49764*D1**2*fd**2*g2*s**2 - 60060*D1**2*fd**2*g2*s - 140712*D1*Dd*K*bd1*f**2*r**2 - 240240*D1*Dd*K*bd1*f**2*r*s + 215358*D1*Dd*K*bd1*f**2*r - 99528*D1*Dd*K*bd1*f**2*s**2 + 179322*D1*Dd*K*bd1*f**2*s - 79794*D1*Dd*K*bd1*f**2 + 90896*D1*Dd*bd1*f**3*r**2 + 151216*D1*Dd*bd1*f**3*r*s - 160160*D1*Dd*bd1*f**3*r + 60320*D1*Dd*bd1*f**3*s**2 - 133406*D1*Dd*bd1*f**3*s + 67080*D1*Dd*bd1*f**3 + 20592*D1*Dd*bd1*f**2*r**2 + 41184*D1*Dd*bd1*f**2*r*s - 36036*D1*Dd*bd1*f**2*r + 20592*D1*Dd*bd1*f**2*s**2 - 36036*D1*Dd*bd1*f**2*s + 15444*D1*Dd*bd1*f**2 - 6864*D1*Dd*bd1*f*g2*r**2 - 96096*D1*Dd*bd1*f*g2*r*s + 18876*D1*Dd*bd1*f*g2*r - 89232*D1*Dd*bd1*f*g2*s**2 + 90948*D1*Dd*bd1*f*g2*s - 15444*D1*Dd*bd1*f*g2 - 41184*D1*Dd*bd2*f**2*r**2 - 82368*D1*Dd*bd2*f**2*r*s + 72072*D1*Dd*bd2*f**2*r - 41184*D1*Dd*bd2*f**2*s**2 + 72072*D1*Dd*bd2*f**2*s - 30888*D1*Dd*bd2*f**2 + 9020*D1*Dd*f**4*r**2 + 36320*D1*Dd*f**4*r*s - 22670*D1*Dd*f**4*r + 27300*D1*Dd*f**4*s**2 - 36380*D1*Dd*f**4*s + 15905*D1*Dd*f**4 - 72480*D1*Dd*f**3*fd*r**2 - 311680*D1*Dd*f**3*fd*r*s + 192080*D1*Dd*f**3*fd*r - 239200*D1*Dd*f**3*fd*s**2 + 317120*D1*Dd*f**3*fd*s - 103290*D1*Dd*f**3*fd + 13728*D1*Dd*f**3*r**2 + 17160*D1*Dd*f**3*r*s - 15444*D1*Dd*f**3*r + 3432*D1*Dd*f**3*s**2 - 7722*D1*Dd*f**3*s + 5148*D1*Dd*f**3 - 209352*D1*Dd*f**2*g2*r**2 - 363792*D1*Dd*f**2*g2*r*s + 286572*D1*Dd*f**2*g2*r - 154440*D1*Dd*f**2*g2*s**2 + 245388*D1*Dd*f**2*g2*s - 129558*D1*Dd*f**2*g2 + 281424*D1*Dd*f**2*gd2*r**2 + 480480*D1*Dd*f**2*gd2*r*s - 430716*D1*Dd*f**2*gd2*r + 199056*D1*Dd*f**2*gd2*s**2 - 358644*D1*Dd*f**2*gd2*s + 159588*D1*Dd*f**2*gd2 + 562848*D1*Dd*f*fd*g2*r**2 + 960960*D1*Dd*f*fd*g2*r*s - 662376*D1*Dd*f*fd*g2*r + 398112*D1*Dd*f*fd*g2*s**2 - 559416*D1*Dd*f*fd*g2*s + 190476*D1*Dd*f*fd*g2 - 9060*D1*Ddd*f**4*r**2 - 38960*D1*Ddd*f**4*r*s + 24010*D1*Ddd*f**4*r - 29900*D1*Ddd*f**4*s**2 + 39640*D1*Ddd*f**4*s - 17215*D1*Ddd*f**4 + 140712*D1*Ddd*f**2*g2*r**2 + 240240*D1*Ddd*f**2*g2*r*s - 190476*D1*Ddd*f**2*g2*r + 99528*D1*Ddd*f**2*g2*s**2 - 159588*D1*Ddd*f**2*g2*s + 84942*D1*Ddd*f**2*g2 - 27180*Dd**2*f**4*r**2 - 116880*Dd**2*f**4*r*s + 72030*Dd**2*f**4*r - 89700*Dd**2*f**4*s**2 + 118920*Dd**2*f**4*s - 34430*Dd**2*f**4 + 422136*Dd**2*f**2*g2*r**2 + 720720*Dd**2*f**2*g2*r*s - 571428*Dd**2*f**2*g2*r + 298584*Dd**2*f**2*g2*s**2 - 478764*Dd**2*f**2*g2*s + 169884*Dd**2*f**2*g2 + 858*b1**3*(D1**2*(13*fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(14*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 13*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*(7*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(7*K + 3*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(-28*C*D1**2*fd*r**2 - 56*C*D1**2*fd*r*s + 56*C*D1**2*fd*r - 28*C*D1**2*fd*s**2 + 56*C*D1**2*fd*s - 28*C*D1**2*fd - 112*C*D1*Dd*f*r**2 - 224*C*D1*Dd*f*r*s + 168*C*D1*Dd*f*r - 112*C*D1*Dd*f*s**2 + 168*C*D1*Dd*f*s - 84*C*D1*Dd*f + 89*D1**2*K*fd*r**2 + 154*D1**2*K*fd*r*s + 8*D1**2*K*fd*r + 65*D1**2*K*fd*s**2 + 8*D1**2*K*fd*s - 4*D1**2*K*fd + D1**2*K*fdd*r**2 + 14*D1**2*K*fdd*r*s - 4*D1**2*K*fdd*r + 13*D1**2*K*fdd*s**2 - 4*D1**2*K*fdd*s + 2*D1**2*K*fdd - 2*D1**2*bdd1*(7*K + 3*f)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 38*D1**2*f*fd*r**2 - 100*D1**2*f*fd*r*s + 34*D1**2*f*fd*r - 62*D1**2*f*fd*s**2 + 46*D1**2*f*fd*s - 23*D1**2*f*fd + 50*D1**2*f*fdd*r**2 + 124*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r + 74*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 33*D1**2*f*fdd + 50*D1**2*fd**2*r**2 + 124*D1**2*fd**2*r*s - 54*D1**2*fd**2*r + 74*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s - 8*D1**2*fd**2 + 2*D1**2*fd*r**2 - 10*D1**2*fd*r*s - 28*D1**2*fd*r - 12*D1**2*fd*s**2 - 28*D1**2*fd*s + 14*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 + 356*D1*Dd*K*f*r**2 + 616*D1*Dd*K*f*r*s - 486*D1*Dd*K*f*r + 260*D1*Dd*K*f*s**2 - 414*D1*Dd*K*f*s + 219*D1*Dd*K*f + 8*D1*Dd*K*fd*r**2 + 112*D1*Dd*K*fd*r*s - 46*D1*Dd*K*fd*r + 104*D1*Dd*K*fd*s**2 - 82*D1*Dd*K*fd*s + 12*D1*Dd*K*fd - 76*D1*Dd*f**2*r**2 - 200*D1*Dd*f**2*r*s + 138*D1*Dd*f**2*r - 124*D1*Dd*f**2*s**2 + 174*D1*Dd*f**2*s - 81*D1*Dd*f**2 + 400*D1*Dd*f*fd*r**2 + 992*D1*Dd*f*fd*r*s - 564*D1*Dd*f*fd*r + 592*D1*Dd*f*fd*s**2 - 684*D1*Dd*f*fd*s + 186*D1*Dd*f*fd + 8*D1*Dd*f*r**2 - 40*D1*Dd*f*r*s + 16*D1*Dd*f*r - 48*D1*Dd*f*s**2 + 58*D1*Dd*f*s - 22*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 36*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 36*D1*Dd*fd*s - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 + 4*D1*Ddd*K*f*r**2 + 56*D1*Ddd*K*f*r*s - 30*D1*Ddd*K*f*r + 52*D1*Ddd*K*f*s**2 - 66*D1*Ddd*K*f*s + 27*D1*Ddd*K*f + 100*D1*Ddd*f**2*r**2 + 248*D1*Ddd*f**2*r*s - 174*D1*Ddd*f**2*r + 148*D1*Ddd*f**2*s**2 - 210*D1*Ddd*f**2*s + 99*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + 2*D1*bd1*(D1*(14*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 13*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2)) - 2*Dd*(7*K + 3*f)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 12*Dd**2*K*f*r**2 + 168*Dd**2*K*f*r*s - 90*Dd**2*K*f*r + 156*Dd**2*K*f*s**2 - 198*Dd**2*K*f*s + 54*Dd**2*K*f + 300*Dd**2*f**2*r**2 + 744*Dd**2*f**2*r*s - 522*Dd**2*f**2*r + 444*Dd**2*f**2*s**2 - 630*Dd**2*f**2*s + 198*Dd**2*f**2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) - 13*b1*(528*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*s - 132*C*D1**2*f*fd + 1056*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 1056*C*D1*Dd*f**2*r - 264*C*D1*Dd*f**2*s + 264*C*D1*Dd*f**2 - 66*D1**2*K*bdd1*f*r**2 - 924*D1**2*K*bdd1*f*r*s + 396*D1**2*K*bdd1*f*r - 858*D1**2*K*bdd1*f*s**2 + 1188*D1**2*K*bdd1*f*s - 396*D1**2*K*bdd1*f - 4026*D1**2*K*f*fd*r**2 - 6996*D1**2*K*f*fd*r*s + 4026*D1**2*K*f*fd*r - 2970*D1**2*K*f*fd*s**2 + 3498*D1**2*K*f*fd*s - 2013*D1**2*K*f*fd + 2706*D1**2*K*f*fdd*r**2 + 4620*D1**2*K*f*fdd*r*s - 2706*D1**2*K*f*fdd*r + 1914*D1**2*K*f*fdd*s**2 - 2310*D1**2*K*f*fdd*s + 1353*D1**2*K*f*fdd + 2706*D1**2*K*fd**2*r**2 + 4620*D1**2*K*fd**2*r*s - 2706*D1**2*K*fd**2*r + 1914*D1**2*K*fd**2*s**2 - 2310*D1**2*K*fd**2*s - 1254*D1**2*b2*fd*r**2 - 2508*D1**2*b2*fd*r*s - 1254*D1**2*b2*fd*s**2 + 396*D1**2*b2*fdd*r**2 + 792*D1**2*b2*fdd*r*s + 396*D1**2*b2*fdd*s**2 + 132*D1**2*bd1**2*(7*K + 3*f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 1650*D1**2*bdd1*f**2*r**2 - 4092*D1**2*bdd1*f**2*r*s + 3960*D1**2*bdd1*f**2*r - 2442*D1**2*bdd1*f**2*s**2 + 4752*D1**2*bdd1*f**2*s - 2178*D1**2*bdd1*f**2 - 396*D1**2*bdd1*f*r**2 - 792*D1**2*bdd1*f*r*s + 792*D1**2*bdd1*f*r - 396*D1**2*bdd1*f*s**2 + 792*D1**2*bdd1*f*s - 396*D1**2*bdd1*f - 1848*D1**2*bdd1*g2*r**2 - 3696*D1**2*bdd1*g2*r*s + 1848*D1**2*bdd1*g2*r - 1848*D1**2*bdd1*g2*s**2 + 1848*D1**2*bdd1*g2*s - 924*D1**2*bdd1*g2 + 396*D1**2*bdd2*f*r**2 + 792*D1**2*bdd2*f*r*s - 792*D1**2*bdd2*f*r + 396*D1**2*bdd2*f*s**2 - 792*D1**2*bdd2*f*s + 396*D1**2*bdd2*f + 2274*D1**2*f**2*fd*r**2 + 3774*D1**2*f**2*fd*r*s - 2312*D1**2*f**2*fd*r + 1500*D1**2*f**2*fd*s**2 - 1796*D1**2*f**2*fd*s + 762*D1**2*f**2*fd - 2622*D1**2*f**2*fdd*r**2 - 4362*D1**2*f**2*fdd*r*s + 2740*D1**2*f**2*fdd*r - 1740*D1**2*f**2*fdd*s**2 + 2152*D1**2*f**2*fdd*s - 942*D1**2*f**2*fdd - 5244*D1**2*f*fd**2*r**2 - 8724*D1**2*f*fd**2*r*s + 5480*D1**2*f*fd**2*r - 3480*D1**2*f*fd**2*s**2 + 4304*D1**2*f*fd**2*s - 1092*D1**2*f*fd**2 + 396*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 726*D1**2*f*fd*r + 660*D1**2*f*fd*s**2 - 858*D1**2*f*fd*s + 462*D1**2*f*fd - 396*D1**2*f*fdd*r**2 - 792*D1**2*f*fdd*r*s + 396*D1**2*f*fdd*r - 396*D1**2*f*fdd*s**2 + 396*D1**2*f*fdd*s - 198*D1**2*f*fdd + 5874*D1**2*f*gd2*r**2 + 10164*D1**2*f*gd2*r*s - 10164*D1**2*f*gd2*r + 4290*D1**2*f*gd2*s**2 - 8580*D1**2*f*gd2*s + 4290*D1**2*f*gd2 + 66*D1**2*f*gdd2*r**2 + 924*D1**2*f*gdd2*r*s - 924*D1**2*f*gdd2*r + 858*D1**2*f*gdd2*s**2 - 1716*D1**2*f*gdd2*s + 858*D1**2*f*gdd2 - 396*D1**2*fd**2*r**2 - 792*D1**2*fd**2*r*s + 396*D1**2*fd**2*r - 396*D1**2*fd**2*s**2 + 396*D1**2*fd**2*s + 5874*D1**2*fd*g2*r**2 + 10164*D1**2*fd*g2*r*s + 528*D1**2*fd*g2*r + 4290*D1**2*fd*g2*s**2 + 528*D1**2*fd*g2*s - 264*D1**2*fd*g2 + 132*D1**2*fd*gd2*r**2 + 1848*D1**2*fd*gd2*r*s - 1188*D1**2*fd*gd2*r + 1716*D1**2*fd*gd2*s**2 - 1980*D1**2*fd*gd2*s + 264*D1**2*fd*gd2 + 66*D1**2*fdd*g2*r**2 + 924*D1**2*fdd*g2*r*s - 264*D1**2*fdd*g2*r + 858*D1**2*fdd*g2*s**2 - 264*D1**2*fdd*g2*s + 132*D1**2*fdd*g2 - 8052*D1*Dd*K*f**2*r**2 - 13992*D1*Dd*K*f**2*r*s + 11022*D1*Dd*K*f**2*r - 5940*D1*Dd*K*f**2*s**2 + 9438*D1*Dd*K*f**2*s - 4983*D1*Dd*K*f**2 + 21648*D1*Dd*K*f*fd*r**2 + 36960*D1*Dd*K*f*fd*r*s - 25476*D1*Dd*K*f*fd*r + 15312*D1*Dd*K*f*fd*s**2 - 21516*D1*Dd*K*f*fd*s + 7326*D1*Dd*K*f*fd - 5016*D1*Dd*b2*f*r**2 - 10032*D1*Dd*b2*f*r*s + 7524*D1*Dd*b2*f*r - 5016*D1*Dd*b2*f*s**2 + 7524*D1*Dd*b2*f*s - 3762*D1*Dd*b2*f + 3168*D1*Dd*b2*fd*r**2 + 6336*D1*Dd*b2*fd*r*s - 2376*D1*Dd*b2*fd*r + 3168*D1*Dd*b2*fd*s**2 - 2376*D1*Dd*b2*fd*s + 3032*D1*Dd*f**3*r**2 + 5032*D1*Dd*f**3*r*s - 4032*D1*Dd*f**3*r + 2000*D1*Dd*f**3*s**2 - 3258*D1*Dd*f**3*s + 1758*D1*Dd*f**3 - 20976*D1*Dd*f**2*fd*r**2 - 34896*D1*Dd*f**2*fd*r*s + 24928*D1*Dd*f**2*fd*r - 13920*D1*Dd*f**2*fd*s**2 + 19930*D1*Dd*f**2*fd*s - 7044*D1*Dd*f**2*fd + 792*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 1452*D1*Dd*f**2*r + 1320*D1*Dd*f**2*s**2 - 1848*D1*Dd*f**2*s + 858*D1*Dd*f**2 - 3168*D1*Dd*f*fd*r**2 - 6336*D1*Dd*f*fd*r*s + 3960*D1*Dd*f*fd*r - 3168*D1*Dd*f*fd*s**2 + 3960*D1*Dd*f*fd*s - 1188*D1*Dd*f*fd + 23496*D1*Dd*f*g2*r**2 + 40656*D1*Dd*f*g2*r*s - 32076*D1*Dd*f*g2*r + 17160*D1*Dd*f*g2*s**2 - 27324*D1*Dd*f*g2*s + 14454*D1*Dd*f*g2 + 528*D1*Dd*f*gd2*r**2 + 7392*D1*Dd*f*gd2*r*s - 5676*D1*Dd*f*gd2*r + 6864*D1*Dd*f*gd2*s**2 - 11220*D1*Dd*f*gd2*s + 4356*D1*Dd*f*gd2 + 528*D1*Dd*fd*g2*r**2 + 7392*D1*Dd*fd*g2*r*s - 3036*D1*Dd*fd*g2*r + 6864*D1*Dd*fd*g2*s**2 - 5412*D1*Dd*fd*g2*s + 792*D1*Dd*fd*g2 + 5412*D1*Ddd*K*f**2*r**2 + 9240*D1*Ddd*K*f**2*r*s - 7326*D1*Ddd*K*f**2*r + 3828*D1*Ddd*K*f**2*s**2 - 6138*D1*Ddd*K*f**2*s + 3267*D1*Ddd*K*f**2 + 1584*D1*Ddd*b2*f*r**2 + 3168*D1*Ddd*b2*f*r*s - 2376*D1*Ddd*b2*f*r + 1584*D1*Ddd*b2*f*s**2 - 2376*D1*Ddd*b2*f*s + 1188*D1*Ddd*b2*f - 3496*D1*Ddd*f**3*r**2 - 5816*D1*Ddd*f**3*r*s + 4656*D1*Ddd*f**3*r - 2320*D1*Ddd*f**3*s**2 + 3774*D1*Ddd*f**3*s - 2034*D1*Ddd*f**3 - 792*D1*Ddd*f**2*r**2 - 1584*D1*Ddd*f**2*r*s + 1188*D1*Ddd*f**2*r - 792*D1*Ddd*f**2*s**2 + 1188*D1*Ddd*f**2*s - 594*D1*Ddd*f**2 + 264*D1*Ddd*f*g2*r**2 + 3696*D1*Ddd*f*g2*r*s - 1980*D1*Ddd*f*g2*r + 3432*D1*Ddd*f*g2*s**2 - 4356*D1*Ddd*f*g2*s + 1782*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f**2*(19*r**2 + r*(50*s - 52) + 31*s**2 - 64*s + 29) + f*(14*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 89*K*r**2 - 154*K*r*s + 170*K*r - 65*K*s**2 + 146*K*s - 79*K - 2*fd*(50*r**2 + 124*r*s - 87*r + 74*s**2 - 105*s + 34) - 2*r**2 + 10*r*s - 17*r + 12*s**2 - 31*s + 12) - 2*fd*(K*(r**2 + r*(14*s - 5) + 13*s**2 - 11*s + 1) + 6*r**2 + 6*r*(2*s - 1) + 6*s*(s - 1)) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f**2*(100*r**2 + r*(248*s - 207) + 148*s**2 - 249*s + 102) + f*(K*(4*r**2 + 56*r*s - 27*r + 52*s**2 - 69*s + 21) + 24*r**2 + 48*r*s - 42*r + 24*s**2 - 42*s + 18) + 14*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 66*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 16236*Dd**2*K*f**2*r**2 + 27720*Dd**2*K*f**2*r*s - 21978*Dd**2*K*f**2*r + 11484*Dd**2*K*f**2*s**2 - 18414*Dd**2*K*f**2*s + 6534*Dd**2*K*f**2 + 4752*Dd**2*b2*f*r**2 + 9504*Dd**2*b2*f*r*s - 7128*Dd**2*b2*f*r + 4752*Dd**2*b2*f*s**2 - 7128*Dd**2*b2*f*s + 2376*Dd**2*b2*f - 10488*Dd**2*f**3*r**2 - 17448*Dd**2*f**3*r*s + 13968*Dd**2*f**3*r - 6960*Dd**2*f**3*s**2 + 11322*Dd**2*f**3*s - 4068*Dd**2*f**3 - 2376*Dd**2*f**2*r**2 - 4752*Dd**2*f**2*r*s + 3564*Dd**2*f**2*r - 2376*Dd**2*f**2*s**2 + 3564*Dd**2*f**2*s - 1188*Dd**2*f**2 + 792*Dd**2*f*g2*r**2 + 11088*Dd**2*f*g2*r*s - 5940*Dd**2*f*g2*r + 10296*Dd**2*f*g2*s**2 - 13068*Dd**2*f*g2*s + 3564*Dd**2*f*g2) + 858*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 12*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 12*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 120*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 36*Dd**2*f**2))/(9009*d**2*k3**6) + D1**2*Pk1*Pk3*k1**2*st**6*(40*C - 20)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k3**4) + 2*D1**2*Pk1*Pk3*k1**2*st**4*(132*b1**2*(2*C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 33*b1*(2*C - 1)*(D1**2*(f*(-4*bdd1*s*(2*r + 2*s - 1) + fd*(-8*r*s + 4*r - 22*s**2 + 22*s - 11) + fdd*(8*r*s - 4*r + 18*s**2 - 18*s + 9)) + 2*fd**2*(r*(4*s - 2) + s*(9*s - 9))) + 4*D1*bd1*(2*D1*f*s*(2*r + 2*s - 1) - D1*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*(f*(8*r*s - 4*r + 22*s**2 - 24*s + 11) - 4*fd*(2*s - 1)*(4*r + 9*s - 5)) + Ddd*f*(r*(4 - 8*s) - 18*s**2 + 20*s - 9)) + 2*Dd**2*f**2*(12*r*(2*s - 1) + 54*s**2 - 60*s + 13)) + f*(-132*D1**2*bd1**2*s*(2*C - 1)*(2*r + 2*s - 1) + D1**2*(f*(-8*C*fdd*(4*r*(3*s - 1) + 15*s**2 - 14*s + 5) + 33*bdd1*s*(2*C - 1)*(4*r + 9*s - 4) + 4*fd*(4*C*(12*r*s - 4*r + 15*s**2 - 14*s + 5) - 27*r*s + 9*r - 36*s**2 + 33*s - 12) + 6*fdd*(r*(9*s - 3) + 12*s**2 - 11*s + 4)) - 2*fd**2*(8*C*(4*r*(3*s - 1) + 15*s**2 - 14*s + 2) + r*(18 - 54*s) - 72*s**2 + 66*s - 9)) + 33*D1*bd1*(2*C - 1)*(D1*(f*s*(-4*r - 11*s + 4) + 2*fd*(8*r*s - 2*r + 18*s**2 - 13*s + 2)) + 8*Dd*f*(r*(4*s - 1) + 9*s**2 - 7*s + 1)) + 2*D1*f*(Dd*(16*C*f*(r*(8*s - 4) + 10*s**2 - 12*s + 5) - 32*C*fd*(r*(12*s - 5) + 15*s**2 - 16*s + 4) - 6*f*(6*r*(2*s - 1) + 16*s**2 - 19*s + 8) + 3*fd*(6*r*(12*s - 5) + 96*s**2 - 101*s + 25)) + Ddd*f*(-8*C*(8*r*s - 4*r + 10*s**2 - 12*s + 5) + 36*r*s - 18*r + 48*s**2 - 57*s + 24)) - 6*Dd**2*f**2*(8*C*(r*(8*s - 4) + 10*s**2 - 12*s + 3) + r*(18 - 36*s) - 48*s**2 + 57*s - 14)))/(231*d**2*k3**4) + D1**2*Pk1*Pk3*k1**2*st**2*(33*b1**2*(D1**2*(fd*(C*(86*r - 26*s + 26) - 43*r - 5*s + 5) + fdd*(6*C*r + 62*C*(s - 1) - 3*r - 29*s + 29))*(r + s - 1) + D1*(Dd*(f*(2*C*(172*r**2 + 2*r*(60*s - 73) - 52*s**2 + 22*s + 17) - 172*r**2 - 192*r*s + 182*r - 20*s**2 + 68*s - 53) + 2*fd*(2*C*(12*r**2 + 136*r*s - 105*r + 124*s**2 - 203*s + 79) - 12*r**2 - 128*r*s + 99*r - 116*s**2 + 190*s - 74)) + Ddd*f*(2*C*(12*r**2 + 136*r*s - 74*r + 124*s**2 - 158*s + 65) - 12*r**2 - 128*r*s + 70*r - 116*s**2 + 148*s - 61)) + 2*Dd**2*f*(2*C*(18*r**2 + 3*r*(68*s - 37) + 186*s**2 - 237*s + 65) - 18*r**2 - 3*r*(64*s - 35) - 174*s**2 + 222*s - 61)) + 33*b1*(16*C*D1**2*f*fd*r**2 + 48*C*D1**2*f*fd*r*s - 36*C*D1**2*f*fd*r + 84*C*D1**2*f*fd*s**2 - 112*C*D1**2*f*fd*s + 48*C*D1**2*f*fd - 8*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s + 44*C*D1**2*f*fdd*r - 84*C*D1**2*f*fdd*s**2 + 112*C*D1**2*f*fdd*s - 52*C*D1**2*f*fdd - 8*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s + 44*C*D1**2*fd**2*r - 84*C*D1**2*fd**2*s**2 + 112*C*D1**2*fd**2*s - 28*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r**2 + 96*C*D1*Dd*f**2*r*s - 64*C*D1*Dd*f**2*r + 168*C*D1*Dd*f**2*s**2 - 192*C*D1*Dd*f**2*s + 92*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s + 288*C*D1*Dd*f*fd*r - 672*C*D1*Dd*f*fd*s**2 + 832*C*D1*Dd*f*fd*s - 268*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r*s + 56*C*D1*Ddd*f**2*r - 168*C*D1*Ddd*f**2*s**2 + 192*C*D1*Ddd*f**2*s - 88*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r*s + 168*C*Dd**2*f**2*r - 504*C*Dd**2*f**2*s**2 + 576*C*Dd**2*f**2*s - 132*C*Dd**2*f**2 + D1**2*bdd1*f*(2*C*(6*r**2 + 68*r*s - 6*r + 62*s**2 - 34*s + 3) - 6*r**2 - 64*r*s + 6*r - 58*s**2 + 32*s - 3) - 8*D1**2*f*fd*r**2 - 14*D1**2*f*fd*r*s + 13*D1**2*f*fd*r - 28*D1**2*f*fd*s**2 + 44*D1**2*f*fd*s - 17*D1**2*f*fd + 4*D1**2*f*fdd*r**2 + 14*D1**2*f*fdd*r*s - 17*D1**2*f*fdd*r + 28*D1**2*f*fdd*s**2 - 44*D1**2*f*fdd*s + 19*D1**2*f*fdd + 4*D1**2*fd**2*r**2 + 14*D1**2*fd**2*r*s - 17*D1**2*fd**2*r + 28*D1**2*fd**2*s**2 - 44*D1**2*fd**2*s + 16*D1**2*fd**2 - 16*D1*Dd*f**2*r**2 - 28*D1*Dd*f**2*r*s + 22*D1*Dd*f**2*r - 56*D1*Dd*f**2*s**2 + 63*D1*Dd*f**2*s - 32*D1*Dd*f**2 + 32*D1*Dd*f*fd*r**2 + 112*D1*Dd*f*fd*r*s - 104*D1*Dd*f*fd*r + 224*D1*Dd*f*fd*s**2 - 302*D1*Dd*f*fd*s + 105*D1*Dd*f*fd + 8*D1*Ddd*f**2*r**2 + 28*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 56*D1*Ddd*f**2*s**2 - 63*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + D1*bd1*(D1*(f*(2*C*(86*r**2 + 60*r*s - 86*r - 26*s**2 - 30*s + 43) - 86*r**2 - 96*r*s + 86*r - 10*s**2 + 48*s - 43) + 2*fd*(2*C*(6*r**2 + 68*r*s - 37*r + 62*s**2 - 79*s + 17) - 6*r**2 - 64*r*s + 35*r - 58*s**2 + 74*s - 16)) + 2*Dd*f*(2*C*(24*r**2 + 272*r*s - 86*r + 248*s**2 - 226*s + 37) - 24*r**2 - 256*r*s + 82*r - 232*s**2 + 212*s - 35)) + 24*Dd**2*f**2*r**2 + 84*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 168*Dd**2*f**2*s**2 - 189*Dd**2*f**2*s + 42*Dd**2*f**2) + f*(-2166*C*D1**2*f*fd*r**2 - 10668*C*D1**2*f*fd*r*s + 5000*C*D1**2*f*fd*r - 7428*C*D1**2*f*fd*s**2 + 8508*C*D1**2*f*fd*s - 3198*C*D1**2*f*fd + 2370*C*D1**2*f*fdd*r**2 + 10284*C*D1**2*f*fdd*r*s - 5008*C*D1**2*f*fdd*r + 7080*C*D1**2*f*fdd*s**2 - 8148*C*D1**2*f*fdd*s + 3150*C*D1**2*f*fdd + 4740*C*D1**2*fd**2*r**2 + 20568*C*D1**2*fd**2*r*s - 10016*C*D1**2*fd**2*r + 14160*C*D1**2*fd**2*s**2 - 16296*C*D1**2*fd**2*s + 3428*C*D1**2*fd**2 - 2888*C*D1*Dd*f**2*r**2 - 14224*C*D1*Dd*f**2*r*s + 8556*C*D1*Dd*f**2*r - 9904*C*D1*Dd*f**2*s**2 + 13460*C*D1*Dd*f**2*s - 5674*C*D1*Dd*f**2 + 18960*C*D1*Dd*f*fd*r**2 + 82272*C*D1*Dd*f*fd*r*s - 45340*C*D1*Dd*f*fd*r + 56640*C*D1*Dd*f*fd*s**2 - 71196*C*D1*Dd*f*fd*s + 21304*C*D1*Dd*f*fd + 3160*C*D1*Ddd*f**2*r**2 + 13712*C*D1*Ddd*f**2*r*s - 8436*C*D1*Ddd*f**2*r + 9440*C*D1*Ddd*f**2*s**2 - 12868*C*D1*Ddd*f**2*s + 5510*C*D1*Ddd*f**2 + 9480*C*Dd**2*f**2*r**2 + 41136*C*Dd**2*f**2*r*s - 25308*C*Dd**2*f**2*r + 28320*C*Dd**2*f**2*s**2 - 38604*C*Dd**2*f**2*s + 11576*C*Dd**2*f**2 + 66*D1**2*bd1**2*(r**2*(6*C - 3) + r*(68*C*s - 6*C - 32*s + 3) + s*(62*C*s - 34*C - 29*s + 16)) - 33*D1**2*bdd1*f*(2*C*(2*r**2 + 12*r*s + 6*r + 21*s**2 + 2*s - 3) - 2*r**2 - 7*r*s - 6*r - 14*s**2 - 9*s + 3) + 1083*D1**2*f*fd*r**2 + 6027*D1**2*f*fd*r*s - 2731*D1**2*f*fd*r + 4461*D1**2*f*fd*s**2 - 4983*D1**2*f*fd*s + 1848*D1**2*f*fd - 1185*D1**2*f*fdd*r**2 - 5835*D1**2*f*fdd*r*s + 2735*D1**2*f*fdd*r - 4359*D1**2*f*fdd*s**2 + 4851*D1**2*f*fdd*s - 1848*D1**2*f*fdd - 2370*D1**2*fd**2*r**2 - 11670*D1**2*fd**2*r*s + 5470*D1**2*fd**2*r - 8718*D1**2*fd**2*s**2 + 9702*D1**2*fd**2*s - 1945*D1**2*fd**2 + 1444*D1*Dd*f**2*r**2 + 8036*D1*Dd*f**2*r*s - 4740*D1*Dd*f**2*r + 5948*D1*Dd*f**2*s**2 - 7957*D1*Dd*f**2*s + 3335*D1*Dd*f**2 - 9480*D1*Dd*f*fd*r**2 - 46680*D1*Dd*f*fd*r*s + 24980*D1*Dd*f*fd*r - 34872*D1*Dd*f*fd*s**2 + 42675*D1*Dd*f*fd*s - 12437*D1*Dd*f*fd - 1580*D1*Ddd*f**2*r**2 - 7780*D1*Ddd*f**2*r*s + 4680*D1*Ddd*f**2*r - 5812*D1*Ddd*f**2*s**2 + 7757*D1*Ddd*f**2*s - 3301*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f*(C*(8*r**2 + 24*r*s - 4*r + 42*s**2 + 4*s + 2) - 4*r**2 - 7*r*s + 2*r - 14*s**2 - 9*s - 1) + fd*(-4*C*(4*r**2 + 24*r*s - 5*r + 42*s**2 - 26*s - 1) + 8*r**2 + 28*r*s - 5*r + 56*s**2 - 26*s - 9)) + Dd*f*(-4*C*(8*r**2 + 48*r*s - 2*r + 84*s**2 - 44*s - 5) + 16*r**2 + 56*r*s + 6*r + 112*s**2 - 27*s - 24)) - 4740*Dd**2*f**2*r**2 - 23340*Dd**2*f**2*r*s + 14040*Dd**2*f**2*r - 17436*Dd**2*f**2*s**2 + 23271*Dd**2*f**2*s - 6796*Dd**2*f**2))/(693*d**2*k3**4) - 2*D1**2*Pk1*Pk3*k1**2*(-70*D1**2*K*bd1**2*f*r**2 - 148*D1**2*K*bd1**2*f*r*s + 214*D1**2*K*bd1**2*f*r - 76*D1**2*K*bd1**2*f*s**2 + 216*D1**2*K*bd1**2*f*s - 140*D1**2*K*bd1**2*f + 68*D1**2*K*bd1*f**2*r**2 + 106*D1**2*K*bd1*f**2*r*s - 106*D1**2*K*bd1*f**2*r + 53*D1**2*K*bd1*f**2*s**2 - 106*D1**2*K*bd1*f**2*s + 53*D1**2*K*bd1*f**2 - 304*D1**2*K*bd1*f*fd*r**2 - 584*D1**2*K*bd1*f*fd*r*s + 444*D1**2*K*bd1*f*fd*r - 264*D1**2*K*bd1*f*fd*s**2 + 410*D1**2*K*bd1*f*fd*s - 146*D1**2*K*bd1*f*fd - 76*D1**2*K*bdd1*f**2*r**2 - 146*D1**2*K*bdd1*f**2*r*s + 146*D1**2*K*bdd1*f**2*r - 66*D1**2*K*bdd1*f**2*s**2 + 132*D1**2*K*bdd1*f**2*s - 66*D1**2*K*bdd1*f**2 + 42*D1**2*bd1**2*f**2*r*s - 21*D1**2*bd1**2*f**2*r + 42*D1**2*bd1**2*f**2*s**2 - 75*D1**2*bd1**2*f**2*s + 33*D1**2*bd1**2*f**2 + 42*D1**2*bd1**2*f*r*s - 21*D1**2*bd1**2*f*r + 40*D1**2*bd1**2*f*s**2 - 73*D1**2*bd1**2*f*s + 33*D1**2*bd1**2*f - 112*D1**2*bd1**2*g2*r**2 - 224*D1**2*bd1**2*g2*r*s + 112*D1**2*bd1**2*g2*r - 112*D1**2*bd1**2*g2*s**2 + 112*D1**2*bd1**2*g2*s - 70*D1**2*bd1*bd2*f*r**2 - 140*D1**2*bd1*bd2*f*r*s + 140*D1**2*bd1*bd2*f*r - 70*D1**2*bd1*bd2*f*s**2 + 140*D1**2*bd1*bd2*f*s - 70*D1**2*bd1*bd2*f - 30*D1**2*bd1*f**3*r*s + 30*D1**2*bd1*f**3*r - 22*D1**2*bd1*f**3*s**2 + 56*D1**2*bd1*f**3*s - 28*D1**2*bd1*f**3 + 180*D1**2*bd1*f**2*fd*r*s - 120*D1**2*bd1*f**2*fd*r + 132*D1**2*bd1*f**2*fd*s**2 - 230*D1**2*bd1*f**2*fd*s + 86*D1**2*bd1*f**2*fd - 18*D1**2*bd1*f**2*r*s + 18*D1**2*bd1*f**2*r - 24*D1**2*bd1*f**2*s**2 + 48*D1**2*bd1*f**2*s - 24*D1**2*bd1*f**2 + 120*D1**2*bd1*f*fd*r*s - 60*D1**2*bd1*f*fd*r + 108*D1**2*bd1*f*fd*s**2 - 138*D1**2*bd1*f*fd*s + 30*D1**2*bd1*f*fd - 42*D1**2*bd1*f*g2*r**2 - 100*D1**2*bd1*f*g2*r*s + 168*D1**2*bd1*f*g2*r - 82*D1**2*bd1*f*g2*s**2 + 168*D1**2*bd1*f*g2*s - 84*D1**2*bd1*f*g2 + 140*D1**2*bd1*f*gd2*r**2 + 296*D1**2*bd1*f*gd2*r*s - 428*D1**2*bd1*f*gd2*r + 152*D1**2*bd1*f*gd2*s**2 - 432*D1**2*bd1*f*gd2*s + 280*D1**2*bd1*f*gd2 + 140*D1**2*bd1*fd*g2*r**2 + 296*D1**2*bd1*fd*g2*r*s - 140*D1**2*bd1*fd*g2*r + 152*D1**2*bd1*fd*g2*s**2 - 148*D1**2*bd1*fd*g2*s + 26*D1**2*bd2*f**2*r**2 + 44*D1**2*bd2*f**2*r*s - 44*D1**2*bd2*f**2*r + 18*D1**2*bd2*f**2*s**2 - 36*D1**2*bd2*f**2*s + 18*D1**2*bd2*f**2 - 136*D1**2*bd2*f*fd*r**2 - 256*D1**2*bd2*f*fd*r*s + 196*D1**2*bd2*f*fd*r - 120*D1**2*bd2*f*fd*s**2 + 184*D1**2*bd2*f*fd*s - 64*D1**2*bd2*f*fd + 30*D1**2*bdd1*f**3*r*s - 30*D1**2*bdd1*f**3*r + 22*D1**2*bdd1*f**3*s**2 - 56*D1**2*bdd1*f**3*s + 28*D1**2*bdd1*f**3 + 30*D1**2*bdd1*f**2*r*s - 30*D1**2*bdd1*f**2*r + 27*D1**2*bdd1*f**2*s**2 - 54*D1**2*bdd1*f**2*s + 27*D1**2*bdd1*f**2 + 70*D1**2*bdd1*f*g2*r**2 + 148*D1**2*bdd1*f*g2*r*s - 280*D1**2*bdd1*f*g2*r + 76*D1**2*bdd1*f*g2*s**2 - 280*D1**2*bdd1*f*g2*s + 140*D1**2*bdd1*f*g2 - 34*D1**2*bdd2*f**2*r**2 - 64*D1**2*bdd2*f**2*r*s + 64*D1**2*bdd2*f**2*r - 30*D1**2*bdd2*f**2*s**2 + 60*D1**2*bdd2*f**2*s - 30*D1**2*bdd2*f**2 + 20*D1**2*f**3*fd*s**2 - 20*D1**2*f**3*fd*s + 10*D1**2*f**3*fd - 20*D1**2*f**3*fdd*s**2 + 20*D1**2*f**3*fdd*s - 10*D1**2*f**3*fdd - 60*D1**2*f**2*fd**2*s**2 + 60*D1**2*f**2*fd**2*s - 10*D1**2*f**2*fd**2 - 136*D1**2*f**2*gd2*r**2 - 212*D1**2*f**2*gd2*r*s + 212*D1**2*f**2*gd2*r - 106*D1**2*f**2*gd2*s**2 + 212*D1**2*f**2*gd2*s - 106*D1**2*f**2*gd2 + 152*D1**2*f**2*gdd2*r**2 + 292*D1**2*f**2*gdd2*r*s - 292*D1**2*f**2*gdd2*r + 132*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 132*D1**2*f**2*gdd2 - 272*D1**2*f*fd*g2*r**2 - 424*D1**2*f*fd*g2*r*s + 272*D1**2*f*fd*g2*r - 212*D1**2*f*fd*g2*s**2 + 212*D1**2*f*fd*g2*s - 136*D1**2*f*fd*g2 + 608*D1**2*f*fd*gd2*r**2 + 1168*D1**2*f*fd*gd2*r*s - 888*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 820*D1**2*f*fd*gd2*s + 292*D1**2*f*fd*gd2 + 304*D1**2*f*fdd*g2*r**2 + 584*D1**2*f*fdd*g2*r*s - 304*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 292*D1**2*f*fdd*g2*s + 152*D1**2*f*fdd*g2 + 304*D1**2*fd**2*g2*r**2 + 584*D1**2*fd**2*g2*r*s - 304*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 292*D1**2*fd**2*g2*s - 608*D1*Dd*K*bd1*f**2*r**2 - 1168*D1*Dd*K*bd1*f**2*r*s + 1028*D1*Dd*K*bd1*f**2*r - 528*D1*Dd*K*bd1*f**2*s**2 + 938*D1*Dd*K*bd1*f**2*s - 410*D1*Dd*K*bd1*f**2 + 240*D1*Dd*bd1*f**3*r*s - 180*D1*Dd*bd1*f**3*r + 176*D1*Dd*bd1*f**3*s**2 - 342*D1*Dd*bd1*f**3*s + 142*D1*Dd*bd1*f**3 + 240*D1*Dd*bd1*f**2*r*s - 180*D1*Dd*bd1*f**2*r + 216*D1*Dd*bd1*f**2*s**2 - 354*D1*Dd*bd1*f**2*s + 138*D1*Dd*bd1*f**2 + 560*D1*Dd*bd1*f*g2*r**2 + 1184*D1*Dd*bd1*f*g2*r*s - 1556*D1*Dd*bd1*f*g2*r + 608*D1*Dd*bd1*f*g2*s**2 - 1572*D1*Dd*bd1*f*g2*s + 840*D1*Dd*bd1*f*g2 - 272*D1*Dd*bd2*f**2*r**2 - 512*D1*Dd*bd2*f**2*r*s + 452*D1*Dd*bd2*f**2*r - 240*D1*Dd*bd2*f**2*s**2 + 424*D1*Dd*bd2*f**2*s - 184*D1*Dd*bd2*f**2 + 20*D1*Dd*f**4*s**2 - 20*D1*Dd*f**4*s + 10*D1*Dd*f**4 - 160*D1*Dd*f**3*fd*s**2 + 160*D1*Dd*f**3*fd*s - 40*D1*Dd*f**3*fd - 544*D1*Dd*f**2*g2*r**2 - 848*D1*Dd*f**2*g2*r*s + 696*D1*Dd*f**2*g2*r - 424*D1*Dd*f**2*g2*s**2 + 636*D1*Dd*f**2*g2*s - 348*D1*Dd*f**2*g2 + 1216*D1*Dd*f**2*gd2*r**2 + 2336*D1*Dd*f**2*gd2*r*s - 2056*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1876*D1*Dd*f**2*gd2*s + 820*D1*Dd*f**2*gd2 + 2432*D1*Dd*f*fd*g2*r**2 + 4672*D1*Dd*f*fd*g2*r*s - 2992*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2808*D1*Dd*f*fd*g2*s + 888*D1*Dd*f*fd*g2 - 20*D1*Ddd*f**4*s**2 + 20*D1*Ddd*f**4*s - 10*D1*Ddd*f**4 + 608*D1*Ddd*f**2*g2*r**2 + 1168*D1*Ddd*f**2*g2*r*s - 888*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 820*D1*Ddd*f**2*g2*s + 416*D1*Ddd*f**2*g2 - 60*Dd**2*f**4*s**2 + 60*Dd**2*f**4*s - 10*Dd**2*f**4 + 1824*Dd**2*f**2*g2*r**2 + 3504*Dd**2*f**2*g2*r*s - 2664*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 2460*Dd**2*f**2*g2*s + 848*Dd**2*f**2*g2 + 14*b1**3*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(-4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(r*(6 - 8*s) - 8*s**2 + 13*s - 5) + 8*r*s - 4*r + 8*s**2 - 10*s + 4) + Ddd*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2) - 4*r*s + 2*r - 4*s**2 + 5*s - 2)) + Dd**2*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4) - 12*r*s + 6*r - 12*s**2 + 15*s - 4)) + b1**2*(21*D1**2*K*fd*r**2 + 50*D1**2*K*fd*r*s + 42*D1**2*K*fd*r + 41*D1**2*K*fd*s**2 + 34*D1**2*K*fd*s - 21*D1**2*K*fd - 35*D1**2*K*fdd*r**2 - 74*D1**2*K*fdd*r*s - 70*D1**2*K*fdd*r - 38*D1**2*K*fdd*s**2 - 66*D1**2*K*fdd*s + 35*D1**2*K*fdd + 14*D1**2*bdd1*(2*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(-3*r*s + r - 3*s**2 + 3*s - 1) - 3*r*s + r - 3*s**2 + 3*s - 1) - 42*D1**2*f*fd*r*s + 21*D1**2*f*fd*r - 42*D1**2*f*fd*s**2 + 30*D1**2*f*fd*s - 21*D1**2*f*fd + 42*D1**2*f*fdd*r*s - 21*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s + 21*D1**2*f*fdd + 42*D1**2*fd**2*r*s - 21*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s - 12*D1**2*fd**2 - 7*D1**2*fd*r*s - 19*D1**2*fd*s**2 - 10*D1**2*fd*s + 21*D1**2*fdd*r*s + 20*D1**2*fdd*s**2 + 12*D1**2*fdd*s + 112*D1**2*gd2*r**2 + 224*D1**2*gd2*r*s - 224*D1**2*gd2*r + 112*D1**2*gd2*s**2 - 224*D1**2*gd2*s + 112*D1**2*gd2 - 56*D1**2*gdd2*r**2 - 112*D1**2*gdd2*r*s + 112*D1**2*gdd2*r - 56*D1**2*gdd2*s**2 + 112*D1**2*gdd2*s - 56*D1**2*gdd2 + 84*D1*Dd*K*f*r**2 + 200*D1*Dd*K*f*r*s - 142*D1*Dd*K*f*r + 164*D1*Dd*K*f*s**2 - 214*D1*Dd*K*f*s + 103*D1*Dd*K*f - 280*D1*Dd*K*fd*r**2 - 592*D1*Dd*K*fd*r*s - 62*D1*Dd*K*fd*r - 304*D1*Dd*K*fd*s**2 - 38*D1*Dd*K*fd*s + 202*D1*Dd*K*fd - 84*D1*Dd*f**2*r*s + 42*D1*Dd*f**2*r - 84*D1*Dd*f**2*s**2 + 105*D1*Dd*f**2*s - 42*D1*Dd*f**2 + 336*D1*Dd*f*fd*r*s - 168*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 330*D1*Dd*f*fd*s + 81*D1*Dd*f*fd - 28*D1*Dd*f*r*s + 14*D1*Dd*f*r - 76*D1*Dd*f*s**2 + 83*D1*Dd*f*s - 38*D1*Dd*f + 168*D1*Dd*fd*r*s - 42*D1*Dd*fd*r + 160*D1*Dd*fd*s**2 - 53*D1*Dd*fd*s - 24*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 896*D1*Dd*g2*r*s - 672*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 672*D1*Dd*g2*s + 336*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 896*D1*Dd*gd2*r*s + 784*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 784*D1*Dd*gd2*s - 336*D1*Dd*gd2 - 140*D1*Ddd*K*f*r**2 - 296*D1*Ddd*K*f*r*s + 218*D1*Ddd*K*f*r - 152*D1*Ddd*K*f*s**2 + 226*D1*Ddd*K*f*s - 111*D1*Ddd*K*f + 84*D1*Ddd*f**2*r*s - 42*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 105*D1*Ddd*f**2*s + 42*D1*Ddd*f**2 + 84*D1*Ddd*f*r*s - 42*D1*Ddd*f*r + 80*D1*Ddd*f*s**2 - 101*D1*Ddd*f*s + 40*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 448*D1*Ddd*g2*r*s + 336*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 336*D1*Ddd*g2*s - 168*D1*Ddd*g2 + 14*D1*bd1*(D1*(-4*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd*(r*(4 - 6*s) - 6*s**2 + 9*s - 3) + 6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(4*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(r*(10 - 24*s) - 24*s**2 + 27*s - 7) - 24*r*s + 10*r - 24*s**2 + 27*s - 7)) - 420*Dd**2*K*f*r**2 - 888*Dd**2*K*f*r*s + 654*Dd**2*K*f*r - 456*Dd**2*K*f*s**2 + 678*Dd**2*K*f*s - 224*Dd**2*K*f + 252*Dd**2*f**2*r*s - 126*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 315*Dd**2*f**2*s + 84*Dd**2*f**2 + 252*Dd**2*f*r*s - 126*Dd**2*f*r + 240*Dd**2*f*s**2 - 303*Dd**2*f*s + 82*Dd**2*f - 672*Dd**2*g2*r**2 - 1344*Dd**2*g2*r*s + 1008*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 1008*Dd**2*g2*s - 336*Dd**2*g2) + b1*(-70*D1**2*K*bdd1*f*r**2 - 148*D1**2*K*bdd1*f*r*s + 214*D1**2*K*bdd1*f*r - 76*D1**2*K*bdd1*f*s**2 + 216*D1**2*K*bdd1*f*s - 108*D1**2*K*bdd1*f + 136*D1**2*K*f*fd*r**2 + 212*D1**2*K*f*fd*r*s - 136*D1**2*K*f*fd*r + 106*D1**2*K*f*fd*s**2 - 106*D1**2*K*f*fd*s + 68*D1**2*K*f*fd - 152*D1**2*K*f*fdd*r**2 - 292*D1**2*K*f*fdd*r*s + 152*D1**2*K*f*fdd*r - 132*D1**2*K*f*fdd*s**2 + 146*D1**2*K*f*fdd*s - 76*D1**2*K*f*fdd - 152*D1**2*K*fd**2*r**2 - 292*D1**2*K*fd**2*r*s + 152*D1**2*K*fd**2*r - 132*D1**2*K*fd**2*s**2 + 146*D1**2*K*fd**2*s + 21*D1**2*b2*fd*r**2 + 42*D1**2*b2*fd*r*s + 21*D1**2*b2*fd*s**2 - 35*D1**2*b2*fdd*r**2 - 70*D1**2*b2*fdd*r*s - 35*D1**2*b2*fdd*s**2 - 14*D1**2*bd1**2*(-4*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*r*s - 2*r + 6*s**2 - 6*s + 1) + 42*D1**2*bdd1*f**2*r*s - 21*D1**2*bdd1*f**2*r + 42*D1**2*bdd1*f**2*s**2 - 75*D1**2*bdd1*f**2*s + 21*D1**2*bdd1*f**2 + 42*D1**2*bdd1*f*r*s - 21*D1**2*bdd1*f*r + 40*D1**2*bdd1*f*s**2 - 73*D1**2*bdd1*f*s + 20*D1**2*bdd1*f - 112*D1**2*bdd1*g2*r**2 - 224*D1**2*bdd1*g2*r*s + 112*D1**2*bdd1*g2*r - 112*D1**2*bdd1*g2*s**2 + 112*D1**2*bdd1*g2*s - 56*D1**2*bdd1*g2 - 35*D1**2*bdd2*f*r**2 - 70*D1**2*bdd2*f*r*s + 70*D1**2*bdd2*f*r - 35*D1**2*bdd2*f*s**2 + 70*D1**2*bdd2*f*s - 35*D1**2*bdd2*f - 90*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r - 66*D1**2*f**2*fd*s**2 + 62*D1**2*f**2*fd*s - 16*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r*s - 30*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 62*D1**2*f**2*fdd*s + 16*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r*s - 60*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 124*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 - 36*D1**2*f*fd*r*s - 48*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s + 60*D1**2*f*fdd*r*s + 54*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s - 42*D1**2*f*gd2*r**2 - 100*D1**2*f*gd2*r*s + 100*D1**2*f*gd2*r - 82*D1**2*f*gd2*s**2 + 164*D1**2*f*gd2*s - 82*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 148*D1**2*f*gdd2*r*s - 148*D1**2*f*gdd2*r + 76*D1**2*f*gdd2*s**2 - 152*D1**2*f*gdd2*s + 76*D1**2*f*gdd2 + 60*D1**2*fd**2*r*s + 54*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s - 42*D1**2*fd*g2*r**2 - 100*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*r - 82*D1**2*fd*g2*s**2 - 68*D1**2*fd*g2*s + 42*D1**2*fd*g2 + 140*D1**2*fd*gd2*r**2 + 296*D1**2*fd*gd2*r*s - 8*D1**2*fd*gd2*r + 152*D1**2*fd*gd2*s**2 - 20*D1**2*fd*gd2*s - 132*D1**2*fd*gd2 + 70*D1**2*fdd*g2*r**2 + 148*D1**2*fdd*g2*r*s + 140*D1**2*fdd*g2*r + 76*D1**2*fdd*g2*s**2 + 132*D1**2*fdd*g2*s - 70*D1**2*fdd*g2 + 272*D1*Dd*K*f**2*r**2 + 424*D1*Dd*K*f**2*r*s - 348*D1*Dd*K*f**2*r + 212*D1*Dd*K*f**2*s**2 - 318*D1*Dd*K*f**2*s + 174*D1*Dd*K*f**2 - 1216*D1*Dd*K*f*fd*r**2 - 2336*D1*Dd*K*f*fd*r*s + 1496*D1*Dd*K*f*fd*r - 1056*D1*Dd*K*f*fd*s**2 + 1404*D1*Dd*K*f*fd*s - 444*D1*Dd*K*f*fd + 84*D1*Dd*b2*f*r**2 + 168*D1*Dd*b2*f*r*s - 126*D1*Dd*b2*f*r + 84*D1*Dd*b2*f*s**2 - 126*D1*Dd*b2*f*s + 63*D1*Dd*b2*f - 280*D1*Dd*b2*fd*r**2 - 560*D1*Dd*b2*fd*r*s + 210*D1*Dd*b2*fd*r - 280*D1*Dd*b2*fd*s**2 + 210*D1*Dd*b2*fd*s - 120*D1*Dd*f**3*r*s + 60*D1*Dd*f**3*r - 88*D1*Dd*f**3*s**2 + 118*D1*Dd*f**3*s - 44*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r*s - 300*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 602*D1*Dd*f**2*fd*s + 154*D1*Dd*f**2*fd - 72*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 114*D1*Dd*f**2*s - 48*D1*Dd*f**2 + 480*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 432*D1*Dd*f*fd*s**2 - 396*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 168*D1*Dd*f*g2*r**2 - 400*D1*Dd*f*g2*r*s + 284*D1*Dd*f*g2*r - 328*D1*Dd*f*g2*s**2 + 428*D1*Dd*f*g2*s - 206*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 1184*D1*Dd*f*gd2*r*s - 1028*D1*Dd*f*gd2*r + 608*D1*Dd*f*gd2*s**2 - 1060*D1*Dd*f*gd2*s + 452*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 1184*D1*Dd*fd*g2*r*s + 124*D1*Dd*fd*g2*r + 608*D1*Dd*fd*g2*s**2 + 76*D1*Dd*fd*g2*s - 404*D1*Dd*fd*g2 - 304*D1*Ddd*K*f**2*r**2 - 584*D1*Ddd*K*f**2*r*s + 444*D1*Ddd*K*f**2*r - 264*D1*Ddd*K*f**2*s**2 + 410*D1*Ddd*K*f**2*s - 208*D1*Ddd*K*f**2 - 140*D1*Ddd*b2*f*r**2 - 280*D1*Ddd*b2*f*r*s + 210*D1*Ddd*b2*f*r - 140*D1*Ddd*b2*f*s**2 + 210*D1*Ddd*b2*f*s - 105*D1*Ddd*b2*f + 120*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 118*D1*Ddd*f**3*s + 44*D1*Ddd*f**3 + 120*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 108*D1*Ddd*f**2*s**2 - 138*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 592*D1*Ddd*f*g2*r*s - 436*D1*Ddd*f*g2*r + 304*D1*Ddd*f*g2*s**2 - 452*D1*Ddd*f*g2*s + 222*D1*Ddd*f*g2 - D1*bd1*(D1*(3*f**2*(7*r*(2*s - 1) + 14*s**2 - 25*s + 7) - f*(K*(42*r**2 + 2*r*(50*s - 67) + 82*s**2 - 166*s + 83) + 21*fd*(2*s - 1)*(4*r + 4*s - 3) - 14*r*s + 7*r - 38*s**2 + 55*s - 19) + fd*(2*K*(70*r**2 + 37*r*(4*s - 1) + 76*s**2 - 42*s - 33) + r*(21 - 84*s) - 80*s**2 + 49*s + 12) - 112*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 112*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*(-3*f**2*(2*s - 1)*(56*r + 56*s - 57) + f*(2*K*(280*r**2 + 592*r*s - 646*r + 304*s**2 - 658*s + 323) - (2*s - 1)*(168*r + 160*s - 167)) + 112*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 7*D1*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) - 912*Dd**2*K*f**2*r**2 - 1752*Dd**2*K*f**2*r*s + 1332*Dd**2*K*f**2*r - 792*Dd**2*K*f**2*s**2 + 1230*Dd**2*K*f**2*s - 424*Dd**2*K*f**2 - 420*Dd**2*b2*f*r**2 - 840*Dd**2*b2*f*r*s + 630*Dd**2*b2*f*r - 420*Dd**2*b2*f*s**2 + 630*Dd**2*b2*f*s - 210*Dd**2*b2*f + 360*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 354*Dd**2*f**3*s + 104*Dd**2*f**3 + 360*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 324*Dd**2*f**2*s**2 - 414*Dd**2*f**2*s + 114*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 1776*Dd**2*f*g2*r*s - 1308*Dd**2*f*g2*r + 912*Dd**2*f*g2*s**2 - 1356*Dd**2*f*g2*s + 448*Dd**2*f*g2) + b2*(-35*D1**2*bdd1*f*(r + s - 1)**2 + 2*D1**2*(f*(fd*(26*r**2 + 44*r*s - 26*r + 18*s**2 - 22*s + 13) - fdd*(34*r**2 + 64*r*s - 34*r + 30*s**2 - 32*s + 17)) - 2*fd**2*(17*r**2 + r*(32*s - 17) + s*(15*s - 16))) + 7*D1*bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 2*D1*f*(Dd*(f*(52*r**2 + 88*r*s - 70*r + 36*s**2 - 58*s + 31) - 2*fd*(136*r**2 + 256*r*s - 166*r + 120*s**2 - 156*s + 49)) - Ddd*f*(68*r**2 + 2*r*(64*s - 49) + 60*s**2 - 92*s + 47)) - 4*Dd**2*f**2*(102*r**2 + 3*r*(64*s - 49) + 90*s**2 - 138*s + 47)))/(21*d**2*k3**4) + D1**2*Pk1*Pk3*k1**2*st**4*(16*C - 8)*(66*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s))) + 33*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(2*s**2 - 2*s + 1) + fd*(-2*s**2 + 3*s - 1)) - 2*D1*Ddd*f*(2*s**2 - 2*s + 1) - 2*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) - 2*s*(33*bd1**2*s + fd**2*(3*s - 2))) + 2*D1*f*(2*Dd*(2*f*s**2 - 2*f*s + f - 6*fd*s**2 + 5*fd*s - fd) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(231*d**2*k2**2*k3**2) - D1**2*Pk1*Pk3*k1**2*st**2*(2*C - 1)*(14*D1*b1*s*(-5*D1*bdd1*f*s + bd1*(7*D1*f*s - 10*D1*fd*(s - 1) + 20*Dd*f*(1 - 2*s))) + 7*b1**2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + 2*D1*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(2*s**2 - 3*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(7*fd - 5*fdd)*(3*s**2 - 2*s + 1) - 10*s*(7*bd1**2*s + fd**2*(3*s - 2))) + 2*D1*f*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(6*s**2 - 5*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k2**2*k3**2) - 20*D1**2*Pk1*Pk3*k2**6*st**6*(429*b1**2*(D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 26*b1*f*(-33*D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 66*D1*bd1*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 2*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f**2*(-858*D1**2*bd1**2*(r + s - 1)**2 + 52*D1**2*bdd1*f*(r + s - 1)**2 + 15*D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 104*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + 15*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(3003*d**2*k3**8) - 20*D1**2*Pk1*Pk3*k2**4*st**6*(792*C*D1**2*b1*f*fd*r**2 + 1056*C*D1**2*b1*f*fd*r*s - 528*C*D1**2*b1*f*fd*r + 264*C*D1**2*b1*f*fd*s**2 - 264*C*D1**2*b1*f*fd*s + 132*C*D1**2*b1*f*fd - 396*C*D1**2*b1*f*fdd*r**2 - 528*C*D1**2*b1*f*fdd*r*s + 264*C*D1**2*b1*f*fdd*r - 132*C*D1**2*b1*f*fdd*s**2 + 132*C*D1**2*b1*f*fdd*s - 66*C*D1**2*b1*f*fdd - 396*C*D1**2*b1*fd**2*r**2 - 528*C*D1**2*b1*fd**2*r*s + 264*C*D1**2*b1*fd**2*r - 132*C*D1**2*b1*fd**2*s**2 + 132*C*D1**2*b1*fd**2*s + 36*C*D1**2*f**2*fd*r**2 + 48*C*D1**2*f**2*fd*r*s - 40*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 16*C*D1**2*f**2*fd - 18*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 20*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 36*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 40*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 1584*C*D1*Dd*b1*f**2*r**2 + 2112*C*D1*Dd*b1*f**2*r*s - 1848*C*D1*Dd*b1*f**2*r + 528*C*D1*Dd*b1*f**2*s**2 - 1056*C*D1*Dd*b1*f**2*s + 660*C*D1*Dd*b1*f**2 - 3168*C*D1*Dd*b1*f*fd*r**2 - 4224*C*D1*Dd*b1*f*fd*r*s + 2904*C*D1*Dd*b1*f*fd*r - 1056*C*D1*Dd*b1*f*fd*s**2 + 1584*C*D1*Dd*b1*f*fd*s - 528*C*D1*Dd*b1*f*fd + 48*C*D1*Dd*f**3*r**2 + 64*C*D1*Dd*f**3*r*s - 56*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 32*C*D1*Dd*f**3*s + 20*C*D1*Dd*f**3 - 144*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 164*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 96*C*D1*Dd*f**2*fd*s - 44*C*D1*Dd*f**2*fd - 792*C*D1*Ddd*b1*f**2*r**2 - 1056*C*D1*Ddd*b1*f**2*r*s + 924*C*D1*Ddd*b1*f**2*r - 264*C*D1*Ddd*b1*f**2*s**2 + 528*C*D1*Ddd*b1*f**2*s - 330*C*D1*Ddd*b1*f**2 - 24*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 28*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 16*C*D1*Ddd*f**3*s - 10*C*D1*Ddd*f**3 - 2376*C*Dd**2*b1*f**2*r**2 - 3168*C*Dd**2*b1*f**2*r*s + 2772*C*Dd**2*b1*f**2*r - 792*C*Dd**2*b1*f**2*s**2 + 1584*C*Dd**2*b1*f**2*s - 660*C*Dd**2*b1*f**2 - 72*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 84*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 48*C*Dd**2*f**3*s - 20*C*Dd**2*f**3 - 528*D1**2*b1*f*fd*r**2 - 660*D1**2*b1*f*fd*r*s + 330*D1**2*b1*f*fd*r - 132*D1**2*b1*f*fd*s**2 + 132*D1**2*b1*f*fd*s - 66*D1**2*b1*f*fd + 264*D1**2*b1*f*fdd*r**2 + 330*D1**2*b1*f*fdd*r*s - 165*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s**2 - 66*D1**2*b1*f*fdd*s + 33*D1**2*b1*f*fdd + 264*D1**2*b1*fd**2*r**2 + 330*D1**2*b1*fd**2*r*s - 165*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)*(2*C*(3*r + s - 3) - 4*r - s + 4) - 24*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 26*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 14*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 13*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 7*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 24*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 26*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 14*D1**2*f*fd**2*s + 5*D1**2*f*fd**2 - 1056*D1*Dd*b1*f**2*r**2 - 1320*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s**2 + 594*D1*Dd*b1*f**2*s - 396*D1*Dd*b1*f**2 + 2112*D1*Dd*b1*f*fd*r**2 + 2640*D1*Dd*b1*f*fd*r*s - 1848*D1*Dd*b1*f*fd*r + 528*D1*Dd*b1*f*fd*s**2 - 858*D1*Dd*b1*f*fd*s + 297*D1*Dd*b1*f*fd - 32*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 18*D1*Dd*f**3*s - 12*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 106*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 55*D1*Dd*f**2*fd*s + 27*D1*Dd*f**2*fd + 528*D1*Ddd*b1*f**2*r**2 + 660*D1*Ddd*b1*f**2*r*s - 594*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s**2 - 297*D1*Ddd*b1*f**2*s + 198*D1*Ddd*b1*f**2 + 16*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 18*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 9*D1*Ddd*f**3*s + 6*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(2*f*(r + s - 1)*(2*C*(3*r + s - 3) - 4*r - s + 4) + fd*(-4*C*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) + 16*r**2 + 20*r*s - 21*r + 4*s**2 - 12*s + 5)) + Dd*f*(-4*C*(12*r**2 + 16*r*s - 19*r + 4*s**2 - 12*s + 7) + 32*r**2 + 40*r*s - 50*r + 8*s**2 - 29*s + 18)) + 1584*Dd**2*b1*f**2*r**2 + 1980*Dd**2*b1*f**2*r*s - 1782*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s**2 - 891*Dd**2*b1*f**2*s + 396*Dd**2*b1*f**2 + 48*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 54*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 27*Dd**2*f**3*s + 12*Dd**2*f**3)/(693*d**2*k3**6) - 4*D1**2*Pk1*Pk3*k2**4*st**4*(-5148*C*D1**2*bd1*f**2*r**2 - 6864*C*D1**2*bd1*f**2*r*s + 10296*C*D1**2*bd1*f**2*r - 1716*C*D1**2*bd1*f**2*s**2 + 6864*C*D1**2*bd1*f**2*s - 5148*C*D1**2*bd1*f**2 - 5148*D1**2*K*bd1**2*f*r**2 - 6864*D1**2*K*bd1**2*f*r*s + 8580*D1**2*K*bd1**2*f*r - 1716*D1**2*K*bd1**2*f*s**2 + 5148*D1**2*K*bd1**2*f*s - 3432*D1**2*K*bd1**2*f + 6006*D1**2*bd1**2*f**2*r**2 + 13728*D1**2*bd1**2*f**2*r*s - 12870*D1**2*bd1**2*f**2*r + 7722*D1**2*bd1**2*f**2*s**2 - 14586*D1**2*bd1**2*f**2*s + 6864*D1**2*bd1**2*f**2 + 1716*D1**2*bd1**2*f*r**2 + 1716*D1**2*bd1**2*f*r*s - 2574*D1**2*bd1**2*f*r - 858*D1**2*bd1**2*f*s + 858*D1**2*bd1**2*f - 1716*D1**2*bd1*bd2*f*r**2 - 3432*D1**2*bd1*bd2*f*r*s + 3432*D1**2*bd1*bd2*f*r - 1716*D1**2*bd1*bd2*f*s**2 + 3432*D1**2*bd1*bd2*f*s - 1716*D1**2*bd1*bd2*f + 572*D1**2*bd1*f**3*r**2 + 936*D1**2*bd1*f**3*r*s - 1248*D1**2*bd1*f**3*r + 364*D1**2*bd1*f**3*s**2 - 1040*D1**2*bd1*f**3*s + 832*D1**2*bd1*f**3 - 1716*D1**2*bd1*f**2*fd*r**2 - 2808*D1**2*bd1*f**2*fd*r*s + 2756*D1**2*bd1*f**2*fd*r - 1092*D1**2*bd1*f**2*fd*s**2 + 2236*D1**2*bd1*f**2*fd*s - 832*D1**2*bd1*f**2*fd + 3432*D1**2*bd1*f**2*r**2 + 4290*D1**2*bd1*f**2*r*s - 6864*D1**2*bd1*f**2*r + 858*D1**2*bd1*f**2*s**2 - 4290*D1**2*bd1*f**2*s + 3432*D1**2*bd1*f**2 - 10296*D1**2*bd1*f*g2*r**2 - 13728*D1**2*bd1*f*g2*r*s + 20592*D1**2*bd1*f*g2*r - 3432*D1**2*bd1*f*g2*s**2 + 13728*D1**2*bd1*f*g2*s - 10296*D1**2*bd1*f*g2 + 10296*D1**2*bd1*f*gd2*r**2 + 13728*D1**2*bd1*f*gd2*r*s - 17160*D1**2*bd1*f*gd2*r + 3432*D1**2*bd1*f*gd2*s**2 - 10296*D1**2*bd1*f*gd2*s + 6864*D1**2*bd1*f*gd2 + 10296*D1**2*bd1*fd*g2*r**2 + 13728*D1**2*bd1*fd*g2*r*s - 10296*D1**2*bd1*fd*g2*r + 3432*D1**2*bd1*fd*g2*s**2 - 6864*D1**2*bd1*fd*g2*s - 286*D1**2*bdd1*f**3*r**2 - 468*D1**2*bdd1*f**3*r*s + 624*D1**2*bdd1*f**3*r - 182*D1**2*bdd1*f**3*s**2 + 520*D1**2*bdd1*f**3*s - 416*D1**2*bdd1*f**3 + 5148*D1**2*bdd1*f*g2*r**2 + 6864*D1**2*bdd1*f*g2*r*s - 10296*D1**2*bdd1*f*g2*r + 1716*D1**2*bdd1*f*g2*s**2 - 6864*D1**2*bdd1*f*g2*s + 5148*D1**2*bdd1*f*g2 - 60*D1**2*f**3*fd*r**2 - 1672*D1**2*f**3*fd*r*s + 866*D1**2*f**3*fd*r - 1612*D1**2*f**3*fd*s**2 + 2030*D1**2*f**3*fd*s - 821*D1**2*f**3*fd + 1044*D1**2*f**3*fdd*r**2 + 2968*D1**2*f**3*fdd*r*s - 2006*D1**2*f**3*fdd*r + 1924*D1**2*f**3*fdd*s**2 - 2666*D1**2*f**3*fdd*s + 1223*D1**2*f**3*fdd + 3132*D1**2*f**2*fd**2*r**2 + 8904*D1**2*f**2*fd**2*r*s - 6018*D1**2*f**2*fd**2*r + 5772*D1**2*f**2*fd**2*s**2 - 7998*D1**2*f**2*fd**2*s + 2446*D1**2*f**2*fd**2 - 2288*D1*Dd*bd1*f**3*r**2 - 3744*D1*Dd*bd1*f**3*r*s + 4004*D1*Dd*bd1*f**3*r - 1456*D1*Dd*bd1*f**3*s**2 + 3276*D1*Dd*bd1*f**3*s - 1664*D1*Dd*bd1*f**3 + 41184*D1*Dd*bd1*f*g2*r**2 + 54912*D1*Dd*bd1*f*g2*r*s - 65208*D1*Dd*bd1*f*g2*r + 13728*D1*Dd*bd1*f*g2*s**2 - 41184*D1*Dd*bd1*f*g2*s + 24024*D1*Dd*bd1*f*g2 - 60*D1*Dd*f**4*r**2 - 1672*D1*Dd*f**4*r*s + 866*D1*Dd*f**4*r - 1612*D1*Dd*f**4*s**2 + 2030*D1*Dd*f**4*s - 821*D1*Dd*f**4 + 8352*D1*Dd*f**3*fd*r**2 + 23744*D1*Dd*f**3*fd*r*s - 16048*D1*Dd*f**3*fd*r + 15392*D1*Dd*f**3*fd*s**2 - 21328*D1*Dd*f**3*fd*s + 7338*D1*Dd*f**3*fd + 1044*D1*Ddd*f**4*r**2 + 2968*D1*Ddd*f**4*r*s - 2006*D1*Ddd*f**4*r + 1924*D1*Ddd*f**4*s**2 - 2666*D1*Ddd*f**4*s + 1223*D1*Ddd*f**4 + 858*D1*b2*(-D1*bdd1*f*(r + s - 1) + 2*bd1*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)))*(r + s - 1) + 3132*Dd**2*f**4*r**2 + 8904*Dd**2*f**4*r*s - 6018*Dd**2*f**4*r + 5772*Dd**2*f**4*s**2 - 7998*Dd**2*f**4*s + 2446*Dd**2*f**4 + 858*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(12*D1**2*K*fd*r**2 + 16*D1**2*K*fd*r*s + 4*D1**2*K*fd*s**2 - 6*D1**2*K*fdd*r**2 - 8*D1**2*K*fdd*r*s - 2*D1**2*K*fdd*s**2 - 2*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 10*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 14*D1**2*f*fd*s**2 + 14*D1**2*f*fd*s - 7*D1**2*f*fd + 14*D1**2*f*fdd*r**2 + 32*D1**2*f*fdd*r*s - 16*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 14*D1**2*fd**2*r**2 + 32*D1**2*fd**2*r*s - 16*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 4*D1**2*fd*r**2 - 4*D1**2*fd*r*s + 2*D1**2*fdd*r**2 + 2*D1**2*fdd*r*s + 48*D1*Dd*K*f*r**2 + 64*D1*Dd*K*f*r*s - 56*D1*Dd*K*f*r + 16*D1*Dd*K*f*s**2 - 32*D1*Dd*K*f*s + 20*D1*Dd*K*f - 48*D1*Dd*K*fd*r**2 - 64*D1*Dd*K*fd*r*s + 28*D1*Dd*K*fd*r - 16*D1*Dd*K*fd*s**2 + 16*D1*Dd*K*fd*s - 20*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 34*D1*Dd*f**2*r - 28*D1*Dd*f**2*s**2 + 40*D1*Dd*f**2*s - 19*D1*Dd*f**2 + 112*D1*Dd*f*fd*r**2 + 256*D1*Dd*f*fd*r*s - 156*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 176*D1*Dd*f*fd*s + 52*D1*Dd*f*fd - 16*D1*Dd*f*r**2 - 16*D1*Dd*f*r*s + 16*D1*Dd*f*r + 4*D1*Dd*f*s - 4*D1*Dd*f + 16*D1*Dd*fd*r**2 + 16*D1*Dd*fd*r*s - 8*D1*Dd*fd*r - 2*D1*Dd*fd*s - 24*D1*Ddd*K*f*r**2 - 32*D1*Ddd*K*f*r*s + 28*D1*Ddd*K*f*r - 8*D1*Ddd*K*f*s**2 + 16*D1*Ddd*K*f*s - 10*D1*Ddd*K*f + 28*D1*Ddd*f**2*r**2 + 64*D1*Ddd*f**2*r*s - 46*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 52*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 + 8*D1*Ddd*f*r**2 + 8*D1*Ddd*f*r*s - 8*D1*Ddd*f*r - 2*D1*Ddd*f*s + 2*D1*Ddd*f + 4*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 72*Dd**2*K*f*r**2 - 96*Dd**2*K*f*r*s + 84*Dd**2*K*f*r - 24*Dd**2*K*f*s**2 + 48*Dd**2*K*f*s - 20*Dd**2*K*f + 84*Dd**2*f**2*r**2 + 192*Dd**2*f**2*r*s - 138*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 156*Dd**2*f**2*s + 50*Dd**2*f**2 + 24*Dd**2*f*r**2 + 24*Dd**2*f*r*s - 24*Dd**2*f*r - 6*Dd**2*f*s + 4*Dd**2*f) - 26*b1*(396*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s - 264*C*D1**2*f*fd*r + 132*C*D1**2*f*fd*s**2 - 132*C*D1**2*f*fd*s + 66*C*D1**2*f*fd + 792*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 924*C*D1*Dd*f**2*r + 264*C*D1*Dd*f**2*s**2 - 528*C*D1*Dd*f**2*s + 330*C*D1*Dd*f**2 + 198*D1**2*K*bdd1*f*r**2 + 264*D1**2*K*bdd1*f*r*s - 330*D1**2*K*bdd1*f*r + 66*D1**2*K*bdd1*f*s**2 - 198*D1**2*K*bdd1*f*s + 132*D1**2*K*bdd1*f - 66*D1**2*b2*fd*r**2 - 132*D1**2*b2*fd*r*s - 66*D1**2*b2*fd*s**2 + 33*D1**2*b2*fdd*r**2 + 66*D1**2*b2*fdd*r*s + 33*D1**2*b2*fdd*s**2 + 66*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 231*D1**2*bdd1*f**2*r**2 - 528*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*r - 297*D1**2*bdd1*f**2*s**2 + 561*D1**2*bdd1*f**2*s - 264*D1**2*bdd1*f**2 - 66*D1**2*bdd1*f*r**2 - 66*D1**2*bdd1*f*r*s + 99*D1**2*bdd1*f*r + 33*D1**2*bdd1*f*s - 33*D1**2*bdd1*f + 33*D1**2*bdd2*f*r**2 + 66*D1**2*bdd2*f*r*s - 66*D1**2*bdd2*f*r + 33*D1**2*bdd2*f*s**2 - 66*D1**2*bdd2*f*s + 33*D1**2*bdd2*f - 66*D1**2*f**2*fd*r**2 - 108*D1**2*f**2*fd*r*s + 68*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 52*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 33*D1**2*f**2*fdd*r**2 + 54*D1**2*f**2*fdd*r*s - 34*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s**2 - 26*D1**2*f**2*fdd*s + 9*D1**2*f**2*fdd + 66*D1**2*f*fd**2*r**2 + 108*D1**2*f*fd**2*r*s - 68*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s**2 - 52*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 330*D1**2*f*fd*r*s + 165*D1**2*f*fd*r - 66*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 33*D1**2*f*fd + 396*D1**2*f*gd2*r**2 + 528*D1**2*f*gd2*r*s - 528*D1**2*f*gd2*r + 132*D1**2*f*gd2*s**2 - 264*D1**2*f*gd2*s + 132*D1**2*f*gd2 - 198*D1**2*f*gdd2*r**2 - 264*D1**2*f*gdd2*r*s + 264*D1**2*f*gdd2*r - 66*D1**2*f*gdd2*s**2 + 132*D1**2*f*gdd2*s - 66*D1**2*f*gdd2 + 396*D1**2*fd*g2*r**2 + 528*D1**2*fd*g2*r*s + 132*D1**2*fd*g2*s**2 - 396*D1**2*fd*gd2*r**2 - 528*D1**2*fd*gd2*r*s + 264*D1**2*fd*gd2*r - 132*D1**2*fd*gd2*s**2 + 132*D1**2*fd*gd2*s - 198*D1**2*fdd*g2*r**2 - 264*D1**2*fdd*g2*r*s - 66*D1**2*fdd*g2*s**2 - 264*D1*Dd*b2*f*r**2 - 528*D1*Dd*b2*f*r*s + 396*D1*Dd*b2*f*r - 264*D1*Dd*b2*f*s**2 + 396*D1*Dd*b2*f*s - 198*D1*Dd*b2*f + 264*D1*Dd*b2*fd*r**2 + 528*D1*Dd*b2*fd*r*s - 198*D1*Dd*b2*fd*r + 264*D1*Dd*b2*fd*s**2 - 198*D1*Dd*b2*fd*s - 88*D1*Dd*f**3*r**2 - 144*D1*Dd*f**3*r*s + 116*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 92*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 264*D1*Dd*f**2*fd*r**2 + 432*D1*Dd*f**2*fd*r*s - 310*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s**2 - 242*D1*Dd*f**2*fd*s + 86*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 660*D1*Dd*f**2*r*s + 594*D1*Dd*f**2*r - 132*D1*Dd*f**2*s**2 + 297*D1*Dd*f**2*s - 198*D1*Dd*f**2 + 1584*D1*Dd*f*g2*r**2 + 2112*D1*Dd*f*g2*r*s - 1848*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s**2 - 1056*D1*Dd*f*g2*s + 660*D1*Dd*f*g2 - 1584*D1*Dd*f*gd2*r**2 - 2112*D1*Dd*f*gd2*r*s + 1980*D1*Dd*f*gd2*r - 528*D1*Dd*f*gd2*s**2 + 1056*D1*Dd*f*gd2*s - 528*D1*Dd*f*gd2 - 1584*D1*Dd*fd*g2*r**2 - 2112*D1*Dd*fd*g2*r*s + 924*D1*Dd*fd*g2*r - 528*D1*Dd*fd*g2*s**2 + 528*D1*Dd*fd*g2*s + 132*D1*Ddd*b2*f*r**2 + 264*D1*Ddd*b2*f*r*s - 198*D1*Ddd*b2*f*r + 132*D1*Ddd*b2*f*s**2 - 198*D1*Ddd*b2*f*s + 99*D1*Ddd*b2*f + 44*D1*Ddd*f**3*r**2 + 72*D1*Ddd*f**3*r*s - 58*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 46*D1*Ddd*f**3*s + 25*D1*Ddd*f**3 - 792*D1*Ddd*f*g2*r**2 - 1056*D1*Ddd*f*g2*r*s + 924*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2*s**2 + 528*D1*Ddd*f*g2*s - 330*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(f**2*(5*r**2 + r*(12*s - 11) + 7*s**2 - 13*s + 6) - f*(fd*(28*r**2 + r*(64*s - 46) + 36*s**2 - 52*s + 17) + (2*r + 2*s - 2)*(2*K*(3*r + s - 2) - 2*r + 1)) + fd*(K*s*(4*s - 6) + r**2*(12*K - 4) + r*(2*K*(8*s - 5) - 4*s + 3) + s)) + Dd*f*(2*K*(24*r**2 + 32*r*s - 34*r + 8*s**2 - 20*s + 11) - f*(56*r**2 + 2*r*(64*s - 53) + 72*s**2 - 120*s + 49) - 16*r**2 - 16*r*s + 20*r + 6*s - 5)) - 66*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 396*Dd**2*b2*f*r**2 + 792*Dd**2*b2*f*r*s - 594*Dd**2*b2*f*r + 396*Dd**2*b2*f*s**2 - 594*Dd**2*b2*f*s + 198*Dd**2*b2*f + 132*Dd**2*f**3*r**2 + 216*Dd**2*f**3*r*s - 174*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 138*Dd**2*f**3*s + 50*Dd**2*f**3 - 2376*Dd**2*f*g2*r**2 - 3168*Dd**2*f*g2*r*s + 2772*Dd**2*f*g2*r - 792*Dd**2*f*g2*s**2 + 1584*Dd**2*f*g2*s - 660*Dd**2*f*g2))/(3003*d**2*k3**6) - 10*D1**2*Pk1*Pk3*k2**2*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(4*C*(r*(4*s - 2) + 2*s**2 - 2*s + 1) + r*(5 - 10*s) - 4*s**2 + 4*s - 2) + fd**2*(-r*(8*C - 5)*(2*s - 1) + 4*s*(-2*C*(s - 1) + s - 1))) + D1*f*(Dd*(2*f*(8*C*(2*s - 1)*(2*r + s - 1) - 20*r*s + 10*r - 8*s**2 + 13*s - 4) - fd*(2*s - 1)*(8*C*(8*r + 4*s - 3) - 40*r - 16*s + 13)) + Ddd*f*(-8*C*(2*s - 1)*(2*r + s - 1) + 20*r*s - 10*r + 8*s**2 - 13*s + 4)) + Dd**2*f**2*(-24*C*(2*s - 1)*(2*r + s - 1) + 30*r*(2*s - 1) + 24*s**2 - 39*s + 14)) + f*(D1**2*(f*(-33*bdd1*s*(4*C*(2*r + s - 2) - 5*r - 2*s + 5) + 2*fd*(4*C*(3*s - 1)*(2*r + s - 1) - 15*r*s + 5*r - 6*s**2 + 9*s - 2) + fdd*(-4*C*(3*s - 1)*(2*r + s - 1) + 15*r*s - 5*r + 6*s**2 - 9*s + 2)) + fd**2*(-8*C*(3*s - 1)*(2*r + s - 1) + 10*r*(3*s - 1) + 12*s**2 - 18*s + 5)) + 33*D1*bd1*(D1*(2*f*s*(4*C*(2*r + s - 2) - 5*r - 2*s + 5) + fd*(-8*C*(4*r*s - r + 2*s**2 - 3*s + 1) + 20*r*s - 5*r + 8*s**2 - 14*s + 5)) + Dd*f*(-8*C*(8*r*s - 2*r + 4*s**2 - 7*s + 2) + 40*r*s - 10*r + 16*s**2 - 33*s + 10)) + D1*f*(Dd*(2*f*(8*C*(2*s - 1)*(2*r + s - 1) - 20*r*s + 10*r - 8*s**2 + 13*s - 4) + fd*(-8*C*(12*s - 5)*(2*r + s - 1) + 120*r*s - 50*r + 48*s**2 - 75*s + 23)) + Ddd*f*(-8*C*(2*s - 1)*(2*r + s - 1) + 20*r*s - 10*r + 8*s**2 - 13*s + 4)) + Dd**2*f**2*(-24*C*(2*s - 1)*(2*r + s - 1) + 30*r*(2*s - 1) + 24*s**2 - 39*s + 14)))/(693*d**2*k3**4) - 2*D1**2*Pk1*Pk3*k2**2*st**4*(66*b1**2*(4*C - 3)*(D1**2*r*(2*fd - fdd)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-8*r**2 - 8*r*(s - 1) + s - 1)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + 33*b1*(-24*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 40*C*D1**2*f*fd*s**2 + 40*C*D1**2*f*fd*s - 20*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 96*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 36*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 18*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 96*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 36*C*D1**2*fd**2*s**2 - 36*C*D1**2*fd**2*s - 48*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 120*C*D1*Dd*f**2*r - 80*C*D1*Dd*f**2*s**2 + 128*C*D1*Dd*f**2*s - 52*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 768*C*D1*Dd*f*fd*r*s - 464*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 384*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 192*C*D1*Ddd*f**2*r*s - 136*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 56*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 576*C*Dd**2*f**2*r*s - 408*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 132*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + 2*r*(s - 1) - s + 1) + 16*D1**2*f*fd*r**2 + 54*D1**2*f*fd*r*s - 27*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 - 14*D1**2*f*fd*s + 7*D1**2*f*fd - 24*D1**2*f*fdd*r**2 - 58*D1**2*f*fdd*r*s + 29*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 24*D1**2*fd**2*r**2 - 58*D1**2*fd**2*r*s + 29*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 32*D1*Dd*f**2*r**2 + 108*D1*Dd*f**2*r*s - 70*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 - 55*D1*Dd*f**2*s + 22*D1*Dd*f**2 - 192*D1*Dd*f*fd*r**2 - 464*D1*Dd*f*fd*r*s + 280*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 202*D1*Dd*f*fd*s - 65*D1*Dd*f*fd - 48*D1*Ddd*f**2*r**2 - 116*D1*Ddd*f**2*r*s + 82*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 65*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 + 2*D1*bd1*(4*C - 3)*(D1*(f*(4*r**2 + 4*r*(s - 1) - 2*s + 2) + fd*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 144*Dd**2*f**2*r**2 - 348*Dd**2*f**2*r*s + 246*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 195*Dd**2*f**2*s - 76*Dd**2*f**2) + f*(-426*C*D1**2*f*fd*r**2 - 144*C*D1**2*f*fd*r*s + 332*C*D1**2*f*fd*r + 12*C*D1**2*f*fd*s**2 + 40*C*D1**2*f*fd*s - 138*C*D1**2*f*fd + 312*C*D1**2*f*fdd*r**2 + 72*C*D1**2*f*fdd*r*s - 232*C*D1**2*f*fdd*r - 6*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 102*C*D1**2*f*fdd + 624*C*D1**2*fd**2*r**2 + 144*C*D1**2*fd**2*r*s - 464*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s + 24*C*D1**2*fd**2 - 568*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 380*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 + 32*C*D1*Dd*f**2*s - 134*C*D1*Dd*f**2 + 2496*C*D1*Dd*f*fd*r**2 + 576*C*D1*Dd*f*fd*r*s - 1696*C*D1*Dd*f*fd*r - 48*C*D1*Dd*f*fd*s**2 - 128*C*D1*Dd*f*fd*s + 272*C*D1*Dd*f*fd + 416*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 256*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 - 16*C*D1*Ddd*f**2*s + 100*C*D1*Ddd*f**2 + 1248*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 768*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 - 48*C*Dd**2*f**2*s + 44*C*Dd**2*f**2 - 66*D1**2*bd1**2*(4*C - 3)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(2*C*(10*r**2 + 4*r*(6*s - 5) + 9*s**2 - 24*s + 10) - 12*r**2 - 29*r*s + 24*r - 9*s**2 + 29*s - 12) + 195*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s - 126*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s + 49*D1**2*f*fd - 147*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s + 96*D1**2*f*fdd*r + 24*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s - 41*D1**2*f*fdd - 294*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s + 192*D1**2*fd**2*r + 48*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s + 2*D1**2*fd**2 + 260*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s - 122*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 + 68*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 1176*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s + 666*D1*Dd*f*fd*r + 192*D1*Dd*f*fd*s**2 - 174*D1*Dd*f*fd*s - 60*D1*Dd*f*fd - 196*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s + 94*D1*Ddd*f**2*r + 32*D1*Ddd*f**2*s**2 - 34*D1*Ddd*f**2*s - 33*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(4*C*(3*r**2 + 12*r*s - 6*r + 5*s**2 - 12*s + 3) - 8*r**2 - 27*r*s + 16*r - 7*s**2 + 27*s - 8) + fd*(-4*C*(20*r**2 + 48*r*s - 32*r + 18*s**2 - 33*s + 12) + 48*r**2 + 116*r*s - 77*r + 36*s**2 - 76*s + 29)) + Dd*f*(-8*C*(20*r**2 + 48*r*s - 37*r + 18*s**2 - 39*s + 17) + 96*r**2 + 232*r*s - 178*r + 72*s**2 - 181*s + 82)) - 588*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s + 282*Dd**2*f**2*r + 96*Dd**2*f**2*s**2 - 102*Dd**2*f**2*s + 20*Dd**2*f**2))/(231*d**2*k3**4) + D1**2*Pk1*Pk3*k2**2*st**2*(-2574*C*D1**2*bd1*f**2*r**2 - 3432*C*D1**2*bd1*f**2*r*s - 1716*C*D1**2*bd1*f**2*r + 858*C*D1**2*bd1*f**2 + 2574*C*D1**2*f**2*fd*r**2 - 1716*C*D1**2*f**2*fd*r + 858*C*D1**2*f**2*fd + 3432*C*D1*Dd*f**3*r**2 - 1716*C*D1*Dd*f**3*r + 858*C*D1*Dd*f**3 - 62634*D1**2*K*bd1**2*f*r**2 - 96096*D1**2*K*bd1**2*f*r*s + 107250*D1**2*K*bd1**2*f*r - 29172*D1**2*K*bd1**2*f*s**2 + 75504*D1**2*K*bd1**2*f*s - 46332*D1**2*K*bd1**2*f + 6006*D1**2*K*bd1*f**2*r**2 - 3432*D1**2*K*bd1*f**2*r*s + 3432*D1**2*K*bd1*f**2*r - 1716*D1**2*K*bd1*f**2*s**2 + 3432*D1**2*K*bd1*f**2*s - 1716*D1**2*K*bd1*f**2 + 5148*D1**2*K*bd1*f*fd*r**2 + 34320*D1**2*K*bd1*f*fd*r*s - 19734*D1**2*K*bd1*f*fd*r + 10296*D1**2*K*bd1*f*fd*s**2 - 18876*D1**2*K*bd1*f*fd*s + 8580*D1**2*K*bd1*f*fd + 1287*D1**2*K*bdd1*f**2*r**2 + 8580*D1**2*K*bdd1*f**2*r*s - 8580*D1**2*K*bdd1*f**2*r + 2574*D1**2*K*bdd1*f**2*s**2 - 5148*D1**2*K*bdd1*f**2*s + 2574*D1**2*K*bdd1*f**2 + 16302*D1**2*bd1**2*f**2*r**2 + 33462*D1**2*bd1**2*f**2*r*s - 35607*D1**2*bd1**2*f**2*r + 17160*D1**2*bd1**2*f**2*s**2 - 39897*D1**2*bd1**2*f**2*s + 18447*D1**2*bd1**2*f**2 + 7722*D1**2*bd1**2*f*r**2 + 6006*D1**2*bd1**2*f*r*s - 9009*D1**2*bd1**2*f*r - 6006*D1**2*bd1**2*f*s**2 + 3861*D1**2*bd1**2*f*s + 2145*D1**2*bd1**2*f - 48048*D1**2*bd1**2*g2*r**2 - 48048*D1**2*bd1**2*g2*r*s + 48048*D1**2*bd1**2*g2*r + 24024*D1**2*bd1**2*g2*s - 30030*D1**2*bd1*bd2*f*r**2 - 60060*D1**2*bd1*bd2*f*r*s + 60060*D1**2*bd1*bd2*f*r - 30030*D1**2*bd1*bd2*f*s**2 + 60060*D1**2*bd1*bd2*f*s - 30030*D1**2*bd1*bd2*f + 3705*D1**2*bd1*f**3*r**2 + 11804*D1**2*bd1*f**3*r*s - 9659*D1**2*bd1*f**3*r + 3861*D1**2*bd1*f**3*s**2 - 11583*D1**2*bd1*f**3*s + 7267*D1**2*bd1*f**3 - 32994*D1**2*bd1*f**2*fd*r**2 - 102336*D1**2*bd1*f**2*fd*r*s + 74932*D1**2*bd1*f**2*fd*r - 38610*D1**2*bd1*f**2*fd*s**2 + 72826*D1**2*bd1*f**2*fd*s - 26091*D1**2*bd1*f**2*fd + 6006*D1**2*bd1*f**2*r**2 + 15015*D1**2*bd1*f**2*r*s - 9867*D1**2*bd1*f**2*r + 4719*D1**2*bd1*f**2*s**2 - 8580*D1**2*bd1*f**2*s + 3003*D1**2*bd1*f**2 - 15444*D1**2*bd1*f*fd*r**2 - 32604*D1**2*bd1*f*fd*r*s + 24024*D1**2*bd1*f*fd*r - 12012*D1**2*bd1*f*fd*s**2 + 20163*D1**2*bd1*f*fd*s - 8151*D1**2*bd1*f*fd - 41184*D1**2*bd1*f*g2*r**2 - 48048*D1**2*bd1*f*g2*r*s + 68640*D1**2*bd1*f*g2*r - 10296*D1**2*bd1*f*g2*s**2 + 41184*D1**2*bd1*f*g2*s - 34320*D1**2*bd1*f*g2 + 125268*D1**2*bd1*f*gd2*r**2 + 192192*D1**2*bd1*f*gd2*r*s - 214500*D1**2*bd1*f*gd2*r + 58344*D1**2*bd1*f*gd2*s**2 - 151008*D1**2*bd1*f*gd2*s + 92664*D1**2*bd1*f*gd2 + 125268*D1**2*bd1*fd*g2*r**2 + 192192*D1**2*bd1*fd*g2*r*s - 125268*D1**2*bd1*fd*g2*r + 58344*D1**2*bd1*fd*g2*s**2 - 96096*D1**2*bd1*fd*g2*s + 2145*D1**2*bd2*f**2*r**2 + 858*D1**2*bd2*f**2*r*s - 858*D1**2*bd2*f**2*r - 1287*D1**2*bd2*f**2*s**2 + 2574*D1**2*bd2*f**2*s - 1287*D1**2*bd2*f**2 + 8580*D1**2*bd2*f*fd*r**2 + 17160*D1**2*bd2*f*fd*r*s - 12870*D1**2*bd2*f*fd*r + 8580*D1**2*bd2*f*fd*s**2 - 12870*D1**2*bd2*f*fd*s + 4290*D1**2*bd2*f*fd - 5499*D1**2*bdd1*f**3*r**2 - 17056*D1**2*bdd1*f**3*r*s + 14911*D1**2*bdd1*f**3*r - 6435*D1**2*bdd1*f**3*s**2 + 15015*D1**2*bdd1*f**3*s - 9425*D1**2*bdd1*f**3 - 3861*D1**2*bdd1*f**2*r**2 - 8151*D1**2*bdd1*f**2*r*s + 8151*D1**2*bdd1*f**2*r - 3003*D1**2*bdd1*f**2*s**2 + 6006*D1**2*bdd1*f**2*s - 3003*D1**2*bdd1*f**2 + 62634*D1**2*bdd1*f*g2*r**2 + 96096*D1**2*bdd1*f*g2*r*s - 118404*D1**2*bdd1*f*g2*r + 29172*D1**2*bdd1*f*g2*s**2 - 92664*D1**2*bdd1*f*g2*s + 59202*D1**2*bdd1*f*g2 + 2145*D1**2*bdd2*f**2*r**2 + 4290*D1**2*bdd2*f**2*r*s - 4290*D1**2*bdd2*f**2*r + 2145*D1**2*bdd2*f**2*s**2 - 4290*D1**2*bdd2*f**2*s + 2145*D1**2*bdd2*f**2 - 5060*D1**2*f**3*fd*r**2 - 30420*D1**2*f**3*fd*r*s + 17740*D1**2*f**3*fd*r - 30888*D1**2*f**3*fd*s**2 + 38493*D1**2*f**3*fd*s - 16709*D1**2*f**3*fd + 3700*D1**2*f**3*fdd*r**2 + 30420*D1**2*f**3*fdd*r*s - 17060*D1**2*f**3*fdd*r + 30888*D1**2*f**3*fdd*s**2 - 38493*D1**2*f**3*fdd*s + 16369*D1**2*f**3*fdd + 11100*D1**2*f**2*fd**2*r**2 + 91260*D1**2*f**2*fd**2*r*s - 51180*D1**2*f**2*fd**2*r + 92664*D1**2*f**2*fd**2*s**2 - 115479*D1**2*f**2*fd**2*s + 30654*D1**2*f**2*fd**2 - 5148*D1**2*f**2*fd*r**2 - 2574*D1**2*f**2*fd*r*s + 4290*D1**2*f**2*fd*r + 858*D1**2*f**2*fd*s - 1716*D1**2*f**2*fd - 12012*D1**2*f**2*gd2*r**2 + 6864*D1**2*f**2*gd2*r*s - 6864*D1**2*f**2*gd2*r + 3432*D1**2*f**2*gd2*s**2 - 6864*D1**2*f**2*gd2*s + 3432*D1**2*f**2*gd2 - 2574*D1**2*f**2*gdd2*r**2 - 17160*D1**2*f**2*gdd2*r*s + 17160*D1**2*f**2*gdd2*r - 5148*D1**2*f**2*gdd2*s**2 + 10296*D1**2*f**2*gdd2*s - 5148*D1**2*f**2*gdd2 - 24024*D1**2*f*fd*g2*r**2 + 13728*D1**2*f*fd*g2*r*s + 24024*D1**2*f*fd*g2*r + 6864*D1**2*f*fd*g2*s**2 - 6864*D1**2*f*fd*g2*s - 12012*D1**2*f*fd*g2 - 10296*D1**2*f*fd*gd2*r**2 - 68640*D1**2*f*fd*gd2*r*s + 39468*D1**2*f*fd*gd2*r - 20592*D1**2*f*fd*gd2*s**2 + 37752*D1**2*f*fd*gd2*s - 17160*D1**2*f*fd*gd2 - 5148*D1**2*f*fdd*g2*r**2 - 34320*D1**2*f*fdd*g2*r*s + 5148*D1**2*f*fdd*g2*r - 10296*D1**2*f*fdd*g2*s**2 + 17160*D1**2*f*fdd*g2*s - 2574*D1**2*f*fdd*g2 - 5148*D1**2*fd**2*g2*r**2 - 34320*D1**2*fd**2*g2*r*s + 5148*D1**2*fd**2*g2*r - 10296*D1**2*fd**2*g2*s**2 + 17160*D1**2*fd**2*g2*s + 10296*D1*Dd*K*bd1*f**2*r**2 + 68640*D1*Dd*K*bd1*f**2*r*s - 54054*D1*Dd*K*bd1*f**2*r + 20592*D1*Dd*K*bd1*f**2*s**2 - 39468*D1*Dd*K*bd1*f**2*s + 18876*D1*Dd*K*bd1*f**2 - 43992*D1*Dd*bd1*f**3*r**2 - 136448*D1*Dd*bd1*f**3*r*s + 104754*D1*Dd*bd1*f**3*r - 51480*D1*Dd*bd1*f**3*s**2 + 102856*D1*Dd*bd1*f**3*s - 44941*D1*Dd*bd1*f**3 - 30888*D1*Dd*bd1*f**2*r**2 - 65208*D1*Dd*bd1*f**2*r*s + 56628*D1*Dd*bd1*f**2*r - 24024*D1*Dd*bd1*f**2*s**2 + 44187*D1*Dd*bd1*f**2*s - 20163*D1*Dd*bd1*f**2 + 501072*D1*Dd*bd1*f*g2*r**2 + 768768*D1*Dd*bd1*f*g2*r*s - 791076*D1*Dd*bd1*f*g2*r + 233376*D1*Dd*bd1*f*g2*s**2 - 583440*D1*Dd*bd1*f*g2*s + 303732*D1*Dd*bd1*f*g2 + 17160*D1*Dd*bd2*f**2*r**2 + 34320*D1*Dd*bd2*f**2*r*s - 30030*D1*Dd*bd2*f**2*r + 17160*D1*Dd*bd2*f**2*s**2 - 30030*D1*Dd*bd2*f**2*s + 12870*D1*Dd*bd2*f**2 - 5060*D1*Dd*f**4*r**2 - 30420*D1*Dd*f**4*r*s + 17740*D1*Dd*f**4*r - 30888*D1*Dd*f**4*s**2 + 38493*D1*Dd*f**4*s - 16709*D1*Dd*f**4 + 29600*D1*Dd*f**3*fd*r**2 + 243360*D1*Dd*f**3*fd*r*s - 136480*D1*Dd*f**3*fd*r + 247104*D1*Dd*f**3*fd*s**2 - 307944*D1*Dd*f**3*fd*s + 94046*D1*Dd*f**3*fd - 6864*D1*Dd*f**3*r**2 - 3432*D1*Dd*f**3*r*s + 5148*D1*Dd*f**3*r + 858*D1*Dd*f**3*s - 1716*D1*Dd*f**3 - 48048*D1*Dd*f**2*g2*r**2 + 27456*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r + 13728*D1*Dd*f**2*g2*s**2 - 20592*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 - 20592*D1*Dd*f**2*gd2*r**2 - 137280*D1*Dd*f**2*gd2*r*s + 108108*D1*Dd*f**2*gd2*r - 41184*D1*Dd*f**2*gd2*s**2 + 78936*D1*Dd*f**2*gd2*s - 37752*D1*Dd*f**2*gd2 - 41184*D1*Dd*f*fd*g2*r**2 - 274560*D1*Dd*f*fd*g2*r*s + 99528*D1*Dd*f*fd*g2*r - 82368*D1*Dd*f*fd*g2*s**2 + 144144*D1*Dd*f*fd*g2*s - 39468*D1*Dd*f*fd*g2 + 3700*D1*Ddd*f**4*r**2 + 30420*D1*Ddd*f**4*r*s - 17060*D1*Ddd*f**4*r + 30888*D1*Ddd*f**4*s**2 - 38493*D1*Ddd*f**4*s + 16369*D1*Ddd*f**4 - 10296*D1*Ddd*f**2*g2*r**2 - 68640*D1*Ddd*f**2*g2*r*s + 39468*D1*Ddd*f**2*g2*r - 20592*D1*Ddd*f**2*g2*s**2 + 37752*D1*Ddd*f**2*g2*s - 12870*D1*Ddd*f**2*g2 + 11100*Dd**2*f**4*r**2 + 91260*Dd**2*f**4*r*s - 51180*Dd**2*f**4*r + 92664*Dd**2*f**4*s**2 - 115479*Dd**2*f**4*s + 30654*Dd**2*f**4 - 30888*Dd**2*f**2*g2*r**2 - 205920*Dd**2*f**2*g2*r*s + 118404*Dd**2*f**2*g2*r - 61776*Dd**2*f**2*g2*s**2 + 113256*Dd**2*f**2*g2*s - 44616*Dd**2*f**2*g2 + 3003*b1**3*(D1**2*(fd*(r + 3*s - 3) + fdd*(-3*r - 5*s + 5))*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 2*r*(8*s - 5) + 12*s**2 - 16*s + 7) - 2*fd*(12*r**2 + r*(32*s - 27) + 20*s**2 - 34*s + 14) - 2*(4*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*f*(12*r**2 + r*(32*s - 22) + 20*s**2 - 28*s + 13) + 2*Ddd*(2*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 2*Dd**2*(f*(18*r**2 + r*(48*s - 33) + 30*s**2 - 42*s + 13) - (2*K - 1)*(12*r**2 + 12*r*(s - 1) - 3*s + 2))) + 429*b1**2*(56*C*D1**2*fd*r**2 + 56*C*D1**2*fd*r*s - 56*C*D1**2*fd*r + 224*C*D1*Dd*f*r**2 + 224*C*D1*Dd*f*r*s - 224*C*D1*Dd*f*r - 56*C*D1*Dd*f*s + 56*C*D1*Dd*f + 48*D1**2*K*fd*r**2 + 56*D1**2*K*fd*r*s - 16*D1**2*K*fd*r + 12*D1**2*K*fd*s**2 - 8*D1**2*K*fd*s + 8*D1**2*K*fd - 73*D1**2*K*fdd*r**2 - 112*D1**2*K*fdd*r*s + 8*D1**2*K*fdd*r - 34*D1**2*K*fdd*s**2 + 4*D1**2*K*fdd*s - 4*D1**2*K*fdd - 7*D1**2*bdd1*(f*(9*r**2 + 2*r*(12*s - 7) + 15*s**2 - 18*s + 8) + (2 - 4*K)*(3*r**2 + 3*r*(s - 1) - s + 1)) - 46*D1**2*f*fd*r**2 - 94*D1**2*f*fd*r*s + 33*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 30*D1**2*f*fd*s - 12*D1**2*f*fd + 38*D1**2*f*fdd*r**2 + 78*D1**2*f*fdd*r*s - 33*D1**2*f*fdd*r + 40*D1**2*f*fdd*s**2 - 26*D1**2*f*fdd*s + 12*D1**2*f*fdd + 38*D1**2*fd**2*r**2 + 78*D1**2*fd**2*r*s - 33*D1**2*fd**2*r + 40*D1**2*fd**2*s**2 - 26*D1**2*fd**2*s - 14*D1**2*fd**2 - 46*D1**2*fd*r**2 - 7*D1**2*fd*r*s + 50*D1**2*fd*r + 35*D1**2*fd*s**2 + 4*D1**2*fd*s - 4*D1**2*fd + 9*D1**2*fdd*r**2 + 7*D1**2*fdd*r*s - 4*D1**2*fdd*r - 7*D1**2*fdd*s**2 - 2*D1**2*fdd*s + 2*D1**2*fdd + 112*D1**2*gd2*r**2 + 112*D1**2*gd2*r*s - 112*D1**2*gd2*r - 56*D1**2*gdd2*r**2 - 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*r + 192*D1*Dd*K*f*r**2 + 224*D1*Dd*K*f*r*s - 208*D1*Dd*K*f*r + 48*D1*Dd*K*f*s**2 - 104*D1*Dd*K*f*s + 72*D1*Dd*K*f - 584*D1*Dd*K*fd*r**2 - 896*D1*Dd*K*fd*r*s + 402*D1*Dd*K*fd*r - 272*D1*Dd*K*fd*s**2 + 264*D1*Dd*K*fd*s - 16*D1*Dd*K*fd - 92*D1*Dd*f**2*r**2 - 188*D1*Dd*f**2*r*s + 140*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 143*D1*Dd*f**2*s - 71*D1*Dd*f**2 + 304*D1*Dd*f*fd*r**2 + 624*D1*Dd*f*fd*r*s - 364*D1*Dd*f*fd*r + 320*D1*Dd*f*fd*s**2 - 342*D1*Dd*f*fd*s + 85*D1*Dd*f*fd - 184*D1*Dd*f*r**2 - 28*D1*Dd*f*r*s + 106*D1*Dd*f*r + 140*D1*Dd*f*s**2 - 133*D1*Dd*f*s + 24*D1*Dd*f + 72*D1*Dd*fd*r**2 + 56*D1*Dd*fd*r*s - 48*D1*Dd*fd*r - 56*D1*Dd*fd*s**2 + 13*D1*Dd*fd*s + 8*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 448*D1*Dd*g2*r*s - 448*D1*Dd*g2*r - 112*D1*Dd*g2*s + 112*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 448*D1*Dd*gd2*r*s + 448*D1*Dd*gd2*r + 56*D1*Dd*gd2*s - 56*D1*Dd*gd2 - 292*D1*Ddd*K*f*r**2 - 448*D1*Ddd*K*f*r*s + 370*D1*Ddd*K*f*r - 136*D1*Ddd*K*f*s**2 + 248*D1*Ddd*K*f*s - 141*D1*Ddd*K*f + 76*D1*Ddd*f**2*r**2 + 156*D1*Ddd*f**2*r*s - 116*D1*Ddd*f**2*r + 80*D1*Ddd*f**2*s**2 - 119*D1*Ddd*f**2*s + 59*D1*Ddd*f**2 + 36*D1*Ddd*f*r**2 + 28*D1*Ddd*f*r*s - 32*D1*Ddd*f*r - 28*D1*Ddd*f*s**2 + 21*D1*Ddd*f*s - 5*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 224*D1*Ddd*g2*r*s + 224*D1*Ddd*g2*r + 56*D1*Ddd*g2*s - 56*D1*Ddd*g2 + 7*D1*bd1*(D1*(f*(3*r**2 + 6*r*(2*s - 1) + 9*s**2 - 10*s + 4) - 2*fd*(9*r**2 + 24*r*s - 19*r + 15*s**2 - 24*s + 9) - 2*(4*K - 2)*(3*r**2 + 3*r*(s - 1) - s + 1)) - 2*Dd*f*(36*r**2 + r*(96*s - 61) + 60*s**2 - 78*s + 25) + 2*Dd*(2*K - 1)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 876*Dd**2*K*f*r**2 - 1344*Dd**2*K*f*r*s + 1110*Dd**2*K*f*r - 408*Dd**2*K*f*s**2 + 744*Dd**2*K*f*s - 292*Dd**2*K*f + 228*Dd**2*f**2*r**2 + 468*Dd**2*f**2*r*s - 348*Dd**2*f**2*r + 240*Dd**2*f**2*s**2 - 357*Dd**2*f**2*s + 118*Dd**2*f**2 + 108*Dd**2*f*r**2 + 84*Dd**2*f*r*s - 96*Dd**2*f*r - 84*Dd**2*f*s**2 + 63*Dd**2*f*s - 672*Dd**2*g2*r**2 - 672*Dd**2*g2*r*s + 672*Dd**2*g2*r + 168*Dd**2*g2*s - 112*Dd**2*g2) - 13*b1*(396*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r - 264*C*D1**2*f*fd*s + 264*C*D1**2*f*fd + 792*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 924*C*D1*Dd*f**2*r - 264*C*D1*Dd*f**2*s + 198*C*D1*Dd*f**2 + 4818*D1**2*K*bdd1*f*r**2 + 7392*D1**2*K*bdd1*f*r*s - 8250*D1**2*K*bdd1*f*r + 2244*D1**2*K*bdd1*f*s**2 - 5808*D1**2*K*bdd1*f*s + 3399*D1**2*K*bdd1*f - 924*D1**2*K*f*fd*r**2 + 528*D1**2*K*f*fd*r*s + 924*D1**2*K*f*fd*r + 264*D1**2*K*f*fd*s**2 - 264*D1**2*K*f*fd*s - 462*D1**2*K*f*fd - 198*D1**2*K*f*fdd*r**2 - 1320*D1**2*K*f*fdd*r*s + 198*D1**2*K*f*fdd*r - 396*D1**2*K*f*fdd*s**2 + 660*D1**2*K*f*fdd*s - 99*D1**2*K*f*fdd - 198*D1**2*K*fd**2*r**2 - 1320*D1**2*K*fd**2*r*s + 198*D1**2*K*fd**2*r - 396*D1**2*K*fd**2*s**2 + 660*D1**2*K*fd**2*s - 693*D1**2*b2*fd*r**2 - 1386*D1**2*b2*fd*r*s - 693*D1**2*b2*fd*s**2 + 1155*D1**2*b2*fdd*r**2 + 2310*D1**2*b2*fdd*r*s + 1155*D1**2*b2*fdd*s**2 + 462*D1**2*bd1**2*(f*(9*r**2 + 2*r*(12*s - 7) + 15*s**2 - 18*s + 4) - (2*K - 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) - 1254*D1**2*bdd1*f**2*r**2 - 2574*D1**2*bdd1*f**2*r*s + 2739*D1**2*bdd1*f**2*r - 1320*D1**2*bdd1*f**2*s**2 + 3069*D1**2*bdd1*f**2*s - 1551*D1**2*bdd1*f**2 - 594*D1**2*bdd1*f*r**2 - 462*D1**2*bdd1*f*r*s + 693*D1**2*bdd1*f*r + 462*D1**2*bdd1*f*s**2 - 297*D1**2*bdd1*f*s + 3696*D1**2*bdd1*g2*r**2 + 3696*D1**2*bdd1*g2*r*s - 3696*D1**2*bdd1*g2*r - 1848*D1**2*bdd1*g2*s + 1848*D1**2*bdd1*g2 + 1155*D1**2*bdd2*f*r**2 + 2310*D1**2*bdd2*f*r*s - 2310*D1**2*bdd2*f*r + 1155*D1**2*bdd2*f*s**2 - 2310*D1**2*bdd2*f*s + 1155*D1**2*bdd2*f - 855*D1**2*f**2*fd*r**2 - 2724*D1**2*f**2*fd*r*s + 1643*D1**2*f**2*fd*r - 891*D1**2*f**2*fd*s**2 + 1205*D1**2*f**2*fd*s - 320*D1**2*f**2*fd + 1269*D1**2*f**2*fdd*r**2 + 3936*D1**2*f**2*fdd*r*s - 2323*D1**2*f**2*fdd*r + 1485*D1**2*f**2*fdd*s**2 - 2137*D1**2*f**2*fdd*s + 688*D1**2*f**2*fdd + 2538*D1**2*f*fd**2*r**2 + 7872*D1**2*f*fd**2*r*s - 4646*D1**2*f*fd**2*r + 2970*D1**2*f*fd**2*s**2 - 4274*D1**2*f*fd**2*s + 1607*D1**2*f*fd**2 - 924*D1**2*f*fd*r**2 - 2310*D1**2*f*fd*r*s + 1320*D1**2*f*fd*r - 726*D1**2*f*fd*s**2 + 1221*D1**2*f*fd*s - 594*D1**2*f*fd + 594*D1**2*f*fdd*r**2 + 1254*D1**2*f*fdd*r*s - 594*D1**2*f*fdd*r + 462*D1**2*f*fdd*s**2 - 627*D1**2*f*fdd*s + 297*D1**2*f*fdd + 3168*D1**2*f*gd2*r**2 + 3696*D1**2*f*gd2*r*s - 3696*D1**2*f*gd2*r + 792*D1**2*f*gd2*s**2 - 1584*D1**2*f*gd2*s + 792*D1**2*f*gd2 - 4818*D1**2*f*gdd2*r**2 - 7392*D1**2*f*gdd2*r*s + 7392*D1**2*f*gdd2*r - 2244*D1**2*f*gdd2*s**2 + 4488*D1**2*f*gdd2*s - 2244*D1**2*f*gdd2 + 594*D1**2*fd**2*r**2 + 1254*D1**2*fd**2*r*s - 594*D1**2*fd**2*r + 462*D1**2*fd**2*s**2 - 627*D1**2*fd**2*s + 3168*D1**2*fd*g2*r**2 + 3696*D1**2*fd*g2*r*s - 1056*D1**2*fd*g2*r + 792*D1**2*fd*g2*s**2 - 528*D1**2*fd*g2*s + 528*D1**2*fd*g2 - 9636*D1**2*fd*gd2*r**2 - 14784*D1**2*fd*gd2*r*s + 7920*D1**2*fd*gd2*r - 4488*D1**2*fd*gd2*s**2 + 4752*D1**2*fd*gd2*s - 264*D1**2*fd*gd2 - 4818*D1**2*fdd*g2*r**2 - 7392*D1**2*fdd*g2*r*s + 528*D1**2*fdd*g2*r - 2244*D1**2*fdd*g2*s**2 + 264*D1**2*fdd*g2*s - 264*D1**2*fdd*g2 - 1848*D1*Dd*K*f**2*r**2 + 1056*D1*Dd*K*f**2*r*s + 396*D1*Dd*K*f**2*r + 528*D1*Dd*K*f**2*s**2 - 792*D1*Dd*K*f**2*s - 198*D1*Dd*K*f**2 - 1584*D1*Dd*K*f*fd*r**2 - 10560*D1*Dd*K*f*fd*r*s + 3828*D1*Dd*K*f*fd*r - 3168*D1*Dd*K*f*fd*s**2 + 5544*D1*Dd*K*f*fd*s - 1518*D1*Dd*K*f*fd - 2772*D1*Dd*b2*f*r**2 - 5544*D1*Dd*b2*f*r*s + 4158*D1*Dd*b2*f*r - 2772*D1*Dd*b2*f*s**2 + 4158*D1*Dd*b2*f*s - 2079*D1*Dd*b2*f + 9240*D1*Dd*b2*fd*r**2 + 18480*D1*Dd*b2*fd*r*s - 6930*D1*Dd*b2*fd*r + 9240*D1*Dd*b2*fd*s**2 - 6930*D1*Dd*b2*fd*s - 1140*D1*Dd*f**3*r**2 - 3632*D1*Dd*f**3*r*s + 2386*D1*Dd*f**3*r - 1188*D1*Dd*f**3*s**2 + 2096*D1*Dd*f**3*s - 879*D1*Dd*f**3 + 10152*D1*Dd*f**2*fd*r**2 + 31488*D1*Dd*f**2*fd*r*s - 19702*D1*Dd*f**2*fd*r + 11880*D1*Dd*f**2*fd*s**2 - 18424*D1*Dd*f**2*fd*s + 6597*D1*Dd*f**2*fd - 1848*D1*Dd*f**2*r**2 - 4620*D1*Dd*f**2*r*s + 3234*D1*Dd*f**2*r - 1452*D1*Dd*f**2*s**2 + 2607*D1*Dd*f**2*s - 1188*D1*Dd*f**2 + 4752*D1*Dd*f*fd*r**2 + 10032*D1*Dd*f*fd*r*s - 6072*D1*Dd*f*fd*r + 3696*D1*Dd*f*fd*s**2 - 5610*D1*Dd*f*fd*s + 1848*D1*Dd*f*fd + 12672*D1*Dd*f*g2*r**2 + 14784*D1*Dd*f*g2*r*s - 13728*D1*Dd*f*g2*r + 3168*D1*Dd*f*g2*s**2 - 6864*D1*Dd*f*g2*s + 4752*D1*Dd*f*g2 - 38544*D1*Dd*f*gd2*r**2 - 59136*D1*Dd*f*gd2*r*s + 53988*D1*Dd*f*gd2*r - 17952*D1*Dd*f*gd2*s**2 + 34320*D1*Dd*f*gd2*s - 16368*D1*Dd*f*gd2 - 38544*D1*Dd*fd*g2*r**2 - 59136*D1*Dd*fd*g2*r*s + 26532*D1*Dd*fd*g2*r - 17952*D1*Dd*fd*g2*s**2 + 17424*D1*Dd*fd*g2*s - 1056*D1*Dd*fd*g2 - 396*D1*Ddd*K*f**2*r**2 - 2640*D1*Ddd*K*f**2*r*s + 1518*D1*Ddd*K*f**2*r - 792*D1*Ddd*K*f**2*s**2 + 1452*D1*Ddd*K*f**2*s - 495*D1*Ddd*K*f**2 + 4620*D1*Ddd*b2*f*r**2 + 9240*D1*Ddd*b2*f*r*s - 6930*D1*Ddd*b2*f*r + 4620*D1*Ddd*b2*f*s**2 - 6930*D1*Ddd*b2*f*s + 3465*D1*Ddd*b2*f + 1692*D1*Ddd*f**3*r**2 + 5248*D1*Ddd*f**3*r*s - 3470*D1*Ddd*f**3*r + 1980*D1*Ddd*f**3*s**2 - 3292*D1*Ddd*f**3*s + 1413*D1*Ddd*f**3 + 1188*D1*Ddd*f**2*r**2 + 2508*D1*Ddd*f**2*r*s - 1848*D1*Ddd*f**2*r + 924*D1*Ddd*f**2*s**2 - 1551*D1*Ddd*f**2*s + 759*D1*Ddd*f**2 - 19272*D1*Ddd*f*g2*r**2 - 29568*D1*Ddd*f*g2*r*s + 24420*D1*Ddd*f*g2*r - 8976*D1*Ddd*f*g2*s**2 + 16368*D1*Ddd*f*g2*s - 9306*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(f**2*(46*r**2 + r*(94*s - 107) + 48*s**2 - 113*s + 59) - f*(56*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 96*K*r**2 + 112*K*r*s - 136*K*r + 24*K*s**2 - 72*K*s + 52*K + fd*(152*r**2 + 8*r*(39*s - 29) + 160*s**2 - 238*s + 89) - 92*r**2 - 14*r*s + 49*r + 70*s**2 - 67*s - 7) + fd*(2*K*(146*r**2 + 7*r*(32*s - 19) + 68*s**2 - 92*s + 2) - 36*r**2 + r*(29 - 28*s) + 28*s**2 - 5*s - 2) - 56*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 56*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd*(-f**2*(304*r**2 + 12*r*(52*s - 47) + 320*s**2 - 610*s + 269) + f*(2*K*(584*r**2 + 896*r*s - 870*r + 272*s**2 - 600*s + 301) - 144*r**2 - 112*r*s + 148*r + 112*s**2 - 78*s - 3) + 112*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 231*D1*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) - 1188*Dd**2*K*f**2*r**2 - 7920*Dd**2*K*f**2*r*s + 4554*Dd**2*K*f**2*r - 2376*Dd**2*K*f**2*s**2 + 4356*Dd**2*K*f**2*s - 1716*Dd**2*K*f**2 + 13860*Dd**2*b2*f*r**2 + 27720*Dd**2*b2*f*r*s - 20790*Dd**2*b2*f*r + 13860*Dd**2*b2*f*s**2 - 20790*Dd**2*b2*f*s + 6930*Dd**2*b2*f + 5076*Dd**2*f**3*r**2 + 15744*Dd**2*f**3*r*s - 10410*Dd**2*f**3*r + 5940*Dd**2*f**3*s**2 - 9876*Dd**2*f**3*s + 3614*Dd**2*f**3 + 3564*Dd**2*f**2*r**2 + 7524*Dd**2*f**2*r*s - 5544*Dd**2*f**2*r + 2772*Dd**2*f**2*s**2 - 4653*Dd**2*f**2*s + 1716*Dd**2*f**2 - 57816*Dd**2*f*g2*r**2 - 88704*Dd**2*f*g2*r*s + 73260*Dd**2*f*g2*r - 26928*Dd**2*f*g2*s**2 + 49104*Dd**2*f*g2*s - 19272*Dd**2*f*g2) + 429*b2*(-35*D1**2*bdd1*f*(r + s - 1)**2 + 10*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 10*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + 5*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 10*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s + 20*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 14*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 10*D1*Dd*f**2*s - D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 100*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 100*D1*Dd*f*fd*s + 30*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 7*D1*bd1*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2))/(9009*d**2*k3**4) - D1**2*Pk1*Pk3*st**6*(40*C - 20)*(33*b1*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)) + f*(D1**2*(f*(fd*(6*s**2 - 4*s + 2) + fdd*(-3*s**2 + 2*s - 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) + 2*D1*f*(2*Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*(2*s - 1)*(33*bd1*s + fd*(3*s - 1)) + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(693*d**2*k3**2) - 2*D1**2*Pk1*Pk3*st**4*(-66*b1**2*(4*C - 3)*(D1*Dd*(2*f*(-4*r*s + 2*r + s) + fd*(8*r*s - 6*r - s + 1)) - D1*(D1*r*(2*fd - fdd)*(s - 1) + Ddd*f*(-4*r*s + 2*r + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 33*b1*(D1**2*(f*(2*bdd1*s*(-8*C*r + 4*C + 6*r - 3) - fd*(2*C - 1)*(8*r*s - 4*r + 22*s**2 - 22*s + 11) + fdd*(2*C - 1)*(8*r*s - 4*r + 18*s**2 - 18*s + 9)) + fd**2*(4*C - 2)*(r*(4*s - 2) + s*(9*s - 9))) - 2*D1*bd1*(4*C - 3)*(D1*(2*f*s*(1 - 2*r) + fd*r*(4*s - 2) - fd*s + fd) + 2*Dd*f*(r*(8*s - 2) - 3*s + 1)) - D1*f*(4*C - 2)*(Dd*(f*(8*r*s - 4*r + 22*s**2 - 24*s + 11) - 4*fd*(2*s - 1)*(4*r + 9*s - 5)) + Ddd*f*(r*(4 - 8*s) - 18*s**2 + 20*s - 9)) + Dd**2*f**2*(4*C - 2)*(12*r*(2*s - 1) + 54*s**2 - 60*s + 13)) - f*(66*D1**2*bd1**2*s*(4*C - 3)*(2*r - 1) + D1**2*(f*(-33*bdd1*s*(2*C - 1)*(4*r + 9*s - 4) + 4*fd*(-8*C*s + r*(8*C - 3)*(3*s - 1) + 6*s**2 - s + 2) - 2*fdd*(-8*C*s + r*(8*C - 3)*(3*s - 1) + 6*s**2 - s + 2)) + 2*fd**2*(-8*C*(r*(6*s - 2) - 2*s + 1) + 6*r*(3*s - 1) - 12*s**2 + 2*s + 3)) - 33*D1*bd1*(2*C - 1)*(D1*(f*s*(-4*r - 11*s + 4) + 2*fd*(8*r*s - 2*r + 18*s**2 - 13*s + 2)) + 8*Dd*f*(r*(4*s - 1) + 9*s**2 - 7*s + 1)) + 2*D1*f*(Dd*(2*f*(-8*C*s + r*(16*C - 6)*(2*s - 1) + 8*s**2 - 5*s + 4) + fd*(-8*C*(24*r*s - 10*r - 7*s + 3) + 72*r*s - 30*r - 48*s**2 + 19*s + 1)) + Ddd*f*(8*C*s - r*(16*C - 6)*(2*s - 1) - 8*s**2 + 5*s - 4)) + 2*Dd**2*f**2*(-8*C*(6*r*(2*s - 1) - 3*s + 2) + 18*r*(2*s - 1) - 24*s**2 + 15*s + 2)))/(231*d**2*k3**2) - D1**2*Pk1*Pk3*st**2*(33*b1**2*(D1**2*(fd*(2*C*(7*r**2 - 42*r*(s - 1) + 9*(s - 1)**2) - 7*r**2 + 63*r*(s - 1) - 18*(s - 1)**2) + fdd*(2*C*(7*r**2 + 42*r*(s - 1) - (s - 1)**2) - 7*r**2 - 63*r*(s - 1) + 2*(s - 1)**2)) + D1*(Dd*(f*(2*C*(28*r**2 + r*(70 - 168*s) + 36*s**2 + 6*s + 25) - 28*r**2 + 28*r*(9*s - 4) - 72*s**2 + 9*s - 43) + fd*(4*C*(28*r**2 + 7*r*(24*s - 19) - 4*s**2 - 15*s + 19) - 56*r**2 - 56*r*(9*s - 7) + 16*s**2 + 39*s - 55)) + Ddd*f*(2*C*(28*r**2 + 14*r*(12*s - 7) - 4*s**2 - 38*s + 5) - 28*r**2 - 28*r*(9*s - 5) + 8*s**2 + 55*s - 3)) + Dd**2*f*(4*C*(42*r**2 + 21*r*(12*s - 7) - 6*s**2 - 57*s + 41) - 84*r**2 - 84*r*(9*s - 5) + 24*s**2 + 165*s - 122)) + 33*b1*(192*C*D1**2*f*fd*r*s - 68*C*D1**2*f*fd*r + 172*C*D1**2*f*fd*s**2 - 184*C*D1**2*f*fd*s + 72*C*D1**2*f*fd - 192*C*D1**2*f*fdd*r*s + 68*C*D1**2*f*fdd*r - 172*C*D1**2*f*fdd*s**2 + 184*C*D1**2*f*fdd*s - 72*C*D1**2*f*fdd - 192*C*D1**2*fd**2*r*s + 68*C*D1**2*fd**2*r - 172*C*D1**2*fd**2*s**2 + 184*C*D1**2*fd**2*s - 12*C*D1**2*fd**2 + 384*C*D1*Dd*f**2*r*s - 192*C*D1*Dd*f**2*r + 344*C*D1*Dd*f**2*s**2 - 440*C*D1*Dd*f**2*s + 172*C*D1*Dd*f**2 - 1536*C*D1*Dd*f*fd*r*s + 656*C*D1*Dd*f*fd*r - 1376*C*D1*Dd*f*fd*s**2 + 1616*C*D1*Dd*f*fd*s - 436*C*D1*Dd*f*fd - 384*C*D1*Ddd*f**2*r*s + 192*C*D1*Ddd*f**2*r - 344*C*D1*Ddd*f**2*s**2 + 440*C*D1*Ddd*f**2*s - 172*C*D1*Ddd*f**2 - 1152*C*Dd**2*f**2*r*s + 576*C*Dd**2*f**2*r - 1032*C*Dd**2*f**2*s**2 + 1320*C*Dd**2*f**2*s - 364*C*Dd**2*f**2 + D1**2*bdd1*f*(2*C*(14*r**2 + 14*r*(6*s - 1) - 2*s**2 - 42*s + 7) - 14*r**2 - 14*r*(9*s - 1) + 4*s**2 + 63*s - 7) - 96*D1**2*f*fd*r*s + 34*D1**2*f*fd*r - 76*D1**2*f*fd*s**2 + 85*D1**2*f*fd*s - 31*D1**2*f*fd + 96*D1**2*f*fdd*r*s - 34*D1**2*f*fdd*r + 76*D1**2*f*fdd*s**2 - 85*D1**2*f*fdd*s + 31*D1**2*f*fdd + 96*D1**2*fd**2*r*s - 34*D1**2*fd**2*r + 76*D1**2*fd**2*s**2 - 85*D1**2*fd**2*s + 9*D1**2*fd**2 - 192*D1*Dd*f**2*r*s + 96*D1*Dd*f**2*r - 152*D1*Dd*f**2*s**2 + 200*D1*Dd*f**2*s - 76*D1*Dd*f**2 + 768*D1*Dd*f*fd*r*s - 328*D1*Dd*f*fd*r + 608*D1*Dd*f*fd*s**2 - 740*D1*Dd*f*fd*s + 204*D1*Dd*f*fd + 192*D1*Ddd*f**2*r*s - 96*D1*Ddd*f**2*r + 152*D1*Ddd*f**2*s**2 - 200*D1*Ddd*f**2*s + 76*D1*Ddd*f**2 + D1*bd1*(D1*(f*(2*C*(14*r**2 - 14*r*(6*s + 1) + 18*s**2 + 42*s + 7) - 14*r**2 + 14*r*(9*s + 1) - 36*s**2 - 63*s - 7) + fd*(4*C*(14*r**2 + 7*r*(12*s - 7) - 2*s**2 - 19*s + 21) - 28*r**2 - 28*r*(9*s - 5) + 8*s**2 + 55*s - 63)) + 2*Dd*f*(2*C*(56*r**2 + 42*r*(8*s - 3) - 8*s**2 - 122*s + 49) - 56*r**2 - 168*r*(3*s - 1) + 16*s**2 + 181*s - 70)) + 576*Dd**2*f**2*r*s - 288*Dd**2*f**2*r + 456*Dd**2*f**2*s**2 - 600*Dd**2*f**2*s + 172*Dd**2*f**2) + f*(-210*C*D1**2*f*fd*r**2 - 1188*C*D1**2*f*fd*r*s + 536*C*D1**2*f*fd*r - 1188*C*D1**2*f*fd*s**2 + 1188*C*D1**2*f*fd*s - 466*C*D1**2*f*fd + 6*C*D1**2*f*fdd*r**2 + 1188*C*D1**2*f*fdd*r*s - 400*C*D1**2*f*fdd*r + 1188*C*D1**2*f*fdd*s**2 - 1188*C*D1**2*f*fdd*s + 398*C*D1**2*f*fdd + 12*C*D1**2*fd**2*r**2 + 2376*C*D1**2*fd**2*r*s - 800*C*D1**2*fd**2*r + 2376*C*D1**2*fd**2*s**2 - 2376*C*D1**2*fd**2*s + 396*C*D1**2*fd**2 - 280*C*D1*Dd*f**2*r**2 - 1584*C*D1*Dd*f**2*r*s + 932*C*D1*Dd*f**2*r - 1584*C*D1*Dd*f**2*s**2 + 1980*C*D1*Dd*f**2*s - 862*C*D1*Dd*f**2 + 48*C*D1*Dd*f*fd*r**2 + 9504*C*D1*Dd*f*fd*r*s - 3988*C*D1*Dd*f*fd*r + 9504*C*D1*Dd*f*fd*s**2 - 10692*C*D1*Dd*f*fd*s + 2776*C*D1*Dd*f*fd + 8*C*D1*Ddd*f**2*r**2 + 1584*C*D1*Ddd*f**2*r*s - 796*C*D1*Ddd*f**2*r + 1584*C*D1*Ddd*f**2*s**2 - 1980*C*D1*Ddd*f**2*s + 794*C*D1*Ddd*f**2 + 24*C*Dd**2*f**2*r**2 + 4752*C*Dd**2*f**2*r*s - 2388*C*Dd**2*f**2*r + 4752*C*Dd**2*f**2*s**2 - 5940*C*Dd**2*f**2*s + 1584*C*Dd**2*f**2 + 33*D1**2*bd1**2*(r**2*(28*C - 14) + 14*r*(2*C*(6*s - 1) - 9*s + 1) + s*(-4*C*(s + 21) + 4*s + 63)) - 33*D1**2*bdd1*f*(2*C*(48*r*s - 14*r + 43*s**2 - 42*s + 7) - 48*r*s + 14*r - 38*s**2 + 39*s - 7) + 105*D1**2*f*fd*r**2 + 1083*D1**2*f*fd*r*s - 431*D1**2*f*fd*r + 1188*D1**2*f*fd*s**2 - 1153*D1**2*f*fd*s + 431*D1**2*f*fd - 3*D1**2*f*fdd*r**2 - 987*D1**2*f*fdd*r*s + 331*D1**2*f*fdd*r - 1188*D1**2*f*fdd*s**2 + 1121*D1**2*f*fdd*s - 397*D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 1974*D1**2*fd**2*r*s + 662*D1**2*fd**2*r - 2376*D1**2*fd**2*s**2 + 2242*D1**2*fd**2*s - 329*D1**2*fd**2 + 140*D1*Dd*f**2*r**2 + 1444*D1*Dd*f**2*r*s - 792*D1*Dd*f**2*r + 1584*D1*Dd*f**2*s**2 - 1945*D1*Dd*f**2*s + 827*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 - 7896*D1*Dd*f*fd*r*s + 3304*D1*Dd*f*fd*r - 9504*D1*Dd*f*fd*s**2 + 10223*D1*Dd*f*fd*s - 2573*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 1316*D1*Ddd*f**2*r*s + 660*D1*Ddd*f**2*r - 1584*D1*Ddd*f**2*s**2 + 1913*D1*Ddd*f**2*s - 793*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f*(2*C*(48*r*s - 14*r + 43*s**2 - 42*s + 7) - 48*r*s + 14*r - 38*s**2 + 39*s - 7) + fd*(-4*C*(96*r*s - 31*r + 86*s**2 - 88*s + 21) + 192*r*s - 62*r + 152*s**2 - 163*s + 39)) - 4*Dd*f*(C*(192*r*s - 76*r + 172*s**2 - 194*s + 49) - 96*r*s + 38*r - 76*s**2 + 89*s - 23)) - 12*Dd**2*f**2*r**2 - 3948*Dd**2*f**2*r*s + 1980*Dd**2*f**2*r - 4752*Dd**2*f**2*s**2 + 5739*Dd**2*f**2*s - 1450*Dd**2*f**2))/(693*d**2*k3**2) + 2*D1**2*Pk1*Pk3*(-8*D1**2*K*bdd1*f**2*r**2 - 18*D1**2*K*bdd1*f**2*r*s + 18*D1**2*K*bdd1*f**2*r - 7*D1**2*K*bdd1*f**2*s**2 + 14*D1**2*K*bdd1*f**2*s - 7*D1**2*K*bdd1*f**2 + 32*D1**2*b2*f*fd*r**2 + 36*D1**2*b2*f*fd*r*s - 32*D1**2*b2*f*fd*r + 14*D1**2*b2*f*fd*s**2 - 18*D1**2*b2*f*fd*s + 16*D1**2*b2*f*fd - 16*D1**2*b2*f*fdd*r**2 - 36*D1**2*b2*f*fdd*r*s + 16*D1**2*b2*f*fdd*r - 14*D1**2*b2*f*fdd*s**2 + 18*D1**2*b2*f*fdd*s - 8*D1**2*b2*f*fdd - 16*D1**2*b2*fd**2*r**2 - 36*D1**2*b2*fd**2*r*s + 16*D1**2*b2*fd**2*r - 14*D1**2*b2*fd**2*s**2 + 18*D1**2*b2*fd**2*s + D1**2*bd1**2*(f**2*(28*s**2 - 23*s + 9) + f*(6*K*(r*(6*s - 3) + s*(2*s - 2)) + 16*s**2 - 25*s + 9) - 28*g2*s**2) + 16*D1**2*bd2*f**2*r**2 + 18*D1**2*bd2*f**2*r*s - 18*D1**2*bd2*f**2*r + 7*D1**2*bd2*f**2*s**2 - 14*D1**2*bd2*f**2*s + 7*D1**2*bd2*f**2 - 32*D1**2*bd2*f*fd*r**2 - 72*D1**2*bd2*f*fd*r*s + 52*D1**2*bd2*f*fd*r - 28*D1**2*bd2*f*fd*s**2 + 46*D1**2*bd2*f*fd*s - 18*D1**2*bd2*f*fd + 10*D1**2*bdd1*f**3*r*s - 10*D1**2*bdd1*f**3*r + 18*D1**2*bdd1*f**3*s**2 - 24*D1**2*bdd1*f**3*s + 12*D1**2*bdd1*f**3 + 10*D1**2*bdd1*f**2*r*s - 10*D1**2*bdd1*f**2*r + 12*D1**2*bdd1*f**2*s**2 - 24*D1**2*bdd1*f**2*s + 12*D1**2*bdd1*f**2 - 36*D1**2*bdd1*f*g2*r*s - 12*D1**2*bdd1*f*g2*s**2 - 8*D1**2*bdd2*f**2*r**2 - 18*D1**2*bdd2*f**2*r*s + 18*D1**2*bdd2*f**2*r - 7*D1**2*bdd2*f**2*s**2 + 14*D1**2*bdd2*f**2*s - 7*D1**2*bdd2*f**2 - 32*D1**2*f**2*gd2*r**2 - 36*D1**2*f**2*gd2*r*s + 36*D1**2*f**2*gd2*r - 14*D1**2*f**2*gd2*s**2 + 28*D1**2*f**2*gd2*s - 14*D1**2*f**2*gd2 + 16*D1**2*f**2*gdd2*r**2 + 36*D1**2*f**2*gdd2*r*s - 36*D1**2*f**2*gdd2*r + 14*D1**2*f**2*gdd2*s**2 - 28*D1**2*f**2*gdd2*s + 14*D1**2*f**2*gdd2 - 64*D1**2*f*fd*g2*r**2 - 72*D1**2*f*fd*g2*r*s + 64*D1**2*f*fd*g2*r - 28*D1**2*f*fd*g2*s**2 + 36*D1**2*f*fd*g2*s - 32*D1**2*f*fd*g2 + 64*D1**2*f*fd*gd2*r**2 + 144*D1**2*f*fd*gd2*r*s - 104*D1**2*f*fd*gd2*r + 56*D1**2*f*fd*gd2*s**2 - 92*D1**2*f*fd*gd2*s + 36*D1**2*f*fd*gd2 + 32*D1**2*f*fdd*g2*r**2 + 72*D1**2*f*fdd*g2*r*s - 32*D1**2*f*fdd*g2*r + 28*D1**2*f*fdd*g2*s**2 - 36*D1**2*f*fdd*g2*s + 16*D1**2*f*fdd*g2 + 32*D1**2*fd**2*g2*r**2 + 72*D1**2*fd**2*g2*r*s - 32*D1**2*fd**2*g2*r + 28*D1**2*fd**2*g2*s**2 - 36*D1**2*fd**2*g2*s + 64*D1*Dd*b2*f**2*r**2 + 72*D1*Dd*b2*f**2*r*s - 68*D1*Dd*b2*f**2*r + 28*D1*Dd*b2*f**2*s**2 - 46*D1*Dd*b2*f**2*s + 30*D1*Dd*b2*f**2 - 128*D1*Dd*b2*f*fd*r**2 - 288*D1*Dd*b2*f*fd*r*s + 168*D1*Dd*b2*f*fd*r - 112*D1*Dd*b2*f*fd*s**2 + 164*D1*Dd*b2*f*fd*s - 52*D1*Dd*b2*f*fd - 64*D1*Dd*bd2*f**2*r**2 - 144*D1*Dd*bd2*f**2*r*s + 124*D1*Dd*bd2*f**2*r - 56*D1*Dd*bd2*f**2*s**2 + 102*D1*Dd*bd2*f**2*s - 46*D1*Dd*bd2*f**2 - 128*D1*Dd*f**2*g2*r**2 - 144*D1*Dd*f**2*g2*r*s + 136*D1*Dd*f**2*g2*r - 56*D1*Dd*f**2*g2*s**2 + 92*D1*Dd*f**2*g2*s - 60*D1*Dd*f**2*g2 + 128*D1*Dd*f**2*gd2*r**2 + 288*D1*Dd*f**2*gd2*r*s - 248*D1*Dd*f**2*gd2*r + 112*D1*Dd*f**2*gd2*s**2 - 204*D1*Dd*f**2*gd2*s + 92*D1*Dd*f**2*gd2 + 256*D1*Dd*f*fd*g2*r**2 + 576*D1*Dd*f*fd*g2*r*s - 336*D1*Dd*f*fd*g2*r + 224*D1*Dd*f*fd*g2*s**2 - 328*D1*Dd*f*fd*g2*s + 104*D1*Dd*f*fd*g2 - 32*D1*Ddd*b2*f**2*r**2 - 72*D1*Ddd*b2*f**2*r*s + 52*D1*Ddd*b2*f**2*r - 28*D1*Ddd*b2*f**2*s**2 + 46*D1*Ddd*b2*f**2*s - 22*D1*Ddd*b2*f**2 + 64*D1*Ddd*f**2*g2*r**2 + 144*D1*Ddd*f**2*g2*r*s - 104*D1*Ddd*f**2*g2*r + 56*D1*Ddd*f**2*g2*s**2 - 92*D1*Ddd*f**2*g2*s + 44*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-2*f**3*(5*r*(s - 1) + 9*s**2 - 12*s + 6) + f**2*(K*(16*r**2 + 18*r*(s - 1) + 7*(s - 1)**2) + 2*fd*(10*r*(3*s - 2) + 54*s**2 - 65*s + 17) - (2*s - 2)*(r + 6*s - 6)) - 2*f*(fd*(K*(16*r**2 + 36*r*s - 26*r + 14*s**2 - 23*s + 9) - 20*r*s + 10*r - 24*s**2 + 29*s - 5) + g2*s*(6*r - 5*s) + 6*gd2*(r*(6*s - 3) + s*(2*s - 2))) - 12*fd*g2*s*(6*r + 2*s - 3)) + 2*Dd*f*(f**2*(10*r*(4*s - 3) + 72*s**2 - 89*s + 29) + f*(-K*(32*r**2 + 72*r*s - 62*r + 28*s**2 - 51*s + 23) + 40*r*s - 30*r + 48*s**2 - 77*s + 29) - 6*g2*(6*r*(4*s - 1) + s*(8*s - 7)))) - 96*Dd**2*b2*f**2*r**2 - 216*Dd**2*b2*f**2*r*s + 156*Dd**2*b2*f**2*r - 84*Dd**2*b2*f**2*s**2 + 138*Dd**2*b2*f**2*s - 50*Dd**2*b2*f**2 + 192*Dd**2*f**2*g2*r**2 + 432*Dd**2*f**2*g2*r*s - 312*Dd**2*f**2*g2*r + 168*Dd**2*f**2*g2*s**2 - 276*Dd**2*f**2*g2*s + 100*Dd**2*f**2*g2 - 14*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(2*s**2 - 2*s + 1) + Dd**2*(-6*s**2 + 6*s - 1)) + b1**2*(6*D1**2*K*fd*r*s - 5*D1**2*K*fd*s**2 - 6*D1**2*K*fd*s + 18*D1**2*K*fdd*r*s + 6*D1**2*K*fdd*s**2 - 18*D1**2*K*fdd*s + 7*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) - 28*D1**2*f*fd*s**2 + 33*D1**2*f*fd*s - 21*D1**2*f*fd + 28*D1**2*f*fdd*s**2 - 33*D1**2*f*fdd*s + 21*D1**2*f*fdd + 28*D1**2*fd**2*s**2 - 33*D1**2*fd**2*s + 5*D1**2*fd**2 - 9*D1**2*fd*s**2 + 3*D1**2*fd*s + 8*D1**2*fdd*s**2 + 9*D1**2*fdd*s + 28*D1**2*gd2*s**2 - 56*D1**2*gd2*s + 28*D1**2*gd2 - 14*D1**2*gdd2*s**2 + 28*D1**2*gdd2*s - 14*D1**2*gdd2 + 24*D1*Dd*K*f*r*s - 12*D1*Dd*K*f*r - 20*D1*Dd*K*f*s**2 + 14*D1*Dd*K*f*s - 10*D1*Dd*K*f + 144*D1*Dd*K*fd*r*s - 36*D1*Dd*K*fd*r + 48*D1*Dd*K*fd*s**2 - 114*D1*Dd*K*fd*s + 36*D1*Dd*K*fd - 56*D1*Dd*f**2*s**2 + 56*D1*Dd*f**2*s - 28*D1*Dd*f**2 + 224*D1*Dd*f*fd*s**2 - 244*D1*Dd*f*fd*s + 66*D1*Dd*f*fd - 36*D1*Dd*f*s**2 + 36*D1*Dd*f*s - 18*D1*Dd*f + 64*D1*Dd*fd*s**2 + 4*D1*Dd*fd*s - 18*D1*Dd*fd + 112*D1*Dd*g2*s**2 - 112*D1*Dd*g2*s + 56*D1*Dd*g2 - 112*D1*Dd*gd2*s**2 + 168*D1*Dd*gd2*s - 56*D1*Dd*gd2 + 72*D1*Ddd*K*f*r*s - 36*D1*Ddd*K*f*r + 24*D1*Ddd*K*f*s**2 - 42*D1*Ddd*K*f*s + 12*D1*Ddd*K*f + 56*D1*Ddd*f**2*s**2 - 56*D1*Ddd*f**2*s + 28*D1*Ddd*f**2 + 32*D1*Ddd*f*s**2 - 32*D1*Ddd*f*s + 16*D1*Ddd*f - 56*D1*Ddd*g2*s**2 + 56*D1*Ddd*g2*s - 28*D1*Ddd*g2 - 14*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) - 2*Dd*(6*s**2 - 5*s + 1)) + 216*Dd**2*K*f*r*s - 108*Dd**2*K*f*r + 72*Dd**2*K*f*s**2 - 126*Dd**2*K*f*s + 48*Dd**2*K*f + 168*Dd**2*f**2*s**2 - 168*Dd**2*f**2*s + 28*Dd**2*f**2 + 96*Dd**2*f*s**2 - 96*Dd**2*f*s + 16*Dd**2*f - 168*Dd**2*g2*s**2 + 168*Dd**2*g2*s - 28*Dd**2*g2) + b1*(14*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + D1**2*bdd1*(f**2*(28*s**2 - 23*s + 7) + f*(6*K*(6*r*s - 3*r + 2*s**2 - 2*s + 1) + 16*s**2 - 25*s + 8) - 28*g2*s**2) - 2*D1**2*(f**2*(fd - fdd)*(5*r*(3*s - 1) + 27*s**2 - 29*s + 12) - f*(-8*K*fdd*r**2 - 18*K*fdd*r*s + 8*K*fdd*r - 7*K*fdd*s**2 + 9*K*fdd*s - 4*K*fdd + fd**2*(10*r*(3*s - 1) + 54*s**2 - 58*s + 11) + fd*(K*(16*r**2 + 2*r*(9*s - 8) + 7*s**2 - 9*s + 8) + s*(-2*r - 12*s + 1)) + 10*fdd*r*s + 12*fdd*s**2 - 5*fdd*s - gd2*(s - 1)*(6*r - 5*s + 5) - 18*gdd2*r*s + 18*gdd2*r - 6*gdd2*s**2 + 12*gdd2*s - 6*gdd2) + fd**2*(K*(8*r**2 + 2*r*(9*s - 4) + s*(7*s - 9)) + s*(-10*r - 12*s + 5)) + fd*(g2*s*(6*r - 5*s - 6) + 6*gd2*(r*(6*s - 3) + 2*s**2 - 5*s + 3)) + 6*fdd*g2*s*(3*r + s - 3)) + D1*bd1*(D1*(f**2*(-28*s**2 + 23*s - 7) + f*(K*(12*r*s - 6*r - 10*s**2 + 10*s - 5) + 14*fd*(8*s**2 - 8*s + 1) - 18*s**2 + 15*s - 9) + fd*(6*K*(3*r*(4*s - 1) + 4*s**2 - 8*s + 3) + 32*s**2 - 7*s - 9) + 56*s*(g2*s - gd2*s + gd2)) + 2*Dd*(2*s - 1)*(f**2*(56*s - 23) + f*(3*K*(24*r + 8*s - 7) + 32*s - 25) - 56*g2*s)) - 2*D1*(Dd*(f**3*(10*r*(2*s - 1) + 36*s**2 - 41*s + 18) - f**2*(K*(32*r**2 + 36*r*s - 34*r + 14*s**2 - 23*s + 15) + fd*(10*r*(12*s - 5) + 216*s**2 - 239*s + 63) - 4*r*s + 2*r - 24*s**2 + 25*s - 12) + 2*f*(fd*(K*(32*r**2 + 72*r*s - 42*r + 28*s**2 - 41*s + 13) - 40*r*s + 10*r - 48*s**2 + 39*s - 5) + g2*(6*r*(2*s - 1) - 10*s**2 + 7*s - 5) + 3*gd2*(6*r*(4*s - 3) + 8*s**2 - 15*s + 7)) + 6*fd*g2*(6*r*(4*s - 1) + 8*s**2 - 19*s + 6)) + Ddd*f*(f**2*(r*(10 - 20*s) - 36*s**2 + 41*s - 18) + f*(K*(16*r**2 + 36*r*s - 26*r + 14*s**2 - 23*s + 11) - 20*r*s + 10*r - 24*s**2 + 29*s - 12) + 6*g2*(6*r*(2*s - 1) + 4*s**2 - 7*s + 2))) - 2*Dd**2*f*(f**2*(r*(30 - 60*s) - 108*s**2 + 123*s - 28) + f*(K*(48*r**2 + 108*r*s - 78*r + 42*s**2 - 69*s + 25) - 60*r*s + 30*r - 72*s**2 + 87*s - 22) + 6*g2*(18*r*(2*s - 1) + 12*s**2 - 21*s + 8))))/(21*d**2*k3**2) + D1**2*Pk1*Pk3*st**4*(16*C - 8)*(2*D1**2*bd1**2*f*s**2 + 2*D1*b1*s*(D1*bdd1*f*s + 2*bd1*(-D1*f*s + D1*fd*(s - 1) + 2*Dd*f*(2*s - 1))) + b1**2*(-D1**2*(2*fd - fdd)*(s - 1)**2 + 4*D1*Dd*(f*(-2*s**2 + 2*s - 1) + fd*(2*s**2 - 3*s + 1)) + 2*D1*Ddd*f*(2*s**2 - 2*s + 1) + 2*Dd**2*f*(6*s**2 - 6*s + 1)))/(7*d**2*k2**2) + D1**2*Pk1*Pk3*st**2*(2*C - 1)*(D1*f*s*(-70*D1*bd1**2*s + D1*bd1*(-7*f*s + 10*fd*(2*s - 1)) + 5*D1*bdd1*f*s + 20*Dd*bd1*f*(2*s - 1)) + 7*b1**2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + 2*D1*(7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*fd*(2*s**2 - 3*s + 1) - 5*Ddd*f*(2*s**2 - 2*s + 1)) - 10*Dd**2*f*(6*s**2 - 6*s + 1)) + b1*(D1**2*(f*(-7*fd*(2*s**2 - 2*s + 1) + 5*fdd*(2*s**2 - 2*s + 1) + s**2*(98*bd1 - 70*bdd1)) + fd*s*(-140*bd1 + 10*fd)*(s - 1)) + 2*D1*f*(-7*Dd*f*(2*s**2 - 2*s + 1) - 10*Dd*(2*s - 1)*(14*bd1*s - 2*fd*s + fd) + 5*Ddd*f*(2*s**2 - 2*s + 1)) + 10*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(21*d**2*k2**2) + D1**2*Pk1*Pk3*(4*C - 2)*(D1*f*s*(-D1*bdd1*f*s + bd1*(D1*f*s + D1*fd*(2 - 4*s) + Dd*f*(4 - 8*s))) + b1*(D1**2*(f*(fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*f*(Dd*f*(2*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 2*s)**2 + Ddd*f*(-2*s**2 + 2*s - 1)) - 2*Dd**2*f**2*(6*s**2 - 6*s + 1)))/(3*d**2*k2**2) + 10*D1**2*Pk1*Pk3*k2**4*st**6*(132*C*D1**2*b1*f*fd*r**2 - 66*C*D1**2*b1*f*fdd*r**2 - 66*C*D1**2*b1*fd**2*r**2 + 6*C*D1**2*f**2*fd*r**2 - 4*C*D1**2*f**2*fd*r + 2*C*D1**2*f**2*fd - 3*C*D1**2*f**2*fdd*r**2 + 2*C*D1**2*f**2*fdd*r - C*D1**2*f**2*fdd - 6*C*D1**2*f*fd**2*r**2 + 4*C*D1**2*f*fd**2*r + 264*C*D1*Dd*b1*f**2*r**2 - 132*C*D1*Dd*b1*f**2*r + 66*C*D1*Dd*b1*f**2 - 528*C*D1*Dd*b1*f*fd*r**2 + 132*C*D1*Dd*b1*f*fd*r + 8*C*D1*Dd*f**3*r**2 - 4*C*D1*Dd*f**3*r + 2*C*D1*Dd*f**3 - 24*C*D1*Dd*f**2*fd*r**2 + 14*C*D1*Dd*f**2*fd*r - 2*C*D1*Dd*f**2*fd - 132*C*D1*Ddd*b1*f**2*r**2 + 66*C*D1*Ddd*b1*f**2*r - 33*C*D1*Ddd*b1*f**2 - 4*C*D1*Ddd*f**3*r**2 + 2*C*D1*Ddd*f**3*r - C*D1*Ddd*f**3 - 396*C*Dd**2*b1*f**2*r**2 + 198*C*Dd**2*b1*f**2*r - 12*C*Dd**2*f**3*r**2 + 6*C*Dd**2*f**3*r - 264*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*f*fdd*r*s - 33*D1**2*b1*f*fdd*r + 132*D1**2*b1*fd**2*r**2 + 66*D1**2*b1*fd**2*r*s - 33*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(C*(r - 1) - 2*r - s + 2) - 12*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 10*D1**2*f**2*fd*r + 2*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s - 5*D1**2*f**2*fdd*r - D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd + 12*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s - 10*D1**2*f*fd**2*r - 2*D1**2*f*fd**2*s + D1**2*f*fd**2 - 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 396*D1*Dd*b1*f**2*r + 66*D1*Dd*b1*f**2*s - 132*D1*Dd*b1*f**2 + 1056*D1*Dd*b1*f*fd*r**2 + 528*D1*Dd*b1*f*fd*r*s - 528*D1*Dd*b1*f*fd*r - 66*D1*Dd*b1*f*fd*s + 33*D1*Dd*b1*f*fd - 16*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r + 2*D1*Dd*f**3*s - 4*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s - 38*D1*Dd*f**2*fd*r - 7*D1*Dd*f**2*fd*s + 7*D1*Dd*f**2*fd + 264*D1*Ddd*b1*f**2*r**2 + 132*D1*Ddd*b1*f**2*r*s - 198*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2*s + 66*D1*Ddd*b1*f**2 + 8*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s - 6*D1*Ddd*f**3*r - D1*Ddd*f**3*s + 2*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(2*f*(r - 1)*(C*(r - 1) - 2*r - s + 2) + fd*(-r**2*(4*C - 8) + r*(4*C + 4*s - 9) - 2*s + 1)) + Dd*f*(-2*C*(4*r**2 - 5*r + 1) + 16*r**2 + 8*r*s - 22*r - 5*s + 6)) + 792*Dd**2*b1*f**2*r**2 + 396*Dd**2*b1*f**2*r*s - 594*Dd**2*b1*f**2*r - 99*Dd**2*b1*f**2*s + 66*Dd**2*b1*f**2 + 24*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s - 18*Dd**2*f**3*r - 3*Dd**2*f**3*s + 2*Dd**2*f**3)/(693*d**2*k1**2*k3**4) - 2*D1**2*Pk1*Pk3*k2**4*st**4*(-858*D1**2*bd1**2*f*(f*(4*r**2 + r*(4*s - 5) - 2*s + 1) - r**2*(K - 3) + r*(K + 2*s - 4) - s + 1) - 13*D1*bd1*(D1*(f**3*(18*r**2 + r*(133*s - 134) - 165*s + 75) + f**2*(-66*C*(r - 1)**2 + fd*(-252*r**2 - 894*r*s + 714*r + 479*s - 322) + (66*r - 66)*(2*r + s - 2)) - 132*f*(r - 1)*(g2*(r - 1) - gd2*r) + 132*fd*g2*r*(r - 1)) + Dd*f*(f**2*(-336*r**2 - 2*r*(596*s - 523) + 809*s - 496) + 132*g2*(4*r**2 - 5*r + 1))) + 429*b1**2*(D1**2*r*(2*f*(fd - fdd)*(4*r + 4*s - 3) + fd**2*(-8*r - 8*s + 6) - 2*fd*r*(K - 3) + 4*fd*s + fdd*r*(K - 3) - 2*fdd*s) + D1*(2*Dd*(f**2*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - f*(4*K*r**2 - 2*K*r + K + fd*(8*r - 1)*(4*r + 4*s - 3) - 12*r**2 - 8*r*s + 10*r + 2*s - 3) + fd*(r**2*(4*K - 12) - r*(K + 8*s - 5) + s)) + Ddd*f*(4*K*r**2 - 2*K*r + K - 4*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 12*r**2 - 8*r*s + 10*r + 2*s - 3)) - 2*Dd**2*f*(f*(24*r**2 + 24*r*(s - 1) - 6*s + 4) - r**2*(6*K - 18) + 3*r*(K + 4*s - 5) - 3*s + 2)) + 13*b1*(132*C*D1**2*f*fd*r**2 + 264*C*D1*Dd*f**2*r**2 - 132*C*D1*Dd*f**2*r + 66*C*D1*Dd*f**2 - 33*D1**2*bdd1*f*(K*(-2*r**2 + 2*r - 1) + 2*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + 6*r**2 + 4*r*s - 8*r - 2*s + 3) - 54*D1**2*f**2*fd*r**2 - 399*D1**2*f**2*fd*r*s + 168*D1**2*f**2*fd*r - 32*D1**2*f**2*fd*s + 57*D1**2*f**2*fd + 126*D1**2*f**2*fdd*r**2 + 447*D1**2*f**2*fdd*r*s - 216*D1**2*f**2*fdd*r + 16*D1**2*f**2*fdd*s - 45*D1**2*f**2*fdd + 252*D1**2*f*fd**2*r**2 + 894*D1**2*f*fd**2*r*s - 432*D1**2*f*fd**2*r + 32*D1**2*f*fd**2*s - 24*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 132*D1**2*f*fd*r*s + 66*D1**2*f*fd*r + 132*D1**2*f*gd2*r**2 - 66*D1**2*f*gdd2*r**2 + 132*D1**2*fd*g2*r**2 - 132*D1**2*fd*gd2*r**2 - 66*D1**2*fdd*g2*r**2 - 72*D1*Dd*f**3*r**2 - 532*D1*Dd*f**3*r*s + 302*D1*Dd*f**3*r + 133*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 1008*D1*Dd*f**2*fd*r**2 + 3576*D1*Dd*f**2*fd*r*s - 2010*D1*Dd*f**2*fd*r - 383*D1*Dd*f**2*fd*s + 184*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r*s + 396*D1*Dd*f**2*r + 66*D1*Dd*f**2*s - 132*D1*Dd*f**2 + 528*D1*Dd*f*g2*r**2 - 264*D1*Dd*f*g2*r + 132*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r**2 + 132*D1*Dd*f*gd2*r - 528*D1*Dd*fd*g2*r**2 + 132*D1*Dd*fd*g2*r + 168*D1*Ddd*f**3*r**2 + 596*D1*Ddd*f**3*r*s - 382*D1*Ddd*f**3*r - 149*D1*Ddd*f**3*s + 42*D1*Ddd*f**3 - 264*D1*Ddd*f*g2*r**2 + 132*D1*Ddd*f*g2*r - 66*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(2*K*r**2 - 2*K*r + K + fd*(4*r - 1)*(4*r + 4*s - 3) - 6*r**2 - 4*r*s + 8*r + 2*s - 3) + fd*(r**2*(2*K - 6) - r*(K + 4*s - 4) + s)) + Dd*f*(8*K*r**2 - 6*K*r + K - f*(8*r - 3)*(4*r + 4*s - 3) - 24*r**2 - 16*r*s + 26*r + 6*s - 6)) + 504*Dd**2*f**3*r**2 + 1788*Dd**2*f**3*r*s - 1146*Dd**2*f**3*r - 447*Dd**2*f**3*s + 298*Dd**2*f**3 - 792*Dd**2*f*g2*r**2 + 396*Dd**2*f*g2*r) + f*(13*D1**2*bdd1*(f**2*(42*r**2 + 149*r*s - 166*r - 165*s + 87) - 66*g2*(r - 1)**2) - 2*f*(D1**2*(f*(fd*(588*r**2 + 520*r*s - 554*r - 130*s + 147) + fdd*(-684*r**2 - 520*r*s + 602*r + 130*s - 171)) - 2*fd**2*(1026*r**2 + r*(780*s - 903) - 195*s + 130)) + D1*f*(Dd*(f*(588*r**2 + 520*r*s - 554*r - 130*s + 147) - 2*fd*(4*r - 1)*(684*r + 520*s - 431)) + Ddd*f*(-684*r**2 + r*(602 - 520*s) + 130*s - 171)) - 2*Dd**2*f**2*(1026*r**2 + r*(780*s - 903) - 195*s + 130))))/(3003*d**2*k1**2*k3**4) - 10*D1**2*Pk1*Pk3*k2**2*st**6*(33*D1*bd1*f*(D1*(2*f*s*(r - 1) + fd*(-4*r*s + r + 2*s - 1)) + Dd*f*(r*(2 - 8*s) + 5*s - 2)) - 33*b1*(D1*Dd*f*(2*f*(-4*r*s + 2*r + s) + fd*(8*r - 1)*(2*s - 1)) - D1*(D1*r*(2*s - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + 2*r + s)) + Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(2*f*(4*r*s - 2*r - s) + fd*(-24*r*s + 10*r + 7*s - 3)) + D1*(D1*(2*f*fd*(r*(3*s - 1) - s) + f*(-33*bdd1*s*(r - 1) + fdd*(-3*r*s + r + s)) + fd**2*(r*(2 - 6*s) + 2*s - 1)) + Ddd*f**2*(r*(2 - 4*s) + s)) + Dd**2*f**2*(r*(6 - 12*s) + 3*s - 2)))/(693*d**2*k1**2*k3**2) + 2*D1**2*Pk1*Pk3*k2**2*st**4*(66*b1**2*(C - 1)*(D1**2*r**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*r*(1 - 4*r)) + D1*Ddd*f*(-4*r**2 + 2*r - 1) + 6*Dd**2*f*r*(1 - 2*r)) + 33*b1*(-2*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) + 4*D1**2*f*fd*r**2 + 14*D1**2*f*fd*r*s - 7*D1**2*f*fd*r - 4*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 5*D1**2*f*fdd*r - 4*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 5*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 + 28*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r - 7*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 32*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r + 10*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 8*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 14*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + 4*D1*bd1*(C - 1)*(D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(1 - 2*r) + Dd*f*(-8*r**2 + 6*r - 1)) - 24*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 42*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2) - f*(150*C*D1**2*f*fd*r**2 - 100*C*D1**2*f*fd*r + 50*C*D1**2*f*fd - 174*C*D1**2*f*fdd*r**2 + 116*C*D1**2*f*fdd*r - 58*C*D1**2*f*fdd - 348*C*D1**2*fd**2*r**2 + 232*C*D1**2*fd**2*r + 200*C*D1*Dd*f**2*r**2 - 100*C*D1*Dd*f**2*r + 50*C*D1*Dd*f**2 - 1392*C*D1*Dd*f*fd*r**2 + 812*C*D1*Dd*f*fd*r - 116*C*D1*Dd*f*fd - 232*C*D1*Ddd*f**2*r**2 + 116*C*D1*Ddd*f**2*r - 58*C*D1*Ddd*f**2 - 696*C*Dd**2*f**2*r**2 + 348*C*Dd**2*f**2*r + 132*D1**2*bd1**2*r*(C - 1)*(r - 1) + 33*D1**2*bdd1*f*(r - 1)*(2*r + 5*s - 2) - 123*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 90*D1**2*f*fd*r + 8*D1**2*f*fd*s - 41*D1**2*f*fd + 111*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 78*D1**2*f*fdd*r - 4*D1**2*f*fdd*s + 37*D1**2*f*fdd + 222*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 156*D1**2*fd**2*r - 8*D1**2*fd**2*s + 4*D1**2*fd**2 - 164*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 98*D1*Dd*f**2*r + 8*D1*Dd*f**2*s - 41*D1*Dd*f**2 + 888*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 558*D1*Dd*f*fd*r - 28*D1*Dd*f*fd*s + 86*D1*Dd*f*fd + 148*D1*Ddd*f**2*r**2 + 16*D1*Ddd*f**2*r*s - 82*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s + 37*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(r - 1)*(2*r + 7*s - 2) + fd*(-8*r**2 - 20*r*s + 13*r + 10*s - 5)) + Dd*f*(-16*r**2 + r*(30 - 40*s) + 25*s - 14)) + 444*Dd**2*f**2*r**2 + 48*Dd**2*f**2*r*s - 246*Dd**2*f**2*r - 12*Dd**2*f**2*s + 8*Dd**2*f**2))/(231*d**2*k1**2*k3**2) - D1**2*Pk1*Pk3*k2**2*st**2*(-88*D1**2*K*bdd1*f**2*r**2 + 132*D1**2*b2*f*fd*r**2 - 132*D1**2*b2*f*fd*r + 66*D1**2*b2*f*fd - 176*D1**2*b2*f*fdd*r**2 + 176*D1**2*b2*f*fdd*r - 88*D1**2*b2*f*fdd - 176*D1**2*b2*fd**2*r**2 + 176*D1**2*b2*fd**2*r + 11*D1**2*bd1**2*(f**2*(32*r**2 + 3*r*(36*s - 25) - 54*s + 27) + f*(r**2*(38 - 2*K) + r*(46*s - 59) - 23*s + 23) - 28*g2*r*(r - 1)) + 66*D1**2*bd2*f**2*r**2 - 352*D1**2*bd2*f*fd*r**2 + 176*D1**2*bd2*f*fd*r + 96*D1**2*bdd1*f**3*r**2 + 66*D1**2*bdd1*f**3*r*s - 33*D1**2*bdd1*f**3*r + 22*D1**2*bdd1*f**2*r**2 - 11*D1**2*bdd1*f**2*r*s + 11*D1**2*bdd1*f**2*r + 22*D1**2*bdd1*f*g2*r**2 - 88*D1**2*bdd2*f**2*r**2 - 132*D1**2*f**2*gd2*r**2 + 176*D1**2*f**2*gdd2*r**2 - 264*D1**2*f*fd*g2*r**2 + 264*D1**2*f*fd*g2*r - 132*D1**2*f*fd*g2 + 704*D1**2*f*fd*gd2*r**2 - 352*D1**2*f*fd*gd2*r + 352*D1**2*f*fdd*g2*r**2 - 352*D1**2*f*fdd*g2*r + 176*D1**2*f*fdd*g2 + 352*D1**2*fd**2*g2*r**2 - 352*D1**2*fd**2*g2*r + 264*D1*Dd*b2*f**2*r**2 - 132*D1*Dd*b2*f**2*r + 66*D1*Dd*b2*f**2 - 1408*D1*Dd*b2*f*fd*r**2 + 1056*D1*Dd*b2*f*fd*r - 176*D1*Dd*b2*f*fd - 704*D1*Dd*bd2*f**2*r**2 + 176*D1*Dd*bd2*f**2*r - 528*D1*Dd*f**2*g2*r**2 + 264*D1*Dd*f**2*g2*r - 132*D1*Dd*f**2*g2 + 1408*D1*Dd*f**2*gd2*r**2 - 352*D1*Dd*f**2*gd2*r + 2816*D1*Dd*f*fd*g2*r**2 - 2112*D1*Dd*f*fd*g2*r + 352*D1*Dd*f*fd*g2 - 352*D1*Ddd*b2*f**2*r**2 + 176*D1*Ddd*b2*f**2*r - 88*D1*Ddd*b2*f**2 + 704*D1*Ddd*f**2*g2*r**2 - 352*D1*Ddd*f**2*g2*r + 176*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(3*f**3*r*(20*r + 22*s - 11) + f**2*(fd*(-576*r**2 - 6*r*(66*s - 65) + 66*s - 33) + 11*r*(r*(2*C - 6*K + 8) + s - 1)) + 11*f*(fd*(r**2*(32*K - 8) + r*(-16*K + 4*s + 2) - s + 1) + r**2*(4*g2 - 4*gd2)) - 44*fd*g2*r*(r - 1)) + Dd*f*(f**2*(768*r**2 + 24*r*(22*s - 19) - 66*s + 33) - 11*f*(r**2*(64*K - 16) - 2*r*(8*K - 4*s + 1) - s + 1) + 44*g2*r*(4*r - 1))) - 1056*Dd**2*b2*f**2*r**2 + 528*Dd**2*b2*f**2*r + 2112*Dd**2*f**2*g2*r**2 - 1056*Dd**2*f**2*g2*r - 77*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(1 - 2*r)) - 11*b1**2*(-14*C*D1**2*fd*r**2 - 56*C*D1*Dd*f*r**2 + 28*C*D1*Dd*f*r - 14*C*D1*Dd*f - 2*D1**2*K*fd*r**2 + 4*D1**2*K*fd*r - 2*D1**2*K*fd + D1**2*K*fdd*r**2 - 2*D1**2*K*fdd*r + D1**2*K*fdd - 7*D1**2*bdd1*(K - 1)*(3*r**2 - 2*r + 1) + 24*D1**2*f*fd*r**2 + 108*D1**2*f*fd*r*s - 69*D1**2*f*fd*r - 6*D1**2*f*fd - 32*D1**2*f*fdd*r**2 - 108*D1**2*f*fdd*r*s + 65*D1**2*f*fdd*r + 8*D1**2*f*fdd - 32*D1**2*fd**2*r**2 - 108*D1**2*fd**2*r*s + 65*D1**2*fd**2*r + 38*D1**2*fd*r**2 + 25*D1**2*fd*r*s - 4*D1**2*fd*r + 2*D1**2*fd - 19*D1**2*fdd*r**2 - 23*D1**2*fdd*r*s + 2*D1**2*fdd*r - D1**2*fdd - 28*D1**2*gd2*r**2 + 14*D1**2*gdd2*r**2 - 8*D1*Dd*K*f*r**2 + 4*D1*Dd*K*f*r - 2*D1*Dd*K*f + 8*D1*Dd*K*fd*r**2 - 10*D1*Dd*K*fd*r + 2*D1*Dd*K*fd + 48*D1*Dd*f**2*r**2 + 216*D1*Dd*f**2*r*s - 132*D1*Dd*f**2*r - 54*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 256*D1*Dd*f*fd*r**2 - 864*D1*Dd*f*fd*r*s + 540*D1*Dd*f*fd*r + 108*D1*Dd*f*fd*s - 65*D1*Dd*f*fd + 152*D1*Dd*f*r**2 + 100*D1*Dd*f*r*s - 126*D1*Dd*f*r - 25*D1*Dd*f*s + 38*D1*Dd*f - 152*D1*Dd*fd*r**2 - 184*D1*Dd*fd*r*s + 92*D1*Dd*fd*r + 23*D1*Dd*fd*s - 2*D1*Dd*fd - 112*D1*Dd*g2*r**2 + 56*D1*Dd*g2*r - 28*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 - 28*D1*Dd*gd2*r + 4*D1*Ddd*K*f*r**2 - 2*D1*Ddd*K*f*r + D1*Ddd*K*f - 64*D1*Ddd*f**2*r**2 - 216*D1*Ddd*f**2*r*s + 140*D1*Ddd*f**2*r + 54*D1*Ddd*f**2*s - 16*D1*Ddd*f**2 - 76*D1*Ddd*f*r**2 - 92*D1*Ddd*f*r*s + 84*D1*Ddd*f*r + 23*D1*Ddd*f*s - 19*D1*Ddd*f + 56*D1*Ddd*g2*r**2 - 28*D1*Ddd*g2*r + 14*D1*Ddd*g2 + 14*D1*bd1*(K - 1)*(D1*(3*r**2 - 2*r + 1) + Dd*(-12*r**2 + 7*r - 1)) + 12*Dd**2*K*f*r**2 - 6*Dd**2*K*f*r - 192*Dd**2*f**2*r**2 - 648*Dd**2*f**2*r*s + 420*Dd**2*f**2*r + 162*Dd**2*f**2*s - 108*Dd**2*f**2 - 228*Dd**2*f*r**2 - 276*Dd**2*f*r*s + 252*Dd**2*f*r + 69*Dd**2*f*s - 46*Dd**2*f + 168*Dd**2*g2*r**2 - 84*Dd**2*g2*r) + b1*(-44*C*D1**2*f*fd*r**2 + 44*C*D1**2*f*fd*r - 22*C*D1**2*f*fd - 88*C*D1*Dd*f**2*r**2 + 44*C*D1*Dd*f**2*r - 22*C*D1*Dd*f**2 + 132*D1**2*K*f*fd*r**2 - 132*D1**2*K*f*fd*r + 66*D1**2*K*f*fd - 176*D1**2*K*f*fdd*r**2 + 176*D1**2*K*f*fdd*r - 88*D1**2*K*f*fdd - 176*D1**2*K*fd**2*r**2 + 176*D1**2*K*fd**2*r + 154*D1**2*bd1**2*r*(K - 1)*(3*r - 2) + 11*D1**2*bdd1*(f**2*(32*r**2 + 3*r*(36*s - 25) - 54*s + 24) + f*(-r**2*(2*K - 38) + r*(46*s - 59) - 23*s + 18) - 14*g2*(2*r**2 - 2*r + 1)) - 180*D1**2*f**2*fd*r**2 - 198*D1**2*f**2*fd*r*s + 219*D1**2*f**2*fd*r + 66*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 288*D1**2*f**2*fdd*r**2 + 198*D1**2*f**2*fdd*r*s - 291*D1**2*f**2*fdd*r - 66*D1**2*f**2*fdd*s + 96*D1**2*f**2*fdd + 576*D1**2*f*fd**2*r**2 + 396*D1**2*f*fd**2*r*s - 582*D1**2*f*fd**2*r - 132*D1**2*f*fd**2*s + 99*D1**2*f*fd**2 - 176*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r*s + 176*D1**2*f*fd*r + 11*D1**2*f*fd*s - 88*D1**2*f*fd + 44*D1**2*f*fdd*r**2 - 22*D1**2*f*fdd*r*s - 44*D1**2*f*fdd*r + 11*D1**2*f*fdd*s + 22*D1**2*f*fdd - 44*D1**2*f*gd2*r**2 + 22*D1**2*f*gdd2*r**2 + 44*D1**2*fd**2*r**2 - 22*D1**2*fd**2*r*s - 44*D1**2*fd**2*r + 11*D1**2*fd**2*s - 44*D1**2*fd*g2*r**2 + 88*D1**2*fd*g2*r - 44*D1**2*fd*g2 + 44*D1**2*fd*gd2*r**2 - 44*D1**2*fd*gd2*r + 22*D1**2*fdd*g2*r**2 - 44*D1**2*fdd*g2*r + 22*D1**2*fdd*g2 + 264*D1*Dd*K*f**2*r**2 - 132*D1*Dd*K*f**2*r + 66*D1*Dd*K*f**2 - 1408*D1*Dd*K*f*fd*r**2 + 1056*D1*Dd*K*f*fd*r - 176*D1*Dd*K*f*fd - 240*D1*Dd*f**3*r**2 - 264*D1*Dd*f**3*r*s + 252*D1*Dd*f**3*r + 66*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 2304*D1*Dd*f**2*fd*r**2 + 1584*D1*Dd*f**2*fd*r*s - 2136*D1*Dd*f**2*fd*r - 462*D1*Dd*f**2*fd*s + 423*D1*Dd*f**2*fd - 352*D1*Dd*f**2*r**2 - 44*D1*Dd*f**2*r*s + 198*D1*Dd*f**2*r + 11*D1*Dd*f**2*s - 88*D1*Dd*f**2 + 352*D1*Dd*f*fd*r**2 - 176*D1*Dd*f*fd*r*s - 220*D1*Dd*f*fd*r + 66*D1*Dd*f*fd*s + 22*D1*Dd*f*fd - 176*D1*Dd*f*g2*r**2 + 88*D1*Dd*f*g2*r - 44*D1*Dd*f*g2 + 176*D1*Dd*f*gd2*r**2 - 44*D1*Dd*f*gd2*r + 176*D1*Dd*fd*g2*r**2 - 220*D1*Dd*fd*g2*r + 44*D1*Dd*fd*g2 - 352*D1*Ddd*K*f**2*r**2 + 176*D1*Ddd*K*f**2*r - 88*D1*Ddd*K*f**2 + 384*D1*Ddd*f**3*r**2 + 264*D1*Ddd*f**3*r*s - 324*D1*Ddd*f**3*r - 66*D1*Ddd*f**3*s + 96*D1*Ddd*f**3 + 88*D1*Ddd*f**2*r**2 - 44*D1*Ddd*f**2*r*s - 22*D1*Ddd*f**2*r + 11*D1*Ddd*f**2*s + 22*D1*Ddd*f**2 + 88*D1*Ddd*f*g2*r**2 - 44*D1*Ddd*f*g2*r + 22*D1*Ddd*f*g2 - 11*D1*bd1*(D1*(4*K*fd*r**2 - 4*K*fd*r + 3*f**2*(8*r**2 + 3*r*(12*s - 7) - 18*s + 6) - f*(14*C*(2*r**2 - 2*r + 1) + 4*K*r**2 + fd*(128*r**2 + 8*r*(54*s - 35) - 108*s + 81) - 76*r**2 - 50*r*s + 97*r + 25*s - 36) - 76*fd*r**2 - 92*fd*r*s + 63*fd*r + 23*fd*s - 56*g2*r**2 + 56*g2*r - 28*g2 + 56*gd2*r**2 - 28*gd2*r) + Dd*(f**2*(-256*r**2 + r*(580 - 864*s) + 324*s - 183) + f*(r**2*(16*K - 304) - 4*r*(K + 92*s - 101) + 138*s - 105) + 28*g2*(8*r**2 - 6*r + 1))) - 1056*Dd**2*K*f**2*r**2 + 528*Dd**2*K*f**2*r + 1152*Dd**2*f**3*r**2 + 792*Dd**2*f**3*r*s - 972*Dd**2*f**3*r - 198*Dd**2*f**3*s + 132*Dd**2*f**3 + 264*Dd**2*f**2*r**2 - 132*Dd**2*f**2*r*s - 66*Dd**2*f**2*r + 33*Dd**2*f**2*s - 22*Dd**2*f**2 + 264*Dd**2*f*g2*r**2 - 132*Dd**2*f*g2*r))/(231*d**2*k1**2*k3**2) - 4*D1**2*Pk1*Pk3*st**4*(D1**2*bd1**2*f*s*(1 - 2*r) + D1*b1*(D1*bd1*(2*f*s*(2*r - 1) + fd*(-4*r*s + 2*r + s - 1)) + D1*bdd1*f*s*(1 - 2*r) - 2*Dd*bd1*f*(r*(8*s - 2) - 3*s + 1)) + b1**2*(-D1*Dd*(2*f*(-4*r*s + 2*r + s) + fd*(8*r*s - 6*r - s + 1)) + D1*(D1*r*(2*fd - fdd)*(s - 1) + Ddd*f*(-4*r*s + 2*r + s)) + Dd**2*f*(r*(6 - 12*s) + 3*s - 2)))/(7*d**2*k1**2) + D1**2*Pk1*Pk3*st**2*(-D1*f*(23*D1*bd1**2*s*(2*r - 1) - D1*bdd1*f*r*(r*(16*C - 8) + s) + bd1*(D1*(f*r*(r*(12*C - 6) + s) + fd*(r**2*(32 - 64*C) + r*(32*C - 4*s - 15) + s)) + Dd*f*(r**2*(64 - 128*C) + 2*r*(16*C - 4*s - 7) + s))) + b1**2*(D1*Dd*(39*f*(4*r*s - 2*r - s) - 23*fd*(8*r*s - 6*r - s + 1)) + D1*(D1*r*(39*fd - 23*fdd)*(s - 1) + 23*Ddd*f*(-4*r*s + 2*r + s)) - 23*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(D1**2*(f*(23*bdd1*s*(1 - 2*r) + fd*(-12*C*(2*r**2 - 2*r + 1) + 12*r**2 - 2*r*s - 11*r + s + 6) + fdd*(16*C*(2*r**2 - 2*r + 1) - 16*r**2 + 2*r*s + 15*r - s - 8)) + fd**2*(r**2*(32*C - 16) + r*(-32*C + 2*s + 15) - s + 1)) + D1*bd1*(D1*(39*f*s*(2*r - 1) - 23*fd*(4*r*s - 2*r - s + 1)) - 46*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*f*(Dd*(f*(-12*C*(4*r**2 - 2*r + 1) + 24*r**2 - 2*r*(2*s + 5) + s + 6) + fd*(32*C*(8*r**2 - 6*r + 1) - 128*r**2 + 8*r*(2*s + 11) - 6*s - 13)) + Ddd*f*(16*C*(4*r**2 - 2*r + 1) - 32*r**2 + 2*r*(2*s + 7) - s - 8)) + Dd**2*f**2*(r**2*(192*C - 96) + r*(-96*C + 12*s + 42) - 3*s + 2)))/(21*d**2*k1**2) + 2*D1**2*Pk1*Pk3*(D1*r*(D1*bd1**2*f*(22*K*r + f*(3 - 6*s) - 6*s + 3) + 11*D1*bdd1*f*r*(b2 - 2*g2) + bd1*(2*D1*f*r*(11*bd2 + g2 - 22*gd2) - 44*D1*fd*g2*(r - 1) + 44*Dd*f*g2*(1 - 4*r) + b2*(-D1*f*r + 22*D1*fd*(r - 1) + 22*Dd*f*(4*r - 1)))) - 14*b1**3*(D1*Dd*(fd*(8*r*s - 6*r - s + 1) - (f + 2)*(4*r*s - 2*r - s)) + D1*(-D1*r*(fd - fdd)*(s - 1) + Ddd*(f + 1)*(4*r*s - 2*r - s)) + Dd**2*(f + 1)*(6*r*(2*s - 1) - 3*s + 2)) + b1**2*(-D1*Dd*(K*f*(4*r**2 - 2*r + 1) - 22*K*fd*(4*r**2 - 5*r + 1) + 3*f*fd*(8*r - 3)*(2*s - 1) - f*(3*f + 13)*(r*(4*s - 2) - s) + 3*fd*(r*(8*s - 2) - 5*s + 2)) + 14*D1*bd1*(-D1*fd*(r*(6*s - 4) - s + 1) + D1*(f + 2)*(r*(3*s - 1) - s) - Dd*(f + 1)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(-14*bdd1*(f + 1)*(r*(3*s - 1) - s) + 3*fd**2*(-2*r*s + r + s - 1) - fd*(K*(r - 1)**2 + 3*f*(-2*r*s + r + s) - s*(13*r - 13)) + fdd*(11*K*(r - 1)**2 + 3*f*(-2*r*s + r + s) - 3*r*s + 3*s)) + Ddd*f*(11*K*(4*r**2 - 2*r + 1) - (3*f + 3)*(r*(4*s - 2) - s))) - 3*Dd**2*f*(-44*K*r**2 + f*(6*r*(2*s - 1) - 3*s + 2) + 2*r*(11*K + 6*s - 3) - 3*s + 2)) - b1*(-22*D1**2*K*bdd1*f*r**2 + 14*D1**2*bd1**2*(f + 1)*(r*(6*s - 2) - 2*s + 1) + D1**2*bd2*f*r**2 - 22*D1**2*bd2*fd*r**2 + 22*D1**2*bd2*fd*r + 6*D1**2*bdd1*f**2*r*s - 3*D1**2*bdd1*f**2*r + 6*D1**2*bdd1*f*r*s - 3*D1**2*bdd1*f*r - 11*D1**2*bdd2*f*r**2 - 2*D1**2*f*gd2*r**2 + 22*D1**2*f*gdd2*r**2 - 2*D1**2*fd*g2*r**2 + 4*D1**2*fd*g2*r - 2*D1**2*fd*g2 + 44*D1**2*fd*gd2*r**2 - 44*D1**2*fd*gd2*r + 22*D1**2*fdd*g2*r**2 - 44*D1**2*fdd*g2*r + 22*D1**2*fdd*g2 - 88*D1*Dd*bd2*f*r**2 + 22*D1*Dd*bd2*f*r - 8*D1*Dd*f*g2*r**2 + 4*D1*Dd*f*g2*r - 2*D1*Dd*f*g2 + 176*D1*Dd*f*gd2*r**2 - 44*D1*Dd*f*gd2*r + 176*D1*Dd*fd*g2*r**2 - 220*D1*Dd*fd*g2*r + 44*D1*Dd*fd*g2 + 88*D1*Ddd*f*g2*r**2 - 44*D1*Ddd*f*g2*r + 22*D1*Ddd*f*g2 + D1*bd1*(D1*(f*r*(2*K*r + f*(3 - 6*s) - 26*s + 13) + fd*(-44*K*r**2 + 3*f*(4*r - 1)*(2*s - 1) + r*(44*K + 12*s - 3) - 6*s + 3)) + Dd*f*(-176*K*r**2 + 3*f*(8*r - 1)*(2*s - 1) + 4*r*(11*K + 12*s - 6) - 6*s + 3)) + 264*Dd**2*f*g2*r**2 - 132*Dd**2*f*g2*r + b2*(D1**2*(fd - 11*fdd)*(r - 1)**2 + D1*(Dd*f*(4*r**2 - 2*r + 1) - 22*Dd*fd*(4*r**2 - 5*r + 1) - 11*Ddd*f*(4*r**2 - 2*r + 1)) + 66*Dd**2*f*r*(1 - 2*r))))/(21*d**2*k1**2) + D1**2*Pk1*Pkd3*ct**8*k2**6*(10*C - 10)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 168*D1**2*f**2*fd*r**2 + 336*D1**2*f**2*fd*r*s - 224*D1**2*f**2*fd*r + 168*D1**2*f**2*fd*s**2 - 224*D1**2*f**2*fd*s + 112*D1**2*f**2*fd - 84*D1**2*f**2*fdd*r**2 - 168*D1**2*f**2*fdd*r*s + 112*D1**2*f**2*fdd*r - 84*D1**2*f**2*fdd*s**2 + 112*D1**2*f**2*fdd*s - 56*D1**2*f**2*fdd - 168*D1**2*f*fd**2*r**2 - 336*D1**2*f*fd**2*r*s + 224*D1**2*f*fd**2*r - 168*D1**2*f*fd**2*s**2 + 224*D1**2*f*fd**2*s - 56*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 224*D1*Dd*f**3*r**2 + 448*D1*Dd*f**3*r*s - 336*D1*Dd*f**3*r + 224*D1*Dd*f**3*s**2 - 336*D1*Dd*f**3*s + 168*D1*Dd*f**3 - 672*D1*Dd*f**2*fd*r**2 - 1344*D1*Dd*f**2*fd*r*s + 952*D1*Dd*f**2*fd*r - 672*D1*Dd*f**2*fd*s**2 + 952*D1*Dd*f**2*fd*s - 336*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 112*D1*Ddd*f**3*r**2 - 224*D1*Ddd*f**3*r*s + 168*D1*Ddd*f**3*r - 112*D1*Ddd*f**3*s**2 + 168*D1*Ddd*f**3*s - 84*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 336*Dd**2*f**3*r**2 - 672*Dd**2*f**3*r*s + 504*Dd**2*f**3*r - 336*Dd**2*f**3*s**2 + 504*Dd**2*f**3*s - 168*Dd**2*f**3)/(77*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**8*k2**4*(40*C - 40)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 56*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 28*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 28*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**5) + 5*D1**2*Pk1*Pkd3*ct**7*f*k2**7*(312*D1**2*b1*f*fd*r**2 + 624*D1**2*b1*f*fd*r*s - 416*D1**2*b1*f*fd*r + 312*D1**2*b1*f*fd*s**2 - 416*D1**2*b1*f*fd*s + 208*D1**2*b1*f*fd - 156*D1**2*b1*f*fdd*r**2 - 312*D1**2*b1*f*fdd*r*s + 208*D1**2*b1*f*fdd*r - 156*D1**2*b1*f*fdd*s**2 + 208*D1**2*b1*f*fdd*s - 104*D1**2*b1*f*fdd - 312*D1**2*b1*fd**2*r**2 - 624*D1**2*b1*fd**2*r*s + 416*D1**2*b1*fd**2*r - 312*D1**2*b1*fd**2*s**2 + 416*D1**2*b1*fd**2*s - 104*D1**2*b1*fd**2 - 52*D1**2*bdd1*f**2*(r + s - 1)**2 + 360*D1**2*f**2*fd*r**2 + 720*D1**2*f**2*fd*r*s - 540*D1**2*f**2*fd*r + 360*D1**2*f**2*fd*s**2 - 540*D1**2*f**2*fd*s + 270*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r**2 - 360*D1**2*f**2*fdd*r*s + 270*D1**2*f**2*fdd*r - 180*D1**2*f**2*fdd*s**2 + 270*D1**2*f**2*fdd*s - 135*D1**2*f**2*fdd - 540*D1**2*f*fd**2*r**2 - 1080*D1**2*f*fd**2*r*s + 810*D1**2*f*fd**2*r - 540*D1**2*f*fd**2*s**2 + 810*D1**2*f*fd**2*s - 270*D1**2*f*fd**2 + 416*D1*Dd*b1*f**2*r**2 + 832*D1*Dd*b1*f**2*r*s - 624*D1*Dd*b1*f**2*r + 416*D1*Dd*b1*f**2*s**2 - 624*D1*Dd*b1*f**2*s + 312*D1*Dd*b1*f**2 - 1248*D1*Dd*b1*f*fd*r**2 - 2496*D1*Dd*b1*f*fd*r*s + 1768*D1*Dd*b1*f*fd*r - 1248*D1*Dd*b1*f*fd*s**2 + 1768*D1*Dd*b1*f*fd*s - 624*D1*Dd*b1*f*fd + 360*D1*Dd*f**3*r**2 + 720*D1*Dd*f**3*r*s - 540*D1*Dd*f**3*r + 360*D1*Dd*f**3*s**2 - 540*D1*Dd*f**3*s + 270*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r**2 - 2880*D1*Dd*f**2*fd*r*s + 2160*D1*Dd*f**2*fd*r - 1440*D1*Dd*f**2*fd*s**2 + 2160*D1*Dd*f**2*fd*s - 810*D1*Dd*f**2*fd - 208*D1*Ddd*b1*f**2*r**2 - 416*D1*Ddd*b1*f**2*r*s + 312*D1*Ddd*b1*f**2*r - 208*D1*Ddd*b1*f**2*s**2 + 312*D1*Ddd*b1*f**2*s - 156*D1*Ddd*b1*f**2 - 180*D1*Ddd*f**3*r**2 - 360*D1*Ddd*f**3*r*s + 270*D1*Ddd*f**3*r - 180*D1*Ddd*f**3*s**2 + 270*D1*Ddd*f**3*s - 135*D1*Ddd*f**3 + 104*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 624*Dd**2*b1*f**2*r**2 - 1248*Dd**2*b1*f**2*r*s + 936*Dd**2*b1*f**2*r - 624*Dd**2*b1*f**2*s**2 + 936*Dd**2*b1*f**2*s - 312*Dd**2*b1*f**2 - 540*Dd**2*f**3*r**2 - 1080*Dd**2*f**3*r*s + 810*Dd**2*f**3*r - 540*Dd**2*f**3*s**2 + 810*Dd**2*f**3*s - 270*Dd**2*f**3)/(143*d**2*k1*k3**7) + D1**2*Pk1*Pkd3*ct**7*k1*k2**5*(6336*C*D1**2*b1*f*fd*r**2 + 12672*C*D1**2*b1*f*fd*r*s - 6336*C*D1**2*b1*f*fd*r + 6336*C*D1**2*b1*f*fd*s**2 - 6336*C*D1**2*b1*f*fd*s + 3168*C*D1**2*b1*f*fd - 3960*C*D1**2*b1*f*fdd*r**2 - 7920*C*D1**2*b1*f*fdd*r*s + 3960*C*D1**2*b1*f*fdd*r - 3960*C*D1**2*b1*f*fdd*s**2 + 3960*C*D1**2*b1*f*fdd*s - 1980*C*D1**2*b1*f*fdd - 3960*C*D1**2*b1*fd**2*r**2 - 7920*C*D1**2*b1*fd**2*r*s + 3960*C*D1**2*b1*fd**2*r - 3960*C*D1**2*b1*fd**2*s**2 + 3960*C*D1**2*b1*fd**2*s + 8100*C*D1**2*f**2*fd*r**2 + 16200*C*D1**2*f**2*fd*r*s - 10800*C*D1**2*f**2*fd*r + 8100*C*D1**2*f**2*fd*s**2 - 10800*C*D1**2*f**2*fd*s + 5400*C*D1**2*f**2*fd - 5040*C*D1**2*f**2*fdd*r**2 - 10080*C*D1**2*f**2*fdd*r*s + 6720*C*D1**2*f**2*fdd*r - 5040*C*D1**2*f**2*fdd*s**2 + 6720*C*D1**2*f**2*fdd*s - 3360*C*D1**2*f**2*fdd - 10080*C*D1**2*f*fd**2*r**2 - 20160*C*D1**2*f*fd**2*r*s + 13440*C*D1**2*f*fd**2*r - 10080*C*D1**2*f*fd**2*s**2 + 13440*C*D1**2*f*fd**2*s - 3360*C*D1**2*f*fd**2 + 12672*C*D1*Dd*b1*f**2*r**2 + 25344*C*D1*Dd*b1*f**2*r*s - 19008*C*D1*Dd*b1*f**2*r + 12672*C*D1*Dd*b1*f**2*s**2 - 19008*C*D1*Dd*b1*f**2*s + 9504*C*D1*Dd*b1*f**2 - 31680*C*D1*Dd*b1*f*fd*r**2 - 63360*C*D1*Dd*b1*f*fd*r*s + 39600*C*D1*Dd*b1*f*fd*r - 31680*C*D1*Dd*b1*f*fd*s**2 + 39600*C*D1*Dd*b1*f*fd*s - 11880*C*D1*Dd*b1*f*fd + 10800*C*D1*Dd*f**3*r**2 + 21600*C*D1*Dd*f**3*r*s - 16200*C*D1*Dd*f**3*r + 10800*C*D1*Dd*f**3*s**2 - 16200*C*D1*Dd*f**3*s + 8100*C*D1*Dd*f**3 - 40320*C*D1*Dd*f**2*fd*r**2 - 80640*C*D1*Dd*f**2*fd*r*s + 57120*C*D1*Dd*f**2*fd*r - 40320*C*D1*Dd*f**2*fd*s**2 + 57120*C*D1*Dd*f**2*fd*s - 20160*C*D1*Dd*f**2*fd - 7920*C*D1*Ddd*b1*f**2*r**2 - 15840*C*D1*Ddd*b1*f**2*r*s + 11880*C*D1*Ddd*b1*f**2*r - 7920*C*D1*Ddd*b1*f**2*s**2 + 11880*C*D1*Ddd*b1*f**2*s - 5940*C*D1*Ddd*b1*f**2 - 6720*C*D1*Ddd*f**3*r**2 - 13440*C*D1*Ddd*f**3*r*s + 10080*C*D1*Ddd*f**3*r - 6720*C*D1*Ddd*f**3*s**2 + 10080*C*D1*Ddd*f**3*s - 5040*C*D1*Ddd*f**3 - 23760*C*Dd**2*b1*f**2*r**2 - 47520*C*Dd**2*b1*f**2*r*s + 35640*C*Dd**2*b1*f**2*r - 23760*C*Dd**2*b1*f**2*s**2 + 35640*C*Dd**2*b1*f**2*s - 11880*C*Dd**2*b1*f**2 - 20160*C*Dd**2*f**3*r**2 - 40320*C*Dd**2*f**3*r*s + 30240*C*Dd**2*f**3*r - 20160*C*Dd**2*f**3*s**2 + 30240*C*Dd**2*f**3*s - 10080*C*Dd**2*f**3 - 5676*D1**2*b1*f*fd*r**2 - 11352*D1**2*b1*f*fd*r*s + 5676*D1**2*b1*f*fd*r - 5676*D1**2*b1*f*fd*s**2 + 5676*D1**2*b1*f*fd*s - 2838*D1**2*b1*f*fd + 3630*D1**2*b1*f*fdd*r**2 + 7260*D1**2*b1*f*fdd*r*s - 3630*D1**2*b1*f*fdd*r + 3630*D1**2*b1*f*fdd*s**2 - 3630*D1**2*b1*f*fdd*s + 1815*D1**2*b1*f*fdd + 3630*D1**2*b1*fd**2*r**2 + 7260*D1**2*b1*fd**2*r*s - 3630*D1**2*b1*fd**2*r + 3630*D1**2*b1*fd**2*s**2 - 3630*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(12*C - 11)*(r + s - 1)**2 - 7260*D1**2*f**2*fd*r**2 - 14520*D1**2*f**2*fd*r*s + 9680*D1**2*f**2*fd*r - 7260*D1**2*f**2*fd*s**2 + 9680*D1**2*f**2*fd*s - 4840*D1**2*f**2*fd + 4620*D1**2*f**2*fdd*r**2 + 9240*D1**2*f**2*fdd*r*s - 6160*D1**2*f**2*fdd*r + 4620*D1**2*f**2*fdd*s**2 - 6160*D1**2*f**2*fdd*s + 3080*D1**2*f**2*fdd + 9240*D1**2*f*fd**2*r**2 + 18480*D1**2*f*fd**2*r*s - 12320*D1**2*f*fd**2*r + 9240*D1**2*f*fd**2*s**2 - 12320*D1**2*f*fd**2*s + 3080*D1**2*f*fd**2 - 11352*D1*Dd*b1*f**2*r**2 - 22704*D1*Dd*b1*f**2*r*s + 17028*D1*Dd*b1*f**2*r - 11352*D1*Dd*b1*f**2*s**2 + 17028*D1*Dd*b1*f**2*s - 8514*D1*Dd*b1*f**2 + 29040*D1*Dd*b1*f*fd*r**2 + 58080*D1*Dd*b1*f*fd*r*s - 36300*D1*Dd*b1*f*fd*r + 29040*D1*Dd*b1*f*fd*s**2 - 36300*D1*Dd*b1*f*fd*s + 10890*D1*Dd*b1*f*fd - 9680*D1*Dd*f**3*r**2 - 19360*D1*Dd*f**3*r*s + 14520*D1*Dd*f**3*r - 9680*D1*Dd*f**3*s**2 + 14520*D1*Dd*f**3*s - 7260*D1*Dd*f**3 + 36960*D1*Dd*f**2*fd*r**2 + 73920*D1*Dd*f**2*fd*r*s - 52360*D1*Dd*f**2*fd*r + 36960*D1*Dd*f**2*fd*s**2 - 52360*D1*Dd*f**2*fd*s + 18480*D1*Dd*f**2*fd + 7260*D1*Ddd*b1*f**2*r**2 + 14520*D1*Ddd*b1*f**2*r*s - 10890*D1*Ddd*b1*f**2*r + 7260*D1*Ddd*b1*f**2*s**2 - 10890*D1*Ddd*b1*f**2*s + 5445*D1*Ddd*b1*f**2 + 6160*D1*Ddd*f**3*r**2 + 12320*D1*Ddd*f**3*r*s - 9240*D1*Ddd*f**3*r + 6160*D1*Ddd*f**3*s**2 - 9240*D1*Ddd*f**3*s + 4620*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(48*C - 43)*(r + s - 1) - D1*fd*(60*C - 55)*(2*r + 2*s - 1) - Dd*f*(60*C - 55)*(4*r + 4*s - 3)) + 21780*Dd**2*b1*f**2*r**2 + 43560*Dd**2*b1*f**2*r*s - 32670*Dd**2*b1*f**2*r + 21780*Dd**2*b1*f**2*s**2 - 32670*Dd**2*b1*f**2*s + 10890*Dd**2*b1*f**2 + 18480*Dd**2*f**3*r**2 + 36960*Dd**2*f**3*r*s - 27720*Dd**2*f**3*r + 18480*Dd**2*f**3*s**2 - 27720*Dd**2*f**3*s + 9240*Dd**2*f**3)/(77*d**2*k3**7) + 4*D1**2*Pk1*Pkd3*ct**7*k1*k2**3*(33*b1*(D1**2*(f*(fd*(88*C - 78) + fdd*(45 - 50*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(45 - 50*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(88*C - 78)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(45 - 50*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(45 - 50*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(45 - 50*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(494*C - 438)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (10*C - 9)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(252 - 280*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(88*C - 78)*(r + s - 1) - fd*(50*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(45 - 50*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 10*D1*f*(Dd*(f*(247*C - 219)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(140*C - 126)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(126 - 140*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(252 - 280*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**5) - D1**2*Pk1*Pkd3*ct**7*k2**5*(3168*C*D1**2*b1*f*fd*r**2 + 3168*C*D1**2*b1*f*fd*r*s - 1584*C*D1**2*b1*f*fd*r + 5160*C*D1**2*f**2*fd*r**2 + 5160*C*D1**2*f**2*fd*r*s - 5160*C*D1**2*f**2*fd*r - 1720*C*D1**2*f**2*fd*s + 1720*C*D1**2*f**2*fd - 600*C*D1**2*f**2*fdd*r**2 - 600*C*D1**2*f**2*fdd*r*s + 600*C*D1**2*f**2*fdd*r + 200*C*D1**2*f**2*fdd*s - 200*C*D1**2*f**2*fdd - 1200*C*D1**2*f*fd**2*r**2 - 1200*C*D1**2*f*fd**2*r*s + 1200*C*D1**2*f*fd**2*r + 400*C*D1**2*f*fd**2*s - 200*C*D1**2*f*fd**2 + 6336*C*D1*Dd*b1*f**2*r**2 + 6336*C*D1*Dd*b1*f**2*r*s - 6336*C*D1*Dd*b1*f**2*r - 1584*C*D1*Dd*b1*f**2*s + 1584*C*D1*Dd*b1*f**2 + 6880*C*D1*Dd*f**3*r**2 + 6880*C*D1*Dd*f**3*r*s - 6880*C*D1*Dd*f**3*r - 1720*C*D1*Dd*f**3*s + 1720*C*D1*Dd*f**3 - 4800*C*D1*Dd*f**2*fd*r**2 - 4800*C*D1*Dd*f**2*fd*r*s + 4800*C*D1*Dd*f**2*fd*r + 1400*C*D1*Dd*f**2*fd*s - 1000*C*D1*Dd*f**2*fd - 800*C*D1*Ddd*f**3*r**2 - 800*C*D1*Ddd*f**3*r*s + 800*C*D1*Ddd*f**3*r + 200*C*D1*Ddd*f**3*s - 200*C*D1*Ddd*f**3 - 2400*C*Dd**2*f**3*r**2 - 2400*C*Dd**2*f**3*r*s + 2400*C*Dd**2*f**3*r + 600*C*Dd**2*f**3*s - 400*C*Dd**2*f**3 - 6468*D1**2*b1*f*fd*r**2 - 9768*D1**2*b1*f*fd*r*s + 4884*D1**2*b1*f*fd*r - 3300*D1**2*b1*f*fd*s**2 + 3300*D1**2*b1*f*fd*s - 1650*D1**2*b1*f*fd + 1650*D1**2*b1*f*fdd*r**2 + 3300*D1**2*b1*f*fdd*r*s - 1650*D1**2*b1*f*fdd*r + 1650*D1**2*b1*f*fdd*s**2 - 1650*D1**2*b1*f*fdd*s + 825*D1**2*b1*f*fdd + 1650*D1**2*b1*fd**2*r**2 + 3300*D1**2*b1*fd**2*r*s - 1650*D1**2*b1*fd**2*r + 1650*D1**2*b1*fd**2*s**2 - 1650*D1**2*b1*fd**2*s + 825*D1**2*bdd1*f**2*(r + s - 1)**2 - 9360*D1**2*f**2*fd*r**2 - 13560*D1**2*f**2*fd*r*s + 10760*D1**2*f**2*fd*r - 4200*D1**2*f**2*fd*s**2 + 7320*D1**2*f**2*fd*s - 4520*D1**2*f**2*fd + 2700*D1**2*f**2*fdd*r**2 + 4800*D1**2*f**2*fdd*r*s - 3400*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 3000*D1**2*f**2*fdd*s + 1600*D1**2*f**2*fdd + 5400*D1**2*f*fd**2*r**2 + 9600*D1**2*f*fd**2*r*s - 6800*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 6000*D1**2*f*fd**2*s + 1600*D1**2*f*fd**2 - 12936*D1*Dd*b1*f**2*r**2 - 19536*D1*Dd*b1*f**2*r*s + 16236*D1*Dd*b1*f**2*r - 6600*D1*Dd*b1*f**2*s**2 + 11484*D1*Dd*b1*f**2*s - 6534*D1*Dd*b1*f**2 + 13200*D1*Dd*b1*f*fd*r**2 + 26400*D1*Dd*b1*f*fd*r*s - 16500*D1*Dd*b1*f*fd*r + 13200*D1*Dd*b1*f*fd*s**2 - 16500*D1*Dd*b1*f*fd*s + 4950*D1*Dd*b1*f*fd - 12480*D1*Dd*f**3*r**2 - 18080*D1*Dd*f**3*r*s + 15280*D1*Dd*f**3*r - 5600*D1*Dd*f**3*s**2 + 10120*D1*Dd*f**3*s - 5920*D1*Dd*f**3 + 21600*D1*Dd*f**2*fd*r**2 + 38400*D1*Dd*f**2*fd*r*s - 28600*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 25200*D1*Dd*f**2*fd*s + 9400*D1*Dd*f**2*fd + 3300*D1*Ddd*b1*f**2*r**2 + 6600*D1*Ddd*b1*f**2*r*s - 4950*D1*Ddd*b1*f**2*r + 3300*D1*Ddd*b1*f**2*s**2 - 4950*D1*Ddd*b1*f**2*s + 2475*D1*Ddd*b1*f**2 + 3600*D1*Ddd*f**3*r**2 + 6400*D1*Ddd*f**3*r*s - 5000*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4400*D1*Ddd*f**3*s + 2300*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(24*C*(r - 1) - 49*r - 25*s + 49) + 25*D1*fd*(2*r + 2*s - 1) + 25*Dd*f*(4*r + 4*s - 3)) + 9900*Dd**2*b1*f**2*r**2 + 19800*Dd**2*b1*f**2*r*s - 14850*Dd**2*b1*f**2*r + 9900*Dd**2*b1*f**2*s**2 - 14850*Dd**2*b1*f**2*s + 4950*Dd**2*b1*f**2 + 10800*Dd**2*f**3*r**2 + 19200*Dd**2*f**3*r*s - 15000*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 13200*Dd**2*f**3*s + 4600*Dd**2*f**3)/(693*d**2*k1*k3**5) + 20*D1**2*Pk1*Pkd3*ct**7*k2**3*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 56*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 28*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 28*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k1*k3**3) - 10*D1**2*Pk1*Pkd3*ct**6*f*k2**6*(-507*D1**2*b1*f*fd*r**2 - 507*D1**2*b1*f*fd*r*s + 338*D1**2*b1*f*fd*r + 897*D1**2*b1*f*fdd*r**2 + 897*D1**2*b1*f*fdd*r*s - 598*D1**2*b1*f*fdd*r + 1794*D1**2*b1*fd**2*r**2 + 1794*D1**2*b1*fd**2*r*s - 1196*D1**2*b1*fd**2*r + 299*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 112*D1**2*f**2*fd*r**2 + 112*D1**2*f**2*fd*r*s - 112*D1**2*f**2*fd*r - 28*D1**2*f**2*fd*s + 28*D1**2*f**2*fd + 672*D1**2*f**2*fdd*r**2 + 672*D1**2*f**2*fdd*r*s - 672*D1**2*f**2*fdd*r - 168*D1**2*f**2*fdd*s + 168*D1**2*f**2*fdd + 2016*D1**2*f*fd**2*r**2 + 2016*D1**2*f*fd**2*r*s - 2016*D1**2*f*fd**2*r - 504*D1**2*f*fd**2*s + 336*D1**2*f*fd**2 - 676*D1*Dd*b1*f**2*r**2 - 676*D1*Dd*b1*f**2*r*s + 676*D1*Dd*b1*f**2*r + 169*D1*Dd*b1*f**2*s - 169*D1*Dd*b1*f**2 + 7176*D1*Dd*b1*f*fd*r**2 + 7176*D1*Dd*b1*f*fd*r*s - 5980*D1*Dd*b1*f*fd*r - 897*D1*Dd*b1*f*fd*s + 598*D1*Dd*b1*f*fd + 112*D1*Dd*f**3*r**2 + 112*D1*Dd*f**3*r*s - 112*D1*Dd*f**3*r - 28*D1*Dd*f**3*s + 28*D1*Dd*f**3 + 5376*D1*Dd*f**2*fd*r**2 + 5376*D1*Dd*f**2*fd*r*s - 5376*D1*Dd*f**2*fd*r - 1344*D1*Dd*f**2*fd*s + 1008*D1*Dd*f**2*fd + 1196*D1*Ddd*b1*f**2*r**2 + 1196*D1*Ddd*b1*f**2*r*s - 1196*D1*Ddd*b1*f**2*r - 299*D1*Ddd*b1*f**2*s + 299*D1*Ddd*b1*f**2 + 672*D1*Ddd*f**3*r**2 + 672*D1*Ddd*f**3*r*s - 672*D1*Ddd*f**3*r - 168*D1*Ddd*f**3*s + 168*D1*Ddd*f**3 - 13*D1*bd1*f*(D1*(13*f*(r - 1)*(r + s - 1) - 23*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 23*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 3588*Dd**2*b1*f**2*r**2 + 3588*Dd**2*b1*f**2*r*s - 3588*Dd**2*b1*f**2*r - 897*Dd**2*b1*f**2*s + 598*Dd**2*b1*f**2 + 2016*Dd**2*f**3*r**2 + 2016*Dd**2*f**3*r*s - 2016*Dd**2*f**3*r - 504*Dd**2*f**3*s + 336*Dd**2*f**3)/(9009*d**2*k1**2*k3**5) + D1**2*Pk1*Pkd3*ct**6*k1**2*k2**4*(12672*C*D1**2*b1*f*fd*r**2 + 25344*C*D1**2*b1*f*fd*r*s - 12672*C*D1**2*b1*f*fd*r + 12672*C*D1**2*b1*f*fd*s**2 - 12672*C*D1**2*b1*f*fd*s + 6336*C*D1**2*b1*f*fd - 9900*C*D1**2*b1*f*fdd*r**2 - 19800*C*D1**2*b1*f*fdd*r*s + 9900*C*D1**2*b1*f*fdd*r - 9900*C*D1**2*b1*f*fdd*s**2 + 9900*C*D1**2*b1*f*fdd*s - 4950*C*D1**2*b1*f*fdd - 9900*C*D1**2*b1*fd**2*r**2 - 19800*C*D1**2*b1*fd**2*r*s + 9900*C*D1**2*b1*fd**2*r - 9900*C*D1**2*b1*fd**2*s**2 + 9900*C*D1**2*b1*fd**2*s + 16290*C*D1**2*f**2*fd*r**2 + 32580*C*D1**2*f**2*fd*r*s - 21720*C*D1**2*f**2*fd*r + 16290*C*D1**2*f**2*fd*s**2 - 21720*C*D1**2*f**2*fd*s + 10860*C*D1**2*f**2*fd - 12600*C*D1**2*f**2*fdd*r**2 - 25200*C*D1**2*f**2*fdd*r*s + 16800*C*D1**2*f**2*fdd*r - 12600*C*D1**2*f**2*fdd*s**2 + 16800*C*D1**2*f**2*fdd*s - 8400*C*D1**2*f**2*fdd - 25200*C*D1**2*f*fd**2*r**2 - 50400*C*D1**2*f*fd**2*r*s + 33600*C*D1**2*f*fd**2*r - 25200*C*D1**2*f*fd**2*s**2 + 33600*C*D1**2*f*fd**2*s - 8400*C*D1**2*f*fd**2 + 25344*C*D1*Dd*b1*f**2*r**2 + 50688*C*D1*Dd*b1*f**2*r*s - 38016*C*D1*Dd*b1*f**2*r + 25344*C*D1*Dd*b1*f**2*s**2 - 38016*C*D1*Dd*b1*f**2*s + 19008*C*D1*Dd*b1*f**2 - 79200*C*D1*Dd*b1*f*fd*r**2 - 158400*C*D1*Dd*b1*f*fd*r*s + 99000*C*D1*Dd*b1*f*fd*r - 79200*C*D1*Dd*b1*f*fd*s**2 + 99000*C*D1*Dd*b1*f*fd*s - 29700*C*D1*Dd*b1*f*fd + 21720*C*D1*Dd*f**3*r**2 + 43440*C*D1*Dd*f**3*r*s - 32580*C*D1*Dd*f**3*r + 21720*C*D1*Dd*f**3*s**2 - 32580*C*D1*Dd*f**3*s + 16290*C*D1*Dd*f**3 - 100800*C*D1*Dd*f**2*fd*r**2 - 201600*C*D1*Dd*f**2*fd*r*s + 142800*C*D1*Dd*f**2*fd*r - 100800*C*D1*Dd*f**2*fd*s**2 + 142800*C*D1*Dd*f**2*fd*s - 50400*C*D1*Dd*f**2*fd - 19800*C*D1*Ddd*b1*f**2*r**2 - 39600*C*D1*Ddd*b1*f**2*r*s + 29700*C*D1*Ddd*b1*f**2*r - 19800*C*D1*Ddd*b1*f**2*s**2 + 29700*C*D1*Ddd*b1*f**2*s - 14850*C*D1*Ddd*b1*f**2 - 16800*C*D1*Ddd*f**3*r**2 - 33600*C*D1*Ddd*f**3*r*s + 25200*C*D1*Ddd*f**3*r - 16800*C*D1*Ddd*f**3*s**2 + 25200*C*D1*Ddd*f**3*s - 12600*C*D1*Ddd*f**3 - 59400*C*Dd**2*b1*f**2*r**2 - 118800*C*Dd**2*b1*f**2*r*s + 89100*C*Dd**2*b1*f**2*r - 59400*C*Dd**2*b1*f**2*s**2 + 89100*C*Dd**2*b1*f**2*s - 29700*C*Dd**2*b1*f**2 - 50400*C*Dd**2*f**3*r**2 - 100800*C*Dd**2*f**3*r*s + 75600*C*Dd**2*f**3*r - 50400*C*Dd**2*f**3*s**2 + 75600*C*Dd**2*f**3*s - 25200*C*Dd**2*f**3 - 10164*D1**2*b1*f*fd*r**2 - 20328*D1**2*b1*f*fd*r*s + 10164*D1**2*b1*f*fd*r - 10164*D1**2*b1*f*fd*s**2 + 10164*D1**2*b1*f*fd*s - 5082*D1**2*b1*f*fd + 8250*D1**2*b1*f*fdd*r**2 + 16500*D1**2*b1*f*fdd*r*s - 8250*D1**2*b1*f*fdd*r + 8250*D1**2*b1*f*fdd*s**2 - 8250*D1**2*b1*f*fdd*s + 4125*D1**2*b1*f*fdd + 8250*D1**2*b1*fd**2*r**2 + 16500*D1**2*b1*fd**2*r*s - 8250*D1**2*b1*fd**2*r + 8250*D1**2*b1*fd**2*s**2 - 8250*D1**2*b1*fd**2*s - 825*D1**2*bdd1*f**2*(6*C - 5)*(r + s - 1)**2 - 13080*D1**2*f**2*fd*r**2 - 26160*D1**2*f**2*fd*r*s + 17440*D1**2*f**2*fd*r - 13080*D1**2*f**2*fd*s**2 + 17440*D1**2*f**2*fd*s - 8720*D1**2*f**2*fd + 10500*D1**2*f**2*fdd*r**2 + 21000*D1**2*f**2*fdd*r*s - 14000*D1**2*f**2*fdd*r + 10500*D1**2*f**2*fdd*s**2 - 14000*D1**2*f**2*fdd*s + 7000*D1**2*f**2*fdd + 21000*D1**2*f*fd**2*r**2 + 42000*D1**2*f*fd**2*r*s - 28000*D1**2*f*fd**2*r + 21000*D1**2*f*fd**2*s**2 - 28000*D1**2*f*fd**2*s + 7000*D1**2*f*fd**2 - 20328*D1*Dd*b1*f**2*r**2 - 40656*D1*Dd*b1*f**2*r*s + 30492*D1*Dd*b1*f**2*r - 20328*D1*Dd*b1*f**2*s**2 + 30492*D1*Dd*b1*f**2*s - 15246*D1*Dd*b1*f**2 + 66000*D1*Dd*b1*f*fd*r**2 + 132000*D1*Dd*b1*f*fd*r*s - 82500*D1*Dd*b1*f*fd*r + 66000*D1*Dd*b1*f*fd*s**2 - 82500*D1*Dd*b1*f*fd*s + 24750*D1*Dd*b1*f*fd - 17440*D1*Dd*f**3*r**2 - 34880*D1*Dd*f**3*r*s + 26160*D1*Dd*f**3*r - 17440*D1*Dd*f**3*s**2 + 26160*D1*Dd*f**3*s - 13080*D1*Dd*f**3 + 84000*D1*Dd*f**2*fd*r**2 + 168000*D1*Dd*f**2*fd*r*s - 119000*D1*Dd*f**2*fd*r + 84000*D1*Dd*f**2*fd*s**2 - 119000*D1*Dd*f**2*fd*s + 42000*D1*Dd*f**2*fd + 16500*D1*Ddd*b1*f**2*r**2 + 33000*D1*Ddd*b1*f**2*r*s - 24750*D1*Ddd*b1*f**2*r + 16500*D1*Ddd*b1*f**2*s**2 - 24750*D1*Ddd*b1*f**2*s + 12375*D1*Ddd*b1*f**2 + 14000*D1*Ddd*f**3*r**2 + 28000*D1*Ddd*f**3*r*s - 21000*D1*Ddd*f**3*r + 14000*D1*Ddd*f**3*s**2 - 21000*D1*Ddd*f**3*s + 10500*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(96*C - 77)*(r + s - 1) - D1*fd*(150*C - 125)*(2*r + 2*s - 1) - Dd*f*(150*C - 125)*(4*r + 4*s - 3)) + 49500*Dd**2*b1*f**2*r**2 + 99000*Dd**2*b1*f**2*r*s - 74250*Dd**2*b1*f**2*r + 49500*Dd**2*b1*f**2*s**2 - 74250*Dd**2*b1*f**2*s + 24750*Dd**2*b1*f**2 + 42000*Dd**2*f**3*r**2 + 84000*Dd**2*f**3*r*s - 63000*Dd**2*f**3*r + 42000*Dd**2*f**3*s**2 - 63000*Dd**2*f**3*s + 21000*Dd**2*f**3)/(77*d**2*k3**7) + 4*D1**2*Pk1*Pkd3*ct**6*k1**2*k2**2*(66*b1*(D1**2*(f*(fd*(76*C - 59) + fdd*(40 - 50*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(40 - 50*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(76*C - 59)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(40 - 50*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(40 - 50*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(40 - 50*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(856*C - 665)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 16)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(448 - 560*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 66*D1*bd1*(D1*(f*s*(76*C - 59)*(r + s - 1) - fd*(50*C - 40)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(40 - 50*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(856*C - 665)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(560*C - 448)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(448 - 560*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(448 - 560*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**6*k2**6*st**2*(15*C - 15)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 150*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 - 200*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 200*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 150*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3)/(77*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**6*k2**6*(-12870*C*D1**2*f**2*fd*r**2 - 25740*C*D1**2*f**2*fd*r*s + 17160*C*D1**2*f**2*fd*r - 12870*C*D1**2*f**2*fd*s**2 + 17160*C*D1**2*f**2*fd*s - 8580*C*D1**2*f**2*fd - 17160*C*D1*Dd*f**3*r**2 - 34320*C*D1*Dd*f**3*r*s + 25740*C*D1*Dd*f**3*r - 17160*C*D1*Dd*f**3*s**2 + 25740*C*D1*Dd*f**3*s - 12870*C*D1*Dd*f**3 - 2145*D1**2*K*bdd1*f**2*r**2 - 4290*D1**2*K*bdd1*f**2*r*s + 4290*D1**2*K*bdd1*f**2*r - 2145*D1**2*K*bdd1*f**2*s**2 + 4290*D1**2*K*bdd1*f**2*s - 2145*D1**2*K*bdd1*f**2 + 858*D1**2*bd1**2*f*(-6*K + 5*f + 6)*(r + s - 1)**2 - 7280*D1**2*bdd1*f**3*r**2 - 14560*D1**2*bdd1*f**3*r*s + 14560*D1**2*bdd1*f**3*r - 7280*D1**2*bdd1*f**3*s**2 + 14560*D1**2*bdd1*f**3*s - 7280*D1**2*bdd1*f**3 + 2145*D1**2*bdd1*f**2*r**2 + 4290*D1**2*bdd1*f**2*r*s - 4290*D1**2*bdd1*f**2*r + 2145*D1**2*bdd1*f**2*s**2 - 4290*D1**2*bdd1*f**2*s + 2145*D1**2*bdd1*f**2 + 5148*D1**2*bdd1*f*g2*r**2 + 10296*D1**2*bdd1*f*g2*r*s - 10296*D1**2*bdd1*f*g2*r + 5148*D1**2*bdd1*f*g2*s**2 - 10296*D1**2*bdd1*f*g2*s + 5148*D1**2*bdd1*f*g2 + 48440*D1**2*f**3*fd*r**2 + 96880*D1**2*f**3*fd*r*s - 72660*D1**2*f**3*fd*r + 48440*D1**2*f**3*fd*s**2 - 72660*D1**2*f**3*fd*s + 36330*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 + 12870*D1**2*f**2*fd*r**2 + 25740*D1**2*f**2*fd*r*s - 17160*D1**2*f**2*fd*r + 12870*D1**2*f**2*fd*s**2 - 17160*D1**2*f**2*fd*s + 8580*D1**2*f**2*fd - 8580*D1**2*f**2*gd2*r**2 - 17160*D1**2*f**2*gd2*r*s + 17160*D1**2*f**2*gd2*r - 8580*D1**2*f**2*gd2*s**2 + 17160*D1**2*f**2*gd2*s - 8580*D1**2*f**2*gd2 + 4290*D1**2*f**2*gdd2*r**2 + 8580*D1**2*f**2*gdd2*r*s - 8580*D1**2*f**2*gdd2*r + 4290*D1**2*f**2*gdd2*s**2 - 8580*D1**2*f**2*gdd2*s + 4290*D1**2*f**2*gdd2 - 17160*D1**2*f*fd*g2*r**2 - 34320*D1**2*f*fd*g2*r*s + 17160*D1**2*f*fd*g2*r - 17160*D1**2*f*fd*g2*s**2 + 17160*D1**2*f*fd*g2*s - 8580*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r**2 + 34320*D1**2*f*fd*gd2*r*s - 25740*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 25740*D1**2*f*fd*gd2*s + 8580*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r**2 + 17160*D1**2*f*fdd*g2*r*s - 8580*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r**2 + 17160*D1**2*fd**2*g2*r*s - 8580*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 48440*D1*Dd*f**4*r**2 + 96880*D1*Dd*f**4*r*s - 72660*D1*Dd*f**4*r + 48440*D1*Dd*f**4*s**2 - 72660*D1*Dd*f**4*s + 36330*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd + 17160*D1*Dd*f**3*r**2 + 34320*D1*Dd*f**3*r*s - 25740*D1*Dd*f**3*r + 17160*D1*Dd*f**3*s**2 - 25740*D1*Dd*f**3*s + 12870*D1*Dd*f**3 - 34320*D1*Dd*f**2*g2*r**2 - 68640*D1*Dd*f**2*g2*r*s + 51480*D1*Dd*f**2*g2*r - 34320*D1*Dd*f**2*g2*s**2 + 51480*D1*Dd*f**2*g2*s - 25740*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r**2 + 68640*D1*Dd*f**2*gd2*r*s - 60060*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 60060*D1*Dd*f**2*gd2*s + 25740*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r**2 + 137280*D1*Dd*f*fd*g2*r*s - 85800*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 85800*D1*Dd*f*fd*g2*s + 25740*D1*Dd*f*fd*g2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 17160*D1*Ddd*f**2*g2*r**2 + 34320*D1*Ddd*f**2*g2*r*s - 25740*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 25740*D1*Ddd*f**2*g2*s + 12870*D1*Ddd*f**2*g2 + 26*D1*bd1*(D1*(395*f**3*(r + s - 1) + f**2*(-198*C*(r + s - 1) - 560*fd*(3*r + 3*s - 2) + (165*K + 33)*(r + s - 1)) - 33*f*(5*fd*(K - 1)*(2*r + 2*s - 1) + (12*g2 - 12*gd2)*(r + s - 1)) + 396*fd*g2*(r + s)) - Dd*f*(560*f**2 + 165*f*(K - 1) - 396*g2)*(4*r + 4*s - 3))*(r + s - 1) - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 51480*Dd**2*f**2*g2*r**2 + 102960*Dd**2*f**2*g2*r*s - 77220*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 77220*Dd**2*f**2*g2*s + 25740*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(5*fd**2*(r + s - 1) + 6*fd*(K - 1)*(r + s) - 3*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (6*K - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-6*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-6*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 13*b1*(792*C*D1**2*f*fd*r**2 + 1584*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 792*C*D1**2*f*fd*s**2 - 792*C*D1**2*f*fd*s + 396*C*D1**2*f*fd + 1584*C*D1*Dd*f**2*r**2 + 3168*C*D1*Dd*f**2*r*s - 2376*C*D1*Dd*f**2*r + 1584*C*D1*Dd*f**2*s**2 - 2376*C*D1*Dd*f**2*s + 1188*C*D1*Dd*f**2 - 660*D1**2*K*f*fd*r**2 - 1320*D1**2*K*f*fd*r*s + 660*D1**2*K*f*fd*r - 660*D1**2*K*f*fd*s**2 + 660*D1**2*K*f*fd*s - 330*D1**2*K*f*fd + 330*D1**2*K*f*fdd*r**2 + 660*D1**2*K*f*fdd*r*s - 330*D1**2*K*f*fdd*r + 330*D1**2*K*f*fdd*s**2 - 330*D1**2*K*f*fdd*s + 165*D1**2*K*f*fdd + 330*D1**2*K*fd**2*r**2 + 660*D1**2*K*fd**2*r*s - 330*D1**2*K*fd**2*r + 330*D1**2*K*fd**2*s**2 - 330*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(-6*K + 5*f + 6)*(r + s - 1)**2 - 2370*D1**2*f**2*fd*r**2 - 4740*D1**2*f**2*fd*r*s + 3160*D1**2*f**2*fd*r - 2370*D1**2*f**2*fd*s**2 + 3160*D1**2*f**2*fd*s - 1580*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*r**2 + 3360*D1**2*f**2*fdd*r*s - 2240*D1**2*f**2*fdd*r + 1680*D1**2*f**2*fdd*s**2 - 2240*D1**2*f**2*fdd*s + 1120*D1**2*f**2*fdd + 3360*D1**2*f*fd**2*r**2 + 6720*D1**2*f*fd**2*r*s - 4480*D1**2*f*fd**2*r + 3360*D1**2*f*fd**2*s**2 - 4480*D1**2*f*fd**2*s + 1120*D1**2*f*fd**2 - 132*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r*s + 132*D1**2*f*fd*r - 132*D1**2*f*fd*s**2 + 132*D1**2*f*fd*s - 66*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 660*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r - 330*D1**2*f*fdd*s**2 + 330*D1**2*f*fdd*s - 165*D1**2*f*fdd + 792*D1**2*f*gd2*r**2 + 1584*D1**2*f*gd2*r*s - 1584*D1**2*f*gd2*r + 792*D1**2*f*gd2*s**2 - 1584*D1**2*f*gd2*s + 792*D1**2*f*gd2 - 396*D1**2*f*gdd2*r**2 - 792*D1**2*f*gdd2*r*s + 792*D1**2*f*gdd2*r - 396*D1**2*f*gdd2*s**2 + 792*D1**2*f*gdd2*s - 396*D1**2*f*gdd2 - 330*D1**2*fd**2*r**2 - 660*D1**2*fd**2*r*s + 330*D1**2*fd**2*r - 330*D1**2*fd**2*s**2 + 330*D1**2*fd**2*s + 792*D1**2*fd*g2*r**2 + 1584*D1**2*fd*g2*r*s + 792*D1**2*fd*g2*s**2 - 792*D1**2*fd*gd2*r**2 - 1584*D1**2*fd*gd2*r*s + 792*D1**2*fd*gd2*r - 792*D1**2*fd*gd2*s**2 + 792*D1**2*fd*gd2*s - 396*D1**2*fdd*g2*r**2 - 792*D1**2*fdd*g2*r*s - 396*D1**2*fdd*g2*s**2 - 1320*D1*Dd*K*f**2*r**2 - 2640*D1*Dd*K*f**2*r*s + 1980*D1*Dd*K*f**2*r - 1320*D1*Dd*K*f**2*s**2 + 1980*D1*Dd*K*f**2*s - 990*D1*Dd*K*f**2 + 2640*D1*Dd*K*f*fd*r**2 + 5280*D1*Dd*K*f*fd*r*s - 3300*D1*Dd*K*f*fd*r + 2640*D1*Dd*K*f*fd*s**2 - 3300*D1*Dd*K*f*fd*s + 990*D1*Dd*K*f*fd - 3160*D1*Dd*f**3*r**2 - 6320*D1*Dd*f**3*r*s + 4740*D1*Dd*f**3*r - 3160*D1*Dd*f**3*s**2 + 4740*D1*Dd*f**3*s - 2370*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*r**2 + 26880*D1*Dd*f**2*fd*r*s - 19040*D1*Dd*f**2*fd*r + 13440*D1*Dd*f**2*fd*s**2 - 19040*D1*Dd*f**2*fd*s + 6720*D1*Dd*f**2*fd - 264*D1*Dd*f**2*r**2 - 528*D1*Dd*f**2*r*s + 396*D1*Dd*f**2*r - 264*D1*Dd*f**2*s**2 + 396*D1*Dd*f**2*s - 198*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 5280*D1*Dd*f*fd*r*s + 3300*D1*Dd*f*fd*r - 2640*D1*Dd*f*fd*s**2 + 3300*D1*Dd*f*fd*s - 990*D1*Dd*f*fd + 3168*D1*Dd*f*g2*r**2 + 6336*D1*Dd*f*g2*r*s - 4752*D1*Dd*f*g2*r + 3168*D1*Dd*f*g2*s**2 - 4752*D1*Dd*f*g2*s + 2376*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 6336*D1*Dd*f*gd2*r*s + 5544*D1*Dd*f*gd2*r - 3168*D1*Dd*f*gd2*s**2 + 5544*D1*Dd*f*gd2*s - 2376*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 6336*D1*Dd*fd*g2*r*s + 2376*D1*Dd*fd*g2*r - 3168*D1*Dd*fd*g2*s**2 + 2376*D1*Dd*fd*g2*s + 660*D1*Ddd*K*f**2*r**2 + 1320*D1*Ddd*K*f**2*r*s - 990*D1*Ddd*K*f**2*r + 660*D1*Ddd*K*f**2*s**2 - 990*D1*Ddd*K*f**2*s + 495*D1*Ddd*K*f**2 + 2240*D1*Ddd*f**3*r**2 + 4480*D1*Ddd*f**3*r*s - 3360*D1*Ddd*f**3*r + 2240*D1*Ddd*f**3*s**2 - 3360*D1*Ddd*f**3*s + 1680*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 - 1320*D1*Ddd*f**2*r*s + 990*D1*Ddd*f**2*r - 660*D1*Ddd*f**2*s**2 + 990*D1*Ddd*f**2*s - 495*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 3168*D1*Ddd*f*g2*r*s + 2376*D1*Ddd*f*g2*r - 1584*D1*Ddd*f*g2*s**2 + 2376*D1*Ddd*f*g2*s - 1188*D1*Ddd*f*g2 + 132*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 6*f*(K - 1)*(r + s - 1) + 6*fd*(K - 1)*(r + s)) - Dd*f*(-6*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 1980*Dd**2*K*f**2*r**2 + 3960*Dd**2*K*f**2*r*s - 2970*Dd**2*K*f**2*r + 1980*Dd**2*K*f**2*s**2 - 2970*Dd**2*K*f**2*s + 990*Dd**2*K*f**2 + 6720*Dd**2*f**3*r**2 + 13440*Dd**2*f**3*r*s - 10080*Dd**2*f**3*r + 6720*Dd**2*f**3*s**2 - 10080*Dd**2*f**3*s + 3360*Dd**2*f**3 - 1980*Dd**2*f**2*r**2 - 3960*Dd**2*f**2*r*s + 2970*Dd**2*f**2*r - 1980*Dd**2*f**2*s**2 + 2970*Dd**2*f**2*s - 990*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 9504*Dd**2*f*g2*r*s + 7128*Dd**2*f*g2*r - 4752*Dd**2*f*g2*s**2 + 7128*Dd**2*f*g2*s - 2376*Dd**2*f*g2))/(1001*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**6*k2**4*st**2*(20*C - 20)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 50*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 25*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 25*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**6*k2**4*(1980*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-424*C*D1**2*f*fd*r**2 - 752*C*D1**2*f*fd*r*s + 176*C*D1**2*f*fd*r - 328*C*D1**2*f*fd*s**2 + 128*C*D1**2*f*fd*s - 64*C*D1**2*f*fd + 200*C*D1**2*f*fdd*r**2 + 496*C*D1**2*f*fdd*r*s - 148*C*D1**2*f*fdd*r + 296*C*D1**2*f*fdd*s**2 - 196*C*D1**2*f*fdd*s + 98*C*D1**2*f*fdd + 200*C*D1**2*fd**2*r**2 + 496*C*D1**2*fd**2*r*s - 148*C*D1**2*fd**2*r + 296*C*D1**2*fd**2*s**2 - 196*C*D1**2*fd**2*s - 100*C*D1**2*fd**2 - 848*C*D1*Dd*f**2*r**2 - 1504*C*D1*Dd*f**2*r*s + 1176*C*D1*Dd*f**2*r - 656*C*D1*Dd*f**2*s**2 + 1032*C*D1*Dd*f**2*s - 540*C*D1*Dd*f**2 + 1600*C*D1*Dd*f*fd*r**2 + 3968*C*D1*Dd*f*fd*r*s - 1984*C*D1*Dd*f*fd*r + 2368*C*D1*Dd*f*fd*s**2 - 2464*C*D1*Dd*f*fd*s + 540*C*D1*Dd*f*fd + 400*C*D1*Ddd*f**2*r**2 + 992*C*D1*Ddd*f**2*r*s - 696*C*D1*Ddd*f**2*r + 592*C*D1*Ddd*f**2*s**2 - 840*C*D1*Ddd*f**2*s + 396*C*D1*Ddd*f**2 + 1200*C*Dd**2*f**2*r**2 + 2976*C*Dd**2*f**2*r*s - 2088*C*Dd**2*f**2*r + 1776*C*Dd**2*f**2*s**2 - 2520*C*Dd**2*f**2*s + 792*C*Dd**2*f**2 - 60*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 564*D1**2*f*fd*r**2 + 1072*D1**2*f*fd*r*s - 336*D1**2*f*fd*r + 508*D1**2*f*fd*s**2 - 308*D1**2*f*fd*s + 154*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 776*D1**2*f*fdd*r*s + 288*D1**2*f*fdd*r - 446*D1**2*f*fdd*s**2 + 346*D1**2*f*fdd*s - 173*D1**2*f*fdd - 330*D1**2*fd**2*r**2 - 776*D1**2*fd**2*r*s + 288*D1**2*fd**2*r - 446*D1**2*fd**2*s**2 + 346*D1**2*fd**2*s + 100*D1**2*fd**2 + 1128*D1*Dd*f**2*r**2 + 2144*D1*Dd*f**2*r*s - 1636*D1*Dd*f**2*r + 1016*D1*Dd*f**2*s**2 - 1552*D1*Dd*f**2*s + 790*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 6208*D1*Dd*f*fd*r*s + 3364*D1*Dd*f*fd*r - 3568*D1*Dd*f*fd*s**2 + 3944*D1*Dd*f*fd*s - 980*D1*Dd*f*fd - 660*D1*Ddd*f**2*r**2 - 1552*D1*Ddd*f**2*r*s + 1106*D1*Ddd*f**2*r - 892*D1*Ddd*f**2*s**2 + 1280*D1*Ddd*f**2*s - 611*D1*Ddd*f**2 + 120*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 1980*Dd**2*f**2*r**2 - 4656*Dd**2*f**2*r*s + 3318*Dd**2*f**2*r - 2676*Dd**2*f**2*s**2 + 3840*Dd**2*f**2*s - 1222*Dd**2*f**2) + f*(-3960*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(2*C*(50*r**2 + 2*r*(62*s - 75) + 74*s**2 - 174*s + 75) - 165*r**2 + r*(430 - 388*s) - 223*s**2 + 488*s - 215) - 10*D1**2*(f*(fd*(C*(3201*r**2 + 6*r*(901*s - 656) + 2205*s**2 - 3272*s + 1802) - 3738*r**2 + r*(4728 - 6708*s) - 2970*s**2 + 4216*s - 2236) + fdd*(-C*(1551*r**2 + 6*r*(533*s - 350) + 1647*s**2 - 2164*s + 1066) + 2067*r**2 + 6*r*(724*s - 471) + 2277*s**2 - 2966*s + 1448)) + 2*fd**2*(-C*(1551*r**2 + 6*r*(533*s - 350) + 1647*s**2 - 2164*s + 533) + 2067*r**2 + 6*r*(724*s - 471) + 2277*s**2 - 2966*s + 724)) - 66*D1*bd1*(D1*(f*(2*C*(53*r**2 + 94*r*s - 156*r + 41*s**2 - 144*s + 78) - 141*r**2 - 268*r*s + 382*r - 127*s**2 + 368*s - 191) + fd*(-2*C*(100*r**2 + 248*r*s - 187*r + 148*s**2 - 223*s + 87) + 330*r**2 + 776*r*s - 574*r + 446*s**2 - 661*s + 244)) + Dd*f*(-2*C*(200*r**2 + 496*r*s - 474*r + 296*s**2 - 558*s + 249) + 660*r**2 + 1552*r*s - 1413*r + 892*s**2 - 1616*s + 703)) - 10*D1*f*(Dd*(f*(C*(4268*r**2 + 7208*r*s - 5738*r + 2940*s**2 - 4742*s + 2537) - 4984*r**2 - 8944*r*s + 6964*r - 3960*s**2 + 6196*s - 3226) - 2*fd*(C*(6204*r**2 + 12792*r*s - 8949*r + 6588*s**2 - 9221*s + 3214) - 8268*r**2 - 17376*r*s + 12063*r - 9108*s**2 + 12658*s - 4379)) + Ddd*f*(-C*(2068*r**2 + 4264*r*s - 3166*r + 2196*s**2 - 3262*s + 1615) + 2756*r**2 + 5792*r*s - 4274*r + 3036*s**2 - 4484*s + 2207)) + 20*Dd**2*f**2*(C*(3102*r**2 + r*(6396*s - 4749) + 3294*s**2 - 4893*s + 1615) - 4134*r**2 + r*(6411 - 8688*s) - 4554*s**2 + 6726*s - 2207)))/(693*d**2*k3**5) + 4*D1**2*Pk1*Pkd3*ct**6*k2**2*(396*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 66*b1*(D1**2*(f*(-6*bdd1*s*(C - 1)*(2*r + 2*s - 1) + fd*(7*r*(2*s - 1) + 14*s**2 - s*(10*C + 4) + 7) + 5*fdd*(C*s - 2*r*s + r - 2*s**2 + s - 1)) + 5*fd**2*(C*(s - 1) - 2*r*s + r - 2*s**2 + s + 1)) - 6*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(7*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 5*fd*(2*s - 1)*(2*C - 8*r - 8*s + 3)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) - f*(396*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + 5*D1**2*(f*(66*bdd1*s*(C + r + s - 2) + fd*(112*C - 191)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(56*C - 112)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(112 - 56*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 66*D1*bd1*(D1*(f*s*(10*C + 7*r + 7*s - 17) - 5*fd*(C*(s - 1) + 4*r*s - r + 4*s**2 - 5*s + 2)) - 5*Dd*f*(C*(4*s - 2) + 8*r*s - 2*r + 8*s**2 - 13*s + 4)) + 5*D1*f*(Dd*(f*(112*C - 191)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(56*C - 112)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(112 - 56*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(112 - 56*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**3) - 2*D1**2*Pk1*Pkd3*ct**6*k2**4*(44*D1**2*b1*f*fd*r**2 + 44*D1**2*b1*f*fd*r*s - 22*D1**2*b1*f*fd*r + 110*D1**2*b1*f*fdd*r**2 + 110*D1**2*b1*f*fdd*r*s - 55*D1**2*b1*f*fdd*r + 110*D1**2*b1*fd**2*r**2 + 110*D1**2*b1*fd**2*r*s - 55*D1**2*b1*fd**2*r + 55*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 150*D1**2*f**2*fd*r**2 + 150*D1**2*f**2*fd*r*s - 150*D1**2*f**2*fd*r - 50*D1**2*f**2*fd*s + 50*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r**2 + 90*D1**2*f**2*fdd*r*s - 90*D1**2*f**2*fdd*r - 30*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r**2 + 180*D1**2*f*fd**2*r*s - 180*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s + 30*D1**2*f*fd**2 + 88*D1*Dd*b1*f**2*r**2 + 88*D1*Dd*b1*f**2*r*s - 88*D1*Dd*b1*f**2*r - 22*D1*Dd*b1*f**2*s + 22*D1*Dd*b1*f**2 + 880*D1*Dd*b1*f*fd*r**2 + 880*D1*Dd*b1*f*fd*r*s - 660*D1*Dd*b1*f*fd*r - 110*D1*Dd*b1*f*fd*s + 55*D1*Dd*b1*f*fd + 200*D1*Dd*f**3*r**2 + 200*D1*Dd*f**3*r*s - 200*D1*Dd*f**3*r - 50*D1*Dd*f**3*s + 50*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r**2 + 720*D1*Dd*f**2*fd*r*s - 720*D1*Dd*f**2*fd*r - 210*D1*Dd*f**2*fd*s + 150*D1*Dd*f**2*fd + 220*D1*Ddd*b1*f**2*r**2 + 220*D1*Ddd*b1*f**2*r*s - 220*D1*Ddd*b1*f**2*r - 55*D1*Ddd*b1*f**2*s + 55*D1*Ddd*b1*f**2 + 120*D1*Ddd*f**3*r**2 + 120*D1*Ddd*f**3*r*s - 120*D1*Ddd*f**3*r - 30*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + 11*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 660*Dd**2*b1*f**2*r**2 + 660*Dd**2*b1*f**2*r*s - 660*Dd**2*b1*f**2*r - 165*Dd**2*b1*f**2*s + 110*Dd**2*b1*f**2 + 360*Dd**2*f**3*r**2 + 360*Dd**2*f**3*r*s - 360*Dd**2*f**3*r - 90*Dd**2*f**3*s + 60*Dd**2*f**3)/(231*d**2*k1**2*k3**3) + 15*D1**2*Pk1*Pkd3*ct**5*f*k2**7*st**2*(390*D1**2*b1*f*fd*r**2 + 780*D1**2*b1*f*fd*r*s - 520*D1**2*b1*f*fd*r + 390*D1**2*b1*f*fd*s**2 - 520*D1**2*b1*f*fd*s + 260*D1**2*b1*f*fd - 195*D1**2*b1*f*fdd*r**2 - 390*D1**2*b1*f*fdd*r*s + 260*D1**2*b1*f*fdd*r - 195*D1**2*b1*f*fdd*s**2 + 260*D1**2*b1*f*fdd*s - 130*D1**2*b1*f*fdd - 390*D1**2*b1*fd**2*r**2 - 780*D1**2*b1*fd**2*r*s + 520*D1**2*b1*fd**2*r - 390*D1**2*b1*fd**2*s**2 + 520*D1**2*b1*fd**2*s - 130*D1**2*b1*fd**2 - 65*D1**2*bdd1*f**2*(r + s - 1)**2 + 392*D1**2*f**2*fd*r**2 + 784*D1**2*f**2*fd*r*s - 588*D1**2*f**2*fd*r + 392*D1**2*f**2*fd*s**2 - 588*D1**2*f**2*fd*s + 294*D1**2*f**2*fd - 196*D1**2*f**2*fdd*r**2 - 392*D1**2*f**2*fdd*r*s + 294*D1**2*f**2*fdd*r - 196*D1**2*f**2*fdd*s**2 + 294*D1**2*f**2*fdd*s - 147*D1**2*f**2*fdd - 588*D1**2*f*fd**2*r**2 - 1176*D1**2*f*fd**2*r*s + 882*D1**2*f*fd**2*r - 588*D1**2*f*fd**2*s**2 + 882*D1**2*f*fd**2*s - 294*D1**2*f*fd**2 + 520*D1*Dd*b1*f**2*r**2 + 1040*D1*Dd*b1*f**2*r*s - 780*D1*Dd*b1*f**2*r + 520*D1*Dd*b1*f**2*s**2 - 780*D1*Dd*b1*f**2*s + 390*D1*Dd*b1*f**2 - 1560*D1*Dd*b1*f*fd*r**2 - 3120*D1*Dd*b1*f*fd*r*s + 2210*D1*Dd*b1*f*fd*r - 1560*D1*Dd*b1*f*fd*s**2 + 2210*D1*Dd*b1*f*fd*s - 780*D1*Dd*b1*f*fd + 392*D1*Dd*f**3*r**2 + 784*D1*Dd*f**3*r*s - 588*D1*Dd*f**3*r + 392*D1*Dd*f**3*s**2 - 588*D1*Dd*f**3*s + 294*D1*Dd*f**3 - 1568*D1*Dd*f**2*fd*r**2 - 3136*D1*Dd*f**2*fd*r*s + 2352*D1*Dd*f**2*fd*r - 1568*D1*Dd*f**2*fd*s**2 + 2352*D1*Dd*f**2*fd*s - 882*D1*Dd*f**2*fd - 260*D1*Ddd*b1*f**2*r**2 - 520*D1*Ddd*b1*f**2*r*s + 390*D1*Ddd*b1*f**2*r - 260*D1*Ddd*b1*f**2*s**2 + 390*D1*Ddd*b1*f**2*s - 195*D1*Ddd*b1*f**2 - 196*D1*Ddd*f**3*r**2 - 392*D1*Ddd*f**3*r*s + 294*D1*Ddd*f**3*r - 196*D1*Ddd*f**3*s**2 + 294*D1*Ddd*f**3*s - 147*D1*Ddd*f**3 + 130*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 780*Dd**2*b1*f**2*r**2 - 1560*Dd**2*b1*f**2*r*s + 1170*Dd**2*b1*f**2*r - 780*Dd**2*b1*f**2*s**2 + 1170*Dd**2*b1*f**2*s - 390*Dd**2*b1*f**2 - 588*Dd**2*f**3*r**2 - 1176*Dd**2*f**3*r*s + 882*Dd**2*f**3*r - 588*Dd**2*f**3*s**2 + 882*Dd**2*f**3*s - 294*Dd**2*f**3)/(286*d**2*k1*k3**7) + D1**2*Pk1*Pkd3*ct**5*k1**3*k2**3*(13728*C*D1**2*b1*f*fd*r**2 + 27456*C*D1**2*b1*f*fd*r*s - 13728*C*D1**2*b1*f*fd*r + 13728*C*D1**2*b1*f*fd*s**2 - 13728*C*D1**2*b1*f*fd*s + 6864*C*D1**2*b1*f*fd - 13200*C*D1**2*b1*f*fdd*r**2 - 26400*C*D1**2*b1*f*fdd*r*s + 13200*C*D1**2*b1*f*fdd*r - 13200*C*D1**2*b1*f*fdd*s**2 + 13200*C*D1**2*b1*f*fdd*s - 6600*C*D1**2*b1*f*fdd - 13200*C*D1**2*b1*fd**2*r**2 - 26400*C*D1**2*b1*fd**2*r*s + 13200*C*D1**2*b1*fd**2*r - 13200*C*D1**2*b1*fd**2*s**2 + 13200*C*D1**2*b1*fd**2*s + 17760*C*D1**2*f**2*fd*r**2 + 35520*C*D1**2*f**2*fd*r*s - 23680*C*D1**2*f**2*fd*r + 17760*C*D1**2*f**2*fd*s**2 - 23680*C*D1**2*f**2*fd*s + 11840*C*D1**2*f**2*fd - 16800*C*D1**2*f**2*fdd*r**2 - 33600*C*D1**2*f**2*fdd*r*s + 22400*C*D1**2*f**2*fdd*r - 16800*C*D1**2*f**2*fdd*s**2 + 22400*C*D1**2*f**2*fdd*s - 11200*C*D1**2*f**2*fdd - 33600*C*D1**2*f*fd**2*r**2 - 67200*C*D1**2*f*fd**2*r*s + 44800*C*D1**2*f*fd**2*r - 33600*C*D1**2*f*fd**2*s**2 + 44800*C*D1**2*f*fd**2*s - 11200*C*D1**2*f*fd**2 + 27456*C*D1*Dd*b1*f**2*r**2 + 54912*C*D1*Dd*b1*f**2*r*s - 41184*C*D1*Dd*b1*f**2*r + 27456*C*D1*Dd*b1*f**2*s**2 - 41184*C*D1*Dd*b1*f**2*s + 20592*C*D1*Dd*b1*f**2 - 105600*C*D1*Dd*b1*f*fd*r**2 - 211200*C*D1*Dd*b1*f*fd*r*s + 132000*C*D1*Dd*b1*f*fd*r - 105600*C*D1*Dd*b1*f*fd*s**2 + 132000*C*D1*Dd*b1*f*fd*s - 39600*C*D1*Dd*b1*f*fd + 23680*C*D1*Dd*f**3*r**2 + 47360*C*D1*Dd*f**3*r*s - 35520*C*D1*Dd*f**3*r + 23680*C*D1*Dd*f**3*s**2 - 35520*C*D1*Dd*f**3*s + 17760*C*D1*Dd*f**3 - 134400*C*D1*Dd*f**2*fd*r**2 - 268800*C*D1*Dd*f**2*fd*r*s + 190400*C*D1*Dd*f**2*fd*r - 134400*C*D1*Dd*f**2*fd*s**2 + 190400*C*D1*Dd*f**2*fd*s - 67200*C*D1*Dd*f**2*fd - 26400*C*D1*Ddd*b1*f**2*r**2 - 52800*C*D1*Ddd*b1*f**2*r*s + 39600*C*D1*Ddd*b1*f**2*r - 26400*C*D1*Ddd*b1*f**2*s**2 + 39600*C*D1*Ddd*b1*f**2*s - 19800*C*D1*Ddd*b1*f**2 - 22400*C*D1*Ddd*f**3*r**2 - 44800*C*D1*Ddd*f**3*r*s + 33600*C*D1*Ddd*f**3*r - 22400*C*D1*Ddd*f**3*s**2 + 33600*C*D1*Ddd*f**3*s - 16800*C*D1*Ddd*f**3 - 79200*C*Dd**2*b1*f**2*r**2 - 158400*C*Dd**2*b1*f**2*r*s + 118800*C*Dd**2*b1*f**2*r - 79200*C*Dd**2*b1*f**2*s**2 + 118800*C*Dd**2*b1*f**2*s - 39600*C*Dd**2*b1*f**2 - 67200*C*Dd**2*f**3*r**2 - 134400*C*Dd**2*f**3*r*s + 100800*C*Dd**2*f**3*r - 67200*C*Dd**2*f**3*s**2 + 100800*C*Dd**2*f**3*s - 33600*C*Dd**2*f**3 - 9900*D1**2*b1*f*fd*r**2 - 19800*D1**2*b1*f*fd*r*s + 9900*D1**2*b1*f*fd*r - 9900*D1**2*b1*f*fd*s**2 + 9900*D1**2*b1*f*fd*s - 4950*D1**2*b1*f*fd + 9900*D1**2*b1*f*fdd*r**2 + 19800*D1**2*b1*f*fdd*r*s - 9900*D1**2*b1*f*fdd*r + 9900*D1**2*b1*f*fdd*s**2 - 9900*D1**2*b1*f*fdd*s + 4950*D1**2*b1*f*fdd + 9900*D1**2*b1*fd**2*r**2 + 19800*D1**2*b1*fd**2*r*s - 9900*D1**2*b1*fd**2*r + 9900*D1**2*b1*fd**2*s**2 - 9900*D1**2*b1*fd**2*s - 1650*D1**2*bdd1*f**2*(4*C - 3)*(r + s - 1)**2 - 12825*D1**2*f**2*fd*r**2 - 25650*D1**2*f**2*fd*r*s + 17100*D1**2*f**2*fd*r - 12825*D1**2*f**2*fd*s**2 + 17100*D1**2*f**2*fd*s - 8550*D1**2*f**2*fd + 12600*D1**2*f**2*fdd*r**2 + 25200*D1**2*f**2*fdd*r*s - 16800*D1**2*f**2*fdd*r + 12600*D1**2*f**2*fdd*s**2 - 16800*D1**2*f**2*fdd*s + 8400*D1**2*f**2*fdd + 25200*D1**2*f*fd**2*r**2 + 50400*D1**2*f*fd**2*r*s - 33600*D1**2*f*fd**2*r + 25200*D1**2*f*fd**2*s**2 - 33600*D1**2*f*fd**2*s + 8400*D1**2*f*fd**2 - 19800*D1*Dd*b1*f**2*r**2 - 39600*D1*Dd*b1*f**2*r*s + 29700*D1*Dd*b1*f**2*r - 19800*D1*Dd*b1*f**2*s**2 + 29700*D1*Dd*b1*f**2*s - 14850*D1*Dd*b1*f**2 + 79200*D1*Dd*b1*f*fd*r**2 + 158400*D1*Dd*b1*f*fd*r*s - 99000*D1*Dd*b1*f*fd*r + 79200*D1*Dd*b1*f*fd*s**2 - 99000*D1*Dd*b1*f*fd*s + 29700*D1*Dd*b1*f*fd - 17100*D1*Dd*f**3*r**2 - 34200*D1*Dd*f**3*r*s + 25650*D1*Dd*f**3*r - 17100*D1*Dd*f**3*s**2 + 25650*D1*Dd*f**3*s - 12825*D1*Dd*f**3 + 100800*D1*Dd*f**2*fd*r**2 + 201600*D1*Dd*f**2*fd*r*s - 142800*D1*Dd*f**2*fd*r + 100800*D1*Dd*f**2*fd*s**2 - 142800*D1*Dd*f**2*fd*s + 50400*D1*Dd*f**2*fd + 19800*D1*Ddd*b1*f**2*r**2 + 39600*D1*Ddd*b1*f**2*r*s - 29700*D1*Ddd*b1*f**2*r + 19800*D1*Ddd*b1*f**2*s**2 - 29700*D1*Ddd*b1*f**2*s + 14850*D1*Ddd*b1*f**2 + 16800*D1*Ddd*f**3*r**2 + 33600*D1*Ddd*f**3*r*s - 25200*D1*Ddd*f**3*r + 16800*D1*Ddd*f**3*s**2 - 25200*D1*Ddd*f**3*s + 12600*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(104*C - 75)*(r + s - 1) - D1*fd*(200*C - 150)*(2*r + 2*s - 1) - Dd*f*(200*C - 150)*(4*r + 4*s - 3)) + 59400*Dd**2*b1*f**2*r**2 + 118800*Dd**2*b1*f**2*r*s - 89100*Dd**2*b1*f**2*r + 59400*Dd**2*b1*f**2*s**2 - 89100*Dd**2*b1*f**2*s + 29700*Dd**2*b1*f**2 + 50400*Dd**2*f**3*r**2 + 100800*Dd**2*f**3*r*s - 75600*Dd**2*f**3*r + 50400*Dd**2*f**3*s**2 - 75600*Dd**2*f**3*s + 25200*Dd**2*f**3)/(77*d**2*k3**7) + 4*D1**2*Pk1*Pkd3*ct**5*k1**3*k2*(66*b1*(D1**2*(f*(fd*(64*C - 43) + fdd*(35 - 50*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(35 - 50*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(64*C - 43)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(35 - 50*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(35 - 50*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(35 - 50*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(724*C - 487)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (20*C - 14)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(392 - 560*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 66*D1*bd1*(D1*(f*s*(64*C - 43)*(r + s - 1) - fd*(50*C - 35)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(35 - 50*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(724*C - 487)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(560*C - 392)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(392 - 560*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(392 - 560*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**5*k1*k2**5*st**2*(16896*C*D1**2*b1*f*fd*r**2 + 33792*C*D1**2*b1*f*fd*r*s - 16896*C*D1**2*b1*f*fd*r + 16896*C*D1**2*b1*f*fd*s**2 - 16896*C*D1**2*b1*f*fd*s + 8448*C*D1**2*b1*f*fd - 9240*C*D1**2*b1*f*fdd*r**2 - 18480*C*D1**2*b1*f*fdd*r*s + 9240*C*D1**2*b1*f*fdd*r - 9240*C*D1**2*b1*f*fdd*s**2 + 9240*C*D1**2*b1*f*fdd*s - 4620*C*D1**2*b1*f*fdd - 9240*C*D1**2*b1*fd**2*r**2 - 18480*C*D1**2*b1*fd**2*r*s + 9240*C*D1**2*b1*fd**2*r - 9240*C*D1**2*b1*fd**2*s**2 + 9240*C*D1**2*b1*fd**2*s + 18624*C*D1**2*f**2*fd*r**2 + 37248*C*D1**2*f**2*fd*r*s - 24832*C*D1**2*f**2*fd*r + 18624*C*D1**2*f**2*fd*s**2 - 24832*C*D1**2*f**2*fd*s + 12416*C*D1**2*f**2*fd - 10500*C*D1**2*f**2*fdd*r**2 - 21000*C*D1**2*f**2*fdd*r*s + 14000*C*D1**2*f**2*fdd*r - 10500*C*D1**2*f**2*fdd*s**2 + 14000*C*D1**2*f**2*fdd*s - 7000*C*D1**2*f**2*fdd - 21000*C*D1**2*f*fd**2*r**2 - 42000*C*D1**2*f*fd**2*r*s + 28000*C*D1**2*f*fd**2*r - 21000*C*D1**2*f*fd**2*s**2 + 28000*C*D1**2*f*fd**2*s - 7000*C*D1**2*f*fd**2 + 33792*C*D1*Dd*b1*f**2*r**2 + 67584*C*D1*Dd*b1*f**2*r*s - 50688*C*D1*Dd*b1*f**2*r + 33792*C*D1*Dd*b1*f**2*s**2 - 50688*C*D1*Dd*b1*f**2*s + 25344*C*D1*Dd*b1*f**2 - 73920*C*D1*Dd*b1*f*fd*r**2 - 147840*C*D1*Dd*b1*f*fd*r*s + 92400*C*D1*Dd*b1*f*fd*r - 73920*C*D1*Dd*b1*f*fd*s**2 + 92400*C*D1*Dd*b1*f*fd*s - 27720*C*D1*Dd*b1*f*fd + 24832*C*D1*Dd*f**3*r**2 + 49664*C*D1*Dd*f**3*r*s - 37248*C*D1*Dd*f**3*r + 24832*C*D1*Dd*f**3*s**2 - 37248*C*D1*Dd*f**3*s + 18624*C*D1*Dd*f**3 - 84000*C*D1*Dd*f**2*fd*r**2 - 168000*C*D1*Dd*f**2*fd*r*s + 119000*C*D1*Dd*f**2*fd*r - 84000*C*D1*Dd*f**2*fd*s**2 + 119000*C*D1*Dd*f**2*fd*s - 42000*C*D1*Dd*f**2*fd - 18480*C*D1*Ddd*b1*f**2*r**2 - 36960*C*D1*Ddd*b1*f**2*r*s + 27720*C*D1*Ddd*b1*f**2*r - 18480*C*D1*Ddd*b1*f**2*s**2 + 27720*C*D1*Ddd*b1*f**2*s - 13860*C*D1*Ddd*b1*f**2 - 14000*C*D1*Ddd*f**3*r**2 - 28000*C*D1*Ddd*f**3*r*s + 21000*C*D1*Ddd*f**3*r - 14000*C*D1*Ddd*f**3*s**2 + 21000*C*D1*Ddd*f**3*s - 10500*C*D1*Ddd*f**3 - 55440*C*Dd**2*b1*f**2*r**2 - 110880*C*Dd**2*b1*f**2*r*s + 83160*C*Dd**2*b1*f**2*r - 55440*C*Dd**2*b1*f**2*s**2 + 83160*C*Dd**2*b1*f**2*s - 27720*C*Dd**2*b1*f**2 - 42000*C*Dd**2*f**3*r**2 - 84000*C*Dd**2*f**3*r*s + 63000*C*Dd**2*f**3*r - 42000*C*Dd**2*f**3*s**2 + 63000*C*Dd**2*f**3*s - 21000*C*Dd**2*f**3 - 14916*D1**2*b1*f*fd*r**2 - 29832*D1**2*b1*f*fd*r*s + 14916*D1**2*b1*f*fd*r - 14916*D1**2*b1*f*fd*s**2 + 14916*D1**2*b1*f*fd*s - 7458*D1**2*b1*f*fd + 8250*D1**2*b1*f*fdd*r**2 + 16500*D1**2*b1*f*fdd*r*s - 8250*D1**2*b1*f*fdd*r + 8250*D1**2*b1*f*fdd*s**2 - 8250*D1**2*b1*f*fdd*s + 4125*D1**2*b1*f*fdd + 8250*D1**2*b1*fd**2*r**2 + 16500*D1**2*b1*fd**2*r*s - 8250*D1**2*b1*fd**2*r + 8250*D1**2*b1*fd**2*s**2 - 8250*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(28*C - 25)*(r + s - 1)**2 - 16374*D1**2*f**2*fd*r**2 - 32748*D1**2*f**2*fd*r*s + 21832*D1**2*f**2*fd*r - 16374*D1**2*f**2*fd*s**2 + 21832*D1**2*f**2*fd*s - 10916*D1**2*f**2*fd + 9375*D1**2*f**2*fdd*r**2 + 18750*D1**2*f**2*fdd*r*s - 12500*D1**2*f**2*fdd*r + 9375*D1**2*f**2*fdd*s**2 - 12500*D1**2*f**2*fdd*s + 6250*D1**2*f**2*fdd + 18750*D1**2*f*fd**2*r**2 + 37500*D1**2*f*fd**2*r*s - 25000*D1**2*f*fd**2*r + 18750*D1**2*f*fd**2*s**2 - 25000*D1**2*f*fd**2*s + 6250*D1**2*f*fd**2 - 29832*D1*Dd*b1*f**2*r**2 - 59664*D1*Dd*b1*f**2*r*s + 44748*D1*Dd*b1*f**2*r - 29832*D1*Dd*b1*f**2*s**2 + 44748*D1*Dd*b1*f**2*s - 22374*D1*Dd*b1*f**2 + 66000*D1*Dd*b1*f*fd*r**2 + 132000*D1*Dd*b1*f*fd*r*s - 82500*D1*Dd*b1*f*fd*r + 66000*D1*Dd*b1*f*fd*s**2 - 82500*D1*Dd*b1*f*fd*s + 24750*D1*Dd*b1*f*fd - 21832*D1*Dd*f**3*r**2 - 43664*D1*Dd*f**3*r*s + 32748*D1*Dd*f**3*r - 21832*D1*Dd*f**3*s**2 + 32748*D1*Dd*f**3*s - 16374*D1*Dd*f**3 + 75000*D1*Dd*f**2*fd*r**2 + 150000*D1*Dd*f**2*fd*r*s - 106250*D1*Dd*f**2*fd*r + 75000*D1*Dd*f**2*fd*s**2 - 106250*D1*Dd*f**2*fd*s + 37500*D1*Dd*f**2*fd + 16500*D1*Ddd*b1*f**2*r**2 + 33000*D1*Ddd*b1*f**2*r*s - 24750*D1*Ddd*b1*f**2*r + 16500*D1*Ddd*b1*f**2*s**2 - 24750*D1*Ddd*b1*f**2*s + 12375*D1*Ddd*b1*f**2 + 12500*D1*Ddd*f**3*r**2 + 25000*D1*Ddd*f**3*r*s - 18750*D1*Ddd*f**3*r + 12500*D1*Ddd*f**3*s**2 - 18750*D1*Ddd*f**3*s + 9375*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(128*C - 113)*(r + s - 1) - D1*fd*(140*C - 125)*(2*r + 2*s - 1) - Dd*f*(140*C - 125)*(4*r + 4*s - 3)) + 49500*Dd**2*b1*f**2*r**2 + 99000*Dd**2*b1*f**2*r*s - 74250*Dd**2*b1*f**2*r + 49500*Dd**2*b1*f**2*s**2 - 74250*Dd**2*b1*f**2*s + 24750*Dd**2*b1*f**2 + 37500*Dd**2*f**3*r**2 + 75000*Dd**2*f**3*r*s - 56250*Dd**2*f**3*r + 37500*Dd**2*f**3*s**2 - 56250*Dd**2*f**3*s + 18750*Dd**2*f**3)/(154*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**5*k1*k2**5*(-51480*C*D1**2*f**2*fd*r**2 - 102960*C*D1**2*f**2*fd*r*s + 68640*C*D1**2*f**2*fd*r - 51480*C*D1**2*f**2*fd*s**2 + 68640*C*D1**2*f**2*fd*s - 34320*C*D1**2*f**2*fd - 68640*C*D1*Dd*f**3*r**2 - 137280*C*D1*Dd*f**3*r*s + 102960*C*D1*Dd*f**3*r - 68640*C*D1*Dd*f**3*s**2 + 102960*C*D1*Dd*f**3*s - 51480*C*D1*Dd*f**3 - 12870*D1**2*K*bdd1*f**2*r**2 - 25740*D1**2*K*bdd1*f**2*r*s + 25740*D1**2*K*bdd1*f**2*r - 12870*D1**2*K*bdd1*f**2*s**2 + 25740*D1**2*K*bdd1*f**2*s - 12870*D1**2*K*bdd1*f**2 + 858*D1**2*bd1**2*f*(-36*K + 25*f + 30)*(r + s - 1)**2 - 9100*D1**2*bdd1*f**3*r**2 - 18200*D1**2*bdd1*f**3*r*s + 18200*D1**2*bdd1*f**3*r - 9100*D1**2*bdd1*f**3*s**2 + 18200*D1**2*bdd1*f**3*s - 9100*D1**2*bdd1*f**3 + 10725*D1**2*bdd1*f**2*r**2 + 21450*D1**2*bdd1*f**2*r*s - 21450*D1**2*bdd1*f**2*r + 10725*D1**2*bdd1*f**2*s**2 - 21450*D1**2*bdd1*f**2*s + 10725*D1**2*bdd1*f**2 + 30888*D1**2*bdd1*f*g2*r**2 + 61776*D1**2*bdd1*f*g2*r*s - 61776*D1**2*bdd1*f*g2*r + 30888*D1**2*bdd1*f*g2*s**2 - 61776*D1**2*bdd1*f*g2*s + 30888*D1**2*bdd1*f*g2 + 75040*D1**2*f**3*fd*r**2 + 150080*D1**2*f**3*fd*r*s - 112560*D1**2*f**3*fd*r + 75040*D1**2*f**3*fd*s**2 - 112560*D1**2*f**3*fd*s + 56280*D1**2*f**3*fd - 63000*D1**2*f**3*fdd*r**2 - 126000*D1**2*f**3*fdd*r*s + 94500*D1**2*f**3*fdd*r - 63000*D1**2*f**3*fdd*s**2 + 94500*D1**2*f**3*fdd*s - 47250*D1**2*f**3*fdd - 189000*D1**2*f**2*fd**2*r**2 - 378000*D1**2*f**2*fd**2*r*s + 283500*D1**2*f**2*fd**2*r - 189000*D1**2*f**2*fd**2*s**2 + 283500*D1**2*f**2*fd**2*s - 94500*D1**2*f**2*fd**2 + 45045*D1**2*f**2*fd*r**2 + 90090*D1**2*f**2*fd*r*s - 60060*D1**2*f**2*fd*r + 45045*D1**2*f**2*fd*s**2 - 60060*D1**2*f**2*fd*s + 30030*D1**2*f**2*fd - 41184*D1**2*f**2*gd2*r**2 - 82368*D1**2*f**2*gd2*r*s + 82368*D1**2*f**2*gd2*r - 41184*D1**2*f**2*gd2*s**2 + 82368*D1**2*f**2*gd2*s - 41184*D1**2*f**2*gd2 + 25740*D1**2*f**2*gdd2*r**2 + 51480*D1**2*f**2*gdd2*r*s - 51480*D1**2*f**2*gdd2*r + 25740*D1**2*f**2*gdd2*s**2 - 51480*D1**2*f**2*gdd2*s + 25740*D1**2*f**2*gdd2 - 82368*D1**2*f*fd*g2*r**2 - 164736*D1**2*f*fd*g2*r*s + 82368*D1**2*f*fd*g2*r - 82368*D1**2*f*fd*g2*s**2 + 82368*D1**2*f*fd*g2*s - 41184*D1**2*f*fd*g2 + 102960*D1**2*f*fd*gd2*r**2 + 205920*D1**2*f*fd*gd2*r*s - 154440*D1**2*f*fd*gd2*r + 102960*D1**2*f*fd*gd2*s**2 - 154440*D1**2*f*fd*gd2*s + 51480*D1**2*f*fd*gd2 + 51480*D1**2*f*fdd*g2*r**2 + 102960*D1**2*f*fdd*g2*r*s - 51480*D1**2*f*fdd*g2*r + 51480*D1**2*f*fdd*g2*s**2 - 51480*D1**2*f*fdd*g2*s + 25740*D1**2*f*fdd*g2 + 51480*D1**2*fd**2*g2*r**2 + 102960*D1**2*fd**2*g2*r*s - 51480*D1**2*fd**2*g2*r + 51480*D1**2*fd**2*g2*s**2 - 51480*D1**2*fd**2*g2*s + 75040*D1*Dd*f**4*r**2 + 150080*D1*Dd*f**4*r*s - 112560*D1*Dd*f**4*r + 75040*D1*Dd*f**4*s**2 - 112560*D1*Dd*f**4*s + 56280*D1*Dd*f**4 - 504000*D1*Dd*f**3*fd*r**2 - 1008000*D1*Dd*f**3*fd*r*s + 756000*D1*Dd*f**3*fd*r - 504000*D1*Dd*f**3*fd*s**2 + 756000*D1*Dd*f**3*fd*s - 283500*D1*Dd*f**3*fd + 60060*D1*Dd*f**3*r**2 + 120120*D1*Dd*f**3*r*s - 90090*D1*Dd*f**3*r + 60060*D1*Dd*f**3*s**2 - 90090*D1*Dd*f**3*s + 45045*D1*Dd*f**3 - 164736*D1*Dd*f**2*g2*r**2 - 329472*D1*Dd*f**2*g2*r*s + 247104*D1*Dd*f**2*g2*r - 164736*D1*Dd*f**2*g2*s**2 + 247104*D1*Dd*f**2*g2*s - 123552*D1*Dd*f**2*g2 + 205920*D1*Dd*f**2*gd2*r**2 + 411840*D1*Dd*f**2*gd2*r*s - 360360*D1*Dd*f**2*gd2*r + 205920*D1*Dd*f**2*gd2*s**2 - 360360*D1*Dd*f**2*gd2*s + 154440*D1*Dd*f**2*gd2 + 411840*D1*Dd*f*fd*g2*r**2 + 823680*D1*Dd*f*fd*g2*r*s - 514800*D1*Dd*f*fd*g2*r + 411840*D1*Dd*f*fd*g2*s**2 - 514800*D1*Dd*f*fd*g2*s + 154440*D1*Dd*f*fd*g2 - 63000*D1*Ddd*f**4*r**2 - 126000*D1*Ddd*f**4*r*s + 94500*D1*Ddd*f**4*r - 63000*D1*Ddd*f**4*s**2 + 94500*D1*Ddd*f**4*s - 47250*D1*Ddd*f**4 + 102960*D1*Ddd*f**2*g2*r**2 + 205920*D1*Ddd*f**2*g2*r*s - 154440*D1*Ddd*f**2*g2*r + 102960*D1*Ddd*f**2*g2*s**2 - 154440*D1*Ddd*f**2*g2*s + 77220*D1*Ddd*f**2*g2 + 13*D1*bd1*(D1*(575*f**3*(r + s - 1) - 4*f**2*(396*C*(r + s - 1) + 350*fd*(3*r + 3*s - 2) - (396*K + 33)*(r + s - 1)) - 66*f*(5*fd*(6*K - 5)*(2*r + 2*s - 1) + (58*g2 - 72*gd2)*(r + s - 1)) + 4752*fd*g2*(r + s)) - 2*Dd*f*(700*f**2 + 165*f*(6*K - 5) - 2376*g2)*(4*r + 4*s - 3))*(r + s - 1) - 189000*Dd**2*f**4*r**2 - 378000*Dd**2*f**4*r*s + 283500*Dd**2*f**4*r - 189000*Dd**2*f**4*s**2 + 283500*Dd**2*f**4*s - 94500*Dd**2*f**4 + 308880*Dd**2*f**2*g2*r**2 + 617760*Dd**2*f**2*g2*r*s - 463320*Dd**2*f**2*g2*r + 308880*Dd**2*f**2*g2*s**2 - 463320*Dd**2*f**2*g2*s + 154440*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(f*(38*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(25*fd**2*(r + s - 1) + fd*(29*K - 23)*(r + s) - 3*fdd*(6*K - 5)*(r + s))) + D1*(2*Dd*(19*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(25*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (29*K - 23)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(6*K - 5)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-36*K + 25*f + 30)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-36*K + 25*f + 30)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 13*b1*(3168*C*D1**2*f*fd*r**2 + 6336*C*D1**2*f*fd*r*s - 3168*C*D1**2*f*fd*r + 3168*C*D1**2*f*fd*s**2 - 3168*C*D1**2*f*fd*s + 1584*C*D1**2*f*fd + 6336*C*D1*Dd*f**2*r**2 + 12672*C*D1*Dd*f**2*r*s - 9504*C*D1*Dd*f**2*r + 6336*C*D1*Dd*f**2*s**2 - 9504*C*D1*Dd*f**2*s + 4752*C*D1*Dd*f**2 - 3168*D1**2*K*f*fd*r**2 - 6336*D1**2*K*f*fd*r*s + 3168*D1**2*K*f*fd*r - 3168*D1**2*K*f*fd*s**2 + 3168*D1**2*K*f*fd*s - 1584*D1**2*K*f*fd + 1980*D1**2*K*f*fdd*r**2 + 3960*D1**2*K*f*fdd*r*s - 1980*D1**2*K*f*fdd*r + 1980*D1**2*K*f*fdd*s**2 - 1980*D1**2*K*f*fdd*s + 990*D1**2*K*f*fdd + 1980*D1**2*K*fd**2*r**2 + 3960*D1**2*K*fd**2*r*s - 1980*D1**2*K*fd**2*r + 1980*D1**2*K*fd**2*s**2 - 1980*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(-36*K + 25*f + 30)*(r + s - 1)**2 - 1725*D1**2*f**2*fd*r**2 - 3450*D1**2*f**2*fd*r*s + 2300*D1**2*f**2*fd*r - 1725*D1**2*f**2*fd*s**2 + 2300*D1**2*f**2*fd*s - 1150*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd - 1650*D1**2*f*fdd*r**2 - 3300*D1**2*f*fdd*r*s + 1650*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1650*D1**2*f*fdd*s - 825*D1**2*f*fdd + 3828*D1**2*f*gd2*r**2 + 7656*D1**2*f*gd2*r*s - 7656*D1**2*f*gd2*r + 3828*D1**2*f*gd2*s**2 - 7656*D1**2*f*gd2*s + 3828*D1**2*f*gd2 - 2376*D1**2*f*gdd2*r**2 - 4752*D1**2*f*gdd2*r*s + 4752*D1**2*f*gdd2*r - 2376*D1**2*f*gdd2*s**2 + 4752*D1**2*f*gdd2*s - 2376*D1**2*f*gdd2 - 1650*D1**2*fd**2*r**2 - 3300*D1**2*fd**2*r*s + 1650*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1650*D1**2*fd**2*s + 3828*D1**2*fd*g2*r**2 + 7656*D1**2*fd*g2*r*s + 3828*D1**2*fd*g2*s**2 - 4752*D1**2*fd*gd2*r**2 - 9504*D1**2*fd*gd2*r*s + 4752*D1**2*fd*gd2*r - 4752*D1**2*fd*gd2*s**2 + 4752*D1**2*fd*gd2*s - 2376*D1**2*fdd*g2*r**2 - 4752*D1**2*fdd*g2*r*s - 2376*D1**2*fdd*g2*s**2 - 6336*D1*Dd*K*f**2*r**2 - 12672*D1*Dd*K*f**2*r*s + 9504*D1*Dd*K*f**2*r - 6336*D1*Dd*K*f**2*s**2 + 9504*D1*Dd*K*f**2*s - 4752*D1*Dd*K*f**2 + 15840*D1*Dd*K*f*fd*r**2 + 31680*D1*Dd*K*f*fd*r*s - 19800*D1*Dd*K*f*fd*r + 15840*D1*Dd*K*f*fd*s**2 - 19800*D1*Dd*K*f*fd*s + 5940*D1*Dd*K*f*fd - 2300*D1*Dd*f**3*r**2 - 4600*D1*Dd*f**3*r*s + 3450*D1*Dd*f**3*r - 2300*D1*Dd*f**3*s**2 + 3450*D1*Dd*f**3*s - 1725*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 23800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 23800*D1*Dd*f**2*fd*s + 8400*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 - 13200*D1*Dd*f*fd*r**2 - 26400*D1*Dd*f*fd*r*s + 16500*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 16500*D1*Dd*f*fd*s - 4950*D1*Dd*f*fd + 15312*D1*Dd*f*g2*r**2 + 30624*D1*Dd*f*g2*r*s - 22968*D1*Dd*f*g2*r + 15312*D1*Dd*f*g2*s**2 - 22968*D1*Dd*f*g2*s + 11484*D1*Dd*f*g2 - 19008*D1*Dd*f*gd2*r**2 - 38016*D1*Dd*f*gd2*r*s + 33264*D1*Dd*f*gd2*r - 19008*D1*Dd*f*gd2*s**2 + 33264*D1*Dd*f*gd2*s - 14256*D1*Dd*f*gd2 - 19008*D1*Dd*fd*g2*r**2 - 38016*D1*Dd*fd*g2*r*s + 14256*D1*Dd*fd*g2*r - 19008*D1*Dd*fd*g2*s**2 + 14256*D1*Dd*fd*g2*s + 3960*D1*Ddd*K*f**2*r**2 + 7920*D1*Ddd*K*f**2*r*s - 5940*D1*Ddd*K*f**2*r + 3960*D1*Ddd*K*f**2*s**2 - 5940*D1*Ddd*K*f**2*s + 2970*D1*Ddd*K*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 - 3300*D1*Ddd*f**2*r**2 - 6600*D1*Ddd*f**2*r*s + 4950*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 4950*D1*Ddd*f**2*s - 2475*D1*Ddd*f**2 - 9504*D1*Ddd*f*g2*r**2 - 19008*D1*Ddd*f*g2*r*s + 14256*D1*Ddd*f*g2*r - 9504*D1*Ddd*f*g2*s**2 + 14256*D1*Ddd*f*g2*s - 7128*D1*Ddd*f*g2 + 132*D1*bd1*(D1*(19*f**2*(r + s - 1) - 25*f*fd*(2*r + 2*s - 1) - f*(29*K - 23)*(r + s - 1) + 6*fd*(6*K - 5)*(r + s)) - Dd*f*(-36*K + 25*f + 30)*(4*r + 4*s - 3))*(r + s - 1) + 11880*Dd**2*K*f**2*r**2 + 23760*Dd**2*K*f**2*r*s - 17820*Dd**2*K*f**2*r + 11880*Dd**2*K*f**2*s**2 - 17820*Dd**2*K*f**2*s + 5940*Dd**2*K*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3 - 9900*Dd**2*f**2*r**2 - 19800*Dd**2*f**2*r*s + 14850*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 14850*Dd**2*f**2*s - 4950*Dd**2*f**2 - 28512*Dd**2*f*g2*r**2 - 57024*Dd**2*f*g2*r*s + 42768*Dd**2*f*g2*r - 28512*Dd**2*f*g2*s**2 + 42768*Dd**2*f*g2*s - 14256*Dd**2*f*g2))/(1001*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct**5*k1*k2**3*st**2*(33*b1*(D1**2*(f*(fd*(76*C - 66) + fdd*(35 - 40*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(35 - 40*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(76*C - 66)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(35 - 40*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(35 - 40*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(35 - 40*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(1868*C - 1618)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (40*C - 35)*(33*bdd1*s*(r + s - 1) + 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(875 - 1000*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(76*C - 66)*(r + s - 1) - fd*(40*C - 35)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(35 - 40*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(1868*C - 1618)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(1000*C - 875)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(875 - 1000*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(875 - 1000*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**5*k1*k2**3*(330*b1**2*(D1**2*(fd*(34*C - 28) + fdd*(21 - 24*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(17*C - 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(21 - 24*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(21 - 24*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(144*C - 126)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-832*C*D1**2*f*fd*r**2 - 2240*C*D1**2*f*fd*r*s + 560*C*D1**2*f*fd*r - 1408*C*D1**2*f*fd*s**2 + 848*C*D1**2*f*fd*s - 424*C*D1**2*f*fd + 800*C*D1**2*f*fdd*r**2 + 2080*C*D1**2*f*fdd*r*s - 640*C*D1**2*f*fdd*r + 1280*C*D1**2*f*fdd*s**2 - 880*C*D1**2*f*fdd*s + 440*C*D1**2*f*fdd + 800*C*D1**2*fd**2*r**2 + 2080*C*D1**2*fd**2*r*s - 640*C*D1**2*fd**2*r + 1280*C*D1**2*fd**2*s**2 - 880*C*D1**2*fd**2*s - 400*C*D1**2*fd**2 - 1664*C*D1*Dd*f**2*r**2 - 4480*C*D1*Dd*f**2*r*s + 3072*C*D1*Dd*f**2*r - 2816*C*D1*Dd*f**2*s**2 + 3936*C*D1*Dd*f**2*s - 1824*C*D1*Dd*f**2 + 6400*C*D1*Dd*f*fd*r**2 + 16640*C*D1*Dd*f*fd*r*s - 8320*C*D1*Dd*f*fd*r + 10240*C*D1*Dd*f*fd*s**2 - 10720*C*D1*Dd*f*fd*s + 2400*C*D1*Dd*f*fd + 1600*C*D1*Ddd*f**2*r**2 + 4160*C*D1*Ddd*f**2*r*s - 2880*C*D1*Ddd*f**2*r + 2560*C*D1*Ddd*f**2*s**2 - 3600*C*D1*Ddd*f**2*s + 1680*C*D1*Ddd*f**2 + 4800*C*Dd**2*f**2*r**2 + 12480*C*Dd**2*f**2*r*s - 8640*C*Dd**2*f**2*r + 7680*C*Dd**2*f**2*s**2 - 10800*C*Dd**2*f**2*s + 3360*C*Dd**2*f**2 - 30*D1**2*bdd1*f*(8*C - 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 788*D1**2*f*fd*r**2 + 2168*D1**2*f*fd*r*s - 624*D1**2*f*fd*r + 1380*D1**2*f*fd*s**2 - 920*D1**2*f*fd*s + 460*D1**2*f*fd - 790*D1**2*f*fdd*r**2 - 2092*D1**2*f*fdd*r*s + 696*D1**2*f*fdd*r - 1302*D1**2*f*fdd*s**2 + 952*D1**2*f*fdd*s - 476*D1**2*f*fdd - 790*D1**2*fd**2*r**2 - 2092*D1**2*fd**2*r*s + 696*D1**2*fd**2*r - 1302*D1**2*fd**2*s**2 + 952*D1**2*fd**2*s + 350*D1**2*fd**2 + 1576*D1*Dd*f**2*r**2 + 4336*D1*Dd*f**2*r*s - 2956*D1*Dd*f**2*r + 2760*D1*Dd*f**2*s**2 - 3844*D1*Dd*f**2*s + 1774*D1*Dd*f**2 - 6320*D1*Dd*f*fd*r**2 - 16736*D1*Dd*f*fd*r*s + 8548*D1*Dd*f*fd*r - 10416*D1*Dd*f*fd*s**2 + 11108*D1*Dd*f*fd*s - 2600*D1*Dd*f*fd - 1580*D1*Ddd*f**2*r**2 - 4184*D1*Ddd*f**2*r*s + 2882*D1*Ddd*f**2*r - 2604*D1*Ddd*f**2*s**2 + 3650*D1*Ddd*f**2*s - 1697*D1*Ddd*f**2 + 20*D1*bd1*(D1*(f*(17*C - 14)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(21 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(21 - 24*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 4740*Dd**2*f**2*r**2 - 12552*Dd**2*f**2*r*s + 8646*Dd**2*f**2*r - 7812*Dd**2*f**2*s**2 + 10950*Dd**2*f**2*s - 3394*Dd**2*f**2) + f*(-1980*D1**2*bd1**2*(8*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(40*C*(10*r**2 + 26*r*s - 30*r + 16*s**2 - 36*s + 15) - 395*r**2 - 1046*r*s + 1140*r - 651*s**2 + 1396*s - 570) - 5*D1**2*(f*(4*fd*(C*(3525*r**2 + 7638*r*s - 4896*r + 4113*s**2 - 5288*s + 2546) - 3108*r**2 - 6963*r*s + 4393*r - 3855*s**2 + 4891*s - 2321) + fdd*(-8*C*(1401*r**2 + 3147*r*s - 1983*r + 1746*s**2 - 2213*s + 1049) + 10473*r**2 + 24222*r*s - 15056*r + 13749*s**2 - 17240*s + 8074)) + 2*fd**2*(-4*C*(2802*r**2 + 6294*r*s - 3966*r + 3492*s**2 - 4426*s + 1049) + 10473*r**2 + 24222*r*s - 15056*r + 13749*s**2 - 17240*s + 4037)) - 66*D1*bd1*(D1*(f*(4*C*(52*r**2 + 2*r*(70*s - 87) + 88*s**2 - 210*s + 87) - 197*r**2 - 542*r*s + 624*r - 345*s**2 + 772*s - 312) - 2*fd*(20*C*(20*r**2 + 52*r*s - 38*r + 32*s**2 - 47*s + 18) - 395*r**2 - 1046*r*s + 744*r - 651*s**2 + 936*s - 349)) + Dd*f*(-40*C*(40*r**2 + 104*r*s - 96*r + 64*s**2 - 117*s + 51) + 1580*r**2 + 4184*r*s - 3721*r + 2604*s**2 - 4617*s + 1966)) - 5*D1*f*(2*Dd*(2*f*(C*(4700*r**2 + 10184*r*s - 7442*r + 5484*s**2 - 8030*s + 3917) - 4144*r**2 - 9284*r*s + 6714*r - 5140*s**2 + 7461*s - 3606) + fd*(-4*C*(11208*r**2 + 25176*r*s - 17028*r + 13968*s**2 - 18983*s + 6409) + 41892*r**2 + 96888*r*s - 64807*r + 54996*s**2 - 74089*s + 24768)) + Ddd*f*(-8*C*(1868*r**2 + 4196*r*s - 3032*r + 2328*s**2 - 3377*s + 1631) + 13964*r**2 + 32296*r*s - 23130*r + 18332*s**2 - 26406*s + 12657)) - 10*Dd**2*f**2*(-4*C*(5604*r**2 + 12588*r*s - 9096*r + 6984*s**2 - 10131*s + 3262) + 20946*r**2 + 48444*r*s - 34695*r + 27498*s**2 - 39609*s + 12657)))/(693*d**2*k3**5) + 4*D1**2*Pk1*Pkd3*ct**5*k1*k2*(22*b1**2*(D1**2*(s - 1)*(fd*(29*C - 23) + fdd*(15 - 18*C))*(r + s - 1) + D1*(Dd*(f*(29*C - 23)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(18*C - 15)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(15 - 18*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(18*C - 15)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 11*b1*(D1**2*(f*(-6*bdd1*s*(6*C - 5)*(2*r + 2*s - 1) + fd*(r*(8*s - 4) + 8*s**2 - s*(48*C - 30) + 4) + 5*fdd*(-2*r*s + r - 2*s**2 + s*(6*C - 3) - 1)) + 5*fd**2*(6*C*(s - 1) - 2*r*s + r - 2*s**2 - 3*s + 5)) + 2*D1*bd1*(D1*(f*s*(29*C - 23)*(2*r + 2*s - 1) - fd*(18*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(30 - 36*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(4*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 5*fd*(2*s - 1)*(12*C - 8*r - 8*s - 5)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) - f*(66*D1**2*bd1**2*s*(6*C - 5)*(2*r + 2*s - 1) + 5*D1**2*(f*(11*bdd1*s*(6*C + r + s - 6) + fd*(90*C - 79)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(56*C - 56)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(56 - 56*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 11*D1*bd1*(D1*(2*f*s*(24*C + 2*r + 2*s - 21) - 5*fd*(6*C*(s - 1) + 4*r*s - r + 4*s**2 - 9*s + 6)) - 5*Dd*f*(12*C*(2*s - 1) + 8*r*s - 2*r + 8*s**2 - 29*s + 12)) + 5*D1*f*(Dd*(f*(90*C - 79)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(56*C - 56)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(56 - 56*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(56 - 56*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**3) - D1**2*Pk1*Pkd3*ct**5*k2**5*st**2*(8448*C*D1**2*b1*f*fd*r**2 + 8448*C*D1**2*b1*f*fd*r*s - 4224*C*D1**2*b1*f*fd*r - 2640*C*D1**2*b1*f*fdd*r**2 - 2640*C*D1**2*b1*f*fdd*r*s + 1320*C*D1**2*b1*f*fdd*r - 2640*C*D1**2*b1*fd**2*r**2 - 2640*C*D1**2*b1*fd**2*r*s + 1320*C*D1**2*b1*fd**2*r + 11424*C*D1**2*f**2*fd*r**2 + 11424*C*D1**2*f**2*fd*r*s - 11424*C*D1**2*f**2*fd*r - 3808*C*D1**2*f**2*fd*s + 3808*C*D1**2*f**2*fd - 4920*C*D1**2*f**2*fdd*r**2 - 4920*C*D1**2*f**2*fdd*r*s + 4920*C*D1**2*f**2*fdd*r + 1640*C*D1**2*f**2*fdd*s - 1640*C*D1**2*f**2*fdd - 9840*C*D1**2*f*fd**2*r**2 - 9840*C*D1**2*f*fd**2*r*s + 9840*C*D1**2*f*fd**2*r + 3280*C*D1**2*f*fd**2*s - 1640*C*D1**2*f*fd**2 + 16896*C*D1*Dd*b1*f**2*r**2 + 16896*C*D1*Dd*b1*f**2*r*s - 16896*C*D1*Dd*b1*f**2*r - 4224*C*D1*Dd*b1*f**2*s + 4224*C*D1*Dd*b1*f**2 - 21120*C*D1*Dd*b1*f*fd*r**2 - 21120*C*D1*Dd*b1*f*fd*r*s + 15840*C*D1*Dd*b1*f*fd*r + 2640*C*D1*Dd*b1*f*fd*s - 1320*C*D1*Dd*b1*f*fd + 15232*C*D1*Dd*f**3*r**2 + 15232*C*D1*Dd*f**3*r*s - 15232*C*D1*Dd*f**3*r - 3808*C*D1*Dd*f**3*s + 3808*C*D1*Dd*f**3 - 39360*C*D1*Dd*f**2*fd*r**2 - 39360*C*D1*Dd*f**2*fd*r*s + 39360*C*D1*Dd*f**2*fd*r + 11480*C*D1*Dd*f**2*fd*s - 8200*C*D1*Dd*f**2*fd - 5280*C*D1*Ddd*b1*f**2*r**2 - 5280*C*D1*Ddd*b1*f**2*r*s + 5280*C*D1*Ddd*b1*f**2*r + 1320*C*D1*Ddd*b1*f**2*s - 1320*C*D1*Ddd*b1*f**2 - 6560*C*D1*Ddd*f**3*r**2 - 6560*C*D1*Ddd*f**3*r*s + 6560*C*D1*Ddd*f**3*r + 1640*C*D1*Ddd*f**3*s - 1640*C*D1*Ddd*f**3 - 15840*C*Dd**2*b1*f**2*r**2 - 15840*C*Dd**2*b1*f**2*r*s + 15840*C*Dd**2*b1*f**2*r + 3960*C*Dd**2*b1*f**2*s - 2640*C*Dd**2*b1*f**2 - 19680*C*Dd**2*f**3*r**2 - 19680*C*Dd**2*f**3*r*s + 19680*C*Dd**2*f**3*r + 4920*C*Dd**2*f**3*s - 3280*C*Dd**2*f**3 - 18348*D1**2*b1*f*fd*r**2 - 28248*D1**2*b1*f*fd*r*s + 14124*D1**2*b1*f*fd*r - 9900*D1**2*b1*f*fd*s**2 + 9900*D1**2*b1*f*fd*s - 4950*D1**2*b1*f*fd + 7590*D1**2*b1*f*fdd*r**2 + 12540*D1**2*b1*f*fdd*r*s - 6270*D1**2*b1*f*fdd*r + 4950*D1**2*b1*f*fdd*s**2 - 4950*D1**2*b1*f*fdd*s + 2475*D1**2*b1*f*fdd + 7590*D1**2*b1*fd**2*r**2 + 12540*D1**2*b1*fd**2*r*s - 6270*D1**2*b1*fd**2*r + 4950*D1**2*b1*fd**2*s**2 - 4950*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)*(8*C*(r - 1) - 23*r - 15*s + 23) - 22674*D1**2*f**2*fd*r**2 - 33924*D1**2*f**2*fd*r*s + 26424*D1**2*f**2*fd*r - 11250*D1**2*f**2*fd*s**2 + 18808*D1**2*f**2*fd*s - 11308*D1**2*f**2*fd + 10545*D1**2*f**2*fdd*r**2 + 16170*D1**2*f**2*fdd*r*s - 12420*D1**2*f**2*fdd*r + 5625*D1**2*f**2*fdd*s**2 - 9140*D1**2*f**2*fdd*s + 5390*D1**2*f**2*fdd + 21090*D1**2*f*fd**2*r**2 + 32340*D1**2*f*fd**2*r*s - 24840*D1**2*f*fd**2*r + 11250*D1**2*f*fd**2*s**2 - 18280*D1**2*f*fd**2*s + 5390*D1**2*f*fd**2 - 36696*D1*Dd*b1*f**2*r**2 - 56496*D1*Dd*b1*f**2*r*s + 46596*D1*Dd*b1*f**2*r - 19800*D1*Dd*b1*f**2*s**2 + 33924*D1*Dd*b1*f**2*s - 19074*D1*Dd*b1*f**2 + 60720*D1*Dd*b1*f*fd*r**2 + 100320*D1*Dd*b1*f*fd*r*s - 65340*D1*Dd*b1*f*fd*r + 39600*D1*Dd*b1*f*fd*s**2 - 52140*D1*Dd*b1*f*fd*s + 16170*D1*Dd*b1*f*fd - 30232*D1*Dd*f**3*r**2 - 45232*D1*Dd*f**3*r*s + 37732*D1*Dd*f**3*r - 15000*D1*Dd*f**3*s**2 + 26308*D1*Dd*f**3*s - 15058*D1*Dd*f**3 + 84360*D1*Dd*f**2*fd*r**2 + 129360*D1*Dd*f**2*fd*r*s - 103110*D1*Dd*f**2*fd*r + 45000*D1*Dd*f**2*fd*s**2 - 75230*D1*Dd*f**2*fd*s + 30700*D1*Dd*f**2*fd + 15180*D1*Ddd*b1*f**2*r**2 + 25080*D1*Ddd*b1*f**2*r*s - 20130*D1*Ddd*b1*f**2*r + 9900*D1*Ddd*b1*f**2*s**2 - 16170*D1*Ddd*b1*f**2*s + 8745*D1*Ddd*b1*f**2 + 14060*D1*Ddd*f**3*r**2 + 21560*D1*Ddd*f**3*r*s - 17810*D1*Ddd*f**3*r + 7500*D1*Ddd*f**3*s**2 - 12890*D1*Ddd*f**3*s + 7265*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1)*(64*C*(r - 1) - 139*r - 75*s + 139) - 5*fd*(4*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) - 46*r**2 - 76*r*s + 65*r - 30*s**2 + 53*s - 19)) - 5*Dd*f*(4*C*(8*r**2 + 8*r*s - 12*r - 5*s + 4) - 92*r**2 - 152*r*s + 153*r - 60*s**2 + 125*s - 61)) + 45540*Dd**2*b1*f**2*r**2 + 75240*Dd**2*b1*f**2*r*s - 60390*Dd**2*b1*f**2*r + 29700*Dd**2*b1*f**2*s**2 - 48510*Dd**2*b1*f**2*s + 17490*Dd**2*b1*f**2 + 42180*Dd**2*f**3*r**2 + 64680*Dd**2*f**3*r*s - 53430*Dd**2*f**3*r + 22500*Dd**2*f**3*s**2 - 38670*Dd**2*f**3*s + 14530*Dd**2*f**3)/(1386*d**2*k1*k3**5) + D1**2*Pk1*Pkd3*ct**5*k2**5*(51480*C*D1**2*f**2*fd*r**2 + 51480*C*D1**2*f**2*fd*r*s - 51480*C*D1**2*f**2*fd*r - 17160*C*D1**2*f**2*fd*s + 17160*C*D1**2*f**2*fd + 68640*C*D1*Dd*f**3*r**2 + 68640*C*D1*Dd*f**3*r*s - 68640*C*D1*Dd*f**3*r - 17160*C*D1*Dd*f**3*s + 17160*C*D1*Dd*f**3 + 1716*D1**2*K*bdd1*f**2*r**2 + 1716*D1**2*K*bdd1*f**2*r*s - 1716*D1**2*K*bdd1*f**2*r - 4290*D1**2*bd1**2*f*(r + s - 1)*(5*f*(2*r + 2*s - 1) + 6*r + 6*s - 6) - 16445*D1**2*bdd1*f**3*r**2 - 11050*D1**2*bdd1*f**3*r*s + 13390*D1**2*bdd1*f**3*r + 5395*D1**2*bdd1*f**3*s**2 - 8450*D1**2*bdd1*f**3*s - 6045*D1**2*bdd1*f**3 - 12441*D1**2*bdd1*f**2*r**2 - 23166*D1**2*bdd1*f**2*r*s + 23166*D1**2*bdd1*f**2*r - 10725*D1**2*bdd1*f**2*s**2 + 21450*D1**2*bdd1*f**2*s - 10725*D1**2*bdd1*f**2 - 40880*D1**2*f**3*fd*r**2 - 106400*D1**2*f**3*fd*r*s + 73640*D1**2*f**3*fd*r - 65520*D1**2*f**3*fd*s**2 + 92120*D1**2*f**3*fd*s - 42980*D1**2*f**3*fd + 24080*D1**2*f**3*fdd*r**2 + 104160*D1**2*f**3*fdd*r*s - 64120*D1**2*f**3*fdd*r + 80080*D1**2*f**3*fdd*s**2 - 106120*D1**2*f**3*fdd*s + 46060*D1**2*f**3*fdd + 72240*D1**2*f**2*fd**2*r**2 + 312480*D1**2*f**2*fd**2*r*s - 192360*D1**2*f**2*fd**2*r + 240240*D1**2*f**2*fd**2*s**2 - 318360*D1**2*f**2*fd**2*s + 92120*D1**2*f**2*fd**2 - 83655*D1**2*f**2*fd*r**2 - 115830*D1**2*f**2*fd*r*s + 94380*D1**2*f**2*fd*r - 32175*D1**2*f**2*fd*s**2 + 60060*D1**2*f**2*fd*s - 38610*D1**2*f**2*fd + 27456*D1**2*f**2*gd2*r**2 + 27456*D1**2*f**2*gd2*r*s - 27456*D1**2*f**2*gd2*r - 3432*D1**2*f**2*gdd2*r**2 - 3432*D1**2*f**2*gdd2*r*s + 3432*D1**2*f**2*gdd2*r + 54912*D1**2*f*fd*g2*r**2 + 54912*D1**2*f*fd*g2*r*s - 54912*D1**2*f*fd*g2*r - 27456*D1**2*f*fd*g2*s + 27456*D1**2*f*fd*g2 - 13728*D1**2*f*fd*gd2*r**2 - 13728*D1**2*f*fd*gd2*r*s + 13728*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s - 3432*D1**2*f*fd*gd2 - 6864*D1**2*f*fdd*g2*r**2 - 6864*D1**2*f*fdd*g2*r*s + 6864*D1**2*f*fdd*g2*r + 3432*D1**2*f*fdd*g2*s - 3432*D1**2*f*fdd*g2 - 6864*D1**2*fd**2*g2*r**2 - 6864*D1**2*fd**2*g2*r*s + 6864*D1**2*fd**2*g2*r + 3432*D1**2*fd**2*g2*s - 40880*D1*Dd*f**4*r**2 - 106400*D1*Dd*f**4*r*s + 73640*D1*Dd*f**4*r - 65520*D1*Dd*f**4*s**2 + 92120*D1*Dd*f**4*s - 42980*D1*Dd*f**4 + 192640*D1*Dd*f**3*fd*r**2 + 833280*D1*Dd*f**3*fd*r*s - 512960*D1*Dd*f**3*fd*r + 640640*D1*Dd*f**3*fd*s**2 - 848960*D1*Dd*f**3*fd*s + 276360*D1*Dd*f**3*fd - 111540*D1*Dd*f**3*r**2 - 154440*D1*Dd*f**3*r*s + 132990*D1*Dd*f**3*r - 42900*D1*Dd*f**3*s**2 + 81510*D1*Dd*f**3*s - 49335*D1*Dd*f**3 + 109824*D1*Dd*f**2*g2*r**2 + 109824*D1*Dd*f**2*g2*r*s - 109824*D1*Dd*f**2*g2*r - 27456*D1*Dd*f**2*g2*s + 27456*D1*Dd*f**2*g2 - 27456*D1*Dd*f**2*gd2*r**2 - 27456*D1*Dd*f**2*gd2*r*s + 27456*D1*Dd*f**2*gd2*r + 3432*D1*Dd*f**2*gd2*s - 3432*D1*Dd*f**2*gd2 - 54912*D1*Dd*f*fd*g2*r**2 - 54912*D1*Dd*f*fd*g2*r*s + 54912*D1*Dd*f*fd*g2*r + 20592*D1*Dd*f*fd*g2*s - 13728*D1*Dd*f*fd*g2 + 24080*D1*Ddd*f**4*r**2 + 104160*D1*Ddd*f**4*r*s - 64120*D1*Ddd*f**4*r + 80080*D1*Ddd*f**4*s**2 - 106120*D1*Ddd*f**4*s + 46060*D1*Ddd*f**4 - 13728*D1*Ddd*f**2*g2*r**2 - 13728*D1*Ddd*f**2*g2*r*s + 13728*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s - 3432*D1*Ddd*f**2*g2 + 13*D1*bd1*f*(D1*(5*f**2*(539*r**2 + r*(802*s - 478) + 263*s**2 - 202*s + 219) + 2*f*(792*C*(r - 1)*(r + s - 1) - 5*fd*(759*r**2 + 510*r*s - 629*r - 249*s**2 + 211*s - 120) - (r + s - 1)*(528*K*r - 66*r - 330*s - 462)) + 66*fd*(K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 58*r**2 - 108*r*s + 83*r - 50*s**2 + 77*s - 27) + 1848*g2*(r - 1)*(r + s - 1)) - 2*Dd*f*(-66*K*(8*r**2 + 8*r*(s - 1) - s + 1) + 5*f*(1012*r**2 + r*(680*s - 835) - 332*s**2 + 341*s - 27) + 3828*r**2 + 7128*r*s - 6303*r + 3300*s**2 - 5841*s + 2541)) + 72240*Dd**2*f**4*r**2 + 312480*Dd**2*f**4*r*s - 192360*Dd**2*f**4*r + 240240*Dd**2*f**4*s**2 - 318360*Dd**2*f**4*s + 92120*Dd**2*f**4 - 41184*Dd**2*f**2*g2*r**2 - 41184*Dd**2*f**2*g2*r*s + 41184*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s - 6864*Dd**2*f**2*g2 + 429*b1**2*(D1**2*(25*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 50*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 4*fd*(r + s)*(r*(7*K - 22) - 15*s) - 30*fdd*(r + s)**2) + 2*D1*(Dd*(50*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-14*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 25*fd*(4*r + 4*s - 3)**2 + 176*r**2 + 296*r*s - 236*r + 120*s**2 - 194*s + 104) - 30*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 5*Ddd*f*(5*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f*(5*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(3168*C*D1**2*f*fd*r**2 + 3168*C*D1**2*f*fd*r*s - 1584*C*D1**2*f*fd*r + 6336*C*D1*Dd*f**2*r**2 + 6336*C*D1*Dd*f**2*r*s - 6336*C*D1*Dd*f**2*r - 1584*C*D1*Dd*f**2*s + 1584*C*D1*Dd*f**2 - 2112*D1**2*K*f*fd*r**2 - 2112*D1**2*K*f*fd*r*s + 2112*D1**2*K*f*fd*r + 1056*D1**2*K*f*fd*s - 1056*D1**2*K*f*fd + 264*D1**2*K*f*fdd*r**2 + 264*D1**2*K*f*fdd*r*s - 264*D1**2*K*f*fdd*r - 132*D1**2*K*f*fdd*s + 132*D1**2*K*f*fdd + 264*D1**2*K*fd**2*r**2 + 264*D1**2*K*fd**2*r*s - 264*D1**2*K*fd**2*r - 132*D1**2*K*fd**2*s - 165*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 12*(r + s - 1)**2) + 8085*D1**2*f**2*fd*r**2 + 12030*D1**2*f**2*fd*r*s - 11020*D1**2*f**2*fd*r + 3945*D1**2*f**2*fd*s**2 - 8260*D1**2*f**2*fd*s + 4230*D1**2*f**2*fd - 3795*D1**2*f**2*fdd*r**2 - 2550*D1**2*f**2*fdd*r*s + 3200*D1**2*f**2*fdd*r + 1245*D1**2*f**2*fdd*s**2 - 160*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd - 7590*D1**2*f*fd**2*r**2 - 5100*D1**2*f*fd**2*r*s + 6400*D1**2*f*fd**2*r + 2490*D1**2*f*fd**2*s**2 - 320*D1**2*f*fd**2*s - 2070*D1**2*f*fd**2 + 264*D1**2*f*fd*r**2 + 1584*D1**2*f*fd*r*s - 1848*D1**2*f*fd*r + 1320*D1**2*f*fd*s**2 - 2376*D1**2*f*fd*s + 1716*D1**2*f*fd - 1914*D1**2*f*fdd*r**2 - 3564*D1**2*f*fdd*r*s + 1914*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1782*D1**2*f*fdd*s - 957*D1**2*f*fdd + 1848*D1**2*f*gd2*r**2 + 1848*D1**2*f*gd2*r*s - 1848*D1**2*f*gd2*r - 1914*D1**2*fd**2*r**2 - 3564*D1**2*fd**2*r*s + 1914*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1782*D1**2*fd**2*s + 1848*D1**2*fd*g2*r**2 + 1848*D1**2*fd*g2*r*s - 4224*D1*Dd*K*f**2*r**2 - 4224*D1*Dd*K*f**2*r*s + 4224*D1*Dd*K*f**2*r + 1056*D1*Dd*K*f**2*s - 1056*D1*Dd*K*f**2 + 2112*D1*Dd*K*f*fd*r**2 + 2112*D1*Dd*K*f*fd*r*s - 2112*D1*Dd*K*f*fd*r - 792*D1*Dd*K*f*fd*s + 528*D1*Dd*K*f*fd + 10780*D1*Dd*f**3*r**2 + 16040*D1*Dd*f**3*r*s - 13410*D1*Dd*f**3*r + 5260*D1*Dd*f**3*s**2 - 9270*D1*Dd*f**3*s + 5325*D1*Dd*f**3 - 30360*D1*Dd*f**2*fd*r**2 - 20400*D1*Dd*f**2*fd*r*s + 25490*D1*Dd*f**2*fd*r + 9960*D1*Dd*f**2*fd*s**2 - 3070*D1*Dd*f**2*fd*s - 2880*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 + 3168*D1*Dd*f**2*r*s - 1848*D1*Dd*f**2*r + 2640*D1*Dd*f**2*s**2 - 3432*D1*Dd*f**2*s + 1452*D1*Dd*f**2 - 15312*D1*Dd*f*fd*r**2 - 28512*D1*Dd*f*fd*r*s + 18612*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 17292*D1*Dd*f*fd*s - 5478*D1*Dd*f*fd + 7392*D1*Dd*f*g2*r**2 + 7392*D1*Dd*f*g2*r*s - 7392*D1*Dd*f*g2*r - 1848*D1*Dd*f*g2*s + 1848*D1*Dd*f*g2 + 528*D1*Ddd*K*f**2*r**2 + 528*D1*Ddd*K*f**2*r*s - 528*D1*Ddd*K*f**2*r - 132*D1*Ddd*K*f**2*s + 132*D1*Ddd*K*f**2 - 5060*D1*Ddd*f**3*r**2 - 3400*D1*Ddd*f**3*r*s + 4230*D1*Ddd*f**3*r + 1660*D1*Ddd*f**3*s**2 - 810*D1*Ddd*f**3*s - 435*D1*Ddd*f**3 - 3828*D1*Ddd*f**2*r**2 - 7128*D1*Ddd*f**2*r*s + 5478*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 5082*D1*Ddd*f**2*s - 2607*D1*Ddd*f**2 + 66*D1*bd1*(D1*(25*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(r + s - 1)*(14*K*r - 7*K + 50*fd*(2*r + 2*s - 1) - 44*r - 30*s + 37) - 60*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 5*Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 12*r + 12*s - 12)) + 1584*Dd**2*K*f**2*r**2 + 1584*Dd**2*K*f**2*r*s - 1584*Dd**2*K*f**2*r - 396*Dd**2*K*f**2*s + 264*Dd**2*K*f**2 - 15180*Dd**2*f**3*r**2 - 10200*Dd**2*f**3*r*s + 12690*Dd**2*f**3*r + 4980*Dd**2*f**3*s**2 - 2430*Dd**2*f**3*s - 870*Dd**2*f**3 - 11484*Dd**2*f**2*r**2 - 21384*Dd**2*f**2*r*s + 16434*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 15246*Dd**2*f**2*s - 5214*Dd**2*f**2))/(9009*d**2*k1*k3**5) + 10*D1**2*Pk1*Pkd3*ct**5*k2**3*st**2*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 50*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 25*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 25*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k1*k3**3) - D1**2*Pk1*Pkd3*ct**5*k2**3*(66*b1**2*(D1**2*(fd*(r*(28*C - 34) - 6*s + 6) + 3*fdd*(r + s - 1))*(r + s - 1) + D1*(2*Dd*(f*(14*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 68*r**2 - 80*r*s + 74*r - 12*s**2 + 32*s - 23) + 3*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(128*C*D1**2*f*fd*r**2 + 128*C*D1**2*f*fd*r*s - 192*C*D1**2*f*fd*r - 64*C*D1**2*f*fd*s + 64*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r**2 - 16*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r + 8*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r**2 - 16*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 + 256*C*D1*Dd*f**2*r**2 + 256*C*D1*Dd*f**2*r*s - 256*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s + 64*C*D1*Dd*f**2 - 128*C*D1*Dd*f*fd*r**2 - 128*C*D1*Dd*f*fd*r*s + 160*C*D1*Dd*f*fd*r + 48*C*D1*Dd*f*fd*s - 40*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r**2 - 32*C*D1*Ddd*f**2*r*s + 32*C*D1*Ddd*f**2*r + 8*C*D1*Ddd*f**2*s - 8*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r**2 - 96*C*Dd**2*f**2*r*s + 96*C*Dd**2*f**2*r + 24*C*Dd**2*f**2*s - 16*C*Dd**2*f**2 + 6*D1**2*bdd1*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 112*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s + 140*D1**2*f*fd*r + 128*D1**2*f*fd*s**2 - 44*D1**2*f*fd*s - 10*D1**2*f*fd + 26*D1**2*f*fdd*r**2 - 92*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*r - 118*D1**2*f*fdd*s**2 + 100*D1**2*f*fdd*s - 46*D1**2*f*fdd + 26*D1**2*fd**2*r**2 - 92*D1**2*fd**2*r*s + 20*D1**2*fd**2*r - 118*D1**2*fd**2*s**2 + 100*D1**2*fd**2*s + 18*D1**2*fd**2 - 224*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s + 96*D1*Dd*f**2*r + 256*D1*Dd*f**2*s**2 - 264*D1*Dd*f**2*s + 72*D1*Dd*f**2 + 208*D1*Dd*f*fd*r**2 - 736*D1*Dd*f*fd*r*s + 212*D1*Dd*f*fd*r - 944*D1*Dd*f*fd*s**2 + 964*D1*Dd*f*fd*s - 220*D1*Dd*f*fd + 52*D1*Ddd*f**2*r**2 - 184*D1*Ddd*f**2*r*s + 66*D1*Ddd*f**2*r - 236*D1*Ddd*f**2*s**2 + 282*D1*Ddd*f**2*s - 105*D1*Ddd*f**2 + 4*D1*bd1*(D1*(f*(14*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 34*r**2 - 40*r*s + 34*r - 6*s**2 + 20*s - 17) + 3*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 156*Dd**2*f**2*r**2 - 552*Dd**2*f**2*r*s + 198*Dd**2*f**2*r - 708*Dd**2*f**2*s**2 + 846*Dd**2*f**2*s - 210*Dd**2*f**2) - f*(-396*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1**2*(f*(33*bdd1*(r**2*(8*C - 13) + r*s*(8*C + 46) + s*(59*s - 64)) + 5*fd*(80*C*(3*r**2 + 3*r*(s - 1) - s + 1) - 759*r**2 - 1986*r*s + 1168*r - 1227*s**2 + 1480*s - 662) - 5*fdd*(40*C*(3*r**2 + 3*r*(s - 1) - s + 1) - 231*r**2 - 1290*r*s + 584*r - 1059*s**2 + 1136*s - 430)) - 10*fd**2*(20*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 231*r**2 + r*(584 - 1290*s) - 1059*s**2 + 1136*s - 215)) - 66*D1*bd1*(D1*(f*(r**2*(32*C - 28) + 2*r*(16*C*s + 2*s - 9) + 32*s**2 - 46*s + 9) - 2*fd*(-2*C*s + r**2*(8*C - 13) + r*(8*C*s - 6*C + 46*s - 5) + 59*s**2 - 57*s + 16)) + Dd*f*(4*C*s + r**2*(52 - 32*C) + r*(-32*C*s + 16*C - 184*s + 33) - 236*s**2 + 269*s - 64)) + 5*D1*f*(Dd*(f*(80*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 1012*r**2 - 2648*r*s + 1830*r - 1636*s**2 + 2298*s - 1071) + 2*fd*(-20*C*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 924*r**2 + 5160*r*s - 2689*r + 4236*s**2 - 5035*s + 1428)) + Ddd*f*(-40*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 308*r**2 + 2*r*(860*s - 507) + 1412*s**2 - 1842*s + 783)) - 10*Dd**2*f**2*(20*C*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - 462*r**2 - 3*r*(860*s - 507) - 2118*s**2 + 2763*s - 783)))/(693*d**2*k1*k3**3) + 4*D1**2*Pk1*Pkd3*ct**5*k2*(D1*f*(-6*D1*bd1**2*s*(2*r + 2*s - 1) - 5*D1*bdd1*f*s*(r + s) - 5*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 2) + s*(8*s - 5)))) + 6*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(-6*bdd1*s*(2*r + 2*s - 1) + 10*fd*(2*s - 1)*(r + s - 1) - 5*fdd*(2*s - 1)*(r + s - 1)) - 5*fd**2*(2*s - 1)*(r + s - 1)) + 6*D1*bd1*(2*D1*f*s*(2*r + 2*s - 1) - D1*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + 5*D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k1*k3) + D1**2*Pk1*Pkd3*ct**4*f*k2**6*st**4*(90*C - 90)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**4*f*k2**4*st**4*(40*C - 40)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4))/(77*d**2*k3**5) + 5*D1**2*Pk1*Pkd3*ct**4*f*k2**6*st**2*(2691*D1**2*b1*f*fd*r**2 + 2691*D1**2*b1*f*fd*r*s - 1794*D1**2*b1*f*fd*r - 1989*D1**2*b1*f*fdd*r**2 - 1989*D1**2*b1*f*fdd*r*s + 1326*D1**2*b1*f*fdd*r - 3978*D1**2*b1*fd**2*r**2 - 3978*D1**2*b1*fd**2*r*s + 2652*D1**2*b1*fd**2*r - 663*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 1420*D1**2*f**2*fd*r**2 + 1420*D1**2*f**2*fd*r*s - 1420*D1**2*f**2*fd*r - 355*D1**2*f**2*fd*s + 355*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 60*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s - 15*D1**2*f**2*fdd - 180*D1**2*f*fd**2*r**2 - 180*D1**2*f*fd**2*r*s + 180*D1**2*f*fd**2*r + 45*D1**2*f*fd**2*s - 30*D1**2*f*fd**2 + 3588*D1*Dd*b1*f**2*r**2 + 3588*D1*Dd*b1*f**2*r*s - 3588*D1*Dd*b1*f**2*r - 897*D1*Dd*b1*f**2*s + 897*D1*Dd*b1*f**2 - 15912*D1*Dd*b1*f*fd*r**2 - 15912*D1*Dd*b1*f*fd*r*s + 13260*D1*Dd*b1*f*fd*r + 1989*D1*Dd*b1*f*fd*s - 1326*D1*Dd*b1*f*fd + 1420*D1*Dd*f**3*r**2 + 1420*D1*Dd*f**3*r*s - 1420*D1*Dd*f**3*r - 355*D1*Dd*f**3*s + 355*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 480*D1*Dd*f**2*fd*r*s + 480*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s - 90*D1*Dd*f**2*fd - 2652*D1*Ddd*b1*f**2*r**2 - 2652*D1*Ddd*b1*f**2*r*s + 2652*D1*Ddd*b1*f**2*r + 663*D1*Ddd*b1*f**2*s - 663*D1*Ddd*b1*f**2 - 60*D1*Ddd*f**3*r**2 - 60*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r + 15*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 + 39*D1*bd1*f*(D1*(23*f*(r - 1)*(r + s - 1) - 17*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 17*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 7956*Dd**2*b1*f**2*r**2 - 7956*Dd**2*b1*f**2*r*s + 7956*Dd**2*b1*f**2*r + 1989*Dd**2*b1*f**2*s - 1326*Dd**2*b1*f**2 - 180*Dd**2*f**3*r**2 - 180*Dd**2*f**3*r*s + 180*Dd**2*f**3*r + 45*Dd**2*f**3*s - 30*Dd**2*f**3)/(9009*d**2*k1**2*k3**5) + D1**2*Pk1*Pkd3*ct**4*k1**4*k2**2*(8712*C*D1**2*b1*f*fd*r**2 + 17424*C*D1**2*b1*f*fd*r*s - 8712*C*D1**2*b1*f*fd*r + 8712*C*D1**2*b1*f*fd*s**2 - 8712*C*D1**2*b1*f*fd*s + 4356*C*D1**2*b1*f*fd - 9900*C*D1**2*b1*f*fdd*r**2 - 19800*C*D1**2*b1*f*fdd*r*s + 9900*C*D1**2*b1*f*fdd*r - 9900*C*D1**2*b1*f*fdd*s**2 + 9900*C*D1**2*b1*f*fdd*s - 4950*C*D1**2*b1*f*fdd - 9900*C*D1**2*b1*fd**2*r**2 - 19800*C*D1**2*b1*fd**2*r*s + 9900*C*D1**2*b1*fd**2*r - 9900*C*D1**2*b1*fd**2*s**2 + 9900*C*D1**2*b1*fd**2*s + 11340*C*D1**2*f**2*fd*r**2 + 22680*C*D1**2*f**2*fd*r*s - 15120*C*D1**2*f**2*fd*r + 11340*C*D1**2*f**2*fd*s**2 - 15120*C*D1**2*f**2*fd*s + 7560*C*D1**2*f**2*fd - 12600*C*D1**2*f**2*fdd*r**2 - 25200*C*D1**2*f**2*fdd*r*s + 16800*C*D1**2*f**2*fdd*r - 12600*C*D1**2*f**2*fdd*s**2 + 16800*C*D1**2*f**2*fdd*s - 8400*C*D1**2*f**2*fdd - 25200*C*D1**2*f*fd**2*r**2 - 50400*C*D1**2*f*fd**2*r*s + 33600*C*D1**2*f*fd**2*r - 25200*C*D1**2*f*fd**2*s**2 + 33600*C*D1**2*f*fd**2*s - 8400*C*D1**2*f*fd**2 + 17424*C*D1*Dd*b1*f**2*r**2 + 34848*C*D1*Dd*b1*f**2*r*s - 26136*C*D1*Dd*b1*f**2*r + 17424*C*D1*Dd*b1*f**2*s**2 - 26136*C*D1*Dd*b1*f**2*s + 13068*C*D1*Dd*b1*f**2 - 79200*C*D1*Dd*b1*f*fd*r**2 - 158400*C*D1*Dd*b1*f*fd*r*s + 99000*C*D1*Dd*b1*f*fd*r - 79200*C*D1*Dd*b1*f*fd*s**2 + 99000*C*D1*Dd*b1*f*fd*s - 29700*C*D1*Dd*b1*f*fd + 15120*C*D1*Dd*f**3*r**2 + 30240*C*D1*Dd*f**3*r*s - 22680*C*D1*Dd*f**3*r + 15120*C*D1*Dd*f**3*s**2 - 22680*C*D1*Dd*f**3*s + 11340*C*D1*Dd*f**3 - 100800*C*D1*Dd*f**2*fd*r**2 - 201600*C*D1*Dd*f**2*fd*r*s + 142800*C*D1*Dd*f**2*fd*r - 100800*C*D1*Dd*f**2*fd*s**2 + 142800*C*D1*Dd*f**2*fd*s - 50400*C*D1*Dd*f**2*fd - 19800*C*D1*Ddd*b1*f**2*r**2 - 39600*C*D1*Ddd*b1*f**2*r*s + 29700*C*D1*Ddd*b1*f**2*r - 19800*C*D1*Ddd*b1*f**2*s**2 + 29700*C*D1*Ddd*b1*f**2*s - 14850*C*D1*Ddd*b1*f**2 - 16800*C*D1*Ddd*f**3*r**2 - 33600*C*D1*Ddd*f**3*r*s + 25200*C*D1*Ddd*f**3*r - 16800*C*D1*Ddd*f**3*s**2 + 25200*C*D1*Ddd*f**3*s - 12600*C*D1*Ddd*f**3 - 59400*C*Dd**2*b1*f**2*r**2 - 118800*C*Dd**2*b1*f**2*r*s + 89100*C*Dd**2*b1*f**2*r - 59400*C*Dd**2*b1*f**2*s**2 + 89100*C*Dd**2*b1*f**2*s - 29700*C*Dd**2*b1*f**2 - 50400*C*Dd**2*f**3*r**2 - 100800*C*Dd**2*f**3*r*s + 75600*C*Dd**2*f**3*r - 50400*C*Dd**2*f**3*s**2 + 75600*C*Dd**2*f**3*s - 25200*C*Dd**2*f**3 - 5676*D1**2*b1*f*fd*r**2 - 11352*D1**2*b1*f*fd*r*s + 5676*D1**2*b1*f*fd*r - 5676*D1**2*b1*f*fd*s**2 + 5676*D1**2*b1*f*fd*s - 2838*D1**2*b1*f*fd + 6600*D1**2*b1*f*fdd*r**2 + 13200*D1**2*b1*f*fdd*r*s - 6600*D1**2*b1*f*fdd*r + 6600*D1**2*b1*f*fdd*s**2 - 6600*D1**2*b1*f*fdd*s + 3300*D1**2*b1*f*fdd + 6600*D1**2*b1*fd**2*r**2 + 13200*D1**2*b1*fd**2*r*s - 6600*D1**2*b1*fd**2*r + 6600*D1**2*b1*fd**2*s**2 - 6600*D1**2*b1*fd**2*s - 1650*D1**2*bdd1*f**2*(3*C - 2)*(r + s - 1)**2 - 7395*D1**2*f**2*fd*r**2 - 14790*D1**2*f**2*fd*r*s + 9860*D1**2*f**2*fd*r - 7395*D1**2*f**2*fd*s**2 + 9860*D1**2*f**2*fd*s - 4930*D1**2*f**2*fd + 8400*D1**2*f**2*fdd*r**2 + 16800*D1**2*f**2*fdd*r*s - 11200*D1**2*f**2*fdd*r + 8400*D1**2*f**2*fdd*s**2 - 11200*D1**2*f**2*fdd*s + 5600*D1**2*f**2*fdd + 16800*D1**2*f*fd**2*r**2 + 33600*D1**2*f*fd**2*r*s - 22400*D1**2*f*fd**2*r + 16800*D1**2*f*fd**2*s**2 - 22400*D1**2*f*fd**2*s + 5600*D1**2*f*fd**2 - 11352*D1*Dd*b1*f**2*r**2 - 22704*D1*Dd*b1*f**2*r*s + 17028*D1*Dd*b1*f**2*r - 11352*D1*Dd*b1*f**2*s**2 + 17028*D1*Dd*b1*f**2*s - 8514*D1*Dd*b1*f**2 + 52800*D1*Dd*b1*f*fd*r**2 + 105600*D1*Dd*b1*f*fd*r*s - 66000*D1*Dd*b1*f*fd*r + 52800*D1*Dd*b1*f*fd*s**2 - 66000*D1*Dd*b1*f*fd*s + 19800*D1*Dd*b1*f*fd - 9860*D1*Dd*f**3*r**2 - 19720*D1*Dd*f**3*r*s + 14790*D1*Dd*f**3*r - 9860*D1*Dd*f**3*s**2 + 14790*D1*Dd*f**3*s - 7395*D1*Dd*f**3 + 67200*D1*Dd*f**2*fd*r**2 + 134400*D1*Dd*f**2*fd*r*s - 95200*D1*Dd*f**2*fd*r + 67200*D1*Dd*f**2*fd*s**2 - 95200*D1*Dd*f**2*fd*s + 33600*D1*Dd*f**2*fd + 13200*D1*Ddd*b1*f**2*r**2 + 26400*D1*Ddd*b1*f**2*r*s - 19800*D1*Ddd*b1*f**2*r + 13200*D1*Ddd*b1*f**2*s**2 - 19800*D1*Ddd*b1*f**2*s + 9900*D1*Ddd*b1*f**2 + 11200*D1*Ddd*f**3*r**2 + 22400*D1*Ddd*f**3*r*s - 16800*D1*Ddd*f**3*r + 11200*D1*Ddd*f**3*s**2 - 16800*D1*Ddd*f**3*s + 8400*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(66*C - 43)*(r + s - 1) - D1*fd*(150*C - 100)*(2*r + 2*s - 1) - Dd*f*(150*C - 100)*(4*r + 4*s - 3)) + 39600*Dd**2*b1*f**2*r**2 + 79200*Dd**2*b1*f**2*r*s - 59400*Dd**2*b1*f**2*r + 39600*Dd**2*b1*f**2*s**2 - 59400*Dd**2*b1*f**2*s + 19800*Dd**2*b1*f**2 + 33600*Dd**2*f**3*r**2 + 67200*Dd**2*f**3*r*s - 50400*Dd**2*f**3*r + 33600*Dd**2*f**3*s**2 - 50400*Dd**2*f**3*s + 16800*Dd**2*f**3)/(77*d**2*k3**7) + 4*D1**2*Pk1*Pkd3*ct**4*k1**4*(66*b1*(D1**2*(f*(fd*(26*C - 15) + fdd*(15 - 25*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(15 - 25*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(26*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(15 - 25*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(15 - 25*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(15 - 25*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(5*D1**2*(f*(fd*(296*C - 171)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (10*C - 6)*(33*bdd1*s*(r + s - 1) + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(168 - 280*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 66*D1*bd1*(D1*(f*s*(26*C - 15)*(r + s - 1) - fd*(25*C - 15)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(15 - 25*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + 5*D1*f*(Dd*(f*(296*C - 171)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(280*C - 168)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(168 - 280*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 5*Dd**2*f**2*(168 - 280*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**4*k1**2*k2**4*st**2*(29040*C*D1**2*b1*f*fd*r**2 + 58080*C*D1**2*b1*f*fd*r*s - 29040*C*D1**2*b1*f*fd*r + 29040*C*D1**2*b1*f*fd*s**2 - 29040*C*D1**2*b1*f*fd*s + 14520*C*D1**2*b1*f*fd - 17292*C*D1**2*b1*f*fdd*r**2 - 34584*C*D1**2*b1*f*fdd*r*s + 17292*C*D1**2*b1*f*fdd*r - 17292*C*D1**2*b1*f*fdd*s**2 + 17292*C*D1**2*b1*f*fdd*s - 8646*C*D1**2*b1*f*fdd - 17292*C*D1**2*b1*fd**2*r**2 - 34584*C*D1**2*b1*fd**2*r*s + 17292*C*D1**2*b1*fd**2*r - 17292*C*D1**2*b1*fd**2*s**2 + 17292*C*D1**2*b1*fd**2*s + 30984*C*D1**2*f**2*fd*r**2 + 61968*C*D1**2*f**2*fd*r*s - 41312*C*D1**2*f**2*fd*r + 30984*C*D1**2*f**2*fd*s**2 - 41312*C*D1**2*f**2*fd*s + 20656*C*D1**2*f**2*fd - 19650*C*D1**2*f**2*fdd*r**2 - 39300*C*D1**2*f**2*fdd*r*s + 26200*C*D1**2*f**2*fdd*r - 19650*C*D1**2*f**2*fdd*s**2 + 26200*C*D1**2*f**2*fdd*s - 13100*C*D1**2*f**2*fdd - 39300*C*D1**2*f*fd**2*r**2 - 78600*C*D1**2*f*fd**2*r*s + 52400*C*D1**2*f*fd**2*r - 39300*C*D1**2*f*fd**2*s**2 + 52400*C*D1**2*f*fd**2*s - 13100*C*D1**2*f*fd**2 + 58080*C*D1*Dd*b1*f**2*r**2 + 116160*C*D1*Dd*b1*f**2*r*s - 87120*C*D1*Dd*b1*f**2*r + 58080*C*D1*Dd*b1*f**2*s**2 - 87120*C*D1*Dd*b1*f**2*s + 43560*C*D1*Dd*b1*f**2 - 138336*C*D1*Dd*b1*f*fd*r**2 - 276672*C*D1*Dd*b1*f*fd*r*s + 172920*C*D1*Dd*b1*f*fd*r - 138336*C*D1*Dd*b1*f*fd*s**2 + 172920*C*D1*Dd*b1*f*fd*s - 51876*C*D1*Dd*b1*f*fd + 41312*C*D1*Dd*f**3*r**2 + 82624*C*D1*Dd*f**3*r*s - 61968*C*D1*Dd*f**3*r + 41312*C*D1*Dd*f**3*s**2 - 61968*C*D1*Dd*f**3*s + 30984*C*D1*Dd*f**3 - 157200*C*D1*Dd*f**2*fd*r**2 - 314400*C*D1*Dd*f**2*fd*r*s + 222700*C*D1*Dd*f**2*fd*r - 157200*C*D1*Dd*f**2*fd*s**2 + 222700*C*D1*Dd*f**2*fd*s - 78600*C*D1*Dd*f**2*fd - 34584*C*D1*Ddd*b1*f**2*r**2 - 69168*C*D1*Ddd*b1*f**2*r*s + 51876*C*D1*Ddd*b1*f**2*r - 34584*C*D1*Ddd*b1*f**2*s**2 + 51876*C*D1*Ddd*b1*f**2*s - 25938*C*D1*Ddd*b1*f**2 - 26200*C*D1*Ddd*f**3*r**2 - 52400*C*D1*Ddd*f**3*r*s + 39300*C*D1*Ddd*f**3*r - 26200*C*D1*Ddd*f**3*s**2 + 39300*C*D1*Ddd*f**3*s - 19650*C*D1*Ddd*f**3 - 103752*C*Dd**2*b1*f**2*r**2 - 207504*C*Dd**2*b1*f**2*r*s + 155628*C*Dd**2*b1*f**2*r - 103752*C*Dd**2*b1*f**2*s**2 + 155628*C*Dd**2*b1*f**2*s - 51876*C*Dd**2*b1*f**2 - 78600*C*Dd**2*f**3*r**2 - 157200*C*Dd**2*f**3*r*s + 117900*C*Dd**2*f**3*r - 78600*C*Dd**2*f**3*s**2 + 117900*C*Dd**2*f**3*s - 39300*C*Dd**2*f**3 - 22572*D1**2*b1*f*fd*r**2 - 45144*D1**2*b1*f*fd*r*s + 22572*D1**2*b1*f*fd*r - 22572*D1**2*b1*f*fd*s**2 + 22572*D1**2*b1*f*fd*s - 11286*D1**2*b1*f*fd + 13662*D1**2*b1*f*fdd*r**2 + 27324*D1**2*b1*f*fdd*r*s - 13662*D1**2*b1*f*fdd*r + 13662*D1**2*b1*f*fdd*s**2 - 13662*D1**2*b1*f*fdd*s + 6831*D1**2*b1*f*fdd + 13662*D1**2*b1*fd**2*r**2 + 27324*D1**2*b1*fd**2*r*s - 13662*D1**2*b1*fd**2*r + 13662*D1**2*b1*fd**2*s**2 - 13662*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(262*C - 207)*(r + s - 1)**2 - 23922*D1**2*f**2*fd*r**2 - 47844*D1**2*f**2*fd*r*s + 31896*D1**2*f**2*fd*r - 23922*D1**2*f**2*fd*s**2 + 31896*D1**2*f**2*fd*s - 15948*D1**2*f**2*fd + 15525*D1**2*f**2*fdd*r**2 + 31050*D1**2*f**2*fdd*r*s - 20700*D1**2*f**2*fdd*r + 15525*D1**2*f**2*fdd*s**2 - 20700*D1**2*f**2*fdd*s + 10350*D1**2*f**2*fdd + 31050*D1**2*f*fd**2*r**2 + 62100*D1**2*f*fd**2*r*s - 41400*D1**2*f*fd**2*r + 31050*D1**2*f*fd**2*s**2 - 41400*D1**2*f*fd**2*s + 10350*D1**2*f*fd**2 - 45144*D1*Dd*b1*f**2*r**2 - 90288*D1*Dd*b1*f**2*r*s + 67716*D1*Dd*b1*f**2*r - 45144*D1*Dd*b1*f**2*s**2 + 67716*D1*Dd*b1*f**2*s - 33858*D1*Dd*b1*f**2 + 109296*D1*Dd*b1*f*fd*r**2 + 218592*D1*Dd*b1*f*fd*r*s - 136620*D1*Dd*b1*f*fd*r + 109296*D1*Dd*b1*f*fd*s**2 - 136620*D1*Dd*b1*f*fd*s + 40986*D1*Dd*b1*f*fd - 31896*D1*Dd*f**3*r**2 - 63792*D1*Dd*f**3*r*s + 47844*D1*Dd*f**3*r - 31896*D1*Dd*f**3*s**2 + 47844*D1*Dd*f**3*s - 23922*D1*Dd*f**3 + 124200*D1*Dd*f**2*fd*r**2 + 248400*D1*Dd*f**2*fd*r*s - 175950*D1*Dd*f**2*fd*r + 124200*D1*Dd*f**2*fd*s**2 - 175950*D1*Dd*f**2*fd*s + 62100*D1*Dd*f**2*fd + 27324*D1*Ddd*b1*f**2*r**2 + 54648*D1*Ddd*b1*f**2*r*s - 40986*D1*Ddd*b1*f**2*r + 27324*D1*Ddd*b1*f**2*s**2 - 40986*D1*Ddd*b1*f**2*s + 20493*D1*Ddd*b1*f**2 + 20700*D1*Ddd*f**3*r**2 + 41400*D1*Ddd*f**3*r*s - 31050*D1*Ddd*f**3*r + 20700*D1*Ddd*f**3*s**2 - 31050*D1*Ddd*f**3*s + 15525*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(D1*f*(220*C - 171)*(r + s - 1) - D1*fd*(262*C - 207)*(2*r + 2*s - 1) - Dd*f*(262*C - 207)*(4*r + 4*s - 3)) + 81972*Dd**2*b1*f**2*r**2 + 163944*Dd**2*b1*f**2*r*s - 122958*Dd**2*b1*f**2*r + 81972*Dd**2*b1*f**2*s**2 - 122958*Dd**2*b1*f**2*s + 40986*Dd**2*b1*f**2 + 62100*Dd**2*f**3*r**2 + 124200*Dd**2*f**3*r*s - 93150*Dd**2*f**3*r + 62100*Dd**2*f**3*s**2 - 93150*Dd**2*f**3*s + 31050*Dd**2*f**3)/(154*d**2*k3**7) - 3*D1**2*Pk1*Pkd3*ct**4*k1**2*k2**4*(25740*C*D1**2*f**2*fd*r**2 + 51480*C*D1**2*f**2*fd*r*s - 34320*C*D1**2*f**2*fd*r + 25740*C*D1**2*f**2*fd*s**2 - 34320*C*D1**2*f**2*fd*s + 17160*C*D1**2*f**2*fd + 34320*C*D1*Dd*f**3*r**2 + 68640*C*D1*Dd*f**3*r*s - 51480*C*D1*Dd*f**3*r + 34320*C*D1*Dd*f**3*s**2 - 51480*C*D1*Dd*f**3*s + 25740*C*D1*Dd*f**3 + 10725*D1**2*K*bdd1*f**2*r**2 + 21450*D1**2*K*bdd1*f**2*r*s - 21450*D1**2*K*bdd1*f**2*r + 10725*D1**2*K*bdd1*f**2*s**2 - 21450*D1**2*K*bdd1*f**2*s + 10725*D1**2*K*bdd1*f**2 - 2860*D1**2*bd1**2*f*(-9*K + 5*f + 6)*(r + s - 1)**2 - 7150*D1**2*bdd1*f**2*r**2 - 14300*D1**2*bdd1*f**2*r*s + 14300*D1**2*bdd1*f**2*r - 7150*D1**2*bdd1*f**2*s**2 + 14300*D1**2*bdd1*f**2*s - 7150*D1**2*bdd1*f**2 - 25740*D1**2*bdd1*f*g2*r**2 - 51480*D1**2*bdd1*f*g2*r*s + 51480*D1**2*bdd1*f*g2*r - 25740*D1**2*bdd1*f*g2*s**2 + 51480*D1**2*bdd1*f*g2*s - 25740*D1**2*bdd1*f*g2 - 20160*D1**2*f**3*fd*r**2 - 40320*D1**2*f**3*fd*r*s + 30240*D1**2*f**3*fd*r - 20160*D1**2*f**3*fd*s**2 + 30240*D1**2*f**3*fd*s - 15120*D1**2*f**3*fd + 21000*D1**2*f**3*fdd*r**2 + 42000*D1**2*f**3*fdd*r*s - 31500*D1**2*f**3*fdd*r + 21000*D1**2*f**3*fdd*s**2 - 31500*D1**2*f**3*fdd*s + 15750*D1**2*f**3*fdd + 63000*D1**2*f**2*fd**2*r**2 + 126000*D1**2*f**2*fd**2*r*s - 94500*D1**2*f**2*fd**2*r + 63000*D1**2*f**2*fd**2*s**2 - 94500*D1**2*f**2*fd**2*s + 31500*D1**2*f**2*fd**2 - 19305*D1**2*f**2*fd*r**2 - 38610*D1**2*f**2*fd*r*s + 25740*D1**2*f**2*fd*r - 19305*D1**2*f**2*fd*s**2 + 25740*D1**2*f**2*fd*s - 12870*D1**2*f**2*fd + 27456*D1**2*f**2*gd2*r**2 + 54912*D1**2*f**2*gd2*r*s - 54912*D1**2*f**2*gd2*r + 27456*D1**2*f**2*gd2*s**2 - 54912*D1**2*f**2*gd2*s + 27456*D1**2*f**2*gd2 - 21450*D1**2*f**2*gdd2*r**2 - 42900*D1**2*f**2*gdd2*r*s + 42900*D1**2*f**2*gdd2*r - 21450*D1**2*f**2*gdd2*s**2 + 42900*D1**2*f**2*gdd2*s - 21450*D1**2*f**2*gdd2 + 54912*D1**2*f*fd*g2*r**2 + 109824*D1**2*f*fd*g2*r*s - 54912*D1**2*f*fd*g2*r + 54912*D1**2*f*fd*g2*s**2 - 54912*D1**2*f*fd*g2*s + 27456*D1**2*f*fd*g2 - 85800*D1**2*f*fd*gd2*r**2 - 171600*D1**2*f*fd*gd2*r*s + 128700*D1**2*f*fd*gd2*r - 85800*D1**2*f*fd*gd2*s**2 + 128700*D1**2*f*fd*gd2*s - 42900*D1**2*f*fd*gd2 - 42900*D1**2*f*fdd*g2*r**2 - 85800*D1**2*f*fdd*g2*r*s + 42900*D1**2*f*fdd*g2*r - 42900*D1**2*f*fdd*g2*s**2 + 42900*D1**2*f*fdd*g2*s - 21450*D1**2*f*fdd*g2 - 42900*D1**2*fd**2*g2*r**2 - 85800*D1**2*fd**2*g2*r*s + 42900*D1**2*fd**2*g2*r - 42900*D1**2*fd**2*g2*s**2 + 42900*D1**2*fd**2*g2*s - 20160*D1*Dd*f**4*r**2 - 40320*D1*Dd*f**4*r*s + 30240*D1*Dd*f**4*r - 20160*D1*Dd*f**4*s**2 + 30240*D1*Dd*f**4*s - 15120*D1*Dd*f**4 + 168000*D1*Dd*f**3*fd*r**2 + 336000*D1*Dd*f**3*fd*r*s - 252000*D1*Dd*f**3*fd*r + 168000*D1*Dd*f**3*fd*s**2 - 252000*D1*Dd*f**3*fd*s + 94500*D1*Dd*f**3*fd - 25740*D1*Dd*f**3*r**2 - 51480*D1*Dd*f**3*r*s + 38610*D1*Dd*f**3*r - 25740*D1*Dd*f**3*s**2 + 38610*D1*Dd*f**3*s - 19305*D1*Dd*f**3 + 109824*D1*Dd*f**2*g2*r**2 + 219648*D1*Dd*f**2*g2*r*s - 164736*D1*Dd*f**2*g2*r + 109824*D1*Dd*f**2*g2*s**2 - 164736*D1*Dd*f**2*g2*s + 82368*D1*Dd*f**2*g2 - 171600*D1*Dd*f**2*gd2*r**2 - 343200*D1*Dd*f**2*gd2*r*s + 300300*D1*Dd*f**2*gd2*r - 171600*D1*Dd*f**2*gd2*s**2 + 300300*D1*Dd*f**2*gd2*s - 128700*D1*Dd*f**2*gd2 - 343200*D1*Dd*f*fd*g2*r**2 - 686400*D1*Dd*f*fd*g2*r*s + 429000*D1*Dd*f*fd*g2*r - 343200*D1*Dd*f*fd*g2*s**2 + 429000*D1*Dd*f*fd*g2*s - 128700*D1*Dd*f*fd*g2 + 21000*D1*Ddd*f**4*r**2 + 42000*D1*Ddd*f**4*r*s - 31500*D1*Ddd*f**4*r + 21000*D1*Ddd*f**4*s**2 - 31500*D1*Ddd*f**4*s + 15750*D1*Ddd*f**4 - 85800*D1*Ddd*f**2*g2*r**2 - 171600*D1*Ddd*f**2*g2*r*s + 128700*D1*Ddd*f**2*g2*r - 85800*D1*Ddd*f**2*g2*s**2 + 128700*D1*Ddd*f**2*g2*s - 64350*D1*Ddd*f**2*g2 + 286*D1*bd1*(D1*(5*f**3*(r + s - 1) + 2*f**2*(18*C - 24*K + 1)*(r + s - 1) + 25*f*fd*(3*K - 2)*(2*r + 2*s - 1) + 9*f*(13*g2 - 20*gd2)*(r + s - 1) - 180*fd*g2*(r + s)) + 5*Dd*f*(5*f*(3*K - 2) - 36*g2)*(4*r + 4*s - 3))*(r + s - 1) + 63000*Dd**2*f**4*r**2 + 126000*Dd**2*f**4*r*s - 94500*Dd**2*f**4*r + 63000*Dd**2*f**4*s**2 - 94500*Dd**2*f**4*s + 31500*Dd**2*f**4 - 257400*Dd**2*f**2*g2*r**2 - 514800*Dd**2*f**2*g2*r*s + 386100*Dd**2*f**2*g2*r - 257400*Dd**2*f**2*g2*s**2 + 386100*Dd**2*f**2*g2*s - 128700*Dd**2*f**2*g2 + 143*b1**2*(D1**2*(2*f*(29*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(117*K - 71)*(r + s) - 30*fdd*(3*K - 2)*(r + s))) + D1*(Dd*(58*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (117*K - 71)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*fd*(3*K - 2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 10*Ddd*f*(-9*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f*(-9*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 143*b1*(144*C*D1**2*f*fd*r**2 + 288*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*r + 144*C*D1**2*f*fd*s**2 - 144*C*D1**2*f*fd*s + 72*C*D1**2*f*fd + 288*C*D1*Dd*f**2*r**2 + 576*C*D1*Dd*f**2*r*s - 432*C*D1*Dd*f**2*r + 288*C*D1*Dd*f**2*s**2 - 432*C*D1*Dd*f**2*s + 216*C*D1*Dd*f**2 - 192*D1**2*K*f*fd*r**2 - 384*D1**2*K*f*fd*r*s + 192*D1**2*K*f*fd*r - 192*D1**2*K*f*fd*s**2 + 192*D1**2*K*f*fd*s - 96*D1**2*K*f*fd + 150*D1**2*K*f*fdd*r**2 + 300*D1**2*K*f*fdd*r*s - 150*D1**2*K*f*fdd*r + 150*D1**2*K*f*fdd*s**2 - 150*D1**2*K*f*fdd*s + 75*D1**2*K*f*fdd + 150*D1**2*K*fd**2*r**2 + 300*D1**2*K*fd**2*r*s - 150*D1**2*K*fd**2*r + 150*D1**2*K*fd**2*s**2 - 150*D1**2*K*fd**2*s - 20*D1**2*bdd1*f*(-9*K + 5*f + 6)*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 100*D1**2*f*fdd*r**2 - 200*D1**2*f*fdd*r*s + 100*D1**2*f*fdd*r - 100*D1**2*f*fdd*s**2 + 100*D1**2*f*fdd*s - 50*D1**2*f*fdd + 234*D1**2*f*gd2*r**2 + 468*D1**2*f*gd2*r*s - 468*D1**2*f*gd2*r + 234*D1**2*f*gd2*s**2 - 468*D1**2*f*gd2*s + 234*D1**2*f*gd2 - 180*D1**2*f*gdd2*r**2 - 360*D1**2*f*gdd2*r*s + 360*D1**2*f*gdd2*r - 180*D1**2*f*gdd2*s**2 + 360*D1**2*f*gdd2*s - 180*D1**2*f*gdd2 - 100*D1**2*fd**2*r**2 - 200*D1**2*fd**2*r*s + 100*D1**2*fd**2*r - 100*D1**2*fd**2*s**2 + 100*D1**2*fd**2*s + 234*D1**2*fd*g2*r**2 + 468*D1**2*fd*g2*r*s + 234*D1**2*fd*g2*s**2 - 360*D1**2*fd*gd2*r**2 - 720*D1**2*fd*gd2*r*s + 360*D1**2*fd*gd2*r - 360*D1**2*fd*gd2*s**2 + 360*D1**2*fd*gd2*s - 180*D1**2*fdd*g2*r**2 - 360*D1**2*fdd*g2*r*s - 180*D1**2*fdd*g2*s**2 - 384*D1*Dd*K*f**2*r**2 - 768*D1*Dd*K*f**2*r*s + 576*D1*Dd*K*f**2*r - 384*D1*Dd*K*f**2*s**2 + 576*D1*Dd*K*f**2*s - 288*D1*Dd*K*f**2 + 1200*D1*Dd*K*f*fd*r**2 + 2400*D1*Dd*K*f*fd*r*s - 1500*D1*Dd*K*f*fd*r + 1200*D1*Dd*K*f*fd*s**2 - 1500*D1*Dd*K*f*fd*s + 450*D1*Dd*K*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 800*D1*Dd*f*fd*r**2 - 1600*D1*Dd*f*fd*r*s + 1000*D1*Dd*f*fd*r - 800*D1*Dd*f*fd*s**2 + 1000*D1*Dd*f*fd*s - 300*D1*Dd*f*fd + 936*D1*Dd*f*g2*r**2 + 1872*D1*Dd*f*g2*r*s - 1404*D1*Dd*f*g2*r + 936*D1*Dd*f*g2*s**2 - 1404*D1*Dd*f*g2*s + 702*D1*Dd*f*g2 - 1440*D1*Dd*f*gd2*r**2 - 2880*D1*Dd*f*gd2*r*s + 2520*D1*Dd*f*gd2*r - 1440*D1*Dd*f*gd2*s**2 + 2520*D1*Dd*f*gd2*s - 1080*D1*Dd*f*gd2 - 1440*D1*Dd*fd*g2*r**2 - 2880*D1*Dd*fd*g2*r*s + 1080*D1*Dd*fd*g2*r - 1440*D1*Dd*fd*g2*s**2 + 1080*D1*Dd*fd*g2*s + 300*D1*Ddd*K*f**2*r**2 + 600*D1*Ddd*K*f**2*r*s - 450*D1*Ddd*K*f**2*r + 300*D1*Ddd*K*f**2*s**2 - 450*D1*Ddd*K*f**2*s + 225*D1*Ddd*K*f**2 - 200*D1*Ddd*f**2*r**2 - 400*D1*Ddd*f**2*r*s + 300*D1*Ddd*f**2*r - 200*D1*Ddd*f**2*s**2 + 300*D1*Ddd*f**2*s - 150*D1*Ddd*f**2 - 720*D1*Ddd*f*g2*r**2 - 1440*D1*Ddd*f*g2*r*s + 1080*D1*Ddd*f*g2*r - 720*D1*Ddd*f*g2*s**2 + 1080*D1*Ddd*f*g2*s - 540*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(58*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(117*K - 71)*(r + s - 1) + 60*fd*(3*K - 2)*(r + s)) - 20*Dd*f*(-9*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 900*Dd**2*K*f**2*r**2 + 1800*Dd**2*K*f**2*r*s - 1350*Dd**2*K*f**2*r + 900*Dd**2*K*f**2*s**2 - 1350*Dd**2*K*f**2*s + 450*Dd**2*K*f**2 - 600*Dd**2*f**2*r**2 - 1200*Dd**2*f**2*r*s + 900*Dd**2*f**2*r - 600*Dd**2*f**2*s**2 + 900*Dd**2*f**2*s - 300*Dd**2*f**2 - 2160*Dd**2*f*g2*r**2 - 4320*Dd**2*f*g2*r*s + 3240*Dd**2*f*g2*r - 2160*Dd**2*f*g2*s**2 + 3240*Dd**2*f*g2*s - 1080*Dd**2*f*g2))/(1001*d**2*k3**7) + 2*D1**2*Pk1*Pkd3*ct**4*k1**2*k2**2*st**2*(33*b1*(D1**2*(f*(fd*(112*C - 84) + fdd*(47 - 62*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - fd**2*(62*C - 47)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(112*C - 84)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(62*C - 47)*(2*s - 1)*(8*r + 8*s - 5)) - Ddd*f*(62*C - 47)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f**2*(62*C - 47)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(2704*C - 2020)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (62*C - 47)*(33*bdd1*s*(r + s - 1) + 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(1175 - 1550*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(f*s*(112*C - 84)*(r + s - 1) - fd*(62*C - 47)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(62*C - 47)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(2704*C - 2020)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(1550*C - 1175)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(1175 - 1550*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(1175 - 1550*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**4*k1**2*k2**2*(330*b1**2*(D1**2*(fd*(37*C - 26) + fdd*(27 - 36*C))*(r + s - 1)**2 + D1*(Dd*(f*(37*C - 26)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(54 - 72*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(27 - 36*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(216*C - 162)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-912*C*D1**2*f*fd*r**2 - 3264*C*D1**2*f*fd*r*s + 1032*C*D1**2*f*fd*r - 2352*C*D1**2*f*fd*s**2 + 1752*C*D1**2*f*fd*s - 876*C*D1**2*f*fd + 1200*C*D1**2*f*fdd*r**2 + 3360*C*D1**2*f*fdd*r*s - 1080*C*D1**2*f*fdd*r + 2160*C*D1**2*f*fdd*s**2 - 1560*C*D1**2*f*fdd*s + 780*C*D1**2*f*fdd + 1200*C*D1**2*fd**2*r**2 + 3360*C*D1**2*fd**2*r*s - 1080*C*D1**2*fd**2*r + 2160*C*D1**2*fd**2*s**2 - 1560*C*D1**2*fd**2*s - 600*C*D1**2*fd**2 - 1824*C*D1*Dd*f**2*r**2 - 6528*C*D1*Dd*f**2*r*s + 4176*C*D1*Dd*f**2*r - 4704*C*D1*Dd*f**2*s**2 + 6336*C*D1*Dd*f**2*s - 2808*C*D1*Dd*f**2 + 9600*C*D1*Dd*f*fd*r**2 + 26880*C*D1*Dd*f*fd*r*s - 13440*C*D1*Dd*f*fd*r + 17280*C*D1*Dd*f*fd*s**2 - 18240*C*D1*Dd*f*fd*s + 4200*C*D1*Dd*f*fd + 2400*C*D1*Ddd*f**2*r**2 + 6720*C*D1*Ddd*f**2*r*s - 4560*C*D1*Ddd*f**2*r + 4320*C*D1*Ddd*f**2*s**2 - 6000*C*D1*Ddd*f**2*s + 2760*C*D1*Ddd*f**2 + 7200*C*Dd**2*f**2*r**2 + 20160*C*Dd**2*f**2*r*s - 13680*C*Dd**2*f**2*r + 12960*C*Dd**2*f**2*s**2 - 18000*C*Dd**2*f**2*s + 5520*C*Dd**2*f**2 - 90*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 676*D1**2*f*fd*r**2 + 2576*D1**2*f*fd*r*s - 868*D1**2*f*fd*r + 1900*D1**2*f*fd*s**2 - 1480*D1**2*f*fd*s + 740*D1**2*f*fd - 890*D1**2*f*fdd*r**2 - 2668*D1**2*f*fdd*r*s + 884*D1**2*f*fdd*r - 1778*D1**2*f*fdd*s**2 + 1328*D1**2*f*fdd*s - 664*D1**2*f*fdd - 890*D1**2*fd**2*r**2 - 2668*D1**2*fd**2*r*s + 884*D1**2*fd**2*r - 1778*D1**2*fd**2*s**2 + 1328*D1**2*fd**2*s + 450*D1**2*fd**2 + 1352*D1*Dd*f**2*r**2 + 5152*D1*Dd*f**2*r*s - 3252*D1*Dd*f**2*r + 3800*D1*Dd*f**2*s**2 - 5088*D1*Dd*f**2*s + 2238*D1*Dd*f**2 - 7120*D1*Dd*f*fd*r**2 - 21344*D1*Dd*f*fd*r*s + 10652*D1*Dd*f*fd*r - 14224*D1*Dd*f*fd*s**2 + 15092*D1*Dd*f*fd*s - 3540*D1*Dd*f*fd - 1780*D1*Ddd*f**2*r**2 - 5336*D1*Ddd*f**2*r*s + 3558*D1*Ddd*f**2*r - 3556*D1*Ddd*f**2*s**2 + 4890*D1*Ddd*f**2*s - 2223*D1*Ddd*f**2 + 10*D1*bd1*(D1*(f*(37*C - 26)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(54 - 72*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(54 - 72*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5340*Dd**2*f**2*r**2 - 16008*Dd**2*f**2*r*s + 10674*Dd**2*f**2*r - 10668*Dd**2*f**2*s**2 + 14670*Dd**2*f**2*s - 4446*Dd**2*f**2) + f*(-5940*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(60*C*(10*r**2 + 28*r*s - 30*r + 18*s**2 - 38*s + 15) - 445*r**2 - 1334*r*s + 1340*r - 889*s**2 + 1784*s - 670) - 5*D1**2*(f*(2*fd*(C*(7599*r**2 + 6*r*(3323*s - 1952) + 12339*s**2 - 14872*s + 6646) - 5481*r**2 - 15189*r*s + 8717*r - 9708*s**2 + 11535*s - 5063) + fdd*(-28*C*(579*r**2 + 1398*r*s - 852*r + 819*s**2 - 1012*s + 466) + 12015*r**2 + 30534*r*s - 18188*r + 18519*s**2 - 22524*s + 10178)) + 2*fd**2*(-28*C*(579*r**2 + 1398*r*s - 852*r + 819*s**2 - 1012*s + 233) + 12015*r**2 + 30534*r*s - 18188*r + 18519*s**2 - 22524*s + 5089)) - 66*D1*bd1*(D1*(f*(6*C*(38*r**2 + 2*r*(68*s - 63) + 98*s**2 - 186*s + 63) - 169*r**2 - 644*r*s + 548*r - 475*s**2 + 854*s - 274) - 2*fd*(30*C*(20*r**2 + 56*r*s - 39*r + 36*s**2 - 51*s + 19) - 445*r**2 - 1334*r*s + 891*r - 889*s**2 + 1224*s - 446)) + Dd*f*(-60*C*(40*r**2 + 14*r*(8*s - 7) + 72*s**2 - 126*s + 53) + 1780*r**2 + 5336*r*s - 4459*r + 3556*s**2 - 6013*s + 2454)) - 5*D1*f*(2*Dd*(f*(C*(10132*r**2 + 26584*r*s - 18358*r + 16452*s**2 - 23098*s + 10759) - 7308*r**2 - 20252*r*s + 13780*r - 12944*s**2 + 18007*s - 8299) + fd*(-28*C*(2316*r**2 + 5592*r*s - 3681*r + 3276*s**2 - 4361*s + 1438) + 48060*r**2 + 122136*r*s - 78925*r + 74076*s**2 - 97353*s + 31618)) + Ddd*f*(-28*C*(772*r**2 + 2*r*(932*s - 659) + 1092*s**2 - 1558*s + 739) + 16020*r**2 + 40712*r*s - 28366*r + 24692*s**2 - 34870*s + 16351)) + 10*Dd**2*f**2*(28*C*(1158*r**2 + 3*r*(932*s - 659) + 1638*s**2 - 2337*s + 739) - 24030*r**2 - 61068*r*s + 42549*r - 37038*s**2 + 52305*s - 16351)))/(693*d**2*k3**5) + 4*D1**2*Pk1*Pkd3*ct**4*k1**2*(33*D1*b1*(2*D1*(f*fd*s*(11 - 18*C) + f*s*(3*C - 2)*(-6*bdd1*(2*r + 2*s - 1) + 5*fdd) + fd**2*(15*C - 10)*(s - 1)) + Dd*f*fd*(60*C - 40)*(2*s - 1) + bd1*(D1*(f*s*(44*C - 27)*(2*r + 2*s - 1) - fd*(36*C - 24)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(48 - 72*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1))) + 33*b1**2*(D1**2*(s - 1)*(fd*(44*C - 27) + fdd*(24 - 36*C))*(r + s - 1) + D1*(Dd*(f*(44*C - 27)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(36*C - 24)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(24 - 36*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(36*C - 24)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-396*D1**2*bd1**2*s*(3*C - 2)*(2*r + 2*s - 1) - 5*D1**2*(f*(fd*(204*C - 125)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (6*C - 4)*(-33*bdd1*s + 28*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(112 - 168*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 66*D1*bd1*(D1*f*s*(18*C - 11) + D1*fd*(10 - 15*C)*(s - 1) - Dd*f*(30*C - 20)*(2*s - 1)) - 5*D1*f*(Dd*(f*(204*C - 125)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(168*C - 112)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(112 - 168*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(112 - 168*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**4*k2**6*st**2*(-15444*C*D1**2*f**2*fd*r**2 - 30888*C*D1**2*f**2*fd*r*s + 20592*C*D1**2*f**2*fd*r - 15444*C*D1**2*f**2*fd*s**2 + 20592*C*D1**2*f**2*fd*s - 10296*C*D1**2*f**2*fd - 20592*C*D1*Dd*f**3*r**2 - 41184*C*D1*Dd*f**3*r*s + 30888*C*D1*Dd*f**3*r - 20592*C*D1*Dd*f**3*s**2 + 30888*C*D1*Dd*f**3*s - 15444*C*D1*Dd*f**3 - 2574*D1**2*K*bdd1*f**2*r**2 - 5148*D1**2*K*bdd1*f**2*r*s + 5148*D1**2*K*bdd1*f**2*r - 2574*D1**2*K*bdd1*f**2*s**2 + 5148*D1**2*K*bdd1*f**2*s - 2574*D1**2*K*bdd1*f**2 + 2574*D1**2*bd1**2*f*(-2*K + 5*f + 2)*(r + s - 1)**2 - 19500*D1**2*bdd1*f**3*r**2 - 39000*D1**2*bdd1*f**3*r*s + 39000*D1**2*bdd1*f**3*r - 19500*D1**2*bdd1*f**3*s**2 + 39000*D1**2*bdd1*f**3*s - 19500*D1**2*bdd1*f**3 + 2574*D1**2*bdd1*f**2*r**2 + 5148*D1**2*bdd1*f**2*r*s - 5148*D1**2*bdd1*f**2*r + 2574*D1**2*bdd1*f**2*s**2 - 5148*D1**2*bdd1*f**2*s + 2574*D1**2*bdd1*f**2 + 5148*D1**2*bdd1*f*g2*r**2 + 10296*D1**2*bdd1*f*g2*r*s - 10296*D1**2*bdd1*f*g2*r + 5148*D1**2*bdd1*f*g2*s**2 - 10296*D1**2*bdd1*f*g2*s + 5148*D1**2*bdd1*f*g2 + 121000*D1**2*f**3*fd*r**2 + 242000*D1**2*f**3*fd*r*s - 181500*D1**2*f**3*fd*r + 121000*D1**2*f**3*fd*s**2 - 181500*D1**2*f**3*fd*s + 90750*D1**2*f**3*fd - 73500*D1**2*f**3*fdd*r**2 - 147000*D1**2*f**3*fdd*r*s + 110250*D1**2*f**3*fdd*r - 73500*D1**2*f**3*fdd*s**2 + 110250*D1**2*f**3*fdd*s - 55125*D1**2*f**3*fdd - 220500*D1**2*f**2*fd**2*r**2 - 441000*D1**2*f**2*fd**2*r*s + 330750*D1**2*f**2*fd**2*r - 220500*D1**2*f**2*fd**2*s**2 + 330750*D1**2*f**2*fd**2*s - 110250*D1**2*f**2*fd**2 + 15444*D1**2*f**2*fd*r**2 + 30888*D1**2*f**2*fd*r*s - 20592*D1**2*f**2*fd*r + 15444*D1**2*f**2*fd*s**2 - 20592*D1**2*f**2*fd*s + 10296*D1**2*f**2*fd - 10296*D1**2*f**2*gd2*r**2 - 20592*D1**2*f**2*gd2*r*s + 20592*D1**2*f**2*gd2*r - 10296*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s - 10296*D1**2*f**2*gd2 + 5148*D1**2*f**2*gdd2*r**2 + 10296*D1**2*f**2*gdd2*r*s - 10296*D1**2*f**2*gdd2*r + 5148*D1**2*f**2*gdd2*s**2 - 10296*D1**2*f**2*gdd2*s + 5148*D1**2*f**2*gdd2 - 20592*D1**2*f*fd*g2*r**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 20592*D1**2*f*fd*g2*s**2 + 20592*D1**2*f*fd*g2*s - 10296*D1**2*f*fd*g2 + 20592*D1**2*f*fd*gd2*r**2 + 41184*D1**2*f*fd*gd2*r*s - 30888*D1**2*f*fd*gd2*r + 20592*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 10296*D1**2*f*fd*gd2 + 10296*D1**2*f*fdd*g2*r**2 + 20592*D1**2*f*fdd*g2*r*s - 10296*D1**2*f*fdd*g2*r + 10296*D1**2*f*fdd*g2*s**2 - 10296*D1**2*f*fdd*g2*s + 5148*D1**2*f*fdd*g2 + 10296*D1**2*fd**2*g2*r**2 + 20592*D1**2*fd**2*g2*r*s - 10296*D1**2*fd**2*g2*r + 10296*D1**2*fd**2*g2*s**2 - 10296*D1**2*fd**2*g2*s + 121000*D1*Dd*f**4*r**2 + 242000*D1*Dd*f**4*r*s - 181500*D1*Dd*f**4*r + 121000*D1*Dd*f**4*s**2 - 181500*D1*Dd*f**4*s + 90750*D1*Dd*f**4 - 588000*D1*Dd*f**3*fd*r**2 - 1176000*D1*Dd*f**3*fd*r*s + 882000*D1*Dd*f**3*fd*r - 588000*D1*Dd*f**3*fd*s**2 + 882000*D1*Dd*f**3*fd*s - 330750*D1*Dd*f**3*fd + 20592*D1*Dd*f**3*r**2 + 41184*D1*Dd*f**3*r*s - 30888*D1*Dd*f**3*r + 20592*D1*Dd*f**3*s**2 - 30888*D1*Dd*f**3*s + 15444*D1*Dd*f**3 - 41184*D1*Dd*f**2*g2*r**2 - 82368*D1*Dd*f**2*g2*r*s + 61776*D1*Dd*f**2*g2*r - 41184*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 30888*D1*Dd*f**2*g2 + 41184*D1*Dd*f**2*gd2*r**2 + 82368*D1*Dd*f**2*gd2*r*s - 72072*D1*Dd*f**2*gd2*r + 41184*D1*Dd*f**2*gd2*s**2 - 72072*D1*Dd*f**2*gd2*s + 30888*D1*Dd*f**2*gd2 + 82368*D1*Dd*f*fd*g2*r**2 + 164736*D1*Dd*f*fd*g2*r*s - 102960*D1*Dd*f*fd*g2*r + 82368*D1*Dd*f*fd*g2*s**2 - 102960*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 73500*D1*Ddd*f**4*r**2 - 147000*D1*Ddd*f**4*r*s + 110250*D1*Ddd*f**4*r - 73500*D1*Ddd*f**4*s**2 + 110250*D1*Ddd*f**4*s - 55125*D1*Ddd*f**4 + 20592*D1*Ddd*f**2*g2*r**2 + 41184*D1*Ddd*f**2*g2*r*s - 30888*D1*Ddd*f**2*g2*r + 20592*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 15444*D1*Ddd*f**2*g2 - 156*D1*bd1*(r + s - 1)*(33*C*D1*f**2*(r + s - 1) - D1*(195*f**3*(r + s - 1) + f**2*(33*K*(r + s - 1) - 250*fd*(3*r + 3*s - 2)) - 33*f*(fd*(K - 1)*(2*r + 2*s - 1) + (2*g2 - 2*gd2)*(r + s - 1)) + 66*fd*g2*(r + s)) + Dd*f*(250*f**2 + 33*f*(K - 1) - 66*g2)*(4*r + 4*s - 3)) - 220500*Dd**2*f**4*r**2 - 441000*Dd**2*f**4*r*s + 330750*Dd**2*f**4*r - 220500*Dd**2*f**4*s**2 + 330750*Dd**2*f**4*s - 110250*Dd**2*f**4 + 61776*Dd**2*f**2*g2*r**2 + 123552*Dd**2*f**2*g2*r*s - 92664*Dd**2*f**2*g2*r + 61776*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 30888*Dd**2*f**2*g2 - 1287*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(5*fd**2*(r + s - 1) + 2*fd*(K - 1)*(r + s) - fdd*(K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (2*K - 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-2*K + 5*f + 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-2*K + 5*f + 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 78*b1*(132*C*D1**2*f*fd*r**2 + 264*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*r + 132*C*D1**2*f*fd*s**2 - 132*C*D1**2*f*fd*s + 66*C*D1**2*f*fd + 264*C*D1*Dd*f**2*r**2 + 528*C*D1*Dd*f**2*r*s - 396*C*D1*Dd*f**2*r + 264*C*D1*Dd*f**2*s**2 - 396*C*D1*Dd*f**2*s + 198*C*D1*Dd*f**2 - 132*D1**2*K*f*fd*r**2 - 264*D1**2*K*f*fd*r*s + 132*D1**2*K*f*fd*r - 132*D1**2*K*f*fd*s**2 + 132*D1**2*K*f*fd*s - 66*D1**2*K*f*fd + 66*D1**2*K*f*fdd*r**2 + 132*D1**2*K*f*fdd*r*s - 66*D1**2*K*f*fdd*r + 66*D1**2*K*f*fdd*s**2 - 66*D1**2*K*f*fdd*s + 33*D1**2*K*f*fdd + 66*D1**2*K*fd**2*r**2 + 132*D1**2*K*fd**2*r*s - 66*D1**2*K*fd**2*r + 66*D1**2*K*fd**2*s**2 - 66*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(-2*K + 5*f + 2)*(r + s - 1)**2 - 1170*D1**2*f**2*fd*r**2 - 2340*D1**2*f**2*fd*r*s + 1560*D1**2*f**2*fd*r - 1170*D1**2*f**2*fd*s**2 + 1560*D1**2*f**2*fd*s - 780*D1**2*f**2*fd + 750*D1**2*f**2*fdd*r**2 + 1500*D1**2*f**2*fdd*r*s - 1000*D1**2*f**2*fdd*r + 750*D1**2*f**2*fdd*s**2 - 1000*D1**2*f**2*fdd*s + 500*D1**2*f**2*fdd + 1500*D1**2*f*fd**2*r**2 + 3000*D1**2*f*fd**2*r*s - 2000*D1**2*f*fd**2*r + 1500*D1**2*f*fd**2*s**2 - 2000*D1**2*f*fd**2*s + 500*D1**2*f*fd**2 - 66*D1**2*f*fdd*r**2 - 132*D1**2*f*fdd*r*s + 66*D1**2*f*fdd*r - 66*D1**2*f*fdd*s**2 + 66*D1**2*f*fdd*s - 33*D1**2*f*fdd + 132*D1**2*f*gd2*r**2 + 264*D1**2*f*gd2*r*s - 264*D1**2*f*gd2*r + 132*D1**2*f*gd2*s**2 - 264*D1**2*f*gd2*s + 132*D1**2*f*gd2 - 66*D1**2*f*gdd2*r**2 - 132*D1**2*f*gdd2*r*s + 132*D1**2*f*gdd2*r - 66*D1**2*f*gdd2*s**2 + 132*D1**2*f*gdd2*s - 66*D1**2*f*gdd2 - 66*D1**2*fd**2*r**2 - 132*D1**2*fd**2*r*s + 66*D1**2*fd**2*r - 66*D1**2*fd**2*s**2 + 66*D1**2*fd**2*s + 132*D1**2*fd*g2*r**2 + 264*D1**2*fd*g2*r*s + 132*D1**2*fd*g2*s**2 - 132*D1**2*fd*gd2*r**2 - 264*D1**2*fd*gd2*r*s + 132*D1**2*fd*gd2*r - 132*D1**2*fd*gd2*s**2 + 132*D1**2*fd*gd2*s - 66*D1**2*fdd*g2*r**2 - 132*D1**2*fdd*g2*r*s - 66*D1**2*fdd*g2*s**2 - 264*D1*Dd*K*f**2*r**2 - 528*D1*Dd*K*f**2*r*s + 396*D1*Dd*K*f**2*r - 264*D1*Dd*K*f**2*s**2 + 396*D1*Dd*K*f**2*s - 198*D1*Dd*K*f**2 + 528*D1*Dd*K*f*fd*r**2 + 1056*D1*Dd*K*f*fd*r*s - 660*D1*Dd*K*f*fd*r + 528*D1*Dd*K*f*fd*s**2 - 660*D1*Dd*K*f*fd*s + 198*D1*Dd*K*f*fd - 1560*D1*Dd*f**3*r**2 - 3120*D1*Dd*f**3*r*s + 2340*D1*Dd*f**3*r - 1560*D1*Dd*f**3*s**2 + 2340*D1*Dd*f**3*s - 1170*D1*Dd*f**3 + 6000*D1*Dd*f**2*fd*r**2 + 12000*D1*Dd*f**2*fd*r*s - 8500*D1*Dd*f**2*fd*r + 6000*D1*Dd*f**2*fd*s**2 - 8500*D1*Dd*f**2*fd*s + 3000*D1*Dd*f**2*fd - 528*D1*Dd*f*fd*r**2 - 1056*D1*Dd*f*fd*r*s + 660*D1*Dd*f*fd*r - 528*D1*Dd*f*fd*s**2 + 660*D1*Dd*f*fd*s - 198*D1*Dd*f*fd + 528*D1*Dd*f*g2*r**2 + 1056*D1*Dd*f*g2*r*s - 792*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s**2 - 792*D1*Dd*f*g2*s + 396*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r**2 - 1056*D1*Dd*f*gd2*r*s + 924*D1*Dd*f*gd2*r - 528*D1*Dd*f*gd2*s**2 + 924*D1*Dd*f*gd2*s - 396*D1*Dd*f*gd2 - 528*D1*Dd*fd*g2*r**2 - 1056*D1*Dd*fd*g2*r*s + 396*D1*Dd*fd*g2*r - 528*D1*Dd*fd*g2*s**2 + 396*D1*Dd*fd*g2*s + 132*D1*Ddd*K*f**2*r**2 + 264*D1*Ddd*K*f**2*r*s - 198*D1*Ddd*K*f**2*r + 132*D1*Ddd*K*f**2*s**2 - 198*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 + 1000*D1*Ddd*f**3*r**2 + 2000*D1*Ddd*f**3*r*s - 1500*D1*Ddd*f**3*r + 1000*D1*Ddd*f**3*s**2 - 1500*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 - 132*D1*Ddd*f**2*r**2 - 264*D1*Ddd*f**2*r*s + 198*D1*Ddd*f**2*r - 132*D1*Ddd*f**2*s**2 + 198*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 - 264*D1*Ddd*f*g2*r**2 - 528*D1*Ddd*f*g2*r*s + 396*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2*s**2 + 396*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 2*f*(K - 1)*(r + s - 1) + 2*fd*(K - 1)*(r + s)) - Dd*f*(-2*K + 5*f + 2)*(4*r + 4*s - 3))*(r + s - 1) + 396*Dd**2*K*f**2*r**2 + 792*Dd**2*K*f**2*r*s - 594*Dd**2*K*f**2*r + 396*Dd**2*K*f**2*s**2 - 594*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 + 3000*Dd**2*f**3*r**2 + 6000*Dd**2*f**3*r*s - 4500*Dd**2*f**3*r + 3000*Dd**2*f**3*s**2 - 4500*Dd**2*f**3*s + 1500*Dd**2*f**3 - 396*Dd**2*f**2*r**2 - 792*Dd**2*f**2*r*s + 594*Dd**2*f**2*r - 396*Dd**2*f**2*s**2 + 594*Dd**2*f**2*s - 198*Dd**2*f**2 - 792*Dd**2*f*g2*r**2 - 1584*Dd**2*f*g2*r*s + 1188*Dd**2*f*g2*r - 792*Dd**2*f*g2*s**2 + 1188*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(2002*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**4*k2**4*st**2*(1980*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-1392*C*D1**2*f*fd*r**2 - 2240*C*D1**2*f*fd*r*s + 880*C*D1**2*f*fd*r - 848*C*D1**2*f*fd*s**2 + 608*C*D1**2*f*fd*s - 304*C*D1**2*f*fd + 732*C*D1**2*f*fdd*r**2 + 1288*C*D1**2*f*fdd*r*s - 524*C*D1**2*f*fdd*r + 556*C*D1**2*f*fdd*s**2 - 436*C*D1**2*f*fdd*s + 218*C*D1**2*f*fdd + 732*C*D1**2*fd**2*r**2 + 1288*C*D1**2*fd**2*r*s - 524*C*D1**2*fd**2*r + 556*C*D1**2*fd**2*s**2 - 436*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 - 2784*C*D1*Dd*f**2*r**2 - 4480*C*D1*Dd*f**2*r*s + 3632*C*D1*Dd*f**2*r - 1696*C*D1*Dd*f**2*s**2 + 2816*C*D1*Dd*f**2*s - 1544*C*D1*Dd*f**2 + 5856*C*D1*Dd*f*fd*r**2 + 10304*C*D1*Dd*f*fd*r*s - 6136*C*D1*Dd*f*fd*r + 4448*C*D1*Dd*f*fd*s**2 - 5256*C*D1*Dd*f*fd*s + 1396*C*D1*Dd*f*fd + 1464*C*D1*Ddd*f**2*r**2 + 2576*C*D1*Ddd*f**2*r*s - 2020*C*D1*Ddd*f**2*r + 1112*C*D1*Ddd*f**2*s**2 - 1756*C*D1*Ddd*f**2*s + 922*C*D1*Ddd*f**2 + 4392*C*Dd**2*f**2*r**2 + 7728*C*Dd**2*f**2*r*s - 6060*C*Dd**2*f**2*r + 3336*C*Dd**2*f**2*s**2 - 5268*C*Dd**2*f**2*s + 1844*C*Dd**2*f**2 - 60*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 1652*D1**2*f*fd*r**2 + 2880*D1**2*f*fd*r*s - 1200*D1**2*f*fd*r + 1228*D1**2*f*fd*s**2 - 988*D1**2*f*fd*s + 494*D1**2*f*fd - 922*D1**2*f*fdd*r**2 - 1728*D1**2*f*fdd*r*s + 744*D1**2*f*fdd*r - 806*D1**2*f*fdd*s**2 + 686*D1**2*f*fdd*s - 343*D1**2*f*fdd - 922*D1**2*fd**2*r**2 - 1728*D1**2*fd**2*r*s + 744*D1**2*fd**2*r - 806*D1**2*fd**2*s**2 + 686*D1**2*fd**2*s + 120*D1**2*fd**2 + 3304*D1*Dd*f**2*r**2 + 5760*D1*Dd*f**2*r*s - 4532*D1*Dd*f**2*r + 2456*D1*Dd*f**2*s**2 - 3896*D1*Dd*f**2*s + 2054*D1*Dd*f**2 - 7376*D1*Dd*f*fd*r**2 - 13824*D1*Dd*f*fd*r*s + 8276*D1*Dd*f*fd*r - 6448*D1*Dd*f*fd*s**2 + 7696*D1*Dd*f*fd*s - 2116*D1*Dd*f*fd - 1844*D1*Ddd*f**2*r**2 - 3456*D1*Ddd*f**2*r*s + 2650*D1*Ddd*f**2*r - 1612*D1*Ddd*f**2*s**2 + 2476*D1*Ddd*f**2*s - 1267*D1*Ddd*f**2 + 120*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5532*Dd**2*f**2*r**2 - 10368*Dd**2*f**2*r*s + 7950*Dd**2*f**2*r - 4836*Dd**2*f**2*s**2 + 7428*Dd**2*f**2*s - 2534*Dd**2*f**2) + f*(-66720*C*D1**2*f*fd*r**2 - 109536*C*D1**2*f*fd*r*s + 80992*C*D1**2*f*fd*r - 42816*C*D1**2*f*fd*s**2 + 65056*C*D1**2*f*fd*s - 36512*C*D1**2*f*fd + 40686*C*D1**2*f*fdd*r**2 + 68628*C*D1**2*f*fdd*r*s - 50000*C*D1**2*f*fdd*r + 27942*C*D1**2*f*fdd*s**2 - 41504*C*D1**2*f*fdd*s + 22876*C*D1**2*f*fdd + 81372*C*D1**2*fd**2*r**2 + 137256*C*D1**2*fd**2*r*s - 100000*C*D1**2*fd**2*r + 55884*C*D1**2*fd**2*s**2 - 83008*C*D1**2*fd**2*s + 22876*C*D1**2*fd**2 - 88960*C*D1*Dd*f**2*r**2 - 146048*C*D1*Dd*f**2*r*s + 117504*C*D1*Dd*f**2*r - 57088*C*D1*Dd*f**2*s**2 + 93600*C*D1*Dd*f**2*s - 50784*C*D1*Dd*f**2 + 325488*C*D1*Dd*f*fd*r**2 + 549024*C*D1*Dd*f*fd*r*s - 418628*C*D1*Dd*f*fd*r + 223536*C*D1*Dd*f*fd*s**2 - 346412*C*D1*Dd*f*fd*s + 133008*C*D1*Dd*f*fd + 54248*C*D1*Ddd*f**2*r**2 + 91504*C*D1*Ddd*f**2*r*s - 72876*C*D1*Ddd*f**2*r + 37256*C*D1*Ddd*f**2*s**2 - 60132*C*D1*Ddd*f**2*s + 32190*C*D1*Ddd*f**2 + 162744*C*Dd**2*f**2*r**2 + 274512*C*Dd**2*f**2*r*s - 218628*C*Dd**2*f**2*r + 111768*C*Dd**2*f**2*s**2 - 180396*C*Dd**2*f**2*s + 64380*C*Dd**2*f**2 - 3960*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(C*(366*r**2 + r*(644*s - 852) + 278*s**2 - 764*s + 426) - 461*r**2 + r*(1042 - 864*s) - 403*s**2 + 984*s - 521) + 74694*D1**2*f*fd*r**2 + 130320*D1**2*f*fd*r*s - 93236*D1**2*f*fd*r + 55626*D1**2*f*fd*s**2 - 80524*D1**2*f*fd*s + 43440*D1**2*f*fd - 46851*D1**2*f*fdd*r**2 - 84168*D1**2*f*fdd*r*s + 59290*D1**2*f*fdd*r - 37317*D1**2*f*fdd*s**2 + 52934*D1**2*f*fdd*s - 28056*D1**2*f*fdd - 93702*D1**2*fd**2*r**2 - 168336*D1**2*fd**2*r*s + 118580*D1**2*fd**2*r - 74634*D1**2*fd**2*s**2 + 105868*D1**2*fd**2*s - 28056*D1**2*fd**2 + 99592*D1*Dd*f**2*r**2 + 173760*D1*Dd*f**2*r*s - 136676*D1*Dd*f**2*r + 74168*D1*Dd*f**2*s**2 - 117608*D1*Dd*f**2*s + 61982*D1*Dd*f**2 - 374808*D1*Dd*f*fd*r**2 - 673344*D1*Dd*f*fd*r*s + 499198*D1*Dd*f*fd*r - 298536*D1*Dd*f*fd*s**2 + 445172*D1*Dd*f*fd*s - 165158*D1*Dd*f*fd - 62468*D1*Ddd*f**2*r**2 - 112224*D1*Ddd*f**2*r*s + 87346*D1*Ddd*f**2*r - 49756*D1*Ddd*f**2*s**2 + 77812*D1*Ddd*f**2*s - 40495*D1*Ddd*f**2 - 66*D1*bd1*(D1*(f*(4*C*(87*r**2 + 4*r*(35*s - 51) + 53*s**2 - 170*s + 102) - 413*r**2 + r*(946 - 720*s) - 307*s**2 + 840*s - 473) + fd*(-2*C*(366*r**2 + r*(644*s - 557) + 278*s**2 - 491*s + 191) + 922*r**2 + 2*r*(864*s - 707) + 806*s**2 - 1327*s + 492)) + Dd*f*(-2*C*(732*r**2 + 23*r*(56*s - 59) + 556*s**2 - 1203*s + 595) + 1844*r**2 + r*(3456*s - 3409) + 1612*s**2 - 3206*s + 1505)) - 187404*Dd**2*f**2*r**2 - 336672*Dd**2*f**2*r*s + 262038*Dd**2*f**2*r - 149268*Dd**2*f**2*s**2 + 233436*Dd**2*f**2*s - 80990*Dd**2*f**2))/(1386*d**2*k3**5) - D1**2*Pk1*Pkd3*ct**4*k2**4*(-61776*C*D1**2*bd1*f**2*r**2 - 61776*C*D1**2*bd1*f**2*r*s + 175032*C*D1**2*bd1*f**2*r + 113256*C*D1**2*bd1*f**2*s - 87516*C*D1**2*bd1*f**2 - 218790*C*D1**2*f**2*fd*r**2 - 283140*C*D1**2*f**2*fd*r*s + 240240*C*D1**2*f**2*fd*r - 64350*C*D1**2*f**2*fd*s**2 + 137280*C*D1**2*f**2*fd*s - 94380*C*D1**2*f**2*fd - 291720*C*D1*Dd*f**3*r**2 - 377520*C*D1*Dd*f**3*r*s + 334620*C*D1*Dd*f**3*r - 85800*C*D1*Dd*f**3*s**2 + 180180*C*D1*Dd*f**3*s - 115830*C*D1*Dd*f**3 - 50622*D1**2*K*bd1**2*f*r**2 - 101244*D1**2*K*bd1**2*f*r*s + 126984*D1**2*K*bd1**2*f*r - 50622*D1**2*K*bd1**2*f*s**2 + 126984*D1**2*K*bd1**2*f*s - 76362*D1**2*K*bd1**2*f + 84084*D1**2*K*bd1*f**2*r**2 + 120120*D1**2*K*bd1*f**2*r*s - 120120*D1**2*K*bd1*f**2*r + 36036*D1**2*K*bd1*f**2*s**2 - 72072*D1**2*K*bd1*f**2*s + 36036*D1**2*K*bd1*f**2 - 163020*D1**2*K*bd1*f*fd*r**2 - 291720*D1**2*K*bd1*f*fd*r*s + 227370*D1**2*K*bd1*f*fd*r - 128700*D1**2*K*bd1*f*fd*s**2 + 201630*D1**2*K*bd1*f*fd*s - 72930*D1**2*K*bd1*f*fd - 40755*D1**2*K*bdd1*f**2*r**2 - 72930*D1**2*K*bdd1*f**2*r*s + 72930*D1**2*K*bdd1*f**2*r - 32175*D1**2*K*bdd1*f**2*s**2 + 64350*D1**2*K*bdd1*f**2*s - 32175*D1**2*K*bdd1*f**2 + 164736*D1**2*bd1**2*f**2*r**2 + 339768*D1**2*bd1**2*f**2*r*s - 291720*D1**2*bd1**2*f**2*r + 175032*D1**2*bd1**2*f**2*s**2 - 302016*D1**2*bd1**2*f**2*s + 126984*D1**2*bd1**2*f**2 + 117546*D1**2*bd1**2*f*r**2 + 245388*D1**2*bd1**2*f*r*s - 265980*D1**2*bd1**2*f*r + 127842*D1**2*bd1**2*f*s**2 - 276276*D1**2*bd1**2*f*s + 148434*D1**2*bd1**2*f - 60060*D1**2*bd1**2*g2*r**2 - 120120*D1**2*bd1**2*g2*r*s + 60060*D1**2*bd1**2*g2*r - 60060*D1**2*bd1**2*g2*s**2 + 60060*D1**2*bd1**2*g2*s - 25740*D1**2*bd1*bd2*f*r**2 - 51480*D1**2*bd1*bd2*f*r*s + 51480*D1**2*bd1*bd2*f*r - 25740*D1**2*bd1*bd2*f*s**2 + 51480*D1**2*bd1*bd2*f*s - 25740*D1**2*bd1*bd2*f - 83590*D1**2*bd1*f**3*r**2 - 116610*D1**2*bd1*f**3*r*s + 94770*D1**2*bd1*f**3*r - 33020*D1**2*bd1*f**3*s**2 + 44200*D1**2*bd1*f**3*s - 44330*D1**2*bd1*f**3 + 340860*D1**2*bd1*f**2*fd*r**2 + 362700*D1**2*bd1*f**2*fd*r*s - 350740*D1**2*bd1*f**2*fd*r + 21840*D1**2*bd1*f**2*fd*s**2 - 84890*D1**2*bd1*f**2*fd*s + 10790*D1**2*bd1*f**2*fd - 41184*D1**2*bd1*f**2*r**2 - 102960*D1**2*bd1*f**2*r*s - 5148*D1**2*bd1*f**2*r - 61776*D1**2*bd1*f**2*s**2 + 15444*D1**2*bd1*f**2*s + 20592*D1**2*bd1*f**2 + 267696*D1**2*bd1*f*fd*r**2 + 525096*D1**2*bd1*f*fd*r*s - 396396*D1**2*bd1*f*fd*r + 257400*D1**2*bd1*f*fd*s**2 - 388674*D1**2*bd1*f*fd*s + 131274*D1**2*bd1*f*fd - 107250*D1**2*bd1*f*g2*r**2 - 142428*D1**2*bd1*f*g2*r*s + 317460*D1**2*bd1*f*g2*r - 35178*D1**2*bd1*f*g2*s**2 + 245388*D1**2*bd1*f*g2*s - 158730*D1**2*bd1*f*g2 + 101244*D1**2*bd1*f*gd2*r**2 + 202488*D1**2*bd1*f*gd2*r*s - 253968*D1**2*bd1*f*gd2*r + 101244*D1**2*bd1*f*gd2*s**2 - 253968*D1**2*bd1*f*gd2*s + 152724*D1**2*bd1*f*gd2 + 101244*D1**2*bd1*fd*g2*r**2 + 202488*D1**2*bd1*fd*g2*r*s - 101244*D1**2*bd1*fd*g2*r + 101244*D1**2*bd1*fd*g2*s**2 - 101244*D1**2*bd1*fd*g2*s + 21450*D1**2*bd2*f**2*r**2 + 42900*D1**2*bd2*f**2*r*s - 42900*D1**2*bd2*f**2*r + 21450*D1**2*bd2*f**2*s**2 - 42900*D1**2*bd2*f**2*s + 21450*D1**2*bd2*f**2 - 42900*D1**2*bd2*f*fd*r**2 - 85800*D1**2*bd2*f*fd*r*s + 64350*D1**2*bd2*f*fd*r - 42900*D1**2*bd2*f*fd*s**2 + 64350*D1**2*bd2*f*fd*s - 21450*D1**2*bd2*f*fd + 56810*D1**2*bdd1*f**3*r**2 + 60450*D1**2*bdd1*f**3*r*s - 58110*D1**2*bdd1*f**3*r + 3640*D1**2*bdd1*f**3*s**2 - 4940*D1**2*bdd1*f**3*s + 28600*D1**2*bdd1*f**3 + 66924*D1**2*bdd1*f**2*r**2 + 131274*D1**2*bdd1*f**2*r*s - 131274*D1**2*bdd1*f**2*r + 64350*D1**2*bdd1*f**2*s**2 - 128700*D1**2*bdd1*f**2*s + 64350*D1**2*bdd1*f**2 + 50622*D1**2*bdd1*f*g2*r**2 + 101244*D1**2*bdd1*f*g2*r*s - 152724*D1**2*bdd1*f*g2*r + 50622*D1**2*bdd1*f*g2*s**2 - 152724*D1**2*bdd1*f*g2*s + 76362*D1**2*bdd1*f*g2 - 10725*D1**2*bdd2*f**2*r**2 - 21450*D1**2*bdd2*f**2*r*s + 21450*D1**2*bdd2*f**2*r - 10725*D1**2*bdd2*f**2*s**2 + 21450*D1**2*bdd2*f**2*s - 10725*D1**2*bdd2*f**2 + 115920*D1**2*f**3*fd*r**2 + 341600*D1**2*f**3*fd*r*s - 228760*D1**2*f**3*fd*r + 225680*D1**2*f**3*fd*s**2 - 311080*D1**2*f**3*fd*s + 141820*D1**2*f**3*fd - 112560*D1**2*f**3*fdd*r**2 - 381920*D1**2*f**3*fdd*r*s + 247240*D1**2*f**3*fdd*r - 269360*D1**2*f**3*fdd*s**2 + 364840*D1**2*f**3*fdd*s - 162820*D1**2*f**3*fdd - 337680*D1**2*f**2*fd**2*r**2 - 1145760*D1**2*f**2*fd**2*r*s + 741720*D1**2*f**2*fd**2*r - 808080*D1**2*f**2*fd**2*s**2 + 1094520*D1**2*f**2*fd**2*s - 325640*D1**2*f**2*fd**2 + 238095*D1**2*f**2*fd*r**2 + 334620*D1**2*f**2*fd*r*s - 270270*D1**2*f**2*fd*r + 96525*D1**2*f**2*fd*s**2 - 175890*D1**2*f**2*fd*s + 111540*D1**2*f**2*fd - 168168*D1**2*f**2*gd2*r**2 - 240240*D1**2*f**2*gd2*r*s + 240240*D1**2*f**2*gd2*r - 72072*D1**2*f**2*gd2*s**2 + 144144*D1**2*f**2*gd2*s - 72072*D1**2*f**2*gd2 + 81510*D1**2*f**2*gdd2*r**2 + 145860*D1**2*f**2*gdd2*r*s - 145860*D1**2*f**2*gdd2*r + 64350*D1**2*f**2*gdd2*s**2 - 128700*D1**2*f**2*gdd2*s + 64350*D1**2*f**2*gdd2 - 336336*D1**2*f*fd*g2*r**2 - 480480*D1**2*f*fd*g2*r*s + 336336*D1**2*f*fd*g2*r - 144144*D1**2*f*fd*g2*s**2 + 240240*D1**2*f*fd*g2*s - 168168*D1**2*f*fd*g2 + 326040*D1**2*f*fd*gd2*r**2 + 583440*D1**2*f*fd*gd2*r*s - 454740*D1**2*f*fd*gd2*r + 257400*D1**2*f*fd*gd2*s**2 - 403260*D1**2*f*fd*gd2*s + 145860*D1**2*f*fd*gd2 + 163020*D1**2*f*fdd*g2*r**2 + 291720*D1**2*f*fdd*g2*r*s - 163020*D1**2*f*fdd*g2*r + 128700*D1**2*f*fdd*g2*s**2 - 145860*D1**2*f*fdd*g2*s + 81510*D1**2*f*fdd*g2 + 163020*D1**2*fd**2*g2*r**2 + 291720*D1**2*fd**2*g2*r*s - 163020*D1**2*fd**2*g2*r + 128700*D1**2*fd**2*g2*s**2 - 145860*D1**2*fd**2*g2*s - 326040*D1*Dd*K*bd1*f**2*r**2 - 583440*D1*Dd*K*bd1*f**2*r*s + 519090*D1*Dd*K*bd1*f**2*r - 257400*D1*Dd*K*bd1*f**2*s**2 + 459030*D1*Dd*K*bd1*f**2*s - 201630*D1*Dd*K*bd1*f**2 + 454480*D1*Dd*bd1*f**3*r**2 + 483600*D1*Dd*bd1*f**3*r*s - 466960*D1*Dd*bd1*f**3*r + 29120*D1*Dd*bd1*f**3*s**2 - 94770*D1*Dd*bd1*f**3*s + 67990*D1*Dd*bd1*f**3 + 535392*D1*Dd*bd1*f**2*r**2 + 1050192*D1*Dd*bd1*f**2*r*s - 921492*D1*Dd*bd1*f**2*r + 514800*D1*Dd*bd1*f**2*s**2 - 903474*D1*Dd*bd1*f**2*s + 388674*D1*Dd*bd1*f**2 + 404976*D1*Dd*bd1*f*g2*r**2 + 809952*D1*Dd*bd1*f*g2*r*s - 914628*D1*Dd*bd1*f*g2*r + 404976*D1*Dd*bd1*f*g2*s**2 - 914628*D1*Dd*bd1*f*g2*s + 458172*D1*Dd*bd1*f*g2 - 85800*D1*Dd*bd2*f**2*r**2 - 171600*D1*Dd*bd2*f**2*r*s + 150150*D1*Dd*bd2*f**2*r - 85800*D1*Dd*bd2*f**2*s**2 + 150150*D1*Dd*bd2*f**2*s - 64350*D1*Dd*bd2*f**2 + 115920*D1*Dd*f**4*r**2 + 341600*D1*Dd*f**4*r*s - 228760*D1*Dd*f**4*r + 225680*D1*Dd*f**4*s**2 - 311080*D1*Dd*f**4*s + 141820*D1*Dd*f**4 - 900480*D1*Dd*f**3*fd*r**2 - 3055360*D1*Dd*f**3*fd*r*s + 1977920*D1*Dd*f**3*fd*r - 2154880*D1*Dd*f**3*fd*s**2 + 2918720*D1*Dd*f**3*fd*s - 976920*D1*Dd*f**3*fd + 317460*D1*Dd*f**3*r**2 + 446160*D1*Dd*f**3*r*s - 381810*D1*Dd*f**3*r + 128700*D1*Dd*f**3*s**2 - 240240*D1*Dd*f**3*s + 143715*D1*Dd*f**3 - 672672*D1*Dd*f**2*g2*r**2 - 960960*D1*Dd*f**2*g2*r*s + 816816*D1*Dd*f**2*g2*r - 288288*D1*Dd*f**2*g2*s**2 + 528528*D1*Dd*f**2*g2*s - 312312*D1*Dd*f**2*g2 + 652080*D1*Dd*f**2*gd2*r**2 + 1166880*D1*Dd*f**2*gd2*r*s - 1038180*D1*Dd*f**2*gd2*r + 514800*D1*Dd*f**2*gd2*s**2 - 918060*D1*Dd*f**2*gd2*s + 403260*D1*Dd*f**2*gd2 + 1304160*D1*Dd*f*fd*g2*r**2 + 2333760*D1*Dd*f*fd*g2*r*s - 1561560*D1*Dd*f*fd*g2*r + 1029600*D1*Dd*f*fd*g2*s**2 - 1389960*D1*Dd*f*fd*g2*s + 454740*D1*Dd*f*fd*g2 - 112560*D1*Ddd*f**4*r**2 - 381920*D1*Ddd*f**4*r*s + 247240*D1*Ddd*f**4*r - 269360*D1*Ddd*f**4*s**2 + 364840*D1*Ddd*f**4*s - 162820*D1*Ddd*f**4 + 326040*D1*Ddd*f**2*g2*r**2 + 583440*D1*Ddd*f**2*g2*r*s - 454740*D1*Ddd*f**2*g2*r + 257400*D1*Ddd*f**2*g2*s**2 - 403260*D1*Ddd*f**2*g2*s + 210210*D1*Ddd*f**2*g2 - 337680*Dd**2*f**4*r**2 - 1145760*Dd**2*f**4*r*s + 741720*Dd**2*f**4*r - 808080*Dd**2*f**4*s**2 + 1094520*Dd**2*f**4*s - 325640*Dd**2*f**4 + 978120*Dd**2*f**2*g2*r**2 + 1750320*Dd**2*f**2*g2*r*s - 1364220*Dd**2*f**2*g2*r + 772200*Dd**2*f**2*g2*s**2 - 1209780*Dd**2*f**2*g2*s + 420420*Dd**2*f**2*g2 + 2145*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (7*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-7*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-7*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(70*C*D1**2*fd*r**2 + 140*C*D1**2*fd*r*s - 140*C*D1**2*fd*r + 70*C*D1**2*fd*s**2 - 140*C*D1**2*fd*s + 70*C*D1**2*fd + 280*C*D1*Dd*f*r**2 + 560*C*D1*Dd*f*r*s - 420*C*D1*Dd*f*r + 280*C*D1*Dd*f*s**2 - 420*C*D1*Dd*f*s + 210*C*D1*Dd*f + 125*D1**2*K*fd*r**2 + 166*D1**2*K*fd*r*s + 120*D1**2*K*fd*r + 41*D1**2*K*fd*s**2 + 120*D1**2*K*fd*s - 60*D1**2*K*fd - 59*D1**2*K*fdd*r**2 - 118*D1**2*K*fdd*r*s - 60*D1**2*K*fdd*r - 59*D1**2*K*fdd*s**2 - 60*D1**2*K*fdd*s + 30*D1**2*K*fdd - 5*D1**2*bdd1*(-7*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 420*D1**2*f*fd*r**2 - 864*D1**2*f*fd*r*s + 512*D1**2*f*fd*r - 444*D1**2*f*fd*s**2 + 524*D1**2*f*fd*s - 262*D1**2*f*fd + 384*D1**2*f*fdd*r**2 + 792*D1**2*f*fdd*r*s - 496*D1**2*f*fdd*r + 408*D1**2*f*fdd*s**2 - 508*D1**2*f*fdd*s + 254*D1**2*f*fdd + 384*D1**2*fd**2*r**2 + 792*D1**2*fd**2*r*s - 496*D1**2*fd**2*r + 408*D1**2*fd**2*s**2 - 508*D1**2*fd**2*s + 100*D1**2*fd**2 - 281*D1**2*fd*r**2 - 502*D1**2*fd*r*s + 20*D1**2*fd*r - 221*D1**2*fd*s**2 + 20*D1**2*fd*s - 10*D1**2*fd + 137*D1**2*fdd*r**2 + 286*D1**2*fdd*r*s + 60*D1**2*fdd*r + 149*D1**2*fdd*s**2 + 60*D1**2*fdd*s - 30*D1**2*fdd + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 + 500*D1*Dd*K*f*r**2 + 664*D1*Dd*K*f*r*s - 582*D1*Dd*K*f*r + 164*D1*Dd*K*f*s**2 - 330*D1*Dd*K*f*s + 207*D1*Dd*K*f - 472*D1*Dd*K*fd*r**2 - 944*D1*Dd*K*fd*r*s + 114*D1*Dd*K*fd*r - 472*D1*Dd*K*fd*s**2 + 114*D1*Dd*K*fd*s + 180*D1*Dd*K*fd - 840*D1*Dd*f**2*r**2 - 1728*D1*Dd*f**2*r*s + 1284*D1*Dd*f**2*r - 888*D1*Dd*f**2*s**2 + 1320*D1*Dd*f**2*s - 654*D1*Dd*f**2 + 3072*D1*Dd*f*fd*r**2 + 6336*D1*Dd*f*fd*r*s - 4336*D1*Dd*f*fd*r + 3264*D1*Dd*f*fd*s**2 - 4456*D1*Dd*f*fd*s + 1512*D1*Dd*f*fd - 1124*D1*Dd*f*r**2 - 2008*D1*Dd*f*r*s + 1566*D1*Dd*f*r - 884*D1*Dd*f*s**2 + 1386*D1*Dd*f*s - 723*D1*Dd*f + 1096*D1*Dd*fd*r**2 + 2288*D1*Dd*fd*r*s - 606*D1*Dd*fd*r + 1192*D1*Dd*fd*s**2 - 642*D1*Dd*fd*s - 180*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 - 236*D1*Ddd*K*f*r**2 - 472*D1*Ddd*K*f*r*s + 354*D1*Ddd*K*f*r - 236*D1*Ddd*K*f*s**2 + 354*D1*Ddd*K*f*s - 177*D1*Ddd*K*f + 768*D1*Ddd*f**2*r**2 + 1584*D1*Ddd*f**2*r*s - 1176*D1*Ddd*f**2*r + 816*D1*Ddd*f**2*s**2 - 1212*D1*Ddd*f**2*s + 600*D1*Ddd*f**2 + 548*D1*Ddd*f*r**2 + 1144*D1*Ddd*f*r*s - 846*D1*Ddd*f*r + 596*D1*Ddd*f*s**2 - 882*D1*Ddd*f*s + 435*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 10*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (7*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-7*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 708*Dd**2*K*f*r**2 - 1416*Dd**2*K*f*r*s + 1062*Dd**2*K*f*r - 708*Dd**2*K*f*s**2 + 1062*Dd**2*K*f*s - 354*Dd**2*K*f + 2304*Dd**2*f**2*r**2 + 4752*Dd**2*f**2*r*s - 3528*Dd**2*f**2*r + 2448*Dd**2*f**2*s**2 - 3636*Dd**2*f**2*s + 1200*Dd**2*f**2 + 1644*Dd**2*f*r**2 + 3432*Dd**2*f*r*s - 2538*Dd**2*f*r + 1788*Dd**2*f*s**2 - 2646*Dd**2*f*s + 870*Dd**2*f - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) - 13*b1*(9504*C*D1**2*f*fd*r**2 + 9504*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 3960*C*D1**2*f*fd*s - 1980*C*D1**2*f*fd + 19008*C*D1*Dd*f**2*r**2 + 19008*C*D1*Dd*f**2*r*s - 19008*C*D1*Dd*f**2*r - 4752*C*D1*Dd*f**2*s + 4752*C*D1*Dd*f**2 + 3894*D1**2*K*bdd1*f*r**2 + 7788*D1**2*K*bdd1*f*r*s - 9768*D1**2*K*bdd1*f*r + 3894*D1**2*K*bdd1*f*s**2 - 9768*D1**2*K*bdd1*f*s + 4884*D1**2*K*bdd1*f - 12936*D1**2*K*f*fd*r**2 - 18480*D1**2*K*f*fd*r*s + 12936*D1**2*K*f*fd*r - 5544*D1**2*K*f*fd*s**2 + 9240*D1**2*K*f*fd*s - 6468*D1**2*K*f*fd + 6270*D1**2*K*f*fdd*r**2 + 11220*D1**2*K*f*fdd*r*s - 6270*D1**2*K*f*fdd*r + 4950*D1**2*K*f*fdd*s**2 - 5610*D1**2*K*f*fdd*s + 3135*D1**2*K*f*fdd + 6270*D1**2*K*fd**2*r**2 + 11220*D1**2*K*fd**2*r*s - 6270*D1**2*K*fd**2*r + 4950*D1**2*K*fd**2*s**2 - 5610*D1**2*K*fd**2*s - 1980*D1**2*b2*fd*r**2 - 3960*D1**2*b2*fd*r*s - 1980*D1**2*b2*fd*s**2 + 990*D1**2*b2*fdd*r**2 + 1980*D1**2*b2*fdd*r*s + 990*D1**2*b2*fdd*s**2 + 330*D1**2*bd1**2*(-7*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 12672*D1**2*bdd1*f**2*r**2 - 26136*D1**2*bdd1*f**2*r*s + 22440*D1**2*bdd1*f**2*r - 13464*D1**2*bdd1*f**2*s**2 + 23232*D1**2*bdd1*f**2*s - 11418*D1**2*bdd1*f**2 - 9042*D1**2*bdd1*f*r**2 - 18876*D1**2*bdd1*f*r*s + 20460*D1**2*bdd1*f*r - 9834*D1**2*bdd1*f*s**2 + 21252*D1**2*bdd1*f*s - 10428*D1**2*bdd1*f + 4620*D1**2*bdd1*g2*r**2 + 9240*D1**2*bdd1*g2*r*s - 4620*D1**2*bdd1*g2*r + 4620*D1**2*bdd1*g2*s**2 - 4620*D1**2*bdd1*g2*s + 2310*D1**2*bdd1*g2 + 990*D1**2*bdd2*f*r**2 + 1980*D1**2*bdd2*f*r*s - 1980*D1**2*bdd2*f*r + 990*D1**2*bdd2*f*s**2 - 1980*D1**2*bdd2*f*s + 990*D1**2*bdd2*f + 19290*D1**2*f**2*fd*r**2 + 26910*D1**2*f**2*fd*r*s - 23510*D1**2*f**2*fd*r + 7620*D1**2*f**2*fd*s**2 - 15730*D1**2*f**2*fd*s + 8100*D1**2*f**2*fd - 13110*D1**2*f**2*fdd*r**2 - 13950*D1**2*f**2*fdd*r*s + 13570*D1**2*f**2*fdd*r - 840*D1**2*f**2*fdd*s**2 + 5390*D1**2*f**2*fdd*s - 2730*D1**2*f**2*fdd - 26220*D1**2*f*fd**2*r**2 - 27900*D1**2*f*fd**2*r*s + 27140*D1**2*f*fd**2*r - 1680*D1**2*f*fd**2*s**2 + 10780*D1**2*f*fd**2*s - 9030*D1**2*f*fd**2 + 6336*D1**2*f*fd*r**2 + 15840*D1**2*f*fd*r*s - 14652*D1**2*f*fd*r + 9504*D1**2*f*fd*s**2 - 16236*D1**2*f*fd*s + 9504*D1**2*f*fd - 10296*D1**2*f*fdd*r**2 - 20196*D1**2*f*fdd*r*s + 10296*D1**2*f*fdd*r - 9900*D1**2*f*fdd*s**2 + 10098*D1**2*f*fdd*s - 5148*D1**2*f*fdd + 8250*D1**2*f*gd2*r**2 + 10956*D1**2*f*gd2*r*s - 10956*D1**2*f*gd2*r + 2706*D1**2*f*gd2*s**2 - 5412*D1**2*f*gd2*s + 2706*D1**2*f*gd2 - 3894*D1**2*f*gdd2*r**2 - 7788*D1**2*f*gdd2*r*s + 7788*D1**2*f*gdd2*r - 3894*D1**2*f*gdd2*s**2 + 7788*D1**2*f*gdd2*s - 3894*D1**2*f*gdd2 - 10296*D1**2*fd**2*r**2 - 20196*D1**2*fd**2*r*s + 10296*D1**2*fd**2*r - 9900*D1**2*fd**2*s**2 + 10098*D1**2*fd**2*s + 8250*D1**2*fd*g2*r**2 + 10956*D1**2*fd*g2*r*s + 7920*D1**2*fd*g2*r + 2706*D1**2*fd*g2*s**2 + 7920*D1**2*fd*g2*s - 3960*D1**2*fd*g2 - 7788*D1**2*fd*gd2*r**2 - 15576*D1**2*fd*gd2*r*s + 3828*D1**2*fd*gd2*r - 7788*D1**2*fd*gd2*s**2 + 3828*D1**2*fd*gd2*s + 3960*D1**2*fd*gd2 - 3894*D1**2*fdd*g2*r**2 - 7788*D1**2*fdd*g2*r*s - 3960*D1**2*fdd*g2*r - 3894*D1**2*fdd*g2*s**2 - 3960*D1**2*fdd*g2*s + 1980*D1**2*fdd*g2 - 25872*D1*Dd*K*f**2*r**2 - 36960*D1*Dd*K*f**2*r*s + 31416*D1*Dd*K*f**2*r - 11088*D1*Dd*K*f**2*s**2 + 20328*D1*Dd*K*f**2*s - 12012*D1*Dd*K*f**2 + 50160*D1*Dd*K*f*fd*r**2 + 89760*D1*Dd*K*f*fd*r*s - 60060*D1*Dd*K*f*fd*r + 39600*D1*Dd*K*f*fd*s**2 - 53460*D1*Dd*K*f*fd*s + 17490*D1*Dd*K*f*fd - 7920*D1*Dd*b2*f*r**2 - 15840*D1*Dd*b2*f*r*s + 11880*D1*Dd*b2*f*r - 7920*D1*Dd*b2*f*s**2 + 11880*D1*Dd*b2*f*s - 5940*D1*Dd*b2*f + 7920*D1*Dd*b2*fd*r**2 + 15840*D1*Dd*b2*fd*r*s - 5940*D1*Dd*b2*fd*r + 7920*D1*Dd*b2*fd*s**2 - 5940*D1*Dd*b2*fd*s + 25720*D1*Dd*f**3*r**2 + 35880*D1*Dd*f**3*r*s - 30800*D1*Dd*f**3*r + 10160*D1*Dd*f**3*s**2 - 19130*D1*Dd*f**3*s + 11510*D1*Dd*f**3 - 104880*D1*Dd*f**2*fd*r**2 - 111600*D1*Dd*f**2*fd*r*s + 108400*D1*Dd*f**2*fd*r - 6720*D1*Dd*f**2*fd*s**2 + 38870*D1*Dd*f**2*fd*s - 24350*D1*Dd*f**2*fd + 12672*D1*Dd*f**2*r**2 + 31680*D1*Dd*f**2*r*s - 22176*D1*Dd*f**2*r + 19008*D1*Dd*f**2*s**2 - 26928*D1*Dd*f**2*s + 12672*D1*Dd*f**2 - 82368*D1*Dd*f*fd*r**2 - 161568*D1*Dd*f*fd*r*s + 102168*D1*Dd*f*fd*r - 79200*D1*Dd*f*fd*s**2 + 100188*D1*Dd*f*fd*s - 30492*D1*Dd*f*fd + 33000*D1*Dd*f*g2*r**2 + 43824*D1*Dd*f*g2*r*s - 38412*D1*Dd*f*g2*r + 10824*D1*Dd*f*g2*s**2 - 21780*D1*Dd*f*g2*s + 13662*D1*Dd*f*g2 - 31152*D1*Dd*f*gd2*r**2 - 62304*D1*Dd*f*gd2*r*s + 54516*D1*Dd*f*gd2*r - 31152*D1*Dd*f*gd2*s**2 + 54516*D1*Dd*f*gd2*s - 23364*D1*Dd*f*gd2 - 31152*D1*Dd*fd*g2*r**2 - 62304*D1*Dd*fd*g2*r*s + 7524*D1*Dd*fd*g2*r - 31152*D1*Dd*fd*g2*s**2 + 7524*D1*Dd*fd*g2*s + 11880*D1*Dd*fd*g2 + 12540*D1*Ddd*K*f**2*r**2 + 22440*D1*Ddd*K*f**2*r*s - 17490*D1*Ddd*K*f**2*r + 9900*D1*Ddd*K*f**2*s**2 - 15510*D1*Ddd*K*f**2*s + 8085*D1*Ddd*K*f**2 + 3960*D1*Ddd*b2*f*r**2 + 7920*D1*Ddd*b2*f*r*s - 5940*D1*Ddd*b2*f*r + 3960*D1*Ddd*b2*f*s**2 - 5940*D1*Ddd*b2*f*s + 2970*D1*Ddd*b2*f - 17480*D1*Ddd*f**3*r**2 - 18600*D1*Ddd*f**3*r*s + 18040*D1*Ddd*f**3*r - 1120*D1*Ddd*f**3*s**2 + 5770*D1*Ddd*f**3*s - 4930*D1*Ddd*f**3 - 20592*D1*Ddd*f**2*r**2 - 40392*D1*Ddd*f**2*r*s + 30492*D1*Ddd*f**2*r - 19800*D1*Ddd*f**2*s**2 + 29898*D1*Ddd*f**2*s - 15048*D1*Ddd*f**2 - 15576*D1*Ddd*f*g2*r**2 - 31152*D1*Ddd*f*g2*r*s + 23364*D1*Ddd*f*g2*r - 15576*D1*Ddd*f*g2*s**2 + 23364*D1*Ddd*f*g2*s - 11682*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(2*f**2*(105*r**2 + r*(216*s - 193) + 111*s**2 - 199*s + 98) - f*(35*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 125*K*r**2 + 166*K*r*s - 268*K*r + 41*K*s**2 - 184*K*s + 113*K + 6*fd*(128*r**2 + 4*r*(66*s - 49) + 136*s**2 - 202*s + 67) - 281*r**2 - 502*r*s + 522*r - 221*s**2 + 462*s - 246) + 2*fd*(K*(59*r**2 + 2*r*(59*s - 22) + 59*s**2 - 44*s - 15) - 137*r**2 + r*(125 - 286*s) - 149*s**2 + 131*s + 15) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(2*f**2*(384*r**2 + r*(792*s - 634) + 408*s**2 - 655*s + 261) + f*(-K*(236*r**2 + 472*r*s - 473*r + 236*s**2 - 473*s + 222) + 548*r**2 + 1144*r*s - 1043*r + 596*s**2 - 1085*s + 477) - 35*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 1980*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 37620*Dd**2*K*f**2*r**2 + 67320*Dd**2*K*f**2*r*s - 52470*Dd**2*K*f**2*r + 29700*Dd**2*K*f**2*s**2 - 46530*Dd**2*K*f**2*s + 16170*Dd**2*K*f**2 + 11880*Dd**2*b2*f*r**2 + 23760*Dd**2*b2*f*r*s - 17820*Dd**2*b2*f*r + 11880*Dd**2*b2*f*s**2 - 17820*Dd**2*b2*f*s + 5940*Dd**2*b2*f - 52440*Dd**2*f**3*r**2 - 55800*Dd**2*f**3*r*s + 54120*Dd**2*f**3*r - 3360*Dd**2*f**3*s**2 + 17310*Dd**2*f**3*s - 9860*Dd**2*f**3 - 61776*Dd**2*f**2*r**2 - 121176*Dd**2*f**2*r*s + 91476*Dd**2*f**2*r - 59400*Dd**2*f**2*s**2 + 89694*Dd**2*f**2*s - 30096*Dd**2*f**2 - 46728*Dd**2*f*g2*r**2 - 93456*Dd**2*f*g2*r*s + 70092*Dd**2*f*g2*r - 46728*Dd**2*f*g2*s**2 + 70092*Dd**2*f*g2*s - 23364*Dd**2*f*g2) + 2145*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 5*D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 12*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 5*D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(9009*d**2*k3**5) + 2*D1**2*Pk1*Pkd3*ct**4*k2**2*st**2*(132*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + 33*b1*(D1**2*(f*(-4*bdd1*s*(C - 1)*(2*r + 2*s - 1) - 4*fd*(C*(6*r*s - 3*r + 6*s**2 - 4*s + 3) - 10*r*s + 5*r - 10*s**2 + 8*s - 5) + fdd*(2*C*(6*r*s - 3*r + 6*s**2 - 4*s + 3) - 22*r*s + 11*r - 22*s**2 + 18*s - 11)) + fd**2*(2*C*(r*(6*s - 3) + 6*s**2 - 4*s - 2) + r*(11 - 22*s) - 22*s**2 + 18*s + 4)) - 4*D1*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(20 - 12*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(2*s - 1)*(C*(48*r + 48*s - 22) - 88*r - 88*s + 47)) + Ddd*f*(6*C - 11)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(6*C - 11)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-132*D1**2*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1**2*(f*(33*bdd1*s*(2*C*(3*r + 3*s - 5) - 11*r - 11*s + 15) + fd*(684 - 500*C)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(250*C - 375)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(250*C - 375)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 33*D1*bd1*(D1*(4*f*s*(C*(3*r + 3*s - 5) - 5*r - 5*s + 7) + fd*(-2*C*(12*r*s - 3*r + 12*s**2 - 14*s + 5) + 44*r*s - 11*r + 44*s**2 - 48*s + 15)) + Dd*f*(-2*C*(24*r*s - 6*r + 24*s**2 - 35*s + 10) + 88*r*s - 22*r + 88*s**2 - 115*s + 30)) + D1*f*(Dd*(f*(684 - 500*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(250*C - 375)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(250*C - 375)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(250*C - 375)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**4*k2**2*(-22*b1**2*(D1**2*(r + s - 1)*(C*fd*(53*r + 81*s - 81) + C*fdd*(-37*r - 65*s + 65) - 40*fd*(r + 2*s - 2) + 34*fdd*(r + 2*s - 2)) + D1*(Dd*(-2*C*fd*(148*r**2 + r*(408*s - 343) + 260*s**2 - 441*s + 181) + f*(C*(212*r**2 + 536*r*s - 374*r + 324*s**2 - 458*s + 215) - 160*r**2 - 480*r*s + 320*r - 320*s**2 + 440*s - 200) + 34*fd*(8*r**2 + 4*r*(6*s - 5) + 16*s**2 - 27*s + 11)) + Ddd*f*(-C*(148*r**2 + 408*r*s - 278*r + 260*s**2 - 362*s + 167) + 136*r**2 + 408*r*s - 272*r + 272*s**2 - 374*s + 170)) - 2*Dd**2*f*(C*(222*r**2 + 612*r*s - 417*r + 390*s**2 - 543*s + 167) - 204*r**2 - 612*r*s + 408*r - 408*s**2 + 561*s - 170)) - 11*b1*(200*C*D1**2*f*fd*r**2 + 208*C*D1**2*f*fd*r*s - 376*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 280*C*D1**2*f*fd*s + 140*C*D1**2*f*fd - 52*C*D1**2*f*fdd*r**2 - 56*C*D1**2*f*fdd*r*s + 200*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 200*C*D1**2*f*fdd*s - 88*C*D1**2*f*fdd - 52*C*D1**2*fd**2*r**2 - 56*C*D1**2*fd**2*r*s + 200*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 200*C*D1**2*fd**2*s - 196*C*D1**2*fd**2 + 400*C*D1*Dd*f**2*r**2 + 416*C*D1*Dd*f**2*r*s - 408*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 120*C*D1*Dd*f**2*s + 108*C*D1*Dd*f**2 - 416*C*D1*Dd*f*fd*r**2 - 448*C*D1*Dd*f*fd*r*s + 1016*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 872*C*D1*Dd*f*fd*s - 600*C*D1*Dd*f*fd - 104*C*D1*Ddd*f**2*r**2 - 112*C*D1*Ddd*f**2*r*s + 108*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 36*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 312*C*Dd**2*f**2*r**2 - 336*C*Dd**2*f**2*r*s + 324*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 108*C*Dd**2*f**2*s - 60*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(C*(74*r**2 + 204*r*s - 74*r + 130*s**2 - 102*s + 37) - 68*r**2 - 204*r*s + 68*r - 136*s**2 + 102*s - 34) - 128*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s + 164*D1**2*f*fd*r + 224*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s + 6*D1**2*f*fd + 34*D1**2*f*fdd*r**2 - 168*D1**2*f*fdd*r*s - 70*D1**2*f*fdd*r - 202*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 24*D1**2*f*fdd + 34*D1**2*fd**2*r**2 - 168*D1**2*fd**2*r*s - 70*D1**2*fd**2*r - 202*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 192*D1**2*fd**2 - 256*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s + 32*D1*Dd*f**2*r + 448*D1*Dd*f**2*s**2 - 496*D1*Dd*f**2*s + 160*D1*Dd*f**2 + 272*D1*Dd*f*fd*r**2 - 1344*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r - 1616*D1*Dd*f*fd*s**2 + 1016*D1*Dd*f*fd*s + 50*D1*Dd*f*fd + 68*D1*Ddd*f**2*r**2 - 336*D1*Ddd*f**2*r*s + 134*D1*Ddd*f**2*r - 404*D1*Ddd*f**2*s**2 + 488*D1*Ddd*f**2*s - 185*D1*Ddd*f**2 + 2*D1*bd1*(-2*C*D1*fd*(74*r**2 + r*(204*s - 139) + 130*s**2 - 181*s + 51) - 2*C*Dd*f*(296*r**2 + 6*r*(136*s - 71) + 520*s**2 - 566*s + 139) + D1*f*(C*(106*r**2 + 268*r*s - 106*r + 162*s**2 - 134*s + 53) - 80*r**2 - 240*r*s + 80*r - 160*s**2 + 120*s - 40) + 34*D1*fd*(4*r**2 + 4*r*(3*s - 2) + 8*s**2 - 11*s + 3) + 68*Dd*f*(8*r**2 + 12*r*(2*s - 1) + 16*s**2 - 17*s + 4)) + 204*Dd**2*f**2*r**2 - 1008*Dd**2*f**2*r*s + 402*Dd**2*f**2*r - 1212*Dd**2*f**2*s**2 + 1464*Dd**2*f**2*s - 370*Dd**2*f**2) + f*(44*D1**2*bd1**2*(r**2*(37*C - 34) + r*(C*(102*s - 37) - 102*s + 34) + s*(C*(65*s - 51) - 68*s + 51)) + 11*D1**2*bdd1*f*(2*C*(13*r**2 + 2*r*(7*s + 30) + s**2 + 84*s - 30) - 17*r**2 + 12*r*(7*s - 10) + 101*s**2 - 276*s + 60) + 5*D1**2*(f*(fd*(2*C*(219*r**2 + 582*r*s - 340*r + 363*s**2 - 436*s + 194) - 465*r**2 - 1824*r*s + 918*r - 1359*s**2 + 1514*s - 608) + fdd*(-6*C*(75*r**2 + 6*r*(29*s - 18) + 99*s**2 - 124*s + 58) + 447*r**2 + 1638*r*s - 844*r + 1191*s**2 - 1340*s + 546)) - 2*fd**2*(6*C*(75*r**2 + 6*r*(29*s - 18) + 99*s**2 - 124*s + 29) - 447*r**2 - 1638*r*s + 844*r - 1191*s**2 + 1340*s - 273)) - 22*D1*bd1*(D1*(f*(2*C*(25*r**2 + 2*r*(13*s + 9) + s**2 + 42*s - 9) - 32*r**2 + 6*r*(4*s - 7) + 56*s**2 - 144*s + 21) - fd*(4*C*(13*r**2 + r*(14*s + 5) + s**2 + 17*s - 21) - 34*r**2 + r*(168*s - 85) + 202*s**2 - 281*s + 138)) - Dd*f*(2*C*(52*r**2 + r*(56*s + 93) + 4*s**2 + 159*s - 114) - 68*r**2 + r*(336*s - 307) + 404*s**2 - 796*s + 336)) + 5*D1*f*(Dd*(f*(2*C*(292*r**2 + r*(776*s - 534) + 484*s**2 - 678*s + 315) - 620*r**2 + r*(1526 - 2432*s) - 1812*s**2 + 2420*s - 1061) + 2*fd*(-6*C*(300*r**2 + r*(696*s - 465) + 396*s**2 - 533*s + 178) + 1788*r**2 + 7*r*(936*s - 539) + 4764*s**2 - 5881*s + 1762)) + Ddd*f*(-6*C*(100*r**2 + 2*r*(116*s - 83) + 132*s**2 - 190*s + 91) + 596*r**2 + 2*r*(1092*s - 695) + 1588*s**2 - 2134*s + 943)) - 10*Dd**2*f**2*(6*C*(150*r**2 + 3*r*(116*s - 83) + 198*s**2 - 285*s + 91) - 894*r**2 + r*(2085 - 3276*s) - 2382*s**2 + 3201*s - 943)))/(231*d**2*k3**3) - 4*D1**2*Pk1*Pkd3*ct**4*(-2*D1*f*(6*D1*bd1**2*s*(C - 1)*(2*r + 2*s - 1) + D1*bd1*(-f*s*(10*C - 7)*(r + s) + fd*(5*C - 5)*(r*(4*s - 1) + s*(4*s - 3))) + 5*D1*bdd1*f*s*(C - 1)*(r + s) + 5*Dd*bd1*f*(C - 1)*(r*(8*s - 2) + s*(8*s - 5))) + b1**2*(D1**2*(s - 1)*(fd*(24*C - 17) - fdd*(12*C - 12))*(r + s - 1) + D1*(Dd*(f*(24*C - 17)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(12*C - 12)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(12 - 12*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(12*C - 12)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(2*D1**2*(f*fd*(10*C - 7)*(2*s - 1)*(r + s - 1) - f*(C - 1)*(6*bdd1*s*(2*r + 2*s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) - fd**2*(5*C - 5)*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(f*s*(24*C - 17)*(2*r + 2*s - 1) - fd*(12*C - 12)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(24 - 24*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + 2*D1*f*(Dd*(f*(10*C - 7)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(5 - 5*C)*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(5 - 5*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 2*Dd**2*f**2*(5 - 5*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k3) - D1**2*Pk1*Pkd3*ct**4*k2**4*st**2*(132*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 330*D1**2*b1*f*fdd*r**2 + 330*D1**2*b1*f*fdd*r*s - 165*D1**2*b1*f*fdd*r + 330*D1**2*b1*fd**2*r**2 + 330*D1**2*b1*fd**2*r*s - 165*D1**2*b1*fd**2*r + 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 606*D1**2*f**2*fd*r**2 + 606*D1**2*f**2*fd*r*s - 606*D1**2*f**2*fd*r - 202*D1**2*f**2*fd*s + 202*D1**2*f**2*fd - 105*D1**2*f**2*fdd*r**2 - 105*D1**2*f**2*fdd*r*s + 105*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd*s - 35*D1**2*f**2*fdd - 210*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 70*D1**2*f*fd**2*s - 35*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r - 66*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 + 2640*D1*Dd*b1*f*fd*r**2 + 2640*D1*Dd*b1*f*fd*r*s - 1980*D1*Dd*b1*f*fd*r - 330*D1*Dd*b1*f*fd*s + 165*D1*Dd*b1*f*fd + 808*D1*Dd*f**3*r**2 + 808*D1*Dd*f**3*r*s - 808*D1*Dd*f**3*r - 202*D1*Dd*f**3*s + 202*D1*Dd*f**3 - 840*D1*Dd*f**2*fd*r**2 - 840*D1*Dd*f**2*fd*r*s + 840*D1*Dd*f**2*fd*r + 245*D1*Dd*f**2*fd*s - 175*D1*Dd*f**2*fd + 660*D1*Ddd*b1*f**2*r**2 + 660*D1*Ddd*b1*f**2*r*s - 660*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2*s + 165*D1*Ddd*b1*f**2 - 140*D1*Ddd*f**3*r**2 - 140*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 35*D1*Ddd*f**3*s - 35*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 1980*Dd**2*b1*f**2*r**2 + 1980*Dd**2*b1*f**2*r*s - 1980*Dd**2*b1*f**2*r - 495*Dd**2*b1*f**2*s + 330*Dd**2*b1*f**2 - 420*Dd**2*f**3*r**2 - 420*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 105*Dd**2*f**3*s - 70*Dd**2*f**3)/(693*d**2*k1**2*k3**3) + 2*D1**2*Pk1*Pkd3*ct**4*k2**4*(-D1*f*(66*D1*bd1**2*(2*f*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + (6*r - 3)*(r + s - 1)) + bd1*(D1*(35*f**2*r*(2*r + 2*s - 1) + f*(65*fd*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1) + 198*r + 198*s - 198) + 99*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd*f*(65*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 792*r**2 + 792*r*(s - 1) - 99*s + 99)) + f*(D1*(bdd1*r*(65*f*(2*r + 2*s - 1) + 99*r + 99*s - 99) - 165*fd*(3*r**2 + 3*r*(s - 1) - s + 1)) - 165*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1))) + 66*b1**2*(-D1**2*r*(-f*(fd - 2*fdd)*(4*r + 4*s - 3) + fd**2*(8*r + 8*s - 6) + fd*(r + s) + 3*fdd*(r + s)) + D1*(Dd*(f**2*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + f*(-2*fd*(8*r - 1)*(4*r + 4*s - 3) - 4*r**2 - 4*r*s + 4*r + s - 1) + 3*fd*(-8*r**2 + r*(4 - 8*s) + s)) - Ddd*f*(4*f + 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(4*f + 3)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-66*D1**2*bdd1*f*(2*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + (6*r - 3)*(r + s - 1)) - 210*D1**2*f**2*fd*r**2 - 210*D1**2*f**2*fd*r*s + 245*D1**2*f**2*fd*r + 70*D1**2*f**2*fd*s - 70*D1**2*f**2*fd - 390*D1**2*f**2*fdd*r**2 - 390*D1**2*f**2*fdd*r*s + 455*D1**2*f**2*fdd*r + 130*D1**2*f**2*fdd*s - 130*D1**2*f**2*fdd - 780*D1**2*f*fd**2*r**2 - 780*D1**2*f*fd**2*r*s + 910*D1**2*f*fd**2*r + 260*D1**2*f*fd**2*s - 195*D1**2*f*fd**2 + 198*D1**2*f*fd*r + 198*D1**2*f*fd*s - 198*D1**2*f*fd - 198*D1**2*f*fdd*r**2 - 198*D1**2*f*fdd*r*s + 198*D1**2*f*fdd*r + 99*D1**2*f*fdd*s - 99*D1**2*f*fdd - 198*D1**2*fd**2*r**2 - 198*D1**2*fd**2*r*s + 198*D1**2*fd**2*r + 99*D1**2*fd**2*s - 280*D1*Dd*f**3*r**2 - 280*D1*Dd*f**3*r*s + 280*D1*Dd*f**3*r + 70*D1*Dd*f**3*s - 70*D1*Dd*f**3 - 3120*D1*Dd*f**2*fd*r**2 - 3120*D1*Dd*f**2*fd*r*s + 3380*D1*Dd*f**2*fd*r + 910*D1*Dd*f**2*fd*s - 715*D1*Dd*f**2*fd - 1584*D1*Dd*f*fd*r**2 - 1584*D1*Dd*f*fd*r*s + 1584*D1*Dd*f*fd*r + 594*D1*Dd*f*fd*s - 396*D1*Dd*f*fd - 520*D1*Ddd*f**3*r**2 - 520*D1*Ddd*f**3*r*s + 520*D1*Ddd*f**3*r + 130*D1*Ddd*f**3*s - 130*D1*Ddd*f**3 - 396*D1*Ddd*f**2*r**2 - 396*D1*Ddd*f**2*r*s + 396*D1*Ddd*f**2*r + 99*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 + 66*D1*bd1*(D1*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(-2*fd*(4*r - 1)*(4*r + 4*s - 3) - (2*r - 1)*(r + s - 1)) + 3*fd*(-4*r**2 + r*(3 - 4*s) + s)) - Dd*f*(2*f*(8*r - 3)*(4*r + 4*s - 3) + 48*r**2 + 12*r*(4*s - 5) - 18*s + 15)) - 1560*Dd**2*f**3*r**2 - 1560*Dd**2*f**3*r*s + 1560*Dd**2*f**3*r + 390*Dd**2*f**3*s - 260*Dd**2*f**3 - 1188*Dd**2*f**2*r**2 - 1188*Dd**2*f**2*r*s + 1188*Dd**2*f**2*r + 297*Dd**2*f**2*s - 198*Dd**2*f**2))/(693*d**2*k1**2*k3**3) - 2*D1**2*Pk1*Pkd3*ct**4*k2**2*(3*D1*f*(2*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + D1*bdd1*f*r*(r + s) + bd1*(D1*(2*f*r*(r + s) + fd*(4*r**2 + 4*r*s - 3*r - s)) + Dd*f*(8*r**2 + r*(8*s - 4) - s))) + 2*b1**2*(D1**2*r*(fd + 3*fdd)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 4*r*(s - 1) - s + 1) + 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(6*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*D1**2*(2*r - 1)*(f*(2*fd + fdd) + fd**2)*(r + s - 1) + 2*D1*bd1*(D1*(f*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 3*D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(21*d**2*k1**2*k3) + 3*D1**2*Pk1*Pkd3*ct**3*f*k1*k2**5*st**4*(132*D1**2*bd1*f*(C - 1)*(r + s - 1)**2 + 132*D1*b1*(C - 1)*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + (100*C - 85)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**7) + 4*D1**2*Pk1*Pkd3*ct**3*f*k1*k2**3*st**4*(D1**2*(f*(22*bd1*s*(C - 1)*(r + s - 1) + fd*(60*C - 50)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(30*C - 25)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(25 - 30*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 22*D1*b1*(C - 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + D1*f*(30*C - 25)*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(25 - 30*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4))/(77*d**2*k3**5) + 15*D1**2*Pk1*Pkd3*ct**3*f*k2**7*st**4*(78*D1**2*b1*f*fd*r**2 + 156*D1**2*b1*f*fd*r*s - 104*D1**2*b1*f*fd*r + 78*D1**2*b1*f*fd*s**2 - 104*D1**2*b1*f*fd*s + 52*D1**2*b1*f*fd - 39*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*f*fdd*r*s + 52*D1**2*b1*f*fdd*r - 39*D1**2*b1*f*fdd*s**2 + 52*D1**2*b1*f*fdd*s - 26*D1**2*b1*f*fdd - 78*D1**2*b1*fd**2*r**2 - 156*D1**2*b1*fd**2*r*s + 104*D1**2*b1*fd**2*r - 78*D1**2*b1*fd**2*s**2 + 104*D1**2*b1*fd**2*s - 26*D1**2*b1*fd**2 - 13*D1**2*bdd1*f**2*(r + s - 1)**2 + 80*D1**2*f**2*fd*r**2 + 160*D1**2*f**2*fd*r*s - 120*D1**2*f**2*fd*r + 80*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 40*D1**2*f**2*fdd*r**2 - 80*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 40*D1**2*f**2*fdd*s**2 + 60*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 180*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 180*D1**2*f*fd**2*s - 60*D1**2*f*fd**2 + 104*D1*Dd*b1*f**2*r**2 + 208*D1*Dd*b1*f**2*r*s - 156*D1*Dd*b1*f**2*r + 104*D1*Dd*b1*f**2*s**2 - 156*D1*Dd*b1*f**2*s + 78*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 - 624*D1*Dd*b1*f*fd*r*s + 442*D1*Dd*b1*f*fd*r - 312*D1*Dd*b1*f*fd*s**2 + 442*D1*Dd*b1*f*fd*s - 156*D1*Dd*b1*f*fd + 80*D1*Dd*f**3*r**2 + 160*D1*Dd*f**3*r*s - 120*D1*Dd*f**3*r + 80*D1*Dd*f**3*s**2 - 120*D1*Dd*f**3*s + 60*D1*Dd*f**3 - 320*D1*Dd*f**2*fd*r**2 - 640*D1*Dd*f**2*fd*r*s + 480*D1*Dd*f**2*fd*r - 320*D1*Dd*f**2*fd*s**2 + 480*D1*Dd*f**2*fd*s - 180*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 - 104*D1*Ddd*b1*f**2*r*s + 78*D1*Ddd*b1*f**2*r - 52*D1*Ddd*b1*f**2*s**2 + 78*D1*Ddd*b1*f**2*s - 39*D1*Ddd*b1*f**2 - 40*D1*Ddd*f**3*r**2 - 80*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 40*D1*Ddd*f**3*s**2 + 60*D1*Ddd*f**3*s - 30*D1*Ddd*f**3 + 26*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 156*Dd**2*b1*f**2*r**2 - 312*Dd**2*b1*f**2*r*s + 234*Dd**2*b1*f**2*r - 156*Dd**2*b1*f**2*s**2 + 234*Dd**2*b1*f**2*s - 78*Dd**2*b1*f**2 - 120*Dd**2*f**3*r**2 - 240*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 120*Dd**2*f**3*s**2 + 180*Dd**2*f**3*s - 60*Dd**2*f**3)/(143*d**2*k1*k3**7) + D1**2*Pk1*Pkd3*ct**3*f*k2**5*st**4*(264*D1**2*bd1*f*(C - 1)*(r - 1)*(r + s - 1) - 5*D1**2*(f*(2*fd - fdd)*(8*C*(3*r**2 + 3*r*(s - 1) - s + 1) - 69*r**2 + r*(84 - 114*s) - 45*s**2 + 68*s - 38) + 2*fd**2*(-4*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 69*r**2 + 6*r*(19*s - 14) + 45*s**2 - 68*s + 19)) + 264*D1*b1*(C - 1)*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*D1*f*(2*Dd*(f*(8*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 92*r**2 - 152*r*s + 122*r - 60*s**2 + 98*s - 53) + fd*(-4*C*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 276*r**2 + 456*r*s - 351*r + 180*s**2 - 283*s + 110)) + Ddd*f*(-8*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 92*r**2 + 2*r*(76*s - 61) + 60*s**2 - 98*s + 53)) - 10*Dd**2*f**2*(-4*C*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 138*r**2 + 3*r*(76*s - 61) + 90*s**2 - 147*s + 53))/(231*d**2*k1*k3**5) + 20*D1**2*Pk1*Pkd3*ct**3*f*k2**3*st**4*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4))/(77*d**2*k1*k3**3) + D1**2*Pk1*Pkd3*ct**3*k1**5*k2*(12*C - 7)*(264*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r + 264*D1**2*b1*f*fd*s**2 - 264*D1**2*b1*f*fd*s + 132*D1**2*b1*f*fd - 330*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 330*D1**2*b1*f*fdd*s**2 + 330*D1**2*b1*f*fdd*s - 165*D1**2*b1*f*fdd - 330*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r - 330*D1**2*b1*fd**2*s**2 + 330*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)**2 + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 792*D1*Dd*b1*f**2*r + 528*D1*Dd*b1*f**2*s**2 - 792*D1*Dd*b1*f**2*s + 396*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 3300*D1*Dd*b1*f*fd*r - 2640*D1*Dd*b1*f*fd*s**2 + 3300*D1*Dd*b1*f*fd*s - 990*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 690*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 690*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 990*D1*Ddd*b1*f**2*r - 660*D1*Ddd*b1*f**2*s**2 + 990*D1*Ddd*b1*f**2*s - 495*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 1980*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 2970*Dd**2*b1*f**2*r - 1980*Dd**2*b1*f**2*s**2 + 2970*Dd**2*b1*f**2*s - 990*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3)/(77*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**3*k1**5*(8*C - 4)*(33*b1*(D1**2*(f*(4*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(4*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(2*s - 1)*(8*r + 8*s - 5)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-5*D1**2*(f*(33*bdd1*s*(r + s - 1) - 23*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(D1*(4*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) - 5*D1*f*(Dd*(-23*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 28*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) + 28*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 140*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k2*k3**5) + D1**2*Pk1*Pkd3*ct**3*k1**3*k2**3*st**2*(12672*C*D1**2*b1*f*fd*r**2 + 25344*C*D1**2*b1*f*fd*r*s - 12672*C*D1**2*b1*f*fd*r + 12672*C*D1**2*b1*f*fd*s**2 - 12672*C*D1**2*b1*f*fd*s + 6336*C*D1**2*b1*f*fd - 8184*C*D1**2*b1*f*fdd*r**2 - 16368*C*D1**2*b1*f*fdd*r*s + 8184*C*D1**2*b1*f*fdd*r - 8184*C*D1**2*b1*f*fdd*s**2 + 8184*C*D1**2*b1*f*fdd*s - 4092*C*D1**2*b1*f*fdd - 8184*C*D1**2*b1*fd**2*r**2 - 16368*C*D1**2*b1*fd**2*r*s + 8184*C*D1**2*b1*fd**2*r - 8184*C*D1**2*b1*fd**2*s**2 + 8184*C*D1**2*b1*fd**2*s + 13056*C*D1**2*f**2*fd*r**2 + 26112*C*D1**2*f**2*fd*r*s - 17408*C*D1**2*f**2*fd*r + 13056*C*D1**2*f**2*fd*s**2 - 17408*C*D1**2*f**2*fd*s + 8704*C*D1**2*f**2*fd - 9300*C*D1**2*f**2*fdd*r**2 - 18600*C*D1**2*f**2*fdd*r*s + 12400*C*D1**2*f**2*fdd*r - 9300*C*D1**2*f**2*fdd*s**2 + 12400*C*D1**2*f**2*fdd*s - 6200*C*D1**2*f**2*fdd - 18600*C*D1**2*f*fd**2*r**2 - 37200*C*D1**2*f*fd**2*r*s + 24800*C*D1**2*f*fd**2*r - 18600*C*D1**2*f*fd**2*s**2 + 24800*C*D1**2*f*fd**2*s - 6200*C*D1**2*f*fd**2 + 25344*C*D1*Dd*b1*f**2*r**2 + 50688*C*D1*Dd*b1*f**2*r*s - 38016*C*D1*Dd*b1*f**2*r + 25344*C*D1*Dd*b1*f**2*s**2 - 38016*C*D1*Dd*b1*f**2*s + 19008*C*D1*Dd*b1*f**2 - 65472*C*D1*Dd*b1*f*fd*r**2 - 130944*C*D1*Dd*b1*f*fd*r*s + 81840*C*D1*Dd*b1*f*fd*r - 65472*C*D1*Dd*b1*f*fd*s**2 + 81840*C*D1*Dd*b1*f*fd*s - 24552*C*D1*Dd*b1*f*fd + 17408*C*D1*Dd*f**3*r**2 + 34816*C*D1*Dd*f**3*r*s - 26112*C*D1*Dd*f**3*r + 17408*C*D1*Dd*f**3*s**2 - 26112*C*D1*Dd*f**3*s + 13056*C*D1*Dd*f**3 - 74400*C*D1*Dd*f**2*fd*r**2 - 148800*C*D1*Dd*f**2*fd*r*s + 105400*C*D1*Dd*f**2*fd*r - 74400*C*D1*Dd*f**2*fd*s**2 + 105400*C*D1*Dd*f**2*fd*s - 37200*C*D1*Dd*f**2*fd - 16368*C*D1*Ddd*b1*f**2*r**2 - 32736*C*D1*Ddd*b1*f**2*r*s + 24552*C*D1*Ddd*b1*f**2*r - 16368*C*D1*Ddd*b1*f**2*s**2 + 24552*C*D1*Ddd*b1*f**2*s - 12276*C*D1*Ddd*b1*f**2 - 12400*C*D1*Ddd*f**3*r**2 - 24800*C*D1*Ddd*f**3*r*s + 18600*C*D1*Ddd*f**3*r - 12400*C*D1*Ddd*f**3*s**2 + 18600*C*D1*Ddd*f**3*s - 9300*C*D1*Ddd*f**3 - 49104*C*Dd**2*b1*f**2*r**2 - 98208*C*Dd**2*b1*f**2*r*s + 73656*C*Dd**2*b1*f**2*r - 49104*C*Dd**2*b1*f**2*s**2 + 73656*C*Dd**2*b1*f**2*s - 24552*C*Dd**2*b1*f**2 - 37200*C*Dd**2*f**3*r**2 - 74400*C*Dd**2*f**3*r*s + 55800*C*Dd**2*f**3*r - 37200*C*Dd**2*f**3*s**2 + 55800*C*Dd**2*f**3*s - 18600*C*Dd**2*f**3 - 8646*D1**2*b1*f*fd*r**2 - 17292*D1**2*b1*f*fd*r*s + 8646*D1**2*b1*f*fd*r - 8646*D1**2*b1*f*fd*s**2 + 8646*D1**2*b1*f*fd*s - 4323*D1**2*b1*f*fd + 5676*D1**2*b1*f*fdd*r**2 + 11352*D1**2*b1*f*fdd*r*s - 5676*D1**2*b1*f*fdd*r + 5676*D1**2*b1*f*fdd*s**2 - 5676*D1**2*b1*f*fdd*s + 2838*D1**2*b1*f*fdd + 5676*D1**2*b1*fd**2*r**2 + 11352*D1**2*b1*fd**2*r*s - 5676*D1**2*b1*fd**2*r + 5676*D1**2*b1*fd**2*s**2 - 5676*D1**2*b1*fd**2*s - 66*D1**2*bdd1*f**2*(62*C - 43)*(r + s - 1)**2 - 8841*D1**2*f**2*fd*r**2 - 17682*D1**2*f**2*fd*r*s + 11788*D1**2*f**2*fd*r - 8841*D1**2*f**2*fd*s**2 + 11788*D1**2*f**2*fd*s - 5894*D1**2*f**2*fd + 6450*D1**2*f**2*fdd*r**2 + 12900*D1**2*f**2*fdd*r*s - 8600*D1**2*f**2*fdd*r + 6450*D1**2*f**2*fdd*s**2 - 8600*D1**2*f**2*fdd*s + 4300*D1**2*f**2*fdd + 12900*D1**2*f*fd**2*r**2 + 25800*D1**2*f*fd**2*r*s - 17200*D1**2*f*fd**2*r + 12900*D1**2*f*fd**2*s**2 - 17200*D1**2*f*fd**2*s + 4300*D1**2*f*fd**2 - 17292*D1*Dd*b1*f**2*r**2 - 34584*D1*Dd*b1*f**2*r*s + 25938*D1*Dd*b1*f**2*r - 17292*D1*Dd*b1*f**2*s**2 + 25938*D1*Dd*b1*f**2*s - 12969*D1*Dd*b1*f**2 + 45408*D1*Dd*b1*f*fd*r**2 + 90816*D1*Dd*b1*f*fd*r*s - 56760*D1*Dd*b1*f*fd*r + 45408*D1*Dd*b1*f*fd*s**2 - 56760*D1*Dd*b1*f*fd*s + 17028*D1*Dd*b1*f*fd - 11788*D1*Dd*f**3*r**2 - 23576*D1*Dd*f**3*r*s + 17682*D1*Dd*f**3*r - 11788*D1*Dd*f**3*s**2 + 17682*D1*Dd*f**3*s - 8841*D1*Dd*f**3 + 51600*D1*Dd*f**2*fd*r**2 + 103200*D1*Dd*f**2*fd*r*s - 73100*D1*Dd*f**2*fd*r + 51600*D1*Dd*f**2*fd*s**2 - 73100*D1*Dd*f**2*fd*s + 25800*D1*Dd*f**2*fd + 11352*D1*Ddd*b1*f**2*r**2 + 22704*D1*Ddd*b1*f**2*r*s - 17028*D1*Ddd*b1*f**2*r + 11352*D1*Ddd*b1*f**2*s**2 - 17028*D1*Ddd*b1*f**2*s + 8514*D1*Ddd*b1*f**2 + 8600*D1*Ddd*f**3*r**2 + 17200*D1*Ddd*f**3*r*s - 12900*D1*Ddd*f**3*r + 8600*D1*Ddd*f**3*s**2 - 12900*D1*Ddd*f**3*s + 6450*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(192*C - 131)*(r + s - 1) - D1*fd*(248*C - 172)*(2*r + 2*s - 1) - Dd*f*(248*C - 172)*(4*r + 4*s - 3)) + 34056*Dd**2*b1*f**2*r**2 + 68112*Dd**2*b1*f**2*r*s - 51084*Dd**2*b1*f**2*r + 34056*Dd**2*b1*f**2*s**2 - 51084*Dd**2*b1*f**2*s + 17028*Dd**2*b1*f**2 + 25800*Dd**2*f**3*r**2 + 51600*Dd**2*f**3*r*s - 38700*Dd**2*f**3*r + 25800*Dd**2*f**3*s**2 - 38700*Dd**2*f**3*s + 12900*Dd**2*f**3)/(77*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**3*k1**3*k2**3*(-51480*C*D1**2*f**2*fd*r**2 - 102960*C*D1**2*f**2*fd*r*s + 68640*C*D1**2*f**2*fd*r - 51480*C*D1**2*f**2*fd*s**2 + 68640*C*D1**2*f**2*fd*s - 34320*C*D1**2*f**2*fd - 68640*C*D1*Dd*f**3*r**2 - 137280*C*D1*Dd*f**3*r*s + 102960*C*D1*Dd*f**3*r - 68640*C*D1*Dd*f**3*s**2 + 102960*C*D1*Dd*f**3*s - 51480*C*D1*Dd*f**3 - 42900*D1**2*K*bdd1*f**2*r**2 - 85800*D1**2*K*bdd1*f**2*r*s + 85800*D1**2*K*bdd1*f**2*r - 42900*D1**2*K*bdd1*f**2*s**2 + 85800*D1**2*K*bdd1*f**2*s - 42900*D1**2*K*bdd1*f**2 + 8580*D1**2*bd1**2*f*(-12*K + 5*f + 6)*(r + s - 1)**2 + 9100*D1**2*bdd1*f**3*r**2 + 18200*D1**2*bdd1*f**3*r*s - 18200*D1**2*bdd1*f**3*r + 9100*D1**2*bdd1*f**3*s**2 - 18200*D1**2*bdd1*f**3*s + 9100*D1**2*bdd1*f**3 + 21450*D1**2*bdd1*f**2*r**2 + 42900*D1**2*bdd1*f**2*r*s - 42900*D1**2*bdd1*f**2*r + 21450*D1**2*bdd1*f**2*s**2 - 42900*D1**2*bdd1*f**2*s + 21450*D1**2*bdd1*f**2 + 102960*D1**2*bdd1*f*g2*r**2 + 205920*D1**2*bdd1*f*g2*r*s - 205920*D1**2*bdd1*f*g2*r + 102960*D1**2*bdd1*f*g2*s**2 - 205920*D1**2*bdd1*f*g2*s + 102960*D1**2*bdd1*f*g2 + 26600*D1**2*f**3*fd*r**2 + 53200*D1**2*f**3*fd*r*s - 39900*D1**2*f**3*fd*r + 26600*D1**2*f**3*fd*s**2 - 39900*D1**2*f**3*fd*s + 19950*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 + 32175*D1**2*f**2*fd*r**2 + 64350*D1**2*f**2*fd*r*s - 42900*D1**2*f**2*fd*r + 32175*D1**2*f**2*fd*s**2 - 42900*D1**2*f**2*fd*s + 21450*D1**2*f**2*fd - 89232*D1**2*f**2*gd2*r**2 - 178464*D1**2*f**2*gd2*r*s + 178464*D1**2*f**2*gd2*r - 89232*D1**2*f**2*gd2*s**2 + 178464*D1**2*f**2*gd2*s - 89232*D1**2*f**2*gd2 + 85800*D1**2*f**2*gdd2*r**2 + 171600*D1**2*f**2*gdd2*r*s - 171600*D1**2*f**2*gdd2*r + 85800*D1**2*f**2*gdd2*s**2 - 171600*D1**2*f**2*gdd2*s + 85800*D1**2*f**2*gdd2 - 178464*D1**2*f*fd*g2*r**2 - 356928*D1**2*f*fd*g2*r*s + 178464*D1**2*f*fd*g2*r - 178464*D1**2*f*fd*g2*s**2 + 178464*D1**2*f*fd*g2*s - 89232*D1**2*f*fd*g2 + 343200*D1**2*f*fd*gd2*r**2 + 686400*D1**2*f*fd*gd2*r*s - 514800*D1**2*f*fd*gd2*r + 343200*D1**2*f*fd*gd2*s**2 - 514800*D1**2*f*fd*gd2*s + 171600*D1**2*f*fd*gd2 + 171600*D1**2*f*fdd*g2*r**2 + 343200*D1**2*f*fdd*g2*r*s - 171600*D1**2*f*fdd*g2*r + 171600*D1**2*f*fdd*g2*s**2 - 171600*D1**2*f*fdd*g2*s + 85800*D1**2*f*fdd*g2 + 171600*D1**2*fd**2*g2*r**2 + 343200*D1**2*fd**2*g2*r*s - 171600*D1**2*fd**2*g2*r + 171600*D1**2*fd**2*g2*s**2 - 171600*D1**2*fd**2*g2*s + 26600*D1*Dd*f**4*r**2 + 53200*D1*Dd*f**4*r*s - 39900*D1*Dd*f**4*r + 26600*D1*Dd*f**4*s**2 - 39900*D1*Dd*f**4*s + 19950*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd + 42900*D1*Dd*f**3*r**2 + 85800*D1*Dd*f**3*r*s - 64350*D1*Dd*f**3*r + 42900*D1*Dd*f**3*s**2 - 64350*D1*Dd*f**3*s + 32175*D1*Dd*f**3 - 356928*D1*Dd*f**2*g2*r**2 - 713856*D1*Dd*f**2*g2*r*s + 535392*D1*Dd*f**2*g2*r - 356928*D1*Dd*f**2*g2*s**2 + 535392*D1*Dd*f**2*g2*s - 267696*D1*Dd*f**2*g2 + 686400*D1*Dd*f**2*gd2*r**2 + 1372800*D1*Dd*f**2*gd2*r*s - 1201200*D1*Dd*f**2*gd2*r + 686400*D1*Dd*f**2*gd2*s**2 - 1201200*D1*Dd*f**2*gd2*s + 514800*D1*Dd*f**2*gd2 + 1372800*D1*Dd*f*fd*g2*r**2 + 2745600*D1*Dd*f*fd*g2*r*s - 1716000*D1*Dd*f*fd*g2*r + 1372800*D1*Dd*f*fd*g2*s**2 - 1716000*D1*Dd*f*fd*g2*s + 514800*D1*Dd*f*fd*g2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 343200*D1*Ddd*f**2*g2*r**2 + 686400*D1*Ddd*f**2*g2*r*s - 514800*D1*Ddd*f**2*g2*r + 343200*D1*Ddd*f**2*g2*s**2 - 514800*D1*Ddd*f**2*g2*s + 257400*D1*Ddd*f**2*g2 - 52*D1*bd1*(D1*(185*f**3*(r + s - 1) + 2*f**2*(198*C*(r + s - 1) - 175*fd*(3*r + 3*s - 2) - (429*K - 66)*(r + s - 1)) + 33*f*(25*fd*(2*K - 1)*(2*r + 2*s - 1) + (64*g2 - 120*gd2)*(r + s - 1)) - 3960*fd*g2*(r + s)) - 5*Dd*f*(70*f**2 - 165*f*(2*K - 1) + 792*g2)*(4*r + 4*s - 3))*(r + s - 1) - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 1029600*Dd**2*f**2*g2*r**2 + 2059200*Dd**2*f**2*g2*r*s - 1544400*Dd**2*f**2*g2*r + 1029600*Dd**2*f**2*g2*s**2 - 1544400*Dd**2*f**2*g2*s + 514800*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(2*f*(23*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(128*K - 57)*(r + s) - 60*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(46*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (128*K - 57)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 120*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 10*Ddd*f*(-12*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f*(-12*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 26*b1*(1584*C*D1**2*f*fd*r**2 + 3168*C*D1**2*f*fd*r*s - 1584*C*D1**2*f*fd*r + 1584*C*D1**2*f*fd*s**2 - 1584*C*D1**2*f*fd*s + 792*C*D1**2*f*fd + 3168*C*D1*Dd*f**2*r**2 + 6336*C*D1*Dd*f**2*r*s - 4752*C*D1*Dd*f**2*r + 3168*C*D1*Dd*f**2*s**2 - 4752*C*D1*Dd*f**2*s + 2376*C*D1*Dd*f**2 - 3432*D1**2*K*f*fd*r**2 - 6864*D1**2*K*f*fd*r*s + 3432*D1**2*K*f*fd*r - 3432*D1**2*K*f*fd*s**2 + 3432*D1**2*K*f*fd*s - 1716*D1**2*K*f*fd + 3300*D1**2*K*f*fdd*r**2 + 6600*D1**2*K*f*fdd*r*s - 3300*D1**2*K*f*fdd*r + 3300*D1**2*K*f*fdd*s**2 - 3300*D1**2*K*f*fdd*s + 1650*D1**2*K*f*fdd + 3300*D1**2*K*fd**2*r**2 + 6600*D1**2*K*fd**2*r*s - 3300*D1**2*K*fd**2*r + 3300*D1**2*K*fd**2*s**2 - 3300*D1**2*K*fd**2*s - 330*D1**2*bdd1*f*(-12*K + 5*f + 6)*(r + s - 1)**2 + 1110*D1**2*f**2*fd*r**2 + 2220*D1**2*f**2*fd*r*s - 1480*D1**2*f**2*fd*r + 1110*D1**2*f**2*fd*s**2 - 1480*D1**2*f**2*fd*s + 740*D1**2*f**2*fd - 1050*D1**2*f**2*fdd*r**2 - 2100*D1**2*f**2*fdd*r*s + 1400*D1**2*f**2*fdd*r - 1050*D1**2*f**2*fdd*s**2 + 1400*D1**2*f**2*fdd*s - 700*D1**2*f**2*fdd - 2100*D1**2*f*fd**2*r**2 - 4200*D1**2*f*fd**2*r*s + 2800*D1**2*f*fd**2*r - 2100*D1**2*f*fd**2*s**2 + 2800*D1**2*f*fd**2*s - 700*D1**2*f*fd**2 + 528*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 528*D1**2*f*fd*r + 528*D1**2*f*fd*s**2 - 528*D1**2*f*fd*s + 264*D1**2*f*fd - 1650*D1**2*f*fdd*r**2 - 3300*D1**2*f*fdd*r*s + 1650*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1650*D1**2*f*fdd*s - 825*D1**2*f*fdd + 4224*D1**2*f*gd2*r**2 + 8448*D1**2*f*gd2*r*s - 8448*D1**2*f*gd2*r + 4224*D1**2*f*gd2*s**2 - 8448*D1**2*f*gd2*s + 4224*D1**2*f*gd2 - 3960*D1**2*f*gdd2*r**2 - 7920*D1**2*f*gdd2*r*s + 7920*D1**2*f*gdd2*r - 3960*D1**2*f*gdd2*s**2 + 7920*D1**2*f*gdd2*s - 3960*D1**2*f*gdd2 - 1650*D1**2*fd**2*r**2 - 3300*D1**2*fd**2*r*s + 1650*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1650*D1**2*fd**2*s + 4224*D1**2*fd*g2*r**2 + 8448*D1**2*fd*g2*r*s + 4224*D1**2*fd*g2*s**2 - 7920*D1**2*fd*gd2*r**2 - 15840*D1**2*fd*gd2*r*s + 7920*D1**2*fd*gd2*r - 7920*D1**2*fd*gd2*s**2 + 7920*D1**2*fd*gd2*s - 3960*D1**2*fdd*g2*r**2 - 7920*D1**2*fdd*g2*r*s - 3960*D1**2*fdd*g2*s**2 - 6864*D1*Dd*K*f**2*r**2 - 13728*D1*Dd*K*f**2*r*s + 10296*D1*Dd*K*f**2*r - 6864*D1*Dd*K*f**2*s**2 + 10296*D1*Dd*K*f**2*s - 5148*D1*Dd*K*f**2 + 26400*D1*Dd*K*f*fd*r**2 + 52800*D1*Dd*K*f*fd*r*s - 33000*D1*Dd*K*f*fd*r + 26400*D1*Dd*K*f*fd*s**2 - 33000*D1*Dd*K*f*fd*s + 9900*D1*Dd*K*f*fd + 1480*D1*Dd*f**3*r**2 + 2960*D1*Dd*f**3*r*s - 2220*D1*Dd*f**3*r + 1480*D1*Dd*f**3*s**2 - 2220*D1*Dd*f**3*s + 1110*D1*Dd*f**3 - 8400*D1*Dd*f**2*fd*r**2 - 16800*D1*Dd*f**2*fd*r*s + 11900*D1*Dd*f**2*fd*r - 8400*D1*Dd*f**2*fd*s**2 + 11900*D1*Dd*f**2*fd*s - 4200*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 1584*D1*Dd*f**2*r + 1056*D1*Dd*f**2*s**2 - 1584*D1*Dd*f**2*s + 792*D1*Dd*f**2 - 13200*D1*Dd*f*fd*r**2 - 26400*D1*Dd*f*fd*r*s + 16500*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 16500*D1*Dd*f*fd*s - 4950*D1*Dd*f*fd + 16896*D1*Dd*f*g2*r**2 + 33792*D1*Dd*f*g2*r*s - 25344*D1*Dd*f*g2*r + 16896*D1*Dd*f*g2*s**2 - 25344*D1*Dd*f*g2*s + 12672*D1*Dd*f*g2 - 31680*D1*Dd*f*gd2*r**2 - 63360*D1*Dd*f*gd2*r*s + 55440*D1*Dd*f*gd2*r - 31680*D1*Dd*f*gd2*s**2 + 55440*D1*Dd*f*gd2*s - 23760*D1*Dd*f*gd2 - 31680*D1*Dd*fd*g2*r**2 - 63360*D1*Dd*fd*g2*r*s + 23760*D1*Dd*fd*g2*r - 31680*D1*Dd*fd*g2*s**2 + 23760*D1*Dd*fd*g2*s + 6600*D1*Ddd*K*f**2*r**2 + 13200*D1*Ddd*K*f**2*r*s - 9900*D1*Ddd*K*f**2*r + 6600*D1*Ddd*K*f**2*s**2 - 9900*D1*Ddd*K*f**2*s + 4950*D1*Ddd*K*f**2 - 1400*D1*Ddd*f**3*r**2 - 2800*D1*Ddd*f**3*r*s + 2100*D1*Ddd*f**3*r - 1400*D1*Ddd*f**3*s**2 + 2100*D1*Ddd*f**3*s - 1050*D1*Ddd*f**3 - 3300*D1*Ddd*f**2*r**2 - 6600*D1*Ddd*f**2*r*s + 4950*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 4950*D1*Ddd*f**2*s - 2475*D1*Ddd*f**2 - 15840*D1*Ddd*f*g2*r**2 - 31680*D1*Ddd*f*g2*r*s + 23760*D1*Ddd*f*g2*r - 15840*D1*Ddd*f*g2*s**2 + 23760*D1*Ddd*f*g2*s - 11880*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(46*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(128*K - 57)*(r + s - 1) + 120*fd*(2*K - 1)*(r + s)) - 20*Dd*f*(-12*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 19800*Dd**2*K*f**2*r**2 + 39600*Dd**2*K*f**2*r*s - 29700*Dd**2*K*f**2*r + 19800*Dd**2*K*f**2*s**2 - 29700*Dd**2*K*f**2*s + 9900*Dd**2*K*f**2 - 4200*Dd**2*f**3*r**2 - 8400*Dd**2*f**3*r*s + 6300*Dd**2*f**3*r - 4200*Dd**2*f**3*s**2 + 6300*Dd**2*f**3*s - 2100*Dd**2*f**3 - 9900*Dd**2*f**2*r**2 - 19800*Dd**2*f**2*r*s + 14850*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 14850*Dd**2*f**2*s - 4950*Dd**2*f**2 - 47520*Dd**2*f*g2*r**2 - 95040*Dd**2*f*g2*r*s + 71280*Dd**2*f*g2*r - 47520*Dd**2*f*g2*s**2 + 71280*Dd**2*f*g2*s - 23760*Dd**2*f*g2))/(1001*d**2*k3**7) + 4*D1**2*Pk1*Pkd3*ct**3*k1**3*k2*st**2*(11*b1*(D1**2*(f*(fd*(119*C - 77) + fdd*(45 - 69*C))*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(45 - 69*C)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f*(119*C - 77)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(45 - 69*C)*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(45 - 69*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(45 - 69*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(fd*(941*C - 607)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - (23*C - 15)*(33*bdd1*s*(r + s - 1) + 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(375 - 575*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(D1*(f*s*(119*C - 77)*(r + s - 1) - fd*(69*C - 45)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(45 - 69*C)*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(f*(941*C - 607)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(575*C - 375)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(375 - 575*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(375 - 575*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**3*k1**3*k2*(165*b1**2*(8*C - 5)*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-544*C*D1**2*f*fd*r**2 - 2432*C*D1**2*f*fd*r*s + 896*C*D1**2*f*fd*r - 1888*C*D1**2*f*fd*s**2 + 1568*C*D1**2*f*fd*s - 784*C*D1**2*f*fd + 800*C*D1**2*f*fdd*r**2 + 2560*C*D1**2*f*fdd*r*s - 880*C*D1**2*f*fdd*r + 1760*C*D1**2*f*fdd*s**2 - 1360*C*D1**2*f*fdd*s + 680*C*D1**2*f*fdd + 800*C*D1**2*fd**2*r**2 + 2560*C*D1**2*fd**2*r*s - 880*C*D1**2*fd**2*r + 1760*C*D1**2*fd**2*s**2 - 1360*C*D1**2*fd**2*s - 400*C*D1**2*fd**2 - 1088*C*D1*Dd*f**2*r**2 - 4864*C*D1*Dd*f**2*r*s + 2976*C*D1*Dd*f**2*r - 3776*C*D1*Dd*f**2*s**2 + 4992*C*D1*Dd*f**2*s - 2160*C*D1*Dd*f**2 + 6400*C*D1*Dd*f*fd*r**2 + 20480*C*D1*Dd*f*fd*r*s - 10240*C*D1*Dd*f*fd*r + 14080*C*D1*Dd*f*fd*s**2 - 15040*C*D1*Dd*f*fd*s + 3600*C*D1*Dd*f*fd + 1600*C*D1*Ddd*f**2*r**2 + 5120*C*D1*Ddd*f**2*r*s - 3360*C*D1*Ddd*f**2*r + 3520*C*D1*Ddd*f**2*s**2 - 4800*C*D1*Ddd*f**2*s + 2160*C*D1*Ddd*f**2 + 4800*C*Dd**2*f**2*r**2 + 15360*C*Dd**2*f**2*r*s - 10080*C*Dd**2*f**2*r + 10560*C*Dd**2*f**2*s**2 - 14400*C*Dd**2*f**2*s + 4320*C*Dd**2*f**2 - 30*D1**2*bdd1*f*(8*C - 5)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 324*D1**2*f*fd*r**2 + 1624*D1**2*f*fd*r*s - 612*D1**2*f*fd*r + 1300*D1**2*f*fd*s**2 - 1100*D1**2*f*fd*s + 550*D1**2*f*fd - 480*D1**2*f*fdd*r**2 - 1712*D1**2*f*fdd*r*s + 606*D1**2*f*fdd*r - 1232*D1**2*f*fdd*s**2 + 982*D1**2*f*fdd*s - 491*D1**2*f*fdd - 480*D1**2*fd**2*r**2 - 1712*D1**2*fd**2*r*s + 606*D1**2*fd**2*r - 1232*D1**2*fd**2*s**2 + 982*D1**2*fd**2*s + 250*D1**2*fd**2 + 648*D1*Dd*f**2*r**2 + 3248*D1*Dd*f**2*r*s - 1948*D1*Dd*f**2*r + 2600*D1*Dd*f**2*s**2 - 3412*D1*Dd*f**2*s + 1462*D1*Dd*f**2 - 3840*D1*Dd*f*fd*r**2 - 13696*D1*Dd*f*fd*r*s + 6808*D1*Dd*f*fd*r - 9856*D1*Dd*f*fd*s**2 + 10568*D1*Dd*f*fd*s - 2570*D1*Dd*f*fd - 960*D1*Ddd*f**2*r**2 - 3424*D1*Ddd*f**2*r*s + 2192*D1*Ddd*f**2*r - 2464*D1*Ddd*f**2*s**2 + 3320*D1*Ddd*f**2*s - 1472*D1*Ddd*f**2 + 5*D1*bd1*(8*C - 5)*(D1*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 12*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2880*Dd**2*f**2*r**2 - 10272*Dd**2*f**2*r*s + 6576*Dd**2*f**2*r - 7392*Dd**2*f**2*s**2 + 9960*Dd**2*f**2*s - 2944*Dd**2*f**2) + f*(-1980*D1**2*bd1**2*(8*C - 5)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(40*C*(10*r**2 + r*(32*s - 30) + 22*s**2 - 42*s + 15) - 240*r**2 + r*(730 - 856*s) - 616*s**2 + 1106*s - 365) - 5*D1**2*(f*(4*fd*(8*C*(267*r**2 + r*(843*s - 459) + 576*s**2 - 665*s + 281) - 1293*r**2 + r*(2337 - 4425*s) - 3132*s**2 + 3563*s - 1475) + fdd*(-8*C*(1326*r**2 + 3*r*(1189*s - 691) + 2241*s**2 - 2683*s + 1189) + 6447*r**2 + 6*r*(3125*s - 1758) + 12303*s**2 - 14452*s + 6250)) + 2*fd**2*(-4*C*(2652*r**2 + 6*r*(1189*s - 691) + 4482*s**2 - 5366*s + 1189) + 6447*r**2 + 6*r*(3125*s - 1758) + 12303*s**2 - 14452*s + 3125)) - 66*D1*bd1*(D1*(f*(8*C*(17*r**2 + 76*r*s - 54*r + 59*s**2 - 96*s + 27) - 81*r**2 - 406*r*s + 262*r - 325*s**2 + 506*s - 131) + fd*(-40*C*(20*r**2 + 64*r*s - 41*r + 44*s**2 - 59*s + 21) + 480*r**2 + 1712*r*s - 1033*r + 1232*s**2 - 1597*s + 553)) + Dd*f*(-40*C*(40*r**2 + 2*r*(64*s - 51) + 88*s**2 - 144*s + 57) + 960*r**2 + 4*r*(856*s - 639) + 2464*s**2 - 3872*s + 1471)) - 5*D1*f*(2*Dd*(2*f*(8*C*(356*r**2 + 1124*r*s - 740*r + 768*s**2 - 1049*s + 473) - 1724*r**2 - 5900*r*s + 3812*r - 4176*s**2 + 5651*s - 2519) + fd*(-4*C*(10608*r**2 + 6*r*(4756*s - 3013) + 17928*s**2 - 23263*s + 7439) + 25788*r**2 + 75000*r*s - 46293*r + 49212*s**2 - 62885*s + 19726)) + Ddd*f*(-8*C*(1768*r**2 + 4756*r*s - 3262*r + 2988*s**2 - 4177*s + 1936) + 8596*r**2 + 25000*r*s - 16798*r + 16404*s**2 - 22654*s + 10351)) - 10*Dd**2*f**2*(-4*C*(5304*r**2 + 6*r*(2378*s - 1631) + 8964*s**2 - 12531*s + 3872) + 12894*r**2 + 3*r*(12500*s - 8399) + 24606*s**2 - 33981*s + 10351)))/(693*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**3*k1**3*(8*C - 4)*(33*D1*b1*(D1*bd1*(5*f*s*(2*r + 2*s - 1) - 6*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - 4*D1*f*fd*s + D1*f*s*(-6*bdd1*(2*r + 2*s - 1) + 5*fdd) + 5*D1*fd**2*(s - 1) - 12*Dd*bd1*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1) + 10*Dd*f*fd*(2*s - 1)) + 33*b1**2*(D1**2*(5*fd - 6*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 6*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 6*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 6*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-198*D1**2*bd1**2*s*(2*r + 2*s - 1) - 5*D1**2*(f*(33*bdd1*s + 23*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 33*D1*bd1*(4*D1*f*s - 5*D1*fd*(s - 1) + 10*Dd*f*(1 - 2*s)) - 5*D1*f*(Dd*(23*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 28*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 28*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 140*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(693*d**2*k2*k3**3) + D1**2*Pk1*Pkd3*ct**3*k1*k2**5*st**2*(-23166*C*D1**2*f**2*fd*r**2 - 46332*C*D1**2*f**2*fd*r*s + 30888*C*D1**2*f**2*fd*r - 23166*C*D1**2*f**2*fd*s**2 + 30888*C*D1**2*f**2*fd*s - 15444*C*D1**2*f**2*fd - 30888*C*D1*Dd*f**3*r**2 - 61776*C*D1*Dd*f**3*r*s + 46332*C*D1*Dd*f**3*r - 30888*C*D1*Dd*f**3*s**2 + 46332*C*D1*Dd*f**3*s - 23166*C*D1*Dd*f**3 - 5148*D1**2*K*bdd1*f**2*r**2 - 10296*D1**2*K*bdd1*f**2*r*s + 10296*D1**2*K*bdd1*f**2*r - 5148*D1**2*K*bdd1*f**2*s**2 + 10296*D1**2*K*bdd1*f**2*s - 5148*D1**2*K*bdd1*f**2 + 858*D1**2*bd1**2*f*(-12*K + 25*f + 9)*(r + s - 1)**2 - 8125*D1**2*bdd1*f**3*r**2 - 16250*D1**2*bdd1*f**3*r*s + 16250*D1**2*bdd1*f**3*r - 8125*D1**2*bdd1*f**3*s**2 + 16250*D1**2*bdd1*f**3*s - 8125*D1**2*bdd1*f**3 + 3861*D1**2*bdd1*f**2*r**2 + 7722*D1**2*bdd1*f**2*r*s - 7722*D1**2*bdd1*f**2*r + 3861*D1**2*bdd1*f**2*s**2 - 7722*D1**2*bdd1*f**2*s + 3861*D1**2*bdd1*f**2 + 10296*D1**2*bdd1*f*g2*r**2 + 20592*D1**2*bdd1*f*g2*r*s - 20592*D1**2*bdd1*f*g2*r + 10296*D1**2*bdd1*f*g2*s**2 - 20592*D1**2*bdd1*f*g2*s + 10296*D1**2*bdd1*f*g2 + 68100*D1**2*f**3*fd*r**2 + 136200*D1**2*f**3*fd*r*s - 102150*D1**2*f**3*fd*r + 68100*D1**2*f**3*fd*s**2 - 102150*D1**2*f**3*fd*s + 51075*D1**2*f**3*fd - 49000*D1**2*f**3*fdd*r**2 - 98000*D1**2*f**3*fdd*r*s + 73500*D1**2*f**3*fdd*r - 49000*D1**2*f**3*fdd*s**2 + 73500*D1**2*f**3*fdd*s - 36750*D1**2*f**3*fdd - 147000*D1**2*f**2*fd**2*r**2 - 294000*D1**2*f**2*fd**2*r*s + 220500*D1**2*f**2*fd**2*r - 147000*D1**2*f**2*fd**2*s**2 + 220500*D1**2*f**2*fd**2*s - 73500*D1**2*f**2*fd**2 + 19305*D1**2*f**2*fd*r**2 + 38610*D1**2*f**2*fd*r*s - 25740*D1**2*f**2*fd*r + 19305*D1**2*f**2*fd*s**2 - 25740*D1**2*f**2*fd*s + 12870*D1**2*f**2*fd - 19734*D1**2*f**2*gd2*r**2 - 39468*D1**2*f**2*gd2*r*s + 39468*D1**2*f**2*gd2*r - 19734*D1**2*f**2*gd2*s**2 + 39468*D1**2*f**2*gd2*s - 19734*D1**2*f**2*gd2 + 10296*D1**2*f**2*gdd2*r**2 + 20592*D1**2*f**2*gdd2*r*s - 20592*D1**2*f**2*gdd2*r + 10296*D1**2*f**2*gdd2*s**2 - 20592*D1**2*f**2*gdd2*s + 10296*D1**2*f**2*gdd2 - 39468*D1**2*f*fd*g2*r**2 - 78936*D1**2*f*fd*g2*r*s + 39468*D1**2*f*fd*g2*r - 39468*D1**2*f*fd*g2*s**2 + 39468*D1**2*f*fd*g2*s - 19734*D1**2*f*fd*g2 + 41184*D1**2*f*fd*gd2*r**2 + 82368*D1**2*f*fd*gd2*r*s - 61776*D1**2*f*fd*gd2*r + 41184*D1**2*f*fd*gd2*s**2 - 61776*D1**2*f*fd*gd2*s + 20592*D1**2*f*fd*gd2 + 20592*D1**2*f*fdd*g2*r**2 + 41184*D1**2*f*fdd*g2*r*s - 20592*D1**2*f*fdd*g2*r + 20592*D1**2*f*fdd*g2*s**2 - 20592*D1**2*f*fdd*g2*s + 10296*D1**2*f*fdd*g2 + 20592*D1**2*fd**2*g2*r**2 + 41184*D1**2*fd**2*g2*r*s - 20592*D1**2*fd**2*g2*r + 20592*D1**2*fd**2*g2*s**2 - 20592*D1**2*fd**2*g2*s + 68100*D1*Dd*f**4*r**2 + 136200*D1*Dd*f**4*r*s - 102150*D1*Dd*f**4*r + 68100*D1*Dd*f**4*s**2 - 102150*D1*Dd*f**4*s + 51075*D1*Dd*f**4 - 392000*D1*Dd*f**3*fd*r**2 - 784000*D1*Dd*f**3*fd*r*s + 588000*D1*Dd*f**3*fd*r - 392000*D1*Dd*f**3*fd*s**2 + 588000*D1*Dd*f**3*fd*s - 220500*D1*Dd*f**3*fd + 25740*D1*Dd*f**3*r**2 + 51480*D1*Dd*f**3*r*s - 38610*D1*Dd*f**3*r + 25740*D1*Dd*f**3*s**2 - 38610*D1*Dd*f**3*s + 19305*D1*Dd*f**3 - 78936*D1*Dd*f**2*g2*r**2 - 157872*D1*Dd*f**2*g2*r*s + 118404*D1*Dd*f**2*g2*r - 78936*D1*Dd*f**2*g2*s**2 + 118404*D1*Dd*f**2*g2*s - 59202*D1*Dd*f**2*g2 + 82368*D1*Dd*f**2*gd2*r**2 + 164736*D1*Dd*f**2*gd2*r*s - 144144*D1*Dd*f**2*gd2*r + 82368*D1*Dd*f**2*gd2*s**2 - 144144*D1*Dd*f**2*gd2*s + 61776*D1*Dd*f**2*gd2 + 164736*D1*Dd*f*fd*g2*r**2 + 329472*D1*Dd*f*fd*g2*r*s - 205920*D1*Dd*f*fd*g2*r + 164736*D1*Dd*f*fd*g2*s**2 - 205920*D1*Dd*f*fd*g2*s + 61776*D1*Dd*f*fd*g2 - 49000*D1*Ddd*f**4*r**2 - 98000*D1*Ddd*f**4*r*s + 73500*D1*Ddd*f**4*r - 49000*D1*Ddd*f**4*s**2 + 73500*D1*Ddd*f**4*s - 36750*D1*Ddd*f**4 + 41184*D1*Ddd*f**2*g2*r**2 + 82368*D1*Ddd*f**2*g2*r*s - 61776*D1*Ddd*f**2*g2*r + 41184*D1*Ddd*f**2*g2*s**2 - 61776*D1*Ddd*f**2*g2*s + 30888*D1*Ddd*f**2*g2 + 13*D1*bd1*(D1*(689*f**3*(r + s - 1) - f**2*(594*C*(r + s - 1) + 1250*fd*(3*r + 3*s - 2) - (759*K - 66)*(r + s - 1)) - 66*f*(3*fd*(4*K - 3)*(2*r + 2*s - 1) + (31*g2 - 24*gd2)*(r + s - 1)) + 1584*fd*g2*(r + s)) - 2*Dd*f*(625*f**2 + 99*f*(4*K - 3) - 792*g2)*(4*r + 4*s - 3))*(r + s - 1) - 147000*Dd**2*f**4*r**2 - 294000*Dd**2*f**4*r*s + 220500*Dd**2*f**4*r - 147000*Dd**2*f**4*s**2 + 220500*Dd**2*f**4*s - 73500*Dd**2*f**4 + 123552*Dd**2*f**2*g2*r**2 + 247104*Dd**2*f**2*g2*r*s - 185328*Dd**2*f**2*g2*r + 123552*Dd**2*f**2*g2*s**2 - 185328*Dd**2*f**2*g2*s + 61776*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(f*(44*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + fd*(31*K - 25)*(r + s) - 3*fdd*(4*K - 3)*(r + s))) + D1*(Dd*(44*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(50*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (31*K - 25)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(4*K - 3)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-12*K + 25*f + 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-12*K + 25*f + 9)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 13*b1*(1188*C*D1**2*f*fd*r**2 + 2376*C*D1**2*f*fd*r*s - 1188*C*D1**2*f*fd*r + 1188*C*D1**2*f*fd*s**2 - 1188*C*D1**2*f*fd*s + 594*C*D1**2*f*fd + 2376*C*D1*Dd*f**2*r**2 + 4752*C*D1*Dd*f**2*r*s - 3564*C*D1*Dd*f**2*r + 2376*C*D1*Dd*f**2*s**2 - 3564*C*D1*Dd*f**2*s + 1782*C*D1*Dd*f**2 - 1518*D1**2*K*f*fd*r**2 - 3036*D1**2*K*f*fd*r*s + 1518*D1**2*K*f*fd*r - 1518*D1**2*K*f*fd*s**2 + 1518*D1**2*K*f*fd*s - 759*D1**2*K*f*fd + 792*D1**2*K*f*fdd*r**2 + 1584*D1**2*K*f*fdd*r*s - 792*D1**2*K*f*fdd*r + 792*D1**2*K*f*fdd*s**2 - 792*D1**2*K*f*fdd*s + 396*D1**2*K*f*fdd + 792*D1**2*K*fd**2*r**2 + 1584*D1**2*K*fd**2*r*s - 792*D1**2*K*fd**2*r + 792*D1**2*K*fd**2*s**2 - 792*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(-12*K + 25*f + 9)*(r + s - 1)**2 - 2067*D1**2*f**2*fd*r**2 - 4134*D1**2*f**2*fd*r*s + 2756*D1**2*f**2*fd*r - 2067*D1**2*f**2*fd*s**2 + 2756*D1**2*f**2*fd*s - 1378*D1**2*f**2*fd + 1875*D1**2*f**2*fdd*r**2 + 3750*D1**2*f**2*fdd*r*s - 2500*D1**2*f**2*fdd*r + 1875*D1**2*f**2*fdd*s**2 - 2500*D1**2*f**2*fdd*s + 1250*D1**2*f**2*fdd + 3750*D1**2*f*fd**2*r**2 + 7500*D1**2*f*fd**2*r*s - 5000*D1**2*f*fd**2*r + 3750*D1**2*f*fd**2*s**2 - 5000*D1**2*f*fd**2*s + 1250*D1**2*f*fd**2 + 132*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 132*D1**2*f*fd*r + 132*D1**2*f*fd*s**2 - 132*D1**2*f*fd*s + 66*D1**2*f*fd - 594*D1**2*f*fdd*r**2 - 1188*D1**2*f*fdd*r*s + 594*D1**2*f*fdd*r - 594*D1**2*f*fdd*s**2 + 594*D1**2*f*fdd*s - 297*D1**2*f*fdd + 2046*D1**2*f*gd2*r**2 + 4092*D1**2*f*gd2*r*s - 4092*D1**2*f*gd2*r + 2046*D1**2*f*gd2*s**2 - 4092*D1**2*f*gd2*s + 2046*D1**2*f*gd2 - 792*D1**2*f*gdd2*r**2 - 1584*D1**2*f*gdd2*r*s + 1584*D1**2*f*gdd2*r - 792*D1**2*f*gdd2*s**2 + 1584*D1**2*f*gdd2*s - 792*D1**2*f*gdd2 - 594*D1**2*fd**2*r**2 - 1188*D1**2*fd**2*r*s + 594*D1**2*fd**2*r - 594*D1**2*fd**2*s**2 + 594*D1**2*fd**2*s + 2046*D1**2*fd*g2*r**2 + 4092*D1**2*fd*g2*r*s + 2046*D1**2*fd*g2*s**2 - 1584*D1**2*fd*gd2*r**2 - 3168*D1**2*fd*gd2*r*s + 1584*D1**2*fd*gd2*r - 1584*D1**2*fd*gd2*s**2 + 1584*D1**2*fd*gd2*s - 792*D1**2*fdd*g2*r**2 - 1584*D1**2*fdd*g2*r*s - 792*D1**2*fdd*g2*s**2 - 3036*D1*Dd*K*f**2*r**2 - 6072*D1*Dd*K*f**2*r*s + 4554*D1*Dd*K*f**2*r - 3036*D1*Dd*K*f**2*s**2 + 4554*D1*Dd*K*f**2*s - 2277*D1*Dd*K*f**2 + 6336*D1*Dd*K*f*fd*r**2 + 12672*D1*Dd*K*f*fd*r*s - 7920*D1*Dd*K*f*fd*r + 6336*D1*Dd*K*f*fd*s**2 - 7920*D1*Dd*K*f*fd*s + 2376*D1*Dd*K*f*fd - 2756*D1*Dd*f**3*r**2 - 5512*D1*Dd*f**3*r*s + 4134*D1*Dd*f**3*r - 2756*D1*Dd*f**3*s**2 + 4134*D1*Dd*f**3*s - 2067*D1*Dd*f**3 + 15000*D1*Dd*f**2*fd*r**2 + 30000*D1*Dd*f**2*fd*r*s - 21250*D1*Dd*f**2*fd*r + 15000*D1*Dd*f**2*fd*s**2 - 21250*D1*Dd*f**2*fd*s + 7500*D1*Dd*f**2*fd + 264*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 396*D1*Dd*f**2*r + 264*D1*Dd*f**2*s**2 - 396*D1*Dd*f**2*s + 198*D1*Dd*f**2 - 4752*D1*Dd*f*fd*r**2 - 9504*D1*Dd*f*fd*r*s + 5940*D1*Dd*f*fd*r - 4752*D1*Dd*f*fd*s**2 + 5940*D1*Dd*f*fd*s - 1782*D1*Dd*f*fd + 8184*D1*Dd*f*g2*r**2 + 16368*D1*Dd*f*g2*r*s - 12276*D1*Dd*f*g2*r + 8184*D1*Dd*f*g2*s**2 - 12276*D1*Dd*f*g2*s + 6138*D1*Dd*f*g2 - 6336*D1*Dd*f*gd2*r**2 - 12672*D1*Dd*f*gd2*r*s + 11088*D1*Dd*f*gd2*r - 6336*D1*Dd*f*gd2*s**2 + 11088*D1*Dd*f*gd2*s - 4752*D1*Dd*f*gd2 - 6336*D1*Dd*fd*g2*r**2 - 12672*D1*Dd*fd*g2*r*s + 4752*D1*Dd*fd*g2*r - 6336*D1*Dd*fd*g2*s**2 + 4752*D1*Dd*fd*g2*s + 1584*D1*Ddd*K*f**2*r**2 + 3168*D1*Ddd*K*f**2*r*s - 2376*D1*Ddd*K*f**2*r + 1584*D1*Ddd*K*f**2*s**2 - 2376*D1*Ddd*K*f**2*s + 1188*D1*Ddd*K*f**2 + 2500*D1*Ddd*f**3*r**2 + 5000*D1*Ddd*f**3*r*s - 3750*D1*Ddd*f**3*r + 2500*D1*Ddd*f**3*s**2 - 3750*D1*Ddd*f**3*s + 1875*D1*Ddd*f**3 - 1188*D1*Ddd*f**2*r**2 - 2376*D1*Ddd*f**2*r*s + 1782*D1*Ddd*f**2*r - 1188*D1*Ddd*f**2*s**2 + 1782*D1*Ddd*f**2*s - 891*D1*Ddd*f**2 - 3168*D1*Ddd*f*g2*r**2 - 6336*D1*Ddd*f*g2*r*s + 4752*D1*Ddd*f*g2*r - 3168*D1*Ddd*f*g2*s**2 + 4752*D1*Ddd*f*g2*s - 2376*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(44*f**2*(r + s - 1) - 50*f*fd*(2*r + 2*s - 1) - f*(31*K - 25)*(r + s - 1) + 6*fd*(4*K - 3)*(r + s)) - 2*Dd*f*(-12*K + 25*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 4752*Dd**2*K*f**2*r**2 + 9504*Dd**2*K*f**2*r*s - 7128*Dd**2*K*f**2*r + 4752*Dd**2*K*f**2*s**2 - 7128*Dd**2*K*f**2*s + 2376*Dd**2*K*f**2 + 7500*Dd**2*f**3*r**2 + 15000*Dd**2*f**3*r*s - 11250*Dd**2*f**3*r + 7500*Dd**2*f**3*s**2 - 11250*Dd**2*f**3*s + 3750*Dd**2*f**3 - 3564*Dd**2*f**2*r**2 - 7128*Dd**2*f**2*r*s + 5346*Dd**2*f**2*r - 3564*Dd**2*f**2*s**2 + 5346*Dd**2*f**2*s - 1782*Dd**2*f**2 - 9504*Dd**2*f*g2*r**2 - 19008*Dd**2*f*g2*r*s + 14256*Dd**2*f*g2*r - 9504*Dd**2*f*g2*s**2 + 14256*Dd**2*f*g2*s - 4752*Dd**2*f*g2))/(1001*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**3*k1*k2**3*st**2*(165*b1**2*(D1**2*(fd*(50*C - 44) + fdd*(15 - 18*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(25*C - 22)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(15 - 18*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(15 - 18*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(108*C - 90)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-1144*C*D1**2*f*fd*r**2 - 2208*C*D1**2*f*fd*r*s + 764*C*D1**2*f*fd*r - 1064*C*D1**2*f*fd*s**2 + 724*C*D1**2*f*fd*s - 362*C*D1**2*f*fd + 792*C*D1**2*f*fdd*r**2 + 1584*C*D1**2*f*fdd*r*s - 612*C*D1**2*f*fdd*r + 792*C*D1**2*f*fdd*s**2 - 612*C*D1**2*f*fdd*s + 306*C*D1**2*f*fdd + 792*C*D1**2*fd**2*r**2 + 1584*C*D1**2*fd**2*r*s - 612*C*D1**2*fd**2*r + 792*C*D1**2*fd**2*s**2 - 612*C*D1**2*fd**2*s - 180*C*D1**2*fd**2 - 2288*C*D1*Dd*f**2*r**2 - 4416*C*D1*Dd*f**2*r*s + 3352*C*D1*Dd*f**2*r - 2128*C*D1*Dd*f**2*s**2 + 3232*C*D1*Dd*f**2*s - 1636*C*D1*Dd*f**2 + 6336*C*D1*Dd*f*fd*r**2 + 12672*C*D1*Dd*f*fd*r*s - 7200*C*D1*Dd*f*fd*r + 6336*C*D1*Dd*f*fd*s**2 - 7200*C*D1*Dd*f*fd*s + 1836*C*D1*Dd*f*fd + 1584*C*D1*Ddd*f**2*r**2 + 3168*C*D1*Ddd*f**2*r*s - 2376*C*D1*Ddd*f**2*r + 1584*C*D1*Ddd*f**2*s**2 - 2376*C*D1*Ddd*f**2*s + 1188*C*D1*Ddd*f**2 + 4752*C*Dd**2*f**2*r**2 + 9504*C*Dd**2*f**2*r*s - 7128*C*Dd**2*f**2*r + 4752*C*Dd**2*f**2*s**2 - 7128*C*Dd**2*f**2*s + 2376*C*Dd**2*f**2 - 15*D1**2*bdd1*f*(6*C - 5)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 952*D1**2*f*fd*r**2 + 1912*D1**2*f*fd*r*s - 676*D1**2*f*fd*r + 960*D1**2*f*fd*s**2 - 680*D1**2*f*fd*s + 340*D1**2*f*fd - 672*D1**2*f*fdd*r**2 - 1400*D1**2*f*fdd*r*s + 550*D1**2*f*fdd*r - 728*D1**2*f*fdd*s**2 + 578*D1**2*f*fdd*s - 289*D1**2*f*fdd - 672*D1**2*fd**2*r**2 - 1400*D1**2*fd**2*r*s + 550*D1**2*fd**2*r - 728*D1**2*fd**2*s**2 + 578*D1**2*fd**2*s + 150*D1**2*fd**2 + 1904*D1*Dd*f**2*r**2 + 3824*D1*Dd*f**2*r*s - 2864*D1*Dd*f**2*r + 1920*D1*Dd*f**2*s**2 - 2876*D1*Dd*f**2*s + 1436*D1*Dd*f**2 - 5376*D1*Dd*f*fd*r**2 - 11200*D1*Dd*f*fd*r*s + 6344*D1*Dd*f*fd*r - 5824*D1*Dd*f*fd*s**2 + 6624*D1*Dd*f*fd*s - 1706*D1*Dd*f*fd - 1344*D1*Ddd*f**2*r**2 - 2800*D1*Ddd*f**2*r*s + 2072*D1*Ddd*f**2*r - 1456*D1*Ddd*f**2*s**2 + 2156*D1*Ddd*f**2*s - 1064*D1*Ddd*f**2 + 10*D1*bd1*(D1*(f*(25*C - 22)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(15 - 18*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(15 - 18*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 4032*Dd**2*f**2*r**2 - 8400*Dd**2*f**2*r*s + 6216*Dd**2*f**2*r - 4368*Dd**2*f**2*s**2 + 6468*Dd**2*f**2*s - 2128*Dd**2*f**2) + f*(-57882*C*D1**2*f*fd*r**2 - 112404*C*D1**2*f*fd*r*s + 76056*C*D1**2*f*fd*r - 54522*C*D1**2*f*fd*s**2 + 73816*C*D1**2*f*fd*s - 37468*C*D1**2*f*fd + 43890*C*D1**2*f*fdd*r**2 + 84516*C*D1**2*f*fdd*r*s - 57432*C*D1**2*f*fdd*r + 40626*C*D1**2*f*fdd*s**2 - 55256*C*D1**2*f*fdd*s + 28172*C*D1**2*f*fdd + 87780*C*D1**2*fd**2*r**2 + 169032*C*D1**2*fd**2*r*s - 114864*C*D1**2*fd**2*r + 81252*C*D1**2*fd**2*s**2 - 110512*C*D1**2*fd**2*s + 28172*C*D1**2*fd**2 - 77176*C*D1*Dd*f**2*r**2 - 149872*C*D1*Dd*f**2*r*s + 113524*C*D1*Dd*f**2*r - 72696*C*D1*Dd*f**2*s**2 + 110164*C*D1*Dd*f**2*s - 55642*C*D1*Dd*f**2 + 351120*C*D1*Dd*f*fd*r**2 + 676128*C*D1*Dd*f*fd*r*s - 486540*C*D1*Dd*f*fd*r + 325008*C*D1*Dd*f*fd*s**2 - 468044*C*D1*Dd*f*fd*s + 167944*C*D1*Dd*f*fd + 58520*C*D1*Ddd*f**2*r**2 + 112688*C*D1*Ddd*f**2*r*s - 85604*C*D1*Ddd*f**2*r + 54168*C*D1*Ddd*f**2*s**2 - 82340*C*D1*Ddd*f**2*s + 41714*C*D1*Ddd*f**2 + 175560*C*Dd**2*f**2*r**2 + 338064*C*Dd**2*f**2*r*s - 256812*C*Dd**2*f**2*r + 162504*C*Dd**2*f**2*s**2 - 247020*C*Dd**2*f**2*s + 83428*C*Dd**2*f**2 - 990*D1**2*bd1**2*(6*C - 5)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(18*C*(22*r**2 + r*(44*s - 54) + 22*s**2 - 54*s + 27) - 336*r**2 + r*(822 - 700*s) - 364*s**2 + 850*s - 411) + 47580*D1**2*f*fd*r**2 + 94944*D1**2*f*fd*r*s - 63368*D1**2*f*fd*r + 47364*D1**2*f*fd*s**2 - 63224*D1**2*f*fd*s + 31648*D1**2*f*fd - 36561*D1**2*f*fdd*r**2 - 73014*D1**2*f*fdd*r*s + 48712*D1**2*f*fdd*r - 36453*D1**2*f*fdd*s**2 + 48640*D1**2*f*fdd*s - 24338*D1**2*f*fdd - 73122*D1**2*fd**2*r**2 - 146028*D1**2*fd**2*r*s + 97424*D1**2*fd**2*r - 72906*D1**2*fd**2*s**2 + 97280*D1**2*fd**2*s - 24338*D1**2*fd**2 + 63440*D1*Dd*f**2*r**2 + 126592*D1*Dd*f**2*r*s - 95016*D1*Dd*f**2*r + 63152*D1*Dd*f**2*s**2 - 94800*D1*Dd*f**2*s + 47436*D1*Dd*f**2 - 292488*D1*Dd*f*fd*r**2 - 584112*D1*Dd*f*fd*r*s + 413998*D1*Dd*f*fd*r - 291624*D1*Dd*f*fd*s**2 + 413386*D1*Dd*f*fd*s - 145992*D1*Dd*f*fd - 48748*D1*Ddd*f**2*r**2 - 97352*D1*Ddd*f**2*r*s + 73050*D1*Ddd*f**2*r - 48604*D1*Ddd*f**2*s**2 + 72942*D1*Ddd*f**2*s - 36489*D1*Ddd*f**2 - 66*D1*bd1*(D1*(f*(C*(286*r**2 + 552*r*s - 742*r + 266*s**2 - 722*s + 371) - 238*r**2 - 478*r*s + 616*r - 240*s**2 + 618*s - 308) + fd*(-18*C*(44*r**2 + 88*r*s - 71*r + 44*s**2 - 71*s + 27) + 672*r**2 + 1400*r*s - 1097*r + 728*s**2 - 1139*s + 425)) + Dd*f*(-18*C*(88*r**2 + 2*r*(88*s - 87) + 88*s**2 - 174*s + 81) + 1344*r**2 + 40*r*(70*s - 67) + 1456*s**2 - 2778*s + 1261)) - 146244*Dd**2*f**2*r**2 - 292056*Dd**2*f**2*r*s + 219150*Dd**2*f**2*r - 145812*Dd**2*f**2*s**2 + 218826*Dd**2*f**2*s - 72978*Dd**2*f**2))/(693*d**2*k3**5) - D1**2*Pk1*Pkd3*ct**3*k1*k2**3*(-61776*C*D1**2*bd1*f**2*r**2 - 61776*C*D1**2*bd1*f**2*r*s + 226512*C*D1**2*bd1*f**2*r + 164736*C*D1**2*bd1*f**2*s - 113256*C*D1**2*bd1*f**2 - 283140*C*D1**2*f**2*fd*r**2 - 411840*C*D1**2*f**2*fd*r*s + 326040*C*D1**2*f**2*fd*r - 128700*C*D1**2*f**2*fd*s**2 + 223080*C*D1**2*f**2*fd*s - 137280*C*D1**2*f**2*fd - 377520*C*D1*Dd*f**3*r**2 - 549120*C*D1*Dd*f**3*r*s + 463320*C*D1*Dd*f**3*r - 171600*C*D1*Dd*f**3*s**2 + 308880*C*D1*Dd*f**3*s - 180180*C*D1*Dd*f**3 - 202488*D1**2*K*bd1**2*f*r**2 - 404976*D1**2*K*bd1**2*f*r*s + 507936*D1**2*K*bd1**2*f*r - 202488*D1**2*K*bd1**2*f*s**2 + 507936*D1**2*K*bd1**2*f*s - 305448*D1**2*K*bd1**2*f + 183612*D1**2*K*bd1*f**2*r**2 + 302016*D1**2*K*bd1*f**2*r*s - 302016*D1**2*K*bd1*f**2*r + 118404*D1**2*K*bd1*f**2*s**2 - 236808*D1**2*K*bd1*f**2*s + 118404*D1**2*K*bd1*f**2 - 583440*D1**2*K*bd1*f*fd*r**2 - 1098240*D1**2*K*bd1*f*fd*r*s + 840840*D1**2*K*bd1*f*fd*r - 514800*D1**2*K*bd1*f*fd*s**2 + 789360*D1**2*K*bd1*f*fd*s - 274560*D1**2*K*bd1*f*fd - 145860*D1**2*K*bdd1*f**2*r**2 - 274560*D1**2*K*bdd1*f**2*r*s + 274560*D1**2*K*bdd1*f**2*r - 128700*D1**2*K*bdd1*f**2*s**2 + 257400*D1**2*K*bdd1*f**2*s - 128700*D1**2*K*bdd1*f**2 + 236808*D1**2*bd1**2*f**2*r**2 + 514800*D1**2*bd1**2*f**2*r*s - 494208*D1**2*bd1**2*f**2*r + 277992*D1**2*bd1**2*f**2*s**2 - 535392*D1**2*bd1**2*f**2*s + 257400*D1**2*bd1**2*f**2 + 198198*D1**2*bd1**2*f*r**2 + 437580*D1**2*bd1**2*f*r*s - 494208*D1**2*bd1**2*f*r + 239382*D1**2*bd1**2*f*s**2 - 535392*D1**2*bd1**2*f*s + 296010*D1**2*bd1**2*f - 240240*D1**2*bd1**2*g2*r**2 - 480480*D1**2*bd1**2*g2*r*s + 240240*D1**2*bd1**2*g2*r - 240240*D1**2*bd1**2*g2*s**2 + 240240*D1**2*bd1**2*g2*s - 102960*D1**2*bd1*bd2*f*r**2 - 205920*D1**2*bd1*bd2*f*r*s + 205920*D1**2*bd1*bd2*f*r - 102960*D1**2*bd1*bd2*f*s**2 + 205920*D1**2*bd1*bd2*f*s - 102960*D1**2*bd1*bd2*f - 100360*D1**2*bd1*f**3*r**2 - 144040*D1**2*bd1*f**3*r*s + 157430*D1**2*bd1*f**3*r - 43680*D1**2*bd1*f**3*s**2 + 100750*D1**2*bd1*f**3*s - 79495*D1**2*bd1*f**3 + 609960*D1**2*bd1*f**2*fd*r**2 + 895440*D1**2*bd1*f**2*fd*r*s - 817960*D1**2*bd1*f**2*fd*r + 285480*D1**2*bd1*f**2*fd*s**2 - 547560*D1**2*bd1*f**2*fd*s + 198640*D1**2*bd1*f**2*fd - 87516*D1**2*bd1*f**2*r**2 - 199056*D1**2*bd1*f**2*r*s + 70356*D1**2*bd1*f**2*r - 111540*D1**2*bd1*f**2*s**2 + 94380*D1**2*bd1*f**2*s - 21450*D1**2*bd1*f**2 + 504504*D1**2*bd1*f*fd*r**2 + 1036464*D1**2*bd1*f*fd*r*s - 770484*D1**2*bd1*f*fd*r + 531960*D1**2*bd1*f*fd*s**2 - 791076*D1**2*bd1*f*fd*s + 259116*D1**2*bd1*f*fd - 212784*D1**2*bd1*f*g2*r**2 - 353496*D1**2*bd1*f*g2*r*s + 717288*D1**2*bd1*f*g2*r - 140712*D1**2*bd1*f*g2*s**2 + 645216*D1**2*bd1*f*g2*s - 358644*D1**2*bd1*f*g2 + 404976*D1**2*bd1*f*gd2*r**2 + 809952*D1**2*bd1*f*gd2*r*s - 1015872*D1**2*bd1*f*gd2*r + 404976*D1**2*bd1*f*gd2*s**2 - 1015872*D1**2*bd1*f*gd2*s + 610896*D1**2*bd1*f*gd2 + 404976*D1**2*bd1*fd*g2*r**2 + 809952*D1**2*bd1*fd*g2*r*s - 404976*D1**2*bd1*fd*g2*r + 404976*D1**2*bd1*fd*g2*s**2 - 404976*D1**2*bd1*fd*g2*s + 60060*D1**2*bd2*f**2*r**2 + 120120*D1**2*bd2*f**2*r*s - 120120*D1**2*bd2*f**2*r + 60060*D1**2*bd2*f**2*s**2 - 120120*D1**2*bd2*f**2*s + 60060*D1**2*bd2*f**2 - 171600*D1**2*bd2*f*fd*r**2 - 343200*D1**2*bd2*f*fd*r*s + 257400*D1**2*bd2*f*fd*r - 171600*D1**2*bd2*f*fd*s**2 + 257400*D1**2*bd2*f*fd*s - 85800*D1**2*bd2*f*fd + 101660*D1**2*bdd1*f**3*r**2 + 149240*D1**2*bdd1*f**3*r*s - 158080*D1**2*bdd1*f**3*r + 47580*D1**2*bdd1*f**3*s**2 - 104000*D1**2*bdd1*f**3*s + 83720*D1**2*bdd1*f**3 + 126126*D1**2*bdd1*f**2*r**2 + 259116*D1**2*bdd1*f**2*r*s - 259116*D1**2*bdd1*f**2*r + 132990*D1**2*bdd1*f**2*s**2 - 265980*D1**2*bdd1*f**2*s + 132990*D1**2*bdd1*f**2 + 202488*D1**2*bdd1*f*g2*r**2 + 404976*D1**2*bdd1*f*g2*r*s - 610896*D1**2*bdd1*f*g2*r + 202488*D1**2*bdd1*f*g2*s**2 - 610896*D1**2*bdd1*f*g2*s + 305448*D1**2*bdd1*f*g2 - 42900*D1**2*bdd2*f**2*r**2 - 85800*D1**2*bdd2*f**2*r*s + 85800*D1**2*bdd2*f**2*r - 42900*D1**2*bdd2*f**2*s**2 + 85800*D1**2*bdd2*f**2*s - 42900*D1**2*bdd2*f**2 + 113680*D1**2*f**3*fd*r**2 + 397600*D1**2*f**3*fd*r*s - 255640*D1**2*f**3*fd*r + 283920*D1**2*f**3*fd*s**2 - 383320*D1**2*f**3*fd*s + 170380*D1**2*f**3*fd - 126000*D1**2*f**3*fdd*r**2 - 453600*D1**2*f**3*fdd*r*s + 289800*D1**2*f**3*fdd*r - 327600*D1**2*f**3*fdd*s**2 + 441000*D1**2*f**3*fdd*s - 195300*D1**2*f**3*fdd - 378000*D1**2*f**2*fd**2*r**2 - 1360800*D1**2*f**2*fd**2*r*s + 869400*D1**2*f**2*fd**2*r - 982800*D1**2*f**2*fd**2*s**2 + 1323000*D1**2*f**2*fd**2*s - 390600*D1**2*f**2*fd**2 + 225225*D1**2*f**2*fd*r**2 + 321750*D1**2*f**2*fd*r*s - 257400*D1**2*f**2*fd*r + 96525*D1**2*f**2*fd*s**2 - 171600*D1**2*f**2*fd*s + 107250*D1**2*f**2*fd - 367224*D1**2*f**2*gd2*r**2 - 604032*D1**2*f**2*gd2*r*s + 604032*D1**2*f**2*gd2*r - 236808*D1**2*f**2*gd2*s**2 + 473616*D1**2*f**2*gd2*s - 236808*D1**2*f**2*gd2 + 291720*D1**2*f**2*gdd2*r**2 + 549120*D1**2*f**2*gdd2*r*s - 549120*D1**2*f**2*gdd2*r + 257400*D1**2*f**2*gdd2*s**2 - 514800*D1**2*f**2*gdd2*s + 257400*D1**2*f**2*gdd2 - 734448*D1**2*f*fd*g2*r**2 - 1208064*D1**2*f*fd*g2*r*s + 734448*D1**2*f*fd*g2*r - 473616*D1**2*f*fd*g2*s**2 + 604032*D1**2*f*fd*g2*s - 367224*D1**2*f*fd*g2 + 1166880*D1**2*f*fd*gd2*r**2 + 2196480*D1**2*f*fd*gd2*r*s - 1681680*D1**2*f*fd*gd2*r + 1029600*D1**2*f*fd*gd2*s**2 - 1578720*D1**2*f*fd*gd2*s + 549120*D1**2*f*fd*gd2 + 583440*D1**2*f*fdd*g2*r**2 + 1098240*D1**2*f*fdd*g2*r*s - 583440*D1**2*f*fdd*g2*r + 514800*D1**2*f*fdd*g2*s**2 - 549120*D1**2*f*fdd*g2*s + 291720*D1**2*f*fdd*g2 + 583440*D1**2*fd**2*g2*r**2 + 1098240*D1**2*fd**2*g2*r*s - 583440*D1**2*fd**2*g2*r + 514800*D1**2*fd**2*g2*s**2 - 549120*D1**2*fd**2*g2*s - 1166880*D1*Dd*K*bd1*f**2*r**2 - 2196480*D1*Dd*K*bd1*f**2*r*s + 1939080*D1*Dd*K*bd1*f**2*r - 1029600*D1*Dd*K*bd1*f**2*s**2 + 1818960*D1*Dd*K*bd1*f**2*s - 789360*D1*Dd*K*bd1*f**2 + 813280*D1*Dd*bd1*f**3*r**2 + 1193920*D1*Dd*bd1*f**3*r*s - 1134120*D1*Dd*bd1*f**3*r + 380640*D1*Dd*bd1*f**3*s**2 - 755560*D1*Dd*bd1*f**3*s + 366080*D1*Dd*bd1*f**3 + 1009008*D1*Dd*bd1*f**2*r**2 + 2072928*D1*Dd*bd1*f**2*r*s - 1806948*D1*Dd*bd1*f**2*r + 1063920*D1*Dd*bd1*f**2*s**2 - 1854996*D1*Dd*bd1*f**2*s + 791076*D1*Dd*bd1*f**2 + 1619904*D1*Dd*bd1*f*g2*r**2 + 3239808*D1*Dd*bd1*f*g2*r*s - 3658512*D1*Dd*bd1*f*g2*r + 1619904*D1*Dd*bd1*f*g2*s**2 - 3658512*D1*Dd*bd1*f*g2*s + 1832688*D1*Dd*bd1*f*g2 - 343200*D1*Dd*bd2*f**2*r**2 - 686400*D1*Dd*bd2*f**2*r*s + 600600*D1*Dd*bd2*f**2*r - 343200*D1*Dd*bd2*f**2*s**2 + 600600*D1*Dd*bd2*f**2*s - 257400*D1*Dd*bd2*f**2 + 113680*D1*Dd*f**4*r**2 + 397600*D1*Dd*f**4*r*s - 255640*D1*Dd*f**4*r + 283920*D1*Dd*f**4*s**2 - 383320*D1*Dd*f**4*s + 170380*D1*Dd*f**4 - 1008000*D1*Dd*f**3*fd*r**2 - 3628800*D1*Dd*f**3*fd*r*s + 2318400*D1*Dd*f**3*fd*r - 2620800*D1*Dd*f**3*fd*s**2 + 3528000*D1*Dd*f**3*fd*s - 1171800*D1*Dd*f**3*fd + 300300*D1*Dd*f**3*r**2 + 429000*D1*Dd*f**3*r*s - 364650*D1*Dd*f**3*r + 128700*D1*Dd*f**3*s**2 - 235950*D1*Dd*f**3*s + 139425*D1*Dd*f**3 - 1468896*D1*Dd*f**2*g2*r**2 - 2416128*D1*Dd*f**2*g2*r*s + 1942512*D1*Dd*f**2*g2*r - 947232*D1*Dd*f**2*g2*s**2 + 1551264*D1*Dd*f**2*g2*s - 840840*D1*Dd*f**2*g2 + 2333760*D1*Dd*f**2*gd2*r**2 + 4392960*D1*Dd*f**2*gd2*r*s - 3878160*D1*Dd*f**2*gd2*r + 2059200*D1*Dd*f**2*gd2*s**2 - 3637920*D1*Dd*f**2*gd2*s + 1578720*D1*Dd*f**2*gd2 + 4667520*D1*Dd*f*fd*g2*r**2 + 8785920*D1*Dd*f*fd*g2*r*s - 5697120*D1*Dd*f*fd*g2*r + 4118400*D1*Dd*f*fd*g2*s**2 - 5353920*D1*Dd*f*fd*g2*s + 1681680*D1*Dd*f*fd*g2 - 126000*D1*Ddd*f**4*r**2 - 453600*D1*Ddd*f**4*r*s + 289800*D1*Ddd*f**4*r - 327600*D1*Ddd*f**4*s**2 + 441000*D1*Ddd*f**4*s - 195300*D1*Ddd*f**4 + 1166880*D1*Ddd*f**2*g2*r**2 + 2196480*D1*Ddd*f**2*g2*r*s - 1681680*D1*Ddd*f**2*g2*r + 1029600*D1*Ddd*f**2*g2*s**2 - 1578720*D1*Ddd*f**2*g2*s + 806520*D1*Ddd*f**2*g2 - 378000*Dd**2*f**4*r**2 - 1360800*Dd**2*f**4*r*s + 869400*Dd**2*f**4*r - 982800*Dd**2*f**4*s**2 + 1323000*Dd**2*f**4*s - 390600*Dd**2*f**4 + 3500640*Dd**2*f**2*g2*r**2 + 6589440*Dd**2*f**2*g2*r*s - 5045040*Dd**2*f**2*g2*r + 3088800*Dd**2*f**2*g2*s**2 - 4736160*Dd**2*f**2*g2*s + 1613040*Dd**2*f**2*g2 + 2145*b1**3*(2*D1**2*(11*fd - 9*fdd)*(r + s - 1)**2 + D1*(2*Dd*(11*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (28*K - 21)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-28*K + 18*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-28*K + 18*f + 21)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(140*C*D1**2*fd*r**2 + 280*C*D1**2*fd*r*s - 280*C*D1**2*fd*r + 140*C*D1**2*fd*s**2 - 280*C*D1**2*fd*s + 140*C*D1**2*fd + 560*C*D1*Dd*f*r**2 + 1120*C*D1*Dd*f*r*s - 840*C*D1*Dd*f*r + 560*C*D1*Dd*f*s**2 - 840*C*D1*Dd*f*s + 420*C*D1*Dd*f + 248*D1**2*K*fd*r**2 + 412*D1**2*K*fd*r*s + 340*D1**2*K*fd*r + 164*D1**2*K*fd*s**2 + 340*D1**2*K*fd*s - 170*D1**2*K*fd - 236*D1**2*K*fdd*r**2 - 472*D1**2*K*fdd*r*s - 240*D1**2*K*fdd*r - 236*D1**2*K*fdd*s**2 - 240*D1**2*K*fdd*s + 120*D1**2*K*fdd - 5*D1**2*bdd1*(-28*K + 18*f + 21)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 420*D1**2*f*fd*r**2 - 936*D1**2*f*fd*r*s + 408*D1**2*f*fd*r - 516*D1**2*f*fd*s**2 + 456*D1**2*f*fd*s - 228*D1**2*f*fd + 552*D1**2*f*fdd*r**2 + 1200*D1**2*f*fdd*r*s - 600*D1**2*f*fdd*r + 648*D1**2*f*fdd*s**2 - 648*D1**2*f*fdd*s + 324*D1**2*f*fdd + 552*D1**2*fd**2*r**2 + 1200*D1**2*fd**2*r*s - 600*D1**2*fd**2*r + 648*D1**2*fd**2*s**2 - 648*D1**2*fd**2*s - 329*D1**2*fd*r**2 - 642*D1**2*fd*r*s - 10*D1**2*fd*r - 313*D1**2*fd*s**2 - 10*D1**2*fd*s + 5*D1**2*fd + 231*D1**2*fdd*r**2 + 510*D1**2*fdd*r*s + 180*D1**2*fdd*r + 279*D1**2*fdd*s**2 + 180*D1**2*fdd*s - 90*D1**2*fdd + 560*D1**2*gd2*r**2 + 1120*D1**2*gd2*r*s - 1120*D1**2*gd2*r + 560*D1**2*gd2*s**2 - 1120*D1**2*gd2*s + 560*D1**2*gd2 - 280*D1**2*gdd2*r**2 - 560*D1**2*gdd2*r*s + 560*D1**2*gdd2*r - 280*D1**2*gdd2*s**2 + 560*D1**2*gdd2*s - 280*D1**2*gdd2 + 992*D1*Dd*K*f*r**2 + 1648*D1*Dd*K*f*r*s - 1320*D1*Dd*K*f*r + 656*D1*Dd*K*f*s**2 - 1068*D1*Dd*K*f*s + 576*D1*Dd*K*f - 1888*D1*Dd*K*fd*r**2 - 3776*D1*Dd*K*fd*r*s + 456*D1*Dd*K*fd*r - 1888*D1*Dd*K*fd*s**2 + 456*D1*Dd*K*fd*s + 720*D1*Dd*K*fd - 840*D1*Dd*f**2*r**2 - 1872*D1*Dd*f**2*r*s + 1356*D1*Dd*f**2*r - 1032*D1*Dd*f**2*s**2 + 1500*D1*Dd*f**2*s - 726*D1*Dd*f**2 + 4416*D1*Dd*f*fd*r**2 + 9600*D1*Dd*f*fd*r*s - 5904*D1*Dd*f*fd*r + 5184*D1*Dd*f*fd*s**2 - 6384*D1*Dd*f*fd*s + 1896*D1*Dd*f*fd - 1316*D1*Dd*f*r**2 - 2568*D1*Dd*f*r*s + 1942*D1*Dd*f*r - 1252*D1*Dd*f*s**2 + 1894*D1*Dd*f*s - 955*D1*Dd*f + 1848*D1*Dd*fd*r**2 + 4080*D1*Dd*fd*r*s - 762*D1*Dd*fd*r + 2232*D1*Dd*fd*s**2 - 906*D1*Dd*fd*s - 540*D1*Dd*fd + 2240*D1*Dd*g2*r**2 + 4480*D1*Dd*g2*r*s - 3360*D1*Dd*g2*r + 2240*D1*Dd*g2*s**2 - 3360*D1*Dd*g2*s + 1680*D1*Dd*g2 - 2240*D1*Dd*gd2*r**2 - 4480*D1*Dd*gd2*r*s + 3920*D1*Dd*gd2*r - 2240*D1*Dd*gd2*s**2 + 3920*D1*Dd*gd2*s - 1680*D1*Dd*gd2 - 944*D1*Ddd*K*f*r**2 - 1888*D1*Ddd*K*f*r*s + 1416*D1*Ddd*K*f*r - 944*D1*Ddd*K*f*s**2 + 1416*D1*Ddd*K*f*s - 708*D1*Ddd*K*f + 1104*D1*Ddd*f**2*r**2 + 2400*D1*Ddd*f**2*r*s - 1752*D1*Ddd*f**2*r + 1296*D1*Ddd*f**2*s**2 - 1896*D1*Ddd*f**2*s + 924*D1*Ddd*f**2 + 924*D1*Ddd*f*r**2 + 2040*D1*Ddd*f*r*s - 1482*D1*Ddd*f*r + 1116*D1*Ddd*f*s**2 - 1626*D1*Ddd*f*s + 789*D1*Ddd*f - 1120*D1*Ddd*g2*r**2 - 2240*D1*Ddd*g2*r*s + 1680*D1*Ddd*g2*r - 1120*D1*Ddd*g2*s**2 + 1680*D1*Ddd*g2*s - 840*D1*Ddd*g2 + 10*D1*bd1*(D1*(11*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (28*K - 21)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-28*K + 18*f + 21)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 2832*Dd**2*K*f*r**2 - 5664*Dd**2*K*f*r*s + 4248*Dd**2*K*f*r - 2832*Dd**2*K*f*s**2 + 4248*Dd**2*K*f*s - 1416*Dd**2*K*f + 3312*Dd**2*f**2*r**2 + 7200*Dd**2*f**2*r*s - 5256*Dd**2*f**2*r + 3888*Dd**2*f**2*s**2 - 5688*Dd**2*f**2*s + 1848*Dd**2*f**2 + 2772*Dd**2*f*r**2 + 6120*Dd**2*f*r*s - 4446*Dd**2*f*r + 3348*Dd**2*f*s**2 - 4878*Dd**2*f*s + 1578*Dd**2*f - 3360*Dd**2*g2*r**2 - 6720*Dd**2*g2*r*s + 5040*Dd**2*g2*r - 3360*Dd**2*g2*s**2 + 5040*Dd**2*g2*s - 1680*Dd**2*g2) - 13*b1*(9504*C*D1**2*f*fd*r**2 + 9504*C*D1**2*f*fd*r*s + 3168*C*D1**2*f*fd*r + 7920*C*D1**2*f*fd*s - 3960*C*D1**2*f*fd + 19008*C*D1*Dd*f**2*r**2 + 19008*C*D1*Dd*f**2*r*s - 19008*C*D1*Dd*f**2*r - 4752*C*D1*Dd*f**2*s + 4752*C*D1*Dd*f**2 + 15576*D1**2*K*bdd1*f*r**2 + 31152*D1**2*K*bdd1*f*r*s - 39072*D1**2*K*bdd1*f*r + 15576*D1**2*K*bdd1*f*s**2 - 39072*D1**2*K*bdd1*f*s + 19536*D1**2*K*bdd1*f - 28248*D1**2*K*f*fd*r**2 - 46464*D1**2*K*f*fd*r*s + 28248*D1**2*K*f*fd*r - 18216*D1**2*K*f*fd*s**2 + 23232*D1**2*K*f*fd*s - 14124*D1**2*K*f*fd + 22440*D1**2*K*f*fdd*r**2 + 42240*D1**2*K*f*fdd*r*s - 22440*D1**2*K*f*fdd*r + 19800*D1**2*K*f*fdd*s**2 - 21120*D1**2*K*f*fdd*s + 11220*D1**2*K*f*fdd + 22440*D1**2*K*fd**2*r**2 + 42240*D1**2*K*fd**2*r*s - 22440*D1**2*K*fd**2*r + 19800*D1**2*K*fd**2*s**2 - 21120*D1**2*K*fd**2*s - 5610*D1**2*b2*fd*r**2 - 11220*D1**2*b2*fd*r*s - 5610*D1**2*b2*fd*s**2 + 3960*D1**2*b2*fdd*r**2 + 7920*D1**2*b2*fdd*r*s + 3960*D1**2*b2*fdd*s**2 + 330*D1**2*bd1**2*(-28*K + 18*f + 21)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 18216*D1**2*bdd1*f**2*r**2 - 39600*D1**2*bdd1*f**2*r*s + 38016*D1**2*bdd1*f**2*r - 21384*D1**2*bdd1*f**2*s**2 + 41184*D1**2*bdd1*f**2*s - 19800*D1**2*bdd1*f**2 - 15246*D1**2*bdd1*f*r**2 - 33660*D1**2*bdd1*f*r*s + 38016*D1**2*bdd1*f*r - 18414*D1**2*bdd1*f*s**2 + 41184*D1**2*bdd1*f*s - 19800*D1**2*bdd1*f + 18480*D1**2*bdd1*g2*r**2 + 36960*D1**2*bdd1*g2*r*s - 18480*D1**2*bdd1*g2*r + 18480*D1**2*bdd1*g2*s**2 - 18480*D1**2*bdd1*g2*s + 9240*D1**2*bdd1*g2 + 3960*D1**2*bdd2*f*r**2 + 7920*D1**2*bdd2*f*r*s - 7920*D1**2*bdd2*f*r + 3960*D1**2*bdd2*f*s**2 - 7920*D1**2*bdd2*f*s + 3960*D1**2*bdd2*f + 23160*D1**2*f**2*fd*r**2 + 33240*D1**2*f**2*fd*r*s - 25490*D1**2*f**2*fd*r + 10080*D1**2*f**2*fd*s**2 - 16770*D1**2*f**2*fd*s + 8325*D1**2*f**2*fd - 23460*D1**2*f**2*fdd*r**2 - 34440*D1**2*f**2*fdd*r*s + 26440*D1**2*f**2*fdd*r - 10980*D1**2*f**2*fdd*s**2 + 18120*D1**2*f**2*fdd*s - 8700*D1**2*f**2*fdd - 46920*D1**2*f*fd**2*r**2 - 68880*D1**2*f*fd**2*r*s + 52880*D1**2*f*fd**2*r - 21960*D1**2*f*fd**2*s**2 + 36240*D1**2*f*fd**2*s - 15000*D1**2*f*fd**2 + 13464*D1**2*f*fd*r**2 + 30624*D1**2*f*fd*r*s - 23364*D1**2*f*fd*r + 17160*D1**2*f*fd*s**2 - 25212*D1**2*f*fd*s + 13662*D1**2*f*fd - 19404*D1**2*f*fdd*r**2 - 39864*D1**2*f*fdd*r*s + 19404*D1**2*f*fdd*r - 20460*D1**2*f*fdd*s**2 + 19932*D1**2*f*fdd*s - 9702*D1**2*f*fdd + 16368*D1**2*f*gd2*r**2 + 27192*D1**2*f*gd2*r*s - 27192*D1**2*f*gd2*r + 10824*D1**2*f*gd2*s**2 - 21648*D1**2*f*gd2*s + 10824*D1**2*f*gd2 - 15576*D1**2*f*gdd2*r**2 - 31152*D1**2*f*gdd2*r*s + 31152*D1**2*f*gdd2*r - 15576*D1**2*f*gdd2*s**2 + 31152*D1**2*f*gdd2*s - 15576*D1**2*f*gdd2 - 19404*D1**2*fd**2*r**2 - 39864*D1**2*fd**2*r*s + 19404*D1**2*fd**2*r - 20460*D1**2*fd**2*s**2 + 19932*D1**2*fd**2*s + 16368*D1**2*fd*g2*r**2 + 27192*D1**2*fd*g2*r*s + 22440*D1**2*fd*g2*r + 10824*D1**2*fd*g2*s**2 + 22440*D1**2*fd*g2*s - 11220*D1**2*fd*g2 - 31152*D1**2*fd*gd2*r**2 - 62304*D1**2*fd*gd2*r*s + 15312*D1**2*fd*gd2*r - 31152*D1**2*fd*gd2*s**2 + 15312*D1**2*fd*gd2*s + 15840*D1**2*fd*gd2 - 15576*D1**2*fdd*g2*r**2 - 31152*D1**2*fdd*g2*r*s - 15840*D1**2*fdd*g2*r - 15576*D1**2*fdd*g2*s**2 - 15840*D1**2*fdd*g2*s + 7920*D1**2*fdd*g2 - 56496*D1*Dd*K*f**2*r**2 - 92928*D1*Dd*K*f**2*r*s + 74712*D1*Dd*K*f**2*r - 36432*D1*Dd*K*f**2*s**2 + 59664*D1*Dd*K*f**2*s - 32340*D1*Dd*K*f**2 + 179520*D1*Dd*K*f*fd*r**2 + 337920*D1*Dd*K*f*fd*r*s - 219120*D1*Dd*K*f*fd*r + 158400*D1*Dd*K*f*fd*s**2 - 205920*D1*Dd*K*f*fd*s + 64680*D1*Dd*K*f*fd - 22440*D1*Dd*b2*f*r**2 - 44880*D1*Dd*b2*f*r*s + 33660*D1*Dd*b2*f*r - 22440*D1*Dd*b2*f*s**2 + 33660*D1*Dd*b2*f*s - 16830*D1*Dd*b2*f + 31680*D1*Dd*b2*fd*r**2 + 63360*D1*Dd*b2*fd*r*s - 23760*D1*Dd*b2*fd*r + 31680*D1*Dd*b2*fd*s**2 - 23760*D1*Dd*b2*fd*s + 30880*D1*Dd*f**3*r**2 + 44320*D1*Dd*f**3*r*s - 37600*D1*Dd*f**3*r + 13440*D1*Dd*f**3*s**2 - 24520*D1*Dd*f**3*s + 14440*D1*Dd*f**3 - 187680*D1*Dd*f**2*fd*r**2 - 275520*D1*Dd*f**2*fd*r*s + 221560*D1*Dd*f**2*fd*r - 87840*D1*Dd*f**2*fd*s**2 + 150840*D1*Dd*f**2*fd*s - 62680*D1*Dd*f**2*fd + 26928*D1*Dd*f**2*r**2 + 61248*D1*Dd*f**2*r*s - 44088*D1*Dd*f**2*r + 34320*D1*Dd*f**2*s**2 - 49632*D1*Dd*f**2*s + 23892*D1*Dd*f**2 - 155232*D1*Dd*f*fd*r**2 - 318912*D1*Dd*f*fd*r*s + 196152*D1*Dd*f*fd*r - 163680*D1*Dd*f*fd*s**2 + 201432*D1*Dd*f*fd*s - 59268*D1*Dd*f*fd + 65472*D1*Dd*f*g2*r**2 + 108768*D1*Dd*f*g2*r*s - 87120*D1*Dd*f*g2*r + 43296*D1*Dd*f*g2*s**2 - 70488*D1*Dd*f*g2*s + 38016*D1*Dd*f*g2 - 124608*D1*Dd*f*gd2*r**2 - 249216*D1*Dd*f*gd2*r*s + 218064*D1*Dd*f*gd2*r - 124608*D1*Dd*f*gd2*s**2 + 218064*D1*Dd*f*gd2*s - 93456*D1*Dd*f*gd2 - 124608*D1*Dd*fd*g2*r**2 - 249216*D1*Dd*fd*g2*r*s + 30096*D1*Dd*fd*g2*r - 124608*D1*Dd*fd*g2*s**2 + 30096*D1*Dd*fd*g2*s + 47520*D1*Dd*fd*g2 + 44880*D1*Ddd*K*f**2*r**2 + 84480*D1*Ddd*K*f**2*r*s - 64680*D1*Ddd*K*f**2*r + 39600*D1*Ddd*K*f**2*s**2 - 60720*D1*Ddd*K*f**2*s + 31020*D1*Ddd*K*f**2 + 15840*D1*Ddd*b2*f*r**2 + 31680*D1*Ddd*b2*f*r*s - 23760*D1*Ddd*b2*f*r + 15840*D1*Ddd*b2*f*s**2 - 23760*D1*Ddd*b2*f*s + 11880*D1*Ddd*b2*f - 31280*D1*Ddd*f**3*r**2 - 45920*D1*Ddd*f**3*r*s + 38600*D1*Ddd*f**3*r - 14640*D1*Ddd*f**3*s**2 + 26120*D1*Ddd*f**3*s - 15140*D1*Ddd*f**3 - 38808*D1*Ddd*f**2*r**2 - 79728*D1*Ddd*f**2*r*s + 59268*D1*Ddd*f**2*r - 40920*D1*Ddd*f**2*s**2 + 60852*D1*Ddd*f**2*s - 30162*D1*Ddd*f**2 - 62304*D1*Ddd*f*g2*r**2 - 124608*D1*Ddd*f*g2*r*s + 93456*D1*Ddd*f*g2*r - 62304*D1*Ddd*f*g2*s**2 + 93456*D1*Ddd*f*g2*s - 46728*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(16*K*fd*(59*r**2 + 2*r*(59*s - 22) + 59*s**2 - 44*s - 15) + 6*f**2*(70*r**2 + 2*r*(78*s - 79) + 86*s**2 - 174*s + 83) - f*(140*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 496*K*r**2 + 824*K*r*s - 1248*K*r + 328*K*s**2 - 1080*K*s + 582*K + 48*fd*(46*r**2 + 100*r*s - 73*r + 54*s**2 - 79*s + 26) - 658*r**2 - 1284*r*s + 1310*r - 626*s**2 + 1278*s - 647) - 12*fd*(77*r**2 + 2*r*(85*s - 33) + 93*s**2 - 74*s - 15) - 560*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 560*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(12*f**2*(92*r**2 + r*(200*s - 169) + 108*s**2 - 183*s + 76) + f*(-4*K*(236*r**2 + 472*r*s - 473*r + 236*s**2 - 473*s + 222) + 924*r**2 + 2040*r*s - 1893*r + 1116*s**2 - 2061*s + 912) - 140*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 330*D1*bd2*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) + 134640*Dd**2*K*f**2*r**2 + 253440*Dd**2*K*f**2*r*s - 194040*Dd**2*K*f**2*r + 118800*Dd**2*K*f**2*s**2 - 182160*Dd**2*K*f**2*s + 62040*Dd**2*K*f**2 + 47520*Dd**2*b2*f*r**2 + 95040*Dd**2*b2*f*r*s - 71280*Dd**2*b2*f*r + 47520*Dd**2*b2*f*s**2 - 71280*Dd**2*b2*f*s + 23760*Dd**2*b2*f - 93840*Dd**2*f**3*r**2 - 137760*Dd**2*f**3*r*s + 115800*Dd**2*f**3*r - 43920*Dd**2*f**3*s**2 + 78360*Dd**2*f**3*s - 30280*Dd**2*f**3 - 116424*Dd**2*f**2*r**2 - 239184*Dd**2*f**2*r*s + 177804*Dd**2*f**2*r - 122760*Dd**2*f**2*s**2 + 182556*Dd**2*f**2*s - 60324*Dd**2*f**2 - 186912*Dd**2*f*g2*r**2 - 373824*Dd**2*f*g2*r*s + 280368*Dd**2*f*g2*r - 186912*Dd**2*f*g2*s**2 + 280368*Dd**2*f*g2*s - 93456*Dd**2*f*g2) + 4290*b2*(-12*D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*(-f*(7*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bd1*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) - 2*D1*f*(Dd*(-7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(9009*d**2*k3**5) + 4*D1**2*Pk1*Pkd3*ct**3*k1*k2*st**2*(11*b1**2*(D1**2*(s - 1)*(fd*(37*C - 31) + fdd*(12 - 15*C))*(r + s - 1) + D1*(Dd*(f*(37*C - 31)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(15*C - 12)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(12 - 15*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(15*C - 12)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 11*b1*(D1**2*(f*(fd*(C*(-50*r*s + 25*r - 50*s**2 + 21*s - 25) + 38*r*s - 19*r + 38*s**2 - 15*s + 19) + (15*C - 12)*(bdd1*s*(-2*r - 2*s + 1) + fdd*(2*r*s - r + 2*s**2 - s + 1))) + fd**2*(15*C - 12)*(r*(2*s - 1) + 2*s**2 - s - 1)) + D1*bd1*(D1*(f*s*(37*C - 31)*(2*r + 2*s - 1) - fd*(15*C - 12)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(24 - 30*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(-f*(25*C - 19)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(15*C - 12)*(2*s - 1)*(8*r + 8*s - 3)) + Ddd*f*(15*C - 12)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(15*C - 12)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-33*D1**2*bd1**2*s*(5*C - 4)*(2*r + 2*s - 1) + D1**2*(f*(fd*(334 - 434*C)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + (5*C - 4)*(33*bdd1*s*(r + s - 2) + 50*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1))) + fd**2*(250*C - 200)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 11*D1*bd1*(D1*(f*s*(C*(25*r + 25*s - 54) - 19*r - 19*s + 42) + fd*(12 - 15*C)*(r*(4*s - 1) + 4*s**2 - 5*s + 2)) + Dd*f*(12 - 15*C)*(r*(8*s - 2) + 8*s**2 - 13*s + 4)) - 2*D1*f*(Dd*(f*(217*C - 167)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(125*C - 100)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + Ddd*f*(100 - 125*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(250*C - 200)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**3*k1*k2*(-11*b1**2*(D1**2*(4*fd*(18*C*r + 88*C*(s - 1) - 11*r - 72*s + 72) + fdd*(-4*C*(37*r + 79*s - 79) + 99*r + 263*s - 263))*(r + s - 1) + D1*(2*Dd*(2*f*(2*C*(36*r**2 + 4*r*(53*s - 31) + 176*s**2 - 229*s + 97) - 44*r**2 - 332*r*s + 188*r - 288*s**2 + 371*s - 155) + fd*(-4*C*(148*r**2 + 464*r*s - 385*r + 316*s**2 - 532*s + 216) + 396*r**2 + 1448*r*s - 1185*r + 1052*s**2 - 1759*s + 707)) + Ddd*f*(-4*C*(148*r**2 + 464*r*s - 306*r + 316*s**2 - 432*s + 195) + 396*r**2 + 1448*r*s - 922*r + 1052*s**2 - 1414*s + 625)) - 2*Dd**2*f*(12*C*(74*r**2 + r*(232*s - 153) + 158*s**2 - 216*s + 65) - 594*r**2 - 3*r*(724*s - 461) - 1578*s**2 + 2121*s - 625)) - 11*b1*(64*C*D1**2*f*fd*r**2 + 32*C*D1**2*f*fd*r*s - 224*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s**2 - 368*C*D1**2*f*fd*s + 88*C*D1**2*f*fd - 56*C*D1**2*f*fdd*r**2 - 64*C*D1**2*f*fdd*r*s + 328*C*D1**2*f*fdd*r - 8*C*D1**2*f*fdd*s**2 + 424*C*D1**2*f*fdd*s - 152*C*D1**2*f*fdd - 56*C*D1**2*fd**2*r**2 - 64*C*D1**2*fd**2*r*s + 328*C*D1**2*fd**2*r - 8*C*D1**2*fd**2*s**2 + 424*C*D1**2*fd**2*s - 416*C*D1**2*fd**2 + 128*C*D1*Dd*f**2*r**2 + 64*C*D1*Dd*f**2*r*s - 96*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 448*C*D1*Dd*f*fd*r**2 - 512*C*D1*Dd*f*fd*r*s + 1552*C*D1*Dd*f*fd*r - 64*C*D1*Dd*f*fd*s**2 + 1792*C*D1*Dd*f*fd*s - 1176*C*D1*Dd*f*fd - 112*C*D1*Ddd*f**2*r**2 - 128*C*D1*Ddd*f**2*r*s + 120*C*D1*Ddd*f**2*r - 16*C*D1*Ddd*f**2*s**2 + 48*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 336*C*Dd**2*f**2*r**2 - 384*C*Dd**2*f**2*r*s + 360*C*Dd**2*f**2*r - 48*C*Dd**2*f**2*s**2 + 144*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 + D1**2*bdd1*f*(-4*C*(74*r**2 + 232*r*s - 74*r + 158*s**2 - 116*s + 37) + 198*r**2 + 724*r*s - 198*r + 526*s**2 - 362*s + 99) - 40*D1**2*f*fd*r**2 + 64*D1**2*f*fd*r*s + 100*D1**2*f*fd*r + 104*D1**2*f*fd*s**2 + 204*D1**2*f*fd*s - 14*D1**2*f*fd + 38*D1**2*f*fdd*r**2 - 44*D1**2*f*fdd*r*s - 176*D1**2*f*fdd*r - 82*D1**2*f*fdd*s**2 - 240*D1**2*f*fdd*s + 58*D1**2*f*fdd + 38*D1**2*fd**2*r**2 - 44*D1**2*fd**2*r*s - 176*D1**2*fd**2*r - 82*D1**2*fd**2*s**2 - 240*D1**2*fd**2*s + 322*D1**2*fd**2 - 80*D1*Dd*f**2*r**2 + 128*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 208*D1*Dd*f**2*s**2 - 240*D1*Dd*f**2*s + 84*D1*Dd*f**2 + 304*D1*Dd*f*fd*r**2 - 352*D1*Dd*f*fd*r*s - 692*D1*Dd*f*fd*r - 656*D1*Dd*f*fd*s**2 - 588*D1*Dd*f*fd*s + 656*D1*Dd*f*fd + 76*D1*Ddd*f**2*r**2 - 88*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 164*D1*Ddd*f**2*s**2 + 186*D1*Ddd*f**2*s - 63*D1*Ddd*f**2 + 2*D1*bd1*(D1*(2*f*(2*C*(18*r**2 + 2*r*(53*s - 9) + 88*s**2 - 53*s + 9) - 22*r**2 - 166*r*s + 22*r - 144*s**2 + 83*s - 11) + fd*(-4*C*(74*r**2 + 232*r*s - 153*r + 158*s**2 - 216*s + 58) + 198*r**2 + 724*r*s - 461*r + 526*s**2 - 707*s + 181)) + Dd*f*(-4*C*(296*r**2 + 928*r*s - 454*r + 632*s**2 - 664*s + 153) + 792*r**2 + 2896*r*s - 1318*r + 2104*s**2 - 2138*s + 461)) + 228*Dd**2*f**2*r**2 - 264*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 492*Dd**2*f**2*s**2 + 558*Dd**2*f**2*s - 126*Dd**2*f**2) + f*(22*D1**2*bd1**2*(r**2*(148*C - 99) + r*(4*C*(116*s - 37) - 362*s + 99) + s*(4*C*(79*s - 58) - 263*s + 181)) + 11*D1**2*bdd1*f*(4*C*(7*r**2 + r*(8*s + 60) + s**2 + 96*s - 30) - 19*r**2 + 2*r*(11*s - 80) + 41*s**2 - 344*s + 80) + 5*D1**2*(f*(fd*(4*C*(159*r**2 + r*(588*s - 302) + 429*s**2 - 482*s + 196) - 411*r**2 + r*(952 - 2034*s) - 1623*s**2 + 1760*s - 678) + fdd*(-4*C*(195*r**2 + r*(558*s - 316) + 363*s**2 - 428*s + 186) + 519*r**2 + 2*r*(987*s - 502) + 1455*s**2 - 1628*s + 658)) + 2*fd**2*(-4*C*(195*r**2 + r*(558*s - 316) + 363*s**2 - 428*s + 93) + 519*r**2 + 2*r*(987*s - 502) + 1455*s**2 - 1628*s + 329)) - 22*D1*bd1*(D1*(f*(4*C*(4*r**2 + 2*r*(s + 9) - 2*s**2 + 48*s - 9) - 10*r**2 + 16*r*s - 46*r + 26*s**2 - 170*s + 23) - 2*fd*(C*(28*r**2 + 32*r*s + 38*r + 4*s**2 + 86*s - 96) - 19*r**2 + 22*r*s - 36*r + 41*s**2 - 112*s + 86)) - Dd*f*(4*C*(28*r**2 + 32*r*s + 105*r + 4*s**2 + 186*s - 126) - 76*r**2 + 88*r*s - 323*r + 164*s**2 - 781*s + 424)) + 5*D1*f*(Dd*(f*(4*C*(212*r**2 + 784*r*s - 498*r + 572*s**2 - 768*s + 339) - 548*r**2 - 2712*r*s + 1630*r - 2164*s**2 + 2842*s - 1219) - 2*fd*(4*C*(780*r**2 + 2232*r*s - 1385*r + 1452*s**2 - 1861*s + 586) - 2076*r**2 - 7896*r*s + 4501*r - 5820*s**2 + 7153*s - 2130)) + Ddd*f*(-4*C*(260*r**2 + 744*r*s - 502*r + 484*s**2 - 670*s + 307) + 692*r**2 + 2632*r*s - 1662*r + 1940*s**2 - 2598*s + 1143)) + 10*Dd**2*f**2*(-4*C*(390*r**2 + 3*r*(372*s - 251) + 726*s**2 - 1005*s + 307) + 1038*r**2 + 3*r*(1316*s - 831) + 2910*s**2 - 3897*s + 1143)))/(231*d**2*k3**3) - D1**2*Pk1*Pkd3*ct**3*k1*(8*C - 4)*(D1*f*(-6*D1*bd1**2*s*(2*r + 2*s - 1) + D1*bd1*(4*f*s*(r + s) - 5*fd*(r*(4*s - 1) + s*(4*s - 3))) - 5*D1*bdd1*f*s*(r + s) - 5*Dd*bd1*f*(r*(8*s - 2) + s*(8*s - 5))) + b1**2*(D1**2*(5*fd - 6*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 6*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 6*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 6*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(D1**2*(f*(-6*bdd1*s*(2*r + 2*s - 1) + 4*fd*(2*s - 1)*(r + s - 1) - 5*fdd*(2*s - 1)*(r + s - 1)) - 5*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(5*f*s*(2*r + 2*s - 1) - 6*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 12*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(4*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 5*fd*(2*s - 1)*(8*r + 8*s - 7)) - 5*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k2*k3) - D1**2*Pk1*Pkd3*ct**3*k2**5*st**2*(-30888*C*D1**2*f**2*fd*r**2 - 30888*C*D1**2*f**2*fd*r*s + 30888*C*D1**2*f**2*fd*r + 10296*C*D1**2*f**2*fd*s - 10296*C*D1**2*f**2*fd - 41184*C*D1*Dd*f**3*r**2 - 41184*C*D1*Dd*f**3*r*s + 41184*C*D1*Dd*f**3*r + 10296*C*D1*Dd*f**3*s - 10296*C*D1*Dd*f**3 - 2574*D1**2*K*bdd1*f**2*r**2 - 2574*D1**2*K*bdd1*f**2*r*s + 2574*D1**2*K*bdd1*f**2*r + 858*D1**2*bd1**2*f*(r + s - 1)*(-6*K*r + 3*K + 25*f*(2*r + 2*s - 1) + 21*r + 15*s - 18) + 12155*D1**2*bdd1*f**3*r**2 + 4810*D1**2*bdd1*f**3*r*s - 5980*D1**2*bdd1*f**3*r - 7345*D1**2*bdd1*f**3*s**2 + 13520*D1**2*bdd1*f**3*s + 1950*D1**2*bdd1*f**3 + 9009*D1**2*bdd1*f**2*r**2 + 15444*D1**2*bdd1*f**2*r*s - 15444*D1**2*bdd1*f**2*r + 6435*D1**2*bdd1*f**2*s**2 - 12870*D1**2*bdd1*f**2*s + 6435*D1**2*bdd1*f**2 + 5148*D1**2*bdd1*f*g2*r**2 + 5148*D1**2*bdd1*f*g2*r*s - 10296*D1**2*bdd1*f*g2*r - 5148*D1**2*bdd1*f*g2*s + 5148*D1**2*bdd1*f*g2 + 20500*D1**2*f**3*fd*r**2 + 79000*D1**2*f**3*fd*r*s - 49750*D1**2*f**3*fd*r + 58500*D1**2*f**3*fd*s**2 - 78250*D1**2*f**3*fd*s + 34375*D1**2*f**3*fd - 44700*D1**2*f**3*fdd*r**2 - 116200*D1**2*f**3*fdd*r*s + 80450*D1**2*f**3*fdd*r - 71500*D1**2*f**3*fdd*s**2 + 100550*D1**2*f**3*fdd*s - 46925*D1**2*f**3*fdd - 134100*D1**2*f**2*fd**2*r**2 - 348600*D1**2*f**2*fd**2*r*s + 241350*D1**2*f**2*fd**2*r - 214500*D1**2*f**2*fd**2*s**2 + 301650*D1**2*f**2*fd**2*s - 93850*D1**2*f**2*fd**2 + 50193*D1**2*f**2*fd*r**2 + 69498*D1**2*f**2*fd*r*s - 56628*D1**2*f**2*fd*r + 19305*D1**2*f**2*fd*s**2 - 36036*D1**2*f**2*fd*s + 23166*D1**2*f**2*fd - 8580*D1**2*f**2*gd2*r**2 - 8580*D1**2*f**2*gd2*r*s + 8580*D1**2*f**2*gd2*r + 5148*D1**2*f**2*gdd2*r**2 + 5148*D1**2*f**2*gdd2*r*s - 5148*D1**2*f**2*gdd2*r - 17160*D1**2*f*fd*g2*r**2 - 17160*D1**2*f*fd*g2*r*s + 17160*D1**2*f*fd*g2*r + 8580*D1**2*f*fd*g2*s - 8580*D1**2*f*fd*g2 + 20592*D1**2*f*fd*gd2*r**2 + 20592*D1**2*f*fd*gd2*r*s - 20592*D1**2*f*fd*gd2*r - 5148*D1**2*f*fd*gd2*s + 5148*D1**2*f*fd*gd2 + 10296*D1**2*f*fdd*g2*r**2 + 10296*D1**2*f*fdd*g2*r*s - 10296*D1**2*f*fdd*g2*r - 5148*D1**2*f*fdd*g2*s + 5148*D1**2*f*fdd*g2 + 10296*D1**2*fd**2*g2*r**2 + 10296*D1**2*fd**2*g2*r*s - 10296*D1**2*fd**2*g2*r - 5148*D1**2*fd**2*g2*s + 20500*D1*Dd*f**4*r**2 + 79000*D1*Dd*f**4*r*s - 49750*D1*Dd*f**4*r + 58500*D1*Dd*f**4*s**2 - 78250*D1*Dd*f**4*s + 34375*D1*Dd*f**4 - 357600*D1*Dd*f**3*fd*r**2 - 929600*D1*Dd*f**3*fd*r*s + 643600*D1*Dd*f**3*fd*r - 572000*D1*Dd*f**3*fd*s**2 + 804400*D1*Dd*f**3*fd*s - 281550*D1*Dd*f**3*fd + 66924*D1*Dd*f**3*r**2 + 92664*D1*Dd*f**3*r*s - 79794*D1*Dd*f**3*r + 25740*D1*Dd*f**3*s**2 - 48906*D1*Dd*f**3*s + 29601*D1*Dd*f**3 - 34320*D1*Dd*f**2*g2*r**2 - 34320*D1*Dd*f**2*g2*r*s + 34320*D1*Dd*f**2*g2*r + 8580*D1*Dd*f**2*g2*s - 8580*D1*Dd*f**2*g2 + 41184*D1*Dd*f**2*gd2*r**2 + 41184*D1*Dd*f**2*gd2*r*s - 41184*D1*Dd*f**2*gd2*r - 5148*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 82368*D1*Dd*f*fd*g2*r**2 + 82368*D1*Dd*f*fd*g2*r*s - 82368*D1*Dd*f*fd*g2*r - 30888*D1*Dd*f*fd*g2*s + 20592*D1*Dd*f*fd*g2 - 44700*D1*Ddd*f**4*r**2 - 116200*D1*Ddd*f**4*r*s + 80450*D1*Ddd*f**4*r - 71500*D1*Ddd*f**4*s**2 + 100550*D1*Ddd*f**4*s - 46925*D1*Ddd*f**4 + 20592*D1*Ddd*f**2*g2*r**2 + 20592*D1*Ddd*f**2*g2*r*s - 20592*D1*Ddd*f**2*g2*r - 5148*D1*Ddd*f**2*g2*s + 5148*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(f**3*(2563*r**2 + r*(3578*s - 2570) + 1015*s**2 - 1022*s + 1257) + f**2*(792*C*(r - 1)*(r + s - 1) - 10*fd*(561*r**2 + 222*r*s - 353*r - 339*s**2 + 397*s - 192) - (r + s - 1)*(330*K*r - 33*r - 495*s - 297)) + 66*f*(3*fd*(K*(4*r**2 + 4*r*(s - 1) - s + 1) - 14*r**2 - 24*r*s + 19*r - 10*s**2 + 16*s - 6) + (-2*g2*(r - 1) - 6*gd2*(2*r - 1))*(r + s - 1)) - 396*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 2*Dd*f*(5*f**2*(748*r**2 + r*(296*s - 445) - 452*s**2 + 605*s - 162) - 99*f*(K*(8*r**2 + 8*r*(s - 1) - s + 1) - 28*r**2 - 48*r*s + 43*r - 20*s**2 + 36*s - 16) + 198*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 134100*Dd**2*f**4*r**2 - 348600*Dd**2*f**4*r*s + 241350*Dd**2*f**4*r - 214500*Dd**2*f**4*s**2 + 301650*Dd**2*f**4*s - 93850*Dd**2*f**4 + 61776*Dd**2*f**2*g2*r**2 + 61776*Dd**2*f**2*g2*r*s - 61776*Dd**2*f**2*g2*r - 15444*Dd**2*f**2*g2*s + 10296*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(25*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 50*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*fd*(r + s)*(r*(K + 14) + 15*s) + 3*fdd*(r + s)*(r*(2*K - 7) - 5*s)) + D1*(2*Dd*(50*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(K*(4*r**2 + 4*r*(s - 1) - s + 1) - 25*fd*(4*r + 4*s - 3)**2 + 56*r**2 + 116*r*s - 86*r + 60*s**2 - 89*s + 44) + 3*fd*(r**2*(8*K - 28) + r*(K*(8*s - 4) - 48*s + 19) - s*(K + 20*s - 16))) - Ddd*f*(-3*K*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 50*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 84*r**2 + 144*r*s - 114*r + 60*s**2 - 96*s + 51)) - 6*Dd**2*f*(K*(-12*r**2 - 12*r*(s - 1) + 3*s - 2) + 50*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 42*r**2 + 72*r*s - 57*r + 30*s**2 - 48*s + 17)) - 13*b1*(1584*C*D1**2*f*fd*r**2 + 1584*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 3168*C*D1*Dd*f**2*r**2 + 3168*C*D1*Dd*f**2*r*s - 3168*C*D1*Dd*f**2*r - 792*C*D1*Dd*f**2*s + 792*C*D1*Dd*f**2 - 660*D1**2*K*f*fd*r**2 - 660*D1**2*K*f*fd*r*s + 660*D1**2*K*f*fd*r + 330*D1**2*K*f*fd*s - 330*D1**2*K*f*fd + 396*D1**2*K*f*fdd*r**2 + 396*D1**2*K*f*fdd*r*s - 396*D1**2*K*f*fdd*r - 198*D1**2*K*f*fdd*s + 198*D1**2*K*f*fdd + 396*D1**2*K*fd**2*r**2 + 396*D1**2*K*fd**2*r*s - 396*D1**2*K*fd**2*r - 198*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(25*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (r + s - 1)*(-12*K*r + 6*K + 42*r + 30*s - 36)) + 7689*D1**2*f**2*fd*r**2 + 10734*D1**2*f**2*fd*r*s - 9712*D1**2*f**2*fd*r + 3045*D1**2*f**2*fd*s**2 - 6616*D1**2*f**2*fd*s + 3336*D1**2*f**2*fd - 2805*D1**2*f**2*fdd*r**2 - 1110*D1**2*f**2*fdd*r*s + 2150*D1**2*f**2*fdd*r + 1695*D1**2*f**2*fdd*s**2 - 850*D1**2*f**2*fdd*s + 345*D1**2*f**2*fdd - 5610*D1**2*f*fd**2*r**2 - 2220*D1**2*f*fd**2*r*s + 4300*D1**2*f*fd**2*r + 3390*D1**2*f*fd**2*s**2 - 1700*D1**2*f*fd**2*s - 1530*D1**2*f*fd**2 + 66*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 858*D1**2*f*fd*r + 990*D1**2*f*fd*s**2 - 1320*D1**2*f*fd*s + 825*D1**2*f*fd - 1386*D1**2*f*fdd*r**2 - 2376*D1**2*f*fdd*r*s + 1386*D1**2*f*fdd*r - 990*D1**2*f*fdd*s**2 + 1188*D1**2*f*fdd*s - 693*D1**2*f*fdd - 132*D1**2*f*gd2*r**2 - 132*D1**2*f*gd2*r*s + 132*D1**2*f*gd2*r - 396*D1**2*f*gdd2*r**2 - 396*D1**2*f*gdd2*r*s + 396*D1**2*f*gdd2*r - 1386*D1**2*fd**2*r**2 - 2376*D1**2*fd**2*r*s + 1386*D1**2*fd**2*r - 990*D1**2*fd**2*s**2 + 1188*D1**2*fd**2*s - 132*D1**2*fd*g2*r**2 - 132*D1**2*fd*g2*r*s - 792*D1**2*fd*gd2*r**2 - 792*D1**2*fd*gd2*r*s + 396*D1**2*fd*gd2*r - 396*D1**2*fdd*g2*r**2 - 396*D1**2*fdd*g2*r*s - 1320*D1*Dd*K*f**2*r**2 - 1320*D1*Dd*K*f**2*r*s + 1320*D1*Dd*K*f**2*r + 330*D1*Dd*K*f**2*s - 330*D1*Dd*K*f**2 + 3168*D1*Dd*K*f*fd*r**2 + 3168*D1*Dd*K*f*fd*r*s - 3168*D1*Dd*K*f*fd*r - 1188*D1*Dd*K*f*fd*s + 792*D1*Dd*K*f*fd + 10252*D1*Dd*f**3*r**2 + 14312*D1*Dd*f**3*r*s - 12282*D1*Dd*f**3*r + 4060*D1*Dd*f**3*s**2 - 7638*D1*Dd*f**3*s + 4593*D1*Dd*f**3 - 22440*D1*Dd*f**2*fd*r**2 - 8880*D1*Dd*f**2*fd*r*s + 16430*D1*Dd*f**2*fd*r + 13560*D1*Dd*f**2*fd*s**2 - 9070*D1*Dd*f**2*fd*s - 450*D1*Dd*f**2*fd + 132*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 1122*D1*Dd*f**2*r + 1980*D1*Dd*f**2*s**2 - 2508*D1*Dd*f**2*s + 1023*D1*Dd*f**2 - 11088*D1*Dd*f*fd*r**2 - 19008*D1*Dd*f*fd*r*s + 13068*D1*Dd*f*fd*r - 7920*D1*Dd*f*fd*s**2 + 11088*D1*Dd*f*fd*s - 3762*D1*Dd*f*fd - 528*D1*Dd*f*g2*r**2 - 528*D1*Dd*f*g2*r*s + 528*D1*Dd*f*g2*r + 132*D1*Dd*f*g2*s - 132*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 3168*D1*Dd*f*gd2*r*s + 3168*D1*Dd*f*gd2*r + 396*D1*Dd*f*gd2*s - 396*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 3168*D1*Dd*fd*g2*r*s + 1584*D1*Dd*fd*g2*r + 396*D1*Dd*fd*g2*s + 792*D1*Ddd*K*f**2*r**2 + 792*D1*Ddd*K*f**2*r*s - 792*D1*Ddd*K*f**2*r - 198*D1*Ddd*K*f**2*s + 198*D1*Ddd*K*f**2 - 3740*D1*Ddd*f**3*r**2 - 1480*D1*Ddd*f**3*r*s + 2610*D1*Ddd*f**3*r + 2260*D1*Ddd*f**3*s**2 - 1890*D1*Ddd*f**3*s + 195*D1*Ddd*f**3 - 2772*D1*Ddd*f**2*r**2 - 4752*D1*Ddd*f**2*r*s + 3762*D1*Ddd*f**2*r - 1980*D1*Ddd*f**2*s**2 + 3168*D1*Ddd*f**2*s - 1683*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 1584*D1*Ddd*f*g2*r*s + 1584*D1*Ddd*f*g2*r + 396*D1*Ddd*f*g2*s - 396*D1*Ddd*f*g2 + 66*D1*bd1*(25*D1*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - D1*f*(r + s - 1)*(-2*K*r + K + 100*fd*(2*r + 2*s - 1) - 28*r - 30*s + 29) + 3*D1*fd*(r**2*(4*K - 14) + r*(4*K*s - 3*K - 24*s + 13) - s*(K + 10*s - 11)) - 25*Dd*f**2*(4*r + 4*s - 3)**2 + 3*Dd*f*(K*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) - 56*r**2 - 96*r*s + 90*r - 40*s**2 + 76*s - 35)) + 2376*Dd**2*K*f**2*r**2 + 2376*Dd**2*K*f**2*r*s - 2376*Dd**2*K*f**2*r - 594*Dd**2*K*f**2*s + 396*Dd**2*K*f**2 - 11220*Dd**2*f**3*r**2 - 4440*Dd**2*f**3*r*s + 7830*Dd**2*f**3*r + 6780*Dd**2*f**3*s**2 - 5670*Dd**2*f**3*s + 390*Dd**2*f**3 - 8316*Dd**2*f**2*r**2 - 14256*Dd**2*f**2*r*s + 11286*Dd**2*f**2*r - 5940*Dd**2*f**2*s**2 + 9504*Dd**2*f**2*s - 3366*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 4752*Dd**2*f*g2*r*s + 4752*Dd**2*f*g2*r + 1188*Dd**2*f*g2*s - 792*Dd**2*f*g2))/(9009*d**2*k1*k3**5) + D1**2*Pk1*Pkd3*ct**3*k2**3*st**2*(33*b1**2*(D1**2*(2*fd*(2*C*r + r + 3*s - 3) + 3*fdd*(r*(4*C - 5) - s + 1))*(r + s - 1) + D1*(2*Dd*(f*(C*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + 4*r**2 + 2*r*(8*s - 5) + 12*s**2 - 16*s + 7) + 3*fd*(2*C*(8*r**2 + 8*r*(s - 1) - s + 1) - 20*r**2 + r*(23 - 24*s) - 4*s**2 + 9*s - 5)) + 3*Ddd*f*(4*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 20*r**2 + r*(22 - 24*s) - 4*s**2 + 10*s - 7)) + 6*Dd**2*f*(C*(24*r**2 + 24*r*(s - 1) - 6*s + 4) - 30*r**2 + r*(33 - 36*s) - 6*s**2 + 15*s - 7)) + 33*b1*(-40*C*D1**2*f*fd*r**2 - 40*C*D1**2*f*fd*r*s + 60*C*D1**2*f*fd*r + 20*C*D1**2*f*fd*s - 20*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 24*C*D1**2*f*fdd*r*s - 36*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 24*C*D1**2*fd**2*r*s - 36*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 - 80*C*D1*Dd*f**2*r**2 - 80*C*D1*Dd*f**2*r*s + 80*C*D1*Dd*f**2*r + 20*C*D1*Dd*f**2*s - 20*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 192*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r - 72*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 48*C*D1*Ddd*f**2*r*s - 48*C*D1*Ddd*f**2*r - 12*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 144*C*Dd**2*f**2*r*s - 144*C*Dd**2*f**2*r - 36*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 + 3*D1**2*bdd1*f*(C*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 10*r**2 - 12*r*s + 10*r - 2*s**2 + 6*s - 5) + 22*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s - 22*D1**2*f*fd*r - 82*D1**2*f*fd*s**2 + 50*D1**2*f*fd*s - 15*D1**2*f*fd - 12*D1**2*f*fdd*r**2 + 56*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r + 68*D1**2*f*fdd*s**2 - 50*D1**2*f*fdd*s + 19*D1**2*f*fdd - 12*D1**2*fd**2*r**2 + 56*D1**2*fd**2*r*s + 2*D1**2*fd**2*r + 68*D1**2*fd**2*s**2 - 50*D1**2*fd**2*s - 18*D1**2*fd**2 + 44*D1*Dd*f**2*r**2 - 120*D1*Dd*f**2*r*s + 38*D1*Dd*f**2*r - 164*D1*Dd*f**2*s**2 + 194*D1*Dd*f**2*s - 71*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 + 448*D1*Dd*f*fd*r*s - 80*D1*Dd*f*fd*r + 544*D1*Dd*f*fd*s**2 - 528*D1*Dd*f*fd*s + 98*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 + 112*D1*Ddd*f**2*r*s - 44*D1*Ddd*f**2*r + 136*D1*Ddd*f**2*s**2 - 164*D1*Ddd*f**2*s + 62*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(C*(4*r**2 + 4*r*(s - 1) - 2*s + 2) + 2*r**2 + 8*r*s - 2*r + 6*s**2 - 4*s + 1) + 3*fd*(C*(8*r**2 + 8*r*(s - 1) - 2*s + 2) - 10*r**2 - 12*r*s + 11*r - 2*s**2 + 5*s - 3)) + 3*Dd*f*(4*C*(8*r**2 + 8*r*(s - 1) - 3*s + 2) - 40*r**2 - 48*r*s + 42*r - 8*s**2 + 22*s - 11)) - 72*Dd**2*f**2*r**2 + 336*Dd**2*f**2*r*s - 132*Dd**2*f**2*r + 408*Dd**2*f**2*s**2 - 492*Dd**2*f**2*s + 124*Dd**2*f**2) + f*(336*C*D1**2*f*fd*r**2 + 336*C*D1**2*f*fd*r*s - 336*C*D1**2*f*fd*r - 112*C*D1**2*f*fd*s + 112*C*D1**2*f*fd - 960*C*D1**2*f*fdd*r**2 - 960*C*D1**2*f*fdd*r*s + 960*C*D1**2*f*fdd*r + 320*C*D1**2*f*fdd*s - 320*C*D1**2*f*fdd - 1920*C*D1**2*fd**2*r**2 - 1920*C*D1**2*fd**2*r*s + 1920*C*D1**2*fd**2*r + 640*C*D1**2*fd**2*s - 320*C*D1**2*fd**2 + 448*C*D1*Dd*f**2*r**2 + 448*C*D1*Dd*f**2*r*s - 448*C*D1*Dd*f**2*r - 112*C*D1*Dd*f**2*s + 112*C*D1*Dd*f**2 - 7680*C*D1*Dd*f*fd*r**2 - 7680*C*D1*Dd*f*fd*r*s + 7680*C*D1*Dd*f*fd*r + 2240*C*D1*Dd*f*fd*s - 1600*C*D1*Dd*f*fd - 1280*C*D1*Ddd*f**2*r**2 - 1280*C*D1*Ddd*f**2*r*s + 1280*C*D1*Ddd*f**2*r + 320*C*D1*Ddd*f**2*s - 320*C*D1*Ddd*f**2 - 3840*C*Dd**2*f**2*r**2 - 3840*C*Dd**2*f**2*r*s + 3840*C*Dd**2*f**2*r + 960*C*Dd**2*f**2*s - 640*C*Dd**2*f**2 + 198*D1**2*bd1**2*(r**2*(4*C - 5) + r*(4*C*(s - 1) - 6*s + 5) - s*(2*C + s - 3)) + 33*D1**2*bdd1*f*(r**2*(12*C - 6) + 2*r*(s*(6*C + 14) - 9) + 34*s**2 - 46*s + 9) - 2481*D1**2*f*fd*r**2 - 6654*D1**2*f*fd*r*s + 3872*D1**2*f*fd*r - 4173*D1**2*f*fd*s**2 + 5000*D1**2*f*fd*s - 2218*D1**2*f*fd + 2379*D1**2*f*fdd*r**2 + 5802*D1**2*f*fdd*r*s - 3520*D1**2*f*fdd*r + 3423*D1**2*f*fdd*s**2 - 4216*D1**2*f*fdd*s + 1934*D1**2*f*fdd + 4758*D1**2*fd**2*r**2 + 11604*D1**2*fd**2*r*s - 7040*D1**2*fd**2*r + 6846*D1**2*fd**2*s**2 - 8432*D1**2*fd**2*s + 1934*D1**2*fd**2 - 3308*D1*Dd*f**2*r**2 - 8872*D1*Dd*f**2*r*s + 6090*D1*Dd*f**2*r - 5564*D1*Dd*f**2*s**2 + 7782*D1*Dd*f**2*s - 3609*D1*Dd*f**2 + 19032*D1*Dd*f*fd*r**2 + 46416*D1*Dd*f*fd*r*s - 30442*D1*Dd*f*fd*r + 27384*D1*Dd*f*fd*s**2 - 36358*D1*Dd*f*fd*s + 11952*D1*Dd*f*fd + 3172*D1*Ddd*f**2*r**2 + 7736*D1*Ddd*f**2*r*s - 5454*D1*Ddd*f**2*r + 4564*D1*Ddd*f**2*s**2 - 6498*D1*Ddd*f**2*s + 3075*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(r**2*(20*C - 11) + 10*r*(2*C*s + 3*s - 3) + 41*s**2 - 62*s + 15) - 2*fd*(-6*C*s + r**2*(24*C - 12) + r*(6*C*(4*s - 3) + 56*s - 17) + 68*s**2 - 71*s + 23)) + 2*Dd*f*(r**2*(24 - 48*C) + r*(C*(24 - 48*s) - 112*s + 58) - 136*s**2 + s*(6*C + 174) - 55)) + 9516*Dd**2*f**2*r**2 + 23208*Dd**2*f**2*r*s - 16362*Dd**2*f**2*r + 13692*Dd**2*f**2*s**2 - 19494*Dd**2*f**2*s + 6150*Dd**2*f**2))/(693*d**2*k1*k3**3) + D1**2*Pk1*Pkd3*ct**3*k2**3*(-132*D1**2*K*bdd1*f**2*r**2 - 132*D1**2*K*bdd1*f**2*r*s + 132*D1**2*K*bdd1*f**2*r + 528*D1**2*b2*f*fd*r**2 + 528*D1**2*b2*f*fd*r*s - 528*D1**2*b2*f*fd*r - 264*D1**2*b2*f*fd*s + 264*D1**2*b2*f*fd - 264*D1**2*b2*f*fdd*r**2 - 264*D1**2*b2*f*fdd*r*s + 264*D1**2*b2*f*fdd*r + 132*D1**2*b2*f*fdd*s - 132*D1**2*b2*f*fdd - 264*D1**2*b2*fd**2*r**2 - 264*D1**2*b2*fd**2*r*s + 264*D1**2*b2*fd**2*r + 132*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*f*(f*(r**2 + r*(25 - 78*s) - 79*s**2 + 83*s - 24) + r**2*(11 - 4*K) + 2*r*(-2*K*s + K - 15*s + 7) - 41*s**2 + 64*s - 23) + 264*D1**2*bd2*f**2*r**2 + 264*D1**2*bd2*f**2*r*s - 264*D1**2*bd2*f**2*r - 528*D1**2*bd2*f*fd*r**2 - 528*D1**2*bd2*f*fd*r*s + 528*D1**2*bd2*f*fd*r + 132*D1**2*bd2*f*fd*s - 132*D1**2*bd2*f*fd + 670*D1**2*bdd1*f**3*r**2 + 2980*D1**2*bdd1*f**3*r*s - 1590*D1**2*bdd1*f**3*r + 2310*D1**2*bdd1*f**3*s**2 - 2310*D1**2*bdd1*f**3*s + 1155*D1**2*bdd1*f**3 + 396*D1**2*bdd1*f**2*r**2 + 1716*D1**2*bdd1*f**2*r*s - 1716*D1**2*bdd1*f**2*r + 1320*D1**2*bdd1*f**2*s**2 - 2640*D1**2*bdd1*f**2*s + 1320*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r**2 - 264*D1**2*bdd1*f*g2*r*s - 132*D1**2*bdd2*f**2*r**2 - 132*D1**2*bdd2*f**2*r*s + 132*D1**2*bdd2*f**2*r + 1980*D1**2*f**2*fd*r**2 + 1980*D1**2*f**2*fd*r*s - 1980*D1**2*f**2*fd*r - 660*D1**2*f**2*fd*s + 660*D1**2*f**2*fd - 528*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s + 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gdd2*r**2 + 264*D1**2*f**2*gdd2*r*s - 264*D1**2*f**2*gdd2*r - 1056*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 1056*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 + 1056*D1**2*f*fd*gd2*r**2 + 1056*D1**2*f*fd*gd2*r*s - 1056*D1**2*f*fd*gd2*r - 264*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 528*D1**2*f*fdd*g2*r**2 + 528*D1**2*f*fdd*g2*r*s - 528*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s + 264*D1**2*f*fdd*g2 + 528*D1**2*fd**2*g2*r**2 + 528*D1**2*fd**2*g2*r*s - 528*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s + 1056*D1*Dd*b2*f**2*r**2 + 1056*D1*Dd*b2*f**2*r*s - 1056*D1*Dd*b2*f**2*r - 264*D1*Dd*b2*f**2*s + 264*D1*Dd*b2*f**2 - 2112*D1*Dd*b2*f*fd*r**2 - 2112*D1*Dd*b2*f*fd*r*s + 2112*D1*Dd*b2*f*fd*r + 792*D1*Dd*b2*f*fd*s - 528*D1*Dd*b2*f*fd - 1056*D1*Dd*bd2*f**2*r**2 - 1056*D1*Dd*bd2*f**2*r*s + 1056*D1*Dd*bd2*f**2*r + 132*D1*Dd*bd2*f**2*s - 132*D1*Dd*bd2*f**2 + 2640*D1*Dd*f**3*r**2 + 2640*D1*Dd*f**3*r*s - 2640*D1*Dd*f**3*r - 660*D1*Dd*f**3*s + 660*D1*Dd*f**3 - 2112*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s + 2112*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s - 528*D1*Dd*f**2*g2 + 2112*D1*Dd*f**2*gd2*r**2 + 2112*D1*Dd*f**2*gd2*r*s - 2112*D1*Dd*f**2*gd2*r - 264*D1*Dd*f**2*gd2*s + 264*D1*Dd*f**2*gd2 + 4224*D1*Dd*f*fd*g2*r**2 + 4224*D1*Dd*f*fd*g2*r*s - 4224*D1*Dd*f*fd*g2*r - 1584*D1*Dd*f*fd*g2*s + 1056*D1*Dd*f*fd*g2 - 528*D1*Ddd*b2*f**2*r**2 - 528*D1*Ddd*b2*f**2*r*s + 528*D1*Ddd*b2*f**2*r + 132*D1*Ddd*b2*f**2*s - 132*D1*Ddd*b2*f**2 + 1056*D1*Ddd*f**2*g2*r**2 + 1056*D1*Ddd*f**2*g2*r*s - 1056*D1*Ddd*f**2*g2*r - 264*D1*Ddd*f**2*g2*s + 264*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(202*r**2 + r*(532*s - 306) + 330*s**2 - 330*s + 165) + 2*f**2*(10*fd*(201*r**2 + r*(894*s - 524) + 693*s**2 - 842*s + 195) + 33*r**2*(24*C + 4*K - 36) + 66*r*(12*C*s + 2*K*(s - 1) - 26*s + 5) - 528*s**2 + 462*s - 33) - 132*f*(fd*(K*(4*r**2 + 4*r*(s - 1) - s + 1) - 12*r**2 - 52*r*s + 32*r - 40*s**2 + 53*s - 13) - 2*r*(9*g2*(r + s) + gd2*(-2*r - 2*s + 1))) - 264*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + 2*Dd*f*(5*f**2*(536*r**2 + 2*r*(1192*s - 683) + 1848*s**2 - 2146*s + 621) - 66*f*(K*(8*r**2 + 8*r*(s - 1) - s + 1) - 24*r**2 - 104*r*s + 84*r - 80*s**2 + 133*s - 53) - 132*g2*(8*r**2 + r*(8*s - 4) - s))) - 1584*Dd**2*b2*f**2*r**2 - 1584*Dd**2*b2*f**2*r*s + 1584*Dd**2*b2*f**2*r + 396*Dd**2*b2*f**2*s - 264*Dd**2*b2*f**2 + 3168*Dd**2*f**2*g2*r**2 + 3168*Dd**2*f**2*g2*r*s - 3168*Dd**2*f**2*g2*r - 792*Dd**2*f**2*g2*s + 528*Dd**2*f**2*g2 + 33*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) - Ddd*(6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(56*C*D1**2*fd*r**2 + 56*C*D1**2*fd*r*s - 56*C*D1**2*fd*r + 224*C*D1*Dd*f*r**2 + 224*C*D1*Dd*f*r*s - 224*C*D1*Dd*f*r - 56*C*D1*Dd*f*s + 56*C*D1*Dd*f - 36*D1**2*K*fd*r**2 - 36*D1**2*K*fd*r*s + 72*D1**2*K*fd*r + 36*D1**2*K*fd*s - 36*D1**2*K*fd + 4*D1**2*K*fdd*r**2 + 4*D1**2*K*fdd*r*s - 8*D1**2*K*fdd*r - 4*D1**2*K*fdd*s + 4*D1**2*K*fdd - D1**2*bdd1*(6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 28*D1**2*f*fd*r**2 - 72*D1**2*f*fd*r*s + 28*D1**2*f*fd*r - 100*D1**2*f*fd*s**2 + 132*D1**2*f*fd*s - 62*D1**2*f*fd - 2*D1**2*f*fdd*r**2 + 156*D1**2*f*fdd*r*s - 104*D1**2*f*fdd*r + 158*D1**2*f*fdd*s**2 - 228*D1**2*f*fdd*s + 112*D1**2*f*fdd - 2*D1**2*fd**2*r**2 + 156*D1**2*fd**2*r*s - 104*D1**2*fd**2*r + 158*D1**2*fd**2*s**2 - 228*D1**2*fd**2*s + 70*D1**2*fd**2 - 34*D1**2*fd*r**2 - 60*D1**2*fd*r*s - 26*D1**2*fd*r - 26*D1**2*fd*s**2 - 46*D1**2*fd*s + 41*D1**2*fd - 11*D1**2*fdd*r**2 + 30*D1**2*fdd*r*s + 20*D1**2*fdd*r + 41*D1**2*fdd*s**2 + 16*D1**2*fdd*s - 10*D1**2*fdd - 144*D1*Dd*K*f*r**2 - 144*D1*Dd*K*f*r*s + 144*D1*Dd*K*f*r + 36*D1*Dd*K*f*s - 36*D1*Dd*K*f + 32*D1*Dd*K*fd*r**2 + 32*D1*Dd*K*fd*r*s - 48*D1*Dd*K*fd*r - 20*D1*Dd*K*fd*s + 16*D1*Dd*K*fd + 56*D1*Dd*f**2*r**2 - 144*D1*Dd*f**2*r*s + 44*D1*Dd*f**2*r - 200*D1*Dd*f**2*s**2 + 236*D1*Dd*f**2*s - 86*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 + 1248*D1*Dd*f*fd*r*s - 724*D1*Dd*f*fd*r + 1264*D1*Dd*f*fd*s**2 - 1700*D1*Dd*f*fd*s + 560*D1*Dd*f*fd - 136*D1*Dd*f*r**2 - 240*D1*Dd*f*r*s + 188*D1*Dd*f*r - 104*D1*Dd*f*s**2 + 164*D1*Dd*f*s - 86*D1*Dd*f - 88*D1*Dd*fd*r**2 + 240*D1*Dd*fd*r*s + 42*D1*Dd*fd*r + 328*D1*Dd*fd*s**2 - 130*D1*Dd*fd*s - 52*D1*Dd*fd + 16*D1*Ddd*K*f*r**2 + 16*D1*Ddd*K*f*r*s - 16*D1*Ddd*K*f*r - 4*D1*Ddd*K*f*s + 4*D1*Ddd*K*f - 4*D1*Ddd*f**2*r**2 + 312*D1*Ddd*f**2*r*s - 154*D1*Ddd*f**2*r + 316*D1*Ddd*f**2*s**2 - 394*D1*Ddd*f**2*s + 157*D1*Ddd*f**2 - 44*D1*Ddd*f*r**2 + 120*D1*Ddd*f*r*s - 38*D1*Ddd*f*r + 164*D1*Ddd*f*s**2 - 194*D1*Ddd*f*s + 71*D1*Ddd*f + 2*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 21*r**2 + 42*r*s - 28*r + 21*s**2 - 28*s + 14) - Dd*(6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 48*Dd**2*K*f*r**2 + 48*Dd**2*K*f*r*s - 48*Dd**2*K*f*r - 12*Dd**2*K*f*s + 8*Dd**2*K*f - 12*Dd**2*f**2*r**2 + 936*Dd**2*f**2*r*s - 462*Dd**2*f**2*r + 948*Dd**2*f**2*s**2 - 1182*Dd**2*f**2*s + 314*Dd**2*f**2 - 132*Dd**2*f*r**2 + 360*Dd**2*f*r*s - 114*Dd**2*f*r + 492*Dd**2*f*s**2 - 582*Dd**2*f*s + 142*Dd**2*f) + b1*(3168*C*D1**2*f*fd*r**2 + 3168*C*D1**2*f*fd*r*s - 4752*C*D1**2*f*fd*r - 1584*C*D1**2*f*fd*s + 1584*C*D1**2*f*fd + 6336*C*D1*Dd*f**2*r**2 + 6336*C*D1*Dd*f**2*r*s - 6336*C*D1*Dd*f**2*r - 1584*C*D1*Dd*f**2*s + 1584*C*D1*Dd*f**2 + 528*D1**2*K*f*fd*r**2 + 528*D1**2*K*f*fd*r*s - 528*D1**2*K*f*fd*r - 264*D1**2*K*f*fd*s + 264*D1**2*K*f*fd - 264*D1**2*K*f*fdd*r**2 - 264*D1**2*K*f*fdd*r*s + 264*D1**2*K*f*fdd*r + 132*D1**2*K*f*fdd*s - 132*D1**2*K*f*fdd - 264*D1**2*K*fd**2*r**2 - 264*D1**2*K*fd**2*r*s + 264*D1**2*K*fd**2*r + 132*D1**2*K*fd**2*s - 66*D1**2*bd1**2*(6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 33*D1**2*bdd1*f*(f*(2*r**2 + r*(50 - 156*s) - 158*s**2 + 166*s - 45) + r**2*(22 - 8*K) + 4*r*(-2*K*s + K - 15*s + 7) - 82*s**2 + 128*s - 40) - 3030*D1**2*f**2*fd*r**2 - 7980*D1**2*f**2*fd*r*s + 5810*D1**2*f**2*fd*r - 4950*D1**2*f**2*fd*s**2 + 7610*D1**2*f**2*fd*s - 3485*D1**2*f**2*fd + 2010*D1**2*f**2*fdd*r**2 + 8940*D1**2*f**2*fdd*r*s - 5710*D1**2*f**2*fdd*r + 6930*D1**2*f**2*fdd*s**2 - 9910*D1**2*f**2*fdd*s + 4135*D1**2*f**2*fdd + 4020*D1**2*f*fd**2*r**2 + 17880*D1**2*f*fd**2*r*s - 11420*D1**2*f*fd**2*r + 13860*D1**2*f*fd**2*s**2 - 19820*D1**2*f*fd**2*s + 6680*D1**2*f*fd**2 - 4752*D1**2*f*fd*r**2 - 6864*D1**2*f*fd*r*s + 7524*D1**2*f*fd*r - 2112*D1**2*f*fd*s**2 + 4620*D1**2*f*fd*s - 3366*D1**2*f*fd + 792*D1**2*f*fdd*r**2 + 3432*D1**2*f*fdd*r*s - 792*D1**2*f*fdd*r + 2640*D1**2*f*fdd*s**2 - 1716*D1**2*f*fdd*s + 396*D1**2*f*fdd + 2376*D1**2*f*gd2*r**2 + 2376*D1**2*f*gd2*r*s - 2376*D1**2*f*gd2*r - 264*D1**2*f*gdd2*r**2 - 264*D1**2*f*gdd2*r*s + 264*D1**2*f*gdd2*r + 792*D1**2*fd**2*r**2 + 3432*D1**2*fd**2*r*s - 792*D1**2*fd**2*r + 2640*D1**2*fd**2*s**2 - 1716*D1**2*fd**2*s + 2376*D1**2*fd*g2*r**2 + 2376*D1**2*fd*g2*r*s - 4752*D1**2*fd*g2*r - 2376*D1**2*fd*g2*s + 2376*D1**2*fd*g2 - 528*D1**2*fd*gd2*r**2 - 528*D1**2*fd*gd2*r*s + 792*D1**2*fd*gd2*r + 264*D1**2*fd*gd2*s - 264*D1**2*fd*gd2 - 264*D1**2*fdd*g2*r**2 - 264*D1**2*fdd*g2*r*s + 528*D1**2*fdd*g2*r + 264*D1**2*fdd*g2*s - 264*D1**2*fdd*g2 + 1056*D1*Dd*K*f**2*r**2 + 1056*D1*Dd*K*f**2*r*s - 1056*D1*Dd*K*f**2*r - 264*D1*Dd*K*f**2*s + 264*D1*Dd*K*f**2 - 2112*D1*Dd*K*f*fd*r**2 - 2112*D1*Dd*K*f*fd*r*s + 2112*D1*Dd*K*f*fd*r + 792*D1*Dd*K*f*fd*s - 528*D1*Dd*K*f*fd - 4040*D1*Dd*f**3*r**2 - 10640*D1*Dd*f**3*r*s + 7340*D1*Dd*f**3*r - 6600*D1*Dd*f**3*s**2 + 9260*D1*Dd*f**3*s - 4310*D1*Dd*f**3 + 16080*D1*Dd*f**2*fd*r**2 + 71520*D1*Dd*f**2*fd*r*s - 44740*D1*Dd*f**2*fd*r + 55440*D1*Dd*f**2*fd*s**2 - 76300*D1*Dd*f**2*fd*s + 25530*D1*Dd*f**2*fd - 9504*D1*Dd*f**2*r**2 - 13728*D1*Dd*f**2*r*s + 11616*D1*Dd*f**2*r - 4224*D1*Dd*f**2*s**2 + 7656*D1*Dd*f**2*s - 4488*D1*Dd*f**2 + 6336*D1*Dd*f*fd*r**2 + 27456*D1*Dd*f*fd*r*s - 11616*D1*Dd*f*fd*r + 21120*D1*Dd*f*fd*s**2 - 20856*D1*Dd*f*fd*s + 4224*D1*Dd*f*fd + 9504*D1*Dd*f*g2*r**2 + 9504*D1*Dd*f*g2*r*s - 9504*D1*Dd*f*g2*r - 2376*D1*Dd*f*g2*s + 2376*D1*Dd*f*g2 - 2112*D1*Dd*f*gd2*r**2 - 2112*D1*Dd*f*gd2*r*s + 2112*D1*Dd*f*gd2*r + 264*D1*Dd*f*gd2*s - 264*D1*Dd*f*gd2 - 2112*D1*Dd*fd*g2*r**2 - 2112*D1*Dd*fd*g2*r*s + 3168*D1*Dd*fd*g2*r + 1320*D1*Dd*fd*g2*s - 1056*D1*Dd*fd*g2 - 528*D1*Ddd*K*f**2*r**2 - 528*D1*Ddd*K*f**2*r*s + 528*D1*Ddd*K*f**2*r + 132*D1*Ddd*K*f**2*s - 132*D1*Ddd*K*f**2 + 2680*D1*Ddd*f**3*r**2 + 11920*D1*Ddd*f**3*r*s - 7300*D1*Ddd*f**3*r + 9240*D1*Ddd*f**3*s**2 - 12220*D1*Ddd*f**3*s + 5290*D1*Ddd*f**3 + 1584*D1*Ddd*f**2*r**2 + 6864*D1*Ddd*f**2*r*s - 4224*D1*Ddd*f**2*r + 5280*D1*Ddd*f**2*s**2 - 6996*D1*Ddd*f**2*s + 3036*D1*Ddd*f**2 - 1056*D1*Ddd*f*g2*r**2 - 1056*D1*Ddd*f*g2*r*s + 1056*D1*Ddd*f*g2*r + 264*D1*Ddd*f*g2*s - 264*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(4*f**2*(7*r**2 + r*(4 - 18*s) - 25*s**2 + 26*s - 6) + f*(56*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 72*K*r**2 - 72*K*r*s + 36*K*r - 4*fd*(2*r**2 - 156*r*s + 77*r - 158*s**2 + 197*s - 49) - 68*r**2 - 120*r*s + 154*r - 52*s**2 + 158*s - 101) + 4*fd*(K*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 11*r**2 + r*(30*s + 3) + 41*s**2 - 24*s - 4)) - 2*Dd*f*(-2*K*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + f*(8*r**2 + r*(254 - 624*s) - 632*s**2 + 726*s - 191) + 88*r**2 - 240*r*s + 94*r - 328*s**2 + 450*s - 142)) - 1584*Dd**2*K*f**2*r**2 - 1584*Dd**2*K*f**2*r*s + 1584*Dd**2*K*f**2*r + 396*Dd**2*K*f**2*s - 264*Dd**2*K*f**2 + 8040*Dd**2*f**3*r**2 + 35760*Dd**2*f**3*r*s - 21900*Dd**2*f**3*r + 27720*Dd**2*f**3*s**2 - 36660*Dd**2*f**3*s + 10580*Dd**2*f**3 + 4752*Dd**2*f**2*r**2 + 20592*Dd**2*f**2*r*s - 12672*Dd**2*f**2*r + 15840*Dd**2*f**2*s**2 - 20988*Dd**2*f**2*s + 6072*Dd**2*f**2 - 3168*Dd**2*f*g2*r**2 - 3168*Dd**2*f*g2*r*s + 3168*Dd**2*f*g2*r + 792*Dd**2*f*g2*s - 528*Dd**2*f*g2))/(693*d**2*k1*k3**3) + 4*D1**2*Pk1*Pkd3*ct**3*k2*st**2*(D1*f*(D1*bd1**2*s*(-2*r - 2*s + 1) - D1*bdd1*f*s*(r + s) + bd1*(2*D1*f*s*(r + s) + D1*fd*(-4*r*s + r + s*(3 - 4*s)) + Dd*f*r*(2 - 8*s) + Dd*f*s*(5 - 8*s))) + b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(bdd1*s*(-2*r - 2*s + 1) + 2*fd*(2*s - 1)*(r + s - 1) - fdd*(2*s - 1)*(r + s - 1)) - fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(2*D1*f*s*(2*r + 2*s - 1) - D1*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(7*d**2*k1*k3) + D1**2*Pk1*Pkd3*ct**3*k2*(2*D1*f*(D1*bd1**2*(-5*r**2 + r*(42*s + 5) + s*(47*s - 21)) - 2*D1*bdd1*f*(r + s)*(r*(2*C - 1) - 10*s) + bd1*(D1*(f*(r + s)*(r*(8*C - 1) - 25*s) - 2*fd*(r**2*(8*C - 4) + r*(8*C*s - 6*C - 44*s + 13) + s*(-2*C - 40*s + 31))) - 2*Dd*f*(r**2*(16*C - 8) + 8*r*(2*C*s - C - 11*s + 3) + s*(-2*C - 80*s + 51)))) + b1**2*(D1**2*(r + s - 1)*(fd*(17*r - 59*s + 59) - 5*fdd*r + 47*fdd*(s - 1)) + D1*(Dd*(f*(68*r**2 - 168*r*s + 50*r - 236*s**2 + 278*s - 101) + 2*fd*(-20*r**2 + 168*r*s - 121*r + 188*s**2 - 303*s + 115)) + Ddd*f*(-20*r**2 + 2*r*(84*s - 37) + 188*s**2 - 230*s + 89)) + 2*Dd**2*f*(-30*r**2 + 3*r*(84*s - 37) + 282*s**2 - 345*s + 89)) + b1*(D1**2*bdd1*f*(-10*r**2 + 2*r*(42*s + 5) + 94*s**2 - 42*s - 5) + 4*D1**2*(f*(fd*(8*C*r - 4*C - r - 25*s + 13) + fdd*(-4*C*r + 2*C + 2*r + 20*s - 11)) + fd**2*(C*(2 - 4*r) + 2*r + 20*s - 11))*(r + s - 1) + D1*bd1*(D1*(f*(34*r**2 - 84*r*s - 34*r - 118*s**2 + 42*s + 17) + 2*fd*(-10*r**2 + 84*r*s - 37*r + 94*s**2 - 115*s + 21)) + 2*Dd*f*(-40*r**2 + 6*r*(56*s - 9) + 376*s**2 - 314*s + 37)) + 2*D1*f*(Dd*(f*(8*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 4*r**2 + r*(54 - 104*s) - 100*s**2 + 126*s - 51) + 2*fd*(-2*C*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 16*r**2 + 4*r*(44*s - 25) + 160*s**2 - 226*s + 75)) + 2*Ddd*f*(C*(-8*r**2 - 8*r*s + 8*r + 2*s - 2) + 4*r**2 + 4*r*(11*s - 6) + 40*s**2 - 51*s + 21)) + 4*Dd**2*f**2*(C*(-24*r**2 - 24*r*(s - 1) + 6*s - 4) + 12*r**2 + 12*r*(11*s - 6) + 120*s**2 - 153*s + 42)))/(21*d**2*k1*k3) + 3*D1**2*Pk1*Pkd3*ct**2*f*k1**2*k2**4*st**4*(66*D1**2*bd1*f*(5*C - 4)*(r + s - 1)**2 + 66*D1*b1*(5*C - 4)*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + (122*C - 87)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**7) + 4*D1**2*Pk1*Pkd3*ct**2*f*k1**2*k2**2*st**4*(D1**2*(f*(11*bd1*s*(4*C - 3)*(r + s - 1) + fd*(64*C - 44)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(32*C - 22)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(22 - 32*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*b1*(4*C - 3)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + D1*f*(32*C - 22)*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(22 - 32*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4))/(77*d**2*k3**5) + 10*D1**2*Pk1*Pkd3*ct**2*f*k2**6*st**4*(468*D1**2*b1*f*fd*r**2 + 468*D1**2*b1*f*fd*r*s - 312*D1**2*b1*f*fd*r - 234*D1**2*b1*f*fdd*r**2 - 234*D1**2*b1*f*fdd*r*s + 156*D1**2*b1*f*fdd*r - 468*D1**2*b1*fd**2*r**2 - 468*D1**2*b1*fd**2*r*s + 312*D1**2*b1*fd**2*r - 78*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 284*D1**2*f**2*fd*r**2 + 284*D1**2*f**2*fd*r*s - 284*D1**2*f**2*fd*r - 71*D1**2*f**2*fd*s + 71*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s - 3*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 36*D1**2*f*fd**2*r + 9*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 + 624*D1*Dd*b1*f**2*r**2 + 624*D1*Dd*b1*f**2*r*s - 624*D1*Dd*b1*f**2*r - 156*D1*Dd*b1*f**2*s + 156*D1*Dd*b1*f**2 - 1872*D1*Dd*b1*f*fd*r**2 - 1872*D1*Dd*b1*f*fd*r*s + 1560*D1*Dd*b1*f*fd*r + 234*D1*Dd*b1*f*fd*s - 156*D1*Dd*b1*f*fd + 284*D1*Dd*f**3*r**2 + 284*D1*Dd*f**3*r*s - 284*D1*Dd*f**3*r - 71*D1*Dd*f**3*s + 71*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 96*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s - 18*D1*Dd*f**2*fd - 312*D1*Ddd*b1*f**2*r**2 - 312*D1*Ddd*b1*f**2*r*s + 312*D1*Ddd*b1*f**2*r + 78*D1*Ddd*b1*f**2*s - 78*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 12*D1*Ddd*f**3*r*s + 12*D1*Ddd*f**3*r + 3*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 78*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 936*Dd**2*b1*f**2*r**2 - 936*Dd**2*b1*f**2*r*s + 936*Dd**2*b1*f**2*r + 234*Dd**2*b1*f**2*s - 156*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 36*Dd**2*f**3*r*s + 36*Dd**2*f**3*r + 9*Dd**2*f**3*s - 6*Dd**2*f**3)/(3003*d**2*k1**2*k3**5) + 2*D1**2*Pk1*Pkd3*ct**2*f*k2**4*st**4*(66*D1**2*bd1*f*(r - 1)*(r + s - 1) + 5*D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + 66*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + 5*Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2))/(231*d**2*k1**2*k3**3) + D1**2*Pk1*Pkd3*ct**2*k1**6*(2*C - 1)*(264*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r + 264*D1**2*b1*f*fd*s**2 - 264*D1**2*b1*f*fd*s + 132*D1**2*b1*f*fd - 330*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 330*D1**2*b1*f*fdd*s**2 + 330*D1**2*b1*f*fdd*s - 165*D1**2*b1*f*fdd - 330*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r - 330*D1**2*b1*fd**2*s**2 + 330*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)**2 + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 792*D1*Dd*b1*f**2*r + 528*D1*Dd*b1*f**2*s**2 - 792*D1*Dd*b1*f**2*s + 396*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 3300*D1*Dd*b1*f*fd*r - 2640*D1*Dd*b1*f*fd*s**2 + 3300*D1*Dd*b1*f*fd*s - 990*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 690*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 690*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 990*D1*Ddd*b1*f**2*r - 660*D1*Ddd*b1*f**2*s**2 + 990*D1*Ddd*b1*f**2*s - 495*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 1980*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 2970*Dd**2*b1*f**2*r - 1980*Dd**2*b1*f**2*s**2 + 2970*Dd**2*b1*f**2*s - 990*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3)/(77*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**2*k1**4*k2**2*st**2*(5742*C*D1**2*b1*f*fd*r**2 + 11484*C*D1**2*b1*f*fd*r*s - 5742*C*D1**2*b1*f*fd*r + 5742*C*D1**2*b1*f*fd*s**2 - 5742*C*D1**2*b1*f*fd*s + 2871*C*D1**2*b1*f*fd - 4026*C*D1**2*b1*f*fdd*r**2 - 8052*C*D1**2*b1*f*fdd*r*s + 4026*C*D1**2*b1*f*fdd*r - 4026*C*D1**2*b1*f*fdd*s**2 + 4026*C*D1**2*b1*f*fdd*s - 2013*C*D1**2*b1*f*fdd - 4026*C*D1**2*b1*fd**2*r**2 - 8052*C*D1**2*b1*fd**2*r*s + 4026*C*D1**2*b1*fd**2*r - 4026*C*D1**2*b1*fd**2*s**2 + 4026*C*D1**2*b1*fd**2*s + 5685*C*D1**2*f**2*fd*r**2 + 11370*C*D1**2*f**2*fd*r*s - 7580*C*D1**2*f**2*fd*r + 5685*C*D1**2*f**2*fd*s**2 - 7580*C*D1**2*f**2*fd*s + 3790*C*D1**2*f**2*fd - 4575*C*D1**2*f**2*fdd*r**2 - 9150*C*D1**2*f**2*fdd*r*s + 6100*C*D1**2*f**2*fdd*r - 4575*C*D1**2*f**2*fdd*s**2 + 6100*C*D1**2*f**2*fdd*s - 3050*C*D1**2*f**2*fdd - 9150*C*D1**2*f*fd**2*r**2 - 18300*C*D1**2*f*fd**2*r*s + 12200*C*D1**2*f*fd**2*r - 9150*C*D1**2*f*fd**2*s**2 + 12200*C*D1**2*f*fd**2*s - 3050*C*D1**2*f*fd**2 + 11484*C*D1*Dd*b1*f**2*r**2 + 22968*C*D1*Dd*b1*f**2*r*s - 17226*C*D1*Dd*b1*f**2*r + 11484*C*D1*Dd*b1*f**2*s**2 - 17226*C*D1*Dd*b1*f**2*s + 8613*C*D1*Dd*b1*f**2 - 32208*C*D1*Dd*b1*f*fd*r**2 - 64416*C*D1*Dd*b1*f*fd*r*s + 40260*C*D1*Dd*b1*f*fd*r - 32208*C*D1*Dd*b1*f*fd*s**2 + 40260*C*D1*Dd*b1*f*fd*s - 12078*C*D1*Dd*b1*f*fd + 7580*C*D1*Dd*f**3*r**2 + 15160*C*D1*Dd*f**3*r*s - 11370*C*D1*Dd*f**3*r + 7580*C*D1*Dd*f**3*s**2 - 11370*C*D1*Dd*f**3*s + 5685*C*D1*Dd*f**3 - 36600*C*D1*Dd*f**2*fd*r**2 - 73200*C*D1*Dd*f**2*fd*r*s + 51850*C*D1*Dd*f**2*fd*r - 36600*C*D1*Dd*f**2*fd*s**2 + 51850*C*D1*Dd*f**2*fd*s - 18300*C*D1*Dd*f**2*fd - 8052*C*D1*Ddd*b1*f**2*r**2 - 16104*C*D1*Ddd*b1*f**2*r*s + 12078*C*D1*Ddd*b1*f**2*r - 8052*C*D1*Ddd*b1*f**2*s**2 + 12078*C*D1*Ddd*b1*f**2*s - 6039*C*D1*Ddd*b1*f**2 - 6100*C*D1*Ddd*f**3*r**2 - 12200*C*D1*Ddd*f**3*r*s + 9150*C*D1*Ddd*f**3*r - 6100*C*D1*Ddd*f**3*s**2 + 9150*C*D1*Ddd*f**3*s - 4575*C*D1*Ddd*f**3 - 24156*C*Dd**2*b1*f**2*r**2 - 48312*C*Dd**2*b1*f**2*r*s + 36234*C*Dd**2*b1*f**2*r - 24156*C*Dd**2*b1*f**2*s**2 + 36234*C*Dd**2*b1*f**2*s - 12078*C*Dd**2*b1*f**2 - 18300*C*Dd**2*f**3*r**2 - 36600*C*Dd**2*f**3*r*s + 27450*C*Dd**2*f**3*r - 18300*C*Dd**2*f**3*s**2 + 27450*C*Dd**2*f**3*s - 9150*C*Dd**2*f**3 - 3432*D1**2*b1*f*fd*r**2 - 6864*D1**2*b1*f*fd*r*s + 3432*D1**2*b1*f*fd*r - 3432*D1**2*b1*f*fd*s**2 + 3432*D1**2*b1*f*fd*s - 1716*D1**2*b1*f*fd + 2442*D1**2*b1*f*fdd*r**2 + 4884*D1**2*b1*f*fdd*r*s - 2442*D1**2*b1*f*fdd*r + 2442*D1**2*b1*f*fdd*s**2 - 2442*D1**2*b1*f*fdd*s + 1221*D1**2*b1*f*fdd + 2442*D1**2*b1*fd**2*r**2 + 4884*D1**2*b1*fd**2*r*s - 2442*D1**2*b1*fd**2*r + 2442*D1**2*b1*fd**2*s**2 - 2442*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(61*C - 37)*(r + s - 1)**2 - 3372*D1**2*f**2*fd*r**2 - 6744*D1**2*f**2*fd*r*s + 4496*D1**2*f**2*fd*r - 3372*D1**2*f**2*fd*s**2 + 4496*D1**2*f**2*fd*s - 2248*D1**2*f**2*fd + 2775*D1**2*f**2*fdd*r**2 + 5550*D1**2*f**2*fdd*r*s - 3700*D1**2*f**2*fdd*r + 2775*D1**2*f**2*fdd*s**2 - 3700*D1**2*f**2*fdd*s + 1850*D1**2*f**2*fdd + 5550*D1**2*f*fd**2*r**2 + 11100*D1**2*f*fd**2*r*s - 7400*D1**2*f*fd**2*r + 5550*D1**2*f*fd**2*s**2 - 7400*D1**2*f*fd**2*s + 1850*D1**2*f*fd**2 - 6864*D1*Dd*b1*f**2*r**2 - 13728*D1*Dd*b1*f**2*r*s + 10296*D1*Dd*b1*f**2*r - 6864*D1*Dd*b1*f**2*s**2 + 10296*D1*Dd*b1*f**2*s - 5148*D1*Dd*b1*f**2 + 19536*D1*Dd*b1*f*fd*r**2 + 39072*D1*Dd*b1*f*fd*r*s - 24420*D1*Dd*b1*f*fd*r + 19536*D1*Dd*b1*f*fd*s**2 - 24420*D1*Dd*b1*f*fd*s + 7326*D1*Dd*b1*f*fd - 4496*D1*Dd*f**3*r**2 - 8992*D1*Dd*f**3*r*s + 6744*D1*Dd*f**3*r - 4496*D1*Dd*f**3*s**2 + 6744*D1*Dd*f**3*s - 3372*D1*Dd*f**3 + 22200*D1*Dd*f**2*fd*r**2 + 44400*D1*Dd*f**2*fd*r*s - 31450*D1*Dd*f**2*fd*r + 22200*D1*Dd*f**2*fd*s**2 - 31450*D1*Dd*f**2*fd*s + 11100*D1*Dd*f**2*fd + 4884*D1*Ddd*b1*f**2*r**2 + 9768*D1*Ddd*b1*f**2*r*s - 7326*D1*Ddd*b1*f**2*r + 4884*D1*Ddd*b1*f**2*s**2 - 7326*D1*Ddd*b1*f**2*s + 3663*D1*Ddd*b1*f**2 + 3700*D1*Ddd*f**3*r**2 + 7400*D1*Ddd*f**3*r*s - 5550*D1*Ddd*f**3*r + 3700*D1*Ddd*f**3*s**2 - 5550*D1*Ddd*f**3*s + 2775*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(87*C - 52)*(r + s - 1) - D1*fd*(122*C - 74)*(2*r + 2*s - 1) - Dd*f*(122*C - 74)*(4*r + 4*s - 3)) + 14652*Dd**2*b1*f**2*r**2 + 29304*Dd**2*b1*f**2*r*s - 21978*Dd**2*b1*f**2*r + 14652*Dd**2*b1*f**2*s**2 - 21978*Dd**2*b1*f**2*s + 7326*Dd**2*b1*f**2 + 11100*Dd**2*f**3*r**2 + 22200*Dd**2*f**3*r*s - 16650*Dd**2*f**3*r + 11100*Dd**2*f**3*s**2 - 16650*Dd**2*f**3*s + 5550*Dd**2*f**3)/(77*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**2*k1**4*k2**2*(-12870*C*D1**2*f**2*fd*r**2 - 25740*C*D1**2*f**2*fd*r*s + 17160*C*D1**2*f**2*fd*r - 12870*C*D1**2*f**2*fd*s**2 + 17160*C*D1**2*f**2*fd*s - 8580*C*D1**2*f**2*fd - 17160*C*D1*Dd*f**3*r**2 - 34320*C*D1*Dd*f**3*r*s + 25740*C*D1*Dd*f**3*r - 17160*C*D1*Dd*f**3*s**2 + 25740*C*D1*Dd*f**3*s - 12870*C*D1*Dd*f**3 - 32175*D1**2*K*bdd1*f**2*r**2 - 64350*D1**2*K*bdd1*f**2*r*s + 64350*D1**2*K*bdd1*f**2*r - 32175*D1**2*K*bdd1*f**2*s**2 + 64350*D1**2*K*bdd1*f**2*s - 32175*D1**2*K*bdd1*f**2 + 4290*D1**2*bd1**2*f*(-18*K + 5*f + 6)*(r + s - 1)**2 + 7280*D1**2*bdd1*f**3*r**2 + 14560*D1**2*bdd1*f**3*r*s - 14560*D1**2*bdd1*f**3*r + 7280*D1**2*bdd1*f**3*s**2 - 14560*D1**2*bdd1*f**3*s + 7280*D1**2*bdd1*f**3 + 10725*D1**2*bdd1*f**2*r**2 + 21450*D1**2*bdd1*f**2*r*s - 21450*D1**2*bdd1*f**2*r + 10725*D1**2*bdd1*f**2*s**2 - 21450*D1**2*bdd1*f**2*s + 10725*D1**2*bdd1*f**2 + 77220*D1**2*bdd1*f*g2*r**2 + 154440*D1**2*bdd1*f*g2*r*s - 154440*D1**2*bdd1*f*g2*r + 77220*D1**2*bdd1*f*g2*s**2 - 154440*D1**2*bdd1*f*g2*s + 77220*D1**2*bdd1*f*g2 + 5320*D1**2*f**3*fd*r**2 + 10640*D1**2*f**3*fd*r*s - 7980*D1**2*f**3*fd*r + 5320*D1**2*f**3*fd*s**2 - 7980*D1**2*f**3*fd*s + 3990*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 + 6435*D1**2*f**2*fd*r**2 + 12870*D1**2*f**2*fd*r*s - 8580*D1**2*f**2*fd*r + 6435*D1**2*f**2*fd*s**2 - 8580*D1**2*f**2*fd*s + 4290*D1**2*f**2*fd - 56628*D1**2*f**2*gd2*r**2 - 113256*D1**2*f**2*gd2*r*s + 113256*D1**2*f**2*gd2*r - 56628*D1**2*f**2*gd2*s**2 + 113256*D1**2*f**2*gd2*s - 56628*D1**2*f**2*gd2 + 64350*D1**2*f**2*gdd2*r**2 + 128700*D1**2*f**2*gdd2*r*s - 128700*D1**2*f**2*gdd2*r + 64350*D1**2*f**2*gdd2*s**2 - 128700*D1**2*f**2*gdd2*s + 64350*D1**2*f**2*gdd2 - 113256*D1**2*f*fd*g2*r**2 - 226512*D1**2*f*fd*g2*r*s + 113256*D1**2*f*fd*g2*r - 113256*D1**2*f*fd*g2*s**2 + 113256*D1**2*f*fd*g2*s - 56628*D1**2*f*fd*g2 + 257400*D1**2*f*fd*gd2*r**2 + 514800*D1**2*f*fd*gd2*r*s - 386100*D1**2*f*fd*gd2*r + 257400*D1**2*f*fd*gd2*s**2 - 386100*D1**2*f*fd*gd2*s + 128700*D1**2*f*fd*gd2 + 128700*D1**2*f*fdd*g2*r**2 + 257400*D1**2*f*fdd*g2*r*s - 128700*D1**2*f*fdd*g2*r + 128700*D1**2*f*fdd*g2*s**2 - 128700*D1**2*f*fdd*g2*s + 64350*D1**2*f*fdd*g2 + 128700*D1**2*fd**2*g2*r**2 + 257400*D1**2*fd**2*g2*r*s - 128700*D1**2*fd**2*g2*r + 128700*D1**2*fd**2*g2*s**2 - 128700*D1**2*fd**2*g2*s + 5320*D1*Dd*f**4*r**2 + 10640*D1*Dd*f**4*r*s - 7980*D1*Dd*f**4*r + 5320*D1*Dd*f**4*s**2 - 7980*D1*Dd*f**4*s + 3990*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd + 8580*D1*Dd*f**3*r**2 + 17160*D1*Dd*f**3*r*s - 12870*D1*Dd*f**3*r + 8580*D1*Dd*f**3*s**2 - 12870*D1*Dd*f**3*s + 6435*D1*Dd*f**3 - 226512*D1*Dd*f**2*g2*r**2 - 453024*D1*Dd*f**2*g2*r*s + 339768*D1*Dd*f**2*g2*r - 226512*D1*Dd*f**2*g2*s**2 + 339768*D1*Dd*f**2*g2*s - 169884*D1*Dd*f**2*g2 + 514800*D1*Dd*f**2*gd2*r**2 + 1029600*D1*Dd*f**2*gd2*r*s - 900900*D1*Dd*f**2*gd2*r + 514800*D1*Dd*f**2*gd2*s**2 - 900900*D1*Dd*f**2*gd2*s + 386100*D1*Dd*f**2*gd2 + 1029600*D1*Dd*f*fd*g2*r**2 + 2059200*D1*Dd*f*fd*g2*r*s - 1287000*D1*Dd*f*fd*g2*r + 1029600*D1*Dd*f*fd*g2*s**2 - 1287000*D1*Dd*f*fd*g2*s + 386100*D1*Dd*f*fd*g2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 257400*D1*Ddd*f**2*g2*r**2 + 514800*D1*Ddd*f**2*g2*r*s - 386100*D1*Ddd*f**2*g2*r + 257400*D1*Ddd*f**2*g2*s**2 - 386100*D1*Ddd*f**2*g2*s + 193050*D1*Ddd*f**2*g2 - 26*D1*bd1*(D1*(230*f**3*(r + s - 1) + f**2*(198*C*(r + s - 1) - 560*fd*(3*r + 3*s - 2) - (1089*K - 231)*(r + s - 1)) + 33*f*(25*fd*(3*K - 1)*(2*r + 2*s - 1) + (82*g2 - 180*gd2)*(r + s - 1)) - 5940*fd*g2*(r + s)) - 5*Dd*f*(112*f**2 - 165*f*(3*K - 1) + 1188*g2)*(4*r + 4*s - 3))*(r + s - 1) - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 772200*Dd**2*f**2*g2*r**2 + 1544400*Dd**2*f**2*g2*r*s - 1158300*Dd**2*f**2*g2*r + 772200*Dd**2*f**2*g2*s**2 - 1158300*Dd**2*f**2*g2*s + 386100*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(5*f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + fd*(82*K - 25)*(r + s) - 30*fdd*(3*K - 1)*(r + s))) + D1*(Dd*(20*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(50*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (82*K - 25)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*fd*(3*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 5*Ddd*f*(-18*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f*(-18*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 13*b1*(792*C*D1**2*f*fd*r**2 + 1584*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 792*C*D1**2*f*fd*s**2 - 792*C*D1**2*f*fd*s + 396*C*D1**2*f*fd + 1584*C*D1*Dd*f**2*r**2 + 3168*C*D1*Dd*f**2*r*s - 2376*C*D1*Dd*f**2*r + 1584*C*D1*Dd*f**2*s**2 - 2376*C*D1*Dd*f**2*s + 1188*C*D1*Dd*f**2 - 4356*D1**2*K*f*fd*r**2 - 8712*D1**2*K*f*fd*r*s + 4356*D1**2*K*f*fd*r - 4356*D1**2*K*f*fd*s**2 + 4356*D1**2*K*f*fd*s - 2178*D1**2*K*f*fd + 4950*D1**2*K*f*fdd*r**2 + 9900*D1**2*K*f*fdd*r*s - 4950*D1**2*K*f*fdd*r + 4950*D1**2*K*f*fdd*s**2 - 4950*D1**2*K*f*fdd*s + 2475*D1**2*K*f*fdd + 4950*D1**2*K*fd**2*r**2 + 9900*D1**2*K*fd**2*r*s - 4950*D1**2*K*fd**2*r + 4950*D1**2*K*fd**2*s**2 - 4950*D1**2*K*fd**2*s - 330*D1**2*bdd1*f*(-18*K + 5*f + 6)*(r + s - 1)**2 + 1380*D1**2*f**2*fd*r**2 + 2760*D1**2*f**2*fd*r*s - 1840*D1**2*f**2*fd*r + 1380*D1**2*f**2*fd*s**2 - 1840*D1**2*f**2*fd*s + 920*D1**2*f**2*fd - 1680*D1**2*f**2*fdd*r**2 - 3360*D1**2*f**2*fdd*r*s + 2240*D1**2*f**2*fdd*r - 1680*D1**2*f**2*fdd*s**2 + 2240*D1**2*f**2*fdd*s - 1120*D1**2*f**2*fdd - 3360*D1**2*f*fd**2*r**2 - 6720*D1**2*f*fd**2*r*s + 4480*D1**2*f*fd**2*r - 3360*D1**2*f*fd**2*s**2 + 4480*D1**2*f*fd**2*s - 1120*D1**2*f*fd**2 + 924*D1**2*f*fd*r**2 + 1848*D1**2*f*fd*r*s - 924*D1**2*f*fd*r + 924*D1**2*f*fd*s**2 - 924*D1**2*f*fd*s + 462*D1**2*f*fd - 1650*D1**2*f*fdd*r**2 - 3300*D1**2*f*fdd*r*s + 1650*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1650*D1**2*f*fdd*s - 825*D1**2*f*fdd + 5412*D1**2*f*gd2*r**2 + 10824*D1**2*f*gd2*r*s - 10824*D1**2*f*gd2*r + 5412*D1**2*f*gd2*s**2 - 10824*D1**2*f*gd2*s + 5412*D1**2*f*gd2 - 5940*D1**2*f*gdd2*r**2 - 11880*D1**2*f*gdd2*r*s + 11880*D1**2*f*gdd2*r - 5940*D1**2*f*gdd2*s**2 + 11880*D1**2*f*gdd2*s - 5940*D1**2*f*gdd2 - 1650*D1**2*fd**2*r**2 - 3300*D1**2*fd**2*r*s + 1650*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1650*D1**2*fd**2*s + 5412*D1**2*fd*g2*r**2 + 10824*D1**2*fd*g2*r*s + 5412*D1**2*fd*g2*s**2 - 11880*D1**2*fd*gd2*r**2 - 23760*D1**2*fd*gd2*r*s + 11880*D1**2*fd*gd2*r - 11880*D1**2*fd*gd2*s**2 + 11880*D1**2*fd*gd2*s - 5940*D1**2*fdd*g2*r**2 - 11880*D1**2*fdd*g2*r*s - 5940*D1**2*fdd*g2*s**2 - 8712*D1*Dd*K*f**2*r**2 - 17424*D1*Dd*K*f**2*r*s + 13068*D1*Dd*K*f**2*r - 8712*D1*Dd*K*f**2*s**2 + 13068*D1*Dd*K*f**2*s - 6534*D1*Dd*K*f**2 + 39600*D1*Dd*K*f*fd*r**2 + 79200*D1*Dd*K*f*fd*r*s - 49500*D1*Dd*K*f*fd*r + 39600*D1*Dd*K*f*fd*s**2 - 49500*D1*Dd*K*f*fd*s + 14850*D1*Dd*K*f*fd + 1840*D1*Dd*f**3*r**2 + 3680*D1*Dd*f**3*r*s - 2760*D1*Dd*f**3*r + 1840*D1*Dd*f**3*s**2 - 2760*D1*Dd*f**3*s + 1380*D1*Dd*f**3 - 13440*D1*Dd*f**2*fd*r**2 - 26880*D1*Dd*f**2*fd*r*s + 19040*D1*Dd*f**2*fd*r - 13440*D1*Dd*f**2*fd*s**2 + 19040*D1*Dd*f**2*fd*s - 6720*D1*Dd*f**2*fd + 1848*D1*Dd*f**2*r**2 + 3696*D1*Dd*f**2*r*s - 2772*D1*Dd*f**2*r + 1848*D1*Dd*f**2*s**2 - 2772*D1*Dd*f**2*s + 1386*D1*Dd*f**2 - 13200*D1*Dd*f*fd*r**2 - 26400*D1*Dd*f*fd*r*s + 16500*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 16500*D1*Dd*f*fd*s - 4950*D1*Dd*f*fd + 21648*D1*Dd*f*g2*r**2 + 43296*D1*Dd*f*g2*r*s - 32472*D1*Dd*f*g2*r + 21648*D1*Dd*f*g2*s**2 - 32472*D1*Dd*f*g2*s + 16236*D1*Dd*f*g2 - 47520*D1*Dd*f*gd2*r**2 - 95040*D1*Dd*f*gd2*r*s + 83160*D1*Dd*f*gd2*r - 47520*D1*Dd*f*gd2*s**2 + 83160*D1*Dd*f*gd2*s - 35640*D1*Dd*f*gd2 - 47520*D1*Dd*fd*g2*r**2 - 95040*D1*Dd*fd*g2*r*s + 35640*D1*Dd*fd*g2*r - 47520*D1*Dd*fd*g2*s**2 + 35640*D1*Dd*fd*g2*s + 9900*D1*Ddd*K*f**2*r**2 + 19800*D1*Ddd*K*f**2*r*s - 14850*D1*Ddd*K*f**2*r + 9900*D1*Ddd*K*f**2*s**2 - 14850*D1*Ddd*K*f**2*s + 7425*D1*Ddd*K*f**2 - 2240*D1*Ddd*f**3*r**2 - 4480*D1*Ddd*f**3*r*s + 3360*D1*Ddd*f**3*r - 2240*D1*Ddd*f**3*s**2 + 3360*D1*Ddd*f**3*s - 1680*D1*Ddd*f**3 - 3300*D1*Ddd*f**2*r**2 - 6600*D1*Ddd*f**2*r*s + 4950*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 4950*D1*Ddd*f**2*s - 2475*D1*Ddd*f**2 - 23760*D1*Ddd*f*g2*r**2 - 47520*D1*Ddd*f*g2*r*s + 35640*D1*Ddd*f*g2*r - 23760*D1*Ddd*f*g2*s**2 + 35640*D1*Ddd*f*g2*s - 17820*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(20*f**2*(r + s - 1) - 50*f*fd*(2*r + 2*s - 1) - f*(82*K - 25)*(r + s - 1) + 60*fd*(3*K - 1)*(r + s)) - 10*Dd*f*(-18*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 29700*Dd**2*K*f**2*r**2 + 59400*Dd**2*K*f**2*r*s - 44550*Dd**2*K*f**2*r + 29700*Dd**2*K*f**2*s**2 - 44550*Dd**2*K*f**2*s + 14850*Dd**2*K*f**2 - 6720*Dd**2*f**3*r**2 - 13440*Dd**2*f**3*r*s + 10080*Dd**2*f**3*r - 6720*Dd**2*f**3*s**2 + 10080*Dd**2*f**3*s - 3360*Dd**2*f**3 - 9900*Dd**2*f**2*r**2 - 19800*Dd**2*f**2*r*s + 14850*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 14850*Dd**2*f**2*s - 4950*Dd**2*f**2 - 71280*Dd**2*f*g2*r**2 - 142560*Dd**2*f*g2*r*s + 106920*Dd**2*f*g2*r - 71280*Dd**2*f*g2*s**2 + 106920*Dd**2*f*g2*s - 35640*Dd**2*f*g2))/(1001*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**2*k1**4*st**2*(32*C - 18)*(11*b1*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(2*s - 1)*(8*r + 8*s - 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(39*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 25*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 25*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 25*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**2*k1**4*(165*b1**2*(2*C - 1)*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-136*C*D1**2*f*fd*r**2 - 848*C*D1**2*f*fd*r*s + 344*C*D1**2*f*fd*r - 712*C*D1**2*f*fd*s**2 + 632*C*D1**2*f*fd*s - 316*C*D1**2*f*fd + 200*C*D1**2*f*fdd*r**2 + 880*C*D1**2*f*fdd*r*s - 340*C*D1**2*f*fdd*r + 680*C*D1**2*f*fdd*s**2 - 580*C*D1**2*f*fdd*s + 290*C*D1**2*f*fdd + 200*C*D1**2*fd**2*r**2 + 880*C*D1**2*fd**2*r*s - 340*C*D1**2*fd**2*r + 680*C*D1**2*fd**2*s**2 - 580*C*D1**2*fd**2*s - 100*C*D1**2*fd**2 - 272*C*D1*Dd*f**2*r**2 - 1696*C*D1*Dd*f**2*r*s + 984*C*D1*Dd*f**2*r - 1424*C*D1*Dd*f**2*s**2 + 1848*C*D1*Dd*f**2*s - 780*C*D1*Dd*f**2 + 1600*C*D1*Dd*f*fd*r**2 + 7040*C*D1*Dd*f*fd*r*s - 3520*C*D1*Dd*f*fd*r + 5440*C*D1*Dd*f*fd*s**2 - 5920*C*D1*Dd*f*fd*s + 1500*C*D1*Dd*f*fd + 400*C*D1*Ddd*f**2*r**2 + 1760*C*D1*Ddd*f**2*r*s - 1080*C*D1*Ddd*f**2*r + 1360*C*D1*Ddd*f**2*s**2 - 1800*C*D1*Ddd*f**2*s + 780*C*D1*Ddd*f**2 + 1200*C*Dd**2*f**2*r**2 + 5280*C*Dd**2*f**2*r*s - 3240*C*Dd**2*f**2*r + 4080*C*Dd**2*f**2*s**2 - 5400*C*Dd**2*f**2*s + 1560*C*Dd**2*f**2 - 30*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 68*D1**2*f*fd*r**2 + 488*D1**2*f*fd*r*s - 204*D1**2*f*fd*r + 420*D1**2*f*fd*s**2 - 380*D1**2*f*fd*s + 190*D1**2*f*fd - 100*D1**2*f*fdd*r**2 - 508*D1**2*f*fdd*r*s + 204*D1**2*f*fdd*r - 408*D1**2*f*fdd*s**2 + 358*D1**2*f*fdd*s - 179*D1**2*f*fdd - 100*D1**2*fd**2*r**2 - 508*D1**2*fd**2*r*s + 204*D1**2*fd**2*r - 408*D1**2*fd**2*s**2 + 358*D1**2*fd**2*s + 50*D1**2*fd**2 + 136*D1*Dd*f**2*r**2 + 976*D1*Dd*f**2*r*s - 556*D1*Dd*f**2*r + 840*D1*Dd*f**2*s**2 - 1084*D1*Dd*f**2*s + 454*D1*Dd*f**2 - 800*D1*Dd*f*fd*r**2 - 4064*D1*Dd*f*fd*r*s + 2032*D1*Dd*f*fd*r - 3264*D1*Dd*f*fd*s**2 + 3572*D1*Dd*f*fd*s - 920*D1*Dd*f*fd - 200*D1*Ddd*f**2*r**2 - 1016*D1*Ddd*f**2*r*s + 608*D1*Ddd*f**2*r - 816*D1*Ddd*f**2*s**2 + 1070*D1*Ddd*f**2*s - 458*D1*Ddd*f**2 + 5*D1*bd1*(2*C - 1)*(D1*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 12*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 600*Dd**2*f**2*r**2 - 3048*Dd**2*f**2*r*s + 1824*Dd**2*f**2*r - 2448*Dd**2*f**2*s**2 + 3210*Dd**2*f**2*s - 916*Dd**2*f**2) + f*(-1980*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(10*C*(10*r**2 + 44*r*s - 30*r + 34*s**2 - 54*s + 15) - 50*r**2 - 254*r*s + 150*r - 204*s**2 + 304*s - 75) - 5*D1**2*(-4*C*fd**2*(1311*r**2 + 6*r*(757*s - 398) + 3231*s**2 - 3668*s + 757) + 2*f*fd*(2*C*(519*r**2 + 6*r*(361*s - 178) + 1647*s**2 - 1820*s + 722) - 519*r**2 - 2433*r*s + 1157*r - 1914*s**2 + 2087*s - 811) + f*fdd*(-2*C*(1311*r**2 + 6*r*(757*s - 398) + 3231*s**2 - 3668*s + 1514) + 1311*r**2 + 46*r*(111*s - 56) + 3795*s**2 - 4232*s + 1702) + 46*fd**2*(57*r**2 + 2*r*(111*s - 56) + 165*s**2 - 184*s + 37)) - 66*D1*bd1*(D1*(f*(2*C*(17*r**2 + 106*r*s - 54*r + 89*s**2 - 126*s + 27) - 17*r**2 - 122*r*s + 54*r - 105*s**2 + 142*s - 27) + fd*(-10*C*(20*r**2 + 88*r*s - 47*r + 68*s**2 - 83*s + 27) + 100*r**2 + 508*r*s - 252*r + 408*s**2 - 483*s + 152)) + Dd*f*(-10*C*(40*r**2 + 2*r*(88*s - 57) + 136*s**2 - 198*s + 69) + 200*r**2 + 1016*r*s - 604*r + 816*s**2 - 1143*s + 379)) - 5*D1*f*(2*Dd*(f*(2*C*(692*r**2 + 2888*r*s - 1790*r + 2196*s**2 - 2918*s + 1271) - 692*r**2 - 3244*r*s + 1968*r - 2552*s**2 + 3363*s - 1449) + fd*(-2*C*(5244*r**2 + 3*r*(6056*s - 3543) + 12924*s**2 - 16069*s + 4862) + 5244*r**2 + 23*r*(888*s - 503) + 15180*s**2 - 18607*s + 5520)) + Ddd*f*(-2*C*(1748*r**2 + 6056*r*s - 3902*r + 4308*s**2 - 5822*s + 2591) + 1748*r**2 + 6808*r*s - 4278*r + 5060*s**2 - 6762*s + 2967)) + 10*Dd**2*f**2*(2*C*(2622*r**2 + 9084*r*s - 5853*r + 6462*s**2 - 8733*s + 2591) - 2622*r**2 - 10212*r*s + 6417*r - 7590*s**2 + 10143*s - 2967)))/(693*d**2*k3**5) - 3*D1**2*Pk1*Pkd3*ct**2*k1**2*k2**4*st**2*(-1716*D1**2*bd1**2*f*(-6*K + 10*f + 3)*(r + s - 1)**2 - 2574*D1**2*bdd1*f*(r + s - 1)**2*(-2*K*f + f + 4*g2) + 2*D1**2*(-50*f**3*(59*fd - 49*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(14700*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(2717*C - 1859)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (9581*gd2 - 5148*gdd2)*(r + s - 1)**2) + 143*f*(fd*(67*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 72*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 36*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 10296*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 143*D1*bd1*(D1*(12*f**3*(r + s - 1) + f**2*(38*C - 67*K + 7)*(r + s - 1) + 36*f*fd*(2*K - 1)*(2*r + 2*s - 1) + 2*f*(107*g2 - 72*gd2)*(r + s - 1) - 144*fd*g2*(r + s)) + 36*Dd*f*(f*(2*K - 1) - 4*g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(2950*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(2717*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4900*fd*(4*r + 4*s - 3)**2 - 7436*r**2 - 1859*r*(8*s - 6) - 7436*s**2 + 11154*s - 5577) - 143*f*(67*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 72*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 10296*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2*Ddd*f*(1225*f**2 - 2574*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 24*Dd**2*f**2*(1225*f**2 - 2574*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 143*b1**2*(D1**2*(12*f*(8*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(120*fd**2*(r + s - 1) + fd*(107*K - 57)*(r + s) - 18*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(96*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(120*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (107*K - 57)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 36*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-6*K + 10*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-6*K + 10*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 143*b1*(76*C*D1**2*f*fd*r**2 + 152*C*D1**2*f*fd*r*s - 76*C*D1**2*f*fd*r + 76*C*D1**2*f*fd*s**2 - 76*C*D1**2*f*fd*s + 38*C*D1**2*f*fd + 152*C*D1*Dd*f**2*r**2 + 304*C*D1*Dd*f**2*r*s - 228*C*D1*Dd*f**2*r + 152*C*D1*Dd*f**2*s**2 - 228*C*D1*Dd*f**2*s + 114*C*D1*Dd*f**2 - 134*D1**2*K*f*fd*r**2 - 268*D1**2*K*f*fd*r*s + 134*D1**2*K*f*fd*r - 134*D1**2*K*f*fd*s**2 + 134*D1**2*K*f*fd*s - 67*D1**2*K*f*fd + 72*D1**2*K*f*fdd*r**2 + 144*D1**2*K*f*fdd*r*s - 72*D1**2*K*f*fdd*r + 72*D1**2*K*f*fdd*s**2 - 72*D1**2*K*f*fdd*s + 36*D1**2*K*f*fdd + 72*D1**2*K*fd**2*r**2 + 144*D1**2*K*fd**2*r*s - 72*D1**2*K*fd**2*r + 72*D1**2*K*fd**2*s**2 - 72*D1**2*K*fd**2*s - 12*D1**2*bdd1*f*(-6*K + 10*f + 3)*(r + s - 1)**2 + 36*D1**2*f**2*fd*r**2 + 72*D1**2*f**2*fd*r*s - 48*D1**2*f**2*fd*r + 36*D1**2*f**2*fd*s**2 - 48*D1**2*f**2*fd*s + 24*D1**2*f**2*fd + 14*D1**2*f*fd*r**2 + 28*D1**2*f*fd*r*s - 14*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 - 14*D1**2*f*fd*s + 7*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd + 214*D1**2*f*gd2*r**2 + 428*D1**2*f*gd2*r*s - 428*D1**2*f*gd2*r + 214*D1**2*f*gd2*s**2 - 428*D1**2*f*gd2*s + 214*D1**2*f*gd2 - 72*D1**2*f*gdd2*r**2 - 144*D1**2*f*gdd2*r*s + 144*D1**2*f*gdd2*r - 72*D1**2*f*gdd2*s**2 + 144*D1**2*f*gdd2*s - 72*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 214*D1**2*fd*g2*r**2 + 428*D1**2*fd*g2*r*s + 214*D1**2*fd*g2*s**2 - 144*D1**2*fd*gd2*r**2 - 288*D1**2*fd*gd2*r*s + 144*D1**2*fd*gd2*r - 144*D1**2*fd*gd2*s**2 + 144*D1**2*fd*gd2*s - 72*D1**2*fdd*g2*r**2 - 144*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*s**2 - 268*D1*Dd*K*f**2*r**2 - 536*D1*Dd*K*f**2*r*s + 402*D1*Dd*K*f**2*r - 268*D1*Dd*K*f**2*s**2 + 402*D1*Dd*K*f**2*s - 201*D1*Dd*K*f**2 + 576*D1*Dd*K*f*fd*r**2 + 1152*D1*Dd*K*f*fd*r*s - 720*D1*Dd*K*f*fd*r + 576*D1*Dd*K*f*fd*s**2 - 720*D1*Dd*K*f*fd*s + 216*D1*Dd*K*f*fd + 48*D1*Dd*f**3*r**2 + 96*D1*Dd*f**3*r*s - 72*D1*Dd*f**3*r + 48*D1*Dd*f**3*s**2 - 72*D1*Dd*f**3*s + 36*D1*Dd*f**3 + 28*D1*Dd*f**2*r**2 + 56*D1*Dd*f**2*r*s - 42*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 - 42*D1*Dd*f**2*s + 21*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 856*D1*Dd*f*g2*r**2 + 1712*D1*Dd*f*g2*r*s - 1284*D1*Dd*f*g2*r + 856*D1*Dd*f*g2*s**2 - 1284*D1*Dd*f*g2*s + 642*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r**2 - 1152*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r - 576*D1*Dd*f*gd2*s**2 + 1008*D1*Dd*f*gd2*s - 432*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r**2 - 1152*D1*Dd*fd*g2*r*s + 432*D1*Dd*fd*g2*r - 576*D1*Dd*fd*g2*s**2 + 432*D1*Dd*fd*g2*s + 144*D1*Ddd*K*f**2*r**2 + 288*D1*Ddd*K*f**2*r*s - 216*D1*Ddd*K*f**2*r + 144*D1*Ddd*K*f**2*s**2 - 216*D1*Ddd*K*f**2*s + 108*D1*Ddd*K*f**2 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r**2 - 576*D1*Ddd*f*g2*r*s + 432*D1*Ddd*f*g2*r - 288*D1*Ddd*f*g2*s**2 + 432*D1*Ddd*f*g2*s - 216*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(96*f**2*(r + s - 1) - 120*f*fd*(2*r + 2*s - 1) - f*(107*K - 57)*(r + s - 1) + 36*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-6*K + 10*f + 3)*(4*r + 4*s - 3))*(r + s - 1) + 432*Dd**2*K*f**2*r**2 + 864*Dd**2*K*f**2*r*s - 648*Dd**2*K*f**2*r + 432*Dd**2*K*f**2*s**2 - 648*Dd**2*K*f**2*s + 216*Dd**2*K*f**2 - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 - 864*Dd**2*f*g2*r**2 - 1728*Dd**2*f*g2*r*s + 1296*Dd**2*f*g2*r - 864*Dd**2*f*g2*s**2 + 1296*Dd**2*f*g2*s - 432*Dd**2*f*g2))/(2002*d**2*k3**7) + D1**2*Pk1*Pkd3*ct**2*k1**2*k2**2*st**2*(165*b1**2*(D1**2*(fd*(73*C - 54) + fdd*(13 - 19*C))*(r + s - 1)**2 + D1*(Dd*(f*(73*C - 54)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(26 - 38*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(19*C - 13)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(114*C - 78)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-788*C*D1**2*f*fd*r**2 - 1760*C*D1**2*f*fd*r*s + 550*C*D1**2*f*fd*r - 972*C*D1**2*f*fd*s**2 + 642*C*D1**2*f*fd*s - 321*C*D1**2*f*fd + 664*C*D1**2*f*fdd*r**2 + 1456*C*D1**2*f*fdd*r*s - 538*C*D1**2*f*fdd*r + 792*C*D1**2*f*fdd*s**2 - 602*C*D1**2*f*fdd*s + 301*C*D1**2*f*fdd + 664*C*D1**2*fd**2*r**2 + 1456*C*D1**2*fd**2*r*s - 538*C*D1**2*fd**2*r + 792*C*D1**2*fd**2*s**2 - 602*C*D1**2*fd**2*s - 190*C*D1**2*fd**2 - 1576*C*D1*Dd*f**2*r**2 - 3520*C*D1*Dd*f**2*r*s + 2548*C*D1*Dd*f**2*r - 1944*C*D1*Dd*f**2*s**2 + 2824*C*D1*Dd*f**2*s - 1366*C*D1*Dd*f**2 + 5312*C*D1*Dd*f*fd*r**2 + 11648*C*D1*Dd*f*fd*r*s - 6392*C*D1*Dd*f*fd*r + 6336*C*D1*Dd*f*fd*s**2 - 7032*C*D1*Dd*f*fd*s + 1742*C*D1*Dd*f*fd + 1328*C*D1*Ddd*f**2*r**2 + 2912*C*D1*Ddd*f**2*r*s - 2120*C*D1*Ddd*f**2*r + 1584*C*D1*Ddd*f**2*s**2 - 2312*C*D1*Ddd*f**2*s + 1124*C*D1*Ddd*f**2 + 3984*C*Dd**2*f**2*r**2 + 8736*C*Dd**2*f**2*r*s - 6360*C*Dd**2*f**2*r + 4752*C*Dd**2*f**2*s**2 - 6936*C*Dd**2*f**2*s + 2248*C*Dd**2*f**2 - 5*D1**2*bdd1*f*(19*C - 13)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 516*D1**2*f*fd*r**2 + 1216*D1**2*f*fd*r*s - 388*D1**2*f*fd*r + 700*D1**2*f*fd*s**2 - 480*D1**2*f*fd*s + 240*D1**2*f*fd - 436*D1**2*f*fdd*r**2 - 1012*D1**2*f*fdd*r*s + 376*D1**2*f*fdd*r - 576*D1**2*f*fdd*s**2 + 446*D1**2*f*fdd*s - 223*D1**2*f*fdd - 436*D1**2*fd**2*r**2 - 1012*D1**2*fd**2*r*s + 376*D1**2*fd**2*r - 576*D1**2*fd**2*s**2 + 446*D1**2*fd**2*s + 130*D1**2*fd**2 + 1032*D1*Dd*f**2*r**2 + 2432*D1*Dd*f**2*r*s - 1732*D1*Dd*f**2*r + 1400*D1*Dd*f**2*s**2 - 2008*D1*Dd*f**2*s + 958*D1*Dd*f**2 - 3488*D1*Dd*f*fd*r**2 - 8096*D1*Dd*f*fd*r*s + 4400*D1*Dd*f*fd*r - 4608*D1*Dd*f*fd*s**2 + 5100*D1*Dd*f*fd*s - 1268*D1*Dd*f*fd - 872*D1*Ddd*f**2*r**2 - 2024*D1*Ddd*f**2*r*s + 1448*D1*Ddd*f**2*r - 1152*D1*Ddd*f**2*s**2 + 1658*D1*Ddd*f**2*s - 794*D1*Ddd*f**2 + 5*D1*bd1*(D1*(f*(73*C - 54)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(26 - 38*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(26 - 38*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2616*Dd**2*f**2*r**2 - 6072*Dd**2*f**2*r*s + 4344*Dd**2*f**2*r - 3456*Dd**2*f**2*s**2 + 4974*Dd**2*f**2*s - 1588*Dd**2*f**2) + f*(-42549*C*D1**2*f*fd*r**2 - 93174*C*D1**2*f*fd*r*s + 59424*C*D1**2*f*fd*r - 50625*C*D1**2*f*fd*s**2 + 64808*C*D1**2*f*fd*s - 31058*C*D1**2*f*fd + 37857*C*D1**2*f*fdd*r**2 + 79554*C*D1**2*f*fdd*r*s - 51756*C*D1**2*f*fdd*r + 41697*C*D1**2*f*fdd*s**2 - 54316*C*D1**2*f*fdd*s + 26518*C*D1**2*f*fdd + 75714*C*D1**2*fd**2*r**2 + 159108*C*D1**2*fd**2*r*s - 103512*C*D1**2*fd**2*r + 83394*C*D1**2*fd**2*s**2 - 108632*C*D1**2*fd**2*s + 26518*C*D1**2*fd**2 - 56732*C*D1*Dd*f**2*r**2 - 124232*C*D1*Dd*f**2*r*s + 90482*C*D1*Dd*f**2*r - 67500*C*D1*Dd*f**2*s**2 + 98558*C*D1*Dd*f**2*s - 47933*C*D1*Dd*f**2 + 302856*C*D1*Dd*f*fd*r**2 + 636432*C*D1*Dd*f*fd*r*s - 441846*C*D1*Dd*f*fd*r + 333576*C*D1*Dd*f*fd*s**2 - 463606*C*D1*Dd*f*fd*s + 160388*C*D1*Dd*f*fd + 50476*C*D1*Ddd*f**2*r**2 + 106072*C*D1*Ddd*f**2*r*s - 78274*C*D1*Ddd*f**2*r + 55596*C*D1*Ddd*f**2*s**2 - 82114*C*D1*Ddd*f**2*s + 40417*C*D1*Ddd*f**2 + 151428*C*Dd**2*f**2*r**2 + 318216*C*Dd**2*f**2*r*s - 234822*C*Dd**2*f**2*r + 166788*C*Dd**2*f**2*s**2 - 246342*C*Dd**2*f**2*s + 80834*C*Dd**2*f**2 - 330*D1**2*bd1**2*(19*C - 13)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(C*(332*r**2 + 14*r*(52*s - 61) + 396*s**2 - 918*s + 427) - 218*r**2 + r*(566 - 506*s) - 288*s**2 + 636*s - 283) + 28104*D1**2*f*fd*r**2 + 63564*D1**2*f*fd*r*s - 39924*D1**2*f*fd*r + 35460*D1**2*f*fd*s**2 - 44828*D1**2*f*fd*s + 21188*D1**2*f*fd - 25041*D1**2*f*fdd*r**2 - 54948*D1**2*f*fdd*r*s + 35010*D1**2*f*fdd*r - 29907*D1**2*f*fdd*s**2 + 38254*D1**2*f*fdd*s - 18316*D1**2*f*fdd - 50082*D1**2*fd**2*r**2 - 109896*D1**2*fd**2*r*s + 70020*D1**2*fd**2*r - 59814*D1**2*fd**2*s**2 + 76508*D1**2*fd**2*s - 18316*D1**2*fd**2 + 37472*D1*Dd*f**2*r**2 + 84752*D1*Dd*f**2*r*s - 61112*D1*Dd*f**2*r + 47280*D1*Dd*f**2*s**2 - 68468*D1*Dd*f**2*s + 33008*D1*Dd*f**2 - 200328*D1*Dd*f*fd*r**2 - 439584*D1*Dd*f*fd*r*s + 300018*D1*Dd*f*fd*r - 239256*D1*Dd*f*fd*s**2 + 327592*D1*Dd*f*fd*s - 111518*D1*Dd*f*fd - 33388*D1*Ddd*f**2*r**2 - 73264*D1*Ddd*f**2*r*s + 53326*D1*Ddd*f**2*r - 39876*D1*Ddd*f**2*s**2 + 58192*D1*Ddd*f**2*s - 28285*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(C*(394*r**2 + 880*r*s - 1118*r + 486*s**2 - 1210*s + 559) - 258*r**2 - 608*r*s + 736*r - 350*s**2 + 828*s - 368) - 2*fd*(C*(664*r**2 + 1456*r*s - 1123*r + 792*s**2 - 1219*s + 459) - 436*r**2 - 1012*r*s + 754*r - 576*s**2 + 859*s - 318)) + 2*Dd*f*(-C*(1328*r**2 + 16*r*(182*s - 173) + 1584*s**2 - 2992*s + 1345) + 872*r**2 + 8*r*(253*s - 232) + 1152*s**2 - 2101*s + 919)) - 100164*Dd**2*f**2*r**2 - 219792*Dd**2*f**2*r*s + 159978*Dd**2*f**2*r - 119628*Dd**2*f**2*s**2 + 174576*Dd**2*f**2*s - 56570*Dd**2*f**2))/(693*d**2*k3**5) - D1**2*Pk1*Pkd3*ct**2*k1**2*k2**2*(-20592*C*D1**2*bd1*f**2*r**2 - 20592*C*D1**2*bd1*f**2*r*s + 92664*C*D1**2*bd1*f**2*r + 72072*C*D1**2*bd1*f**2*s - 46332*C*D1**2*bd1*f**2 - 115830*C*D1**2*f**2*fd*r**2 - 180180*C*D1**2*f**2*fd*r*s + 137280*C*D1**2*f**2*fd*r - 64350*C*D1**2*f**2*fd*s**2 + 102960*C*D1**2*f**2*fd*s - 60060*C*D1**2*f**2*fd - 154440*C*D1*Dd*f**3*r**2 - 240240*C*D1*Dd*f**3*r*s + 197340*C*D1*Dd*f**3*r - 85800*C*D1*Dd*f**3*s**2 + 145860*C*D1*Dd*f**3*s - 81510*C*D1*Dd*f**3 - 303732*D1**2*K*bd1**2*f*r**2 - 607464*D1**2*K*bd1**2*f*r*s + 761904*D1**2*K*bd1**2*f*r - 303732*D1**2*K*bd1**2*f*s**2 + 761904*D1**2*K*bd1**2*f*s - 458172*D1**2*K*bd1**2*f + 196482*D1**2*K*bd1*f**2*r**2 + 348348*D1**2*K*bd1*f**2*r*s - 348348*D1**2*K*bd1*f**2*r + 151866*D1**2*K*bd1*f**2*s**2 - 303732*D1**2*K*bd1*f**2*s + 151866*D1**2*K*bd1*f**2 - 840840*D1**2*K*bd1*f*fd*r**2 - 1613040*D1**2*K*bd1*f*fd*r*s + 1226940*D1**2*K*bd1*f*fd*r - 772200*D1**2*K*bd1*f*fd*s**2 + 1175460*D1**2*K*bd1*f*fd*s - 403260*D1**2*K*bd1*f*fd - 210210*D1**2*K*bdd1*f**2*r**2 - 403260*D1**2*K*bdd1*f**2*r*s + 403260*D1**2*K*bdd1*f**2*r - 193050*D1**2*K*bdd1*f**2*s**2 + 386100*D1**2*K*bdd1*f**2*s - 193050*D1**2*K*bdd1*f**2 + 151008*D1**2*bd1**2*f**2*r**2 + 363792*D1**2*bd1**2*f**2*r*s - 375804*D1**2*bd1**2*f**2*r + 212784*D1**2*bd1**2*f**2*s**2 - 437580*D1**2*bd1**2*f**2*s + 224796*D1**2*bd1**2*f**2 + 146718*D1**2*bd1**2*f*r**2 + 355212*D1**2*bd1**2*f*r*s - 401544*D1**2*bd1**2*f*r + 208494*D1**2*bd1**2*f*s**2 - 463320*D1**2*bd1**2*f*s + 254826*D1**2*bd1**2*f - 360360*D1**2*bd1**2*g2*r**2 - 720720*D1**2*bd1**2*g2*r*s + 360360*D1**2*bd1**2*g2*r - 360360*D1**2*bd1**2*g2*s**2 + 360360*D1**2*bd1**2*g2*s - 154440*D1**2*bd1*bd2*f*r**2 - 308880*D1**2*bd1*bd2*f*r*s + 308880*D1**2*bd1*bd2*f*r - 154440*D1**2*bd1*bd2*f*s**2 + 308880*D1**2*bd1*bd2*f*s - 154440*D1**2*bd1*bd2*f - 70915*D1**2*bd1*f**3*r**2 - 121160*D1**2*bd1*f**3*r*s + 142220*D1**2*bd1*f**3*r - 50245*D1**2*bd1*f**3*s**2 + 121550*D1**2*bd1*f**3*s - 78780*D1**2*bd1*f**3 + 502320*D1**2*bd1*f**2*fd*r**2 + 904020*D1**2*bd1*f**2*fd*r*s - 808340*D1**2*bd1*f**2*fd*r + 401700*D1**2*bd1*f**2*fd*s**2 - 724490*D1**2*bd1*f**2*fd*s + 285480*D1**2*bd1*f**2*fd - 71214*D1**2*bd1*f**2*r**2 - 159588*D1**2*bd1*f**2*r*s + 118404*D1**2*bd1*f**2*r - 88374*D1**2*bd1*f**2*s**2 + 135564*D1**2*bd1*f**2*s - 60060*D1**2*bd1*f**2 + 404976*D1**2*bd1*f*fd*r**2 + 885456*D1**2*bd1*f*fd*r*s - 645216*D1**2*bd1*f*fd*r + 480480*D1**2*bd1*f*fd*s**2 - 701844*D1**2*bd1*f*fd*s + 221364*D1**2*bd1*f*fd - 235092*D1**2*bd1*f*g2*r**2 - 446160*D1**2*bd1*f*g2*r*s + 787644*D1**2*bd1*f*g2*r - 211068*D1**2*bd1*f*g2*s**2 + 763620*D1**2*bd1*f*g2*s - 393822*D1**2*bd1*f*g2 + 607464*D1**2*bd1*f*gd2*r**2 + 1214928*D1**2*bd1*f*gd2*r*s - 1523808*D1**2*bd1*f*gd2*r + 607464*D1**2*bd1*f*gd2*s**2 - 1523808*D1**2*bd1*f*gd2*s + 916344*D1**2*bd1*f*gd2 + 607464*D1**2*bd1*fd*g2*r**2 + 1214928*D1**2*bd1*fd*g2*r*s - 607464*D1**2*bd1*fd*g2*r + 607464*D1**2*bd1*fd*g2*s**2 - 607464*D1**2*bd1*fd*g2*s + 64350*D1**2*bd2*f**2*r**2 + 128700*D1**2*bd2*f**2*r*s - 128700*D1**2*bd2*f**2*r + 64350*D1**2*bd2*f**2*s**2 - 128700*D1**2*bd2*f**2*s + 64350*D1**2*bd2*f**2 - 257400*D1**2*bd2*f*fd*r**2 - 514800*D1**2*bd2*f*fd*r*s + 386100*D1**2*bd2*f*fd*r - 257400*D1**2*bd2*f*fd*s**2 + 386100*D1**2*bd2*f*fd*s - 128700*D1**2*bd2*f*fd + 83720*D1**2*bdd1*f**3*r**2 + 150670*D1**2*bdd1*f**3*r*s - 169780*D1**2*bdd1*f**3*r + 66950*D1**2*bdd1*f**3*s**2 - 153010*D1**2*bdd1*f**3*s + 95160*D1**2*bdd1*f**3 + 101244*D1**2*bdd1*f**2*r**2 + 221364*D1**2*bdd1*f**2*r*s - 221364*D1**2*bdd1*f**2*r + 120120*D1**2*bdd1*f**2*s**2 - 240240*D1**2*bdd1*f**2*s + 120120*D1**2*bdd1*f**2 + 303732*D1**2*bdd1*f*g2*r**2 + 607464*D1**2*bdd1*f*g2*r*s - 916344*D1**2*bdd1*f*g2*r + 303732*D1**2*bdd1*f*g2*s**2 - 916344*D1**2*bdd1*f*g2*s + 458172*D1**2*bdd1*f*g2 - 64350*D1**2*bdd2*f**2*r**2 - 128700*D1**2*bdd2*f**2*r*s + 128700*D1**2*bdd2*f**2*r - 64350*D1**2*bdd2*f**2*s**2 + 128700*D1**2*bdd2*f**2*s - 64350*D1**2*bdd2*f**2 + 37520*D1**2*f**3*fd*r**2 + 190400*D1**2*f**3*fd*r*s - 113960*D1**2*f**3*fd*r + 152880*D1**2*f**3*fd*s**2 - 200480*D1**2*f**3*fd*s + 85820*D1**2*f**3*fd - 44240*D1**2*f**3*fdd*r**2 - 211680*D1**2*f**3*fdd*r*s + 127960*D1**2*f**3*fdd*r - 167440*D1**2*f**3*fdd*s**2 + 220360*D1**2*f**3*fdd*s - 94780*D1**2*f**3*fdd - 132720*D1**2*f**2*fd**2*r**2 - 635040*D1**2*f**2*fd**2*r*s + 383880*D1**2*f**2*fd**2*r - 502320*D1**2*f**2*fd**2*s**2 + 661080*D1**2*f**2*fd**2*s - 189560*D1**2*f**2*fd**2 + 70785*D1**2*f**2*fd*r**2 + 102960*D1**2*f**2*fd*r*s - 81510*D1**2*f**2*fd*r + 32175*D1**2*f**2*fd*s**2 - 55770*D1**2*f**2*fd*s + 34320*D1**2*f**2*fd - 392964*D1**2*f**2*gd2*r**2 - 696696*D1**2*f**2*gd2*r*s + 696696*D1**2*f**2*gd2*r - 303732*D1**2*f**2*gd2*s**2 + 607464*D1**2*f**2*gd2*s - 303732*D1**2*f**2*gd2 + 420420*D1**2*f**2*gdd2*r**2 + 806520*D1**2*f**2*gdd2*r*s - 806520*D1**2*f**2*gdd2*r + 386100*D1**2*f**2*gdd2*s**2 - 772200*D1**2*f**2*gdd2*s + 386100*D1**2*f**2*gdd2 - 785928*D1**2*f*fd*g2*r**2 - 1393392*D1**2*f*fd*g2*r*s + 785928*D1**2*f*fd*g2*r - 607464*D1**2*f*fd*g2*s**2 + 696696*D1**2*f*fd*g2*s - 392964*D1**2*f*fd*g2 + 1681680*D1**2*f*fd*gd2*r**2 + 3226080*D1**2*f*fd*gd2*r*s - 2453880*D1**2*f*fd*gd2*r + 1544400*D1**2*f*fd*gd2*s**2 - 2350920*D1**2*f*fd*gd2*s + 806520*D1**2*f*fd*gd2 + 840840*D1**2*f*fdd*g2*r**2 + 1613040*D1**2*f*fdd*g2*r*s - 840840*D1**2*f*fdd*g2*r + 772200*D1**2*f*fdd*g2*s**2 - 806520*D1**2*f*fdd*g2*s + 420420*D1**2*f*fdd*g2 + 840840*D1**2*fd**2*g2*r**2 + 1613040*D1**2*fd**2*g2*r*s - 840840*D1**2*fd**2*g2*r + 772200*D1**2*fd**2*g2*s**2 - 806520*D1**2*fd**2*g2*s - 1681680*D1*Dd*K*bd1*f**2*r**2 - 3226080*D1*Dd*K*bd1*f**2*r*s + 2839980*D1*Dd*K*bd1*f**2*r - 1544400*D1*Dd*K*bd1*f**2*s**2 + 2719860*D1*Dd*K*bd1*f**2*s - 1175460*D1*Dd*K*bd1*f**2 + 669760*D1*Dd*bd1*f**3*r**2 + 1205360*D1*Dd*bd1*f**3*r*s - 1147900*D1*Dd*bd1*f**3*r + 535600*D1*Dd*bd1*f**3*s**2 - 1030510*D1*Dd*bd1*f**3*s + 475800*D1*Dd*bd1*f**3 + 809952*D1*Dd*bd1*f**2*r**2 + 1770912*D1*Dd*bd1*f**2*r*s - 1530672*D1*Dd*bd1*f**2*r + 960960*D1*Dd*bd1*f**2*s**2 - 1662804*D1*Dd*bd1*f**2*s + 701844*D1*Dd*bd1*f**2 + 2429856*D1*Dd*bd1*f*g2*r**2 + 4859712*D1*Dd*bd1*f*g2*r*s - 5487768*D1*Dd*bd1*f*g2*r + 2429856*D1*Dd*bd1*f*g2*s**2 - 5487768*D1*Dd*bd1*f*g2*s + 2749032*D1*Dd*bd1*f*g2 - 514800*D1*Dd*bd2*f**2*r**2 - 1029600*D1*Dd*bd2*f**2*r*s + 900900*D1*Dd*bd2*f**2*r - 514800*D1*Dd*bd2*f**2*s**2 + 900900*D1*Dd*bd2*f**2*s - 386100*D1*Dd*bd2*f**2 + 37520*D1*Dd*f**4*r**2 + 190400*D1*Dd*f**4*r*s - 113960*D1*Dd*f**4*r + 152880*D1*Dd*f**4*s**2 - 200480*D1*Dd*f**4*s + 85820*D1*Dd*f**4 - 353920*D1*Dd*f**3*fd*r**2 - 1693440*D1*Dd*f**3*fd*r*s + 1023680*D1*Dd*f**3*fd*r - 1339520*D1*Dd*f**3*fd*s**2 + 1762880*D1*Dd*f**3*fd*s - 568680*D1*Dd*f**3*fd + 94380*D1*Dd*f**3*r**2 + 137280*D1*Dd*f**3*r*s - 115830*D1*Dd*f**3*r + 42900*D1*Dd*f**3*s**2 - 77220*D1*Dd*f**3*s + 45045*D1*Dd*f**3 - 1571856*D1*Dd*f**2*g2*r**2 - 2786784*D1*Dd*f**2*g2*r*s + 2179320*D1*Dd*f**2*g2*r - 1214928*D1*Dd*f**2*g2*s**2 + 1911624*D1*Dd*f**2*g2*s - 1000428*D1*Dd*f**2*g2 + 3363360*D1*Dd*f**2*gd2*r**2 + 6452160*D1*Dd*f**2*gd2*r*s - 5679960*D1*Dd*f**2*gd2*r + 3088800*D1*Dd*f**2*gd2*s**2 - 5439720*D1*Dd*f**2*gd2*s + 2350920*D1*Dd*f**2*gd2 + 6726720*D1*Dd*f*fd*g2*r**2 + 12904320*D1*Dd*f*fd*g2*r*s - 8271120*D1*Dd*f*fd*g2*r + 6177600*D1*Dd*f*fd*g2*s**2 - 7927920*D1*Dd*f*fd*g2*s + 2453880*D1*Dd*f*fd*g2 - 44240*D1*Ddd*f**4*r**2 - 211680*D1*Ddd*f**4*r*s + 127960*D1*Ddd*f**4*r - 167440*D1*Ddd*f**4*s**2 + 220360*D1*Ddd*f**4*s - 94780*D1*Ddd*f**4 + 1681680*D1*Ddd*f**2*g2*r**2 + 3226080*D1*Ddd*f**2*g2*r*s - 2453880*D1*Ddd*f**2*g2*r + 1544400*D1*Ddd*f**2*g2*s**2 - 2350920*D1*Ddd*f**2*g2*s + 1192620*D1*Ddd*f**2*g2 - 132720*Dd**2*f**4*r**2 - 635040*Dd**2*f**4*r*s + 383880*Dd**2*f**4*r - 502320*Dd**2*f**4*s**2 + 661080*Dd**2*f**4*s - 189560*Dd**2*f**4 + 5045040*Dd**2*f**2*g2*r**2 + 9678240*Dd**2*f**2*g2*r*s - 7361640*Dd**2*f**2*g2*r + 4633200*Dd**2*f**2*g2*s**2 - 7052760*Dd**2*f**2*g2*s + 2385240*Dd**2*f**2*g2 + 6435*b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(70*C*D1**2*fd*r**2 + 140*C*D1**2*fd*r*s - 140*C*D1**2*fd*r + 70*C*D1**2*fd*s**2 - 140*C*D1**2*fd*s + 70*C*D1**2*fd + 280*C*D1*Dd*f*r**2 + 560*C*D1*Dd*f*r*s - 420*C*D1*Dd*f*r + 280*C*D1*Dd*f*s**2 - 420*C*D1*Dd*f*s + 210*C*D1*Dd*f + 274*D1**2*K*fd*r**2 + 520*D1**2*K*fd*r*s + 370*D1**2*K*fd*r + 246*D1**2*K*fd*s**2 + 370*D1**2*K*fd*s - 185*D1**2*K*fd - 354*D1**2*K*fdd*r**2 - 708*D1**2*K*fdd*r*s - 360*D1**2*K*fdd*r - 354*D1**2*K*fdd*s**2 - 360*D1**2*K*fdd*s + 180*D1**2*K*fdd - 15*D1**2*bdd1*(-14*K + 6*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 260*D1**2*f*fd*r**2 - 664*D1**2*f*fd*r*s + 252*D1**2*f*fd*r - 404*D1**2*f*fd*s**2 + 324*D1**2*f*fd*s - 162*D1**2*f*fd + 352*D1**2*f*fdd*r**2 + 848*D1**2*f*fdd*r*s - 324*D1**2*f*fdd*r + 496*D1**2*f*fdd*s**2 - 396*D1**2*f*fdd*s + 198*D1**2*f*fdd + 352*D1**2*fd**2*r**2 + 848*D1**2*fd**2*r*s - 324*D1**2*fd**2*r + 496*D1**2*fd**2*s**2 - 396*D1**2*fd**2*s - 100*D1**2*fd**2 - 167*D1**2*fd*r**2 - 380*D1**2*fd*r*s - 80*D1**2*fd*r - 213*D1**2*fd*s**2 - 80*D1**2*fd*s + 40*D1**2*fd + 171*D1**2*fdd*r**2 + 414*D1**2*fdd*r*s + 180*D1**2*fdd*r + 243*D1**2*fdd*s**2 + 180*D1**2*fdd*s - 90*D1**2*fdd + 840*D1**2*gd2*r**2 + 1680*D1**2*gd2*r*s - 1680*D1**2*gd2*r + 840*D1**2*gd2*s**2 - 1680*D1**2*gd2*s + 840*D1**2*gd2 - 420*D1**2*gdd2*r**2 - 840*D1**2*gdd2*r*s + 840*D1**2*gdd2*r - 420*D1**2*gdd2*s**2 + 840*D1**2*gdd2*s - 420*D1**2*gdd2 + 1096*D1*Dd*K*f*r**2 + 2080*D1*Dd*K*f*r*s - 1588*D1*Dd*K*f*r + 984*D1*Dd*K*f*s**2 - 1504*D1*Dd*K*f*s + 766*D1*Dd*K*f - 2832*D1*Dd*K*fd*r**2 - 5664*D1*Dd*K*fd*r*s + 684*D1*Dd*K*fd*r - 2832*D1*Dd*K*fd*s**2 + 684*D1*Dd*K*fd*s + 1080*D1*Dd*K*fd - 520*D1*Dd*f**2*r**2 - 1328*D1*Dd*f**2*r*s + 924*D1*Dd*f**2*r - 808*D1*Dd*f**2*s**2 + 1140*D1*Dd*f**2*s - 534*D1*Dd*f**2 + 2816*D1*Dd*f*fd*r**2 + 6784*D1*Dd*f*fd*r*s - 3696*D1*Dd*f*fd*r + 3968*D1*Dd*f*fd*s**2 - 4416*D1*Dd*f*fd*s + 1116*D1*Dd*f*fd - 668*D1*Dd*f*r**2 - 1520*D1*Dd*f*r*s + 1094*D1*Dd*f*r - 852*D1*Dd*f*s**2 + 1232*D1*Dd*f*s - 593*D1*Dd*f + 1368*D1*Dd*fd*r**2 + 3312*D1*Dd*fd*r*s - 450*D1*Dd*fd*r + 1944*D1*Dd*fd*s**2 - 666*D1*Dd*fd*s - 540*D1*Dd*fd + 3360*D1*Dd*g2*r**2 + 6720*D1*Dd*g2*r*s - 5040*D1*Dd*g2*r + 3360*D1*Dd*g2*s**2 - 5040*D1*Dd*g2*s + 2520*D1*Dd*g2 - 3360*D1*Dd*gd2*r**2 - 6720*D1*Dd*gd2*r*s + 5880*D1*Dd*gd2*r - 3360*D1*Dd*gd2*s**2 + 5880*D1*Dd*gd2*s - 2520*D1*Dd*gd2 - 1416*D1*Ddd*K*f*r**2 - 2832*D1*Ddd*K*f*r*s + 2124*D1*Ddd*K*f*r - 1416*D1*Ddd*K*f*s**2 + 2124*D1*Ddd*K*f*s - 1062*D1*Ddd*K*f + 704*D1*Ddd*f**2*r**2 + 1696*D1*Ddd*f**2*r*s - 1200*D1*Ddd*f**2*r + 992*D1*Ddd*f**2*s**2 - 1416*D1*Ddd*f**2*s + 672*D1*Ddd*f**2 + 684*D1*Ddd*f*r**2 + 1656*D1*Ddd*f*r*s - 1170*D1*Ddd*f*r + 972*D1*Ddd*f*s**2 - 1386*D1*Ddd*f*s + 657*D1*Ddd*f - 1680*D1*Ddd*g2*r**2 - 3360*D1*Ddd*g2*r*s + 2520*D1*Ddd*g2*r - 1680*D1*Ddd*g2*s**2 + 2520*D1*Ddd*g2*s - 1260*D1*Ddd*g2 + 15*D1*bd1*(D1*(5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-14*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 4248*Dd**2*K*f*r**2 - 8496*Dd**2*K*f*r*s + 6372*Dd**2*K*f*r - 4248*Dd**2*K*f*s**2 + 6372*Dd**2*K*f*s - 2124*Dd**2*K*f + 2112*Dd**2*f**2*r**2 + 5088*Dd**2*f**2*r*s - 3600*Dd**2*f**2*r + 2976*Dd**2*f**2*s**2 - 4248*Dd**2*f**2*s + 1344*Dd**2*f**2 + 2052*Dd**2*f*r**2 + 4968*Dd**2*f*r*s - 3510*Dd**2*f*r + 2916*Dd**2*f*s**2 - 4158*Dd**2*f*s + 1314*Dd**2*f - 5040*Dd**2*g2*r**2 - 10080*Dd**2*g2*r*s + 7560*Dd**2*g2*r - 5040*Dd**2*g2*s**2 + 7560*Dd**2*g2*s - 2520*Dd**2*g2) - 13*b1*(3168*C*D1**2*f*fd*r**2 + 3168*C*D1**2*f*fd*r*s + 2376*C*D1**2*f*fd*r + 3960*C*D1**2*f*fd*s - 1980*C*D1**2*f*fd + 6336*C*D1*Dd*f**2*r**2 + 6336*C*D1*Dd*f**2*r*s - 6336*C*D1*Dd*f**2*r - 1584*C*D1*Dd*f**2*s + 1584*C*D1*Dd*f**2 + 23364*D1**2*K*bdd1*f*r**2 + 46728*D1**2*K*bdd1*f*r*s - 58608*D1**2*K*bdd1*f*r + 23364*D1**2*K*bdd1*f*s**2 - 58608*D1**2*K*bdd1*f*s + 29304*D1**2*K*bdd1*f - 30228*D1**2*K*f*fd*r**2 - 53592*D1**2*K*f*fd*r*s + 30228*D1**2*K*f*fd*r - 23364*D1**2*K*f*fd*s**2 + 26796*D1**2*K*f*fd*s - 15114*D1**2*K*f*fd + 32340*D1**2*K*f*fdd*r**2 + 62040*D1**2*K*f*fdd*r*s - 32340*D1**2*K*f*fdd*r + 29700*D1**2*K*f*fdd*s**2 - 31020*D1**2*K*f*fdd*s + 16170*D1**2*K*f*fdd + 32340*D1**2*K*fd**2*r**2 + 62040*D1**2*K*fd**2*r*s - 32340*D1**2*K*fd**2*r + 29700*D1**2*K*fd**2*s**2 - 31020*D1**2*K*fd**2*s - 6105*D1**2*b2*fd*r**2 - 12210*D1**2*b2*fd*r*s - 6105*D1**2*b2*fd*s**2 + 5940*D1**2*b2*fdd*r**2 + 11880*D1**2*b2*fdd*r*s + 5940*D1**2*b2*fdd*s**2 + 990*D1**2*bd1**2*(-14*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 11616*D1**2*bdd1*f**2*r**2 - 27984*D1**2*bdd1*f**2*r*s + 28908*D1**2*bdd1*f**2*r - 16368*D1**2*bdd1*f**2*s**2 + 33660*D1**2*bdd1*f**2*s - 15642*D1**2*bdd1*f**2 - 11286*D1**2*bdd1*f*r**2 - 27324*D1**2*bdd1*f*r*s + 30888*D1**2*bdd1*f*r - 16038*D1**2*bdd1*f*s**2 + 35640*D1**2*bdd1*f*s - 16632*D1**2*bdd1*f + 27720*D1**2*bdd1*g2*r**2 + 55440*D1**2*bdd1*g2*r*s - 27720*D1**2*bdd1*g2*r + 27720*D1**2*bdd1*g2*s**2 - 27720*D1**2*bdd1*g2*s + 13860*D1**2*bdd1*g2 + 5940*D1**2*bdd2*f*r**2 + 11880*D1**2*bdd2*f*r*s - 11880*D1**2*bdd2*f*r + 5940*D1**2*bdd2*f*s**2 - 11880*D1**2*bdd2*f*s + 5940*D1**2*bdd2*f + 16365*D1**2*f**2*fd*r**2 + 27960*D1**2*f**2*fd*r*s - 18610*D1**2*f**2*fd*r + 11595*D1**2*f**2*fd*s**2 - 15430*D1**2*f**2*fd*s + 7125*D1**2*f**2*fd - 19320*D1**2*f**2*fdd*r**2 - 34770*D1**2*f**2*fdd*r*s + 23000*D1**2*f**2*fdd*r - 15450*D1**2*f**2*fdd*s**2 + 20420*D1**2*f**2*fdd*s - 9420*D1**2*f**2*fdd - 38640*D1**2*f*fd**2*r**2 - 69540*D1**2*f*fd**2*r*s + 46000*D1**2*f*fd**2*r - 30900*D1**2*f*fd**2*s**2 + 40840*D1**2*f*fd**2*s - 11520*D1**2*f*fd**2 + 10956*D1**2*f*fd*r**2 + 24552*D1**2*f*fd*r*s - 14124*D1**2*f*fd*r + 13596*D1**2*f*fd*s**2 - 15444*D1**2*f*fd*s + 7656*D1**2*f*fd - 15576*D1**2*f*fdd*r**2 - 34056*D1**2*f*fdd*r*s + 15576*D1**2*f*fdd*r - 18480*D1**2*f*fdd*s**2 + 17028*D1**2*f*fdd*s - 7788*D1**2*f*fdd + 18084*D1**2*f*gd2*r**2 + 34320*D1**2*f*gd2*r*s - 34320*D1**2*f*gd2*r + 16236*D1**2*f*gd2*s**2 - 32472*D1**2*f*gd2*s + 16236*D1**2*f*gd2 - 23364*D1**2*f*gdd2*r**2 - 46728*D1**2*f*gdd2*r*s + 46728*D1**2*f*gdd2*r - 23364*D1**2*f*gdd2*s**2 + 46728*D1**2*f*gdd2*s - 23364*D1**2*f*gdd2 - 15576*D1**2*fd**2*r**2 - 34056*D1**2*fd**2*r*s + 15576*D1**2*fd**2*r - 18480*D1**2*fd**2*s**2 + 17028*D1**2*fd**2*s + 18084*D1**2*fd*g2*r**2 + 34320*D1**2*fd*g2*r*s + 24420*D1**2*fd*g2*r + 16236*D1**2*fd*g2*s**2 + 24420*D1**2*fd*g2*s - 12210*D1**2*fd*g2 - 46728*D1**2*fd*gd2*r**2 - 93456*D1**2*fd*gd2*r*s + 22968*D1**2*fd*gd2*r - 46728*D1**2*fd*gd2*s**2 + 22968*D1**2*fd*gd2*s + 23760*D1**2*fd*gd2 - 23364*D1**2*fdd*g2*r**2 - 46728*D1**2*fdd*g2*r*s - 23760*D1**2*fdd*g2*r - 23364*D1**2*fdd*g2*s**2 - 23760*D1**2*fdd*g2*s + 11880*D1**2*fdd*g2 - 60456*D1*Dd*K*f**2*r**2 - 107184*D1*Dd*K*f**2*r*s + 83820*D1*Dd*K*f**2*r - 46728*D1*Dd*K*f**2*s**2 + 73524*D1*Dd*K*f**2*s - 38478*D1*Dd*K*f**2 + 258720*D1*Dd*K*f*fd*r**2 + 496320*D1*Dd*K*f*fd*r*s - 318120*D1*Dd*K*f*fd*r + 237600*D1*Dd*K*f*fd*s**2 - 304920*D1*Dd*K*f*fd*s + 94380*D1*Dd*K*f*fd - 24420*D1*Dd*b2*f*r**2 - 48840*D1*Dd*b2*f*r*s + 36630*D1*Dd*b2*f*r - 24420*D1*Dd*b2*f*s**2 + 36630*D1*Dd*b2*f*s - 18315*D1*Dd*b2*f + 47520*D1*Dd*b2*fd*r**2 + 95040*D1*Dd*b2*fd*r*s - 35640*D1*Dd*b2*fd*r + 47520*D1*Dd*b2*fd*s**2 - 35640*D1*Dd*b2*fd*s + 21820*D1*Dd*f**3*r**2 + 37280*D1*Dd*f**3*r*s - 29550*D1*Dd*f**3*r + 15460*D1*Dd*f**3*s**2 - 24780*D1*Dd*f**3*s + 13185*D1*Dd*f**3 - 154560*D1*Dd*f**2*fd*r**2 - 278160*D1*Dd*f**2*fd*r*s + 200180*D1*Dd*f**2*fd*r - 123600*D1*Dd*f**2*fd*s**2 + 178250*D1*Dd*f**2*fd*s - 63840*D1*Dd*f**2*fd + 21912*D1*Dd*f**2*r**2 + 49104*D1*Dd*f**2*r*s - 35508*D1*Dd*f**2*r + 27192*D1*Dd*f**2*s**2 - 39468*D1*Dd*f**2*s + 19074*D1*Dd*f**2 - 124608*D1*Dd*f*fd*r**2 - 272448*D1*Dd*f*fd*r*s + 161568*D1*Dd*f*fd*r - 147840*D1*Dd*f*fd*s**2 + 176088*D1*Dd*f*fd*s - 49632*D1*Dd*f*fd + 72336*D1*Dd*f*g2*r**2 + 137280*D1*Dd*f*g2*r*s - 104808*D1*Dd*f*g2*r + 64944*D1*Dd*f*g2*s**2 - 99264*D1*Dd*f*g2*s + 50556*D1*Dd*f*g2 - 186912*D1*Dd*f*gd2*r**2 - 373824*D1*Dd*f*gd2*r*s + 327096*D1*Dd*f*gd2*r - 186912*D1*Dd*f*gd2*s**2 + 327096*D1*Dd*f*gd2*s - 140184*D1*Dd*f*gd2 - 186912*D1*Dd*fd*g2*r**2 - 373824*D1*Dd*fd*g2*r*s + 45144*D1*Dd*fd*g2*r - 186912*D1*Dd*fd*g2*s**2 + 45144*D1*Dd*fd*g2*s + 71280*D1*Dd*fd*g2 + 64680*D1*Ddd*K*f**2*r**2 + 124080*D1*Ddd*K*f**2*r*s - 94380*D1*Ddd*K*f**2*r + 59400*D1*Ddd*K*f**2*s**2 - 90420*D1*Ddd*K*f**2*s + 45870*D1*Ddd*K*f**2 + 23760*D1*Ddd*b2*f*r**2 + 47520*D1*Ddd*b2*f*r*s - 35640*D1*Ddd*b2*f*r + 23760*D1*Ddd*b2*f*s**2 - 35640*D1*Ddd*b2*f*s + 17820*D1*Ddd*b2*f - 25760*D1*Ddd*f**3*r**2 - 46360*D1*Ddd*f**3*r*s + 36060*D1*Ddd*f**3*r - 20600*D1*Ddd*f**3*s**2 + 32190*D1*Ddd*f**3*s - 16740*D1*Ddd*f**3 - 31152*D1*Ddd*f**2*r**2 - 68112*D1*Ddd*f**2*r*s + 49632*D1*Ddd*f**2*r - 36960*D1*Ddd*f**2*s**2 + 53988*D1*Ddd*f**2*s - 26268*D1*Ddd*f**2 - 93456*D1*Ddd*f*g2*r**2 - 186912*D1*Ddd*f*g2*r*s + 140184*D1*Ddd*f*g2*r - 93456*D1*Ddd*f*g2*s**2 + 140184*D1*Ddd*f*g2*s - 70092*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(4*f**2*(65*r**2 + 2*r*(83*s - 84) + 101*s**2 - 204*s + 93) - f*(70*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 548*K*r**2 + 1040*K*r*s - 1438*K*r + 492*K*s**2 - 1382*K*s + 705*K + 8*fd*(176*r**2 + 424*r*s - 300*r + 248*s**2 - 354*s + 115) - 334*r**2 - 760*r*s + 794*r - 426*s**2 + 886*s - 420) + 12*fd*(2*K*(59*r**2 + 118*r*s - 44*r + 59*s**2 - 44*s - 15) - 57*r**2 - 138*r*s + 48*r - 81*s**2 + 60*s + 15) - 840*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 840*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 4*Dd*(-6*K*f*(236*r**2 + r*(472*s - 473) + 236*s**2 - 473*s + 222) + f**2*(704*r**2 + 4*r*(424*s - 369) + 992*s**2 - 1728*s + 729) + 9*f*(76*r**2 + r*(184*s - 169) + 108*s**2 - 197*s + 86) - 210*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 165*D1*bd2*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) + 194040*Dd**2*K*f**2*r**2 + 372240*Dd**2*K*f**2*r*s - 283140*Dd**2*K*f**2*r + 178200*Dd**2*K*f**2*s**2 - 271260*Dd**2*K*f**2*s + 91740*Dd**2*K*f**2 + 71280*Dd**2*b2*f*r**2 + 142560*Dd**2*b2*f*r*s - 106920*Dd**2*b2*f*r + 71280*Dd**2*b2*f*s**2 - 106920*Dd**2*b2*f*s + 35640*Dd**2*b2*f - 77280*Dd**2*f**3*r**2 - 139080*Dd**2*f**3*r*s + 108180*Dd**2*f**3*r - 61800*Dd**2*f**3*s**2 + 96570*Dd**2*f**3*s - 33480*Dd**2*f**3 - 93456*Dd**2*f**2*r**2 - 204336*Dd**2*f**2*r*s + 148896*Dd**2*f**2*r - 110880*Dd**2*f**2*s**2 + 161964*Dd**2*f**2*s - 52536*Dd**2*f**2 - 280368*Dd**2*f*g2*r**2 - 560736*Dd**2*f*g2*r*s + 420552*Dd**2*f*g2*r - 280368*Dd**2*f*g2*s**2 + 420552*Dd**2*f*g2*s - 140184*Dd**2*f*g2) + 2145*b2*(-36*D1**2*bdd1*f*(r + s - 1)**2 + 30*D1**2*(f*(fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bd1*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) + 30*D1*f*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(9009*d**2*k3**5) + 2*D1**2*Pk1*Pkd3*ct**2*k1**2*st**2*(11*b1**2*(D1**2*(s - 1)*(fd*(76*C - 51) + fdd*(15 - 24*C))*(r + s - 1) + D1*(Dd*(f*(76*C - 51)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(24*C - 15)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(15 - 24*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(24*C - 15)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 11*b1*(-D1**2*(f*(3*bdd1*s*(8*C - 5)*(2*r + 2*s - 1) + fd*(4*C*(8*r*s - 4*r + 8*s**2 + 3*s + 4) - 16*r*s + 8*r - 16*s**2 - 11*s - 8) + 3*fdd*(-4*C*(2*r*s - r + 2*s**2 + 1) + 4*r*s - 2*r + 4*s**2 + s + 2)) - 3*fd**2*(C*(8*r*s - 4*r + 8*s**2 - 8) - 4*r*s + 2*r - 4*s**2 - s + 5)) + D1*bd1*(D1*(f*s*(76*C - 51)*(2*r + 2*s - 1) - fd*(24*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(30 - 48*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - 2*D1*f*(Dd*f*(8*C - 4)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 6*Dd*fd*(2*s - 1)*(C*(8*r + 8*s - 1) - 4*r - 4*s) - Ddd*f*(6*C - 3)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(12*C - 6)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-33*D1**2*bd1**2*s*(8*C - 5)*(2*r + 2*s - 1) + D1**2*(f*(33*bdd1*s*(4*C*(r + s - 3) - 2*r - 2*s + 7) - fd*(468*C - 273)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(300*C - 175)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(300*C - 175)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 11*D1*bd1*(D1*(f*s*(4*C*(4*r + 4*s - 15) - 8*r - 8*s + 35) - 3*fd*(4*C*(4*r*s - r + 4*s**2 - 6*s + 3) - 8*r*s + 2*r - 8*s**2 + 13*s - 7)) - 6*Dd*f*(2*C*(8*r*s - 2*r + 8*s**2 - 17*s + 6) - 8*r*s + 2*r - 8*s**2 + 19*s - 7)) - D1*f*(12*C - 7)*(Dd*(39*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 25*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 25*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(300*C - 175)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**2*k1**2*(-33*b1**2*(D1**2*(2*fd*(2*C*(9*r + 65*s - 65) - 9*r - 84*s + 84) + fdd*(-74*C*r - 242*C*(s - 1) + 37*r + 161*s - 161))*(r + s - 1) + D1*(2*Dd*(f*(C*(72*r**2 + 592*r*s - 332*r + 520*s**2 - 668*s + 278) - 36*r**2 - 372*r*s + 204*r - 336*s**2 + 429*s - 177) + fd*(-2*C*(148*r**2 + 632*r*s - 511*r + 484*s**2 - 805*s + 321) + 148*r**2 + 792*r*s - 631*r + 644*s**2 - 1065*s + 421)) + Ddd*f*(-2*C*(148*r**2 + 632*r*s - 390*r + 484*s**2 - 642*s + 279) + 148*r**2 + 792*r*s - 470*r + 644*s**2 - 842*s + 359)) + 2*Dd**2*f*(-6*C*(74*r**2 + r*(316*s - 195) + 242*s**2 - 321*s + 93) + 222*r**2 + 3*r*(396*s - 235) + 966*s**2 - 1263*s + 359)) - 33*b1*(16*C*D1**2*f*fd*r**2 - 88*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 - 248*C*D1**2*f*fd*s + 36*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r*s + 152*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 280*C*D1**2*f*fdd*s - 72*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r*s + 152*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 280*C*D1**2*fd**2*s - 276*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r**2 - 16*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 32*C*D1*Dd*f**2*s - 8*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 - 192*C*D1*Dd*f*fd*r*s + 696*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 1160*C*D1*Dd*f*fd*s - 712*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 - 48*C*D1*Ddd*f**2*r*s + 44*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 20*C*D1*Ddd*f**2*s - 14*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 - 144*C*Dd**2*f**2*r*s + 132*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 60*C*Dd**2*f**2*s - 28*C*Dd**2*f**2 + D1**2*bdd1*f*(-2*C*(74*r**2 + 316*r*s - 74*r + 242*s**2 - 158*s + 37) + 74*r**2 + 396*r*s - 74*r + 322*s**2 - 198*s + 37) - 8*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 + 156*D1**2*f*fd*s - 18*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 76*D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 174*D1**2*f*fdd*s + 36*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 76*D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 174*D1**2*fd**2*s + 172*D1**2*fd**2 - 16*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 348*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 716*D1*Dd*f*fd*s + 424*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 22*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 10*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(2*C*(18*r**2 + 2*r*(74*s - 9) + 130*s**2 - 74*s + 9) - 18*r**2 - 3*r*(62*s - 6) - 168*s**2 + 93*s - 9) + fd*(-2*C*(74*r**2 + 316*r*s - 195*r + 242*s**2 - 321*s + 79) + 74*r**2 + 396*r*s - 235*r + 322*s**2 - 421*s + 99)) + Dd*f*(-2*C*(296*r**2 + 1264*r*s - 538*r + 968*s**2 - 958*s + 195) + 296*r**2 + 1584*r*s - 618*r + 1288*s**2 - 1238*s + 235)) + 60*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 66*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 30*Dd**2*f**2*s + 14*Dd**2*f**2) + f*(66*D1**2*bd1**2*(r**2*(74*C - 37) + r*(C*(316*s - 74) - 198*s + 37) + s*(2*C*(121*s - 79) - 161*s + 99)) + 33*D1**2*bdd1*f*(2*C*(5*r**2 + 6*r*(s + 10) + s**2 + 132*s - 30) - 5*r**2 - 6*r*(s + 10) - s**2 - 166*s + 30) + 5*D1**2*(f*(fd*(2*C*(417*r**2 + 6*r*(383*s - 174) + 1881*s**2 - 2020*s + 766) - 417*r**2 - 2832*r*s + 1222*r - 2415*s**2 + 2554*s - 944) + fdd*(-2*C*(555*r**2 + 6*r*(373*s - 186) + 1683*s**2 - 1868*s + 746) + 555*r**2 + 2802*r*s - 1304*r + 2247*s**2 - 2432*s + 934)) + 2*fd**2*(-2*C*(555*r**2 + 6*r*(373*s - 186) + 1683*s**2 - 1868*s + 373) + 555*r**2 + 2802*r*s - 1304*r + 2247*s**2 - 2432*s + 467)) - 66*D1*bd1*(D1*(f*(2*C*(2*r**2 + 18*r - 2*s**2 + 66*s - 9) - 2*r**2 - 18*r + 2*s**2 - 82*s + 9) + fd*(-4*C*(5*r**2 + 6*r*s + 11*r + s**2 + 31*s - 33) + 10*r**2 + 12*r*s + 22*r + 2*s**2 + 79*s - 83)) + Dd*f*(-2*C*(20*r**2 + 24*r*s + 109*r + 4*s**2 + 259*s - 162) + 20*r**2 + 24*r*s + 109*r + 4*s**2 + 327*s - 196)) + 5*D1*f*(Dd*(f*(2*C*(556*r**2 + 3064*r*s - 1810*r + 2508*s**2 - 3274*s + 1393) - 556*r**2 - 3776*r*s + 2166*r - 3220*s**2 + 4164*s - 1749) + 2*fd*(-2*C*(2220*r**2 + 8952*r*s - 5025*r + 6732*s**2 - 8221*s + 2426) + 2220*r**2 + 11208*r*s - 5965*r + 8988*s**2 - 10759*s + 3084)) + Ddd*f*(-2*C*(740*r**2 + 2984*r*s - 1862*r + 2244*s**2 - 2990*s + 1307) + 740*r**2 + 3736*r*s - 2238*r + 2996*s**2 - 3930*s + 1683)) - 10*Dd**2*f**2*(C*(2220*r**2 + 8952*r*s - 5586*r + 6732*s**2 - 8970*s + 2614) - 1110*r**2 - 5604*r*s + 3357*r - 4494*s**2 + 5895*s - 1683)))/(693*d**2*k3**3) - D1**2*Pk1*Pkd3*ct**2*k2**6*st**6*(5*C - 5)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(77*d**2*k3**7) - 3*D1**2*Pk1*Pkd3*ct**2*k2**6*st**4*(-858*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 78*D1*bd1*(D1*(20*f**3*(r + s - 1) + f**2*(11*C*(r + s - 1) - 20*fd*(3*r + 3*s - 2) - 11*r - 11*s + 11) + 22*f*(g2 - gd2)*(r + s - 1) - 22*fd*g2*(r + s)) - 2*Dd*f*(10*f**2 + 11*g2)*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 78*b1*(-22*C*D1**2*f*fd*r**2 - 44*C*D1**2*f*fd*r*s + 22*C*D1**2*f*fd*r - 22*C*D1**2*f*fd*s**2 + 22*C*D1**2*f*fd*s - 11*C*D1**2*f*fd - 44*C*D1*Dd*f**2*r**2 - 88*C*D1*Dd*f**2*r*s + 66*C*D1*Dd*f**2*r - 44*C*D1*Dd*f**2*s**2 + 66*C*D1*Dd*f**2*s - 33*C*D1*Dd*f**2 - 11*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 60*D1**2*f**2*fd*r**2 - 120*D1**2*f**2*fd*r*s + 80*D1**2*f**2*fd*r - 60*D1**2*f**2*fd*s**2 + 80*D1**2*f**2*fd*s - 40*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r**2 + 60*D1**2*f**2*fdd*r*s - 40*D1**2*f**2*fdd*r + 30*D1**2*f**2*fdd*s**2 - 40*D1**2*f**2*fdd*s + 20*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 + 120*D1**2*f*fd**2*r*s - 80*D1**2*f*fd**2*r + 60*D1**2*f*fd**2*s**2 - 80*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 22*D1**2*f*gd2*r**2 - 44*D1**2*f*gd2*r*s + 44*D1**2*f*gd2*r - 22*D1**2*f*gd2*s**2 + 44*D1**2*f*gd2*s - 22*D1**2*f*gd2 + 11*D1**2*f*gdd2*r**2 + 22*D1**2*f*gdd2*r*s - 22*D1**2*f*gdd2*r + 11*D1**2*f*gdd2*s**2 - 22*D1**2*f*gdd2*s + 11*D1**2*f*gdd2 - 22*D1**2*fd*g2*r**2 - 44*D1**2*fd*g2*r*s - 22*D1**2*fd*g2*s**2 + 22*D1**2*fd*gd2*r**2 + 44*D1**2*fd*gd2*r*s - 22*D1**2*fd*gd2*r + 22*D1**2*fd*gd2*s**2 - 22*D1**2*fd*gd2*s + 11*D1**2*fdd*g2*r**2 + 22*D1**2*fdd*g2*r*s + 11*D1**2*fdd*g2*s**2 - 80*D1*Dd*f**3*r**2 - 160*D1*Dd*f**3*r*s + 120*D1*Dd*f**3*r - 80*D1*Dd*f**3*s**2 + 120*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r**2 + 480*D1*Dd*f**2*fd*r*s - 340*D1*Dd*f**2*fd*r + 240*D1*Dd*f**2*fd*s**2 - 340*D1*Dd*f**2*fd*s + 120*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 88*D1*Dd*f*g2*r**2 - 176*D1*Dd*f*g2*r*s + 132*D1*Dd*f*g2*r - 88*D1*Dd*f*g2*s**2 + 132*D1*Dd*f*g2*s - 66*D1*Dd*f*g2 + 88*D1*Dd*f*gd2*r**2 + 176*D1*Dd*f*gd2*r*s - 154*D1*Dd*f*gd2*r + 88*D1*Dd*f*gd2*s**2 - 154*D1*Dd*f*gd2*s + 66*D1*Dd*f*gd2 + 88*D1*Dd*fd*g2*r**2 + 176*D1*Dd*fd*g2*r*s - 66*D1*Dd*fd*g2*r + 88*D1*Dd*fd*g2*s**2 - 66*D1*Dd*fd*g2*s + 40*D1*Ddd*f**3*r**2 + 80*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 40*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + 44*D1*Ddd*f*g2*r**2 + 88*D1*Ddd*f*g2*r*s - 66*D1*Ddd*f*g2*r + 44*D1*Ddd*f*g2*s**2 - 66*D1*Ddd*f*g2*s + 33*D1*Ddd*f*g2 + 22*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 120*Dd**2*f**3*r**2 + 240*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 120*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 60*Dd**2*f**3 + 132*Dd**2*f*g2*r**2 + 264*Dd**2*f*g2*r*s - 198*Dd**2*f*g2*r + 132*Dd**2*f*g2*s**2 - 198*Dd**2*f*g2*s + 66*Dd**2*f*g2) - 2*f*(-39*D1**2*bdd1*(10*f**2 + 11*g2)*(r + s - 1)**2 + 5*f*(D1**2*(f*(137*fd - 75*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 450*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(137*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 150*fd*(4*r + 4*s - 3)**2) - 75*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 450*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(1001*d**2*k3**7) - D1**2*Pk1*Pkd3*ct**2*k2**4*st**6*(20*C - 20)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(693*d**2*k3**5) + D1**2*Pk1*Pkd3*ct**2*k2**4*st**4*(-330*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 66*b1*(-6*C*D1**2*f*fd*r**2 - 20*C*D1**2*f*fd*r*s + 10*C*D1**2*f*fd*r - 14*C*D1**2*f*fd*s**2 + 14*C*D1**2*f*fd*s - 7*C*D1**2*f*fd + 10*C*D1**2*f*fdd*r**2 + 28*C*D1**2*f*fdd*r*s - 14*C*D1**2*f*fdd*r + 18*C*D1**2*f*fdd*s**2 - 18*C*D1**2*f*fdd*s + 9*C*D1**2*f*fdd + 10*C*D1**2*fd**2*r**2 + 28*C*D1**2*fd**2*r*s - 14*C*D1**2*fd**2*r + 18*C*D1**2*fd**2*s**2 - 18*C*D1**2*fd**2*s - 12*C*D1*Dd*f**2*r**2 - 40*C*D1*Dd*f**2*r*s + 26*C*D1*Dd*f**2*r - 28*C*D1*Dd*f**2*s**2 + 38*C*D1*Dd*f**2*s - 17*C*D1*Dd*f**2 + 80*C*D1*Dd*f*fd*r**2 + 224*C*D1*Dd*f*fd*r*s - 132*C*D1*Dd*f*fd*r + 144*C*D1*Dd*f*fd*s**2 - 172*C*D1*Dd*f*fd*s + 50*C*D1*Dd*f*fd + 20*C*D1*Ddd*f**2*r**2 + 56*C*D1*Ddd*f**2*r*s - 38*C*D1*Ddd*f**2*r + 36*C*D1*Ddd*f**2*s**2 - 50*C*D1*Ddd*f**2*s + 23*C*D1*Ddd*f**2 + 60*C*Dd**2*f**2*r**2 + 168*C*Dd**2*f**2*r*s - 114*C*Dd**2*f**2*r + 108*C*Dd**2*f**2*s**2 - 150*C*Dd**2*f**2*s + 46*C*Dd**2*f**2 - 5*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 4*D1**2*f*fd*r**2 + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s - 8*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 132*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 172*D1*Dd*f*fd*s - 50*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 38*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 50*D1*Ddd*f**2*s - 23*D1*Ddd*f**2 + 10*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 60*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 114*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 150*Dd**2*f**2*s - 46*Dd**2*f**2) + f*(-1572*C*D1**2*f*fd*r**2 - 2712*C*D1**2*f*fd*r*s + 1952*C*D1**2*f*fd*r - 1140*C*D1**2*f*fd*s**2 + 1664*C*D1**2*f*fd*s - 904*C*D1**2*f*fd + 786*C*D1**2*f*fdd*r**2 + 1356*C*D1**2*f*fdd*r*s - 976*C*D1**2*f*fdd*r + 570*C*D1**2*f*fdd*s**2 - 832*C*D1**2*f*fdd*s + 452*C*D1**2*f*fdd + 1572*C*D1**2*fd**2*r**2 + 2712*C*D1**2*fd**2*r*s - 1952*C*D1**2*fd**2*r + 1140*C*D1**2*fd**2*s**2 - 1664*C*D1**2*fd**2*s + 452*C*D1**2*fd**2 - 2096*C*D1*Dd*f**2*r**2 - 3616*C*D1*Dd*f**2*r*s + 2856*C*D1*Dd*f**2*r - 1520*C*D1*Dd*f**2*s**2 + 2424*C*D1*Dd*f**2*s - 1284*C*D1*Dd*f**2 + 6288*C*D1*Dd*f*fd*r**2 + 10848*C*D1*Dd*f*fd*r*s - 8188*C*D1*Dd*f*fd*r + 4560*C*D1*Dd*f*fd*s**2 - 6964*C*D1*Dd*f*fd*s + 2640*C*D1*Dd*f*fd + 1048*C*D1*Ddd*f**2*r**2 + 1808*C*D1*Ddd*f**2*r*s - 1428*C*D1*Ddd*f**2*r + 760*C*D1*Ddd*f**2*s**2 - 1212*C*D1*Ddd*f**2*s + 642*C*D1*Ddd*f**2 + 3144*C*Dd**2*f**2*r**2 + 5424*C*Dd**2*f**2*r*s - 4284*C*Dd**2*f**2*r + 2280*C*Dd**2*f**2*s**2 - 3636*C*Dd**2*f**2*s + 1284*C*Dd**2*f**2 + 660*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 66*D1**2*bdd1*f*(C - 1)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) + 1662*D1**2*f*fd*r**2 + 2952*D1**2*f*fd*r*s - 2092*D1**2*f*fd*r + 1290*D1**2*f*fd*s**2 - 1844*D1**2*f*fd*s + 984*D1**2*f*fd - 831*D1**2*f*fdd*r**2 - 1476*D1**2*f*fdd*r*s + 1046*D1**2*f*fdd*r - 645*D1**2*f*fdd*s**2 + 922*D1**2*f*fdd*s - 492*D1**2*f*fdd - 1662*D1**2*fd**2*r**2 - 2952*D1**2*fd**2*r*s + 2092*D1**2*fd**2*r - 1290*D1**2*fd**2*s**2 + 1844*D1**2*fd**2*s - 492*D1**2*fd**2 + 2216*D1*Dd*f**2*r**2 + 3936*D1*Dd*f**2*r*s - 3076*D1*Dd*f**2*r + 1720*D1*Dd*f**2*s**2 - 2704*D1*Dd*f**2*s + 1414*D1*Dd*f**2 - 6648*D1*Dd*f*fd*r**2 - 11808*D1*Dd*f*fd*r*s + 8798*D1*Dd*f*fd*r - 5160*D1*Dd*f*fd*s**2 + 7744*D1*Dd*f*fd*s - 2890*D1*Dd*f*fd - 1108*D1*Ddd*f**2*r**2 - 1968*D1*Ddd*f**2*r*s + 1538*D1*Ddd*f**2*r - 860*D1*Ddd*f**2*s**2 + 1352*D1*Ddd*f**2*s - 707*D1*Ddd*f**2 + 66*D1*bd1*(D1*(f*(r + s - 1)*(C*(3*r + 7*s - 3) + 2*r - 2*s - 2) - fd*(2*C - 2)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7)) + Dd*f*(2 - 2*C)*(20*r**2 + r*(56*s - 39) + 36*s**2 - 53*s + 19)) - 3324*Dd**2*f**2*r**2 - 5904*Dd**2*f**2*r*s + 4614*Dd**2*f**2*r - 2580*Dd**2*f**2*s**2 + 4056*Dd**2*f**2*s - 1414*Dd**2*f**2))/(231*d**2*k3**5) - D1**2*Pk1*Pkd3*ct**2*k2**4*st**2*(-20878*C*D1**2*bd1*f**2*r**2 - 28028*C*D1**2*bd1*f**2*r*s + 44616*C*D1**2*bd1*f**2*r - 7150*C*D1**2*bd1*f**2*s**2 + 30888*C*D1**2*bd1*f**2*s - 22308*C*D1**2*bd1*f**2 - 66924*C*D1**2*f**2*fd*r**2 - 92664*C*D1**2*f**2*fd*r*s + 75504*C*D1**2*f**2*fd*r - 25740*C*D1**2*f**2*fd*s**2 + 48048*C*D1**2*f**2*fd*s - 30888*C*D1**2*f**2*fd - 89232*C*D1*Dd*f**3*r**2 - 123552*C*D1*Dd*f**3*r*s + 106392*C*D1*Dd*f**3*r - 34320*C*D1*Dd*f**3*s**2 + 65208*C*D1*Dd*f**3*s - 39468*C*D1*Dd*f**3 - 10868*D1**2*K*bd1**2*f*r**2 - 11440*D1**2*K*bd1**2*f*r*s + 18018*D1**2*K*bd1**2*f*r - 572*D1**2*K*bd1**2*f*s**2 + 7722*D1**2*K*bd1**2*f*s - 7150*D1**2*K*bd1**2*f + 19305*D1**2*K*bd1*f**2*r**2 + 31174*D1**2*K*bd1*f**2*r*s - 31174*D1**2*K*bd1*f**2*r + 11869*D1**2*K*bd1*f**2*s**2 - 23738*D1**2*K*bd1*f**2*s + 11869*D1**2*K*bd1*f**2 - 47476*D1**2*K*bd1*f*fd*r**2 - 74360*D1**2*K*bd1*f*fd*r*s + 60918*D1**2*K*bd1*f*fd*r - 26884*D1**2*K*bd1*f*fd*s**2 + 45474*D1**2*K*bd1*f*fd*s - 18590*D1**2*K*bd1*f*fd - 11869*D1**2*K*bdd1*f**2*r**2 - 18590*D1**2*K*bdd1*f**2*r*s + 18590*D1**2*K*bdd1*f**2*r - 6721*D1**2*K*bdd1*f**2*s**2 + 13442*D1**2*K*bdd1*f**2*s - 6721*D1**2*K*bdd1*f**2 + 63492*D1**2*bd1**2*f**2*r**2 + 130416*D1**2*bd1**2*f**2*r*s - 111540*D1**2*bd1**2*f**2*r + 66924*D1**2*bd1**2*f**2*s**2 - 114972*D1**2*bd1**2*f**2*s + 48048*D1**2*bd1**2*f**2 + 16016*D1**2*bd1**2*f*r**2 + 25168*D1**2*bd1**2*f*r*s - 30030*D1**2*bd1**2*f*r + 9152*D1**2*bd1**2*f*s**2 - 23166*D1**2*bd1**2*f*s + 14014*D1**2*bd1**2*f + 20020*D1**2*bd1**2*g2*r**2 + 40040*D1**2*bd1**2*g2*r*s - 20020*D1**2*bd1**2*g2*r + 20020*D1**2*bd1**2*g2*s**2 - 20020*D1**2*bd1**2*g2*s - 8580*D1**2*bd1*bd2*f*r**2 - 17160*D1**2*bd1*bd2*f*r*s + 17160*D1**2*bd1*bd2*f*r - 8580*D1**2*bd1*bd2*f*s**2 + 17160*D1**2*bd1*bd2*f*s - 8580*D1**2*bd1*bd2*f - 35308*D1**2*bd1*f**3*r**2 - 51636*D1**2*bd1*f**3*r*s + 40404*D1**2*bd1*f**3*r - 16328*D1**2*bd1*f**3*s**2 + 21424*D1**2*bd1*f**3*s - 20306*D1**2*bd1*f**3 + 116220*D1**2*bd1*f**2*fd*r**2 + 108576*D1**2*bd1*f**2*fd*r*s - 110188*D1**2*bd1*f**2*fd*r - 7644*D1**2*bd1*f**2*fd*s**2 - 6968*D1**2*bd1*f**2*fd*s - 4420*D1**2*bd1*f**2*fd - 5005*D1**2*bd1*f**2*r**2 - 16874*D1**2*bd1*f**2*r*s + 2002*D1**2*bd1*f**2*r - 11869*D1**2*bd1*f**2*s**2 + 8866*D1**2*bd1*f**2*s + 1573*D1**2*bd1*f**2 + 57772*D1**2*bd1*f*fd*r**2 + 101816*D1**2*bd1*f*fd*r*s - 79794*D1**2*bd1*f*fd*r + 44044*D1**2*bd1*f*fd*s**2 - 69498*D1**2*bd1*f*fd*s + 25454*D1**2*bd1*f*fd - 35750*D1**2*bd1*f*g2*r**2 - 58916*D1**2*bd1*f*g2*r*s + 77220*D1**2*bd1*f*g2*r - 23166*D1**2*bd1*f*g2*s**2 + 64636*D1**2*bd1*f*g2*s - 38610*D1**2*bd1*f*g2 + 21736*D1**2*bd1*f*gd2*r**2 + 22880*D1**2*bd1*f*gd2*r*s - 36036*D1**2*bd1*f*gd2*r + 1144*D1**2*bd1*f*gd2*s**2 - 15444*D1**2*bd1*f*gd2*s + 14300*D1**2*bd1*f*gd2 + 21736*D1**2*bd1*fd*g2*r**2 + 22880*D1**2*bd1*fd*g2*r*s - 21736*D1**2*bd1*fd*g2*r + 1144*D1**2*bd1*fd*g2*s**2 - 11440*D1**2*bd1*fd*g2*s + 8580*D1**2*bd2*f**2*r**2 + 17160*D1**2*bd2*f**2*r*s - 17160*D1**2*bd2*f**2*r + 8580*D1**2*bd2*f**2*s**2 - 17160*D1**2*bd2*f**2*s + 8580*D1**2*bd2*f**2 - 17160*D1**2*bd2*f*fd*r**2 - 34320*D1**2*bd2*f*fd*r*s + 25740*D1**2*bd2*f*fd*r - 17160*D1**2*bd2*f*fd*s**2 + 25740*D1**2*bd2*f*fd*s - 8580*D1**2*bd2*f*fd + 19370*D1**2*bdd1*f**3*r**2 + 18096*D1**2*bdd1*f**3*r*s - 17628*D1**2*bdd1*f**3*r - 1274*D1**2*bdd1*f**3*s**2 + 3016*D1**2*bdd1*f**3*s + 8008*D1**2*bdd1*f**3 + 14443*D1**2*bdd1*f**2*r**2 + 25454*D1**2*bdd1*f**2*r*s - 25454*D1**2*bdd1*f**2*r + 11011*D1**2*bdd1*f**2*s**2 - 22022*D1**2*bdd1*f**2*s + 11011*D1**2*bdd1*f**2 + 10868*D1**2*bdd1*f*g2*r**2 + 11440*D1**2*bdd1*f*g2*r*s - 24596*D1**2*bdd1*f*g2*r + 572*D1**2*bdd1*f*g2*s**2 - 14300*D1**2*bdd1*f*g2*s + 12298*D1**2*bdd1*f*g2 - 4290*D1**2*bdd2*f**2*r**2 - 8580*D1**2*bdd2*f**2*r*s + 8580*D1**2*bdd2*f**2*r - 4290*D1**2*bdd2*f**2*s**2 + 8580*D1**2*bdd2*f**2*s - 4290*D1**2*bdd2*f**2 + 38040*D1**2*f**3*fd*r**2 + 118640*D1**2*f**3*fd*r*s - 78340*D1**2*f**3*fd*r + 80600*D1**2*f**3*fd*s**2 - 110260*D1**2*f**3*fd*s + 49810*D1**2*f**3*fd - 54120*D1**2*f**3*fdd*r**2 - 150320*D1**2*f**3*fdd*r*s + 102220*D1**2*f**3*fdd*r - 96200*D1**2*f**3*fdd*s**2 + 133780*D1**2*f**3*fdd*s - 61630*D1**2*f**3*fdd - 162360*D1**2*f**2*fd**2*r**2 - 450960*D1**2*f**2*fd**2*r*s + 306660*D1**2*f**2*fd**2*r - 288600*D1**2*f**2*fd**2*s**2 + 401340*D1**2*f**2*fd**2*s - 123260*D1**2*f**2*fd**2 + 61776*D1**2*f**2*fd*r**2 + 87516*D1**2*f**2*fd*r*s - 70356*D1**2*f**2*fd*r + 25740*D1**2*f**2*fd*s**2 - 46332*D1**2*f**2*fd*s + 29172*D1**2*f**2*fd - 38610*D1**2*f**2*gd2*r**2 - 62348*D1**2*f**2*gd2*r*s + 62348*D1**2*f**2*gd2*r - 23738*D1**2*f**2*gd2*s**2 + 47476*D1**2*f**2*gd2*s - 23738*D1**2*f**2*gd2 + 23738*D1**2*f**2*gdd2*r**2 + 37180*D1**2*f**2*gdd2*r*s - 37180*D1**2*f**2*gdd2*r + 13442*D1**2*f**2*gdd2*s**2 - 26884*D1**2*f**2*gdd2*s + 13442*D1**2*f**2*gdd2 - 77220*D1**2*f*fd*g2*r**2 - 124696*D1**2*f*fd*g2*r*s + 77220*D1**2*f*fd*g2*r - 47476*D1**2*f*fd*g2*s**2 + 62348*D1**2*f*fd*g2*s - 38610*D1**2*f*fd*g2 + 94952*D1**2*f*fd*gd2*r**2 + 148720*D1**2*f*fd*gd2*r*s - 121836*D1**2*f*fd*gd2*r + 53768*D1**2*f*fd*gd2*s**2 - 90948*D1**2*f*fd*gd2*s + 37180*D1**2*f*fd*gd2 + 47476*D1**2*f*fdd*g2*r**2 + 74360*D1**2*f*fdd*g2*r*s - 47476*D1**2*f*fdd*g2*r + 26884*D1**2*f*fdd*g2*s**2 - 37180*D1**2*f*fdd*g2*s + 23738*D1**2*f*fdd*g2 + 47476*D1**2*fd**2*g2*r**2 + 74360*D1**2*fd**2*g2*r*s - 47476*D1**2*fd**2*g2*r + 26884*D1**2*fd**2*g2*s**2 - 37180*D1**2*fd**2*g2*s - 94952*D1*Dd*K*bd1*f**2*r**2 - 148720*D1*Dd*K*bd1*f**2*r*s + 135278*D1*Dd*K*bd1*f**2*r - 53768*D1*Dd*K*bd1*f**2*s**2 + 99242*D1*Dd*K*bd1*f**2*s - 45474*D1*Dd*K*bd1*f**2 + 154960*D1*Dd*bd1*f**3*r**2 + 144768*D1*Dd*bd1*f**3*r*s - 145444*D1*Dd*bd1*f**3*r - 10192*D1*Dd*bd1*f**3*s**2 - 936*D1*Dd*bd1*f**3*s + 11596*D1*Dd*bd1*f**3 + 115544*D1*Dd*bd1*f**2*r**2 + 203632*D1*Dd*bd1*f**2*r*s - 181610*D1*Dd*bd1*f**2*r + 88088*D1*Dd*bd1*f**2*s**2 - 157586*D1*Dd*bd1*f**2*s + 69498*D1*Dd*bd1*f**2 + 86944*D1*Dd*bd1*f*g2*r**2 + 91520*D1*Dd*bd1*f*g2*r*s - 143000*D1*Dd*bd1*f*g2*r + 4576*D1*Dd*bd1*f*g2*s**2 - 70928*D1*Dd*bd1*f*g2*s + 53196*D1*Dd*bd1*f*g2 - 34320*D1*Dd*bd2*f**2*r**2 - 68640*D1*Dd*bd2*f**2*r*s + 60060*D1*Dd*bd2*f**2*r - 34320*D1*Dd*bd2*f**2*s**2 + 60060*D1*Dd*bd2*f**2*s - 25740*D1*Dd*bd2*f**2 + 38040*D1*Dd*f**4*r**2 + 118640*D1*Dd*f**4*r*s - 78340*D1*Dd*f**4*r + 80600*D1*Dd*f**4*s**2 - 110260*D1*Dd*f**4*s + 49810*D1*Dd*f**4 - 432960*D1*Dd*f**3*fd*r**2 - 1202560*D1*Dd*f**3*fd*r*s + 817760*D1*Dd*f**3*fd*r - 769600*D1*Dd*f**3*fd*s**2 + 1070240*D1*Dd*f**3*fd*s - 369780*D1*Dd*f**3*fd + 82368*D1*Dd*f**3*r**2 + 116688*D1*Dd*f**3*r*s - 99528*D1*Dd*f**3*r + 34320*D1*Dd*f**3*s**2 - 63492*D1*Dd*f**3*s + 37752*D1*Dd*f**3 - 154440*D1*Dd*f**2*g2*r**2 - 249392*D1*Dd*f**2*g2*r*s + 201916*D1*Dd*f**2*g2*r - 94952*D1*Dd*f**2*g2*s**2 + 157300*D1*Dd*f**2*g2*s - 86086*D1*Dd*f**2*g2 + 189904*D1*Dd*f**2*gd2*r**2 + 297440*D1*Dd*f**2*gd2*r*s - 270556*D1*Dd*f**2*gd2*r + 107536*D1*Dd*f**2*gd2*s**2 - 198484*D1*Dd*f**2*gd2*s + 90948*D1*Dd*f**2*gd2 + 379808*D1*Dd*f*fd*g2*r**2 + 594880*D1*Dd*f*fd*g2*r*s - 433576*D1*Dd*f*fd*g2*r + 215072*D1*Dd*f*fd*g2*s**2 - 330616*D1*Dd*f*fd*g2*s + 121836*D1*Dd*f*fd*g2 - 54120*D1*Ddd*f**4*r**2 - 150320*D1*Ddd*f**4*r*s + 102220*D1*Ddd*f**4*r - 96200*D1*Ddd*f**4*s**2 + 133780*D1*Ddd*f**4*s - 61630*D1*Ddd*f**4 + 94952*D1*Ddd*f**2*g2*r**2 + 148720*D1*Ddd*f**2*g2*r*s - 121836*D1*Ddd*f**2*g2*r + 53768*D1*Ddd*f**2*g2*s**2 - 90948*D1*Ddd*f**2*g2*s + 50622*D1*Ddd*f**2*g2 - 162360*Dd**2*f**4*r**2 - 450960*Dd**2*f**4*r*s + 306660*Dd**2*f**4*r - 288600*Dd**2*f**4*s**2 + 401340*Dd**2*f**4*s - 123260*Dd**2*f**4 + 284856*Dd**2*f**2*g2*r**2 + 446160*Dd**2*f**2*g2*r*s - 365508*Dd**2*f**2*g2*r + 161304*Dd**2*f**2*g2*s**2 - 272844*Dd**2*f**2*g2*s + 101244*Dd**2*f**2*g2 + 715*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (7*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(7*K + 6*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(7*K + 6*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 143*b1**2*(-70*C*D1**2*fd*r**2 - 140*C*D1**2*fd*r*s + 140*C*D1**2*fd*r - 70*C*D1**2*fd*s**2 + 140*C*D1**2*fd*s - 70*C*D1**2*fd - 280*C*D1*Dd*f*r**2 - 560*C*D1*Dd*f*r*s + 420*C*D1*Dd*f*r - 280*C*D1*Dd*f*s**2 + 420*C*D1*Dd*f*s - 210*C*D1*Dd*f + 125*D1**2*K*fd*r**2 + 206*D1**2*K*fd*r*s + 20*D1**2*K*fd*r + 81*D1**2*K*fd*s**2 + 20*D1**2*K*fd*s - 10*D1**2*K*fd - 38*D1**2*K*fdd*r**2 - 40*D1**2*K*fdd*r*s - 10*D1**2*K*fdd*r - 2*D1**2*K*fdd*s**2 - 10*D1**2*K*fdd*s + 5*D1**2*K*fdd - 5*D1**2*bdd1*(7*K + 6*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 660*D1**2*f*fd*r**2 - 1344*D1**2*f*fd*r*s + 852*D1**2*f*fd*r - 684*D1**2*f*fd*s**2 + 864*D1**2*f*fd*s - 432*D1**2*f*fd + 444*D1**2*f*fdd*r**2 + 912*D1**2*f*fdd*r*s - 576*D1**2*f*fdd*r + 468*D1**2*f*fdd*s**2 - 588*D1**2*f*fdd*s + 294*D1**2*f*fdd + 444*D1**2*fd**2*r**2 + 912*D1**2*fd**2*r*s - 576*D1**2*fd**2*r + 468*D1**2*fd**2*s**2 - 588*D1**2*fd**2*s + 120*D1**2*fd**2 - 161*D1**2*fd*r**2 - 302*D1**2*fd*r*s - 160*D1**2*fd*r - 141*D1**2*fd*s**2 - 160*D1**2*fd*s + 80*D1**2*fd + 56*D1**2*fdd*r**2 + 88*D1**2*fdd*r*s + 10*D1**2*fdd*r + 32*D1**2*fdd*s**2 + 10*D1**2*fdd*s - 5*D1**2*fdd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 + 70*D1**2*gdd2*r**2 + 140*D1**2*gdd2*r*s - 140*D1**2*gdd2*r + 70*D1**2*gdd2*s**2 - 140*D1**2*gdd2*s + 70*D1**2*gdd2 + 500*D1*Dd*K*f*r**2 + 824*D1*Dd*K*f*r*s - 662*D1*Dd*K*f*r + 324*D1*Dd*K*f*s**2 - 530*D1*Dd*K*f*s + 287*D1*Dd*K*f - 304*D1*Dd*K*fd*r**2 - 320*D1*Dd*K*fd*r*s + 116*D1*Dd*K*fd*r - 16*D1*Dd*K*fd*s**2 + 8*D1*Dd*K*fd*s + 30*D1*Dd*K*fd - 1320*D1*Dd*f**2*r**2 - 2688*D1*Dd*f**2*r*s + 2004*D1*Dd*f**2*r - 1368*D1*Dd*f**2*s**2 + 2040*D1*Dd*f**2*s - 1014*D1*Dd*f**2 + 3552*D1*Dd*f*fd*r**2 + 7296*D1*Dd*f*fd*r*s - 5016*D1*Dd*f*fd*r + 3744*D1*Dd*f*fd*s**2 - 5136*D1*Dd*f*fd*s + 1752*D1*Dd*f*fd - 644*D1*Dd*f*r**2 - 1208*D1*Dd*f*r*s + 926*D1*Dd*f*r - 564*D1*Dd*f*s**2 + 866*D1*Dd*f*s - 443*D1*Dd*f + 448*D1*Dd*fd*r**2 + 704*D1*Dd*fd*r*s - 248*D1*Dd*fd*r + 256*D1*Dd*fd*s**2 - 176*D1*Dd*fd*s - 30*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 + 1120*D1*Dd*gd2*r*s - 980*D1*Dd*gd2*r + 560*D1*Dd*gd2*s**2 - 980*D1*Dd*gd2*s + 420*D1*Dd*gd2 - 152*D1*Ddd*K*f*r**2 - 160*D1*Ddd*K*f*r*s + 156*D1*Ddd*K*f*r - 8*D1*Ddd*K*f*s**2 + 48*D1*Ddd*K*f*s - 42*D1*Ddd*K*f + 888*D1*Ddd*f**2*r**2 + 1824*D1*Ddd*f**2*r*s - 1356*D1*Ddd*f**2*r + 936*D1*Ddd*f**2*s**2 - 1392*D1*Ddd*f**2*s + 690*D1*Ddd*f**2 + 224*D1*Ddd*f*r**2 + 352*D1*Ddd*f*r*s - 288*D1*Ddd*f*r + 128*D1*Ddd*f*s**2 - 216*D1*Ddd*f*s + 120*D1*Ddd*f + 280*D1*Ddd*g2*r**2 + 560*D1*Ddd*g2*r*s - 420*D1*Ddd*g2*r + 280*D1*Ddd*g2*s**2 - 420*D1*Ddd*g2*s + 210*D1*Ddd*g2 + 10*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (7*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(7*K + 6*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 456*Dd**2*K*f*r**2 - 480*Dd**2*K*f*r*s + 468*Dd**2*K*f*r - 24*Dd**2*K*f*s**2 + 144*Dd**2*K*f*s - 84*Dd**2*K*f + 2664*Dd**2*f**2*r**2 + 5472*Dd**2*f**2*r*s - 4068*Dd**2*f**2*r + 2808*Dd**2*f**2*s**2 - 4176*Dd**2*f**2*s + 1380*Dd**2*f**2 + 672*Dd**2*f*r**2 + 1056*Dd**2*f*r*s - 864*Dd**2*f*r + 384*Dd**2*f*s**2 - 648*Dd**2*f*s + 240*Dd**2*f + 840*Dd**2*g2*r**2 + 1680*Dd**2*g2*r*s - 1260*Dd**2*g2*r + 840*Dd**2*g2*s**2 - 1260*Dd**2*g2*s + 420*Dd**2*g2) - 13*b1*(3212*C*D1**2*f*fd*r**2 + 4312*C*D1**2*f*fd*r*s - 1936*C*D1**2*f*fd*r + 1100*C*D1**2*f*fd*s**2 - 880*C*D1**2*f*fd*s + 440*C*D1**2*f*fd + 6424*C*D1*Dd*f**2*r**2 + 8624*C*D1*Dd*f**2*r*s - 7524*C*D1*Dd*f**2*r + 2200*C*D1*Dd*f**2*s**2 - 4356*C*D1*Dd*f**2*s + 2706*C*D1*Dd*f**2 + 836*D1**2*K*bdd1*f*r**2 + 880*D1**2*K*bdd1*f*r*s - 1386*D1**2*K*bdd1*f*r + 44*D1**2*K*bdd1*f*s**2 - 594*D1**2*K*bdd1*f*s + 495*D1**2*K*bdd1*f - 2970*D1**2*K*f*fd*r**2 - 4796*D1**2*K*f*fd*r*s + 2970*D1**2*K*f*fd*r - 1826*D1**2*K*f*fd*s**2 + 2398*D1**2*K*f*fd*s - 1485*D1**2*K*f*fd + 1826*D1**2*K*f*fdd*r**2 + 2860*D1**2*K*f*fdd*r*s - 1826*D1**2*K*f*fdd*r + 1034*D1**2*K*f*fdd*s**2 - 1430*D1**2*K*f*fdd*s + 913*D1**2*K*f*fdd + 1826*D1**2*K*fd**2*r**2 + 2860*D1**2*K*fd**2*r*s - 1826*D1**2*K*fd**2*r + 1034*D1**2*K*fd**2*s**2 - 1430*D1**2*K*fd**2*s - 660*D1**2*b2*fd*r**2 - 1320*D1**2*b2*fd*r*s - 660*D1**2*b2*fd*s**2 + 330*D1**2*b2*fdd*r**2 + 660*D1**2*b2*fdd*r*s + 330*D1**2*b2*fdd*s**2 + 110*D1**2*bd1**2*(7*K + 6*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 4884*D1**2*bdd1*f**2*r**2 - 10032*D1**2*bdd1*f**2*r*s + 8580*D1**2*bdd1*f**2*r - 5148*D1**2*bdd1*f**2*s**2 + 8844*D1**2*bdd1*f**2*s - 4356*D1**2*bdd1*f**2 - 1232*D1**2*bdd1*f*r**2 - 1936*D1**2*bdd1*f*r*s + 2310*D1**2*bdd1*f*r - 704*D1**2*bdd1*f*s**2 + 1782*D1**2*bdd1*f*s - 1023*D1**2*bdd1*f - 1540*D1**2*bdd1*g2*r**2 - 3080*D1**2*bdd1*g2*r*s + 1540*D1**2*bdd1*g2*r - 1540*D1**2*bdd1*g2*s**2 + 1540*D1**2*bdd1*g2*s - 770*D1**2*bdd1*g2 + 330*D1**2*bdd2*f*r**2 + 660*D1**2*bdd2*f*r*s - 660*D1**2*bdd2*f*r + 330*D1**2*bdd2*f*s**2 - 660*D1**2*bdd2*f*s + 330*D1**2*bdd2*f + 8148*D1**2*f**2*fd*r**2 + 11916*D1**2*f**2*fd*r*s - 10268*D1**2*f**2*fd*r + 3768*D1**2*f**2*fd*s**2 - 7348*D1**2*f**2*fd*s + 3666*D1**2*f**2*fd - 4470*D1**2*f**2*fdd*r**2 - 4176*D1**2*f**2*fdd*r*s + 4408*D1**2*f**2*fdd*r + 294*D1**2*f**2*fdd*s**2 + 1232*D1**2*f**2*fdd*s - 678*D1**2*f**2*fdd - 8940*D1**2*f*fd**2*r**2 - 8352*D1**2*f*fd**2*r*s + 8816*D1**2*f*fd**2*r + 588*D1**2*f*fd**2*s**2 + 2464*D1**2*f*fd**2*s - 2928*D1**2*f*fd**2 + 770*D1**2*f*fd*r**2 + 2596*D1**2*f*fd*r*s - 1914*D1**2*f*fd*r + 1826*D1**2*f*fd*s**2 - 2442*D1**2*f*fd*s + 1419*D1**2*f*fd - 2222*D1**2*f*fdd*r**2 - 3916*D1**2*f*fdd*r*s + 2222*D1**2*f*fdd*r - 1694*D1**2*f*fdd*s**2 + 1958*D1**2*f*fdd*s - 1111*D1**2*f*fdd + 2750*D1**2*f*gd2*r**2 + 4532*D1**2*f*gd2*r*s - 4532*D1**2*f*gd2*r + 1782*D1**2*f*gd2*s**2 - 3564*D1**2*f*gd2*s + 1782*D1**2*f*gd2 - 836*D1**2*f*gdd2*r**2 - 880*D1**2*f*gdd2*r*s + 880*D1**2*f*gdd2*r - 44*D1**2*f*gdd2*s**2 + 88*D1**2*f*gdd2*s - 44*D1**2*f*gdd2 - 2222*D1**2*fd**2*r**2 - 3916*D1**2*fd**2*r*s + 2222*D1**2*fd**2*r - 1694*D1**2*fd**2*s**2 + 1958*D1**2*fd**2*s + 2750*D1**2*fd*g2*r**2 + 4532*D1**2*fd*g2*r*s + 440*D1**2*fd*g2*r + 1782*D1**2*fd*g2*s**2 + 440*D1**2*fd*g2*s - 220*D1**2*fd*g2 - 1672*D1**2*fd*gd2*r**2 - 1760*D1**2*fd*gd2*r*s + 660*D1**2*fd*gd2*r - 88*D1**2*fd*gd2*s**2 - 132*D1**2*fd*gd2*s + 220*D1**2*fd*gd2 - 836*D1**2*fdd*g2*r**2 - 880*D1**2*fdd*g2*r*s - 220*D1**2*fdd*g2*r - 44*D1**2*fdd*g2*s**2 - 220*D1**2*fdd*g2*s + 110*D1**2*fdd*g2 - 5940*D1*Dd*K*f**2*r**2 - 9592*D1*Dd*K*f**2*r*s + 7766*D1*Dd*K*f**2*r - 3652*D1*Dd*K*f**2*s**2 + 6050*D1*Dd*K*f**2*s - 3311*D1*Dd*K*f**2 + 14608*D1*Dd*K*f*fd*r**2 + 22880*D1*Dd*K*f*fd*r*s - 16676*D1*Dd*K*f*fd*r + 8272*D1*Dd*K*f*fd*s**2 - 12716*D1*Dd*K*f*fd*s + 4686*D1*Dd*K*f*fd - 2640*D1*Dd*b2*f*r**2 - 5280*D1*Dd*b2*f*r*s + 3960*D1*Dd*b2*f*r - 2640*D1*Dd*b2*f*s**2 + 3960*D1*Dd*b2*f*s - 1980*D1*Dd*b2*f + 2640*D1*Dd*b2*fd*r**2 + 5280*D1*Dd*b2*fd*r*s - 1980*D1*Dd*b2*fd*r + 2640*D1*Dd*b2*fd*s**2 - 1980*D1*Dd*b2*fd*s + 10864*D1*Dd*f**3*r**2 + 15888*D1*Dd*f**3*r*s - 13376*D1*Dd*f**3*r + 5024*D1*Dd*f**3*s**2 - 8996*D1*Dd*f**3*s + 5228*D1*Dd*f**3 - 35760*D1*Dd*f**2*fd*r**2 - 33408*D1*Dd*f**2*fd*r*s + 34924*D1*Dd*f**2*fd*r + 2352*D1*Dd*f**2*fd*s**2 + 7928*D1*Dd*f**2*fd*s - 6872*D1*Dd*f**2*fd + 1540*D1*Dd*f**2*r**2 + 5192*D1*Dd*f**2*r*s - 3366*D1*Dd*f**2*r + 3652*D1*Dd*f**2*s**2 - 4950*D1*Dd*f**2*s + 2211*D1*Dd*f**2 - 17776*D1*Dd*f*fd*r**2 - 31328*D1*Dd*f*fd*r*s + 21164*D1*Dd*f*fd*r - 13552*D1*Dd*f*fd*s**2 + 18524*D1*Dd*f*fd*s - 6138*D1*Dd*f*fd + 11000*D1*Dd*f*g2*r**2 + 18128*D1*Dd*f*g2*r*s - 14564*D1*Dd*f*g2*r + 7128*D1*Dd*f*g2*s**2 - 11660*D1*Dd*f*g2*s + 6314*D1*Dd*f*g2 - 6688*D1*Dd*f*gd2*r**2 - 7040*D1*Dd*f*gd2*r*s + 6952*D1*Dd*f*gd2*r - 352*D1*Dd*f*gd2*s**2 + 1408*D1*Dd*f*gd2*s - 1056*D1*Dd*f*gd2 - 6688*D1*Dd*fd*g2*r**2 - 7040*D1*Dd*fd*g2*r*s + 2552*D1*Dd*fd*g2*r - 352*D1*Dd*fd*g2*s**2 + 176*D1*Dd*fd*g2*s + 660*D1*Dd*fd*g2 + 3652*D1*Ddd*K*f**2*r**2 + 5720*D1*Ddd*K*f**2*r*s - 4686*D1*Ddd*K*f**2*r + 2068*D1*Ddd*K*f**2*s**2 - 3498*D1*Ddd*K*f**2*s + 1947*D1*Ddd*K*f**2 + 1320*D1*Ddd*b2*f*r**2 + 2640*D1*Ddd*b2*f*r*s - 1980*D1*Ddd*b2*f*r + 1320*D1*Ddd*b2*f*s**2 - 1980*D1*Ddd*b2*f*s + 990*D1*Ddd*b2*f - 5960*D1*Ddd*f**3*r**2 - 5568*D1*Ddd*f**3*r*s + 5764*D1*Ddd*f**3*r + 392*D1*Ddd*f**3*s**2 + 1000*D1*Ddd*f**3*s - 1294*D1*Ddd*f**3 - 4444*D1*Ddd*f**2*r**2 - 7832*D1*Ddd*f**2*r*s + 6138*D1*Ddd*f**2*r - 3388*D1*Ddd*f**2*s**2 + 5346*D1*Ddd*f**2*s - 2805*D1*Ddd*f**2 - 3344*D1*Ddd*f*g2*r**2 - 3520*D1*Ddd*f*g2*r*s + 3432*D1*Ddd*f*g2*r - 176*D1*Ddd*f*g2*s**2 + 1056*D1*Ddd*f*g2*s - 924*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(3*f**2*(110*r**2 + 32*r*(7*s - 6) + 114*s**2 - 196*s + 97) + f*(35*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 125*K*r**2 - 206*K*r*s + 238*K*r - 81*K*s**2 + 194*K*s - 108*K - 6*fd*(148*r**2 + 304*r*s - 226*r + 156*s**2 - 232*s + 77) + 161*r**2 + 302*r*s - 392*r + 141*s**2 - 372*s + 191) + fd*(K*(76*r**2 + r*(80*s - 53) + 4*s**2 - 17*s - 5) - 112*r**2 + r*(95 - 176*s) - 64*s**2 + 71*s + 5) + 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 70*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - Dd*(6*f**2*(296*r**2 + r*(608*s - 486) + 312*s**2 - 500*s + 199) + f*(-K*(304*r**2 + 8*r*(40*s - 51) + 16*s**2 - 156*s + 117) + 448*r**2 + 704*r*s - 708*r + 256*s**2 - 540*s + 267) + 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 660*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 10956*Dd**2*K*f**2*r**2 + 17160*Dd**2*K*f**2*r*s - 14058*Dd**2*K*f**2*r + 6204*Dd**2*K*f**2*s**2 - 10494*Dd**2*K*f**2*s + 3894*Dd**2*K*f**2 + 3960*Dd**2*b2*f*r**2 + 7920*Dd**2*b2*f*r*s - 5940*Dd**2*b2*f*r + 3960*Dd**2*b2*f*s**2 - 5940*Dd**2*b2*f*s + 1980*Dd**2*b2*f - 17880*Dd**2*f**3*r**2 - 16704*Dd**2*f**3*r*s + 17292*Dd**2*f**3*r + 1176*Dd**2*f**3*s**2 + 3000*Dd**2*f**3*s - 2588*Dd**2*f**3 - 13332*Dd**2*f**2*r**2 - 23496*Dd**2*f**2*r*s + 18414*Dd**2*f**2*r - 10164*Dd**2*f**2*s**2 + 16038*Dd**2*f**2*s - 5610*Dd**2*f**2 - 10032*Dd**2*f*g2*r**2 - 10560*Dd**2*f*g2*r*s + 10296*Dd**2*f*g2*r - 528*Dd**2*f*g2*s**2 + 3168*Dd**2*f*g2*s - 1848*Dd**2*f*g2) + 4290*b2*(-D1**2*bdd1*f*(r + s - 1)**2 + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd*s - 6*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 2*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2))/(6006*d**2*k3**5) - 4*D1**2*Pk1*Pkd3*ct**2*k2**2*st**4*(11*D1*b1*(-2*bd1*(C - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) - f*(D1*(2*bdd1*s*(C - 1)*(2*r + 2*s - 1) + fd*(2*r*s - r + 2*s**2 - 2*s + 1)) + Dd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2))) + 22*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-11*bd1*s*(r + s - 1) + fd*(20*C - 20)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(10*C - 10)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - (2*C - 2)*(11*bd1**2*s*(2*r + 2*s - 1) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1))) + D1*f*(10*C - 10)*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(10 - 10*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(77*d**2*k3**3) - D1**2*Pk1*Pkd3*ct**2*k2**2*st**2*(11*b1**2*(D1**2*(fd*(83*C*r + 15*C*(s - 1) - 78*r - 22*s + 22) + fdd*(-31*C*r + 17*C*(s - 1) + 25*r - 17*s + 17))*(r + s - 1) + D1*(Dd*(f*(C*(332*r**2 + 392*r*s - 362*r + 60*s**2 - 158*s + 113) - 312*r**2 - 400*r*s + 356*r - 88*s**2 + 188*s - 122) - 2*fd*(C*(124*r**2 + 56*r*s - 73*r - 68*s**2 + 95*s - 27) - 100*r**2 - 32*r*s + 49*r + 68*s**2 - 98*s + 30)) + Ddd*f*(C*(-124*r**2 - 56*r*s + 90*r + 68*s**2 - 54*s + 3) + 100*r**2 + 32*r*s - 66*r - 68*s**2 + 60*s - 9)) - 6*Dd**2*f*(C*(62*r**2 + r*(28*s - 45) - 34*s**2 + 27*s - 1) - 50*r**2 + r*(33 - 16*s) + 34*s**2 - 30*s + 3)) + 11*b1*(82*C*D1**2*f*fd*r**2 + 28*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*r - 54*C*D1**2*f*fd*s**2 - 44*C*D1**2*f*fd*s + 32*C*D1**2*f*fd - 18*C*D1**2*f*fdd*r**2 + 44*C*D1**2*f*fdd*r*s + 56*C*D1**2*f*fdd*r + 62*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd - 18*C*D1**2*fd**2*r**2 + 44*C*D1**2*fd**2*r*s + 56*C*D1**2*fd**2*r + 62*C*D1**2*fd**2*s**2 - 62*C*D1**2*fd**2 + 164*C*D1*Dd*f**2*r**2 + 56*C*D1*Dd*f**2*r*s - 110*C*D1*Dd*f**2*r - 108*C*D1*Dd*f**2*s**2 + 94*C*D1*Dd*f**2*s - 13*C*D1*Dd*f**2 - 144*C*D1*Dd*f*fd*r**2 + 352*C*D1*Dd*f*fd*r*s + 172*C*D1*Dd*f*fd*r + 496*C*D1*Dd*f*fd*s**2 - 292*C*D1*Dd*f*fd*s - 56*C*D1*Dd*f*fd - 36*C*D1*Ddd*f**2*r**2 + 88*C*D1*Ddd*f**2*r*s - 26*C*D1*Ddd*f**2*r + 124*C*D1*Ddd*f**2*s**2 - 146*C*D1*Ddd*f**2*s + 53*C*D1*Ddd*f**2 - 108*C*Dd**2*f**2*r**2 + 264*C*Dd**2*f**2*r*s - 78*C*Dd**2*f**2*r + 372*C*Dd**2*f**2*s**2 - 438*C*Dd**2*f**2*s + 106*C*Dd**2*f**2 + D1**2*bdd1*f*(C*(-62*r**2 - 28*r*s + 62*r + 34*s**2 + 14*s - 31) + 50*r**2 + 16*r*s - 50*r - 34*s**2 - 8*s + 25) - 48*D1**2*f*fd*r**2 + 68*D1**2*f*fd*r*s + 66*D1**2*f*fd*r + 116*D1**2*f*fd*s**2 - 28*D1**2*f*fd*s + 8*D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 104*D1**2*f*fdd*r*s - 14*D1**2*f*fdd*r - 110*D1**2*f*fdd*s**2 + 54*D1**2*f*fdd*s - 22*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 104*D1**2*fd**2*r*s - 14*D1**2*fd**2*r - 110*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s + 56*D1**2*fd**2 - 96*D1*Dd*f**2*r**2 + 136*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r + 232*D1*Dd*f**2*s**2 - 266*D1*Dd*f**2*s + 92*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 832*D1*Dd*f*fd*r*s + 140*D1*Dd*f*fd*r - 880*D1*Dd*f*fd*s**2 + 760*D1*Dd*f*fd*s - 94*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 - 208*D1*Ddd*f**2*r*s + 98*D1*Ddd*f**2*r - 220*D1*Ddd*f**2*s**2 + 272*D1*Ddd*f**2*s - 107*D1*Ddd*f**2 + D1*bd1*(D1*(f*(C*(166*r**2 + 2*r*(98*s - 83) + 30*s**2 - 98*s + 83) - 156*r**2 - 4*r*(50*s - 39) - 44*s**2 + 100*s - 78) + 2*fd*(-C*(62*r**2 + 28*r*s - 45*r - 34*s**2 + 27*s + 7) + 50*r**2 + 16*r*s - 33*r - 34*s**2 + 30*s + 4)) + 2*Dd*f*(-C*(248*r**2 + 112*r*s - 214*r - 136*s**2 + 26*s + 45) + 200*r**2 + 64*r*s - 166*r - 136*s**2 + 44*s + 33)) + 36*Dd**2*f**2*r**2 - 624*Dd**2*f**2*r*s + 294*Dd**2*f**2*r - 660*Dd**2*f**2*s**2 + 816*Dd**2*f**2*s - 214*Dd**2*f**2) + f*(-22*D1**2*bd1**2*(r**2*(31*C - 25) + r*(14*C*s - 31*C - 8*s + 25) + s*(-17*C*s - 7*C + 17*s + 4)) - 11*D1**2*bdd1*f*(C*(9*r**2 - 22*r*s + 60*r - 31*s**2 + 84*s - 30) - 3*r**2 + 52*r*s - 60*r + 55*s**2 - 108*s + 30) - 2*D1**2*(f*(fd*(3*C*(159*r**2 + 522*r*s - 280*r + 363*s**2 - 416*s + 174) - 597*r**2 - 2037*r*s + 1077*r - 1440*s**2 + 1639*s - 679) - 3*fdd*(3*C*(87*r**2 + 6*r*(31*s - 20) + 99*s**2 - 128*s + 62) - 237*r**2 - 642*r*s + 372*r - 405*s**2 + 484*s - 214)) - 6*fd**2*(3*C*(87*r**2 + 6*r*(31*s - 20) + 99*s**2 - 128*s + 31) - 237*r**2 - 642*r*s + 372*r - 405*s**2 + 484*s - 107)) + 11*D1*bd1*(D1*(f*(C*(41*r**2 + 14*r*s + 36*r - 27*s**2 + 84*s - 18) - 24*r**2 + 34*r*s - 52*r + 58*s**2 - 122*s + 26) - 2*fd*(2*C*(9*r**2 - 22*r*s + 16*r - 31*s**2 + 42*s - 21) - 6*r**2 + 104*r*s - 53*r + 110*s**2 - 135*s + 54)) + 2*Dd*f*(C*(-36*r**2 + 88*r*s - 133*r + 124*s**2 - 241*s + 114) + 12*r**2 - 208*r*s + 169*r - 220*s**2 + 352*s - 138)) - 2*D1*f*(Dd*(f*(3*C*(212*r**2 + 696*r*s - 454*r + 484*s**2 - 658*s + 295) - 796*r**2 - 2716*r*s + 1756*r - 1920*s**2 + 2599*s - 1159) - 6*fd*(3*C*(348*r**2 + 744*r*s - 513*r + 396*s**2 - 547*s + 188) - 948*r**2 - 2568*r*s + 1623*r - 1620*s**2 + 2099*s - 670)) - 3*Ddd*f*(3*C*(116*r**2 + 248*r*s - 182*r + 132*s**2 - 194*s + 95) - 316*r**2 - 856*r*s + 586*r - 540*s**2 + 754*s - 349)) + 12*Dd**2*f**2*(3*C*(174*r**2 + 372*r*s - 273*r + 198*s**2 - 291*s + 95) - 474*r**2 - 1284*r*s + 879*r - 810*s**2 + 1131*s - 349)))/(231*d**2*k3**3) + D1**2*Pk1*Pkd3*ct**2*k2**2*(1980*C*D1**2*bd1*f**2*r**2 + 2376*C*D1**2*bd1*f**2*r*s + 396*C*D1**2*bd1*f**2*s**2 + 924*D1**2*K*bd1**2*f*r**2 + 1056*D1**2*K*bd1**2*f*r*s + 1782*D1**2*K*bd1**2*f*r + 132*D1**2*K*bd1**2*f*s**2 + 2178*D1**2*K*bd1**2*f*s - 2310*D1**2*K*bd1**2*f + 1386*D1**2*K*bd1*f**2*r**2 + 1980*D1**2*K*bd1*f**2*r*s - 1980*D1**2*K*bd1*f**2*r + 594*D1**2*K*bd1*f**2*s**2 - 1188*D1**2*K*bd1*f**2*s + 594*D1**2*K*bd1*f**2 - 5544*D1**2*K*bd1*f*fd*r**2 - 9504*D1**2*K*bd1*f*fd*r*s + 7524*D1**2*K*bd1*f*fd*r - 3960*D1**2*K*bd1*f*fd*s**2 + 6336*D1**2*K*bd1*f*fd*s - 2376*D1**2*K*bd1*f*fd - 1386*D1**2*K*bdd1*f**2*r**2 - 2376*D1**2*K*bdd1*f**2*r*s + 2376*D1**2*K*bdd1*f**2*r - 990*D1**2*K*bdd1*f**2*s**2 + 1980*D1**2*K*bdd1*f**2*s - 990*D1**2*K*bdd1*f**2 + 660*D1**2*bd1**2*f**2*r**2 + 8712*D1**2*bd1**2*f**2*r*s - 4884*D1**2*bd1**2*f**2*r + 8052*D1**2*bd1**2*f**2*s**2 - 10560*D1**2*bd1**2*f**2*s + 4356*D1**2*bd1**2*f**2 - 330*D1**2*bd1**2*f*r**2 + 3828*D1**2*bd1**2*f*r*s - 4158*D1**2*bd1**2*f*r + 4158*D1**2*bd1**2*f*s**2 - 8778*D1**2*bd1**2*f*s + 4620*D1**2*bd1**2*f - 4620*D1**2*bd1**2*g2*r**2 - 9240*D1**2*bd1**2*g2*r*s + 4620*D1**2*bd1**2*g2*r - 4620*D1**2*bd1**2*g2*s**2 + 4620*D1**2*bd1**2*g2*s - 1914*D1**2*bd1*bd2*f*r**2 - 3828*D1**2*bd1*bd2*f*r*s + 4224*D1**2*bd1*bd2*f*r - 1914*D1**2*bd1*bd2*f*s**2 + 4224*D1**2*bd1*bd2*f*s - 2310*D1**2*bd1*bd2*f - 1435*D1**2*bd1*f**3*r**2 - 4900*D1**2*bd1*f**3*r*s + 3180*D1**2*bd1*f**3*r - 3465*D1**2*bd1*f**3*s**2 + 3960*D1**2*bd1*f**3*s - 1980*D1**2*bd1*f**3 + 9750*D1**2*bd1*f**2*fd*r**2 + 36480*D1**2*bd1*f**2*fd*r*s - 23210*D1**2*bd1*f**2*fd*r + 26730*D1**2*bd1*f**2*fd*s**2 - 34460*D1**2*bd1*f**2*fd*s + 9180*D1**2*bd1*f**2*fd - 2574*D1**2*bd1*f**2*r**2 - 4752*D1**2*bd1*f**2*r*s + 2772*D1**2*bd1*f**2*r - 2178*D1**2*bd1*f**2*s**2 + 3564*D1**2*bd1*f**2*s - 1584*D1**2*bd1*f**2 + 5544*D1**2*bd1*f*fd*r**2 + 17424*D1**2*bd1*f*fd*r*s - 11484*D1**2*bd1*f*fd*r + 11880*D1**2*bd1*f*fd*s**2 - 16236*D1**2*bd1*f*fd*s + 4356*D1**2*bd1*f*fd + 3696*D1**2*bd1*f*g2*r**2 + 3960*D1**2*bd1*f*g2*r*s + 2772*D1**2*bd1*f*g2*r + 264*D1**2*bd1*f*g2*s**2 + 2772*D1**2*bd1*f*g2*s - 1386*D1**2*bd1*f*g2 - 1848*D1**2*bd1*f*gd2*r**2 - 2112*D1**2*bd1*f*gd2*r*s - 3564*D1**2*bd1*f*gd2*r - 264*D1**2*bd1*f*gd2*s**2 - 4356*D1**2*bd1*f*gd2*s + 4620*D1**2*bd1*f*gd2 - 1848*D1**2*bd1*fd*g2*r**2 - 2112*D1**2*bd1*fd*g2*r*s + 1848*D1**2*bd1*fd*g2*r - 264*D1**2*bd1*fd*g2*s**2 + 1056*D1**2*bd1*fd*g2*s + 1386*D1**2*bd2*f**2*r**2 + 1980*D1**2*bd2*f**2*r*s - 1980*D1**2*bd2*f**2*r + 594*D1**2*bd2*f**2*s**2 - 1188*D1**2*bd2*f**2*s + 594*D1**2*bd2*f**2 - 5544*D1**2*bd2*f*fd*r**2 - 9504*D1**2*bd2*f*fd*r*s + 7524*D1**2*bd2*f*fd*r - 3960*D1**2*bd2*f*fd*s**2 + 6336*D1**2*bd2*f*fd*s - 2376*D1**2*bd2*f*fd + 1625*D1**2*bdd1*f**3*r**2 + 6080*D1**2*bdd1*f**3*r*s - 3900*D1**2*bdd1*f**3*r + 4455*D1**2*bdd1*f**3*s**2 - 5280*D1**2*bdd1*f**3*s + 2640*D1**2*bdd1*f**3 + 1386*D1**2*bdd1*f**2*r**2 + 4356*D1**2*bdd1*f**2*r*s - 4356*D1**2*bdd1*f**2*r + 2970*D1**2*bdd1*f**2*s**2 - 5940*D1**2*bdd1*f**2*s + 2970*D1**2*bdd1*f**2 - 924*D1**2*bdd1*f*g2*r**2 - 1056*D1**2*bdd1*f*g2*r*s - 4620*D1**2*bdd1*f*g2*r - 132*D1**2*bdd1*f*g2*s**2 - 4620*D1**2*bdd1*f*g2*s + 2310*D1**2*bdd1*f*g2 - 1386*D1**2*bdd2*f**2*r**2 - 2376*D1**2*bdd2*f**2*r*s + 2376*D1**2*bdd2*f**2*r - 990*D1**2*bdd2*f**2*s**2 + 1980*D1**2*bdd2*f**2*s - 990*D1**2*bdd2*f**2 + 990*D1**2*f**2*fd*r**2 + 990*D1**2*f**2*fd*r*s - 990*D1**2*f**2*fd*r - 330*D1**2*f**2*fd*s + 330*D1**2*f**2*fd - 2772*D1**2*f**2*gd2*r**2 - 3960*D1**2*f**2*gd2*r*s + 3960*D1**2*f**2*gd2*r - 1188*D1**2*f**2*gd2*s**2 + 2376*D1**2*f**2*gd2*s - 1188*D1**2*f**2*gd2 + 2772*D1**2*f**2*gdd2*r**2 + 4752*D1**2*f**2*gdd2*r*s - 4752*D1**2*f**2*gdd2*r + 1980*D1**2*f**2*gdd2*s**2 - 3960*D1**2*f**2*gdd2*s + 1980*D1**2*f**2*gdd2 - 5544*D1**2*f*fd*g2*r**2 - 7920*D1**2*f*fd*g2*r*s + 5544*D1**2*f*fd*g2*r - 2376*D1**2*f*fd*g2*s**2 + 3960*D1**2*f*fd*g2*s - 2772*D1**2*f*fd*g2 + 11088*D1**2*f*fd*gd2*r**2 + 19008*D1**2*f*fd*gd2*r*s - 15048*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 12672*D1**2*f*fd*gd2*s + 4752*D1**2*f*fd*gd2 + 5544*D1**2*f*fdd*g2*r**2 + 9504*D1**2*f*fdd*g2*r*s - 5544*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 4752*D1**2*f*fdd*g2*s + 2772*D1**2*f*fdd*g2 + 5544*D1**2*fd**2*g2*r**2 + 9504*D1**2*fd**2*g2*r*s - 5544*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 4752*D1**2*fd**2*g2*s - 11088*D1*Dd*K*bd1*f**2*r**2 - 19008*D1*Dd*K*bd1*f**2*r*s + 17028*D1*Dd*K*bd1*f**2*r - 7920*D1*Dd*K*bd1*f**2*s**2 + 14256*D1*Dd*K*bd1*f**2*s - 6336*D1*Dd*K*bd1*f**2 + 13000*D1*Dd*bd1*f**3*r**2 + 48640*D1*Dd*bd1*f**3*r*s - 31010*D1*Dd*bd1*f**3*r + 35640*D1*Dd*bd1*f**3*s**2 - 45020*D1*Dd*bd1*f**3*s + 14460*D1*Dd*bd1*f**3 + 11088*D1*Dd*bd1*f**2*r**2 + 34848*D1*Dd*bd1*f**2*r*s - 28908*D1*Dd*bd1*f**2*r + 23760*D1*Dd*bd1*f**2*s**2 - 39996*D1*Dd*bd1*f**2*s + 16236*D1*Dd*bd1*f**2 - 7392*D1*Dd*bd1*f*g2*r**2 - 8448*D1*Dd*bd1*f*g2*r*s - 14520*D1*Dd*bd1*f*g2*r - 1056*D1*Dd*bd1*f*g2*s**2 - 16896*D1*Dd*bd1*f*g2*s + 13860*D1*Dd*bd1*f*g2 - 11088*D1*Dd*bd2*f**2*r**2 - 19008*D1*Dd*bd2*f**2*r*s + 17028*D1*Dd*bd2*f**2*r - 7920*D1*Dd*bd2*f**2*s**2 + 14256*D1*Dd*bd2*f**2*s - 6336*D1*Dd*bd2*f**2 + 1320*D1*Dd*f**3*r**2 + 1320*D1*Dd*f**3*r*s - 1320*D1*Dd*f**3*r - 330*D1*Dd*f**3*s + 330*D1*Dd*f**3 - 11088*D1*Dd*f**2*g2*r**2 - 15840*D1*Dd*f**2*g2*r*s + 13464*D1*Dd*f**2*g2*r - 4752*D1*Dd*f**2*g2*s**2 + 8712*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 22176*D1*Dd*f**2*gd2*r**2 + 38016*D1*Dd*f**2*gd2*r*s - 34056*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 28512*D1*Dd*f**2*gd2*s + 12672*D1*Dd*f**2*gd2 + 44352*D1*Dd*f*fd*g2*r**2 + 76032*D1*Dd*f*fd*g2*r*s - 52272*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 44352*D1*Dd*f*fd*g2*s + 15048*D1*Dd*f*fd*g2 + 11088*D1*Ddd*f**2*g2*r**2 + 19008*D1*Ddd*f**2*g2*r*s - 15048*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 12672*D1*Ddd*f**2*g2*s + 6732*D1*Ddd*f**2*g2 + 33264*Dd**2*f**2*g2*r**2 + 57024*Dd**2*f**2*g2*r*s - 45144*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 38016*Dd**2*f**2*g2*s + 13464*Dd**2*f**2*g2 + 33*b1**3*(D1**2*(r + s - 1)*(17*fd*r + 31*fd*(s - 1) + fdd*(-33*r - 47*s + 47)) + D1*(Dd*(-70*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(68*r**2 + 2*r*(96*s - 65) + 124*s**2 - 172*s + 79) - 2*fd*(132*r**2 + 320*r*s - 273*r + 188*s**2 - 322*s + 134) + 224*r**2 + 56*r*(10*s - 7) + 336*s**2 - 476*s + 224) - Ddd*(-35*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(132*r**2 + r*(320*s - 226) + 188*s**2 - 268*s + 127) + 112*r**2 + 280*r*s - 196*r + 168*s**2 - 238*s + 112)) - 2*Dd**2*(-105*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(198*r**2 + r*(480*s - 339) + 282*s**2 - 402*s + 127) + 168*r**2 + 420*r*s - 294*r + 252*s**2 - 357*s + 112)) + 33*b1**2*(70*C*D1**2*fd*r**2 + 84*C*D1**2*fd*r*s - 84*C*D1**2*fd*r + 14*C*D1**2*fd*s**2 - 28*C*D1**2*fd*s + 14*C*D1**2*fd + 280*C*D1*Dd*f*r**2 + 336*C*D1*Dd*f*r*s - 308*C*D1*Dd*f*r + 56*C*D1*Dd*f*s**2 - 140*C*D1*Dd*f*s + 98*C*D1*Dd*f + 105*D1**2*K*bdd1*r**2 + 210*D1**2*K*bdd1*r*s - 140*D1**2*K*bdd1*r + 105*D1**2*K*bdd1*s**2 - 140*D1**2*K*bdd1*s + 70*D1**2*K*bdd1 - 56*D1**2*K*fd*r**2 - 60*D1**2*K*fd*r*s + 154*D1**2*K*fd*r - 4*D1**2*K*fd*s**2 + 102*D1**2*K*fd*s - 77*D1**2*K*fd + 14*D1**2*K*fdd*r**2 + 16*D1**2*K*fdd*r*s - 98*D1**2*K*fdd*r + 2*D1**2*K*fdd*s**2 - 86*D1**2*K*fdd*s + 49*D1**2*K*fdd - 99*D1**2*bdd1*f*r**2 - 240*D1**2*bdd1*f*r*s + 146*D1**2*bdd1*f*r - 141*D1**2*bdd1*f*s**2 + 174*D1**2*bdd1*f*s - 80*D1**2*bdd1*f - 84*D1**2*bdd1*r**2 - 210*D1**2*bdd1*r*s + 126*D1**2*bdd1*r - 126*D1**2*bdd1*s**2 + 154*D1**2*bdd1*s - 70*D1**2*bdd1 + 7*D1**2*bdd2*r**2 + 14*D1**2*bdd2*r*s - 14*D1**2*bdd2*r + 7*D1**2*bdd2*s**2 - 14*D1**2*bdd2*s + 7*D1**2*bdd2 + 8*D1**2*f*fd*r**2 - 192*D1**2*f*fd*r*s + 92*D1**2*f*fd*r - 200*D1**2*f*fd*s**2 + 252*D1**2*f*fd*s - 124*D1**2*f*fd + 20*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 136*D1**2*f*fdd*r + 244*D1**2*f*fdd*s**2 - 300*D1**2*f*fdd*s + 152*D1**2*f*fdd + 20*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 136*D1**2*fd**2*r + 244*D1**2*fd**2*s**2 - 300*D1**2*fd**2*s + 56*D1**2*fd**2 - 32*D1**2*fd*r**2 - 88*D1**2*fd*r*s - 30*D1**2*fd*r - 56*D1**2*fd*s**2 - 52*D1**2*fd*s + 36*D1**2*fd - 5*D1**2*fdd*r**2 + 58*D1**2*fdd*r*s + 78*D1**2*fdd*r + 63*D1**2*fdd*s**2 + 82*D1**2*fdd*s - 39*D1**2*fdd + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 - 224*D1*Dd*K*f*r**2 - 240*D1*Dd*K*f*r*s + 232*D1*Dd*K*f*r - 16*D1*Dd*K*f*s**2 + 76*D1*Dd*K*f*s - 64*D1*Dd*K*f + 112*D1*Dd*K*fd*r**2 + 128*D1*Dd*K*fd*r*s - 452*D1*Dd*K*fd*r + 16*D1*Dd*K*fd*s**2 - 368*D1*Dd*K*fd*s + 270*D1*Dd*K*fd - 56*D1*Dd*b2*r**2 - 112*D1*Dd*b2*r*s + 84*D1*Dd*b2*r - 56*D1*Dd*b2*s**2 + 84*D1*Dd*b2*s - 42*D1*Dd*b2 + 16*D1*Dd*f**2*r**2 - 384*D1*Dd*f**2*r*s + 184*D1*Dd*f**2*r - 400*D1*Dd*f**2*s**2 + 496*D1*Dd*f**2*s - 196*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 1112*D1*Dd*f*fd*r + 1952*D1*Dd*f*fd*s**2 - 2440*D1*Dd*f*fd*s + 736*D1*Dd*f*fd - 128*D1*Dd*f*r**2 - 352*D1*Dd*f*r*s + 240*D1*Dd*f*r - 224*D1*Dd*f*s**2 + 312*D1*Dd*f*s - 144*D1*Dd*f - 40*D1*Dd*fd*r**2 + 464*D1*Dd*fd*r*s + 206*D1*Dd*fd*r + 504*D1*Dd*fd*s**2 + 18*D1*Dd*fd*s - 242*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 + 56*D1*Ddd*K*f*r**2 + 64*D1*Ddd*K*f*r*s - 60*D1*Ddd*K*f*r + 8*D1*Ddd*K*f*s**2 - 24*D1*Ddd*K*f*s + 18*D1*Ddd*K*f + 28*D1*Ddd*b2*r**2 + 56*D1*Ddd*b2*r*s - 42*D1*Ddd*b2*r + 28*D1*Ddd*b2*s**2 - 42*D1*Ddd*b2*s + 21*D1*Ddd*b2 + 40*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 284*D1*Ddd*f**2*r + 488*D1*Ddd*f**2*s**2 - 620*D1*Ddd*f**2*s + 254*D1*Ddd*f**2 - 20*D1*Ddd*f*r**2 + 232*D1*Ddd*f*r*s - 106*D1*Ddd*f*r + 252*D1*Ddd*f*s**2 - 310*D1*Ddd*f*s + 121*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 + D1*bd1*(D1*(-70*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(51*r**2 + 2*r*(72*s - 41) + 93*s**2 - 110*s + 48) - 2*fd*(99*r**2 + 240*r*s - 193*r + 141*s**2 - 228*s + 87) + 168*r**2 + 84*r*(5*s - 3) + 252*s**2 - 308*s + 140) - 2*Dd*(-35*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(396*r**2 + r*(960*s - 631) + 564*s**2 - 750*s + 247) + 336*r**2 + 840*r*s - 546*r + 504*s**2 - 665*s + 217)) - 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) + 168*Dd**2*K*f*r**2 + 192*Dd**2*K*f*r*s - 180*Dd**2*K*f*r + 24*Dd**2*K*f*s**2 - 72*Dd**2*K*f*s + 36*Dd**2*K*f + 84*Dd**2*b2*r**2 + 168*Dd**2*b2*r*s - 126*Dd**2*b2*r + 84*Dd**2*b2*s**2 - 126*Dd**2*b2*s + 42*Dd**2*b2 + 120*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 852*Dd**2*f**2*r + 1464*Dd**2*f**2*s**2 - 1860*Dd**2*f**2*s + 508*Dd**2*f**2 - 60*Dd**2*f*r**2 + 696*Dd**2*f*r*s - 318*Dd**2*f*r + 756*Dd**2*f*s**2 - 930*Dd**2*f*s + 242*Dd**2*f - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) + b1*(3960*C*D1**2*f*fd*r**2 + 4752*C*D1**2*f*fd*r*s - 6336*C*D1**2*f*fd*r + 792*C*D1**2*f*fd*s**2 - 3168*C*D1**2*f*fd*s + 2376*C*D1**2*f*fd + 7920*C*D1*Dd*f**2*r**2 + 9504*C*D1*Dd*f**2*r*s - 8712*C*D1*Dd*f**2*r + 1584*C*D1*Dd*f**2*s**2 - 3960*C*D1*Dd*f**2*s + 2772*C*D1*Dd*f**2 + 924*D1**2*K*bdd1*f*r**2 + 1056*D1**2*K*bdd1*f*r*s + 1782*D1**2*K*bdd1*f*r + 132*D1**2*K*bdd1*f*s**2 + 2178*D1**2*K*bdd1*f*s - 1089*D1**2*K*bdd1*f + 2772*D1**2*K*f*fd*r**2 + 3960*D1**2*K*f*fd*r*s - 2772*D1**2*K*f*fd*r + 1188*D1**2*K*f*fd*s**2 - 1980*D1**2*K*f*fd*s + 1386*D1**2*K*f*fd - 2772*D1**2*K*f*fdd*r**2 - 4752*D1**2*K*f*fdd*r*s + 2772*D1**2*K*f*fdd*r - 1980*D1**2*K*f*fdd*s**2 + 2376*D1**2*K*f*fdd*s - 1386*D1**2*K*f*fdd - 2772*D1**2*K*fd**2*r**2 - 4752*D1**2*K*fd**2*r*s + 2772*D1**2*K*fd**2*r - 1980*D1**2*K*fd**2*s**2 + 2376*D1**2*K*fd**2*s - 66*D1**2*bd1**2*(-35*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(99*r**2 + 2*r*(120*s - 73) + 141*s**2 - 174*s + 40) + 84*r**2 + 210*r*s - 126*r + 126*s**2 - 154*s + 35) + 297*D1**2*bd2*f*r**2 + 594*D1**2*bd2*f*r*s - 594*D1**2*bd2*f*r + 297*D1**2*bd2*f*s**2 - 594*D1**2*bd2*f*s + 297*D1**2*bd2*f - 1914*D1**2*bd2*fd*r**2 - 3828*D1**2*bd2*fd*r*s + 1518*D1**2*bd2*fd*r - 1914*D1**2*bd2*fd*s**2 + 1518*D1**2*bd2*fd*s + 396*D1**2*bd2*fd + 660*D1**2*bdd1*f**2*r**2 + 8712*D1**2*bdd1*f**2*r*s - 4884*D1**2*bdd1*f**2*r + 8052*D1**2*bdd1*f**2*s**2 - 10560*D1**2*bdd1*f**2*s + 3366*D1**2*bdd1*f**2 - 330*D1**2*bdd1*f*r**2 + 3828*D1**2*bdd1*f*r*s - 4158*D1**2*bdd1*f*r + 4158*D1**2*bdd1*f*s**2 - 8778*D1**2*bdd1*f*s + 3201*D1**2*bdd1*f - 4620*D1**2*bdd1*g2*r**2 - 9240*D1**2*bdd1*g2*r*s + 4620*D1**2*bdd1*g2*r - 4620*D1**2*bdd1*g2*s**2 + 4620*D1**2*bdd1*g2*s - 2310*D1**2*bdd1*g2 - 957*D1**2*bdd2*f*r**2 - 1914*D1**2*bdd2*f*r*s + 1914*D1**2*bdd2*f*r - 957*D1**2*bdd2*f*s**2 + 1914*D1**2*bdd2*f*s - 957*D1**2*bdd2*f - 4305*D1**2*f**2*fd*r**2 - 14700*D1**2*f**2*fd*r*s + 9490*D1**2*f**2*fd*r - 10395*D1**2*f**2*fd*s**2 + 14800*D1**2*f**2*fd*s - 6385*D1**2*f**2*fd + 4875*D1**2*f**2*fdd*r**2 + 18240*D1**2*f**2*fdd*r*s - 11510*D1**2*f**2*fdd*r + 13365*D1**2*f**2*fdd*s**2 - 18620*D1**2*f**2*fdd*s + 7895*D1**2*f**2*fdd + 9750*D1**2*f*fd**2*r**2 + 36480*D1**2*f*fd**2*r*s - 23020*D1**2*f*fd**2*r + 26730*D1**2*f*fd**2*s**2 - 37240*D1**2*f*fd**2*s + 11890*D1**2*f*fd**2 - 5148*D1**2*f*fd*r**2 - 9504*D1**2*f*fd*r*s + 7128*D1**2*f*fd*r - 4356*D1**2*f*fd*s**2 + 5544*D1**2*f*fd*s - 3168*D1**2*f*fd + 2772*D1**2*f*fdd*r**2 + 8712*D1**2*f*fdd*r*s - 2772*D1**2*f*fdd*r + 5940*D1**2*f*fdd*s**2 - 4356*D1**2*f*fdd*s + 1386*D1**2*f*fdd + 3696*D1**2*f*gd2*r**2 + 3960*D1**2*f*gd2*r*s - 3960*D1**2*f*gd2*r + 264*D1**2*f*gd2*s**2 - 528*D1**2*f*gd2*s + 264*D1**2*f*gd2 - 924*D1**2*f*gdd2*r**2 - 1056*D1**2*f*gdd2*r*s + 1056*D1**2*f*gdd2*r - 132*D1**2*f*gdd2*s**2 + 264*D1**2*f*gdd2*s - 132*D1**2*f*gdd2 + 2772*D1**2*fd**2*r**2 + 8712*D1**2*fd**2*r*s - 2772*D1**2*fd**2*r + 5940*D1**2*fd**2*s**2 - 4356*D1**2*fd**2*s + 3696*D1**2*fd*g2*r**2 + 3960*D1**2*fd*g2*r*s - 10164*D1**2*fd*g2*r + 264*D1**2*fd*g2*s**2 - 6732*D1**2*fd*g2*s + 5082*D1**2*fd*g2 - 1848*D1**2*fd*gd2*r**2 - 2112*D1**2*fd*gd2*r*s + 7524*D1**2*fd*gd2*r - 264*D1**2*fd*gd2*s**2 + 5940*D1**2*fd*gd2*s - 5676*D1**2*fd*gd2 - 924*D1**2*fdd*g2*r**2 - 1056*D1**2*fdd*g2*r*s + 6468*D1**2*fdd*g2*r - 132*D1**2*fdd*g2*s**2 + 5676*D1**2*fdd*g2*s - 3234*D1**2*fdd*g2 + 5544*D1*Dd*K*f**2*r**2 + 7920*D1*Dd*K*f**2*r*s - 6732*D1*Dd*K*f**2*r + 2376*D1*Dd*K*f**2*s**2 - 4356*D1*Dd*K*f**2*s + 2574*D1*Dd*K*f**2 - 22176*D1*Dd*K*f*fd*r**2 - 38016*D1*Dd*K*f*fd*r*s + 26136*D1*Dd*K*f*fd*r - 15840*D1*Dd*K*f*fd*s**2 + 22176*D1*Dd*K*f*fd*s - 7524*D1*Dd*K*f*fd - 7656*D1*Dd*bd2*f*r**2 - 15312*D1*Dd*bd2*f*r*s + 13398*D1*Dd*bd2*f*r - 7656*D1*Dd*bd2*f*s**2 + 13398*D1*Dd*bd2*f*s - 5742*D1*Dd*bd2*f - 5740*D1*Dd*f**3*r**2 - 19600*D1*Dd*f**3*r*s + 12670*D1*Dd*f**3*r - 13860*D1*Dd*f**3*s**2 + 18760*D1*Dd*f**3*s - 8365*D1*Dd*f**3 + 39000*D1*Dd*f**2*fd*r**2 + 145920*D1*Dd*f**2*fd*r*s - 92270*D1*Dd*f**2*fd*r + 106920*D1*Dd*f**2*fd*s**2 - 146180*D1*Dd*f**2*fd*s + 48750*D1*Dd*f**2*fd - 10296*D1*Dd*f**2*r**2 - 19008*D1*Dd*f**2*r*s + 14652*D1*Dd*f**2*r - 8712*D1*Dd*f**2*s**2 + 13464*D1*Dd*f**2*s - 6930*D1*Dd*f**2 + 22176*D1*Dd*f*fd*r**2 + 69696*D1*Dd*f*fd*r*s - 34056*D1*Dd*f*fd*r + 47520*D1*Dd*f*fd*s**2 - 49896*D1*Dd*f*fd*s + 11484*D1*Dd*f*fd + 14784*D1*Dd*f*g2*r**2 + 15840*D1*Dd*f*g2*r*s - 15312*D1*Dd*f*g2*r + 1056*D1*Dd*f*g2*s**2 - 5016*D1*Dd*f*g2*s + 4224*D1*Dd*f*g2 - 7392*D1*Dd*f*gd2*r**2 - 8448*D1*Dd*f*gd2*r*s + 8184*D1*Dd*f*gd2*r - 1056*D1*Dd*f*gd2*s**2 + 2640*D1*Dd*f*gd2*s - 1584*D1*Dd*f*gd2 - 7392*D1*Dd*fd*g2*r**2 - 8448*D1*Dd*fd*g2*r*s + 29832*D1*Dd*fd*g2*r - 1056*D1*Dd*fd*g2*s**2 + 24288*D1*Dd*fd*g2*s - 17820*D1*Dd*fd*g2 - 5544*D1*Ddd*K*f**2*r**2 - 9504*D1*Ddd*K*f**2*r*s + 7524*D1*Ddd*K*f**2*r - 3960*D1*Ddd*K*f**2*s**2 + 6336*D1*Ddd*K*f**2*s - 3366*D1*Ddd*K*f**2 + 6500*D1*Ddd*f**3*r**2 + 24320*D1*Ddd*f**3*r*s - 15410*D1*Ddd*f**3*r + 17820*D1*Ddd*f**3*s**2 - 23900*D1*Ddd*f**3*s + 10535*D1*Ddd*f**3 + 5544*D1*Ddd*f**2*r**2 + 17424*D1*Ddd*f**2*r*s - 11484*D1*Ddd*f**2*r + 11880*D1*Ddd*f**2*s**2 - 16236*D1*Ddd*f**2*s + 7326*D1*Ddd*f**2 - 3696*D1*Ddd*f*g2*r**2 - 4224*D1*Ddd*f*g2*r*s + 3960*D1*Ddd*f*g2*r - 528*D1*Ddd*f*g2*s**2 + 1584*D1*Ddd*f*g2*s - 1188*D1*Ddd*f*g2 + 33*D1*bd1*(14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(4*f**2*(2*r**2 + r*(23 - 48*s) - 50*s**2 + 61*s - 18) + f*(14*C*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) - 112*K*r**2 - 120*K*r*s + 18*K*r - 8*K*s**2 - 34*K*s + 17*K + 8*fd*(10*r**2 + 132*r*s - 71*r + 122*s**2 - 155*s + 40) - 64*r**2 - 176*r*s + 182*r - 112*s**2 + 252*s - 124) + 2*fd*(K*(28*r**2 + 32*r*s - 71*r + 4*s**2 - 53*s + 43) - 10*r**2 + 116*r*s + 15*r + 126*s**2 - 51*s - 41) + 140*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 140*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(2*f**2*(40*r**2 + r*(528*s - 290) + 488*s**2 - 630*s + 197) + f*(K*(112*r**2 + 16*r*(8*s + 3) + 16*s**2 + 108*s - 93) - 40*r**2 + 464*r*s - 358*r + 504*s**2 - 842*s + 329) - 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 16632*Dd**2*K*f**2*r**2 - 28512*Dd**2*K*f**2*r*s + 22572*Dd**2*K*f**2*r - 11880*Dd**2*K*f**2*s**2 + 19008*Dd**2*K*f**2*s - 6732*Dd**2*K*f**2 + 19500*Dd**2*f**3*r**2 + 72960*Dd**2*f**3*r*s - 46230*Dd**2*f**3*r + 53460*Dd**2*f**3*s**2 - 71700*Dd**2*f**3*s + 21070*Dd**2*f**3 + 16632*Dd**2*f**2*r**2 + 52272*Dd**2*f**2*r*s - 34452*Dd**2*f**2*r + 35640*Dd**2*f**2*s**2 - 48708*Dd**2*f**2*s + 14652*Dd**2*f**2 - 11088*Dd**2*f*g2*r**2 - 12672*Dd**2*f*g2*r*s + 11880*Dd**2*f*g2*r - 1584*Dd**2*f*g2*s**2 + 4752*Dd**2*f*g2*s - 2376*Dd**2*f*g2 - 33*b2*(-7*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 9*D1**2*fd*r**2 - 18*D1**2*fd*r*s - 24*D1**2*fd*r - 9*D1**2*fd*s**2 - 24*D1**2*fd*s + 12*D1**2*fd + 29*D1**2*fdd*r**2 + 58*D1**2*fdd*r*s + 12*D1**2*fdd*r + 29*D1**2*fdd*s**2 + 12*D1**2*fdd*s - 6*D1**2*fdd - 36*D1*Dd*f*r**2 - 72*D1*Dd*f*r*s + 54*D1*Dd*f*r - 36*D1*Dd*f*s**2 + 54*D1*Dd*f*s - 27*D1*Dd*f + 232*D1*Dd*fd*r**2 + 464*D1*Dd*fd*r*s - 126*D1*Dd*fd*r + 232*D1*Dd*fd*s**2 - 126*D1*Dd*fd*s - 36*D1*Dd*fd + 116*D1*Ddd*f*r**2 + 232*D1*Ddd*f*r*s - 174*D1*Ddd*f*r + 116*D1*Ddd*f*s**2 - 174*D1*Ddd*f*s + 87*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 348*Dd**2*f*r**2 + 696*Dd**2*f*r*s - 522*Dd**2*f*r + 348*Dd**2*f*s**2 - 522*Dd**2*f*s + 174*Dd**2*f)) + 33*b2*(14*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - D1**2*bdd1*f*(29*r**2 + r*(58*s - 70) + 29*s**2 - 70*s + 35) + 6*D1**2*(f*(fd*(14*r**2 + 20*r*s - 14*r + 6*s**2 - 10*s + 7) - fdd*(14*r**2 + 24*r*s - 14*r + 10*s**2 - 12*s + 7)) - 2*fd**2*(7*r**2 + r*(12*s - 7) + s*(5*s - 6))) + D1*bd1*(D1*(3*f*(3*r**2 + 2*r*(3*s - 7) + 3*s**2 - 14*s + 7) - 58*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(116*r**2 + r*(232*s - 227) + 116*s**2 - 227*s + 105)) + 6*D1*f*(Dd*(f*(28*r**2 + 40*r*s - 34*r + 12*s**2 - 22*s + 13) - 2*fd*(56*r**2 + 96*r*s - 66*r + 40*s**2 - 56*s + 19)) - Ddd*f*(28*r**2 + r*(48*s - 38) + 20*s**2 - 32*s + 17)) - 12*Dd**2*f**2*(42*r**2 + r*(72*s - 57) + 30*s**2 - 48*s + 17)))/(693*d**2*k3**3) - 2*D1**2*Pk1*Pkd3*ct**2*st**2*(D1*f*(-3*D1*bd1**2*s*(4*C - 3)*(2*r + 2*s - 1) + D1*bd1*(f*s*(24*C - 17)*(r + s) - fd*(12*C - 9)*(r*(4*s - 1) + s*(4*s - 3))) - 3*D1*bdd1*f*s*(4*C - 3)*(r + s) - 3*Dd*bd1*f*(4*C - 3)*(r*(8*s - 2) + s*(8*s - 5))) + b1**2*(D1**2*(s - 1)*(fd*(24*C - 25) + fdd*(9 - 12*C))*(r + s - 1) + D1*(Dd*(f*(24*C - 25)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - fd*(12*C - 9)*(r*(8*s - 6) + 8*s**2 - 13*s + 5)) + Ddd*f*(9 - 12*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*f*(12*C - 9)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(D1**2*(f*fd*(24*C - 17)*(2*s - 1)*(r + s - 1) - f*(12*C - 9)*(bdd1*s*(2*r + 2*s - 1) + fdd*(2*s - 1)*(r + s - 1)) - fd**2*(12*C - 9)*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(f*s*(24*C - 25)*(2*r + 2*s - 1) - fd*(12*C - 9)*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) + Dd*f*(18 - 24*C)*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(f*(24*C - 17)*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(9 - 12*C)*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(9 - 12*C)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + Dd**2*f**2*(9 - 12*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k3) + D1**2*Pk1*Pkd3*ct**2*(-2*D1*f*(D1*bd1**2*(r**2*(14*C - 7) + r*(84*C*s - 14*C - 82*s + 7) + s*(70*C*s - 42*C - 75*s + 41)) + D1*bdd1*f*(r + s)*(10*C*r + 30*C*s - 5*r - 32*s) + bd1*(D1*(-f*(r + s)*(r*(2*C - 1) + s*(42*C - 37)) + fd*(r**2*(40*C - 20) + r*(20*C*(8*s - 3) - 148*s + 47) + s*(20*C*(6*s - 5) - 128*s + 101))) + Dd*f*(r**2*(80*C - 40) + 4*r*(5*C*(16*s - 5) - 74*s + 21) + s*(80*C*(3*s - 2) - 256*s + 165)))) + b1**2*(-D1**2*(fd*(14*C*(r - 7*s + 7) - 7*r + 87*s - 87) + fdd*(14*C*(r + 5*s - 5) - 7*r - 75*s + 75))*(r + s - 1) + D1*(Dd*(f*(-14*C*(4*r**2 - 24*r*s + 10*r - 28*s**2 + 34*s - 13) + 28*r**2 - 320*r*s + 146*r - 348*s**2 + 428*s - 167) + 2*fd*(-14*C*(4*r**2 + 24*r*s - 19*r + 20*s**2 - 33*s + 13) + 28*r**2 + 328*r*s - 253*r + 300*s**2 - 491*s + 191)) + Ddd*f*(-14*C*(4*r**2 + 24*r*s - 14*r + 20*s**2 - 26*s + 11) + 28*r**2 + 328*r*s - 178*r + 300*s**2 - 382*s + 157)) - 2*Dd**2*f*(14*C*(6*r**2 + 36*r*s - 21*r + 30*s**2 - 39*s + 11) - 42*r**2 - 492*r*s + 267*r - 450*s**2 + 573*s - 157)) + b1*(D1**2*bdd1*f*(-14*C*(2*r**2 + 2*r*(6*s - 1) + 10*s**2 - 6*s + 1) + 14*r**2 + 2*r*(82*s - 7) + 150*s**2 - 82*s + 7) + 2*D1**2*(f*(fd*(4*C*(r + 21*s - 11) - 2*r - 74*s + 38) + fdd*(-20*C*(r + 3*s - 2) + 10*r + 64*s - 37)) + fd**2*(-20*C*(r + 3*s - 2) + 10*r + 64*s - 37))*(r + s - 1) + D1*bd1*(D1*(f*(-14*C*(2*r**2 - 2*r*(6*s + 1) - 14*s**2 + 6*s + 1) + 14*r**2 - 2*r*(80*s + 7) - 174*s**2 + 80*s + 7) + 2*fd*(-14*C*(2*r**2 + r*(12*s - 7) + 10*s**2 - 13*s + 3) + 14*r**2 + r*(164*s - 89) + 150*s**2 - 191*s + 41)) - 2*Dd*f*(14*C*(8*r**2 + 6*r*(8*s - 3) + 40*s**2 - 38*s + 7) - 56*r**2 + r*(206 - 656*s) - 600*s**2 + 546*s - 89)) + 2*D1*f*(Dd*(f*(2*C*(4*r**2 + 88*r*s - 46*r + 84*s**2 - 106*s + 43) - 4*r**2 - 152*r*s + 78*r - 148*s**2 + 186*s - 75) + fd*(-20*C*(8*r**2 + 32*r*s - 22*r + 24*s**2 - 36*s + 13) + 80*r**2 + 592*r*s - 356*r + 512*s**2 - 734*s + 249)) + Ddd*f*(-10*C*(4*r**2 + 2*r*(8*s - 5) + 12*s**2 - 16*s + 7) + 20*r**2 + 148*r*s - 84*r + 128*s**2 - 165*s + 69)) + 2*Dd**2*f**2*(-20*C*(6*r**2 + 3*r*(8*s - 5) + 18*s**2 - 24*s + 7) + 60*r**2 + 12*r*(37*s - 21) + 384*s**2 - 495*s + 138)))/(21*d**2*k3) + 2*D1**2*Pk1*Pkd3*ct**2*k2**4*st**2*(D1*f**2*(-33*D1*bd1**2*(4*r**2 + r*(4*s - 5) - 2*s + 1) + D1*(bdd1*f*r*(-2*r - 2*s + 1) + 33*fd*(3*r**2 + 3*r*(s - 1) - s + 1)) + 33*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1) + bd1*(D1*(fd*(-12*r**2 - 2*r*(6*s - 5) + 2*s - 1) + r**2*(70*f + 44) + r*(70*f*s - 35*f + 44*s - 77) - 33*s + 33) + Dd*f*(-16*r**2 - 4*r*(4*s - 3) + 2*s - 1))) + 11*b1**2*(D1**2*r*(3*f*(2*fd - fdd)*(4*r + 4*s - 3) + fd*(-3*fd*(4*r + 4*s - 3) + 7*r + 7*s)) + D1*f*(Dd*(12*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r - 1)*(4*r + 4*s - 3) + 28*r**2 + 28*r*(s - 1) - 7*s + 7) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*f*(-33*D1**2*bdd1*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + 210*D1**2*f*fd*r**2 + 210*D1**2*f*fd*r*s - 245*D1**2*f*fd*r - 70*D1**2*f*fd*s + 70*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s + 7*D1**2*f*fdd*r + 2*D1**2*f*fdd*s - 2*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s + 14*D1**2*fd**2*r + 4*D1**2*fd**2*s - 3*D1**2*fd**2 + 88*D1**2*fd*r**2 + 88*D1**2*fd*r*s - 55*D1**2*fd*r - 11*D1**2*fd*s + 11*D1**2*fd + 280*D1*Dd*f**2*r**2 + 280*D1*Dd*f**2*r*s - 280*D1*Dd*f**2*r - 70*D1*Dd*f**2*s + 70*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s + 52*D1*Dd*f*fd*r + 14*D1*Dd*f*fd*s - 11*D1*Dd*f*fd + 176*D1*Dd*f*r**2 + 176*D1*Dd*f*r*s - 176*D1*Dd*f*r - 44*D1*Dd*f*s + 44*D1*Dd*f - 8*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 8*D1*Ddd*f**2*r + 2*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + 11*D1*bd1*(D1*(6*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 3*fd*(4*r - 1)*(4*r + 4*s - 3) + (14*r - 7)*(r + s - 1)) - 3*Dd*f*(8*r - 3)*(4*r + 4*s - 3)) - 24*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 24*Dd**2*f**2*r + 6*Dd**2*f**2*s - 4*Dd**2*f**2))/(231*d**2*k1**2*k3**3) + 2*D1**2*Pk1*Pkd3*ct**2*k2**2*(2*D1**2*bd1*f*r*(-bd1*(f + 2)*(2*r + 2*s - 1) + 3*f*(r + s)) - D1*b1*(D1*bd1**2*(5*f + 7)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + bd1*(D1*(2*f**2*r*(2*r + 2*s - 1) + f*(2*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - 2*r**2 - 2*r*s + 8*r + 7*s - 7) + 4*fd*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + 2*Dd*f*(f + 2)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1)) - 2*f*(D1*(-bdd1*r*(f + 2)*(2*r + 2*s - 1) + 3*fd*(2*r - 1)*(r + s - 1)) + 3*Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1))) + b1**3*(D1**2*r*(3*fd - 5*fdd)*(r + s - 1) + D1*(Dd*(3*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + 56*r**2 + 56*r*(s - 1) - 14*s + 14) - Ddd*(5*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(5*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(-D1**2*bdd1*(5*f + 7)*(3*r**2 + 3*r*(s - 1) - s + 1) - 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 2*D1**2*f*fd*s - 2*D1**2*f*fd - 4*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r + 2*D1**2*f*fdd*s - 2*D1**2*f*fdd - 4*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 2*D1**2*fd**2*s - 2*D1**2*fd**2 + D1**2*fd*r**2 + D1**2*fd*r*s + 5*D1**2*fd*r + 6*D1**2*fd*s - 6*D1**2*fd - 4*D1**2*fdd*r**2 - 4*D1**2*fdd*r*s + 8*D1**2*fdd*r + 4*D1**2*fdd*s - 4*D1**2*fdd - 8*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r + 2*D1*Dd*f**2*s - 2*D1*Dd*f**2 - 32*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 40*D1*Dd*f*fd*r + 12*D1*Dd*f*fd*s - 10*D1*Dd*f*fd + 4*D1*Dd*f*r**2 + 4*D1*Dd*f*r*s - 4*D1*Dd*f*r - D1*Dd*f*s + D1*Dd*f - 32*D1*Dd*fd*r**2 - 32*D1*Dd*fd*r*s + 48*D1*Dd*fd*r + 20*D1*Dd*fd*s - 16*D1*Dd*fd - 8*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 8*D1*Ddd*f**2*r + 2*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 - 16*D1*Ddd*f*r**2 - 16*D1*Ddd*f*r*s + 16*D1*Ddd*f*r + 4*D1*Ddd*f*s - 4*D1*Ddd*f + D1*bd1*(D1*(f*(9*r**2 + 9*r*(s - 1) - 3*s + 3) - 5*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + 42*r**2 + 42*r*(s - 1) - 14*s + 14) - Dd*(5*f + 7)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 24*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 24*Dd**2*f**2*r + 6*Dd**2*f**2*s - 4*Dd**2*f**2 - 48*Dd**2*f*r**2 - 48*Dd**2*f*r*s + 48*Dd**2*f*r + 12*Dd**2*f*s - 8*Dd**2*f))/(21*d**2*k1**2*k3) + 3*D1**2*Pk1*Pkd3*ct*f*k1**3*k2**3*st**4*(33*D1**2*bd1*f*(8*C - 5)*(r + s - 1)**2 + 33*D1*b1*(8*C - 5)*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + (64*C - 38)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**7) + 4*D1**2*Pk1*Pkd3*ct*f*k1**3*k2*st**4*(D1**2*(f*(11*bd1*s*(2*C - 1)*(r + s - 1) + fd*(28*C - 16)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(14*C - 8)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + fd**2*(8 - 14*C)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*b1*(2*C - 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + D1*f*(14*C - 8)*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(8 - 14*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4))/(77*d**2*k3**5) + 5*D1**2*Pk1*Pkd3*ct*f*k2**7*st**6*(-78*D1**2*b1*f*fd*r**2 - 156*D1**2*b1*f*fd*r*s + 104*D1**2*b1*f*fd*r - 78*D1**2*b1*f*fd*s**2 + 104*D1**2*b1*f*fd*s - 52*D1**2*b1*f*fd + 39*D1**2*b1*f*fdd*r**2 + 78*D1**2*b1*f*fdd*r*s - 52*D1**2*b1*f*fdd*r + 39*D1**2*b1*f*fdd*s**2 - 52*D1**2*b1*f*fdd*s + 26*D1**2*b1*f*fdd + 78*D1**2*b1*fd**2*r**2 + 156*D1**2*b1*fd**2*r*s - 104*D1**2*b1*fd**2*r + 78*D1**2*b1*fd**2*s**2 - 104*D1**2*b1*fd**2*s + 26*D1**2*b1*fd**2 + 13*D1**2*bdd1*f**2*(r + s - 1)**2 + 24*D1**2*f**2*fd*r**2 + 48*D1**2*f**2*fd*r*s - 36*D1**2*f**2*fd*r + 24*D1**2*f**2*fd*s**2 - 36*D1**2*f**2*fd*s + 18*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 - 24*D1**2*f**2*fdd*r*s + 18*D1**2*f**2*fdd*r - 12*D1**2*f**2*fdd*s**2 + 18*D1**2*f**2*fdd*s - 9*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r**2 - 72*D1**2*f*fd**2*r*s + 54*D1**2*f*fd**2*r - 36*D1**2*f*fd**2*s**2 + 54*D1**2*f*fd**2*s - 18*D1**2*f*fd**2 - 104*D1*Dd*b1*f**2*r**2 - 208*D1*Dd*b1*f**2*r*s + 156*D1*Dd*b1*f**2*r - 104*D1*Dd*b1*f**2*s**2 + 156*D1*Dd*b1*f**2*s - 78*D1*Dd*b1*f**2 + 312*D1*Dd*b1*f*fd*r**2 + 624*D1*Dd*b1*f*fd*r*s - 442*D1*Dd*b1*f*fd*r + 312*D1*Dd*b1*f*fd*s**2 - 442*D1*Dd*b1*f*fd*s + 156*D1*Dd*b1*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 - 192*D1*Dd*f**2*fd*r*s + 144*D1*Dd*f**2*fd*r - 96*D1*Dd*f**2*fd*s**2 + 144*D1*Dd*f**2*fd*s - 54*D1*Dd*f**2*fd + 52*D1*Ddd*b1*f**2*r**2 + 104*D1*Ddd*b1*f**2*r*s - 78*D1*Ddd*b1*f**2*r + 52*D1*Ddd*b1*f**2*s**2 - 78*D1*Ddd*b1*f**2*s + 39*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 24*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 18*D1*Ddd*f**3*s - 9*D1*Ddd*f**3 - 26*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + 156*Dd**2*b1*f**2*r**2 + 312*Dd**2*b1*f**2*r*s - 234*Dd**2*b1*f**2*r + 156*Dd**2*b1*f**2*s**2 - 234*Dd**2*b1*f**2*s + 78*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 72*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 54*Dd**2*f**3*s - 18*Dd**2*f**3)/(286*d**2*k1*k3**7) + D1**2*Pk1*Pkd3*ct*k1**5*k2*st**2*(2376*C*D1**2*b1*f*fd*r**2 + 4752*C*D1**2*b1*f*fd*r*s - 2376*C*D1**2*b1*f*fd*r + 2376*C*D1**2*b1*f*fd*s**2 - 2376*C*D1**2*b1*f*fd*s + 1188*C*D1**2*b1*f*fd - 1848*C*D1**2*b1*f*fdd*r**2 - 3696*C*D1**2*b1*f*fdd*r*s + 1848*C*D1**2*b1*f*fdd*r - 1848*C*D1**2*b1*f*fdd*s**2 + 1848*C*D1**2*b1*f*fdd*s - 924*C*D1**2*b1*f*fdd - 1848*C*D1**2*b1*fd**2*r**2 - 3696*C*D1**2*b1*fd**2*r*s + 1848*C*D1**2*b1*fd**2*r - 1848*C*D1**2*b1*fd**2*s**2 + 1848*C*D1**2*b1*fd**2*s + 2220*C*D1**2*f**2*fd*r**2 + 4440*C*D1**2*f**2*fd*r*s - 2960*C*D1**2*f**2*fd*r + 2220*C*D1**2*f**2*fd*s**2 - 2960*C*D1**2*f**2*fd*s + 1480*C*D1**2*f**2*fd - 2100*C*D1**2*f**2*fdd*r**2 - 4200*C*D1**2*f**2*fdd*r*s + 2800*C*D1**2*f**2*fdd*r - 2100*C*D1**2*f**2*fdd*s**2 + 2800*C*D1**2*f**2*fdd*s - 1400*C*D1**2*f**2*fdd - 4200*C*D1**2*f*fd**2*r**2 - 8400*C*D1**2*f*fd**2*r*s + 5600*C*D1**2*f*fd**2*r - 4200*C*D1**2*f*fd**2*s**2 + 5600*C*D1**2*f*fd**2*s - 1400*C*D1**2*f*fd**2 + 4752*C*D1*Dd*b1*f**2*r**2 + 9504*C*D1*Dd*b1*f**2*r*s - 7128*C*D1*Dd*b1*f**2*r + 4752*C*D1*Dd*b1*f**2*s**2 - 7128*C*D1*Dd*b1*f**2*s + 3564*C*D1*Dd*b1*f**2 - 14784*C*D1*Dd*b1*f*fd*r**2 - 29568*C*D1*Dd*b1*f*fd*r*s + 18480*C*D1*Dd*b1*f*fd*r - 14784*C*D1*Dd*b1*f*fd*s**2 + 18480*C*D1*Dd*b1*f*fd*s - 5544*C*D1*Dd*b1*f*fd + 2960*C*D1*Dd*f**3*r**2 + 5920*C*D1*Dd*f**3*r*s - 4440*C*D1*Dd*f**3*r + 2960*C*D1*Dd*f**3*s**2 - 4440*C*D1*Dd*f**3*s + 2220*C*D1*Dd*f**3 - 16800*C*D1*Dd*f**2*fd*r**2 - 33600*C*D1*Dd*f**2*fd*r*s + 23800*C*D1*Dd*f**2*fd*r - 16800*C*D1*Dd*f**2*fd*s**2 + 23800*C*D1*Dd*f**2*fd*s - 8400*C*D1*Dd*f**2*fd - 3696*C*D1*Ddd*b1*f**2*r**2 - 7392*C*D1*Ddd*b1*f**2*r*s + 5544*C*D1*Ddd*b1*f**2*r - 3696*C*D1*Ddd*b1*f**2*s**2 + 5544*C*D1*Ddd*b1*f**2*s - 2772*C*D1*Ddd*b1*f**2 - 2800*C*D1*Ddd*f**3*r**2 - 5600*C*D1*Ddd*f**3*r*s + 4200*C*D1*Ddd*f**3*r - 2800*C*D1*Ddd*f**3*s**2 + 4200*C*D1*Ddd*f**3*s - 2100*C*D1*Ddd*f**3 - 11088*C*Dd**2*b1*f**2*r**2 - 22176*C*Dd**2*b1*f**2*r*s + 16632*C*Dd**2*b1*f**2*r - 11088*C*Dd**2*b1*f**2*s**2 + 16632*C*Dd**2*b1*f**2*s - 5544*C*Dd**2*b1*f**2 - 8400*C*Dd**2*f**3*r**2 - 16800*C*Dd**2*f**3*r*s + 12600*C*Dd**2*f**3*r - 8400*C*Dd**2*f**3*s**2 + 12600*C*Dd**2*f**3*s - 4200*C*Dd**2*f**3 - 1254*D1**2*b1*f*fd*r**2 - 2508*D1**2*b1*f*fd*r*s + 1254*D1**2*b1*f*fd*r - 1254*D1**2*b1*f*fd*s**2 + 1254*D1**2*b1*f*fd*s - 627*D1**2*b1*f*fd + 990*D1**2*b1*f*fdd*r**2 + 1980*D1**2*b1*f*fdd*r*s - 990*D1**2*b1*f*fdd*r + 990*D1**2*b1*f*fdd*s**2 - 990*D1**2*b1*f*fdd*s + 495*D1**2*b1*f*fdd + 990*D1**2*b1*fd**2*r**2 + 1980*D1**2*b1*fd**2*r*s - 990*D1**2*b1*fd**2*r + 990*D1**2*b1*fd**2*s**2 - 990*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(28*C - 15)*(r + s - 1)**2 - 1161*D1**2*f**2*fd*r**2 - 2322*D1**2*f**2*fd*r*s + 1548*D1**2*f**2*fd*r - 1161*D1**2*f**2*fd*s**2 + 1548*D1**2*f**2*fd*s - 774*D1**2*f**2*fd + 1125*D1**2*f**2*fdd*r**2 + 2250*D1**2*f**2*fdd*r*s - 1500*D1**2*f**2*fdd*r + 1125*D1**2*f**2*fdd*s**2 - 1500*D1**2*f**2*fdd*s + 750*D1**2*f**2*fdd + 2250*D1**2*f*fd**2*r**2 + 4500*D1**2*f*fd**2*r*s - 3000*D1**2*f*fd**2*r + 2250*D1**2*f*fd**2*s**2 - 3000*D1**2*f*fd**2*s + 750*D1**2*f*fd**2 - 2508*D1*Dd*b1*f**2*r**2 - 5016*D1*Dd*b1*f**2*r*s + 3762*D1*Dd*b1*f**2*r - 2508*D1*Dd*b1*f**2*s**2 + 3762*D1*Dd*b1*f**2*s - 1881*D1*Dd*b1*f**2 + 7920*D1*Dd*b1*f*fd*r**2 + 15840*D1*Dd*b1*f*fd*r*s - 9900*D1*Dd*b1*f*fd*r + 7920*D1*Dd*b1*f*fd*s**2 - 9900*D1*Dd*b1*f*fd*s + 2970*D1*Dd*b1*f*fd - 1548*D1*Dd*f**3*r**2 - 3096*D1*Dd*f**3*r*s + 2322*D1*Dd*f**3*r - 1548*D1*Dd*f**3*s**2 + 2322*D1*Dd*f**3*s - 1161*D1*Dd*f**3 + 9000*D1*Dd*f**2*fd*r**2 + 18000*D1*Dd*f**2*fd*r*s - 12750*D1*Dd*f**2*fd*r + 9000*D1*Dd*f**2*fd*s**2 - 12750*D1*Dd*f**2*fd*s + 4500*D1*Dd*f**2*fd + 1980*D1*Ddd*b1*f**2*r**2 + 3960*D1*Ddd*b1*f**2*r*s - 2970*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s**2 - 2970*D1*Ddd*b1*f**2*s + 1485*D1*Ddd*b1*f**2 + 1500*D1*Ddd*f**3*r**2 + 3000*D1*Ddd*f**3*r*s - 2250*D1*Ddd*f**3*r + 1500*D1*Ddd*f**3*s**2 - 2250*D1*Ddd*f**3*s + 1125*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(36*C - 19)*(r + s - 1) - D1*fd*(56*C - 30)*(2*r + 2*s - 1) - Dd*f*(56*C - 30)*(4*r + 4*s - 3)) + 5940*Dd**2*b1*f**2*r**2 + 11880*Dd**2*b1*f**2*r*s - 8910*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s**2 - 8910*Dd**2*b1*f**2*s + 2970*Dd**2*b1*f**2 + 4500*Dd**2*f**3*r**2 + 9000*Dd**2*f**3*r*s - 6750*Dd**2*f**3*r + 4500*Dd**2*f**3*s**2 - 6750*Dd**2*f**3*s + 2250*Dd**2*f**3)/(154*d**2*k3**7) + D1**2*Pk1*Pkd3*ct*k1**5*k2*(-990*D1**2*K*bdd1*f**2*r**2 - 1980*D1**2*K*bdd1*f**2*r*s + 1980*D1**2*K*bdd1*f**2*r - 990*D1**2*K*bdd1*f**2*s**2 + 1980*D1**2*K*bdd1*f**2*s - 990*D1**2*K*bdd1*f**2 + 66*D1**2*bd1**2*f*(-36*K + 5*f + 6)*(r + s - 1)**2 + 140*D1**2*bdd1*f**3*r**2 + 280*D1**2*bdd1*f**3*r*s - 280*D1**2*bdd1*f**3*r + 140*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 140*D1**2*bdd1*f**3 + 165*D1**2*bdd1*f**2*r**2 + 330*D1**2*bdd1*f**2*r*s - 330*D1**2*bdd1*f**2*r + 165*D1**2*bdd1*f**2*s**2 - 330*D1**2*bdd1*f**2*s + 165*D1**2*bdd1*f**2 + 2376*D1**2*bdd1*f*g2*r**2 + 4752*D1**2*bdd1*f*g2*r*s - 4752*D1**2*bdd1*f*g2*r + 2376*D1**2*bdd1*f*g2*s**2 - 4752*D1**2*bdd1*f*g2*s + 2376*D1**2*bdd1*f*g2 - 1584*D1**2*f**2*gd2*r**2 - 3168*D1**2*f**2*gd2*r*s + 3168*D1**2*f**2*gd2*r - 1584*D1**2*f**2*gd2*s**2 + 3168*D1**2*f**2*gd2*s - 1584*D1**2*f**2*gd2 + 1980*D1**2*f**2*gdd2*r**2 + 3960*D1**2*f**2*gdd2*r*s - 3960*D1**2*f**2*gdd2*r + 1980*D1**2*f**2*gdd2*s**2 - 3960*D1**2*f**2*gdd2*s + 1980*D1**2*f**2*gdd2 - 3168*D1**2*f*fd*g2*r**2 - 6336*D1**2*f*fd*g2*r*s + 3168*D1**2*f*fd*g2*r - 3168*D1**2*f*fd*g2*s**2 + 3168*D1**2*f*fd*g2*s - 1584*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r**2 + 15840*D1**2*f*fd*gd2*r*s - 11880*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 11880*D1**2*f*fd*gd2*s + 3960*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r**2 + 7920*D1**2*f*fdd*g2*r*s - 3960*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r**2 + 7920*D1**2*fd**2*g2*r*s - 3960*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s - 6336*D1*Dd*f**2*g2*r**2 - 12672*D1*Dd*f**2*g2*r*s + 9504*D1*Dd*f**2*g2*r - 6336*D1*Dd*f**2*g2*s**2 + 9504*D1*Dd*f**2*g2*s - 4752*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r**2 + 31680*D1*Dd*f**2*gd2*r*s - 27720*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 27720*D1*Dd*f**2*gd2*s + 11880*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r**2 + 63360*D1*Dd*f*fd*g2*r*s - 39600*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 39600*D1*Dd*f*fd*g2*s + 11880*D1*Dd*f*fd*g2 + 7920*D1*Ddd*f**2*g2*r**2 + 15840*D1*Ddd*f**2*g2*r*s - 11880*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 11880*D1*Ddd*f**2*g2*s + 5940*D1*Ddd*f**2*g2 - D1*bd1*(D1*(115*f**3*(r + s - 1) - 4*f**2*(70*fd*(3*r + 3*s - 2) + (198*K - 33)*(r + s - 1)) + 66*f*(5*fd*(6*K - 1)*(2*r + 2*s - 1) + (30*g2 - 72*gd2)*(r + s - 1)) - 4752*fd*g2*(r + s)) - 2*Dd*f*(140*f**2 - 165*f*(6*K - 1) + 2376*g2)*(4*r + 4*s - 3))*(r + s - 1) + 23760*Dd**2*f**2*g2*r**2 + 47520*Dd**2*f**2*g2*r*s - 35640*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 35640*Dd**2*f**2*g2*s + 11880*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 5*fd*(6*K - 1)*(r + s) - 6*fdd*(6*K - 1)*(r + s))) + D1*(Dd*(4*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(2*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (6*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(6*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-36*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-36*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(1584*D1**2*K*f*fd*r**2 + 3168*D1**2*K*f*fd*r*s - 1584*D1**2*K*f*fd*r + 1584*D1**2*K*f*fd*s**2 - 1584*D1**2*K*f*fd*s + 792*D1**2*K*f*fd - 1980*D1**2*K*f*fdd*r**2 - 3960*D1**2*K*f*fdd*r*s + 1980*D1**2*K*f*fdd*r - 1980*D1**2*K*f*fdd*s**2 + 1980*D1**2*K*f*fdd*s - 990*D1**2*K*f*fdd - 1980*D1**2*K*fd**2*r**2 - 3960*D1**2*K*fd**2*r*s + 1980*D1**2*K*fd**2*r - 1980*D1**2*K*fd**2*s**2 + 1980*D1**2*K*fd**2*s + 66*D1**2*bdd1*f*(-36*K + 5*f + 6)*(r + s - 1)**2 - 345*D1**2*f**2*fd*r**2 - 690*D1**2*f**2*fd*r*s + 460*D1**2*f**2*fd*r - 345*D1**2*f**2*fd*s**2 + 460*D1**2*f**2*fd*s - 230*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd + 330*D1**2*f*fdd*r**2 + 660*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 330*D1**2*f*fdd*s**2 - 330*D1**2*f*fdd*s + 165*D1**2*f*fdd - 1980*D1**2*f*gd2*r**2 - 3960*D1**2*f*gd2*r*s + 3960*D1**2*f*gd2*r - 1980*D1**2*f*gd2*s**2 + 3960*D1**2*f*gd2*s - 1980*D1**2*f*gd2 + 2376*D1**2*f*gdd2*r**2 + 4752*D1**2*f*gdd2*r*s - 4752*D1**2*f*gdd2*r + 2376*D1**2*f*gdd2*s**2 - 4752*D1**2*f*gdd2*s + 2376*D1**2*f*gdd2 + 330*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 330*D1**2*fd**2*s**2 - 330*D1**2*fd**2*s - 1980*D1**2*fd*g2*r**2 - 3960*D1**2*fd*g2*r*s - 1980*D1**2*fd*g2*s**2 + 4752*D1**2*fd*gd2*r**2 + 9504*D1**2*fd*gd2*r*s - 4752*D1**2*fd*gd2*r + 4752*D1**2*fd*gd2*s**2 - 4752*D1**2*fd*gd2*s + 2376*D1**2*fdd*g2*r**2 + 4752*D1**2*fdd*g2*r*s + 2376*D1**2*fdd*g2*s**2 + 3168*D1*Dd*K*f**2*r**2 + 6336*D1*Dd*K*f**2*r*s - 4752*D1*Dd*K*f**2*r + 3168*D1*Dd*K*f**2*s**2 - 4752*D1*Dd*K*f**2*s + 2376*D1*Dd*K*f**2 - 15840*D1*Dd*K*f*fd*r**2 - 31680*D1*Dd*K*f*fd*r*s + 19800*D1*Dd*K*f*fd*r - 15840*D1*Dd*K*f*fd*s**2 + 19800*D1*Dd*K*f*fd*s - 5940*D1*Dd*K*f*fd - 460*D1*Dd*f**3*r**2 - 920*D1*Dd*f**3*r*s + 690*D1*Dd*f**3*r - 460*D1*Dd*f**3*s**2 + 690*D1*Dd*f**3*s - 345*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 + 5280*D1*Dd*f*fd*r*s - 3300*D1*Dd*f*fd*r + 2640*D1*Dd*f*fd*s**2 - 3300*D1*Dd*f*fd*s + 990*D1*Dd*f*fd - 7920*D1*Dd*f*g2*r**2 - 15840*D1*Dd*f*g2*r*s + 11880*D1*Dd*f*g2*r - 7920*D1*Dd*f*g2*s**2 + 11880*D1*Dd*f*g2*s - 5940*D1*Dd*f*g2 + 19008*D1*Dd*f*gd2*r**2 + 38016*D1*Dd*f*gd2*r*s - 33264*D1*Dd*f*gd2*r + 19008*D1*Dd*f*gd2*s**2 - 33264*D1*Dd*f*gd2*s + 14256*D1*Dd*f*gd2 + 19008*D1*Dd*fd*g2*r**2 + 38016*D1*Dd*fd*g2*r*s - 14256*D1*Dd*fd*g2*r + 19008*D1*Dd*fd*g2*s**2 - 14256*D1*Dd*fd*g2*s - 3960*D1*Ddd*K*f**2*r**2 - 7920*D1*Ddd*K*f**2*r*s + 5940*D1*Ddd*K*f**2*r - 3960*D1*Ddd*K*f**2*s**2 + 5940*D1*Ddd*K*f**2*s - 2970*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 + 1320*D1*Ddd*f**2*r*s - 990*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s**2 - 990*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 + 9504*D1*Ddd*f*g2*r**2 + 19008*D1*Ddd*f*g2*r*s - 14256*D1*Ddd*f*g2*r + 9504*D1*Ddd*f*g2*s**2 - 14256*D1*Ddd*f*g2*s + 7128*D1*Ddd*f*g2 - 66*D1*bd1*(D1*(4*f**2*(r + s - 1) - 5*f*(fd*(4*r + 4*s - 2) + (6*K - 1)*(r + s - 1)) + 12*fd*(6*K - 1)*(r + s)) - 2*Dd*f*(-36*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) - 11880*Dd**2*K*f**2*r**2 - 23760*Dd**2*K*f**2*r*s + 17820*Dd**2*K*f**2*r - 11880*Dd**2*K*f**2*s**2 + 17820*Dd**2*K*f**2*s - 5940*Dd**2*K*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 1980*Dd**2*f**2*r**2 + 3960*Dd**2*f**2*r*s - 2970*Dd**2*f**2*r + 1980*Dd**2*f**2*s**2 - 2970*Dd**2*f**2*s + 990*Dd**2*f**2 + 28512*Dd**2*f*g2*r**2 + 57024*Dd**2*f*g2*r*s - 42768*Dd**2*f*g2*r + 28512*Dd**2*f*g2*s**2 - 42768*Dd**2*f*g2*s + 14256*Dd**2*f*g2))/(77*d**2*k3**7) + D1**2*Pk1*Pkd3*ct*k1**5*st**2*(4*C - 2)*(11*b1*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(2*s - 1)*(8*r + 8*s - 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 2) + 8*s**2 - 9*s + 2)) + D1*f*(Dd*(39*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 25*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) - 25*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 25*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k2*k3**5) - D1**2*Pk1*Pkd3*ct*k1**5*(8*C - 4)*(6*b1*(D1**2*(f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-6*bdd1*s*(r + s - 1) + 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) - 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 6*D1*bd1*(D1*(f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + 5*D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k2*k3**5) + D1**2*Pk1*Pkd3*ct*k1**3*k2**3*st**2*(-20592*C*D1**2*f**2*fd*r**2 - 41184*C*D1**2*f**2*fd*r*s + 27456*C*D1**2*f**2*fd*r - 20592*C*D1**2*f**2*fd*s**2 + 27456*C*D1**2*f**2*fd*s - 13728*C*D1**2*f**2*fd - 27456*C*D1*Dd*f**3*r**2 - 54912*C*D1*Dd*f**3*r*s + 41184*C*D1*Dd*f**3*r - 27456*C*D1*Dd*f**3*s**2 + 41184*C*D1*Dd*f**3*s - 20592*C*D1*Dd*f**3 - 10296*D1**2*K*bdd1*f**2*r**2 - 20592*D1**2*K*bdd1*f**2*r*s + 20592*D1**2*K*bdd1*f**2*r - 10296*D1**2*K*bdd1*f**2*s**2 + 20592*D1**2*K*bdd1*f**2*s - 10296*D1**2*K*bdd1*f**2 + 5148*D1**2*bd1**2*f*(-4*K + 5*f + 1)*(r + s - 1)**2 + 4875*D1**2*bdd1*f**3*r**2 + 9750*D1**2*bdd1*f**3*r*s - 9750*D1**2*bdd1*f**3*r + 4875*D1**2*bdd1*f**3*s**2 - 9750*D1**2*bdd1*f**3*s + 4875*D1**2*bdd1*f**3 + 2574*D1**2*bdd1*f**2*r**2 + 5148*D1**2*bdd1*f**2*r*s - 5148*D1**2*bdd1*f**2*r + 2574*D1**2*bdd1*f**2*s**2 - 5148*D1**2*bdd1*f**2*s + 2574*D1**2*bdd1*f**2 + 20592*D1**2*bdd1*f*g2*r**2 + 41184*D1**2*bdd1*f*g2*r*s - 41184*D1**2*bdd1*f*g2*r + 20592*D1**2*bdd1*f*g2*s**2 - 41184*D1**2*bdd1*f*g2*s + 20592*D1**2*bdd1*f*g2 + 15100*D1**2*f**3*fd*r**2 + 30200*D1**2*f**3*fd*r*s - 22650*D1**2*f**3*fd*r + 15100*D1**2*f**3*fd*s**2 - 22650*D1**2*f**3*fd*s + 11325*D1**2*f**3*fd - 14700*D1**2*f**3*fdd*r**2 - 29400*D1**2*f**3*fdd*r*s + 22050*D1**2*f**3*fdd*r - 14700*D1**2*f**3*fdd*s**2 + 22050*D1**2*f**3*fdd*s - 11025*D1**2*f**3*fdd - 44100*D1**2*f**2*fd**2*r**2 - 88200*D1**2*f**2*fd**2*r*s + 66150*D1**2*f**2*fd**2*r - 44100*D1**2*f**2*fd**2*s**2 + 66150*D1**2*f**2*fd**2*s - 22050*D1**2*f**2*fd**2 + 11583*D1**2*f**2*fd*r**2 + 23166*D1**2*f**2*fd*r*s - 15444*D1**2*f**2*fd*r + 11583*D1**2*f**2*fd*s**2 - 15444*D1**2*f**2*fd*s + 7722*D1**2*f**2*fd - 37752*D1**2*f**2*gd2*r**2 - 75504*D1**2*f**2*gd2*r*s + 75504*D1**2*f**2*gd2*r - 37752*D1**2*f**2*gd2*s**2 + 75504*D1**2*f**2*gd2*s - 37752*D1**2*f**2*gd2 + 20592*D1**2*f**2*gdd2*r**2 + 41184*D1**2*f**2*gdd2*r*s - 41184*D1**2*f**2*gdd2*r + 20592*D1**2*f**2*gdd2*s**2 - 41184*D1**2*f**2*gdd2*s + 20592*D1**2*f**2*gdd2 - 75504*D1**2*f*fd*g2*r**2 - 151008*D1**2*f*fd*g2*r*s + 75504*D1**2*f*fd*g2*r - 75504*D1**2*f*fd*g2*s**2 + 75504*D1**2*f*fd*g2*s - 37752*D1**2*f*fd*g2 + 82368*D1**2*f*fd*gd2*r**2 + 164736*D1**2*f*fd*gd2*r*s - 123552*D1**2*f*fd*gd2*r + 82368*D1**2*f*fd*gd2*s**2 - 123552*D1**2*f*fd*gd2*s + 41184*D1**2*f*fd*gd2 + 41184*D1**2*f*fdd*g2*r**2 + 82368*D1**2*f*fdd*g2*r*s - 41184*D1**2*f*fdd*g2*r + 41184*D1**2*f*fdd*g2*s**2 - 41184*D1**2*f*fdd*g2*s + 20592*D1**2*f*fdd*g2 + 41184*D1**2*fd**2*g2*r**2 + 82368*D1**2*fd**2*g2*r*s - 41184*D1**2*fd**2*g2*r + 41184*D1**2*fd**2*g2*s**2 - 41184*D1**2*fd**2*g2*s + 15100*D1*Dd*f**4*r**2 + 30200*D1*Dd*f**4*r*s - 22650*D1*Dd*f**4*r + 15100*D1*Dd*f**4*s**2 - 22650*D1*Dd*f**4*s + 11325*D1*Dd*f**4 - 117600*D1*Dd*f**3*fd*r**2 - 235200*D1*Dd*f**3*fd*r*s + 176400*D1*Dd*f**3*fd*r - 117600*D1*Dd*f**3*fd*s**2 + 176400*D1*Dd*f**3*fd*s - 66150*D1*Dd*f**3*fd + 15444*D1*Dd*f**3*r**2 + 30888*D1*Dd*f**3*r*s - 23166*D1*Dd*f**3*r + 15444*D1*Dd*f**3*s**2 - 23166*D1*Dd*f**3*s + 11583*D1*Dd*f**3 - 151008*D1*Dd*f**2*g2*r**2 - 302016*D1*Dd*f**2*g2*r*s + 226512*D1*Dd*f**2*g2*r - 151008*D1*Dd*f**2*g2*s**2 + 226512*D1*Dd*f**2*g2*s - 113256*D1*Dd*f**2*g2 + 164736*D1*Dd*f**2*gd2*r**2 + 329472*D1*Dd*f**2*gd2*r*s - 288288*D1*Dd*f**2*gd2*r + 164736*D1*Dd*f**2*gd2*s**2 - 288288*D1*Dd*f**2*gd2*s + 123552*D1*Dd*f**2*gd2 + 329472*D1*Dd*f*fd*g2*r**2 + 658944*D1*Dd*f*fd*g2*r*s - 411840*D1*Dd*f*fd*g2*r + 329472*D1*Dd*f*fd*g2*s**2 - 411840*D1*Dd*f*fd*g2*s + 123552*D1*Dd*f*fd*g2 - 14700*D1*Ddd*f**4*r**2 - 29400*D1*Ddd*f**4*r*s + 22050*D1*Ddd*f**4*r - 14700*D1*Ddd*f**4*s**2 + 22050*D1*Ddd*f**4*s - 11025*D1*Ddd*f**4 + 82368*D1*Ddd*f**2*g2*r**2 + 164736*D1*Ddd*f**2*g2*r*s - 123552*D1*Ddd*f**2*g2*r + 82368*D1*Ddd*f**2*g2*s**2 - 123552*D1*Ddd*f**2*g2*s + 61776*D1*Ddd*f**2*g2 - 78*D1*bd1*(D1*(103*f**3*(r + s - 1) + f**2*(88*C*(r + s - 1) - 125*fd*(3*r + 3*s - 2) - (242*K - 11)*(r + s - 1)) + 22*f*(3*fd*(4*K - 1)*(2*r + 2*s - 1) + (38*g2 - 24*gd2)*(r + s - 1)) - 528*fd*g2*(r + s)) - Dd*f*(125*f**2 - 66*f*(4*K - 1) + 528*g2)*(4*r + 4*s - 3))*(r + s - 1) - 44100*Dd**2*f**4*r**2 - 88200*Dd**2*f**4*r*s + 66150*Dd**2*f**4*r - 44100*Dd**2*f**4*s**2 + 66150*Dd**2*f**4*s - 22050*Dd**2*f**4 + 247104*Dd**2*f**2*g2*r**2 + 494208*Dd**2*f**2*g2*r*s - 370656*Dd**2*f**2*g2*r + 247104*Dd**2*f**2*g2*s**2 - 370656*Dd**2*f**2*g2*s + 123552*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(15*f*(3*fd - 2*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(60*fd**2*(r + s - 1) + 19*fd*(4*K - 1)*(r + s) - 6*fdd*(4*K - 1)*(r + s))) + D1*(Dd*(45*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (76*K - 19)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(4*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-4*K + 5*f + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-4*K + 5*f + 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 39*b1*(352*C*D1**2*f*fd*r**2 + 704*C*D1**2*f*fd*r*s - 352*C*D1**2*f*fd*r + 352*C*D1**2*f*fd*s**2 - 352*C*D1**2*f*fd*s + 176*C*D1**2*f*fd + 704*C*D1*Dd*f**2*r**2 + 1408*C*D1*Dd*f**2*r*s - 1056*C*D1*Dd*f**2*r + 704*C*D1*Dd*f**2*s**2 - 1056*C*D1*Dd*f**2*s + 528*C*D1*Dd*f**2 - 968*D1**2*K*f*fd*r**2 - 1936*D1**2*K*f*fd*r*s + 968*D1**2*K*f*fd*r - 968*D1**2*K*f*fd*s**2 + 968*D1**2*K*f*fd*s - 484*D1**2*K*f*fd + 528*D1**2*K*f*fdd*r**2 + 1056*D1**2*K*f*fdd*r*s - 528*D1**2*K*f*fdd*r + 528*D1**2*K*f*fdd*s**2 - 528*D1**2*K*f*fdd*s + 264*D1**2*K*f*fdd + 528*D1**2*K*fd**2*r**2 + 1056*D1**2*K*fd**2*r*s - 528*D1**2*K*fd**2*r + 528*D1**2*K*fd**2*s**2 - 528*D1**2*K*fd**2*s - 132*D1**2*bdd1*f*(-4*K + 5*f + 1)*(r + s - 1)**2 + 618*D1**2*f**2*fd*r**2 + 1236*D1**2*f**2*fd*r*s - 824*D1**2*f**2*fd*r + 618*D1**2*f**2*fd*s**2 - 824*D1**2*f**2*fd*s + 412*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 750*D1**2*f**2*fdd*r*s + 500*D1**2*f**2*fdd*r - 375*D1**2*f**2*fdd*s**2 + 500*D1**2*f**2*fdd*s - 250*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 1500*D1**2*f*fd**2*r*s + 1000*D1**2*f*fd**2*r - 750*D1**2*f*fd**2*s**2 + 1000*D1**2*f*fd**2*s - 250*D1**2*f*fd**2 + 44*D1**2*f*fd*r**2 + 88*D1**2*f*fd*r*s - 44*D1**2*f*fd*r + 44*D1**2*f*fd*s**2 - 44*D1**2*f*fd*s + 22*D1**2*f*fd - 132*D1**2*f*fdd*r**2 - 264*D1**2*f*fdd*r*s + 132*D1**2*f*fdd*r - 132*D1**2*f*fdd*s**2 + 132*D1**2*f*fdd*s - 66*D1**2*f*fdd + 1672*D1**2*f*gd2*r**2 + 3344*D1**2*f*gd2*r*s - 3344*D1**2*f*gd2*r + 1672*D1**2*f*gd2*s**2 - 3344*D1**2*f*gd2*s + 1672*D1**2*f*gd2 - 528*D1**2*f*gdd2*r**2 - 1056*D1**2*f*gdd2*r*s + 1056*D1**2*f*gdd2*r - 528*D1**2*f*gdd2*s**2 + 1056*D1**2*f*gdd2*s - 528*D1**2*f*gdd2 - 132*D1**2*fd**2*r**2 - 264*D1**2*fd**2*r*s + 132*D1**2*fd**2*r - 132*D1**2*fd**2*s**2 + 132*D1**2*fd**2*s + 1672*D1**2*fd*g2*r**2 + 3344*D1**2*fd*g2*r*s + 1672*D1**2*fd*g2*s**2 - 1056*D1**2*fd*gd2*r**2 - 2112*D1**2*fd*gd2*r*s + 1056*D1**2*fd*gd2*r - 1056*D1**2*fd*gd2*s**2 + 1056*D1**2*fd*gd2*s - 528*D1**2*fdd*g2*r**2 - 1056*D1**2*fdd*g2*r*s - 528*D1**2*fdd*g2*s**2 - 1936*D1*Dd*K*f**2*r**2 - 3872*D1*Dd*K*f**2*r*s + 2904*D1*Dd*K*f**2*r - 1936*D1*Dd*K*f**2*s**2 + 2904*D1*Dd*K*f**2*s - 1452*D1*Dd*K*f**2 + 4224*D1*Dd*K*f*fd*r**2 + 8448*D1*Dd*K*f*fd*r*s - 5280*D1*Dd*K*f*fd*r + 4224*D1*Dd*K*f*fd*s**2 - 5280*D1*Dd*K*f*fd*s + 1584*D1*Dd*K*f*fd + 824*D1*Dd*f**3*r**2 + 1648*D1*Dd*f**3*r*s - 1236*D1*Dd*f**3*r + 824*D1*Dd*f**3*s**2 - 1236*D1*Dd*f**3*s + 618*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 6000*D1*Dd*f**2*fd*r*s + 4250*D1*Dd*f**2*fd*r - 3000*D1*Dd*f**2*fd*s**2 + 4250*D1*Dd*f**2*fd*s - 1500*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r**2 + 176*D1*Dd*f**2*r*s - 132*D1*Dd*f**2*r + 88*D1*Dd*f**2*s**2 - 132*D1*Dd*f**2*s + 66*D1*Dd*f**2 - 1056*D1*Dd*f*fd*r**2 - 2112*D1*Dd*f*fd*r*s + 1320*D1*Dd*f*fd*r - 1056*D1*Dd*f*fd*s**2 + 1320*D1*Dd*f*fd*s - 396*D1*Dd*f*fd + 6688*D1*Dd*f*g2*r**2 + 13376*D1*Dd*f*g2*r*s - 10032*D1*Dd*f*g2*r + 6688*D1*Dd*f*g2*s**2 - 10032*D1*Dd*f*g2*s + 5016*D1*Dd*f*g2 - 4224*D1*Dd*f*gd2*r**2 - 8448*D1*Dd*f*gd2*r*s + 7392*D1*Dd*f*gd2*r - 4224*D1*Dd*f*gd2*s**2 + 7392*D1*Dd*f*gd2*s - 3168*D1*Dd*f*gd2 - 4224*D1*Dd*fd*g2*r**2 - 8448*D1*Dd*fd*g2*r*s + 3168*D1*Dd*fd*g2*r - 4224*D1*Dd*fd*g2*s**2 + 3168*D1*Dd*fd*g2*s + 1056*D1*Ddd*K*f**2*r**2 + 2112*D1*Ddd*K*f**2*r*s - 1584*D1*Ddd*K*f**2*r + 1056*D1*Ddd*K*f**2*s**2 - 1584*D1*Ddd*K*f**2*s + 792*D1*Ddd*K*f**2 - 500*D1*Ddd*f**3*r**2 - 1000*D1*Ddd*f**3*r*s + 750*D1*Ddd*f**3*r - 500*D1*Ddd*f**3*s**2 + 750*D1*Ddd*f**3*s - 375*D1*Ddd*f**3 - 264*D1*Ddd*f**2*r**2 - 528*D1*Ddd*f**2*r*s + 396*D1*Ddd*f**2*r - 264*D1*Ddd*f**2*s**2 + 396*D1*Ddd*f**2*s - 198*D1*Ddd*f**2 - 2112*D1*Ddd*f*g2*r**2 - 4224*D1*Ddd*f*g2*r*s + 3168*D1*Ddd*f*g2*r - 2112*D1*Ddd*f*g2*s**2 + 3168*D1*Ddd*f*g2*s - 1584*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(45*f**2*(r + s - 1) - 60*f*fd*(2*r + 2*s - 1) - 19*f*(4*K - 1)*(r + s - 1) + 12*fd*(4*K - 1)*(r + s)) - 12*Dd*f*(-4*K + 5*f + 1)*(4*r + 4*s - 3))*(r + s - 1) + 3168*Dd**2*K*f**2*r**2 + 6336*Dd**2*K*f**2*r*s - 4752*Dd**2*K*f**2*r + 3168*Dd**2*K*f**2*s**2 - 4752*Dd**2*K*f**2*s + 1584*Dd**2*K*f**2 - 1500*Dd**2*f**3*r**2 - 3000*Dd**2*f**3*r*s + 2250*Dd**2*f**3*r - 1500*Dd**2*f**3*s**2 + 2250*Dd**2*f**3*s - 750*Dd**2*f**3 - 792*Dd**2*f**2*r**2 - 1584*Dd**2*f**2*r*s + 1188*Dd**2*f**2*r - 792*Dd**2*f**2*s**2 + 1188*Dd**2*f**2*s - 396*Dd**2*f**2 - 6336*Dd**2*f*g2*r**2 - 12672*Dd**2*f*g2*r*s + 9504*Dd**2*f*g2*r - 6336*Dd**2*f*g2*s**2 + 9504*Dd**2*f*g2*s - 3168*Dd**2*f*g2))/(2002*d**2*k3**7) + D1**2*Pk1*Pkd3*ct*k1**3*k2*st**2*(165*b1**2*(D1**2*(fd*(88*C - 53) + fdd*(9 - 16*C))*(r + s - 1)**2 + D1*(Dd*(f*(88*C - 53)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(18 - 32*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(16*C - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(96*C - 54)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-432*C*D1**2*f*fd*r**2 - 1168*C*D1**2*f*fd*r*s + 344*C*D1**2*f*fd*r - 736*C*D1**2*f*fd*s**2 + 496*C*D1**2*f*fd*s - 248*C*D1**2*f*fd + 432*C*D1**2*f*fdd*r**2 + 1072*C*D1**2*f*fdd*r*s - 376*C*D1**2*f*fdd*r + 640*C*D1**2*f*fdd*s**2 - 480*C*D1**2*f*fdd*s + 240*C*D1**2*f*fdd + 432*C*D1**2*fd**2*r**2 + 1072*C*D1**2*fd**2*r*s - 376*C*D1**2*fd**2*r + 640*C*D1**2*fd**2*s**2 - 480*C*D1**2*fd**2*s - 160*C*D1**2*fd**2 - 864*C*D1*Dd*f**2*r**2 - 2336*C*D1*Dd*f**2*r*s + 1600*C*D1*Dd*f**2*r - 1472*C*D1*Dd*f**2*s**2 + 2056*C*D1*Dd*f**2*s - 952*C*D1*Dd*f**2 + 3456*C*D1*Dd*f*fd*r**2 + 8576*C*D1*Dd*f*fd*r*s - 4512*C*D1*Dd*f*fd*r + 5120*C*D1*Dd*f*fd*s**2 - 5552*C*D1*Dd*f*fd*s + 1336*C*D1*Dd*f*fd + 864*C*D1*Ddd*f**2*r**2 + 2144*C*D1*Ddd*f**2*r*s - 1504*C*D1*Ddd*f**2*r + 1280*C*D1*Ddd*f**2*s**2 - 1816*C*D1*Ddd*f**2*s + 856*C*D1*Ddd*f**2 + 2592*C*Dd**2*f**2*r**2 + 6432*C*Dd**2*f**2*r*s - 4512*C*Dd**2*f**2*r + 3840*C*Dd**2*f**2*s**2 - 5448*C*Dd**2*f**2*s + 1712*C*Dd**2*f**2 - 5*D1**2*bdd1*f*(16*C - 9)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 242*D1**2*f*fd*r**2 + 700*D1**2*f*fd*r*s - 220*D1**2*f*fd*r + 458*D1**2*f*fd*s**2 - 328*D1**2*f*fd*s + 164*D1**2*f*fd - 238*D1**2*f*fdd*r**2 - 636*D1**2*f*fdd*r*s + 228*D1**2*f*fdd*r - 398*D1**2*f*fdd*s**2 + 308*D1**2*f*fdd*s - 154*D1**2*f*fdd - 238*D1**2*fd**2*r**2 - 636*D1**2*fd**2*r*s + 228*D1**2*fd**2*r - 398*D1**2*fd**2*s**2 + 308*D1**2*fd**2*s + 90*D1**2*fd**2 + 484*D1*Dd*f**2*r**2 + 1400*D1*Dd*f**2*r*s - 942*D1*Dd*f**2*r + 916*D1*Dd*f**2*s**2 - 1266*D1*Dd*f**2*s + 579*D1*Dd*f**2 - 1904*D1*Dd*f*fd*r**2 - 5088*D1*Dd*f*fd*r*s + 2660*D1*Dd*f*fd*r - 3184*D1*Dd*f*fd*s**2 + 3460*D1*Dd*f*fd*s - 844*D1*Dd*f*fd - 476*D1*Ddd*f**2*r**2 - 1272*D1*Ddd*f**2*r*s + 874*D1*Ddd*f**2*r - 796*D1*Ddd*f**2*s**2 + 1114*D1*Ddd*f**2*s - 517*D1*Ddd*f**2 + 5*D1*bd1*(D1*(f*(88*C - 53)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(18 - 32*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(18 - 32*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 1428*Dd**2*f**2*r**2 - 3816*Dd**2*f**2*r*s + 2622*Dd**2*f**2*r - 2388*Dd**2*f**2*s**2 + 3342*Dd**2*f**2*s - 1034*Dd**2*f**2) + f*(-330*D1**2*bd1**2*(16*C - 9)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(8*C*(27*r**2 + 67*r*s - 74*r + 40*s**2 - 87*s + 37) - 119*r**2 - 318*r*s + 328*r - 199*s**2 + 408*s - 164) - 2*D1**2*(f*(fd*(4*C*(3192*r**2 + 8031*r*s - 4805*r + 4839*s**2 - 5903*s + 2677) - 7107*r**2 - 18612*r*s + 10942*r - 11505*s**2 + 13874*s - 6204) - 2*fdd*(2*C*(3279*r**2 + 7629*r*s - 4729*r + 4350*s**2 - 5443*s + 2543) - 3633*r**2 - 8910*r*s + 5392*r - 5277*s**2 + 6488*s - 2970)) - 4*fd**2*(C*(6558*r**2 + 15258*r*s - 9458*r + 8700*s**2 - 10886*s + 2543) - 3633*r**2 - 8910*r*s + 5392*r - 5277*s**2 + 6488*s - 1485)) - 33*D1*bd1*(D1*(f*(8*C*(27*r**2 + 73*r*s - 84*r + 46*s**2 - 103*s + 42) - 121*r**2 - 350*r*s + 372*r - 229*s**2 + 480*s - 186) - 4*fd*(2*C*(108*r**2 + 268*r*s - 195*r + 160*s**2 - 234*s + 87) - 119*r**2 - 318*r*s + 221*r - 199*s**2 + 281*s - 102)) - 2*Dd*f*(4*C*(216*r**2 + 536*r*s - 484*r + 320*s**2 - 575*s + 248) - 476*r**2 - 1272*r*s + 1093*r - 796*s**2 + 1373*s - 572)) - 2*D1*f*(Dd*(f*(4*C*(4256*r**2 + 10708*r*s - 7482*r + 6452*s**2 - 9129*s + 4290) - 9476*r**2 - 24816*r*s + 17146*r - 15340*s**2 + 21544*s - 10039) - 4*fd*(C*(26232*r**2 + 61032*r*s - 40732*r + 34800*s**2 - 46801*s + 15615) - 14532*r**2 - 35640*r*s + 23327*r - 21108*s**2 + 27985*s - 9184)) - 2*Ddd*f*(2*C*(4372*r**2 + 10172*r*s - 7272*r + 5800*s**2 - 8343*s + 3993) - 4844*r**2 - 11880*r*s + 8362*r - 7036*s**2 + 10006*s - 4729)) + 8*Dd**2*f**2*(3*C*(4372*r**2 + 10172*r*s - 7272*r + 5800*s**2 - 8343*s + 2662) - 7266*r**2 - 17820*r*s + 12543*r - 10554*s**2 + 15009*s - 4729)))/(1386*d**2*k3**5) - D1**2*Pk1*Pkd3*ct*k1**3*k2*(-15576*D1**2*K*bd1**2*f*r**2 - 31152*D1**2*K*bd1**2*f*r*s + 39072*D1**2*K*bd1**2*f*r - 15576*D1**2*K*bd1**2*f*s**2 + 39072*D1**2*K*bd1**2*f*s - 23496*D1**2*K*bd1**2*f + 8448*D1**2*K*bd1*f**2*r**2 + 15576*D1**2*K*bd1*f**2*r*s - 15576*D1**2*K*bd1*f**2*r + 7128*D1**2*K*bd1*f**2*s**2 - 14256*D1**2*K*bd1*f**2*s + 7128*D1**2*K*bd1*f**2 - 42240*D1**2*K*bd1*f*fd*r**2 - 81840*D1**2*K*bd1*f*fd*r*s + 62040*D1**2*K*bd1*f*fd*r - 39600*D1**2*K*bd1*f*fd*s**2 + 60060*D1**2*K*bd1*f*fd*s - 20460*D1**2*K*bd1*f*fd - 10560*D1**2*K*bdd1*f**2*r**2 - 20460*D1**2*K*bdd1*f**2*r*s + 20460*D1**2*K*bdd1*f**2*r - 9900*D1**2*K*bdd1*f**2*s**2 + 19800*D1**2*K*bdd1*f**2*s - 9900*D1**2*K*bdd1*f**2 + 2772*D1**2*bd1**2*f**2*r**2 + 8712*D1**2*bd1**2*f**2*r*s - 8778*D1**2*bd1**2*f**2*r + 5940*D1**2*bd1**2*f**2*s**2 - 11946*D1**2*bd1**2*f**2*s + 6006*D1**2*bd1**2*f**2 + 3102*D1**2*bd1**2*f*r**2 + 9372*D1**2*bd1**2*f*r*s - 9768*D1**2*bd1**2*f*r + 6270*D1**2*bd1**2*f*s**2 - 12936*D1**2*bd1**2*f*s + 6666*D1**2*bd1**2*f - 18480*D1**2*bd1**2*g2*r**2 - 36960*D1**2*bd1**2*g2*r*s + 18480*D1**2*bd1**2*g2*r - 18480*D1**2*bd1**2*g2*s**2 + 18480*D1**2*bd1**2*g2*s - 7920*D1**2*bd1*bd2*f*r**2 - 15840*D1**2*bd1*bd2*f*r*s + 15840*D1**2*bd1*bd2*f*r - 7920*D1**2*bd1*bd2*f*s**2 + 15840*D1**2*bd1*bd2*f*s - 7920*D1**2*bd1*bd2*f - 1600*D1**2*bd1*f**3*r**2 - 3660*D1**2*bd1*f**3*r*s + 4320*D1**2*bd1*f**3*r - 2060*D1**2*bd1*f**3*s**2 + 4780*D1**2*bd1*f**3*s - 2720*D1**2*bd1*f**3 + 11730*D1**2*bd1*f**2*fd*r**2 + 26820*D1**2*bd1*f**2*fd*r*s - 23110*D1**2*bd1*f**2*fd*r + 15090*D1**2*bd1*f**2*fd*s**2 - 25910*D1**2*bd1*f**2*fd*s + 10160*D1**2*bd1*f**2*fd - 1782*D1**2*bd1*f**2*r**2 - 4356*D1**2*bd1*f**2*r*s + 4356*D1**2*bd1*f**2*r - 2574*D1**2*bd1*f**2*s**2 + 5148*D1**2*bd1*f**2*s - 2574*D1**2*bd1*f**2 + 9108*D1**2*bd1*f*fd*r**2 + 22968*D1**2*bd1*f*fd*r*s - 16038*D1**2*bd1*f*fd*r + 13860*D1**2*bd1*f*fd*s**2 - 19602*D1**2*bd1*f*fd*s + 5742*D1**2*bd1*f*fd - 10824*D1**2*bd1*f*g2*r**2 - 21648*D1**2*bd1*f*g2*r*s + 34848*D1**2*bd1*f*g2*r - 10824*D1**2*bd1*f*g2*s**2 + 34848*D1**2*bd1*f*g2*s - 17424*D1**2*bd1*f*g2 + 31152*D1**2*bd1*f*gd2*r**2 + 62304*D1**2*bd1*f*gd2*r*s - 78144*D1**2*bd1*f*gd2*r + 31152*D1**2*bd1*f*gd2*s**2 - 78144*D1**2*bd1*f*gd2*s + 46992*D1**2*bd1*f*gd2 + 31152*D1**2*bd1*fd*g2*r**2 + 62304*D1**2*bd1*fd*g2*r*s - 31152*D1**2*bd1*fd*g2*r + 31152*D1**2*bd1*fd*g2*s**2 - 31152*D1**2*bd1*fd*g2*s + 2640*D1**2*bd2*f**2*r**2 + 5280*D1**2*bd2*f**2*r*s - 5280*D1**2*bd2*f**2*r + 2640*D1**2*bd2*f**2*s**2 - 5280*D1**2*bd2*f**2*s + 2640*D1**2*bd2*f**2 - 13200*D1**2*bd2*f*fd*r**2 - 26400*D1**2*bd2*f*fd*r*s + 19800*D1**2*bd2*f*fd*r - 13200*D1**2*bd2*f*fd*s**2 + 19800*D1**2*bd2*f*fd*s - 6600*D1**2*bd2*f*fd + 1955*D1**2*bdd1*f**3*r**2 + 4470*D1**2*bdd1*f**3*r*s - 5130*D1**2*bdd1*f**3*r + 2515*D1**2*bdd1*f**3*s**2 - 5690*D1**2*bdd1*f**3*s + 3175*D1**2*bdd1*f**3 + 2277*D1**2*bdd1*f**2*r**2 + 5742*D1**2*bdd1*f**2*r*s - 5742*D1**2*bdd1*f**2*r + 3465*D1**2*bdd1*f**2*s**2 - 6930*D1**2*bdd1*f**2*s + 3465*D1**2*bdd1*f**2 + 15576*D1**2*bdd1*f*g2*r**2 + 31152*D1**2*bdd1*f*g2*r*s - 46992*D1**2*bdd1*f*g2*r + 15576*D1**2*bdd1*f*g2*s**2 - 46992*D1**2*bdd1*f*g2*s + 23496*D1**2*bdd1*f*g2 - 3300*D1**2*bdd2*f**2*r**2 - 6600*D1**2*bdd2*f**2*r*s + 6600*D1**2*bdd2*f**2*r - 3300*D1**2*bdd2*f**2*s**2 + 6600*D1**2*bdd2*f**2*s - 3300*D1**2*bdd2*f**2 + 2240*D1**2*f**3*fd*r*s - 1120*D1**2*f**3*fd*r + 2240*D1**2*f**3*fd*s**2 - 2800*D1**2*f**3*fd*s + 1120*D1**2*f**3*fd - 2240*D1**2*f**3*fdd*r*s + 1120*D1**2*f**3*fdd*r - 2240*D1**2*f**3*fdd*s**2 + 2800*D1**2*f**3*fdd*s - 1120*D1**2*f**3*fdd - 6720*D1**2*f**2*fd**2*r*s + 3360*D1**2*f**2*fd**2*r - 6720*D1**2*f**2*fd**2*s**2 + 8400*D1**2*f**2*fd**2*s - 2240*D1**2*f**2*fd**2 - 16896*D1**2*f**2*gd2*r**2 - 31152*D1**2*f**2*gd2*r*s + 31152*D1**2*f**2*gd2*r - 14256*D1**2*f**2*gd2*s**2 + 28512*D1**2*f**2*gd2*s - 14256*D1**2*f**2*gd2 + 21120*D1**2*f**2*gdd2*r**2 + 40920*D1**2*f**2*gdd2*r*s - 40920*D1**2*f**2*gdd2*r + 19800*D1**2*f**2*gdd2*s**2 - 39600*D1**2*f**2*gdd2*s + 19800*D1**2*f**2*gdd2 - 33792*D1**2*f*fd*g2*r**2 - 62304*D1**2*f*fd*g2*r*s + 33792*D1**2*f*fd*g2*r - 28512*D1**2*f*fd*g2*s**2 + 31152*D1**2*f*fd*g2*s - 16896*D1**2*f*fd*g2 + 84480*D1**2*f*fd*gd2*r**2 + 163680*D1**2*f*fd*gd2*r*s - 124080*D1**2*f*fd*gd2*r + 79200*D1**2*f*fd*gd2*s**2 - 120120*D1**2*f*fd*gd2*s + 40920*D1**2*f*fd*gd2 + 42240*D1**2*f*fdd*g2*r**2 + 81840*D1**2*f*fdd*g2*r*s - 42240*D1**2*f*fdd*g2*r + 39600*D1**2*f*fdd*g2*s**2 - 40920*D1**2*f*fdd*g2*s + 21120*D1**2*f*fdd*g2 + 42240*D1**2*fd**2*g2*r**2 + 81840*D1**2*fd**2*g2*r*s - 42240*D1**2*fd**2*g2*r + 39600*D1**2*fd**2*g2*s**2 - 40920*D1**2*fd**2*g2*s - 84480*D1*Dd*K*bd1*f**2*r**2 - 163680*D1*Dd*K*bd1*f**2*r*s + 143880*D1*Dd*K*bd1*f**2*r - 79200*D1*Dd*K*bd1*f**2*s**2 + 139260*D1*Dd*K*bd1*f**2*s - 60060*D1*Dd*K*bd1*f**2 + 15640*D1*Dd*bd1*f**3*r**2 + 35760*D1*Dd*bd1*f**3*r*s - 33370*D1*Dd*bd1*f**3*r + 20120*D1*Dd*bd1*f**3*s**2 - 37290*D1*Dd*bd1*f**3*s + 16510*D1*Dd*bd1*f**3 + 18216*D1*Dd*bd1*f**2*r**2 + 45936*D1*Dd*bd1*f**2*r*s - 39006*D1*Dd*bd1*f**2*r + 27720*D1*Dd*bd1*f**2*s**2 - 47322*D1*Dd*bd1*f**2*s + 19602*D1*Dd*bd1*f**2 + 124608*D1*Dd*bd1*f*g2*r**2 + 249216*D1*Dd*bd1*f*g2*r*s - 281424*D1*Dd*bd1*f*g2*r + 124608*D1*Dd*bd1*f*g2*s**2 - 281424*D1*Dd*bd1*f*g2*s + 140976*D1*Dd*bd1*f*g2 - 26400*D1*Dd*bd2*f**2*r**2 - 52800*D1*Dd*bd2*f**2*r*s + 46200*D1*Dd*bd2*f**2*r - 26400*D1*Dd*bd2*f**2*s**2 + 46200*D1*Dd*bd2*f**2*s - 19800*D1*Dd*bd2*f**2 + 2240*D1*Dd*f**4*r*s - 1120*D1*Dd*f**4*r + 2240*D1*Dd*f**4*s**2 - 2800*D1*Dd*f**4*s + 1120*D1*Dd*f**4 - 17920*D1*Dd*f**3*fd*r*s + 8960*D1*Dd*f**3*fd*r - 17920*D1*Dd*f**3*fd*s**2 + 22400*D1*Dd*f**3*fd*s - 6720*D1*Dd*f**3*fd - 67584*D1*Dd*f**2*g2*r**2 - 124608*D1*Dd*f**2*g2*r*s + 96096*D1*Dd*f**2*g2*r - 57024*D1*Dd*f**2*g2*s**2 + 88176*D1*Dd*f**2*g2*s - 45408*D1*Dd*f**2*g2 + 168960*D1*Dd*f**2*gd2*r**2 + 327360*D1*Dd*f**2*gd2*r*s - 287760*D1*Dd*f**2*gd2*r + 158400*D1*Dd*f**2*gd2*s**2 - 278520*D1*Dd*f**2*gd2*s + 120120*D1*Dd*f**2*gd2 + 337920*D1*Dd*f*fd*g2*r**2 + 654720*D1*Dd*f*fd*g2*r*s - 417120*D1*Dd*f*fd*g2*r + 316800*D1*Dd*f*fd*g2*s**2 - 403920*D1*Dd*f*fd*g2*s + 124080*D1*Dd*f*fd*g2 - 2240*D1*Ddd*f**4*r*s + 1120*D1*Ddd*f**4*r - 2240*D1*Ddd*f**4*s**2 + 2800*D1*Ddd*f**4*s - 1120*D1*Ddd*f**4 + 84480*D1*Ddd*f**2*g2*r**2 + 163680*D1*Ddd*f**2*g2*r*s - 124080*D1*Ddd*f**2*g2*r + 79200*D1*Ddd*f**2*g2*s**2 - 120120*D1*Ddd*f**2*g2*s + 60720*D1*Ddd*f**2*g2 - 6720*Dd**2*f**4*r*s + 3360*Dd**2*f**4*r - 6720*Dd**2*f**4*s**2 + 8400*Dd**2*f**4*s - 2240*Dd**2*f**4 + 253440*Dd**2*f**2*g2*r**2 + 491040*Dd**2*f**2*g2*r*s - 372240*Dd**2*f**2*g2*r + 237600*Dd**2*f**2*g2*s**2 - 360360*Dd**2*f**2*g2*s + 121440*Dd**2*f**2*g2 + 165*b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(28*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-28*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-28*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(164*D1**2*K*fd*r**2 + 328*D1**2*K*fd*r*s + 200*D1**2*K*fd*r + 164*D1**2*K*fd*s**2 + 200*D1**2*K*fd*s - 100*D1**2*K*fd - 236*D1**2*K*fdd*r**2 - 472*D1**2*K*fdd*r*s - 240*D1**2*K*fdd*r - 236*D1**2*K*fdd*s**2 - 240*D1**2*K*fdd*s + 120*D1**2*K*fdd - 5*D1**2*bdd1*(-28*K + 6*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 60*D1**2*f*fd*r**2 - 216*D1**2*f*fd*r*s + 68*D1**2*f*fd*r - 156*D1**2*f*fd*s**2 + 116*D1**2*f*fd*s - 58*D1**2*f*fd + 84*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 82*D1**2*f*fdd*r + 180*D1**2*f*fdd*s**2 - 130*D1**2*f*fdd*s + 65*D1**2*f*fdd + 84*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 82*D1**2*fd**2*r + 180*D1**2*fd**2*s**2 - 130*D1**2*fd**2*s - 50*D1**2*fd**2 - 31*D1**2*fd*r**2 - 102*D1**2*fd*r*s - 50*D1**2*fd*r - 71*D1**2*fd*s**2 - 50*D1**2*fd*s + 25*D1**2*fd + 47*D1**2*fdd*r**2 + 142*D1**2*fdd*r*s + 60*D1**2*fdd*r + 95*D1**2*fdd*s**2 + 60*D1**2*fdd*s - 30*D1**2*fdd + 560*D1**2*gd2*r**2 + 1120*D1**2*gd2*r*s - 1120*D1**2*gd2*r + 560*D1**2*gd2*s**2 - 1120*D1**2*gd2*s + 560*D1**2*gd2 - 280*D1**2*gdd2*r**2 - 560*D1**2*gdd2*r*s + 560*D1**2*gdd2*r - 280*D1**2*gdd2*s**2 + 560*D1**2*gdd2*s - 280*D1**2*gdd2 + 656*D1*Dd*K*f*r**2 + 1312*D1*Dd*K*f*r*s - 984*D1*Dd*K*f*r + 656*D1*Dd*K*f*s**2 - 984*D1*Dd*K*f*s + 492*D1*Dd*K*f - 1888*D1*Dd*K*fd*r**2 - 3776*D1*Dd*K*fd*r*s + 456*D1*Dd*K*fd*r - 1888*D1*Dd*K*fd*s**2 + 456*D1*Dd*K*fd*s + 720*D1*Dd*K*fd - 120*D1*Dd*f**2*r**2 - 432*D1*Dd*f**2*r*s + 276*D1*Dd*f**2*r - 312*D1*Dd*f**2*s**2 + 420*D1*Dd*f**2*s - 186*D1*Dd*f**2 + 672*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 1024*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 1504*D1*Dd*f*fd*s + 342*D1*Dd*f*fd - 124*D1*Dd*f*r**2 - 408*D1*Dd*f*r*s + 266*D1*Dd*f*r - 284*D1*Dd*f*s**2 + 386*D1*Dd*f*s - 173*D1*Dd*f + 376*D1*Dd*fd*r**2 + 1136*D1*Dd*fd*r*s - 138*D1*Dd*fd*r + 760*D1*Dd*fd*s**2 - 282*D1*Dd*fd*s - 180*D1*Dd*fd + 2240*D1*Dd*g2*r**2 + 4480*D1*Dd*g2*r*s - 3360*D1*Dd*g2*r + 2240*D1*Dd*g2*s**2 - 3360*D1*Dd*g2*s + 1680*D1*Dd*g2 - 2240*D1*Dd*gd2*r**2 - 4480*D1*Dd*gd2*r*s + 3920*D1*Dd*gd2*r - 2240*D1*Dd*gd2*s**2 + 3920*D1*Dd*gd2*s - 1680*D1*Dd*gd2 - 944*D1*Ddd*K*f*r**2 - 1888*D1*Ddd*K*f*r*s + 1416*D1*Ddd*K*f*r - 944*D1*Ddd*K*f*s**2 + 1416*D1*Ddd*K*f*s - 708*D1*Ddd*K*f + 168*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 348*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 492*D1*Ddd*f**2*s + 222*D1*Ddd*f**2 + 188*D1*Ddd*f*r**2 + 568*D1*Ddd*f*r*s - 378*D1*Ddd*f*r + 380*D1*Ddd*f*s**2 - 522*D1*Ddd*f*s + 237*D1*Ddd*f - 1120*D1*Ddd*g2*r**2 - 2240*D1*Ddd*g2*r*s + 1680*D1*Ddd*g2*r - 1120*D1*Ddd*g2*s**2 + 1680*D1*Ddd*g2*s - 840*D1*Ddd*g2 + 5*D1*bd1*(D1*(5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(28*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-28*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 2832*Dd**2*K*f*r**2 - 5664*Dd**2*K*f*r*s + 4248*Dd**2*K*f*r - 2832*Dd**2*K*f*s**2 + 4248*Dd**2*K*f*s - 1416*Dd**2*K*f + 504*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 1044*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1476*Dd**2*f**2*s + 444*Dd**2*f**2 + 564*Dd**2*f*r**2 + 1704*Dd**2*f*r*s - 1134*Dd**2*f*r + 1140*Dd**2*f*s**2 - 1566*Dd**2*f*s + 474*Dd**2*f - 3360*Dd**2*g2*r**2 - 6720*Dd**2*g2*r*s + 5040*Dd**2*g2*r - 3360*Dd**2*g2*s**2 + 5040*Dd**2*g2*s - 1680*Dd**2*g2) + b1*(-15576*D1**2*K*bdd1*f*r**2 - 31152*D1**2*K*bdd1*f*r*s + 39072*D1**2*K*bdd1*f*r - 15576*D1**2*K*bdd1*f*s**2 + 39072*D1**2*K*bdd1*f*s - 19536*D1**2*K*bdd1*f + 16896*D1**2*K*f*fd*r**2 + 31152*D1**2*K*f*fd*r*s - 16896*D1**2*K*f*fd*r + 14256*D1**2*K*f*fd*s**2 - 15576*D1**2*K*f*fd*s + 8448*D1**2*K*f*fd - 21120*D1**2*K*f*fdd*r**2 - 40920*D1**2*K*f*fdd*r*s + 21120*D1**2*K*f*fdd*r - 19800*D1**2*K*f*fdd*s**2 + 20460*D1**2*K*f*fdd*s - 10560*D1**2*K*f*fdd - 21120*D1**2*K*fd**2*r**2 - 40920*D1**2*K*fd**2*r*s + 21120*D1**2*K*fd**2*r - 19800*D1**2*K*fd**2*s**2 + 20460*D1**2*K*fd**2*s + 3300*D1**2*b2*fd*r**2 + 6600*D1**2*b2*fd*r*s + 3300*D1**2*b2*fd*s**2 - 3960*D1**2*b2*fdd*r**2 - 7920*D1**2*b2*fdd*r*s - 3960*D1**2*b2*fdd*s**2 - 330*D1**2*bd1**2*(-28*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2772*D1**2*bdd1*f**2*r**2 + 8712*D1**2*bdd1*f**2*r*s - 8778*D1**2*bdd1*f**2*r + 5940*D1**2*bdd1*f**2*s**2 - 11946*D1**2*bdd1*f**2*s + 5181*D1**2*bdd1*f**2 + 3102*D1**2*bdd1*f*r**2 + 9372*D1**2*bdd1*f*r*s - 9768*D1**2*bdd1*f*r + 6270*D1**2*bdd1*f*s**2 - 12936*D1**2*bdd1*f*s + 5676*D1**2*bdd1*f - 18480*D1**2*bdd1*g2*r**2 - 36960*D1**2*bdd1*g2*r*s + 18480*D1**2*bdd1*g2*r - 18480*D1**2*bdd1*g2*s**2 + 18480*D1**2*bdd1*g2*s - 9240*D1**2*bdd1*g2 - 3960*D1**2*bdd2*f*r**2 - 7920*D1**2*bdd2*f*r*s + 7920*D1**2*bdd2*f*r - 3960*D1**2*bdd2*f*s**2 + 7920*D1**2*bdd2*f*s - 3960*D1**2*bdd2*f - 4800*D1**2*f**2*fd*r**2 - 10980*D1**2*f**2*fd*r*s + 6200*D1**2*f**2*fd*r - 6180*D1**2*f**2*fd*s**2 + 7120*D1**2*f**2*fd*s - 3000*D1**2*f**2*fd + 5865*D1**2*f**2*fdd*r**2 + 13410*D1**2*f**2*fdd*r*s - 7720*D1**2*f**2*fdd*r + 7545*D1**2*f**2*fdd*s**2 - 8840*D1**2*f**2*fdd*s + 3810*D1**2*f**2*fdd + 11730*D1**2*f*fd**2*r**2 + 26820*D1**2*f*fd**2*r*s - 15440*D1**2*f*fd**2*r + 15090*D1**2*f*fd**2*s**2 - 17680*D1**2*f*fd**2*s + 3810*D1**2*f*fd**2 - 3564*D1**2*f*fd*r**2 - 8712*D1**2*f*fd*r*s + 3564*D1**2*f*fd*r - 5148*D1**2*f*fd*s**2 + 4356*D1**2*f*fd*s - 1782*D1**2*f*fd + 4554*D1**2*f*fdd*r**2 + 11484*D1**2*f*fdd*r*s - 4554*D1**2*f*fdd*r + 6930*D1**2*f*fdd*s**2 - 5742*D1**2*f*fdd*s + 2277*D1**2*f*fdd - 10824*D1**2*f*gd2*r**2 - 21648*D1**2*f*gd2*r*s + 21648*D1**2*f*gd2*r - 10824*D1**2*f*gd2*s**2 + 21648*D1**2*f*gd2*s - 10824*D1**2*f*gd2 + 15576*D1**2*f*gdd2*r**2 + 31152*D1**2*f*gdd2*r*s - 31152*D1**2*f*gdd2*r + 15576*D1**2*f*gdd2*s**2 - 31152*D1**2*f*gdd2*s + 15576*D1**2*f*gdd2 + 4554*D1**2*fd**2*r**2 + 11484*D1**2*fd**2*r*s - 4554*D1**2*fd**2*r + 6930*D1**2*fd**2*s**2 - 5742*D1**2*fd**2*s - 10824*D1**2*fd*g2*r**2 - 21648*D1**2*fd*g2*r*s - 13200*D1**2*fd*g2*r - 10824*D1**2*fd*g2*s**2 - 13200*D1**2*fd*g2*s + 6600*D1**2*fd*g2 + 31152*D1**2*fd*gd2*r**2 + 62304*D1**2*fd*gd2*r*s - 15312*D1**2*fd*gd2*r + 31152*D1**2*fd*gd2*s**2 - 15312*D1**2*fd*gd2*s - 15840*D1**2*fd*gd2 + 15576*D1**2*fdd*g2*r**2 + 31152*D1**2*fdd*g2*r*s + 15840*D1**2*fdd*g2*r + 15576*D1**2*fdd*g2*s**2 + 15840*D1**2*fdd*g2*s - 7920*D1**2*fdd*g2 + 33792*D1*Dd*K*f**2*r**2 + 62304*D1*Dd*K*f**2*r*s - 48048*D1*Dd*K*f**2*r + 28512*D1*Dd*K*f**2*s**2 - 44088*D1*Dd*K*f**2*s + 22704*D1*Dd*K*f**2 - 168960*D1*Dd*K*f*fd*r**2 - 327360*D1*Dd*K*f*fd*r*s + 208560*D1*Dd*K*f*fd*r - 158400*D1*Dd*K*f*fd*s**2 + 201960*D1*Dd*K*f*fd*s - 62040*D1*Dd*K*f*fd + 13200*D1*Dd*b2*f*r**2 + 26400*D1*Dd*b2*f*r*s - 19800*D1*Dd*b2*f*r + 13200*D1*Dd*b2*f*s**2 - 19800*D1*Dd*b2*f*s + 9900*D1*Dd*b2*f - 31680*D1*Dd*b2*fd*r**2 - 63360*D1*Dd*b2*fd*r*s + 23760*D1*Dd*b2*fd*r - 31680*D1*Dd*b2*fd*s**2 + 23760*D1*Dd*b2*fd*s - 6400*D1*Dd*f**3*r**2 - 14640*D1*Dd*f**3*r*s + 10520*D1*Dd*f**3*r - 8240*D1*Dd*f**3*s**2 + 11900*D1*Dd*f**3*s - 5720*D1*Dd*f**3 + 46920*D1*Dd*f**2*fd*r**2 + 107280*D1*Dd*f**2*fd*r*s - 69430*D1*Dd*f**2*fd*r + 60360*D1*Dd*f**2*fd*s**2 - 78950*D1*Dd*f**2*fd*s + 25400*D1*Dd*f**2*fd - 7128*D1*Dd*f**2*r**2 - 17424*D1*Dd*f**2*r*s + 12276*D1*Dd*f**2*r - 10296*D1*Dd*f**2*s**2 + 14652*D1*Dd*f**2*s - 6930*D1*Dd*f**2 + 36432*D1*Dd*f*fd*r**2 + 91872*D1*Dd*f*fd*r*s - 50292*D1*Dd*f*fd*r + 55440*D1*Dd*f*fd*s**2 - 62172*D1*Dd*f*fd*s + 16038*D1*Dd*f*fd - 43296*D1*Dd*f*g2*r**2 - 86592*D1*Dd*f*g2*r*s + 64944*D1*Dd*f*g2*r - 43296*D1*Dd*f*g2*s**2 + 64944*D1*Dd*f*g2*s - 32472*D1*Dd*f*g2 + 124608*D1*Dd*f*gd2*r**2 + 249216*D1*Dd*f*gd2*r*s - 218064*D1*Dd*f*gd2*r + 124608*D1*Dd*f*gd2*s**2 - 218064*D1*Dd*f*gd2*s + 93456*D1*Dd*f*gd2 + 124608*D1*Dd*fd*g2*r**2 + 249216*D1*Dd*fd*g2*r*s - 30096*D1*Dd*fd*g2*r + 124608*D1*Dd*fd*g2*s**2 - 30096*D1*Dd*fd*g2*s - 47520*D1*Dd*fd*g2 - 42240*D1*Ddd*K*f**2*r**2 - 81840*D1*Ddd*K*f**2*r*s + 62040*D1*Ddd*K*f**2*r - 39600*D1*Ddd*K*f**2*s**2 + 60060*D1*Ddd*K*f**2*s - 30360*D1*Ddd*K*f**2 - 15840*D1*Ddd*b2*f*r**2 - 31680*D1*Ddd*b2*f*r*s + 23760*D1*Ddd*b2*f*r - 15840*D1*Ddd*b2*f*s**2 + 23760*D1*Ddd*b2*f*s - 11880*D1*Ddd*b2*f + 7820*D1*Ddd*f**3*r**2 + 17880*D1*Ddd*f**3*r*s - 12850*D1*Ddd*f**3*r + 10060*D1*Ddd*f**3*s**2 - 14530*D1*Ddd*f**3*s + 6985*D1*Ddd*f**3 + 9108*D1*Ddd*f**2*r**2 + 22968*D1*Ddd*f**2*r*s - 16038*D1*Ddd*f**2*r + 13860*D1*Ddd*f**2*s**2 - 19602*D1*Ddd*f**2*s + 9207*D1*Ddd*f**2 + 62304*D1*Ddd*f*g2*r**2 + 124608*D1*Ddd*f*g2*r*s - 93456*D1*Ddd*f*g2*r + 62304*D1*Ddd*f*g2*s**2 - 93456*D1*Ddd*f*g2*s + 46728*D1*Ddd*f*g2 - 33*D1*bd1*(D1*(4*f**2*(15*r**2 + r*(54*s - 52) + 39*s**2 - 76*s + 32) - f*(4*K*(82*r**2 + 164*r*s - 214*r + 82*s**2 - 214*s + 107) + 24*fd*(14*r**2 + r*(44*s - 29) + 30*s**2 - 41*s + 13) - 62*r**2 - 204*r*s + 214*r - 142*s**2 + 294*s - 127) + 4*fd*(4*K*(59*r**2 + 2*r*(59*s - 22) + 59*s**2 - 44*s - 15) - 47*r**2 + r*(44 - 142*s) - 95*s**2 + 68*s + 15) - 560*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 560*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*f**2*(336*r**2 + 176*r*(6*s - 5) + 720*s**2 - 1216*s + 495) + 4*Dd*f*(4*K*(236*r**2 + r*(472*s - 473) + 236*s**2 - 473*s + 222) - 188*r**2 + r*(485 - 568*s) - 380*s**2 + 653*s - 270) + 560*Dd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 660*D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 126720*Dd**2*K*f**2*r**2 - 245520*Dd**2*K*f**2*r*s + 186120*Dd**2*K*f**2*r - 118800*Dd**2*K*f**2*s**2 + 180180*Dd**2*K*f**2*s - 60720*Dd**2*K*f**2 - 47520*Dd**2*b2*f*r**2 - 95040*Dd**2*b2*f*r*s + 71280*Dd**2*b2*f*r - 47520*Dd**2*b2*f*s**2 + 71280*Dd**2*b2*f*s - 23760*Dd**2*b2*f + 23460*Dd**2*f**3*r**2 + 53640*Dd**2*f**3*r*s - 38550*Dd**2*f**3*r + 30180*Dd**2*f**3*s**2 - 43590*Dd**2*f**3*s + 13970*Dd**2*f**3 + 27324*Dd**2*f**2*r**2 + 68904*Dd**2*f**2*r*s - 48114*Dd**2*f**2*r + 41580*Dd**2*f**2*s**2 - 58806*Dd**2*f**2*s + 18414*Dd**2*f**2 + 186912*Dd**2*f*g2*r**2 + 373824*Dd**2*f*g2*r*s - 280368*Dd**2*f*g2*r + 186912*Dd**2*f*g2*s**2 - 280368*Dd**2*f*g2*s + 93456*Dd**2*f*g2) + 660*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 100*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2))/(693*d**2*k3**5) + D1**2*Pk1*Pkd3*ct*k1**3*st**2*(4*C - 2)*(11*D1*b1*(D1*bd1*(13*f*s*(2*r + 2*s - 1) - 3*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - 5*D1*f*fd*s + 3*D1*f*s*(-2*bdd1*r - 2*bdd1*s + bdd1 + fdd) + 3*D1*fd**2*(s - 1) - 6*Dd*bd1*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1) + 6*Dd*f*fd*(2*s - 1)) + 11*b1**2*(D1**2*(13*fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(13*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + f*(-33*D1**2*bd1**2*s*(2*r + 2*s - 1) + D1**2*(f*(-33*bdd1*s - 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 11*D1*bd1*(5*D1*f*s - 3*D1*fd*(s - 1) + 6*Dd*f*(1 - 2*s)) + D1*f*(Dd*(-39*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + 25*fd*(24*r*s - 10*r + 24*s**2 - 27*s + 7)) + 25*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) + 25*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(231*d**2*k2*k3**3) - D1**2*Pk1*Pkd3*ct*k1**3*(8*C - 4)*(D1*b1*(D1*(-6*f*fd*s + f*s*(-7*bdd1*(2*r + 2*s - 1) + 6*fdd) + 6*fd**2*(s - 1)) + 12*Dd*f*fd*(2*s - 1) - 7*bd1*(D1*(f*s*(-2*r - 2*s + 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1))) + 7*b1**2*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(-7*D1**2*bd1**2*s*(2*r + 2*s - 1) + D1**2*(f*(-6*bdd1*s - 5*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + 6*D1*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s)) - 5*D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + 5*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k2*k3**3) - D1**2*Pk1*Pkd3*ct*k1*k2**5*st**6*(20*C - 15)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(154*d**2*k3**7) - 3*D1**2*Pk1*Pkd3*ct*k1*k2**5*st**4*(-858*D1**2*bd1**2*f*(2*K - 1)*(r + s - 1)**2 - 13*D1*bd1*(D1*(50*f**3*(r + s - 1) + f**2*(132*C*(r + s - 1) - 50*fd*(3*r + 3*s - 2) - 99*r - 99*s + 99) + 264*f*(g2 - gd2)*(r + s - 1) - 264*fd*g2*(r + s)) - 2*Dd*f*(25*f**2 + 132*g2)*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*(D1**2*(2*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (2*K - 1)*(2*fd - fdd)*(r + s)**2) + D1*(2*Dd*(f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(2*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(2*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(-264*C*D1**2*f*fd*r**2 - 528*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*r - 264*C*D1**2*f*fd*s**2 + 264*C*D1**2*f*fd*s - 132*C*D1**2*f*fd - 528*C*D1*Dd*f**2*r**2 - 1056*C*D1*Dd*f**2*r*s + 792*C*D1*Dd*f**2*r - 528*C*D1*Dd*f**2*s**2 + 792*C*D1*Dd*f**2*s - 396*C*D1*Dd*f**2 - 66*D1**2*bdd1*f*(2*K - 1)*(r + s - 1)**2 - 150*D1**2*f**2*fd*r**2 - 300*D1**2*f**2*fd*r*s + 200*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 200*D1**2*f**2*fd*s - 100*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 + 198*D1**2*f*fd*r**2 + 396*D1**2*f*fd*r*s - 198*D1**2*f*fd*r + 198*D1**2*f*fd*s**2 - 198*D1**2*f*fd*s + 99*D1**2*f*fd - 264*D1**2*f*gd2*r**2 - 528*D1**2*f*gd2*r*s + 528*D1**2*f*gd2*r - 264*D1**2*f*gd2*s**2 + 528*D1**2*f*gd2*s - 264*D1**2*f*gd2 + 132*D1**2*f*gdd2*r**2 + 264*D1**2*f*gdd2*r*s - 264*D1**2*f*gdd2*r + 132*D1**2*f*gdd2*s**2 - 264*D1**2*f*gdd2*s + 132*D1**2*f*gdd2 - 264*D1**2*fd*g2*r**2 - 528*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*s**2 + 264*D1**2*fd*gd2*r**2 + 528*D1**2*fd*gd2*r*s - 264*D1**2*fd*gd2*r + 264*D1**2*fd*gd2*s**2 - 264*D1**2*fd*gd2*s + 132*D1**2*fdd*g2*r**2 + 264*D1**2*fdd*g2*r*s + 132*D1**2*fdd*g2*s**2 - 200*D1*Dd*f**3*r**2 - 400*D1*Dd*f**3*r*s + 300*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 300*D1*Dd*f**3*s - 150*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 850*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 850*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd + 396*D1*Dd*f**2*r**2 + 792*D1*Dd*f**2*r*s - 594*D1*Dd*f**2*r + 396*D1*Dd*f**2*s**2 - 594*D1*Dd*f**2*s + 297*D1*Dd*f**2 - 1056*D1*Dd*f*g2*r**2 - 2112*D1*Dd*f*g2*r*s + 1584*D1*Dd*f*g2*r - 1056*D1*Dd*f*g2*s**2 + 1584*D1*Dd*f*g2*s - 792*D1*Dd*f*g2 + 1056*D1*Dd*f*gd2*r**2 + 2112*D1*Dd*f*gd2*r*s - 1848*D1*Dd*f*gd2*r + 1056*D1*Dd*f*gd2*s**2 - 1848*D1*Dd*f*gd2*s + 792*D1*Dd*f*gd2 + 1056*D1*Dd*fd*g2*r**2 + 2112*D1*Dd*fd*g2*r*s - 792*D1*Dd*fd*g2*r + 1056*D1*Dd*fd*g2*s**2 - 792*D1*Dd*fd*g2*s + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 528*D1*Ddd*f*g2*r**2 + 1056*D1*Ddd*f*g2*r*s - 792*D1*Ddd*f*g2*r + 528*D1*Ddd*f*g2*s**2 - 792*D1*Ddd*f*g2*s + 396*D1*Ddd*f*g2 + 132*D1*bd1*(D1*(f**2*(r + s - 1) + f*(2*K - 1)*(r + s - 1) - fd*(2*K - 1)*(r + s)) - Dd*f*(2*K - 1)*(4*r + 4*s - 3))*(r + s - 1) + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 + 1584*Dd**2*f*g2*r**2 + 3168*Dd**2*f*g2*r*s - 2376*Dd**2*f*g2*r + 1584*Dd**2*f*g2*s**2 - 2376*Dd**2*f*g2*s + 792*Dd**2*f*g2) + f*(13*D1**2*bdd1*(25*f**2 + 132*g2)*(r + s - 1)**2 + f*(D1**2*(-f*(857*fd - 500*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 3000*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(-857*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 1000*fd*(4*r + 4*s - 3)**2) + 500*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 3000*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(1001*d**2*k3**7) - D1**2*Pk1*Pkd3*ct*k1*k2**3*st**6*(40*C - 30)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(693*d**2*k3**5) + D1**2*Pk1*Pkd3*ct*k1*k2**3*st**4*(-165*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(48*C*D1**2*f*fd*r**2 + 32*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 16*C*D1**2*f*fd*s - 8*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 112*C*D1**2*f*fdd*r*s - 56*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 36*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 112*C*D1**2*fd**2*r*s - 56*C*D1**2*fd**2*r + 72*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s + 96*C*D1*Dd*f**2*r**2 + 64*C*D1*Dd*f**2*r*s - 80*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 16*C*D1*Dd*f**2*s + 8*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 896*C*D1*Dd*f*fd*r*s - 528*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 688*C*D1*Dd*f*fd*s + 200*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 224*C*D1*Ddd*f**2*r*s - 152*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 200*C*D1*Ddd*f**2*s + 92*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 672*C*Dd**2*f**2*r*s - 456*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 600*C*Dd**2*f**2*s + 184*C*Dd**2*f**2 - 5*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 32*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 84*D1**2*f*fdd*r*s + 42*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 54*D1**2*f*fdd*s - 27*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 84*D1**2*fd**2*r*s + 42*D1**2*fd**2*r - 54*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s - 64*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 56*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 4*D1*Dd*f**2*s - 8*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 672*D1*Dd*f*fd*r*s + 396*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 516*D1*Dd*f*fd*s - 150*D1*Dd*f*fd - 60*D1*Ddd*f**2*r**2 - 168*D1*Ddd*f**2*r*s + 114*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 150*D1*Ddd*f**2*s - 69*D1*Ddd*f**2 + 10*D1*bd1*(4*C - 3)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 180*Dd**2*f**2*r**2 - 504*Dd**2*f**2*r*s + 342*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 450*Dd**2*f**2*s - 138*Dd**2*f**2) + f*(330*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 33*D1**2*bdd1*f*(4*C - 3)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) - 8*D1**2*(f*(2*fd - fdd)*(C*(111*r**2 + 6*r*(35*s - 24) + 99*s**2 - 136*s + 70) - 78*r**2 + r*(101 - 147*s) - 69*s**2 + 95*s - 49) + fd**2*(-2*C*(111*r**2 + 6*r*(35*s - 24) + 99*s**2 - 136*s + 35) + 156*r**2 + r*(294*s - 202) + 138*s**2 - 190*s + 49)) - 66*D1*bd1*(D1*(2*f*(r + s - 1)*(6*C*r - 2*C*(s + 3) - 4*r + s + 4) + fd*(4*C - 3)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7)) + Dd*f*(4*C - 3)*(20*r**2 + r*(56*s - 39) + 36*s**2 - 53*s + 19)) - 8*D1*f*(Dd*(2*f*(C*(148*r**2 + r*(280*s - 214) + 132*s**2 - 202*s + 103) - 104*r**2 - 2*r*(98*s - 75) - 92*s**2 + 141*s - 72) + fd*(-2*C*(444*r**2 + 21*r*(40*s - 29) + 396*s**2 - 575*s + 208) + 624*r**2 + 14*r*(84*s - 61) + 552*s**2 - 803*s + 291)) + Ddd*f*(-C*(148*r**2 + r*(280*s - 214) + 132*s**2 - 202*s + 103) + 104*r**2 + 2*r*(98*s - 75) + 92*s**2 - 141*s + 72)) - 8*Dd**2*f**2*(-2*C*(222*r**2 + r*(420*s - 321) + 198*s**2 - 303*s + 103) + 312*r**2 + 6*r*(98*s - 75) + 276*s**2 - 423*s + 144)))/(231*d**2*k3**5) - D1**2*Pk1*Pkd3*ct*k1*k2**3*st**2*(-41184*C*D1**2*bd1*f**2*r**2 - 58344*C*D1**2*bd1*f**2*r*s + 99528*C*D1**2*bd1*f**2*r - 17160*C*D1**2*bd1*f**2*s**2 + 75504*C*D1**2*bd1*f**2*s - 49764*C*D1**2*bd1*f**2 - 149292*C*D1**2*f**2*fd*r**2 - 226512*C*D1**2*f**2*fd*r*s + 175032*C*D1**2*f**2*fd*r - 77220*C*D1**2*f**2*fd*s**2 + 126984*C*D1**2*f**2*fd*s - 75504*C*D1**2*f**2*fd - 199056*C*D1*Dd*f**3*r**2 - 302016*C*D1*Dd*f**3*r*s + 250536*C*D1*Dd*f**3*r - 102960*C*D1*Dd*f**3*s**2 + 178464*C*D1*Dd*f**3*s - 101244*C*D1*Dd*f**3 - 34320*D1**2*K*bd1**2*f*r**2 - 37752*D1**2*K*bd1**2*f*r*s + 61776*D1**2*K*bd1**2*f*r - 3432*D1**2*K*bd1**2*f*s**2 + 30888*D1**2*K*bd1**2*f*s - 27456*D1**2*K*bd1**2*f + 87516*D1**2*K*bd1*f**2*r**2 + 154440*D1**2*K*bd1*f**2*r*s - 154440*D1**2*K*bd1*f**2*r + 66924*D1**2*K*bd1*f**2*s**2 - 133848*D1**2*K*bd1*f**2*s + 66924*D1**2*K*bd1*f**2 - 223080*D1**2*K*bd1*f*fd*r**2 - 384384*D1**2*K*bd1*f*fd*r*s + 303732*D1**2*K*bd1*f*fd*r - 161304*D1**2*K*bd1*f*fd*s**2 + 257400*D1**2*K*bd1*f*fd*s - 96096*D1**2*K*bd1*f*fd - 55770*D1**2*K*bdd1*f**2*r**2 - 96096*D1**2*K*bdd1*f**2*r*s + 96096*D1**2*K*bdd1*f**2*r - 40326*D1**2*K*bdd1*f**2*s**2 + 80652*D1**2*K*bdd1*f**2*s - 40326*D1**2*K*bdd1*f**2 + 131274*D1**2*bd1**2*f**2*r**2 + 283140*D1**2*bd1**2*f**2*r*s - 272844*D1**2*bd1**2*f**2*r + 151866*D1**2*bd1**2*f**2*s**2 - 293436*D1**2*bd1**2*f**2*s + 141570*D1**2*bd1**2*f**2 + 17160*D1**2*bd1**2*f*r**2 + 24024*D1**2*bd1**2*f*r*s - 33462*D1**2*bd1**2*f*r + 6864*D1**2*bd1**2*f*s**2 - 23166*D1**2*bd1**2*f*s + 16302*D1**2*bd1**2*f + 120120*D1**2*bd1**2*g2*r**2 + 240240*D1**2*bd1**2*g2*r*s - 120120*D1**2*bd1**2*g2*r + 120120*D1**2*bd1**2*g2*s**2 - 120120*D1**2*bd1**2*g2*s - 51480*D1**2*bd1*bd2*f*r**2 - 102960*D1**2*bd1*bd2*f*r*s + 102960*D1**2*bd1*bd2*f*r - 51480*D1**2*bd1*bd2*f*s**2 + 102960*D1**2*bd1*bd2*f*s - 51480*D1**2*bd1*bd2*f - 70434*D1**2*bd1*f**3*r**2 - 111852*D1**2*bd1*f**3*r*s + 109434*D1**2*bd1*f**3*r - 41418*D1**2*bd1*f**3*s**2 + 80418*D1**2*bd1*f**3*s - 57525*D1**2*bd1*f**3 + 340002*D1**2*bd1*f**2*fd*r**2 + 479700*D1**2*bd1*f**2*fd*r*s - 447018*D1**2*bd1*f**2*fd*r + 139698*D1**2*bd1*f**2*fd*s**2 - 280098*D1**2*bd1*f**2*fd*s + 104208*D1**2*bd1*f**2*fd - 18876*D1**2*bd1*f**2*r**2 - 48048*D1**2*bd1*f**2*r*s + 16302*D1**2*bd1*f**2*r - 29172*D1**2*bd1*f**2*s**2 + 26598*D1**2*bd1*f**2*s - 3861*D1**2*bd1*f**2 + 111540*D1**2*bd1*f*fd*r**2 + 202488*D1**2*bd1*f*fd*r*s - 157014*D1**2*bd1*f*fd*r + 90948*D1**2*bd1*f*fd*s**2 - 141570*D1**2*bd1*f*fd*s + 50622*D1**2*bd1*f*fd - 260832*D1**2*bd1*f*g2*r**2 - 459888*D1**2*bd1*f*g2*r*s + 555984*D1**2*bd1*f*g2*r - 199056*D1**2*bd1*f*g2*s**2 + 494208*D1**2*bd1*f*g2*s - 277992*D1**2*bd1*f*g2 + 68640*D1**2*bd1*f*gd2*r**2 + 75504*D1**2*bd1*f*gd2*r*s - 123552*D1**2*bd1*f*gd2*r + 6864*D1**2*bd1*f*gd2*s**2 - 61776*D1**2*bd1*f*gd2*s + 54912*D1**2*bd1*f*gd2 + 68640*D1**2*bd1*fd*g2*r**2 + 75504*D1**2*bd1*fd*g2*r*s - 68640*D1**2*bd1*fd*g2*r + 6864*D1**2*bd1*fd*g2*s**2 - 37752*D1**2*bd1*fd*g2*s + 47190*D1**2*bd2*f**2*r**2 + 94380*D1**2*bd2*f**2*r*s - 94380*D1**2*bd2*f**2*r + 47190*D1**2*bd2*f**2*s**2 - 94380*D1**2*bd2*f**2*s + 47190*D1**2*bd2*f**2 - 102960*D1**2*bd2*f*fd*r**2 - 205920*D1**2*bd2*f*fd*r*s + 154440*D1**2*bd2*f*fd*r - 102960*D1**2*bd2*f*fd*s**2 + 154440*D1**2*bd2*f*fd*s - 51480*D1**2*bd2*f*fd + 56667*D1**2*bdd1*f**3*r**2 + 79950*D1**2*bdd1*f**3*r*s - 86892*D1**2*bdd1*f**3*r + 23283*D1**2*bdd1*f**3*s**2 - 53508*D1**2*bdd1*f**3*s + 44850*D1**2*bdd1*f**3 + 27885*D1**2*bdd1*f**2*r**2 + 50622*D1**2*bdd1*f**2*r*s - 50622*D1**2*bdd1*f**2*r + 22737*D1**2*bdd1*f**2*s**2 - 45474*D1**2*bdd1*f**2*s + 22737*D1**2*bdd1*f**2 + 34320*D1**2*bdd1*f*g2*r**2 + 37752*D1**2*bdd1*f*g2*r*s - 85800*D1**2*bdd1*f*g2*r + 3432*D1**2*bdd1*f*g2*s**2 - 54912*D1**2*bdd1*f*g2*s + 42900*D1**2*bdd1*f*g2 - 25740*D1**2*bdd2*f**2*r**2 - 51480*D1**2*bdd2*f**2*r*s + 51480*D1**2*bdd2*f**2*r - 25740*D1**2*bdd2*f**2*s**2 + 51480*D1**2*bdd2*f**2*s - 25740*D1**2*bdd2*f**2 + 67940*D1**2*f**3*fd*r**2 + 220040*D1**2*f**3*fd*r*s - 143990*D1**2*f**3*fd*r + 152100*D1**2*f**3*fd*s**2 - 207110*D1**2*f**3*fd*s + 93035*D1**2*f**3*fd - 81420*D1**2*f**3*fdd*r**2 - 256920*D1**2*f**3*fdd*r*s + 169170*D1**2*f**3*fdd*r - 175500*D1**2*f**3*fdd*s**2 + 239730*D1**2*f**3*fdd*s - 108105*D1**2*f**3*fdd - 244260*D1**2*f**2*fd**2*r**2 - 770760*D1**2*f**2*fd**2*r*s + 507510*D1**2*f**2*fd**2*r - 526500*D1**2*f**2*fd**2*s**2 + 719190*D1**2*f**2*fd**2*s - 216210*D1**2*f**2*fd**2 + 101673*D1**2*f**2*fd*r**2 + 146718*D1**2*f**2*fd*r*s - 116688*D1**2*f**2*fd*r + 45045*D1**2*f**2*fd*s**2 - 78936*D1**2*f**2*fd*s + 48906*D1**2*f**2*fd - 175032*D1**2*f**2*gd2*r**2 - 308880*D1**2*f**2*gd2*r*s + 308880*D1**2*f**2*gd2*r - 133848*D1**2*f**2*gd2*s**2 + 267696*D1**2*f**2*gd2*s - 133848*D1**2*f**2*gd2 + 111540*D1**2*f**2*gdd2*r**2 + 192192*D1**2*f**2*gdd2*r*s - 192192*D1**2*f**2*gdd2*r + 80652*D1**2*f**2*gdd2*s**2 - 161304*D1**2*f**2*gdd2*s + 80652*D1**2*f**2*gdd2 - 350064*D1**2*f*fd*g2*r**2 - 617760*D1**2*f*fd*g2*r*s + 350064*D1**2*f*fd*g2*r - 267696*D1**2*f*fd*g2*s**2 + 308880*D1**2*f*fd*g2*s - 175032*D1**2*f*fd*g2 + 446160*D1**2*f*fd*gd2*r**2 + 768768*D1**2*f*fd*gd2*r*s - 607464*D1**2*f*fd*gd2*r + 322608*D1**2*f*fd*gd2*s**2 - 514800*D1**2*f*fd*gd2*s + 192192*D1**2*f*fd*gd2 + 223080*D1**2*f*fdd*g2*r**2 + 384384*D1**2*f*fdd*g2*r*s - 223080*D1**2*f*fdd*g2*r + 161304*D1**2*f*fdd*g2*s**2 - 192192*D1**2*f*fdd*g2*s + 111540*D1**2*f*fdd*g2 + 223080*D1**2*fd**2*g2*r**2 + 384384*D1**2*fd**2*g2*r*s - 223080*D1**2*fd**2*g2*r + 161304*D1**2*fd**2*g2*s**2 - 192192*D1**2*fd**2*g2*s - 446160*D1*Dd*K*bd1*f**2*r**2 - 768768*D1*Dd*K*bd1*f**2*r*s + 688116*D1*Dd*K*bd1*f**2*r - 322608*D1*Dd*K*bd1*f**2*s**2 + 580008*D1*Dd*K*bd1*f**2*s - 257400*D1*Dd*K*bd1*f**2 + 453336*D1*Dd*bd1*f**3*r**2 + 639600*D1*Dd*bd1*f**3*r*s - 620802*D1*Dd*bd1*f**3*r + 186264*D1*Dd*bd1*f**3*s**2 - 387114*D1*Dd*bd1*f**3*s + 193908*D1*Dd*bd1*f**3 + 223080*D1*Dd*bd1*f**2*r**2 + 404976*D1*Dd*bd1*f**2*r*s - 359502*D1*Dd*bd1*f**2*r + 181896*D1*Dd*bd1*f**2*s**2 - 323466*D1*Dd*bd1*f**2*s + 141570*D1*Dd*bd1*f**2 + 274560*D1*Dd*bd1*f*g2*r**2 + 302016*D1*Dd*bd1*f*g2*r*s - 487344*D1*Dd*bd1*f*g2*r + 27456*D1*Dd*bd1*f*g2*s**2 - 271128*D1*Dd*bd1*f*g2*s + 195624*D1*Dd*bd1*f*g2 - 205920*D1*Dd*bd2*f**2*r**2 - 411840*D1*Dd*bd2*f**2*r*s + 360360*D1*Dd*bd2*f**2*r - 205920*D1*Dd*bd2*f**2*s**2 + 360360*D1*Dd*bd2*f**2*s - 154440*D1*Dd*bd2*f**2 + 67940*D1*Dd*f**4*r**2 + 220040*D1*Dd*f**4*r*s - 143990*D1*Dd*f**4*r + 152100*D1*Dd*f**4*s**2 - 207110*D1*Dd*f**4*s + 93035*D1*Dd*f**4 - 651360*D1*Dd*f**3*fd*r**2 - 2055360*D1*Dd*f**3*fd*r*s + 1353360*D1*Dd*f**3*fd*r - 1404000*D1*Dd*f**3*fd*s**2 + 1917840*D1*Dd*f**3*fd*s - 648630*D1*Dd*f**3*fd + 135564*D1*Dd*f**3*r**2 + 195624*D1*Dd*f**3*r*s - 165594*D1*Dd*f**3*r + 60060*D1*Dd*f**3*s**2 - 108966*D1*Dd*f**3*s + 63921*D1*Dd*f**3 - 700128*D1*Dd*f**2*g2*r**2 - 1235520*D1*Dd*f**2*g2*r*s + 967824*D1*Dd*f**2*g2*r - 535392*D1*Dd*f**2*g2*s**2 + 844272*D1*Dd*f**2*g2*s - 442728*D1*Dd*f**2*g2 + 892320*D1*Dd*f**2*gd2*r**2 + 1537536*D1*Dd*f**2*gd2*r*s - 1376232*D1*Dd*f**2*gd2*r + 645216*D1*Dd*f**2*gd2*s**2 - 1160016*D1*Dd*f**2*gd2*s + 514800*D1*Dd*f**2*gd2 + 1784640*D1*Dd*f*fd*g2*r**2 + 3075072*D1*Dd*f*fd*g2*r*s - 2107248*D1*Dd*f*fd*g2*r + 1290432*D1*Dd*f*fd*g2*s**2 - 1798368*D1*Dd*f*fd*g2*s + 607464*D1*Dd*f*fd*g2 - 81420*D1*Ddd*f**4*r**2 - 256920*D1*Ddd*f**4*r*s + 169170*D1*Ddd*f**4*r - 175500*D1*Ddd*f**4*s**2 + 239730*D1*Ddd*f**4*s - 108105*D1*Ddd*f**4 + 446160*D1*Ddd*f**2*g2*r**2 + 768768*D1*Ddd*f**2*g2*r*s - 607464*D1*Ddd*f**2*g2*r + 322608*D1*Ddd*f**2*g2*s**2 - 514800*D1*Ddd*f**2*g2*s + 272844*D1*Ddd*f**2*g2 - 244260*Dd**2*f**4*r**2 - 770760*Dd**2*f**4*r*s + 507510*Dd**2*f**4*r - 526500*Dd**2*f**4*s**2 + 719190*Dd**2*f**4*s - 216210*Dd**2*f**4 + 1338480*Dd**2*f**2*g2*r**2 + 2306304*Dd**2*f**2*g2*r*s - 1822392*Dd**2*f**2*g2*r + 967824*Dd**2*f**2*g2*s**2 - 1544400*Dd**2*f**2*g2*s + 545688*Dd**2*f**2*g2 + 2145*b1**3*(D1**2*(32*fd - 9*fdd)*(r + s - 1)**2 + D1*(2*Dd*(16*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 9*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(14*K + 9*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(14*K + 9*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(-140*C*D1**2*fd*r**2 - 280*C*D1**2*fd*r*s + 280*C*D1**2*fd*r - 140*C*D1**2*fd*s**2 + 280*C*D1**2*fd*s - 140*C*D1**2*fd - 560*C*D1*Dd*f*r**2 - 1120*C*D1*Dd*f*r*s + 840*C*D1*Dd*f*r - 560*C*D1*Dd*f*s**2 + 840*C*D1*Dd*f*s - 420*C*D1*Dd*f + 304*D1**2*K*fd*r**2 + 536*D1**2*K*fd*r*s + 40*D1**2*K*fd*r + 232*D1**2*K*fd*s**2 + 40*D1**2*K*fd*s - 20*D1**2*K*fd - 40*D1**2*K*fdd*r**2 - 44*D1**2*K*fdd*r*s - 20*D1**2*K*fdd*r - 4*D1**2*K*fdd*s**2 - 20*D1**2*K*fdd*s + 10*D1**2*K*fdd - 5*D1**2*bdd1*(14*K + 9*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 350*D1**2*f*fd*r**2 - 748*D1**2*f*fd*r*s + 344*D1**2*f*fd*r - 398*D1**2*f*fd*s**2 + 368*D1**2*f*fd*s - 184*D1**2*f*fd + 306*D1**2*f*fdd*r**2 + 660*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 354*D1**2*f*fdd*s**2 - 354*D1**2*f*fdd*s + 177*D1**2*f*fdd + 306*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 354*D1**2*fd**2*s**2 - 354*D1**2*fd**2*s - 33*D1**2*fd*r**2 - 70*D1**2*fd*r*s - 230*D1**2*fd*r - 37*D1**2*fd*s**2 - 230*D1**2*fd*s + 115*D1**2*fd + 20*D1**2*fdd*r**2 + 28*D1**2*fdd*r*s + 10*D1**2*fdd*r + 8*D1**2*fdd*s**2 + 10*D1**2*fdd*s - 5*D1**2*fdd - 280*D1**2*gd2*r**2 - 560*D1**2*gd2*r*s + 560*D1**2*gd2*r - 280*D1**2*gd2*s**2 + 560*D1**2*gd2*s - 280*D1**2*gd2 + 140*D1**2*gdd2*r**2 + 280*D1**2*gdd2*r*s - 280*D1**2*gdd2*r + 140*D1**2*gdd2*s**2 - 280*D1**2*gdd2*s + 140*D1**2*gdd2 + 1216*D1*Dd*K*f*r**2 + 2144*D1*Dd*K*f*r*s - 1680*D1*Dd*K*f*r + 928*D1*Dd*K*f*s**2 - 1464*D1*Dd*K*f*s + 768*D1*Dd*K*f - 320*D1*Dd*K*fd*r**2 - 352*D1*Dd*K*fd*r*s + 88*D1*Dd*K*fd*r - 32*D1*Dd*K*fd*s**2 - 20*D1*Dd*K*fd*s + 60*D1*Dd*K*fd - 700*D1*Dd*f**2*r**2 - 1496*D1*Dd*f**2*r*s + 1098*D1*Dd*f**2*r - 796*D1*Dd*f**2*s**2 + 1170*D1*Dd*f**2*s - 573*D1*Dd*f**2 + 2448*D1*Dd*f*fd*r**2 + 5280*D1*Dd*f*fd*r*s - 3252*D1*Dd*f*fd*r + 2832*D1*Dd*f*fd*s**2 - 3492*D1*Dd*f*fd*s + 1038*D1*Dd*f*fd - 132*D1*Dd*f*r**2 - 280*D1*Dd*f*r*s + 206*D1*Dd*f*r - 148*D1*Dd*f*s**2 + 218*D1*Dd*f*s - 107*D1*Dd*f + 160*D1*Dd*fd*r**2 + 224*D1*Dd*fd*r*s - 56*D1*Dd*fd*r + 64*D1*Dd*fd*s**2 - 20*D1*Dd*fd*s - 30*D1*Dd*fd - 1120*D1*Dd*g2*r**2 - 2240*D1*Dd*g2*r*s + 1680*D1*Dd*g2*r - 1120*D1*Dd*g2*s**2 + 1680*D1*Dd*g2*s - 840*D1*Dd*g2 + 1120*D1*Dd*gd2*r**2 + 2240*D1*Dd*gd2*r*s - 1960*D1*Dd*gd2*r + 1120*D1*Dd*gd2*s**2 - 1960*D1*Dd*gd2*s + 840*D1*Dd*gd2 - 160*D1*Ddd*K*f*r**2 - 176*D1*Ddd*K*f*r*s + 168*D1*Ddd*K*f*r - 16*D1*Ddd*K*f*s**2 + 60*D1*Ddd*K*f*s - 48*D1*Ddd*K*f + 612*D1*Ddd*f**2*r**2 + 1320*D1*Ddd*f**2*r*s - 966*D1*Ddd*f**2*r + 708*D1*Ddd*f**2*s**2 - 1038*D1*Ddd*f**2*s + 507*D1*Ddd*f**2 + 80*D1*Ddd*f*r**2 + 112*D1*Ddd*f*r*s - 96*D1*Ddd*f*r + 32*D1*Ddd*f*s**2 - 60*D1*Ddd*f*s + 36*D1*Ddd*f + 560*D1*Ddd*g2*r**2 + 1120*D1*Ddd*g2*r*s - 840*D1*Ddd*g2*r + 560*D1*Ddd*g2*s**2 - 840*D1*Ddd*g2*s + 420*D1*Ddd*g2 + 10*D1*bd1*(D1*(16*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(14*K + 9*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 480*Dd**2*K*f*r**2 - 528*Dd**2*K*f*r*s + 504*Dd**2*K*f*r - 48*Dd**2*K*f*s**2 + 180*Dd**2*K*f*s - 96*Dd**2*K*f + 1836*Dd**2*f**2*r**2 + 3960*Dd**2*f**2*r*s - 2898*Dd**2*f**2*r + 2124*Dd**2*f**2*s**2 - 3114*Dd**2*f**2*s + 1014*Dd**2*f**2 + 240*Dd**2*f*r**2 + 336*Dd**2*f*r*s - 288*Dd**2*f*r + 96*Dd**2*f*s**2 - 180*Dd**2*f*s + 72*Dd**2*f + 1680*Dd**2*g2*r**2 + 3360*Dd**2*g2*r*s - 2520*Dd**2*g2*r + 1680*Dd**2*g2*s**2 - 2520*Dd**2*g2*s + 840*Dd**2*g2) - 39*b1*(2112*C*D1**2*f*fd*r**2 + 2992*C*D1**2*f*fd*r*s - 1056*C*D1**2*f*fd*r + 880*C*D1**2*f*fd*s**2 - 440*C*D1**2*f*fd*s + 220*C*D1**2*f*fd + 4224*C*D1*Dd*f**2*r**2 + 5984*C*D1*Dd*f**2*r*s - 5104*C*D1*Dd*f**2*r + 1760*C*D1*Dd*f**2*s**2 - 3256*C*D1*Dd*f**2*s + 1936*C*D1*Dd*f**2 + 880*D1**2*K*bdd1*f*r**2 + 968*D1**2*K*bdd1*f*r*s - 1584*D1**2*K*bdd1*f*r + 88*D1**2*K*bdd1*f*s**2 - 792*D1**2*K*bdd1*f*s + 594*D1**2*K*bdd1*f - 4488*D1**2*K*f*fd*r**2 - 7920*D1**2*K*f*fd*r*s + 4488*D1**2*K*f*fd*r - 3432*D1**2*K*f*fd*s**2 + 3960*D1**2*K*f*fd*s - 2244*D1**2*K*f*fd + 2860*D1**2*K*f*fdd*r**2 + 4928*D1**2*K*f*fdd*r*s - 2860*D1**2*K*f*fdd*r + 2068*D1**2*K*f*fdd*s**2 - 2464*D1**2*K*f*fdd*s + 1430*D1**2*K*f*fdd + 2860*D1**2*K*fd**2*r**2 + 4928*D1**2*K*fd**2*r*s - 2860*D1**2*K*fd**2*r + 2068*D1**2*K*fd**2*s**2 - 2464*D1**2*K*fd**2*s - 2090*D1**2*b2*fd*r**2 - 4180*D1**2*b2*fd*r*s - 2090*D1**2*b2*fd*s**2 + 660*D1**2*b2*fdd*r**2 + 1320*D1**2*b2*fdd*r*s + 660*D1**2*b2*fdd*s**2 + 110*D1**2*bd1**2*(14*K + 9*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 3366*D1**2*bdd1*f**2*r**2 - 7260*D1**2*bdd1*f**2*r*s + 6996*D1**2*bdd1*f**2*r - 3894*D1**2*bdd1*f**2*s**2 + 7524*D1**2*bdd1*f**2*s - 3630*D1**2*bdd1*f**2 - 440*D1**2*bdd1*f*r**2 - 616*D1**2*bdd1*f*r*s + 858*D1**2*bdd1*f*r - 176*D1**2*bdd1*f*s**2 + 594*D1**2*bdd1*f*s - 363*D1**2*bdd1*f - 3080*D1**2*bdd1*g2*r**2 - 6160*D1**2*bdd1*g2*r*s + 3080*D1**2*bdd1*g2*r - 3080*D1**2*bdd1*g2*s**2 + 3080*D1**2*bdd1*g2*s - 1540*D1**2*bdd1*g2 + 660*D1**2*bdd2*f*r**2 + 1320*D1**2*bdd2*f*r*s - 1320*D1**2*bdd2*f*r + 660*D1**2*bdd2*f*s**2 - 1320*D1**2*bdd2*f*s + 660*D1**2*bdd2*f + 5418*D1**2*f**2*fd*r**2 + 8604*D1**2*f**2*fd*r*s - 6542*D1**2*f**2*fd*r + 3186*D1**2*f**2*fd*s**2 - 5054*D1**2*f**2*fd*s + 2455*D1**2*f**2*fd - 4359*D1**2*f**2*fdd*r**2 - 6150*D1**2*f**2*fdd*r*s + 4778*D1**2*f**2*fdd*r - 1791*D1**2*f**2*fdd*s**2 + 3066*D1**2*f**2*fdd*s - 1497*D1**2*f**2*fdd - 8718*D1**2*f*fd**2*r**2 - 12300*D1**2*f*fd**2*r*s + 9556*D1**2*f*fd**2*r - 3582*D1**2*f*fd**2*s**2 + 6132*D1**2*f*fd**2*s - 2622*D1**2*f*fd**2 + 968*D1**2*f*fd*r**2 + 2464*D1**2*f*fd*r*s - 1782*D1**2*f*fd*r + 1496*D1**2*f*fd*s**2 - 2046*D1**2*f*fd*s + 1133*D1**2*f*fd - 1430*D1**2*f*fdd*r**2 - 2596*D1**2*f*fdd*r*s + 1430*D1**2*f*fdd*r - 1166*D1**2*f*fdd*s**2 + 1298*D1**2*f*fdd*s - 715*D1**2*f*fdd + 6688*D1**2*f*gd2*r**2 + 11792*D1**2*f*gd2*r*s - 11792*D1**2*f*gd2*r + 5104*D1**2*f*gd2*s**2 - 10208*D1**2*f*gd2*s + 5104*D1**2*f*gd2 - 880*D1**2*f*gdd2*r**2 - 968*D1**2*f*gdd2*r*s + 968*D1**2*f*gdd2*r - 88*D1**2*f*gdd2*s**2 + 176*D1**2*f*gdd2*s - 88*D1**2*f*gdd2 - 1430*D1**2*fd**2*r**2 - 2596*D1**2*fd**2*r*s + 1430*D1**2*fd**2*r - 1166*D1**2*fd**2*s**2 + 1298*D1**2*fd**2*s + 6688*D1**2*fd*g2*r**2 + 11792*D1**2*fd*g2*r*s + 880*D1**2*fd*g2*r + 5104*D1**2*fd*g2*s**2 + 880*D1**2*fd*g2*s - 440*D1**2*fd*g2 - 1760*D1**2*fd*gd2*r**2 - 1936*D1**2*fd*gd2*r*s + 528*D1**2*fd*gd2*r - 176*D1**2*fd*gd2*s**2 - 264*D1**2*fd*gd2*s + 440*D1**2*fd*gd2 - 880*D1**2*fdd*g2*r**2 - 968*D1**2*fdd*g2*r*s - 440*D1**2*fdd*g2*r - 88*D1**2*fdd*g2*s**2 - 440*D1**2*fdd*g2*s + 220*D1**2*fdd*g2 - 8976*D1*Dd*K*f**2*r**2 - 15840*D1*Dd*K*f**2*r*s + 12408*D1*Dd*K*f**2*r - 6864*D1*Dd*K*f**2*s**2 + 10824*D1*Dd*K*f**2*s - 5676*D1*Dd*K*f**2 + 22880*D1*Dd*K*f*fd*r**2 + 39424*D1*Dd*K*f*fd*r*s - 27016*D1*Dd*K*f*fd*r + 16544*D1*Dd*K*f*fd*s**2 - 23056*D1*Dd*K*f*fd*s + 7788*D1*Dd*K*f*fd - 8360*D1*Dd*b2*f*r**2 - 16720*D1*Dd*b2*f*r*s + 12540*D1*Dd*b2*f*r - 8360*D1*Dd*b2*f*s**2 + 12540*D1*Dd*b2*f*s - 6270*D1*Dd*b2*f + 5280*D1*Dd*b2*fd*r**2 + 10560*D1*Dd*b2*fd*r*s - 3960*D1*Dd*b2*fd*r + 5280*D1*Dd*b2*fd*s**2 - 3960*D1*Dd*b2*fd*s + 7224*D1*Dd*f**3*r**2 + 11472*D1*Dd*f**3*r*s - 9348*D1*Dd*f**3*r + 4248*D1*Dd*f**3*s**2 - 7116*D1*Dd*f**3*s + 3930*D1*Dd*f**3 - 34872*D1*Dd*f**2*fd*r**2 - 49200*D1*Dd*f**2*fd*r*s + 40130*D1*Dd*f**2*fd*r - 14328*D1*Dd*f**2*fd*s**2 + 25578*D1*Dd*f**2*fd*s - 10910*D1*Dd*f**2*fd + 1936*D1*Dd*f**2*r**2 + 4928*D1*Dd*f**2*r*s - 3432*D1*Dd*f**2*r + 2992*D1*Dd*f**2*s**2 - 4224*D1*Dd*f**2*s + 1980*D1*Dd*f**2 - 11440*D1*Dd*f*fd*r**2 - 20768*D1*Dd*f*fd*r*s + 13772*D1*Dd*f*fd*r - 9328*D1*Dd*f*fd*s**2 + 12452*D1*Dd*f*fd*s - 4026*D1*Dd*f*fd + 26752*D1*Dd*f*g2*r**2 + 47168*D1*Dd*f*g2*r*s - 36960*D1*Dd*f*g2*r + 20416*D1*Dd*f*g2*s**2 - 32208*D1*Dd*f*g2*s + 16896*D1*Dd*f*g2 - 7040*D1*Dd*f*gd2*r**2 - 7744*D1*Dd*f*gd2*r*s + 7568*D1*Dd*f*gd2*r - 704*D1*Dd*f*gd2*s**2 + 2024*D1*Dd*f*gd2*s - 1320*D1*Dd*f*gd2 - 7040*D1*Dd*fd*g2*r**2 - 7744*D1*Dd*fd*g2*r*s + 1936*D1*Dd*fd*g2*r - 704*D1*Dd*fd*g2*s**2 - 440*D1*Dd*fd*g2*s + 1320*D1*Dd*fd*g2 + 5720*D1*Ddd*K*f**2*r**2 + 9856*D1*Ddd*K*f**2*r*s - 7788*D1*Ddd*K*f**2*r + 4136*D1*Ddd*K*f**2*s**2 - 6600*D1*Ddd*K*f**2*s + 3498*D1*Ddd*K*f**2 + 2640*D1*Ddd*b2*f*r**2 + 5280*D1*Ddd*b2*f*r*s - 3960*D1*Ddd*b2*f*r + 2640*D1*Ddd*b2*f*s**2 - 3960*D1*Ddd*b2*f*s + 1980*D1*Ddd*b2*f - 5812*D1*Ddd*f**3*r**2 - 8200*D1*Ddd*f**3*r*s + 7006*D1*Ddd*f**3*r - 2388*D1*Ddd*f**3*s**2 + 4438*D1*Ddd*f**3*s - 2647*D1*Ddd*f**3 - 2860*D1*Ddd*f**2*r**2 - 5192*D1*Ddd*f**2*r*s + 4026*D1*Ddd*f**2*r - 2332*D1*Ddd*f**2*s**2 + 3630*D1*Ddd*f**2*s - 1881*D1*Ddd*f**2 - 3520*D1*Ddd*f*g2*r**2 - 3872*D1*Ddd*f*g2*r*s + 3696*D1*Ddd*f*g2*r - 352*D1*Ddd*f*g2*s**2 + 1320*D1*Ddd*f*g2*s - 1056*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(f**2*(350*r**2 + r*(748*s - 754) + 398*s**2 - 802*s + 389) + f*(140*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 608*K*r**2 - 1072*K*r*s + 1184*K*r - 464*K*s**2 + 1040*K*s - 556*K - 12*fd*(102*r**2 + 220*r*s - 161*r + 118*s**2 - 173*s + 57) + 66*r**2 + 140*r*s - 366*r + 74*s**2 - 374*s + 185) + 2*fd*(2*K*(40*r**2 + r*(44*s - 26) + 4*s**2 - 8*s - 5) - 40*r**2 + r*(29 - 56*s) - 16*s**2 + 17*s + 5) + 280*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 280*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(6*f**2*(204*r**2 + r*(440*s - 373) + 236*s**2 - 401*s + 167) + f*(-4*K*(80*r**2 + 2*r*(44*s - 57) + 8*s**2 - 51*s + 36) + 160*r**2 + 28*r*(8*s - 9) + 64*s**2 - 168*s + 93) + 140*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 110*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 17160*Dd**2*K*f**2*r**2 + 29568*Dd**2*K*f**2*r*s - 23364*Dd**2*K*f**2*r + 12408*Dd**2*K*f**2*s**2 - 19800*Dd**2*K*f**2*s + 6996*Dd**2*K*f**2 + 7920*Dd**2*b2*f*r**2 + 15840*Dd**2*b2*f*r*s - 11880*Dd**2*b2*f*r + 7920*Dd**2*b2*f*s**2 - 11880*Dd**2*b2*f*s + 3960*Dd**2*b2*f - 17436*Dd**2*f**3*r**2 - 24600*Dd**2*f**3*r*s + 21018*Dd**2*f**3*r - 7164*Dd**2*f**3*s**2 + 13314*Dd**2*f**3*s - 5294*Dd**2*f**3 - 8580*Dd**2*f**2*r**2 - 15576*Dd**2*f**2*r*s + 12078*Dd**2*f**2*r - 6996*Dd**2*f**2*s**2 + 10890*Dd**2*f**2*s - 3762*Dd**2*f**2 - 10560*Dd**2*f*g2*r**2 - 11616*Dd**2*f*g2*r*s + 11088*Dd**2*f*g2*r - 1056*Dd**2*f*g2*s**2 + 3960*Dd**2*f*g2*s - 2112*Dd**2*f*g2) + 4290*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 12*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 12*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 120*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 36*Dd**2*f**2))/(18018*d**2*k3**5) - 4*D1**2*Pk1*Pkd3*ct*k1*k2*st**4*(11*D1*b1*(-bd1*(4*C - 3)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + f*(D1*(-bdd1*s*(4*C - 3)*(2*r + 2*s - 1) + fd*(2*C - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + Dd*f*(2*C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 2))) + 11*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(-11*bd1**2*s*(4*C - 3)*(2*r + 2*s - 1) + f*(11*bd1*s*(2*C - 1)*(r + s - 1) + fd*(20*C - 12)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(10*C - 6)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(10*C - 6)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(10*C - 6)*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(6 - 10*C)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(77*d**2*k3**3) + D1**2*Pk1*Pkd3*ct*k1*k2*st**2*(-66*b1**2*(D1**2*(fd*(16*C*(9*r + s - 1) - 93*r - 19*s + 19) + 4*fdd*(-4*C*(r - 3*s + 3) + 2*r - 9*s + 9))*(r + s - 1) + D1*(Dd*(f*(16*C*(36*r**2 + 40*r*s - 38*r + 4*s**2 - 14*s + 11) - 372*r**2 - 448*r*s + 410*r - 76*s**2 + 188*s - 131) - 4*fd*(8*C*(4*r**2 - 8*r*s + 5*r - 12*s**2 + 19*s - 7) - 16*r**2 + 56*r*s - 38*r + 72*s**2 - 115*s + 43)) - 4*Ddd*f*(4*C*(4*r**2 - 8*r*s + 2*r - 12*s**2 + 14*s - 5) - 8*r**2 + 28*r*s - 10*r + 36*s**2 - 43*s + 16)) - 4*Dd**2*f*(8*C*(6*r**2 + r*(3 - 12*s) - 18*s**2 + 21*s - 5) - 24*r**2 + 6*r*(14*s - 5) + 108*s**2 - 129*s + 32)) - 33*b1*(88*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*r - 120*C*D1**2*f*fd*s**2 - 56*C*D1**2*f*fd*s + 20*C*D1**2*f*fd - 8*C*D1**2*f*fdd*r**2 + 128*C*D1**2*f*fdd*r*s + 64*C*D1**2*f*fdd*r + 136*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s + 4*C*D1**2*f*fdd - 8*C*D1**2*fd**2*r**2 + 128*C*D1**2*fd**2*r*s + 64*C*D1**2*fd**2*r + 136*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s - 128*C*D1**2*fd**2 + 176*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s - 56*C*D1*Dd*f**2*r - 240*C*D1*Dd*f**2*s**2 + 256*C*D1*Dd*f**2*s - 76*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r**2 + 1024*C*D1*Dd*f*fd*r*s + 16*C*D1*Dd*f*fd*r + 1088*C*D1*Dd*f*fd*s**2 - 704*C*D1*Dd*f*fd*s - 48*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 + 256*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 272*C*D1*Ddd*f**2*s**2 - 336*C*D1*Ddd*f**2*s + 132*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 + 768*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 816*C*Dd**2*f**2*s**2 - 1008*C*Dd**2*f**2*s + 264*C*Dd**2*f**2 - 8*D1**2*bdd1*f*(4*C*(2*r**2 - 4*r*s - 2*r - 6*s**2 + 2*s + 1) - 4*r**2 + 14*r*s + 4*r + 18*s**2 - 7*s - 2) - 46*D1**2*f*fd*r**2 + 52*D1**2*f*fd*r*s + 74*D1**2*f*fd*r + 98*D1**2*f*fd*s**2 + 22*D1**2*f*fd*s - D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 100*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*r - 106*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 13*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 100*D1**2*fd**2*r*s - 30*D1**2*fd**2*r - 106*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 88*D1**2*fd**2 - 92*D1*Dd*f**2*r**2 + 104*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 196*D1*Dd*f**2*s**2 - 222*D1*Dd*f**2*s + 75*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 800*D1*Dd*f*fd*r*s + 68*D1*Dd*f*fd*r - 848*D1*Dd*f*fd*s**2 + 596*D1*Dd*f*fd*s - 6*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 - 200*D1*Ddd*f**2*r*s + 94*D1*Ddd*f**2*r - 212*D1*Ddd*f**2*s**2 + 262*D1*Ddd*f**2*s - 103*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(16*C*(18*r**2 + 20*r*s - 18*r + 2*s**2 - 10*s + 9) - 186*r**2 - 224*r*s + 186*r - 38*s**2 + 112*s - 93) - 4*fd*(8*C*(2*r**2 - 4*r*s + r - 6*s**2 + 7*s - 1) - 8*r**2 + 28*r*s - 10*r + 36*s**2 - 43*s + 7)) - 8*Dd*f*(4*C*(8*r**2 - 2*r*(8*s + 1) - 24*s**2 + 18*s - 1) - 16*r**2 + 56*r*s - 2*r + 72*s**2 - 57*s + 5)) + 36*Dd**2*f**2*r**2 - 600*Dd**2*f**2*r*s + 282*Dd**2*f**2*r - 636*Dd**2*f**2*s**2 + 786*Dd**2*f**2*s - 206*Dd**2*f**2) + f*(5436*C*D1**2*f*fd*r**2 + 20880*C*D1**2*f*fd*r*s - 10584*C*D1**2*f*fd*r + 15444*C*D1**2*f*fd*s**2 - 17256*C*D1**2*f*fd*s + 6960*C*D1**2*f*fd - 7668*C*D1**2*f*fdd*r**2 - 20736*C*D1**2*f*fdd*r*s + 12024*C*D1**2*f*fdd*r - 13068*C*D1**2*f*fdd*s**2 + 15624*C*D1**2*f*fdd*s - 6912*C*D1**2*f*fdd - 15336*C*D1**2*fd**2*r**2 - 41472*C*D1**2*fd**2*r*s + 24048*C*D1**2*fd**2*r - 26136*C*D1**2*fd**2*s**2 + 31248*C*D1**2*fd**2*s - 6912*C*D1**2*fd**2 + 7248*C*D1*Dd*f**2*r**2 + 27840*C*D1*Dd*f**2*r*s - 17544*C*D1*Dd*f**2*r + 20592*C*D1*Dd*f**2*s**2 - 27552*C*D1*Dd*f**2*s + 12108*C*D1*Dd*f**2 - 61344*C*D1*Dd*f*fd*r**2 - 165888*C*D1*Dd*f*fd*r*s + 104904*C*D1*Dd*f*fd*r - 104544*C*D1*Dd*f*fd*s**2 + 135504*C*D1*Dd*f*fd*s - 43272*C*D1*Dd*f*fd - 10224*C*D1*Ddd*f**2*r**2 - 27648*C*D1*Ddd*f**2*r*s + 18936*C*D1*Ddd*f**2*r - 17424*C*D1*Ddd*f**2*s**2 + 24336*C*D1*Ddd*f**2*s - 11268*C*D1*Ddd*f**2 - 30672*C*Dd**2*f**2*r**2 - 82944*C*Dd**2*f**2*r*s + 56808*C*Dd**2*f**2*r - 52272*C*Dd**2*f**2*s**2 + 73008*C*Dd**2*f**2*s - 22536*C*Dd**2*f**2 + 264*D1**2*bd1**2*(r**2*(8*C - 4) - 2*r*(8*C*s + 4*C - 7*s - 2) + s*(-24*C*s + 8*C + 18*s - 7)) + 33*D1**2*bdd1*f*(4*C*(r**2 - 16*r*s + 30*r - 17*s**2 + 48*s - 15) - 3*r**2 + 50*r*s - 74*r + 53*s**2 - 138*s + 37) - 3705*D1**2*f*fd*r**2 - 14622*D1**2*f*fd*r*s + 7344*D1**2*f*fd*r - 10917*D1**2*f*fd*s**2 + 12152*D1**2*f*fd*s - 4874*D1**2*f*fd + 4575*D1**2*f*fdd*r**2 + 14142*D1**2*f*fdd*r*s - 7764*D1**2*f*fdd*r + 9567*D1**2*f*fdd*s**2 - 11092*D1**2*f*fdd*s + 4714*D1**2*f*fdd + 9150*D1**2*fd**2*r**2 + 28284*D1**2*fd**2*r*s - 15528*D1**2*fd**2*r + 19134*D1**2*fd**2*s**2 - 22184*D1**2*fd**2*s + 4714*D1**2*fd**2 - 4940*D1*Dd*f**2*r**2 - 19496*D1*Dd*f**2*r*s + 12218*D1*Dd*f**2*r - 14556*D1*Dd*f**2*s**2 + 19430*D1*Dd*f**2*s - 8513*D1*Dd*f**2 + 36600*D1*Dd*f*fd*r**2 + 113136*D1*Dd*f*fd*r*s - 68490*D1*Dd*f*fd*r + 76536*D1*Dd*f*fd*s**2 - 96778*D1*Dd*f*fd*s + 29948*D1*Dd*f*fd + 6100*D1*Ddd*f**2*r**2 + 18856*D1*Ddd*f**2*r*s - 12478*D1*Ddd*f**2*r + 12756*D1*Ddd*f**2*s**2 - 17470*D1*Ddd*f**2*s + 7903*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(4*C*(11*r**2 - 4*r*s + 18*r - 15*s**2 + 48*s - 9) - 23*r**2 + 26*r*s - 54*r + 49*s**2 - 146*s + 27) - 2*fd*(4*C*(2*r**2 - 32*r*s + 22*r - 34*s**2 + 49*s - 24) - 6*r**2 + 100*r*s - 59*r + 106*s**2 - 147*s + 69)) + 2*Dd*f*(-4*C*(4*r**2 - 64*r*s + 75*r - 68*s**2 + 138*s - 63) + 12*r**2 - 200*r*s + 195*r - 212*s**2 + 407*s - 175)) + 18300*Dd**2*f**2*r**2 + 56568*Dd**2*f**2*r*s - 37434*Dd**2*f**2*r + 38268*Dd**2*f**2*s**2 - 52410*Dd**2*f**2*s + 15806*Dd**2*f**2))/(1386*d**2*k3**3) + D1**2*Pk1*Pkd3*ct*k1*k2*(1056*D1**2*K*bd1**2*f*r**2 + 1320*D1**2*K*bd1**2*f*r*s + 3960*D1**2*K*bd1**2*f*r + 264*D1**2*K*bd1**2*f*s**2 + 4356*D1**2*K*bd1**2*f*s - 4620*D1**2*K*bd1**2*f + 1980*D1**2*K*bd1*f**2*r**2 + 3168*D1**2*K*bd1*f**2*r*s - 3168*D1**2*K*bd1*f**2*r + 1188*D1**2*K*bd1*f**2*s**2 - 2376*D1**2*K*bd1*f**2*s + 1188*D1**2*K*bd1*f**2 - 9504*D1**2*K*bd1*f*fd*r**2 - 17424*D1**2*K*bd1*f*fd*r*s + 13464*D1**2*K*bd1*f*fd*r - 7920*D1**2*K*bd1*f*fd*s**2 + 12276*D1**2*K*bd1*f*fd*s - 4356*D1**2*K*bd1*f*fd - 2376*D1**2*K*bdd1*f**2*r**2 - 4356*D1**2*K*bdd1*f**2*r*s + 4356*D1**2*K*bdd1*f**2*r - 1980*D1**2*K*bdd1*f**2*s**2 + 3960*D1**2*K*bdd1*f**2*s - 1980*D1**2*K*bdd1*f**2 - 330*D1**2*bd1**2*f**2*r**2 + 2508*D1**2*bd1**2*f**2*r*s - 1914*D1**2*bd1**2*f**2*r + 2838*D1**2*bd1**2*f**2*s**2 - 4950*D1**2*bd1**2*f**2*s + 2904*D1**2*bd1**2*f**2 - 396*D1**2*bd1**2*f*r**2 + 1056*D1**2*bd1**2*f*r*s - 2046*D1**2*bd1**2*f*r + 1452*D1**2*bd1**2*f*s**2 - 4554*D1**2*bd1**2*f*s + 3102*D1**2*bd1**2*f - 9240*D1**2*bd1**2*g2*r**2 - 18480*D1**2*bd1**2*g2*r*s + 9240*D1**2*bd1**2*g2*r - 9240*D1**2*bd1**2*g2*s**2 + 9240*D1**2*bd1**2*g2*s - 3828*D1**2*bd1*bd2*f*r**2 - 7656*D1**2*bd1*bd2*f*r*s + 8448*D1**2*bd1*bd2*f*r - 3828*D1**2*bd1*bd2*f*s**2 + 8448*D1**2*bd1*bd2*f*s - 4620*D1**2*bd1*bd2*f - 565*D1**2*bd1*f**3*r**2 - 2710*D1**2*bd1*f**3*r*s + 2050*D1**2*bd1*f**3*r - 2145*D1**2*bd1*f**3*s**2 + 2970*D1**2*bd1*f**3*s - 1485*D1**2*bd1*f**3 + 4170*D1**2*bd1*f**2*fd*r**2 + 19020*D1**2*bd1*f**2*fd*r*s - 12750*D1**2*bd1*f**2*fd*r + 14850*D1**2*bd1*f**2*fd*s**2 - 20330*D1**2*bd1*f**2*fd*s + 6140*D1**2*bd1*f**2*fd - 594*D1**2*bd1*f**2*r**2 - 1980*D1**2*bd1*f**2*r*s + 1980*D1**2*bd1*f**2*r - 1386*D1**2*bd1*f**2*s**2 + 2772*D1**2*bd1*f**2*s - 1386*D1**2*bd1*f**2 + 3168*D1**2*bd1*f*fd*r**2 + 11088*D1**2*bd1*f*fd*r*s - 7128*D1**2*bd1*f*fd*r + 7920*D1**2*bd1*f*fd*s**2 - 10692*D1**2*bd1*f*fd*s + 2772*D1**2*bd1*f*fd + 1188*D1**2*bd1*f*g2*r**2 + 792*D1**2*bd1*f*g2*r*s + 5544*D1**2*bd1*f*g2*r - 396*D1**2*bd1*f*g2*s**2 + 5544*D1**2*bd1*f*g2*s - 2772*D1**2*bd1*f*g2 - 2112*D1**2*bd1*f*gd2*r**2 - 2640*D1**2*bd1*f*gd2*r*s - 7920*D1**2*bd1*f*gd2*r - 528*D1**2*bd1*f*gd2*s**2 - 8712*D1**2*bd1*f*gd2*s + 9240*D1**2*bd1*f*gd2 - 2112*D1**2*bd1*fd*g2*r**2 - 2640*D1**2*bd1*fd*g2*r*s + 2112*D1**2*bd1*fd*g2*r - 528*D1**2*bd1*fd*g2*s**2 + 1320*D1**2*bd1*fd*g2*s + 1980*D1**2*bd2*f**2*r**2 + 3168*D1**2*bd2*f**2*r*s - 3168*D1**2*bd2*f**2*r + 1188*D1**2*bd2*f**2*s**2 - 2376*D1**2*bd2*f**2*s + 1188*D1**2*bd2*f**2 - 9504*D1**2*bd2*f*fd*r**2 - 17424*D1**2*bd2*f*fd*r*s + 13464*D1**2*bd2*f*fd*r - 7920*D1**2*bd2*f*fd*s**2 + 12276*D1**2*bd2*f*fd*s - 4356*D1**2*bd2*f*fd + 695*D1**2*bdd1*f**3*r**2 + 3170*D1**2*bdd1*f**3*r*s - 2510*D1**2*bdd1*f**3*r + 2475*D1**2*bdd1*f**3*s**2 - 3630*D1**2*bdd1*f**3*s + 1815*D1**2*bdd1*f**3 + 792*D1**2*bdd1*f**2*r**2 + 2772*D1**2*bdd1*f**2*r*s - 2772*D1**2*bdd1*f**2*r + 1980*D1**2*bdd1*f**2*s**2 - 3960*D1**2*bdd1*f**2*s + 1980*D1**2*bdd1*f**2 - 1056*D1**2*bdd1*f*g2*r**2 - 1320*D1**2*bdd1*f*g2*r*s - 9240*D1**2*bdd1*f*g2*r - 264*D1**2*bdd1*f*g2*s**2 - 9240*D1**2*bdd1*f*g2*s + 4620*D1**2*bdd1*f*g2 - 2376*D1**2*bdd2*f**2*r**2 - 4356*D1**2*bdd2*f**2*r*s + 4356*D1**2*bdd2*f**2*r - 1980*D1**2*bdd2*f**2*s**2 + 3960*D1**2*bdd2*f**2*s - 1980*D1**2*bdd2*f**2 - 3960*D1**2*f**2*gd2*r**2 - 6336*D1**2*f**2*gd2*r*s + 6336*D1**2*f**2*gd2*r - 2376*D1**2*f**2*gd2*s**2 + 4752*D1**2*f**2*gd2*s - 2376*D1**2*f**2*gd2 + 4752*D1**2*f**2*gdd2*r**2 + 8712*D1**2*f**2*gdd2*r*s - 8712*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 7920*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 - 7920*D1**2*f*fd*g2*r**2 - 12672*D1**2*f*fd*g2*r*s + 7920*D1**2*f*fd*g2*r - 4752*D1**2*f*fd*g2*s**2 + 6336*D1**2*f*fd*g2*s - 3960*D1**2*f*fd*g2 + 19008*D1**2*f*fd*gd2*r**2 + 34848*D1**2*f*fd*gd2*r*s - 26928*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 24552*D1**2*f*fd*gd2*s + 8712*D1**2*f*fd*gd2 + 9504*D1**2*f*fdd*g2*r**2 + 17424*D1**2*f*fdd*g2*r*s - 9504*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 8712*D1**2*f*fdd*g2*s + 4752*D1**2*f*fdd*g2 + 9504*D1**2*fd**2*g2*r**2 + 17424*D1**2*fd**2*g2*r*s - 9504*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 8712*D1**2*fd**2*g2*s - 19008*D1*Dd*K*bd1*f**2*r**2 - 34848*D1*Dd*K*bd1*f**2*r*s + 30888*D1*Dd*K*bd1*f**2*r - 15840*D1*Dd*K*bd1*f**2*s**2 + 28116*D1*Dd*K*bd1*f**2*s - 12276*D1*Dd*K*bd1*f**2 + 5560*D1*Dd*bd1*f**3*r**2 + 25360*D1*Dd*bd1*f**3*r*s - 17770*D1*Dd*bd1*f**3*r + 19800*D1*Dd*bd1*f**3*s**2 - 27590*D1*Dd*bd1*f**3*s + 9770*D1*Dd*bd1*f**3 + 6336*D1*Dd*bd1*f**2*r**2 + 22176*D1*Dd*bd1*f**2*r*s - 18216*D1*Dd*bd1*f**2*r + 15840*D1*Dd*bd1*f**2*s**2 - 26532*D1*Dd*bd1*f**2*s + 10692*D1*Dd*bd1*f**2 - 8448*D1*Dd*bd1*f*g2*r**2 - 10560*D1*Dd*bd1*f*g2*r*s - 32208*D1*Dd*bd1*f*g2*r - 2112*D1*Dd*bd1*f*g2*s**2 - 34584*D1*Dd*bd1*f*g2*s + 27720*D1*Dd*bd1*f*g2 - 19008*D1*Dd*bd2*f**2*r**2 - 34848*D1*Dd*bd2*f**2*r*s + 30888*D1*Dd*bd2*f**2*r - 15840*D1*Dd*bd2*f**2*s**2 + 28116*D1*Dd*bd2*f**2*s - 12276*D1*Dd*bd2*f**2 - 15840*D1*Dd*f**2*g2*r**2 - 25344*D1*Dd*f**2*g2*r*s + 20592*D1*Dd*f**2*g2*r - 9504*D1*Dd*f**2*g2*s**2 + 15840*D1*Dd*f**2*g2*s - 8712*D1*Dd*f**2*g2 + 38016*D1*Dd*f**2*gd2*r**2 + 69696*D1*Dd*f**2*gd2*r*s - 61776*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 56232*D1*Dd*f**2*gd2*s + 24552*D1*Dd*f**2*gd2 + 76032*D1*Dd*f*fd*g2*r**2 + 139392*D1*Dd*f*fd*g2*r*s - 91872*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 83952*D1*Dd*f*fd*g2*s + 26928*D1*Dd*f*fd*g2 + 19008*D1*Ddd*f**2*g2*r**2 + 34848*D1*Ddd*f**2*g2*r*s - 26928*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 24552*D1*Ddd*f**2*g2*s + 12672*D1*Ddd*f**2*g2 + 57024*Dd**2*f**2*g2*r**2 + 104544*Dd**2*f**2*g2*r*s - 80784*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 73656*Dd**2*f**2*g2*s + 25344*Dd**2*f**2*g2 + 33*b1**3*(D1**2*(r + s - 1)*(12*fd*r + 40*fd*(s - 1) + fdd*(-27*r - 55*s + 55)) + D1*(2*Dd*(-70*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*f*(12*r**2 + 4*r*(13*s - 8) + 40*s**2 - 53*s + 23) - fd*(108*r**2 + r*(328*s - 273) + 220*s**2 - 371*s + 151) + 84*r**2 + 280*r*s - 182*r + 196*s**2 - 266*s + 119) - Ddd*f*(108*r**2 + r*(328*s - 218) + 220*s**2 - 302*s + 137) + 7*Ddd*(10*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*r**2 + r*(26 - 40*s) - 28*s**2 + 38*s - 17)) - 2*Dd**2*(-210*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(162*r**2 + r*(492*s - 327) + 330*s**2 - 453*s + 137) + 126*r**2 + 420*r*s - 273*r + 294*s**2 - 399*s + 119)) + 33*b1**2*(210*D1**2*K*bdd1*r**2 + 420*D1**2*K*bdd1*r*s - 280*D1**2*K*bdd1*r + 210*D1**2*K*bdd1*s**2 - 280*D1**2*K*bdd1*s + 140*D1**2*K*bdd1 - 18*D1**2*K*fd*r**2 - 12*D1**2*K*fd*r*s + 120*D1**2*K*fd*r + 6*D1**2*K*fd*s**2 + 96*D1**2*K*fd*s - 60*D1**2*K*fd + 16*D1**2*K*fdd*r**2 + 20*D1**2*K*fdd*r*s - 172*D1**2*K*fdd*r + 4*D1**2*K*fdd*s**2 - 160*D1**2*K*fdd*s + 86*D1**2*K*fdd - 81*D1**2*bdd1*f*r**2 - 246*D1**2*bdd1*f*r*s + 136*D1**2*bdd1*f*r - 165*D1**2*bdd1*f*s**2 + 192*D1**2*bdd1*f*s - 82*D1**2*bdd1*f - 63*D1**2*bdd1*r**2 - 210*D1**2*bdd1*r*s + 112*D1**2*bdd1*r - 147*D1**2*bdd1*s**2 + 168*D1**2*bdd1*s - 70*D1**2*bdd1 + 14*D1**2*bdd2*r**2 + 28*D1**2*bdd2*r*s - 28*D1**2*bdd2*r + 14*D1**2*bdd2*s**2 - 28*D1**2*bdd2*s + 14*D1**2*bdd2 + 8*D1**2*f*fd*r**2 - 80*D1**2*f*fd*r*s + 28*D1**2*f*fd*r - 88*D1**2*f*fd*s**2 + 84*D1**2*f*fd*s - 50*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 76*D1**2*f*fdd*r*s - 8*D1**2*f*fdd*r + 86*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s + 40*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 76*D1**2*fd**2*r*s - 8*D1**2*fd**2*r + 86*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s - 26*D1**2*fd**2 + 5*D1**2*fd*r**2 - 18*D1**2*fd*r*s - 32*D1**2*fd*r - 23*D1**2*fd*s**2 - 44*D1**2*fd*s + 16*D1**2*fd - 6*D1**2*fdd*r**2 + 16*D1**2*fdd*r*s + 58*D1**2*fdd*r + 22*D1**2*fdd*s**2 + 78*D1**2*fdd*s - 29*D1**2*fdd + 280*D1**2*gd2*r**2 + 560*D1**2*gd2*r*s - 560*D1**2*gd2*r + 280*D1**2*gd2*s**2 - 560*D1**2*gd2*s + 280*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 - 72*D1*Dd*K*f*r**2 - 48*D1*Dd*K*f*r*s + 60*D1*Dd*K*f*r + 24*D1*Dd*K*f*s**2 - 12*D1*Dd*K*f*s - 6*D1*Dd*K*f + 128*D1*Dd*K*fd*r**2 + 160*D1*Dd*K*fd*r*s - 760*D1*Dd*K*fd*r + 32*D1*Dd*K*fd*s**2 - 676*D1*Dd*K*fd*s + 492*D1*Dd*K*fd - 112*D1*Dd*b2*r**2 - 224*D1*Dd*b2*r*s + 168*D1*Dd*b2*r - 112*D1*Dd*b2*s**2 + 168*D1*Dd*b2*s - 84*D1*Dd*b2 + 16*D1*Dd*f**2*r**2 - 160*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 176*D1*Dd*f**2*s**2 + 216*D1*Dd*f**2*s - 84*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 608*D1*Dd*f*fd*r*s - 164*D1*Dd*f*fd*r + 688*D1*Dd*f*fd*s**2 - 660*D1*Dd*f*fd*s + 128*D1*Dd*f*fd + 20*D1*Dd*f*r**2 - 72*D1*Dd*f*r*s + 26*D1*Dd*f*r - 92*D1*Dd*f*s**2 + 110*D1*Dd*f*s - 41*D1*Dd*f - 48*D1*Dd*fd*r**2 + 128*D1*Dd*fd*r*s + 212*D1*Dd*fd*r + 176*D1*Dd*fd*s**2 + 208*D1*Dd*fd*s - 214*D1*Dd*fd + 1120*D1*Dd*g2*r**2 + 2240*D1*Dd*g2*r*s - 1680*D1*Dd*g2*r + 1120*D1*Dd*g2*s**2 - 1680*D1*Dd*g2*s + 840*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 + 64*D1*Ddd*K*f*r**2 + 80*D1*Ddd*K*f*r*s - 72*D1*Ddd*K*f*r + 16*D1*Ddd*K*f*s**2 - 36*D1*Ddd*K*f*s + 24*D1*Ddd*K*f + 56*D1*Ddd*b2*r**2 + 112*D1*Ddd*b2*r*s - 84*D1*Ddd*b2*r + 56*D1*Ddd*b2*s**2 - 84*D1*Ddd*b2*s + 42*D1*Ddd*b2 - 20*D1*Ddd*f**2*r**2 + 152*D1*Ddd*f**2*r*s - 66*D1*Ddd*f**2*r + 172*D1*Ddd*f**2*s**2 - 210*D1*Ddd*f**2*s + 81*D1*Ddd*f**2 - 24*D1*Ddd*f*r**2 + 64*D1*Ddd*f*r*s - 20*D1*Ddd*f*r + 88*D1*Ddd*f*s**2 - 104*D1*Ddd*f*s + 38*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 + 2*D1*bd1*(D1*(-70*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 2*f*(9*r**2 + r*(39*s - 19) + 30*s**2 - 33*s + 13) - fd*(81*r**2 + 246*r*s - 191*r + 165*s**2 - 261*s + 96) + 63*r**2 + 210*r*s - 112*r + 147*s**2 - 168*s + 70) - Dd*f*(324*r**2 + r*(984*s - 599) + 660*s**2 - 837*s + 260) + 7*Dd*(10*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 36*r**2 + r*(71 - 120*s) - 84*s**2 + 105*s - 32)) - 28*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) + 192*Dd**2*K*f*r**2 + 240*Dd**2*K*f*r*s - 216*Dd**2*K*f*r + 48*Dd**2*K*f*s**2 - 108*Dd**2*K*f*s + 48*Dd**2*K*f + 168*Dd**2*b2*r**2 + 336*Dd**2*b2*r*s - 252*Dd**2*b2*r + 168*Dd**2*b2*s**2 - 252*Dd**2*b2*s + 84*Dd**2*b2 - 60*Dd**2*f**2*r**2 + 456*Dd**2*f**2*r*s - 198*Dd**2*f**2*r + 516*Dd**2*f**2*s**2 - 630*Dd**2*f**2*s + 162*Dd**2*f**2 - 72*Dd**2*f*r**2 + 192*Dd**2*f*r*s - 60*Dd**2*f*r + 264*Dd**2*f*s**2 - 312*Dd**2*f*s + 76*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) - b1*(-1056*D1**2*K*bdd1*f*r**2 - 1320*D1**2*K*bdd1*f*r*s - 3960*D1**2*K*bdd1*f*r - 264*D1**2*K*bdd1*f*s**2 - 4356*D1**2*K*bdd1*f*s + 2178*D1**2*K*bdd1*f - 3960*D1**2*K*f*fd*r**2 - 6336*D1**2*K*f*fd*r*s + 3960*D1**2*K*f*fd*r - 2376*D1**2*K*f*fd*s**2 + 3168*D1**2*K*f*fd*s - 1980*D1**2*K*f*fd + 4752*D1**2*K*f*fdd*r**2 + 8712*D1**2*K*f*fdd*r*s - 4752*D1**2*K*f*fdd*r + 3960*D1**2*K*f*fdd*s**2 - 4356*D1**2*K*f*fdd*s + 2376*D1**2*K*f*fdd + 4752*D1**2*K*fd**2*r**2 + 8712*D1**2*K*fd**2*r*s - 4752*D1**2*K*fd**2*r + 3960*D1**2*K*fd**2*s**2 - 4356*D1**2*K*fd**2*s + 66*D1**2*bd1**2*(-70*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(81*r**2 + 2*r*(123*s - 68) + 165*s**2 - 192*s + 41) + 63*r**2 + 210*r*s - 112*r + 147*s**2 - 168*s + 35) - 1056*D1**2*bd2*f*r**2 - 2112*D1**2*bd2*f*r*s + 2112*D1**2*bd2*f*r - 1056*D1**2*bd2*f*s**2 + 2112*D1**2*bd2*f*s - 1056*D1**2*bd2*f + 3828*D1**2*bd2*fd*r**2 + 7656*D1**2*bd2*fd*r*s - 3036*D1**2*bd2*fd*r + 3828*D1**2*bd2*fd*s**2 - 3036*D1**2*bd2*fd*s - 792*D1**2*bd2*fd + 330*D1**2*bdd1*f**2*r**2 - 2508*D1**2*bdd1*f**2*r*s + 1914*D1**2*bdd1*f**2*r - 2838*D1**2*bdd1*f**2*s**2 + 4950*D1**2*bdd1*f**2*s - 1353*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*r**2 - 1056*D1**2*bdd1*f*r*s + 2046*D1**2*bdd1*f*r - 1452*D1**2*bdd1*f*s**2 + 4554*D1**2*bdd1*f*s - 1485*D1**2*bdd1*f + 9240*D1**2*bdd1*g2*r**2 + 18480*D1**2*bdd1*g2*r*s - 9240*D1**2*bdd1*g2*r + 9240*D1**2*bdd1*g2*s**2 - 9240*D1**2*bdd1*g2*s + 4620*D1**2*bdd1*g2 + 1914*D1**2*bdd2*f*r**2 + 3828*D1**2*bdd2*f*r*s - 3828*D1**2*bdd2*f*r + 1914*D1**2*bdd2*f*s**2 - 3828*D1**2*bdd2*f*s + 1914*D1**2*bdd2*f + 1695*D1**2*f**2*fd*r**2 + 8130*D1**2*f**2*fd*r*s - 4500*D1**2*f**2*fd*r + 6435*D1**2*f**2*fd*s**2 - 8320*D1**2*f**2*fd*s + 3370*D1**2*f**2*fd - 2085*D1**2*f**2*fdd*r**2 - 9510*D1**2*f**2*fdd*r*s + 5220*D1**2*f**2*fdd*r - 7425*D1**2*f**2*fdd*s**2 + 9440*D1**2*f**2*fdd*s - 3830*D1**2*f**2*fdd - 4170*D1**2*f*fd**2*r**2 - 19020*D1**2*f*fd**2*r*s + 10440*D1**2*f*fd**2*r - 14850*D1**2*f*fd**2*s**2 + 18880*D1**2*f*fd**2*s - 5150*D1**2*f*fd**2 + 1188*D1**2*f*fd*r**2 + 3960*D1**2*f*fd*r*s - 1188*D1**2*f*fd*r + 2772*D1**2*f*fd*s**2 - 1980*D1**2*f*fd*s + 594*D1**2*f*fd - 1584*D1**2*f*fdd*r**2 - 5544*D1**2*f*fdd*r*s + 1584*D1**2*f*fdd*r - 3960*D1**2*f*fdd*s**2 + 2772*D1**2*f*fdd*s - 792*D1**2*f*fdd - 1188*D1**2*f*gd2*r**2 - 792*D1**2*f*gd2*r*s + 792*D1**2*f*gd2*r + 396*D1**2*f*gd2*s**2 - 792*D1**2*f*gd2*s + 396*D1**2*f*gd2 + 1056*D1**2*f*gdd2*r**2 + 1320*D1**2*f*gdd2*r*s - 1320*D1**2*f*gdd2*r + 264*D1**2*f*gdd2*s**2 - 528*D1**2*f*gdd2*s + 264*D1**2*f*gdd2 - 1584*D1**2*fd**2*r**2 - 5544*D1**2*fd**2*r*s + 1584*D1**2*fd**2*r - 3960*D1**2*fd**2*s**2 + 2772*D1**2*fd**2*s - 1188*D1**2*fd*g2*r**2 - 792*D1**2*fd*g2*r*s + 7920*D1**2*fd*g2*r + 396*D1**2*fd*g2*s**2 + 6336*D1**2*fd*g2*s - 3960*D1**2*fd*g2 + 2112*D1**2*fd*gd2*r**2 + 2640*D1**2*fd*gd2*r*s - 12672*D1**2*fd*gd2*r + 528*D1**2*fd*gd2*s**2 - 11088*D1**2*fd*gd2*s + 10560*D1**2*fd*gd2 + 1056*D1**2*fdd*g2*r**2 + 1320*D1**2*fdd*g2*r*s - 11352*D1**2*fdd*g2*r + 264*D1**2*fdd*g2*s**2 - 10560*D1**2*fdd*g2*s + 5676*D1**2*fdd*g2 - 7920*D1*Dd*K*f**2*r**2 - 12672*D1*Dd*K*f**2*r*s + 10296*D1*Dd*K*f**2*r - 4752*D1*Dd*K*f**2*s**2 + 7920*D1*Dd*K*f**2*s - 4356*D1*Dd*K*f**2 + 38016*D1*Dd*K*f*fd*r**2 + 69696*D1*Dd*K*f*fd*r*s - 45936*D1*Dd*K*f*fd*r + 31680*D1*Dd*K*f*fd*s**2 - 41976*D1*Dd*K*f*fd*s + 13464*D1*Dd*K*f*fd + 15312*D1*Dd*bd2*f*r**2 + 30624*D1*Dd*bd2*f*r*s - 26796*D1*Dd*bd2*f*r + 15312*D1*Dd*bd2*f*s**2 - 26796*D1*Dd*bd2*f*s + 11484*D1*Dd*bd2*f + 2260*D1*Dd*f**3*r**2 + 10840*D1*Dd*f**3*r*s - 6550*D1*Dd*f**3*r + 8580*D1*Dd*f**3*s**2 - 11290*D1*Dd*f**3*s + 4855*D1*Dd*f**3 - 16680*D1*Dd*f**2*fd*r**2 - 76080*D1*Dd*f**2*fd*r*s + 44070*D1*Dd*f**2*fd*r - 59400*D1*Dd*f**2*fd*s**2 + 76970*D1*Dd*f**2*fd*s - 24100*D1*Dd*f**2*fd + 2376*D1*Dd*f**2*r**2 + 7920*D1*Dd*f**2*r*s - 5148*D1*Dd*f**2*r + 5544*D1*Dd*f**2*s**2 - 7524*D1*Dd*f**2*s + 3366*D1*Dd*f**2 - 12672*D1*Dd*f*fd*r**2 - 44352*D1*Dd*f*fd*r*s + 20592*D1*Dd*f*fd*r - 31680*D1*Dd*f*fd*s**2 + 32472*D1*Dd*f*fd*s - 7128*D1*Dd*f*fd - 4752*D1*Dd*f*g2*r**2 - 3168*D1*Dd*f*g2*r*s + 3960*D1*Dd*f*g2*r + 1584*D1*Dd*f*g2*s**2 - 792*D1*Dd*f*g2*s - 396*D1*Dd*f*g2 + 8448*D1*Dd*f*gd2*r**2 + 10560*D1*Dd*f*gd2*r*s - 10032*D1*Dd*f*gd2*r + 2112*D1*Dd*f*gd2*s**2 - 4488*D1*Dd*f*gd2*s + 2376*D1*Dd*f*gd2 + 8448*D1*Dd*fd*g2*r**2 + 10560*D1*Dd*fd*g2*r*s - 50160*D1*Dd*fd*g2*r + 2112*D1*Dd*fd*g2*s**2 - 44616*D1*Dd*fd*g2*s + 32472*D1*Dd*fd*g2 + 9504*D1*Ddd*K*f**2*r**2 + 17424*D1*Ddd*K*f**2*r*s - 13464*D1*Ddd*K*f**2*r + 7920*D1*Ddd*K*f**2*s**2 - 12276*D1*Ddd*K*f**2*s + 6336*D1*Ddd*K*f**2 - 2780*D1*Ddd*f**3*r**2 - 12680*D1*Ddd*f**3*r*s + 7730*D1*Ddd*f**3*r - 9900*D1*Ddd*f**3*s**2 + 13070*D1*Ddd*f**3*s - 5645*D1*Ddd*f**3 - 3168*D1*Ddd*f**2*r**2 - 11088*D1*Ddd*f**2*r*s + 7128*D1*Ddd*f**2*r - 7920*D1*Ddd*f**2*s**2 + 10692*D1*Ddd*f**2*s - 4752*D1*Ddd*f**2 + 4224*D1*Ddd*f*g2*r**2 + 5280*D1*Ddd*f*g2*r*s - 4752*D1*Ddd*f*g2*r + 1056*D1*Ddd*f*g2*s**2 - 2376*D1*Ddd*f*g2*s + 1584*D1*Ddd*f*g2 - 66*D1*bd1*(14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f**2*(4*r**2 + r*(22 - 40*s) - 44*s**2 + 66*s - 17) - f*(6*K*(3*r**2 + 2*r*(s + 3) - s**2 + 8*s - 4) + 2*fd*(10*r**2 + r*(33 - 76*s) - 86*s**2 + 105*s - 25) - 5*r**2 + 18*r*s - 20*r + 23*s**2 - 54*s + 17) + fd*(2*K*(16*r**2 + 4*r*(5*s - 14) + 4*s**2 - 47*s + 40) - 12*r**2 + r*(32*s + 27) + 44*s**2 + 9*s - 39) + 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*(f**2*(-40*r**2 + 2*r*(152*s - 91) + 344*s**2 - 510*s + 179) + f*(4*K*(32*r**2 + r*(40*s + 42) + 8*s**2 + 57*s - 48) - 48*r**2 + 16*r*(8*s - 9) + 176*s**2 - 380*s + 169) - 140*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 28512*Dd**2*K*f**2*r**2 + 52272*Dd**2*K*f**2*r*s - 40392*Dd**2*K*f**2*r + 23760*Dd**2*K*f**2*s**2 - 36828*Dd**2*K*f**2*s + 12672*Dd**2*K*f**2 - 8340*Dd**2*f**3*r**2 - 38040*Dd**2*f**3*r*s + 23190*Dd**2*f**3*r - 29700*Dd**2*f**3*s**2 + 39210*Dd**2*f**3*s - 11290*Dd**2*f**3 - 9504*Dd**2*f**2*r**2 - 33264*Dd**2*f**2*r*s + 21384*Dd**2*f**2*r - 23760*Dd**2*f**2*s**2 + 32076*Dd**2*f**2*s - 9504*Dd**2*f**2 + 12672*Dd**2*f*g2*r**2 + 15840*Dd**2*f*g2*r*s - 14256*Dd**2*f*g2*r + 3168*Dd**2*f*g2*s**2 - 7128*Dd**2*f*g2*s + 3168*Dd**2*f*g2 + 66*b2*(-7*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 16*D1**2*fd*r**2 - 32*D1**2*fd*r*s - 10*D1**2*fd*r - 16*D1**2*fd*s**2 - 10*D1**2*fd*s + 5*D1**2*fd + 29*D1**2*fdd*r**2 + 58*D1**2*fdd*r*s + 12*D1**2*fdd*r + 29*D1**2*fdd*s**2 + 12*D1**2*fdd*s - 6*D1**2*fdd - 64*D1*Dd*f*r**2 - 128*D1*Dd*f*r*s + 96*D1*Dd*f*r - 64*D1*Dd*f*s**2 + 96*D1*Dd*f*s - 48*D1*Dd*f + 232*D1*Dd*fd*r**2 + 464*D1*Dd*fd*r*s - 126*D1*Dd*fd*r + 232*D1*Dd*fd*s**2 - 126*D1*Dd*fd*s - 36*D1*Dd*fd + 116*D1*Ddd*f*r**2 + 232*D1*Ddd*f*r*s - 174*D1*Ddd*f*r + 116*D1*Ddd*f*s**2 - 174*D1*Ddd*f*s + 87*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 348*Dd**2*f*r**2 + 696*Dd**2*f*r*s - 522*Dd**2*f*r + 348*Dd**2*f*s**2 - 522*Dd**2*f*s + 174*Dd**2*f)) + 66*b2*(14*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - D1**2*bdd1*f*(29*r**2 + r*(58*s - 70) + 29*s**2 - 70*s + 35) + 6*D1**2*(f*(fd*(10*r**2 + 2*r*(8*s - 5) + 6*s**2 - 8*s + 5) - fdd*(12*r**2 + 2*r*(11*s - 6) + 10*s**2 - 11*s + 6)) + fd**2*(-12*r**2 + r*(12 - 22*s) + s*(11 - 10*s))) + D1*bd1*(D1*(f*(16*r**2 + r*(32*s - 42) + 16*s**2 - 42*s + 21) - 58*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(116*r**2 + r*(232*s - 227) + 116*s**2 - 227*s + 105)) + 6*D1*f*(Dd*(f*(20*r**2 + 32*r*s - 26*r + 12*s**2 - 20*s + 11) - 2*fd*(48*r**2 + 88*r*s - 58*r + 40*s**2 - 53*s + 17)) - Ddd*f*(24*r**2 + r*(44*s - 34) + 20*s**2 - 31*s + 16)) - 6*Dd**2*f**2*(72*r**2 + 6*r*(22*s - 17) + 60*s**2 - 93*s + 32)))/(693*d**2*k3**3) - D1**2*Pk1*Pkd3*ct*k1*st**2*(4*C - 2)*(D1*f*(-3*D1*bd1**2*s*(2*r + 2*s - 1) + D1*bd1*(5*f*s*(r + s) - 3*fd*(r*(4*s - 1) + s*(4*s - 3))) - 3*D1*bdd1*f*s*(r + s) - 3*Dd*bd1*f*(r*(8*s - 2) + s*(8*s - 5))) + b1**2*(D1**2*(13*fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(13*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(8*r*s - 6*r + 8*s**2 - 13*s + 5)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1*(D1**2*(5*f*fd*(2*s - 1)*(r + s - 1) - 3*f*(bdd1*s*(2*r + 2*s - 1) + fdd*(2*s - 1)*(r + s - 1)) - 3*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(13*f*s*(2*r + 2*s - 1) - 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 6*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + D1*f*(Dd*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 3*fd*(2*s - 1)*(8*r + 8*s - 7)) - 3*Ddd*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - 3*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k2*k3) + D1**2*Pk1*Pkd3*ct*k1*(8*C - 4)*(D1*f*(-7*D1*bd1**2*s*(2*r + 2*s - 1) - 6*D1*bdd1*f*s*(r + s) - 6*bd1*(D1*(-f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 2) + s*(8*s - 5)))) + 7*b1**2*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + b1*(D1**2*(f*(-7*bdd1*s*(2*r + 2*s - 1) + 6*fd*(2*s - 1)*(r + s - 1) - 6*fdd*(2*s - 1)*(r + s - 1)) - 6*fd**2*(2*s - 1)*(r + s - 1)) + 7*D1*bd1*(-D1*(f*s*(-2*r - 2*s + 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1)) + 6*D1*f*(Dd*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) - 6*Dd**2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)))/(21*d**2*k2*k3) + 5*D1**2*Pk1*Pkd3*ct*k2**5*st**6*(1056*C*D1**2*b1*f*fd*r**2 + 1056*C*D1**2*b1*f*fd*r*s - 528*C*D1**2*b1*f*fd*r - 528*C*D1**2*b1*f*fdd*r**2 - 528*C*D1**2*b1*f*fdd*r*s + 264*C*D1**2*b1*f*fdd*r - 528*C*D1**2*b1*fd**2*r**2 - 528*C*D1**2*b1*fd**2*r*s + 264*C*D1**2*b1*fd**2*r + 48*C*D1**2*f**2*fd*r**2 + 48*C*D1**2*f**2*fd*r*s - 48*C*D1**2*f**2*fd*r - 16*C*D1**2*f**2*fd*s + 16*C*D1**2*f**2*fd - 24*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 24*C*D1**2*f**2*fdd*r + 8*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 48*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 48*C*D1**2*f*fd**2*r + 16*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 2112*C*D1*Dd*b1*f**2*r**2 + 2112*C*D1*Dd*b1*f**2*r*s - 2112*C*D1*Dd*b1*f**2*r - 528*C*D1*Dd*b1*f**2*s + 528*C*D1*Dd*b1*f**2 - 4224*C*D1*Dd*b1*f*fd*r**2 - 4224*C*D1*Dd*b1*f*fd*r*s + 3168*C*D1*Dd*b1*f*fd*r + 528*C*D1*Dd*b1*f*fd*s - 264*C*D1*Dd*b1*f*fd + 64*C*D1*Dd*f**3*r**2 + 64*C*D1*Dd*f**3*r*s - 64*C*D1*Dd*f**3*r - 16*C*D1*Dd*f**3*s + 16*C*D1*Dd*f**3 - 192*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 192*C*D1*Dd*f**2*fd*r + 56*C*D1*Dd*f**2*fd*s - 40*C*D1*Dd*f**2*fd - 1056*C*D1*Ddd*b1*f**2*r**2 - 1056*C*D1*Ddd*b1*f**2*r*s + 1056*C*D1*Ddd*b1*f**2*r + 264*C*D1*Ddd*b1*f**2*s - 264*C*D1*Ddd*b1*f**2 - 32*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 32*C*D1*Ddd*f**3*r + 8*C*D1*Ddd*f**3*s - 8*C*D1*Ddd*f**3 - 3168*C*Dd**2*b1*f**2*r**2 - 3168*C*Dd**2*b1*f**2*r*s + 3168*C*Dd**2*b1*f**2*r + 792*C*Dd**2*b1*f**2*s - 528*C*Dd**2*b1*f**2 - 96*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 96*C*Dd**2*f**3*r + 24*C*Dd**2*f**3*s - 16*C*Dd**2*f**3 - 1716*D1**2*b1*f*fd*r**2 - 2376*D1**2*b1*f*fd*r*s + 1188*D1**2*b1*f*fd*r - 660*D1**2*b1*f*fd*s**2 + 660*D1**2*b1*f*fd*s - 330*D1**2*b1*f*fd + 858*D1**2*b1*f*fdd*r**2 + 1188*D1**2*b1*f*fdd*r*s - 594*D1**2*b1*f*fdd*r + 330*D1**2*b1*f*fdd*s**2 - 330*D1**2*b1*f*fdd*s + 165*D1**2*b1*f*fdd + 858*D1**2*b1*fd**2*r**2 + 1188*D1**2*b1*fd**2*r*s - 594*D1**2*b1*fd**2*r + 330*D1**2*b1*fd**2*s**2 - 330*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)*(8*C*(r - 1) - 13*r - 5*s + 13) - 78*D1**2*f**2*fd*r**2 - 108*D1**2*f**2*fd*r*s + 88*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 56*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 39*D1**2*f**2*fdd*r**2 + 54*D1**2*f**2*fdd*r*s - 44*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 28*D1**2*f**2*fdd*s + 18*D1**2*f**2*fdd + 78*D1**2*f*fd**2*r**2 + 108*D1**2*f*fd**2*r*s - 88*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 56*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 - 3432*D1*Dd*b1*f**2*r**2 - 4752*D1*Dd*b1*f**2*r*s + 4092*D1*Dd*b1*f**2*r - 1320*D1*Dd*b1*f**2*s**2 + 2508*D1*Dd*b1*f**2*s - 1518*D1*Dd*b1*f**2 + 6864*D1*Dd*b1*f*fd*r**2 + 9504*D1*Dd*b1*f*fd*r*s - 6468*D1*Dd*b1*f*fd*r + 2640*D1*Dd*b1*f*fd*s**2 - 3828*D1*Dd*b1*f*fd*s + 1254*D1*Dd*b1*f*fd - 104*D1*Dd*f**3*r**2 - 144*D1*Dd*f**3*r*s + 124*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 76*D1*Dd*f**3*s - 46*D1*Dd*f**3 + 312*D1*Dd*f**2*fd*r**2 + 432*D1*Dd*f**2*fd*r*s - 362*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 226*D1*Dd*f**2*fd*s + 100*D1*Dd*f**2*fd + 1716*D1*Ddd*b1*f**2*r**2 + 2376*D1*Ddd*b1*f**2*r*s - 2046*D1*Ddd*b1*f**2*r + 660*D1*Ddd*b1*f**2*s**2 - 1254*D1*Ddd*b1*f**2*s + 759*D1*Ddd*b1*f**2 + 52*D1*Ddd*f**3*r**2 + 72*D1*Ddd*f**3*r*s - 62*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 38*D1*Ddd*f**3*s + 23*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1)*(8*C*(r - 1) - 13*r - 5*s + 13) + fd*(-4*C*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + 26*r**2 + 36*r*s - 35*r + 10*s**2 - 23*s + 9)) + Dd*f*(-4*C*(8*r**2 + 8*r*s - 12*r - 5*s + 4) + 52*r**2 + 72*r*s - 83*r + 20*s**2 - 55*s + 31)) + 5148*Dd**2*b1*f**2*r**2 + 7128*Dd**2*b1*f**2*r*s - 6138*Dd**2*b1*f**2*r + 1980*Dd**2*b1*f**2*s**2 - 3762*Dd**2*b1*f**2*s + 1518*Dd**2*b1*f**2 + 156*Dd**2*f**3*r**2 + 216*Dd**2*f**3*r*s - 186*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 114*Dd**2*f**3*s + 46*Dd**2*f**3)/(1386*d**2*k1*k3**5) + D1**2*Pk1*Pkd3*ct*k2**5*st**4*(-858*D1**2*bd1**2*f*(r + s - 1)*(K*(4*r - 2) - 9*r - 5*s + 7) + 13*D1*bd1*(D1*(10*f**3*(22*r**2 + r*(32*s - 38) + 10*s**2 - 26*s + 21) + f**2*(-264*C*(r - 1)*(r + s - 1) - 20*fd*(33*r**2 + 48*r*s - 46*r + 15*s**2 - 31*s + 12) + 429*r**2 + 594*r*s - 858*r + 165*s**2 - 594*s + 429) - 264*f*(r + s - 1)*(2*g2*(r - 1) - 2*gd2*r + gd2) + 264*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 10*Dd*f**3*(88*r**2 + 2*r*(64*s - 65) + 40*s**2 - 88*s + 45) + 264*Dd*f*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 429*b1**2*(D1**2*(2*fd - fdd)*(r + s)*(r*(4*K - 9) - 5*s) + D1*(2*Dd*(f*(4*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 36*r**2 - 56*r*s + 46*r - 20*s**2 + 34*s - 19) + fd*(r**2*(36 - 16*K) + r*(-16*K*s + 8*K + 56*s - 23) + s*(2*K + 20*s - 17))) + Ddd*f*(-4*K*(4*r**2 + 4*r*(s - 1) - s + 1) + 36*r**2 + 56*r*s - 46*r + 20*s**2 - 34*s + 19)) - 2*Dd**2*f*(K*(24*r**2 + 24*r*(s - 1) - 6*s + 4) - 54*r**2 - 84*r*s + 69*r - 30*s**2 + 51*s - 19)) + 13*b1*(-528*C*D1**2*f*fd*r**2 - 528*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*r - 1056*C*D1*Dd*f**2*r**2 - 1056*C*D1*Dd*f**2*r*s + 1056*C*D1*Dd*f**2*r + 264*C*D1*Dd*f**2*s - 264*C*D1*Dd*f**2 - 66*D1**2*bdd1*f*(r + s - 1)*(4*K*r - 2*K - 9*r - 5*s + 7) + 660*D1**2*f**2*fd*r**2 + 960*D1**2*f**2*fd*r*s - 700*D1**2*f**2*fd*r + 300*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 210*D1**2*f**2*fd - 330*D1**2*f**2*fdd*r**2 - 480*D1**2*f**2*fdd*r*s + 350*D1**2*f**2*fdd*r - 150*D1**2*f**2*fdd*s**2 + 230*D1**2*f**2*fdd*s - 105*D1**2*f**2*fdd - 660*D1**2*f*fd**2*r**2 - 960*D1**2*f*fd**2*r*s + 700*D1**2*f*fd**2*r - 300*D1**2*f*fd**2*s**2 + 460*D1**2*f*fd**2*s - 180*D1**2*f*fd**2 + 858*D1**2*f*fd*r**2 + 1188*D1**2*f*fd*r*s - 594*D1**2*f*fd*r + 330*D1**2*f*fd*s**2 - 330*D1**2*f*fd*s + 165*D1**2*f*fd - 528*D1**2*f*gd2*r**2 - 528*D1**2*f*gd2*r*s + 528*D1**2*f*gd2*r + 264*D1**2*f*gdd2*r**2 + 264*D1**2*f*gdd2*r*s - 264*D1**2*f*gdd2*r - 528*D1**2*fd*g2*r**2 - 528*D1**2*fd*g2*r*s + 528*D1**2*fd*gd2*r**2 + 528*D1**2*fd*gd2*r*s - 264*D1**2*fd*gd2*r + 264*D1**2*fdd*g2*r**2 + 264*D1**2*fdd*g2*r*s + 880*D1*Dd*f**3*r**2 + 1280*D1*Dd*f**3*r*s - 1080*D1*Dd*f**3*r + 400*D1*Dd*f**3*s**2 - 720*D1*Dd*f**3*s + 420*D1*Dd*f**3 - 2640*D1*Dd*f**2*fd*r**2 - 3840*D1*Dd*f**2*fd*r*s + 3020*D1*Dd*f**2*fd*r - 1200*D1*Dd*f**2*fd*s**2 + 2000*D1*Dd*f**2*fd*s - 810*D1*Dd*f**2*fd + 1716*D1*Dd*f**2*r**2 + 2376*D1*Dd*f**2*r*s - 2046*D1*Dd*f**2*r + 660*D1*Dd*f**2*s**2 - 1254*D1*Dd*f**2*s + 759*D1*Dd*f**2 - 2112*D1*Dd*f*g2*r**2 - 2112*D1*Dd*f*g2*r*s + 2112*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s - 528*D1*Dd*f*g2 + 2112*D1*Dd*f*gd2*r**2 + 2112*D1*Dd*f*gd2*r*s - 2112*D1*Dd*f*gd2*r - 264*D1*Dd*f*gd2*s + 264*D1*Dd*f*gd2 + 2112*D1*Dd*fd*g2*r**2 + 2112*D1*Dd*fd*g2*r*s - 1056*D1*Dd*fd*g2*r - 264*D1*Dd*fd*g2*s - 440*D1*Ddd*f**3*r**2 - 640*D1*Ddd*f**3*r*s + 540*D1*Ddd*f**3*r - 200*D1*Ddd*f**3*s**2 + 360*D1*Ddd*f**3*s - 210*D1*Ddd*f**3 + 1056*D1*Ddd*f*g2*r**2 + 1056*D1*Ddd*f*g2*r*s - 1056*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2*s + 264*D1*Ddd*f*g2 + 132*D1*bd1*(D1*(f*(r + s - 1)*(K*(4*r - 2) - 9*r - 5*s + 7) + fd*(r**2*(9 - 4*K) + r*(-4*K*s + 3*K + 14*s - 8) + s*(K + 5*s - 6))) + Dd*f*(K*(-16*r**2 - 16*r*s + 20*r + 6*s - 5) + 36*r**2 + 56*r*s - 55*r + 20*s**2 - 41*s + 20)) - 1320*Dd**2*f**3*r**2 - 1920*Dd**2*f**3*r*s + 1620*Dd**2*f**3*r - 600*Dd**2*f**3*s**2 + 1080*Dd**2*f**3*s - 420*Dd**2*f**3 + 3168*Dd**2*f*g2*r**2 + 3168*Dd**2*f*g2*r*s - 3168*Dd**2*f*g2*r - 792*Dd**2*f*g2*s + 528*Dd**2*f*g2) + f*(-13*D1**2*bdd1*(5*f**2*(22*r**2 + 32*r*s - 38*r + 10*s**2 - 26*s + 21) - 264*g2*(r - 1)*(r + s - 1)) + f*(D1**2*(f*(3*fd*(644*r**2 - 2*r*(68*s + 127) - 780*s**2 + 814*s - 229) + 5*fdd*(332*r**2 + r*(904*s - 618) + 572*s**2 - 798*s + 369)) + 30*fd**2*(166*r**2 + r*(452*s - 309) + 286*s**2 - 399*s + 123)) + D1*f*(Dd*(3*f*(644*r**2 - 2*r*(68*s + 127) - 780*s**2 + 814*s - 229) + 10*fd*(1328*r**2 + 8*r*(452*s - 309) + 2288*s**2 - 3192*s + 1107)) + 5*Ddd*f*(332*r**2 + r*(904*s - 618) + 572*s**2 - 798*s + 369)) + 30*Dd**2*f**2*(166*r**2 + r*(452*s - 309) + 286*s**2 - 399*s + 123))))/(3003*d**2*k1*k3**5) - 10*D1**2*Pk1*Pkd3*ct*k2**3*st**6*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(693*d**2*k1*k3**3) + D1**2*Pk1*Pkd3*ct*k2**3*st**4*(33*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)*(r*(8*C - 9) - s + 1) + D1*(2*Dd*(f*(8*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 36*r**2 - 40*r*s + 38*r - 4*s**2 + 14*s - 11) + fd*(-4*C*(8*r**2 + 8*r*(s - 1) - s + 1) + 36*r**2 + 40*r*s - 39*r + 4*s**2 - 11*s + 7)) + Ddd*f*(-8*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 36*r**2 + 40*r*s - 38*r + 4*s**2 - 14*s + 11)) - 2*Dd**2*f*(4*C*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - 54*r**2 + r*(57 - 60*s) - 6*s**2 + 21*s - 11)) + 33*b1*(D1**2*bdd1*f*(-8*C*(2*r**2 + 2*r*(s - 1) - s + 1) + 18*r**2 + 20*r*s - 18*r + 2*s**2 - 10*s + 9) + 10*D1**2*f*fd*r**2 + 28*D1**2*f*fd*r*s - 14*D1**2*f*fd*r + 18*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 9*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 20*D1*Dd*f**2*r**2 + 56*D1*Dd*f**2*r*s - 38*D1*Dd*f**2*r + 36*D1*Dd*f**2*s**2 - 50*D1*Dd*f**2*s + 23*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 132*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 172*D1*Dd*f*fd*s - 50*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 38*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 50*D1*Ddd*f**2*s - 23*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(8*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 18*r**2 - 20*r*s + 18*r - 2*s**2 + 10*s - 9) + fd*(-4*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 18*r**2 + 20*r*s - 19*r + 2*s**2 - 7*s + 5)) + Dd*f*(-8*C*(8*r**2 + 8*r*(s - 1) - 3*s + 2) + 72*r**2 + 80*r*s - 74*r + 8*s**2 - 34*s + 19)) - 60*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 114*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 150*Dd**2*f**2*s - 46*Dd**2*f**2) - f*(66*D1**2*bd1**2*(r**2*(8*C - 9) + r*(8*C*(s - 1) - 10*s + 9) - s*(4*C + s - 5)) + 33*D1**2*bdd1*f*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) + 2*D1**2*(f*(2*fd - fdd)*(20*C*(3*r**2 + 3*r*(s - 1) - s + 1) - 21*r**2 + r*(16 - 6*s) + 15*s**2 - 8*s - 2) - 2*fd**2*(10*C*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 21*r**2 + r*(16 - 6*s) + 15*s**2 - 8*s - 1)) - 33*D1*bd1*(D1*(f*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) - 2*fd*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7)) - 2*Dd*f*(20*r**2 + r*(56*s - 39) + 36*s**2 - 53*s + 19)) + 2*D1*f*(2*Dd*(f*(20*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 28*r**2 + r*(18 - 8*s) + 20*s**2 - 18*s + 3) + fd*(-10*C*(24*r**2 + 24*r*(s - 1) - 7*s + 5) + 84*r**2 + r*(24*s - 59) + s*(43 - 60*s))) + Ddd*f*(-20*C*(4*r**2 + 4*r*(s - 1) - s + 1) + 28*r**2 + 2*r*(4*s - 9) - 20*s**2 + 18*s - 3)) - 4*Dd**2*f**2*(10*C*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - 42*r**2 + 3*r*(9 - 4*s) + 30*s**2 - 27*s + 3)))/(231*d**2*k1*k3**3) + D1**2*Pk1*Pkd3*ct*k2**3*st**2*(D1*(-22*D1*bd1**2*(f**2*(9*r**2 - 30*r*s - 39*s**2 + 36*s - 9) + f*(r**2*(34 - 4*K) + r*(-4*K*s + 2*K + 64*s - 61) + 30*s**2 - 59*s + 29) + 28*g2*(-2*r**2 - 2*r*(s - 1) + s)) + bd1*(D1*(f**3*(86*r**2 + r*(98 - 244*s) - 330*s**2 + 330*s - 165) + f**2*(4*fd*(381*r**2 + 2*r*(537*s - 340) + 693*s**2 - 872*s + 213) - 11*r**2*(-8*C + 8*K + 6) - 11*r*(-8*C*s + 8*K*(s - 1) + 20*s + 2) - 154*s**2 + 154*s - 11) + 22*f*(11*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 4*r*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) - 88*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + 2*Dd*f*(f**2*(1016*r**2 + 2864*r*s - 1750*r + 1848*s**2 - 2206*s + 657) + 121*f*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 44*g2*(8*r**2 + 8*r*s - 4*r - s))) + f*(D1*bdd1*(f**2*(254*r**2 + r*(716*s - 390) + 462*s**2 - 462*s + 231) + 121*f*(r + s - 1)**2 - 88*g2*r*(r + s)) + 44*D1*(f*(fd*(9*r**2 + 9*r*(s - 1) - 3*s + 3) - r*(2*bd2 - 4*gd2)*(r + s - 1)) + 4*fd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 44*Dd*f*(3*f + 4*g2)*(4*r**2 + 4*r*(s - 1) - s + 1) - 88*b2*(D1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)))) + 11*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(6*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 14*Dd*(4*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 20*r**2 + r*(22 - 24*s) - 4*s**2 + 10*s - 7) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*Ddd*(4*K*(4*r**2 + 4*r*(s - 1) - s + 1) - 20*r**2 + r*(22 - 24*s) - 4*s**2 + 10*s - 7)) - 2*Dd**2*(7*K*(24*r**2 + 24*r*(s - 1) - 6*s + 4) + 9*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 210*r**2 - 252*r*s + 231*r - 42*s**2 + 105*s - 49)) + 11*b1**2*(-56*C*D1**2*fd*r**2 - 56*C*D1**2*fd*r*s + 56*C*D1**2*fd*r - 224*C*D1*Dd*f*r**2 - 224*C*D1*Dd*f*r*s + 224*C*D1*Dd*f*r + 56*C*D1*Dd*f*s - 56*C*D1*Dd*f - 8*D1**2*K*fd*r**2 - 8*D1**2*K*fd*r*s + 16*D1**2*K*fd*r + 8*D1**2*K*fd*s - 8*D1**2*K*fd + 4*D1**2*K*fdd*r**2 + 4*D1**2*K*fdd*r*s - 8*D1**2*K*fdd*r - 4*D1**2*K*fdd*s + 4*D1**2*K*fdd + D1**2*bdd1*(-28*K*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 105*r**2 + 126*r*s - 112*r + 21*s**2 - 56*s + 42) + 80*D1**2*f*fd*r**2 + 32*D1**2*f*fd*r*s - 14*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 74*D1**2*f*fd*s - 41*D1**2*f*fd - 18*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 42*D1**2*f*fdd*r + 78*D1**2*f*fdd*s**2 - 114*D1**2*f*fdd*s + 57*D1**2*f*fdd - 18*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 42*D1**2*fd**2*r + 78*D1**2*fd**2*s**2 - 114*D1**2*fd**2*s + 36*D1**2*fd**2 + 96*D1**2*fd*r**2 + 100*D1**2*fd*r*s - 90*D1**2*fd*r + 4*D1**2*fd*s**2 - 26*D1**2*fd*s + 17*D1**2*fd - 34*D1**2*fdd*r**2 - 64*D1**2*fdd*r*s + 10*D1**2*fdd*r - 30*D1**2*fdd*s**2 + 6*D1**2*fdd*s - 5*D1**2*fdd - 112*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r + 56*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r - 32*D1*Dd*K*f*r**2 - 32*D1*Dd*K*f*r*s + 32*D1*Dd*K*f*r + 8*D1*Dd*K*f*s - 8*D1*Dd*K*f + 32*D1*Dd*K*fd*r**2 + 32*D1*Dd*K*fd*r*s - 48*D1*Dd*K*fd*r - 20*D1*Dd*K*fd*s + 16*D1*Dd*K*fd + 160*D1*Dd*f**2*r**2 + 64*D1*Dd*f**2*r*s - 112*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 80*D1*Dd*f**2*s - 8*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 252*D1*Dd*f*fd*r + 624*D1*Dd*f*fd*s**2 - 828*D1*Dd*f*fd*s + 270*D1*Dd*f*fd + 384*D1*Dd*f*r**2 + 400*D1*Dd*f*r*s - 392*D1*Dd*f*r + 16*D1*Dd*f*s**2 - 116*D1*Dd*f*s + 104*D1*Dd*f - 272*D1*Dd*fd*r**2 - 512*D1*Dd*fd*r*s + 236*D1*Dd*fd*r - 240*D1*Dd*fd*s**2 + 208*D1*Dd*fd*s - 22*D1*Dd*fd - 448*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 448*D1*Dd*g2*r + 112*D1*Dd*g2*s - 112*D1*Dd*g2 + 448*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 448*D1*Dd*gd2*r - 56*D1*Dd*gd2*s + 56*D1*Dd*gd2 + 16*D1*Ddd*K*f*r**2 + 16*D1*Ddd*K*f*r*s - 16*D1*Ddd*K*f*r - 4*D1*Ddd*K*f*s + 4*D1*Ddd*K*f - 36*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 42*D1*Ddd*f**2*r + 156*D1*Ddd*f**2*s**2 - 186*D1*Ddd*f**2*s + 69*D1*Ddd*f**2 - 136*D1*Ddd*f*r**2 - 256*D1*Ddd*f*r*s + 196*D1*Ddd*f*r - 120*D1*Ddd*f*s**2 + 184*D1*Ddd*f*s - 94*D1*Ddd*f + 224*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 224*D1*Ddd*g2*r - 56*D1*Ddd*g2*s + 56*D1*Ddd*g2 + 2*D1*bd1*(3*D1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*D1*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 7*D1*(4*K*(3*r**2 + 3*r*(s - 1) - s + 1) - 15*r**2 - 2*r*(9*s - 8) - 3*s**2 + 8*s - 6) - 3*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 7*Dd*(2*K*(24*r**2 + 24*r*(s - 1) - 7*s + 5) - 60*r**2 + r*(65 - 72*s) - 12*s**2 + 31*s - 16)) + 48*Dd**2*K*f*r**2 + 48*Dd**2*K*f*r*s - 48*Dd**2*K*f*r - 12*Dd**2*K*f*s + 8*Dd**2*K*f - 108*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 126*Dd**2*f**2*r + 468*Dd**2*f**2*s**2 - 558*Dd**2*f**2*s + 138*Dd**2*f**2 - 408*Dd**2*f*r**2 - 768*Dd**2*f*r*s + 588*Dd**2*f*r - 360*Dd**2*f*s**2 + 552*Dd**2*f*s - 188*Dd**2*f + 672*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 672*Dd**2*g2*r - 168*Dd**2*g2*s + 112*Dd**2*g2) + b1*(176*C*D1**2*f*fd*r**2 + 176*C*D1**2*f*fd*r*s - 264*C*D1**2*f*fd*r - 88*C*D1**2*f*fd*s + 88*C*D1**2*f*fd + 352*C*D1*Dd*f**2*r**2 + 352*C*D1*Dd*f**2*r*s - 352*C*D1*Dd*f**2*r - 88*C*D1*Dd*f**2*s + 88*C*D1*Dd*f**2 - 176*D1**2*K*f*fd*r**2 - 176*D1**2*K*f*fd*r*s + 176*D1**2*K*f*fd*r + 88*D1**2*K*f*fd*s - 88*D1**2*K*f*fd - 22*D1**2*bd1**2*(14*K*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 105*r**2 - 126*r*s + 112*r - 21*s**2 + 56*s - 21) - 11*D1**2*bdd1*(6*f**2*(3*r**2 - 10*r*s - 13*s**2 + 12*s - 2) + f*(r**2*(68 - 8*K) - 2*r*(4*K*s - 2*K - 64*s + 61) + 60*s**2 - 118*s + 59) - 56*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 258*D1**2*f**2*fd*r**2 - 732*D1**2*f**2*fd*r*s + 218*D1**2*f**2*fd*r - 990*D1**2*f**2*fd*s**2 + 1234*D1**2*f**2*fd*s - 409*D1**2*f**2*fd + 762*D1**2*f**2*fdd*r**2 + 2148*D1**2*f**2*fdd*r*s - 1550*D1**2*f**2*fdd*r + 1386*D1**2*f**2*fdd*s**2 - 2102*D1**2*f**2*fdd*s + 947*D1**2*f**2*fdd + 1524*D1**2*f*fd**2*r**2 + 4296*D1**2*f*fd**2*r*s - 3100*D1**2*f*fd**2*r + 2772*D1**2*f*fd**2*s**2 - 4204*D1**2*f*fd**2*s + 1504*D1**2*f*fd**2 - 132*D1**2*f*fd*r**2 - 440*D1**2*f*fd*r*s + 374*D1**2*f*fd*r - 308*D1**2*f*fd*s**2 + 374*D1**2*f*fd*s - 209*D1**2*f*fd + 242*D1**2*f*fdd*r**2 + 484*D1**2*f*fdd*r*s - 242*D1**2*f*fdd*r + 242*D1**2*f*fdd*s**2 - 242*D1**2*f*fdd*s + 121*D1**2*f*fdd + 176*D1**2*f*gd2*r**2 + 176*D1**2*f*gd2*r*s - 176*D1**2*f*gd2*r - 88*D1**2*f*gdd2*r**2 - 88*D1**2*f*gdd2*r*s + 88*D1**2*f*gdd2*r + 242*D1**2*fd**2*r**2 + 484*D1**2*fd**2*r*s - 242*D1**2*fd**2*r + 242*D1**2*fd**2*s**2 - 242*D1**2*fd**2*s + 176*D1**2*fd*g2*r**2 + 176*D1**2*fd*g2*r*s - 352*D1**2*fd*g2*r - 176*D1**2*fd*g2*s + 176*D1**2*fd*g2 - 176*D1**2*fd*gd2*r**2 - 176*D1**2*fd*gd2*r*s + 264*D1**2*fd*gd2*r + 88*D1**2*fd*gd2*s - 88*D1**2*fd*gd2 - 88*D1**2*fdd*g2*r**2 - 88*D1**2*fdd*g2*r*s + 176*D1**2*fdd*g2*r + 88*D1**2*fdd*g2*s - 88*D1**2*fdd*g2 - 352*D1*Dd*K*f**2*r**2 - 352*D1*Dd*K*f**2*r*s + 352*D1*Dd*K*f**2*r + 88*D1*Dd*K*f**2*s - 88*D1*Dd*K*f**2 + 344*D1*Dd*f**3*r**2 - 976*D1*Dd*f**3*r*s + 316*D1*Dd*f**3*r - 1320*D1*Dd*f**3*s**2 + 1564*D1*Dd*f**3*s - 574*D1*Dd*f**3 + 6096*D1*Dd*f**2*fd*r**2 + 17184*D1*Dd*f**2*fd*r*s - 12020*D1*Dd*f**2*fd*r + 11088*D1*Dd*f**2*fd*s**2 - 16100*D1*Dd*f**2*fd*s + 5754*D1*Dd*f**2*fd - 264*D1*Dd*f**2*r**2 - 880*D1*Dd*f**2*r*s + 572*D1*Dd*f**2*r - 616*D1*Dd*f**2*s**2 + 836*D1*Dd*f**2*s - 374*D1*Dd*f**2 + 1936*D1*Dd*f*fd*r**2 + 3872*D1*Dd*f*fd*r*s - 2420*D1*Dd*f*fd*r + 1936*D1*Dd*f*fd*s**2 - 2420*D1*Dd*f*fd*s + 726*D1*Dd*f*fd + 704*D1*Dd*f*g2*r**2 + 704*D1*Dd*f*g2*r*s - 704*D1*Dd*f*g2*r - 176*D1*Dd*f*g2*s + 176*D1*Dd*f*g2 - 704*D1*Dd*f*gd2*r**2 - 704*D1*Dd*f*gd2*r*s + 704*D1*Dd*f*gd2*r + 88*D1*Dd*f*gd2*s - 88*D1*Dd*f*gd2 - 704*D1*Dd*fd*g2*r**2 - 704*D1*Dd*fd*g2*r*s + 1056*D1*Dd*fd*g2*r + 440*D1*Dd*fd*g2*s - 352*D1*Dd*fd*g2 + 1016*D1*Ddd*f**3*r**2 + 2864*D1*Ddd*f**3*r*s - 1940*D1*Ddd*f**3*r + 1848*D1*Ddd*f**3*s**2 - 2564*D1*Ddd*f**3*s + 1178*D1*Ddd*f**3 + 484*D1*Ddd*f**2*r**2 + 968*D1*Ddd*f**2*r*s - 726*D1*Ddd*f**2*r + 484*D1*Ddd*f**2*s**2 - 726*D1*Ddd*f**2*s + 363*D1*Ddd*f**2 - 352*D1*Ddd*f*g2*r**2 - 352*D1*Ddd*f*g2*r*s + 352*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2*s - 88*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(f**2*(80*r**2 + r*(32*s - 98) - 48*s**2 + 6*s + 33) + f*(-56*C*(2*r**2 + 2*r*(s - 1) - s + 1) - 16*K*r**2 - 16*K*r*s + 8*K*r - 12*fd*(6*r**2 - 20*r*s + 7*r - 26*s**2 + 31*s - 7) + 192*r**2 + 200*r*s - 202*r + 8*s**2 - 82*s + 83) + 2*fd*(2*K*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 68*r**2 + r*(71 - 128*s) - 60*s**2 + 65*s - 3) - 56*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 56*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) + 2*Dd*(-6*f**2*(12*r**2 + r*(7 - 40*s) - 52*s**2 + 55*s - 12) + f*(K*(32*r**2 + 8*r*(4*s - 3) - 4*s + 2) - 272*r**2 - 512*r*s + 440*r - 240*s**2 + 420*s - 179) + 56*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + 3048*Dd**2*f**3*r**2 + 8592*Dd**2*f**3*r*s - 5820*Dd**2*f**3*r + 5544*Dd**2*f**3*s**2 - 7692*Dd**2*f**3*s + 2356*Dd**2*f**3 + 1452*Dd**2*f**2*r**2 + 2904*Dd**2*f**2*r*s - 2178*Dd**2*f**2*r + 1452*Dd**2*f**2*s**2 - 2178*Dd**2*f**2*s + 726*Dd**2*f**2 - 1056*Dd**2*f*g2*r**2 - 1056*Dd**2*f*g2*r*s + 1056*Dd**2*f*g2*r + 264*Dd**2*f*g2*s - 176*Dd**2*f*g2))/(462*d**2*k1*k3**3) - 4*D1**2*Pk1*Pkd3*ct*k2*st**4*(D1**2*bd1**2*f*s*(-2*r - 2*s + 1) + D1*b1*(D1*bdd1*f*s*(-2*r - 2*s + 1) - bd1*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(7*d**2*k1*k3) + D1**2*Pk1*Pkd3*ct*k2*st**2*(D1*f*(-2*D1*bd1**2*(5*r**2 + r*(34*s - 5) + s*(29*s - 17)) + D1*bdd1*f*(3*r**2 + 14*r*s + 11*s**2) + bd1*(D1*(-f*(r + s)*(r*(16*C - 3) + 17*s) + 4*fd*(3*r**2 + r*(14*s - 5) + s*(11*s - 9))) + 2*Dd*f*(12*r**2 + r*(56*s - 17) + s*(44*s - 29)))) + b1**2*(D1**2*(r + s - 1)*(3*fd*r + 23*fd*(s - 1) + fdd*(-5*r - 29*s + 29)) + D1*(Dd*(f*(12*r**2 + 104*r*s - 58*r + 92*s**2 - 118*s + 49) - 2*fd*(20*r**2 + 136*r*s - 107*r + 116*s**2 - 191*s + 75)) - Ddd*f*(20*r**2 + 2*r*(68*s - 39) + 116*s**2 - 150*s + 63)) - 6*Dd**2*f*(10*r**2 + r*(68*s - 39) + 58*s**2 - 75*s + 21)) + b1*(-32*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r + 16*C*D1**2*f*fd*s - 16*C*D1**2*f*fd - 64*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s + 64*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s - 16*C*D1*Dd*f**2 - D1**2*bdd1*f*(10*r**2 + 68*r*s - 10*r + 58*s**2 - 34*s + 5) + 6*D1**2*f*fd*r**2 - 28*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 34*D1**2*f*fd*s**2 + 48*D1**2*f*fd*s - 14*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 28*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 22*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 14*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 28*D1**2*fd**2*r*s - 20*D1**2*fd**2*r + 22*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s + 14*D1**2*fd**2 + 12*D1*Dd*f**2*r**2 - 56*D1*Dd*f**2*r*s + 22*D1*Dd*f**2*r - 68*D1*Dd*f**2*s**2 + 82*D1*Dd*f**2*s - 31*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 224*D1*Dd*f*fd*r*s - 148*D1*Dd*f*fd*r + 176*D1*Dd*f*fd*s**2 - 260*D1*Dd*f*fd*s + 92*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 + 56*D1*Ddd*f**2*r*s - 34*D1*Ddd*f**2*r + 44*D1*Ddd*f**2*s**2 - 58*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 + D1*bd1*(D1*(f*(6*r**2 + 52*r*s - 6*r + 46*s**2 - 26*s + 3) - 2*fd*(10*r**2 + 68*r*s - 39*r + 58*s**2 - 75*s + 17)) - 2*Dd*f*(40*r**2 + r*(272*s - 98) + 232*s**2 - 218*s + 39)) + 36*Dd**2*f**2*r**2 + 168*Dd**2*f**2*r*s - 102*Dd**2*f**2*r + 132*Dd**2*f**2*s**2 - 174*Dd**2*f**2*s + 50*Dd**2*f**2))/(42*d**2*k1*k3) + D1**2*Pk1*Pkd3*ct*k2*(2*D1*(D1*bd1**2*f*(r**2*(-4*K + 2*f - 1) + r*(2*s - 1)*(-2*K + 10*f + 9) + s*(18*f + 19)*(s - 1)) - 2*D1*bdd1*f*r*(b2 - 2*g2)*(r + s) - 2*bd1*(D1*b2*(-2*f*r*(r + s) + fd*(2*r**2 + 2*r*(s - 1) - s)) + D1*bd2*f*r*(2*r + 2*s - 1) + 2*D1*(f*r*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1)) + fd*g2*(-2*r**2 - 2*r*(s - 1) + s)) + Dd*b2*f*(8*r**2 + r*(8*s - 4) - s) + 2*Dd*f*g2*(-8*r**2 + r*(4 - 8*s) + s))) + b1**3*(D1**2*(fd*(13*r - 7*s + 7) - 3*fdd*(r - 7*s + 7))*(r + s - 1) + D1*(Dd*f*(52*r**2 + r*(24*s - 38) - 28*s**2 + 22*s - 1) - 6*Dd*fd*(4*r**2 + r*(17 - 24*s) - 28*s**2 + 45*s - 17) - 28*Dd*(-4*r**2 + 2*r + (1 - 2*s)**2) - 3*Ddd*f*(4*r**2 + r*(10 - 24*s) - 28*s**2 + 34*s - 13) + 14*Ddd*(-4*r**2 + 2*r + (1 - 2*s)**2)) + 2*Dd**2*(-3*f*(6*r**2 - 36*r*s + 15*r - 42*s**2 + 51*s - 13) - 84*r**2 + 42*r + 84*s**2 - 84*s + 14)) + b1**2*(8*D1**2*K*fd*r**2 + 8*D1**2*K*fd*r*s - 16*D1**2*K*fd*r - 8*D1**2*K*fd*s + 8*D1**2*K*fd - 4*D1**2*K*fdd*r**2 - 4*D1**2*K*fdd*r*s + 8*D1**2*K*fdd*r + 4*D1**2*K*fdd*s - 4*D1**2*K*fdd + D1**2*bdd1*(-3*f*(3*r**2 + r*(4 - 18*s) - 21*s**2 + 20*s - 6) - 42*r**2 + 28*r + 14*s*(3*s - 2)) + 4*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s - 12*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 4*D1**2*f*fd + 4*D1**2*f*fdd*r**2 + 40*D1**2*f*fdd*r*s - 24*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 56*D1**2*f*fdd*s + 20*D1**2*f*fdd + 4*D1**2*fd**2*r**2 + 40*D1**2*fd**2*r*s - 24*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 56*D1**2*fd**2*s + 20*D1**2*fd**2 + 9*D1**2*fd*r**2 + 6*D1**2*fd*r*s - 18*D1**2*fd*r - 3*D1**2*fd*s**2 - 6*D1**2*fd*s + 9*D1**2*fd - D1**2*fdd*r**2 + 18*D1**2*fdd*r*s + 2*D1**2*fdd*r + 19*D1**2*fdd*s**2 - 18*D1**2*fdd*s - D1**2*fdd + 32*D1*Dd*K*f*r**2 + 32*D1*Dd*K*f*r*s - 32*D1*Dd*K*f*r - 8*D1*Dd*K*f*s + 8*D1*Dd*K*f - 32*D1*Dd*K*fd*r**2 - 32*D1*Dd*K*fd*r*s + 48*D1*Dd*K*fd*r + 20*D1*Dd*K*fd*s - 16*D1*Dd*K*fd + 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 + 28*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 32*D1*Dd*f*fd*r**2 + 320*D1*Dd*f*fd*r*s - 184*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s**2 - 408*D1*Dd*f*fd*s + 136*D1*Dd*f*fd + 36*D1*Dd*f*r**2 + 24*D1*Dd*f*r*s - 30*D1*Dd*f*r - 12*D1*Dd*f*s**2 + 6*D1*Dd*f*s + 3*D1*Dd*f - 8*D1*Dd*fd*r**2 + 144*D1*Dd*fd*r*s - 26*D1*Dd*fd*r + 152*D1*Dd*fd*s**2 - 166*D1*Dd*fd*s + 34*D1*Dd*fd - 16*D1*Ddd*K*f*r**2 - 16*D1*Ddd*K*f*r*s + 16*D1*Ddd*K*f*r + 4*D1*Ddd*K*f*s - 4*D1*Ddd*K*f + 8*D1*Ddd*f**2*r**2 + 80*D1*Ddd*f**2*r*s - 44*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 92*D1*Ddd*f**2*s + 38*D1*Ddd*f**2 - 4*D1*Ddd*f*r**2 + 72*D1*Ddd*f*r*s - 34*D1*Ddd*f*r + 76*D1*Ddd*f*s**2 - 94*D1*Ddd*f*s + 37*D1*Ddd*f + D1*bd1*(D1*f*(39*r**2 + 2*r*(9*s - 16) - 21*s**2 + 8*s + 6) - 2*D1*(fd*(9*r**2 + r*(33 - 54*s) - 63*s**2 + 93*s - 30) - 42*r**2 + 28*r + 14*s*(3*s - 2)) - 6*Dd*f*(12*r**2 + r*(23 - 72*s) - 84*s**2 + 91*s - 22) - 28*Dd*(12*r**2 - 7*r - 12*s**2 + 10*s - 1)) - 48*Dd**2*K*f*r**2 - 48*Dd**2*K*f*r*s + 48*Dd**2*K*f*r + 12*Dd**2*K*f*s - 8*Dd**2*K*f + 24*Dd**2*f**2*r**2 + 240*Dd**2*f**2*r*s - 132*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 276*Dd**2*f**2*s + 76*Dd**2*f**2 - 12*Dd**2*f*r**2 + 216*Dd**2*f*r*s - 102*Dd**2*f*r + 228*Dd**2*f*s**2 - 282*Dd**2*f*s + 74*Dd**2*f) + b1*(-2*D1**2*bd1**2*(3*f*(3*r**2 + r*(4 - 18*s) - 21*s**2 + 20*s - 3) + 42*r**2 - 28*r + 14*s*(2 - 3*s)) + D1**2*bdd1*f*(2*f*(2*r**2 + 20*r*s - 10*r + 18*s**2 - 18*s + 9) + r**2*(-8*K - 2) - r*(4*K - 18)*(2*s - 1) + 38*s**2 - 38*s + 19) - 4*D1**2*bdd2*f*r**2 - 4*D1**2*bdd2*f*r*s + 4*D1**2*bdd2*f*r - 16*D1**2*f*gd2*r**2 - 16*D1**2*f*gd2*r*s + 16*D1**2*f*gd2*r + 8*D1**2*f*gdd2*r**2 + 8*D1**2*f*gdd2*r*s - 8*D1**2*f*gdd2*r - 16*D1**2*fd*g2*r**2 - 16*D1**2*fd*g2*r*s + 32*D1**2*fd*g2*r + 16*D1**2*fd*g2*s - 16*D1**2*fd*g2 + 16*D1**2*fd*gd2*r**2 + 16*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*r - 8*D1**2*fd*gd2*s + 8*D1**2*fd*gd2 + 8*D1**2*fdd*g2*r**2 + 8*D1**2*fdd*g2*r*s - 16*D1**2*fdd*g2*r - 8*D1**2*fdd*g2*s + 8*D1**2*fdd*g2 - 64*D1*Dd*f*g2*r**2 - 64*D1*Dd*f*g2*r*s + 64*D1*Dd*f*g2*r + 16*D1*Dd*f*g2*s - 16*D1*Dd*f*g2 + 64*D1*Dd*f*gd2*r**2 + 64*D1*Dd*f*gd2*r*s - 64*D1*Dd*f*gd2*r - 8*D1*Dd*f*gd2*s + 8*D1*Dd*f*gd2 + 64*D1*Dd*fd*g2*r**2 + 64*D1*Dd*fd*g2*r*s - 96*D1*Dd*fd*g2*r - 40*D1*Dd*fd*g2*s + 32*D1*Dd*fd*g2 + 32*D1*Ddd*f*g2*r**2 + 32*D1*Ddd*f*g2*r*s - 32*D1*Ddd*f*g2*r - 8*D1*Ddd*f*g2*s + 8*D1*Ddd*f*g2 + D1*bd1*(D1*(2*f**2*(2*r**2 + r*(2 - 4*s) - 6*s**2 + 6*s - 3) + f*(8*fd*(2*r**2 + r*(20*s - 11) + 18*s**2 - 23*s + 7) + r**2*(16*K + 18) + r*(8*K + 6)*(2*s - 1) - 6*s**2 + 6*s - 3) - 2*fd*(2*K*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 2*r**2 + r*(7 - 36*s) - 38*s**2 + 37*s - 9)) + 2*Dd*f*(K*(-32*r**2 - 32*r*s + 24*r + 4*s - 2) + 2*f*(8*r**2 + r*(80*s - 42) + 72*s**2 - 82*s + 23) - 8*r**2 + 144*r*s - 70*r + 152*s**2 - 170*s + 47)) + 4*D1*bd2*(D1*(r + s - 1)*(2*f*r - 2*fd*r + fd) - Dd*f*(8*r**2 + 8*r*(s - 1) - s + 1)) + 96*Dd**2*f*g2*r**2 + 96*Dd**2*f*g2*r*s - 96*Dd**2*f*g2*r - 24*Dd**2*f*g2*s + 16*Dd**2*f*g2 + 4*b2*(D1**2*(2*fd - fdd)*(r - 1)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2))))/(21*d**2*k1*k3) + D1**2*Pk1*Pkd3*f*k1**4*k2**2*st**4*(18*C - 9)*(11*D1**2*bd1*f*(r + s - 1)**2 + 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 11*D1*b1*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**7) + D1**2*Pk1*Pkd3*f*k1**4*st**4*(8*C - 4)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4))/(77*d**2*k3**5) + 5*D1**2*Pk1*Pkd3*f*k2**6*st**6*(1131*D1**2*b1*f*fd*r**2 + 1131*D1**2*b1*f*fd*r*s - 754*D1**2*b1*f*fd*r - 1209*D1**2*b1*f*fdd*r**2 - 1209*D1**2*b1*f*fdd*r*s + 806*D1**2*b1*f*fdd*r - 2418*D1**2*b1*fd**2*r**2 - 2418*D1**2*b1*fd**2*r*s + 1612*D1**2*b1*fd**2*r - 403*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 252*D1**2*f**2*fd*r**2 + 252*D1**2*f**2*fd*r*s - 252*D1**2*f**2*fd*r - 63*D1**2*f**2*fd*s + 63*D1**2*f**2*fd - 204*D1**2*f**2*fdd*r**2 - 204*D1**2*f**2*fdd*r*s + 204*D1**2*f**2*fdd*r + 51*D1**2*f**2*fdd*s - 51*D1**2*f**2*fdd - 612*D1**2*f*fd**2*r**2 - 612*D1**2*f*fd**2*r*s + 612*D1**2*f*fd**2*r + 153*D1**2*f*fd**2*s - 102*D1**2*f*fd**2 + 1508*D1*Dd*b1*f**2*r**2 + 1508*D1*Dd*b1*f**2*r*s - 1508*D1*Dd*b1*f**2*r - 377*D1*Dd*b1*f**2*s + 377*D1*Dd*b1*f**2 - 9672*D1*Dd*b1*f*fd*r**2 - 9672*D1*Dd*b1*f*fd*r*s + 8060*D1*Dd*b1*f*fd*r + 1209*D1*Dd*b1*f*fd*s - 806*D1*Dd*b1*f*fd + 252*D1*Dd*f**3*r**2 + 252*D1*Dd*f**3*r*s - 252*D1*Dd*f**3*r - 63*D1*Dd*f**3*s + 63*D1*Dd*f**3 - 1632*D1*Dd*f**2*fd*r**2 - 1632*D1*Dd*f**2*fd*r*s + 1632*D1*Dd*f**2*fd*r + 408*D1*Dd*f**2*fd*s - 306*D1*Dd*f**2*fd - 1612*D1*Ddd*b1*f**2*r**2 - 1612*D1*Ddd*b1*f**2*r*s + 1612*D1*Ddd*b1*f**2*r + 403*D1*Ddd*b1*f**2*s - 403*D1*Ddd*b1*f**2 - 204*D1*Ddd*f**3*r**2 - 204*D1*Ddd*f**3*r*s + 204*D1*Ddd*f**3*r + 51*D1*Ddd*f**3*s - 51*D1*Ddd*f**3 + 13*D1*bd1*f*(D1*(29*f*(r - 1)*(r + s - 1) - 31*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 31*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 4836*Dd**2*b1*f**2*r**2 - 4836*Dd**2*b1*f**2*r*s + 4836*Dd**2*b1*f**2*r + 1209*Dd**2*b1*f**2*s - 806*Dd**2*b1*f**2 - 612*Dd**2*f**3*r**2 - 612*Dd**2*f**3*r*s + 612*Dd**2*f**3*r + 153*Dd**2*f**3*s - 102*Dd**2*f**3)/(9009*d**2*k1**2*k3**5) + D1**2*Pk1*Pkd3*k1**6*st**2*(2*C - 1)*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 66*D1**2*b1*f*fd*s + 33*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 51*D1**2*f**2*fd*r**2 + 102*D1**2*f**2*fd*r*s - 68*D1**2*f**2*fd*r + 51*D1**2*f**2*fd*s**2 - 68*D1**2*f**2*fd*s + 34*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 198*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2*s**2 - 198*D1*Dd*b1*f**2*s + 99*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 68*D1*Dd*f**3*r**2 + 136*D1*Dd*f**3*r*s - 102*D1*Dd*f**3*r + 68*D1*Dd*f**3*s**2 - 102*D1*Dd*f**3*s + 51*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3)/(154*d**2*k3**7) + 3*D1**2*Pk1*Pkd3*k1**6*(5*D1**2*K*b1**2*fd*r**2 + 10*D1**2*K*b1**2*fd*r*s + 5*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r**2 - 12*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 + 8*D1**2*K*b1*f*fd*r**2 + 16*D1**2*K*b1*f*fd*r*s - 8*D1**2*K*b1*f*fd*r + 8*D1**2*K*b1*f*fd*s**2 - 8*D1**2*K*b1*f*fd*s + 4*D1**2*K*b1*f*fd - 10*D1**2*K*b1*f*fdd*r**2 - 20*D1**2*K*b1*f*fdd*r*s + 10*D1**2*K*b1*f*fdd*r - 10*D1**2*K*b1*f*fdd*s**2 + 10*D1**2*K*b1*f*fdd*s - 5*D1**2*K*b1*f*fdd - 10*D1**2*K*b1*fd**2*r**2 - 20*D1**2*K*b1*fd**2*r*s + 10*D1**2*K*b1*fd**2*r - 10*D1**2*K*b1*fd**2*s**2 + 10*D1**2*K*b1*fd**2*s - 12*D1**2*K*bd1**2*f*(r + s - 1)**2 - 10*D1**2*b1*f*gd2*r**2 - 20*D1**2*b1*f*gd2*r*s + 20*D1**2*b1*f*gd2*r - 10*D1**2*b1*f*gd2*s**2 + 20*D1**2*b1*f*gd2*s - 10*D1**2*b1*f*gd2 + 12*D1**2*b1*f*gdd2*r**2 + 24*D1**2*b1*f*gdd2*r*s - 24*D1**2*b1*f*gdd2*r + 12*D1**2*b1*f*gdd2*s**2 - 24*D1**2*b1*f*gdd2*s + 12*D1**2*b1*f*gdd2 - 10*D1**2*b1*fd*g2*r**2 - 20*D1**2*b1*fd*g2*r*s - 10*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r**2 + 48*D1**2*b1*fd*gd2*r*s - 24*D1**2*b1*fd*gd2*r + 24*D1**2*b1*fd*gd2*s**2 - 24*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r**2 + 24*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(12*K*b1 + 5*K*f - 12*g2) - 8*D1**2*f**2*gd2*r**2 - 16*D1**2*f**2*gd2*r*s + 16*D1**2*f**2*gd2*r - 8*D1**2*f**2*gd2*s**2 + 16*D1**2*f**2*gd2*s - 8*D1**2*f**2*gd2 + 10*D1**2*f**2*gdd2*r**2 + 20*D1**2*f**2*gdd2*r*s - 20*D1**2*f**2*gdd2*r + 10*D1**2*f**2*gdd2*s**2 - 20*D1**2*f**2*gdd2*s + 10*D1**2*f**2*gdd2 - 16*D1**2*f*fd*g2*r**2 - 32*D1**2*f*fd*g2*r*s + 16*D1**2*f*fd*g2*r - 16*D1**2*f*fd*g2*s**2 + 16*D1**2*f*fd*g2*s - 8*D1**2*f*fd*g2 + 40*D1**2*f*fd*gd2*r**2 + 80*D1**2*f*fd*gd2*r*s - 60*D1**2*f*fd*gd2*r + 40*D1**2*f*fd*gd2*s**2 - 60*D1**2*f*fd*gd2*s + 20*D1**2*f*fd*gd2 + 20*D1**2*f*fdd*g2*r**2 + 40*D1**2*f*fdd*g2*r*s - 20*D1**2*f*fdd*g2*r + 20*D1**2*f*fdd*g2*s**2 - 20*D1**2*f*fdd*g2*s + 10*D1**2*f*fdd*g2 + 20*D1**2*fd**2*g2*r**2 + 40*D1**2*fd**2*g2*r*s - 20*D1**2*fd**2*g2*r + 20*D1**2*fd**2*g2*s**2 - 20*D1**2*fd**2*g2*s + 20*D1*Dd*K*b1**2*f*r**2 + 40*D1*Dd*K*b1**2*f*r*s - 30*D1*Dd*K*b1**2*f*r + 20*D1*Dd*K*b1**2*f*s**2 - 30*D1*Dd*K*b1**2*f*s + 15*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 96*D1*Dd*K*b1**2*fd*r*s + 36*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 36*D1*Dd*K*b1**2*fd*s + 16*D1*Dd*K*b1*f**2*r**2 + 32*D1*Dd*K*b1*f**2*r*s - 24*D1*Dd*K*b1*f**2*r + 16*D1*Dd*K*b1*f**2*s**2 - 24*D1*Dd*K*b1*f**2*s + 12*D1*Dd*K*b1*f**2 - 80*D1*Dd*K*b1*f*fd*r**2 - 160*D1*Dd*K*b1*f*fd*r*s + 100*D1*Dd*K*b1*f*fd*r - 80*D1*Dd*K*b1*f*fd*s**2 + 100*D1*Dd*K*b1*f*fd*s - 30*D1*Dd*K*b1*f*fd - 40*D1*Dd*b1*f*g2*r**2 - 80*D1*Dd*b1*f*g2*r*s + 60*D1*Dd*b1*f*g2*r - 40*D1*Dd*b1*f*g2*s**2 + 60*D1*Dd*b1*f*g2*s - 30*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 192*D1*Dd*b1*f*gd2*r*s - 168*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 168*D1*Dd*b1*f*gd2*s + 72*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 192*D1*Dd*b1*fd*g2*r*s - 72*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 72*D1*Dd*b1*fd*g2*s - 32*D1*Dd*f**2*g2*r**2 - 64*D1*Dd*f**2*g2*r*s + 48*D1*Dd*f**2*g2*r - 32*D1*Dd*f**2*g2*s**2 + 48*D1*Dd*f**2*g2*s - 24*D1*Dd*f**2*g2 + 80*D1*Dd*f**2*gd2*r**2 + 160*D1*Dd*f**2*gd2*r*s - 140*D1*Dd*f**2*gd2*r + 80*D1*Dd*f**2*gd2*s**2 - 140*D1*Dd*f**2*gd2*s + 60*D1*Dd*f**2*gd2 + 160*D1*Dd*f*fd*g2*r**2 + 320*D1*Dd*f*fd*g2*r*s - 200*D1*Dd*f*fd*g2*r + 160*D1*Dd*f*fd*g2*s**2 - 200*D1*Dd*f*fd*g2*s + 60*D1*Dd*f*fd*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 48*D1*Ddd*K*b1**2*f*r*s + 36*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 36*D1*Ddd*K*b1**2*f*s - 18*D1*Ddd*K*b1**2*f - 20*D1*Ddd*K*b1*f**2*r**2 - 40*D1*Ddd*K*b1*f**2*r*s + 30*D1*Ddd*K*b1*f**2*r - 20*D1*Ddd*K*b1*f**2*s**2 + 30*D1*Ddd*K*b1*f**2*s - 15*D1*Ddd*K*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 96*D1*Ddd*b1*f*g2*r*s - 72*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 72*D1*Ddd*b1*f*g2*s + 36*D1*Ddd*b1*f*g2 + 40*D1*Ddd*f**2*g2*r**2 + 80*D1*Ddd*f**2*g2*r*s - 60*D1*Ddd*f**2*g2*r + 40*D1*Ddd*f**2*g2*s**2 - 60*D1*Ddd*f**2*g2*s + 30*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(2*K*f**2*(r + s - 1) + f*(5*K*(b1*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 5*g2*(r + s - 1) + 12*gd2*(r + s - 1)) + 12*fd*(r + s)*(-K*b1 + g2)) + Dd*f*(4*r + 4*s - 3)*(-12*K*b1 - 5*K*f + 12*g2))*(r + s - 1) - 72*Dd**2*K*b1**2*f*r**2 - 144*Dd**2*K*b1**2*f*r*s + 108*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 108*Dd**2*K*b1**2*f*s - 36*Dd**2*K*b1**2*f - 60*Dd**2*K*b1*f**2*r**2 - 120*Dd**2*K*b1*f**2*r*s + 90*Dd**2*K*b1*f**2*r - 60*Dd**2*K*b1*f**2*s**2 + 90*Dd**2*K*b1*f**2*s - 30*Dd**2*K*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 288*Dd**2*b1*f*g2*r*s - 216*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 216*Dd**2*b1*f*g2*s + 72*Dd**2*b1*f*g2 + 120*Dd**2*f**2*g2*r**2 + 240*Dd**2*f**2*g2*r*s - 180*Dd**2*f**2*g2*r + 120*Dd**2*f**2*g2*s**2 - 180*Dd**2*f**2*g2*s + 60*Dd**2*f**2*g2)/(7*d**2*k3**7) + D1**2*Pk1*Pkd3*k1**4*k2**2*st**2*(-2574*C*D1**2*f**2*fd*r**2 - 5148*C*D1**2*f**2*fd*r*s + 3432*C*D1**2*f**2*fd*r - 2574*C*D1**2*f**2*fd*s**2 + 3432*C*D1**2*f**2*fd*s - 1716*C*D1**2*f**2*fd - 3432*C*D1*Dd*f**3*r**2 - 6864*C*D1*Dd*f**3*r*s + 5148*C*D1*Dd*f**3*r - 3432*C*D1*Dd*f**3*s**2 + 5148*C*D1*Dd*f**3*s - 2574*C*D1*Dd*f**3 - 2574*D1**2*K*bdd1*f**2*r**2 - 5148*D1**2*K*bdd1*f**2*r*s + 5148*D1**2*K*bdd1*f**2*r - 2574*D1**2*K*bdd1*f**2*s**2 + 5148*D1**2*K*bdd1*f**2*s - 2574*D1**2*K*bdd1*f**2 + 858*D1**2*bd1**2*f*(-6*K + 5*f)*(r + s - 1)**2 + 1300*D1**2*bdd1*f**3*r**2 + 2600*D1**2*bdd1*f**3*r*s - 2600*D1**2*bdd1*f**3*r + 1300*D1**2*bdd1*f**3*s**2 - 2600*D1**2*bdd1*f**3*s + 1300*D1**2*bdd1*f**3 + 5148*D1**2*bdd1*f*g2*r**2 + 10296*D1**2*bdd1*f*g2*r*s - 10296*D1**2*bdd1*f*g2*r + 5148*D1**2*bdd1*f*g2*s**2 - 10296*D1**2*bdd1*f*g2*s + 5148*D1**2*bdd1*f*g2 + 660*D1**2*f**3*fd*r**2 + 1320*D1**2*f**3*fd*r*s - 990*D1**2*f**3*fd*r + 660*D1**2*f**3*fd*s**2 - 990*D1**2*f**3*fd*s + 495*D1**2*f**3*fd - 980*D1**2*f**3*fdd*r**2 - 1960*D1**2*f**3*fdd*r*s + 1470*D1**2*f**3*fdd*r - 980*D1**2*f**3*fdd*s**2 + 1470*D1**2*f**3*fdd*s - 735*D1**2*f**3*fdd - 2940*D1**2*f**2*fd**2*r**2 - 5880*D1**2*f**2*fd**2*r*s + 4410*D1**2*f**2*fd**2*r - 2940*D1**2*f**2*fd**2*s**2 + 4410*D1**2*f**2*fd**2*s - 1470*D1**2*f**2*fd**2 + 1287*D1**2*f**2*fd*r**2 + 2574*D1**2*f**2*fd*r*s - 1716*D1**2*f**2*fd*r + 1287*D1**2*f**2*fd*s**2 - 1716*D1**2*f**2*fd*s + 858*D1**2*f**2*fd - 9438*D1**2*f**2*gd2*r**2 - 18876*D1**2*f**2*gd2*r*s + 18876*D1**2*f**2*gd2*r - 9438*D1**2*f**2*gd2*s**2 + 18876*D1**2*f**2*gd2*s - 9438*D1**2*f**2*gd2 + 5148*D1**2*f**2*gdd2*r**2 + 10296*D1**2*f**2*gdd2*r*s - 10296*D1**2*f**2*gdd2*r + 5148*D1**2*f**2*gdd2*s**2 - 10296*D1**2*f**2*gdd2*s + 5148*D1**2*f**2*gdd2 - 18876*D1**2*f*fd*g2*r**2 - 37752*D1**2*f*fd*g2*r*s + 18876*D1**2*f*fd*g2*r - 18876*D1**2*f*fd*g2*s**2 + 18876*D1**2*f*fd*g2*s - 9438*D1**2*f*fd*g2 + 20592*D1**2*f*fd*gd2*r**2 + 41184*D1**2*f*fd*gd2*r*s - 30888*D1**2*f*fd*gd2*r + 20592*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 10296*D1**2*f*fd*gd2 + 10296*D1**2*f*fdd*g2*r**2 + 20592*D1**2*f*fdd*g2*r*s - 10296*D1**2*f*fdd*g2*r + 10296*D1**2*f*fdd*g2*s**2 - 10296*D1**2*f*fdd*g2*s + 5148*D1**2*f*fdd*g2 + 10296*D1**2*fd**2*g2*r**2 + 20592*D1**2*fd**2*g2*r*s - 10296*D1**2*fd**2*g2*r + 10296*D1**2*fd**2*g2*s**2 - 10296*D1**2*fd**2*g2*s + 660*D1*Dd*f**4*r**2 + 1320*D1*Dd*f**4*r*s - 990*D1*Dd*f**4*r + 660*D1*Dd*f**4*s**2 - 990*D1*Dd*f**4*s + 495*D1*Dd*f**4 - 7840*D1*Dd*f**3*fd*r**2 - 15680*D1*Dd*f**3*fd*r*s + 11760*D1*Dd*f**3*fd*r - 7840*D1*Dd*f**3*fd*s**2 + 11760*D1*Dd*f**3*fd*s - 4410*D1*Dd*f**3*fd + 1716*D1*Dd*f**3*r**2 + 3432*D1*Dd*f**3*r*s - 2574*D1*Dd*f**3*r + 1716*D1*Dd*f**3*s**2 - 2574*D1*Dd*f**3*s + 1287*D1*Dd*f**3 - 37752*D1*Dd*f**2*g2*r**2 - 75504*D1*Dd*f**2*g2*r*s + 56628*D1*Dd*f**2*g2*r - 37752*D1*Dd*f**2*g2*s**2 + 56628*D1*Dd*f**2*g2*s - 28314*D1*Dd*f**2*g2 + 41184*D1*Dd*f**2*gd2*r**2 + 82368*D1*Dd*f**2*gd2*r*s - 72072*D1*Dd*f**2*gd2*r + 41184*D1*Dd*f**2*gd2*s**2 - 72072*D1*Dd*f**2*gd2*s + 30888*D1*Dd*f**2*gd2 + 82368*D1*Dd*f*fd*g2*r**2 + 164736*D1*Dd*f*fd*g2*r*s - 102960*D1*Dd*f*fd*g2*r + 82368*D1*Dd*f*fd*g2*s**2 - 102960*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 980*D1*Ddd*f**4*r**2 - 1960*D1*Ddd*f**4*r*s + 1470*D1*Ddd*f**4*r - 980*D1*Ddd*f**4*s**2 + 1470*D1*Ddd*f**4*s - 735*D1*Ddd*f**4 + 20592*D1*Ddd*f**2*g2*r**2 + 41184*D1*Ddd*f**2*g2*r*s - 30888*D1*Ddd*f**2*g2*r + 20592*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 15444*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(134*f**3*(r + s - 1) + f**2*(66*C*(r + s - 1) - 363*K*r - 363*K*s + 363*K + 462*b1*(r + s - 1) - 600*fd*r - 600*fd*s + 400*fd - 33*r - 33*s + 33) - 66*f*(19*K*b1*(r + s - 1) - 6*K*fd*(2*r + 2*s - 1) + 10*b1*fd*(2*r + 2*s - 1) - 19*g2*(r + s - 1) + 12*gd2*(r + s - 1)) - 792*fd*(r + s)*(-K*b1 + g2)) - 4*Dd*f*(4*r + 4*s - 3)*(-99*K*f + 33*b1*(-6*K + 5*f) + 50*f**2 + 198*g2))*(r + s - 1) - 2940*Dd**2*f**4*r**2 - 5880*Dd**2*f**4*r*s + 4410*Dd**2*f**4*r - 2940*Dd**2*f**4*s**2 + 4410*Dd**2*f**4*s - 1470*Dd**2*f**4 + 61776*Dd**2*f**2*g2*r**2 + 123552*Dd**2*f**2*g2*r*s - 92664*Dd**2*f**2*g2*r + 61776*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 30888*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(f*(7*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(19*K*fd*(r + s) - 6*K*fdd*(r + s) + 10*fd**2*(r + s - 1))) + D1*(Dd*(12*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 7*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(19*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - Ddd*f*(-6*K + 5*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-6*K + 5*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(66*D1**2*bdd1*f*(-6*K + 5*f)*(r + s - 1)**2 + D1**2*(-2*f**2*(67*fd - 50*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-198*K*fdd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 200*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 33*fd*(2*C - 11*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 1254*gd2*(r + s - 1)**2 + 396*gdd2*(r + s - 1)**2) + (-66*r - 66*s)*(6*K*fd**2*(r + s - 1) + 19*fd*g2*(r + s) - 12*fd*gd2*(r + s - 1) - 6*fdd*g2*(r + s))) + D1*(Dd*(-134*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-66*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 200*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + (363*K + 33)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 66*f*(19*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*fd*(-2*r - 2*s + 1) + 2*gd2*(r + s - 1))*(-24*r - 24*s + 18)) + 792*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 2*Ddd*f*(-99*K*f + 50*f**2 + 198*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f*(-99*K*f + 50*f**2 + 198*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(2002*d**2*k3**7) + D1**2*Pk1*Pkd3*k1**4*st**2*(165*b1**2*(2*C - 1)*(D1**2*(9*fd - fdd)*(r + s - 1)**2 + D1*(Dd*(9*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-28*C*D1**2*f*fd*r**2 - 120*C*D1**2*f*fd*r*s + 40*C*D1**2*f*fd*r - 92*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s - 36*C*D1**2*f*fd + 36*C*D1**2*f*fdd*r**2 + 120*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 84*C*D1**2*f*fdd*s**2 - 64*C*D1**2*f*fdd*s + 32*C*D1**2*f*fdd + 36*C*D1**2*fd**2*r**2 + 120*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 84*C*D1**2*fd**2*s**2 - 64*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 56*C*D1*Dd*f**2*r**2 - 240*C*D1*Dd*f**2*r*s + 148*C*D1*Dd*f**2*r - 184*C*D1*Dd*f**2*s**2 + 244*C*D1*Dd*f**2*s - 106*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r**2 + 960*C*D1*Dd*f*fd*r*s - 472*C*D1*Dd*f*fd*r + 672*C*D1*Dd*f*fd*s**2 - 712*C*D1*Dd*f*fd*s + 168*C*D1*Dd*f*fd + 72*C*D1*Ddd*f**2*r**2 + 240*C*D1*Ddd*f**2*r*s - 156*C*D1*Ddd*f**2*r + 168*C*D1*Ddd*f**2*s**2 - 228*C*D1*Ddd*f**2*s + 102*C*D1*Ddd*f**2 + 216*C*Dd**2*f**2*r**2 + 720*C*Dd**2*f**2*r*s - 468*C*Dd**2*f**2*r + 504*C*Dd**2*f**2*s**2 - 684*C*Dd**2*f**2*s + 204*C*Dd**2*f**2 - 5*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 14*D1**2*f*fd*r**2 + 64*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 50*D1**2*f*fd*s**2 - 40*D1**2*f*fd*s + 20*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 64*D1**2*f*fdd*r*s + 22*D1**2*f*fdd*r - 46*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd - 18*D1**2*fd**2*r**2 - 64*D1**2*fd**2*r*s + 22*D1**2*fd**2*r - 46*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 10*D1**2*fd**2 + 28*D1*Dd*f**2*r**2 + 128*D1*Dd*f**2*r*s - 78*D1*Dd*f**2*r + 100*D1*Dd*f**2*s**2 - 132*D1*Dd*f**2*s + 57*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 512*D1*Dd*f*fd*r*s + 252*D1*Dd*f*fd*r - 368*D1*Dd*f*fd*s**2 + 392*D1*Dd*f*fd*s - 94*D1*Dd*f*fd - 36*D1*Ddd*f**2*r**2 - 128*D1*Ddd*f**2*r*s + 82*D1*Ddd*f**2*r - 92*D1*Ddd*f**2*s**2 + 124*D1*Ddd*f**2*s - 55*D1*Ddd*f**2 + 5*D1*bd1*(2*C - 1)*(D1*(9*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 108*Dd**2*f**2*r**2 - 384*Dd**2*f**2*r*s + 246*Dd**2*f**2*r - 276*Dd**2*f**2*s**2 + 372*Dd**2*f**2*s - 110*Dd**2*f**2) + f*(-330*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bdd1*f*(2*C*(9*r**2 + r*(30*s - 28) + 21*s**2 - 40*s + 14) - 9*r**2 - 4*r*(8*s - 7) - 23*s**2 + 42*s - 14) - 2*D1**2*(f*(fd*(4*C*(237*r**2 + 822*r*s - 432*r + 585*s**2 - 664*s + 274) - 474*r**2 - 1695*r*s + 881*r - 1221*s**2 + 1379*s - 565) + fdd*(-2*C*(633*r**2 + 6*r*(302*s - 171) + 1179*s**2 - 1390*s + 604) + 633*r**2 + 1887*r*s - 1051*r + 1254*s**2 - 1465*s + 629)) + fd**2*(-4*C*(633*r**2 + 6*r*(302*s - 171) + 1179*s**2 - 1390*s + 302) + 1266*r**2 + 3774*r*s - 2102*r + 2508*s**2 - 2930*s + 629)) - 33*D1*bd1*(D1*(f*(2*C*(7*r**2 + 6*r*(5*s - 4) + 23*s**2 - 40*s + 12) - 7*r**2 - 32*r*s + 24*r - 25*s**2 + 42*s - 12) - 2*fd*(4*C*(9*r**2 + 30*r*s - 19*r + 21*s**2 - 28*s + 10) - 18*r**2 - 64*r*s + 39*r - 46*s**2 + 60*s - 21)) - 2*Dd*f*(2*C*(36*r**2 + 120*r*s - 95*r + 84*s**2 - 137*s + 54) - 36*r**2 - 128*r*s + 97*r - 92*s**2 + 146*s - 56)) - 2*D1*f*(Dd*(f*(4*C*(316*r**2 + 1096*r*s - 706*r + 780*s**2 - 1054*s + 469) - 632*r**2 - 2260*r*s + 1446*r - 1628*s**2 + 2193*s - 972) + fd*(-4*C*(2532*r**2 + 7248*r*s - 4497*r + 4716*s**2 - 6044*s + 1903) + 5064*r**2 + 15096*r*s - 9244*r + 10032*s**2 - 12763*s + 3981)) + Ddd*f*(-2*C*(844*r**2 + 2*r*(1208*s - 815) + 1572*s**2 - 2176*s + 997) + 844*r**2 + 4*r*(629*s - 420) + 1672*s**2 - 2301*s + 1047)) - 2*Dd**2*f**2*(-4*C*(1266*r**2 + 3*r*(1208*s - 815) + 2358*s**2 - 3264*s + 997) + 2532*r**2 + 12*r*(629*s - 420) + 5016*s**2 - 6903*s + 2094)))/(1386*d**2*k3**5) + D1**2*Pk1*Pkd3*k1**4*(118*D1**2*K*bd1**2*f*r**2 + 236*D1**2*K*bd1**2*f*r*s - 296*D1**2*K*bd1**2*f*r + 118*D1**2*K*bd1**2*f*s**2 - 296*D1**2*K*bd1**2*f*s + 178*D1**2*K*bd1**2*f - 62*D1**2*K*bd1*f**2*r**2 - 116*D1**2*K*bd1*f**2*r*s + 116*D1**2*K*bd1*f**2*r - 54*D1**2*K*bd1*f**2*s**2 + 108*D1**2*K*bd1*f**2*s - 54*D1**2*K*bd1*f**2 + 316*D1**2*K*bd1*f*fd*r**2 + 616*D1**2*K*bd1*f*fd*r*s - 466*D1**2*K*bd1*f*fd*r + 300*D1**2*K*bd1*f*fd*s**2 - 454*D1**2*K*bd1*f*fd*s + 154*D1**2*K*bd1*f*fd + 79*D1**2*K*bdd1*f**2*r**2 + 154*D1**2*K*bdd1*f**2*r*s - 154*D1**2*K*bdd1*f**2*r + 75*D1**2*K*bdd1*f**2*s**2 - 150*D1**2*K*bdd1*f**2*s + 75*D1**2*K*bdd1*f**2 - 24*D1**2*bd1**2*f**2*r*s + 12*D1**2*bd1**2*f**2*r - 24*D1**2*bd1**2*f**2*s**2 + 36*D1**2*bd1**2*f**2*s - 12*D1**2*bd1**2*f**2 - 24*D1**2*bd1**2*f*r*s + 12*D1**2*bd1**2*f*r - 24*D1**2*bd1**2*f*s**2 + 36*D1**2*bd1**2*f*s - 12*D1**2*bd1**2*f + 140*D1**2*bd1**2*g2*r**2 + 280*D1**2*bd1**2*g2*r*s - 140*D1**2*bd1**2*g2*r + 140*D1**2*bd1**2*g2*s**2 - 140*D1**2*bd1**2*g2*s + 60*D1**2*bd1*bd2*f*r**2 + 120*D1**2*bd1*bd2*f*r*s - 120*D1**2*bd1*bd2*f*r + 60*D1**2*bd1*bd2*f*s**2 - 120*D1**2*bd1*bd2*f*s + 60*D1**2*bd1*bd2*f + 10*D1**2*bd1*f**3*r*s - 10*D1**2*bd1*f**3*r + 10*D1**2*bd1*f**3*s**2 - 20*D1**2*bd1*f**3*s + 10*D1**2*bd1*f**3 - 60*D1**2*bd1*f**2*fd*r*s + 40*D1**2*bd1*f**2*fd*r - 60*D1**2*bd1*f**2*fd*s**2 + 90*D1**2*bd1*f**2*fd*s - 30*D1**2*bd1*f**2*fd + 8*D1**2*bd1*f**2*r*s - 8*D1**2*bd1*f**2*r + 8*D1**2*bd1*f**2*s**2 - 16*D1**2*bd1*f**2*s + 8*D1**2*bd1*f**2 - 40*D1**2*bd1*f*fd*r*s + 20*D1**2*bd1*f*fd*r - 40*D1**2*bd1*f*fd*s**2 + 50*D1**2*bd1*f*fd*s - 10*D1**2*bd1*f*fd + 82*D1**2*bd1*f*g2*r**2 + 164*D1**2*bd1*f*g2*r*s - 264*D1**2*bd1*f*g2*r + 82*D1**2*bd1*f*g2*s**2 - 264*D1**2*bd1*f*g2*s + 132*D1**2*bd1*f*g2 - 236*D1**2*bd1*f*gd2*r**2 - 472*D1**2*bd1*f*gd2*r*s + 592*D1**2*bd1*f*gd2*r - 236*D1**2*bd1*f*gd2*s**2 + 592*D1**2*bd1*f*gd2*s - 356*D1**2*bd1*f*gd2 - 236*D1**2*bd1*fd*g2*r**2 - 472*D1**2*bd1*fd*g2*r*s + 236*D1**2*bd1*fd*g2*r - 236*D1**2*bd1*fd*g2*s**2 + 236*D1**2*bd1*fd*g2*s - 20*D1**2*bd2*f**2*r**2 - 40*D1**2*bd2*f**2*r*s + 40*D1**2*bd2*f**2*r - 20*D1**2*bd2*f**2*s**2 + 40*D1**2*bd2*f**2*s - 20*D1**2*bd2*f**2 + 100*D1**2*bd2*f*fd*r**2 + 200*D1**2*bd2*f*fd*r*s - 150*D1**2*bd2*f*fd*r + 100*D1**2*bd2*f*fd*s**2 - 150*D1**2*bd2*f*fd*s + 50*D1**2*bd2*f*fd - 10*D1**2*bdd1*f**3*r*s + 10*D1**2*bdd1*f**3*r - 10*D1**2*bdd1*f**3*s**2 + 20*D1**2*bdd1*f**3*s - 10*D1**2*bdd1*f**3 - 10*D1**2*bdd1*f**2*r*s + 10*D1**2*bdd1*f**2*r - 10*D1**2*bdd1*f**2*s**2 + 20*D1**2*bdd1*f**2*s - 10*D1**2*bdd1*f**2 - 118*D1**2*bdd1*f*g2*r**2 - 236*D1**2*bdd1*f*g2*r*s + 356*D1**2*bdd1*f*g2*r - 118*D1**2*bdd1*f*g2*s**2 + 356*D1**2*bdd1*f*g2*s - 178*D1**2*bdd1*f*g2 + 25*D1**2*bdd2*f**2*r**2 + 50*D1**2*bdd2*f**2*r*s - 50*D1**2*bdd2*f**2*r + 25*D1**2*bdd2*f**2*s**2 - 50*D1**2*bdd2*f**2*s + 25*D1**2*bdd2*f**2 + 124*D1**2*f**2*gd2*r**2 + 232*D1**2*f**2*gd2*r*s - 232*D1**2*f**2*gd2*r + 108*D1**2*f**2*gd2*s**2 - 216*D1**2*f**2*gd2*s + 108*D1**2*f**2*gd2 - 158*D1**2*f**2*gdd2*r**2 - 308*D1**2*f**2*gdd2*r*s + 308*D1**2*f**2*gdd2*r - 150*D1**2*f**2*gdd2*s**2 + 300*D1**2*f**2*gdd2*s - 150*D1**2*f**2*gdd2 + 248*D1**2*f*fd*g2*r**2 + 464*D1**2*f*fd*g2*r*s - 248*D1**2*f*fd*g2*r + 216*D1**2*f*fd*g2*s**2 - 232*D1**2*f*fd*g2*s + 124*D1**2*f*fd*g2 - 632*D1**2*f*fd*gd2*r**2 - 1232*D1**2*f*fd*gd2*r*s + 932*D1**2*f*fd*gd2*r - 600*D1**2*f*fd*gd2*s**2 + 908*D1**2*f*fd*gd2*s - 308*D1**2*f*fd*gd2 - 316*D1**2*f*fdd*g2*r**2 - 616*D1**2*f*fdd*g2*r*s + 316*D1**2*f*fdd*g2*r - 300*D1**2*f*fdd*g2*s**2 + 308*D1**2*f*fdd*g2*s - 158*D1**2*f*fdd*g2 - 316*D1**2*fd**2*g2*r**2 - 616*D1**2*fd**2*g2*r*s + 316*D1**2*fd**2*g2*r - 300*D1**2*fd**2*g2*s**2 + 308*D1**2*fd**2*g2*s + 632*D1*Dd*K*bd1*f**2*r**2 + 1232*D1*Dd*K*bd1*f**2*r*s - 1082*D1*Dd*K*bd1*f**2*r + 600*D1*Dd*K*bd1*f**2*s**2 - 1054*D1*Dd*K*bd1*f**2*s + 454*D1*Dd*K*bd1*f**2 - 80*D1*Dd*bd1*f**3*r*s + 60*D1*Dd*bd1*f**3*r - 80*D1*Dd*bd1*f**3*s**2 + 130*D1*Dd*bd1*f**3*s - 50*D1*Dd*bd1*f**3 - 80*D1*Dd*bd1*f**2*r*s + 60*D1*Dd*bd1*f**2*r - 80*D1*Dd*bd1*f**2*s**2 + 130*D1*Dd*bd1*f**2*s - 50*D1*Dd*bd1*f**2 - 944*D1*Dd*bd1*f*g2*r**2 - 1888*D1*Dd*bd1*f*g2*r*s + 2132*D1*Dd*bd1*f*g2*r - 944*D1*Dd*bd1*f*g2*s**2 + 2132*D1*Dd*bd1*f*g2*s - 1068*D1*Dd*bd1*f*g2 + 200*D1*Dd*bd2*f**2*r**2 + 400*D1*Dd*bd2*f**2*r*s - 350*D1*Dd*bd2*f**2*r + 200*D1*Dd*bd2*f**2*s**2 - 350*D1*Dd*bd2*f**2*s + 150*D1*Dd*bd2*f**2 + 496*D1*Dd*f**2*g2*r**2 + 928*D1*Dd*f**2*g2*r*s - 712*D1*Dd*f**2*g2*r + 432*D1*Dd*f**2*g2*s**2 - 664*D1*Dd*f**2*g2*s + 340*D1*Dd*f**2*g2 - 1264*D1*Dd*f**2*gd2*r**2 - 2464*D1*Dd*f**2*gd2*r*s + 2164*D1*Dd*f**2*gd2*r - 1200*D1*Dd*f**2*gd2*s**2 + 2108*D1*Dd*f**2*gd2*s - 908*D1*Dd*f**2*gd2 - 2528*D1*Dd*f*fd*g2*r**2 - 4928*D1*Dd*f*fd*g2*r*s + 3128*D1*Dd*f*fd*g2*r - 2400*D1*Dd*f*fd*g2*s**2 + 3048*D1*Dd*f*fd*g2*s - 932*D1*Dd*f*fd*g2 - 632*D1*Ddd*f**2*g2*r**2 - 1232*D1*Ddd*f**2*g2*r*s + 932*D1*Ddd*f**2*g2*r - 600*D1*Ddd*f**2*g2*s**2 + 908*D1*Ddd*f**2*g2*s - 458*D1*Ddd*f**2*g2 - 1896*Dd**2*f**2*g2*r**2 - 3696*Dd**2*f**2*g2*r*s + 2796*Dd**2*f**2*g2*r - 1800*Dd**2*f**2*g2*s**2 + 2724*Dd**2*f**2*g2*s - 916*Dd**2*f**2*g2 + 35*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(210*K*bd1*r**2 + 420*K*bd1*r*s - 280*K*bd1*r + 210*K*bd1*s**2 - 280*K*bd1*s + 140*K*bd1 - 105*K*bdd1*r**2 - 210*K*bdd1*r*s + 140*K*bdd1*r - 105*K*bdd1*s**2 + 140*K*bdd1*s - 70*K*bdd1 - 41*K*fd*r**2 - 82*K*fd*r*s - 50*K*fd*r - 41*K*fd*s**2 - 50*K*fd*s + 25*K*fd + 59*K*fdd*r**2 + 118*K*fdd*r*s + 60*K*fdd*r + 59*K*fdd*s**2 + 60*K*fdd*s - 30*K*fdd + 12*f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 24*fd**2*r*s + 12*fd**2*r - 24*fd**2*s**2 + 24*fd**2*s + 10*fd*r*s + 10*fd*s**2 - 12*fdd*r*s - 12*fdd*s**2 - 140*gd2*(r + s - 1)**2 + 70*gdd2*r**2 + 140*gdd2*r*s - 140*gdd2*r + 70*gdd2*s**2 - 140*gdd2*s + 70*gdd2) + D1*(Dd*(-840*K*bd1*r**2 - 1680*K*bd1*r*s + 1190*K*bd1*r - 840*K*bd1*s**2 + 1190*K*bd1*s - 420*K*bd1 + 472*K*fd*r**2 + 944*K*fd*r*s - 114*K*fd*r + 472*K*fd*s**2 - 114*K*fd*s - 180*K*fd + 12*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - f*(41*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 12*fd*(2*s - 1)*(8*r + 8*s - 5) - 40*r*s + 20*r - 40*s**2 + 50*s - 20) - 96*fd*r*s + 24*fd*r - 96*fd*s**2 + 60*fd*s - 140*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 140*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*(-12*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(59*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 48*r*s + 24*r - 48*s**2 + 60*s - 24) + 70*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) - 6*Dd**2*(2*f**2*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4) + f*(-59*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 24*r*s - 12*r + 24*s**2 - 30*s + 8) - 70*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + b1*(-70*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 118*D1**2*K*bdd1*f*r**2 + 236*D1**2*K*bdd1*f*r*s - 296*D1**2*K*bdd1*f*r + 118*D1**2*K*bdd1*f*s**2 - 296*D1**2*K*bdd1*f*s + 148*D1**2*K*bdd1*f - 124*D1**2*K*f*fd*r**2 - 232*D1**2*K*f*fd*r*s + 124*D1**2*K*f*fd*r - 108*D1**2*K*f*fd*s**2 + 116*D1**2*K*f*fd*s - 62*D1**2*K*f*fd + 158*D1**2*K*f*fdd*r**2 + 308*D1**2*K*f*fdd*r*s - 158*D1**2*K*f*fdd*r + 150*D1**2*K*f*fdd*s**2 - 154*D1**2*K*f*fdd*s + 79*D1**2*K*f*fdd + 158*D1**2*K*fd**2*r**2 + 308*D1**2*K*fd**2*r*s - 158*D1**2*K*fd**2*r + 150*D1**2*K*fd**2*s**2 - 154*D1**2*K*fd**2*s - 25*D1**2*b2*fd*r**2 - 50*D1**2*b2*fd*r*s - 25*D1**2*b2*fd*s**2 + 30*D1**2*b2*fdd*r**2 + 60*D1**2*b2*fdd*r*s + 30*D1**2*b2*fdd*s**2 - 24*D1**2*bdd1*f**2*r*s + 12*D1**2*bdd1*f**2*r - 24*D1**2*bdd1*f**2*s**2 + 36*D1**2*bdd1*f**2*s - 12*D1**2*bdd1*f**2 - 24*D1**2*bdd1*f*r*s + 12*D1**2*bdd1*f*r - 24*D1**2*bdd1*f*s**2 + 36*D1**2*bdd1*f*s - 12*D1**2*bdd1*f + 140*D1**2*bdd1*g2*r**2 + 280*D1**2*bdd1*g2*r*s - 140*D1**2*bdd1*g2*r + 140*D1**2*bdd1*g2*s**2 - 140*D1**2*bdd1*g2*s + 70*D1**2*bdd1*g2 + 30*D1**2*bdd2*f*r**2 + 60*D1**2*bdd2*f*r*s - 60*D1**2*bdd2*f*r + 30*D1**2*bdd2*f*s**2 - 60*D1**2*bdd2*f*s + 30*D1**2*bdd2*f + 30*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 30*D1**2*f**2*fd*s + 10*D1**2*f**2*fd - 30*D1**2*f**2*fdd*r*s + 10*D1**2*f**2*fdd*r - 30*D1**2*f**2*fdd*s**2 + 30*D1**2*f**2*fdd*s - 10*D1**2*f**2*fdd - 60*D1**2*f*fd**2*r*s + 20*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s**2 + 60*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 16*D1**2*f*fd*r*s + 16*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s - 20*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s + 82*D1**2*f*gd2*r**2 + 164*D1**2*f*gd2*r*s - 164*D1**2*f*gd2*r + 82*D1**2*f*gd2*s**2 - 164*D1**2*f*gd2*s + 82*D1**2*f*gd2 - 118*D1**2*f*gdd2*r**2 - 236*D1**2*f*gdd2*r*s + 236*D1**2*f*gdd2*r - 118*D1**2*f*gdd2*s**2 + 236*D1**2*f*gdd2*s - 118*D1**2*f*gdd2 - 20*D1**2*fd**2*r*s - 20*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 82*D1**2*fd*g2*r**2 + 164*D1**2*fd*g2*r*s + 100*D1**2*fd*g2*r + 82*D1**2*fd*g2*s**2 + 100*D1**2*fd*g2*s - 50*D1**2*fd*g2 - 236*D1**2*fd*gd2*r**2 - 472*D1**2*fd*gd2*r*s + 116*D1**2*fd*gd2*r - 236*D1**2*fd*gd2*s**2 + 116*D1**2*fd*gd2*s + 120*D1**2*fd*gd2 - 118*D1**2*fdd*g2*r**2 - 236*D1**2*fdd*g2*r*s - 120*D1**2*fdd*g2*r - 118*D1**2*fdd*g2*s**2 - 120*D1**2*fdd*g2*s + 60*D1**2*fdd*g2 - 248*D1*Dd*K*f**2*r**2 - 464*D1*Dd*K*f**2*r*s + 356*D1*Dd*K*f**2*r - 216*D1*Dd*K*f**2*s**2 + 332*D1*Dd*K*f**2*s - 170*D1*Dd*K*f**2 + 1264*D1*Dd*K*f*fd*r**2 + 2464*D1*Dd*K*f*fd*r*s - 1564*D1*Dd*K*f*fd*r + 1200*D1*Dd*K*f*fd*s**2 - 1524*D1*Dd*K*f*fd*s + 466*D1*Dd*K*f*fd - 100*D1*Dd*b2*f*r**2 - 200*D1*Dd*b2*f*r*s + 150*D1*Dd*b2*f*r - 100*D1*Dd*b2*f*s**2 + 150*D1*Dd*b2*f*s - 75*D1*Dd*b2*f + 240*D1*Dd*b2*fd*r**2 + 480*D1*Dd*b2*fd*r*s - 180*D1*Dd*b2*fd*r + 240*D1*Dd*b2*fd*s**2 - 180*D1*Dd*b2*fd*s + 40*D1*Dd*f**3*r*s - 20*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 50*D1*Dd*f**3*s + 20*D1*Dd*f**3 - 240*D1*Dd*f**2*fd*r*s + 100*D1*Dd*f**2*fd*r - 240*D1*Dd*f**2*fd*s**2 + 270*D1*Dd*f**2*fd*s - 70*D1*Dd*f**2*fd + 32*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r + 32*D1*Dd*f**2*s**2 - 40*D1*Dd*f**2*s + 16*D1*Dd*f**2 - 160*D1*Dd*f*fd*r*s + 40*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 140*D1*Dd*f*fd*s - 20*D1*Dd*f*fd + 328*D1*Dd*f*g2*r**2 + 656*D1*Dd*f*g2*r*s - 492*D1*Dd*f*g2*r + 328*D1*Dd*f*g2*s**2 - 492*D1*Dd*f*g2*s + 246*D1*Dd*f*g2 - 944*D1*Dd*f*gd2*r**2 - 1888*D1*Dd*f*gd2*r*s + 1652*D1*Dd*f*gd2*r - 944*D1*Dd*f*gd2*s**2 + 1652*D1*Dd*f*gd2*s - 708*D1*Dd*f*gd2 - 944*D1*Dd*fd*g2*r**2 - 1888*D1*Dd*fd*g2*r*s + 228*D1*Dd*fd*g2*r - 944*D1*Dd*fd*g2*s**2 + 228*D1*Dd*fd*g2*s + 360*D1*Dd*fd*g2 + 316*D1*Ddd*K*f**2*r**2 + 616*D1*Ddd*K*f**2*r*s - 466*D1*Ddd*K*f**2*r + 300*D1*Ddd*K*f**2*s**2 - 454*D1*Ddd*K*f**2*s + 229*D1*Ddd*K*f**2 + 120*D1*Ddd*b2*f*r**2 + 240*D1*Ddd*b2*f*r*s - 180*D1*Ddd*b2*f*r + 120*D1*Ddd*b2*f*s**2 - 180*D1*Ddd*b2*f*s + 90*D1*Ddd*b2*f - 40*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r - 40*D1*Ddd*f**3*s**2 + 50*D1*Ddd*f**3*s - 20*D1*Ddd*f**3 - 40*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 50*D1*Ddd*f**2*s - 20*D1*Ddd*f**2 - 472*D1*Ddd*f*g2*r**2 - 944*D1*Ddd*f*g2*r*s + 708*D1*Ddd*f*g2*r - 472*D1*Ddd*f*g2*s**2 + 708*D1*Ddd*f*g2*s - 354*D1*Ddd*f*g2 + D1*bd1*(D1*(12*f**2*(2*s - 1)*(r + s - 1) - f*(K*(82*r**2 + 164*r*s - 214*r + 82*s**2 - 214*s + 107) + 12*fd*(2*s - 1)*(4*r + 4*s - 3) + (2*s - 1)*(-10*r - 10*s + 10)) + 4*fd*(K*(59*r**2 + 2*r*(59*s - 22) + 59*s**2 - 44*s - 15) - 12*r*s + 3*r + 3*s*(3 - 4*s)) - 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(3*f**2*(2*s - 1)*(8*r + 8*s - 7) + f*(-K*(236*r**2 + 472*r*s - 473*r + 236*s**2 - 473*s + 222) + (6*s - 3)*(8*r + 8*s - 7)) - 35*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 5*D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 948*Dd**2*K*f**2*r**2 + 1848*Dd**2*K*f**2*r*s - 1398*Dd**2*K*f**2*r + 900*Dd**2*K*f**2*s**2 - 1362*Dd**2*K*f**2*s + 458*Dd**2*K*f**2 + 360*Dd**2*b2*f*r**2 + 720*Dd**2*b2*f*r*s - 540*Dd**2*b2*f*r + 360*Dd**2*b2*f*s**2 - 540*Dd**2*b2*f*s + 180*Dd**2*b2*f - 120*Dd**2*f**3*r*s + 60*Dd**2*f**3*r - 120*Dd**2*f**3*s**2 + 150*Dd**2*f**3*s - 40*Dd**2*f**3 - 120*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 150*Dd**2*f**2*s - 40*Dd**2*f**2 - 1416*Dd**2*f*g2*r**2 - 2832*Dd**2*f*g2*r*s + 2124*Dd**2*f*g2*r - 1416*Dd**2*f*g2*s**2 + 2124*Dd**2*f*g2*s - 708*Dd**2*f*g2) - 5*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 100*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2))/(21*d**2*k3**5) - D1**2*Pk1*Pkd3*k1**2*k2**4*st**6*(10*C - 5)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(154*d**2*k3**7) - 3*D1**2*Pk1*Pkd3*k1**2*k2**4*st**4*(-858*D1**2*K*bd1**2*f*(r + s - 1)**2 + D1**2*f*(858*bdd1*g2*(r + s - 1)**2 - f**2*(161*fd - 100*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 600*f*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*D1*bd1*(D1*(f**2*(-2*C + 2*b1 + 1)*(r + s - 1) - 4*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 4*fd*(r + s)*(-K*b1 + g2)) + 4*Dd*f*(-K*b1 + g2)*(4*r + 4*s - 3))*(r + s - 1) + D1*f**3*(Dd*(-161*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 200*fd*(4*r + 4*s - 3)**2) + 100*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 600*Dd**2*f**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 429*b1**2*(D1**2*(K*(2*fd - fdd)*(r + s)**2 + f*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + D1*(Dd*(2*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 429*b1*(D1**2*(f*(fd*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s - 1)**2*(2*K*bdd1 + 4*gd2 - 2*gdd2)) + (-2*r - 2*s)*(-2*fd*g2*(r + s) + 2*fd*gd2*(r + s - 1) + fdd*g2*(r + s))) + D1*(Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4*f*(g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 4*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(1001*d**2*k3**7) - D1**2*Pk1*Pkd3*k1**2*k2**2*st**6*(20*C - 10)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(693*d**2*k3**5) + D1**2*Pk1*Pkd3*k1**2*k2**2*st**4*(-55*b1**2*(2*C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(24*C*D1**2*f*fd*r**2 + 16*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r - 8*C*D1**2*f*fd*s**2 + 8*C*D1**2*f*fd*s - 4*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r**2 + 56*C*D1**2*f*fdd*r*s - 28*C*D1**2*f*fdd*r + 36*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 18*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r**2 + 56*C*D1**2*fd**2*r*s - 28*C*D1**2*fd**2*r + 36*C*D1**2*fd**2*s**2 - 36*C*D1**2*fd**2*s + 48*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 40*C*D1*Dd*f**2*r - 16*C*D1*Dd*f**2*s**2 + 8*C*D1*Dd*f**2*s + 4*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*r**2 + 448*C*D1*Dd*f*fd*r*s - 264*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 344*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*r**2 + 112*C*D1*Ddd*f**2*r*s - 76*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s**2 - 100*C*D1*Ddd*f**2*s + 46*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*r**2 + 336*C*Dd**2*f**2*r*s - 228*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s**2 - 300*C*Dd**2*f**2*s + 92*C*Dd**2*f**2 - 5*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s + 6*D1**2*f*fd*r - 10*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s - 24*D1*Dd*f**2*r**2 - 24*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r + 6*D1*Dd*f**2*s - 6*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 132*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 172*D1*Dd*f*fd*s - 50*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 38*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 50*D1*Ddd*f**2*s - 23*D1*Ddd*f**2 + 10*D1*bd1*(2*C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 60*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 114*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 150*Dd**2*f**2*s - 46*Dd**2*f**2) + f*(110*D1**2*bd1**2*(2*C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 11*D1**2*bdd1*f*(2*C - 1)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) - 22*D1*bd1*(D1*(f*(r + s - 1)*(6*C*r - 2*C*(s + 3) - 3*r + 3) + fd*(2*C - 1)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7)) + Dd*f*(2*C - 1)*(20*r**2 + r*(56*s - 39) + 36*s**2 - 53*s + 19)) - (28*C - 16)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(77*d**2*k3**5) - D1**2*Pk1*Pkd3*k1**2*k2**2*st**2*(-3432*C*D1**2*bd1*f**2*r**2 - 3432*C*D1**2*bd1*f**2*r*s + 15444*C*D1**2*bd1*f**2*r + 12012*C*D1**2*bd1*f**2*s - 7722*C*D1**2*bd1*f**2 - 23166*C*D1**2*f**2*fd*r**2 - 36036*C*D1**2*f**2*fd*r*s + 27456*C*D1**2*f**2*fd*r - 12870*C*D1**2*f**2*fd*s**2 + 20592*C*D1**2*f**2*fd*s - 12012*C*D1**2*f**2*fd - 30888*C*D1*Dd*f**3*r**2 - 48048*C*D1*Dd*f**3*r*s + 39468*C*D1*Dd*f**3*r - 17160*C*D1*Dd*f**3*s**2 + 29172*C*D1*Dd*f**3*s - 16302*C*D1*Dd*f**3 - 12012*D1**2*K*bd1**2*f*r**2 - 13728*D1**2*K*bd1**2*f*r*s + 23166*D1**2*K*bd1**2*f*r - 1716*D1**2*K*bd1**2*f*s**2 + 12870*D1**2*K*bd1**2*f*s - 11154*D1**2*K*bd1**2*f + 40326*D1**2*K*bd1*f**2*r**2 + 73788*D1**2*K*bd1*f**2*r*s - 73788*D1**2*K*bd1*f**2*r + 33462*D1**2*K*bd1*f**2*s**2 - 66924*D1**2*K*bd1*f**2*s + 33462*D1**2*K*bd1*f**2 - 101244*D1**2*K*bd1*f*fd*r**2 - 181896*D1**2*K*bd1*f*fd*r*s + 141570*D1**2*K*bd1*f*fd*r - 80652*D1**2*K*bd1*f*fd*s**2 + 126126*D1**2*K*bd1*f*fd*s - 45474*D1**2*K*bd1*f*fd - 25311*D1**2*K*bdd1*f**2*r**2 - 45474*D1**2*K*bdd1*f**2*r*s + 45474*D1**2*K*bdd1*f**2*r - 20163*D1**2*K*bdd1*f**2*s**2 + 40326*D1**2*K*bdd1*f**2*s - 20163*D1**2*K*bdd1*f**2 + 26598*D1**2*bd1**2*f**2*r**2 + 63492*D1**2*bd1**2*f**2*r*s - 66924*D1**2*bd1**2*f**2*r + 36894*D1**2*bd1**2*f**2*s**2 - 77220*D1**2*bd1**2*f**2*s + 40326*D1**2*bd1**2*f**2 + 5148*D1**2*bd1**2*f*r**2 + 10296*D1**2*bd1**2*f*r*s - 10296*D1**2*bd1**2*f*r + 5148*D1**2*bd1**2*f*s**2 - 10296*D1**2*bd1**2*f*s + 5148*D1**2*bd1**2*f + 60060*D1**2*bd1**2*g2*r**2 + 120120*D1**2*bd1**2*g2*r*s - 60060*D1**2*bd1**2*g2*r + 60060*D1**2*bd1**2*g2*s**2 - 60060*D1**2*bd1**2*g2*s - 25740*D1**2*bd1*bd2*f*r**2 - 51480*D1**2*bd1*bd2*f*r*s + 51480*D1**2*bd1*bd2*f*r - 25740*D1**2*bd1*bd2*f*s**2 + 51480*D1**2*bd1*bd2*f*s - 25740*D1**2*bd1*bd2*f - 15743*D1**2*bd1*f**3*r**2 - 28132*D1**2*bd1*f**3*r*s + 32812*D1**2*bd1*f**3*r - 12389*D1**2*bd1*f**3*s**2 + 29458*D1**2*bd1*f**3*s - 18174*D1**2*bd1*f**3 + 97422*D1**2*bd1*f**2*fd*r**2 + 171912*D1**2*bd1*f**2*fd*r*s - 155194*D1**2*bd1*f**2*fd*r + 74490*D1**2*bd1*f**2*fd*s**2 - 136084*D1**2*bd1*f**2*fd*s + 54288*D1**2*bd1*f**2*fd - 2574*D1**2*bd1*f**2*r**2 - 6864*D1**2*bd1*f**2*r*s - 4290*D1**2*bd1*f**2*s**2 + 1716*D1**2*bd1*f**2*s + 429*D1**2*bd1*f**2 + 10296*D1**2*bd1*f*fd*r**2 + 20592*D1**2*bd1*f*fd*r*s - 15444*D1**2*bd1*f*fd*r + 10296*D1**2*bd1*f*fd*s**2 - 15444*D1**2*bd1*f*fd*s + 5148*D1**2*bd1*f*fd - 120120*D1**2*bd1*f*g2*r**2 - 219648*D1**2*bd1*f*g2*r*s + 257400*D1**2*bd1*f*g2*r - 99528*D1**2*bd1*f*g2*s**2 + 236808*D1**2*bd1*f*g2*s - 128700*D1**2*bd1*f*g2 + 24024*D1**2*bd1*f*gd2*r**2 + 27456*D1**2*bd1*f*gd2*r*s - 46332*D1**2*bd1*f*gd2*r + 3432*D1**2*bd1*f*gd2*s**2 - 25740*D1**2*bd1*f*gd2*s + 22308*D1**2*bd1*f*gd2 + 24024*D1**2*bd1*fd*g2*r**2 + 27456*D1**2*bd1*fd*g2*r*s - 24024*D1**2*bd1*fd*g2*r + 3432*D1**2*bd1*fd*g2*s**2 - 13728*D1**2*bd1*fd*g2*s + 23595*D1**2*bd2*f**2*r**2 + 47190*D1**2*bd2*f**2*r*s - 47190*D1**2*bd2*f**2*r + 23595*D1**2*bd2*f**2*s**2 - 47190*D1**2*bd2*f**2*s + 23595*D1**2*bd2*f**2 - 51480*D1**2*bd2*f*fd*r**2 - 102960*D1**2*bd2*f*fd*r*s + 77220*D1**2*bd2*f*fd*r - 51480*D1**2*bd2*f*fd*s**2 + 77220*D1**2*bd2*f*fd*s - 25740*D1**2*bd2*f*fd + 16237*D1**2*bdd1*f**3*r**2 + 28652*D1**2*bdd1*f**3*r*s - 32708*D1**2*bdd1*f**3*r + 12415*D1**2*bdd1*f**3*s**2 - 28886*D1**2*bdd1*f**3*s + 18096*D1**2*bdd1*f**3 + 2574*D1**2*bdd1*f**2*r**2 + 5148*D1**2*bdd1*f**2*r*s - 5148*D1**2*bdd1*f**2*r + 2574*D1**2*bdd1*f**2*s**2 - 5148*D1**2*bdd1*f**2*s + 2574*D1**2*bdd1*f**2 + 12012*D1**2*bdd1*f*g2*r**2 + 13728*D1**2*bdd1*f*g2*r*s - 32604*D1**2*bdd1*f*g2*r + 1716*D1**2*bdd1*f*g2*s**2 - 22308*D1**2*bdd1*f*g2*s + 16302*D1**2*bdd1*f*g2 - 12870*D1**2*bdd2*f**2*r**2 - 25740*D1**2*bdd2*f**2*r*s + 25740*D1**2*bdd2*f**2*r - 12870*D1**2*bdd2*f**2*s**2 + 25740*D1**2*bdd2*f**2*s - 12870*D1**2*bdd2*f**2 + 9020*D1**2*f**3*fd*r**2 + 36320*D1**2*f**3*fd*r*s - 22670*D1**2*f**3*fd*r + 27300*D1**2*f**3*fd*s**2 - 36380*D1**2*f**3*fd*s + 15905*D1**2*f**3*fd - 9060*D1**2*f**3*fdd*r**2 - 38960*D1**2*f**3*fdd*r*s + 24010*D1**2*f**3*fdd*r - 29900*D1**2*f**3*fdd*s**2 + 39640*D1**2*f**3*fdd*s - 17215*D1**2*f**3*fdd - 27180*D1**2*f**2*fd**2*r**2 - 116880*D1**2*f**2*fd**2*r*s + 72030*D1**2*f**2*fd**2*r - 89700*D1**2*f**2*fd**2*s**2 + 118920*D1**2*f**2*fd**2*s - 34430*D1**2*f**2*fd**2 + 14157*D1**2*f**2*fd*r**2 + 20592*D1**2*f**2*fd*r*s - 16302*D1**2*f**2*fd*r + 6435*D1**2*f**2*fd*s**2 - 11154*D1**2*f**2*fd*s + 6864*D1**2*f**2*fd - 80652*D1**2*f**2*gd2*r**2 - 147576*D1**2*f**2*gd2*r*s + 147576*D1**2*f**2*gd2*r - 66924*D1**2*f**2*gd2*s**2 + 133848*D1**2*f**2*gd2*s - 66924*D1**2*f**2*gd2 + 50622*D1**2*f**2*gdd2*r**2 + 90948*D1**2*f**2*gdd2*r*s - 90948*D1**2*f**2*gdd2*r + 40326*D1**2*f**2*gdd2*s**2 - 80652*D1**2*f**2*gdd2*s + 40326*D1**2*f**2*gdd2 - 161304*D1**2*f*fd*g2*r**2 - 295152*D1**2*f*fd*g2*r*s + 161304*D1**2*f*fd*g2*r - 133848*D1**2*f*fd*g2*s**2 + 147576*D1**2*f*fd*g2*s - 80652*D1**2*f*fd*g2 + 202488*D1**2*f*fd*gd2*r**2 + 363792*D1**2*f*fd*gd2*r*s - 283140*D1**2*f*fd*gd2*r + 161304*D1**2*f*fd*gd2*s**2 - 252252*D1**2*f*fd*gd2*s + 90948*D1**2*f*fd*gd2 + 101244*D1**2*f*fdd*g2*r**2 + 181896*D1**2*f*fdd*g2*r*s - 101244*D1**2*f*fdd*g2*r + 80652*D1**2*f*fdd*g2*s**2 - 90948*D1**2*f*fdd*g2*s + 50622*D1**2*f*fdd*g2 + 101244*D1**2*fd**2*g2*r**2 + 181896*D1**2*fd**2*g2*r*s - 101244*D1**2*fd**2*g2*r + 80652*D1**2*fd**2*g2*s**2 - 90948*D1**2*fd**2*g2*s - 202488*D1*Dd*K*bd1*f**2*r**2 - 363792*D1*Dd*K*bd1*f**2*r*s + 323466*D1*Dd*K*bd1*f**2*r - 161304*D1*Dd*K*bd1*f**2*s**2 + 287430*D1*Dd*K*bd1*f**2*s - 126126*D1*Dd*K*bd1*f**2 + 129896*D1*Dd*bd1*f**3*r**2 + 229216*D1*Dd*bd1*f**3*r*s - 220610*D1*Dd*bd1*f**3*r + 99320*D1*Dd*bd1*f**3*s**2 - 193856*D1*Dd*bd1*f**3*s + 90480*D1*Dd*bd1*f**3 + 20592*D1*Dd*bd1*f**2*r**2 + 41184*D1*Dd*bd1*f**2*r*s - 36036*D1*Dd*bd1*f**2*r + 20592*D1*Dd*bd1*f**2*s**2 - 36036*D1*Dd*bd1*f**2*s + 15444*D1*Dd*bd1*f**2 + 96096*D1*Dd*bd1*f*g2*r**2 + 109824*D1*Dd*bd1*f*g2*r*s - 181896*D1*Dd*bd1*f*g2*r + 13728*D1*Dd*bd1*f*g2*s**2 - 109824*D1*Dd*bd1*f*g2*s + 77220*D1*Dd*bd1*f*g2 - 102960*D1*Dd*bd2*f**2*r**2 - 205920*D1*Dd*bd2*f**2*r*s + 180180*D1*Dd*bd2*f**2*r - 102960*D1*Dd*bd2*f**2*s**2 + 180180*D1*Dd*bd2*f**2*s - 77220*D1*Dd*bd2*f**2 + 9020*D1*Dd*f**4*r**2 + 36320*D1*Dd*f**4*r*s - 22670*D1*Dd*f**4*r + 27300*D1*Dd*f**4*s**2 - 36380*D1*Dd*f**4*s + 15905*D1*Dd*f**4 - 72480*D1*Dd*f**3*fd*r**2 - 311680*D1*Dd*f**3*fd*r*s + 192080*D1*Dd*f**3*fd*r - 239200*D1*Dd*f**3*fd*s**2 + 317120*D1*Dd*f**3*fd*s - 103290*D1*Dd*f**3*fd + 18876*D1*Dd*f**3*r**2 + 27456*D1*Dd*f**3*r*s - 23166*D1*Dd*f**3*r + 8580*D1*Dd*f**3*s**2 - 15444*D1*Dd*f**3*s + 9009*D1*Dd*f**3 - 322608*D1*Dd*f**2*g2*r**2 - 590304*D1*Dd*f**2*g2*r*s + 456456*D1*Dd*f**2*g2*r - 267696*D1*Dd*f**2*g2*s**2 + 415272*D1*Dd*f**2*g2*s - 214500*D1*Dd*f**2*g2 + 404976*D1*Dd*f**2*gd2*r**2 + 727584*D1*Dd*f**2*gd2*r*s - 646932*D1*Dd*f**2*gd2*r + 322608*D1*Dd*f**2*gd2*s**2 - 574860*D1*Dd*f**2*gd2*s + 252252*D1*Dd*f**2*gd2 + 809952*D1*Dd*f*fd*g2*r**2 + 1455168*D1*Dd*f*fd*g2*r*s - 971256*D1*Dd*f*fd*g2*r + 645216*D1*Dd*f*fd*g2*s**2 - 868296*D1*Dd*f*fd*g2*s + 283140*D1*Dd*f*fd*g2 - 9060*D1*Ddd*f**4*r**2 - 38960*D1*Ddd*f**4*r*s + 24010*D1*Ddd*f**4*r - 29900*D1*Ddd*f**4*s**2 + 39640*D1*Ddd*f**4*s - 17215*D1*Ddd*f**4 + 202488*D1*Ddd*f**2*g2*r**2 + 363792*D1*Ddd*f**2*g2*r*s - 283140*D1*Ddd*f**2*g2*r + 161304*D1*Ddd*f**2*g2*s**2 - 252252*D1*Ddd*f**2*g2*s + 131274*D1*Ddd*f**2*g2 - 27180*Dd**2*f**4*r**2 - 116880*Dd**2*f**4*r*s + 72030*Dd**2*f**4*r - 89700*Dd**2*f**4*s**2 + 118920*Dd**2*f**4*s - 34430*Dd**2*f**4 + 607464*Dd**2*f**2*g2*r**2 + 1091376*Dd**2*f**2*g2*r*s - 849420*Dd**2*f**2*g2*r + 483912*Dd**2*f**2*g2*s**2 - 756756*Dd**2*f**2*g2*s + 262548*Dd**2*f**2*g2 + 2145*b1**3*(D1**2*(13*fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(14*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 13*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*(7*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(7*K + 3*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(-70*C*D1**2*fd*r**2 - 140*C*D1**2*fd*r*s + 140*C*D1**2*fd*r - 70*C*D1**2*fd*s**2 + 140*C*D1**2*fd*s - 70*C*D1**2*fd - 280*C*D1*Dd*f*r**2 - 560*C*D1*Dd*f*r*s + 420*C*D1*Dd*f*r - 280*C*D1*Dd*f*s**2 + 420*C*D1*Dd*f*s - 210*C*D1*Dd*f + 140*D1**2*K*fd*r**2 + 256*D1**2*K*fd*r*s + 20*D1**2*K*fd*r + 116*D1**2*K*fd*s**2 + 20*D1**2*K*fd*s - 10*D1**2*K*fd - 14*D1**2*K*fdd*r**2 - 16*D1**2*K*fdd*r*s - 10*D1**2*K*fdd*r - 2*D1**2*K*fdd*s**2 - 10*D1**2*K*fdd*s + 5*D1**2*K*fdd - 5*D1**2*bdd1*(7*K + 3*f)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 50*D1**2*f*fd*r**2 - 124*D1**2*f*fd*r*s + 22*D1**2*f*fd*r - 74*D1**2*f*fd*s**2 + 34*D1**2*f*fd*s - 17*D1**2*f*fd + 62*D1**2*f*fdd*r**2 + 148*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r + 86*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 33*D1**2*f*fdd + 62*D1**2*fd**2*r**2 + 148*D1**2*fd**2*r*s - 54*D1**2*fd**2*r + 86*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s - 20*D1**2*fd**2 + 23*D1**2*fd*r**2 + 32*D1**2*fd*r*s - 70*D1**2*fd*r + 9*D1**2*fd*s**2 - 70*D1**2*fd*s + 35*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 + 70*D1**2*gdd2*r**2 + 140*D1**2*gdd2*r*s - 140*D1**2*gdd2*r + 70*D1**2*gdd2*s**2 - 140*D1**2*gdd2*s + 70*D1**2*gdd2 + 560*D1*Dd*K*f*r**2 + 1024*D1*Dd*K*f*r*s - 792*D1*Dd*K*f*r + 464*D1*Dd*K*f*s**2 - 720*D1*Dd*K*f*s + 372*D1*Dd*K*f - 112*D1*Dd*K*fd*r**2 - 128*D1*Dd*K*fd*r*s + 20*D1*Dd*K*fd*r - 16*D1*Dd*K*fd*s**2 - 16*D1*Dd*K*fd*s + 30*D1*Dd*K*fd - 100*D1*Dd*f**2*r**2 - 248*D1*Dd*f**2*r*s + 174*D1*Dd*f**2*r - 148*D1*Dd*f**2*s**2 + 210*D1*Dd*f**2*s - 99*D1*Dd*f**2 + 496*D1*Dd*f*fd*r**2 + 1184*D1*Dd*f*fd*r*s - 636*D1*Dd*f*fd*r + 688*D1*Dd*f*fd*s**2 - 756*D1*Dd*f*fd*s + 186*D1*Dd*f*fd + 92*D1*Dd*f*r**2 + 128*D1*Dd*f*r*s - 110*D1*Dd*f*r + 36*D1*Dd*f*s**2 - 68*D1*Dd*f*s + 41*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 36*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 36*D1*Dd*fd*s - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 + 1120*D1*Dd*gd2*r*s - 980*D1*Dd*gd2*r + 560*D1*Dd*gd2*s**2 - 980*D1*Dd*gd2*s + 420*D1*Dd*gd2 - 56*D1*Ddd*K*f*r**2 - 64*D1*Ddd*K*f*r*s + 60*D1*Ddd*K*f*r - 8*D1*Ddd*K*f*s**2 + 24*D1*Ddd*K*f*s - 18*D1*Ddd*K*f + 124*D1*Ddd*f**2*r**2 + 296*D1*Ddd*f**2*r*s - 210*D1*Ddd*f**2*r + 172*D1*Ddd*f**2*s**2 - 246*D1*Ddd*f**2*s + 117*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f + 280*D1*Ddd*g2*r**2 + 560*D1*Ddd*g2*r*s - 420*D1*Ddd*g2*r + 280*D1*Ddd*g2*s**2 - 420*D1*Ddd*g2*s + 210*D1*Ddd*g2 + 5*D1*bd1*(D1*(14*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 13*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2)) - 2*Dd*(7*K + 3*f)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 168*Dd**2*K*f*r**2 - 192*Dd**2*K*f*r*s + 180*Dd**2*K*f*r - 24*Dd**2*K*f*s**2 + 72*Dd**2*K*f*s - 36*Dd**2*K*f + 372*Dd**2*f**2*r**2 + 888*Dd**2*f**2*r*s - 630*Dd**2*f**2*r + 516*Dd**2*f**2*s**2 - 738*Dd**2*f**2*s + 234*Dd**2*f**2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f + 840*Dd**2*g2*r**2 + 1680*Dd**2*g2*r*s - 1260*Dd**2*g2*r + 840*Dd**2*g2*s**2 - 1260*Dd**2*g2*s + 420*Dd**2*g2) - 13*b1*(528*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s + 396*C*D1**2*f*fd*r + 660*C*D1**2*f*fd*s - 330*C*D1**2*f*fd + 1056*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 1056*C*D1*Dd*f**2*r - 264*C*D1*Dd*f**2*s + 264*C*D1*Dd*f**2 + 924*D1**2*K*bdd1*f*r**2 + 1056*D1**2*K*bdd1*f*r*s - 1782*D1**2*K*bdd1*f*r + 132*D1**2*K*bdd1*f*s**2 - 990*D1**2*K*bdd1*f*s + 693*D1**2*K*bdd1*f - 6204*D1**2*K*f*fd*r**2 - 11352*D1**2*K*f*fd*r*s + 6204*D1**2*K*f*fd*r - 5148*D1**2*K*f*fd*s**2 + 5676*D1**2*K*f*fd*s - 3102*D1**2*K*f*fd + 3894*D1**2*K*f*fdd*r**2 + 6996*D1**2*K*f*fdd*r*s - 3894*D1**2*K*f*fdd*r + 3102*D1**2*K*f*fdd*s**2 - 3498*D1**2*K*f*fdd*s + 1947*D1**2*K*f*fdd + 3894*D1**2*K*fd**2*r**2 + 6996*D1**2*K*fd**2*r*s - 3894*D1**2*K*fd**2*r + 3102*D1**2*K*fd**2*s**2 - 3498*D1**2*K*fd**2*s - 3135*D1**2*b2*fd*r**2 - 6270*D1**2*b2*fd*r*s - 3135*D1**2*b2*fd*s**2 + 990*D1**2*b2*fdd*r**2 + 1980*D1**2*b2*fdd*r*s + 990*D1**2*b2*fdd*s**2 + 330*D1**2*bd1**2*(7*K + 3*f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2046*D1**2*bdd1*f**2*r**2 - 4884*D1**2*bdd1*f**2*r*s + 5148*D1**2*bdd1*f**2*r - 2838*D1**2*bdd1*f**2*s**2 + 5940*D1**2*bdd1*f**2*s - 2772*D1**2*bdd1*f**2 - 396*D1**2*bdd1*f*r**2 - 792*D1**2*bdd1*f*r*s + 792*D1**2*bdd1*f*r - 396*D1**2*bdd1*f*s**2 + 792*D1**2*bdd1*f*s - 396*D1**2*bdd1*f - 4620*D1**2*bdd1*g2*r**2 - 9240*D1**2*bdd1*g2*r*s + 4620*D1**2*bdd1*g2*r - 4620*D1**2*bdd1*g2*s**2 + 4620*D1**2*bdd1*g2*s - 2310*D1**2*bdd1*g2 + 990*D1**2*bdd2*f*r**2 + 1980*D1**2*bdd2*f*r*s - 1980*D1**2*bdd2*f*r + 990*D1**2*bdd2*f*s**2 - 1980*D1**2*bdd2*f*s + 990*D1**2*bdd2*f + 3633*D1**2*f**2*fd*r**2 + 6492*D1**2*f**2*fd*r*s - 4226*D1**2*f**2*fd*r + 2859*D1**2*f**2*fd*s**2 - 3710*D1**2*f**2*fd*s + 1719*D1**2*f**2*fd - 3747*D1**2*f**2*fdd*r**2 - 6612*D1**2*f**2*fdd*r*s + 4390*D1**2*f**2*fdd*r - 2865*D1**2*f**2*fdd*s**2 + 3802*D1**2*f**2*fdd*s - 1767*D1**2*f**2*fdd - 7494*D1**2*f*fd**2*r**2 - 13224*D1**2*f*fd**2*r*s + 8780*D1**2*f*fd**2*r - 5730*D1**2*f*fd**2*s**2 + 7604*D1**2*f*fd**2*s - 2142*D1**2*f*fd**2 + 396*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 924*D1**2*f*fd*r + 660*D1**2*f*fd*s**2 - 1056*D1**2*f*fd*s + 561*D1**2*f*fd - 396*D1**2*f*fdd*r**2 - 792*D1**2*f*fdd*r*s + 396*D1**2*f*fdd*r - 396*D1**2*f*fdd*s**2 + 396*D1**2*f*fdd*s - 198*D1**2*f*fdd + 9240*D1**2*f*gd2*r**2 + 16896*D1**2*f*gd2*r*s - 16896*D1**2*f*gd2*r + 7656*D1**2*f*gd2*s**2 - 15312*D1**2*f*gd2*s + 7656*D1**2*f*gd2 - 924*D1**2*f*gdd2*r**2 - 1056*D1**2*f*gdd2*r*s + 1056*D1**2*f*gdd2*r - 132*D1**2*f*gdd2*s**2 + 264*D1**2*f*gdd2*s - 132*D1**2*f*gdd2 - 396*D1**2*fd**2*r**2 - 792*D1**2*fd**2*r*s + 396*D1**2*fd**2*r - 396*D1**2*fd**2*s**2 + 396*D1**2*fd**2*s + 9240*D1**2*fd*g2*r**2 + 16896*D1**2*fd*g2*r*s + 1320*D1**2*fd*g2*r + 7656*D1**2*fd*g2*s**2 + 1320*D1**2*fd*g2*s - 660*D1**2*fd*g2 - 1848*D1**2*fd*gd2*r**2 - 2112*D1**2*fd*gd2*r*s + 396*D1**2*fd*gd2*r - 264*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 660*D1**2*fd*gd2 - 924*D1**2*fdd*g2*r**2 - 1056*D1**2*fdd*g2*r*s - 660*D1**2*fdd*g2*r - 132*D1**2*fdd*g2*s**2 - 660*D1**2*fdd*g2*s + 330*D1**2*fdd*g2 - 12408*D1*Dd*K*f**2*r**2 - 22704*D1*Dd*K*f**2*r*s + 17556*D1*Dd*K*f**2*r - 10296*D1*Dd*K*f**2*s**2 + 15972*D1*Dd*K*f**2*s - 8250*D1*Dd*K*f**2 + 31152*D1*Dd*K*f*fd*r**2 + 55968*D1*Dd*K*f*fd*r*s - 37356*D1*Dd*K*f*fd*r + 24816*D1*Dd*K*f*fd*s**2 - 33396*D1*Dd*K*f*fd*s + 10890*D1*Dd*K*f*fd - 12540*D1*Dd*b2*f*r**2 - 25080*D1*Dd*b2*f*r*s + 18810*D1*Dd*b2*f*r - 12540*D1*Dd*b2*f*s**2 + 18810*D1*Dd*b2*f*s - 9405*D1*Dd*b2*f + 7920*D1*Dd*b2*fd*r**2 + 15840*D1*Dd*b2*fd*r*s - 5940*D1*Dd*b2*fd*r + 7920*D1*Dd*b2*fd*s**2 - 5940*D1*Dd*b2*fd*s + 4844*D1*Dd*f**3*r**2 + 8656*D1*Dd*f**3*r*s - 6750*D1*Dd*f**3*r + 3812*D1*Dd*f**3*s**2 - 5976*D1*Dd*f**3*s + 3117*D1*Dd*f**3 - 29976*D1*Dd*f**2*fd*r**2 - 52896*D1*Dd*f**2*fd*r*s + 38278*D1*Dd*f**2*fd*r - 22920*D1*Dd*f**2*fd*s**2 + 33280*D1*Dd*f**2*fd*s - 11994*D1*Dd*f**2*fd + 792*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 1452*D1*Dd*f**2*r + 1320*D1*Dd*f**2*s**2 - 1848*D1*Dd*f**2*s + 858*D1*Dd*f**2 - 3168*D1*Dd*f*fd*r**2 - 6336*D1*Dd*f*fd*r*s + 3960*D1*Dd*f*fd*r - 3168*D1*Dd*f*fd*s**2 + 3960*D1*Dd*f*fd*s - 1188*D1*Dd*f*fd + 36960*D1*Dd*f*g2*r**2 + 67584*D1*Dd*f*g2*r*s - 52272*D1*Dd*f*g2*r + 30624*D1*Dd*f*g2*s**2 - 47520*D1*Dd*f*g2*s + 24552*D1*Dd*f*g2 - 7392*D1*Dd*f*gd2*r**2 - 8448*D1*Dd*f*gd2*r*s + 8184*D1*Dd*f*gd2*r - 1056*D1*Dd*f*gd2*s**2 + 2640*D1*Dd*f*gd2*s - 1584*D1*Dd*f*gd2 - 7392*D1*Dd*fd*g2*r**2 - 8448*D1*Dd*fd*g2*r*s + 1320*D1*Dd*fd*g2*r - 1056*D1*Dd*fd*g2*s**2 - 1056*D1*Dd*fd*g2*s + 1980*D1*Dd*fd*g2 + 7788*D1*Ddd*K*f**2*r**2 + 13992*D1*Ddd*K*f**2*r*s - 10890*D1*Ddd*K*f**2*r + 6204*D1*Ddd*K*f**2*s**2 - 9702*D1*Ddd*K*f**2*s + 5049*D1*Ddd*K*f**2 + 3960*D1*Ddd*b2*f*r**2 + 7920*D1*Ddd*b2*f*r*s - 5940*D1*Ddd*b2*f*r + 3960*D1*Ddd*b2*f*s**2 - 5940*D1*Ddd*b2*f*s + 2970*D1*Ddd*b2*f - 4996*D1*Ddd*f**3*r**2 - 8816*D1*Ddd*f**3*r*s + 6906*D1*Ddd*f**3*r - 3820*D1*Ddd*f**3*s**2 + 6024*D1*Ddd*f**3*s - 3159*D1*Ddd*f**3 - 792*D1*Ddd*f**2*r**2 - 1584*D1*Ddd*f**2*r*s + 1188*D1*Ddd*f**2*r - 792*D1*Ddd*f**2*s**2 + 1188*D1*Ddd*f**2*s - 594*D1*Ddd*f**2 - 3696*D1*Ddd*f*g2*r**2 - 4224*D1*Ddd*f*g2*r*s + 3960*D1*Ddd*f*g2*r - 528*D1*Ddd*f*g2*s**2 + 1584*D1*Ddd*f*g2*s - 1188*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(2*f**2*(25*r**2 + r*(62*s - 76) + 37*s**2 - 88*s + 41) + f*(70*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 280*K*r**2 - 512*K*r*s + 556*K*r - 232*K*s**2 + 508*K*s - 266*K - 4*fd*(62*r**2 + 148*r*s - 105*r + 86*s**2 - 123*s + 40) - 46*r**2 - 64*r*s + 8*r - 18*s**2 - 20*s + 3) + 2*fd*(K*(28*r**2 + r*(32*s - 17) + 4*s**2 - 5*s - 5) - 12*r**2 - 12*r*(2*s - 1) - 12*s*(s - 1)) + 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f**2*(248*r**2 + r*(592*s - 522) + 344*s**2 - 606*s + 258) + f*(-K*(112*r**2 + 8*r*(16*s - 21) + 16*s**2 - 84*s + 57) + 48*r**2 + 12*r*(8*s - 7) + 48*s**2 - 84*s + 36) + 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 165*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 23364*Dd**2*K*f**2*r**2 + 41976*Dd**2*K*f**2*r*s - 32670*Dd**2*K*f**2*r + 18612*Dd**2*K*f**2*s**2 - 29106*Dd**2*K*f**2*s + 10098*Dd**2*K*f**2 + 11880*Dd**2*b2*f*r**2 + 23760*Dd**2*b2*f*r*s - 17820*Dd**2*b2*f*r + 11880*Dd**2*b2*f*s**2 - 17820*Dd**2*b2*f*s + 5940*Dd**2*b2*f - 14988*Dd**2*f**3*r**2 - 26448*Dd**2*f**3*r*s + 20718*Dd**2*f**3*r - 11460*Dd**2*f**3*s**2 + 18072*Dd**2*f**3*s - 6318*Dd**2*f**3 - 2376*Dd**2*f**2*r**2 - 4752*Dd**2*f**2*r*s + 3564*Dd**2*f**2*r - 2376*Dd**2*f**2*s**2 + 3564*Dd**2*f**2*s - 1188*Dd**2*f**2 - 11088*Dd**2*f*g2*r**2 - 12672*Dd**2*f*g2*r*s + 11880*Dd**2*f*g2*r - 1584*Dd**2*f*g2*s**2 + 4752*Dd**2*f*g2*s - 2376*Dd**2*f*g2) + 2145*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 12*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 12*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 120*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 36*Dd**2*f**2))/(18018*d**2*k3**5) - D1**2*Pk1*Pkd3*k1**2*st**4*(8*C - 4)*(11*D1*b1*(D1*bdd1*f*s*(-2*r - 2*s + 1) - bd1*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1))) + 11*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(-11*bd1**2*s*(2*r + 2*s - 1) + f*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(77*d**2*k3**3) - D1**2*Pk1*Pkd3*k1**2*st**2*(66*b1**2*(D1**2*(fd*(C*(52*r - 4*s + 4) - 26*r - 7*s + 7) + fdd*(2*C*(r + 15*s - 15) - r - 14*s + 14))*(r + s - 1) + D1*(Dd*(f*(4*C*(52*r**2 + 48*r*s - 50*r - 4*s**2 - 8*s + 11) - 104*r**2 - 132*r*s + 118*r - 28*s**2 + 61*s - 40) + fd*(4*C*(4*r**2 + 64*r*s - 49*r + 60*s**2 - 98*s + 38) - 8*r**2 - 120*r*s + 92*r - 112*s**2 + 183*s - 71)) + Ddd*f*(2*C*(4*r**2 + 64*r*s - 34*r + 60*s**2 - 76*s + 31) - 4*r**2 - 60*r*s + 32*r - 56*s**2 + 71*s - 29)) + Dd**2*f*(4*C*(6*r**2 + 96*r*s - 51*r + 90*s**2 - 114*s + 31) - 12*r**2 - 180*r*s + 96*r - 168*s**2 + 213*s - 58)) + 33*b1*(4*C*D1**2*f*fd*r**2 - 24*C*D1**2*f*fd*r*s - 4*C*D1**2*f*fd*r - 28*C*D1**2*f*fd*s**2 - 4*C*D1**2*f*fd*s - 6*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 + 24*C*D1**2*f*fdd*r*s + 12*C*D1**2*f*fdd*r + 28*C*D1**2*f*fdd*s**2 + 4*C*D1**2*f*fdd*s + 2*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 + 24*C*D1**2*fd**2*r*s + 12*C*D1**2*fd**2*r + 28*C*D1**2*fd**2*s**2 + 4*C*D1**2*fd**2*s - 32*C*D1**2*fd**2 + 8*C*D1*Dd*f**2*r**2 - 48*C*D1*Dd*f**2*r*s + 20*C*D1*Dd*f**2*r - 56*C*D1*Dd*f**2*s**2 + 68*C*D1*Dd*f**2*s - 26*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 + 192*C*D1*Dd*f*fd*r*s + 8*C*D1*Dd*f*fd*r + 224*C*D1*Dd*f*fd*s**2 - 120*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 + 48*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 56*C*D1*Ddd*f**2*s**2 - 68*C*D1*Ddd*f**2*s + 26*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 + 144*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 168*C*Dd**2*f**2*s**2 - 204*C*Dd**2*f**2*s + 52*C*Dd**2*f**2 + 2*D1**2*bdd1*f*(C*(4*r**2 + 64*r*s - 4*r + 60*s**2 - 32*s + 2) - 2*r**2 - 30*r*s + 2*r - 28*s**2 + 15*s - 1) - 2*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s + 2*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s + 3*D1**2*f*fd + 2*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 14*D1**2*f*fdd*s**2 - 4*D1**2*f*fdd*s - D1**2*f*fdd + 2*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 14*D1**2*fd**2*s**2 - 4*D1**2*fd**2*s + 18*D1**2*fd**2 - 4*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s - 10*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 - 34*D1*Dd*f**2*s + 13*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s - 4*D1*Dd*f*fd*r - 112*D1*Dd*f*fd*s**2 + 52*D1*Dd*f*fd*s + 14*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 10*D1*Ddd*f**2*r - 28*D1*Ddd*f**2*s**2 + 34*D1*Ddd*f**2*s - 13*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(4*C*(26*r**2 + 24*r*s - 26*r - 2*s**2 - 12*s + 13) - 52*r**2 - 66*r*s + 52*r - 14*s**2 + 33*s - 26) + fd*(4*C*(2*r**2 + 32*r*s - 17*r + 30*s**2 - 38*s + 8) - 4*r**2 - 60*r*s + 32*r - 56*s**2 + 71*s - 15)) + 2*Dd*f*(2*C*(8*r**2 + 128*r*s - 38*r + 120*s**2 - 108*s + 17) - 8*r**2 - 120*r*s + 36*r - 112*s**2 + 101*s - 16)) + 12*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 30*Dd**2*f**2*r - 84*Dd**2*f**2*s**2 + 102*Dd**2*f**2*s - 26*Dd**2*f**2) + f*(-978*C*D1**2*f*fd*r**2 - 4740*C*D1**2*f*fd*r*s + 2232*C*D1**2*f*fd*r - 3762*C*D1**2*f*fd*s**2 + 4088*C*D1**2*f*fd*s - 1580*C*D1**2*f*fd + 1182*C*D1**2*f*fdd*r**2 + 4548*C*D1**2*f*fdd*r*s - 2304*C*D1**2*f*fdd*r + 3366*C*D1**2*f*fdd*s**2 - 3760*C*D1**2*f*fdd*s + 1516*C*D1**2*f*fdd + 2364*C*D1**2*fd**2*r**2 + 9096*C*D1**2*fd**2*r*s - 4608*C*D1**2*fd**2*r + 6732*C*D1**2*fd**2*s**2 - 7520*C*D1**2*fd**2*s + 1516*C*D1**2*fd**2 - 1304*C*D1*Dd*f**2*r**2 - 6320*C*D1*Dd*f**2*r*s + 3812*C*D1*Dd*f**2*r - 5016*C*D1*Dd*f**2*s**2 + 6596*C*D1*Dd*f**2*s - 2834*C*D1*Dd*f**2 + 9456*C*D1*Dd*f*fd*r**2 + 36384*C*D1*Dd*f*fd*r*s - 20676*C*D1*Dd*f*fd*r + 26928*C*D1*Dd*f*fd*s**2 - 33052*C*D1*Dd*f*fd*s + 9824*C*D1*Dd*f*fd + 1576*C*D1*Ddd*f**2*r**2 + 6064*C*D1*Ddd*f**2*r*s - 3820*C*D1*Ddd*f**2*r + 4488*C*D1*Ddd*f**2*s**2 - 6004*C*D1*Ddd*f**2*s + 2638*C*D1*Ddd*f**2 + 4728*C*Dd**2*f**2*r**2 + 18192*C*Dd**2*f**2*r*s - 11460*C*Dd**2*f**2*r + 13464*C*Dd**2*f**2*s**2 - 18012*C*Dd**2*f**2*s + 5276*C*Dd**2*f**2 + 66*D1**2*bd1**2*(r**2*(4*C - 2) + r*(C*(64*s - 4) - 30*s + 2) + s*(4*C*(15*s - 8) - 28*s + 15)) - 33*D1**2*bdd1*f*(2*C*(r**2 + r*(10 - 6*s) - 7*s**2 + 22*s - 5) - r**2 + 2*r*(3*s - 5) + 7*s**2 - 24*s + 5) + 489*D1**2*f*fd*r**2 + 2472*D1**2*f*fd*r*s - 1150*D1**2*f*fd*r + 1983*D1**2*f*fd*s**2 - 2146*D1**2*f*fd*s + 824*D1**2*f*fd - 591*D1**2*f*fdd*r**2 - 2424*D1**2*f*fdd*r*s + 1202*D1**2*f*fdd*r - 1833*D1**2*f*fdd*s**2 + 2030*D1**2*f*fdd*s - 808*D1**2*f*fdd - 1182*D1**2*fd**2*r**2 - 4848*D1**2*fd**2*r*s + 2404*D1**2*fd**2*r - 3666*D1**2*fd**2*s**2 + 4060*D1**2*fd**2*s - 808*D1**2*fd**2 + 652*D1*Dd*f**2*r**2 + 3296*D1*Dd*f**2*r*s - 1974*D1*Dd*f**2*r + 2644*D1*Dd*f**2*s**2 - 3468*D1*Dd*f**2*s + 1485*D1*Dd*f**2 - 4728*D1*Dd*f*fd*r**2 - 19392*D1*Dd*f*fd*r*s + 10838*D1*Dd*f*fd*r - 14664*D1*Dd*f*fd*s**2 + 17876*D1*Dd*f*fd*s - 5262*D1*Dd*f*fd - 788*D1*Ddd*f**2*r**2 - 3232*D1*Ddd*f**2*r*s + 2010*D1*Ddd*f**2*r - 2444*D1*Ddd*f**2*s**2 + 3252*D1*Ddd*f**2*s - 1419*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f*(2*C*(r**2 - 6*r*(s - 1) - 7*s**2 + 22*s - 3) - r**2 + 6*r*(s - 1) + 7*s**2 - 24*s + 3) + 2*fd*(C*(-4*r**2 + 2*r*(12*s - 7) + 28*s**2 - 42*s + 22) + 2*r**2 - 12*r*s + 7*r - 14*s**2 + 22*s - 12)) - 2*Dd*f*(2*C*(4*r**2 + r*(25 - 24*s) - 28*s**2 + 61*s - 27) - 4*r**2 + r*(24*s - 25) + 28*s**2 - 65*s + 29)) - 2364*Dd**2*f**2*r**2 - 9696*Dd**2*f**2*r*s + 6030*Dd**2*f**2*r - 7332*Dd**2*f**2*s**2 + 9756*Dd**2*f**2*s - 2838*Dd**2*f**2))/(1386*d**2*k3**3) + D1**2*Pk1*Pkd3*k1**2*(-34*D1**2*K*bdd1*f**2*r**2 - 64*D1**2*K*bdd1*f**2*r*s + 64*D1**2*K*bdd1*f**2*r - 30*D1**2*K*bdd1*f**2*s**2 + 60*D1**2*K*bdd1*f**2*s - 30*D1**2*K*bdd1*f**2 - 2*D1**2*bd1**2*(6*f**2*(s - 1) - f*(K*(6*r**2 + 8*r*s + 31*r + 2*s**2 + 33*s - 35) - 6*s + 6) + 70*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 26*D1**2*bd2*f**2*r**2 + 44*D1**2*bd2*f**2*r*s - 44*D1**2*bd2*f**2*r + 18*D1**2*bd2*f**2*s**2 - 36*D1**2*bd2*f**2*s + 18*D1**2*bd2*f**2 - 136*D1**2*bd2*f*fd*r**2 - 256*D1**2*bd2*f*fd*r*s + 196*D1**2*bd2*f*fd*r - 120*D1**2*bd2*f*fd*s**2 + 184*D1**2*bd2*f*fd*s - 64*D1**2*bd2*f*fd + 10*D1**2*bdd1*f**3*r*s - 10*D1**2*bdd1*f**3*r + 10*D1**2*bdd1*f**3*s**2 - 20*D1**2*bdd1*f**3*s + 10*D1**2*bdd1*f**3 + 10*D1**2*bdd1*f**2*r*s - 10*D1**2*bdd1*f**2*r + 10*D1**2*bdd1*f**2*s**2 - 20*D1**2*bdd1*f**2*s + 10*D1**2*bdd1*f**2 - 12*D1**2*bdd1*f*g2*r**2 - 16*D1**2*bdd1*f*g2*r*s - 140*D1**2*bdd1*f*g2*r - 4*D1**2*bdd1*f*g2*s**2 - 140*D1**2*bdd1*f*g2*s + 70*D1**2*bdd1*f*g2 - 34*D1**2*bdd2*f**2*r**2 - 64*D1**2*bdd2*f**2*r*s + 64*D1**2*bdd2*f**2*r - 30*D1**2*bdd2*f**2*s**2 + 60*D1**2*bdd2*f**2*s - 30*D1**2*bdd2*f**2 - 52*D1**2*f**2*gd2*r**2 - 88*D1**2*f**2*gd2*r*s + 88*D1**2*f**2*gd2*r - 36*D1**2*f**2*gd2*s**2 + 72*D1**2*f**2*gd2*s - 36*D1**2*f**2*gd2 + 68*D1**2*f**2*gdd2*r**2 + 128*D1**2*f**2*gdd2*r*s - 128*D1**2*f**2*gdd2*r + 60*D1**2*f**2*gdd2*s**2 - 120*D1**2*f**2*gdd2*s + 60*D1**2*f**2*gdd2 - 104*D1**2*f*fd*g2*r**2 - 176*D1**2*f*fd*g2*r*s + 104*D1**2*f*fd*g2*r - 72*D1**2*f*fd*g2*s**2 + 88*D1**2*f*fd*g2*s - 52*D1**2*f*fd*g2 + 272*D1**2*f*fd*gd2*r**2 + 512*D1**2*f*fd*gd2*r*s - 392*D1**2*f*fd*gd2*r + 240*D1**2*f*fd*gd2*s**2 - 368*D1**2*f*fd*gd2*s + 128*D1**2*f*fd*gd2 + 136*D1**2*f*fdd*g2*r**2 + 256*D1**2*f*fdd*g2*r*s - 136*D1**2*f*fdd*g2*r + 120*D1**2*f*fdd*g2*s**2 - 128*D1**2*f*fdd*g2*s + 68*D1**2*f*fdd*g2 + 136*D1**2*fd**2*g2*r**2 + 256*D1**2*fd**2*g2*r*s - 136*D1**2*fd**2*g2*r + 120*D1**2*fd**2*g2*s**2 - 128*D1**2*fd**2*g2*s - 272*D1*Dd*bd2*f**2*r**2 - 512*D1*Dd*bd2*f**2*r*s + 452*D1*Dd*bd2*f**2*r - 240*D1*Dd*bd2*f**2*s**2 + 424*D1*Dd*bd2*f**2*s - 184*D1*Dd*bd2*f**2 - 208*D1*Dd*f**2*g2*r**2 - 352*D1*Dd*f**2*g2*r*s + 280*D1*Dd*f**2*g2*r - 144*D1*Dd*f**2*g2*s**2 + 232*D1*Dd*f**2*g2*s - 124*D1*Dd*f**2*g2 + 544*D1*Dd*f**2*gd2*r**2 + 1024*D1*Dd*f**2*gd2*r*s - 904*D1*Dd*f**2*gd2*r + 480*D1*Dd*f**2*gd2*s**2 - 848*D1*Dd*f**2*gd2*s + 368*D1*Dd*f**2*gd2 + 1088*D1*Dd*f*fd*g2*r**2 + 2048*D1*Dd*f*fd*g2*r*s - 1328*D1*Dd*f*fd*g2*r + 960*D1*Dd*f*fd*g2*s**2 - 1248*D1*Dd*f*fd*g2*s + 392*D1*Dd*f*fd*g2 + 272*D1*Ddd*f**2*g2*r**2 + 512*D1*Ddd*f**2*g2*r*s - 392*D1*Ddd*f**2*g2*r + 240*D1*Ddd*f**2*g2*s**2 - 368*D1*Ddd*f**2*g2*s + 188*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*bd2*f*(29*r**2 + r*(58*s - 64) + 29*s**2 - 64*s + 35) + D1*(5*f**3*(s - 1)*(r + s - 1) - f**2*(5*fd*(r*(6*s - 4) + 6*s**2 - 9*s + 3) + (r + s - 1)*(K*(13*r + 9*s - 9) - 4*s + 4)) + f*(fd*(2*K*(34*r**2 + 64*r*s - 49*r + 30*s**2 - 46*s + 16) - 20*r*s + 10*r - 20*s**2 + 25*s - 5) - g2*(5*r**2 + 2*r*(s + 21) - 3*s**2 + 42*s - 21) + 2*gd2*(6*r**2 + r*(8*s + 31) + 2*s**2 + 33*s - 35)) + 4*fd*g2*(3*r**2 + r*(4*s - 3) + s*(s - 2))) + Dd*f*(-5*f**2*(r*(8*s - 6) + 8*s**2 - 13*s + 5) + f*(2*K*(68*r**2 + 128*r*s - 113*r + 60*s**2 - 106*s + 46) - 40*r*s + 30*r - 40*s**2 + 65*s - 25) + 2*g2*(24*r**2 + 2*r*(16*s + 63) + 8*s**2 + 132*s - 105))) + 816*Dd**2*f**2*g2*r**2 + 1536*Dd**2*f**2*g2*r*s - 1176*Dd**2*f**2*g2*r + 720*Dd**2*f**2*g2*s**2 - 1104*Dd**2*f**2*g2*s + 376*Dd**2*f**2*g2 + 7*b1**3*(2*D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(2*Dd*(-20*K*r**2 - 40*K*r*s + 30*K*r - 20*K*s**2 + 30*K*s - 15*K + f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5) + 8*r*s - 4*r + 8*s**2 - 10*s + 4) + Ddd*(5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 8*r*s + 4*r - 8*s**2 + 10*s - 4)) + 2*Dd**2*(15*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4) - 12*r*s + 6*r - 12*s**2 + 15*s - 4)) + b1**2*(105*D1**2*K*bdd1*r**2 + 210*D1**2*K*bdd1*r*s - 140*D1**2*K*bdd1*r + 105*D1**2*K*bdd1*s**2 - 140*D1**2*K*bdd1*s + 70*D1**2*K*bdd1 - 5*D1**2*K*fd*r**2 - 2*D1**2*K*fd*r*s + 52*D1**2*K*fd*r + 3*D1**2*K*fd*s**2 + 44*D1**2*K*fd*s - 26*D1**2*K*fd + 6*D1**2*K*fdd*r**2 + 8*D1**2*K*fdd*r*s - 82*D1**2*K*fdd*r + 2*D1**2*K*fdd*s**2 - 78*D1**2*K*fdd*s + 41*D1**2*K*fdd - 42*D1**2*bdd1*f*r*s + 14*D1**2*bdd1*f*r - 42*D1**2*bdd1*f*s**2 + 42*D1**2*bdd1*f*s - 14*D1**2*bdd1*f - 42*D1**2*bdd1*r*s + 14*D1**2*bdd1*r - 42*D1**2*bdd1*s**2 + 42*D1**2*bdd1*s - 14*D1**2*bdd1 + 7*D1**2*bdd2*r**2 + 14*D1**2*bdd2*r*s - 14*D1**2*bdd2*r + 7*D1**2*bdd2*s**2 - 14*D1**2*bdd2*s + 7*D1**2*bdd2 - 12*D1**2*f*fd*s + 12*D1**2*f*fdd*s + 12*D1**2*fd**2*s - 12*D1**2*fd**2 - 10*D1**2*fd*s + 12*D1**2*fdd*s + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 - 20*D1*Dd*K*f*r**2 - 8*D1*Dd*K*f*r*s + 14*D1*Dd*K*f*r + 12*D1*Dd*K*f*s**2 - 10*D1*Dd*K*f*s + D1*Dd*K*f + 48*D1*Dd*K*fd*r**2 + 64*D1*Dd*K*fd*r*s - 356*D1*Dd*K*fd*r + 16*D1*Dd*K*fd*s**2 - 328*D1*Dd*K*fd*s + 238*D1*Dd*K*fd - 56*D1*Dd*b2*r**2 - 112*D1*Dd*b2*r*s + 84*D1*Dd*b2*r - 56*D1*Dd*b2*s**2 + 84*D1*Dd*b2*s - 42*D1*Dd*b2 + 48*D1*Dd*f*fd*s - 24*D1*Dd*f*fd + 48*D1*Dd*fd*s - 24*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 + 24*D1*Ddd*K*f*r**2 + 32*D1*Ddd*K*f*r*s - 28*D1*Ddd*K*f*r + 8*D1*Ddd*K*f*s**2 - 16*D1*Ddd*K*f*s + 10*D1*Ddd*K*f + 28*D1*Ddd*b2*r**2 + 56*D1*Ddd*b2*r*s - 42*D1*Ddd*b2*r + 28*D1*Ddd*b2*s**2 - 42*D1*Ddd*b2*s + 21*D1*Ddd*b2 - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 14*D1*bd1*(D1*(-15*K*r**2 - 30*K*r*s + 20*K*r - 15*K*s**2 + 20*K*s - 10*K + f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd*(-6*r*s + 4*r - 6*s**2 + 9*s - 3) + 6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(5*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(r*(10 - 24*s) - 24*s**2 + 27*s - 7) - 24*r*s + 10*r - 24*s**2 + 27*s - 7)) - 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) + 72*Dd**2*K*f*r**2 + 96*Dd**2*K*f*r*s - 84*Dd**2*K*f*r + 24*Dd**2*K*f*s**2 - 48*Dd**2*K*f*s + 20*Dd**2*K*f + 84*Dd**2*b2*r**2 + 168*Dd**2*b2*r*s - 126*Dd**2*b2*r + 84*Dd**2*b2*s**2 - 126*Dd**2*b2*s + 42*Dd**2*b2 - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) - b1*(-12*D1**2*K*bdd1*f*r**2 - 16*D1**2*K*bdd1*f*r*s - 62*D1**2*K*bdd1*f*r - 4*D1**2*K*bdd1*f*s**2 - 66*D1**2*K*bdd1*f*s + 33*D1**2*K*bdd1*f - 52*D1**2*K*f*fd*r**2 - 88*D1**2*K*f*fd*r*s + 52*D1**2*K*f*fd*r - 36*D1**2*K*f*fd*s**2 + 44*D1**2*K*f*fd*s - 26*D1**2*K*f*fd + 68*D1**2*K*f*fdd*r**2 + 128*D1**2*K*f*fdd*r*s - 68*D1**2*K*f*fdd*r + 60*D1**2*K*f*fdd*s**2 - 64*D1**2*K*f*fdd*s + 34*D1**2*K*f*fdd + 68*D1**2*K*fd**2*r**2 + 128*D1**2*K*fd**2*r*s - 68*D1**2*K*fd**2*r + 60*D1**2*K*fd**2*s**2 - 64*D1**2*K*fd**2*s + 14*D1**2*bd1**2*(-5*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*r*s - 2*r + 6*s**2 - 6*s + 1) - 16*D1**2*bd2*f*r**2 - 32*D1**2*bd2*f*r*s + 32*D1**2*bd2*f*r - 16*D1**2*bd2*f*s**2 + 32*D1**2*bd2*f*s - 16*D1**2*bd2*f + 58*D1**2*bd2*fd*r**2 + 116*D1**2*bd2*fd*r*s - 46*D1**2*bd2*fd*r + 58*D1**2*bd2*fd*s**2 - 46*D1**2*bd2*fd*s - 12*D1**2*bd2*fd + 12*D1**2*bdd1*f**2*s + 12*D1**2*bdd1*f*s + 140*D1**2*bdd1*g2*r**2 + 280*D1**2*bdd1*g2*r*s - 140*D1**2*bdd1*g2*r + 140*D1**2*bdd1*g2*s**2 - 140*D1**2*bdd1*g2*s + 70*D1**2*bdd1*g2 + 29*D1**2*bdd2*f*r**2 + 58*D1**2*bdd2*f*r*s - 58*D1**2*bdd2*f*r + 29*D1**2*bdd2*f*s**2 - 58*D1**2*bdd2*f*s + 29*D1**2*bdd2*f + 30*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 30*D1**2*f**2*fd*s + 10*D1**2*f**2*fd - 30*D1**2*f**2*fdd*r*s + 10*D1**2*f**2*fdd*r - 30*D1**2*f**2*fdd*s**2 + 30*D1**2*f**2*fdd*s - 10*D1**2*f**2*fdd - 60*D1**2*f*fd**2*r*s + 20*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s**2 + 60*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 16*D1**2*f*fd*r*s + 16*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s - 20*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 10*D1**2*f*gd2*r**2 - 4*D1**2*f*gd2*r*s + 4*D1**2*f*gd2*r + 6*D1**2*f*gd2*s**2 - 12*D1**2*f*gd2*s + 6*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 16*D1**2*f*gdd2*r*s - 16*D1**2*f*gdd2*r + 4*D1**2*f*gdd2*s**2 - 8*D1**2*f*gdd2*s + 4*D1**2*f*gdd2 - 20*D1**2*fd**2*r*s - 20*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s - 10*D1**2*fd*g2*r**2 - 4*D1**2*fd*g2*r*s + 104*D1**2*fd*g2*r + 6*D1**2*fd*g2*s**2 + 88*D1**2*fd*g2*s - 52*D1**2*fd*g2 + 24*D1**2*fd*gd2*r**2 + 32*D1**2*fd*gd2*r*s - 180*D1**2*fd*gd2*r + 8*D1**2*fd*gd2*s**2 - 164*D1**2*fd*gd2*s + 156*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r**2 + 16*D1**2*fdd*g2*r*s - 164*D1**2*fdd*g2*r + 4*D1**2*fdd*g2*s**2 - 156*D1**2*fdd*g2*s + 82*D1**2*fdd*g2 - 104*D1*Dd*K*f**2*r**2 - 176*D1*Dd*K*f**2*r*s + 140*D1*Dd*K*f**2*r - 72*D1*Dd*K*f**2*s**2 + 116*D1*Dd*K*f**2*s - 62*D1*Dd*K*f**2 + 544*D1*Dd*K*f*fd*r**2 + 1024*D1*Dd*K*f*fd*r*s - 664*D1*Dd*K*f*fd*r + 480*D1*Dd*K*f*fd*s**2 - 624*D1*Dd*K*f*fd*s + 196*D1*Dd*K*f*fd + 232*D1*Dd*bd2*f*r**2 + 464*D1*Dd*bd2*f*r*s - 406*D1*Dd*bd2*f*r + 232*D1*Dd*bd2*f*s**2 - 406*D1*Dd*bd2*f*s + 174*D1*Dd*bd2*f + 40*D1*Dd*f**3*r*s - 20*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 50*D1*Dd*f**3*s + 20*D1*Dd*f**3 - 240*D1*Dd*f**2*fd*r*s + 100*D1*Dd*f**2*fd*r - 240*D1*Dd*f**2*fd*s**2 + 270*D1*Dd*f**2*fd*s - 70*D1*Dd*f**2*fd + 32*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r + 32*D1*Dd*f**2*s**2 - 40*D1*Dd*f**2*s + 16*D1*Dd*f**2 - 160*D1*Dd*f*fd*r*s + 40*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 140*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 40*D1*Dd*f*g2*r**2 - 16*D1*Dd*f*g2*r*s + 28*D1*Dd*f*g2*r + 24*D1*Dd*f*g2*s**2 - 20*D1*Dd*f*g2*s + 2*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 128*D1*Dd*f*gd2*r*s - 120*D1*Dd*f*gd2*r + 32*D1*Dd*f*gd2*s**2 - 64*D1*Dd*f*gd2*s + 32*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 128*D1*Dd*fd*g2*r*s - 712*D1*Dd*fd*g2*r + 32*D1*Dd*fd*g2*s**2 - 656*D1*Dd*fd*g2*s + 476*D1*Dd*fd*g2 + 136*D1*Ddd*K*f**2*r**2 + 256*D1*Ddd*K*f**2*r*s - 196*D1*Ddd*K*f**2*r + 120*D1*Ddd*K*f**2*s**2 - 184*D1*Ddd*K*f**2*s + 94*D1*Ddd*K*f**2 - 40*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r - 40*D1*Ddd*f**3*s**2 + 50*D1*Ddd*f**3*s - 20*D1*Ddd*f**3 - 40*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 50*D1*Ddd*f**2*s - 20*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 64*D1*Ddd*f*g2*r*s - 56*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s**2 - 32*D1*Ddd*f*g2*s + 20*D1*Ddd*f*g2 - 2*D1*bd1*(7*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-5*K*f*r**2 - 2*K*f*r*s - 20*K*f*r + 3*K*f*s**2 - 24*K*f*s + 12*K*f + K*fd*(12*r**2 + r*(16*s - 51) + 4*s**2 - 45*s + 39) + 6*f**2*s + 5*f*s + 6*fd*(s - 1) + 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 140*gd2*r**2 - 280*gd2*r*s + 210*gd2*r - 140*gd2*s**2 + 210*gd2*s - 70*gd2) + Dd*(f**2*(12 - 24*s) + f*(K*(48*r**2 + 64*r*s + 96*r + 16*s**2 + 116*s - 97) - 24*s + 12) - 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 408*Dd**2*K*f**2*r**2 + 768*Dd**2*K*f**2*r*s - 588*Dd**2*K*f**2*r + 360*Dd**2*K*f**2*s**2 - 552*Dd**2*K*f**2*s + 188*Dd**2*K*f**2 - 120*Dd**2*f**3*r*s + 60*Dd**2*f**3*r - 120*Dd**2*f**3*s**2 + 150*Dd**2*f**3*s - 40*Dd**2*f**3 - 120*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 150*Dd**2*f**2*s - 40*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 192*Dd**2*f*g2*r*s - 168*Dd**2*f*g2*r + 48*Dd**2*f*g2*s**2 - 96*Dd**2*f*g2*s + 40*Dd**2*f*g2 + b2*(-7*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 16*D1**2*fd*r**2 - 32*D1**2*fd*r*s - 10*D1**2*fd*r - 16*D1**2*fd*s**2 - 10*D1**2*fd*s + 5*D1**2*fd + 29*D1**2*fdd*r**2 + 58*D1**2*fdd*r*s + 12*D1**2*fdd*r + 29*D1**2*fdd*s**2 + 12*D1**2*fdd*s - 6*D1**2*fdd - 64*D1*Dd*f*r**2 - 128*D1*Dd*f*r*s + 96*D1*Dd*f*r - 64*D1*Dd*f*s**2 + 96*D1*Dd*f*s - 48*D1*Dd*f + 232*D1*Dd*fd*r**2 + 464*D1*Dd*fd*r*s - 126*D1*Dd*fd*r + 232*D1*Dd*fd*s**2 - 126*D1*Dd*fd*s - 36*D1*Dd*fd + 116*D1*Ddd*f*r**2 + 232*D1*Ddd*f*r*s - 174*D1*Ddd*f*r + 116*D1*Ddd*f*s**2 - 174*D1*Ddd*f*s + 87*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 348*Dd**2*f*r**2 + 696*Dd**2*f*r*s - 522*Dd**2*f*r + 348*Dd**2*f*s**2 - 522*Dd**2*f*s + 174*Dd**2*f)) + b2*(14*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - D1**2*bdd1*f*(29*r**2 + r*(58*s - 70) + 29*s**2 - 70*s + 35) + 2*D1**2*(f*(fd*(26*r**2 + 44*r*s - 26*r + 18*s**2 - 22*s + 13) - fdd*(34*r**2 + 64*r*s - 34*r + 30*s**2 - 32*s + 17)) - 2*fd**2*(17*r**2 + r*(32*s - 17) + s*(15*s - 16))) + D1*bd1*(D1*(f*(16*r**2 + r*(32*s - 42) + 16*s**2 - 42*s + 21) - 58*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(116*r**2 + r*(232*s - 227) + 116*s**2 - 227*s + 105)) + 2*D1*f*(Dd*(f*(52*r**2 + 88*r*s - 70*r + 36*s**2 - 58*s + 31) - 2*fd*(136*r**2 + 256*r*s - 166*r + 120*s**2 - 156*s + 49)) - Ddd*f*(68*r**2 + 2*r*(64*s - 49) + 60*s**2 - 92*s + 47)) - 4*Dd**2*f**2*(102*r**2 + 3*r*(64*s - 49) + 90*s**2 - 138*s + 47)))/(21*d**2*k3**3) + 5*D1**2*Pk1*Pkd3*k2**6*st**6*(429*b1**2*(D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 26*b1*f*(-33*D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 66*D1*bd1*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 2*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f**2*(-858*D1**2*bd1**2*(r + s - 1)**2 + 52*D1**2*bdd1*f*(r + s - 1)**2 + 15*D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 104*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + 15*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(2002*d**2*k3**7) + 5*D1**2*Pk1*Pkd3*k2**4*st**6*(2376*C*D1**2*b1*f*fd*r**2 + 3696*C*D1**2*b1*f*fd*r*s - 1848*C*D1**2*b1*f*fd*r + 1320*C*D1**2*b1*f*fd*s**2 - 1320*C*D1**2*b1*f*fd*s + 660*C*D1**2*b1*f*fd - 1188*C*D1**2*b1*f*fdd*r**2 - 1848*C*D1**2*b1*f*fdd*r*s + 924*C*D1**2*b1*f*fdd*r - 660*C*D1**2*b1*f*fdd*s**2 + 660*C*D1**2*b1*f*fdd*s - 330*C*D1**2*b1*f*fdd - 1188*C*D1**2*b1*fd**2*r**2 - 1848*C*D1**2*b1*fd**2*r*s + 924*C*D1**2*b1*fd**2*r - 660*C*D1**2*b1*fd**2*s**2 + 660*C*D1**2*b1*fd**2*s + 108*C*D1**2*f**2*fd*r**2 + 168*C*D1**2*f**2*fd*r*s - 128*C*D1**2*f**2*fd*r + 60*C*D1**2*f**2*fd*s**2 - 96*C*D1**2*f**2*fd*s + 56*C*D1**2*f**2*fd - 54*C*D1**2*f**2*fdd*r**2 - 84*C*D1**2*f**2*fdd*r*s + 64*C*D1**2*f**2*fdd*r - 30*C*D1**2*f**2*fdd*s**2 + 48*C*D1**2*f**2*fdd*s - 28*C*D1**2*f**2*fdd - 108*C*D1**2*f*fd**2*r**2 - 168*C*D1**2*f*fd**2*r*s + 128*C*D1**2*f*fd**2*r - 60*C*D1**2*f*fd**2*s**2 + 96*C*D1**2*f*fd**2*s - 28*C*D1**2*f*fd**2 + 4752*C*D1*Dd*b1*f**2*r**2 + 7392*C*D1*Dd*b1*f**2*r*s - 6072*C*D1*Dd*b1*f**2*r + 2640*C*D1*Dd*b1*f**2*s**2 - 4488*C*D1*Dd*b1*f**2*s + 2508*C*D1*Dd*b1*f**2 - 9504*C*D1*Dd*b1*f*fd*r**2 - 14784*C*D1*Dd*b1*f*fd*r*s + 9768*C*D1*Dd*b1*f*fd*r - 5280*C*D1*Dd*b1*f*fd*s**2 + 7128*C*D1*Dd*b1*f*fd*s - 2244*C*D1*Dd*b1*f*fd + 144*C*D1*Dd*f**3*r**2 + 224*C*D1*Dd*f**3*r*s - 184*C*D1*Dd*f**3*r + 80*C*D1*Dd*f**3*s**2 - 136*C*D1*Dd*f**3*s + 76*C*D1*Dd*f**3 - 432*C*D1*Dd*f**2*fd*r**2 - 672*C*D1*Dd*f**2*fd*r*s + 532*C*D1*Dd*f**2*fd*r - 240*C*D1*Dd*f**2*fd*s**2 + 396*C*D1*Dd*f**2*fd*s - 160*C*D1*Dd*f**2*fd - 2376*C*D1*Ddd*b1*f**2*r**2 - 3696*C*D1*Ddd*b1*f**2*r*s + 3036*C*D1*Ddd*b1*f**2*r - 1320*C*D1*Ddd*b1*f**2*s**2 + 2244*C*D1*Ddd*b1*f**2*s - 1254*C*D1*Ddd*b1*f**2 - 72*C*D1*Ddd*f**3*r**2 - 112*C*D1*Ddd*f**3*r*s + 92*C*D1*Ddd*f**3*r - 40*C*D1*Ddd*f**3*s**2 + 68*C*D1*Ddd*f**3*s - 38*C*D1*Ddd*f**3 - 7128*C*Dd**2*b1*f**2*r**2 - 11088*C*Dd**2*b1*f**2*r*s + 9108*C*Dd**2*b1*f**2*r - 3960*C*Dd**2*b1*f**2*s**2 + 6732*C*Dd**2*b1*f**2*s - 2508*C*Dd**2*b1*f**2 - 216*C*Dd**2*f**3*r**2 - 336*C*Dd**2*f**3*r*s + 276*C*Dd**2*f**3*r - 120*C*Dd**2*f**3*s**2 + 204*C*Dd**2*f**3*s - 76*C*Dd**2*f**3 - 1452*D1**2*b1*f*fd*r**2 - 2112*D1**2*b1*f*fd*r*s + 1056*D1**2*b1*f*fd*r - 660*D1**2*b1*f*fd*s**2 + 660*D1**2*b1*f*fd*s - 330*D1**2*b1*f*fd + 726*D1**2*b1*f*fdd*r**2 + 1056*D1**2*b1*f*fdd*r*s - 528*D1**2*b1*f*fdd*r + 330*D1**2*b1*f*fdd*s**2 - 330*D1**2*b1*f*fdd*s + 165*D1**2*b1*f*fdd + 726*D1**2*b1*fd**2*r**2 + 1056*D1**2*b1*fd**2*r*s - 528*D1**2*b1*fd**2*r + 330*D1**2*b1*fd**2*s**2 - 330*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)*(2*C*(9*r + 5*s - 9) - 11*r - 5*s + 11) - 66*D1**2*f**2*fd*r**2 - 96*D1**2*f**2*fd*r*s + 76*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 52*D1**2*f**2*fd*s - 32*D1**2*f**2*fd + 33*D1**2*f**2*fdd*r**2 + 48*D1**2*f**2*fdd*r*s - 38*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 26*D1**2*f**2*fdd*s + 16*D1**2*f**2*fdd + 66*D1**2*f*fd**2*r**2 + 96*D1**2*f*fd**2*r*s - 76*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 52*D1**2*f*fd**2*s + 16*D1**2*f*fd**2 - 2904*D1*Dd*b1*f**2*r**2 - 4224*D1*Dd*b1*f**2*r*s + 3564*D1*Dd*b1*f**2*r - 1320*D1*Dd*b1*f**2*s**2 + 2376*D1*Dd*b1*f**2*s - 1386*D1*Dd*b1*f**2 + 5808*D1*Dd*b1*f*fd*r**2 + 8448*D1*Dd*b1*f*fd*r*s - 5676*D1*Dd*b1*f*fd*r + 2640*D1*Dd*b1*f*fd*s**2 - 3696*D1*Dd*b1*f*fd*s + 1188*D1*Dd*b1*f*fd - 88*D1*Dd*f**3*r**2 - 128*D1*Dd*f**3*r*s + 108*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 72*D1*Dd*f**3*s - 42*D1*Dd*f**3 + 264*D1*Dd*f**2*fd*r**2 + 384*D1*Dd*f**2*fd*r*s - 314*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 212*D1*Dd*f**2*fd*s + 90*D1*Dd*f**2*fd + 1452*D1*Ddd*b1*f**2*r**2 + 2112*D1*Ddd*b1*f**2*r*s - 1782*D1*Ddd*b1*f**2*r + 660*D1*Ddd*b1*f**2*s**2 - 1188*D1*Ddd*b1*f**2*s + 693*D1*Ddd*b1*f**2 + 44*D1*Ddd*f**3*r**2 + 64*D1*Ddd*f**3*r*s - 54*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 36*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1)*(2*C*(9*r + 5*s - 9) - 11*r - 5*s + 11) + fd*(-2*C*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) + 22*r**2 + 32*r*s - 30*r + 10*s**2 - 21*s + 8)) + Dd*f*(-2*C*(36*r**2 + 56*r*s - 59*r + 20*s**2 - 45*s + 23) + 44*r**2 + 64*r*s - 71*r + 20*s**2 - 50*s + 27)) + 4356*Dd**2*b1*f**2*r**2 + 6336*Dd**2*b1*f**2*r*s - 5346*Dd**2*b1*f**2*r + 1980*Dd**2*b1*f**2*s**2 - 3564*Dd**2*b1*f**2*s + 1386*Dd**2*b1*f**2 + 132*Dd**2*f**3*r**2 + 192*Dd**2*f**3*r*s - 162*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 108*Dd**2*f**3*s + 42*Dd**2*f**3)/(1386*d**2*k3**5) + D1**2*Pk1*Pkd3*k2**4*st**4*(-7722*C*D1**2*bd1*f**2*r**2 - 12012*C*D1**2*bd1*f**2*r*s + 15444*C*D1**2*bd1*f**2*r - 4290*C*D1**2*bd1*f**2*s**2 + 12012*C*D1**2*bd1*f**2*s - 7722*C*D1**2*bd1*f**2 - 7722*D1**2*K*bd1**2*f*r**2 - 12012*D1**2*K*bd1**2*f*r*s + 13728*D1**2*K*bd1**2*f*r - 4290*D1**2*K*bd1**2*f*s**2 + 10296*D1**2*K*bd1**2*f*s - 6006*D1**2*K*bd1**2*f + 6006*D1**2*bd1**2*f**2*r**2 + 13728*D1**2*bd1**2*f**2*r*s - 12870*D1**2*bd1**2*f**2*r + 7722*D1**2*bd1**2*f**2*s**2 - 14586*D1**2*bd1**2*f**2*s + 6864*D1**2*bd1**2*f**2 + 1716*D1**2*bd1**2*f*r**2 + 1716*D1**2*bd1**2*f*r*s - 2574*D1**2*bd1**2*f*r - 858*D1**2*bd1**2*f*s + 858*D1**2*bd1**2*f - 4290*D1**2*bd1*bd2*f*r**2 - 8580*D1**2*bd1*bd2*f*r*s + 8580*D1**2*bd1*bd2*f*r - 4290*D1**2*bd1*bd2*f*s**2 + 8580*D1**2*bd1*bd2*f*s - 4290*D1**2*bd1*bd2*f + 1118*D1**2*bd1*f**3*r**2 + 2028*D1**2*bd1*f**3*r*s - 1872*D1**2*bd1*f**3*r + 910*D1**2*bd1*f**3*s**2 - 1664*D1**2*bd1*f**3*s + 1144*D1**2*bd1*f**3 - 3354*D1**2*bd1*f**2*fd*r**2 - 6084*D1**2*bd1*f**2*fd*r*s + 5018*D1**2*bd1*f**2*fd*r - 2730*D1**2*bd1*f**2*fd*s**2 + 4498*D1**2*bd1*f**2*fd*s - 1456*D1**2*bd1*f**2*fd + 4719*D1**2*bd1*f**2*r**2 + 6864*D1**2*bd1*f**2*r*s - 9438*D1**2*bd1*f**2*r + 2145*D1**2*bd1*f**2*s**2 - 6864*D1**2*bd1*f**2*s + 4719*D1**2*bd1*f**2 - 15444*D1**2*bd1*f*g2*r**2 - 24024*D1**2*bd1*f*g2*r*s + 30888*D1**2*bd1*f*g2*r - 8580*D1**2*bd1*f*g2*s**2 + 24024*D1**2*bd1*f*g2*s - 15444*D1**2*bd1*f*g2 + 15444*D1**2*bd1*f*gd2*r**2 + 24024*D1**2*bd1*f*gd2*r*s - 27456*D1**2*bd1*f*gd2*r + 8580*D1**2*bd1*f*gd2*s**2 - 20592*D1**2*bd1*f*gd2*s + 12012*D1**2*bd1*f*gd2 + 15444*D1**2*bd1*fd*g2*r**2 + 24024*D1**2*bd1*fd*g2*r*s - 15444*D1**2*bd1*fd*g2*r + 8580*D1**2*bd1*fd*g2*s**2 - 12012*D1**2*bd1*fd*g2*s - 559*D1**2*bdd1*f**3*r**2 - 1014*D1**2*bdd1*f**3*r*s + 936*D1**2*bdd1*f**3*r - 455*D1**2*bdd1*f**3*s**2 + 832*D1**2*bdd1*f**3*s - 572*D1**2*bdd1*f**3 + 7722*D1**2*bdd1*f*g2*r**2 + 12012*D1**2*bdd1*f*g2*r*s - 15444*D1**2*bdd1*f*g2*r + 4290*D1**2*bdd1*f*g2*s**2 - 12012*D1**2*bdd1*f*g2*s + 7722*D1**2*bdd1*f*g2 - 60*D1**2*f**3*fd*r**2 - 1672*D1**2*f**3*fd*r*s + 866*D1**2*f**3*fd*r - 1612*D1**2*f**3*fd*s**2 + 2030*D1**2*f**3*fd*s - 821*D1**2*f**3*fd + 1044*D1**2*f**3*fdd*r**2 + 2968*D1**2*f**3*fdd*r*s - 2006*D1**2*f**3*fdd*r + 1924*D1**2*f**3*fdd*s**2 - 2666*D1**2*f**3*fdd*s + 1223*D1**2*f**3*fdd + 3132*D1**2*f**2*fd**2*r**2 + 8904*D1**2*f**2*fd**2*r*s - 6018*D1**2*f**2*fd**2*r + 5772*D1**2*f**2*fd**2*s**2 - 7998*D1**2*f**2*fd**2*s + 2446*D1**2*f**2*fd**2 - 4472*D1*Dd*bd1*f**3*r**2 - 8112*D1*Dd*bd1*f**3*r*s + 6890*D1*Dd*bd1*f**3*r - 3640*D1*Dd*bd1*f**3*s**2 + 6162*D1*Dd*bd1*f**3*s - 2600*D1*Dd*bd1*f**3 + 61776*D1*Dd*bd1*f*g2*r**2 + 96096*D1*Dd*bd1*f*g2*r*s - 101244*D1*Dd*bd1*f*g2*r + 34320*D1*Dd*bd1*f*g2*s**2 - 77220*D1*Dd*bd1*f*g2*s + 39468*D1*Dd*bd1*f*g2 - 60*D1*Dd*f**4*r**2 - 1672*D1*Dd*f**4*r*s + 866*D1*Dd*f**4*r - 1612*D1*Dd*f**4*s**2 + 2030*D1*Dd*f**4*s - 821*D1*Dd*f**4 + 8352*D1*Dd*f**3*fd*r**2 + 23744*D1*Dd*f**3*fd*r*s - 16048*D1*Dd*f**3*fd*r + 15392*D1*Dd*f**3*fd*s**2 - 21328*D1*Dd*f**3*fd*s + 7338*D1*Dd*f**3*fd + 1044*D1*Ddd*f**4*r**2 + 2968*D1*Ddd*f**4*r*s - 2006*D1*Ddd*f**4*r + 1924*D1*Ddd*f**4*s**2 - 2666*D1*Ddd*f**4*s + 1223*D1*Ddd*f**4 + 2145*D1*b2*(-D1*bdd1*f*(r + s - 1) + 2*bd1*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)))*(r + s - 1) + 3132*Dd**2*f**4*r**2 + 8904*Dd**2*f**4*r*s - 6018*Dd**2*f**4*r + 5772*Dd**2*f**4*s**2 - 7998*Dd**2*f**4*s + 2446*Dd**2*f**4 + 2145*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*b1**2*(18*D1**2*K*fd*r**2 + 28*D1**2*K*fd*r*s + 10*D1**2*K*fd*s**2 - 9*D1**2*K*fdd*r**2 - 14*D1**2*K*fdd*r*s - 5*D1**2*K*fdd*s**2 - 5*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 10*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 14*D1**2*f*fd*s**2 + 14*D1**2*f*fd*s - 7*D1**2*f*fd + 14*D1**2*f*fdd*r**2 + 32*D1**2*f*fdd*r*s - 16*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 14*D1**2*fd**2*r**2 + 32*D1**2*fd**2*r*s - 16*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 4*D1**2*fd*r**2 - 4*D1**2*fd*r*s + 2*D1**2*fdd*r**2 + 2*D1**2*fdd*r*s + 72*D1*Dd*K*f*r**2 + 112*D1*Dd*K*f*r*s - 92*D1*Dd*K*f*r + 40*D1*Dd*K*f*s**2 - 68*D1*Dd*K*f*s + 38*D1*Dd*K*f - 72*D1*Dd*K*fd*r**2 - 112*D1*Dd*K*fd*r*s + 46*D1*Dd*K*fd*r - 40*D1*Dd*K*fd*s**2 + 34*D1*Dd*K*fd*s - 20*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 34*D1*Dd*f**2*r - 28*D1*Dd*f**2*s**2 + 40*D1*Dd*f**2*s - 19*D1*Dd*f**2 + 112*D1*Dd*f*fd*r**2 + 256*D1*Dd*f*fd*r*s - 156*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 176*D1*Dd*f*fd*s + 52*D1*Dd*f*fd - 16*D1*Dd*f*r**2 - 16*D1*Dd*f*r*s + 16*D1*Dd*f*r + 4*D1*Dd*f*s - 4*D1*Dd*f + 16*D1*Dd*fd*r**2 + 16*D1*Dd*fd*r*s - 8*D1*Dd*fd*r - 2*D1*Dd*fd*s - 36*D1*Ddd*K*f*r**2 - 56*D1*Ddd*K*f*r*s + 46*D1*Ddd*K*f*r - 20*D1*Ddd*K*f*s**2 + 34*D1*Ddd*K*f*s - 19*D1*Ddd*K*f + 28*D1*Ddd*f**2*r**2 + 64*D1*Ddd*f**2*r*s - 46*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 52*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 + 8*D1*Ddd*f*r**2 + 8*D1*Ddd*f*r*s - 8*D1*Ddd*f*r - 2*D1*Ddd*f*s + 2*D1*Ddd*f + 10*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 108*Dd**2*K*f*r**2 - 168*Dd**2*K*f*r*s + 138*Dd**2*K*f*r - 60*Dd**2*K*f*s**2 + 102*Dd**2*K*f*s - 38*Dd**2*K*f + 84*Dd**2*f**2*r**2 + 192*Dd**2*f**2*r*s - 138*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 156*Dd**2*f**2*s + 50*Dd**2*f**2 + 24*Dd**2*f*r**2 + 24*Dd**2*f*r*s - 24*Dd**2*f*r - 6*Dd**2*f*s + 4*Dd**2*f) - 13*b1*(1188*C*D1**2*f*fd*r**2 + 1848*C*D1**2*f*fd*r*s - 924*C*D1**2*f*fd*r + 660*C*D1**2*f*fd*s**2 - 660*C*D1**2*f*fd*s + 330*C*D1**2*f*fd + 2376*C*D1*Dd*f**2*r**2 + 3696*C*D1*Dd*f**2*r*s - 3036*C*D1*Dd*f**2*r + 1320*C*D1*Dd*f**2*s**2 - 2244*C*D1*Dd*f**2*s + 1254*C*D1*Dd*f**2 + 594*D1**2*K*bdd1*f*r**2 + 924*D1**2*K*bdd1*f*r*s - 1056*D1**2*K*bdd1*f*r + 330*D1**2*K*bdd1*f*s**2 - 792*D1**2*K*bdd1*f*s + 462*D1**2*K*bdd1*f - 330*D1**2*b2*fd*r**2 - 660*D1**2*b2*fd*r*s - 330*D1**2*b2*fd*s**2 + 165*D1**2*b2*fdd*r**2 + 330*D1**2*b2*fdd*r*s + 165*D1**2*b2*fdd*s**2 + 330*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 462*D1**2*bdd1*f**2*r**2 - 1056*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*r - 594*D1**2*bdd1*f**2*s**2 + 1122*D1**2*bdd1*f**2*s - 528*D1**2*bdd1*f**2 - 132*D1**2*bdd1*f*r**2 - 132*D1**2*bdd1*f*r*s + 198*D1**2*bdd1*f*r + 66*D1**2*bdd1*f*s - 66*D1**2*bdd1*f + 165*D1**2*bdd2*f*r**2 + 330*D1**2*bdd2*f*r*s - 330*D1**2*bdd2*f*r + 165*D1**2*bdd2*f*s**2 - 330*D1**2*bdd2*f*s + 165*D1**2*bdd2*f - 258*D1**2*f**2*fd*r**2 - 468*D1**2*f**2*fd*r*s + 340*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 308*D1**2*f**2*fd*s - 138*D1**2*f**2*fd + 129*D1**2*f**2*fdd*r**2 + 234*D1**2*f**2*fdd*r*s - 170*D1**2*f**2*fdd*r + 105*D1**2*f**2*fdd*s**2 - 154*D1**2*f**2*fdd*s + 69*D1**2*f**2*fdd + 258*D1**2*f*fd**2*r**2 + 468*D1**2*f*fd**2*r*s - 340*D1**2*f*fd**2*r + 210*D1**2*f*fd**2*s**2 - 308*D1**2*f*fd**2*s + 114*D1**2*f*fd**2 - 726*D1**2*f*fd*r**2 - 1056*D1**2*f*fd*r*s + 528*D1**2*f*fd*r - 330*D1**2*f*fd*s**2 + 330*D1**2*f*fd*s - 165*D1**2*f*fd + 1188*D1**2*f*gd2*r**2 + 1848*D1**2*f*gd2*r*s - 1848*D1**2*f*gd2*r + 660*D1**2*f*gd2*s**2 - 1320*D1**2*f*gd2*s + 660*D1**2*f*gd2 - 594*D1**2*f*gdd2*r**2 - 924*D1**2*f*gdd2*r*s + 924*D1**2*f*gdd2*r - 330*D1**2*f*gdd2*s**2 + 660*D1**2*f*gdd2*s - 330*D1**2*f*gdd2 + 1188*D1**2*fd*g2*r**2 + 1848*D1**2*fd*g2*r*s + 660*D1**2*fd*g2*s**2 - 1188*D1**2*fd*gd2*r**2 - 1848*D1**2*fd*gd2*r*s + 924*D1**2*fd*gd2*r - 660*D1**2*fd*gd2*s**2 + 660*D1**2*fd*gd2*s - 594*D1**2*fdd*g2*r**2 - 924*D1**2*fdd*g2*r*s - 330*D1**2*fdd*g2*s**2 - 1320*D1*Dd*b2*f*r**2 - 2640*D1*Dd*b2*f*r*s + 1980*D1*Dd*b2*f*r - 1320*D1*Dd*b2*f*s**2 + 1980*D1*Dd*b2*f*s - 990*D1*Dd*b2*f + 1320*D1*Dd*b2*fd*r**2 + 2640*D1*Dd*b2*fd*r*s - 990*D1*Dd*b2*fd*r + 1320*D1*Dd*b2*fd*s**2 - 990*D1*Dd*b2*fd*s - 344*D1*Dd*f**3*r**2 - 624*D1*Dd*f**3*r*s + 484*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 436*D1*Dd*f**3*s - 226*D1*Dd*f**3 + 1032*D1*Dd*f**2*fd*r**2 + 1872*D1*Dd*f**2*fd*r*s - 1406*D1*Dd*f**2*fd*r + 840*D1*Dd*f**2*fd*s**2 - 1270*D1*Dd*f**2*fd*s + 478*D1*Dd*f**2*fd - 1452*D1*Dd*f**2*r**2 - 2112*D1*Dd*f**2*r*s + 1782*D1*Dd*f**2*r - 660*D1*Dd*f**2*s**2 + 1188*D1*Dd*f**2*s - 693*D1*Dd*f**2 + 4752*D1*Dd*f*g2*r**2 + 7392*D1*Dd*f*g2*r*s - 6072*D1*Dd*f*g2*r + 2640*D1*Dd*f*g2*s**2 - 4488*D1*Dd*f*g2*s + 2508*D1*Dd*f*g2 - 4752*D1*Dd*f*gd2*r**2 - 7392*D1*Dd*f*gd2*r*s + 6732*D1*Dd*f*gd2*r - 2640*D1*Dd*f*gd2*s**2 + 4884*D1*Dd*f*gd2*s - 2244*D1*Dd*f*gd2 - 4752*D1*Dd*fd*g2*r**2 - 7392*D1*Dd*fd*g2*r*s + 3036*D1*Dd*fd*g2*r - 2640*D1*Dd*fd*g2*s**2 + 2244*D1*Dd*fd*g2*s + 660*D1*Ddd*b2*f*r**2 + 1320*D1*Ddd*b2*f*r*s - 990*D1*Ddd*b2*f*r + 660*D1*Ddd*b2*f*s**2 - 990*D1*Ddd*b2*f*s + 495*D1*Ddd*b2*f + 172*D1*Ddd*f**3*r**2 + 312*D1*Ddd*f**3*r*s - 242*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s**2 - 218*D1*Ddd*f**3*s + 113*D1*Ddd*f**3 - 2376*D1*Ddd*f*g2*r**2 - 3696*D1*Ddd*f*g2*r*s + 3036*D1*Ddd*f*g2*r - 1320*D1*Ddd*f*g2*s**2 + 2244*D1*Ddd*f*g2*s - 1254*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f**2*(5*r**2 + r*(12*s - 11) + 7*s**2 - 13*s + 6) - f*(fd*(28*r**2 + r*(64*s - 46) + 36*s**2 - 52*s + 17) + (2*r + 2*s - 2)*(K*(9*r + 5*s - 7) - 2*r + 1)) + fd*(2*K*s*(5*s - 6) + r**2*(18*K - 4) + r*(4*K*(7*s - 4) - 4*s + 3) + s)) + Dd*f*(2*K*(36*r**2 + 56*r*s - 55*r + 20*s**2 - 41*s + 20) - f*(56*r**2 + 2*r*(64*s - 53) + 72*s**2 - 120*s + 49) - 16*r**2 - 16*r*s + 20*r + 6*s - 5)) - 330*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 1980*Dd**2*b2*f*r**2 + 3960*Dd**2*b2*f*r*s - 2970*Dd**2*b2*f*r + 1980*Dd**2*b2*f*s**2 - 2970*Dd**2*b2*f*s + 990*Dd**2*b2*f + 516*Dd**2*f**3*r**2 + 936*Dd**2*f**3*r*s - 726*Dd**2*f**3*r + 420*Dd**2*f**3*s**2 - 654*Dd**2*f**3*s + 226*Dd**2*f**3 - 7128*Dd**2*f*g2*r**2 - 11088*Dd**2*f*g2*r*s + 9108*Dd**2*f*g2*r - 3960*Dd**2*f*g2*s**2 + 6732*Dd**2*f*g2*s - 2508*Dd**2*f*g2))/(3003*d**2*k3**5) + D1**2*Pk1*Pkd3*k2**2*st**6*(20*C - 10)*(33*b1*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - fd*(2*s - 1)*(8*r + 8*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)) + f*(D1**2*(f*(-33*bdd1*s*(r + s - 1) + fd*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fdd*(-3*r*s + r - 3*s**2 + 3*s - 1)) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + 33*D1*bd1*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) + Dd*f*(r*(2 - 8*s) - 8*s**2 + 9*s - 2)) + D1*f*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-24*r*s + 10*r - 24*s**2 + 27*s - 7)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f**2*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(693*d**2*k3**3) + D1**2*Pk1*Pkd3*k2**2*st**4*(11*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)*(2*C*(5*r + s - 1) - 7*r - s + 1) + D1*(2*Dd*(f*(2*C*(20*r**2 + r*(24*s - 22) + 4*s**2 - 10*s + 7) - 28*r**2 + r*(30 - 32*s) - (3 - 2*s)**2) + fd*(-2*C*(20*r**2 + r*(24*s - 23) + 4*s**2 - 9*s + 5) + 28*r**2 + r*(32*s - 31) + 4*s**2 - 10*s + 6)) + Ddd*f*(-2*C*(20*r**2 + r*(24*s - 22) + 4*s**2 - 10*s + 7) + 28*r**2 + r*(32*s - 30) + (3 - 2*s)**2)) - 2*Dd**2*f*(2*C*(30*r**2 + r*(36*s - 33) + 6*s**2 - 15*s + 7) - 42*r**2 - 3*r*(16*s - 15) - 6*s**2 + 18*s - 9)) + 11*b1*(-12*C*D1**2*f*fd*r**2 - 56*C*D1**2*f*fd*r*s + 28*C*D1**2*f*fd*r - 44*C*D1**2*f*fd*s**2 + 44*C*D1**2*f*fd*s - 22*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r**2 + 56*C*D1**2*f*fdd*r*s - 28*C*D1**2*f*fdd*r + 36*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 18*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r**2 + 56*C*D1**2*fd**2*r*s - 28*C*D1**2*fd**2*r + 36*C*D1**2*fd**2*s**2 - 36*C*D1**2*fd**2*s - 24*C*D1*Dd*f**2*r**2 - 112*C*D1*Dd*f**2*r*s + 68*C*D1*Dd*f**2*r - 88*C*D1*Dd*f**2*s**2 + 116*C*D1*Dd*f**2*s - 50*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*r**2 + 448*C*D1*Dd*f*fd*r*s - 264*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 344*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*r**2 + 112*C*D1*Ddd*f**2*r*s - 76*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s**2 - 100*C*D1*Ddd*f**2*s + 46*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*r**2 + 336*C*Dd**2*f**2*r*s - 228*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s**2 - 300*C*Dd**2*f**2*s + 92*C*Dd**2*f**2 + D1**2*bdd1*f*(-2*C*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) + 14*r**2 + 2*r*(8*s - 7) + 2*s**2 - 8*s + 7) + 6*D1**2*f*fd*r**2 + 24*D1**2*f*fd*r*s - 12*D1**2*f*fd*r + 18*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 9*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 12*D1*Dd*f**2*r**2 + 48*D1*Dd*f**2*r*s - 30*D1*Dd*f**2*r + 36*D1*Dd*f**2*s**2 - 48*D1*Dd*f**2*s + 21*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 132*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 172*D1*Dd*f*fd*s - 50*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 38*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 50*D1*Ddd*f**2*s - 23*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(2*C*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) - 14*r**2 - 16*r*s + 14*r - 2*s**2 + 8*s - 7) + fd*(-2*C*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + 14*r**2 + 16*r*s - 15*r + 2*s**2 - 6*s + 4)) + Dd*f*(-2*C*(40*r**2 + 6*r*(8*s - 7) + 8*s**2 - 22*s + 11) + 56*r**2 + 64*r*s - 58*r + 8*s**2 - 28*s + 15)) - 60*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 114*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 150*Dd**2*f**2*s - 46*Dd**2*f**2) + f*(-22*D1**2*bd1**2*(r**2*(10*C - 7) + r*(2*C*(6*s - 5) - 8*s + 7) + s*(2*C*(s - 3) - s + 4)) + 11*D1**2*bdd1*f*(2*C - 1)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) - 2*D1**2*(4*C*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) - (3*r**2 - 2*r + s*(2 - 3*s))*(2*f*fd - f*fdd - 2*fd**2)) - 11*D1*bd1*(D1*(f*(r + s - 1)*(C*(6*r + 22*s - 6) - 3*r - 9*s + 3) - fd*(4*C - 2)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7)) + Dd*f*(2 - 4*C)*(20*r**2 + r*(56*s - 39) + 36*s**2 - 53*s + 19)) - 2*D1*f*(2*Dd*(f*(4*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 4*r**2 + 2*r + (1 - 2*s)**2) - fd*(2*C*(24*r**2 + 24*r*(s - 1) - 7*s + 5) - 12*r**2 + 7*r + 12*s**2 - 10*s + 1)) - Ddd*f*(4*C*(4*r**2 + 4*r*(s - 1) - s + 1) - 4*r**2 + 2*r + (1 - 2*s)**2)) + 4*Dd**2*f**2*(C*(24*r**2 + 24*r*(s - 1) - 6*s + 4) - 6*r**2 + 3*r + 6*s**2 - 6*s + 1)))/(77*d**2*k3**3) + D1**2*Pk1*Pkd3*k2**2*st**2*(330*C*D1**2*bd1*f**2*r**2 + 396*C*D1**2*bd1*f**2*r*s + 66*C*D1**2*bd1*f**2*s**2 + 2640*D1**2*K*bd1**2*f*r**2 + 5016*D1**2*K*bd1**2*f*r*s - 4818*D1**2*K*bd1**2*f*r + 2376*D1**2*K*bd1**2*f*s**2 - 4686*D1**2*K*bd1**2*f*s + 2310*D1**2*K*bd1**2*f - 165*D1**2*K*bd1*f**2*r**2 - 66*D1**2*K*bd1*f**2*r*s + 66*D1**2*K*bd1*f**2*r + 99*D1**2*K*bd1*f**2*s**2 - 198*D1**2*K*bd1*f**2*s + 99*D1**2*K*bd1*f**2 - 660*D1**2*K*bd1*f*fd*r**2 - 1320*D1**2*K*bd1*f*fd*r*s + 990*D1**2*K*bd1*f*fd*r - 660*D1**2*K*bd1*f*fd*s**2 + 990*D1**2*K*bd1*f*fd*s - 330*D1**2*K*bd1*f*fd - 165*D1**2*K*bdd1*f**2*r**2 - 330*D1**2*K*bdd1*f**2*r*s + 330*D1**2*K*bdd1*f**2*r - 165*D1**2*K*bdd1*f**2*s**2 + 330*D1**2*K*bdd1*f**2*s - 165*D1**2*K*bdd1*f**2 + 1320*D1**2*bd1**2*f**2*r*s - 594*D1**2*bd1**2*f**2*r + 1320*D1**2*bd1**2*f**2*s**2 - 1650*D1**2*bd1**2*f**2*s + 660*D1**2*bd1**2*f**2 + 264*D1**2*bd1**2*f*r**2 + 660*D1**2*bd1**2*f*r*s - 726*D1**2*bd1**2*f*r + 396*D1**2*bd1**2*f*s**2 - 792*D1**2*bd1**2*f*s + 396*D1**2*bd1**2*f + 4620*D1**2*bd1**2*g2*r**2 + 5544*D1**2*bd1**2*g2*r*s - 4620*D1**2*bd1**2*g2*r + 924*D1**2*bd1**2*g2*s**2 - 2772*D1**2*bd1**2*g2*s + 2376*D1**2*bd1*bd2*f*r**2 + 4752*D1**2*bd1*bd2*f*r*s - 4686*D1**2*bd1*bd2*f*r + 2376*D1**2*bd1*bd2*f*s**2 - 4686*D1**2*bd1*bd2*f*s + 2310*D1**2*bd1*bd2*f - 215*D1**2*bd1*f**3*r**2 - 908*D1**2*bd1*f**3*r*s + 516*D1**2*bd1*f**3*r - 693*D1**2*bd1*f**3*s**2 + 792*D1**2*bd1*f**3*s - 396*D1**2*bd1*f**3 + 2526*D1**2*bd1*f**2*fd*r**2 + 7872*D1**2*bd1*f**2*fd*r*s - 5170*D1**2*bd1*f**2*fd*r + 5346*D1**2*bd1*f**2*fd*s**2 - 6988*D1**2*bd1*f**2*fd*s + 1908*D1**2*bd1*f**2*fd - 561*D1**2*bd1*f**2*r**2 - 924*D1**2*bd1*f**2*r*s + 594*D1**2*bd1*f**2*r - 363*D1**2*bd1*f**2*s**2 + 594*D1**2*bd1*f**2*s - 264*D1**2*bd1*f**2 + 792*D1**2*bd1*f*fd*r**2 + 1584*D1**2*bd1*f*fd*r*s - 1188*D1**2*bd1*f*fd*r + 792*D1**2*bd1*f*fd*s**2 - 1188*D1**2*bd1*f*fd*s + 396*D1**2*bd1*f*fd + 2046*D1**2*bd1*f*g2*r**2 + 3564*D1**2*bd1*f*g2*r*s - 2772*D1**2*bd1*f*g2*r + 1518*D1**2*bd1*f*g2*s**2 - 2772*D1**2*bd1*f*g2*s + 1386*D1**2*bd1*f*g2 - 5280*D1**2*bd1*f*gd2*r**2 - 10032*D1**2*bd1*f*gd2*r*s + 9636*D1**2*bd1*f*gd2*r - 4752*D1**2*bd1*f*gd2*s**2 + 9372*D1**2*bd1*f*gd2*s - 4620*D1**2*bd1*f*gd2 - 5280*D1**2*bd1*fd*g2*r**2 - 10032*D1**2*bd1*fd*g2*r*s + 5280*D1**2*bd1*fd*g2*r - 4752*D1**2*bd1*fd*g2*s**2 + 5016*D1**2*bd1*fd*g2*s - 165*D1**2*bd2*f**2*r**2 - 66*D1**2*bd2*f**2*r*s + 66*D1**2*bd2*f**2*r + 99*D1**2*bd2*f**2*s**2 - 198*D1**2*bd2*f**2*s + 99*D1**2*bd2*f**2 - 660*D1**2*bd2*f*fd*r**2 - 1320*D1**2*bd2*f*fd*r*s + 990*D1**2*bd2*f*fd*r - 660*D1**2*bd2*f*fd*s**2 + 990*D1**2*bd2*f*fd*s - 330*D1**2*bd2*f*fd + 421*D1**2*bdd1*f**3*r**2 + 1312*D1**2*bdd1*f**3*r*s - 852*D1**2*bdd1*f**3*r + 891*D1**2*bdd1*f**3*s**2 - 1056*D1**2*bdd1*f**3*s + 528*D1**2*bdd1*f**3 + 198*D1**2*bdd1*f**2*r**2 + 396*D1**2*bdd1*f**2*r*s - 396*D1**2*bdd1*f**2*r + 198*D1**2*bdd1*f**2*s**2 - 396*D1**2*bdd1*f**2*s + 198*D1**2*bdd1*f**2 - 2640*D1**2*bdd1*f*g2*r**2 - 5016*D1**2*bdd1*f*g2*r*s + 4620*D1**2*bdd1*f*g2*r - 2376*D1**2*bdd1*f*g2*s**2 + 4620*D1**2*bdd1*f*g2*s - 2310*D1**2*bdd1*f*g2 - 165*D1**2*bdd2*f**2*r**2 - 330*D1**2*bdd2*f**2*r*s + 330*D1**2*bdd2*f**2*r - 165*D1**2*bdd2*f**2*s**2 + 330*D1**2*bdd2*f**2*s - 165*D1**2*bdd2*f**2 + 198*D1**2*f**2*fd*r**2 + 198*D1**2*f**2*fd*r*s - 198*D1**2*f**2*fd*r - 66*D1**2*f**2*fd*s + 66*D1**2*f**2*fd + 330*D1**2*f**2*gd2*r**2 + 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*r - 198*D1**2*f**2*gd2*s**2 + 396*D1**2*f**2*gd2*s - 198*D1**2*f**2*gd2 + 330*D1**2*f**2*gdd2*r**2 + 660*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*r + 330*D1**2*f**2*gdd2*s**2 - 660*D1**2*f**2*gdd2*s + 330*D1**2*f**2*gdd2 + 660*D1**2*f*fd*g2*r**2 + 264*D1**2*f*fd*g2*r*s - 660*D1**2*f*fd*g2*r - 396*D1**2*f*fd*g2*s**2 - 132*D1**2*f*fd*g2*s + 330*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*r**2 + 2640*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 1320*D1**2*f*fd*gd2*s**2 - 1980*D1**2*f*fd*gd2*s + 660*D1**2*f*fd*gd2 + 660*D1**2*f*fdd*g2*r**2 + 1320*D1**2*f*fdd*g2*r*s - 660*D1**2*f*fdd*g2*r + 660*D1**2*f*fdd*g2*s**2 - 660*D1**2*f*fdd*g2*s + 330*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*r**2 + 1320*D1**2*fd**2*g2*r*s - 660*D1**2*fd**2*g2*r + 660*D1**2*fd**2*g2*s**2 - 660*D1**2*fd**2*g2*s - 1320*D1*Dd*K*bd1*f**2*r**2 - 2640*D1*Dd*K*bd1*f**2*r*s + 2310*D1*Dd*K*bd1*f**2*r - 1320*D1*Dd*K*bd1*f**2*s**2 + 2310*D1*Dd*K*bd1*f**2*s - 990*D1*Dd*K*bd1*f**2 + 3368*D1*Dd*bd1*f**3*r**2 + 10496*D1*Dd*bd1*f**3*r*s - 6874*D1*Dd*bd1*f**3*r + 7128*D1*Dd*bd1*f**3*s**2 - 9100*D1*Dd*bd1*f**3*s + 2964*D1*Dd*bd1*f**3 + 1584*D1*Dd*bd1*f**2*r**2 + 3168*D1*Dd*bd1*f**2*r*s - 2772*D1*Dd*bd1*f**2*r + 1584*D1*Dd*bd1*f**2*s**2 - 2772*D1*Dd*bd1*f**2*s + 1188*D1*Dd*bd1*f**2 - 21120*D1*Dd*bd1*f*g2*r**2 - 40128*D1*Dd*bd1*f*g2*r*s + 33792*D1*Dd*bd1*f*g2*r - 19008*D1*Dd*bd1*f*g2*s**2 + 33000*D1*Dd*bd1*f*g2*s - 13860*D1*Dd*bd1*f*g2 - 1320*D1*Dd*bd2*f**2*r**2 - 2640*D1*Dd*bd2*f**2*r*s + 2310*D1*Dd*bd2*f**2*r - 1320*D1*Dd*bd2*f**2*s**2 + 2310*D1*Dd*bd2*f**2*s - 990*D1*Dd*bd2*f**2 + 264*D1*Dd*f**3*r**2 + 264*D1*Dd*f**3*r*s - 264*D1*Dd*f**3*r - 66*D1*Dd*f**3*s + 66*D1*Dd*f**3 + 1320*D1*Dd*f**2*g2*r**2 + 528*D1*Dd*f**2*g2*r*s - 924*D1*Dd*f**2*g2*r - 792*D1*Dd*f**2*g2*s**2 + 660*D1*Dd*f**2*g2*s - 66*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*r**2 + 5280*D1*Dd*f**2*gd2*r*s - 4620*D1*Dd*f**2*gd2*r + 2640*D1*Dd*f**2*gd2*s**2 - 4620*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 5280*D1*Dd*f*fd*g2*r**2 + 10560*D1*Dd*f*fd*g2*r*s - 6600*D1*Dd*f*fd*g2*r + 5280*D1*Dd*f*fd*g2*s**2 - 6600*D1*Dd*f*fd*g2*s + 1980*D1*Dd*f*fd*g2 + 1320*D1*Ddd*f**2*g2*r**2 + 2640*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 1320*D1*Ddd*f**2*g2*s**2 - 1980*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 3960*Dd**2*f**2*g2*r**2 + 7920*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 3960*Dd**2*f**2*g2*s**2 - 5940*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 - 33*b1**3*(D1**2*(r + s - 1)*(3*fd*r + 17*fd*(s - 1) + fdd*(-19*r - 33*s + 33)) + D1*(Dd*f*(12*r**2 + r*(80*s - 46) + 68*s**2 - 88*s + 37) - 2*Dd*(7*K*(20*r**2 + 24*r*s - 22*r + 4*s**2 - 10*s + 7) + fd*(76*r**2 + 208*r*s - 175*r + 132*s**2 - 224*s + 92) - 56*r**2 - 56*r*s + 56*r + 14*s - 14) - Ddd*f*(76*r**2 + 2*r*(104*s - 71) + 132*s**2 - 184*s + 85) + 7*Ddd*(K*(20*r**2 + r*(24*s - 22) + 4*s**2 - 10*s + 7) - 8*r**2 - 8*r*s + 8*r + 2*s - 2)) - 2*Dd**2*(-7*K*(30*r**2 + r*(36*s - 33) + 6*s**2 - 15*s + 7) + f*(114*r**2 + 3*r*(104*s - 71) + 198*s**2 - 276*s + 85) + 84*r**2 + 84*r*(s - 1) - 21*s + 14)) - 33*b1**2*(70*C*D1**2*fd*r**2 + 84*C*D1**2*fd*r*s - 84*C*D1**2*fd*r + 14*C*D1**2*fd*s**2 - 28*C*D1**2*fd*s + 14*C*D1**2*fd + 280*C*D1*Dd*f*r**2 + 336*C*D1*Dd*f*r*s - 308*C*D1*Dd*f*r + 56*C*D1*Dd*f*s**2 - 140*C*D1*Dd*f*s + 98*C*D1*Dd*f + 105*D1**2*K*bdd1*r**2 + 126*D1**2*K*bdd1*r*s - 112*D1**2*K*bdd1*r + 21*D1**2*K*bdd1*s**2 - 56*D1**2*K*bdd1*s + 42*D1**2*K*bdd1 + 31*D1**2*K*fd*r**2 + 54*D1**2*K*fd*r*s - 20*D1**2*K*fd*r + 23*D1**2*K*fd*s**2 - 12*D1**2*K*fd*s + 10*D1**2*K*fd - 40*D1**2*K*fdd*r**2 - 76*D1**2*K*fdd*r*s + 10*D1**2*K*fdd*r - 36*D1**2*K*fdd*s**2 + 6*D1**2*K*fdd*s - 5*D1**2*K*fdd - 57*D1**2*bdd1*f*r**2 - 156*D1**2*bdd1*f*r*s + 90*D1**2*bdd1*f*r - 99*D1**2*bdd1*f*s**2 + 118*D1**2*bdd1*f*s - 52*D1**2*bdd1*f - 42*D1**2*bdd1*r**2 - 42*D1**2*bdd1*r*s + 42*D1**2*bdd1*r + 14*D1**2*bdd1*s - 14*D1**2*bdd1 + 7*D1**2*bdd2*r**2 + 14*D1**2*bdd2*r*s - 14*D1**2*bdd2*r + 7*D1**2*bdd2*s**2 - 14*D1**2*bdd2*s + 7*D1**2*bdd2 - 12*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 14*D1**2*f*fd*r + 28*D1**2*f*fd*s**2 - 38*D1**2*f*fd*s + 22*D1**2*f*fd - 40*D1**2*f*fdd*r*s + 22*D1**2*f*fdd*r - 40*D1**2*f*fdd*s**2 + 50*D1**2*f*fdd*s - 26*D1**2*f*fdd - 40*D1**2*fd**2*r*s + 22*D1**2*fd**2*r - 40*D1**2*fd**2*s**2 + 50*D1**2*fd**2*s - 10*D1**2*fd**2 - 41*D1**2*fd*r**2 - 22*D1**2*fd*r*s + 64*D1**2*fd*r + 19*D1**2*fd*s**2 + 18*D1**2*fd*s - 11*D1**2*fd - 4*D1**2*fdd*r**2 - 10*D1**2*fdd*r*s - 4*D1**2*fdd*r - 6*D1**2*fdd*s**2 - 2*D1**2*fdd*s + 2*D1**2*fdd + 140*D1**2*gd2*r**2 + 168*D1**2*gd2*r*s - 168*D1**2*gd2*r + 28*D1**2*gd2*s**2 - 56*D1**2*gd2*s + 28*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 84*D1**2*gdd2*r*s + 84*D1**2*gdd2*r - 14*D1**2*gdd2*s**2 + 28*D1**2*gdd2*s - 14*D1**2*gdd2 + 124*D1*Dd*K*f*r**2 + 216*D1*Dd*K*f*r*s - 170*D1*Dd*K*f*r + 92*D1*Dd*K*f*s**2 - 146*D1*Dd*K*f*s + 77*D1*Dd*K*f - 320*D1*Dd*K*fd*r**2 - 608*D1*Dd*K*fd*r*s + 272*D1*Dd*K*fd*r - 288*D1*Dd*K*fd*s**2 + 244*D1*Dd*K*fd*s - 22*D1*Dd*K*fd - 56*D1*Dd*b2*r**2 - 112*D1*Dd*b2*r*s + 84*D1*Dd*b2*r - 56*D1*Dd*b2*s**2 + 84*D1*Dd*b2*s - 42*D1*Dd*b2 - 24*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r + 56*D1*Dd*f**2*s**2 - 64*D1*Dd*f**2*s + 22*D1*Dd*f**2 - 320*D1*Dd*f*fd*r*s + 168*D1*Dd*f*fd*r - 320*D1*Dd*f*fd*s**2 + 400*D1*Dd*f*fd*s - 122*D1*Dd*f*fd - 164*D1*Dd*f*r**2 - 88*D1*Dd*f*r*s + 126*D1*Dd*f*r + 76*D1*Dd*f*s**2 - 54*D1*Dd*f*s - 3*D1*Dd*f - 32*D1*Dd*fd*r**2 - 80*D1*Dd*fd*r*s + 12*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 + 26*D1*Dd*fd*s + 8*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 672*D1*Dd*g2*r*s - 616*D1*Dd*g2*r + 112*D1*Dd*g2*s**2 - 280*D1*Dd*g2*s + 196*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 672*D1*Dd*gd2*r*s + 644*D1*Dd*gd2*r - 112*D1*Dd*gd2*s**2 + 252*D1*Dd*gd2*s - 140*D1*Dd*gd2 - 160*D1*Ddd*K*f*r**2 - 304*D1*Ddd*K*f*r*s + 232*D1*Ddd*K*f*r - 144*D1*Ddd*K*f*s**2 + 220*D1*Ddd*K*f*s - 112*D1*Ddd*K*f + 28*D1*Ddd*b2*r**2 + 56*D1*Ddd*b2*r*s - 42*D1*Ddd*b2*r + 28*D1*Ddd*b2*s**2 - 42*D1*Ddd*b2*s + 21*D1*Ddd*b2 - 80*D1*Ddd*f**2*r*s + 40*D1*Ddd*f**2*r - 80*D1*Ddd*f**2*s**2 + 100*D1*Ddd*f**2*s - 40*D1*Ddd*f**2 - 16*D1*Ddd*f*r**2 - 40*D1*Ddd*f*r*s + 28*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 34*D1*Ddd*f*s - 16*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 336*D1*Ddd*g2*r*s + 308*D1*Ddd*g2*r - 56*D1*Ddd*g2*s**2 + 140*D1*Ddd*g2*s - 98*D1*Ddd*g2 + D1*bd1*(D1*f*(9*r**2 + r*(60*s - 26) + 51*s**2 - 54*s + 20) - 2*D1*(7*K*(15*r**2 + 2*r*(9*s - 8) + 3*s**2 - 8*s + 6) + fd*(57*r**2 + 3*r*(52*s - 41) + 99*s**2 - 158*s + 59) - 42*r**2 - 42*r*s + 42*r + 14*s - 14) - 2*Dd*f*(228*r**2 + r*(624*s - 393) + 396*s**2 - 512*s + 163) + 14*Dd*(K*(60*r**2 + r*(72*s - 65) + 12*s**2 - 31*s + 16) - 24*r**2 - 24*r*(s - 1) + 7*s - 5)) - 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 480*Dd**2*K*f*r**2 - 912*Dd**2*K*f*r*s + 696*Dd**2*K*f*r - 432*Dd**2*K*f*s**2 + 660*Dd**2*K*f*s - 224*Dd**2*K*f + 84*Dd**2*b2*r**2 + 168*Dd**2*b2*r*s - 126*Dd**2*b2*r + 84*Dd**2*b2*s**2 - 126*Dd**2*b2*s + 42*Dd**2*b2 - 240*Dd**2*f**2*r*s + 120*Dd**2*f**2*r - 240*Dd**2*f**2*s**2 + 300*Dd**2*f**2*s - 80*Dd**2*f**2 - 48*Dd**2*f*r**2 - 120*Dd**2*f*r*s + 84*Dd**2*f*r - 72*Dd**2*f*s**2 + 102*Dd**2*f*s - 32*Dd**2*f - 840*Dd**2*g2*r**2 - 1008*Dd**2*g2*r*s + 924*Dd**2*g2*r - 168*Dd**2*g2*s**2 + 420*Dd**2*g2*s - 196*Dd**2*g2) + b1*(660*C*D1**2*f*fd*r**2 + 792*C*D1**2*f*fd*r*s - 1056*C*D1**2*f*fd*r + 132*C*D1**2*f*fd*s**2 - 528*C*D1**2*f*fd*s + 396*C*D1**2*f*fd + 1320*C*D1*Dd*f**2*r**2 + 1584*C*D1*Dd*f**2*r*s - 1452*C*D1*Dd*f**2*r + 264*C*D1*Dd*f**2*s**2 - 660*C*D1*Dd*f**2*s + 462*C*D1*Dd*f**2 + 2640*D1**2*K*bdd1*f*r**2 + 5016*D1**2*K*bdd1*f*r*s - 4818*D1**2*K*bdd1*f*r + 2376*D1**2*K*bdd1*f*s**2 - 4686*D1**2*K*bdd1*f*s + 2343*D1**2*K*bdd1*f - 330*D1**2*K*f*fd*r**2 - 132*D1**2*K*f*fd*r*s + 330*D1**2*K*f*fd*r + 198*D1**2*K*f*fd*s**2 + 66*D1**2*K*f*fd*s - 165*D1**2*K*f*fd - 330*D1**2*K*f*fdd*r**2 - 660*D1**2*K*f*fdd*r*s + 330*D1**2*K*f*fdd*r - 330*D1**2*K*f*fdd*s**2 + 330*D1**2*K*f*fdd*s - 165*D1**2*K*f*fdd - 330*D1**2*K*fd**2*r**2 - 660*D1**2*K*fd**2*r*s + 330*D1**2*K*fd**2*r - 330*D1**2*K*fd**2*s**2 + 330*D1**2*K*fd**2*s + 66*D1**2*bd1**2*(-7*K*(15*r**2 + 2*r*(9*s - 8) + 3*s**2 - 8*s + 3) + f*(57*r**2 + 6*r*(26*s - 15) + 99*s**2 - 118*s + 26) + 42*r**2 + 42*r*s - 42*r - 14*s + 7) - 759*D1**2*bd2*f*r**2 - 1518*D1**2*bd2*f*r*s + 1518*D1**2*bd2*f*r - 759*D1**2*bd2*f*s**2 + 1518*D1**2*bd2*f*s - 759*D1**2*bd2*f + 2376*D1**2*bd2*fd*r**2 + 4752*D1**2*bd2*fd*r*s - 2442*D1**2*bd2*fd*r + 2376*D1**2*bd2*fd*s**2 - 2442*D1**2*bd2*fd*s + 66*D1**2*bd2*fd + 1320*D1**2*bdd1*f**2*r*s - 594*D1**2*bdd1*f**2*r + 1320*D1**2*bdd1*f**2*s**2 - 1650*D1**2*bdd1*f**2*s + 462*D1**2*bdd1*f**2 + 264*D1**2*bdd1*f*r**2 + 660*D1**2*bdd1*f*r*s - 726*D1**2*bdd1*f*r + 396*D1**2*bdd1*f*s**2 - 792*D1**2*bdd1*f*s + 396*D1**2*bdd1*f + 4620*D1**2*bdd1*g2*r**2 + 5544*D1**2*bdd1*g2*r*s - 4620*D1**2*bdd1*g2*r + 924*D1**2*bdd1*g2*s**2 - 2772*D1**2*bdd1*g2*s + 2310*D1**2*bdd1*g2 + 1188*D1**2*bdd2*f*r**2 + 2376*D1**2*bdd2*f*r*s - 2376*D1**2*bdd2*f*r + 1188*D1**2*bdd2*f*s**2 - 2376*D1**2*bdd2*f*s + 1188*D1**2*bdd2*f - 645*D1**2*f**2*fd*r**2 - 2724*D1**2*f**2*fd*r*s + 1730*D1**2*f**2*fd*r - 2079*D1**2*f**2*fd*s**2 + 2888*D1**2*f**2*fd*s - 1205*D1**2*f**2*fd + 1263*D1**2*f**2*fdd*r**2 + 3936*D1**2*f**2*fdd*r*s - 2614*D1**2*f**2*fdd*r + 2673*D1**2*f**2*fdd*s**2 - 3820*D1**2*f**2*fdd*s + 1675*D1**2*f**2*fdd + 2526*D1**2*f*fd**2*r**2 + 7872*D1**2*f*fd**2*r*s - 5228*D1**2*f*fd**2*r + 5346*D1**2*f*fd**2*s**2 - 7640*D1**2*f*fd**2*s + 2498*D1**2*f*fd**2 - 1122*D1**2*f*fd*r**2 - 1848*D1**2*f*fd*r*s + 1452*D1**2*f*fd*r - 726*D1**2*f*fd*s**2 + 1056*D1**2*f*fd*s - 660*D1**2*f*fd + 396*D1**2*f*fdd*r**2 + 792*D1**2*f*fdd*r*s - 396*D1**2*f*fdd*r + 396*D1**2*f*fdd*s**2 - 396*D1**2*f*fdd*s + 198*D1**2*f*fdd + 2046*D1**2*f*gd2*r**2 + 3564*D1**2*f*gd2*r*s - 3564*D1**2*f*gd2*r + 1518*D1**2*f*gd2*s**2 - 3036*D1**2*f*gd2*s + 1518*D1**2*f*gd2 - 2640*D1**2*f*gdd2*r**2 - 5016*D1**2*f*gdd2*r*s + 5016*D1**2*f*gdd2*r - 2376*D1**2*f*gdd2*s**2 + 4752*D1**2*f*gdd2*s - 2376*D1**2*f*gdd2 + 396*D1**2*fd**2*r**2 + 792*D1**2*fd**2*r*s - 396*D1**2*fd**2*r + 396*D1**2*fd**2*s**2 - 396*D1**2*fd**2*s + 2046*D1**2*fd*g2*r**2 + 3564*D1**2*fd*g2*r*s - 1320*D1**2*fd*g2*r + 1518*D1**2*fd*g2*s**2 - 792*D1**2*fd*g2*s + 660*D1**2*fd*g2 - 5280*D1**2*fd*gd2*r**2 - 10032*D1**2*fd*gd2*r*s + 5676*D1**2*fd*gd2*r - 4752*D1**2*fd*gd2*s**2 + 5148*D1**2*fd*gd2*s - 396*D1**2*fd*gd2 - 2640*D1**2*fdd*g2*r**2 - 5016*D1**2*fdd*g2*r*s + 660*D1**2*fdd*g2*r - 2376*D1**2*fdd*g2*s**2 + 396*D1**2*fdd*g2*s - 330*D1**2*fdd*g2 - 660*D1*Dd*K*f**2*r**2 - 264*D1*Dd*K*f**2*r*s + 462*D1*Dd*K*f**2*r + 396*D1*Dd*K*f**2*s**2 - 330*D1*Dd*K*f**2*s + 33*D1*Dd*K*f**2 - 2640*D1*Dd*K*f*fd*r**2 - 5280*D1*Dd*K*f*fd*r*s + 3300*D1*Dd*K*f*fd*r - 2640*D1*Dd*K*f*fd*s**2 + 3300*D1*Dd*K*f*fd*s - 990*D1*Dd*K*f*fd + 9504*D1*Dd*bd2*f*r**2 + 19008*D1*Dd*bd2*f*r*s - 16632*D1*Dd*bd2*f*r + 9504*D1*Dd*bd2*f*s**2 - 16632*D1*Dd*bd2*f*s + 7128*D1*Dd*bd2*f - 860*D1*Dd*f**3*r**2 - 3632*D1*Dd*f**3*r*s + 2246*D1*Dd*f**3*r - 2772*D1*Dd*f**3*s**2 + 3680*D1*Dd*f**3*s - 1601*D1*Dd*f**3 + 10104*D1*Dd*f**2*fd*r**2 + 31488*D1*Dd*f**2*fd*r*s - 20854*D1*Dd*f**2*fd*r + 21384*D1*Dd*f**2*fd*s**2 - 29908*D1*Dd*f**2*fd*s + 10254*D1*Dd*f**2*fd - 2244*D1*Dd*f**2*r**2 - 3696*D1*Dd*f**2*r*s + 2970*D1*Dd*f**2*r - 1452*D1*Dd*f**2*s**2 + 2376*D1*Dd*f**2*s - 1287*D1*Dd*f**2 + 3168*D1*Dd*f*fd*r**2 + 6336*D1*Dd*f*fd*r*s - 3960*D1*Dd*f*fd*r + 3168*D1*Dd*f*fd*s**2 - 3960*D1*Dd*f*fd*s + 1188*D1*Dd*f*fd + 8184*D1*Dd*f*g2*r**2 + 14256*D1*Dd*f*g2*r*s - 11220*D1*Dd*f*g2*r + 6072*D1*Dd*f*g2*s**2 - 9636*D1*Dd*f*g2*s + 5082*D1*Dd*f*g2 - 21120*D1*Dd*f*gd2*r**2 - 40128*D1*Dd*f*gd2*r*s + 35376*D1*Dd*f*gd2*r - 19008*D1*Dd*f*gd2*s**2 + 33528*D1*Dd*f*gd2*s - 14520*D1*Dd*f*gd2 - 21120*D1*Dd*fd*g2*r**2 - 40128*D1*Dd*fd*g2*r*s + 17952*D1*Dd*fd*g2*r - 19008*D1*Dd*fd*g2*s**2 + 16104*D1*Dd*fd*g2*s - 1452*D1*Dd*fd*g2 - 660*D1*Ddd*K*f**2*r**2 - 1320*D1*Ddd*K*f**2*r*s + 990*D1*Ddd*K*f**2*r - 660*D1*Ddd*K*f**2*s**2 + 990*D1*Ddd*K*f**2*s - 495*D1*Ddd*K*f**2 + 1684*D1*Ddd*f**3*r**2 + 5248*D1*Ddd*f**3*r*s - 3466*D1*Ddd*f**3*r + 3564*D1*Ddd*f**3*s**2 - 4876*D1*Ddd*f**3*s + 2203*D1*Ddd*f**3 + 792*D1*Ddd*f**2*r**2 + 1584*D1*Ddd*f**2*r*s - 1188*D1*Ddd*f**2*r + 792*D1*Ddd*f**2*s**2 - 1188*D1*Ddd*f**2*s + 594*D1*Ddd*f**2 - 10560*D1*Ddd*f*g2*r**2 - 20064*D1*Ddd*f*g2*r*s + 15312*D1*Ddd*f*g2*r - 9504*D1*Ddd*f*g2*s**2 + 14520*D1*Ddd*f*g2*s - 7392*D1*Ddd*f*g2 - 33*D1*bd1*(14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-2*f**2*(6*r**2 - r*(8*s + 5) + s*(13 - 14*s)) + f*(14*C*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) + 62*K*r**2 + 108*K*r*s - 96*K*r + 46*K*s**2 - 88*K*s + 44*K - 10*fd*(16*r*s - 8*r + 16*s**2 - 20*s + 5) - 82*r**2 - 44*r*s + 40*r + 38*s**2 - 34*s - 11) - 2*fd*(K*(80*r**2 + r*(152*s - 83) + 72*s**2 - 77*s + 3) + 8*r**2 + r*(20*s - 7) + 12*s**2 - 10*s - 1) + 28*g2*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) - 28*gd2*(10*r**2 + r*(12*s - 11) + 2*s**2 - 5*s + 3)) - 2*Dd*(f**2*(4*r*(40*s - 19) + 160*s**2 - 200*s + 59) + f*(K*(320*r**2 + 608*r*s - 524*r + 288*s**2 - 504*s + 215) + 32*r**2 + 80*r*s - 72*r + 48*s**2 - 82*s + 35) + 14*g2*(40*r**2 + 6*r*(8*s - 7) + 8*s**2 - 22*s + 11))) - 1980*Dd**2*K*f**2*r**2 - 3960*Dd**2*K*f**2*r*s + 2970*Dd**2*K*f**2*r - 1980*Dd**2*K*f**2*s**2 + 2970*Dd**2*K*f**2*s - 990*Dd**2*K*f**2 + 5052*Dd**2*f**3*r**2 + 15744*Dd**2*f**3*r*s - 10398*Dd**2*f**3*r + 10692*Dd**2*f**3*s**2 - 14628*Dd**2*f**3*s + 4406*Dd**2*f**3 + 2376*Dd**2*f**2*r**2 + 4752*Dd**2*f**2*r*s - 3564*Dd**2*f**2*r + 2376*Dd**2*f**2*s**2 - 3564*Dd**2*f**2*s + 1188*Dd**2*f**2 - 31680*Dd**2*f*g2*r**2 - 60192*Dd**2*f*g2*r*s + 45936*Dd**2*f*g2*r - 28512*Dd**2*f*g2*s**2 + 43560*Dd**2*f*g2*s - 14784*Dd**2*f*g2 + 33*b2*(-7*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 23*D1**2*fd*r**2 - 46*D1**2*fd*r*s + 4*D1**2*fd*r - 23*D1**2*fd*s**2 + 4*D1**2*fd*s - 2*D1**2*fd + 36*D1**2*fdd*r**2 + 72*D1**2*fdd*r*s - 2*D1**2*fdd*r + 36*D1**2*fdd*s**2 - 2*D1**2*fdd*s + D1**2*fdd - 92*D1*Dd*f*r**2 - 184*D1*Dd*f*r*s + 138*D1*Dd*f*r - 92*D1*Dd*f*s**2 + 138*D1*Dd*f*s - 69*D1*Dd*f + 288*D1*Dd*fd*r**2 + 576*D1*Dd*fd*r*s - 224*D1*Dd*fd*r + 288*D1*Dd*fd*s**2 - 224*D1*Dd*fd*s + 6*D1*Dd*fd + 144*D1*Ddd*f*r**2 + 288*D1*Ddd*f*r*s - 216*D1*Ddd*f*r + 144*D1*Ddd*f*s**2 - 216*D1*Ddd*f*s + 108*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 432*Dd**2*f*r**2 + 864*Dd**2*f*r*s - 648*Dd**2*f*r + 432*Dd**2*f*s**2 - 648*Dd**2*f*s + 216*Dd**2*f)) - 33*b2*(14*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - D1**2*bdd1*f*(36*r**2 + 72*r*s - 70*r + 36*s**2 - 70*s + 35) + 10*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 10*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + 5*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 10*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s + 20*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 14*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 10*D1*Dd*f**2*s - D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 100*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 100*D1*Dd*f*fd*s + 30*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + D1*bd1*(D1*(f*(23*r**2 + r*(46*s - 42) + 23*s**2 - 42*s + 21) - 72*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(144*r**2 + 8*r*(36*s - 31) + 144*s**2 - 248*s + 105)) + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2))/(1386*d**2*k3**3) + D1**2*Pk1*Pkd3*st**4*(8*C - 4)*(D1**2*bd1**2*f*s*(-2*r - 2*s + 1) + D1*b1*(D1*bdd1*f*s*(-2*r - 2*s + 1) - bd1*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 2*Dd*f*(r*(8*s - 2) + 8*s**2 - 7*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(2*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5)) + Ddd*f*(r*(2 - 4*s) - 4*s**2 + 5*s - 2)) + Dd**2*f*(r*(6 - 12*s) - 12*s**2 + 15*s - 4)))/(7*d**2*k3) + D1**2*Pk1*Pkd3*st**2*(D1*f*(2*D1*bd1**2*(r**2*(14*C - 7) + r*(84*C*s - 14*C - 40*s + 7) + s*(70*C*s - 42*C - 33*s + 20)) - D1*bdd1*f*(r + s)*(r*(2*C - 1) + s*(10*C - 7)) + bd1*(D1*(-f*(r + s)*(r*(2*C - 1) + s*(9 - 14*C)) - 2*fd*(r**2*(4*C - 2) + r*(8*C*(3*s - 1) - 16*s + 5) + s*(4*C*(5*s - 4) - 14*s + 11))) - 2*Dd*f*(r**2*(8*C - 4) + r*(48*C*s - 14*C - 32*s + 9) + 2*s*(20*C*s - 13*C - 14*s + 9)))) + b1**2*(D1**2*(fd*(14*C*(r - 7*s + 7) - 7*r + 31*s - 31) + fdd*(14*C*(r + 5*s - 5) - 7*r - 33*s + 33))*(r + s - 1) + D1*(Dd*(f*(14*C*(4*r**2 - 24*r*s + 10*r - 28*s**2 + 34*s - 13) - 28*r**2 + 96*r*s - 34*r + 124*s**2 - 148*s + 55) + 2*fd*(14*C*(4*r**2 + 24*r*s - 19*r + 20*s**2 - 33*s + 13) - 28*r**2 - 160*r*s + 127*r - 132*s**2 + 218*s - 86)) + Ddd*f*(14*C*(4*r**2 + 24*r*s - 14*r + 20*s**2 - 26*s + 11) - 28*r**2 - 160*r*s + 94*r - 132*s**2 + 172*s - 73)) + 2*Dd**2*f*(14*C*(6*r**2 + 36*r*s - 21*r + 30*s**2 - 39*s + 11) - 42*r**2 - 240*r*s + 141*r - 198*s**2 + 258*s - 73)) + b1*(-4*C*D1**2*f*fd*r**2 + 24*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r + 28*C*D1**2*f*fd*s**2 - 40*C*D1**2*f*fd*s + 12*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r*s + 16*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 32*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r*s + 16*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 32*C*D1**2*fd**2*s - 12*C*D1**2*fd**2 - 8*C*D1*Dd*f**2*r**2 + 48*C*D1*Dd*f**2*r*s - 20*C*D1*Dd*f**2*r + 56*C*D1*Dd*f**2*s**2 - 68*C*D1*Dd*f**2*s + 26*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 - 192*C*D1*Dd*f*fd*r*s + 120*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 232*C*D1*Dd*f*fd*s - 80*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 - 48*C*D1*Ddd*f**2*r*s + 28*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 52*C*D1*Ddd*f**2*s - 22*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 - 144*C*Dd**2*f**2*r*s + 84*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 156*C*Dd**2*f**2*s - 44*C*Dd**2*f**2 + D1**2*bdd1*f*(14*C*(2*r**2 + 12*r*s - 2*r + 10*s**2 - 6*s + 1) - 14*r**2 - 80*r*s + 14*r - 66*s**2 + 40*s - 7) + 2*D1**2*f*fd*r**2 - 16*D1**2*f*fd*r*s + 6*D1**2*f*fd*r - 18*D1**2*f*fd*s**2 + 26*D1**2*f*fd*s - 8*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 16*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r + 14*D1**2*f*fdd*s**2 - 22*D1**2*f*fdd*s + 8*D1**2*f*fdd + 2*D1**2*fd**2*r**2 + 16*D1**2*fd**2*r*s - 10*D1**2*fd**2*r + 14*D1**2*fd**2*s**2 - 22*D1**2*fd**2*s + 8*D1**2*fd**2 + 4*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 14*D1*Dd*f**2*r - 36*D1*Dd*f**2*s**2 + 44*D1*Dd*f**2*s - 17*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 128*D1*Dd*f*fd*r*s - 76*D1*Dd*f*fd*r + 112*D1*Dd*f*fd*s**2 - 160*D1*Dd*f*fd*s + 54*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 + 32*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 28*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + D1*bd1*(D1*(f*(14*C*(2*r**2 - 2*r*(6*s + 1) - 14*s**2 + 6*s + 1) - 14*r**2 + 48*r*s + 14*r + 62*s**2 - 24*s - 7) + 2*fd*(14*C*(2*r**2 + 12*r*s - 7*r + 10*s**2 - 13*s + 3) - 14*r**2 - 80*r*s + 47*r - 66*s**2 + 86*s - 20)) + 2*Dd*f*(14*C*(8*r**2 + 6*r*(8*s - 3) + 40*s**2 - 38*s + 7) - 56*r**2 - 320*r*s + 122*r - 264*s**2 + 252*s - 47)) + 12*Dd**2*f**2*r**2 + 96*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 84*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 30*Dd**2*f**2))/(42*d**2*k3) - D1**2*Pk1*Pkd3*(D1*(-2*D1*bd1**2*f*(-11*K*r**2 + r*(2*s - 1)*(-9*K + 6*f + 6) + s*(s - 1)*(-7*K + 12*f + 12)) + D1*bdd1*f*(b2 - 2*g2)*(11*r**2 + 18*r*s + 7*s**2) + bd1*(D1*b2*(f*(-r**2 + 6*r*s + 7*s**2) + 2*fd*(11*r**2 + r*(18*s - 11) + s*(7*s - 9))) + 2*D1*bd2*f*(11*r**2 + 9*r*(2*s - 1) + s*(7*s - 7)) - 2*D1*(f*(g2*(-r**2 + 6*r*s + 7*s**2) + 2*gd2*(11*r**2 + 9*r*(2*s - 1) + s*(7*s - 7))) + 2*fd*g2*(11*r**2 + r*(18*s - 11) + s*(7*s - 9))) + 2*Dd*b2*f*(44*r**2 + r*(72*s - 29) + s*(28*s - 23)) - 4*Dd*f*g2*(44*r**2 + r*(72*s - 29) + s*(28*s - 23)))) + 14*b1**3*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*(f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + fd*(-8*r*s + 6*r - 8*s**2 + 13*s - 5) + 8*r*s - 4*r + 8*s**2 - 10*s + 4) - Ddd*(f + 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 2)) - Dd**2*(f + 1)*(6*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + b1**2*(-D1**2*K*fd*r**2 + 6*D1**2*K*fd*r*s + 2*D1**2*K*fd*r + 7*D1**2*K*fd*s**2 - 6*D1**2*K*fd*s - D1**2*K*fd + 11*D1**2*K*fdd*r**2 + 18*D1**2*K*fdd*r*s - 22*D1**2*K*fdd*r + 7*D1**2*K*fdd*s**2 - 18*D1**2*K*fdd*s + 11*D1**2*K*fdd - 14*D1**2*bdd1*(f + 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 24*D1**2*f*fd*r*s - 12*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s + 12*D1**2*f*fd - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 24*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 12*D1**2*f*fdd - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 24*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s - 12*D1**2*fd**2 + 10*D1**2*fd*r*s + 10*D1**2*fd*s**2 - 10*D1**2*fd*s - 12*D1**2*fdd*r*s - 12*D1**2*fdd*s**2 + 12*D1**2*fdd*s - 4*D1*Dd*K*f*r**2 + 24*D1*Dd*K*f*r*s - 10*D1*Dd*K*f*r + 28*D1*Dd*K*f*s**2 - 34*D1*Dd*K*f*s + 13*D1*Dd*K*f + 88*D1*Dd*K*fd*r**2 + 144*D1*Dd*K*fd*r*s - 146*D1*Dd*K*fd*r + 56*D1*Dd*K*fd*s**2 - 118*D1*Dd*K*fd*s + 58*D1*Dd*K*fd + 48*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 60*D1*Dd*f**2*s + 24*D1*Dd*f**2 - 192*D1*Dd*f*fd*r*s + 96*D1*Dd*f*fd*r - 192*D1*Dd*f*fd*s**2 + 264*D1*Dd*f*fd*s - 84*D1*Dd*f*fd + 40*D1*Dd*f*r*s - 20*D1*Dd*f*r + 40*D1*Dd*f*s**2 - 50*D1*Dd*f*s + 20*D1*Dd*f - 96*D1*Dd*fd*r*s + 24*D1*Dd*fd*r - 96*D1*Dd*fd*s**2 + 108*D1*Dd*fd*s - 24*D1*Dd*fd + 44*D1*Ddd*K*f*r**2 + 72*D1*Ddd*K*f*r*s - 58*D1*Ddd*K*f*r + 28*D1*Ddd*K*f*s**2 - 46*D1*Ddd*K*f*s + 25*D1*Ddd*K*f - 48*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r - 48*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 24*D1*Ddd*f**2 - 48*D1*Ddd*f*r*s + 24*D1*Ddd*f*r - 48*D1*Ddd*f*s**2 + 60*D1*Ddd*f*s - 24*D1*Ddd*f + 14*D1*bd1*(D1*(f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd*(-6*r*s + 4*r - 6*s**2 + 9*s - 3) + 6*r*s - 2*r + 6*s**2 - 6*s + 2) - Dd*(f + 1)*(2*r*(12*s - 5) + 24*s**2 - 27*s + 7)) + 132*Dd**2*K*f*r**2 + 216*Dd**2*K*f*r*s - 174*Dd**2*K*f*r + 84*Dd**2*K*f*s**2 - 138*Dd**2*K*f*s + 50*Dd**2*K*f - 144*Dd**2*f**2*r*s + 72*Dd**2*f**2*r - 144*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 48*Dd**2*f**2 - 144*Dd**2*f*r*s + 72*Dd**2*f*r - 144*Dd**2*f*s**2 + 180*Dd**2*f*s - 48*Dd**2*f) - b1*(-22*D1**2*K*bdd1*f*r**2 - 36*D1**2*K*bdd1*f*r*s + 18*D1**2*K*bdd1*f*r - 14*D1**2*K*bdd1*f*s**2 + 14*D1**2*K*bdd1*f*s - 7*D1**2*K*bdd1*f + D1**2*b2*fd*r**2 - 6*D1**2*b2*fd*r*s - 2*D1**2*b2*fd*r - 7*D1**2*b2*fd*s**2 + 6*D1**2*b2*fd*s + D1**2*b2*fd - 11*D1**2*b2*fdd*r**2 - 18*D1**2*b2*fdd*r*s + 22*D1**2*b2*fdd*r - 7*D1**2*b2*fdd*s**2 + 18*D1**2*b2*fdd*s - 11*D1**2*b2*fdd + 14*D1**2*bd1**2*(f + 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 24*D1**2*bdd1*f**2*r*s - 12*D1**2*bdd1*f**2*r + 24*D1**2*bdd1*f**2*s**2 - 24*D1**2*bdd1*f**2*s + 12*D1**2*bdd1*f**2 + 24*D1**2*bdd1*f*r*s - 12*D1**2*bdd1*f*r + 24*D1**2*bdd1*f*s**2 - 24*D1**2*bdd1*f*s + 12*D1**2*bdd1*f - 11*D1**2*bdd2*f*r**2 - 18*D1**2*bdd2*f*r*s + 18*D1**2*bdd2*f*r - 7*D1**2*bdd2*f*s**2 + 14*D1**2*bdd2*f*s - 7*D1**2*bdd2*f - 2*D1**2*f*gd2*r**2 + 12*D1**2*f*gd2*r*s - 12*D1**2*f*gd2*r + 14*D1**2*f*gd2*s**2 - 28*D1**2*f*gd2*s + 14*D1**2*f*gd2 + 22*D1**2*f*gdd2*r**2 + 36*D1**2*f*gdd2*r*s - 36*D1**2*f*gdd2*r + 14*D1**2*f*gdd2*s**2 - 28*D1**2*f*gdd2*s + 14*D1**2*f*gdd2 - 2*D1**2*fd*g2*r**2 + 12*D1**2*fd*g2*r*s + 4*D1**2*fd*g2*r + 14*D1**2*fd*g2*s**2 - 12*D1**2*fd*g2*s - 2*D1**2*fd*g2 + 44*D1**2*fd*gd2*r**2 + 72*D1**2*fd*gd2*r*s - 80*D1**2*fd*gd2*r + 28*D1**2*fd*gd2*s**2 - 64*D1**2*fd*gd2*s + 36*D1**2*fd*gd2 + 22*D1**2*fdd*g2*r**2 + 36*D1**2*fdd*g2*r*s - 44*D1**2*fdd*g2*r + 14*D1**2*fdd*g2*s**2 - 36*D1**2*fdd*g2*s + 22*D1**2*fdd*g2 + 4*D1*Dd*b2*f*r**2 - 24*D1*Dd*b2*f*r*s + 10*D1*Dd*b2*f*r - 28*D1*Dd*b2*f*s**2 + 34*D1*Dd*b2*f*s - 13*D1*Dd*b2*f - 88*D1*Dd*b2*fd*r**2 - 144*D1*Dd*b2*fd*r*s + 146*D1*Dd*b2*fd*r - 56*D1*Dd*b2*fd*s**2 + 118*D1*Dd*b2*fd*s - 58*D1*Dd*b2*fd - 8*D1*Dd*f*g2*r**2 + 48*D1*Dd*f*g2*r*s - 20*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s**2 - 68*D1*Dd*f*g2*s + 26*D1*Dd*f*g2 + 176*D1*Dd*f*gd2*r**2 + 288*D1*Dd*f*gd2*r*s - 260*D1*Dd*f*gd2*r + 112*D1*Dd*f*gd2*s**2 - 204*D1*Dd*f*gd2*s + 92*D1*Dd*f*gd2 + 176*D1*Dd*fd*g2*r**2 + 288*D1*Dd*fd*g2*r*s - 292*D1*Dd*fd*g2*r + 112*D1*Dd*fd*g2*s**2 - 236*D1*Dd*fd*g2*s + 116*D1*Dd*fd*g2 - 44*D1*Ddd*b2*f*r**2 - 72*D1*Ddd*b2*f*r*s + 58*D1*Ddd*b2*f*r - 28*D1*Ddd*b2*f*s**2 + 46*D1*Ddd*b2*f*s - 25*D1*Ddd*b2*f + 88*D1*Ddd*f*g2*r**2 + 144*D1*Ddd*f*g2*r*s - 116*D1*Ddd*f*g2*r + 56*D1*Ddd*f*g2*s**2 - 92*D1*Ddd*f*g2*s + 50*D1*Ddd*f*g2 - D1*bd1*(D1*(12*f**2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + f*(K*(-2*r**2 + 12*r*s - 6*r + 14*s**2 - 14*s + 7) - 12*fd*(2*s - 1)*(4*r + 4*s - 3) + 20*r*s - 10*r + 20*s**2 - 20*s + 10) + 2*fd*(K*(22*r**2 + r*(36*s - 31) + 14*s**2 - 25*s + 9) - 6*r*(4*s - 1) - 6*(1 - 2*s)**2)) - 2*Dd*f*(-K*(88*r**2 + 144*r*s - 94*r + 56*s**2 - 74*s + 23) + 6*f*(2*s - 1)*(8*r + 8*s - 5) + (12*s - 6)*(8*r + 8*s - 5))) + D1*bd2*(D1*(f*(r - 7*s + 7) - 2*fd*(11*r + 7*s - 9))*(r + s - 1) - 2*Dd*f*(44*r**2 + r*(72*s - 65) + 28*s**2 - 51*s + 23)) - 132*Dd**2*b2*f*r**2 - 216*Dd**2*b2*f*r*s + 174*Dd**2*b2*f*r - 84*Dd**2*b2*f*s**2 + 138*Dd**2*b2*f*s - 50*Dd**2*b2*f + 264*Dd**2*f*g2*r**2 + 432*Dd**2*f*g2*r*s - 348*Dd**2*f*g2*r + 168*Dd**2*f*g2*s**2 - 276*Dd**2*f*g2*s + 100*Dd**2*f*g2))/(21*d**2*k3) + 5*D1**2*Pk1*Pkd3*k2**4*st**6*(132*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 33*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 6*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r - 2*D1**2*f**2*fd*s + 2*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 3*D1**2*f**2*fdd*r*s + 3*D1**2*f**2*fdd*r + D1**2*f**2*fdd*s - D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 6*D1**2*f*fd**2*r*s + 6*D1**2*f*fd**2*r + 2*D1**2*f*fd**2*s - D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r - 66*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 396*D1*Dd*b1*f*fd*r + 66*D1*Dd*b1*f*fd*s - 33*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 8*D1*Dd*f**3*r - 2*D1*Dd*f**3*s + 2*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 24*D1*Dd*f**2*fd*r*s + 24*D1*Dd*f**2*fd*r + 7*D1*Dd*f**2*fd*s - 5*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 4*D1*Ddd*f**3*r*s + 4*D1*Ddd*f**3*r + D1*Ddd*f**3*s - D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r + 99*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 12*Dd**2*f**3*r*s + 12*Dd**2*f**3*r + 3*Dd**2*f**3*s - 2*Dd**2*f**3)/(693*d**2*k1**2*k3**3) + 2*D1**2*Pk1*Pkd3*k2**4*st**4*(D1*f*(-33*D1*bd1**2*(f*(4*r**2 + r*(4*s - 5) - 2*s + 1) + (2*r - 1)*(r + s - 1)) - 4*D1*bdd1*f**2*r*(2*r + 2*s - 1) + bd1*f*(D1*(fd*(-48*r**2 - 8*r*(6*s - 5) + 8*s - 4) + r**2*(16*f - 33) + r*(16*f*s - 8*f - 33*s + 66) + 33*s - 33) - 4*Dd*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1))) + 33*b1**2*(-D1**2*r*(-f*(fd - fdd)*(4*r + 4*s - 3) + fd**2*(4*r + 4*s - 3) - 2*fd*(r + s) + fdd*(r + s)) + D1*(Dd*(f**2*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + f*(-fd*(8*r - 1)*(4*r + 4*s - 3) + 8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-8*r**2 + r*(4 - 8*s) + s)) - Ddd*f*(2*f + 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(2*f + 1)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(33*D1*bd1*(D1*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(-fd*(4*r - 1)*(4*r + 4*s - 3) + (4*r - 2)*(r + s - 1)) + fd*(-4*r**2 + r*(3 - 4*s) + s)) - Dd*f*(f*(8*r - 3)*(4*r + 4*s - 3) + 16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + f*(-33*D1**2*bdd1*(f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + (2*r - 1)*(r + s - 1)) + D1**2*(4*f*(2*fd - fdd)*(6*r**2 + r*(6*s - 7) - 2*s + 2) - fd*(4*fd*(12*r**2 + 2*r*(6*s - 7) - 4*s + 3) + 33*r*(2*r + 2*s - 1))) + D1*f*(Dd*(16*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 4*fd*(48*r**2 + r*(48*s - 52) - 14*s + 11) - 132*r**2 - 132*r*(s - 1) + 33*s - 33) - 8*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 8*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2))))/(231*d**2*k1**2*k3**3) + 2*D1**2*Pk1*Pkd3*k2**2*st**4*(D1**2*bd1**2*f*(-2*r**2 - 2*r*(s - 1) + s) + D1*b1*(D1*bdd1*f*(-2*r**2 - 2*r*(s - 1) + s - 1) + bd1*(D1*(f*(4*r**2 + 4*r*(s - 1) - 2*s + 2) + fd*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + b1**2*(D1**2*r*(2*fd - fdd)*(r + s - 1) + D1*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-8*r**2 - 8*r*(s - 1) + s - 1)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)))/(7*d**2*k1**2*k3) + D1**2*Pk1*Pkd3*k2**2*st**2*(D1**2*bd1*f*r*(-bd1*(f - 1)*(2*r + 2*s - 1) + f*(r + s)) + D1*b1*(-D1*bd1**2*(9*f + 7)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + bd1*(D1*(5*f**2*r*(2*r + 2*s - 1) - f*(fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + 18*r**2 + 2*r*(9*s - 8) - 7*s + 7) + fd*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(f - 1)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1)) + f*(D1*(-bdd1*r*(f - 1)*(2*r + 2*s - 1) + fd*(2*r - 1)*(r + s - 1)) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1))) + b1**3*(D1**2*r*(11*fd - 9*fdd)*(r + s - 1) + D1*(Dd*(11*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 9*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + 56*r**2 + 56*r*(s - 1) - 14*s + 14) - Ddd*(9*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(9*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(-D1**2*bdd1*(9*f + 7)*(3*r**2 + 3*r*(s - 1) - s + 1) + 10*D1**2*f*fd*r**2 + 10*D1**2*f*fd*r*s - 15*D1**2*f*fd*r - 5*D1**2*f*fd*s + 5*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 2*D1**2*fd**2*r*s + 3*D1**2*fd**2*r + D1**2*fd**2*s - D1**2*fd**2 - 9*D1**2*fd*r**2 - 9*D1**2*fd*r*s + 11*D1**2*fd*r + 2*D1**2*fd*s - 2*D1**2*fd + D1**2*fdd*r**2 + D1**2*fdd*r*s - 2*D1**2*fdd*r - D1**2*fdd*s + D1**2*fdd + 20*D1*Dd*f**2*r**2 + 20*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r - 5*D1*Dd*f**2*s + 5*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 16*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r + 6*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 36*D1*Dd*f*r**2 - 36*D1*Dd*f*r*s + 36*D1*Dd*f*r + 9*D1*Dd*f*s - 9*D1*Dd*f + 8*D1*Dd*fd*r**2 + 8*D1*Dd*fd*r*s - 12*D1*Dd*fd*r - 5*D1*Dd*fd*s + 4*D1*Dd*fd - 4*D1*Ddd*f**2*r**2 - 4*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r + D1*Ddd*f**2*s - D1*Ddd*f**2 + 4*D1*Ddd*f*r**2 + 4*D1*Ddd*f*r*s - 4*D1*Ddd*f*r - D1*Ddd*f*s + D1*Ddd*f + D1*bd1*(D1*(11*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 9*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + 42*r**2 + 42*r*(s - 1) - 14*s + 14) - Dd*(9*f + 7)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 12*Dd**2*f**2*r**2 - 12*Dd**2*f**2*r*s + 12*Dd**2*f**2*r + 3*Dd**2*f**2*s - 2*Dd**2*f**2 + 12*Dd**2*f*r**2 + 12*Dd**2*f*r*s - 12*Dd**2*f*r - 3*Dd**2*f*s + 2*Dd**2*f))/(21*d**2*k1**2*k3) - D1**2*Pk1*Pkdd3*ct**8*k2**6*(10*C - 10)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 168*D1**2*f**2*fd*r**2 + 336*D1**2*f**2*fd*r*s - 224*D1**2*f**2*fd*r + 168*D1**2*f**2*fd*s**2 - 224*D1**2*f**2*fd*s + 112*D1**2*f**2*fd - 84*D1**2*f**2*fdd*r**2 - 168*D1**2*f**2*fdd*r*s + 112*D1**2*f**2*fdd*r - 84*D1**2*f**2*fdd*s**2 + 112*D1**2*f**2*fdd*s - 56*D1**2*f**2*fdd - 168*D1**2*f*fd**2*r**2 - 336*D1**2*f*fd**2*r*s + 224*D1**2*f*fd**2*r - 168*D1**2*f*fd**2*s**2 + 224*D1**2*f*fd**2*s - 56*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 224*D1*Dd*f**3*r**2 + 448*D1*Dd*f**3*r*s - 336*D1*Dd*f**3*r + 224*D1*Dd*f**3*s**2 - 336*D1*Dd*f**3*s + 168*D1*Dd*f**3 - 672*D1*Dd*f**2*fd*r**2 - 1344*D1*Dd*f**2*fd*r*s + 952*D1*Dd*f**2*fd*r - 672*D1*Dd*f**2*fd*s**2 + 952*D1*Dd*f**2*fd*s - 336*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 112*D1*Ddd*f**3*r**2 - 224*D1*Ddd*f**3*r*s + 168*D1*Ddd*f**3*r - 112*D1*Ddd*f**3*s**2 + 168*D1*Ddd*f**3*s - 84*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 336*Dd**2*f**3*r**2 - 672*Dd**2*f**3*r*s + 504*Dd**2*f**3*r - 336*Dd**2*f**3*s**2 + 504*Dd**2*f**3*s - 168*Dd**2*f**3)/(693*d**2*k3**6) - 5*D1**2*Pk1*Pkdd3*ct**7*f*k2**7*(312*D1**2*b1*f*fd*r**2 + 624*D1**2*b1*f*fd*r*s - 416*D1**2*b1*f*fd*r + 312*D1**2*b1*f*fd*s**2 - 416*D1**2*b1*f*fd*s + 208*D1**2*b1*f*fd - 156*D1**2*b1*f*fdd*r**2 - 312*D1**2*b1*f*fdd*r*s + 208*D1**2*b1*f*fdd*r - 156*D1**2*b1*f*fdd*s**2 + 208*D1**2*b1*f*fdd*s - 104*D1**2*b1*f*fdd - 312*D1**2*b1*fd**2*r**2 - 624*D1**2*b1*fd**2*r*s + 416*D1**2*b1*fd**2*r - 312*D1**2*b1*fd**2*s**2 + 416*D1**2*b1*fd**2*s - 104*D1**2*b1*fd**2 - 52*D1**2*bdd1*f**2*(r + s - 1)**2 + 360*D1**2*f**2*fd*r**2 + 720*D1**2*f**2*fd*r*s - 540*D1**2*f**2*fd*r + 360*D1**2*f**2*fd*s**2 - 540*D1**2*f**2*fd*s + 270*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r**2 - 360*D1**2*f**2*fdd*r*s + 270*D1**2*f**2*fdd*r - 180*D1**2*f**2*fdd*s**2 + 270*D1**2*f**2*fdd*s - 135*D1**2*f**2*fdd - 540*D1**2*f*fd**2*r**2 - 1080*D1**2*f*fd**2*r*s + 810*D1**2*f*fd**2*r - 540*D1**2*f*fd**2*s**2 + 810*D1**2*f*fd**2*s - 270*D1**2*f*fd**2 + 416*D1*Dd*b1*f**2*r**2 + 832*D1*Dd*b1*f**2*r*s - 624*D1*Dd*b1*f**2*r + 416*D1*Dd*b1*f**2*s**2 - 624*D1*Dd*b1*f**2*s + 312*D1*Dd*b1*f**2 - 1248*D1*Dd*b1*f*fd*r**2 - 2496*D1*Dd*b1*f*fd*r*s + 1768*D1*Dd*b1*f*fd*r - 1248*D1*Dd*b1*f*fd*s**2 + 1768*D1*Dd*b1*f*fd*s - 624*D1*Dd*b1*f*fd + 360*D1*Dd*f**3*r**2 + 720*D1*Dd*f**3*r*s - 540*D1*Dd*f**3*r + 360*D1*Dd*f**3*s**2 - 540*D1*Dd*f**3*s + 270*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r**2 - 2880*D1*Dd*f**2*fd*r*s + 2160*D1*Dd*f**2*fd*r - 1440*D1*Dd*f**2*fd*s**2 + 2160*D1*Dd*f**2*fd*s - 810*D1*Dd*f**2*fd - 208*D1*Ddd*b1*f**2*r**2 - 416*D1*Ddd*b1*f**2*r*s + 312*D1*Ddd*b1*f**2*r - 208*D1*Ddd*b1*f**2*s**2 + 312*D1*Ddd*b1*f**2*s - 156*D1*Ddd*b1*f**2 - 180*D1*Ddd*f**3*r**2 - 360*D1*Ddd*f**3*r*s + 270*D1*Ddd*f**3*r - 180*D1*Ddd*f**3*s**2 + 270*D1*Ddd*f**3*s - 135*D1*Ddd*f**3 + 104*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 624*Dd**2*b1*f**2*r**2 - 1248*Dd**2*b1*f**2*r*s + 936*Dd**2*b1*f**2*r - 624*Dd**2*b1*f**2*s**2 + 936*Dd**2*b1*f**2*s - 312*Dd**2*b1*f**2 - 540*Dd**2*f**3*r**2 - 1080*Dd**2*f**3*r*s + 810*Dd**2*f**3*r - 540*Dd**2*f**3*s**2 + 810*Dd**2*f**3*s - 270*Dd**2*f**3)/(1287*d**2*k1*k3**6) + D1**2*Pk1*Pkdd3*ct**7*k1*k2**5*(-6336*C*D1**2*b1*f*fd*r**2 - 12672*C*D1**2*b1*f*fd*r*s + 6336*C*D1**2*b1*f*fd*r - 6336*C*D1**2*b1*f*fd*s**2 + 6336*C*D1**2*b1*f*fd*s - 3168*C*D1**2*b1*f*fd + 3960*C*D1**2*b1*f*fdd*r**2 + 7920*C*D1**2*b1*f*fdd*r*s - 3960*C*D1**2*b1*f*fdd*r + 3960*C*D1**2*b1*f*fdd*s**2 - 3960*C*D1**2*b1*f*fdd*s + 1980*C*D1**2*b1*f*fdd + 3960*C*D1**2*b1*fd**2*r**2 + 7920*C*D1**2*b1*fd**2*r*s - 3960*C*D1**2*b1*fd**2*r + 3960*C*D1**2*b1*fd**2*s**2 - 3960*C*D1**2*b1*fd**2*s - 8100*C*D1**2*f**2*fd*r**2 - 16200*C*D1**2*f**2*fd*r*s + 10800*C*D1**2*f**2*fd*r - 8100*C*D1**2*f**2*fd*s**2 + 10800*C*D1**2*f**2*fd*s - 5400*C*D1**2*f**2*fd + 5040*C*D1**2*f**2*fdd*r**2 + 10080*C*D1**2*f**2*fdd*r*s - 6720*C*D1**2*f**2*fdd*r + 5040*C*D1**2*f**2*fdd*s**2 - 6720*C*D1**2*f**2*fdd*s + 3360*C*D1**2*f**2*fdd + 10080*C*D1**2*f*fd**2*r**2 + 20160*C*D1**2*f*fd**2*r*s - 13440*C*D1**2*f*fd**2*r + 10080*C*D1**2*f*fd**2*s**2 - 13440*C*D1**2*f*fd**2*s + 3360*C*D1**2*f*fd**2 - 12672*C*D1*Dd*b1*f**2*r**2 - 25344*C*D1*Dd*b1*f**2*r*s + 19008*C*D1*Dd*b1*f**2*r - 12672*C*D1*Dd*b1*f**2*s**2 + 19008*C*D1*Dd*b1*f**2*s - 9504*C*D1*Dd*b1*f**2 + 31680*C*D1*Dd*b1*f*fd*r**2 + 63360*C*D1*Dd*b1*f*fd*r*s - 39600*C*D1*Dd*b1*f*fd*r + 31680*C*D1*Dd*b1*f*fd*s**2 - 39600*C*D1*Dd*b1*f*fd*s + 11880*C*D1*Dd*b1*f*fd - 10800*C*D1*Dd*f**3*r**2 - 21600*C*D1*Dd*f**3*r*s + 16200*C*D1*Dd*f**3*r - 10800*C*D1*Dd*f**3*s**2 + 16200*C*D1*Dd*f**3*s - 8100*C*D1*Dd*f**3 + 40320*C*D1*Dd*f**2*fd*r**2 + 80640*C*D1*Dd*f**2*fd*r*s - 57120*C*D1*Dd*f**2*fd*r + 40320*C*D1*Dd*f**2*fd*s**2 - 57120*C*D1*Dd*f**2*fd*s + 20160*C*D1*Dd*f**2*fd + 7920*C*D1*Ddd*b1*f**2*r**2 + 15840*C*D1*Ddd*b1*f**2*r*s - 11880*C*D1*Ddd*b1*f**2*r + 7920*C*D1*Ddd*b1*f**2*s**2 - 11880*C*D1*Ddd*b1*f**2*s + 5940*C*D1*Ddd*b1*f**2 + 6720*C*D1*Ddd*f**3*r**2 + 13440*C*D1*Ddd*f**3*r*s - 10080*C*D1*Ddd*f**3*r + 6720*C*D1*Ddd*f**3*s**2 - 10080*C*D1*Ddd*f**3*s + 5040*C*D1*Ddd*f**3 + 23760*C*Dd**2*b1*f**2*r**2 + 47520*C*Dd**2*b1*f**2*r*s - 35640*C*Dd**2*b1*f**2*r + 23760*C*Dd**2*b1*f**2*s**2 - 35640*C*Dd**2*b1*f**2*s + 11880*C*Dd**2*b1*f**2 + 20160*C*Dd**2*f**3*r**2 + 40320*C*Dd**2*f**3*r*s - 30240*C*Dd**2*f**3*r + 20160*C*Dd**2*f**3*s**2 - 30240*C*Dd**2*f**3*s + 10080*C*Dd**2*f**3 + 5676*D1**2*b1*f*fd*r**2 + 11352*D1**2*b1*f*fd*r*s - 5676*D1**2*b1*f*fd*r + 5676*D1**2*b1*f*fd*s**2 - 5676*D1**2*b1*f*fd*s + 2838*D1**2*b1*f*fd - 3630*D1**2*b1*f*fdd*r**2 - 7260*D1**2*b1*f*fdd*r*s + 3630*D1**2*b1*f*fdd*r - 3630*D1**2*b1*f*fdd*s**2 + 3630*D1**2*b1*f*fdd*s - 1815*D1**2*b1*f*fdd - 3630*D1**2*b1*fd**2*r**2 - 7260*D1**2*b1*fd**2*r*s + 3630*D1**2*b1*fd**2*r - 3630*D1**2*b1*fd**2*s**2 + 3630*D1**2*b1*fd**2*s + 165*D1**2*bdd1*f**2*(12*C - 11)*(r + s - 1)**2 + 7260*D1**2*f**2*fd*r**2 + 14520*D1**2*f**2*fd*r*s - 9680*D1**2*f**2*fd*r + 7260*D1**2*f**2*fd*s**2 - 9680*D1**2*f**2*fd*s + 4840*D1**2*f**2*fd - 4620*D1**2*f**2*fdd*r**2 - 9240*D1**2*f**2*fdd*r*s + 6160*D1**2*f**2*fdd*r - 4620*D1**2*f**2*fdd*s**2 + 6160*D1**2*f**2*fdd*s - 3080*D1**2*f**2*fdd - 9240*D1**2*f*fd**2*r**2 - 18480*D1**2*f*fd**2*r*s + 12320*D1**2*f*fd**2*r - 9240*D1**2*f*fd**2*s**2 + 12320*D1**2*f*fd**2*s - 3080*D1**2*f*fd**2 + 11352*D1*Dd*b1*f**2*r**2 + 22704*D1*Dd*b1*f**2*r*s - 17028*D1*Dd*b1*f**2*r + 11352*D1*Dd*b1*f**2*s**2 - 17028*D1*Dd*b1*f**2*s + 8514*D1*Dd*b1*f**2 - 29040*D1*Dd*b1*f*fd*r**2 - 58080*D1*Dd*b1*f*fd*r*s + 36300*D1*Dd*b1*f*fd*r - 29040*D1*Dd*b1*f*fd*s**2 + 36300*D1*Dd*b1*f*fd*s - 10890*D1*Dd*b1*f*fd + 9680*D1*Dd*f**3*r**2 + 19360*D1*Dd*f**3*r*s - 14520*D1*Dd*f**3*r + 9680*D1*Dd*f**3*s**2 - 14520*D1*Dd*f**3*s + 7260*D1*Dd*f**3 - 36960*D1*Dd*f**2*fd*r**2 - 73920*D1*Dd*f**2*fd*r*s + 52360*D1*Dd*f**2*fd*r - 36960*D1*Dd*f**2*fd*s**2 + 52360*D1*Dd*f**2*fd*s - 18480*D1*Dd*f**2*fd - 7260*D1*Ddd*b1*f**2*r**2 - 14520*D1*Ddd*b1*f**2*r*s + 10890*D1*Ddd*b1*f**2*r - 7260*D1*Ddd*b1*f**2*s**2 + 10890*D1*Ddd*b1*f**2*s - 5445*D1*Ddd*b1*f**2 - 6160*D1*Ddd*f**3*r**2 - 12320*D1*Ddd*f**3*r*s + 9240*D1*Ddd*f**3*r - 6160*D1*Ddd*f**3*s**2 + 9240*D1*Ddd*f**3*s - 4620*D1*Ddd*f**3 - 66*D1*bd1*f*(r + s - 1)*(D1*f*(48*C - 43)*(r + s - 1) - D1*fd*(60*C - 55)*(2*r + 2*s - 1) - Dd*f*(60*C - 55)*(4*r + 4*s - 3)) - 21780*Dd**2*b1*f**2*r**2 - 43560*Dd**2*b1*f**2*r*s + 32670*Dd**2*b1*f**2*r - 21780*Dd**2*b1*f**2*s**2 + 32670*Dd**2*b1*f**2*s - 10890*Dd**2*b1*f**2 - 18480*Dd**2*f**3*r**2 - 36960*Dd**2*f**3*r*s + 27720*Dd**2*f**3*r - 18480*Dd**2*f**3*s**2 + 27720*Dd**2*f**3*s - 9240*Dd**2*f**3)/(693*d**2*k3**6) - 5*D1**2*Pk1*Pkdd3*ct**7*k2**5*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 168*D1**2*f**2*fd*r**2 + 336*D1**2*f**2*fd*r*s - 224*D1**2*f**2*fd*r + 168*D1**2*f**2*fd*s**2 - 224*D1**2*f**2*fd*s + 112*D1**2*f**2*fd - 84*D1**2*f**2*fdd*r**2 - 168*D1**2*f**2*fdd*r*s + 112*D1**2*f**2*fdd*r - 84*D1**2*f**2*fdd*s**2 + 112*D1**2*f**2*fdd*s - 56*D1**2*f**2*fdd - 168*D1**2*f*fd**2*r**2 - 336*D1**2*f*fd**2*r*s + 224*D1**2*f*fd**2*r - 168*D1**2*f*fd**2*s**2 + 224*D1**2*f*fd**2*s - 56*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 224*D1*Dd*f**3*r**2 + 448*D1*Dd*f**3*r*s - 336*D1*Dd*f**3*r + 224*D1*Dd*f**3*s**2 - 336*D1*Dd*f**3*s + 168*D1*Dd*f**3 - 672*D1*Dd*f**2*fd*r**2 - 1344*D1*Dd*f**2*fd*r*s + 952*D1*Dd*f**2*fd*r - 672*D1*Dd*f**2*fd*s**2 + 952*D1*Dd*f**2*fd*s - 336*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 112*D1*Ddd*f**3*r**2 - 224*D1*Ddd*f**3*r*s + 168*D1*Ddd*f**3*r - 112*D1*Ddd*f**3*s**2 + 168*D1*Ddd*f**3*s - 84*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 336*Dd**2*f**3*r**2 - 672*Dd**2*f**3*r*s + 504*Dd**2*f**3*r - 336*Dd**2*f**3*s**2 + 504*Dd**2*f**3*s - 168*Dd**2*f**3)/(693*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct**6*k1**2*k2**4*(-12672*C*D1**2*b1*f*fd*r**2 - 25344*C*D1**2*b1*f*fd*r*s + 12672*C*D1**2*b1*f*fd*r - 12672*C*D1**2*b1*f*fd*s**2 + 12672*C*D1**2*b1*f*fd*s - 6336*C*D1**2*b1*f*fd + 9900*C*D1**2*b1*f*fdd*r**2 + 19800*C*D1**2*b1*f*fdd*r*s - 9900*C*D1**2*b1*f*fdd*r + 9900*C*D1**2*b1*f*fdd*s**2 - 9900*C*D1**2*b1*f*fdd*s + 4950*C*D1**2*b1*f*fdd + 9900*C*D1**2*b1*fd**2*r**2 + 19800*C*D1**2*b1*fd**2*r*s - 9900*C*D1**2*b1*fd**2*r + 9900*C*D1**2*b1*fd**2*s**2 - 9900*C*D1**2*b1*fd**2*s - 16290*C*D1**2*f**2*fd*r**2 - 32580*C*D1**2*f**2*fd*r*s + 21720*C*D1**2*f**2*fd*r - 16290*C*D1**2*f**2*fd*s**2 + 21720*C*D1**2*f**2*fd*s - 10860*C*D1**2*f**2*fd + 12600*C*D1**2*f**2*fdd*r**2 + 25200*C*D1**2*f**2*fdd*r*s - 16800*C*D1**2*f**2*fdd*r + 12600*C*D1**2*f**2*fdd*s**2 - 16800*C*D1**2*f**2*fdd*s + 8400*C*D1**2*f**2*fdd + 25200*C*D1**2*f*fd**2*r**2 + 50400*C*D1**2*f*fd**2*r*s - 33600*C*D1**2*f*fd**2*r + 25200*C*D1**2*f*fd**2*s**2 - 33600*C*D1**2*f*fd**2*s + 8400*C*D1**2*f*fd**2 - 25344*C*D1*Dd*b1*f**2*r**2 - 50688*C*D1*Dd*b1*f**2*r*s + 38016*C*D1*Dd*b1*f**2*r - 25344*C*D1*Dd*b1*f**2*s**2 + 38016*C*D1*Dd*b1*f**2*s - 19008*C*D1*Dd*b1*f**2 + 79200*C*D1*Dd*b1*f*fd*r**2 + 158400*C*D1*Dd*b1*f*fd*r*s - 99000*C*D1*Dd*b1*f*fd*r + 79200*C*D1*Dd*b1*f*fd*s**2 - 99000*C*D1*Dd*b1*f*fd*s + 29700*C*D1*Dd*b1*f*fd - 21720*C*D1*Dd*f**3*r**2 - 43440*C*D1*Dd*f**3*r*s + 32580*C*D1*Dd*f**3*r - 21720*C*D1*Dd*f**3*s**2 + 32580*C*D1*Dd*f**3*s - 16290*C*D1*Dd*f**3 + 100800*C*D1*Dd*f**2*fd*r**2 + 201600*C*D1*Dd*f**2*fd*r*s - 142800*C*D1*Dd*f**2*fd*r + 100800*C*D1*Dd*f**2*fd*s**2 - 142800*C*D1*Dd*f**2*fd*s + 50400*C*D1*Dd*f**2*fd + 19800*C*D1*Ddd*b1*f**2*r**2 + 39600*C*D1*Ddd*b1*f**2*r*s - 29700*C*D1*Ddd*b1*f**2*r + 19800*C*D1*Ddd*b1*f**2*s**2 - 29700*C*D1*Ddd*b1*f**2*s + 14850*C*D1*Ddd*b1*f**2 + 16800*C*D1*Ddd*f**3*r**2 + 33600*C*D1*Ddd*f**3*r*s - 25200*C*D1*Ddd*f**3*r + 16800*C*D1*Ddd*f**3*s**2 - 25200*C*D1*Ddd*f**3*s + 12600*C*D1*Ddd*f**3 + 59400*C*Dd**2*b1*f**2*r**2 + 118800*C*Dd**2*b1*f**2*r*s - 89100*C*Dd**2*b1*f**2*r + 59400*C*Dd**2*b1*f**2*s**2 - 89100*C*Dd**2*b1*f**2*s + 29700*C*Dd**2*b1*f**2 + 50400*C*Dd**2*f**3*r**2 + 100800*C*Dd**2*f**3*r*s - 75600*C*Dd**2*f**3*r + 50400*C*Dd**2*f**3*s**2 - 75600*C*Dd**2*f**3*s + 25200*C*Dd**2*f**3 + 10164*D1**2*b1*f*fd*r**2 + 20328*D1**2*b1*f*fd*r*s - 10164*D1**2*b1*f*fd*r + 10164*D1**2*b1*f*fd*s**2 - 10164*D1**2*b1*f*fd*s + 5082*D1**2*b1*f*fd - 8250*D1**2*b1*f*fdd*r**2 - 16500*D1**2*b1*f*fdd*r*s + 8250*D1**2*b1*f*fdd*r - 8250*D1**2*b1*f*fdd*s**2 + 8250*D1**2*b1*f*fdd*s - 4125*D1**2*b1*f*fdd - 8250*D1**2*b1*fd**2*r**2 - 16500*D1**2*b1*fd**2*r*s + 8250*D1**2*b1*fd**2*r - 8250*D1**2*b1*fd**2*s**2 + 8250*D1**2*b1*fd**2*s + 825*D1**2*bdd1*f**2*(6*C - 5)*(r + s - 1)**2 + 13080*D1**2*f**2*fd*r**2 + 26160*D1**2*f**2*fd*r*s - 17440*D1**2*f**2*fd*r + 13080*D1**2*f**2*fd*s**2 - 17440*D1**2*f**2*fd*s + 8720*D1**2*f**2*fd - 10500*D1**2*f**2*fdd*r**2 - 21000*D1**2*f**2*fdd*r*s + 14000*D1**2*f**2*fdd*r - 10500*D1**2*f**2*fdd*s**2 + 14000*D1**2*f**2*fdd*s - 7000*D1**2*f**2*fdd - 21000*D1**2*f*fd**2*r**2 - 42000*D1**2*f*fd**2*r*s + 28000*D1**2*f*fd**2*r - 21000*D1**2*f*fd**2*s**2 + 28000*D1**2*f*fd**2*s - 7000*D1**2*f*fd**2 + 20328*D1*Dd*b1*f**2*r**2 + 40656*D1*Dd*b1*f**2*r*s - 30492*D1*Dd*b1*f**2*r + 20328*D1*Dd*b1*f**2*s**2 - 30492*D1*Dd*b1*f**2*s + 15246*D1*Dd*b1*f**2 - 66000*D1*Dd*b1*f*fd*r**2 - 132000*D1*Dd*b1*f*fd*r*s + 82500*D1*Dd*b1*f*fd*r - 66000*D1*Dd*b1*f*fd*s**2 + 82500*D1*Dd*b1*f*fd*s - 24750*D1*Dd*b1*f*fd + 17440*D1*Dd*f**3*r**2 + 34880*D1*Dd*f**3*r*s - 26160*D1*Dd*f**3*r + 17440*D1*Dd*f**3*s**2 - 26160*D1*Dd*f**3*s + 13080*D1*Dd*f**3 - 84000*D1*Dd*f**2*fd*r**2 - 168000*D1*Dd*f**2*fd*r*s + 119000*D1*Dd*f**2*fd*r - 84000*D1*Dd*f**2*fd*s**2 + 119000*D1*Dd*f**2*fd*s - 42000*D1*Dd*f**2*fd - 16500*D1*Ddd*b1*f**2*r**2 - 33000*D1*Ddd*b1*f**2*r*s + 24750*D1*Ddd*b1*f**2*r - 16500*D1*Ddd*b1*f**2*s**2 + 24750*D1*Ddd*b1*f**2*s - 12375*D1*Ddd*b1*f**2 - 14000*D1*Ddd*f**3*r**2 - 28000*D1*Ddd*f**3*r*s + 21000*D1*Ddd*f**3*r - 14000*D1*Ddd*f**3*s**2 + 21000*D1*Ddd*f**3*s - 10500*D1*Ddd*f**3 - 66*D1*bd1*f*(r + s - 1)*(D1*f*(96*C - 77)*(r + s - 1) - D1*fd*(150*C - 125)*(2*r + 2*s - 1) - Dd*f*(150*C - 125)*(4*r + 4*s - 3)) - 49500*Dd**2*b1*f**2*r**2 - 99000*Dd**2*b1*f**2*r*s + 74250*Dd**2*b1*f**2*r - 49500*Dd**2*b1*f**2*s**2 + 74250*Dd**2*b1*f**2*s - 24750*Dd**2*b1*f**2 - 42000*Dd**2*f**3*r**2 - 84000*Dd**2*f**3*r*s + 63000*Dd**2*f**3*r - 42000*Dd**2*f**3*s**2 + 63000*Dd**2*f**3*s - 21000*Dd**2*f**3)/(693*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**6*k2**6*st**2*(5*C - 5)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 150*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 - 200*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 200*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 150*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3)/(231*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**6*k2**6*(12870*C*D1**2*f**2*fd*r**2 + 25740*C*D1**2*f**2*fd*r*s - 17160*C*D1**2*f**2*fd*r + 12870*C*D1**2*f**2*fd*s**2 - 17160*C*D1**2*f**2*fd*s + 8580*C*D1**2*f**2*fd + 17160*C*D1*Dd*f**3*r**2 + 34320*C*D1*Dd*f**3*r*s - 25740*C*D1*Dd*f**3*r + 17160*C*D1*Dd*f**3*s**2 - 25740*C*D1*Dd*f**3*s + 12870*C*D1*Dd*f**3 + 2145*D1**2*K*bdd1*f**2*r**2 + 4290*D1**2*K*bdd1*f**2*r*s - 4290*D1**2*K*bdd1*f**2*r + 2145*D1**2*K*bdd1*f**2*s**2 - 4290*D1**2*K*bdd1*f**2*s + 2145*D1**2*K*bdd1*f**2 - 858*D1**2*bd1**2*f*(-6*K + 5*f + 6)*(r + s - 1)**2 + 7280*D1**2*bdd1*f**3*r**2 + 14560*D1**2*bdd1*f**3*r*s - 14560*D1**2*bdd1*f**3*r + 7280*D1**2*bdd1*f**3*s**2 - 14560*D1**2*bdd1*f**3*s + 7280*D1**2*bdd1*f**3 - 2145*D1**2*bdd1*f**2*r**2 - 4290*D1**2*bdd1*f**2*r*s + 4290*D1**2*bdd1*f**2*r - 2145*D1**2*bdd1*f**2*s**2 + 4290*D1**2*bdd1*f**2*s - 2145*D1**2*bdd1*f**2 - 5148*D1**2*bdd1*f*g2*r**2 - 10296*D1**2*bdd1*f*g2*r*s + 10296*D1**2*bdd1*f*g2*r - 5148*D1**2*bdd1*f*g2*s**2 + 10296*D1**2*bdd1*f*g2*s - 5148*D1**2*bdd1*f*g2 - 48440*D1**2*f**3*fd*r**2 - 96880*D1**2*f**3*fd*r*s + 72660*D1**2*f**3*fd*r - 48440*D1**2*f**3*fd*s**2 + 72660*D1**2*f**3*fd*s - 36330*D1**2*f**3*fd + 31500*D1**2*f**3*fdd*r**2 + 63000*D1**2*f**3*fdd*r*s - 47250*D1**2*f**3*fdd*r + 31500*D1**2*f**3*fdd*s**2 - 47250*D1**2*f**3*fdd*s + 23625*D1**2*f**3*fdd + 94500*D1**2*f**2*fd**2*r**2 + 189000*D1**2*f**2*fd**2*r*s - 141750*D1**2*f**2*fd**2*r + 94500*D1**2*f**2*fd**2*s**2 - 141750*D1**2*f**2*fd**2*s + 47250*D1**2*f**2*fd**2 - 12870*D1**2*f**2*fd*r**2 - 25740*D1**2*f**2*fd*r*s + 17160*D1**2*f**2*fd*r - 12870*D1**2*f**2*fd*s**2 + 17160*D1**2*f**2*fd*s - 8580*D1**2*f**2*fd + 8580*D1**2*f**2*gd2*r**2 + 17160*D1**2*f**2*gd2*r*s - 17160*D1**2*f**2*gd2*r + 8580*D1**2*f**2*gd2*s**2 - 17160*D1**2*f**2*gd2*s + 8580*D1**2*f**2*gd2 - 4290*D1**2*f**2*gdd2*r**2 - 8580*D1**2*f**2*gdd2*r*s + 8580*D1**2*f**2*gdd2*r - 4290*D1**2*f**2*gdd2*s**2 + 8580*D1**2*f**2*gdd2*s - 4290*D1**2*f**2*gdd2 + 17160*D1**2*f*fd*g2*r**2 + 34320*D1**2*f*fd*g2*r*s - 17160*D1**2*f*fd*g2*r + 17160*D1**2*f*fd*g2*s**2 - 17160*D1**2*f*fd*g2*s + 8580*D1**2*f*fd*g2 - 17160*D1**2*f*fd*gd2*r**2 - 34320*D1**2*f*fd*gd2*r*s + 25740*D1**2*f*fd*gd2*r - 17160*D1**2*f*fd*gd2*s**2 + 25740*D1**2*f*fd*gd2*s - 8580*D1**2*f*fd*gd2 - 8580*D1**2*f*fdd*g2*r**2 - 17160*D1**2*f*fdd*g2*r*s + 8580*D1**2*f*fdd*g2*r - 8580*D1**2*f*fdd*g2*s**2 + 8580*D1**2*f*fdd*g2*s - 4290*D1**2*f*fdd*g2 - 8580*D1**2*fd**2*g2*r**2 - 17160*D1**2*fd**2*g2*r*s + 8580*D1**2*fd**2*g2*r - 8580*D1**2*fd**2*g2*s**2 + 8580*D1**2*fd**2*g2*s - 48440*D1*Dd*f**4*r**2 - 96880*D1*Dd*f**4*r*s + 72660*D1*Dd*f**4*r - 48440*D1*Dd*f**4*s**2 + 72660*D1*Dd*f**4*s - 36330*D1*Dd*f**4 + 252000*D1*Dd*f**3*fd*r**2 + 504000*D1*Dd*f**3*fd*r*s - 378000*D1*Dd*f**3*fd*r + 252000*D1*Dd*f**3*fd*s**2 - 378000*D1*Dd*f**3*fd*s + 141750*D1*Dd*f**3*fd - 17160*D1*Dd*f**3*r**2 - 34320*D1*Dd*f**3*r*s + 25740*D1*Dd*f**3*r - 17160*D1*Dd*f**3*s**2 + 25740*D1*Dd*f**3*s - 12870*D1*Dd*f**3 + 34320*D1*Dd*f**2*g2*r**2 + 68640*D1*Dd*f**2*g2*r*s - 51480*D1*Dd*f**2*g2*r + 34320*D1*Dd*f**2*g2*s**2 - 51480*D1*Dd*f**2*g2*s + 25740*D1*Dd*f**2*g2 - 34320*D1*Dd*f**2*gd2*r**2 - 68640*D1*Dd*f**2*gd2*r*s + 60060*D1*Dd*f**2*gd2*r - 34320*D1*Dd*f**2*gd2*s**2 + 60060*D1*Dd*f**2*gd2*s - 25740*D1*Dd*f**2*gd2 - 68640*D1*Dd*f*fd*g2*r**2 - 137280*D1*Dd*f*fd*g2*r*s + 85800*D1*Dd*f*fd*g2*r - 68640*D1*Dd*f*fd*g2*s**2 + 85800*D1*Dd*f*fd*g2*s - 25740*D1*Dd*f*fd*g2 + 31500*D1*Ddd*f**4*r**2 + 63000*D1*Ddd*f**4*r*s - 47250*D1*Ddd*f**4*r + 31500*D1*Ddd*f**4*s**2 - 47250*D1*Ddd*f**4*s + 23625*D1*Ddd*f**4 - 17160*D1*Ddd*f**2*g2*r**2 - 34320*D1*Ddd*f**2*g2*r*s + 25740*D1*Ddd*f**2*g2*r - 17160*D1*Ddd*f**2*g2*s**2 + 25740*D1*Ddd*f**2*g2*s - 12870*D1*Ddd*f**2*g2 - 26*D1*bd1*(D1*(395*f**3*(r + s - 1) + f**2*(-198*C*(r + s - 1) - 560*fd*(3*r + 3*s - 2) + (165*K + 33)*(r + s - 1)) - 33*f*(5*fd*(K - 1)*(2*r + 2*s - 1) + (12*g2 - 12*gd2)*(r + s - 1)) + 396*fd*g2*(r + s)) - Dd*f*(560*f**2 + 165*f*(K - 1) - 396*g2)*(4*r + 4*s - 3))*(r + s - 1) + 94500*Dd**2*f**4*r**2 + 189000*Dd**2*f**4*r*s - 141750*Dd**2*f**4*r + 94500*Dd**2*f**4*s**2 - 141750*Dd**2*f**4*s + 47250*Dd**2*f**4 - 51480*Dd**2*f**2*g2*r**2 - 102960*Dd**2*f**2*g2*r*s + 77220*Dd**2*f**2*g2*r - 51480*Dd**2*f**2*g2*s**2 + 77220*Dd**2*f**2*g2*s - 25740*Dd**2*f**2*g2 + 429*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(5*fd**2*(r + s - 1) + 6*fd*(K - 1)*(r + s) - 3*fdd*(K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (6*K - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-6*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-6*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(792*C*D1**2*f*fd*r**2 + 1584*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 792*C*D1**2*f*fd*s**2 - 792*C*D1**2*f*fd*s + 396*C*D1**2*f*fd + 1584*C*D1*Dd*f**2*r**2 + 3168*C*D1*Dd*f**2*r*s - 2376*C*D1*Dd*f**2*r + 1584*C*D1*Dd*f**2*s**2 - 2376*C*D1*Dd*f**2*s + 1188*C*D1*Dd*f**2 - 660*D1**2*K*f*fd*r**2 - 1320*D1**2*K*f*fd*r*s + 660*D1**2*K*f*fd*r - 660*D1**2*K*f*fd*s**2 + 660*D1**2*K*f*fd*s - 330*D1**2*K*f*fd + 330*D1**2*K*f*fdd*r**2 + 660*D1**2*K*f*fdd*r*s - 330*D1**2*K*f*fdd*r + 330*D1**2*K*f*fdd*s**2 - 330*D1**2*K*f*fdd*s + 165*D1**2*K*f*fdd + 330*D1**2*K*fd**2*r**2 + 660*D1**2*K*fd**2*r*s - 330*D1**2*K*fd**2*r + 330*D1**2*K*fd**2*s**2 - 330*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(-6*K + 5*f + 6)*(r + s - 1)**2 - 2370*D1**2*f**2*fd*r**2 - 4740*D1**2*f**2*fd*r*s + 3160*D1**2*f**2*fd*r - 2370*D1**2*f**2*fd*s**2 + 3160*D1**2*f**2*fd*s - 1580*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*r**2 + 3360*D1**2*f**2*fdd*r*s - 2240*D1**2*f**2*fdd*r + 1680*D1**2*f**2*fdd*s**2 - 2240*D1**2*f**2*fdd*s + 1120*D1**2*f**2*fdd + 3360*D1**2*f*fd**2*r**2 + 6720*D1**2*f*fd**2*r*s - 4480*D1**2*f*fd**2*r + 3360*D1**2*f*fd**2*s**2 - 4480*D1**2*f*fd**2*s + 1120*D1**2*f*fd**2 - 132*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r*s + 132*D1**2*f*fd*r - 132*D1**2*f*fd*s**2 + 132*D1**2*f*fd*s - 66*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 660*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r - 330*D1**2*f*fdd*s**2 + 330*D1**2*f*fdd*s - 165*D1**2*f*fdd + 792*D1**2*f*gd2*r**2 + 1584*D1**2*f*gd2*r*s - 1584*D1**2*f*gd2*r + 792*D1**2*f*gd2*s**2 - 1584*D1**2*f*gd2*s + 792*D1**2*f*gd2 - 396*D1**2*f*gdd2*r**2 - 792*D1**2*f*gdd2*r*s + 792*D1**2*f*gdd2*r - 396*D1**2*f*gdd2*s**2 + 792*D1**2*f*gdd2*s - 396*D1**2*f*gdd2 - 330*D1**2*fd**2*r**2 - 660*D1**2*fd**2*r*s + 330*D1**2*fd**2*r - 330*D1**2*fd**2*s**2 + 330*D1**2*fd**2*s + 792*D1**2*fd*g2*r**2 + 1584*D1**2*fd*g2*r*s + 792*D1**2*fd*g2*s**2 - 792*D1**2*fd*gd2*r**2 - 1584*D1**2*fd*gd2*r*s + 792*D1**2*fd*gd2*r - 792*D1**2*fd*gd2*s**2 + 792*D1**2*fd*gd2*s - 396*D1**2*fdd*g2*r**2 - 792*D1**2*fdd*g2*r*s - 396*D1**2*fdd*g2*s**2 - 1320*D1*Dd*K*f**2*r**2 - 2640*D1*Dd*K*f**2*r*s + 1980*D1*Dd*K*f**2*r - 1320*D1*Dd*K*f**2*s**2 + 1980*D1*Dd*K*f**2*s - 990*D1*Dd*K*f**2 + 2640*D1*Dd*K*f*fd*r**2 + 5280*D1*Dd*K*f*fd*r*s - 3300*D1*Dd*K*f*fd*r + 2640*D1*Dd*K*f*fd*s**2 - 3300*D1*Dd*K*f*fd*s + 990*D1*Dd*K*f*fd - 3160*D1*Dd*f**3*r**2 - 6320*D1*Dd*f**3*r*s + 4740*D1*Dd*f**3*r - 3160*D1*Dd*f**3*s**2 + 4740*D1*Dd*f**3*s - 2370*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*r**2 + 26880*D1*Dd*f**2*fd*r*s - 19040*D1*Dd*f**2*fd*r + 13440*D1*Dd*f**2*fd*s**2 - 19040*D1*Dd*f**2*fd*s + 6720*D1*Dd*f**2*fd - 264*D1*Dd*f**2*r**2 - 528*D1*Dd*f**2*r*s + 396*D1*Dd*f**2*r - 264*D1*Dd*f**2*s**2 + 396*D1*Dd*f**2*s - 198*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 5280*D1*Dd*f*fd*r*s + 3300*D1*Dd*f*fd*r - 2640*D1*Dd*f*fd*s**2 + 3300*D1*Dd*f*fd*s - 990*D1*Dd*f*fd + 3168*D1*Dd*f*g2*r**2 + 6336*D1*Dd*f*g2*r*s - 4752*D1*Dd*f*g2*r + 3168*D1*Dd*f*g2*s**2 - 4752*D1*Dd*f*g2*s + 2376*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 6336*D1*Dd*f*gd2*r*s + 5544*D1*Dd*f*gd2*r - 3168*D1*Dd*f*gd2*s**2 + 5544*D1*Dd*f*gd2*s - 2376*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 6336*D1*Dd*fd*g2*r*s + 2376*D1*Dd*fd*g2*r - 3168*D1*Dd*fd*g2*s**2 + 2376*D1*Dd*fd*g2*s + 660*D1*Ddd*K*f**2*r**2 + 1320*D1*Ddd*K*f**2*r*s - 990*D1*Ddd*K*f**2*r + 660*D1*Ddd*K*f**2*s**2 - 990*D1*Ddd*K*f**2*s + 495*D1*Ddd*K*f**2 + 2240*D1*Ddd*f**3*r**2 + 4480*D1*Ddd*f**3*r*s - 3360*D1*Ddd*f**3*r + 2240*D1*Ddd*f**3*s**2 - 3360*D1*Ddd*f**3*s + 1680*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 - 1320*D1*Ddd*f**2*r*s + 990*D1*Ddd*f**2*r - 660*D1*Ddd*f**2*s**2 + 990*D1*Ddd*f**2*s - 495*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 3168*D1*Ddd*f*g2*r*s + 2376*D1*Ddd*f*g2*r - 1584*D1*Ddd*f*g2*s**2 + 2376*D1*Ddd*f*g2*s - 1188*D1*Ddd*f*g2 + 132*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 6*f*(K - 1)*(r + s - 1) + 6*fd*(K - 1)*(r + s)) - Dd*f*(-6*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 1980*Dd**2*K*f**2*r**2 + 3960*Dd**2*K*f**2*r*s - 2970*Dd**2*K*f**2*r + 1980*Dd**2*K*f**2*s**2 - 2970*Dd**2*K*f**2*s + 990*Dd**2*K*f**2 + 6720*Dd**2*f**3*r**2 + 13440*Dd**2*f**3*r*s - 10080*Dd**2*f**3*r + 6720*Dd**2*f**3*s**2 - 10080*Dd**2*f**3*s + 3360*Dd**2*f**3 - 1980*Dd**2*f**2*r**2 - 3960*Dd**2*f**2*r*s + 2970*Dd**2*f**2*r - 1980*Dd**2*f**2*s**2 + 2970*Dd**2*f**2*s - 990*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 9504*Dd**2*f*g2*r*s + 7128*Dd**2*f*g2*r - 4752*Dd**2*f*g2*s**2 + 7128*Dd**2*f*g2*s - 2376*Dd**2*f*g2))/(9009*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**6*k2**4*(-396*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-40*C*D1**2*f*fd*r - 40*C*D1**2*f*fd*s + 20*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r + 20*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r + 20*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 + 80*C*D1*Dd*f*fd*r + 80*C*D1*Dd*f*fd*s - 60*C*D1*Dd*f*fd - 12*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 36*D1**2*f*fd*r**2 + 72*D1**2*f*fd*r*s + 4*D1**2*f*fd*r + 36*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 2*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 20*D1**2*fd**2 + 72*D1*Dd*f**2*r**2 + 144*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 108*D1*Dd*f**2*s + 54*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 220*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 220*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 + 24*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2) + f*(792*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 165*D1**2*bdd1*f*(C*(4*r + 4*s - 2) + 3*r**2 + 2*r*(3*s - 5) + 3*s**2 - 10*s + 5) + 10*D1**2*(f*(fd*(56*C - 107) + fdd*(70 - 28*C))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(140 - 56*C)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 66*D1*bd1*(D1*f*(10*C*(2*r + 2*s - 1) + 9*r**2 + 2*r*(9*s - 19) + 9*s**2 - 38*s + 19) - 5*D1*fd*(r + s - 1)*(2*C + 6*r + 6*s - 5) - 5*Dd*f*(4*r + 4*s - 3)*(2*C + 3*r + 3*s - 5)) + 10*D1*f*(Dd*(f*(56*C - 107)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(56*C - 140)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + Ddd*f*(70 - 28*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 10*Dd**2*f**2*(420 - 168*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k3**4) - 5*D1**2*Pk1*Pkdd3*ct**5*f*k2**7*st**2*(390*D1**2*b1*f*fd*r**2 + 780*D1**2*b1*f*fd*r*s - 520*D1**2*b1*f*fd*r + 390*D1**2*b1*f*fd*s**2 - 520*D1**2*b1*f*fd*s + 260*D1**2*b1*f*fd - 195*D1**2*b1*f*fdd*r**2 - 390*D1**2*b1*f*fdd*r*s + 260*D1**2*b1*f*fdd*r - 195*D1**2*b1*f*fdd*s**2 + 260*D1**2*b1*f*fdd*s - 130*D1**2*b1*f*fdd - 390*D1**2*b1*fd**2*r**2 - 780*D1**2*b1*fd**2*r*s + 520*D1**2*b1*fd**2*r - 390*D1**2*b1*fd**2*s**2 + 520*D1**2*b1*fd**2*s - 130*D1**2*b1*fd**2 - 65*D1**2*bdd1*f**2*(r + s - 1)**2 + 392*D1**2*f**2*fd*r**2 + 784*D1**2*f**2*fd*r*s - 588*D1**2*f**2*fd*r + 392*D1**2*f**2*fd*s**2 - 588*D1**2*f**2*fd*s + 294*D1**2*f**2*fd - 196*D1**2*f**2*fdd*r**2 - 392*D1**2*f**2*fdd*r*s + 294*D1**2*f**2*fdd*r - 196*D1**2*f**2*fdd*s**2 + 294*D1**2*f**2*fdd*s - 147*D1**2*f**2*fdd - 588*D1**2*f*fd**2*r**2 - 1176*D1**2*f*fd**2*r*s + 882*D1**2*f*fd**2*r - 588*D1**2*f*fd**2*s**2 + 882*D1**2*f*fd**2*s - 294*D1**2*f*fd**2 + 520*D1*Dd*b1*f**2*r**2 + 1040*D1*Dd*b1*f**2*r*s - 780*D1*Dd*b1*f**2*r + 520*D1*Dd*b1*f**2*s**2 - 780*D1*Dd*b1*f**2*s + 390*D1*Dd*b1*f**2 - 1560*D1*Dd*b1*f*fd*r**2 - 3120*D1*Dd*b1*f*fd*r*s + 2210*D1*Dd*b1*f*fd*r - 1560*D1*Dd*b1*f*fd*s**2 + 2210*D1*Dd*b1*f*fd*s - 780*D1*Dd*b1*f*fd + 392*D1*Dd*f**3*r**2 + 784*D1*Dd*f**3*r*s - 588*D1*Dd*f**3*r + 392*D1*Dd*f**3*s**2 - 588*D1*Dd*f**3*s + 294*D1*Dd*f**3 - 1568*D1*Dd*f**2*fd*r**2 - 3136*D1*Dd*f**2*fd*r*s + 2352*D1*Dd*f**2*fd*r - 1568*D1*Dd*f**2*fd*s**2 + 2352*D1*Dd*f**2*fd*s - 882*D1*Dd*f**2*fd - 260*D1*Ddd*b1*f**2*r**2 - 520*D1*Ddd*b1*f**2*r*s + 390*D1*Ddd*b1*f**2*r - 260*D1*Ddd*b1*f**2*s**2 + 390*D1*Ddd*b1*f**2*s - 195*D1*Ddd*b1*f**2 - 196*D1*Ddd*f**3*r**2 - 392*D1*Ddd*f**3*r*s + 294*D1*Ddd*f**3*r - 196*D1*Ddd*f**3*s**2 + 294*D1*Ddd*f**3*s - 147*D1*Ddd*f**3 + 130*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 780*Dd**2*b1*f**2*r**2 - 1560*Dd**2*b1*f**2*r*s + 1170*Dd**2*b1*f**2*r - 780*Dd**2*b1*f**2*s**2 + 1170*Dd**2*b1*f**2*s - 390*Dd**2*b1*f**2 - 588*Dd**2*f**3*r**2 - 1176*Dd**2*f**3*r*s + 882*Dd**2*f**3*r - 588*Dd**2*f**3*s**2 + 882*Dd**2*f**3*s - 294*Dd**2*f**3)/(858*d**2*k1*k3**6) + D1**2*Pk1*Pkdd3*ct**5*k1**3*k2**3*(-13728*C*D1**2*b1*f*fd*r**2 - 27456*C*D1**2*b1*f*fd*r*s + 13728*C*D1**2*b1*f*fd*r - 13728*C*D1**2*b1*f*fd*s**2 + 13728*C*D1**2*b1*f*fd*s - 6864*C*D1**2*b1*f*fd + 13200*C*D1**2*b1*f*fdd*r**2 + 26400*C*D1**2*b1*f*fdd*r*s - 13200*C*D1**2*b1*f*fdd*r + 13200*C*D1**2*b1*f*fdd*s**2 - 13200*C*D1**2*b1*f*fdd*s + 6600*C*D1**2*b1*f*fdd + 13200*C*D1**2*b1*fd**2*r**2 + 26400*C*D1**2*b1*fd**2*r*s - 13200*C*D1**2*b1*fd**2*r + 13200*C*D1**2*b1*fd**2*s**2 - 13200*C*D1**2*b1*fd**2*s - 17760*C*D1**2*f**2*fd*r**2 - 35520*C*D1**2*f**2*fd*r*s + 23680*C*D1**2*f**2*fd*r - 17760*C*D1**2*f**2*fd*s**2 + 23680*C*D1**2*f**2*fd*s - 11840*C*D1**2*f**2*fd + 16800*C*D1**2*f**2*fdd*r**2 + 33600*C*D1**2*f**2*fdd*r*s - 22400*C*D1**2*f**2*fdd*r + 16800*C*D1**2*f**2*fdd*s**2 - 22400*C*D1**2*f**2*fdd*s + 11200*C*D1**2*f**2*fdd + 33600*C*D1**2*f*fd**2*r**2 + 67200*C*D1**2*f*fd**2*r*s - 44800*C*D1**2*f*fd**2*r + 33600*C*D1**2*f*fd**2*s**2 - 44800*C*D1**2*f*fd**2*s + 11200*C*D1**2*f*fd**2 - 27456*C*D1*Dd*b1*f**2*r**2 - 54912*C*D1*Dd*b1*f**2*r*s + 41184*C*D1*Dd*b1*f**2*r - 27456*C*D1*Dd*b1*f**2*s**2 + 41184*C*D1*Dd*b1*f**2*s - 20592*C*D1*Dd*b1*f**2 + 105600*C*D1*Dd*b1*f*fd*r**2 + 211200*C*D1*Dd*b1*f*fd*r*s - 132000*C*D1*Dd*b1*f*fd*r + 105600*C*D1*Dd*b1*f*fd*s**2 - 132000*C*D1*Dd*b1*f*fd*s + 39600*C*D1*Dd*b1*f*fd - 23680*C*D1*Dd*f**3*r**2 - 47360*C*D1*Dd*f**3*r*s + 35520*C*D1*Dd*f**3*r - 23680*C*D1*Dd*f**3*s**2 + 35520*C*D1*Dd*f**3*s - 17760*C*D1*Dd*f**3 + 134400*C*D1*Dd*f**2*fd*r**2 + 268800*C*D1*Dd*f**2*fd*r*s - 190400*C*D1*Dd*f**2*fd*r + 134400*C*D1*Dd*f**2*fd*s**2 - 190400*C*D1*Dd*f**2*fd*s + 67200*C*D1*Dd*f**2*fd + 26400*C*D1*Ddd*b1*f**2*r**2 + 52800*C*D1*Ddd*b1*f**2*r*s - 39600*C*D1*Ddd*b1*f**2*r + 26400*C*D1*Ddd*b1*f**2*s**2 - 39600*C*D1*Ddd*b1*f**2*s + 19800*C*D1*Ddd*b1*f**2 + 22400*C*D1*Ddd*f**3*r**2 + 44800*C*D1*Ddd*f**3*r*s - 33600*C*D1*Ddd*f**3*r + 22400*C*D1*Ddd*f**3*s**2 - 33600*C*D1*Ddd*f**3*s + 16800*C*D1*Ddd*f**3 + 79200*C*Dd**2*b1*f**2*r**2 + 158400*C*Dd**2*b1*f**2*r*s - 118800*C*Dd**2*b1*f**2*r + 79200*C*Dd**2*b1*f**2*s**2 - 118800*C*Dd**2*b1*f**2*s + 39600*C*Dd**2*b1*f**2 + 67200*C*Dd**2*f**3*r**2 + 134400*C*Dd**2*f**3*r*s - 100800*C*Dd**2*f**3*r + 67200*C*Dd**2*f**3*s**2 - 100800*C*Dd**2*f**3*s + 33600*C*Dd**2*f**3 + 9900*D1**2*b1*f*fd*r**2 + 19800*D1**2*b1*f*fd*r*s - 9900*D1**2*b1*f*fd*r + 9900*D1**2*b1*f*fd*s**2 - 9900*D1**2*b1*f*fd*s + 4950*D1**2*b1*f*fd - 9900*D1**2*b1*f*fdd*r**2 - 19800*D1**2*b1*f*fdd*r*s + 9900*D1**2*b1*f*fdd*r - 9900*D1**2*b1*f*fdd*s**2 + 9900*D1**2*b1*f*fdd*s - 4950*D1**2*b1*f*fdd - 9900*D1**2*b1*fd**2*r**2 - 19800*D1**2*b1*fd**2*r*s + 9900*D1**2*b1*fd**2*r - 9900*D1**2*b1*fd**2*s**2 + 9900*D1**2*b1*fd**2*s + 1650*D1**2*bdd1*f**2*(4*C - 3)*(r + s - 1)**2 + 12825*D1**2*f**2*fd*r**2 + 25650*D1**2*f**2*fd*r*s - 17100*D1**2*f**2*fd*r + 12825*D1**2*f**2*fd*s**2 - 17100*D1**2*f**2*fd*s + 8550*D1**2*f**2*fd - 12600*D1**2*f**2*fdd*r**2 - 25200*D1**2*f**2*fdd*r*s + 16800*D1**2*f**2*fdd*r - 12600*D1**2*f**2*fdd*s**2 + 16800*D1**2*f**2*fdd*s - 8400*D1**2*f**2*fdd - 25200*D1**2*f*fd**2*r**2 - 50400*D1**2*f*fd**2*r*s + 33600*D1**2*f*fd**2*r - 25200*D1**2*f*fd**2*s**2 + 33600*D1**2*f*fd**2*s - 8400*D1**2*f*fd**2 + 19800*D1*Dd*b1*f**2*r**2 + 39600*D1*Dd*b1*f**2*r*s - 29700*D1*Dd*b1*f**2*r + 19800*D1*Dd*b1*f**2*s**2 - 29700*D1*Dd*b1*f**2*s + 14850*D1*Dd*b1*f**2 - 79200*D1*Dd*b1*f*fd*r**2 - 158400*D1*Dd*b1*f*fd*r*s + 99000*D1*Dd*b1*f*fd*r - 79200*D1*Dd*b1*f*fd*s**2 + 99000*D1*Dd*b1*f*fd*s - 29700*D1*Dd*b1*f*fd + 17100*D1*Dd*f**3*r**2 + 34200*D1*Dd*f**3*r*s - 25650*D1*Dd*f**3*r + 17100*D1*Dd*f**3*s**2 - 25650*D1*Dd*f**3*s + 12825*D1*Dd*f**3 - 100800*D1*Dd*f**2*fd*r**2 - 201600*D1*Dd*f**2*fd*r*s + 142800*D1*Dd*f**2*fd*r - 100800*D1*Dd*f**2*fd*s**2 + 142800*D1*Dd*f**2*fd*s - 50400*D1*Dd*f**2*fd - 19800*D1*Ddd*b1*f**2*r**2 - 39600*D1*Ddd*b1*f**2*r*s + 29700*D1*Ddd*b1*f**2*r - 19800*D1*Ddd*b1*f**2*s**2 + 29700*D1*Ddd*b1*f**2*s - 14850*D1*Ddd*b1*f**2 - 16800*D1*Ddd*f**3*r**2 - 33600*D1*Ddd*f**3*r*s + 25200*D1*Ddd*f**3*r - 16800*D1*Ddd*f**3*s**2 + 25200*D1*Ddd*f**3*s - 12600*D1*Ddd*f**3 - 66*D1*bd1*f*(r + s - 1)*(D1*f*(104*C - 75)*(r + s - 1) - D1*fd*(200*C - 150)*(2*r + 2*s - 1) - Dd*f*(200*C - 150)*(4*r + 4*s - 3)) - 59400*Dd**2*b1*f**2*r**2 - 118800*Dd**2*b1*f**2*r*s + 89100*Dd**2*b1*f**2*r - 59400*Dd**2*b1*f**2*s**2 + 89100*Dd**2*b1*f**2*s - 29700*Dd**2*b1*f**2 - 50400*Dd**2*f**3*r**2 - 100800*Dd**2*f**3*r*s + 75600*Dd**2*f**3*r - 50400*Dd**2*f**3*s**2 + 75600*Dd**2*f**3*s - 25200*Dd**2*f**3)/(693*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**5*k1*k2**5*st**2*(-16896*C*D1**2*b1*f*fd*r**2 - 33792*C*D1**2*b1*f*fd*r*s + 16896*C*D1**2*b1*f*fd*r - 16896*C*D1**2*b1*f*fd*s**2 + 16896*C*D1**2*b1*f*fd*s - 8448*C*D1**2*b1*f*fd + 9240*C*D1**2*b1*f*fdd*r**2 + 18480*C*D1**2*b1*f*fdd*r*s - 9240*C*D1**2*b1*f*fdd*r + 9240*C*D1**2*b1*f*fdd*s**2 - 9240*C*D1**2*b1*f*fdd*s + 4620*C*D1**2*b1*f*fdd + 9240*C*D1**2*b1*fd**2*r**2 + 18480*C*D1**2*b1*fd**2*r*s - 9240*C*D1**2*b1*fd**2*r + 9240*C*D1**2*b1*fd**2*s**2 - 9240*C*D1**2*b1*fd**2*s - 18624*C*D1**2*f**2*fd*r**2 - 37248*C*D1**2*f**2*fd*r*s + 24832*C*D1**2*f**2*fd*r - 18624*C*D1**2*f**2*fd*s**2 + 24832*C*D1**2*f**2*fd*s - 12416*C*D1**2*f**2*fd + 10500*C*D1**2*f**2*fdd*r**2 + 21000*C*D1**2*f**2*fdd*r*s - 14000*C*D1**2*f**2*fdd*r + 10500*C*D1**2*f**2*fdd*s**2 - 14000*C*D1**2*f**2*fdd*s + 7000*C*D1**2*f**2*fdd + 21000*C*D1**2*f*fd**2*r**2 + 42000*C*D1**2*f*fd**2*r*s - 28000*C*D1**2*f*fd**2*r + 21000*C*D1**2*f*fd**2*s**2 - 28000*C*D1**2*f*fd**2*s + 7000*C*D1**2*f*fd**2 - 33792*C*D1*Dd*b1*f**2*r**2 - 67584*C*D1*Dd*b1*f**2*r*s + 50688*C*D1*Dd*b1*f**2*r - 33792*C*D1*Dd*b1*f**2*s**2 + 50688*C*D1*Dd*b1*f**2*s - 25344*C*D1*Dd*b1*f**2 + 73920*C*D1*Dd*b1*f*fd*r**2 + 147840*C*D1*Dd*b1*f*fd*r*s - 92400*C*D1*Dd*b1*f*fd*r + 73920*C*D1*Dd*b1*f*fd*s**2 - 92400*C*D1*Dd*b1*f*fd*s + 27720*C*D1*Dd*b1*f*fd - 24832*C*D1*Dd*f**3*r**2 - 49664*C*D1*Dd*f**3*r*s + 37248*C*D1*Dd*f**3*r - 24832*C*D1*Dd*f**3*s**2 + 37248*C*D1*Dd*f**3*s - 18624*C*D1*Dd*f**3 + 84000*C*D1*Dd*f**2*fd*r**2 + 168000*C*D1*Dd*f**2*fd*r*s - 119000*C*D1*Dd*f**2*fd*r + 84000*C*D1*Dd*f**2*fd*s**2 - 119000*C*D1*Dd*f**2*fd*s + 42000*C*D1*Dd*f**2*fd + 18480*C*D1*Ddd*b1*f**2*r**2 + 36960*C*D1*Ddd*b1*f**2*r*s - 27720*C*D1*Ddd*b1*f**2*r + 18480*C*D1*Ddd*b1*f**2*s**2 - 27720*C*D1*Ddd*b1*f**2*s + 13860*C*D1*Ddd*b1*f**2 + 14000*C*D1*Ddd*f**3*r**2 + 28000*C*D1*Ddd*f**3*r*s - 21000*C*D1*Ddd*f**3*r + 14000*C*D1*Ddd*f**3*s**2 - 21000*C*D1*Ddd*f**3*s + 10500*C*D1*Ddd*f**3 + 55440*C*Dd**2*b1*f**2*r**2 + 110880*C*Dd**2*b1*f**2*r*s - 83160*C*Dd**2*b1*f**2*r + 55440*C*Dd**2*b1*f**2*s**2 - 83160*C*Dd**2*b1*f**2*s + 27720*C*Dd**2*b1*f**2 + 42000*C*Dd**2*f**3*r**2 + 84000*C*Dd**2*f**3*r*s - 63000*C*Dd**2*f**3*r + 42000*C*Dd**2*f**3*s**2 - 63000*C*Dd**2*f**3*s + 21000*C*Dd**2*f**3 + 14916*D1**2*b1*f*fd*r**2 + 29832*D1**2*b1*f*fd*r*s - 14916*D1**2*b1*f*fd*r + 14916*D1**2*b1*f*fd*s**2 - 14916*D1**2*b1*f*fd*s + 7458*D1**2*b1*f*fd - 8250*D1**2*b1*f*fdd*r**2 - 16500*D1**2*b1*f*fdd*r*s + 8250*D1**2*b1*f*fdd*r - 8250*D1**2*b1*f*fdd*s**2 + 8250*D1**2*b1*f*fdd*s - 4125*D1**2*b1*f*fdd - 8250*D1**2*b1*fd**2*r**2 - 16500*D1**2*b1*fd**2*r*s + 8250*D1**2*b1*fd**2*r - 8250*D1**2*b1*fd**2*s**2 + 8250*D1**2*b1*fd**2*s + 165*D1**2*bdd1*f**2*(28*C - 25)*(r + s - 1)**2 + 16374*D1**2*f**2*fd*r**2 + 32748*D1**2*f**2*fd*r*s - 21832*D1**2*f**2*fd*r + 16374*D1**2*f**2*fd*s**2 - 21832*D1**2*f**2*fd*s + 10916*D1**2*f**2*fd - 9375*D1**2*f**2*fdd*r**2 - 18750*D1**2*f**2*fdd*r*s + 12500*D1**2*f**2*fdd*r - 9375*D1**2*f**2*fdd*s**2 + 12500*D1**2*f**2*fdd*s - 6250*D1**2*f**2*fdd - 18750*D1**2*f*fd**2*r**2 - 37500*D1**2*f*fd**2*r*s + 25000*D1**2*f*fd**2*r - 18750*D1**2*f*fd**2*s**2 + 25000*D1**2*f*fd**2*s - 6250*D1**2*f*fd**2 + 29832*D1*Dd*b1*f**2*r**2 + 59664*D1*Dd*b1*f**2*r*s - 44748*D1*Dd*b1*f**2*r + 29832*D1*Dd*b1*f**2*s**2 - 44748*D1*Dd*b1*f**2*s + 22374*D1*Dd*b1*f**2 - 66000*D1*Dd*b1*f*fd*r**2 - 132000*D1*Dd*b1*f*fd*r*s + 82500*D1*Dd*b1*f*fd*r - 66000*D1*Dd*b1*f*fd*s**2 + 82500*D1*Dd*b1*f*fd*s - 24750*D1*Dd*b1*f*fd + 21832*D1*Dd*f**3*r**2 + 43664*D1*Dd*f**3*r*s - 32748*D1*Dd*f**3*r + 21832*D1*Dd*f**3*s**2 - 32748*D1*Dd*f**3*s + 16374*D1*Dd*f**3 - 75000*D1*Dd*f**2*fd*r**2 - 150000*D1*Dd*f**2*fd*r*s + 106250*D1*Dd*f**2*fd*r - 75000*D1*Dd*f**2*fd*s**2 + 106250*D1*Dd*f**2*fd*s - 37500*D1*Dd*f**2*fd - 16500*D1*Ddd*b1*f**2*r**2 - 33000*D1*Ddd*b1*f**2*r*s + 24750*D1*Ddd*b1*f**2*r - 16500*D1*Ddd*b1*f**2*s**2 + 24750*D1*Ddd*b1*f**2*s - 12375*D1*Ddd*b1*f**2 - 12500*D1*Ddd*f**3*r**2 - 25000*D1*Ddd*f**3*r*s + 18750*D1*Ddd*f**3*r - 12500*D1*Ddd*f**3*s**2 + 18750*D1*Ddd*f**3*s - 9375*D1*Ddd*f**3 - 66*D1*bd1*f*(r + s - 1)*(D1*f*(128*C - 113)*(r + s - 1) - D1*fd*(140*C - 125)*(2*r + 2*s - 1) - Dd*f*(140*C - 125)*(4*r + 4*s - 3)) - 49500*Dd**2*b1*f**2*r**2 - 99000*Dd**2*b1*f**2*r*s + 74250*Dd**2*b1*f**2*r - 49500*Dd**2*b1*f**2*s**2 + 74250*Dd**2*b1*f**2*s - 24750*Dd**2*b1*f**2 - 37500*Dd**2*f**3*r**2 - 75000*Dd**2*f**3*r*s + 56250*Dd**2*f**3*r - 37500*Dd**2*f**3*s**2 + 56250*Dd**2*f**3*s - 18750*Dd**2*f**3)/(1386*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**5*k1*k2**5*(51480*C*D1**2*f**2*fd*r**2 + 102960*C*D1**2*f**2*fd*r*s - 68640*C*D1**2*f**2*fd*r + 51480*C*D1**2*f**2*fd*s**2 - 68640*C*D1**2*f**2*fd*s + 34320*C*D1**2*f**2*fd + 68640*C*D1*Dd*f**3*r**2 + 137280*C*D1*Dd*f**3*r*s - 102960*C*D1*Dd*f**3*r + 68640*C*D1*Dd*f**3*s**2 - 102960*C*D1*Dd*f**3*s + 51480*C*D1*Dd*f**3 + 12870*D1**2*K*bdd1*f**2*r**2 + 25740*D1**2*K*bdd1*f**2*r*s - 25740*D1**2*K*bdd1*f**2*r + 12870*D1**2*K*bdd1*f**2*s**2 - 25740*D1**2*K*bdd1*f**2*s + 12870*D1**2*K*bdd1*f**2 - 858*D1**2*bd1**2*f*(-36*K + 25*f + 30)*(r + s - 1)**2 + 9100*D1**2*bdd1*f**3*r**2 + 18200*D1**2*bdd1*f**3*r*s - 18200*D1**2*bdd1*f**3*r + 9100*D1**2*bdd1*f**3*s**2 - 18200*D1**2*bdd1*f**3*s + 9100*D1**2*bdd1*f**3 - 10725*D1**2*bdd1*f**2*r**2 - 21450*D1**2*bdd1*f**2*r*s + 21450*D1**2*bdd1*f**2*r - 10725*D1**2*bdd1*f**2*s**2 + 21450*D1**2*bdd1*f**2*s - 10725*D1**2*bdd1*f**2 - 30888*D1**2*bdd1*f*g2*r**2 - 61776*D1**2*bdd1*f*g2*r*s + 61776*D1**2*bdd1*f*g2*r - 30888*D1**2*bdd1*f*g2*s**2 + 61776*D1**2*bdd1*f*g2*s - 30888*D1**2*bdd1*f*g2 - 75040*D1**2*f**3*fd*r**2 - 150080*D1**2*f**3*fd*r*s + 112560*D1**2*f**3*fd*r - 75040*D1**2*f**3*fd*s**2 + 112560*D1**2*f**3*fd*s - 56280*D1**2*f**3*fd + 63000*D1**2*f**3*fdd*r**2 + 126000*D1**2*f**3*fdd*r*s - 94500*D1**2*f**3*fdd*r + 63000*D1**2*f**3*fdd*s**2 - 94500*D1**2*f**3*fdd*s + 47250*D1**2*f**3*fdd + 189000*D1**2*f**2*fd**2*r**2 + 378000*D1**2*f**2*fd**2*r*s - 283500*D1**2*f**2*fd**2*r + 189000*D1**2*f**2*fd**2*s**2 - 283500*D1**2*f**2*fd**2*s + 94500*D1**2*f**2*fd**2 - 45045*D1**2*f**2*fd*r**2 - 90090*D1**2*f**2*fd*r*s + 60060*D1**2*f**2*fd*r - 45045*D1**2*f**2*fd*s**2 + 60060*D1**2*f**2*fd*s - 30030*D1**2*f**2*fd + 41184*D1**2*f**2*gd2*r**2 + 82368*D1**2*f**2*gd2*r*s - 82368*D1**2*f**2*gd2*r + 41184*D1**2*f**2*gd2*s**2 - 82368*D1**2*f**2*gd2*s + 41184*D1**2*f**2*gd2 - 25740*D1**2*f**2*gdd2*r**2 - 51480*D1**2*f**2*gdd2*r*s + 51480*D1**2*f**2*gdd2*r - 25740*D1**2*f**2*gdd2*s**2 + 51480*D1**2*f**2*gdd2*s - 25740*D1**2*f**2*gdd2 + 82368*D1**2*f*fd*g2*r**2 + 164736*D1**2*f*fd*g2*r*s - 82368*D1**2*f*fd*g2*r + 82368*D1**2*f*fd*g2*s**2 - 82368*D1**2*f*fd*g2*s + 41184*D1**2*f*fd*g2 - 102960*D1**2*f*fd*gd2*r**2 - 205920*D1**2*f*fd*gd2*r*s + 154440*D1**2*f*fd*gd2*r - 102960*D1**2*f*fd*gd2*s**2 + 154440*D1**2*f*fd*gd2*s - 51480*D1**2*f*fd*gd2 - 51480*D1**2*f*fdd*g2*r**2 - 102960*D1**2*f*fdd*g2*r*s + 51480*D1**2*f*fdd*g2*r - 51480*D1**2*f*fdd*g2*s**2 + 51480*D1**2*f*fdd*g2*s - 25740*D1**2*f*fdd*g2 - 51480*D1**2*fd**2*g2*r**2 - 102960*D1**2*fd**2*g2*r*s + 51480*D1**2*fd**2*g2*r - 51480*D1**2*fd**2*g2*s**2 + 51480*D1**2*fd**2*g2*s - 75040*D1*Dd*f**4*r**2 - 150080*D1*Dd*f**4*r*s + 112560*D1*Dd*f**4*r - 75040*D1*Dd*f**4*s**2 + 112560*D1*Dd*f**4*s - 56280*D1*Dd*f**4 + 504000*D1*Dd*f**3*fd*r**2 + 1008000*D1*Dd*f**3*fd*r*s - 756000*D1*Dd*f**3*fd*r + 504000*D1*Dd*f**3*fd*s**2 - 756000*D1*Dd*f**3*fd*s + 283500*D1*Dd*f**3*fd - 60060*D1*Dd*f**3*r**2 - 120120*D1*Dd*f**3*r*s + 90090*D1*Dd*f**3*r - 60060*D1*Dd*f**3*s**2 + 90090*D1*Dd*f**3*s - 45045*D1*Dd*f**3 + 164736*D1*Dd*f**2*g2*r**2 + 329472*D1*Dd*f**2*g2*r*s - 247104*D1*Dd*f**2*g2*r + 164736*D1*Dd*f**2*g2*s**2 - 247104*D1*Dd*f**2*g2*s + 123552*D1*Dd*f**2*g2 - 205920*D1*Dd*f**2*gd2*r**2 - 411840*D1*Dd*f**2*gd2*r*s + 360360*D1*Dd*f**2*gd2*r - 205920*D1*Dd*f**2*gd2*s**2 + 360360*D1*Dd*f**2*gd2*s - 154440*D1*Dd*f**2*gd2 - 411840*D1*Dd*f*fd*g2*r**2 - 823680*D1*Dd*f*fd*g2*r*s + 514800*D1*Dd*f*fd*g2*r - 411840*D1*Dd*f*fd*g2*s**2 + 514800*D1*Dd*f*fd*g2*s - 154440*D1*Dd*f*fd*g2 + 63000*D1*Ddd*f**4*r**2 + 126000*D1*Ddd*f**4*r*s - 94500*D1*Ddd*f**4*r + 63000*D1*Ddd*f**4*s**2 - 94500*D1*Ddd*f**4*s + 47250*D1*Ddd*f**4 - 102960*D1*Ddd*f**2*g2*r**2 - 205920*D1*Ddd*f**2*g2*r*s + 154440*D1*Ddd*f**2*g2*r - 102960*D1*Ddd*f**2*g2*s**2 + 154440*D1*Ddd*f**2*g2*s - 77220*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(575*f**3*(r + s - 1) - 4*f**2*(396*C*(r + s - 1) + 350*fd*(3*r + 3*s - 2) - (396*K + 33)*(r + s - 1)) - 66*f*(5*fd*(6*K - 5)*(2*r + 2*s - 1) + (58*g2 - 72*gd2)*(r + s - 1)) + 4752*fd*g2*(r + s)) - 2*Dd*f*(700*f**2 + 165*f*(6*K - 5) - 2376*g2)*(4*r + 4*s - 3))*(r + s - 1) + 189000*Dd**2*f**4*r**2 + 378000*Dd**2*f**4*r*s - 283500*Dd**2*f**4*r + 189000*Dd**2*f**4*s**2 - 283500*Dd**2*f**4*s + 94500*Dd**2*f**4 - 308880*Dd**2*f**2*g2*r**2 - 617760*Dd**2*f**2*g2*r*s + 463320*Dd**2*f**2*g2*r - 308880*Dd**2*f**2*g2*s**2 + 463320*Dd**2*f**2*g2*s - 154440*Dd**2*f**2*g2 + 429*b1**2*(D1**2*(f*(38*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(25*fd**2*(r + s - 1) + fd*(29*K - 23)*(r + s) - 3*fdd*(6*K - 5)*(r + s))) + D1*(2*Dd*(19*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(25*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (29*K - 23)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(6*K - 5)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-36*K + 25*f + 30)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-36*K + 25*f + 30)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(3168*C*D1**2*f*fd*r**2 + 6336*C*D1**2*f*fd*r*s - 3168*C*D1**2*f*fd*r + 3168*C*D1**2*f*fd*s**2 - 3168*C*D1**2*f*fd*s + 1584*C*D1**2*f*fd + 6336*C*D1*Dd*f**2*r**2 + 12672*C*D1*Dd*f**2*r*s - 9504*C*D1*Dd*f**2*r + 6336*C*D1*Dd*f**2*s**2 - 9504*C*D1*Dd*f**2*s + 4752*C*D1*Dd*f**2 - 3168*D1**2*K*f*fd*r**2 - 6336*D1**2*K*f*fd*r*s + 3168*D1**2*K*f*fd*r - 3168*D1**2*K*f*fd*s**2 + 3168*D1**2*K*f*fd*s - 1584*D1**2*K*f*fd + 1980*D1**2*K*f*fdd*r**2 + 3960*D1**2*K*f*fdd*r*s - 1980*D1**2*K*f*fdd*r + 1980*D1**2*K*f*fdd*s**2 - 1980*D1**2*K*f*fdd*s + 990*D1**2*K*f*fdd + 1980*D1**2*K*fd**2*r**2 + 3960*D1**2*K*fd**2*r*s - 1980*D1**2*K*fd**2*r + 1980*D1**2*K*fd**2*s**2 - 1980*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(-36*K + 25*f + 30)*(r + s - 1)**2 - 1725*D1**2*f**2*fd*r**2 - 3450*D1**2*f**2*fd*r*s + 2300*D1**2*f**2*fd*r - 1725*D1**2*f**2*fd*s**2 + 2300*D1**2*f**2*fd*s - 1150*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd - 1650*D1**2*f*fdd*r**2 - 3300*D1**2*f*fdd*r*s + 1650*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1650*D1**2*f*fdd*s - 825*D1**2*f*fdd + 3828*D1**2*f*gd2*r**2 + 7656*D1**2*f*gd2*r*s - 7656*D1**2*f*gd2*r + 3828*D1**2*f*gd2*s**2 - 7656*D1**2*f*gd2*s + 3828*D1**2*f*gd2 - 2376*D1**2*f*gdd2*r**2 - 4752*D1**2*f*gdd2*r*s + 4752*D1**2*f*gdd2*r - 2376*D1**2*f*gdd2*s**2 + 4752*D1**2*f*gdd2*s - 2376*D1**2*f*gdd2 - 1650*D1**2*fd**2*r**2 - 3300*D1**2*fd**2*r*s + 1650*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1650*D1**2*fd**2*s + 3828*D1**2*fd*g2*r**2 + 7656*D1**2*fd*g2*r*s + 3828*D1**2*fd*g2*s**2 - 4752*D1**2*fd*gd2*r**2 - 9504*D1**2*fd*gd2*r*s + 4752*D1**2*fd*gd2*r - 4752*D1**2*fd*gd2*s**2 + 4752*D1**2*fd*gd2*s - 2376*D1**2*fdd*g2*r**2 - 4752*D1**2*fdd*g2*r*s - 2376*D1**2*fdd*g2*s**2 - 6336*D1*Dd*K*f**2*r**2 - 12672*D1*Dd*K*f**2*r*s + 9504*D1*Dd*K*f**2*r - 6336*D1*Dd*K*f**2*s**2 + 9504*D1*Dd*K*f**2*s - 4752*D1*Dd*K*f**2 + 15840*D1*Dd*K*f*fd*r**2 + 31680*D1*Dd*K*f*fd*r*s - 19800*D1*Dd*K*f*fd*r + 15840*D1*Dd*K*f*fd*s**2 - 19800*D1*Dd*K*f*fd*s + 5940*D1*Dd*K*f*fd - 2300*D1*Dd*f**3*r**2 - 4600*D1*Dd*f**3*r*s + 3450*D1*Dd*f**3*r - 2300*D1*Dd*f**3*s**2 + 3450*D1*Dd*f**3*s - 1725*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 23800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 23800*D1*Dd*f**2*fd*s + 8400*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 - 13200*D1*Dd*f*fd*r**2 - 26400*D1*Dd*f*fd*r*s + 16500*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 16500*D1*Dd*f*fd*s - 4950*D1*Dd*f*fd + 15312*D1*Dd*f*g2*r**2 + 30624*D1*Dd*f*g2*r*s - 22968*D1*Dd*f*g2*r + 15312*D1*Dd*f*g2*s**2 - 22968*D1*Dd*f*g2*s + 11484*D1*Dd*f*g2 - 19008*D1*Dd*f*gd2*r**2 - 38016*D1*Dd*f*gd2*r*s + 33264*D1*Dd*f*gd2*r - 19008*D1*Dd*f*gd2*s**2 + 33264*D1*Dd*f*gd2*s - 14256*D1*Dd*f*gd2 - 19008*D1*Dd*fd*g2*r**2 - 38016*D1*Dd*fd*g2*r*s + 14256*D1*Dd*fd*g2*r - 19008*D1*Dd*fd*g2*s**2 + 14256*D1*Dd*fd*g2*s + 3960*D1*Ddd*K*f**2*r**2 + 7920*D1*Ddd*K*f**2*r*s - 5940*D1*Ddd*K*f**2*r + 3960*D1*Ddd*K*f**2*s**2 - 5940*D1*Ddd*K*f**2*s + 2970*D1*Ddd*K*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 - 3300*D1*Ddd*f**2*r**2 - 6600*D1*Ddd*f**2*r*s + 4950*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 4950*D1*Ddd*f**2*s - 2475*D1*Ddd*f**2 - 9504*D1*Ddd*f*g2*r**2 - 19008*D1*Ddd*f*g2*r*s + 14256*D1*Ddd*f*g2*r - 9504*D1*Ddd*f*g2*s**2 + 14256*D1*Ddd*f*g2*s - 7128*D1*Ddd*f*g2 + 132*D1*bd1*(D1*(19*f**2*(r + s - 1) - 25*f*fd*(2*r + 2*s - 1) - f*(29*K - 23)*(r + s - 1) + 6*fd*(6*K - 5)*(r + s)) - Dd*f*(-36*K + 25*f + 30)*(4*r + 4*s - 3))*(r + s - 1) + 11880*Dd**2*K*f**2*r**2 + 23760*Dd**2*K*f**2*r*s - 17820*Dd**2*K*f**2*r + 11880*Dd**2*K*f**2*s**2 - 17820*Dd**2*K*f**2*s + 5940*Dd**2*K*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3 - 9900*Dd**2*f**2*r**2 - 19800*Dd**2*f**2*r*s + 14850*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 14850*Dd**2*f**2*s - 4950*Dd**2*f**2 - 28512*Dd**2*f*g2*r**2 - 57024*Dd**2*f*g2*r*s + 42768*Dd**2*f*g2*r - 28512*Dd**2*f*g2*s**2 + 42768*Dd**2*f*g2*s - 14256*Dd**2*f*g2))/(9009*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**5*k1*k2**3*(-66*b1**2*(D1**2*(fd*(34*C - 28) + fdd*(21 - 24*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(17*C - 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(21 - 24*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(21 - 24*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(144*C - 126)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-112*C*D1**2*f*fd*r - 112*C*D1**2*f*fd*s + 56*C*D1**2*f*fd + 80*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s - 40*C*D1**2*f*fdd + 80*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s - 80*C*D1**2*fd**2 + 320*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s - 240*C*D1*Dd*f*fd - 6*D1**2*bdd1*f*(8*C - 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 24*D1**2*f*fd*r**2 + 48*D1**2*f*fd*r*s + 68*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 + 68*D1**2*f*fd*s - 34*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s - 40*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 - 40*D1**2*f*fdd*s + 20*D1**2*f*fdd - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s - 40*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 - 40*D1**2*fd**2*s + 70*D1**2*fd**2 + 48*D1*Dd*f**2*r**2 + 96*D1*Dd*f**2*r*s - 72*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 36*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd*s + 120*D1*Dd*f*fd - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 + 4*D1*bd1*(D1*(f*(17*C - 14)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(21 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(21 - 24*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2) + f*(396*D1**2*bd1**2*(8*C - 7)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 165*D1**2*bdd1*f*(8*C*(2*r + 2*s - 1) + 3*r**2 + r*(6*s - 20) + 3*s**2 - 20*s + 10) + 5*D1**2*(f*(fd*(316*C - 329) + fdd*(280 - 224*C))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(560 - 448*C)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 66*D1*bd1*(D1*f*(28*C*(2*r + 2*s - 1) + 6*r**2 + 2*r*(6*s - 29) + 6*s**2 - 58*s + 29) - 10*D1*fd*(r + s - 1)*(4*C + 3*r + 3*s - 5) - 5*Dd*f*(4*r + 4*s - 3)*(8*C + 3*r + 3*s - 10)) + 5*D1*f*(Dd*(f*(316*C - 329)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(448*C - 560)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + Ddd*f*(280 - 224*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 5*Dd**2*f**2*(1680 - 1344*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k3**4) - 5*D1**2*Pk1*Pkdd3*ct**5*k2**5*st**2*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 150*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 - 200*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 200*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 150*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3)/(462*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct**5*k2**5*(D1*f*(66*D1*bd1**2*(r + s - 1)*(5*f*(2*r + 2*s - 1) + 6*r + 6*s - 6) - 2*bd1*(D1*(140*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*f*(r + s - 1)*(140*fd*(3*r + 3*s - 1) - 33*r - 33*s + 33) - 165*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 5*Dd*f*(4*r + 4*s - 3)*(28*f*(2*r + 2*s - 1) + 33*r + 33*s - 33)) + 5*f*(D1*bdd1*(28*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 33*(r + s - 1)**2) + 33*D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 33*Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 33*b1**2*(D1**2*(5*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 12*fd*(r + s)**2 - 6*fdd*(r + s)**2) + 2*D1*(Dd*(10*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-5*fd*(4*r + 4*s - 3)**2 + 24*r**2 + 48*r*s - 36*r + 24*s**2 - 36*s + 18) - 6*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(5*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(5*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(33*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 12*(r + s - 1)**2) - 1680*D1**2*f**2*fd*r**2 - 3360*D1**2*f**2*fd*r*s + 2800*D1**2*f**2*fd*r - 1680*D1**2*f**2*fd*s**2 + 2800*D1**2*f**2*fd*s - 1400*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 + 1680*D1**2*f**2*fdd*r*s - 1400*D1**2*f**2*fdd*r + 840*D1**2*f**2*fdd*s**2 - 1400*D1**2*f**2*fdd*s + 700*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r**2 + 3360*D1**2*f*fd**2*r*s - 2800*D1**2*f*fd**2*r + 1680*D1**2*f*fd**2*s**2 - 2800*D1**2*f*fd**2*s + 1120*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd + 330*D1**2*f*fdd*r**2 + 660*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 330*D1**2*f*fdd*s**2 - 330*D1**2*f*fdd*s + 165*D1**2*f*fdd + 330*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 330*D1**2*fd**2*s**2 - 330*D1**2*fd**2*s - 2240*D1*Dd*f**3*r**2 - 4480*D1*Dd*f**3*r*s + 3360*D1*Dd*f**3*r - 2240*D1*Dd*f**3*s**2 + 3360*D1*Dd*f**3*s - 1680*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 + 13440*D1*Dd*f**2*fd*r*s - 10640*D1*Dd*f**2*fd*r + 6720*D1*Dd*f**2*fd*s**2 - 10640*D1*Dd*f**2*fd*s + 4200*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 + 5280*D1*Dd*f*fd*r*s - 3300*D1*Dd*f*fd*r + 2640*D1*Dd*f*fd*s**2 - 3300*D1*Dd*f*fd*s + 990*D1*Dd*f*fd + 1120*D1*Ddd*f**3*r**2 + 2240*D1*Ddd*f**3*r*s - 1680*D1*Ddd*f**3*r + 1120*D1*Ddd*f**3*s**2 - 1680*D1*Ddd*f**3*s + 840*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 + 1320*D1*Ddd*f**2*r*s - 990*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s**2 - 990*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 - 66*D1*bd1*(D1*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 4*f*(r + s - 1)*(5*fd*(2*r + 2*s - 1) - 3*r - 3*s + 3) - 12*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 12*r + 12*s - 12)) + 3360*Dd**2*f**3*r**2 + 6720*Dd**2*f**3*r*s - 5040*Dd**2*f**3*r + 3360*Dd**2*f**3*s**2 - 5040*Dd**2*f**3*s + 1680*Dd**2*f**3 + 1980*Dd**2*f**2*r**2 + 3960*Dd**2*f**2*r*s - 2970*Dd**2*f**2*r + 1980*Dd**2*f**2*s**2 - 2970*Dd**2*f**2*s + 990*Dd**2*f**2))/(693*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct**5*k2**3*(D1*f*(r + s)*(12*D1*bd1**2*(r + s - 1) + 5*D1*bdd1*f*(r + s) + 10*bd1*(-D1*f*(r + s) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) - 6*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(6*D1**2*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*D1**2*(r + s - 1)**2*(2*f*fd - f*fdd - fd**2) - 12*D1*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k1*k3**2) - D1**2*Pk1*Pkdd3*ct**4*f*k2**6*st**4*(10*C - 10)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**4*k1**4*k2**2*(-8712*C*D1**2*b1*f*fd*r**2 - 17424*C*D1**2*b1*f*fd*r*s + 8712*C*D1**2*b1*f*fd*r - 8712*C*D1**2*b1*f*fd*s**2 + 8712*C*D1**2*b1*f*fd*s - 4356*C*D1**2*b1*f*fd + 9900*C*D1**2*b1*f*fdd*r**2 + 19800*C*D1**2*b1*f*fdd*r*s - 9900*C*D1**2*b1*f*fdd*r + 9900*C*D1**2*b1*f*fdd*s**2 - 9900*C*D1**2*b1*f*fdd*s + 4950*C*D1**2*b1*f*fdd + 9900*C*D1**2*b1*fd**2*r**2 + 19800*C*D1**2*b1*fd**2*r*s - 9900*C*D1**2*b1*fd**2*r + 9900*C*D1**2*b1*fd**2*s**2 - 9900*C*D1**2*b1*fd**2*s - 11340*C*D1**2*f**2*fd*r**2 - 22680*C*D1**2*f**2*fd*r*s + 15120*C*D1**2*f**2*fd*r - 11340*C*D1**2*f**2*fd*s**2 + 15120*C*D1**2*f**2*fd*s - 7560*C*D1**2*f**2*fd + 12600*C*D1**2*f**2*fdd*r**2 + 25200*C*D1**2*f**2*fdd*r*s - 16800*C*D1**2*f**2*fdd*r + 12600*C*D1**2*f**2*fdd*s**2 - 16800*C*D1**2*f**2*fdd*s + 8400*C*D1**2*f**2*fdd + 25200*C*D1**2*f*fd**2*r**2 + 50400*C*D1**2*f*fd**2*r*s - 33600*C*D1**2*f*fd**2*r + 25200*C*D1**2*f*fd**2*s**2 - 33600*C*D1**2*f*fd**2*s + 8400*C*D1**2*f*fd**2 - 17424*C*D1*Dd*b1*f**2*r**2 - 34848*C*D1*Dd*b1*f**2*r*s + 26136*C*D1*Dd*b1*f**2*r - 17424*C*D1*Dd*b1*f**2*s**2 + 26136*C*D1*Dd*b1*f**2*s - 13068*C*D1*Dd*b1*f**2 + 79200*C*D1*Dd*b1*f*fd*r**2 + 158400*C*D1*Dd*b1*f*fd*r*s - 99000*C*D1*Dd*b1*f*fd*r + 79200*C*D1*Dd*b1*f*fd*s**2 - 99000*C*D1*Dd*b1*f*fd*s + 29700*C*D1*Dd*b1*f*fd - 15120*C*D1*Dd*f**3*r**2 - 30240*C*D1*Dd*f**3*r*s + 22680*C*D1*Dd*f**3*r - 15120*C*D1*Dd*f**3*s**2 + 22680*C*D1*Dd*f**3*s - 11340*C*D1*Dd*f**3 + 100800*C*D1*Dd*f**2*fd*r**2 + 201600*C*D1*Dd*f**2*fd*r*s - 142800*C*D1*Dd*f**2*fd*r + 100800*C*D1*Dd*f**2*fd*s**2 - 142800*C*D1*Dd*f**2*fd*s + 50400*C*D1*Dd*f**2*fd + 19800*C*D1*Ddd*b1*f**2*r**2 + 39600*C*D1*Ddd*b1*f**2*r*s - 29700*C*D1*Ddd*b1*f**2*r + 19800*C*D1*Ddd*b1*f**2*s**2 - 29700*C*D1*Ddd*b1*f**2*s + 14850*C*D1*Ddd*b1*f**2 + 16800*C*D1*Ddd*f**3*r**2 + 33600*C*D1*Ddd*f**3*r*s - 25200*C*D1*Ddd*f**3*r + 16800*C*D1*Ddd*f**3*s**2 - 25200*C*D1*Ddd*f**3*s + 12600*C*D1*Ddd*f**3 + 59400*C*Dd**2*b1*f**2*r**2 + 118800*C*Dd**2*b1*f**2*r*s - 89100*C*Dd**2*b1*f**2*r + 59400*C*Dd**2*b1*f**2*s**2 - 89100*C*Dd**2*b1*f**2*s + 29700*C*Dd**2*b1*f**2 + 50400*C*Dd**2*f**3*r**2 + 100800*C*Dd**2*f**3*r*s - 75600*C*Dd**2*f**3*r + 50400*C*Dd**2*f**3*s**2 - 75600*C*Dd**2*f**3*s + 25200*C*Dd**2*f**3 + 5676*D1**2*b1*f*fd*r**2 + 11352*D1**2*b1*f*fd*r*s - 5676*D1**2*b1*f*fd*r + 5676*D1**2*b1*f*fd*s**2 - 5676*D1**2*b1*f*fd*s + 2838*D1**2*b1*f*fd - 6600*D1**2*b1*f*fdd*r**2 - 13200*D1**2*b1*f*fdd*r*s + 6600*D1**2*b1*f*fdd*r - 6600*D1**2*b1*f*fdd*s**2 + 6600*D1**2*b1*f*fdd*s - 3300*D1**2*b1*f*fdd - 6600*D1**2*b1*fd**2*r**2 - 13200*D1**2*b1*fd**2*r*s + 6600*D1**2*b1*fd**2*r - 6600*D1**2*b1*fd**2*s**2 + 6600*D1**2*b1*fd**2*s + 1650*D1**2*bdd1*f**2*(3*C - 2)*(r + s - 1)**2 + 7395*D1**2*f**2*fd*r**2 + 14790*D1**2*f**2*fd*r*s - 9860*D1**2*f**2*fd*r + 7395*D1**2*f**2*fd*s**2 - 9860*D1**2*f**2*fd*s + 4930*D1**2*f**2*fd - 8400*D1**2*f**2*fdd*r**2 - 16800*D1**2*f**2*fdd*r*s + 11200*D1**2*f**2*fdd*r - 8400*D1**2*f**2*fdd*s**2 + 11200*D1**2*f**2*fdd*s - 5600*D1**2*f**2*fdd - 16800*D1**2*f*fd**2*r**2 - 33600*D1**2*f*fd**2*r*s + 22400*D1**2*f*fd**2*r - 16800*D1**2*f*fd**2*s**2 + 22400*D1**2*f*fd**2*s - 5600*D1**2*f*fd**2 + 11352*D1*Dd*b1*f**2*r**2 + 22704*D1*Dd*b1*f**2*r*s - 17028*D1*Dd*b1*f**2*r + 11352*D1*Dd*b1*f**2*s**2 - 17028*D1*Dd*b1*f**2*s + 8514*D1*Dd*b1*f**2 - 52800*D1*Dd*b1*f*fd*r**2 - 105600*D1*Dd*b1*f*fd*r*s + 66000*D1*Dd*b1*f*fd*r - 52800*D1*Dd*b1*f*fd*s**2 + 66000*D1*Dd*b1*f*fd*s - 19800*D1*Dd*b1*f*fd + 9860*D1*Dd*f**3*r**2 + 19720*D1*Dd*f**3*r*s - 14790*D1*Dd*f**3*r + 9860*D1*Dd*f**3*s**2 - 14790*D1*Dd*f**3*s + 7395*D1*Dd*f**3 - 67200*D1*Dd*f**2*fd*r**2 - 134400*D1*Dd*f**2*fd*r*s + 95200*D1*Dd*f**2*fd*r - 67200*D1*Dd*f**2*fd*s**2 + 95200*D1*Dd*f**2*fd*s - 33600*D1*Dd*f**2*fd - 13200*D1*Ddd*b1*f**2*r**2 - 26400*D1*Ddd*b1*f**2*r*s + 19800*D1*Ddd*b1*f**2*r - 13200*D1*Ddd*b1*f**2*s**2 + 19800*D1*Ddd*b1*f**2*s - 9900*D1*Ddd*b1*f**2 - 11200*D1*Ddd*f**3*r**2 - 22400*D1*Ddd*f**3*r*s + 16800*D1*Ddd*f**3*r - 11200*D1*Ddd*f**3*s**2 + 16800*D1*Ddd*f**3*s - 8400*D1*Ddd*f**3 - 66*D1*bd1*f*(r + s - 1)*(D1*f*(66*C - 43)*(r + s - 1) - D1*fd*(150*C - 100)*(2*r + 2*s - 1) - Dd*f*(150*C - 100)*(4*r + 4*s - 3)) - 39600*Dd**2*b1*f**2*r**2 - 79200*Dd**2*b1*f**2*r*s + 59400*Dd**2*b1*f**2*r - 39600*Dd**2*b1*f**2*s**2 + 59400*Dd**2*b1*f**2*s - 19800*Dd**2*b1*f**2 - 33600*Dd**2*f**3*r**2 - 67200*Dd**2*f**3*r*s + 50400*Dd**2*f**3*r - 33600*Dd**2*f**3*s**2 + 50400*Dd**2*f**3*s - 16800*Dd**2*f**3)/(693*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**4*k1**2*k2**4*st**2*(-29040*C*D1**2*b1*f*fd*r**2 - 58080*C*D1**2*b1*f*fd*r*s + 29040*C*D1**2*b1*f*fd*r - 29040*C*D1**2*b1*f*fd*s**2 + 29040*C*D1**2*b1*f*fd*s - 14520*C*D1**2*b1*f*fd + 17292*C*D1**2*b1*f*fdd*r**2 + 34584*C*D1**2*b1*f*fdd*r*s - 17292*C*D1**2*b1*f*fdd*r + 17292*C*D1**2*b1*f*fdd*s**2 - 17292*C*D1**2*b1*f*fdd*s + 8646*C*D1**2*b1*f*fdd + 17292*C*D1**2*b1*fd**2*r**2 + 34584*C*D1**2*b1*fd**2*r*s - 17292*C*D1**2*b1*fd**2*r + 17292*C*D1**2*b1*fd**2*s**2 - 17292*C*D1**2*b1*fd**2*s - 30984*C*D1**2*f**2*fd*r**2 - 61968*C*D1**2*f**2*fd*r*s + 41312*C*D1**2*f**2*fd*r - 30984*C*D1**2*f**2*fd*s**2 + 41312*C*D1**2*f**2*fd*s - 20656*C*D1**2*f**2*fd + 19650*C*D1**2*f**2*fdd*r**2 + 39300*C*D1**2*f**2*fdd*r*s - 26200*C*D1**2*f**2*fdd*r + 19650*C*D1**2*f**2*fdd*s**2 - 26200*C*D1**2*f**2*fdd*s + 13100*C*D1**2*f**2*fdd + 39300*C*D1**2*f*fd**2*r**2 + 78600*C*D1**2*f*fd**2*r*s - 52400*C*D1**2*f*fd**2*r + 39300*C*D1**2*f*fd**2*s**2 - 52400*C*D1**2*f*fd**2*s + 13100*C*D1**2*f*fd**2 - 58080*C*D1*Dd*b1*f**2*r**2 - 116160*C*D1*Dd*b1*f**2*r*s + 87120*C*D1*Dd*b1*f**2*r - 58080*C*D1*Dd*b1*f**2*s**2 + 87120*C*D1*Dd*b1*f**2*s - 43560*C*D1*Dd*b1*f**2 + 138336*C*D1*Dd*b1*f*fd*r**2 + 276672*C*D1*Dd*b1*f*fd*r*s - 172920*C*D1*Dd*b1*f*fd*r + 138336*C*D1*Dd*b1*f*fd*s**2 - 172920*C*D1*Dd*b1*f*fd*s + 51876*C*D1*Dd*b1*f*fd - 41312*C*D1*Dd*f**3*r**2 - 82624*C*D1*Dd*f**3*r*s + 61968*C*D1*Dd*f**3*r - 41312*C*D1*Dd*f**3*s**2 + 61968*C*D1*Dd*f**3*s - 30984*C*D1*Dd*f**3 + 157200*C*D1*Dd*f**2*fd*r**2 + 314400*C*D1*Dd*f**2*fd*r*s - 222700*C*D1*Dd*f**2*fd*r + 157200*C*D1*Dd*f**2*fd*s**2 - 222700*C*D1*Dd*f**2*fd*s + 78600*C*D1*Dd*f**2*fd + 34584*C*D1*Ddd*b1*f**2*r**2 + 69168*C*D1*Ddd*b1*f**2*r*s - 51876*C*D1*Ddd*b1*f**2*r + 34584*C*D1*Ddd*b1*f**2*s**2 - 51876*C*D1*Ddd*b1*f**2*s + 25938*C*D1*Ddd*b1*f**2 + 26200*C*D1*Ddd*f**3*r**2 + 52400*C*D1*Ddd*f**3*r*s - 39300*C*D1*Ddd*f**3*r + 26200*C*D1*Ddd*f**3*s**2 - 39300*C*D1*Ddd*f**3*s + 19650*C*D1*Ddd*f**3 + 103752*C*Dd**2*b1*f**2*r**2 + 207504*C*Dd**2*b1*f**2*r*s - 155628*C*Dd**2*b1*f**2*r + 103752*C*Dd**2*b1*f**2*s**2 - 155628*C*Dd**2*b1*f**2*s + 51876*C*Dd**2*b1*f**2 + 78600*C*Dd**2*f**3*r**2 + 157200*C*Dd**2*f**3*r*s - 117900*C*Dd**2*f**3*r + 78600*C*Dd**2*f**3*s**2 - 117900*C*Dd**2*f**3*s + 39300*C*Dd**2*f**3 + 22572*D1**2*b1*f*fd*r**2 + 45144*D1**2*b1*f*fd*r*s - 22572*D1**2*b1*f*fd*r + 22572*D1**2*b1*f*fd*s**2 - 22572*D1**2*b1*f*fd*s + 11286*D1**2*b1*f*fd - 13662*D1**2*b1*f*fdd*r**2 - 27324*D1**2*b1*f*fdd*r*s + 13662*D1**2*b1*f*fdd*r - 13662*D1**2*b1*f*fdd*s**2 + 13662*D1**2*b1*f*fdd*s - 6831*D1**2*b1*f*fdd - 13662*D1**2*b1*fd**2*r**2 - 27324*D1**2*b1*fd**2*r*s + 13662*D1**2*b1*fd**2*r - 13662*D1**2*b1*fd**2*s**2 + 13662*D1**2*b1*fd**2*s + 33*D1**2*bdd1*f**2*(262*C - 207)*(r + s - 1)**2 + 23922*D1**2*f**2*fd*r**2 + 47844*D1**2*f**2*fd*r*s - 31896*D1**2*f**2*fd*r + 23922*D1**2*f**2*fd*s**2 - 31896*D1**2*f**2*fd*s + 15948*D1**2*f**2*fd - 15525*D1**2*f**2*fdd*r**2 - 31050*D1**2*f**2*fdd*r*s + 20700*D1**2*f**2*fdd*r - 15525*D1**2*f**2*fdd*s**2 + 20700*D1**2*f**2*fdd*s - 10350*D1**2*f**2*fdd - 31050*D1**2*f*fd**2*r**2 - 62100*D1**2*f*fd**2*r*s + 41400*D1**2*f*fd**2*r - 31050*D1**2*f*fd**2*s**2 + 41400*D1**2*f*fd**2*s - 10350*D1**2*f*fd**2 + 45144*D1*Dd*b1*f**2*r**2 + 90288*D1*Dd*b1*f**2*r*s - 67716*D1*Dd*b1*f**2*r + 45144*D1*Dd*b1*f**2*s**2 - 67716*D1*Dd*b1*f**2*s + 33858*D1*Dd*b1*f**2 - 109296*D1*Dd*b1*f*fd*r**2 - 218592*D1*Dd*b1*f*fd*r*s + 136620*D1*Dd*b1*f*fd*r - 109296*D1*Dd*b1*f*fd*s**2 + 136620*D1*Dd*b1*f*fd*s - 40986*D1*Dd*b1*f*fd + 31896*D1*Dd*f**3*r**2 + 63792*D1*Dd*f**3*r*s - 47844*D1*Dd*f**3*r + 31896*D1*Dd*f**3*s**2 - 47844*D1*Dd*f**3*s + 23922*D1*Dd*f**3 - 124200*D1*Dd*f**2*fd*r**2 - 248400*D1*Dd*f**2*fd*r*s + 175950*D1*Dd*f**2*fd*r - 124200*D1*Dd*f**2*fd*s**2 + 175950*D1*Dd*f**2*fd*s - 62100*D1*Dd*f**2*fd - 27324*D1*Ddd*b1*f**2*r**2 - 54648*D1*Ddd*b1*f**2*r*s + 40986*D1*Ddd*b1*f**2*r - 27324*D1*Ddd*b1*f**2*s**2 + 40986*D1*Ddd*b1*f**2*s - 20493*D1*Ddd*b1*f**2 - 20700*D1*Ddd*f**3*r**2 - 41400*D1*Ddd*f**3*r*s + 31050*D1*Ddd*f**3*r - 20700*D1*Ddd*f**3*s**2 + 31050*D1*Ddd*f**3*s - 15525*D1*Ddd*f**3 - 66*D1*bd1*f*(r + s - 1)*(D1*f*(220*C - 171)*(r + s - 1) - D1*fd*(262*C - 207)*(2*r + 2*s - 1) - Dd*f*(262*C - 207)*(4*r + 4*s - 3)) - 81972*Dd**2*b1*f**2*r**2 - 163944*Dd**2*b1*f**2*r*s + 122958*Dd**2*b1*f**2*r - 81972*Dd**2*b1*f**2*s**2 + 122958*Dd**2*b1*f**2*s - 40986*Dd**2*b1*f**2 - 62100*Dd**2*f**3*r**2 - 124200*Dd**2*f**3*r*s + 93150*Dd**2*f**3*r - 62100*Dd**2*f**3*s**2 + 93150*Dd**2*f**3*s - 31050*Dd**2*f**3)/(1386*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**4*k1**2*k2**4*(25740*C*D1**2*f**2*fd*r**2 + 51480*C*D1**2*f**2*fd*r*s - 34320*C*D1**2*f**2*fd*r + 25740*C*D1**2*f**2*fd*s**2 - 34320*C*D1**2*f**2*fd*s + 17160*C*D1**2*f**2*fd + 34320*C*D1*Dd*f**3*r**2 + 68640*C*D1*Dd*f**3*r*s - 51480*C*D1*Dd*f**3*r + 34320*C*D1*Dd*f**3*s**2 - 51480*C*D1*Dd*f**3*s + 25740*C*D1*Dd*f**3 + 10725*D1**2*K*bdd1*f**2*r**2 + 21450*D1**2*K*bdd1*f**2*r*s - 21450*D1**2*K*bdd1*f**2*r + 10725*D1**2*K*bdd1*f**2*s**2 - 21450*D1**2*K*bdd1*f**2*s + 10725*D1**2*K*bdd1*f**2 - 2860*D1**2*bd1**2*f*(-9*K + 5*f + 6)*(r + s - 1)**2 - 7150*D1**2*bdd1*f**2*r**2 - 14300*D1**2*bdd1*f**2*r*s + 14300*D1**2*bdd1*f**2*r - 7150*D1**2*bdd1*f**2*s**2 + 14300*D1**2*bdd1*f**2*s - 7150*D1**2*bdd1*f**2 - 25740*D1**2*bdd1*f*g2*r**2 - 51480*D1**2*bdd1*f*g2*r*s + 51480*D1**2*bdd1*f*g2*r - 25740*D1**2*bdd1*f*g2*s**2 + 51480*D1**2*bdd1*f*g2*s - 25740*D1**2*bdd1*f*g2 - 20160*D1**2*f**3*fd*r**2 - 40320*D1**2*f**3*fd*r*s + 30240*D1**2*f**3*fd*r - 20160*D1**2*f**3*fd*s**2 + 30240*D1**2*f**3*fd*s - 15120*D1**2*f**3*fd + 21000*D1**2*f**3*fdd*r**2 + 42000*D1**2*f**3*fdd*r*s - 31500*D1**2*f**3*fdd*r + 21000*D1**2*f**3*fdd*s**2 - 31500*D1**2*f**3*fdd*s + 15750*D1**2*f**3*fdd + 63000*D1**2*f**2*fd**2*r**2 + 126000*D1**2*f**2*fd**2*r*s - 94500*D1**2*f**2*fd**2*r + 63000*D1**2*f**2*fd**2*s**2 - 94500*D1**2*f**2*fd**2*s + 31500*D1**2*f**2*fd**2 - 19305*D1**2*f**2*fd*r**2 - 38610*D1**2*f**2*fd*r*s + 25740*D1**2*f**2*fd*r - 19305*D1**2*f**2*fd*s**2 + 25740*D1**2*f**2*fd*s - 12870*D1**2*f**2*fd + 27456*D1**2*f**2*gd2*r**2 + 54912*D1**2*f**2*gd2*r*s - 54912*D1**2*f**2*gd2*r + 27456*D1**2*f**2*gd2*s**2 - 54912*D1**2*f**2*gd2*s + 27456*D1**2*f**2*gd2 - 21450*D1**2*f**2*gdd2*r**2 - 42900*D1**2*f**2*gdd2*r*s + 42900*D1**2*f**2*gdd2*r - 21450*D1**2*f**2*gdd2*s**2 + 42900*D1**2*f**2*gdd2*s - 21450*D1**2*f**2*gdd2 + 54912*D1**2*f*fd*g2*r**2 + 109824*D1**2*f*fd*g2*r*s - 54912*D1**2*f*fd*g2*r + 54912*D1**2*f*fd*g2*s**2 - 54912*D1**2*f*fd*g2*s + 27456*D1**2*f*fd*g2 - 85800*D1**2*f*fd*gd2*r**2 - 171600*D1**2*f*fd*gd2*r*s + 128700*D1**2*f*fd*gd2*r - 85800*D1**2*f*fd*gd2*s**2 + 128700*D1**2*f*fd*gd2*s - 42900*D1**2*f*fd*gd2 - 42900*D1**2*f*fdd*g2*r**2 - 85800*D1**2*f*fdd*g2*r*s + 42900*D1**2*f*fdd*g2*r - 42900*D1**2*f*fdd*g2*s**2 + 42900*D1**2*f*fdd*g2*s - 21450*D1**2*f*fdd*g2 - 42900*D1**2*fd**2*g2*r**2 - 85800*D1**2*fd**2*g2*r*s + 42900*D1**2*fd**2*g2*r - 42900*D1**2*fd**2*g2*s**2 + 42900*D1**2*fd**2*g2*s - 20160*D1*Dd*f**4*r**2 - 40320*D1*Dd*f**4*r*s + 30240*D1*Dd*f**4*r - 20160*D1*Dd*f**4*s**2 + 30240*D1*Dd*f**4*s - 15120*D1*Dd*f**4 + 168000*D1*Dd*f**3*fd*r**2 + 336000*D1*Dd*f**3*fd*r*s - 252000*D1*Dd*f**3*fd*r + 168000*D1*Dd*f**3*fd*s**2 - 252000*D1*Dd*f**3*fd*s + 94500*D1*Dd*f**3*fd - 25740*D1*Dd*f**3*r**2 - 51480*D1*Dd*f**3*r*s + 38610*D1*Dd*f**3*r - 25740*D1*Dd*f**3*s**2 + 38610*D1*Dd*f**3*s - 19305*D1*Dd*f**3 + 109824*D1*Dd*f**2*g2*r**2 + 219648*D1*Dd*f**2*g2*r*s - 164736*D1*Dd*f**2*g2*r + 109824*D1*Dd*f**2*g2*s**2 - 164736*D1*Dd*f**2*g2*s + 82368*D1*Dd*f**2*g2 - 171600*D1*Dd*f**2*gd2*r**2 - 343200*D1*Dd*f**2*gd2*r*s + 300300*D1*Dd*f**2*gd2*r - 171600*D1*Dd*f**2*gd2*s**2 + 300300*D1*Dd*f**2*gd2*s - 128700*D1*Dd*f**2*gd2 - 343200*D1*Dd*f*fd*g2*r**2 - 686400*D1*Dd*f*fd*g2*r*s + 429000*D1*Dd*f*fd*g2*r - 343200*D1*Dd*f*fd*g2*s**2 + 429000*D1*Dd*f*fd*g2*s - 128700*D1*Dd*f*fd*g2 + 21000*D1*Ddd*f**4*r**2 + 42000*D1*Ddd*f**4*r*s - 31500*D1*Ddd*f**4*r + 21000*D1*Ddd*f**4*s**2 - 31500*D1*Ddd*f**4*s + 15750*D1*Ddd*f**4 - 85800*D1*Ddd*f**2*g2*r**2 - 171600*D1*Ddd*f**2*g2*r*s + 128700*D1*Ddd*f**2*g2*r - 85800*D1*Ddd*f**2*g2*s**2 + 128700*D1*Ddd*f**2*g2*s - 64350*D1*Ddd*f**2*g2 + 286*D1*bd1*(D1*(5*f**3*(r + s - 1) + 2*f**2*(18*C - 24*K + 1)*(r + s - 1) + 25*f*fd*(3*K - 2)*(2*r + 2*s - 1) + 9*f*(13*g2 - 20*gd2)*(r + s - 1) - 180*fd*g2*(r + s)) + 5*Dd*f*(5*f*(3*K - 2) - 36*g2)*(4*r + 4*s - 3))*(r + s - 1) + 63000*Dd**2*f**4*r**2 + 126000*Dd**2*f**4*r*s - 94500*Dd**2*f**4*r + 63000*Dd**2*f**4*s**2 - 94500*Dd**2*f**4*s + 31500*Dd**2*f**4 - 257400*Dd**2*f**2*g2*r**2 - 514800*Dd**2*f**2*g2*r*s + 386100*Dd**2*f**2*g2*r - 257400*Dd**2*f**2*g2*s**2 + 386100*Dd**2*f**2*g2*s - 128700*Dd**2*f**2*g2 + 143*b1**2*(D1**2*(2*f*(29*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(117*K - 71)*(r + s) - 30*fdd*(3*K - 2)*(r + s))) + D1*(Dd*(58*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (117*K - 71)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*fd*(3*K - 2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 10*Ddd*f*(-9*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f*(-9*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 143*b1*(144*C*D1**2*f*fd*r**2 + 288*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*r + 144*C*D1**2*f*fd*s**2 - 144*C*D1**2*f*fd*s + 72*C*D1**2*f*fd + 288*C*D1*Dd*f**2*r**2 + 576*C*D1*Dd*f**2*r*s - 432*C*D1*Dd*f**2*r + 288*C*D1*Dd*f**2*s**2 - 432*C*D1*Dd*f**2*s + 216*C*D1*Dd*f**2 - 192*D1**2*K*f*fd*r**2 - 384*D1**2*K*f*fd*r*s + 192*D1**2*K*f*fd*r - 192*D1**2*K*f*fd*s**2 + 192*D1**2*K*f*fd*s - 96*D1**2*K*f*fd + 150*D1**2*K*f*fdd*r**2 + 300*D1**2*K*f*fdd*r*s - 150*D1**2*K*f*fdd*r + 150*D1**2*K*f*fdd*s**2 - 150*D1**2*K*f*fdd*s + 75*D1**2*K*f*fdd + 150*D1**2*K*fd**2*r**2 + 300*D1**2*K*fd**2*r*s - 150*D1**2*K*fd**2*r + 150*D1**2*K*fd**2*s**2 - 150*D1**2*K*fd**2*s - 20*D1**2*bdd1*f*(-9*K + 5*f + 6)*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 100*D1**2*f*fdd*r**2 - 200*D1**2*f*fdd*r*s + 100*D1**2*f*fdd*r - 100*D1**2*f*fdd*s**2 + 100*D1**2*f*fdd*s - 50*D1**2*f*fdd + 234*D1**2*f*gd2*r**2 + 468*D1**2*f*gd2*r*s - 468*D1**2*f*gd2*r + 234*D1**2*f*gd2*s**2 - 468*D1**2*f*gd2*s + 234*D1**2*f*gd2 - 180*D1**2*f*gdd2*r**2 - 360*D1**2*f*gdd2*r*s + 360*D1**2*f*gdd2*r - 180*D1**2*f*gdd2*s**2 + 360*D1**2*f*gdd2*s - 180*D1**2*f*gdd2 - 100*D1**2*fd**2*r**2 - 200*D1**2*fd**2*r*s + 100*D1**2*fd**2*r - 100*D1**2*fd**2*s**2 + 100*D1**2*fd**2*s + 234*D1**2*fd*g2*r**2 + 468*D1**2*fd*g2*r*s + 234*D1**2*fd*g2*s**2 - 360*D1**2*fd*gd2*r**2 - 720*D1**2*fd*gd2*r*s + 360*D1**2*fd*gd2*r - 360*D1**2*fd*gd2*s**2 + 360*D1**2*fd*gd2*s - 180*D1**2*fdd*g2*r**2 - 360*D1**2*fdd*g2*r*s - 180*D1**2*fdd*g2*s**2 - 384*D1*Dd*K*f**2*r**2 - 768*D1*Dd*K*f**2*r*s + 576*D1*Dd*K*f**2*r - 384*D1*Dd*K*f**2*s**2 + 576*D1*Dd*K*f**2*s - 288*D1*Dd*K*f**2 + 1200*D1*Dd*K*f*fd*r**2 + 2400*D1*Dd*K*f*fd*r*s - 1500*D1*Dd*K*f*fd*r + 1200*D1*Dd*K*f*fd*s**2 - 1500*D1*Dd*K*f*fd*s + 450*D1*Dd*K*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 800*D1*Dd*f*fd*r**2 - 1600*D1*Dd*f*fd*r*s + 1000*D1*Dd*f*fd*r - 800*D1*Dd*f*fd*s**2 + 1000*D1*Dd*f*fd*s - 300*D1*Dd*f*fd + 936*D1*Dd*f*g2*r**2 + 1872*D1*Dd*f*g2*r*s - 1404*D1*Dd*f*g2*r + 936*D1*Dd*f*g2*s**2 - 1404*D1*Dd*f*g2*s + 702*D1*Dd*f*g2 - 1440*D1*Dd*f*gd2*r**2 - 2880*D1*Dd*f*gd2*r*s + 2520*D1*Dd*f*gd2*r - 1440*D1*Dd*f*gd2*s**2 + 2520*D1*Dd*f*gd2*s - 1080*D1*Dd*f*gd2 - 1440*D1*Dd*fd*g2*r**2 - 2880*D1*Dd*fd*g2*r*s + 1080*D1*Dd*fd*g2*r - 1440*D1*Dd*fd*g2*s**2 + 1080*D1*Dd*fd*g2*s + 300*D1*Ddd*K*f**2*r**2 + 600*D1*Ddd*K*f**2*r*s - 450*D1*Ddd*K*f**2*r + 300*D1*Ddd*K*f**2*s**2 - 450*D1*Ddd*K*f**2*s + 225*D1*Ddd*K*f**2 - 200*D1*Ddd*f**2*r**2 - 400*D1*Ddd*f**2*r*s + 300*D1*Ddd*f**2*r - 200*D1*Ddd*f**2*s**2 + 300*D1*Ddd*f**2*s - 150*D1*Ddd*f**2 - 720*D1*Ddd*f*g2*r**2 - 1440*D1*Ddd*f*g2*r*s + 1080*D1*Ddd*f*g2*r - 720*D1*Ddd*f*g2*s**2 + 1080*D1*Ddd*f*g2*s - 540*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(58*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(117*K - 71)*(r + s - 1) + 60*fd*(3*K - 2)*(r + s)) - 20*Dd*f*(-9*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 900*Dd**2*K*f**2*r**2 + 1800*Dd**2*K*f**2*r*s - 1350*Dd**2*K*f**2*r + 900*Dd**2*K*f**2*s**2 - 1350*Dd**2*K*f**2*s + 450*Dd**2*K*f**2 - 600*Dd**2*f**2*r**2 - 1200*Dd**2*f**2*r*s + 900*Dd**2*f**2*r - 600*Dd**2*f**2*s**2 + 900*Dd**2*f**2*s - 300*Dd**2*f**2 - 2160*Dd**2*f*g2*r**2 - 4320*Dd**2*f*g2*r*s + 3240*Dd**2*f*g2*r - 2160*Dd**2*f*g2*s**2 + 3240*Dd**2*f*g2*s - 1080*Dd**2*f*g2))/(3003*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**4*k1**2*k2**2*(-66*b1**2*(D1**2*(fd*(37*C - 26) + fdd*(27 - 36*C))*(r + s - 1)**2 + D1*(Dd*(f*(37*C - 26)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(54 - 72*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(27 - 36*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(216*C - 162)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-120*C*D1**2*f*fd*r - 120*C*D1**2*f*fd*s + 60*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s - 60*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 + 480*C*D1*Dd*f*fd*r + 480*C*D1*Dd*f*fd*s - 360*C*D1*Dd*f*fd - 18*D1**2*bdd1*f*(4*C - 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s + 76*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 + 76*D1**2*f*fd*s - 38*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s - 80*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 - 80*D1**2*f*fdd*s + 40*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s - 80*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 - 80*D1**2*fd**2*s + 90*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s - 260*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 - 260*D1*Dd*f*fd*s + 240*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(37*C - 26)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(54 - 72*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(54 - 72*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2) + f*(1188*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 165*D1**2*bdd1*f*(12*C*(2*r + 2*s - 1) + r**2 + 2*r*(s - 10) + s**2 - 20*s + 10) + 5*D1**2*(f*(fd*(342*C - 263) + fdd*(280 - 336*C))*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd**2*(560 - 672*C)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 66*D1*bd1*(D1*f*(30*C*(2*r + 2*s - 1) + 2*r**2 + r*(4*s - 46) + 2*s**2 - 46*s + 23) - 10*D1*fd*(r + s - 1)*(6*C + r + s - 5) - 5*Dd*f*(4*r + 4*s - 3)*(12*C + r + s - 10)) + 5*D1*f*(Dd*(f*(342*C - 263)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(672*C - 560)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + Ddd*f*(280 - 336*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 5*Dd**2*f**2*(2016*C - 1680)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**4*k2**6*st**2*(15444*C*D1**2*f**2*fd*r**2 + 30888*C*D1**2*f**2*fd*r*s - 20592*C*D1**2*f**2*fd*r + 15444*C*D1**2*f**2*fd*s**2 - 20592*C*D1**2*f**2*fd*s + 10296*C*D1**2*f**2*fd + 20592*C*D1*Dd*f**3*r**2 + 41184*C*D1*Dd*f**3*r*s - 30888*C*D1*Dd*f**3*r + 20592*C*D1*Dd*f**3*s**2 - 30888*C*D1*Dd*f**3*s + 15444*C*D1*Dd*f**3 + 2574*D1**2*K*bdd1*f**2*r**2 + 5148*D1**2*K*bdd1*f**2*r*s - 5148*D1**2*K*bdd1*f**2*r + 2574*D1**2*K*bdd1*f**2*s**2 - 5148*D1**2*K*bdd1*f**2*s + 2574*D1**2*K*bdd1*f**2 - 2574*D1**2*bd1**2*f*(-2*K + 5*f + 2)*(r + s - 1)**2 + 19500*D1**2*bdd1*f**3*r**2 + 39000*D1**2*bdd1*f**3*r*s - 39000*D1**2*bdd1*f**3*r + 19500*D1**2*bdd1*f**3*s**2 - 39000*D1**2*bdd1*f**3*s + 19500*D1**2*bdd1*f**3 - 2574*D1**2*bdd1*f**2*r**2 - 5148*D1**2*bdd1*f**2*r*s + 5148*D1**2*bdd1*f**2*r - 2574*D1**2*bdd1*f**2*s**2 + 5148*D1**2*bdd1*f**2*s - 2574*D1**2*bdd1*f**2 - 5148*D1**2*bdd1*f*g2*r**2 - 10296*D1**2*bdd1*f*g2*r*s + 10296*D1**2*bdd1*f*g2*r - 5148*D1**2*bdd1*f*g2*s**2 + 10296*D1**2*bdd1*f*g2*s - 5148*D1**2*bdd1*f*g2 - 121000*D1**2*f**3*fd*r**2 - 242000*D1**2*f**3*fd*r*s + 181500*D1**2*f**3*fd*r - 121000*D1**2*f**3*fd*s**2 + 181500*D1**2*f**3*fd*s - 90750*D1**2*f**3*fd + 73500*D1**2*f**3*fdd*r**2 + 147000*D1**2*f**3*fdd*r*s - 110250*D1**2*f**3*fdd*r + 73500*D1**2*f**3*fdd*s**2 - 110250*D1**2*f**3*fdd*s + 55125*D1**2*f**3*fdd + 220500*D1**2*f**2*fd**2*r**2 + 441000*D1**2*f**2*fd**2*r*s - 330750*D1**2*f**2*fd**2*r + 220500*D1**2*f**2*fd**2*s**2 - 330750*D1**2*f**2*fd**2*s + 110250*D1**2*f**2*fd**2 - 15444*D1**2*f**2*fd*r**2 - 30888*D1**2*f**2*fd*r*s + 20592*D1**2*f**2*fd*r - 15444*D1**2*f**2*fd*s**2 + 20592*D1**2*f**2*fd*s - 10296*D1**2*f**2*fd + 10296*D1**2*f**2*gd2*r**2 + 20592*D1**2*f**2*gd2*r*s - 20592*D1**2*f**2*gd2*r + 10296*D1**2*f**2*gd2*s**2 - 20592*D1**2*f**2*gd2*s + 10296*D1**2*f**2*gd2 - 5148*D1**2*f**2*gdd2*r**2 - 10296*D1**2*f**2*gdd2*r*s + 10296*D1**2*f**2*gdd2*r - 5148*D1**2*f**2*gdd2*s**2 + 10296*D1**2*f**2*gdd2*s - 5148*D1**2*f**2*gdd2 + 20592*D1**2*f*fd*g2*r**2 + 41184*D1**2*f*fd*g2*r*s - 20592*D1**2*f*fd*g2*r + 20592*D1**2*f*fd*g2*s**2 - 20592*D1**2*f*fd*g2*s + 10296*D1**2*f*fd*g2 - 20592*D1**2*f*fd*gd2*r**2 - 41184*D1**2*f*fd*gd2*r*s + 30888*D1**2*f*fd*gd2*r - 20592*D1**2*f*fd*gd2*s**2 + 30888*D1**2*f*fd*gd2*s - 10296*D1**2*f*fd*gd2 - 10296*D1**2*f*fdd*g2*r**2 - 20592*D1**2*f*fdd*g2*r*s + 10296*D1**2*f*fdd*g2*r - 10296*D1**2*f*fdd*g2*s**2 + 10296*D1**2*f*fdd*g2*s - 5148*D1**2*f*fdd*g2 - 10296*D1**2*fd**2*g2*r**2 - 20592*D1**2*fd**2*g2*r*s + 10296*D1**2*fd**2*g2*r - 10296*D1**2*fd**2*g2*s**2 + 10296*D1**2*fd**2*g2*s - 121000*D1*Dd*f**4*r**2 - 242000*D1*Dd*f**4*r*s + 181500*D1*Dd*f**4*r - 121000*D1*Dd*f**4*s**2 + 181500*D1*Dd*f**4*s - 90750*D1*Dd*f**4 + 588000*D1*Dd*f**3*fd*r**2 + 1176000*D1*Dd*f**3*fd*r*s - 882000*D1*Dd*f**3*fd*r + 588000*D1*Dd*f**3*fd*s**2 - 882000*D1*Dd*f**3*fd*s + 330750*D1*Dd*f**3*fd - 20592*D1*Dd*f**3*r**2 - 41184*D1*Dd*f**3*r*s + 30888*D1*Dd*f**3*r - 20592*D1*Dd*f**3*s**2 + 30888*D1*Dd*f**3*s - 15444*D1*Dd*f**3 + 41184*D1*Dd*f**2*g2*r**2 + 82368*D1*Dd*f**2*g2*r*s - 61776*D1*Dd*f**2*g2*r + 41184*D1*Dd*f**2*g2*s**2 - 61776*D1*Dd*f**2*g2*s + 30888*D1*Dd*f**2*g2 - 41184*D1*Dd*f**2*gd2*r**2 - 82368*D1*Dd*f**2*gd2*r*s + 72072*D1*Dd*f**2*gd2*r - 41184*D1*Dd*f**2*gd2*s**2 + 72072*D1*Dd*f**2*gd2*s - 30888*D1*Dd*f**2*gd2 - 82368*D1*Dd*f*fd*g2*r**2 - 164736*D1*Dd*f*fd*g2*r*s + 102960*D1*Dd*f*fd*g2*r - 82368*D1*Dd*f*fd*g2*s**2 + 102960*D1*Dd*f*fd*g2*s - 30888*D1*Dd*f*fd*g2 + 73500*D1*Ddd*f**4*r**2 + 147000*D1*Ddd*f**4*r*s - 110250*D1*Ddd*f**4*r + 73500*D1*Ddd*f**4*s**2 - 110250*D1*Ddd*f**4*s + 55125*D1*Ddd*f**4 - 20592*D1*Ddd*f**2*g2*r**2 - 41184*D1*Ddd*f**2*g2*r*s + 30888*D1*Ddd*f**2*g2*r - 20592*D1*Ddd*f**2*g2*s**2 + 30888*D1*Ddd*f**2*g2*s - 15444*D1*Ddd*f**2*g2 + 156*D1*bd1*(r + s - 1)*(33*C*D1*f**2*(r + s - 1) - D1*(195*f**3*(r + s - 1) + f**2*(33*K*(r + s - 1) - 250*fd*(3*r + 3*s - 2)) - 33*f*(fd*(K - 1)*(2*r + 2*s - 1) + (2*g2 - 2*gd2)*(r + s - 1)) + 66*fd*g2*(r + s)) + Dd*f*(250*f**2 + 33*f*(K - 1) - 66*g2)*(4*r + 4*s - 3)) + 220500*Dd**2*f**4*r**2 + 441000*Dd**2*f**4*r*s - 330750*Dd**2*f**4*r + 220500*Dd**2*f**4*s**2 - 330750*Dd**2*f**4*s + 110250*Dd**2*f**4 - 61776*Dd**2*f**2*g2*r**2 - 123552*Dd**2*f**2*g2*r*s + 92664*Dd**2*f**2*g2*r - 61776*Dd**2*f**2*g2*s**2 + 92664*Dd**2*f**2*g2*s - 30888*Dd**2*f**2*g2 + 1287*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(5*fd**2*(r + s - 1) + 2*fd*(K - 1)*(r + s) - fdd*(K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (2*K - 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*fd*(K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-2*K + 5*f + 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-2*K + 5*f + 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 78*b1*(132*C*D1**2*f*fd*r**2 + 264*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*r + 132*C*D1**2*f*fd*s**2 - 132*C*D1**2*f*fd*s + 66*C*D1**2*f*fd + 264*C*D1*Dd*f**2*r**2 + 528*C*D1*Dd*f**2*r*s - 396*C*D1*Dd*f**2*r + 264*C*D1*Dd*f**2*s**2 - 396*C*D1*Dd*f**2*s + 198*C*D1*Dd*f**2 - 132*D1**2*K*f*fd*r**2 - 264*D1**2*K*f*fd*r*s + 132*D1**2*K*f*fd*r - 132*D1**2*K*f*fd*s**2 + 132*D1**2*K*f*fd*s - 66*D1**2*K*f*fd + 66*D1**2*K*f*fdd*r**2 + 132*D1**2*K*f*fdd*r*s - 66*D1**2*K*f*fdd*r + 66*D1**2*K*f*fdd*s**2 - 66*D1**2*K*f*fdd*s + 33*D1**2*K*f*fdd + 66*D1**2*K*fd**2*r**2 + 132*D1**2*K*fd**2*r*s - 66*D1**2*K*fd**2*r + 66*D1**2*K*fd**2*s**2 - 66*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(-2*K + 5*f + 2)*(r + s - 1)**2 - 1170*D1**2*f**2*fd*r**2 - 2340*D1**2*f**2*fd*r*s + 1560*D1**2*f**2*fd*r - 1170*D1**2*f**2*fd*s**2 + 1560*D1**2*f**2*fd*s - 780*D1**2*f**2*fd + 750*D1**2*f**2*fdd*r**2 + 1500*D1**2*f**2*fdd*r*s - 1000*D1**2*f**2*fdd*r + 750*D1**2*f**2*fdd*s**2 - 1000*D1**2*f**2*fdd*s + 500*D1**2*f**2*fdd + 1500*D1**2*f*fd**2*r**2 + 3000*D1**2*f*fd**2*r*s - 2000*D1**2*f*fd**2*r + 1500*D1**2*f*fd**2*s**2 - 2000*D1**2*f*fd**2*s + 500*D1**2*f*fd**2 - 66*D1**2*f*fdd*r**2 - 132*D1**2*f*fdd*r*s + 66*D1**2*f*fdd*r - 66*D1**2*f*fdd*s**2 + 66*D1**2*f*fdd*s - 33*D1**2*f*fdd + 132*D1**2*f*gd2*r**2 + 264*D1**2*f*gd2*r*s - 264*D1**2*f*gd2*r + 132*D1**2*f*gd2*s**2 - 264*D1**2*f*gd2*s + 132*D1**2*f*gd2 - 66*D1**2*f*gdd2*r**2 - 132*D1**2*f*gdd2*r*s + 132*D1**2*f*gdd2*r - 66*D1**2*f*gdd2*s**2 + 132*D1**2*f*gdd2*s - 66*D1**2*f*gdd2 - 66*D1**2*fd**2*r**2 - 132*D1**2*fd**2*r*s + 66*D1**2*fd**2*r - 66*D1**2*fd**2*s**2 + 66*D1**2*fd**2*s + 132*D1**2*fd*g2*r**2 + 264*D1**2*fd*g2*r*s + 132*D1**2*fd*g2*s**2 - 132*D1**2*fd*gd2*r**2 - 264*D1**2*fd*gd2*r*s + 132*D1**2*fd*gd2*r - 132*D1**2*fd*gd2*s**2 + 132*D1**2*fd*gd2*s - 66*D1**2*fdd*g2*r**2 - 132*D1**2*fdd*g2*r*s - 66*D1**2*fdd*g2*s**2 - 264*D1*Dd*K*f**2*r**2 - 528*D1*Dd*K*f**2*r*s + 396*D1*Dd*K*f**2*r - 264*D1*Dd*K*f**2*s**2 + 396*D1*Dd*K*f**2*s - 198*D1*Dd*K*f**2 + 528*D1*Dd*K*f*fd*r**2 + 1056*D1*Dd*K*f*fd*r*s - 660*D1*Dd*K*f*fd*r + 528*D1*Dd*K*f*fd*s**2 - 660*D1*Dd*K*f*fd*s + 198*D1*Dd*K*f*fd - 1560*D1*Dd*f**3*r**2 - 3120*D1*Dd*f**3*r*s + 2340*D1*Dd*f**3*r - 1560*D1*Dd*f**3*s**2 + 2340*D1*Dd*f**3*s - 1170*D1*Dd*f**3 + 6000*D1*Dd*f**2*fd*r**2 + 12000*D1*Dd*f**2*fd*r*s - 8500*D1*Dd*f**2*fd*r + 6000*D1*Dd*f**2*fd*s**2 - 8500*D1*Dd*f**2*fd*s + 3000*D1*Dd*f**2*fd - 528*D1*Dd*f*fd*r**2 - 1056*D1*Dd*f*fd*r*s + 660*D1*Dd*f*fd*r - 528*D1*Dd*f*fd*s**2 + 660*D1*Dd*f*fd*s - 198*D1*Dd*f*fd + 528*D1*Dd*f*g2*r**2 + 1056*D1*Dd*f*g2*r*s - 792*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s**2 - 792*D1*Dd*f*g2*s + 396*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r**2 - 1056*D1*Dd*f*gd2*r*s + 924*D1*Dd*f*gd2*r - 528*D1*Dd*f*gd2*s**2 + 924*D1*Dd*f*gd2*s - 396*D1*Dd*f*gd2 - 528*D1*Dd*fd*g2*r**2 - 1056*D1*Dd*fd*g2*r*s + 396*D1*Dd*fd*g2*r - 528*D1*Dd*fd*g2*s**2 + 396*D1*Dd*fd*g2*s + 132*D1*Ddd*K*f**2*r**2 + 264*D1*Ddd*K*f**2*r*s - 198*D1*Ddd*K*f**2*r + 132*D1*Ddd*K*f**2*s**2 - 198*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 + 1000*D1*Ddd*f**3*r**2 + 2000*D1*Ddd*f**3*r*s - 1500*D1*Ddd*f**3*r + 1000*D1*Ddd*f**3*s**2 - 1500*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 - 132*D1*Ddd*f**2*r**2 - 264*D1*Ddd*f**2*r*s + 198*D1*Ddd*f**2*r - 132*D1*Ddd*f**2*s**2 + 198*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 - 264*D1*Ddd*f*g2*r**2 - 528*D1*Ddd*f*g2*r*s + 396*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2*s**2 + 396*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 2*f*(K - 1)*(r + s - 1) + 2*fd*(K - 1)*(r + s)) - Dd*f*(-2*K + 5*f + 2)*(4*r + 4*s - 3))*(r + s - 1) + 396*Dd**2*K*f**2*r**2 + 792*Dd**2*K*f**2*r*s - 594*Dd**2*K*f**2*r + 396*Dd**2*K*f**2*s**2 - 594*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 + 3000*Dd**2*f**3*r**2 + 6000*Dd**2*f**3*r*s - 4500*Dd**2*f**3*r + 3000*Dd**2*f**3*s**2 - 4500*Dd**2*f**3*s + 1500*Dd**2*f**3 - 396*Dd**2*f**2*r**2 - 792*Dd**2*f**2*r*s + 594*Dd**2*f**2*r - 396*Dd**2*f**2*s**2 + 594*Dd**2*f**2*s - 198*Dd**2*f**2 - 792*Dd**2*f*g2*r**2 - 1584*Dd**2*f*g2*r*s + 1188*Dd**2*f*g2*r - 792*Dd**2*f*g2*s**2 + 1188*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(18018*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**4*k2**4*st**2*(-396*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-72*C*D1**2*f*fd*r**2 - 144*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s - 12*C*D1**2*f*fd + 36*C*D1**2*f*fdd*r**2 + 72*C*D1**2*f*fdd*r*s - 12*C*D1**2*f*fdd*r + 36*C*D1**2*f*fdd*s**2 - 12*C*D1**2*f*fdd*s + 6*C*D1**2*f*fdd + 36*C*D1**2*fd**2*r**2 + 72*C*D1**2*fd**2*r*s - 12*C*D1**2*fd**2*r + 36*C*D1**2*fd**2*s**2 - 12*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 144*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 216*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 216*C*D1*Dd*f**2*s - 108*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r**2 + 576*C*D1*Dd*f*fd*r*s - 264*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 264*C*D1*Dd*f*fd*s + 36*C*D1*Dd*f*fd + 72*C*D1*Ddd*f**2*r**2 + 144*C*D1*Ddd*f**2*r*s - 108*C*D1*Ddd*f**2*r + 72*C*D1*Ddd*f**2*s**2 - 108*C*D1*Ddd*f**2*s + 54*C*D1*Ddd*f**2 + 216*C*Dd**2*f**2*r**2 + 432*C*Dd**2*f**2*r*s - 324*C*Dd**2*f**2*r + 216*C*Dd**2*f**2*s**2 - 324*C*Dd**2*f**2*s + 108*C*Dd**2*f**2 - 12*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 148*D1**2*f*fd*r**2 + 296*D1**2*f*fd*r*s - 100*D1**2*f*fd*r + 148*D1**2*f*fd*s**2 - 100*D1**2*f*fd*s + 50*D1**2*f*fd - 86*D1**2*f*fdd*r**2 - 172*D1**2*f*fdd*r*s + 62*D1**2*f*fdd*r - 86*D1**2*f*fdd*s**2 + 62*D1**2*f*fdd*s - 31*D1**2*f*fdd - 86*D1**2*fd**2*r**2 - 172*D1**2*fd**2*r*s + 62*D1**2*fd**2*r - 86*D1**2*fd**2*s**2 + 62*D1**2*fd**2*s + 24*D1**2*fd**2 + 296*D1*Dd*f**2*r**2 + 592*D1*Dd*f**2*r*s - 444*D1*Dd*f**2*r + 296*D1*Dd*f**2*s**2 - 444*D1*Dd*f**2*s + 222*D1*Dd*f**2 - 688*D1*Dd*f*fd*r**2 - 1376*D1*Dd*f*fd*r*s + 764*D1*Dd*f*fd*r - 688*D1*Dd*f*fd*s**2 + 764*D1*Dd*f*fd*s - 186*D1*Dd*f*fd - 172*D1*Ddd*f**2*r**2 - 344*D1*Ddd*f**2*r*s + 258*D1*Ddd*f**2*r - 172*D1*Ddd*f**2*s**2 + 258*D1*Ddd*f**2*s - 129*D1*Ddd*f**2 + 24*D1*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 516*Dd**2*f**2*r**2 - 1032*Dd**2*f**2*r*s + 774*Dd**2*f**2*r - 516*Dd**2*f**2*s**2 + 774*Dd**2*f**2*s - 258*Dd**2*f**2) + f*(4500*C*D1**2*f*fd*r**2 + 9000*C*D1**2*f*fd*r*s - 6000*C*D1**2*f*fd*r + 4500*C*D1**2*f*fd*s**2 - 6000*C*D1**2*f*fd*s + 3000*C*D1**2*f*fd - 2250*C*D1**2*f*fdd*r**2 - 4500*C*D1**2*f*fdd*r*s + 3000*C*D1**2*f*fdd*r - 2250*C*D1**2*f*fdd*s**2 + 3000*C*D1**2*f*fdd*s - 1500*C*D1**2*f*fdd - 4500*C*D1**2*fd**2*r**2 - 9000*C*D1**2*fd**2*r*s + 6000*C*D1**2*fd**2*r - 4500*C*D1**2*fd**2*s**2 + 6000*C*D1**2*fd**2*s - 1500*C*D1**2*fd**2 + 6000*C*D1*Dd*f**2*r**2 + 12000*C*D1*Dd*f**2*r*s - 9000*C*D1*Dd*f**2*r + 6000*C*D1*Dd*f**2*s**2 - 9000*C*D1*Dd*f**2*s + 4500*C*D1*Dd*f**2 - 18000*C*D1*Dd*f*fd*r**2 - 36000*C*D1*Dd*f*fd*r*s + 25500*C*D1*Dd*f*fd*r - 18000*C*D1*Dd*f*fd*s**2 + 25500*C*D1*Dd*f*fd*s - 9000*C*D1*Dd*f*fd - 3000*C*D1*Ddd*f**2*r**2 - 6000*C*D1*Ddd*f**2*r*s + 4500*C*D1*Ddd*f**2*r - 3000*C*D1*Ddd*f**2*s**2 + 4500*C*D1*Ddd*f**2*s - 2250*C*D1*Ddd*f**2 - 9000*C*Dd**2*f**2*r**2 - 18000*C*Dd**2*f**2*r*s + 13500*C*Dd**2*f**2*r - 9000*C*Dd**2*f**2*s**2 + 13500*C*Dd**2*f**2*s - 4500*C*Dd**2*f**2 + 792*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 33*D1**2*bdd1*f*(6*C*(3*r**2 + 6*r*s - 10*r + 3*s**2 - 10*s + 5) - 43*r**2 - 86*r*s + 110*r - 43*s**2 + 110*s - 55) - 7062*D1**2*f*fd*r**2 - 14124*D1**2*f*fd*r*s + 9416*D1**2*f*fd*r - 7062*D1**2*f*fd*s**2 + 9416*D1**2*f*fd*s - 4708*D1**2*f*fd + 4125*D1**2*f*fdd*r**2 + 8250*D1**2*f*fdd*r*s - 5500*D1**2*f*fdd*r + 4125*D1**2*f*fdd*s**2 - 5500*D1**2*f*fdd*s + 2750*D1**2*f*fdd + 8250*D1**2*fd**2*r**2 + 16500*D1**2*fd**2*r*s - 11000*D1**2*fd**2*r + 8250*D1**2*fd**2*s**2 - 11000*D1**2*fd**2*s + 2750*D1**2*fd**2 - 9416*D1*Dd*f**2*r**2 - 18832*D1*Dd*f**2*r*s + 14124*D1*Dd*f**2*r - 9416*D1*Dd*f**2*s**2 + 14124*D1*Dd*f**2*s - 7062*D1*Dd*f**2 + 33000*D1*Dd*f*fd*r**2 + 66000*D1*Dd*f*fd*r*s - 46750*D1*Dd*f*fd*r + 33000*D1*Dd*f*fd*s**2 - 46750*D1*Dd*f*fd*s + 16500*D1*Dd*f*fd + 5500*D1*Ddd*f**2*r**2 + 11000*D1*Ddd*f**2*r*s - 8250*D1*Ddd*f**2*r + 5500*D1*Ddd*f**2*s**2 - 8250*D1*Ddd*f**2*s + 4125*D1*Ddd*f**2 + 66*D1*bd1*(D1*(f*(6*C*(3*r**2 + 6*r*s - 10*r + 3*s**2 - 10*s + 5) - 37*r**2 - 74*r*s + 98*r - 37*s**2 + 98*s - 49) - fd*(r + s - 1)*(6*C*(6*r + 6*s - 5) - 86*r - 86*s + 55)) - Dd*f*(4*r + 4*s - 3)*(6*C*(3*r + 3*s - 5) - 43*r - 43*s + 55)) + 16500*Dd**2*f**2*r**2 + 33000*Dd**2*f**2*r*s - 24750*Dd**2*f**2*r + 16500*Dd**2*f**2*s**2 - 24750*Dd**2*f**2*s + 8250*Dd**2*f**2))/(1386*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**4*k2**4*(792*C*D1**2*bd1*f**2*r + 792*C*D1**2*bd1*f**2*s - 396*C*D1**2*bd1*f**2 - 990*C*D1**2*f**2*fd*r**2 - 1980*C*D1**2*f**2*fd*r*s + 1320*C*D1**2*f**2*fd*r - 990*C*D1**2*f**2*fd*s**2 + 1320*C*D1**2*f**2*fd*s - 660*C*D1**2*f**2*fd - 1320*C*D1*Dd*f**3*r**2 - 2640*C*D1*Dd*f**3*r*s + 1980*C*D1*Dd*f**3*r - 1320*C*D1*Dd*f**3*s**2 + 1980*C*D1*Dd*f**3*s - 990*C*D1*Dd*f**3 + 396*D1**2*K*bd1**2*f*r + 396*D1**2*K*bd1**2*f*s - 396*D1**2*K*bd1**2*f + 330*D1**2*K*bd1*f**2*r**2 + 660*D1**2*K*bd1*f**2*r*s - 660*D1**2*K*bd1*f**2*r + 330*D1**2*K*bd1*f**2*s**2 - 660*D1**2*K*bd1*f**2*s + 330*D1**2*K*bd1*f**2 - 660*D1**2*K*bd1*f*fd*r**2 - 1320*D1**2*K*bd1*f*fd*r*s + 990*D1**2*K*bd1*f*fd*r - 660*D1**2*K*bd1*f*fd*s**2 + 990*D1**2*K*bd1*f*fd*s - 330*D1**2*K*bd1*f*fd - 165*D1**2*K*bdd1*f**2*r**2 - 330*D1**2*K*bdd1*f**2*r*s + 330*D1**2*K*bdd1*f**2*r - 165*D1**2*K*bdd1*f**2*s**2 + 330*D1**2*K*bdd1*f**2*s - 165*D1**2*K*bdd1*f**2 + 1980*D1**2*bd1**2*f**2*r**2 + 3960*D1**2*bd1**2*f**2*r*s - 3300*D1**2*bd1**2*f**2*r + 1980*D1**2*bd1**2*f**2*s**2 - 3300*D1**2*bd1**2*f**2*s + 1320*D1**2*bd1**2*f**2 + 1188*D1**2*bd1**2*f*r**2 + 2376*D1**2*bd1**2*f*r*s - 2772*D1**2*bd1**2*f*r + 1188*D1**2*bd1**2*f*s**2 - 2772*D1**2*bd1**2*f*s + 1584*D1**2*bd1**2*f - 924*D1**2*bd1**2*g2*r**2 - 1848*D1**2*bd1**2*g2*r*s + 924*D1**2*bd1**2*g2*r - 924*D1**2*bd1**2*g2*s**2 + 924*D1**2*bd1**2*g2*s - 396*D1**2*bd1*bd2*f*r**2 - 792*D1**2*bd1*bd2*f*r*s + 792*D1**2*bd1*bd2*f*r - 396*D1**2*bd1*bd2*f*s**2 + 792*D1**2*bd1*bd2*f*s - 396*D1**2*bd1*bd2*f - 1300*D1**2*bd1*f**3*r**2 - 2600*D1**2*bd1*f**3*r*s + 1580*D1**2*bd1*f**3*r - 1300*D1**2*bd1*f**3*s**2 + 1580*D1**2*bd1*f**3*s - 790*D1**2*bd1*f**3 + 5880*D1**2*bd1*f**2*fd*r**2 + 11760*D1**2*bd1*f**2*fd*r*s - 8120*D1**2*bd1*f**2*fd*r + 5880*D1**2*bd1*f**2*fd*s**2 - 8120*D1**2*bd1*f**2*fd*s + 2240*D1**2*bd1*f**2*fd - 726*D1**2*bd1*f**2*r**2 - 1452*D1**2*bd1*f**2*r*s + 660*D1**2*bd1*f**2*r - 726*D1**2*bd1*f**2*s**2 + 660*D1**2*bd1*f**2*s - 330*D1**2*bd1*f**2 + 2640*D1**2*bd1*f*fd*r**2 + 5280*D1**2*bd1*f*fd*r*s - 3960*D1**2*bd1*f*fd*r + 2640*D1**2*bd1*f*fd*s**2 - 3960*D1**2*bd1*f*fd*s + 1320*D1**2*bd1*f*fd + 1584*D1**2*bd1*f*g2*r + 1584*D1**2*bd1*f*g2*s - 792*D1**2*bd1*f*g2 - 792*D1**2*bd1*f*gd2*r - 792*D1**2*bd1*f*gd2*s + 792*D1**2*bd1*f*gd2 + 330*D1**2*bd2*f**2*r**2 + 660*D1**2*bd2*f**2*r*s - 660*D1**2*bd2*f**2*r + 330*D1**2*bd2*f**2*s**2 - 660*D1**2*bd2*f**2*s + 330*D1**2*bd2*f**2 - 660*D1**2*bd2*f*fd*r**2 - 1320*D1**2*bd2*f*fd*r*s + 990*D1**2*bd2*f*fd*r - 660*D1**2*bd2*f*fd*s**2 + 990*D1**2*bd2*f*fd*s - 330*D1**2*bd2*f*fd + 980*D1**2*bdd1*f**3*r**2 + 1960*D1**2*bdd1*f**3*r*s - 1120*D1**2*bdd1*f**3*r + 980*D1**2*bdd1*f**3*s**2 - 1120*D1**2*bdd1*f**3*s + 560*D1**2*bdd1*f**3 + 660*D1**2*bdd1*f**2*r**2 + 1320*D1**2*bdd1*f**2*r*s - 1320*D1**2*bdd1*f**2*r + 660*D1**2*bdd1*f**2*s**2 - 1320*D1**2*bdd1*f**2*s + 660*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 165*D1**2*bdd2*f**2*r**2 - 330*D1**2*bdd2*f**2*r*s + 330*D1**2*bdd2*f**2*r - 165*D1**2*bdd2*f**2*s**2 + 330*D1**2*bdd2*f**2*s - 165*D1**2*bdd2*f**2 + 1485*D1**2*f**2*fd*r**2 + 2970*D1**2*f**2*fd*r*s - 1980*D1**2*f**2*fd*r + 1485*D1**2*f**2*fd*s**2 - 1980*D1**2*f**2*fd*s + 990*D1**2*f**2*fd - 660*D1**2*f**2*gd2*r**2 - 1320*D1**2*f**2*gd2*r*s + 1320*D1**2*f**2*gd2*r - 660*D1**2*f**2*gd2*s**2 + 1320*D1**2*f**2*gd2*s - 660*D1**2*f**2*gd2 + 330*D1**2*f**2*gdd2*r**2 + 660*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*r + 330*D1**2*f**2*gdd2*s**2 - 660*D1**2*f**2*gdd2*s + 330*D1**2*f**2*gdd2 - 1320*D1**2*f*fd*g2*r**2 - 2640*D1**2*f*fd*g2*r*s + 1320*D1**2*f*fd*g2*r - 1320*D1**2*f*fd*g2*s**2 + 1320*D1**2*f*fd*g2*s - 660*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*r**2 + 2640*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 1320*D1**2*f*fd*gd2*s**2 - 1980*D1**2*f*fd*gd2*s + 660*D1**2*f*fd*gd2 + 660*D1**2*f*fdd*g2*r**2 + 1320*D1**2*f*fdd*g2*r*s - 660*D1**2*f*fdd*g2*r + 660*D1**2*f*fdd*g2*s**2 - 660*D1**2*f*fdd*g2*s + 330*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*r**2 + 1320*D1**2*fd**2*g2*r*s - 660*D1**2*fd**2*g2*r + 660*D1**2*fd**2*g2*s**2 - 660*D1**2*fd**2*g2*s - 1320*D1*Dd*K*bd1*f**2*r**2 - 2640*D1*Dd*K*bd1*f**2*r*s + 2310*D1*Dd*K*bd1*f**2*r - 1320*D1*Dd*K*bd1*f**2*s**2 + 2310*D1*Dd*K*bd1*f**2*s - 990*D1*Dd*K*bd1*f**2 + 7840*D1*Dd*bd1*f**3*r**2 + 15680*D1*Dd*bd1*f**3*r*s - 10360*D1*Dd*bd1*f**3*r + 7840*D1*Dd*bd1*f**3*s**2 - 10360*D1*Dd*bd1*f**3*s + 3360*D1*Dd*bd1*f**3 + 5280*D1*Dd*bd1*f**2*r**2 + 10560*D1*Dd*bd1*f**2*r*s - 9240*D1*Dd*bd1*f**2*r + 5280*D1*Dd*bd1*f**2*s**2 - 9240*D1*Dd*bd1*f**2*s + 3960*D1*Dd*bd1*f**2 - 3168*D1*Dd*bd1*f*g2*r - 3168*D1*Dd*bd1*f*g2*s + 2376*D1*Dd*bd1*f*g2 - 1320*D1*Dd*bd2*f**2*r**2 - 2640*D1*Dd*bd2*f**2*r*s + 2310*D1*Dd*bd2*f**2*r - 1320*D1*Dd*bd2*f**2*s**2 + 2310*D1*Dd*bd2*f**2*s - 990*D1*Dd*bd2*f**2 + 1980*D1*Dd*f**3*r**2 + 3960*D1*Dd*f**3*r*s - 2970*D1*Dd*f**3*r + 1980*D1*Dd*f**3*s**2 - 2970*D1*Dd*f**3*s + 1485*D1*Dd*f**3 - 2640*D1*Dd*f**2*g2*r**2 - 5280*D1*Dd*f**2*g2*r*s + 3960*D1*Dd*f**2*g2*r - 2640*D1*Dd*f**2*g2*s**2 + 3960*D1*Dd*f**2*g2*s - 1980*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*r**2 + 5280*D1*Dd*f**2*gd2*r*s - 4620*D1*Dd*f**2*gd2*r + 2640*D1*Dd*f**2*gd2*s**2 - 4620*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 5280*D1*Dd*f*fd*g2*r**2 + 10560*D1*Dd*f*fd*g2*r*s - 6600*D1*Dd*f*fd*g2*r + 5280*D1*Dd*f*fd*g2*s**2 - 6600*D1*Dd*f*fd*g2*s + 1980*D1*Dd*f*fd*g2 + 1320*D1*Ddd*f**2*g2*r**2 + 2640*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 1320*D1*Ddd*f**2*g2*s**2 - 1980*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 3960*Dd**2*f**2*g2*r**2 + 7920*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 3960*Dd**2*f**2*g2*s**2 - 5940*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (7*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-7*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-7*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(-D1**2*bdd1*(-7*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*D1**2*(10*f*fdd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 10*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + fd*(7*C*(r + s - 1)**2 + 12*K*r + 12*K*s - 6*K - 2*f*(18*r**2 + 36*r*s - 22*r + 18*s**2 - 22*s + 11) - 18*r**2 - 36*r*s + 2*r - 18*s**2 + 2*s - 1) + 3*fdd*(-2*K*r - 2*K*s + K + 3*r**2 + 6*r*s + 2*r + 3*s**2 + 2*s - 1) + (14*gd2 - 7*gdd2)*(r + s - 1)**2) + 2*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (7*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-7*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 2*D1*(Dd*(-18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(7*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 20*fd*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 72*r**2 - 18*r*(8*s - 6) - 72*s**2 + 108*s - 54) - 6*fd*(4*r + 4*s - 3)*(K - 3*r - 3*s - 1) + 14*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 14*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*(15*f**2 + 9*f - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*(15*f**2 + 9*f - 7*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-792*C*D1**2*f*fd*r - 792*C*D1**2*f*fd*s + 396*C*D1**2*f*fd + 396*D1**2*K*bdd1*f*r + 396*D1**2*K*bdd1*f*s - 198*D1**2*K*bdd1*f + 660*D1**2*K*f*fd*r**2 + 1320*D1**2*K*f*fd*r*s - 660*D1**2*K*f*fd*r + 660*D1**2*K*f*fd*s**2 - 660*D1**2*K*f*fd*s + 330*D1**2*K*f*fd - 330*D1**2*K*f*fdd*r**2 - 660*D1**2*K*f*fdd*r*s + 330*D1**2*K*f*fdd*r - 330*D1**2*K*f*fdd*s**2 + 330*D1**2*K*f*fdd*s - 165*D1**2*K*f*fdd - 330*D1**2*K*fd**2*r**2 - 660*D1**2*K*fd**2*r*s + 330*D1**2*K*fd**2*r - 330*D1**2*K*fd**2*s**2 + 330*D1**2*K*fd**2*s + 396*D1**2*b2*fd*r**2 + 792*D1**2*b2*fd*r*s + 396*D1**2*b2*fd*s**2 - 198*D1**2*b2*fdd*r**2 - 396*D1**2*b2*fdd*r*s - 198*D1**2*b2*fdd*s**2 - 66*D1**2*bd1**2*(-7*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 1980*D1**2*bdd1*f**2*r**2 + 3960*D1**2*bdd1*f**2*r*s - 3300*D1**2*bdd1*f**2*r + 1980*D1**2*bdd1*f**2*s**2 - 3300*D1**2*bdd1*f**2*s + 1650*D1**2*bdd1*f**2 + 1188*D1**2*bdd1*f*r**2 + 2376*D1**2*bdd1*f*r*s - 2772*D1**2*bdd1*f*r + 1188*D1**2*bdd1*f*s**2 - 2772*D1**2*bdd1*f*s + 1386*D1**2*bdd1*f - 924*D1**2*bdd1*g2*r**2 - 1848*D1**2*bdd1*g2*r*s + 924*D1**2*bdd1*g2*r - 924*D1**2*bdd1*g2*s**2 + 924*D1**2*bdd1*g2*s - 462*D1**2*bdd1*g2 - 198*D1**2*bdd2*f*r**2 - 396*D1**2*bdd2*f*r*s + 396*D1**2*bdd2*f*r - 198*D1**2*bdd2*f*s**2 + 396*D1**2*bdd2*f*s - 198*D1**2*bdd2*f - 3900*D1**2*f**2*fd*r**2 - 7800*D1**2*f**2*fd*r*s + 6220*D1**2*f**2*fd*r - 3900*D1**2*f**2*fd*s**2 + 6220*D1**2*f**2*fd*s - 3110*D1**2*f**2*fd + 2940*D1**2*f**2*fdd*r**2 + 5880*D1**2*f**2*fdd*r*s - 4760*D1**2*f**2*fdd*r + 2940*D1**2*f**2*fdd*s**2 - 4760*D1**2*f**2*fdd*s + 2380*D1**2*f**2*fdd + 5880*D1**2*f*fd**2*r**2 + 11760*D1**2*f*fd**2*r*s - 9520*D1**2*f*fd**2*r + 5880*D1**2*f*fd**2*s**2 - 9520*D1**2*f*fd**2*s + 3640*D1**2*f*fd**2 - 1452*D1**2*f*fd*r**2 - 2904*D1**2*f*fd*r*s + 2244*D1**2*f*fd*r - 1452*D1**2*f*fd*s**2 + 2244*D1**2*f*fd*s - 1122*D1**2*f*fd + 1320*D1**2*f*fdd*r**2 + 2640*D1**2*f*fdd*r*s - 1320*D1**2*f*fdd*r + 1320*D1**2*f*fdd*s**2 - 1320*D1**2*f*fdd*s + 660*D1**2*f*fdd + 1320*D1**2*fd**2*r**2 + 2640*D1**2*fd**2*r*s - 1320*D1**2*fd**2*r + 1320*D1**2*fd**2*s**2 - 1320*D1**2*fd**2*s - 1584*D1**2*fd*g2*r - 1584*D1**2*fd*g2*s + 792*D1**2*fd*g2 + 792*D1**2*fd*gd2*r + 792*D1**2*fd*gd2*s - 792*D1**2*fd*gd2 + 792*D1**2*fdd*g2*r + 792*D1**2*fdd*g2*s - 396*D1**2*fdd*g2 + 1320*D1*Dd*K*f**2*r**2 + 2640*D1*Dd*K*f**2*r*s - 1980*D1*Dd*K*f**2*r + 1320*D1*Dd*K*f**2*s**2 - 1980*D1*Dd*K*f**2*s + 990*D1*Dd*K*f**2 - 2640*D1*Dd*K*f*fd*r**2 - 5280*D1*Dd*K*f*fd*r*s + 3300*D1*Dd*K*f*fd*r - 2640*D1*Dd*K*f*fd*s**2 + 3300*D1*Dd*K*f*fd*s - 990*D1*Dd*K*f*fd + 1584*D1*Dd*b2*f*r**2 + 3168*D1*Dd*b2*f*r*s - 2376*D1*Dd*b2*f*r + 1584*D1*Dd*b2*f*s**2 - 2376*D1*Dd*b2*f*s + 1188*D1*Dd*b2*f - 1584*D1*Dd*b2*fd*r**2 - 3168*D1*Dd*b2*fd*r*s + 1188*D1*Dd*b2*fd*r - 1584*D1*Dd*b2*fd*s**2 + 1188*D1*Dd*b2*fd*s - 5200*D1*Dd*f**3*r**2 - 10400*D1*Dd*f**3*r*s + 7800*D1*Dd*f**3*r - 5200*D1*Dd*f**3*s**2 + 7800*D1*Dd*f**3*s - 3900*D1*Dd*f**3 + 23520*D1*Dd*f**2*fd*r**2 + 47040*D1*Dd*f**2*fd*r*s - 36680*D1*Dd*f**2*fd*r + 23520*D1*Dd*f**2*fd*s**2 - 36680*D1*Dd*f**2*fd*s + 14280*D1*Dd*f**2*fd - 2904*D1*Dd*f**2*r**2 - 5808*D1*Dd*f**2*r*s + 4356*D1*Dd*f**2*r - 2904*D1*Dd*f**2*s**2 + 4356*D1*Dd*f**2*s - 2178*D1*Dd*f**2 + 10560*D1*Dd*f*fd*r**2 + 21120*D1*Dd*f*fd*r*s - 13200*D1*Dd*f*fd*r + 10560*D1*Dd*f*fd*s**2 - 13200*D1*Dd*f*fd*s + 3960*D1*Dd*f*fd + 3168*D1*Dd*fd*g2*r + 3168*D1*Dd*fd*g2*s - 2376*D1*Dd*fd*g2 - 660*D1*Ddd*K*f**2*r**2 - 1320*D1*Ddd*K*f**2*r*s + 990*D1*Ddd*K*f**2*r - 660*D1*Ddd*K*f**2*s**2 + 990*D1*Ddd*K*f**2*s - 495*D1*Ddd*K*f**2 - 792*D1*Ddd*b2*f*r**2 - 1584*D1*Ddd*b2*f*r*s + 1188*D1*Ddd*b2*f*r - 792*D1*Ddd*b2*f*s**2 + 1188*D1*Ddd*b2*f*s - 594*D1*Ddd*b2*f + 3920*D1*Ddd*f**3*r**2 + 7840*D1*Ddd*f**3*r*s - 5880*D1*Ddd*f**3*r + 3920*D1*Ddd*f**3*s**2 - 5880*D1*Ddd*f**3*s + 2940*D1*Ddd*f**3 + 2640*D1*Ddd*f**2*r**2 + 5280*D1*Ddd*f**2*r*s - 3960*D1*Ddd*f**2*r + 2640*D1*Ddd*f**2*s**2 - 3960*D1*Ddd*f**2*s + 1980*D1*Ddd*f**2 - 66*D1*bd1*(D1*(4*f**2*(9*r**2 + 2*r*(9*s - 8) + 9*s**2 - 16*s + 8) + f*(-7*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 12*K*r + 12*K*s - 6*K - 60*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 36*r**2 + 72*r*s - 70*r + 36*s**2 - 70*s + 35) + 6*fd*(r + s - 1)*(K - 6*r - 6*s - 1) - 14*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 14*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*(4*r + 4*s - 3)*(5*f**2*(6*r + 6*s - 5) + 3*f*(K + 6*r + 6*s - 7) - 7*g2*(2*r + 2*s - 1))) + 396*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 1980*Dd**2*K*f**2*r**2 - 3960*Dd**2*K*f**2*r*s + 2970*Dd**2*K*f**2*r - 1980*Dd**2*K*f**2*s**2 + 2970*Dd**2*K*f**2*s - 990*Dd**2*K*f**2 - 2376*Dd**2*b2*f*r**2 - 4752*Dd**2*b2*f*r*s + 3564*Dd**2*b2*f*r - 2376*Dd**2*b2*f*s**2 + 3564*Dd**2*b2*f*s - 1188*Dd**2*b2*f + 11760*Dd**2*f**3*r**2 + 23520*Dd**2*f**3*r*s - 17640*Dd**2*f**3*r + 11760*Dd**2*f**3*s**2 - 17640*Dd**2*f**3*s + 5880*Dd**2*f**3 + 7920*Dd**2*f**2*r**2 + 15840*Dd**2*f**2*r*s - 11880*Dd**2*f**2*r + 7920*Dd**2*f**2*s**2 - 11880*Dd**2*f**2*s + 3960*Dd**2*f**2) + 33*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 5*D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 12*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 5*D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**4*k2**2*(-D1*f*(r + s)*(12*D1*bd1**2*(2*C - 3)*(r + s - 1) + 5*D1*bdd1*f*(2*C - 3)*(r + s) + 2*bd1*(-D1*f*(10*C - 9)*(r + s) + D1*fd*(20*C - 30)*(r + s - 1) + Dd*f*(10*C - 15)*(4*r + 4*s - 3))) + 2*b1**2*(D1**2*(fd*(12*C - 11) + fdd*(9 - 6*C))*(r + s - 1)**2 + D1*(Dd*(f*(12*C - 11)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(18 - 12*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(9 - 6*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(36*C - 54)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(40*C*D1**2*f*fd*r**2 + 80*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*r + 40*C*D1**2*f*fd*s**2 - 80*C*D1**2*f*fd*s + 40*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 - 40*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 40*C*D1**2*f*fdd*s - 20*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 - 40*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 40*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 + 80*C*D1*Dd*f**2*r**2 + 160*C*D1*Dd*f**2*r*s - 120*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s**2 - 120*C*D1*Dd*f**2*s + 60*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 - 320*C*D1*Dd*f*fd*r*s + 280*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 280*C*D1*Dd*f*fd*s - 120*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 - 80*C*D1*Ddd*f**2*r*s + 60*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 60*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 - 240*C*Dd**2*f**2*r*s + 180*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 180*C*Dd**2*f**2*s - 60*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(2*C - 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 36*D1**2*f*fd*r**2 - 72*D1**2*f*fd*r*s + 72*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 72*D1**2*f*fd*s - 36*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s + 30*D1**2*f*fdd + 30*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 60*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s + 30*D1**2*fd**2 - 72*D1*Dd*f**2*r**2 - 144*D1*Dd*f**2*r*s + 108*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 108*D1*Dd*f**2*s - 54*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 420*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 420*D1*Dd*f*fd*s + 180*D1*Dd*f*fd + 60*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 90*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 90*D1*Ddd*f**2*s + 45*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(12*C - 11)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(18 - 12*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(18 - 12*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 180*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 270*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 270*Dd**2*f**2*s + 90*Dd**2*f**2))/(21*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct**3*f*k1*k2**5*st**4*(-132*D1**2*bd1*f*(C - 1)*(r + s - 1)**2 - 132*D1*b1*(C - 1)*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - (100*C - 85)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**6) - 5*D1**2*Pk1*Pkdd3*ct**3*f*k2**7*st**4*(78*D1**2*b1*f*fd*r**2 + 156*D1**2*b1*f*fd*r*s - 104*D1**2*b1*f*fd*r + 78*D1**2*b1*f*fd*s**2 - 104*D1**2*b1*f*fd*s + 52*D1**2*b1*f*fd - 39*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*f*fdd*r*s + 52*D1**2*b1*f*fdd*r - 39*D1**2*b1*f*fdd*s**2 + 52*D1**2*b1*f*fdd*s - 26*D1**2*b1*f*fdd - 78*D1**2*b1*fd**2*r**2 - 156*D1**2*b1*fd**2*r*s + 104*D1**2*b1*fd**2*r - 78*D1**2*b1*fd**2*s**2 + 104*D1**2*b1*fd**2*s - 26*D1**2*b1*fd**2 - 13*D1**2*bdd1*f**2*(r + s - 1)**2 + 80*D1**2*f**2*fd*r**2 + 160*D1**2*f**2*fd*r*s - 120*D1**2*f**2*fd*r + 80*D1**2*f**2*fd*s**2 - 120*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 40*D1**2*f**2*fdd*r**2 - 80*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 40*D1**2*f**2*fdd*s**2 + 60*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 180*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 180*D1**2*f*fd**2*s - 60*D1**2*f*fd**2 + 104*D1*Dd*b1*f**2*r**2 + 208*D1*Dd*b1*f**2*r*s - 156*D1*Dd*b1*f**2*r + 104*D1*Dd*b1*f**2*s**2 - 156*D1*Dd*b1*f**2*s + 78*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 - 624*D1*Dd*b1*f*fd*r*s + 442*D1*Dd*b1*f*fd*r - 312*D1*Dd*b1*f*fd*s**2 + 442*D1*Dd*b1*f*fd*s - 156*D1*Dd*b1*f*fd + 80*D1*Dd*f**3*r**2 + 160*D1*Dd*f**3*r*s - 120*D1*Dd*f**3*r + 80*D1*Dd*f**3*s**2 - 120*D1*Dd*f**3*s + 60*D1*Dd*f**3 - 320*D1*Dd*f**2*fd*r**2 - 640*D1*Dd*f**2*fd*r*s + 480*D1*Dd*f**2*fd*r - 320*D1*Dd*f**2*fd*s**2 + 480*D1*Dd*f**2*fd*s - 180*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 - 104*D1*Ddd*b1*f**2*r*s + 78*D1*Ddd*b1*f**2*r - 52*D1*Ddd*b1*f**2*s**2 + 78*D1*Ddd*b1*f**2*s - 39*D1*Ddd*b1*f**2 - 40*D1*Ddd*f**3*r**2 - 80*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 40*D1*Ddd*f**3*s**2 + 60*D1*Ddd*f**3*s - 30*D1*Ddd*f**3 + 26*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 156*Dd**2*b1*f**2*r**2 - 312*Dd**2*b1*f**2*r*s + 234*Dd**2*b1*f**2*r - 156*Dd**2*b1*f**2*s**2 + 234*Dd**2*b1*f**2*s - 78*Dd**2*b1*f**2 - 120*Dd**2*f**3*r**2 - 240*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 120*Dd**2*f**3*s**2 + 180*Dd**2*f**3*s - 60*Dd**2*f**3)/(429*d**2*k1*k3**6) - 5*D1**2*Pk1*Pkdd3*ct**3*f*k2**5*st**4*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k1*k3**4) - D1**2*Pk1*Pkdd3*ct**3*k1**5*k2*(12*C - 7)*(264*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r + 264*D1**2*b1*f*fd*s**2 - 264*D1**2*b1*f*fd*s + 132*D1**2*b1*f*fd - 330*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 330*D1**2*b1*f*fdd*s**2 + 330*D1**2*b1*f*fdd*s - 165*D1**2*b1*f*fdd - 330*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r - 330*D1**2*b1*fd**2*s**2 + 330*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)**2 + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 792*D1*Dd*b1*f**2*r + 528*D1*Dd*b1*f**2*s**2 - 792*D1*Dd*b1*f**2*s + 396*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 3300*D1*Dd*b1*f*fd*r - 2640*D1*Dd*b1*f*fd*s**2 + 3300*D1*Dd*b1*f*fd*s - 990*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 690*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 690*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 990*D1*Ddd*b1*f**2*r - 660*D1*Ddd*b1*f**2*s**2 + 990*D1*Ddd*b1*f**2*s - 495*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 1980*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 2970*Dd**2*b1*f**2*r - 1980*Dd**2*b1*f**2*s**2 + 2970*Dd**2*b1*f**2*s - 990*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3)/(693*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**3*k1**3*k2**3*st**2*(-12672*C*D1**2*b1*f*fd*r**2 - 25344*C*D1**2*b1*f*fd*r*s + 12672*C*D1**2*b1*f*fd*r - 12672*C*D1**2*b1*f*fd*s**2 + 12672*C*D1**2*b1*f*fd*s - 6336*C*D1**2*b1*f*fd + 8184*C*D1**2*b1*f*fdd*r**2 + 16368*C*D1**2*b1*f*fdd*r*s - 8184*C*D1**2*b1*f*fdd*r + 8184*C*D1**2*b1*f*fdd*s**2 - 8184*C*D1**2*b1*f*fdd*s + 4092*C*D1**2*b1*f*fdd + 8184*C*D1**2*b1*fd**2*r**2 + 16368*C*D1**2*b1*fd**2*r*s - 8184*C*D1**2*b1*fd**2*r + 8184*C*D1**2*b1*fd**2*s**2 - 8184*C*D1**2*b1*fd**2*s - 13056*C*D1**2*f**2*fd*r**2 - 26112*C*D1**2*f**2*fd*r*s + 17408*C*D1**2*f**2*fd*r - 13056*C*D1**2*f**2*fd*s**2 + 17408*C*D1**2*f**2*fd*s - 8704*C*D1**2*f**2*fd + 9300*C*D1**2*f**2*fdd*r**2 + 18600*C*D1**2*f**2*fdd*r*s - 12400*C*D1**2*f**2*fdd*r + 9300*C*D1**2*f**2*fdd*s**2 - 12400*C*D1**2*f**2*fdd*s + 6200*C*D1**2*f**2*fdd + 18600*C*D1**2*f*fd**2*r**2 + 37200*C*D1**2*f*fd**2*r*s - 24800*C*D1**2*f*fd**2*r + 18600*C*D1**2*f*fd**2*s**2 - 24800*C*D1**2*f*fd**2*s + 6200*C*D1**2*f*fd**2 - 25344*C*D1*Dd*b1*f**2*r**2 - 50688*C*D1*Dd*b1*f**2*r*s + 38016*C*D1*Dd*b1*f**2*r - 25344*C*D1*Dd*b1*f**2*s**2 + 38016*C*D1*Dd*b1*f**2*s - 19008*C*D1*Dd*b1*f**2 + 65472*C*D1*Dd*b1*f*fd*r**2 + 130944*C*D1*Dd*b1*f*fd*r*s - 81840*C*D1*Dd*b1*f*fd*r + 65472*C*D1*Dd*b1*f*fd*s**2 - 81840*C*D1*Dd*b1*f*fd*s + 24552*C*D1*Dd*b1*f*fd - 17408*C*D1*Dd*f**3*r**2 - 34816*C*D1*Dd*f**3*r*s + 26112*C*D1*Dd*f**3*r - 17408*C*D1*Dd*f**3*s**2 + 26112*C*D1*Dd*f**3*s - 13056*C*D1*Dd*f**3 + 74400*C*D1*Dd*f**2*fd*r**2 + 148800*C*D1*Dd*f**2*fd*r*s - 105400*C*D1*Dd*f**2*fd*r + 74400*C*D1*Dd*f**2*fd*s**2 - 105400*C*D1*Dd*f**2*fd*s + 37200*C*D1*Dd*f**2*fd + 16368*C*D1*Ddd*b1*f**2*r**2 + 32736*C*D1*Ddd*b1*f**2*r*s - 24552*C*D1*Ddd*b1*f**2*r + 16368*C*D1*Ddd*b1*f**2*s**2 - 24552*C*D1*Ddd*b1*f**2*s + 12276*C*D1*Ddd*b1*f**2 + 12400*C*D1*Ddd*f**3*r**2 + 24800*C*D1*Ddd*f**3*r*s - 18600*C*D1*Ddd*f**3*r + 12400*C*D1*Ddd*f**3*s**2 - 18600*C*D1*Ddd*f**3*s + 9300*C*D1*Ddd*f**3 + 49104*C*Dd**2*b1*f**2*r**2 + 98208*C*Dd**2*b1*f**2*r*s - 73656*C*Dd**2*b1*f**2*r + 49104*C*Dd**2*b1*f**2*s**2 - 73656*C*Dd**2*b1*f**2*s + 24552*C*Dd**2*b1*f**2 + 37200*C*Dd**2*f**3*r**2 + 74400*C*Dd**2*f**3*r*s - 55800*C*Dd**2*f**3*r + 37200*C*Dd**2*f**3*s**2 - 55800*C*Dd**2*f**3*s + 18600*C*Dd**2*f**3 + 8646*D1**2*b1*f*fd*r**2 + 17292*D1**2*b1*f*fd*r*s - 8646*D1**2*b1*f*fd*r + 8646*D1**2*b1*f*fd*s**2 - 8646*D1**2*b1*f*fd*s + 4323*D1**2*b1*f*fd - 5676*D1**2*b1*f*fdd*r**2 - 11352*D1**2*b1*f*fdd*r*s + 5676*D1**2*b1*f*fdd*r - 5676*D1**2*b1*f*fdd*s**2 + 5676*D1**2*b1*f*fdd*s - 2838*D1**2*b1*f*fdd - 5676*D1**2*b1*fd**2*r**2 - 11352*D1**2*b1*fd**2*r*s + 5676*D1**2*b1*fd**2*r - 5676*D1**2*b1*fd**2*s**2 + 5676*D1**2*b1*fd**2*s + 66*D1**2*bdd1*f**2*(62*C - 43)*(r + s - 1)**2 + 8841*D1**2*f**2*fd*r**2 + 17682*D1**2*f**2*fd*r*s - 11788*D1**2*f**2*fd*r + 8841*D1**2*f**2*fd*s**2 - 11788*D1**2*f**2*fd*s + 5894*D1**2*f**2*fd - 6450*D1**2*f**2*fdd*r**2 - 12900*D1**2*f**2*fdd*r*s + 8600*D1**2*f**2*fdd*r - 6450*D1**2*f**2*fdd*s**2 + 8600*D1**2*f**2*fdd*s - 4300*D1**2*f**2*fdd - 12900*D1**2*f*fd**2*r**2 - 25800*D1**2*f*fd**2*r*s + 17200*D1**2*f*fd**2*r - 12900*D1**2*f*fd**2*s**2 + 17200*D1**2*f*fd**2*s - 4300*D1**2*f*fd**2 + 17292*D1*Dd*b1*f**2*r**2 + 34584*D1*Dd*b1*f**2*r*s - 25938*D1*Dd*b1*f**2*r + 17292*D1*Dd*b1*f**2*s**2 - 25938*D1*Dd*b1*f**2*s + 12969*D1*Dd*b1*f**2 - 45408*D1*Dd*b1*f*fd*r**2 - 90816*D1*Dd*b1*f*fd*r*s + 56760*D1*Dd*b1*f*fd*r - 45408*D1*Dd*b1*f*fd*s**2 + 56760*D1*Dd*b1*f*fd*s - 17028*D1*Dd*b1*f*fd + 11788*D1*Dd*f**3*r**2 + 23576*D1*Dd*f**3*r*s - 17682*D1*Dd*f**3*r + 11788*D1*Dd*f**3*s**2 - 17682*D1*Dd*f**3*s + 8841*D1*Dd*f**3 - 51600*D1*Dd*f**2*fd*r**2 - 103200*D1*Dd*f**2*fd*r*s + 73100*D1*Dd*f**2*fd*r - 51600*D1*Dd*f**2*fd*s**2 + 73100*D1*Dd*f**2*fd*s - 25800*D1*Dd*f**2*fd - 11352*D1*Ddd*b1*f**2*r**2 - 22704*D1*Ddd*b1*f**2*r*s + 17028*D1*Ddd*b1*f**2*r - 11352*D1*Ddd*b1*f**2*s**2 + 17028*D1*Ddd*b1*f**2*s - 8514*D1*Ddd*b1*f**2 - 8600*D1*Ddd*f**3*r**2 - 17200*D1*Ddd*f**3*r*s + 12900*D1*Ddd*f**3*r - 8600*D1*Ddd*f**3*s**2 + 12900*D1*Ddd*f**3*s - 6450*D1*Ddd*f**3 - 33*D1*bd1*f*(r + s - 1)*(D1*f*(192*C - 131)*(r + s - 1) - D1*fd*(248*C - 172)*(2*r + 2*s - 1) - Dd*f*(248*C - 172)*(4*r + 4*s - 3)) - 34056*Dd**2*b1*f**2*r**2 - 68112*Dd**2*b1*f**2*r*s + 51084*Dd**2*b1*f**2*r - 34056*Dd**2*b1*f**2*s**2 + 51084*Dd**2*b1*f**2*s - 17028*Dd**2*b1*f**2 - 25800*Dd**2*f**3*r**2 - 51600*Dd**2*f**3*r*s + 38700*Dd**2*f**3*r - 25800*Dd**2*f**3*s**2 + 38700*Dd**2*f**3*s - 12900*Dd**2*f**3)/(693*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**3*k1**3*k2**3*(-51480*C*D1**2*f**2*fd*r**2 - 102960*C*D1**2*f**2*fd*r*s + 68640*C*D1**2*f**2*fd*r - 51480*C*D1**2*f**2*fd*s**2 + 68640*C*D1**2*f**2*fd*s - 34320*C*D1**2*f**2*fd - 68640*C*D1*Dd*f**3*r**2 - 137280*C*D1*Dd*f**3*r*s + 102960*C*D1*Dd*f**3*r - 68640*C*D1*Dd*f**3*s**2 + 102960*C*D1*Dd*f**3*s - 51480*C*D1*Dd*f**3 - 42900*D1**2*K*bdd1*f**2*r**2 - 85800*D1**2*K*bdd1*f**2*r*s + 85800*D1**2*K*bdd1*f**2*r - 42900*D1**2*K*bdd1*f**2*s**2 + 85800*D1**2*K*bdd1*f**2*s - 42900*D1**2*K*bdd1*f**2 + 8580*D1**2*bd1**2*f*(-12*K + 5*f + 6)*(r + s - 1)**2 + 9100*D1**2*bdd1*f**3*r**2 + 18200*D1**2*bdd1*f**3*r*s - 18200*D1**2*bdd1*f**3*r + 9100*D1**2*bdd1*f**3*s**2 - 18200*D1**2*bdd1*f**3*s + 9100*D1**2*bdd1*f**3 + 21450*D1**2*bdd1*f**2*r**2 + 42900*D1**2*bdd1*f**2*r*s - 42900*D1**2*bdd1*f**2*r + 21450*D1**2*bdd1*f**2*s**2 - 42900*D1**2*bdd1*f**2*s + 21450*D1**2*bdd1*f**2 + 102960*D1**2*bdd1*f*g2*r**2 + 205920*D1**2*bdd1*f*g2*r*s - 205920*D1**2*bdd1*f*g2*r + 102960*D1**2*bdd1*f*g2*s**2 - 205920*D1**2*bdd1*f*g2*s + 102960*D1**2*bdd1*f*g2 + 26600*D1**2*f**3*fd*r**2 + 53200*D1**2*f**3*fd*r*s - 39900*D1**2*f**3*fd*r + 26600*D1**2*f**3*fd*s**2 - 39900*D1**2*f**3*fd*s + 19950*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 + 32175*D1**2*f**2*fd*r**2 + 64350*D1**2*f**2*fd*r*s - 42900*D1**2*f**2*fd*r + 32175*D1**2*f**2*fd*s**2 - 42900*D1**2*f**2*fd*s + 21450*D1**2*f**2*fd - 89232*D1**2*f**2*gd2*r**2 - 178464*D1**2*f**2*gd2*r*s + 178464*D1**2*f**2*gd2*r - 89232*D1**2*f**2*gd2*s**2 + 178464*D1**2*f**2*gd2*s - 89232*D1**2*f**2*gd2 + 85800*D1**2*f**2*gdd2*r**2 + 171600*D1**2*f**2*gdd2*r*s - 171600*D1**2*f**2*gdd2*r + 85800*D1**2*f**2*gdd2*s**2 - 171600*D1**2*f**2*gdd2*s + 85800*D1**2*f**2*gdd2 - 178464*D1**2*f*fd*g2*r**2 - 356928*D1**2*f*fd*g2*r*s + 178464*D1**2*f*fd*g2*r - 178464*D1**2*f*fd*g2*s**2 + 178464*D1**2*f*fd*g2*s - 89232*D1**2*f*fd*g2 + 343200*D1**2*f*fd*gd2*r**2 + 686400*D1**2*f*fd*gd2*r*s - 514800*D1**2*f*fd*gd2*r + 343200*D1**2*f*fd*gd2*s**2 - 514800*D1**2*f*fd*gd2*s + 171600*D1**2*f*fd*gd2 + 171600*D1**2*f*fdd*g2*r**2 + 343200*D1**2*f*fdd*g2*r*s - 171600*D1**2*f*fdd*g2*r + 171600*D1**2*f*fdd*g2*s**2 - 171600*D1**2*f*fdd*g2*s + 85800*D1**2*f*fdd*g2 + 171600*D1**2*fd**2*g2*r**2 + 343200*D1**2*fd**2*g2*r*s - 171600*D1**2*fd**2*g2*r + 171600*D1**2*fd**2*g2*s**2 - 171600*D1**2*fd**2*g2*s + 26600*D1*Dd*f**4*r**2 + 53200*D1*Dd*f**4*r*s - 39900*D1*Dd*f**4*r + 26600*D1*Dd*f**4*s**2 - 39900*D1*Dd*f**4*s + 19950*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd + 42900*D1*Dd*f**3*r**2 + 85800*D1*Dd*f**3*r*s - 64350*D1*Dd*f**3*r + 42900*D1*Dd*f**3*s**2 - 64350*D1*Dd*f**3*s + 32175*D1*Dd*f**3 - 356928*D1*Dd*f**2*g2*r**2 - 713856*D1*Dd*f**2*g2*r*s + 535392*D1*Dd*f**2*g2*r - 356928*D1*Dd*f**2*g2*s**2 + 535392*D1*Dd*f**2*g2*s - 267696*D1*Dd*f**2*g2 + 686400*D1*Dd*f**2*gd2*r**2 + 1372800*D1*Dd*f**2*gd2*r*s - 1201200*D1*Dd*f**2*gd2*r + 686400*D1*Dd*f**2*gd2*s**2 - 1201200*D1*Dd*f**2*gd2*s + 514800*D1*Dd*f**2*gd2 + 1372800*D1*Dd*f*fd*g2*r**2 + 2745600*D1*Dd*f*fd*g2*r*s - 1716000*D1*Dd*f*fd*g2*r + 1372800*D1*Dd*f*fd*g2*s**2 - 1716000*D1*Dd*f*fd*g2*s + 514800*D1*Dd*f*fd*g2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 343200*D1*Ddd*f**2*g2*r**2 + 686400*D1*Ddd*f**2*g2*r*s - 514800*D1*Ddd*f**2*g2*r + 343200*D1*Ddd*f**2*g2*s**2 - 514800*D1*Ddd*f**2*g2*s + 257400*D1*Ddd*f**2*g2 - 52*D1*bd1*(D1*(185*f**3*(r + s - 1) + 2*f**2*(198*C*(r + s - 1) - 175*fd*(3*r + 3*s - 2) - (429*K - 66)*(r + s - 1)) + 33*f*(25*fd*(2*K - 1)*(2*r + 2*s - 1) + (64*g2 - 120*gd2)*(r + s - 1)) - 3960*fd*g2*(r + s)) - 5*Dd*f*(70*f**2 - 165*f*(2*K - 1) + 792*g2)*(4*r + 4*s - 3))*(r + s - 1) - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 1029600*Dd**2*f**2*g2*r**2 + 2059200*Dd**2*f**2*g2*r*s - 1544400*Dd**2*f**2*g2*r + 1029600*Dd**2*f**2*g2*s**2 - 1544400*Dd**2*f**2*g2*s + 514800*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(2*f*(23*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(128*K - 57)*(r + s) - 60*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(46*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (128*K - 57)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 120*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 10*Ddd*f*(-12*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f*(-12*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 26*b1*(1584*C*D1**2*f*fd*r**2 + 3168*C*D1**2*f*fd*r*s - 1584*C*D1**2*f*fd*r + 1584*C*D1**2*f*fd*s**2 - 1584*C*D1**2*f*fd*s + 792*C*D1**2*f*fd + 3168*C*D1*Dd*f**2*r**2 + 6336*C*D1*Dd*f**2*r*s - 4752*C*D1*Dd*f**2*r + 3168*C*D1*Dd*f**2*s**2 - 4752*C*D1*Dd*f**2*s + 2376*C*D1*Dd*f**2 - 3432*D1**2*K*f*fd*r**2 - 6864*D1**2*K*f*fd*r*s + 3432*D1**2*K*f*fd*r - 3432*D1**2*K*f*fd*s**2 + 3432*D1**2*K*f*fd*s - 1716*D1**2*K*f*fd + 3300*D1**2*K*f*fdd*r**2 + 6600*D1**2*K*f*fdd*r*s - 3300*D1**2*K*f*fdd*r + 3300*D1**2*K*f*fdd*s**2 - 3300*D1**2*K*f*fdd*s + 1650*D1**2*K*f*fdd + 3300*D1**2*K*fd**2*r**2 + 6600*D1**2*K*fd**2*r*s - 3300*D1**2*K*fd**2*r + 3300*D1**2*K*fd**2*s**2 - 3300*D1**2*K*fd**2*s - 330*D1**2*bdd1*f*(-12*K + 5*f + 6)*(r + s - 1)**2 + 1110*D1**2*f**2*fd*r**2 + 2220*D1**2*f**2*fd*r*s - 1480*D1**2*f**2*fd*r + 1110*D1**2*f**2*fd*s**2 - 1480*D1**2*f**2*fd*s + 740*D1**2*f**2*fd - 1050*D1**2*f**2*fdd*r**2 - 2100*D1**2*f**2*fdd*r*s + 1400*D1**2*f**2*fdd*r - 1050*D1**2*f**2*fdd*s**2 + 1400*D1**2*f**2*fdd*s - 700*D1**2*f**2*fdd - 2100*D1**2*f*fd**2*r**2 - 4200*D1**2*f*fd**2*r*s + 2800*D1**2*f*fd**2*r - 2100*D1**2*f*fd**2*s**2 + 2800*D1**2*f*fd**2*s - 700*D1**2*f*fd**2 + 528*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 528*D1**2*f*fd*r + 528*D1**2*f*fd*s**2 - 528*D1**2*f*fd*s + 264*D1**2*f*fd - 1650*D1**2*f*fdd*r**2 - 3300*D1**2*f*fdd*r*s + 1650*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1650*D1**2*f*fdd*s - 825*D1**2*f*fdd + 4224*D1**2*f*gd2*r**2 + 8448*D1**2*f*gd2*r*s - 8448*D1**2*f*gd2*r + 4224*D1**2*f*gd2*s**2 - 8448*D1**2*f*gd2*s + 4224*D1**2*f*gd2 - 3960*D1**2*f*gdd2*r**2 - 7920*D1**2*f*gdd2*r*s + 7920*D1**2*f*gdd2*r - 3960*D1**2*f*gdd2*s**2 + 7920*D1**2*f*gdd2*s - 3960*D1**2*f*gdd2 - 1650*D1**2*fd**2*r**2 - 3300*D1**2*fd**2*r*s + 1650*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1650*D1**2*fd**2*s + 4224*D1**2*fd*g2*r**2 + 8448*D1**2*fd*g2*r*s + 4224*D1**2*fd*g2*s**2 - 7920*D1**2*fd*gd2*r**2 - 15840*D1**2*fd*gd2*r*s + 7920*D1**2*fd*gd2*r - 7920*D1**2*fd*gd2*s**2 + 7920*D1**2*fd*gd2*s - 3960*D1**2*fdd*g2*r**2 - 7920*D1**2*fdd*g2*r*s - 3960*D1**2*fdd*g2*s**2 - 6864*D1*Dd*K*f**2*r**2 - 13728*D1*Dd*K*f**2*r*s + 10296*D1*Dd*K*f**2*r - 6864*D1*Dd*K*f**2*s**2 + 10296*D1*Dd*K*f**2*s - 5148*D1*Dd*K*f**2 + 26400*D1*Dd*K*f*fd*r**2 + 52800*D1*Dd*K*f*fd*r*s - 33000*D1*Dd*K*f*fd*r + 26400*D1*Dd*K*f*fd*s**2 - 33000*D1*Dd*K*f*fd*s + 9900*D1*Dd*K*f*fd + 1480*D1*Dd*f**3*r**2 + 2960*D1*Dd*f**3*r*s - 2220*D1*Dd*f**3*r + 1480*D1*Dd*f**3*s**2 - 2220*D1*Dd*f**3*s + 1110*D1*Dd*f**3 - 8400*D1*Dd*f**2*fd*r**2 - 16800*D1*Dd*f**2*fd*r*s + 11900*D1*Dd*f**2*fd*r - 8400*D1*Dd*f**2*fd*s**2 + 11900*D1*Dd*f**2*fd*s - 4200*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 1584*D1*Dd*f**2*r + 1056*D1*Dd*f**2*s**2 - 1584*D1*Dd*f**2*s + 792*D1*Dd*f**2 - 13200*D1*Dd*f*fd*r**2 - 26400*D1*Dd*f*fd*r*s + 16500*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 16500*D1*Dd*f*fd*s - 4950*D1*Dd*f*fd + 16896*D1*Dd*f*g2*r**2 + 33792*D1*Dd*f*g2*r*s - 25344*D1*Dd*f*g2*r + 16896*D1*Dd*f*g2*s**2 - 25344*D1*Dd*f*g2*s + 12672*D1*Dd*f*g2 - 31680*D1*Dd*f*gd2*r**2 - 63360*D1*Dd*f*gd2*r*s + 55440*D1*Dd*f*gd2*r - 31680*D1*Dd*f*gd2*s**2 + 55440*D1*Dd*f*gd2*s - 23760*D1*Dd*f*gd2 - 31680*D1*Dd*fd*g2*r**2 - 63360*D1*Dd*fd*g2*r*s + 23760*D1*Dd*fd*g2*r - 31680*D1*Dd*fd*g2*s**2 + 23760*D1*Dd*fd*g2*s + 6600*D1*Ddd*K*f**2*r**2 + 13200*D1*Ddd*K*f**2*r*s - 9900*D1*Ddd*K*f**2*r + 6600*D1*Ddd*K*f**2*s**2 - 9900*D1*Ddd*K*f**2*s + 4950*D1*Ddd*K*f**2 - 1400*D1*Ddd*f**3*r**2 - 2800*D1*Ddd*f**3*r*s + 2100*D1*Ddd*f**3*r - 1400*D1*Ddd*f**3*s**2 + 2100*D1*Ddd*f**3*s - 1050*D1*Ddd*f**3 - 3300*D1*Ddd*f**2*r**2 - 6600*D1*Ddd*f**2*r*s + 4950*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 4950*D1*Ddd*f**2*s - 2475*D1*Ddd*f**2 - 15840*D1*Ddd*f*g2*r**2 - 31680*D1*Ddd*f*g2*r*s + 23760*D1*Ddd*f*g2*r - 15840*D1*Ddd*f*g2*s**2 + 23760*D1*Ddd*f*g2*s - 11880*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(46*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(128*K - 57)*(r + s - 1) + 120*fd*(2*K - 1)*(r + s)) - 20*Dd*f*(-12*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 19800*Dd**2*K*f**2*r**2 + 39600*Dd**2*K*f**2*r*s - 29700*Dd**2*K*f**2*r + 19800*Dd**2*K*f**2*s**2 - 29700*Dd**2*K*f**2*s + 9900*Dd**2*K*f**2 - 4200*Dd**2*f**3*r**2 - 8400*Dd**2*f**3*r*s + 6300*Dd**2*f**3*r - 4200*Dd**2*f**3*s**2 + 6300*Dd**2*f**3*s - 2100*Dd**2*f**3 - 9900*Dd**2*f**2*r**2 - 19800*Dd**2*f**2*r*s + 14850*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 14850*Dd**2*f**2*s - 4950*Dd**2*f**2 - 47520*Dd**2*f*g2*r**2 - 95040*Dd**2*f*g2*r*s + 71280*Dd**2*f*g2*r - 47520*Dd**2*f*g2*s**2 + 71280*Dd**2*f*g2*s - 23760*Dd**2*f*g2))/(9009*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**3*k1**3*k2*(8*C - 5)*(33*D1*b1*(D1*bd1*(5*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 6*D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 8*D1*f*fd*r - 8*D1*f*fd*s + 4*D1*f*fd + 10*D1*f*fdd*r + 10*D1*f*fdd*s - 5*D1*f*fdd + 10*D1*fd**2*r + 10*D1*fd**2*s - 10*D1*fd**2 - 12*Dd*bd1*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 40*Dd*f*fd*r + 40*Dd*f*fd*s - 30*Dd*f*fd) + 33*b1**2*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(-396*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 165*D1**2*bdd1*f*(2*r + 2*s - 1) - 5*D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 56*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 66*D1*bd1*(D1*f*(4*r + 4*s - 2) - 5*D1*fd*(r + s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 5*D1*f*(Dd*(23*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 56*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 28*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 840*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**3*k1*k2**5*st**2*(23166*C*D1**2*f**2*fd*r**2 + 46332*C*D1**2*f**2*fd*r*s - 30888*C*D1**2*f**2*fd*r + 23166*C*D1**2*f**2*fd*s**2 - 30888*C*D1**2*f**2*fd*s + 15444*C*D1**2*f**2*fd + 30888*C*D1*Dd*f**3*r**2 + 61776*C*D1*Dd*f**3*r*s - 46332*C*D1*Dd*f**3*r + 30888*C*D1*Dd*f**3*s**2 - 46332*C*D1*Dd*f**3*s + 23166*C*D1*Dd*f**3 + 5148*D1**2*K*bdd1*f**2*r**2 + 10296*D1**2*K*bdd1*f**2*r*s - 10296*D1**2*K*bdd1*f**2*r + 5148*D1**2*K*bdd1*f**2*s**2 - 10296*D1**2*K*bdd1*f**2*s + 5148*D1**2*K*bdd1*f**2 - 858*D1**2*bd1**2*f*(-12*K + 25*f + 9)*(r + s - 1)**2 + 8125*D1**2*bdd1*f**3*r**2 + 16250*D1**2*bdd1*f**3*r*s - 16250*D1**2*bdd1*f**3*r + 8125*D1**2*bdd1*f**3*s**2 - 16250*D1**2*bdd1*f**3*s + 8125*D1**2*bdd1*f**3 - 3861*D1**2*bdd1*f**2*r**2 - 7722*D1**2*bdd1*f**2*r*s + 7722*D1**2*bdd1*f**2*r - 3861*D1**2*bdd1*f**2*s**2 + 7722*D1**2*bdd1*f**2*s - 3861*D1**2*bdd1*f**2 - 10296*D1**2*bdd1*f*g2*r**2 - 20592*D1**2*bdd1*f*g2*r*s + 20592*D1**2*bdd1*f*g2*r - 10296*D1**2*bdd1*f*g2*s**2 + 20592*D1**2*bdd1*f*g2*s - 10296*D1**2*bdd1*f*g2 - 68100*D1**2*f**3*fd*r**2 - 136200*D1**2*f**3*fd*r*s + 102150*D1**2*f**3*fd*r - 68100*D1**2*f**3*fd*s**2 + 102150*D1**2*f**3*fd*s - 51075*D1**2*f**3*fd + 49000*D1**2*f**3*fdd*r**2 + 98000*D1**2*f**3*fdd*r*s - 73500*D1**2*f**3*fdd*r + 49000*D1**2*f**3*fdd*s**2 - 73500*D1**2*f**3*fdd*s + 36750*D1**2*f**3*fdd + 147000*D1**2*f**2*fd**2*r**2 + 294000*D1**2*f**2*fd**2*r*s - 220500*D1**2*f**2*fd**2*r + 147000*D1**2*f**2*fd**2*s**2 - 220500*D1**2*f**2*fd**2*s + 73500*D1**2*f**2*fd**2 - 19305*D1**2*f**2*fd*r**2 - 38610*D1**2*f**2*fd*r*s + 25740*D1**2*f**2*fd*r - 19305*D1**2*f**2*fd*s**2 + 25740*D1**2*f**2*fd*s - 12870*D1**2*f**2*fd + 19734*D1**2*f**2*gd2*r**2 + 39468*D1**2*f**2*gd2*r*s - 39468*D1**2*f**2*gd2*r + 19734*D1**2*f**2*gd2*s**2 - 39468*D1**2*f**2*gd2*s + 19734*D1**2*f**2*gd2 - 10296*D1**2*f**2*gdd2*r**2 - 20592*D1**2*f**2*gdd2*r*s + 20592*D1**2*f**2*gdd2*r - 10296*D1**2*f**2*gdd2*s**2 + 20592*D1**2*f**2*gdd2*s - 10296*D1**2*f**2*gdd2 + 39468*D1**2*f*fd*g2*r**2 + 78936*D1**2*f*fd*g2*r*s - 39468*D1**2*f*fd*g2*r + 39468*D1**2*f*fd*g2*s**2 - 39468*D1**2*f*fd*g2*s + 19734*D1**2*f*fd*g2 - 41184*D1**2*f*fd*gd2*r**2 - 82368*D1**2*f*fd*gd2*r*s + 61776*D1**2*f*fd*gd2*r - 41184*D1**2*f*fd*gd2*s**2 + 61776*D1**2*f*fd*gd2*s - 20592*D1**2*f*fd*gd2 - 20592*D1**2*f*fdd*g2*r**2 - 41184*D1**2*f*fdd*g2*r*s + 20592*D1**2*f*fdd*g2*r - 20592*D1**2*f*fdd*g2*s**2 + 20592*D1**2*f*fdd*g2*s - 10296*D1**2*f*fdd*g2 - 20592*D1**2*fd**2*g2*r**2 - 41184*D1**2*fd**2*g2*r*s + 20592*D1**2*fd**2*g2*r - 20592*D1**2*fd**2*g2*s**2 + 20592*D1**2*fd**2*g2*s - 68100*D1*Dd*f**4*r**2 - 136200*D1*Dd*f**4*r*s + 102150*D1*Dd*f**4*r - 68100*D1*Dd*f**4*s**2 + 102150*D1*Dd*f**4*s - 51075*D1*Dd*f**4 + 392000*D1*Dd*f**3*fd*r**2 + 784000*D1*Dd*f**3*fd*r*s - 588000*D1*Dd*f**3*fd*r + 392000*D1*Dd*f**3*fd*s**2 - 588000*D1*Dd*f**3*fd*s + 220500*D1*Dd*f**3*fd - 25740*D1*Dd*f**3*r**2 - 51480*D1*Dd*f**3*r*s + 38610*D1*Dd*f**3*r - 25740*D1*Dd*f**3*s**2 + 38610*D1*Dd*f**3*s - 19305*D1*Dd*f**3 + 78936*D1*Dd*f**2*g2*r**2 + 157872*D1*Dd*f**2*g2*r*s - 118404*D1*Dd*f**2*g2*r + 78936*D1*Dd*f**2*g2*s**2 - 118404*D1*Dd*f**2*g2*s + 59202*D1*Dd*f**2*g2 - 82368*D1*Dd*f**2*gd2*r**2 - 164736*D1*Dd*f**2*gd2*r*s + 144144*D1*Dd*f**2*gd2*r - 82368*D1*Dd*f**2*gd2*s**2 + 144144*D1*Dd*f**2*gd2*s - 61776*D1*Dd*f**2*gd2 - 164736*D1*Dd*f*fd*g2*r**2 - 329472*D1*Dd*f*fd*g2*r*s + 205920*D1*Dd*f*fd*g2*r - 164736*D1*Dd*f*fd*g2*s**2 + 205920*D1*Dd*f*fd*g2*s - 61776*D1*Dd*f*fd*g2 + 49000*D1*Ddd*f**4*r**2 + 98000*D1*Ddd*f**4*r*s - 73500*D1*Ddd*f**4*r + 49000*D1*Ddd*f**4*s**2 - 73500*D1*Ddd*f**4*s + 36750*D1*Ddd*f**4 - 41184*D1*Ddd*f**2*g2*r**2 - 82368*D1*Ddd*f**2*g2*r*s + 61776*D1*Ddd*f**2*g2*r - 41184*D1*Ddd*f**2*g2*s**2 + 61776*D1*Ddd*f**2*g2*s - 30888*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(689*f**3*(r + s - 1) - f**2*(594*C*(r + s - 1) + 1250*fd*(3*r + 3*s - 2) - (759*K - 66)*(r + s - 1)) - 66*f*(3*fd*(4*K - 3)*(2*r + 2*s - 1) + (31*g2 - 24*gd2)*(r + s - 1)) + 1584*fd*g2*(r + s)) - 2*Dd*f*(625*f**2 + 99*f*(4*K - 3) - 792*g2)*(4*r + 4*s - 3))*(r + s - 1) + 147000*Dd**2*f**4*r**2 + 294000*Dd**2*f**4*r*s - 220500*Dd**2*f**4*r + 147000*Dd**2*f**4*s**2 - 220500*Dd**2*f**4*s + 73500*Dd**2*f**4 - 123552*Dd**2*f**2*g2*r**2 - 247104*Dd**2*f**2*g2*r*s + 185328*Dd**2*f**2*g2*r - 123552*Dd**2*f**2*g2*s**2 + 185328*Dd**2*f**2*g2*s - 61776*Dd**2*f**2*g2 + 429*b1**2*(D1**2*(f*(44*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + fd*(31*K - 25)*(r + s) - 3*fdd*(4*K - 3)*(r + s))) + D1*(Dd*(44*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(50*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (31*K - 25)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(4*K - 3)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-12*K + 25*f + 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-12*K + 25*f + 9)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(1188*C*D1**2*f*fd*r**2 + 2376*C*D1**2*f*fd*r*s - 1188*C*D1**2*f*fd*r + 1188*C*D1**2*f*fd*s**2 - 1188*C*D1**2*f*fd*s + 594*C*D1**2*f*fd + 2376*C*D1*Dd*f**2*r**2 + 4752*C*D1*Dd*f**2*r*s - 3564*C*D1*Dd*f**2*r + 2376*C*D1*Dd*f**2*s**2 - 3564*C*D1*Dd*f**2*s + 1782*C*D1*Dd*f**2 - 1518*D1**2*K*f*fd*r**2 - 3036*D1**2*K*f*fd*r*s + 1518*D1**2*K*f*fd*r - 1518*D1**2*K*f*fd*s**2 + 1518*D1**2*K*f*fd*s - 759*D1**2*K*f*fd + 792*D1**2*K*f*fdd*r**2 + 1584*D1**2*K*f*fdd*r*s - 792*D1**2*K*f*fdd*r + 792*D1**2*K*f*fdd*s**2 - 792*D1**2*K*f*fdd*s + 396*D1**2*K*f*fdd + 792*D1**2*K*fd**2*r**2 + 1584*D1**2*K*fd**2*r*s - 792*D1**2*K*fd**2*r + 792*D1**2*K*fd**2*s**2 - 792*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(-12*K + 25*f + 9)*(r + s - 1)**2 - 2067*D1**2*f**2*fd*r**2 - 4134*D1**2*f**2*fd*r*s + 2756*D1**2*f**2*fd*r - 2067*D1**2*f**2*fd*s**2 + 2756*D1**2*f**2*fd*s - 1378*D1**2*f**2*fd + 1875*D1**2*f**2*fdd*r**2 + 3750*D1**2*f**2*fdd*r*s - 2500*D1**2*f**2*fdd*r + 1875*D1**2*f**2*fdd*s**2 - 2500*D1**2*f**2*fdd*s + 1250*D1**2*f**2*fdd + 3750*D1**2*f*fd**2*r**2 + 7500*D1**2*f*fd**2*r*s - 5000*D1**2*f*fd**2*r + 3750*D1**2*f*fd**2*s**2 - 5000*D1**2*f*fd**2*s + 1250*D1**2*f*fd**2 + 132*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 132*D1**2*f*fd*r + 132*D1**2*f*fd*s**2 - 132*D1**2*f*fd*s + 66*D1**2*f*fd - 594*D1**2*f*fdd*r**2 - 1188*D1**2*f*fdd*r*s + 594*D1**2*f*fdd*r - 594*D1**2*f*fdd*s**2 + 594*D1**2*f*fdd*s - 297*D1**2*f*fdd + 2046*D1**2*f*gd2*r**2 + 4092*D1**2*f*gd2*r*s - 4092*D1**2*f*gd2*r + 2046*D1**2*f*gd2*s**2 - 4092*D1**2*f*gd2*s + 2046*D1**2*f*gd2 - 792*D1**2*f*gdd2*r**2 - 1584*D1**2*f*gdd2*r*s + 1584*D1**2*f*gdd2*r - 792*D1**2*f*gdd2*s**2 + 1584*D1**2*f*gdd2*s - 792*D1**2*f*gdd2 - 594*D1**2*fd**2*r**2 - 1188*D1**2*fd**2*r*s + 594*D1**2*fd**2*r - 594*D1**2*fd**2*s**2 + 594*D1**2*fd**2*s + 2046*D1**2*fd*g2*r**2 + 4092*D1**2*fd*g2*r*s + 2046*D1**2*fd*g2*s**2 - 1584*D1**2*fd*gd2*r**2 - 3168*D1**2*fd*gd2*r*s + 1584*D1**2*fd*gd2*r - 1584*D1**2*fd*gd2*s**2 + 1584*D1**2*fd*gd2*s - 792*D1**2*fdd*g2*r**2 - 1584*D1**2*fdd*g2*r*s - 792*D1**2*fdd*g2*s**2 - 3036*D1*Dd*K*f**2*r**2 - 6072*D1*Dd*K*f**2*r*s + 4554*D1*Dd*K*f**2*r - 3036*D1*Dd*K*f**2*s**2 + 4554*D1*Dd*K*f**2*s - 2277*D1*Dd*K*f**2 + 6336*D1*Dd*K*f*fd*r**2 + 12672*D1*Dd*K*f*fd*r*s - 7920*D1*Dd*K*f*fd*r + 6336*D1*Dd*K*f*fd*s**2 - 7920*D1*Dd*K*f*fd*s + 2376*D1*Dd*K*f*fd - 2756*D1*Dd*f**3*r**2 - 5512*D1*Dd*f**3*r*s + 4134*D1*Dd*f**3*r - 2756*D1*Dd*f**3*s**2 + 4134*D1*Dd*f**3*s - 2067*D1*Dd*f**3 + 15000*D1*Dd*f**2*fd*r**2 + 30000*D1*Dd*f**2*fd*r*s - 21250*D1*Dd*f**2*fd*r + 15000*D1*Dd*f**2*fd*s**2 - 21250*D1*Dd*f**2*fd*s + 7500*D1*Dd*f**2*fd + 264*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 396*D1*Dd*f**2*r + 264*D1*Dd*f**2*s**2 - 396*D1*Dd*f**2*s + 198*D1*Dd*f**2 - 4752*D1*Dd*f*fd*r**2 - 9504*D1*Dd*f*fd*r*s + 5940*D1*Dd*f*fd*r - 4752*D1*Dd*f*fd*s**2 + 5940*D1*Dd*f*fd*s - 1782*D1*Dd*f*fd + 8184*D1*Dd*f*g2*r**2 + 16368*D1*Dd*f*g2*r*s - 12276*D1*Dd*f*g2*r + 8184*D1*Dd*f*g2*s**2 - 12276*D1*Dd*f*g2*s + 6138*D1*Dd*f*g2 - 6336*D1*Dd*f*gd2*r**2 - 12672*D1*Dd*f*gd2*r*s + 11088*D1*Dd*f*gd2*r - 6336*D1*Dd*f*gd2*s**2 + 11088*D1*Dd*f*gd2*s - 4752*D1*Dd*f*gd2 - 6336*D1*Dd*fd*g2*r**2 - 12672*D1*Dd*fd*g2*r*s + 4752*D1*Dd*fd*g2*r - 6336*D1*Dd*fd*g2*s**2 + 4752*D1*Dd*fd*g2*s + 1584*D1*Ddd*K*f**2*r**2 + 3168*D1*Ddd*K*f**2*r*s - 2376*D1*Ddd*K*f**2*r + 1584*D1*Ddd*K*f**2*s**2 - 2376*D1*Ddd*K*f**2*s + 1188*D1*Ddd*K*f**2 + 2500*D1*Ddd*f**3*r**2 + 5000*D1*Ddd*f**3*r*s - 3750*D1*Ddd*f**3*r + 2500*D1*Ddd*f**3*s**2 - 3750*D1*Ddd*f**3*s + 1875*D1*Ddd*f**3 - 1188*D1*Ddd*f**2*r**2 - 2376*D1*Ddd*f**2*r*s + 1782*D1*Ddd*f**2*r - 1188*D1*Ddd*f**2*s**2 + 1782*D1*Ddd*f**2*s - 891*D1*Ddd*f**2 - 3168*D1*Ddd*f*g2*r**2 - 6336*D1*Ddd*f*g2*r*s + 4752*D1*Ddd*f*g2*r - 3168*D1*Ddd*f*g2*s**2 + 4752*D1*Ddd*f*g2*s - 2376*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(44*f**2*(r + s - 1) - 50*f*fd*(2*r + 2*s - 1) - f*(31*K - 25)*(r + s - 1) + 6*fd*(4*K - 3)*(r + s)) - 2*Dd*f*(-12*K + 25*f + 9)*(4*r + 4*s - 3))*(r + s - 1) + 4752*Dd**2*K*f**2*r**2 + 9504*Dd**2*K*f**2*r*s - 7128*Dd**2*K*f**2*r + 4752*Dd**2*K*f**2*s**2 - 7128*Dd**2*K*f**2*s + 2376*Dd**2*K*f**2 + 7500*Dd**2*f**3*r**2 + 15000*Dd**2*f**3*r*s - 11250*Dd**2*f**3*r + 7500*Dd**2*f**3*s**2 - 11250*Dd**2*f**3*s + 3750*Dd**2*f**3 - 3564*Dd**2*f**2*r**2 - 7128*Dd**2*f**2*r*s + 5346*Dd**2*f**2*r - 3564*Dd**2*f**2*s**2 + 5346*Dd**2*f**2*s - 1782*Dd**2*f**2 - 9504*Dd**2*f*g2*r**2 - 19008*Dd**2*f*g2*r*s + 14256*Dd**2*f*g2*r - 9504*Dd**2*f*g2*s**2 + 14256*Dd**2*f*g2*s - 4752*Dd**2*f*g2))/(9009*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**3*k1*k2**3*st**2*(-33*b1**2*(D1**2*(fd*(50*C - 44) + fdd*(15 - 18*C))*(r + s - 1)**2 + D1*(2*Dd*(f*(25*C - 22)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(15 - 18*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(15 - 18*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(108*C - 90)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-68*C*D1**2*f*fd*r**2 - 136*C*D1**2*f*fd*r*s - 68*C*D1**2*f*fd*s**2 + 44*C*D1**2*f*fdd*r**2 + 88*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r + 44*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s + 4*C*D1**2*f*fdd + 44*C*D1**2*fd**2*r**2 + 88*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r + 44*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s - 36*C*D1**2*fd**2 - 136*C*D1*Dd*f**2*r**2 - 272*C*D1*Dd*f**2*r*s + 204*C*D1*Dd*f**2*r - 136*C*D1*Dd*f**2*s**2 + 204*C*D1*Dd*f**2*s - 102*C*D1*Dd*f**2 + 352*C*D1*Dd*f*fd*r**2 + 704*C*D1*Dd*f*fd*r*s - 296*C*D1*Dd*f*fd*r + 352*C*D1*Dd*f*fd*s**2 - 296*C*D1*Dd*f*fd*s + 24*C*D1*Dd*f*fd + 88*C*D1*Ddd*f**2*r**2 + 176*C*D1*Ddd*f**2*r*s - 132*C*D1*Ddd*f**2*r + 88*C*D1*Ddd*f**2*s**2 - 132*C*D1*Ddd*f**2*s + 66*C*D1*Ddd*f**2 + 264*C*Dd**2*f**2*r**2 + 528*C*Dd**2*f**2*r*s - 396*C*Dd**2*f**2*r + 264*C*Dd**2*f**2*s**2 - 396*C*Dd**2*f**2*s + 132*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(6*C - 5)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 66*D1**2*f*fd*r**2 + 132*D1**2*f*fd*r*s - 10*D1**2*f*fd*r + 66*D1**2*f*fd*s**2 - 10*D1**2*f*fd*s + 5*D1**2*f*fd - 46*D1**2*f*fdd*r**2 - 92*D1**2*f*fdd*r*s + 16*D1**2*f*fdd*r - 46*D1**2*f*fdd*s**2 + 16*D1**2*f*fdd*s - 8*D1**2*f*fdd - 46*D1**2*fd**2*r**2 - 92*D1**2*fd**2*r*s + 16*D1**2*fd**2*r - 46*D1**2*fd**2*s**2 + 16*D1**2*fd**2*s + 30*D1**2*fd**2 + 132*D1*Dd*f**2*r**2 + 264*D1*Dd*f**2*r*s - 198*D1*Dd*f**2*r + 132*D1*Dd*f**2*s**2 - 198*D1*Dd*f**2*s + 99*D1*Dd*f**2 - 368*D1*Dd*f*fd*r**2 - 736*D1*Dd*f*fd*r*s + 340*D1*Dd*f*fd*r - 368*D1*Dd*f*fd*s**2 + 340*D1*Dd*f*fd*s - 48*D1*Dd*f*fd - 92*D1*Ddd*f**2*r**2 - 184*D1*Ddd*f**2*r*s + 138*D1*Ddd*f**2*r - 92*D1*Ddd*f**2*s**2 + 138*D1*Ddd*f**2*s - 69*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(25*C - 22)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(15 - 18*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(15 - 18*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 276*Dd**2*f**2*r**2 - 552*Dd**2*f**2*r*s + 414*Dd**2*f**2*r - 276*Dd**2*f**2*s**2 + 414*Dd**2*f**2*s - 138*Dd**2*f**2) + f*(4812*C*D1**2*f*fd*r**2 + 9624*C*D1**2*f*fd*r*s - 6416*C*D1**2*f*fd*r + 4812*C*D1**2*f*fd*s**2 - 6416*C*D1**2*f*fd*s + 3208*C*D1**2*f*fd - 3000*C*D1**2*f*fdd*r**2 - 6000*C*D1**2*f*fdd*r*s + 4000*C*D1**2*f*fdd*r - 3000*C*D1**2*f*fdd*s**2 + 4000*C*D1**2*f*fdd*s - 2000*C*D1**2*f*fdd - 6000*C*D1**2*fd**2*r**2 - 12000*C*D1**2*fd**2*r*s + 8000*C*D1**2*fd**2*r - 6000*C*D1**2*fd**2*s**2 + 8000*C*D1**2*fd**2*s - 2000*C*D1**2*fd**2 + 6416*C*D1*Dd*f**2*r**2 + 12832*C*D1*Dd*f**2*r*s - 9624*C*D1*Dd*f**2*r + 6416*C*D1*Dd*f**2*s**2 - 9624*C*D1*Dd*f**2*s + 4812*C*D1*Dd*f**2 - 24000*C*D1*Dd*f*fd*r**2 - 48000*C*D1*Dd*f*fd*r*s + 34000*C*D1*Dd*f*fd*r - 24000*C*D1*Dd*f*fd*s**2 + 34000*C*D1*Dd*f*fd*s - 12000*C*D1*Dd*f*fd - 4000*C*D1*Ddd*f**2*r**2 - 8000*C*D1*Ddd*f**2*r*s + 6000*C*D1*Ddd*f**2*r - 4000*C*D1*Ddd*f**2*s**2 + 6000*C*D1*Ddd*f**2*s - 3000*C*D1*Ddd*f**2 - 12000*C*Dd**2*f**2*r**2 - 24000*C*Dd**2*f**2*r*s + 18000*C*Dd**2*f**2*r - 12000*C*Dd**2*f**2*s**2 + 18000*C*Dd**2*f**2*s - 6000*C*Dd**2*f**2 + 198*D1**2*bd1**2*(6*C - 5)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 33*D1**2*bdd1*f*(C*(22*r**2 + 44*r*s - 80*r + 22*s**2 - 80*s + 40) - 23*r**2 - 46*r*s + 76*r - 23*s**2 + 76*s - 38) - 4215*D1**2*f*fd*r**2 - 8430*D1**2*f*fd*r*s + 5620*D1**2*f*fd*r - 4215*D1**2*f*fd*s**2 + 5620*D1**2*f*fd*s - 2810*D1**2*f*fd + 2850*D1**2*f*fdd*r**2 + 5700*D1**2*f*fdd*r*s - 3800*D1**2*f*fdd*r + 2850*D1**2*f*fdd*s**2 - 3800*D1**2*f*fdd*s + 1900*D1**2*f*fdd + 5700*D1**2*fd**2*r**2 + 11400*D1**2*fd**2*r*s - 7600*D1**2*fd**2*r + 5700*D1**2*fd**2*s**2 - 7600*D1**2*fd**2*s + 1900*D1**2*fd**2 - 5620*D1*Dd*f**2*r**2 - 11240*D1*Dd*f**2*r*s + 8430*D1*Dd*f**2*r - 5620*D1*Dd*f**2*s**2 + 8430*D1*Dd*f**2*s - 4215*D1*Dd*f**2 + 22800*D1*Dd*f*fd*r**2 + 45600*D1*Dd*f*fd*r*s - 32300*D1*Dd*f*fd*r + 22800*D1*Dd*f*fd*s**2 - 32300*D1*Dd*f*fd*s + 11400*D1*Dd*f*fd + 3800*D1*Ddd*f**2*r**2 + 7600*D1*Ddd*f**2*r*s - 5700*D1*Ddd*f**2*r + 3800*D1*Ddd*f**2*s**2 - 5700*D1*Ddd*f**2*s + 2850*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f*(34*C*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) - 33*r**2 - 66*r*s + 122*r - 33*s**2 + 122*s - 61) - 4*fd*(r + s - 1)*(C*(22*r + 22*s - 20) - 23*r - 23*s + 19)) - 2*Dd*f*(4*r + 4*s - 3)*(C*(22*r + 22*s - 40) - 23*r - 23*s + 38)) + 11400*Dd**2*f**2*r**2 + 22800*Dd**2*f**2*r*s - 17100*Dd**2*f**2*r + 11400*Dd**2*f**2*s**2 - 17100*Dd**2*f**2*s + 5700*Dd**2*f**2))/(693*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**3*k1*k2**3*(528*C*D1**2*bd1*f**2*r + 528*C*D1**2*bd1*f**2*s - 264*C*D1**2*bd1*f**2 - 660*C*D1**2*f**2*fd*r**2 - 1320*C*D1**2*f**2*fd*r*s + 880*C*D1**2*f**2*fd*r - 660*C*D1**2*f**2*fd*s**2 + 880*C*D1**2*f**2*fd*s - 440*C*D1**2*f**2*fd - 880*C*D1*Dd*f**3*r**2 - 1760*C*D1*Dd*f**3*r*s + 1320*C*D1*Dd*f**3*r - 880*C*D1*Dd*f**3*s**2 + 1320*C*D1*Dd*f**3*s - 660*C*D1*Dd*f**3 + 528*D1**2*K*bd1**2*f*r + 528*D1**2*K*bd1**2*f*s - 528*D1**2*K*bd1**2*f + 308*D1**2*K*bd1*f**2*r**2 + 616*D1**2*K*bd1*f**2*r*s - 616*D1**2*K*bd1*f**2*r + 308*D1**2*K*bd1*f**2*s**2 - 616*D1**2*K*bd1*f**2*s + 308*D1**2*K*bd1*f**2 - 880*D1**2*K*bd1*f*fd*r**2 - 1760*D1**2*K*bd1*f*fd*r*s + 1320*D1**2*K*bd1*f*fd*r - 880*D1**2*K*bd1*f*fd*s**2 + 1320*D1**2*K*bd1*f*fd*s - 440*D1**2*K*bd1*f*fd - 220*D1**2*K*bdd1*f**2*r**2 - 440*D1**2*K*bdd1*f**2*r*s + 440*D1**2*K*bdd1*f**2*r - 220*D1**2*K*bdd1*f**2*s**2 + 440*D1**2*K*bdd1*f**2*s - 220*D1**2*K*bdd1*f**2 + 660*D1**2*bd1**2*f**2*r**2 + 1320*D1**2*bd1**2*f**2*r*s - 1320*D1**2*bd1**2*f**2*r + 660*D1**2*bd1**2*f**2*s**2 - 1320*D1**2*bd1**2*f**2*s + 660*D1**2*bd1**2*f**2 + 396*D1**2*bd1**2*f*r**2 + 792*D1**2*bd1**2*f*r*s - 1188*D1**2*bd1**2*f*r + 396*D1**2*bd1**2*f*s**2 - 1188*D1**2*bd1**2*f*s + 792*D1**2*bd1**2*f - 1232*D1**2*bd1**2*g2*r**2 - 2464*D1**2*bd1**2*g2*r*s + 1232*D1**2*bd1**2*g2*r - 1232*D1**2*bd1**2*g2*s**2 + 1232*D1**2*bd1**2*g2*s - 528*D1**2*bd1*bd2*f*r**2 - 1056*D1**2*bd1*bd2*f*r*s + 1056*D1**2*bd1*bd2*f*r - 528*D1**2*bd1*bd2*f*s**2 + 1056*D1**2*bd1*bd2*f*s - 528*D1**2*bd1*bd2*f - 400*D1**2*bd1*f**3*r**2 - 800*D1**2*bd1*f**3*r*s + 570*D1**2*bd1*f**3*r - 400*D1**2*bd1*f**3*s**2 + 570*D1**2*bd1*f**3*s - 285*D1**2*bd1*f**3 + 2520*D1**2*bd1*f**2*fd*r**2 + 5040*D1**2*bd1*f**2*fd*r*s - 3640*D1**2*bd1*f**2*fd*r + 2520*D1**2*bd1*f**2*fd*s**2 - 3640*D1**2*bd1*f**2*fd*s + 1120*D1**2*bd1*f**2*fd - 330*D1**2*bd1*f**2*r**2 - 660*D1**2*bd1*f**2*r*s + 264*D1**2*bd1*f**2*r - 330*D1**2*bd1*f**2*s**2 + 264*D1**2*bd1*f**2*s - 132*D1**2*bd1*f**2 + 1320*D1**2*bd1*f*fd*r**2 + 2640*D1**2*bd1*f*fd*r*s - 1980*D1**2*bd1*f*fd*r + 1320*D1**2*bd1*f*fd*s**2 - 1980*D1**2*bd1*f*fd*s + 660*D1**2*bd1*f*fd + 1496*D1**2*bd1*f*g2*r + 1496*D1**2*bd1*f*g2*s - 748*D1**2*bd1*f*g2 - 1056*D1**2*bd1*f*gd2*r - 1056*D1**2*bd1*f*gd2*s + 1056*D1**2*bd1*f*gd2 + 308*D1**2*bd2*f**2*r**2 + 616*D1**2*bd2*f**2*r*s - 616*D1**2*bd2*f**2*r + 308*D1**2*bd2*f**2*s**2 - 616*D1**2*bd2*f**2*s + 308*D1**2*bd2*f**2 - 880*D1**2*bd2*f*fd*r**2 - 1760*D1**2*bd2*f*fd*r*s + 1320*D1**2*bd2*f*fd*r - 880*D1**2*bd2*f*fd*s**2 + 1320*D1**2*bd2*f*fd*s - 440*D1**2*bd2*f*fd + 420*D1**2*bdd1*f**3*r**2 + 840*D1**2*bdd1*f**3*r*s - 560*D1**2*bdd1*f**3*r + 420*D1**2*bdd1*f**3*s**2 - 560*D1**2*bdd1*f**3*s + 280*D1**2*bdd1*f**3 + 330*D1**2*bdd1*f**2*r**2 + 660*D1**2*bdd1*f**2*r*s - 660*D1**2*bdd1*f**2*r + 330*D1**2*bdd1*f**2*s**2 - 660*D1**2*bdd1*f**2*s + 330*D1**2*bdd1*f**2 - 1056*D1**2*bdd1*f*g2*r - 1056*D1**2*bdd1*f*g2*s + 528*D1**2*bdd1*f*g2 - 220*D1**2*bdd2*f**2*r**2 - 440*D1**2*bdd2*f**2*r*s + 440*D1**2*bdd2*f**2*r - 220*D1**2*bdd2*f**2*s**2 + 440*D1**2*bdd2*f**2*s - 220*D1**2*bdd2*f**2 + 495*D1**2*f**2*fd*r**2 + 990*D1**2*f**2*fd*r*s - 660*D1**2*f**2*fd*r + 495*D1**2*f**2*fd*s**2 - 660*D1**2*f**2*fd*s + 330*D1**2*f**2*fd - 616*D1**2*f**2*gd2*r**2 - 1232*D1**2*f**2*gd2*r*s + 1232*D1**2*f**2*gd2*r - 616*D1**2*f**2*gd2*s**2 + 1232*D1**2*f**2*gd2*s - 616*D1**2*f**2*gd2 + 440*D1**2*f**2*gdd2*r**2 + 880*D1**2*f**2*gdd2*r*s - 880*D1**2*f**2*gdd2*r + 440*D1**2*f**2*gdd2*s**2 - 880*D1**2*f**2*gdd2*s + 440*D1**2*f**2*gdd2 - 1232*D1**2*f*fd*g2*r**2 - 2464*D1**2*f*fd*g2*r*s + 1232*D1**2*f*fd*g2*r - 1232*D1**2*f*fd*g2*s**2 + 1232*D1**2*f*fd*g2*s - 616*D1**2*f*fd*g2 + 1760*D1**2*f*fd*gd2*r**2 + 3520*D1**2*f*fd*gd2*r*s - 2640*D1**2*f*fd*gd2*r + 1760*D1**2*f*fd*gd2*s**2 - 2640*D1**2*f*fd*gd2*s + 880*D1**2*f*fd*gd2 + 880*D1**2*f*fdd*g2*r**2 + 1760*D1**2*f*fdd*g2*r*s - 880*D1**2*f*fdd*g2*r + 880*D1**2*f*fdd*g2*s**2 - 880*D1**2*f*fdd*g2*s + 440*D1**2*f*fdd*g2 + 880*D1**2*fd**2*g2*r**2 + 1760*D1**2*fd**2*g2*r*s - 880*D1**2*fd**2*g2*r + 880*D1**2*fd**2*g2*s**2 - 880*D1**2*fd**2*g2*s - 1760*D1*Dd*K*bd1*f**2*r**2 - 3520*D1*Dd*K*bd1*f**2*r*s + 3080*D1*Dd*K*bd1*f**2*r - 1760*D1*Dd*K*bd1*f**2*s**2 + 3080*D1*Dd*K*bd1*f**2*s - 1320*D1*Dd*K*bd1*f**2 + 3360*D1*Dd*bd1*f**3*r**2 + 6720*D1*Dd*bd1*f**3*r*s - 4760*D1*Dd*bd1*f**3*r + 3360*D1*Dd*bd1*f**3*s**2 - 4760*D1*Dd*bd1*f**3*s + 1680*D1*Dd*bd1*f**3 + 2640*D1*Dd*bd1*f**2*r**2 + 5280*D1*Dd*bd1*f**2*r*s - 4620*D1*Dd*bd1*f**2*r + 2640*D1*Dd*bd1*f**2*s**2 - 4620*D1*Dd*bd1*f**2*s + 1980*D1*Dd*bd1*f**2 - 4224*D1*Dd*bd1*f*g2*r - 4224*D1*Dd*bd1*f*g2*s + 3168*D1*Dd*bd1*f*g2 - 1760*D1*Dd*bd2*f**2*r**2 - 3520*D1*Dd*bd2*f**2*r*s + 3080*D1*Dd*bd2*f**2*r - 1760*D1*Dd*bd2*f**2*s**2 + 3080*D1*Dd*bd2*f**2*s - 1320*D1*Dd*bd2*f**2 + 660*D1*Dd*f**3*r**2 + 1320*D1*Dd*f**3*r*s - 990*D1*Dd*f**3*r + 660*D1*Dd*f**3*s**2 - 990*D1*Dd*f**3*s + 495*D1*Dd*f**3 - 2464*D1*Dd*f**2*g2*r**2 - 4928*D1*Dd*f**2*g2*r*s + 3696*D1*Dd*f**2*g2*r - 2464*D1*Dd*f**2*g2*s**2 + 3696*D1*Dd*f**2*g2*s - 1848*D1*Dd*f**2*g2 + 3520*D1*Dd*f**2*gd2*r**2 + 7040*D1*Dd*f**2*gd2*r*s - 6160*D1*Dd*f**2*gd2*r + 3520*D1*Dd*f**2*gd2*s**2 - 6160*D1*Dd*f**2*gd2*s + 2640*D1*Dd*f**2*gd2 + 7040*D1*Dd*f*fd*g2*r**2 + 14080*D1*Dd*f*fd*g2*r*s - 8800*D1*Dd*f*fd*g2*r + 7040*D1*Dd*f*fd*g2*s**2 - 8800*D1*Dd*f*fd*g2*s + 2640*D1*Dd*f*fd*g2 + 1760*D1*Ddd*f**2*g2*r**2 + 3520*D1*Ddd*f**2*g2*r*s - 2640*D1*Ddd*f**2*g2*r + 1760*D1*Ddd*f**2*g2*s**2 - 2640*D1*Ddd*f**2*g2*s + 1320*D1*Ddd*f**2*g2 + 5280*Dd**2*f**2*g2*r**2 + 10560*Dd**2*f**2*g2*r*s - 7920*Dd**2*f**2*g2*r + 5280*Dd**2*f**2*g2*s**2 - 7920*Dd**2*f**2*g2*s + 2640*Dd**2*f**2*g2 + 11*b1**3*(2*D1**2*(11*fd - 9*fdd)*(r + s - 1)**2 + D1*(2*Dd*(11*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (28*K - 21)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-28*K + 18*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-28*K + 18*f + 21)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(28*C*D1**2*fd*r**2 + 56*C*D1**2*fd*r*s - 56*C*D1**2*fd*r + 28*C*D1**2*fd*s**2 - 56*C*D1**2*fd*s + 28*C*D1**2*fd + 112*C*D1*Dd*f*r**2 + 224*C*D1*Dd*f*r*s - 168*C*D1*Dd*f*r + 112*C*D1*Dd*f*s**2 - 168*C*D1*Dd*f*s + 84*C*D1*Dd*f + 68*D1**2*K*fd*r + 68*D1**2*K*fd*s - 34*D1**2*K*fd - 48*D1**2*K*fdd*r - 48*D1**2*K*fdd*s + 24*D1**2*K*fdd - D1**2*bdd1*(-28*K + 18*f + 21)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 48*D1**2*f*fd*r**2 - 96*D1**2*f*fd*r*s + 36*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 18*D1**2*f*fd + 60*D1**2*f*fdd*r**2 + 120*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 - 60*D1**2*f*fdd*s + 30*D1**2*f*fdd + 60*D1**2*fd**2*r**2 + 120*D1**2*fd**2*r*s - 60*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 60*D1**2*fd**2*s - 36*D1**2*fd*r**2 - 72*D1**2*fd*r*s - 2*D1**2*fd*r - 36*D1**2*fd*s**2 - 2*D1**2*fd*s + D1**2*fd + 18*D1**2*fdd*r**2 + 36*D1**2*fdd*r*s + 36*D1**2*fdd*r + 18*D1**2*fdd*s**2 + 36*D1**2*fdd*s - 18*D1**2*fdd + 112*D1**2*gd2*r**2 + 224*D1**2*gd2*r*s - 224*D1**2*gd2*r + 112*D1**2*gd2*s**2 - 224*D1**2*gd2*s + 112*D1**2*gd2 - 56*D1**2*gdd2*r**2 - 112*D1**2*gdd2*r*s + 112*D1**2*gdd2*r - 56*D1**2*gdd2*s**2 + 112*D1**2*gdd2*s - 56*D1**2*gdd2 - 192*D1*Dd*K*fd*r - 192*D1*Dd*K*fd*s + 144*D1*Dd*K*fd - 96*D1*Dd*f**2*r**2 - 192*D1*Dd*f**2*r*s + 144*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 144*D1*Dd*f**2*s - 72*D1*Dd*f**2 + 480*D1*Dd*f*fd*r**2 + 960*D1*Dd*f*fd*r*s - 600*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 600*D1*Dd*f*fd*s + 180*D1*Dd*f*fd - 144*D1*Dd*f*r**2 - 288*D1*Dd*f*r*s + 216*D1*Dd*f*r - 144*D1*Dd*f*s**2 + 216*D1*Dd*f*s - 108*D1*Dd*f + 144*D1*Dd*fd*r**2 + 288*D1*Dd*fd*r*s + 36*D1*Dd*fd*r + 144*D1*Dd*fd*s**2 + 36*D1*Dd*fd*s - 108*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 896*D1*Dd*g2*r*s - 672*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 672*D1*Dd*g2*s + 336*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 896*D1*Dd*gd2*r*s + 784*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 784*D1*Dd*gd2*s - 336*D1*Dd*gd2 + 120*D1*Ddd*f**2*r**2 + 240*D1*Ddd*f**2*r*s - 180*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 180*D1*Ddd*f**2*s + 90*D1*Ddd*f**2 + 72*D1*Ddd*f*r**2 + 144*D1*Ddd*f*r*s - 108*D1*Ddd*f*r + 72*D1*Ddd*f*s**2 - 108*D1*Ddd*f*s + 54*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 448*D1*Ddd*g2*r*s + 336*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 336*D1*Ddd*g2*s - 168*D1*Ddd*g2 + 2*D1*bd1*(D1*(11*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (28*K - 21)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-28*K + 18*f + 21)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 360*Dd**2*f**2*r**2 + 720*Dd**2*f**2*r*s - 540*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 540*Dd**2*f**2*s + 180*Dd**2*f**2 + 216*Dd**2*f*r**2 + 432*Dd**2*f*r*s - 324*Dd**2*f*r + 216*Dd**2*f*s**2 - 324*Dd**2*f*s + 108*Dd**2*f - 672*Dd**2*g2*r**2 - 1344*Dd**2*g2*r*s + 1008*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 1008*Dd**2*g2*s - 336*Dd**2*g2) + b1*(-528*C*D1**2*f*fd*r - 528*C*D1**2*f*fd*s + 264*C*D1**2*f*fd + 528*D1**2*K*bdd1*f*r + 528*D1**2*K*bdd1*f*s - 264*D1**2*K*bdd1*f + 616*D1**2*K*f*fd*r**2 + 1232*D1**2*K*f*fd*r*s - 616*D1**2*K*f*fd*r + 616*D1**2*K*f*fd*s**2 - 616*D1**2*K*f*fd*s + 308*D1**2*K*f*fd - 440*D1**2*K*f*fdd*r**2 - 880*D1**2*K*f*fdd*r*s + 440*D1**2*K*f*fdd*r - 440*D1**2*K*f*fdd*s**2 + 440*D1**2*K*f*fdd*s - 220*D1**2*K*f*fdd - 440*D1**2*K*fd**2*r**2 - 880*D1**2*K*fd**2*r*s + 440*D1**2*K*fd**2*r - 440*D1**2*K*fd**2*s**2 + 440*D1**2*K*fd**2*s + 374*D1**2*b2*fd*r**2 + 748*D1**2*b2*fd*r*s + 374*D1**2*b2*fd*s**2 - 264*D1**2*b2*fdd*r**2 - 528*D1**2*b2*fdd*r*s - 264*D1**2*b2*fdd*s**2 - 22*D1**2*bd1**2*(-28*K + 18*f + 21)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 660*D1**2*bdd1*f**2*r**2 + 1320*D1**2*bdd1*f**2*r*s - 1320*D1**2*bdd1*f**2*r + 660*D1**2*bdd1*f**2*s**2 - 1320*D1**2*bdd1*f**2*s + 660*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*r**2 + 792*D1**2*bdd1*f*r*s - 1188*D1**2*bdd1*f*r + 396*D1**2*bdd1*f*s**2 - 1188*D1**2*bdd1*f*s + 594*D1**2*bdd1*f - 1232*D1**2*bdd1*g2*r**2 - 2464*D1**2*bdd1*g2*r*s + 1232*D1**2*bdd1*g2*r - 1232*D1**2*bdd1*g2*s**2 + 1232*D1**2*bdd1*g2*s - 616*D1**2*bdd1*g2 - 264*D1**2*bdd2*f*r**2 - 528*D1**2*bdd2*f*r*s + 528*D1**2*bdd2*f*r - 264*D1**2*bdd2*f*s**2 + 528*D1**2*bdd2*f*s - 264*D1**2*bdd2*f - 1200*D1**2*f**2*fd*r**2 - 2400*D1**2*f**2*fd*r*s + 1830*D1**2*f**2*fd*r - 1200*D1**2*f**2*fd*s**2 + 1830*D1**2*f**2*fd*s - 915*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 2520*D1**2*f**2*fdd*r*s - 1960*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1960*D1**2*f**2*fdd*s + 980*D1**2*f**2*fdd + 2520*D1**2*f*fd**2*r**2 + 5040*D1**2*f*fd**2*r*s - 3920*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 3920*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 660*D1**2*f*fd*r**2 - 1320*D1**2*f*fd*r*s + 1056*D1**2*f*fd*r - 660*D1**2*f*fd*s**2 + 1056*D1**2*f*fd*s - 528*D1**2*f*fd + 660*D1**2*f*fdd*r**2 + 1320*D1**2*f*fdd*r*s - 660*D1**2*f*fdd*r + 660*D1**2*f*fdd*s**2 - 660*D1**2*f*fdd*s + 330*D1**2*f*fdd + 660*D1**2*fd**2*r**2 + 1320*D1**2*fd**2*r*s - 660*D1**2*fd**2*r + 660*D1**2*fd**2*s**2 - 660*D1**2*fd**2*s - 1496*D1**2*fd*g2*r - 1496*D1**2*fd*g2*s + 748*D1**2*fd*g2 + 1056*D1**2*fd*gd2*r + 1056*D1**2*fd*gd2*s - 1056*D1**2*fd*gd2 + 1056*D1**2*fdd*g2*r + 1056*D1**2*fdd*g2*s - 528*D1**2*fdd*g2 + 1232*D1*Dd*K*f**2*r**2 + 2464*D1*Dd*K*f**2*r*s - 1848*D1*Dd*K*f**2*r + 1232*D1*Dd*K*f**2*s**2 - 1848*D1*Dd*K*f**2*s + 924*D1*Dd*K*f**2 - 3520*D1*Dd*K*f*fd*r**2 - 7040*D1*Dd*K*f*fd*r*s + 4400*D1*Dd*K*f*fd*r - 3520*D1*Dd*K*f*fd*s**2 + 4400*D1*Dd*K*f*fd*s - 1320*D1*Dd*K*f*fd + 1496*D1*Dd*b2*f*r**2 + 2992*D1*Dd*b2*f*r*s - 2244*D1*Dd*b2*f*r + 1496*D1*Dd*b2*f*s**2 - 2244*D1*Dd*b2*f*s + 1122*D1*Dd*b2*f - 2112*D1*Dd*b2*fd*r**2 - 4224*D1*Dd*b2*fd*r*s + 1584*D1*Dd*b2*fd*r - 2112*D1*Dd*b2*fd*s**2 + 1584*D1*Dd*b2*fd*s - 1600*D1*Dd*f**3*r**2 - 3200*D1*Dd*f**3*r*s + 2400*D1*Dd*f**3*r - 1600*D1*Dd*f**3*s**2 + 2400*D1*Dd*f**3*s - 1200*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 20160*D1*Dd*f**2*fd*r*s - 15400*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 15400*D1*Dd*f**2*fd*s + 5880*D1*Dd*f**2*fd - 1320*D1*Dd*f**2*r**2 - 2640*D1*Dd*f**2*r*s + 1980*D1*Dd*f**2*r - 1320*D1*Dd*f**2*s**2 + 1980*D1*Dd*f**2*s - 990*D1*Dd*f**2 + 5280*D1*Dd*f*fd*r**2 + 10560*D1*Dd*f*fd*r*s - 6600*D1*Dd*f*fd*r + 5280*D1*Dd*f*fd*s**2 - 6600*D1*Dd*f*fd*s + 1980*D1*Dd*f*fd + 4224*D1*Dd*fd*g2*r + 4224*D1*Dd*fd*g2*s - 3168*D1*Dd*fd*g2 - 880*D1*Ddd*K*f**2*r**2 - 1760*D1*Ddd*K*f**2*r*s + 1320*D1*Ddd*K*f**2*r - 880*D1*Ddd*K*f**2*s**2 + 1320*D1*Ddd*K*f**2*s - 660*D1*Ddd*K*f**2 - 1056*D1*Ddd*b2*f*r**2 - 2112*D1*Ddd*b2*f*r*s + 1584*D1*Ddd*b2*f*r - 1056*D1*Ddd*b2*f*s**2 + 1584*D1*Ddd*b2*f*s - 792*D1*Ddd*b2*f + 1680*D1*Ddd*f**3*r**2 + 3360*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 2520*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*r**2 + 2640*D1*Ddd*f**2*r*s - 1980*D1*Ddd*f**2*r + 1320*D1*Ddd*f**2*s**2 - 1980*D1*Ddd*f**2*s + 990*D1*Ddd*f**2 - 11*D1*bd1*(D1*(6*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + f*(-28*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 68*K*r + 68*K*s - 34*K - 120*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 72*r**2 + 144*r*s - 146*r + 72*s**2 - 146*s + 73) + 12*fd*(r + s - 1)*(4*K - 6*r - 6*s - 3) - 112*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 112*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 4*Dd*(4*r + 4*s - 3)*(30*f**2*(r + s - 1) + 3*f*(4*K + 6*r + 6*s - 9) - 28*g2*(2*r + 2*s - 1))) + 22*D1*bd2*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) - 2640*Dd**2*K*f**2*r**2 - 5280*Dd**2*K*f**2*r*s + 3960*Dd**2*K*f**2*r - 2640*Dd**2*K*f**2*s**2 + 3960*Dd**2*K*f**2*s - 1320*Dd**2*K*f**2 - 3168*Dd**2*b2*f*r**2 - 6336*Dd**2*b2*f*r*s + 4752*Dd**2*b2*f*r - 3168*Dd**2*b2*f*s**2 + 4752*Dd**2*b2*f*s - 1584*Dd**2*b2*f + 5040*Dd**2*f**3*r**2 + 10080*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 7560*Dd**2*f**3*s + 2520*Dd**2*f**3 + 3960*Dd**2*f**2*r**2 + 7920*Dd**2*f**2*r*s - 5940*Dd**2*f**2*r + 3960*Dd**2*f**2*s**2 - 5940*Dd**2*f**2*s + 1980*Dd**2*f**2) + 22*b2*(-12*D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*(-f*(7*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bd1*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) - 2*D1*f*(Dd*(-7*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**3*k1*k2*(4*C - 3)*(-D1*f*(r + s)*(12*D1*bd1**2*(r + s - 1) + 5*D1*bdd1*f*(r + s) + bd1*(-4*D1*f*(r + s) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-6*D1**2*bdd1*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 16*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 8*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 20*D1**2*f*fdd*s - 10*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 20*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 20*D1**2*fd**2*s - 10*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 140*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 140*D1*Dd*f*fd*s - 60*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 12*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2))/(21*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct**3*k2**5*st**2*(D1*f*(66*D1*bd1**2*(r + s - 1)*(5*f*(2*r + 2*s - 1) + 3*r + 3*s - 3) + bd1*(D1*(-250*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(r + s - 1)*(500*fd*(3*r + 3*s - 1) - 99*r - 99*s + 99) + 198*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(4*r + 4*s - 3)*(125*f*(2*r + 2*s - 1) + 99*r + 99*s - 99)) + f*(D1*bdd1*(125*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 99*(r + s - 1)**2) + 99*D1*fd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 99*Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 33*b1**2*(D1**2*(5*f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 6*fd*(r + s)**2 - 3*fdd*(r + s)**2) + D1*(2*Dd*(10*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-5*fd*(4*r + 4*s - 3)**2 + 12*r**2 + 24*r*s - 18*r + 12*s**2 - 18*s + 9) - 3*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(10*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(10*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(33*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 6*(r + s - 1)**2) - 1500*D1**2*f**2*fd*r**2 - 3000*D1**2*f**2*fd*r*s + 2500*D1**2*f**2*fd*r - 1500*D1**2*f**2*fd*s**2 + 2500*D1**2*f**2*fd*s - 1250*D1**2*f**2*fd + 750*D1**2*f**2*fdd*r**2 + 1500*D1**2*f**2*fdd*r*s - 1250*D1**2*f**2*fdd*r + 750*D1**2*f**2*fdd*s**2 - 1250*D1**2*f**2*fdd*s + 625*D1**2*f**2*fdd + 1500*D1**2*f*fd**2*r**2 + 3000*D1**2*f*fd**2*r*s - 2500*D1**2*f*fd**2*r + 1500*D1**2*f*fd**2*s**2 - 2500*D1**2*f*fd**2*s + 1000*D1**2*f*fd**2 - 198*D1**2*f*fd*r**2 - 396*D1**2*f*fd*r*s + 198*D1**2*f*fd*r - 198*D1**2*f*fd*s**2 + 198*D1**2*f*fd*s - 99*D1**2*f*fd + 198*D1**2*f*fdd*r**2 + 396*D1**2*f*fdd*r*s - 198*D1**2*f*fdd*r + 198*D1**2*f*fdd*s**2 - 198*D1**2*f*fdd*s + 99*D1**2*f*fdd + 198*D1**2*fd**2*r**2 + 396*D1**2*fd**2*r*s - 198*D1**2*fd**2*r + 198*D1**2*fd**2*s**2 - 198*D1**2*fd**2*s - 2000*D1*Dd*f**3*r**2 - 4000*D1*Dd*f**3*r*s + 3000*D1*Dd*f**3*r - 2000*D1*Dd*f**3*s**2 + 3000*D1*Dd*f**3*s - 1500*D1*Dd*f**3 + 6000*D1*Dd*f**2*fd*r**2 + 12000*D1*Dd*f**2*fd*r*s - 9500*D1*Dd*f**2*fd*r + 6000*D1*Dd*f**2*fd*s**2 - 9500*D1*Dd*f**2*fd*s + 3750*D1*Dd*f**2*fd - 396*D1*Dd*f**2*r**2 - 792*D1*Dd*f**2*r*s + 594*D1*Dd*f**2*r - 396*D1*Dd*f**2*s**2 + 594*D1*Dd*f**2*s - 297*D1*Dd*f**2 + 1584*D1*Dd*f*fd*r**2 + 3168*D1*Dd*f*fd*r*s - 1980*D1*Dd*f*fd*r + 1584*D1*Dd*f*fd*s**2 - 1980*D1*Dd*f*fd*s + 594*D1*Dd*f*fd + 1000*D1*Ddd*f**3*r**2 + 2000*D1*Ddd*f**3*r*s - 1500*D1*Ddd*f**3*r + 1000*D1*Ddd*f**3*s**2 - 1500*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 + 396*D1*Ddd*f**2*r**2 + 792*D1*Ddd*f**2*r*s - 594*D1*Ddd*f**2*r + 396*D1*Ddd*f**2*s**2 - 594*D1*Ddd*f**2*s + 297*D1*Ddd*f**2 - 66*D1*bd1*(D1*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(r + s - 1)*(10*fd*(2*r + 2*s - 1) - 3*r - 3*s + 3) - 6*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 6*r + 6*s - 6)) + 3000*Dd**2*f**3*r**2 + 6000*Dd**2*f**3*r*s - 4500*Dd**2*f**3*r + 3000*Dd**2*f**3*s**2 - 4500*Dd**2*f**3*s + 1500*Dd**2*f**3 + 1188*Dd**2*f**2*r**2 + 2376*Dd**2*f**2*r*s - 1782*Dd**2*f**2*r + 1188*Dd**2*f**2*s**2 - 1782*Dd**2*f**2*s + 594*Dd**2*f**2))/(693*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct**3*k2**3*st**2*(D1*f*(r + s)*(2*D1*bd1**2*(r + s - 1) + D1*bdd1*f*(r + s) + bd1*(-2*D1*f*(r + s) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3))) + b1**2*(-D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(-2*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*Dd*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*bdd1*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 4*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 4*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 4*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 4*D1**2*f*fdd*s + 2*D1**2*f*fdd + 2*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 4*D1**2*fd**2*s + 2*D1**2*fd**2 - 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 32*D1*Dd*f*fd*r*s - 28*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 28*D1*Dd*f*fd*s + 12*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 2*D1*bd1*(D1*(-f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 12*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 18*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s + 6*Dd**2*f**2))/(7*d**2*k1*k3**2) + D1**2*Pk1*Pkdd3*ct**3*k2**3*(2*D1**2*bd1*f*(r + s)*(bd1*(5*f + 6)*(r + s - 1) + 3*f*(r + s)) + D1*b1*(2*D1*bd1**2*(6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + bd1*(D1*(-10*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*f*(4*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 2*r**2 - 4*r*s + 2*r - 2*s**2 + 2*s - 1) + 12*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(5*f + 6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + f*(D1*bdd1*(5*f + 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 12*D1*fd*(r + s - 1)**2 + 6*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**3*(-6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(-2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) + Ddd*(6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*bdd1*(6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 20*D1**2*f*fd*r**2 - 40*D1**2*f*fd*r*s + 40*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 40*D1**2*f*fd*s - 20*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 10*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 20*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s + 10*D1**2*fd**2 - 5*D1**2*fd*r**2 - 10*D1**2*fd*r*s + 10*D1**2*fd*r - 5*D1**2*fd*s**2 + 10*D1**2*fd*s - 5*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r + 6*D1**2*fdd*s**2 - 12*D1**2*fdd*s + 6*D1**2*fdd - 40*D1*Dd*f**2*r**2 - 80*D1*Dd*f**2*r*s + 60*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 60*D1*Dd*f**2*s - 30*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 140*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 140*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 20*D1*Dd*f*r**2 - 40*D1*Dd*f*r*s + 30*D1*Dd*f*r - 20*D1*Dd*f*s**2 + 30*D1*Dd*f*s - 15*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 84*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 84*D1*Dd*fd*s + 36*D1*Dd*fd + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f - 2*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 21*r**2 + 42*r*s - 28*r + 21*s**2 - 28*s + 14) - Dd*(6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f))/(21*d**2*k1*k3**2) + D1**2*Pk1*Pkdd3*ct**2*f*k1**2*k2**4*st**4*(-66*D1**2*bd1*f*(5*C - 4)*(r + s - 1)**2 - 66*D1*b1*(5*C - 4)*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - (122*C - 87)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**2*k1**6*(2*C - 1)*(264*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r + 264*D1**2*b1*f*fd*s**2 - 264*D1**2*b1*f*fd*s + 132*D1**2*b1*f*fd - 330*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 330*D1**2*b1*f*fdd*s**2 + 330*D1**2*b1*f*fdd*s - 165*D1**2*b1*f*fdd - 330*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r - 330*D1**2*b1*fd**2*s**2 + 330*D1**2*b1*fd**2*s - 165*D1**2*bdd1*f**2*(r + s - 1)**2 + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 792*D1*Dd*b1*f**2*r + 528*D1*Dd*b1*f**2*s**2 - 792*D1*Dd*b1*f**2*s + 396*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 3300*D1*Dd*b1*f*fd*r - 2640*D1*Dd*b1*f*fd*s**2 + 3300*D1*Dd*b1*f*fd*s - 990*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 690*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 690*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 990*D1*Ddd*b1*f**2*r - 660*D1*Ddd*b1*f**2*s**2 + 990*D1*Ddd*b1*f**2*s - 495*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 + 66*D1*bd1*f*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 1980*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 2970*Dd**2*b1*f**2*r - 1980*Dd**2*b1*f**2*s**2 + 2970*Dd**2*b1*f**2*s - 990*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3)/(693*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**2*k1**4*k2**2*st**2*(-5742*C*D1**2*b1*f*fd*r**2 - 11484*C*D1**2*b1*f*fd*r*s + 5742*C*D1**2*b1*f*fd*r - 5742*C*D1**2*b1*f*fd*s**2 + 5742*C*D1**2*b1*f*fd*s - 2871*C*D1**2*b1*f*fd + 4026*C*D1**2*b1*f*fdd*r**2 + 8052*C*D1**2*b1*f*fdd*r*s - 4026*C*D1**2*b1*f*fdd*r + 4026*C*D1**2*b1*f*fdd*s**2 - 4026*C*D1**2*b1*f*fdd*s + 2013*C*D1**2*b1*f*fdd + 4026*C*D1**2*b1*fd**2*r**2 + 8052*C*D1**2*b1*fd**2*r*s - 4026*C*D1**2*b1*fd**2*r + 4026*C*D1**2*b1*fd**2*s**2 - 4026*C*D1**2*b1*fd**2*s - 5685*C*D1**2*f**2*fd*r**2 - 11370*C*D1**2*f**2*fd*r*s + 7580*C*D1**2*f**2*fd*r - 5685*C*D1**2*f**2*fd*s**2 + 7580*C*D1**2*f**2*fd*s - 3790*C*D1**2*f**2*fd + 4575*C*D1**2*f**2*fdd*r**2 + 9150*C*D1**2*f**2*fdd*r*s - 6100*C*D1**2*f**2*fdd*r + 4575*C*D1**2*f**2*fdd*s**2 - 6100*C*D1**2*f**2*fdd*s + 3050*C*D1**2*f**2*fdd + 9150*C*D1**2*f*fd**2*r**2 + 18300*C*D1**2*f*fd**2*r*s - 12200*C*D1**2*f*fd**2*r + 9150*C*D1**2*f*fd**2*s**2 - 12200*C*D1**2*f*fd**2*s + 3050*C*D1**2*f*fd**2 - 11484*C*D1*Dd*b1*f**2*r**2 - 22968*C*D1*Dd*b1*f**2*r*s + 17226*C*D1*Dd*b1*f**2*r - 11484*C*D1*Dd*b1*f**2*s**2 + 17226*C*D1*Dd*b1*f**2*s - 8613*C*D1*Dd*b1*f**2 + 32208*C*D1*Dd*b1*f*fd*r**2 + 64416*C*D1*Dd*b1*f*fd*r*s - 40260*C*D1*Dd*b1*f*fd*r + 32208*C*D1*Dd*b1*f*fd*s**2 - 40260*C*D1*Dd*b1*f*fd*s + 12078*C*D1*Dd*b1*f*fd - 7580*C*D1*Dd*f**3*r**2 - 15160*C*D1*Dd*f**3*r*s + 11370*C*D1*Dd*f**3*r - 7580*C*D1*Dd*f**3*s**2 + 11370*C*D1*Dd*f**3*s - 5685*C*D1*Dd*f**3 + 36600*C*D1*Dd*f**2*fd*r**2 + 73200*C*D1*Dd*f**2*fd*r*s - 51850*C*D1*Dd*f**2*fd*r + 36600*C*D1*Dd*f**2*fd*s**2 - 51850*C*D1*Dd*f**2*fd*s + 18300*C*D1*Dd*f**2*fd + 8052*C*D1*Ddd*b1*f**2*r**2 + 16104*C*D1*Ddd*b1*f**2*r*s - 12078*C*D1*Ddd*b1*f**2*r + 8052*C*D1*Ddd*b1*f**2*s**2 - 12078*C*D1*Ddd*b1*f**2*s + 6039*C*D1*Ddd*b1*f**2 + 6100*C*D1*Ddd*f**3*r**2 + 12200*C*D1*Ddd*f**3*r*s - 9150*C*D1*Ddd*f**3*r + 6100*C*D1*Ddd*f**3*s**2 - 9150*C*D1*Ddd*f**3*s + 4575*C*D1*Ddd*f**3 + 24156*C*Dd**2*b1*f**2*r**2 + 48312*C*Dd**2*b1*f**2*r*s - 36234*C*Dd**2*b1*f**2*r + 24156*C*Dd**2*b1*f**2*s**2 - 36234*C*Dd**2*b1*f**2*s + 12078*C*Dd**2*b1*f**2 + 18300*C*Dd**2*f**3*r**2 + 36600*C*Dd**2*f**3*r*s - 27450*C*Dd**2*f**3*r + 18300*C*Dd**2*f**3*s**2 - 27450*C*Dd**2*f**3*s + 9150*C*Dd**2*f**3 + 3432*D1**2*b1*f*fd*r**2 + 6864*D1**2*b1*f*fd*r*s - 3432*D1**2*b1*f*fd*r + 3432*D1**2*b1*f*fd*s**2 - 3432*D1**2*b1*f*fd*s + 1716*D1**2*b1*f*fd - 2442*D1**2*b1*f*fdd*r**2 - 4884*D1**2*b1*f*fdd*r*s + 2442*D1**2*b1*f*fdd*r - 2442*D1**2*b1*f*fdd*s**2 + 2442*D1**2*b1*f*fdd*s - 1221*D1**2*b1*f*fdd - 2442*D1**2*b1*fd**2*r**2 - 4884*D1**2*b1*fd**2*r*s + 2442*D1**2*b1*fd**2*r - 2442*D1**2*b1*fd**2*s**2 + 2442*D1**2*b1*fd**2*s + 33*D1**2*bdd1*f**2*(61*C - 37)*(r + s - 1)**2 + 3372*D1**2*f**2*fd*r**2 + 6744*D1**2*f**2*fd*r*s - 4496*D1**2*f**2*fd*r + 3372*D1**2*f**2*fd*s**2 - 4496*D1**2*f**2*fd*s + 2248*D1**2*f**2*fd - 2775*D1**2*f**2*fdd*r**2 - 5550*D1**2*f**2*fdd*r*s + 3700*D1**2*f**2*fdd*r - 2775*D1**2*f**2*fdd*s**2 + 3700*D1**2*f**2*fdd*s - 1850*D1**2*f**2*fdd - 5550*D1**2*f*fd**2*r**2 - 11100*D1**2*f*fd**2*r*s + 7400*D1**2*f*fd**2*r - 5550*D1**2*f*fd**2*s**2 + 7400*D1**2*f*fd**2*s - 1850*D1**2*f*fd**2 + 6864*D1*Dd*b1*f**2*r**2 + 13728*D1*Dd*b1*f**2*r*s - 10296*D1*Dd*b1*f**2*r + 6864*D1*Dd*b1*f**2*s**2 - 10296*D1*Dd*b1*f**2*s + 5148*D1*Dd*b1*f**2 - 19536*D1*Dd*b1*f*fd*r**2 - 39072*D1*Dd*b1*f*fd*r*s + 24420*D1*Dd*b1*f*fd*r - 19536*D1*Dd*b1*f*fd*s**2 + 24420*D1*Dd*b1*f*fd*s - 7326*D1*Dd*b1*f*fd + 4496*D1*Dd*f**3*r**2 + 8992*D1*Dd*f**3*r*s - 6744*D1*Dd*f**3*r + 4496*D1*Dd*f**3*s**2 - 6744*D1*Dd*f**3*s + 3372*D1*Dd*f**3 - 22200*D1*Dd*f**2*fd*r**2 - 44400*D1*Dd*f**2*fd*r*s + 31450*D1*Dd*f**2*fd*r - 22200*D1*Dd*f**2*fd*s**2 + 31450*D1*Dd*f**2*fd*s - 11100*D1*Dd*f**2*fd - 4884*D1*Ddd*b1*f**2*r**2 - 9768*D1*Ddd*b1*f**2*r*s + 7326*D1*Ddd*b1*f**2*r - 4884*D1*Ddd*b1*f**2*s**2 + 7326*D1*Ddd*b1*f**2*s - 3663*D1*Ddd*b1*f**2 - 3700*D1*Ddd*f**3*r**2 - 7400*D1*Ddd*f**3*r*s + 5550*D1*Ddd*f**3*r - 3700*D1*Ddd*f**3*s**2 + 5550*D1*Ddd*f**3*s - 2775*D1*Ddd*f**3 - 33*D1*bd1*f*(r + s - 1)*(D1*f*(87*C - 52)*(r + s - 1) - D1*fd*(122*C - 74)*(2*r + 2*s - 1) - Dd*f*(122*C - 74)*(4*r + 4*s - 3)) - 14652*Dd**2*b1*f**2*r**2 - 29304*Dd**2*b1*f**2*r*s + 21978*Dd**2*b1*f**2*r - 14652*Dd**2*b1*f**2*s**2 + 21978*Dd**2*b1*f**2*s - 7326*Dd**2*b1*f**2 - 11100*Dd**2*f**3*r**2 - 22200*Dd**2*f**3*r*s + 16650*Dd**2*f**3*r - 11100*Dd**2*f**3*s**2 + 16650*Dd**2*f**3*s - 5550*Dd**2*f**3)/(693*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**2*k1**4*k2**2*(-12870*C*D1**2*f**2*fd*r**2 - 25740*C*D1**2*f**2*fd*r*s + 17160*C*D1**2*f**2*fd*r - 12870*C*D1**2*f**2*fd*s**2 + 17160*C*D1**2*f**2*fd*s - 8580*C*D1**2*f**2*fd - 17160*C*D1*Dd*f**3*r**2 - 34320*C*D1*Dd*f**3*r*s + 25740*C*D1*Dd*f**3*r - 17160*C*D1*Dd*f**3*s**2 + 25740*C*D1*Dd*f**3*s - 12870*C*D1*Dd*f**3 - 32175*D1**2*K*bdd1*f**2*r**2 - 64350*D1**2*K*bdd1*f**2*r*s + 64350*D1**2*K*bdd1*f**2*r - 32175*D1**2*K*bdd1*f**2*s**2 + 64350*D1**2*K*bdd1*f**2*s - 32175*D1**2*K*bdd1*f**2 + 4290*D1**2*bd1**2*f*(-18*K + 5*f + 6)*(r + s - 1)**2 + 7280*D1**2*bdd1*f**3*r**2 + 14560*D1**2*bdd1*f**3*r*s - 14560*D1**2*bdd1*f**3*r + 7280*D1**2*bdd1*f**3*s**2 - 14560*D1**2*bdd1*f**3*s + 7280*D1**2*bdd1*f**3 + 10725*D1**2*bdd1*f**2*r**2 + 21450*D1**2*bdd1*f**2*r*s - 21450*D1**2*bdd1*f**2*r + 10725*D1**2*bdd1*f**2*s**2 - 21450*D1**2*bdd1*f**2*s + 10725*D1**2*bdd1*f**2 + 77220*D1**2*bdd1*f*g2*r**2 + 154440*D1**2*bdd1*f*g2*r*s - 154440*D1**2*bdd1*f*g2*r + 77220*D1**2*bdd1*f*g2*s**2 - 154440*D1**2*bdd1*f*g2*s + 77220*D1**2*bdd1*f*g2 + 5320*D1**2*f**3*fd*r**2 + 10640*D1**2*f**3*fd*r*s - 7980*D1**2*f**3*fd*r + 5320*D1**2*f**3*fd*s**2 - 7980*D1**2*f**3*fd*s + 3990*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 + 6435*D1**2*f**2*fd*r**2 + 12870*D1**2*f**2*fd*r*s - 8580*D1**2*f**2*fd*r + 6435*D1**2*f**2*fd*s**2 - 8580*D1**2*f**2*fd*s + 4290*D1**2*f**2*fd - 56628*D1**2*f**2*gd2*r**2 - 113256*D1**2*f**2*gd2*r*s + 113256*D1**2*f**2*gd2*r - 56628*D1**2*f**2*gd2*s**2 + 113256*D1**2*f**2*gd2*s - 56628*D1**2*f**2*gd2 + 64350*D1**2*f**2*gdd2*r**2 + 128700*D1**2*f**2*gdd2*r*s - 128700*D1**2*f**2*gdd2*r + 64350*D1**2*f**2*gdd2*s**2 - 128700*D1**2*f**2*gdd2*s + 64350*D1**2*f**2*gdd2 - 113256*D1**2*f*fd*g2*r**2 - 226512*D1**2*f*fd*g2*r*s + 113256*D1**2*f*fd*g2*r - 113256*D1**2*f*fd*g2*s**2 + 113256*D1**2*f*fd*g2*s - 56628*D1**2*f*fd*g2 + 257400*D1**2*f*fd*gd2*r**2 + 514800*D1**2*f*fd*gd2*r*s - 386100*D1**2*f*fd*gd2*r + 257400*D1**2*f*fd*gd2*s**2 - 386100*D1**2*f*fd*gd2*s + 128700*D1**2*f*fd*gd2 + 128700*D1**2*f*fdd*g2*r**2 + 257400*D1**2*f*fdd*g2*r*s - 128700*D1**2*f*fdd*g2*r + 128700*D1**2*f*fdd*g2*s**2 - 128700*D1**2*f*fdd*g2*s + 64350*D1**2*f*fdd*g2 + 128700*D1**2*fd**2*g2*r**2 + 257400*D1**2*fd**2*g2*r*s - 128700*D1**2*fd**2*g2*r + 128700*D1**2*fd**2*g2*s**2 - 128700*D1**2*fd**2*g2*s + 5320*D1*Dd*f**4*r**2 + 10640*D1*Dd*f**4*r*s - 7980*D1*Dd*f**4*r + 5320*D1*Dd*f**4*s**2 - 7980*D1*Dd*f**4*s + 3990*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd + 8580*D1*Dd*f**3*r**2 + 17160*D1*Dd*f**3*r*s - 12870*D1*Dd*f**3*r + 8580*D1*Dd*f**3*s**2 - 12870*D1*Dd*f**3*s + 6435*D1*Dd*f**3 - 226512*D1*Dd*f**2*g2*r**2 - 453024*D1*Dd*f**2*g2*r*s + 339768*D1*Dd*f**2*g2*r - 226512*D1*Dd*f**2*g2*s**2 + 339768*D1*Dd*f**2*g2*s - 169884*D1*Dd*f**2*g2 + 514800*D1*Dd*f**2*gd2*r**2 + 1029600*D1*Dd*f**2*gd2*r*s - 900900*D1*Dd*f**2*gd2*r + 514800*D1*Dd*f**2*gd2*s**2 - 900900*D1*Dd*f**2*gd2*s + 386100*D1*Dd*f**2*gd2 + 1029600*D1*Dd*f*fd*g2*r**2 + 2059200*D1*Dd*f*fd*g2*r*s - 1287000*D1*Dd*f*fd*g2*r + 1029600*D1*Dd*f*fd*g2*s**2 - 1287000*D1*Dd*f*fd*g2*s + 386100*D1*Dd*f*fd*g2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 257400*D1*Ddd*f**2*g2*r**2 + 514800*D1*Ddd*f**2*g2*r*s - 386100*D1*Ddd*f**2*g2*r + 257400*D1*Ddd*f**2*g2*s**2 - 386100*D1*Ddd*f**2*g2*s + 193050*D1*Ddd*f**2*g2 - 26*D1*bd1*(D1*(230*f**3*(r + s - 1) + f**2*(198*C*(r + s - 1) - 560*fd*(3*r + 3*s - 2) - (1089*K - 231)*(r + s - 1)) + 33*f*(25*fd*(3*K - 1)*(2*r + 2*s - 1) + (82*g2 - 180*gd2)*(r + s - 1)) - 5940*fd*g2*(r + s)) - 5*Dd*f*(112*f**2 - 165*f*(3*K - 1) + 1188*g2)*(4*r + 4*s - 3))*(r + s - 1) - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 772200*Dd**2*f**2*g2*r**2 + 1544400*Dd**2*f**2*g2*r*s - 1158300*Dd**2*f**2*g2*r + 772200*Dd**2*f**2*g2*s**2 - 1158300*Dd**2*f**2*g2*s + 386100*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(5*f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + fd*(82*K - 25)*(r + s) - 30*fdd*(3*K - 1)*(r + s))) + D1*(Dd*(20*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(50*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (82*K - 25)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*fd*(3*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 5*Ddd*f*(-18*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f*(-18*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 13*b1*(792*C*D1**2*f*fd*r**2 + 1584*C*D1**2*f*fd*r*s - 792*C*D1**2*f*fd*r + 792*C*D1**2*f*fd*s**2 - 792*C*D1**2*f*fd*s + 396*C*D1**2*f*fd + 1584*C*D1*Dd*f**2*r**2 + 3168*C*D1*Dd*f**2*r*s - 2376*C*D1*Dd*f**2*r + 1584*C*D1*Dd*f**2*s**2 - 2376*C*D1*Dd*f**2*s + 1188*C*D1*Dd*f**2 - 4356*D1**2*K*f*fd*r**2 - 8712*D1**2*K*f*fd*r*s + 4356*D1**2*K*f*fd*r - 4356*D1**2*K*f*fd*s**2 + 4356*D1**2*K*f*fd*s - 2178*D1**2*K*f*fd + 4950*D1**2*K*f*fdd*r**2 + 9900*D1**2*K*f*fdd*r*s - 4950*D1**2*K*f*fdd*r + 4950*D1**2*K*f*fdd*s**2 - 4950*D1**2*K*f*fdd*s + 2475*D1**2*K*f*fdd + 4950*D1**2*K*fd**2*r**2 + 9900*D1**2*K*fd**2*r*s - 4950*D1**2*K*fd**2*r + 4950*D1**2*K*fd**2*s**2 - 4950*D1**2*K*fd**2*s - 330*D1**2*bdd1*f*(-18*K + 5*f + 6)*(r + s - 1)**2 + 1380*D1**2*f**2*fd*r**2 + 2760*D1**2*f**2*fd*r*s - 1840*D1**2*f**2*fd*r + 1380*D1**2*f**2*fd*s**2 - 1840*D1**2*f**2*fd*s + 920*D1**2*f**2*fd - 1680*D1**2*f**2*fdd*r**2 - 3360*D1**2*f**2*fdd*r*s + 2240*D1**2*f**2*fdd*r - 1680*D1**2*f**2*fdd*s**2 + 2240*D1**2*f**2*fdd*s - 1120*D1**2*f**2*fdd - 3360*D1**2*f*fd**2*r**2 - 6720*D1**2*f*fd**2*r*s + 4480*D1**2*f*fd**2*r - 3360*D1**2*f*fd**2*s**2 + 4480*D1**2*f*fd**2*s - 1120*D1**2*f*fd**2 + 924*D1**2*f*fd*r**2 + 1848*D1**2*f*fd*r*s - 924*D1**2*f*fd*r + 924*D1**2*f*fd*s**2 - 924*D1**2*f*fd*s + 462*D1**2*f*fd - 1650*D1**2*f*fdd*r**2 - 3300*D1**2*f*fdd*r*s + 1650*D1**2*f*fdd*r - 1650*D1**2*f*fdd*s**2 + 1650*D1**2*f*fdd*s - 825*D1**2*f*fdd + 5412*D1**2*f*gd2*r**2 + 10824*D1**2*f*gd2*r*s - 10824*D1**2*f*gd2*r + 5412*D1**2*f*gd2*s**2 - 10824*D1**2*f*gd2*s + 5412*D1**2*f*gd2 - 5940*D1**2*f*gdd2*r**2 - 11880*D1**2*f*gdd2*r*s + 11880*D1**2*f*gdd2*r - 5940*D1**2*f*gdd2*s**2 + 11880*D1**2*f*gdd2*s - 5940*D1**2*f*gdd2 - 1650*D1**2*fd**2*r**2 - 3300*D1**2*fd**2*r*s + 1650*D1**2*fd**2*r - 1650*D1**2*fd**2*s**2 + 1650*D1**2*fd**2*s + 5412*D1**2*fd*g2*r**2 + 10824*D1**2*fd*g2*r*s + 5412*D1**2*fd*g2*s**2 - 11880*D1**2*fd*gd2*r**2 - 23760*D1**2*fd*gd2*r*s + 11880*D1**2*fd*gd2*r - 11880*D1**2*fd*gd2*s**2 + 11880*D1**2*fd*gd2*s - 5940*D1**2*fdd*g2*r**2 - 11880*D1**2*fdd*g2*r*s - 5940*D1**2*fdd*g2*s**2 - 8712*D1*Dd*K*f**2*r**2 - 17424*D1*Dd*K*f**2*r*s + 13068*D1*Dd*K*f**2*r - 8712*D1*Dd*K*f**2*s**2 + 13068*D1*Dd*K*f**2*s - 6534*D1*Dd*K*f**2 + 39600*D1*Dd*K*f*fd*r**2 + 79200*D1*Dd*K*f*fd*r*s - 49500*D1*Dd*K*f*fd*r + 39600*D1*Dd*K*f*fd*s**2 - 49500*D1*Dd*K*f*fd*s + 14850*D1*Dd*K*f*fd + 1840*D1*Dd*f**3*r**2 + 3680*D1*Dd*f**3*r*s - 2760*D1*Dd*f**3*r + 1840*D1*Dd*f**3*s**2 - 2760*D1*Dd*f**3*s + 1380*D1*Dd*f**3 - 13440*D1*Dd*f**2*fd*r**2 - 26880*D1*Dd*f**2*fd*r*s + 19040*D1*Dd*f**2*fd*r - 13440*D1*Dd*f**2*fd*s**2 + 19040*D1*Dd*f**2*fd*s - 6720*D1*Dd*f**2*fd + 1848*D1*Dd*f**2*r**2 + 3696*D1*Dd*f**2*r*s - 2772*D1*Dd*f**2*r + 1848*D1*Dd*f**2*s**2 - 2772*D1*Dd*f**2*s + 1386*D1*Dd*f**2 - 13200*D1*Dd*f*fd*r**2 - 26400*D1*Dd*f*fd*r*s + 16500*D1*Dd*f*fd*r - 13200*D1*Dd*f*fd*s**2 + 16500*D1*Dd*f*fd*s - 4950*D1*Dd*f*fd + 21648*D1*Dd*f*g2*r**2 + 43296*D1*Dd*f*g2*r*s - 32472*D1*Dd*f*g2*r + 21648*D1*Dd*f*g2*s**2 - 32472*D1*Dd*f*g2*s + 16236*D1*Dd*f*g2 - 47520*D1*Dd*f*gd2*r**2 - 95040*D1*Dd*f*gd2*r*s + 83160*D1*Dd*f*gd2*r - 47520*D1*Dd*f*gd2*s**2 + 83160*D1*Dd*f*gd2*s - 35640*D1*Dd*f*gd2 - 47520*D1*Dd*fd*g2*r**2 - 95040*D1*Dd*fd*g2*r*s + 35640*D1*Dd*fd*g2*r - 47520*D1*Dd*fd*g2*s**2 + 35640*D1*Dd*fd*g2*s + 9900*D1*Ddd*K*f**2*r**2 + 19800*D1*Ddd*K*f**2*r*s - 14850*D1*Ddd*K*f**2*r + 9900*D1*Ddd*K*f**2*s**2 - 14850*D1*Ddd*K*f**2*s + 7425*D1*Ddd*K*f**2 - 2240*D1*Ddd*f**3*r**2 - 4480*D1*Ddd*f**3*r*s + 3360*D1*Ddd*f**3*r - 2240*D1*Ddd*f**3*s**2 + 3360*D1*Ddd*f**3*s - 1680*D1*Ddd*f**3 - 3300*D1*Ddd*f**2*r**2 - 6600*D1*Ddd*f**2*r*s + 4950*D1*Ddd*f**2*r - 3300*D1*Ddd*f**2*s**2 + 4950*D1*Ddd*f**2*s - 2475*D1*Ddd*f**2 - 23760*D1*Ddd*f*g2*r**2 - 47520*D1*Ddd*f*g2*r*s + 35640*D1*Ddd*f*g2*r - 23760*D1*Ddd*f*g2*s**2 + 35640*D1*Ddd*f*g2*s - 17820*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(20*f**2*(r + s - 1) - 50*f*fd*(2*r + 2*s - 1) - f*(82*K - 25)*(r + s - 1) + 60*fd*(3*K - 1)*(r + s)) - 10*Dd*f*(-18*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 29700*Dd**2*K*f**2*r**2 + 59400*Dd**2*K*f**2*r*s - 44550*Dd**2*K*f**2*r + 29700*Dd**2*K*f**2*s**2 - 44550*Dd**2*K*f**2*s + 14850*Dd**2*K*f**2 - 6720*Dd**2*f**3*r**2 - 13440*Dd**2*f**3*r*s + 10080*Dd**2*f**3*r - 6720*Dd**2*f**3*s**2 + 10080*Dd**2*f**3*s - 3360*Dd**2*f**3 - 9900*Dd**2*f**2*r**2 - 19800*Dd**2*f**2*r*s + 14850*Dd**2*f**2*r - 9900*Dd**2*f**2*s**2 + 14850*Dd**2*f**2*s - 4950*Dd**2*f**2 - 71280*Dd**2*f*g2*r**2 - 142560*Dd**2*f*g2*r*s + 106920*Dd**2*f*g2*r - 71280*Dd**2*f*g2*s**2 + 106920*Dd**2*f*g2*s - 35640*Dd**2*f*g2))/(9009*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct**2*k1**4*(2*C - 1)*(33*D1*b1*(D1*bd1*(5*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 6*D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 8*D1*f*fd*r - 8*D1*f*fd*s + 4*D1*f*fd + 10*D1*f*fdd*r + 10*D1*f*fdd*s - 5*D1*f*fdd + 10*D1*fd**2*r + 10*D1*fd**2*s - 10*D1*fd**2 - 12*Dd*bd1*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 40*Dd*f*fd*r + 40*Dd*f*fd*s - 30*Dd*f*fd) + 33*b1**2*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(-396*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 165*D1**2*bdd1*f*(2*r + 2*s - 1) - 5*D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 56*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 66*D1*bd1*(D1*f*(4*r + 4*s - 2) - 5*D1*fd*(r + s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 5*D1*f*(Dd*(23*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 56*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 28*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 840*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**2*k1**2*k2**4*st**2*(-1716*D1**2*bd1**2*f*(-6*K + 10*f + 3)*(r + s - 1)**2 - 2574*D1**2*bdd1*f*(r + s - 1)**2*(-2*K*f + f + 4*g2) + 2*D1**2*(-50*f**3*(59*fd - 49*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(14700*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + fd*(2717*C - 1859)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (9581*gd2 - 5148*gdd2)*(r + s - 1)**2) + 143*f*(fd*(67*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 72*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 36*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 10296*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 143*D1*bd1*(D1*(12*f**3*(r + s - 1) + f**2*(38*C - 67*K + 7)*(r + s - 1) + 36*f*fd*(2*K - 1)*(2*r + 2*s - 1) + 2*f*(107*g2 - 72*gd2)*(r + s - 1) - 144*fd*g2*(r + s)) + 36*Dd*f*(f*(2*K - 1) - 4*g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(2950*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(2717*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4900*fd*(4*r + 4*s - 3)**2 - 7436*r**2 - 1859*r*(8*s - 6) - 7436*s**2 + 11154*s - 5577) - 143*f*(67*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 72*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 10296*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2*Ddd*f*(1225*f**2 - 2574*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 24*Dd**2*f**2*(1225*f**2 - 2574*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 143*b1**2*(D1**2*(12*f*(8*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(120*fd**2*(r + s - 1) + fd*(107*K - 57)*(r + s) - 18*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(96*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(120*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (107*K - 57)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 36*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-6*K + 10*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-6*K + 10*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 143*b1*(76*C*D1**2*f*fd*r**2 + 152*C*D1**2*f*fd*r*s - 76*C*D1**2*f*fd*r + 76*C*D1**2*f*fd*s**2 - 76*C*D1**2*f*fd*s + 38*C*D1**2*f*fd + 152*C*D1*Dd*f**2*r**2 + 304*C*D1*Dd*f**2*r*s - 228*C*D1*Dd*f**2*r + 152*C*D1*Dd*f**2*s**2 - 228*C*D1*Dd*f**2*s + 114*C*D1*Dd*f**2 - 134*D1**2*K*f*fd*r**2 - 268*D1**2*K*f*fd*r*s + 134*D1**2*K*f*fd*r - 134*D1**2*K*f*fd*s**2 + 134*D1**2*K*f*fd*s - 67*D1**2*K*f*fd + 72*D1**2*K*f*fdd*r**2 + 144*D1**2*K*f*fdd*r*s - 72*D1**2*K*f*fdd*r + 72*D1**2*K*f*fdd*s**2 - 72*D1**2*K*f*fdd*s + 36*D1**2*K*f*fdd + 72*D1**2*K*fd**2*r**2 + 144*D1**2*K*fd**2*r*s - 72*D1**2*K*fd**2*r + 72*D1**2*K*fd**2*s**2 - 72*D1**2*K*fd**2*s - 12*D1**2*bdd1*f*(-6*K + 10*f + 3)*(r + s - 1)**2 + 36*D1**2*f**2*fd*r**2 + 72*D1**2*f**2*fd*r*s - 48*D1**2*f**2*fd*r + 36*D1**2*f**2*fd*s**2 - 48*D1**2*f**2*fd*s + 24*D1**2*f**2*fd + 14*D1**2*f*fd*r**2 + 28*D1**2*f*fd*r*s - 14*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 - 14*D1**2*f*fd*s + 7*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd + 214*D1**2*f*gd2*r**2 + 428*D1**2*f*gd2*r*s - 428*D1**2*f*gd2*r + 214*D1**2*f*gd2*s**2 - 428*D1**2*f*gd2*s + 214*D1**2*f*gd2 - 72*D1**2*f*gdd2*r**2 - 144*D1**2*f*gdd2*r*s + 144*D1**2*f*gdd2*r - 72*D1**2*f*gdd2*s**2 + 144*D1**2*f*gdd2*s - 72*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 214*D1**2*fd*g2*r**2 + 428*D1**2*fd*g2*r*s + 214*D1**2*fd*g2*s**2 - 144*D1**2*fd*gd2*r**2 - 288*D1**2*fd*gd2*r*s + 144*D1**2*fd*gd2*r - 144*D1**2*fd*gd2*s**2 + 144*D1**2*fd*gd2*s - 72*D1**2*fdd*g2*r**2 - 144*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*s**2 - 268*D1*Dd*K*f**2*r**2 - 536*D1*Dd*K*f**2*r*s + 402*D1*Dd*K*f**2*r - 268*D1*Dd*K*f**2*s**2 + 402*D1*Dd*K*f**2*s - 201*D1*Dd*K*f**2 + 576*D1*Dd*K*f*fd*r**2 + 1152*D1*Dd*K*f*fd*r*s - 720*D1*Dd*K*f*fd*r + 576*D1*Dd*K*f*fd*s**2 - 720*D1*Dd*K*f*fd*s + 216*D1*Dd*K*f*fd + 48*D1*Dd*f**3*r**2 + 96*D1*Dd*f**3*r*s - 72*D1*Dd*f**3*r + 48*D1*Dd*f**3*s**2 - 72*D1*Dd*f**3*s + 36*D1*Dd*f**3 + 28*D1*Dd*f**2*r**2 + 56*D1*Dd*f**2*r*s - 42*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 - 42*D1*Dd*f**2*s + 21*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 856*D1*Dd*f*g2*r**2 + 1712*D1*Dd*f*g2*r*s - 1284*D1*Dd*f*g2*r + 856*D1*Dd*f*g2*s**2 - 1284*D1*Dd*f*g2*s + 642*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r**2 - 1152*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r - 576*D1*Dd*f*gd2*s**2 + 1008*D1*Dd*f*gd2*s - 432*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r**2 - 1152*D1*Dd*fd*g2*r*s + 432*D1*Dd*fd*g2*r - 576*D1*Dd*fd*g2*s**2 + 432*D1*Dd*fd*g2*s + 144*D1*Ddd*K*f**2*r**2 + 288*D1*Ddd*K*f**2*r*s - 216*D1*Ddd*K*f**2*r + 144*D1*Ddd*K*f**2*s**2 - 216*D1*Ddd*K*f**2*s + 108*D1*Ddd*K*f**2 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r**2 - 576*D1*Ddd*f*g2*r*s + 432*D1*Ddd*f*g2*r - 288*D1*Ddd*f*g2*s**2 + 432*D1*Ddd*f*g2*s - 216*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(96*f**2*(r + s - 1) - 120*f*fd*(2*r + 2*s - 1) - f*(107*K - 57)*(r + s - 1) + 36*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-6*K + 10*f + 3)*(4*r + 4*s - 3))*(r + s - 1) + 432*Dd**2*K*f**2*r**2 + 864*Dd**2*K*f**2*r*s - 648*Dd**2*K*f**2*r + 432*Dd**2*K*f**2*s**2 - 648*Dd**2*K*f**2*s + 216*Dd**2*K*f**2 - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 - 864*Dd**2*f*g2*r**2 - 1728*Dd**2*f*g2*r*s + 1296*Dd**2*f*g2*r - 864*Dd**2*f*g2*s**2 + 1296*Dd**2*f*g2*s - 432*Dd**2*f*g2))/(6006*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**2*k1**2*k2**2*st**2*(-11*b1**2*(D1**2*(fd*(73*C - 54) + fdd*(13 - 19*C))*(r + s - 1)**2 + D1*(Dd*(f*(73*C - 54)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(26 - 38*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(19*C - 13)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(114*C - 78)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(-42*C*D1**2*f*fd*r**2 - 84*C*D1**2*f*fd*r*s - 24*C*D1**2*f*fd*r - 42*C*D1**2*f*fd*s**2 - 24*C*D1**2*f*fd*s + 12*C*D1**2*f*fd + 34*C*D1**2*f*fdd*r**2 + 68*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*r + 34*C*D1**2*f*fdd*s**2 + 4*C*D1**2*f*fdd*s - 2*C*D1**2*f*fdd + 34*C*D1**2*fd**2*r**2 + 68*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*r + 34*C*D1**2*fd**2*s**2 + 4*C*D1**2*fd**2*s - 38*C*D1**2*fd**2 - 84*C*D1*Dd*f**2*r**2 - 168*C*D1*Dd*f**2*r*s + 126*C*D1*Dd*f**2*r - 84*C*D1*Dd*f**2*s**2 + 126*C*D1*Dd*f**2*s - 63*C*D1*Dd*f**2 + 272*C*D1*Dd*f*fd*r**2 + 544*C*D1*Dd*f*fd*r*s - 188*C*D1*Dd*f*fd*r + 272*C*D1*Dd*f*fd*s**2 - 188*C*D1*Dd*f*fd*s - 12*C*D1*Dd*f*fd + 68*C*D1*Ddd*f**2*r**2 + 136*C*D1*Ddd*f**2*r*s - 102*C*D1*Ddd*f**2*r + 68*C*D1*Ddd*f**2*s**2 - 102*C*D1*Ddd*f**2*s + 51*C*D1*Ddd*f**2 + 204*C*Dd**2*f**2*r**2 + 408*C*Dd**2*f**2*r*s - 306*C*Dd**2*f**2*r + 204*C*Dd**2*f**2*s**2 - 306*C*Dd**2*f**2*s + 102*C*Dd**2*f**2 - D1**2*bdd1*f*(19*C - 13)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 26*D1**2*f*fd*r**2 + 52*D1**2*f*fd*r*s + 18*D1**2*f*fd*r + 26*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s - 9*D1**2*f*fd - 22*D1**2*f*fdd*r**2 - 44*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r - 22*D1**2*f*fdd*s**2 - 4*D1**2*f*fdd*s + 2*D1**2*f*fdd - 22*D1**2*fd**2*r**2 - 44*D1**2*fd**2*r*s - 4*D1**2*fd**2*r - 22*D1**2*fd**2*s**2 - 4*D1**2*fd**2*s + 26*D1**2*fd**2 + 52*D1*Dd*f**2*r**2 + 104*D1*Dd*f**2*r*s - 78*D1*Dd*f**2*r + 52*D1*Dd*f**2*s**2 - 78*D1*Dd*f**2*s + 39*D1*Dd*f**2 - 176*D1*Dd*f*fd*r**2 - 352*D1*Dd*f*fd*r*s + 116*D1*Dd*f*fd*r - 176*D1*Dd*f*fd*s**2 + 116*D1*Dd*f*fd*s + 12*D1*Dd*f*fd - 44*D1*Ddd*f**2*r**2 - 88*D1*Ddd*f**2*r*s + 66*D1*Ddd*f**2*r - 44*D1*Ddd*f**2*s**2 + 66*D1*Ddd*f**2*s - 33*D1*Ddd*f**2 + D1*bd1*(D1*(f*(73*C - 54)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(26 - 38*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(26 - 38*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 132*Dd**2*f**2*r**2 - 264*Dd**2*f**2*r*s + 198*Dd**2*f**2*r - 132*Dd**2*f**2*s**2 + 198*Dd**2*f**2*s - 66*Dd**2*f**2) + f*(1206*C*D1**2*f*fd*r**2 + 2412*C*D1**2*f*fd*r*s - 1608*C*D1**2*f*fd*r + 1206*C*D1**2*f*fd*s**2 - 1608*C*D1**2*f*fd*s + 804*C*D1**2*f*fd - 900*C*D1**2*f*fdd*r**2 - 1800*C*D1**2*f*fdd*r*s + 1200*C*D1**2*f*fdd*r - 900*C*D1**2*f*fdd*s**2 + 1200*C*D1**2*f*fdd*s - 600*C*D1**2*f*fdd - 1800*C*D1**2*fd**2*r**2 - 3600*C*D1**2*fd**2*r*s + 2400*C*D1**2*fd**2*r - 1800*C*D1**2*fd**2*s**2 + 2400*C*D1**2*fd**2*s - 600*C*D1**2*fd**2 + 1608*C*D1*Dd*f**2*r**2 + 3216*C*D1*Dd*f**2*r*s - 2412*C*D1*Dd*f**2*r + 1608*C*D1*Dd*f**2*s**2 - 2412*C*D1*Dd*f**2*s + 1206*C*D1*Dd*f**2 - 7200*C*D1*Dd*f*fd*r**2 - 14400*C*D1*Dd*f*fd*r*s + 10200*C*D1*Dd*f*fd*r - 7200*C*D1*Dd*f*fd*s**2 + 10200*C*D1*Dd*f*fd*s - 3600*C*D1*Dd*f*fd - 1200*C*D1*Ddd*f**2*r**2 - 2400*C*D1*Ddd*f**2*r*s + 1800*C*D1*Ddd*f**2*r - 1200*C*D1*Ddd*f**2*s**2 + 1800*C*D1*Ddd*f**2*s - 900*C*D1*Ddd*f**2 - 3600*C*Dd**2*f**2*r**2 - 7200*C*Dd**2*f**2*r*s + 5400*C*Dd**2*f**2*r - 3600*C*Dd**2*f**2*s**2 + 5400*C*Dd**2*f**2*s - 1800*C*Dd**2*f**2 + 22*D1**2*bd1**2*(19*C - 13)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 11*D1**2*bdd1*f*(C*(17*r**2 + 34*r*s - 72*r + 17*s**2 - 72*s + 36) - 11*r**2 - 22*r*s + 48*r - 11*s**2 + 48*s - 24) - 771*D1**2*f*fd*r**2 - 1542*D1**2*f*fd*r*s + 1028*D1**2*f*fd*r - 771*D1**2*f*fd*s**2 + 1028*D1**2*f*fd*s - 514*D1**2*f*fd + 600*D1**2*f*fdd*r**2 + 1200*D1**2*f*fdd*r*s - 800*D1**2*f*fdd*r + 600*D1**2*f*fdd*s**2 - 800*D1**2*f*fdd*s + 400*D1**2*f*fdd + 1200*D1**2*fd**2*r**2 + 2400*D1**2*fd**2*r*s - 1600*D1**2*fd**2*r + 1200*D1**2*fd**2*s**2 - 1600*D1**2*fd**2*s + 400*D1**2*fd**2 - 1028*D1*Dd*f**2*r**2 - 2056*D1*Dd*f**2*r*s + 1542*D1*Dd*f**2*r - 1028*D1*Dd*f**2*s**2 + 1542*D1*Dd*f**2*s - 771*D1*Dd*f**2 + 4800*D1*Dd*f*fd*r**2 + 9600*D1*Dd*f*fd*r*s - 6800*D1*Dd*f*fd*r + 4800*D1*Dd*f*fd*s**2 - 6800*D1*Dd*f*fd*s + 2400*D1*Dd*f*fd + 800*D1*Ddd*f**2*r**2 + 1600*D1*Ddd*f**2*r*s - 1200*D1*Ddd*f**2*r + 800*D1*Ddd*f**2*s**2 - 1200*D1*Ddd*f**2*s + 600*D1*Ddd*f**2 + 11*D1*bd1*(D1*(f*(3*C*(7*r**2 + 14*r*s - 36*r + 7*s**2 - 36*s + 18) - 13*r**2 - 26*r*s + 70*r - 13*s**2 + 70*s - 35) - 4*fd*(r + s - 1)*(C*(17*r + 17*s - 18) - 11*r - 11*s + 12)) - 2*Dd*f*(4*r + 4*s - 3)*(C*(17*r + 17*s - 36) - 11*r - 11*s + 24)) + 2400*Dd**2*f**2*r**2 + 4800*Dd**2*f**2*r*s - 3600*Dd**2*f**2*r + 2400*Dd**2*f**2*s**2 - 3600*Dd**2*f**2*s + 1200*Dd**2*f**2))/(231*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**2*k1**2*k2**2*(792*C*D1**2*bd1*f**2*r + 792*C*D1**2*bd1*f**2*s - 396*C*D1**2*bd1*f**2 - 990*C*D1**2*f**2*fd*r**2 - 1980*C*D1**2*f**2*fd*r*s + 1320*C*D1**2*f**2*fd*r - 990*C*D1**2*f**2*fd*s**2 + 1320*C*D1**2*f**2*fd*s - 660*C*D1**2*f**2*fd - 1320*C*D1*Dd*f**3*r**2 - 2640*C*D1*Dd*f**3*r*s + 1980*C*D1*Dd*f**3*r - 1320*C*D1*Dd*f**3*s**2 + 1980*C*D1*Dd*f**3*s - 990*C*D1*Dd*f**3 + 2376*D1**2*K*bd1**2*f*r + 2376*D1**2*K*bd1**2*f*s - 2376*D1**2*K*bd1**2*f + 990*D1**2*K*bd1*f**2*r**2 + 1980*D1**2*K*bd1*f**2*r*s - 1980*D1**2*K*bd1*f**2*r + 990*D1**2*K*bd1*f**2*s**2 - 1980*D1**2*K*bd1*f**2*s + 990*D1**2*K*bd1*f**2 - 3960*D1**2*K*bd1*f*fd*r**2 - 7920*D1**2*K*bd1*f*fd*r*s + 5940*D1**2*K*bd1*f*fd*r - 3960*D1**2*K*bd1*f*fd*s**2 + 5940*D1**2*K*bd1*f*fd*s - 1980*D1**2*K*bd1*f*fd - 990*D1**2*K*bdd1*f**2*r**2 - 1980*D1**2*K*bdd1*f**2*r*s + 1980*D1**2*K*bdd1*f**2*r - 990*D1**2*K*bdd1*f**2*s**2 + 1980*D1**2*K*bdd1*f**2*s - 990*D1**2*K*bdd1*f**2 + 660*D1**2*bd1**2*f**2*r**2 + 1320*D1**2*bd1**2*f**2*r*s - 1980*D1**2*bd1**2*f**2*r + 660*D1**2*bd1**2*f**2*s**2 - 1980*D1**2*bd1**2*f**2*s + 1320*D1**2*bd1**2*f**2 + 396*D1**2*bd1**2*f*r**2 + 792*D1**2*bd1**2*f*r*s - 1980*D1**2*bd1**2*f*r + 396*D1**2*bd1**2*f*s**2 - 1980*D1**2*bd1**2*f*s + 1584*D1**2*bd1**2*f - 5544*D1**2*bd1**2*g2*r**2 - 11088*D1**2*bd1**2*g2*r*s + 5544*D1**2*bd1**2*g2*r - 5544*D1**2*bd1**2*g2*s**2 + 5544*D1**2*bd1**2*g2*s - 2376*D1**2*bd1*bd2*f*r**2 - 4752*D1**2*bd1*bd2*f*r*s + 4752*D1**2*bd1*bd2*f*r - 2376*D1**2*bd1*bd2*f*s**2 + 4752*D1**2*bd1*bd2*f*s - 2376*D1**2*bd1*bd2*f - 575*D1**2*bd1*f**3*r**2 - 1150*D1**2*bd1*f**3*r*s + 920*D1**2*bd1*f**3*r - 575*D1**2*bd1*f**3*s**2 + 920*D1**2*bd1*f**3*s - 460*D1**2*bd1*f**3 + 4200*D1**2*bd1*f**2*fd*r**2 + 8400*D1**2*bd1*f**2*fd*r*s - 6440*D1**2*bd1*f**2*fd*r + 4200*D1**2*bd1*f**2*fd*s**2 - 6440*D1**2*bd1*f**2*fd*s + 2240*D1**2*bd1*f**2*fd - 528*D1**2*bd1*f**2*r**2 - 1056*D1**2*bd1*f**2*r*s + 660*D1**2*bd1*f**2*r - 528*D1**2*bd1*f**2*s**2 + 660*D1**2*bd1*f**2*s - 330*D1**2*bd1*f**2 + 2640*D1**2*bd1*f*fd*r**2 + 5280*D1**2*bd1*f*fd*r*s - 3960*D1**2*bd1*f*fd*r + 2640*D1**2*bd1*f*fd*s**2 - 3960*D1**2*bd1*f*fd*s + 1320*D1**2*bd1*f*fd + 4884*D1**2*bd1*f*g2*r + 4884*D1**2*bd1*f*g2*s - 2442*D1**2*bd1*f*g2 - 4752*D1**2*bd1*f*gd2*r - 4752*D1**2*bd1*f*gd2*s + 4752*D1**2*bd1*f*gd2 + 990*D1**2*bd2*f**2*r**2 + 1980*D1**2*bd2*f**2*r*s - 1980*D1**2*bd2*f**2*r + 990*D1**2*bd2*f**2*s**2 - 1980*D1**2*bd2*f**2*s + 990*D1**2*bd2*f**2 - 3960*D1**2*bd2*f*fd*r**2 - 7920*D1**2*bd2*f*fd*r*s + 5940*D1**2*bd2*f*fd*r - 3960*D1**2*bd2*f*fd*s**2 + 5940*D1**2*bd2*f*fd*s - 1980*D1**2*bd2*f*fd + 700*D1**2*bdd1*f**3*r**2 + 1400*D1**2*bdd1*f**3*r*s - 1120*D1**2*bdd1*f**3*r + 700*D1**2*bdd1*f**3*s**2 - 1120*D1**2*bdd1*f**3*s + 560*D1**2*bdd1*f**3 + 660*D1**2*bdd1*f**2*r**2 + 1320*D1**2*bdd1*f**2*r*s - 1320*D1**2*bdd1*f**2*r + 660*D1**2*bdd1*f**2*s**2 - 1320*D1**2*bdd1*f**2*s + 660*D1**2*bdd1*f**2 - 4752*D1**2*bdd1*f*g2*r - 4752*D1**2*bdd1*f*g2*s + 2376*D1**2*bdd1*f*g2 - 990*D1**2*bdd2*f**2*r**2 - 1980*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*r - 990*D1**2*bdd2*f**2*s**2 + 1980*D1**2*bdd2*f**2*s - 990*D1**2*bdd2*f**2 + 495*D1**2*f**2*fd*r**2 + 990*D1**2*f**2*fd*r*s - 660*D1**2*f**2*fd*r + 495*D1**2*f**2*fd*s**2 - 660*D1**2*f**2*fd*s + 330*D1**2*f**2*fd - 1980*D1**2*f**2*gd2*r**2 - 3960*D1**2*f**2*gd2*r*s + 3960*D1**2*f**2*gd2*r - 1980*D1**2*f**2*gd2*s**2 + 3960*D1**2*f**2*gd2*s - 1980*D1**2*f**2*gd2 + 1980*D1**2*f**2*gdd2*r**2 + 3960*D1**2*f**2*gdd2*r*s - 3960*D1**2*f**2*gdd2*r + 1980*D1**2*f**2*gdd2*s**2 - 3960*D1**2*f**2*gdd2*s + 1980*D1**2*f**2*gdd2 - 3960*D1**2*f*fd*g2*r**2 - 7920*D1**2*f*fd*g2*r*s + 3960*D1**2*f*fd*g2*r - 3960*D1**2*f*fd*g2*s**2 + 3960*D1**2*f*fd*g2*s - 1980*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r**2 + 15840*D1**2*f*fd*gd2*r*s - 11880*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 11880*D1**2*f*fd*gd2*s + 3960*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r**2 + 7920*D1**2*f*fdd*g2*r*s - 3960*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r**2 + 7920*D1**2*fd**2*g2*r*s - 3960*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s - 7920*D1*Dd*K*bd1*f**2*r**2 - 15840*D1*Dd*K*bd1*f**2*r*s + 13860*D1*Dd*K*bd1*f**2*r - 7920*D1*Dd*K*bd1*f**2*s**2 + 13860*D1*Dd*K*bd1*f**2*s - 5940*D1*Dd*K*bd1*f**2 + 5600*D1*Dd*bd1*f**3*r**2 + 11200*D1*Dd*bd1*f**3*r*s - 8680*D1*Dd*bd1*f**3*r + 5600*D1*Dd*bd1*f**3*s**2 - 8680*D1*Dd*bd1*f**3*s + 3360*D1*Dd*bd1*f**3 + 5280*D1*Dd*bd1*f**2*r**2 + 10560*D1*Dd*bd1*f**2*r*s - 9240*D1*Dd*bd1*f**2*r + 5280*D1*Dd*bd1*f**2*s**2 - 9240*D1*Dd*bd1*f**2*s + 3960*D1*Dd*bd1*f**2 - 19008*D1*Dd*bd1*f*g2*r - 19008*D1*Dd*bd1*f*g2*s + 14256*D1*Dd*bd1*f*g2 - 7920*D1*Dd*bd2*f**2*r**2 - 15840*D1*Dd*bd2*f**2*r*s + 13860*D1*Dd*bd2*f**2*r - 7920*D1*Dd*bd2*f**2*s**2 + 13860*D1*Dd*bd2*f**2*s - 5940*D1*Dd*bd2*f**2 + 660*D1*Dd*f**3*r**2 + 1320*D1*Dd*f**3*r*s - 990*D1*Dd*f**3*r + 660*D1*Dd*f**3*s**2 - 990*D1*Dd*f**3*s + 495*D1*Dd*f**3 - 7920*D1*Dd*f**2*g2*r**2 - 15840*D1*Dd*f**2*g2*r*s + 11880*D1*Dd*f**2*g2*r - 7920*D1*Dd*f**2*g2*s**2 + 11880*D1*Dd*f**2*g2*s - 5940*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r**2 + 31680*D1*Dd*f**2*gd2*r*s - 27720*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 27720*D1*Dd*f**2*gd2*s + 11880*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r**2 + 63360*D1*Dd*f*fd*g2*r*s - 39600*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 39600*D1*Dd*f*fd*g2*s + 11880*D1*Dd*f*fd*g2 + 7920*D1*Ddd*f**2*g2*r**2 + 15840*D1*Ddd*f**2*g2*r*s - 11880*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 11880*D1*Ddd*f**2*g2*s + 5940*D1*Ddd*f**2*g2 + 23760*Dd**2*f**2*g2*r**2 + 47520*Dd**2*f**2*g2*r*s - 35640*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 35640*Dd**2*f**2*g2*s + 11880*Dd**2*f**2*g2 + 99*b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(14*C*D1**2*fd*r**2 + 28*C*D1**2*fd*r*s - 28*C*D1**2*fd*r + 14*C*D1**2*fd*s**2 - 28*C*D1**2*fd*s + 14*C*D1**2*fd + 56*C*D1*Dd*f*r**2 + 112*C*D1*Dd*f*r*s - 84*C*D1*Dd*f*r + 56*C*D1*Dd*f*s**2 - 84*C*D1*Dd*f*s + 42*C*D1*Dd*f + 74*D1**2*K*fd*r + 74*D1**2*K*fd*s - 37*D1**2*K*fd - 72*D1**2*K*fdd*r - 72*D1**2*K*fdd*s + 36*D1**2*K*fdd - 3*D1**2*bdd1*(-14*K + 6*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 16*D1**2*f*fd*r**2 - 32*D1**2*f*fd*r*s - 16*D1**2*f*fd*s**2 + 20*D1**2*f*fdd*r**2 + 40*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*s**2 + 20*D1**2*fd**2*r**2 + 40*D1**2*fd**2*r*s + 20*D1**2*fd**2*s**2 - 20*D1**2*fd**2 - 12*D1**2*fd*r**2 - 24*D1**2*fd*r*s - 16*D1**2*fd*r - 12*D1**2*fd*s**2 - 16*D1**2*fd*s + 8*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s + 36*D1**2*fdd*r + 6*D1**2*fdd*s**2 + 36*D1**2*fdd*s - 18*D1**2*fdd + 168*D1**2*gd2*r**2 + 336*D1**2*gd2*r*s - 336*D1**2*gd2*r + 168*D1**2*gd2*s**2 - 336*D1**2*gd2*s + 168*D1**2*gd2 - 84*D1**2*gdd2*r**2 - 168*D1**2*gdd2*r*s + 168*D1**2*gdd2*r - 84*D1**2*gdd2*s**2 + 168*D1**2*gdd2*s - 84*D1**2*gdd2 - 288*D1*Dd*K*fd*r - 288*D1*Dd*K*fd*s + 216*D1*Dd*K*fd - 32*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 48*D1*Dd*f**2*r - 32*D1*Dd*f**2*s**2 + 48*D1*Dd*f**2*s - 24*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 + 320*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r + 160*D1*Dd*f*fd*s**2 - 120*D1*Dd*f*fd*s - 48*D1*Dd*f*r**2 - 96*D1*Dd*f*r*s + 72*D1*Dd*f*r - 48*D1*Dd*f*s**2 + 72*D1*Dd*f*s - 36*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s + 108*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 + 108*D1*Dd*fd*s - 108*D1*Dd*fd + 672*D1*Dd*g2*r**2 + 1344*D1*Dd*g2*r*s - 1008*D1*Dd*g2*r + 672*D1*Dd*g2*s**2 - 1008*D1*Dd*g2*s + 504*D1*Dd*g2 - 672*D1*Dd*gd2*r**2 - 1344*D1*Dd*gd2*r*s + 1176*D1*Dd*gd2*r - 672*D1*Dd*gd2*s**2 + 1176*D1*Dd*gd2*s - 504*D1*Dd*gd2 + 40*D1*Ddd*f**2*r**2 + 80*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 60*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f - 336*D1*Ddd*g2*r**2 - 672*D1*Ddd*g2*r*s + 504*D1*Ddd*g2*r - 336*D1*Ddd*g2*s**2 + 504*D1*Ddd*g2*s - 252*D1*Ddd*g2 + 3*D1*bd1*(D1*(5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-14*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 120*Dd**2*f**2*r**2 + 240*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 180*Dd**2*f**2*s + 60*Dd**2*f**2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f - 1008*Dd**2*g2*r**2 - 2016*Dd**2*g2*r*s + 1512*Dd**2*g2*r - 1008*Dd**2*g2*s**2 + 1512*Dd**2*g2*s - 504*Dd**2*g2) + b1*(-792*C*D1**2*f*fd*r - 792*C*D1**2*f*fd*s + 396*C*D1**2*f*fd + 2376*D1**2*K*bdd1*f*r + 2376*D1**2*K*bdd1*f*s - 1188*D1**2*K*bdd1*f + 1980*D1**2*K*f*fd*r**2 + 3960*D1**2*K*f*fd*r*s - 1980*D1**2*K*f*fd*r + 1980*D1**2*K*f*fd*s**2 - 1980*D1**2*K*f*fd*s + 990*D1**2*K*f*fd - 1980*D1**2*K*f*fdd*r**2 - 3960*D1**2*K*f*fdd*r*s + 1980*D1**2*K*f*fdd*r - 1980*D1**2*K*f*fdd*s**2 + 1980*D1**2*K*f*fdd*s - 990*D1**2*K*f*fdd - 1980*D1**2*K*fd**2*r**2 - 3960*D1**2*K*fd**2*r*s + 1980*D1**2*K*fd**2*r - 1980*D1**2*K*fd**2*s**2 + 1980*D1**2*K*fd**2*s + 1221*D1**2*b2*fd*r**2 + 2442*D1**2*b2*fd*r*s + 1221*D1**2*b2*fd*s**2 - 1188*D1**2*b2*fdd*r**2 - 2376*D1**2*b2*fdd*r*s - 1188*D1**2*b2*fdd*s**2 - 198*D1**2*bd1**2*(-14*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 660*D1**2*bdd1*f**2*r**2 + 1320*D1**2*bdd1*f**2*r*s - 1980*D1**2*bdd1*f**2*r + 660*D1**2*bdd1*f**2*s**2 - 1980*D1**2*bdd1*f**2*s + 990*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*r**2 + 792*D1**2*bdd1*f*r*s - 1980*D1**2*bdd1*f*r + 396*D1**2*bdd1*f*s**2 - 1980*D1**2*bdd1*f*s + 990*D1**2*bdd1*f - 5544*D1**2*bdd1*g2*r**2 - 11088*D1**2*bdd1*g2*r*s + 5544*D1**2*bdd1*g2*r - 5544*D1**2*bdd1*g2*s**2 + 5544*D1**2*bdd1*g2*s - 2772*D1**2*bdd1*g2 - 1188*D1**2*bdd2*f*r**2 - 2376*D1**2*bdd2*f*r*s + 2376*D1**2*bdd2*f*r - 1188*D1**2*bdd2*f*s**2 + 2376*D1**2*bdd2*f*s - 1188*D1**2*bdd2*f - 1725*D1**2*f**2*fd*r**2 - 3450*D1**2*f**2*fd*r*s + 2530*D1**2*f**2*fd*r - 1725*D1**2*f**2*fd*s**2 + 2530*D1**2*f**2*fd*s - 1265*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 3080*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 3080*D1**2*f**2*fdd*s + 1540*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 6160*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 6160*D1**2*f*fd**2*s + 1960*D1**2*f*fd**2 - 1056*D1**2*f*fd*r**2 - 2112*D1**2*f*fd*r*s + 1452*D1**2*f*fd*r - 1056*D1**2*f*fd*s**2 + 1452*D1**2*f*fd*s - 726*D1**2*f*fd + 1320*D1**2*f*fdd*r**2 + 2640*D1**2*f*fdd*r*s - 1320*D1**2*f*fdd*r + 1320*D1**2*f*fdd*s**2 - 1320*D1**2*f*fdd*s + 660*D1**2*f*fdd + 1320*D1**2*fd**2*r**2 + 2640*D1**2*fd**2*r*s - 1320*D1**2*fd**2*r + 1320*D1**2*fd**2*s**2 - 1320*D1**2*fd**2*s - 4884*D1**2*fd*g2*r - 4884*D1**2*fd*g2*s + 2442*D1**2*fd*g2 + 4752*D1**2*fd*gd2*r + 4752*D1**2*fd*gd2*s - 4752*D1**2*fd*gd2 + 4752*D1**2*fdd*g2*r + 4752*D1**2*fdd*g2*s - 2376*D1**2*fdd*g2 + 3960*D1*Dd*K*f**2*r**2 + 7920*D1*Dd*K*f**2*r*s - 5940*D1*Dd*K*f**2*r + 3960*D1*Dd*K*f**2*s**2 - 5940*D1*Dd*K*f**2*s + 2970*D1*Dd*K*f**2 - 15840*D1*Dd*K*f*fd*r**2 - 31680*D1*Dd*K*f*fd*r*s + 19800*D1*Dd*K*f*fd*r - 15840*D1*Dd*K*f*fd*s**2 + 19800*D1*Dd*K*f*fd*s - 5940*D1*Dd*K*f*fd + 4884*D1*Dd*b2*f*r**2 + 9768*D1*Dd*b2*f*r*s - 7326*D1*Dd*b2*f*r + 4884*D1*Dd*b2*f*s**2 - 7326*D1*Dd*b2*f*s + 3663*D1*Dd*b2*f - 9504*D1*Dd*b2*fd*r**2 - 19008*D1*Dd*b2*fd*r*s + 7128*D1*Dd*b2*fd*r - 9504*D1*Dd*b2*fd*s**2 + 7128*D1*Dd*b2*fd*s - 2300*D1*Dd*f**3*r**2 - 4600*D1*Dd*f**3*r*s + 3450*D1*Dd*f**3*r - 2300*D1*Dd*f**3*s**2 + 3450*D1*Dd*f**3*s - 1725*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 24920*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 24920*D1*Dd*f**2*fd*s + 9240*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*r**2 - 4224*D1*Dd*f**2*r*s + 3168*D1*Dd*f**2*r - 2112*D1*Dd*f**2*s**2 + 3168*D1*Dd*f**2*s - 1584*D1*Dd*f**2 + 10560*D1*Dd*f*fd*r**2 + 21120*D1*Dd*f*fd*r*s - 13200*D1*Dd*f*fd*r + 10560*D1*Dd*f*fd*s**2 - 13200*D1*Dd*f*fd*s + 3960*D1*Dd*f*fd + 19008*D1*Dd*fd*g2*r + 19008*D1*Dd*fd*g2*s - 14256*D1*Dd*fd*g2 - 3960*D1*Ddd*K*f**2*r**2 - 7920*D1*Ddd*K*f**2*r*s + 5940*D1*Ddd*K*f**2*r - 3960*D1*Ddd*K*f**2*s**2 + 5940*D1*Ddd*K*f**2*s - 2970*D1*Ddd*K*f**2 - 4752*D1*Ddd*b2*f*r**2 - 9504*D1*Ddd*b2*f*r*s + 7128*D1*Ddd*b2*f*r - 4752*D1*Ddd*b2*f*s**2 + 7128*D1*Ddd*b2*f*s - 3564*D1*Ddd*b2*f + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 + 2640*D1*Ddd*f**2*r**2 + 5280*D1*Ddd*f**2*r*s - 3960*D1*Ddd*f**2*r + 2640*D1*Ddd*f**2*s**2 - 3960*D1*Ddd*f**2*s + 1980*D1*Ddd*f**2 - 33*D1*bd1*(D1*(8*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + f*(-14*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 74*K*r + 74*K*s - 37*K - 40*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 24*r**2 + 48*r*s - 64*r + 24*s**2 - 64*s + 32) + 12*fd*(r + s - 1)*(6*K - 2*r - 2*s - 3) - 168*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 168*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 4*Dd*(4*r + 4*s - 3)*(5*f**2*(2*r + 2*s - 3) + 3*f*(6*K + 2*r + 2*s - 5) - 42*g2*(2*r + 2*s - 1))) + 33*D1*bd2*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) - 11880*Dd**2*K*f**2*r**2 - 23760*Dd**2*K*f**2*r*s + 17820*Dd**2*K*f**2*r - 11880*Dd**2*K*f**2*s**2 + 17820*Dd**2*K*f**2*s - 5940*Dd**2*K*f**2 - 14256*Dd**2*b2*f*r**2 - 28512*Dd**2*b2*f*r*s + 21384*Dd**2*b2*f*r - 14256*Dd**2*b2*f*s**2 + 21384*Dd**2*b2*f*s - 7128*Dd**2*b2*f + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3 + 7920*Dd**2*f**2*r**2 + 15840*Dd**2*f**2*r*s - 11880*Dd**2*f**2*r + 7920*Dd**2*f**2*s**2 - 11880*Dd**2*f**2*s + 3960*Dd**2*f**2) + 33*b2*(-36*D1**2*bdd1*f*(r + s - 1)**2 + 30*D1**2*(f*(fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bd1*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) + 30*D1*f*(Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**2*k1**2*(2*C - 1)*(-D1*f*(r + s)*(12*D1*bd1**2*(r + s - 1) + 5*D1*bdd1*f*(r + s) + bd1*(-4*D1*f*(r + s) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-6*D1**2*bdd1*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 16*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 8*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 20*D1**2*f*fdd*s - 10*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 20*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 20*D1**2*fd**2*s - 10*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 140*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 140*D1*Dd*f*fd*s - 60*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 12*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2))/(21*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct**2*k2**6*st**6*(5*C - 5)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(693*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**2*k2**6*st**4*(-858*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 78*D1*bd1*(D1*(20*f**3*(r + s - 1) + f**2*(11*C*(r + s - 1) - 20*fd*(3*r + 3*s - 2) - 11*r - 11*s + 11) + 22*f*(g2 - gd2)*(r + s - 1) - 22*fd*g2*(r + s)) - 2*Dd*f*(10*f**2 + 11*g2)*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 78*b1*(-22*C*D1**2*f*fd*r**2 - 44*C*D1**2*f*fd*r*s + 22*C*D1**2*f*fd*r - 22*C*D1**2*f*fd*s**2 + 22*C*D1**2*f*fd*s - 11*C*D1**2*f*fd - 44*C*D1*Dd*f**2*r**2 - 88*C*D1*Dd*f**2*r*s + 66*C*D1*Dd*f**2*r - 44*C*D1*Dd*f**2*s**2 + 66*C*D1*Dd*f**2*s - 33*C*D1*Dd*f**2 - 11*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 60*D1**2*f**2*fd*r**2 - 120*D1**2*f**2*fd*r*s + 80*D1**2*f**2*fd*r - 60*D1**2*f**2*fd*s**2 + 80*D1**2*f**2*fd*s - 40*D1**2*f**2*fd + 30*D1**2*f**2*fdd*r**2 + 60*D1**2*f**2*fdd*r*s - 40*D1**2*f**2*fdd*r + 30*D1**2*f**2*fdd*s**2 - 40*D1**2*f**2*fdd*s + 20*D1**2*f**2*fdd + 60*D1**2*f*fd**2*r**2 + 120*D1**2*f*fd**2*r*s - 80*D1**2*f*fd**2*r + 60*D1**2*f*fd**2*s**2 - 80*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 22*D1**2*f*gd2*r**2 - 44*D1**2*f*gd2*r*s + 44*D1**2*f*gd2*r - 22*D1**2*f*gd2*s**2 + 44*D1**2*f*gd2*s - 22*D1**2*f*gd2 + 11*D1**2*f*gdd2*r**2 + 22*D1**2*f*gdd2*r*s - 22*D1**2*f*gdd2*r + 11*D1**2*f*gdd2*s**2 - 22*D1**2*f*gdd2*s + 11*D1**2*f*gdd2 - 22*D1**2*fd*g2*r**2 - 44*D1**2*fd*g2*r*s - 22*D1**2*fd*g2*s**2 + 22*D1**2*fd*gd2*r**2 + 44*D1**2*fd*gd2*r*s - 22*D1**2*fd*gd2*r + 22*D1**2*fd*gd2*s**2 - 22*D1**2*fd*gd2*s + 11*D1**2*fdd*g2*r**2 + 22*D1**2*fdd*g2*r*s + 11*D1**2*fdd*g2*s**2 - 80*D1*Dd*f**3*r**2 - 160*D1*Dd*f**3*r*s + 120*D1*Dd*f**3*r - 80*D1*Dd*f**3*s**2 + 120*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 240*D1*Dd*f**2*fd*r**2 + 480*D1*Dd*f**2*fd*r*s - 340*D1*Dd*f**2*fd*r + 240*D1*Dd*f**2*fd*s**2 - 340*D1*Dd*f**2*fd*s + 120*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 88*D1*Dd*f*g2*r**2 - 176*D1*Dd*f*g2*r*s + 132*D1*Dd*f*g2*r - 88*D1*Dd*f*g2*s**2 + 132*D1*Dd*f*g2*s - 66*D1*Dd*f*g2 + 88*D1*Dd*f*gd2*r**2 + 176*D1*Dd*f*gd2*r*s - 154*D1*Dd*f*gd2*r + 88*D1*Dd*f*gd2*s**2 - 154*D1*Dd*f*gd2*s + 66*D1*Dd*f*gd2 + 88*D1*Dd*fd*g2*r**2 + 176*D1*Dd*fd*g2*r*s - 66*D1*Dd*fd*g2*r + 88*D1*Dd*fd*g2*s**2 - 66*D1*Dd*fd*g2*s + 40*D1*Ddd*f**3*r**2 + 80*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 40*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + 44*D1*Ddd*f*g2*r**2 + 88*D1*Ddd*f*g2*r*s - 66*D1*Ddd*f*g2*r + 44*D1*Ddd*f*g2*s**2 - 66*D1*Ddd*f*g2*s + 33*D1*Ddd*f*g2 + 22*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 120*Dd**2*f**3*r**2 + 240*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 120*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 60*Dd**2*f**3 + 132*Dd**2*f*g2*r**2 + 264*Dd**2*f*g2*r*s - 198*Dd**2*f*g2*r + 132*Dd**2*f*g2*s**2 - 198*Dd**2*f*g2*s + 66*Dd**2*f*g2) - 2*f*(-39*D1**2*bdd1*(10*f**2 + 11*g2)*(r + s - 1)**2 + 5*f*(D1**2*(f*(137*fd - 75*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 450*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(137*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 150*fd*(4*r + 4*s - 3)**2) - 75*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 450*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(3003*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct**2*k2**4*st**4*(66*D1*b1*(2*bd1*(C - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - f*(D1*bdd1*(C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 66*b1**2*(C - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(-132*D1**2*bd1**2*(C - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 66*D1**2*bd1*f*(r + s - 1)**2 + (30*C - 35)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(231*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**2*k2**4*st**2*(-396*C*D1**2*f**2*fd*r**2 - 792*C*D1**2*f**2*fd*r*s + 528*C*D1**2*f**2*fd*r - 396*C*D1**2*f**2*fd*s**2 + 528*C*D1**2*f**2*fd*s - 264*C*D1**2*f**2*fd - 528*C*D1*Dd*f**3*r**2 - 1056*C*D1*Dd*f**3*r*s + 792*C*D1*Dd*f**3*r - 528*C*D1*Dd*f**3*s**2 + 792*C*D1*Dd*f**3*s - 396*C*D1*Dd*f**3 - 66*D1**2*K*bdd1*f**2*r**2 - 132*D1**2*K*bdd1*f**2*r*s + 132*D1**2*K*bdd1*f**2*r - 66*D1**2*K*bdd1*f**2*s**2 + 132*D1**2*K*bdd1*f**2*s - 66*D1**2*K*bdd1*f**2 + 22*D1**2*bd1**2*(r + s - 1)*(12*f**2*(3*r + 3*s - 2) + f*(K*(-5*r - 5*s + 6) + 11*r + 11*s - 12) + 14*g2*(r + s)) + 132*D1**2*bd2*f**2*r**2 + 264*D1**2*bd2*f**2*r*s - 264*D1**2*bd2*f**2*r + 132*D1**2*bd2*f**2*s**2 - 264*D1**2*bd2*f**2*s + 132*D1**2*bd2*f**2 - 264*D1**2*bd2*f*fd*r**2 - 528*D1**2*bd2*f*fd*r*s + 396*D1**2*bd2*f*fd*r - 264*D1**2*bd2*f*fd*s**2 + 396*D1**2*bd2*f*fd*s - 132*D1**2*bd2*f*fd + 350*D1**2*bdd1*f**3*r**2 + 700*D1**2*bdd1*f**3*r*s - 400*D1**2*bdd1*f**3*r + 350*D1**2*bdd1*f**3*s**2 - 400*D1**2*bdd1*f**3*s + 200*D1**2*bdd1*f**3 + 132*D1**2*bdd1*f**2*r**2 + 264*D1**2*bdd1*f**2*r*s - 264*D1**2*bdd1*f**2*r + 132*D1**2*bdd1*f**2*s**2 - 264*D1**2*bdd1*f**2*s + 132*D1**2*bdd1*f**2 + 110*D1**2*bdd1*f*g2*r**2 + 220*D1**2*bdd1*f*g2*r*s - 264*D1**2*bdd1*f*g2*r + 110*D1**2*bdd1*f*g2*s**2 - 264*D1**2*bdd1*f*g2*s + 132*D1**2*bdd1*f*g2 - 66*D1**2*bdd2*f**2*r**2 - 132*D1**2*bdd2*f**2*r*s + 132*D1**2*bdd2*f**2*r - 66*D1**2*bdd2*f**2*s**2 + 132*D1**2*bdd2*f**2*s - 66*D1**2*bdd2*f**2 + 396*D1**2*f**2*fd*r**2 + 792*D1**2*f**2*fd*r*s - 528*D1**2*f**2*fd*r + 396*D1**2*f**2*fd*s**2 - 528*D1**2*f**2*fd*s + 264*D1**2*f**2*fd - 264*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s + 528*D1**2*f**2*gd2*r - 264*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s - 264*D1**2*f**2*gd2 + 132*D1**2*f**2*gdd2*r**2 + 264*D1**2*f**2*gdd2*r*s - 264*D1**2*f**2*gdd2*r + 132*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 132*D1**2*f**2*gdd2 - 528*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r**2 + 1056*D1**2*f*fd*gd2*r*s - 792*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r**2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r**2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s - 528*D1*Dd*bd2*f**2*r**2 - 1056*D1*Dd*bd2*f**2*r*s + 924*D1*Dd*bd2*f**2*r - 528*D1*Dd*bd2*f**2*s**2 + 924*D1*Dd*bd2*f**2*s - 396*D1*Dd*bd2*f**2 + 528*D1*Dd*f**3*r**2 + 1056*D1*Dd*f**3*r*s - 792*D1*Dd*f**3*r + 528*D1*Dd*f**3*s**2 - 792*D1*Dd*f**3*s + 396*D1*Dd*f**3 - 1056*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s + 1584*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 792*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r**2 + 2112*D1*Dd*f**2*gd2*r*s - 1848*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1848*D1*Dd*f**2*gd2*s + 792*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r**2 + 4224*D1*Dd*f*fd*g2*r*s - 2640*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2640*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 + 528*D1*Ddd*f**2*g2*r**2 + 1056*D1*Ddd*f**2*g2*r*s - 792*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 396*D1*Ddd*f**2*g2 + 2*D1*bd1*(-66*D1*bd2*f*(r + s - 1)**2 + D1*(-f**3*(284*r**2 + r*(568*s - 334) + 284*s**2 - 334*s + 167) + f**2*(-11*C*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) + 66*K*(r + s - 1)**2 + 50*fd*(21*r**2 + r*(42*s - 29) + 21*s**2 - 29*s + 8) - 66*r**2 - 132*r*s + 110*r - 66*s**2 + 110*s - 55) - 22*f*(3*fd*(K - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + g2*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) - gd2*(5*r**2 + r*(10*s - 11) + 5*s**2 - 11*s + 6)) + 110*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(4*r + 4*s - 3)*(25*f**2*(7*r + 7*s - 4) - 33*f*(K - 2)*(r + s - 1) + 11*g2*(5*r + 5*s - 6))) + 1584*Dd**2*f**2*g2*r**2 + 3168*Dd**2*f**2*g2*r*s - 2376*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 792*Dd**2*f**2*g2 + 11*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (7*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(7*K + 6*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(7*K + 6*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(-14*C*D1**2*fd*r**2 - 28*C*D1**2*fd*r*s + 28*C*D1**2*fd*r - 14*C*D1**2*fd*s**2 + 28*C*D1**2*fd*s - 14*C*D1**2*fd - 56*C*D1*Dd*f*r**2 - 112*C*D1*Dd*f*r*s + 84*C*D1*Dd*f*r - 56*C*D1*Dd*f*s**2 + 84*C*D1*Dd*f*s - 42*C*D1*Dd*f + 10*D1**2*K*fd*r**2 + 20*D1**2*K*fd*r*s + 4*D1**2*K*fd*r + 10*D1**2*K*fd*s**2 + 4*D1**2*K*fd*s - 2*D1**2*K*fd - 5*D1**2*K*fdd*r**2 - 10*D1**2*K*fdd*r*s - 2*D1**2*K*fdd*r - 5*D1**2*K*fdd*s**2 - 2*D1**2*K*fdd*s + D1**2*K*fdd - D1**2*bdd1*(7*K + 6*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 120*D1**2*f*fd*r**2 - 240*D1**2*f*fd*r*s + 156*D1**2*f*fd*r - 120*D1**2*f*fd*s**2 + 156*D1**2*f*fd*s - 78*D1**2*f*fd + 72*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s - 96*D1**2*f*fdd*r + 72*D1**2*f*fdd*s**2 - 96*D1**2*f*fdd*s + 48*D1**2*f*fdd + 72*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s - 96*D1**2*fd**2*r + 72*D1**2*fd**2*s**2 - 96*D1**2*fd**2*s + 24*D1**2*fd**2 - 22*D1**2*fd*r**2 - 44*D1**2*fd*r*s - 32*D1**2*fd*r - 22*D1**2*fd*s**2 - 32*D1**2*fd*s + 16*D1**2*fd + 11*D1**2*fdd*r**2 + 22*D1**2*fdd*r*s + 2*D1**2*fdd*r + 11*D1**2*fdd*s**2 + 2*D1**2*fdd*s - D1**2*fdd - 28*D1**2*gd2*r**2 - 56*D1**2*gd2*r*s + 56*D1**2*gd2*r - 28*D1**2*gd2*s**2 + 56*D1**2*gd2*s - 28*D1**2*gd2 + 14*D1**2*gdd2*r**2 + 28*D1**2*gdd2*r*s - 28*D1**2*gdd2*r + 14*D1**2*gdd2*s**2 - 28*D1**2*gdd2*s + 14*D1**2*gdd2 + 40*D1*Dd*K*f*r**2 + 80*D1*Dd*K*f*r*s - 60*D1*Dd*K*f*r + 40*D1*Dd*K*f*s**2 - 60*D1*Dd*K*f*s + 30*D1*Dd*K*f - 40*D1*Dd*K*fd*r**2 - 80*D1*Dd*K*fd*r*s + 22*D1*Dd*K*fd*r - 40*D1*Dd*K*fd*s**2 + 22*D1*Dd*K*fd*s + 6*D1*Dd*K*fd - 240*D1*Dd*f**2*r**2 - 480*D1*Dd*f**2*r*s + 360*D1*Dd*f**2*r - 240*D1*Dd*f**2*s**2 + 360*D1*Dd*f**2*s - 180*D1*Dd*f**2 + 576*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 816*D1*Dd*f*fd*r + 576*D1*Dd*f*fd*s**2 - 816*D1*Dd*f*fd*s + 288*D1*Dd*f*fd - 88*D1*Dd*f*r**2 - 176*D1*Dd*f*r*s + 132*D1*Dd*f*r - 88*D1*Dd*f*s**2 + 132*D1*Dd*f*s - 66*D1*Dd*f + 88*D1*Dd*fd*r**2 + 176*D1*Dd*fd*r*s - 58*D1*Dd*fd*r + 88*D1*Dd*fd*s**2 - 58*D1*Dd*fd*s - 6*D1*Dd*fd - 112*D1*Dd*g2*r**2 - 224*D1*Dd*g2*r*s + 168*D1*Dd*g2*r - 112*D1*Dd*g2*s**2 + 168*D1*Dd*g2*s - 84*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 + 224*D1*Dd*gd2*r*s - 196*D1*Dd*gd2*r + 112*D1*Dd*gd2*s**2 - 196*D1*Dd*gd2*s + 84*D1*Dd*gd2 - 20*D1*Ddd*K*f*r**2 - 40*D1*Ddd*K*f*r*s + 30*D1*Ddd*K*f*r - 20*D1*Ddd*K*f*s**2 + 30*D1*Ddd*K*f*s - 15*D1*Ddd*K*f + 144*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 216*D1*Ddd*f**2*r + 144*D1*Ddd*f**2*s**2 - 216*D1*Ddd*f**2*s + 108*D1*Ddd*f**2 + 44*D1*Ddd*f*r**2 + 88*D1*Ddd*f*r*s - 66*D1*Ddd*f*r + 44*D1*Ddd*f*s**2 - 66*D1*Ddd*f*s + 33*D1*Ddd*f + 56*D1*Ddd*g2*r**2 + 112*D1*Ddd*g2*r*s - 84*D1*Ddd*g2*r + 56*D1*Ddd*g2*s**2 - 84*D1*Ddd*g2*s + 42*D1*Ddd*g2 + 2*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (7*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(7*K + 6*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 60*Dd**2*K*f*r**2 - 120*Dd**2*K*f*r*s + 90*Dd**2*K*f*r - 60*Dd**2*K*f*s**2 + 90*Dd**2*K*f*s - 30*Dd**2*K*f + 432*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 648*Dd**2*f**2*r + 432*Dd**2*f**2*s**2 - 648*Dd**2*f**2*s + 216*Dd**2*f**2 + 132*Dd**2*f*r**2 + 264*Dd**2*f*r*s - 198*Dd**2*f*r + 132*Dd**2*f*s**2 - 198*Dd**2*f*s + 66*Dd**2*f + 168*Dd**2*g2*r**2 + 336*Dd**2*g2*r*s - 252*Dd**2*g2*r + 168*Dd**2*g2*s**2 - 252*Dd**2*g2*s + 84*Dd**2*g2) + b1*(-220*C*D1**2*f*fd*r**2 - 440*C*D1**2*f*fd*r*s + 176*C*D1**2*f*fd*r - 220*C*D1**2*f*fd*s**2 + 176*C*D1**2*f*fd*s - 88*C*D1**2*f*fd - 440*C*D1*Dd*f**2*r**2 - 880*C*D1*Dd*f**2*r*s + 660*C*D1*Dd*f**2*r - 440*C*D1*Dd*f**2*s**2 + 660*C*D1*Dd*f**2*s - 330*C*D1*Dd*f**2 - 110*D1**2*K*bdd1*f*r**2 - 220*D1**2*K*bdd1*f*r*s + 242*D1**2*K*bdd1*f*r - 110*D1**2*K*bdd1*f*s**2 + 242*D1**2*K*bdd1*f*s - 121*D1**2*K*bdd1*f + 264*D1**2*K*f*fd*r**2 + 528*D1**2*K*f*fd*r*s - 264*D1**2*K*f*fd*r + 264*D1**2*K*f*fd*s**2 - 264*D1**2*K*f*fd*s + 132*D1**2*K*f*fd - 132*D1**2*K*f*fdd*r**2 - 264*D1**2*K*f*fdd*r*s + 132*D1**2*K*f*fdd*r - 132*D1**2*K*f*fdd*s**2 + 132*D1**2*K*f*fdd*s - 66*D1**2*K*f*fdd - 132*D1**2*K*fd**2*r**2 - 264*D1**2*K*fd**2*r*s + 132*D1**2*K*fd**2*r - 132*D1**2*K*fd**2*s**2 + 132*D1**2*K*fd**2*s + 132*D1**2*b2*fd*r**2 + 264*D1**2*b2*fd*r*s + 132*D1**2*b2*fd*s**2 - 66*D1**2*b2*fdd*r**2 - 132*D1**2*b2*fdd*r*s - 66*D1**2*b2*fdd*s**2 - 22*D1**2*bd1**2*(7*K + 6*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 792*D1**2*bdd1*f**2*r**2 + 1584*D1**2*bdd1*f**2*r*s - 1320*D1**2*bdd1*f**2*r + 792*D1**2*bdd1*f**2*s**2 - 1320*D1**2*bdd1*f**2*s + 660*D1**2*bdd1*f**2 + 242*D1**2*bdd1*f*r**2 + 484*D1**2*bdd1*f*r*s - 506*D1**2*bdd1*f*r + 242*D1**2*bdd1*f*s**2 - 506*D1**2*bdd1*f*s + 253*D1**2*bdd1*f + 308*D1**2*bdd1*g2*r**2 + 616*D1**2*bdd1*g2*r*s - 308*D1**2*bdd1*g2*r + 308*D1**2*bdd1*g2*s**2 - 308*D1**2*bdd1*g2*s + 154*D1**2*bdd1*g2 - 66*D1**2*bdd2*f*r**2 - 132*D1**2*bdd2*f*r*s + 132*D1**2*bdd2*f*r - 66*D1**2*bdd2*f*s**2 + 132*D1**2*bdd2*f*s - 66*D1**2*bdd2*f - 1704*D1**2*f**2*fd*r**2 - 3408*D1**2*f**2*fd*r*s + 2740*D1**2*f**2*fd*r - 1704*D1**2*f**2*fd*s**2 + 2740*D1**2*f**2*fd*s - 1370*D1**2*f**2*fd + 1050*D1**2*f**2*fdd*r**2 + 2100*D1**2*f**2*fdd*r*s - 1700*D1**2*f**2*fdd*r + 1050*D1**2*f**2*fdd*s**2 - 1700*D1**2*f**2*fdd*s + 850*D1**2*f**2*fdd + 2100*D1**2*f*fd**2*r**2 + 4200*D1**2*f*fd**2*r*s - 3400*D1**2*f*fd**2*r + 2100*D1**2*f*fd**2*s**2 - 3400*D1**2*f*fd**2*s + 1300*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 308*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 308*D1**2*f*fd*s - 154*D1**2*f*fd + 264*D1**2*f*fdd*r**2 + 528*D1**2*f*fdd*r*s - 264*D1**2*f*fdd*r + 264*D1**2*f*fdd*s**2 - 264*D1**2*f*fdd*s + 132*D1**2*f*fdd - 220*D1**2*f*gd2*r**2 - 440*D1**2*f*gd2*r*s + 440*D1**2*f*gd2*r - 220*D1**2*f*gd2*s**2 + 440*D1**2*f*gd2*s - 220*D1**2*f*gd2 + 110*D1**2*f*gdd2*r**2 + 220*D1**2*f*gdd2*r*s - 220*D1**2*f*gdd2*r + 110*D1**2*f*gdd2*s**2 - 220*D1**2*f*gdd2*s + 110*D1**2*f*gdd2 + 264*D1**2*fd**2*r**2 + 528*D1**2*fd**2*r*s - 264*D1**2*fd**2*r + 264*D1**2*fd**2*s**2 - 264*D1**2*fd**2*s - 220*D1**2*fd*g2*r**2 - 440*D1**2*fd*g2*r*s - 88*D1**2*fd*g2*r - 220*D1**2*fd*g2*s**2 - 88*D1**2*fd*g2*s + 44*D1**2*fd*g2 + 220*D1**2*fd*gd2*r**2 + 440*D1**2*fd*gd2*r*s - 176*D1**2*fd*gd2*r + 220*D1**2*fd*gd2*s**2 - 176*D1**2*fd*gd2*s - 44*D1**2*fd*gd2 + 110*D1**2*fdd*g2*r**2 + 220*D1**2*fdd*g2*r*s + 44*D1**2*fdd*g2*r + 110*D1**2*fdd*g2*s**2 + 44*D1**2*fdd*g2*s - 22*D1**2*fdd*g2 + 528*D1*Dd*K*f**2*r**2 + 1056*D1*Dd*K*f**2*r*s - 792*D1*Dd*K*f**2*r + 528*D1*Dd*K*f**2*s**2 - 792*D1*Dd*K*f**2*s + 396*D1*Dd*K*f**2 - 1056*D1*Dd*K*f*fd*r**2 - 2112*D1*Dd*K*f*fd*r*s + 1320*D1*Dd*K*f*fd*r - 1056*D1*Dd*K*f*fd*s**2 + 1320*D1*Dd*K*f*fd*s - 396*D1*Dd*K*f*fd + 528*D1*Dd*b2*f*r**2 + 1056*D1*Dd*b2*f*r*s - 792*D1*Dd*b2*f*r + 528*D1*Dd*b2*f*s**2 - 792*D1*Dd*b2*f*s + 396*D1*Dd*b2*f - 528*D1*Dd*b2*fd*r**2 - 1056*D1*Dd*b2*fd*r*s + 396*D1*Dd*b2*fd*r - 528*D1*Dd*b2*fd*s**2 + 396*D1*Dd*b2*fd*s - 2272*D1*Dd*f**3*r**2 - 4544*D1*Dd*f**3*r*s + 3408*D1*Dd*f**3*r - 2272*D1*Dd*f**3*s**2 + 3408*D1*Dd*f**3*s - 1704*D1*Dd*f**3 + 8400*D1*Dd*f**2*fd*r**2 + 16800*D1*Dd*f**2*fd*r*s - 13100*D1*Dd*f**2*fd*r + 8400*D1*Dd*f**2*fd*s**2 - 13100*D1*Dd*f**2*fd*s + 5100*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 2112*D1*Dd*f*fd*r**2 + 4224*D1*Dd*f*fd*r*s - 2640*D1*Dd*f*fd*r + 2112*D1*Dd*f*fd*s**2 - 2640*D1*Dd*f*fd*s + 792*D1*Dd*f*fd - 880*D1*Dd*f*g2*r**2 - 1760*D1*Dd*f*g2*r*s + 1320*D1*Dd*f*g2*r - 880*D1*Dd*f*g2*s**2 + 1320*D1*Dd*f*g2*s - 660*D1*Dd*f*g2 + 880*D1*Dd*f*gd2*r**2 + 1760*D1*Dd*f*gd2*r*s - 1540*D1*Dd*f*gd2*r + 880*D1*Dd*f*gd2*s**2 - 1540*D1*Dd*f*gd2*s + 660*D1*Dd*f*gd2 + 880*D1*Dd*fd*g2*r**2 + 1760*D1*Dd*fd*g2*r*s - 484*D1*Dd*fd*g2*r + 880*D1*Dd*fd*g2*s**2 - 484*D1*Dd*fd*g2*s - 132*D1*Dd*fd*g2 - 264*D1*Ddd*K*f**2*r**2 - 528*D1*Ddd*K*f**2*r*s + 396*D1*Ddd*K*f**2*r - 264*D1*Ddd*K*f**2*s**2 + 396*D1*Ddd*K*f**2*s - 198*D1*Ddd*K*f**2 - 264*D1*Ddd*b2*f*r**2 - 528*D1*Ddd*b2*f*r*s + 396*D1*Ddd*b2*f*r - 264*D1*Ddd*b2*f*s**2 + 396*D1*Ddd*b2*f*s - 198*D1*Ddd*b2*f + 1400*D1*Ddd*f**3*r**2 + 2800*D1*Ddd*f**3*r*s - 2100*D1*Ddd*f**3*r + 1400*D1*Ddd*f**3*s**2 - 2100*D1*Ddd*f**3*s + 1050*D1*Ddd*f**3 + 528*D1*Ddd*f**2*r**2 + 1056*D1*Ddd*f**2*r*s - 792*D1*Ddd*f**2*r + 528*D1*Ddd*f**2*s**2 - 792*D1*Ddd*f**2*s + 396*D1*Ddd*f**2 + 440*D1*Ddd*f*g2*r**2 + 880*D1*Ddd*f*g2*r*s - 660*D1*Ddd*f*g2*r + 440*D1*Ddd*f*g2*s**2 - 660*D1*Ddd*f*g2*s + 330*D1*Ddd*f*g2 - 22*D1*bd1*(D1*(3*f**2*(20*r**2 + r*(40*s - 34) + 20*s**2 - 34*s + 17) + f*(7*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*K*r**2 - 20*K*r*s + 22*K*r - 10*K*s**2 + 22*K*s - 11*K - 72*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 22*r**2 + 44*r*s - 60*r + 22*s**2 - 60*s + 30) + fd*(r + s - 1)*(10*K*r + 10*K*s + K - 22*r - 22*s - 1) + 14*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - Dd*(4*r + 4*s - 3)*(12*f**2*(6*r + 6*s - 5) + f*(K*(-10*r - 10*s + 11) + 22*r + 22*s - 23) + 14*g2*(2*r + 2*s - 1))) + 132*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 792*Dd**2*K*f**2*r**2 - 1584*Dd**2*K*f**2*r*s + 1188*Dd**2*K*f**2*r - 792*Dd**2*K*f**2*s**2 + 1188*Dd**2*K*f**2*s - 396*Dd**2*K*f**2 - 792*Dd**2*b2*f*r**2 - 1584*Dd**2*b2*f*r*s + 1188*Dd**2*b2*f*r - 792*Dd**2*b2*f*s**2 + 1188*Dd**2*b2*f*s - 396*Dd**2*b2*f + 4200*Dd**2*f**3*r**2 + 8400*Dd**2*f**3*r*s - 6300*Dd**2*f**3*r + 4200*Dd**2*f**3*s**2 - 6300*Dd**2*f**3*s + 2100*Dd**2*f**3 + 1584*Dd**2*f**2*r**2 + 3168*Dd**2*f**2*r*s - 2376*Dd**2*f**2*r + 1584*Dd**2*f**2*s**2 - 2376*Dd**2*f**2*s + 792*Dd**2*f**2 + 1320*Dd**2*f*g2*r**2 + 2640*Dd**2*f*g2*r*s - 1980*Dd**2*f*g2*r + 1320*Dd**2*f*g2*s**2 - 1980*Dd**2*f*g2*s + 660*Dd**2*f*g2) + 66*b2*(-D1**2*bdd1*f*(r + s - 1)**2 + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd*s - 6*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 2*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2))/(462*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct**2*k2**2*st**2*(-D1*f*(r + s)*(12*D1*bd1**2*(C - 1)*(r + s - 1) + 6*D1*bdd1*f*(C - 1)*(r + s) + bd1*(-D1*f*(12*C - 11)*(r + s) + D1*fd*(24*C - 24)*(r + s - 1) + Dd*f*(12*C - 12)*(4*r + 4*s - 3))) + b1**2*(D1**2*(fd*(12*C - 19) - fdd*(6*C - 6))*(r + s - 1)**2 + D1*(Dd*(f*(12*C - 19)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(12 - 12*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(6 - 6*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(36*C - 36)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(24*C*D1**2*f*fd*r**2 + 48*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*r + 24*C*D1**2*f*fd*s**2 - 48*C*D1**2*f*fd*s + 24*C*D1**2*f*fd - 12*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s**2 + 24*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 12*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s**2 + 24*C*D1**2*fd**2*s - 12*C*D1**2*fd**2 + 48*C*D1*Dd*f**2*r**2 + 96*C*D1*Dd*f**2*r*s - 72*C*D1*Dd*f**2*r + 48*C*D1*Dd*f**2*s**2 - 72*C*D1*Dd*f**2*s + 36*C*D1*Dd*f**2 - 96*C*D1*Dd*f*fd*r**2 - 192*C*D1*Dd*f*fd*r*s + 168*C*D1*Dd*f*fd*r - 96*C*D1*Dd*f*fd*s**2 + 168*C*D1*Dd*f*fd*s - 72*C*D1*Dd*f*fd - 24*C*D1*Ddd*f**2*r**2 - 48*C*D1*Ddd*f**2*r*s + 36*C*D1*Ddd*f**2*r - 24*C*D1*Ddd*f**2*s**2 + 36*C*D1*Ddd*f**2*s - 18*C*D1*Ddd*f**2 - 72*C*Dd**2*f**2*r**2 - 144*C*Dd**2*f**2*r*s + 108*C*Dd**2*f**2*r - 72*C*Dd**2*f**2*s**2 + 108*C*Dd**2*f**2*s - 36*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(C - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 22*D1**2*f*fd*r**2 - 44*D1**2*f*fd*r*s + 44*D1**2*f*fd*r - 22*D1**2*f*fd*s**2 + 44*D1**2*f*fd*s - 22*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s - 24*D1**2*f*fdd*r + 12*D1**2*f*fdd*s**2 - 24*D1**2*f*fdd*s + 12*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 24*D1**2*fd**2*r + 12*D1**2*fd**2*s**2 - 24*D1**2*fd**2*s + 12*D1**2*fd**2 - 44*D1*Dd*f**2*r**2 - 88*D1*Dd*f**2*r*s + 66*D1*Dd*f**2*r - 44*D1*Dd*f**2*s**2 + 66*D1*Dd*f**2*s - 33*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s - 168*D1*Dd*f*fd*r + 96*D1*Dd*f*fd*s**2 - 168*D1*Dd*f*fd*s + 72*D1*Dd*f*fd + 24*D1*Ddd*f**2*r**2 + 48*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + D1*bd1*(D1*(f*(12*C - 19)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(12 - 12*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(12 - 12*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 72*Dd**2*f**2*r**2 + 144*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 72*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 36*Dd**2*f**2))/(21*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct**2*k2**2*(-2*D1*(r + s)*(-2*D1*bd1**2*(5*f**2 - 3*f*(K - 2) + 7*g2)*(r + s - 1) - 6*D1*bdd1*f*g2*(r + s) + b2*(7*D1*bd1**2*(r + s - 1) + 3*D1*bdd1*f*(r + s) + 6*bd1*(-D1*f*(r + s) + D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + 3*bd1*(2*D1*bd2*f*(r + s - 1) + D1*(-4*f*gd2*(r + s - 1) + f*(r + s)*(f*(2*C - 1) + 4*g2) - 4*fd*g2*(r + s - 1)) - 4*Dd*f*g2*(4*r + 4*s - 3))) + b1**3*(-2*D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(-2*Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (7*K - 14)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + Ddd*(-7*K + 12*f + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(-7*K + 12*f + 14)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-14*C*D1**2*fd*r**2 - 28*C*D1**2*fd*r*s + 28*C*D1**2*fd*r - 14*C*D1**2*fd*s**2 + 28*C*D1**2*fd*s - 14*C*D1**2*fd - 56*C*D1*Dd*f*r**2 - 112*C*D1*Dd*f*r*s + 84*C*D1*Dd*f*r - 56*C*D1*Dd*f*s**2 + 84*C*D1*Dd*f*s - 42*C*D1*Dd*f - 21*D1**2*K*bdd1*r**2 - 42*D1**2*K*bdd1*r*s + 28*D1**2*K*bdd1*r - 21*D1**2*K*bdd1*s**2 + 28*D1**2*K*bdd1*s - 14*D1**2*K*bdd1 + 12*D1**2*K*fd*r**2 + 24*D1**2*K*fd*r*s - 24*D1**2*K*fd*r + 12*D1**2*K*fd*s**2 - 24*D1**2*K*fd*s + 12*D1**2*K*fd - 6*D1**2*K*fdd*r**2 - 12*D1**2*K*fdd*r*s + 12*D1**2*K*fdd*r - 6*D1**2*K*fdd*s**2 + 12*D1**2*K*fdd*s - 6*D1**2*K*fdd + 36*D1**2*bdd1*f*r**2 + 72*D1**2*bdd1*f*r*s - 48*D1**2*bdd1*f*r + 36*D1**2*bdd1*f*s**2 - 48*D1**2*bdd1*f*s + 24*D1**2*bdd1*f + 42*D1**2*bdd1*r**2 + 84*D1**2*bdd1*r*s - 56*D1**2*bdd1*r + 42*D1**2*bdd1*s**2 - 56*D1**2*bdd1*s + 28*D1**2*bdd1 - 7*D1**2*bdd2*r**2 - 14*D1**2*bdd2*r*s + 14*D1**2*bdd2*r - 7*D1**2*bdd2*s**2 + 14*D1**2*bdd2*s - 7*D1**2*bdd2 - 16*D1**2*f*fd*r**2 - 32*D1**2*f*fd*r*s + 32*D1**2*f*fd*r - 16*D1**2*f*fd*s**2 + 32*D1**2*f*fd*s - 16*D1**2*f*fd + 20*D1**2*f*fdd*r**2 + 40*D1**2*f*fdd*r*s - 40*D1**2*f*fdd*r + 20*D1**2*f*fdd*s**2 - 40*D1**2*f*fdd*s + 20*D1**2*f*fdd + 20*D1**2*fd**2*r**2 + 40*D1**2*fd**2*r*s - 40*D1**2*fd**2*r + 20*D1**2*fd**2*s**2 - 40*D1**2*fd**2*s + 20*D1**2*fd**2 - 3*D1**2*fd*r**2 - 6*D1**2*fd*r*s + 6*D1**2*fd*r - 3*D1**2*fd*s**2 + 6*D1**2*fd*s - 3*D1**2*fd + 12*D1**2*fdd*r**2 + 24*D1**2*fdd*r*s - 24*D1**2*fdd*r + 12*D1**2*fdd*s**2 - 24*D1**2*fdd*s + 12*D1**2*fdd - 28*D1**2*gd2*r**2 - 56*D1**2*gd2*r*s + 56*D1**2*gd2*r - 28*D1**2*gd2*s**2 + 56*D1**2*gd2*s - 28*D1**2*gd2 + 14*D1**2*gdd2*r**2 + 28*D1**2*gdd2*r*s - 28*D1**2*gdd2*r + 14*D1**2*gdd2*s**2 - 28*D1**2*gdd2*s + 14*D1**2*gdd2 + 48*D1*Dd*K*f*r**2 + 96*D1*Dd*K*f*r*s - 72*D1*Dd*K*f*r + 48*D1*Dd*K*f*s**2 - 72*D1*Dd*K*f*s + 36*D1*Dd*K*f - 48*D1*Dd*K*fd*r**2 - 96*D1*Dd*K*fd*r*s + 84*D1*Dd*K*fd*r - 48*D1*Dd*K*fd*s**2 + 84*D1*Dd*K*fd*s - 36*D1*Dd*K*fd + 56*D1*Dd*b2*r**2 + 112*D1*Dd*b2*r*s - 84*D1*Dd*b2*r + 56*D1*Dd*b2*s**2 - 84*D1*Dd*b2*s + 42*D1*Dd*b2 - 32*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 48*D1*Dd*f**2*r - 32*D1*Dd*f**2*s**2 + 48*D1*Dd*f**2*s - 24*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 + 320*D1*Dd*f*fd*r*s - 280*D1*Dd*f*fd*r + 160*D1*Dd*f*fd*s**2 - 280*D1*Dd*f*fd*s + 120*D1*Dd*f*fd - 12*D1*Dd*f*r**2 - 24*D1*Dd*f*r*s + 18*D1*Dd*f*r - 12*D1*Dd*f*s**2 + 18*D1*Dd*f*s - 9*D1*Dd*f + 96*D1*Dd*fd*r**2 + 192*D1*Dd*fd*r*s - 168*D1*Dd*fd*r + 96*D1*Dd*fd*s**2 - 168*D1*Dd*fd*s + 72*D1*Dd*fd - 112*D1*Dd*g2*r**2 - 224*D1*Dd*g2*r*s + 168*D1*Dd*g2*r - 112*D1*Dd*g2*s**2 + 168*D1*Dd*g2*s - 84*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 + 224*D1*Dd*gd2*r*s - 196*D1*Dd*gd2*r + 112*D1*Dd*gd2*s**2 - 196*D1*Dd*gd2*s + 84*D1*Dd*gd2 - 24*D1*Ddd*K*f*r**2 - 48*D1*Ddd*K*f*r*s + 36*D1*Ddd*K*f*r - 24*D1*Ddd*K*f*s**2 + 36*D1*Ddd*K*f*s - 18*D1*Ddd*K*f - 28*D1*Ddd*b2*r**2 - 56*D1*Ddd*b2*r*s + 42*D1*Ddd*b2*r - 28*D1*Ddd*b2*s**2 + 42*D1*Ddd*b2*s - 21*D1*Ddd*b2 + 40*D1*Ddd*f**2*r**2 + 80*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 60*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + 48*D1*Ddd*f*r**2 + 96*D1*Ddd*f*r*s - 72*D1*Ddd*f*r + 48*D1*Ddd*f*s**2 - 72*D1*Ddd*f*s + 36*D1*Ddd*f + 56*D1*Ddd*g2*r**2 + 112*D1*Ddd*g2*r*s - 84*D1*Ddd*g2*r + 56*D1*Ddd*g2*s**2 - 84*D1*Ddd*g2*s + 42*D1*Ddd*g2 - 2*D1*bd1*(D1*(5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (7*K - 14)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-7*K + 12*f + 14)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 72*Dd**2*K*f*r**2 - 144*Dd**2*K*f*r*s + 108*Dd**2*K*f*r - 72*Dd**2*K*f*s**2 + 108*Dd**2*K*f*s - 36*Dd**2*K*f - 84*Dd**2*b2*r**2 - 168*Dd**2*b2*r*s + 126*Dd**2*b2*r - 84*Dd**2*b2*s**2 + 126*Dd**2*b2*s - 42*Dd**2*b2 + 120*Dd**2*f**2*r**2 + 240*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 180*Dd**2*f**2*s + 60*Dd**2*f**2 + 144*Dd**2*f*r**2 + 288*Dd**2*f*r*s - 216*Dd**2*f*r + 144*Dd**2*f*s**2 - 216*Dd**2*f*s + 72*Dd**2*f + 168*Dd**2*g2*r**2 + 336*Dd**2*g2*r*s - 252*Dd**2*g2*r + 168*Dd**2*g2*s**2 - 252*Dd**2*g2*s + 84*Dd**2*g2) + b1*(2*D1**2*bd1**2*(-7*K + 12*f + 14)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(5*f**2 - 3*f*(K - 2) + 7*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*D1**2*bdd2*f*(r + s - 1)**2 + 12*D1**2*(r + s - 1)**2*(f*(-2*C*fd + fd - 2*gd2 + gdd2) - 2*fd*g2 + 2*fd*gd2 + fdd*g2) - 6*D1*Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4*f*(g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 4*fd*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 12*D1*Ddd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + D1*bd1*(-14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - D1*(8*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(14*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 40*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - (12*K - 3)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + 12*fd*(K - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 28*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 4*Dd*(5*f**2 - 3*f*(K - 2) + 7*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 12*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 72*Dd**2*f*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + b2*(-7*D1**2*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + 14*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 6*D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(21*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct*f*k1**3*k2**3*st**4*(-33*D1**2*bd1*f*(8*C - 5)*(r + s - 1)**2 - 33*D1*b1*(8*C - 5)*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - (64*C - 38)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**6) + 5*D1**2*Pk1*Pkdd3*ct*f*k2**7*st**6*(78*D1**2*b1*f*fd*r**2 + 156*D1**2*b1*f*fd*r*s - 104*D1**2*b1*f*fd*r + 78*D1**2*b1*f*fd*s**2 - 104*D1**2*b1*f*fd*s + 52*D1**2*b1*f*fd - 39*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*f*fdd*r*s + 52*D1**2*b1*f*fdd*r - 39*D1**2*b1*f*fdd*s**2 + 52*D1**2*b1*f*fdd*s - 26*D1**2*b1*f*fdd - 78*D1**2*b1*fd**2*r**2 - 156*D1**2*b1*fd**2*r*s + 104*D1**2*b1*fd**2*r - 78*D1**2*b1*fd**2*s**2 + 104*D1**2*b1*fd**2*s - 26*D1**2*b1*fd**2 - 13*D1**2*bdd1*f**2*(r + s - 1)**2 - 24*D1**2*f**2*fd*r**2 - 48*D1**2*f**2*fd*r*s + 36*D1**2*f**2*fd*r - 24*D1**2*f**2*fd*s**2 + 36*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 24*D1**2*f**2*fdd*r*s - 18*D1**2*f**2*fdd*r + 12*D1**2*f**2*fdd*s**2 - 18*D1**2*f**2*fdd*s + 9*D1**2*f**2*fdd + 36*D1**2*f*fd**2*r**2 + 72*D1**2*f*fd**2*r*s - 54*D1**2*f*fd**2*r + 36*D1**2*f*fd**2*s**2 - 54*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 + 104*D1*Dd*b1*f**2*r**2 + 208*D1*Dd*b1*f**2*r*s - 156*D1*Dd*b1*f**2*r + 104*D1*Dd*b1*f**2*s**2 - 156*D1*Dd*b1*f**2*s + 78*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 - 624*D1*Dd*b1*f*fd*r*s + 442*D1*Dd*b1*f*fd*r - 312*D1*Dd*b1*f*fd*s**2 + 442*D1*Dd*b1*f*fd*s - 156*D1*Dd*b1*f*fd - 24*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 36*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 192*D1*Dd*f**2*fd*r*s - 144*D1*Dd*f**2*fd*r + 96*D1*Dd*f**2*fd*s**2 - 144*D1*Dd*f**2*fd*s + 54*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 - 104*D1*Ddd*b1*f**2*r*s + 78*D1*Ddd*b1*f**2*r - 52*D1*Ddd*b1*f**2*s**2 + 78*D1*Ddd*b1*f**2*s - 39*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*r**2 + 24*D1*Ddd*f**3*r*s - 18*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 18*D1*Ddd*f**3*s + 9*D1*Ddd*f**3 + 26*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 156*Dd**2*b1*f**2*r**2 - 312*Dd**2*b1*f**2*r*s + 234*Dd**2*b1*f**2*r - 156*Dd**2*b1*f**2*s**2 + 234*Dd**2*b1*f**2*s - 78*Dd**2*b1*f**2 + 36*Dd**2*f**3*r**2 + 72*Dd**2*f**3*r*s - 54*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 54*Dd**2*f**3*s + 18*Dd**2*f**3)/(2574*d**2*k1*k3**6) + D1**2*Pk1*Pkdd3*ct*k1**5*k2*st**2*(-2376*C*D1**2*b1*f*fd*r**2 - 4752*C*D1**2*b1*f*fd*r*s + 2376*C*D1**2*b1*f*fd*r - 2376*C*D1**2*b1*f*fd*s**2 + 2376*C*D1**2*b1*f*fd*s - 1188*C*D1**2*b1*f*fd + 1848*C*D1**2*b1*f*fdd*r**2 + 3696*C*D1**2*b1*f*fdd*r*s - 1848*C*D1**2*b1*f*fdd*r + 1848*C*D1**2*b1*f*fdd*s**2 - 1848*C*D1**2*b1*f*fdd*s + 924*C*D1**2*b1*f*fdd + 1848*C*D1**2*b1*fd**2*r**2 + 3696*C*D1**2*b1*fd**2*r*s - 1848*C*D1**2*b1*fd**2*r + 1848*C*D1**2*b1*fd**2*s**2 - 1848*C*D1**2*b1*fd**2*s - 2220*C*D1**2*f**2*fd*r**2 - 4440*C*D1**2*f**2*fd*r*s + 2960*C*D1**2*f**2*fd*r - 2220*C*D1**2*f**2*fd*s**2 + 2960*C*D1**2*f**2*fd*s - 1480*C*D1**2*f**2*fd + 2100*C*D1**2*f**2*fdd*r**2 + 4200*C*D1**2*f**2*fdd*r*s - 2800*C*D1**2*f**2*fdd*r + 2100*C*D1**2*f**2*fdd*s**2 - 2800*C*D1**2*f**2*fdd*s + 1400*C*D1**2*f**2*fdd + 4200*C*D1**2*f*fd**2*r**2 + 8400*C*D1**2*f*fd**2*r*s - 5600*C*D1**2*f*fd**2*r + 4200*C*D1**2*f*fd**2*s**2 - 5600*C*D1**2*f*fd**2*s + 1400*C*D1**2*f*fd**2 - 4752*C*D1*Dd*b1*f**2*r**2 - 9504*C*D1*Dd*b1*f**2*r*s + 7128*C*D1*Dd*b1*f**2*r - 4752*C*D1*Dd*b1*f**2*s**2 + 7128*C*D1*Dd*b1*f**2*s - 3564*C*D1*Dd*b1*f**2 + 14784*C*D1*Dd*b1*f*fd*r**2 + 29568*C*D1*Dd*b1*f*fd*r*s - 18480*C*D1*Dd*b1*f*fd*r + 14784*C*D1*Dd*b1*f*fd*s**2 - 18480*C*D1*Dd*b1*f*fd*s + 5544*C*D1*Dd*b1*f*fd - 2960*C*D1*Dd*f**3*r**2 - 5920*C*D1*Dd*f**3*r*s + 4440*C*D1*Dd*f**3*r - 2960*C*D1*Dd*f**3*s**2 + 4440*C*D1*Dd*f**3*s - 2220*C*D1*Dd*f**3 + 16800*C*D1*Dd*f**2*fd*r**2 + 33600*C*D1*Dd*f**2*fd*r*s - 23800*C*D1*Dd*f**2*fd*r + 16800*C*D1*Dd*f**2*fd*s**2 - 23800*C*D1*Dd*f**2*fd*s + 8400*C*D1*Dd*f**2*fd + 3696*C*D1*Ddd*b1*f**2*r**2 + 7392*C*D1*Ddd*b1*f**2*r*s - 5544*C*D1*Ddd*b1*f**2*r + 3696*C*D1*Ddd*b1*f**2*s**2 - 5544*C*D1*Ddd*b1*f**2*s + 2772*C*D1*Ddd*b1*f**2 + 2800*C*D1*Ddd*f**3*r**2 + 5600*C*D1*Ddd*f**3*r*s - 4200*C*D1*Ddd*f**3*r + 2800*C*D1*Ddd*f**3*s**2 - 4200*C*D1*Ddd*f**3*s + 2100*C*D1*Ddd*f**3 + 11088*C*Dd**2*b1*f**2*r**2 + 22176*C*Dd**2*b1*f**2*r*s - 16632*C*Dd**2*b1*f**2*r + 11088*C*Dd**2*b1*f**2*s**2 - 16632*C*Dd**2*b1*f**2*s + 5544*C*Dd**2*b1*f**2 + 8400*C*Dd**2*f**3*r**2 + 16800*C*Dd**2*f**3*r*s - 12600*C*Dd**2*f**3*r + 8400*C*Dd**2*f**3*s**2 - 12600*C*Dd**2*f**3*s + 4200*C*Dd**2*f**3 + 1254*D1**2*b1*f*fd*r**2 + 2508*D1**2*b1*f*fd*r*s - 1254*D1**2*b1*f*fd*r + 1254*D1**2*b1*f*fd*s**2 - 1254*D1**2*b1*f*fd*s + 627*D1**2*b1*f*fd - 990*D1**2*b1*f*fdd*r**2 - 1980*D1**2*b1*f*fdd*r*s + 990*D1**2*b1*f*fdd*r - 990*D1**2*b1*f*fdd*s**2 + 990*D1**2*b1*f*fdd*s - 495*D1**2*b1*f*fdd - 990*D1**2*b1*fd**2*r**2 - 1980*D1**2*b1*fd**2*r*s + 990*D1**2*b1*fd**2*r - 990*D1**2*b1*fd**2*s**2 + 990*D1**2*b1*fd**2*s + 33*D1**2*bdd1*f**2*(28*C - 15)*(r + s - 1)**2 + 1161*D1**2*f**2*fd*r**2 + 2322*D1**2*f**2*fd*r*s - 1548*D1**2*f**2*fd*r + 1161*D1**2*f**2*fd*s**2 - 1548*D1**2*f**2*fd*s + 774*D1**2*f**2*fd - 1125*D1**2*f**2*fdd*r**2 - 2250*D1**2*f**2*fdd*r*s + 1500*D1**2*f**2*fdd*r - 1125*D1**2*f**2*fdd*s**2 + 1500*D1**2*f**2*fdd*s - 750*D1**2*f**2*fdd - 2250*D1**2*f*fd**2*r**2 - 4500*D1**2*f*fd**2*r*s + 3000*D1**2*f*fd**2*r - 2250*D1**2*f*fd**2*s**2 + 3000*D1**2*f*fd**2*s - 750*D1**2*f*fd**2 + 2508*D1*Dd*b1*f**2*r**2 + 5016*D1*Dd*b1*f**2*r*s - 3762*D1*Dd*b1*f**2*r + 2508*D1*Dd*b1*f**2*s**2 - 3762*D1*Dd*b1*f**2*s + 1881*D1*Dd*b1*f**2 - 7920*D1*Dd*b1*f*fd*r**2 - 15840*D1*Dd*b1*f*fd*r*s + 9900*D1*Dd*b1*f*fd*r - 7920*D1*Dd*b1*f*fd*s**2 + 9900*D1*Dd*b1*f*fd*s - 2970*D1*Dd*b1*f*fd + 1548*D1*Dd*f**3*r**2 + 3096*D1*Dd*f**3*r*s - 2322*D1*Dd*f**3*r + 1548*D1*Dd*f**3*s**2 - 2322*D1*Dd*f**3*s + 1161*D1*Dd*f**3 - 9000*D1*Dd*f**2*fd*r**2 - 18000*D1*Dd*f**2*fd*r*s + 12750*D1*Dd*f**2*fd*r - 9000*D1*Dd*f**2*fd*s**2 + 12750*D1*Dd*f**2*fd*s - 4500*D1*Dd*f**2*fd - 1980*D1*Ddd*b1*f**2*r**2 - 3960*D1*Ddd*b1*f**2*r*s + 2970*D1*Ddd*b1*f**2*r - 1980*D1*Ddd*b1*f**2*s**2 + 2970*D1*Ddd*b1*f**2*s - 1485*D1*Ddd*b1*f**2 - 1500*D1*Ddd*f**3*r**2 - 3000*D1*Ddd*f**3*r*s + 2250*D1*Ddd*f**3*r - 1500*D1*Ddd*f**3*s**2 + 2250*D1*Ddd*f**3*s - 1125*D1*Ddd*f**3 - 33*D1*bd1*f*(r + s - 1)*(D1*f*(36*C - 19)*(r + s - 1) - D1*fd*(56*C - 30)*(2*r + 2*s - 1) - Dd*f*(56*C - 30)*(4*r + 4*s - 3)) - 5940*Dd**2*b1*f**2*r**2 - 11880*Dd**2*b1*f**2*r*s + 8910*Dd**2*b1*f**2*r - 5940*Dd**2*b1*f**2*s**2 + 8910*Dd**2*b1*f**2*s - 2970*Dd**2*b1*f**2 - 4500*Dd**2*f**3*r**2 - 9000*Dd**2*f**3*r*s + 6750*Dd**2*f**3*r - 4500*Dd**2*f**3*s**2 + 6750*Dd**2*f**3*s - 2250*Dd**2*f**3)/(1386*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct*k1**5*k2*(-990*D1**2*K*bdd1*f**2*r**2 - 1980*D1**2*K*bdd1*f**2*r*s + 1980*D1**2*K*bdd1*f**2*r - 990*D1**2*K*bdd1*f**2*s**2 + 1980*D1**2*K*bdd1*f**2*s - 990*D1**2*K*bdd1*f**2 + 66*D1**2*bd1**2*f*(-36*K + 5*f + 6)*(r + s - 1)**2 + 140*D1**2*bdd1*f**3*r**2 + 280*D1**2*bdd1*f**3*r*s - 280*D1**2*bdd1*f**3*r + 140*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 140*D1**2*bdd1*f**3 + 165*D1**2*bdd1*f**2*r**2 + 330*D1**2*bdd1*f**2*r*s - 330*D1**2*bdd1*f**2*r + 165*D1**2*bdd1*f**2*s**2 - 330*D1**2*bdd1*f**2*s + 165*D1**2*bdd1*f**2 + 2376*D1**2*bdd1*f*g2*r**2 + 4752*D1**2*bdd1*f*g2*r*s - 4752*D1**2*bdd1*f*g2*r + 2376*D1**2*bdd1*f*g2*s**2 - 4752*D1**2*bdd1*f*g2*s + 2376*D1**2*bdd1*f*g2 - 1584*D1**2*f**2*gd2*r**2 - 3168*D1**2*f**2*gd2*r*s + 3168*D1**2*f**2*gd2*r - 1584*D1**2*f**2*gd2*s**2 + 3168*D1**2*f**2*gd2*s - 1584*D1**2*f**2*gd2 + 1980*D1**2*f**2*gdd2*r**2 + 3960*D1**2*f**2*gdd2*r*s - 3960*D1**2*f**2*gdd2*r + 1980*D1**2*f**2*gdd2*s**2 - 3960*D1**2*f**2*gdd2*s + 1980*D1**2*f**2*gdd2 - 3168*D1**2*f*fd*g2*r**2 - 6336*D1**2*f*fd*g2*r*s + 3168*D1**2*f*fd*g2*r - 3168*D1**2*f*fd*g2*s**2 + 3168*D1**2*f*fd*g2*s - 1584*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r**2 + 15840*D1**2*f*fd*gd2*r*s - 11880*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 11880*D1**2*f*fd*gd2*s + 3960*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r**2 + 7920*D1**2*f*fdd*g2*r*s - 3960*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r**2 + 7920*D1**2*fd**2*g2*r*s - 3960*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s - 6336*D1*Dd*f**2*g2*r**2 - 12672*D1*Dd*f**2*g2*r*s + 9504*D1*Dd*f**2*g2*r - 6336*D1*Dd*f**2*g2*s**2 + 9504*D1*Dd*f**2*g2*s - 4752*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r**2 + 31680*D1*Dd*f**2*gd2*r*s - 27720*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 27720*D1*Dd*f**2*gd2*s + 11880*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r**2 + 63360*D1*Dd*f*fd*g2*r*s - 39600*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 39600*D1*Dd*f*fd*g2*s + 11880*D1*Dd*f*fd*g2 + 7920*D1*Ddd*f**2*g2*r**2 + 15840*D1*Ddd*f**2*g2*r*s - 11880*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 11880*D1*Ddd*f**2*g2*s + 5940*D1*Ddd*f**2*g2 - D1*bd1*(D1*(115*f**3*(r + s - 1) - 4*f**2*(70*fd*(3*r + 3*s - 2) + (198*K - 33)*(r + s - 1)) + 66*f*(5*fd*(6*K - 1)*(2*r + 2*s - 1) + (30*g2 - 72*gd2)*(r + s - 1)) - 4752*fd*g2*(r + s)) - 2*Dd*f*(140*f**2 - 165*f*(6*K - 1) + 2376*g2)*(4*r + 4*s - 3))*(r + s - 1) + 23760*Dd**2*f**2*g2*r**2 + 47520*Dd**2*f**2*g2*r*s - 35640*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 35640*Dd**2*f**2*g2*s + 11880*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 5*fd*(6*K - 1)*(r + s) - 6*fdd*(6*K - 1)*(r + s))) + D1*(Dd*(4*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(2*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (6*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(6*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-36*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-36*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(1584*D1**2*K*f*fd*r**2 + 3168*D1**2*K*f*fd*r*s - 1584*D1**2*K*f*fd*r + 1584*D1**2*K*f*fd*s**2 - 1584*D1**2*K*f*fd*s + 792*D1**2*K*f*fd - 1980*D1**2*K*f*fdd*r**2 - 3960*D1**2*K*f*fdd*r*s + 1980*D1**2*K*f*fdd*r - 1980*D1**2*K*f*fdd*s**2 + 1980*D1**2*K*f*fdd*s - 990*D1**2*K*f*fdd - 1980*D1**2*K*fd**2*r**2 - 3960*D1**2*K*fd**2*r*s + 1980*D1**2*K*fd**2*r - 1980*D1**2*K*fd**2*s**2 + 1980*D1**2*K*fd**2*s + 66*D1**2*bdd1*f*(-36*K + 5*f + 6)*(r + s - 1)**2 - 345*D1**2*f**2*fd*r**2 - 690*D1**2*f**2*fd*r*s + 460*D1**2*f**2*fd*r - 345*D1**2*f**2*fd*s**2 + 460*D1**2*f**2*fd*s - 230*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd + 330*D1**2*f*fdd*r**2 + 660*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 330*D1**2*f*fdd*s**2 - 330*D1**2*f*fdd*s + 165*D1**2*f*fdd - 1980*D1**2*f*gd2*r**2 - 3960*D1**2*f*gd2*r*s + 3960*D1**2*f*gd2*r - 1980*D1**2*f*gd2*s**2 + 3960*D1**2*f*gd2*s - 1980*D1**2*f*gd2 + 2376*D1**2*f*gdd2*r**2 + 4752*D1**2*f*gdd2*r*s - 4752*D1**2*f*gdd2*r + 2376*D1**2*f*gdd2*s**2 - 4752*D1**2*f*gdd2*s + 2376*D1**2*f*gdd2 + 330*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 330*D1**2*fd**2*s**2 - 330*D1**2*fd**2*s - 1980*D1**2*fd*g2*r**2 - 3960*D1**2*fd*g2*r*s - 1980*D1**2*fd*g2*s**2 + 4752*D1**2*fd*gd2*r**2 + 9504*D1**2*fd*gd2*r*s - 4752*D1**2*fd*gd2*r + 4752*D1**2*fd*gd2*s**2 - 4752*D1**2*fd*gd2*s + 2376*D1**2*fdd*g2*r**2 + 4752*D1**2*fdd*g2*r*s + 2376*D1**2*fdd*g2*s**2 + 3168*D1*Dd*K*f**2*r**2 + 6336*D1*Dd*K*f**2*r*s - 4752*D1*Dd*K*f**2*r + 3168*D1*Dd*K*f**2*s**2 - 4752*D1*Dd*K*f**2*s + 2376*D1*Dd*K*f**2 - 15840*D1*Dd*K*f*fd*r**2 - 31680*D1*Dd*K*f*fd*r*s + 19800*D1*Dd*K*f*fd*r - 15840*D1*Dd*K*f*fd*s**2 + 19800*D1*Dd*K*f*fd*s - 5940*D1*Dd*K*f*fd - 460*D1*Dd*f**3*r**2 - 920*D1*Dd*f**3*r*s + 690*D1*Dd*f**3*r - 460*D1*Dd*f**3*s**2 + 690*D1*Dd*f**3*s - 345*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 + 5280*D1*Dd*f*fd*r*s - 3300*D1*Dd*f*fd*r + 2640*D1*Dd*f*fd*s**2 - 3300*D1*Dd*f*fd*s + 990*D1*Dd*f*fd - 7920*D1*Dd*f*g2*r**2 - 15840*D1*Dd*f*g2*r*s + 11880*D1*Dd*f*g2*r - 7920*D1*Dd*f*g2*s**2 + 11880*D1*Dd*f*g2*s - 5940*D1*Dd*f*g2 + 19008*D1*Dd*f*gd2*r**2 + 38016*D1*Dd*f*gd2*r*s - 33264*D1*Dd*f*gd2*r + 19008*D1*Dd*f*gd2*s**2 - 33264*D1*Dd*f*gd2*s + 14256*D1*Dd*f*gd2 + 19008*D1*Dd*fd*g2*r**2 + 38016*D1*Dd*fd*g2*r*s - 14256*D1*Dd*fd*g2*r + 19008*D1*Dd*fd*g2*s**2 - 14256*D1*Dd*fd*g2*s - 3960*D1*Ddd*K*f**2*r**2 - 7920*D1*Ddd*K*f**2*r*s + 5940*D1*Ddd*K*f**2*r - 3960*D1*Ddd*K*f**2*s**2 + 5940*D1*Ddd*K*f**2*s - 2970*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 + 1320*D1*Ddd*f**2*r*s - 990*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s**2 - 990*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 + 9504*D1*Ddd*f*g2*r**2 + 19008*D1*Ddd*f*g2*r*s - 14256*D1*Ddd*f*g2*r + 9504*D1*Ddd*f*g2*s**2 - 14256*D1*Ddd*f*g2*s + 7128*D1*Ddd*f*g2 - 66*D1*bd1*(D1*(4*f**2*(r + s - 1) - 5*f*(fd*(4*r + 4*s - 2) + (6*K - 1)*(r + s - 1)) + 12*fd*(6*K - 1)*(r + s)) - 2*Dd*f*(-36*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) - 11880*Dd**2*K*f**2*r**2 - 23760*Dd**2*K*f**2*r*s + 17820*Dd**2*K*f**2*r - 11880*Dd**2*K*f**2*s**2 + 17820*Dd**2*K*f**2*s - 5940*Dd**2*K*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 1980*Dd**2*f**2*r**2 + 3960*Dd**2*f**2*r*s - 2970*Dd**2*f**2*r + 1980*Dd**2*f**2*s**2 - 2970*Dd**2*f**2*s + 990*Dd**2*f**2 + 28512*Dd**2*f*g2*r**2 + 57024*Dd**2*f*g2*r*s - 42768*Dd**2*f*g2*r + 28512*Dd**2*f*g2*s**2 - 42768*Dd**2*f*g2*s + 14256*Dd**2*f*g2))/(693*d**2*k3**6) - D1**2*Pk1*Pkdd3*ct*k1**3*k2**3*st**2*(-20592*C*D1**2*f**2*fd*r**2 - 41184*C*D1**2*f**2*fd*r*s + 27456*C*D1**2*f**2*fd*r - 20592*C*D1**2*f**2*fd*s**2 + 27456*C*D1**2*f**2*fd*s - 13728*C*D1**2*f**2*fd - 27456*C*D1*Dd*f**3*r**2 - 54912*C*D1*Dd*f**3*r*s + 41184*C*D1*Dd*f**3*r - 27456*C*D1*Dd*f**3*s**2 + 41184*C*D1*Dd*f**3*s - 20592*C*D1*Dd*f**3 - 10296*D1**2*K*bdd1*f**2*r**2 - 20592*D1**2*K*bdd1*f**2*r*s + 20592*D1**2*K*bdd1*f**2*r - 10296*D1**2*K*bdd1*f**2*s**2 + 20592*D1**2*K*bdd1*f**2*s - 10296*D1**2*K*bdd1*f**2 + 5148*D1**2*bd1**2*f*(-4*K + 5*f + 1)*(r + s - 1)**2 + 4875*D1**2*bdd1*f**3*r**2 + 9750*D1**2*bdd1*f**3*r*s - 9750*D1**2*bdd1*f**3*r + 4875*D1**2*bdd1*f**3*s**2 - 9750*D1**2*bdd1*f**3*s + 4875*D1**2*bdd1*f**3 + 2574*D1**2*bdd1*f**2*r**2 + 5148*D1**2*bdd1*f**2*r*s - 5148*D1**2*bdd1*f**2*r + 2574*D1**2*bdd1*f**2*s**2 - 5148*D1**2*bdd1*f**2*s + 2574*D1**2*bdd1*f**2 + 20592*D1**2*bdd1*f*g2*r**2 + 41184*D1**2*bdd1*f*g2*r*s - 41184*D1**2*bdd1*f*g2*r + 20592*D1**2*bdd1*f*g2*s**2 - 41184*D1**2*bdd1*f*g2*s + 20592*D1**2*bdd1*f*g2 + 15100*D1**2*f**3*fd*r**2 + 30200*D1**2*f**3*fd*r*s - 22650*D1**2*f**3*fd*r + 15100*D1**2*f**3*fd*s**2 - 22650*D1**2*f**3*fd*s + 11325*D1**2*f**3*fd - 14700*D1**2*f**3*fdd*r**2 - 29400*D1**2*f**3*fdd*r*s + 22050*D1**2*f**3*fdd*r - 14700*D1**2*f**3*fdd*s**2 + 22050*D1**2*f**3*fdd*s - 11025*D1**2*f**3*fdd - 44100*D1**2*f**2*fd**2*r**2 - 88200*D1**2*f**2*fd**2*r*s + 66150*D1**2*f**2*fd**2*r - 44100*D1**2*f**2*fd**2*s**2 + 66150*D1**2*f**2*fd**2*s - 22050*D1**2*f**2*fd**2 + 11583*D1**2*f**2*fd*r**2 + 23166*D1**2*f**2*fd*r*s - 15444*D1**2*f**2*fd*r + 11583*D1**2*f**2*fd*s**2 - 15444*D1**2*f**2*fd*s + 7722*D1**2*f**2*fd - 37752*D1**2*f**2*gd2*r**2 - 75504*D1**2*f**2*gd2*r*s + 75504*D1**2*f**2*gd2*r - 37752*D1**2*f**2*gd2*s**2 + 75504*D1**2*f**2*gd2*s - 37752*D1**2*f**2*gd2 + 20592*D1**2*f**2*gdd2*r**2 + 41184*D1**2*f**2*gdd2*r*s - 41184*D1**2*f**2*gdd2*r + 20592*D1**2*f**2*gdd2*s**2 - 41184*D1**2*f**2*gdd2*s + 20592*D1**2*f**2*gdd2 - 75504*D1**2*f*fd*g2*r**2 - 151008*D1**2*f*fd*g2*r*s + 75504*D1**2*f*fd*g2*r - 75504*D1**2*f*fd*g2*s**2 + 75504*D1**2*f*fd*g2*s - 37752*D1**2*f*fd*g2 + 82368*D1**2*f*fd*gd2*r**2 + 164736*D1**2*f*fd*gd2*r*s - 123552*D1**2*f*fd*gd2*r + 82368*D1**2*f*fd*gd2*s**2 - 123552*D1**2*f*fd*gd2*s + 41184*D1**2*f*fd*gd2 + 41184*D1**2*f*fdd*g2*r**2 + 82368*D1**2*f*fdd*g2*r*s - 41184*D1**2*f*fdd*g2*r + 41184*D1**2*f*fdd*g2*s**2 - 41184*D1**2*f*fdd*g2*s + 20592*D1**2*f*fdd*g2 + 41184*D1**2*fd**2*g2*r**2 + 82368*D1**2*fd**2*g2*r*s - 41184*D1**2*fd**2*g2*r + 41184*D1**2*fd**2*g2*s**2 - 41184*D1**2*fd**2*g2*s + 15100*D1*Dd*f**4*r**2 + 30200*D1*Dd*f**4*r*s - 22650*D1*Dd*f**4*r + 15100*D1*Dd*f**4*s**2 - 22650*D1*Dd*f**4*s + 11325*D1*Dd*f**4 - 117600*D1*Dd*f**3*fd*r**2 - 235200*D1*Dd*f**3*fd*r*s + 176400*D1*Dd*f**3*fd*r - 117600*D1*Dd*f**3*fd*s**2 + 176400*D1*Dd*f**3*fd*s - 66150*D1*Dd*f**3*fd + 15444*D1*Dd*f**3*r**2 + 30888*D1*Dd*f**3*r*s - 23166*D1*Dd*f**3*r + 15444*D1*Dd*f**3*s**2 - 23166*D1*Dd*f**3*s + 11583*D1*Dd*f**3 - 151008*D1*Dd*f**2*g2*r**2 - 302016*D1*Dd*f**2*g2*r*s + 226512*D1*Dd*f**2*g2*r - 151008*D1*Dd*f**2*g2*s**2 + 226512*D1*Dd*f**2*g2*s - 113256*D1*Dd*f**2*g2 + 164736*D1*Dd*f**2*gd2*r**2 + 329472*D1*Dd*f**2*gd2*r*s - 288288*D1*Dd*f**2*gd2*r + 164736*D1*Dd*f**2*gd2*s**2 - 288288*D1*Dd*f**2*gd2*s + 123552*D1*Dd*f**2*gd2 + 329472*D1*Dd*f*fd*g2*r**2 + 658944*D1*Dd*f*fd*g2*r*s - 411840*D1*Dd*f*fd*g2*r + 329472*D1*Dd*f*fd*g2*s**2 - 411840*D1*Dd*f*fd*g2*s + 123552*D1*Dd*f*fd*g2 - 14700*D1*Ddd*f**4*r**2 - 29400*D1*Ddd*f**4*r*s + 22050*D1*Ddd*f**4*r - 14700*D1*Ddd*f**4*s**2 + 22050*D1*Ddd*f**4*s - 11025*D1*Ddd*f**4 + 82368*D1*Ddd*f**2*g2*r**2 + 164736*D1*Ddd*f**2*g2*r*s - 123552*D1*Ddd*f**2*g2*r + 82368*D1*Ddd*f**2*g2*s**2 - 123552*D1*Ddd*f**2*g2*s + 61776*D1*Ddd*f**2*g2 - 78*D1*bd1*(D1*(103*f**3*(r + s - 1) + f**2*(88*C*(r + s - 1) - 125*fd*(3*r + 3*s - 2) - (242*K - 11)*(r + s - 1)) + 22*f*(3*fd*(4*K - 1)*(2*r + 2*s - 1) + (38*g2 - 24*gd2)*(r + s - 1)) - 528*fd*g2*(r + s)) - Dd*f*(125*f**2 - 66*f*(4*K - 1) + 528*g2)*(4*r + 4*s - 3))*(r + s - 1) - 44100*Dd**2*f**4*r**2 - 88200*Dd**2*f**4*r*s + 66150*Dd**2*f**4*r - 44100*Dd**2*f**4*s**2 + 66150*Dd**2*f**4*s - 22050*Dd**2*f**4 + 247104*Dd**2*f**2*g2*r**2 + 494208*Dd**2*f**2*g2*r*s - 370656*Dd**2*f**2*g2*r + 247104*Dd**2*f**2*g2*s**2 - 370656*Dd**2*f**2*g2*s + 123552*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(15*f*(3*fd - 2*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(60*fd**2*(r + s - 1) + 19*fd*(4*K - 1)*(r + s) - 6*fdd*(4*K - 1)*(r + s))) + D1*(Dd*(45*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (76*K - 19)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(4*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-4*K + 5*f + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-4*K + 5*f + 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 39*b1*(352*C*D1**2*f*fd*r**2 + 704*C*D1**2*f*fd*r*s - 352*C*D1**2*f*fd*r + 352*C*D1**2*f*fd*s**2 - 352*C*D1**2*f*fd*s + 176*C*D1**2*f*fd + 704*C*D1*Dd*f**2*r**2 + 1408*C*D1*Dd*f**2*r*s - 1056*C*D1*Dd*f**2*r + 704*C*D1*Dd*f**2*s**2 - 1056*C*D1*Dd*f**2*s + 528*C*D1*Dd*f**2 - 968*D1**2*K*f*fd*r**2 - 1936*D1**2*K*f*fd*r*s + 968*D1**2*K*f*fd*r - 968*D1**2*K*f*fd*s**2 + 968*D1**2*K*f*fd*s - 484*D1**2*K*f*fd + 528*D1**2*K*f*fdd*r**2 + 1056*D1**2*K*f*fdd*r*s - 528*D1**2*K*f*fdd*r + 528*D1**2*K*f*fdd*s**2 - 528*D1**2*K*f*fdd*s + 264*D1**2*K*f*fdd + 528*D1**2*K*fd**2*r**2 + 1056*D1**2*K*fd**2*r*s - 528*D1**2*K*fd**2*r + 528*D1**2*K*fd**2*s**2 - 528*D1**2*K*fd**2*s - 132*D1**2*bdd1*f*(-4*K + 5*f + 1)*(r + s - 1)**2 + 618*D1**2*f**2*fd*r**2 + 1236*D1**2*f**2*fd*r*s - 824*D1**2*f**2*fd*r + 618*D1**2*f**2*fd*s**2 - 824*D1**2*f**2*fd*s + 412*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 750*D1**2*f**2*fdd*r*s + 500*D1**2*f**2*fdd*r - 375*D1**2*f**2*fdd*s**2 + 500*D1**2*f**2*fdd*s - 250*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 1500*D1**2*f*fd**2*r*s + 1000*D1**2*f*fd**2*r - 750*D1**2*f*fd**2*s**2 + 1000*D1**2*f*fd**2*s - 250*D1**2*f*fd**2 + 44*D1**2*f*fd*r**2 + 88*D1**2*f*fd*r*s - 44*D1**2*f*fd*r + 44*D1**2*f*fd*s**2 - 44*D1**2*f*fd*s + 22*D1**2*f*fd - 132*D1**2*f*fdd*r**2 - 264*D1**2*f*fdd*r*s + 132*D1**2*f*fdd*r - 132*D1**2*f*fdd*s**2 + 132*D1**2*f*fdd*s - 66*D1**2*f*fdd + 1672*D1**2*f*gd2*r**2 + 3344*D1**2*f*gd2*r*s - 3344*D1**2*f*gd2*r + 1672*D1**2*f*gd2*s**2 - 3344*D1**2*f*gd2*s + 1672*D1**2*f*gd2 - 528*D1**2*f*gdd2*r**2 - 1056*D1**2*f*gdd2*r*s + 1056*D1**2*f*gdd2*r - 528*D1**2*f*gdd2*s**2 + 1056*D1**2*f*gdd2*s - 528*D1**2*f*gdd2 - 132*D1**2*fd**2*r**2 - 264*D1**2*fd**2*r*s + 132*D1**2*fd**2*r - 132*D1**2*fd**2*s**2 + 132*D1**2*fd**2*s + 1672*D1**2*fd*g2*r**2 + 3344*D1**2*fd*g2*r*s + 1672*D1**2*fd*g2*s**2 - 1056*D1**2*fd*gd2*r**2 - 2112*D1**2*fd*gd2*r*s + 1056*D1**2*fd*gd2*r - 1056*D1**2*fd*gd2*s**2 + 1056*D1**2*fd*gd2*s - 528*D1**2*fdd*g2*r**2 - 1056*D1**2*fdd*g2*r*s - 528*D1**2*fdd*g2*s**2 - 1936*D1*Dd*K*f**2*r**2 - 3872*D1*Dd*K*f**2*r*s + 2904*D1*Dd*K*f**2*r - 1936*D1*Dd*K*f**2*s**2 + 2904*D1*Dd*K*f**2*s - 1452*D1*Dd*K*f**2 + 4224*D1*Dd*K*f*fd*r**2 + 8448*D1*Dd*K*f*fd*r*s - 5280*D1*Dd*K*f*fd*r + 4224*D1*Dd*K*f*fd*s**2 - 5280*D1*Dd*K*f*fd*s + 1584*D1*Dd*K*f*fd + 824*D1*Dd*f**3*r**2 + 1648*D1*Dd*f**3*r*s - 1236*D1*Dd*f**3*r + 824*D1*Dd*f**3*s**2 - 1236*D1*Dd*f**3*s + 618*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 6000*D1*Dd*f**2*fd*r*s + 4250*D1*Dd*f**2*fd*r - 3000*D1*Dd*f**2*fd*s**2 + 4250*D1*Dd*f**2*fd*s - 1500*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r**2 + 176*D1*Dd*f**2*r*s - 132*D1*Dd*f**2*r + 88*D1*Dd*f**2*s**2 - 132*D1*Dd*f**2*s + 66*D1*Dd*f**2 - 1056*D1*Dd*f*fd*r**2 - 2112*D1*Dd*f*fd*r*s + 1320*D1*Dd*f*fd*r - 1056*D1*Dd*f*fd*s**2 + 1320*D1*Dd*f*fd*s - 396*D1*Dd*f*fd + 6688*D1*Dd*f*g2*r**2 + 13376*D1*Dd*f*g2*r*s - 10032*D1*Dd*f*g2*r + 6688*D1*Dd*f*g2*s**2 - 10032*D1*Dd*f*g2*s + 5016*D1*Dd*f*g2 - 4224*D1*Dd*f*gd2*r**2 - 8448*D1*Dd*f*gd2*r*s + 7392*D1*Dd*f*gd2*r - 4224*D1*Dd*f*gd2*s**2 + 7392*D1*Dd*f*gd2*s - 3168*D1*Dd*f*gd2 - 4224*D1*Dd*fd*g2*r**2 - 8448*D1*Dd*fd*g2*r*s + 3168*D1*Dd*fd*g2*r - 4224*D1*Dd*fd*g2*s**2 + 3168*D1*Dd*fd*g2*s + 1056*D1*Ddd*K*f**2*r**2 + 2112*D1*Ddd*K*f**2*r*s - 1584*D1*Ddd*K*f**2*r + 1056*D1*Ddd*K*f**2*s**2 - 1584*D1*Ddd*K*f**2*s + 792*D1*Ddd*K*f**2 - 500*D1*Ddd*f**3*r**2 - 1000*D1*Ddd*f**3*r*s + 750*D1*Ddd*f**3*r - 500*D1*Ddd*f**3*s**2 + 750*D1*Ddd*f**3*s - 375*D1*Ddd*f**3 - 264*D1*Ddd*f**2*r**2 - 528*D1*Ddd*f**2*r*s + 396*D1*Ddd*f**2*r - 264*D1*Ddd*f**2*s**2 + 396*D1*Ddd*f**2*s - 198*D1*Ddd*f**2 - 2112*D1*Ddd*f*g2*r**2 - 4224*D1*Ddd*f*g2*r*s + 3168*D1*Ddd*f*g2*r - 2112*D1*Ddd*f*g2*s**2 + 3168*D1*Ddd*f*g2*s - 1584*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(45*f**2*(r + s - 1) - 60*f*fd*(2*r + 2*s - 1) - 19*f*(4*K - 1)*(r + s - 1) + 12*fd*(4*K - 1)*(r + s)) - 12*Dd*f*(-4*K + 5*f + 1)*(4*r + 4*s - 3))*(r + s - 1) + 3168*Dd**2*K*f**2*r**2 + 6336*Dd**2*K*f**2*r*s - 4752*Dd**2*K*f**2*r + 3168*Dd**2*K*f**2*s**2 - 4752*Dd**2*K*f**2*s + 1584*Dd**2*K*f**2 - 1500*Dd**2*f**3*r**2 - 3000*Dd**2*f**3*r*s + 2250*Dd**2*f**3*r - 1500*Dd**2*f**3*s**2 + 2250*Dd**2*f**3*s - 750*Dd**2*f**3 - 792*Dd**2*f**2*r**2 - 1584*Dd**2*f**2*r*s + 1188*Dd**2*f**2*r - 792*Dd**2*f**2*s**2 + 1188*Dd**2*f**2*s - 396*Dd**2*f**2 - 6336*Dd**2*f*g2*r**2 - 12672*Dd**2*f*g2*r*s + 9504*Dd**2*f*g2*r - 6336*Dd**2*f*g2*s**2 + 9504*Dd**2*f*g2*s - 3168*Dd**2*f*g2))/(18018*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct*k1**3*k2*st**2*(-33*b1**2*(D1**2*(fd*(88*C - 53) + fdd*(9 - 16*C))*(r + s - 1)**2 + D1*(Dd*(f*(88*C - 53)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(18 - 32*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(16*C - 9)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(96*C - 54)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-16*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s - 32*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 - 32*C*D1**2*f*fd*s + 16*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r**2 + 32*C*D1**2*f*fdd*r*s + 16*C*D1**2*f*fdd*r + 16*C*D1**2*f*fdd*s**2 + 16*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r**2 + 32*C*D1**2*fd**2*r*s + 16*C*D1**2*fd**2*r + 16*C*D1**2*fd**2*s**2 + 16*C*D1**2*fd**2*s - 32*C*D1**2*fd**2 - 32*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r**2 + 256*C*D1*Dd*f*fd*r*s - 32*C*D1*Dd*f*fd*r + 128*C*D1*Dd*f*fd*s**2 - 32*C*D1*Dd*f*fd*s - 48*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r**2 + 64*C*D1*Ddd*f**2*r*s - 48*C*D1*Ddd*f**2*r + 32*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 24*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r**2 + 192*C*Dd**2*f**2*r*s - 144*C*Dd**2*f**2*r + 96*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 - D1**2*bdd1*f*(16*C - 9)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s + 18*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s - 9*D1**2*f*fd - 8*D1**2*f*fdd*r**2 - 16*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r - 8*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 5*D1**2*f*fdd - 8*D1**2*fd**2*r**2 - 16*D1**2*fd**2*r*s - 10*D1**2*fd**2*r - 8*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s + 18*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 64*D1*Dd*f*fd*r**2 - 128*D1*Dd*f*fd*r*s + 8*D1*Dd*f*fd*r - 64*D1*Dd*f*fd*s**2 + 8*D1*Dd*f*fd*s + 30*D1*Dd*f*fd - 16*D1*Ddd*f**2*r**2 - 32*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r - 16*D1*Ddd*f**2*s**2 + 24*D1*Ddd*f**2*s - 12*D1*Ddd*f**2 + D1*bd1*(D1*(f*(88*C - 53)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(18 - 32*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(18 - 32*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 48*Dd**2*f**2*r**2 - 96*Dd**2*f**2*r*s + 72*Dd**2*f**2*r - 48*Dd**2*f**2*s**2 + 72*Dd**2*f**2*s - 24*Dd**2*f**2) + f*(2016*C*D1**2*f*fd*r**2 + 4032*C*D1**2*f*fd*r*s - 2688*C*D1**2*f*fd*r + 2016*C*D1**2*f*fd*s**2 - 2688*C*D1**2*f*fd*s + 1344*C*D1**2*f*fd - 1800*C*D1**2*f*fdd*r**2 - 3600*C*D1**2*f*fdd*r*s + 2400*C*D1**2*f*fdd*r - 1800*C*D1**2*f*fdd*s**2 + 2400*C*D1**2*f*fdd*s - 1200*C*D1**2*f*fdd - 3600*C*D1**2*fd**2*r**2 - 7200*C*D1**2*fd**2*r*s + 4800*C*D1**2*fd**2*r - 3600*C*D1**2*fd**2*s**2 + 4800*C*D1**2*fd**2*s - 1200*C*D1**2*fd**2 + 2688*C*D1*Dd*f**2*r**2 + 5376*C*D1*Dd*f**2*r*s - 4032*C*D1*Dd*f**2*r + 2688*C*D1*Dd*f**2*s**2 - 4032*C*D1*Dd*f**2*s + 2016*C*D1*Dd*f**2 - 14400*C*D1*Dd*f*fd*r**2 - 28800*C*D1*Dd*f*fd*r*s + 20400*C*D1*Dd*f*fd*r - 14400*C*D1*Dd*f*fd*s**2 + 20400*C*D1*Dd*f*fd*s - 7200*C*D1*Dd*f*fd - 2400*C*D1*Ddd*f**2*r**2 - 4800*C*D1*Ddd*f**2*r*s + 3600*C*D1*Ddd*f**2*r - 2400*C*D1*Ddd*f**2*s**2 + 3600*C*D1*Ddd*f**2*s - 1800*C*D1*Ddd*f**2 - 7200*C*Dd**2*f**2*r**2 - 14400*C*Dd**2*f**2*r*s + 10800*C*Dd**2*f**2*r - 7200*C*Dd**2*f**2*s**2 + 10800*C*Dd**2*f**2*s - 3600*C*Dd**2*f**2 + 66*D1**2*bd1**2*(16*C - 9)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 33*D1**2*bdd1*f*(8*C*(r**2 + 2*r*(s - 3) + s**2 - 6*s + 3) - 4*r**2 - 8*r*s + 26*r - 4*s**2 + 26*s - 13) - 1059*D1**2*f*fd*r**2 - 2118*D1**2*f*fd*r*s + 1412*D1**2*f*fd*r - 1059*D1**2*f*fd*s**2 + 1412*D1**2*f*fd*s - 706*D1**2*f*fd + 975*D1**2*f*fdd*r**2 + 1950*D1**2*f*fdd*r*s - 1300*D1**2*f*fdd*r + 975*D1**2*f*fdd*s**2 - 1300*D1**2*f*fdd*s + 650*D1**2*f*fdd + 1950*D1**2*fd**2*r**2 + 3900*D1**2*fd**2*r*s - 2600*D1**2*fd**2*r + 1950*D1**2*fd**2*s**2 - 2600*D1**2*fd**2*s + 650*D1**2*fd**2 - 1412*D1*Dd*f**2*r**2 - 2824*D1*Dd*f**2*r*s + 2118*D1*Dd*f**2*r - 1412*D1*Dd*f**2*s**2 + 2118*D1*Dd*f**2*s - 1059*D1*Dd*f**2 + 7800*D1*Dd*f*fd*r**2 + 15600*D1*Dd*f*fd*r*s - 11050*D1*Dd*f*fd*r + 7800*D1*Dd*f*fd*s**2 - 11050*D1*Dd*f*fd*s + 3900*D1*Dd*f*fd + 1300*D1*Ddd*f**2*r**2 + 2600*D1*Ddd*f**2*r*s - 1950*D1*Ddd*f**2*r + 1300*D1*Ddd*f**2*s**2 - 1950*D1*Ddd*f**2*s + 975*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f*(8*C*(r**2 + 2*r*(s - 4) + s**2 - 8*s + 4) - 4*r**2 - 8*r*s + 34*r - 4*s**2 + 34*s - 17) - 2*fd*(r + s - 1)*(8*C*(2*r + 2*s - 3) - 8*r - 8*s + 13)) - 2*Dd*f*(4*r + 4*s - 3)*(8*C*(r + s - 3) - 4*r - 4*s + 13)) + 3900*Dd**2*f**2*r**2 + 7800*Dd**2*f**2*r*s - 5850*Dd**2*f**2*r + 3900*Dd**2*f**2*s**2 - 5850*Dd**2*f**2*s + 1950*Dd**2*f**2))/(1386*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct*k1**3*k2*(1584*D1**2*K*bd1**2*f*r + 1584*D1**2*K*bd1**2*f*s - 1584*D1**2*K*bd1**2*f + 528*D1**2*K*bd1*f**2*r**2 + 1056*D1**2*K*bd1*f**2*r*s - 1056*D1**2*K*bd1*f**2*r + 528*D1**2*K*bd1*f**2*s**2 - 1056*D1**2*K*bd1*f**2*s + 528*D1**2*K*bd1*f**2 - 2640*D1**2*K*bd1*f*fd*r**2 - 5280*D1**2*K*bd1*f*fd*r*s + 3960*D1**2*K*bd1*f*fd*r - 2640*D1**2*K*bd1*f*fd*s**2 + 3960*D1**2*K*bd1*f*fd*s - 1320*D1**2*K*bd1*f*fd - 660*D1**2*K*bdd1*f**2*r**2 - 1320*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 660*D1**2*K*bdd1*f**2*s**2 + 1320*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 - 330*D1**2*bd1**2*f**2*r - 330*D1**2*bd1**2*f**2*s + 330*D1**2*bd1**2*f**2 - 396*D1**2*bd1**2*f*r - 396*D1**2*bd1**2*f*s + 396*D1**2*bd1**2*f - 3696*D1**2*bd1**2*g2*r**2 - 7392*D1**2*bd1**2*g2*r*s + 3696*D1**2*bd1**2*g2*r - 3696*D1**2*bd1**2*g2*s**2 + 3696*D1**2*bd1**2*g2*s - 1584*D1**2*bd1*bd2*f*r**2 - 3168*D1**2*bd1*bd2*f*r*s + 3168*D1**2*bd1*bd2*f*r - 1584*D1**2*bd1*bd2*f*s**2 + 3168*D1**2*bd1*bd2*f*s - 1584*D1**2*bd1*bd2*f - 115*D1**2*bd1*f**3*r**2 - 230*D1**2*bd1*f**3*r*s + 230*D1**2*bd1*f**3*r - 115*D1**2*bd1*f**3*s**2 + 230*D1**2*bd1*f**3*s - 115*D1**2*bd1*f**3 + 840*D1**2*bd1*f**2*fd*r**2 + 1680*D1**2*bd1*f**2*fd*r*s - 1400*D1**2*bd1*f**2*fd*r + 840*D1**2*bd1*f**2*fd*s**2 - 1400*D1**2*bd1*f**2*fd*s + 560*D1**2*bd1*f**2*fd - 132*D1**2*bd1*f**2*r**2 - 264*D1**2*bd1*f**2*r*s + 264*D1**2*bd1*f**2*r - 132*D1**2*bd1*f**2*s**2 + 264*D1**2*bd1*f**2*s - 132*D1**2*bd1*f**2 + 660*D1**2*bd1*f*fd*r**2 + 1320*D1**2*bd1*f*fd*r*s - 990*D1**2*bd1*f*fd*r + 660*D1**2*bd1*f*fd*s**2 - 990*D1**2*bd1*f*fd*s + 330*D1**2*bd1*f*fd + 2640*D1**2*bd1*f*g2*r + 2640*D1**2*bd1*f*g2*s - 1320*D1**2*bd1*f*g2 - 3168*D1**2*bd1*f*gd2*r - 3168*D1**2*bd1*f*gd2*s + 3168*D1**2*bd1*f*gd2 + 528*D1**2*bd2*f**2*r**2 + 1056*D1**2*bd2*f**2*r*s - 1056*D1**2*bd2*f**2*r + 528*D1**2*bd2*f**2*s**2 - 1056*D1**2*bd2*f**2*s + 528*D1**2*bd2*f**2 - 2640*D1**2*bd2*f*fd*r**2 - 5280*D1**2*bd2*f*fd*r*s + 3960*D1**2*bd2*f*fd*r - 2640*D1**2*bd2*f*fd*s**2 + 3960*D1**2*bd2*f*fd*s - 1320*D1**2*bd2*f*fd + 140*D1**2*bdd1*f**3*r**2 + 280*D1**2*bdd1*f**3*r*s - 280*D1**2*bdd1*f**3*r + 140*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s + 140*D1**2*bdd1*f**3 + 165*D1**2*bdd1*f**2*r**2 + 330*D1**2*bdd1*f**2*r*s - 330*D1**2*bdd1*f**2*r + 165*D1**2*bdd1*f**2*s**2 - 330*D1**2*bdd1*f**2*s + 165*D1**2*bdd1*f**2 - 3168*D1**2*bdd1*f*g2*r - 3168*D1**2*bdd1*f*g2*s + 1584*D1**2*bdd1*f*g2 - 660*D1**2*bdd2*f**2*r**2 - 1320*D1**2*bdd2*f**2*r*s + 1320*D1**2*bdd2*f**2*r - 660*D1**2*bdd2*f**2*s**2 + 1320*D1**2*bdd2*f**2*s - 660*D1**2*bdd2*f**2 - 1056*D1**2*f**2*gd2*r**2 - 2112*D1**2*f**2*gd2*r*s + 2112*D1**2*f**2*gd2*r - 1056*D1**2*f**2*gd2*s**2 + 2112*D1**2*f**2*gd2*s - 1056*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 - 2112*D1**2*f*fd*g2*r**2 - 4224*D1**2*f*fd*g2*r*s + 2112*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s**2 + 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s - 5280*D1*Dd*K*bd1*f**2*r**2 - 10560*D1*Dd*K*bd1*f**2*r*s + 9240*D1*Dd*K*bd1*f**2*r - 5280*D1*Dd*K*bd1*f**2*s**2 + 9240*D1*Dd*K*bd1*f**2*s - 3960*D1*Dd*K*bd1*f**2 + 1120*D1*Dd*bd1*f**3*r**2 + 2240*D1*Dd*bd1*f**3*r*s - 1960*D1*Dd*bd1*f**3*r + 1120*D1*Dd*bd1*f**3*s**2 - 1960*D1*Dd*bd1*f**3*s + 840*D1*Dd*bd1*f**3 + 1320*D1*Dd*bd1*f**2*r**2 + 2640*D1*Dd*bd1*f**2*r*s - 2310*D1*Dd*bd1*f**2*r + 1320*D1*Dd*bd1*f**2*s**2 - 2310*D1*Dd*bd1*f**2*s + 990*D1*Dd*bd1*f**2 - 12672*D1*Dd*bd1*f*g2*r - 12672*D1*Dd*bd1*f*g2*s + 9504*D1*Dd*bd1*f*g2 - 5280*D1*Dd*bd2*f**2*r**2 - 10560*D1*Dd*bd2*f**2*r*s + 9240*D1*Dd*bd2*f**2*r - 5280*D1*Dd*bd2*f**2*s**2 + 9240*D1*Dd*bd2*f**2*s - 3960*D1*Dd*bd2*f**2 - 4224*D1*Dd*f**2*g2*r**2 - 8448*D1*Dd*f**2*g2*r*s + 6336*D1*Dd*f**2*g2*r - 4224*D1*Dd*f**2*g2*s**2 + 6336*D1*Dd*f**2*g2*s - 3168*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2 + 33*b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(28*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-28*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-28*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(40*D1**2*K*fd*r + 40*D1**2*K*fd*s - 20*D1**2*K*fd - 48*D1**2*K*fdd*r - 48*D1**2*K*fdd*s + 24*D1**2*K*fdd - D1**2*bdd1*(-28*K + 6*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 8*D1**2*f*fd*r - 8*D1**2*f*fd*s + 4*D1**2*f*fd + 10*D1**2*f*fdd*r + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd + 10*D1**2*fd**2*r + 10*D1**2*fd**2*s - 10*D1**2*fd**2 - 10*D1**2*fd*r - 10*D1**2*fd*s + 5*D1**2*fd + 12*D1**2*fdd*r + 12*D1**2*fdd*s - 6*D1**2*fdd + 112*D1**2*gd2*r**2 + 224*D1**2*gd2*r*s - 224*D1**2*gd2*r + 112*D1**2*gd2*s**2 - 224*D1**2*gd2*s + 112*D1**2*gd2 - 56*D1**2*gdd2*r**2 - 112*D1**2*gdd2*r*s + 112*D1**2*gdd2*r - 56*D1**2*gdd2*s**2 + 112*D1**2*gdd2*s - 56*D1**2*gdd2 - 192*D1*Dd*K*fd*r - 192*D1*Dd*K*fd*s + 144*D1*Dd*K*fd + 40*D1*Dd*f*fd*r + 40*D1*Dd*f*fd*s - 30*D1*Dd*f*fd + 48*D1*Dd*fd*r + 48*D1*Dd*fd*s - 36*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 896*D1*Dd*g2*r*s - 672*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 672*D1*Dd*g2*s + 336*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 896*D1*Dd*gd2*r*s + 784*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 784*D1*Dd*gd2*s - 336*D1*Dd*gd2 - 224*D1*Ddd*g2*r**2 - 448*D1*Ddd*g2*r*s + 336*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 336*D1*Ddd*g2*s - 168*D1*Ddd*g2 + D1*bd1*(D1*(5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(28*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-28*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 672*Dd**2*g2*r**2 - 1344*Dd**2*g2*r*s + 1008*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 1008*Dd**2*g2*s - 336*Dd**2*g2) - b1*(-1584*D1**2*K*bdd1*f*r - 1584*D1**2*K*bdd1*f*s + 792*D1**2*K*bdd1*f - 1056*D1**2*K*f*fd*r**2 - 2112*D1**2*K*f*fd*r*s + 1056*D1**2*K*f*fd*r - 1056*D1**2*K*f*fd*s**2 + 1056*D1**2*K*f*fd*s - 528*D1**2*K*f*fd + 1320*D1**2*K*f*fdd*r**2 + 2640*D1**2*K*f*fdd*r*s - 1320*D1**2*K*f*fdd*r + 1320*D1**2*K*f*fdd*s**2 - 1320*D1**2*K*f*fdd*s + 660*D1**2*K*f*fdd + 1320*D1**2*K*fd**2*r**2 + 2640*D1**2*K*fd**2*r*s - 1320*D1**2*K*fd**2*r + 1320*D1**2*K*fd**2*s**2 - 1320*D1**2*K*fd**2*s - 660*D1**2*b2*fd*r**2 - 1320*D1**2*b2*fd*r*s - 660*D1**2*b2*fd*s**2 + 792*D1**2*b2*fdd*r**2 + 1584*D1**2*b2*fdd*r*s + 792*D1**2*b2*fdd*s**2 + 66*D1**2*bd1**2*(-28*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 330*D1**2*bdd1*f**2*r + 330*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*r + 396*D1**2*bdd1*f*s - 198*D1**2*bdd1*f + 3696*D1**2*bdd1*g2*r**2 + 7392*D1**2*bdd1*g2*r*s - 3696*D1**2*bdd1*g2*r + 3696*D1**2*bdd1*g2*s**2 - 3696*D1**2*bdd1*g2*s + 1848*D1**2*bdd1*g2 + 792*D1**2*bdd2*f*r**2 + 1584*D1**2*bdd2*f*r*s - 1584*D1**2*bdd2*f*r + 792*D1**2*bdd2*f*s**2 - 1584*D1**2*bdd2*f*s + 792*D1**2*bdd2*f + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 264*D1**2*f*fd*r**2 + 528*D1**2*f*fd*r*s - 264*D1**2*f*fd*r + 264*D1**2*f*fd*s**2 - 264*D1**2*f*fd*s + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 660*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r - 330*D1**2*f*fdd*s**2 + 330*D1**2*f*fdd*s - 165*D1**2*f*fdd - 330*D1**2*fd**2*r**2 - 660*D1**2*fd**2*r*s + 330*D1**2*fd**2*r - 330*D1**2*fd**2*s**2 + 330*D1**2*fd**2*s + 2640*D1**2*fd*g2*r + 2640*D1**2*fd*g2*s - 1320*D1**2*fd*g2 - 3168*D1**2*fd*gd2*r - 3168*D1**2*fd*gd2*s + 3168*D1**2*fd*gd2 - 3168*D1**2*fdd*g2*r - 3168*D1**2*fdd*g2*s + 1584*D1**2*fdd*g2 - 2112*D1*Dd*K*f**2*r**2 - 4224*D1*Dd*K*f**2*r*s + 3168*D1*Dd*K*f**2*r - 2112*D1*Dd*K*f**2*s**2 + 3168*D1*Dd*K*f**2*s - 1584*D1*Dd*K*f**2 + 10560*D1*Dd*K*f*fd*r**2 + 21120*D1*Dd*K*f*fd*r*s - 13200*D1*Dd*K*f*fd*r + 10560*D1*Dd*K*f*fd*s**2 - 13200*D1*Dd*K*f*fd*s + 3960*D1*Dd*K*f*fd - 2640*D1*Dd*b2*f*r**2 - 5280*D1*Dd*b2*f*r*s + 3960*D1*Dd*b2*f*r - 2640*D1*Dd*b2*f*s**2 + 3960*D1*Dd*b2*f*s - 1980*D1*Dd*b2*f + 6336*D1*Dd*b2*fd*r**2 + 12672*D1*Dd*b2*fd*r*s - 4752*D1*Dd*b2*fd*r + 6336*D1*Dd*b2*fd*s**2 - 4752*D1*Dd*b2*fd*s + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 690*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 690*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 + 1056*D1*Dd*f**2*r*s - 792*D1*Dd*f**2*r + 528*D1*Dd*f**2*s**2 - 792*D1*Dd*f**2*s + 396*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 5280*D1*Dd*f*fd*r*s + 3300*D1*Dd*f*fd*r - 2640*D1*Dd*f*fd*s**2 + 3300*D1*Dd*f*fd*s - 990*D1*Dd*f*fd - 12672*D1*Dd*fd*g2*r - 12672*D1*Dd*fd*g2*s + 9504*D1*Dd*fd*g2 + 2640*D1*Ddd*K*f**2*r**2 + 5280*D1*Ddd*K*f**2*r*s - 3960*D1*Ddd*K*f**2*r + 2640*D1*Ddd*K*f**2*s**2 - 3960*D1*Ddd*K*f**2*s + 1980*D1*Ddd*K*f**2 + 3168*D1*Ddd*b2*f*r**2 + 6336*D1*Ddd*b2*f*r*s - 4752*D1*Ddd*b2*f*r + 3168*D1*Ddd*b2*f*s**2 - 4752*D1*Ddd*b2*f*s + 2376*D1*Ddd*b2*f - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 - 1320*D1*Ddd*f**2*r*s + 990*D1*Ddd*f**2*r - 660*D1*Ddd*f**2*s**2 + 990*D1*Ddd*f**2*s - 495*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f**2*(8*r + 8*s - 4) - 5*f*(4*K - 1)*(2*r + 2*s - 1) - 12*fd*(4*K - 1)*(r + s - 1) + 112*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 112*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(5*f**2 + f*(6 - 24*K) + 56*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 132*D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 7920*Dd**2*K*f**2*r**2 + 15840*Dd**2*K*f**2*r*s - 11880*Dd**2*K*f**2*r + 7920*Dd**2*K*f**2*s**2 - 11880*Dd**2*K*f**2*s + 3960*Dd**2*K*f**2 + 9504*Dd**2*b2*f*r**2 + 19008*Dd**2*b2*f*r*s - 14256*Dd**2*b2*f*r + 9504*Dd**2*b2*f*s**2 - 14256*Dd**2*b2*f*s + 4752*Dd**2*b2*f - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 1980*Dd**2*f**2*r**2 - 3960*Dd**2*f**2*r*s + 2970*Dd**2*f**2*r - 1980*Dd**2*f**2*s**2 + 2970*Dd**2*f**2*s - 990*Dd**2*f**2) + 132*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 100*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2))/(693*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct*k1*k2**5*st**6*(20*C - 15)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(1386*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct*k1*k2**5*st**4*(-858*D1**2*bd1**2*f*(2*K - 1)*(r + s - 1)**2 - 13*D1*bd1*(D1*(50*f**3*(r + s - 1) + f**2*(132*C*(r + s - 1) - 50*fd*(3*r + 3*s - 2) - 99*r - 99*s + 99) + 264*f*(g2 - gd2)*(r + s - 1) - 264*fd*g2*(r + s)) - 2*Dd*f*(25*f**2 + 132*g2)*(4*r + 4*s - 3))*(r + s - 1) + 429*b1**2*(D1**2*(2*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (2*K - 1)*(2*fd - fdd)*(r + s)**2) + D1*(2*Dd*(f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(2*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(2*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(-264*C*D1**2*f*fd*r**2 - 528*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*r - 264*C*D1**2*f*fd*s**2 + 264*C*D1**2*f*fd*s - 132*C*D1**2*f*fd - 528*C*D1*Dd*f**2*r**2 - 1056*C*D1*Dd*f**2*r*s + 792*C*D1*Dd*f**2*r - 528*C*D1*Dd*f**2*s**2 + 792*C*D1*Dd*f**2*s - 396*C*D1*Dd*f**2 - 66*D1**2*bdd1*f*(2*K - 1)*(r + s - 1)**2 - 150*D1**2*f**2*fd*r**2 - 300*D1**2*f**2*fd*r*s + 200*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 200*D1**2*f**2*fd*s - 100*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 + 198*D1**2*f*fd*r**2 + 396*D1**2*f*fd*r*s - 198*D1**2*f*fd*r + 198*D1**2*f*fd*s**2 - 198*D1**2*f*fd*s + 99*D1**2*f*fd - 264*D1**2*f*gd2*r**2 - 528*D1**2*f*gd2*r*s + 528*D1**2*f*gd2*r - 264*D1**2*f*gd2*s**2 + 528*D1**2*f*gd2*s - 264*D1**2*f*gd2 + 132*D1**2*f*gdd2*r**2 + 264*D1**2*f*gdd2*r*s - 264*D1**2*f*gdd2*r + 132*D1**2*f*gdd2*s**2 - 264*D1**2*f*gdd2*s + 132*D1**2*f*gdd2 - 264*D1**2*fd*g2*r**2 - 528*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*s**2 + 264*D1**2*fd*gd2*r**2 + 528*D1**2*fd*gd2*r*s - 264*D1**2*fd*gd2*r + 264*D1**2*fd*gd2*s**2 - 264*D1**2*fd*gd2*s + 132*D1**2*fdd*g2*r**2 + 264*D1**2*fdd*g2*r*s + 132*D1**2*fdd*g2*s**2 - 200*D1*Dd*f**3*r**2 - 400*D1*Dd*f**3*r*s + 300*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 300*D1*Dd*f**3*s - 150*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 850*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 850*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd + 396*D1*Dd*f**2*r**2 + 792*D1*Dd*f**2*r*s - 594*D1*Dd*f**2*r + 396*D1*Dd*f**2*s**2 - 594*D1*Dd*f**2*s + 297*D1*Dd*f**2 - 1056*D1*Dd*f*g2*r**2 - 2112*D1*Dd*f*g2*r*s + 1584*D1*Dd*f*g2*r - 1056*D1*Dd*f*g2*s**2 + 1584*D1*Dd*f*g2*s - 792*D1*Dd*f*g2 + 1056*D1*Dd*f*gd2*r**2 + 2112*D1*Dd*f*gd2*r*s - 1848*D1*Dd*f*gd2*r + 1056*D1*Dd*f*gd2*s**2 - 1848*D1*Dd*f*gd2*s + 792*D1*Dd*f*gd2 + 1056*D1*Dd*fd*g2*r**2 + 2112*D1*Dd*fd*g2*r*s - 792*D1*Dd*fd*g2*r + 1056*D1*Dd*fd*g2*s**2 - 792*D1*Dd*fd*g2*s + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 528*D1*Ddd*f*g2*r**2 + 1056*D1*Ddd*f*g2*r*s - 792*D1*Ddd*f*g2*r + 528*D1*Ddd*f*g2*s**2 - 792*D1*Ddd*f*g2*s + 396*D1*Ddd*f*g2 + 132*D1*bd1*(D1*(f**2*(r + s - 1) + f*(2*K - 1)*(r + s - 1) - fd*(2*K - 1)*(r + s)) - Dd*f*(2*K - 1)*(4*r + 4*s - 3))*(r + s - 1) + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 + 1584*Dd**2*f*g2*r**2 + 3168*Dd**2*f*g2*r*s - 2376*Dd**2*f*g2*r + 1584*Dd**2*f*g2*s**2 - 2376*Dd**2*f*g2*s + 792*Dd**2*f*g2) + f*(13*D1**2*bdd1*(25*f**2 + 132*g2)*(r + s - 1)**2 + f*(D1**2*(-f*(857*fd - 500*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 3000*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(-857*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 1000*fd*(4*r + 4*s - 3)**2) + 500*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 3000*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(3003*d**2*k3**6) + D1**2*Pk1*Pkdd3*ct*k1*k2**3*st**4*(33*D1*b1*(4*C - 3)*(2*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + f*(-D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 33*b1**2*(4*C - 3)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(-66*D1**2*bd1**2*(4*C - 3)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 33*D1**2*bd1*f*(4*C - 3)*(r + s - 1)**2 + (40*C - 26)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(231*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct*k1*k2**3*st**2*(-88*C*D1**2*bd1*f**2*r**2 - 176*C*D1**2*bd1*f**2*r*s + 264*C*D1**2*bd1*f**2*r - 88*C*D1**2*bd1*f**2*s**2 + 264*C*D1**2*bd1*f**2*s - 132*C*D1**2*bd1*f**2 - 396*C*D1**2*f**2*fd*r**2 - 792*C*D1**2*f**2*fd*r*s + 528*C*D1**2*f**2*fd*r - 396*C*D1**2*f**2*fd*s**2 + 528*C*D1**2*f**2*fd*s - 264*C*D1**2*f**2*fd - 528*C*D1*Dd*f**3*r**2 - 1056*C*D1*Dd*f**3*r*s + 792*C*D1*Dd*f**3*r - 528*C*D1*Dd*f**3*s**2 + 792*C*D1*Dd*f**3*s - 396*C*D1*Dd*f**3 - 220*D1**2*K*bd1**2*f*r**2 - 440*D1**2*K*bd1**2*f*r*s + 484*D1**2*K*bd1**2*f*r - 220*D1**2*K*bd1**2*f*s**2 + 484*D1**2*K*bd1**2*f*s - 264*D1**2*K*bd1**2*f + 242*D1**2*K*bd1*f**2*r**2 + 484*D1**2*K*bd1*f**2*r*s - 484*D1**2*K*bd1*f**2*r + 242*D1**2*K*bd1*f**2*s**2 - 484*D1**2*K*bd1*f**2*s + 242*D1**2*K*bd1*f**2 - 528*D1**2*K*bd1*f*fd*r**2 - 1056*D1**2*K*bd1*f*fd*r*s + 792*D1**2*K*bd1*f*fd*r - 528*D1**2*K*bd1*f*fd*s**2 + 792*D1**2*K*bd1*f*fd*s - 264*D1**2*K*bd1*f*fd - 132*D1**2*K*bdd1*f**2*r**2 - 264*D1**2*K*bdd1*f**2*r*s + 264*D1**2*K*bdd1*f**2*r - 132*D1**2*K*bdd1*f**2*s**2 + 264*D1**2*K*bdd1*f**2*s - 132*D1**2*K*bdd1*f**2 + 396*D1**2*bd1**2*f**2*r**2 + 792*D1**2*bd1**2*f**2*r*s - 792*D1**2*bd1**2*f**2*r + 396*D1**2*bd1**2*f**2*s**2 - 792*D1**2*bd1**2*f**2*s + 396*D1**2*bd1**2*f**2 + 110*D1**2*bd1**2*f*r**2 + 220*D1**2*bd1**2*f*r*s - 242*D1**2*bd1**2*f*r + 110*D1**2*bd1**2*f*s**2 - 242*D1**2*bd1**2*f*s + 132*D1**2*bd1**2*f + 616*D1**2*bd1**2*g2*r**2 + 1232*D1**2*bd1**2*g2*r*s - 616*D1**2*bd1**2*g2*r + 616*D1**2*bd1**2*g2*s**2 - 616*D1**2*bd1**2*g2*s - 264*D1**2*bd1*bd2*f*r**2 - 528*D1**2*bd1*bd2*f*r*s + 528*D1**2*bd1*bd2*f*r - 264*D1**2*bd1*bd2*f*s**2 + 528*D1**2*bd1*bd2*f*s - 264*D1**2*bd1*bd2*f - 318*D1**2*bd1*f**3*r**2 - 636*D1**2*bd1*f**3*r*s + 446*D1**2*bd1*f**3*r - 318*D1**2*bd1*f**3*s**2 + 446*D1**2*bd1*f**3*s - 223*D1**2*bd1*f**3 + 1350*D1**2*bd1*f**2*fd*r**2 + 2700*D1**2*bd1*f**2*fd*r*s - 1950*D1**2*bd1*f**2*fd*r + 1350*D1**2*bd1*f**2*fd*s**2 - 1950*D1**2*bd1*f**2*fd*s + 600*D1**2*bd1*f**2*fd - 77*D1**2*bd1*f**2*r**2 - 154*D1**2*bd1*f**2*r*s + 88*D1**2*bd1*f**2*r - 77*D1**2*bd1*f**2*s**2 + 88*D1**2*bd1*f**2*s - 44*D1**2*bd1*f**2 + 264*D1**2*bd1*f*fd*r**2 + 528*D1**2*bd1*f*fd*r*s - 396*D1**2*bd1*f*fd*r + 264*D1**2*bd1*f*fd*s**2 - 396*D1**2*bd1*f*fd*s + 132*D1**2*bd1*f*fd - 748*D1**2*bd1*f*g2*r**2 - 1496*D1**2*bd1*f*g2*r*s + 1672*D1**2*bd1*f*g2*r - 748*D1**2*bd1*f*g2*s**2 + 1672*D1**2*bd1*f*g2*s - 836*D1**2*bd1*f*g2 + 440*D1**2*bd1*f*gd2*r**2 + 880*D1**2*bd1*f*gd2*r*s - 968*D1**2*bd1*f*gd2*r + 440*D1**2*bd1*f*gd2*s**2 - 968*D1**2*bd1*f*gd2*s + 528*D1**2*bd1*f*gd2 + 440*D1**2*bd1*fd*g2*r**2 + 880*D1**2*bd1*fd*g2*r*s - 440*D1**2*bd1*fd*g2*r + 440*D1**2*bd1*fd*g2*s**2 - 440*D1**2*bd1*fd*g2*s + 242*D1**2*bd2*f**2*r**2 + 484*D1**2*bd2*f**2*r*s - 484*D1**2*bd2*f**2*r + 242*D1**2*bd2*f**2*s**2 - 484*D1**2*bd2*f**2*s + 242*D1**2*bd2*f**2 - 528*D1**2*bd2*f*fd*r**2 - 1056*D1**2*bd2*f*fd*r*s + 792*D1**2*bd2*f*fd*r - 528*D1**2*bd2*f*fd*s**2 + 792*D1**2*bd2*f*fd*s - 264*D1**2*bd2*f*fd + 225*D1**2*bdd1*f**3*r**2 + 450*D1**2*bdd1*f**3*r*s - 300*D1**2*bdd1*f**3*r + 225*D1**2*bdd1*f**3*s**2 - 300*D1**2*bdd1*f**3*s + 150*D1**2*bdd1*f**3 + 66*D1**2*bdd1*f**2*r**2 + 132*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*r + 66*D1**2*bdd1*f**2*s**2 - 132*D1**2*bdd1*f**2*s + 66*D1**2*bdd1*f**2 + 220*D1**2*bdd1*f*g2*r**2 + 440*D1**2*bdd1*f*g2*r*s - 528*D1**2*bdd1*f*g2*r + 220*D1**2*bdd1*f*g2*s**2 - 528*D1**2*bdd1*f*g2*s + 264*D1**2*bdd1*f*g2 - 132*D1**2*bdd2*f**2*r**2 - 264*D1**2*bdd2*f**2*r*s + 264*D1**2*bdd2*f**2*r - 132*D1**2*bdd2*f**2*s**2 + 264*D1**2*bdd2*f**2*s - 132*D1**2*bdd2*f**2 + 231*D1**2*f**2*fd*r**2 + 462*D1**2*f**2*fd*r*s - 308*D1**2*f**2*fd*r + 231*D1**2*f**2*fd*s**2 - 308*D1**2*f**2*fd*s + 154*D1**2*f**2*fd - 484*D1**2*f**2*gd2*r**2 - 968*D1**2*f**2*gd2*r*s + 968*D1**2*f**2*gd2*r - 484*D1**2*f**2*gd2*s**2 + 968*D1**2*f**2*gd2*s - 484*D1**2*f**2*gd2 + 264*D1**2*f**2*gdd2*r**2 + 528*D1**2*f**2*gdd2*r*s - 528*D1**2*f**2*gdd2*r + 264*D1**2*f**2*gdd2*s**2 - 528*D1**2*f**2*gdd2*s + 264*D1**2*f**2*gdd2 - 968*D1**2*f*fd*g2*r**2 - 1936*D1**2*f*fd*g2*r*s + 968*D1**2*f*fd*g2*r - 968*D1**2*f*fd*g2*s**2 + 968*D1**2*f*fd*g2*s - 484*D1**2*f*fd*g2 + 1056*D1**2*f*fd*gd2*r**2 + 2112*D1**2*f*fd*gd2*r*s - 1584*D1**2*f*fd*gd2*r + 1056*D1**2*f*fd*gd2*s**2 - 1584*D1**2*f*fd*gd2*s + 528*D1**2*f*fd*gd2 + 528*D1**2*f*fdd*g2*r**2 + 1056*D1**2*f*fdd*g2*r*s - 528*D1**2*f*fdd*g2*r + 528*D1**2*f*fdd*g2*s**2 - 528*D1**2*f*fdd*g2*s + 264*D1**2*f*fdd*g2 + 528*D1**2*fd**2*g2*r**2 + 1056*D1**2*fd**2*g2*r*s - 528*D1**2*fd**2*g2*r + 528*D1**2*fd**2*g2*s**2 - 528*D1**2*fd**2*g2*s - 1056*D1*Dd*K*bd1*f**2*r**2 - 2112*D1*Dd*K*bd1*f**2*r*s + 1848*D1*Dd*K*bd1*f**2*r - 1056*D1*Dd*K*bd1*f**2*s**2 + 1848*D1*Dd*K*bd1*f**2*s - 792*D1*Dd*K*bd1*f**2 + 1800*D1*Dd*bd1*f**3*r**2 + 3600*D1*Dd*bd1*f**3*r*s - 2550*D1*Dd*bd1*f**3*r + 1800*D1*Dd*bd1*f**3*s**2 - 2550*D1*Dd*bd1*f**3*s + 900*D1*Dd*bd1*f**3 + 528*D1*Dd*bd1*f**2*r**2 + 1056*D1*Dd*bd1*f**2*r*s - 924*D1*Dd*bd1*f**2*r + 528*D1*Dd*bd1*f**2*s**2 - 924*D1*Dd*bd1*f**2*s + 396*D1*Dd*bd1*f**2 + 1760*D1*Dd*bd1*f*g2*r**2 + 3520*D1*Dd*bd1*f*g2*r*s - 3432*D1*Dd*bd1*f*g2*r + 1760*D1*Dd*bd1*f*g2*s**2 - 3432*D1*Dd*bd1*f*g2*s + 1584*D1*Dd*bd1*f*g2 - 1056*D1*Dd*bd2*f**2*r**2 - 2112*D1*Dd*bd2*f**2*r*s + 1848*D1*Dd*bd2*f**2*r - 1056*D1*Dd*bd2*f**2*s**2 + 1848*D1*Dd*bd2*f**2*s - 792*D1*Dd*bd2*f**2 + 308*D1*Dd*f**3*r**2 + 616*D1*Dd*f**3*r*s - 462*D1*Dd*f**3*r + 308*D1*Dd*f**3*s**2 - 462*D1*Dd*f**3*s + 231*D1*Dd*f**3 - 1936*D1*Dd*f**2*g2*r**2 - 3872*D1*Dd*f**2*g2*r*s + 2904*D1*Dd*f**2*g2*r - 1936*D1*Dd*f**2*g2*s**2 + 2904*D1*Dd*f**2*g2*s - 1452*D1*Dd*f**2*g2 + 2112*D1*Dd*f**2*gd2*r**2 + 4224*D1*Dd*f**2*gd2*r*s - 3696*D1*Dd*f**2*gd2*r + 2112*D1*Dd*f**2*gd2*s**2 - 3696*D1*Dd*f**2*gd2*s + 1584*D1*Dd*f**2*gd2 + 4224*D1*Dd*f*fd*g2*r**2 + 8448*D1*Dd*f*fd*g2*r*s - 5280*D1*Dd*f*fd*g2*r + 4224*D1*Dd*f*fd*g2*s**2 - 5280*D1*Dd*f*fd*g2*s + 1584*D1*Dd*f*fd*g2 + 1056*D1*Ddd*f**2*g2*r**2 + 2112*D1*Ddd*f**2*g2*r*s - 1584*D1*Ddd*f**2*g2*r + 1056*D1*Ddd*f**2*g2*s**2 - 1584*D1*Ddd*f**2*g2*s + 792*D1*Ddd*f**2*g2 + 3168*Dd**2*f**2*g2*r**2 + 6336*Dd**2*f**2*g2*r*s - 4752*Dd**2*f**2*g2*r + 3168*Dd**2*f**2*g2*s**2 - 4752*Dd**2*f**2*g2*s + 1584*Dd**2*f**2*g2 + 11*b1**3*(D1**2*(32*fd - 9*fdd)*(r + s - 1)**2 + D1*(2*Dd*(16*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 9*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(14*K + 9*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(14*K + 9*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(-28*C*D1**2*fd*r**2 - 56*C*D1**2*fd*r*s + 56*C*D1**2*fd*r - 28*C*D1**2*fd*s**2 + 56*C*D1**2*fd*s - 28*C*D1**2*fd - 112*C*D1*Dd*f*r**2 - 224*C*D1*Dd*f*r*s + 168*C*D1*Dd*f*r - 112*C*D1*Dd*f*s**2 + 168*C*D1*Dd*f*s - 84*C*D1*Dd*f + 34*D1**2*K*fd*r**2 + 68*D1**2*K*fd*r*s + 8*D1**2*K*fd*r + 34*D1**2*K*fd*s**2 + 8*D1**2*K*fd*s - 4*D1**2*K*fd - 10*D1**2*K*fdd*r**2 - 20*D1**2*K*fdd*r*s - 4*D1**2*K*fdd*r - 10*D1**2*K*fdd*s**2 - 4*D1**2*K*fdd*s + 2*D1**2*K*fdd - D1**2*bdd1*(14*K + 9*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 52*D1**2*f*fd*r**2 - 104*D1**2*f*fd*r*s + 46*D1**2*f*fd*r - 52*D1**2*f*fd*s**2 + 46*D1**2*f*fd*s - 23*D1**2*f*fd + 36*D1**2*f*fdd*r**2 + 72*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 18*D1**2*f*fdd + 36*D1**2*fd**2*r**2 + 72*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s + 4*D1**2*fd*r**2 + 8*D1**2*fd*r*s - 46*D1**2*fd*r + 4*D1**2*fd*s**2 - 46*D1**2*fd*s + 23*D1**2*fd + 5*D1**2*fdd*r**2 + 10*D1**2*fdd*r*s + 2*D1**2*fdd*r + 5*D1**2*fdd*s**2 + 2*D1**2*fdd*s - D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 + 136*D1*Dd*K*f*r**2 + 272*D1*Dd*K*f*r*s - 204*D1*Dd*K*f*r + 136*D1*Dd*K*f*s**2 - 204*D1*Dd*K*f*s + 102*D1*Dd*K*f - 80*D1*Dd*K*fd*r**2 - 160*D1*Dd*K*fd*r*s + 44*D1*Dd*K*fd*r - 80*D1*Dd*K*fd*s**2 + 44*D1*Dd*K*fd*s + 12*D1*Dd*K*fd - 104*D1*Dd*f**2*r**2 - 208*D1*Dd*f**2*r*s + 156*D1*Dd*f**2*r - 104*D1*Dd*f**2*s**2 + 156*D1*Dd*f**2*s - 78*D1*Dd*f**2 + 288*D1*Dd*f*fd*r**2 + 576*D1*Dd*f*fd*r*s - 360*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s**2 - 360*D1*Dd*f*fd*s + 108*D1*Dd*f*fd + 16*D1*Dd*f*r**2 + 32*D1*Dd*f*r*s - 24*D1*Dd*f*r + 16*D1*Dd*f*s**2 - 24*D1*Dd*f*s + 12*D1*Dd*f + 40*D1*Dd*fd*r**2 + 80*D1*Dd*fd*r*s - 22*D1*Dd*fd*r + 40*D1*Dd*fd*s**2 - 22*D1*Dd*fd*s - 6*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 - 40*D1*Ddd*K*f*r**2 - 80*D1*Ddd*K*f*r*s + 60*D1*Ddd*K*f*r - 40*D1*Ddd*K*f*s**2 + 60*D1*Ddd*K*f*s - 30*D1*Ddd*K*f + 72*D1*Ddd*f**2*r**2 + 144*D1*Ddd*f**2*r*s - 108*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 108*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 20*D1*Ddd*f*r**2 + 40*D1*Ddd*f*r*s - 30*D1*Ddd*f*r + 20*D1*Ddd*f*s**2 - 30*D1*Ddd*f*s + 15*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + 2*D1*bd1*(D1*(16*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 9*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(14*K + 9*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 120*Dd**2*K*f*r**2 - 240*Dd**2*K*f*r*s + 180*Dd**2*K*f*r - 120*Dd**2*K*f*s**2 + 180*Dd**2*K*f*s - 60*Dd**2*K*f + 216*Dd**2*f**2*r**2 + 432*Dd**2*f**2*r*s - 324*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 324*Dd**2*f**2*s + 108*Dd**2*f**2 + 60*Dd**2*f*r**2 + 120*Dd**2*f*r*s - 90*Dd**2*f*r + 60*Dd**2*f*s**2 - 90*Dd**2*f*s + 30*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) + b1*(-176*C*D1**2*f*fd*r**2 - 352*C*D1**2*f*fd*r*s + 88*C*D1**2*f*fd*r - 176*C*D1**2*f*fd*s**2 + 88*C*D1**2*f*fd*s - 44*C*D1**2*f*fd - 352*C*D1*Dd*f**2*r**2 - 704*C*D1*Dd*f**2*r*s + 528*C*D1*Dd*f**2*r - 352*C*D1*Dd*f**2*s**2 + 528*C*D1*Dd*f**2*s - 264*C*D1*Dd*f**2 - 220*D1**2*K*bdd1*f*r**2 - 440*D1**2*K*bdd1*f*r*s + 484*D1**2*K*bdd1*f*r - 220*D1**2*K*bdd1*f*s**2 + 484*D1**2*K*bdd1*f*s - 242*D1**2*K*bdd1*f + 484*D1**2*K*f*fd*r**2 + 968*D1**2*K*f*fd*r*s - 484*D1**2*K*f*fd*r + 484*D1**2*K*f*fd*s**2 - 484*D1**2*K*f*fd*s + 242*D1**2*K*f*fd - 264*D1**2*K*f*fdd*r**2 - 528*D1**2*K*f*fdd*r*s + 264*D1**2*K*f*fdd*r - 264*D1**2*K*f*fdd*s**2 + 264*D1**2*K*f*fdd*s - 132*D1**2*K*f*fdd - 264*D1**2*K*fd**2*r**2 - 528*D1**2*K*fd**2*r*s + 264*D1**2*K*fd**2*r - 264*D1**2*K*fd**2*s**2 + 264*D1**2*K*fd**2*s + 418*D1**2*b2*fd*r**2 + 836*D1**2*b2*fd*r*s + 418*D1**2*b2*fd*s**2 - 132*D1**2*b2*fdd*r**2 - 264*D1**2*b2*fdd*r*s - 132*D1**2*b2*fdd*s**2 - 22*D1**2*bd1**2*(14*K + 9*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 396*D1**2*bdd1*f**2*r**2 + 792*D1**2*bdd1*f**2*r*s - 792*D1**2*bdd1*f**2*r + 396*D1**2*bdd1*f**2*s**2 - 792*D1**2*bdd1*f**2*s + 396*D1**2*bdd1*f**2 + 110*D1**2*bdd1*f*r**2 + 220*D1**2*bdd1*f*r*s - 242*D1**2*bdd1*f*r + 110*D1**2*bdd1*f*s**2 - 242*D1**2*bdd1*f*s + 121*D1**2*bdd1*f + 616*D1**2*bdd1*g2*r**2 + 1232*D1**2*bdd1*g2*r*s - 616*D1**2*bdd1*g2*r + 616*D1**2*bdd1*g2*s**2 - 616*D1**2*bdd1*g2*s + 308*D1**2*bdd1*g2 - 132*D1**2*bdd2*f*r**2 - 264*D1**2*bdd2*f*r*s + 264*D1**2*bdd2*f*r - 132*D1**2*bdd2*f*s**2 + 264*D1**2*bdd2*f*s - 132*D1**2*bdd2*f - 954*D1**2*f**2*fd*r**2 - 1908*D1**2*f**2*fd*r*s + 1462*D1**2*f**2*fd*r - 954*D1**2*f**2*fd*s**2 + 1462*D1**2*f**2*fd*s - 731*D1**2*f**2*fd + 675*D1**2*f**2*fdd*r**2 + 1350*D1**2*f**2*fdd*r*s - 1050*D1**2*f**2*fdd*r + 675*D1**2*f**2*fdd*s**2 - 1050*D1**2*f**2*fdd*s + 525*D1**2*f**2*fdd + 1350*D1**2*f*fd**2*r**2 + 2700*D1**2*f*fd**2*r*s - 2100*D1**2*f*fd**2*r + 1350*D1**2*f*fd**2*s**2 - 2100*D1**2*f*fd**2*s + 750*D1**2*f*fd**2 - 154*D1**2*f*fd*r**2 - 308*D1**2*f*fd*r*s + 220*D1**2*f*fd*r - 154*D1**2*f*fd*s**2 + 220*D1**2*f*fd*s - 110*D1**2*f*fd + 132*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 132*D1**2*f*fdd*r + 132*D1**2*f*fdd*s**2 - 132*D1**2*f*fdd*s + 66*D1**2*f*fdd - 748*D1**2*f*gd2*r**2 - 1496*D1**2*f*gd2*r*s + 1496*D1**2*f*gd2*r - 748*D1**2*f*gd2*s**2 + 1496*D1**2*f*gd2*s - 748*D1**2*f*gd2 + 220*D1**2*f*gdd2*r**2 + 440*D1**2*f*gdd2*r*s - 440*D1**2*f*gdd2*r + 220*D1**2*f*gdd2*s**2 - 440*D1**2*f*gdd2*s + 220*D1**2*f*gdd2 + 132*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 132*D1**2*fd**2*r + 132*D1**2*fd**2*s**2 - 132*D1**2*fd**2*s - 748*D1**2*fd*g2*r**2 - 1496*D1**2*fd*g2*r*s - 176*D1**2*fd*g2*r - 748*D1**2*fd*g2*s**2 - 176*D1**2*fd*g2*s + 88*D1**2*fd*g2 + 440*D1**2*fd*gd2*r**2 + 880*D1**2*fd*gd2*r*s - 352*D1**2*fd*gd2*r + 440*D1**2*fd*gd2*s**2 - 352*D1**2*fd*gd2*s - 88*D1**2*fd*gd2 + 220*D1**2*fdd*g2*r**2 + 440*D1**2*fdd*g2*r*s + 88*D1**2*fdd*g2*r + 220*D1**2*fdd*g2*s**2 + 88*D1**2*fdd*g2*s - 44*D1**2*fdd*g2 + 968*D1*Dd*K*f**2*r**2 + 1936*D1*Dd*K*f**2*r*s - 1452*D1*Dd*K*f**2*r + 968*D1*Dd*K*f**2*s**2 - 1452*D1*Dd*K*f**2*s + 726*D1*Dd*K*f**2 - 2112*D1*Dd*K*f*fd*r**2 - 4224*D1*Dd*K*f*fd*r*s + 2640*D1*Dd*K*f*fd*r - 2112*D1*Dd*K*f*fd*s**2 + 2640*D1*Dd*K*f*fd*s - 792*D1*Dd*K*f*fd + 1672*D1*Dd*b2*f*r**2 + 3344*D1*Dd*b2*f*r*s - 2508*D1*Dd*b2*f*r + 1672*D1*Dd*b2*f*s**2 - 2508*D1*Dd*b2*f*s + 1254*D1*Dd*b2*f - 1056*D1*Dd*b2*fd*r**2 - 2112*D1*Dd*b2*fd*r*s + 792*D1*Dd*b2*fd*r - 1056*D1*Dd*b2*fd*s**2 + 792*D1*Dd*b2*fd*s - 1272*D1*Dd*f**3*r**2 - 2544*D1*Dd*f**3*r*s + 1908*D1*Dd*f**3*r - 1272*D1*Dd*f**3*s**2 + 1908*D1*Dd*f**3*s - 954*D1*Dd*f**3 + 5400*D1*Dd*f**2*fd*r**2 + 10800*D1*Dd*f**2*fd*r*s - 8250*D1*Dd*f**2*fd*r + 5400*D1*Dd*f**2*fd*s**2 - 8250*D1*Dd*f**2*fd*s + 3150*D1*Dd*f**2*fd - 308*D1*Dd*f**2*r**2 - 616*D1*Dd*f**2*r*s + 462*D1*Dd*f**2*r - 308*D1*Dd*f**2*s**2 + 462*D1*Dd*f**2*s - 231*D1*Dd*f**2 + 1056*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 1320*D1*Dd*f*fd*r + 1056*D1*Dd*f*fd*s**2 - 1320*D1*Dd*f*fd*s + 396*D1*Dd*f*fd - 2992*D1*Dd*f*g2*r**2 - 5984*D1*Dd*f*g2*r*s + 4488*D1*Dd*f*g2*r - 2992*D1*Dd*f*g2*s**2 + 4488*D1*Dd*f*g2*s - 2244*D1*Dd*f*g2 + 1760*D1*Dd*f*gd2*r**2 + 3520*D1*Dd*f*gd2*r*s - 3080*D1*Dd*f*gd2*r + 1760*D1*Dd*f*gd2*s**2 - 3080*D1*Dd*f*gd2*s + 1320*D1*Dd*f*gd2 + 1760*D1*Dd*fd*g2*r**2 + 3520*D1*Dd*fd*g2*r*s - 968*D1*Dd*fd*g2*r + 1760*D1*Dd*fd*g2*s**2 - 968*D1*Dd*fd*g2*s - 264*D1*Dd*fd*g2 - 528*D1*Ddd*K*f**2*r**2 - 1056*D1*Ddd*K*f**2*r*s + 792*D1*Ddd*K*f**2*r - 528*D1*Ddd*K*f**2*s**2 + 792*D1*Ddd*K*f**2*s - 396*D1*Ddd*K*f**2 - 528*D1*Ddd*b2*f*r**2 - 1056*D1*Ddd*b2*f*r*s + 792*D1*Ddd*b2*f*r - 528*D1*Ddd*b2*f*s**2 + 792*D1*Ddd*b2*f*s - 396*D1*Ddd*b2*f + 900*D1*Ddd*f**3*r**2 + 1800*D1*Ddd*f**3*r*s - 1350*D1*Ddd*f**3*r + 900*D1*Ddd*f**3*s**2 - 1350*D1*Ddd*f**3*s + 675*D1*Ddd*f**3 + 264*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 396*D1*Ddd*f**2*r + 264*D1*Ddd*f**2*s**2 - 396*D1*Ddd*f**2*s + 198*D1*Ddd*f**2 + 880*D1*Ddd*f*g2*r**2 + 1760*D1*Ddd*f*g2*r*s - 1320*D1*Ddd*f*g2*r + 880*D1*Ddd*f*g2*s**2 - 1320*D1*Ddd*f*g2*s + 660*D1*Ddd*f*g2 - 11*D1*bd1*(D1*(f**2*(52*r**2 + 2*r*(52*s - 55) + 52*s**2 - 110*s + 55) + f*(28*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 68*K*r**2 - 136*K*r*s + 144*K*r - 68*K*s**2 + 144*K*s - 72*K - 72*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 8*r**2 - 16*r*s - 30*r - 8*s**2 - 30*s + 15) + 2*fd*(2*K - 1)*(10*r**2 + r*(20*s - 9) + 10*s**2 - 9*s - 1) + 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(4*r + 4*s - 3)*(36*f**2*(r + s - 1) - f*(2*K - 1)*(10*r + 10*s - 11) + 28*g2*(2*r + 2*s - 1))) + 22*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 1584*Dd**2*K*f**2*r**2 - 3168*Dd**2*K*f**2*r*s + 2376*Dd**2*K*f**2*r - 1584*Dd**2*K*f**2*s**2 + 2376*Dd**2*K*f**2*s - 792*Dd**2*K*f**2 - 1584*Dd**2*b2*f*r**2 - 3168*Dd**2*b2*f*r*s + 2376*Dd**2*b2*f*r - 1584*Dd**2*b2*f*s**2 + 2376*Dd**2*b2*f*s - 792*Dd**2*b2*f + 2700*Dd**2*f**3*r**2 + 5400*Dd**2*f**3*r*s - 4050*Dd**2*f**3*r + 2700*Dd**2*f**3*s**2 - 4050*Dd**2*f**3*s + 1350*Dd**2*f**3 + 792*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 1188*Dd**2*f**2*r + 792*Dd**2*f**2*s**2 - 1188*Dd**2*f**2*s + 396*Dd**2*f**2 + 2640*Dd**2*f*g2*r**2 + 5280*Dd**2*f*g2*r*s - 3960*Dd**2*f*g2*r + 2640*Dd**2*f*g2*s**2 - 3960*Dd**2*f*g2*s + 1320*Dd**2*f*g2) + 22*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 12*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 12*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 120*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 36*Dd**2*f**2))/(462*d**2*k3**4) + D1**2*Pk1*Pkdd3*ct*k1*k2*st**2*(-D1*f*(r + s)*(2*D1*bd1**2*(12*C - 7)*(r + s - 1) + D1*bdd1*f*(12*C - 7)*(r + s) + bd1*(-D1*f*(20*C - 11)*(r + s) + D1*fd*(48*C - 28)*(r + s - 1) + Dd*f*(24*C - 14)*(4*r + 4*s - 3))) + b1**2*(D1**2*(fd*(52*C - 35) + fdd*(7 - 12*C))*(r + s - 1)**2 + D1*(Dd*(f*(52*C - 35)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(14 - 24*C)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(12*C - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Dd**2*f*(72*C - 42)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(40*C*D1**2*f*fd*r**2 + 80*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*r + 40*C*D1**2*f*fd*s**2 - 80*C*D1**2*f*fd*s + 40*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s + 48*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 + 48*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s + 48*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 + 48*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 + 80*C*D1*Dd*f**2*r**2 + 160*C*D1*Dd*f**2*r*s - 120*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s**2 - 120*C*D1*Dd*f**2*s + 60*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s + 336*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 336*C*D1*Dd*f*fd*s - 144*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r*s + 72*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 72*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r*s + 216*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 216*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 - D1**2*bdd1*f*(12*C - 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 22*D1**2*f*fd*r**2 - 44*D1**2*f*fd*r*s + 44*D1**2*f*fd*r - 22*D1**2*f*fd*s**2 + 44*D1**2*f*fd*s - 22*D1**2*f*fd + 14*D1**2*f*fdd*r**2 + 28*D1**2*f*fdd*r*s - 28*D1**2*f*fdd*r + 14*D1**2*f*fdd*s**2 - 28*D1**2*f*fdd*s + 14*D1**2*f*fdd + 14*D1**2*fd**2*r**2 + 28*D1**2*fd**2*r*s - 28*D1**2*fd**2*r + 14*D1**2*fd**2*s**2 - 28*D1**2*fd**2*s + 14*D1**2*fd**2 - 44*D1*Dd*f**2*r**2 - 88*D1*Dd*f**2*r*s + 66*D1*Dd*f**2*r - 44*D1*Dd*f**2*s**2 + 66*D1*Dd*f**2*s - 33*D1*Dd*f**2 + 112*D1*Dd*f*fd*r**2 + 224*D1*Dd*f*fd*r*s - 196*D1*Dd*f*fd*r + 112*D1*Dd*f*fd*s**2 - 196*D1*Dd*f*fd*s + 84*D1*Dd*f*fd + 28*D1*Ddd*f**2*r**2 + 56*D1*Ddd*f**2*r*s - 42*D1*Ddd*f**2*r + 28*D1*Ddd*f**2*s**2 - 42*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 + D1*bd1*(D1*(f*(52*C - 35)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(14 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*f*(14 - 24*C)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 84*Dd**2*f**2*r**2 + 168*Dd**2*f**2*r*s - 126*Dd**2*f**2*r + 84*Dd**2*f**2*s**2 - 126*Dd**2*f**2*s + 42*Dd**2*f**2))/(42*d**2*k3**2) + D1**2*Pk1*Pkdd3*ct*k1*k2*(-2*D1*(r + s)*(-D1*bd1**2*(5*f**2 + f*(6 - 12*K) + 28*g2)*(r + s - 1) - 12*D1*bdd1*f*g2*(r + s) + b2*(14*D1*bd1**2*(r + s - 1) + 6*D1*bdd1*f*(r + s) + bd1*(-5*D1*f*(r + s) + 12*D1*fd*(r + s - 1) + 12*Dd*f*(4*r + 4*s - 3))) + 2*bd1*(6*D1*bd2*f*(r + s - 1) + D1*(5*f*g2*(r + s) - 12*f*gd2*(r + s - 1) - 12*fd*g2*(r + s - 1)) - 12*Dd*f*g2*(4*r + 4*s - 3))) + b1**3*(-D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(-5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 2*(14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + Ddd*(-14*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(-14*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-42*D1**2*K*bdd1*r**2 - 84*D1**2*K*bdd1*r*s + 56*D1**2*K*bdd1*r - 42*D1**2*K*bdd1*s**2 + 56*D1**2*K*bdd1*s - 28*D1**2*K*bdd1 + 10*D1**2*K*fd*r**2 + 20*D1**2*K*fd*r*s - 20*D1**2*K*fd*r + 10*D1**2*K*fd*s**2 - 20*D1**2*K*fd*s + 10*D1**2*K*fd - 12*D1**2*K*fdd*r**2 - 24*D1**2*K*fdd*r*s + 24*D1**2*K*fdd*r - 12*D1**2*K*fdd*s**2 + 24*D1**2*K*fdd*s - 12*D1**2*K*fdd + 18*D1**2*bdd1*f*r**2 + 36*D1**2*bdd1*f*r*s - 24*D1**2*bdd1*f*r + 18*D1**2*bdd1*f*s**2 - 24*D1**2*bdd1*f*s + 12*D1**2*bdd1*f + 21*D1**2*bdd1*r**2 + 42*D1**2*bdd1*r*s - 28*D1**2*bdd1*r + 21*D1**2*bdd1*s**2 - 28*D1**2*bdd1*s + 14*D1**2*bdd1 - 14*D1**2*bdd2*r**2 - 28*D1**2*bdd2*r*s + 28*D1**2*bdd2*r - 14*D1**2*bdd2*s**2 + 28*D1**2*bdd2*s - 14*D1**2*bdd2 - 8*D1**2*f*fd*r**2 - 16*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 10*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 20*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s + 10*D1**2*fd**2 - 5*D1**2*fd*r**2 - 10*D1**2*fd*r*s + 10*D1**2*fd*r - 5*D1**2*fd*s**2 + 10*D1**2*fd*s - 5*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r + 6*D1**2*fdd*s**2 - 12*D1**2*fdd*s + 6*D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 + 40*D1*Dd*K*f*r**2 + 80*D1*Dd*K*f*r*s - 60*D1*Dd*K*f*r + 40*D1*Dd*K*f*s**2 - 60*D1*Dd*K*f*s + 30*D1*Dd*K*f - 96*D1*Dd*K*fd*r**2 - 192*D1*Dd*K*fd*r*s + 168*D1*Dd*K*fd*r - 96*D1*Dd*K*fd*s**2 + 168*D1*Dd*K*fd*s - 72*D1*Dd*K*fd + 112*D1*Dd*b2*r**2 + 224*D1*Dd*b2*r*s - 168*D1*Dd*b2*r + 112*D1*Dd*b2*s**2 - 168*D1*Dd*b2*s + 84*D1*Dd*b2 - 16*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 140*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 140*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 20*D1*Dd*f*r**2 - 40*D1*Dd*f*r*s + 30*D1*Dd*f*r - 20*D1*Dd*f*s**2 + 30*D1*Dd*f*s - 15*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 84*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 84*D1*Dd*fd*s + 36*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 - 48*D1*Ddd*K*f*r**2 - 96*D1*Ddd*K*f*r*s + 72*D1*Ddd*K*f*r - 48*D1*Ddd*K*f*s**2 + 72*D1*Ddd*K*f*s - 36*D1*Ddd*K*f - 56*D1*Ddd*b2*r**2 - 112*D1*Ddd*b2*r*s + 84*D1*Ddd*b2*r - 56*D1*Ddd*b2*s**2 + 84*D1*Ddd*b2*s - 42*D1*Ddd*b2 + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + D1*bd1*(D1*(-5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 2*(14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) + 2*Dd*(-14*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 28*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 144*Dd**2*K*f*r**2 - 288*Dd**2*K*f*r*s + 216*Dd**2*K*f*r - 144*Dd**2*K*f*s**2 + 216*Dd**2*K*f*s - 72*Dd**2*K*f - 168*Dd**2*b2*r**2 - 336*Dd**2*b2*r*s + 252*Dd**2*b2*r - 168*Dd**2*b2*s**2 + 252*Dd**2*b2*s - 84*Dd**2*b2 + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) + b1*(-24*D1**2*K*bdd1*f*r**2 - 48*D1**2*K*bdd1*f*r*s + 24*D1**2*K*bdd1*f*r - 24*D1**2*K*bdd1*f*s**2 + 24*D1**2*K*bdd1*f*s - 12*D1**2*K*bdd1*f + 2*D1**2*bd1**2*(-14*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 10*D1**2*bd2*f*r**2 + 20*D1**2*bd2*f*r*s - 20*D1**2*bd2*f*r + 10*D1**2*bd2*f*s**2 - 20*D1**2*bd2*f*s + 10*D1**2*bd2*f - 24*D1**2*bd2*fd*r**2 - 48*D1**2*bd2*fd*r*s + 48*D1**2*bd2*fd*r - 24*D1**2*bd2*fd*s**2 + 48*D1**2*bd2*fd*s - 24*D1**2*bd2*fd + 10*D1**2*bdd1*f**2*r**2 + 20*D1**2*bdd1*f**2*r*s - 10*D1**2*bdd1*f**2*r + 10*D1**2*bdd1*f**2*s**2 - 10*D1**2*bdd1*f**2*s + 5*D1**2*bdd1*f**2 + 12*D1**2*bdd1*f*r**2 + 24*D1**2*bdd1*f*r*s - 12*D1**2*bdd1*f*r + 12*D1**2*bdd1*f*s**2 - 12*D1**2*bdd1*f*s + 6*D1**2*bdd1*f + 56*D1**2*bdd1*g2*r**2 + 112*D1**2*bdd1*g2*r*s - 56*D1**2*bdd1*g2*r + 56*D1**2*bdd1*g2*s**2 - 56*D1**2*bdd1*g2*s + 28*D1**2*bdd1*g2 - 12*D1**2*bdd2*f*r**2 - 24*D1**2*bdd2*f*r*s + 24*D1**2*bdd2*f*r - 12*D1**2*bdd2*f*s**2 + 24*D1**2*bdd2*f*s - 12*D1**2*bdd2*f - 20*D1**2*f*gd2*r**2 - 40*D1**2*f*gd2*r*s + 40*D1**2*f*gd2*r - 20*D1**2*f*gd2*s**2 + 40*D1**2*f*gd2*s - 20*D1**2*f*gd2 + 24*D1**2*f*gdd2*r**2 + 48*D1**2*f*gdd2*r*s - 48*D1**2*f*gdd2*r + 24*D1**2*f*gdd2*s**2 - 48*D1**2*f*gdd2*s + 24*D1**2*f*gdd2 - 20*D1**2*fd*g2*r**2 - 40*D1**2*fd*g2*r*s + 40*D1**2*fd*g2*r - 20*D1**2*fd*g2*s**2 + 40*D1**2*fd*g2*s - 20*D1**2*fd*g2 + 48*D1**2*fd*gd2*r**2 + 96*D1**2*fd*gd2*r*s - 96*D1**2*fd*gd2*r + 48*D1**2*fd*gd2*s**2 - 96*D1**2*fd*gd2*s + 48*D1**2*fd*gd2 + 24*D1**2*fdd*g2*r**2 + 48*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*r + 24*D1**2*fdd*g2*s**2 - 48*D1**2*fdd*g2*s + 24*D1**2*fdd*g2 - 96*D1*Dd*bd2*f*r**2 - 192*D1*Dd*bd2*f*r*s + 168*D1*Dd*bd2*f*r - 96*D1*Dd*bd2*f*s**2 + 168*D1*Dd*bd2*f*s - 72*D1*Dd*bd2*f - 80*D1*Dd*f*g2*r**2 - 160*D1*Dd*f*g2*r*s + 120*D1*Dd*f*g2*r - 80*D1*Dd*f*g2*s**2 + 120*D1*Dd*f*g2*s - 60*D1*Dd*f*g2 + 192*D1*Dd*f*gd2*r**2 + 384*D1*Dd*f*gd2*r*s - 336*D1*Dd*f*gd2*r + 192*D1*Dd*f*gd2*s**2 - 336*D1*Dd*f*gd2*s + 144*D1*Dd*f*gd2 + 192*D1*Dd*fd*g2*r**2 + 384*D1*Dd*fd*g2*r*s - 336*D1*Dd*fd*g2*r + 192*D1*Dd*fd*g2*s**2 - 336*D1*Dd*fd*g2*s + 144*D1*Dd*fd*g2 + 96*D1*Ddd*f*g2*r**2 + 192*D1*Ddd*f*g2*r*s - 144*D1*Ddd*f*g2*r + 96*D1*Ddd*f*g2*s**2 - 144*D1*Ddd*f*g2*s + 72*D1*Ddd*f*g2 + D1*bd1*(-28*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-4*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*f*(4*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + (2*K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) - 12*fd*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 56*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 56*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*(5*f**2 + f*(6 - 12*K) + 28*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 288*Dd**2*f*g2*r**2 + 576*Dd**2*f*g2*r*s - 432*Dd**2*f*g2*r + 288*Dd**2*f*g2*s**2 - 432*Dd**2*f*g2*s + 144*Dd**2*f*g2 + 2*b2*(-7*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 5*D1**2*fd*r**2 + 10*D1**2*fd*r*s - 10*D1**2*fd*r + 5*D1**2*fd*s**2 - 10*D1**2*fd*s + 5*D1**2*fd - 6*D1**2*fdd*r**2 - 12*D1**2*fdd*r*s + 12*D1**2*fdd*r - 6*D1**2*fdd*s**2 + 12*D1**2*fdd*s - 6*D1**2*fdd + 20*D1*Dd*f*r**2 + 40*D1*Dd*f*r*s - 30*D1*Dd*f*r + 20*D1*Dd*f*s**2 - 30*D1*Dd*f*s + 15*D1*Dd*f - 48*D1*Dd*fd*r**2 - 96*D1*Dd*fd*r*s + 84*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 + 84*D1*Dd*fd*s - 36*D1*Dd*fd - 24*D1*Ddd*f*r**2 - 48*D1*Ddd*f*r*s + 36*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 36*D1*Ddd*f*s - 18*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 72*Dd**2*f*r**2 - 144*Dd**2*f*r*s + 108*Dd**2*f*r - 72*Dd**2*f*s**2 + 108*Dd**2*f*s - 36*Dd**2*f)))/(21*d**2*k3**2) + 5*D1**2*Pk1*Pkdd3*ct*k2**5*st**6*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(1386*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct*k2**5*st**4*(D1*f*(-66*D1*bd1**2*(r + s - 1)**2 + 5*D1*bdd1*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + bd1*f*(-10*D1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1*(r + s - 1)*(20*fd*(3*r + 3*s - 1) - 33*r - 33*s + 33) + 10*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 33*b1**2*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(132*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + f*(-66*D1**2*bdd1*(r + s - 1)**2 + D1**2*(5*f*fdd*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 20*fd**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - fd*(10*f*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 66*r**2 + 33*r*(4*s - 2) + 66*s**2 - 66*s + 33)) + D1*f*(-Dd*(20*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd*(24*r**2 + 48*r*s - 38*r + 24*s**2 - 38*s + 15) + 132*r**2 + 264*r*s - 198*r + 132*s**2 - 198*s + 99) + 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(231*d**2*k1*k3**4) + D1**2*Pk1*Pkdd3*ct*k2**3*st**4*(-2*D1**2*bd1**2*f*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*b1*(-D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k1*k3**2) + D1**2*Pk1*Pkdd3*ct*k2**3*st**2*(D1**2*bd1*f*(r + s)*(2*bd1*(3*f + 1)*(r + s - 1) + f*(r + s)) + D1*b1*(2*D1*bd1**2*(3*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + bd1*(D1*(-6*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*f*(4*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 6*r**2 - 12*r*s + 6*r - 6*s**2 + 6*s - 3) + 2*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(3*f + 1)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + f*(D1*bdd1*(3*f + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**3*(-3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(-3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) + Ddd*(3*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(3*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*bdd1*(3*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 24*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 12*D1**2*f*fdd*s + 6*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 12*D1**2*fd**2*s + 6*D1**2*fd**2 - 9*D1**2*fd*r**2 - 18*D1**2*fd*r*s + 18*D1**2*fd*r - 9*D1**2*fd*s**2 + 18*D1**2*fd*s - 9*D1**2*fd + D1**2*fdd*r**2 + 2*D1**2*fdd*r*s - 2*D1**2*fdd*r + D1**2*fdd*s**2 - 2*D1**2*fdd*s + D1**2*fdd - 24*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 + 36*D1*Dd*f**2*s - 18*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 84*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 84*D1*Dd*f*fd*s + 36*D1*Dd*f*fd - 36*D1*Dd*f*r**2 - 72*D1*Dd*f*r*s + 54*D1*Dd*f*r - 36*D1*Dd*f*s**2 + 54*D1*Dd*f*s - 27*D1*Dd*f + 8*D1*Dd*fd*r**2 + 16*D1*Dd*fd*r*s - 14*D1*Dd*fd*r + 8*D1*Dd*fd*s**2 - 14*D1*Dd*fd*s + 6*D1*Dd*fd + 12*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 4*D1*Ddd*f*r**2 + 8*D1*Ddd*f*r*s - 6*D1*Ddd*f*r + 4*D1*Ddd*f*s**2 - 6*D1*Ddd*f*s + 3*D1*Ddd*f - 2*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 21*r**2 - 42*r*s + 28*r - 21*s**2 + 28*s - 14) - Dd*(3*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 36*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 18*Dd**2*f**2 + 12*Dd**2*f*r**2 + 24*Dd**2*f*r*s - 18*Dd**2*f*r + 12*Dd**2*f*s**2 - 18*Dd**2*f*s + 6*Dd**2*f))/(42*d**2*k1*k3**2) - D1**2*Pk1*Pkdd3*f*k1**4*k2**2*st**4*(2*C - 1)*(11*D1**2*bd1*f*(r + s - 1)**2 + 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 11*D1*b1*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**6) - D1**2*Pk1*Pkdd3*k1**6*st**2*(2*C - 1)*(66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 66*D1**2*b1*f*fd*s + 33*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 51*D1**2*f**2*fd*r**2 + 102*D1**2*f**2*fd*r*s - 68*D1**2*f**2*fd*r + 51*D1**2*f**2*fd*s**2 - 68*D1**2*f**2*fd*s + 34*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 198*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2*s**2 - 198*D1*Dd*b1*f**2*s + 99*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 68*D1*Dd*f**3*r**2 + 136*D1*Dd*f**3*r*s - 102*D1*Dd*f**3*r + 68*D1*Dd*f**3*s**2 - 102*D1*Dd*f**3*s + 51*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 + 33*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3)/(1386*d**2*k3**6) - D1**2*Pk1*Pkdd3*k1**6*(5*D1**2*K*b1**2*fd*r**2 + 10*D1**2*K*b1**2*fd*r*s + 5*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r**2 - 12*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 + 8*D1**2*K*b1*f*fd*r**2 + 16*D1**2*K*b1*f*fd*r*s - 8*D1**2*K*b1*f*fd*r + 8*D1**2*K*b1*f*fd*s**2 - 8*D1**2*K*b1*f*fd*s + 4*D1**2*K*b1*f*fd - 10*D1**2*K*b1*f*fdd*r**2 - 20*D1**2*K*b1*f*fdd*r*s + 10*D1**2*K*b1*f*fdd*r - 10*D1**2*K*b1*f*fdd*s**2 + 10*D1**2*K*b1*f*fdd*s - 5*D1**2*K*b1*f*fdd - 10*D1**2*K*b1*fd**2*r**2 - 20*D1**2*K*b1*fd**2*r*s + 10*D1**2*K*b1*fd**2*r - 10*D1**2*K*b1*fd**2*s**2 + 10*D1**2*K*b1*fd**2*s - 12*D1**2*K*bd1**2*f*(r + s - 1)**2 - 10*D1**2*b1*f*gd2*r**2 - 20*D1**2*b1*f*gd2*r*s + 20*D1**2*b1*f*gd2*r - 10*D1**2*b1*f*gd2*s**2 + 20*D1**2*b1*f*gd2*s - 10*D1**2*b1*f*gd2 + 12*D1**2*b1*f*gdd2*r**2 + 24*D1**2*b1*f*gdd2*r*s - 24*D1**2*b1*f*gdd2*r + 12*D1**2*b1*f*gdd2*s**2 - 24*D1**2*b1*f*gdd2*s + 12*D1**2*b1*f*gdd2 - 10*D1**2*b1*fd*g2*r**2 - 20*D1**2*b1*fd*g2*r*s - 10*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r**2 + 48*D1**2*b1*fd*gd2*r*s - 24*D1**2*b1*fd*gd2*r + 24*D1**2*b1*fd*gd2*s**2 - 24*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r**2 + 24*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(12*K*b1 + 5*K*f - 12*g2) - 8*D1**2*f**2*gd2*r**2 - 16*D1**2*f**2*gd2*r*s + 16*D1**2*f**2*gd2*r - 8*D1**2*f**2*gd2*s**2 + 16*D1**2*f**2*gd2*s - 8*D1**2*f**2*gd2 + 10*D1**2*f**2*gdd2*r**2 + 20*D1**2*f**2*gdd2*r*s - 20*D1**2*f**2*gdd2*r + 10*D1**2*f**2*gdd2*s**2 - 20*D1**2*f**2*gdd2*s + 10*D1**2*f**2*gdd2 - 16*D1**2*f*fd*g2*r**2 - 32*D1**2*f*fd*g2*r*s + 16*D1**2*f*fd*g2*r - 16*D1**2*f*fd*g2*s**2 + 16*D1**2*f*fd*g2*s - 8*D1**2*f*fd*g2 + 40*D1**2*f*fd*gd2*r**2 + 80*D1**2*f*fd*gd2*r*s - 60*D1**2*f*fd*gd2*r + 40*D1**2*f*fd*gd2*s**2 - 60*D1**2*f*fd*gd2*s + 20*D1**2*f*fd*gd2 + 20*D1**2*f*fdd*g2*r**2 + 40*D1**2*f*fdd*g2*r*s - 20*D1**2*f*fdd*g2*r + 20*D1**2*f*fdd*g2*s**2 - 20*D1**2*f*fdd*g2*s + 10*D1**2*f*fdd*g2 + 20*D1**2*fd**2*g2*r**2 + 40*D1**2*fd**2*g2*r*s - 20*D1**2*fd**2*g2*r + 20*D1**2*fd**2*g2*s**2 - 20*D1**2*fd**2*g2*s + 20*D1*Dd*K*b1**2*f*r**2 + 40*D1*Dd*K*b1**2*f*r*s - 30*D1*Dd*K*b1**2*f*r + 20*D1*Dd*K*b1**2*f*s**2 - 30*D1*Dd*K*b1**2*f*s + 15*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 96*D1*Dd*K*b1**2*fd*r*s + 36*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 36*D1*Dd*K*b1**2*fd*s + 16*D1*Dd*K*b1*f**2*r**2 + 32*D1*Dd*K*b1*f**2*r*s - 24*D1*Dd*K*b1*f**2*r + 16*D1*Dd*K*b1*f**2*s**2 - 24*D1*Dd*K*b1*f**2*s + 12*D1*Dd*K*b1*f**2 - 80*D1*Dd*K*b1*f*fd*r**2 - 160*D1*Dd*K*b1*f*fd*r*s + 100*D1*Dd*K*b1*f*fd*r - 80*D1*Dd*K*b1*f*fd*s**2 + 100*D1*Dd*K*b1*f*fd*s - 30*D1*Dd*K*b1*f*fd - 40*D1*Dd*b1*f*g2*r**2 - 80*D1*Dd*b1*f*g2*r*s + 60*D1*Dd*b1*f*g2*r - 40*D1*Dd*b1*f*g2*s**2 + 60*D1*Dd*b1*f*g2*s - 30*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 192*D1*Dd*b1*f*gd2*r*s - 168*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 168*D1*Dd*b1*f*gd2*s + 72*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 192*D1*Dd*b1*fd*g2*r*s - 72*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 72*D1*Dd*b1*fd*g2*s - 32*D1*Dd*f**2*g2*r**2 - 64*D1*Dd*f**2*g2*r*s + 48*D1*Dd*f**2*g2*r - 32*D1*Dd*f**2*g2*s**2 + 48*D1*Dd*f**2*g2*s - 24*D1*Dd*f**2*g2 + 80*D1*Dd*f**2*gd2*r**2 + 160*D1*Dd*f**2*gd2*r*s - 140*D1*Dd*f**2*gd2*r + 80*D1*Dd*f**2*gd2*s**2 - 140*D1*Dd*f**2*gd2*s + 60*D1*Dd*f**2*gd2 + 160*D1*Dd*f*fd*g2*r**2 + 320*D1*Dd*f*fd*g2*r*s - 200*D1*Dd*f*fd*g2*r + 160*D1*Dd*f*fd*g2*s**2 - 200*D1*Dd*f*fd*g2*s + 60*D1*Dd*f*fd*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 48*D1*Ddd*K*b1**2*f*r*s + 36*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 36*D1*Ddd*K*b1**2*f*s - 18*D1*Ddd*K*b1**2*f - 20*D1*Ddd*K*b1*f**2*r**2 - 40*D1*Ddd*K*b1*f**2*r*s + 30*D1*Ddd*K*b1*f**2*r - 20*D1*Ddd*K*b1*f**2*s**2 + 30*D1*Ddd*K*b1*f**2*s - 15*D1*Ddd*K*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 96*D1*Ddd*b1*f*g2*r*s - 72*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 72*D1*Ddd*b1*f*g2*s + 36*D1*Ddd*b1*f*g2 + 40*D1*Ddd*f**2*g2*r**2 + 80*D1*Ddd*f**2*g2*r*s - 60*D1*Ddd*f**2*g2*r + 40*D1*Ddd*f**2*g2*s**2 - 60*D1*Ddd*f**2*g2*s + 30*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(2*K*f**2*(r + s - 1) + f*(5*K*(b1*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - 5*g2*(r + s - 1) + 12*gd2*(r + s - 1)) + 12*fd*(r + s)*(-K*b1 + g2)) + Dd*f*(4*r + 4*s - 3)*(-12*K*b1 - 5*K*f + 12*g2))*(r + s - 1) - 72*Dd**2*K*b1**2*f*r**2 - 144*Dd**2*K*b1**2*f*r*s + 108*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 108*Dd**2*K*b1**2*f*s - 36*Dd**2*K*b1**2*f - 60*Dd**2*K*b1*f**2*r**2 - 120*Dd**2*K*b1*f**2*r*s + 90*Dd**2*K*b1*f**2*r - 60*Dd**2*K*b1*f**2*s**2 + 90*Dd**2*K*b1*f**2*s - 30*Dd**2*K*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 288*Dd**2*b1*f*g2*r*s - 216*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 216*Dd**2*b1*f*g2*s + 72*Dd**2*b1*f*g2 + 120*Dd**2*f**2*g2*r**2 + 240*Dd**2*f**2*g2*r*s - 180*Dd**2*f**2*g2*r + 120*Dd**2*f**2*g2*s**2 - 180*Dd**2*f**2*g2*s + 60*Dd**2*f**2*g2)/(21*d**2*k3**6) - D1**2*Pk1*Pkdd3*k1**4*k2**2*st**2*(-2574*C*D1**2*f**2*fd*r**2 - 5148*C*D1**2*f**2*fd*r*s + 3432*C*D1**2*f**2*fd*r - 2574*C*D1**2*f**2*fd*s**2 + 3432*C*D1**2*f**2*fd*s - 1716*C*D1**2*f**2*fd - 3432*C*D1*Dd*f**3*r**2 - 6864*C*D1*Dd*f**3*r*s + 5148*C*D1*Dd*f**3*r - 3432*C*D1*Dd*f**3*s**2 + 5148*C*D1*Dd*f**3*s - 2574*C*D1*Dd*f**3 - 2574*D1**2*K*bdd1*f**2*r**2 - 5148*D1**2*K*bdd1*f**2*r*s + 5148*D1**2*K*bdd1*f**2*r - 2574*D1**2*K*bdd1*f**2*s**2 + 5148*D1**2*K*bdd1*f**2*s - 2574*D1**2*K*bdd1*f**2 + 858*D1**2*bd1**2*f*(-6*K + 5*f)*(r + s - 1)**2 + 1300*D1**2*bdd1*f**3*r**2 + 2600*D1**2*bdd1*f**3*r*s - 2600*D1**2*bdd1*f**3*r + 1300*D1**2*bdd1*f**3*s**2 - 2600*D1**2*bdd1*f**3*s + 1300*D1**2*bdd1*f**3 + 5148*D1**2*bdd1*f*g2*r**2 + 10296*D1**2*bdd1*f*g2*r*s - 10296*D1**2*bdd1*f*g2*r + 5148*D1**2*bdd1*f*g2*s**2 - 10296*D1**2*bdd1*f*g2*s + 5148*D1**2*bdd1*f*g2 + 660*D1**2*f**3*fd*r**2 + 1320*D1**2*f**3*fd*r*s - 990*D1**2*f**3*fd*r + 660*D1**2*f**3*fd*s**2 - 990*D1**2*f**3*fd*s + 495*D1**2*f**3*fd - 980*D1**2*f**3*fdd*r**2 - 1960*D1**2*f**3*fdd*r*s + 1470*D1**2*f**3*fdd*r - 980*D1**2*f**3*fdd*s**2 + 1470*D1**2*f**3*fdd*s - 735*D1**2*f**3*fdd - 2940*D1**2*f**2*fd**2*r**2 - 5880*D1**2*f**2*fd**2*r*s + 4410*D1**2*f**2*fd**2*r - 2940*D1**2*f**2*fd**2*s**2 + 4410*D1**2*f**2*fd**2*s - 1470*D1**2*f**2*fd**2 + 1287*D1**2*f**2*fd*r**2 + 2574*D1**2*f**2*fd*r*s - 1716*D1**2*f**2*fd*r + 1287*D1**2*f**2*fd*s**2 - 1716*D1**2*f**2*fd*s + 858*D1**2*f**2*fd - 9438*D1**2*f**2*gd2*r**2 - 18876*D1**2*f**2*gd2*r*s + 18876*D1**2*f**2*gd2*r - 9438*D1**2*f**2*gd2*s**2 + 18876*D1**2*f**2*gd2*s - 9438*D1**2*f**2*gd2 + 5148*D1**2*f**2*gdd2*r**2 + 10296*D1**2*f**2*gdd2*r*s - 10296*D1**2*f**2*gdd2*r + 5148*D1**2*f**2*gdd2*s**2 - 10296*D1**2*f**2*gdd2*s + 5148*D1**2*f**2*gdd2 - 18876*D1**2*f*fd*g2*r**2 - 37752*D1**2*f*fd*g2*r*s + 18876*D1**2*f*fd*g2*r - 18876*D1**2*f*fd*g2*s**2 + 18876*D1**2*f*fd*g2*s - 9438*D1**2*f*fd*g2 + 20592*D1**2*f*fd*gd2*r**2 + 41184*D1**2*f*fd*gd2*r*s - 30888*D1**2*f*fd*gd2*r + 20592*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 10296*D1**2*f*fd*gd2 + 10296*D1**2*f*fdd*g2*r**2 + 20592*D1**2*f*fdd*g2*r*s - 10296*D1**2*f*fdd*g2*r + 10296*D1**2*f*fdd*g2*s**2 - 10296*D1**2*f*fdd*g2*s + 5148*D1**2*f*fdd*g2 + 10296*D1**2*fd**2*g2*r**2 + 20592*D1**2*fd**2*g2*r*s - 10296*D1**2*fd**2*g2*r + 10296*D1**2*fd**2*g2*s**2 - 10296*D1**2*fd**2*g2*s + 660*D1*Dd*f**4*r**2 + 1320*D1*Dd*f**4*r*s - 990*D1*Dd*f**4*r + 660*D1*Dd*f**4*s**2 - 990*D1*Dd*f**4*s + 495*D1*Dd*f**4 - 7840*D1*Dd*f**3*fd*r**2 - 15680*D1*Dd*f**3*fd*r*s + 11760*D1*Dd*f**3*fd*r - 7840*D1*Dd*f**3*fd*s**2 + 11760*D1*Dd*f**3*fd*s - 4410*D1*Dd*f**3*fd + 1716*D1*Dd*f**3*r**2 + 3432*D1*Dd*f**3*r*s - 2574*D1*Dd*f**3*r + 1716*D1*Dd*f**3*s**2 - 2574*D1*Dd*f**3*s + 1287*D1*Dd*f**3 - 37752*D1*Dd*f**2*g2*r**2 - 75504*D1*Dd*f**2*g2*r*s + 56628*D1*Dd*f**2*g2*r - 37752*D1*Dd*f**2*g2*s**2 + 56628*D1*Dd*f**2*g2*s - 28314*D1*Dd*f**2*g2 + 41184*D1*Dd*f**2*gd2*r**2 + 82368*D1*Dd*f**2*gd2*r*s - 72072*D1*Dd*f**2*gd2*r + 41184*D1*Dd*f**2*gd2*s**2 - 72072*D1*Dd*f**2*gd2*s + 30888*D1*Dd*f**2*gd2 + 82368*D1*Dd*f*fd*g2*r**2 + 164736*D1*Dd*f*fd*g2*r*s - 102960*D1*Dd*f*fd*g2*r + 82368*D1*Dd*f*fd*g2*s**2 - 102960*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 980*D1*Ddd*f**4*r**2 - 1960*D1*Ddd*f**4*r*s + 1470*D1*Ddd*f**4*r - 980*D1*Ddd*f**4*s**2 + 1470*D1*Ddd*f**4*s - 735*D1*Ddd*f**4 + 20592*D1*Ddd*f**2*g2*r**2 + 41184*D1*Ddd*f**2*g2*r*s - 30888*D1*Ddd*f**2*g2*r + 20592*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 15444*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(134*f**3*(r + s - 1) + f**2*(66*C*(r + s - 1) - 363*K*r - 363*K*s + 363*K + 462*b1*(r + s - 1) - 600*fd*r - 600*fd*s + 400*fd - 33*r - 33*s + 33) - 66*f*(19*K*b1*(r + s - 1) - 6*K*fd*(2*r + 2*s - 1) + 10*b1*fd*(2*r + 2*s - 1) - 19*g2*(r + s - 1) + 12*gd2*(r + s - 1)) - 792*fd*(r + s)*(-K*b1 + g2)) - 4*Dd*f*(4*r + 4*s - 3)*(-99*K*f + 33*b1*(-6*K + 5*f) + 50*f**2 + 198*g2))*(r + s - 1) - 2940*Dd**2*f**4*r**2 - 5880*Dd**2*f**4*r*s + 4410*Dd**2*f**4*r - 2940*Dd**2*f**4*s**2 + 4410*Dd**2*f**4*s - 1470*Dd**2*f**4 + 61776*Dd**2*f**2*g2*r**2 + 123552*Dd**2*f**2*g2*r*s - 92664*Dd**2*f**2*g2*r + 61776*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 30888*Dd**2*f**2*g2 - 429*b1**2*(D1**2*(f*(7*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(19*K*fd*(r + s) - 6*K*fdd*(r + s) + 10*fd**2*(r + s - 1))) + D1*(Dd*(12*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 7*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(19*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - Ddd*f*(-6*K + 5*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-6*K + 5*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 13*b1*(66*D1**2*bdd1*f*(-6*K + 5*f)*(r + s - 1)**2 + D1**2*(-2*f**2*(67*fd - 50*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(-198*K*fdd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 200*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 33*fd*(2*C - 11*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 1254*gd2*(r + s - 1)**2 + 396*gdd2*(r + s - 1)**2) + (-66*r - 66*s)*(6*K*fd**2*(r + s - 1) + 19*fd*g2*(r + s) - 12*fd*gd2*(r + s - 1) - 6*fdd*g2*(r + s))) + D1*(Dd*(-134*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-66*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 200*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + (363*K + 33)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 66*f*(19*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*fd*(-2*r - 2*s + 1) + 2*gd2*(r + s - 1))*(-24*r - 24*s + 18)) + 792*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 2*Ddd*f*(-99*K*f + 50*f**2 + 198*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f*(-99*K*f + 50*f**2 + 198*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(18018*d**2*k3**6) - D1**2*Pk1*Pkdd3*k1**4*st**2*(2*C - 1)*(33*D1*b1*(D1*bd1*(9*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*D1*f*fd*r - 2*D1*f*fd*s + D1*f*fd + 2*D1*f*fdd*r + 2*D1*f*fdd*s - D1*f*fdd + 2*D1*fd**2*r + 2*D1*fd**2*s - 2*D1*fd**2 - 2*Dd*bd1*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 8*Dd*f*fd*r + 8*Dd*f*fd*s - 6*Dd*f*fd) + 33*b1**2*(D1**2*(9*fd - fdd)*(r + s - 1)**2 + D1*(Dd*(9*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(-66*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 33*D1**2*bdd1*f*(2*r + 2*s - 1) - 51*D1**2*f*fd*r**2 - 102*D1**2*f*fd*r*s + 68*D1**2*f*fd*r - 51*D1**2*f*fd*s**2 + 68*D1**2*f*fd*s - 34*D1**2*f*fd + 75*D1**2*f*fdd*r**2 + 150*D1**2*f*fdd*r*s - 100*D1**2*f*fdd*r + 75*D1**2*f*fdd*s**2 - 100*D1**2*f*fdd*s + 50*D1**2*f*fdd + 150*D1**2*fd**2*r**2 + 300*D1**2*fd**2*r*s - 200*D1**2*fd**2*r + 150*D1**2*fd**2*s**2 - 200*D1**2*fd**2*s + 50*D1**2*fd**2 - 68*D1*Dd*f**2*r**2 - 136*D1*Dd*f**2*r*s + 102*D1*Dd*f**2*r - 68*D1*Dd*f**2*s**2 + 102*D1*Dd*f**2*s - 51*D1*Dd*f**2 + 600*D1*Dd*f*fd*r**2 + 1200*D1*Dd*f*fd*r*s - 850*D1*Dd*f*fd*r + 600*D1*Dd*f*fd*s**2 - 850*D1*Dd*f*fd*s + 300*D1*Dd*f*fd + 100*D1*Ddd*f**2*r**2 + 200*D1*Ddd*f**2*r*s - 150*D1*Ddd*f**2*r + 100*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 75*D1*Ddd*f**2 + 33*D1*bd1*(D1*f*(2*r + 2*s - 1) - 2*D1*fd*(r + s - 1) - 2*Dd*f*(4*r + 4*s - 3)) + 300*Dd**2*f**2*r**2 + 600*Dd**2*f**2*r*s - 450*Dd**2*f**2*r + 300*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 150*Dd**2*f**2))/(1386*d**2*k3**4) + D1**2*Pk1*Pkdd3*k1**4*(12*D1**2*K*bd1**2*f*r + 12*D1**2*K*bd1**2*f*s - 12*D1**2*K*bd1**2*f + 4*D1**2*K*bd1*f**2*r**2 + 8*D1**2*K*bd1*f**2*r*s - 8*D1**2*K*bd1*f**2*r + 4*D1**2*K*bd1*f**2*s**2 - 8*D1**2*K*bd1*f**2*s + 4*D1**2*K*bd1*f**2 - 20*D1**2*K*bd1*f*fd*r**2 - 40*D1**2*K*bd1*f*fd*r*s + 30*D1**2*K*bd1*f*fd*r - 20*D1**2*K*bd1*f*fd*s**2 + 30*D1**2*K*bd1*f*fd*s - 10*D1**2*K*bd1*f*fd - 5*D1**2*K*bdd1*f**2*r**2 - 10*D1**2*K*bdd1*f**2*r*s + 10*D1**2*K*bdd1*f**2*r - 5*D1**2*K*bdd1*f**2*s**2 + 10*D1**2*K*bdd1*f**2*s - 5*D1**2*K*bdd1*f**2 - 28*D1**2*bd1**2*g2*r**2 - 56*D1**2*bd1**2*g2*r*s + 28*D1**2*bd1**2*g2*r - 28*D1**2*bd1**2*g2*s**2 + 28*D1**2*bd1**2*g2*s - 12*D1**2*bd1*bd2*f*r**2 - 24*D1**2*bd1*bd2*f*r*s + 24*D1**2*bd1*bd2*f*r - 12*D1**2*bd1*bd2*f*s**2 + 24*D1**2*bd1*bd2*f*s - 12*D1**2*bd1*bd2*f + 20*D1**2*bd1*f*g2*r + 20*D1**2*bd1*f*g2*s - 10*D1**2*bd1*f*g2 - 24*D1**2*bd1*f*gd2*r - 24*D1**2*bd1*f*gd2*s + 24*D1**2*bd1*f*gd2 + 4*D1**2*bd2*f**2*r**2 + 8*D1**2*bd2*f**2*r*s - 8*D1**2*bd2*f**2*r + 4*D1**2*bd2*f**2*s**2 - 8*D1**2*bd2*f**2*s + 4*D1**2*bd2*f**2 - 20*D1**2*bd2*f*fd*r**2 - 40*D1**2*bd2*f*fd*r*s + 30*D1**2*bd2*f*fd*r - 20*D1**2*bd2*f*fd*s**2 + 30*D1**2*bd2*f*fd*s - 10*D1**2*bd2*f*fd - 24*D1**2*bdd1*f*g2*r - 24*D1**2*bdd1*f*g2*s + 12*D1**2*bdd1*f*g2 - 5*D1**2*bdd2*f**2*r**2 - 10*D1**2*bdd2*f**2*r*s + 10*D1**2*bdd2*f**2*r - 5*D1**2*bdd2*f**2*s**2 + 10*D1**2*bdd2*f**2*s - 5*D1**2*bdd2*f**2 - 8*D1**2*f**2*gd2*r**2 - 16*D1**2*f**2*gd2*r*s + 16*D1**2*f**2*gd2*r - 8*D1**2*f**2*gd2*s**2 + 16*D1**2*f**2*gd2*s - 8*D1**2*f**2*gd2 + 10*D1**2*f**2*gdd2*r**2 + 20*D1**2*f**2*gdd2*r*s - 20*D1**2*f**2*gdd2*r + 10*D1**2*f**2*gdd2*s**2 - 20*D1**2*f**2*gdd2*s + 10*D1**2*f**2*gdd2 - 16*D1**2*f*fd*g2*r**2 - 32*D1**2*f*fd*g2*r*s + 16*D1**2*f*fd*g2*r - 16*D1**2*f*fd*g2*s**2 + 16*D1**2*f*fd*g2*s - 8*D1**2*f*fd*g2 + 40*D1**2*f*fd*gd2*r**2 + 80*D1**2*f*fd*gd2*r*s - 60*D1**2*f*fd*gd2*r + 40*D1**2*f*fd*gd2*s**2 - 60*D1**2*f*fd*gd2*s + 20*D1**2*f*fd*gd2 + 20*D1**2*f*fdd*g2*r**2 + 40*D1**2*f*fdd*g2*r*s - 20*D1**2*f*fdd*g2*r + 20*D1**2*f*fdd*g2*s**2 - 20*D1**2*f*fdd*g2*s + 10*D1**2*f*fdd*g2 + 20*D1**2*fd**2*g2*r**2 + 40*D1**2*fd**2*g2*r*s - 20*D1**2*fd**2*g2*r + 20*D1**2*fd**2*g2*s**2 - 20*D1**2*fd**2*g2*s - 40*D1*Dd*K*bd1*f**2*r**2 - 80*D1*Dd*K*bd1*f**2*r*s + 70*D1*Dd*K*bd1*f**2*r - 40*D1*Dd*K*bd1*f**2*s**2 + 70*D1*Dd*K*bd1*f**2*s - 30*D1*Dd*K*bd1*f**2 - 96*D1*Dd*bd1*f*g2*r - 96*D1*Dd*bd1*f*g2*s + 72*D1*Dd*bd1*f*g2 - 40*D1*Dd*bd2*f**2*r**2 - 80*D1*Dd*bd2*f**2*r*s + 70*D1*Dd*bd2*f**2*r - 40*D1*Dd*bd2*f**2*s**2 + 70*D1*Dd*bd2*f**2*s - 30*D1*Dd*bd2*f**2 - 32*D1*Dd*f**2*g2*r**2 - 64*D1*Dd*f**2*g2*r*s + 48*D1*Dd*f**2*g2*r - 32*D1*Dd*f**2*g2*s**2 + 48*D1*Dd*f**2*g2*s - 24*D1*Dd*f**2*g2 + 80*D1*Dd*f**2*gd2*r**2 + 160*D1*Dd*f**2*gd2*r*s - 140*D1*Dd*f**2*gd2*r + 80*D1*Dd*f**2*gd2*s**2 - 140*D1*Dd*f**2*gd2*s + 60*D1*Dd*f**2*gd2 + 160*D1*Dd*f*fd*g2*r**2 + 320*D1*Dd*f*fd*g2*r*s - 200*D1*Dd*f*fd*g2*r + 160*D1*Dd*f*fd*g2*s**2 - 200*D1*Dd*f*fd*g2*s + 60*D1*Dd*f*fd*g2 + 40*D1*Ddd*f**2*g2*r**2 + 80*D1*Ddd*f**2*g2*r*s - 60*D1*Ddd*f**2*g2*r + 40*D1*Ddd*f**2*g2*s**2 - 60*D1*Ddd*f**2*g2*s + 30*D1*Ddd*f**2*g2 + 120*Dd**2*f**2*g2*r**2 + 240*Dd**2*f**2*g2*r*s - 180*Dd**2*f**2*g2*r + 120*Dd**2*f**2*g2*s**2 - 180*Dd**2*f**2*g2*s + 60*Dd**2*f**2*g2 - 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(K*(-14*bd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 7*bdd1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + (5*fd - 6*fdd)*(2*r + 2*s - 1)) + 28*gd2*(r + s - 1)**2 - 14*gdd2*(r + s - 1)**2) + 2*D1*(Dd*(14*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - (4*r + 4*s - 3)*(-7*K*bd1*(3*r + 3*s - 2) + 6*K*fd + 14*gd2*(r + s - 1))) - 7*Ddd*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 84*Dd**2*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(42*D1**2*K*bd1**2*r**2 + 84*D1**2*K*bd1**2*r*s - 56*D1**2*K*bd1**2*r + 42*D1**2*K*bd1**2*s**2 - 56*D1**2*K*bd1**2*s + 14*D1**2*K*bd1**2 - 10*D1**2*K*bd1*f*r - 10*D1**2*K*bd1*f*s + 5*D1**2*K*bd1*f - 12*D1**2*K*bd1*fd*r - 12*D1**2*K*bd1*fd*s + 12*D1**2*K*bd1*fd + 12*D1**2*K*bdd1*f*r + 12*D1**2*K*bdd1*f*s - 6*D1**2*K*bdd1*f + 8*D1**2*K*f*fd*r**2 + 16*D1**2*K*f*fd*r*s - 8*D1**2*K*f*fd*r + 8*D1**2*K*f*fd*s**2 - 8*D1**2*K*f*fd*s + 4*D1**2*K*f*fd - 10*D1**2*K*f*fdd*r**2 - 20*D1**2*K*f*fdd*r*s + 10*D1**2*K*f*fdd*r - 10*D1**2*K*f*fdd*s**2 + 10*D1**2*K*f*fdd*s - 5*D1**2*K*f*fdd - 10*D1**2*K*fd**2*r**2 - 20*D1**2*K*fd**2*r*s + 10*D1**2*K*fd**2*r - 10*D1**2*K*fd**2*s**2 + 10*D1**2*K*fd**2*s + 56*D1**2*bd1*g2*r**2 + 112*D1**2*bd1*g2*r*s - 56*D1**2*bd1*g2*r + 56*D1**2*bd1*g2*s**2 - 56*D1**2*bd1*g2*s + 28*D1**2*bd1*g2 - 56*D1**2*bd1*gd2*r**2 - 112*D1**2*bd1*gd2*r*s + 84*D1**2*bd1*gd2*r - 56*D1**2*bd1*gd2*s**2 + 84*D1**2*bd1*gd2*s - 28*D1**2*bd1*gd2 - 28*D1**2*bdd1*g2*r**2 - 56*D1**2*bdd1*g2*r*s + 28*D1**2*bdd1*g2*r - 28*D1**2*bdd1*g2*s**2 + 28*D1**2*bdd1*g2*s - 14*D1**2*bdd1*g2 - 6*D1**2*bdd2*f*(r + s - 1)**2 - 20*D1**2*fd*g2*r - 20*D1**2*fd*g2*s + 10*D1**2*fd*g2 + 24*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s - 24*D1**2*fd*gd2 + 24*D1**2*fdd*g2*r + 24*D1**2*fdd*g2*s - 12*D1**2*fdd*g2 + 48*D1*Dd*K*bd1*f*r + 48*D1*Dd*K*bd1*f*s - 36*D1*Dd*K*bd1*f + 16*D1*Dd*K*f**2*r**2 + 32*D1*Dd*K*f**2*r*s - 24*D1*Dd*K*f**2*r + 16*D1*Dd*K*f**2*s**2 - 24*D1*Dd*K*f**2*s + 12*D1*Dd*K*f**2 - 80*D1*Dd*K*f*fd*r**2 - 160*D1*Dd*K*f*fd*r*s + 100*D1*Dd*K*f*fd*r - 80*D1*Dd*K*f*fd*s**2 + 100*D1*Dd*K*f*fd*s - 30*D1*Dd*K*f*fd - 224*D1*Dd*bd1*g2*r**2 - 448*D1*Dd*bd1*g2*r*s + 280*D1*Dd*bd1*g2*r - 224*D1*Dd*bd1*g2*s**2 + 280*D1*Dd*bd1*g2*s - 84*D1*Dd*bd1*g2 + 96*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s - 72*D1*Dd*fd*g2 - 20*D1*Ddd*K*f**2*r**2 - 40*D1*Ddd*K*f**2*r*s + 30*D1*Ddd*K*f**2*r - 20*D1*Ddd*K*f**2*s**2 + 30*D1*Ddd*K*f**2*s - 15*D1*Ddd*K*f**2 + D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 60*Dd**2*K*f**2*r**2 - 120*Dd**2*K*f**2*r*s + 90*Dd**2*K*f**2*r - 60*Dd**2*K*f**2*s**2 + 90*Dd**2*K*f**2*s - 30*Dd**2*K*f**2) + b2*(5*D1**2*b1*fd*r**2 + 10*D1**2*b1*fd*r*s + 5*D1**2*b1*fd*s**2 - 6*D1**2*b1*fdd*r**2 - 12*D1**2*b1*fdd*r*s - 6*D1**2*b1*fdd*s**2 - 6*D1**2*bdd1*f*(r + s - 1)**2 + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 20*D1*Dd*b1*f*r**2 + 40*D1*Dd*b1*f*r*s - 30*D1*Dd*b1*f*r + 20*D1*Dd*b1*f*s**2 - 30*D1*Dd*b1*f*s + 15*D1*Dd*b1*f - 48*D1*Dd*b1*fd*r**2 - 96*D1*Dd*b1*fd*r*s + 36*D1*Dd*b1*fd*r - 48*D1*Dd*b1*fd*s**2 + 36*D1*Dd*b1*fd*s + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 100*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 24*D1*Ddd*b1*f*r**2 - 48*D1*Ddd*b1*f*r*s + 36*D1*Ddd*b1*f*r - 24*D1*Ddd*b1*f*s**2 + 36*D1*Ddd*b1*f*s - 18*D1*Ddd*b1*f - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*b1*f*r**2 - 144*Dd**2*b1*f*r*s + 108*Dd**2*b1*f*r - 72*Dd**2*b1*f*s**2 + 108*Dd**2*b1*f*s - 36*Dd**2*b1*f - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2))/(21*d**2*k3**4) + D1**2*Pk1*Pkdd3*k1**2*k2**4*st**6*(10*C - 5)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(1386*d**2*k3**6) + D1**2*Pk1*Pkdd3*k1**2*k2**4*st**4*(-858*D1**2*K*bd1**2*f*(r + s - 1)**2 + D1**2*f*(858*bdd1*g2*(r + s - 1)**2 - f**2*(161*fd - 100*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 600*f*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 429*D1*bd1*(D1*(f**2*(-2*C + 2*b1 + 1)*(r + s - 1) - 4*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 4*fd*(r + s)*(-K*b1 + g2)) + 4*Dd*f*(-K*b1 + g2)*(4*r + 4*s - 3))*(r + s - 1) + D1*f**3*(Dd*(-161*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 200*fd*(4*r + 4*s - 3)**2) + 100*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 600*Dd**2*f**4*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 429*b1**2*(D1**2*(K*(2*fd - fdd)*(r + s)**2 + f*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) + D1*(Dd*(2*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 429*b1*(D1**2*(f*(fd*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s - 1)**2*(2*K*bdd1 + 4*gd2 - 2*gdd2)) + (-2*r - 2*s)*(-2*fd*g2*(r + s) + 2*fd*gd2*(r + s - 1) + fdd*g2*(r + s))) + D1*(Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 4*f*(g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 4*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*g2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(3003*d**2*k3**6) + D1**2*Pk1*Pkdd3*k1**2*k2**2*st**4*(2*C - 1)*(11*D1*b1*(2*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + f*(-D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 11*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f*(-22*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 11*D1**2*bd1*f*(r + s - 1)**2 + 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 2*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**4) + D1**2*Pk1*Pkdd3*k1**2*k2**2*st**2*(132*C*D1**2*bd1*f**2*r + 132*C*D1**2*bd1*f**2*s - 66*C*D1**2*bd1*f**2 - 198*C*D1**2*f**2*fd*r**2 - 396*C*D1**2*f**2*fd*r*s + 264*C*D1**2*f**2*fd*r - 198*C*D1**2*f**2*fd*s**2 + 264*C*D1**2*f**2*fd*s - 132*C*D1**2*f**2*fd - 264*C*D1*Dd*f**3*r**2 - 528*C*D1*Dd*f**3*r*s + 396*C*D1*Dd*f**3*r - 264*C*D1*Dd*f**3*s**2 + 396*C*D1*Dd*f**3*s - 198*C*D1*Dd*f**3 - 330*D1**2*K*bd1**2*f*r**2 - 660*D1**2*K*bd1**2*f*r*s + 726*D1**2*K*bd1**2*f*r - 330*D1**2*K*bd1**2*f*s**2 + 726*D1**2*K*bd1**2*f*s - 396*D1**2*K*bd1**2*f + 363*D1**2*K*bd1*f**2*r**2 + 726*D1**2*K*bd1*f**2*r*s - 726*D1**2*K*bd1*f**2*r + 363*D1**2*K*bd1*f**2*s**2 - 726*D1**2*K*bd1*f**2*s + 363*D1**2*K*bd1*f**2 - 792*D1**2*K*bd1*f*fd*r**2 - 1584*D1**2*K*bd1*f*fd*r*s + 1188*D1**2*K*bd1*f*fd*r - 792*D1**2*K*bd1*f*fd*s**2 + 1188*D1**2*K*bd1*f*fd*s - 396*D1**2*K*bd1*f*fd - 198*D1**2*K*bdd1*f**2*r**2 - 396*D1**2*K*bdd1*f**2*r*s + 396*D1**2*K*bdd1*f**2*r - 198*D1**2*K*bdd1*f**2*s**2 + 396*D1**2*K*bdd1*f**2*s - 198*D1**2*K*bdd1*f**2 + 132*D1**2*bd1**2*f**2*r**2 + 264*D1**2*bd1**2*f**2*r*s - 396*D1**2*bd1**2*f**2*r + 132*D1**2*bd1**2*f**2*s**2 - 396*D1**2*bd1**2*f**2*s + 264*D1**2*bd1**2*f**2 + 924*D1**2*bd1**2*g2*r**2 + 1848*D1**2*bd1**2*g2*r*s - 924*D1**2*bd1**2*g2*r + 924*D1**2*bd1**2*g2*s**2 - 924*D1**2*bd1**2*g2*s - 396*D1**2*bd1*bd2*f*r**2 - 792*D1**2*bd1*bd2*f*r*s + 792*D1**2*bd1*bd2*f*r - 396*D1**2*bd1*bd2*f*s**2 + 792*D1**2*bd1*bd2*f*s - 396*D1**2*bd1*bd2*f - 151*D1**2*bd1*f**3*r**2 - 302*D1**2*bd1*f**3*r*s + 268*D1**2*bd1*f**3*r - 151*D1**2*bd1*f**3*s**2 + 268*D1**2*bd1*f**3*s - 134*D1**2*bd1*f**3 + 750*D1**2*bd1*f**2*fd*r**2 + 1500*D1**2*bd1*f**2*fd*r*s - 1150*D1**2*bd1*f**2*fd*r + 750*D1**2*bd1*f**2*fd*s**2 - 1150*D1**2*bd1*f**2*fd*s + 400*D1**2*bd1*f**2*fd - 66*D1**2*bd1*f**2*r - 66*D1**2*bd1*f**2*s + 33*D1**2*bd1*f**2 - 1122*D1**2*bd1*f*g2*r**2 - 2244*D1**2*bd1*f*g2*r*s + 2508*D1**2*bd1*f*g2*r - 1122*D1**2*bd1*f*g2*s**2 + 2508*D1**2*bd1*f*g2*s - 1254*D1**2*bd1*f*g2 + 660*D1**2*bd1*f*gd2*r**2 + 1320*D1**2*bd1*f*gd2*r*s - 1452*D1**2*bd1*f*gd2*r + 660*D1**2*bd1*f*gd2*s**2 - 1452*D1**2*bd1*f*gd2*s + 792*D1**2*bd1*f*gd2 + 660*D1**2*bd1*fd*g2*r**2 + 1320*D1**2*bd1*fd*g2*r*s - 660*D1**2*bd1*fd*g2*r + 660*D1**2*bd1*fd*g2*s**2 - 660*D1**2*bd1*fd*g2*s + 363*D1**2*bd2*f**2*r**2 + 726*D1**2*bd2*f**2*r*s - 726*D1**2*bd2*f**2*r + 363*D1**2*bd2*f**2*s**2 - 726*D1**2*bd2*f**2*s + 363*D1**2*bd2*f**2 - 792*D1**2*bd2*f*fd*r**2 - 1584*D1**2*bd2*f*fd*r*s + 1188*D1**2*bd2*f*fd*r - 792*D1**2*bd2*f*fd*s**2 + 1188*D1**2*bd2*f*fd*s - 396*D1**2*bd2*f*fd + 125*D1**2*bdd1*f**3*r**2 + 250*D1**2*bdd1*f**3*r*s - 200*D1**2*bdd1*f**3*r + 125*D1**2*bdd1*f**3*s**2 - 200*D1**2*bdd1*f**3*s + 100*D1**2*bdd1*f**3 + 330*D1**2*bdd1*f*g2*r**2 + 660*D1**2*bdd1*f*g2*r*s - 792*D1**2*bdd1*f*g2*r + 330*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 198*D1**2*bdd2*f**2*r**2 - 396*D1**2*bdd2*f**2*r*s + 396*D1**2*bdd2*f**2*r - 198*D1**2*bdd2*f**2*s**2 + 396*D1**2*bdd2*f**2*s - 198*D1**2*bdd2*f**2 + 99*D1**2*f**2*fd*r**2 + 198*D1**2*f**2*fd*r*s - 132*D1**2*f**2*fd*r + 99*D1**2*f**2*fd*s**2 - 132*D1**2*f**2*fd*s + 66*D1**2*f**2*fd - 726*D1**2*f**2*gd2*r**2 - 1452*D1**2*f**2*gd2*r*s + 1452*D1**2*f**2*gd2*r - 726*D1**2*f**2*gd2*s**2 + 1452*D1**2*f**2*gd2*s - 726*D1**2*f**2*gd2 + 396*D1**2*f**2*gdd2*r**2 + 792*D1**2*f**2*gdd2*r*s - 792*D1**2*f**2*gdd2*r + 396*D1**2*f**2*gdd2*s**2 - 792*D1**2*f**2*gdd2*s + 396*D1**2*f**2*gdd2 - 1452*D1**2*f*fd*g2*r**2 - 2904*D1**2*f*fd*g2*r*s + 1452*D1**2*f*fd*g2*r - 1452*D1**2*f*fd*g2*s**2 + 1452*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 1584*D1**2*f*fd*gd2*r**2 + 3168*D1**2*f*fd*gd2*r*s - 2376*D1**2*f*fd*gd2*r + 1584*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 792*D1**2*f*fd*gd2 + 792*D1**2*f*fdd*g2*r**2 + 1584*D1**2*f*fdd*g2*r*s - 792*D1**2*f*fdd*g2*r + 792*D1**2*f*fdd*g2*s**2 - 792*D1**2*f*fdd*g2*s + 396*D1**2*f*fdd*g2 + 792*D1**2*fd**2*g2*r**2 + 1584*D1**2*fd**2*g2*r*s - 792*D1**2*fd**2*g2*r + 792*D1**2*fd**2*g2*s**2 - 792*D1**2*fd**2*g2*s - 1584*D1*Dd*K*bd1*f**2*r**2 - 3168*D1*Dd*K*bd1*f**2*r*s + 2772*D1*Dd*K*bd1*f**2*r - 1584*D1*Dd*K*bd1*f**2*s**2 + 2772*D1*Dd*K*bd1*f**2*s - 1188*D1*Dd*K*bd1*f**2 + 1000*D1*Dd*bd1*f**3*r**2 + 2000*D1*Dd*bd1*f**3*r*s - 1550*D1*Dd*bd1*f**3*r + 1000*D1*Dd*bd1*f**3*s**2 - 1550*D1*Dd*bd1*f**3*s + 600*D1*Dd*bd1*f**3 + 2640*D1*Dd*bd1*f*g2*r**2 + 5280*D1*Dd*bd1*f*g2*r*s - 5148*D1*Dd*bd1*f*g2*r + 2640*D1*Dd*bd1*f*g2*s**2 - 5148*D1*Dd*bd1*f*g2*s + 2376*D1*Dd*bd1*f*g2 - 1584*D1*Dd*bd2*f**2*r**2 - 3168*D1*Dd*bd2*f**2*r*s + 2772*D1*Dd*bd2*f**2*r - 1584*D1*Dd*bd2*f**2*s**2 + 2772*D1*Dd*bd2*f**2*s - 1188*D1*Dd*bd2*f**2 + 132*D1*Dd*f**3*r**2 + 264*D1*Dd*f**3*r*s - 198*D1*Dd*f**3*r + 132*D1*Dd*f**3*s**2 - 198*D1*Dd*f**3*s + 99*D1*Dd*f**3 - 2904*D1*Dd*f**2*g2*r**2 - 5808*D1*Dd*f**2*g2*r*s + 4356*D1*Dd*f**2*g2*r - 2904*D1*Dd*f**2*g2*s**2 + 4356*D1*Dd*f**2*g2*s - 2178*D1*Dd*f**2*g2 + 3168*D1*Dd*f**2*gd2*r**2 + 6336*D1*Dd*f**2*gd2*r*s - 5544*D1*Dd*f**2*gd2*r + 3168*D1*Dd*f**2*gd2*s**2 - 5544*D1*Dd*f**2*gd2*s + 2376*D1*Dd*f**2*gd2 + 6336*D1*Dd*f*fd*g2*r**2 + 12672*D1*Dd*f*fd*g2*r*s - 7920*D1*Dd*f*fd*g2*r + 6336*D1*Dd*f*fd*g2*s**2 - 7920*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 + 1584*D1*Ddd*f**2*g2*r**2 + 3168*D1*Ddd*f**2*g2*r*s - 2376*D1*Ddd*f**2*g2*r + 1584*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 1188*D1*Ddd*f**2*g2 + 4752*Dd**2*f**2*g2*r**2 + 9504*Dd**2*f**2*g2*r*s - 7128*Dd**2*f**2*g2*r + 4752*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 2376*Dd**2*f**2*g2 + 33*b1**3*(D1**2*(13*fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(14*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 13*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*(7*K + 3*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(7*K + 3*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(-14*C*D1**2*fd*r**2 - 28*C*D1**2*fd*r*s + 28*C*D1**2*fd*r - 14*C*D1**2*fd*s**2 + 28*C*D1**2*fd*s - 14*C*D1**2*fd - 56*C*D1*Dd*f*r**2 - 112*C*D1*Dd*f*r*s + 84*C*D1*Dd*f*r - 56*C*D1*Dd*f*s**2 + 84*C*D1*Dd*f*s - 42*C*D1*Dd*f + 17*D1**2*K*fd*r**2 + 34*D1**2*K*fd*r*s + 4*D1**2*K*fd*r + 17*D1**2*K*fd*s**2 + 4*D1**2*K*fd*s - 2*D1**2*K*fd - 5*D1**2*K*fdd*r**2 - 10*D1**2*K*fdd*r*s - 2*D1**2*K*fdd*r - 5*D1**2*K*fdd*s**2 - 2*D1**2*K*fdd*s + D1**2*K*fdd - D1**2*bdd1*(7*K + 3*f)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 4*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd + 4*D1**2*f*fdd*r**2 + 8*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*s**2 + 4*D1**2*fd**2*r**2 + 8*D1**2*fd**2*r*s + 4*D1**2*fd**2*s**2 - 4*D1**2*fd**2 + 7*D1**2*fd*r**2 + 14*D1**2*fd*r*s - 14*D1**2*fd*r + 7*D1**2*fd*s**2 - 14*D1**2*fd*s + 7*D1**2*fd - 28*D1**2*gd2*r**2 - 56*D1**2*gd2*r*s + 56*D1**2*gd2*r - 28*D1**2*gd2*s**2 + 56*D1**2*gd2*s - 28*D1**2*gd2 + 14*D1**2*gdd2*r**2 + 28*D1**2*gdd2*r*s - 28*D1**2*gdd2*r + 14*D1**2*gdd2*s**2 - 28*D1**2*gdd2*s + 14*D1**2*gdd2 + 68*D1*Dd*K*f*r**2 + 136*D1*Dd*K*f*r*s - 102*D1*Dd*K*f*r + 68*D1*Dd*K*f*s**2 - 102*D1*Dd*K*f*s + 51*D1*Dd*K*f - 40*D1*Dd*K*fd*r**2 - 80*D1*Dd*K*fd*r*s + 22*D1*Dd*K*fd*r - 40*D1*Dd*K*fd*s**2 + 22*D1*Dd*K*fd*s + 6*D1*Dd*K*fd - 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 32*D1*Dd*f*fd*r**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 32*D1*Dd*f*fd*s**2 - 24*D1*Dd*f*fd*s + 28*D1*Dd*f*r**2 + 56*D1*Dd*f*r*s - 42*D1*Dd*f*r + 28*D1*Dd*f*s**2 - 42*D1*Dd*f*s + 21*D1*Dd*f - 112*D1*Dd*g2*r**2 - 224*D1*Dd*g2*r*s + 168*D1*Dd*g2*r - 112*D1*Dd*g2*s**2 + 168*D1*Dd*g2*s - 84*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 + 224*D1*Dd*gd2*r*s - 196*D1*Dd*gd2*r + 112*D1*Dd*gd2*s**2 - 196*D1*Dd*gd2*s + 84*D1*Dd*gd2 - 20*D1*Ddd*K*f*r**2 - 40*D1*Ddd*K*f*r*s + 30*D1*Ddd*K*f*r - 20*D1*Ddd*K*f*s**2 + 30*D1*Ddd*K*f*s - 15*D1*Ddd*K*f + 8*D1*Ddd*f**2*r**2 + 16*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 8*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 56*D1*Ddd*g2*r**2 + 112*D1*Ddd*g2*r*s - 84*D1*Ddd*g2*r + 56*D1*Ddd*g2*s**2 - 84*D1*Ddd*g2*s + 42*D1*Ddd*g2 + D1*bd1*(D1*(14*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 13*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2)) - 2*Dd*(7*K + 3*f)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 60*Dd**2*K*f*r**2 - 120*Dd**2*K*f*r*s + 90*Dd**2*K*f*r - 60*Dd**2*K*f*s**2 + 90*Dd**2*K*f*s - 30*Dd**2*K*f + 24*Dd**2*f**2*r**2 + 48*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 24*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 12*Dd**2*f**2 + 168*Dd**2*g2*r**2 + 336*Dd**2*g2*r*s - 252*Dd**2*g2*r + 168*Dd**2*g2*s**2 - 252*Dd**2*g2*s + 84*Dd**2*g2) + b1*(-132*C*D1**2*f*fd*r - 132*C*D1**2*f*fd*s + 66*C*D1**2*f*fd - 330*D1**2*K*bdd1*f*r**2 - 660*D1**2*K*bdd1*f*r*s + 726*D1**2*K*bdd1*f*r - 330*D1**2*K*bdd1*f*s**2 + 726*D1**2*K*bdd1*f*s - 363*D1**2*K*bdd1*f + 726*D1**2*K*f*fd*r**2 + 1452*D1**2*K*f*fd*r*s - 726*D1**2*K*f*fd*r + 726*D1**2*K*f*fd*s**2 - 726*D1**2*K*f*fd*s + 363*D1**2*K*f*fd - 396*D1**2*K*f*fdd*r**2 - 792*D1**2*K*f*fdd*r*s + 396*D1**2*K*f*fdd*r - 396*D1**2*K*f*fdd*s**2 + 396*D1**2*K*f*fdd*s - 198*D1**2*K*f*fdd - 396*D1**2*K*fd**2*r**2 - 792*D1**2*K*fd**2*r*s + 396*D1**2*K*fd**2*r - 396*D1**2*K*fd**2*s**2 + 396*D1**2*K*fd**2*s + 627*D1**2*b2*fd*r**2 + 1254*D1**2*b2*fd*r*s + 627*D1**2*b2*fd*s**2 - 198*D1**2*b2*fdd*r**2 - 396*D1**2*b2*fdd*r*s - 198*D1**2*b2*fdd*s**2 - 66*D1**2*bd1**2*(7*K + 3*f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 132*D1**2*bdd1*f**2*r**2 + 264*D1**2*bdd1*f**2*r*s - 396*D1**2*bdd1*f**2*r + 132*D1**2*bdd1*f**2*s**2 - 396*D1**2*bdd1*f**2*s + 198*D1**2*bdd1*f**2 + 924*D1**2*bdd1*g2*r**2 + 1848*D1**2*bdd1*g2*r*s - 924*D1**2*bdd1*g2*r + 924*D1**2*bdd1*g2*s**2 - 924*D1**2*bdd1*g2*s + 462*D1**2*bdd1*g2 - 198*D1**2*bdd2*f*r**2 - 396*D1**2*bdd2*f*r*s + 396*D1**2*bdd2*f*r - 198*D1**2*bdd2*f*s**2 + 396*D1**2*bdd2*f*s - 198*D1**2*bdd2*f - 453*D1**2*f**2*fd*r**2 - 906*D1**2*f**2*fd*r*s + 638*D1**2*f**2*fd*r - 453*D1**2*f**2*fd*s**2 + 638*D1**2*f**2*fd*s - 319*D1**2*f**2*fd + 375*D1**2*f**2*fdd*r**2 + 750*D1**2*f**2*fdd*r*s - 550*D1**2*f**2*fdd*r + 375*D1**2*f**2*fdd*s**2 - 550*D1**2*f**2*fdd*s + 275*D1**2*f**2*fdd + 750*D1**2*f*fd**2*r**2 + 1500*D1**2*f*fd**2*r*s - 1100*D1**2*f*fd**2*r + 750*D1**2*f*fd**2*s**2 - 1100*D1**2*f*fd**2*s + 350*D1**2*f*fd**2 + 66*D1**2*f*fd*r + 66*D1**2*f*fd*s - 33*D1**2*f*fd - 1122*D1**2*f*gd2*r**2 - 2244*D1**2*f*gd2*r*s + 2244*D1**2*f*gd2*r - 1122*D1**2*f*gd2*s**2 + 2244*D1**2*f*gd2*s - 1122*D1**2*f*gd2 + 330*D1**2*f*gdd2*r**2 + 660*D1**2*f*gdd2*r*s - 660*D1**2*f*gdd2*r + 330*D1**2*f*gdd2*s**2 - 660*D1**2*f*gdd2*s + 330*D1**2*f*gdd2 - 1122*D1**2*fd*g2*r**2 - 2244*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*r - 1122*D1**2*fd*g2*s**2 - 264*D1**2*fd*g2*s + 132*D1**2*fd*g2 + 660*D1**2*fd*gd2*r**2 + 1320*D1**2*fd*gd2*r*s - 528*D1**2*fd*gd2*r + 660*D1**2*fd*gd2*s**2 - 528*D1**2*fd*gd2*s - 132*D1**2*fd*gd2 + 330*D1**2*fdd*g2*r**2 + 660*D1**2*fdd*g2*r*s + 132*D1**2*fdd*g2*r + 330*D1**2*fdd*g2*s**2 + 132*D1**2*fdd*g2*s - 66*D1**2*fdd*g2 + 1452*D1*Dd*K*f**2*r**2 + 2904*D1*Dd*K*f**2*r*s - 2178*D1*Dd*K*f**2*r + 1452*D1*Dd*K*f**2*s**2 - 2178*D1*Dd*K*f**2*s + 1089*D1*Dd*K*f**2 - 3168*D1*Dd*K*f*fd*r**2 - 6336*D1*Dd*K*f*fd*r*s + 3960*D1*Dd*K*f*fd*r - 3168*D1*Dd*K*f*fd*s**2 + 3960*D1*Dd*K*f*fd*s - 1188*D1*Dd*K*f*fd + 2508*D1*Dd*b2*f*r**2 + 5016*D1*Dd*b2*f*r*s - 3762*D1*Dd*b2*f*r + 2508*D1*Dd*b2*f*s**2 - 3762*D1*Dd*b2*f*s + 1881*D1*Dd*b2*f - 1584*D1*Dd*b2*fd*r**2 - 3168*D1*Dd*b2*fd*r*s + 1188*D1*Dd*b2*fd*r - 1584*D1*Dd*b2*fd*s**2 + 1188*D1*Dd*b2*fd*s - 604*D1*Dd*f**3*r**2 - 1208*D1*Dd*f**3*r*s + 906*D1*Dd*f**3*r - 604*D1*Dd*f**3*s**2 + 906*D1*Dd*f**3*s - 453*D1*Dd*f**3 + 3000*D1*Dd*f**2*fd*r**2 + 6000*D1*Dd*f**2*fd*r*s - 4450*D1*Dd*f**2*fd*r + 3000*D1*Dd*f**2*fd*s**2 - 4450*D1*Dd*f**2*fd*s + 1650*D1*Dd*f**2*fd - 4488*D1*Dd*f*g2*r**2 - 8976*D1*Dd*f*g2*r*s + 6732*D1*Dd*f*g2*r - 4488*D1*Dd*f*g2*s**2 + 6732*D1*Dd*f*g2*s - 3366*D1*Dd*f*g2 + 2640*D1*Dd*f*gd2*r**2 + 5280*D1*Dd*f*gd2*r*s - 4620*D1*Dd*f*gd2*r + 2640*D1*Dd*f*gd2*s**2 - 4620*D1*Dd*f*gd2*s + 1980*D1*Dd*f*gd2 + 2640*D1*Dd*fd*g2*r**2 + 5280*D1*Dd*fd*g2*r*s - 1452*D1*Dd*fd*g2*r + 2640*D1*Dd*fd*g2*s**2 - 1452*D1*Dd*fd*g2*s - 396*D1*Dd*fd*g2 - 792*D1*Ddd*K*f**2*r**2 - 1584*D1*Ddd*K*f**2*r*s + 1188*D1*Ddd*K*f**2*r - 792*D1*Ddd*K*f**2*s**2 + 1188*D1*Ddd*K*f**2*s - 594*D1*Ddd*K*f**2 - 792*D1*Ddd*b2*f*r**2 - 1584*D1*Ddd*b2*f*r*s + 1188*D1*Ddd*b2*f*r - 792*D1*Ddd*b2*f*s**2 + 1188*D1*Ddd*b2*f*s - 594*D1*Ddd*b2*f + 500*D1*Ddd*f**3*r**2 + 1000*D1*Ddd*f**3*r*s - 750*D1*Ddd*f**3*r + 500*D1*Ddd*f**3*s**2 - 750*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 + 1320*D1*Ddd*f*g2*r**2 + 2640*D1*Ddd*f*g2*r*s - 1980*D1*Ddd*f*g2*r + 1320*D1*Ddd*f*g2*s**2 - 1980*D1*Ddd*f*g2*s + 990*D1*Ddd*f*g2 - 33*D1*bd1*(D1*(4*f**2*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) + f*(14*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 34*K*r**2 - 68*K*r*s + 72*K*r - 34*K*s**2 + 72*K*s - 36*K - 8*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 14*r**2 - 28*r*s + 14*r - 14*s**2 + 14*s - 7) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (-K*fd*(10*r + 10*s + 1) + 14*gd2*(2*r + 2*s - 1))*(2*r + 2*s - 2)) - 2*Dd*(4*r + 4*s - 3)*(K*f*(-10*r - 10*s + 11) + f**2*(4*r + 4*s - 6) + 14*g2*(2*r + 2*s - 1))) + 33*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 2376*Dd**2*K*f**2*r**2 - 4752*Dd**2*K*f**2*r*s + 3564*Dd**2*K*f**2*r - 2376*Dd**2*K*f**2*s**2 + 3564*Dd**2*K*f**2*s - 1188*Dd**2*K*f**2 - 2376*Dd**2*b2*f*r**2 - 4752*Dd**2*b2*f*r*s + 3564*Dd**2*b2*f*r - 2376*Dd**2*b2*f*s**2 + 3564*Dd**2*b2*f*s - 1188*Dd**2*b2*f + 1500*Dd**2*f**3*r**2 + 3000*Dd**2*f**3*r*s - 2250*Dd**2*f**3*r + 1500*Dd**2*f**3*s**2 - 2250*Dd**2*f**3*s + 750*Dd**2*f**3 + 3960*Dd**2*f*g2*r**2 + 7920*Dd**2*f*g2*r*s - 5940*Dd**2*f*g2*r + 3960*Dd**2*f*g2*s**2 - 5940*Dd**2*f*g2*s + 1980*Dd**2*f*g2) + 33*b2*(-6*D1**2*bdd1*f*(r + s - 1)**2 + 22*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 22*D1**2*f*fd*s**2 - 22*D1**2*f*fd*s + 11*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 12*D1**2*f*fdd*s - 6*D1**2*f*fdd - 12*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 12*D1**2*fd**2*s + 44*D1*Dd*f**2*r**2 + 88*D1*Dd*f**2*r*s - 66*D1*Dd*f**2*r + 44*D1*Dd*f**2*s**2 - 66*D1*Dd*f**2*s + 33*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 120*D1*Dd*f*fd*s - 36*D1*Dd*f*fd - 24*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 + D1*bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 36*Dd**2*f**2))/(1386*d**2*k3**4) + D1**2*Pk1*Pkdd3*k1**2*st**2*(2*C - 1)*(-D1*f*(r + s)*(2*D1*bd1**2*(r + s - 1) + D1*bdd1*f*(r + s) + bd1*(-D1*f*(r + s) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(9*fd - fdd)*(r + s - 1)**2 + D1*(Dd*(9*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-D1**2*bdd1*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 4*D1**2*f*fdd*s - 2*D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 4*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 4*D1**2*fd**2*s - 2*D1**2*fd**2 + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 28*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 28*D1*Dd*f*fd*s - 12*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + D1*bd1*(D1*(9*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2))/(42*d**2*k3**2) - D1**2*Pk1*Pkdd3*k1**2*(D1*(r + s)*(14*D1*b2*bd1**2*(r + s - 1) + 6*D1*b2*bdd1*f*(r + s) - 4*D1*bd1**2*(-3*K*f + 7*g2)*(r + s - 1) - 12*D1*bdd1*f*g2*(r + s) + b2*bd1*(-5*D1*f*(r + s) + 12*D1*fd*(r + s - 1) + 12*Dd*f*(4*r + 4*s - 3)) + 2*bd1*(6*D1*bd2*f*(r + s - 1) + D1*(5*f*g2*(r + s) - 12*f*gd2*(r + s - 1) - 12*fd*g2*(r + s - 1)) - 12*Dd*f*g2*(4*r + 4*s - 3))) - 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-42*D1**2*K*bd1*r**2 - 84*D1**2*K*bd1*r*s + 56*D1**2*K*bd1*r - 42*D1**2*K*bd1*s**2 + 56*D1**2*K*bd1*s - 28*D1**2*K*bd1 + 21*D1**2*K*bdd1*r**2 + 42*D1**2*K*bdd1*r*s - 28*D1**2*K*bdd1*r + 21*D1**2*K*bdd1*s**2 - 28*D1**2*K*bdd1*s + 14*D1**2*K*bdd1 - 5*D1**2*K*fd*r**2 - 10*D1**2*K*fd*r*s + 10*D1**2*K*fd*r - 5*D1**2*K*fd*s**2 + 10*D1**2*K*fd*s - 5*D1**2*K*fd + 6*D1**2*K*fdd*r**2 + 12*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r + 6*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd + 7*D1**2*bdd2*(r + s - 1)**2 + 28*D1**2*gd2*r**2 + 56*D1**2*gd2*r*s - 56*D1**2*gd2*r + 28*D1**2*gd2*s**2 - 56*D1**2*gd2*s + 28*D1**2*gd2 - 14*D1**2*gdd2*r**2 - 28*D1**2*gdd2*r*s + 28*D1**2*gdd2*r - 14*D1**2*gdd2*s**2 + 28*D1**2*gdd2*s - 14*D1**2*gdd2 + 168*D1*Dd*K*bd1*r**2 + 336*D1*Dd*K*bd1*r*s - 238*D1*Dd*K*bd1*r + 168*D1*Dd*K*bd1*s**2 - 238*D1*Dd*K*bd1*s + 84*D1*Dd*K*bd1 - 20*D1*Dd*K*f*r**2 - 40*D1*Dd*K*f*r*s + 30*D1*Dd*K*f*r - 20*D1*Dd*K*f*s**2 + 30*D1*Dd*K*f*s - 15*D1*Dd*K*f + 48*D1*Dd*K*fd*r**2 + 96*D1*Dd*K*fd*r*s - 84*D1*Dd*K*fd*r + 48*D1*Dd*K*fd*s**2 - 84*D1*Dd*K*fd*s + 36*D1*Dd*K*fd - 56*D1*Dd*b2*r**2 - 112*D1*Dd*b2*r*s + 84*D1*Dd*b2*r - 56*D1*Dd*b2*s**2 + 84*D1*Dd*b2*s - 42*D1*Dd*b2 + 112*D1*Dd*g2*r**2 + 224*D1*Dd*g2*r*s - 168*D1*Dd*g2*r + 112*D1*Dd*g2*s**2 - 168*D1*Dd*g2*s + 84*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 - 224*D1*Dd*gd2*r*s + 196*D1*Dd*gd2*r - 112*D1*Dd*gd2*s**2 + 196*D1*Dd*gd2*s - 84*D1*Dd*gd2 + 24*D1*Ddd*K*f*r**2 + 48*D1*Ddd*K*f*r*s - 36*D1*Ddd*K*f*r + 24*D1*Ddd*K*f*s**2 - 36*D1*Ddd*K*f*s + 18*D1*Ddd*K*f + 28*D1*Ddd*b2*r**2 + 56*D1*Ddd*b2*r*s - 42*D1*Ddd*b2*r + 28*D1*Ddd*b2*s**2 - 42*D1*Ddd*b2*s + 21*D1*Ddd*b2 - 56*D1*Ddd*g2*r**2 - 112*D1*Ddd*g2*r*s + 84*D1*Ddd*g2*r - 56*D1*Ddd*g2*s**2 + 84*D1*Ddd*g2*s - 42*D1*Ddd*g2 - 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) + 72*Dd**2*K*f*r**2 + 144*Dd**2*K*f*r*s - 108*Dd**2*K*f*r + 72*Dd**2*K*f*s**2 - 108*Dd**2*K*f*s + 36*Dd**2*K*f + 84*Dd**2*b2*r**2 + 168*Dd**2*b2*r*s - 126*Dd**2*b2*r + 84*Dd**2*b2*s**2 - 126*Dd**2*b2*s + 42*Dd**2*b2 - 168*Dd**2*g2*r**2 - 336*Dd**2*g2*r*s + 252*Dd**2*g2*r - 168*Dd**2*g2*s**2 + 252*Dd**2*g2*s - 84*Dd**2*g2) + b1*(14*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 12*D1**2*K*bdd1*f*r**2 + 24*D1**2*K*bdd1*f*r*s - 12*D1**2*K*bdd1*f*r + 12*D1**2*K*bdd1*f*s**2 - 12*D1**2*K*bdd1*f*s + 6*D1**2*K*bdd1*f - 5*D1**2*bd2*f*r**2 - 10*D1**2*bd2*f*r*s + 10*D1**2*bd2*f*r - 5*D1**2*bd2*f*s**2 + 10*D1**2*bd2*f*s - 5*D1**2*bd2*f + 12*D1**2*bd2*fd*r**2 + 24*D1**2*bd2*fd*r*s - 24*D1**2*bd2*fd*r + 12*D1**2*bd2*fd*s**2 - 24*D1**2*bd2*fd*s + 12*D1**2*bd2*fd - 28*D1**2*bdd1*g2*r**2 - 56*D1**2*bdd1*g2*r*s + 28*D1**2*bdd1*g2*r - 28*D1**2*bdd1*g2*s**2 + 28*D1**2*bdd1*g2*s - 14*D1**2*bdd1*g2 + 6*D1**2*bdd2*f*r**2 + 12*D1**2*bdd2*f*r*s - 12*D1**2*bdd2*f*r + 6*D1**2*bdd2*f*s**2 - 12*D1**2*bdd2*f*s + 6*D1**2*bdd2*f + 10*D1**2*f*gd2*r**2 + 20*D1**2*f*gd2*r*s - 20*D1**2*f*gd2*r + 10*D1**2*f*gd2*s**2 - 20*D1**2*f*gd2*s + 10*D1**2*f*gd2 - 12*D1**2*f*gdd2*r**2 - 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*r - 12*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 12*D1**2*f*gdd2 + 10*D1**2*fd*g2*r**2 + 20*D1**2*fd*g2*r*s - 20*D1**2*fd*g2*r + 10*D1**2*fd*g2*s**2 - 20*D1**2*fd*g2*s + 10*D1**2*fd*g2 - 24*D1**2*fd*gd2*r**2 - 48*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 24*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fd*gd2 - 12*D1**2*fdd*g2*r**2 - 24*D1**2*fdd*g2*r*s + 24*D1**2*fdd*g2*r - 12*D1**2*fdd*g2*s**2 + 24*D1**2*fdd*g2*s - 12*D1**2*fdd*g2 + 48*D1*Dd*bd2*f*r**2 + 96*D1*Dd*bd2*f*r*s - 84*D1*Dd*bd2*f*r + 48*D1*Dd*bd2*f*s**2 - 84*D1*Dd*bd2*f*s + 36*D1*Dd*bd2*f + 40*D1*Dd*f*g2*r**2 + 80*D1*Dd*f*g2*r*s - 60*D1*Dd*f*g2*r + 40*D1*Dd*f*g2*s**2 - 60*D1*Dd*f*g2*s + 30*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r**2 - 192*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 168*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r**2 - 192*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s - 72*D1*Dd*fd*g2 - 48*D1*Ddd*f*g2*r**2 - 96*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 72*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + D1*bd1*(14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(K*(-5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(-3*K*f + 7*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 144*Dd**2*f*g2*r**2 - 288*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 216*Dd**2*f*g2*s - 72*Dd**2*f*g2 + b2*(7*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 5*D1**2*fd*r**2 - 10*D1**2*fd*r*s + 10*D1**2*fd*r - 5*D1**2*fd*s**2 + 10*D1**2*fd*s - 5*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r + 6*D1**2*fdd*s**2 - 12*D1**2*fdd*s + 6*D1**2*fdd - 20*D1*Dd*f*r**2 - 40*D1*Dd*f*r*s + 30*D1*Dd*f*r - 20*D1*Dd*f*s**2 + 30*D1*Dd*f*s - 15*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 84*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 84*D1*Dd*fd*s + 36*D1*Dd*fd + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f - 14*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f)))/(21*d**2*k3**2) - 5*D1**2*Pk1*Pkdd3*k2**6*st**6*(429*b1**2*(D1**2*(f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 26*b1*f*(-33*D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + 66*D1*bd1*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 2*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + f**2*(-858*D1**2*bd1**2*(r + s - 1)**2 + 52*D1**2*bdd1*f*(r + s - 1)**2 + 15*D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 104*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + 15*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(18018*d**2*k3**6) - D1**2*Pk1*Pkdd3*k2**4*st**6*(10*C - 5)*(132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - 33*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(1386*d**2*k3**4) + D1**2*Pk1*Pkdd3*k2**4*st**4*(D1*(66*D1*K*bd1**2*f*(r + s - 1)**2 + D1*bdd1*f*(f**2*(7*r**2 + 2*r*(7*s - 4) + 7*s**2 - 8*s + 4) - 66*g2*(r + s - 1)**2) - 33*b2*(-D1*bdd1*f*(r + s - 1) + 2*bd1*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)))*(r + s - 1) + bd1*(66*D1*bd2*f*(r + s - 1)**2 + D1*(-2*f**3*(7*r**2 + 2*r*(7*s - 4) + 7*s**2 - 8*s + 4) + f**2*(r + s - 1)*(66*C*(r + s - 1) + 2*fd*(21*r + 21*s - 8) - 33*r - 33*s + 33) + 132*f*(g2 - gd2)*(r + s - 1)**2 - 132*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(f**2*(7*r + 7*s - 4) - 66*g2*(r + s - 1))*(4*r + 4*s - 3))) - 33*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1**2*(-D1**2*bdd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + K*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + b1*(132*C*D1**2*f*fd*r**2 + 264*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*r + 132*C*D1**2*f*fd*s**2 - 132*C*D1**2*f*fd*s + 66*C*D1**2*f*fd + 264*C*D1*Dd*f**2*r**2 + 528*C*D1*Dd*f**2*r*s - 396*C*D1*Dd*f**2*r + 264*C*D1*Dd*f**2*s**2 - 396*C*D1*Dd*f**2*s + 198*C*D1*Dd*f**2 + 66*D1**2*K*bdd1*f*r**2 + 132*D1**2*K*bdd1*f*r*s - 132*D1**2*K*bdd1*f*r + 66*D1**2*K*bdd1*f*s**2 - 132*D1**2*K*bdd1*f*s + 66*D1**2*K*bdd1*f - 66*D1**2*b2*fd*r**2 - 132*D1**2*b2*fd*r*s - 66*D1**2*b2*fd*s**2 + 33*D1**2*b2*fdd*r**2 + 66*D1**2*b2*fdd*r*s + 33*D1**2*b2*fdd*s**2 + 66*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 33*D1**2*bdd2*f*r**2 + 66*D1**2*bdd2*f*r*s - 66*D1**2*bdd2*f*r + 33*D1**2*bdd2*f*s**2 - 66*D1**2*bdd2*f*s + 33*D1**2*bdd2*f - 42*D1**2*f**2*fd*r**2 - 84*D1**2*f**2*fd*r*s + 68*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 68*D1**2*f**2*fd*s - 34*D1**2*f**2*fd + 21*D1**2*f**2*fdd*r**2 + 42*D1**2*f**2*fdd*r*s - 34*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s**2 - 34*D1**2*f**2*fdd*s + 17*D1**2*f**2*fdd + 42*D1**2*f*fd**2*r**2 + 84*D1**2*f*fd**2*r*s - 68*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s**2 - 68*D1**2*f*fd**2*s + 26*D1**2*f*fd**2 - 66*D1**2*f*fd*r**2 - 132*D1**2*f*fd*r*s + 66*D1**2*f*fd*r - 66*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 33*D1**2*f*fd + 132*D1**2*f*gd2*r**2 + 264*D1**2*f*gd2*r*s - 264*D1**2*f*gd2*r + 132*D1**2*f*gd2*s**2 - 264*D1**2*f*gd2*s + 132*D1**2*f*gd2 - 66*D1**2*f*gdd2*r**2 - 132*D1**2*f*gdd2*r*s + 132*D1**2*f*gdd2*r - 66*D1**2*f*gdd2*s**2 + 132*D1**2*f*gdd2*s - 66*D1**2*f*gdd2 + 132*D1**2*fd*g2*r**2 + 264*D1**2*fd*g2*r*s + 132*D1**2*fd*g2*s**2 - 132*D1**2*fd*gd2*r**2 - 264*D1**2*fd*gd2*r*s + 132*D1**2*fd*gd2*r - 132*D1**2*fd*gd2*s**2 + 132*D1**2*fd*gd2*s - 66*D1**2*fdd*g2*r**2 - 132*D1**2*fdd*g2*r*s - 66*D1**2*fdd*g2*s**2 - 264*D1*Dd*b2*f*r**2 - 528*D1*Dd*b2*f*r*s + 396*D1*Dd*b2*f*r - 264*D1*Dd*b2*f*s**2 + 396*D1*Dd*b2*f*s - 198*D1*Dd*b2*f + 264*D1*Dd*b2*fd*r**2 + 528*D1*Dd*b2*fd*r*s - 198*D1*Dd*b2*fd*r + 264*D1*Dd*b2*fd*s**2 - 198*D1*Dd*b2*fd*s - 56*D1*Dd*f**3*r**2 - 112*D1*Dd*f**3*r*s + 84*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 84*D1*Dd*f**3*s - 42*D1*Dd*f**3 + 168*D1*Dd*f**2*fd*r**2 + 336*D1*Dd*f**2*fd*r*s - 262*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s**2 - 262*D1*Dd*f**2*fd*s + 102*D1*Dd*f**2*fd - 132*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r*s + 198*D1*Dd*f**2*r - 132*D1*Dd*f**2*s**2 + 198*D1*Dd*f**2*s - 99*D1*Dd*f**2 + 528*D1*Dd*f*g2*r**2 + 1056*D1*Dd*f*g2*r*s - 792*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s**2 - 792*D1*Dd*f*g2*s + 396*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r**2 - 1056*D1*Dd*f*gd2*r*s + 924*D1*Dd*f*gd2*r - 528*D1*Dd*f*gd2*s**2 + 924*D1*Dd*f*gd2*s - 396*D1*Dd*f*gd2 - 528*D1*Dd*fd*g2*r**2 - 1056*D1*Dd*fd*g2*r*s + 396*D1*Dd*fd*g2*r - 528*D1*Dd*fd*g2*s**2 + 396*D1*Dd*fd*g2*s + 132*D1*Ddd*b2*f*r**2 + 264*D1*Ddd*b2*f*r*s - 198*D1*Ddd*b2*f*r + 132*D1*Ddd*b2*f*s**2 - 198*D1*Ddd*b2*f*s + 99*D1*Ddd*b2*f + 28*D1*Ddd*f**3*r**2 + 56*D1*Ddd*f**3*r*s - 42*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 42*D1*Ddd*f**3*s + 21*D1*Ddd*f**3 - 264*D1*Ddd*f*g2*r**2 - 528*D1*Ddd*f*g2*r*s + 396*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2*s**2 + 396*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 - 132*D1*K*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 66*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 396*Dd**2*b2*f*r**2 + 792*Dd**2*b2*f*r*s - 594*Dd**2*b2*f*r + 396*Dd**2*b2*f*s**2 - 594*Dd**2*b2*f*s + 198*Dd**2*b2*f + 84*Dd**2*f**3*r**2 + 168*Dd**2*f**3*r*s - 126*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 126*Dd**2*f**3*s + 42*Dd**2*f**3 - 792*Dd**2*f*g2*r**2 - 1584*Dd**2*f*g2*r*s + 1188*Dd**2*f*g2*r - 792*Dd**2*f*g2*s**2 + 1188*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(231*d**2*k3**4) - D1**2*Pk1*Pkdd3*k2**2*st**4*(2*C - 1)*(-2*D1**2*bd1**2*f*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*b1*(-D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**2) + D1**2*Pk1*Pkdd3*k2**2*st**2*(D1*(r + s)*(2*D1*bd1**2*(r + s - 1)*(-K*f + 2*f**2 - 14*g2) + 2*D1*bdd1*f*g2*(r + s) + b2*(14*D1*bd1**2*(r + s - 1) - D1*bdd1*f*(r + s) - 2*bd1*(-D1*f*(r + s) + D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + bd1*(-2*D1*bd2*f*(r + s - 1) + D1*(4*f*gd2*(r + s - 1) - f*(r + s)*(f*(2*C - 1) + 4*g2) + 4*fd*g2*(r + s - 1)) + 4*Dd*f*g2*(4*r + 4*s - 3))) + b1**3*(-2*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(-2*Dd*(7*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*(7*K + 2*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(7*K + 2*f)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(14*C*D1**2*fd*r**2 + 28*C*D1**2*fd*r*s - 28*C*D1**2*fd*r + 14*C*D1**2*fd*s**2 - 28*C*D1**2*fd*s + 14*C*D1**2*fd + 56*C*D1*Dd*f*r**2 + 112*C*D1*Dd*f*r*s - 84*C*D1*Dd*f*r + 56*C*D1*Dd*f*s**2 - 84*C*D1*Dd*f*s + 42*C*D1*Dd*f - 42*D1**2*K*bd1*r**2 - 84*D1**2*K*bd1*r*s + 56*D1**2*K*bd1*r - 42*D1**2*K*bd1*s**2 + 56*D1**2*K*bd1*s - 28*D1**2*K*bd1 + 21*D1**2*K*bdd1*r**2 + 42*D1**2*K*bdd1*r*s - 28*D1**2*K*bdd1*r + 21*D1**2*K*bdd1*s**2 - 28*D1**2*K*bdd1*s + 14*D1**2*K*bdd1 + 2*D1**2*K*fd*r**2 + 4*D1**2*K*fd*r*s - 4*D1**2*K*fd*r + 2*D1**2*K*fd*s**2 - 4*D1**2*K*fd*s + 2*D1**2*K*fd - D1**2*K*fdd*r**2 - 2*D1**2*K*fdd*r*s + 2*D1**2*K*fdd*r - D1**2*K*fdd*s**2 + 2*D1**2*K*fdd*s - D1**2*K*fdd - 12*D1**2*bd1*f*r**2 - 24*D1**2*bd1*f*r*s + 16*D1**2*bd1*f*r - 12*D1**2*bd1*f*s**2 + 16*D1**2*bd1*f*s - 8*D1**2*bd1*f + 12*D1**2*bd1*fd*r**2 + 24*D1**2*bd1*fd*r*s - 20*D1**2*bd1*fd*r + 12*D1**2*bd1*fd*s**2 - 20*D1**2*bd1*fd*s + 8*D1**2*bd1*fd + 6*D1**2*bdd1*f*r**2 + 12*D1**2*bdd1*f*r*s - 8*D1**2*bdd1*f*r + 6*D1**2*bdd1*f*s**2 - 8*D1**2*bdd1*f*s + 4*D1**2*bdd1*f + 7*D1**2*bdd2*(r + s - 1)**2 - 8*D1**2*f*fd*r**2 - 16*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 4*D1**2*f*fdd*r**2 + 8*D1**2*f*fdd*r*s - 8*D1**2*f*fdd*r + 4*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s + 4*D1**2*f*fdd + 4*D1**2*fd**2*r**2 + 8*D1**2*fd**2*r*s - 8*D1**2*fd**2*r + 4*D1**2*fd**2*s**2 - 8*D1**2*fd**2*s + 4*D1**2*fd**2 - 7*D1**2*fd*r**2 - 14*D1**2*fd*r*s + 14*D1**2*fd*r - 7*D1**2*fd*s**2 + 14*D1**2*fd*s - 7*D1**2*fd + 28*D1**2*gd2*r**2 + 56*D1**2*gd2*r*s - 56*D1**2*gd2*r + 28*D1**2*gd2*s**2 - 56*D1**2*gd2*s + 28*D1**2*gd2 - 14*D1**2*gdd2*r**2 - 28*D1**2*gdd2*r*s + 28*D1**2*gdd2*r - 14*D1**2*gdd2*s**2 + 28*D1**2*gdd2*s - 14*D1**2*gdd2 + 168*D1*Dd*K*bd1*r**2 + 336*D1*Dd*K*bd1*r*s - 238*D1*Dd*K*bd1*r + 168*D1*Dd*K*bd1*s**2 - 238*D1*Dd*K*bd1*s + 84*D1*Dd*K*bd1 + 8*D1*Dd*K*f*r**2 + 16*D1*Dd*K*f*r*s - 12*D1*Dd*K*f*r + 8*D1*Dd*K*f*s**2 - 12*D1*Dd*K*f*s + 6*D1*Dd*K*f - 8*D1*Dd*K*fd*r**2 - 16*D1*Dd*K*fd*r*s + 14*D1*Dd*K*fd*r - 8*D1*Dd*K*fd*s**2 + 14*D1*Dd*K*fd*s - 6*D1*Dd*K*fd - 56*D1*Dd*b2*r**2 - 112*D1*Dd*b2*r*s + 84*D1*Dd*b2*r - 56*D1*Dd*b2*s**2 + 84*D1*Dd*b2*s - 42*D1*Dd*b2 + 48*D1*Dd*bd1*f*r**2 + 96*D1*Dd*bd1*f*r*s - 68*D1*Dd*bd1*f*r + 48*D1*Dd*bd1*f*s**2 - 68*D1*Dd*bd1*f*s + 24*D1*Dd*bd1*f - 16*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 32*D1*Dd*f*fd*r**2 + 64*D1*Dd*f*fd*r*s - 56*D1*Dd*f*fd*r + 32*D1*Dd*f*fd*s**2 - 56*D1*Dd*f*fd*s + 24*D1*Dd*f*fd - 28*D1*Dd*f*r**2 - 56*D1*Dd*f*r*s + 42*D1*Dd*f*r - 28*D1*Dd*f*s**2 + 42*D1*Dd*f*s - 21*D1*Dd*f + 112*D1*Dd*g2*r**2 + 224*D1*Dd*g2*r*s - 168*D1*Dd*g2*r + 112*D1*Dd*g2*s**2 - 168*D1*Dd*g2*s + 84*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 - 224*D1*Dd*gd2*r*s + 196*D1*Dd*gd2*r - 112*D1*Dd*gd2*s**2 + 196*D1*Dd*gd2*s - 84*D1*Dd*gd2 - 4*D1*Ddd*K*f*r**2 - 8*D1*Ddd*K*f*r*s + 6*D1*Ddd*K*f*r - 4*D1*Ddd*K*f*s**2 + 6*D1*Ddd*K*f*s - 3*D1*Ddd*K*f + 28*D1*Ddd*b2*r**2 + 56*D1*Ddd*b2*r*s - 42*D1*Ddd*b2*r + 28*D1*Ddd*b2*s**2 - 42*D1*Ddd*b2*s + 21*D1*Ddd*b2 + 8*D1*Ddd*f**2*r**2 + 16*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 8*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 - 56*D1*Ddd*g2*r**2 - 112*D1*Ddd*g2*r*s + 84*D1*Ddd*g2*r - 56*D1*Ddd*g2*s**2 + 84*D1*Ddd*g2*s - 42*D1*Ddd*g2 - 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 12*Dd**2*K*f*r**2 - 24*Dd**2*K*f*r*s + 18*Dd**2*K*f*r - 12*Dd**2*K*f*s**2 + 18*Dd**2*K*f*s - 6*Dd**2*K*f + 84*Dd**2*b2*r**2 + 168*Dd**2*b2*r*s - 126*Dd**2*b2*r + 84*Dd**2*b2*s**2 - 126*Dd**2*b2*s + 42*Dd**2*b2 + 24*Dd**2*f**2*r**2 + 48*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 24*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 12*Dd**2*f**2 - 168*Dd**2*g2*r**2 - 336*Dd**2*g2*r*s + 252*Dd**2*g2*r - 168*Dd**2*g2*s**2 + 252*Dd**2*g2*s - 84*Dd**2*g2) - b1*(4*C*D1**2*f*fd*r**2 + 8*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd*s + 4*C*D1**2*f*fd + 8*C*D1*Dd*f**2*r**2 + 16*C*D1*Dd*f**2*r*s - 12*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s**2 - 12*C*D1*Dd*f**2*s + 6*C*D1*Dd*f**2 + 2*D1**2*K*bdd1*f*r**2 + 4*D1**2*K*bdd1*f*r*s - 2*D1**2*K*bdd1*f*r + 2*D1**2*K*bdd1*f*s**2 - 2*D1**2*K*bdd1*f*s + D1**2*K*bdd1*f - 2*D1**2*bd1**2*(7*K + 2*f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2*D1**2*bd2*f*r**2 - 4*D1**2*bd2*f*r*s + 4*D1**2*bd2*f*r - 2*D1**2*bd2*f*s**2 + 4*D1**2*bd2*f*s - 2*D1**2*bd2*f + 2*D1**2*bd2*fd*r**2 + 4*D1**2*bd2*fd*r*s - 4*D1**2*bd2*fd*r + 2*D1**2*bd2*fd*s**2 - 4*D1**2*bd2*fd*s + 2*D1**2*bd2*fd - 4*D1**2*bdd1*f**2*r**2 - 8*D1**2*bdd1*f**2*r*s + 4*D1**2*bdd1*f**2*r - 4*D1**2*bdd1*f**2*s**2 + 4*D1**2*bdd1*f**2*s - 2*D1**2*bdd1*f**2 + 28*D1**2*bdd1*g2*r**2 + 56*D1**2*bdd1*g2*r*s - 28*D1**2*bdd1*g2*r + 28*D1**2*bdd1*g2*s**2 - 28*D1**2*bdd1*g2*s + 14*D1**2*bdd1*g2 + D1**2*bdd2*f*r**2 + 2*D1**2*bdd2*f*r*s - 2*D1**2*bdd2*f*r + D1**2*bdd2*f*s**2 - 2*D1**2*bdd2*f*s + D1**2*bdd2*f - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 2*D1**2*f*fd + 4*D1**2*f*gd2*r**2 + 8*D1**2*f*gd2*r*s - 8*D1**2*f*gd2*r + 4*D1**2*f*gd2*s**2 - 8*D1**2*f*gd2*s + 4*D1**2*f*gd2 - 2*D1**2*f*gdd2*r**2 - 4*D1**2*f*gdd2*r*s + 4*D1**2*f*gdd2*r - 2*D1**2*f*gdd2*s**2 + 4*D1**2*f*gdd2*s - 2*D1**2*f*gdd2 + 4*D1**2*fd*g2*r**2 + 8*D1**2*fd*g2*r*s - 8*D1**2*fd*g2*r + 4*D1**2*fd*g2*s**2 - 8*D1**2*fd*g2*s + 4*D1**2*fd*g2 - 4*D1**2*fd*gd2*r**2 - 8*D1**2*fd*gd2*r*s + 8*D1**2*fd*gd2*r - 4*D1**2*fd*gd2*s**2 + 8*D1**2*fd*gd2*s - 4*D1**2*fd*gd2 - 2*D1**2*fdd*g2*r**2 - 4*D1**2*fdd*g2*r*s + 4*D1**2*fdd*g2*r - 2*D1**2*fdd*g2*s**2 + 4*D1**2*fdd*g2*s - 2*D1**2*fdd*g2 + 8*D1*Dd*bd2*f*r**2 + 16*D1*Dd*bd2*f*r*s - 14*D1*Dd*bd2*f*r + 8*D1*Dd*bd2*f*s**2 - 14*D1*Dd*bd2*f*s + 6*D1*Dd*bd2*f - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 16*D1*Dd*f*g2*r**2 + 32*D1*Dd*f*g2*r*s - 24*D1*Dd*f*g2*r + 16*D1*Dd*f*g2*s**2 - 24*D1*Dd*f*g2*s + 12*D1*Dd*f*g2 - 16*D1*Dd*f*gd2*r**2 - 32*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 16*D1*Dd*f*gd2*s**2 + 28*D1*Dd*f*gd2*s - 12*D1*Dd*f*gd2 - 16*D1*Dd*fd*g2*r**2 - 32*D1*Dd*fd*g2*r*s + 28*D1*Dd*fd*g2*r - 16*D1*Dd*fd*g2*s**2 + 28*D1*Dd*fd*g2*s - 12*D1*Dd*fd*g2 - 8*D1*Ddd*f*g2*r**2 - 16*D1*Ddd*f*g2*r*s + 12*D1*Ddd*f*g2*r - 8*D1*Ddd*f*g2*s**2 + 12*D1*Ddd*f*g2*s - 6*D1*Ddd*f*g2 + D1*bd1*(-14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(4*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - f*(14*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 8*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + (2*K - 7)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1)) - 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (2*K*fd + 28*gd2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(-K*f + 2*f**2 - 14*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 24*Dd**2*f*g2*r**2 - 48*Dd**2*f*g2*r*s + 36*Dd**2*f*g2*r - 24*Dd**2*f*g2*s**2 + 36*Dd**2*f*g2*s - 12*Dd**2*f*g2 + b2*(-7*D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 2*D1**2*fd*r**2 - 4*D1**2*fd*r*s + 4*D1**2*fd*r - 2*D1**2*fd*s**2 + 4*D1**2*fd*s - 2*D1**2*fd + D1**2*fdd*r**2 + 2*D1**2*fdd*r*s - 2*D1**2*fdd*r + D1**2*fdd*s**2 - 2*D1**2*fdd*s + D1**2*fdd - 8*D1*Dd*f*r**2 - 16*D1*Dd*f*r*s + 12*D1*Dd*f*r - 8*D1*Dd*f*s**2 + 12*D1*Dd*f*s - 6*D1*Dd*f + 8*D1*Dd*fd*r**2 + 16*D1*Dd*fd*r*s - 14*D1*Dd*fd*r + 8*D1*Dd*fd*s**2 - 14*D1*Dd*fd*s + 6*D1*Dd*fd + 4*D1*Ddd*f*r**2 + 8*D1*Ddd*f*r*s - 6*D1*Ddd*f*r + 4*D1*Ddd*f*s**2 - 6*D1*Ddd*f*s + 3*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 12*Dd**2*f*r**2 + 24*Dd**2*f*r*s - 18*Dd**2*f*r + 12*Dd**2*f*s**2 - 18*Dd**2*f*s + 6*Dd**2*f)))/(42*d**2*k3**2) + D1**2*Pk3*Pkd1*ct**7*k2**5*(16*C - 16)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**7*k2**3*(8*C - 8)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + 2*r + s) + 28*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 2) - s)) + 28*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k3**4) + 40*D1**2*Pk3*Pkd1*ct**6*f*k2**6*(897*D1**2*b1*f*fd*r**2 + 897*D1**2*b1*f*fd*r*s - 598*D1**2*b1*f*fd*r - 1092*D1**2*b1*f*fdd*r**2 - 1092*D1**2*b1*f*fdd*r*s + 728*D1**2*b1*f*fdd*r - 2184*D1**2*b1*fd**2*r**2 - 2184*D1**2*b1*fd**2*r*s + 1456*D1**2*b1*fd**2*r - 364*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 1064*D1**2*f**2*fd*r**2 + 1064*D1**2*f**2*fd*r*s - 1064*D1**2*f**2*fd*r - 266*D1**2*f**2*fd*s + 266*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r**2 - 1260*D1**2*f**2*fdd*r*s + 1260*D1**2*f**2*fdd*r + 315*D1**2*f**2*fdd*s - 315*D1**2*f**2*fdd - 3780*D1**2*f*fd**2*r**2 - 3780*D1**2*f*fd**2*r*s + 3780*D1**2*f*fd**2*r + 945*D1**2*f*fd**2*s - 630*D1**2*f*fd**2 + 1196*D1*Dd*b1*f**2*r**2 + 1196*D1*Dd*b1*f**2*r*s - 1196*D1*Dd*b1*f**2*r - 299*D1*Dd*b1*f**2*s + 299*D1*Dd*b1*f**2 - 8736*D1*Dd*b1*f*fd*r**2 - 8736*D1*Dd*b1*f*fd*r*s + 7280*D1*Dd*b1*f*fd*r + 1092*D1*Dd*b1*f*fd*s - 728*D1*Dd*b1*f*fd + 1064*D1*Dd*f**3*r**2 + 1064*D1*Dd*f**3*r*s - 1064*D1*Dd*f**3*r - 266*D1*Dd*f**3*s + 266*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r**2 - 10080*D1*Dd*f**2*fd*r*s + 10080*D1*Dd*f**2*fd*r + 2520*D1*Dd*f**2*fd*s - 1890*D1*Dd*f**2*fd - 1456*D1*Ddd*b1*f**2*r**2 - 1456*D1*Ddd*b1*f**2*r*s + 1456*D1*Ddd*b1*f**2*r + 364*D1*Ddd*b1*f**2*s - 364*D1*Ddd*b1*f**2 - 1260*D1*Ddd*f**3*r**2 - 1260*D1*Ddd*f**3*r*s + 1260*D1*Ddd*f**3*r + 315*D1*Ddd*f**3*s - 315*D1*Ddd*f**3 + 13*D1*bd1*f*(D1*(23*f*(r - 1)*(r + s - 1) - 28*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 28*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 4368*Dd**2*b1*f**2*r**2 - 4368*Dd**2*b1*f**2*r*s + 4368*Dd**2*b1*f**2*r + 1092*Dd**2*b1*f**2*s - 728*Dd**2*b1*f**2 - 3780*Dd**2*f**3*r**2 - 3780*Dd**2*f**3*r*s + 3780*Dd**2*f**3*r + 945*Dd**2*f**3*s - 630*Dd**2*f**3)/(9009*d**2*k1*k3**6) + D1**2*Pk3*Pkd1*ct**6*k1*k2**4*(80*C - 72)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**6*k1*k2**2*(32*C - 28)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + 2*r + s) + 28*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 2) - s)) + 28*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k3**4) + 2*D1**2*Pk3*Pkd1*ct**6*k2**4*(660*C*D1**2*b1*f*fd*r**2 + 66*C*D1**2*b1*f*fdd*r**2 + 66*C*D1**2*b1*fd**2*r**2 + 240*C*D1**2*f**2*fd*r**2 - 160*C*D1**2*f**2*fd*r + 80*C*D1**2*f**2*fd + 375*C*D1**2*f**2*fdd*r**2 - 250*C*D1**2*f**2*fdd*r + 125*C*D1**2*f**2*fdd + 750*C*D1**2*f*fd**2*r**2 - 500*C*D1**2*f*fd**2*r + 1320*C*D1*Dd*b1*f**2*r**2 - 660*C*D1*Dd*b1*f**2*r + 330*C*D1*Dd*b1*f**2 + 528*C*D1*Dd*b1*f*fd*r**2 - 132*C*D1*Dd*b1*f*fd*r + 320*C*D1*Dd*f**3*r**2 - 160*C*D1*Dd*f**3*r + 80*C*D1*Dd*f**3 + 3000*C*D1*Dd*f**2*fd*r**2 - 1750*C*D1*Dd*f**2*fd*r + 250*C*D1*Dd*f**2*fd + 132*C*D1*Ddd*b1*f**2*r**2 - 66*C*D1*Ddd*b1*f**2*r + 33*C*D1*Ddd*b1*f**2 + 500*C*D1*Ddd*f**3*r**2 - 250*C*D1*Ddd*f**3*r + 125*C*D1*Ddd*f**3 + 396*C*Dd**2*b1*f**2*r**2 - 198*C*Dd**2*b1*f**2*r + 1500*C*Dd**2*f**3*r**2 - 750*C*Dd**2*f**3*r - 132*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r - 726*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 726*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r + 33*D1**2*bdd1*f**2*(r - 1)*(C*(r - 1) - 11*r - 10*s + 11) + 450*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 530*D1**2*f**2*fd*r - 230*D1**2*f**2*fd*s + 150*D1**2*f**2*fd - 1215*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 1090*D1**2*f**2*fdd*r + 280*D1**2*f**2*fdd*s - 405*D1**2*f**2*fdd - 2430*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 2180*D1**2*f*fd**2*r + 560*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 - 264*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s - 66*D1*Dd*b1*f**2 - 5808*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 4092*D1*Dd*b1*f*fd*r + 660*D1*Dd*b1*f*fd*s - 330*D1*Dd*b1*f*fd + 600*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 760*D1*Dd*f**3*r - 230*D1*Dd*f**3*s + 150*D1*Dd*f**3 - 9720*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 8470*D1*Dd*f**2*fd*r + 1960*D1*Dd*f**2*fd*s - 1650*D1*Dd*f**2*fd - 1452*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 1386*D1*Ddd*b1*f**2*r + 330*D1*Ddd*b1*f**2*s - 363*D1*Ddd*b1*f**2 - 1620*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 1370*D1*Ddd*f**3*r + 280*D1*Ddd*f**3*s - 405*D1*Ddd*f**3 + 66*D1*bd1*f*(D1*f*(r - 1)*(5*C*(r - 1) - r + 4*s + 1) + D1*fd*(r**2*(2*C - 22) + r*(-2*C - 20*s + 27) + 10*s - 5) + Dd*f*(4*C*r**2 - 5*C*r + C - 44*r**2 - 40*r*s + 65*r + 25*s - 21)) - 4356*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 4158*Dd**2*b1*f**2*r + 990*Dd**2*b1*f**2*s - 660*Dd**2*b1*f**2 - 4860*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 4110*Dd**2*f**3*r + 840*Dd**2*f**3*s - 560*Dd**2*f**3)/(693*d**2*k1*k3**4) + 4*D1**2*Pk3*Pkd1*ct**6*k2**2*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + 2*r + s) + 28*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 2) - s)) + 28*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k1*k3**2) + 205*D1**2*Pk3*Pkd1*ct**5*f*k2**5*(78*D1**2*b1*f*fd*r**2 - 39*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*fd**2*r**2 - 13*D1**2*bdd1*f**2*(r - 1)**2 + 56*D1**2*f**2*fd*r**2 - 28*D1**2*f**2*fd*r + 14*D1**2*f**2*fd - 28*D1**2*f**2*fdd*r**2 + 14*D1**2*f**2*fdd*r - 7*D1**2*f**2*fdd - 84*D1**2*f*fd**2*r**2 + 42*D1**2*f*fd**2*r + 104*D1*Dd*b1*f**2*r**2 - 52*D1*Dd*b1*f**2*r + 26*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 + 78*D1*Dd*b1*f*fd*r + 56*D1*Dd*f**3*r**2 - 28*D1*Dd*f**3*r + 14*D1*Dd*f**3 - 224*D1*Dd*f**2*fd*r**2 + 112*D1*Dd*f**2*fd*r - 14*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 + 26*D1*Ddd*b1*f**2*r - 13*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*r**2 + 14*D1*Ddd*f**3*r - 7*D1*Ddd*f**3 + 26*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 156*Dd**2*b1*f**2*r**2 + 78*Dd**2*b1*f**2*r - 84*Dd**2*f**3*r**2 + 42*Dd**2*f**3*r)/(9009*d**2*k1**2*k3**4) + D1**2*Pk3*Pkd1*ct**5*k1**2*k2**3*(160*C - 128)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**5*k1**2*k2*(16*C - 12)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + 2*r + s) + 28*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 2) - s)) + 28*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(231*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**5*k2**5*st**2*(16*C - 16)*(462*D1**2*b1*f*fd*r**2 + 462*D1**2*b1*f*fd*r*s - 231*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 453*D1**2*f**2*fd*r**2 + 453*D1**2*f**2*fd*r*s - 453*D1**2*f**2*fd*r - 151*D1**2*f**2*fd*s + 151*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 375*D1**2*f**2*fdd*r*s + 375*D1**2*f**2*fdd*r + 125*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 750*D1**2*f*fd**2*r*s + 750*D1**2*f*fd**2*r + 250*D1**2*f*fd**2*s - 125*D1**2*f*fd**2 + 924*D1*Dd*b1*f**2*r**2 + 924*D1*Dd*b1*f**2*r*s - 924*D1*Dd*b1*f**2*r - 231*D1*Dd*b1*f**2*s + 231*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 604*D1*Dd*f**3*r**2 + 604*D1*Dd*f**3*r*s - 604*D1*Dd*f**3*r - 151*D1*Dd*f**3*s + 151*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 3000*D1*Dd*f**2*fd*r*s + 3000*D1*Dd*f**2*fd*r + 875*D1*Dd*f**2*fd*s - 625*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 500*D1*Ddd*f**3*r**2 - 500*D1*Ddd*f**3*r*s + 500*D1*Ddd*f**3*r + 125*D1*Ddd*f**3*s - 125*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(7*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1500*Dd**2*f**3*r**2 - 1500*Dd**2*f**3*r*s + 1500*Dd**2*f**3*r + 375*Dd**2*f**3*s - 250*Dd**2*f**3)/(693*d**2*k3**6) - 8*D1**2*Pk3*Pkd1*ct**5*k2**5*(2145*D1**2*K*bdd1*f**2*r**2 + 2145*D1**2*K*bdd1*f**2*r*s - 2145*D1**2*K*bdd1*f**2*r - 429*D1**2*bd1**2*f*(2*r - 1)*(-6*K + 5*f + 6)*(r + s - 1) + 5460*D1**2*bdd1*f**3*r**2 + 5460*D1**2*bdd1*f**3*r*s - 12740*D1**2*bdd1*f**3*r - 7280*D1**2*bdd1*f**3*s + 7280*D1**2*bdd1*f**3 - 2145*D1**2*bdd1*f**2*r**2 - 2145*D1**2*bdd1*f**2*r*s + 2145*D1**2*bdd1*f**2*r - 5148*D1**2*bdd1*f*g2*r**2 - 5148*D1**2*bdd1*f*g2*r*s + 10296*D1**2*bdd1*f*g2*r + 5148*D1**2*bdd1*f*g2*s - 5148*D1**2*bdd1*f*g2 - 21280*D1**2*f**3*fd*r**2 - 21280*D1**2*f**3*fd*r*s + 21280*D1**2*f**3*fd*r + 5320*D1**2*f**3*fd*s - 5320*D1**2*f**3*fd + 25200*D1**2*f**3*fdd*r**2 + 25200*D1**2*f**3*fdd*r*s - 25200*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s + 6300*D1**2*f**3*fdd + 75600*D1**2*f**2*fd**2*r**2 + 75600*D1**2*f**2*fd**2*r*s - 75600*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s + 12600*D1**2*f**2*fd**2 + 3432*D1**2*f**2*gd2*r**2 + 3432*D1**2*f**2*gd2*r*s - 3432*D1**2*f**2*gd2*r - 4290*D1**2*f**2*gdd2*r**2 - 4290*D1**2*f**2*gdd2*r*s + 4290*D1**2*f**2*gdd2*r + 6864*D1**2*f*fd*g2*r**2 + 6864*D1**2*f*fd*g2*r*s - 6864*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s + 3432*D1**2*f*fd*g2 - 17160*D1**2*f*fd*gd2*r**2 - 17160*D1**2*f*fd*gd2*r*s + 17160*D1**2*f*fd*gd2*r + 4290*D1**2*f*fd*gd2*s - 4290*D1**2*f*fd*gd2 - 8580*D1**2*f*fdd*g2*r**2 - 8580*D1**2*f*fdd*g2*r*s + 8580*D1**2*f*fdd*g2*r + 4290*D1**2*f*fdd*g2*s - 4290*D1**2*f*fdd*g2 - 8580*D1**2*fd**2*g2*r**2 - 8580*D1**2*fd**2*g2*r*s + 8580*D1**2*fd**2*g2*r + 4290*D1**2*fd**2*g2*s - 21280*D1*Dd*f**4*r**2 - 21280*D1*Dd*f**4*r*s + 21280*D1*Dd*f**4*r + 5320*D1*Dd*f**4*s - 5320*D1*Dd*f**4 + 201600*D1*Dd*f**3*fd*r**2 + 201600*D1*Dd*f**3*fd*r*s - 201600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s + 37800*D1*Dd*f**3*fd + 13728*D1*Dd*f**2*g2*r**2 + 13728*D1*Dd*f**2*g2*r*s - 13728*D1*Dd*f**2*g2*r - 3432*D1*Dd*f**2*g2*s + 3432*D1*Dd*f**2*g2 - 34320*D1*Dd*f**2*gd2*r**2 - 34320*D1*Dd*f**2*gd2*r*s + 34320*D1*Dd*f**2*gd2*r + 4290*D1*Dd*f**2*gd2*s - 4290*D1*Dd*f**2*gd2 - 68640*D1*Dd*f*fd*g2*r**2 - 68640*D1*Dd*f*fd*g2*r*s + 68640*D1*Dd*f*fd*g2*r + 25740*D1*Dd*f*fd*g2*s - 17160*D1*Dd*f*fd*g2 + 25200*D1*Ddd*f**4*r**2 + 25200*D1*Ddd*f**4*r*s - 25200*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s + 6300*D1*Ddd*f**4 - 17160*D1*Ddd*f**2*g2*r**2 - 17160*D1*Ddd*f**2*g2*r*s + 17160*D1*Ddd*f**2*g2*r + 4290*D1*Ddd*f**2*g2*s - 4290*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(115*f**3*(3*r - 4)*(r + s - 1) - 4*f**2*(35*fd*(18*r**2 + 2*r*(9*s - 13) - 11*s + 7) + r*(33 - 33*K)*(r + s - 1)) - 33*f*(5*fd*(K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (10*g2*(r - 1) + 12*gd2*(1 - 2*r))*(r + s - 1)) + 396*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-140*f**2*(24*r**2 + 8*r*(3*s - 5) - 19*s + 15) - 165*f*(K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 396*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 75600*Dd**2*f**4*r**2 + 75600*Dd**2*f**4*r*s - 75600*Dd**2*f**4*r - 18900*Dd**2*f**4*s + 12600*Dd**2*f**4 - 51480*Dd**2*f**2*g2*r**2 - 51480*Dd**2*f**2*g2*r*s + 51480*Dd**2*f**2*g2*r + 12870*Dd**2*f**2*g2*s - 8580*Dd**2*f**2*g2 + 429*b1**2*(D1**2*r*(f*(4*fd - 5*fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 5*fd*(K - 1)*(r + s) + 6*fdd*(K - 1)*(r + s)) + D1*(Dd*(4*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*fd*(K - 1)*(8*r**2 + r*(8*s - 4) - s)) - Ddd*f*(-6*K + 5*f + 6)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(-6*K + 5*f + 6)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-264*D1**2*K*f*fd*r**2 - 264*D1**2*K*f*fd*r*s + 264*D1**2*K*f*fd*r + 132*D1**2*K*f*fd*s - 132*D1**2*K*f*fd + 330*D1**2*K*f*fdd*r**2 + 330*D1**2*K*f*fdd*r*s - 330*D1**2*K*f*fdd*r - 165*D1**2*K*f*fdd*s + 165*D1**2*K*f*fdd + 330*D1**2*K*fd**2*r**2 + 330*D1**2*K*fd**2*r*s - 330*D1**2*K*fd**2*r - 165*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(2*r - 1)*(-6*K + 5*f + 6)*(r + s - 1) - 1035*D1**2*f**2*fd*r**2 - 1035*D1**2*f**2*fd*r*s + 575*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 1260*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd + 2520*D1**2*f*fd**2*r**2 + 2520*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 264*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 264*D1**2*f*fd*r - 132*D1**2*f*fd*s + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 330*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r + 165*D1**2*f*fdd*s - 165*D1**2*f*fdd + 330*D1**2*f*gd2*r**2 + 330*D1**2*f*gd2*r*s - 330*D1**2*f*gd2*r - 396*D1**2*f*gdd2*r**2 - 396*D1**2*f*gdd2*r*s + 396*D1**2*f*gdd2*r - 330*D1**2*fd**2*r**2 - 330*D1**2*fd**2*r*s + 330*D1**2*fd**2*r + 165*D1**2*fd**2*s + 330*D1**2*fd*g2*r**2 + 330*D1**2*fd*g2*r*s - 792*D1**2*fd*gd2*r**2 - 792*D1**2*fd*gd2*r*s + 396*D1**2*fd*gd2*r - 396*D1**2*fdd*g2*r**2 - 396*D1**2*fdd*g2*r*s - 528*D1*Dd*K*f**2*r**2 - 528*D1*Dd*K*f**2*r*s + 528*D1*Dd*K*f**2*r + 132*D1*Dd*K*f**2*s - 132*D1*Dd*K*f**2 + 2640*D1*Dd*K*f*fd*r**2 + 2640*D1*Dd*K*f*fd*r*s - 2640*D1*Dd*K*f*fd*r - 990*D1*Dd*K*f*fd*s + 660*D1*Dd*K*f*fd - 1380*D1*Dd*f**3*r**2 - 1380*D1*Dd*f**3*r*s + 1380*D1*Dd*f**3*r + 345*D1*Dd*f**3*s - 345*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 10080*D1*Dd*f**2*fd*r*s - 7840*D1*Dd*f**2*fd*r - 700*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 528*D1*Dd*f**2*r - 132*D1*Dd*f**2*s + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 2640*D1*Dd*f*fd*r*s + 2640*D1*Dd*f*fd*r + 990*D1*Dd*f*fd*s - 660*D1*Dd*f*fd + 1320*D1*Dd*f*g2*r**2 + 1320*D1*Dd*f*g2*r*s - 1320*D1*Dd*f*g2*r - 330*D1*Dd*f*g2*s + 330*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 3168*D1*Dd*f*gd2*r*s + 3168*D1*Dd*f*gd2*r + 396*D1*Dd*f*gd2*s - 396*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 3168*D1*Dd*fd*g2*r*s + 1584*D1*Dd*fd*g2*r + 396*D1*Dd*fd*g2*s + 660*D1*Ddd*K*f**2*r**2 + 660*D1*Ddd*K*f**2*r*s - 660*D1*Ddd*K*f**2*r - 165*D1*Ddd*K*f**2*s + 165*D1*Ddd*K*f**2 + 1680*D1*Ddd*f**3*r**2 + 1680*D1*Ddd*f**3*r*s - 1680*D1*Ddd*f**3*r - 420*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 - 660*D1*Ddd*f**2*r*s + 660*D1*Ddd*f**2*r + 165*D1*Ddd*f**2*s - 165*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 1584*D1*Ddd*f*g2*r*s + 1584*D1*Ddd*f*g2*r + 396*D1*Ddd*f*g2*s - 396*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(4*f**2*(2*r - 1)*(r + s - 1) - 5*f*(fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + (K - 1)*(2*r - 1)*(r + s - 1)) + 6*fd*(K - 1)*(4*r**2 + r*(4*s - 3) - s)) - Dd*f*(-6*K + 5*f + 6)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1980*Dd**2*K*f**2*r**2 + 1980*Dd**2*K*f**2*r*s - 1980*Dd**2*K*f**2*r - 495*Dd**2*K*f**2*s + 330*Dd**2*K*f**2 + 5040*Dd**2*f**3*r**2 + 5040*Dd**2*f**3*r*s - 5040*Dd**2*f**3*r - 1260*Dd**2*f**3*s + 840*Dd**2*f**3 - 1980*Dd**2*f**2*r**2 - 1980*Dd**2*f**2*r*s + 1980*Dd**2*f**2*r + 495*Dd**2*f**2*s - 330*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 4752*Dd**2*f*g2*r*s + 4752*Dd**2*f*g2*r + 1188*Dd**2*f*g2*s - 792*Dd**2*f*g2))/(9009*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**5*k2**3*st**2*(8*C - 8)*(33*D1*bd1*f*(D1*(7*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 33*b1*(D1*Dd*f*(7*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(7*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(151*f*(4*r*s - 2*r - s) - 125*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(151*f*fd*(r*(3*s - 1) - s) - 5*f*(33*bdd1*s*(r - 1) + 25*fdd*(3*r*s - r - s)) - 125*fd**2*(r*(6*s - 2) - 2*s + 1)) + 125*Ddd*f**2*(r*(2 - 4*s) + s)) - 125*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**5*k2**3*(264*b1**2*(C - 1)*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1*(-256*C*D1**2*f*fd*r*s + 64*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s + 32*C*D1**2*f*fd + 192*C*D1**2*f*fdd*r**2 + 272*C*D1**2*f*fdd*r*s - 56*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s - 40*C*D1**2*f*fdd + 192*C*D1**2*fd**2*r**2 + 272*C*D1**2*fd**2*r*s - 56*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s - 40*C*D1**2*fd**2 - 512*C*D1*Dd*f**2*r*s + 256*C*D1*Dd*f**2*r + 128*C*D1*Dd*f**2*s + 1536*C*D1*Dd*f*fd*r**2 + 2176*C*D1*Dd*f*fd*r*s - 1152*C*D1*Dd*f*fd*r - 112*C*D1*Dd*f*fd*s - 24*C*D1*Dd*f*fd + 384*C*D1*Ddd*f**2*r**2 + 544*C*D1*Ddd*f**2*r*s - 464*C*D1*Ddd*f**2*r - 136*C*D1*Ddd*f**2*s + 96*C*D1*Ddd*f**2 + 1152*C*Dd**2*f**2*r**2 + 1632*C*Dd**2*f**2*r*s - 1392*C*Dd**2*f**2*r - 408*C*Dd**2*f**2*s + 272*C*Dd**2*f**2 - 48*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 68*D1**2*f*fd*r**2 + 320*D1**2*f*fd*r*s - 96*D1**2*f*fd*r + 32*D1**2*f*fd*s - 32*D1**2*f*fd - 250*D1**2*f*fdd*r**2 - 352*D1**2*f*fdd*r*s + 96*D1**2*f*fdd*r - 40*D1**2*f*fdd*s + 40*D1**2*f*fdd - 250*D1**2*fd**2*r**2 - 352*D1**2*fd**2*r*s + 96*D1**2*fd**2*r - 40*D1**2*fd**2*s + 40*D1**2*fd**2 + 136*D1*Dd*f**2*r**2 + 640*D1*Dd*f**2*r*s - 388*D1*Dd*f**2*r - 160*D1*Dd*f**2*s + 34*D1*Dd*f**2 - 2000*D1*Dd*f*fd*r**2 - 2816*D1*Dd*f*fd*r*s + 1588*D1*Dd*f*fd*r + 192*D1*Dd*f*fd*s - 16*D1*Dd*f*fd - 500*D1*Ddd*f**2*r**2 - 704*D1*Ddd*f**2*r*s + 602*D1*Ddd*f**2*r + 176*D1*Ddd*f**2*s - 125*D1*Ddd*f**2 + 8*D1*bd1*(C - 1)*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 1500*Dd**2*f**2*r**2 - 2112*Dd**2*f**2*r*s + 1806*Dd**2*f**2*r + 528*Dd**2*f**2*s - 352*Dd**2*f**2) + f*(-1584*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(8*C*(12*r**2 + 17*r*(s - 2) - 22*s + 17) - 125*r**2 - 176*r*s + 330*r + 216*s - 165) - 5*D1**2*(f*(2*fd*(28*C*(27*r**2 + 48*r*s - 34*r - 16*s + 9) - 987*r**2 - 1620*r*s + 1198*r + 540*s - 329) + fdd*(-16*C*(171*r**2 + 183*r*s - 175*r - 61*s + 57) + 3165*r**2 + 3600*r*s - 3310*r - 1200*s + 1055)) + 2*fd**2*(-8*C*(342*r**2 + 366*r*s - 350*r - 122*s + 61) + 3165*r**2 + 3600*r*s - 3310*r - 1200*s + 600)) - 66*D1*bd1*(D1*(f*(16*C*(4*r*s - 2*r - 5*s + 1) - 17*r**2 - 80*r*s + 66*r + 96*s - 33) - 2*fd*(2*C*(48*r**2 + 68*r*s - 75*r - 39*s + 22) - 125*r**2 - 176*r*s + 189*r + 98*s - 54)) + Dd*f*(-4*C*(96*r**2 + 2*r*(68*s - 97) - 105*s + 78) + 500*r**2 + 704*r*s - 961*r - 520*s + 381)) - 5*D1*f*(2*Dd*(f*(28*C*(36*r**2 + 64*r*s - 50*r - 16*s + 9) - 1316*r**2 - 2160*r*s + 1738*r + 540*s - 329) + fd*(-8*C*(1368*r**2 + 8*r*(183*s - 176) - 427*s + 297) + 12660*r**2 + 5*r*(2880*s - 2677) - 4200*s + 2855)) + Ddd*f*(-16*C*(228*r**2 + 4*r*(61*s - 59) - 61*s + 57) + 4220*r**2 + 5*r*(960*s - 902) - 1200*s + 1055)) + 10*Dd**2*f**2*(8*C*(684*r**2 + 732*r*s - 708*r - 183*s + 122) - 6330*r**2 - 7200*r*s + 6765*r + 1800*s - 1200)))/(693*d**2*k3**4) + 4*D1**2*Pk3*Pkd1*ct**5*k2*(-66*b1**2*(C - 1)*(D1*Dd*(5*f*(-4*r*s + 2*r + s) + 6*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(5*fd - 6*fdd)*(s - 1) + 6*Ddd*f*(4*r*s - 2*r - s)) + 6*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 33*b1*(D1*Dd*f*(8*f*r*(2*s - 1) - 4*f*s + 5*fd*(2*s - 1)*(4*C - 8*r - 3)) - 2*D1*bd1*(C - 1)*(D1*(5*f*s*(1 - 2*r) + 6*fd*(4*r*s - 2*r - s + 1)) + 12*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(-4*f*fd*(-2*r*s + r + s*(2*C - 2)) + f*(-12*bdd1*s*(C - 1)*(2*r - 1) + 5*fdd*(-2*r*s + r + s*(2*C - 2))) + 5*fd**2*(2*C*(s - 1) - 2*r*s + r - 2*s + 2)) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(-396*D1**2*bd1**2*s*(C - 1)*(2*r - 1) - 5*D1*Dd*f*(2*C - 3)*(23*f*(r*(4*s - 2) - s) - 28*fd*(2*r*(12*s - 5) - 7*s + 3)) + 33*D1*bd1*(D1*(4*f*s*(2*C + r - 3) - 5*fd*(2*C*(s - 1) + 4*r*s - r - 4*s + 3)) - 5*Dd*f*(C*(8*s - 4) + 8*r*s - 2*r - 13*s + 6)) - 5*D1*(D1*(f*fd*(46*C - 69)*(r*(3*s - 1) - s) + f*(33*bdd1*s*(2*C + r - 3) - fdd*(56*C - 84)*(r*(3*s - 1) - s)) - fd**2*(56*C - 84)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(84 - 56*C)*(r*(4*s - 2) - s)) - 5*Dd**2*f**2*(84 - 56*C)*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k3**2) + D1**2*Pk3*Pkd1*ct**5*k2**3*(1188*D1**2*b1*f*fd*r**2 - 594*D1**2*b1*f*fdd*r**2 - 594*D1**2*b1*fd**2*r**2 - 297*D1**2*bdd1*f**2*(r - 1)**2 + 930*D1**2*f**2*fd*r**2 - 620*D1**2*f**2*fd*r + 310*D1**2*f**2*fd - 465*D1**2*f**2*fdd*r**2 + 310*D1**2*f**2*fdd*r - 155*D1**2*f**2*fdd - 930*D1**2*f*fd**2*r**2 + 620*D1**2*f*fd**2*r + 2376*D1*Dd*b1*f**2*r**2 - 1188*D1*Dd*b1*f**2*r + 594*D1*Dd*b1*f**2 - 4752*D1*Dd*b1*f*fd*r**2 + 1188*D1*Dd*b1*f*fd*r + 1240*D1*Dd*f**3*r**2 - 620*D1*Dd*f**3*r + 310*D1*Dd*f**3 - 3720*D1*Dd*f**2*fd*r**2 + 2170*D1*Dd*f**2*fd*r - 310*D1*Dd*f**2*fd - 1188*D1*Ddd*b1*f**2*r**2 + 594*D1*Ddd*b1*f**2*r - 297*D1*Ddd*b1*f**2 - 620*D1*Ddd*f**3*r**2 + 310*D1*Ddd*f**3*r - 155*D1*Ddd*f**3 + 594*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 3564*Dd**2*b1*f**2*r**2 + 1782*Dd**2*b1*f**2*r - 1860*Dd**2*f**3*r**2 + 930*Dd**2*f**3*r)/(693*d**2*k1**2*k3**2) + 20*D1**2*Pk3*Pkd1*ct**4*f*k2**6*st**2*(3276*D1**2*b1*f*fd*r**2 + 3276*D1**2*b1*f*fd*r*s - 2184*D1**2*b1*f*fd*r - 2925*D1**2*b1*f*fdd*r**2 - 2925*D1**2*b1*f*fdd*r*s + 1950*D1**2*b1*f*fdd*r - 5850*D1**2*b1*fd**2*r**2 - 5850*D1**2*b1*fd**2*r*s + 3900*D1**2*b1*fd**2*r - 975*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 3280*D1**2*f**2*fd*r**2 + 3280*D1**2*f**2*fd*r*s - 3280*D1**2*f**2*fd*r - 820*D1**2*f**2*fd*s + 820*D1**2*f**2*fd - 2940*D1**2*f**2*fdd*r**2 - 2940*D1**2*f**2*fdd*r*s + 2940*D1**2*f**2*fdd*r + 735*D1**2*f**2*fdd*s - 735*D1**2*f**2*fdd - 8820*D1**2*f*fd**2*r**2 - 8820*D1**2*f*fd**2*r*s + 8820*D1**2*f*fd**2*r + 2205*D1**2*f*fd**2*s - 1470*D1**2*f*fd**2 + 4368*D1*Dd*b1*f**2*r**2 + 4368*D1*Dd*b1*f**2*r*s - 4368*D1*Dd*b1*f**2*r - 1092*D1*Dd*b1*f**2*s + 1092*D1*Dd*b1*f**2 - 23400*D1*Dd*b1*f*fd*r**2 - 23400*D1*Dd*b1*f*fd*r*s + 19500*D1*Dd*b1*f*fd*r + 2925*D1*Dd*b1*f*fd*s - 1950*D1*Dd*b1*f*fd + 3280*D1*Dd*f**3*r**2 + 3280*D1*Dd*f**3*r*s - 3280*D1*Dd*f**3*r - 820*D1*Dd*f**3*s + 820*D1*Dd*f**3 - 23520*D1*Dd*f**2*fd*r**2 - 23520*D1*Dd*f**2*fd*r*s + 23520*D1*Dd*f**2*fd*r + 5880*D1*Dd*f**2*fd*s - 4410*D1*Dd*f**2*fd - 3900*D1*Ddd*b1*f**2*r**2 - 3900*D1*Ddd*b1*f**2*r*s + 3900*D1*Ddd*b1*f**2*r + 975*D1*Ddd*b1*f**2*s - 975*D1*Ddd*b1*f**2 - 2940*D1*Ddd*f**3*r**2 - 2940*D1*Ddd*f**3*r*s + 2940*D1*Ddd*f**3*r + 735*D1*Ddd*f**3*s - 735*D1*Ddd*f**3 + 39*D1*bd1*f*(D1*(28*f*(r - 1)*(r + s - 1) - 25*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 25*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 11700*Dd**2*b1*f**2*r**2 - 11700*Dd**2*b1*f**2*r*s + 11700*Dd**2*b1*f**2*r + 2925*Dd**2*b1*f**2*s - 1950*Dd**2*b1*f**2 - 8820*Dd**2*f**3*r**2 - 8820*Dd**2*f**3*r*s + 8820*Dd**2*f**3*r + 2205*Dd**2*f**3*s - 1470*Dd**2*f**3)/(9009*d**2*k1*k3**6) + D1**2*Pk3*Pkd1*ct**4*k1**3*k2**2*(160*C - 112)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**4*k1**3*(32*C - 20)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + 2*r + s) + 28*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 2) - s)) + 28*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k3**4) + 8*D1**2*Pk3*Pkd1*ct**4*k1*k2**4*st**2*(3432*C*D1**2*b1*f*fd*r**2 + 3432*C*D1**2*b1*f*fd*r*s - 1716*C*D1**2*b1*f*fd*r - 2508*C*D1**2*b1*f*fdd*r**2 - 2508*C*D1**2*b1*f*fdd*r*s + 1254*C*D1**2*b1*f*fdd*r - 2508*C*D1**2*b1*fd**2*r**2 - 2508*C*D1**2*b1*fd**2*r*s + 1254*C*D1**2*b1*fd**2*r + 3324*C*D1**2*f**2*fd*r**2 + 3324*C*D1**2*f**2*fd*r*s - 3324*C*D1**2*f**2*fd*r - 1108*C*D1**2*f**2*fd*s + 1108*C*D1**2*f**2*fd - 2850*C*D1**2*f**2*fdd*r**2 - 2850*C*D1**2*f**2*fdd*r*s + 2850*C*D1**2*f**2*fdd*r + 950*C*D1**2*f**2*fdd*s - 950*C*D1**2*f**2*fdd - 5700*C*D1**2*f*fd**2*r**2 - 5700*C*D1**2*f*fd**2*r*s + 5700*C*D1**2*f*fd**2*r + 1900*C*D1**2*f*fd**2*s - 950*C*D1**2*f*fd**2 + 6864*C*D1*Dd*b1*f**2*r**2 + 6864*C*D1*Dd*b1*f**2*r*s - 6864*C*D1*Dd*b1*f**2*r - 1716*C*D1*Dd*b1*f**2*s + 1716*C*D1*Dd*b1*f**2 - 20064*C*D1*Dd*b1*f*fd*r**2 - 20064*C*D1*Dd*b1*f*fd*r*s + 15048*C*D1*Dd*b1*f*fd*r + 2508*C*D1*Dd*b1*f*fd*s - 1254*C*D1*Dd*b1*f*fd + 4432*C*D1*Dd*f**3*r**2 + 4432*C*D1*Dd*f**3*r*s - 4432*C*D1*Dd*f**3*r - 1108*C*D1*Dd*f**3*s + 1108*C*D1*Dd*f**3 - 22800*C*D1*Dd*f**2*fd*r**2 - 22800*C*D1*Dd*f**2*fd*r*s + 22800*C*D1*Dd*f**2*fd*r + 6650*C*D1*Dd*f**2*fd*s - 4750*C*D1*Dd*f**2*fd - 5016*C*D1*Ddd*b1*f**2*r**2 - 5016*C*D1*Ddd*b1*f**2*r*s + 5016*C*D1*Ddd*b1*f**2*r + 1254*C*D1*Ddd*b1*f**2*s - 1254*C*D1*Ddd*b1*f**2 - 3800*C*D1*Ddd*f**3*r**2 - 3800*C*D1*Ddd*f**3*r*s + 3800*C*D1*Ddd*f**3*r + 950*C*D1*Ddd*f**3*s - 950*C*D1*Ddd*f**3 - 15048*C*Dd**2*b1*f**2*r**2 - 15048*C*Dd**2*b1*f**2*r*s + 15048*C*Dd**2*b1*f**2*r + 3762*C*Dd**2*b1*f**2*s - 2508*C*Dd**2*b1*f**2 - 11400*C*Dd**2*f**3*r**2 - 11400*C*Dd**2*f**3*r*s + 11400*C*Dd**2*f**3*r + 2850*C*Dd**2*f**3*s - 1900*C*Dd**2*f**3 - 2970*D1**2*b1*f*fd*r**2 - 2970*D1**2*b1*f*fd*r*s + 1485*D1**2*b1*f*fd*r + 2178*D1**2*b1*f*fdd*r**2 + 2178*D1**2*b1*f*fdd*r*s - 1089*D1**2*b1*f*fdd*r + 2178*D1**2*b1*fd**2*r**2 + 2178*D1**2*b1*fd**2*r*s - 1089*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(38*C - 33)*(r - 1)*(r + s - 1) - 2871*D1**2*f**2*fd*r**2 - 2871*D1**2*f**2*fd*r*s + 2871*D1**2*f**2*fd*r + 957*D1**2*f**2*fd*s - 957*D1**2*f**2*fd + 2475*D1**2*f**2*fdd*r**2 + 2475*D1**2*f**2*fdd*r*s - 2475*D1**2*f**2*fdd*r - 825*D1**2*f**2*fdd*s + 825*D1**2*f**2*fdd + 4950*D1**2*f*fd**2*r**2 + 4950*D1**2*f*fd**2*r*s - 4950*D1**2*f*fd**2*r - 1650*D1**2*f*fd**2*s + 825*D1**2*f*fd**2 - 5940*D1*Dd*b1*f**2*r**2 - 5940*D1*Dd*b1*f**2*r*s + 5940*D1*Dd*b1*f**2*r + 1485*D1*Dd*b1*f**2*s - 1485*D1*Dd*b1*f**2 + 17424*D1*Dd*b1*f*fd*r**2 + 17424*D1*Dd*b1*f*fd*r*s - 13068*D1*Dd*b1*f*fd*r - 2178*D1*Dd*b1*f*fd*s + 1089*D1*Dd*b1*f*fd - 3828*D1*Dd*f**3*r**2 - 3828*D1*Dd*f**3*r*s + 3828*D1*Dd*f**3*r + 957*D1*Dd*f**3*s - 957*D1*Dd*f**3 + 19800*D1*Dd*f**2*fd*r**2 + 19800*D1*Dd*f**2*fd*r*s - 19800*D1*Dd*f**2*fd*r - 5775*D1*Dd*f**2*fd*s + 4125*D1*Dd*f**2*fd + 4356*D1*Ddd*b1*f**2*r**2 + 4356*D1*Ddd*b1*f**2*r*s - 4356*D1*Ddd*b1*f**2*r - 1089*D1*Ddd*b1*f**2*s + 1089*D1*Ddd*b1*f**2 + 3300*D1*Ddd*f**3*r**2 + 3300*D1*Ddd*f**3*r*s - 3300*D1*Ddd*f**3*r - 825*D1*Ddd*f**3*s + 825*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(52*C - 45)*(r - 1)*(r + s - 1) - fd*(38*C - 33)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(38*C - 33)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 13068*Dd**2*b1*f**2*r**2 + 13068*Dd**2*b1*f**2*r*s - 13068*Dd**2*b1*f**2*r - 3267*Dd**2*b1*f**2*s + 2178*Dd**2*b1*f**2 + 9900*Dd**2*f**3*r**2 + 9900*Dd**2*f**3*r*s - 9900*Dd**2*f**3*r - 2475*Dd**2*f**3*s + 1650*Dd**2*f**3)/(693*d**2*k3**6) - 8*D1**2*Pk3*Pkd1*ct**4*k1*k2**4*(-858*D1**2*bd1**2*f*(2*r - 1)*(-15*K + 10*f + 12)*(r + s - 1) + 65*D1**2*bdd1*f*(r + s - 1)*(56*f**2*(r - 3) + 33*f*r*(5*K - 4) - 396*g2*(r - 1)) - 30*D1**2*(7*f**3*(38*fd - 45*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) + f**2*(-315*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - r*(572*gd2 - 715*gdd2)*(r + s - 1)) - 143*f*(fd*(g2*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 715*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) - 13*D1*bd1*(D1*(230*f**3*(r - 3)*(r + s - 1) - 4*f**2*(70*fd*(6*r**2 + 6*r*(s - 2) - 7*s + 4) - r*(165*K - 132)*(r + s - 1)) - 165*f*(fd*(5*K - 4)*(4*r**2 + 4*r*(s - 1) - s + 1) + (10*g2*(r - 1) + 12*gd2*(1 - 2*r))*(r + s - 1)) + 1980*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(56*f**2*(8*r**2 + 4*r*(2*s - 5) - 13*s + 10) + 33*f*(5*K - 4)*(8*r**2 + 8*r*(s - 1) - s + 1) - 396*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 30*D1*f*(Dd*(266*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 630*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 143*f*(4*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 1430*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 5*Ddd*f*(63*f**2 - 143*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 150*Dd**2*f**2*(63*f**2 - 143*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 429*b1**2*(D1**2*r*(4*f*(4*fd - 5*fdd)*(2*r + 2*s - 1) - 20*fd**2*(2*r + 2*s - 1) - 5*fd*(5*K - 4)*(r + s) + 6*fdd*(5*K - 4)*(r + s)) + D1*(Dd*(16*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(64*r**2 + 16*r*(4*s - 3) - 8*s + 4) + (5*K - 4)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*fd*(5*K - 4)*(8*r**2 + r*(8*s - 4) - s)) - 2*Ddd*f*(-15*K + 10*f + 12)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 2*Dd**2*f*(-15*K + 10*f + 12)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-1320*D1**2*K*f*fd*r**2 - 1320*D1**2*K*f*fd*r*s + 1320*D1**2*K*f*fd*r + 660*D1**2*K*f*fd*s - 660*D1**2*K*f*fd + 1650*D1**2*K*f*fdd*r**2 + 1650*D1**2*K*f*fdd*r*s - 1650*D1**2*K*f*fdd*r - 825*D1**2*K*f*fdd*s + 825*D1**2*K*f*fdd + 1650*D1**2*K*fd**2*r**2 + 1650*D1**2*K*fd**2*r*s - 1650*D1**2*K*fd**2*r - 825*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(2*r - 1)*(-15*K + 10*f + 12)*(r + s - 1) - 690*D1**2*f**2*fd*r**2 - 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*s + 460*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 + 1056*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 1056*D1**2*f*fd*r - 528*D1**2*f*fd*s + 528*D1**2*f*fd - 1320*D1**2*f*fdd*r**2 - 1320*D1**2*f*fdd*r*s + 1320*D1**2*f*fdd*r + 660*D1**2*f*fdd*s - 660*D1**2*f*fdd + 1650*D1**2*f*gd2*r**2 + 1650*D1**2*f*gd2*r*s - 1650*D1**2*f*gd2*r - 1980*D1**2*f*gdd2*r**2 - 1980*D1**2*f*gdd2*r*s + 1980*D1**2*f*gdd2*r - 1320*D1**2*fd**2*r**2 - 1320*D1**2*fd**2*r*s + 1320*D1**2*fd**2*r + 660*D1**2*fd**2*s + 1650*D1**2*fd*g2*r**2 + 1650*D1**2*fd*g2*r*s - 3960*D1**2*fd*gd2*r**2 - 3960*D1**2*fd*gd2*r*s + 1980*D1**2*fd*gd2*r - 1980*D1**2*fdd*g2*r**2 - 1980*D1**2*fdd*g2*r*s - 2640*D1*Dd*K*f**2*r**2 - 2640*D1*Dd*K*f**2*r*s + 2640*D1*Dd*K*f**2*r + 660*D1*Dd*K*f**2*s - 660*D1*Dd*K*f**2 + 13200*D1*Dd*K*f*fd*r**2 + 13200*D1*Dd*K*f*fd*r*s - 13200*D1*Dd*K*f*fd*r - 4950*D1*Dd*K*f*fd*s + 3300*D1*Dd*K*f*fd - 920*D1*Dd*f**3*r**2 - 920*D1*Dd*f**3*r*s + 920*D1*Dd*f**3*r + 230*D1*Dd*f**3*s - 230*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 3360*D1*Dd*f**2*fd*r + 1400*D1*Dd*f**2*fd*s - 1120*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 2112*D1*Dd*f**2*r - 528*D1*Dd*f**2*s + 528*D1*Dd*f**2 - 10560*D1*Dd*f*fd*r**2 - 10560*D1*Dd*f*fd*r*s + 10560*D1*Dd*f*fd*r + 3960*D1*Dd*f*fd*s - 2640*D1*Dd*f*fd + 6600*D1*Dd*f*g2*r**2 + 6600*D1*Dd*f*g2*r*s - 6600*D1*Dd*f*g2*r - 1650*D1*Dd*f*g2*s + 1650*D1*Dd*f*g2 - 15840*D1*Dd*f*gd2*r**2 - 15840*D1*Dd*f*gd2*r*s + 15840*D1*Dd*f*gd2*r + 1980*D1*Dd*f*gd2*s - 1980*D1*Dd*f*gd2 - 15840*D1*Dd*fd*g2*r**2 - 15840*D1*Dd*fd*g2*r*s + 7920*D1*Dd*fd*g2*r + 1980*D1*Dd*fd*g2*s + 3300*D1*Ddd*K*f**2*r**2 + 3300*D1*Ddd*K*f**2*r*s - 3300*D1*Ddd*K*f**2*r - 825*D1*Ddd*K*f**2*s + 825*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 1120*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s + 280*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*r**2 - 2640*D1*Ddd*f**2*r*s + 2640*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s - 660*D1*Ddd*f**2 - 7920*D1*Ddd*f*g2*r**2 - 7920*D1*Ddd*f*g2*r*s + 7920*D1*Ddd*f*g2*r + 1980*D1*Ddd*f*g2*s - 1980*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(16*f**2*(2*r - 1)*(r + s - 1) - 5*f*(4*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + (5*K - 4)*(2*r - 1)*(r + s - 1)) + 6*fd*(5*K - 4)*(4*r**2 + r*(4*s - 3) - s)) - 2*Dd*f*(-15*K + 10*f + 12)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 9900*Dd**2*K*f**2*r**2 + 9900*Dd**2*K*f**2*r*s - 9900*Dd**2*K*f**2*r - 2475*Dd**2*K*f**2*s + 1650*Dd**2*K*f**2 + 3360*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 3360*Dd**2*f**3*r - 840*Dd**2*f**3*s + 560*Dd**2*f**3 - 7920*Dd**2*f**2*r**2 - 7920*Dd**2*f**2*r*s + 7920*Dd**2*f**2*r + 1980*Dd**2*f**2*s - 1320*Dd**2*f**2 - 23760*Dd**2*f*g2*r**2 - 23760*Dd**2*f*g2*r*s + 23760*Dd**2*f*g2*r + 5940*Dd**2*f*g2*s - 3960*Dd**2*f*g2))/(9009*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*ct**4*k1*k2**2*st**2*(33*D1*bd1*f*(D1*(f*s*(46*C - 39)*(r - 1) - fd*(32*C - 27)*(r*(4*s - 1) - 2*s + 1)) - Dd*f*(32*C - 27)*(r*(8*s - 2) - 5*s + 2)) - 33*b1*(D1*Dd*f*(-f*(46*C - 39)*(r*(4*s - 2) - s) + fd*(32*C - 27)*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(46*C - 39) + f*fdd*(27 - 32*C) + fd**2*(27 - 32*C)) + Ddd*f**2*(32*C - 27)*(r*(4*s - 2) - s)) + Dd**2*f**2*(32*C - 27)*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(f*(1006*C - 855)*(r*(4*s - 2) - s) - fd*(800*C - 675)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(f*fd*(1006*C - 855)*(r*(3*s - 1) - s) - f*(32*C - 27)*(33*bdd1*s*(r - 1) + 25*fdd*(r*(3*s - 1) - s)) - fd**2*(800*C - 675)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(675 - 800*C)*(r*(4*s - 2) - s)) + Dd**2*f**2*(675 - 800*C)*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**4*k1*k2**2*(132*b1**2*(6*C - 5)*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1*(-240*C*D1**2*f*fd*r**2 - 864*C*D1**2*f*fd*r*s + 240*C*D1**2*f*fd*r - 96*C*D1**2*f*fd*s + 96*C*D1**2*f*fd + 552*C*D1**2*f*fdd*r**2 + 912*C*D1**2*f*fdd*r*s - 216*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s - 120*C*D1**2*f*fdd + 552*C*D1**2*fd**2*r**2 + 912*C*D1**2*fd**2*r*s - 216*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 - 480*C*D1*Dd*f**2*r**2 - 1728*C*D1*Dd*f**2*r*s + 1104*C*D1*Dd*f**2*r + 432*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 + 4416*C*D1*Dd*f*fd*r**2 + 7296*C*D1*Dd*f*fd*r*s - 3792*C*D1*Dd*f*fd*r - 432*C*D1*Dd*f*fd*s - 24*C*D1*Dd*f*fd + 1104*C*D1*Ddd*f**2*r**2 + 1824*C*D1*Ddd*f**2*r*s - 1464*C*D1*Ddd*f**2*r - 456*C*D1*Ddd*f**2*s + 276*C*D1*Ddd*f**2 + 3312*C*Dd**2*f**2*r**2 + 5472*C*Dd**2*f**2*r*s - 4392*C*Dd**2*f**2*r - 1368*C*Dd**2*f**2*s + 912*C*Dd**2*f**2 - 24*D1**2*bdd1*f*(6*C - 5)*(2*r**2 + 2*r*(s - 1) - s + 1) + 220*D1**2*f*fd*r**2 + 784*D1**2*f*fd*r*s - 232*D1**2*f*fd*r + 80*D1**2*f*fd*s - 80*D1**2*f*fd - 458*D1**2*f*fdd*r**2 - 836*D1**2*f*fdd*r*s + 218*D1**2*f*fdd*r - 100*D1**2*f*fdd*s + 100*D1**2*f*fdd - 458*D1**2*fd**2*r**2 - 836*D1**2*fd**2*r*s + 218*D1**2*fd**2*r - 100*D1**2*fd**2*s + 100*D1**2*fd**2 + 440*D1*Dd*f**2*r**2 + 1568*D1*Dd*f**2*r*s - 1004*D1*Dd*f**2*r - 392*D1*Dd*f**2*s + 110*D1*Dd*f**2 - 3664*D1*Dd*f*fd*r**2 - 6688*D1*Dd*f*fd*r*s + 3460*D1*Dd*f*fd*r + 436*D1*Dd*f*fd*s - 18*D1*Dd*f*fd - 916*D1*Ddd*f**2*r**2 - 1672*D1*Ddd*f**2*r*s + 1294*D1*Ddd*f**2*r + 418*D1*Ddd*f**2*s - 229*D1*Ddd*f**2 + 4*D1*bd1*(6*C - 5)*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 2748*Dd**2*f**2*r**2 - 5016*Dd**2*f**2*r*s + 3882*Dd**2*f**2*r + 1254*Dd**2*f**2*s - 836*Dd**2*f**2) + f*(-792*D1**2*bd1**2*(6*C - 5)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(12*C*(23*r**2 + r*(38*s - 66) - 48*s + 33) - 229*r**2 - 418*r*s + 658*r + 518*s - 329) - 5*D1**2*(f*(2*fd*(12*C*(213*r**2 + 369*r*s - 265*r - 123*s + 71) - 2154*r**2 - 3963*r*s + 2757*r + 1321*s - 718) + fdd*(-84*C*(87*r**2 + 114*r*s - 96*r - 38*s + 29) + 6015*r**2 + 8616*r*s - 6882*r - 2872*s + 2005)) - 2*fd**2*(84*C*(87*r**2 + 114*r*s - 96*r - 38*s + 19) - 6015*r**2 - 8616*r*s + 6882*r + 2872*s - 1436)) - 66*D1*bd1*(D1*(f*(12*C*(5*r**2 + 18*r*(s - 1) - 22*s + 9) - 55*r**2 - 196*r*s + 190*r + 236*s - 95) + fd*(-12*C*(46*r**2 + 76*r*s - 75*r - 43*s + 24) + 458*r**2 + 836*r*s - 767*r - 468*s + 259)) + Dd*f*(-12*C*(92*r**2 + 152*r*s - 193*r - 115*s + 81) + 916*r**2 + 1672*r*s - 1963*r - 1245*s + 847)) - 5*D1*f*(2*Dd*(f*(12*C*(284*r**2 + 492*r*s - 388*r - 123*s + 71) - 2872*r**2 - 5284*r*s + 4078*r + 1321*s - 718) + fd*(-84*C*(348*r**2 + 456*r*s - 393*r - 133*s + 86) + 24060*r**2 + 34464*r*s - 28395*r - 10052*s + 6313)) + Ddd*f*(-84*C*(116*r**2 + 2*r*(76*s - 67) - 38*s + 29) + 8020*r**2 + 11488*r*s - 9754*r - 2872*s + 2005)) - 10*Dd**2*f**2*(-84*C*(174*r**2 + 3*r*(76*s - 67) - 57*s + 38) + 12030*r**2 + 3*r*(5744*s - 4877) - 4308*s + 2872)))/(693*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**4*k1*(16*C - 12)*(33*D1*b1*(D1*bd1*(5*f*s*(2*r - 1) - 6*fd*(r*(4*s - 2) - s + 1)) - 4*D1*f*fd*s + D1*f*s*(bdd1*(6 - 12*r) + 5*fdd) + 5*D1*fd**2*(s - 1) - 12*Dd*bd1*f*(r*(8*s - 2) - 3*s + 1) + 10*Dd*f*fd*(2*s - 1)) - 33*b1**2*(D1*Dd*(5*f*(-4*r*s + 2*r + s) + 6*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(5*fd - 6*fdd)*(s - 1) + 6*Ddd*f*(4*r*s - 2*r - s)) + 6*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + f*(-198*D1**2*bd1**2*s*(2*r - 1) - 5*D1*Dd*f*(23*f*(4*r*s - 2*r - s) - 28*fd*(24*r*s - 10*r - 7*s + 3)) + 33*D1*bd1*(4*D1*f*s - 5*D1*fd*(s - 1) + 10*Dd*f*(1 - 2*s)) - 5*D1*(D1*(23*f*fd*(r*(3*s - 1) - s) + f*(33*bdd1*s + 28*fdd*(-3*r*s + r + s)) - 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(2 - 4*s) + s)) + 140*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k3**2) - 4*D1**2*Pk3*Pkd1*ct**4*k2**4*st**2*(330*C*D1**2*b1*f*fd*r**2 - 264*C*D1**2*b1*f*fdd*r**2 - 264*C*D1**2*b1*fd**2*r**2 + 663*C*D1**2*f**2*fd*r**2 - 442*C*D1**2*f**2*fd*r + 221*C*D1**2*f**2*fd - 480*C*D1**2*f**2*fdd*r**2 + 320*C*D1**2*f**2*fdd*r - 160*C*D1**2*f**2*fdd - 960*C*D1**2*f*fd**2*r**2 + 640*C*D1**2*f*fd**2*r + 660*C*D1*Dd*b1*f**2*r**2 - 330*C*D1*Dd*b1*f**2*r + 165*C*D1*Dd*b1*f**2 - 2112*C*D1*Dd*b1*f*fd*r**2 + 528*C*D1*Dd*b1*f*fd*r + 884*C*D1*Dd*f**3*r**2 - 442*C*D1*Dd*f**3*r + 221*C*D1*Dd*f**3 - 3840*C*D1*Dd*f**2*fd*r**2 + 2240*C*D1*Dd*f**2*fd*r - 320*C*D1*Dd*f**2*fd - 528*C*D1*Ddd*b1*f**2*r**2 + 264*C*D1*Ddd*b1*f**2*r - 132*C*D1*Ddd*b1*f**2 - 640*C*D1*Ddd*f**3*r**2 + 320*C*D1*Ddd*f**3*r - 160*C*D1*Ddd*f**3 - 1584*C*Dd**2*b1*f**2*r**2 + 792*C*Dd**2*b1*f**2*r - 1920*C*Dd**2*f**3*r**2 + 960*C*Dd**2*f**3*r - 792*D1**2*b1*f*fd*r**2 - 462*D1**2*b1*f*fd*r*s + 231*D1**2*b1*f*fd*r + 594*D1**2*b1*f*fdd*r**2 + 330*D1**2*b1*f*fdd*r*s - 165*D1**2*b1*f*fdd*r + 594*D1**2*b1*fd**2*r**2 + 330*D1**2*b1*fd**2*r*s - 165*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(4*C*(r - 1) - 9*r - 5*s + 9) - 1116*D1**2*f**2*fd*r**2 - 453*D1**2*f**2*fd*r*s + 895*D1**2*f**2*fd*r + 151*D1**2*f**2*fd*s - 372*D1**2*f**2*fd + 855*D1**2*f**2*fdd*r**2 + 375*D1**2*f**2*fdd*r*s - 695*D1**2*f**2*fdd*r - 125*D1**2*f**2*fdd*s + 285*D1**2*f**2*fdd + 1710*D1**2*f*fd**2*r**2 + 750*D1**2*f*fd**2*r*s - 1390*D1**2*f*fd**2*r - 250*D1**2*f*fd**2*s + 125*D1**2*f*fd**2 - 1584*D1*Dd*b1*f**2*r**2 - 924*D1*Dd*b1*f**2*r*s + 1254*D1*Dd*b1*f**2*r + 231*D1*Dd*b1*f**2*s - 396*D1*Dd*b1*f**2 + 4752*D1*Dd*b1*f*fd*r**2 + 2640*D1*Dd*b1*f*fd*r*s - 2508*D1*Dd*b1*f*fd*r - 330*D1*Dd*b1*f*fd*s + 165*D1*Dd*b1*f*fd - 1488*D1*Dd*f**3*r**2 - 604*D1*Dd*f**3*r*s + 1046*D1*Dd*f**3*r + 151*D1*Dd*f**3*s - 372*D1*Dd*f**3 + 6840*D1*Dd*f**2*fd*r**2 + 3000*D1*Dd*f**2*fd*r*s - 5240*D1*Dd*f**2*fd*r - 875*D1*Dd*f**2*fd*s + 945*D1*Dd*f**2*fd + 1188*D1*Ddd*b1*f**2*r**2 + 660*D1*Ddd*b1*f**2*r*s - 924*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2*s + 297*D1*Ddd*b1*f**2 + 1140*D1*Ddd*f**3*r**2 + 500*D1*Ddd*f**3*r*s - 820*D1*Ddd*f**3*r - 125*D1*Ddd*f**3*s + 285*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(r - 1)*(5*C*(r - 1) - 12*r - 7*s + 12) + fd*(-r**2*(16*C - 36) + r*(16*C + 20*s - 41) - 10*s + 5)) + Dd*f*(-8*C*(4*r**2 - 5*r + 1) + 72*r**2 + 20*r*(2*s - 5) - 25*s + 28)) + 3564*Dd**2*b1*f**2*r**2 + 1980*Dd**2*b1*f**2*r*s - 2772*Dd**2*b1*f**2*r - 495*Dd**2*b1*f**2*s + 330*Dd**2*b1*f**2 + 3420*Dd**2*f**3*r**2 + 1500*Dd**2*f**3*r*s - 2460*Dd**2*f**3*r - 375*Dd**2*f**3*s + 250*Dd**2*f**3)/(693*d**2*k1*k3**4) - D1**2*Pk3*Pkd1*ct**4*k2**4*(-2145*D1**2*K*bdd1*f**2*r**2 + 858*D1**2*bd1**2*f*(f*(41*r**2 + r*(40*s - 51) - 20*s + 10) - r**2*(K - 25) + r*(K + 24*s - 37) - 12*s + 12) + 11310*D1**2*bdd1*f**3*r**2 - 6890*D1**2*bdd1*f**3*r*s + 2470*D1**2*bdd1*f**3*r + 21450*D1**2*bdd1*f**3*s - 4875*D1**2*bdd1*f**3 + 10725*D1**2*bdd1*f**2*r**2 + 8580*D1**2*bdd1*f**2*r*s - 8580*D1**2*bdd1*f**2*r + 858*D1**2*bdd1*f*g2*r**2 - 1716*D1**2*bdd1*f*g2*r + 858*D1**2*bdd1*f*g2 + 9240*D1**2*f**3*fd*r**2 + 72800*D1**2*f**3*fd*r*s - 41020*D1**2*f**3*fd*r - 18200*D1**2*f**3*fd*s + 2310*D1**2*f**3*fd - 26460*D1**2*f**3*fdd*r**2 - 72800*D1**2*f**3*fdd*r*s + 49630*D1**2*f**3*fdd*r + 18200*D1**2*f**3*fdd*s - 6615*D1**2*f**3*fdd - 79380*D1**2*f**2*fd**2*r**2 - 218400*D1**2*f**2*fd**2*r*s + 148890*D1**2*f**2*fd**2*r + 54600*D1**2*f**2*fd**2*s - 36400*D1**2*f**2*fd**2 + 1716*D1**2*f**2*gd2*r**2 + 4290*D1**2*f**2*gdd2*r**2 + 3432*D1**2*f*fd*g2*r**2 - 3432*D1**2*f*fd*g2*r + 1716*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r**2 - 8580*D1**2*f*fd*gd2*r + 8580*D1**2*f*fdd*g2*r**2 - 8580*D1**2*f*fdd*g2*r + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r**2 - 8580*D1**2*fd**2*g2*r + 9240*D1*Dd*f**4*r**2 + 72800*D1*Dd*f**4*r*s - 41020*D1*Dd*f**4*r - 18200*D1*Dd*f**4*s + 2310*D1*Dd*f**4 - 211680*D1*Dd*f**3*fd*r**2 - 582400*D1*Dd*f**3*fd*r*s + 397040*D1*Dd*f**3*fd*r + 145600*D1*Dd*f**3*fd*s - 86030*D1*Dd*f**3*fd + 6864*D1*Dd*f**2*g2*r**2 - 3432*D1*Dd*f**2*g2*r + 1716*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r**2 - 8580*D1*Dd*f**2*gd2*r + 68640*D1*Dd*f*fd*g2*r**2 - 51480*D1*Dd*f*fd*g2*r + 8580*D1*Dd*f*fd*g2 - 26460*D1*Ddd*f**4*r**2 - 72800*D1*Ddd*f**4*r*s + 49630*D1*Ddd*f**4*r + 18200*D1*Ddd*f**4*s - 6615*D1*Ddd*f**4 + 17160*D1*Ddd*f**2*g2*r**2 - 8580*D1*Ddd*f**2*g2*r + 4290*D1*Ddd*f**2*g2 - 26*D1*bd1*(D1*(5*f**3*(108*r**2 - 73*r*s - 94*r + 165*s + 24) + f**2*(-5*fd*(522*r**2 - 6*r*(53*s + 5) + 383*s - 274) + 33*r*(r*(K + 7) + 8*s - 8)) + 33*f*(5*fd*(r**2*(2*K - 10) - r*(K + 8*s - 9) + 2*s - 2) + (2 - 2*r)*(6*g2*(r - 1) + gd2*r)) - 66*fd*g2*r*(r - 1)) - Dd*f*(5*f**2*(696*r**2 + r*(8 - 424*s) + 713*s - 349) - 165*f*(r**2*(4*K - 20) - r*(K + 16*s - 17) + 2*s - 2) + 66*g2*(4*r**2 - 5*r + 1))) - 79380*Dd**2*f**4*r**2 - 218400*Dd**2*f**4*r*s + 148890*Dd**2*f**4*r + 54600*Dd**2*f**4*s - 36400*Dd**2*f**4 + 51480*Dd**2*f**2*g2*r**2 - 25740*Dd**2*f**2*g2*r - 429*b1**2*(D1**2*r*(f*fd*(44*r + 64*s - 48) - 2*f*fdd*(41*r + 40*s - 30) + fd**2*(-82*r - 80*s + 60) + 4*fd*r*(3*K + 2) + 20*fd*s + fdd*r*(K - 25) - 24*fdd*s) + D1*(2*Dd*(f**2*(44*r**2 + r*(64*s - 54) - 16*s + 11) - 2*f*(-3*K*(4*r**2 - 2*r + 1) + fd*(164*r**2 + r*(160*s - 141) - 20*s + 15) - 8*r**2 - 20*r*s + 14*r + 5*s - 2) + fd*(r**2*(4*K - 100) - r*(K + 96*s - 49) + 12*s)) + Ddd*f*(4*K*r**2 - 2*K*r + K + f*(-164*r**2 - 2*r*(80*s - 81) + 40*s - 41) - 100*r**2 - 96*r*s + 98*r + 24*s - 25)) - 2*Dd**2*f*(f*(246*r**2 + 3*r*(80*s - 81) - 60*s + 40) - 3*r**2*(2*K - 50) + 3*r*(K + 48*s - 49) - 36*s + 24)) - 13*b1*(132*D1**2*K*f*fd*r**2 - 132*D1**2*K*f*fd*r + 66*D1**2*K*f*fd + 330*D1**2*K*f*fdd*r**2 - 330*D1**2*K*f*fdd*r + 165*D1**2*K*f*fdd + 330*D1**2*K*fd**2*r**2 - 330*D1**2*K*fd**2*r - 33*D1**2*bdd1*f*(K*(-2*r**2 + 2*r - 1) + f*(82*r**2 + 2*r*(40*s - 51) - 40*s + 41) + 50*r**2 + 48*r*s - 74*r - 24*s + 25) + 3240*D1**2*f**2*fd*r**2 - 2190*D1**2*f**2*fd*r*s + 240*D1**2*f**2*fd*r - 920*D1**2*f**2*fd*s + 840*D1**2*f**2*fd - 2610*D1**2*f**2*fdd*r**2 + 1590*D1**2*f**2*fdd*r*s + 870*D1**2*f**2*fdd*r + 1120*D1**2*f**2*fdd*s - 1245*D1**2*f**2*fdd - 5220*D1**2*f*fd**2*r**2 + 3180*D1**2*f*fd**2*r*s + 1740*D1**2*f*fd**2*r + 2240*D1**2*f*fd**2*s - 1680*D1**2*f*fd**2 + 924*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 924*D1**2*f*fd*r - 528*D1**2*f*fd*s + 462*D1**2*f*fd - 1650*D1**2*f*fdd*r**2 - 1320*D1**2*f*fdd*r*s + 1650*D1**2*f*fdd*r + 660*D1**2*f*fdd*s - 825*D1**2*f*fdd - 792*D1**2*f*gd2*r**2 - 66*D1**2*f*gdd2*r**2 - 1650*D1**2*fd**2*r**2 - 1320*D1**2*fd**2*r*s + 1650*D1**2*fd**2*r + 660*D1**2*fd**2*s - 792*D1**2*fd*g2*r**2 - 132*D1**2*fd*gd2*r**2 - 66*D1**2*fdd*g2*r**2 + 264*D1*Dd*K*f**2*r**2 - 132*D1*Dd*K*f**2*r + 66*D1*Dd*K*f**2 + 2640*D1*Dd*K*f*fd*r**2 - 1980*D1*Dd*K*f*fd*r + 330*D1*Dd*K*f*fd + 4320*D1*Dd*f**3*r**2 - 2920*D1*Dd*f**3*r*s - 700*D1*Dd*f**3*r + 730*D1*Dd*f**3*s + 1080*D1*Dd*f**3 - 20880*D1*Dd*f**2*fd*r**2 + 12720*D1*Dd*f**2*fd*r*s + 5520*D1*Dd*f**2*fd*r + 2890*D1*Dd*f**2*fd*s - 3110*D1*Dd*f**2*fd + 1848*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 1980*D1*Dd*f**2*r - 528*D1*Dd*f**2*s + 462*D1*Dd*f**2 - 13200*D1*Dd*f*fd*r**2 - 10560*D1*Dd*f*fd*r*s + 12540*D1*Dd*f*fd*r + 3960*D1*Dd*f*fd*s - 2970*D1*Dd*f*fd - 3168*D1*Dd*f*g2*r**2 + 1584*D1*Dd*f*g2*r - 792*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r**2 + 132*D1*Dd*f*gd2*r - 528*D1*Dd*fd*g2*r**2 + 132*D1*Dd*fd*g2*r + 660*D1*Ddd*K*f**2*r**2 - 330*D1*Ddd*K*f**2*r + 165*D1*Ddd*K*f**2 - 3480*D1*Ddd*f**3*r**2 + 2120*D1*Ddd*f**3*r*s + 680*D1*Ddd*f**3*r - 530*D1*Ddd*f**3*s - 870*D1*Ddd*f**3 - 3300*D1*Ddd*f**2*r**2 - 2640*D1*Ddd*f**2*r*s + 2970*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s - 825*D1*Ddd*f**2 - 264*D1*Ddd*f*g2*r**2 + 132*D1*Ddd*f*g2*r - 66*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f**2*(22*r**2 + r*(32*s - 30) - 16*s + 11) - 2*f*(K*(-6*r**2 + 6*r - 3) + fd*(82*r**2 + r*(80*s - 81) - 20*s + 15) - 4*r**2 - 10*r*s + 9*r + 5*s - 2) + fd*(r**2*(2*K - 50) - r*(K + 48*s - 37) + 12*s)) + Dd*f*(8*K*r**2 - 6*K*r + K + f*(-328*r**2 + r*(366 - 320*s) + 120*s - 91) - 200*r**2 - 192*r*s + 246*r + 72*s - 61)) + 1980*Dd**2*K*f**2*r**2 - 990*Dd**2*K*f**2*r - 10440*Dd**2*f**3*r**2 + 6360*Dd**2*f**3*r*s + 2040*Dd**2*f**3*r - 1590*Dd**2*f**3*s + 1060*Dd**2*f**3 - 9900*Dd**2*f**2*r**2 - 7920*Dd**2*f**2*r*s + 8910*Dd**2*f**2*r + 1980*Dd**2*f**2*s - 1320*Dd**2*f**2 - 792*Dd**2*f*g2*r**2 + 396*Dd**2*f*g2*r))/(9009*d**2*k1*k3**4) + 4*D1**2*Pk3*Pkd1*ct**4*k2**2*st**2*(33*D1*bd1*f*(D1*(7*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 33*b1*(D1*Dd*f*(7*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(7*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(151*f*(4*r*s - 2*r - s) - 125*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(151*f*fd*(r*(3*s - 1) - s) - 5*f*(33*bdd1*s*(r - 1) + 25*fdd*(3*r*s - r - s)) - 125*fd**2*(r*(6*s - 2) - 2*s + 1)) + 125*Ddd*f**2*(r*(2 - 4*s) + s)) - 125*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k1*k3**2) + D1**2*Pk3*Pkd1*ct**4*k2**2*(66*b1**2*(C - 1)*(D1**2*r**2*(12*fd + fdd) + 2*D1*Dd*(6*f*(4*r**2 - 2*r + 1) + fd*r*(4*r - 1)) + D1*Ddd*f*(4*r**2 - 2*r + 1) + 6*Dd**2*f*r*(2*r - 1)) + 33*b1*(-32*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r**2 - 20*C*D1**2*f*fdd*r + 10*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r**2 - 20*C*D1**2*fd**2*r - 64*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r - 16*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r**2 - 112*C*D1*Dd*f*fd*r + 20*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r**2 - 16*C*D1*Ddd*f**2*r + 8*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r**2 - 48*C*Dd**2*f**2*r + 2*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) + 36*D1**2*f*fd*r**2 - 112*D1**2*f*fd*r*s + 64*D1**2*f*fd*r - 4*D1**2*f*fd - 6*D1**2*f*fdd*r**2 + 116*D1**2*f*fdd*r*s - 38*D1**2*f*fdd*r - 10*D1**2*f*fdd - 6*D1**2*fd**2*r**2 + 116*D1**2*fd**2*r*s - 38*D1**2*fd**2*r + 72*D1*Dd*f**2*r**2 - 224*D1*Dd*f**2*r*s + 76*D1*Dd*f**2*r + 56*D1*Dd*f**2*s + 18*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 + 928*D1*Dd*f*fd*r*s - 372*D1*Dd*f*fd*r - 116*D1*Dd*f*fd*s + 38*D1*Dd*f*fd - 12*D1*Ddd*f**2*r**2 + 232*D1*Ddd*f**2*r*s - 110*D1*Ddd*f**2*r - 58*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + 4*D1*bd1*(C - 1)*(6*D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(2*r - 1) + Dd*f*(8*r**2 - 6*r + 1)) - 36*Dd**2*f**2*r**2 + 696*Dd**2*f**2*r*s - 330*Dd**2*f**2*r - 174*Dd**2*f**2*s + 116*Dd**2*f**2) + f*(132*D1**2*bd1**2*r*(C - 1)*(r - 1) + 33*D1**2*bdd1*f*(C*(8*r**2 + 4*r - 2) - 3*r**2 + 58*r*s - 14*r - 58*s + 7) - 5*D1**2*(f*(fd*(32*C*(3*r**2 - 2*r + 1) - 24*r**2 + 930*r*s - 294*r - 310*s - 8) + 5*fdd*(10*C*(3*r**2 - 2*r + 1) - 57*r**2 - 192*r*s + 102*r + 64*s - 19)) + 10*fd**2*(r**2*(30*C - 57) - 2*r*(10*C + 96*s - 51) + 64*s - 32)) - 66*D1*bd1*(D1*(f*(2*C*(4*r**2 - 10*r + 5) - 9*r**2 + 28*r*s + 22*r - 28*s - 11) + fd*(r**2*(6 - 16*C) + r*(6*C - 116*s + 33) + 58*s - 29)) + Dd*f*(C*(2 - 32*r**2) + 12*r**2 - 232*r*s + 83*r + 145*s - 65)) - 5*D1*f*(2*Dd*(f*(16*C*(4*r**2 - 2*r + 1) - 16*r**2 + 620*r*s - 302*r - 155*s - 4) + 5*fd*(10*C*(12*r**2 - 7*r + 1) - 228*r**2 - 768*r*s + 453*r + 224*s - 115)) + 5*Ddd*f*(10*C*(4*r**2 - 2*r + 1) - 76*r**2 - 256*r*s + 166*r + 64*s - 19)) - 50*Dd**2*f**2*(r**2*(60*C - 114) - 3*r*(10*C + 128*s - 83) + 96*s - 64)))/(693*d**2*k1*k3**2) + 4*D1**2*Pk3*Pkd1*ct**4*(D1*f*(6*D1*bd1**2*s*(1 - 2*r) + D1*bd1*(4*f*r*s + 5*fd*(-4*r*s + r + s)) - 5*D1*bdd1*f*r*s + 5*Dd*bd1*f*(r*(2 - 8*s) + s)) + b1**2*(D1*Dd*(5*f*(4*r*s - 2*r - s) - 6*fd*(8*r*s - 6*r - s + 1)) + D1*(D1*r*(5*fd - 6*fdd)*(s - 1) + 6*Ddd*f*(-4*r*s + 2*r + s)) - 6*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(D1*Dd*f*(8*f*r*(2*s - 1) - 4*f*s - 5*fd*(8*r - 3)*(2*s - 1)) + D1*bd1*(D1*(5*f*s*(2*r - 1) - 6*fd*(4*r*s - 2*r - s + 1)) - 12*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(6*bdd1*f*s*(1 - 2*r) + 4*f*fd*r*(2*s - 1) - 4*f*fd*s + 5*f*fdd*(-2*r*s + r + s) + 5*fd**2*(-2*r*s + r + s - 1)) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(21*d**2*k1) + D1**2*Pk3*Pkd1*ct**3*f*k2**5*st**4*(16*C - 16)*(33*D1**2*bd1*f*(r - 1)*(r + s - 1) + 5*D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + 33*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + 5*Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2))/(231*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**3*f*k2**3*st**4*(8*C - 8)*(D1*Dd*f*(-5*fd*(24*r*s - 10*r - 7*s + 3) + (33*b1 + 10*f)*(4*r*s - 2*r - s)) + D1*(D1*(f*(33*bd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1) + fd*(33*b1*r*(2*s - 1) + 10*f*(3*r*s - r - s))) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2))/(231*d**2*k3**4) + 10*D1**2*Pk3*Pkd1*ct**3*f*k2**5*st**2*(1014*D1**2*b1*f*fd*r**2 - 507*D1**2*b1*f*fdd*r**2 - 1014*D1**2*b1*fd**2*r**2 - 169*D1**2*bdd1*f**2*(r - 1)**2 - 280*D1**2*f**2*fd*r**2 + 140*D1**2*f**2*fd*r - 70*D1**2*f**2*fd + 140*D1**2*f**2*fdd*r**2 - 70*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd + 420*D1**2*f*fd**2*r**2 - 210*D1**2*f*fd**2*r + 1352*D1*Dd*b1*f**2*r**2 - 676*D1*Dd*b1*f**2*r + 338*D1*Dd*b1*f**2 - 4056*D1*Dd*b1*f*fd*r**2 + 1014*D1*Dd*b1*f*fd*r - 280*D1*Dd*f**3*r**2 + 140*D1*Dd*f**3*r - 70*D1*Dd*f**3 + 1120*D1*Dd*f**2*fd*r**2 - 560*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd - 676*D1*Ddd*b1*f**2*r**2 + 338*D1*Ddd*b1*f**2*r - 169*D1*Ddd*b1*f**2 + 140*D1*Ddd*f**3*r**2 - 70*D1*Ddd*f**3*r + 35*D1*Ddd*f**3 + 338*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 2028*Dd**2*b1*f**2*r**2 + 1014*Dd**2*b1*f**2*r + 420*Dd**2*f**3*r**2 - 210*Dd**2*f**3*r)/(9009*d**2*k1**2*k3**4) + D1**2*Pk3*Pkd1*ct**3*k1**4*k2*(80*C - 48)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**6) + D1**2*Pk3*Pkd1*ct**3*k1**4*(8*C - 4)*(33*D1*bd1*f*(D1*(4*f*s*(r - 1) - 5*fd*(4*r*s - r - 2*s + 1)) - 5*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 33*b1*(D1*Dd*f*(4*f*(-4*r*s + 2*r + s) + 5*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + 5*Ddd*f**2*(4*r*s - 2*r - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) - 5*f*(D1*Dd*f*(23*f*(-4*r*s + 2*r + s) + 28*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(23*f*fd*(-3*r*s + r + s) + f*(33*bdd1*s*(r - 1) + 28*fdd*(3*r*s - r - s)) + 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(4*s - 2) - s)) + 28*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k2*k3**4) + 8*D1**2*Pk3*Pkd1*ct**3*k1**2*k2**3*st**2*(4818*C*D1**2*b1*f*fd*r**2 + 4818*C*D1**2*b1*f*fd*r*s - 2409*C*D1**2*b1*f*fd*r - 3630*C*D1**2*b1*f*fdd*r**2 - 3630*C*D1**2*b1*f*fdd*r*s + 1815*C*D1**2*b1*f*fdd*r - 3630*C*D1**2*b1*fd**2*r**2 - 3630*C*D1**2*b1*fd**2*r*s + 1815*C*D1**2*b1*fd**2*r + 4587*C*D1**2*f**2*fd*r**2 + 4587*C*D1**2*f**2*fd*r*s - 4587*C*D1**2*f**2*fd*r - 1529*C*D1**2*f**2*fd*s + 1529*C*D1**2*f**2*fd - 4125*C*D1**2*f**2*fdd*r**2 - 4125*C*D1**2*f**2*fdd*r*s + 4125*C*D1**2*f**2*fdd*r + 1375*C*D1**2*f**2*fdd*s - 1375*C*D1**2*f**2*fdd - 8250*C*D1**2*f*fd**2*r**2 - 8250*C*D1**2*f*fd**2*r*s + 8250*C*D1**2*f*fd**2*r + 2750*C*D1**2*f*fd**2*s - 1375*C*D1**2*f*fd**2 + 9636*C*D1*Dd*b1*f**2*r**2 + 9636*C*D1*Dd*b1*f**2*r*s - 9636*C*D1*Dd*b1*f**2*r - 2409*C*D1*Dd*b1*f**2*s + 2409*C*D1*Dd*b1*f**2 - 29040*C*D1*Dd*b1*f*fd*r**2 - 29040*C*D1*Dd*b1*f*fd*r*s + 21780*C*D1*Dd*b1*f*fd*r + 3630*C*D1*Dd*b1*f*fd*s - 1815*C*D1*Dd*b1*f*fd + 6116*C*D1*Dd*f**3*r**2 + 6116*C*D1*Dd*f**3*r*s - 6116*C*D1*Dd*f**3*r - 1529*C*D1*Dd*f**3*s + 1529*C*D1*Dd*f**3 - 33000*C*D1*Dd*f**2*fd*r**2 - 33000*C*D1*Dd*f**2*fd*r*s + 33000*C*D1*Dd*f**2*fd*r + 9625*C*D1*Dd*f**2*fd*s - 6875*C*D1*Dd*f**2*fd - 7260*C*D1*Ddd*b1*f**2*r**2 - 7260*C*D1*Ddd*b1*f**2*r*s + 7260*C*D1*Ddd*b1*f**2*r + 1815*C*D1*Ddd*b1*f**2*s - 1815*C*D1*Ddd*b1*f**2 - 5500*C*D1*Ddd*f**3*r**2 - 5500*C*D1*Ddd*f**3*r*s + 5500*C*D1*Ddd*f**3*r + 1375*C*D1*Ddd*f**3*s - 1375*C*D1*Ddd*f**3 - 21780*C*Dd**2*b1*f**2*r**2 - 21780*C*Dd**2*b1*f**2*r*s + 21780*C*Dd**2*b1*f**2*r + 5445*C*Dd**2*b1*f**2*s - 3630*C*Dd**2*b1*f**2 - 16500*C*Dd**2*f**3*r**2 - 16500*C*Dd**2*f**3*r*s + 16500*C*Dd**2*f**3*r + 4125*C*Dd**2*f**3*s - 2750*C*Dd**2*f**3 - 3564*D1**2*b1*f*fd*r**2 - 3564*D1**2*b1*f*fd*r*s + 1782*D1**2*b1*f*fd*r + 2706*D1**2*b1*f*fdd*r**2 + 2706*D1**2*b1*f*fdd*r*s - 1353*D1**2*b1*f*fdd*r + 2706*D1**2*b1*fd**2*r**2 + 2706*D1**2*b1*fd**2*r*s - 1353*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(55*C - 41)*(r - 1)*(r + s - 1) - 3378*D1**2*f**2*fd*r**2 - 3378*D1**2*f**2*fd*r*s + 3378*D1**2*f**2*fd*r + 1126*D1**2*f**2*fd*s - 1126*D1**2*f**2*fd + 3075*D1**2*f**2*fdd*r**2 + 3075*D1**2*f**2*fdd*r*s - 3075*D1**2*f**2*fdd*r - 1025*D1**2*f**2*fdd*s + 1025*D1**2*f**2*fdd + 6150*D1**2*f*fd**2*r**2 + 6150*D1**2*f*fd**2*r*s - 6150*D1**2*f*fd**2*r - 2050*D1**2*f*fd**2*s + 1025*D1**2*f*fd**2 - 7128*D1*Dd*b1*f**2*r**2 - 7128*D1*Dd*b1*f**2*r*s + 7128*D1*Dd*b1*f**2*r + 1782*D1*Dd*b1*f**2*s - 1782*D1*Dd*b1*f**2 + 21648*D1*Dd*b1*f*fd*r**2 + 21648*D1*Dd*b1*f*fd*r*s - 16236*D1*Dd*b1*f*fd*r - 2706*D1*Dd*b1*f*fd*s + 1353*D1*Dd*b1*f*fd - 4504*D1*Dd*f**3*r**2 - 4504*D1*Dd*f**3*r*s + 4504*D1*Dd*f**3*r + 1126*D1*Dd*f**3*s - 1126*D1*Dd*f**3 + 24600*D1*Dd*f**2*fd*r**2 + 24600*D1*Dd*f**2*fd*r*s - 24600*D1*Dd*f**2*fd*r - 7175*D1*Dd*f**2*fd*s + 5125*D1*Dd*f**2*fd + 5412*D1*Ddd*b1*f**2*r**2 + 5412*D1*Ddd*b1*f**2*r*s - 5412*D1*Ddd*b1*f**2*r - 1353*D1*Ddd*b1*f**2*s + 1353*D1*Ddd*b1*f**2 + 4100*D1*Ddd*f**3*r**2 + 4100*D1*Ddd*f**3*r*s - 4100*D1*Ddd*f**3*r - 1025*D1*Ddd*f**3*s + 1025*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(73*C - 54)*(r - 1)*(r + s - 1) - fd*(55*C - 41)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(55*C - 41)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 16236*Dd**2*b1*f**2*r**2 + 16236*Dd**2*b1*f**2*r*s - 16236*Dd**2*b1*f**2*r - 4059*Dd**2*b1*f**2*s + 2706*Dd**2*b1*f**2 + 12300*Dd**2*f**3*r**2 + 12300*Dd**2*f**3*r*s - 12300*Dd**2*f**3*r - 3075*Dd**2*f**3*s + 2050*Dd**2*f**3)/(693*d**2*k3**6) - 16*D1**2*Pk3*Pkd1*ct**3*k1**2*k2**3*(-1287*D1**2*bd1**2*f*(2*r - 1)*(-10*K + 5*f + 6)*(r + s - 1) - 65*D1**2*bdd1*f*(r + s - 1)*(28*f**2*(r + 2) - 33*f*r*(5*K - 3) + 396*g2*(r - 1)) - 10*D1**2*(7*f**3*(38*fd - 45*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*f**2*(105*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + r*(572*gd2 - 715*gdd2)*(r + s - 1)) - 429*f*(fd*(g2*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 2145*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) + 13*D1*bd1*(D1*(115*f**3*(r + 2)*(r + s - 1) - 4*f**2*(35*fd*(6*r**2 + r*(6*s - 2) + 3*s - 1) + r*(165*K - 99)*(r + s - 1)) + 165*f*(fd*(5*K - 3)*(4*r**2 + 4*r*(s - 1) - s + 1) + (10*g2*(r - 1) + 12*gd2*(1 - 2*r))*(r + s - 1)) - 1980*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(28*f**2*(8*r**2 + 8*r*s + 7*s - 5) - 33*f*(5*K - 3)*(8*r**2 + 8*r*(s - 1) - s + 1) + 396*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 10*D1*f*(Dd*(266*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 630*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 429*f*(4*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 4290*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 15*Ddd*f*(21*f**2 - 143*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 150*Dd**2*f**2*(21*f**2 - 143*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 429*b1**2*(D1**2*r*(3*f*(4*fd - 5*fdd)*(2*r + 2*s - 1) - 15*fd**2*(2*r + 2*s - 1) - 5*fd*(5*K - 3)*(r + s) + 6*fdd*(5*K - 3)*(r + s)) + D1*(Dd*(12*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(48*r**2 + 12*r*(4*s - 3) - 6*s + 3) + (5*K - 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*fd*(5*K - 3)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-10*K + 5*f + 6)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-10*K + 5*f + 6)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-1320*D1**2*K*f*fd*r**2 - 1320*D1**2*K*f*fd*r*s + 1320*D1**2*K*f*fd*r + 660*D1**2*K*f*fd*s - 660*D1**2*K*f*fd + 1650*D1**2*K*f*fdd*r**2 + 1650*D1**2*K*f*fdd*r*s - 1650*D1**2*K*f*fdd*r - 825*D1**2*K*f*fdd*s + 825*D1**2*K*f*fdd + 1650*D1**2*K*fd**2*r**2 + 1650*D1**2*K*fd**2*r*s - 1650*D1**2*K*fd**2*r - 825*D1**2*K*fd**2*s - 99*D1**2*bdd1*f*(2*r - 1)*(-10*K + 5*f + 6)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 575*D1**2*f**2*fd*r - 345*D1**2*f**2*fd*s + 345*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 700*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s - 420*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 1400*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s - 420*D1**2*f*fd**2 + 792*D1**2*f*fd*r**2 + 792*D1**2*f*fd*r*s - 792*D1**2*f*fd*r - 396*D1**2*f*fd*s + 396*D1**2*f*fd - 990*D1**2*f*fdd*r**2 - 990*D1**2*f*fdd*r*s + 990*D1**2*f*fdd*r + 495*D1**2*f*fdd*s - 495*D1**2*f*fdd + 1650*D1**2*f*gd2*r**2 + 1650*D1**2*f*gd2*r*s - 1650*D1**2*f*gd2*r - 1980*D1**2*f*gdd2*r**2 - 1980*D1**2*f*gdd2*r*s + 1980*D1**2*f*gdd2*r - 990*D1**2*fd**2*r**2 - 990*D1**2*fd**2*r*s + 990*D1**2*fd**2*r + 495*D1**2*fd**2*s + 1650*D1**2*fd*g2*r**2 + 1650*D1**2*fd*g2*r*s - 3960*D1**2*fd*gd2*r**2 - 3960*D1**2*fd*gd2*r*s + 1980*D1**2*fd*gd2*r - 1980*D1**2*fdd*g2*r**2 - 1980*D1**2*fdd*g2*r*s - 2640*D1*Dd*K*f**2*r**2 - 2640*D1*Dd*K*f**2*r*s + 2640*D1*Dd*K*f**2*r + 660*D1*Dd*K*f**2*s - 660*D1*Dd*K*f**2 + 13200*D1*Dd*K*f*fd*r**2 + 13200*D1*Dd*K*f*fd*r*s - 13200*D1*Dd*K*f*fd*r - 4950*D1*Dd*K*f*fd*s + 3300*D1*Dd*K*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 4480*D1*Dd*f**2*fd*r + 2100*D1*Dd*f**2*fd*s - 1540*D1*Dd*f**2*fd + 1584*D1*Dd*f**2*r**2 + 1584*D1*Dd*f**2*r*s - 1584*D1*Dd*f**2*r - 396*D1*Dd*f**2*s + 396*D1*Dd*f**2 - 7920*D1*Dd*f*fd*r**2 - 7920*D1*Dd*f*fd*r*s + 7920*D1*Dd*f*fd*r + 2970*D1*Dd*f*fd*s - 1980*D1*Dd*f*fd + 6600*D1*Dd*f*g2*r**2 + 6600*D1*Dd*f*g2*r*s - 6600*D1*Dd*f*g2*r - 1650*D1*Dd*f*g2*s + 1650*D1*Dd*f*g2 - 15840*D1*Dd*f*gd2*r**2 - 15840*D1*Dd*f*gd2*r*s + 15840*D1*Dd*f*gd2*r + 1980*D1*Dd*f*gd2*s - 1980*D1*Dd*f*gd2 - 15840*D1*Dd*fd*g2*r**2 - 15840*D1*Dd*fd*g2*r*s + 7920*D1*Dd*fd*g2*r + 1980*D1*Dd*fd*g2*s + 3300*D1*Ddd*K*f**2*r**2 + 3300*D1*Ddd*K*f**2*r*s - 3300*D1*Ddd*K*f**2*r - 825*D1*Ddd*K*f**2*s + 825*D1*Ddd*K*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1980*D1*Ddd*f**2*r**2 - 1980*D1*Ddd*f**2*r*s + 1980*D1*Ddd*f**2*r + 495*D1*Ddd*f**2*s - 495*D1*Ddd*f**2 - 7920*D1*Ddd*f*g2*r**2 - 7920*D1*Ddd*f*g2*r*s + 7920*D1*Ddd*f*g2*r + 1980*D1*Ddd*f*g2*s - 1980*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(12*f**2*(2*r - 1)*(r + s - 1) - 5*f*(3*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + (5*K - 3)*(2*r - 1)*(r + s - 1)) + 6*fd*(5*K - 3)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-10*K + 5*f + 6)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 9900*Dd**2*K*f**2*r**2 + 9900*Dd**2*K*f**2*r*s - 9900*Dd**2*K*f**2*r - 2475*Dd**2*K*f**2*s + 1650*Dd**2*K*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3 - 5940*Dd**2*f**2*r**2 - 5940*Dd**2*f**2*r*s + 5940*Dd**2*f**2*r + 1485*Dd**2*f**2*s - 990*Dd**2*f**2 - 23760*Dd**2*f*g2*r**2 - 23760*Dd**2*f*g2*r*s + 23760*Dd**2*f*g2*r + 5940*Dd**2*f*g2*s - 3960*Dd**2*f*g2))/(9009*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*ct**3*k1**2*k2*st**2*(33*D1*bd1*f*(D1*(f*s*(55*C - 39)*(r - 1) - fd*(37*C - 26)*(r*(4*s - 1) - 2*s + 1)) - Dd*f*(37*C - 26)*(r*(8*s - 2) - 5*s + 2)) - 33*b1*(D1*Dd*f*(-f*(55*C - 39)*(r*(4*s - 2) - s) + fd*(37*C - 26)*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(55*C - 39) + f*fdd*(26 - 37*C) + fd**2*(26 - 37*C)) + Ddd*f**2*(37*C - 26)*(r*(4*s - 2) - s)) + Dd**2*f**2*(37*C - 26)*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(f*(1223*C - 871)*(r*(4*s - 2) - s) - fd*(925*C - 650)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(f*fd*(1223*C - 871)*(r*(3*s - 1) - s) - f*(37*C - 26)*(33*bdd1*s*(r - 1) + 25*fdd*(r*(3*s - 1) - s)) - fd**2*(925*C - 650)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(650 - 925*C)*(r*(4*s - 2) - s)) + Dd**2*f**2*(650 - 925*C)*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**3*k1**2*k2*(264*b1**2*(3*C - 2)*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1*(-320*C*D1**2*f*fd*r**2 - 1056*C*D1**2*f*fd*r*s + 336*C*D1**2*f*fd*r - 96*C*D1**2*f*fd*s + 96*C*D1**2*f*fd + 544*C*D1**2*f*fdd*r**2 + 1104*C*D1**2*f*fdd*r*s - 312*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s - 120*C*D1**2*f*fdd + 544*C*D1**2*fd**2*r**2 + 1104*C*D1**2*fd**2*r*s - 312*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 - 640*C*D1*Dd*f**2*r**2 - 2112*C*D1*Dd*f**2*r*s + 1376*C*D1*Dd*f**2*r + 528*C*D1*Dd*f**2*s - 160*C*D1*Dd*f**2 + 4352*C*D1*Dd*f*fd*r**2 + 8832*C*D1*Dd*f*fd*r*s - 4544*C*D1*Dd*f*fd*r - 624*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 1088*C*D1*Ddd*f**2*r**2 + 2208*C*D1*Ddd*f**2*r*s - 1648*C*D1*Ddd*f**2*r - 552*C*D1*Ddd*f**2*s + 272*C*D1*Ddd*f**2 + 3264*C*Dd**2*f**2*r**2 + 6624*C*Dd**2*f**2*r*s - 4944*C*Dd**2*f**2*r - 1656*C*Dd**2*f**2*s + 1104*C*Dd**2*f**2 - 48*D1**2*bdd1*f*(3*C - 2)*(2*r**2 + 2*r*(s - 1) - s + 1) + 204*D1**2*f*fd*r**2 + 784*D1**2*f*fd*r*s - 264*D1**2*f*fd*r + 64*D1**2*f*fd*s - 64*D1**2*f*fd - 342*D1**2*f*fdd*r**2 - 824*D1**2*f*fdd*r*s + 252*D1**2*f*fdd*r - 80*D1**2*f*fdd*s + 80*D1**2*f*fdd - 342*D1**2*fd**2*r**2 - 824*D1**2*fd**2*r*s + 252*D1**2*fd**2*r - 80*D1**2*fd**2*s + 80*D1**2*fd**2 + 408*D1*Dd*f**2*r**2 + 1568*D1*Dd*f**2*r*s - 988*D1*Dd*f**2*r - 392*D1*Dd*f**2*s + 102*D1*Dd*f**2 - 2736*D1*Dd*f*fd*r**2 - 6592*D1*Dd*f*fd*r*s + 3340*D1*Dd*f*fd*r + 504*D1*Dd*f*fd*s - 92*D1*Dd*f*fd - 684*D1*Ddd*f**2*r**2 - 1648*D1*Ddd*f**2*r*s + 1166*D1*Ddd*f**2*r + 412*D1*Ddd*f**2*s - 171*D1*Ddd*f**2 + 8*D1*bd1*(3*C - 2)*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 2052*Dd**2*f**2*r**2 - 4944*Dd**2*f**2*r*s + 3498*Dd**2*f**2*r + 1236*Dd**2*f**2*s - 824*Dd**2*f**2) + f*(-1584*D1**2*bd1**2*(3*C - 2)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(8*C*(34*r**2 + 69*r*s - 98*r - 84*s + 49) - 171*r**2 - 412*r*s + 502*r + 492*s - 251) - 5*D1**2*(f*(2*fd*(4*C*(663*r**2 + 1305*r*s - 877*r - 435*s + 221) - 1707*r**2 - 3816*r*s + 2410*r + 1272*s - 569) + fdd*(-8*C*(876*r**2 + 1395*r*s - 1049*r - 465*s + 292) + 4479*r**2 + 8172*r*s - 5710*r - 2724*s + 1493)) - 2*fd**2*(4*C*(1752*r**2 + 2790*r*s - 2098*r - 930*s + 465) - 4479*r**2 - 8172*r*s + 5710*r + 2724*s - 1362)) - 66*D1*bd1*(D1*(f*(8*C*(10*r**2 + 33*r*s - 32*r - 39*s + 16) - 51*r**2 - 196*r*s + 166*r + 228*s - 83) + 2*fd*(-2*C*(136*r**2 + 276*r*s - 235*r - 153*s + 84) + 171*r**2 + 412*r*s - 314*r - 226*s + 123)) + Dd*f*(-4*C*(272*r**2 + 552*r*s - 598*r - 405*s + 266) + 684*r**2 + 1648*r*s - 1587*r - 1190*s + 743)) - 5*D1*f*(2*Dd*(f*(4*C*(884*r**2 + 4*r*(435*s - 328) - 435*s + 221) - 2276*r**2 - 5088*r*s + 3682*r + 1272*s - 569) + fd*(-4*C*(7008*r**2 + 11160*r*s - 8738*r - 3255*s + 1979) + 17916*r**2 + 32688*r*s - 24071*r - 9534*s + 5579)) + Ddd*f*(-8*C*(1168*r**2 + 2*r*(930*s - 757) - 465*s + 292) + 5972*r**2 + 10896*r*s - 8434*r - 2724*s + 1493)) + 30*Dd**2*f**2*(4*C*(1168*r**2 + 2*r*(930*s - 757) - 465*s + 310) - 2986*r**2 - 5448*r*s + 4217*r + 1362*s - 908)))/(693*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**3*k1**2*(8*C - 4)*(33*D1*b1*(D1*bd1*(5*f*s*(2*r - 1) - 6*fd*(r*(4*s - 2) - s + 1)) - 4*D1*f*fd*s + D1*f*s*(bdd1*(6 - 12*r) + 5*fdd) + 5*D1*fd**2*(s - 1) - 12*Dd*bd1*f*(r*(8*s - 2) - 3*s + 1) + 10*Dd*f*fd*(2*s - 1)) - 33*b1**2*(D1*Dd*(5*f*(-4*r*s + 2*r + s) + 6*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(5*fd - 6*fdd)*(s - 1) + 6*Ddd*f*(4*r*s - 2*r - s)) + 6*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + f*(-198*D1**2*bd1**2*s*(2*r - 1) - 5*D1*Dd*f*(23*f*(4*r*s - 2*r - s) - 28*fd*(24*r*s - 10*r - 7*s + 3)) + 33*D1*bd1*(4*D1*f*s - 5*D1*fd*(s - 1) + 10*Dd*f*(1 - 2*s)) - 5*D1*(D1*(23*f*fd*(r*(3*s - 1) - s) + f*(33*bdd1*s + 28*fdd*(-3*r*s + r + s)) - 28*fd**2*(r*(6*s - 2) - 2*s + 1)) + 28*Ddd*f**2*(r*(2 - 4*s) + s)) + 140*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k2*k3**2) - 4*D1**2*Pk3*Pkd1*ct**3*k2**5*st**2*(1287*D1**2*K*bdd1*f**2*r**2 + 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*r - 429*D1**2*bd1**2*f*(2*r - 1)*(-3*K + 10*f + 3)*(r + s - 1) + 9750*D1**2*bdd1*f**3*r**2 + 9750*D1**2*bdd1*f**3*r*s - 22750*D1**2*bdd1*f**3*r - 13000*D1**2*bdd1*f**3*s + 13000*D1**2*bdd1*f**3 - 1287*D1**2*bdd1*f**2*r**2 - 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*r - 2574*D1**2*bdd1*f*g2*r**2 - 2574*D1**2*bdd1*f*g2*r*s + 5148*D1**2*bdd1*f*g2*r + 2574*D1**2*bdd1*f*g2*s - 2574*D1**2*bdd1*f*g2 - 42000*D1**2*f**3*fd*r**2 - 42000*D1**2*f**3*fd*r*s + 42000*D1**2*f**3*fd*r + 10500*D1**2*f**3*fd*s - 10500*D1**2*f**3*fd + 39200*D1**2*f**3*fdd*r**2 + 39200*D1**2*f**3*fdd*r*s - 39200*D1**2*f**3*fdd*r - 9800*D1**2*f**3*fdd*s + 9800*D1**2*f**3*fdd + 117600*D1**2*f**2*fd**2*r**2 + 117600*D1**2*f**2*fd**2*r*s - 117600*D1**2*f**2*fd**2*r - 29400*D1**2*f**2*fd**2*s + 19600*D1**2*f**2*fd**2 + 4290*D1**2*f**2*gd2*r**2 + 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*r - 2574*D1**2*f**2*gdd2*r**2 - 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*r + 8580*D1**2*f*fd*g2*r**2 + 8580*D1**2*f*fd*g2*r*s - 8580*D1**2*f*fd*g2*r - 4290*D1**2*f*fd*g2*s + 4290*D1**2*f*fd*g2 - 10296*D1**2*f*fd*gd2*r**2 - 10296*D1**2*f*fd*gd2*r*s + 10296*D1**2*f*fd*gd2*r + 2574*D1**2*f*fd*gd2*s - 2574*D1**2*f*fd*gd2 - 5148*D1**2*f*fdd*g2*r**2 - 5148*D1**2*f*fdd*g2*r*s + 5148*D1**2*f*fdd*g2*r + 2574*D1**2*f*fdd*g2*s - 2574*D1**2*f*fdd*g2 - 5148*D1**2*fd**2*g2*r**2 - 5148*D1**2*fd**2*g2*r*s + 5148*D1**2*fd**2*g2*r + 2574*D1**2*fd**2*g2*s - 42000*D1*Dd*f**4*r**2 - 42000*D1*Dd*f**4*r*s + 42000*D1*Dd*f**4*r + 10500*D1*Dd*f**4*s - 10500*D1*Dd*f**4 + 313600*D1*Dd*f**3*fd*r**2 + 313600*D1*Dd*f**3*fd*r*s - 313600*D1*Dd*f**3*fd*r - 78400*D1*Dd*f**3*fd*s + 58800*D1*Dd*f**3*fd + 17160*D1*Dd*f**2*g2*r**2 + 17160*D1*Dd*f**2*g2*r*s - 17160*D1*Dd*f**2*g2*r - 4290*D1*Dd*f**2*g2*s + 4290*D1*Dd*f**2*g2 - 20592*D1*Dd*f**2*gd2*r**2 - 20592*D1*Dd*f**2*gd2*r*s + 20592*D1*Dd*f**2*gd2*r + 2574*D1*Dd*f**2*gd2*s - 2574*D1*Dd*f**2*gd2 - 41184*D1*Dd*f*fd*g2*r**2 - 41184*D1*Dd*f*fd*g2*r*s + 41184*D1*Dd*f*fd*g2*r + 15444*D1*Dd*f*fd*g2*s - 10296*D1*Dd*f*fd*g2 + 39200*D1*Ddd*f**4*r**2 + 39200*D1*Ddd*f**4*r*s - 39200*D1*Ddd*f**4*r - 9800*D1*Ddd*f**4*s + 9800*D1*Ddd*f**4 - 10296*D1*Ddd*f**2*g2*r**2 - 10296*D1*Ddd*f**2*g2*r*s + 10296*D1*Ddd*f**2*g2*r + 2574*D1*Ddd*f**2*g2*s - 2574*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(2*f**3*(387*r - 538)*(r + s - 1) - 5*f**2*(50*fd*(18*r**2 + 2*r*(9*s - 13) - 11*s + 7) + r*(33 - 33*K)*(r + s - 1)) - 33*f*(3*fd*(K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (26*g2*(r - 1) + 2*gd2*(3 - 6*r))*(r + s - 1)) + 198*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-250*f**2*(24*r**2 + 8*r*(3*s - 5) - 19*s + 15) - 99*f*(K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 198*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 117600*Dd**2*f**4*r**2 + 117600*Dd**2*f**4*r*s - 117600*Dd**2*f**4*r - 29400*Dd**2*f**4*s + 19600*Dd**2*f**4 - 30888*Dd**2*f**2*g2*r**2 - 30888*Dd**2*f**2*g2*r*s + 30888*Dd**2*f**2*g2*r + 7722*Dd**2*f**2*g2*s - 5148*Dd**2*f**2*g2 + 429*b1**2*(D1**2*r*(2*f*(7*fd - 5*fdd)*(2*r + 2*s - 1) - 10*fd**2*(2*r + 2*s - 1) - 13*fd*(K - 1)*(r + s) + 3*fdd*(K - 1)*(r + s)) + D1*(Dd*(14*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-10*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (13 - 13*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*fd*(K - 1)*(8*r**2 + r*(8*s - 4) - s)) - Ddd*f*(-3*K + 10*f + 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(-3*K + 10*f + 3)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-330*D1**2*K*f*fd*r**2 - 330*D1**2*K*f*fd*r*s + 330*D1**2*K*f*fd*r + 165*D1**2*K*f*fd*s - 165*D1**2*K*f*fd + 198*D1**2*K*f*fdd*r**2 + 198*D1**2*K*f*fdd*r*s - 198*D1**2*K*f*fdd*r - 99*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 198*D1**2*K*fd**2*r**2 + 198*D1**2*K*fd**2*r*s - 198*D1**2*K*fd**2*r - 99*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(2*r - 1)*(-3*K + 10*f + 3)*(r + s - 1) - 2322*D1**2*f**2*fd*r**2 - 2322*D1**2*f**2*fd*r*s + 1246*D1**2*f**2*fd*r - 302*D1**2*f**2*fd*s + 302*D1**2*f**2*fd + 2250*D1**2*f**2*fdd*r**2 + 2250*D1**2*f**2*fdd*r*s - 1250*D1**2*f**2*fdd*r + 250*D1**2*f**2*fdd*s - 250*D1**2*f**2*fdd + 4500*D1**2*f*fd**2*r**2 + 4500*D1**2*f*fd**2*r*s - 2500*D1**2*f*fd**2*r + 500*D1**2*f*fd**2*s - 250*D1**2*f*fd**2 + 330*D1**2*f*fd*r**2 + 330*D1**2*f*fd*r*s - 330*D1**2*f*fd*r - 165*D1**2*f*fd*s + 165*D1**2*f*fd - 198*D1**2*f*fdd*r**2 - 198*D1**2*f*fdd*r*s + 198*D1**2*f*fdd*r + 99*D1**2*f*fdd*s - 99*D1**2*f*fdd + 858*D1**2*f*gd2*r**2 + 858*D1**2*f*gd2*r*s - 858*D1**2*f*gd2*r - 198*D1**2*f*gdd2*r**2 - 198*D1**2*f*gdd2*r*s + 198*D1**2*f*gdd2*r - 198*D1**2*fd**2*r**2 - 198*D1**2*fd**2*r*s + 198*D1**2*fd**2*r + 99*D1**2*fd**2*s + 858*D1**2*fd*g2*r**2 + 858*D1**2*fd*g2*r*s - 396*D1**2*fd*gd2*r**2 - 396*D1**2*fd*gd2*r*s + 198*D1**2*fd*gd2*r - 198*D1**2*fdd*g2*r**2 - 198*D1**2*fdd*g2*r*s - 660*D1*Dd*K*f**2*r**2 - 660*D1*Dd*K*f**2*r*s + 660*D1*Dd*K*f**2*r + 165*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 1584*D1*Dd*K*f*fd*r**2 + 1584*D1*Dd*K*f*fd*r*s - 1584*D1*Dd*K*f*fd*r - 594*D1*Dd*K*f*fd*s + 396*D1*Dd*K*f*fd - 3096*D1*Dd*f**3*r**2 - 3096*D1*Dd*f**3*r*s + 3096*D1*Dd*f**3*r + 774*D1*Dd*f**3*s - 774*D1*Dd*f**3 + 18000*D1*Dd*f**2*fd*r**2 + 18000*D1*Dd*f**2*fd*r*s - 14000*D1*Dd*f**2*fd*r - 1250*D1*Dd*f**2*fd*s + 750*D1*Dd*f**2*fd + 660*D1*Dd*f**2*r**2 + 660*D1*Dd*f**2*r*s - 660*D1*Dd*f**2*r - 165*D1*Dd*f**2*s + 165*D1*Dd*f**2 - 1584*D1*Dd*f*fd*r**2 - 1584*D1*Dd*f*fd*r*s + 1584*D1*Dd*f*fd*r + 594*D1*Dd*f*fd*s - 396*D1*Dd*f*fd + 3432*D1*Dd*f*g2*r**2 + 3432*D1*Dd*f*g2*r*s - 3432*D1*Dd*f*g2*r - 858*D1*Dd*f*g2*s + 858*D1*Dd*f*g2 - 1584*D1*Dd*f*gd2*r**2 - 1584*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r + 198*D1*Dd*f*gd2*s - 198*D1*Dd*f*gd2 - 1584*D1*Dd*fd*g2*r**2 - 1584*D1*Dd*fd*g2*r*s + 792*D1*Dd*fd*g2*r + 198*D1*Dd*fd*g2*s + 396*D1*Ddd*K*f**2*r**2 + 396*D1*Ddd*K*f**2*r*s - 396*D1*Ddd*K*f**2*r - 99*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 + 3000*D1*Ddd*f**3*r**2 + 3000*D1*Ddd*f**3*r*s - 3000*D1*Ddd*f**3*r - 750*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 - 396*D1*Ddd*f**2*r**2 - 396*D1*Ddd*f**2*r*s + 396*D1*Ddd*f**2*r + 99*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 - 792*D1*Ddd*f*g2*r**2 - 792*D1*Ddd*f*g2*r*s + 792*D1*Ddd*f*g2*r + 198*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(14*f**2*(2*r - 1)*(r + s - 1) + f*(-10*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (13*K - 13)*(2*r - 1)*(r + s - 1)) + 3*fd*(K - 1)*(4*r**2 + r*(4*s - 3) - s)) - Dd*f*(-3*K + 10*f + 3)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1188*Dd**2*K*f**2*r**2 + 1188*Dd**2*K*f**2*r*s - 1188*Dd**2*K*f**2*r - 297*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 + 9000*Dd**2*f**3*r**2 + 9000*Dd**2*f**3*r*s - 9000*Dd**2*f**3*r - 2250*Dd**2*f**3*s + 1500*Dd**2*f**3 - 1188*Dd**2*f**2*r**2 - 1188*Dd**2*f**2*r*s + 1188*Dd**2*f**2*r + 297*Dd**2*f**2*s - 198*Dd**2*f**2 - 2376*Dd**2*f*g2*r**2 - 2376*Dd**2*f*g2*r*s + 2376*Dd**2*f*g2*r + 594*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(9009*d**2*k3**6) + 2*D1**2*Pk3*Pkd1*ct**3*k2**3*st**2*(66*b1**2*(C - 1)*(D1**2*r*(13*fd - 3*fdd)*(r + s - 1) + D1*(Dd*(13*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1*(-116*C*D1**2*f*fd*r**2 - 84*C*D1**2*f*fd*r*s + 22*C*D1**2*f*fd*r - 10*C*D1**2*f*fd*s + 10*C*D1**2*f*fd + 104*C*D1**2*f*fdd*r**2 + 76*C*D1**2*f*fdd*r*s - 26*C*D1**2*f*fdd*r + 6*C*D1**2*f*fdd*s - 6*C*D1**2*f*fdd + 104*C*D1**2*fd**2*r**2 + 76*C*D1**2*fd**2*r*s - 26*C*D1**2*fd**2*r + 6*C*D1**2*fd**2*s - 6*C*D1**2*fd**2 - 232*C*D1*Dd*f**2*r**2 - 168*C*D1*Dd*f**2*r*s + 200*C*D1*Dd*f**2*r + 42*C*D1*Dd*f**2*s - 58*C*D1*Dd*f**2 + 832*C*D1*Dd*f*fd*r**2 + 608*C*D1*Dd*f*fd*r*s - 464*C*D1*Dd*f*fd*r - 52*C*D1*Dd*f*fd*s + 14*C*D1*Dd*f*fd + 208*C*D1*Ddd*f**2*r**2 + 152*C*D1*Ddd*f**2*r*s - 180*C*D1*Ddd*f**2*r - 38*C*D1*Ddd*f**2*s + 52*C*D1*Ddd*f**2 + 624*C*Dd**2*f**2*r**2 + 456*C*Dd**2*f**2*r*s - 540*C*Dd**2*f**2*r - 114*C*Dd**2*f**2*s + 76*C*Dd**2*f**2 - 6*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 128*D1**2*f*fd*r**2 + 104*D1**2*f*fd*r*s - 32*D1**2*f*fd*r + 10*D1**2*f*fd*s - 10*D1**2*f*fd - 110*D1**2*f*fdd*r**2 - 92*D1**2*f*fdd*r*s + 34*D1**2*f*fdd*r - 6*D1**2*f*fdd*s + 6*D1**2*f*fdd - 110*D1**2*fd**2*r**2 - 92*D1**2*fd**2*r*s + 34*D1**2*fd**2*r - 6*D1**2*fd**2*s + 6*D1**2*fd**2 + 256*D1*Dd*f**2*r**2 + 208*D1*Dd*f**2*r*s - 232*D1*Dd*f**2*r - 52*D1*Dd*f**2*s + 64*D1*Dd*f**2 - 880*D1*Dd*f*fd*r**2 - 736*D1*Dd*f*fd*r*s + 540*D1*Dd*f*fd*r + 68*D1*Dd*f*fd*s - 22*D1*Dd*f*fd - 220*D1*Ddd*f**2*r**2 - 184*D1*Ddd*f**2*r*s + 202*D1*Ddd*f**2*r + 46*D1*Ddd*f**2*s - 55*D1*Ddd*f**2 + 2*D1*bd1*(C - 1)*(D1*(13*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 660*Dd**2*f**2*r**2 - 552*Dd**2*f**2*r*s + 606*Dd**2*f**2*r + 138*Dd**2*f**2*s - 92*Dd**2*f**2) + f*(-6396*C*D1**2*f*fd*r**2 - 3612*C*D1**2*f*fd*r*s + 5468*C*D1**2*f*fd*r + 1204*C*D1**2*f*fd*s - 2132*C*D1**2*f*fd + 5574*C*D1**2*f*fdd*r**2 + 3588*C*D1**2*f*fdd*r*s - 4912*C*D1**2*f*fdd*r - 1196*C*D1**2*f*fdd*s + 1858*C*D1**2*f*fdd + 11148*C*D1**2*fd**2*r**2 + 7176*C*D1**2*fd**2*r*s - 9824*C*D1**2*fd**2*r - 2392*C*D1**2*fd**2*s + 1196*C*D1**2*fd**2 - 8528*C*D1*Dd*f**2*r**2 - 4816*C*D1*Dd*f**2*r*s + 6672*C*D1*Dd*f**2*r + 1204*C*D1*Dd*f**2*s - 2132*C*D1*Dd*f**2 + 44592*C*D1*Dd*f*fd*r**2 + 28704*C*D1*Dd*f*fd*r*s - 37972*C*D1*Dd*f*fd*r - 8372*C*D1*Dd*f*fd*s + 7304*C*D1*Dd*f*fd + 7432*C*D1*Ddd*f**2*r**2 + 4784*C*D1*Ddd*f**2*r*s - 6108*C*D1*Ddd*f**2*r - 1196*C*D1*Ddd*f**2*s + 1858*C*D1*Ddd*f**2 + 22296*C*Dd**2*f**2*r**2 + 14352*C*Dd**2*f**2*r*s - 18324*C*Dd**2*f**2*r - 3588*C*Dd**2*f**2*s + 2392*C*Dd**2*f**2 - 198*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(2*C*(26*r**2 + r*(19*s - 58) - 22*s + 29) - 55*r**2 + r*(122 - 46*s) + 52*s - 61) + 6486*D1**2*f*fd*r**2 + 4218*D1**2*f*fd*r*s - 5730*D1**2*f*fd*r - 1406*D1**2*f*fd*s + 2162*D1**2*f*fd - 5619*D1**2*f*fdd*r**2 - 4188*D1**2*f*fdd*r*s + 5142*D1**2*f*fdd*r + 1396*D1**2*f*fdd*s - 1873*D1**2*f*fdd - 11238*D1**2*fd**2*r**2 - 8376*D1**2*fd**2*r*s + 10284*D1**2*fd**2*r + 2792*D1**2*fd**2*s - 1396*D1**2*fd**2 + 8648*D1*Dd*f**2*r**2 + 5624*D1*Dd*f**2*r*s - 7136*D1*Dd*f**2*r - 1406*D1*Dd*f**2*s + 2162*D1*Dd*f**2 - 44952*D1*Dd*f*fd*r**2 - 33504*D1*Dd*f*fd*r*s + 40182*D1*Dd*f*fd*r + 9772*D1*Dd*f*fd*s - 7934*D1*Dd*f*fd - 7492*D1*Ddd*f**2*r**2 - 5584*D1*Ddd*f**2*r*s + 6538*D1*Ddd*f**2*r + 1396*D1*Ddd*f**2*s - 1873*D1*Ddd*f**2 - 66*D1*bd1*(D1*(f*(C*(29*r**2 + 21*r*s - 68*r - 26*s + 34) - 32*r**2 - 26*r*s + 74*r + 31*s - 37) + fd*(C*(-104*r**2 - 76*r*s + 129*r + 41*s - 22) + 110*r**2 + 92*r*s - 139*r - 49*s + 26)) + Dd*f*(C*(-208*r**2 + r*(322 - 152*s) + 107*s - 102) + 220*r**2 + 23*r*(8*s - 15) - 127*s + 113)) - 22476*Dd**2*f**2*r**2 - 16752*Dd**2*f**2*r*s + 19614*Dd**2*f**2*r + 4188*Dd**2*f**2*s - 2792*Dd**2*f**2))/(693*d**2*k3**4) - D1**2*Pk3*Pkd1*ct**3*k2**3*(-48048*D1**2*K*bd1**2*f*r**2 - 44616*D1**2*K*bd1**2*f*r*s + 90948*D1**2*K*bd1**2*f*r + 32604*D1**2*K*bd1**2*f*s - 32604*D1**2*K*bd1**2*f + 20592*D1**2*K*bd1*f**2*r**2 + 24024*D1**2*K*bd1*f**2*r*s - 24024*D1**2*K*bd1*f**2*r - 144144*D1**2*K*bd1*f*fd*r**2 - 109824*D1**2*K*bd1*f*fd*r*s + 126984*D1**2*K*bd1*f*fd*r + 27456*D1**2*K*bd1*f*fd*s - 27456*D1**2*K*bd1*f*fd - 36036*D1**2*K*bdd1*f**2*r**2 - 27456*D1**2*K*bdd1*f**2*r*s + 27456*D1**2*K*bdd1*f**2*r + 102102*D1**2*bd1**2*f**2*r**2 + 109824*D1**2*bd1**2*f**2*r*s - 157014*D1**2*bd1**2*f**2*r - 63492*D1**2*bd1**2*f**2*s + 46332*D1**2*bd1**2*f**2 + 78078*D1**2*bd1**2*f*r**2 + 85800*D1**2*bd1**2*f*r*s - 141570*D1**2*bd1**2*f*r - 53196*D1**2*bd1**2*f*s + 53196*D1**2*bd1**2*f - 48048*D1**2*bd1**2*g2*r**2 - 48048*D1**2*bd1**2*g2*r*s + 48048*D1**2*bd1**2*g2*r + 24024*D1**2*bd1**2*g2*s - 20592*D1**2*bd1*bd2*f*r**2 - 20592*D1**2*bd1*bd2*f*r*s + 30888*D1**2*bd1*bd2*f*r + 10296*D1**2*bd1*bd2*f*s - 10296*D1**2*bd1*bd2*f - 29900*D1**2*bd1*f**3*r**2 + 4420*D1**2*bd1*f**3*r*s + 15600*D1**2*bd1*f**3*r - 51480*D1**2*bd1*f**3*s + 9750*D1**2*bd1*f**3 + 218400*D1**2*bd1*f**2*fd*r**2 + 12480*D1**2*bd1*f**2*fd*r*s - 83980*D1**2*bd1*f**2*fd*r + 100880*D1**2*bd1*f**2*fd*s - 63960*D1**2*bd1*f**2*fd - 31746*D1**2*bd1*f**2*r**2 - 37752*D1**2*bd1*f**2*r*s + 37752*D1**2*bd1*f**2*r + 187044*D1**2*bd1*f*fd*r**2 + 178464*D1**2*bd1*f*fd*r*s - 182754*D1**2*bd1*f*fd*r - 44616*D1**2*bd1*f*fd*s + 44616*D1**2*bd1*f*fd - 41184*D1**2*bd1*f*g2*r*s + 34320*D1**2*bd1*f*g2*r + 58344*D1**2*bd1*f*g2*s - 17160*D1**2*bd1*f*g2 + 96096*D1**2*bd1*f*gd2*r**2 + 89232*D1**2*bd1*f*gd2*r*s - 181896*D1**2*bd1*f*gd2*r - 65208*D1**2*bd1*f*gd2*s + 65208*D1**2*bd1*f*gd2 + 96096*D1**2*bd1*fd*g2*r**2 + 89232*D1**2*bd1*fd*g2*r*s - 96096*D1**2*bd1*fd*g2*r - 44616*D1**2*bd1*fd*g2*s + 6864*D1**2*bd2*f**2*r**2 + 6864*D1**2*bd2*f**2*r*s - 6864*D1**2*bd2*f**2*r - 34320*D1**2*bd2*f*fd*r**2 - 34320*D1**2*bd2*f*fd*r*s + 34320*D1**2*bd2*f*fd*r + 8580*D1**2*bd2*f*fd*s - 8580*D1**2*bd2*f*fd + 36400*D1**2*bdd1*f**3*r**2 + 2080*D1**2*bdd1*f**3*r*s - 3510*D1**2*bdd1*f**3*r + 51480*D1**2*bdd1*f**3*s - 17745*D1**2*bdd1*f**3 + 46761*D1**2*bdd1*f**2*r**2 + 44616*D1**2*bdd1*f**2*r*s - 44616*D1**2*bdd1*f**2*r + 48048*D1**2*bdd1*f*g2*r**2 + 44616*D1**2*bdd1*f*g2*r*s - 137280*D1**2*bdd1*f*g2*r - 65208*D1**2*bdd1*f*g2*s + 68640*D1**2*bdd1*f*g2 - 8580*D1**2*bdd2*f**2*r**2 - 8580*D1**2*bdd2*f**2*r*s + 8580*D1**2*bdd2*f**2*r + 52920*D1**2*f**3*fd*r**2 + 174720*D1**2*f**3*fd*r*s - 113820*D1**2*f**3*fd*r - 43680*D1**2*f**3*fd*s + 13230*D1**2*f**3*fd - 70140*D1**2*f**3*fdd*r**2 - 174720*D1**2*f**3*fdd*r*s + 122430*D1**2*f**3*fdd*r + 43680*D1**2*f**3*fdd*s - 17535*D1**2*f**3*fdd - 210420*D1**2*f**2*fd**2*r**2 - 524160*D1**2*f**2*fd**2*r*s + 367290*D1**2*f**2*fd**2*r + 131040*D1**2*f**2*fd**2*s - 87360*D1**2*f**2*fd**2 - 41184*D1**2*f**2*gd2*r**2 - 48048*D1**2*f**2*gd2*r*s + 48048*D1**2*f**2*gd2*r + 72072*D1**2*f**2*gdd2*r**2 + 54912*D1**2*f**2*gdd2*r*s - 54912*D1**2*f**2*gdd2*r - 82368*D1**2*f*fd*g2*r**2 - 96096*D1**2*f*fd*g2*r*s + 82368*D1**2*f*fd*g2*r + 48048*D1**2*f*fd*g2*s - 41184*D1**2*f*fd*g2 + 288288*D1**2*f*fd*gd2*r**2 + 219648*D1**2*f*fd*gd2*r*s - 253968*D1**2*f*fd*gd2*r - 54912*D1**2*f*fd*gd2*s + 54912*D1**2*f*fd*gd2 + 144144*D1**2*f*fdd*g2*r**2 + 109824*D1**2*f*fdd*g2*r*s - 144144*D1**2*f*fdd*g2*r - 54912*D1**2*f*fdd*g2*s + 72072*D1**2*f*fdd*g2 + 144144*D1**2*fd**2*g2*r**2 + 109824*D1**2*fd**2*g2*r*s - 144144*D1**2*fd**2*g2*r - 54912*D1**2*fd**2*g2*s - 288288*D1*Dd*K*bd1*f**2*r**2 - 219648*D1*Dd*K*bd1*f**2*r*s + 236808*D1*Dd*K*bd1*f**2*r + 27456*D1*Dd*K*bd1*f**2*s - 27456*D1*Dd*K*bd1*f**2 + 291200*D1*Dd*bd1*f**3*r**2 + 16640*D1*Dd*bd1*f**3*r*s - 91000*D1*Dd*bd1*f**3*r + 203840*D1*Dd*bd1*f**3*s - 99450*D1*Dd*bd1*f**3 + 374088*D1*Dd*bd1*f**2*r**2 + 356928*D1*Dd*bd1*f**2*r*s - 361218*D1*Dd*bd1*f**2*r - 44616*D1*Dd*bd1*f**2*s + 44616*D1*Dd*bd1*f**2 + 384384*D1*Dd*bd1*f*g2*r**2 + 356928*D1*Dd*bd1*f*g2*r*s - 734448*D1*Dd*bd1*f*g2*r - 305448*D1*Dd*bd1*f*g2*s + 267696*D1*Dd*bd1*f*g2 - 68640*D1*Dd*bd2*f**2*r**2 - 68640*D1*Dd*bd2*f**2*r*s + 68640*D1*Dd*bd2*f**2*r + 8580*D1*Dd*bd2*f**2*s - 8580*D1*Dd*bd2*f**2 + 52920*D1*Dd*f**4*r**2 + 174720*D1*Dd*f**4*r*s - 113820*D1*Dd*f**4*r - 43680*D1*Dd*f**4*s + 13230*D1*Dd*f**4 - 561120*D1*Dd*f**3*fd*r**2 - 1397760*D1*Dd*f**3*fd*r*s + 979440*D1*Dd*f**3*fd*r + 349440*D1*Dd*f**3*fd*s - 209790*D1*Dd*f**3*fd - 164736*D1*Dd*f**2*g2*r**2 - 192192*D1*Dd*f**2*g2*r*s + 178464*D1*Dd*f**2*g2*r + 48048*D1*Dd*f**2*g2*s - 41184*D1*Dd*f**2*g2 + 576576*D1*Dd*f**2*gd2*r**2 + 439296*D1*Dd*f**2*gd2*r*s - 473616*D1*Dd*f**2*gd2*r - 54912*D1*Dd*f**2*gd2*s + 54912*D1*Dd*f**2*gd2 + 1153152*D1*Dd*f*fd*g2*r**2 + 878592*D1*Dd*f*fd*g2*r*s - 1084512*D1*Dd*f*fd*g2*r - 329472*D1*Dd*f*fd*g2*s + 253968*D1*Dd*f*fd*g2 - 70140*D1*Ddd*f**4*r**2 - 174720*D1*Ddd*f**4*r*s + 122430*D1*Ddd*f**4*r + 43680*D1*Ddd*f**4*s - 17535*D1*Ddd*f**4 + 288288*D1*Ddd*f**2*g2*r**2 + 219648*D1*Ddd*f**2*g2*r*s - 253968*D1*Ddd*f**2*g2*r - 54912*D1*Ddd*f**2*g2*s + 72072*D1*Ddd*f**2*g2 - 210420*Dd**2*f**4*r**2 - 524160*Dd**2*f**4*r*s + 367290*Dd**2*f**4*r + 131040*Dd**2*f**4*s - 87360*Dd**2*f**4 + 864864*Dd**2*f**2*g2*r**2 + 658944*Dd**2*f**2*g2*r*s - 761904*Dd**2*f**2*g2*r - 164736*Dd**2*f**2*g2*s + 109824*Dd**2*f**2*g2 + 1716*b1**3*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1) - 2*(7*K - 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-7*K + 6*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-7*K + 6*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 429*b1**2*(48*D1**2*K*fd*r*s + 40*D1**2*K*fd*r + 20*D1**2*K*fd*s - 20*D1**2*K*fd - 56*D1**2*K*fdd*r**2 - 52*D1**2*K*fdd*r*s - 48*D1**2*K*fdd*r - 24*D1**2*K*fdd*s + 24*D1**2*K*fdd - 4*D1**2*bdd1*(-7*K + 6*f + 7)*(3*r**2 + 3*r*(s - 1) - s + 1) - 140*D1**2*f*fd*r**2 - 224*D1**2*f*fd*r*s + 112*D1**2*f*fd*r - 16*D1**2*f*fd*s + 16*D1**2*f*fd + 238*D1**2*f*fdd*r**2 + 256*D1**2*f*fdd*r*s - 128*D1**2*f*fdd*r + 20*D1**2*f*fdd*s - 20*D1**2*f*fdd + 238*D1**2*fd**2*r**2 + 256*D1**2*fd**2*r*s - 128*D1**2*fd**2*r + 20*D1**2*fd**2*s - 20*D1**2*fd**2 - 42*D1**2*fd*r**2 - 88*D1**2*fd*r*s - 40*D1**2*fd*r - 20*D1**2*fd*s + 20*D1**2*fd + 91*D1**2*fdd*r**2 + 100*D1**2*fdd*r*s + 48*D1**2*fdd*r + 24*D1**2*fdd*s - 24*D1**2*fdd + 112*D1**2*gd2*r**2 + 112*D1**2*gd2*r*s - 112*D1**2*gd2*r - 56*D1**2*gdd2*r**2 - 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*r + 192*D1*Dd*K*f*r*s - 96*D1*Dd*K*f*r - 48*D1*Dd*K*f*s - 448*D1*Dd*K*fd*r**2 - 416*D1*Dd*K*fd*r*s + 24*D1*Dd*K*fd*r - 44*D1*Dd*K*fd*s + 96*D1*Dd*K*fd - 280*D1*Dd*f**2*r**2 - 448*D1*Dd*f**2*r*s + 364*D1*Dd*f**2*r + 112*D1*Dd*f**2*s - 70*D1*Dd*f**2 + 1904*D1*Dd*f*fd*r**2 + 2048*D1*Dd*f*fd*r*s - 1500*D1*Dd*f*fd*r - 176*D1*Dd*f*fd*s + 88*D1*Dd*f*fd - 168*D1*Dd*f*r**2 - 352*D1*Dd*f*r*s + 260*D1*Dd*f*r + 88*D1*Dd*f*s - 42*D1*Dd*f + 728*D1*Dd*fd*r**2 + 800*D1*Dd*fd*r*s - 190*D1*Dd*fd*r - 4*D1*Dd*fd*s - 96*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 448*D1*Dd*g2*r*s - 448*D1*Dd*g2*r - 112*D1*Dd*g2*s + 112*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 448*D1*Dd*gd2*r*s + 448*D1*Dd*gd2*r + 56*D1*Dd*gd2*s - 56*D1*Dd*gd2 - 224*D1*Ddd*K*f*r**2 - 208*D1*Ddd*K*f*r*s + 216*D1*Ddd*K*f*r + 52*D1*Ddd*K*f*s - 56*D1*Ddd*K*f + 476*D1*Ddd*f**2*r**2 + 512*D1*Ddd*f**2*r*s - 494*D1*Ddd*f**2*r - 128*D1*Ddd*f**2*s + 119*D1*Ddd*f**2 + 364*D1*Ddd*f*r**2 + 400*D1*Ddd*f*r*s - 382*D1*Ddd*f*r - 100*D1*Ddd*f*s + 91*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 224*D1*Ddd*g2*r*s + 224*D1*Ddd*g2*r + 56*D1*Ddd*g2*s - 56*D1*Ddd*g2 + 4*D1*bd1*(D1*(5*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 6*fd*(6*r**2 + 6*r*(s - 1) - s + 1) - 2*(7*K - 7)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-7*K + 6*f + 7)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 672*Dd**2*K*f*r**2 - 624*Dd**2*K*f*r*s + 648*Dd**2*K*f*r + 156*Dd**2*K*f*s - 104*Dd**2*K*f + 1428*Dd**2*f**2*r**2 + 1536*Dd**2*f**2*r*s - 1482*Dd**2*f**2*r - 384*Dd**2*f**2*s + 256*Dd**2*f**2 + 1092*Dd**2*f*r**2 + 1200*Dd**2*f*r*s - 1146*Dd**2*f*r - 300*Dd**2*f*s + 200*Dd**2*f - 672*Dd**2*g2*r**2 - 672*Dd**2*g2*r*s + 672*Dd**2*g2*r + 168*Dd**2*g2*s - 112*Dd**2*g2) - 13*b1*(-3168*D1**2*K*f*fd*r**2 - 3696*D1**2*K*f*fd*r*s + 3168*D1**2*K*f*fd*r + 1848*D1**2*K*f*fd*s - 1584*D1**2*K*f*fd + 5544*D1**2*K*f*fdd*r**2 + 4224*D1**2*K*f*fdd*r*s - 5544*D1**2*K*f*fdd*r - 2112*D1**2*K*f*fdd*s + 2772*D1**2*K*f*fdd + 5544*D1**2*K*fd**2*r**2 + 4224*D1**2*K*fd**2*r*s - 5544*D1**2*K*fd**2*r - 2112*D1**2*K*fd**2*s - 660*D1**2*b2*fd*r**2 - 660*D1**2*b2*fd*r*s + 792*D1**2*b2*fdd*r**2 + 792*D1**2*b2*fdd*r*s + 132*D1**2*bd1**2*(-7*K + 6*f + 7)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 660*D1**2*bd2*f*r**2 - 660*D1**2*bd2*f*r*s + 660*D1**2*bd2*f*r + 1584*D1**2*bd2*fd*r**2 + 1584*D1**2*bd2*fd*r*s - 792*D1**2*bd2*fd*r - 33*D1**2*bdd1*(f**2*(238*r**2 + r*(256*s - 366) - 148*s + 139) + f*(-4*K*(28*r**2 + 26*r*s - 53*r - 19*s + 20) + 182*r**2 + 200*r*s - 330*r - 124*s + 115) - 56*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 792*D1**2*bdd2*f*r**2 + 792*D1**2*bdd2*f*r*s - 792*D1**2*bdd2*f*r + 6900*D1**2*f**2*fd*r**2 - 1020*D1**2*f**2*fd*r*s - 2720*D1**2*f**2*fd*r - 3620*D1**2*f**2*fd*s + 3050*D1**2*f**2*fd - 8400*D1**2*f**2*fdd*r**2 - 480*D1**2*f**2*fdd*r*s + 5650*D1**2*f**2*fdd*r + 4120*D1**2*f**2*fdd*s - 4165*D1**2*f**2*fdd - 16800*D1**2*f*fd**2*r**2 - 960*D1**2*f*fd**2*r*s + 11300*D1**2*f*fd**2*r + 8240*D1**2*f*fd**2*s - 5240*D1**2*f*fd**2 + 4884*D1**2*f*fd*r**2 + 5808*D1**2*f*fd*r*s - 4884*D1**2*f*fd*r - 2904*D1**2*f*fd*s + 2442*D1**2*f*fd - 7194*D1**2*f*fdd*r**2 - 6864*D1**2*f*fdd*r*s + 7194*D1**2*f*fdd*r + 3432*D1**2*f*fdd*s - 3597*D1**2*f*fdd + 3168*D1**2*f*gd2*r*s - 3168*D1**2*f*gd2*r - 3696*D1**2*f*gdd2*r**2 - 3432*D1**2*f*gdd2*r*s + 3432*D1**2*f*gdd2*r - 7194*D1**2*fd**2*r**2 - 6864*D1**2*fd**2*r*s + 7194*D1**2*fd**2*r + 3432*D1**2*fd**2*s + 3168*D1**2*fd*g2*r*s + 2640*D1**2*fd*g2*r + 1320*D1**2*fd*g2*s - 1320*D1**2*fd*g2 - 7392*D1**2*fd*gd2*r**2 - 6864*D1**2*fd*gd2*r*s + 264*D1**2*fd*gd2*r - 1584*D1**2*fd*gd2*s + 1584*D1**2*fd*gd2 - 3696*D1**2*fdd*g2*r**2 - 3432*D1**2*fdd*g2*r*s - 3168*D1**2*fdd*g2*r - 1584*D1**2*fdd*g2*s + 1584*D1**2*fdd*g2 - 6336*D1*Dd*K*f**2*r**2 - 7392*D1*Dd*K*f**2*r*s + 6864*D1*Dd*K*f**2*r + 1848*D1*Dd*K*f**2*s - 1584*D1*Dd*K*f**2 + 44352*D1*Dd*K*f*fd*r**2 + 33792*D1*Dd*K*f*fd*r*s - 41712*D1*Dd*K*f*fd*r - 12672*D1*Dd*K*f*fd*s + 9768*D1*Dd*K*f*fd - 2640*D1*Dd*b2*f*r**2 - 2640*D1*Dd*b2*f*r*s + 2640*D1*Dd*b2*f*r + 660*D1*Dd*b2*f*s - 660*D1*Dd*b2*f + 6336*D1*Dd*b2*fd*r**2 + 6336*D1*Dd*b2*fd*r*s - 3168*D1*Dd*b2*fd*r - 792*D1*Dd*b2*fd*s + 6336*D1*Dd*bd2*f*r**2 + 6336*D1*Dd*bd2*f*r*s - 6336*D1*Dd*bd2*f*r - 792*D1*Dd*bd2*f*s + 792*D1*Dd*bd2*f + 9200*D1*Dd*f**3*r**2 - 1360*D1*Dd*f**3*r*s - 3920*D1*Dd*f**3*r + 340*D1*Dd*f**3*s + 2300*D1*Dd*f**3 - 67200*D1*Dd*f**2*fd*r**2 - 3840*D1*Dd*f**2*fd*r*s + 40360*D1*Dd*f**2*fd*r + 16960*D1*Dd*f**2*fd*s - 13890*D1*Dd*f**2*fd + 9768*D1*Dd*f**2*r**2 + 11616*D1*Dd*f**2*r*s - 10692*D1*Dd*f**2*r - 2904*D1*Dd*f**2*s + 2442*D1*Dd*f**2 - 57552*D1*Dd*f*fd*r**2 - 54912*D1*Dd*f*fd*r*s + 56892*D1*Dd*f*fd*r + 20592*D1*Dd*f*fd*s - 14058*D1*Dd*f*fd + 12672*D1*Dd*f*g2*r*s - 6336*D1*Dd*f*g2*r - 3168*D1*Dd*f*g2*s - 29568*D1*Dd*f*gd2*r**2 - 27456*D1*Dd*f*gd2*r*s + 27984*D1*Dd*f*gd2*r + 3432*D1*Dd*f*gd2*s - 3432*D1*Dd*f*gd2 - 29568*D1*Dd*fd*g2*r**2 - 27456*D1*Dd*fd*g2*r*s + 1584*D1*Dd*fd*g2*r - 2904*D1*Dd*fd*g2*s + 6336*D1*Dd*fd*g2 + 11088*D1*Ddd*K*f**2*r**2 + 8448*D1*Ddd*K*f**2*r*s - 9768*D1*Ddd*K*f**2*r - 2112*D1*Ddd*K*f**2*s + 2772*D1*Ddd*K*f**2 + 3168*D1*Ddd*b2*f*r**2 + 3168*D1*Ddd*b2*f*r*s - 3168*D1*Ddd*b2*f*r - 792*D1*Ddd*b2*f*s + 792*D1*Ddd*b2*f - 11200*D1*Ddd*f**3*r**2 - 640*D1*Ddd*f**3*r*s + 5920*D1*Ddd*f**3*r + 160*D1*Ddd*f**3*s - 2800*D1*Ddd*f**3 - 14388*D1*Ddd*f**2*r**2 - 13728*D1*Ddd*f**2*r*s + 14058*D1*Ddd*f**2*r + 3432*D1*Ddd*f**2*s - 3597*D1*Ddd*f**2 - 14784*D1*Ddd*f*g2*r**2 - 13728*D1*Ddd*f*g2*r*s + 14256*D1*Ddd*f*g2*r + 3432*D1*Ddd*f*g2*s - 3696*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f**2*(70*r**2 + 14*r*(8*s - 9) - 64*s + 43) + f*(K*(-48*r*s + 44*r + 34*s - 10) - 2*fd*(238*r**2 + r*(256*s - 247) - 64*s + 42) + 42*r**2 + 88*r*s - 106*r - 54*s + 31) + fd*(2*K*(56*r**2 + r*(52*s - 29) - 7*s - 6) - 182*r**2 + r*(117 - 200*s) + 38*s + 12) - 28*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 28*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd*(f**2*(-952*r**2 - 2*r*(512*s - 613) + 424*s - 331) + f*(2*K*(224*r**2 + 208*r*s - 320*r - 102*s + 91) - 728*r**2 - 800*r*s + 1042*r + 348*s - 289) + 56*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + 33264*Dd**2*K*f**2*r**2 + 25344*Dd**2*K*f**2*r*s - 29304*Dd**2*K*f**2*r - 6336*Dd**2*K*f**2*s + 4224*Dd**2*K*f**2 + 9504*Dd**2*b2*f*r**2 + 9504*Dd**2*b2*f*r*s - 9504*Dd**2*b2*f*r - 2376*Dd**2*b2*f*s + 1584*Dd**2*b2*f - 33600*Dd**2*f**3*r**2 - 1920*Dd**2*f**3*r*s + 17760*Dd**2*f**3*r + 480*Dd**2*f**3*s - 320*Dd**2*f**3 - 43164*Dd**2*f**2*r**2 - 41184*Dd**2*f**2*r*s + 42174*Dd**2*f**2*r + 10296*Dd**2*f**2*s - 6864*Dd**2*f**2 - 44352*Dd**2*f*g2*r**2 - 41184*Dd**2*f*g2*r*s + 42768*Dd**2*f*g2*r + 10296*Dd**2*f*g2*s - 6864*Dd**2*f*g2) + 1716*b2*(-6*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*r + 5*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(r - 1)*(r + s - 1) + 6*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 6*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(9009*d**2*k3**4) + 4*D1**2*Pk3*Pkd1*ct**3*k2*st**2*(-33*b1**2*(C - 1)*(D1*Dd*(13*f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(13*fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 33*b1*(D1*Dd*f*(-f*(9*C - 11)*(r*(4*s - 2) - s) + fd*(2*s - 1)*(C*(56*r - 1) - 64*r + 2)) - D1*bd1*(C - 1)*(D1*(13*f*s*(1 - 2*r) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(f*fd*(-r*(9*C - 11)*(2*s - 1) + s*(5 - 5*C)) + f*(3*bdd1*s*(-2*C*r + C + 2*r - 1) + fdd*r*(7*C - 8)*(2*s - 1) + fdd*s*(3*C - 3)) + fd**2*(C*(14*r*s - 7*r + 3*s - 3) - 16*r*s + 8*r - 3*s + 3)) + Ddd*f**2*(7*C - 8)*(r*(4*s - 2) - s)) + Dd**2*f**2*(7*C - 8)*(6*r*(2*s - 1) - 3*s + 2)) + f*(-99*D1**2*bd1**2*s*(C - 1)*(2*r - 1) + D1*Dd*f*(f*(352 - 302*C)*(r*(4*s - 2) - s) + fd*(250*C - 275)*(2*r*(12*s - 5) - 7*s + 3)) - 33*D1*bd1*(D1*(f*s*(C*(9*r - 14) - 11*r + 16) + fd*(C*(-28*r*s + 7*r + 17*s - 10) + 32*r*s - 8*r - 19*s + 11)) + Dd*f*(C*(-56*r*s + 14*r + 47*s - 20) + 64*r*s - 16*r - 52*s + 22)) + D1*(D1*(f*fd*(352 - 302*C)*(r*(3*s - 1) - s) + f*(33*bdd1*s*(7*C*r - 10*C - 8*r + 11) + fdd*(250*C - 275)*(3*r*s - r - s)) + fd**2*(250*C - 275)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(250*C - 275)*(r*(4*s - 2) - s)) + Dd**2*f**2*(250*C - 275)*(6*r*(2*s - 1) - 3*s + 2)))/(693*d**2*k3**2) + D1**2*Pk3*Pkd1*ct**3*k2*(33*b1**2*(D1**2*r*(fd*(8*C*(r - 12*s + 12) - 6*r + 96*s - 96) + 13*fdd*(4*C*(r + 2*s - 2) - 3*r - 8*s + 8)) + D1*(2*Dd*(f*(4*C*(4*r**2 - 48*r*s + 22*r + 12*s + 1) - 12*r**2 + 192*r*s - 90*r - 48*s - 3) + 13*fd*(4*C*(4*r**2 + 8*r*s - 7*r - s + 1) - 12*r**2 - 32*r*s + 27*r + 4*s - 4)) + 13*Ddd*f*(4*C*(4*r**2 + 8*r*s - 6*r - 2*s + 1) - 12*r**2 - 32*r*s + 22*r + 8*s - 3)) + 26*Dd**2*f*(4*C*(6*r**2 + 12*r*s - 9*r - 3*s + 2) - 18*r**2 - 48*r*s + 33*r + 12*s - 8)) + 33*b1*(-32*C*D1**2*f*fd*r**2 + 32*C*D1**2*f*fd*r*s + 32*C*D1**2*f*fd*r + 80*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r**2 - 16*C*D1**2*f*fdd*r*s - 112*C*D1**2*f*fdd*r - 88*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r**2 - 16*C*D1**2*fd**2*r*s - 112*C*D1**2*fd**2*r - 88*C*D1**2*fd**2*s + 88*C*D1**2*fd**2 - 64*C*D1*Dd*f**2*r**2 + 64*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*s - 16*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r**2 - 128*C*D1*Dd*f*fd*r*s - 448*C*D1*Dd*f*fd*r - 336*C*D1*Dd*f*fd*s + 288*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r**2 - 32*C*D1*Ddd*f**2*r*s + 8*C*D1*Ddd*f**2*s + 8*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r**2 - 96*C*Dd**2*f**2*r*s + 24*C*Dd**2*f**2*s - 16*C*Dd**2*f**2 + 13*D1**2*bdd1*f*(4*C*(2*r**2 + 4*r*s - 2*r - 2*s + 1) - 6*r**2 - 16*r*s + 6*r + 8*s - 3) + 16*D1**2*f*fd*r**2 - 112*D1**2*f*fd*r*s + 20*D1**2*f*fd*r - 80*D1**2*f*fd*s + 18*D1**2*f*fd - 8*D1**2*f*fdd*r**2 + 104*D1**2*f*fdd*r*s + 38*D1**2*f*fdd*r + 88*D1**2*f*fdd*s - 45*D1**2*f*fdd - 8*D1**2*fd**2*r**2 + 104*D1**2*fd**2*r*s + 38*D1**2*fd**2*r + 88*D1**2*fd**2*s - 88*D1**2*fd**2 + 32*D1*Dd*f**2*r**2 - 224*D1*Dd*f**2*r*s + 96*D1*Dd*f**2*r + 56*D1*Dd*f**2*s + 8*D1*Dd*f**2 - 64*D1*Dd*f*fd*r**2 + 832*D1*Dd*f*fd*r*s - 40*D1*Dd*f*fd*r + 248*D1*Dd*f*fd*s - 214*D1*Dd*f*fd - 16*D1*Ddd*f**2*r**2 + 208*D1*Ddd*f**2*r*s - 96*D1*Ddd*f**2*r - 52*D1*Ddd*f**2*s - 4*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(C*(8*r**2 - 96*r*s - 8*r + 48*s + 4) - 6*r**2 + 96*r*s + 6*r - 48*s - 3) + 13*fd*(4*C*(2*r**2 + 4*r*s - 3*r - s + 1) - 6*r**2 - 16*r*s + 11*r + 4*s - 4)) + 13*Dd*f*(4*C*(8*r**2 + 2*r*(8*s - 5) - 6*s + 3) - 24*r**2 - 64*r*s + 34*r + 24*s - 11)) - 48*Dd**2*f**2*r**2 + 624*Dd**2*f**2*r*s - 288*Dd**2*f**2*r - 156*Dd**2*f**2*s + 104*Dd**2*f**2) + f*(858*D1**2*bd1**2*(r**2*(4*C - 3) + r*(C*(8*s - 4) - 8*s + 3) - s*(4*C - 4)) + 33*D1**2*bdd1*f*(4*C*(2*r**2 - 2*r*(s - 13) + 24*s - 13) - 4*r**2 + r*(52*s - 82) - 140*s + 41) + 5*D1**2*(f*(2*fd*(4*C*(75*r**2 + 2*r*(99*s - 58) - 66*s + 25) - 255*r**2 - 6*r*(188*s - 91) + 376*s - 85) + fdd*(-4*C*(273*r**2 + r*(396*s - 314) - 132*s + 91) + 849*r**2 + 6*r*(386*s - 223) - 772*s + 283)) + 2*fd**2*(-4*C*(273*r**2 + r*(396*s - 314) - 132*s + 66) + 849*r**2 + 6*r*(386*s - 223) - 772*s + 386)) - 66*D1*bd1*(D1*(f*(C*(8*r**2 - 8*r*s + 8*r + 48*s - 4) - 4*r**2 + 28*r*s - 10*r - 68*s + 5) + fd*(-4*C*(4*r**2 - 4*r*(s - 3) + 13*s - 12) + 8*r**2 - 104*r*s + 63*r + 96*s - 70)) + Dd*f*(-4*C*(8*r**2 - 8*r*s + 52*r + 49*s - 37) + 16*r**2 - 208*r*s + 212*r + 306*s - 181)) + 5*D1*f*(2*Dd*(f*(4*C*(100*r**2 + 264*r*s - 182*r - 66*s + 25) - 340*r**2 - 1504*r*s + 922*r + 376*s - 85) + fd*(-4*C*(1092*r**2 + 1584*r*s - 1297*r - 462*s + 289) + 3396*r**2 + 9264*r*s - 5841*r - 2702*s + 1441)) + Ddd*f*(-4*C*(364*r**2 + 528*r*s - 446*r - 132*s + 91) + 1132*r**2 + 3088*r*s - 2110*r - 772*s + 283)) + 10*Dd**2*f**2*(-12*C*(182*r**2 + r*(264*s - 223) - 66*s + 44) + 1698*r**2 + r*(4632*s - 3165) - 1158*s + 772)))/(693*d**2*k3**2) - D1**2*Pk3*Pkd1*ct**3*(8*C - 4)*(D1*f*(6*D1*bd1**2*s*(1 - 2*r) + D1*bd1*(4*f*r*s + 5*fd*(-4*r*s + r + s)) - 5*D1*bdd1*f*r*s + 5*Dd*bd1*f*(r*(2 - 8*s) + s)) + b1**2*(D1*Dd*(5*f*(4*r*s - 2*r - s) - 6*fd*(8*r*s - 6*r - s + 1)) + D1*(D1*r*(5*fd - 6*fdd)*(s - 1) + 6*Ddd*f*(-4*r*s + 2*r + s)) - 6*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(D1*Dd*f*(8*f*r*(2*s - 1) - 4*f*s - 5*fd*(8*r - 3)*(2*s - 1)) + D1*bd1*(D1*(5*f*s*(2*r - 1) - 6*fd*(4*r*s - 2*r - s + 1)) - 12*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(6*bdd1*f*s*(1 - 2*r) + 4*f*fd*r*(2*s - 1) - 4*f*fd*s + 5*f*fdd*(-2*r*s + r + s) + 5*fd**2*(-2*r*s + r + s - 1)) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(21*d**2*k2) + 2*D1**2*Pk3*Pkd1*ct**3*k2**3*st**2*(132*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 - 210*D1**2*f**2*fd*r**2 + 140*D1**2*f**2*fd*r - 70*D1**2*f**2*fd + 105*D1**2*f**2*fdd*r**2 - 70*D1**2*f**2*fdd*r + 35*D1**2*f**2*fdd + 210*D1**2*f*fd**2*r**2 - 140*D1**2*f*fd**2*r + 264*D1*Dd*b1*f**2*r**2 - 132*D1*Dd*b1*f**2*r + 66*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r - 280*D1*Dd*f**3*r**2 + 140*D1*Dd*f**3*r - 70*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*r**2 - 490*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 + 140*D1*Ddd*f**3*r**2 - 70*D1*Ddd*f**3*r + 35*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r + 420*Dd**2*f**3*r**2 - 210*Dd**2*f**3*r)/(693*d**2*k1**2*k3**2) + D1**2*Pk3*Pkd1*ct**3*k2**3*(D1*f*r*(-22*D1*bd1**2*(14*f + 11)*(r - 1) - 5*D1*bdd1*f*r*(14*f + 11) - 10*bd1*(-D1*f*r*(14*f + 11) + D1*fd*(14*f*(3*r - 1) + 22*r - 11) + Dd*f*(14*f + 11)*(4*r - 1))) + 11*b1**2*(D1**2*r**2*(-28*fd**2 + fd*(56*f + 22) - fdd*(28*f + 11)) + D1*(2*Dd*(14*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(44 - 112*fd) + r*(28*fd - 22) + 11) + 11*fd*r*(1 - 4*r)) - Ddd*f*(14*f + 11)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(14*f + 11)*(2*r - 1)) + b1*(-11*D1**2*bdd1*f*(14*f + 11)*(2*r**2 - 2*r + 1) + 5*D1**2*(14*f**2*(2*fd - fdd)*(3*r**2 - 2*r + 1) + f*(28*fd**2*r*(2 - 3*r) + 22*fd*(2*r**2 - 2*r + 1) - 11*fdd*(2*r**2 - 2*r + 1)) - 22*fd**2*r*(r - 1)) + 22*D1*bd1*(D1*(14*f**2*(2*r**2 - 2*r + 1) + f*(r**2*(22 - 56*fd) + r*(28*fd - 22) + 11) + 11*fd*r*(1 - 2*r)) - Dd*f*(14*f + 11)*(8*r**2 - 6*r + 1)) + 5*D1*f*(2*Dd*(14*f**2*(4*r**2 - 2*r + 1) - 14*f*fd*(12*r**2 - 7*r + 1) + 11*f*(4*r**2 - 2*r + 1) - 11*fd*(8*r**2 - 6*r + 1)) - Ddd*f*(14*f + 11)*(4*r**2 - 2*r + 1)) - 30*Dd**2*f**2*r*(14*f + 11)*(2*r - 1)))/(231*d**2*k1**2*k3**2) + D1**2*Pk3*Pkd1*ct**3*k2*(D1*f*r*(-22*D1*bd1**2*(r - 1) + 10*D1*bd1*(f*r - 2*fd*r + fd) - 5*D1*bdd1*f*r - 10*Dd*bd1*f*(4*r - 1)) + 11*b1**2*(D1**2*r**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*r*(1 - 4*r)) + D1*Ddd*f*(-4*r**2 + 2*r - 1) + 6*Dd**2*f*r*(1 - 2*r)) + b1*(-11*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 5*D1**2*(f*(2*fd - fdd)*(2*r**2 - 2*r + 1) - 2*fd**2*r*(r - 1)) + 22*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(1 - 2*r) + Dd*f*(-8*r**2 + 6*r - 1)) + 5*D1*f*(2*Dd*(4*f*r**2 - 2*f*r + f - 8*fd*r**2 + 6*fd*r - fd) + Ddd*f*(-4*r**2 + 2*r - 1)) + 30*Dd**2*f**2*r*(1 - 2*r)))/(21*d**2*k1**2) + 8*D1**2*Pk3*Pkd1*ct**2*f*k1*k2**4*st**4*(33*D1**2*bd1*f*(6*C - 5)*(r - 1)*(r + s - 1) + 33*D1*b1*(6*C - 5)*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + (26*C - 21)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)))/(231*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*ct**2*f*k1*k2**2*st**4*(D1*Dd*f*(-fd*(24*C - 19)*(2*r*(12*s - 5) - 7*s + 3) + (33*b1*(4*C - 3) + f*(48*C - 38))*(r*(4*s - 2) - s)) + D1*(D1*(f*(33*bd1*s*(4*C - 3)*(r - 1) - fdd*(24*C - 19)*(3*r*s - r - s)) - fd**2*(24*C - 19)*(r*(6*s - 2) - 2*s + 1) + fd*(33*b1*r*(4*C - 3)*(2*s - 1) + f*(48*C - 38)*(3*r*s - r - s))) - Ddd*f**2*(24*C - 19)*(r*(4*s - 2) - s)) - Dd**2*f**2*(24*C - 19)*(6*r*(2*s - 1) - 3*s + 2))/(231*d**2*k3**4) + 40*D1**2*Pk3*Pkd1*ct**2*f*k2**6*st**4*(234*D1**2*b1*f*fd*r**2 + 234*D1**2*b1*f*fd*r*s - 156*D1**2*b1*f*fd*r - 117*D1**2*b1*f*fdd*r**2 - 117*D1**2*b1*f*fdd*r*s + 78*D1**2*b1*f*fdd*r - 234*D1**2*b1*fd**2*r**2 - 234*D1**2*b1*fd**2*r*s + 156*D1**2*b1*fd**2*r - 39*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 188*D1**2*f**2*fd*r**2 + 188*D1**2*f**2*fd*r*s - 188*D1**2*f**2*fd*r - 47*D1**2*f**2*fd*s + 47*D1**2*f**2*fd - 120*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 120*D1**2*f**2*fdd*r + 30*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd - 360*D1**2*f*fd**2*r**2 - 360*D1**2*f*fd**2*r*s + 360*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s - 60*D1**2*f*fd**2 + 312*D1*Dd*b1*f**2*r**2 + 312*D1*Dd*b1*f**2*r*s - 312*D1*Dd*b1*f**2*r - 78*D1*Dd*b1*f**2*s + 78*D1*Dd*b1*f**2 - 936*D1*Dd*b1*f*fd*r**2 - 936*D1*Dd*b1*f*fd*r*s + 780*D1*Dd*b1*f*fd*r + 117*D1*Dd*b1*f*fd*s - 78*D1*Dd*b1*f*fd + 188*D1*Dd*f**3*r**2 + 188*D1*Dd*f**3*r*s - 188*D1*Dd*f**3*r - 47*D1*Dd*f**3*s + 47*D1*Dd*f**3 - 960*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 960*D1*Dd*f**2*fd*r + 240*D1*Dd*f**2*fd*s - 180*D1*Dd*f**2*fd - 156*D1*Ddd*b1*f**2*r**2 - 156*D1*Ddd*b1*f**2*r*s + 156*D1*Ddd*b1*f**2*r + 39*D1*Ddd*b1*f**2*s - 39*D1*Ddd*b1*f**2 - 120*D1*Ddd*f**3*r**2 - 120*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r + 30*D1*Ddd*f**3*s - 30*D1*Ddd*f**3 + 39*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 468*Dd**2*b1*f**2*r**2 - 468*Dd**2*b1*f**2*r*s + 468*Dd**2*b1*f**2*r + 117*Dd**2*b1*f**2*s - 78*Dd**2*b1*f**2 - 360*Dd**2*f**3*r**2 - 360*Dd**2*f**3*r*s + 360*Dd**2*f**3*r + 90*Dd**2*f**3*s - 60*Dd**2*f**3)/(3003*d**2*k1*k3**6) + 4*D1**2*Pk3*Pkd1*ct**2*f*k2**2*st**4*(D1*Dd*f*(-5*fd*(24*r*s - 10*r - 7*s + 3) + (33*b1 + 10*f)*(4*r*s - 2*r - s)) + D1*(D1*(f*(33*bd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1) + fd*(33*b1*r*(2*s - 1) + 10*f*(3*r*s - r - s))) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2))/(231*d**2*k1*k3**2) + D1**2*Pk3*Pkd1*ct**2*k1**5*(16*C - 8)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*ct**2*k1**3*k2**2*st**2*(6204*C*D1**2*b1*f*fd*r**2 + 6204*C*D1**2*b1*f*fd*r*s - 3102*C*D1**2*b1*f*fd*r - 4884*C*D1**2*b1*f*fdd*r**2 - 4884*C*D1**2*b1*f*fdd*r*s + 2442*C*D1**2*b1*f*fdd*r - 4884*C*D1**2*b1*fd**2*r**2 - 4884*C*D1**2*b1*fd**2*r*s + 2442*C*D1**2*b1*fd**2*r + 5754*C*D1**2*f**2*fd*r**2 + 5754*C*D1**2*f**2*fd*r*s - 5754*C*D1**2*f**2*fd*r - 1918*C*D1**2*f**2*fd*s + 1918*C*D1**2*f**2*fd - 5550*C*D1**2*f**2*fdd*r**2 - 5550*C*D1**2*f**2*fdd*r*s + 5550*C*D1**2*f**2*fdd*r + 1850*C*D1**2*f**2*fdd*s - 1850*C*D1**2*f**2*fdd - 11100*C*D1**2*f*fd**2*r**2 - 11100*C*D1**2*f*fd**2*r*s + 11100*C*D1**2*f*fd**2*r + 3700*C*D1**2*f*fd**2*s - 1850*C*D1**2*f*fd**2 + 12408*C*D1*Dd*b1*f**2*r**2 + 12408*C*D1*Dd*b1*f**2*r*s - 12408*C*D1*Dd*b1*f**2*r - 3102*C*D1*Dd*b1*f**2*s + 3102*C*D1*Dd*b1*f**2 - 39072*C*D1*Dd*b1*f*fd*r**2 - 39072*C*D1*Dd*b1*f*fd*r*s + 29304*C*D1*Dd*b1*f*fd*r + 4884*C*D1*Dd*b1*f*fd*s - 2442*C*D1*Dd*b1*f*fd + 7672*C*D1*Dd*f**3*r**2 + 7672*C*D1*Dd*f**3*r*s - 7672*C*D1*Dd*f**3*r - 1918*C*D1*Dd*f**3*s + 1918*C*D1*Dd*f**3 - 44400*C*D1*Dd*f**2*fd*r**2 - 44400*C*D1*Dd*f**2*fd*r*s + 44400*C*D1*Dd*f**2*fd*r + 12950*C*D1*Dd*f**2*fd*s - 9250*C*D1*Dd*f**2*fd - 9768*C*D1*Ddd*b1*f**2*r**2 - 9768*C*D1*Ddd*b1*f**2*r*s + 9768*C*D1*Ddd*b1*f**2*r + 2442*C*D1*Ddd*b1*f**2*s - 2442*C*D1*Ddd*b1*f**2 - 7400*C*D1*Ddd*f**3*r**2 - 7400*C*D1*Ddd*f**3*r*s + 7400*C*D1*Ddd*f**3*r + 1850*C*D1*Ddd*f**3*s - 1850*C*D1*Ddd*f**3 - 29304*C*Dd**2*b1*f**2*r**2 - 29304*C*Dd**2*b1*f**2*r*s + 29304*C*Dd**2*b1*f**2*r + 7326*C*Dd**2*b1*f**2*s - 4884*C*Dd**2*b1*f**2 - 22200*C*Dd**2*f**3*r**2 - 22200*C*Dd**2*f**3*r*s + 22200*C*Dd**2*f**3*r + 5550*C*Dd**2*f**3*s - 3700*C*Dd**2*f**3 - 3894*D1**2*b1*f*fd*r**2 - 3894*D1**2*b1*f*fd*r*s + 1947*D1**2*b1*f*fd*r + 3102*D1**2*b1*f*fdd*r**2 + 3102*D1**2*b1*f*fdd*r*s - 1551*D1**2*b1*f*fdd*r + 3102*D1**2*b1*fd**2*r**2 + 3102*D1**2*b1*fd**2*r*s - 1551*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(74*C - 47)*(r - 1)*(r + s - 1) - 3585*D1**2*f**2*fd*r**2 - 3585*D1**2*f**2*fd*r*s + 3585*D1**2*f**2*fd*r + 1195*D1**2*f**2*fd*s - 1195*D1**2*f**2*fd + 3525*D1**2*f**2*fdd*r**2 + 3525*D1**2*f**2*fdd*r*s - 3525*D1**2*f**2*fdd*r - 1175*D1**2*f**2*fdd*s + 1175*D1**2*f**2*fdd + 7050*D1**2*f*fd**2*r**2 + 7050*D1**2*f*fd**2*r*s - 7050*D1**2*f*fd**2*r - 2350*D1**2*f*fd**2*s + 1175*D1**2*f*fd**2 - 7788*D1*Dd*b1*f**2*r**2 - 7788*D1*Dd*b1*f**2*r*s + 7788*D1*Dd*b1*f**2*r + 1947*D1*Dd*b1*f**2*s - 1947*D1*Dd*b1*f**2 + 24816*D1*Dd*b1*f*fd*r**2 + 24816*D1*Dd*b1*f*fd*r*s - 18612*D1*Dd*b1*f*fd*r - 3102*D1*Dd*b1*f*fd*s + 1551*D1*Dd*b1*f*fd - 4780*D1*Dd*f**3*r**2 - 4780*D1*Dd*f**3*r*s + 4780*D1*Dd*f**3*r + 1195*D1*Dd*f**3*s - 1195*D1*Dd*f**3 + 28200*D1*Dd*f**2*fd*r**2 + 28200*D1*Dd*f**2*fd*r*s - 28200*D1*Dd*f**2*fd*r - 8225*D1*Dd*f**2*fd*s + 5875*D1*Dd*f**2*fd + 6204*D1*Ddd*b1*f**2*r**2 + 6204*D1*Ddd*b1*f**2*r*s - 6204*D1*Ddd*b1*f**2*r - 1551*D1*Ddd*b1*f**2*s + 1551*D1*Ddd*b1*f**2 + 4700*D1*Ddd*f**3*r**2 + 4700*D1*Ddd*f**3*r*s - 4700*D1*Ddd*f**3*r - 1175*D1*Ddd*f**3*s + 1175*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(94*C - 59)*(r - 1)*(r + s - 1) - fd*(74*C - 47)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(74*C - 47)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 18612*Dd**2*b1*f**2*r**2 + 18612*Dd**2*b1*f**2*r*s - 18612*Dd**2*b1*f**2*r - 4653*Dd**2*b1*f**2*s + 3102*Dd**2*b1*f**2 + 14100*Dd**2*f**3*r**2 + 14100*Dd**2*f**3*r*s - 14100*Dd**2*f**3*r - 3525*Dd**2*f**3*s + 2350*Dd**2*f**3)/(693*d**2*k3**6) - 8*D1**2*Pk3*Pkd1*ct**2*k1**3*k2**2*(-1716*D1**2*bd1**2*f*(2*r - 1)*(-15*K + 5*f + 6)*(r + s - 1) - 130*D1**2*bdd1*f*(r + s - 1)*(14*f**2*(3*r + 1) - 33*f*r*(5*K - 2) + 396*g2*(r - 1)) - 5*D1**2*(7*f**3*(38*fd - 45*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) + f**2*(-315*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - r*(6864*gd2 - 8580*gdd2)*(r + s - 1)) - 1716*f*(fd*(g2*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 8580*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) + 13*D1*bd1*(D1*(115*f**3*(3*r + 1)*(r + s - 1) - 4*f**2*(35*fd*(18*r**2 + 2*r*(9*s - 8) - s + 2) + r*(330*K - 132)*(r + s - 1)) + 330*f*(fd*(5*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + (10*g2*(r - 1) + 12*gd2*(1 - 2*r))*(r + s - 1)) - 3960*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 10*Dd*f*(14*f**2*(24*r**2 + 4*r*(6*s - 5) + s) - 33*f*(5*K - 2)*(8*r**2 + 8*r*(s - 1) - s + 1) + 396*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 5*D1*f*(2*Dd*(133*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 315*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 858*f*(4*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 8580*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 15*Ddd*f*(21*f**2 - 572*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 75*Dd**2*f**2*(21*f**2 - 572*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 858*b1**2*(D1**2*r*(2*f*(4*fd - 5*fdd)*(2*r + 2*s - 1) - 10*fd**2*(2*r + 2*s - 1) - 5*fd*(5*K - 2)*(r + s) + 6*fdd*(5*K - 2)*(r + s)) + D1*(Dd*(8*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(32*r**2 + 8*r*(4*s - 3) - 4*s + 2) + (5*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*fd*(5*K - 2)*(8*r**2 + r*(8*s - 4) - s)) - 2*Ddd*f*(-15*K + 5*f + 6)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 2*Dd**2*f*(-15*K + 5*f + 6)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-2640*D1**2*K*f*fd*r**2 - 2640*D1**2*K*f*fd*r*s + 2640*D1**2*K*f*fd*r + 1320*D1**2*K*f*fd*s - 1320*D1**2*K*f*fd + 3300*D1**2*K*f*fdd*r**2 + 3300*D1**2*K*f*fdd*r*s - 3300*D1**2*K*f*fdd*r - 1650*D1**2*K*f*fdd*s + 1650*D1**2*K*f*fdd + 3300*D1**2*K*fd**2*r**2 + 3300*D1**2*K*fd**2*r*s - 3300*D1**2*K*fd**2*r - 1650*D1**2*K*fd**2*s - 132*D1**2*bdd1*f*(2*r - 1)*(-15*K + 5*f + 6)*(r + s - 1) + 1035*D1**2*f**2*fd*r**2 + 1035*D1**2*f**2*fd*r*s - 1150*D1**2*f**2*fd*r - 460*D1**2*f**2*fd*s + 460*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r**2 - 1260*D1**2*f**2*fdd*r*s + 1400*D1**2*f**2*fdd*r + 560*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd - 2520*D1**2*f*fd**2*r**2 - 2520*D1**2*f*fd**2*r*s + 2800*D1**2*f*fd**2*r + 1120*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 + 1056*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 1056*D1**2*f*fd*r - 528*D1**2*f*fd*s + 528*D1**2*f*fd - 1320*D1**2*f*fdd*r**2 - 1320*D1**2*f*fdd*r*s + 1320*D1**2*f*fdd*r + 660*D1**2*f*fdd*s - 660*D1**2*f*fdd + 3300*D1**2*f*gd2*r**2 + 3300*D1**2*f*gd2*r*s - 3300*D1**2*f*gd2*r - 3960*D1**2*f*gdd2*r**2 - 3960*D1**2*f*gdd2*r*s + 3960*D1**2*f*gdd2*r - 1320*D1**2*fd**2*r**2 - 1320*D1**2*fd**2*r*s + 1320*D1**2*fd**2*r + 660*D1**2*fd**2*s + 3300*D1**2*fd*g2*r**2 + 3300*D1**2*fd*g2*r*s - 7920*D1**2*fd*gd2*r**2 - 7920*D1**2*fd*gd2*r*s + 3960*D1**2*fd*gd2*r - 3960*D1**2*fdd*g2*r**2 - 3960*D1**2*fdd*g2*r*s - 5280*D1*Dd*K*f**2*r**2 - 5280*D1*Dd*K*f**2*r*s + 5280*D1*Dd*K*f**2*r + 1320*D1*Dd*K*f**2*s - 1320*D1*Dd*K*f**2 + 26400*D1*Dd*K*f*fd*r**2 + 26400*D1*Dd*K*f*fd*r*s - 26400*D1*Dd*K*f*fd*r - 9900*D1*Dd*K*f*fd*s + 6600*D1*Dd*K*f*fd + 1380*D1*Dd*f**3*r**2 + 1380*D1*Dd*f**3*r*s - 1380*D1*Dd*f**3*r - 345*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r**2 - 10080*D1*Dd*f**2*fd*r*s + 10640*D1*Dd*f**2*fd*r + 3500*D1*Dd*f**2*fd*s - 2520*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 2112*D1*Dd*f**2*r - 528*D1*Dd*f**2*s + 528*D1*Dd*f**2 - 10560*D1*Dd*f*fd*r**2 - 10560*D1*Dd*f*fd*r*s + 10560*D1*Dd*f*fd*r + 3960*D1*Dd*f*fd*s - 2640*D1*Dd*f*fd + 13200*D1*Dd*f*g2*r**2 + 13200*D1*Dd*f*g2*r*s - 13200*D1*Dd*f*g2*r - 3300*D1*Dd*f*g2*s + 3300*D1*Dd*f*g2 - 31680*D1*Dd*f*gd2*r**2 - 31680*D1*Dd*f*gd2*r*s + 31680*D1*Dd*f*gd2*r + 3960*D1*Dd*f*gd2*s - 3960*D1*Dd*f*gd2 - 31680*D1*Dd*fd*g2*r**2 - 31680*D1*Dd*fd*g2*r*s + 15840*D1*Dd*fd*g2*r + 3960*D1*Dd*fd*g2*s + 6600*D1*Ddd*K*f**2*r**2 + 6600*D1*Ddd*K*f**2*r*s - 6600*D1*Ddd*K*f**2*r - 1650*D1*Ddd*K*f**2*s + 1650*D1*Ddd*K*f**2 - 1680*D1*Ddd*f**3*r**2 - 1680*D1*Ddd*f**3*r*s + 1680*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*r**2 - 2640*D1*Ddd*f**2*r*s + 2640*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s - 660*D1*Ddd*f**2 - 15840*D1*Ddd*f*g2*r**2 - 15840*D1*Ddd*f*g2*r*s + 15840*D1*Ddd*f*g2*r + 3960*D1*Ddd*f*g2*s - 3960*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(8*f**2*(2*r - 1)*(r + s - 1) - 5*f*(2*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + (5*K - 2)*(2*r - 1)*(r + s - 1)) + 6*fd*(5*K - 2)*(4*r**2 + r*(4*s - 3) - s)) - 2*Dd*f*(-15*K + 5*f + 6)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 19800*Dd**2*K*f**2*r**2 + 19800*Dd**2*K*f**2*r*s - 19800*Dd**2*K*f**2*r - 4950*Dd**2*K*f**2*s + 3300*Dd**2*K*f**2 - 5040*Dd**2*f**3*r**2 - 5040*Dd**2*f**3*r*s + 5040*Dd**2*f**3*r + 1260*Dd**2*f**3*s - 840*Dd**2*f**3 - 7920*Dd**2*f**2*r**2 - 7920*Dd**2*f**2*r*s + 7920*Dd**2*f**2*r + 1980*Dd**2*f**2*s - 1320*Dd**2*f**2 - 47520*Dd**2*f*g2*r**2 - 47520*Dd**2*f*g2*r*s + 47520*Dd**2*f*g2*r + 11880*Dd**2*f*g2*s - 7920*Dd**2*f*g2))/(9009*d**2*k3**6) + 2*D1**2*Pk3*Pkd1*ct**2*k1**3*st**2*(11*D1*bd1*f*(D1*(f*s*(56*C - 33)*(r - 1) - fd*(36*C - 21)*(r*(4*s - 1) - 2*s + 1)) + Dd*f*(21 - 36*C)*(r*(8*s - 2) - 5*s + 2)) - 11*b1*(D1*Dd*f*(-f*(56*C - 33)*(r*(4*s - 2) - s) + fd*(36*C - 21)*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(f*fd*(56*C - 33) + f*fdd*(21 - 36*C) + fd**2*(21 - 36*C)) + Ddd*f**2*(36*C - 21)*(r*(4*s - 2) - s)) + Dd**2*f**2*(36*C - 21)*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(f*(424*C - 251)*(r*(4*s - 2) - s) - fd*(300*C - 175)*(2*r*(12*s - 5) - 7*s + 3)) + D1*(D1*(f*fd*(424*C - 251)*(r*(3*s - 1) - s) - f*(12*C - 7)*(33*bdd1*s*(r - 1) + 25*fdd*(r*(3*s - 1) - s)) - fd**2*(300*C - 175)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(175 - 300*C)*(r*(4*s - 2) - s)) + Dd**2*f**2*(175 - 300*C)*(6*r*(2*s - 1) - 3*s + 2)))/(231*d**2*k3**4) + D1**2*Pk3*Pkd1*ct**2*k1**3*(132*b1**2*(2*C - 1)*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1*(-120*C*D1**2*f*fd*r**2 - 544*C*D1**2*f*fd*r*s + 208*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s + 32*C*D1**2*f*fd + 180*C*D1**2*f*fdd*r**2 + 560*C*D1**2*f*fdd*r*s - 200*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s - 40*C*D1**2*f*fdd + 180*C*D1**2*fd**2*r**2 + 560*C*D1**2*fd**2*r*s - 200*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s - 40*C*D1**2*fd**2 - 240*C*D1*Dd*f**2*r**2 - 1088*C*D1*Dd*f**2*r*s + 664*C*D1*Dd*f**2*r + 272*C*D1*Dd*f**2*s - 60*C*D1*Dd*f**2 + 1440*C*D1*Dd*f*fd*r**2 + 4480*C*D1*Dd*f*fd*r*s - 2280*C*D1*Dd*f*fd*r - 400*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 360*C*D1*Ddd*f**2*r**2 + 1120*C*D1*Ddd*f**2*r*s - 740*C*D1*Ddd*f**2*r - 280*C*D1*Ddd*f**2*s + 90*C*D1*Ddd*f**2 + 1080*C*Dd**2*f**2*r**2 + 3360*C*Dd**2*f**2*r*s - 2220*C*Dd**2*f**2*r - 840*C*Dd**2*f**2*s + 560*C*Dd**2*f**2 - 24*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 60*D1**2*f*fd*r**2 + 336*D1**2*f*fd*r*s - 136*D1**2*f*fd*r + 16*D1**2*f*fd*s - 16*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 348*D1**2*f*fdd*r*s + 134*D1**2*f*fdd*r - 20*D1**2*f*fdd*s + 20*D1**2*f*fdd - 90*D1**2*fd**2*r**2 - 348*D1**2*fd**2*r*s + 134*D1**2*fd**2*r - 20*D1**2*fd**2*s + 20*D1**2*fd**2 + 120*D1*Dd*f**2*r**2 + 672*D1*Dd*f**2*r*s - 396*D1*Dd*f**2*r - 168*D1*Dd*f**2*s + 30*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 2784*D1*Dd*f*fd*r*s + 1412*D1*Dd*f*fd*r + 268*D1*Dd*f*fd*s - 94*D1*Dd*f*fd - 180*D1*Ddd*f**2*r**2 - 696*D1*Ddd*f**2*r*s + 438*D1*Ddd*f**2*r + 174*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 + 4*D1*bd1*(2*C - 1)*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 540*Dd**2*f**2*r**2 - 2088*Dd**2*f**2*r*s + 1314*Dd**2*f**2*r + 522*Dd**2*f**2*s - 348*Dd**2*f**2) + f*(-792*D1**2*bd1**2*(2*C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(10*C*(9*r**2 + 28*r*s - 26*r - 32*s + 13) - 45*r**2 - 174*r*s + 130*r + 194*s - 65) - 5*D1**2*(f*(2*fd*(4*C*(225*r**2 + 633*r*s - 361*r - 211*s + 75) - 450*r**2 - 1533*r*s + 811*r + 511*s - 150) + fdd*(-2*C*(1143*r**2 + 2652*r*s - 1646*r - 884*s + 381) + 1143*r**2 + 3216*r*s - 1834*r - 1072*s + 381)) + 2*fd**2*(-2*C*(1143*r**2 + 2652*r*s - 1646*r - 884*s + 442) + 1143*r**2 + 3216*r*s - 1834*r - 1072*s + 536)) - 66*D1*bd1*(D1*(f*(2*C*(15*r**2 + 68*r*s - 46*r - 76*s + 23) - 15*r**2 - 84*r*s + 46*r + 92*s - 23) + fd*(-20*C*(9*r**2 + 28*r*s - 18*r - 15*s + 8) + 90*r**2 + 348*r*s - 197*r - 184*s + 97)) + Dd*f*(-10*C*(36*r**2 + 112*r*s - 89*r - 78*s + 45) + 180*r**2 + 696*r*s - 479*r - 475*s + 259)) - 5*D1*f*(2*Dd*(f*(4*C*(300*r**2 + 844*r*s - 572*r - 211*s + 75) - 600*r**2 - 2044*r*s + 1322*r + 511*s - 150) + fd*(-2*C*(4572*r**2 + 10608*r*s - 7087*r - 3094*s + 1707) + 4572*r**2 + 12864*r*s - 8027*r - 3752*s + 1989)) + Ddd*f*(-2*C*(1524*r**2 + 3536*r*s - 2530*r - 884*s + 381) + 1524*r**2 + 4288*r*s - 2906*r - 1072*s + 381)) - 10*Dd**2*f**2*(-2*C*(2286*r**2 + 5304*r*s - 3795*r - 1326*s + 884) + 2286*r**2 + 6432*r*s - 4359*r - 1608*s + 1072)))/(693*d**2*k3**4) - 4*D1**2*Pk3*Pkd1*ct**2*k1*k2**4*st**2*(1287*D1**2*K*bdd1*f**2*r**2 + 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*r - 429*D1**2*bd1**2*f*(2*r - 1)*(-3*K + 8*f + 2)*(r + s - 1) + 1300*D1**2*bdd1*f**3*r**2 + 1300*D1**2*bdd1*f**3*r*s - 5200*D1**2*bdd1*f**3*r - 3900*D1**2*bdd1*f**3*s + 3900*D1**2*bdd1*f**3 - 858*D1**2*bdd1*f**2*r**2 - 858*D1**2*bdd1*f**2*r*s + 858*D1**2*bdd1*f**2*r - 2574*D1**2*bdd1*f*g2*r**2 - 2574*D1**2*bdd1*f*g2*r*s + 5148*D1**2*bdd1*f*g2*r + 2574*D1**2*bdd1*f*g2*s - 2574*D1**2*bdd1*f*g2 - 11820*D1**2*f**3*fd*r**2 - 11820*D1**2*f**3*fd*r*s + 11820*D1**2*f**3*fd*r + 2955*D1**2*f**3*fd*s - 2955*D1**2*f**3*fd + 11760*D1**2*f**3*fdd*r**2 + 11760*D1**2*f**3*fdd*r*s - 11760*D1**2*f**3*fdd*r - 2940*D1**2*f**3*fdd*s + 2940*D1**2*f**3*fdd + 35280*D1**2*f**2*fd**2*r**2 + 35280*D1**2*f**2*fd**2*r*s - 35280*D1**2*f**2*fd**2*r - 8820*D1**2*f**2*fd**2*s + 5880*D1**2*f**2*fd**2 + 4290*D1**2*f**2*gd2*r**2 + 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*r - 2574*D1**2*f**2*gdd2*r**2 - 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*r + 8580*D1**2*f*fd*g2*r**2 + 8580*D1**2*f*fd*g2*r*s - 8580*D1**2*f*fd*g2*r - 4290*D1**2*f*fd*g2*s + 4290*D1**2*f*fd*g2 - 10296*D1**2*f*fd*gd2*r**2 - 10296*D1**2*f*fd*gd2*r*s + 10296*D1**2*f*fd*gd2*r + 2574*D1**2*f*fd*gd2*s - 2574*D1**2*f*fd*gd2 - 5148*D1**2*f*fdd*g2*r**2 - 5148*D1**2*f*fdd*g2*r*s + 5148*D1**2*f*fdd*g2*r + 2574*D1**2*f*fdd*g2*s - 2574*D1**2*f*fdd*g2 - 5148*D1**2*fd**2*g2*r**2 - 5148*D1**2*fd**2*g2*r*s + 5148*D1**2*fd**2*g2*r + 2574*D1**2*fd**2*g2*s - 11820*D1*Dd*f**4*r**2 - 11820*D1*Dd*f**4*r*s + 11820*D1*Dd*f**4*r + 2955*D1*Dd*f**4*s - 2955*D1*Dd*f**4 + 94080*D1*Dd*f**3*fd*r**2 + 94080*D1*Dd*f**3*fd*r*s - 94080*D1*Dd*f**3*fd*r - 23520*D1*Dd*f**3*fd*s + 17640*D1*Dd*f**3*fd + 17160*D1*Dd*f**2*g2*r**2 + 17160*D1*Dd*f**2*g2*r*s - 17160*D1*Dd*f**2*g2*r - 4290*D1*Dd*f**2*g2*s + 4290*D1*Dd*f**2*g2 - 20592*D1*Dd*f**2*gd2*r**2 - 20592*D1*Dd*f**2*gd2*r*s + 20592*D1*Dd*f**2*gd2*r + 2574*D1*Dd*f**2*gd2*s - 2574*D1*Dd*f**2*gd2 - 41184*D1*Dd*f*fd*g2*r**2 - 41184*D1*Dd*f*fd*g2*r*s + 41184*D1*Dd*f*fd*g2*r + 15444*D1*Dd*f*fd*g2*s - 10296*D1*Dd*f*fd*g2 + 11760*D1*Ddd*f**4*r**2 + 11760*D1*Ddd*f**4*r*s - 11760*D1*Ddd*f**4*r - 2940*D1*Ddd*f**4*s + 2940*D1*Ddd*f**4 - 10296*D1*Ddd*f**2*g2*r**2 - 10296*D1*Ddd*f**2*g2*r*s + 10296*D1*Ddd*f**2*g2*r + 2574*D1*Ddd*f**2*g2*s - 2574*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(f**3*(68*r - 303)*(r + s - 1) - 5*f**2*(20*fd*(6*r**2 + 6*r*(s - 2) - 7*s + 4) - r*(33*K - 22)*(r + s - 1)) - 33*f*(fd*(3*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + (26*g2*(r - 1) + 2*gd2*(3 - 6*r))*(r + s - 1)) + 198*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-100*f**2*(8*r**2 + 4*r*(2*s - 5) - 13*s + 10) - 33*f*(3*K - 2)*(8*r**2 + 8*r*(s - 1) - s + 1) + 198*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 35280*Dd**2*f**4*r**2 + 35280*Dd**2*f**4*r*s - 35280*Dd**2*f**4*r - 8820*Dd**2*f**4*s + 5880*Dd**2*f**4 - 30888*Dd**2*f**2*g2*r**2 - 30888*Dd**2*f**2*g2*r*s + 30888*Dd**2*f**2*g2*r + 7722*Dd**2*f**2*g2*s - 5148*Dd**2*f**2*g2 + 143*b1**2*(D1**2*r*(3*f*(11*fd - 8*fdd)*(2*r + 2*s - 1) - 24*fd**2*(2*r + 2*s - 1) - 13*fd*(3*K - 2)*(r + s) + 3*fdd*(3*K - 2)*(r + s)) + D1*(Dd*(33*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-24*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (26 - 39*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*fd*(3*K - 2)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-3*K + 8*f + 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-3*K + 8*f + 2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-330*D1**2*K*f*fd*r**2 - 330*D1**2*K*f*fd*r*s + 330*D1**2*K*f*fd*r + 165*D1**2*K*f*fd*s - 165*D1**2*K*f*fd + 198*D1**2*K*f*fdd*r**2 + 198*D1**2*K*f*fdd*r*s - 198*D1**2*K*f*fdd*r - 99*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 198*D1**2*K*fd**2*r**2 + 198*D1**2*K*fd**2*r*s - 198*D1**2*K*fd**2*r - 99*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(2*r - 1)*(-3*K + 8*f + 2)*(r + s - 1) - 204*D1**2*f**2*fd*r**2 - 204*D1**2*f**2*fd*r*s - 99*D1**2*f**2*fd*r - 235*D1**2*f**2*fd*s + 235*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s + 200*D1**2*f**2*fdd*s - 200*D1**2*f**2*fdd + 600*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s + 400*D1**2*f*fd**2*s - 200*D1**2*f*fd**2 + 220*D1**2*f*fd*r**2 + 220*D1**2*f*fd*r*s - 220*D1**2*f*fd*r - 110*D1**2*f*fd*s + 110*D1**2*f*fd - 132*D1**2*f*fdd*r**2 - 132*D1**2*f*fdd*r*s + 132*D1**2*f*fdd*r + 66*D1**2*f*fdd*s - 66*D1**2*f*fdd + 858*D1**2*f*gd2*r**2 + 858*D1**2*f*gd2*r*s - 858*D1**2*f*gd2*r - 198*D1**2*f*gdd2*r**2 - 198*D1**2*f*gdd2*r*s + 198*D1**2*f*gdd2*r - 132*D1**2*fd**2*r**2 - 132*D1**2*fd**2*r*s + 132*D1**2*fd**2*r + 66*D1**2*fd**2*s + 858*D1**2*fd*g2*r**2 + 858*D1**2*fd*g2*r*s - 396*D1**2*fd*gd2*r**2 - 396*D1**2*fd*gd2*r*s + 198*D1**2*fd*gd2*r - 198*D1**2*fdd*g2*r**2 - 198*D1**2*fdd*g2*r*s - 660*D1*Dd*K*f**2*r**2 - 660*D1*Dd*K*f**2*r*s + 660*D1*Dd*K*f**2*r + 165*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 1584*D1*Dd*K*f*fd*r**2 + 1584*D1*Dd*K*f*fd*r*s - 1584*D1*Dd*K*f*fd*r - 594*D1*Dd*K*f*fd*s + 396*D1*Dd*K*f*fd - 272*D1*Dd*f**3*r**2 - 272*D1*Dd*f**3*r*s + 272*D1*Dd*f**3*r + 68*D1*Dd*f**3*s - 68*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 1200*D1*Dd*f**2*fd*r + 500*D1*Dd*f**2*fd*s - 400*D1*Dd*f**2*fd + 440*D1*Dd*f**2*r**2 + 440*D1*Dd*f**2*r*s - 440*D1*Dd*f**2*r - 110*D1*Dd*f**2*s + 110*D1*Dd*f**2 - 1056*D1*Dd*f*fd*r**2 - 1056*D1*Dd*f*fd*r*s + 1056*D1*Dd*f*fd*r + 396*D1*Dd*f*fd*s - 264*D1*Dd*f*fd + 3432*D1*Dd*f*g2*r**2 + 3432*D1*Dd*f*g2*r*s - 3432*D1*Dd*f*g2*r - 858*D1*Dd*f*g2*s + 858*D1*Dd*f*g2 - 1584*D1*Dd*f*gd2*r**2 - 1584*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r + 198*D1*Dd*f*gd2*s - 198*D1*Dd*f*gd2 - 1584*D1*Dd*fd*g2*r**2 - 1584*D1*Dd*fd*g2*r*s + 792*D1*Dd*fd*g2*r + 198*D1*Dd*fd*g2*s + 396*D1*Ddd*K*f**2*r**2 + 396*D1*Ddd*K*f**2*r*s - 396*D1*Ddd*K*f**2*r - 99*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 + 400*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 400*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s + 100*D1*Ddd*f**3 - 264*D1*Ddd*f**2*r**2 - 264*D1*Ddd*f**2*r*s + 264*D1*Ddd*f**2*r + 66*D1*Ddd*f**2*s - 66*D1*Ddd*f**2 - 792*D1*Ddd*f*g2*r**2 - 792*D1*Ddd*f*g2*r*s + 792*D1*Ddd*f*g2*r + 198*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(33*f**2*(2*r - 1)*(r + s - 1) + f*(-24*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (39*K - 26)*(2*r - 1)*(r + s - 1)) + 3*fd*(3*K - 2)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-3*K + 8*f + 2)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1188*Dd**2*K*f**2*r**2 + 1188*Dd**2*K*f**2*r*s - 1188*Dd**2*K*f**2*r - 297*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 + 1200*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 1200*Dd**2*f**3*r - 300*Dd**2*f**3*s + 200*Dd**2*f**3 - 792*Dd**2*f**2*r**2 - 792*Dd**2*f**2*r*s + 792*Dd**2*f**2*r + 198*Dd**2*f**2*s - 132*Dd**2*f**2 - 2376*Dd**2*f*g2*r**2 - 2376*Dd**2*f*g2*r*s + 2376*Dd**2*f*g2*r + 594*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(3003*d**2*k3**6) + 2*D1**2*Pk3*Pkd1*ct**2*k1*k2**2*st**2*(11*b1**2*(D1**2*r*(fd*(70*C - 57) + fdd*(11 - 14*C))*(r + s - 1) + D1*(Dd*(f*(70*C - 57)*(4*r**2 + 4*r*(s - 1) - s + 1) - fd*(14*C - 11)*(8*r**2 + 8*r*(s - 1) - s + 1)) - Ddd*f*(14*C - 11)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(14*C - 11)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-154*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s + 36*C*D1**2*f*fd*r - 22*C*D1**2*f*fd*s + 22*C*D1**2*f*fd + 152*C*D1**2*f*fdd*r**2 + 152*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 14*C*D1**2*f*fdd*s - 14*C*D1**2*f*fdd + 152*C*D1**2*fd**2*r**2 + 152*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 14*C*D1**2*fd**2*s - 14*C*D1**2*fd**2 - 308*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 314*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s - 77*C*D1*Dd*f**2 + 1216*C*D1*Dd*f*fd*r**2 + 1216*C*D1*Dd*f*fd*r*s - 800*C*D1*Dd*f*fd*r - 96*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 304*C*D1*Ddd*f**2*r**2 + 304*C*D1*Ddd*f**2*r*s - 304*C*D1*Ddd*f**2*r - 76*C*D1*Ddd*f**2*s + 76*C*D1*Ddd*f**2 + 912*C*Dd**2*f**2*r**2 + 912*C*Dd**2*f**2*r*s - 912*C*Dd**2*f**2*r - 228*C*Dd**2*f**2*s + 152*C*Dd**2*f**2 - D1**2*bdd1*f*(14*C - 11)*(2*r**2 + 2*r*(s - 1) - s + 1) + 114*D1**2*f*fd*r**2 + 126*D1**2*f*fd*r*s - 29*D1**2*f*fd*r + 17*D1**2*f*fd*s - 17*D1**2*f*fd - 110*D1**2*f*fdd*r**2 - 122*D1**2*f*fdd*r*s + 39*D1**2*f*fdd*r - 11*D1**2*f*fdd*s + 11*D1**2*f*fdd - 110*D1**2*fd**2*r**2 - 122*D1**2*fd**2*r*s + 39*D1**2*fd**2*r - 11*D1**2*fd**2*s + 11*D1**2*fd**2 + 228*D1*Dd*f**2*r**2 + 252*D1*Dd*f**2*r*s - 240*D1*Dd*f**2*r - 63*D1*Dd*f**2*s + 57*D1*Dd*f**2 - 880*D1*Dd*f*fd*r**2 - 976*D1*Dd*f*fd*r*s + 620*D1*Dd*f*fd*r + 78*D1*Dd*f*fd*s - 17*D1*Dd*f*fd - 220*D1*Ddd*f**2*r**2 - 244*D1*Ddd*f**2*r*s + 232*D1*Ddd*f**2*r + 61*D1*Ddd*f**2*s - 55*D1*Ddd*f**2 + D1*bd1*(D1*(f*(70*C - 57)*(2*r**2 + 2*r*(s - 1) - s + 1) - fd*(14*C - 11)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd*f*(28*C - 22)*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 660*Dd**2*f**2*r**2 - 732*Dd**2*f**2*r*s + 696*Dd**2*f**2*r + 183*Dd**2*f**2*s - 122*Dd**2*f**2) + f*(-2811*C*D1**2*f*fd*r**2 - 2406*C*D1**2*f*fd*r*s + 2676*C*D1**2*f*fd*r + 802*C*D1**2*f*fd*s - 937*C*D1**2*f*fd + 2742*C*D1**2*f*fdd*r**2 + 2490*C*D1**2*f*fdd*r*s - 2658*C*D1**2*f*fdd*r - 830*C*D1**2*f*fdd*s + 914*C*D1**2*f*fdd + 5484*C*D1**2*fd**2*r**2 + 4980*C*D1**2*fd**2*r*s - 5316*C*D1**2*fd**2*r - 1660*C*D1**2*fd**2*s + 830*C*D1**2*fd**2 - 3748*C*D1*Dd*f**2*r**2 - 3208*C*D1*Dd*f**2*r*s + 3478*C*D1*Dd*f**2*r + 802*C*D1*Dd*f**2*s - 937*C*D1*Dd*f**2 + 21936*C*D1*Dd*f*fd*r**2 + 19920*C*D1*Dd*f*fd*r*s - 21096*C*D1*Dd*f*fd*r - 5810*C*D1*Dd*f*fd*s + 4318*C*D1*Dd*f*fd + 3656*C*D1*Ddd*f**2*r**2 + 3320*C*D1*Ddd*f**2*r*s - 3488*C*D1*Ddd*f**2*r - 830*C*D1*Ddd*f**2*s + 914*C*D1*Ddd*f**2 + 10968*C*Dd**2*f**2*r**2 + 9960*C*Dd**2*f**2*r*s - 10464*C*Dd**2*f**2*r - 2490*C*Dd**2*f**2*s + 1660*C*Dd**2*f**2 - 11*D1**2*bd1**2*(14*C - 11)*(2*r**2 + 2*r*(s - 1) - s) + 11*D1**2*bdd1*f*(2*C*(38*r**2 + 38*r*s - 90*r - 45*s + 45) - 55*r**2 + r*(132 - 61*s) + 72*s - 66) + 2082*D1**2*f*fd*r**2 + 1872*D1**2*f*fd*r*s - 2012*D1**2*f*fd*r - 624*D1**2*f*fd*s + 694*D1**2*f*fd - 1998*D1**2*f*fdd*r**2 - 1992*D1**2*f*fdd*r*s + 1996*D1**2*f*fdd*r + 664*D1**2*f*fdd*s - 666*D1**2*f*fdd - 3996*D1**2*fd**2*r**2 - 3984*D1**2*fd**2*r*s + 3992*D1**2*fd**2*r + 1328*D1**2*fd**2*s - 664*D1**2*fd**2 + 2776*D1*Dd*f**2*r**2 + 2496*D1*Dd*f**2*r*s - 2636*D1*Dd*f**2*r - 624*D1*Dd*f**2*s + 694*D1*Dd*f**2 - 15984*D1*Dd*f*fd*r**2 - 15936*D1*Dd*f*fd*r*s + 15964*D1*Dd*f*fd*r + 4648*D1*Dd*f*fd*s - 3324*D1*Dd*f*fd - 2664*D1*Ddd*f**2*r**2 - 2656*D1*Ddd*f**2*r*s + 2660*D1*Ddd*f**2*r + 664*D1*Ddd*f**2*s - 666*D1*Ddd*f**2 - 11*D1*bd1*(D1*(f*(C*(77*r**2 + 80*r*s - 198*r - 102*s + 99) - 57*r**2 - 63*r*s + 148*r + 80*s - 74) + fd*(-2*C*(152*r**2 + 4*r*(38*s - 51) - 83*s + 45) + 220*r**2 + 244*r*s - 303*r - 133*s + 72)) + Dd*f*(-4*C*(152*r**2 + 8*r*(19*s - 32) - 109*s + 90) + 440*r**2 + 8*r*(61*s - 95) - 349*s + 276)) - 7992*Dd**2*f**2*r**2 - 7968*Dd**2*f**2*r*s + 7980*Dd**2*f**2*r + 1992*Dd**2*f**2*s - 1328*Dd**2*f**2))/(231*d**2*k3**4) - D1**2*Pk3*Pkd1*ct**2*k1*k2**2*(-138996*D1**2*K*bd1**2*f*r**2 - 133848*D1**2*K*bd1**2*f*r*s + 267696*D1**2*K*bd1**2*f*r + 97812*D1**2*K*bd1**2*f*s - 97812*D1**2*K*bd1**2*f + 66924*D1**2*K*bd1*f**2*r**2 + 72072*D1**2*K*bd1*f**2*r*s - 72072*D1**2*K*bd1*f**2*r - 380952*D1**2*K*bd1*f*fd*r**2 - 329472*D1**2*K*bd1*f*fd*r*s + 355212*D1**2*K*bd1*f*fd*r + 82368*D1**2*K*bd1*f*fd*s - 82368*D1**2*K*bd1*f*fd - 95238*D1**2*K*bdd1*f**2*r**2 - 82368*D1**2*K*bdd1*f**2*r*s + 82368*D1**2*K*bdd1*f**2*r + 98670*D1**2*bd1**2*f**2*r**2 + 126984*D1**2*bd1**2*f**2*r*s - 187902*D1**2*bd1**2*f**2*r - 80652*D1**2*bd1**2*f**2*s + 72072*D1**2*bd1**2*f**2 + 91806*D1**2*bd1**2*f*r**2 + 120120*D1**2*bd1**2*f*r*s - 193050*D1**2*bd1**2*f*r - 80652*D1**2*bd1**2*f*s + 80652*D1**2*bd1**2*f - 144144*D1**2*bd1**2*g2*r**2 - 144144*D1**2*bd1**2*g2*r*s + 144144*D1**2*bd1**2*g2*r + 72072*D1**2*bd1**2*g2*s - 61776*D1**2*bd1*bd2*f*r**2 - 61776*D1**2*bd1*bd2*f*r*s + 92664*D1**2*bd1*bd2*f*r + 30888*D1**2*bd1*bd2*f*s - 30888*D1**2*bd1*bd2*f - 39000*D1**2*bd1*f**3*r**2 - 23920*D1**2*bd1*f**3*r*s + 41470*D1**2*bd1*f**3*r - 38610*D1**2*bd1*f**3*s + 7540*D1**2*bd1*f**3 + 297180*D1**2*bd1*f**2*fd*r**2 + 174720*D1**2*bd1*f**2*fd*r*s - 237380*D1**2*bd1*f**2*fd*r + 48100*D1**2*bd1*f**2*fd*s - 16770*D1**2*bd1*f**2*fd - 45474*D1**2*bd1*f**2*r**2 - 58344*D1**2*bd1*f**2*r*s + 58344*D1**2*bd1*f**2*r + 245388*D1**2*bd1*f*fd*r**2 + 271128*D1**2*bd1*f*fd*r*s - 258258*D1**2*bd1*f*fd*r - 67782*D1**2*bd1*f*fd*s + 67782*D1**2*bd1*f*fd - 61776*D1**2*bd1*f*g2*r**2 - 123552*D1**2*bd1*f*g2*r*s + 226512*D1**2*bd1*f*g2*r + 175032*D1**2*bd1*f*g2*s - 113256*D1**2*bd1*f*g2 + 277992*D1**2*bd1*f*gd2*r**2 + 267696*D1**2*bd1*f*gd2*r*s - 535392*D1**2*bd1*f*gd2*r - 195624*D1**2*bd1*f*gd2*s + 195624*D1**2*bd1*f*gd2 + 277992*D1**2*bd1*fd*g2*r**2 + 267696*D1**2*bd1*fd*g2*r*s - 277992*D1**2*bd1*fd*g2*r - 133848*D1**2*bd1*fd*g2*s + 20592*D1**2*bd2*f**2*r**2 + 20592*D1**2*bd2*f**2*r*s - 20592*D1**2*bd2*f**2*r - 102960*D1**2*bd2*f*fd*r**2 - 102960*D1**2*bd2*f*fd*r*s + 102960*D1**2*bd2*f*fd*r + 25740*D1**2*bd2*f*fd*s - 25740*D1**2*bd2*f*fd + 49530*D1**2*bdd1*f**3*r**2 + 29120*D1**2*bdd1*f**3*r*s - 40040*D1**2*bdd1*f**3*r + 38610*D1**2*bdd1*f**3*s - 10205*D1**2*bdd1*f**3 + 61347*D1**2*bdd1*f**2*r**2 + 67782*D1**2*bdd1*f**2*r*s - 67782*D1**2*bdd1*f**2*r + 138996*D1**2*bdd1*f*g2*r**2 + 133848*D1**2*bdd1*f*g2*r*s - 401544*D1**2*bdd1*f*g2*r - 195624*D1**2*bdd1*f*g2*s + 200772*D1**2*bdd1*f*g2 - 25740*D1**2*bdd2*f**2*r**2 - 25740*D1**2*bdd2*f**2*r*s + 25740*D1**2*bdd2*f**2*r + 32200*D1**2*f**3*fd*r**2 + 131040*D1**2*f**3*fd*r*s - 81620*D1**2*f**3*fd*r - 32760*D1**2*f**3*fd*s + 8050*D1**2*f**3*fd - 37940*D1**2*f**3*fdd*r**2 - 131040*D1**2*f**3*fdd*r*s + 84490*D1**2*f**3*fdd*r + 32760*D1**2*f**3*fdd*s - 9485*D1**2*f**3*fdd - 113820*D1**2*f**2*fd**2*r**2 - 393120*D1**2*f**2*fd**2*r*s + 253470*D1**2*f**2*fd**2*r + 98280*D1**2*f**2*fd**2*s - 65520*D1**2*f**2*fd**2 - 133848*D1**2*f**2*gd2*r**2 - 144144*D1**2*f**2*gd2*r*s + 144144*D1**2*f**2*gd2*r + 190476*D1**2*f**2*gdd2*r**2 + 164736*D1**2*f**2*gdd2*r*s - 164736*D1**2*f**2*gdd2*r - 267696*D1**2*f*fd*g2*r**2 - 288288*D1**2*f*fd*g2*r*s + 267696*D1**2*f*fd*g2*r + 144144*D1**2*f*fd*g2*s - 133848*D1**2*f*fd*g2 + 761904*D1**2*f*fd*gd2*r**2 + 658944*D1**2*f*fd*gd2*r*s - 710424*D1**2*f*fd*gd2*r - 164736*D1**2*f*fd*gd2*s + 164736*D1**2*f*fd*gd2 + 380952*D1**2*f*fdd*g2*r**2 + 329472*D1**2*f*fdd*g2*r*s - 380952*D1**2*f*fdd*g2*r - 164736*D1**2*f*fdd*g2*s + 190476*D1**2*f*fdd*g2 + 380952*D1**2*fd**2*g2*r**2 + 329472*D1**2*fd**2*g2*r*s - 380952*D1**2*fd**2*g2*r - 164736*D1**2*fd**2*g2*s - 761904*D1*Dd*K*bd1*f**2*r**2 - 658944*D1*Dd*K*bd1*f**2*r*s + 684684*D1*Dd*K*bd1*f**2*r + 82368*D1*Dd*K*bd1*f**2*s - 82368*D1*Dd*K*bd1*f**2 + 396240*D1*Dd*bd1*f**3*r**2 + 232960*D1*Dd*bd1*f**3*r*s - 317460*D1*Dd*bd1*f**3*r + 125320*D1*Dd*bd1*f**3*s - 37180*D1*Dd*bd1*f**3 + 490776*D1*Dd*bd1*f**2*r**2 + 542256*D1*Dd*bd1*f**2*r*s - 529386*D1*Dd*bd1*f**2*r - 67782*D1*Dd*bd1*f**2*s + 67782*D1*Dd*bd1*f**2 + 1111968*D1*Dd*bd1*f*g2*r**2 + 1070784*D1*Dd*bd1*f*g2*r*s - 2151864*D1*Dd*bd1*f*g2*r - 916344*D1*Dd*bd1*f*g2*s + 792792*D1*Dd*bd1*f*g2 - 205920*D1*Dd*bd2*f**2*r**2 - 205920*D1*Dd*bd2*f**2*r*s + 205920*D1*Dd*bd2*f**2*r + 25740*D1*Dd*bd2*f**2*s - 25740*D1*Dd*bd2*f**2 + 32200*D1*Dd*f**4*r**2 + 131040*D1*Dd*f**4*r*s - 81620*D1*Dd*f**4*r - 32760*D1*Dd*f**4*s + 8050*D1*Dd*f**4 - 303520*D1*Dd*f**3*fd*r**2 - 1048320*D1*Dd*f**3*fd*r*s + 675920*D1*Dd*f**3*fd*r + 262080*D1*Dd*f**3*fd*s - 150010*D1*Dd*f**3*fd - 535392*D1*Dd*f**2*g2*r**2 - 576576*D1*Dd*f**2*g2*r*s + 555984*D1*Dd*f**2*g2*r + 144144*D1*Dd*f**2*g2*s - 133848*D1*Dd*f**2*g2 + 1523808*D1*Dd*f**2*gd2*r**2 + 1317888*D1*Dd*f**2*gd2*r*s - 1369368*D1*Dd*f**2*gd2*r - 164736*D1*Dd*f**2*gd2*s + 164736*D1*Dd*f**2*gd2 + 3047616*D1*Dd*f*fd*g2*r**2 + 2635776*D1*Dd*f*fd*g2*r*s - 2944656*D1*Dd*f*fd*g2*r - 988416*D1*Dd*f*fd*g2*s + 710424*D1*Dd*f*fd*g2 - 37940*D1*Ddd*f**4*r**2 - 131040*D1*Ddd*f**4*r*s + 84490*D1*Ddd*f**4*r + 32760*D1*Ddd*f**4*s - 9485*D1*Ddd*f**4 + 761904*D1*Ddd*f**2*g2*r**2 + 658944*D1*Ddd*f**2*g2*r*s - 710424*D1*Ddd*f**2*g2*r - 164736*D1*Ddd*f**2*g2*s + 190476*D1*Ddd*f**2*g2 - 113820*Dd**2*f**4*r**2 - 393120*Dd**2*f**4*r*s + 253470*Dd**2*f**4*r + 98280*Dd**2*f**4*s - 65520*Dd**2*f**4 + 2285712*Dd**2*f**2*g2*r**2 + 1976832*Dd**2*f**2*g2*r*s - 2131272*Dd**2*f**2*g2*r - 494208*Dd**2*f**2*g2*s + 329472*Dd**2*f**2*g2 + 1716*b1**3*(2*D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(2*Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1) - (21*K - 14)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-21*K + 12*f + 14)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-21*K + 12*f + 14)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 429*b1**2*(72*D1**2*K*fd*r**2 + 144*D1**2*K*fd*r*s + 120*D1**2*K*fd*r + 60*D1**2*K*fd*s - 60*D1**2*K*fd - 162*D1**2*K*fdd*r**2 - 156*D1**2*K*fdd*r*s - 144*D1**2*K*fdd*r - 72*D1**2*K*fdd*s + 72*D1**2*K*fdd - 4*D1**2*bdd1*(-21*K + 12*f + 14)*(3*r**2 + 3*r*(s - 1) - s + 1) - 148*D1**2*f*fd*r**2 - 280*D1**2*f*fd*r*s + 92*D1**2*f*fd*r - 32*D1**2*f*fd*s + 32*D1**2*f*fd + 230*D1**2*f*fdd*r**2 + 296*D1**2*f*fdd*r*s - 88*D1**2*f*fdd*r + 40*D1**2*f*fdd*s - 40*D1**2*f*fdd + 230*D1**2*fd**2*r**2 + 296*D1**2*fd**2*r*s - 88*D1**2*fd**2*r + 40*D1**2*fd**2*s - 40*D1**2*fd**2 - 60*D1**2*fd*r**2 - 126*D1**2*fd*r*s - 80*D1**2*fd*r - 40*D1**2*fd*s + 40*D1**2*fd + 107*D1**2*fdd*r**2 + 140*D1**2*fdd*r*s + 96*D1**2*fdd*r + 48*D1**2*fdd*s - 48*D1**2*fdd + 336*D1**2*gd2*r**2 + 336*D1**2*gd2*r*s - 336*D1**2*gd2*r - 168*D1**2*gdd2*r**2 - 168*D1**2*gdd2*r*s + 168*D1**2*gdd2*r + 288*D1*Dd*K*f*r**2 + 576*D1*Dd*K*f*r*s - 432*D1*Dd*K*f*r - 144*D1*Dd*K*f*s + 72*D1*Dd*K*f - 1296*D1*Dd*K*fd*r**2 - 1248*D1*Dd*K*fd*r*s + 60*D1*Dd*K*fd*r - 132*D1*Dd*K*fd*s + 288*D1*Dd*K*fd - 296*D1*Dd*f**2*r**2 - 560*D1*Dd*f**2*r*s + 428*D1*Dd*f**2*r + 140*D1*Dd*f**2*s - 74*D1*Dd*f**2 + 1840*D1*Dd*f*fd*r**2 + 2368*D1*Dd*f*fd*r*s - 1404*D1*Dd*f*fd*r - 136*D1*Dd*f*fd*s + 8*D1*Dd*f*fd - 240*D1*Dd*f*r**2 - 504*D1*Dd*f*r*s + 372*D1*Dd*f*r + 126*D1*Dd*f*s - 60*D1*Dd*f + 856*D1*Dd*fd*r**2 + 1120*D1*Dd*fd*r*s - 110*D1*Dd*fd*r + 52*D1*Dd*fd*s - 192*D1*Dd*fd + 1344*D1*Dd*g2*r**2 + 1344*D1*Dd*g2*r*s - 1344*D1*Dd*g2*r - 336*D1*Dd*g2*s + 336*D1*Dd*g2 - 1344*D1*Dd*gd2*r**2 - 1344*D1*Dd*gd2*r*s + 1344*D1*Dd*gd2*r + 168*D1*Dd*gd2*s - 168*D1*Dd*gd2 - 648*D1*Ddd*K*f*r**2 - 624*D1*Ddd*K*f*r*s + 636*D1*Ddd*K*f*r + 156*D1*Ddd*K*f*s - 162*D1*Ddd*K*f + 460*D1*Ddd*f**2*r**2 + 592*D1*Ddd*f**2*r*s - 526*D1*Ddd*f**2*r - 148*D1*Ddd*f**2*s + 115*D1*Ddd*f**2 + 428*D1*Ddd*f*r**2 + 560*D1*Ddd*f*r*s - 494*D1*Ddd*f*r - 140*D1*Ddd*f*s + 107*D1*Ddd*f - 672*D1*Ddd*g2*r**2 - 672*D1*Ddd*g2*r*s + 672*D1*Ddd*g2*r + 168*D1*Ddd*g2*s - 168*D1*Ddd*g2 + 4*D1*bd1*(2*D1*(5*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 6*fd*(6*r**2 + 6*r*(s - 1) - s + 1) - (21*K - 14)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-21*K + 12*f + 14)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 1944*Dd**2*K*f*r**2 - 1872*Dd**2*K*f*r*s + 1908*Dd**2*K*f*r + 468*Dd**2*K*f*s - 312*Dd**2*K*f + 1380*Dd**2*f**2*r**2 + 1776*Dd**2*f**2*r*s - 1578*Dd**2*f**2*r - 444*Dd**2*f**2*s + 296*Dd**2*f**2 + 1284*Dd**2*f*r**2 + 1680*Dd**2*f*r*s - 1482*Dd**2*f*r - 420*Dd**2*f*s + 280*Dd**2*f - 2016*Dd**2*g2*r**2 - 2016*Dd**2*g2*r*s + 2016*Dd**2*g2*r + 504*Dd**2*g2*s - 336*Dd**2*g2) - 13*b1*(-10296*D1**2*K*f*fd*r**2 - 11088*D1**2*K*f*fd*r*s + 10296*D1**2*K*f*fd*r + 5544*D1**2*K*f*fd*s - 5148*D1**2*K*f*fd + 14652*D1**2*K*f*fdd*r**2 + 12672*D1**2*K*f*fdd*r*s - 14652*D1**2*K*f*fdd*r - 6336*D1**2*K*f*fdd*s + 7326*D1**2*K*f*fdd + 14652*D1**2*K*fd**2*r**2 + 12672*D1**2*K*fd**2*r*s - 14652*D1**2*K*fd**2*r - 6336*D1**2*K*fd**2*s - 1980*D1**2*b2*fd*r**2 - 1980*D1**2*b2*fd*r*s + 2376*D1**2*b2*fdd*r**2 + 2376*D1**2*b2*fdd*r*s + 132*D1**2*bd1**2*(-21*K + 12*f + 14)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 1980*D1**2*bd2*f*r**2 - 1980*D1**2*bd2*f*r*s + 1980*D1**2*bd2*f*r + 4752*D1**2*bd2*fd*r**2 + 4752*D1**2*bd2*fd*r*s - 2376*D1**2*bd2*fd*r - 33*D1**2*bdd1*(f**2*(230*r**2 + r*(296*s - 438) - 188*s + 155) + f*(-6*K*(54*r**2 + 52*r*(s - 2) - 38*s + 39) + 214*r**2 + 280*r*s - 450*r - 188*s + 155) - 168*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 2376*D1**2*bdd2*f*r**2 + 2376*D1**2*bdd2*f*r*s - 2376*D1**2*bdd2*f*r + 9000*D1**2*f**2*fd*r**2 + 5520*D1**2*f**2*fd*r*s - 6490*D1**2*f**2*fd*r - 4810*D1**2*f**2*fd*s + 3580*D1**2*f**2*fd - 11430*D1**2*f**2*fdd*r**2 - 6720*D1**2*f**2*fdd*r*s + 9020*D1**2*f**2*fdd*r + 5210*D1**2*f**2*fdd*s - 4595*D1**2*f**2*fdd - 22860*D1**2*f*fd**2*r**2 - 13440*D1**2*f*fd**2*r*s + 18040*D1**2*f*fd**2*r + 10420*D1**2*f*fd**2*s - 5770*D1**2*f*fd**2 + 6996*D1**2*f*fd*r**2 + 8976*D1**2*f*fd*r*s - 6996*D1**2*f*fd*r - 4488*D1**2*f*fd*s + 3498*D1**2*f*fd - 9438*D1**2*f*fdd*r**2 - 10428*D1**2*f*fdd*r*s + 9438*D1**2*f*fdd*r + 5214*D1**2*f*fdd*s - 4719*D1**2*f*fdd + 4752*D1**2*f*gd2*r**2 + 9504*D1**2*f*gd2*r*s - 9504*D1**2*f*gd2*r - 10692*D1**2*f*gdd2*r**2 - 10296*D1**2*f*gdd2*r*s + 10296*D1**2*f*gdd2*r - 9438*D1**2*fd**2*r**2 - 10428*D1**2*fd**2*r*s + 9438*D1**2*fd**2*r + 5214*D1**2*fd**2*s + 4752*D1**2*fd*g2*r**2 + 9504*D1**2*fd*g2*r*s + 7920*D1**2*fd*g2*r + 3960*D1**2*fd*g2*s - 3960*D1**2*fd*g2 - 21384*D1**2*fd*gd2*r**2 - 20592*D1**2*fd*gd2*r*s + 792*D1**2*fd*gd2*r - 4752*D1**2*fd*gd2*s + 4752*D1**2*fd*gd2 - 10692*D1**2*fdd*g2*r**2 - 10296*D1**2*fdd*g2*r*s - 9504*D1**2*fdd*g2*r - 4752*D1**2*fdd*g2*s + 4752*D1**2*fdd*g2 - 20592*D1*Dd*K*f**2*r**2 - 22176*D1*Dd*K*f**2*r*s + 21384*D1*Dd*K*f**2*r + 5544*D1*Dd*K*f**2*s - 5148*D1*Dd*K*f**2 + 117216*D1*Dd*K*f*fd*r**2 + 101376*D1*Dd*K*f*fd*r*s - 113256*D1*Dd*K*f*fd*r - 38016*D1*Dd*K*f*fd*s + 27324*D1*Dd*K*f*fd - 7920*D1*Dd*b2*f*r**2 - 7920*D1*Dd*b2*f*r*s + 7920*D1*Dd*b2*f*r + 1980*D1*Dd*b2*f*s - 1980*D1*Dd*b2*f + 19008*D1*Dd*b2*fd*r**2 + 19008*D1*Dd*b2*fd*r*s - 9504*D1*Dd*b2*fd*r - 2376*D1*Dd*b2*fd*s + 19008*D1*Dd*bd2*f*r**2 + 19008*D1*Dd*bd2*f*r*s - 19008*D1*Dd*bd2*f*r - 2376*D1*Dd*bd2*f*s + 2376*D1*Dd*bd2*f + 12000*D1*Dd*f**3*r**2 + 7360*D1*Dd*f**3*r*s - 9680*D1*Dd*f**3*r - 1840*D1*Dd*f**3*s + 3000*D1*Dd*f**3 - 91440*D1*Dd*f**2*fd*r**2 - 53760*D1*Dd*f**2*fd*r*s + 72380*D1*Dd*f**2*fd*r + 27560*D1*Dd*f**2*fd*s - 19440*D1*Dd*f**2*fd + 13992*D1*Dd*f**2*r**2 + 17952*D1*Dd*f**2*r*s - 15972*D1*Dd*f**2*r - 4488*D1*Dd*f**2*s + 3498*D1*Dd*f**2 - 75504*D1*Dd*f*fd*r**2 - 83424*D1*Dd*f*fd*r*s + 77484*D1*Dd*f*fd*r + 31284*D1*Dd*f*fd*s - 19866*D1*Dd*f*fd + 19008*D1*Dd*f*g2*r**2 + 38016*D1*Dd*f*g2*r*s - 28512*D1*Dd*f*g2*r - 9504*D1*Dd*f*g2*s + 4752*D1*Dd*f*g2 - 85536*D1*Dd*f*gd2*r**2 - 82368*D1*Dd*f*gd2*r*s + 83160*D1*Dd*f*gd2*r + 10296*D1*Dd*f*gd2*s - 10296*D1*Dd*f*gd2 - 85536*D1*Dd*fd*g2*r**2 - 82368*D1*Dd*fd*g2*r*s + 3960*D1*Dd*fd*g2*r - 8712*D1*Dd*fd*g2*s + 19008*D1*Dd*fd*g2 + 29304*D1*Ddd*K*f**2*r**2 + 25344*D1*Ddd*K*f**2*r*s - 27324*D1*Ddd*K*f**2*r - 6336*D1*Ddd*K*f**2*s + 7326*D1*Ddd*K*f**2 + 9504*D1*Ddd*b2*f*r**2 + 9504*D1*Ddd*b2*f*r*s - 9504*D1*Ddd*b2*f*r - 2376*D1*Ddd*b2*f*s + 2376*D1*Ddd*b2*f - 15240*D1*Ddd*f**3*r**2 - 8960*D1*Ddd*f**3*r*s + 12100*D1*Ddd*f**3*r + 2240*D1*Ddd*f**3*s - 3810*D1*Ddd*f**3 - 18876*D1*Ddd*f**2*r**2 - 20856*D1*Ddd*f**2*r*s + 19866*D1*Ddd*f**2*r + 5214*D1*Ddd*f**2*s - 4719*D1*Ddd*f**2 - 42768*D1*Ddd*f*g2*r**2 - 41184*D1*Ddd*f*g2*r*s + 41976*D1*Ddd*f*g2*r + 10296*D1*Ddd*f*g2*s - 10692*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(f**2*(74*r**2 + 28*r*(5*s - 6) - 86*s + 53) + f*(-6*K*(12*r**2 + 24*r*s - 34*r - 17*s + 11) - 2*fd*(230*r**2 + r*(296*s - 263) - 74*s + 42) + 60*r**2 + 126*r*s - 163*r - 83*s + 50) + fd*(6*K*(54*r**2 + 4*r*(13*s - 7) - 7*s - 6) - 214*r**2 + r*(129 - 280*s) + 46*s + 24) - 84*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 84*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd*(f**2*(-920*r**2 - 2*r*(592*s - 701) + 524*s - 407) + f*(12*K*(108*r**2 + 104*r*s - 157*r - 51*s + 45) - 856*r**2 - 1120*r*s + 1394*r + 516*s - 413) + 168*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + 87912*Dd**2*K*f**2*r**2 + 76032*Dd**2*K*f**2*r*s - 81972*Dd**2*K*f**2*r - 19008*Dd**2*K*f**2*s + 12672*Dd**2*K*f**2 + 28512*Dd**2*b2*f*r**2 + 28512*Dd**2*b2*f*r*s - 28512*Dd**2*b2*f*r - 7128*Dd**2*b2*f*s + 4752*Dd**2*b2*f - 45720*Dd**2*f**3*r**2 - 26880*Dd**2*f**3*r*s + 36300*Dd**2*f**3*r + 6720*Dd**2*f**3*s - 4480*Dd**2*f**3 - 56628*Dd**2*f**2*r**2 - 62568*Dd**2*f**2*r*s + 59598*Dd**2*f**2*r + 15642*Dd**2*f**2*s - 10428*Dd**2*f**2 - 128304*Dd**2*f*g2*r**2 - 123552*Dd**2*f*g2*r*s + 125928*Dd**2*f*g2*r + 30888*Dd**2*f*g2*s - 20592*Dd**2*f*g2) + 5148*b2*(-6*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*r + 5*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(r - 1)*(r + s - 1) + 6*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 6*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(9009*d**2*k3**4) + 2*D1**2*Pk3*Pkd1*ct**2*k1*st**2*(-11*b1**2*(4*C - 3)*(D1*Dd*(13*f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(13*fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + 11*b1*(-4*D1*Dd*f*(f*(4*C - 2)*(r*(4*s - 2) - s) - 3*fd*(2*s - 1)*(8*C*r + C - 4*r - 1)) - D1*bd1*(4*C - 3)*(D1*(13*f*s*(1 - 2*r) + 3*fd*(4*r*s - 2*r - s + 1)) + 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(f*fd*(-r*(16*C - 8)*(2*s - 1) + s*(15 - 20*C)) - 3*f*(bdd1*s*(4*C - 3)*(2*r - 1) + fdd*r*(C*(4 - 8*s) + 4*s - 2) + fdd*s*(3 - 4*C)) + 3*fd**2*(4*C*(2*r*s - r + s - 1) - 4*r*s + 2*r - 3*s + 3)) + Ddd*f**2*(12*C - 6)*(r*(4*s - 2) - s)) + Dd**2*f**2*(12*C - 6)*(6*r*(2*s - 1) - 3*s + 2)) + f*(-33*D1**2*bd1**2*s*(4*C - 3)*(2*r - 1) + D1*Dd*f*(-f*(268*C - 173)*(r*(4*s - 2) - s) + fd*(200*C - 125)*(2*r*(12*s - 5) - 7*s + 3)) - 11*D1*bd1*(D1*(f*s*(4*C*(4*r - 9) - 8*r + 23) - 3*fd*(4*C*(4*r*s - r - 3*s + 2) - 8*r*s + 2*r + 7*s - 5)) - 6*Dd*f*(2*C*(8*r*s - 2*r - 9*s + 4) - 8*r*s + 2*r + 11*s - 5)) + D1*(D1*(-f*fd*(268*C - 173)*(r*(3*s - 1) - s) + f*(33*bdd1*s*(4*C*(r - 2) - 2*r + 5) + fdd*(200*C - 125)*(r*(3*s - 1) - s)) + fd**2*(200*C - 125)*(r*(6*s - 2) - 2*s + 1)) + Ddd*f**2*(200*C - 125)*(r*(4*s - 2) - s)) + Dd**2*f**2*(200*C - 125)*(6*r*(2*s - 1) - 3*s + 2)))/(231*d**2*k3**2) + D1**2*Pk3*Pkd1*ct**2*k1*(-33*b1**2*(D1**2*r*(2*fd*(8*C*r + 76*C*(s - 1) - 4*r - 57*s + 57) - 5*fdd*(10*C*r + 32*C*(s - 1) - 5*r - 24*s + 24)) + D1*(2*Dd*(f*(4*C*(8*r**2 + 76*r*s - 42*r - 19*s + 2) - 16*r**2 - 228*r*s + 122*r + 57*s - 4) - 5*fd*(2*C*(20*r**2 + 64*r*s - 53*r - 8*s + 8) - 20*r**2 - 96*r*s + 77*r + 12*s - 12)) - 5*Ddd*f*(2*C*(20*r**2 + 64*r*s - 42*r - 16*s + 5) - 20*r**2 - 96*r*s + 58*r + 24*s - 5)) - 10*Dd**2*f*(2*C*(30*r**2 + r*(96*s - 63) - 24*s + 16) - 30*r**2 - 3*r*(48*s - 29) + 36*s - 24)) - 33*b1*(-32*C*D1**2*f*fd*r*s - 40*C*D1**2*f*fd*r - 128*C*D1**2*f*fd*s + 28*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r*s + 92*C*D1**2*f*fdd*r + 136*C*D1**2*f*fdd*s - 50*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r*s + 92*C*D1**2*fd**2*r + 136*C*D1**2*fd**2*s - 136*C*D1**2*fd**2 - 64*C*D1*Dd*f**2*r*s + 32*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s + 128*C*D1*Dd*f*fd*r*s + 336*C*D1*Dd*f*fd*r + 528*C*D1*Dd*f*fd*s - 364*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r*s - 16*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s + 96*C*Dd**2*f**2*r*s - 48*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s + 16*C*Dd**2*f**2 - 5*D1**2*bdd1*f*(2*C*(10*r**2 + 32*r*s - 10*r - 16*s + 5) - 10*r**2 - 48*r*s + 10*r + 24*s - 5) + 16*D1**2*f*fd*r*s + 20*D1**2*f*fd*r + 96*D1**2*f*fd*s - 14*D1**2*f*fd - 8*D1**2*f*fdd*r*s - 46*D1**2*f*fdd*r - 102*D1**2*f*fdd*s + 25*D1**2*f*fdd - 8*D1**2*fd**2*r*s - 46*D1**2*fd**2*r - 102*D1**2*fd**2*s + 102*D1**2*fd**2 + 32*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 8*D1*Dd*f**2*s - 64*D1*Dd*f*fd*r*s - 168*D1*Dd*f*fd*r - 400*D1*Dd*f*fd*s + 250*D1*Dd*f*fd - 16*D1*Ddd*f**2*r*s + 8*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s + 2*D1*bd1*(D1*(f*(4*C*(4*r**2 + 38*r*s - 4*r - 19*s + 2) - 8*r**2 - 114*r*s + 8*r + 57*s - 4) - 5*fd*(2*C*(10*r**2 + 32*r*s - 21*r - 8*s + 8) - 10*r**2 - 48*r*s + 29*r + 12*s - 12)) - 5*Dd*f*(2*C*(40*r**2 + 128*r*s - 62*r - 48*s + 21) - 40*r**2 - 192*r*s + 78*r + 72*s - 29)) - 48*Dd**2*f**2*r*s + 24*Dd**2*f**2*r + 12*Dd**2*f**2*s - 8*Dd**2*f**2) + f*(330*D1**2*bd1**2*(r**2*(10*C - 5) + r*(2*C*(16*s - 5) - 24*s + 5) + s*(12 - 16*C)) - 33*D1**2*bdd1*f*(2*C*(r*(4*s - 50) - 72*s + 25) + r*(50 - 4*s) + 106*s - 25) + 5*D1**2*(f*(2*fd*(4*C*(87*r**2 + 297*r*s - 157*r - 99*s + 29) - 174*r**2 - 861*r*s + 403*r + 287*s - 58) + fdd*(-2*C*(471*r**2 + 1188*r*s - 710*r - 396*s + 157) + 471*r**2 + 1752*r*s - 898*r - 584*s + 157)) - 2*fd**2*(2*C*(471*r**2 + 1188*r*s - 710*r - 396*s + 198) - 471*r**2 - 1752*r*s + 898*r + 584*s - 292)) + 66*D1*bd1*(D1*(f*(2*C*(4*r*s - 14*r - 36*s + 7) - 4*r*s + 14*r + 52*s - 7) + fd*(C*(-16*r*s + 54*r + 76*s - 72) + 8*r*s - 27*r - 55*s + 53)) + Dd*f*(C*(r*(208 - 32*s) + 292*s - 194) + 8*r*(2*s - 13) - 214*s + 131)) + 5*D1*f*(2*Dd*(f*(4*C*(116*r**2 + 4*r*(99*s - 64) - 99*s + 29) - 232*r**2 - 1148*r*s + 690*r + 287*s - 58) + fd*(-2*C*(1884*r**2 + 4752*r*s - 3079*r - 1386*s + 751) + 1884*r**2 + 7008*r*s - 4019*r - 2044*s + 1033)) + Ddd*f*(-2*C*(628*r**2 + 2*r*(792*s - 553) - 396*s + 157) + 628*r**2 + 2336*r*s - 1482*r - 584*s + 157)) - 10*Dd**2*f**2*(6*C*(314*r**2 + 792*r*s - 553*r - 198*s + 132) - 942*r**2 - 3504*r*s + 2223*r + 876*s - 584)))/(693*d**2*k3**2) + 2*D1**2*Pk3*Pkd1*ct**2*k2**4*st**4*(-66*C*D1**2*b1*f*fdd*r**2 - 66*C*D1**2*b1*fd**2*r**2 - 66*C*D1**2*f**2*fd*r**2 + 44*C*D1**2*f**2*fd*r - 22*C*D1**2*f**2*fd + 33*C*D1**2*f**2*fdd*r**2 - 22*C*D1**2*f**2*fdd*r + 11*C*D1**2*f**2*fdd + 66*C*D1**2*f*fd**2*r**2 - 44*C*D1**2*f*fd**2*r - 528*C*D1*Dd*b1*f*fd*r**2 + 132*C*D1*Dd*b1*f*fd*r - 88*C*D1*Dd*f**3*r**2 + 44*C*D1*Dd*f**3*r - 22*C*D1*Dd*f**3 + 264*C*D1*Dd*f**2*fd*r**2 - 154*C*D1*Dd*f**2*fd*r + 22*C*D1*Dd*f**2*fd - 132*C*D1*Ddd*b1*f**2*r**2 + 66*C*D1*Ddd*b1*f**2*r - 33*C*D1*Ddd*b1*f**2 + 44*C*D1*Ddd*f**3*r**2 - 22*C*D1*Ddd*f**3*r + 11*C*D1*Ddd*f**3 - 396*C*Dd**2*b1*f**2*r**2 + 198*C*Dd**2*b1*f**2*r + 132*C*Dd**2*f**3*r**2 - 66*C*Dd**2*f**3*r + 132*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(C - 1)*(r - 1)**2 + 126*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 104*D1**2*f**2*fd*r - 20*D1**2*f**2*fd*s + 42*D1**2*f**2*fd - 63*D1**2*f**2*fdd*r**2 - 30*D1**2*f**2*fdd*r*s + 52*D1**2*f**2*fdd*r + 10*D1**2*f**2*fdd*s - 21*D1**2*f**2*fdd - 126*D1**2*f*fd**2*r**2 - 60*D1**2*f*fd**2*r*s + 104*D1**2*f*fd**2*r + 20*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 264*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 264*D1*Dd*b1*f**2*r - 66*D1*Dd*b1*f**2*s + 66*D1*Dd*b1*f**2 + 528*D1*Dd*b1*f*fd*r**2 - 132*D1*Dd*b1*f*fd*r + 168*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 124*D1*Dd*f**3*r - 20*D1*Dd*f**3*s + 42*D1*Dd*f**3 - 504*D1*Dd*f**2*fd*r**2 - 240*D1*Dd*f**2*fd*r*s + 394*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd*s - 72*D1*Dd*f**2*fd + 132*D1*Ddd*b1*f**2*r**2 - 66*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2 - 84*D1*Ddd*f**3*r**2 - 40*D1*Ddd*f**3*r*s + 62*D1*Ddd*f**3*r + 10*D1*Ddd*f**3*s - 21*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(D1*f*(r + s - 1) + D1*fd*r*(2 - 2*C) + Dd*f*(-4*C*r + C + 4*r - 1)) + 396*Dd**2*b1*f**2*r**2 - 198*Dd**2*b1*f**2*r - 252*Dd**2*f**3*r**2 - 120*Dd**2*f**3*r*s + 186*Dd**2*f**3*r + 30*Dd**2*f**3*s - 20*Dd**2*f**3)/(231*d**2*k1*k3**4) + D1**2*Pk3*Pkd1*ct**2*k2**4*st**2*(-858*D1**2*bd1**2*f*(2*f*(4*r**2 + r*(4*s - 5) - 2*s + 1) + (2*r - 1)*(r + s - 1)) - 26*D1**2*bdd1*f**2*(5*f*(12*r**2 - 13*r*s + 14*r + 33*s - 12) + 11*r*(-2*K*r + 5*r + 3*s - 3)) - 2*D1**2*(5*f**3*(fd*(948*r**2 + 4*r*(325*s - 281) - 325*s + 237) + fdd*(-864*r**2 - 2*r*(650*s - 541) + 325*s - 216)) + f**2*(-5*fd**2*(2592*r**2 + 6*r*(650*s - 541) - 975*s + 650) + r**2*(-1001*gd2 + 572*gdd2)) - 143*f*(7*fd*g2*(2*r**2 - 2*r + 1) + 8*fd*gd2*r*(1 - 2*r) - 4*fdd*g2*(2*r**2 - 2*r + 1)) + 1144*fd**2*g2*r*(r - 1)) + 13*D1*bd1*f*(D1*(f**2*(240*r**2 - 62*r*s - 50*r + 330*s - 42) - 10*f*fd*(72*r**2 + r*(30 - 78*s) + 79*s - 56) + 11*f*r*(r*(17 - 7*K) + 10*s - 10) + 22*fd*(r**2*(8*K - 20) - 4*r*(K + 3*s - 4) + 3*s - 3) + 154*g2*(r - 1)**2) - 2*Dd*f*(5*f*(96*r**2 + r*(58 - 104*s) + 145*s - 80) - 11*r**2*(16*K - 40) + 44*r*(K + 6*s - 7) - 33*s + 33)) - 2*D1*f*(Dd*(5*f**3*(948*r**2 + 4*r*(325*s - 281) - 325*s + 237) - 20*f**2*fd*(4*r - 1)*(432*r + 650*s - 433) - 143*f*(7*g2*(4*r**2 - 2*r + 1) + 8*gd2*r*(1 - 4*r)) + 1144*fd*g2*(8*r**2 - 6*r + 1)) + Ddd*f*(-5*f**2*(864*r**2 + 2*r*(650*s - 541) - 325*s + 216) + 572*g2*(4*r**2 - 2*r + 1))) - 2*Dd**2*f**2*(-5*f**2*(2592*r**2 + 6*r*(650*s - 541) - 975*s + 650) + 3432*g2*r*(2*r - 1)) + 143*b1**2*(D1**2*r*(6*f*(fd*(10*r + 12*s - 9) - 2*fdd*(4*r + 4*s - 3)) - 12*fd**2*(4*r + 4*s - 3) + fd*(-7*K*r + 33*r + 26*s) - 6*fdd*(r + s)) + D1*(Dd*(6*f**2*(20*r**2 + r*(24*s - 22) - 6*s + 5) + f*(-7*K*(4*r**2 - 2*r + 1) - 12*fd*(8*r - 1)*(4*r + 4*s - 3) + 132*r**2 + 104*r*s - 118*r - 26*s + 33) + 6*fd*(-8*r**2 + r*(4 - 8*s) + s)) - 6*Ddd*f*(4*f + 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(4*f + 1)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-154*D1**2*K*f*fd*r**2 + 154*D1**2*K*f*fd*r - 77*D1**2*K*f*fd + 88*D1**2*K*f*fdd*r**2 - 88*D1**2*K*f*fdd*r + 44*D1**2*K*f*fdd + 88*D1**2*K*fd**2*r**2 - 88*D1**2*K*fd**2*r - 66*D1**2*bdd1*f*(2*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + (2*r - 1)*(r + s - 1)) + 720*D1**2*f**2*fd*r**2 - 186*D1**2*f**2*fd*r*s - 306*D1**2*f**2*fd*r - 268*D1**2*f**2*fd*s + 282*D1**2*f**2*fd - 360*D1**2*f**2*fdd*r**2 + 390*D1**2*f**2*fdd*r*s + 120*D1**2*f**2*fdd*r + 200*D1**2*f**2*fdd*s - 240*D1**2*f**2*fdd - 720*D1**2*f*fd**2*r**2 + 780*D1**2*f*fd**2*r*s + 240*D1**2*f*fd**2*r + 400*D1**2*f*fd**2*s - 300*D1**2*f*fd**2 + 374*D1**2*f*fd*r**2 + 220*D1**2*f*fd*r*s - 374*D1**2*f*fd*r - 110*D1**2*f*fd*s + 187*D1**2*f*fd - 220*D1**2*f*fdd*r**2 - 132*D1**2*f*fdd*r*s + 220*D1**2*f*fdd*r + 66*D1**2*f*fdd*s - 110*D1**2*f*fdd + 154*D1**2*f*gd2*r**2 - 220*D1**2*fd**2*r**2 - 132*D1**2*fd**2*r*s + 220*D1**2*fd**2*r + 66*D1**2*fd**2*s + 154*D1**2*fd*g2*r**2 - 308*D1*Dd*K*f**2*r**2 + 154*D1*Dd*K*f**2*r - 77*D1*Dd*K*f**2 + 704*D1*Dd*K*f*fd*r**2 - 528*D1*Dd*K*f*fd*r + 88*D1*Dd*K*f*fd + 960*D1*Dd*f**3*r**2 - 248*D1*Dd*f**3*r*s - 356*D1*Dd*f**3*r + 62*D1*Dd*f**3*s + 240*D1*Dd*f**3 - 2880*D1*Dd*f**2*fd*r**2 + 3120*D1*Dd*f**2*fd*r*s + 420*D1*Dd*f**2*fd*r + 410*D1*Dd*f**2*fd*s - 520*D1*Dd*f**2*fd + 748*D1*Dd*f**2*r**2 + 440*D1*Dd*f**2*r*s - 594*D1*Dd*f**2*r - 110*D1*Dd*f**2*s + 187*D1*Dd*f**2 - 1760*D1*Dd*f*fd*r**2 - 1056*D1*Dd*f*fd*r*s + 1584*D1*Dd*f*fd*r + 396*D1*Dd*f*fd*s - 352*D1*Dd*f*fd + 616*D1*Dd*f*g2*r**2 - 308*D1*Dd*f*g2*r + 154*D1*Dd*f*g2 + 176*D1*Ddd*K*f**2*r**2 - 88*D1*Ddd*K*f**2*r + 44*D1*Ddd*K*f**2 - 480*D1*Ddd*f**3*r**2 + 520*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r - 130*D1*Ddd*f**3*s - 120*D1*Ddd*f**3 - 440*D1*Ddd*f**2*r**2 - 264*D1*Ddd*f**2*r*s + 352*D1*Ddd*f**2*r + 66*D1*Ddd*f**2*s - 110*D1*Ddd*f**2 + 11*D1*bd1*(D1*(6*f**2*(10*r**2 + r*(12*s - 13) - 6*s + 5) + f*(-7*K*(2*r**2 - 2*r + 1) - 12*fd*(4*r - 1)*(4*r + 4*s - 3) + 66*r**2 + 52*r*s - 92*r - 26*s + 33) + 6*fd*(-4*r**2 + r*(3 - 4*s) + s)) - 6*Dd*f*(2*f*(8*r - 3)*(4*r + 4*s - 3) + 16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 528*Dd**2*K*f**2*r**2 - 264*Dd**2*K*f**2*r - 1440*Dd**2*f**3*r**2 + 1560*Dd**2*f**3*r*s - 60*Dd**2*f**3*r - 390*Dd**2*f**3*s + 260*Dd**2*f**3 - 1320*Dd**2*f**2*r**2 - 792*Dd**2*f**2*r*s + 1056*Dd**2*f**2*r + 198*Dd**2*f**2*s - 132*Dd**2*f**2))/(3003*d**2*k1*k3**4) - 2*D1**2*Pk3*Pkd1*ct**2*k2**2*st**2*(77*D1*b1**2*(C - 1)*(D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) + 11*b1*(7*D1**2*bd1*f*(C - 1)*(2*r**2 - 2*r + 1) + D1**2*(f*(fd*(C*(26*r**2 - 14*r + 7) - 14*r**2 + 18*r*s + 5*r - 7) + fdd*(C*(-8*r**2 + 8*r - 4) + 2*r**2 - 18*r*s + r + 4)) + fd**2*r*(-8*C*(r - 1) + 2*r - 18*s + 1)) + D1*f*(Dd*(f*(13*C*(4*r**2 - 2*r + 1) - 28*r**2 + 36*r*s - 4*r - 9*s - 7) + fd*(-8*C*(8*r**2 - 6*r + 1) + 16*r**2 - 144*r*s + 36*r + 18*s - 1)) + Ddd*f*(-4*C*(4*r**2 - 2*r + 1) + 4*r**2 - 36*r*s + 16*r + 9*s + 1)) - 3*Dd**2*f**2*(r**2*(16*C - 4) - 4*r*(2*C - 9*s + 4) - 9*s + 6)) + f*(-42*C*D1**2*f*fd*r**2 + 28*C*D1**2*f*fd*r - 14*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 - 80*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd + 240*C*D1**2*fd**2*r**2 - 160*C*D1**2*fd**2*r - 56*C*D1*Dd*f**2*r**2 + 28*C*D1*Dd*f**2*r - 14*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 - 560*C*D1*Dd*f*fd*r + 80*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r**2 - 80*C*D1*Ddd*f**2*r + 40*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r**2 - 240*C*Dd**2*f**2*r - 11*D1**2*bdd1*f*(r**2*(4*C - 1) + r*(9*s - 6) - 9*s + 3) + 240*D1**2*f*fd*r**2 + 249*D1**2*f*fd*r*s - 243*D1**2*f*fd*r - 83*D1**2*f*fd*s + 80*D1**2*f*fd - 219*D1**2*f*fdd*r**2 - 273*D1**2*f*fdd*r*s + 237*D1**2*f*fdd*r + 91*D1**2*f*fdd*s - 73*D1**2*f*fdd - 438*D1**2*fd**2*r**2 - 546*D1**2*fd**2*r*s + 474*D1**2*fd**2*r + 182*D1**2*fd**2*s - 91*D1**2*fd**2 + 320*D1*Dd*f**2*r**2 + 332*D1*Dd*f**2*r*s - 326*D1*Dd*f**2*r - 83*D1*Dd*f**2*s + 80*D1*Dd*f**2 - 1752*D1*Dd*f*fd*r**2 - 2184*D1*Dd*f*fd*r*s + 1932*D1*Dd*f*fd*r + 637*D1*Dd*f*fd*s - 419*D1*Dd*f*fd - 292*D1*Ddd*f**2*r**2 - 364*D1*Ddd*f**2*r*s + 328*D1*Ddd*f**2*r + 91*D1*Ddd*f**2*s - 73*D1*Ddd*f**2 + 11*D1*bd1*(C*(D1*f*(13*r**2 - 12*r + 6) + 8*D1*fd*r*(1 - 2*r) + 8*Dd*f*r*(1 - 4*r)) + D1*(f*(-7*r**2 + 9*r*s - 9*s) + fd*(4*r**2 - 36*r*s + 13*r + 18*s - 9)) + Dd*f*(8*r**2 - 8*r*(9*s - 5) + 45*s - 24)) - 876*Dd**2*f**2*r**2 - 1092*Dd**2*f**2*r*s + 984*Dd**2*f**2*r + 273*Dd**2*f**2*s - 182*Dd**2*f**2))/(231*d**2*k1*k3**2) + D1**2*Pk3*Pkd1*ct**2*k2**2*(88*D1**2*K*bd1**2*f*r**2 + 22*D1**2*K*bd1**2*f*r - 22*D1**2*K*bd1*f**2*r**2 - 220*D1**2*K*bd1*f*fd*r**2 + 110*D1**2*K*bd1*f*fd*r - 55*D1**2*K*bdd1*f**2*r**2 + 220*D1**2*bd1**2*f**2*r**2 + 1584*D1**2*bd1**2*f**2*r*s - 726*D1**2*bd1**2*f**2*r - 792*D1**2*bd1**2*f**2*s + 396*D1**2*bd1**2*f**2 + 22*D1**2*bd1**2*f*r**2 + 880*D1**2*bd1**2*f*r*s - 572*D1**2*bd1**2*f*r - 440*D1**2*bd1**2*f*s + 440*D1**2*bd1**2*f + 308*D1**2*bd1**2*g2*r**2 - 308*D1**2*bd1**2*g2*r - 22*D1**2*bd1*bd2*f*r**2 + 22*D1**2*bd1*bd2*f*r - 120*D1**2*bd1*f**3*r**2 - 660*D1**2*bd1*f**3*r*s + 330*D1**2*bd1*f**3*r + 1350*D1**2*bd1*f**2*fd*r**2 + 3960*D1**2*bd1*f**2*fd*r*s - 2430*D1**2*bd1*f**2*fd*r - 660*D1**2*bd1*f**2*fd*s + 330*D1**2*bd1*f**2*fd - 44*D1**2*bd1*f**2*r**2 - 352*D1**2*bd1*f**2*r*s + 352*D1**2*bd1*f**2*r + 616*D1**2*bd1*f*fd*r**2 + 1496*D1**2*bd1*f*fd*r*s - 1056*D1**2*bd1*f*fd*r - 374*D1**2*bd1*f*fd*s + 374*D1**2*bd1*f*fd + 176*D1**2*bd1*f*g2*r**2 - 528*D1**2*bd1*f*g2*r + 264*D1**2*bd1*f*g2 - 176*D1**2*bd1*f*gd2*r**2 - 44*D1**2*bd1*f*gd2*r - 176*D1**2*bd1*fd*g2*r**2 + 176*D1**2*bd1*fd*g2*r - 22*D1**2*bd2*f**2*r**2 - 220*D1**2*bd2*f*fd*r**2 + 110*D1**2*bd2*f*fd*r + 225*D1**2*bdd1*f**3*r**2 + 660*D1**2*bdd1*f**3*r*s - 330*D1**2*bdd1*f**3*r + 154*D1**2*bdd1*f**2*r**2 + 374*D1**2*bdd1*f**2*r*s - 374*D1**2*bdd1*f**2*r - 88*D1**2*bdd1*f*g2*r**2 - 44*D1**2*bdd1*f*g2*r + 22*D1**2*bdd1*f*g2 - 55*D1**2*bdd2*f**2*r**2 + 44*D1**2*f**2*gd2*r**2 + 110*D1**2*f**2*gdd2*r**2 + 88*D1**2*f*fd*g2*r**2 - 88*D1**2*f*fd*g2*r + 44*D1**2*f*fd*g2 + 440*D1**2*f*fd*gd2*r**2 - 220*D1**2*f*fd*gd2*r + 220*D1**2*f*fdd*g2*r**2 - 220*D1**2*f*fdd*g2*r + 110*D1**2*f*fdd*g2 + 220*D1**2*fd**2*g2*r**2 - 220*D1**2*fd**2*g2*r - 440*D1*Dd*K*bd1*f**2*r**2 + 110*D1*Dd*K*bd1*f**2*r + 1800*D1*Dd*bd1*f**3*r**2 + 5280*D1*Dd*bd1*f**3*r*s - 3090*D1*Dd*bd1*f**3*r - 660*D1*Dd*bd1*f**3*s + 330*D1*Dd*bd1*f**3 + 1232*D1*Dd*bd1*f**2*r**2 + 2992*D1*Dd*bd1*f**2*r*s - 2552*D1*Dd*bd1*f**2*r - 374*D1*Dd*bd1*f**2*s + 374*D1*Dd*bd1*f**2 - 704*D1*Dd*bd1*f*g2*r**2 + 44*D1*Dd*bd1*f*g2 - 440*D1*Dd*bd2*f**2*r**2 + 110*D1*Dd*bd2*f**2*r + 176*D1*Dd*f**2*g2*r**2 - 88*D1*Dd*f**2*g2*r + 44*D1*Dd*f**2*g2 + 880*D1*Dd*f**2*gd2*r**2 - 220*D1*Dd*f**2*gd2*r + 1760*D1*Dd*f*fd*g2*r**2 - 1320*D1*Dd*f*fd*g2*r + 220*D1*Dd*f*fd*g2 + 440*D1*Ddd*f**2*g2*r**2 - 220*D1*Ddd*f**2*g2*r + 110*D1*Ddd*f**2*g2 + 1320*Dd**2*f**2*g2*r**2 - 660*Dd**2*f**2*g2*r - 11*b1**3*(D1**2*r**2*(12*fd + fdd) + 2*D1*Dd*(-7*K*(4*r**2 - 2*r + 1) + 6*f*(4*r**2 - 2*r + 1) + 4*fd*r**2 - fd*r + 28*r**2 - 14*r + 7) + D1*Ddd*(7*K + f - 7)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(2*r - 1)*(7*K + f - 7)) - 11*b1**2*(8*D1**2*K*fd*r**2 + 8*D1**2*K*fd*r - 4*D1**2*K*fd - 4*D1**2*K*fdd*r**2 + 10*D1**2*K*fdd*r - 5*D1**2*K*fdd + D1**2*bdd1*(7*K + f - 7)*(3*r**2 - 2*r + 1) - 8*D1**2*f*fd*r**2 + 144*D1**2*f*fd*r*s - 112*D1**2*f*fd*r + 2*D1**2*f*fd - 20*D1**2*f*fdd*r**2 - 144*D1**2*f*fdd*r*s + 98*D1**2*f*fdd*r + 5*D1**2*f*fdd - 20*D1**2*fd**2*r**2 - 144*D1**2*fd**2*r*s + 98*D1**2*fd**2*r - 12*D1**2*fd*r**2 + 38*D1**2*fd*r*s - 8*D1**2*fd*r + 4*D1**2*fd - D1**2*fdd*r**2 - 40*D1**2*fdd*r*s - 10*D1**2*fdd*r + 5*D1**2*fdd + 28*D1**2*gd2*r**2 - 14*D1**2*gdd2*r**2 + 32*D1*Dd*K*f*r**2 - 16*D1*Dd*K*f*r + 8*D1*Dd*K*f - 32*D1*Dd*K*fd*r**2 + 48*D1*Dd*K*fd*r - 10*D1*Dd*K*fd - 16*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 136*D1*Dd*f**2*r - 72*D1*Dd*f**2*s - 4*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 - 1152*D1*Dd*f*fd*r*s + 720*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s - 98*D1*Dd*f*fd - 48*D1*Dd*f*r**2 + 152*D1*Dd*f*r*s - 52*D1*Dd*f*r - 38*D1*Dd*f*s - 12*D1*Dd*f - 8*D1*Dd*fd*r**2 - 320*D1*Dd*fd*r*s + 42*D1*Dd*fd*r + 40*D1*Dd*fd*s + 10*D1*Dd*fd + 112*D1*Dd*g2*r**2 - 56*D1*Dd*g2*r + 28*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 + 28*D1*Dd*gd2*r - 16*D1*Ddd*K*f*r**2 + 8*D1*Ddd*K*f*r - 4*D1*Ddd*K*f - 40*D1*Ddd*f**2*r**2 - 288*D1*Ddd*f**2*r*s + 164*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 - 4*D1*Ddd*f*r**2 - 160*D1*Ddd*f*r*s + 82*D1*Ddd*f*r + 40*D1*Ddd*f*s - D1*Ddd*f - 56*D1*Ddd*g2*r**2 + 28*D1*Ddd*g2*r - 14*D1*Ddd*g2 + 2*D1*bd1*(D1*(-7*K*(3*r**2 - 2*r + 1) + 6*f*(3*r**2 - 2*r + 1) + 3*fd*r**2 - fd*r + 21*r**2 - 14*r + 7) + Dd*(7*K + f - 7)*(12*r**2 - 7*r + 1)) - 48*Dd**2*K*f*r**2 + 24*Dd**2*K*f*r - 120*Dd**2*f**2*r**2 - 864*Dd**2*f**2*r*s + 492*Dd**2*f**2*r + 216*Dd**2*f**2*s - 144*Dd**2*f**2 - 12*Dd**2*f*r**2 - 480*Dd**2*f*r*s + 246*Dd**2*f*r + 120*Dd**2*f*s - 80*Dd**2*f - 168*Dd**2*g2*r**2 + 84*Dd**2*g2*r) + b1*(-44*D1**2*K*f*fd*r**2 + 44*D1**2*K*f*fd*r - 22*D1**2*K*f*fd - 110*D1**2*K*f*fdd*r**2 + 110*D1**2*K*f*fdd*r - 55*D1**2*K*f*fdd - 110*D1**2*K*fd**2*r**2 + 110*D1**2*K*fd**2*r - 132*D1**2*b2*fd*r**2 - 11*D1**2*b2*fdd*r**2 - 22*D1**2*bd1**2*r*(3*r - 2)*(7*K + f - 7) - 132*D1**2*bd2*f*r**2 - 22*D1**2*bd2*fd*r**2 + 11*D1**2*bdd1*(f**2*(20*r**2 + 6*r*(24*s - 11) - 72*s + 15) + f*(K*(8*r**2 + 2*r - 1) + 2*r**2 + 80*r*s - 52*r - 40*s + 6) + 14*g2*(2*r**2 - 2*r + 1)) - 11*D1**2*bdd2*f*r**2 - 360*D1**2*f**2*fd*r**2 - 1980*D1**2*f**2*fd*r*s + 1230*D1**2*f**2*fd*r + 660*D1**2*f**2*fd*s - 120*D1**2*f**2*fd + 675*D1**2*f**2*fdd*r**2 + 1980*D1**2*f**2*fdd*r*s - 1440*D1**2*f**2*fdd*r - 660*D1**2*f**2*fdd*s + 225*D1**2*f**2*fdd + 1350*D1**2*f*fd**2*r**2 + 3960*D1**2*f*fd**2*r*s - 2880*D1**2*f*fd**2*r - 1320*D1**2*f*fd**2*s + 990*D1**2*f*fd**2 - 88*D1**2*f*fd*r**2 - 704*D1**2*f*fd*r*s + 88*D1**2*f*fd*r + 352*D1**2*f*fd*s - 44*D1**2*f*fd + 308*D1**2*f*fdd*r**2 + 748*D1**2*f*fdd*r*s - 308*D1**2*f*fdd*r - 374*D1**2*f*fdd*s + 154*D1**2*f*fdd + 176*D1**2*f*gd2*r**2 - 88*D1**2*f*gdd2*r**2 + 308*D1**2*fd**2*r**2 + 748*D1**2*fd**2*r*s - 308*D1**2*fd**2*r - 374*D1**2*fd**2*s + 176*D1**2*fd*g2*r**2 + 176*D1**2*fd*g2*r - 88*D1**2*fd*g2 - 176*D1**2*fd*gd2*r**2 + 220*D1**2*fd*gd2*r - 88*D1**2*fdd*g2*r**2 + 220*D1**2*fdd*g2*r - 110*D1**2*fdd*g2 - 88*D1*Dd*K*f**2*r**2 + 44*D1*Dd*K*f**2*r - 22*D1*Dd*K*f**2 - 880*D1*Dd*K*f*fd*r**2 + 660*D1*Dd*K*f*fd*r - 110*D1*Dd*K*f*fd - 528*D1*Dd*b2*f*r**2 + 264*D1*Dd*b2*f*r - 132*D1*Dd*b2*f - 88*D1*Dd*b2*fd*r**2 + 22*D1*Dd*b2*fd*r - 88*D1*Dd*bd2*f*r**2 + 22*D1*Dd*bd2*f*r - 480*D1*Dd*f**3*r**2 - 2640*D1*Dd*f**3*r*s + 1560*D1*Dd*f**3*r + 660*D1*Dd*f**3*s - 120*D1*Dd*f**3 + 5400*D1*Dd*f**2*fd*r**2 + 15840*D1*Dd*f**2*fd*r*s - 11070*D1*Dd*f**2*fd*r - 4620*D1*Dd*f**2*fd*s + 2760*D1*Dd*f**2*fd - 176*D1*Dd*f**2*r**2 - 1408*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r + 352*D1*Dd*f**2*s - 44*D1*Dd*f**2 + 2464*D1*Dd*f*fd*r**2 + 5984*D1*Dd*f*fd*r*s - 3344*D1*Dd*f*fd*r - 2244*D1*Dd*f*fd*s + 1056*D1*Dd*f*fd + 704*D1*Dd*f*g2*r**2 - 352*D1*Dd*f*g2*r + 176*D1*Dd*f*g2 - 704*D1*Dd*f*gd2*r**2 + 176*D1*Dd*f*gd2*r - 704*D1*Dd*fd*g2*r**2 + 1056*D1*Dd*fd*g2*r - 220*D1*Dd*fd*g2 - 220*D1*Ddd*K*f**2*r**2 + 110*D1*Ddd*K*f**2*r - 55*D1*Ddd*K*f**2 - 44*D1*Ddd*b2*f*r**2 + 22*D1*Ddd*b2*f*r - 11*D1*Ddd*b2*f + 900*D1*Ddd*f**3*r**2 + 2640*D1*Ddd*f**3*r*s - 1770*D1*Ddd*f**3*r - 660*D1*Ddd*f**3*s + 225*D1*Ddd*f**3 + 616*D1*Ddd*f**2*r**2 + 1496*D1*Ddd*f**2*r*s - 1056*D1*Ddd*f**2*r - 374*D1*Ddd*f**2*s + 154*D1*Ddd*f**2 - 352*D1*Ddd*f*g2*r**2 + 176*D1*Ddd*f*g2*r - 88*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(8*K*fd*r**2 - 9*K*fd*r + f**2*(4*r**2 + r*(12 - 72*s) + 36*s + 3) + f*(-2*K*(4*r**2 - 6*r + 3) + 2*fd*(20*r**2 + 2*r*(72*s - 41) - 36*s + 27) + 12*r**2 - 38*r*s + 3*r + 19*s + 8) + 2*fd*r**2 + 80*fd*r*s - 16*fd*r - 20*fd*s - 14*g2*(2*r**2 - 2*r + 1) + 28*gd2*r**2 - 14*gd2*r) + Dd*(f**2*(80*r**2 + 8*r*(72*s - 37) - 216*s + 105) + f*(K*(32*r**2 - 4*r - 1) + 8*r**2 + 2*r*(160*s - 93) - 120*s + 66) + 14*g2*(8*r**2 - 6*r + 1))) - 660*Dd**2*K*f**2*r**2 + 330*Dd**2*K*f**2*r - 132*Dd**2*b2*f*r**2 + 66*Dd**2*b2*f*r + 2700*Dd**2*f**3*r**2 + 7920*Dd**2*f**3*r*s - 5310*Dd**2*f**3*r - 1980*Dd**2*f**3*s + 1320*Dd**2*f**3 + 1848*Dd**2*f**2*r**2 + 4488*Dd**2*f**2*r*s - 3168*Dd**2*f**2*r - 1122*Dd**2*f**2*s + 748*Dd**2*f**2 - 1056*Dd**2*f*g2*r**2 + 528*Dd**2*f*g2*r) - 11*b2*(D1**2*bdd1*f*(r - 1)**2 + 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r + 2*D1**2*f*fd + 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 - 60*D1*Dd*f*fd*r + 10*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 - 10*D1*Ddd*f**2*r + 5*D1*Ddd*f**2 + 2*D1*bd1*(r - 1)*(6*D1*f*(r - 1) + D1*fd*r + Dd*f*(4*r - 1)) + 60*Dd**2*f**2*r**2 - 30*Dd**2*f**2*r))/(231*d**2*k1*k3**2) + 2*D1**2*Pk3*Pkd1*ct**2*st**2*(D1*f*(3*D1*bd1**2*s*(1 - 2*r) + D1*bd1*(5*f*r*s + 3*fd*(-4*r*s + r + s)) - 3*D1*bdd1*f*r*s + 3*Dd*bd1*f*(r*(2 - 8*s) + s)) + b1**2*(D1*Dd*(13*f*(4*r*s - 2*r - s) - 3*fd*(8*r*s - 6*r - s + 1)) + D1*(D1*r*(13*fd - 3*fdd)*(s - 1) + 3*Ddd*f*(-4*r*s + 2*r + s)) + 3*Dd**2*f*(r*(6 - 12*s) + 3*s - 2)) + b1*(D1*Dd*f*(5*f*r*(4*s - 2) - 5*f*s - 3*fd*(8*r - 3)*(2*s - 1)) + D1*bd1*(D1*(13*f*s*(2*r - 1) + 3*fd*(-4*r*s + 2*r + s - 1)) - 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(5*f*fd*(r*(2*s - 1) - s) + 3*f*(bdd1*s*(1 - 2*r) + fdd*(-2*r*s + r + s)) + 3*fd**2*(-2*r*s + r + s - 1)) + 3*Ddd*f**2*(r*(2 - 4*s) + s)) + 3*Dd**2*f**2*(r*(6 - 12*s) + 3*s - 2)))/(21*d**2*k1) + D1**2*Pk3*Pkd1*ct**2*(D1*f*(2*D1*bd1**2*(r**2*(1 - 2*C) + r*(2*C + 40*s - 1) - 20*s) + D1*bdd1*f*r*(r*(5 - 10*C) + 34*s) - 2*bd1*(D1*(f*r*(r*(2*C - 1) + 16*s) + fd*(r**2*(20*C - 10) - 2*r*(5*C + 34*s - 11) + 17*s)) + Dd*f*(r**2*(40*C - 20) + r*(-10*C - 136*s + 39) + 17*s))) + b1**2*(D1**2*r*(fd*(-24*C*r + 12*r - 38*s + 38) + fdd*(-2*C*r + r + 40*s - 40)) + D1*(2*Dd*(f*(-12*C*(4*r**2 - 2*r + 1) + 24*r**2 - 76*r*s + 26*r + 19*s + 6) + fd*(r**2*(4 - 8*C) + r*(2*C + 160*s - 121) - 20*s + 20)) + Ddd*f*(C*(-8*r**2 + 4*r - 2) + 4*r**2 + 160*r*s - 82*r - 40*s + 1)) + 2*Dd**2*f*(r**2*(6 - 12*C) + 3*r*(2*C + 80*s - 41) - 60*s + 40)) + b1*(-8*C*D1**2*f*fd*r**2 + 8*C*D1**2*f*fd*r - 4*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 + 20*C*D1**2*f*fdd*r - 10*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 + 20*C*D1**2*fd**2*r - 16*C*D1*Dd*f**2*r**2 + 8*C*D1*Dd*f**2*r - 4*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 + 120*C*D1*Dd*f*fd*r - 20*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 + 20*C*D1*Ddd*f**2*r - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 + 60*C*Dd**2*f**2*r + D1**2*bdd1*f*(C*(-4*r**2 + 4*r - 2) + 2*r**2 + 80*r*s - 2*r - 40*s + 1) + 4*D1**2*f*fd*r**2 - 64*D1**2*f*fd*r*s + 28*D1**2*f*fd*r + 32*D1**2*f*fd*s + 2*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 68*D1**2*f*fdd*r*s - 44*D1**2*f*fdd*r - 34*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 68*D1**2*fd**2*r*s - 44*D1**2*fd**2*r - 34*D1**2*fd**2*s + 34*D1**2*fd**2 + 8*D1*Dd*f**2*r**2 - 128*D1*Dd*f**2*r*s + 60*D1*Dd*f**2*r + 32*D1*Dd*f**2*s + 2*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 544*D1*Dd*f*fd*r*s - 332*D1*Dd*f*fd*r - 204*D1*Dd*f*fd*s + 112*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 136*D1*Ddd*f**2*r*s - 78*D1*Ddd*f**2*r - 34*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 - 2*D1*bd1*(D1*(f*(12*C*(2*r**2 - 2*r + 1) - 12*r**2 + 38*r*s + 12*r - 19*s - 6) + fd*(r**2*(4*C - 2) + r*(-2*C - 80*s + 41) + 20*s - 20)) + Dd*f*(2*C*(8*r**2 - 6*r + 1) - 8*r**2 - 320*r*s + 86*r + 120*s - 41)) + 60*Dd**2*f**2*r**2 + 408*Dd**2*f**2*r*s - 234*Dd**2*f**2*r - 102*Dd**2*f**2*s + 68*Dd**2*f**2))/(21*d**2*k1) + 16*D1**2*Pk3*Pkd1*ct*f*k1**2*k2**3*st**4*(33*D1**2*bd1*f*(3*C - 2)*(r - 1)*(r + s - 1) + 33*D1*b1*(3*C - 2)*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + (11*C - 7)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)))/(231*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*ct*f*k1**2*k2*st**4*(D1*Dd*f*(-fd*(18*C - 11)*(2*r*(12*s - 5) - 7*s + 3) + (r*(4*s - 2) - s)*(66*C*b1 + 36*C*f - 33*b1 - 22*f)) + D1*(D1*(f*(33*bd1*s*(2*C - 1)*(r - 1) - fdd*(18*C - 11)*(3*r*s - r - s)) - fd**2*(18*C - 11)*(r*(6*s - 2) - 2*s + 1) + fd*(33*b1*r*(2*C - 1)*(2*s - 1) + f*(36*C - 22)*(3*r*s - r - s))) - Ddd*f**2*(18*C - 11)*(r*(4*s - 2) - s)) - Dd**2*f**2*(18*C - 11)*(6*r*(2*s - 1) - 3*s + 2))/(231*d**2*k3**4) - 8*D1**2*Pk3*Pkd1*ct*f*k2**5*st**4*(429*D1*b1**2*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 13*b1*(33*D1**2*bd1*f*(2*r - 1)*(r + s - 1) - 5*D1**2*(f*(2*fd - fdd)*(9*r**2 + r*(9*s - 5) + s - 1) + fd**2*(-18*r**2 - 2*r*(9*s - 5) - 2*s + 1)) - 5*D1*f*(Dd*(6*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(-72*r**2 - 8*r*(9*s - 7) + 5*s - 3)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + f*(65*D1**2*bdd1*f*(3*r - 4)*(r + s - 1) - 8*D1**2*(f*(37*fd - 25*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 25*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 65*D1*bd1*(D1*(2*f*(3*r - 4)*(r + s - 1) + fd*(-18*r**2 - 18*r*s + 26*r + 11*s - 7)) + Dd*f*(-24*r**2 - 8*r*(3*s - 5) + 19*s - 15)) - 8*D1*f*(Dd*(37*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 50*fd*(4*r - 1)*(4*r + 4*s - 3)) - 25*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 200*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(3003*d**2*k3**6) - 4*D1**2*Pk3*Pkd1*ct*f*k2*st**4*(D1*Dd*f*(-fd*(10*C - 7)*(2*r*(12*s - 5) - 7*s + 3) + (33*b1*(2*C - 1) + f*(20*C - 14))*(r*(4*s - 2) - s)) + D1*(D1*(f*(33*bd1*s*(2*C - 1)*(r - 1) - fdd*(10*C - 7)*(3*r*s - r - s)) - fd**2*(10*C - 7)*(r*(6*s - 2) - 2*s + 1) + fd*(33*b1*r*(2*C - 1)*(2*s - 1) + f*(20*C - 14)*(3*r*s - r - s))) - Ddd*f**2*(10*C - 7)*(r*(4*s - 2) - s)) - Dd**2*f**2*(10*C - 7)*(6*r*(2*s - 1) - 3*s + 2))/(231*d**2*k3**2) + 5*D1**2*Pk3*Pkd1*ct*f*k2**5*st**4*(390*D1**2*b1*f*fd*r**2 - 195*D1**2*b1*f*fdd*r**2 - 390*D1**2*b1*fd**2*r**2 - 65*D1**2*bdd1*f**2*(r - 1)**2 - 8*D1**2*f**2*fd*r**2 + 4*D1**2*f**2*fd*r - 2*D1**2*f**2*fd + 4*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 12*D1**2*f*fd**2*r**2 - 6*D1**2*f*fd**2*r + 520*D1*Dd*b1*f**2*r**2 - 260*D1*Dd*b1*f**2*r + 130*D1*Dd*b1*f**2 - 1560*D1*Dd*b1*f*fd*r**2 + 390*D1*Dd*b1*f*fd*r - 8*D1*Dd*f**3*r**2 + 4*D1*Dd*f**3*r - 2*D1*Dd*f**3 + 32*D1*Dd*f**2*fd*r**2 - 16*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd - 260*D1*Ddd*b1*f**2*r**2 + 130*D1*Ddd*b1*f**2*r - 65*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 130*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 780*Dd**2*b1*f**2*r**2 + 390*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(3003*d**2*k1**2*k3**4) + 8*D1**2*Pk3*Pkd1*ct*k1**4*k2*st**2*(858*C*D1**2*b1*f*fd*r**2 + 858*C*D1**2*b1*f*fd*r*s - 429*C*D1**2*b1*f*fd*r - 726*C*D1**2*b1*f*fdd*r**2 - 726*C*D1**2*b1*f*fdd*r*s + 363*C*D1**2*b1*f*fdd*r - 726*C*D1**2*b1*fd**2*r**2 - 726*C*D1**2*b1*fd**2*r*s + 363*C*D1**2*b1*fd**2*r + 759*C*D1**2*f**2*fd*r**2 + 759*C*D1**2*f**2*fd*r*s - 759*C*D1**2*f**2*fd*r - 253*C*D1**2*f**2*fd*s + 253*C*D1**2*f**2*fd - 825*C*D1**2*f**2*fdd*r**2 - 825*C*D1**2*f**2*fdd*r*s + 825*C*D1**2*f**2*fdd*r + 275*C*D1**2*f**2*fdd*s - 275*C*D1**2*f**2*fdd - 1650*C*D1**2*f*fd**2*r**2 - 1650*C*D1**2*f*fd**2*r*s + 1650*C*D1**2*f*fd**2*r + 550*C*D1**2*f*fd**2*s - 275*C*D1**2*f*fd**2 + 1716*C*D1*Dd*b1*f**2*r**2 + 1716*C*D1*Dd*b1*f**2*r*s - 1716*C*D1*Dd*b1*f**2*r - 429*C*D1*Dd*b1*f**2*s + 429*C*D1*Dd*b1*f**2 - 5808*C*D1*Dd*b1*f*fd*r**2 - 5808*C*D1*Dd*b1*f*fd*r*s + 4356*C*D1*Dd*b1*f*fd*r + 726*C*D1*Dd*b1*f*fd*s - 363*C*D1*Dd*b1*f*fd + 1012*C*D1*Dd*f**3*r**2 + 1012*C*D1*Dd*f**3*r*s - 1012*C*D1*Dd*f**3*r - 253*C*D1*Dd*f**3*s + 253*C*D1*Dd*f**3 - 6600*C*D1*Dd*f**2*fd*r**2 - 6600*C*D1*Dd*f**2*fd*r*s + 6600*C*D1*Dd*f**2*fd*r + 1925*C*D1*Dd*f**2*fd*s - 1375*C*D1*Dd*f**2*fd - 1452*C*D1*Ddd*b1*f**2*r**2 - 1452*C*D1*Ddd*b1*f**2*r*s + 1452*C*D1*Ddd*b1*f**2*r + 363*C*D1*Ddd*b1*f**2*s - 363*C*D1*Ddd*b1*f**2 - 1100*C*D1*Ddd*f**3*r**2 - 1100*C*D1*Ddd*f**3*r*s + 1100*C*D1*Ddd*f**3*r + 275*C*D1*Ddd*f**3*s - 275*C*D1*Ddd*f**3 - 4356*C*Dd**2*b1*f**2*r**2 - 4356*C*Dd**2*b1*f**2*r*s + 4356*C*Dd**2*b1*f**2*r + 1089*C*Dd**2*b1*f**2*s - 726*C*Dd**2*b1*f**2 - 3300*C*Dd**2*f**3*r**2 - 3300*C*Dd**2*f**3*r*s + 3300*C*Dd**2*f**3*r + 825*C*Dd**2*f**3*s - 550*C*Dd**2*f**3 - 462*D1**2*b1*f*fd*r**2 - 462*D1**2*b1*f*fd*r*s + 231*D1**2*b1*f*fd*r + 396*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 396*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(11*C - 6)*(r - 1)*(r + s - 1) - 405*D1**2*f**2*fd*r**2 - 405*D1**2*f**2*fd*r*s + 405*D1**2*f**2*fd*r + 135*D1**2*f**2*fd*s - 135*D1**2*f**2*fd + 450*D1**2*f**2*fdd*r**2 + 450*D1**2*f**2*fdd*r*s - 450*D1**2*f**2*fdd*r - 150*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd + 900*D1**2*f*fd**2*r**2 + 900*D1**2*f*fd**2*r*s - 900*D1**2*f*fd**2*r - 300*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 924*D1*Dd*b1*f**2*r**2 - 924*D1*Dd*b1*f**2*r*s + 924*D1*Dd*b1*f**2*r + 231*D1*Dd*b1*f**2*s - 231*D1*Dd*b1*f**2 + 3168*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 2376*D1*Dd*b1*f*fd*r - 396*D1*Dd*b1*f*fd*s + 198*D1*Dd*b1*f*fd - 540*D1*Dd*f**3*r**2 - 540*D1*Dd*f**3*r*s + 540*D1*Dd*f**3*r + 135*D1*Dd*f**3*s - 135*D1*Dd*f**3 + 3600*D1*Dd*f**2*fd*r**2 + 3600*D1*Dd*f**2*fd*r*s - 3600*D1*Dd*f**2*fd*r - 1050*D1*Dd*f**2*fd*s + 750*D1*Dd*f**2*fd + 792*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 792*D1*Ddd*b1*f**2*r - 198*D1*Ddd*b1*f**2*s + 198*D1*Ddd*b1*f**2 + 600*D1*Ddd*f**3*r**2 + 600*D1*Ddd*f**3*r*s - 600*D1*Ddd*f**3*r - 150*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(13*C - 7)*(r - 1)*(r + s - 1) - fd*(11*C - 6)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(11*C - 6)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 2376*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 2376*Dd**2*b1*f**2*r - 594*Dd**2*b1*f**2*s + 396*Dd**2*b1*f**2 + 1800*Dd**2*f**3*r**2 + 1800*Dd**2*f**3*r*s - 1800*Dd**2*f**3*r - 450*Dd**2*f**3*s + 300*Dd**2*f**3)/(693*d**2*k3**6) - 8*D1**2*Pk3*Pkd1*ct*k1**4*k2*(-33*D1**2*bd1**2*f*(2*r - 1)*(-30*K + 5*f + 6)*(r + s - 1) - 5*D1**2*bdd1*f*(f*r*(-165*K + 28*f + 33) + 396*g2*(r - 1))*(r + s - 1) + 330*D1**2*(f**2*r*(4*gd2 - 5*gdd2)*(r + s - 1) + f*(fd*(g2*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 5*fd**2*g2*(-2*r**2 - 2*r*(s - 1) + s)) + D1*bd1*(D1*(115*f**3*r*(r + s - 1) - 4*f**2*(35*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + r*(165*K - 33)*(r + s - 1)) + 165*f*(fd*(5*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (10*g2*(r - 1) + 12*gd2*(1 - 2*r))*(r + s - 1)) - 1980*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(28*f**2*(8*r**2 + 8*r*(s - 1) - s + 1) - 33*f*(5*K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 396*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 330*D1*f*(Dd*(f*(4*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) - 10*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 5*Ddd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 1650*Dd**2*f**2*g2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 33*b1**2*(D1**2*r*(f*(4*fd - 5*fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 5*fd*(5*K - 1)*(r + s) + 6*fdd*(5*K - 1)*(r + s)) + D1*(Dd*(4*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (5*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*fd*(5*K - 1)*(8*r**2 + r*(8*s - 4) - s)) - Ddd*f*(-30*K + 5*f + 6)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(-30*K + 5*f + 6)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-1320*D1**2*K*f*fd*r**2 - 1320*D1**2*K*f*fd*r*s + 1320*D1**2*K*f*fd*r + 660*D1**2*K*f*fd*s - 660*D1**2*K*f*fd + 1650*D1**2*K*f*fdd*r**2 + 1650*D1**2*K*f*fdd*r*s - 1650*D1**2*K*f*fdd*r - 825*D1**2*K*f*fdd*s + 825*D1**2*K*f*fdd + 1650*D1**2*K*fd**2*r**2 + 1650*D1**2*K*fd**2*r*s - 1650*D1**2*K*fd**2*r - 825*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(2*r - 1)*(-30*K + 5*f + 6)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 264*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 264*D1**2*f*fd*r - 132*D1**2*f*fd*s + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 330*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r + 165*D1**2*f*fdd*s - 165*D1**2*f*fdd + 1650*D1**2*f*gd2*r**2 + 1650*D1**2*f*gd2*r*s - 1650*D1**2*f*gd2*r - 1980*D1**2*f*gdd2*r**2 - 1980*D1**2*f*gdd2*r*s + 1980*D1**2*f*gdd2*r - 330*D1**2*fd**2*r**2 - 330*D1**2*fd**2*r*s + 330*D1**2*fd**2*r + 165*D1**2*fd**2*s + 1650*D1**2*fd*g2*r**2 + 1650*D1**2*fd*g2*r*s - 3960*D1**2*fd*gd2*r**2 - 3960*D1**2*fd*gd2*r*s + 1980*D1**2*fd*gd2*r - 1980*D1**2*fdd*g2*r**2 - 1980*D1**2*fdd*g2*r*s - 2640*D1*Dd*K*f**2*r**2 - 2640*D1*Dd*K*f**2*r*s + 2640*D1*Dd*K*f**2*r + 660*D1*Dd*K*f**2*s - 660*D1*Dd*K*f**2 + 13200*D1*Dd*K*f*fd*r**2 + 13200*D1*Dd*K*f*fd*r*s - 13200*D1*Dd*K*f*fd*r - 4950*D1*Dd*K*f*fd*s + 3300*D1*Dd*K*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 528*D1*Dd*f**2*r - 132*D1*Dd*f**2*s + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 2640*D1*Dd*f*fd*r*s + 2640*D1*Dd*f*fd*r + 990*D1*Dd*f*fd*s - 660*D1*Dd*f*fd + 6600*D1*Dd*f*g2*r**2 + 6600*D1*Dd*f*g2*r*s - 6600*D1*Dd*f*g2*r - 1650*D1*Dd*f*g2*s + 1650*D1*Dd*f*g2 - 15840*D1*Dd*f*gd2*r**2 - 15840*D1*Dd*f*gd2*r*s + 15840*D1*Dd*f*gd2*r + 1980*D1*Dd*f*gd2*s - 1980*D1*Dd*f*gd2 - 15840*D1*Dd*fd*g2*r**2 - 15840*D1*Dd*fd*g2*r*s + 7920*D1*Dd*fd*g2*r + 1980*D1*Dd*fd*g2*s + 3300*D1*Ddd*K*f**2*r**2 + 3300*D1*Ddd*K*f**2*r*s - 3300*D1*Ddd*K*f**2*r - 825*D1*Ddd*K*f**2*s + 825*D1*Ddd*K*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 - 660*D1*Ddd*f**2*r*s + 660*D1*Ddd*f**2*r + 165*D1*Ddd*f**2*s - 165*D1*Ddd*f**2 - 7920*D1*Ddd*f*g2*r**2 - 7920*D1*Ddd*f*g2*r*s + 7920*D1*Ddd*f*g2*r + 1980*D1*Ddd*f*g2*s - 1980*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(4*f**2*(2*r - 1)*(r + s - 1) - 5*f*(fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + (5*K - 1)*(2*r - 1)*(r + s - 1)) + 6*fd*(5*K - 1)*(4*r**2 + r*(4*s - 3) - s)) - Dd*f*(-30*K + 5*f + 6)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 9900*Dd**2*K*f**2*r**2 + 9900*Dd**2*K*f**2*r*s - 9900*Dd**2*K*f**2*r - 2475*Dd**2*K*f**2*s + 1650*Dd**2*K*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3 - 1980*Dd**2*f**2*r**2 - 1980*Dd**2*f**2*r*s + 1980*Dd**2*f**2*r + 495*Dd**2*f**2*s - 330*Dd**2*f**2 - 23760*Dd**2*f*g2*r**2 - 23760*Dd**2*f*g2*r*s + 23760*Dd**2*f*g2*r + 5940*Dd**2*f*g2*s - 3960*Dd**2*f*g2))/(693*d**2*k3**6) + D1**2*Pk3*Pkd1*ct*k1**4*st**2*(4*C - 2)*(11*D1*bd1*f*(D1*(5*f*s*(r - 1) + 3*fd*(-4*r*s + r + 2*s - 1)) - 3*Dd*f*(r*(8*s - 2) - 5*s + 2)) - 11*b1*(D1*Dd*f*(5*f*(-4*r*s + 2*r + s) + 3*fd*(8*r - 1)*(2*s - 1)) + D1*(-D1*r*(2*s - 1)*(5*f*fd - 3*f*fdd - 3*fd**2) + 3*Ddd*f**2*(4*r*s - 2*r - s)) + 3*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(D1*Dd*f*(39*f*(4*r*s - 2*r - s) - 25*fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(39*f*fd*(r*(3*s - 1) - s) + f*(-33*bdd1*s*(r - 1) + 25*fdd*(-3*r*s + r + s)) - 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(r*(2 - 4*s) + s)) - 25*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(231*d**2*k2*k3**4) - D1**2*Pk3*Pkd1*ct*k1**4*(8*C - 4)*(6*D1*bd1*f*(D1*(f*s*(r - 1) + fd*(-4*r*s + r + 2*s - 1)) + Dd*f*(r*(2 - 8*s) + 5*s - 2)) - 6*b1*(D1*Dd*f*(f*(-4*r*s + 2*r + s) + fd*(8*r - 1)*(2*s - 1)) + D1*(D1*r*(2*s - 1)*(f*(-fd + fdd) + fd**2) - Ddd*f**2*(r*(2 - 4*s) + s)) + Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)) + f*(5*D1*Dd*f*(f*(4*r*s - 2*r - s) + fd*(-24*r*s + 10*r + 7*s - 3)) + D1*(D1*(5*f*fd*(r*(3*s - 1) - s) + f*(-6*bdd1*s*(r - 1) + 5*fdd*(-3*r*s + r + s)) - 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(2 - 4*s) + s)) - 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(21*d**2*k2*k3**4) + 4*D1**2*Pk3*Pkd1*ct*k1**2*k2**3*st**2*(-3861*D1**2*K*bdd1*f**2*r**2 - 3861*D1**2*K*bdd1*f**2*r*s + 3861*D1**2*K*bdd1*f**2*r + 1287*D1**2*bd1**2*f*(2*r - 1)*(-3*K + 6*f + 1)*(r + s - 1) + 1950*D1**2*bdd1*f**3*r**2 + 1950*D1**2*bdd1*f**3*r*s + 1950*D1**2*bdd1*f**3*r + 3900*D1**2*bdd1*f**3*s - 3900*D1**2*bdd1*f**3 + 1287*D1**2*bdd1*f**2*r**2 + 1287*D1**2*bdd1*f**2*r*s - 1287*D1**2*bdd1*f**2*r + 7722*D1**2*bdd1*f*g2*r**2 + 7722*D1**2*bdd1*f*g2*r*s - 15444*D1**2*bdd1*f*g2*r - 7722*D1**2*bdd1*f*g2*s + 7722*D1**2*bdd1*f*g2 + 10520*D1**2*f**3*fd*r**2 + 10520*D1**2*f**3*fd*r*s - 10520*D1**2*f**3*fd*r - 2630*D1**2*f**3*fd*s + 2630*D1**2*f**3*fd - 11760*D1**2*f**3*fdd*r**2 - 11760*D1**2*f**3*fdd*r*s + 11760*D1**2*f**3*fdd*r + 2940*D1**2*f**3*fdd*s - 2940*D1**2*f**3*fdd - 35280*D1**2*f**2*fd**2*r**2 - 35280*D1**2*f**2*fd**2*r*s + 35280*D1**2*f**2*fd**2*r + 8820*D1**2*f**2*fd**2*s - 5880*D1**2*f**2*fd**2 - 12870*D1**2*f**2*gd2*r**2 - 12870*D1**2*f**2*gd2*r*s + 12870*D1**2*f**2*gd2*r + 7722*D1**2*f**2*gdd2*r**2 + 7722*D1**2*f**2*gdd2*r*s - 7722*D1**2*f**2*gdd2*r - 25740*D1**2*f*fd*g2*r**2 - 25740*D1**2*f*fd*g2*r*s + 25740*D1**2*f*fd*g2*r + 12870*D1**2*f*fd*g2*s - 12870*D1**2*f*fd*g2 + 30888*D1**2*f*fd*gd2*r**2 + 30888*D1**2*f*fd*gd2*r*s - 30888*D1**2*f*fd*gd2*r - 7722*D1**2*f*fd*gd2*s + 7722*D1**2*f*fd*gd2 + 15444*D1**2*f*fdd*g2*r**2 + 15444*D1**2*f*fdd*g2*r*s - 15444*D1**2*f*fdd*g2*r - 7722*D1**2*f*fdd*g2*s + 7722*D1**2*f*fdd*g2 + 15444*D1**2*fd**2*g2*r**2 + 15444*D1**2*fd**2*g2*r*s - 15444*D1**2*fd**2*g2*r - 7722*D1**2*fd**2*g2*s + 10520*D1*Dd*f**4*r**2 + 10520*D1*Dd*f**4*r*s - 10520*D1*Dd*f**4*r - 2630*D1*Dd*f**4*s + 2630*D1*Dd*f**4 - 94080*D1*Dd*f**3*fd*r**2 - 94080*D1*Dd*f**3*fd*r*s + 94080*D1*Dd*f**3*fd*r + 23520*D1*Dd*f**3*fd*s - 17640*D1*Dd*f**3*fd - 51480*D1*Dd*f**2*g2*r**2 - 51480*D1*Dd*f**2*g2*r*s + 51480*D1*Dd*f**2*g2*r + 12870*D1*Dd*f**2*g2*s - 12870*D1*Dd*f**2*g2 + 61776*D1*Dd*f**2*gd2*r**2 + 61776*D1*Dd*f**2*gd2*r*s - 61776*D1*Dd*f**2*gd2*r - 7722*D1*Dd*f**2*gd2*s + 7722*D1*Dd*f**2*gd2 + 123552*D1*Dd*f*fd*g2*r**2 + 123552*D1*Dd*f*fd*g2*r*s - 123552*D1*Dd*f*fd*g2*r - 46332*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 11760*D1*Ddd*f**4*r**2 - 11760*D1*Ddd*f**4*r*s + 11760*D1*Ddd*f**4*r + 2940*D1*Ddd*f**4*s - 2940*D1*Ddd*f**4 + 30888*D1*Ddd*f**2*g2*r**2 + 30888*D1*Ddd*f**2*g2*r*s - 30888*D1*Ddd*f**2*g2*r - 7722*D1*Ddd*f**2*g2*s + 7722*D1*Ddd*f**2*g2 - 39*D1*bd1*(D1*(6*f**3*(13*r + 15)*(r + s - 1) - 5*f**2*(10*fd*(6*r**2 + r*(6*s - 2) + 3*s - 1) + r*(33*K - 11)*(r + s - 1)) + 33*f*(fd*(3*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (26*g2*(r - 1) + 2*gd2*(3 - 6*r))*(r + s - 1)) - 198*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - Dd*f*(50*f**2*(8*r**2 + 8*r*s + 7*s - 5) - 33*f*(3*K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 198*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 35280*Dd**2*f**4*r**2 - 35280*Dd**2*f**4*r*s + 35280*Dd**2*f**4*r + 8820*Dd**2*f**4*s - 5880*Dd**2*f**4 + 92664*Dd**2*f**2*g2*r**2 + 92664*Dd**2*f**2*g2*r*s - 92664*Dd**2*f**2*g2*r - 23166*Dd**2*f**2*g2*s + 15444*Dd**2*f**2*g2 - 429*b1**2*(D1**2*r*(6*f*(4*fd - 3*fdd)*(2*r + 2*s - 1) - 18*fd**2*(2*r + 2*s - 1) - 13*fd*(3*K - 1)*(r + s) + 3*fdd*(3*K - 1)*(r + s)) + D1*(Dd*(24*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-18*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (13 - 39*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*fd*(3*K - 1)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-3*K + 6*f + 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-3*K + 6*f + 1)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 39*b1*(-330*D1**2*K*f*fd*r**2 - 330*D1**2*K*f*fd*r*s + 330*D1**2*K*f*fd*r + 165*D1**2*K*f*fd*s - 165*D1**2*K*f*fd + 198*D1**2*K*f*fdd*r**2 + 198*D1**2*K*f*fdd*r*s - 198*D1**2*K*f*fdd*r - 99*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 198*D1**2*K*fd**2*r**2 + 198*D1**2*K*fd**2*r*s - 198*D1**2*K*fd**2*r - 99*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(2*r - 1)*(-3*K + 6*f + 1)*(r + s - 1) + 234*D1**2*f**2*fd*r**2 + 234*D1**2*f**2*fd*r*s - 324*D1**2*f**2*fd*r - 168*D1**2*f**2*fd*s + 168*D1**2*f**2*fd - 150*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 250*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s - 150*D1**2*f**2*fdd - 300*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 500*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s - 150*D1**2*f*fd**2 + 110*D1**2*f*fd*r**2 + 110*D1**2*f*fd*r*s - 110*D1**2*f*fd*r - 55*D1**2*f*fd*s + 55*D1**2*f*fd - 66*D1**2*f*fdd*r**2 - 66*D1**2*f*fdd*r*s + 66*D1**2*f*fdd*r + 33*D1**2*f*fdd*s - 33*D1**2*f*fdd + 858*D1**2*f*gd2*r**2 + 858*D1**2*f*gd2*r*s - 858*D1**2*f*gd2*r - 198*D1**2*f*gdd2*r**2 - 198*D1**2*f*gdd2*r*s + 198*D1**2*f*gdd2*r - 66*D1**2*fd**2*r**2 - 66*D1**2*fd**2*r*s + 66*D1**2*fd**2*r + 33*D1**2*fd**2*s + 858*D1**2*fd*g2*r**2 + 858*D1**2*fd*g2*r*s - 396*D1**2*fd*gd2*r**2 - 396*D1**2*fd*gd2*r*s + 198*D1**2*fd*gd2*r - 198*D1**2*fdd*g2*r**2 - 198*D1**2*fdd*g2*r*s - 660*D1*Dd*K*f**2*r**2 - 660*D1*Dd*K*f**2*r*s + 660*D1*Dd*K*f**2*r + 165*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 1584*D1*Dd*K*f*fd*r**2 + 1584*D1*Dd*K*f*fd*r*s - 1584*D1*Dd*K*f*fd*r - 594*D1*Dd*K*f*fd*s + 396*D1*Dd*K*f*fd + 312*D1*Dd*f**3*r**2 + 312*D1*Dd*f**3*r*s - 312*D1*Dd*f**3*r - 78*D1*Dd*f**3*s + 78*D1*Dd*f**3 - 1200*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 1600*D1*Dd*f**2*fd*r + 750*D1*Dd*f**2*fd*s - 550*D1*Dd*f**2*fd + 220*D1*Dd*f**2*r**2 + 220*D1*Dd*f**2*r*s - 220*D1*Dd*f**2*r - 55*D1*Dd*f**2*s + 55*D1*Dd*f**2 - 528*D1*Dd*f*fd*r**2 - 528*D1*Dd*f*fd*r*s + 528*D1*Dd*f*fd*r + 198*D1*Dd*f*fd*s - 132*D1*Dd*f*fd + 3432*D1*Dd*f*g2*r**2 + 3432*D1*Dd*f*g2*r*s - 3432*D1*Dd*f*g2*r - 858*D1*Dd*f*g2*s + 858*D1*Dd*f*g2 - 1584*D1*Dd*f*gd2*r**2 - 1584*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r + 198*D1*Dd*f*gd2*s - 198*D1*Dd*f*gd2 - 1584*D1*Dd*fd*g2*r**2 - 1584*D1*Dd*fd*g2*r*s + 792*D1*Dd*fd*g2*r + 198*D1*Dd*fd*g2*s + 396*D1*Ddd*K*f**2*r**2 + 396*D1*Ddd*K*f**2*r*s - 396*D1*Ddd*K*f**2*r - 99*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 - 200*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 200*D1*Ddd*f**3*r + 50*D1*Ddd*f**3*s - 50*D1*Ddd*f**3 - 132*D1*Ddd*f**2*r**2 - 132*D1*Ddd*f**2*r*s + 132*D1*Ddd*f**2*r + 33*D1*Ddd*f**2*s - 33*D1*Ddd*f**2 - 792*D1*Ddd*f*g2*r**2 - 792*D1*Ddd*f*g2*r*s + 792*D1*Ddd*f*g2*r + 198*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(24*f**2*(2*r - 1)*(r + s - 1) + f*(-18*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (39*K - 13)*(2*r - 1)*(r + s - 1)) + 3*fd*(3*K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-3*K + 6*f + 1)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1188*Dd**2*K*f**2*r**2 + 1188*Dd**2*K*f**2*r*s - 1188*Dd**2*K*f**2*r - 297*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 - 600*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 600*Dd**2*f**3*r + 150*Dd**2*f**3*s - 100*Dd**2*f**3 - 396*Dd**2*f**2*r**2 - 396*Dd**2*f**2*r*s + 396*Dd**2*f**2*r + 99*Dd**2*f**2*s - 66*Dd**2*f**2 - 2376*Dd**2*f*g2*r**2 - 2376*Dd**2*f*g2*r*s + 2376*Dd**2*f*g2*r + 594*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(9009*d**2*k3**6) + D1**2*Pk3*Pkd1*ct*k1**2*k2*st**2*(132*b1**2*(D1**2*r*(fd*(31*C - 20) + fdd*(3 - 5*C))*(r + s - 1) + D1*(Dd*(f*(31*C - 20)*(4*r**2 + 4*r*(s - 1) - s + 1) - fd*(5*C - 3)*(8*r**2 + 8*r*(s - 1) - s + 1)) - Ddd*f*(5*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(5*C - 3)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1*(-128*C*D1**2*f*fd*r**2 - 184*C*D1**2*f*fd*r*s + 36*C*D1**2*f*fd*r - 28*C*D1**2*f*fd*s + 28*C*D1**2*f*fd + 144*C*D1**2*f*fdd*r**2 + 184*C*D1**2*f*fdd*r*s - 52*C*D1**2*f*fdd*r + 20*C*D1**2*f*fdd*s - 20*C*D1**2*f*fdd + 144*C*D1**2*fd**2*r**2 + 184*C*D1**2*fd**2*r*s - 52*C*D1**2*fd**2*r + 20*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 256*C*D1*Dd*f**2*r**2 - 368*C*D1*Dd*f**2*r*s + 312*C*D1*Dd*f**2*r + 92*C*D1*Dd*f**2*s - 64*C*D1*Dd*f**2 + 1152*C*D1*Dd*f*fd*r**2 + 1472*C*D1*Dd*f*fd*r*s - 864*C*D1*Dd*f*fd*r - 104*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd + 288*C*D1*Ddd*f**2*r**2 + 368*C*D1*Ddd*f**2*r*s - 328*C*D1*Ddd*f**2*r - 92*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 864*C*Dd**2*f**2*r**2 + 1104*C*Dd**2*f**2*r*s - 984*C*Dd**2*f**2*r - 276*C*Dd**2*f**2*s + 184*C*Dd**2*f**2 - 4*D1**2*bdd1*f*(5*C - 3)*(2*r**2 + 2*r*(s - 1) - s + 1) + 76*D1**2*f*fd*r**2 + 120*D1**2*f*fd*r*s - 28*D1**2*f*fd*r + 16*D1**2*f*fd*s - 16*D1**2*f*fd - 82*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 12*D1**2*f*fdd*s + 12*D1**2*f*fdd - 82*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 12*D1**2*fd**2*s + 12*D1**2*fd**2 + 152*D1*Dd*f**2*r**2 + 240*D1*Dd*f**2*r*s - 196*D1*Dd*f**2*r - 60*D1*Dd*f**2*s + 38*D1*Dd*f**2 - 656*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 548*D1*Dd*f*fd*r + 72*D1*Dd*f*fd*s - 12*D1*Dd*f*fd - 164*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 202*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s - 41*D1*Ddd*f**2 + 4*D1*bd1*(D1*(f*(31*C - 20)*(2*r**2 + 2*r*(s - 1) - s + 1) - fd*(5*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd*f*(10*C - 6)*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 492*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 606*Dd**2*f**2*r + 180*Dd**2*f**2*s - 120*Dd**2*f**2) + f*(-7572*C*D1**2*f*fd*r**2 - 8808*C*D1**2*f*fd*r*s + 7984*C*D1**2*f*fd*r + 2936*C*D1**2*f*fd*s - 2524*C*D1**2*f*fd + 8340*C*D1**2*f*fdd*r**2 + 9552*C*D1**2*f*fdd*r*s - 8744*C*D1**2*f*fdd*r - 3184*C*D1**2*f*fdd*s + 2780*C*D1**2*f*fdd + 16680*C*D1**2*fd**2*r**2 + 19104*C*D1**2*fd**2*r*s - 17488*C*D1**2*fd**2*r - 6368*C*D1**2*fd**2*s + 3184*C*D1**2*fd**2 - 10096*C*D1*Dd*f**2*r**2 - 11744*C*D1*Dd*f**2*r*s + 10920*C*D1*Dd*f**2*r + 2936*C*D1*Dd*f**2*s - 2524*C*D1*Dd*f**2 + 66720*C*D1*Dd*f*fd*r**2 + 76416*C*D1*Dd*f*fd*r*s - 70760*C*D1*Dd*f*fd*r - 22288*C*D1*Dd*f*fd*s + 15112*C*D1*Dd*f*fd + 11120*C*D1*Ddd*f**2*r**2 + 12736*C*D1*Ddd*f**2*r*s - 11928*C*D1*Ddd*f**2*r - 3184*C*D1*Ddd*f**2*s + 2780*C*D1*Ddd*f**2 + 33360*C*Dd**2*f**2*r**2 + 38208*C*Dd**2*f**2*r*s - 35784*C*Dd**2*f**2*r - 9552*C*Dd**2*f**2*s + 6368*C*Dd**2*f**2 - 132*D1**2*bd1**2*(5*C - 3)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(4*C*(18*r**2 + 23*r*(s - 2) - 28*s + 23) - 41*r**2 - 60*r*s + 106*r + 72*s - 53) + 4458*D1**2*f*fd*r**2 + 5508*D1**2*f*fd*r*s - 4808*D1**2*f*fd*r - 1836*D1**2*f*fd*s + 1486*D1**2*f*fd - 4803*D1**2*f*fdd*r**2 - 6120*D1**2*f*fdd*r*s + 5242*D1**2*f*fdd*r + 2040*D1**2*f*fdd*s - 1601*D1**2*f*fdd - 9606*D1**2*fd**2*r**2 - 12240*D1**2*fd**2*r*s + 10484*D1**2*fd**2*r + 4080*D1**2*fd**2*s - 2040*D1**2*fd**2 + 5944*D1*Dd*f**2*r**2 + 7344*D1*Dd*f**2*r*s - 6644*D1*Dd*f**2*r - 1836*D1*Dd*f**2*s + 1486*D1*Dd*f**2 - 38424*D1*Dd*f*fd*r**2 - 48960*D1*Dd*f*fd*r*s + 42814*D1*Dd*f*fd*r + 14280*D1*Dd*f*fd*s - 9322*D1*Dd*f*fd - 6404*D1*Ddd*f**2*r**2 - 8160*D1*Ddd*f**2*r*s + 7282*D1*Ddd*f**2*r + 2040*D1*Ddd*f**2*s - 1601*D1*Ddd*f**2 - 66*D1*bd1*(D1*(f*(C*(32*r**2 + 46*r*(s - 2) - 60*s + 46) - 19*r**2 - 30*r*s + 54*r + 38*s - 27) - 2*fd*(C*(72*r**2 + 92*r*s - 105*r - 51*s + 28) - 41*r**2 - 60*r*s + 62*r + 33*s - 18)) + Dd*f*(C*(-288*r**2 - 368*r*s + 532*r + 270*s - 204) + 164*r**2 + 240*r*s - 313*r - 174*s + 125)) - 19212*Dd**2*f**2*r**2 - 24480*Dd**2*f**2*r*s + 21846*Dd**2*f**2*r + 6120*Dd**2*f**2*s - 4080*Dd**2*f**2))/(693*d**2*k3**4) - D1**2*Pk3*Pkd1*ct*k1**2*k2*(-10560*D1**2*K*bd1**2*f*r**2 - 10296*D1**2*K*bd1**2*f*r*s + 20460*D1**2*K*bd1**2*f*r + 7524*D1**2*K*bd1**2*f*s - 7524*D1**2*K*bd1**2*f + 5280*D1**2*K*bd1*f**2*r**2 + 5544*D1**2*K*bd1*f**2*r*s - 5544*D1**2*K*bd1*f**2*r - 27984*D1**2*K*bd1*f*fd*r**2 - 25344*D1**2*K*bd1*f*fd*r*s + 26664*D1**2*K*bd1*f*fd*r + 6336*D1**2*K*bd1*f*fd*s - 6336*D1**2*K*bd1*f*fd - 6996*D1**2*K*bdd1*f**2*r**2 - 6336*D1**2*K*bdd1*f**2*r*s + 6336*D1**2*K*bdd1*f**2*r + 2442*D1**2*bd1**2*f**2*r**2 + 4752*D1**2*bd1**2*f**2*r*s - 6138*D1**2*bd1**2*f**2*r - 3036*D1**2*bd1**2*f**2*s + 3036*D1**2*bd1**2*f**2 + 2706*D1**2*bd1**2*f*r**2 + 5016*D1**2*bd1**2*f*r*s - 6798*D1**2*bd1**2*f*r - 3300*D1**2*bd1**2*f*s + 3300*D1**2*bd1**2*f - 11088*D1**2*bd1**2*g2*r**2 - 11088*D1**2*bd1**2*g2*r*s + 11088*D1**2*bd1**2*g2*r + 5544*D1**2*bd1**2*g2*s - 4752*D1**2*bd1*bd2*f*r**2 - 4752*D1**2*bd1*bd2*f*r*s + 7128*D1**2*bd1*bd2*f*r + 2376*D1**2*bd1*bd2*f*s - 2376*D1**2*bd1*bd2*f - 1370*D1**2*bd1*f**3*r**2 - 1780*D1**2*bd1*f**3*r*s + 2440*D1**2*bd1*f**3*r - 660*D1**2*bd1*f**3*s + 10050*D1**2*bd1*f**2*fd*r**2 + 11280*D1**2*bd1*f**2*fd*r*s - 12190*D1**2*bd1*f**2*fd*r - 560*D1**2*bd1*f**2*fd*s + 1220*D1**2*bd1*f**2*fd - 1518*D1**2*bd1*f**2*r**2 - 2376*D1**2*bd1*f**2*r*s + 2376*D1**2*bd1*f**2*r + 7788*D1**2*bd1*f*fd*r**2 + 11088*D1**2*bd1*f*fd*r*s - 9438*D1**2*bd1*f*fd*r - 2772*D1**2*bd1*f*fd*s + 2772*D1**2*bd1*f*fd - 6336*D1**2*bd1*f*g2*r**2 - 9504*D1**2*bd1*f*g2*r*s + 20592*D1**2*bd1*f*g2*r + 13464*D1**2*bd1*f*g2*s - 10296*D1**2*bd1*f*g2 + 21120*D1**2*bd1*f*gd2*r**2 + 20592*D1**2*bd1*f*gd2*r*s - 40920*D1**2*bd1*f*gd2*r - 15048*D1**2*bd1*f*gd2*s + 15048*D1**2*bd1*f*gd2 + 21120*D1**2*bd1*fd*g2*r**2 + 20592*D1**2*bd1*fd*g2*r*s - 21120*D1**2*bd1*fd*g2*r - 10296*D1**2*bd1*fd*g2*s + 1584*D1**2*bd2*f**2*r**2 + 1584*D1**2*bd2*f**2*r*s - 1584*D1**2*bd2*f**2*r - 7920*D1**2*bd2*f*fd*r**2 - 7920*D1**2*bd2*f*fd*r*s + 7920*D1**2*bd2*f*fd*r + 1980*D1**2*bd2*f*fd*s - 1980*D1**2*bd2*f*fd + 1675*D1**2*bdd1*f**3*r**2 + 1880*D1**2*bdd1*f**3*r*s - 2540*D1**2*bdd1*f**3*r + 660*D1**2*bdd1*f**3*s + 1947*D1**2*bdd1*f**2*r**2 + 2772*D1**2*bdd1*f**2*r*s - 2772*D1**2*bdd1*f**2*r + 10560*D1**2*bdd1*f*g2*r**2 + 10296*D1**2*bdd1*f*g2*r*s - 30624*D1**2*bdd1*f*g2*r - 15048*D1**2*bdd1*f*g2*s + 15312*D1**2*bdd1*f*g2 - 1980*D1**2*bdd2*f**2*r**2 - 1980*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*r + 2240*D1**2*f**3*fd*r*s - 1120*D1**2*f**3*fd*r - 560*D1**2*f**3*fd*s - 2240*D1**2*f**3*fdd*r*s + 1120*D1**2*f**3*fdd*r + 560*D1**2*f**3*fdd*s - 6720*D1**2*f**2*fd**2*r*s + 3360*D1**2*f**2*fd**2*r + 1680*D1**2*f**2*fd**2*s - 1120*D1**2*f**2*fd**2 - 10560*D1**2*f**2*gd2*r**2 - 11088*D1**2*f**2*gd2*r*s + 11088*D1**2*f**2*gd2*r + 13992*D1**2*f**2*gdd2*r**2 + 12672*D1**2*f**2*gdd2*r*s - 12672*D1**2*f**2*gdd2*r - 21120*D1**2*f*fd*g2*r**2 - 22176*D1**2*f*fd*g2*r*s + 21120*D1**2*f*fd*g2*r + 11088*D1**2*f*fd*g2*s - 10560*D1**2*f*fd*g2 + 55968*D1**2*f*fd*gd2*r**2 + 50688*D1**2*f*fd*gd2*r*s - 53328*D1**2*f*fd*gd2*r - 12672*D1**2*f*fd*gd2*s + 12672*D1**2*f*fd*gd2 + 27984*D1**2*f*fdd*g2*r**2 + 25344*D1**2*f*fdd*g2*r*s - 27984*D1**2*f*fdd*g2*r - 12672*D1**2*f*fdd*g2*s + 13992*D1**2*f*fdd*g2 + 27984*D1**2*fd**2*g2*r**2 + 25344*D1**2*fd**2*g2*r*s - 27984*D1**2*fd**2*g2*r - 12672*D1**2*fd**2*g2*s - 55968*D1*Dd*K*bd1*f**2*r**2 - 50688*D1*Dd*K*bd1*f**2*r*s + 52008*D1*Dd*K*bd1*f**2*r + 6336*D1*Dd*K*bd1*f**2*s - 6336*D1*Dd*K*bd1*f**2 + 13400*D1*Dd*bd1*f**3*r**2 + 15040*D1*Dd*bd1*f**3*r*s - 17270*D1*Dd*bd1*f**3*r + 760*D1*Dd*bd1*f**3*s + 1220*D1*Dd*bd1*f**3 + 15576*D1*Dd*bd1*f**2*r**2 + 22176*D1*Dd*bd1*f**2*r*s - 20526*D1*Dd*bd1*f**2*r - 2772*D1*Dd*bd1*f**2*s + 2772*D1*Dd*bd1*f**2 + 84480*D1*Dd*bd1*f*g2*r**2 + 82368*D1*Dd*bd1*f*g2*r*s - 164208*D1*Dd*bd1*f*g2*r - 70488*D1*Dd*bd1*f*g2*s + 60720*D1*Dd*bd1*f*g2 - 15840*D1*Dd*bd2*f**2*r**2 - 15840*D1*Dd*bd2*f**2*r*s + 15840*D1*Dd*bd2*f**2*r + 1980*D1*Dd*bd2*f**2*s - 1980*D1*Dd*bd2*f**2 + 2240*D1*Dd*f**4*r*s - 1120*D1*Dd*f**4*r - 560*D1*Dd*f**4*s - 17920*D1*Dd*f**3*fd*r*s + 8960*D1*Dd*f**3*fd*r + 4480*D1*Dd*f**3*fd*s - 2240*D1*Dd*f**3*fd - 42240*D1*Dd*f**2*g2*r**2 - 44352*D1*Dd*f**2*g2*r*s + 43296*D1*Dd*f**2*g2*r + 11088*D1*Dd*f**2*g2*s - 10560*D1*Dd*f**2*g2 + 111936*D1*Dd*f**2*gd2*r**2 + 101376*D1*Dd*f**2*gd2*r*s - 104016*D1*Dd*f**2*gd2*r - 12672*D1*Dd*f**2*gd2*s + 12672*D1*Dd*f**2*gd2 + 223872*D1*Dd*f*fd*g2*r**2 + 202752*D1*Dd*f*fd*g2*r*s - 218592*D1*Dd*f*fd*g2*r - 76032*D1*Dd*f*fd*g2*s + 53328*D1*Dd*f*fd*g2 - 2240*D1*Ddd*f**4*r*s + 1120*D1*Ddd*f**4*r + 560*D1*Ddd*f**4*s + 55968*D1*Ddd*f**2*g2*r**2 + 50688*D1*Ddd*f**2*g2*r*s - 53328*D1*Ddd*f**2*g2*r - 12672*D1*Ddd*f**2*g2*s + 13992*D1*Ddd*f**2*g2 - 6720*Dd**2*f**4*r*s + 3360*Dd**2*f**4*r + 1680*Dd**2*f**4*s - 1120*Dd**2*f**4 + 167904*Dd**2*f**2*g2*r**2 + 152064*Dd**2*f**2*g2*r*s - 159984*Dd**2*f**2*g2*r - 38016*Dd**2*f**2*g2*s + 25344*Dd**2*f**2*g2 + 132*b1**3*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1) - 2*(21*K - 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-21*K + 6*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-21*K + 6*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1**2*(96*D1**2*K*fd*r**2 + 144*D1**2*K*fd*r*s + 120*D1**2*K*fd*r + 60*D1**2*K*fd*s - 60*D1**2*K*fd - 160*D1**2*K*fdd*r**2 - 156*D1**2*K*fdd*r*s - 144*D1**2*K*fdd*r - 72*D1**2*K*fdd*s + 72*D1**2*K*fdd - 4*D1**2*bdd1*(-21*K + 6*f + 7)*(3*r**2 + 3*r*(s - 1) - s + 1) - 52*D1**2*f*fd*r**2 - 144*D1**2*f*fd*r*s + 40*D1**2*f*fd*r - 16*D1**2*f*fd*s + 16*D1**2*f*fd + 74*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s - 32*D1**2*f*fdd*r + 20*D1**2*f*fdd*s - 20*D1**2*f*fdd + 74*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s - 32*D1**2*fd**2*r + 20*D1**2*fd**2*s - 20*D1**2*fd**2 - 26*D1**2*fd*r**2 - 68*D1**2*fd*r*s - 40*D1**2*fd*r - 20*D1**2*fd*s + 20*D1**2*fd + 41*D1**2*fdd*r**2 + 76*D1**2*fdd*r*s + 48*D1**2*fdd*r + 24*D1**2*fdd*s - 24*D1**2*fdd + 336*D1**2*gd2*r**2 + 336*D1**2*gd2*r*s - 336*D1**2*gd2*r - 168*D1**2*gdd2*r**2 - 168*D1**2*gdd2*r*s + 168*D1**2*gdd2*r + 384*D1*Dd*K*f*r**2 + 576*D1*Dd*K*f*r*s - 480*D1*Dd*K*f*r - 144*D1*Dd*K*f*s + 96*D1*Dd*K*f - 1280*D1*Dd*K*fd*r**2 - 1248*D1*Dd*K*fd*r*s + 56*D1*Dd*K*fd*r - 132*D1*Dd*K*fd*s + 288*D1*Dd*K*fd - 104*D1*Dd*f**2*r**2 - 288*D1*Dd*f**2*r*s + 196*D1*Dd*f**2*r + 72*D1*Dd*f**2*s - 26*D1*Dd*f**2 + 592*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 564*D1*Dd*f*fd*r - 64*D1*Dd*f*fd*s - 8*D1*Dd*f*fd - 104*D1*Dd*f*r**2 - 272*D1*Dd*f*r*s + 188*D1*Dd*f*r + 68*D1*Dd*f*s - 26*D1*Dd*f + 328*D1*Dd*fd*r**2 + 608*D1*Dd*fd*r*s - 42*D1*Dd*fd*r + 20*D1*Dd*fd*s - 96*D1*Dd*fd + 1344*D1*Dd*g2*r**2 + 1344*D1*Dd*g2*r*s - 1344*D1*Dd*g2*r - 336*D1*Dd*g2*s + 336*D1*Dd*g2 - 1344*D1*Dd*gd2*r**2 - 1344*D1*Dd*gd2*r*s + 1344*D1*Dd*gd2*r + 168*D1*Dd*gd2*s - 168*D1*Dd*gd2 - 640*D1*Ddd*K*f*r**2 - 624*D1*Ddd*K*f*r*s + 632*D1*Ddd*K*f*r + 156*D1*Ddd*K*f*s - 160*D1*Ddd*K*f + 148*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 218*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s + 37*D1*Ddd*f**2 + 164*D1*Ddd*f*r**2 + 304*D1*Ddd*f*r*s - 234*D1*Ddd*f*r - 76*D1*Ddd*f*s + 41*D1*Ddd*f - 672*D1*Ddd*g2*r**2 - 672*D1*Ddd*g2*r*s + 672*D1*Ddd*g2*r + 168*D1*Ddd*g2*s - 168*D1*Ddd*g2 + 4*D1*bd1*(D1*(5*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 6*fd*(6*r**2 + 6*r*(s - 1) - s + 1) - 2*(21*K - 7)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-21*K + 6*f + 7)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 1920*Dd**2*K*f*r**2 - 1872*Dd**2*K*f*r*s + 1896*Dd**2*K*f*r + 468*Dd**2*K*f*s - 312*Dd**2*K*f + 444*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 654*Dd**2*f**2*r - 216*Dd**2*f**2*s + 144*Dd**2*f**2 + 492*Dd**2*f*r**2 + 912*Dd**2*f*r*s - 702*Dd**2*f*r - 228*Dd**2*f*s + 152*Dd**2*f - 2016*Dd**2*g2*r**2 - 2016*Dd**2*g2*r*s + 2016*Dd**2*g2*r + 504*Dd**2*g2*s - 336*Dd**2*g2) + b1*(10560*D1**2*K*f*fd*r**2 + 11088*D1**2*K*f*fd*r*s - 10560*D1**2*K*f*fd*r - 5544*D1**2*K*f*fd*s + 5280*D1**2*K*f*fd - 13992*D1**2*K*f*fdd*r**2 - 12672*D1**2*K*f*fdd*r*s + 13992*D1**2*K*f*fdd*r + 6336*D1**2*K*f*fdd*s - 6996*D1**2*K*f*fdd - 13992*D1**2*K*fd**2*r**2 - 12672*D1**2*K*fd**2*r*s + 13992*D1**2*K*fd**2*r + 6336*D1**2*K*fd**2*s + 1980*D1**2*b2*fd*r**2 + 1980*D1**2*b2*fd*r*s - 2376*D1**2*b2*fdd*r**2 - 2376*D1**2*b2*fdd*r*s - 132*D1**2*bd1**2*(-21*K + 6*f + 7)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 1980*D1**2*bd2*f*r**2 + 1980*D1**2*bd2*f*r*s - 1980*D1**2*bd2*f*r - 4752*D1**2*bd2*fd*r**2 - 4752*D1**2*bd2*fd*r*s + 2376*D1**2*bd2*fd*r + 33*D1**2*bdd1*(f**2*(74*r**2 + 6*r*(24*s - 31) - 92*s + 57) + f*(-4*K*(80*r**2 + 78*r*s - 155*r - 57*s + 58) + 82*r**2 + 152*r*s - 206*r - 100*s + 65) - 168*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 2376*D1**2*bdd2*f*r**2 - 2376*D1**2*bdd2*f*r*s + 2376*D1**2*bdd2*f*r - 4110*D1**2*f**2*fd*r**2 - 5340*D1**2*f**2*fd*r*s + 3860*D1**2*f**2*fd*r + 2440*D1**2*f**2*fd*s - 1370*D1**2*f**2*fd + 5025*D1**2*f**2*fdd*r**2 + 5640*D1**2*f**2*fdd*r*s - 4570*D1**2*f**2*fdd*r - 2540*D1**2*f**2*fdd*s + 1675*D1**2*f**2*fdd + 10050*D1**2*f*fd**2*r**2 + 11280*D1**2*f*fd**2*r*s - 9140*D1**2*f*fd**2*r - 5080*D1**2*f*fd**2*s + 2540*D1**2*f*fd**2 - 3036*D1**2*f*fd*r**2 - 4752*D1**2*f*fd*r*s + 3036*D1**2*f*fd*r + 2376*D1**2*f*fd*s - 1518*D1**2*f*fd + 3894*D1**2*f*fdd*r**2 + 5544*D1**2*f*fdd*r*s - 3894*D1**2*f*fdd*r - 2772*D1**2*f*fdd*s + 1947*D1**2*f*fdd - 6336*D1**2*f*gd2*r**2 - 9504*D1**2*f*gd2*r*s + 9504*D1**2*f*gd2*r + 10560*D1**2*f*gdd2*r**2 + 10296*D1**2*f*gdd2*r*s - 10296*D1**2*f*gdd2*r + 3894*D1**2*fd**2*r**2 + 5544*D1**2*fd**2*r*s - 3894*D1**2*fd**2*r - 2772*D1**2*fd**2*s - 6336*D1**2*fd*g2*r**2 - 9504*D1**2*fd*g2*r*s - 7920*D1**2*fd*g2*r - 3960*D1**2*fd*g2*s + 3960*D1**2*fd*g2 + 21120*D1**2*fd*gd2*r**2 + 20592*D1**2*fd*gd2*r*s - 792*D1**2*fd*gd2*r + 4752*D1**2*fd*gd2*s - 4752*D1**2*fd*gd2 + 10560*D1**2*fdd*g2*r**2 + 10296*D1**2*fdd*g2*r*s + 9504*D1**2*fdd*g2*r + 4752*D1**2*fdd*g2*s - 4752*D1**2*fdd*g2 + 21120*D1*Dd*K*f**2*r**2 + 22176*D1*Dd*K*f**2*r*s - 21648*D1*Dd*K*f**2*r - 5544*D1*Dd*K*f**2*s + 5280*D1*Dd*K*f**2 - 111936*D1*Dd*K*f*fd*r**2 - 101376*D1*Dd*K*f*fd*r*s + 109296*D1*Dd*K*f*fd*r + 38016*D1*Dd*K*f*fd*s - 26664*D1*Dd*K*f*fd + 7920*D1*Dd*b2*f*r**2 + 7920*D1*Dd*b2*f*r*s - 7920*D1*Dd*b2*f*r - 1980*D1*Dd*b2*f*s + 1980*D1*Dd*b2*f - 19008*D1*Dd*b2*fd*r**2 - 19008*D1*Dd*b2*fd*r*s + 9504*D1*Dd*b2*fd*r + 2376*D1*Dd*b2*fd*s - 19008*D1*Dd*bd2*f*r**2 - 19008*D1*Dd*bd2*f*r*s + 19008*D1*Dd*bd2*f*r + 2376*D1*Dd*bd2*f*s - 2376*D1*Dd*bd2*f - 5480*D1*Dd*f**3*r**2 - 7120*D1*Dd*f**3*r*s + 6300*D1*Dd*f**3*r + 1780*D1*Dd*f**3*s - 1370*D1*Dd*f**3 + 40200*D1*Dd*f**2*fd*r**2 + 45120*D1*Dd*f**2*fd*r*s - 39610*D1*Dd*f**2*fd*r - 15800*D1*Dd*f**2*fd*s + 9650*D1*Dd*f**2*fd - 6072*D1*Dd*f**2*r**2 - 9504*D1*Dd*f**2*r*s + 7788*D1*Dd*f**2*r + 2376*D1*Dd*f**2*s - 1518*D1*Dd*f**2 + 31152*D1*Dd*f*fd*r**2 + 44352*D1*Dd*f*fd*r*s - 34452*D1*Dd*f*fd*r - 16632*D1*Dd*f*fd*s + 9438*D1*Dd*f*fd - 25344*D1*Dd*f*g2*r**2 - 38016*D1*Dd*f*g2*r*s + 31680*D1*Dd*f*g2*r + 9504*D1*Dd*f*g2*s - 6336*D1*Dd*f*g2 + 84480*D1*Dd*f*gd2*r**2 + 82368*D1*Dd*f*gd2*r*s - 82896*D1*Dd*f*gd2*r - 10296*D1*Dd*f*gd2*s + 10296*D1*Dd*f*gd2 + 84480*D1*Dd*fd*g2*r**2 + 82368*D1*Dd*fd*g2*r*s - 3696*D1*Dd*fd*g2*r + 8712*D1*Dd*fd*g2*s - 19008*D1*Dd*fd*g2 - 27984*D1*Ddd*K*f**2*r**2 - 25344*D1*Ddd*K*f**2*r*s + 26664*D1*Ddd*K*f**2*r + 6336*D1*Ddd*K*f**2*s - 6996*D1*Ddd*K*f**2 - 9504*D1*Ddd*b2*f*r**2 - 9504*D1*Ddd*b2*f*r*s + 9504*D1*Ddd*b2*f*r + 2376*D1*Ddd*b2*f*s - 2376*D1*Ddd*b2*f + 6700*D1*Ddd*f**3*r**2 + 7520*D1*Ddd*f**3*r*s - 7110*D1*Ddd*f**3*r - 1880*D1*Ddd*f**3*s + 1675*D1*Ddd*f**3 + 7788*D1*Ddd*f**2*r**2 + 11088*D1*Ddd*f**2*r*s - 9438*D1*Ddd*f**2*r - 2772*D1*Ddd*f**2*s + 1947*D1*Ddd*f**2 + 42240*D1*Ddd*f*g2*r**2 + 41184*D1*Ddd*f*g2*r*s - 41712*D1*Ddd*f*g2*r - 10296*D1*Ddd*f*g2*s + 10560*D1*Ddd*f*g2 - 66*D1*bd1*(D1*(f**2*(26*r**2 + r*(72*s - 78) - 44*s + 21) + f*(-6*K*(16*r**2 + 24*r*s - 38*r - 17*s + 13) - 2*fd*(74*r**2 + r*(144*s - 109) - 36*s + 18) + 26*r**2 + 68*r*s - 80*r - 44*s + 23) + fd*(2*K*(160*r**2 + r*(156*s - 83) - 21*s - 18) - 82*r**2 + r*(55 - 152*s) + 26*s + 12) - 84*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 84*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd*(f**2*(-296*r**2 + r*(590 - 576*s) + 256*s - 185) + f*(2*K*(640*r**2 + 312*r*(2*s - 3) - 306*s + 269) - 328*r**2 - 608*r*s + 646*r + 276*s - 203) + 168*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 83952*Dd**2*K*f**2*r**2 - 76032*Dd**2*K*f**2*r*s + 79992*Dd**2*K*f**2*r + 19008*Dd**2*K*f**2*s - 12672*Dd**2*K*f**2 - 28512*Dd**2*b2*f*r**2 - 28512*Dd**2*b2*f*r*s + 28512*Dd**2*b2*f*r + 7128*Dd**2*b2*f*s - 4752*Dd**2*b2*f + 20100*Dd**2*f**3*r**2 + 22560*Dd**2*f**3*r*s - 21330*Dd**2*f**3*r - 5640*Dd**2*f**3*s + 3760*Dd**2*f**3 + 23364*Dd**2*f**2*r**2 + 33264*Dd**2*f**2*r*s - 28314*Dd**2*f**2*r - 8316*Dd**2*f**2*s + 5544*Dd**2*f**2 + 126720*Dd**2*f*g2*r**2 + 123552*Dd**2*f*g2*r*s - 125136*Dd**2*f*g2*r - 30888*Dd**2*f*g2*s + 20592*Dd**2*f*g2) + 396*b2*(-6*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*r + 5*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(r - 1)*(r + s - 1) + 6*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 6*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(693*d**2*k3**4) + D1**2*Pk3*Pkd1*ct*k1**2*st**2*(4*C - 2)*(11*D1*b1*(D1*bd1*(13*f*s*(2*r - 1) + 3*fd*(r*(2 - 4*s) + s - 1)) - 5*D1*f*fd*s + 3*D1*f*s*(-2*bdd1*r + bdd1 + fdd) + 3*D1*fd**2*(s - 1) - 6*Dd*bd1*f*(r*(8*s - 2) - 3*s + 1) + 6*Dd*f*fd*(2*s - 1)) - 11*b1**2*(D1*Dd*(13*f*(-4*r*s + 2*r + s) + 3*fd*(8*r*s - 6*r - s + 1)) + D1*(-D1*r*(13*fd - 3*fdd)*(s - 1) + 3*Ddd*f*(4*r*s - 2*r - s)) + 3*Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + f*(33*D1**2*bd1**2*s*(1 - 2*r) + D1*Dd*f*(39*f*(r*(2 - 4*s) + s) + 25*fd*(2*r*(12*s - 5) - 7*s + 3)) + 11*D1*bd1*(5*D1*f*s - 3*D1*fd*(s - 1) + 6*Dd*f*(1 - 2*s)) + D1*(D1*(-39*f*fd*(r*(3*s - 1) - s) + f*(-33*bdd1*s + 25*fdd*(3*r*s - r - s)) + 25*fd**2*(r*(6*s - 2) - 2*s + 1)) + 25*Ddd*f**2*(r*(4*s - 2) - s)) + 25*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(231*d**2*k2*k3**2) - D1**2*Pk3*Pkd1*ct*k1**2*(8*C - 4)*(D1*b1*(D1*(-6*f*fd*s + f*s*(bdd1*(7 - 14*r) + 6*fdd) + 6*fd**2*(s - 1)) + 12*Dd*f*fd*(2*s - 1) - 7*bd1*(D1*(f*s*(1 - 2*r) + fd*r*(4*s - 2) - fd*s + fd) + 2*Dd*f*(r*(8*s - 2) - 3*s + 1))) - 7*b1**2*(D1*Dd*(f*r*(2 - 4*s) + f*s + fd*r*(8*s - 6) - fd*s + fd) - D1*(D1*r*(fd - fdd)*(s - 1) + Ddd*f*(r*(2 - 4*s) + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + f*(7*D1**2*bd1**2*s*(1 - 2*r) - 5*D1*Dd*f*(f*(r*(4*s - 2) - s) + fd*(r*(10 - 24*s) + 7*s - 3)) + 6*D1*bd1*(D1*(f*s - fd*s + fd) + Dd*f*(2 - 4*s)) + D1*(D1*(5*f*fd*(-3*r*s + r + s) - f*(6*bdd1*s + 5*fdd*(-3*r*s + r + s)) + 5*fd**2*(r*(6*s - 2) - 2*s + 1)) + 5*Ddd*f**2*(r*(4*s - 2) - s)) + 5*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(21*d**2*k2*k3**2) - D1**2*Pk3*Pkd1*ct*k2**3*st**4*(1056*C*D1**2*b1*f*fd*r**2 + 1056*C*D1**2*b1*f*fd*r*s - 528*C*D1**2*b1*f*fd*r + 264*C*D1**2*b1*f*fdd*r**2 + 264*C*D1**2*b1*fd**2*r**2 + 456*C*D1**2*f**2*fd*r**2 + 288*C*D1**2*f**2*fd*r*s - 400*C*D1**2*f**2*fd*r - 96*C*D1**2*f**2*fd*s + 152*C*D1**2*f**2*fd - 228*C*D1**2*f**2*fdd*r**2 - 144*C*D1**2*f**2*fdd*r*s + 200*C*D1**2*f**2*fdd*r + 48*C*D1**2*f**2*fdd*s - 76*C*D1**2*f**2*fdd - 456*C*D1**2*f*fd**2*r**2 - 288*C*D1**2*f*fd**2*r*s + 400*C*D1**2*f*fd**2*r + 96*C*D1**2*f*fd**2*s - 48*C*D1**2*f*fd**2 + 2112*C*D1*Dd*b1*f**2*r**2 + 2112*C*D1*Dd*b1*f**2*r*s - 2112*C*D1*Dd*b1*f**2*r - 528*C*D1*Dd*b1*f**2*s + 528*C*D1*Dd*b1*f**2 + 2112*C*D1*Dd*b1*f*fd*r**2 - 528*C*D1*Dd*b1*f*fd*r + 608*C*D1*Dd*f**3*r**2 + 384*C*D1*Dd*f**3*r*s - 496*C*D1*Dd*f**3*r - 96*C*D1*Dd*f**3*s + 152*C*D1*Dd*f**3 - 1824*C*D1*Dd*f**2*fd*r**2 - 1152*C*D1*Dd*f**2*fd*r*s + 1544*C*D1*Dd*f**2*fd*r + 336*C*D1*Dd*f**2*fd*s - 296*C*D1*Dd*f**2*fd + 528*C*D1*Ddd*b1*f**2*r**2 - 264*C*D1*Ddd*b1*f**2*r + 132*C*D1*Ddd*b1*f**2 - 304*C*D1*Ddd*f**3*r**2 - 192*C*D1*Ddd*f**3*r*s + 248*C*D1*Ddd*f**3*r + 48*C*D1*Ddd*f**3*s - 76*C*D1*Ddd*f**3 + 1584*C*Dd**2*b1*f**2*r**2 - 792*C*Dd**2*b1*f**2*r - 912*C*Dd**2*f**3*r**2 - 576*C*Dd**2*f**3*r*s + 744*C*Dd**2*f**3*r + 144*C*Dd**2*f**3*s - 96*C*Dd**2*f**3 - 924*D1**2*b1*f*fd*r**2 - 1056*D1**2*b1*f*fd*r*s + 528*D1**2*b1*f*fd*r - 198*D1**2*b1*f*fdd*r**2 - 198*D1**2*b1*fd**2*r**2 + 33*D1**2*bdd1*f**2*(4*C - 3)*(r - 1)**2 - 378*D1**2*f**2*fd*r**2 - 240*D1**2*f**2*fd*r*s + 332*D1**2*f**2*fd*r + 80*D1**2*f**2*fd*s - 126*D1**2*f**2*fd + 189*D1**2*f**2*fdd*r**2 + 120*D1**2*f**2*fdd*r*s - 166*D1**2*f**2*fdd*r - 40*D1**2*f**2*fdd*s + 63*D1**2*f**2*fdd + 378*D1**2*f*fd**2*r**2 + 240*D1**2*f*fd**2*r*s - 332*D1**2*f*fd**2*r - 80*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 1848*D1*Dd*b1*f**2*r**2 - 2112*D1*Dd*b1*f**2*r*s + 1980*D1*Dd*b1*f**2*r + 528*D1*Dd*b1*f**2*s - 462*D1*Dd*b1*f**2 - 1584*D1*Dd*b1*f*fd*r**2 + 396*D1*Dd*b1*f*fd*r - 504*D1*Dd*f**3*r**2 - 320*D1*Dd*f**3*r*s + 412*D1*Dd*f**3*r + 80*D1*Dd*f**3*s - 126*D1*Dd*f**3 + 1512*D1*Dd*f**2*fd*r**2 + 960*D1*Dd*f**2*fd*r*s - 1282*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd*s + 246*D1*Dd*f**2*fd - 396*D1*Ddd*b1*f**2*r**2 + 198*D1*Ddd*b1*f**2*r - 99*D1*Ddd*b1*f**2 + 252*D1*Ddd*f**3*r**2 + 160*D1*Ddd*f**3*r*s - 206*D1*Ddd*f**3*r - 40*D1*Ddd*f**3*s + 63*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(D1*f*(8*C*(r + s - 1) - 7*r - 8*s + 7) + D1*fd*r*(8*C - 6) + Dd*f*(4*C - 3)*(4*r - 1)) - 1188*Dd**2*b1*f**2*r**2 + 594*Dd**2*b1*f**2*r + 756*Dd**2*f**3*r**2 + 480*Dd**2*f**3*r*s - 618*Dd**2*f**3*r - 120*Dd**2*f**3*s + 80*Dd**2*f**3)/(231*d**2*k3**4) + D1**2*Pk3*Pkd1*ct*k2**3*st**2*(2288*D1**2*K*bd1**2*f*r**2 + 2288*D1**2*K*bd1**2*f*r*s - 3432*D1**2*K*bd1**2*f*r - 1144*D1**2*K*bd1**2*f*s + 1144*D1**2*K*bd1**2*f - 3718*D1**2*K*bd1*f**2*r**2 - 1716*D1**2*K*bd1*f**2*r*s + 1716*D1**2*K*bd1*f**2*r + 9152*D1**2*K*bd1*f*fd*r**2 + 4576*D1**2*K*bd1*f*fd*r*s - 6864*D1**2*K*bd1*f*fd*r - 1144*D1**2*K*bd1*f*fd*s + 1144*D1**2*K*bd1*f*fd + 2288*D1**2*K*bdd1*f**2*r**2 + 1144*D1**2*K*bdd1*f**2*r*s - 1144*D1**2*K*bdd1*f**2*r - 9438*D1**2*bd1**2*f**2*r**2 - 10296*D1**2*bd1**2*f**2*r*s + 14586*D1**2*bd1**2*f**2*r + 6006*D1**2*bd1**2*f**2*s - 4290*D1**2*bd1**2*f**2 - 2574*D1**2*bd1**2*f*r**2 - 2288*D1**2*bd1**2*f*r*s + 3718*D1**2*bd1**2*f*r + 1144*D1**2*bd1**2*f*s - 1144*D1**2*bd1**2*f + 1716*D1**2*bd1*bd2*f*r**2 + 1716*D1**2*bd1*bd2*f*r*s - 2574*D1**2*bd1*bd2*f*r - 858*D1**2*bd1*bd2*f*s + 858*D1**2*bd1*bd2*f + 3926*D1**2*bd1*f**3*r**2 + 494*D1**2*bd1*f**3*r*s - 1066*D1**2*bd1*f**3*r + 5148*D1**2*bd1*f**3*s - 1560*D1**2*bd1*f**3 - 19500*D1**2*bd1*f**2*fd*r**2 + 1092*D1**2*bd1*f**2*fd*r*s + 5200*D1**2*bd1*f**2*fd*r - 10478*D1**2*bd1*f**2*fd*s + 6630*D1**2*bd1*f**2*fd + 3146*D1**2*bd1*f**2*r**2 + 1716*D1**2*bd1*f**2*r*s - 1716*D1**2*bd1*f**2*r - 7436*D1**2*bd1*f*fd*r**2 - 4576*D1**2*bd1*f*fd*r*s + 6006*D1**2*bd1*f*fd*r + 1144*D1**2*bd1*f*fd*s - 1144*D1**2*bd1*f*fd + 16588*D1**2*bd1*f*g2*r**2 + 12584*D1**2*bd1*f*g2*r*s - 33176*D1**2*bd1*f*g2*r - 12584*D1**2*bd1*f*g2*s + 16588*D1**2*bd1*f*g2 - 4576*D1**2*bd1*f*gd2*r**2 - 4576*D1**2*bd1*f*gd2*r*s + 6864*D1**2*bd1*f*gd2*r + 2288*D1**2*bd1*f*gd2*s - 2288*D1**2*bd1*f*gd2 - 4576*D1**2*bd1*fd*g2*r**2 - 4576*D1**2*bd1*fd*g2*r*s + 4576*D1**2*bd1*fd*g2*r + 2288*D1**2*bd1*fd*g2*s - 1430*D1**2*bd2*f**2*r**2 - 1430*D1**2*bd2*f**2*r*s + 1430*D1**2*bd2*f**2*r + 3432*D1**2*bd2*f*fd*r**2 + 3432*D1**2*bd2*f*fd*r*s - 3432*D1**2*bd2*f*fd*r - 858*D1**2*bd2*f*fd*s + 858*D1**2*bd2*f*fd - 3250*D1**2*bdd1*f**3*r**2 + 182*D1**2*bdd1*f**3*r*s - 468*D1**2*bdd1*f**3*r - 5148*D1**2*bdd1*f**3*s + 2067*D1**2*bdd1*f**3 - 1859*D1**2*bdd1*f**2*r**2 - 1144*D1**2*bdd1*f**2*r*s + 1144*D1**2*bdd1*f**2*r - 2288*D1**2*bdd1*f*g2*r**2 - 2288*D1**2*bdd1*f*g2*r*s + 4576*D1**2*bdd1*f*g2*r + 2288*D1**2*bdd1*f*g2*s - 2288*D1**2*bdd1*f*g2 + 858*D1**2*bdd2*f**2*r**2 + 858*D1**2*bdd2*f**2*r*s - 858*D1**2*bdd2*f**2*r - 8640*D1**2*f**3*fd*r**2 - 15600*D1**2*f**3*fd*r*s + 12120*D1**2*f**3*fd*r + 3900*D1**2*f**3*fd*s - 2160*D1**2*f**3*fd + 8220*D1**2*f**3*fdd*r**2 + 15600*D1**2*f**3*fdd*r*s - 11910*D1**2*f**3*fdd*r - 3900*D1**2*f**3*fdd*s + 2055*D1**2*f**3*fdd + 24660*D1**2*f**2*fd**2*r**2 + 46800*D1**2*f**2*fd**2*r*s - 35730*D1**2*f**2*fd**2*r - 11700*D1**2*f**2*fd**2*s + 7800*D1**2*f**2*fd**2 + 7436*D1**2*f**2*gd2*r**2 + 3432*D1**2*f**2*gd2*r*s - 3432*D1**2*f**2*gd2*r - 4576*D1**2*f**2*gdd2*r**2 - 2288*D1**2*f**2*gdd2*r*s + 2288*D1**2*f**2*gdd2*r + 14872*D1**2*f*fd*g2*r**2 + 6864*D1**2*f*fd*g2*r*s - 14872*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s + 7436*D1**2*f*fd*g2 - 18304*D1**2*f*fd*gd2*r**2 - 9152*D1**2*f*fd*gd2*r*s + 13728*D1**2*f*fd*gd2*r + 2288*D1**2*f*fd*gd2*s - 2288*D1**2*f*fd*gd2 - 9152*D1**2*f*fdd*g2*r**2 - 4576*D1**2*f*fdd*g2*r*s + 9152*D1**2*f*fdd*g2*r + 2288*D1**2*f*fdd*g2*s - 4576*D1**2*f*fdd*g2 - 9152*D1**2*fd**2*g2*r**2 - 4576*D1**2*fd**2*g2*r*s + 9152*D1**2*fd**2*g2*r + 2288*D1**2*fd**2*g2*s + 18304*D1*Dd*K*bd1*f**2*r**2 + 9152*D1*Dd*K*bd1*f**2*r*s - 11440*D1*Dd*K*bd1*f**2*r - 1144*D1*Dd*K*bd1*f**2*s + 1144*D1*Dd*K*bd1*f**2 - 26000*D1*Dd*bd1*f**3*r**2 + 1456*D1*Dd*bd1*f**3*r*s + 4264*D1*Dd*bd1*f**3*r - 20774*D1*Dd*bd1*f**3*s + 10764*D1*Dd*bd1*f**3 - 14872*D1*Dd*bd1*f**2*r**2 - 9152*D1*Dd*bd1*f**2*r*s + 10582*D1*Dd*bd1*f**2*r + 1144*D1*Dd*bd1*f**2*s - 1144*D1*Dd*bd1*f**2 - 18304*D1*Dd*bd1*f*g2*r**2 - 18304*D1*Dd*bd1*f*g2*r*s + 27456*D1*Dd*bd1*f*g2*r + 11440*D1*Dd*bd1*f*g2*s - 9152*D1*Dd*bd1*f*g2 + 6864*D1*Dd*bd2*f**2*r**2 + 6864*D1*Dd*bd2*f**2*r*s - 6864*D1*Dd*bd2*f**2*r - 858*D1*Dd*bd2*f**2*s + 858*D1*Dd*bd2*f**2 - 8640*D1*Dd*f**4*r**2 - 15600*D1*Dd*f**4*r*s + 12120*D1*Dd*f**4*r + 3900*D1*Dd*f**4*s - 2160*D1*Dd*f**4 + 65760*D1*Dd*f**3*fd*r**2 + 124800*D1*Dd*f**3*fd*r*s - 95280*D1*Dd*f**3*fd*r - 31200*D1*Dd*f**3*fd*s + 19710*D1*Dd*f**3*fd + 29744*D1*Dd*f**2*g2*r**2 + 13728*D1*Dd*f**2*g2*r*s - 21736*D1*Dd*f**2*g2*r - 3432*D1*Dd*f**2*g2*s + 7436*D1*Dd*f**2*g2 - 36608*D1*Dd*f**2*gd2*r**2 - 18304*D1*Dd*f**2*gd2*r*s + 22880*D1*Dd*f**2*gd2*r + 2288*D1*Dd*f**2*gd2*s - 2288*D1*Dd*f**2*gd2 - 73216*D1*Dd*f*fd*g2*r**2 - 36608*D1*Dd*f*fd*g2*r*s + 64064*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s - 13728*D1*Dd*f*fd*g2 + 8220*D1*Ddd*f**4*r**2 + 15600*D1*Ddd*f**4*r*s - 11910*D1*Ddd*f**4*r - 3900*D1*Ddd*f**4*s + 2055*D1*Ddd*f**4 - 18304*D1*Ddd*f**2*g2*r**2 - 9152*D1*Ddd*f**2*g2*r*s + 13728*D1*Ddd*f**2*g2*r + 2288*D1*Ddd*f**2*g2*s - 4576*D1*Ddd*f**2*g2 + 24660*Dd**2*f**4*r**2 + 46800*Dd**2*f**4*r*s - 35730*Dd**2*f**4*r - 11700*Dd**2*f**4*s + 7800*Dd**2*f**4 - 54912*Dd**2*f**2*g2*r**2 - 27456*Dd**2*f**2*g2*r*s + 41184*Dd**2*f**2*g2*r + 6864*Dd**2*f**2*g2*s - 4576*Dd**2*f**2*g2 - 286*b1**3*(D1**2*r*(13*fd - 3*fdd)*(r + s - 1) + D1*(Dd*(13*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 143*b1**2*(58*D1**2*K*fd*r**2 + 44*D1**2*K*fd*r*s - 8*D1**2*K*fdd*r**2 - 8*D1**2*K*fdd*r*s - 6*D1**2*bdd1*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 64*D1**2*f*fd*r**2 - 88*D1**2*f*fd*r*s + 40*D1**2*f*fd*r - 10*D1**2*f*fd*s + 10*D1**2*f*fd + 66*D1**2*f*fdd*r**2 + 72*D1**2*f*fdd*r*s - 36*D1**2*f*fdd*r + 6*D1**2*f*fdd*s - 6*D1**2*f*fdd + 66*D1**2*fd**2*r**2 + 72*D1**2*fd**2*r*s - 36*D1**2*fd**2*r + 6*D1**2*fd**2*s - 6*D1**2*fd**2 - 46*D1**2*fd*r**2 - 44*D1**2*fd*r*s + 9*D1**2*fdd*r**2 + 8*D1**2*fdd*r*s + 232*D1*Dd*K*f*r**2 + 176*D1*Dd*K*f*r*s - 204*D1*Dd*K*f*r - 44*D1*Dd*K*f*s + 58*D1*Dd*K*f - 64*D1*Dd*K*fd*r**2 - 64*D1*Dd*K*fd*r*s + 32*D1*Dd*K*fd*r + 8*D1*Dd*K*fd*s - 128*D1*Dd*f**2*r**2 - 176*D1*Dd*f**2*r*s + 152*D1*Dd*f**2*r + 44*D1*Dd*f**2*s - 32*D1*Dd*f**2 + 528*D1*Dd*f*fd*r**2 + 576*D1*Dd*f*fd*r*s - 420*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s + 24*D1*Dd*f*fd - 184*D1*Dd*f*r**2 - 176*D1*Dd*f*r*s + 180*D1*Dd*f*r + 44*D1*Dd*f*s - 46*D1*Dd*f + 72*D1*Dd*fd*r**2 + 64*D1*Dd*fd*r*s - 34*D1*Dd*fd*r - 8*D1*Dd*fd*s - 32*D1*Ddd*K*f*r**2 - 32*D1*Ddd*K*f*r*s + 32*D1*Ddd*K*f*r + 8*D1*Ddd*K*f*s - 8*D1*Ddd*K*f + 132*D1*Ddd*f**2*r**2 + 144*D1*Ddd*f**2*r*s - 138*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s + 33*D1*Ddd*f**2 + 36*D1*Ddd*f*r**2 + 32*D1*Ddd*f*r*s - 34*D1*Ddd*f*r - 8*D1*Ddd*f*s + 9*D1*Ddd*f + 2*D1*bd1*(D1*(13*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1)) - 3*Dd*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 96*Dd**2*K*f*r**2 - 96*Dd**2*K*f*r*s + 96*Dd**2*K*f*r + 24*Dd**2*K*f*s - 16*Dd**2*K*f + 396*Dd**2*f**2*r**2 + 432*Dd**2*f**2*r*s - 414*Dd**2*f**2*r - 108*Dd**2*f**2*s + 72*Dd**2*f**2 + 108*Dd**2*f*r**2 + 96*Dd**2*f*r*s - 102*Dd**2*f*r - 24*Dd**2*f*s + 16*Dd**2*f) + 13*b1*(-572*D1**2*K*f*fd*r**2 - 264*D1**2*K*f*fd*r*s + 572*D1**2*K*f*fd*r + 132*D1**2*K*f*fd*s - 286*D1**2*K*f*fd + 352*D1**2*K*f*fdd*r**2 + 176*D1**2*K*f*fdd*r*s - 352*D1**2*K*f*fdd*r - 88*D1**2*K*f*fdd*s + 176*D1**2*K*f*fdd + 352*D1**2*K*fd**2*r**2 + 176*D1**2*K*fd**2*r*s - 352*D1**2*K*fd**2*r - 88*D1**2*K*fd**2*s - 286*D1**2*b2*fd*r**2 - 286*D1**2*b2*fd*r*s + 66*D1**2*b2*fdd*r**2 + 66*D1**2*b2*fdd*r*s + 66*D1**2*bd1**2*f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 286*D1**2*bd2*f*r**2 - 286*D1**2*bd2*f*r*s + 286*D1**2*bd2*f*r + 132*D1**2*bd2*fd*r**2 + 132*D1**2*bd2*fd*r*s - 66*D1**2*bd2*fd*r - 11*D1**2*bdd1*f*(-8*K*(2*r - 1)*(r + s - 1) + 3*f*(22*r**2 + r*(24*s - 34) - 14*s + 13) + 18*r**2 + 16*r*s - 26*r - 8*s + 9) + 66*D1**2*bdd2*f*r**2 + 66*D1**2*bdd2*f*r*s - 66*D1**2*bdd2*f*r + 906*D1**2*f**2*fd*r**2 + 114*D1**2*f**2*fd*r*s - 598*D1**2*f**2*fd*r - 434*D1**2*f**2*fd*s + 422*D1**2*f**2*fd - 750*D1**2*f**2*fdd*r**2 + 42*D1**2*f**2*fdd*r*s + 508*D1**2*f**2*fdd*r + 382*D1**2*f**2*fdd*s - 409*D1**2*f**2*fdd - 1500*D1**2*f*fd**2*r**2 + 84*D1**2*f*fd**2*r*s + 1016*D1**2*f*fd**2*r + 764*D1**2*f*fd**2*s - 482*D1**2*f*fd**2 + 484*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 484*D1**2*f*fd*r - 132*D1**2*f*fd*s + 242*D1**2*f*fd - 286*D1**2*f*fdd*r**2 - 176*D1**2*f*fdd*r*s + 286*D1**2*f*fdd*r + 88*D1**2*f*fdd*s - 143*D1**2*f*fdd + 1276*D1**2*f*gd2*r**2 + 968*D1**2*f*gd2*r*s - 968*D1**2*f*gd2*r - 176*D1**2*f*gdd2*r**2 - 176*D1**2*f*gdd2*r*s + 176*D1**2*f*gdd2*r - 286*D1**2*fd**2*r**2 - 176*D1**2*fd**2*r*s + 286*D1**2*fd**2*r + 88*D1**2*fd**2*s + 1276*D1**2*fd*g2*r**2 + 968*D1**2*fd*g2*r*s - 352*D1**2*fd*gd2*r**2 - 352*D1**2*fd*gd2*r*s + 176*D1**2*fd*gd2*r - 176*D1**2*fdd*g2*r**2 - 176*D1**2*fdd*g2*r*s - 1144*D1*Dd*K*f**2*r**2 - 528*D1*Dd*K*f**2*r*s + 836*D1*Dd*K*f**2*r + 132*D1*Dd*K*f**2*s - 286*D1*Dd*K*f**2 + 2816*D1*Dd*K*f*fd*r**2 + 1408*D1*Dd*K*f*fd*r*s - 2464*D1*Dd*K*f*fd*r - 528*D1*Dd*K*f*fd*s + 528*D1*Dd*K*f*fd - 1144*D1*Dd*b2*f*r**2 - 1144*D1*Dd*b2*f*r*s + 1144*D1*Dd*b2*f*r + 286*D1*Dd*b2*f*s - 286*D1*Dd*b2*f + 528*D1*Dd*b2*fd*r**2 + 528*D1*Dd*b2*fd*r*s - 264*D1*Dd*b2*fd*r - 66*D1*Dd*b2*fd*s + 528*D1*Dd*bd2*f*r**2 + 528*D1*Dd*bd2*f*r*s - 528*D1*Dd*bd2*f*r - 66*D1*Dd*bd2*f*s + 66*D1*Dd*bd2*f + 1208*D1*Dd*f**3*r**2 + 152*D1*Dd*f**3*r*s - 680*D1*Dd*f**3*r - 38*D1*Dd*f**3*s + 302*D1*Dd*f**3 - 6000*D1*Dd*f**2*fd*r**2 + 336*D1*Dd*f**2*fd*r*s + 3448*D1*Dd*f**2*fd*r + 1486*D1*Dd*f**2*fd*s - 1272*D1*Dd*f**2*fd + 968*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 748*D1*Dd*f**2*r - 132*D1*Dd*f**2*s + 242*D1*Dd*f**2 - 2288*D1*Dd*f*fd*r**2 - 1408*D1*Dd*f*fd*r*s + 2068*D1*Dd*f*fd*r + 528*D1*Dd*f*fd*s - 462*D1*Dd*f*fd + 5104*D1*Dd*f*g2*r**2 + 3872*D1*Dd*f*g2*r*s - 4488*D1*Dd*f*g2*r - 968*D1*Dd*f*g2*s + 1276*D1*Dd*f*g2 - 1408*D1*Dd*f*gd2*r**2 - 1408*D1*Dd*f*gd2*r*s + 1408*D1*Dd*f*gd2*r + 176*D1*Dd*f*gd2*s - 176*D1*Dd*f*gd2 - 1408*D1*Dd*fd*g2*r**2 - 1408*D1*Dd*fd*g2*r*s + 704*D1*Dd*fd*g2*r + 176*D1*Dd*fd*g2*s + 704*D1*Ddd*K*f**2*r**2 + 352*D1*Ddd*K*f**2*r*s - 528*D1*Ddd*K*f**2*r - 88*D1*Ddd*K*f**2*s + 176*D1*Ddd*K*f**2 + 264*D1*Ddd*b2*f*r**2 + 264*D1*Ddd*b2*f*r*s - 264*D1*Ddd*b2*f*r - 66*D1*Ddd*b2*f*s + 66*D1*Ddd*b2*f - 1000*D1*Ddd*f**3*r**2 + 56*D1*Ddd*f**3*r*s + 472*D1*Ddd*f**3*r - 14*D1*Ddd*f**3*s - 250*D1*Ddd*f**3 - 572*D1*Ddd*f**2*r**2 - 352*D1*Ddd*f**2*r*s + 462*D1*Ddd*f**2*r + 88*D1*Ddd*f**2*s - 143*D1*Ddd*f**2 - 704*D1*Ddd*f*g2*r**2 - 704*D1*Ddd*f*g2*r*s + 704*D1*Ddd*f*g2*r + 176*D1*Ddd*f*g2*s - 176*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(f**2*(32*r**2 + r*(44*s - 56) - 27*s + 21) + f*(K*(-58*r**2 - 44*r*s + 80*r + 22*s - 29) - 6*fd*(22*r**2 + r*(24*s - 23) - 6*s + 4) + 46*r**2 + 44*r*s - 68*r - 22*s + 23) + fd*(r**2*(16*K - 18) + r*(4*K*(4*s - 3) - 16*s + 13) - s*(4*K - 4))) + Dd*f*(4*K*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) - 3*f*(88*r**2 + 6*r*(16*s - 19) - 40*s + 31) - 72*r**2 - 64*r*s + 86*r + 24*s - 21)) + 2112*Dd**2*K*f**2*r**2 + 1056*Dd**2*K*f**2*r*s - 1584*Dd**2*K*f**2*r - 264*Dd**2*K*f**2*s + 176*Dd**2*K*f**2 + 792*Dd**2*b2*f*r**2 + 792*Dd**2*b2*f*r*s - 792*Dd**2*b2*f*r - 198*Dd**2*b2*f*s + 132*Dd**2*b2*f - 3000*Dd**2*f**3*r**2 + 168*Dd**2*f**3*r*s + 1416*Dd**2*f**3*r - 42*Dd**2*f**3*s + 28*Dd**2*f**3 - 1716*Dd**2*f**2*r**2 - 1056*Dd**2*f**2*r*s + 1386*Dd**2*f**2*r + 264*Dd**2*f**2*s - 176*Dd**2*f**2 - 2112*Dd**2*f*g2*r**2 - 2112*Dd**2*f*g2*r*s + 2112*Dd**2*f*g2*r + 528*Dd**2*f*g2*s - 352*Dd**2*f*g2) - 286*b2*(-3*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 10*D1**2*f*fd*r**2 + 10*D1**2*f*fd*r*s - 10*D1**2*f*fd*r - 5*D1**2*f*fd*s + 5*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r + 3*D1**2*f*fdd*s - 3*D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 3*D1**2*fd**2*s + 20*D1*Dd*f**2*r**2 + 20*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r - 5*D1*Dd*f**2*s + 5*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r + 18*D1*Dd*f*fd*s - 12*D1*Dd*f*fd - 12*D1*Ddd*f**2*r**2 - 12*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r + 3*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + D1*bd1*(D1*(13*f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 36*Dd**2*f**2*r**2 - 36*Dd**2*f**2*r*s + 36*Dd**2*f**2*r + 9*Dd**2*f**2*s - 6*Dd**2*f**2))/(3003*d**2*k3**4) - D1**2*Pk3*Pkd1*ct*k2*st**2*(11*b1**2*(D1**2*r*(12*fd*(C*(4*r + 3*s - 3) - 3*r - 3*s + 3) + fdd*(4*C*(r - s + 1) - 3*r + 4*s - 4)) + D1*(2*Dd*(6*f*(C*(16*r**2 + 2*r*(6*s - 7) - 3*s + 4) - 12*r**2 - 12*r*(s - 1) + 3*s - 3) + fd*(2*C*(8*r**2 - 8*r*s + 4*r + s - 1) - 12*r**2 + 16*r*s - 9*r - 2*s + 2)) + Ddd*f*(4*C*(4*r**2 - 4*r*s + s + 1) - 12*r**2 + 16*r*s - 2*r - 4*s - 3)) + 2*Dd**2*f*(C*(24*r**2 - 24*r*s + 6*s - 4) - 18*r**2 + 24*r*s - 3*r - 6*s + 4)) + 11*b1*(32*C*D1**2*f*fd*r**2 - 40*C*D1**2*f*fd*r*s - 12*C*D1**2*f*fd*r - 4*C*D1**2*f*fd*s + 16*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*r + 4*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*r + 4*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 + 64*C*D1*Dd*f**2*r**2 - 80*C*D1*Dd*f**2*r*s + 8*C*D1*Dd*f**2*r + 20*C*D1*Dd*f**2*s + 16*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 64*C*D1*Dd*f*fd*r - 24*C*D1*Dd*f*fd*s - 12*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 40*C*D1*Ddd*f**2*r - 20*C*D1*Ddd*f**2*s + 240*C*Dd**2*f**2*r*s - 120*C*Dd**2*f**2*r - 60*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 + D1**2*bdd1*f*(4*C*(2*r**2 - 2*r*(s + 1) + s + 1) - 6*r**2 + r*(8*s + 6) - 4*s - 3) - 16*D1**2*f*fd*r**2 + 40*D1**2*f*fd*r*s + 4*D1**2*f*fd*r + 4*D1**2*f*fd*s - 12*D1**2*f*fd - 40*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 4*D1**2*f*fdd*s + 9*D1**2*f*fdd - 40*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 4*D1**2*fd**2*s + 4*D1**2*fd**2 - 32*D1*Dd*f**2*r**2 + 80*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r - 20*D1*Dd*f**2*s - 8*D1*Dd*f**2 - 320*D1*Dd*f*fd*r*s + 88*D1*Dd*f*fd*r + 24*D1*Dd*f*fd*s + 6*D1*Dd*f*fd - 80*D1*Ddd*f**2*r*s + 40*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s + 2*D1*bd1*(D1*(6*f*(C*(8*r**2 + 6*r*s - 8*r - 3*s + 4) - 6*r**2 - 6*r*s + 6*r + 3*s - 3) + fd*(2*C*(4*r**2 - 4*r*s + s - 1) - 6*r**2 + 8*r*s - r - 2*s + 2)) + Dd*f*(r**2*(32*C - 24) - 2*r*(8*C*(2*s + 1) - 16*s - 5) + s*(12*C - 12) + 1)) - 240*Dd**2*f**2*r*s + 120*Dd**2*f**2*r + 60*Dd**2*f**2*s - 40*Dd**2*f**2) + f*(-480*C*D1**2*f*fd*r**2 - 792*C*D1**2*f*fd*r*s + 584*C*D1**2*f*fd*r + 264*C*D1**2*f*fd*s - 160*C*D1**2*f*fd + 636*C*D1**2*f*fdd*r**2 + 792*C*D1**2*f*fdd*r*s - 688*C*D1**2*f*fdd*r - 264*C*D1**2*f*fdd*s + 212*C*D1**2*f*fdd + 1272*C*D1**2*fd**2*r**2 + 1584*C*D1**2*fd**2*r*s - 1376*C*D1**2*fd**2*r - 528*C*D1**2*fd**2*s + 264*C*D1**2*fd**2 - 640*C*D1*Dd*f**2*r**2 - 1056*C*D1*Dd*f**2*r*s + 848*C*D1*Dd*f**2*r + 264*C*D1*Dd*f**2*s - 160*C*D1*Dd*f**2 + 5088*C*D1*Dd*f*fd*r**2 + 6336*C*D1*Dd*f*fd*r*s - 5608*C*D1*Dd*f*fd*r - 1848*C*D1*Dd*f*fd*s + 1216*C*D1*Dd*f*fd + 848*C*D1*Ddd*f**2*r**2 + 1056*C*D1*Ddd*f**2*r*s - 952*C*D1*Ddd*f**2*r - 264*C*D1*Ddd*f**2*s + 212*C*D1*Ddd*f**2 + 2544*C*Dd**2*f**2*r**2 + 3168*C*Dd**2*f**2*r*s - 2856*C*Dd**2*f**2*r - 792*C*Dd**2*f**2*s + 528*C*Dd**2*f**2 + 22*D1**2*bd1**2*(r**2*(4*C - 3) + r*(-4*C*(s + 1) + 4*s + 3) + s*(2*C - 2)) + 11*D1**2*bdd1*f*(4*C*(r*(5*s - 6) - 6*s + 3) + r*(18 - 20*s) + 24*s - 9) + 396*D1**2*f*fd*r**2 + 696*D1**2*f*fd*r*s - 496*D1**2*f*fd*r - 232*D1**2*f*fd*s + 132*D1**2*f*fd - 429*D1**2*f*fdd*r**2 - 744*D1**2*f*fdd*r*s + 534*D1**2*f*fdd*r + 248*D1**2*f*fdd*s - 143*D1**2*f*fdd - 858*D1**2*fd**2*r**2 - 1488*D1**2*fd**2*r*s + 1068*D1**2*fd**2*r + 496*D1**2*fd**2*s - 248*D1**2*fd**2 + 528*D1*Dd*f**2*r**2 + 928*D1*Dd*f**2*r*s - 728*D1*Dd*f**2*r - 232*D1*Dd*f**2*s + 132*D1*Dd*f**2 - 3432*D1*Dd*f*fd*r**2 - 5952*D1*Dd*f*fd*r*s + 4482*D1*Dd*f*fd*r + 1736*D1*Dd*f*fd*s - 1030*D1*Dd*f*fd - 572*D1*Ddd*f**2*r**2 - 992*D1*Ddd*f**2*r*s + 782*D1*Ddd*f**2*r + 248*D1*Ddd*f**2*s - 143*D1*Ddd*f**2 + 22*D1*bd1*(D1*(2*f*(r**2*(4*C - 2) + r*(-s*(5*C - 5) - 2) + s*(6*C - 6) + 1) + fd*(2*C*(r*(20*s - 11) - 11*s + 6) + r*(19 - 40*s) + 22*s - 12)) + Dd*f*(C*(r*(80*s - 68) - 58*s + 36) + r*(56 - 80*s) + 58*s - 33)) - 1716*Dd**2*f**2*r**2 - 2976*Dd**2*f**2*r*s + 2346*Dd**2*f**2*r + 744*Dd**2*f**2*s - 496*Dd**2*f**2))/(231*d**2*k3**2) + D1**2*Pk3*Pkd1*ct*k2*(88*D1**2*K*bd1**2*f*r**2 - 88*D1**2*K*bd1**2*f*r*s + 704*D1**2*K*bd1**2*f*r + 308*D1**2*K*bd1**2*f*s - 308*D1**2*K*bd1**2*f + 220*D1**2*K*bd1*f**2*r**2 + 264*D1**2*K*bd1*f**2*r*s - 264*D1**2*K*bd1*f**2*r - 1496*D1**2*K*bd1*f*fd*r**2 - 1056*D1**2*K*bd1*f*fd*r*s + 1276*D1**2*K*bd1*f*fd*r + 264*D1**2*K*bd1*f*fd*s - 264*D1**2*K*bd1*f*fd - 374*D1**2*K*bdd1*f**2*r**2 - 264*D1**2*K*bdd1*f**2*r*s + 264*D1**2*K*bdd1*f**2*r + 1056*D1**2*bd1**2*f**2*r*s - 638*D1**2*bd1**2*f**2*r - 792*D1**2*bd1**2*f**2*s + 528*D1**2*bd1**2*f**2 + 616*D1**2*bd1**2*f*r*s - 682*D1**2*bd1**2*f*r - 572*D1**2*bd1**2*f*s + 572*D1**2*bd1**2*f - 616*D1**2*bd1**2*g2*r**2 - 1232*D1**2*bd1**2*g2*r*s + 616*D1**2*bd1**2*g2*r + 616*D1**2*bd1**2*g2*s - 660*D1**2*bd1*bd2*f*r**2 - 616*D1**2*bd1*bd2*f*r*s + 968*D1**2*bd1*bd2*f*r + 308*D1**2*bd1*bd2*f*s - 308*D1**2*bd1*bd2*f - 150*D1**2*bd1*f**3*r**2 - 660*D1**2*bd1*f**3*r*s + 440*D1**2*bd1*f**3*r + 1110*D1**2*bd1*f**2*fd*r**2 + 3960*D1**2*bd1*f**2*fd*r*s - 2570*D1**2*bd1*f**2*fd*r - 660*D1**2*bd1*f**2*fd*s + 440*D1**2*bd1*f**2*fd - 154*D1**2*bd1*f**2*r**2 - 440*D1**2*bd1*f**2*r*s + 440*D1**2*bd1*f**2*r + 836*D1**2*bd1*f*fd*r**2 + 1936*D1**2*bd1*f*fd*r*s - 1386*D1**2*bd1*f*fd*r - 484*D1**2*bd1*f*fd*s + 484*D1**2*bd1*f*fd + 176*D1**2*bd1*f*g2*r**2 - 176*D1**2*bd1*f*g2*r*s + 176*D1**2*bd1*f*g2*r + 616*D1**2*bd1*f*g2*s - 88*D1**2*bd1*f*g2 - 176*D1**2*bd1*f*gd2*r**2 + 176*D1**2*bd1*f*gd2*r*s - 1408*D1**2*bd1*f*gd2*r - 616*D1**2*bd1*f*gd2*s + 616*D1**2*bd1*f*gd2 - 176*D1**2*bd1*fd*g2*r**2 + 176*D1**2*bd1*fd*g2*r*s + 176*D1**2*bd1*fd*g2*r - 88*D1**2*bd1*fd*g2*s + 220*D1**2*bd2*f**2*r**2 + 264*D1**2*bd2*f**2*r*s - 264*D1**2*bd2*f**2*r - 1496*D1**2*bd2*f*fd*r**2 - 1056*D1**2*bd2*f*fd*r*s + 1276*D1**2*bd2*f*fd*r + 264*D1**2*bd2*f*fd*s - 264*D1**2*bd2*f*fd + 185*D1**2*bdd1*f**3*r**2 + 660*D1**2*bdd1*f**3*r*s - 440*D1**2*bdd1*f**3*r + 209*D1**2*bdd1*f**2*r**2 + 484*D1**2*bdd1*f**2*r*s - 484*D1**2*bdd1*f**2*r - 88*D1**2*bdd1*f*g2*r**2 + 88*D1**2*bdd1*f*g2*r*s - 1320*D1**2*bdd1*f*g2*r - 616*D1**2*bdd1*f*g2*s + 660*D1**2*bdd1*f*g2 - 374*D1**2*bdd2*f**2*r**2 - 264*D1**2*bdd2*f**2*r*s + 264*D1**2*bdd2*f**2*r - 440*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s + 528*D1**2*f**2*gd2*r + 748*D1**2*f**2*gdd2*r**2 + 528*D1**2*f**2*gdd2*r*s - 528*D1**2*f**2*gdd2*r - 880*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 880*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s - 440*D1**2*f*fd*g2 + 2992*D1**2*f*fd*gd2*r**2 + 2112*D1**2*f*fd*gd2*r*s - 2552*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s + 528*D1**2*f*fd*gd2 + 1496*D1**2*f*fdd*g2*r**2 + 1056*D1**2*f*fdd*g2*r*s - 1496*D1**2*f*fdd*g2*r - 528*D1**2*f*fdd*g2*s + 748*D1**2*f*fdd*g2 + 1496*D1**2*fd**2*g2*r**2 + 1056*D1**2*fd**2*g2*r*s - 1496*D1**2*fd**2*g2*r - 528*D1**2*fd**2*g2*s - 2992*D1*Dd*K*bd1*f**2*r**2 - 2112*D1*Dd*K*bd1*f**2*r*s + 2332*D1*Dd*K*bd1*f**2*r + 264*D1*Dd*K*bd1*f**2*s - 264*D1*Dd*K*bd1*f**2 + 1480*D1*Dd*bd1*f**3*r**2 + 5280*D1*Dd*bd1*f**3*r*s - 3450*D1*Dd*bd1*f**3*r - 660*D1*Dd*bd1*f**3*s + 440*D1*Dd*bd1*f**3 + 1672*D1*Dd*bd1*f**2*r**2 + 3872*D1*Dd*bd1*f**2*r*s - 3322*D1*Dd*bd1*f**2*r - 484*D1*Dd*bd1*f**2*s + 484*D1*Dd*bd1*f**2 - 704*D1*Dd*bd1*f*g2*r**2 + 704*D1*Dd*bd1*f*g2*r*s - 5280*D1*Dd*bd1*f*g2*r - 2552*D1*Dd*bd1*f*g2*s + 2552*D1*Dd*bd1*f*g2 - 2992*D1*Dd*bd2*f**2*r**2 - 2112*D1*Dd*bd2*f**2*r*s + 2332*D1*Dd*bd2*f**2*r + 264*D1*Dd*bd2*f**2*s - 264*D1*Dd*bd2*f**2 - 1760*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s + 1936*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s - 440*D1*Dd*f**2*g2 + 5984*D1*Dd*f**2*gd2*r**2 + 4224*D1*Dd*f**2*gd2*r*s - 4664*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s + 528*D1*Dd*f**2*gd2 + 11968*D1*Dd*f*fd*g2*r**2 + 8448*D1*Dd*f*fd*g2*r*s - 11088*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s + 2552*D1*Dd*f*fd*g2 + 2992*D1*Ddd*f**2*g2*r**2 + 2112*D1*Ddd*f**2*g2*r*s - 2552*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s + 748*D1*Ddd*f**2*g2 + 8976*Dd**2*f**2*g2*r**2 + 6336*Dd**2*f**2*g2*r*s - 7656*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s + 1056*Dd**2*f**2*g2 + 11*b1**3*(D1**2*r*(2*fd*(r + 14*s - 14) + fdd*(-15*r - 28*s + 28)) + D1*(2*Dd*(-14*K*(4*r**2 + 8*r*s - 6*r - 2*s + 1) + f*(4*r**2 + r*(56*s - 30) - 14*s + 1) + fd*(-60*r**2 + r*(99 - 112*s) + 14*s - 14) + 28*r**2 + 112*r*s - 70*r - 28*s + 7) + Ddd*(14*K*(4*r**2 + 8*r*s - 6*r - 2*s + 1) + f*(-60*r**2 + r*(86 - 112*s) + 28*s - 15) - 28*r**2 - 112*r*s + 70*r + 28*s - 7)) - 2*Dd**2*(-14*K*(6*r**2 + 12*r*s - 9*r - 3*s + 2) + f*(90*r**2 + 3*r*(56*s - 43) - 42*s + 28) + 42*r**2 + 168*r*s - 105*r - 42*s + 28)) + 11*b1**2*(-8*D1**2*K*fd*r**2 + 8*D1**2*K*fd*r*s + 24*D1**2*K*fd*r + 20*D1**2*K*fd*s - 12*D1**2*K*fd + 4*D1**2*K*fdd*r**2 - 4*D1**2*K*fdd*r*s - 68*D1**2*K*fdd*r - 24*D1**2*K*fdd*s + 34*D1**2*K*fdd + D1**2*bdd1*(14*K*(3*r - 1)*(r + 2*s - 1) + f*(-45*r**2 + r*(58 - 84*s) + 28*s - 15) - 21*r**2 - 84*r*s + 42*r + 28*s - 7) - 96*D1**2*f*fd*r*s + 52*D1**2*f*fd*r - 24*D1**2*f*fd*s + 10*D1**2*f*fd + 96*D1**2*f*fdd*r*s - 38*D1**2*f*fdd*r + 24*D1**2*f*fdd*s - 17*D1**2*f*fdd + 96*D1**2*fd**2*r*s - 38*D1**2*fd**2*r + 24*D1**2*fd**2*s - 24*D1**2*fd**2 - 28*D1**2*fd*r*s - 12*D1**2*fd*r - 20*D1**2*fd*s + 6*D1**2*fd + 28*D1**2*fdd*r*s + 34*D1**2*fdd*r + 24*D1**2*fdd*s - 17*D1**2*fdd + 56*D1**2*gd2*r**2 + 112*D1**2*gd2*r*s - 112*D1**2*gd2*r - 28*D1**2*gdd2*r**2 - 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*r - 32*D1*Dd*K*f*r**2 + 32*D1*Dd*K*f*r*s - 8*D1*Dd*K*f*s - 8*D1*Dd*K*f + 32*D1*Dd*K*fd*r**2 - 32*D1*Dd*K*fd*r*s - 272*D1*Dd*K*fd*r - 92*D1*Dd*K*fd*s + 116*D1*Dd*K*fd - 192*D1*Dd*f**2*r*s + 96*D1*Dd*f**2*r + 48*D1*Dd*f**2*s + 768*D1*Dd*f*fd*r*s - 344*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 112*D1*Dd*f*r*s + 56*D1*Dd*f*r + 28*D1*Dd*f*s + 224*D1*Dd*fd*r*s + 80*D1*Dd*fd*r + 68*D1*Dd*fd*s - 82*D1*Dd*fd + 224*D1*Dd*g2*r**2 + 448*D1*Dd*g2*r*s - 336*D1*Dd*g2*r - 112*D1*Dd*g2*s + 56*D1*Dd*g2 - 224*D1*Dd*gd2*r**2 - 448*D1*Dd*gd2*r*s + 392*D1*Dd*gd2*r + 56*D1*Dd*gd2*s - 56*D1*Dd*gd2 + 16*D1*Ddd*K*f*r**2 - 16*D1*Ddd*K*f*r*s + 4*D1*Ddd*K*f*s + 4*D1*Ddd*K*f + 192*D1*Ddd*f**2*r*s - 96*D1*Ddd*f**2*r - 48*D1*Ddd*f**2*s + 112*D1*Ddd*f*r*s - 56*D1*Ddd*f*r - 28*D1*Ddd*f*s - 112*D1*Ddd*g2*r**2 - 224*D1*Ddd*g2*r*s + 168*D1*Ddd*g2*r + 56*D1*Ddd*g2*s - 28*D1*Ddd*g2 + 2*D1*bd1*(D1*f*(3*r**2 + 2*r*(21*s - 8) - 14*s + 1) + D1*fd*(-45*r**2 + r*(71 - 84*s) + 14*s - 14) - 7*D1*(2*K*(3*r - 1)*(r + 2*s - 1) - 3*r**2 + r*(6 - 12*s) + 4*s - 1) + Dd*f*(-180*r**2 - 7*r*(48*s - 35) + 98*s - 57) + 7*Dd*(2*K*(12*r**2 + r*(24*s - 17) - 7*s + 4) - 12*r**2 + r*(27 - 48*s) + 14*s - 7)) + 48*Dd**2*K*f*r**2 - 48*Dd**2*K*f*r*s + 12*Dd**2*K*f*s - 8*Dd**2*K*f + 576*Dd**2*f**2*r*s - 288*Dd**2*f**2*r - 144*Dd**2*f**2*s + 96*Dd**2*f**2 + 336*Dd**2*f*r*s - 168*Dd**2*f*r - 84*Dd**2*f*s + 56*Dd**2*f - 336*Dd**2*g2*r**2 - 672*Dd**2*g2*r*s + 504*Dd**2*g2*r + 168*Dd**2*g2*s - 112*Dd**2*g2) - b1*(-440*D1**2*K*f*fd*r**2 - 528*D1**2*K*f*fd*r*s + 440*D1**2*K*f*fd*r + 264*D1**2*K*f*fd*s - 220*D1**2*K*f*fd + 748*D1**2*K*f*fdd*r**2 + 528*D1**2*K*f*fdd*r*s - 748*D1**2*K*f*fdd*r - 264*D1**2*K*f*fdd*s + 374*D1**2*K*f*fdd + 748*D1**2*K*fd**2*r**2 + 528*D1**2*K*fd**2*r*s - 748*D1**2*K*fd**2*r - 264*D1**2*K*fd**2*s - 44*D1**2*b2*fd*r**2 - 308*D1**2*b2*fd*r*s + 330*D1**2*b2*fdd*r**2 + 308*D1**2*b2*fdd*r*s + 22*D1**2*bd1**2*(-14*K*(3*r - 1)*(r + 2*s - 1) + f*(45*r**2 + r*(84*s - 58) - 28*s + 14) + 21*r**2 + 84*r*s - 42*r - 28*s + 14) - 44*D1**2*bd2*f*r**2 - 308*D1**2*bd2*f*r*s + 308*D1**2*bd2*f*r + 660*D1**2*bd2*fd*r**2 + 616*D1**2*bd2*fd*r*s - 308*D1**2*bd2*fd*r - 11*D1**2*bdd1*(f**2*(r*(96*s - 58) - 72*s + 17) + f*(K*(8*r**2 - 8*r*(s - 8) + 28*s - 30) + 56*r*s - 62*r - 52*s + 17) - 28*g2*(2*r**2 + r*(4*s - 2) - 2*s + 1)) + 330*D1**2*bdd2*f*r**2 + 308*D1**2*bdd2*f*r*s - 308*D1**2*bdd2*f*r + 450*D1**2*f**2*fd*r**2 + 1980*D1**2*f**2*fd*r*s - 1180*D1**2*f**2*fd*r - 660*D1**2*f**2*fd*s + 150*D1**2*f**2*fd - 555*D1**2*f**2*fdd*r**2 - 1980*D1**2*f**2*fdd*r*s + 1250*D1**2*f**2*fdd*r + 660*D1**2*f**2*fdd*s - 185*D1**2*f**2*fdd - 1110*D1**2*f*fd**2*r**2 - 3960*D1**2*f*fd**2*r*s + 2500*D1**2*f*fd**2*r + 1320*D1**2*f*fd**2*s - 880*D1**2*f*fd**2 + 308*D1**2*f*fd*r**2 + 880*D1**2*f*fd*r*s - 308*D1**2*f*fd*r - 440*D1**2*f*fd*s + 154*D1**2*f*fd - 418*D1**2*f*fdd*r**2 - 968*D1**2*f*fdd*r*s + 418*D1**2*f*fdd*r + 484*D1**2*f*fdd*s - 209*D1**2*f*fdd - 176*D1**2*f*gd2*r**2 + 176*D1**2*f*gd2*r*s - 176*D1**2*f*gd2*r + 88*D1**2*f*gdd2*r**2 - 88*D1**2*f*gdd2*r*s + 88*D1**2*f*gdd2*r - 418*D1**2*fd**2*r**2 - 968*D1**2*fd**2*r*s + 418*D1**2*fd**2*r + 484*D1**2*fd**2*s - 176*D1**2*fd*g2*r**2 + 176*D1**2*fd*g2*r*s + 528*D1**2*fd*g2*r + 440*D1**2*fd*g2*s - 264*D1**2*fd*g2 + 176*D1**2*fd*gd2*r**2 - 176*D1**2*fd*gd2*r*s - 1408*D1**2*fd*gd2*r - 528*D1**2*fd*gd2*s + 528*D1**2*fd*gd2 + 88*D1**2*fdd*g2*r**2 - 88*D1**2*fdd*g2*r*s - 1496*D1**2*fdd*g2*r - 528*D1**2*fdd*g2*s + 748*D1**2*fdd*g2 - 880*D1*Dd*K*f**2*r**2 - 1056*D1*Dd*K*f**2*r*s + 968*D1*Dd*K*f**2*r + 264*D1*Dd*K*f**2*s - 220*D1*Dd*K*f**2 + 5984*D1*Dd*K*f*fd*r**2 + 4224*D1*Dd*K*f*fd*r*s - 5544*D1*Dd*K*f*fd*r - 1584*D1*Dd*K*f*fd*s + 1276*D1*Dd*K*f*fd - 176*D1*Dd*b2*f*r**2 - 1232*D1*Dd*b2*f*r*s + 704*D1*Dd*b2*f*r + 308*D1*Dd*b2*f*s - 44*D1*Dd*b2*f + 2640*D1*Dd*b2*fd*r**2 + 2464*D1*Dd*b2*fd*r*s - 1276*D1*Dd*b2*fd*r - 308*D1*Dd*b2*fd*s + 2640*D1*Dd*bd2*f*r**2 + 2464*D1*Dd*bd2*f*r*s - 2508*D1*Dd*bd2*f*r - 308*D1*Dd*bd2*f*s + 308*D1*Dd*bd2*f + 600*D1*Dd*f**3*r**2 + 2640*D1*Dd*f**3*r*s - 1620*D1*Dd*f**3*r - 660*D1*Dd*f**3*s + 150*D1*Dd*f**3 - 4440*D1*Dd*f**2*fd*r**2 - 15840*D1*Dd*f**2*fd*r*s + 10070*D1*Dd*f**2*fd*r + 4620*D1*Dd*f**2*fd*s - 2570*D1*Dd*f**2*fd + 616*D1*Dd*f**2*r**2 + 1760*D1*Dd*f**2*r*s - 1188*D1*Dd*f**2*r - 440*D1*Dd*f**2*s + 154*D1*Dd*f**2 - 3344*D1*Dd*f*fd*r**2 - 7744*D1*Dd*f*fd*r*s + 4444*D1*Dd*f*fd*r + 2904*D1*Dd*f*fd*s - 1386*D1*Dd*f*fd - 704*D1*Dd*f*g2*r**2 + 704*D1*Dd*f*g2*r*s - 176*D1*Dd*f*g2*s - 176*D1*Dd*f*g2 + 704*D1*Dd*f*gd2*r**2 - 704*D1*Dd*f*gd2*r*s + 352*D1*Dd*f*gd2*r + 88*D1*Dd*f*gd2*s - 88*D1*Dd*f*gd2 + 704*D1*Dd*fd*g2*r**2 - 704*D1*Dd*fd*g2*r*s - 5984*D1*Dd*fd*g2*r - 2024*D1*Dd*fd*g2*s + 2552*D1*Dd*fd*g2 + 1496*D1*Ddd*K*f**2*r**2 + 1056*D1*Ddd*K*f**2*r*s - 1276*D1*Ddd*K*f**2*r - 264*D1*Ddd*K*f**2*s + 374*D1*Ddd*K*f**2 + 1320*D1*Ddd*b2*f*r**2 + 1232*D1*Ddd*b2*f*r*s - 1276*D1*Ddd*b2*f*r - 308*D1*Ddd*b2*f*s + 330*D1*Ddd*b2*f - 740*D1*Ddd*f**3*r**2 - 2640*D1*Ddd*f**3*r*s + 1690*D1*Ddd*f**3*r + 660*D1*Ddd*f**3*s - 185*D1*Ddd*f**3 - 836*D1*Ddd*f**2*r**2 - 1936*D1*Ddd*f**2*r*s + 1386*D1*Ddd*f**2*r + 484*D1*Ddd*f**2*s - 209*D1*Ddd*f**2 + 352*D1*Ddd*f*g2*r**2 - 352*D1*Ddd*f*g2*r*s + 88*D1*Ddd*f*g2*s + 88*D1*Ddd*f*g2 + 22*D1*bd1*(D1*(f**2*(r*(48*s - 22) - 36*s + 5) + f*(2*K*(4*r**2 - 4*r*s + 4*r + 7*s - 1) - 12*fd*(8*r*(2*s - 1) - 4*s + 3) + 28*r*s - 20*r - 24*s + 3) + fd*(K*(-8*r**2 + 8*r*s + 36*r + 10*s - 12) - r*(56*s + 3) + 2*s + 12) - 28*g2*(2*r**2 + r*(4*s - 2) - 2*s + 1) - 28*gd2*(-2*r**2 + r*(3 - 4*s) + s - 1)) + Dd*(f**2*(-4*r*(96*s - 53) + 192*s - 101) + f*(-4*K*(8*r**2 - 8*r*(s - 4) + 15*s - 15) - 224*r*s + 180*r + 132*s - 83) + 28*g2*(8*r**2 + 2*r*(8*s - 5) - 6*s + 3))) + 4488*Dd**2*K*f**2*r**2 + 3168*Dd**2*K*f**2*r*s - 3828*Dd**2*K*f**2*r - 792*Dd**2*K*f**2*s + 528*Dd**2*K*f**2 + 3960*Dd**2*b2*f*r**2 + 3696*Dd**2*b2*f*r*s - 3828*Dd**2*b2*f*r - 924*Dd**2*b2*f*s + 616*Dd**2*b2*f - 2220*Dd**2*f**3*r**2 - 7920*Dd**2*f**3*r*s + 5070*Dd**2*f**3*r + 1980*Dd**2*f**3*s - 1320*Dd**2*f**3 - 2508*Dd**2*f**2*r**2 - 5808*Dd**2*f**2*r*s + 4158*Dd**2*f**2*r + 1452*Dd**2*f**2*s - 968*Dd**2*f**2 + 1056*Dd**2*f*g2*r**2 - 1056*Dd**2*f*g2*r*s + 264*Dd**2*f*g2*s - 176*Dd**2*f*g2) + 22*b2*(-D1**2*bdd1*f*(r - 1)*(15*r + 14*s - 15) + 20*D1**2*f*fd*r**2 + 24*D1**2*f*fd*r*s - 20*D1**2*f*fd*r - 12*D1**2*f*fd*s + 10*D1**2*f*fd - 34*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 34*D1**2*f*fdd*r + 12*D1**2*f*fdd*s - 17*D1**2*f*fdd - 34*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 34*D1**2*fd**2*r + 12*D1**2*fd**2*s + 40*D1*Dd*f**2*r**2 + 48*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r - 12*D1*Dd*f**2*s + 10*D1*Dd*f**2 - 272*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 252*D1*Dd*f*fd*r + 72*D1*Dd*f*fd*s - 58*D1*Dd*f*fd - 68*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 58*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s - 17*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(r - 1)*(r + 7*s - 1) + fd*(-15*r**2 - 14*r*s + 15*r + 7*s)) + Dd*f*(-60*r**2 + r*(89 - 56*s) + 35*s - 29)) - 204*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 174*Dd**2*f**2*r + 36*Dd**2*f**2*s - 24*Dd**2*f**2))/(231*d**2*k3**2) - D1**2*Pk3*Pkd1*ct*st**2*(4*C - 2)*(D1*f*(3*D1*bd1**2*s*(1 - 2*r) + D1*bd1*(5*f*r*s + 3*fd*(-4*r*s + r + s)) - 3*D1*bdd1*f*r*s + 3*Dd*bd1*f*(r*(2 - 8*s) + s)) + b1**2*(D1*Dd*(13*f*(4*r*s - 2*r - s) - 3*fd*(8*r*s - 6*r - s + 1)) + D1*(D1*r*(13*fd - 3*fdd)*(s - 1) + 3*Ddd*f*(-4*r*s + 2*r + s)) + 3*Dd**2*f*(r*(6 - 12*s) + 3*s - 2)) + b1*(D1*Dd*f*(5*f*r*(4*s - 2) - 5*f*s - 3*fd*(8*r - 3)*(2*s - 1)) + D1*bd1*(D1*(13*f*s*(2*r - 1) + 3*fd*(-4*r*s + 2*r + s - 1)) - 6*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(5*f*fd*(r*(2*s - 1) - s) + 3*f*(bdd1*s*(1 - 2*r) + fdd*(-2*r*s + r + s)) + 3*fd**2*(-2*r*s + r + s - 1)) + 3*Ddd*f**2*(r*(2 - 4*s) + s)) + 3*Dd**2*f**2*(r*(6 - 12*s) + 3*s - 2)))/(21*d**2*k2) + D1**2*Pk3*Pkd1*ct*(8*C - 4)*(D1*f*(7*D1*bd1**2*s*(1 - 2*r) - 6*D1*bdd1*f*r*s + 6*bd1*(D1*(f*r*s + fd*(-4*r*s + r + s)) + Dd*f*(r*(2 - 8*s) + s))) - 7*b1**2*(D1*Dd*(f*r*(2 - 4*s) + f*s + fd*r*(8*s - 6) - fd*s + fd) - D1*(D1*r*(fd - fdd)*(s - 1) + Ddd*f*(r*(2 - 4*s) + s)) + Dd**2*f*(6*r*(2*s - 1) - 3*s + 2)) + b1*(6*D1*Dd*f*(f*r*(4*s - 2) - f*s - fd*(8*r - 3)*(2*s - 1)) + 7*D1*bd1*(D1*(f*s*(2*r - 1) + fd*(-4*r*s + 2*r + s - 1)) - 2*Dd*f*(r*(8*s - 2) - 3*s + 1)) + D1*(D1*(7*bdd1*f*s*(1 - 2*r) + 6*f*fd*r*(2*s - 1) - 6*f*fd*s + 6*f*fdd*(-2*r*s + r + s) + 6*fd**2*(-2*r*s + r + s - 1)) + 6*Ddd*f**2*(r*(2 - 4*s) + s)) - 6*Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2)))/(21*d**2*k2) + D1**2*Pk3*Pkd1*ct*k2**3*st**4*(132*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 - 6*D1**2*f**2*fd*r**2 + 4*D1**2*f**2*fd*r - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 - 2*D1**2*f**2*fdd*r + D1**2*f**2*fdd + 6*D1**2*f*fd**2*r**2 - 4*D1**2*f*fd**2*r + 264*D1*Dd*b1*f**2*r**2 - 132*D1*Dd*b1*f**2*r + 66*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r - 8*D1*Dd*f**3*r**2 + 4*D1*Dd*f**3*r - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 - 14*D1*Dd*f**2*fd*r + 2*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 + 4*D1*Ddd*f**3*r**2 - 2*D1*Ddd*f**3*r + D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 2*D1*fd*r + Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r + 12*Dd**2*f**3*r**2 - 6*Dd**2*f**3*r)/(231*d**2*k1**2*k3**2) + D1**2*Pk3*Pkd1*ct*k2**3*st**2*(D1*f*r*(-66*D1*bd1**2*(2*f + 1)*(r - 1) + D1*bdd1*f*r*(6*f + 11) + 2*bd1*(-D1*f*r*(6*f + 11) + D1*fd*(6*f*(3*r - 1) + 22*r - 11) + Dd*f*(6*f + 11)*(4*r - 1))) + 33*b1**2*(-D1**2*r**2*(4*f*fdd + 4*fd**2 + fd*(-8*f - 2) + fdd) + D1*(2*Dd*(f**2*(8*r**2 - 4*r + 2) + f*r**2*(4 - 16*fd) + f*r*(4*fd - 2) + f + fd*r*(1 - 4*r)) - Ddd*f*(2*f + 1)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(2*f + 1)*(2*r - 1)) + b1*(-33*D1**2*bdd1*f*(2*f + 1)*(2*r**2 - 2*r + 1) - 36*D1**2*f**2*fd*r**2 + 24*D1**2*f**2*fd*r - 12*D1**2*f**2*fd + 18*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r + 6*D1**2*f**2*fdd + 36*D1**2*f*fd**2*r**2 - 24*D1**2*f*fd**2*r - 44*D1**2*f*fd*r**2 + 44*D1**2*f*fd*r - 22*D1**2*f*fd + 22*D1**2*f*fdd*r**2 - 22*D1**2*f*fdd*r + 11*D1**2*f*fdd + 22*D1**2*fd**2*r**2 - 22*D1**2*fd**2*r - 48*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r - 12*D1*Dd*f**3 + 144*D1*Dd*f**2*fd*r**2 - 84*D1*Dd*f**2*fd*r + 12*D1*Dd*f**2*fd - 88*D1*Dd*f**2*r**2 + 44*D1*Dd*f**2*r - 22*D1*Dd*f**2 + 176*D1*Dd*f*fd*r**2 - 132*D1*Dd*f*fd*r + 22*D1*Dd*f*fd + 24*D1*Ddd*f**3*r**2 - 12*D1*Ddd*f**3*r + 6*D1*Ddd*f**3 + 44*D1*Ddd*f**2*r**2 - 22*D1*Ddd*f**2*r + 11*D1*Ddd*f**2 + 66*D1*bd1*(D1*(f**2*(4*r**2 - 4*r + 2) + f*r**2*(2 - 8*fd) + f*r*(4*fd - 2) + f + fd*r*(1 - 2*r)) - Dd*f*(2*f + 1)*(8*r**2 - 6*r + 1)) + 72*Dd**2*f**3*r**2 - 36*Dd**2*f**3*r + 132*Dd**2*f**2*r**2 - 66*Dd**2*f**2*r))/(231*d**2*k1**2*k3**2) + D1**2*Pk3*Pkd1*ct*k2*st**2*(D1*f*r*(-6*D1*bd1**2*(r - 1) + D1*bdd1*f*r - 2*bd1*(D1*(f*r - 2*fd*r + fd) + Dd*(-4*f*r + f))) + 3*b1**2*(D1**2*r**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*r**2 - 2*r + 1) + fd*r*(1 - 4*r)) + D1*Ddd*f*(-4*r**2 + 2*r - 1) + 6*Dd**2*f*r*(1 - 2*r)) + b1*(-3*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 4*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r - 2*D1**2*f*fd + 2*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r + D1**2*f*fdd + 2*D1**2*fd**2*r**2 - 2*D1**2*fd**2*r - 8*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r - 2*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 - 12*D1*Dd*f*fd*r + 2*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 - 2*D1*Ddd*f**2*r + D1*Ddd*f**2 + 6*D1*bd1*(D1*f*(2*r**2 - 2*r + 1) + D1*fd*r*(1 - 2*r) + Dd*f*(-8*r**2 + 6*r - 1)) + 12*Dd**2*f**2*r**2 - 6*Dd**2*f**2*r))/(21*d**2*k1**2) - D1**2*Pk3*Pkd1*ct*k2*(2*D1**2*bd1**2*f*r**2*(3*f + 7) + 2*D1*b1*r*(3*D1*bd1**2*(3*f + 7)*(3*r - 2) + D1*bdd1*f*r*(3*f + 7) + 2*bd1*(-D1*f*r*(3*f + 7) + D1*fd*(6*f*r - 3*f + 7*r - 7) + Dd*f*(3*f + 7)*(4*r - 1))) - 3*b1**3*(3*D1**2*r**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*r**2 - 2*r + 1) - r**2*(12*fd - 28) + r*(3*fd - 14) + 7) - D1*Ddd*(3*f + 7)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(3*f + 7)*(2*r - 1)) + b1**2*(3*D1**2*bdd1*(3*f + 7)*(3*r**2 - 2*r + 1) - 12*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r - 6*D1**2*f*fd + 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r - 14*D1**2*fd*r**2 + 28*D1**2*fd*r - 14*D1**2*fd + 7*D1**2*fdd*r**2 - 14*D1**2*fdd*r + 7*D1**2*fdd - 24*D1*Dd*f**2*r**2 + 12*D1*Dd*f**2*r - 6*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 - 36*D1*Dd*f*fd*r + 6*D1*Dd*f*fd - 56*D1*Dd*f*r**2 + 28*D1*Dd*f*r - 14*D1*Dd*f + 56*D1*Dd*fd*r**2 - 70*D1*Dd*fd*r + 14*D1*Dd*fd + 12*D1*Ddd*f**2*r**2 - 6*D1*Ddd*f**2*r + 3*D1*Ddd*f**2 + 28*D1*Ddd*f*r**2 - 14*D1*Ddd*f*r + 7*D1*Ddd*f - 6*D1*bd1*(D1*(f*(9*r**2 - 6*r + 3) + r**2*(21 - 9*fd) + r*(3*fd - 14) + 7) - Dd*(3*f + 7)*(12*r**2 - 7*r + 1)) + 36*Dd**2*f**2*r**2 - 18*Dd**2*f**2*r + 84*Dd**2*f*r**2 - 42*Dd**2*f*r))/(21*d**2*k1**2) + D1**2*Pk3*Pkd1*f*k1**3*k2**2*st**4*(16*C - 8)*(11*D1**2*bd1*f*(r - 1)*(r + s - 1) + 6*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s - 6*D1**2*f*fd*r - 2*D1**2*f*fd*s + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 - 3*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + D1**2*f*fdd*s - D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 2*D1**2*fd**2*s - D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 - 24*D1*Dd*f*fd*r*s + 24*D1*Dd*f*fd*r + 7*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 4*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r + D1*Ddd*f**2*s - D1*Ddd*f**2 + 11*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd**2*f**2*r**2 - 12*Dd**2*f**2*r*s + 12*Dd**2*f**2*r + 3*Dd**2*f**2*s - 2*Dd**2*f**2)/(77*d**2*k3**6) + D1**2*Pk3*Pkd1*f*k1**3*st**4*(16*C - 8)*(D1*Dd*f*(2*f*(4*r*s - 2*r - s) + fd*(-24*r*s + 10*r + 7*s - 3)) + D1*(D1*(2*f*fd*(3*r*s - r - s) + f*fdd*(-3*r*s + r + s) + fd**2*(-6*r*s + 2*r + 2*s - 1)) + Ddd*f**2*(r*(2 - 4*s) + s)) + Dd**2*f**2*(r*(6 - 12*s) + 3*s - 2))/(231*d**2*k3**4) - 8*D1**2*Pk3*Pkd1*f*k1*k2**4*st**4*(429*D1*b1**2*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 13*b1*(33*D1**2*bd1*f*(2*r - 1)*(r + s - 1) - 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*s + 2*s - 2) - 2*fd**2*(3*r**2 + 3*r*s + 2*s - 1)) - 2*D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 + r*(12 - 24*s) - 5*s + 4)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + f*(26*D1**2*bdd1*f*(r - 3)*(r + s - 1) - 3*D1**2*(f*(27*fd - 20*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 20*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 26*D1*bd1*(D1*(2*f*(r - 3)*(r + s - 1) + fd*(-6*r**2 - 6*r*(s - 2) + 7*s - 4)) + Dd*f*(-8*r**2 + r*(20 - 8*s) + 13*s - 10)) - 3*D1*f*(Dd*(27*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 40*fd*(4*r - 1)*(4*r + 4*s - 3)) - 20*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 60*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(3003*d**2*k3**6) + D1**2*Pk3*Pkd1*f*k1*st**4*(16*C - 8)*(D1*Dd*f*(2*f*(-4*r*s + 2*r + s) + fd*(24*r*s - 10*r - 7*s + 3)) + D1*(D1*(2*f*fd*(-3*r*s + r + s) + f*fdd*(3*r*s - r - s) + fd**2*(6*r*s - 2*r - 2*s + 1)) + Ddd*f**2*(r*(4*s - 2) - s)) + Dd**2*f**2*(6*r*(2*s - 1) - 3*s + 2))/(231*d**2*k3**2) + 20*D1**2*Pk3*Pkd1*f*k2**6*st**6*(-78*D1**2*b1*f*fd*r**2 - 78*D1**2*b1*f*fd*r*s + 52*D1**2*b1*f*fd*r + 39*D1**2*b1*f*fdd*r**2 + 39*D1**2*b1*f*fdd*r*s - 26*D1**2*b1*f*fdd*r + 78*D1**2*b1*fd**2*r**2 + 78*D1**2*b1*fd**2*r*s - 52*D1**2*b1*fd**2*r + 13*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 24*D1**2*f**2*fd*r**2 + 24*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s - 3*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 36*D1**2*f*fd**2*r + 9*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 - 104*D1*Dd*b1*f**2*r**2 - 104*D1*Dd*b1*f**2*r*s + 104*D1*Dd*b1*f**2*r + 26*D1*Dd*b1*f**2*s - 26*D1*Dd*b1*f**2 + 312*D1*Dd*b1*f*fd*r**2 + 312*D1*Dd*b1*f*fd*r*s - 260*D1*Dd*b1*f*fd*r - 39*D1*Dd*b1*f*fd*s + 26*D1*Dd*b1*f*fd + 24*D1*Dd*f**3*r**2 + 24*D1*Dd*f**3*r*s - 24*D1*Dd*f**3*r - 6*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 96*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s - 18*D1*Dd*f**2*fd + 52*D1*Ddd*b1*f**2*r**2 + 52*D1*Ddd*b1*f**2*r*s - 52*D1*Ddd*b1*f**2*r - 13*D1*Ddd*b1*f**2*s + 13*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 12*D1*Ddd*f**3*r*s + 12*D1*Ddd*f**3*r + 3*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 - 13*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) + 156*Dd**2*b1*f**2*r**2 + 156*Dd**2*b1*f**2*r*s - 156*Dd**2*b1*f**2*r - 39*Dd**2*b1*f**2*s + 26*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 36*Dd**2*f**3*r*s + 36*Dd**2*f**3*r + 9*Dd**2*f**3*s - 6*Dd**2*f**3)/(9009*d**2*k1*k3**6) + D1**2*Pk3*Pkd1*k1**5*st**2*(8*C - 4)*(66*D1**2*b1*f*fd*r**2 + 66*D1**2*b1*f*fd*r*s - 33*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 33*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 51*D1**2*f**2*fd*r**2 + 51*D1**2*f**2*fd*r*s - 51*D1**2*f**2*fd*r - 17*D1**2*f**2*fd*s + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 132*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r - 33*D1*Dd*b1*f**2*s + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 396*D1*Dd*b1*f*fd*r + 66*D1*Dd*b1*f*fd*s - 33*D1*Dd*b1*f*fd + 68*D1*Dd*f**3*r**2 + 68*D1*Dd*f**3*r*s - 68*D1*Dd*f**3*r - 17*D1*Dd*f**3*s + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 600*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s - 125*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r + 99*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 300*Dd**2*f**3*r + 75*Dd**2*f**3*s - 50*Dd**2*f**3)/(693*d**2*k3**6) + 8*D1**2*Pk3*Pkd1*k1**5*(5*D1**2*K*b1**2*fd*r**2 + 5*D1**2*K*b1**2*fd*r*s - 6*D1**2*K*b1**2*fdd*r**2 - 6*D1**2*K*b1**2*fdd*r*s + 8*D1**2*K*b1*f*fd*r**2 + 8*D1**2*K*b1*f*fd*r*s - 8*D1**2*K*b1*f*fd*r - 4*D1**2*K*b1*f*fd*s + 4*D1**2*K*b1*f*fd - 10*D1**2*K*b1*f*fdd*r**2 - 10*D1**2*K*b1*f*fdd*r*s + 10*D1**2*K*b1*f*fdd*r + 5*D1**2*K*b1*f*fdd*s - 5*D1**2*K*b1*f*fdd - 10*D1**2*K*b1*fd**2*r**2 - 10*D1**2*K*b1*fd**2*r*s + 10*D1**2*K*b1*fd**2*r + 5*D1**2*K*b1*fd**2*s - 6*D1**2*K*bd1**2*f*(2*r - 1)*(r + s - 1) - 10*D1**2*b1*f*gd2*r**2 - 10*D1**2*b1*f*gd2*r*s + 10*D1**2*b1*f*gd2*r + 12*D1**2*b1*f*gdd2*r**2 + 12*D1**2*b1*f*gdd2*r*s - 12*D1**2*b1*f*gdd2*r - 10*D1**2*b1*fd*g2*r**2 - 10*D1**2*b1*fd*g2*r*s + 24*D1**2*b1*fd*gd2*r**2 + 24*D1**2*b1*fd*gd2*r*s - 12*D1**2*b1*fd*gd2*r + 12*D1**2*b1*fdd*g2*r**2 + 12*D1**2*b1*fdd*g2*r*s + D1**2*bdd1*f*(r + s - 1)*(K*b1*(6 - 12*r) - 5*K*f*r + 12*g2*(r - 1)) - 8*D1**2*f**2*gd2*r**2 - 8*D1**2*f**2*gd2*r*s + 8*D1**2*f**2*gd2*r + 10*D1**2*f**2*gdd2*r**2 + 10*D1**2*f**2*gdd2*r*s - 10*D1**2*f**2*gdd2*r - 16*D1**2*f*fd*g2*r**2 - 16*D1**2*f*fd*g2*r*s + 16*D1**2*f*fd*g2*r + 8*D1**2*f*fd*g2*s - 8*D1**2*f*fd*g2 + 40*D1**2*f*fd*gd2*r**2 + 40*D1**2*f*fd*gd2*r*s - 40*D1**2*f*fd*gd2*r - 10*D1**2*f*fd*gd2*s + 10*D1**2*f*fd*gd2 + 20*D1**2*f*fdd*g2*r**2 + 20*D1**2*f*fdd*g2*r*s - 20*D1**2*f*fdd*g2*r - 10*D1**2*f*fdd*g2*s + 10*D1**2*f*fdd*g2 + 20*D1**2*fd**2*g2*r**2 + 20*D1**2*fd**2*g2*r*s - 20*D1**2*fd**2*g2*r - 10*D1**2*fd**2*g2*s + 20*D1*Dd*K*b1**2*f*r**2 + 20*D1*Dd*K*b1**2*f*r*s - 20*D1*Dd*K*b1**2*f*r - 5*D1*Dd*K*b1**2*f*s + 5*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 48*D1*Dd*K*b1**2*fd*r*s + 24*D1*Dd*K*b1**2*fd*r + 6*D1*Dd*K*b1**2*fd*s + 16*D1*Dd*K*b1*f**2*r**2 + 16*D1*Dd*K*b1*f**2*r*s - 16*D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s + 4*D1*Dd*K*b1*f**2 - 80*D1*Dd*K*b1*f*fd*r**2 - 80*D1*Dd*K*b1*f*fd*r*s + 80*D1*Dd*K*b1*f*fd*r + 30*D1*Dd*K*b1*f*fd*s - 20*D1*Dd*K*b1*f*fd - 40*D1*Dd*b1*f*g2*r**2 - 40*D1*Dd*b1*f*g2*r*s + 40*D1*Dd*b1*f*g2*r + 10*D1*Dd*b1*f*g2*s - 10*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 96*D1*Dd*b1*f*gd2*r*s - 96*D1*Dd*b1*f*gd2*r - 12*D1*Dd*b1*f*gd2*s + 12*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 96*D1*Dd*b1*fd*g2*r*s - 48*D1*Dd*b1*fd*g2*r - 12*D1*Dd*b1*fd*g2*s - 32*D1*Dd*f**2*g2*r**2 - 32*D1*Dd*f**2*g2*r*s + 32*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s - 8*D1*Dd*f**2*g2 + 80*D1*Dd*f**2*gd2*r**2 + 80*D1*Dd*f**2*gd2*r*s - 80*D1*Dd*f**2*gd2*r - 10*D1*Dd*f**2*gd2*s + 10*D1*Dd*f**2*gd2 + 160*D1*Dd*f*fd*g2*r**2 + 160*D1*Dd*f*fd*g2*r*s - 160*D1*Dd*f*fd*g2*r - 60*D1*Dd*f*fd*g2*s + 40*D1*Dd*f*fd*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 24*D1*Ddd*K*b1**2*f*r*s + 24*D1*Ddd*K*b1**2*f*r + 6*D1*Ddd*K*b1**2*f*s - 6*D1*Ddd*K*b1**2*f - 20*D1*Ddd*K*b1*f**2*r**2 - 20*D1*Ddd*K*b1*f**2*r*s + 20*D1*Ddd*K*b1*f**2*r + 5*D1*Ddd*K*b1*f**2*s - 5*D1*Ddd*K*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 48*D1*Ddd*b1*f*g2*r*s - 48*D1*Ddd*b1*f*g2*r - 12*D1*Ddd*b1*f*g2*s + 12*D1*Ddd*b1*f*g2 + 40*D1*Ddd*f**2*g2*r**2 + 40*D1*Ddd*f**2*g2*r*s - 40*D1*Ddd*f**2*g2*r - 10*D1*Ddd*f**2*g2*s + 10*D1*Ddd*f**2*g2 + D1*bd1*(D1*(4*K*f**2*r*(r + s - 1) + f*(5*K*(b1*(2*r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 4*r + s - 1)) - 10*g2*(r - 1)*(r + s - 1) + 12*gd2*(2*r - 1)*(r + s - 1)) + 6*fd*(K*b1*(-4*r**2 + r*(3 - 4*s) + s) + g2*(4*r**2 + 4*r*(s - 1) - 2*s))) + Dd*f*(-K*(6*b1*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 5*f*(8*r**2 + 8*r*(s - 1) - s + 1)) + 12*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 72*Dd**2*K*b1**2*f*r**2 - 72*Dd**2*K*b1**2*f*r*s + 72*Dd**2*K*b1**2*f*r + 18*Dd**2*K*b1**2*f*s - 12*Dd**2*K*b1**2*f - 60*Dd**2*K*b1*f**2*r**2 - 60*Dd**2*K*b1*f**2*r*s + 60*Dd**2*K*b1*f**2*r + 15*Dd**2*K*b1*f**2*s - 10*Dd**2*K*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 144*Dd**2*b1*f*g2*r*s - 144*Dd**2*b1*f*g2*r - 36*Dd**2*b1*f*g2*s + 24*Dd**2*b1*f*g2 + 120*Dd**2*f**2*g2*r**2 + 120*Dd**2*f**2*g2*r*s - 120*Dd**2*f**2*g2*r - 30*Dd**2*f**2*g2*s + 20*Dd**2*f**2*g2)/(21*d**2*k3**6) + 4*D1**2*Pk3*Pkd1*k1**3*k2**2*st**2*(-1287*D1**2*K*bdd1*f**2*r**2 - 1287*D1**2*K*bdd1*f**2*r*s + 1287*D1**2*K*bdd1*f**2*r + 429*D1**2*bd1**2*f*(-3*K + 4*f)*(2*r - 1)*(r + s - 1) + 975*D1**2*bdd1*f**3*r**2 + 975*D1**2*bdd1*f**3*r*s - 650*D1**2*bdd1*f**3*r + 325*D1**2*bdd1*f**3*s - 325*D1**2*bdd1*f**3 + 2574*D1**2*bdd1*f*g2*r**2 + 2574*D1**2*bdd1*f*g2*r*s - 5148*D1**2*bdd1*f*g2*r - 2574*D1**2*bdd1*f*g2*s + 2574*D1**2*bdd1*f*g2 + 660*D1**2*f**3*fd*r**2 + 660*D1**2*f**3*fd*r*s - 660*D1**2*f**3*fd*r - 165*D1**2*f**3*fd*s + 165*D1**2*f**3*fd - 980*D1**2*f**3*fdd*r**2 - 980*D1**2*f**3*fdd*r*s + 980*D1**2*f**3*fdd*r + 245*D1**2*f**3*fdd*s - 245*D1**2*f**3*fdd - 2940*D1**2*f**2*fd**2*r**2 - 2940*D1**2*f**2*fd**2*r*s + 2940*D1**2*f**2*fd**2*r + 735*D1**2*f**2*fd**2*s - 490*D1**2*f**2*fd**2 - 4290*D1**2*f**2*gd2*r**2 - 4290*D1**2*f**2*gd2*r*s + 4290*D1**2*f**2*gd2*r + 2574*D1**2*f**2*gdd2*r**2 + 2574*D1**2*f**2*gdd2*r*s - 2574*D1**2*f**2*gdd2*r - 8580*D1**2*f*fd*g2*r**2 - 8580*D1**2*f*fd*g2*r*s + 8580*D1**2*f*fd*g2*r + 4290*D1**2*f*fd*g2*s - 4290*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r**2 + 10296*D1**2*f*fd*gd2*r*s - 10296*D1**2*f*fd*gd2*r - 2574*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r**2 + 5148*D1**2*f*fdd*g2*r*s - 5148*D1**2*f*fdd*g2*r - 2574*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r**2 + 5148*D1**2*fd**2*g2*r*s - 5148*D1**2*fd**2*g2*r - 2574*D1**2*fd**2*g2*s + 660*D1*Dd*f**4*r**2 + 660*D1*Dd*f**4*r*s - 660*D1*Dd*f**4*r - 165*D1*Dd*f**4*s + 165*D1*Dd*f**4 - 7840*D1*Dd*f**3*fd*r**2 - 7840*D1*Dd*f**3*fd*r*s + 7840*D1*Dd*f**3*fd*r + 1960*D1*Dd*f**3*fd*s - 1470*D1*Dd*f**3*fd - 17160*D1*Dd*f**2*g2*r**2 - 17160*D1*Dd*f**2*g2*r*s + 17160*D1*Dd*f**2*g2*r + 4290*D1*Dd*f**2*g2*s - 4290*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r**2 + 20592*D1*Dd*f**2*gd2*r*s - 20592*D1*Dd*f**2*gd2*r - 2574*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r**2 + 41184*D1*Dd*f*fd*g2*r*s - 41184*D1*Dd*f*fd*g2*r - 15444*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 980*D1*Ddd*f**4*r**2 - 980*D1*Ddd*f**4*r*s + 980*D1*Ddd*f**4*r + 245*D1*Ddd*f**4*s - 245*D1*Ddd*f**4 + 10296*D1*Ddd*f**2*g2*r**2 + 10296*D1*Ddd*f**2*g2*r*s - 10296*D1*Ddd*f**2*g2*r - 2574*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(f**3*(84*r + 17)*(r + s - 1) - 5*f**2*(33*K*r*(r + s - 1) + 5*fd*(18*r**2 + 2*r*(9*s - 8) - s + 2)) + 33*f*(3*K*fd*(4*r**2 + 4*r*(s - 1) - s + 1) + 26*g2*(r - 1)*(r + s - 1) - 6*gd2*(2*r - 1)*(r + s - 1)) - 198*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - Dd*f*(f*(-99*K*(8*r**2 + 8*r*(s - 1) - s + 1) + 25*f*(24*r**2 + 4*r*(6*s - 5) + s)) + 198*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 2940*Dd**2*f**4*r**2 - 2940*Dd**2*f**4*r*s + 2940*Dd**2*f**4*r + 735*Dd**2*f**4*s - 490*Dd**2*f**4 + 30888*Dd**2*f**2*g2*r**2 + 30888*Dd**2*f**2*g2*r*s - 30888*Dd**2*f**2*g2*r - 7722*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 - 429*b1**2*(D1**2*r*(-13*K*fd*(r + s) + 3*K*fdd*(r + s) + f*(5*fd - 4*fdd)*(2*r + 2*s - 1) + fd**2*(-8*r - 8*s + 4)) + D1*(Dd*(3*K*fd*(8*r**2 + r*(8*s - 4) - s) + 5*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - f*(13*K*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(64*r**2 + 16*r*(4*s - 3) - 8*s + 4))) - Ddd*f*(-3*K + 4*f)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(-3*K + 4*f)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 13*b1*(-330*D1**2*K*f*fd*r**2 - 330*D1**2*K*f*fd*r*s + 330*D1**2*K*f*fd*r + 165*D1**2*K*f*fd*s - 165*D1**2*K*f*fd + 198*D1**2*K*f*fdd*r**2 + 198*D1**2*K*f*fdd*r*s - 198*D1**2*K*f*fdd*r - 99*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 198*D1**2*K*fd**2*r**2 + 198*D1**2*K*fd**2*r*s - 198*D1**2*K*fd**2*r - 99*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(-3*K + 4*f)*(2*r - 1)*(r + s - 1) + 252*D1**2*f**2*fd*r**2 + 252*D1**2*f**2*fd*r*s - 269*D1**2*f**2*fd*r - 101*D1**2*f**2*fd*s + 101*D1**2*f**2*fd - 225*D1**2*f**2*fdd*r**2 - 225*D1**2*f**2*fdd*r*s + 250*D1**2*f**2*fdd*r + 100*D1**2*f**2*fdd*s - 100*D1**2*f**2*fdd - 450*D1**2*f*fd**2*r**2 - 450*D1**2*f*fd**2*r*s + 500*D1**2*f*fd**2*r + 200*D1**2*f*fd**2*s - 100*D1**2*f*fd**2 + 858*D1**2*f*gd2*r**2 + 858*D1**2*f*gd2*r*s - 858*D1**2*f*gd2*r - 198*D1**2*f*gdd2*r**2 - 198*D1**2*f*gdd2*r*s + 198*D1**2*f*gdd2*r + 858*D1**2*fd*g2*r**2 + 858*D1**2*fd*g2*r*s - 396*D1**2*fd*gd2*r**2 - 396*D1**2*fd*gd2*r*s + 198*D1**2*fd*gd2*r - 198*D1**2*fdd*g2*r**2 - 198*D1**2*fdd*g2*r*s - 660*D1*Dd*K*f**2*r**2 - 660*D1*Dd*K*f**2*r*s + 660*D1*Dd*K*f**2*r + 165*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 1584*D1*Dd*K*f*fd*r**2 + 1584*D1*Dd*K*f*fd*r*s - 1584*D1*Dd*K*f*fd*r - 594*D1*Dd*K*f*fd*s + 396*D1*Dd*K*f*fd + 336*D1*Dd*f**3*r**2 + 336*D1*Dd*f**3*r*s - 336*D1*Dd*f**3*r - 84*D1*Dd*f**3*s + 84*D1*Dd*f**3 - 1800*D1*Dd*f**2*fd*r**2 - 1800*D1*Dd*f**2*fd*r*s + 1900*D1*Dd*f**2*fd*r + 625*D1*Dd*f**2*fd*s - 450*D1*Dd*f**2*fd + 3432*D1*Dd*f*g2*r**2 + 3432*D1*Dd*f*g2*r*s - 3432*D1*Dd*f*g2*r - 858*D1*Dd*f*g2*s + 858*D1*Dd*f*g2 - 1584*D1*Dd*f*gd2*r**2 - 1584*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r + 198*D1*Dd*f*gd2*s - 198*D1*Dd*f*gd2 - 1584*D1*Dd*fd*g2*r**2 - 1584*D1*Dd*fd*g2*r*s + 792*D1*Dd*fd*g2*r + 198*D1*Dd*fd*g2*s + 396*D1*Ddd*K*f**2*r**2 + 396*D1*Ddd*K*f**2*r*s - 396*D1*Ddd*K*f**2*r - 99*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 - 300*D1*Ddd*f**3*r**2 - 300*D1*Ddd*f**3*r*s + 300*D1*Ddd*f**3*r + 75*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 792*D1*Ddd*f*g2*r**2 - 792*D1*Ddd*f*g2*r*s + 792*D1*Ddd*f*g2*r + 198*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(3*K*fd*(4*r**2 + r*(4*s - 3) - s) + 5*f**2*(2*r - 1)*(r + s - 1) - f*(13*K*(2*r - 1)*(r + s - 1) + 4*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1))) - Dd*f*(-3*K + 4*f)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1188*Dd**2*K*f**2*r**2 + 1188*Dd**2*K*f**2*r*s - 1188*Dd**2*K*f**2*r - 297*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 - 900*Dd**2*f**3*r**2 - 900*Dd**2*f**3*r*s + 900*Dd**2*f**3*r + 225*Dd**2*f**3*s - 150*Dd**2*f**3 - 2376*Dd**2*f*g2*r**2 - 2376*Dd**2*f*g2*r*s + 2376*Dd**2*f*g2*r + 594*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(9009*d**2*k3**6) + D1**2*Pk3*Pkd1*k1**3*st**2*(66*b1**2*(2*C - 1)*(D1**2*r*(9*fd - fdd)*(r + s - 1) + D1*(Dd*(9*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(-8*r**2 - 8*r*(s - 1) + s - 1)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + 33*b1*(-12*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*r - 4*C*D1**2*f*fd*s + 4*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r**2 + 32*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r + 4*C*D1**2*f*fdd*s - 4*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r**2 + 32*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r + 4*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 - 24*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s + 44*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s - 6*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r**2 + 256*C*D1*Dd*f*fd*r*s - 128*C*D1*Dd*f*fd*r - 16*C*D1*Dd*f*fd*s + 32*C*D1*Ddd*f**2*r**2 + 64*C*D1*Ddd*f**2*r*s - 48*C*D1*Ddd*f**2*r - 16*C*D1*Ddd*f**2*s + 8*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r**2 + 192*C*Dd**2*f**2*r*s - 144*C*Dd**2*f**2*r - 48*C*Dd**2*f**2*s + 32*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(2*C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 6*D1**2*f*fd*r**2 + 18*D1**2*f*fd*r*s - 5*D1**2*f*fd*r + 2*D1**2*f*fd*s - 2*D1**2*f*fd - 8*D1**2*f*fdd*r**2 - 18*D1**2*f*fdd*r*s + 5*D1**2*f*fdd*r - 2*D1**2*f*fdd*s + 2*D1**2*f*fdd - 8*D1**2*fd**2*r**2 - 18*D1**2*fd**2*r*s + 5*D1**2*fd**2*r - 2*D1**2*fd**2*s + 2*D1**2*fd**2 + 12*D1*Dd*f**2*r**2 + 36*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r - 9*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 64*D1*Dd*f*fd*r**2 - 144*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*r + 10*D1*Dd*f*fd*s - D1*Dd*f*fd - 16*D1*Ddd*f**2*r**2 - 36*D1*Ddd*f**2*r*s + 26*D1*Ddd*f**2*r + 9*D1*Ddd*f**2*s - 4*D1*Ddd*f**2 + 2*D1*bd1*(2*C - 1)*(D1*(9*f*(2*r**2 + 2*r*(s - 1) - s + 1) + fd*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 48*Dd**2*f**2*r**2 - 108*Dd**2*f**2*r*s + 78*Dd**2*f**2*r + 27*Dd**2*f**2*s - 18*Dd**2*f**2) + f*(-846*C*D1**2*f*fd*r**2 - 1596*C*D1**2*f*fd*r*s + 1096*C*D1**2*f*fd*r + 532*C*D1**2*f*fd*s - 282*C*D1**2*f*fd + 1116*C*D1**2*f*fdd*r**2 + 1788*C*D1**2*f*fdd*r*s - 1340*C*D1**2*f*fdd*r - 596*C*D1**2*f*fdd*s + 372*C*D1**2*f*fdd + 2232*C*D1**2*fd**2*r**2 + 3576*C*D1**2*fd**2*r*s - 2680*C*D1**2*fd**2*r - 1192*C*D1**2*fd**2*s + 596*C*D1**2*fd**2 - 1128*C*D1*Dd*f**2*r**2 - 2128*C*D1*Dd*f**2*r*s + 1628*C*D1*Dd*f**2*r + 532*C*D1*Dd*f**2*s - 282*C*D1*Dd*f**2 + 8928*C*D1*Dd*f*fd*r**2 + 14304*C*D1*Dd*f*fd*r*s - 11168*C*D1*Dd*f*fd*r - 4172*C*D1*Dd*f*fd*s + 2532*C*D1*Dd*f*fd + 1488*C*D1*Ddd*f**2*r**2 + 2384*C*D1*Ddd*f**2*r*s - 1936*C*D1*Ddd*f**2*r - 596*C*D1*Ddd*f**2*s + 372*C*D1*Ddd*f**2 + 4464*C*Dd**2*f**2*r**2 + 7152*C*Dd**2*f**2*r*s - 5808*C*Dd**2*f**2*r - 1788*C*Dd**2*f**2*s + 1192*C*Dd**2*f**2 - 66*D1**2*bd1**2*(2*C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(4*C*(2*r**2 + 4*r*s - 6*r - 5*s + 3) - 4*r**2 - 9*r*s + 12*r + 11*s - 6) + 423*D1**2*f*fd*r**2 + 849*D1**2*f*fd*r*s - 565*D1**2*f*fd*r - 283*D1**2*f*fd*s + 141*D1**2*f*fd - 558*D1**2*f*fdd*r**2 - 969*D1**2*f*fdd*r*s + 695*D1**2*f*fdd*r + 323*D1**2*f*fdd*s - 186*D1**2*f*fdd - 1116*D1**2*fd**2*r**2 - 1938*D1**2*fd**2*r*s + 1390*D1**2*fd**2*r + 646*D1**2*fd**2*s - 323*D1**2*fd**2 + 564*D1*Dd*f**2*r**2 + 1132*D1*Dd*f**2*r*s - 848*D1*Dd*f**2*r - 283*D1*Dd*f**2*s + 141*D1*Dd*f**2 - 4464*D1*Dd*f*fd*r**2 - 7752*D1*Dd*f*fd*r*s + 5834*D1*Dd*f*fd*r + 2261*D1*Dd*f*fd*s - 1341*D1*Dd*f*fd - 744*D1*Ddd*f**2*r**2 - 1292*D1*Ddd*f**2*r*s + 1018*D1*Ddd*f**2*r + 323*D1*Ddd*f**2*s - 186*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(2*C*(3*r**2 + 8*r*s - 10*r - 10*s + 5) - 3*r**2 - 9*r*s + 10*r + 11*s - 5) + fd*(-4*C*(8*r**2 + 2*r*(8*s - 7) - 9*s + 5) + 16*r**2 + 36*r*s - 29*r - 20*s + 11)) + Dd*f*(-16*C*(4*r**2 + 8*r*s - 9*r - 6*s + 4) + 32*r**2 + 72*r*s - 74*r - 53*s + 34)) - 2232*Dd**2*f**2*r**2 - 3876*Dd**2*f**2*r*s + 3054*Dd**2*f**2*r + 969*Dd**2*f**2*s - 646*Dd**2*f**2))/(693*d**2*k3**4) + D1**2*Pk3*Pkd1*k1**3*(-84*D1**2*K*b1**2*bdd1*r**2 - 84*D1**2*K*b1**2*bdd1*r*s + 84*D1**2*K*b1**2*bdd1*r + 28*D1**2*K*b1**2*bdd1*s - 28*D1**2*K*b1**2*bdd1 - 36*D1**2*K*b1**2*fd*r**2 - 48*D1**2*K*b1**2*fd*r*s - 40*D1**2*K*b1**2*fd*r - 20*D1**2*K*b1**2*fd*s + 20*D1**2*K*b1**2*fd + 53*D1**2*K*b1**2*fdd*r**2 + 52*D1**2*K*b1**2*fdd*r*s + 48*D1**2*K*b1**2*fdd*r + 24*D1**2*K*b1**2*fdd*s - 24*D1**2*K*b1**2*fdd + 106*D1**2*K*b1*bdd1*f*r**2 + 104*D1**2*K*b1*bdd1*f*r*s - 206*D1**2*K*b1*bdd1*f*r - 76*D1**2*K*b1*bdd1*f*s + 77*D1**2*K*b1*bdd1*f - 108*D1**2*K*b1*f*fd*r**2 - 112*D1**2*K*b1*f*fd*r*s + 108*D1**2*K*b1*f*fd*r + 56*D1**2*K*b1*f*fd*s - 54*D1**2*K*b1*f*fd + 138*D1**2*K*b1*f*fdd*r**2 + 128*D1**2*K*b1*f*fdd*r*s - 138*D1**2*K*b1*f*fdd*r - 64*D1**2*K*b1*f*fdd*s + 69*D1**2*K*b1*f*fdd + 138*D1**2*K*b1*fd**2*r**2 + 128*D1**2*K*b1*fd**2*r*s - 138*D1**2*K*b1*fd**2*r - 64*D1**2*K*b1*fd**2*s + 69*D1**2*K*bdd1*f**2*r**2 + 64*D1**2*K*bdd1*f**2*r*s - 64*D1**2*K*bdd1*f**2*r + 24*D1**2*b1**2*f*fd*r*s - 12*D1**2*b1**2*f*fd*r - 24*D1**2*b1**2*f*fdd*r*s + 12*D1**2*b1**2*f*fdd*r - 24*D1**2*b1**2*fd**2*r*s + 12*D1**2*b1**2*fd**2*r + 10*D1**2*b1**2*fd*r*s - 12*D1**2*b1**2*fdd*r*s - 112*D1**2*b1**2*gd2*r**2 - 112*D1**2*b1**2*gd2*r*s + 112*D1**2*b1**2*gd2*r + 56*D1**2*b1**2*gdd2*r**2 + 56*D1**2*b1**2*gdd2*r*s - 56*D1**2*b1**2*gdd2*r - 20*D1**2*b1*bd2*f*r**2 - 20*D1**2*b1*bd2*f*r*s + 20*D1**2*b1*bd2*f*r + 48*D1**2*b1*bd2*fd*r**2 + 48*D1**2*b1*bd2*fd*r*s - 24*D1**2*b1*bd2*fd*r - 24*D1**2*b1*bdd1*f**2*r*s + 12*D1**2*b1*bdd1*f**2*r + 12*D1**2*b1*bdd1*f**2*s - 24*D1**2*b1*bdd1*f*r*s + 12*D1**2*b1*bdd1*f*r + 12*D1**2*b1*bdd1*f*s + 112*D1**2*b1*bdd1*g2*r**2 + 112*D1**2*b1*bdd1*g2*r*s - 112*D1**2*b1*bdd1*g2*r - 56*D1**2*b1*bdd1*g2*s + 56*D1**2*b1*bdd1*g2 + 24*D1**2*b1*bdd2*f*r**2 + 24*D1**2*b1*bdd2*f*r*s - 24*D1**2*b1*bdd2*f*r + 30*D1**2*b1*f**2*fd*r*s - 10*D1**2*b1*f**2*fd*r - 10*D1**2*b1*f**2*fd*s - 30*D1**2*b1*f**2*fdd*r*s + 10*D1**2*b1*f**2*fdd*r + 10*D1**2*b1*f**2*fdd*s - 60*D1**2*b1*f*fd**2*r*s + 20*D1**2*b1*f*fd**2*r + 20*D1**2*b1*f*fd**2*s - 10*D1**2*b1*f*fd**2 + 16*D1**2*b1*f*fd*r*s - 8*D1**2*b1*f*fd*s - 20*D1**2*b1*f*fdd*r*s + 10*D1**2*b1*f*fdd*s + 72*D1**2*b1*f*gd2*r**2 + 96*D1**2*b1*f*gd2*r*s - 96*D1**2*b1*f*gd2*r - 106*D1**2*b1*f*gdd2*r**2 - 104*D1**2*b1*f*gdd2*r*s + 104*D1**2*b1*f*gdd2*r - 20*D1**2*b1*fd**2*r*s + 10*D1**2*b1*fd**2*s + 72*D1**2*b1*fd*g2*r**2 + 96*D1**2*b1*fd*g2*r*s + 80*D1**2*b1*fd*g2*r + 40*D1**2*b1*fd*g2*s - 40*D1**2*b1*fd*g2 - 212*D1**2*b1*fd*gd2*r**2 - 208*D1**2*b1*fd*gd2*r*s + 8*D1**2*b1*fd*gd2*r - 48*D1**2*b1*fd*gd2*s + 48*D1**2*b1*fd*gd2 - 106*D1**2*b1*fdd*g2*r**2 - 104*D1**2*b1*fdd*g2*r*s - 96*D1**2*b1*fdd*g2*r - 48*D1**2*b1*fdd*g2*s + 48*D1**2*b1*fdd*g2 - 2*D1**2*bd1**2*(14*K*b1*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*f**2*(r*(2*s - 1) - s + 1) + f*(K*(-53*r**2 - 52*r*s + 103*r + 38*s - 38) + 12*r*s - 6*r - 6*s + 6) + 28*g2*(-2*r**2 - 2*r*(s - 1) + s)) - 16*D1**2*bd2*f**2*r**2 - 16*D1**2*bd2*f**2*r*s + 16*D1**2*bd2*f**2*r + 80*D1**2*bd2*f*fd*r**2 + 80*D1**2*bd2*f*fd*r*s - 80*D1**2*bd2*f*fd*r - 20*D1**2*bd2*f*fd*s + 20*D1**2*bd2*f*fd - 10*D1**2*bdd1*f**3*r*s + 10*D1**2*bdd1*f**3*r - 10*D1**2*bdd1*f**2*r*s + 10*D1**2*bdd1*f**2*r - 106*D1**2*bdd1*f*g2*r**2 - 104*D1**2*bdd1*f*g2*r*s + 308*D1**2*bdd1*f*g2*r + 152*D1**2*bdd1*f*g2*s - 154*D1**2*bdd1*f*g2 + 20*D1**2*bdd2*f**2*r**2 + 20*D1**2*bdd2*f**2*r*s - 20*D1**2*bdd2*f**2*r + 108*D1**2*f**2*gd2*r**2 + 112*D1**2*f**2*gd2*r*s - 112*D1**2*f**2*gd2*r - 138*D1**2*f**2*gdd2*r**2 - 128*D1**2*f**2*gdd2*r*s + 128*D1**2*f**2*gdd2*r + 216*D1**2*f*fd*g2*r**2 + 224*D1**2*f*fd*g2*r*s - 216*D1**2*f*fd*g2*r - 112*D1**2*f*fd*g2*s + 108*D1**2*f*fd*g2 - 552*D1**2*f*fd*gd2*r**2 - 512*D1**2*f*fd*gd2*r*s + 532*D1**2*f*fd*gd2*r + 128*D1**2*f*fd*gd2*s - 128*D1**2*f*fd*gd2 - 276*D1**2*f*fdd*g2*r**2 - 256*D1**2*f*fdd*g2*r*s + 276*D1**2*f*fdd*g2*r + 128*D1**2*f*fdd*g2*s - 138*D1**2*f*fdd*g2 - 276*D1**2*fd**2*g2*r**2 - 256*D1**2*fd**2*g2*r*s + 276*D1**2*fd**2*g2*r + 128*D1**2*fd**2*g2*s + 224*D1*Dd*K*b1**3*r**2 + 224*D1*Dd*K*b1**3*r*s - 224*D1*Dd*K*b1**3*r - 56*D1*Dd*K*b1**3*s + 56*D1*Dd*K*b1**3 - 144*D1*Dd*K*b1**2*f*r**2 - 192*D1*Dd*K*b1**2*f*r*s + 168*D1*Dd*K*b1**2*f*r + 48*D1*Dd*K*b1**2*f*s - 36*D1*Dd*K*b1**2*f + 424*D1*Dd*K*b1**2*fd*r**2 + 416*D1*Dd*K*b1**2*fd*r*s - 18*D1*Dd*K*b1**2*fd*r + 44*D1*Dd*K*b1**2*fd*s - 96*D1*Dd*K*b1**2*fd - 216*D1*Dd*K*b1*f**2*r**2 - 224*D1*Dd*K*b1*f**2*r*s + 220*D1*Dd*K*b1*f**2*r + 56*D1*Dd*K*b1*f**2*s - 54*D1*Dd*K*b1*f**2 + 1104*D1*Dd*K*b1*f*fd*r**2 + 1024*D1*Dd*K*b1*f*fd*r*s - 1084*D1*Dd*K*b1*f*fd*r - 384*D1*Dd*K*b1*f*fd*s + 266*D1*Dd*K*b1*f*fd + 48*D1*Dd*b1**2*f**2*r*s - 24*D1*Dd*b1**2*f**2*r - 12*D1*Dd*b1**2*f**2*s - 192*D1*Dd*b1**2*f*fd*r*s + 96*D1*Dd*b1**2*f*fd*r + 24*D1*Dd*b1**2*f*fd*s - 12*D1*Dd*b1**2*f*fd + 40*D1*Dd*b1**2*f*r*s - 20*D1*Dd*b1**2*f*r - 10*D1*Dd*b1**2*f*s - 96*D1*Dd*b1**2*fd*r*s + 24*D1*Dd*b1**2*fd*r + 12*D1*Dd*b1**2*fd*s - 448*D1*Dd*b1**2*g2*r**2 - 448*D1*Dd*b1**2*g2*r*s + 448*D1*Dd*b1**2*g2*r + 112*D1*Dd*b1**2*g2*s - 112*D1*Dd*b1**2*g2 + 448*D1*Dd*b1**2*gd2*r**2 + 448*D1*Dd*b1**2*gd2*r*s - 448*D1*Dd*b1**2*gd2*r - 56*D1*Dd*b1**2*gd2*s + 56*D1*Dd*b1**2*gd2 + 192*D1*Dd*b1*bd2*f*r**2 + 192*D1*Dd*b1*bd2*f*r*s - 192*D1*Dd*b1*bd2*f*r - 24*D1*Dd*b1*bd2*f*s + 24*D1*Dd*b1*bd2*f + 40*D1*Dd*b1*f**3*r*s - 20*D1*Dd*b1*f**3*r - 10*D1*Dd*b1*f**3*s - 240*D1*Dd*b1*f**2*fd*r*s + 100*D1*Dd*b1*f**2*fd*r + 70*D1*Dd*b1*f**2*fd*s - 30*D1*Dd*b1*f**2*fd + 32*D1*Dd*b1*f**2*r*s - 16*D1*Dd*b1*f**2*r - 8*D1*Dd*b1*f**2*s - 160*D1*Dd*b1*f*fd*r*s + 40*D1*Dd*b1*f*fd*r + 60*D1*Dd*b1*f*fd*s - 20*D1*Dd*b1*f*fd + 288*D1*Dd*b1*f*g2*r**2 + 384*D1*Dd*b1*f*g2*r*s - 336*D1*Dd*b1*f*g2*r - 96*D1*Dd*b1*f*g2*s + 72*D1*Dd*b1*f*g2 - 848*D1*Dd*b1*f*gd2*r**2 - 832*D1*Dd*b1*f*gd2*r*s + 836*D1*Dd*b1*f*gd2*r + 104*D1*Dd*b1*f*gd2*s - 104*D1*Dd*b1*f*gd2 - 848*D1*Dd*b1*fd*g2*r**2 - 832*D1*Dd*b1*fd*g2*r*s + 36*D1*Dd*b1*fd*g2*r - 88*D1*Dd*b1*fd*g2*s + 192*D1*Dd*b1*fd*g2 + 160*D1*Dd*bd2*f**2*r**2 + 160*D1*Dd*bd2*f**2*r*s - 160*D1*Dd*bd2*f**2*r - 20*D1*Dd*bd2*f**2*s + 20*D1*Dd*bd2*f**2 + 432*D1*Dd*f**2*g2*r**2 + 448*D1*Dd*f**2*g2*r*s - 440*D1*Dd*f**2*g2*r - 112*D1*Dd*f**2*g2*s + 108*D1*Dd*f**2*g2 - 1104*D1*Dd*f**2*gd2*r**2 - 1024*D1*Dd*f**2*gd2*r*s + 1044*D1*Dd*f**2*gd2*r + 128*D1*Dd*f**2*gd2*s - 128*D1*Dd*f**2*gd2 - 2208*D1*Dd*f*fd*g2*r**2 - 2048*D1*Dd*f*fd*g2*r*s + 2168*D1*Dd*f*fd*g2*r + 768*D1*Dd*f*fd*g2*s - 532*D1*Dd*f*fd*g2 - 112*D1*Ddd*K*b1**3*r**2 - 112*D1*Ddd*K*b1**3*r*s + 112*D1*Ddd*K*b1**3*r + 28*D1*Ddd*K*b1**3*s - 28*D1*Ddd*K*b1**3 + 212*D1*Ddd*K*b1**2*f*r**2 + 208*D1*Ddd*K*b1**2*f*r*s - 210*D1*Ddd*K*b1**2*f*r - 52*D1*Ddd*K*b1**2*f*s + 53*D1*Ddd*K*b1**2*f + 276*D1*Ddd*K*b1*f**2*r**2 + 256*D1*Ddd*K*b1*f**2*r*s - 266*D1*Ddd*K*b1*f**2*r - 64*D1*Ddd*K*b1*f**2*s + 69*D1*Ddd*K*b1*f**2 - 48*D1*Ddd*b1**2*f**2*r*s + 24*D1*Ddd*b1**2*f**2*r + 12*D1*Ddd*b1**2*f**2*s - 48*D1*Ddd*b1**2*f*r*s + 24*D1*Ddd*b1**2*f*r + 12*D1*Ddd*b1**2*f*s + 224*D1*Ddd*b1**2*g2*r**2 + 224*D1*Ddd*b1**2*g2*r*s - 224*D1*Ddd*b1**2*g2*r - 56*D1*Ddd*b1**2*g2*s + 56*D1*Ddd*b1**2*g2 - 40*D1*Ddd*b1*f**3*r*s + 20*D1*Ddd*b1*f**3*r + 10*D1*Ddd*b1*f**3*s - 40*D1*Ddd*b1*f**2*r*s + 20*D1*Ddd*b1*f**2*r + 10*D1*Ddd*b1*f**2*s - 424*D1*Ddd*b1*f*g2*r**2 - 416*D1*Ddd*b1*f*g2*r*s + 420*D1*Ddd*b1*f*g2*r + 104*D1*Ddd*b1*f*g2*s - 106*D1*Ddd*b1*f*g2 - 552*D1*Ddd*f**2*g2*r**2 - 512*D1*Ddd*f**2*g2*r*s + 532*D1*Ddd*f**2*g2*r + 128*D1*Ddd*f**2*g2*s - 138*D1*Ddd*f**2*g2 + 2*D1*bd1*(-27*D1*K*f**2*r**2 - 28*D1*K*f**2*r*s + 28*D1*K*f**2*r + 138*D1*K*f*fd*r**2 + 128*D1*K*f*fd*r*s - 133*D1*K*f*fd*r - 32*D1*K*f*fd*s + 32*D1*K*f*fd + 12*D1*bd2*f*(2*r - 1)*(r + s - 1) + 5*D1*f**3*r*s - 5*D1*f**3*r - 30*D1*f**2*fd*r*s + 20*D1*f**2*fd*r + 5*D1*f**2*fd*s - 5*D1*f**2*fd + 4*D1*f**2*r*s - 4*D1*f**2*r - 20*D1*f*fd*r*s + 10*D1*f*fd*r + 5*D1*f*fd*s - 5*D1*f*fd + 36*D1*f*g2*r**2 + 48*D1*f*g2*r*s - 112*D1*f*g2*r - 68*D1*f*g2*s + 56*D1*f*g2 - 106*D1*f*gd2*r**2 - 104*D1*f*gd2*r*s + 206*D1*f*gd2*r + 76*D1*f*gd2*s - 76*D1*f*gd2 - 106*D1*fd*g2*r**2 - 104*D1*fd*g2*r*s + 106*D1*fd*g2*r + 52*D1*fd*g2*s + 276*Dd*K*f**2*r**2 + 256*Dd*K*f**2*r*s - 261*Dd*K*f**2*r - 32*Dd*K*f**2*s + 32*Dd*K*f**2 - 40*Dd*f**3*r*s + 30*Dd*f**3*r + 5*Dd*f**3*s - 5*Dd*f**3 - 40*Dd*f**2*r*s + 30*Dd*f**2*r + 5*Dd*f**2*s - 5*Dd*f**2 - 424*Dd*f*g2*r**2 - 416*Dd*f*g2*r*s + 826*Dd*f*g2*r + 356*Dd*f*g2*s - 306*Dd*f*g2 + 14*K*b1**2*(D1*(6*r**2 + 6*r*(s - 1) - 2*s + 2) + Dd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + b1*(D1*(106*K*fd*r**2 + 104*K*fd*r*s - 55*K*fd*r - 14*K*fd*s - 12*K*fd + 6*f**2*(r*(2*s - 1) - s) - f*(K*(36*r**2 + 48*r*s - 80*r - 34*s + 28) + 6*fd*(4*r - 1)*(2*s - 1) - 10*r*s + 5*r + 5*s) - 24*fd*r*s + 6*fd*r + 6*fd*s - 56*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 112*gd2*r**2 + 112*gd2*r*s - 112*gd2*r - 28*gd2*s + 28*gd2) + Dd*(-6*f**2*(8*r - 3)*(2*s - 1) + f*(K*(424*r**2 + 416*r*s - 622*r - 204*s + 179) + (18 - 48*r)*(2*s - 1)) + 56*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)))) - 336*Dd**2*K*b1**3*r**2 - 336*Dd**2*K*b1**3*r*s + 336*Dd**2*K*b1**3*r + 84*Dd**2*K*b1**3*s - 56*Dd**2*K*b1**3 + 636*Dd**2*K*b1**2*f*r**2 + 624*Dd**2*K*b1**2*f*r*s - 630*Dd**2*K*b1**2*f*r - 156*Dd**2*K*b1**2*f*s + 104*Dd**2*K*b1**2*f + 828*Dd**2*K*b1*f**2*r**2 + 768*Dd**2*K*b1*f**2*r*s - 798*Dd**2*K*b1*f**2*r - 192*Dd**2*K*b1*f**2*s + 128*Dd**2*K*b1*f**2 - 144*Dd**2*b1**2*f**2*r*s + 72*Dd**2*b1**2*f**2*r + 36*Dd**2*b1**2*f**2*s - 24*Dd**2*b1**2*f**2 - 144*Dd**2*b1**2*f*r*s + 72*Dd**2*b1**2*f*r + 36*Dd**2*b1**2*f*s - 24*Dd**2*b1**2*f + 672*Dd**2*b1**2*g2*r**2 + 672*Dd**2*b1**2*g2*r*s - 672*Dd**2*b1**2*g2*r - 168*Dd**2*b1**2*g2*s + 112*Dd**2*b1**2*g2 - 120*Dd**2*b1*f**3*r*s + 60*Dd**2*b1*f**3*r + 30*Dd**2*b1*f**3*s - 20*Dd**2*b1*f**3 - 120*Dd**2*b1*f**2*r*s + 60*Dd**2*b1*f**2*r + 30*Dd**2*b1*f**2*s - 20*Dd**2*b1*f**2 - 1272*Dd**2*b1*f*g2*r**2 - 1248*Dd**2*b1*f*g2*r*s + 1260*Dd**2*b1*f*g2*r + 312*Dd**2*b1*f*g2*s - 208*Dd**2*b1*f*g2 - 1656*Dd**2*f**2*g2*r**2 - 1536*Dd**2*f**2*g2*r*s + 1596*Dd**2*f**2*g2*r + 384*Dd**2*f**2*g2*s - 256*Dd**2*f**2*g2 - 4*b2*(5*D1**2*b1*fd*r**2 + 5*D1**2*b1*fd*r*s - 6*D1**2*b1*fdd*r**2 - 6*D1**2*b1*fdd*r*s - 6*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*r + 5*D1**2*fd**2*s + 20*D1*Dd*b1*f*r**2 + 20*D1*Dd*b1*f*r*s - 20*D1*Dd*b1*f*r - 5*D1*Dd*b1*f*s + 5*D1*Dd*b1*f - 48*D1*Dd*b1*fd*r**2 - 48*D1*Dd*b1*fd*r*s + 24*D1*Dd*b1*fd*r + 6*D1*Dd*b1*fd*s + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 24*D1*Ddd*b1*f*r**2 - 24*D1*Ddd*b1*f*r*s + 24*D1*Ddd*b1*f*r + 6*D1*Ddd*b1*f*s - 6*D1*Ddd*b1*f - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(r - 1)*(r + s - 1) + 6*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 6*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 72*Dd**2*b1*f*r**2 - 72*Dd**2*b1*f*r*s + 72*Dd**2*b1*f*r + 18*Dd**2*b1*f*s - 12*Dd**2*b1*f - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k3**4) - D1**2*Pk3*Pkd1*k1*k2**2*st**4*(1056*C*D1**2*b1*f*fd*r**2 + 1056*C*D1**2*b1*f*fd*r*s - 528*C*D1**2*b1*f*fd*r + 132*C*D1**2*b1*f*fdd*r**2 + 132*C*D1**2*b1*fd**2*r**2 + 228*C*D1**2*f**2*fd*r**2 + 192*C*D1**2*f**2*fd*r*s - 216*C*D1**2*f**2*fd*r - 64*C*D1**2*f**2*fd*s + 76*C*D1**2*f**2*fd - 114*C*D1**2*f**2*fdd*r**2 - 96*C*D1**2*f**2*fdd*r*s + 108*C*D1**2*f**2*fdd*r + 32*C*D1**2*f**2*fdd*s - 38*C*D1**2*f**2*fdd - 228*C*D1**2*f*fd**2*r**2 - 192*C*D1**2*f*fd**2*r*s + 216*C*D1**2*f*fd**2*r + 64*C*D1**2*f*fd**2*s - 32*C*D1**2*f*fd**2 + 2112*C*D1*Dd*b1*f**2*r**2 + 2112*C*D1*Dd*b1*f**2*r*s - 2112*C*D1*Dd*b1*f**2*r - 528*C*D1*Dd*b1*f**2*s + 528*C*D1*Dd*b1*f**2 + 1056*C*D1*Dd*b1*f*fd*r**2 - 264*C*D1*Dd*b1*f*fd*r + 304*C*D1*Dd*f**3*r**2 + 256*C*D1*Dd*f**3*r*s - 280*C*D1*Dd*f**3*r - 64*C*D1*Dd*f**3*s + 76*C*D1*Dd*f**3 - 912*C*D1*Dd*f**2*fd*r**2 - 768*C*D1*Dd*f**2*fd*r*s + 852*C*D1*Dd*f**2*fd*r + 224*C*D1*Dd*f**2*fd*s - 172*C*D1*Dd*f**2*fd + 264*C*D1*Ddd*b1*f**2*r**2 - 132*C*D1*Ddd*b1*f**2*r + 66*C*D1*Ddd*b1*f**2 - 152*C*D1*Ddd*f**3*r**2 - 128*C*D1*Ddd*f**3*r*s + 140*C*D1*Ddd*f**3*r + 32*C*D1*Ddd*f**3*s - 38*C*D1*Ddd*f**3 + 792*C*Dd**2*b1*f**2*r**2 - 396*C*Dd**2*b1*f**2*r - 456*C*Dd**2*f**3*r**2 - 384*C*Dd**2*f**3*r*s + 420*C*Dd**2*f**3*r + 96*C*Dd**2*f**3*s - 64*C*Dd**2*f**3 - 528*D1**2*b1*f*fd*r**2 - 660*D1**2*b1*f*fd*r*s + 330*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 + 33*D1**2*bdd1*f**2*(2*C - 1)*(r - 1)**2 - 138*D1**2*f**2*fd*r**2 - 108*D1**2*f**2*fd*r*s + 128*D1**2*f**2*fd*r + 36*D1**2*f**2*fd*s - 46*D1**2*f**2*fd + 69*D1**2*f**2*fdd*r**2 + 54*D1**2*f**2*fdd*r*s - 64*D1**2*f**2*fdd*r - 18*D1**2*f**2*fdd*s + 23*D1**2*f**2*fdd + 138*D1**2*f*fd**2*r**2 + 108*D1**2*f*fd**2*r*s - 128*D1**2*f*fd**2*r - 36*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 - 1056*D1*Dd*b1*f**2*r**2 - 1320*D1*Dd*b1*f**2*r*s + 1188*D1*Dd*b1*f**2*r + 330*D1*Dd*b1*f**2*s - 264*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r - 184*D1*Dd*f**3*r**2 - 144*D1*Dd*f**3*r*s + 164*D1*Dd*f**3*r + 36*D1*Dd*f**3*s - 46*D1*Dd*f**3 + 552*D1*Dd*f**2*fd*r**2 + 432*D1*Dd*f**2*fd*r*s - 502*D1*Dd*f**2*fd*r - 126*D1*Dd*f**2*fd*s + 100*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 + 92*D1*Ddd*f**3*r**2 + 72*D1*Ddd*f**3*r*s - 82*D1*Ddd*f**3*r - 18*D1*Ddd*f**3*s + 23*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(D1*f*(8*C*(r + s - 1) - 4*r - 5*s + 4) + D1*fd*r*(4*C - 2) + Dd*f*(2*C - 1)*(4*r - 1)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r + 276*Dd**2*f**3*r**2 + 216*Dd**2*f**3*r*s - 246*Dd**2*f**3*r - 54*Dd**2*f**3*s + 36*Dd**2*f**3)/(231*d**2*k3**4) - D1**2*Pk3*Pkd1*k1*k2**2*st**2*(-6864*D1**2*K*bd1**2*f*r**2 - 6864*D1**2*K*bd1**2*f*r*s + 10296*D1**2*K*bd1**2*f*r + 3432*D1**2*K*bd1**2*f*s - 3432*D1**2*K*bd1**2*f + 8151*D1**2*K*bd1*f**2*r**2 + 5148*D1**2*K*bd1*f**2*r*s - 5148*D1**2*K*bd1*f**2*r - 20592*D1**2*K*bd1*f*fd*r**2 - 13728*D1**2*K*bd1*f*fd*r*s + 17160*D1**2*K*bd1*f*fd*r + 3432*D1**2*K*bd1*f*fd*s - 3432*D1**2*K*bd1*f*fd - 5148*D1**2*K*bdd1*f**2*r**2 - 3432*D1**2*K*bdd1*f**2*r*s + 3432*D1**2*K*bdd1*f**2*r + 8580*D1**2*bd1**2*f**2*r**2 + 11154*D1**2*bd1**2*f**2*r*s - 16731*D1**2*bd1**2*f**2*r - 7293*D1**2*bd1**2*f**2*s + 6435*D1**2*bd1**2*f**2 + 1716*D1**2*bd1**2*f*r**2 + 858*D1**2*bd1**2*f*r*s - 2145*D1**2*bd1**2*f*r - 429*D1**2*bd1**2*f*s + 429*D1**2*bd1**2*f - 5148*D1**2*bd1*bd2*f*r**2 - 5148*D1**2*bd1*bd2*f*r*s + 7722*D1**2*bd1*bd2*f*r + 2574*D1**2*bd1*bd2*f*s - 2574*D1**2*bd1*bd2*f - 4524*D1**2*bd1*f**3*r**2 - 2626*D1**2*bd1*f**3*r*s + 4147*D1**2*bd1*f**3*r - 3861*D1**2*bd1*f**3*s + 949*D1**2*bd1*f**3 + 29016*D1**2*bd1*f**2*fd*r**2 + 15600*D1**2*bd1*f**2*fd*r*s - 22022*D1**2*bd1*f**2*fd*r + 5122*D1**2*bd1*f**2*fd*s - 1911*D1**2*bd1*f**2*fd - 1716*D1**2*bd1*f**2*r**2 - 429*D1**2*bd1*f**2*r*s + 429*D1**2*bd1*f**2*r + 3432*D1**2*bd1*f*fd*r**2 + 1716*D1**2*bd1*f*fd*r*s - 2574*D1**2*bd1*f*fd*r - 429*D1**2*bd1*f*fd*s + 429*D1**2*bd1*f*fd - 43758*D1**2*bd1*f*g2*r**2 - 37752*D1**2*bd1*f*g2*r*s + 87516*D1**2*bd1*f*g2*r + 37752*D1**2*bd1*f*g2*s - 43758*D1**2*bd1*f*g2 + 13728*D1**2*bd1*f*gd2*r**2 + 13728*D1**2*bd1*f*gd2*r*s - 20592*D1**2*bd1*f*gd2*r - 6864*D1**2*bd1*f*gd2*s + 6864*D1**2*bd1*f*gd2 + 13728*D1**2*bd1*fd*g2*r**2 + 13728*D1**2*bd1*fd*g2*r*s - 13728*D1**2*bd1*fd*g2*r - 6864*D1**2*bd1*fd*g2*s + 4290*D1**2*bd2*f**2*r**2 + 4290*D1**2*bd2*f**2*r*s - 4290*D1**2*bd2*f**2*r - 10296*D1**2*bd2*f*fd*r**2 - 10296*D1**2*bd2*f*fd*r*s + 10296*D1**2*bd2*f*fd*r + 2574*D1**2*bd2*f*fd*s - 2574*D1**2*bd2*f*fd + 4836*D1**2*bdd1*f**3*r**2 + 2600*D1**2*bdd1*f**3*r*s - 3575*D1**2*bdd1*f**3*r + 3861*D1**2*bdd1*f**3*s - 1118*D1**2*bdd1*f**3 + 858*D1**2*bdd1*f**2*r**2 + 429*D1**2*bdd1*f**2*r*s - 429*D1**2*bdd1*f**2*r + 6864*D1**2*bdd1*f*g2*r**2 + 6864*D1**2*bdd1*f*g2*r*s - 13728*D1**2*bdd1*f*g2*r - 6864*D1**2*bdd1*f*g2*s + 6864*D1**2*bdd1*f*g2 - 2574*D1**2*bdd2*f**2*r**2 - 2574*D1**2*bdd2*f**2*r*s + 2574*D1**2*bdd2*f**2*r + 4180*D1**2*f**3*fd*r**2 + 11700*D1**2*f**3*fd*r*s - 7940*D1**2*f**3*fd*r - 2925*D1**2*f**3*fd*s + 1045*D1**2*f**3*fd - 4040*D1**2*f**3*fdd*r**2 - 11700*D1**2*f**3*fdd*r*s + 7870*D1**2*f**3*fdd*r + 2925*D1**2*f**3*fdd*s - 1010*D1**2*f**3*fdd - 12120*D1**2*f**2*fd**2*r**2 - 35100*D1**2*f**2*fd**2*r*s + 23610*D1**2*f**2*fd**2*r + 8775*D1**2*f**2*fd**2*s - 5850*D1**2*f**2*fd**2 - 16302*D1**2*f**2*gd2*r**2 - 10296*D1**2*f**2*gd2*r*s + 10296*D1**2*f**2*gd2*r + 10296*D1**2*f**2*gdd2*r**2 + 6864*D1**2*f**2*gdd2*r*s - 6864*D1**2*f**2*gdd2*r - 32604*D1**2*f*fd*g2*r**2 - 20592*D1**2*f*fd*g2*r*s + 32604*D1**2*f*fd*g2*r + 10296*D1**2*f*fd*g2*s - 16302*D1**2*f*fd*g2 + 41184*D1**2*f*fd*gd2*r**2 + 27456*D1**2*f*fd*gd2*r*s - 34320*D1**2*f*fd*gd2*r - 6864*D1**2*f*fd*gd2*s + 6864*D1**2*f*fd*gd2 + 20592*D1**2*f*fdd*g2*r**2 + 13728*D1**2*f*fdd*g2*r*s - 20592*D1**2*f*fdd*g2*r - 6864*D1**2*f*fdd*g2*s + 10296*D1**2*f*fdd*g2 + 20592*D1**2*fd**2*g2*r**2 + 13728*D1**2*fd**2*g2*r*s - 20592*D1**2*fd**2*g2*r - 6864*D1**2*fd**2*g2*s - 41184*D1*Dd*K*bd1*f**2*r**2 - 27456*D1*Dd*K*bd1*f**2*r*s + 30888*D1*Dd*K*bd1*f**2*r + 3432*D1*Dd*K*bd1*f**2*s - 3432*D1*Dd*K*bd1*f**2 + 38688*D1*Dd*bd1*f**3*r**2 + 20800*D1*Dd*bd1*f**3*r*s - 29172*D1*Dd*bd1*f**3*r + 12844*D1*Dd*bd1*f**3*s - 4147*D1*Dd*bd1*f**3 + 6864*D1*Dd*bd1*f**2*r**2 + 3432*D1*Dd*bd1*f**2*r*s - 4290*D1*Dd*bd1*f**2*r - 429*D1*Dd*bd1*f**2*s + 429*D1*Dd*bd1*f**2 + 54912*D1*Dd*bd1*f*g2*r**2 + 54912*D1*Dd*bd1*f*g2*r*s - 82368*D1*Dd*bd1*f*g2*r - 34320*D1*Dd*bd1*f*g2*s + 27456*D1*Dd*bd1*f*g2 - 20592*D1*Dd*bd2*f**2*r**2 - 20592*D1*Dd*bd2*f**2*r*s + 20592*D1*Dd*bd2*f**2*r + 2574*D1*Dd*bd2*f**2*s - 2574*D1*Dd*bd2*f**2 + 4180*D1*Dd*f**4*r**2 + 11700*D1*Dd*f**4*r*s - 7940*D1*Dd*f**4*r - 2925*D1*Dd*f**4*s + 1045*D1*Dd*f**4 - 32320*D1*Dd*f**3*fd*r**2 - 93600*D1*Dd*f**3*fd*r*s + 62960*D1*Dd*f**3*fd*r + 23400*D1*Dd*f**3*fd*s - 13720*D1*Dd*f**3*fd - 65208*D1*Dd*f**2*g2*r**2 - 41184*D1*Dd*f**2*g2*r*s + 53196*D1*Dd*f**2*g2*r + 10296*D1*Dd*f**2*g2*s - 16302*D1*Dd*f**2*g2 + 82368*D1*Dd*f**2*gd2*r**2 + 54912*D1*Dd*f**2*gd2*r*s - 61776*D1*Dd*f**2*gd2*r - 6864*D1*Dd*f**2*gd2*s + 6864*D1*Dd*f**2*gd2 + 164736*D1*Dd*f*fd*g2*r**2 + 109824*D1*Dd*f*fd*g2*r*s - 151008*D1*Dd*f*fd*g2*r - 41184*D1*Dd*f*fd*g2*s + 34320*D1*Dd*f*fd*g2 - 4040*D1*Ddd*f**4*r**2 - 11700*D1*Ddd*f**4*r*s + 7870*D1*Ddd*f**4*r + 2925*D1*Ddd*f**4*s - 1010*D1*Ddd*f**4 + 41184*D1*Ddd*f**2*g2*r**2 + 27456*D1*Ddd*f**2*g2*r*s - 34320*D1*Ddd*f**2*g2*r - 6864*D1*Ddd*f**2*g2*s + 10296*D1*Ddd*f**2*g2 - 12120*Dd**2*f**4*r**2 - 35100*Dd**2*f**4*r*s + 23610*Dd**2*f**4*r + 8775*Dd**2*f**4*s - 5850*Dd**2*f**4 + 123552*Dd**2*f**2*g2*r**2 + 82368*Dd**2*f**2*g2*r*s - 102960*Dd**2*f**2*g2*r - 20592*Dd**2*f**2*g2*s + 13728*Dd**2*f**2*g2 + 858*b1**3*(D1**2*r*(11*fd - 2*fdd)*(r + s - 1) + D1*(Dd*(11*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 2*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + 2*Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 429*b1**2*(51*D1**2*K*fd*r**2 + 44*D1**2*K*fd*r*s - 8*D1**2*K*fdd*r**2 - 8*D1**2*K*fdd*r*s - 4*D1**2*bdd1*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 14*D1**2*f*fd*r**2 - 26*D1**2*f*fd*r*s + 3*D1**2*f*fd*r - 6*D1**2*f*fd*s + 6*D1**2*f*fd + 20*D1**2*f*fdd*r**2 + 26*D1**2*f*fdd*r*s - 7*D1**2*f*fdd*r + 4*D1**2*f*fdd*s - 4*D1**2*f*fdd + 20*D1**2*fd**2*r**2 + 26*D1**2*fd**2*r*s - 7*D1**2*fd**2*r + 4*D1**2*fd**2*s - 4*D1**2*fd**2 - 4*D1**2*fd*r**2 - 9*D1**2*fd*r*s + 2*D1**2*fdd*r**2 + D1**2*fdd*r*s + 204*D1*Dd*K*f*r**2 + 176*D1*Dd*K*f*r*s - 190*D1*Dd*K*f*r - 44*D1*Dd*K*f*s + 51*D1*Dd*K*f - 64*D1*Dd*K*fd*r**2 - 64*D1*Dd*K*fd*r*s + 32*D1*Dd*K*fd*r + 8*D1*Dd*K*fd*s - 28*D1*Dd*f**2*r**2 - 52*D1*Dd*f**2*r*s + 40*D1*Dd*f**2*r + 13*D1*Dd*f**2*s - 7*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 + 208*D1*Dd*f*fd*r*s - 120*D1*Dd*f*fd*r - 10*D1*Dd*f*fd*s - D1*Dd*f*fd - 16*D1*Dd*f*r**2 - 36*D1*Dd*f*r*s + 26*D1*Dd*f*r + 9*D1*Dd*f*s - 4*D1*Dd*f + 16*D1*Dd*fd*r**2 + 8*D1*Dd*fd*r*s - 6*D1*Dd*fd*r - D1*Dd*fd*s - 32*D1*Ddd*K*f*r**2 - 32*D1*Ddd*K*f*r*s + 32*D1*Ddd*K*f*r + 8*D1*Ddd*K*f*s - 8*D1*Ddd*K*f + 40*D1*Ddd*f**2*r**2 + 52*D1*Ddd*f**2*r*s - 46*D1*Ddd*f**2*r - 13*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 + 8*D1*Ddd*f*r**2 + 4*D1*Ddd*f*r*s - 6*D1*Ddd*f*r - D1*Ddd*f*s + 2*D1*Ddd*f + 2*D1*bd1*(D1*(11*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 2*fd*(6*r**2 + 6*r*(s - 1) - s + 1)) - 2*Dd*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 96*Dd**2*K*f*r**2 - 96*Dd**2*K*f*r*s + 96*Dd**2*K*f*r + 24*Dd**2*K*f*s - 16*Dd**2*K*f + 120*Dd**2*f**2*r**2 + 156*Dd**2*f**2*r*s - 138*Dd**2*f**2*r - 39*Dd**2*f**2*s + 26*Dd**2*f**2 + 24*Dd**2*f*r**2 + 12*Dd**2*f*r*s - 18*Dd**2*f*r - 3*Dd**2*f*s + 2*Dd**2*f) - 13*b1*(-1254*D1**2*K*f*fd*r**2 - 792*D1**2*K*f*fd*r*s + 1254*D1**2*K*f*fd*r + 396*D1**2*K*f*fd*s - 627*D1**2*K*f*fd + 792*D1**2*K*f*fdd*r**2 + 528*D1**2*K*f*fdd*r*s - 792*D1**2*K*f*fdd*r - 264*D1**2*K*f*fdd*s + 396*D1**2*K*f*fdd + 792*D1**2*K*fd**2*r**2 + 528*D1**2*K*fd**2*r*s - 792*D1**2*K*fd**2*r - 264*D1**2*K*fd**2*s - 858*D1**2*b2*fd*r**2 - 858*D1**2*b2*fd*r*s + 198*D1**2*b2*fdd*r**2 + 198*D1**2*b2*fdd*r*s + 132*D1**2*bd1**2*f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 858*D1**2*bd2*f*r**2 - 858*D1**2*bd2*f*r*s + 858*D1**2*bd2*f*r + 396*D1**2*bd2*fd*r**2 + 396*D1**2*bd2*fd*r*s - 198*D1**2*bd2*fd*r - 33*D1**2*bdd1*f*(-8*K*(2*r - 1)*(r + s - 1) + f*(20*r**2 + 13*r*(2*s - 3) - 17*s + 14) + 4*r**2 + 2*r*s - 5*r - s + 2) + 198*D1**2*bdd2*f*r**2 + 198*D1**2*bdd2*f*r*s - 198*D1**2*bdd2*f*r + 1044*D1**2*f**2*fd*r**2 + 606*D1**2*f**2*fd*r*s - 781*D1**2*f**2*fd*r - 499*D1**2*f**2*fd*s + 421*D1**2*f**2*fd - 1116*D1**2*f**2*fdd*r**2 - 600*D1**2*f**2*fdd*r*s + 869*D1**2*f**2*fdd*r + 497*D1**2*f**2*fdd*s - 458*D1**2*f**2*fdd - 2232*D1**2*f*fd**2*r**2 - 1200*D1**2*f*fd**2*r*s + 1738*D1**2*f*fd**2*r + 994*D1**2*f*fd**2*s - 547*D1**2*f*fd**2 + 264*D1**2*f*fd*r**2 + 66*D1**2*f*fd*r*s - 264*D1**2*f*fd*r - 33*D1**2*f*fd*s + 132*D1**2*f*fd - 132*D1**2*f*fdd*r**2 - 66*D1**2*f*fdd*r*s + 132*D1**2*f*fdd*r + 33*D1**2*f*fdd*s - 66*D1**2*f*fdd + 3366*D1**2*f*gd2*r**2 + 2904*D1**2*f*gd2*r*s - 2904*D1**2*f*gd2*r - 528*D1**2*f*gdd2*r**2 - 528*D1**2*f*gdd2*r*s + 528*D1**2*f*gdd2*r - 132*D1**2*fd**2*r**2 - 66*D1**2*fd**2*r*s + 132*D1**2*fd**2*r + 33*D1**2*fd**2*s + 3366*D1**2*fd*g2*r**2 + 2904*D1**2*fd*g2*r*s - 1056*D1**2*fd*gd2*r**2 - 1056*D1**2*fd*gd2*r*s + 528*D1**2*fd*gd2*r - 528*D1**2*fdd*g2*r**2 - 528*D1**2*fdd*g2*r*s - 2508*D1*Dd*K*f**2*r**2 - 1584*D1*Dd*K*f**2*r*s + 2046*D1*Dd*K*f**2*r + 396*D1*Dd*K*f**2*s - 627*D1*Dd*K*f**2 + 6336*D1*Dd*K*f*fd*r**2 + 4224*D1*Dd*K*f*fd*r*s - 5808*D1*Dd*K*f*fd*r - 1584*D1*Dd*K*f*fd*s + 1320*D1*Dd*K*f*fd - 3432*D1*Dd*b2*f*r**2 - 3432*D1*Dd*b2*f*r*s + 3432*D1*Dd*b2*f*r + 858*D1*Dd*b2*f*s - 858*D1*Dd*b2*f + 1584*D1*Dd*b2*fd*r**2 + 1584*D1*Dd*b2*fd*r*s - 792*D1*Dd*b2*fd*r - 198*D1*Dd*b2*fd*s + 1584*D1*Dd*bd2*f*r**2 + 1584*D1*Dd*bd2*f*r*s - 1584*D1*Dd*bd2*f*r - 198*D1*Dd*bd2*f*s + 198*D1*Dd*bd2*f + 1392*D1*Dd*f**3*r**2 + 808*D1*Dd*f**3*r*s - 1100*D1*Dd*f**3*r - 202*D1*Dd*f**3*s + 348*D1*Dd*f**3 - 8928*D1*Dd*f**2*fd*r**2 - 4800*D1*Dd*f**2*fd*r*s + 6908*D1*Dd*f**2*fd*r + 2588*D1*Dd*f**2*fd*s - 1863*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 + 132*D1*Dd*f**2*r*s - 330*D1*Dd*f**2*r - 33*D1*Dd*f**2*s + 132*D1*Dd*f**2 - 1056*D1*Dd*f*fd*r**2 - 528*D1*Dd*f*fd*r*s + 924*D1*Dd*f*fd*r + 198*D1*Dd*f*fd*s - 198*D1*Dd*f*fd + 13464*D1*Dd*f*g2*r**2 + 11616*D1*Dd*f*g2*r*s - 12540*D1*Dd*f*g2*r - 2904*D1*Dd*f*g2*s + 3366*D1*Dd*f*g2 - 4224*D1*Dd*f*gd2*r**2 - 4224*D1*Dd*f*gd2*r*s + 4224*D1*Dd*f*gd2*r + 528*D1*Dd*f*gd2*s - 528*D1*Dd*f*gd2 - 4224*D1*Dd*fd*g2*r**2 - 4224*D1*Dd*fd*g2*r*s + 2112*D1*Dd*fd*g2*r + 528*D1*Dd*fd*g2*s + 1584*D1*Ddd*K*f**2*r**2 + 1056*D1*Ddd*K*f**2*r*s - 1320*D1*Ddd*K*f**2*r - 264*D1*Ddd*K*f**2*s + 396*D1*Ddd*K*f**2 + 792*D1*Ddd*b2*f*r**2 + 792*D1*Ddd*b2*f*r*s - 792*D1*Ddd*b2*f*r - 198*D1*Ddd*b2*f*s + 198*D1*Ddd*b2*f - 1488*D1*Ddd*f**3*r**2 - 800*D1*Ddd*f**3*r*s + 1144*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s - 372*D1*Ddd*f**3 - 264*D1*Ddd*f**2*r**2 - 132*D1*Ddd*f**2*r*s + 198*D1*Ddd*f**2*r + 33*D1*Ddd*f**2*s - 66*D1*Ddd*f**2 - 2112*D1*Ddd*f*g2*r**2 - 2112*D1*Ddd*f*g2*r*s + 2112*D1*Ddd*f*g2*r + 528*D1*Ddd*f*g2*s - 528*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(f**2*(14*r**2 + r*(26*s - 37) - 19*s + 13) + f*(K*(-102*r**2 - 88*r*s + 146*r + 44*s - 51) + fd*(-80*r**2 + r*(92 - 104*s) + 26*s - 15) + 8*r**2 + 18*r*s - 17*r - 9*s + 4) + fd*(-8*K*s + r**2*(32*K - 8) + r*(8*K*(4*s - 3) - 4*s + 5) + s)) + Dd*f*(8*K*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + f*(-160*r**2 - 8*r*(26*s - 31) + 94*s - 73) - 32*r**2 - 16*r*s + 32*r + 6*s - 7)) + 4752*Dd**2*K*f**2*r**2 + 3168*Dd**2*K*f**2*r*s - 3960*Dd**2*K*f**2*r - 792*Dd**2*K*f**2*s + 528*Dd**2*K*f**2 + 2376*Dd**2*b2*f*r**2 + 2376*Dd**2*b2*f*r*s - 2376*Dd**2*b2*f*r - 594*Dd**2*b2*f*s + 396*Dd**2*b2*f - 4464*Dd**2*f**3*r**2 - 2400*Dd**2*f**3*r*s + 3432*Dd**2*f**3*r + 600*Dd**2*f**3*s - 400*Dd**2*f**3 - 792*Dd**2*f**2*r**2 - 396*Dd**2*f**2*r*s + 594*Dd**2*f**2*r + 99*Dd**2*f**2*s - 66*Dd**2*f**2 - 6336*Dd**2*f*g2*r**2 - 6336*Dd**2*f*g2*r*s + 6336*Dd**2*f*g2*r + 1584*Dd**2*f*g2*s - 1056*Dd**2*f*g2) + 858*b2*(-3*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 10*D1**2*f*fd*r**2 + 10*D1**2*f*fd*r*s - 10*D1**2*f*fd*r - 5*D1**2*f*fd*s + 5*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r + 3*D1**2*f*fdd*s - 3*D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 3*D1**2*fd**2*s + 20*D1*Dd*f**2*r**2 + 20*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r - 5*D1*Dd*f**2*s + 5*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r + 18*D1*Dd*f*fd*s - 12*D1*Dd*f*fd - 12*D1*Ddd*f**2*r**2 - 12*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r + 3*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + D1*bd1*(D1*(13*f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 36*Dd**2*f**2*r**2 - 36*Dd**2*f**2*r*s + 36*Dd**2*f**2*r + 9*Dd**2*f**2*s - 6*Dd**2*f**2))/(9009*d**2*k3**4) + D1**2*Pk3*Pkd1*k1*st**2*(-33*b1**2*(D1**2*r*(fd*(34*C*r + 36*C*(s - 1) - 17*r - 27*s + 27) + fdd*(4*C*(r - s + 1) - 2*r + 3*s - 3)) + D1*(Dd*(f*(2*C*(68*r**2 + 72*r*s - 70*r - 18*s + 17) - 68*r**2 - 108*r*s + 88*r + 27*s - 17) + fd*(4*C*(8*r**2 - 8*r*s + 4*r + s - 1) - 16*r**2 + 24*r*s - 14*r - 3*s + 3)) + Ddd*f*(4*C*(4*r**2 - 4*r*s + s + 1) - 8*r**2 + 12*r*s - 2*r - 3*s - 2)) + Dd**2*f*(4*C*(12*r**2 - 12*r*s + 3*s - 2) - 24*r**2 + 6*r*(6*s - 1) - 9*s + 6)) - 33*b1*(-16*C*D1**2*f*fd*r*s + 4*C*D1**2*f*fd*r - 4*C*D1**2*f*fd*s + 2*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*s - 4*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 - 32*C*D1*Dd*f**2*r*s + 16*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s + 128*C*D1*Dd*f*fd*r*s - 32*C*D1*Dd*f*fd*r - 8*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r*s - 16*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s + 96*C*Dd**2*f**2*r*s - 48*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s + 16*C*Dd**2*f**2 + D1**2*bdd1*f*(4*C*(2*r**2 - 2*r*(s + 1) + s + 1) - 4*r**2 + 6*r*s + 4*r - 3*s - 2) + 8*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 3*D1**2*f*fd*s - D1**2*f*fd - 8*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*s + 2*D1**2*f*fdd - 8*D1**2*fd**2*r*s - 3*D1**2*fd**2*s + 3*D1**2*fd**2 + 16*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 4*D1*Dd*f**2*s - 64*D1*Dd*f*fd*r*s + 16*D1*Dd*f*fd*r - 4*D1*Dd*f*fd*s + 6*D1*Dd*f*fd - 16*D1*Ddd*f**2*r*s + 8*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s + D1*bd1*(D1*(f*(C*(68*r**2 + 72*r*s - 68*r - 36*s + 34) - 34*r**2 - 54*r*s + 34*r + 27*s - 17) + fd*(4*C*(4*r**2 - 4*r*s + s - 1) - 8*r**2 + 12*r*s - 2*r - 3*s + 3)) + 2*Dd*f*(12*C*s + r**2*(32*C - 16) + r*(-16*C*(2*s + 1) + 24*s + 6) - 9*s + 1)) - 48*Dd**2*f**2*r*s + 24*Dd**2*f**2*r + 12*Dd**2*f**2*s - 8*Dd**2*f**2) + f*(438*C*D1**2*f*fd*r**2 + 1188*C*D1**2*f*fd*r*s - 688*C*D1**2*f*fd*r - 396*C*D1**2*f*fd*s + 146*C*D1**2*f*fd - 516*C*D1**2*f*fdd*r**2 - 1188*C*D1**2*f*fdd*r*s + 740*C*D1**2*f*fdd*r + 396*C*D1**2*f*fdd*s - 172*C*D1**2*f*fdd - 1032*C*D1**2*fd**2*r**2 - 2376*C*D1**2*fd**2*r*s + 1480*C*D1**2*fd**2*r + 792*C*D1**2*fd**2*s - 396*C*D1**2*fd**2 + 584*C*D1*Dd*f**2*r**2 + 1584*C*D1*Dd*f**2*r*s - 1084*C*D1*Dd*f**2*r - 396*C*D1*Dd*f**2*s + 146*C*D1*Dd*f**2 - 4128*C*D1*Dd*f*fd*r**2 - 9504*C*D1*Dd*f*fd*r*s + 6368*C*D1*Dd*f*fd*r + 2772*C*D1*Dd*f*fd*s - 1532*C*D1*Dd*f*fd - 688*C*D1*Ddd*f**2*r**2 - 1584*C*D1*Ddd*f**2*r*s + 1136*C*D1*Ddd*f**2*r + 396*C*D1*Ddd*f**2*s - 172*C*D1*Ddd*f**2 - 2064*C*Dd**2*f**2*r**2 - 4752*C*Dd**2*f**2*r*s + 3408*C*Dd**2*f**2*r + 1188*C*Dd**2*f**2*s - 792*C*Dd**2*f**2 - 33*D1**2*bd1**2*(r**2*(8*C - 4) + r*(-8*C*(s + 1) + 6*s + 4) + s*(4*C - 3)) - 33*D1**2*bdd1*f*(4*C*(2*r*(s - 1) - 3*s + 1) - 4*r*(s - 1) + 7*s - 2) - 219*D1**2*f*fd*r**2 - 645*D1**2*f*fd*r*s + 361*D1**2*f*fd*r + 215*D1**2*f*fd*s - 73*D1**2*f*fd + 258*D1**2*f*fdd*r**2 + 669*D1**2*f*fdd*r*s - 395*D1**2*f*fdd*r - 223*D1**2*f*fdd*s + 86*D1**2*f*fdd + 516*D1**2*fd**2*r**2 + 1338*D1**2*fd**2*r*s - 790*D1**2*fd**2*r - 446*D1**2*fd**2*s + 223*D1**2*fd**2 - 292*D1*Dd*f**2*r**2 - 860*D1*Dd*f**2*r*s + 576*D1*Dd*f**2*r + 215*D1*Dd*f**2*s - 73*D1*Dd*f**2 + 2064*D1*Dd*f*fd*r**2 + 5352*D1*Dd*f*fd*r*s - 3434*D1*Dd*f*fd*r - 1561*D1*Dd*f*fd*s + 841*D1*Dd*f*fd + 344*D1*Ddd*f**2*r**2 + 892*D1*Ddd*f**2*r*s - 618*D1*Ddd*f**2*r - 223*D1*Ddd*f**2*s + 86*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f*(2*C*(4*r*s - 2*r - 6*s + 1) - 4*r*s + 2*r + 7*s - 1) + fd*(-4*C*(8*r*s - 4*r - 5*s + 3) + 16*r*s - 8*r - 11*s + 7)) + 2*Dd*f*(-4*C*(r*(8*s - 6) - 7*s + 4) + 4*r*(4*s - 3) - 16*s + 9)) + 1032*Dd**2*f**2*r**2 + 2676*Dd**2*f**2*r*s - 1854*Dd**2*f**2*r - 669*Dd**2*f**2*s + 446*Dd**2*f**2))/(693*d**2*k3**2) - D1**2*Pk3*Pkd1*k1*(8*D1**2*K*bd1**2*f*r*s - 62*D1**2*K*bd1**2*f*r - 28*D1**2*K*bd1**2*f*s + 28*D1**2*K*bd1**2*f - 22*D1**2*K*bd1*f**2*r**2 - 24*D1**2*K*bd1*f**2*r*s + 24*D1**2*K*bd1*f**2*r + 116*D1**2*K*bd1*f*fd*r**2 + 96*D1**2*K*bd1*f*fd*r*s - 106*D1**2*K*bd1*f*fd*r - 24*D1**2*K*bd1*f*fd*s + 24*D1**2*K*bd1*f*fd + 29*D1**2*K*bdd1*f**2*r**2 + 24*D1**2*K*bdd1*f**2*r*s - 24*D1**2*K*bdd1*f**2*r + 12*D1**2*bd1**2*f**2*s - 12*D1**2*bd1**2*f**2 + 12*D1**2*bd1**2*f*s - 12*D1**2*bd1**2*f + 84*D1**2*bd1**2*g2*r**2 + 112*D1**2*bd1**2*g2*r*s - 84*D1**2*bd1**2*g2*r - 56*D1**2*bd1**2*g2*s + 58*D1**2*bd1*bd2*f*r**2 + 56*D1**2*bd1*bd2*f*r*s - 86*D1**2*bd1*bd2*f*r - 28*D1**2*bd1*bd2*f*s + 28*D1**2*bd1*bd2*f + 10*D1**2*bd1*f**3*r*s - 10*D1**2*bd1*f**3*r - 60*D1**2*bd1*f**2*fd*r*s + 40*D1**2*bd1*f**2*fd*r + 10*D1**2*bd1*f**2*fd*s - 10*D1**2*bd1*f**2*fd + 8*D1**2*bd1*f**2*r*s - 8*D1**2*bd1*f**2*r - 40*D1**2*bd1*f*fd*r*s + 20*D1**2*bd1*f*fd*r + 10*D1**2*bd1*f*fd*s - 10*D1**2*bd1*f*fd + 16*D1**2*bd1*f*g2*r*s - 64*D1**2*bd1*f*g2*r - 56*D1**2*bd1*f*g2*s + 32*D1**2*bd1*f*g2 - 16*D1**2*bd1*f*gd2*r*s + 124*D1**2*bd1*f*gd2*r + 56*D1**2*bd1*f*gd2*s - 56*D1**2*bd1*f*gd2 - 16*D1**2*bd1*fd*g2*r*s + 8*D1**2*bd1*fd*g2*s - 22*D1**2*bd2*f**2*r**2 - 24*D1**2*bd2*f**2*r*s + 24*D1**2*bd2*f**2*r + 116*D1**2*bd2*f*fd*r**2 + 96*D1**2*bd2*f*fd*r*s - 106*D1**2*bd2*f*fd*r - 24*D1**2*bd2*f*fd*s + 24*D1**2*bd2*f*fd - 10*D1**2*bdd1*f**3*r*s + 10*D1**2*bdd1*f**3*r - 10*D1**2*bdd1*f**2*r*s + 10*D1**2*bdd1*f**2*r - 8*D1**2*bdd1*f*g2*r*s + 116*D1**2*bdd1*f*g2*r + 56*D1**2*bdd1*f*g2*s - 58*D1**2*bdd1*f*g2 + 29*D1**2*bdd2*f**2*r**2 + 24*D1**2*bdd2*f**2*r*s - 24*D1**2*bdd2*f**2*r + 44*D1**2*f**2*gd2*r**2 + 48*D1**2*f**2*gd2*r*s - 48*D1**2*f**2*gd2*r - 58*D1**2*f**2*gdd2*r**2 - 48*D1**2*f**2*gdd2*r*s + 48*D1**2*f**2*gdd2*r + 88*D1**2*f*fd*g2*r**2 + 96*D1**2*f*fd*g2*r*s - 88*D1**2*f*fd*g2*r - 48*D1**2*f*fd*g2*s + 44*D1**2*f*fd*g2 - 232*D1**2*f*fd*gd2*r**2 - 192*D1**2*f*fd*gd2*r*s + 212*D1**2*f*fd*gd2*r + 48*D1**2*f*fd*gd2*s - 48*D1**2*f*fd*gd2 - 116*D1**2*f*fdd*g2*r**2 - 96*D1**2*f*fdd*g2*r*s + 116*D1**2*f*fdd*g2*r + 48*D1**2*f*fdd*g2*s - 58*D1**2*f*fdd*g2 - 116*D1**2*fd**2*g2*r**2 - 96*D1**2*fd**2*g2*r*s + 116*D1**2*fd**2*g2*r + 48*D1**2*fd**2*g2*s + 232*D1*Dd*K*bd1*f**2*r**2 + 192*D1*Dd*K*bd1*f**2*r*s - 202*D1*Dd*K*bd1*f**2*r - 24*D1*Dd*K*bd1*f**2*s + 24*D1*Dd*K*bd1*f**2 - 80*D1*Dd*bd1*f**3*r*s + 60*D1*Dd*bd1*f**3*r + 10*D1*Dd*bd1*f**3*s - 10*D1*Dd*bd1*f**3 - 80*D1*Dd*bd1*f**2*r*s + 60*D1*Dd*bd1*f**2*r + 10*D1*Dd*bd1*f**2*s - 10*D1*Dd*bd1*f**2 - 64*D1*Dd*bd1*f*g2*r*s + 480*D1*Dd*bd1*f*g2*r + 232*D1*Dd*bd1*f*g2*s - 228*D1*Dd*bd1*f*g2 + 232*D1*Dd*bd2*f**2*r**2 + 192*D1*Dd*bd2*f**2*r*s - 202*D1*Dd*bd2*f**2*r - 24*D1*Dd*bd2*f**2*s + 24*D1*Dd*bd2*f**2 + 176*D1*Dd*f**2*g2*r**2 + 192*D1*Dd*f**2*g2*r*s - 184*D1*Dd*f**2*g2*r - 48*D1*Dd*f**2*g2*s + 44*D1*Dd*f**2*g2 - 464*D1*Dd*f**2*gd2*r**2 - 384*D1*Dd*f**2*gd2*r*s + 404*D1*Dd*f**2*gd2*r + 48*D1*Dd*f**2*gd2*s - 48*D1*Dd*f**2*gd2 - 928*D1*Dd*f*fd*g2*r**2 - 768*D1*Dd*f*fd*g2*r*s + 888*D1*Dd*f*fd*g2*r + 288*D1*Dd*f*fd*g2*s - 212*D1*Dd*f*fd*g2 - 232*D1*Ddd*f**2*g2*r**2 - 192*D1*Ddd*f**2*g2*r*s + 212*D1*Ddd*f**2*g2*r + 48*D1*Ddd*f**2*g2*s - 58*D1*Ddd*f**2*g2 - 696*Dd**2*f**2*g2*r**2 - 576*Dd**2*f**2*g2*r*s + 636*Dd**2*f**2*g2*r + 144*Dd**2*f**2*g2*s - 96*Dd**2*f**2*g2 + 7*b1**3*(2*D1*Dd*(K*(12*r**2 + 2*r*(8*s - 7) - 4*s + 3) + fd*(r*(8*s - 6) - s + 1) - (f + 2)*(r*(4*s - 2) - s)) - D1*(2*D1*r*(fd - fdd)*(s - 1) + Ddd*K*(12*r**2 + 2*r*(8*s - 7) - 4*s + 3) - 2*Ddd*(f + 1)*(r*(4*s - 2) - s)) + 2*Dd**2*(K*(-18*r**2 - 24*r*s + 21*r + 6*s - 4) + f*(6*r*(2*s - 1) - 3*s + 2) + 12*r*s - 6*r - 3*s + 2)) + b1**2*(-D1**2*(4*K*fd*(2*r*(s + 4) + 5*s - 4) - 4*K*fdd*r*s - 58*K*fdd*r - 24*K*fdd*s + 29*K*fdd + 7*bdd1*(K*(9*r**2 + 2*r*(6*s - 5) - 4*s + 3) + (-2*f - 2)*(r*(3*s - 1) - s)) + 12*f*fdd*s + 12*fd**2*(s - 1) - fd*s*(12*f + 10) + 12*fdd*s + 84*gd2*r**2 + 112*gd2*r*s - 112*gd2*r - 42*gdd2*r**2 - 56*gdd2*r*s + 56*gdd2*r) - 14*D1*bd1*(-D1*(K*(9*r**2 + 2*r*(6*s - 5) - 4*s + 3) + fd*(r*(6*s - 4) - s + 1) - (f + 2)*(r*(3*s - 1) - s)) + Dd*(K*(36*r**2 + 48*r*s - 41*r - 14*s + 9) + f*(r*(10 - 24*s) + 7*s - 3) - 24*r*s + 10*r + 7*s - 3)) - 2*D1*(-Dd*fd*(K*(16*r*(s + 7) + 46*s - 53) + f*(12 - 24*s) - 24*s + 12) + 2*Dd*(2*K*f*(4*r*s - 2*r - s) + 7*g2*(12*r**2 + 2*r*(8*s - 7) - 4*s + 3) - 7*gd2*(12*r**2 + 16*r*s - 15*r - 2*s + 2)) + 2*Ddd*K*f*(r*(2 - 4*s) + s) - 7*Ddd*g2*(12*r**2 + 2*r*(8*s - 7) - 4*s + 3)) + 4*Dd**2*(K*f*(6*r*(2*s - 1) - 3*s + 2) + 7*g2*(18*r**2 + 3*r*(8*s - 7) - 6*s + 4))) + b1*(8*D1**2*K*bdd1*f*r*s - 62*D1**2*K*bdd1*f*r - 28*D1**2*K*bdd1*f*s + 29*D1**2*K*bdd1*f - 44*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 44*D1**2*K*f*fd*r + 24*D1**2*K*f*fd*s - 22*D1**2*K*f*fd + 58*D1**2*K*f*fdd*r**2 + 48*D1**2*K*f*fdd*r*s - 58*D1**2*K*f*fdd*r - 24*D1**2*K*f*fdd*s + 29*D1**2*K*f*fdd + 58*D1**2*K*fd**2*r**2 + 48*D1**2*K*fd**2*r*s - 58*D1**2*K*fd**2*r - 24*D1**2*K*fd**2*s + 14*D1**2*bd1**2*(K*(-9*r**2 - 2*r*(6*s - 5) + 4*s - 2) + f*r*(6*s - 2) - 2*f*s + f + 6*r*s - 2*r - 2*s + 1) - 16*D1**2*bd2*f*r**2 - 28*D1**2*bd2*f*r*s + 28*D1**2*bd2*f*r + 58*D1**2*bd2*fd*r**2 + 56*D1**2*bd2*fd*r*s - 28*D1**2*bd2*fd*r + 12*D1**2*bdd1*f**2*s + 12*D1**2*bdd1*f*s + 84*D1**2*bdd1*g2*r**2 + 112*D1**2*bdd1*g2*r*s - 84*D1**2*bdd1*g2*r - 56*D1**2*bdd1*g2*s + 42*D1**2*bdd1*g2 + 29*D1**2*bdd2*f*r**2 + 28*D1**2*bdd2*f*r*s - 28*D1**2*bdd2*f*r + 30*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r - 10*D1**2*f**2*fd*s - 30*D1**2*f**2*fdd*r*s + 10*D1**2*f**2*fdd*r + 10*D1**2*f**2*fdd*s - 60*D1**2*f*fd**2*r*s + 20*D1**2*f*fd**2*r + 20*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*s - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*s + 16*D1**2*f*gd2*r*s - 16*D1**2*f*gd2*r - 8*D1**2*f*gdd2*r*s + 8*D1**2*f*gdd2*r - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*s + 16*D1**2*fd*g2*r*s + 64*D1**2*fd*g2*r + 40*D1**2*fd*g2*s - 32*D1**2*fd*g2 - 16*D1**2*fd*gd2*r*s - 108*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s + 48*D1**2*fd*gd2 - 8*D1**2*fdd*g2*r*s - 116*D1**2*fdd*g2*r - 48*D1**2*fdd*g2*s + 58*D1**2*fdd*g2 - 88*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s + 92*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s - 22*D1*Dd*K*f**2 + 464*D1*Dd*K*f*fd*r**2 + 384*D1*Dd*K*f*fd*r*s - 444*D1*Dd*K*f*fd*r - 144*D1*Dd*K*f*fd*s + 106*D1*Dd*K*f*fd + 232*D1*Dd*bd2*f*r**2 + 224*D1*Dd*bd2*f*r*s - 226*D1*Dd*bd2*f*r - 28*D1*Dd*bd2*f*s + 28*D1*Dd*bd2*f + 40*D1*Dd*f**3*r*s - 20*D1*Dd*f**3*r - 10*D1*Dd*f**3*s - 240*D1*Dd*f**2*fd*r*s + 100*D1*Dd*f**2*fd*r + 70*D1*Dd*f**2*fd*s - 30*D1*Dd*f**2*fd + 32*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 8*D1*Dd*f**2*s - 160*D1*Dd*f*fd*r*s + 40*D1*Dd*f*fd*r + 60*D1*Dd*f*fd*s - 20*D1*Dd*f*fd + 64*D1*Dd*f*g2*r*s - 32*D1*Dd*f*g2*r - 16*D1*Dd*f*g2*s - 64*D1*Dd*f*gd2*r*s + 48*D1*Dd*f*gd2*r + 8*D1*Dd*f*gd2*s - 8*D1*Dd*f*gd2 - 64*D1*Dd*fd*g2*r*s - 448*D1*Dd*fd*g2*r - 184*D1*Dd*fd*g2*s + 212*D1*Dd*fd*g2 + 116*D1*Ddd*K*f**2*r**2 + 96*D1*Ddd*K*f**2*r*s - 106*D1*Ddd*K*f**2*r - 24*D1*Ddd*K*f**2*s + 29*D1*Ddd*K*f**2 - 40*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r + 10*D1*Ddd*f**3*s - 40*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 10*D1*Ddd*f**2*s - 32*D1*Ddd*f*g2*r*s + 16*D1*Ddd*f*g2*r + 8*D1*Ddd*f*g2*s - 2*D1*bd1*(D1*(8*K*f*r*s - 20*K*f*r - 14*K*f*s + 8*K*f + 6*f**2*s + 5*f*s - fd*(K*(8*r*s + 27*r + 10*s - 12) - 6*s + 6) + 14*g2*(6*r**2 + 8*r*s - 6*r - 4*s + 3) - 84*gd2*r**2 - 112*gd2*r*s + 98*gd2*r + 28*gd2*s - 28*gd2) + Dd*(f**2*(12 - 24*s) + f*(K*(-32*r*s + 132*r + 60*s - 59) - 24*s + 12) - 14*g2*(24*r**2 + r*(32*s - 26) - 12*s + 7))) + 348*Dd**2*K*f**2*r**2 + 288*Dd**2*K*f**2*r*s - 318*Dd**2*K*f**2*r - 72*Dd**2*K*f**2*s + 48*Dd**2*K*f**2 - 120*Dd**2*f**3*r*s + 60*Dd**2*f**3*r + 30*Dd**2*f**3*s - 20*Dd**2*f**3 - 120*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 30*Dd**2*f**2*s - 20*Dd**2*f**2 - 96*Dd**2*f*g2*r*s + 48*Dd**2*f*g2*r + 24*Dd**2*f*g2*s - 16*Dd**2*f*g2 + b2*(D1**2*r*(-4*fd*(4*r + 7*s) + fdd*(29*r + 28*s)) + D1*(-2*Dd*(2*f*(16*r**2 + 28*r*s - 22*r - 7*s + 4) + fd*(-116*r**2 - 112*r*s + 57*r + 14*s)) + Ddd*f*(116*r**2 + 2*r*(56*s - 57) - 28*s + 29)) + 2*Dd**2*f*(174*r**2 + 3*r*(56*s - 57) - 42*s + 28))) + b2*(D1**2*bdd1*f*(r - 1)*(29*r + 28*s - 29) - 44*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 44*D1**2*f*fd*r + 24*D1**2*f*fd*s - 22*D1**2*f*fd + 58*D1**2*f*fdd*r**2 + 48*D1**2*f*fdd*r*s - 58*D1**2*f*fdd*r - 24*D1**2*f*fdd*s + 29*D1**2*f*fdd + 58*D1**2*fd**2*r**2 + 48*D1**2*fd**2*r*s - 58*D1**2*fd**2*r - 24*D1**2*fd**2*s - 88*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s + 92*D1*Dd*f**2*r + 24*D1*Dd*f**2*s - 22*D1*Dd*f**2 + 464*D1*Dd*f*fd*r**2 + 384*D1*Dd*f*fd*r*s - 444*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s + 106*D1*Dd*f*fd + 116*D1*Ddd*f**2*r**2 + 96*D1*Ddd*f**2*r*s - 106*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s + 29*D1*Ddd*f**2 - 2*D1*bd1*(D1*(2*f*(r - 1)*(4*r + 7*s - 4) + fd*(-29*r**2 - 28*r*s + 29*r + 14*s)) + Dd*f*(-116*r**2 + r*(173 - 112*s) + 70*s - 57)) + 348*Dd**2*f**2*r**2 + 288*Dd**2*f**2*r*s - 318*Dd**2*f**2*r - 72*Dd**2*f**2*s + 48*Dd**2*f**2))/(21*d**2*k3**2) + D1**2*Pk3*Pkd1*k2**4*st**4*(429*b1**2*(2*D1**2*r**2*(f*fdd + fd**2) + D1*f*(4*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f**2*r*(2*r - 1)) + 13*b1*f*(33*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 108*D1**2*f*fd*r**2 + 48*D1**2*f*fd*r*s - 36*D1**2*f*fd*r - 16*D1**2*f*fd*s + 6*D1**2*f*fd - 54*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r + 8*D1**2*f*fdd*s - 3*D1**2*f*fdd - 108*D1**2*fd**2*r**2 - 48*D1**2*fd**2*r*s + 36*D1**2*fd**2*r + 16*D1**2*fd**2*s - 12*D1**2*fd**2 + 144*D1*Dd*f**2*r**2 + 64*D1*Dd*f**2*r*s - 104*D1*Dd*f**2*r - 16*D1*Dd*f**2*s + 36*D1*Dd*f**2 - 432*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 228*D1*Dd*f*fd*r + 56*D1*Dd*f*fd*s - 34*D1*Dd*f*fd - 72*D1*Ddd*f**2*r**2 - 32*D1*Ddd*f**2*r*s + 52*D1*Ddd*f**2*r + 8*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 + 66*D1*bd1*(2*r - 1)*(2*D1*fd*r + Dd*f*(4*r - 1)) - 216*Dd**2*f**2*r**2 - 96*Dd**2*f**2*r*s + 156*Dd**2*f**2*r + 24*Dd**2*f**2*s - 16*Dd**2*f**2) + f**2*(858*D1**2*bd1**2*r*(r - 1) - 13*D1**2*bdd1*f*(18*r**2 + 8*r*s - 34*r + 15) - 336*D1**2*f*fd*r**2 - 520*D1**2*f*fd*r*s + 428*D1**2*f*fd*r + 130*D1**2*f*fd*s - 84*D1**2*f*fd + 324*D1**2*f*fdd*r**2 + 520*D1**2*f*fdd*r*s - 422*D1**2*f*fdd*r - 130*D1**2*f*fdd*s + 81*D1**2*f*fdd + 972*D1**2*fd**2*r**2 + 1560*D1**2*fd**2*r*s - 1266*D1**2*fd**2*r - 390*D1**2*fd**2*s + 260*D1**2*fd**2 - 336*D1*Dd*f**2*r**2 - 520*D1*Dd*f**2*r*s + 428*D1*Dd*f**2*r + 130*D1*Dd*f**2*s - 84*D1*Dd*f**2 + 2592*D1*Dd*f*fd*r**2 + 4160*D1*Dd*f*fd*r*s - 3376*D1*Dd*f*fd*r - 1040*D1*Dd*f*fd*s + 682*D1*Dd*f*fd + 324*D1*Ddd*f**2*r**2 + 520*D1*Ddd*f**2*r*s - 422*D1*Ddd*f**2*r - 130*D1*Ddd*f**2*s + 81*D1*Ddd*f**2 + 26*D1*bd1*(D1*(f*(18*r**2 + r*(8*s - 34) + 15) - 2*fd*(27*r**2 + 6*r*(2*s - 5) - 2*s + 1)) + Dd*f*(-72*r**2 + r*(94 - 32*s) + 4*s - 17)) + 972*Dd**2*f**2*r**2 + 1560*Dd**2*f**2*r*s - 1266*Dd**2*f**2*r - 390*Dd**2*f**2*s + 260*Dd**2*f**2))/(3003*d**2*k1*k3**4) + D1**2*Pk3*Pkd1*k2**2*st**4*(132*C*D1**2*b1*f*fdd*r**2 + 132*C*D1**2*b1*fd**2*r**2 - 60*C*D1**2*f**2*fd*r**2 + 40*C*D1**2*f**2*fd*r - 20*C*D1**2*f**2*fd + 30*C*D1**2*f**2*fdd*r**2 - 20*C*D1**2*f**2*fdd*r + 10*C*D1**2*f**2*fdd + 60*C*D1**2*f*fd**2*r**2 - 40*C*D1**2*f*fd**2*r + 1056*C*D1*Dd*b1*f*fd*r**2 - 264*C*D1*Dd*b1*f*fd*r - 80*C*D1*Dd*f**3*r**2 + 40*C*D1*Dd*f**3*r - 20*C*D1*Dd*f**3 + 240*C*D1*Dd*f**2*fd*r**2 - 140*C*D1*Dd*f**2*fd*r + 20*C*D1*Dd*f**2*fd + 264*C*D1*Ddd*b1*f**2*r**2 - 132*C*D1*Ddd*b1*f**2*r + 66*C*D1*Ddd*b1*f**2 + 40*C*D1*Ddd*f**3*r**2 - 20*C*D1*Ddd*f**3*r + 10*C*D1*Ddd*f**3 + 792*C*Dd**2*b1*f**2*r**2 - 396*C*Dd**2*b1*f**2*r + 120*C*Dd**2*f**3*r**2 - 60*C*Dd**2*f**3*r - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 + 33*D1**2*bdd1*f**2*(2*C - 1)*(r - 1)**2 + 6*D1**2*f**2*fd*r**2 - 12*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 + 6*D1**2*f**2*fdd*r*s - 2*D1**2*f**2*fdd*s - D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 + 12*D1**2*f*fd**2*r*s - 4*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 - 264*D1*Dd*b1*f**2*r*s + 132*D1*Dd*b1*f**2*r + 66*D1*Dd*b1*f**2*s - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 8*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r*s + 4*D1*Dd*f**3*r + 4*D1*Dd*f**3*s + 2*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 + 48*D1*Dd*f**2*fd*r*s - 6*D1*Dd*f**2*fd*r - 14*D1*Dd*f**2*fd*s + 4*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 + 8*D1*Ddd*f**3*r*s - 2*D1*Ddd*f**3*r - 2*D1*Ddd*f**3*s - D1*Ddd*f**3 - 66*D1*bd1*f*(r - 1)*(D1*f*s + D1*fd*r*(2 - 4*C) - Dd*f*(2*C - 1)*(4*r - 1)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 12*Dd**2*f**3*r**2 + 24*Dd**2*f**3*r*s - 6*Dd**2*f**3*r - 6*Dd**2*f**3*s + 4*Dd**2*f**3)/(231*d**2*k1*k3**2) + D1**2*Pk3*Pkd1*k2**2*st**2*(D1*(11*D1*bd1**2*f*(3*f*(r*(4*s - 1) - 2*s + 1) + r**2*(8*K + 4) + r*(-8*K + 2*s - 5) - s + 1) - 11*b2*(bd1*(r - 1)*(D1*f*(r - 1) - 8*D1*fd*r + 8*Dd*f*(1 - 4*r)) + f*(-4*D1*bdd1*(r - 1)**2 + D1*fd*(2*r**2 - 2*r + 1) + Dd*f*(4*r**2 - 2*r + 1))) + bd1*(D1*(-3*f**3*r*(13*r + 22*s - 11) + f**2*(3*fd*(72*r**2 + 6*r*(22*s - 15) - 22*s + 11) - 11*r*(r*(K + 4) + s - 1)) + 11*f*(fd*(4*r - 1)*(2*r + s - 1) + (2*r - 2)*(g2*(r - 1) + r*(4*bd2 - 8*gd2))) - 176*fd*g2*r*(r - 1)) + Dd*f*(3*f**2*(96*r**2 + 16*r*(11*s - 7) - 22*s + 11) + 11*f*(8*r - 1)*(2*r + s - 1) - 176*g2*(4*r**2 - 5*r + 1))) + f*(D1*bdd1*(f*r*(f*(36*r + 66*s - 33) + 22*r + 11*s - 11) - 88*g2*(r - 1)**2) - 11*D1*f*r**2*(bd2 - 2*gd2) + 22*D1*fd*g2*(2*r**2 - 2*r + 1) + 22*Dd*f*g2*(4*r**2 - 2*r + 1))) - 11*b1**3*(D1**2*r**2*(fd - 4*fdd) + D1*(Dd*f*(4*r**2 - 2*r + 1) + 8*Dd*fd*r*(1 - 4*r) - 4*Ddd*f*(4*r**2 - 2*r + 1)) + 24*Dd**2*f*r*(1 - 2*r)) - 11*b1**2*(D1**2*K*fd*r**2 - 4*D1**2*K*fdd*r**2 - 4*D1**2*bdd1*f*(3*r**2 - 2*r + 1) - 4*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s - 11*D1**2*f*fd*r + D1**2*f*fd - 12*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r - 12*D1**2*fd**2*r*s + 9*D1**2*fd**2*r + 4*D1**2*fd*r**2 + 9*D1**2*fd*r*s - 2*D1**2*fdd*r**2 - D1**2*fdd*r*s + 4*D1*Dd*K*f*r**2 - 2*D1*Dd*K*f*r + D1*Dd*K*f - 32*D1*Dd*K*fd*r**2 + 8*D1*Dd*K*fd*r - 8*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 6*D1*Dd*f**2*s - 2*D1*Dd*f**2 - 96*D1*Dd*f*fd*r*s + 60*D1*Dd*f*fd*r + 12*D1*Dd*f*fd*s - 9*D1*Dd*f*fd + 16*D1*Dd*f*r**2 + 36*D1*Dd*f*r*s - 26*D1*Dd*f*r - 9*D1*Dd*f*s + 4*D1*Dd*f - 16*D1*Dd*fd*r**2 - 8*D1*Dd*fd*r*s + 6*D1*Dd*fd*r + D1*Dd*fd*s - 16*D1*Ddd*K*f*r**2 + 8*D1*Ddd*K*f*r - 4*D1*Ddd*K*f - 24*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r + 6*D1*Ddd*f**2*s - 8*D1*Ddd*f*r**2 - 4*D1*Ddd*f*r*s + 6*D1*Ddd*f*r + D1*Ddd*f*s - 2*D1*Ddd*f + D1*bd1*(D1*f*(3*r**2 - 2*r + 1) + 8*D1*fd*r*(1 - 3*r) - 8*Dd*f*(12*r**2 - 7*r + 1)) - 48*Dd**2*K*f*r**2 + 24*Dd**2*K*f*r - 72*Dd**2*f**2*r*s + 36*Dd**2*f**2*r + 18*Dd**2*f**2*s - 12*Dd**2*f**2 - 24*Dd**2*f*r**2 - 12*Dd**2*f*r*s + 18*Dd**2*f*r + 3*Dd**2*f*s - 2*Dd**2*f) + b1*(-22*D1**2*K*f*fd*r**2 + 22*D1**2*K*f*fd*r - 11*D1**2*K*f*fd - 11*D1**2*b2*fd*r**2 + 44*D1**2*b2*fdd*r**2 + 88*D1**2*bd1**2*f*r*(3*r - 2) - 11*D1**2*bd2*f*r**2 + 88*D1**2*bd2*fd*r**2 + 11*D1**2*bdd1*f*(K*(8*r**2 - 8*r + 4) - 6*f*s + 4*r**2 + r*(12*f*s - 3*f + 2*s - 5) - s + 2) + 44*D1**2*bdd2*f*r**2 - 117*D1**2*f**2*fd*r**2 - 198*D1**2*f**2*fd*r*s + 177*D1**2*f**2*fd*r + 66*D1**2*f**2*fd*s - 39*D1**2*f**2*fd + 108*D1**2*f**2*fdd*r**2 + 198*D1**2*f**2*fdd*r*s - 171*D1**2*f**2*fdd*r - 66*D1**2*f**2*fdd*s + 36*D1**2*f**2*fdd + 216*D1**2*f*fd**2*r**2 + 396*D1**2*f*fd**2*r*s - 342*D1**2*f*fd**2*r - 132*D1**2*f*fd**2*s + 99*D1**2*f*fd**2 - 88*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r*s + 88*D1**2*f*fd*r + 11*D1**2*f*fd*s - 44*D1**2*f*fd + 44*D1**2*f*fdd*r**2 + 22*D1**2*f*fdd*r*s - 44*D1**2*f*fdd*r - 11*D1**2*f*fdd*s + 22*D1**2*f*fdd + 22*D1**2*f*gd2*r**2 - 88*D1**2*f*gdd2*r**2 + 44*D1**2*fd**2*r**2 + 22*D1**2*fd**2*r*s - 44*D1**2*fd**2*r - 11*D1**2*fd**2*s + 22*D1**2*fd*g2*r**2 - 176*D1**2*fd*gd2*r**2 - 88*D1**2*fdd*g2*r**2 - 44*D1*Dd*K*f**2*r**2 + 22*D1*Dd*K*f**2*r - 11*D1*Dd*K*f**2 - 44*D1*Dd*b2*f*r**2 + 22*D1*Dd*b2*f*r - 11*D1*Dd*b2*f + 352*D1*Dd*b2*fd*r**2 - 88*D1*Dd*b2*fd*r + 352*D1*Dd*bd2*f*r**2 - 88*D1*Dd*bd2*f*r - 156*D1*Dd*f**3*r**2 - 264*D1*Dd*f**3*r*s + 210*D1*Dd*f**3*r + 66*D1*Dd*f**3*s - 39*D1*Dd*f**3 + 864*D1*Dd*f**2*fd*r**2 + 1584*D1*Dd*f**2*fd*r*s - 1296*D1*Dd*f**2*fd*r - 462*D1*Dd*f**2*fd*s + 303*D1*Dd*f**2*fd - 176*D1*Dd*f**2*r**2 - 44*D1*Dd*f**2*r*s + 110*D1*Dd*f**2*r + 11*D1*Dd*f**2*s - 44*D1*Dd*f**2 + 352*D1*Dd*f*fd*r**2 + 176*D1*Dd*f*fd*r*s - 308*D1*Dd*f*fd*r - 66*D1*Dd*f*fd*s + 66*D1*Dd*f*fd + 88*D1*Dd*f*g2*r**2 - 44*D1*Dd*f*g2*r + 22*D1*Dd*f*g2 - 704*D1*Dd*f*gd2*r**2 + 176*D1*Dd*f*gd2*r - 704*D1*Dd*fd*g2*r**2 + 176*D1*Dd*fd*g2*r + 176*D1*Ddd*b2*f*r**2 - 88*D1*Ddd*b2*f*r + 44*D1*Ddd*b2*f + 144*D1*Ddd*f**3*r**2 + 264*D1*Ddd*f**3*r*s - 204*D1*Ddd*f**3*r - 66*D1*Ddd*f**3*s + 36*D1*Ddd*f**3 + 88*D1*Ddd*f**2*r**2 + 44*D1*Ddd*f**2*r*s - 66*D1*Ddd*f**2*r - 11*D1*Ddd*f**2*s + 22*D1*Ddd*f**2 - 352*D1*Ddd*f*g2*r**2 + 176*D1*Ddd*f*g2*r - 88*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(f**2*(4*r**2 - 3*r*(4*s + 1) + 6*s + 3) + f*(K*(-2*r**2 + 2*r - 1) + 3*fd*(8*r*(2*s - 1) - 4*s + 3) - 8*r**2 - 18*r*s + 17*r + 9*s - 4) + fd*(r**2*(16*K + 8) + r*(-8*K + 4*s - 5) - s)) + Dd*f*(8*K*(8*r**2 - 6*r + 1) + 3*f*(4*r*(8*s - 3) - 12*s + 5) + 32*r**2 + 16*r*s - 32*r - 6*s + 7)) + 528*Dd**2*b2*f*r**2 - 264*Dd**2*b2*f*r + 432*Dd**2*f**3*r**2 + 792*Dd**2*f**3*r*s - 612*Dd**2*f**3*r - 198*Dd**2*f**3*s + 132*Dd**2*f**3 + 264*Dd**2*f**2*r**2 + 132*Dd**2*f**2*r*s - 198*Dd**2*f**2*r - 33*Dd**2*f**2*s + 22*Dd**2*f**2 - 1056*Dd**2*f*g2*r**2 + 528*Dd**2*f*g2*r))/(231*d**2*k1*k3**2) + D1**2*Pk3*Pkd1*st**2*(-D1*f*(D1*bd1**2*(r**2*(8 - 16*C) + 2*r*(8*C - s - 4) + s) - D1*bdd1*f*r*s + bd1*(D1*(f*r*(2*C*r - r + s) + fd*(-4*r*s + r + s)) + Dd*f*(r*(2 - 8*s) + s))) + b1**2*(D1**2*r*(fd*(-2*C*r + r - 9*s + 9) + fdd*(8*C*r - 4*r + s - 1)) + D1*(Dd*(f*(C*(-8*r**2 + 4*r - 2) + 4*r**2 - 36*r*s + 16*r + 9*s + 1) + fd*(r**2*(64*C - 32) + r*(-16*C + 8*s + 2) - s + 1)) + Ddd*f*(8*C*(4*r**2 - 2*r + 1) - 16*r**2 + 4*r*s + 6*r - s - 4)) + Dd**2*f*(r**2*(96*C - 48) - 6*r*(8*C - 2*s - 3) - 3*s + 2)) + b1*(-4*C*D1**2*f*fd*r**2 + 4*C*D1**2*f*fd*r - 2*C*D1**2*f*fd - 8*C*D1*Dd*f**2*r**2 + 4*C*D1*Dd*f**2*r - 2*C*D1*Dd*f**2 + D1**2*bdd1*f*(8*C*(2*r**2 - 2*r + 1) - 8*r**2 + 2*r*(s + 4) - s - 4) + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r*s - D1**2*f*fd*r + D1**2*f*fd*s + D1**2*f*fd + 2*D1**2*f*fdd*r*s - D1**2*f*fdd*r - D1**2*f*fdd*s + 2*D1**2*fd**2*r*s - D1**2*fd**2*r - D1**2*fd**2*s + D1**2*fd**2 + 4*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*s + D1*Dd*f**2 + 16*D1*Dd*f*fd*r*s - 8*D1*Dd*f*fd*r - 6*D1*Dd*f*fd*s + 3*D1*Dd*f*fd + 4*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r - D1*Ddd*f**2*s + D1*bd1*(D1*(f*(C*(-4*r**2 + 4*r - 2) + 2*r**2 - 2*r*(9*s + 1) + 9*s + 1) + fd*(r**2*(32*C - 16) + r*(-16*C + 4*s + 6) - s + 1)) + 2*Dd*f*(8*C*(8*r**2 - 6*r + 1) - 32*r**2 + r*(8*s + 22) - 3*s - 3)) + 12*Dd**2*f**2*r*s - 6*Dd**2*f**2*r - 3*Dd**2*f**2*s + 2*Dd**2*f**2))/(21*d**2*k1) - D1**2*Pk3*Pkd1*(D1*r*(-2*D1*bd1**2*(6*f**2*(2*s - 1) + f*(-5*K*r + 12*s - 6) - 14*g2*(r - 1)) - 10*D1*bdd1*f*g2*r + b2*(-14*D1*bd1**2*(r - 1) + 5*D1*bdd1*f*r + 2*bd1*(2*D1*f*r + 5*D1*fd*(r - 1) + 5*Dd*f*(4*r - 1))) - 2*bd1*(D1*f*r*(-5*bd2 + 4*g2 + 10*gd2) + 10*D1*fd*g2*(r - 1) + 10*Dd*f*g2*(4*r - 1))) - 7*b1**3*(2*D1*Dd*(K*(-4*r**2 + 2*r - 1) + fd*r*(8*s - 6) - fd*s + fd - (f + 2)*(r*(4*s - 2) - s)) + D1*(-2*D1*r*(fd - fdd)*(s - 1) + Ddd*K*(4*r**2 - 2*r + 1) + 2*Ddd*(f + 1)*(r*(4*s - 2) - s)) + 2*Dd**2*(6*K*r**2 + f*(6*r*(2*s - 1) - 3*s + 2) - 3*r*(K - 4*s + 2) - 3*s + 2)) + b1**2*(-21*D1**2*K*bdd1*r**2 + 14*D1**2*K*bdd1*r - 7*D1**2*K*bdd1 + 4*D1**2*K*fd*r**2 - 8*D1**2*K*fd*r + 4*D1**2*K*fd + 5*D1**2*K*fdd*r**2 - 10*D1**2*K*fdd*r + 5*D1**2*K*fdd + 14*D1**2*bd2*r**2 - 42*D1**2*bdd1*f*r*s + 14*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s - 42*D1**2*bdd1*r*s + 14*D1**2*bdd1*r + 14*D1**2*bdd1*s - 7*D1**2*bdd2*r**2 + 24*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 12*D1**2*f*fd*s - 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r + 12*D1**2*f*fdd*s - 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r + 12*D1**2*fd**2*s - 12*D1**2*fd**2 + 10*D1**2*fd*r*s - 10*D1**2*fd*s - 12*D1**2*fdd*r*s + 12*D1**2*fdd*s - 28*D1**2*gd2*r**2 + 14*D1**2*gdd2*r**2 + 16*D1*Dd*K*f*r**2 - 8*D1*Dd*K*f*r + 4*D1*Dd*K*f + 40*D1*Dd*K*fd*r**2 - 50*D1*Dd*K*fd*r + 10*D1*Dd*K*fd - 56*D1*Dd*bd2*r**2 + 14*D1*Dd*bd2*r + 48*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r - 12*D1*Dd*f**2*s - 192*D1*Dd*f*fd*r*s + 96*D1*Dd*f*fd*r + 72*D1*Dd*f*fd*s - 36*D1*Dd*f*fd + 40*D1*Dd*f*r*s - 20*D1*Dd*f*r - 10*D1*Dd*f*s - 96*D1*Dd*fd*r*s + 24*D1*Dd*fd*r + 60*D1*Dd*fd*s - 24*D1*Dd*fd - 112*D1*Dd*g2*r**2 + 56*D1*Dd*g2*r - 28*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 - 28*D1*Dd*gd2*r + 20*D1*Ddd*K*f*r**2 - 10*D1*Ddd*K*f*r + 5*D1*Ddd*K*f - 48*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s - 48*D1*Ddd*f*r*s + 24*D1*Ddd*f*r + 12*D1*Ddd*f*s + 56*D1*Ddd*g2*r**2 - 28*D1*Ddd*g2*r + 14*D1*Ddd*g2 + 14*D1*bd1*(D1*(K*(3*r**2 - 2*r + 1) + fd*(r*(4 - 6*s) + s - 1) + (f + 2)*(3*r*s - r - s)) - Dd*(12*K*r**2 - 7*K*r + K + f*(2*r*(12*s - 5) - 7*s + 3) + 24*r*s - 10*r - 7*s + 3)) + 60*Dd**2*K*f*r**2 - 30*Dd**2*K*f*r - 144*Dd**2*f**2*r*s + 72*Dd**2*f**2*r + 36*Dd**2*f**2*s - 24*Dd**2*f**2 - 144*Dd**2*f*r*s + 72*Dd**2*f*r + 36*Dd**2*f*s - 24*Dd**2*f + 168*Dd**2*g2*r**2 - 84*Dd**2*g2*r + 7*b2*(D1*(2*Dd - Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(1 - 2*r))) + b1*(10*D1**2*K*bdd1*f*r**2 - 14*D1**2*bd1**2*(3*K*r**2 + f*r*(6*s - 2) - 2*f*s + f - 2*r*(K - 3*s + 1) - 2*s + 1) + 4*D1**2*bd2*f*r**2 + 10*D1**2*bd2*fd*r**2 - 10*D1**2*bd2*fd*r - 24*D1**2*bdd1*f**2*r*s + 12*D1**2*bdd1*f**2*r - 24*D1**2*bdd1*f*r*s + 12*D1**2*bdd1*f*r + 28*D1**2*bdd1*g2*r**2 - 28*D1**2*bdd1*g2*r + 14*D1**2*bdd1*g2 + 5*D1**2*bdd2*f*r**2 - 8*D1**2*f*gd2*r**2 - 10*D1**2*f*gdd2*r**2 - 8*D1**2*fd*g2*r**2 + 16*D1**2*fd*g2*r - 8*D1**2*fd*g2 - 20*D1**2*fd*gd2*r**2 + 20*D1**2*fd*gd2*r - 10*D1**2*fdd*g2*r**2 + 20*D1**2*fdd*g2*r - 10*D1**2*fdd*g2 + 40*D1*Dd*bd2*f*r**2 - 10*D1*Dd*bd2*f*r - 32*D1*Dd*f*g2*r**2 + 16*D1*Dd*f*g2*r - 8*D1*Dd*f*g2 - 80*D1*Dd*f*gd2*r**2 + 20*D1*Dd*f*gd2*r - 80*D1*Dd*fd*g2*r**2 + 100*D1*Dd*fd*g2*r - 20*D1*Dd*fd*g2 - 40*D1*Ddd*f*g2*r**2 + 20*D1*Ddd*f*g2*r - 10*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(-2*fd*(-5*K*r**2 + 3*f*(4*r - 1)*(2*s - 1) + r*(5*K + 12*s - 3) - 6*s + 3) - 14*g2*(2*r**2 - 2*r + 1) + r*(bd2*(7 - 14*r) + 6*f**2*(2*s - 1) + f*(4*K*r + 10*s - 5) + 14*gd2*(2*r - 1))) - 2*Dd*(3*f**2*(8*r - 1)*(2*s - 1) + f*(-20*K*r**2 + r*(5*K + 48*s - 24) - 6*s + 3) - 7*g2*(8*r**2 - 6*r + 1))) - 120*Dd**2*f*g2*r**2 + 60*Dd**2*f*g2*r + b2*(-7*D1**2*bdd1*(2*r**2 - 2*r + 1) + 4*D1**2*fd*r**2 - 8*D1**2*fd*r + 4*D1**2*fd + 5*D1**2*fdd*r**2 - 10*D1**2*fdd*r + 5*D1**2*fdd + 16*D1*Dd*f*r**2 - 8*D1*Dd*f*r + 4*D1*Dd*f + 40*D1*Dd*fd*r**2 - 50*D1*Dd*fd*r + 10*D1*Dd*fd + 20*D1*Ddd*f*r**2 - 10*D1*Ddd*f*r + 5*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 - 2*r + 1) + Dd*(-8*r**2 + 6*r - 1)) + 60*Dd**2*f*r**2 - 30*Dd**2*f*r)))/(21*d**2*k1) - D1**2*Pk3*Pkdd1*ct**6*k2**4*(2*C - 2)*(264*D1**2*b1*f*fd*r**2 - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 165*D1**2*bdd1*f**2*(r - 1)**2 + 345*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 + 660*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 + 1960*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 + 330*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r - 140*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) - 1980*Dd**2*b1*f**2*r**2 + 990*Dd**2*b1*f**2*r - 1680*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r)/(693*d**2*k3**4) - 5*D1**2*Pk3*Pkdd1*ct**5*f*k2**5*(897*D1**2*b1*f*fd*r**2 - 1092*D1**2*b1*f*fdd*r**2 - 2184*D1**2*b1*fd**2*r**2 - 364*D1**2*bdd1*f**2*(r - 1)**2 + 1064*D1**2*f**2*fd*r**2 - 532*D1**2*f**2*fd*r + 266*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r**2 + 630*D1**2*f**2*fdd*r - 315*D1**2*f**2*fdd - 3780*D1**2*f*fd**2*r**2 + 1890*D1**2*f*fd**2*r + 1196*D1*Dd*b1*f**2*r**2 - 598*D1*Dd*b1*f**2*r + 299*D1*Dd*b1*f**2 - 8736*D1*Dd*b1*f*fd*r**2 + 2184*D1*Dd*b1*f*fd*r + 1064*D1*Dd*f**3*r**2 - 532*D1*Dd*f**3*r + 266*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r**2 + 5040*D1*Dd*f**2*fd*r - 630*D1*Dd*f**2*fd - 1456*D1*Ddd*b1*f**2*r**2 + 728*D1*Ddd*b1*f**2*r - 364*D1*Ddd*b1*f**2 - 1260*D1*Ddd*f**3*r**2 + 630*D1*Ddd*f**3*r - 315*D1*Ddd*f**3 + 13*D1*bd1*f*(r - 1)*(23*D1*f*(r - 1) - 168*D1*fd*r + 56*Dd*f*(1 - 4*r)) - 4368*Dd**2*b1*f**2*r**2 + 2184*Dd**2*b1*f**2*r - 3780*Dd**2*f**3*r**2 + 1890*Dd**2*f**3*r)/(9009*d**2*k1*k3**4) - D1**2*Pk3*Pkdd1*ct**5*k1*k2**3*(8*C - 7)*(264*D1**2*b1*f*fd*r**2 - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 165*D1**2*bdd1*f**2*(r - 1)**2 + 345*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 + 660*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 + 1960*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 + 330*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r - 140*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) - 1980*Dd**2*b1*f**2*r**2 + 990*Dd**2*b1*f**2*r - 1680*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r)/(693*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**5*k2**3*(-264*D1**2*b1*f*fd*r**2 + 330*D1**2*b1*f*fdd*r**2 + 330*D1**2*b1*fd**2*r**2 + 165*D1**2*bdd1*f**2*(r - 1)**2 - 345*D1**2*f**2*fd*r**2 + 230*D1**2*f**2*fd*r - 115*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 - 280*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 - 560*D1**2*f*fd**2*r - 528*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2 + 2640*D1*Dd*b1*f*fd*r**2 - 660*D1*Dd*b1*f*fd*r - 460*D1*Dd*f**3*r**2 + 230*D1*Dd*f**3*r - 115*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 - 1960*D1*Dd*f**2*fd*r + 280*D1*Dd*f**2*fd + 660*D1*Ddd*b1*f**2*r**2 - 330*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2 + 560*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r + 140*D1*Ddd*f**3 - 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) + 1980*Dd**2*b1*f**2*r**2 - 990*Dd**2*b1*f**2*r + 1680*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r)/(693*d**2*k1*k3**2) - D1**2*Pk3*Pkdd1*ct**4*k1**2*k2**2*(4*C - 3)*(264*D1**2*b1*f*fd*r**2 - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 165*D1**2*bdd1*f**2*(r - 1)**2 + 345*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 + 660*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 + 1960*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 + 330*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r - 140*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) - 1980*Dd**2*b1*f**2*r**2 + 990*Dd**2*b1*f**2*r - 1680*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r)/(231*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct**4*k2**4*st**2*(2*C - 2)*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(231*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**4*k2**4*(2145*D1**2*K*bdd1*f**2*r**2 - 858*D1**2*bd1**2*f*r*(r - 1)*(-6*K + 5*f + 6) + 3640*D1**2*bdd1*f**3*r**2 - 10920*D1**2*bdd1*f**3*r + 5460*D1**2*bdd1*f**3 - 2145*D1**2*bdd1*f**2*r**2 - 5148*D1**2*bdd1*f*g2*r**2 + 10296*D1**2*bdd1*f*g2*r - 5148*D1**2*bdd1*f*g2 - 15960*D1**2*f**3*fd*r**2 + 7980*D1**2*f**3*fd*r - 3990*D1**2*f**3*fd + 18900*D1**2*f**3*fdd*r**2 - 9450*D1**2*f**3*fdd*r + 4725*D1**2*f**3*fdd + 56700*D1**2*f**2*fd**2*r**2 - 28350*D1**2*f**2*fd**2*r + 3432*D1**2*f**2*gd2*r**2 - 4290*D1**2*f**2*gdd2*r**2 + 6864*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r + 3432*D1**2*f*fd*g2 - 17160*D1**2*f*fd*gd2*r**2 + 8580*D1**2*f*fd*gd2*r - 8580*D1**2*f*fdd*g2*r**2 + 8580*D1**2*f*fdd*g2*r - 4290*D1**2*f*fdd*g2 - 8580*D1**2*fd**2*g2*r**2 + 8580*D1**2*fd**2*g2*r - 15960*D1*Dd*f**4*r**2 + 7980*D1*Dd*f**4*r - 3990*D1*Dd*f**4 + 151200*D1*Dd*f**3*fd*r**2 - 75600*D1*Dd*f**3*fd*r + 9450*D1*Dd*f**3*fd + 13728*D1*Dd*f**2*g2*r**2 - 6864*D1*Dd*f**2*g2*r + 3432*D1*Dd*f**2*g2 - 34320*D1*Dd*f**2*gd2*r**2 + 8580*D1*Dd*f**2*gd2*r - 68640*D1*Dd*f*fd*g2*r**2 + 51480*D1*Dd*f*fd*g2*r - 8580*D1*Dd*f*fd*g2 + 18900*D1*Ddd*f**4*r**2 - 9450*D1*Ddd*f**4*r + 4725*D1*Ddd*f**4 - 17160*D1*Ddd*f**2*g2*r**2 + 8580*D1*Ddd*f**2*g2*r - 4290*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(115*f**3*(2*r**2 - 6*r + 3) - 4*f**2*r*(140*fd*(3*r - 4) + r*(33 - 33*K)) - 66*f*(5*fd*r*(K - 1)*(2*r - 1) + 5*g2*(r - 1)**2 - 12*gd2*r*(r - 1)) + 792*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(140*f**2*(2*r - 3) + 165*f*r*(K - 1) - 396*g2*(r - 1))) + 56700*Dd**2*f**4*r**2 - 28350*Dd**2*f**4*r - 51480*Dd**2*f**2*g2*r**2 + 25740*Dd**2*f**2*g2*r + 429*b1**2*(D1**2*r**2*(-10*fd**2 + fd*(-5*K + 8*f + 5) - 2*fdd*(-3*K + 5*f + 3)) + D1*(Dd*(4*f**2*(4*r**2 - 2*r + 1) - 5*f*(K*(4*r**2 - 2*r + 1) + r**2*(16*fd - 4) + r*(2 - 4*fd) - 1) + 12*fd*r*(K - 1)*(4*r - 1)) - Ddd*f*(-6*K + 5*f + 6)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(2*r - 1)*(-6*K + 5*f + 6)) + 13*b1*(-264*D1**2*K*f*fd*r**2 + 264*D1**2*K*f*fd*r - 132*D1**2*K*f*fd + 330*D1**2*K*f*fdd*r**2 - 330*D1**2*K*f*fdd*r + 165*D1**2*K*f*fdd + 330*D1**2*K*fd**2*r**2 - 330*D1**2*K*fd**2*r - 33*D1**2*bdd1*f*(-6*K + 5*f + 6)*(2*r**2 - 2*r + 1) - 690*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 264*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 + 330*D1**2*f*fdd*r - 165*D1**2*f*fdd + 330*D1**2*f*gd2*r**2 - 396*D1**2*f*gdd2*r**2 - 330*D1**2*fd**2*r**2 + 330*D1**2*fd**2*r + 330*D1**2*fd*g2*r**2 - 792*D1**2*fd*gd2*r**2 - 396*D1**2*fdd*g2*r**2 - 528*D1*Dd*K*f**2*r**2 + 264*D1*Dd*K*f**2*r - 132*D1*Dd*K*f**2 + 2640*D1*Dd*K*f*fd*r**2 - 1980*D1*Dd*K*f*fd*r + 330*D1*Dd*K*f*fd - 920*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r - 230*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 - 560*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 + 1980*D1*Dd*f*fd*r - 330*D1*Dd*f*fd + 1320*D1*Dd*f*g2*r**2 - 660*D1*Dd*f*g2*r + 330*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 + 792*D1*Dd*f*gd2*r - 3168*D1*Dd*fd*g2*r**2 + 792*D1*Dd*fd*g2*r + 660*D1*Ddd*K*f**2*r**2 - 330*D1*Ddd*K*f**2*r + 165*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r + 280*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 + 330*D1*Ddd*f**2*r - 165*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 + 792*D1*Ddd*f*g2*r - 396*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(f**2*(8*r**2 - 8*r + 4) - 5*f*(K*(2*r**2 - 2*r + 1) + r**2*(8*fd - 2) + r*(2 - 4*fd) - 1) + 12*fd*r*(K - 1)*(2*r - 1)) - 2*Dd*f*(-6*K + 5*f + 6)*(8*r**2 - 6*r + 1)) + 1980*Dd**2*K*f**2*r**2 - 990*Dd**2*K*f**2*r + 3360*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r - 1980*Dd**2*f**2*r**2 + 990*Dd**2*f**2*r - 4752*Dd**2*f*g2*r**2 + 2376*Dd**2*f*g2*r))/(9009*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**4*k2**2*(-66*b1**2*(C - 1)*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) - 33*b1*(-16*C*D1**2*f*fd*r + 8*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r - 10*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r + 80*C*D1*Dd*f*fd*r - 20*C*D1*Dd*f*fd - 12*D1**2*bdd1*f*(C - 1)*(2*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r - 8*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r + 10*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 60*D1*Dd*f*fd*r + 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + 2*D1*bd1*(C - 1)*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r) + f*(792*D1**2*bd1**2*r*(C - 1)*(r - 1) + 165*D1**2*bdd1*f*(C*(4*r - 2) + r**2 - 6*r + 3) - 66*D1*bd1*(2*D1*(f*(4*C*r - 2*C + r**2 - 6*r + 3) - 5*fd*r*(C + r - 2)) - 5*Dd*f*(4*r - 1)*(2*C + r - 3)) + 5*(2*C - 3)*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 - 2*r + 1) + 56*fd**2*r*(2 - 3*r)) + D1*f*(23*Dd*f*(4*r**2 - 2*r + 1) - 56*Dd*fd*(12*r**2 - 7*r + 1) - 28*Ddd*f*(4*r**2 - 2*r + 1)) + 168*Dd**2*f**2*r*(1 - 2*r))))/(693*d**2*k3**2) - 5*D1**2*Pk3*Pkdd1*ct**3*f*k2**5*st**2*(663*D1**2*b1*f*fd*r**2 - 975*D1**2*b1*f*fdd*r**2 - 1950*D1**2*b1*fd**2*r**2 - 325*D1**2*bdd1*f**2*(r - 1)**2 + 660*D1**2*f**2*fd*r**2 - 330*D1**2*f**2*fd*r + 165*D1**2*f**2*fd - 980*D1**2*f**2*fdd*r**2 + 490*D1**2*f**2*fdd*r - 245*D1**2*f**2*fdd - 2940*D1**2*f*fd**2*r**2 + 1470*D1**2*f*fd**2*r + 884*D1*Dd*b1*f**2*r**2 - 442*D1*Dd*b1*f**2*r + 221*D1*Dd*b1*f**2 - 7800*D1*Dd*b1*f*fd*r**2 + 1950*D1*Dd*b1*f*fd*r + 660*D1*Dd*f**3*r**2 - 330*D1*Dd*f**3*r + 165*D1*Dd*f**3 - 7840*D1*Dd*f**2*fd*r**2 + 3920*D1*Dd*f**2*fd*r - 490*D1*Dd*f**2*fd - 1300*D1*Ddd*b1*f**2*r**2 + 650*D1*Ddd*b1*f**2*r - 325*D1*Ddd*b1*f**2 - 980*D1*Ddd*f**3*r**2 + 490*D1*Ddd*f**3*r - 245*D1*Ddd*f**3 + 13*D1*bd1*f*(r - 1)*(17*D1*f*(r - 1) - 150*D1*fd*r + 50*Dd*f*(1 - 4*r)) - 3900*Dd**2*b1*f**2*r**2 + 1950*Dd**2*b1*f**2*r - 2940*Dd**2*f**3*r**2 + 1470*Dd**2*f**3*r)/(9009*d**2*k1*k3**4) - D1**2*Pk3*Pkdd1*ct**3*k1**3*k2*(8*C - 5)*(264*D1**2*b1*f*fd*r**2 - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 165*D1**2*bdd1*f**2*(r - 1)**2 + 345*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 + 660*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 + 1960*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 + 330*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r - 140*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) - 1980*Dd**2*b1*f**2*r**2 + 990*Dd**2*b1*f**2*r - 1680*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r)/(693*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct**3*k1*k2**3*st**2*(6*C - 5)*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(231*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**3*k1*k2**3*(2860*D1**2*K*bdd1*f**2*r**2 - 858*D1**2*bd1**2*f*r*(r - 1)*(-8*K + 5*f + 6) - 3640*D1**2*bdd1*f**3*r + 1820*D1**2*bdd1*f**3 - 2145*D1**2*bdd1*f**2*r**2 - 6864*D1**2*bdd1*f*g2*r**2 + 13728*D1**2*bdd1*f*g2*r - 6864*D1**2*bdd1*f*g2 - 5320*D1**2*f**3*fd*r**2 + 2660*D1**2*f**3*fd*r - 1330*D1**2*f**3*fd + 6300*D1**2*f**3*fdd*r**2 - 3150*D1**2*f**3*fdd*r + 1575*D1**2*f**3*fdd + 18900*D1**2*f**2*fd**2*r**2 - 9450*D1**2*f**2*fd**2*r + 4576*D1**2*f**2*gd2*r**2 - 5720*D1**2*f**2*gdd2*r**2 + 9152*D1**2*f*fd*g2*r**2 - 9152*D1**2*f*fd*g2*r + 4576*D1**2*f*fd*g2 - 22880*D1**2*f*fd*gd2*r**2 + 11440*D1**2*f*fd*gd2*r - 11440*D1**2*f*fdd*g2*r**2 + 11440*D1**2*f*fdd*g2*r - 5720*D1**2*f*fdd*g2 - 11440*D1**2*fd**2*g2*r**2 + 11440*D1**2*fd**2*g2*r - 5320*D1*Dd*f**4*r**2 + 2660*D1*Dd*f**4*r - 1330*D1*Dd*f**4 + 50400*D1*Dd*f**3*fd*r**2 - 25200*D1*Dd*f**3*fd*r + 3150*D1*Dd*f**3*fd + 18304*D1*Dd*f**2*g2*r**2 - 9152*D1*Dd*f**2*g2*r + 4576*D1*Dd*f**2*g2 - 45760*D1*Dd*f**2*gd2*r**2 + 11440*D1*Dd*f**2*gd2*r - 91520*D1*Dd*f*fd*g2*r**2 + 68640*D1*Dd*f*fd*g2*r - 11440*D1*Dd*f*fd*g2 + 6300*D1*Ddd*f**4*r**2 - 3150*D1*Ddd*f**4*r + 1575*D1*Ddd*f**4 - 22880*D1*Ddd*f**2*g2*r**2 + 11440*D1*Ddd*f**2*g2*r - 5720*D1*Ddd*f**2*g2 + 13*D1*bd1*(D1*(115*f**3*(2*r - 1) - 4*f**2*r*(140*fd + r*(44*K - 33)) + 22*f*(5*fd*r*(4*K - 3)*(2*r - 1) + 20*g2*(r - 1)**2 - 48*gd2*r*(r - 1)) - 1056*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(140*f**2 - 55*f*r*(4*K - 3) + 528*g2*(r - 1))) + 18900*Dd**2*f**4*r**2 - 9450*Dd**2*f**4*r - 68640*Dd**2*f**2*g2*r**2 + 34320*Dd**2*f**2*g2*r + 143*b1**2*(D1**2*r**2*(-30*fd**2 + fd*(-20*K + 24*f + 15) - 6*fdd*(-4*K + 5*f + 3)) + D1*(Dd*(12*f**2*(4*r**2 - 2*r + 1) - 5*f*(4*K*(4*r**2 - 2*r + 1) + r**2*(48*fd - 12) + r*(6 - 12*fd) - 3) + 12*fd*r*(4*K - 3)*(4*r - 1)) - 3*Ddd*f*(-8*K + 5*f + 6)*(4*r**2 - 2*r + 1)) - 18*Dd**2*f*r*(2*r - 1)*(-8*K + 5*f + 6)) + 13*b1*(-352*D1**2*K*f*fd*r**2 + 352*D1**2*K*f*fd*r - 176*D1**2*K*f*fd + 440*D1**2*K*f*fdd*r**2 - 440*D1**2*K*f*fdd*r + 220*D1**2*K*f*fdd + 440*D1**2*K*fd**2*r**2 - 440*D1**2*K*fd**2*r - 33*D1**2*bdd1*f*(-8*K + 5*f + 6)*(2*r**2 - 2*r + 1) - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd + 560*D1**2*f*fd**2*r + 264*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 + 330*D1**2*f*fdd*r - 165*D1**2*f*fdd + 440*D1**2*f*gd2*r**2 - 528*D1**2*f*gdd2*r**2 - 330*D1**2*fd**2*r**2 + 330*D1**2*fd**2*r + 440*D1**2*fd*g2*r**2 - 1056*D1**2*fd*gd2*r**2 - 528*D1**2*fdd*g2*r**2 - 704*D1*Dd*K*f**2*r**2 + 352*D1*Dd*K*f**2*r - 176*D1*Dd*K*f**2 + 3520*D1*Dd*K*f*fd*r**2 - 2640*D1*Dd*K*f*fd*r + 440*D1*Dd*K*f*fd + 1120*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 + 1980*D1*Dd*f*fd*r - 330*D1*Dd*f*fd + 1760*D1*Dd*f*g2*r**2 - 880*D1*Dd*f*g2*r + 440*D1*Dd*f*g2 - 4224*D1*Dd*f*gd2*r**2 + 1056*D1*Dd*f*gd2*r - 4224*D1*Dd*fd*g2*r**2 + 1056*D1*Dd*fd*g2*r + 880*D1*Ddd*K*f**2*r**2 - 440*D1*Ddd*K*f**2*r + 220*D1*Ddd*K*f**2 - 660*D1*Ddd*f**2*r**2 + 330*D1*Ddd*f**2*r - 165*D1*Ddd*f**2 - 2112*D1*Ddd*f*g2*r**2 + 1056*D1*Ddd*f*g2*r - 528*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(12*f**2*(2*r**2 - 2*r + 1) - 5*f*(K*(8*r**2 - 8*r + 4) + r**2*(24*fd - 6) + r*(6 - 12*fd) - 3) + 12*fd*r*(4*K - 3)*(2*r - 1)) - 6*Dd*f*(-8*K + 5*f + 6)*(8*r**2 - 6*r + 1)) + 2640*Dd**2*K*f**2*r**2 - 1320*Dd**2*K*f**2*r - 1980*Dd**2*f**2*r**2 + 990*Dd**2*f**2*r - 6336*Dd**2*f*g2*r**2 + 3168*Dd**2*f*g2*r))/(3003*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct**3*k1*k2*(4*C - 3)*(33*D1*b1*(-6*D1*bdd1*f*(2*r**2 - 2*r + 1) - 8*D1*f*fd*r + 4*D1*f*fd + 10*D1*f*fdd*r - 5*D1*f*fdd + 10*D1*fd**2*r + 40*Dd*f*fd*r - 10*Dd*f*fd + bd1*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1))) + 33*b1**2*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + f*(-396*D1**2*bd1**2*r*(r - 1) - 165*D1**2*bdd1*f*(2*r - 1) - 5*D1**2*(f*(23*fd - 28*fdd)*(3*r**2 - 2*r + 1) + 56*fd**2*r*(2 - 3*r)) + 66*D1*bd1*(D1*f*(4*r - 2) - 5*D1*fd*r + 5*Dd*f*(1 - 4*r)) - 5*D1*f*(23*Dd*f*(4*r**2 - 2*r + 1) - 56*Dd*fd*(12*r**2 - 7*r + 1) - 28*Ddd*f*(4*r**2 - 2*r + 1)) - 840*Dd**2*f**2*r*(1 - 2*r)))/(693*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct**3*k2**3*st**2*(-66*D1**2*b1*f*fd*r**2 + 66*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*fd**2*r**2 + 33*D1**2*bdd1*f**2*(r - 1)**2 - 51*D1**2*f**2*fd*r**2 + 34*D1**2*f**2*fd*r - 17*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 - 50*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 - 100*D1**2*f*fd**2*r - 132*D1*Dd*b1*f**2*r**2 + 66*D1*Dd*b1*f**2*r - 33*D1*Dd*b1*f**2 + 528*D1*Dd*b1*f*fd*r**2 - 132*D1*Dd*b1*f*fd*r - 68*D1*Dd*f**3*r**2 + 34*D1*Dd*f**3*r - 17*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 - 350*D1*Dd*f**2*fd*r + 50*D1*Dd*f**2*fd + 132*D1*Ddd*b1*f**2*r**2 - 66*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2 + 100*D1*Ddd*f**3*r**2 - 50*D1*Ddd*f**3*r + 25*D1*Ddd*f**3 - 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) + 396*Dd**2*b1*f**2*r**2 - 198*Dd**2*b1*f**2*r + 300*Dd**2*f**3*r**2 - 150*Dd**2*f**3*r)/(231*d**2*k1*k3**2) + D1**2*Pk3*Pkdd1*ct**3*k2**3*(D1*f*r*(132*D1*bd1**2*(5*f + 3)*(r - 1) + 5*D1*bdd1*f*r*(56*f + 33) + 2*bd1*(-D1*f*r*(115*f + 66) + 5*D1*fd*(56*f*(3*r - 1) + 66*r - 33) + 5*Dd*f*(56*f + 33)*(4*r - 1))) - 33*b1**2*(D1**2*r**2*(-20*fd**2 + fd*(16*f + 5) - fdd*(20*f + 6)) + D1*(Dd*(8*f**2*(4*r**2 - 2*r + 1) - 5*f*(r**2*(32*fd - 4) + r*(2 - 8*fd) - 1) + 12*fd*r*(1 - 4*r)) - 2*Ddd*f*(5*f + 3)*(4*r**2 - 2*r + 1)) - 12*Dd**2*f*r*(5*f + 3)*(2*r - 1)) + b1*(66*D1**2*bdd1*f*(5*f + 3)*(2*r**2 - 2*r + 1) - 690*D1**2*f**2*fd*r**2 + 460*D1**2*f**2*fd*r - 230*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 - 560*D1**2*f**2*fdd*r + 280*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r**2 - 1120*D1**2*f*fd**2*r - 264*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r - 132*D1**2*f*fd + 330*D1**2*f*fdd*r**2 - 330*D1**2*f*fdd*r + 165*D1**2*f*fdd + 330*D1**2*fd**2*r**2 - 330*D1**2*fd**2*r - 920*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r - 230*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 - 3920*D1*Dd*f**2*fd*r + 560*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 + 264*D1*Dd*f**2*r - 132*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 - 1980*D1*Dd*f*fd*r + 330*D1*Dd*f*fd + 1120*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r + 280*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 - 330*D1*Ddd*f**2*r + 165*D1*Ddd*f**2 - 33*D1*bd1*(D1*(8*f**2*(2*r**2 - 2*r + 1) - 5*f*(r**2*(16*fd - 2) + r*(2 - 8*fd) - 1) + 12*fd*r*(1 - 2*r)) - 4*Dd*f*(5*f + 3)*(8*r**2 - 6*r + 1)) + 3360*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r + 1980*Dd**2*f**2*r**2 - 990*Dd**2*f**2*r))/(693*d**2*k1*k3**2) + D1**2*Pk3*Pkdd1*ct**3*k2*(D1*f*r*(12*D1*bd1**2*(r - 1) + 5*D1*bdd1*f*r + 2*bd1*(-2*D1*f*r + 5*D1*fd*(2*r - 1) + 5*Dd*f*(4*r - 1))) + b1**2*(D1**2*r**2*(-5*fd + 6*fdd) + D1*(-5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(4*r - 1) + 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(2*r - 1)) + b1*(6*D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r - 16*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 - 60*D1*Dd*f*fd*r + 10*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 - 10*D1*Ddd*f**2*r + 5*D1*Ddd*f**2 + D1*bd1*(-5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(2*r - 1) + 12*Dd*f*(8*r**2 - 6*r + 1)) + 60*Dd**2*f**2*r**2 - 30*Dd**2*f**2*r))/(21*d**2*k1) - D1**2*Pk3*Pkdd1*ct**2*f*k2**4*st**4*(2*C - 2)*(33*D1**2*bd1*f*(r - 1)**2 + 6*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 6*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 + 14*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + 33*D1*b1*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r)/(231*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct**2*k1**4*(2*C - 1)*(264*D1**2*b1*f*fd*r**2 - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*fd**2*r**2 - 165*D1**2*bdd1*f**2*(r - 1)**2 + 345*D1**2*f**2*fd*r**2 - 230*D1**2*f**2*fd*r + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 + 280*D1**2*f**2*fdd*r - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 + 560*D1**2*f*fd**2*r + 528*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 + 660*D1*Dd*b1*f*fd*r + 460*D1*Dd*f**3*r**2 - 230*D1*Dd*f**3*r + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 + 1960*D1*Dd*f**2*fd*r - 280*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 + 330*D1*Ddd*b1*f**2*r - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 + 280*D1*Ddd*f**3*r - 140*D1*Ddd*f**3 + 66*D1*bd1*f*(r - 1)*(2*D1*(f*(r - 1) - 5*fd*r) + 5*Dd*f*(1 - 4*r)) - 1980*Dd**2*b1*f**2*r**2 + 990*Dd**2*b1*f**2*r - 1680*Dd**2*f**3*r**2 + 840*Dd**2*f**3*r)/(693*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct**2*k1**2*k2**2*st**2*(19*C - 13)*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(693*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct**2*k1**2*k2**2*(12870*D1**2*K*bdd1*f**2*r**2 - 2574*D1**2*bd1**2*f*r*(r - 1)*(-12*K + 5*f + 6) - 3640*D1**2*bdd1*f**3*r**2 - 3640*D1**2*bdd1*f**3*r + 1820*D1**2*bdd1*f**3 - 6435*D1**2*bdd1*f**2*r**2 - 30888*D1**2*bdd1*f*g2*r**2 + 61776*D1**2*bdd1*f*g2*r - 30888*D1**2*bdd1*f*g2 - 5320*D1**2*f**3*fd*r**2 + 2660*D1**2*f**3*fd*r - 1330*D1**2*f**3*fd + 6300*D1**2*f**3*fdd*r**2 - 3150*D1**2*f**3*fdd*r + 1575*D1**2*f**3*fdd + 18900*D1**2*f**2*fd**2*r**2 - 9450*D1**2*f**2*fd**2*r + 20592*D1**2*f**2*gd2*r**2 - 25740*D1**2*f**2*gdd2*r**2 + 41184*D1**2*f*fd*g2*r**2 - 41184*D1**2*f*fd*g2*r + 20592*D1**2*f*fd*g2 - 102960*D1**2*f*fd*gd2*r**2 + 51480*D1**2*f*fd*gd2*r - 51480*D1**2*f*fdd*g2*r**2 + 51480*D1**2*f*fdd*g2*r - 25740*D1**2*f*fdd*g2 - 51480*D1**2*fd**2*g2*r**2 + 51480*D1**2*fd**2*g2*r - 5320*D1*Dd*f**4*r**2 + 2660*D1*Dd*f**4*r - 1330*D1*Dd*f**4 + 50400*D1*Dd*f**3*fd*r**2 - 25200*D1*Dd*f**3*fd*r + 3150*D1*Dd*f**3*fd + 82368*D1*Dd*f**2*g2*r**2 - 41184*D1*Dd*f**2*g2*r + 20592*D1*Dd*f**2*g2 - 205920*D1*Dd*f**2*gd2*r**2 + 51480*D1*Dd*f**2*gd2*r - 411840*D1*Dd*f*fd*g2*r**2 + 308880*D1*Dd*f*fd*g2*r - 51480*D1*Dd*f*fd*g2 + 6300*D1*Ddd*f**4*r**2 - 3150*D1*Ddd*f**4*r + 1575*D1*Ddd*f**4 - 102960*D1*Ddd*f**2*g2*r**2 + 51480*D1*Ddd*f**2*g2*r - 25740*D1*Ddd*f**2*g2 + 13*D1*bd1*(D1*(115*f**3*(2*r**2 + 2*r - 1) - 12*f**2*r**2*(66*K + 140*fd - 33) + 198*f*(5*fd*r*(2*K - 1)*(2*r - 1) + 10*g2*(r - 1)**2 - 24*gd2*r*(r - 1)) - 4752*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(140*f**2*(2*r + 1) - 495*f*r*(2*K - 1) + 2376*g2*(r - 1))) + 18900*Dd**2*f**4*r**2 - 9450*Dd**2*f**4*r - 308880*Dd**2*f**2*g2*r**2 + 154440*Dd**2*f**2*g2*r + 1287*b1**2*(D1**2*r**2*(-10*fd**2 + fd*(-10*K + 8*f + 5) - 2*fdd*(-6*K + 5*f + 3)) + D1*(Dd*(4*f**2*(4*r**2 - 2*r + 1) - 5*f*(K*(8*r**2 - 4*r + 2) + r**2*(16*fd - 4) + r*(2 - 4*fd) - 1) + 12*fd*r*(2*K - 1)*(4*r - 1)) - Ddd*f*(-12*K + 5*f + 6)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(2*r - 1)*(-12*K + 5*f + 6)) + 13*b1*(-1584*D1**2*K*f*fd*r**2 + 1584*D1**2*K*f*fd*r - 792*D1**2*K*f*fd + 1980*D1**2*K*f*fdd*r**2 - 1980*D1**2*K*f*fdd*r + 990*D1**2*K*f*fdd + 1980*D1**2*K*fd**2*r**2 - 1980*D1**2*K*fd**2*r - 99*D1**2*bdd1*f*(-12*K + 5*f + 6)*(2*r**2 - 2*r + 1) + 690*D1**2*f**2*fd*r**2 - 690*D1**2*f**2*fd*r + 345*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd - 1680*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r + 792*D1**2*f*fd*r**2 - 792*D1**2*f*fd*r + 396*D1**2*f*fd - 990*D1**2*f*fdd*r**2 + 990*D1**2*f*fdd*r - 495*D1**2*f*fdd + 1980*D1**2*f*gd2*r**2 - 2376*D1**2*f*gdd2*r**2 - 990*D1**2*fd**2*r**2 + 990*D1**2*fd**2*r + 1980*D1**2*fd*g2*r**2 - 4752*D1**2*fd*gd2*r**2 - 2376*D1**2*fdd*g2*r**2 - 3168*D1*Dd*K*f**2*r**2 + 1584*D1*Dd*K*f**2*r - 792*D1*Dd*K*f**2 + 15840*D1*Dd*K*f*fd*r**2 - 11880*D1*Dd*K*f*fd*r + 1980*D1*Dd*K*f*fd + 920*D1*Dd*f**3*r**2 - 460*D1*Dd*f**3*r + 230*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 + 5040*D1*Dd*f**2*fd*r - 840*D1*Dd*f**2*fd + 1584*D1*Dd*f**2*r**2 - 792*D1*Dd*f**2*r + 396*D1*Dd*f**2 - 7920*D1*Dd*f*fd*r**2 + 5940*D1*Dd*f*fd*r - 990*D1*Dd*f*fd + 7920*D1*Dd*f*g2*r**2 - 3960*D1*Dd*f*g2*r + 1980*D1*Dd*f*g2 - 19008*D1*Dd*f*gd2*r**2 + 4752*D1*Dd*f*gd2*r - 19008*D1*Dd*fd*g2*r**2 + 4752*D1*Dd*fd*g2*r + 3960*D1*Ddd*K*f**2*r**2 - 1980*D1*Ddd*K*f**2*r + 990*D1*Ddd*K*f**2 - 1120*D1*Ddd*f**3*r**2 + 560*D1*Ddd*f**3*r - 280*D1*Ddd*f**3 - 1980*D1*Ddd*f**2*r**2 + 990*D1*Ddd*f**2*r - 495*D1*Ddd*f**2 - 9504*D1*Ddd*f*g2*r**2 + 4752*D1*Ddd*f*g2*r - 2376*D1*Ddd*f*g2 + 99*D1*bd1*(D1*(f**2*(8*r**2 - 8*r + 4) - 5*f*(K*(4*r**2 - 4*r + 2) + r**2*(8*fd - 2) + r*(2 - 4*fd) - 1) + 12*fd*r*(2*K - 1)*(2*r - 1)) - 2*Dd*f*(-12*K + 5*f + 6)*(8*r**2 - 6*r + 1)) + 11880*Dd**2*K*f**2*r**2 - 5940*Dd**2*K*f**2*r - 3360*Dd**2*f**3*r**2 + 1680*Dd**2*f**3*r - 5940*Dd**2*f**2*r**2 + 2970*Dd**2*f**2*r - 28512*Dd**2*f*g2*r**2 + 14256*Dd**2*f*g2*r))/(9009*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct**2*k1**2*(2*C - 1)*(33*D1*b1*(-6*D1*bdd1*f*(2*r**2 - 2*r + 1) - 8*D1*f*fd*r + 4*D1*f*fd + 10*D1*f*fdd*r - 5*D1*f*fdd + 10*D1*fd**2*r + 40*Dd*f*fd*r - 10*Dd*f*fd + bd1*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1))) + 33*b1**2*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + f*(-396*D1**2*bd1**2*r*(r - 1) - 165*D1**2*bdd1*f*(2*r - 1) - 5*D1**2*(f*(23*fd - 28*fdd)*(3*r**2 - 2*r + 1) + 56*fd**2*r*(2 - 3*r)) + 66*D1*bd1*(D1*f*(4*r - 2) - 5*D1*fd*r + 5*Dd*f*(1 - 4*r)) - 5*D1*f*(23*Dd*f*(4*r**2 - 2*r + 1) - 56*Dd*fd*(12*r**2 - 7*r + 1) - 28*Ddd*f*(4*r**2 - 2*r + 1)) - 840*Dd**2*f**2*r*(1 - 2*r)))/(693*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct**2*k2**4*st**2*(143*D1**2*K*bdd1*f**2*r**2 - 286*D1**2*bd1**2*f*r*(r - 1)*(-K + 6*f + 1) + 1300*D1**2*bdd1*f**3*r**2 - 3900*D1**2*bdd1*f**3*r + 1950*D1**2*bdd1*f**3 - 143*D1**2*bdd1*f**2*r**2 - 286*D1**2*bdd1*f*g2*r**2 + 572*D1**2*bdd1*f*g2*r - 286*D1**2*bdd1*f*g2 - 3960*D1**2*f**3*fd*r**2 + 1980*D1**2*f**3*fd*r - 990*D1**2*f**3*fd + 5880*D1**2*f**3*fdd*r**2 - 2940*D1**2*f**3*fdd*r + 1470*D1**2*f**3*fdd + 17640*D1**2*f**2*fd**2*r**2 - 8820*D1**2*f**2*fd**2*r + 286*D1**2*f**2*gd2*r**2 - 286*D1**2*f**2*gdd2*r**2 + 572*D1**2*f*fd*g2*r**2 - 572*D1**2*f*fd*g2*r + 286*D1**2*f*fd*g2 - 1144*D1**2*f*fd*gd2*r**2 + 572*D1**2*f*fd*gd2*r - 572*D1**2*f*fdd*g2*r**2 + 572*D1**2*f*fdd*g2*r - 286*D1**2*f*fdd*g2 - 572*D1**2*fd**2*g2*r**2 + 572*D1**2*fd**2*g2*r - 3960*D1*Dd*f**4*r**2 + 1980*D1*Dd*f**4*r - 990*D1*Dd*f**4 + 47040*D1*Dd*f**3*fd*r**2 - 23520*D1*Dd*f**3*fd*r + 2940*D1*Dd*f**3*fd + 1144*D1*Dd*f**2*g2*r**2 - 572*D1*Dd*f**2*g2*r + 286*D1*Dd*f**2*g2 - 2288*D1*Dd*f**2*gd2*r**2 + 572*D1*Dd*f**2*gd2*r - 4576*D1*Dd*f*fd*g2*r**2 + 3432*D1*Dd*f*fd*g2*r - 572*D1*Dd*f*fd*g2 + 5880*D1*Ddd*f**4*r**2 - 2940*D1*Ddd*f**4*r + 1470*D1*Ddd*f**4 - 1144*D1*Ddd*f**2*g2*r**2 + 572*D1*Ddd*f**2*g2*r - 286*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(34*f**3*(2*r**2 - 6*r + 3) + f**2*r*(-200*fd*(3*r - 4) + r*(11*K - 11)) - 22*f*(fd*r*(K - 1)*(2*r - 1) + 9*g2*(r - 1)**2 - 2*gd2*r*(r - 1)) + 44*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(50*f**2*(2*r - 3) + 11*f*r*(K - 1) - 22*g2*(r - 1))) + 17640*Dd**2*f**4*r**2 - 8820*Dd**2*f**4*r - 3432*Dd**2*f**2*g2*r**2 + 1716*Dd**2*f**2*g2*r + 143*b1**2*(-D1**2*r**2*(12*fd**2 - 3*fd*(-3*K + 4*f + 3) + fdd*(-K + 12*f + 1)) + D1*(Dd*(6*f**2*(4*r**2 - 2*r + 1) - 3*f*(3*K*(4*r**2 - 2*r + 1) + r**2*(32*fd - 12) + r*(6 - 8*fd) - 3) + 2*fd*r*(K - 1)*(4*r - 1)) - Ddd*f*(-K + 6*f + 1)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(2*r - 1)*(-K + 6*f + 1)) + 13*b1*(-22*D1**2*K*f*fd*r**2 + 22*D1**2*K*f*fd*r - 11*D1**2*K*f*fd + 22*D1**2*K*f*fdd*r**2 - 22*D1**2*K*f*fdd*r + 11*D1**2*K*f*fdd + 22*D1**2*K*fd**2*r**2 - 22*D1**2*K*fd**2*r - 11*D1**2*bdd1*f*(-K + 6*f + 1)*(2*r**2 - 2*r + 1) - 204*D1**2*f**2*fd*r**2 - 68*D1**2*f**2*fd*r + 34*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r**2 + 100*D1**2*f**2*fdd*r - 50*D1**2*f**2*fdd + 600*D1**2*f*fd**2*r**2 + 200*D1**2*f*fd**2*r + 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r + 11*D1**2*f*fd - 22*D1**2*f*fdd*r**2 + 22*D1**2*f*fdd*r - 11*D1**2*f*fdd + 198*D1**2*f*gd2*r**2 - 22*D1**2*f*gdd2*r**2 - 22*D1**2*fd**2*r**2 + 22*D1**2*fd**2*r + 198*D1**2*fd*g2*r**2 - 44*D1**2*fd*gd2*r**2 - 22*D1**2*fdd*g2*r**2 - 44*D1*Dd*K*f**2*r**2 + 22*D1*Dd*K*f**2*r - 11*D1*Dd*K*f**2 + 176*D1*Dd*K*f*fd*r**2 - 132*D1*Dd*K*f*fd*r + 22*D1*Dd*K*f*fd - 272*D1*Dd*f**3*r**2 + 136*D1*Dd*f**3*r - 68*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r**2 - 200*D1*Dd*f**2*fd*r - 100*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 - 22*D1*Dd*f**2*r + 11*D1*Dd*f**2 - 176*D1*Dd*f*fd*r**2 + 132*D1*Dd*f*fd*r - 22*D1*Dd*f*fd + 792*D1*Dd*f*g2*r**2 - 396*D1*Dd*f*g2*r + 198*D1*Dd*f*g2 - 176*D1*Dd*f*gd2*r**2 + 44*D1*Dd*f*gd2*r - 176*D1*Dd*fd*g2*r**2 + 44*D1*Dd*fd*g2*r + 44*D1*Ddd*K*f**2*r**2 - 22*D1*Ddd*K*f**2*r + 11*D1*Ddd*K*f**2 + 400*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r + 100*D1*Ddd*f**3 - 44*D1*Ddd*f**2*r**2 + 22*D1*Ddd*f**2*r - 11*D1*Ddd*f**2 - 88*D1*Ddd*f*g2*r**2 + 44*D1*Ddd*f*g2*r - 22*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(6*f**2*(2*r**2 - 2*r + 1) - 3*f*(K*(6*r**2 - 6*r + 3) + r**2*(16*fd - 6) + r*(6 - 8*fd) - 3) + 2*fd*r*(K - 1)*(2*r - 1)) - 2*Dd*f*(-K + 6*f + 1)*(8*r**2 - 6*r + 1)) + 132*Dd**2*K*f**2*r**2 - 66*Dd**2*K*f**2*r + 1200*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r - 132*Dd**2*f**2*r**2 + 66*Dd**2*f**2*r - 264*Dd**2*f*g2*r**2 + 132*Dd**2*f*g2*r))/(6006*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct**2*k2**2*st**2*(C - 1)*(11*b1**2*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) + 11*b1*(-D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 10*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r - 20*D1*Dd*f**2*r**2 + 10*D1*Dd*f**2*r - 5*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 - 12*D1*Dd*f*fd*r - 2*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 - 10*D1*Ddd*f**2*r + 5*D1*Ddd*f**2 + D1*bd1*(9*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 2*r) - 2*Dd*f*(8*r**2 - 6*r + 1)) + 60*Dd**2*f**2*r**2 - 30*Dd**2*f**2*r) + f*(-22*D1**2*bd1**2*r*(r - 1) + 11*D1**2*bdd1*f*(5*r**2 - 12*r + 6) - 2*D1**2*(f*(17*fd - 25*fdd)*(3*r**2 - 2*r + 1) + 50*fd**2*r*(2 - 3*r)) - 11*D1*bd1*(D1*f*(5*r**2 - 12*r + 6) + 2*D1*fd*r*(11 - 10*r) - 2*Dd*f*(20*r**2 - 29*r + 6)) - 2*D1*f*(17*Dd*f*(4*r**2 - 2*r + 1) - 50*Dd*fd*(12*r**2 - 7*r + 1) - 25*Ddd*f*(4*r**2 - 2*r + 1)) - 300*Dd**2*f**2*r*(1 - 2*r)))/(231*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct**2*k2**2*(132*D1**2*K*bd1**2*f*r + 44*D1**2*K*bd1*f**2*r**2 - 220*D1**2*K*bd1*f*fd*r**2 + 110*D1**2*K*bd1*f*fd*r - 55*D1**2*K*bdd1*f**2*r**2 + 220*D1**2*bd1**2*f**2*r**2 - 330*D1**2*bd1**2*f**2*r + 132*D1**2*bd1**2*f*r**2 - 264*D1**2*bd1**2*f*r - 308*D1**2*bd1**2*g2*r**2 + 308*D1**2*bd1**2*g2*r - 132*D1**2*bd1*bd2*f*r**2 + 132*D1**2*bd1*bd2*f*r - 115*D1**2*bd1*f**3*r**2 + 840*D1**2*bd1*f**2*fd*r**2 - 280*D1**2*bd1*f**2*fd*r - 88*D1**2*bd1*f**2*r**2 + 440*D1**2*bd1*f*fd*r**2 - 220*D1**2*bd1*f*fd*r + 220*D1**2*bd1*f*g2*r - 110*D1**2*bd1*f*g2 - 264*D1**2*bd1*f*gd2*r + 44*D1**2*bd2*f**2*r**2 - 220*D1**2*bd2*f*fd*r**2 + 110*D1**2*bd2*f*fd*r + 140*D1**2*bdd1*f**3*r**2 + 110*D1**2*bdd1*f**2*r**2 - 264*D1**2*bdd1*f*g2*r + 132*D1**2*bdd1*f*g2 - 55*D1**2*bdd2*f**2*r**2 - 88*D1**2*f**2*gd2*r**2 + 110*D1**2*f**2*gdd2*r**2 - 176*D1**2*f*fd*g2*r**2 + 176*D1**2*f*fd*g2*r - 88*D1**2*f*fd*g2 + 440*D1**2*f*fd*gd2*r**2 - 220*D1**2*f*fd*gd2*r + 220*D1**2*f*fdd*g2*r**2 - 220*D1**2*f*fdd*g2*r + 110*D1**2*f*fdd*g2 + 220*D1**2*fd**2*g2*r**2 - 220*D1**2*fd**2*g2*r - 440*D1*Dd*K*bd1*f**2*r**2 + 110*D1*Dd*K*bd1*f**2*r + 1120*D1*Dd*bd1*f**3*r**2 - 280*D1*Dd*bd1*f**3*r + 880*D1*Dd*bd1*f**2*r**2 - 220*D1*Dd*bd1*f**2*r - 1056*D1*Dd*bd1*f*g2*r + 264*D1*Dd*bd1*f*g2 - 440*D1*Dd*bd2*f**2*r**2 + 110*D1*Dd*bd2*f**2*r - 352*D1*Dd*f**2*g2*r**2 + 176*D1*Dd*f**2*g2*r - 88*D1*Dd*f**2*g2 + 880*D1*Dd*f**2*gd2*r**2 - 220*D1*Dd*f**2*gd2*r + 1760*D1*Dd*f*fd*g2*r**2 - 1320*D1*Dd*f*fd*g2*r + 220*D1*Dd*f*fd*g2 + 440*D1*Ddd*f**2*g2*r**2 - 220*D1*Ddd*f**2*g2*r + 110*D1*Ddd*f**2*g2 + 1320*Dd**2*f**2*g2*r**2 - 660*Dd**2*f**2*g2*r + 11*b1**3*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*(-7*K*(4*r**2 - 2*r + 1) - r**2*(24*fd - 28) + r*(6*fd - 14) + 7) - Ddd*(-7*K + 6*f + 7)*(4*r**2 - 2*r + 1)) - 6*Dd**2*r*(2*r - 1)*(-7*K + 6*f + 7)) + 11*b1**2*(10*D1**2*K*fd*r - 5*D1**2*K*fd - 12*D1**2*K*fdd*r + 6*D1**2*K*fdd - D1**2*bdd1*(-7*K + 6*f + 7)*(3*r**2 - 2*r + 1) - 16*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd + 20*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd + 20*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r - 5*D1**2*fd*r**2 - 10*D1**2*fd*r + 5*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r - 6*D1**2*fdd + 28*D1**2*gd2*r**2 - 14*D1**2*gdd2*r**2 - 48*D1*Dd*K*fd*r + 12*D1*Dd*K*fd - 32*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r - 8*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 - 10*D1*Dd*f*fd - 20*D1*Dd*f*r**2 + 10*D1*Dd*f*r - 5*D1*Dd*f + 48*D1*Dd*fd*r**2 + 36*D1*Dd*fd*r - 12*D1*Dd*fd + 112*D1*Dd*g2*r**2 - 56*D1*Dd*g2*r + 28*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 + 28*D1*Dd*gd2*r + 40*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r + 10*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 - 12*D1*Ddd*f*r + 6*D1*Ddd*f - 56*D1*Ddd*g2*r**2 + 28*D1*Ddd*g2*r - 14*D1*Ddd*g2 + D1*bd1*(5*D1*f*(3*r**2 - 2*r + 1) + 2*D1*(-7*K*(3*r**2 - 2*r + 1) - r**2*(18*fd - 21) + r*(6*fd - 14) + 7) - 2*Dd*(-7*K + 6*f + 7)*(12*r**2 - 7*r + 1)) + 120*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r + 72*Dd**2*f*r**2 - 36*Dd**2*f*r - 168*Dd**2*g2*r**2 + 84*Dd**2*g2*r) + b1*(88*D1**2*K*f*fd*r**2 - 88*D1**2*K*f*fd*r + 44*D1**2*K*f*fd - 110*D1**2*K*f*fdd*r**2 + 110*D1**2*K*f*fdd*r - 55*D1**2*K*f*fdd - 110*D1**2*K*fd**2*r**2 + 110*D1**2*K*fd**2*r + 55*D1**2*b2*fd*r**2 - 66*D1**2*b2*fdd*r**2 - 22*D1**2*bd1**2*r*(3*r - 2)*(-7*K + 6*f + 7) + 55*D1**2*bd2*f*r**2 - 132*D1**2*bd2*fd*r**2 + 11*D1**2*bdd1*(5*f**2*(4*r**2 - 6*r + 3) + 6*f*(K*(2*r - 1) + 2*(r - 1)**2) - 14*g2*(2*r**2 - 2*r + 1)) - 66*D1**2*bdd2*f*r**2 - 345*D1**2*f**2*fd*r**2 + 230*D1**2*f**2*fd*r - 115*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 - 280*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 - 560*D1**2*f*fd**2*r - 176*D1**2*f*fd*r**2 + 176*D1**2*f*fd*r - 88*D1**2*f*fd + 220*D1**2*f*fdd*r**2 - 220*D1**2*f*fdd*r + 110*D1**2*f*fdd + 220*D1**2*fd**2*r**2 - 220*D1**2*fd**2*r - 220*D1**2*fd*g2*r + 110*D1**2*fd*g2 + 264*D1**2*fd*gd2*r + 264*D1**2*fdd*g2*r - 132*D1**2*fdd*g2 + 176*D1*Dd*K*f**2*r**2 - 88*D1*Dd*K*f**2*r + 44*D1*Dd*K*f**2 - 880*D1*Dd*K*f*fd*r**2 + 660*D1*Dd*K*f*fd*r - 110*D1*Dd*K*f*fd + 220*D1*Dd*b2*f*r**2 - 110*D1*Dd*b2*f*r + 55*D1*Dd*b2*f - 528*D1*Dd*b2*fd*r**2 + 132*D1*Dd*b2*fd*r - 528*D1*Dd*bd2*f*r**2 + 132*D1*Dd*bd2*f*r - 460*D1*Dd*f**3*r**2 + 230*D1*Dd*f**3*r - 115*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 - 1960*D1*Dd*f**2*fd*r + 280*D1*Dd*f**2*fd - 352*D1*Dd*f**2*r**2 + 176*D1*Dd*f**2*r - 88*D1*Dd*f**2 + 1760*D1*Dd*f*fd*r**2 - 1320*D1*Dd*f*fd*r + 220*D1*Dd*f*fd + 1056*D1*Dd*fd*g2*r - 264*D1*Dd*fd*g2 - 220*D1*Ddd*K*f**2*r**2 + 110*D1*Ddd*K*f**2*r - 55*D1*Ddd*K*f**2 - 264*D1*Ddd*b2*f*r**2 + 132*D1*Ddd*b2*f*r - 66*D1*Ddd*b2*f + 560*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r + 140*D1*Ddd*f**3 + 440*D1*Ddd*f**2*r**2 - 220*D1*Ddd*f**2*r + 110*D1*Ddd*f**2 - 11*D1*bd1*(D1*(5*K*f*(2*r - 1) + 4*f**2*(4*r**2 - 6*r + 3) + 10*f*(r**2*(1 - 8*fd) + r*(4*fd - 2) + 1) - 28*g2*(2*r**2 - 2*r + 1) + 4*r*(3*fd*(K - 2*r) + 7*gd2*(2*r - 1))) - 2*Dd*(4*r - 1)*(5*f**2*(4*r - 3) + 6*f*(K + 2*r - 2) + 14*g2*(1 - 2*r))) - 660*Dd**2*K*f**2*r**2 + 330*Dd**2*K*f**2*r - 792*Dd**2*b2*f*r**2 + 396*Dd**2*b2*f*r + 1680*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r + 1320*Dd**2*f**2*r**2 - 660*Dd**2*f**2*r) + 11*b2*(-6*D1**2*bdd1*f*(r - 1)**2 + 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 60*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + D1*bd1*(r - 1)*(5*D1*f*(r - 1) - 12*D1*fd*r + 12*Dd*f*(1 - 4*r)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(231*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct**2*(2*C - 1)*(D1*f*r*(-12*D1*bd1**2*(r - 1) - 5*D1*bdd1*f*r + 2*bd1*(2*D1*f*r + D1*fd*(5 - 10*r) + 5*Dd*f*(1 - 4*r))) + b1**2*(D1**2*r**2*(5*fd - 6*fdd) + D1*(5*Dd*f*(4*r**2 - 2*r + 1) + 12*Dd*fd*r*(1 - 4*r) - 6*Ddd*f*(4*r**2 - 2*r + 1)) + 36*Dd**2*f*r*(1 - 2*r)) + b1*(-6*D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 60*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + D1*bd1*(5*D1*f*(2*r**2 - 2*r + 1) + 12*D1*fd*r*(1 - 2*r) - 12*Dd*f*(8*r**2 - 6*r + 1)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(21*d**2) - D1**2*Pk3*Pkdd1*ct*f*k1*k2**3*st**4*(4*C - 3)*(33*D1**2*bd1*f*(r - 1)**2 + 6*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 6*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 + 14*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + 33*D1*b1*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r)/(231*d**2*k3**4) - 5*D1**2*Pk3*Pkdd1*ct*f*k2**5*st**4*(78*D1**2*b1*f*fd*r**2 - 39*D1**2*b1*f*fdd*r**2 - 78*D1**2*b1*fd**2*r**2 - 13*D1**2*bdd1*f**2*(r - 1)**2 + 28*D1**2*f**2*fd*r**2 - 14*D1**2*f**2*fd*r + 7*D1**2*f**2*fd - 40*D1**2*f**2*fdd*r**2 + 20*D1**2*f**2*fdd*r - 10*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r**2 + 60*D1**2*f*fd**2*r + 104*D1*Dd*b1*f**2*r**2 - 52*D1*Dd*b1*f**2*r + 26*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 + 78*D1*Dd*b1*f*fd*r + 28*D1*Dd*f**3*r**2 - 14*D1*Dd*f**3*r + 7*D1*Dd*f**3 - 320*D1*Dd*f**2*fd*r**2 + 160*D1*Dd*f**2*fd*r - 20*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 + 26*D1*Ddd*b1*f**2*r - 13*D1*Ddd*b1*f**2 - 40*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r - 10*D1*Ddd*f**3 + 26*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 3*D1*fd*r + Dd*f*(1 - 4*r)) - 156*Dd**2*b1*f**2*r**2 + 78*Dd**2*b1*f**2*r - 120*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r)/(3003*d**2*k1*k3**4) + D1**2*Pk3*Pkdd1*ct*f*k2**3*st**4*(-33*D1**2*bd1*f*(r - 1)**2 - 6*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r - 2*D1**2*f*fd + 3*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r + D1**2*f*fdd + 6*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r - 8*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r - 2*D1*Dd*f**2 + 24*D1*Dd*f*fd*r**2 - 14*D1*Dd*f*fd*r + 2*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 - 2*D1*Ddd*f**2*r + D1*Ddd*f**2 - 33*D1*b1*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) + 12*Dd**2*f**2*r**2 - 6*Dd**2*f**2*r)/(231*d**2*k1*k3**2) - D1**2*Pk3*Pkdd1*ct*k1**3*k2*st**2*(16*C - 9)*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(1386*d**2*k3**4) - D1**2*Pk3*Pkdd1*ct*k1**3*k2*(-660*D1**2*K*bdd1*f**2*r**2 + 66*D1**2*bd1**2*f*r*(r - 1)*(-24*K + 5*f + 6) + 140*D1**2*bdd1*f**3*r**2 + 165*D1**2*bdd1*f**2*r**2 + 1584*D1**2*bdd1*f*g2*r**2 - 3168*D1**2*bdd1*f*g2*r + 1584*D1**2*bdd1*f*g2 - 1056*D1**2*f**2*gd2*r**2 + 1320*D1**2*f**2*gdd2*r**2 - 2112*D1**2*f*fd*g2*r**2 + 2112*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 - 2640*D1**2*f*fd*gd2*r + 2640*D1**2*f*fdd*g2*r**2 - 2640*D1**2*f*fdd*g2*r + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 - 2640*D1**2*fd**2*g2*r - 4224*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 - 2640*D1*Dd*f**2*gd2*r + 21120*D1*Dd*f*fd*g2*r**2 - 15840*D1*Dd*f*fd*g2*r + 2640*D1*Dd*f*fd*g2 + 5280*D1*Ddd*f**2*g2*r**2 - 2640*D1*Ddd*f**2*g2*r + 1320*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(115*f**3*r**2 - 4*f**2*r*(70*fd*(3*r - 1) + r*(132*K - 33)) + 66*f*(5*fd*r*(4*K - 1)*(2*r - 1) + 20*g2*(r - 1)**2 - 48*gd2*r*(r - 1)) - 3168*fd*g2*r*(r - 1)) + 2*Dd*f*(4*r - 1)*(5*f*r*(-132*K + 28*f + 33) + 1584*g2*(r - 1))) + 15840*Dd**2*f**2*g2*r**2 - 7920*Dd**2*f**2*g2*r - 33*b1**2*(D1**2*r**2*(-10*fd**2 + fd*(-20*K + 8*f + 5) - 2*fdd*(-12*K + 5*f + 3)) + D1*(Dd*(4*f**2*(4*r**2 - 2*r + 1) - 5*f*(4*K*(4*r**2 - 2*r + 1) + r**2*(16*fd - 4) + r*(2 - 4*fd) - 1) + 12*fd*r*(4*K - 1)*(4*r - 1)) - Ddd*f*(-24*K + 5*f + 6)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(2*r - 1)*(-24*K + 5*f + 6)) + b1*(1056*D1**2*K*f*fd*r**2 - 1056*D1**2*K*f*fd*r + 528*D1**2*K*f*fd - 1320*D1**2*K*f*fdd*r**2 + 1320*D1**2*K*f*fdd*r - 660*D1**2*K*f*fdd - 1320*D1**2*K*fd**2*r**2 + 1320*D1**2*K*fd**2*r + 33*D1**2*bdd1*f*(-24*K + 5*f + 6)*(2*r**2 - 2*r + 1) - 345*D1**2*f**2*fd*r**2 + 230*D1**2*f**2*fd*r - 115*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 - 280*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 - 560*D1**2*f*fd**2*r - 264*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r - 132*D1**2*f*fd + 330*D1**2*f*fdd*r**2 - 330*D1**2*f*fdd*r + 165*D1**2*f*fdd - 1320*D1**2*f*gd2*r**2 + 1584*D1**2*f*gdd2*r**2 + 330*D1**2*fd**2*r**2 - 330*D1**2*fd**2*r - 1320*D1**2*fd*g2*r**2 + 3168*D1**2*fd*gd2*r**2 + 1584*D1**2*fdd*g2*r**2 + 2112*D1*Dd*K*f**2*r**2 - 1056*D1*Dd*K*f**2*r + 528*D1*Dd*K*f**2 - 10560*D1*Dd*K*f*fd*r**2 + 7920*D1*Dd*K*f*fd*r - 1320*D1*Dd*K*f*fd - 460*D1*Dd*f**3*r**2 + 230*D1*Dd*f**3*r - 115*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 - 1960*D1*Dd*f**2*fd*r + 280*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 + 264*D1*Dd*f**2*r - 132*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 - 1980*D1*Dd*f*fd*r + 330*D1*Dd*f*fd - 5280*D1*Dd*f*g2*r**2 + 2640*D1*Dd*f*g2*r - 1320*D1*Dd*f*g2 + 12672*D1*Dd*f*gd2*r**2 - 3168*D1*Dd*f*gd2*r + 12672*D1*Dd*fd*g2*r**2 - 3168*D1*Dd*fd*g2*r - 2640*D1*Ddd*K*f**2*r**2 + 1320*D1*Ddd*K*f**2*r - 660*D1*Ddd*K*f**2 + 560*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r + 140*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 - 330*D1*Ddd*f**2*r + 165*D1*Ddd*f**2 + 6336*D1*Ddd*f*g2*r**2 - 3168*D1*Ddd*f*g2*r + 1584*D1*Ddd*f*g2 - 33*D1*bd1*(D1*(f**2*(8*r**2 - 8*r + 4) - 5*f*(K*(8*r**2 - 8*r + 4) + r**2*(8*fd - 2) + r*(2 - 4*fd) - 1) + 12*fd*r*(4*K - 1)*(2*r - 1)) - 2*Dd*f*(-24*K + 5*f + 6)*(8*r**2 - 6*r + 1)) - 7920*Dd**2*K*f**2*r**2 + 3960*Dd**2*K*f**2*r + 1680*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r + 1980*Dd**2*f**2*r**2 - 990*Dd**2*f**2*r + 19008*Dd**2*f*g2*r**2 - 9504*Dd**2*f*g2*r))/(693*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct*k1*k2**3*st**2*(286*D1**2*K*bdd1*f**2*r**2 - 286*D1**2*bd1**2*f*r*(r - 1)*(-2*K + 9*f + 1) - 1950*D1**2*bdd1*f**3*r + 975*D1**2*bdd1*f**3 - 143*D1**2*bdd1*f**2*r**2 - 572*D1**2*bdd1*f*g2*r**2 + 1144*D1**2*bdd1*f*g2*r - 572*D1**2*bdd1*f*g2 - 1980*D1**2*f**3*fd*r**2 + 990*D1**2*f**3*fd*r - 495*D1**2*f**3*fd + 2940*D1**2*f**3*fdd*r**2 - 1470*D1**2*f**3*fdd*r + 735*D1**2*f**3*fdd + 8820*D1**2*f**2*fd**2*r**2 - 4410*D1**2*f**2*fd**2*r + 572*D1**2*f**2*gd2*r**2 - 572*D1**2*f**2*gdd2*r**2 + 1144*D1**2*f*fd*g2*r**2 - 1144*D1**2*f*fd*g2*r + 572*D1**2*f*fd*g2 - 2288*D1**2*f*fd*gd2*r**2 + 1144*D1**2*f*fd*gd2*r - 1144*D1**2*f*fdd*g2*r**2 + 1144*D1**2*f*fdd*g2*r - 572*D1**2*f*fdd*g2 - 1144*D1**2*fd**2*g2*r**2 + 1144*D1**2*fd**2*g2*r - 1980*D1*Dd*f**4*r**2 + 990*D1*Dd*f**4*r - 495*D1*Dd*f**4 + 23520*D1*Dd*f**3*fd*r**2 - 11760*D1*Dd*f**3*fd*r + 1470*D1*Dd*f**3*fd + 2288*D1*Dd*f**2*g2*r**2 - 1144*D1*Dd*f**2*g2*r + 572*D1*Dd*f**2*g2 - 4576*D1*Dd*f**2*gd2*r**2 + 1144*D1*Dd*f**2*gd2*r - 9152*D1*Dd*f*fd*g2*r**2 + 6864*D1*Dd*f*fd*g2*r - 1144*D1*Dd*f*fd*g2 + 2940*D1*Ddd*f**4*r**2 - 1470*D1*Ddd*f**4*r + 735*D1*Ddd*f**4 - 2288*D1*Ddd*f**2*g2*r**2 + 1144*D1*Ddd*f**2*g2*r - 572*D1*Ddd*f**2*g2 + 13*D1*bd1*(D1*(51*f**3*(2*r - 1) + f**2*r*(-300*fd + r*(11 - 22*K)) + 22*f*(fd*r*(2*K - 1)*(2*r - 1) + 18*g2*(r - 1)**2 - 4*gd2*r*(r - 1)) - 88*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(75*f**2 + 11*f*r*(1 - 2*K) + 44*g2*(r - 1))) + 8820*Dd**2*f**4*r**2 - 4410*Dd**2*f**4*r - 6864*Dd**2*f**2*g2*r**2 + 3432*Dd**2*f**2*g2*r + 143*b1**2*(-D1**2*r**2*(18*fd**2 - 9*fd*(-2*K + 2*f + 1) + fdd*(-2*K + 18*f + 1)) + D1*(Dd*(9*f**2*(4*r**2 - 2*r + 1) - 9*f*(K*(8*r**2 - 4*r + 2) + r**2*(16*fd - 4) + r*(2 - 4*fd) - 1) + 2*fd*r*(2*K - 1)*(4*r - 1)) - Ddd*f*(-2*K + 9*f + 1)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(2*r - 1)*(-2*K + 9*f + 1)) + 13*b1*(-44*D1**2*K*f*fd*r**2 + 44*D1**2*K*f*fd*r - 22*D1**2*K*f*fd + 44*D1**2*K*f*fdd*r**2 - 44*D1**2*K*f*fdd*r + 22*D1**2*K*f*fdd + 44*D1**2*K*fd**2*r**2 - 44*D1**2*K*fd**2*r - 11*D1**2*bdd1*f*(-2*K + 9*f + 1)*(2*r**2 - 2*r + 1) - 102*D1**2*f**2*fd*r + 51*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r + 22*D1**2*f*fd*r**2 - 22*D1**2*f*fd*r + 11*D1**2*f*fd - 22*D1**2*f*fdd*r**2 + 22*D1**2*f*fdd*r - 11*D1**2*f*fdd + 396*D1**2*f*gd2*r**2 - 44*D1**2*f*gdd2*r**2 - 22*D1**2*fd**2*r**2 + 22*D1**2*fd**2*r + 396*D1**2*fd*g2*r**2 - 88*D1**2*fd*gd2*r**2 - 44*D1**2*fdd*g2*r**2 - 88*D1*Dd*K*f**2*r**2 + 44*D1*Dd*K*f**2*r - 22*D1*Dd*K*f**2 + 352*D1*Dd*K*f*fd*r**2 - 264*D1*Dd*K*f*fd*r + 44*D1*Dd*K*f*fd + 600*D1*Dd*f**2*fd*r - 150*D1*Dd*f**2*fd + 44*D1*Dd*f**2*r**2 - 22*D1*Dd*f**2*r + 11*D1*Dd*f**2 - 176*D1*Dd*f*fd*r**2 + 132*D1*Dd*f*fd*r - 22*D1*Dd*f*fd + 1584*D1*Dd*f*g2*r**2 - 792*D1*Dd*f*g2*r + 396*D1*Dd*f*g2 - 352*D1*Dd*f*gd2*r**2 + 88*D1*Dd*f*gd2*r - 352*D1*Dd*fd*g2*r**2 + 88*D1*Dd*fd*g2*r + 88*D1*Ddd*K*f**2*r**2 - 44*D1*Ddd*K*f**2*r + 22*D1*Ddd*K*f**2 - 44*D1*Ddd*f**2*r**2 + 22*D1*Ddd*f**2*r - 11*D1*Ddd*f**2 - 176*D1*Ddd*f*g2*r**2 + 88*D1*Ddd*f*g2*r - 44*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(9*f**2*(2*r**2 - 2*r + 1) - 9*f*(K*(4*r**2 - 4*r + 2) + r**2*(8*fd - 2) + r*(2 - 4*fd) - 1) + 2*fd*r*(2*K - 1)*(2*r - 1)) - 2*Dd*f*(-2*K + 9*f + 1)*(8*r**2 - 6*r + 1)) + 264*Dd**2*K*f**2*r**2 - 132*Dd**2*K*f**2*r - 132*Dd**2*f**2*r**2 + 66*Dd**2*f**2*r - 528*Dd**2*f*g2*r**2 + 264*Dd**2*f*g2*r))/(6006*d**2*k3**4) + D1**2*Pk3*Pkdd1*ct*k1*k2*st**2*(-33*b1**2*(4*C - 3)*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) - 33*b1*(-16*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r + 4*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r**2 + 8*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r**2 + 8*C*D1**2*fd**2*r - 32*C*D1*Dd*f**2*r**2 + 16*C*D1*Dd*f**2*r - 8*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r**2 - 8*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r**2 - 16*C*D1*Ddd*f**2*r + 8*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r**2 - 48*C*Dd**2*f**2*r - D1**2*bdd1*f*(4*C - 3)*(2*r**2 - 2*r + 1) + 8*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r - 3*D1**2*f*fd - 8*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r + 3*D1**2*f*fdd - 8*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 64*D1*Dd*f*fd*r**2 - 8*D1*Dd*f*fd*r + 6*D1*Dd*f*fd - 16*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r - 4*D1*Ddd*f**2 + D1*bd1*(4*C - 3)*(9*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 2*r) - 2*Dd*f*(8*r**2 - 6*r + 1)) - 48*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r) + f*(66*D1**2*bd1**2*r*(4*C - 3)*(r - 1) - 33*D1**2*bdd1*f*(4*C*(2*r**2 - 6*r + 3) - 4*r**2 + 14*r - 7) + 33*D1*bd1*(D1*(f*(4*C*(2*r**2 - 6*r + 3) - 4*r**2 + 14*r - 7) + 2*fd*r*(-4*C*(4*r - 5) + 8*r - 11)) - 2*Dd*f*(4*r - 1)*(4*C*(2*r - 3) - 4*r + 7)) + (12*C - 7)*(D1**2*(f*(17*fd - 25*fdd)*(3*r**2 - 2*r + 1) + 50*fd**2*r*(2 - 3*r)) + D1*f*(17*Dd*f*(4*r**2 - 2*r + 1) - 50*Dd*fd*(12*r**2 - 7*r + 1) - 25*Ddd*f*(4*r**2 - 2*r + 1)) + 150*Dd**2*f**2*r*(1 - 2*r))))/(1386*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct*k1*k2*(792*D1**2*K*bd1**2*f*r + 264*D1**2*K*bd1*f**2*r**2 - 1320*D1**2*K*bd1*f*fd*r**2 + 660*D1**2*K*bd1*f*fd*r - 330*D1**2*K*bdd1*f**2*r**2 - 330*D1**2*bd1**2*f**2*r - 396*D1**2*bd1**2*f*r - 1848*D1**2*bd1**2*g2*r**2 + 1848*D1**2*bd1**2*g2*r - 792*D1**2*bd1*bd2*f*r**2 + 792*D1**2*bd1*bd2*f*r - 115*D1**2*bd1*f**3*r**2 + 840*D1**2*bd1*f**2*fd*r**2 - 280*D1**2*bd1*f**2*fd*r - 132*D1**2*bd1*f**2*r**2 + 660*D1**2*bd1*f*fd*r**2 - 330*D1**2*bd1*f*fd*r + 1320*D1**2*bd1*f*g2*r - 660*D1**2*bd1*f*g2 - 1584*D1**2*bd1*f*gd2*r + 264*D1**2*bd2*f**2*r**2 - 1320*D1**2*bd2*f*fd*r**2 + 660*D1**2*bd2*f*fd*r + 140*D1**2*bdd1*f**3*r**2 + 165*D1**2*bdd1*f**2*r**2 - 1584*D1**2*bdd1*f*g2*r + 792*D1**2*bdd1*f*g2 - 330*D1**2*bdd2*f**2*r**2 - 528*D1**2*f**2*gd2*r**2 + 660*D1**2*f**2*gdd2*r**2 - 1056*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2 + 2640*D1**2*f*fd*gd2*r**2 - 1320*D1**2*f*fd*gd2*r + 1320*D1**2*f*fdd*g2*r**2 - 1320*D1**2*f*fdd*g2*r + 660*D1**2*f*fdd*g2 + 1320*D1**2*fd**2*g2*r**2 - 1320*D1**2*fd**2*g2*r - 2640*D1*Dd*K*bd1*f**2*r**2 + 660*D1*Dd*K*bd1*f**2*r + 1120*D1*Dd*bd1*f**3*r**2 - 280*D1*Dd*bd1*f**3*r + 1320*D1*Dd*bd1*f**2*r**2 - 330*D1*Dd*bd1*f**2*r - 6336*D1*Dd*bd1*f*g2*r + 1584*D1*Dd*bd1*f*g2 - 2640*D1*Dd*bd2*f**2*r**2 + 660*D1*Dd*bd2*f**2*r - 2112*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2 + 5280*D1*Dd*f**2*gd2*r**2 - 1320*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f*fd*g2*r**2 - 7920*D1*Dd*f*fd*g2*r + 1320*D1*Dd*f*fd*g2 + 2640*D1*Ddd*f**2*g2*r**2 - 1320*D1*Ddd*f**2*g2*r + 660*D1*Ddd*f**2*g2 + 7920*Dd**2*f**2*g2*r**2 - 3960*Dd**2*f**2*g2*r + 33*b1**3*(D1**2*r**2*(5*fd - 6*fdd) + D1*Dd*(-28*K*(4*r**2 - 2*r + 1) + 5*f*(4*r**2 - 2*r + 1) - 48*fd*r**2 + 12*fd*r + 56*r**2 - 28*r + 14) - D1*Ddd*(-14*K + 6*f + 7)*(4*r**2 - 2*r + 1) - 6*Dd**2*r*(2*r - 1)*(-14*K + 6*f + 7)) + 33*b1**2*(20*D1**2*K*fd*r - 10*D1**2*K*fd - 24*D1**2*K*fdd*r + 12*D1**2*K*fdd - D1**2*bdd1*(-14*K + 6*f + 7)*(3*r**2 - 2*r + 1) - 8*D1**2*f*fd*r + 4*D1**2*f*fd + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd + 10*D1**2*fd**2*r - 10*D1**2*fd*r + 5*D1**2*fd + 12*D1**2*fdd*r - 6*D1**2*fdd + 56*D1**2*gd2*r**2 - 28*D1**2*gdd2*r**2 - 96*D1*Dd*K*fd*r + 24*D1*Dd*K*fd + 40*D1*Dd*f*fd*r - 10*D1*Dd*f*fd + 48*D1*Dd*fd*r - 12*D1*Dd*fd + 224*D1*Dd*g2*r**2 - 112*D1*Dd*g2*r + 56*D1*Dd*g2 - 224*D1*Dd*gd2*r**2 + 56*D1*Dd*gd2*r - 112*D1*Ddd*g2*r**2 + 56*D1*Ddd*g2*r - 28*D1*Ddd*g2 + D1*bd1*(D1*(-28*K*(3*r**2 - 2*r + 1) + 5*f*(3*r**2 - 2*r + 1) - 36*fd*r**2 + 12*fd*r + 42*r**2 - 28*r + 14) - 2*Dd*(-14*K + 6*f + 7)*(12*r**2 - 7*r + 1)) - 336*Dd**2*g2*r**2 + 168*Dd**2*g2*r) + b1*(528*D1**2*K*f*fd*r**2 - 528*D1**2*K*f*fd*r + 264*D1**2*K*f*fd - 660*D1**2*K*f*fdd*r**2 + 660*D1**2*K*f*fdd*r - 330*D1**2*K*f*fdd - 660*D1**2*K*fd**2*r**2 + 660*D1**2*K*fd**2*r + 330*D1**2*b2*fd*r**2 - 396*D1**2*b2*fdd*r**2 - 66*D1**2*bd1**2*r*(3*r - 2)*(-14*K + 6*f + 7) + 330*D1**2*bd2*f*r**2 - 792*D1**2*bd2*fd*r**2 - 33*D1**2*bdd1*(5*f**2*(2*r - 1) - 6*f*(2*K - 1)*(2*r - 1) + 28*g2*(2*r**2 - 2*r + 1)) - 396*D1**2*bdd2*f*r**2 - 345*D1**2*f**2*fd*r**2 + 230*D1**2*f**2*fd*r - 115*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 - 280*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 - 560*D1**2*f*fd**2*r - 264*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r - 132*D1**2*f*fd + 330*D1**2*f*fdd*r**2 - 330*D1**2*f*fdd*r + 165*D1**2*f*fdd + 330*D1**2*fd**2*r**2 - 330*D1**2*fd**2*r - 1320*D1**2*fd*g2*r + 660*D1**2*fd*g2 + 1584*D1**2*fd*gd2*r + 1584*D1**2*fdd*g2*r - 792*D1**2*fdd*g2 + 1056*D1*Dd*K*f**2*r**2 - 528*D1*Dd*K*f**2*r + 264*D1*Dd*K*f**2 - 5280*D1*Dd*K*f*fd*r**2 + 3960*D1*Dd*K*f*fd*r - 660*D1*Dd*K*f*fd + 1320*D1*Dd*b2*f*r**2 - 660*D1*Dd*b2*f*r + 330*D1*Dd*b2*f - 3168*D1*Dd*b2*fd*r**2 + 792*D1*Dd*b2*fd*r - 3168*D1*Dd*bd2*f*r**2 + 792*D1*Dd*bd2*f*r - 460*D1*Dd*f**3*r**2 + 230*D1*Dd*f**3*r - 115*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 - 1960*D1*Dd*f**2*fd*r + 280*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 + 264*D1*Dd*f**2*r - 132*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 - 1980*D1*Dd*f*fd*r + 330*D1*Dd*f*fd + 6336*D1*Dd*fd*g2*r - 1584*D1*Dd*fd*g2 - 1320*D1*Ddd*K*f**2*r**2 + 660*D1*Ddd*K*f**2*r - 330*D1*Ddd*K*f**2 - 1584*D1*Ddd*b2*f*r**2 + 792*D1*Ddd*b2*f*r - 396*D1*Ddd*b2*f + 560*D1*Ddd*f**3*r**2 - 280*D1*Ddd*f**3*r + 140*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 - 330*D1*Ddd*f**2*r + 165*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f**2*(8*r - 4) - 5*f*(2*K - 1)*(2*r - 1) + 4*fd*r*(3 - 6*K) + 56*g2*(2*r**2 - 2*r + 1) + 56*gd2*r*(1 - 2*r)) - 2*Dd*(4*r - 1)*(5*f**2 + f*(6 - 12*K) + 28*g2*(2*r - 1))) - 3960*Dd**2*K*f**2*r**2 + 1980*Dd**2*K*f**2*r - 4752*Dd**2*b2*f*r**2 + 2376*Dd**2*b2*f*r + 1680*Dd**2*f**3*r**2 - 840*Dd**2*f**3*r + 1980*Dd**2*f**2*r**2 - 990*Dd**2*f**2*r) + 66*b2*(-6*D1**2*bdd1*f*(r - 1)**2 + 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 60*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + D1*bd1*(r - 1)*(5*D1*f*(r - 1) - 12*D1*fd*r + 12*Dd*f*(1 - 4*r)) - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(693*d**2*k3**2) + D1**2*Pk3*Pkdd1*ct*k2**3*st**2*(D1*f*r*(22*D1*bd1**2*(6*f + 1)*(r - 1) + D1*bdd1*f*r*(50*f + 11) + bd1*(-D1*f*r*(34*f + 11) + 2*D1*fd*(50*f*(3*r - 1) + 22*r - 11) + 2*Dd*f*(50*f + 11)*(4*r - 1))) - 11*b1**2*(-D1**2*r**2*(12*f*fdd + 12*fd**2 + fd*(-12*f - 9) + fdd) + D1*(Dd*(6*f**2*(4*r**2 - 2*r + 1) + f*(r**2*(36 - 96*fd) + r*(24*fd - 18) + 9) + 2*fd*r*(1 - 4*r)) - Ddd*f*(6*f + 1)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(6*f + 1)*(2*r - 1)) + b1*(11*D1**2*bdd1*f*(6*f + 1)*(2*r**2 - 2*r + 1) - 102*D1**2*f**2*fd*r**2 + 68*D1**2*f**2*fd*r - 34*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 - 100*D1**2*f**2*fdd*r + 50*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 - 200*D1**2*f*fd**2*r - 22*D1**2*f*fd*r**2 + 22*D1**2*f*fd*r - 11*D1**2*f*fd + 22*D1**2*f*fdd*r**2 - 22*D1**2*f*fdd*r + 11*D1**2*f*fdd + 22*D1**2*fd**2*r**2 - 22*D1**2*fd**2*r - 136*D1*Dd*f**3*r**2 + 68*D1*Dd*f**3*r - 34*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 - 700*D1*Dd*f**2*fd*r + 100*D1*Dd*f**2*fd - 44*D1*Dd*f**2*r**2 + 22*D1*Dd*f**2*r - 11*D1*Dd*f**2 + 176*D1*Dd*f*fd*r**2 - 132*D1*Dd*f*fd*r + 22*D1*Dd*f*fd + 200*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r + 50*D1*Ddd*f**3 + 44*D1*Ddd*f**2*r**2 - 22*D1*Ddd*f**2*r + 11*D1*Ddd*f**2 - 11*D1*bd1*(D1*(6*f**2*(2*r**2 - 2*r + 1) - 3*f*(r**2*(16*fd - 6) + r*(6 - 8*fd) - 3) + 2*fd*r*(1 - 2*r)) - 2*Dd*f*(6*f + 1)*(8*r**2 - 6*r + 1)) + 600*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r + 132*Dd**2*f**2*r**2 - 66*Dd**2*f**2*r))/(462*d**2*k1*k3**2) + D1**2*Pk3*Pkdd1*ct*k2*st**2*(D1*f*r*(2*D1*bd1**2*(r - 1) + D1*bdd1*f*r + bd1*(-D1*f*r + D1*fd*(4*r - 2) + 2*Dd*f*(4*r - 1))) + b1**2*(D1**2*r**2*(-9*fd + fdd) + D1*(-9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(4*r - 1) + Ddd*f*(4*r**2 - 2*r + 1)) + 6*Dd**2*f*r*(2*r - 1)) + b1*(D1**2*bdd1*f*(2*r**2 - 2*r + 1) - 2*D1**2*f*fd*r**2 + 2*D1**2*f*fd*r - D1**2*f*fd + 2*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r + D1**2*f*fdd + 2*D1**2*fd**2*r**2 - 2*D1**2*fd**2*r - 4*D1*Dd*f**2*r**2 + 2*D1*Dd*f**2*r - D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 - 12*D1*Dd*f*fd*r + 2*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 - 2*D1*Ddd*f**2*r + D1*Ddd*f**2 + D1*bd1*(-9*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(2*r - 1) + 2*Dd*f*(8*r**2 - 6*r + 1)) + 12*Dd**2*f**2*r**2 - 6*Dd**2*f**2*r))/(42*d**2*k1) + D1**2*Pk3*Pkdd1*ct*k2*(2*D1**2*bd1**2*f*r**2*(5*f + 6) + 2*D1*b1*r*(D1*bd1**2*(6*f + 7)*(3*r - 2) + D1*bdd1*f*r*(5*f + 6) + bd1*(-D1*f*r*(4*f + 5) + 2*D1*fd*(10*f*r - 5*f + 6*r - 6) + 2*Dd*f*(5*f + 6)*(4*r - 1))) + b1**3*(D1**2*r**2*(-5*fd + 6*fdd) - D1*Dd*(5*f*(4*r**2 - 2*r + 1) - r**2*(48*fd - 56) + r*(12*fd - 28) + 14) + D1*Ddd*(6*f + 7)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(6*f + 7)*(2*r - 1)) + b1**2*(D1**2*bdd1*(6*f + 7)*(3*r**2 - 2*r + 1) - 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r - 5*D1**2*fd*r**2 + 10*D1**2*fd*r - 5*D1**2*fd + 6*D1**2*fdd*r**2 - 12*D1**2*fdd*r + 6*D1**2*fdd - 16*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 - 60*D1*Dd*f*fd*r + 10*D1*Dd*f*fd - 20*D1*Dd*f*r**2 + 10*D1*Dd*f*r - 5*D1*Dd*f + 48*D1*Dd*fd*r**2 - 60*D1*Dd*fd*r + 12*D1*Dd*fd + 20*D1*Ddd*f**2*r**2 - 10*D1*Ddd*f**2*r + 5*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 - 12*D1*Ddd*f*r + 6*D1*Ddd*f + D1*bd1*(-D1*(5*f*(3*r**2 - 2*r + 1) - r**2*(36*fd - 42) + r*(12*fd - 28) + 14) + 2*Dd*(6*f + 7)*(12*r**2 - 7*r + 1)) + 60*Dd**2*f**2*r**2 - 30*Dd**2*f**2*r + 72*Dd**2*f*r**2 - 36*Dd**2*f*r))/(21*d**2*k1) - D1**2*Pk3*Pkdd1*f*k1**2*k2**2*st**4*(2*C - 1)*(33*D1**2*bd1*f*(r - 1)**2 + 6*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 6*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 + 14*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + 33*D1*b1*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r)/(231*d**2*k3**4) + D1**2*Pk3*Pkdd1*f*k2**4*st**4*(429*D1*b1**2*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) + 13*b1*(33*D1**2*bd1*f*(2*r**2 - 2*r + 1) + D1**2*(-f*(2*fd - fdd)*(6*r**2 + 2*r - 1) + 4*fd**2*r*(3*r + 1)) - 2*D1*f*(Dd*(f*(8*r**2 - 4*r + 2) - 24*fd*r**2 + 2*fd*r + fd) + Ddd*f*(-4*r**2 + 2*r - 1)) + 12*Dd**2*f**2*r*(2*r - 1)) + f*(13*D1**2*bdd1*f*(2*r**2 - 6*r + 3) - 3*D1**2*(f*(7*fd - 10*fdd)*(4*r**2 - 2*r + 1) + 60*fd**2*r*(1 - 2*r)) - 26*D1*bd1*(D1*f*(2*r**2 - 6*r + 3) + 2*D1*fd*r*(4 - 3*r) + Dd*f*(-8*r**2 + 14*r - 3)) - 3*D1*f*(7*Dd*f*(4*r**2 - 2*r + 1) - 20*Dd*fd*(1 - 4*r)**2 - 10*Ddd*f*(4*r**2 - 2*r + 1)) - 180*Dd**2*f**2*r*(1 - 2*r)))/(3003*d**2*k3**4) + D1**2*Pk3*Pkdd1*f*k2**2*st**4*(2*C - 1)*(33*D1**2*bd1*f*(r - 1)**2 + 6*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 6*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r + 8*D1*Dd*f**2*r**2 - 4*D1*Dd*f**2*r + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 + 14*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + 33*D1*b1*(2*D1*fd*r**2 + Dd*f*(4*r**2 - 2*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r)/(231*d**2*k3**2) - D1**2*Pk3*Pkdd1*k1**4*st**2*(2*C - 1)*(66*D1**2*b1*f*fd*r**2 - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*fd**2*r**2 - 33*D1**2*bdd1*f**2*(r - 1)**2 + 51*D1**2*f**2*fd*r**2 - 34*D1**2*f**2*fd*r + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 + 50*D1**2*f**2*fdd*r - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 + 100*D1**2*f*fd**2*r + 132*D1*Dd*b1*f**2*r**2 - 66*D1*Dd*b1*f**2*r + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 + 132*D1*Dd*b1*f*fd*r + 68*D1*Dd*f**3*r**2 - 34*D1*Dd*f**3*r + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 + 350*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 + 66*D1*Ddd*b1*f**2*r - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 + 50*D1*Ddd*f**3*r - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(r - 1)*(D1*f*(r - 1) - 4*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 396*Dd**2*b1*f**2*r**2 + 198*Dd**2*b1*f**2*r - 300*Dd**2*f**3*r**2 + 150*Dd**2*f**3*r)/(1386*d**2*k3**4) + D1**2*Pk3*Pkdd1*k1**4*(-5*D1**2*K*b1**2*fd*r**2 + 6*D1**2*K*b1**2*fdd*r**2 - 8*D1**2*K*b1*f*fd*r**2 + 8*D1**2*K*b1*f*fd*r - 4*D1**2*K*b1*f*fd + 10*D1**2*K*b1*f*fdd*r**2 - 10*D1**2*K*b1*f*fdd*r + 5*D1**2*K*b1*f*fdd + 10*D1**2*K*b1*fd**2*r**2 - 10*D1**2*K*b1*fd**2*r + 12*D1**2*K*bd1**2*f*r*(r - 1) + 10*D1**2*b1*f*gd2*r**2 - 12*D1**2*b1*f*gdd2*r**2 + 10*D1**2*b1*fd*g2*r**2 - 24*D1**2*b1*fd*gd2*r**2 - 12*D1**2*b1*fdd*g2*r**2 + D1**2*bdd1*f*(6*K*b1*(2*r**2 - 2*r + 1) + 5*K*f*r**2 - 12*g2*(r - 1)**2) + 8*D1**2*f**2*gd2*r**2 - 10*D1**2*f**2*gdd2*r**2 + 16*D1**2*f*fd*g2*r**2 - 16*D1**2*f*fd*g2*r + 8*D1**2*f*fd*g2 - 40*D1**2*f*fd*gd2*r**2 + 20*D1**2*f*fd*gd2*r - 20*D1**2*f*fdd*g2*r**2 + 20*D1**2*f*fdd*g2*r - 10*D1**2*f*fdd*g2 - 20*D1**2*fd**2*g2*r**2 + 20*D1**2*fd**2*g2*r - 20*D1*Dd*K*b1**2*f*r**2 + 10*D1*Dd*K*b1**2*f*r - 5*D1*Dd*K*b1**2*f + 48*D1*Dd*K*b1**2*fd*r**2 - 12*D1*Dd*K*b1**2*fd*r - 16*D1*Dd*K*b1*f**2*r**2 + 8*D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2 + 80*D1*Dd*K*b1*f*fd*r**2 - 60*D1*Dd*K*b1*f*fd*r + 10*D1*Dd*K*b1*f*fd + 40*D1*Dd*b1*f*g2*r**2 - 20*D1*Dd*b1*f*g2*r + 10*D1*Dd*b1*f*g2 - 96*D1*Dd*b1*f*gd2*r**2 + 24*D1*Dd*b1*f*gd2*r - 96*D1*Dd*b1*fd*g2*r**2 + 24*D1*Dd*b1*fd*g2*r + 32*D1*Dd*f**2*g2*r**2 - 16*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2 - 80*D1*Dd*f**2*gd2*r**2 + 20*D1*Dd*f**2*gd2*r - 160*D1*Dd*f*fd*g2*r**2 + 120*D1*Dd*f*fd*g2*r - 20*D1*Dd*f*fd*g2 + 24*D1*Ddd*K*b1**2*f*r**2 - 12*D1*Ddd*K*b1**2*f*r + 6*D1*Ddd*K*b1**2*f + 20*D1*Ddd*K*b1*f**2*r**2 - 10*D1*Ddd*K*b1*f**2*r + 5*D1*Ddd*K*b1*f**2 - 48*D1*Ddd*b1*f*g2*r**2 + 24*D1*Ddd*b1*f*g2*r - 12*D1*Ddd*b1*f*g2 - 40*D1*Ddd*f**2*g2*r**2 + 20*D1*Ddd*f**2*g2*r - 10*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-4*K*f**2*r**2 + f*(-5*K*b1*(2*r**2 - 2*r + 1) + 10*K*fd*r*(2*r - 1) + 10*g2*(r - 1)**2 - 24*gd2*r*(r - 1)) - 12*fd*r*(K*b1*(1 - 2*r) + 2*g2*(r - 1))) + 2*Dd*f*(4*r - 1)*(6*K*b1*(2*r - 1) + 5*K*f*r - 12*g2*(r - 1))) + 72*Dd**2*K*b1**2*f*r**2 - 36*Dd**2*K*b1**2*f*r + 60*Dd**2*K*b1*f**2*r**2 - 30*Dd**2*K*b1*f**2*r - 144*Dd**2*b1*f*g2*r**2 + 72*Dd**2*b1*f*g2*r - 120*Dd**2*f**2*g2*r**2 + 60*Dd**2*f**2*g2*r)/(21*d**2*k3**4) + D1**2*Pk3*Pkdd1*k1**2*k2**2*st**2*(429*D1**2*K*bdd1*f**2*r**2 - 858*D1**2*bd1**2*f*r*(-K + 3*f)*(r - 1) - 650*D1**2*bdd1*f**3*r**2 - 650*D1**2*bdd1*f**3*r + 325*D1**2*bdd1*f**3 - 858*D1**2*bdd1*f*g2*r**2 + 1716*D1**2*bdd1*f*g2*r - 858*D1**2*bdd1*f*g2 - 660*D1**2*f**3*fd*r**2 + 330*D1**2*f**3*fd*r - 165*D1**2*f**3*fd + 980*D1**2*f**3*fdd*r**2 - 490*D1**2*f**3*fdd*r + 245*D1**2*f**3*fdd + 2940*D1**2*f**2*fd**2*r**2 - 1470*D1**2*f**2*fd**2*r + 858*D1**2*f**2*gd2*r**2 - 858*D1**2*f**2*gdd2*r**2 + 1716*D1**2*f*fd*g2*r**2 - 1716*D1**2*f*fd*g2*r + 858*D1**2*f*fd*g2 - 3432*D1**2*f*fd*gd2*r**2 + 1716*D1**2*f*fd*gd2*r - 1716*D1**2*f*fdd*g2*r**2 + 1716*D1**2*f*fdd*g2*r - 858*D1**2*f*fdd*g2 - 1716*D1**2*fd**2*g2*r**2 + 1716*D1**2*fd**2*g2*r - 660*D1*Dd*f**4*r**2 + 330*D1*Dd*f**4*r - 165*D1*Dd*f**4 + 7840*D1*Dd*f**3*fd*r**2 - 3920*D1*Dd*f**3*fd*r + 490*D1*Dd*f**3*fd + 3432*D1*Dd*f**2*g2*r**2 - 1716*D1*Dd*f**2*g2*r + 858*D1*Dd*f**2*g2 - 6864*D1*Dd*f**2*gd2*r**2 + 1716*D1*Dd*f**2*gd2*r - 13728*D1*Dd*f*fd*g2*r**2 + 10296*D1*Dd*f*fd*g2*r - 1716*D1*Dd*f*fd*g2 + 980*D1*Ddd*f**4*r**2 - 490*D1*Ddd*f**4*r + 245*D1*Ddd*f**4 - 3432*D1*Ddd*f**2*g2*r**2 + 1716*D1*Ddd*f**2*g2*r - 858*D1*Ddd*f**2*g2 + 13*D1*bd1*(D1*(17*f**3*(2*r**2 + 2*r - 1) - 3*f**2*r**2*(11*K + 100*fd) + 66*f*(K*fd*r*(2*r - 1) + 9*g2*(r - 1)**2 - 2*gd2*r*(r - 1)) - 132*fd*g2*r*(r - 1)) - 2*Dd*f*(4*r - 1)*(-33*K*f*r + 25*f**2*(2*r + 1) + 66*g2*(r - 1))) + 2940*Dd**2*f**4*r**2 - 1470*Dd**2*f**4*r - 10296*Dd**2*f**2*g2*r**2 + 5148*Dd**2*f**2*g2*r + 429*b1**2*(D1**2*r**2*(-9*K*fd + K*fdd + 6*f*(fd - fdd) - 6*fd**2) + D1*(Dd*(2*K*fd*r*(4*r - 1) + 3*f**2*(4*r**2 - 2*r + 1) - 3*f*(3*K*(4*r**2 - 2*r + 1) + 4*fd*r*(4*r - 1))) - Ddd*f*(-K + 3*f)*(4*r**2 - 2*r + 1)) - 6*Dd**2*f*r*(-K + 3*f)*(2*r - 1)) + 13*b1*(-66*D1**2*K*f*fd*r**2 + 66*D1**2*K*f*fd*r - 33*D1**2*K*f*fd + 66*D1**2*K*f*fdd*r**2 - 66*D1**2*K*f*fdd*r + 33*D1**2*K*f*fdd + 66*D1**2*K*fd**2*r**2 - 66*D1**2*K*fd**2*r - 33*D1**2*bdd1*f*(-K + 3*f)*(2*r**2 - 2*r + 1) + 102*D1**2*f**2*fd*r**2 - 102*D1**2*f**2*fd*r + 51*D1**2*f**2*fd - 150*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd - 300*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r + 594*D1**2*f*gd2*r**2 - 66*D1**2*f*gdd2*r**2 + 594*D1**2*fd*g2*r**2 - 132*D1**2*fd*gd2*r**2 - 66*D1**2*fdd*g2*r**2 - 132*D1*Dd*K*f**2*r**2 + 66*D1*Dd*K*f**2*r - 33*D1*Dd*K*f**2 + 528*D1*Dd*K*f*fd*r**2 - 396*D1*Dd*K*f*fd*r + 66*D1*Dd*K*f*fd + 136*D1*Dd*f**3*r**2 - 68*D1*Dd*f**3*r + 34*D1*Dd*f**3 - 1200*D1*Dd*f**2*fd*r**2 + 900*D1*Dd*f**2*fd*r - 150*D1*Dd*f**2*fd + 2376*D1*Dd*f*g2*r**2 - 1188*D1*Dd*f*g2*r + 594*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r**2 + 132*D1*Dd*f*gd2*r - 528*D1*Dd*fd*g2*r**2 + 132*D1*Dd*fd*g2*r + 132*D1*Ddd*K*f**2*r**2 - 66*D1*Ddd*K*f**2*r + 33*D1*Ddd*K*f**2 - 200*D1*Ddd*f**3*r**2 + 100*D1*Ddd*f**3*r - 50*D1*Ddd*f**3 - 264*D1*Ddd*f*g2*r**2 + 132*D1*Ddd*f*g2*r - 66*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(2*K*fd*r*(2*r - 1) + f**2*(6*r**2 - 6*r + 3) - 3*f*(K*(6*r**2 - 6*r + 3) + 4*fd*r*(2*r - 1))) - 2*Dd*f*(-K + 3*f)*(8*r**2 - 6*r + 1)) + 396*Dd**2*K*f**2*r**2 - 198*Dd**2*K*f**2*r - 600*Dd**2*f**3*r**2 + 300*Dd**2*f**3*r - 792*Dd**2*f*g2*r**2 + 396*Dd**2*f*g2*r))/(18018*d**2*k3**4) - D1**2*Pk3*Pkdd1*k1**2*st**2*(2*C - 1)*(33*D1*b1*(-D1*bdd1*f*(2*r**2 - 2*r + 1) - 2*D1*f*fd*r + D1*f*fd + 2*D1*f*fdd*r - D1*f*fdd + 2*D1*fd**2*r + 8*Dd*f*fd*r - 2*Dd*f*fd + bd1*(9*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 2*r) - 2*Dd*f*(8*r**2 - 6*r + 1))) + 33*b1**2*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) + f*(-66*D1**2*bd1**2*r*(r - 1) + 33*D1**2*bdd1*f*(1 - 2*r) - 51*D1**2*f*fd*r**2 + 34*D1**2*f*fd*r - 17*D1**2*f*fd + 75*D1**2*f*fdd*r**2 - 50*D1**2*f*fdd*r + 25*D1**2*f*fdd + 150*D1**2*fd**2*r**2 - 100*D1**2*fd**2*r - 68*D1*Dd*f**2*r**2 + 34*D1*Dd*f**2*r - 17*D1*Dd*f**2 + 600*D1*Dd*f*fd*r**2 - 350*D1*Dd*f*fd*r + 50*D1*Dd*f*fd + 100*D1*Ddd*f**2*r**2 - 50*D1*Ddd*f**2*r + 25*D1*Ddd*f**2 + 33*D1*bd1*(-D1*(-2*f*r + f + 2*fd*r) + 2*Dd*f*(1 - 4*r)) + 300*Dd**2*f**2*r**2 - 150*Dd**2*f**2*r))/(1386*d**2*k3**2) + D1**2*Pk3*Pkdd1*k1**2*(12*D1**2*K*bd1**2*f*r + 4*D1**2*K*bd1*f**2*r**2 - 20*D1**2*K*bd1*f*fd*r**2 + 10*D1**2*K*bd1*f*fd*r - 5*D1**2*K*bdd1*f**2*r**2 - 28*D1**2*bd1**2*g2*r**2 + 28*D1**2*bd1**2*g2*r - 12*D1**2*bd1*bd2*f*r**2 + 12*D1**2*bd1*bd2*f*r + 20*D1**2*bd1*f*g2*r - 10*D1**2*bd1*f*g2 - 24*D1**2*bd1*f*gd2*r + 4*D1**2*bd2*f**2*r**2 - 20*D1**2*bd2*f*fd*r**2 + 10*D1**2*bd2*f*fd*r - 24*D1**2*bdd1*f*g2*r + 12*D1**2*bdd1*f*g2 - 5*D1**2*bdd2*f**2*r**2 - 8*D1**2*f**2*gd2*r**2 + 10*D1**2*f**2*gdd2*r**2 - 16*D1**2*f*fd*g2*r**2 + 16*D1**2*f*fd*g2*r - 8*D1**2*f*fd*g2 + 40*D1**2*f*fd*gd2*r**2 - 20*D1**2*f*fd*gd2*r + 20*D1**2*f*fdd*g2*r**2 - 20*D1**2*f*fdd*g2*r + 10*D1**2*f*fdd*g2 + 20*D1**2*fd**2*g2*r**2 - 20*D1**2*fd**2*g2*r - 40*D1*Dd*K*bd1*f**2*r**2 + 10*D1*Dd*K*bd1*f**2*r - 96*D1*Dd*bd1*f*g2*r + 24*D1*Dd*bd1*f*g2 - 40*D1*Dd*bd2*f**2*r**2 + 10*D1*Dd*bd2*f**2*r - 32*D1*Dd*f**2*g2*r**2 + 16*D1*Dd*f**2*g2*r - 8*D1*Dd*f**2*g2 + 80*D1*Dd*f**2*gd2*r**2 - 20*D1*Dd*f**2*gd2*r + 160*D1*Dd*f*fd*g2*r**2 - 120*D1*Dd*f*fd*g2*r + 20*D1*Dd*f*fd*g2 + 40*D1*Ddd*f**2*g2*r**2 - 20*D1*Ddd*f**2*g2*r + 10*D1*Ddd*f**2*g2 + 120*Dd**2*f**2*g2*r**2 - 60*Dd**2*f**2*g2*r - 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(1 - 2*r)) + b1**2*(D1**2*(-14*K*bd1*(3*r**2 - 2*r + 1) + 7*K*bdd1*(3*r**2 - 2*r + 1) + 10*K*fd*r - 5*K*fd - 12*K*fdd*r + 6*K*fdd + 28*gd2*r**2 - 14*gdd2*r**2) + 2*D1*(14*Dd*g2*(4*r**2 - 2*r + 1) + Dd*(4*r - 1)*(7*K*bd1*(3*r - 1) - 6*K*fd - 14*gd2*r) - 7*Ddd*g2*(4*r**2 - 2*r + 1)) + 84*Dd**2*g2*r*(1 - 2*r)) + b1*(14*D1**2*K*bd1**2*r*(3*r - 2) + 8*D1**2*K*f*fd*r**2 - 8*D1**2*K*f*fd*r + 4*D1**2*K*f*fd - 10*D1**2*K*f*fdd*r**2 + 10*D1**2*K*f*fdd*r - 5*D1**2*K*f*fdd - 10*D1**2*K*fd**2*r**2 + 10*D1**2*K*fd**2*r + 5*D1**2*bd2*f*r**2 - 12*D1**2*bd2*fd*r**2 - 2*D1**2*bdd1*(3*K*f*(1 - 2*r) + 7*g2*(2*r**2 - 2*r + 1)) - 6*D1**2*bdd2*f*r**2 - 20*D1**2*fd*g2*r + 10*D1**2*fd*g2 + 24*D1**2*fd*gd2*r + 24*D1**2*fdd*g2*r - 12*D1**2*fdd*g2 + 16*D1*Dd*K*f**2*r**2 - 8*D1*Dd*K*f**2*r + 4*D1*Dd*K*f**2 - 80*D1*Dd*K*f*fd*r**2 + 60*D1*Dd*K*f*fd*r - 10*D1*Dd*K*f*fd - 48*D1*Dd*bd2*f*r**2 + 12*D1*Dd*bd2*f*r + 96*D1*Dd*fd*g2*r - 24*D1*Dd*fd*g2 - 20*D1*Ddd*K*f**2*r**2 + 10*D1*Ddd*K*f**2*r - 5*D1*Ddd*K*f**2 + D1*bd1*(D1*(5*K*f*(1 - 2*r) + 28*g2*(2*r**2 - 2*r + 1) - 4*r*(3*K*fd + 14*gd2*r - 7*gd2)) - 4*Dd*(4*r - 1)*(-3*K*f + 7*g2*(2*r - 1))) - 60*Dd**2*K*f**2*r**2 + 30*Dd**2*K*f**2*r) + b2*(5*D1**2*b1*fd*r**2 - 6*D1**2*b1*fdd*r**2 - 6*D1**2*bdd1*f*(r - 1)**2 + 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r + 20*D1*Dd*b1*f*r**2 - 10*D1*Dd*b1*f*r + 5*D1*Dd*b1*f - 48*D1*Dd*b1*fd*r**2 + 12*D1*Dd*b1*fd*r + 16*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 + 60*D1*Dd*f*fd*r - 10*D1*Dd*f*fd - 24*D1*Ddd*b1*f*r**2 + 12*D1*Ddd*b1*f*r - 6*D1*Ddd*b1*f - 20*D1*Ddd*f**2*r**2 + 10*D1*Ddd*f**2*r - 5*D1*Ddd*f**2 + D1*bd1*(r - 1)*(5*D1*f*(r - 1) - 12*D1*fd*r + 12*Dd*f*(1 - 4*r)) - 72*Dd**2*b1*f*r**2 + 36*Dd**2*b1*f*r - 60*Dd**2*f**2*r**2 + 30*Dd**2*f**2*r))/(21*d**2*k3**2) + D1**2*Pk3*Pkdd1*k2**2*st**2*(-22*D1**2*K*bd1**2*f*r**2 + 22*D1**2*K*bd1**2*f*r + 11*D1**2*K*bd1*f**2*r**2 - 44*D1**2*K*bd1*f*fd*r**2 + 22*D1**2*K*bd1*f*fd*r - 11*D1**2*K*bdd1*f**2*r**2 + 44*D1**2*bd1**2*f**2*r**2 - 66*D1**2*bd1**2*f**2*r - 22*D1**2*bd1*bd2*f*r**2 + 22*D1**2*bd1*bd2*f*r - 17*D1**2*bd1*f**3*r**2 + 150*D1**2*bd1*f**2*fd*r**2 - 50*D1**2*bd1*f**2*fd*r - 198*D1**2*bd1*f*g2*r**2 + 396*D1**2*bd1*f*g2*r - 198*D1**2*bd1*f*g2 + 44*D1**2*bd1*f*gd2*r**2 - 44*D1**2*bd1*f*gd2*r + 44*D1**2*bd1*fd*g2*r**2 - 44*D1**2*bd1*fd*g2*r + 11*D1**2*bd2*f**2*r**2 - 44*D1**2*bd2*f*fd*r**2 + 22*D1**2*bd2*f*fd*r + 25*D1**2*bdd1*f**3*r**2 + 22*D1**2*bdd1*f*g2*r**2 - 44*D1**2*bdd1*f*g2*r + 22*D1**2*bdd1*f*g2 - 11*D1**2*bdd2*f**2*r**2 - 22*D1**2*f**2*gd2*r**2 + 22*D1**2*f**2*gdd2*r**2 - 44*D1**2*f*fd*g2*r**2 + 44*D1**2*f*fd*g2*r - 22*D1**2*f*fd*g2 + 88*D1**2*f*fd*gd2*r**2 - 44*D1**2*f*fd*gd2*r + 44*D1**2*f*fdd*g2*r**2 - 44*D1**2*f*fdd*g2*r + 22*D1**2*f*fdd*g2 + 44*D1**2*fd**2*g2*r**2 - 44*D1**2*fd**2*g2*r - 88*D1*Dd*K*bd1*f**2*r**2 + 22*D1*Dd*K*bd1*f**2*r + 200*D1*Dd*bd1*f**3*r**2 - 50*D1*Dd*bd1*f**3*r + 176*D1*Dd*bd1*f*g2*r**2 - 220*D1*Dd*bd1*f*g2*r + 44*D1*Dd*bd1*f*g2 - 88*D1*Dd*bd2*f**2*r**2 + 22*D1*Dd*bd2*f**2*r - 88*D1*Dd*f**2*g2*r**2 + 44*D1*Dd*f**2*g2*r - 22*D1*Dd*f**2*g2 + 176*D1*Dd*f**2*gd2*r**2 - 44*D1*Dd*f**2*gd2*r + 352*D1*Dd*f*fd*g2*r**2 - 264*D1*Dd*f*fd*g2*r + 44*D1*Dd*f*fd*g2 + 88*D1*Ddd*f**2*g2*r**2 - 44*D1*Ddd*f**2*g2*r + 22*D1*Ddd*f**2*g2 + 264*Dd**2*f**2*g2*r**2 - 132*Dd**2*f**2*g2*r + 11*b1**3*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) + 11*b1**2*(9*D1**2*K*fd*r**2 - D1**2*K*fdd*r**2 - D1**2*bdd1*f*(3*r**2 - 2*r + 1) - 4*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd + 4*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd + 4*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r + 36*D1*Dd*K*f*r**2 - 18*D1*Dd*K*f*r + 9*D1*Dd*K*f - 8*D1*Dd*K*fd*r**2 + 2*D1*Dd*K*fd*r - 8*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r - 2*D1*Dd*f**2 + 32*D1*Dd*f*fd*r**2 - 2*D1*Dd*f*fd - 4*D1*Ddd*K*f*r**2 + 2*D1*Ddd*K*f*r - D1*Ddd*K*f + 8*D1*Ddd*f**2*r**2 - 4*D1*Ddd*f**2*r + 2*D1*Ddd*f**2 + D1*bd1*(9*D1*f*(3*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 3*r) - 2*Dd*f*(12*r**2 - 7*r + 1)) - 12*Dd**2*K*f*r**2 + 6*Dd**2*K*f*r + 24*Dd**2*f**2*r**2 - 12*Dd**2*f**2*r) + b1*(-22*D1**2*K*bdd1*f*r**2 + 22*D1**2*K*bdd1*f*r - 11*D1**2*K*bdd1*f + 22*D1**2*K*f*fd*r**2 - 22*D1**2*K*f*fd*r + 11*D1**2*K*f*fd - 22*D1**2*K*f*fdd*r**2 + 22*D1**2*K*f*fdd*r - 11*D1**2*K*f*fdd - 22*D1**2*K*fd**2*r**2 + 22*D1**2*K*fd**2*r + 22*D1**2*bd1**2*f*r*(2 - 3*r) + 99*D1**2*bd2*f*r**2 - 22*D1**2*bd2*fd*r**2 + 44*D1**2*bdd1*f**2*r**2 - 66*D1**2*bdd1*f**2*r + 33*D1**2*bdd1*f**2 - 11*D1**2*bdd2*f*r**2 - 51*D1**2*f**2*fd*r**2 + 34*D1**2*f**2*fd*r - 17*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 - 50*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 - 100*D1**2*f*fd**2*r - 198*D1**2*f*gd2*r**2 + 22*D1**2*f*gdd2*r**2 - 198*D1**2*fd*g2*r**2 + 44*D1**2*fd*gd2*r**2 + 22*D1**2*fdd*g2*r**2 + 44*D1*Dd*K*f**2*r**2 - 22*D1*Dd*K*f**2*r + 11*D1*Dd*K*f**2 - 176*D1*Dd*K*f*fd*r**2 + 132*D1*Dd*K*f*fd*r - 22*D1*Dd*K*f*fd - 88*D1*Dd*bd2*f*r**2 + 22*D1*Dd*bd2*f*r - 68*D1*Dd*f**3*r**2 + 34*D1*Dd*f**3*r - 17*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 - 350*D1*Dd*f**2*fd*r + 50*D1*Dd*f**2*fd - 792*D1*Dd*f*g2*r**2 + 396*D1*Dd*f*g2*r - 198*D1*Dd*f*g2 + 176*D1*Dd*f*gd2*r**2 - 44*D1*Dd*f*gd2*r + 176*D1*Dd*fd*g2*r**2 - 44*D1*Dd*fd*g2*r - 44*D1*Ddd*K*f**2*r**2 + 22*D1*Ddd*K*f**2*r - 11*D1*Ddd*K*f**2 + 100*D1*Ddd*f**3*r**2 - 50*D1*Ddd*f**3*r + 25*D1*Ddd*f**3 + 88*D1*Ddd*f*g2*r**2 - 44*D1*Ddd*f*g2*r + 22*D1*Ddd*f*g2 - 11*D1*bd1*(D1*(-9*K*f*(2*r**2 - 2*r + 1) + 2*K*fd*r*(2*r - 1) + f**2*(4*r**2 - 6*r + 3) + 8*f*fd*r*(1 - 2*r)) - 2*Dd*f*(4*r - 1)*(-2*K*r + K + f*(4*r - 3))) - 132*Dd**2*K*f**2*r**2 + 66*Dd**2*K*f**2*r + 300*Dd**2*f**3*r**2 - 150*Dd**2*f**3*r + 264*Dd**2*f*g2*r**2 - 132*Dd**2*f*g2*r + 11*b2*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r))) + 11*b2*(-D1**2*bdd1*f*(r - 1)**2 + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 2*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 2*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 + 12*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + D1*bd1*(r - 1)*(9*D1*f*(r - 1) - 2*D1*fd*r + 2*Dd*f*(1 - 4*r)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r))/(462*d**2*k3**2) + D1**2*Pk3*Pkdd1*st**2*(2*C - 1)*(D1*f*r*(-2*D1*bd1**2*(r - 1) - D1*bdd1*f*r + bd1*(D1*f*r + D1*fd*(2 - 4*r) + Dd*f*(2 - 8*r))) + b1**2*(D1**2*r**2*(9*fd - fdd) + D1*(9*Dd*f*(4*r**2 - 2*r + 1) + 2*Dd*fd*r*(1 - 4*r) + Ddd*f*(-4*r**2 + 2*r - 1)) + 6*Dd**2*f*r*(1 - 2*r)) + b1*(-D1**2*bdd1*f*(2*r**2 - 2*r + 1) + 2*D1**2*f*fd*r**2 - 2*D1**2*f*fd*r + D1**2*f*fd - 2*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r - D1**2*f*fdd - 2*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r + 4*D1*Dd*f**2*r**2 - 2*D1*Dd*f**2*r + D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 + 12*D1*Dd*f*fd*r - 2*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 + 2*D1*Ddd*f**2*r - D1*Ddd*f**2 + D1*bd1*(9*D1*f*(2*r**2 - 2*r + 1) + 2*D1*fd*r*(1 - 2*r) - 2*Dd*f*(8*r**2 - 6*r + 1)) - 12*Dd**2*f**2*r**2 + 6*Dd**2*f**2*r))/(42*d**2) + D1**2*Pk3*Pkdd1*(D1*r*(-14*D1*b2*bd1**2*(r - 1) - 6*D1*b2*bdd1*f*r + 4*D1*bd1**2*(-3*K*f*r + 7*g2*(r - 1)) + 12*D1*bdd1*f*g2*r + b2*bd1*(5*D1*f*r - 12*D1*fd*(r - 1) + 12*Dd*f*(1 - 4*r)) - 2*bd1*(D1*f*r*(6*bd2 + 5*g2 - 12*gd2) - 12*D1*fd*g2*(r - 1) + 12*Dd*f*g2*(1 - 4*r))) + 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(1 - 2*r)) + b1**2*(D1**2*(14*K*bd1*(3*r**2 - 2*r + 1) - 7*K*bdd1*(3*r**2 - 2*r + 1) + 5*K*fd*r**2 - 10*K*fd*r + 5*K*fd - 6*K*fdd*r**2 + 12*K*fdd*r - 6*K*fdd + 14*bd2*r**2 - 7*bdd2*r**2 - 28*gd2*r**2 + 14*gdd2*r**2) - D1*Dd*(14*K*bd1*(12*r**2 - 7*r + 1) - 20*K*f*r**2 + 10*K*f*r - 5*K*f + 48*K*fd*r**2 - 60*K*fd*r + 12*K*fd + 56*bd2*r**2 - 14*bd2*r + 28*g2*(4*r**2 - 2*r + 1) - 112*gd2*r**2 + 28*gd2*r) + 2*D1*Ddd*(-3*K*f + 7*g2)*(4*r**2 - 2*r + 1) + 12*Dd**2*r*(2*r - 1)*(-3*K*f + 7*g2) + 7*b2*(D1*(2*Dd - Ddd)*(4*r**2 - 2*r + 1) + 6*Dd**2*r*(1 - 2*r))) + b1*(14*D1**2*K*bd1**2*r*(2 - 3*r) - 12*D1**2*K*bdd1*f*r**2 + 5*D1**2*bd2*f*r**2 - 12*D1**2*bd2*fd*r**2 + 12*D1**2*bd2*fd*r + 28*D1**2*bdd1*g2*r**2 - 28*D1**2*bdd1*g2*r + 14*D1**2*bdd1*g2 - 6*D1**2*bdd2*f*r**2 - 10*D1**2*f*gd2*r**2 + 12*D1**2*f*gdd2*r**2 - 10*D1**2*fd*g2*r**2 + 20*D1**2*fd*g2*r - 10*D1**2*fd*g2 + 24*D1**2*fd*gd2*r**2 - 24*D1**2*fd*gd2*r + 12*D1**2*fdd*g2*r**2 - 24*D1**2*fdd*g2*r + 12*D1**2*fdd*g2 - 48*D1*Dd*bd2*f*r**2 + 12*D1*Dd*bd2*f*r - 40*D1*Dd*f*g2*r**2 + 20*D1*Dd*f*g2*r - 10*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 - 24*D1*Dd*f*gd2*r + 96*D1*Dd*fd*g2*r**2 - 120*D1*Dd*fd*g2*r + 24*D1*Dd*fd*g2 + 48*D1*Ddd*f*g2*r**2 - 24*D1*Ddd*f*g2*r + 12*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(14*g2*(2*r**2 - 2*r + 1) + r*(-5*K*f*r + 12*K*fd*r - 12*K*fd + 14*bd2*r - 7*bd2 - 28*gd2*r + 14*gd2)) + 2*Dd*(4*r - 1)*(6*K*f*r + g2*(7 - 14*r))) + 144*Dd**2*f*g2*r**2 - 72*Dd**2*f*g2*r + b2*(-7*D1**2*bdd1*(2*r**2 - 2*r + 1) + 5*D1**2*fd*r**2 - 10*D1**2*fd*r + 5*D1**2*fd - 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r - 6*D1**2*fdd + 20*D1*Dd*f*r**2 - 10*D1*Dd*f*r + 5*D1*Dd*f - 48*D1*Dd*fd*r**2 + 60*D1*Dd*fd*r - 12*D1*Dd*fd - 24*D1*Ddd*f*r**2 + 12*D1*Ddd*f*r - 6*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 - 2*r + 1) + Dd*(-8*r**2 + 6*r - 1)) - 72*Dd**2*f*r**2 + 36*Dd**2*f*r)))/(21*d**2) - D1**2*Pkd1*Pkd3*ct**7*k2**5*(4*C - 4)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**5) - 10*D1**2*Pkd1*Pkd3*ct**6*f*k2**6*(897*D1**2*b1*f*fd*r**2 + 897*D1**2*b1*f*fd*r*s - 598*D1**2*b1*f*fd*r - 1092*D1**2*b1*f*fdd*r**2 - 1092*D1**2*b1*f*fdd*r*s + 728*D1**2*b1*f*fdd*r - 2184*D1**2*b1*fd**2*r**2 - 2184*D1**2*b1*fd**2*r*s + 1456*D1**2*b1*fd**2*r - 364*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 1064*D1**2*f**2*fd*r**2 + 1064*D1**2*f**2*fd*r*s - 1064*D1**2*f**2*fd*r - 266*D1**2*f**2*fd*s + 266*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r**2 - 1260*D1**2*f**2*fdd*r*s + 1260*D1**2*f**2*fdd*r + 315*D1**2*f**2*fdd*s - 315*D1**2*f**2*fdd - 3780*D1**2*f*fd**2*r**2 - 3780*D1**2*f*fd**2*r*s + 3780*D1**2*f*fd**2*r + 945*D1**2*f*fd**2*s - 630*D1**2*f*fd**2 + 1196*D1*Dd*b1*f**2*r**2 + 1196*D1*Dd*b1*f**2*r*s - 1196*D1*Dd*b1*f**2*r - 299*D1*Dd*b1*f**2*s + 299*D1*Dd*b1*f**2 - 8736*D1*Dd*b1*f*fd*r**2 - 8736*D1*Dd*b1*f*fd*r*s + 7280*D1*Dd*b1*f*fd*r + 1092*D1*Dd*b1*f*fd*s - 728*D1*Dd*b1*f*fd + 1064*D1*Dd*f**3*r**2 + 1064*D1*Dd*f**3*r*s - 1064*D1*Dd*f**3*r - 266*D1*Dd*f**3*s + 266*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r**2 - 10080*D1*Dd*f**2*fd*r*s + 10080*D1*Dd*f**2*fd*r + 2520*D1*Dd*f**2*fd*s - 1890*D1*Dd*f**2*fd - 1456*D1*Ddd*b1*f**2*r**2 - 1456*D1*Ddd*b1*f**2*r*s + 1456*D1*Ddd*b1*f**2*r + 364*D1*Ddd*b1*f**2*s - 364*D1*Ddd*b1*f**2 - 1260*D1*Ddd*f**3*r**2 - 1260*D1*Ddd*f**3*r*s + 1260*D1*Ddd*f**3*r + 315*D1*Ddd*f**3*s - 315*D1*Ddd*f**3 + 13*D1*bd1*f*(D1*(23*f*(r - 1)*(r + s - 1) - 28*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 28*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 4368*Dd**2*b1*f**2*r**2 - 4368*Dd**2*b1*f**2*r*s + 4368*Dd**2*b1*f**2*r + 1092*Dd**2*b1*f**2*s - 728*Dd**2*b1*f**2 - 3780*Dd**2*f**3*r**2 - 3780*Dd**2*f**3*r*s + 3780*Dd**2*f**3*r + 945*Dd**2*f**3*s - 630*Dd**2*f**3)/(9009*d**2*k1*k3**5) - D1**2*Pkd1*Pkd3*ct**6*k1*k2**4*(20*C - 18)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct**6*k2**4*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k1*k3**3) - D1**2*Pkd1*Pkd3*ct**5*k1**2*k2**3*(40*C - 32)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**5) - D1**2*Pkd1*Pkd3*ct**5*k2**5*st**2*(4*C - 4)*(462*D1**2*b1*f*fd*r**2 + 462*D1**2*b1*f*fd*r*s - 231*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 453*D1**2*f**2*fd*r**2 + 453*D1**2*f**2*fd*r*s - 453*D1**2*f**2*fd*r - 151*D1**2*f**2*fd*s + 151*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 375*D1**2*f**2*fdd*r*s + 375*D1**2*f**2*fdd*r + 125*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 750*D1**2*f*fd**2*r*s + 750*D1**2*f*fd**2*r + 250*D1**2*f*fd**2*s - 125*D1**2*f*fd**2 + 924*D1*Dd*b1*f**2*r**2 + 924*D1*Dd*b1*f**2*r*s - 924*D1*Dd*b1*f**2*r - 231*D1*Dd*b1*f**2*s + 231*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 604*D1*Dd*f**3*r**2 + 604*D1*Dd*f**3*r*s - 604*D1*Dd*f**3*r - 151*D1*Dd*f**3*s + 151*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 3000*D1*Dd*f**2*fd*r*s + 3000*D1*Dd*f**2*fd*r + 875*D1*Dd*f**2*fd*s - 625*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 500*D1*Ddd*f**3*r**2 - 500*D1*Ddd*f**3*r*s + 500*D1*Ddd*f**3*r + 125*D1*Ddd*f**3*s - 125*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(7*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1500*Dd**2*f**3*r**2 - 1500*Dd**2*f**3*r*s + 1500*Dd**2*f**3*r + 375*Dd**2*f**3*s - 250*Dd**2*f**3)/(693*d**2*k3**5) + 2*D1**2*Pkd1*Pkd3*ct**5*k2**5*(2145*D1**2*K*bdd1*f**2*r**2 + 2145*D1**2*K*bdd1*f**2*r*s - 2145*D1**2*K*bdd1*f**2*r - 429*D1**2*bd1**2*f*(2*r - 1)*(-6*K + 5*f + 6)*(r + s - 1) + 5460*D1**2*bdd1*f**3*r**2 + 5460*D1**2*bdd1*f**3*r*s - 12740*D1**2*bdd1*f**3*r - 7280*D1**2*bdd1*f**3*s + 7280*D1**2*bdd1*f**3 - 2145*D1**2*bdd1*f**2*r**2 - 2145*D1**2*bdd1*f**2*r*s + 2145*D1**2*bdd1*f**2*r - 5148*D1**2*bdd1*f*g2*r**2 - 5148*D1**2*bdd1*f*g2*r*s + 10296*D1**2*bdd1*f*g2*r + 5148*D1**2*bdd1*f*g2*s - 5148*D1**2*bdd1*f*g2 - 21280*D1**2*f**3*fd*r**2 - 21280*D1**2*f**3*fd*r*s + 21280*D1**2*f**3*fd*r + 5320*D1**2*f**3*fd*s - 5320*D1**2*f**3*fd + 25200*D1**2*f**3*fdd*r**2 + 25200*D1**2*f**3*fdd*r*s - 25200*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s + 6300*D1**2*f**3*fdd + 75600*D1**2*f**2*fd**2*r**2 + 75600*D1**2*f**2*fd**2*r*s - 75600*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s + 12600*D1**2*f**2*fd**2 + 3432*D1**2*f**2*gd2*r**2 + 3432*D1**2*f**2*gd2*r*s - 3432*D1**2*f**2*gd2*r - 4290*D1**2*f**2*gdd2*r**2 - 4290*D1**2*f**2*gdd2*r*s + 4290*D1**2*f**2*gdd2*r + 6864*D1**2*f*fd*g2*r**2 + 6864*D1**2*f*fd*g2*r*s - 6864*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s + 3432*D1**2*f*fd*g2 - 17160*D1**2*f*fd*gd2*r**2 - 17160*D1**2*f*fd*gd2*r*s + 17160*D1**2*f*fd*gd2*r + 4290*D1**2*f*fd*gd2*s - 4290*D1**2*f*fd*gd2 - 8580*D1**2*f*fdd*g2*r**2 - 8580*D1**2*f*fdd*g2*r*s + 8580*D1**2*f*fdd*g2*r + 4290*D1**2*f*fdd*g2*s - 4290*D1**2*f*fdd*g2 - 8580*D1**2*fd**2*g2*r**2 - 8580*D1**2*fd**2*g2*r*s + 8580*D1**2*fd**2*g2*r + 4290*D1**2*fd**2*g2*s - 21280*D1*Dd*f**4*r**2 - 21280*D1*Dd*f**4*r*s + 21280*D1*Dd*f**4*r + 5320*D1*Dd*f**4*s - 5320*D1*Dd*f**4 + 201600*D1*Dd*f**3*fd*r**2 + 201600*D1*Dd*f**3*fd*r*s - 201600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s + 37800*D1*Dd*f**3*fd + 13728*D1*Dd*f**2*g2*r**2 + 13728*D1*Dd*f**2*g2*r*s - 13728*D1*Dd*f**2*g2*r - 3432*D1*Dd*f**2*g2*s + 3432*D1*Dd*f**2*g2 - 34320*D1*Dd*f**2*gd2*r**2 - 34320*D1*Dd*f**2*gd2*r*s + 34320*D1*Dd*f**2*gd2*r + 4290*D1*Dd*f**2*gd2*s - 4290*D1*Dd*f**2*gd2 - 68640*D1*Dd*f*fd*g2*r**2 - 68640*D1*Dd*f*fd*g2*r*s + 68640*D1*Dd*f*fd*g2*r + 25740*D1*Dd*f*fd*g2*s - 17160*D1*Dd*f*fd*g2 + 25200*D1*Ddd*f**4*r**2 + 25200*D1*Ddd*f**4*r*s - 25200*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s + 6300*D1*Ddd*f**4 - 17160*D1*Ddd*f**2*g2*r**2 - 17160*D1*Ddd*f**2*g2*r*s + 17160*D1*Ddd*f**2*g2*r + 4290*D1*Ddd*f**2*g2*s - 4290*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(115*f**3*(3*r - 4)*(r + s - 1) - 4*f**2*(35*fd*(18*r**2 + 2*r*(9*s - 13) - 11*s + 7) + r*(33 - 33*K)*(r + s - 1)) - 33*f*(5*fd*(K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (10*g2*(r - 1) + 12*gd2*(1 - 2*r))*(r + s - 1)) + 396*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-140*f**2*(24*r**2 + 8*r*(3*s - 5) - 19*s + 15) - 165*f*(K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 396*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 75600*Dd**2*f**4*r**2 + 75600*Dd**2*f**4*r*s - 75600*Dd**2*f**4*r - 18900*Dd**2*f**4*s + 12600*Dd**2*f**4 - 51480*Dd**2*f**2*g2*r**2 - 51480*Dd**2*f**2*g2*r*s + 51480*Dd**2*f**2*g2*r + 12870*Dd**2*f**2*g2*s - 8580*Dd**2*f**2*g2 + 429*b1**2*(D1**2*r*(f*(4*fd - 5*fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 5*fd*(K - 1)*(r + s) + 6*fdd*(K - 1)*(r + s)) + D1*(Dd*(4*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*fd*(K - 1)*(8*r**2 + r*(8*s - 4) - s)) - Ddd*f*(-6*K + 5*f + 6)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(-6*K + 5*f + 6)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-264*D1**2*K*f*fd*r**2 - 264*D1**2*K*f*fd*r*s + 264*D1**2*K*f*fd*r + 132*D1**2*K*f*fd*s - 132*D1**2*K*f*fd + 330*D1**2*K*f*fdd*r**2 + 330*D1**2*K*f*fdd*r*s - 330*D1**2*K*f*fdd*r - 165*D1**2*K*f*fdd*s + 165*D1**2*K*f*fdd + 330*D1**2*K*fd**2*r**2 + 330*D1**2*K*fd**2*r*s - 330*D1**2*K*fd**2*r - 165*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(2*r - 1)*(-6*K + 5*f + 6)*(r + s - 1) - 1035*D1**2*f**2*fd*r**2 - 1035*D1**2*f**2*fd*r*s + 575*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 1260*D1**2*f**2*fdd*r*s - 700*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd + 2520*D1**2*f*fd**2*r**2 + 2520*D1**2*f*fd**2*r*s - 1400*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 264*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 264*D1**2*f*fd*r - 132*D1**2*f*fd*s + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 330*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r + 165*D1**2*f*fdd*s - 165*D1**2*f*fdd + 330*D1**2*f*gd2*r**2 + 330*D1**2*f*gd2*r*s - 330*D1**2*f*gd2*r - 396*D1**2*f*gdd2*r**2 - 396*D1**2*f*gdd2*r*s + 396*D1**2*f*gdd2*r - 330*D1**2*fd**2*r**2 - 330*D1**2*fd**2*r*s + 330*D1**2*fd**2*r + 165*D1**2*fd**2*s + 330*D1**2*fd*g2*r**2 + 330*D1**2*fd*g2*r*s - 792*D1**2*fd*gd2*r**2 - 792*D1**2*fd*gd2*r*s + 396*D1**2*fd*gd2*r - 396*D1**2*fdd*g2*r**2 - 396*D1**2*fdd*g2*r*s - 528*D1*Dd*K*f**2*r**2 - 528*D1*Dd*K*f**2*r*s + 528*D1*Dd*K*f**2*r + 132*D1*Dd*K*f**2*s - 132*D1*Dd*K*f**2 + 2640*D1*Dd*K*f*fd*r**2 + 2640*D1*Dd*K*f*fd*r*s - 2640*D1*Dd*K*f*fd*r - 990*D1*Dd*K*f*fd*s + 660*D1*Dd*K*f*fd - 1380*D1*Dd*f**3*r**2 - 1380*D1*Dd*f**3*r*s + 1380*D1*Dd*f**3*r + 345*D1*Dd*f**3*s - 345*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 10080*D1*Dd*f**2*fd*r*s - 7840*D1*Dd*f**2*fd*r - 700*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 528*D1*Dd*f**2*r - 132*D1*Dd*f**2*s + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 2640*D1*Dd*f*fd*r*s + 2640*D1*Dd*f*fd*r + 990*D1*Dd*f*fd*s - 660*D1*Dd*f*fd + 1320*D1*Dd*f*g2*r**2 + 1320*D1*Dd*f*g2*r*s - 1320*D1*Dd*f*g2*r - 330*D1*Dd*f*g2*s + 330*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 3168*D1*Dd*f*gd2*r*s + 3168*D1*Dd*f*gd2*r + 396*D1*Dd*f*gd2*s - 396*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 3168*D1*Dd*fd*g2*r*s + 1584*D1*Dd*fd*g2*r + 396*D1*Dd*fd*g2*s + 660*D1*Ddd*K*f**2*r**2 + 660*D1*Ddd*K*f**2*r*s - 660*D1*Ddd*K*f**2*r - 165*D1*Ddd*K*f**2*s + 165*D1*Ddd*K*f**2 + 1680*D1*Ddd*f**3*r**2 + 1680*D1*Ddd*f**3*r*s - 1680*D1*Ddd*f**3*r - 420*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 - 660*D1*Ddd*f**2*r*s + 660*D1*Ddd*f**2*r + 165*D1*Ddd*f**2*s - 165*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 1584*D1*Ddd*f*g2*r*s + 1584*D1*Ddd*f*g2*r + 396*D1*Ddd*f*g2*s - 396*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(4*f**2*(2*r - 1)*(r + s - 1) - 5*f*(fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + (K - 1)*(2*r - 1)*(r + s - 1)) + 6*fd*(K - 1)*(4*r**2 + r*(4*s - 3) - s)) - Dd*f*(-6*K + 5*f + 6)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1980*Dd**2*K*f**2*r**2 + 1980*Dd**2*K*f**2*r*s - 1980*Dd**2*K*f**2*r - 495*Dd**2*K*f**2*s + 330*Dd**2*K*f**2 + 5040*Dd**2*f**3*r**2 + 5040*Dd**2*f**3*r*s - 5040*Dd**2*f**3*r - 1260*Dd**2*f**3*s + 840*Dd**2*f**3 - 1980*Dd**2*f**2*r**2 - 1980*Dd**2*f**2*r*s + 1980*Dd**2*f**2*r + 495*Dd**2*f**2*s - 330*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 4752*Dd**2*f*g2*r*s + 4752*Dd**2*f*g2*r + 1188*Dd**2*f*g2*s - 792*Dd**2*f*g2))/(9009*d**2*k3**5) - 4*D1**2*Pkd1*Pkd3*ct**5*k2**3*(33*b1**2*(C - 1)*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1*(-8*C*D1**2*f*fd*r - 4*C*D1**2*f*fd*s + 4*C*D1**2*f*fd + 10*C*D1**2*f*fdd*r + 5*C*D1**2*f*fdd*s - 5*C*D1**2*f*fdd + 10*C*D1**2*fd**2*r + 5*C*D1**2*fd**2*s - 5*C*D1**2*fd**2 + 40*C*D1*Dd*f*fd*r + 20*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd - 6*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r + 4*D1**2*f*fd*s - 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r - 5*D1**2*f*fdd*s + 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s - 5*D1**2*fd**2*r - 5*D1**2*fd**2*s + 5*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 10*D1*Dd*f*fd*s + 15*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(C - 1)*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2) - f*(198*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 165*D1**2*bdd1*f*(C*(2*r + s - 1) + r**2 + r*(s - 4) - 2*s + 2) - 33*D1*bd1*(D1*(4*f*(C*(2*r + s - 1) + r**2 + r*(s - 4) - 2*s + 2) - 5*fd*(C*(2*r + s - 1) + 4*r**2 + r*(4*s - 7) - 3*s + 2)) - 5*Dd*f*(4*C*(2*r + s - 1) + 8*r**2 + 4*r*(2*s - 5) - 9*s + 8)) + 5*(C - 2)*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 28*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(23*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 28*fd*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 28*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 28*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2))))/(693*d**2*k3**3) - 5*D1**2*Pkd1*Pkd3*ct**4*f*k2**6*st**2*(3276*D1**2*b1*f*fd*r**2 + 3276*D1**2*b1*f*fd*r*s - 2184*D1**2*b1*f*fd*r - 2925*D1**2*b1*f*fdd*r**2 - 2925*D1**2*b1*f*fdd*r*s + 1950*D1**2*b1*f*fdd*r - 5850*D1**2*b1*fd**2*r**2 - 5850*D1**2*b1*fd**2*r*s + 3900*D1**2*b1*fd**2*r - 975*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 3280*D1**2*f**2*fd*r**2 + 3280*D1**2*f**2*fd*r*s - 3280*D1**2*f**2*fd*r - 820*D1**2*f**2*fd*s + 820*D1**2*f**2*fd - 2940*D1**2*f**2*fdd*r**2 - 2940*D1**2*f**2*fdd*r*s + 2940*D1**2*f**2*fdd*r + 735*D1**2*f**2*fdd*s - 735*D1**2*f**2*fdd - 8820*D1**2*f*fd**2*r**2 - 8820*D1**2*f*fd**2*r*s + 8820*D1**2*f*fd**2*r + 2205*D1**2*f*fd**2*s - 1470*D1**2*f*fd**2 + 4368*D1*Dd*b1*f**2*r**2 + 4368*D1*Dd*b1*f**2*r*s - 4368*D1*Dd*b1*f**2*r - 1092*D1*Dd*b1*f**2*s + 1092*D1*Dd*b1*f**2 - 23400*D1*Dd*b1*f*fd*r**2 - 23400*D1*Dd*b1*f*fd*r*s + 19500*D1*Dd*b1*f*fd*r + 2925*D1*Dd*b1*f*fd*s - 1950*D1*Dd*b1*f*fd + 3280*D1*Dd*f**3*r**2 + 3280*D1*Dd*f**3*r*s - 3280*D1*Dd*f**3*r - 820*D1*Dd*f**3*s + 820*D1*Dd*f**3 - 23520*D1*Dd*f**2*fd*r**2 - 23520*D1*Dd*f**2*fd*r*s + 23520*D1*Dd*f**2*fd*r + 5880*D1*Dd*f**2*fd*s - 4410*D1*Dd*f**2*fd - 3900*D1*Ddd*b1*f**2*r**2 - 3900*D1*Ddd*b1*f**2*r*s + 3900*D1*Ddd*b1*f**2*r + 975*D1*Ddd*b1*f**2*s - 975*D1*Ddd*b1*f**2 - 2940*D1*Ddd*f**3*r**2 - 2940*D1*Ddd*f**3*r*s + 2940*D1*Ddd*f**3*r + 735*D1*Ddd*f**3*s - 735*D1*Ddd*f**3 + 39*D1*bd1*f*(D1*(28*f*(r - 1)*(r + s - 1) - 25*fd*(6*r**2 + 6*r*s - 8*r - 3*s + 2)) - 25*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 11700*Dd**2*b1*f**2*r**2 - 11700*Dd**2*b1*f**2*r*s + 11700*Dd**2*b1*f**2*r + 2925*Dd**2*b1*f**2*s - 1950*Dd**2*b1*f**2 - 8820*Dd**2*f**3*r**2 - 8820*Dd**2*f**3*r*s + 8820*Dd**2*f**3*r + 2205*Dd**2*f**3*s - 1470*Dd**2*f**3)/(9009*d**2*k1*k3**5) - D1**2*Pkd1*Pkd3*ct**4*k1**3*k2**2*(40*C - 28)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct**4*k1*k2**4*st**2*(3432*C*D1**2*b1*f*fd*r**2 + 3432*C*D1**2*b1*f*fd*r*s - 1716*C*D1**2*b1*f*fd*r - 2508*C*D1**2*b1*f*fdd*r**2 - 2508*C*D1**2*b1*f*fdd*r*s + 1254*C*D1**2*b1*f*fdd*r - 2508*C*D1**2*b1*fd**2*r**2 - 2508*C*D1**2*b1*fd**2*r*s + 1254*C*D1**2*b1*fd**2*r + 3324*C*D1**2*f**2*fd*r**2 + 3324*C*D1**2*f**2*fd*r*s - 3324*C*D1**2*f**2*fd*r - 1108*C*D1**2*f**2*fd*s + 1108*C*D1**2*f**2*fd - 2850*C*D1**2*f**2*fdd*r**2 - 2850*C*D1**2*f**2*fdd*r*s + 2850*C*D1**2*f**2*fdd*r + 950*C*D1**2*f**2*fdd*s - 950*C*D1**2*f**2*fdd - 5700*C*D1**2*f*fd**2*r**2 - 5700*C*D1**2*f*fd**2*r*s + 5700*C*D1**2*f*fd**2*r + 1900*C*D1**2*f*fd**2*s - 950*C*D1**2*f*fd**2 + 6864*C*D1*Dd*b1*f**2*r**2 + 6864*C*D1*Dd*b1*f**2*r*s - 6864*C*D1*Dd*b1*f**2*r - 1716*C*D1*Dd*b1*f**2*s + 1716*C*D1*Dd*b1*f**2 - 20064*C*D1*Dd*b1*f*fd*r**2 - 20064*C*D1*Dd*b1*f*fd*r*s + 15048*C*D1*Dd*b1*f*fd*r + 2508*C*D1*Dd*b1*f*fd*s - 1254*C*D1*Dd*b1*f*fd + 4432*C*D1*Dd*f**3*r**2 + 4432*C*D1*Dd*f**3*r*s - 4432*C*D1*Dd*f**3*r - 1108*C*D1*Dd*f**3*s + 1108*C*D1*Dd*f**3 - 22800*C*D1*Dd*f**2*fd*r**2 - 22800*C*D1*Dd*f**2*fd*r*s + 22800*C*D1*Dd*f**2*fd*r + 6650*C*D1*Dd*f**2*fd*s - 4750*C*D1*Dd*f**2*fd - 5016*C*D1*Ddd*b1*f**2*r**2 - 5016*C*D1*Ddd*b1*f**2*r*s + 5016*C*D1*Ddd*b1*f**2*r + 1254*C*D1*Ddd*b1*f**2*s - 1254*C*D1*Ddd*b1*f**2 - 3800*C*D1*Ddd*f**3*r**2 - 3800*C*D1*Ddd*f**3*r*s + 3800*C*D1*Ddd*f**3*r + 950*C*D1*Ddd*f**3*s - 950*C*D1*Ddd*f**3 - 15048*C*Dd**2*b1*f**2*r**2 - 15048*C*Dd**2*b1*f**2*r*s + 15048*C*Dd**2*b1*f**2*r + 3762*C*Dd**2*b1*f**2*s - 2508*C*Dd**2*b1*f**2 - 11400*C*Dd**2*f**3*r**2 - 11400*C*Dd**2*f**3*r*s + 11400*C*Dd**2*f**3*r + 2850*C*Dd**2*f**3*s - 1900*C*Dd**2*f**3 - 2970*D1**2*b1*f*fd*r**2 - 2970*D1**2*b1*f*fd*r*s + 1485*D1**2*b1*f*fd*r + 2178*D1**2*b1*f*fdd*r**2 + 2178*D1**2*b1*f*fdd*r*s - 1089*D1**2*b1*f*fdd*r + 2178*D1**2*b1*fd**2*r**2 + 2178*D1**2*b1*fd**2*r*s - 1089*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(38*C - 33)*(r - 1)*(r + s - 1) - 2871*D1**2*f**2*fd*r**2 - 2871*D1**2*f**2*fd*r*s + 2871*D1**2*f**2*fd*r + 957*D1**2*f**2*fd*s - 957*D1**2*f**2*fd + 2475*D1**2*f**2*fdd*r**2 + 2475*D1**2*f**2*fdd*r*s - 2475*D1**2*f**2*fdd*r - 825*D1**2*f**2*fdd*s + 825*D1**2*f**2*fdd + 4950*D1**2*f*fd**2*r**2 + 4950*D1**2*f*fd**2*r*s - 4950*D1**2*f*fd**2*r - 1650*D1**2*f*fd**2*s + 825*D1**2*f*fd**2 - 5940*D1*Dd*b1*f**2*r**2 - 5940*D1*Dd*b1*f**2*r*s + 5940*D1*Dd*b1*f**2*r + 1485*D1*Dd*b1*f**2*s - 1485*D1*Dd*b1*f**2 + 17424*D1*Dd*b1*f*fd*r**2 + 17424*D1*Dd*b1*f*fd*r*s - 13068*D1*Dd*b1*f*fd*r - 2178*D1*Dd*b1*f*fd*s + 1089*D1*Dd*b1*f*fd - 3828*D1*Dd*f**3*r**2 - 3828*D1*Dd*f**3*r*s + 3828*D1*Dd*f**3*r + 957*D1*Dd*f**3*s - 957*D1*Dd*f**3 + 19800*D1*Dd*f**2*fd*r**2 + 19800*D1*Dd*f**2*fd*r*s - 19800*D1*Dd*f**2*fd*r - 5775*D1*Dd*f**2*fd*s + 4125*D1*Dd*f**2*fd + 4356*D1*Ddd*b1*f**2*r**2 + 4356*D1*Ddd*b1*f**2*r*s - 4356*D1*Ddd*b1*f**2*r - 1089*D1*Ddd*b1*f**2*s + 1089*D1*Ddd*b1*f**2 + 3300*D1*Ddd*f**3*r**2 + 3300*D1*Ddd*f**3*r*s - 3300*D1*Ddd*f**3*r - 825*D1*Ddd*f**3*s + 825*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(52*C - 45)*(r - 1)*(r + s - 1) - fd*(38*C - 33)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(38*C - 33)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 13068*Dd**2*b1*f**2*r**2 + 13068*Dd**2*b1*f**2*r*s - 13068*Dd**2*b1*f**2*r - 3267*Dd**2*b1*f**2*s + 2178*Dd**2*b1*f**2 + 9900*Dd**2*f**3*r**2 + 9900*Dd**2*f**3*r*s - 9900*Dd**2*f**3*r - 2475*Dd**2*f**3*s + 1650*Dd**2*f**3)/(693*d**2*k3**5) + 2*D1**2*Pkd1*Pkd3*ct**4*k1*k2**4*(-858*D1**2*bd1**2*f*(2*r - 1)*(-15*K + 10*f + 12)*(r + s - 1) + 65*D1**2*bdd1*f*(r + s - 1)*(56*f**2*(r - 3) + 33*f*r*(5*K - 4) - 396*g2*(r - 1)) - 30*D1**2*(7*f**3*(38*fd - 45*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) + f**2*(-315*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - r*(572*gd2 - 715*gdd2)*(r + s - 1)) - 143*f*(fd*(g2*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 715*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) - 13*D1*bd1*(D1*(230*f**3*(r - 3)*(r + s - 1) - 4*f**2*(70*fd*(6*r**2 + 6*r*(s - 2) - 7*s + 4) - r*(165*K - 132)*(r + s - 1)) - 165*f*(fd*(5*K - 4)*(4*r**2 + 4*r*(s - 1) - s + 1) + (10*g2*(r - 1) + 12*gd2*(1 - 2*r))*(r + s - 1)) + 1980*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(56*f**2*(8*r**2 + 4*r*(2*s - 5) - 13*s + 10) + 33*f*(5*K - 4)*(8*r**2 + 8*r*(s - 1) - s + 1) - 396*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 30*D1*f*(Dd*(266*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 630*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 143*f*(4*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 1430*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 5*Ddd*f*(63*f**2 - 143*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 150*Dd**2*f**2*(63*f**2 - 143*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 429*b1**2*(D1**2*r*(4*f*(4*fd - 5*fdd)*(2*r + 2*s - 1) - 20*fd**2*(2*r + 2*s - 1) - 5*fd*(5*K - 4)*(r + s) + 6*fdd*(5*K - 4)*(r + s)) + D1*(Dd*(16*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(64*r**2 + 16*r*(4*s - 3) - 8*s + 4) + (5*K - 4)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*fd*(5*K - 4)*(8*r**2 + r*(8*s - 4) - s)) - 2*Ddd*f*(-15*K + 10*f + 12)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 2*Dd**2*f*(-15*K + 10*f + 12)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-1320*D1**2*K*f*fd*r**2 - 1320*D1**2*K*f*fd*r*s + 1320*D1**2*K*f*fd*r + 660*D1**2*K*f*fd*s - 660*D1**2*K*f*fd + 1650*D1**2*K*f*fdd*r**2 + 1650*D1**2*K*f*fdd*r*s - 1650*D1**2*K*f*fdd*r - 825*D1**2*K*f*fdd*s + 825*D1**2*K*f*fdd + 1650*D1**2*K*fd**2*r**2 + 1650*D1**2*K*fd**2*r*s - 1650*D1**2*K*fd**2*r - 825*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(2*r - 1)*(-15*K + 10*f + 12)*(r + s - 1) - 690*D1**2*f**2*fd*r**2 - 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*s + 460*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 + 1056*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 1056*D1**2*f*fd*r - 528*D1**2*f*fd*s + 528*D1**2*f*fd - 1320*D1**2*f*fdd*r**2 - 1320*D1**2*f*fdd*r*s + 1320*D1**2*f*fdd*r + 660*D1**2*f*fdd*s - 660*D1**2*f*fdd + 1650*D1**2*f*gd2*r**2 + 1650*D1**2*f*gd2*r*s - 1650*D1**2*f*gd2*r - 1980*D1**2*f*gdd2*r**2 - 1980*D1**2*f*gdd2*r*s + 1980*D1**2*f*gdd2*r - 1320*D1**2*fd**2*r**2 - 1320*D1**2*fd**2*r*s + 1320*D1**2*fd**2*r + 660*D1**2*fd**2*s + 1650*D1**2*fd*g2*r**2 + 1650*D1**2*fd*g2*r*s - 3960*D1**2*fd*gd2*r**2 - 3960*D1**2*fd*gd2*r*s + 1980*D1**2*fd*gd2*r - 1980*D1**2*fdd*g2*r**2 - 1980*D1**2*fdd*g2*r*s - 2640*D1*Dd*K*f**2*r**2 - 2640*D1*Dd*K*f**2*r*s + 2640*D1*Dd*K*f**2*r + 660*D1*Dd*K*f**2*s - 660*D1*Dd*K*f**2 + 13200*D1*Dd*K*f*fd*r**2 + 13200*D1*Dd*K*f*fd*r*s - 13200*D1*Dd*K*f*fd*r - 4950*D1*Dd*K*f*fd*s + 3300*D1*Dd*K*f*fd - 920*D1*Dd*f**3*r**2 - 920*D1*Dd*f**3*r*s + 920*D1*Dd*f**3*r + 230*D1*Dd*f**3*s - 230*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 3360*D1*Dd*f**2*fd*r + 1400*D1*Dd*f**2*fd*s - 1120*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 2112*D1*Dd*f**2*r - 528*D1*Dd*f**2*s + 528*D1*Dd*f**2 - 10560*D1*Dd*f*fd*r**2 - 10560*D1*Dd*f*fd*r*s + 10560*D1*Dd*f*fd*r + 3960*D1*Dd*f*fd*s - 2640*D1*Dd*f*fd + 6600*D1*Dd*f*g2*r**2 + 6600*D1*Dd*f*g2*r*s - 6600*D1*Dd*f*g2*r - 1650*D1*Dd*f*g2*s + 1650*D1*Dd*f*g2 - 15840*D1*Dd*f*gd2*r**2 - 15840*D1*Dd*f*gd2*r*s + 15840*D1*Dd*f*gd2*r + 1980*D1*Dd*f*gd2*s - 1980*D1*Dd*f*gd2 - 15840*D1*Dd*fd*g2*r**2 - 15840*D1*Dd*fd*g2*r*s + 7920*D1*Dd*fd*g2*r + 1980*D1*Dd*fd*g2*s + 3300*D1*Ddd*K*f**2*r**2 + 3300*D1*Ddd*K*f**2*r*s - 3300*D1*Ddd*K*f**2*r - 825*D1*Ddd*K*f**2*s + 825*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 1120*D1*Ddd*f**3*r - 280*D1*Ddd*f**3*s + 280*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*r**2 - 2640*D1*Ddd*f**2*r*s + 2640*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s - 660*D1*Ddd*f**2 - 7920*D1*Ddd*f*g2*r**2 - 7920*D1*Ddd*f*g2*r*s + 7920*D1*Ddd*f*g2*r + 1980*D1*Ddd*f*g2*s - 1980*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(16*f**2*(2*r - 1)*(r + s - 1) - 5*f*(4*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + (5*K - 4)*(2*r - 1)*(r + s - 1)) + 6*fd*(5*K - 4)*(4*r**2 + r*(4*s - 3) - s)) - 2*Dd*f*(-15*K + 10*f + 12)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 9900*Dd**2*K*f**2*r**2 + 9900*Dd**2*K*f**2*r*s - 9900*Dd**2*K*f**2*r - 2475*Dd**2*K*f**2*s + 1650*Dd**2*K*f**2 + 3360*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 3360*Dd**2*f**3*r - 840*Dd**2*f**3*s + 560*Dd**2*f**3 - 7920*Dd**2*f**2*r**2 - 7920*Dd**2*f**2*r*s + 7920*Dd**2*f**2*r + 1980*Dd**2*f**2*s - 1320*Dd**2*f**2 - 23760*Dd**2*f*g2*r**2 - 23760*Dd**2*f*g2*r*s + 23760*Dd**2*f*g2*r + 5940*Dd**2*f*g2*s - 3960*Dd**2*f*g2))/(9009*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct**4*k1*k2**2*(11*b1**2*(6*C - 5)*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1*(-48*C*D1**2*f*fd*r - 24*C*D1**2*f*fd*s + 24*C*D1**2*f*fd + 60*C*D1**2*f*fdd*r + 30*C*D1**2*f*fdd*s - 30*C*D1**2*f*fdd + 60*C*D1**2*fd**2*r + 30*C*D1**2*fd**2*s - 30*C*D1**2*fd**2 + 240*C*D1*Dd*f*fd*r + 120*C*D1*Dd*f*fd*s - 120*C*D1*Dd*f*fd - 6*D1**2*bdd1*f*(6*C - 5)*(2*r**2 + 2*r*(s - 1) - s + 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s + 36*D1**2*f*fd*r + 20*D1**2*f*fd*s - 20*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s - 45*D1**2*f*fdd*r - 25*D1**2*f*fdd*s + 25*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s - 45*D1**2*fd**2*r - 25*D1**2*fd**2*s + 25*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s - 140*D1*Dd*f*fd*r - 90*D1*Dd*f*fd*s + 95*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(6*C - 5)*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2) - f*(66*D1**2*bd1**2*(6*C - 5)*(2*r**2 + 2*r*(s - 1) - s) + 55*D1**2*bdd1*f*(6*C*(2*r + s - 1) + r**2 + r*(s - 12) - 6*s + 6) - 11*D1*bd1*(D1*(4*f*(6*C*(2*r + s - 1) + r**2 + r*(s - 12) - 6*s + 6) - 5*fd*(6*C*(2*r + s - 1) + 4*r**2 + r*(4*s - 15) - 7*s + 6)) - 5*Dd*f*(24*C*(2*r + s - 1) + 8*r**2 + r*(8*s - 52) - 25*s + 24)) + (10*C - 10)*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 28*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(23*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 28*fd*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 28*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 28*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2))))/(231*d**2*k3**3) - 2*D1**2*Pkd1*Pkd3*ct**4*k2**4*st**2*(462*D1**2*b1*f*fd*r**2 + 462*D1**2*b1*f*fd*r*s - 231*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 453*D1**2*f**2*fd*r**2 + 453*D1**2*f**2*fd*r*s - 453*D1**2*f**2*fd*r - 151*D1**2*f**2*fd*s + 151*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 375*D1**2*f**2*fdd*r*s + 375*D1**2*f**2*fdd*r + 125*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd - 750*D1**2*f*fd**2*r**2 - 750*D1**2*f*fd**2*r*s + 750*D1**2*f*fd**2*r + 250*D1**2*f*fd**2*s - 125*D1**2*f*fd**2 + 924*D1*Dd*b1*f**2*r**2 + 924*D1*Dd*b1*f**2*r*s - 924*D1*Dd*b1*f**2*r - 231*D1*Dd*b1*f**2*s + 231*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 604*D1*Dd*f**3*r**2 + 604*D1*Dd*f**3*r*s - 604*D1*Dd*f**3*r - 151*D1*Dd*f**3*s + 151*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 3000*D1*Dd*f**2*fd*r*s + 3000*D1*Dd*f**2*fd*r + 875*D1*Dd*f**2*fd*s - 625*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 500*D1*Ddd*f**3*r**2 - 500*D1*Ddd*f**3*r*s + 500*D1*Ddd*f**3*r + 125*D1*Ddd*f**3*s - 125*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(7*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1500*Dd**2*f**3*r**2 - 1500*Dd**2*f**3*r*s + 1500*Dd**2*f**3*r + 375*Dd**2*f**3*s - 250*Dd**2*f**3)/(693*d**2*k1*k3**3) - 2*D1**2*Pkd1*Pkd3*ct**4*k2**4*(D1*f*(-33*D1*bd1**2*(5*f*(4*r**2 + r*(4*s - 5) - 2*s + 1) + (12*r - 6)*(r + s - 1)) - 5*D1*bdd1*f*r*(28*f*(2*r + 2*s - 1) + 33*r + 33*s - 33) - bd1*(D1*(-f*r*(115*f*(2*r + 2*s - 1) + 132*r + 132*s - 132) + 5*fd*(28*f*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1) + 132*r**2 + 132*r*(s - 1) - 33*s + 33)) + 5*Dd*f*(28*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 264*r**2 + 264*r*(s - 1) - 33*s + 33))) + 33*b1**2*(D1**2*r*(f*(4*fd - 5*fdd)*(4*r + 4*s - 3) - 5*fd**2*(4*r + 4*s - 3) + 5*fd*(r + s) - 6*fdd*(r + s)) + D1*(Dd*(8*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(8*r - 1)*(4*r + 4*s - 3) - 4*r**2 - 4*r*s + 4*r + s - 1) + 6*fd*(-8*r**2 + r*(4 - 8*s) + s)) - 2*Ddd*f*(5*f + 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 2*Dd**2*f*(5*f + 3)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-33*D1**2*bdd1*f*(5*f*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + (12*r - 6)*(r + s - 1)) + 690*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 805*D1**2*f**2*fd*r - 230*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 980*D1**2*f**2*fdd*r + 280*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd - 1680*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1960*D1**2*f*fd**2*r + 560*D1**2*f*fd**2*s - 420*D1**2*f*fd**2 + 264*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 264*D1**2*f*fd*r - 132*D1**2*f*fd*s + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 330*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r + 165*D1**2*f*fdd*s - 165*D1**2*f*fdd - 330*D1**2*fd**2*r**2 - 330*D1**2*fd**2*r*s + 330*D1**2*fd**2*r + 165*D1**2*fd**2*s + 920*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 920*D1*Dd*f**3*r - 230*D1*Dd*f**3*s + 230*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 7280*D1*Dd*f**2*fd*r + 1960*D1*Dd*f**2*fd*s - 1540*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 528*D1*Dd*f**2*r - 132*D1*Dd*f**2*s + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 2640*D1*Dd*f*fd*r*s + 2640*D1*Dd*f*fd*r + 990*D1*Dd*f*fd*s - 660*D1*Dd*f*fd - 1120*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 1120*D1*Ddd*f**3*r + 280*D1*Ddd*f**3*s - 280*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 - 660*D1*Ddd*f**2*r*s + 660*D1*Ddd*f**2*r + 165*D1*Ddd*f**2*s - 165*D1*Ddd*f**2 + 33*D1*bd1*(D1*(4*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 5*f*fd*(4*r - 1)*(4*r + 4*s - 3) + 5*f*(2*r - 1)*(r + s - 1) + 6*fd*(-4*r**2 + r*(3 - 4*s) + s)) - Dd*f*(5*f*(8*r - 3)*(4*r + 4*s - 3) + 96*r**2 + 24*r*(4*s - 5) - 36*s + 30)) - 3360*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 3360*Dd**2*f**3*r + 840*Dd**2*f**3*s - 560*Dd**2*f**3 - 1980*Dd**2*f**2*r**2 - 1980*Dd**2*f**2*r*s + 1980*Dd**2*f**2*r + 495*Dd**2*f**2*s - 330*Dd**2*f**2))/(693*d**2*k1*k3**3) - 2*D1**2*Pkd1*Pkd3*ct**4*k2**2*(D1*f*(-6*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) - 5*D1*bdd1*f*r*(r + s) + bd1*(D1*(4*f*r*(r + s) - 5*fd*(4*r**2 + 4*r*s - 3*r - s)) - 5*Dd*f*(8*r**2 + r*(8*s - 4) - s))) + b1**2*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-6*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 15*D1**2*fd**2*r + 5*D1**2*fd**2*s - 5*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 25*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k1*k3) - D1**2*Pkd1*Pkd3*ct**3*f*k2**5*st**4*(4*C - 4)*(33*D1**2*bd1*f*(r - 1)*(r + s - 1) + 5*D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + 33*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + 5*Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2))/(231*d**2*k3**5) - D1**2*Pkd1*Pkd3*ct**3*k1**4*k2*(20*C - 12)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct**3*k1**2*k2**3*st**2*(4818*C*D1**2*b1*f*fd*r**2 + 4818*C*D1**2*b1*f*fd*r*s - 2409*C*D1**2*b1*f*fd*r - 3630*C*D1**2*b1*f*fdd*r**2 - 3630*C*D1**2*b1*f*fdd*r*s + 1815*C*D1**2*b1*f*fdd*r - 3630*C*D1**2*b1*fd**2*r**2 - 3630*C*D1**2*b1*fd**2*r*s + 1815*C*D1**2*b1*fd**2*r + 4587*C*D1**2*f**2*fd*r**2 + 4587*C*D1**2*f**2*fd*r*s - 4587*C*D1**2*f**2*fd*r - 1529*C*D1**2*f**2*fd*s + 1529*C*D1**2*f**2*fd - 4125*C*D1**2*f**2*fdd*r**2 - 4125*C*D1**2*f**2*fdd*r*s + 4125*C*D1**2*f**2*fdd*r + 1375*C*D1**2*f**2*fdd*s - 1375*C*D1**2*f**2*fdd - 8250*C*D1**2*f*fd**2*r**2 - 8250*C*D1**2*f*fd**2*r*s + 8250*C*D1**2*f*fd**2*r + 2750*C*D1**2*f*fd**2*s - 1375*C*D1**2*f*fd**2 + 9636*C*D1*Dd*b1*f**2*r**2 + 9636*C*D1*Dd*b1*f**2*r*s - 9636*C*D1*Dd*b1*f**2*r - 2409*C*D1*Dd*b1*f**2*s + 2409*C*D1*Dd*b1*f**2 - 29040*C*D1*Dd*b1*f*fd*r**2 - 29040*C*D1*Dd*b1*f*fd*r*s + 21780*C*D1*Dd*b1*f*fd*r + 3630*C*D1*Dd*b1*f*fd*s - 1815*C*D1*Dd*b1*f*fd + 6116*C*D1*Dd*f**3*r**2 + 6116*C*D1*Dd*f**3*r*s - 6116*C*D1*Dd*f**3*r - 1529*C*D1*Dd*f**3*s + 1529*C*D1*Dd*f**3 - 33000*C*D1*Dd*f**2*fd*r**2 - 33000*C*D1*Dd*f**2*fd*r*s + 33000*C*D1*Dd*f**2*fd*r + 9625*C*D1*Dd*f**2*fd*s - 6875*C*D1*Dd*f**2*fd - 7260*C*D1*Ddd*b1*f**2*r**2 - 7260*C*D1*Ddd*b1*f**2*r*s + 7260*C*D1*Ddd*b1*f**2*r + 1815*C*D1*Ddd*b1*f**2*s - 1815*C*D1*Ddd*b1*f**2 - 5500*C*D1*Ddd*f**3*r**2 - 5500*C*D1*Ddd*f**3*r*s + 5500*C*D1*Ddd*f**3*r + 1375*C*D1*Ddd*f**3*s - 1375*C*D1*Ddd*f**3 - 21780*C*Dd**2*b1*f**2*r**2 - 21780*C*Dd**2*b1*f**2*r*s + 21780*C*Dd**2*b1*f**2*r + 5445*C*Dd**2*b1*f**2*s - 3630*C*Dd**2*b1*f**2 - 16500*C*Dd**2*f**3*r**2 - 16500*C*Dd**2*f**3*r*s + 16500*C*Dd**2*f**3*r + 4125*C*Dd**2*f**3*s - 2750*C*Dd**2*f**3 - 3564*D1**2*b1*f*fd*r**2 - 3564*D1**2*b1*f*fd*r*s + 1782*D1**2*b1*f*fd*r + 2706*D1**2*b1*f*fdd*r**2 + 2706*D1**2*b1*f*fdd*r*s - 1353*D1**2*b1*f*fdd*r + 2706*D1**2*b1*fd**2*r**2 + 2706*D1**2*b1*fd**2*r*s - 1353*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(55*C - 41)*(r - 1)*(r + s - 1) - 3378*D1**2*f**2*fd*r**2 - 3378*D1**2*f**2*fd*r*s + 3378*D1**2*f**2*fd*r + 1126*D1**2*f**2*fd*s - 1126*D1**2*f**2*fd + 3075*D1**2*f**2*fdd*r**2 + 3075*D1**2*f**2*fdd*r*s - 3075*D1**2*f**2*fdd*r - 1025*D1**2*f**2*fdd*s + 1025*D1**2*f**2*fdd + 6150*D1**2*f*fd**2*r**2 + 6150*D1**2*f*fd**2*r*s - 6150*D1**2*f*fd**2*r - 2050*D1**2*f*fd**2*s + 1025*D1**2*f*fd**2 - 7128*D1*Dd*b1*f**2*r**2 - 7128*D1*Dd*b1*f**2*r*s + 7128*D1*Dd*b1*f**2*r + 1782*D1*Dd*b1*f**2*s - 1782*D1*Dd*b1*f**2 + 21648*D1*Dd*b1*f*fd*r**2 + 21648*D1*Dd*b1*f*fd*r*s - 16236*D1*Dd*b1*f*fd*r - 2706*D1*Dd*b1*f*fd*s + 1353*D1*Dd*b1*f*fd - 4504*D1*Dd*f**3*r**2 - 4504*D1*Dd*f**3*r*s + 4504*D1*Dd*f**3*r + 1126*D1*Dd*f**3*s - 1126*D1*Dd*f**3 + 24600*D1*Dd*f**2*fd*r**2 + 24600*D1*Dd*f**2*fd*r*s - 24600*D1*Dd*f**2*fd*r - 7175*D1*Dd*f**2*fd*s + 5125*D1*Dd*f**2*fd + 5412*D1*Ddd*b1*f**2*r**2 + 5412*D1*Ddd*b1*f**2*r*s - 5412*D1*Ddd*b1*f**2*r - 1353*D1*Ddd*b1*f**2*s + 1353*D1*Ddd*b1*f**2 + 4100*D1*Ddd*f**3*r**2 + 4100*D1*Ddd*f**3*r*s - 4100*D1*Ddd*f**3*r - 1025*D1*Ddd*f**3*s + 1025*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(73*C - 54)*(r - 1)*(r + s - 1) - fd*(55*C - 41)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(55*C - 41)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 16236*Dd**2*b1*f**2*r**2 + 16236*Dd**2*b1*f**2*r*s - 16236*Dd**2*b1*f**2*r - 4059*Dd**2*b1*f**2*s + 2706*Dd**2*b1*f**2 + 12300*Dd**2*f**3*r**2 + 12300*Dd**2*f**3*r*s - 12300*Dd**2*f**3*r - 3075*Dd**2*f**3*s + 2050*Dd**2*f**3)/(693*d**2*k3**5) + 4*D1**2*Pkd1*Pkd3*ct**3*k1**2*k2**3*(-1287*D1**2*bd1**2*f*(2*r - 1)*(-10*K + 5*f + 6)*(r + s - 1) - 65*D1**2*bdd1*f*(r + s - 1)*(28*f**2*(r + 2) - 33*f*r*(5*K - 3) + 396*g2*(r - 1)) - 10*D1**2*(7*f**3*(38*fd - 45*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*f**2*(105*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + r*(572*gd2 - 715*gdd2)*(r + s - 1)) - 429*f*(fd*(g2*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 2145*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) + 13*D1*bd1*(D1*(115*f**3*(r + 2)*(r + s - 1) - 4*f**2*(35*fd*(6*r**2 + r*(6*s - 2) + 3*s - 1) + r*(165*K - 99)*(r + s - 1)) + 165*f*(fd*(5*K - 3)*(4*r**2 + 4*r*(s - 1) - s + 1) + (10*g2*(r - 1) + 12*gd2*(1 - 2*r))*(r + s - 1)) - 1980*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(28*f**2*(8*r**2 + 8*r*s + 7*s - 5) - 33*f*(5*K - 3)*(8*r**2 + 8*r*(s - 1) - s + 1) + 396*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 10*D1*f*(Dd*(266*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 630*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 429*f*(4*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 4290*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 15*Ddd*f*(21*f**2 - 143*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 150*Dd**2*f**2*(21*f**2 - 143*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 429*b1**2*(D1**2*r*(3*f*(4*fd - 5*fdd)*(2*r + 2*s - 1) - 15*fd**2*(2*r + 2*s - 1) - 5*fd*(5*K - 3)*(r + s) + 6*fdd*(5*K - 3)*(r + s)) + D1*(Dd*(12*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(48*r**2 + 12*r*(4*s - 3) - 6*s + 3) + (5*K - 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*fd*(5*K - 3)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-10*K + 5*f + 6)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-10*K + 5*f + 6)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-1320*D1**2*K*f*fd*r**2 - 1320*D1**2*K*f*fd*r*s + 1320*D1**2*K*f*fd*r + 660*D1**2*K*f*fd*s - 660*D1**2*K*f*fd + 1650*D1**2*K*f*fdd*r**2 + 1650*D1**2*K*f*fdd*r*s - 1650*D1**2*K*f*fdd*r - 825*D1**2*K*f*fdd*s + 825*D1**2*K*f*fdd + 1650*D1**2*K*fd**2*r**2 + 1650*D1**2*K*fd**2*r*s - 1650*D1**2*K*fd**2*r - 825*D1**2*K*fd**2*s - 99*D1**2*bdd1*f*(2*r - 1)*(-10*K + 5*f + 6)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 575*D1**2*f**2*fd*r - 345*D1**2*f**2*fd*s + 345*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 700*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s - 420*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 1400*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s - 420*D1**2*f*fd**2 + 792*D1**2*f*fd*r**2 + 792*D1**2*f*fd*r*s - 792*D1**2*f*fd*r - 396*D1**2*f*fd*s + 396*D1**2*f*fd - 990*D1**2*f*fdd*r**2 - 990*D1**2*f*fdd*r*s + 990*D1**2*f*fdd*r + 495*D1**2*f*fdd*s - 495*D1**2*f*fdd + 1650*D1**2*f*gd2*r**2 + 1650*D1**2*f*gd2*r*s - 1650*D1**2*f*gd2*r - 1980*D1**2*f*gdd2*r**2 - 1980*D1**2*f*gdd2*r*s + 1980*D1**2*f*gdd2*r - 990*D1**2*fd**2*r**2 - 990*D1**2*fd**2*r*s + 990*D1**2*fd**2*r + 495*D1**2*fd**2*s + 1650*D1**2*fd*g2*r**2 + 1650*D1**2*fd*g2*r*s - 3960*D1**2*fd*gd2*r**2 - 3960*D1**2*fd*gd2*r*s + 1980*D1**2*fd*gd2*r - 1980*D1**2*fdd*g2*r**2 - 1980*D1**2*fdd*g2*r*s - 2640*D1*Dd*K*f**2*r**2 - 2640*D1*Dd*K*f**2*r*s + 2640*D1*Dd*K*f**2*r + 660*D1*Dd*K*f**2*s - 660*D1*Dd*K*f**2 + 13200*D1*Dd*K*f*fd*r**2 + 13200*D1*Dd*K*f*fd*r*s - 13200*D1*Dd*K*f*fd*r - 4950*D1*Dd*K*f*fd*s + 3300*D1*Dd*K*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 4480*D1*Dd*f**2*fd*r + 2100*D1*Dd*f**2*fd*s - 1540*D1*Dd*f**2*fd + 1584*D1*Dd*f**2*r**2 + 1584*D1*Dd*f**2*r*s - 1584*D1*Dd*f**2*r - 396*D1*Dd*f**2*s + 396*D1*Dd*f**2 - 7920*D1*Dd*f*fd*r**2 - 7920*D1*Dd*f*fd*r*s + 7920*D1*Dd*f*fd*r + 2970*D1*Dd*f*fd*s - 1980*D1*Dd*f*fd + 6600*D1*Dd*f*g2*r**2 + 6600*D1*Dd*f*g2*r*s - 6600*D1*Dd*f*g2*r - 1650*D1*Dd*f*g2*s + 1650*D1*Dd*f*g2 - 15840*D1*Dd*f*gd2*r**2 - 15840*D1*Dd*f*gd2*r*s + 15840*D1*Dd*f*gd2*r + 1980*D1*Dd*f*gd2*s - 1980*D1*Dd*f*gd2 - 15840*D1*Dd*fd*g2*r**2 - 15840*D1*Dd*fd*g2*r*s + 7920*D1*Dd*fd*g2*r + 1980*D1*Dd*fd*g2*s + 3300*D1*Ddd*K*f**2*r**2 + 3300*D1*Ddd*K*f**2*r*s - 3300*D1*Ddd*K*f**2*r - 825*D1*Ddd*K*f**2*s + 825*D1*Ddd*K*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1980*D1*Ddd*f**2*r**2 - 1980*D1*Ddd*f**2*r*s + 1980*D1*Ddd*f**2*r + 495*D1*Ddd*f**2*s - 495*D1*Ddd*f**2 - 7920*D1*Ddd*f*g2*r**2 - 7920*D1*Ddd*f*g2*r*s + 7920*D1*Ddd*f*g2*r + 1980*D1*Ddd*f*g2*s - 1980*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(12*f**2*(2*r - 1)*(r + s - 1) - 5*f*(3*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + (5*K - 3)*(2*r - 1)*(r + s - 1)) + 6*fd*(5*K - 3)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-10*K + 5*f + 6)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 9900*Dd**2*K*f**2*r**2 + 9900*Dd**2*K*f**2*r*s - 9900*Dd**2*K*f**2*r - 2475*Dd**2*K*f**2*s + 1650*Dd**2*K*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3 - 5940*Dd**2*f**2*r**2 - 5940*Dd**2*f**2*r*s + 5940*Dd**2*f**2*r + 1485*Dd**2*f**2*s - 990*Dd**2*f**2 - 23760*Dd**2*f*g2*r**2 - 23760*Dd**2*f*g2*r*s + 23760*Dd**2*f*g2*r + 5940*Dd**2*f*g2*s - 3960*Dd**2*f*g2))/(9009*d**2*k3**5) - D1**2*Pkd1*Pkd3*ct**3*k1**2*k2*(12*C - 8)*(33*D1*b1*(-6*D1*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + bd1*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + (D1*(-4*f*fd + 5*f*fdd + 5*fd**2) + 20*Dd*f*fd)*(2*r + s - 1)) + 33*b1**2*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + f*(-198*D1**2*bd1**2*(2*r**2 + 2*r*(s - 1) - s) - 165*D1**2*bdd1*f*(2*r + s - 1) - 5*D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 28*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + 33*D1*bd1*(2*r + s - 1)*(4*D1*f - 5*D1*fd - 20*Dd*f) - 5*D1*f*(Dd*(23*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 28*fd*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 28*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 140*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(693*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct**3*k2**5*st**2*(1287*D1**2*K*bdd1*f**2*r**2 + 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*r - 429*D1**2*bd1**2*f*(2*r - 1)*(-3*K + 10*f + 3)*(r + s - 1) + 9750*D1**2*bdd1*f**3*r**2 + 9750*D1**2*bdd1*f**3*r*s - 22750*D1**2*bdd1*f**3*r - 13000*D1**2*bdd1*f**3*s + 13000*D1**2*bdd1*f**3 - 1287*D1**2*bdd1*f**2*r**2 - 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*r - 2574*D1**2*bdd1*f*g2*r**2 - 2574*D1**2*bdd1*f*g2*r*s + 5148*D1**2*bdd1*f*g2*r + 2574*D1**2*bdd1*f*g2*s - 2574*D1**2*bdd1*f*g2 - 42000*D1**2*f**3*fd*r**2 - 42000*D1**2*f**3*fd*r*s + 42000*D1**2*f**3*fd*r + 10500*D1**2*f**3*fd*s - 10500*D1**2*f**3*fd + 39200*D1**2*f**3*fdd*r**2 + 39200*D1**2*f**3*fdd*r*s - 39200*D1**2*f**3*fdd*r - 9800*D1**2*f**3*fdd*s + 9800*D1**2*f**3*fdd + 117600*D1**2*f**2*fd**2*r**2 + 117600*D1**2*f**2*fd**2*r*s - 117600*D1**2*f**2*fd**2*r - 29400*D1**2*f**2*fd**2*s + 19600*D1**2*f**2*fd**2 + 4290*D1**2*f**2*gd2*r**2 + 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*r - 2574*D1**2*f**2*gdd2*r**2 - 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*r + 8580*D1**2*f*fd*g2*r**2 + 8580*D1**2*f*fd*g2*r*s - 8580*D1**2*f*fd*g2*r - 4290*D1**2*f*fd*g2*s + 4290*D1**2*f*fd*g2 - 10296*D1**2*f*fd*gd2*r**2 - 10296*D1**2*f*fd*gd2*r*s + 10296*D1**2*f*fd*gd2*r + 2574*D1**2*f*fd*gd2*s - 2574*D1**2*f*fd*gd2 - 5148*D1**2*f*fdd*g2*r**2 - 5148*D1**2*f*fdd*g2*r*s + 5148*D1**2*f*fdd*g2*r + 2574*D1**2*f*fdd*g2*s - 2574*D1**2*f*fdd*g2 - 5148*D1**2*fd**2*g2*r**2 - 5148*D1**2*fd**2*g2*r*s + 5148*D1**2*fd**2*g2*r + 2574*D1**2*fd**2*g2*s - 42000*D1*Dd*f**4*r**2 - 42000*D1*Dd*f**4*r*s + 42000*D1*Dd*f**4*r + 10500*D1*Dd*f**4*s - 10500*D1*Dd*f**4 + 313600*D1*Dd*f**3*fd*r**2 + 313600*D1*Dd*f**3*fd*r*s - 313600*D1*Dd*f**3*fd*r - 78400*D1*Dd*f**3*fd*s + 58800*D1*Dd*f**3*fd + 17160*D1*Dd*f**2*g2*r**2 + 17160*D1*Dd*f**2*g2*r*s - 17160*D1*Dd*f**2*g2*r - 4290*D1*Dd*f**2*g2*s + 4290*D1*Dd*f**2*g2 - 20592*D1*Dd*f**2*gd2*r**2 - 20592*D1*Dd*f**2*gd2*r*s + 20592*D1*Dd*f**2*gd2*r + 2574*D1*Dd*f**2*gd2*s - 2574*D1*Dd*f**2*gd2 - 41184*D1*Dd*f*fd*g2*r**2 - 41184*D1*Dd*f*fd*g2*r*s + 41184*D1*Dd*f*fd*g2*r + 15444*D1*Dd*f*fd*g2*s - 10296*D1*Dd*f*fd*g2 + 39200*D1*Ddd*f**4*r**2 + 39200*D1*Ddd*f**4*r*s - 39200*D1*Ddd*f**4*r - 9800*D1*Ddd*f**4*s + 9800*D1*Ddd*f**4 - 10296*D1*Ddd*f**2*g2*r**2 - 10296*D1*Ddd*f**2*g2*r*s + 10296*D1*Ddd*f**2*g2*r + 2574*D1*Ddd*f**2*g2*s - 2574*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(2*f**3*(387*r - 538)*(r + s - 1) - 5*f**2*(50*fd*(18*r**2 + 2*r*(9*s - 13) - 11*s + 7) + r*(33 - 33*K)*(r + s - 1)) - 33*f*(3*fd*(K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (26*g2*(r - 1) + 2*gd2*(3 - 6*r))*(r + s - 1)) + 198*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-250*f**2*(24*r**2 + 8*r*(3*s - 5) - 19*s + 15) - 99*f*(K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 198*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 117600*Dd**2*f**4*r**2 + 117600*Dd**2*f**4*r*s - 117600*Dd**2*f**4*r - 29400*Dd**2*f**4*s + 19600*Dd**2*f**4 - 30888*Dd**2*f**2*g2*r**2 - 30888*Dd**2*f**2*g2*r*s + 30888*Dd**2*f**2*g2*r + 7722*Dd**2*f**2*g2*s - 5148*Dd**2*f**2*g2 + 429*b1**2*(D1**2*r*(2*f*(7*fd - 5*fdd)*(2*r + 2*s - 1) - 10*fd**2*(2*r + 2*s - 1) - 13*fd*(K - 1)*(r + s) + 3*fdd*(K - 1)*(r + s)) + D1*(Dd*(14*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-10*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (13 - 13*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*fd*(K - 1)*(8*r**2 + r*(8*s - 4) - s)) - Ddd*f*(-3*K + 10*f + 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(-3*K + 10*f + 3)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-330*D1**2*K*f*fd*r**2 - 330*D1**2*K*f*fd*r*s + 330*D1**2*K*f*fd*r + 165*D1**2*K*f*fd*s - 165*D1**2*K*f*fd + 198*D1**2*K*f*fdd*r**2 + 198*D1**2*K*f*fdd*r*s - 198*D1**2*K*f*fdd*r - 99*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 198*D1**2*K*fd**2*r**2 + 198*D1**2*K*fd**2*r*s - 198*D1**2*K*fd**2*r - 99*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(2*r - 1)*(-3*K + 10*f + 3)*(r + s - 1) - 2322*D1**2*f**2*fd*r**2 - 2322*D1**2*f**2*fd*r*s + 1246*D1**2*f**2*fd*r - 302*D1**2*f**2*fd*s + 302*D1**2*f**2*fd + 2250*D1**2*f**2*fdd*r**2 + 2250*D1**2*f**2*fdd*r*s - 1250*D1**2*f**2*fdd*r + 250*D1**2*f**2*fdd*s - 250*D1**2*f**2*fdd + 4500*D1**2*f*fd**2*r**2 + 4500*D1**2*f*fd**2*r*s - 2500*D1**2*f*fd**2*r + 500*D1**2*f*fd**2*s - 250*D1**2*f*fd**2 + 330*D1**2*f*fd*r**2 + 330*D1**2*f*fd*r*s - 330*D1**2*f*fd*r - 165*D1**2*f*fd*s + 165*D1**2*f*fd - 198*D1**2*f*fdd*r**2 - 198*D1**2*f*fdd*r*s + 198*D1**2*f*fdd*r + 99*D1**2*f*fdd*s - 99*D1**2*f*fdd + 858*D1**2*f*gd2*r**2 + 858*D1**2*f*gd2*r*s - 858*D1**2*f*gd2*r - 198*D1**2*f*gdd2*r**2 - 198*D1**2*f*gdd2*r*s + 198*D1**2*f*gdd2*r - 198*D1**2*fd**2*r**2 - 198*D1**2*fd**2*r*s + 198*D1**2*fd**2*r + 99*D1**2*fd**2*s + 858*D1**2*fd*g2*r**2 + 858*D1**2*fd*g2*r*s - 396*D1**2*fd*gd2*r**2 - 396*D1**2*fd*gd2*r*s + 198*D1**2*fd*gd2*r - 198*D1**2*fdd*g2*r**2 - 198*D1**2*fdd*g2*r*s - 660*D1*Dd*K*f**2*r**2 - 660*D1*Dd*K*f**2*r*s + 660*D1*Dd*K*f**2*r + 165*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 1584*D1*Dd*K*f*fd*r**2 + 1584*D1*Dd*K*f*fd*r*s - 1584*D1*Dd*K*f*fd*r - 594*D1*Dd*K*f*fd*s + 396*D1*Dd*K*f*fd - 3096*D1*Dd*f**3*r**2 - 3096*D1*Dd*f**3*r*s + 3096*D1*Dd*f**3*r + 774*D1*Dd*f**3*s - 774*D1*Dd*f**3 + 18000*D1*Dd*f**2*fd*r**2 + 18000*D1*Dd*f**2*fd*r*s - 14000*D1*Dd*f**2*fd*r - 1250*D1*Dd*f**2*fd*s + 750*D1*Dd*f**2*fd + 660*D1*Dd*f**2*r**2 + 660*D1*Dd*f**2*r*s - 660*D1*Dd*f**2*r - 165*D1*Dd*f**2*s + 165*D1*Dd*f**2 - 1584*D1*Dd*f*fd*r**2 - 1584*D1*Dd*f*fd*r*s + 1584*D1*Dd*f*fd*r + 594*D1*Dd*f*fd*s - 396*D1*Dd*f*fd + 3432*D1*Dd*f*g2*r**2 + 3432*D1*Dd*f*g2*r*s - 3432*D1*Dd*f*g2*r - 858*D1*Dd*f*g2*s + 858*D1*Dd*f*g2 - 1584*D1*Dd*f*gd2*r**2 - 1584*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r + 198*D1*Dd*f*gd2*s - 198*D1*Dd*f*gd2 - 1584*D1*Dd*fd*g2*r**2 - 1584*D1*Dd*fd*g2*r*s + 792*D1*Dd*fd*g2*r + 198*D1*Dd*fd*g2*s + 396*D1*Ddd*K*f**2*r**2 + 396*D1*Ddd*K*f**2*r*s - 396*D1*Ddd*K*f**2*r - 99*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 + 3000*D1*Ddd*f**3*r**2 + 3000*D1*Ddd*f**3*r*s - 3000*D1*Ddd*f**3*r - 750*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 - 396*D1*Ddd*f**2*r**2 - 396*D1*Ddd*f**2*r*s + 396*D1*Ddd*f**2*r + 99*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 - 792*D1*Ddd*f*g2*r**2 - 792*D1*Ddd*f*g2*r*s + 792*D1*Ddd*f*g2*r + 198*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(14*f**2*(2*r - 1)*(r + s - 1) + f*(-10*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (13*K - 13)*(2*r - 1)*(r + s - 1)) + 3*fd*(K - 1)*(4*r**2 + r*(4*s - 3) - s)) - Dd*f*(-3*K + 10*f + 3)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1188*Dd**2*K*f**2*r**2 + 1188*Dd**2*K*f**2*r*s - 1188*Dd**2*K*f**2*r - 297*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 + 9000*Dd**2*f**3*r**2 + 9000*Dd**2*f**3*r*s - 9000*Dd**2*f**3*r - 2250*Dd**2*f**3*s + 1500*Dd**2*f**3 - 1188*Dd**2*f**2*r**2 - 1188*Dd**2*f**2*r*s + 1188*Dd**2*f**2*r + 297*Dd**2*f**2*s - 198*Dd**2*f**2 - 2376*Dd**2*f*g2*r**2 - 2376*Dd**2*f*g2*r*s + 2376*Dd**2*f*g2*r + 594*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(9009*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct**3*k2**3*st**2*(33*b1**2*(C - 1)*(D1**2*r*(13*fd - 3*fdd)*(r + s - 1) + D1*(Dd*(13*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1*(-18*C*D1**2*f*fd*r**2 - 18*C*D1**2*f*fd*r*s - C*D1**2*f*fd*r - 5*C*D1**2*f*fd*s + 5*C*D1**2*f*fd + 14*C*D1**2*f*fdd*r**2 + 14*C*D1**2*f*fdd*r*s - C*D1**2*f*fdd*r + 3*C*D1**2*f*fdd*s - 3*C*D1**2*f*fdd + 14*C*D1**2*fd**2*r**2 + 14*C*D1**2*fd**2*r*s - C*D1**2*fd**2*r + 3*C*D1**2*fd**2*s - 3*C*D1**2*fd**2 - 36*C*D1*Dd*f**2*r**2 - 36*C*D1*Dd*f**2*r*s + 36*C*D1*Dd*f**2*r + 9*C*D1*Dd*f**2*s - 9*C*D1*Dd*f**2 + 112*C*D1*Dd*f*fd*r**2 + 112*C*D1*Dd*f*fd*r*s - 60*C*D1*Dd*f*fd*r - 2*C*D1*Dd*f*fd*s - 5*C*D1*Dd*f*fd + 28*C*D1*Ddd*f**2*r**2 + 28*C*D1*Ddd*f**2*r*s - 28*C*D1*Ddd*f**2*r - 7*C*D1*Ddd*f**2*s + 7*C*D1*Ddd*f**2 + 84*C*Dd**2*f**2*r**2 + 84*C*Dd**2*f**2*r*s - 84*C*Dd**2*f**2*r - 21*C*Dd**2*f**2*s + 14*C*Dd**2*f**2 - 3*D1**2*bdd1*f*(C - 1)*(2*r**2 + 2*r*(s - 1) - s + 1) + 28*D1**2*f*fd*r**2 + 28*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 5*D1**2*f*fd*s - 5*D1**2*f*fd - 22*D1**2*f*fdd*r**2 - 22*D1**2*f*fdd*r*s + 5*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 3*D1**2*f*fdd - 22*D1**2*fd**2*r**2 - 22*D1**2*fd**2*r*s + 5*D1**2*fd**2*r - 3*D1**2*fd**2*s + 3*D1**2*fd**2 + 56*D1*Dd*f**2*r**2 + 56*D1*Dd*f**2*r*s - 56*D1*Dd*f**2*r - 14*D1*Dd*f**2*s + 14*D1*Dd*f**2 - 176*D1*Dd*f*fd*r**2 - 176*D1*Dd*f*fd*r*s + 108*D1*Dd*f*fd*r + 10*D1*Dd*f*fd*s + D1*Dd*f*fd - 44*D1*Ddd*f**2*r**2 - 44*D1*Ddd*f**2*r*s + 44*D1*Ddd*f**2*r + 11*D1*Ddd*f**2*s - 11*D1*Ddd*f**2 + D1*bd1*(C - 1)*(D1*(13*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 132*Dd**2*f**2*r**2 - 132*Dd**2*f**2*r*s + 132*Dd**2*f**2*r + 33*Dd**2*f**2*s - 22*Dd**2*f**2) + f*(-906*C*D1**2*f*fd*r**2 - 906*C*D1**2*f*fd*r*s + 906*C*D1**2*f*fd*r + 302*C*D1**2*f*fd*s - 302*C*D1**2*f*fd + 750*C*D1**2*f*fdd*r**2 + 750*C*D1**2*f*fdd*r*s - 750*C*D1**2*f*fdd*r - 250*C*D1**2*f*fdd*s + 250*C*D1**2*f*fdd + 1500*C*D1**2*fd**2*r**2 + 1500*C*D1**2*fd**2*r*s - 1500*C*D1**2*fd**2*r - 500*C*D1**2*fd**2*s + 250*C*D1**2*fd**2 - 1208*C*D1*Dd*f**2*r**2 - 1208*C*D1*Dd*f**2*r*s + 1208*C*D1*Dd*f**2*r + 302*C*D1*Dd*f**2*s - 302*C*D1*Dd*f**2 + 6000*C*D1*Dd*f*fd*r**2 + 6000*C*D1*Dd*f*fd*r*s - 6000*C*D1*Dd*f*fd*r - 1750*C*D1*Dd*f*fd*s + 1250*C*D1*Dd*f*fd + 1000*C*D1*Ddd*f**2*r**2 + 1000*C*D1*Ddd*f**2*r*s - 1000*C*D1*Ddd*f**2*r - 250*C*D1*Ddd*f**2*s + 250*C*D1*Ddd*f**2 + 3000*C*Dd**2*f**2*r**2 + 3000*C*Dd**2*f**2*r*s - 3000*C*Dd**2*f**2*r - 750*C*Dd**2*f**2*s + 500*C*Dd**2*f**2 - 99*D1**2*bd1**2*(C - 1)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(C*(7*r**2 + 7*r*s - 20*r - 10*s + 10) - 11*r**2 - 11*r*s + 28*r + 14*s - 14) + 1209*D1**2*f*fd*r**2 + 1209*D1**2*f*fd*r*s - 1209*D1**2*f*fd*r - 403*D1**2*f*fd*s + 403*D1**2*f*fd - 1050*D1**2*f*fdd*r**2 - 1050*D1**2*f*fdd*r*s + 1050*D1**2*f*fdd*r + 350*D1**2*f*fdd*s - 350*D1**2*f*fdd - 2100*D1**2*fd**2*r**2 - 2100*D1**2*fd**2*r*s + 2100*D1**2*fd**2*r + 700*D1**2*fd**2*s - 350*D1**2*fd**2 + 1612*D1*Dd*f**2*r**2 + 1612*D1*Dd*f**2*r*s - 1612*D1*Dd*f**2*r - 403*D1*Dd*f**2*s + 403*D1*Dd*f**2 - 8400*D1*Dd*f*fd*r**2 - 8400*D1*Dd*f*fd*r*s + 8400*D1*Dd*f*fd*r + 2450*D1*Dd*f*fd*s - 1750*D1*Dd*f*fd - 1400*D1*Ddd*f**2*r**2 - 1400*D1*Ddd*f**2*r*s + 1400*D1*Ddd*f**2*r + 350*D1*Ddd*f**2*s - 350*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(C*(9*r**2 + 9*r*s - 28*r - 14*s + 14) - 14*r**2 - 14*r*s + 38*r + 19*s - 19) + fd*(C*(-28*r**2 - 28*r*s + 41*r + 17*s - 10) + 44*r**2 + 44*r*s - 61*r - 25*s + 14)) + Dd*f*(C*(-56*r**2 - 56*r*s + 108*r + 47*s - 40) + 88*r**2 + 88*r*s - 156*r - 67*s + 56)) - 4200*Dd**2*f**2*r**2 - 4200*Dd**2*f**2*r*s + 4200*Dd**2*f**2*r + 1050*Dd**2*f**2*s - 700*Dd**2*f**2))/(693*d**2*k3**3) + 2*D1**2*Pkd1*Pkd3*ct**3*k2**3*(396*D1**2*K*bd1**2*f*r + 198*D1**2*K*bd1**2*f*s - 198*D1**2*K*bd1**2*f + 132*D1**2*K*bd1*f**2*r**2 + 132*D1**2*K*bd1*f**2*r*s - 132*D1**2*K*bd1*f**2*r - 660*D1**2*K*bd1*f*fd*r**2 - 660*D1**2*K*bd1*f*fd*r*s + 660*D1**2*K*bd1*f*fd*r + 165*D1**2*K*bd1*f*fd*s - 165*D1**2*K*bd1*f*fd - 165*D1**2*K*bdd1*f**2*r**2 - 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*r + 1320*D1**2*bd1**2*f**2*r**2 + 1320*D1**2*bd1**2*f**2*r*s - 1980*D1**2*bd1**2*f**2*r - 825*D1**2*bd1**2*f**2*s + 495*D1**2*bd1**2*f**2 + 792*D1**2*bd1**2*f*r**2 + 792*D1**2*bd1**2*f*r*s - 1584*D1**2*bd1**2*f*r - 594*D1**2*bd1**2*f*s + 594*D1**2*bd1**2*f - 924*D1**2*bd1**2*g2*r**2 - 924*D1**2*bd1**2*g2*r*s + 924*D1**2*bd1**2*g2*r + 462*D1**2*bd1**2*g2*s - 396*D1**2*bd1*bd2*f*r**2 - 396*D1**2*bd1*bd2*f*r*s + 594*D1**2*bd1*bd2*f*r + 198*D1**2*bd1*bd2*f*s - 198*D1**2*bd1*bd2*f - 575*D1**2*bd1*f**3*r**2 - 575*D1**2*bd1*f**3*r*s + 345*D1**2*bd1*f**3*r + 4200*D1**2*bd1*f**2*fd*r**2 + 4200*D1**2*bd1*f**2*fd*r*s - 3640*D1**2*bd1*f**2*fd*r - 700*D1**2*bd1*f**2*fd*s + 420*D1**2*bd1*f**2*fd - 396*D1**2*bd1*f**2*r**2 - 396*D1**2*bd1*f**2*r*s + 396*D1**2*bd1*f**2*r + 1980*D1**2*bd1*f*fd*r**2 + 1980*D1**2*bd1*f*fd*r*s - 1980*D1**2*bd1*f*fd*r - 495*D1**2*bd1*f*fd*s + 495*D1**2*bd1*f*fd + 660*D1**2*bd1*f*g2*r + 330*D1**2*bd1*f*g2*s - 330*D1**2*bd1*f*g2 - 792*D1**2*bd1*f*gd2*r - 396*D1**2*bd1*f*gd2*s + 396*D1**2*bd1*f*gd2 + 132*D1**2*bd2*f**2*r**2 + 132*D1**2*bd2*f**2*r*s - 132*D1**2*bd2*f**2*r - 660*D1**2*bd2*f*fd*r**2 - 660*D1**2*bd2*f*fd*r*s + 660*D1**2*bd2*f*fd*r + 165*D1**2*bd2*f*fd*s - 165*D1**2*bd2*f*fd + 700*D1**2*bdd1*f**3*r**2 + 700*D1**2*bdd1*f**3*r*s - 420*D1**2*bdd1*f**3*r + 495*D1**2*bdd1*f**2*r**2 + 495*D1**2*bdd1*f**2*r*s - 495*D1**2*bdd1*f**2*r - 792*D1**2*bdd1*f*g2*r - 396*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 165*D1**2*bdd2*f**2*r**2 - 165*D1**2*bdd2*f**2*r*s + 165*D1**2*bdd2*f**2*r - 264*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*r + 330*D1**2*f**2*gdd2*r**2 + 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*r - 528*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*r**2 + 1320*D1**2*f*fd*gd2*r*s - 1320*D1**2*f*fd*gd2*r - 330*D1**2*f*fd*gd2*s + 330*D1**2*f*fd*gd2 + 660*D1**2*f*fdd*g2*r**2 + 660*D1**2*f*fdd*g2*r*s - 660*D1**2*f*fdd*g2*r - 330*D1**2*f*fdd*g2*s + 330*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*r**2 + 660*D1**2*fd**2*g2*r*s - 660*D1**2*fd**2*g2*r - 330*D1**2*fd**2*g2*s - 1320*D1*Dd*K*bd1*f**2*r**2 - 1320*D1*Dd*K*bd1*f**2*r*s + 1320*D1*Dd*K*bd1*f**2*r + 165*D1*Dd*K*bd1*f**2*s - 165*D1*Dd*K*bd1*f**2 + 5600*D1*Dd*bd1*f**3*r**2 + 5600*D1*Dd*bd1*f**3*r*s - 4480*D1*Dd*bd1*f**3*r - 700*D1*Dd*bd1*f**3*s + 420*D1*Dd*bd1*f**3 + 3960*D1*Dd*bd1*f**2*r**2 + 3960*D1*Dd*bd1*f**2*r*s - 3960*D1*Dd*bd1*f**2*r - 495*D1*Dd*bd1*f**2*s + 495*D1*Dd*bd1*f**2 - 3168*D1*Dd*bd1*f*g2*r - 1584*D1*Dd*bd1*f*g2*s + 1584*D1*Dd*bd1*f*g2 - 1320*D1*Dd*bd2*f**2*r**2 - 1320*D1*Dd*bd2*f**2*r*s + 1320*D1*Dd*bd2*f**2*r + 165*D1*Dd*bd2*f**2*s - 165*D1*Dd*bd2*f**2 - 1056*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s + 1056*D1*Dd*f**2*g2*r + 264*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*r**2 + 2640*D1*Dd*f**2*gd2*r*s - 2640*D1*Dd*f**2*gd2*r - 330*D1*Dd*f**2*gd2*s + 330*D1*Dd*f**2*gd2 + 5280*D1*Dd*f*fd*g2*r**2 + 5280*D1*Dd*f*fd*g2*r*s - 5280*D1*Dd*f*fd*g2*r - 1980*D1*Dd*f*fd*g2*s + 1320*D1*Dd*f*fd*g2 + 1320*D1*Ddd*f**2*g2*r**2 + 1320*D1*Ddd*f**2*g2*r*s - 1320*D1*Ddd*f**2*g2*r - 330*D1*Ddd*f**2*g2*s + 330*D1*Ddd*f**2*g2 + 3960*Dd**2*f**2*g2*r**2 + 3960*Dd**2*f**2*g2*r*s - 3960*Dd**2*f**2*g2*r - 990*Dd**2*f**2*g2*s + 660*Dd**2*f**2*g2 + 33*b1**3*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1) - 2*(7*K - 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-7*K + 6*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-7*K + 6*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1**2*(10*D1**2*K*fd*r + 5*D1**2*K*fd*s - 5*D1**2*K*fd - 12*D1**2*K*fdd*r - 6*D1**2*K*fdd*s + 6*D1**2*K*fdd - D1**2*bdd1*(-7*K + 6*f + 7)*(3*r**2 + 3*r*(s - 1) - s + 1) - 32*D1**2*f*fd*r**2 - 32*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd + 40*D1**2*f*fdd*r**2 + 40*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd + 40*D1**2*fd**2*r**2 + 40*D1**2*fd**2*r*s - 20*D1**2*fd**2*r + 5*D1**2*fd**2*s - 5*D1**2*fd**2 - 10*D1**2*fd*r**2 - 10*D1**2*fd*r*s - 10*D1**2*fd*r - 5*D1**2*fd*s + 5*D1**2*fd + 12*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s + 12*D1**2*fdd*r + 6*D1**2*fdd*s - 6*D1**2*fdd + 28*D1**2*gd2*r**2 + 28*D1**2*gd2*r*s - 28*D1**2*gd2*r - 14*D1**2*gdd2*r**2 - 14*D1**2*gdd2*r*s + 14*D1**2*gdd2*r - 48*D1*Dd*K*fd*r - 24*D1*Dd*K*fd*s + 24*D1*Dd*K*fd - 64*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 64*D1*Dd*f**2*r + 16*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 320*D1*Dd*f*fd*r**2 + 320*D1*Dd*f*fd*r*s - 240*D1*Dd*f*fd*r - 20*D1*Dd*f*fd*s + 10*D1*Dd*f*fd - 40*D1*Dd*f*r**2 - 40*D1*Dd*f*r*s + 40*D1*Dd*f*r + 10*D1*Dd*f*s - 10*D1*Dd*f + 96*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s + 12*D1*Dd*fd*s - 24*D1*Dd*fd + 112*D1*Dd*g2*r**2 + 112*D1*Dd*g2*r*s - 112*D1*Dd*g2*r - 28*D1*Dd*g2*s + 28*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 - 112*D1*Dd*gd2*r*s + 112*D1*Dd*gd2*r + 14*D1*Dd*gd2*s - 14*D1*Dd*gd2 + 80*D1*Ddd*f**2*r**2 + 80*D1*Ddd*f**2*r*s - 80*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s + 20*D1*Ddd*f**2 + 48*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 48*D1*Ddd*f*r - 12*D1*Ddd*f*s + 12*D1*Ddd*f - 56*D1*Ddd*g2*r**2 - 56*D1*Ddd*g2*r*s + 56*D1*Ddd*g2*r + 14*D1*Ddd*g2*s - 14*D1*Ddd*g2 + D1*bd1*(D1*(5*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 6*fd*(6*r**2 + 6*r*(s - 1) - s + 1) - 2*(7*K - 7)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-7*K + 6*f + 7)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 240*Dd**2*f**2*r**2 + 240*Dd**2*f**2*r*s - 240*Dd**2*f**2*r - 60*Dd**2*f**2*s + 40*Dd**2*f**2 + 144*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 144*Dd**2*f*r - 36*Dd**2*f*s + 24*Dd**2*f - 168*Dd**2*g2*r**2 - 168*Dd**2*g2*r*s + 168*Dd**2*g2*r + 42*Dd**2*g2*s - 28*Dd**2*g2) + b1*(264*D1**2*K*f*fd*r**2 + 264*D1**2*K*f*fd*r*s - 264*D1**2*K*f*fd*r - 132*D1**2*K*f*fd*s + 132*D1**2*K*f*fd - 330*D1**2*K*f*fdd*r**2 - 330*D1**2*K*f*fdd*r*s + 330*D1**2*K*f*fdd*r + 165*D1**2*K*f*fdd*s - 165*D1**2*K*f*fdd - 330*D1**2*K*fd**2*r**2 - 330*D1**2*K*fd**2*r*s + 330*D1**2*K*fd**2*r + 165*D1**2*K*fd**2*s + 165*D1**2*b2*fd*r**2 + 165*D1**2*b2*fd*r*s - 198*D1**2*b2*fdd*r**2 - 198*D1**2*b2*fdd*r*s - 33*D1**2*bd1**2*(-7*K + 6*f + 7)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 165*D1**2*bd2*f*r**2 + 165*D1**2*bd2*f*r*s - 165*D1**2*bd2*f*r - 396*D1**2*bd2*fd*r**2 - 396*D1**2*bd2*fd*r*s + 198*D1**2*bd2*fd*r + 33*D1**2*bdd1*(5*f**2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 5) + 6*f*(K*(2*r + s - 1) + 4*r**2 + 4*r*(s - 2) - 3*s + 3) - 14*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 198*D1**2*bdd2*f*r**2 - 198*D1**2*bdd2*f*r*s + 198*D1**2*bdd2*f*r - 1725*D1**2*f**2*fd*r**2 - 1725*D1**2*f**2*fd*r*s + 1955*D1**2*f**2*fd*r + 575*D1**2*f**2*fd*s - 575*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 2100*D1**2*f**2*fdd*r*s - 2380*D1**2*f**2*fdd*r - 700*D1**2*f**2*fdd*s + 700*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 4200*D1**2*f*fd**2*r*s - 4760*D1**2*f*fd**2*r - 1400*D1**2*f*fd**2*s + 980*D1**2*f*fd**2 - 792*D1**2*f*fd*r**2 - 792*D1**2*f*fd*r*s + 792*D1**2*f*fd*r + 396*D1**2*f*fd*s - 396*D1**2*f*fd + 990*D1**2*f*fdd*r**2 + 990*D1**2*f*fdd*r*s - 990*D1**2*f*fdd*r - 495*D1**2*f*fdd*s + 495*D1**2*f*fdd + 990*D1**2*fd**2*r**2 + 990*D1**2*fd**2*r*s - 990*D1**2*fd**2*r - 495*D1**2*fd**2*s - 660*D1**2*fd*g2*r - 330*D1**2*fd*g2*s + 330*D1**2*fd*g2 + 792*D1**2*fd*gd2*r + 396*D1**2*fd*gd2*s - 396*D1**2*fd*gd2 + 792*D1**2*fdd*g2*r + 396*D1**2*fdd*g2*s - 396*D1**2*fdd*g2 + 528*D1*Dd*K*f**2*r**2 + 528*D1*Dd*K*f**2*r*s - 528*D1*Dd*K*f**2*r - 132*D1*Dd*K*f**2*s + 132*D1*Dd*K*f**2 - 2640*D1*Dd*K*f*fd*r**2 - 2640*D1*Dd*K*f*fd*r*s + 2640*D1*Dd*K*f*fd*r + 990*D1*Dd*K*f*fd*s - 660*D1*Dd*K*f*fd + 660*D1*Dd*b2*f*r**2 + 660*D1*Dd*b2*f*r*s - 660*D1*Dd*b2*f*r - 165*D1*Dd*b2*f*s + 165*D1*Dd*b2*f - 1584*D1*Dd*b2*fd*r**2 - 1584*D1*Dd*b2*fd*r*s + 792*D1*Dd*b2*fd*r + 198*D1*Dd*b2*fd*s - 1584*D1*Dd*bd2*f*r**2 - 1584*D1*Dd*bd2*f*r*s + 1584*D1*Dd*bd2*f*r + 198*D1*Dd*bd2*f*s - 198*D1*Dd*bd2*f - 2300*D1*Dd*f**3*r**2 - 2300*D1*Dd*f**3*r*s + 2300*D1*Dd*f**3*r + 575*D1*Dd*f**3*s - 575*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 16800*D1*Dd*f**2*fd*r*s - 17920*D1*Dd*f**2*fd*r - 4900*D1*Dd*f**2*fd*s + 3780*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*r**2 - 1584*D1*Dd*f**2*r*s + 1584*D1*Dd*f**2*r + 396*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 7920*D1*Dd*f*fd*r**2 + 7920*D1*Dd*f*fd*r*s - 7920*D1*Dd*f*fd*r - 2970*D1*Dd*f*fd*s + 1980*D1*Dd*f*fd + 3168*D1*Dd*fd*g2*r + 1584*D1*Dd*fd*g2*s - 1584*D1*Dd*fd*g2 - 660*D1*Ddd*K*f**2*r**2 - 660*D1*Ddd*K*f**2*r*s + 660*D1*Ddd*K*f**2*r + 165*D1*Ddd*K*f**2*s - 165*D1*Ddd*K*f**2 - 792*D1*Ddd*b2*f*r**2 - 792*D1*Ddd*b2*f*r*s + 792*D1*Ddd*b2*f*r + 198*D1*Ddd*b2*f*s - 198*D1*Ddd*b2*f + 2800*D1*Ddd*f**3*r**2 + 2800*D1*Ddd*f**3*r*s - 2800*D1*Ddd*f**3*r - 700*D1*Ddd*f**3*s + 700*D1*Ddd*f**3 + 1980*D1*Ddd*f**2*r**2 + 1980*D1*Ddd*f**2*r*s - 1980*D1*Ddd*f**2*r - 495*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 - 33*D1*bd1*(D1*(4*f**2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 5) - 5*f*(-2*K*r - K*s + K + 2*fd*(4*r - 1)*(4*r + 4*s - 3) - 4*r**2 - 4*r*s + 8*r + 3*s - 3) + 6*fd*(K*(2*r + s - 1) - 8*r**2 - 8*r*s + 4*r + s + 1) - 14*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 14*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*(5*f**2*(32*r**2 + 8*r*(4*s - 5) - 14*s + 11) + 6*f*(2*K*(2*r + s - 1) + 16*r**2 + 8*r*(2*s - 3) - 8*s + 7) - 14*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 1980*Dd**2*K*f**2*r**2 - 1980*Dd**2*K*f**2*r*s + 1980*Dd**2*K*f**2*r + 495*Dd**2*K*f**2*s - 330*Dd**2*K*f**2 - 2376*Dd**2*b2*f*r**2 - 2376*Dd**2*b2*f*r*s + 2376*Dd**2*b2*f*r + 594*Dd**2*b2*f*s - 396*Dd**2*b2*f + 8400*Dd**2*f**3*r**2 + 8400*Dd**2*f**3*r*s - 8400*Dd**2*f**3*r - 2100*Dd**2*f**3*s + 1400*Dd**2*f**3 + 5940*Dd**2*f**2*r**2 + 5940*Dd**2*f**2*r*s - 5940*Dd**2*f**2*r - 1485*Dd**2*f**2*s + 990*Dd**2*f**2) + 33*b2*(-6*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*r + 5*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(r - 1)*(r + s - 1) + 6*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 6*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(693*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct**3*k2*(4*C - 4)*(D1*f*(-6*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) - 5*D1*bdd1*f*r*(r + s) + bd1*(D1*(4*f*r*(r + s) - 5*fd*(4*r**2 + 4*r*s - 3*r - s)) - 5*Dd*f*(8*r**2 + r*(8*s - 4) - s))) + b1**2*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-6*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 15*D1**2*fd**2*r + 5*D1**2*fd**2*s - 5*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 25*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k3) - 2*D1**2*Pkd1*Pkd3*ct**2*f*k1*k2**4*st**4*(33*D1**2*bd1*f*(6*C - 5)*(r - 1)*(r + s - 1) + 33*D1*b1*(6*C - 5)*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + (26*C - 21)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)))/(231*d**2*k3**5) - 10*D1**2*Pkd1*Pkd3*ct**2*f*k2**6*st**4*(234*D1**2*b1*f*fd*r**2 + 234*D1**2*b1*f*fd*r*s - 156*D1**2*b1*f*fd*r - 117*D1**2*b1*f*fdd*r**2 - 117*D1**2*b1*f*fdd*r*s + 78*D1**2*b1*f*fdd*r - 234*D1**2*b1*fd**2*r**2 - 234*D1**2*b1*fd**2*r*s + 156*D1**2*b1*fd**2*r - 39*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 188*D1**2*f**2*fd*r**2 + 188*D1**2*f**2*fd*r*s - 188*D1**2*f**2*fd*r - 47*D1**2*f**2*fd*s + 47*D1**2*f**2*fd - 120*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 120*D1**2*f**2*fdd*r + 30*D1**2*f**2*fdd*s - 30*D1**2*f**2*fdd - 360*D1**2*f*fd**2*r**2 - 360*D1**2*f*fd**2*r*s + 360*D1**2*f*fd**2*r + 90*D1**2*f*fd**2*s - 60*D1**2*f*fd**2 + 312*D1*Dd*b1*f**2*r**2 + 312*D1*Dd*b1*f**2*r*s - 312*D1*Dd*b1*f**2*r - 78*D1*Dd*b1*f**2*s + 78*D1*Dd*b1*f**2 - 936*D1*Dd*b1*f*fd*r**2 - 936*D1*Dd*b1*f*fd*r*s + 780*D1*Dd*b1*f*fd*r + 117*D1*Dd*b1*f*fd*s - 78*D1*Dd*b1*f*fd + 188*D1*Dd*f**3*r**2 + 188*D1*Dd*f**3*r*s - 188*D1*Dd*f**3*r - 47*D1*Dd*f**3*s + 47*D1*Dd*f**3 - 960*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 960*D1*Dd*f**2*fd*r + 240*D1*Dd*f**2*fd*s - 180*D1*Dd*f**2*fd - 156*D1*Ddd*b1*f**2*r**2 - 156*D1*Ddd*b1*f**2*r*s + 156*D1*Ddd*b1*f**2*r + 39*D1*Ddd*b1*f**2*s - 39*D1*Ddd*b1*f**2 - 120*D1*Ddd*f**3*r**2 - 120*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r + 30*D1*Ddd*f**3*s - 30*D1*Ddd*f**3 + 39*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 468*Dd**2*b1*f**2*r**2 - 468*Dd**2*b1*f**2*r*s + 468*Dd**2*b1*f**2*r + 117*Dd**2*b1*f**2*s - 78*Dd**2*b1*f**2 - 360*Dd**2*f**3*r**2 - 360*Dd**2*f**3*r*s + 360*Dd**2*f**3*r + 90*Dd**2*f**3*s - 60*Dd**2*f**3)/(3003*d**2*k1*k3**5) - 2*D1**2*Pkd1*Pkd3*ct**2*f*k2**4*st**4*(33*D1**2*bd1*f*(r - 1)*(r + s - 1) + 5*D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + 33*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 5*D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + 5*Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2))/(231*d**2*k1*k3**3) - D1**2*Pkd1*Pkd3*ct**2*k1**5*(4*C - 2)*(264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 330*D1**2*b1*f*fdd*r**2 - 330*D1**2*b1*f*fdd*r*s + 165*D1**2*b1*f*fdd*r - 330*D1**2*b1*fd**2*r**2 - 330*D1**2*b1*fd**2*r*s + 165*D1**2*b1*fd**2*r - 165*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 2640*D1*Dd*b1*f*fd*r*s + 1980*D1*Dd*b1*f*fd*r + 330*D1*Dd*b1*f*fd*s - 165*D1*Dd*b1*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 660*D1*Ddd*b1*f**2*r**2 - 660*D1*Ddd*b1*f**2*r*s + 660*D1*Ddd*b1*f**2*r + 165*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(4*f*(r - 1)*(r + s - 1) - 5*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 5*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 1980*Dd**2*b1*f**2*r**2 - 1980*Dd**2*b1*f**2*r*s + 1980*Dd**2*b1*f**2*r + 495*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3)/(693*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**2*k1**3*k2**2*st**2*(-6204*C*D1**2*b1*f*fd*r**2 - 6204*C*D1**2*b1*f*fd*r*s + 3102*C*D1**2*b1*f*fd*r + 4884*C*D1**2*b1*f*fdd*r**2 + 4884*C*D1**2*b1*f*fdd*r*s - 2442*C*D1**2*b1*f*fdd*r + 4884*C*D1**2*b1*fd**2*r**2 + 4884*C*D1**2*b1*fd**2*r*s - 2442*C*D1**2*b1*fd**2*r - 5754*C*D1**2*f**2*fd*r**2 - 5754*C*D1**2*f**2*fd*r*s + 5754*C*D1**2*f**2*fd*r + 1918*C*D1**2*f**2*fd*s - 1918*C*D1**2*f**2*fd + 5550*C*D1**2*f**2*fdd*r**2 + 5550*C*D1**2*f**2*fdd*r*s - 5550*C*D1**2*f**2*fdd*r - 1850*C*D1**2*f**2*fdd*s + 1850*C*D1**2*f**2*fdd + 11100*C*D1**2*f*fd**2*r**2 + 11100*C*D1**2*f*fd**2*r*s - 11100*C*D1**2*f*fd**2*r - 3700*C*D1**2*f*fd**2*s + 1850*C*D1**2*f*fd**2 - 12408*C*D1*Dd*b1*f**2*r**2 - 12408*C*D1*Dd*b1*f**2*r*s + 12408*C*D1*Dd*b1*f**2*r + 3102*C*D1*Dd*b1*f**2*s - 3102*C*D1*Dd*b1*f**2 + 39072*C*D1*Dd*b1*f*fd*r**2 + 39072*C*D1*Dd*b1*f*fd*r*s - 29304*C*D1*Dd*b1*f*fd*r - 4884*C*D1*Dd*b1*f*fd*s + 2442*C*D1*Dd*b1*f*fd - 7672*C*D1*Dd*f**3*r**2 - 7672*C*D1*Dd*f**3*r*s + 7672*C*D1*Dd*f**3*r + 1918*C*D1*Dd*f**3*s - 1918*C*D1*Dd*f**3 + 44400*C*D1*Dd*f**2*fd*r**2 + 44400*C*D1*Dd*f**2*fd*r*s - 44400*C*D1*Dd*f**2*fd*r - 12950*C*D1*Dd*f**2*fd*s + 9250*C*D1*Dd*f**2*fd + 9768*C*D1*Ddd*b1*f**2*r**2 + 9768*C*D1*Ddd*b1*f**2*r*s - 9768*C*D1*Ddd*b1*f**2*r - 2442*C*D1*Ddd*b1*f**2*s + 2442*C*D1*Ddd*b1*f**2 + 7400*C*D1*Ddd*f**3*r**2 + 7400*C*D1*Ddd*f**3*r*s - 7400*C*D1*Ddd*f**3*r - 1850*C*D1*Ddd*f**3*s + 1850*C*D1*Ddd*f**3 + 29304*C*Dd**2*b1*f**2*r**2 + 29304*C*Dd**2*b1*f**2*r*s - 29304*C*Dd**2*b1*f**2*r - 7326*C*Dd**2*b1*f**2*s + 4884*C*Dd**2*b1*f**2 + 22200*C*Dd**2*f**3*r**2 + 22200*C*Dd**2*f**3*r*s - 22200*C*Dd**2*f**3*r - 5550*C*Dd**2*f**3*s + 3700*C*Dd**2*f**3 + 3894*D1**2*b1*f*fd*r**2 + 3894*D1**2*b1*f*fd*r*s - 1947*D1**2*b1*f*fd*r - 3102*D1**2*b1*f*fdd*r**2 - 3102*D1**2*b1*f*fdd*r*s + 1551*D1**2*b1*f*fdd*r - 3102*D1**2*b1*fd**2*r**2 - 3102*D1**2*b1*fd**2*r*s + 1551*D1**2*b1*fd**2*r + 33*D1**2*bdd1*f**2*(74*C - 47)*(r - 1)*(r + s - 1) + 3585*D1**2*f**2*fd*r**2 + 3585*D1**2*f**2*fd*r*s - 3585*D1**2*f**2*fd*r - 1195*D1**2*f**2*fd*s + 1195*D1**2*f**2*fd - 3525*D1**2*f**2*fdd*r**2 - 3525*D1**2*f**2*fdd*r*s + 3525*D1**2*f**2*fdd*r + 1175*D1**2*f**2*fdd*s - 1175*D1**2*f**2*fdd - 7050*D1**2*f*fd**2*r**2 - 7050*D1**2*f*fd**2*r*s + 7050*D1**2*f*fd**2*r + 2350*D1**2*f*fd**2*s - 1175*D1**2*f*fd**2 + 7788*D1*Dd*b1*f**2*r**2 + 7788*D1*Dd*b1*f**2*r*s - 7788*D1*Dd*b1*f**2*r - 1947*D1*Dd*b1*f**2*s + 1947*D1*Dd*b1*f**2 - 24816*D1*Dd*b1*f*fd*r**2 - 24816*D1*Dd*b1*f*fd*r*s + 18612*D1*Dd*b1*f*fd*r + 3102*D1*Dd*b1*f*fd*s - 1551*D1*Dd*b1*f*fd + 4780*D1*Dd*f**3*r**2 + 4780*D1*Dd*f**3*r*s - 4780*D1*Dd*f**3*r - 1195*D1*Dd*f**3*s + 1195*D1*Dd*f**3 - 28200*D1*Dd*f**2*fd*r**2 - 28200*D1*Dd*f**2*fd*r*s + 28200*D1*Dd*f**2*fd*r + 8225*D1*Dd*f**2*fd*s - 5875*D1*Dd*f**2*fd - 6204*D1*Ddd*b1*f**2*r**2 - 6204*D1*Ddd*b1*f**2*r*s + 6204*D1*Ddd*b1*f**2*r + 1551*D1*Ddd*b1*f**2*s - 1551*D1*Ddd*b1*f**2 - 4700*D1*Ddd*f**3*r**2 - 4700*D1*Ddd*f**3*r*s + 4700*D1*Ddd*f**3*r + 1175*D1*Ddd*f**3*s - 1175*D1*Ddd*f**3 - 33*D1*bd1*f*(D1*(f*(94*C - 59)*(r - 1)*(r + s - 1) - fd*(74*C - 47)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(74*C - 47)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 18612*Dd**2*b1*f**2*r**2 - 18612*Dd**2*b1*f**2*r*s + 18612*Dd**2*b1*f**2*r + 4653*Dd**2*b1*f**2*s - 3102*Dd**2*b1*f**2 - 14100*Dd**2*f**3*r**2 - 14100*Dd**2*f**3*r*s + 14100*Dd**2*f**3*r + 3525*Dd**2*f**3*s - 2350*Dd**2*f**3)/(693*d**2*k3**5) + 2*D1**2*Pkd1*Pkd3*ct**2*k1**3*k2**2*(-1716*D1**2*bd1**2*f*(2*r - 1)*(-15*K + 5*f + 6)*(r + s - 1) - 130*D1**2*bdd1*f*(r + s - 1)*(14*f**2*(3*r + 1) - 33*f*r*(5*K - 2) + 396*g2*(r - 1)) - 5*D1**2*(7*f**3*(38*fd - 45*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) + f**2*(-315*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) - r*(6864*gd2 - 8580*gdd2)*(r + s - 1)) - 1716*f*(fd*(g2*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 8580*fd**2*g2*(2*r**2 + 2*r*(s - 1) - s)) + 13*D1*bd1*(D1*(115*f**3*(3*r + 1)*(r + s - 1) - 4*f**2*(35*fd*(18*r**2 + 2*r*(9*s - 8) - s + 2) + r*(330*K - 132)*(r + s - 1)) + 330*f*(fd*(5*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + (10*g2*(r - 1) + 12*gd2*(1 - 2*r))*(r + s - 1)) - 3960*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 10*Dd*f*(14*f**2*(24*r**2 + 4*r*(6*s - 5) + s) - 33*f*(5*K - 2)*(8*r**2 + 8*r*(s - 1) - s + 1) + 396*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 5*D1*f*(2*Dd*(133*f**3*(4*r**2 + 4*r*(s - 1) - s + 1) - 315*f**2*fd*(4*r - 1)*(4*r + 4*s - 3) - 858*f*(4*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) + 8580*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 15*Ddd*f*(21*f**2 - 572*g2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 75*Dd**2*f**2*(21*f**2 - 572*g2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 858*b1**2*(D1**2*r*(2*f*(4*fd - 5*fdd)*(2*r + 2*s - 1) - 10*fd**2*(2*r + 2*s - 1) - 5*fd*(5*K - 2)*(r + s) + 6*fdd*(5*K - 2)*(r + s)) + D1*(Dd*(8*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(32*r**2 + 8*r*(4*s - 3) - 4*s + 2) + (5*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*fd*(5*K - 2)*(8*r**2 + r*(8*s - 4) - s)) - 2*Ddd*f*(-15*K + 5*f + 6)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 2*Dd**2*f*(-15*K + 5*f + 6)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-2640*D1**2*K*f*fd*r**2 - 2640*D1**2*K*f*fd*r*s + 2640*D1**2*K*f*fd*r + 1320*D1**2*K*f*fd*s - 1320*D1**2*K*f*fd + 3300*D1**2*K*f*fdd*r**2 + 3300*D1**2*K*f*fdd*r*s - 3300*D1**2*K*f*fdd*r - 1650*D1**2*K*f*fdd*s + 1650*D1**2*K*f*fdd + 3300*D1**2*K*fd**2*r**2 + 3300*D1**2*K*fd**2*r*s - 3300*D1**2*K*fd**2*r - 1650*D1**2*K*fd**2*s - 132*D1**2*bdd1*f*(2*r - 1)*(-15*K + 5*f + 6)*(r + s - 1) + 1035*D1**2*f**2*fd*r**2 + 1035*D1**2*f**2*fd*r*s - 1150*D1**2*f**2*fd*r - 460*D1**2*f**2*fd*s + 460*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r**2 - 1260*D1**2*f**2*fdd*r*s + 1400*D1**2*f**2*fdd*r + 560*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd - 2520*D1**2*f*fd**2*r**2 - 2520*D1**2*f*fd**2*r*s + 2800*D1**2*f*fd**2*r + 1120*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 + 1056*D1**2*f*fd*r**2 + 1056*D1**2*f*fd*r*s - 1056*D1**2*f*fd*r - 528*D1**2*f*fd*s + 528*D1**2*f*fd - 1320*D1**2*f*fdd*r**2 - 1320*D1**2*f*fdd*r*s + 1320*D1**2*f*fdd*r + 660*D1**2*f*fdd*s - 660*D1**2*f*fdd + 3300*D1**2*f*gd2*r**2 + 3300*D1**2*f*gd2*r*s - 3300*D1**2*f*gd2*r - 3960*D1**2*f*gdd2*r**2 - 3960*D1**2*f*gdd2*r*s + 3960*D1**2*f*gdd2*r - 1320*D1**2*fd**2*r**2 - 1320*D1**2*fd**2*r*s + 1320*D1**2*fd**2*r + 660*D1**2*fd**2*s + 3300*D1**2*fd*g2*r**2 + 3300*D1**2*fd*g2*r*s - 7920*D1**2*fd*gd2*r**2 - 7920*D1**2*fd*gd2*r*s + 3960*D1**2*fd*gd2*r - 3960*D1**2*fdd*g2*r**2 - 3960*D1**2*fdd*g2*r*s - 5280*D1*Dd*K*f**2*r**2 - 5280*D1*Dd*K*f**2*r*s + 5280*D1*Dd*K*f**2*r + 1320*D1*Dd*K*f**2*s - 1320*D1*Dd*K*f**2 + 26400*D1*Dd*K*f*fd*r**2 + 26400*D1*Dd*K*f*fd*r*s - 26400*D1*Dd*K*f*fd*r - 9900*D1*Dd*K*f*fd*s + 6600*D1*Dd*K*f*fd + 1380*D1*Dd*f**3*r**2 + 1380*D1*Dd*f**3*r*s - 1380*D1*Dd*f**3*r - 345*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r**2 - 10080*D1*Dd*f**2*fd*r*s + 10640*D1*Dd*f**2*fd*r + 3500*D1*Dd*f**2*fd*s - 2520*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*r**2 + 2112*D1*Dd*f**2*r*s - 2112*D1*Dd*f**2*r - 528*D1*Dd*f**2*s + 528*D1*Dd*f**2 - 10560*D1*Dd*f*fd*r**2 - 10560*D1*Dd*f*fd*r*s + 10560*D1*Dd*f*fd*r + 3960*D1*Dd*f*fd*s - 2640*D1*Dd*f*fd + 13200*D1*Dd*f*g2*r**2 + 13200*D1*Dd*f*g2*r*s - 13200*D1*Dd*f*g2*r - 3300*D1*Dd*f*g2*s + 3300*D1*Dd*f*g2 - 31680*D1*Dd*f*gd2*r**2 - 31680*D1*Dd*f*gd2*r*s + 31680*D1*Dd*f*gd2*r + 3960*D1*Dd*f*gd2*s - 3960*D1*Dd*f*gd2 - 31680*D1*Dd*fd*g2*r**2 - 31680*D1*Dd*fd*g2*r*s + 15840*D1*Dd*fd*g2*r + 3960*D1*Dd*fd*g2*s + 6600*D1*Ddd*K*f**2*r**2 + 6600*D1*Ddd*K*f**2*r*s - 6600*D1*Ddd*K*f**2*r - 1650*D1*Ddd*K*f**2*s + 1650*D1*Ddd*K*f**2 - 1680*D1*Ddd*f**3*r**2 - 1680*D1*Ddd*f**3*r*s + 1680*D1*Ddd*f**3*r + 420*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*r**2 - 2640*D1*Ddd*f**2*r*s + 2640*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s - 660*D1*Ddd*f**2 - 15840*D1*Ddd*f*g2*r**2 - 15840*D1*Ddd*f*g2*r*s + 15840*D1*Ddd*f*g2*r + 3960*D1*Ddd*f*g2*s - 3960*D1*Ddd*f*g2 + 66*D1*bd1*(D1*(8*f**2*(2*r - 1)*(r + s - 1) - 5*f*(2*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + (5*K - 2)*(2*r - 1)*(r + s - 1)) + 6*fd*(5*K - 2)*(4*r**2 + r*(4*s - 3) - s)) - 2*Dd*f*(-15*K + 5*f + 6)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 19800*Dd**2*K*f**2*r**2 + 19800*Dd**2*K*f**2*r*s - 19800*Dd**2*K*f**2*r - 4950*Dd**2*K*f**2*s + 3300*Dd**2*K*f**2 - 5040*Dd**2*f**3*r**2 - 5040*Dd**2*f**3*r*s + 5040*Dd**2*f**3*r + 1260*Dd**2*f**3*s - 840*Dd**2*f**3 - 7920*Dd**2*f**2*r**2 - 7920*Dd**2*f**2*r*s + 7920*Dd**2*f**2*r + 1980*Dd**2*f**2*s - 1320*Dd**2*f**2 - 47520*Dd**2*f*g2*r**2 - 47520*Dd**2*f*g2*r*s + 47520*Dd**2*f*g2*r + 11880*Dd**2*f*g2*s - 7920*Dd**2*f*g2))/(9009*d**2*k3**5) - D1**2*Pkd1*Pkd3*ct**2*k1**3*(4*C - 2)*(33*D1*b1*(-6*D1*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + bd1*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + (D1*(-4*f*fd + 5*f*fdd + 5*fd**2) + 20*Dd*f*fd)*(2*r + s - 1)) + 33*b1**2*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + f*(-198*D1**2*bd1**2*(2*r**2 + 2*r*(s - 1) - s) - 165*D1**2*bdd1*f*(2*r + s - 1) - 5*D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 28*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + 33*D1*bd1*(2*r + s - 1)*(4*D1*f - 5*D1*fd - 20*Dd*f) - 5*D1*f*(Dd*(23*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 28*fd*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 28*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 140*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(693*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct**2*k1*k2**4*st**2*(1287*D1**2*K*bdd1*f**2*r**2 + 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*r - 429*D1**2*bd1**2*f*(2*r - 1)*(-3*K + 8*f + 2)*(r + s - 1) + 1300*D1**2*bdd1*f**3*r**2 + 1300*D1**2*bdd1*f**3*r*s - 5200*D1**2*bdd1*f**3*r - 3900*D1**2*bdd1*f**3*s + 3900*D1**2*bdd1*f**3 - 858*D1**2*bdd1*f**2*r**2 - 858*D1**2*bdd1*f**2*r*s + 858*D1**2*bdd1*f**2*r - 2574*D1**2*bdd1*f*g2*r**2 - 2574*D1**2*bdd1*f*g2*r*s + 5148*D1**2*bdd1*f*g2*r + 2574*D1**2*bdd1*f*g2*s - 2574*D1**2*bdd1*f*g2 - 11820*D1**2*f**3*fd*r**2 - 11820*D1**2*f**3*fd*r*s + 11820*D1**2*f**3*fd*r + 2955*D1**2*f**3*fd*s - 2955*D1**2*f**3*fd + 11760*D1**2*f**3*fdd*r**2 + 11760*D1**2*f**3*fdd*r*s - 11760*D1**2*f**3*fdd*r - 2940*D1**2*f**3*fdd*s + 2940*D1**2*f**3*fdd + 35280*D1**2*f**2*fd**2*r**2 + 35280*D1**2*f**2*fd**2*r*s - 35280*D1**2*f**2*fd**2*r - 8820*D1**2*f**2*fd**2*s + 5880*D1**2*f**2*fd**2 + 4290*D1**2*f**2*gd2*r**2 + 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*r - 2574*D1**2*f**2*gdd2*r**2 - 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*r + 8580*D1**2*f*fd*g2*r**2 + 8580*D1**2*f*fd*g2*r*s - 8580*D1**2*f*fd*g2*r - 4290*D1**2*f*fd*g2*s + 4290*D1**2*f*fd*g2 - 10296*D1**2*f*fd*gd2*r**2 - 10296*D1**2*f*fd*gd2*r*s + 10296*D1**2*f*fd*gd2*r + 2574*D1**2*f*fd*gd2*s - 2574*D1**2*f*fd*gd2 - 5148*D1**2*f*fdd*g2*r**2 - 5148*D1**2*f*fdd*g2*r*s + 5148*D1**2*f*fdd*g2*r + 2574*D1**2*f*fdd*g2*s - 2574*D1**2*f*fdd*g2 - 5148*D1**2*fd**2*g2*r**2 - 5148*D1**2*fd**2*g2*r*s + 5148*D1**2*fd**2*g2*r + 2574*D1**2*fd**2*g2*s - 11820*D1*Dd*f**4*r**2 - 11820*D1*Dd*f**4*r*s + 11820*D1*Dd*f**4*r + 2955*D1*Dd*f**4*s - 2955*D1*Dd*f**4 + 94080*D1*Dd*f**3*fd*r**2 + 94080*D1*Dd*f**3*fd*r*s - 94080*D1*Dd*f**3*fd*r - 23520*D1*Dd*f**3*fd*s + 17640*D1*Dd*f**3*fd + 17160*D1*Dd*f**2*g2*r**2 + 17160*D1*Dd*f**2*g2*r*s - 17160*D1*Dd*f**2*g2*r - 4290*D1*Dd*f**2*g2*s + 4290*D1*Dd*f**2*g2 - 20592*D1*Dd*f**2*gd2*r**2 - 20592*D1*Dd*f**2*gd2*r*s + 20592*D1*Dd*f**2*gd2*r + 2574*D1*Dd*f**2*gd2*s - 2574*D1*Dd*f**2*gd2 - 41184*D1*Dd*f*fd*g2*r**2 - 41184*D1*Dd*f*fd*g2*r*s + 41184*D1*Dd*f*fd*g2*r + 15444*D1*Dd*f*fd*g2*s - 10296*D1*Dd*f*fd*g2 + 11760*D1*Ddd*f**4*r**2 + 11760*D1*Ddd*f**4*r*s - 11760*D1*Ddd*f**4*r - 2940*D1*Ddd*f**4*s + 2940*D1*Ddd*f**4 - 10296*D1*Ddd*f**2*g2*r**2 - 10296*D1*Ddd*f**2*g2*r*s + 10296*D1*Ddd*f**2*g2*r + 2574*D1*Ddd*f**2*g2*s - 2574*D1*Ddd*f**2*g2 - 13*D1*bd1*(D1*(f**3*(68*r - 303)*(r + s - 1) - 5*f**2*(20*fd*(6*r**2 + 6*r*(s - 2) - 7*s + 4) - r*(33*K - 22)*(r + s - 1)) - 33*f*(fd*(3*K - 2)*(4*r**2 + 4*r*(s - 1) - s + 1) + (26*g2*(r - 1) + 2*gd2*(3 - 6*r))*(r + s - 1)) + 198*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) + Dd*f*(-100*f**2*(8*r**2 + 4*r*(2*s - 5) - 13*s + 10) - 33*f*(3*K - 2)*(8*r**2 + 8*r*(s - 1) - s + 1) + 198*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 35280*Dd**2*f**4*r**2 + 35280*Dd**2*f**4*r*s - 35280*Dd**2*f**4*r - 8820*Dd**2*f**4*s + 5880*Dd**2*f**4 - 30888*Dd**2*f**2*g2*r**2 - 30888*Dd**2*f**2*g2*r*s + 30888*Dd**2*f**2*g2*r + 7722*Dd**2*f**2*g2*s - 5148*Dd**2*f**2*g2 + 143*b1**2*(D1**2*r*(3*f*(11*fd - 8*fdd)*(2*r + 2*s - 1) - 24*fd**2*(2*r + 2*s - 1) - 13*fd*(3*K - 2)*(r + s) + 3*fdd*(3*K - 2)*(r + s)) + D1*(Dd*(33*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-24*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (26 - 39*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*fd*(3*K - 2)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-3*K + 8*f + 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-3*K + 8*f + 2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-330*D1**2*K*f*fd*r**2 - 330*D1**2*K*f*fd*r*s + 330*D1**2*K*f*fd*r + 165*D1**2*K*f*fd*s - 165*D1**2*K*f*fd + 198*D1**2*K*f*fdd*r**2 + 198*D1**2*K*f*fdd*r*s - 198*D1**2*K*f*fdd*r - 99*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 198*D1**2*K*fd**2*r**2 + 198*D1**2*K*fd**2*r*s - 198*D1**2*K*fd**2*r - 99*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(2*r - 1)*(-3*K + 8*f + 2)*(r + s - 1) - 204*D1**2*f**2*fd*r**2 - 204*D1**2*f**2*fd*r*s - 99*D1**2*f**2*fd*r - 235*D1**2*f**2*fd*s + 235*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s + 200*D1**2*f**2*fdd*s - 200*D1**2*f**2*fdd + 600*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s + 400*D1**2*f*fd**2*s - 200*D1**2*f*fd**2 + 220*D1**2*f*fd*r**2 + 220*D1**2*f*fd*r*s - 220*D1**2*f*fd*r - 110*D1**2*f*fd*s + 110*D1**2*f*fd - 132*D1**2*f*fdd*r**2 - 132*D1**2*f*fdd*r*s + 132*D1**2*f*fdd*r + 66*D1**2*f*fdd*s - 66*D1**2*f*fdd + 858*D1**2*f*gd2*r**2 + 858*D1**2*f*gd2*r*s - 858*D1**2*f*gd2*r - 198*D1**2*f*gdd2*r**2 - 198*D1**2*f*gdd2*r*s + 198*D1**2*f*gdd2*r - 132*D1**2*fd**2*r**2 - 132*D1**2*fd**2*r*s + 132*D1**2*fd**2*r + 66*D1**2*fd**2*s + 858*D1**2*fd*g2*r**2 + 858*D1**2*fd*g2*r*s - 396*D1**2*fd*gd2*r**2 - 396*D1**2*fd*gd2*r*s + 198*D1**2*fd*gd2*r - 198*D1**2*fdd*g2*r**2 - 198*D1**2*fdd*g2*r*s - 660*D1*Dd*K*f**2*r**2 - 660*D1*Dd*K*f**2*r*s + 660*D1*Dd*K*f**2*r + 165*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 1584*D1*Dd*K*f*fd*r**2 + 1584*D1*Dd*K*f*fd*r*s - 1584*D1*Dd*K*f*fd*r - 594*D1*Dd*K*f*fd*s + 396*D1*Dd*K*f*fd - 272*D1*Dd*f**3*r**2 - 272*D1*Dd*f**3*r*s + 272*D1*Dd*f**3*r + 68*D1*Dd*f**3*s - 68*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 1200*D1*Dd*f**2*fd*r + 500*D1*Dd*f**2*fd*s - 400*D1*Dd*f**2*fd + 440*D1*Dd*f**2*r**2 + 440*D1*Dd*f**2*r*s - 440*D1*Dd*f**2*r - 110*D1*Dd*f**2*s + 110*D1*Dd*f**2 - 1056*D1*Dd*f*fd*r**2 - 1056*D1*Dd*f*fd*r*s + 1056*D1*Dd*f*fd*r + 396*D1*Dd*f*fd*s - 264*D1*Dd*f*fd + 3432*D1*Dd*f*g2*r**2 + 3432*D1*Dd*f*g2*r*s - 3432*D1*Dd*f*g2*r - 858*D1*Dd*f*g2*s + 858*D1*Dd*f*g2 - 1584*D1*Dd*f*gd2*r**2 - 1584*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r + 198*D1*Dd*f*gd2*s - 198*D1*Dd*f*gd2 - 1584*D1*Dd*fd*g2*r**2 - 1584*D1*Dd*fd*g2*r*s + 792*D1*Dd*fd*g2*r + 198*D1*Dd*fd*g2*s + 396*D1*Ddd*K*f**2*r**2 + 396*D1*Ddd*K*f**2*r*s - 396*D1*Ddd*K*f**2*r - 99*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 + 400*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 400*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s + 100*D1*Ddd*f**3 - 264*D1*Ddd*f**2*r**2 - 264*D1*Ddd*f**2*r*s + 264*D1*Ddd*f**2*r + 66*D1*Ddd*f**2*s - 66*D1*Ddd*f**2 - 792*D1*Ddd*f*g2*r**2 - 792*D1*Ddd*f*g2*r*s + 792*D1*Ddd*f*g2*r + 198*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(33*f**2*(2*r - 1)*(r + s - 1) + f*(-24*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (39*K - 26)*(2*r - 1)*(r + s - 1)) + 3*fd*(3*K - 2)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-3*K + 8*f + 2)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1188*Dd**2*K*f**2*r**2 + 1188*Dd**2*K*f**2*r*s - 1188*Dd**2*K*f**2*r - 297*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 + 1200*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 1200*Dd**2*f**3*r - 300*Dd**2*f**3*s + 200*Dd**2*f**3 - 792*Dd**2*f**2*r**2 - 792*Dd**2*f**2*r*s + 792*Dd**2*f**2*r + 198*Dd**2*f**2*s - 132*Dd**2*f**2 - 2376*Dd**2*f*g2*r**2 - 2376*Dd**2*f*g2*r*s + 2376*Dd**2*f*g2*r + 594*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(3003*d**2*k3**5) + D1**2*Pkd1*Pkd3*ct**2*k1*k2**2*st**2*(-11*b1**2*(D1**2*r*(fd*(70*C - 57) + fdd*(11 - 14*C))*(r + s - 1) + D1*(Dd*(f*(70*C - 57)*(4*r**2 + 4*r*(s - 1) - s + 1) - fd*(14*C - 11)*(8*r**2 + 8*r*(s - 1) - s + 1)) - Ddd*f*(14*C - 11)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(14*C - 11)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 11*b1*(-52*C*D1**2*f*fd*r**2 - 52*C*D1**2*f*fd*r*s - 18*C*D1**2*f*fd*r - 22*C*D1**2*f*fd*s + 22*C*D1**2*f*fd + 44*C*D1**2*f*fdd*r**2 + 44*C*D1**2*f*fdd*r*s + 6*C*D1**2*f*fdd*r + 14*C*D1**2*f*fdd*s - 14*C*D1**2*f*fdd + 44*C*D1**2*fd**2*r**2 + 44*C*D1**2*fd**2*r*s + 6*C*D1**2*fd**2*r + 14*C*D1**2*fd**2*s - 14*C*D1**2*fd**2 - 104*C*D1*Dd*f**2*r**2 - 104*C*D1*Dd*f**2*r*s + 104*C*D1*Dd*f**2*r + 26*C*D1*Dd*f**2*s - 26*C*D1*Dd*f**2 + 352*C*D1*Dd*f*fd*r**2 + 352*C*D1*Dd*f*fd*r*s - 152*C*D1*Dd*f*fd*r + 12*C*D1*Dd*f*fd*s - 34*C*D1*Dd*f*fd + 88*C*D1*Ddd*f**2*r**2 + 88*C*D1*Ddd*f**2*r*s - 88*C*D1*Ddd*f**2*r - 22*C*D1*Ddd*f**2*s + 22*C*D1*Ddd*f**2 + 264*C*Dd**2*f**2*r**2 + 264*C*Dd**2*f**2*r*s - 264*C*Dd**2*f**2*r - 66*C*Dd**2*f**2*s + 44*C*Dd**2*f**2 - D1**2*bdd1*f*(14*C - 11)*(2*r**2 + 2*r*(s - 1) - s + 1) + 36*D1**2*f*fd*r**2 + 36*D1**2*f*fd*r*s + 16*D1**2*f*fd*r + 17*D1**2*f*fd*s - 17*D1**2*f*fd - 32*D1**2*f*fdd*r**2 - 32*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 11*D1**2*f*fdd*s + 11*D1**2*f*fdd - 32*D1**2*fd**2*r**2 - 32*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 11*D1**2*fd**2*s + 11*D1**2*fd**2 + 72*D1*Dd*f**2*r**2 + 72*D1*Dd*f**2*r*s - 72*D1*Dd*f**2*r - 18*D1*Dd*f**2*s + 18*D1*Dd*f**2 - 256*D1*Dd*f*fd*r**2 - 256*D1*Dd*f*fd*r*s + 104*D1*Dd*f*fd*r - 12*D1*Dd*f*fd*s + 28*D1*Dd*f*fd - 64*D1*Ddd*f**2*r**2 - 64*D1*Ddd*f**2*r*s + 64*D1*Ddd*f**2*r + 16*D1*Ddd*f**2*s - 16*D1*Ddd*f**2 + D1*bd1*(D1*(f*(70*C - 57)*(2*r**2 + 2*r*(s - 1) - s + 1) - fd*(14*C - 11)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd*f*(28*C - 22)*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 192*Dd**2*f**2*r**2 - 192*Dd**2*f**2*r*s + 192*Dd**2*f**2*r + 48*Dd**2*f**2*s - 32*Dd**2*f**2) + f*(1008*C*D1**2*f*fd*r**2 + 1008*C*D1**2*f*fd*r*s - 1008*C*D1**2*f*fd*r - 336*C*D1**2*f*fd*s + 336*C*D1**2*f*fd - 900*C*D1**2*f*fdd*r**2 - 900*C*D1**2*f*fdd*r*s + 900*C*D1**2*f*fdd*r + 300*C*D1**2*f*fdd*s - 300*C*D1**2*f*fdd - 1800*C*D1**2*fd**2*r**2 - 1800*C*D1**2*fd**2*r*s + 1800*C*D1**2*fd**2*r + 600*C*D1**2*fd**2*s - 300*C*D1**2*fd**2 + 1344*C*D1*Dd*f**2*r**2 + 1344*C*D1*Dd*f**2*r*s - 1344*C*D1*Dd*f**2*r - 336*C*D1*Dd*f**2*s + 336*C*D1*Dd*f**2 - 7200*C*D1*Dd*f*fd*r**2 - 7200*C*D1*Dd*f*fd*r*s + 7200*C*D1*Dd*f*fd*r + 2100*C*D1*Dd*f*fd*s - 1500*C*D1*Dd*f*fd - 1200*C*D1*Ddd*f**2*r**2 - 1200*C*D1*Ddd*f**2*r*s + 1200*C*D1*Ddd*f**2*r + 300*C*D1*Ddd*f**2*s - 300*C*D1*Ddd*f**2 - 3600*C*Dd**2*f**2*r**2 - 3600*C*Dd**2*f**2*r*s + 3600*C*Dd**2*f**2*r + 900*C*Dd**2*f**2*s - 600*C*Dd**2*f**2 + 11*D1**2*bd1**2*(14*C - 11)*(2*r**2 + 2*r*(s - 1) - s) - 11*D1**2*bdd1*f*(C*(22*r**2 + 22*r*s - 72*r - 36*s + 36) - 16*r**2 - 16*r*s + 54*r + 27*s - 27) - 723*D1**2*f*fd*r**2 - 723*D1**2*f*fd*r*s + 723*D1**2*f*fd*r + 241*D1**2*f*fd*s - 241*D1**2*f*fd + 675*D1**2*f*fdd*r**2 + 675*D1**2*f*fdd*r*s - 675*D1**2*f*fdd*r - 225*D1**2*f*fdd*s + 225*D1**2*f*fdd + 1350*D1**2*fd**2*r**2 + 1350*D1**2*fd**2*r*s - 1350*D1**2*fd**2*r - 450*D1**2*fd**2*s + 225*D1**2*fd**2 - 964*D1*Dd*f**2*r**2 - 964*D1*Dd*f**2*r*s + 964*D1*Dd*f**2*r + 241*D1*Dd*f**2*s - 241*D1*Dd*f**2 + 5400*D1*Dd*f*fd*r**2 + 5400*D1*Dd*f*fd*r*s - 5400*D1*Dd*f*fd*r - 1575*D1*Dd*f*fd*s + 1125*D1*Dd*f*fd + 900*D1*Ddd*f**2*r**2 + 900*D1*Ddd*f**2*r*s - 900*D1*Ddd*f**2*r - 225*D1*Ddd*f**2*s + 225*D1*Ddd*f**2 + 11*D1*bd1*(D1*(f*(C*(26*r**2 + 26*r*s - 96*r - 48*s + 48) - 18*r**2 - 18*r*s + 70*r + 35*s - 35) + fd*(-2*C*(44*r**2 + 44*r*s - 69*r - 29*s + 18) + 64*r**2 + 64*r*s - 102*r - 43*s + 27)) - 2*Dd*f*(C*(88*r**2 + 88*r*s - 188*r - 83*s + 72) - 64*r**2 - 64*r*s + 140*r + 62*s - 54)) + 2700*Dd**2*f**2*r**2 + 2700*Dd**2*f**2*r*s - 2700*Dd**2*f**2*r - 675*Dd**2*f**2*s + 450*Dd**2*f**2))/(231*d**2*k3**3) + 2*D1**2*Pkd1*Pkd3*ct**2*k1*k2**2*(1188*D1**2*K*bd1**2*f*r + 594*D1**2*K*bd1**2*f*s - 594*D1**2*K*bd1**2*f + 396*D1**2*K*bd1*f**2*r**2 + 396*D1**2*K*bd1*f**2*r*s - 396*D1**2*K*bd1*f**2*r - 1980*D1**2*K*bd1*f*fd*r**2 - 1980*D1**2*K*bd1*f*fd*r*s + 1980*D1**2*K*bd1*f*fd*r + 495*D1**2*K*bd1*f*fd*s - 495*D1**2*K*bd1*f*fd - 495*D1**2*K*bdd1*f**2*r**2 - 495*D1**2*K*bdd1*f**2*r*s + 495*D1**2*K*bdd1*f**2*r + 660*D1**2*bd1**2*f**2*r**2 + 660*D1**2*bd1**2*f**2*r*s - 1485*D1**2*bd1**2*f**2*r - 660*D1**2*bd1**2*f**2*s + 495*D1**2*bd1**2*f**2 + 396*D1**2*bd1**2*f*r**2 + 396*D1**2*bd1**2*f*r*s - 1386*D1**2*bd1**2*f*r - 594*D1**2*bd1**2*f*s + 594*D1**2*bd1**2*f - 2772*D1**2*bd1**2*g2*r**2 - 2772*D1**2*bd1**2*g2*r*s + 2772*D1**2*bd1**2*g2*r + 1386*D1**2*bd1**2*g2*s - 1188*D1**2*bd1*bd2*f*r**2 - 1188*D1**2*bd1*bd2*f*r*s + 1782*D1**2*bd1*bd2*f*r + 594*D1**2*bd1*bd2*f*s - 594*D1**2*bd1*bd2*f - 460*D1**2*bd1*f**3*r**2 - 460*D1**2*bd1*f**3*r*s + 345*D1**2*bd1*f**3*r + 3360*D1**2*bd1*f**2*fd*r**2 + 3360*D1**2*bd1*f**2*fd*r*s - 3080*D1**2*bd1*f**2*fd*r - 560*D1**2*bd1*f**2*fd*s + 420*D1**2*bd1*f**2*fd - 396*D1**2*bd1*f**2*r**2 - 396*D1**2*bd1*f**2*r*s + 396*D1**2*bd1*f**2*r + 1980*D1**2*bd1*f*fd*r**2 + 1980*D1**2*bd1*f*fd*r*s - 1980*D1**2*bd1*f*fd*r - 495*D1**2*bd1*f*fd*s + 495*D1**2*bd1*f*fd + 1980*D1**2*bd1*f*g2*r + 990*D1**2*bd1*f*g2*s - 990*D1**2*bd1*f*g2 - 2376*D1**2*bd1*f*gd2*r - 1188*D1**2*bd1*f*gd2*s + 1188*D1**2*bd1*f*gd2 + 396*D1**2*bd2*f**2*r**2 + 396*D1**2*bd2*f**2*r*s - 396*D1**2*bd2*f**2*r - 1980*D1**2*bd2*f*fd*r**2 - 1980*D1**2*bd2*f*fd*r*s + 1980*D1**2*bd2*f*fd*r + 495*D1**2*bd2*f*fd*s - 495*D1**2*bd2*f*fd + 560*D1**2*bdd1*f**3*r**2 + 560*D1**2*bdd1*f**3*r*s - 420*D1**2*bdd1*f**3*r + 495*D1**2*bdd1*f**2*r**2 + 495*D1**2*bdd1*f**2*r*s - 495*D1**2*bdd1*f**2*r - 2376*D1**2*bdd1*f*g2*r - 1188*D1**2*bdd1*f*g2*s + 1188*D1**2*bdd1*f*g2 - 495*D1**2*bdd2*f**2*r**2 - 495*D1**2*bdd2*f**2*r*s + 495*D1**2*bdd2*f**2*r - 792*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r + 990*D1**2*f**2*gdd2*r**2 + 990*D1**2*f**2*gdd2*r*s - 990*D1**2*f**2*gdd2*r - 1584*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 1584*D1**2*f*fd*g2*r + 792*D1**2*f*fd*g2*s - 792*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r**2 + 3960*D1**2*f*fd*gd2*r*s - 3960*D1**2*f*fd*gd2*r - 990*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r**2 + 1980*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r - 990*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r**2 + 1980*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r - 990*D1**2*fd**2*g2*s - 3960*D1*Dd*K*bd1*f**2*r**2 - 3960*D1*Dd*K*bd1*f**2*r*s + 3960*D1*Dd*K*bd1*f**2*r + 495*D1*Dd*K*bd1*f**2*s - 495*D1*Dd*K*bd1*f**2 + 4480*D1*Dd*bd1*f**3*r**2 + 4480*D1*Dd*bd1*f**3*r*s - 3920*D1*Dd*bd1*f**3*r - 560*D1*Dd*bd1*f**3*s + 420*D1*Dd*bd1*f**3 + 3960*D1*Dd*bd1*f**2*r**2 + 3960*D1*Dd*bd1*f**2*r*s - 3960*D1*Dd*bd1*f**2*r - 495*D1*Dd*bd1*f**2*s + 495*D1*Dd*bd1*f**2 - 9504*D1*Dd*bd1*f*g2*r - 4752*D1*Dd*bd1*f*g2*s + 4752*D1*Dd*bd1*f*g2 - 3960*D1*Dd*bd2*f**2*r**2 - 3960*D1*Dd*bd2*f**2*r*s + 3960*D1*Dd*bd2*f**2*r + 495*D1*Dd*bd2*f**2*s - 495*D1*Dd*bd2*f**2 - 3168*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 3168*D1*Dd*f**2*g2*r + 792*D1*Dd*f**2*g2*s - 792*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r**2 + 7920*D1*Dd*f**2*gd2*r*s - 7920*D1*Dd*f**2*gd2*r - 990*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r**2 + 15840*D1*Dd*f*fd*g2*r*s - 15840*D1*Dd*f*fd*g2*r - 5940*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 + 3960*D1*Ddd*f**2*g2*r**2 + 3960*D1*Ddd*f**2*g2*r*s - 3960*D1*Ddd*f**2*g2*r - 990*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 11880*Dd**2*f**2*g2*r**2 + 11880*Dd**2*f**2*g2*r*s - 11880*Dd**2*f**2*g2*r - 2970*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1**3*(2*D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(2*Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1) - (21*K - 14)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-21*K + 12*f + 14)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-21*K + 12*f + 14)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1**2*(30*D1**2*K*fd*r + 15*D1**2*K*fd*s - 15*D1**2*K*fd - 36*D1**2*K*fdd*r - 18*D1**2*K*fdd*s + 18*D1**2*K*fdd - D1**2*bdd1*(-21*K + 12*f + 14)*(3*r**2 + 3*r*(s - 1) - s + 1) - 16*D1**2*f*fd*r**2 - 16*D1**2*f*fd*r*s - 4*D1**2*f*fd*r - 8*D1**2*f*fd*s + 8*D1**2*f*fd + 20*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s + 5*D1**2*f*fdd*r + 10*D1**2*f*fdd*s - 10*D1**2*f*fdd + 20*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s + 5*D1**2*fd**2*r + 10*D1**2*fd**2*s - 10*D1**2*fd**2 - 5*D1**2*fd*r**2 - 5*D1**2*fd*r*s - 20*D1**2*fd*r - 10*D1**2*fd*s + 10*D1**2*fd + 6*D1**2*fdd*r**2 + 6*D1**2*fdd*r*s + 24*D1**2*fdd*r + 12*D1**2*fdd*s - 12*D1**2*fdd + 84*D1**2*gd2*r**2 + 84*D1**2*gd2*r*s - 84*D1**2*gd2*r - 42*D1**2*gdd2*r**2 - 42*D1**2*gdd2*r*s + 42*D1**2*gdd2*r - 144*D1*Dd*K*fd*r - 72*D1*Dd*K*fd*s + 72*D1*Dd*K*fd - 32*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 32*D1*Dd*f**2*r + 8*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 60*D1*Dd*f*fd*r + 20*D1*Dd*f*fd*s - 25*D1*Dd*f*fd - 20*D1*Dd*f*r**2 - 20*D1*Dd*f*r*s + 20*D1*Dd*f*r + 5*D1*Dd*f*s - 5*D1*Dd*f + 48*D1*Dd*fd*r**2 + 48*D1*Dd*fd*r*s + 72*D1*Dd*fd*r + 42*D1*Dd*fd*s - 48*D1*Dd*fd + 336*D1*Dd*g2*r**2 + 336*D1*Dd*g2*r*s - 336*D1*Dd*g2*r - 84*D1*Dd*g2*s + 84*D1*Dd*g2 - 336*D1*Dd*gd2*r**2 - 336*D1*Dd*gd2*r*s + 336*D1*Dd*gd2*r + 42*D1*Dd*gd2*s - 42*D1*Dd*gd2 + 40*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 40*D1*Ddd*f**2*r - 10*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 24*D1*Ddd*f*r*s - 24*D1*Ddd*f*r - 6*D1*Ddd*f*s + 6*D1*Ddd*f - 168*D1*Ddd*g2*r**2 - 168*D1*Ddd*g2*r*s + 168*D1*Ddd*g2*r + 42*D1*Ddd*g2*s - 42*D1*Ddd*g2 + D1*bd1*(2*D1*(5*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 6*fd*(6*r**2 + 6*r*(s - 1) - s + 1) - (21*K - 14)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-21*K + 12*f + 14)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 120*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 120*Dd**2*f**2*r - 30*Dd**2*f**2*s + 20*Dd**2*f**2 + 72*Dd**2*f*r**2 + 72*Dd**2*f*r*s - 72*Dd**2*f*r - 18*Dd**2*f*s + 12*Dd**2*f - 504*Dd**2*g2*r**2 - 504*Dd**2*g2*r*s + 504*Dd**2*g2*r + 126*Dd**2*g2*s - 84*Dd**2*g2) + b1*(792*D1**2*K*f*fd*r**2 + 792*D1**2*K*f*fd*r*s - 792*D1**2*K*f*fd*r - 396*D1**2*K*f*fd*s + 396*D1**2*K*f*fd - 990*D1**2*K*f*fdd*r**2 - 990*D1**2*K*f*fdd*r*s + 990*D1**2*K*f*fdd*r + 495*D1**2*K*f*fdd*s - 495*D1**2*K*f*fdd - 990*D1**2*K*fd**2*r**2 - 990*D1**2*K*fd**2*r*s + 990*D1**2*K*fd**2*r + 495*D1**2*K*fd**2*s + 495*D1**2*b2*fd*r**2 + 495*D1**2*b2*fd*r*s - 594*D1**2*b2*fdd*r**2 - 594*D1**2*b2*fdd*r*s - 33*D1**2*bd1**2*(-21*K + 12*f + 14)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 495*D1**2*bd2*f*r**2 + 495*D1**2*bd2*f*r*s - 495*D1**2*bd2*f*r - 1188*D1**2*bd2*fd*r**2 - 1188*D1**2*bd2*fd*r*s + 594*D1**2*bd2*fd*r + 33*D1**2*bdd1*(5*f**2*(4*r**2 + r*(4*s - 9) - 4*s + 4) + 6*f*(3*K*(2*r + s - 1) + 2*r**2 + 2*r*s - 7*r - 3*s + 3) - 42*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) - 594*D1**2*bdd2*f*r**2 - 594*D1**2*bdd2*f*r*s + 594*D1**2*bdd2*f*r - 1380*D1**2*f**2*fd*r**2 - 1380*D1**2*f**2*fd*r*s + 1495*D1**2*f**2*fd*r + 460*D1**2*f**2*fd*s - 460*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*r**2 + 1680*D1**2*f**2*fdd*r*s - 1820*D1**2*f**2*fdd*r - 560*D1**2*f**2*fdd*s + 560*D1**2*f**2*fdd + 3360*D1**2*f*fd**2*r**2 + 3360*D1**2*f*fd**2*r*s - 3640*D1**2*f*fd**2*r - 1120*D1**2*f*fd**2*s + 700*D1**2*f*fd**2 - 792*D1**2*f*fd*r**2 - 792*D1**2*f*fd*r*s + 792*D1**2*f*fd*r + 396*D1**2*f*fd*s - 396*D1**2*f*fd + 990*D1**2*f*fdd*r**2 + 990*D1**2*f*fdd*r*s - 990*D1**2*f*fdd*r - 495*D1**2*f*fdd*s + 495*D1**2*f*fdd + 990*D1**2*fd**2*r**2 + 990*D1**2*fd**2*r*s - 990*D1**2*fd**2*r - 495*D1**2*fd**2*s - 1980*D1**2*fd*g2*r - 990*D1**2*fd*g2*s + 990*D1**2*fd*g2 + 2376*D1**2*fd*gd2*r + 1188*D1**2*fd*gd2*s - 1188*D1**2*fd*gd2 + 2376*D1**2*fdd*g2*r + 1188*D1**2*fdd*g2*s - 1188*D1**2*fdd*g2 + 1584*D1*Dd*K*f**2*r**2 + 1584*D1*Dd*K*f**2*r*s - 1584*D1*Dd*K*f**2*r - 396*D1*Dd*K*f**2*s + 396*D1*Dd*K*f**2 - 7920*D1*Dd*K*f*fd*r**2 - 7920*D1*Dd*K*f*fd*r*s + 7920*D1*Dd*K*f*fd*r + 2970*D1*Dd*K*f*fd*s - 1980*D1*Dd*K*f*fd + 1980*D1*Dd*b2*f*r**2 + 1980*D1*Dd*b2*f*r*s - 1980*D1*Dd*b2*f*r - 495*D1*Dd*b2*f*s + 495*D1*Dd*b2*f - 4752*D1*Dd*b2*fd*r**2 - 4752*D1*Dd*b2*fd*r*s + 2376*D1*Dd*b2*fd*r + 594*D1*Dd*b2*fd*s - 4752*D1*Dd*bd2*f*r**2 - 4752*D1*Dd*bd2*f*r*s + 4752*D1*Dd*bd2*f*r + 594*D1*Dd*bd2*f*s - 594*D1*Dd*bd2*f - 1840*D1*Dd*f**3*r**2 - 1840*D1*Dd*f**3*r*s + 1840*D1*Dd*f**3*r + 460*D1*Dd*f**3*s - 460*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*r**2 + 13440*D1*Dd*f**2*fd*r*s - 14000*D1*Dd*f**2*fd*r - 3920*D1*Dd*f**2*fd*s + 2940*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*r**2 - 1584*D1*Dd*f**2*r*s + 1584*D1*Dd*f**2*r + 396*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 7920*D1*Dd*f*fd*r**2 + 7920*D1*Dd*f*fd*r*s - 7920*D1*Dd*f*fd*r - 2970*D1*Dd*f*fd*s + 1980*D1*Dd*f*fd + 9504*D1*Dd*fd*g2*r + 4752*D1*Dd*fd*g2*s - 4752*D1*Dd*fd*g2 - 1980*D1*Ddd*K*f**2*r**2 - 1980*D1*Ddd*K*f**2*r*s + 1980*D1*Ddd*K*f**2*r + 495*D1*Ddd*K*f**2*s - 495*D1*Ddd*K*f**2 - 2376*D1*Ddd*b2*f*r**2 - 2376*D1*Ddd*b2*f*r*s + 2376*D1*Ddd*b2*f*r + 594*D1*Ddd*b2*f*s - 594*D1*Ddd*b2*f + 2240*D1*Ddd*f**3*r**2 + 2240*D1*Ddd*f**3*r*s - 2240*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s + 560*D1*Ddd*f**3 + 1980*D1*Ddd*f**2*r**2 + 1980*D1*Ddd*f**2*r*s - 1980*D1*Ddd*f**2*r - 495*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 - 33*D1*bd1*(D1*(4*f**2*(4*r**2 + r*(4*s - 9) - 4*s + 4) - 5*f*(-3*K*(2*r + s - 1) + fd*(4*r - 1)*(4*r + 4*s - 3) - 2*r**2 - 2*r*s + 7*r + 3*s - 3) - 6*fd*(-3*K*(2*r + s - 1) + 4*r**2 + 4*r*s + r + s - 2) - 42*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) - 42*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) - Dd*(5*f**2*(32*r**2 + 4*r*(8*s - 13) - 20*s + 17) + 6*f*(12*K*(2*r + s - 1) + 16*r**2 + 4*r*(4*s - 9) - 14*s + 13) - 84*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) - 5940*Dd**2*K*f**2*r**2 - 5940*Dd**2*K*f**2*r*s + 5940*Dd**2*K*f**2*r + 1485*Dd**2*K*f**2*s - 990*Dd**2*K*f**2 - 7128*Dd**2*b2*f*r**2 - 7128*Dd**2*b2*f*r*s + 7128*Dd**2*b2*f*r + 1782*Dd**2*b2*f*s - 1188*Dd**2*b2*f + 6720*Dd**2*f**3*r**2 + 6720*Dd**2*f**3*r*s - 6720*Dd**2*f**3*r - 1680*Dd**2*f**3*s + 1120*Dd**2*f**3 + 5940*Dd**2*f**2*r**2 + 5940*Dd**2*f**2*r*s - 5940*Dd**2*f**2*r - 1485*Dd**2*f**2*s + 990*Dd**2*f**2) + 99*b2*(-6*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*r + 5*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(r - 1)*(r + s - 1) + 6*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 6*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(693*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct**2*k1*(4*C - 2)*(D1*f*(-6*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) - 5*D1*bdd1*f*r*(r + s) + bd1*(D1*(4*f*r*(r + s) - 5*fd*(4*r**2 + 4*r*s - 3*r - s)) - 5*Dd*f*(8*r**2 + r*(8*s - 4) - s))) + b1**2*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 6*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-6*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 15*D1**2*fd**2*r + 5*D1**2*fd**2*s - 5*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 25*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k3) + D1**2*Pkd1*Pkd3*ct**2*k2**4*st**2*(D1*f*(33*D1*bd1**2*(2*f*(4*r**2 + 4*r*s - 5*r - 2*s + 1) + (2*r - 1)*(r + s - 1)) + D1*bdd1*f*r*(50*f*(2*r + 2*s - 1) + 33*r + 33*s - 33) + bd1*(D1*(-f*r*(67*f*(2*r + 2*s - 1) + 55*r + 55*s - 55) + fd*(50*f*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1) + 132*r**2 + 132*r*(s - 1) - 33*s + 33)) + Dd*f*(50*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 264*r**2 + 264*r*(s - 1) - 33*s + 33))) - 11*b1**2*(D1**2*r*(3*f*(3*fd - 2*fdd)*(4*r + 4*s - 3) - 6*fd**2*(4*r + 4*s - 3) + 13*fd*(r + s) - 3*fdd*(r + s)) + D1*(Dd*(18*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-6*fd*(8*r - 1)*(4*r + 4*s - 3) + 52*r**2 + 52*r*(s - 1) - 13*s + 13) + 3*fd*(-8*r**2 + r*(4 - 8*s) + s)) - 3*Ddd*f*(4*f + 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(4*f + 1)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(33*D1**2*bdd1*f*(2*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + (2*r - 1)*(r + s - 1)) - 402*D1**2*f**2*fd*r**2 - 402*D1**2*f**2*fd*r*s + 469*D1**2*f**2*fd*r + 134*D1**2*f**2*fd*s - 134*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s - 350*D1**2*f**2*fdd*r - 100*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 600*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s - 700*D1**2*f*fd**2*r - 200*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 110*D1**2*f*fd*r**2 - 110*D1**2*f*fd*r*s + 110*D1**2*f*fd*r + 55*D1**2*f*fd*s - 55*D1**2*f*fd + 66*D1**2*f*fdd*r**2 + 66*D1**2*f*fdd*r*s - 66*D1**2*f*fdd*r - 33*D1**2*f*fdd*s + 33*D1**2*f*fdd + 66*D1**2*fd**2*r**2 + 66*D1**2*fd**2*r*s - 66*D1**2*fd**2*r - 33*D1**2*fd**2*s - 536*D1*Dd*f**3*r**2 - 536*D1*Dd*f**3*r*s + 536*D1*Dd*f**3*r + 134*D1*Dd*f**3*s - 134*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 2600*D1*Dd*f**2*fd*r - 700*D1*Dd*f**2*fd*s + 550*D1*Dd*f**2*fd - 220*D1*Dd*f**2*r**2 - 220*D1*Dd*f**2*r*s + 220*D1*Dd*f**2*r + 55*D1*Dd*f**2*s - 55*D1*Dd*f**2 + 528*D1*Dd*f*fd*r**2 + 528*D1*Dd*f*fd*r*s - 528*D1*Dd*f*fd*r - 198*D1*Dd*f*fd*s + 132*D1*Dd*f*fd + 400*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 400*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s + 100*D1*Ddd*f**3 + 132*D1*Ddd*f**2*r**2 + 132*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r - 33*D1*Ddd*f**2*s + 33*D1*Ddd*f**2 - 11*D1*bd1*(D1*(9*f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(-6*fd*(4*r - 1)*(4*r + 4*s - 3) + (26*r - 13)*(r + s - 1)) + 3*fd*(-4*r**2 + r*(3 - 4*s) + s)) - 3*Dd*f*(2*f*(8*r - 3)*(4*r + 4*s - 3) + 16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1200*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 1200*Dd**2*f**3*r - 300*Dd**2*f**3*s + 200*Dd**2*f**3 + 396*Dd**2*f**2*r**2 + 396*Dd**2*f**2*r*s - 396*Dd**2*f**2*r - 99*Dd**2*f**2*s + 66*Dd**2*f**2))/(231*d**2*k1*k3**3) + D1**2*Pkd1*Pkd3*ct**2*k2**2*st**2*(D1*f*(3*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + 3*D1*bdd1*f*r*(r + s) + bd1*(D1*(-5*f*r*(r + s) + 3*fd*(4*r**2 + 4*r*s - 3*r - s)) + 3*Dd*f*(8*r**2 + r*(8*s - 4) - s))) + b1**2*(-D1**2*r*(13*fd - 3*fdd)*(r + s - 1) + D1*(Dd*(-13*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(3*D1**2*bdd1*f*(2*r**2 + 2*r*(s - 1) - s + 1) - 10*D1**2*f*fd*r**2 - 10*D1**2*f*fd*r*s + 15*D1**2*f*fd*r + 5*D1**2*f*fd*s - 5*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s - 9*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s - 9*D1**2*fd**2*r - 3*D1**2*fd**2*s + 3*D1**2*fd**2 - 20*D1*Dd*f**2*r**2 - 20*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r + 5*D1*Dd*f**2*s - 5*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s - 60*D1*Dd*f*fd*r - 18*D1*Dd*f*fd*s + 15*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r - 3*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + D1*bd1*(D1*(-13*f*(2*r**2 + 2*r*(s - 1) - s + 1) + 3*fd*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 36*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s - 36*Dd**2*f**2*r - 9*Dd**2*f**2*s + 6*Dd**2*f**2))/(21*d**2*k1*k3) - 2*D1**2*Pkd1*Pkd3*ct**2*k2**2*(-D1**2*bd1**2*f*r*(5*f + 6)*(2*r + 2*s - 1) - D1*b1*(D1*bd1**2*(6*f + 7)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + D1*bdd1*f*r*(5*f + 6)*(2*r + 2*s - 1) + bd1*(D1*(5*f*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - f*r*(4*f + 5)*(2*r + 2*s - 1) + 6*fd*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*f*(5*f + 6)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1))) + b1**3*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1) + 56*r**2 + 56*r*(s - 1) - 14*s + 14) - Ddd*(6*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(6*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(-D1**2*bdd1*(6*f + 7)*(3*r**2 + 3*r*(s - 1) - s + 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 15*D1**2*fd**2*r + 5*D1**2*fd**2*s - 5*D1**2*fd**2 + 5*D1**2*fd*r**2 + 5*D1**2*fd*r*s - 10*D1**2*fd*r - 5*D1**2*fd*s + 5*D1**2*fd - 6*D1**2*fdd*r**2 - 6*D1**2*fdd*r*s + 12*D1**2*fdd*r + 6*D1**2*fdd*s - 6*D1**2*fdd + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 25*D1*Dd*f*fd + 20*D1*Dd*f*r**2 + 20*D1*Dd*f*r*s - 20*D1*Dd*f*r - 5*D1*Dd*f*s + 5*D1*Dd*f - 48*D1*Dd*fd*r**2 - 48*D1*Dd*fd*r*s + 72*D1*Dd*fd*r + 30*D1*Dd*fd*s - 24*D1*Dd*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 - 24*D1*Ddd*f*r**2 - 24*D1*Ddd*f*r*s + 24*D1*Ddd*f*r + 6*D1*Ddd*f*s - 6*D1*Ddd*f + D1*bd1*(D1*(5*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 6*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + 42*r**2 + 42*r*(s - 1) - 14*s + 14) - Dd*(6*f + 7)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2 - 72*Dd**2*f*r**2 - 72*Dd**2*f*r*s + 72*Dd**2*f*r + 18*Dd**2*f*s - 12*Dd**2*f))/(21*d**2*k1*k3) - 4*D1**2*Pkd1*Pkd3*ct*f*k1**2*k2**3*st**4*(33*D1**2*bd1*f*(3*C - 2)*(r - 1)*(r + s - 1) + 33*D1*b1*(3*C - 2)*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + (11*C - 7)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)))/(231*d**2*k3**5) + 2*D1**2*Pkd1*Pkd3*ct*f*k2**5*st**4*(429*D1*b1**2*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 13*b1*(33*D1**2*bd1*f*(2*r - 1)*(r + s - 1) - 5*D1**2*(f*(2*fd - fdd)*(9*r**2 + r*(9*s - 5) + s - 1) + fd**2*(-18*r**2 - 2*r*(9*s - 5) - 2*s + 1)) - 5*D1*f*(Dd*(6*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(-72*r**2 - 8*r*(9*s - 7) + 5*s - 3)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 15*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + f*(65*D1**2*bdd1*f*(3*r - 4)*(r + s - 1) - 8*D1**2*(f*(37*fd - 25*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 25*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 65*D1*bd1*(D1*(2*f*(3*r - 4)*(r + s - 1) + fd*(-18*r**2 - 18*r*s + 26*r + 11*s - 7)) + Dd*f*(-24*r**2 - 8*r*(3*s - 5) + 19*s - 15)) - 8*D1*f*(Dd*(37*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 50*fd*(4*r - 1)*(4*r + 4*s - 3)) - 25*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 200*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(3003*d**2*k3**5) + 4*D1**2*Pkd1*Pkd3*ct*f*k2**3*st**4*(33*D1**2*bd1*f*(C - 1)*(r - 1)*(r + s - 1) + 33*D1*b1*(C - 1)*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + (5*C - 4)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)))/(231*d**2*k3**3) - 2*D1**2*Pkd1*Pkd3*ct*k1**4*k2*st**2*(858*C*D1**2*b1*f*fd*r**2 + 858*C*D1**2*b1*f*fd*r*s - 429*C*D1**2*b1*f*fd*r - 726*C*D1**2*b1*f*fdd*r**2 - 726*C*D1**2*b1*f*fdd*r*s + 363*C*D1**2*b1*f*fdd*r - 726*C*D1**2*b1*fd**2*r**2 - 726*C*D1**2*b1*fd**2*r*s + 363*C*D1**2*b1*fd**2*r + 759*C*D1**2*f**2*fd*r**2 + 759*C*D1**2*f**2*fd*r*s - 759*C*D1**2*f**2*fd*r - 253*C*D1**2*f**2*fd*s + 253*C*D1**2*f**2*fd - 825*C*D1**2*f**2*fdd*r**2 - 825*C*D1**2*f**2*fdd*r*s + 825*C*D1**2*f**2*fdd*r + 275*C*D1**2*f**2*fdd*s - 275*C*D1**2*f**2*fdd - 1650*C*D1**2*f*fd**2*r**2 - 1650*C*D1**2*f*fd**2*r*s + 1650*C*D1**2*f*fd**2*r + 550*C*D1**2*f*fd**2*s - 275*C*D1**2*f*fd**2 + 1716*C*D1*Dd*b1*f**2*r**2 + 1716*C*D1*Dd*b1*f**2*r*s - 1716*C*D1*Dd*b1*f**2*r - 429*C*D1*Dd*b1*f**2*s + 429*C*D1*Dd*b1*f**2 - 5808*C*D1*Dd*b1*f*fd*r**2 - 5808*C*D1*Dd*b1*f*fd*r*s + 4356*C*D1*Dd*b1*f*fd*r + 726*C*D1*Dd*b1*f*fd*s - 363*C*D1*Dd*b1*f*fd + 1012*C*D1*Dd*f**3*r**2 + 1012*C*D1*Dd*f**3*r*s - 1012*C*D1*Dd*f**3*r - 253*C*D1*Dd*f**3*s + 253*C*D1*Dd*f**3 - 6600*C*D1*Dd*f**2*fd*r**2 - 6600*C*D1*Dd*f**2*fd*r*s + 6600*C*D1*Dd*f**2*fd*r + 1925*C*D1*Dd*f**2*fd*s - 1375*C*D1*Dd*f**2*fd - 1452*C*D1*Ddd*b1*f**2*r**2 - 1452*C*D1*Ddd*b1*f**2*r*s + 1452*C*D1*Ddd*b1*f**2*r + 363*C*D1*Ddd*b1*f**2*s - 363*C*D1*Ddd*b1*f**2 - 1100*C*D1*Ddd*f**3*r**2 - 1100*C*D1*Ddd*f**3*r*s + 1100*C*D1*Ddd*f**3*r + 275*C*D1*Ddd*f**3*s - 275*C*D1*Ddd*f**3 - 4356*C*Dd**2*b1*f**2*r**2 - 4356*C*Dd**2*b1*f**2*r*s + 4356*C*Dd**2*b1*f**2*r + 1089*C*Dd**2*b1*f**2*s - 726*C*Dd**2*b1*f**2 - 3300*C*Dd**2*f**3*r**2 - 3300*C*Dd**2*f**3*r*s + 3300*C*Dd**2*f**3*r + 825*C*Dd**2*f**3*s - 550*C*Dd**2*f**3 - 462*D1**2*b1*f*fd*r**2 - 462*D1**2*b1*f*fd*r*s + 231*D1**2*b1*f*fd*r + 396*D1**2*b1*f*fdd*r**2 + 396*D1**2*b1*f*fdd*r*s - 198*D1**2*b1*f*fdd*r + 396*D1**2*b1*fd**2*r**2 + 396*D1**2*b1*fd**2*r*s - 198*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(11*C - 6)*(r - 1)*(r + s - 1) - 405*D1**2*f**2*fd*r**2 - 405*D1**2*f**2*fd*r*s + 405*D1**2*f**2*fd*r + 135*D1**2*f**2*fd*s - 135*D1**2*f**2*fd + 450*D1**2*f**2*fdd*r**2 + 450*D1**2*f**2*fdd*r*s - 450*D1**2*f**2*fdd*r - 150*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd + 900*D1**2*f*fd**2*r**2 + 900*D1**2*f*fd**2*r*s - 900*D1**2*f*fd**2*r - 300*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 924*D1*Dd*b1*f**2*r**2 - 924*D1*Dd*b1*f**2*r*s + 924*D1*Dd*b1*f**2*r + 231*D1*Dd*b1*f**2*s - 231*D1*Dd*b1*f**2 + 3168*D1*Dd*b1*f*fd*r**2 + 3168*D1*Dd*b1*f*fd*r*s - 2376*D1*Dd*b1*f*fd*r - 396*D1*Dd*b1*f*fd*s + 198*D1*Dd*b1*f*fd - 540*D1*Dd*f**3*r**2 - 540*D1*Dd*f**3*r*s + 540*D1*Dd*f**3*r + 135*D1*Dd*f**3*s - 135*D1*Dd*f**3 + 3600*D1*Dd*f**2*fd*r**2 + 3600*D1*Dd*f**2*fd*r*s - 3600*D1*Dd*f**2*fd*r - 1050*D1*Dd*f**2*fd*s + 750*D1*Dd*f**2*fd + 792*D1*Ddd*b1*f**2*r**2 + 792*D1*Ddd*b1*f**2*r*s - 792*D1*Ddd*b1*f**2*r - 198*D1*Ddd*b1*f**2*s + 198*D1*Ddd*b1*f**2 + 600*D1*Ddd*f**3*r**2 + 600*D1*Ddd*f**3*r*s - 600*D1*Ddd*f**3*r - 150*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(13*C - 7)*(r - 1)*(r + s - 1) - fd*(11*C - 6)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(11*C - 6)*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 2376*Dd**2*b1*f**2*r**2 + 2376*Dd**2*b1*f**2*r*s - 2376*Dd**2*b1*f**2*r - 594*Dd**2*b1*f**2*s + 396*Dd**2*b1*f**2 + 1800*Dd**2*f**3*r**2 + 1800*Dd**2*f**3*r*s - 1800*Dd**2*f**3*r - 450*Dd**2*f**3*s + 300*Dd**2*f**3)/(693*d**2*k3**5) + 2*D1**2*Pkd1*Pkd3*ct*k1**4*k2*(-33*D1**2*bd1**2*f*(2*r - 1)*(-30*K + 5*f + 6)*(r + s - 1) - 5*D1**2*bdd1*f*(f*r*(-165*K + 28*f + 33) + 396*g2*(r - 1))*(r + s - 1) + 330*D1**2*(f**2*r*(4*gd2 - 5*gdd2)*(r + s - 1) + f*(fd*(g2*(8*r**2 + 8*r*(s - 1) - 4*s + 4) - 5*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 5*fdd*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 5*fd**2*g2*(-2*r**2 - 2*r*(s - 1) + s)) + D1*bd1*(D1*(115*f**3*r*(r + s - 1) - 4*f**2*(35*fd*(6*r**2 + 6*r*(s - 1) - s + 1) + r*(165*K - 33)*(r + s - 1)) + 165*f*(fd*(5*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (10*g2*(r - 1) + 12*gd2*(1 - 2*r))*(r + s - 1)) - 1980*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 5*Dd*f*(28*f**2*(8*r**2 + 8*r*(s - 1) - s + 1) - 33*f*(5*K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 396*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 330*D1*f*(Dd*(f*(4*g2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*gd2*(8*r**2 + 8*r*(s - 1) - s + 1)) - 10*fd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 5*Ddd*f*g2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 1650*Dd**2*f**2*g2*(12*r**2 + 12*r*(s - 1) - 3*s + 2) + 33*b1**2*(D1**2*r*(f*(4*fd - 5*fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 5*fd*(5*K - 1)*(r + s) + 6*fdd*(5*K - 1)*(r + s)) + D1*(Dd*(4*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - 5*f*(fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (5*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 6*fd*(5*K - 1)*(8*r**2 + r*(8*s - 4) - s)) - Ddd*f*(-30*K + 5*f + 6)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(-30*K + 5*f + 6)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(-1320*D1**2*K*f*fd*r**2 - 1320*D1**2*K*f*fd*r*s + 1320*D1**2*K*f*fd*r + 660*D1**2*K*f*fd*s - 660*D1**2*K*f*fd + 1650*D1**2*K*f*fdd*r**2 + 1650*D1**2*K*f*fdd*r*s - 1650*D1**2*K*f*fdd*r - 825*D1**2*K*f*fdd*s + 825*D1**2*K*f*fdd + 1650*D1**2*K*fd**2*r**2 + 1650*D1**2*K*fd**2*r*s - 1650*D1**2*K*fd**2*r - 825*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(2*r - 1)*(-30*K + 5*f + 6)*(r + s - 1) + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 264*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 264*D1**2*f*fd*r - 132*D1**2*f*fd*s + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 330*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r + 165*D1**2*f*fdd*s - 165*D1**2*f*fdd + 1650*D1**2*f*gd2*r**2 + 1650*D1**2*f*gd2*r*s - 1650*D1**2*f*gd2*r - 1980*D1**2*f*gdd2*r**2 - 1980*D1**2*f*gdd2*r*s + 1980*D1**2*f*gdd2*r - 330*D1**2*fd**2*r**2 - 330*D1**2*fd**2*r*s + 330*D1**2*fd**2*r + 165*D1**2*fd**2*s + 1650*D1**2*fd*g2*r**2 + 1650*D1**2*fd*g2*r*s - 3960*D1**2*fd*gd2*r**2 - 3960*D1**2*fd*gd2*r*s + 1980*D1**2*fd*gd2*r - 1980*D1**2*fdd*g2*r**2 - 1980*D1**2*fdd*g2*r*s - 2640*D1*Dd*K*f**2*r**2 - 2640*D1*Dd*K*f**2*r*s + 2640*D1*Dd*K*f**2*r + 660*D1*Dd*K*f**2*s - 660*D1*Dd*K*f**2 + 13200*D1*Dd*K*f*fd*r**2 + 13200*D1*Dd*K*f*fd*r*s - 13200*D1*Dd*K*f*fd*r - 4950*D1*Dd*K*f*fd*s + 3300*D1*Dd*K*f*fd + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 528*D1*Dd*f**2*r - 132*D1*Dd*f**2*s + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 2640*D1*Dd*f*fd*r*s + 2640*D1*Dd*f*fd*r + 990*D1*Dd*f*fd*s - 660*D1*Dd*f*fd + 6600*D1*Dd*f*g2*r**2 + 6600*D1*Dd*f*g2*r*s - 6600*D1*Dd*f*g2*r - 1650*D1*Dd*f*g2*s + 1650*D1*Dd*f*g2 - 15840*D1*Dd*f*gd2*r**2 - 15840*D1*Dd*f*gd2*r*s + 15840*D1*Dd*f*gd2*r + 1980*D1*Dd*f*gd2*s - 1980*D1*Dd*f*gd2 - 15840*D1*Dd*fd*g2*r**2 - 15840*D1*Dd*fd*g2*r*s + 7920*D1*Dd*fd*g2*r + 1980*D1*Dd*fd*g2*s + 3300*D1*Ddd*K*f**2*r**2 + 3300*D1*Ddd*K*f**2*r*s - 3300*D1*Ddd*K*f**2*r - 825*D1*Ddd*K*f**2*s + 825*D1*Ddd*K*f**2 - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 - 660*D1*Ddd*f**2*r*s + 660*D1*Ddd*f**2*r + 165*D1*Ddd*f**2*s - 165*D1*Ddd*f**2 - 7920*D1*Ddd*f*g2*r**2 - 7920*D1*Ddd*f*g2*r*s + 7920*D1*Ddd*f*g2*r + 1980*D1*Ddd*f*g2*s - 1980*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(4*f**2*(2*r - 1)*(r + s - 1) - 5*f*(fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) + (5*K - 1)*(2*r - 1)*(r + s - 1)) + 6*fd*(5*K - 1)*(4*r**2 + r*(4*s - 3) - s)) - Dd*f*(-30*K + 5*f + 6)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 9900*Dd**2*K*f**2*r**2 + 9900*Dd**2*K*f**2*r*s - 9900*Dd**2*K*f**2*r - 2475*Dd**2*K*f**2*s + 1650*Dd**2*K*f**2 - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3 - 1980*Dd**2*f**2*r**2 - 1980*Dd**2*f**2*r*s + 1980*Dd**2*f**2*r + 495*Dd**2*f**2*s - 330*Dd**2*f**2 - 23760*Dd**2*f*g2*r**2 - 23760*Dd**2*f*g2*r*s + 23760*Dd**2*f*g2*r + 5940*Dd**2*f*g2*s - 3960*Dd**2*f*g2))/(693*d**2*k3**5) - D1**2*Pkd1*Pkd3*ct*k1**2*k2**3*st**2*(-3861*D1**2*K*bdd1*f**2*r**2 - 3861*D1**2*K*bdd1*f**2*r*s + 3861*D1**2*K*bdd1*f**2*r + 1287*D1**2*bd1**2*f*(2*r - 1)*(-3*K + 6*f + 1)*(r + s - 1) + 1950*D1**2*bdd1*f**3*r**2 + 1950*D1**2*bdd1*f**3*r*s + 1950*D1**2*bdd1*f**3*r + 3900*D1**2*bdd1*f**3*s - 3900*D1**2*bdd1*f**3 + 1287*D1**2*bdd1*f**2*r**2 + 1287*D1**2*bdd1*f**2*r*s - 1287*D1**2*bdd1*f**2*r + 7722*D1**2*bdd1*f*g2*r**2 + 7722*D1**2*bdd1*f*g2*r*s - 15444*D1**2*bdd1*f*g2*r - 7722*D1**2*bdd1*f*g2*s + 7722*D1**2*bdd1*f*g2 + 10520*D1**2*f**3*fd*r**2 + 10520*D1**2*f**3*fd*r*s - 10520*D1**2*f**3*fd*r - 2630*D1**2*f**3*fd*s + 2630*D1**2*f**3*fd - 11760*D1**2*f**3*fdd*r**2 - 11760*D1**2*f**3*fdd*r*s + 11760*D1**2*f**3*fdd*r + 2940*D1**2*f**3*fdd*s - 2940*D1**2*f**3*fdd - 35280*D1**2*f**2*fd**2*r**2 - 35280*D1**2*f**2*fd**2*r*s + 35280*D1**2*f**2*fd**2*r + 8820*D1**2*f**2*fd**2*s - 5880*D1**2*f**2*fd**2 - 12870*D1**2*f**2*gd2*r**2 - 12870*D1**2*f**2*gd2*r*s + 12870*D1**2*f**2*gd2*r + 7722*D1**2*f**2*gdd2*r**2 + 7722*D1**2*f**2*gdd2*r*s - 7722*D1**2*f**2*gdd2*r - 25740*D1**2*f*fd*g2*r**2 - 25740*D1**2*f*fd*g2*r*s + 25740*D1**2*f*fd*g2*r + 12870*D1**2*f*fd*g2*s - 12870*D1**2*f*fd*g2 + 30888*D1**2*f*fd*gd2*r**2 + 30888*D1**2*f*fd*gd2*r*s - 30888*D1**2*f*fd*gd2*r - 7722*D1**2*f*fd*gd2*s + 7722*D1**2*f*fd*gd2 + 15444*D1**2*f*fdd*g2*r**2 + 15444*D1**2*f*fdd*g2*r*s - 15444*D1**2*f*fdd*g2*r - 7722*D1**2*f*fdd*g2*s + 7722*D1**2*f*fdd*g2 + 15444*D1**2*fd**2*g2*r**2 + 15444*D1**2*fd**2*g2*r*s - 15444*D1**2*fd**2*g2*r - 7722*D1**2*fd**2*g2*s + 10520*D1*Dd*f**4*r**2 + 10520*D1*Dd*f**4*r*s - 10520*D1*Dd*f**4*r - 2630*D1*Dd*f**4*s + 2630*D1*Dd*f**4 - 94080*D1*Dd*f**3*fd*r**2 - 94080*D1*Dd*f**3*fd*r*s + 94080*D1*Dd*f**3*fd*r + 23520*D1*Dd*f**3*fd*s - 17640*D1*Dd*f**3*fd - 51480*D1*Dd*f**2*g2*r**2 - 51480*D1*Dd*f**2*g2*r*s + 51480*D1*Dd*f**2*g2*r + 12870*D1*Dd*f**2*g2*s - 12870*D1*Dd*f**2*g2 + 61776*D1*Dd*f**2*gd2*r**2 + 61776*D1*Dd*f**2*gd2*r*s - 61776*D1*Dd*f**2*gd2*r - 7722*D1*Dd*f**2*gd2*s + 7722*D1*Dd*f**2*gd2 + 123552*D1*Dd*f*fd*g2*r**2 + 123552*D1*Dd*f*fd*g2*r*s - 123552*D1*Dd*f*fd*g2*r - 46332*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 11760*D1*Ddd*f**4*r**2 - 11760*D1*Ddd*f**4*r*s + 11760*D1*Ddd*f**4*r + 2940*D1*Ddd*f**4*s - 2940*D1*Ddd*f**4 + 30888*D1*Ddd*f**2*g2*r**2 + 30888*D1*Ddd*f**2*g2*r*s - 30888*D1*Ddd*f**2*g2*r - 7722*D1*Ddd*f**2*g2*s + 7722*D1*Ddd*f**2*g2 - 39*D1*bd1*(D1*(6*f**3*(13*r + 15)*(r + s - 1) - 5*f**2*(10*fd*(6*r**2 + r*(6*s - 2) + 3*s - 1) + r*(33*K - 11)*(r + s - 1)) + 33*f*(fd*(3*K - 1)*(4*r**2 + 4*r*(s - 1) - s + 1) + (26*g2*(r - 1) + 2*gd2*(3 - 6*r))*(r + s - 1)) - 198*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - Dd*f*(50*f**2*(8*r**2 + 8*r*s + 7*s - 5) - 33*f*(3*K - 1)*(8*r**2 + 8*r*(s - 1) - s + 1) + 198*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 35280*Dd**2*f**4*r**2 - 35280*Dd**2*f**4*r*s + 35280*Dd**2*f**4*r + 8820*Dd**2*f**4*s - 5880*Dd**2*f**4 + 92664*Dd**2*f**2*g2*r**2 + 92664*Dd**2*f**2*g2*r*s - 92664*Dd**2*f**2*g2*r - 23166*Dd**2*f**2*g2*s + 15444*Dd**2*f**2*g2 - 429*b1**2*(D1**2*r*(6*f*(4*fd - 3*fdd)*(2*r + 2*s - 1) - 18*fd**2*(2*r + 2*s - 1) - 13*fd*(3*K - 1)*(r + s) + 3*fdd*(3*K - 1)*(r + s)) + D1*(Dd*(24*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) + f*(-18*fd*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + (13 - 39*K)*(4*r**2 + 4*r*(s - 1) - s + 1)) + 3*fd*(3*K - 1)*(8*r**2 + r*(8*s - 4) - s)) - 3*Ddd*f*(-3*K + 6*f + 1)*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(-3*K + 6*f + 1)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 39*b1*(-330*D1**2*K*f*fd*r**2 - 330*D1**2*K*f*fd*r*s + 330*D1**2*K*f*fd*r + 165*D1**2*K*f*fd*s - 165*D1**2*K*f*fd + 198*D1**2*K*f*fdd*r**2 + 198*D1**2*K*f*fdd*r*s - 198*D1**2*K*f*fdd*r - 99*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 198*D1**2*K*fd**2*r**2 + 198*D1**2*K*fd**2*r*s - 198*D1**2*K*fd**2*r - 99*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(2*r - 1)*(-3*K + 6*f + 1)*(r + s - 1) + 234*D1**2*f**2*fd*r**2 + 234*D1**2*f**2*fd*r*s - 324*D1**2*f**2*fd*r - 168*D1**2*f**2*fd*s + 168*D1**2*f**2*fd - 150*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 250*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s - 150*D1**2*f**2*fdd - 300*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 500*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s - 150*D1**2*f*fd**2 + 110*D1**2*f*fd*r**2 + 110*D1**2*f*fd*r*s - 110*D1**2*f*fd*r - 55*D1**2*f*fd*s + 55*D1**2*f*fd - 66*D1**2*f*fdd*r**2 - 66*D1**2*f*fdd*r*s + 66*D1**2*f*fdd*r + 33*D1**2*f*fdd*s - 33*D1**2*f*fdd + 858*D1**2*f*gd2*r**2 + 858*D1**2*f*gd2*r*s - 858*D1**2*f*gd2*r - 198*D1**2*f*gdd2*r**2 - 198*D1**2*f*gdd2*r*s + 198*D1**2*f*gdd2*r - 66*D1**2*fd**2*r**2 - 66*D1**2*fd**2*r*s + 66*D1**2*fd**2*r + 33*D1**2*fd**2*s + 858*D1**2*fd*g2*r**2 + 858*D1**2*fd*g2*r*s - 396*D1**2*fd*gd2*r**2 - 396*D1**2*fd*gd2*r*s + 198*D1**2*fd*gd2*r - 198*D1**2*fdd*g2*r**2 - 198*D1**2*fdd*g2*r*s - 660*D1*Dd*K*f**2*r**2 - 660*D1*Dd*K*f**2*r*s + 660*D1*Dd*K*f**2*r + 165*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 1584*D1*Dd*K*f*fd*r**2 + 1584*D1*Dd*K*f*fd*r*s - 1584*D1*Dd*K*f*fd*r - 594*D1*Dd*K*f*fd*s + 396*D1*Dd*K*f*fd + 312*D1*Dd*f**3*r**2 + 312*D1*Dd*f**3*r*s - 312*D1*Dd*f**3*r - 78*D1*Dd*f**3*s + 78*D1*Dd*f**3 - 1200*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 1600*D1*Dd*f**2*fd*r + 750*D1*Dd*f**2*fd*s - 550*D1*Dd*f**2*fd + 220*D1*Dd*f**2*r**2 + 220*D1*Dd*f**2*r*s - 220*D1*Dd*f**2*r - 55*D1*Dd*f**2*s + 55*D1*Dd*f**2 - 528*D1*Dd*f*fd*r**2 - 528*D1*Dd*f*fd*r*s + 528*D1*Dd*f*fd*r + 198*D1*Dd*f*fd*s - 132*D1*Dd*f*fd + 3432*D1*Dd*f*g2*r**2 + 3432*D1*Dd*f*g2*r*s - 3432*D1*Dd*f*g2*r - 858*D1*Dd*f*g2*s + 858*D1*Dd*f*g2 - 1584*D1*Dd*f*gd2*r**2 - 1584*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r + 198*D1*Dd*f*gd2*s - 198*D1*Dd*f*gd2 - 1584*D1*Dd*fd*g2*r**2 - 1584*D1*Dd*fd*g2*r*s + 792*D1*Dd*fd*g2*r + 198*D1*Dd*fd*g2*s + 396*D1*Ddd*K*f**2*r**2 + 396*D1*Ddd*K*f**2*r*s - 396*D1*Ddd*K*f**2*r - 99*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 - 200*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 200*D1*Ddd*f**3*r + 50*D1*Ddd*f**3*s - 50*D1*Ddd*f**3 - 132*D1*Ddd*f**2*r**2 - 132*D1*Ddd*f**2*r*s + 132*D1*Ddd*f**2*r + 33*D1*Ddd*f**2*s - 33*D1*Ddd*f**2 - 792*D1*Ddd*f*g2*r**2 - 792*D1*Ddd*f*g2*r*s + 792*D1*Ddd*f*g2*r + 198*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 11*D1*bd1*(D1*(24*f**2*(2*r - 1)*(r + s - 1) + f*(-18*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (39*K - 13)*(2*r - 1)*(r + s - 1)) + 3*fd*(3*K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(-3*K + 6*f + 1)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1188*Dd**2*K*f**2*r**2 + 1188*Dd**2*K*f**2*r*s - 1188*Dd**2*K*f**2*r - 297*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 - 600*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 600*Dd**2*f**3*r + 150*Dd**2*f**3*s - 100*Dd**2*f**3 - 396*Dd**2*f**2*r**2 - 396*Dd**2*f**2*r*s + 396*Dd**2*f**2*r + 99*Dd**2*f**2*s - 66*Dd**2*f**2 - 2376*Dd**2*f*g2*r**2 - 2376*Dd**2*f*g2*r*s + 2376*Dd**2*f*g2*r + 594*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(9009*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*ct*k1**2*k2*st**2*(33*b1**2*(D1**2*r*(fd*(31*C - 20) + fdd*(3 - 5*C))*(r + s - 1) + D1*(Dd*(f*(31*C - 20)*(4*r**2 + 4*r*(s - 1) - s + 1) - fd*(5*C - 3)*(8*r**2 + 8*r*(s - 1) - s + 1)) - Ddd*f*(5*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(5*C - 3)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1*(-8*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r*s - 10*C*D1**2*f*fd*r - 7*C*D1**2*f*fd*s + 7*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r**2 + 8*C*D1**2*f*fdd*r*s + 6*C*D1**2*f*fdd*r + 5*C*D1**2*f*fdd*s - 5*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r**2 + 8*C*D1**2*fd**2*r*s + 6*C*D1**2*fd**2*r + 5*C*D1**2*fd**2*s - 5*C*D1**2*fd**2 - 16*C*D1*Dd*f**2*r**2 - 16*C*D1*Dd*f**2*r*s + 16*C*D1*Dd*f**2*r + 4*C*D1*Dd*f**2*s - 4*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r**2 + 64*C*D1*Dd*f*fd*r*s - 8*C*D1*Dd*f*fd*r + 12*C*D1*Dd*f*fd*s - 16*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r**2 + 16*C*D1*Ddd*f**2*r*s - 16*C*D1*Ddd*f**2*r - 4*C*D1*Ddd*f**2*s + 4*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r**2 + 48*C*Dd**2*f**2*r*s - 48*C*Dd**2*f**2*r - 12*C*Dd**2*f**2*s + 8*C*Dd**2*f**2 - D1**2*bdd1*f*(5*C - 3)*(2*r**2 + 2*r*(s - 1) - s + 1) + 4*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 4*D1**2*f*fd*s - 4*D1**2*f*fd - 4*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r - 3*D1**2*f*fdd*s + 3*D1**2*f*fdd - 4*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s - 4*D1**2*fd**2*r - 3*D1**2*fd**2*s + 3*D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 32*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s - 8*D1*Dd*f*fd*s + 10*D1*Dd*f*fd - 8*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 8*D1*Ddd*f**2*r + 2*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + D1*bd1*(D1*(f*(31*C - 20)*(2*r**2 + 2*r*(s - 1) - s + 1) - fd*(5*C - 3)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd*f*(10*C - 6)*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 24*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 24*Dd**2*f**2*r + 6*Dd**2*f**2*s - 4*Dd**2*f**2) + f*(-657*C*D1**2*f*fd*r**2 - 657*C*D1**2*f*fd*r*s + 657*C*D1**2*f*fd*r + 219*C*D1**2*f*fd*s - 219*C*D1**2*f*fd + 675*C*D1**2*f*fdd*r**2 + 675*C*D1**2*f*fdd*r*s - 675*C*D1**2*f*fdd*r - 225*C*D1**2*f*fdd*s + 225*C*D1**2*f*fdd + 1350*C*D1**2*fd**2*r**2 + 1350*C*D1**2*fd**2*r*s - 1350*C*D1**2*fd**2*r - 450*C*D1**2*fd**2*s + 225*C*D1**2*fd**2 - 876*C*D1*Dd*f**2*r**2 - 876*C*D1*Dd*f**2*r*s + 876*C*D1*Dd*f**2*r + 219*C*D1*Dd*f**2*s - 219*C*D1*Dd*f**2 + 5400*C*D1*Dd*f*fd*r**2 + 5400*C*D1*Dd*f*fd*r*s - 5400*C*D1*Dd*f*fd*r - 1575*C*D1*Dd*f*fd*s + 1125*C*D1*Dd*f*fd + 900*C*D1*Ddd*f**2*r**2 + 900*C*D1*Ddd*f**2*r*s - 900*C*D1*Ddd*f**2*r - 225*C*D1*Ddd*f**2*s + 225*C*D1*Ddd*f**2 + 2700*C*Dd**2*f**2*r**2 + 2700*C*Dd**2*f**2*r*s - 2700*C*Dd**2*f**2*r - 675*C*Dd**2*f**2*s + 450*C*Dd**2*f**2 - 33*D1**2*bd1**2*(5*C - 3)*(2*r**2 + 2*r*(s - 1) - s) + 33*D1**2*bdd1*f*(C*(4*r**2 + 2*r*(2*s - 9) - 9*s + 9) - 2*r**2 - 2*r*(s - 5) + 5*s - 5) + 354*D1**2*f*fd*r**2 + 354*D1**2*f*fd*r*s - 354*D1**2*f*fd*r - 118*D1**2*f*fd*s + 118*D1**2*f*fd - 375*D1**2*f*fdd*r**2 - 375*D1**2*f*fdd*r*s + 375*D1**2*f*fdd*r + 125*D1**2*f*fdd*s - 125*D1**2*f*fdd - 750*D1**2*fd**2*r**2 - 750*D1**2*fd**2*r*s + 750*D1**2*fd**2*r + 250*D1**2*fd**2*s - 125*D1**2*fd**2 + 472*D1*Dd*f**2*r**2 + 472*D1*Dd*f**2*r*s - 472*D1*Dd*f**2*r - 118*D1*Dd*f**2*s + 118*D1*Dd*f**2 - 3000*D1*Dd*f*fd*r**2 - 3000*D1*Dd*f*fd*r*s + 3000*D1*Dd*f*fd*r + 875*D1*Dd*f*fd*s - 625*D1*Dd*f*fd - 500*D1*Ddd*f**2*r**2 - 500*D1*Ddd*f**2*r*s + 500*D1*Ddd*f**2*r + 125*D1*Ddd*f**2*s - 125*D1*Ddd*f**2 - 33*D1*bd1*(D1*(f*(C*(4*r**2 + 4*r*s - 22*r - 11*s + 11) - 2*r**2 - 2*r*(s - 6) + 6*s - 6) + fd*(C*(-16*r**2 + r*(30 - 16*s) + 13*s - 9) + 8*r**2 + 8*r*(s - 2) - 7*s + 5)) + 2*Dd*f*(-2*C*(8*r**2 + r*(8*s - 22) - 10*s + 9) + 8*r**2 + 8*r*(s - 3) - 11*s + 10)) - 1500*Dd**2*f**2*r**2 - 1500*Dd**2*f**2*r*s + 1500*Dd**2*f**2*r + 375*Dd**2*f**2*s - 250*Dd**2*f**2))/(693*d**2*k3**3) + 2*D1**2*Pkd1*Pkd3*ct*k1**2*k2*(1188*D1**2*K*bd1**2*f*r + 594*D1**2*K*bd1**2*f*s - 594*D1**2*K*bd1**2*f + 396*D1**2*K*bd1*f**2*r**2 + 396*D1**2*K*bd1*f**2*r*s - 396*D1**2*K*bd1*f**2*r - 1980*D1**2*K*bd1*f*fd*r**2 - 1980*D1**2*K*bd1*f*fd*r*s + 1980*D1**2*K*bd1*f*fd*r + 495*D1**2*K*bd1*f*fd*s - 495*D1**2*K*bd1*f*fd - 495*D1**2*K*bdd1*f**2*r**2 - 495*D1**2*K*bdd1*f**2*r*s + 495*D1**2*K*bdd1*f**2*r - 330*D1**2*bd1**2*f**2*r - 165*D1**2*bd1**2*f**2*s + 165*D1**2*bd1**2*f**2 - 396*D1**2*bd1**2*f*r - 198*D1**2*bd1**2*f*s + 198*D1**2*bd1**2*f - 2772*D1**2*bd1**2*g2*r**2 - 2772*D1**2*bd1**2*g2*r*s + 2772*D1**2*bd1**2*g2*r + 1386*D1**2*bd1**2*g2*s - 1188*D1**2*bd1*bd2*f*r**2 - 1188*D1**2*bd1*bd2*f*r*s + 1782*D1**2*bd1*bd2*f*r + 594*D1**2*bd1*bd2*f*s - 594*D1**2*bd1*bd2*f - 115*D1**2*bd1*f**3*r**2 - 115*D1**2*bd1*f**3*r*s + 115*D1**2*bd1*f**3*r + 840*D1**2*bd1*f**2*fd*r**2 + 840*D1**2*bd1*f**2*fd*r*s - 840*D1**2*bd1*f**2*fd*r - 140*D1**2*bd1*f**2*fd*s + 140*D1**2*bd1*f**2*fd - 132*D1**2*bd1*f**2*r**2 - 132*D1**2*bd1*f**2*r*s + 132*D1**2*bd1*f**2*r + 660*D1**2*bd1*f*fd*r**2 + 660*D1**2*bd1*f*fd*r*s - 660*D1**2*bd1*f*fd*r - 165*D1**2*bd1*f*fd*s + 165*D1**2*bd1*f*fd + 1980*D1**2*bd1*f*g2*r + 990*D1**2*bd1*f*g2*s - 990*D1**2*bd1*f*g2 - 2376*D1**2*bd1*f*gd2*r - 1188*D1**2*bd1*f*gd2*s + 1188*D1**2*bd1*f*gd2 + 396*D1**2*bd2*f**2*r**2 + 396*D1**2*bd2*f**2*r*s - 396*D1**2*bd2*f**2*r - 1980*D1**2*bd2*f*fd*r**2 - 1980*D1**2*bd2*f*fd*r*s + 1980*D1**2*bd2*f*fd*r + 495*D1**2*bd2*f*fd*s - 495*D1**2*bd2*f*fd + 140*D1**2*bdd1*f**3*r**2 + 140*D1**2*bdd1*f**3*r*s - 140*D1**2*bdd1*f**3*r + 165*D1**2*bdd1*f**2*r**2 + 165*D1**2*bdd1*f**2*r*s - 165*D1**2*bdd1*f**2*r - 2376*D1**2*bdd1*f*g2*r - 1188*D1**2*bdd1*f*g2*s + 1188*D1**2*bdd1*f*g2 - 495*D1**2*bdd2*f**2*r**2 - 495*D1**2*bdd2*f**2*r*s + 495*D1**2*bdd2*f**2*r - 792*D1**2*f**2*gd2*r**2 - 792*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r + 990*D1**2*f**2*gdd2*r**2 + 990*D1**2*f**2*gdd2*r*s - 990*D1**2*f**2*gdd2*r - 1584*D1**2*f*fd*g2*r**2 - 1584*D1**2*f*fd*g2*r*s + 1584*D1**2*f*fd*g2*r + 792*D1**2*f*fd*g2*s - 792*D1**2*f*fd*g2 + 3960*D1**2*f*fd*gd2*r**2 + 3960*D1**2*f*fd*gd2*r*s - 3960*D1**2*f*fd*gd2*r - 990*D1**2*f*fd*gd2*s + 990*D1**2*f*fd*gd2 + 1980*D1**2*f*fdd*g2*r**2 + 1980*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r - 990*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 1980*D1**2*fd**2*g2*r**2 + 1980*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r - 990*D1**2*fd**2*g2*s - 3960*D1*Dd*K*bd1*f**2*r**2 - 3960*D1*Dd*K*bd1*f**2*r*s + 3960*D1*Dd*K*bd1*f**2*r + 495*D1*Dd*K*bd1*f**2*s - 495*D1*Dd*K*bd1*f**2 + 1120*D1*Dd*bd1*f**3*r**2 + 1120*D1*Dd*bd1*f**3*r*s - 1120*D1*Dd*bd1*f**3*r - 140*D1*Dd*bd1*f**3*s + 140*D1*Dd*bd1*f**3 + 1320*D1*Dd*bd1*f**2*r**2 + 1320*D1*Dd*bd1*f**2*r*s - 1320*D1*Dd*bd1*f**2*r - 165*D1*Dd*bd1*f**2*s + 165*D1*Dd*bd1*f**2 - 9504*D1*Dd*bd1*f*g2*r - 4752*D1*Dd*bd1*f*g2*s + 4752*D1*Dd*bd1*f*g2 - 3960*D1*Dd*bd2*f**2*r**2 - 3960*D1*Dd*bd2*f**2*r*s + 3960*D1*Dd*bd2*f**2*r + 495*D1*Dd*bd2*f**2*s - 495*D1*Dd*bd2*f**2 - 3168*D1*Dd*f**2*g2*r**2 - 3168*D1*Dd*f**2*g2*r*s + 3168*D1*Dd*f**2*g2*r + 792*D1*Dd*f**2*g2*s - 792*D1*Dd*f**2*g2 + 7920*D1*Dd*f**2*gd2*r**2 + 7920*D1*Dd*f**2*gd2*r*s - 7920*D1*Dd*f**2*gd2*r - 990*D1*Dd*f**2*gd2*s + 990*D1*Dd*f**2*gd2 + 15840*D1*Dd*f*fd*g2*r**2 + 15840*D1*Dd*f*fd*g2*r*s - 15840*D1*Dd*f*fd*g2*r - 5940*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 + 3960*D1*Ddd*f**2*g2*r**2 + 3960*D1*Ddd*f**2*g2*r*s - 3960*D1*Ddd*f**2*g2*r - 990*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 11880*Dd**2*f**2*g2*r**2 + 11880*Dd**2*f**2*g2*r*s - 11880*Dd**2*f**2*g2*r - 2970*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 + 33*b1**3*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1) - 2*(21*K - 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-21*K + 6*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-21*K + 6*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1**2*(30*D1**2*K*fd*r + 15*D1**2*K*fd*s - 15*D1**2*K*fd - 36*D1**2*K*fdd*r - 18*D1**2*K*fdd*s + 18*D1**2*K*fdd - D1**2*bdd1*(-21*K + 6*f + 7)*(3*r**2 + 3*r*(s - 1) - s + 1) - 8*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd + 10*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd + 10*D1**2*fd**2*r + 5*D1**2*fd**2*s - 5*D1**2*fd**2 - 10*D1**2*fd*r - 5*D1**2*fd*s + 5*D1**2*fd + 12*D1**2*fdd*r + 6*D1**2*fdd*s - 6*D1**2*fdd + 84*D1**2*gd2*r**2 + 84*D1**2*gd2*r*s - 84*D1**2*gd2*r - 42*D1**2*gdd2*r**2 - 42*D1**2*gdd2*r*s + 42*D1**2*gdd2*r - 144*D1*Dd*K*fd*r - 72*D1*Dd*K*fd*s + 72*D1*Dd*K*fd + 40*D1*Dd*f*fd*r + 20*D1*Dd*f*fd*s - 20*D1*Dd*f*fd + 48*D1*Dd*fd*r + 24*D1*Dd*fd*s - 24*D1*Dd*fd + 336*D1*Dd*g2*r**2 + 336*D1*Dd*g2*r*s - 336*D1*Dd*g2*r - 84*D1*Dd*g2*s + 84*D1*Dd*g2 - 336*D1*Dd*gd2*r**2 - 336*D1*Dd*gd2*r*s + 336*D1*Dd*gd2*r + 42*D1*Dd*gd2*s - 42*D1*Dd*gd2 - 168*D1*Ddd*g2*r**2 - 168*D1*Ddd*g2*r*s + 168*D1*Ddd*g2*r + 42*D1*Ddd*g2*s - 42*D1*Ddd*g2 + D1*bd1*(D1*(5*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 6*fd*(6*r**2 + 6*r*(s - 1) - s + 1) - 2*(21*K - 7)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-21*K + 6*f + 7)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 504*Dd**2*g2*r**2 - 504*Dd**2*g2*r*s + 504*Dd**2*g2*r + 126*Dd**2*g2*s - 84*Dd**2*g2) - b1*(-792*D1**2*K*f*fd*r**2 - 792*D1**2*K*f*fd*r*s + 792*D1**2*K*f*fd*r + 396*D1**2*K*f*fd*s - 396*D1**2*K*f*fd + 990*D1**2*K*f*fdd*r**2 + 990*D1**2*K*f*fdd*r*s - 990*D1**2*K*f*fdd*r - 495*D1**2*K*f*fdd*s + 495*D1**2*K*f*fdd + 990*D1**2*K*fd**2*r**2 + 990*D1**2*K*fd**2*r*s - 990*D1**2*K*fd**2*r - 495*D1**2*K*fd**2*s - 495*D1**2*b2*fd*r**2 - 495*D1**2*b2*fd*r*s + 594*D1**2*b2*fdd*r**2 + 594*D1**2*b2*fdd*r*s + 33*D1**2*bd1**2*(-21*K + 6*f + 7)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 495*D1**2*bd2*f*r**2 - 495*D1**2*bd2*f*r*s + 495*D1**2*bd2*f*r + 1188*D1**2*bd2*fd*r**2 + 1188*D1**2*bd2*fd*r*s - 594*D1**2*bd2*fd*r + 33*D1**2*bdd1*(5*f**2*(2*r + s - 1) - 6*f*(3*K - 1)*(2*r + s - 1) + 42*g2*(2*r**2 + 2*r*(s - 1) - s + 1)) + 594*D1**2*bdd2*f*r**2 + 594*D1**2*bdd2*f*r*s - 594*D1**2*bdd2*f*r + 345*D1**2*f**2*fd*r**2 + 345*D1**2*f**2*fd*r*s - 345*D1**2*f**2*fd*r - 115*D1**2*f**2*fd*s + 115*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 420*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r + 140*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 840*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r + 280*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 264*D1**2*f*fd*r**2 + 264*D1**2*f*fd*r*s - 264*D1**2*f*fd*r - 132*D1**2*f*fd*s + 132*D1**2*f*fd - 330*D1**2*f*fdd*r**2 - 330*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*r + 165*D1**2*f*fdd*s - 165*D1**2*f*fdd - 330*D1**2*fd**2*r**2 - 330*D1**2*fd**2*r*s + 330*D1**2*fd**2*r + 165*D1**2*fd**2*s + 1980*D1**2*fd*g2*r + 990*D1**2*fd*g2*s - 990*D1**2*fd*g2 - 2376*D1**2*fd*gd2*r - 1188*D1**2*fd*gd2*s + 1188*D1**2*fd*gd2 - 2376*D1**2*fdd*g2*r - 1188*D1**2*fdd*g2*s + 1188*D1**2*fdd*g2 - 1584*D1*Dd*K*f**2*r**2 - 1584*D1*Dd*K*f**2*r*s + 1584*D1*Dd*K*f**2*r + 396*D1*Dd*K*f**2*s - 396*D1*Dd*K*f**2 + 7920*D1*Dd*K*f*fd*r**2 + 7920*D1*Dd*K*f*fd*r*s - 7920*D1*Dd*K*f*fd*r - 2970*D1*Dd*K*f*fd*s + 1980*D1*Dd*K*f*fd - 1980*D1*Dd*b2*f*r**2 - 1980*D1*Dd*b2*f*r*s + 1980*D1*Dd*b2*f*r + 495*D1*Dd*b2*f*s - 495*D1*Dd*b2*f + 4752*D1*Dd*b2*fd*r**2 + 4752*D1*Dd*b2*fd*r*s - 2376*D1*Dd*b2*fd*r - 594*D1*Dd*b2*fd*s + 4752*D1*Dd*bd2*f*r**2 + 4752*D1*Dd*bd2*f*r*s - 4752*D1*Dd*bd2*f*r - 594*D1*Dd*bd2*f*s + 594*D1*Dd*bd2*f + 460*D1*Dd*f**3*r**2 + 460*D1*Dd*f**3*r*s - 460*D1*Dd*f**3*r - 115*D1*Dd*f**3*s + 115*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 3360*D1*Dd*f**2*fd*r*s + 3360*D1*Dd*f**2*fd*r + 980*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd + 528*D1*Dd*f**2*r**2 + 528*D1*Dd*f**2*r*s - 528*D1*Dd*f**2*r - 132*D1*Dd*f**2*s + 132*D1*Dd*f**2 - 2640*D1*Dd*f*fd*r**2 - 2640*D1*Dd*f*fd*r*s + 2640*D1*Dd*f*fd*r + 990*D1*Dd*f*fd*s - 660*D1*Dd*f*fd - 9504*D1*Dd*fd*g2*r - 4752*D1*Dd*fd*g2*s + 4752*D1*Dd*fd*g2 + 1980*D1*Ddd*K*f**2*r**2 + 1980*D1*Ddd*K*f**2*r*s - 1980*D1*Ddd*K*f**2*r - 495*D1*Ddd*K*f**2*s + 495*D1*Ddd*K*f**2 + 2376*D1*Ddd*b2*f*r**2 + 2376*D1*Ddd*b2*f*r*s - 2376*D1*Ddd*b2*f*r - 594*D1*Ddd*b2*f*s + 594*D1*Ddd*b2*f - 560*D1*Ddd*f**3*r**2 - 560*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r + 140*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 660*D1*Ddd*f**2*r**2 - 660*D1*Ddd*f**2*r*s + 660*D1*Ddd*f**2*r + 165*D1*Ddd*f**2*s - 165*D1*Ddd*f**2 - 33*D1*bd1*(D1*(4*f**2*(2*r + s - 1) - 5*f*(3*K - 1)*(2*r + s - 1) - 6*fd*(3*K - 1)*(2*r + s - 1) + 42*g2*(4*r**2 + 4*r*(s - 1) - 2*s + 2) + 42*gd2*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 4*Dd*(5*f**2*(2*r + s - 1) - 6*f*(3*K - 1)*(2*r + s - 1) + 21*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + 5940*Dd**2*K*f**2*r**2 + 5940*Dd**2*K*f**2*r*s - 5940*Dd**2*K*f**2*r - 1485*Dd**2*K*f**2*s + 990*Dd**2*K*f**2 + 7128*Dd**2*b2*f*r**2 + 7128*Dd**2*b2*f*r*s - 7128*Dd**2*b2*f*r - 1782*Dd**2*b2*f*s + 1188*Dd**2*b2*f - 1680*Dd**2*f**3*r**2 - 1680*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r + 420*Dd**2*f**3*s - 280*Dd**2*f**3 - 1980*Dd**2*f**2*r**2 - 1980*Dd**2*f**2*r*s + 1980*Dd**2*f**2*r + 495*Dd**2*f**2*s - 330*Dd**2*f**2) + 99*b2*(-6*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 8*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*r + 5*D1**2*fd**2*s + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 20*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(5*f*(r - 1)*(r + s - 1) + 6*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 6*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2))/(693*d**2*k3**3) + D1**2*Pkd1*Pkd3*ct*k2**3*st**2*(-66*D1**2*K*bd1**2*f*r**2 - 66*D1**2*K*bd1**2*f*r*s + 99*D1**2*K*bd1**2*f*r + 33*D1**2*K*bd1**2*f*s - 33*D1**2*K*bd1**2*f + 55*D1**2*K*bd1*f**2*r**2 + 55*D1**2*K*bd1*f**2*r*s - 55*D1**2*K*bd1*f**2*r - 132*D1**2*K*bd1*f*fd*r**2 - 132*D1**2*K*bd1*f*fd*r*s + 132*D1**2*K*bd1*f*fd*r + 33*D1**2*K*bd1*f*fd*s - 33*D1**2*K*bd1*f*fd - 33*D1**2*K*bdd1*f**2*r**2 - 33*D1**2*K*bdd1*f**2*r*s + 33*D1**2*K*bdd1*f**2*r + 264*D1**2*bd1**2*f**2*r**2 + 264*D1**2*bd1**2*f**2*r*s - 396*D1**2*bd1**2*f**2*r - 165*D1**2*bd1**2*f**2*s + 99*D1**2*bd1**2*f**2 + 66*D1**2*bd1**2*f*r**2 + 66*D1**2*bd1**2*f*r*s - 99*D1**2*bd1**2*f*r - 33*D1**2*bd1**2*f*s + 33*D1**2*bd1**2*f - 66*D1**2*bd1*bd2*f*r**2 - 66*D1**2*bd1*bd2*f*r*s + 99*D1**2*bd1*bd2*f*r + 33*D1**2*bd1*bd2*f*s - 33*D1**2*bd1*bd2*f - 151*D1**2*bd1*f**3*r**2 - 151*D1**2*bd1*f**3*r*s + 95*D1**2*bd1*f**3*r + 750*D1**2*bd1*f**2*fd*r**2 + 750*D1**2*bd1*f**2*fd*r*s - 650*D1**2*bd1*f**2*fd*r - 125*D1**2*bd1*f**2*fd*s + 75*D1**2*bd1*f**2*fd - 55*D1**2*bd1*f**2*r**2 - 55*D1**2*bd1*f**2*r*s + 55*D1**2*bd1*f**2*r + 132*D1**2*bd1*f*fd*r**2 + 132*D1**2*bd1*f*fd*r*s - 132*D1**2*bd1*f*fd*r - 33*D1**2*bd1*f*fd*s + 33*D1**2*bd1*f*fd - 286*D1**2*bd1*f*g2*r**2 - 286*D1**2*bd1*f*g2*r*s + 572*D1**2*bd1*f*g2*r + 286*D1**2*bd1*f*g2*s - 286*D1**2*bd1*f*g2 + 132*D1**2*bd1*f*gd2*r**2 + 132*D1**2*bd1*f*gd2*r*s - 198*D1**2*bd1*f*gd2*r - 66*D1**2*bd1*f*gd2*s + 66*D1**2*bd1*f*gd2 + 132*D1**2*bd1*fd*g2*r**2 + 132*D1**2*bd1*fd*g2*r*s - 132*D1**2*bd1*fd*g2*r - 66*D1**2*bd1*fd*g2*s + 55*D1**2*bd2*f**2*r**2 + 55*D1**2*bd2*f**2*r*s - 55*D1**2*bd2*f**2*r - 132*D1**2*bd2*f*fd*r**2 - 132*D1**2*bd2*f*fd*r*s + 132*D1**2*bd2*f*fd*r + 33*D1**2*bd2*f*fd*s - 33*D1**2*bd2*f*fd + 125*D1**2*bdd1*f**3*r**2 + 125*D1**2*bdd1*f**3*r*s - 75*D1**2*bdd1*f**3*r + 33*D1**2*bdd1*f**2*r**2 + 33*D1**2*bdd1*f**2*r*s - 33*D1**2*bdd1*f**2*r + 66*D1**2*bdd1*f*g2*r**2 + 66*D1**2*bdd1*f*g2*r*s - 132*D1**2*bdd1*f*g2*r - 66*D1**2*bdd1*f*g2*s + 66*D1**2*bdd1*f*g2 - 33*D1**2*bdd2*f**2*r**2 - 33*D1**2*bdd2*f**2*r*s + 33*D1**2*bdd2*f**2*r - 110*D1**2*f**2*gd2*r**2 - 110*D1**2*f**2*gd2*r*s + 110*D1**2*f**2*gd2*r + 66*D1**2*f**2*gdd2*r**2 + 66*D1**2*f**2*gdd2*r*s - 66*D1**2*f**2*gdd2*r - 220*D1**2*f*fd*g2*r**2 - 220*D1**2*f*fd*g2*r*s + 220*D1**2*f*fd*g2*r + 110*D1**2*f*fd*g2*s - 110*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 + 264*D1**2*f*fd*gd2*r*s - 264*D1**2*f*fd*gd2*r - 66*D1**2*f*fd*gd2*s + 66*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r**2 + 132*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r - 66*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 + 132*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r - 66*D1**2*fd**2*g2*s - 264*D1*Dd*K*bd1*f**2*r**2 - 264*D1*Dd*K*bd1*f**2*r*s + 264*D1*Dd*K*bd1*f**2*r + 33*D1*Dd*K*bd1*f**2*s - 33*D1*Dd*K*bd1*f**2 + 1000*D1*Dd*bd1*f**3*r**2 + 1000*D1*Dd*bd1*f**3*r*s - 800*D1*Dd*bd1*f**3*r - 125*D1*Dd*bd1*f**3*s + 75*D1*Dd*bd1*f**3 + 264*D1*Dd*bd1*f**2*r**2 + 264*D1*Dd*bd1*f**2*r*s - 264*D1*Dd*bd1*f**2*r - 33*D1*Dd*bd1*f**2*s + 33*D1*Dd*bd1*f**2 + 528*D1*Dd*bd1*f*g2*r**2 + 528*D1*Dd*bd1*f*g2*r*s - 792*D1*Dd*bd1*f*g2*r - 330*D1*Dd*bd1*f*g2*s + 264*D1*Dd*bd1*f*g2 - 264*D1*Dd*bd2*f**2*r**2 - 264*D1*Dd*bd2*f**2*r*s + 264*D1*Dd*bd2*f**2*r + 33*D1*Dd*bd2*f**2*s - 33*D1*Dd*bd2*f**2 - 440*D1*Dd*f**2*g2*r**2 - 440*D1*Dd*f**2*g2*r*s + 440*D1*Dd*f**2*g2*r + 110*D1*Dd*f**2*g2*s - 110*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 + 528*D1*Dd*f**2*gd2*r*s - 528*D1*Dd*f**2*gd2*r - 66*D1*Dd*f**2*gd2*s + 66*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r**2 + 1056*D1*Dd*f*fd*g2*r*s - 1056*D1*Dd*f*fd*g2*r - 396*D1*Dd*f*fd*g2*s + 264*D1*Dd*f*fd*g2 + 264*D1*Ddd*f**2*g2*r**2 + 264*D1*Ddd*f**2*g2*r*s - 264*D1*Ddd*f**2*g2*r - 66*D1*Ddd*f**2*g2*s + 66*D1*Ddd*f**2*g2 + 792*Dd**2*f**2*g2*r**2 + 792*Dd**2*f**2*g2*r*s - 792*Dd**2*f**2*g2*r - 198*Dd**2*f**2*g2*s + 132*Dd**2*f**2*g2 + 11*b1**3*(D1**2*r*(13*fd - 3*fdd)*(r + s - 1) + D1*(Dd*(13*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 3*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 11*b1**2*(13*D1**2*K*fd*r**2 + 13*D1**2*K*fd*r*s - 3*D1**2*K*fdd*r**2 - 3*D1**2*K*fdd*r*s - 3*D1**2*bdd1*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 32*D1**2*f*fd*r**2 - 32*D1**2*f*fd*r*s + 14*D1**2*f*fd*r - 5*D1**2*f*fd*s + 5*D1**2*f*fd + 24*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 3*D1**2*f*fdd*s - 3*D1**2*f*fdd + 24*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 3*D1**2*fd**2*s - 3*D1**2*fd**2 - 13*D1**2*fd*r**2 - 13*D1**2*fd*r*s + 3*D1**2*fdd*r**2 + 3*D1**2*fdd*r*s + 52*D1*Dd*K*f*r**2 + 52*D1*Dd*K*f*r*s - 52*D1*Dd*K*f*r - 13*D1*Dd*K*f*s + 13*D1*Dd*K*f - 24*D1*Dd*K*fd*r**2 - 24*D1*Dd*K*fd*r*s + 12*D1*Dd*K*fd*r + 3*D1*Dd*K*fd*s - 64*D1*Dd*f**2*r**2 - 64*D1*Dd*f**2*r*s + 64*D1*Dd*f**2*r + 16*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 192*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r - 12*D1*Dd*f*fd*s + 6*D1*Dd*f*fd - 52*D1*Dd*f*r**2 - 52*D1*Dd*f*r*s + 52*D1*Dd*f*r + 13*D1*Dd*f*s - 13*D1*Dd*f + 24*D1*Dd*fd*r**2 + 24*D1*Dd*fd*r*s - 12*D1*Dd*fd*r - 3*D1*Dd*fd*s - 12*D1*Ddd*K*f*r**2 - 12*D1*Ddd*K*f*r*s + 12*D1*Ddd*K*f*r + 3*D1*Ddd*K*f*s - 3*D1*Ddd*K*f + 48*D1*Ddd*f**2*r**2 + 48*D1*Ddd*f**2*r*s - 48*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s + 12*D1*Ddd*f**2 + 12*D1*Ddd*f*r**2 + 12*D1*Ddd*f*r*s - 12*D1*Ddd*f*r - 3*D1*Ddd*f*s + 3*D1*Ddd*f + D1*bd1*(D1*(13*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*fd*(6*r**2 + 6*r*(s - 1) - s + 1)) - 3*Dd*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 36*Dd**2*K*f*r**2 - 36*Dd**2*K*f*r*s + 36*Dd**2*K*f*r + 9*Dd**2*K*f*s - 6*Dd**2*K*f + 144*Dd**2*f**2*r**2 + 144*Dd**2*f**2*r*s - 144*Dd**2*f**2*r - 36*Dd**2*f**2*s + 24*Dd**2*f**2 + 36*Dd**2*f*r**2 + 36*Dd**2*f*r*s - 36*Dd**2*f*r - 9*Dd**2*f*s + 6*Dd**2*f) + b1*(110*D1**2*K*f*fd*r**2 + 110*D1**2*K*f*fd*r*s - 110*D1**2*K*f*fd*r - 55*D1**2*K*f*fd*s + 55*D1**2*K*f*fd - 66*D1**2*K*f*fdd*r**2 - 66*D1**2*K*f*fdd*r*s + 66*D1**2*K*f*fdd*r + 33*D1**2*K*f*fdd*s - 33*D1**2*K*f*fdd - 66*D1**2*K*fd**2*r**2 - 66*D1**2*K*fd**2*r*s + 66*D1**2*K*fd**2*r + 33*D1**2*K*fd**2*s + 143*D1**2*b2*fd*r**2 + 143*D1**2*b2*fd*r*s - 33*D1**2*b2*fdd*r**2 - 33*D1**2*b2*fdd*r*s - 33*D1**2*bd1**2*f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 143*D1**2*bd2*f*r**2 + 143*D1**2*bd2*f*r*s - 143*D1**2*bd2*f*r - 66*D1**2*bd2*fd*r**2 - 66*D1**2*bd2*fd*r*s + 33*D1**2*bd2*fd*r + 33*D1**2*bdd1*f*(f*(8*r**2 + 8*r*s - 12*r - 5*s + 5) - (K - 1)*(2*r - 1)*(r + s - 1)) - 33*D1**2*bdd2*f*r**2 - 33*D1**2*bdd2*f*r*s + 33*D1**2*bdd2*f*r - 453*D1**2*f**2*fd*r**2 - 453*D1**2*f**2*fd*r*s + 509*D1**2*f**2*fd*r + 151*D1**2*f**2*fd*s - 151*D1**2*f**2*fd + 375*D1**2*f**2*fdd*r**2 + 375*D1**2*f**2*fdd*r*s - 425*D1**2*f**2*fdd*r - 125*D1**2*f**2*fdd*s + 125*D1**2*f**2*fdd + 750*D1**2*f*fd**2*r**2 + 750*D1**2*f*fd**2*r*s - 850*D1**2*f*fd**2*r - 250*D1**2*f*fd**2*s + 175*D1**2*f*fd**2 - 110*D1**2*f*fd*r**2 - 110*D1**2*f*fd*r*s + 110*D1**2*f*fd*r + 55*D1**2*f*fd*s - 55*D1**2*f*fd + 66*D1**2*f*fdd*r**2 + 66*D1**2*f*fdd*r*s - 66*D1**2*f*fdd*r - 33*D1**2*f*fdd*s + 33*D1**2*f*fdd - 286*D1**2*f*gd2*r**2 - 286*D1**2*f*gd2*r*s + 286*D1**2*f*gd2*r + 66*D1**2*f*gdd2*r**2 + 66*D1**2*f*gdd2*r*s - 66*D1**2*f*gdd2*r + 66*D1**2*fd**2*r**2 + 66*D1**2*fd**2*r*s - 66*D1**2*fd**2*r - 33*D1**2*fd**2*s - 286*D1**2*fd*g2*r**2 - 286*D1**2*fd*g2*r*s + 132*D1**2*fd*gd2*r**2 + 132*D1**2*fd*gd2*r*s - 66*D1**2*fd*gd2*r + 66*D1**2*fdd*g2*r**2 + 66*D1**2*fdd*g2*r*s + 220*D1*Dd*K*f**2*r**2 + 220*D1*Dd*K*f**2*r*s - 220*D1*Dd*K*f**2*r - 55*D1*Dd*K*f**2*s + 55*D1*Dd*K*f**2 - 528*D1*Dd*K*f*fd*r**2 - 528*D1*Dd*K*f*fd*r*s + 528*D1*Dd*K*f*fd*r + 198*D1*Dd*K*f*fd*s - 132*D1*Dd*K*f*fd + 572*D1*Dd*b2*f*r**2 + 572*D1*Dd*b2*f*r*s - 572*D1*Dd*b2*f*r - 143*D1*Dd*b2*f*s + 143*D1*Dd*b2*f - 264*D1*Dd*b2*fd*r**2 - 264*D1*Dd*b2*fd*r*s + 132*D1*Dd*b2*fd*r + 33*D1*Dd*b2*fd*s - 264*D1*Dd*bd2*f*r**2 - 264*D1*Dd*bd2*f*r*s + 264*D1*Dd*bd2*f*r + 33*D1*Dd*bd2*f*s - 33*D1*Dd*bd2*f - 604*D1*Dd*f**3*r**2 - 604*D1*Dd*f**3*r*s + 604*D1*Dd*f**3*r + 151*D1*Dd*f**3*s - 151*D1*Dd*f**3 + 3000*D1*Dd*f**2*fd*r**2 + 3000*D1*Dd*f**2*fd*r*s - 3200*D1*Dd*f**2*fd*r - 875*D1*Dd*f**2*fd*s + 675*D1*Dd*f**2*fd - 220*D1*Dd*f**2*r**2 - 220*D1*Dd*f**2*r*s + 220*D1*Dd*f**2*r + 55*D1*Dd*f**2*s - 55*D1*Dd*f**2 + 528*D1*Dd*f*fd*r**2 + 528*D1*Dd*f*fd*r*s - 528*D1*Dd*f*fd*r - 198*D1*Dd*f*fd*s + 132*D1*Dd*f*fd - 1144*D1*Dd*f*g2*r**2 - 1144*D1*Dd*f*g2*r*s + 1144*D1*Dd*f*g2*r + 286*D1*Dd*f*g2*s - 286*D1*Dd*f*g2 + 528*D1*Dd*f*gd2*r**2 + 528*D1*Dd*f*gd2*r*s - 528*D1*Dd*f*gd2*r - 66*D1*Dd*f*gd2*s + 66*D1*Dd*f*gd2 + 528*D1*Dd*fd*g2*r**2 + 528*D1*Dd*fd*g2*r*s - 264*D1*Dd*fd*g2*r - 66*D1*Dd*fd*g2*s - 132*D1*Ddd*K*f**2*r**2 - 132*D1*Ddd*K*f**2*r*s + 132*D1*Ddd*K*f**2*r + 33*D1*Ddd*K*f**2*s - 33*D1*Ddd*K*f**2 - 132*D1*Ddd*b2*f*r**2 - 132*D1*Ddd*b2*f*r*s + 132*D1*Ddd*b2*f*r + 33*D1*Ddd*b2*f*s - 33*D1*Ddd*b2*f + 500*D1*Ddd*f**3*r**2 + 500*D1*Ddd*f**3*r*s - 500*D1*Ddd*f**3*r - 125*D1*Ddd*f**3*s + 125*D1*Ddd*f**3 + 132*D1*Ddd*f**2*r**2 + 132*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r - 33*D1*Ddd*f**2*s + 33*D1*Ddd*f**2 + 264*D1*Ddd*f*g2*r**2 + 264*D1*Ddd*f*g2*r*s - 264*D1*Ddd*f*g2*r - 66*D1*Ddd*f*g2*s + 66*D1*Ddd*f*g2 - 11*D1*bd1*(D1*(f**2*(32*r**2 + 32*r*s - 50*r - 21*s + 21) + f*(-6*fd*(4*r - 1)*(4*r + 4*s - 3) + (13 - 13*K)*(2*r - 1)*(r + s - 1)) + 3*fd*(K - 1)*(4*r**2 + r*(4*s - 3) - s)) - 3*Dd*f*(f*(64*r**2 + 16*r*(4*s - 5) - 28*s + 22) - (K - 1)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5))) - 396*Dd**2*K*f**2*r**2 - 396*Dd**2*K*f**2*r*s + 396*Dd**2*K*f**2*r + 99*Dd**2*K*f**2*s - 66*Dd**2*K*f**2 - 396*Dd**2*b2*f*r**2 - 396*Dd**2*b2*f*r*s + 396*Dd**2*b2*f*r + 99*Dd**2*b2*f*s - 66*Dd**2*b2*f + 1500*Dd**2*f**3*r**2 + 1500*Dd**2*f**3*r*s - 1500*Dd**2*f**3*r - 375*Dd**2*f**3*s + 250*Dd**2*f**3 + 396*Dd**2*f**2*r**2 + 396*Dd**2*f**2*r*s - 396*Dd**2*f**2*r - 99*Dd**2*f**2*s + 66*Dd**2*f**2 + 792*Dd**2*f*g2*r**2 + 792*Dd**2*f*g2*r*s - 792*Dd**2*f*g2*r - 198*Dd**2*f*g2*s + 132*Dd**2*f*g2) + 11*b2*(-3*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 10*D1**2*f*fd*r**2 + 10*D1**2*f*fd*r*s - 10*D1**2*f*fd*r - 5*D1**2*f*fd*s + 5*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r + 3*D1**2*f*fdd*s - 3*D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 3*D1**2*fd**2*s + 20*D1*Dd*f**2*r**2 + 20*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r - 5*D1*Dd*f**2*s + 5*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r + 18*D1*Dd*f*fd*s - 12*D1*Dd*f*fd - 12*D1*Ddd*f**2*r**2 - 12*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r + 3*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + D1*bd1*(D1*(13*f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 36*Dd**2*f**2*r**2 - 36*Dd**2*f**2*r*s + 36*Dd**2*f**2*r + 9*Dd**2*f**2*s - 6*Dd**2*f**2))/(231*d**2*k3**3) + 2*D1**2*Pkd1*Pkd3*ct*k2*st**2*(D1*f*(-D1*bd1**2*(3*C - 2)*(2*r**2 + 2*r*(s - 1) - s) - D1*bdd1*f*r*(3*C - 2)*(r + s) + bd1*(D1*(f*r*(5*C - 3)*(r + s) - fd*(3*C - 2)*(4*r**2 + 4*r*s - 3*r - s)) - Dd*f*(3*C - 2)*(8*r**2 + r*(8*s - 4) - s))) + b1**2*(D1**2*r*(fd*(13*C - 11) + fdd*(2 - 3*C))*(r + s - 1) + D1*(Dd*(f*(13*C - 11)*(4*r**2 + 4*r*(s - 1) - s + 1) - fd*(3*C - 2)*(8*r**2 + 8*r*(s - 1) - s + 1)) - Ddd*f*(3*C - 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(3*C - 2)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1*(10*C*D1**2*f*fd*r**2 + 10*C*D1**2*f*fd*r*s - 15*C*D1**2*f*fd*r - 5*C*D1**2*f*fd*s + 5*C*D1**2*f*fd - 6*C*D1**2*f*fdd*r**2 - 6*C*D1**2*f*fdd*r*s + 9*C*D1**2*f*fdd*r + 3*C*D1**2*f*fdd*s - 3*C*D1**2*f*fdd - 6*C*D1**2*fd**2*r**2 - 6*C*D1**2*fd**2*r*s + 9*C*D1**2*fd**2*r + 3*C*D1**2*fd**2*s - 3*C*D1**2*fd**2 + 20*C*D1*Dd*f**2*r**2 + 20*C*D1*Dd*f**2*r*s - 20*C*D1*Dd*f**2*r - 5*C*D1*Dd*f**2*s + 5*C*D1*Dd*f**2 - 48*C*D1*Dd*f*fd*r**2 - 48*C*D1*Dd*f*fd*r*s + 60*C*D1*Dd*f*fd*r + 18*C*D1*Dd*f*fd*s - 15*C*D1*Dd*f*fd - 12*C*D1*Ddd*f**2*r**2 - 12*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r + 3*C*D1*Ddd*f**2*s - 3*C*D1*Ddd*f**2 - 36*C*Dd**2*f**2*r**2 - 36*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r + 9*C*Dd**2*f**2*s - 6*C*Dd**2*f**2 - D1**2*bdd1*f*(3*C - 2)*(2*r**2 + 2*r*(s - 1) - s + 1) - 6*D1**2*f*fd*r**2 - 6*D1**2*f*fd*r*s + 9*D1**2*f*fd*r + 3*D1**2*f*fd*s - 3*D1**2*f*fd + 4*D1**2*f*fdd*r**2 + 4*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 2*D1**2*f*fdd*s + 2*D1**2*f*fdd + 4*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 2*D1**2*fd**2*s + 2*D1**2*fd**2 - 12*D1*Dd*f**2*r**2 - 12*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 3*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 32*D1*Dd*f*fd*r**2 + 32*D1*Dd*f*fd*r*s - 40*D1*Dd*f*fd*r - 12*D1*Dd*f*fd*s + 10*D1*Dd*f*fd + 8*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 8*D1*Ddd*f**2*r - 2*D1*Ddd*f**2*s + 2*D1*Ddd*f**2 + D1*bd1*(D1*(f*(13*C - 11)*(2*r**2 + 2*r*(s - 1) - s + 1) - fd*(3*C - 2)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd*f*(6*C - 4)*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 24*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 24*Dd**2*f**2*r - 6*Dd**2*f**2*s + 4*Dd**2*f**2))/(21*d**2*k3) - 2*D1**2*Pkd1*Pkd3*ct*k2*(D1*(D1*bd1**2*(-5*f**2*r*(2*r + 2*s - 1) + 6*f*r*(K - 1)*(2*r + 2*s - 1) + 14*g2*(-2*r**2 - 2*r*(s - 1) + s)) - 12*D1*bdd1*f*g2*r*(r + s) + b2*(7*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) + 6*D1*bdd1*f*r*(r + s) + bd1*(D1*(-5*f*r*(r + s) + 6*fd*(2*r**2 + 2*r*(s - 1) - s)) + 6*Dd*f*(8*r**2 + r*(8*s - 4) - s))) + 2*bd1*(3*D1*bd2*f*r*(2*r + 2*s - 1) + D1*(f*r*(5*g2*(r + s) - 6*gd2*(2*r + 2*s - 1)) - 6*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 6*Dd*f*g2*(8*r**2 + r*(8*s - 4) - s))) + b1**3*(D1**2*r*(5*fd - 6*fdd)*(r + s - 1) + D1*(Dd*(5*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 6*fd*(8*r**2 + 8*r*(s - 1) - s + 1) - 2*(7*K - 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Ddd*(-7*K + 6*f + 7)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*(-7*K + 6*f + 7)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(-5*D1**2*K*fd*r**2 - 5*D1**2*K*fd*r*s + 10*D1**2*K*fd*r + 5*D1**2*K*fd*s - 5*D1**2*K*fd + 6*D1**2*K*fdd*r**2 + 6*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r - 6*D1**2*K*fdd*s + 6*D1**2*K*fdd - 14*D1**2*bd2*r**2 - 14*D1**2*bd2*r*s + 14*D1**2*bd2*r - D1**2*bdd1*(-7*K + 6*f + 7)*(3*r**2 + 3*r*(s - 1) - s + 1) + 7*D1**2*bdd2*r**2 + 7*D1**2*bdd2*r*s - 7*D1**2*bdd2*r + 8*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 4*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r + 5*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 15*D1**2*fd**2*r + 5*D1**2*fd**2*s - 5*D1**2*fd**2 + 5*D1**2*fd*r**2 + 5*D1**2*fd*r*s - 10*D1**2*fd*r - 5*D1**2*fd*s + 5*D1**2*fd - 6*D1**2*fdd*r**2 - 6*D1**2*fdd*r*s + 12*D1**2*fdd*r + 6*D1**2*fdd*s - 6*D1**2*fdd + 28*D1**2*gd2*r**2 + 28*D1**2*gd2*r*s - 28*D1**2*gd2*r - 14*D1**2*gdd2*r**2 - 14*D1**2*gdd2*r*s + 14*D1**2*gdd2*r - 20*D1*Dd*K*f*r**2 - 20*D1*Dd*K*f*r*s + 20*D1*Dd*K*f*r + 5*D1*Dd*K*f*s - 5*D1*Dd*K*f + 48*D1*Dd*K*fd*r**2 + 48*D1*Dd*K*fd*r*s - 72*D1*Dd*K*fd*r - 30*D1*Dd*K*fd*s + 24*D1*Dd*K*fd - 56*D1*Dd*b2*r**2 - 56*D1*Dd*b2*r*s + 56*D1*Dd*b2*r + 14*D1*Dd*b2*s - 14*D1*Dd*b2 + 56*D1*Dd*bd2*r**2 + 56*D1*Dd*bd2*r*s - 56*D1*Dd*bd2*r - 7*D1*Dd*bd2*s + 7*D1*Dd*bd2 + 16*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r - 4*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r + 30*D1*Dd*f*fd*s - 25*D1*Dd*f*fd + 20*D1*Dd*f*r**2 + 20*D1*Dd*f*r*s - 20*D1*Dd*f*r - 5*D1*Dd*f*s + 5*D1*Dd*f - 48*D1*Dd*fd*r**2 - 48*D1*Dd*fd*r*s + 72*D1*Dd*fd*r + 30*D1*Dd*fd*s - 24*D1*Dd*fd + 112*D1*Dd*g2*r**2 + 112*D1*Dd*g2*r*s - 112*D1*Dd*g2*r - 28*D1*Dd*g2*s + 28*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 - 112*D1*Dd*gd2*r*s + 112*D1*Dd*gd2*r + 14*D1*Dd*gd2*s - 14*D1*Dd*gd2 + 24*D1*Ddd*K*f*r**2 + 24*D1*Ddd*K*f*r*s - 24*D1*Ddd*K*f*r - 6*D1*Ddd*K*f*s + 6*D1*Ddd*K*f + 28*D1*Ddd*b2*r**2 + 28*D1*Ddd*b2*r*s - 28*D1*Ddd*b2*r - 7*D1*Ddd*b2*s + 7*D1*Ddd*b2 - 20*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r + 5*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 - 24*D1*Ddd*f*r**2 - 24*D1*Ddd*f*r*s + 24*D1*Ddd*f*r + 6*D1*Ddd*f*s - 6*D1*Ddd*f - 56*D1*Ddd*g2*r**2 - 56*D1*Ddd*g2*r*s + 56*D1*Ddd*g2*r + 14*D1*Ddd*g2*s - 14*D1*Ddd*g2 + D1*bd1*(D1*(5*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 6*fd*(6*r**2 + 6*r*(s - 1) - s + 1) - 2*(7*K - 7)*(3*r**2 + 3*r*(s - 1) - s + 1)) - Dd*(-7*K + 6*f + 7)*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 72*Dd**2*K*f*r**2 + 72*Dd**2*K*f*r*s - 72*Dd**2*K*f*r - 18*Dd**2*K*f*s + 12*Dd**2*K*f + 84*Dd**2*b2*r**2 + 84*Dd**2*b2*r*s - 84*Dd**2*b2*r - 21*Dd**2*b2*s + 14*Dd**2*b2 - 60*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 60*Dd**2*f**2*r + 15*Dd**2*f**2*s - 10*Dd**2*f**2 - 72*Dd**2*f*r**2 - 72*Dd**2*f*r*s + 72*Dd**2*f*r + 18*Dd**2*f*s - 12*Dd**2*f - 168*Dd**2*g2*r**2 - 168*Dd**2*g2*r*s + 168*Dd**2*g2*r + 42*Dd**2*g2*s - 28*Dd**2*g2) - b1*(-12*D1**2*K*bdd1*f*r**2 - 12*D1**2*K*bdd1*f*r*s + 6*D1**2*K*bdd1*f*r + D1**2*bd1**2*(-7*K + 6*f + 7)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 5*D1**2*bd2*f*r**2 + 5*D1**2*bd2*f*r*s - 5*D1**2*bd2*f*r - 12*D1**2*bd2*fd*r**2 - 12*D1**2*bd2*fd*r*s + 18*D1**2*bd2*fd*r + 6*D1**2*bd2*fd*s - 6*D1**2*bd2*fd + 10*D1**2*bdd1*f**2*r**2 + 10*D1**2*bdd1*f**2*r*s - 5*D1**2*bdd1*f**2*r + 12*D1**2*bdd1*f*r**2 + 12*D1**2*bdd1*f*r*s - 6*D1**2*bdd1*f*r + 28*D1**2*bdd1*g2*r**2 + 28*D1**2*bdd1*g2*r*s - 28*D1**2*bdd1*g2*r - 14*D1**2*bdd1*g2*s + 14*D1**2*bdd1*g2 - 6*D1**2*bdd2*f*r**2 - 6*D1**2*bdd2*f*r*s + 6*D1**2*bdd2*f*r - 10*D1**2*f*gd2*r**2 - 10*D1**2*f*gd2*r*s + 10*D1**2*f*gd2*r + 12*D1**2*f*gdd2*r**2 + 12*D1**2*f*gdd2*r*s - 12*D1**2*f*gdd2*r - 10*D1**2*fd*g2*r**2 - 10*D1**2*fd*g2*r*s + 20*D1**2*fd*g2*r + 10*D1**2*fd*g2*s - 10*D1**2*fd*g2 + 24*D1**2*fd*gd2*r**2 + 24*D1**2*fd*gd2*r*s - 36*D1**2*fd*gd2*r - 12*D1**2*fd*gd2*s + 12*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r**2 + 12*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r - 12*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 - 48*D1*Dd*bd2*f*r**2 - 48*D1*Dd*bd2*f*r*s + 48*D1*Dd*bd2*f*r + 6*D1*Dd*bd2*f*s - 6*D1*Dd*bd2*f - 40*D1*Dd*f*g2*r**2 - 40*D1*Dd*f*g2*r*s + 40*D1*Dd*f*g2*r + 10*D1*Dd*f*g2*s - 10*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 96*D1*Dd*f*gd2*r*s - 96*D1*Dd*f*gd2*r - 12*D1*Dd*f*gd2*s + 12*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 96*D1*Dd*fd*g2*r*s - 144*D1*Dd*fd*g2*r - 60*D1*Dd*fd*g2*s + 48*D1*Dd*fd*g2 + 48*D1*Ddd*f*g2*r**2 + 48*D1*Ddd*f*g2*r*s - 48*D1*Ddd*f*g2*r - 12*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + D1*bd1*(-7*D1*bd2*(4*r**2 + 4*r*(s - 1) - s + 1) + D1*(10*K*f*r**2 + 10*K*f*r*s - 5*K*f*r - 8*f**2*r**2 - 8*f**2*r*s + 4*f**2*r - 10*f*r**2 - 10*f*r*s + 5*f*r + fd*(5*f*(8*r**2 + 8*r*(s - 1) - 2*s + 1) - (6*K - 6)*(4*r**2 + r*(4*s - 5) - 2*s + 1)) - 28*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 56*gd2*r**2 + 56*gd2*r*s - 56*gd2*r - 14*gd2*s + 14*gd2) + Dd*(5*f**2*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) - 6*f*(K - 1)*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 28*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + 144*Dd**2*f*g2*r**2 + 144*Dd**2*f*g2*r*s - 144*Dd**2*f*g2*r - 36*Dd**2*f*g2*s + 24*Dd**2*f*g2 + b2*(-7*D1**2*bdd1*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*D1**2*fd*r**2 + 5*D1**2*fd*r*s - 10*D1**2*fd*r - 5*D1**2*fd*s + 5*D1**2*fd - 6*D1**2*fdd*r**2 - 6*D1**2*fdd*r*s + 12*D1**2*fdd*r + 6*D1**2*fdd*s - 6*D1**2*fdd + 20*D1*Dd*f*r**2 + 20*D1*Dd*f*r*s - 20*D1*Dd*f*r - 5*D1*Dd*f*s + 5*D1*Dd*f - 48*D1*Dd*fd*r**2 - 48*D1*Dd*fd*r*s + 72*D1*Dd*fd*r + 30*D1*Dd*fd*s - 24*D1*Dd*fd - 24*D1*Ddd*f*r**2 - 24*D1*Ddd*f*r*s + 24*D1*Ddd*f*r + 6*D1*Ddd*f*s - 6*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 + 2*r*(s - 1) - s + 1) + Dd*(-8*r**2 - 8*r*(s - 1) + 3*s - 2)) - 72*Dd**2*f*r**2 - 72*Dd**2*f*r*s + 72*Dd**2*f*r + 18*Dd**2*f*s - 12*Dd**2*f)))/(21*d**2*k3) - D1**2*Pkd1*Pkd3*f*k1**3*k2**2*st**4*(4*C - 2)*(11*D1**2*bd1*f*(r - 1)*(r + s - 1) + 6*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s - 6*D1**2*f*fd*r - 2*D1**2*f*fd*s + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 - 3*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + D1**2*f*fdd*s - D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 2*D1**2*fd**2*s - D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 - 24*D1*Dd*f*fd*r*s + 24*D1*Dd*f*fd*r + 7*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 4*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r + D1*Ddd*f**2*s - D1*Ddd*f**2 + 11*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd**2*f**2*r**2 - 12*Dd**2*f**2*r*s + 12*Dd**2*f**2*r + 3*Dd**2*f**2*s - 2*Dd**2*f**2)/(77*d**2*k3**5) + 2*D1**2*Pkd1*Pkd3*f*k1*k2**4*st**4*(429*D1*b1**2*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 13*b1*(33*D1**2*bd1*f*(2*r - 1)*(r + s - 1) - 2*D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*s + 2*s - 2) - 2*fd**2*(3*r**2 + 3*r*s + 2*s - 1)) - 2*D1*f*(Dd*(f*(8*r**2 + 8*r*(s - 1) - 2*s + 2) + fd*(-24*r**2 + r*(12 - 24*s) - 5*s + 4)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd**2*f**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + f*(26*D1**2*bdd1*f*(r - 3)*(r + s - 1) - 3*D1**2*(f*(27*fd - 20*fdd)*(4*r**2 + 4*r*(s - 1) - s + 1) - 20*fd**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) - 26*D1*bd1*(D1*(2*f*(r - 3)*(r + s - 1) + fd*(-6*r**2 - 6*r*(s - 2) + 7*s - 4)) + Dd*f*(-8*r**2 + r*(20 - 8*s) + 13*s - 10)) - 3*D1*f*(Dd*(27*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 40*fd*(4*r - 1)*(4*r + 4*s - 3)) - 20*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 60*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(3003*d**2*k3**5) + D1**2*Pkd1*Pkd3*f*k1*k2**2*st**4*(4*C - 2)*(11*D1**2*bd1*f*(r - 1)*(r + s - 1) + 6*D1**2*f*fd*r**2 + 6*D1**2*f*fd*r*s - 6*D1**2*f*fd*r - 2*D1**2*f*fd*s + 2*D1**2*f*fd - 3*D1**2*f*fdd*r**2 - 3*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + D1**2*f*fdd*s - D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 2*D1**2*fd**2*s - D1**2*fd**2 + 8*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 2*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 24*D1*Dd*f*fd*r**2 - 24*D1*Dd*f*fd*r*s + 24*D1*Dd*f*fd*r + 7*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 4*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r + D1*Ddd*f**2*s - D1*Ddd*f**2 + 11*D1*b1*(D1*fd*r*(2*r + 2*s - 1) + Dd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 12*Dd**2*f**2*r**2 - 12*Dd**2*f**2*r*s + 12*Dd**2*f**2*r + 3*Dd**2*f**2*s - 2*Dd**2*f**2)/(77*d**2*k3**3) + 5*D1**2*Pkd1*Pkd3*f*k2**6*st**6*(78*D1**2*b1*f*fd*r**2 + 78*D1**2*b1*f*fd*r*s - 52*D1**2*b1*f*fd*r - 39*D1**2*b1*f*fdd*r**2 - 39*D1**2*b1*f*fdd*r*s + 26*D1**2*b1*f*fdd*r - 78*D1**2*b1*fd**2*r**2 - 78*D1**2*b1*fd**2*r*s + 52*D1**2*b1*fd**2*r - 13*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) - 24*D1**2*f**2*fd*r**2 - 24*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r*s - 12*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s + 3*D1**2*f**2*fdd + 36*D1**2*f*fd**2*r**2 + 36*D1**2*f*fd**2*r*s - 36*D1**2*f*fd**2*r - 9*D1**2*f*fd**2*s + 6*D1**2*f*fd**2 + 104*D1*Dd*b1*f**2*r**2 + 104*D1*Dd*b1*f**2*r*s - 104*D1*Dd*b1*f**2*r - 26*D1*Dd*b1*f**2*s + 26*D1*Dd*b1*f**2 - 312*D1*Dd*b1*f*fd*r**2 - 312*D1*Dd*b1*f*fd*r*s + 260*D1*Dd*b1*f*fd*r + 39*D1*Dd*b1*f*fd*s - 26*D1*Dd*b1*f*fd - 24*D1*Dd*f**3*r**2 - 24*D1*Dd*f**3*r*s + 24*D1*Dd*f**3*r + 6*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 96*D1*Dd*f**2*fd*r*s - 96*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s + 18*D1*Dd*f**2*fd - 52*D1*Ddd*b1*f**2*r**2 - 52*D1*Ddd*b1*f**2*r*s + 52*D1*Ddd*b1*f**2*r + 13*D1*Ddd*b1*f**2*s - 13*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*r**2 + 12*D1*Ddd*f**3*r*s - 12*D1*Ddd*f**3*r - 3*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 13*D1*bd1*f*(D1*(2*f*(r - 1)*(r + s - 1) + fd*(-6*r**2 - 6*r*s + 8*r + 3*s - 2)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 156*Dd**2*b1*f**2*r**2 - 156*Dd**2*b1*f**2*r*s + 156*Dd**2*b1*f**2*r + 39*Dd**2*b1*f**2*s - 26*Dd**2*b1*f**2 + 36*Dd**2*f**3*r**2 + 36*Dd**2*f**3*r*s - 36*Dd**2*f**3*r - 9*Dd**2*f**3*s + 6*Dd**2*f**3)/(9009*d**2*k1*k3**5) + 2*D1**2*Pkd1*Pkd3*f*k2**4*st**4*(D1*f*(D1*bd1*(-2*f*r*(2*r + 2*s - 1) + fd*(12*r**2 + 2*r*(6*s - 5) - 2*s + 1)) + D1*bdd1*f*r*(2*r + 2*s - 1) + Dd*bd1*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1)) + b1*(D1**2*(-f*(2*fd - fdd)*(6*r**2 + r*(6*s - 7) - 2*s + 2) + fd**2*(12*r**2 + 2*r*(6*s - 7) - 4*s + 3)) + D1*f*(Dd*(-4*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(48*r**2 + r*(48*s - 52) - 14*s + 11)) + 2*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + 2*Dd**2*f**2*(12*r**2 + 12*r*(s - 1) - 3*s + 2)))/(231*d**2*k1*k3**3) - D1**2*Pkd1*Pkd3*k1**5*st**2*(2*C - 1)*(66*D1**2*b1*f*fd*r**2 + 66*D1**2*b1*f*fd*r*s - 33*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 33*D1**2*b1*fd**2*r - 33*D1**2*bdd1*f**2*(r - 1)*(r + s - 1) + 51*D1**2*f**2*fd*r**2 + 51*D1**2*f**2*fd*r*s - 51*D1**2*f**2*fd*r - 17*D1**2*f**2*fd*s + 17*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 75*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r + 25*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 150*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r + 50*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 132*D1*Dd*b1*f**2*r**2 + 132*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r - 33*D1*Dd*b1*f**2*s + 33*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 396*D1*Dd*b1*f*fd*r + 66*D1*Dd*b1*f*fd*s - 33*D1*Dd*b1*f*fd + 68*D1*Dd*f**3*r**2 + 68*D1*Dd*f**3*r*s - 68*D1*Dd*f**3*r - 17*D1*Dd*f**3*s + 17*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 600*D1*Dd*f**2*fd*r*s + 600*D1*Dd*f**2*fd*r + 175*D1*Dd*f**2*fd*s - 125*D1*Dd*f**2*fd - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r + 33*D1*Ddd*b1*f**2*s - 33*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 100*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r + 25*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 + 33*D1*bd1*f*(D1*(f*(r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(-8*r**2 + r*(12 - 8*s) + 5*s - 4)) - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r + 99*Dd**2*b1*f**2*s - 66*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 300*Dd**2*f**3*r*s + 300*Dd**2*f**3*r + 75*Dd**2*f**3*s - 50*Dd**2*f**3)/(693*d**2*k3**5) - 2*D1**2*Pkd1*Pkd3*k1**5*(5*D1**2*K*b1**2*fd*r**2 + 5*D1**2*K*b1**2*fd*r*s - 6*D1**2*K*b1**2*fdd*r**2 - 6*D1**2*K*b1**2*fdd*r*s + 8*D1**2*K*b1*f*fd*r**2 + 8*D1**2*K*b1*f*fd*r*s - 8*D1**2*K*b1*f*fd*r - 4*D1**2*K*b1*f*fd*s + 4*D1**2*K*b1*f*fd - 10*D1**2*K*b1*f*fdd*r**2 - 10*D1**2*K*b1*f*fdd*r*s + 10*D1**2*K*b1*f*fdd*r + 5*D1**2*K*b1*f*fdd*s - 5*D1**2*K*b1*f*fdd - 10*D1**2*K*b1*fd**2*r**2 - 10*D1**2*K*b1*fd**2*r*s + 10*D1**2*K*b1*fd**2*r + 5*D1**2*K*b1*fd**2*s - 6*D1**2*K*bd1**2*f*(2*r - 1)*(r + s - 1) - 10*D1**2*b1*f*gd2*r**2 - 10*D1**2*b1*f*gd2*r*s + 10*D1**2*b1*f*gd2*r + 12*D1**2*b1*f*gdd2*r**2 + 12*D1**2*b1*f*gdd2*r*s - 12*D1**2*b1*f*gdd2*r - 10*D1**2*b1*fd*g2*r**2 - 10*D1**2*b1*fd*g2*r*s + 24*D1**2*b1*fd*gd2*r**2 + 24*D1**2*b1*fd*gd2*r*s - 12*D1**2*b1*fd*gd2*r + 12*D1**2*b1*fdd*g2*r**2 + 12*D1**2*b1*fdd*g2*r*s + D1**2*bdd1*f*(r + s - 1)*(K*b1*(6 - 12*r) - 5*K*f*r + 12*g2*(r - 1)) - 8*D1**2*f**2*gd2*r**2 - 8*D1**2*f**2*gd2*r*s + 8*D1**2*f**2*gd2*r + 10*D1**2*f**2*gdd2*r**2 + 10*D1**2*f**2*gdd2*r*s - 10*D1**2*f**2*gdd2*r - 16*D1**2*f*fd*g2*r**2 - 16*D1**2*f*fd*g2*r*s + 16*D1**2*f*fd*g2*r + 8*D1**2*f*fd*g2*s - 8*D1**2*f*fd*g2 + 40*D1**2*f*fd*gd2*r**2 + 40*D1**2*f*fd*gd2*r*s - 40*D1**2*f*fd*gd2*r - 10*D1**2*f*fd*gd2*s + 10*D1**2*f*fd*gd2 + 20*D1**2*f*fdd*g2*r**2 + 20*D1**2*f*fdd*g2*r*s - 20*D1**2*f*fdd*g2*r - 10*D1**2*f*fdd*g2*s + 10*D1**2*f*fdd*g2 + 20*D1**2*fd**2*g2*r**2 + 20*D1**2*fd**2*g2*r*s - 20*D1**2*fd**2*g2*r - 10*D1**2*fd**2*g2*s + 20*D1*Dd*K*b1**2*f*r**2 + 20*D1*Dd*K*b1**2*f*r*s - 20*D1*Dd*K*b1**2*f*r - 5*D1*Dd*K*b1**2*f*s + 5*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 48*D1*Dd*K*b1**2*fd*r*s + 24*D1*Dd*K*b1**2*fd*r + 6*D1*Dd*K*b1**2*fd*s + 16*D1*Dd*K*b1*f**2*r**2 + 16*D1*Dd*K*b1*f**2*r*s - 16*D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s + 4*D1*Dd*K*b1*f**2 - 80*D1*Dd*K*b1*f*fd*r**2 - 80*D1*Dd*K*b1*f*fd*r*s + 80*D1*Dd*K*b1*f*fd*r + 30*D1*Dd*K*b1*f*fd*s - 20*D1*Dd*K*b1*f*fd - 40*D1*Dd*b1*f*g2*r**2 - 40*D1*Dd*b1*f*g2*r*s + 40*D1*Dd*b1*f*g2*r + 10*D1*Dd*b1*f*g2*s - 10*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 96*D1*Dd*b1*f*gd2*r*s - 96*D1*Dd*b1*f*gd2*r - 12*D1*Dd*b1*f*gd2*s + 12*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 96*D1*Dd*b1*fd*g2*r*s - 48*D1*Dd*b1*fd*g2*r - 12*D1*Dd*b1*fd*g2*s - 32*D1*Dd*f**2*g2*r**2 - 32*D1*Dd*f**2*g2*r*s + 32*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s - 8*D1*Dd*f**2*g2 + 80*D1*Dd*f**2*gd2*r**2 + 80*D1*Dd*f**2*gd2*r*s - 80*D1*Dd*f**2*gd2*r - 10*D1*Dd*f**2*gd2*s + 10*D1*Dd*f**2*gd2 + 160*D1*Dd*f*fd*g2*r**2 + 160*D1*Dd*f*fd*g2*r*s - 160*D1*Dd*f*fd*g2*r - 60*D1*Dd*f*fd*g2*s + 40*D1*Dd*f*fd*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 24*D1*Ddd*K*b1**2*f*r*s + 24*D1*Ddd*K*b1**2*f*r + 6*D1*Ddd*K*b1**2*f*s - 6*D1*Ddd*K*b1**2*f - 20*D1*Ddd*K*b1*f**2*r**2 - 20*D1*Ddd*K*b1*f**2*r*s + 20*D1*Ddd*K*b1*f**2*r + 5*D1*Ddd*K*b1*f**2*s - 5*D1*Ddd*K*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 48*D1*Ddd*b1*f*g2*r*s - 48*D1*Ddd*b1*f*g2*r - 12*D1*Ddd*b1*f*g2*s + 12*D1*Ddd*b1*f*g2 + 40*D1*Ddd*f**2*g2*r**2 + 40*D1*Ddd*f**2*g2*r*s - 40*D1*Ddd*f**2*g2*r - 10*D1*Ddd*f**2*g2*s + 10*D1*Ddd*f**2*g2 + D1*bd1*(D1*(4*K*f**2*r*(r + s - 1) + f*(5*K*(b1*(2*r - 1)*(r + s - 1) + fd*(-4*r**2 - 4*r*s + 4*r + s - 1)) - 10*g2*(r - 1)*(r + s - 1) + 12*gd2*(2*r - 1)*(r + s - 1)) + 6*fd*(K*b1*(-4*r**2 + r*(3 - 4*s) + s) + g2*(4*r**2 + 4*r*(s - 1) - 2*s))) + Dd*f*(-K*(6*b1*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + 5*f*(8*r**2 + 8*r*(s - 1) - s + 1)) + 12*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) - 72*Dd**2*K*b1**2*f*r**2 - 72*Dd**2*K*b1**2*f*r*s + 72*Dd**2*K*b1**2*f*r + 18*Dd**2*K*b1**2*f*s - 12*Dd**2*K*b1**2*f - 60*Dd**2*K*b1*f**2*r**2 - 60*Dd**2*K*b1*f**2*r*s + 60*Dd**2*K*b1*f**2*r + 15*Dd**2*K*b1*f**2*s - 10*Dd**2*K*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 144*Dd**2*b1*f*g2*r*s - 144*Dd**2*b1*f*g2*r - 36*Dd**2*b1*f*g2*s + 24*Dd**2*b1*f*g2 + 120*Dd**2*f**2*g2*r**2 + 120*Dd**2*f**2*g2*r*s - 120*Dd**2*f**2*g2*r - 30*Dd**2*f**2*g2*s + 20*Dd**2*f**2*g2)/(21*d**2*k3**5) + D1**2*Pkd1*Pkd3*k1**3*k2**2*st**2*(1287*D1**2*K*bdd1*f**2*r**2 + 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*r - 429*D1**2*bd1**2*f*(-3*K + 4*f)*(2*r - 1)*(r + s - 1) - 975*D1**2*bdd1*f**3*r**2 - 975*D1**2*bdd1*f**3*r*s + 650*D1**2*bdd1*f**3*r - 325*D1**2*bdd1*f**3*s + 325*D1**2*bdd1*f**3 - 2574*D1**2*bdd1*f*g2*r**2 - 2574*D1**2*bdd1*f*g2*r*s + 5148*D1**2*bdd1*f*g2*r + 2574*D1**2*bdd1*f*g2*s - 2574*D1**2*bdd1*f*g2 - 660*D1**2*f**3*fd*r**2 - 660*D1**2*f**3*fd*r*s + 660*D1**2*f**3*fd*r + 165*D1**2*f**3*fd*s - 165*D1**2*f**3*fd + 980*D1**2*f**3*fdd*r**2 + 980*D1**2*f**3*fdd*r*s - 980*D1**2*f**3*fdd*r - 245*D1**2*f**3*fdd*s + 245*D1**2*f**3*fdd + 2940*D1**2*f**2*fd**2*r**2 + 2940*D1**2*f**2*fd**2*r*s - 2940*D1**2*f**2*fd**2*r - 735*D1**2*f**2*fd**2*s + 490*D1**2*f**2*fd**2 + 4290*D1**2*f**2*gd2*r**2 + 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*r - 2574*D1**2*f**2*gdd2*r**2 - 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*r + 8580*D1**2*f*fd*g2*r**2 + 8580*D1**2*f*fd*g2*r*s - 8580*D1**2*f*fd*g2*r - 4290*D1**2*f*fd*g2*s + 4290*D1**2*f*fd*g2 - 10296*D1**2*f*fd*gd2*r**2 - 10296*D1**2*f*fd*gd2*r*s + 10296*D1**2*f*fd*gd2*r + 2574*D1**2*f*fd*gd2*s - 2574*D1**2*f*fd*gd2 - 5148*D1**2*f*fdd*g2*r**2 - 5148*D1**2*f*fdd*g2*r*s + 5148*D1**2*f*fdd*g2*r + 2574*D1**2*f*fdd*g2*s - 2574*D1**2*f*fdd*g2 - 5148*D1**2*fd**2*g2*r**2 - 5148*D1**2*fd**2*g2*r*s + 5148*D1**2*fd**2*g2*r + 2574*D1**2*fd**2*g2*s - 660*D1*Dd*f**4*r**2 - 660*D1*Dd*f**4*r*s + 660*D1*Dd*f**4*r + 165*D1*Dd*f**4*s - 165*D1*Dd*f**4 + 7840*D1*Dd*f**3*fd*r**2 + 7840*D1*Dd*f**3*fd*r*s - 7840*D1*Dd*f**3*fd*r - 1960*D1*Dd*f**3*fd*s + 1470*D1*Dd*f**3*fd + 17160*D1*Dd*f**2*g2*r**2 + 17160*D1*Dd*f**2*g2*r*s - 17160*D1*Dd*f**2*g2*r - 4290*D1*Dd*f**2*g2*s + 4290*D1*Dd*f**2*g2 - 20592*D1*Dd*f**2*gd2*r**2 - 20592*D1*Dd*f**2*gd2*r*s + 20592*D1*Dd*f**2*gd2*r + 2574*D1*Dd*f**2*gd2*s - 2574*D1*Dd*f**2*gd2 - 41184*D1*Dd*f*fd*g2*r**2 - 41184*D1*Dd*f*fd*g2*r*s + 41184*D1*Dd*f*fd*g2*r + 15444*D1*Dd*f*fd*g2*s - 10296*D1*Dd*f*fd*g2 + 980*D1*Ddd*f**4*r**2 + 980*D1*Ddd*f**4*r*s - 980*D1*Ddd*f**4*r - 245*D1*Ddd*f**4*s + 245*D1*Ddd*f**4 - 10296*D1*Ddd*f**2*g2*r**2 - 10296*D1*Ddd*f**2*g2*r*s + 10296*D1*Ddd*f**2*g2*r + 2574*D1*Ddd*f**2*g2*s - 2574*D1*Ddd*f**2*g2 + 13*D1*bd1*(D1*(f**3*(84*r + 17)*(r + s - 1) - 5*f**2*(33*K*r*(r + s - 1) + 5*fd*(18*r**2 + 2*r*(9*s - 8) - s + 2)) + 33*f*(3*K*fd*(4*r**2 + 4*r*(s - 1) - s + 1) + 26*g2*(r - 1)*(r + s - 1) - 6*gd2*(2*r - 1)*(r + s - 1)) - 198*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - Dd*f*(f*(-99*K*(8*r**2 + 8*r*(s - 1) - s + 1) + 25*f*(24*r**2 + 4*r*(6*s - 5) + s)) + 198*g2*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4))) + 2940*Dd**2*f**4*r**2 + 2940*Dd**2*f**4*r*s - 2940*Dd**2*f**4*r - 735*Dd**2*f**4*s + 490*Dd**2*f**4 - 30888*Dd**2*f**2*g2*r**2 - 30888*Dd**2*f**2*g2*r*s + 30888*Dd**2*f**2*g2*r + 7722*Dd**2*f**2*g2*s - 5148*Dd**2*f**2*g2 + 429*b1**2*(D1**2*r*(-13*K*fd*(r + s) + 3*K*fdd*(r + s) + f*(5*fd - 4*fdd)*(2*r + 2*s - 1) + fd**2*(-8*r - 8*s + 4)) + D1*(Dd*(3*K*fd*(8*r**2 + r*(8*s - 4) - s) + 5*f**2*(4*r**2 + 4*r*(s - 1) - s + 1) - f*(13*K*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(64*r**2 + 16*r*(4*s - 3) - 8*s + 4))) - Ddd*f*(-3*K + 4*f)*(4*r**2 + 4*r*(s - 1) - s + 1)) - Dd**2*f*(-3*K + 4*f)*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 13*b1*(-330*D1**2*K*f*fd*r**2 - 330*D1**2*K*f*fd*r*s + 330*D1**2*K*f*fd*r + 165*D1**2*K*f*fd*s - 165*D1**2*K*f*fd + 198*D1**2*K*f*fdd*r**2 + 198*D1**2*K*f*fdd*r*s - 198*D1**2*K*f*fdd*r - 99*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 198*D1**2*K*fd**2*r**2 + 198*D1**2*K*fd**2*r*s - 198*D1**2*K*fd**2*r - 99*D1**2*K*fd**2*s - 33*D1**2*bdd1*f*(-3*K + 4*f)*(2*r - 1)*(r + s - 1) + 252*D1**2*f**2*fd*r**2 + 252*D1**2*f**2*fd*r*s - 269*D1**2*f**2*fd*r - 101*D1**2*f**2*fd*s + 101*D1**2*f**2*fd - 225*D1**2*f**2*fdd*r**2 - 225*D1**2*f**2*fdd*r*s + 250*D1**2*f**2*fdd*r + 100*D1**2*f**2*fdd*s - 100*D1**2*f**2*fdd - 450*D1**2*f*fd**2*r**2 - 450*D1**2*f*fd**2*r*s + 500*D1**2*f*fd**2*r + 200*D1**2*f*fd**2*s - 100*D1**2*f*fd**2 + 858*D1**2*f*gd2*r**2 + 858*D1**2*f*gd2*r*s - 858*D1**2*f*gd2*r - 198*D1**2*f*gdd2*r**2 - 198*D1**2*f*gdd2*r*s + 198*D1**2*f*gdd2*r + 858*D1**2*fd*g2*r**2 + 858*D1**2*fd*g2*r*s - 396*D1**2*fd*gd2*r**2 - 396*D1**2*fd*gd2*r*s + 198*D1**2*fd*gd2*r - 198*D1**2*fdd*g2*r**2 - 198*D1**2*fdd*g2*r*s - 660*D1*Dd*K*f**2*r**2 - 660*D1*Dd*K*f**2*r*s + 660*D1*Dd*K*f**2*r + 165*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 1584*D1*Dd*K*f*fd*r**2 + 1584*D1*Dd*K*f*fd*r*s - 1584*D1*Dd*K*f*fd*r - 594*D1*Dd*K*f*fd*s + 396*D1*Dd*K*f*fd + 336*D1*Dd*f**3*r**2 + 336*D1*Dd*f**3*r*s - 336*D1*Dd*f**3*r - 84*D1*Dd*f**3*s + 84*D1*Dd*f**3 - 1800*D1*Dd*f**2*fd*r**2 - 1800*D1*Dd*f**2*fd*r*s + 1900*D1*Dd*f**2*fd*r + 625*D1*Dd*f**2*fd*s - 450*D1*Dd*f**2*fd + 3432*D1*Dd*f*g2*r**2 + 3432*D1*Dd*f*g2*r*s - 3432*D1*Dd*f*g2*r - 858*D1*Dd*f*g2*s + 858*D1*Dd*f*g2 - 1584*D1*Dd*f*gd2*r**2 - 1584*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r + 198*D1*Dd*f*gd2*s - 198*D1*Dd*f*gd2 - 1584*D1*Dd*fd*g2*r**2 - 1584*D1*Dd*fd*g2*r*s + 792*D1*Dd*fd*g2*r + 198*D1*Dd*fd*g2*s + 396*D1*Ddd*K*f**2*r**2 + 396*D1*Ddd*K*f**2*r*s - 396*D1*Ddd*K*f**2*r - 99*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 - 300*D1*Ddd*f**3*r**2 - 300*D1*Ddd*f**3*r*s + 300*D1*Ddd*f**3*r + 75*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 792*D1*Ddd*f*g2*r**2 - 792*D1*Ddd*f*g2*r*s + 792*D1*Ddd*f*g2*r + 198*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 + 33*D1*bd1*(D1*(3*K*fd*(4*r**2 + r*(4*s - 3) - s) + 5*f**2*(2*r - 1)*(r + s - 1) - f*(13*K*(2*r - 1)*(r + s - 1) + 4*fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1))) - Dd*f*(-3*K + 4*f)*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5)) + 1188*Dd**2*K*f**2*r**2 + 1188*Dd**2*K*f**2*r*s - 1188*Dd**2*K*f**2*r - 297*Dd**2*K*f**2*s + 198*Dd**2*K*f**2 - 900*Dd**2*f**3*r**2 - 900*Dd**2*f**3*r*s + 900*Dd**2*f**3*r + 225*Dd**2*f**3*s - 150*Dd**2*f**3 - 2376*Dd**2*f*g2*r**2 - 2376*Dd**2*f*g2*r*s + 2376*Dd**2*f*g2*r + 594*Dd**2*f*g2*s - 396*Dd**2*f*g2))/(9009*d**2*k3**5) - D1**2*Pkd1*Pkd3*k1**3*st**2*(2*C - 1)*(33*D1*b1*(D1*bdd1*f*(-2*r**2 - 2*r*(s - 1) + s - 1) + bd1*(D1*(9*f*(2*r**2 + 2*r*(s - 1) - s + 1) + fd*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + (D1*(-f*fd + f*fdd + fd**2) + 4*Dd*f*fd)*(2*r + s - 1)) + 33*b1**2*(D1**2*r*(9*fd - fdd)*(r + s - 1) + D1*(Dd*(9*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(-8*r**2 - 8*r*(s - 1) + s - 1)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + f*(-33*D1**2*bd1**2*(2*r**2 + 2*r*(s - 1) - s) - 33*D1**2*bdd1*f*(2*r + s - 1) - 51*D1**2*f*fd*r**2 - 51*D1**2*f*fd*r*s + 51*D1**2*f*fd*r + 17*D1**2*f*fd*s - 17*D1**2*f*fd + 75*D1**2*f*fdd*r**2 + 75*D1**2*f*fdd*r*s - 75*D1**2*f*fdd*r - 25*D1**2*f*fdd*s + 25*D1**2*f*fdd + 150*D1**2*fd**2*r**2 + 150*D1**2*fd**2*r*s - 150*D1**2*fd**2*r - 50*D1**2*fd**2*s + 25*D1**2*fd**2 - 68*D1*Dd*f**2*r**2 - 68*D1*Dd*f**2*r*s + 68*D1*Dd*f**2*r + 17*D1*Dd*f**2*s - 17*D1*Dd*f**2 + 600*D1*Dd*f*fd*r**2 + 600*D1*Dd*f*fd*r*s - 600*D1*Dd*f*fd*r - 175*D1*Dd*f*fd*s + 125*D1*Dd*f*fd + 100*D1*Ddd*f**2*r**2 + 100*D1*Ddd*f**2*r*s - 100*D1*Ddd*f**2*r - 25*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 + 33*D1*bd1*(D1*(f - fd) - 4*Dd*f)*(2*r + s - 1) + 300*Dd**2*f**2*r**2 + 300*Dd**2*f**2*r*s - 300*Dd**2*f**2*r - 75*Dd**2*f**2*s + 50*Dd**2*f**2))/(693*d**2*k3**3) - 2*D1**2*Pkd1*Pkd3*k1**3*(-21*D1**2*K*b1**2*bdd1*r**2 - 21*D1**2*K*b1**2*bdd1*r*s + 21*D1**2*K*b1**2*bdd1*r + 7*D1**2*K*b1**2*bdd1*s - 7*D1**2*K*b1**2*bdd1 - 10*D1**2*K*b1**2*fd*r - 5*D1**2*K*b1**2*fd*s + 5*D1**2*K*b1**2*fd + 12*D1**2*K*b1**2*fdd*r + 6*D1**2*K*b1**2*fdd*s - 6*D1**2*K*b1**2*fdd - 12*D1**2*K*b1*bdd1*f*r - 6*D1**2*K*b1*bdd1*f*s + 6*D1**2*K*b1*bdd1*f - 8*D1**2*K*b1*f*fd*r**2 - 8*D1**2*K*b1*f*fd*r*s + 8*D1**2*K*b1*f*fd*r + 4*D1**2*K*b1*f*fd*s - 4*D1**2*K*b1*f*fd + 10*D1**2*K*b1*f*fdd*r**2 + 10*D1**2*K*b1*f*fdd*r*s - 10*D1**2*K*b1*f*fdd*r - 5*D1**2*K*b1*f*fdd*s + 5*D1**2*K*b1*f*fdd + 10*D1**2*K*b1*fd**2*r**2 + 10*D1**2*K*b1*fd**2*r*s - 10*D1**2*K*b1*fd**2*r - 5*D1**2*K*b1*fd**2*s + 5*D1**2*K*bdd1*f**2*r**2 + 5*D1**2*K*bdd1*f**2*r*s - 5*D1**2*K*bdd1*f**2*r - 28*D1**2*b1**2*gd2*r**2 - 28*D1**2*b1**2*gd2*r*s + 28*D1**2*b1**2*gd2*r + 14*D1**2*b1**2*gdd2*r**2 + 14*D1**2*b1**2*gdd2*r*s - 14*D1**2*b1**2*gdd2*r - 5*D1**2*b1*bd2*f*r**2 - 5*D1**2*b1*bd2*f*r*s + 5*D1**2*b1*bd2*f*r + 12*D1**2*b1*bd2*fd*r**2 + 12*D1**2*b1*bd2*fd*r*s - 6*D1**2*b1*bd2*fd*r + 28*D1**2*b1*bdd1*g2*r**2 + 28*D1**2*b1*bdd1*g2*r*s - 28*D1**2*b1*bdd1*g2*r - 14*D1**2*b1*bdd1*g2*s + 14*D1**2*b1*bdd1*g2 + 6*D1**2*b1*bdd2*f*r**2 + 6*D1**2*b1*bdd2*f*r*s - 6*D1**2*b1*bdd2*f*r + 20*D1**2*b1*fd*g2*r + 10*D1**2*b1*fd*g2*s - 10*D1**2*b1*fd*g2 - 24*D1**2*b1*fd*gd2*r - 12*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fd*gd2 - 24*D1**2*b1*fdd*g2*r - 12*D1**2*b1*fdd*g2*s + 12*D1**2*b1*fdd*g2 - D1**2*bd1**2*(7*K*b1*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*K*f*(2*r + s - 1) + 14*g2*(-2*r**2 - 2*r*s + 2*r + s)) - 4*D1**2*bd2*f**2*r**2 - 4*D1**2*bd2*f**2*r*s + 4*D1**2*bd2*f**2*r + 20*D1**2*bd2*f*fd*r**2 + 20*D1**2*bd2*f*fd*r*s - 20*D1**2*bd2*f*fd*r - 5*D1**2*bd2*f*fd*s + 5*D1**2*bd2*f*fd + 24*D1**2*bdd1*f*g2*r + 12*D1**2*bdd1*f*g2*s - 12*D1**2*bdd1*f*g2 + 5*D1**2*bdd2*f**2*r**2 + 5*D1**2*bdd2*f**2*r*s - 5*D1**2*bdd2*f**2*r + 8*D1**2*f**2*gd2*r**2 + 8*D1**2*f**2*gd2*r*s - 8*D1**2*f**2*gd2*r - 10*D1**2*f**2*gdd2*r**2 - 10*D1**2*f**2*gdd2*r*s + 10*D1**2*f**2*gdd2*r + 16*D1**2*f*fd*g2*r**2 + 16*D1**2*f*fd*g2*r*s - 16*D1**2*f*fd*g2*r - 8*D1**2*f*fd*g2*s + 8*D1**2*f*fd*g2 - 40*D1**2*f*fd*gd2*r**2 - 40*D1**2*f*fd*gd2*r*s + 40*D1**2*f*fd*gd2*r + 10*D1**2*f*fd*gd2*s - 10*D1**2*f*fd*gd2 - 20*D1**2*f*fdd*g2*r**2 - 20*D1**2*f*fdd*g2*r*s + 20*D1**2*f*fdd*g2*r + 10*D1**2*f*fdd*g2*s - 10*D1**2*f*fdd*g2 - 20*D1**2*fd**2*g2*r**2 - 20*D1**2*fd**2*g2*r*s + 20*D1**2*fd**2*g2*r + 10*D1**2*fd**2*g2*s + 56*D1*Dd*K*b1**3*r**2 + 56*D1*Dd*K*b1**3*r*s - 56*D1*Dd*K*b1**3*r - 14*D1*Dd*K*b1**3*s + 14*D1*Dd*K*b1**3 + 48*D1*Dd*K*b1**2*fd*r + 24*D1*Dd*K*b1**2*fd*s - 24*D1*Dd*K*b1**2*fd - 16*D1*Dd*K*b1*f**2*r**2 - 16*D1*Dd*K*b1*f**2*r*s + 16*D1*Dd*K*b1*f**2*r + 4*D1*Dd*K*b1*f**2*s - 4*D1*Dd*K*b1*f**2 + 80*D1*Dd*K*b1*f*fd*r**2 + 80*D1*Dd*K*b1*f*fd*r*s - 80*D1*Dd*K*b1*f*fd*r - 30*D1*Dd*K*b1*f*fd*s + 20*D1*Dd*K*b1*f*fd - 112*D1*Dd*b1**2*g2*r**2 - 112*D1*Dd*b1**2*g2*r*s + 112*D1*Dd*b1**2*g2*r + 28*D1*Dd*b1**2*g2*s - 28*D1*Dd*b1**2*g2 + 112*D1*Dd*b1**2*gd2*r**2 + 112*D1*Dd*b1**2*gd2*r*s - 112*D1*Dd*b1**2*gd2*r - 14*D1*Dd*b1**2*gd2*s + 14*D1*Dd*b1**2*gd2 + 48*D1*Dd*b1*bd2*f*r**2 + 48*D1*Dd*b1*bd2*f*r*s - 48*D1*Dd*b1*bd2*f*r - 6*D1*Dd*b1*bd2*f*s + 6*D1*Dd*b1*bd2*f - 96*D1*Dd*b1*fd*g2*r - 48*D1*Dd*b1*fd*g2*s + 48*D1*Dd*b1*fd*g2 + 40*D1*Dd*bd2*f**2*r**2 + 40*D1*Dd*bd2*f**2*r*s - 40*D1*Dd*bd2*f**2*r - 5*D1*Dd*bd2*f**2*s + 5*D1*Dd*bd2*f**2 + 32*D1*Dd*f**2*g2*r**2 + 32*D1*Dd*f**2*g2*r*s - 32*D1*Dd*f**2*g2*r - 8*D1*Dd*f**2*g2*s + 8*D1*Dd*f**2*g2 - 80*D1*Dd*f**2*gd2*r**2 - 80*D1*Dd*f**2*gd2*r*s + 80*D1*Dd*f**2*gd2*r + 10*D1*Dd*f**2*gd2*s - 10*D1*Dd*f**2*gd2 - 160*D1*Dd*f*fd*g2*r**2 - 160*D1*Dd*f*fd*g2*r*s + 160*D1*Dd*f*fd*g2*r + 60*D1*Dd*f*fd*g2*s - 40*D1*Dd*f*fd*g2 - 28*D1*Ddd*K*b1**3*r**2 - 28*D1*Ddd*K*b1**3*r*s + 28*D1*Ddd*K*b1**3*r + 7*D1*Ddd*K*b1**3*s - 7*D1*Ddd*K*b1**3 + 20*D1*Ddd*K*b1*f**2*r**2 + 20*D1*Ddd*K*b1*f**2*r*s - 20*D1*Ddd*K*b1*f**2*r - 5*D1*Ddd*K*b1*f**2*s + 5*D1*Ddd*K*b1*f**2 + 56*D1*Ddd*b1**2*g2*r**2 + 56*D1*Ddd*b1**2*g2*r*s - 56*D1*Ddd*b1**2*g2*r - 14*D1*Ddd*b1**2*g2*s + 14*D1*Ddd*b1**2*g2 - 40*D1*Ddd*f**2*g2*r**2 - 40*D1*Ddd*f**2*g2*r*s + 40*D1*Ddd*f**2*g2*r + 10*D1*Ddd*f**2*g2*s - 10*D1*Ddd*f**2*g2 + D1*bd1*(6*D1*bd2*f*(2*r - 1)*(r + s - 1) + 7*K*b1**2*(D1*(6*r**2 + 6*r*(s - 1) - 2*s + 2) + Dd*(-24*r**2 - 24*r*(s - 1) + 7*s - 5)) + b1*(D1*(K*(5*f + 6*fd)*(2*r + s - 1) - 28*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 14*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) + 4*Dd*(-6*K*f*(2*r + s - 1) + 7*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2))) + f*(D1*(-4*K*f*r*(r + s - 1) + 5*K*fd*(4*r**2 + 4*r*(s - 1) - s + 1) - 10*g2*(2*r + s - 1) + 12*gd2*(2*r + s - 1)) + Dd*(5*K*f*(8*r**2 + 8*r*(s - 1) - s + 1) + 48*g2*(2*r + s - 1)))) - 84*Dd**2*K*b1**3*r**2 - 84*Dd**2*K*b1**3*r*s + 84*Dd**2*K*b1**3*r + 21*Dd**2*K*b1**3*s - 14*Dd**2*K*b1**3 + 60*Dd**2*K*b1*f**2*r**2 + 60*Dd**2*K*b1*f**2*r*s - 60*Dd**2*K*b1*f**2*r - 15*Dd**2*K*b1*f**2*s + 10*Dd**2*K*b1*f**2 + 168*Dd**2*b1**2*g2*r**2 + 168*Dd**2*b1**2*g2*r*s - 168*Dd**2*b1**2*g2*r - 42*Dd**2*b1**2*g2*s + 28*Dd**2*b1**2*g2 - 120*Dd**2*f**2*g2*r**2 - 120*Dd**2*f**2*g2*r*s + 120*Dd**2*f**2*g2*r + 30*Dd**2*f**2*g2*s - 20*Dd**2*f**2*g2 + b2*(-5*D1**2*b1*fd*r**2 - 5*D1**2*b1*fd*r*s + 6*D1**2*b1*fdd*r**2 + 6*D1**2*b1*fdd*r*s + 6*D1**2*bdd1*f*(r - 1)*(r + s - 1) - 8*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 4*D1**2*f*fd*s - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r - 5*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*r - 5*D1**2*fd**2*s - 20*D1*Dd*b1*f*r**2 - 20*D1*Dd*b1*f*r*s + 20*D1*Dd*b1*f*r + 5*D1*Dd*b1*f*s - 5*D1*Dd*b1*f + 48*D1*Dd*b1*fd*r**2 + 48*D1*Dd*b1*fd*r*s - 24*D1*Dd*b1*fd*r - 6*D1*Dd*b1*fd*s - 16*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 16*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 80*D1*Dd*f*fd*r*s - 80*D1*Dd*f*fd*r - 30*D1*Dd*f*fd*s + 20*D1*Dd*f*fd + 24*D1*Ddd*b1*f*r**2 + 24*D1*Ddd*b1*f*r*s - 24*D1*Ddd*b1*f*r - 6*D1*Ddd*b1*f*s + 6*D1*Ddd*b1*f + 20*D1*Ddd*f**2*r**2 + 20*D1*Ddd*f**2*r*s - 20*D1*Ddd*f**2*r - 5*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + D1*bd1*(D1*(-5*f*(r - 1)*(r + s - 1) + 6*fd*(2*r**2 + 2*r*(s - 1) - s)) + 6*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) + 72*Dd**2*b1*f*r**2 + 72*Dd**2*b1*f*r*s - 72*Dd**2*b1*f*r - 18*Dd**2*b1*f*s + 12*Dd**2*b1*f + 60*Dd**2*f**2*r**2 + 60*Dd**2*f**2*r*s - 60*Dd**2*f**2*r - 15*Dd**2*f**2*s + 10*Dd**2*f**2))/(21*d**2*k3**3) + D1**2*Pkd1*Pkd3*k1*k2**2*st**2*(-198*D1**2*K*bd1**2*f*r**2 - 198*D1**2*K*bd1**2*f*r*s + 297*D1**2*K*bd1**2*f*r + 99*D1**2*K*bd1**2*f*s - 99*D1**2*K*bd1**2*f + 165*D1**2*K*bd1*f**2*r**2 + 165*D1**2*K*bd1*f**2*r*s - 165*D1**2*K*bd1*f**2*r - 396*D1**2*K*bd1*f*fd*r**2 - 396*D1**2*K*bd1*f*fd*r*s + 396*D1**2*K*bd1*f*fd*r + 99*D1**2*K*bd1*f*fd*s - 99*D1**2*K*bd1*f*fd - 99*D1**2*K*bdd1*f**2*r**2 - 99*D1**2*K*bdd1*f**2*r*s + 99*D1**2*K*bdd1*f**2*r + 132*D1**2*bd1**2*f**2*r**2 + 132*D1**2*bd1**2*f**2*r*s - 297*D1**2*bd1**2*f**2*r - 132*D1**2*bd1**2*f**2*s + 99*D1**2*bd1**2*f**2 - 198*D1**2*bd1*bd2*f*r**2 - 198*D1**2*bd1*bd2*f*r*s + 297*D1**2*bd1*bd2*f*r + 99*D1**2*bd1*bd2*f*s - 99*D1**2*bd1*bd2*f - 101*D1**2*bd1*f**3*r**2 - 101*D1**2*bd1*f**3*r*s + 84*D1**2*bd1*f**3*r + 600*D1**2*bd1*f**2*fd*r**2 + 600*D1**2*bd1*f**2*fd*r*s - 550*D1**2*bd1*f**2*fd*r - 100*D1**2*bd1*f**2*fd*s + 75*D1**2*bd1*f**2*fd - 858*D1**2*bd1*f*g2*r**2 - 858*D1**2*bd1*f*g2*r*s + 1716*D1**2*bd1*f*g2*r + 858*D1**2*bd1*f*g2*s - 858*D1**2*bd1*f*g2 + 396*D1**2*bd1*f*gd2*r**2 + 396*D1**2*bd1*f*gd2*r*s - 594*D1**2*bd1*f*gd2*r - 198*D1**2*bd1*f*gd2*s + 198*D1**2*bd1*f*gd2 + 396*D1**2*bd1*fd*g2*r**2 + 396*D1**2*bd1*fd*g2*r*s - 396*D1**2*bd1*fd*g2*r - 198*D1**2*bd1*fd*g2*s + 165*D1**2*bd2*f**2*r**2 + 165*D1**2*bd2*f**2*r*s - 165*D1**2*bd2*f**2*r - 396*D1**2*bd2*f*fd*r**2 - 396*D1**2*bd2*f*fd*r*s + 396*D1**2*bd2*f*fd*r + 99*D1**2*bd2*f*fd*s - 99*D1**2*bd2*f*fd + 100*D1**2*bdd1*f**3*r**2 + 100*D1**2*bdd1*f**3*r*s - 75*D1**2*bdd1*f**3*r + 198*D1**2*bdd1*f*g2*r**2 + 198*D1**2*bdd1*f*g2*r*s - 396*D1**2*bdd1*f*g2*r - 198*D1**2*bdd1*f*g2*s + 198*D1**2*bdd1*f*g2 - 99*D1**2*bdd2*f**2*r**2 - 99*D1**2*bdd2*f**2*r*s + 99*D1**2*bdd2*f**2*r - 330*D1**2*f**2*gd2*r**2 - 330*D1**2*f**2*gd2*r*s + 330*D1**2*f**2*gd2*r + 198*D1**2*f**2*gdd2*r**2 + 198*D1**2*f**2*gdd2*r*s - 198*D1**2*f**2*gdd2*r - 660*D1**2*f*fd*g2*r**2 - 660*D1**2*f*fd*g2*r*s + 660*D1**2*f*fd*g2*r + 330*D1**2*f*fd*g2*s - 330*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 792*D1**2*f*fd*gd2*r*s - 792*D1**2*f*fd*gd2*r - 198*D1**2*f*fd*gd2*s + 198*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 396*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r - 198*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 396*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r - 198*D1**2*fd**2*g2*s - 792*D1*Dd*K*bd1*f**2*r**2 - 792*D1*Dd*K*bd1*f**2*r*s + 792*D1*Dd*K*bd1*f**2*r + 99*D1*Dd*K*bd1*f**2*s - 99*D1*Dd*K*bd1*f**2 + 800*D1*Dd*bd1*f**3*r**2 + 800*D1*Dd*bd1*f**3*r*s - 700*D1*Dd*bd1*f**3*r - 100*D1*Dd*bd1*f**3*s + 75*D1*Dd*bd1*f**3 + 1584*D1*Dd*bd1*f*g2*r**2 + 1584*D1*Dd*bd1*f*g2*r*s - 2376*D1*Dd*bd1*f*g2*r - 990*D1*Dd*bd1*f*g2*s + 792*D1*Dd*bd1*f*g2 - 792*D1*Dd*bd2*f**2*r**2 - 792*D1*Dd*bd2*f**2*r*s + 792*D1*Dd*bd2*f**2*r + 99*D1*Dd*bd2*f**2*s - 99*D1*Dd*bd2*f**2 - 1320*D1*Dd*f**2*g2*r**2 - 1320*D1*Dd*f**2*g2*r*s + 1320*D1*Dd*f**2*g2*r + 330*D1*Dd*f**2*g2*s - 330*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 1584*D1*Dd*f**2*gd2*r*s - 1584*D1*Dd*f**2*gd2*r - 198*D1*Dd*f**2*gd2*s + 198*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 3168*D1*Dd*f*fd*g2*r*s - 3168*D1*Dd*f*fd*g2*r - 1188*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 + 792*D1*Ddd*f**2*g2*r**2 + 792*D1*Ddd*f**2*g2*r*s - 792*D1*Ddd*f**2*g2*r - 198*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 2376*Dd**2*f**2*g2*r**2 + 2376*Dd**2*f**2*g2*r*s - 2376*Dd**2*f**2*g2*r - 594*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 + 33*b1**3*(D1**2*r*(11*fd - 2*fdd)*(r + s - 1) + D1*(Dd*(11*f*(4*r**2 + 4*r*(s - 1) - s + 1) - 2*fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + 2*Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + 33*b1**2*(13*D1**2*K*fd*r**2 + 13*D1**2*K*fd*r*s - 3*D1**2*K*fdd*r**2 - 3*D1**2*K*fdd*r*s - 2*D1**2*bdd1*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s - 3*D1**2*f*fd*r - 3*D1**2*f*fd*s + 3*D1**2*f*fd + 4*D1**2*f*fdd*r**2 + 4*D1**2*f*fdd*r*s + D1**2*f*fdd*r + 2*D1**2*f*fdd*s - 2*D1**2*f*fdd + 4*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r*s + D1**2*fd**2*r + 2*D1**2*fd**2*s - 2*D1**2*fd**2 + 52*D1*Dd*K*f*r**2 + 52*D1*Dd*K*f*r*s - 52*D1*Dd*K*f*r - 13*D1*Dd*K*f*s + 13*D1*Dd*K*f - 24*D1*Dd*K*fd*r**2 - 24*D1*Dd*K*fd*r*s + 12*D1*Dd*K*fd*r + 3*D1*Dd*K*fd*s - 8*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r + 2*D1*Dd*f**2*s - 2*D1*Dd*f**2 + 32*D1*Dd*f*fd*r**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 4*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 12*D1*Ddd*K*f*r**2 - 12*D1*Ddd*K*f*r*s + 12*D1*Ddd*K*f*r + 3*D1*Ddd*K*f*s - 3*D1*Ddd*K*f + 8*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 8*D1*Ddd*f**2*r - 2*D1*Ddd*f**2*s + 2*D1*Ddd*f**2 + D1*bd1*(D1*(11*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 2*fd*(6*r**2 + 6*r*(s - 1) - s + 1)) - 2*Dd*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) - 36*Dd**2*K*f*r**2 - 36*Dd**2*K*f*r*s + 36*Dd**2*K*f*r + 9*Dd**2*K*f*s - 6*Dd**2*K*f + 24*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 24*Dd**2*f**2*r - 6*Dd**2*f**2*s + 4*Dd**2*f**2) + b1*(-198*D1**2*K*bdd1*f*r**2 - 198*D1**2*K*bdd1*f*r*s + 297*D1**2*K*bdd1*f*r + 99*D1**2*K*bdd1*f*s - 99*D1**2*K*bdd1*f + 330*D1**2*K*f*fd*r**2 + 330*D1**2*K*f*fd*r*s - 330*D1**2*K*f*fd*r - 165*D1**2*K*f*fd*s + 165*D1**2*K*f*fd - 198*D1**2*K*f*fdd*r**2 - 198*D1**2*K*f*fdd*r*s + 198*D1**2*K*f*fdd*r + 99*D1**2*K*f*fdd*s - 99*D1**2*K*f*fdd - 198*D1**2*K*fd**2*r**2 - 198*D1**2*K*fd**2*r*s + 198*D1**2*K*fd**2*r + 99*D1**2*K*fd**2*s - 66*D1**2*bd1**2*f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 429*D1**2*bd2*f*r**2 + 429*D1**2*bd2*f*r*s - 429*D1**2*bd2*f*r - 198*D1**2*bd2*fd*r**2 - 198*D1**2*bd2*fd*r*s + 99*D1**2*bd2*fd*r + 132*D1**2*bdd1*f**2*r**2 + 132*D1**2*bdd1*f**2*r*s - 297*D1**2*bdd1*f**2*r - 132*D1**2*bdd1*f**2*s + 132*D1**2*bdd1*f**2 - 99*D1**2*bdd2*f*r**2 - 99*D1**2*bdd2*f*r*s + 99*D1**2*bdd2*f*r - 303*D1**2*f**2*fd*r**2 - 303*D1**2*f**2*fd*r*s + 320*D1**2*f**2*fd*r + 101*D1**2*f**2*fd*s - 101*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r**2 + 300*D1**2*f**2*fdd*r*s - 325*D1**2*f**2*fdd*r - 100*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd + 600*D1**2*f*fd**2*r**2 + 600*D1**2*f*fd**2*r*s - 650*D1**2*f*fd**2*r - 200*D1**2*f*fd**2*s + 125*D1**2*f*fd**2 - 858*D1**2*f*gd2*r**2 - 858*D1**2*f*gd2*r*s + 858*D1**2*f*gd2*r + 198*D1**2*f*gdd2*r**2 + 198*D1**2*f*gdd2*r*s - 198*D1**2*f*gdd2*r - 858*D1**2*fd*g2*r**2 - 858*D1**2*fd*g2*r*s + 396*D1**2*fd*gd2*r**2 + 396*D1**2*fd*gd2*r*s - 198*D1**2*fd*gd2*r + 198*D1**2*fdd*g2*r**2 + 198*D1**2*fdd*g2*r*s + 660*D1*Dd*K*f**2*r**2 + 660*D1*Dd*K*f**2*r*s - 660*D1*Dd*K*f**2*r - 165*D1*Dd*K*f**2*s + 165*D1*Dd*K*f**2 - 1584*D1*Dd*K*f*fd*r**2 - 1584*D1*Dd*K*f*fd*r*s + 1584*D1*Dd*K*f*fd*r + 594*D1*Dd*K*f*fd*s - 396*D1*Dd*K*f*fd - 792*D1*Dd*bd2*f*r**2 - 792*D1*Dd*bd2*f*r*s + 792*D1*Dd*bd2*f*r + 99*D1*Dd*bd2*f*s - 99*D1*Dd*bd2*f - 404*D1*Dd*f**3*r**2 - 404*D1*Dd*f**3*r*s + 404*D1*Dd*f**3*r + 101*D1*Dd*f**3*s - 101*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r**2 + 2400*D1*Dd*f**2*fd*r*s - 2500*D1*Dd*f**2*fd*r - 700*D1*Dd*f**2*fd*s + 525*D1*Dd*f**2*fd - 3432*D1*Dd*f*g2*r**2 - 3432*D1*Dd*f*g2*r*s + 3432*D1*Dd*f*g2*r + 858*D1*Dd*f*g2*s - 858*D1*Dd*f*g2 + 1584*D1*Dd*f*gd2*r**2 + 1584*D1*Dd*f*gd2*r*s - 1584*D1*Dd*f*gd2*r - 198*D1*Dd*f*gd2*s + 198*D1*Dd*f*gd2 + 1584*D1*Dd*fd*g2*r**2 + 1584*D1*Dd*fd*g2*r*s - 792*D1*Dd*fd*g2*r - 198*D1*Dd*fd*g2*s - 396*D1*Ddd*K*f**2*r**2 - 396*D1*Ddd*K*f**2*r*s + 396*D1*Ddd*K*f**2*r + 99*D1*Ddd*K*f**2*s - 99*D1*Ddd*K*f**2 + 400*D1*Ddd*f**3*r**2 + 400*D1*Ddd*f**3*r*s - 400*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s + 100*D1*Ddd*f**3 + 792*D1*Ddd*f*g2*r**2 + 792*D1*Ddd*f*g2*r*s - 792*D1*Ddd*f*g2*r - 198*D1*Ddd*f*g2*s + 198*D1*Ddd*f*g2 - 33*D1*bd1*(D1*(3*K*fd*(4*r**2 + r*(4*s - 3) - s) + f**2*(4*r**2 + r*(4*s - 11) - 5*s + 5) - f*(13*K*(2*r - 1)*(r + s - 1) + fd*(4*r - 1)*(4*r + 4*s - 3))) + Dd*f*(3*K*(16*r**2 + 4*r*(4*s - 5) - 6*s + 5) + f*(-32*r**2 + r*(52 - 32*s) + 20*s - 17))) - 1188*Dd**2*K*f**2*r**2 - 1188*Dd**2*K*f**2*r*s + 1188*Dd**2*K*f**2*r + 297*Dd**2*K*f**2*s - 198*Dd**2*K*f**2 + 1200*Dd**2*f**3*r**2 + 1200*Dd**2*f**3*r*s - 1200*Dd**2*f**3*r - 300*Dd**2*f**3*s + 200*Dd**2*f**3 + 2376*Dd**2*f*g2*r**2 + 2376*Dd**2*f*g2*r*s - 2376*Dd**2*f*g2*r - 594*Dd**2*f*g2*s + 396*Dd**2*f*g2 + 33*b2*(D1**2*r*(13*fd - 3*fdd)*(r + s) + D1*(Dd*(13*f*(4*r**2 + 4*r*(s - 1) - s + 1) + 3*fd*(-8*r**2 + r*(4 - 8*s) + s)) - 3*Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) - 3*Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2))) + 33*b2*(-3*D1**2*bdd1*f*(r - 1)*(r + s - 1) + 10*D1**2*f*fd*r**2 + 10*D1**2*f*fd*r*s - 10*D1**2*f*fd*r - 5*D1**2*f*fd*s + 5*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 6*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r + 3*D1**2*f*fdd*s - 3*D1**2*f*fdd - 6*D1**2*fd**2*r**2 - 6*D1**2*fd**2*r*s + 6*D1**2*fd**2*r + 3*D1**2*fd**2*s + 20*D1*Dd*f**2*r**2 + 20*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r - 5*D1*Dd*f**2*s + 5*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 48*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r + 18*D1*Dd*f*fd*s - 12*D1*Dd*f*fd - 12*D1*Ddd*f**2*r**2 - 12*D1*Ddd*f**2*r*s + 12*D1*Ddd*f**2*r + 3*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + D1*bd1*(D1*(13*f*(r - 1)*(r + s - 1) + 3*fd*(-2*r**2 - 2*r*s + 2*r + s)) - 3*Dd*f*(8*r**2 + 4*r*(2*s - 3) - 5*s + 4)) - 36*Dd**2*f**2*r**2 - 36*Dd**2*f**2*r*s + 36*Dd**2*f**2*r + 9*Dd**2*f**2*s - 6*Dd**2*f**2))/(693*d**2*k3**3) + D1**2*Pkd1*Pkd3*k1*st**2*(2*C - 1)*(D1*f*(D1*bd1**2*(-2*r**2 - 2*r*(s - 1) + s) - D1*bdd1*f*r*(r + s) + bd1*(D1*(f*r*(r + s) + fd*(-4*r**2 - 4*r*s + 3*r + s)) + Dd*f*(-8*r**2 + r*(4 - 8*s) + s))) + b1**2*(D1**2*r*(9*fd - fdd)*(r + s - 1) + D1*(Dd*(9*f*(4*r**2 + 4*r*(s - 1) - s + 1) + fd*(-8*r**2 - 8*r*(s - 1) + s - 1)) + Ddd*f*(-4*r**2 - 4*r*(s - 1) + s - 1)) + Dd**2*f*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + b1*(D1**2*bdd1*f*(-2*r**2 - 2*r*s + 2*r + s - 1) + 2*D1**2*f*fd*r**2 + 2*D1**2*f*fd*r*s - 3*D1**2*f*fd*r - D1**2*f*fd*s + D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 2*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r**2 - 2*D1**2*fd**2*r*s + 3*D1**2*fd**2*r + D1**2*fd**2*s - D1**2*fd**2 + 4*D1*Dd*f**2*r**2 + 4*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r - D1*Dd*f**2*s + D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 16*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r + 6*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 4*D1*Ddd*f**2*r**2 - 4*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r + D1*Ddd*f**2*s - D1*Ddd*f**2 + D1*bd1*(D1*(9*f*(2*r**2 + 2*r*(s - 1) - s + 1) + fd*(-4*r**2 - 4*r*(s - 1) + s - 1)) - 2*Dd*f*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) - 12*Dd**2*f**2*r**2 - 12*Dd**2*f**2*r*s + 12*Dd**2*f**2*r + 3*Dd**2*f**2*s - 2*Dd**2*f**2))/(21*d**2*k3) + 2*D1**2*Pkd1*Pkd3*k1*(D1*(-2*D1*bd1**2*(3*K*f*r*(2*r + 2*s - 1) - 7*g2*(2*r**2 + 2*r*(s - 1) - s)) + 12*D1*bdd1*f*g2*r*(r + s) + b2*(-7*D1*bd1**2*(2*r**2 + 2*r*(s - 1) - s) - 6*D1*bdd1*f*r*(r + s) + bd1*(D1*(5*f*r*(r + s) - 6*fd*(2*r**2 + 2*r*(s - 1) - s)) - 6*Dd*f*(8*r**2 + r*(8*s - 4) - s))) - 2*bd1*(3*D1*bd2*f*r*(2*r + 2*s - 1) + D1*(f*r*(5*g2*(r + s) - 6*gd2*(2*r + 2*s - 1)) - 6*fd*g2*(2*r**2 + 2*r*(s - 1) - s)) - 6*Dd*f*g2*(8*r**2 + r*(8*s - 4) - s))) + 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + 4*r*(s - 1) - s + 1) + Dd**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2)) + b1**2*(42*D1**2*K*bd1*r**2 + 42*D1**2*K*bd1*r*s - 42*D1**2*K*bd1*r - 14*D1**2*K*bd1*s + 14*D1**2*K*bd1 - 21*D1**2*K*bdd1*r**2 - 21*D1**2*K*bdd1*r*s + 21*D1**2*K*bdd1*r + 7*D1**2*K*bdd1*s - 7*D1**2*K*bdd1 + 5*D1**2*K*fd*r**2 + 5*D1**2*K*fd*r*s - 10*D1**2*K*fd*r - 5*D1**2*K*fd*s + 5*D1**2*K*fd - 6*D1**2*K*fdd*r**2 - 6*D1**2*K*fdd*r*s + 12*D1**2*K*fdd*r + 6*D1**2*K*fdd*s - 6*D1**2*K*fdd - 7*D1**2*bdd2*r**2 - 7*D1**2*bdd2*r*s + 7*D1**2*bdd2*r - 28*D1**2*gd2*r**2 - 28*D1**2*gd2*r*s + 28*D1**2*gd2*r + 14*D1**2*gdd2*r**2 + 14*D1**2*gdd2*r*s - 14*D1**2*gdd2*r - 168*D1*Dd*K*bd1*r**2 - 168*D1*Dd*K*bd1*r*s + 168*D1*Dd*K*bd1*r + 49*D1*Dd*K*bd1*s - 35*D1*Dd*K*bd1 + 20*D1*Dd*K*f*r**2 + 20*D1*Dd*K*f*r*s - 20*D1*Dd*K*f*r - 5*D1*Dd*K*f*s + 5*D1*Dd*K*f - 48*D1*Dd*K*fd*r**2 - 48*D1*Dd*K*fd*r*s + 72*D1*Dd*K*fd*r + 30*D1*Dd*K*fd*s - 24*D1*Dd*K*fd - 112*D1*Dd*g2*r**2 - 112*D1*Dd*g2*r*s + 112*D1*Dd*g2*r + 28*D1*Dd*g2*s - 28*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 + 112*D1*Dd*gd2*r*s - 112*D1*Dd*gd2*r - 14*D1*Dd*gd2*s + 14*D1*Dd*gd2 - 24*D1*Ddd*K*f*r**2 - 24*D1*Ddd*K*f*r*s + 24*D1*Ddd*K*f*r + 6*D1*Ddd*K*f*s - 6*D1*Ddd*K*f + 56*D1*Ddd*g2*r**2 + 56*D1*Ddd*g2*r*s - 56*D1*Ddd*g2*r - 14*D1*Ddd*g2*s + 14*D1*Ddd*g2 + 7*D1*bd2*(2*D1*r*(r + s - 1) + Dd*(-8*r**2 - 8*r*s + 8*r + s - 1)) - 72*Dd**2*K*f*r**2 - 72*Dd**2*K*f*r*s + 72*Dd**2*K*f*r + 18*Dd**2*K*f*s - 12*Dd**2*K*f + 168*Dd**2*g2*r**2 + 168*Dd**2*g2*r*s - 168*Dd**2*g2*r - 42*Dd**2*g2*s + 28*Dd**2*g2 + 7*b2*(D1*(2*Dd - Ddd)*(4*r**2 + 4*r*(s - 1) - s + 1) + Dd**2*(-12*r**2 - 12*r*(s - 1) + 3*s - 2))) + b1*(-7*D1**2*K*bd1**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 12*D1**2*K*bdd1*f*r**2 - 12*D1**2*K*bdd1*f*r*s + 6*D1**2*K*bdd1*f*r + 5*D1**2*bd2*f*r**2 + 5*D1**2*bd2*f*r*s - 5*D1**2*bd2*f*r - 12*D1**2*bd2*fd*r**2 - 12*D1**2*bd2*fd*r*s + 18*D1**2*bd2*fd*r + 6*D1**2*bd2*fd*s - 6*D1**2*bd2*fd + 28*D1**2*bdd1*g2*r**2 + 28*D1**2*bdd1*g2*r*s - 28*D1**2*bdd1*g2*r - 14*D1**2*bdd1*g2*s + 14*D1**2*bdd1*g2 - 6*D1**2*bdd2*f*r**2 - 6*D1**2*bdd2*f*r*s + 6*D1**2*bdd2*f*r - 10*D1**2*f*gd2*r**2 - 10*D1**2*f*gd2*r*s + 10*D1**2*f*gd2*r + 12*D1**2*f*gdd2*r**2 + 12*D1**2*f*gdd2*r*s - 12*D1**2*f*gdd2*r - 10*D1**2*fd*g2*r**2 - 10*D1**2*fd*g2*r*s + 20*D1**2*fd*g2*r + 10*D1**2*fd*g2*s - 10*D1**2*fd*g2 + 24*D1**2*fd*gd2*r**2 + 24*D1**2*fd*gd2*r*s - 36*D1**2*fd*gd2*r - 12*D1**2*fd*gd2*s + 12*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r**2 + 12*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r - 12*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 - 48*D1*Dd*bd2*f*r**2 - 48*D1*Dd*bd2*f*r*s + 48*D1*Dd*bd2*f*r + 6*D1*Dd*bd2*f*s - 6*D1*Dd*bd2*f - 40*D1*Dd*f*g2*r**2 - 40*D1*Dd*f*g2*r*s + 40*D1*Dd*f*g2*r + 10*D1*Dd*f*g2*s - 10*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 96*D1*Dd*f*gd2*r*s - 96*D1*Dd*f*gd2*r - 12*D1*Dd*f*gd2*s + 12*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 96*D1*Dd*fd*g2*r*s - 144*D1*Dd*fd*g2*r - 60*D1*Dd*fd*g2*s + 48*D1*Dd*fd*g2 + 48*D1*Ddd*f*g2*r**2 + 48*D1*Ddd*f*g2*r*s - 48*D1*Ddd*f*g2*r - 12*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + D1*bd1*(-7*D1*bd2*(4*r**2 + 4*r*(s - 1) - s + 1) + D1*(K*(5*f*r*(2*r + 2*s - 1) - 6*fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) - 28*g2*(2*r**2 + 2*r*(s - 1) - s + 1) + 14*gd2*(4*r**2 + 4*r*(s - 1) - s + 1)) - 6*Dd*K*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1) + 28*Dd*g2*(8*r**2 + 8*r*(s - 1) - 3*s + 2)) + 144*Dd**2*f*g2*r**2 + 144*Dd**2*f*g2*r*s - 144*Dd**2*f*g2*r - 36*Dd**2*f*g2*s + 24*Dd**2*f*g2 + b2*(-7*D1**2*bdd1*(2*r**2 + 2*r*(s - 1) - s + 1) + 5*D1**2*fd*r**2 + 5*D1**2*fd*r*s - 10*D1**2*fd*r - 5*D1**2*fd*s + 5*D1**2*fd - 6*D1**2*fdd*r**2 - 6*D1**2*fdd*r*s + 12*D1**2*fdd*r + 6*D1**2*fdd*s - 6*D1**2*fdd + 20*D1*Dd*f*r**2 + 20*D1*Dd*f*r*s - 20*D1*Dd*f*r - 5*D1*Dd*f*s + 5*D1*Dd*f - 48*D1*Dd*fd*r**2 - 48*D1*Dd*fd*r*s + 72*D1*Dd*fd*r + 30*D1*Dd*fd*s - 24*D1*Dd*fd - 24*D1*Ddd*f*r**2 - 24*D1*Ddd*f*r*s + 24*D1*Ddd*f*r + 6*D1*Ddd*f*s - 6*D1*Ddd*f + 14*D1*bd1*(D1*(2*r**2 + 2*r*(s - 1) - s + 1) + Dd*(-8*r**2 - 8*r*(s - 1) + 3*s - 2)) - 72*Dd**2*f*r**2 - 72*Dd**2*f*r*s + 72*Dd**2*f*r + 18*Dd**2*f*s - 12*Dd**2*f)))/(21*d**2*k3) + D1**2*Pkd1*Pkd3*k2**2*st**2*(D1**2*bd1**2*f**2*r*(2*r + 2*s - 1) + D1*b1*f*(D1*bd1**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + D1*bdd1*f*r*(2*r + 2*s - 1) + bd1*(D1*(-2*f*r*(2*r + 2*s - 1) + fd*(8*r**2 + 8*r*(s - 1) - 2*s + 1)) + Dd*f*(16*r**2 + 4*r*(4*s - 3) - 2*s + 1))) + b1**3*(-D1**2*r*(2*fd - fdd)*(r + s - 1) + D1*(Dd*(f*(-8*r**2 - 8*r*s + 8*r + 2*s - 2) + fd*(8*r**2 + 8*r*(s - 1) - s + 1)) + Ddd*f*(4*r**2 + 4*r*(s - 1) - s + 1)) + Dd**2*f*(12*r**2 + 12*r*(s - 1) - 3*s + 2)) + b1**2*(D1**2*bdd1*f*(3*r**2 + 3*r*(s - 1) - s + 1) - 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 2*D1**2*f*fd*s - 2*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 2*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r - D1**2*f*fdd*s + D1**2*f*fdd + 2*D1**2*fd**2*r**2 + 2*D1**2*fd**2*r*s - 3*D1**2*fd**2*r - D1**2*fd**2*s + D1**2*fd**2 - 8*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r + 2*D1*Dd*f**2*s - 2*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 16*D1*Dd*f*fd*r*s - 20*D1*Dd*f*fd*r - 6*D1*Dd*f*fd*s + 5*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 + 4*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r - D1*Ddd*f**2*s + D1*Ddd*f**2 + D1*bd1*(D1*(f*(-6*r**2 - 6*r*s + 6*r + 2*s - 2) + fd*(6*r**2 + 6*r*(s - 1) - s + 1)) + Dd*f*(24*r**2 + 24*r*(s - 1) - 7*s + 5)) + 12*Dd**2*f**2*r**2 + 12*Dd**2*f**2*r*s - 12*Dd**2*f**2*r - 3*Dd**2*f**2*s + 2*Dd**2*f**2))/(21*d**2*k1*k3)
        perm23 = D1**4*Pk2*Pkd3*ct*f*k2**3*r*st**2*(8*C - 4)*(-b1*fd + bd1*f)/(21*d**2*k1*k3**3) + D1**4*Pk3*Pkd2*ct*f*k2**2*r*st**2*(8*C - 4)*(-b1*fd + bd1*f)/(21*d**2*k1*k3**2) + 8*D1**3*Pk2*Pk3*b1*k2**4*(2*C - 1)*(D1*bd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + b1*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)))/(3*d**2*k3**6) + 8*D1**3*Pk2*Pk3*ct**2*k2**6*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + f*(6*C - 3) - 7*g2) + b1*(D1*(f*fd*(12*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) + Dd*f*(12*C*f + 7*K*b1 - 6*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**8) - D1**3*Pk2*Pk3*ct*f*k2**5*st**2*(32*C - 16)*(D1*b1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + D1*bd1*f*r*(r + s - 1) + Dd*b1*f*(4*r**2 + r*(4*s - 5) - 2*s + 2))/(21*d**2*k1*k3**6) + 16*D1**3*Pk2*Pk3*ct*k1*k2**5*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + f*(6*C - 3) - 7*g2) + b1*(D1*(f*fd*(12*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) + Dd*f*(12*C*f + 7*K*b1 - 6*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**8) + 24*D1**3*Pk2*Pk3*f**3*k1**4*k2**2*st**4*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)/(77*d**2*k3**8) + 8*D1**3*Pk2*Pk3*k1**2*k2**4*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + f*(6*C - 3) - 7*g2) + b1*(D1*(f*fd*(12*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) + Dd*f*(12*C*f + 7*K*b1 - 6*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**8) - 4*D1**3*Pk2*Pk3*k2**6*st**2*(-D1*bd1*f*(r + s - 1)**2*(-14*K*b1 + f*(2*C - 1) + 14*g2) + b1*(D1*(-f*fd*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) - Dd*f*(-7*K*b1 + f*(2*C - 1) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**8) - 5*D1**3*Pk2*Pkd3*b1*k2**4*(2*C - 1)*(D1*bd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + b1*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)))/(3*d**2*k3**5) + D1**3*Pk2*Pkd3*ct**3*k2**3*(8*C - 4)*(D1*b1*(2*f*fd*r - f*fdd*r - fd**2*(r - 1)) + D1*bdd1*f**2*r + 2*Dd*b1*f*fd*(1 - 2*r) + bd1*f*(-2*D1*f*r + D1*fd*(r - 1) + 2*Dd*f*(2*r - 1)))/(21*d**2*k1*k3**3) - 3*D1**3*Pk2*Pkd3*ct**2*k2**6*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + f*(6*C - 3) - 7*g2) + b1*(D1*(f*fd*(12*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) + Dd*f*(12*C*f + 7*K*b1 - 6*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**7) + D1**3*Pk2*Pkd3*ct*f*k2**5*st**2*(8*C - 4)*(D1*b1*fd*(2*r**2 + 2*r*(s - 1) - s + 1) + D1*bd1*f*r*(r + s - 1) + Dd*b1*f*(4*r**2 + r*(4*s - 5) - 2*s + 2))/(21*d**2*k1*k3**5) - D1**3*Pk2*Pkd3*ct*f*k2*st**2*(8*C - 4)*(D1*b1*fd*(2*r - 1)*(r + s - 1) + D1*bd1*f*r*(r + s) + Dd*b1*f*(4*r**2 + r*(4*s - 5) - 2*s + 2))/(21*d**2*k1*k3) - 6*D1**3*Pk2*Pkd3*ct*k1*k2**5*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + f*(6*C - 3) - 7*g2) + b1*(D1*(f*fd*(12*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) + Dd*f*(12*C*f + 7*K*b1 - 6*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**7) - 9*D1**3*Pk2*Pkd3*f**3*k1**4*k2**2*st**4*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)/(77*d**2*k3**7) - 3*D1**3*Pk2*Pkd3*k1**2*k2**4*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + f*(6*C - 3) - 7*g2) + b1*(D1*(f*fd*(12*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) + Dd*f*(12*C*f + 7*K*b1 - 6*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(7*d**2*k3**7) + 3*D1**3*Pk2*Pkd3*k2**6*st**2*(-D1*bd1*f*(r + s - 1)**2*(-14*K*b1 + f*(2*C - 1) + 14*g2) + b1*(D1*(-f*fd*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) - Dd*f*(-7*K*b1 + f*(2*C - 1) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(14*d**2*k3**7) + D1**3*Pk2*Pkdd3*b1*k2**4*(2*C - 1)*(D1*bd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + b1*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)))/(3*d**2*k3**4) - D1**3*Pk2*Pkdd3*b1*k2**2*(2*C - 1)*(D1*bd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + b1*(D1*fd*(r + s - 1)**2 + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)))/(3*d**2*k3**2) + D1**3*Pk2*Pkdd3*ct**2*k2**6*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + f*(6*C - 3) - 7*g2) + b1*(D1*(f*fd*(12*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) + Dd*f*(12*C*f + 7*K*b1 - 6*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(21*d**2*k3**6) + 2*D1**3*Pk2*Pkdd3*ct*k1*k2**5*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + f*(6*C - 3) - 7*g2) + b1*(D1*(f*fd*(12*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) + Dd*f*(12*C*f + 7*K*b1 - 6*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(21*d**2*k3**6) + D1**3*Pk2*Pkdd3*f**3*k1**4*k2**2*st**4*(D1*fd + Dd*f)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)/(77*d**2*k3**6) + D1**3*Pk2*Pkdd3*k1**2*k2**4*(2*D1*bd1*f*(r + s - 1)**2*(7*K*b1 + f*(6*C - 3) - 7*g2) + b1*(D1*(f*fd*(12*C - 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 14*f*gd2*(r + s - 1)**2 - 7*fd*(r + s)**2*(-K*b1 + 2*g2)) + Dd*f*(12*C*f + 7*K*b1 - 6*f - 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(21*d**2*k3**6) + D1**3*Pk2*Pkdd3*k2**6*st**2*(D1*bd1*f*(r + s - 1)**2*(-14*K*b1 + f*(2*C - 1) + 14*g2) + b1*(D1*(f*fd*(2*C - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*f*gd2*(r + s - 1)**2 + 7*fd*(r + s)**2*(-K*b1 + 2*g2)) + Dd*f*(-7*K*b1 + f*(2*C - 1) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)))/(42*d**2*k3**6) + 16*D1**3*Pk3*Pkd2*b1*f*k1**4*k2*(D1*b1*fd*s*(2*r + 2*s - 1) + D1*bd1*f*(2*s - 1)*(r + s - 1) + Dd*b1*f*(r*(4*s - 1) + (1 - 2*s)**2))/(7*d**2*k3**6) - 4*D1**3*Pk3*Pkd2*b1*k2**3*(2*C - 1)*(D1*bd1*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + b1*(D1*fd*s*(r + s - 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)))/(3*d**2*k3**4) + D1**3*Pk3*Pkd2*ct**3*k2**2*(8*C - 4)*(D1*b1*(2*f*fd*r - f*fdd*r - fd**2*(r - 1)) + D1*bdd1*f**2*r + 2*Dd*b1*f*fd*(1 - 2*r) + bd1*f*(-2*D1*f*r + D1*fd*(r - 1) + 2*Dd*f*(2*r - 1)))/(21*d**2*k1*k3**2) - 8*D1**3*Pk3*Pkd2*ct**2*k2**5*(D1*bd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(12*C - 6)*(s - 1) - 14*g2*(s - 1)) + b1*(D1*s*(f*fd*(12*C - 6)*(2*r + 2*s - 1) - 14*f*gd2*(r + s - 1) - 7*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(12*C*f + 7*K*b1 - 6*f - 14*g2)))/(21*d**2*k3**6) + D1**3*Pk3*Pkd2*ct*f*k2**4*st**2*(8*C - 4)*(D1*b1*fd*s*(2*r - 1) + D1*bd1*f*r*(s - 1) + Dd*b1*f*(r*(4*s - 1) - 2*s))/(21*d**2*k1*k3**4) - D1**3*Pk3*Pkd2*ct*f*st**2*(8*C - 4)*(D1*b1*fd*(r*(2*s - 1) - s) + D1*bd1*f*r*s + Dd*b1*f*(r*(4*s - 1) - 2*s))/(21*d**2*k1) - 16*D1**3*Pk3*Pkd2*ct*k1*k2**4*(D1*bd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(12*C - 6)*(s - 1) - 14*g2*(s - 1)) + b1*(D1*s*(f*fd*(12*C - 6)*(2*r + 2*s - 1) - 14*f*gd2*(r + s - 1) - 7*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(12*C*f + 7*K*b1 - 6*f - 14*g2)))/(21*d**2*k3**6) - 8*D1**3*Pk3*Pkd2*k1**2*k2**3*(D1*bd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(12*C - 6)*(s - 1) - 14*g2*(s - 1)) + b1*(D1*s*(f*fd*(12*C - 6)*(2*r + 2*s - 1) - 14*f*gd2*(r + s - 1) - 7*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(12*C*f + 7*K*b1 - 6*f - 14*g2)))/(21*d**2*k3**6) + 4*D1**3*Pk3*Pkd2*k2**5*st**2*(-D1*bd1*f*(r + s - 1)*(7*K*b1*(1 - 2*s) + f*(2*C - 1)*(s - 1) + 14*g2*(s - 1)) + b1*(-D1*s*(f*fd*(2*C - 1)*(2*r + 2*s - 1) + 14*f*gd2*(r + s - 1) + 7*fd*(r + s)*(-K*b1 + 2*g2)) - Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-7*K*b1 + f*(2*C - 1) + 14*g2)))/(21*d**2*k3**6) - 4*D1**3*Pkd2*Pkd3*b1*f*k1**4*k2*(D1*b1*fd*s*(2*r + 2*s - 1) + D1*bd1*f*(2*s - 1)*(r + s - 1) + Dd*b1*f*(r*(4*s - 1) + (1 - 2*s)**2))/(7*d**2*k3**5) + 2*D1**3*Pkd2*Pkd3*b1*k2**3*(2*C - 1)*(D1*bd1*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + b1*(D1*fd*s*(r + s - 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)))/(3*d**2*k3**3) - 2*D1**3*Pkd2*Pkd3*b1*k2*(2*C - 1)*(D1*bd1*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + b1*(D1*fd*s*(r + s - 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)))/(3*d**2*k3) + 2*D1**3*Pkd2*Pkd3*ct**2*k2**5*(D1*bd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(12*C - 6)*(s - 1) - 14*g2*(s - 1)) + b1*(D1*s*(f*fd*(12*C - 6)*(2*r + 2*s - 1) - 14*f*gd2*(r + s - 1) - 7*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(12*C*f + 7*K*b1 - 6*f - 14*g2)))/(21*d**2*k3**5) + 4*D1**3*Pkd2*Pkd3*ct*k1*k2**4*(D1*bd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(12*C - 6)*(s - 1) - 14*g2*(s - 1)) + b1*(D1*s*(f*fd*(12*C - 6)*(2*r + 2*s - 1) - 14*f*gd2*(r + s - 1) - 7*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(12*C*f + 7*K*b1 - 6*f - 14*g2)))/(21*d**2*k3**5) + 2*D1**3*Pkd2*Pkd3*k1**2*k2**3*(D1*bd1*f*(r + s - 1)*(7*K*b1*(2*s - 1) + f*(12*C - 6)*(s - 1) - 14*g2*(s - 1)) + b1*(D1*s*(f*fd*(12*C - 6)*(2*r + 2*s - 1) - 14*f*gd2*(r + s - 1) - 7*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(12*C*f + 7*K*b1 - 6*f - 14*g2)))/(21*d**2*k3**5) - 2*D1**3*Pkd2*Pkd3*k1**2*k2*(D1*bd1*f*(s - 1)*(r + s - 1)*(12*C*f + 7*b2 - 6*f - 14*g2) + 7*b1**3*(D1*fd*s*(r + s - 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 7*b1**2*(D1*bd1*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + K*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + b1*(D1*(7*K*bd1*f*(2*s - 1)*(r + s - 1) + s*(7*bd2*f*(r + s - 1) + f*fd*(12*C - 6)*(2*r + 2*s - 1) - 14*f*gd2*(r + s - 1) - 14*fd*g2*(r + s))) + 2*Dd*f*(f*(6*C - 3) - 7*g2)*(r*(4*s - 1) + (1 - 2*s)**2) + 7*b2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))))/(21*d**2*k3**3) + D1**3*Pkd2*Pkd3*k2**5*st**2*(D1*bd1*f*(r + s - 1)*(7*K*b1*(1 - 2*s) + f*(2*C - 1)*(s - 1) + 14*g2*(s - 1)) + b1*(D1*s*(f*fd*(2*C - 1)*(2*r + 2*s - 1) + 14*f*gd2*(r + s - 1) + 7*fd*(r + s)*(-K*b1 + 2*g2)) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-7*K*b1 + f*(2*C - 1) + 14*g2)))/(21*d**2*k3**5) - 40*D1**2*Pk2*Pk3*ct**8*k1**2*k2**4*(4368*C*D1**2*f**2*fd*r**2 + 8736*C*D1**2*f**2*fd*r*s - 5824*C*D1**2*f**2*fd*r + 4368*C*D1**2*f**2*fd*s**2 - 5824*C*D1**2*f**2*fd*s + 2912*C*D1**2*f**2*fd - 2184*C*D1**2*f**2*fdd*r**2 - 4368*C*D1**2*f**2*fdd*r*s + 2912*C*D1**2*f**2*fdd*r - 2184*C*D1**2*f**2*fdd*s**2 + 2912*C*D1**2*f**2*fdd*s - 1456*C*D1**2*f**2*fdd - 4368*C*D1**2*f*fd**2*r**2 - 8736*C*D1**2*f*fd**2*r*s + 5824*C*D1**2*f*fd**2*r - 4368*C*D1**2*f*fd**2*s**2 + 5824*C*D1**2*f*fd**2*s - 1456*C*D1**2*f*fd**2 + 5824*C*D1*Dd*f**3*r**2 + 11648*C*D1*Dd*f**3*r*s - 8736*C*D1*Dd*f**3*r + 5824*C*D1*Dd*f**3*s**2 - 8736*C*D1*Dd*f**3*s + 4368*C*D1*Dd*f**3 - 17472*C*D1*Dd*f**2*fd*r**2 - 34944*C*D1*Dd*f**2*fd*r*s + 24752*C*D1*Dd*f**2*fd*r - 17472*C*D1*Dd*f**2*fd*s**2 + 24752*C*D1*Dd*f**2*fd*s - 8736*C*D1*Dd*f**2*fd - 2912*C*D1*Ddd*f**3*r**2 - 5824*C*D1*Ddd*f**3*r*s + 4368*C*D1*Ddd*f**3*r - 2912*C*D1*Ddd*f**3*s**2 + 4368*C*D1*Ddd*f**3*s - 2184*C*D1*Ddd*f**3 - 8736*C*Dd**2*f**3*r**2 - 17472*C*Dd**2*f**3*r*s + 13104*C*Dd**2*f**3*r - 8736*C*Dd**2*f**3*s**2 + 13104*C*Dd**2*f**3*s - 4368*C*Dd**2*f**3 + 1716*D1**2*K*b1*f*fd*r**2 + 3432*D1**2*K*b1*f*fd*r*s - 1716*D1**2*K*b1*f*fd*r + 1716*D1**2*K*b1*f*fd*s**2 - 1716*D1**2*K*b1*f*fd*s + 858*D1**2*K*b1*f*fd - 858*D1**2*K*b1*f*fdd*r**2 - 1716*D1**2*K*b1*f*fdd*r*s + 858*D1**2*K*b1*f*fdd*r - 858*D1**2*K*b1*f*fdd*s**2 + 858*D1**2*K*b1*f*fdd*s - 429*D1**2*K*b1*f*fdd - 858*D1**2*K*b1*fd**2*r**2 - 1716*D1**2*K*b1*fd**2*r*s + 858*D1**2*K*b1*fd**2*r - 858*D1**2*K*b1*fd**2*s**2 + 858*D1**2*K*b1*fd**2*s - 1716*D1**2*b1*f*fd*r**2 - 3432*D1**2*b1*f*fd*r*s + 1716*D1**2*b1*f*fd*r - 1716*D1**2*b1*f*fd*s**2 + 1716*D1**2*b1*f*fd*s - 858*D1**2*b1*f*fd + 858*D1**2*b1*f*fdd*r**2 + 1716*D1**2*b1*f*fdd*r*s - 858*D1**2*b1*f*fdd*r + 858*D1**2*b1*f*fdd*s**2 - 858*D1**2*b1*f*fdd*s + 429*D1**2*b1*f*fdd + 858*D1**2*b1*fd**2*r**2 + 1716*D1**2*b1*fd**2*r*s - 858*D1**2*b1*fd**2*r + 858*D1**2*b1*fd**2*s**2 - 858*D1**2*b1*fd**2*s - 429*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 2520*D1**2*f**3*fd*r**2 + 5040*D1**2*f**3*fd*r*s - 3780*D1**2*f**3*fd*r + 2520*D1**2*f**3*fd*s**2 - 3780*D1**2*f**3*fd*s + 1890*D1**2*f**3*fd - 1260*D1**2*f**3*fdd*r**2 - 2520*D1**2*f**3*fdd*r*s + 1890*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s**2 + 1890*D1**2*f**3*fdd*s - 945*D1**2*f**3*fdd - 3780*D1**2*f**2*fd**2*r**2 - 7560*D1**2*f**2*fd**2*r*s + 5670*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s**2 + 5670*D1**2*f**2*fd**2*s - 1890*D1**2*f**2*fd**2 - 4368*D1**2*f**2*fd*r**2 - 8736*D1**2*f**2*fd*r*s + 5824*D1**2*f**2*fd*r - 4368*D1**2*f**2*fd*s**2 + 5824*D1**2*f**2*fd*s - 2912*D1**2*f**2*fd + 2184*D1**2*f**2*fdd*r**2 + 4368*D1**2*f**2*fdd*r*s - 2912*D1**2*f**2*fdd*r + 2184*D1**2*f**2*fdd*s**2 - 2912*D1**2*f**2*fdd*s + 1456*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 858*D1**2*f**2*gdd2*r**2 + 1716*D1**2*f**2*gdd2*r*s - 1716*D1**2*f**2*gdd2*r + 858*D1**2*f**2*gdd2*s**2 - 1716*D1**2*f**2*gdd2*s + 858*D1**2*f**2*gdd2 + 4368*D1**2*f*fd**2*r**2 + 8736*D1**2*f*fd**2*r*s - 5824*D1**2*f*fd**2*r + 4368*D1**2*f*fd**2*s**2 - 5824*D1**2*f*fd**2*s + 1456*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r**2 + 6864*D1**2*f*fd*gd2*r*s - 5148*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1716*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r**2 + 3432*D1**2*f*fdd*g2*r*s - 1716*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r**2 + 3432*D1**2*fd**2*g2*r*s - 1716*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 3432*D1*Dd*K*b1*f**2*r**2 + 6864*D1*Dd*K*b1*f**2*r*s - 5148*D1*Dd*K*b1*f**2*r + 3432*D1*Dd*K*b1*f**2*s**2 - 5148*D1*Dd*K*b1*f**2*s + 2574*D1*Dd*K*b1*f**2 - 6864*D1*Dd*K*b1*f*fd*r**2 - 13728*D1*Dd*K*b1*f*fd*r*s + 8580*D1*Dd*K*b1*f*fd*r - 6864*D1*Dd*K*b1*f*fd*s**2 + 8580*D1*Dd*K*b1*f*fd*s - 2574*D1*Dd*K*b1*f*fd - 3432*D1*Dd*b1*f**2*r**2 - 6864*D1*Dd*b1*f**2*r*s + 5148*D1*Dd*b1*f**2*r - 3432*D1*Dd*b1*f**2*s**2 + 5148*D1*Dd*b1*f**2*s - 2574*D1*Dd*b1*f**2 + 6864*D1*Dd*b1*f*fd*r**2 + 13728*D1*Dd*b1*f*fd*r*s - 8580*D1*Dd*b1*f*fd*r + 6864*D1*Dd*b1*f*fd*s**2 - 8580*D1*Dd*b1*f*fd*s + 2574*D1*Dd*b1*f*fd + 2520*D1*Dd*f**4*r**2 + 5040*D1*Dd*f**4*r*s - 3780*D1*Dd*f**4*r + 2520*D1*Dd*f**4*s**2 - 3780*D1*Dd*f**4*s + 1890*D1*Dd*f**4 - 10080*D1*Dd*f**3*fd*r**2 - 20160*D1*Dd*f**3*fd*r*s + 15120*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s**2 + 15120*D1*Dd*f**3*fd*s - 5670*D1*Dd*f**3*fd - 5824*D1*Dd*f**3*r**2 - 11648*D1*Dd*f**3*r*s + 8736*D1*Dd*f**3*r - 5824*D1*Dd*f**3*s**2 + 8736*D1*Dd*f**3*s - 4368*D1*Dd*f**3 + 17472*D1*Dd*f**2*fd*r**2 + 34944*D1*Dd*f**2*fd*r*s - 24752*D1*Dd*f**2*fd*r + 17472*D1*Dd*f**2*fd*s**2 - 24752*D1*Dd*f**2*fd*s + 8736*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r**2 + 13728*D1*Dd*f**2*gd2*r*s - 12012*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 12012*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r**2 + 27456*D1*Dd*f*fd*g2*r*s - 17160*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 17160*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 - 1716*D1*Ddd*K*b1*f**2*r**2 - 3432*D1*Ddd*K*b1*f**2*r*s + 2574*D1*Ddd*K*b1*f**2*r - 1716*D1*Ddd*K*b1*f**2*s**2 + 2574*D1*Ddd*K*b1*f**2*s - 1287*D1*Ddd*K*b1*f**2 + 1716*D1*Ddd*b1*f**2*r**2 + 3432*D1*Ddd*b1*f**2*r*s - 2574*D1*Ddd*b1*f**2*r + 1716*D1*Ddd*b1*f**2*s**2 - 2574*D1*Ddd*b1*f**2*s + 1287*D1*Ddd*b1*f**2 - 1260*D1*Ddd*f**4*r**2 - 2520*D1*Ddd*f**4*r*s + 1890*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s**2 + 1890*D1*Ddd*f**4*s - 945*D1*Ddd*f**4 + 2912*D1*Ddd*f**3*r**2 + 5824*D1*Ddd*f**3*r*s - 4368*D1*Ddd*f**3*r + 2912*D1*Ddd*f**3*s**2 - 4368*D1*Ddd*f**3*s + 2184*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r**2 + 6864*D1*Ddd*f**2*g2*r*s - 5148*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 5148*Dd**2*K*b1*f**2*r**2 - 10296*Dd**2*K*b1*f**2*r*s + 7722*Dd**2*K*b1*f**2*r - 5148*Dd**2*K*b1*f**2*s**2 + 7722*Dd**2*K*b1*f**2*s - 2574*Dd**2*K*b1*f**2 + 5148*Dd**2*b1*f**2*r**2 + 10296*Dd**2*b1*f**2*r*s - 7722*Dd**2*b1*f**2*r + 5148*Dd**2*b1*f**2*s**2 - 7722*Dd**2*b1*f**2*s + 2574*Dd**2*b1*f**2 - 3780*Dd**2*f**4*r**2 - 7560*Dd**2*f**4*r*s + 5670*Dd**2*f**4*r - 3780*Dd**2*f**4*s**2 + 5670*Dd**2*f**4*s - 1890*Dd**2*f**4 + 8736*Dd**2*f**3*r**2 + 17472*Dd**2*f**3*r*s - 13104*Dd**2*f**3*r + 8736*Dd**2*f**3*s**2 - 13104*Dd**2*f**3*s + 4368*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r**2 + 20592*Dd**2*f**2*g2*r*s - 15444*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2)/(3003*d**2*k3**8) - 160*D1**2*Pk2*Pk3*ct**8*k1**2*k2**2*(4368*C*D1**2*f**2*fd*r*s - 1456*C*D1**2*f**2*fd*r + 4368*C*D1**2*f**2*fd*s**2 - 4368*C*D1**2*f**2*fd*s + 1456*C*D1**2*f**2*fd - 2184*C*D1**2*f**2*fdd*r*s + 728*C*D1**2*f**2*fdd*r - 2184*C*D1**2*f**2*fdd*s**2 + 2184*C*D1**2*f**2*fdd*s - 728*C*D1**2*f**2*fdd - 4368*C*D1**2*f*fd**2*r*s + 1456*C*D1**2*f*fd**2*r - 4368*C*D1**2*f*fd**2*s**2 + 4368*C*D1**2*f*fd**2*s - 728*C*D1**2*f*fd**2 + 5824*C*D1*Dd*f**3*r*s - 1456*C*D1*Dd*f**3*r + 5824*C*D1*Dd*f**3*s**2 - 5824*C*D1*Dd*f**3*s + 1456*C*D1*Dd*f**3 - 17472*C*D1*Dd*f**2*fd*r*s + 5096*C*D1*Dd*f**2*fd*r - 17472*C*D1*Dd*f**2*fd*s**2 + 17472*C*D1*Dd*f**2*fd*s - 3640*C*D1*Dd*f**2*fd - 2912*C*D1*Ddd*f**3*r*s + 728*C*D1*Ddd*f**3*r - 2912*C*D1*Ddd*f**3*s**2 + 2912*C*D1*Ddd*f**3*s - 728*C*D1*Ddd*f**3 - 8736*C*Dd**2*f**3*r*s + 2184*C*Dd**2*f**3*r - 8736*C*Dd**2*f**3*s**2 + 8736*C*Dd**2*f**3*s - 1456*C*Dd**2*f**3 - 429*D1**2*K*bdd1*f**2*r*s - 429*D1**2*K*bdd1*f**2*s**2 + 429*D1**2*K*bdd1*f**2*s + 429*D1**2*bdd1*f**2*r*s + 429*D1**2*bdd1*f**2*s**2 - 429*D1**2*bdd1*f**2*s + 2520*D1**2*f**3*fd*r*s - 630*D1**2*f**3*fd*r + 2520*D1**2*f**3*fd*s**2 - 2520*D1**2*f**3*fd*s + 630*D1**2*f**3*fd - 1260*D1**2*f**3*fdd*r*s + 315*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s**2 + 1260*D1**2*f**3*fdd*s - 315*D1**2*f**3*fdd - 3780*D1**2*f**2*fd**2*r*s + 945*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s**2 + 3780*D1**2*f**2*fd**2*s - 630*D1**2*f**2*fd**2 - 4368*D1**2*f**2*fd*r*s + 1456*D1**2*f**2*fd*r - 4368*D1**2*f**2*fd*s**2 + 4368*D1**2*f**2*fd*s - 1456*D1**2*f**2*fd + 2184*D1**2*f**2*fdd*r*s - 728*D1**2*f**2*fdd*r + 2184*D1**2*f**2*fdd*s**2 - 2184*D1**2*f**2*fdd*s + 728*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r*s - 1716*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s + 858*D1**2*f**2*gdd2*r*s + 858*D1**2*f**2*gdd2*s**2 - 858*D1**2*f**2*gdd2*s + 4368*D1**2*f*fd**2*r*s - 1456*D1**2*f*fd**2*r + 4368*D1**2*f*fd**2*s**2 - 4368*D1**2*f*fd**2*s + 728*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r*s - 858*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 3432*D1**2*f*fd*gd2*s + 858*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r*s - 858*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r*s - 858*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 2520*D1*Dd*f**4*r*s - 630*D1*Dd*f**4*r + 2520*D1*Dd*f**4*s**2 - 2520*D1*Dd*f**4*s + 630*D1*Dd*f**4 - 10080*D1*Dd*f**3*fd*r*s + 2520*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s**2 + 10080*D1*Dd*f**3*fd*s - 1890*D1*Dd*f**3*fd - 5824*D1*Dd*f**3*r*s + 1456*D1*Dd*f**3*r - 5824*D1*Dd*f**3*s**2 + 5824*D1*Dd*f**3*s - 1456*D1*Dd*f**3 + 17472*D1*Dd*f**2*fd*r*s - 5096*D1*Dd*f**2*fd*r + 17472*D1*Dd*f**2*fd*s**2 - 17472*D1*Dd*f**2*fd*s + 3640*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r*s + 1716*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 6864*D1*Dd*f**2*g2*s - 1716*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r*s - 858*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 6864*D1*Dd*f**2*gd2*s + 858*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r*s - 5148*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 13728*D1*Dd*f*fd*g2*s + 3432*D1*Dd*f*fd*g2 - 1260*D1*Ddd*f**4*r*s + 315*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s**2 + 1260*D1*Ddd*f**4*s - 315*D1*Ddd*f**4 + 2912*D1*Ddd*f**3*r*s - 728*D1*Ddd*f**3*r + 2912*D1*Ddd*f**3*s**2 - 2912*D1*Ddd*f**3*s + 728*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r*s - 858*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 3432*D1*Ddd*f**2*g2*s + 858*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 3780*Dd**2*f**4*r*s + 945*Dd**2*f**4*r - 3780*Dd**2*f**4*s**2 + 3780*Dd**2*f**4*s - 630*Dd**2*f**4 + 8736*Dd**2*f**3*r*s - 2184*Dd**2*f**3*r + 8736*Dd**2*f**3*s**2 - 8736*Dd**2*f**3*s + 1456*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r*s - 2574*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 10296*Dd**2*f**2*g2*s + 1716*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**6) - 40*D1**2*Pk2*Pk3*ct**8*k1**2*(D1**2*(315*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-1890*fd**2*s*(2*s - 1) + fd*(1456*C - 1456)*(3*s**2 - 2*s + 1) - fdd*(728*C - 728)*(3*s**2 - 2*s + 1) + s**2*(-429*K*bdd1 + 858*bd1*(K - 1) + 429*bdd1 - 1716*gd2 + 858*gdd2)) - 26*f*(fd**2*s*(56*C - 56)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 1716*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(315*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(104*C*(4*s**2 - 2*s + 1) - 45*fd*(1 - 4*s)**2 - 416*s**2 + 208*s - 104) - 13*f*(fd*(56*C - 56)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 858*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(315*f**2 + f*(728*C - 728) - 858*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(315*f**2 + f*(728*C - 728) - 858*g2) + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(3003*d**2*k3**4) - 8*D1**2*Pk2*Pk3*ct**7*k1**3*k2**3*(61620*C*D1**2*f**2*fd*r**2 + 123240*C*D1**2*f**2*fd*r*s - 82160*C*D1**2*f**2*fd*r + 61620*C*D1**2*f**2*fd*s**2 - 82160*C*D1**2*f**2*fd*s + 41080*C*D1**2*f**2*fd - 43680*C*D1**2*f**2*fdd*r**2 - 87360*C*D1**2*f**2*fdd*r*s + 58240*C*D1**2*f**2*fdd*r - 43680*C*D1**2*f**2*fdd*s**2 + 58240*C*D1**2*f**2*fdd*s - 29120*C*D1**2*f**2*fdd - 87360*C*D1**2*f*fd**2*r**2 - 174720*C*D1**2*f*fd**2*r*s + 116480*C*D1**2*f*fd**2*r - 87360*C*D1**2*f*fd**2*s**2 + 116480*C*D1**2*f*fd**2*s - 29120*C*D1**2*f*fd**2 + 82160*C*D1*Dd*f**3*r**2 + 164320*C*D1*Dd*f**3*r*s - 123240*C*D1*Dd*f**3*r + 82160*C*D1*Dd*f**3*s**2 - 123240*C*D1*Dd*f**3*s + 61620*C*D1*Dd*f**3 - 349440*C*D1*Dd*f**2*fd*r**2 - 698880*C*D1*Dd*f**2*fd*r*s + 495040*C*D1*Dd*f**2*fd*r - 349440*C*D1*Dd*f**2*fd*s**2 + 495040*C*D1*Dd*f**2*fd*s - 174720*C*D1*Dd*f**2*fd - 58240*C*D1*Ddd*f**3*r**2 - 116480*C*D1*Ddd*f**3*r*s + 87360*C*D1*Ddd*f**3*r - 58240*C*D1*Ddd*f**3*s**2 + 87360*C*D1*Ddd*f**3*s - 43680*C*D1*Ddd*f**3 - 174720*C*Dd**2*f**3*r**2 - 349440*C*Dd**2*f**3*r*s + 262080*C*Dd**2*f**3*r - 174720*C*Dd**2*f**3*s**2 + 262080*C*Dd**2*f**3*s - 87360*C*Dd**2*f**3 + 24024*D1**2*K*b1*f*fd*r**2 + 48048*D1**2*K*b1*f*fd*r*s - 24024*D1**2*K*b1*f*fd*r + 24024*D1**2*K*b1*f*fd*s**2 - 24024*D1**2*K*b1*f*fd*s + 12012*D1**2*K*b1*f*fd - 17160*D1**2*K*b1*f*fdd*r**2 - 34320*D1**2*K*b1*f*fdd*r*s + 17160*D1**2*K*b1*f*fdd*r - 17160*D1**2*K*b1*f*fdd*s**2 + 17160*D1**2*K*b1*f*fdd*s - 8580*D1**2*K*b1*f*fdd - 17160*D1**2*K*b1*fd**2*r**2 - 34320*D1**2*K*b1*fd**2*r*s + 17160*D1**2*K*b1*fd**2*r - 17160*D1**2*K*b1*fd**2*s**2 + 17160*D1**2*K*b1*fd**2*s - 24024*D1**2*b1*f*fd*r**2 - 48048*D1**2*b1*f*fd*r*s + 24024*D1**2*b1*f*fd*r - 24024*D1**2*b1*f*fd*s**2 + 24024*D1**2*b1*f*fd*s - 12012*D1**2*b1*f*fd + 17160*D1**2*b1*f*fdd*r**2 + 34320*D1**2*b1*f*fdd*r*s - 17160*D1**2*b1*f*fdd*r + 17160*D1**2*b1*f*fdd*s**2 - 17160*D1**2*b1*f*fdd*s + 8580*D1**2*b1*f*fdd + 17160*D1**2*b1*fd**2*r**2 + 34320*D1**2*b1*fd**2*r*s - 17160*D1**2*b1*fd**2*r + 17160*D1**2*b1*fd**2*s**2 - 17160*D1**2*b1*fd**2*s - 8580*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 48440*D1**2*f**3*fd*r**2 + 96880*D1**2*f**3*fd*r*s - 72660*D1**2*f**3*fd*r + 48440*D1**2*f**3*fd*s**2 - 72660*D1**2*f**3*fd*s + 36330*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 - 61620*D1**2*f**2*fd*r**2 - 123240*D1**2*f**2*fd*r*s + 82160*D1**2*f**2*fd*r - 61620*D1**2*f**2*fd*s**2 + 82160*D1**2*f**2*fd*s - 41080*D1**2*f**2*fd + 43680*D1**2*f**2*fdd*r**2 + 87360*D1**2*f**2*fdd*r*s - 58240*D1**2*f**2*fdd*r + 43680*D1**2*f**2*fdd*s**2 - 58240*D1**2*f**2*fdd*s + 29120*D1**2*f**2*fdd - 24024*D1**2*f**2*gd2*r**2 - 48048*D1**2*f**2*gd2*r*s + 48048*D1**2*f**2*gd2*r - 24024*D1**2*f**2*gd2*s**2 + 48048*D1**2*f**2*gd2*s - 24024*D1**2*f**2*gd2 + 17160*D1**2*f**2*gdd2*r**2 + 34320*D1**2*f**2*gdd2*r*s - 34320*D1**2*f**2*gdd2*r + 17160*D1**2*f**2*gdd2*s**2 - 34320*D1**2*f**2*gdd2*s + 17160*D1**2*f**2*gdd2 + 87360*D1**2*f*fd**2*r**2 + 174720*D1**2*f*fd**2*r*s - 116480*D1**2*f*fd**2*r + 87360*D1**2*f*fd**2*s**2 - 116480*D1**2*f*fd**2*s + 29120*D1**2*f*fd**2 - 48048*D1**2*f*fd*g2*r**2 - 96096*D1**2*f*fd*g2*r*s + 48048*D1**2*f*fd*g2*r - 48048*D1**2*f*fd*g2*s**2 + 48048*D1**2*f*fd*g2*s - 24024*D1**2*f*fd*g2 + 68640*D1**2*f*fd*gd2*r**2 + 137280*D1**2*f*fd*gd2*r*s - 102960*D1**2*f*fd*gd2*r + 68640*D1**2*f*fd*gd2*s**2 - 102960*D1**2*f*fd*gd2*s + 34320*D1**2*f*fd*gd2 + 34320*D1**2*f*fdd*g2*r**2 + 68640*D1**2*f*fdd*g2*r*s - 34320*D1**2*f*fdd*g2*r + 34320*D1**2*f*fdd*g2*s**2 - 34320*D1**2*f*fdd*g2*s + 17160*D1**2*f*fdd*g2 + 34320*D1**2*fd**2*g2*r**2 + 68640*D1**2*fd**2*g2*r*s - 34320*D1**2*fd**2*g2*r + 34320*D1**2*fd**2*g2*s**2 - 34320*D1**2*fd**2*g2*s + 48048*D1*Dd*K*b1*f**2*r**2 + 96096*D1*Dd*K*b1*f**2*r*s - 72072*D1*Dd*K*b1*f**2*r + 48048*D1*Dd*K*b1*f**2*s**2 - 72072*D1*Dd*K*b1*f**2*s + 36036*D1*Dd*K*b1*f**2 - 137280*D1*Dd*K*b1*f*fd*r**2 - 274560*D1*Dd*K*b1*f*fd*r*s + 171600*D1*Dd*K*b1*f*fd*r - 137280*D1*Dd*K*b1*f*fd*s**2 + 171600*D1*Dd*K*b1*f*fd*s - 51480*D1*Dd*K*b1*f*fd - 48048*D1*Dd*b1*f**2*r**2 - 96096*D1*Dd*b1*f**2*r*s + 72072*D1*Dd*b1*f**2*r - 48048*D1*Dd*b1*f**2*s**2 + 72072*D1*Dd*b1*f**2*s - 36036*D1*Dd*b1*f**2 + 137280*D1*Dd*b1*f*fd*r**2 + 274560*D1*Dd*b1*f*fd*r*s - 171600*D1*Dd*b1*f*fd*r + 137280*D1*Dd*b1*f*fd*s**2 - 171600*D1*Dd*b1*f*fd*s + 51480*D1*Dd*b1*f*fd + 48440*D1*Dd*f**4*r**2 + 96880*D1*Dd*f**4*r*s - 72660*D1*Dd*f**4*r + 48440*D1*Dd*f**4*s**2 - 72660*D1*Dd*f**4*s + 36330*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd - 82160*D1*Dd*f**3*r**2 - 164320*D1*Dd*f**3*r*s + 123240*D1*Dd*f**3*r - 82160*D1*Dd*f**3*s**2 + 123240*D1*Dd*f**3*s - 61620*D1*Dd*f**3 + 349440*D1*Dd*f**2*fd*r**2 + 698880*D1*Dd*f**2*fd*r*s - 495040*D1*Dd*f**2*fd*r + 349440*D1*Dd*f**2*fd*s**2 - 495040*D1*Dd*f**2*fd*s + 174720*D1*Dd*f**2*fd - 96096*D1*Dd*f**2*g2*r**2 - 192192*D1*Dd*f**2*g2*r*s + 144144*D1*Dd*f**2*g2*r - 96096*D1*Dd*f**2*g2*s**2 + 144144*D1*Dd*f**2*g2*s - 72072*D1*Dd*f**2*g2 + 137280*D1*Dd*f**2*gd2*r**2 + 274560*D1*Dd*f**2*gd2*r*s - 240240*D1*Dd*f**2*gd2*r + 137280*D1*Dd*f**2*gd2*s**2 - 240240*D1*Dd*f**2*gd2*s + 102960*D1*Dd*f**2*gd2 + 274560*D1*Dd*f*fd*g2*r**2 + 549120*D1*Dd*f*fd*g2*r*s - 343200*D1*Dd*f*fd*g2*r + 274560*D1*Dd*f*fd*g2*s**2 - 343200*D1*Dd*f*fd*g2*s + 102960*D1*Dd*f*fd*g2 - 34320*D1*Ddd*K*b1*f**2*r**2 - 68640*D1*Ddd*K*b1*f**2*r*s + 51480*D1*Ddd*K*b1*f**2*r - 34320*D1*Ddd*K*b1*f**2*s**2 + 51480*D1*Ddd*K*b1*f**2*s - 25740*D1*Ddd*K*b1*f**2 + 34320*D1*Ddd*b1*f**2*r**2 + 68640*D1*Ddd*b1*f**2*r*s - 51480*D1*Ddd*b1*f**2*r + 34320*D1*Ddd*b1*f**2*s**2 - 51480*D1*Ddd*b1*f**2*s + 25740*D1*Ddd*b1*f**2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 58240*D1*Ddd*f**3*r**2 + 116480*D1*Ddd*f**3*r*s - 87360*D1*Ddd*f**3*r + 58240*D1*Ddd*f**3*s**2 - 87360*D1*Ddd*f**3*s + 43680*D1*Ddd*f**3 + 68640*D1*Ddd*f**2*g2*r**2 + 137280*D1*Ddd*f**2*g2*r*s - 102960*D1*Ddd*f**2*g2*r + 68640*D1*Ddd*f**2*g2*s**2 - 102960*D1*Ddd*f**2*g2*s + 51480*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 102960*Dd**2*K*b1*f**2*r**2 - 205920*Dd**2*K*b1*f**2*r*s + 154440*Dd**2*K*b1*f**2*r - 102960*Dd**2*K*b1*f**2*s**2 + 154440*Dd**2*K*b1*f**2*s - 51480*Dd**2*K*b1*f**2 + 102960*Dd**2*b1*f**2*r**2 + 205920*Dd**2*b1*f**2*r*s - 154440*Dd**2*b1*f**2*r + 102960*Dd**2*b1*f**2*s**2 - 154440*Dd**2*b1*f**2*s + 51480*Dd**2*b1*f**2 - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 174720*Dd**2*f**3*r**2 + 349440*Dd**2*f**3*r*s - 262080*Dd**2*f**3*r + 174720*Dd**2*f**3*s**2 - 262080*Dd**2*f**3*s + 87360*Dd**2*f**3 + 205920*Dd**2*f**2*g2*r**2 + 411840*Dd**2*f**2*g2*r*s - 308880*Dd**2*f**2*g2*r + 205920*Dd**2*f**2*g2*s**2 - 308880*Dd**2*f**2*g2*s + 102960*Dd**2*f**2*g2)/(3003*d**2*k3**8) - 32*D1**2*Pk2*Pk3*ct**7*k1**3*k2*(52650*C*D1**2*f**2*fd*r*s - 17550*C*D1**2*f**2*fd*r + 52650*C*D1**2*f**2*fd*s**2 - 52650*C*D1**2*f**2*fd*s + 17550*C*D1**2*f**2*fd - 32760*C*D1**2*f**2*fdd*r*s + 10920*C*D1**2*f**2*fdd*r - 32760*C*D1**2*f**2*fdd*s**2 + 32760*C*D1**2*f**2*fdd*s - 10920*C*D1**2*f**2*fdd - 65520*C*D1**2*f*fd**2*r*s + 21840*C*D1**2*f*fd**2*r - 65520*C*D1**2*f*fd**2*s**2 + 65520*C*D1**2*f*fd**2*s - 10920*C*D1**2*f*fd**2 + 70200*C*D1*Dd*f**3*r*s - 17550*C*D1*Dd*f**3*r + 70200*C*D1*Dd*f**3*s**2 - 70200*C*D1*Dd*f**3*s + 17550*C*D1*Dd*f**3 - 262080*C*D1*Dd*f**2*fd*r*s + 76440*C*D1*Dd*f**2*fd*r - 262080*C*D1*Dd*f**2*fd*s**2 + 262080*C*D1*Dd*f**2*fd*s - 54600*C*D1*Dd*f**2*fd - 43680*C*D1*Ddd*f**3*r*s + 10920*C*D1*Ddd*f**3*r - 43680*C*D1*Ddd*f**3*s**2 + 43680*C*D1*Ddd*f**3*s - 10920*C*D1*Ddd*f**3 - 131040*C*Dd**2*f**3*r*s + 32760*C*Dd**2*f**3*r - 131040*C*Dd**2*f**3*s**2 + 131040*C*Dd**2*f**3*s - 21840*C*Dd**2*f**3 - 6435*D1**2*K*bdd1*f**2*r*s - 6435*D1**2*K*bdd1*f**2*s**2 + 6435*D1**2*K*bdd1*f**2*s + 6435*D1**2*bdd1*f**2*r*s + 6435*D1**2*bdd1*f**2*s**2 - 6435*D1**2*bdd1*f**2*s + 43120*D1**2*f**3*fd*r*s - 10780*D1**2*f**3*fd*r + 43120*D1**2*f**3*fd*s**2 - 43120*D1**2*f**3*fd*s + 10780*D1**2*f**3*fd - 25200*D1**2*f**3*fdd*r*s + 6300*D1**2*f**3*fdd*r - 25200*D1**2*f**3*fdd*s**2 + 25200*D1**2*f**3*fdd*s - 6300*D1**2*f**3*fdd - 75600*D1**2*f**2*fd**2*r*s + 18900*D1**2*f**2*fd**2*r - 75600*D1**2*f**2*fd**2*s**2 + 75600*D1**2*f**2*fd**2*s - 12600*D1**2*f**2*fd**2 - 52650*D1**2*f**2*fd*r*s + 17550*D1**2*f**2*fd*r - 52650*D1**2*f**2*fd*s**2 + 52650*D1**2*f**2*fd*s - 17550*D1**2*f**2*fd + 32760*D1**2*f**2*fdd*r*s - 10920*D1**2*f**2*fdd*r + 32760*D1**2*f**2*fdd*s**2 - 32760*D1**2*f**2*fdd*s + 10920*D1**2*f**2*fdd - 20592*D1**2*f**2*gd2*r*s - 20592*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s + 12870*D1**2*f**2*gdd2*r*s + 12870*D1**2*f**2*gdd2*s**2 - 12870*D1**2*f**2*gdd2*s + 65520*D1**2*f*fd**2*r*s - 21840*D1**2*f*fd**2*r + 65520*D1**2*f*fd**2*s**2 - 65520*D1**2*f*fd**2*s + 10920*D1**2*f*fd**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 41184*D1**2*f*fd*g2*s**2 + 41184*D1**2*f*fd*g2*s - 20592*D1**2*f*fd*g2 + 51480*D1**2*f*fd*gd2*r*s - 12870*D1**2*f*fd*gd2*r + 51480*D1**2*f*fd*gd2*s**2 - 51480*D1**2*f*fd*gd2*s + 12870*D1**2*f*fd*gd2 + 25740*D1**2*f*fdd*g2*r*s - 12870*D1**2*f*fdd*g2*r + 25740*D1**2*f*fdd*g2*s**2 - 25740*D1**2*f*fdd*g2*s + 12870*D1**2*f*fdd*g2 + 25740*D1**2*fd**2*g2*r*s - 12870*D1**2*fd**2*g2*r + 25740*D1**2*fd**2*g2*s**2 - 25740*D1**2*fd**2*g2*s + 43120*D1*Dd*f**4*r*s - 10780*D1*Dd*f**4*r + 43120*D1*Dd*f**4*s**2 - 43120*D1*Dd*f**4*s + 10780*D1*Dd*f**4 - 201600*D1*Dd*f**3*fd*r*s + 50400*D1*Dd*f**3*fd*r - 201600*D1*Dd*f**3*fd*s**2 + 201600*D1*Dd*f**3*fd*s - 37800*D1*Dd*f**3*fd - 70200*D1*Dd*f**3*r*s + 17550*D1*Dd*f**3*r - 70200*D1*Dd*f**3*s**2 + 70200*D1*Dd*f**3*s - 17550*D1*Dd*f**3 + 262080*D1*Dd*f**2*fd*r*s - 76440*D1*Dd*f**2*fd*r + 262080*D1*Dd*f**2*fd*s**2 - 262080*D1*Dd*f**2*fd*s + 54600*D1*Dd*f**2*fd - 82368*D1*Dd*f**2*g2*r*s + 20592*D1*Dd*f**2*g2*r - 82368*D1*Dd*f**2*g2*s**2 + 82368*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*g2 + 102960*D1*Dd*f**2*gd2*r*s - 12870*D1*Dd*f**2*gd2*r + 102960*D1*Dd*f**2*gd2*s**2 - 102960*D1*Dd*f**2*gd2*s + 12870*D1*Dd*f**2*gd2 + 205920*D1*Dd*f*fd*g2*r*s - 77220*D1*Dd*f*fd*g2*r + 205920*D1*Dd*f*fd*g2*s**2 - 205920*D1*Dd*f*fd*g2*s + 51480*D1*Dd*f*fd*g2 - 25200*D1*Ddd*f**4*r*s + 6300*D1*Ddd*f**4*r - 25200*D1*Ddd*f**4*s**2 + 25200*D1*Ddd*f**4*s - 6300*D1*Ddd*f**4 + 43680*D1*Ddd*f**3*r*s - 10920*D1*Ddd*f**3*r + 43680*D1*Ddd*f**3*s**2 - 43680*D1*Ddd*f**3*s + 10920*D1*Ddd*f**3 + 51480*D1*Ddd*f**2*g2*r*s - 12870*D1*Ddd*f**2*g2*r + 51480*D1*Ddd*f**2*g2*s**2 - 51480*D1*Ddd*f**2*g2*s + 12870*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(D1*(8*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 75600*Dd**2*f**4*r*s + 18900*Dd**2*f**4*r - 75600*Dd**2*f**4*s**2 + 75600*Dd**2*f**4*s - 12600*Dd**2*f**4 + 131040*Dd**2*f**3*r*s - 32760*Dd**2*f**3*r + 131040*Dd**2*f**3*s**2 - 131040*Dd**2*f**3*s + 21840*Dd**2*f**3 + 154440*Dd**2*f**2*g2*r*s - 38610*Dd**2*f**2*g2*r + 154440*Dd**2*f**2*g2*s**2 - 154440*Dd**2*f**2*g2*s + 25740*Dd**2*f**2*g2 + 1287*b1*(K - 1)*(D1**2*(f*(8*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k3**6) - 40*D1**2*Pk2*Pk3*ct**7*k1**3*(D1**2*(945*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(2835*fd**2*s*(2*s - 1) - fd*(1456*C - 1456)*(3*s**2 - 2*s + 1) + fdd*(728*C - 728)*(3*s**2 - 2*s + 1) + s**2*(429*K*bdd1 - 858*bd1*(K - 1) - 429*bdd1 + 1716*gd2 - 858*gdd2)) - 52*f*(fd**2*s*(56*C - 56)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 3432*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(945*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(208*C*(4*s**2 - 2*s + 1) - 135*fd*(1 - 4*s)**2 - 832*s**2 + 416*s - 208) - 26*f*(fd*(56*C - 56)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 1716*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(945*f**2 + f*(1456*C - 1456) - 1716*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(945*f**2 + f*(1456*C - 1456) - 1716*g2) + 858*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(3003*d**2*k2*k3**4) + 40*D1**2*Pk2*Pk3*ct**7*k1*k2**5*(-672*C*D1**2*f**2*fd*r**2 - 1344*C*D1**2*f**2*fd*r*s + 896*C*D1**2*f**2*fd*r - 672*C*D1**2*f**2*fd*s**2 + 896*C*D1**2*f**2*fd*s - 448*C*D1**2*f**2*fd + 336*C*D1**2*f**2*fdd*r**2 + 672*C*D1**2*f**2*fdd*r*s - 448*C*D1**2*f**2*fdd*r + 336*C*D1**2*f**2*fdd*s**2 - 448*C*D1**2*f**2*fdd*s + 224*C*D1**2*f**2*fdd + 672*C*D1**2*f*fd**2*r**2 + 1344*C*D1**2*f*fd**2*r*s - 896*C*D1**2*f*fd**2*r + 672*C*D1**2*f*fd**2*s**2 - 896*C*D1**2*f*fd**2*s + 224*C*D1**2*f*fd**2 - 896*C*D1*Dd*f**3*r**2 - 1792*C*D1*Dd*f**3*r*s + 1344*C*D1*Dd*f**3*r - 896*C*D1*Dd*f**3*s**2 + 1344*C*D1*Dd*f**3*s - 672*C*D1*Dd*f**3 + 2688*C*D1*Dd*f**2*fd*r**2 + 5376*C*D1*Dd*f**2*fd*r*s - 3808*C*D1*Dd*f**2*fd*r + 2688*C*D1*Dd*f**2*fd*s**2 - 3808*C*D1*Dd*f**2*fd*s + 1344*C*D1*Dd*f**2*fd + 448*C*D1*Ddd*f**3*r**2 + 896*C*D1*Ddd*f**3*r*s - 672*C*D1*Ddd*f**3*r + 448*C*D1*Ddd*f**3*s**2 - 672*C*D1*Ddd*f**3*s + 336*C*D1*Ddd*f**3 + 1344*C*Dd**2*f**3*r**2 + 2688*C*Dd**2*f**3*r*s - 2016*C*Dd**2*f**3*r + 1344*C*Dd**2*f**3*s**2 - 2016*C*Dd**2*f**3*s + 672*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r**2 - 528*D1**2*K*b1*f*fd*r*s + 264*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 132*D1**2*K*b1*f*fdd*s**2 - 132*D1**2*K*b1*f*fdd*s + 66*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 132*D1**2*K*b1*fd**2*s**2 - 132*D1**2*K*b1*fd**2*s + 168*D1**2*b1*f**2*fd*r**2 + 336*D1**2*b1*f**2*fd*r*s - 224*D1**2*b1*f**2*fd*r + 168*D1**2*b1*f**2*fd*s**2 - 224*D1**2*b1*f**2*fd*s + 112*D1**2*b1*f**2*fd - 84*D1**2*b1*f**2*fdd*r**2 - 168*D1**2*b1*f**2*fdd*r*s + 112*D1**2*b1*f**2*fdd*r - 84*D1**2*b1*f**2*fdd*s**2 + 112*D1**2*b1*f**2*fdd*s - 56*D1**2*b1*f**2*fdd - 168*D1**2*b1*f*fd**2*r**2 - 336*D1**2*b1*f*fd**2*r*s + 224*D1**2*b1*f*fd**2*r - 168*D1**2*b1*f*fd**2*s**2 + 224*D1**2*b1*f*fd**2*s - 56*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-66*K + 28*f + 33)*(r + s - 1)**2 + 504*D1**2*f**2*fd*r**2 + 1008*D1**2*f**2*fd*r*s - 672*D1**2*f**2*fd*r + 504*D1**2*f**2*fd*s**2 - 672*D1**2*f**2*fd*s + 336*D1**2*f**2*fd - 252*D1**2*f**2*fdd*r**2 - 504*D1**2*f**2*fdd*r*s + 336*D1**2*f**2*fdd*r - 252*D1**2*f**2*fdd*s**2 + 336*D1**2*f**2*fdd*s - 168*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 504*D1**2*f*fd**2*r**2 - 1008*D1**2*f*fd**2*r*s + 672*D1**2*f*fd**2*r - 504*D1**2*f*fd**2*s**2 + 672*D1**2*f*fd**2*s - 168*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 - 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 792*D1*Dd*K*b1*f**2*s - 396*D1*Dd*K*b1*f**2 + 1056*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1320*D1*Dd*K*b1*f*fd*r + 1056*D1*Dd*K*b1*f*fd*s**2 - 1320*D1*Dd*K*b1*f*fd*s + 396*D1*Dd*K*b1*f*fd + 224*D1*Dd*b1*f**3*r**2 + 448*D1*Dd*b1*f**3*r*s - 336*D1*Dd*b1*f**3*r + 224*D1*Dd*b1*f**3*s**2 - 336*D1*Dd*b1*f**3*s + 168*D1*Dd*b1*f**3 - 672*D1*Dd*b1*f**2*fd*r**2 - 1344*D1*Dd*b1*f**2*fd*r*s + 952*D1*Dd*b1*f**2*fd*r - 672*D1*Dd*b1*f**2*fd*s**2 + 952*D1*Dd*b1*f**2*fd*s - 336*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 672*D1*Dd*f**3*r**2 + 1344*D1*Dd*f**3*r*s - 1008*D1*Dd*f**3*r + 672*D1*Dd*f**3*s**2 - 1008*D1*Dd*f**3*s + 504*D1*Dd*f**3 - 2016*D1*Dd*f**2*fd*r**2 - 4032*D1*Dd*f**2*fd*r*s + 2856*D1*Dd*f**2*fd*r - 2016*D1*Dd*f**2*fd*s**2 + 2856*D1*Dd*f**2*fd*s - 1008*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r + 264*D1*Ddd*K*b1*f**2*s**2 - 396*D1*Ddd*K*b1*f**2*s + 198*D1*Ddd*K*b1*f**2 - 112*D1*Ddd*b1*f**3*r**2 - 224*D1*Ddd*b1*f**3*r*s + 168*D1*Ddd*b1*f**3*r - 112*D1*Ddd*b1*f**3*s**2 + 168*D1*Ddd*b1*f**3*s - 84*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 336*D1*Ddd*f**3*r**2 - 672*D1*Ddd*f**3*r*s + 504*D1*Ddd*f**3*r - 336*D1*Ddd*f**3*s**2 + 504*D1*Ddd*f**3*s - 252*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(28*f**2*(r + s - 1) - 28*f*fd*(3*r + 3*s - 2) - 33*f*(2*K - 1)*(r + s - 1) + 33*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-66*K + 28*f + 33)*(4*r + 4*s - 3))*(r + s - 1) + 792*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r + 792*Dd**2*K*b1*f**2*s**2 - 1188*Dd**2*K*b1*f**2*s + 396*Dd**2*K*b1*f**2 - 336*Dd**2*b1*f**3*r**2 - 672*Dd**2*b1*f**3*r*s + 504*Dd**2*b1*f**3*r - 336*Dd**2*b1*f**3*s**2 + 504*Dd**2*b1*f**3*s - 168*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 1008*Dd**2*f**3*r**2 - 2016*Dd**2*f**3*r*s + 1512*Dd**2*f**3*r - 1008*Dd**2*f**3*s**2 + 1512*Dd**2*f**3*s - 504*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2)/(231*d**2*k3**8) - 40*D1**2*Pk2*Pk3*ct**7*k1*k2**3*(-792*C*D1**2*f**2*fd*r**2 + 552*C*D1**2*f**2*fd*r*s + 344*C*D1**2*f**2*fd*r + 1344*C*D1**2*f**2*fd*s**2 - 1080*C*D1**2*f**2*fd*s + 184*C*D1**2*f**2*fd + 396*C*D1**2*f**2*fdd*r**2 - 276*C*D1**2*f**2*fdd*r*s - 172*C*D1**2*f**2*fdd*r - 672*C*D1**2*f**2*fdd*s**2 + 540*C*D1**2*f**2*fdd*s - 92*C*D1**2*f**2*fdd + 792*C*D1**2*f*fd**2*r**2 - 552*C*D1**2*f*fd**2*r*s - 344*C*D1**2*f*fd**2*r - 1344*C*D1**2*f*fd**2*s**2 + 1080*C*D1**2*f*fd**2*s - 92*C*D1**2*f*fd**2 - 1056*C*D1*Dd*f**3*r**2 + 736*C*D1*Dd*f**3*r*s + 872*C*D1*Dd*f**3*r + 1792*C*D1*Dd*f**3*s**2 - 1264*C*D1*Dd*f**3*s - 80*C*D1*Dd*f**3 + 3168*C*D1*Dd*f**2*fd*r**2 - 2208*C*D1*Dd*f**2*fd*r*s - 1996*C*D1*Dd*f**2*fd*r - 5376*C*D1*Dd*f**2*fd*s**2 + 4056*C*D1*Dd*f**2*fd*s - 196*C*D1*Dd*f**2*fd + 528*C*D1*Ddd*f**3*r**2 - 368*C*D1*Ddd*f**3*r*s - 436*C*D1*Ddd*f**3*r - 896*C*D1*Ddd*f**3*s**2 + 632*C*D1*Ddd*f**3*s + 40*C*D1*Ddd*f**3 + 1584*C*Dd**2*f**3*r**2 - 1104*C*Dd**2*f**3*r*s - 1308*C*Dd**2*f**3*r - 2688*C*Dd**2*f**3*s**2 + 1896*C*Dd**2*f**3*s + 80*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r**2 + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r + 528*D1**2*K*b1*f*fd*s**2 - 528*D1**2*K*b1*f*fd*s + 264*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 - 132*D1**2*K*b1*f*fdd*r*s + 66*D1**2*K*b1*f*fdd*r - 264*D1**2*K*b1*f*fdd*s**2 + 264*D1**2*K*b1*f*fdd*s - 132*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 - 132*D1**2*K*b1*fd**2*r*s + 66*D1**2*K*b1*fd**2*r - 264*D1**2*K*b1*fd**2*s**2 + 264*D1**2*K*b1*fd**2*s + 168*D1**2*b1*f**2*fd*r**2 - 112*D1**2*b1*f**2*fd*r - 168*D1**2*b1*f**2*fd*s**2 + 112*D1**2*b1*f**2*fd*s - 84*D1**2*b1*f**2*fdd*r**2 + 56*D1**2*b1*f**2*fdd*r + 84*D1**2*b1*f**2*fdd*s**2 - 56*D1**2*b1*f**2*fdd*s - 168*D1**2*b1*f*fd**2*r**2 + 112*D1**2*b1*f*fd**2*r + 168*D1**2*b1*f*fd**2*s**2 - 112*D1**2*b1*f*fd**2*s + 396*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 132*D1**2*b1*f*fd*s**2 + 132*D1**2*b1*f*fd*s - 66*D1**2*b1*f*fd - 198*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s**2 - 66*D1**2*b1*f*fdd*s + 33*D1**2*b1*f*fdd - 198*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(r + s - 1)*(-66*K*(r - 2*s - 1) + 28*f*(r - s - 1) + 99*r - 33*s - 99) - 224*D1**2*f**3*fd*r**2 - 224*D1**2*f**3*fd*r*s + 280*D1**2*f**3*fd*r + 112*D1**2*f**3*fd*s - 112*D1**2*f**3*fd + 224*D1**2*f**3*fdd*r**2 + 224*D1**2*f**3*fdd*r*s - 280*D1**2*f**3*fdd*r - 112*D1**2*f**3*fdd*s + 112*D1**2*f**3*fdd + 672*D1**2*f**2*fd**2*r**2 + 672*D1**2*f**2*fd**2*r*s - 840*D1**2*f**2*fd**2*r - 336*D1**2*f**2*fd**2*s + 224*D1**2*f**2*fd**2 + 960*D1**2*f**2*fd*r**2 + 120*D1**2*f**2*fd*r*s - 680*D1**2*f**2*fd*r - 840*D1**2*f**2*fd*s**2 + 520*D1**2*f**2*fd*s + 40*D1**2*f**2*fd - 480*D1**2*f**2*fdd*r**2 - 60*D1**2*f**2*fdd*r*s + 340*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 260*D1**2*f**2*fdd*s - 20*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r - 528*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 + 132*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r + 264*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 960*D1**2*f*fd**2*r**2 - 120*D1**2*f*fd**2*r*s + 680*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 520*D1**2*f*fd**2*s - 20*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 + 528*D1**2*f*fd*gd2*r*s + 396*D1**2*f*fd*gd2*r + 1056*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 528*D1**2*f*fdd*g2*s**2 - 528*D1**2*f*fdd*g2*s + 264*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 528*D1**2*fd**2*g2*s**2 - 528*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 + 528*D1*Dd*K*b1*f**2*r*s + 396*D1*Dd*K*b1*f**2*r + 1056*D1*Dd*K*b1*f**2*s**2 - 792*D1*Dd*K*b1*f**2*s + 1056*D1*Dd*K*b1*f*fd*r**2 - 1056*D1*Dd*K*b1*f*fd*r*s - 132*D1*Dd*K*b1*f*fd*r - 2112*D1*Dd*K*b1*f*fd*s**2 + 1848*D1*Dd*K*b1*f*fd*s - 396*D1*Dd*K*b1*f*fd + 224*D1*Dd*b1*f**3*r**2 - 224*D1*Dd*b1*f**3*r - 224*D1*Dd*b1*f**3*s**2 + 112*D1*Dd*b1*f**3*s + 56*D1*Dd*b1*f**3 - 672*D1*Dd*b1*f**2*fd*r**2 + 560*D1*Dd*b1*f**2*fd*r + 672*D1*Dd*b1*f**2*fd*s**2 - 392*D1*Dd*b1*f**2*fd*s - 56*D1*Dd*b1*f**2*fd + 792*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 924*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 330*D1*Dd*b1*f**2 - 1584*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 1188*D1*Dd*b1*f*fd*r + 528*D1*Dd*b1*f*fd*s**2 - 132*D1*Dd*b1*f*fd*s - 66*D1*Dd*b1*f*fd - 224*D1*Dd*f**4*r**2 - 224*D1*Dd*f**4*r*s + 280*D1*Dd*f**4*r + 112*D1*Dd*f**4*s - 112*D1*Dd*f**4 + 1792*D1*Dd*f**3*fd*r**2 + 1792*D1*Dd*f**3*fd*r*s - 2240*D1*Dd*f**3*fd*r - 896*D1*Dd*f**3*fd*s + 672*D1*Dd*f**3*fd + 1280*D1*Dd*f**3*r**2 + 160*D1*Dd*f**3*r*s - 1320*D1*Dd*f**3*r - 1120*D1*Dd*f**3*s**2 + 480*D1*Dd*f**3*s + 360*D1*Dd*f**3 - 3840*D1*Dd*f**2*fd*r**2 - 480*D1*Dd*f**2*fd*r*s + 3340*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 1760*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 1056*D1*Dd*f**2*gd2*r**2 + 1056*D1*Dd*f**2*gd2*r*s + 1452*D1*Dd*f**2*gd2*r + 2112*D1*Dd*f**2*gd2*s**2 - 1320*D1*Dd*f**2*gd2*s - 396*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 + 2112*D1*Dd*f*fd*g2*r*s + 264*D1*Dd*f*fd*g2*r + 4224*D1*Dd*f*fd*g2*s**2 - 3696*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 - 264*D1*Ddd*K*b1*f**2*r*s - 198*D1*Ddd*K*b1*f**2*r - 528*D1*Ddd*K*b1*f**2*s**2 + 396*D1*Ddd*K*b1*f**2*s - 112*D1*Ddd*b1*f**3*r**2 + 112*D1*Ddd*b1*f**3*r + 112*D1*Ddd*b1*f**3*s**2 - 56*D1*Ddd*b1*f**3*s - 28*D1*Ddd*b1*f**3 - 396*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 462*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s**2 + 66*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 + 224*D1*Ddd*f**4*r**2 + 224*D1*Ddd*f**4*r*s - 280*D1*Ddd*f**4*r - 112*D1*Ddd*f**4*s + 112*D1*Ddd*f**4 - 640*D1*Ddd*f**3*r**2 - 80*D1*Ddd*f**3*r*s + 660*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 240*D1*Ddd*f**3*s - 180*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 + 528*D1*Ddd*f**2*g2*r*s + 396*D1*Ddd*f**2*g2*r + 1056*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 2*D1*bd1*f*(D1*(28*f**2*(r**2 - 2*r - s**2 + 1) + f*(-28*fd*(3*r**2 - 4*r - 3*s**2 + s + 1) + (-33*r - 33*s + 33)*(2*K*(r - 2*s - 1) - 3*r + s + 3)) + 33*fd*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1)) + Dd*f*(33*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 28*f*(4*r**2 - 6*r - 4*s**2 + s + 2) - 396*r**2 - 264*r*s + 627*r + 132*s**2 + 165*s - 231)) + 792*Dd**2*K*b1*f**2*r**2 - 792*Dd**2*K*b1*f**2*r*s - 594*Dd**2*K*b1*f**2*r - 1584*Dd**2*K*b1*f**2*s**2 + 1188*Dd**2*K*b1*f**2*s - 336*Dd**2*b1*f**3*r**2 + 336*Dd**2*b1*f**3*r + 336*Dd**2*b1*f**3*s**2 - 168*Dd**2*b1*f**3*s - 56*Dd**2*b1*f**3 - 1188*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 1386*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s**2 + 198*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 + 672*Dd**2*f**4*r**2 + 672*Dd**2*f**4*r*s - 840*Dd**2*f**4*r - 336*Dd**2*f**4*s + 224*Dd**2*f**4 - 1920*Dd**2*f**3*r**2 - 240*Dd**2*f**3*r*s + 1980*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 720*Dd**2*f**3*s - 360*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 + 1584*Dd**2*f**2*g2*r*s + 1188*Dd**2*f**2*g2*r + 3168*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s)/(693*d**2*k3**6) - 40*D1**2*Pk2*Pk3*ct**7*k1*(b1*(D1**2*(28*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-56*fd**2*s*(3*s - 2) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(28*f**2*(4*s**2 - 2*s + 1) - 28*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(28*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(28*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(56*bd1 - 28*bdd1) + f*(-56*fd*(s**2*(3*bd1 - 3) - s*(bd1 - 2) - 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) - 2*D1*f*(28*Dd*f*(s**2*(4*bd1 - 4) - s*(bd1 - 2) - 1) + Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) + 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2*k3**2) - 80*D1**2*Pk2*Pk3*ct**6*k1**4*k2**2*(6669*C*D1**2*f**2*fd*r**2 + 13338*C*D1**2*f**2*fd*r*s - 8892*C*D1**2*f**2*fd*r + 6669*C*D1**2*f**2*fd*s**2 - 8892*C*D1**2*f**2*fd*s + 4446*C*D1**2*f**2*fd - 6552*C*D1**2*f**2*fdd*r**2 - 13104*C*D1**2*f**2*fdd*r*s + 8736*C*D1**2*f**2*fdd*r - 6552*C*D1**2*f**2*fdd*s**2 + 8736*C*D1**2*f**2*fdd*s - 4368*C*D1**2*f**2*fdd - 13104*C*D1**2*f*fd**2*r**2 - 26208*C*D1**2*f*fd**2*r*s + 17472*C*D1**2*f*fd**2*r - 13104*C*D1**2*f*fd**2*s**2 + 17472*C*D1**2*f*fd**2*s - 4368*C*D1**2*f*fd**2 + 8892*C*D1*Dd*f**3*r**2 + 17784*C*D1*Dd*f**3*r*s - 13338*C*D1*Dd*f**3*r + 8892*C*D1*Dd*f**3*s**2 - 13338*C*D1*Dd*f**3*s + 6669*C*D1*Dd*f**3 - 52416*C*D1*Dd*f**2*fd*r**2 - 104832*C*D1*Dd*f**2*fd*r*s + 74256*C*D1*Dd*f**2*fd*r - 52416*C*D1*Dd*f**2*fd*s**2 + 74256*C*D1*Dd*f**2*fd*s - 26208*C*D1*Dd*f**2*fd - 8736*C*D1*Ddd*f**3*r**2 - 17472*C*D1*Ddd*f**3*r*s + 13104*C*D1*Ddd*f**3*r - 8736*C*D1*Ddd*f**3*s**2 + 13104*C*D1*Ddd*f**3*s - 6552*C*D1*Ddd*f**3 - 26208*C*Dd**2*f**3*r**2 - 52416*C*Dd**2*f**3*r*s + 39312*C*Dd**2*f**3*r - 26208*C*Dd**2*f**3*s**2 + 39312*C*Dd**2*f**3*s - 13104*C*Dd**2*f**3 + 2574*D1**2*K*b1*f*fd*r**2 + 5148*D1**2*K*b1*f*fd*r*s - 2574*D1**2*K*b1*f*fd*r + 2574*D1**2*K*b1*f*fd*s**2 - 2574*D1**2*K*b1*f*fd*s + 1287*D1**2*K*b1*f*fd - 2574*D1**2*K*b1*f*fdd*r**2 - 5148*D1**2*K*b1*f*fdd*r*s + 2574*D1**2*K*b1*f*fdd*r - 2574*D1**2*K*b1*f*fdd*s**2 + 2574*D1**2*K*b1*f*fdd*s - 1287*D1**2*K*b1*f*fdd - 2574*D1**2*K*b1*fd**2*r**2 - 5148*D1**2*K*b1*fd**2*r*s + 2574*D1**2*K*b1*fd**2*r - 2574*D1**2*K*b1*fd**2*s**2 + 2574*D1**2*K*b1*fd**2*s - 2574*D1**2*b1*f*fd*r**2 - 5148*D1**2*b1*f*fd*r*s + 2574*D1**2*b1*f*fd*r - 2574*D1**2*b1*f*fd*s**2 + 2574*D1**2*b1*f*fd*s - 1287*D1**2*b1*f*fd + 2574*D1**2*b1*f*fdd*r**2 + 5148*D1**2*b1*f*fdd*r*s - 2574*D1**2*b1*f*fdd*r + 2574*D1**2*b1*f*fdd*s**2 - 2574*D1**2*b1*f*fdd*s + 1287*D1**2*b1*f*fdd + 2574*D1**2*b1*fd**2*r**2 + 5148*D1**2*b1*fd**2*r*s - 2574*D1**2*b1*fd**2*r + 2574*D1**2*b1*fd**2*s**2 - 2574*D1**2*b1*fd**2*s - 1287*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 7504*D1**2*f**3*fd*r**2 + 15008*D1**2*f**3*fd*r*s - 11256*D1**2*f**3*fd*r + 7504*D1**2*f**3*fd*s**2 - 11256*D1**2*f**3*fd*s + 5628*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 6669*D1**2*f**2*fd*r**2 - 13338*D1**2*f**2*fd*r*s + 8892*D1**2*f**2*fd*r - 6669*D1**2*f**2*fd*s**2 + 8892*D1**2*f**2*fd*s - 4446*D1**2*f**2*fd + 6552*D1**2*f**2*fdd*r**2 + 13104*D1**2*f**2*fdd*r*s - 8736*D1**2*f**2*fdd*r + 6552*D1**2*f**2*fdd*s**2 - 8736*D1**2*f**2*fdd*s + 4368*D1**2*f**2*fdd - 2574*D1**2*f**2*gd2*r**2 - 5148*D1**2*f**2*gd2*r*s + 5148*D1**2*f**2*gd2*r - 2574*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s - 2574*D1**2*f**2*gd2 + 2574*D1**2*f**2*gdd2*r**2 + 5148*D1**2*f**2*gdd2*r*s - 5148*D1**2*f**2*gdd2*r + 2574*D1**2*f**2*gdd2*s**2 - 5148*D1**2*f**2*gdd2*s + 2574*D1**2*f**2*gdd2 + 13104*D1**2*f*fd**2*r**2 + 26208*D1**2*f*fd**2*r*s - 17472*D1**2*f*fd**2*r + 13104*D1**2*f*fd**2*s**2 - 17472*D1**2*f*fd**2*s + 4368*D1**2*f*fd**2 - 5148*D1**2*f*fd*g2*r**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 5148*D1**2*f*fd*g2*s**2 + 5148*D1**2*f*fd*g2*s - 2574*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r**2 + 20592*D1**2*f*fd*gd2*r*s - 15444*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 15444*D1**2*f*fd*gd2*s + 5148*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r**2 + 10296*D1**2*f*fdd*g2*r*s - 5148*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r**2 + 10296*D1**2*fd**2*g2*r*s - 5148*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 5148*D1*Dd*K*b1*f**2*r**2 + 10296*D1*Dd*K*b1*f**2*r*s - 7722*D1*Dd*K*b1*f**2*r + 5148*D1*Dd*K*b1*f**2*s**2 - 7722*D1*Dd*K*b1*f**2*s + 3861*D1*Dd*K*b1*f**2 - 20592*D1*Dd*K*b1*f*fd*r**2 - 41184*D1*Dd*K*b1*f*fd*r*s + 25740*D1*Dd*K*b1*f*fd*r - 20592*D1*Dd*K*b1*f*fd*s**2 + 25740*D1*Dd*K*b1*f*fd*s - 7722*D1*Dd*K*b1*f*fd - 5148*D1*Dd*b1*f**2*r**2 - 10296*D1*Dd*b1*f**2*r*s + 7722*D1*Dd*b1*f**2*r - 5148*D1*Dd*b1*f**2*s**2 + 7722*D1*Dd*b1*f**2*s - 3861*D1*Dd*b1*f**2 + 20592*D1*Dd*b1*f*fd*r**2 + 41184*D1*Dd*b1*f*fd*r*s - 25740*D1*Dd*b1*f*fd*r + 20592*D1*Dd*b1*f*fd*s**2 - 25740*D1*Dd*b1*f*fd*s + 7722*D1*Dd*b1*f*fd + 7504*D1*Dd*f**4*r**2 + 15008*D1*Dd*f**4*r*s - 11256*D1*Dd*f**4*r + 7504*D1*Dd*f**4*s**2 - 11256*D1*Dd*f**4*s + 5628*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 8892*D1*Dd*f**3*r**2 - 17784*D1*Dd*f**3*r*s + 13338*D1*Dd*f**3*r - 8892*D1*Dd*f**3*s**2 + 13338*D1*Dd*f**3*s - 6669*D1*Dd*f**3 + 52416*D1*Dd*f**2*fd*r**2 + 104832*D1*Dd*f**2*fd*r*s - 74256*D1*Dd*f**2*fd*r + 52416*D1*Dd*f**2*fd*s**2 - 74256*D1*Dd*f**2*fd*s + 26208*D1*Dd*f**2*fd - 10296*D1*Dd*f**2*g2*r**2 - 20592*D1*Dd*f**2*g2*r*s + 15444*D1*Dd*f**2*g2*r - 10296*D1*Dd*f**2*g2*s**2 + 15444*D1*Dd*f**2*g2*s - 7722*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r**2 + 41184*D1*Dd*f**2*gd2*r*s - 36036*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 36036*D1*Dd*f**2*gd2*s + 15444*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r**2 + 82368*D1*Dd*f*fd*g2*r*s - 51480*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 51480*D1*Dd*f*fd*g2*s + 15444*D1*Dd*f*fd*g2 - 5148*D1*Ddd*K*b1*f**2*r**2 - 10296*D1*Ddd*K*b1*f**2*r*s + 7722*D1*Ddd*K*b1*f**2*r - 5148*D1*Ddd*K*b1*f**2*s**2 + 7722*D1*Ddd*K*b1*f**2*s - 3861*D1*Ddd*K*b1*f**2 + 5148*D1*Ddd*b1*f**2*r**2 + 10296*D1*Ddd*b1*f**2*r*s - 7722*D1*Ddd*b1*f**2*r + 5148*D1*Ddd*b1*f**2*s**2 - 7722*D1*Ddd*b1*f**2*s + 3861*D1*Ddd*b1*f**2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 8736*D1*Ddd*f**3*r**2 + 17472*D1*Ddd*f**3*r*s - 13104*D1*Ddd*f**3*r + 8736*D1*Ddd*f**3*s**2 - 13104*D1*Ddd*f**3*s + 6552*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r**2 + 20592*D1*Ddd*f**2*g2*r*s - 15444*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 15444*D1*Ddd*f**2*g2*s + 7722*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 15444*Dd**2*K*b1*f**2*r**2 - 30888*Dd**2*K*b1*f**2*r*s + 23166*Dd**2*K*b1*f**2*r - 15444*Dd**2*K*b1*f**2*s**2 + 23166*Dd**2*K*b1*f**2*s - 7722*Dd**2*K*b1*f**2 + 15444*Dd**2*b1*f**2*r**2 + 30888*Dd**2*b1*f**2*r*s - 23166*Dd**2*b1*f**2*r + 15444*Dd**2*b1*f**2*s**2 - 23166*Dd**2*b1*f**2*s + 7722*Dd**2*b1*f**2 - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 26208*Dd**2*f**3*r**2 + 52416*Dd**2*f**3*r*s - 39312*Dd**2*f**3*r + 26208*Dd**2*f**3*s**2 - 39312*Dd**2*f**3*s + 13104*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r**2 + 61776*Dd**2*f**2*g2*r*s - 46332*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 46332*Dd**2*f**2*g2*s + 15444*Dd**2*f**2*g2)/(3003*d**2*k3**8) - 32*D1**2*Pk2*Pk3*ct**6*k1**4*(13260*C*D1**2*f**2*fd*r*s - 4420*C*D1**2*f**2*fd*r + 13260*C*D1**2*f**2*fd*s**2 - 13260*C*D1**2*f**2*fd*s + 4420*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r*s + 3640*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 10920*C*D1**2*f**2*fdd*s - 3640*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r*s + 7280*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 21840*C*D1**2*f*fd**2*s - 3640*C*D1**2*f*fd**2 + 17680*C*D1*Dd*f**3*r*s - 4420*C*D1*Dd*f**3*r + 17680*C*D1*Dd*f**3*s**2 - 17680*C*D1*Dd*f**3*s + 4420*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r*s + 25480*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 87360*C*D1*Dd*f**2*fd*s - 18200*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r*s + 3640*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 14560*C*D1*Ddd*f**3*s - 3640*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r*s + 10920*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 43680*C*Dd**2*f**3*s - 7280*C*Dd**2*f**3 - 2145*D1**2*K*bdd1*f**2*r*s - 2145*D1**2*K*bdd1*f**2*s**2 + 2145*D1**2*K*bdd1*f**2*s + 2145*D1**2*bdd1*f**2*r*s + 2145*D1**2*bdd1*f**2*s**2 - 2145*D1**2*bdd1*f**2*s + 17920*D1**2*f**3*fd*r*s - 4480*D1**2*f**3*fd*r + 17920*D1**2*f**3*fd*s**2 - 17920*D1**2*f**3*fd*s + 4480*D1**2*f**3*fd - 12600*D1**2*f**3*fdd*r*s + 3150*D1**2*f**3*fdd*r - 12600*D1**2*f**3*fdd*s**2 + 12600*D1**2*f**3*fdd*s - 3150*D1**2*f**3*fdd - 37800*D1**2*f**2*fd**2*r*s + 9450*D1**2*f**2*fd**2*r - 37800*D1**2*f**2*fd**2*s**2 + 37800*D1**2*f**2*fd**2*s - 6300*D1**2*f**2*fd**2 - 13260*D1**2*f**2*fd*r*s + 4420*D1**2*f**2*fd*r - 13260*D1**2*f**2*fd*s**2 + 13260*D1**2*f**2*fd*s - 4420*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r*s - 3640*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 10920*D1**2*f**2*fdd*s + 3640*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r*s - 5148*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s + 4290*D1**2*f**2*gdd2*r*s + 4290*D1**2*f**2*gdd2*s**2 - 4290*D1**2*f**2*gdd2*s + 21840*D1**2*f*fd**2*r*s - 7280*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 21840*D1**2*f*fd**2*s + 3640*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r*s - 4290*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 17160*D1**2*f*fd*gd2*s + 4290*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r*s - 4290*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r*s - 4290*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 17920*D1*Dd*f**4*r*s - 4480*D1*Dd*f**4*r + 17920*D1*Dd*f**4*s**2 - 17920*D1*Dd*f**4*s + 4480*D1*Dd*f**4 - 100800*D1*Dd*f**3*fd*r*s + 25200*D1*Dd*f**3*fd*r - 100800*D1*Dd*f**3*fd*s**2 + 100800*D1*Dd*f**3*fd*s - 18900*D1*Dd*f**3*fd - 17680*D1*Dd*f**3*r*s + 4420*D1*Dd*f**3*r - 17680*D1*Dd*f**3*s**2 + 17680*D1*Dd*f**3*s - 4420*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r*s - 25480*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 87360*D1*Dd*f**2*fd*s + 18200*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r*s - 4290*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 34320*D1*Dd*f**2*gd2*s + 4290*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r*s - 25740*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 68640*D1*Dd*f*fd*g2*s + 17160*D1*Dd*f*fd*g2 - 12600*D1*Ddd*f**4*r*s + 3150*D1*Ddd*f**4*r - 12600*D1*Ddd*f**4*s**2 + 12600*D1*Ddd*f**4*s - 3150*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r*s - 3640*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 14560*D1*Ddd*f**3*s + 3640*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r*s - 4290*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 17160*D1*Ddd*f**2*g2*s + 4290*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(6*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 37800*Dd**2*f**4*r*s + 9450*Dd**2*f**4*r - 37800*Dd**2*f**4*s**2 + 37800*Dd**2*f**4*s - 6300*Dd**2*f**4 + 43680*Dd**2*f**3*r*s - 10920*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 43680*Dd**2*f**3*s + 7280*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r*s - 12870*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 51480*Dd**2*f**2*g2*s + 8580*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(6*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**6) - 40*D1**2*Pk2*Pk3*ct**6*k1**4*(D1**2*(945*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-5670*fd**2*s*(2*s - 1) + fd*(1456*C - 1456)*(3*s**2 - 2*s + 1) - fdd*(728*C - 728)*(3*s**2 - 2*s + 1) + s**2*(-429*K*bdd1 + 858*bd1*(K - 1) + 429*bdd1 - 1716*gd2 + 858*gdd2)) - 26*f*(fd**2*s*(56*C - 56)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 1716*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(945*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(104*C*(4*s**2 - 2*s + 1) - 135*fd*(1 - 4*s)**2 - 416*s**2 + 208*s - 104) - 13*f*(fd*(56*C - 56)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 858*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(945*f**2 + f*(728*C - 728) - 858*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(945*f**2 + f*(728*C - 728) - 858*g2) + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(3003*d**2*k2**2*k3**4) - 20*D1**2*Pk2*Pk3*ct**6*k1**2*k2**4*st**2*(11700*C*D1**2*f**2*fd*r**2 + 23400*C*D1**2*f**2*fd*r*s - 15600*C*D1**2*f**2*fd*r + 11700*C*D1**2*f**2*fd*s**2 - 15600*C*D1**2*f**2*fd*s + 7800*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r**2 - 11700*C*D1**2*f**2*fdd*r*s + 7800*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 7800*C*D1**2*f**2*fdd*s - 3900*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r**2 - 23400*C*D1**2*f*fd**2*r*s + 15600*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 15600*C*D1**2*f*fd**2*s - 3900*C*D1**2*f*fd**2 + 15600*C*D1*Dd*f**3*r**2 + 31200*C*D1*Dd*f**3*r*s - 23400*C*D1*Dd*f**3*r + 15600*C*D1*Dd*f**3*s**2 - 23400*C*D1*Dd*f**3*s + 11700*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r**2 - 93600*C*D1*Dd*f**2*fd*r*s + 66300*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 66300*C*D1*Dd*f**2*fd*s - 23400*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r**2 - 15600*C*D1*Ddd*f**3*r*s + 11700*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 11700*C*D1*Ddd*f**3*s - 5850*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r**2 - 46800*C*Dd**2*f**3*r*s + 35100*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 35100*C*Dd**2*f**3*s - 11700*C*Dd**2*f**3 + 5148*D1**2*K*b1*f*fd*r**2 + 10296*D1**2*K*b1*f*fd*r*s - 5148*D1**2*K*b1*f*fd*r + 5148*D1**2*K*b1*f*fd*s**2 - 5148*D1**2*K*b1*f*fd*s + 2574*D1**2*K*b1*f*fd - 2574*D1**2*K*b1*f*fdd*r**2 - 5148*D1**2*K*b1*f*fdd*r*s + 2574*D1**2*K*b1*f*fdd*r - 2574*D1**2*K*b1*f*fdd*s**2 + 2574*D1**2*K*b1*f*fdd*s - 1287*D1**2*K*b1*f*fdd - 2574*D1**2*K*b1*fd**2*r**2 - 5148*D1**2*K*b1*fd**2*r*s + 2574*D1**2*K*b1*fd**2*r - 2574*D1**2*K*b1*fd**2*s**2 + 2574*D1**2*K*b1*fd**2*s - 5148*D1**2*b1*f*fd*r**2 - 10296*D1**2*b1*f*fd*r*s + 5148*D1**2*b1*f*fd*r - 5148*D1**2*b1*f*fd*s**2 + 5148*D1**2*b1*f*fd*s - 2574*D1**2*b1*f*fd + 2574*D1**2*b1*f*fdd*r**2 + 5148*D1**2*b1*f*fdd*r*s - 2574*D1**2*b1*f*fdd*r + 2574*D1**2*b1*f*fdd*s**2 - 2574*D1**2*b1*f*fdd*s + 1287*D1**2*b1*f*fdd + 2574*D1**2*b1*fd**2*r**2 + 5148*D1**2*b1*fd**2*r*s - 2574*D1**2*b1*fd**2*r + 2574*D1**2*b1*fd**2*s**2 - 2574*D1**2*b1*fd**2*s - 1287*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 10976*D1**2*f**3*fd*r**2 + 21952*D1**2*f**3*fd*r*s - 16464*D1**2*f**3*fd*r + 10976*D1**2*f**3*fd*s**2 - 16464*D1**2*f**3*fd*s + 8232*D1**2*f**3*fd - 5488*D1**2*f**3*fdd*r**2 - 10976*D1**2*f**3*fdd*r*s + 8232*D1**2*f**3*fdd*r - 5488*D1**2*f**3*fdd*s**2 + 8232*D1**2*f**3*fdd*s - 4116*D1**2*f**3*fdd - 16464*D1**2*f**2*fd**2*r**2 - 32928*D1**2*f**2*fd**2*r*s + 24696*D1**2*f**2*fd**2*r - 16464*D1**2*f**2*fd**2*s**2 + 24696*D1**2*f**2*fd**2*s - 8232*D1**2*f**2*fd**2 - 11700*D1**2*f**2*fd*r**2 - 23400*D1**2*f**2*fd*r*s + 15600*D1**2*f**2*fd*r - 11700*D1**2*f**2*fd*s**2 + 15600*D1**2*f**2*fd*s - 7800*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r**2 + 11700*D1**2*f**2*fdd*r*s - 7800*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 7800*D1**2*f**2*fdd*s + 3900*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r**2 - 10296*D1**2*f**2*gd2*r*s + 10296*D1**2*f**2*gd2*r - 5148*D1**2*f**2*gd2*s**2 + 10296*D1**2*f**2*gd2*s - 5148*D1**2*f**2*gd2 + 2574*D1**2*f**2*gdd2*r**2 + 5148*D1**2*f**2*gdd2*r*s - 5148*D1**2*f**2*gdd2*r + 2574*D1**2*f**2*gdd2*s**2 - 5148*D1**2*f**2*gdd2*s + 2574*D1**2*f**2*gdd2 + 11700*D1**2*f*fd**2*r**2 + 23400*D1**2*f*fd**2*r*s - 15600*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 15600*D1**2*f*fd**2*s + 3900*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r**2 - 20592*D1**2*f*fd*g2*r*s + 10296*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r**2 + 20592*D1**2*f*fd*gd2*r*s - 15444*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 15444*D1**2*f*fd*gd2*s + 5148*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r**2 + 10296*D1**2*f*fdd*g2*r*s - 5148*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r**2 + 10296*D1**2*fd**2*g2*r*s - 5148*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 10296*D1*Dd*K*b1*f**2*r**2 + 20592*D1*Dd*K*b1*f**2*r*s - 15444*D1*Dd*K*b1*f**2*r + 10296*D1*Dd*K*b1*f**2*s**2 - 15444*D1*Dd*K*b1*f**2*s + 7722*D1*Dd*K*b1*f**2 - 20592*D1*Dd*K*b1*f*fd*r**2 - 41184*D1*Dd*K*b1*f*fd*r*s + 25740*D1*Dd*K*b1*f*fd*r - 20592*D1*Dd*K*b1*f*fd*s**2 + 25740*D1*Dd*K*b1*f*fd*s - 7722*D1*Dd*K*b1*f*fd - 10296*D1*Dd*b1*f**2*r**2 - 20592*D1*Dd*b1*f**2*r*s + 15444*D1*Dd*b1*f**2*r - 10296*D1*Dd*b1*f**2*s**2 + 15444*D1*Dd*b1*f**2*s - 7722*D1*Dd*b1*f**2 + 20592*D1*Dd*b1*f*fd*r**2 + 41184*D1*Dd*b1*f*fd*r*s - 25740*D1*Dd*b1*f*fd*r + 20592*D1*Dd*b1*f*fd*s**2 - 25740*D1*Dd*b1*f*fd*s + 7722*D1*Dd*b1*f*fd + 10976*D1*Dd*f**4*r**2 + 21952*D1*Dd*f**4*r*s - 16464*D1*Dd*f**4*r + 10976*D1*Dd*f**4*s**2 - 16464*D1*Dd*f**4*s + 8232*D1*Dd*f**4 - 43904*D1*Dd*f**3*fd*r**2 - 87808*D1*Dd*f**3*fd*r*s + 65856*D1*Dd*f**3*fd*r - 43904*D1*Dd*f**3*fd*s**2 + 65856*D1*Dd*f**3*fd*s - 24696*D1*Dd*f**3*fd - 15600*D1*Dd*f**3*r**2 - 31200*D1*Dd*f**3*r*s + 23400*D1*Dd*f**3*r - 15600*D1*Dd*f**3*s**2 + 23400*D1*Dd*f**3*s - 11700*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r**2 + 93600*D1*Dd*f**2*fd*r*s - 66300*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 66300*D1*Dd*f**2*fd*s + 23400*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r**2 - 41184*D1*Dd*f**2*g2*r*s + 30888*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 30888*D1*Dd*f**2*g2*s - 15444*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r**2 + 41184*D1*Dd*f**2*gd2*r*s - 36036*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 36036*D1*Dd*f**2*gd2*s + 15444*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r**2 + 82368*D1*Dd*f*fd*g2*r*s - 51480*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 51480*D1*Dd*f*fd*g2*s + 15444*D1*Dd*f*fd*g2 - 5148*D1*Ddd*K*b1*f**2*r**2 - 10296*D1*Ddd*K*b1*f**2*r*s + 7722*D1*Ddd*K*b1*f**2*r - 5148*D1*Ddd*K*b1*f**2*s**2 + 7722*D1*Ddd*K*b1*f**2*s - 3861*D1*Ddd*K*b1*f**2 + 5148*D1*Ddd*b1*f**2*r**2 + 10296*D1*Ddd*b1*f**2*r*s - 7722*D1*Ddd*b1*f**2*r + 5148*D1*Ddd*b1*f**2*s**2 - 7722*D1*Ddd*b1*f**2*s + 3861*D1*Ddd*b1*f**2 - 5488*D1*Ddd*f**4*r**2 - 10976*D1*Ddd*f**4*r*s + 8232*D1*Ddd*f**4*r - 5488*D1*Ddd*f**4*s**2 + 8232*D1*Ddd*f**4*s - 4116*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r**2 + 15600*D1*Ddd*f**3*r*s - 11700*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 11700*D1*Ddd*f**3*s + 5850*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r**2 + 20592*D1*Ddd*f**2*g2*r*s - 15444*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 15444*D1*Ddd*f**2*g2*s + 7722*D1*Ddd*f**2*g2 + 2574*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 15444*Dd**2*K*b1*f**2*r**2 - 30888*Dd**2*K*b1*f**2*r*s + 23166*Dd**2*K*b1*f**2*r - 15444*Dd**2*K*b1*f**2*s**2 + 23166*Dd**2*K*b1*f**2*s - 7722*Dd**2*K*b1*f**2 + 15444*Dd**2*b1*f**2*r**2 + 30888*Dd**2*b1*f**2*r*s - 23166*Dd**2*b1*f**2*r + 15444*Dd**2*b1*f**2*s**2 - 23166*Dd**2*b1*f**2*s + 7722*Dd**2*b1*f**2 - 16464*Dd**2*f**4*r**2 - 32928*Dd**2*f**4*r*s + 24696*Dd**2*f**4*r - 16464*Dd**2*f**4*s**2 + 24696*Dd**2*f**4*s - 8232*Dd**2*f**4 + 23400*Dd**2*f**3*r**2 + 46800*Dd**2*f**3*r*s - 35100*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 35100*Dd**2*f**3*s + 11700*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r**2 + 61776*Dd**2*f**2*g2*r*s - 46332*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 46332*Dd**2*f**2*g2*s + 15444*Dd**2*f**2*g2)/(3003*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**6*k1**2*k2**4*(-165*C*D1**2*bdd1*f**2*r**2 - 330*C*D1**2*bdd1*f**2*r*s + 330*C*D1**2*bdd1*f**2*r - 165*C*D1**2*bdd1*f**2*s**2 + 330*C*D1**2*bdd1*f**2*s - 165*C*D1**2*bdd1*f**2 + 4245*C*D1**2*f**2*fd*r**2 + 8490*C*D1**2*f**2*fd*r*s - 5660*C*D1**2*f**2*fd*r + 4245*C*D1**2*f**2*fd*s**2 - 5660*C*D1**2*f**2*fd*s + 2830*C*D1**2*f**2*fd - 3360*C*D1**2*f**2*fdd*r**2 - 6720*C*D1**2*f**2*fdd*r*s + 4480*C*D1**2*f**2*fdd*r - 3360*C*D1**2*f**2*fdd*s**2 + 4480*C*D1**2*f**2*fdd*s - 2240*C*D1**2*f**2*fdd - 6720*C*D1**2*f*fd**2*r**2 - 13440*C*D1**2*f*fd**2*r*s + 8960*C*D1**2*f*fd**2*r - 6720*C*D1**2*f*fd**2*s**2 + 8960*C*D1**2*f*fd**2*s - 2240*C*D1**2*f*fd**2 + 5660*C*D1*Dd*f**3*r**2 + 11320*C*D1*Dd*f**3*r*s - 8490*C*D1*Dd*f**3*r + 5660*C*D1*Dd*f**3*s**2 - 8490*C*D1*Dd*f**3*s + 4245*C*D1*Dd*f**3 - 26880*C*D1*Dd*f**2*fd*r**2 - 53760*C*D1*Dd*f**2*fd*r*s + 38080*C*D1*Dd*f**2*fd*r - 26880*C*D1*Dd*f**2*fd*s**2 + 38080*C*D1*Dd*f**2*fd*s - 13440*C*D1*Dd*f**2*fd - 4480*C*D1*Ddd*f**3*r**2 - 8960*C*D1*Ddd*f**3*r*s + 6720*C*D1*Ddd*f**3*r - 4480*C*D1*Ddd*f**3*s**2 + 6720*C*D1*Ddd*f**3*s - 3360*C*D1*Ddd*f**3 - 13440*C*Dd**2*f**3*r**2 - 26880*C*Dd**2*f**3*r*s + 20160*C*Dd**2*f**3*r - 13440*C*Dd**2*f**3*s**2 + 20160*C*Dd**2*f**3*s - 6720*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r**2 - 1320*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 660*D1**2*K*bdd1*f**2*s**2 + 1320*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 280*D1**2*bdd1*f**3*r**2 + 560*D1**2*bdd1*f**3*r*s - 560*D1**2*bdd1*f**3*r + 280*D1**2*bdd1*f**3*s**2 - 560*D1**2*bdd1*f**3*s + 280*D1**2*bdd1*f**3 + 495*D1**2*bdd1*f**2*r**2 + 990*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*r + 495*D1**2*bdd1*f**2*s**2 - 990*D1**2*bdd1*f**2*s + 495*D1**2*bdd1*f**2 + 198*D1**2*bdd1*f*g2*r**2 + 396*D1**2*bdd1*f*g2*r*s - 396*D1**2*bdd1*f*g2*r + 198*D1**2*bdd1*f*g2*s**2 - 396*D1**2*bdd1*f*g2*s + 198*D1**2*bdd1*f*g2 - 280*D1**2*f**3*fd*r**2 - 560*D1**2*f**3*fd*r*s + 420*D1**2*f**3*fd*r - 280*D1**2*f**3*fd*s**2 + 420*D1**2*f**3*fd*s - 210*D1**2*f**3*fd - 3060*D1**2*f**2*fd*r**2 - 6120*D1**2*f**2*fd*r*s + 4080*D1**2*f**2*fd*r - 3060*D1**2*f**2*fd*s**2 + 4080*D1**2*f**2*fd*s - 2040*D1**2*f**2*fd + 2520*D1**2*f**2*fdd*r**2 + 5040*D1**2*f**2*fdd*r*s - 3360*D1**2*f**2*fdd*r + 2520*D1**2*f**2*fdd*s**2 - 3360*D1**2*f**2*fdd*s + 1680*D1**2*f**2*fdd - 1650*D1**2*f**2*gd2*r**2 - 3300*D1**2*f**2*gd2*r*s + 3300*D1**2*f**2*gd2*r - 1650*D1**2*f**2*gd2*s**2 + 3300*D1**2*f**2*gd2*s - 1650*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 5040*D1**2*f*fd**2*r**2 + 10080*D1**2*f*fd**2*r*s - 6720*D1**2*f*fd**2*r + 5040*D1**2*f*fd**2*s**2 - 6720*D1**2*f*fd**2*s + 1680*D1**2*f*fd**2 - 3300*D1**2*f*fd*g2*r**2 - 6600*D1**2*f*fd*g2*r*s + 3300*D1**2*f*fd*g2*r - 3300*D1**2*f*fd*g2*s**2 + 3300*D1**2*f*fd*g2*s - 1650*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s - 280*D1*Dd*f**4*r**2 - 560*D1*Dd*f**4*r*s + 420*D1*Dd*f**4*r - 280*D1*Dd*f**4*s**2 + 420*D1*Dd*f**4*s - 210*D1*Dd*f**4 - 4080*D1*Dd*f**3*r**2 - 8160*D1*Dd*f**3*r*s + 6120*D1*Dd*f**3*r - 4080*D1*Dd*f**3*s**2 + 6120*D1*Dd*f**3*s - 3060*D1*Dd*f**3 + 20160*D1*Dd*f**2*fd*r**2 + 40320*D1*Dd*f**2*fd*r*s - 28560*D1*Dd*f**2*fd*r + 20160*D1*Dd*f**2*fd*s**2 - 28560*D1*Dd*f**2*fd*s + 10080*D1*Dd*f**2*fd - 6600*D1*Dd*f**2*g2*r**2 - 13200*D1*Dd*f**2*g2*r*s + 9900*D1*Dd*f**2*g2*r - 6600*D1*Dd*f**2*g2*s**2 + 9900*D1*Dd*f**2*g2*s - 4950*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 3360*D1*Ddd*f**3*r**2 + 6720*D1*Ddd*f**3*r*s - 5040*D1*Ddd*f**3*r + 3360*D1*Ddd*f**3*s**2 - 5040*D1*Ddd*f**3*s + 2520*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 - D1*bd1*(D1*(395*f**3*(r + s - 1) - f**2*(330*C*(r + s - 1) + 560*fd*(3*r + 3*s - 2) + (825*K - 693)*(r + s - 1)) + 66*f*(5*fd*(C + 4*K - 3)*(2*r + 2*s - 1) + (6*g2 - 6*gd2)*(r + s - 1)) - 396*fd*g2*(r + s)) - 2*Dd*f*(280*f**2 - 165*f*(C + 4*K - 3) + 198*g2)*(4*r + 4*s - 3))*(r + s - 1) + 10080*Dd**2*f**3*r**2 + 20160*Dd**2*f**3*r*s - 15120*Dd**2*f**3*r + 10080*Dd**2*f**3*s**2 - 15120*Dd**2*f**3*s + 5040*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2 + 99*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(660*C*D1**2*f*fd*r**2 + 1320*C*D1**2*f*fd*r*s - 660*C*D1**2*f*fd*r + 660*C*D1**2*f*fd*s**2 - 660*C*D1**2*f*fd*s + 330*C*D1**2*f*fd - 330*C*D1**2*f*fdd*r**2 - 660*C*D1**2*f*fdd*r*s + 330*C*D1**2*f*fdd*r - 330*C*D1**2*f*fdd*s**2 + 330*C*D1**2*f*fdd*s - 165*C*D1**2*f*fdd - 330*C*D1**2*fd**2*r**2 - 660*C*D1**2*fd**2*r*s + 330*C*D1**2*fd**2*r - 330*C*D1**2*fd**2*s**2 + 330*C*D1**2*fd**2*s + 1320*C*D1*Dd*f**2*r**2 + 2640*C*D1*Dd*f**2*r*s - 1980*C*D1*Dd*f**2*r + 1320*C*D1*Dd*f**2*s**2 - 1980*C*D1*Dd*f**2*s + 990*C*D1*Dd*f**2 - 2640*C*D1*Dd*f*fd*r**2 - 5280*C*D1*Dd*f*fd*r*s + 3300*C*D1*Dd*f*fd*r - 2640*C*D1*Dd*f*fd*s**2 + 3300*C*D1*Dd*f*fd*s - 990*C*D1*Dd*f*fd - 660*C*D1*Ddd*f**2*r**2 - 1320*C*D1*Ddd*f**2*r*s + 990*C*D1*Ddd*f**2*r - 660*C*D1*Ddd*f**2*s**2 + 990*C*D1*Ddd*f**2*s - 495*C*D1*Ddd*f**2 - 1980*C*Dd**2*f**2*r**2 - 3960*C*Dd**2*f**2*r*s + 2970*C*Dd**2*f**2*r - 1980*C*Dd**2*f**2*s**2 + 2970*C*Dd**2*f**2*s - 990*C*Dd**2*f**2 + 1650*D1**2*K*f*fd*r**2 + 3300*D1**2*K*f*fd*r*s - 1650*D1**2*K*f*fd*r + 1650*D1**2*K*f*fd*s**2 - 1650*D1**2*K*f*fd*s + 825*D1**2*K*f*fd - 1320*D1**2*K*f*fdd*r**2 - 2640*D1**2*K*f*fdd*r*s + 1320*D1**2*K*f*fdd*r - 1320*D1**2*K*f*fdd*s**2 + 1320*D1**2*K*f*fdd*s - 660*D1**2*K*f*fdd - 1320*D1**2*K*fd**2*r**2 - 2640*D1**2*K*fd**2*r*s + 1320*D1**2*K*fd**2*r - 1320*D1**2*K*fd**2*s**2 + 1320*D1**2*K*fd**2*s - 198*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 1185*D1**2*f**2*fd*r**2 - 2370*D1**2*f**2*fd*r*s + 1580*D1**2*f**2*fd*r - 1185*D1**2*f**2*fd*s**2 + 1580*D1**2*f**2*fd*s - 790*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 + 1680*D1**2*f**2*fdd*r*s - 1120*D1**2*f**2*fdd*r + 840*D1**2*f**2*fdd*s**2 - 1120*D1**2*f**2*fdd*s + 560*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r**2 + 3360*D1**2*f*fd**2*r*s - 2240*D1**2*f*fd**2*r + 1680*D1**2*f*fd**2*s**2 - 2240*D1**2*f*fd**2*s + 560*D1**2*f*fd**2 - 1386*D1**2*f*fd*r**2 - 2772*D1**2*f*fd*r*s + 1386*D1**2*f*fd*r - 1386*D1**2*f*fd*s**2 + 1386*D1**2*f*fd*s - 693*D1**2*f*fd + 990*D1**2*f*fdd*r**2 + 1980*D1**2*f*fdd*r*s - 990*D1**2*f*fdd*r + 990*D1**2*f*fdd*s**2 - 990*D1**2*f*fdd*s + 495*D1**2*f*fdd - 396*D1**2*f*gd2*r**2 - 792*D1**2*f*gd2*r*s + 792*D1**2*f*gd2*r - 396*D1**2*f*gd2*s**2 + 792*D1**2*f*gd2*s - 396*D1**2*f*gd2 + 198*D1**2*f*gdd2*r**2 + 396*D1**2*f*gdd2*r*s - 396*D1**2*f*gdd2*r + 198*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s + 198*D1**2*f*gdd2 + 990*D1**2*fd**2*r**2 + 1980*D1**2*fd**2*r*s - 990*D1**2*fd**2*r + 990*D1**2*fd**2*s**2 - 990*D1**2*fd**2*s - 396*D1**2*fd*g2*r**2 - 792*D1**2*fd*g2*r*s - 396*D1**2*fd*g2*s**2 + 396*D1**2*fd*gd2*r**2 + 792*D1**2*fd*gd2*r*s - 396*D1**2*fd*gd2*r + 396*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 198*D1**2*fdd*g2*r**2 + 396*D1**2*fdd*g2*r*s + 198*D1**2*fdd*g2*s**2 + 3300*D1*Dd*K*f**2*r**2 + 6600*D1*Dd*K*f**2*r*s - 4950*D1*Dd*K*f**2*r + 3300*D1*Dd*K*f**2*s**2 - 4950*D1*Dd*K*f**2*s + 2475*D1*Dd*K*f**2 - 10560*D1*Dd*K*f*fd*r**2 - 21120*D1*Dd*K*f*fd*r*s + 13200*D1*Dd*K*f*fd*r - 10560*D1*Dd*K*f*fd*s**2 + 13200*D1*Dd*K*f*fd*s - 3960*D1*Dd*K*f*fd - 1580*D1*Dd*f**3*r**2 - 3160*D1*Dd*f**3*r*s + 2370*D1*Dd*f**3*r - 1580*D1*Dd*f**3*s**2 + 2370*D1*Dd*f**3*s - 1185*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 + 13440*D1*Dd*f**2*fd*r*s - 9520*D1*Dd*f**2*fd*r + 6720*D1*Dd*f**2*fd*s**2 - 9520*D1*Dd*f**2*fd*s + 3360*D1*Dd*f**2*fd - 2772*D1*Dd*f**2*r**2 - 5544*D1*Dd*f**2*r*s + 4158*D1*Dd*f**2*r - 2772*D1*Dd*f**2*s**2 + 4158*D1*Dd*f**2*s - 2079*D1*Dd*f**2 + 7920*D1*Dd*f*fd*r**2 + 15840*D1*Dd*f*fd*r*s - 9900*D1*Dd*f*fd*r + 7920*D1*Dd*f*fd*s**2 - 9900*D1*Dd*f*fd*s + 2970*D1*Dd*f*fd - 1584*D1*Dd*f*g2*r**2 - 3168*D1*Dd*f*g2*r*s + 2376*D1*Dd*f*g2*r - 1584*D1*Dd*f*g2*s**2 + 2376*D1*Dd*f*g2*s - 1188*D1*Dd*f*g2 + 1584*D1*Dd*f*gd2*r**2 + 3168*D1*Dd*f*gd2*r*s - 2772*D1*Dd*f*gd2*r + 1584*D1*Dd*f*gd2*s**2 - 2772*D1*Dd*f*gd2*s + 1188*D1*Dd*f*gd2 + 1584*D1*Dd*fd*g2*r**2 + 3168*D1*Dd*fd*g2*r*s - 1188*D1*Dd*fd*g2*r + 1584*D1*Dd*fd*g2*s**2 - 1188*D1*Dd*fd*g2*s - 2640*D1*Ddd*K*f**2*r**2 - 5280*D1*Ddd*K*f**2*r*s + 3960*D1*Ddd*K*f**2*r - 2640*D1*Ddd*K*f**2*s**2 + 3960*D1*Ddd*K*f**2*s - 1980*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r**2 + 2240*D1*Ddd*f**3*r*s - 1680*D1*Ddd*f**3*r + 1120*D1*Ddd*f**3*s**2 - 1680*D1*Ddd*f**3*s + 840*D1*Ddd*f**3 + 1980*D1*Ddd*f**2*r**2 + 3960*D1*Ddd*f**2*r*s - 2970*D1*Ddd*f**2*r + 1980*D1*Ddd*f**2*s**2 - 2970*D1*Ddd*f**2*s + 1485*D1*Ddd*f**2 + 792*D1*Ddd*f*g2*r**2 + 1584*D1*Ddd*f*g2*r*s - 1188*D1*Ddd*f*g2*r + 792*D1*Ddd*f*g2*s**2 - 1188*D1*Ddd*f*g2*s + 594*D1*Ddd*f*g2 + 396*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 7920*Dd**2*K*f**2*r**2 - 15840*Dd**2*K*f**2*r*s + 11880*Dd**2*K*f**2*r - 7920*Dd**2*K*f**2*s**2 + 11880*Dd**2*K*f**2*s - 3960*Dd**2*K*f**2 + 3360*Dd**2*f**3*r**2 + 6720*Dd**2*f**3*r*s - 5040*Dd**2*f**3*r + 3360*Dd**2*f**3*s**2 - 5040*Dd**2*f**3*s + 1680*Dd**2*f**3 + 5940*Dd**2*f**2*r**2 + 11880*Dd**2*f**2*r*s - 8910*Dd**2*f**2*r + 5940*Dd**2*f**2*s**2 - 8910*Dd**2*f**2*s + 2970*Dd**2*f**2 + 2376*Dd**2*f*g2*r**2 + 4752*Dd**2*f*g2*r*s - 3564*Dd**2*f*g2*r + 2376*Dd**2*f*g2*s**2 - 3564*Dd**2*f*g2*s + 1188*Dd**2*f*g2))/(231*d**2*k3**8) - 80*D1**2*Pk2*Pk3*ct**6*k1**2*k2**2*st**2*(11700*C*D1**2*f**2*fd*r*s - 3900*C*D1**2*f**2*fd*r + 11700*C*D1**2*f**2*fd*s**2 - 11700*C*D1**2*f**2*fd*s + 3900*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 15600*C*D1*Dd*f**3*r*s - 3900*C*D1*Dd*f**3*r + 15600*C*D1*Dd*f**3*s**2 - 15600*C*D1*Dd*f**3*s + 3900*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 10976*D1**2*f**3*fd*r*s - 2744*D1**2*f**3*fd*r + 10976*D1**2*f**3*fd*s**2 - 10976*D1**2*f**3*fd*s + 2744*D1**2*f**3*fd - 5488*D1**2*f**3*fdd*r*s + 1372*D1**2*f**3*fdd*r - 5488*D1**2*f**3*fdd*s**2 + 5488*D1**2*f**3*fdd*s - 1372*D1**2*f**3*fdd - 16464*D1**2*f**2*fd**2*r*s + 4116*D1**2*f**2*fd**2*r - 16464*D1**2*f**2*fd**2*s**2 + 16464*D1**2*f**2*fd**2*s - 2744*D1**2*f**2*fd**2 - 11700*D1**2*f**2*fd*r*s + 3900*D1**2*f**2*fd*r - 11700*D1**2*f**2*fd*s**2 + 11700*D1**2*f**2*fd*s - 3900*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r*s - 5148*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 10976*D1*Dd*f**4*r*s - 2744*D1*Dd*f**4*r + 10976*D1*Dd*f**4*s**2 - 10976*D1*Dd*f**4*s + 2744*D1*Dd*f**4 - 43904*D1*Dd*f**3*fd*r*s + 10976*D1*Dd*f**3*fd*r - 43904*D1*Dd*f**3*fd*s**2 + 43904*D1*Dd*f**3*fd*s - 8232*D1*Dd*f**3*fd - 15600*D1*Dd*f**3*r*s + 3900*D1*Dd*f**3*r - 15600*D1*Dd*f**3*s**2 + 15600*D1*Dd*f**3*s - 3900*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 5488*D1*Ddd*f**4*r*s + 1372*D1*Ddd*f**4*r - 5488*D1*Ddd*f**4*s**2 + 5488*D1*Ddd*f**4*s - 1372*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 16464*Dd**2*f**4*r*s + 4116*Dd**2*f**4*r - 16464*Dd**2*f**4*s**2 + 16464*Dd**2*f**4*s - 2744*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 1287*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**6) + 8*D1**2*Pk2*Pk3*ct**6*k1**2*k2**2*(330*C*D1**2*bdd1*f**2*r**2 + 1320*C*D1**2*bdd1*f**2*r*s - 660*C*D1**2*bdd1*f**2*r + 990*C*D1**2*bdd1*f**2*s**2 - 1320*C*D1**2*bdd1*f**2*s + 660*C*D1**2*bdd1*f**2 + 11385*C*D1**2*f**2*fd*r**2 + 3990*C*D1**2*f**2*fd*r*s - 8920*C*D1**2*f**2*fd*r - 7395*C*D1**2*f**2*fd*s**2 + 3600*C*D1**2*f**2*fd*s + 1330*C*D1**2*f**2*fd - 8415*C*D1**2*f**2*fdd*r**2 - 4470*C*D1**2*f**2*fdd*r*s + 7100*C*D1**2*f**2*fdd*r + 3945*C*D1**2*f**2*fdd*s**2 - 1140*C*D1**2*f**2*fdd*s - 1490*C*D1**2*f**2*fdd - 16830*C*D1**2*f*fd**2*r**2 - 8940*C*D1**2*f*fd**2*r*s + 14200*C*D1**2*f*fd**2*r + 7890*C*D1**2*f*fd**2*s**2 - 2280*C*D1**2*f*fd**2*s - 1490*C*D1**2*f*fd**2 + 15180*C*D1*Dd*f**3*r**2 + 5320*C*D1*Dd*f**3*r*s - 16510*C*D1*Dd*f**3*r - 9860*C*D1*Dd*f**3*s**2 + 2270*C*D1*Dd*f**3*s + 5125*C*D1*Dd*f**3 - 67320*C*D1*Dd*f**2*fd*r**2 - 35760*C*D1*Dd*f**2*fd*r*s + 66530*C*D1*Dd*f**2*fd*r + 31560*C*D1*Dd*f**2*fd*s**2 - 3510*C*D1*Dd*f**2*fd*s - 13060*C*D1*Dd*f**2*fd - 11220*C*D1*Ddd*f**3*r**2 - 5960*C*D1*Ddd*f**3*r*s + 12710*C*D1*Ddd*f**3*r + 5260*C*D1*Ddd*f**3*s**2 + 350*C*D1*Ddd*f**3*s - 4295*C*D1*Ddd*f**3 - 33660*C*Dd**2*f**3*r**2 - 17880*C*Dd**2*f**3*r*s + 38130*C*Dd**2*f**3*r + 15780*C*Dd**2*f**3*s**2 + 1050*C*Dd**2*f**3*s - 8590*C*Dd**2*f**3 - 1485*D1**2*K*bdd1*f**2*r**2 - 726*D1**2*K*bdd1*f**2*r*s + 2970*D1**2*K*bdd1*f**2*r + 759*D1**2*K*bdd1*f**2*s**2 + 726*D1**2*K*bdd1*f**2*s - 1485*D1**2*K*bdd1*f**2 + 396*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1) + 700*D1**2*bdd1*f**3*r**2 + 560*D1**2*bdd1*f**3*r*s - 1400*D1**2*bdd1*f**3*r - 140*D1**2*bdd1*f**3*s**2 - 560*D1**2*bdd1*f**3*s + 840*D1**2*bdd1*f**3 + 1815*D1**2*bdd1*f**2*r**2 + 1716*D1**2*bdd1*f**2*r*s - 3630*D1**2*bdd1*f**2*r - 99*D1**2*bdd1*f**2*s**2 - 1716*D1**2*bdd1*f**2*s + 1485*D1**2*bdd1*f**2 - 396*D1**2*bdd1*f*g2*r**2 - 1584*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r - 1188*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 + 5880*D1**2*f**3*fd*r**2 + 11200*D1**2*f**3*fd*r*s - 8680*D1**2*f**3*fd*r + 5320*D1**2*f**3*fd*s**2 - 8260*D1**2*f**3*fd*s + 4270*D1**2*f**3*fd - 6440*D1**2*f**3*fdd*r**2 - 10080*D1**2*f**3*fdd*r*s + 8960*D1**2*f**3*fdd*r - 3640*D1**2*f**3*fdd*s**2 + 6860*D1**2*f**3*fdd*s - 4130*D1**2*f**3*fdd - 19320*D1**2*f**2*fd**2*r**2 - 30240*D1**2*f**2*fd**2*r*s + 26880*D1**2*f**2*fd**2*r - 10920*D1**2*f**2*fd**2*s**2 + 20580*D1**2*f**2*fd**2*s - 8260*D1**2*f**2*fd**2 - 13755*D1**2*f**2*fd*r**2 - 12780*D1**2*f**2*fd*r*s + 13430*D1**2*f**2*fd*r + 975*D1**2*f**2*fd*s**2 + 3610*D1**2*f**2*fd*s - 4260*D1**2*f**2*fd + 10095*D1**2*f**2*fdd*r**2 + 10350*D1**2*f**2*fdd*r*s - 10180*D1**2*f**2*fdd*r + 255*D1**2*f**2*fdd*s**2 - 3620*D1**2*f**2*fdd*s + 3450*D1**2*f**2*fdd - 3762*D1**2*f**2*gd2*r**2 - 924*D1**2*f**2*gd2*r*s + 7524*D1**2*f**2*gd2*r + 2838*D1**2*f**2*gd2*s**2 + 924*D1**2*f**2*gd2*s - 3762*D1**2*f**2*gd2 + 2970*D1**2*f**2*gdd2*r**2 + 1452*D1**2*f**2*gdd2*r*s - 5940*D1**2*f**2*gdd2*r - 1518*D1**2*f**2*gdd2*s**2 - 1452*D1**2*f**2*gdd2*s + 2970*D1**2*f**2*gdd2 + 20190*D1**2*f*fd**2*r**2 + 20700*D1**2*f*fd**2*r*s - 20360*D1**2*f*fd**2*r + 510*D1**2*f*fd**2*s**2 - 7240*D1**2*f*fd**2*s + 3450*D1**2*f*fd**2 - 7524*D1**2*f*fd*g2*r**2 - 1848*D1**2*f*fd*g2*r*s + 924*D1**2*f*fd*g2*r + 5676*D1**2*f*fd*g2*s**2 - 5676*D1**2*f*fd*g2*s + 2838*D1**2*f*fd*g2 + 11880*D1**2*f*fd*gd2*r**2 + 5808*D1**2*f*fd*gd2*r*s - 13332*D1**2*f*fd*gd2*r - 6072*D1**2*f*fd*gd2*s**2 + 132*D1**2*f*fd*gd2*s + 1452*D1**2*f*fd*gd2 + 5940*D1**2*f*fdd*g2*r**2 + 2904*D1**2*f*fdd*g2*r*s - 1452*D1**2*f*fdd*g2*r - 3036*D1**2*f*fdd*g2*s**2 + 3036*D1**2*f*fdd*g2*s - 1518*D1**2*f*fdd*g2 + 5940*D1**2*fd**2*g2*r**2 + 2904*D1**2*fd**2*g2*r*s - 1452*D1**2*fd**2*g2*r - 3036*D1**2*fd**2*g2*s**2 + 3036*D1**2*fd**2*g2*s + 5880*D1*Dd*f**4*r**2 + 11200*D1*Dd*f**4*r*s - 8680*D1*Dd*f**4*r + 5320*D1*Dd*f**4*s**2 - 8260*D1*Dd*f**4*s + 4270*D1*Dd*f**4 - 51520*D1*Dd*f**3*fd*r**2 - 80640*D1*Dd*f**3*fd*r*s + 71680*D1*Dd*f**3*fd*r - 29120*D1*Dd*f**3*fd*s**2 + 54880*D1*Dd*f**3*fd*s - 24780*D1*Dd*f**3*fd - 18340*D1*Dd*f**3*r**2 - 17040*D1*Dd*f**3*r*s + 22600*D1*Dd*f**3*r + 1300*D1*Dd*f**3*s**2 + 7870*D1*Dd*f**3*s - 8845*D1*Dd*f**3 + 80760*D1*Dd*f**2*fd*r**2 + 82800*D1*Dd*f**2*fd*r*s - 91450*D1*Dd*f**2*fd*r + 2040*D1*Dd*f**2*fd*s**2 - 35690*D1*Dd*f**2*fd*s + 23980*D1*Dd*f**2*fd - 15048*D1*Dd*f**2*g2*r**2 - 3696*D1*Dd*f**2*g2*r*s + 15972*D1*Dd*f**2*g2*r + 11352*D1*Dd*f**2*g2*s**2 - 3828*D1*Dd*f**2*g2*s - 4686*D1*Dd*f**2*g2 + 23760*D1*Dd*f**2*gd2*r**2 + 11616*D1*Dd*f**2*gd2*r*s - 37092*D1*Dd*f**2*gd2*r - 12144*D1*Dd*f**2*gd2*s**2 - 5676*D1*Dd*f**2*gd2*s + 13332*D1*Dd*f**2*gd2 + 47520*D1*Dd*f*fd*g2*r**2 + 23232*D1*Dd*f*fd*g2*r*s - 32472*D1*Dd*f*fd*g2*r - 24288*D1*Dd*f*fd*g2*s**2 + 12408*D1*Dd*f*fd*g2*s - 132*D1*Dd*f*fd*g2 - 6440*D1*Ddd*f**4*r**2 - 10080*D1*Ddd*f**4*r*s + 8960*D1*Ddd*f**4*r - 3640*D1*Ddd*f**4*s**2 + 6860*D1*Ddd*f**4*s - 4130*D1*Ddd*f**4 + 13460*D1*Ddd*f**3*r**2 + 13800*D1*Ddd*f**3*r*s - 16910*D1*Ddd*f**3*r + 340*D1*Ddd*f**3*s**2 - 7070*D1*Ddd*f**3*s + 6815*D1*Ddd*f**3 + 11880*D1*Ddd*f**2*g2*r**2 + 5808*D1*Ddd*f**2*g2*r*s - 13332*D1*Ddd*f**2*g2*r - 6072*D1*Ddd*f**2*g2*s**2 + 132*D1*Ddd*f**2*g2*s + 4422*D1*Ddd*f**2*g2 - D1*bd1*(D1*(10*f**3*(107*r**2 + r*(79*s - 214) - 28*s**2 - 79*s + 135) + f**2*(660*C*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 2) - 33*K*(57*r**2 + 2*r*(7*s - 57) - 43*s**2 - 14*s + 57) - 280*fd*(15*r**2 + 2*r*(6*s - 11) - 3*s**2 - 7*s + 6) + 2145*r**2 + 1254*r*s - 4290*r - 891*s**2 - 1254*s + 1485) - 66*f*(fd*(10*C*(2*r**2 + r*(8*s - 4) + 6*s**2 - 7*s + 1) - K*(90*r**2 + 44*r*s - 101*r - 46*s**2 + s + 11) + 110*r**2 + 104*r*s - 136*r - 6*s**2 - 49*s + 36) + 12*g2*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 2) - 12*gd2*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1)) + 792*fd*g2*(r**2 + r*(4*s - 2) + s*(3*s - 3))) - 2*Dd*f*(140*f**2*(20*r**2 + 16*r*(s - 2) - 4*s**2 - 11*s + 12) + 33*f*(10*C*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4) + K*(-180*r**2 - 88*r*s + 281*r + 92*s**2 + 43*s - 101) + 220*r**2 + 208*r*s - 356*r - 12*s**2 - 153*s + 136) - 396*g2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4))) - 19320*Dd**2*f**4*r**2 - 30240*Dd**2*f**4*r*s + 26880*Dd**2*f**4*r - 10920*Dd**2*f**4*s**2 + 20580*Dd**2*f**4*s - 8260*Dd**2*f**4 + 40380*Dd**2*f**3*r**2 + 41400*Dd**2*f**3*r*s - 50730*Dd**2*f**3*r + 1020*Dd**2*f**3*s**2 - 21210*Dd**2*f**3*s + 13630*Dd**2*f**3 + 35640*Dd**2*f**2*g2*r**2 + 17424*Dd**2*f**2*g2*r*s - 39996*Dd**2*f**2*g2*r - 18216*Dd**2*f**2*g2*s**2 + 396*Dd**2*f**2*g2*s + 8844*Dd**2*f**2*g2 - 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + D1*(2*Dd*(f*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 14*s + 5) - fd*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3)) - Ddd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 14*s + 5)) - 2*Dd**2*f*(6*r**2 + 12*r*(2*s - 1) + 18*s**2 - 21*s + 5)) - b1*(1320*C*D1**2*f*fd*r**2 + 5280*C*D1**2*f*fd*r*s - 2640*C*D1**2*f*fd*r + 3960*C*D1**2*f*fd*s**2 - 3960*C*D1**2*f*fd*s + 1320*C*D1**2*f*fd - 660*C*D1**2*f*fdd*r**2 - 2640*C*D1**2*f*fdd*r*s + 1320*C*D1**2*f*fdd*r - 1980*C*D1**2*f*fdd*s**2 + 1980*C*D1**2*f*fdd*s - 660*C*D1**2*f*fdd - 660*C*D1**2*fd**2*r**2 - 2640*C*D1**2*fd**2*r*s + 1320*C*D1**2*fd**2*r - 1980*C*D1**2*fd**2*s**2 + 1980*C*D1**2*fd**2*s - 660*C*D1**2*fd**2 + 2640*C*D1*Dd*f**2*r**2 + 10560*C*D1*Dd*f**2*r*s - 5280*C*D1*Dd*f**2*r + 7920*C*D1*Dd*f**2*s**2 - 9240*C*D1*Dd*f**2*s + 3300*C*D1*Dd*f**2 - 5280*C*D1*Dd*f*fd*r**2 - 21120*C*D1*Dd*f*fd*r*s + 10560*C*D1*Dd*f*fd*r - 15840*C*D1*Dd*f*fd*s**2 + 17160*C*D1*Dd*f*fd*s - 4620*C*D1*Dd*f*fd - 1320*C*D1*Ddd*f**2*r**2 - 5280*C*D1*Ddd*f**2*r*s + 2640*C*D1*Ddd*f**2*r - 3960*C*D1*Ddd*f**2*s**2 + 4620*C*D1*Ddd*f**2*s - 1650*C*D1*Ddd*f**2 - 3960*C*Dd**2*f**2*r**2 - 15840*C*Dd**2*f**2*r*s + 7920*C*Dd**2*f**2*r - 11880*C*Dd**2*f**2*s**2 + 13860*C*Dd**2*f**2*s - 3300*C*Dd**2*f**2 - 3762*D1**2*K*f*fd*r**2 - 924*D1**2*K*f*fd*r*s + 462*D1**2*K*f*fd*r + 2838*D1**2*K*f*fd*s**2 - 2838*D1**2*K*f*fd*s + 1419*D1**2*K*f*fd + 2970*D1**2*K*f*fdd*r**2 + 1452*D1**2*K*f*fdd*r*s - 726*D1**2*K*f*fdd*r - 1518*D1**2*K*f*fdd*s**2 + 1518*D1**2*K*f*fdd*s - 759*D1**2*K*f*fdd + 2970*D1**2*K*fd**2*r**2 + 1452*D1**2*K*fd**2*r*s - 726*D1**2*K*fd**2*r - 1518*D1**2*K*fd**2*s**2 + 1518*D1**2*K*fd**2*s - 198*D1**2*bdd1*f*(K - 1)*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) + 3210*D1**2*f**2*fd*r**2 + 2370*D1**2*f**2*fd*r*s - 2930*D1**2*f**2*fd*r - 840*D1**2*f**2*fd*s**2 - 230*D1**2*f**2*fd*s + 510*D1**2*f**2*fd - 2100*D1**2*f**2*fdd*r**2 - 1680*D1**2*f**2*fdd*r*s + 1960*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 + 280*D1**2*f**2*fdd*s - 420*D1**2*f**2*fdd - 4200*D1**2*f*fd**2*r**2 - 3360*D1**2*f*fd**2*r*s + 3920*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 + 560*D1**2*f*fd**2*s - 840*D1**2*f*fd**2 + 4290*D1**2*f*fd*r**2 + 2508*D1**2*f*fd*r*s - 1254*D1**2*f*fd*r - 1782*D1**2*f*fd*s**2 + 1782*D1**2*f*fd*s - 231*D1**2*f*fd - 3630*D1**2*f*fdd*r**2 - 3432*D1**2*f*fdd*r*s + 1716*D1**2*f*fdd*r + 198*D1**2*f*fdd*s**2 - 198*D1**2*f*fdd*s - 231*D1**2*f*fdd - 792*D1**2*f*gd2*r**2 - 3168*D1**2*f*gd2*r*s + 1584*D1**2*f*gd2*r - 2376*D1**2*f*gd2*s**2 + 3168*D1**2*f*gd2*s - 792*D1**2*f*gd2 + 396*D1**2*f*gdd2*r**2 + 1584*D1**2*f*gdd2*r*s - 792*D1**2*f*gdd2*r + 1188*D1**2*f*gdd2*s**2 - 1584*D1**2*f*gdd2*s + 396*D1**2*f*gdd2 - 3630*D1**2*fd**2*r**2 - 3432*D1**2*fd**2*r*s + 1716*D1**2*fd**2*r + 198*D1**2*fd**2*s**2 - 198*D1**2*fd**2*s + 660*D1**2*fd**2 - 792*D1**2*fd*g2*r**2 - 3168*D1**2*fd*g2*r*s + 1584*D1**2*fd*g2*r - 2376*D1**2*fd*g2*s**2 + 1584*D1**2*fd*g2*s - 792*D1**2*fd*g2 + 792*D1**2*fd*gd2*r**2 + 3168*D1**2*fd*gd2*r*s - 1584*D1**2*fd*gd2*r + 2376*D1**2*fd*gd2*s**2 - 2376*D1**2*fd*gd2*s + 792*D1**2*fd*gd2 + 396*D1**2*fdd*g2*r**2 + 1584*D1**2*fdd*g2*r*s - 792*D1**2*fdd*g2*r + 1188*D1**2*fdd*g2*s**2 - 792*D1**2*fdd*g2*s + 396*D1**2*fdd*g2 - 7524*D1*Dd*K*f**2*r**2 - 1848*D1*Dd*K*f**2*r*s + 7986*D1*Dd*K*f**2*r + 5676*D1*Dd*K*f**2*s**2 - 1914*D1*Dd*K*f**2*s - 2343*D1*Dd*K*f**2 + 23760*D1*Dd*K*f*fd*r**2 + 11616*D1*Dd*K*f*fd*r*s - 16236*D1*Dd*K*f*fd*r - 12144*D1*Dd*K*f*fd*s**2 + 6204*D1*Dd*K*f*fd*s - 66*D1*Dd*K*f*fd + 4280*D1*Dd*f**3*r**2 + 3160*D1*Dd*f**3*r*s - 5070*D1*Dd*f**3*r - 1120*D1*Dd*f**3*s**2 - 1020*D1*Dd*f**3*s + 1860*D1*Dd*f**3 - 16800*D1*Dd*f**2*fd*r**2 - 13440*D1*Dd*f**2*fd*r*s + 17920*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 + 3640*D1*Dd*f**2*fd*s - 4200*D1*Dd*f**2*fd + 8580*D1*Dd*f**2*r**2 + 5016*D1*Dd*f**2*r*s - 9834*D1*Dd*f**2*r - 3564*D1*Dd*f**2*s**2 - 726*D1*Dd*f**2*s + 3399*D1*Dd*f**2 - 29040*D1*Dd*f*fd*r**2 - 27456*D1*Dd*f*fd*r*s + 24816*D1*Dd*f*fd*r + 1584*D1*Dd*f*fd*s**2 + 5676*D1*Dd*f*fd*s - 3234*D1*Dd*f*fd - 3168*D1*Dd*f*g2*r**2 - 12672*D1*Dd*f*g2*r*s + 6336*D1*Dd*f*g2*r - 9504*D1*Dd*f*g2*s**2 + 11088*D1*Dd*f*g2*s - 3960*D1*Dd*f*g2 + 3168*D1*Dd*f*gd2*r**2 + 12672*D1*Dd*f*gd2*r*s - 6336*D1*Dd*f*gd2*r + 9504*D1*Dd*f*gd2*s**2 - 11880*D1*Dd*f*gd2*s + 3168*D1*Dd*f*gd2 + 3168*D1*Dd*fd*g2*r**2 + 12672*D1*Dd*fd*g2*r*s - 6336*D1*Dd*fd*g2*r + 9504*D1*Dd*fd*g2*s**2 - 8712*D1*Dd*fd*g2*s + 2376*D1*Dd*fd*g2 + 5940*D1*Ddd*K*f**2*r**2 + 2904*D1*Ddd*K*f**2*r*s - 6666*D1*Ddd*K*f**2*r - 3036*D1*Ddd*K*f**2*s**2 + 66*D1*Ddd*K*f**2*s + 2211*D1*Ddd*K*f**2 - 2800*D1*Ddd*f**3*r**2 - 2240*D1*Ddd*f**3*r*s + 3360*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 1260*D1*Ddd*f**3 - 7260*D1*Ddd*f**2*r**2 - 6864*D1*Ddd*f**2*r*s + 8976*D1*Ddd*f**2*r + 396*D1*Ddd*f**2*s**2 + 3234*D1*Ddd*f**2*s - 3531*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r**2 + 6336*D1*Ddd*f*g2*r*s - 3168*D1*Ddd*f*g2*r + 4752*D1*Ddd*f*g2*s**2 - 5544*D1*Ddd*f*g2*s + 1980*D1*Ddd*f*g2 + 396*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) - fd*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 6*s + 1)) - 2*Dd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 17820*Dd**2*K*f**2*r**2 + 8712*Dd**2*K*f**2*r*s - 19998*Dd**2*K*f**2*r - 9108*Dd**2*K*f**2*s**2 + 198*Dd**2*K*f**2*s + 4422*Dd**2*K*f**2 - 8400*Dd**2*f**3*r**2 - 6720*Dd**2*f**3*r*s + 10080*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 2520*Dd**2*f**3 - 21780*Dd**2*f**2*r**2 - 20592*Dd**2*f**2*r*s + 26928*Dd**2*f**2*r + 1188*Dd**2*f**2*s**2 + 9702*Dd**2*f**2*s - 7062*Dd**2*f**2 + 4752*Dd**2*f*g2*r**2 + 19008*Dd**2*f*g2*r*s - 9504*Dd**2*f*g2*r + 14256*Dd**2*f*g2*s**2 - 16632*Dd**2*f*g2*s + 3960*Dd**2*f*g2))/(693*d**2*k3**6) - 20*D1**2*Pk2*Pk3*ct**6*k1**2*st**2*(D1**2*(1372*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 3*f**2*(2744*fd**2*s*(2*s - 1) - fd*(1300*C - 1300)*(3*s**2 - 2*s + 1) + fdd*(650*C - 650)*(3*s**2 - 2*s + 1) + s**2*(429*K*bdd1 - 858*bd1*(K - 1) - 429*bdd1 + 1716*gd2 - 858*gdd2)) - 78*f*(fd**2*s*(50*C - 50)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 5148*fd**2*g2*s*(s - 1)) + 2*D1*f*(Dd*(1372*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(975*C*(4*s**2 - 2*s + 1) - 686*fd*(1 - 4*s)**2 - 3900*s**2 + 1950*s - 975) - 39*f*(fd*(50*C - 50)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 2574*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(686*f**2 + f*(975*C - 975) - 1287*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(2*s - 1)*(686*f**2 + f*(975*C - 975) - 1287*g2) + 1287*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(3003*d**2*k3**4) - 16*D1**2*Pk2*Pk3*ct**6*k1**2*(D1**2*(396*bd1*fd*g2*s*(s - 1) + f**3*s**2*(420*bd1 - 210*bdd1) - 5*f**2*(C*s**2*(-66*bd1 + 33*bdd1) + 28*fd*(s**2*(9*bd1 - 6) + s*(4 - 3*bd1) - 2) + 28*fdd*(3*s**2 - 2*s + 1)) - 2*f*s*(99*bd1**2*s*(K - 1) + 33*bd1*(5*C*fd*(2*s - 1) + s*(6*g2 - 6*gd2)) - 99*bdd1*g2*s + 140*fd**2*(3*s - 2))) - 2*D1*f*(Dd*(198*bd1*g2*s*(1 - 4*s) + 70*f**2*(s**2*(12*bd1 - 8) + s*(4 - 3*bd1) - 2) + 5*f*(4*s - 1)*(33*C*bd1*s + 28*fd*(3*s - 1))) + 70*Ddd*f**2*(4*s**2 - 2*s + 1)) + 840*Dd**2*f**3*s*(1 - 2*s) + 99*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(55*C*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + 2*D1**2*(35*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*s*(-70*fd**2*(3*s - 2) + s*(-33*K*bdd1 + 66*bd1*(K - 1) + 33*bdd1 - 66*gd2 + 33*gdd2)) + (33 - 33*s)*(2*fd*g2*(s - 1) - 2*fd*s*(-K*bd1 + bd1 + gd2) - fdd*g2*(s - 1))) + 2*D1*(2*Dd*(35*f**3*(4*s**2 - 2*s + 1) - 35*f**2*fd*(12*s**2 - 7*s + 1) - 33*f*g2*(4*s**2 - 2*s + 1) + 33*f*s*(4*s - 1)*(-K*bd1 + bd1 + gd2) + 33*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(35*f**2 - 33*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f*s*(35*f**2 - 33*g2)*(2*s - 1)))/(231*d**2*k2**2*k3**2) - 40*D1**2*Pk2*Pk3*ct**6*k2**6*(D1**2*(f**2*(fd*(112*C - 56)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(56*C - 28)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(112*C - 56)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 66*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(56*C - 28)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(33*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(28 - 56*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 33*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(56*C*f + 33*K*b1 - 28*f - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(56*C*f + 33*K*b1 - 28*f - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(231*d**2*k3**8) + 40*D1**2*Pk2*Pk3*ct**6*k2**4*(1248*C*D1**2*f**2*fd*r**2 + 1584*C*D1**2*f**2*fd*r*s - 1360*C*D1**2*f**2*fd*r + 336*C*D1**2*f**2*fd*s**2 - 752*C*D1**2*f**2*fd*s + 528*C*D1**2*f**2*fd - 624*C*D1**2*f**2*fdd*r**2 - 792*C*D1**2*f**2*fdd*r*s + 680*C*D1**2*f**2*fdd*r - 168*C*D1**2*f**2*fdd*s**2 + 376*C*D1**2*f**2*fdd*s - 264*C*D1**2*f**2*fdd - 1248*C*D1**2*f*fd**2*r**2 - 1584*C*D1**2*f*fd**2*r*s + 1360*C*D1**2*f*fd**2*r - 336*C*D1**2*f*fd**2*s**2 + 752*C*D1**2*f*fd**2*s - 264*C*D1**2*f*fd**2 + 1664*C*D1*Dd*f**3*r**2 + 2112*C*D1*Dd*f**3*r*s - 2192*C*D1*Dd*f**3*r + 448*C*D1*Dd*f**3*s**2 - 1280*C*D1*Dd*f**3*s + 944*C*D1*Dd*f**3 - 4992*C*D1*Dd*f**2*fd*r**2 - 6336*C*D1*Dd*f**2*fd*r*s + 6008*C*D1*Dd*f**2*fd*r - 1344*C*D1*Dd*f**2*fd*s**2 + 3424*C*D1*Dd*f**2*fd*s - 1736*C*D1*Dd*f**2*fd - 832*C*D1*Ddd*f**3*r**2 - 1056*C*D1*Ddd*f**3*r*s + 1096*C*D1*Ddd*f**3*r - 224*C*D1*Ddd*f**3*s**2 + 640*C*D1*Ddd*f**3*s - 472*C*D1*Ddd*f**3 - 2496*C*Dd**2*f**3*r**2 - 3168*C*Dd**2*f**3*r*s + 3288*C*Dd**2*f**3*r - 672*C*Dd**2*f**3*s**2 + 1920*C*Dd**2*f**3*s - 944*C*Dd**2*f**3 + 396*D1**2*K*b1*f*fd*r**2 + 528*D1**2*K*b1*f*fd*r*s - 264*D1**2*K*b1*f*fd*r + 132*D1**2*K*b1*f*fd*s**2 - 132*D1**2*K*b1*f*fd*s + 66*D1**2*K*b1*f*fd - 198*D1**2*K*b1*f*fdd*r**2 - 264*D1**2*K*b1*f*fdd*r*s + 132*D1**2*K*b1*f*fdd*r - 66*D1**2*K*b1*f*fdd*s**2 + 66*D1**2*K*b1*f*fdd*s - 33*D1**2*K*b1*f*fdd - 198*D1**2*K*b1*fd**2*r**2 - 264*D1**2*K*b1*fd**2*r*s + 132*D1**2*K*b1*fd**2*r - 66*D1**2*K*b1*fd**2*s**2 + 66*D1**2*K*b1*fd**2*s - 99*D1**2*K*bdd1*f**2*r**2 - 132*D1**2*K*bdd1*f**2*r*s + 198*D1**2*K*bdd1*f**2*r - 33*D1**2*K*bdd1*f**2*s**2 + 132*D1**2*K*bdd1*f**2*s - 99*D1**2*K*bdd1*f**2 - 99*D1**2*b1*f**2*fd*r**2 - 99*D1**2*b1*f**2*fd*r*s + 99*D1**2*b1*f**2*fd*r + 33*D1**2*b1*f**2*fd*s - 33*D1**2*b1*f**2*fd + 99*D1**2*b1*f**2*fdd*r**2 + 99*D1**2*b1*f**2*fdd*r*s - 99*D1**2*b1*f**2*fdd*r - 33*D1**2*b1*f**2*fdd*s + 33*D1**2*b1*f**2*fdd + 198*D1**2*b1*f*fd**2*r**2 + 198*D1**2*b1*f*fd**2*r*s - 198*D1**2*b1*f*fd**2*r - 66*D1**2*b1*f*fd**2*s + 33*D1**2*b1*f*fd**2 - 132*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fdd*r**2 + 66*D1**2*b1*f*fdd*r*s - 33*D1**2*b1*f*fdd*r + 66*D1**2*b1*fd**2*r**2 + 66*D1**2*b1*fd**2*r*s - 33*D1**2*b1*fd**2*r + 132*D1**2*b2*f*fd*r**2 + 264*D1**2*b2*f*fd*r*s - 132*D1**2*b2*f*fd*r + 132*D1**2*b2*f*fd*s**2 - 132*D1**2*b2*f*fd*s + 66*D1**2*b2*f*fd - 66*D1**2*b2*f*fdd*r**2 - 132*D1**2*b2*f*fdd*r*s + 66*D1**2*b2*f*fdd*r - 66*D1**2*b2*f*fdd*s**2 + 66*D1**2*b2*f*fdd*s - 33*D1**2*b2*f*fdd - 66*D1**2*b2*fd**2*r**2 - 132*D1**2*b2*fd**2*r*s + 66*D1**2*b2*fd**2*r - 66*D1**2*b2*fd**2*s**2 + 66*D1**2*b2*fd**2*s + 33*D1**2*bdd1*f**3*r**2 + 33*D1**2*bdd1*f**3*r*s - 66*D1**2*bdd1*f**3*r - 33*D1**2*bdd1*f**3*s + 33*D1**2*bdd1*f**3 + 33*D1**2*bdd1*f**2*r**2 + 33*D1**2*bdd1*f**2*r*s - 66*D1**2*bdd1*f**2*r - 33*D1**2*bdd1*f**2*s + 33*D1**2*bdd1*f**2 - 33*D1**2*bdd2*f**2*r**2 - 66*D1**2*bdd2*f**2*r*s + 66*D1**2*bdd2*f**2*r - 33*D1**2*bdd2*f**2*s**2 + 66*D1**2*bdd2*f**2*s - 33*D1**2*bdd2*f**2 - 852*D1**2*f**2*fd*r**2 - 1020*D1**2*f**2*fd*r*s + 908*D1**2*f**2*fd*r - 168*D1**2*f**2*fd*s**2 + 452*D1**2*f**2*fd*s - 340*D1**2*f**2*fd + 426*D1**2*f**2*fdd*r**2 + 510*D1**2*f**2*fdd*r*s - 454*D1**2*f**2*fdd*r + 84*D1**2*f**2*fdd*s**2 - 226*D1**2*f**2*fdd*s + 170*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 132*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 198*D1**2*f**2*gdd2*r**2 + 264*D1**2*f**2*gdd2*r*s - 396*D1**2*f**2*gdd2*r + 66*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 198*D1**2*f**2*gdd2 + 852*D1**2*f*fd**2*r**2 + 1020*D1**2*f*fd**2*r*s - 908*D1**2*f*fd**2*r + 168*D1**2*f*fd**2*s**2 - 452*D1**2*f*fd**2*s + 170*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 792*D1**2*f*fd*gd2*r**2 + 1056*D1**2*f*fd*gd2*r*s - 1056*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 660*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 396*D1**2*f*fdd*g2*r**2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 396*D1**2*fd**2*g2*r**2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 792*D1*Dd*K*b1*f**2*r**2 + 1056*D1*Dd*K*b1*f**2*r*s - 1056*D1*Dd*K*b1*f**2*r + 264*D1*Dd*K*b1*f**2*s**2 - 660*D1*Dd*K*b1*f**2*s + 462*D1*Dd*K*b1*f**2 - 1584*D1*Dd*K*b1*f*fd*r**2 - 2112*D1*Dd*K*b1*f*fd*r*s + 1584*D1*Dd*K*b1*f*fd*r - 528*D1*Dd*K*b1*f*fd*s**2 + 924*D1*Dd*K*b1*f*fd*s - 330*D1*Dd*K*b1*f*fd - 132*D1*Dd*b1*f**3*r**2 - 132*D1*Dd*b1*f**3*r*s + 165*D1*Dd*b1*f**3*r + 66*D1*Dd*b1*f**3*s - 66*D1*Dd*b1*f**3 + 792*D1*Dd*b1*f**2*fd*r**2 + 792*D1*Dd*b1*f**2*fd*r*s - 891*D1*Dd*b1*f**2*fd*r - 330*D1*Dd*b1*f**2*fd*s + 231*D1*Dd*b1*f**2*fd - 264*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 330*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2*s - 132*D1*Dd*b1*f**2 + 528*D1*Dd*b1*f*fd*r**2 + 528*D1*Dd*b1*f*fd*r*s - 462*D1*Dd*b1*f*fd*r - 132*D1*Dd*b1*f*fd*s + 66*D1*Dd*b1*f*fd + 264*D1*Dd*b2*f**2*r**2 + 528*D1*Dd*b2*f**2*r*s - 396*D1*Dd*b2*f**2*r + 264*D1*Dd*b2*f**2*s**2 - 396*D1*Dd*b2*f**2*s + 198*D1*Dd*b2*f**2 - 528*D1*Dd*b2*f*fd*r**2 - 1056*D1*Dd*b2*f*fd*r*s + 660*D1*Dd*b2*f*fd*r - 528*D1*Dd*b2*f*fd*s**2 + 660*D1*Dd*b2*f*fd*s - 198*D1*Dd*b2*f*fd - 1136*D1*Dd*f**3*r**2 - 1360*D1*Dd*f**3*r*s + 1476*D1*Dd*f**3*r - 224*D1*Dd*f**3*s**2 + 792*D1*Dd*f**3*s - 624*D1*Dd*f**3 + 3408*D1*Dd*f**2*fd*r**2 + 4080*D1*Dd*f**2*fd*r*s - 4030*D1*Dd*f**2*fd*r + 672*D1*Dd*f**2*fd*s**2 - 2092*D1*Dd*f**2*fd*s + 1134*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s + 2112*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 1320*D1*Dd*f**2*g2*s - 924*D1*Dd*f**2*g2 + 1584*D1*Dd*f**2*gd2*r**2 + 2112*D1*Dd*f**2*gd2*r*s - 2640*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 1716*D1*Dd*f**2*gd2*s + 1056*D1*Dd*f**2*gd2 + 3168*D1*Dd*f*fd*g2*r**2 + 4224*D1*Dd*f*fd*g2*r*s - 3168*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1848*D1*Dd*f*fd*g2*s + 660*D1*Dd*f*fd*g2 - 396*D1*Ddd*K*b1*f**2*r**2 - 528*D1*Ddd*K*b1*f**2*r*s + 528*D1*Ddd*K*b1*f**2*r - 132*D1*Ddd*K*b1*f**2*s**2 + 330*D1*Ddd*K*b1*f**2*s - 231*D1*Ddd*K*b1*f**2 + 132*D1*Ddd*b1*f**3*r**2 + 132*D1*Ddd*b1*f**3*r*s - 165*D1*Ddd*b1*f**3*r - 66*D1*Ddd*b1*f**3*s + 66*D1*Ddd*b1*f**3 + 132*D1*Ddd*b1*f**2*r**2 + 132*D1*Ddd*b1*f**2*r*s - 165*D1*Ddd*b1*f**2*r - 66*D1*Ddd*b1*f**2*s + 66*D1*Ddd*b1*f**2 - 132*D1*Ddd*b2*f**2*r**2 - 264*D1*Ddd*b2*f**2*r*s + 198*D1*Ddd*b2*f**2*r - 132*D1*Ddd*b2*f**2*s**2 + 198*D1*Ddd*b2*f**2*s - 99*D1*Ddd*b2*f**2 + 568*D1*Ddd*f**3*r**2 + 680*D1*Ddd*f**3*r*s - 738*D1*Ddd*f**3*r + 112*D1*Ddd*f**3*s**2 - 396*D1*Ddd*f**3*s + 312*D1*Ddd*f**3 + 792*D1*Ddd*f**2*g2*r**2 + 1056*D1*Ddd*f**2*g2*r*s - 1056*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 660*D1*Ddd*f**2*g2*s + 462*D1*Ddd*f**2*g2 - 33*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (2*r + 2*s - 2)*(K*(3*r + s - 3) - r + 1)) + fd*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(2*K*(12*r**2 + 4*r*(4*s - 5) + 4*s**2 - 13*s + 8) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) + 66*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 1188*Dd**2*K*b1*f**2*r**2 - 1584*Dd**2*K*b1*f**2*r*s + 1584*Dd**2*K*b1*f**2*r - 396*Dd**2*K*b1*f**2*s**2 + 990*Dd**2*K*b1*f**2*s - 462*Dd**2*K*b1*f**2 + 396*Dd**2*b1*f**3*r**2 + 396*Dd**2*b1*f**3*r*s - 495*Dd**2*b1*f**3*r - 198*Dd**2*b1*f**3*s + 132*Dd**2*b1*f**3 + 396*Dd**2*b1*f**2*r**2 + 396*Dd**2*b1*f**2*r*s - 495*Dd**2*b1*f**2*r - 198*Dd**2*b1*f**2*s + 132*Dd**2*b1*f**2 - 396*Dd**2*b2*f**2*r**2 - 792*Dd**2*b2*f**2*r*s + 594*Dd**2*b2*f**2*r - 396*Dd**2*b2*f**2*s**2 + 594*Dd**2*b2*f**2*s - 198*Dd**2*b2*f**2 + 1704*Dd**2*f**3*r**2 + 2040*Dd**2*f**3*r*s - 2214*Dd**2*f**3*r + 336*Dd**2*f**3*s**2 - 1188*Dd**2*f**3*s + 624*Dd**2*f**3 + 2376*Dd**2*f**2*g2*r**2 + 3168*Dd**2*f**2*g2*r*s - 3168*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 1980*Dd**2*f**2*g2*s + 924*Dd**2*f**2*g2)/(693*d**2*k3**6) - 600*D1**2*Pk2*Pk3*ct**5*f**2*k1**5*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(143*d**2*k2**3*k3**4) + D1**2*Pk2*Pk3*ct**5*f*k2**5*(800*C - 400)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4))/(693*d**2*k1*k3**6) - 16*D1**2*Pk2*Pk3*ct**5*k1**5*k2*(17940*C*D1**2*f**2*fd*r**2 + 35880*C*D1**2*f**2*fd*r*s - 23920*C*D1**2*f**2*fd*r + 17940*C*D1**2*f**2*fd*s**2 - 23920*C*D1**2*f**2*fd*s + 11960*C*D1**2*f**2*fd - 21840*C*D1**2*f**2*fdd*r**2 - 43680*C*D1**2*f**2*fdd*r*s + 29120*C*D1**2*f**2*fdd*r - 21840*C*D1**2*f**2*fdd*s**2 + 29120*C*D1**2*f**2*fdd*s - 14560*C*D1**2*f**2*fdd - 43680*C*D1**2*f*fd**2*r**2 - 87360*C*D1**2*f*fd**2*r*s + 58240*C*D1**2*f*fd**2*r - 43680*C*D1**2*f*fd**2*s**2 + 58240*C*D1**2*f*fd**2*s - 14560*C*D1**2*f*fd**2 + 23920*C*D1*Dd*f**3*r**2 + 47840*C*D1*Dd*f**3*r*s - 35880*C*D1*Dd*f**3*r + 23920*C*D1*Dd*f**3*s**2 - 35880*C*D1*Dd*f**3*s + 17940*C*D1*Dd*f**3 - 174720*C*D1*Dd*f**2*fd*r**2 - 349440*C*D1*Dd*f**2*fd*r*s + 247520*C*D1*Dd*f**2*fd*r - 174720*C*D1*Dd*f**2*fd*s**2 + 247520*C*D1*Dd*f**2*fd*s - 87360*C*D1*Dd*f**2*fd - 29120*C*D1*Ddd*f**3*r**2 - 58240*C*D1*Ddd*f**3*r*s + 43680*C*D1*Ddd*f**3*r - 29120*C*D1*Ddd*f**3*s**2 + 43680*C*D1*Ddd*f**3*s - 21840*C*D1*Ddd*f**3 - 87360*C*Dd**2*f**3*r**2 - 174720*C*Dd**2*f**3*r*s + 131040*C*Dd**2*f**3*r - 87360*C*Dd**2*f**3*s**2 + 131040*C*Dd**2*f**3*s - 43680*C*Dd**2*f**3 + 6864*D1**2*K*b1*f*fd*r**2 + 13728*D1**2*K*b1*f*fd*r*s - 6864*D1**2*K*b1*f*fd*r + 6864*D1**2*K*b1*f*fd*s**2 - 6864*D1**2*K*b1*f*fd*s + 3432*D1**2*K*b1*f*fd - 8580*D1**2*K*b1*f*fdd*r**2 - 17160*D1**2*K*b1*f*fdd*r*s + 8580*D1**2*K*b1*f*fdd*r - 8580*D1**2*K*b1*f*fdd*s**2 + 8580*D1**2*K*b1*f*fdd*s - 4290*D1**2*K*b1*f*fdd - 8580*D1**2*K*b1*fd**2*r**2 - 17160*D1**2*K*b1*fd**2*r*s + 8580*D1**2*K*b1*fd**2*r - 8580*D1**2*K*b1*fd**2*s**2 + 8580*D1**2*K*b1*fd**2*s - 6864*D1**2*b1*f*fd*r**2 - 13728*D1**2*b1*f*fd*r*s + 6864*D1**2*b1*f*fd*r - 6864*D1**2*b1*f*fd*s**2 + 6864*D1**2*b1*f*fd*s - 3432*D1**2*b1*f*fd + 8580*D1**2*b1*f*fdd*r**2 + 17160*D1**2*b1*f*fdd*r*s - 8580*D1**2*b1*f*fdd*r + 8580*D1**2*b1*f*fdd*s**2 - 8580*D1**2*b1*f*fdd*s + 4290*D1**2*b1*f*fdd + 8580*D1**2*b1*fd**2*r**2 + 17160*D1**2*b1*fd**2*r*s - 8580*D1**2*b1*fd**2*r + 8580*D1**2*b1*fd**2*s**2 - 8580*D1**2*b1*fd**2*s - 4290*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 30240*D1**2*f**3*fd*r**2 + 60480*D1**2*f**3*fd*r*s - 45360*D1**2*f**3*fd*r + 30240*D1**2*f**3*fd*s**2 - 45360*D1**2*f**3*fd*s + 22680*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 - 17940*D1**2*f**2*fd*r**2 - 35880*D1**2*f**2*fd*r*s + 23920*D1**2*f**2*fd*r - 17940*D1**2*f**2*fd*s**2 + 23920*D1**2*f**2*fd*s - 11960*D1**2*f**2*fd + 21840*D1**2*f**2*fdd*r**2 + 43680*D1**2*f**2*fdd*r*s - 29120*D1**2*f**2*fdd*r + 21840*D1**2*f**2*fdd*s**2 - 29120*D1**2*f**2*fdd*s + 14560*D1**2*f**2*fdd - 6864*D1**2*f**2*gd2*r**2 - 13728*D1**2*f**2*gd2*r*s + 13728*D1**2*f**2*gd2*r - 6864*D1**2*f**2*gd2*s**2 + 13728*D1**2*f**2*gd2*s - 6864*D1**2*f**2*gd2 + 8580*D1**2*f**2*gdd2*r**2 + 17160*D1**2*f**2*gdd2*r*s - 17160*D1**2*f**2*gdd2*r + 8580*D1**2*f**2*gdd2*s**2 - 17160*D1**2*f**2*gdd2*s + 8580*D1**2*f**2*gdd2 + 43680*D1**2*f*fd**2*r**2 + 87360*D1**2*f*fd**2*r*s - 58240*D1**2*f*fd**2*r + 43680*D1**2*f*fd**2*s**2 - 58240*D1**2*f*fd**2*s + 14560*D1**2*f*fd**2 - 13728*D1**2*f*fd*g2*r**2 - 27456*D1**2*f*fd*g2*r*s + 13728*D1**2*f*fd*g2*r - 13728*D1**2*f*fd*g2*s**2 + 13728*D1**2*f*fd*g2*s - 6864*D1**2*f*fd*g2 + 34320*D1**2*f*fd*gd2*r**2 + 68640*D1**2*f*fd*gd2*r*s - 51480*D1**2*f*fd*gd2*r + 34320*D1**2*f*fd*gd2*s**2 - 51480*D1**2*f*fd*gd2*s + 17160*D1**2*f*fd*gd2 + 17160*D1**2*f*fdd*g2*r**2 + 34320*D1**2*f*fdd*g2*r*s - 17160*D1**2*f*fdd*g2*r + 17160*D1**2*f*fdd*g2*s**2 - 17160*D1**2*f*fdd*g2*s + 8580*D1**2*f*fdd*g2 + 17160*D1**2*fd**2*g2*r**2 + 34320*D1**2*fd**2*g2*r*s - 17160*D1**2*fd**2*g2*r + 17160*D1**2*fd**2*g2*s**2 - 17160*D1**2*fd**2*g2*s + 13728*D1*Dd*K*b1*f**2*r**2 + 27456*D1*Dd*K*b1*f**2*r*s - 20592*D1*Dd*K*b1*f**2*r + 13728*D1*Dd*K*b1*f**2*s**2 - 20592*D1*Dd*K*b1*f**2*s + 10296*D1*Dd*K*b1*f**2 - 68640*D1*Dd*K*b1*f*fd*r**2 - 137280*D1*Dd*K*b1*f*fd*r*s + 85800*D1*Dd*K*b1*f*fd*r - 68640*D1*Dd*K*b1*f*fd*s**2 + 85800*D1*Dd*K*b1*f*fd*s - 25740*D1*Dd*K*b1*f*fd - 13728*D1*Dd*b1*f**2*r**2 - 27456*D1*Dd*b1*f**2*r*s + 20592*D1*Dd*b1*f**2*r - 13728*D1*Dd*b1*f**2*s**2 + 20592*D1*Dd*b1*f**2*s - 10296*D1*Dd*b1*f**2 + 68640*D1*Dd*b1*f*fd*r**2 + 137280*D1*Dd*b1*f*fd*r*s - 85800*D1*Dd*b1*f*fd*r + 68640*D1*Dd*b1*f*fd*s**2 - 85800*D1*Dd*b1*f*fd*s + 25740*D1*Dd*b1*f*fd + 30240*D1*Dd*f**4*r**2 + 60480*D1*Dd*f**4*r*s - 45360*D1*Dd*f**4*r + 30240*D1*Dd*f**4*s**2 - 45360*D1*Dd*f**4*s + 22680*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd - 23920*D1*Dd*f**3*r**2 - 47840*D1*Dd*f**3*r*s + 35880*D1*Dd*f**3*r - 23920*D1*Dd*f**3*s**2 + 35880*D1*Dd*f**3*s - 17940*D1*Dd*f**3 + 174720*D1*Dd*f**2*fd*r**2 + 349440*D1*Dd*f**2*fd*r*s - 247520*D1*Dd*f**2*fd*r + 174720*D1*Dd*f**2*fd*s**2 - 247520*D1*Dd*f**2*fd*s + 87360*D1*Dd*f**2*fd - 27456*D1*Dd*f**2*g2*r**2 - 54912*D1*Dd*f**2*g2*r*s + 41184*D1*Dd*f**2*g2*r - 27456*D1*Dd*f**2*g2*s**2 + 41184*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*g2 + 68640*D1*Dd*f**2*gd2*r**2 + 137280*D1*Dd*f**2*gd2*r*s - 120120*D1*Dd*f**2*gd2*r + 68640*D1*Dd*f**2*gd2*s**2 - 120120*D1*Dd*f**2*gd2*s + 51480*D1*Dd*f**2*gd2 + 137280*D1*Dd*f*fd*g2*r**2 + 274560*D1*Dd*f*fd*g2*r*s - 171600*D1*Dd*f*fd*g2*r + 137280*D1*Dd*f*fd*g2*s**2 - 171600*D1*Dd*f*fd*g2*s + 51480*D1*Dd*f*fd*g2 - 17160*D1*Ddd*K*b1*f**2*r**2 - 34320*D1*Ddd*K*b1*f**2*r*s + 25740*D1*Ddd*K*b1*f**2*r - 17160*D1*Ddd*K*b1*f**2*s**2 + 25740*D1*Ddd*K*b1*f**2*s - 12870*D1*Ddd*K*b1*f**2 + 17160*D1*Ddd*b1*f**2*r**2 + 34320*D1*Ddd*b1*f**2*r*s - 25740*D1*Ddd*b1*f**2*r + 17160*D1*Ddd*b1*f**2*s**2 - 25740*D1*Ddd*b1*f**2*s + 12870*D1*Ddd*b1*f**2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 29120*D1*Ddd*f**3*r**2 + 58240*D1*Ddd*f**3*r*s - 43680*D1*Ddd*f**3*r + 29120*D1*Ddd*f**3*s**2 - 43680*D1*Ddd*f**3*s + 21840*D1*Ddd*f**3 + 34320*D1*Ddd*f**2*g2*r**2 + 68640*D1*Ddd*f**2*g2*r*s - 51480*D1*Ddd*f**2*g2*r + 34320*D1*Ddd*f**2*g2*s**2 - 51480*D1*Ddd*f**2*g2*s + 25740*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 51480*Dd**2*K*b1*f**2*r**2 - 102960*Dd**2*K*b1*f**2*r*s + 77220*Dd**2*K*b1*f**2*r - 51480*Dd**2*K*b1*f**2*s**2 + 77220*Dd**2*K*b1*f**2*s - 25740*Dd**2*K*b1*f**2 + 51480*Dd**2*b1*f**2*r**2 + 102960*Dd**2*b1*f**2*r*s - 77220*Dd**2*b1*f**2*r + 51480*Dd**2*b1*f**2*s**2 - 77220*Dd**2*b1*f**2*s + 25740*Dd**2*b1*f**2 - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 87360*Dd**2*f**3*r**2 + 174720*Dd**2*f**3*r*s - 131040*Dd**2*f**3*r + 87360*Dd**2*f**3*s**2 - 131040*Dd**2*f**3*s + 43680*Dd**2*f**3 + 102960*Dd**2*f**2*g2*r**2 + 205920*Dd**2*f**2*g2*r*s - 154440*Dd**2*f**2*g2*r + 102960*Dd**2*f**2*g2*s**2 - 154440*Dd**2*f**2*g2*s + 51480*Dd**2*f**2*g2)/(3003*d**2*k3**8) - 32*D1**2*Pk2*Pk3*ct**5*k1**5*(8970*C*D1**2*f**2*fd*r*s - 2990*C*D1**2*f**2*fd*r + 8970*C*D1**2*f**2*fd*s**2 - 8970*C*D1**2*f**2*fd*s + 2990*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r*s + 3640*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 10920*C*D1**2*f**2*fdd*s - 3640*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r*s + 7280*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 21840*C*D1**2*f*fd**2*s - 3640*C*D1**2*f*fd**2 + 11960*C*D1*Dd*f**3*r*s - 2990*C*D1*Dd*f**3*r + 11960*C*D1*Dd*f**3*s**2 - 11960*C*D1*Dd*f**3*s + 2990*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r*s + 25480*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 87360*C*D1*Dd*f**2*fd*s - 18200*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r*s + 3640*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 14560*C*D1*Ddd*f**3*s - 3640*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r*s + 10920*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 43680*C*Dd**2*f**3*s - 7280*C*Dd**2*f**3 - 2145*D1**2*K*bdd1*f**2*r*s - 2145*D1**2*K*bdd1*f**2*s**2 + 2145*D1**2*K*bdd1*f**2*s + 2145*D1**2*bdd1*f**2*r*s + 2145*D1**2*bdd1*f**2*s**2 - 2145*D1**2*bdd1*f**2*s + 28560*D1**2*f**3*fd*r*s - 7140*D1**2*f**3*fd*r + 28560*D1**2*f**3*fd*s**2 - 28560*D1**2*f**3*fd*s + 7140*D1**2*f**3*fd - 25200*D1**2*f**3*fdd*r*s + 6300*D1**2*f**3*fdd*r - 25200*D1**2*f**3*fdd*s**2 + 25200*D1**2*f**3*fdd*s - 6300*D1**2*f**3*fdd - 75600*D1**2*f**2*fd**2*r*s + 18900*D1**2*f**2*fd**2*r - 75600*D1**2*f**2*fd**2*s**2 + 75600*D1**2*f**2*fd**2*s - 12600*D1**2*f**2*fd**2 - 8970*D1**2*f**2*fd*r*s + 2990*D1**2*f**2*fd*r - 8970*D1**2*f**2*fd*s**2 + 8970*D1**2*f**2*fd*s - 2990*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r*s - 3640*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 10920*D1**2*f**2*fdd*s + 3640*D1**2*f**2*fdd - 3432*D1**2*f**2*gd2*r*s - 3432*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s + 4290*D1**2*f**2*gdd2*r*s + 4290*D1**2*f**2*gdd2*s**2 - 4290*D1**2*f**2*gdd2*s + 21840*D1**2*f*fd**2*r*s - 7280*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 21840*D1**2*f*fd**2*s + 3640*D1**2*f*fd**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 6864*D1**2*f*fd*g2*s**2 + 6864*D1**2*f*fd*g2*s - 3432*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r*s - 4290*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 17160*D1**2*f*fd*gd2*s + 4290*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r*s - 4290*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r*s - 4290*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 28560*D1*Dd*f**4*r*s - 7140*D1*Dd*f**4*r + 28560*D1*Dd*f**4*s**2 - 28560*D1*Dd*f**4*s + 7140*D1*Dd*f**4 - 201600*D1*Dd*f**3*fd*r*s + 50400*D1*Dd*f**3*fd*r - 201600*D1*Dd*f**3*fd*s**2 + 201600*D1*Dd*f**3*fd*s - 37800*D1*Dd*f**3*fd - 11960*D1*Dd*f**3*r*s + 2990*D1*Dd*f**3*r - 11960*D1*Dd*f**3*s**2 + 11960*D1*Dd*f**3*s - 2990*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r*s - 25480*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 87360*D1*Dd*f**2*fd*s + 18200*D1*Dd*f**2*fd - 13728*D1*Dd*f**2*g2*r*s + 3432*D1*Dd*f**2*g2*r - 13728*D1*Dd*f**2*g2*s**2 + 13728*D1*Dd*f**2*g2*s - 3432*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r*s - 4290*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 34320*D1*Dd*f**2*gd2*s + 4290*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r*s - 25740*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 68640*D1*Dd*f*fd*g2*s + 17160*D1*Dd*f*fd*g2 - 25200*D1*Ddd*f**4*r*s + 6300*D1*Ddd*f**4*r - 25200*D1*Ddd*f**4*s**2 + 25200*D1*Ddd*f**4*s - 6300*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r*s - 3640*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 14560*D1*Ddd*f**3*s + 3640*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r*s - 4290*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 17160*D1*Ddd*f**2*g2*s + 4290*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(4*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 75600*Dd**2*f**4*r*s + 18900*Dd**2*f**4*r - 75600*Dd**2*f**4*s**2 + 75600*Dd**2*f**4*s - 12600*Dd**2*f**4 + 43680*Dd**2*f**3*r*s - 10920*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 43680*Dd**2*f**3*s + 7280*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r*s - 12870*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 51480*Dd**2*f**2*g2*s + 8580*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(4*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 5*fd*(8*r*s - 3*r + 8*s**2 - 8*s + 2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k2*k3**6) - 4*D1**2*Pk2*Pk3*ct**5*k1**3*k2**3*st**2*(125112*C*D1**2*f**2*fd*r**2 + 250224*C*D1**2*f**2*fd*r*s - 166816*C*D1**2*f**2*fd*r + 125112*C*D1**2*f**2*fd*s**2 - 166816*C*D1**2*f**2*fd*s + 83408*C*D1**2*f**2*fd - 78000*C*D1**2*f**2*fdd*r**2 - 156000*C*D1**2*f**2*fdd*r*s + 104000*C*D1**2*f**2*fdd*r - 78000*C*D1**2*f**2*fdd*s**2 + 104000*C*D1**2*f**2*fdd*s - 52000*C*D1**2*f**2*fdd - 156000*C*D1**2*f*fd**2*r**2 - 312000*C*D1**2*f*fd**2*r*s + 208000*C*D1**2*f*fd**2*r - 156000*C*D1**2*f*fd**2*s**2 + 208000*C*D1**2*f*fd**2*s - 52000*C*D1**2*f*fd**2 + 166816*C*D1*Dd*f**3*r**2 + 333632*C*D1*Dd*f**3*r*s - 250224*C*D1*Dd*f**3*r + 166816*C*D1*Dd*f**3*s**2 - 250224*C*D1*Dd*f**3*s + 125112*C*D1*Dd*f**3 - 624000*C*D1*Dd*f**2*fd*r**2 - 1248000*C*D1*Dd*f**2*fd*r*s + 884000*C*D1*Dd*f**2*fd*r - 624000*C*D1*Dd*f**2*fd*s**2 + 884000*C*D1*Dd*f**2*fd*s - 312000*C*D1*Dd*f**2*fd - 104000*C*D1*Ddd*f**3*r**2 - 208000*C*D1*Ddd*f**3*r*s + 156000*C*D1*Ddd*f**3*r - 104000*C*D1*Ddd*f**3*s**2 + 156000*C*D1*Ddd*f**3*s - 78000*C*D1*Ddd*f**3 - 312000*C*Dd**2*f**3*r**2 - 624000*C*Dd**2*f**3*r*s + 468000*C*Dd**2*f**3*r - 312000*C*Dd**2*f**3*s**2 + 468000*C*Dd**2*f**3*s - 156000*C*Dd**2*f**3 + 58344*D1**2*K*b1*f*fd*r**2 + 116688*D1**2*K*b1*f*fd*r*s - 58344*D1**2*K*b1*f*fd*r + 58344*D1**2*K*b1*f*fd*s**2 - 58344*D1**2*K*b1*f*fd*s + 29172*D1**2*K*b1*f*fd - 34320*D1**2*K*b1*f*fdd*r**2 - 68640*D1**2*K*b1*f*fdd*r*s + 34320*D1**2*K*b1*f*fdd*r - 34320*D1**2*K*b1*f*fdd*s**2 + 34320*D1**2*K*b1*f*fdd*s - 17160*D1**2*K*b1*f*fdd - 34320*D1**2*K*b1*fd**2*r**2 - 68640*D1**2*K*b1*fd**2*r*s + 34320*D1**2*K*b1*fd**2*r - 34320*D1**2*K*b1*fd**2*s**2 + 34320*D1**2*K*b1*fd**2*s - 58344*D1**2*b1*f*fd*r**2 - 116688*D1**2*b1*f*fd*r*s + 58344*D1**2*b1*f*fd*r - 58344*D1**2*b1*f*fd*s**2 + 58344*D1**2*b1*f*fd*s - 29172*D1**2*b1*f*fd + 34320*D1**2*b1*f*fdd*r**2 + 68640*D1**2*b1*f*fdd*r*s - 34320*D1**2*b1*f*fdd*r + 34320*D1**2*b1*f*fdd*s**2 - 34320*D1**2*b1*f*fdd*s + 17160*D1**2*b1*f*fdd + 34320*D1**2*b1*fd**2*r**2 + 68640*D1**2*b1*fd**2*r*s - 34320*D1**2*b1*fd**2*r + 34320*D1**2*b1*fd**2*s**2 - 34320*D1**2*b1*fd**2*s - 17160*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 166800*D1**2*f**3*fd*r**2 + 333600*D1**2*f**3*fd*r*s - 250200*D1**2*f**3*fd*r + 166800*D1**2*f**3*fd*s**2 - 250200*D1**2*f**3*fd*s + 125100*D1**2*f**3*fd - 102900*D1**2*f**3*fdd*r**2 - 205800*D1**2*f**3*fdd*r*s + 154350*D1**2*f**3*fdd*r - 102900*D1**2*f**3*fdd*s**2 + 154350*D1**2*f**3*fdd*s - 77175*D1**2*f**3*fdd - 308700*D1**2*f**2*fd**2*r**2 - 617400*D1**2*f**2*fd**2*r*s + 463050*D1**2*f**2*fd**2*r - 308700*D1**2*f**2*fd**2*s**2 + 463050*D1**2*f**2*fd**2*s - 154350*D1**2*f**2*fd**2 - 125112*D1**2*f**2*fd*r**2 - 250224*D1**2*f**2*fd*r*s + 166816*D1**2*f**2*fd*r - 125112*D1**2*f**2*fd*s**2 + 166816*D1**2*f**2*fd*s - 83408*D1**2*f**2*fd + 78000*D1**2*f**2*fdd*r**2 + 156000*D1**2*f**2*fdd*r*s - 104000*D1**2*f**2*fdd*r + 78000*D1**2*f**2*fdd*s**2 - 104000*D1**2*f**2*fdd*s + 52000*D1**2*f**2*fdd - 58344*D1**2*f**2*gd2*r**2 - 116688*D1**2*f**2*gd2*r*s + 116688*D1**2*f**2*gd2*r - 58344*D1**2*f**2*gd2*s**2 + 116688*D1**2*f**2*gd2*s - 58344*D1**2*f**2*gd2 + 34320*D1**2*f**2*gdd2*r**2 + 68640*D1**2*f**2*gdd2*r*s - 68640*D1**2*f**2*gdd2*r + 34320*D1**2*f**2*gdd2*s**2 - 68640*D1**2*f**2*gdd2*s + 34320*D1**2*f**2*gdd2 + 156000*D1**2*f*fd**2*r**2 + 312000*D1**2*f*fd**2*r*s - 208000*D1**2*f*fd**2*r + 156000*D1**2*f*fd**2*s**2 - 208000*D1**2*f*fd**2*s + 52000*D1**2*f*fd**2 - 116688*D1**2*f*fd*g2*r**2 - 233376*D1**2*f*fd*g2*r*s + 116688*D1**2*f*fd*g2*r - 116688*D1**2*f*fd*g2*s**2 + 116688*D1**2*f*fd*g2*s - 58344*D1**2*f*fd*g2 + 137280*D1**2*f*fd*gd2*r**2 + 274560*D1**2*f*fd*gd2*r*s - 205920*D1**2*f*fd*gd2*r + 137280*D1**2*f*fd*gd2*s**2 - 205920*D1**2*f*fd*gd2*s + 68640*D1**2*f*fd*gd2 + 68640*D1**2*f*fdd*g2*r**2 + 137280*D1**2*f*fdd*g2*r*s - 68640*D1**2*f*fdd*g2*r + 68640*D1**2*f*fdd*g2*s**2 - 68640*D1**2*f*fdd*g2*s + 34320*D1**2*f*fdd*g2 + 68640*D1**2*fd**2*g2*r**2 + 137280*D1**2*fd**2*g2*r*s - 68640*D1**2*fd**2*g2*r + 68640*D1**2*fd**2*g2*s**2 - 68640*D1**2*fd**2*g2*s + 116688*D1*Dd*K*b1*f**2*r**2 + 233376*D1*Dd*K*b1*f**2*r*s - 175032*D1*Dd*K*b1*f**2*r + 116688*D1*Dd*K*b1*f**2*s**2 - 175032*D1*Dd*K*b1*f**2*s + 87516*D1*Dd*K*b1*f**2 - 274560*D1*Dd*K*b1*f*fd*r**2 - 549120*D1*Dd*K*b1*f*fd*r*s + 343200*D1*Dd*K*b1*f*fd*r - 274560*D1*Dd*K*b1*f*fd*s**2 + 343200*D1*Dd*K*b1*f*fd*s - 102960*D1*Dd*K*b1*f*fd - 116688*D1*Dd*b1*f**2*r**2 - 233376*D1*Dd*b1*f**2*r*s + 175032*D1*Dd*b1*f**2*r - 116688*D1*Dd*b1*f**2*s**2 + 175032*D1*Dd*b1*f**2*s - 87516*D1*Dd*b1*f**2 + 274560*D1*Dd*b1*f*fd*r**2 + 549120*D1*Dd*b1*f*fd*r*s - 343200*D1*Dd*b1*f*fd*r + 274560*D1*Dd*b1*f*fd*s**2 - 343200*D1*Dd*b1*f*fd*s + 102960*D1*Dd*b1*f*fd + 166800*D1*Dd*f**4*r**2 + 333600*D1*Dd*f**4*r*s - 250200*D1*Dd*f**4*r + 166800*D1*Dd*f**4*s**2 - 250200*D1*Dd*f**4*s + 125100*D1*Dd*f**4 - 823200*D1*Dd*f**3*fd*r**2 - 1646400*D1*Dd*f**3*fd*r*s + 1234800*D1*Dd*f**3*fd*r - 823200*D1*Dd*f**3*fd*s**2 + 1234800*D1*Dd*f**3*fd*s - 463050*D1*Dd*f**3*fd - 166816*D1*Dd*f**3*r**2 - 333632*D1*Dd*f**3*r*s + 250224*D1*Dd*f**3*r - 166816*D1*Dd*f**3*s**2 + 250224*D1*Dd*f**3*s - 125112*D1*Dd*f**3 + 624000*D1*Dd*f**2*fd*r**2 + 1248000*D1*Dd*f**2*fd*r*s - 884000*D1*Dd*f**2*fd*r + 624000*D1*Dd*f**2*fd*s**2 - 884000*D1*Dd*f**2*fd*s + 312000*D1*Dd*f**2*fd - 233376*D1*Dd*f**2*g2*r**2 - 466752*D1*Dd*f**2*g2*r*s + 350064*D1*Dd*f**2*g2*r - 233376*D1*Dd*f**2*g2*s**2 + 350064*D1*Dd*f**2*g2*s - 175032*D1*Dd*f**2*g2 + 274560*D1*Dd*f**2*gd2*r**2 + 549120*D1*Dd*f**2*gd2*r*s - 480480*D1*Dd*f**2*gd2*r + 274560*D1*Dd*f**2*gd2*s**2 - 480480*D1*Dd*f**2*gd2*s + 205920*D1*Dd*f**2*gd2 + 549120*D1*Dd*f*fd*g2*r**2 + 1098240*D1*Dd*f*fd*g2*r*s - 686400*D1*Dd*f*fd*g2*r + 549120*D1*Dd*f*fd*g2*s**2 - 686400*D1*Dd*f*fd*g2*s + 205920*D1*Dd*f*fd*g2 - 68640*D1*Ddd*K*b1*f**2*r**2 - 137280*D1*Ddd*K*b1*f**2*r*s + 102960*D1*Ddd*K*b1*f**2*r - 68640*D1*Ddd*K*b1*f**2*s**2 + 102960*D1*Ddd*K*b1*f**2*s - 51480*D1*Ddd*K*b1*f**2 + 68640*D1*Ddd*b1*f**2*r**2 + 137280*D1*Ddd*b1*f**2*r*s - 102960*D1*Ddd*b1*f**2*r + 68640*D1*Ddd*b1*f**2*s**2 - 102960*D1*Ddd*b1*f**2*s + 51480*D1*Ddd*b1*f**2 - 102900*D1*Ddd*f**4*r**2 - 205800*D1*Ddd*f**4*r*s + 154350*D1*Ddd*f**4*r - 102900*D1*Ddd*f**4*s**2 + 154350*D1*Ddd*f**4*s - 77175*D1*Ddd*f**4 + 104000*D1*Ddd*f**3*r**2 + 208000*D1*Ddd*f**3*r*s - 156000*D1*Ddd*f**3*r + 104000*D1*Ddd*f**3*s**2 - 156000*D1*Ddd*f**3*s + 78000*D1*Ddd*f**3 + 137280*D1*Ddd*f**2*g2*r**2 + 274560*D1*Ddd*f**2*g2*r*s - 205920*D1*Ddd*f**2*g2*r + 137280*D1*Ddd*f**2*g2*s**2 - 205920*D1*Ddd*f**2*g2*s + 102960*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(17*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 205920*Dd**2*K*b1*f**2*r**2 - 411840*Dd**2*K*b1*f**2*r*s + 308880*Dd**2*K*b1*f**2*r - 205920*Dd**2*K*b1*f**2*s**2 + 308880*Dd**2*K*b1*f**2*s - 102960*Dd**2*K*b1*f**2 + 205920*Dd**2*b1*f**2*r**2 + 411840*Dd**2*b1*f**2*r*s - 308880*Dd**2*b1*f**2*r + 205920*Dd**2*b1*f**2*s**2 - 308880*Dd**2*b1*f**2*s + 102960*Dd**2*b1*f**2 - 308700*Dd**2*f**4*r**2 - 617400*Dd**2*f**4*r*s + 463050*Dd**2*f**4*r - 308700*Dd**2*f**4*s**2 + 463050*Dd**2*f**4*s - 154350*Dd**2*f**4 + 312000*Dd**2*f**3*r**2 + 624000*Dd**2*f**3*r*s - 468000*Dd**2*f**3*r + 312000*Dd**2*f**3*s**2 - 468000*Dd**2*f**3*s + 156000*Dd**2*f**3 + 411840*Dd**2*f**2*g2*r**2 + 823680*Dd**2*f**2*g2*r*s - 617760*Dd**2*f**2*g2*r + 411840*Dd**2*f**2*g2*s**2 - 617760*Dd**2*f**2*g2*s + 205920*Dd**2*f**2*g2)/(3003*d**2*k3**8) - 8*D1**2*Pk2*Pk3*ct**5*k1**3*k2**3*(-1320*C*D1**2*bdd1*f**2*r**2 - 2640*C*D1**2*bdd1*f**2*r*s + 2640*C*D1**2*bdd1*f**2*r - 1320*C*D1**2*bdd1*f**2*s**2 + 2640*C*D1**2*bdd1*f**2*s - 1320*C*D1**2*bdd1*f**2 + 8280*C*D1**2*f**2*fd*r**2 + 16560*C*D1**2*f**2*fd*r*s - 11040*C*D1**2*f**2*fd*r + 8280*C*D1**2*f**2*fd*s**2 - 11040*C*D1**2*f**2*fd*s + 5520*C*D1**2*f**2*fd - 10080*C*D1**2*f**2*fdd*r**2 - 20160*C*D1**2*f**2*fdd*r*s + 13440*C*D1**2*f**2*fdd*r - 10080*C*D1**2*f**2*fdd*s**2 + 13440*C*D1**2*f**2*fdd*s - 6720*C*D1**2*f**2*fdd - 20160*C*D1**2*f*fd**2*r**2 - 40320*C*D1**2*f*fd**2*r*s + 26880*C*D1**2*f*fd**2*r - 20160*C*D1**2*f*fd**2*s**2 + 26880*C*D1**2*f*fd**2*s - 6720*C*D1**2*f*fd**2 + 11040*C*D1*Dd*f**3*r**2 + 22080*C*D1*Dd*f**3*r*s - 16560*C*D1*Dd*f**3*r + 11040*C*D1*Dd*f**3*s**2 - 16560*C*D1*Dd*f**3*s + 8280*C*D1*Dd*f**3 - 80640*C*D1*Dd*f**2*fd*r**2 - 161280*C*D1*Dd*f**2*fd*r*s + 114240*C*D1*Dd*f**2*fd*r - 80640*C*D1*Dd*f**2*fd*s**2 + 114240*C*D1*Dd*f**2*fd*s - 40320*C*D1*Dd*f**2*fd - 13440*C*D1*Ddd*f**3*r**2 - 26880*C*D1*Ddd*f**3*r*s + 20160*C*D1*Ddd*f**3*r - 13440*C*D1*Ddd*f**3*s**2 + 20160*C*D1*Ddd*f**3*s - 10080*C*D1*Ddd*f**3 - 40320*C*Dd**2*f**3*r**2 - 80640*C*Dd**2*f**3*r*s + 60480*C*Dd**2*f**3*r - 40320*C*Dd**2*f**3*s**2 + 60480*C*Dd**2*f**3*s - 20160*C*Dd**2*f**3 - 1980*D1**2*K*bdd1*f**2*r**2 - 3960*D1**2*K*bdd1*f**2*r*s + 3960*D1**2*K*bdd1*f**2*r - 1980*D1**2*K*bdd1*f**2*s**2 + 3960*D1**2*K*bdd1*f**2*s - 1980*D1**2*K*bdd1*f**2 - 1584*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 700*D1**2*bdd1*f**3*r**2 + 1400*D1**2*bdd1*f**3*r*s - 1400*D1**2*bdd1*f**3*r + 700*D1**2*bdd1*f**3*s**2 - 1400*D1**2*bdd1*f**3*s + 700*D1**2*bdd1*f**3 + 2310*D1**2*bdd1*f**2*r**2 + 4620*D1**2*bdd1*f**2*r*s - 4620*D1**2*bdd1*f**2*r + 2310*D1**2*bdd1*f**2*s**2 - 4620*D1**2*bdd1*f**2*s + 2310*D1**2*bdd1*f**2 + 1584*D1**2*bdd1*f*g2*r**2 + 3168*D1**2*bdd1*f*g2*r*s - 3168*D1**2*bdd1*f*g2*r + 1584*D1**2*bdd1*f*g2*s**2 - 3168*D1**2*bdd1*f*g2*s + 1584*D1**2*bdd1*f*g2 - 1680*D1**2*f**3*fd*r**2 - 3360*D1**2*f**3*fd*r*s + 2520*D1**2*f**3*fd*r - 1680*D1**2*f**3*fd*s**2 + 2520*D1**2*f**3*fd*s - 1260*D1**2*f**3*fd - 5715*D1**2*f**2*fd*r**2 - 11430*D1**2*f**2*fd*r*s + 7620*D1**2*f**2*fd*r - 5715*D1**2*f**2*fd*s**2 + 7620*D1**2*f**2*fd*s - 3810*D1**2*f**2*fd + 7560*D1**2*f**2*fdd*r**2 + 15120*D1**2*f**2*fdd*r*s - 10080*D1**2*f**2*fdd*r + 7560*D1**2*f**2*fdd*s**2 - 10080*D1**2*f**2*fdd*s + 5040*D1**2*f**2*fdd - 3168*D1**2*f**2*gd2*r**2 - 6336*D1**2*f**2*gd2*r*s + 6336*D1**2*f**2*gd2*r - 3168*D1**2*f**2*gd2*s**2 + 6336*D1**2*f**2*gd2*s - 3168*D1**2*f**2*gd2 + 3960*D1**2*f**2*gdd2*r**2 + 7920*D1**2*f**2*gdd2*r*s - 7920*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 7920*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 + 15120*D1**2*f*fd**2*r**2 + 30240*D1**2*f*fd**2*r*s - 20160*D1**2*f*fd**2*r + 15120*D1**2*f*fd**2*s**2 - 20160*D1**2*f*fd**2*s + 5040*D1**2*f*fd**2 - 6336*D1**2*f*fd*g2*r**2 - 12672*D1**2*f*fd*g2*r*s + 6336*D1**2*f*fd*g2*r - 6336*D1**2*f*fd*g2*s**2 + 6336*D1**2*f*fd*g2*s - 3168*D1**2*f*fd*g2 + 15840*D1**2*f*fd*gd2*r**2 + 31680*D1**2*f*fd*gd2*r*s - 23760*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 23760*D1**2*f*fd*gd2*s + 7920*D1**2*f*fd*gd2 + 7920*D1**2*f*fdd*g2*r**2 + 15840*D1**2*f*fdd*g2*r*s - 7920*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 7920*D1**2*f*fdd*g2*s + 3960*D1**2*f*fdd*g2 + 7920*D1**2*fd**2*g2*r**2 + 15840*D1**2*fd**2*g2*r*s - 7920*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 7920*D1**2*fd**2*g2*s - 1680*D1*Dd*f**4*r**2 - 3360*D1*Dd*f**4*r*s + 2520*D1*Dd*f**4*r - 1680*D1*Dd*f**4*s**2 + 2520*D1*Dd*f**4*s - 1260*D1*Dd*f**4 - 7620*D1*Dd*f**3*r**2 - 15240*D1*Dd*f**3*r*s + 11430*D1*Dd*f**3*r - 7620*D1*Dd*f**3*s**2 + 11430*D1*Dd*f**3*s - 5715*D1*Dd*f**3 + 60480*D1*Dd*f**2*fd*r**2 + 120960*D1*Dd*f**2*fd*r*s - 85680*D1*Dd*f**2*fd*r + 60480*D1*Dd*f**2*fd*s**2 - 85680*D1*Dd*f**2*fd*s + 30240*D1*Dd*f**2*fd - 12672*D1*Dd*f**2*g2*r**2 - 25344*D1*Dd*f**2*g2*r*s + 19008*D1*Dd*f**2*g2*r - 12672*D1*Dd*f**2*g2*s**2 + 19008*D1*Dd*f**2*g2*s - 9504*D1*Dd*f**2*g2 + 31680*D1*Dd*f**2*gd2*r**2 + 63360*D1*Dd*f**2*gd2*r*s - 55440*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 55440*D1*Dd*f**2*gd2*s + 23760*D1*Dd*f**2*gd2 + 63360*D1*Dd*f*fd*g2*r**2 + 126720*D1*Dd*f*fd*g2*r*s - 79200*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 79200*D1*Dd*f*fd*g2*s + 23760*D1*Dd*f*fd*g2 + 10080*D1*Ddd*f**3*r**2 + 20160*D1*Ddd*f**3*r*s - 15120*D1*Ddd*f**3*r + 10080*D1*Ddd*f**3*s**2 - 15120*D1*Ddd*f**3*s + 7560*D1*Ddd*f**3 + 15840*D1*Ddd*f**2*g2*r**2 + 31680*D1*Ddd*f**2*g2*r*s - 23760*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 23760*D1*Ddd*f**2*g2*s + 11880*D1*Ddd*f**2*g2 - D1*bd1*(D1*(575*f**3*(r + s - 1) - 2*f**2*(924*C*(r + s - 1) + 700*fd*(3*r + 3*s - 2) + (792*K - 1221)*(r + s - 1)) + 132*f*(5*fd*(4*C + 6*K - 7)*(2*r + 2*s - 1) + (17*g2 - 24*gd2)*(r + s - 1)) - 3168*fd*g2*(r + s)) - 4*Dd*f*(350*f**2 - 165*f*(4*C + 6*K - 7) + 792*g2)*(4*r + 4*s - 3))*(r + s - 1) + 30240*Dd**2*f**3*r**2 + 60480*Dd**2*f**3*r*s - 45360*Dd**2*f**3*r + 30240*Dd**2*f**3*s**2 - 45360*Dd**2*f**3*s + 15120*Dd**2*f**3 + 47520*Dd**2*f**2*g2*r**2 + 95040*Dd**2*f**2*g2*r*s - 71280*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 71280*Dd**2*f**2*g2*s + 23760*Dd**2*f**2*g2 + 66*b1**2*(K - 1)*(D1**2*(17*fd - 12*fdd)*(r + s)**2 + D1*(Dd*(17*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 24*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(3696*C*D1**2*f*fd*r**2 + 7392*C*D1**2*f*fd*r*s - 3696*C*D1**2*f*fd*r + 3696*C*D1**2*f*fd*s**2 - 3696*C*D1**2*f*fd*s + 1848*C*D1**2*f*fd - 2640*C*D1**2*f*fdd*r**2 - 5280*C*D1**2*f*fdd*r*s + 2640*C*D1**2*f*fdd*r - 2640*C*D1**2*f*fdd*s**2 + 2640*C*D1**2*f*fdd*s - 1320*C*D1**2*f*fdd - 2640*C*D1**2*fd**2*r**2 - 5280*C*D1**2*fd**2*r*s + 2640*C*D1**2*fd**2*r - 2640*C*D1**2*fd**2*s**2 + 2640*C*D1**2*fd**2*s + 7392*C*D1*Dd*f**2*r**2 + 14784*C*D1*Dd*f**2*r*s - 11088*C*D1*Dd*f**2*r + 7392*C*D1*Dd*f**2*s**2 - 11088*C*D1*Dd*f**2*s + 5544*C*D1*Dd*f**2 - 21120*C*D1*Dd*f*fd*r**2 - 42240*C*D1*Dd*f*fd*r*s + 26400*C*D1*Dd*f*fd*r - 21120*C*D1*Dd*f*fd*s**2 + 26400*C*D1*Dd*f*fd*s - 7920*C*D1*Dd*f*fd - 5280*C*D1*Ddd*f**2*r**2 - 10560*C*D1*Ddd*f**2*r*s + 7920*C*D1*Ddd*f**2*r - 5280*C*D1*Ddd*f**2*s**2 + 7920*C*D1*Ddd*f**2*s - 3960*C*D1*Ddd*f**2 - 15840*C*Dd**2*f**2*r**2 - 31680*C*Dd**2*f**2*r*s + 23760*C*Dd**2*f**2*r - 15840*C*Dd**2*f**2*s**2 + 23760*C*Dd**2*f**2*s - 7920*C*Dd**2*f**2 + 3168*D1**2*K*f*fd*r**2 + 6336*D1**2*K*f*fd*r*s - 3168*D1**2*K*f*fd*r + 3168*D1**2*K*f*fd*s**2 - 3168*D1**2*K*f*fd*s + 1584*D1**2*K*f*fd - 3960*D1**2*K*f*fdd*r**2 - 7920*D1**2*K*f*fdd*r*s + 3960*D1**2*K*f*fdd*r - 3960*D1**2*K*f*fdd*s**2 + 3960*D1**2*K*f*fdd*s - 1980*D1**2*K*f*fdd - 3960*D1**2*K*fd**2*r**2 - 7920*D1**2*K*fd**2*r*s + 3960*D1**2*K*fd**2*r - 3960*D1**2*K*fd**2*s**2 + 3960*D1**2*K*fd**2*s - 1584*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 1725*D1**2*f**2*fd*r**2 - 3450*D1**2*f**2*fd*r*s + 2300*D1**2*f**2*fd*r - 1725*D1**2*f**2*fd*s**2 + 2300*D1**2*f**2*fd*s - 1150*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 4884*D1**2*f*fd*r**2 - 9768*D1**2*f*fd*r*s + 4884*D1**2*f*fd*r - 4884*D1**2*f*fd*s**2 + 4884*D1**2*f*fd*s - 2442*D1**2*f*fd + 4620*D1**2*f*fdd*r**2 + 9240*D1**2*f*fdd*r*s - 4620*D1**2*f*fdd*r + 4620*D1**2*f*fdd*s**2 - 4620*D1**2*f*fdd*s + 2310*D1**2*f*fdd - 2244*D1**2*f*gd2*r**2 - 4488*D1**2*f*gd2*r*s + 4488*D1**2*f*gd2*r - 2244*D1**2*f*gd2*s**2 + 4488*D1**2*f*gd2*s - 2244*D1**2*f*gd2 + 1584*D1**2*f*gdd2*r**2 + 3168*D1**2*f*gdd2*r*s - 3168*D1**2*f*gdd2*r + 1584*D1**2*f*gdd2*s**2 - 3168*D1**2*f*gdd2*s + 1584*D1**2*f*gdd2 + 4620*D1**2*fd**2*r**2 + 9240*D1**2*fd**2*r*s - 4620*D1**2*fd**2*r + 4620*D1**2*fd**2*s**2 - 4620*D1**2*fd**2*s - 2244*D1**2*fd*g2*r**2 - 4488*D1**2*fd*g2*r*s - 2244*D1**2*fd*g2*s**2 + 3168*D1**2*fd*gd2*r**2 + 6336*D1**2*fd*gd2*r*s - 3168*D1**2*fd*gd2*r + 3168*D1**2*fd*gd2*s**2 - 3168*D1**2*fd*gd2*s + 1584*D1**2*fdd*g2*r**2 + 3168*D1**2*fdd*g2*r*s + 1584*D1**2*fdd*g2*s**2 + 6336*D1*Dd*K*f**2*r**2 + 12672*D1*Dd*K*f**2*r*s - 9504*D1*Dd*K*f**2*r + 6336*D1*Dd*K*f**2*s**2 - 9504*D1*Dd*K*f**2*s + 4752*D1*Dd*K*f**2 - 31680*D1*Dd*K*f*fd*r**2 - 63360*D1*Dd*K*f*fd*r*s + 39600*D1*Dd*K*f*fd*r - 31680*D1*Dd*K*f*fd*s**2 + 39600*D1*Dd*K*f*fd*s - 11880*D1*Dd*K*f*fd - 2300*D1*Dd*f**3*r**2 - 4600*D1*Dd*f**3*r*s + 3450*D1*Dd*f**3*r - 2300*D1*Dd*f**3*s**2 + 3450*D1*Dd*f**3*s - 1725*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 23800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 23800*D1*Dd*f**2*fd*s + 8400*D1*Dd*f**2*fd - 9768*D1*Dd*f**2*r**2 - 19536*D1*Dd*f**2*r*s + 14652*D1*Dd*f**2*r - 9768*D1*Dd*f**2*s**2 + 14652*D1*Dd*f**2*s - 7326*D1*Dd*f**2 + 36960*D1*Dd*f*fd*r**2 + 73920*D1*Dd*f*fd*r*s - 46200*D1*Dd*f*fd*r + 36960*D1*Dd*f*fd*s**2 - 46200*D1*Dd*f*fd*s + 13860*D1*Dd*f*fd - 8976*D1*Dd*f*g2*r**2 - 17952*D1*Dd*f*g2*r*s + 13464*D1*Dd*f*g2*r - 8976*D1*Dd*f*g2*s**2 + 13464*D1*Dd*f*g2*s - 6732*D1*Dd*f*g2 + 12672*D1*Dd*f*gd2*r**2 + 25344*D1*Dd*f*gd2*r*s - 22176*D1*Dd*f*gd2*r + 12672*D1*Dd*f*gd2*s**2 - 22176*D1*Dd*f*gd2*s + 9504*D1*Dd*f*gd2 + 12672*D1*Dd*fd*g2*r**2 + 25344*D1*Dd*fd*g2*r*s - 9504*D1*Dd*fd*g2*r + 12672*D1*Dd*fd*g2*s**2 - 9504*D1*Dd*fd*g2*s - 7920*D1*Ddd*K*f**2*r**2 - 15840*D1*Ddd*K*f**2*r*s + 11880*D1*Ddd*K*f**2*r - 7920*D1*Ddd*K*f**2*s**2 + 11880*D1*Ddd*K*f**2*s - 5940*D1*Ddd*K*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 + 9240*D1*Ddd*f**2*r**2 + 18480*D1*Ddd*f**2*r*s - 13860*D1*Ddd*f**2*r + 9240*D1*Ddd*f**2*s**2 - 13860*D1*Ddd*f**2*s + 6930*D1*Ddd*f**2 + 6336*D1*Ddd*f*g2*r**2 + 12672*D1*Ddd*f*g2*r*s - 9504*D1*Ddd*f*g2*r + 6336*D1*Ddd*f*g2*s**2 - 9504*D1*Ddd*f*g2*s + 4752*D1*Ddd*f*g2 + 132*D1*bd1*(K - 1)*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) - 23760*Dd**2*K*f**2*r**2 - 47520*Dd**2*K*f**2*r*s + 35640*Dd**2*K*f**2*r - 23760*Dd**2*K*f**2*s**2 + 35640*Dd**2*K*f**2*s - 11880*Dd**2*K*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3 + 27720*Dd**2*f**2*r**2 + 55440*Dd**2*f**2*r*s - 41580*Dd**2*f**2*r + 27720*Dd**2*f**2*s**2 - 41580*Dd**2*f**2*s + 13860*Dd**2*f**2 + 19008*Dd**2*f*g2*r**2 + 38016*Dd**2*f*g2*r*s - 28512*Dd**2*f*g2*r + 19008*Dd**2*f*g2*s**2 - 28512*Dd**2*f*g2*s + 9504*Dd**2*f*g2))/(231*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**5*k1**3*k2*st**2*(33852*C*D1**2*f**2*fd*r*s - 11284*C*D1**2*f**2*fd*r + 33852*C*D1**2*f**2*fd*s**2 - 33852*C*D1**2*f**2*fd*s + 11284*C*D1**2*f**2*fd - 19500*C*D1**2*f**2*fdd*r*s + 6500*C*D1**2*f**2*fdd*r - 19500*C*D1**2*f**2*fdd*s**2 + 19500*C*D1**2*f**2*fdd*s - 6500*C*D1**2*f**2*fdd - 39000*C*D1**2*f*fd**2*r*s + 13000*C*D1**2*f*fd**2*r - 39000*C*D1**2*f*fd**2*s**2 + 39000*C*D1**2*f*fd**2*s - 6500*C*D1**2*f*fd**2 + 45136*C*D1*Dd*f**3*r*s - 11284*C*D1*Dd*f**3*r + 45136*C*D1*Dd*f**3*s**2 - 45136*C*D1*Dd*f**3*s + 11284*C*D1*Dd*f**3 - 156000*C*D1*Dd*f**2*fd*r*s + 45500*C*D1*Dd*f**2*fd*r - 156000*C*D1*Dd*f**2*fd*s**2 + 156000*C*D1*Dd*f**2*fd*s - 32500*C*D1*Dd*f**2*fd - 26000*C*D1*Ddd*f**3*r*s + 6500*C*D1*Ddd*f**3*r - 26000*C*D1*Ddd*f**3*s**2 + 26000*C*D1*Ddd*f**3*s - 6500*C*D1*Ddd*f**3 - 78000*C*Dd**2*f**3*r*s + 19500*C*Dd**2*f**3*r - 78000*C*Dd**2*f**3*s**2 + 78000*C*Dd**2*f**3*s - 13000*C*Dd**2*f**3 - 4290*D1**2*K*bdd1*f**2*r*s - 4290*D1**2*K*bdd1*f**2*s**2 + 4290*D1**2*K*bdd1*f**2*s + 4290*D1**2*bdd1*f**2*r*s + 4290*D1**2*bdd1*f**2*s**2 - 4290*D1**2*bdd1*f**2*s + 48380*D1**2*f**3*fd*r*s - 12095*D1**2*f**3*fd*r + 48380*D1**2*f**3*fd*s**2 - 48380*D1**2*f**3*fd*s + 12095*D1**2*f**3*fd - 27440*D1**2*f**3*fdd*r*s + 6860*D1**2*f**3*fdd*r - 27440*D1**2*f**3*fdd*s**2 + 27440*D1**2*f**3*fdd*s - 6860*D1**2*f**3*fdd - 82320*D1**2*f**2*fd**2*r*s + 20580*D1**2*f**2*fd**2*r - 82320*D1**2*f**2*fd**2*s**2 + 82320*D1**2*f**2*fd**2*s - 13720*D1**2*f**2*fd**2 - 33852*D1**2*f**2*fd*r*s + 11284*D1**2*f**2*fd*r - 33852*D1**2*f**2*fd*s**2 + 33852*D1**2*f**2*fd*s - 11284*D1**2*f**2*fd + 19500*D1**2*f**2*fdd*r*s - 6500*D1**2*f**2*fdd*r + 19500*D1**2*f**2*fdd*s**2 - 19500*D1**2*f**2*fdd*s + 6500*D1**2*f**2*fdd - 15444*D1**2*f**2*gd2*r*s - 15444*D1**2*f**2*gd2*s**2 + 15444*D1**2*f**2*gd2*s + 8580*D1**2*f**2*gdd2*r*s + 8580*D1**2*f**2*gdd2*s**2 - 8580*D1**2*f**2*gdd2*s + 39000*D1**2*f*fd**2*r*s - 13000*D1**2*f*fd**2*r + 39000*D1**2*f*fd**2*s**2 - 39000*D1**2*f*fd**2*s + 6500*D1**2*f*fd**2 - 30888*D1**2*f*fd*g2*r*s + 15444*D1**2*f*fd*g2*r - 30888*D1**2*f*fd*g2*s**2 + 30888*D1**2*f*fd*g2*s - 15444*D1**2*f*fd*g2 + 34320*D1**2*f*fd*gd2*r*s - 8580*D1**2*f*fd*gd2*r + 34320*D1**2*f*fd*gd2*s**2 - 34320*D1**2*f*fd*gd2*s + 8580*D1**2*f*fd*gd2 + 17160*D1**2*f*fdd*g2*r*s - 8580*D1**2*f*fdd*g2*r + 17160*D1**2*f*fdd*g2*s**2 - 17160*D1**2*f*fdd*g2*s + 8580*D1**2*f*fdd*g2 + 17160*D1**2*fd**2*g2*r*s - 8580*D1**2*fd**2*g2*r + 17160*D1**2*fd**2*g2*s**2 - 17160*D1**2*fd**2*g2*s + 48380*D1*Dd*f**4*r*s - 12095*D1*Dd*f**4*r + 48380*D1*Dd*f**4*s**2 - 48380*D1*Dd*f**4*s + 12095*D1*Dd*f**4 - 219520*D1*Dd*f**3*fd*r*s + 54880*D1*Dd*f**3*fd*r - 219520*D1*Dd*f**3*fd*s**2 + 219520*D1*Dd*f**3*fd*s - 41160*D1*Dd*f**3*fd - 45136*D1*Dd*f**3*r*s + 11284*D1*Dd*f**3*r - 45136*D1*Dd*f**3*s**2 + 45136*D1*Dd*f**3*s - 11284*D1*Dd*f**3 + 156000*D1*Dd*f**2*fd*r*s - 45500*D1*Dd*f**2*fd*r + 156000*D1*Dd*f**2*fd*s**2 - 156000*D1*Dd*f**2*fd*s + 32500*D1*Dd*f**2*fd - 61776*D1*Dd*f**2*g2*r*s + 15444*D1*Dd*f**2*g2*r - 61776*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 15444*D1*Dd*f**2*g2 + 68640*D1*Dd*f**2*gd2*r*s - 8580*D1*Dd*f**2*gd2*r + 68640*D1*Dd*f**2*gd2*s**2 - 68640*D1*Dd*f**2*gd2*s + 8580*D1*Dd*f**2*gd2 + 137280*D1*Dd*f*fd*g2*r*s - 51480*D1*Dd*f*fd*g2*r + 137280*D1*Dd*f*fd*g2*s**2 - 137280*D1*Dd*f*fd*g2*s + 34320*D1*Dd*f*fd*g2 - 27440*D1*Ddd*f**4*r*s + 6860*D1*Ddd*f**4*r - 27440*D1*Ddd*f**4*s**2 + 27440*D1*Ddd*f**4*s - 6860*D1*Ddd*f**4 + 26000*D1*Ddd*f**3*r*s - 6500*D1*Ddd*f**3*r + 26000*D1*Ddd*f**3*s**2 - 26000*D1*Ddd*f**3*s + 6500*D1*Ddd*f**3 + 34320*D1*Ddd*f**2*g2*r*s - 8580*D1*Ddd*f**2*g2*r + 34320*D1*Ddd*f**2*g2*s**2 - 34320*D1*Ddd*f**2*g2*s + 8580*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(D1*(9*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 82320*Dd**2*f**4*r*s + 20580*Dd**2*f**4*r - 82320*Dd**2*f**4*s**2 + 82320*Dd**2*f**4*s - 13720*Dd**2*f**4 + 78000*Dd**2*f**3*r*s - 19500*Dd**2*f**3*r + 78000*Dd**2*f**3*s**2 - 78000*Dd**2*f**3*s + 13000*Dd**2*f**3 + 102960*Dd**2*f**2*g2*r*s - 25740*Dd**2*f**2*g2*r + 102960*Dd**2*f**2*g2*s**2 - 102960*Dd**2*f**2*g2*s + 17160*Dd**2*f**2*g2 + 858*b1*(K - 1)*(D1**2*(f*(9*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(9*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**6) + 8*D1**2*Pk2*Pk3*ct**5*k1**3*k2*(660*C*D1**2*bdd1*f**2*r**2 + 3300*C*D1**2*bdd1*f**2*r*s - 1980*C*D1**2*bdd1*f**2*r + 2640*C*D1**2*bdd1*f**2*s**2 - 3960*C*D1**2*bdd1*f**2*s + 1980*C*D1**2*bdd1*f**2 + 10890*C*D1**2*f**2*fd*r**2 + 19620*C*D1**2*f**2*fd*r*s - 13800*C*D1**2*f**2*fd*r + 8730*C*D1**2*f**2*fd*s**2 - 12360*C*D1**2*f**2*fd*s + 6540*C*D1**2*f**2*fd - 10890*C*D1**2*f**2*fdd*r**2 - 16740*C*D1**2*f**2*fdd*r*s + 12840*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 9480*C*D1**2*f**2*fdd*s - 5580*C*D1**2*f**2*fdd - 21780*C*D1**2*f*fd**2*r**2 - 33480*C*D1**2*f*fd**2*r*s + 25680*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 18960*C*D1**2*f*fd**2*s - 5580*C*D1**2*f*fd**2 + 14520*C*D1*Dd*f**3*r**2 + 26160*C*D1*Dd*f**3*r*s - 21060*C*D1*Dd*f**3*r + 11640*C*D1*Dd*f**3*s**2 - 18900*C*D1*Dd*f**3*s + 10170*C*D1*Dd*f**3 - 87120*C*D1*Dd*f**2*fd*r**2 - 133920*C*D1*Dd*f**2*fd*r*s + 111660*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 83100*C*D1*Dd*f**2*fd*s - 35160*C*D1*Dd*f**2*fd - 14520*C*D1*Ddd*f**3*r**2 - 22320*C*D1*Ddd*f**3*r*s + 20100*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 15060*C*D1*Ddd*f**3*s - 9210*C*D1*Ddd*f**3 - 43560*C*Dd**2*f**3*r**2 - 66960*C*Dd**2*f**3*r*s + 60300*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 45180*C*Dd**2*f**3*s - 18420*C*Dd**2*f**3 - 1980*D1**2*K*bdd1*f**2*r**2 - 3168*D1**2*K*bdd1*f**2*r*s + 3960*D1**2*K*bdd1*f**2*r - 1188*D1**2*K*bdd1*f**2*s**2 + 3168*D1**2*K*bdd1*f**2*s - 1980*D1**2*K*bdd1*f**2 + 396*D1**2*bd1**2*f*(K - 1)*(2*r**2 + 5*r*(2*s - 1) + 8*s**2 - 11*s + 3) + 1260*D1**2*bdd1*f**3*r**2 + 1960*D1**2*bdd1*f**3*r*s - 2800*D1**2*bdd1*f**3*r + 700*D1**2*bdd1*f**3*s**2 - 2240*D1**2*bdd1*f**3*s + 1960*D1**2*bdd1*f**3 + 2310*D1**2*bdd1*f**2*r**2 + 2838*D1**2*bdd1*f**2*r*s - 3960*D1**2*bdd1*f**2*r + 528*D1**2*bdd1*f**2*s**2 - 2178*D1**2*bdd1*f**2*s + 990*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r**2 - 3960*D1**2*bdd1*f*g2*r*s + 2376*D1**2*bdd1*f*g2*r - 3168*D1**2*bdd1*f*g2*s**2 + 4752*D1**2*bdd1*f*g2*s - 2376*D1**2*bdd1*f*g2 + 10920*D1**2*f**3*fd*r**2 + 28560*D1**2*f**3*fd*r*s - 18060*D1**2*f**3*fd*r + 17640*D1**2*f**3*fd*s**2 - 23100*D1**2*f**3*fd*s + 9870*D1**2*f**3*fd - 12600*D1**2*f**3*fdd*r**2 - 25200*D1**2*f**3*fdd*r*s + 18900*D1**2*f**3*fdd*r - 12600*D1**2*f**3*fdd*s**2 + 18900*D1**2*f**3*fdd*s - 9450*D1**2*f**3*fdd - 37800*D1**2*f**2*fd**2*r**2 - 75600*D1**2*f**2*fd**2*r*s + 56700*D1**2*f**2*fd**2*r - 37800*D1**2*f**2*fd**2*s**2 + 56700*D1**2*f**2*fd**2*s - 18900*D1**2*f**2*fd**2 - 13455*D1**2*f**2*fd*r**2 - 27810*D1**2*f**2*fd*r*s + 18240*D1**2*f**2*fd*r - 14355*D1**2*f**2*fd*s**2 + 18840*D1**2*f**2*fd*s - 9270*D1**2*f**2*fd + 13410*D1**2*f**2*fdd*r**2 + 24300*D1**2*f**2*fdd*r*s - 17040*D1**2*f**2*fdd*r + 10890*D1**2*f**2*fdd*s**2 - 15360*D1**2*f**2*fdd*s + 8100*D1**2*f**2*fdd - 3564*D1**2*f**2*gd2*r**2 - 7128*D1**2*f**2*gd2*r*s + 7128*D1**2*f**2*gd2*r - 3564*D1**2*f**2*gd2*s**2 + 7128*D1**2*f**2*gd2*s - 3564*D1**2*f**2*gd2 + 3960*D1**2*f**2*gdd2*r**2 + 6336*D1**2*f**2*gdd2*r*s - 7920*D1**2*f**2*gdd2*r + 2376*D1**2*f**2*gdd2*s**2 - 6336*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 + 26820*D1**2*f*fd**2*r**2 + 48600*D1**2*f*fd**2*r*s - 34080*D1**2*f*fd**2*r + 21780*D1**2*f*fd**2*s**2 - 30720*D1**2*f*fd**2*s + 8100*D1**2*f*fd**2 - 7128*D1**2*f*fd*g2*r**2 - 14256*D1**2*f*fd*g2*r*s + 7128*D1**2*f*fd*g2*r - 7128*D1**2*f*fd*g2*s**2 + 7128*D1**2*f*fd*g2*s - 3564*D1**2*f*fd*g2 + 15840*D1**2*f*fd*gd2*r**2 + 25344*D1**2*f*fd*gd2*r*s - 22176*D1**2*f*fd*gd2*r + 9504*D1**2*f*fd*gd2*s**2 - 17424*D1**2*f*fd*gd2*s + 6336*D1**2*f*fd*gd2 + 7920*D1**2*f*fdd*g2*r**2 + 12672*D1**2*f*fdd*g2*r*s - 6336*D1**2*f*fdd*g2*r + 4752*D1**2*f*fdd*g2*s**2 - 4752*D1**2*f*fdd*g2*s + 2376*D1**2*f*fdd*g2 + 7920*D1**2*fd**2*g2*r**2 + 12672*D1**2*fd**2*g2*r*s - 6336*D1**2*fd**2*g2*r + 4752*D1**2*fd**2*g2*s**2 - 4752*D1**2*fd**2*g2*s + 10920*D1*Dd*f**4*r**2 + 28560*D1*Dd*f**4*r*s - 18060*D1*Dd*f**4*r + 17640*D1*Dd*f**4*s**2 - 23100*D1*Dd*f**4*s + 9870*D1*Dd*f**4 - 100800*D1*Dd*f**3*fd*r**2 - 201600*D1*Dd*f**3*fd*r*s + 151200*D1*Dd*f**3*fd*r - 100800*D1*Dd*f**3*fd*s**2 + 151200*D1*Dd*f**3*fd*s - 56700*D1*Dd*f**3*fd - 17940*D1*Dd*f**3*r**2 - 37080*D1*Dd*f**3*r*s + 27210*D1*Dd*f**3*r - 19140*D1*Dd*f**3*s**2 + 28110*D1*Dd*f**3*s - 13755*D1*Dd*f**3 + 107280*D1*Dd*f**2*fd*r**2 + 194400*D1*Dd*f**2*fd*r*s - 146100*D1*Dd*f**2*fd*r + 87120*D1*Dd*f**2*fd*s**2 - 131820*D1*Dd*f**2*fd*s + 49440*D1*Dd*f**2*fd - 14256*D1*Dd*f**2*g2*r**2 - 28512*D1*Dd*f**2*g2*r*s + 21384*D1*Dd*f**2*g2*r - 14256*D1*Dd*f**2*g2*s**2 + 21384*D1*Dd*f**2*g2*s - 10692*D1*Dd*f**2*g2 + 31680*D1*Dd*f**2*gd2*r**2 + 50688*D1*Dd*f**2*gd2*r*s - 53856*D1*Dd*f**2*gd2*r + 19008*D1*Dd*f**2*gd2*s**2 - 42768*D1*Dd*f**2*gd2*s + 22176*D1*Dd*f**2*gd2 + 63360*D1*Dd*f*fd*g2*r**2 + 101376*D1*Dd*f*fd*g2*r*s - 69696*D1*Dd*f*fd*g2*r + 38016*D1*Dd*f*fd*g2*s**2 - 53856*D1*Dd*f*fd*g2*s + 17424*D1*Dd*f*fd*g2 - 12600*D1*Ddd*f**4*r**2 - 25200*D1*Ddd*f**4*r*s + 18900*D1*Ddd*f**4*r - 12600*D1*Ddd*f**4*s**2 + 18900*D1*Ddd*f**4*s - 9450*D1*Ddd*f**4 + 17880*D1*Ddd*f**3*r**2 + 32400*D1*Ddd*f**3*r*s - 25980*D1*Ddd*f**3*r + 14520*D1*Ddd*f**3*s**2 - 23460*D1*Ddd*f**3*s + 12570*D1*Ddd*f**3 + 15840*D1*Ddd*f**2*g2*r**2 + 25344*D1*Ddd*f**2*g2*r*s - 22176*D1*Ddd*f**2*g2*r + 9504*D1*Ddd*f**2*g2*s**2 - 17424*D1*Ddd*f**2*g2*s + 10296*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(273*r**2 + r*(454*s - 724) + 181*s**2 - 632*s + 553) - 2*f**2*(264*C*(r**2 + r*(8*s - 6) + 7*s**2 - 12*s + 6) - 891*K*(r + s - 1)**2 - 140*fd*(27*r**2 + r*(42*s - 45) + 15*s**2 - 35*s + 14) + 1122*r**2 + 1254*r*s - 1188*r + 132*s**2 - 198*s - 198) + 66*f*(fd*(10*C*(4*r**2 + 10*r*(2*s - 1) + 16*s**2 - 19*s + 3) - 12*K*(10*r**2 + 2*r*(8*s - 7) + 6*s**2 - 11*s + 4) + 140*r**2 + 172*r*s - 173*r + 32*s**2 - 92*s + 63) + 2*g2*(5*r**2 + r*(39*s - 29) + 34*s**2 - 58*s + 29) - 12*gd2*(2*r**2 + 5*r*(2*s - 1) + 8*s**2 - 11*s + 3)) - 792*fd*g2*(2*r**2 + 5*r*(2*s - 1) + s*(8*s - 8))) + 2*Dd*f*(140*f**2*(36*r**2 + r*(56*s - 65) + 20*s**2 - 51*s + 28) + 33*f*(10*C*(8*r**2 + r*(40*s - 21) + 32*s**2 - 42*s + 12) - 12*K*(20*r**2 + 32*r*s - 34*r + 12*s**2 - 27*s + 14) + 280*r**2 + 344*r*s - 423*r + 64*s**2 - 234*s + 153) - 396*g2*(8*r**2 + r*(40*s - 21) + 32*s**2 - 42*s + 12))) - 37800*Dd**2*f**4*r**2 - 75600*Dd**2*f**4*r*s + 56700*Dd**2*f**4*r - 37800*Dd**2*f**4*s**2 + 56700*Dd**2*f**4*s - 18900*Dd**2*f**4 + 53640*Dd**2*f**3*r**2 + 97200*Dd**2*f**3*r*s - 77940*Dd**2*f**3*r + 43560*Dd**2*f**3*s**2 - 70380*Dd**2*f**3*s + 25140*Dd**2*f**3 + 47520*Dd**2*f**2*g2*r**2 + 76032*Dd**2*f**2*g2*r*s - 66528*Dd**2*f**2*g2*r + 28512*Dd**2*f**2*g2*s**2 - 52272*Dd**2*f**2*g2*s + 20592*Dd**2*f**2*g2 - 66*b1**2*(K - 1)*(D1**2*(fd*(5*r**2 + 39*r*s - 10*r + 34*s**2 - 10*s + 5) - 6*fdd*(r**2 + 5*r*s - 2*r + 4*s**2 - 2*s + 1)) + D1*(Dd*f*(20*r**2 + 156*r*s - 59*r + 136*s**2 - 146*s + 44) - 6*Dd*fd*(8*r**2 + r*(40*s - 17) + 32*s**2 - 26*s + 6) - 6*Ddd*f*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 18*s + 6)) - 18*Dd**2*f*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 18*s + 4)) + b1*(-1056*C*D1**2*f*fd*r**2 - 8448*C*D1**2*f*fd*r*s + 2112*C*D1**2*f*fd*r - 7392*C*D1**2*f*fd*s**2 + 5280*C*D1**2*f*fd*s - 1056*C*D1**2*f*fd + 1320*C*D1**2*f*fdd*r**2 + 6600*C*D1**2*f*fdd*r*s - 2640*C*D1**2*f*fdd*r + 5280*C*D1**2*f*fdd*s**2 - 4620*C*D1**2*f*fdd*s + 1320*C*D1**2*f*fdd + 1320*C*D1**2*fd**2*r**2 + 6600*C*D1**2*fd**2*r*s - 2640*C*D1**2*fd**2*r + 5280*C*D1**2*fd**2*s**2 - 4620*C*D1**2*fd**2*s + 1320*C*D1**2*fd**2 - 2112*C*D1*Dd*f**2*r**2 - 16896*C*D1*Dd*f**2*r*s + 6336*C*D1*Dd*f**2*r - 14784*C*D1*Dd*f**2*s**2 + 15840*C*D1*Dd*f**2*s - 4752*C*D1*Dd*f**2 + 10560*C*D1*Dd*f*fd*r**2 + 52800*C*D1*Dd*f*fd*r*s - 22440*C*D1*Dd*f*fd*r + 42240*C*D1*Dd*f*fd*s**2 - 42240*C*D1*Dd*f*fd*s + 9900*C*D1*Dd*f*fd + 2640*C*D1*Ddd*f**2*r**2 + 13200*C*D1*Ddd*f**2*r*s - 5940*C*D1*Ddd*f**2*r + 10560*C*D1*Ddd*f**2*s**2 - 11880*C*D1*Ddd*f**2*s + 3960*C*D1*Ddd*f**2 + 7920*C*Dd**2*f**2*r**2 + 39600*C*Dd**2*f**2*r*s - 17820*C*Dd**2*f**2*r + 31680*C*Dd**2*f**2*s**2 - 35640*C*Dd**2*f**2*s + 7920*C*Dd**2*f**2 + 3564*D1**2*K*f*fd*r**2 + 7128*D1**2*K*f*fd*r*s - 3564*D1**2*K*f*fd*r + 3564*D1**2*K*f*fd*s**2 - 3564*D1**2*K*f*fd*s + 1782*D1**2*K*f*fd - 3960*D1**2*K*f*fdd*r**2 - 6336*D1**2*K*f*fdd*r*s + 3168*D1**2*K*f*fdd*r - 2376*D1**2*K*f*fdd*s**2 + 2376*D1**2*K*f*fdd*s - 1188*D1**2*K*f*fdd - 3960*D1**2*K*fd**2*r**2 - 6336*D1**2*K*fd**2*r*s + 3168*D1**2*K*fd**2*r - 2376*D1**2*K*fd**2*s**2 + 2376*D1**2*K*fd**2*s + 396*D1**2*bdd1*f*(K - 1)*(2*r**2 + 10*r*s - 5*r + 8*s**2 - 11*s + 4) - 4095*D1**2*f**2*fd*r**2 - 6810*D1**2*f**2*fd*r*s + 4110*D1**2*f**2*fd*r - 2715*D1**2*f**2*fd*s**2 + 3190*D1**2*f**2*fd*s - 870*D1**2*f**2*fd + 3780*D1**2*f**2*fdd*r**2 + 5880*D1**2*f**2*fdd*r*s - 4200*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 3080*D1**2*f**2*fdd*s + 1260*D1**2*f**2*fdd + 7560*D1**2*f*fd**2*r**2 + 11760*D1**2*f*fd**2*r*s - 8400*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 6160*D1**2*f*fd**2*s + 2520*D1**2*f*fd**2 - 4488*D1**2*f*fd*r**2 - 5016*D1**2*f*fd*r*s + 4620*D1**2*f*fd*r - 528*D1**2*f*fd*s**2 + 2640*D1**2*f*fd*s - 2904*D1**2*f*fd + 4620*D1**2*f*fdd*r**2 + 5676*D1**2*f*fdd*r*s - 3498*D1**2*f*fdd*r + 1056*D1**2*f*fdd*s**2 - 1716*D1**2*f*fdd*s + 1848*D1**2*f*fdd + 660*D1**2*f*gd2*r**2 + 5148*D1**2*f*gd2*r*s - 1320*D1**2*f*gd2*r + 4488*D1**2*f*gd2*s**2 - 5148*D1**2*f*gd2*s + 660*D1**2*f*gd2 - 792*D1**2*f*gdd2*r**2 - 3960*D1**2*f*gdd2*r*s + 1584*D1**2*f*gdd2*r - 3168*D1**2*f*gdd2*s**2 + 3960*D1**2*f*gdd2*s - 792*D1**2*f*gdd2 + 4620*D1**2*fd**2*r**2 + 5676*D1**2*fd**2*r*s - 3498*D1**2*fd**2*r + 1056*D1**2*fd**2*s**2 - 1716*D1**2*fd**2*s - 1320*D1**2*fd**2 + 660*D1**2*fd*g2*r**2 + 5148*D1**2*fd*g2*r*s - 1320*D1**2*fd*g2*r + 4488*D1**2*fd*g2*s**2 - 1320*D1**2*fd*g2*s + 660*D1**2*fd*g2 - 1584*D1**2*fd*gd2*r**2 - 7920*D1**2*fd*gd2*r*s + 3168*D1**2*fd*gd2*r - 6336*D1**2*fd*gd2*s**2 + 5544*D1**2*fd*gd2*s - 1584*D1**2*fd*gd2 - 792*D1**2*fdd*g2*r**2 - 3960*D1**2*fdd*g2*r*s + 1584*D1**2*fdd*g2*r - 3168*D1**2*fdd*g2*s**2 + 1584*D1**2*fdd*g2*s - 792*D1**2*fdd*g2 + 7128*D1*Dd*K*f**2*r**2 + 14256*D1*Dd*K*f**2*r*s - 10692*D1*Dd*K*f**2*r + 7128*D1*Dd*K*f**2*s**2 - 10692*D1*Dd*K*f**2*s + 5346*D1*Dd*K*f**2 - 31680*D1*Dd*K*f*fd*r**2 - 50688*D1*Dd*K*f*fd*r*s + 34848*D1*Dd*K*f*fd*r - 19008*D1*Dd*K*f*fd*s**2 + 26928*D1*Dd*K*f*fd*s - 8712*D1*Dd*K*f*fd - 5460*D1*Dd*f**3*r**2 - 9080*D1*Dd*f**3*r*s + 7730*D1*Dd*f**3*r - 3620*D1*Dd*f**3*s**2 + 6350*D1*Dd*f**3*s - 3635*D1*Dd*f**3 + 30240*D1*Dd*f**2*fd*r**2 + 47040*D1*Dd*f**2*fd*r*s - 37800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 28280*D1*Dd*f**2*fd*s + 11480*D1*Dd*f**2*fd - 8976*D1*Dd*f**2*r**2 - 10032*D1*Dd*f**2*r*s + 11484*D1*Dd*f**2*r - 1056*D1*Dd*f**2*s**2 + 5544*D1*Dd*f**2*s - 4752*D1*Dd*f**2 + 36960*D1*Dd*f*fd*r**2 + 45408*D1*Dd*f*fd*r*s - 38148*D1*Dd*f*fd*r + 8448*D1*Dd*f*fd*s**2 - 20328*D1*Dd*f*fd*s + 8712*D1*Dd*f*fd + 2640*D1*Dd*f*g2*r**2 + 20592*D1*Dd*f*g2*r*s - 7788*D1*Dd*f*g2*r + 17952*D1*Dd*f*g2*s**2 - 19272*D1*Dd*f*g2*s + 5808*D1*Dd*f*g2 - 6336*D1*Dd*f*gd2*r**2 - 31680*D1*Dd*f*gd2*r*s + 13464*D1*Dd*f*gd2*r - 25344*D1*Dd*f*gd2*s**2 + 30096*D1*Dd*f*gd2*s - 7128*D1*Dd*f*gd2 - 6336*D1*Dd*fd*g2*r**2 - 31680*D1*Dd*fd*g2*r*s + 13464*D1*Dd*fd*g2*r - 25344*D1*Dd*fd*g2*s**2 + 20592*D1*Dd*fd*g2*s - 4752*D1*Dd*fd*g2 - 7920*D1*Ddd*K*f**2*r**2 - 12672*D1*Ddd*K*f**2*r*s + 11088*D1*Ddd*K*f**2*r - 4752*D1*Ddd*K*f**2*s**2 + 8712*D1*Ddd*K*f**2*s - 5148*D1*Ddd*K*f**2 + 5040*D1*Ddd*f**3*r**2 + 7840*D1*Ddd*f**3*r*s - 7000*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 5320*D1*Ddd*f**3*s + 3220*D1*Ddd*f**3 + 9240*D1*Ddd*f**2*r**2 + 11352*D1*Ddd*f**2*r*s - 12078*D1*Ddd*f**2*r + 2112*D1*Ddd*f**2*s**2 - 6732*D1*Ddd*f**2*s + 5148*D1*Ddd*f**2 - 3168*D1*Ddd*f*g2*r**2 - 15840*D1*Ddd*f*g2*r*s + 7128*D1*Ddd*f*g2*r - 12672*D1*Ddd*f*g2*s**2 + 14256*D1*Ddd*f*g2*s - 4752*D1*Ddd*f*g2 - 66*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 78*r*s - 39*r + 68*s**2 - 97*s + 34) - 6*fd*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 15*s + 2)) - 6*Dd*f*(16*r**2 + r*(80*s - 38) + 64*s**2 - 80*s + 21)) - 23760*Dd**2*K*f**2*r**2 - 38016*Dd**2*K*f**2*r*s + 33264*Dd**2*K*f**2*r - 14256*Dd**2*K*f**2*s**2 + 26136*Dd**2*K*f**2*s - 10296*Dd**2*K*f**2 + 15120*Dd**2*f**3*r**2 + 23520*Dd**2*f**3*r*s - 21000*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 15960*Dd**2*f**3*s + 6440*Dd**2*f**3 + 27720*Dd**2*f**2*r**2 + 34056*Dd**2*f**2*r*s - 36234*Dd**2*f**2*r + 6336*Dd**2*f**2*s**2 - 20196*Dd**2*f**2*s + 10296*Dd**2*f**2 - 9504*Dd**2*f*g2*r**2 - 47520*Dd**2*f*g2*r*s + 21384*Dd**2*f*g2*r - 38016*Dd**2*f*g2*s**2 + 42768*Dd**2*f*g2*s - 9504*Dd**2*f*g2))/(693*d**2*k3**6) - 20*D1**2*Pk2*Pk3*ct**5*k1**3*st**2*(D1**2*(3087*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(9261*fd**2*s*(2*s - 1) - fd*(2600*C - 2600)*(3*s**2 - 2*s + 1) + fdd*(1300*C - 1300)*(3*s**2 - 2*s + 1) + s**2*(858*K*bdd1 - 1716*bd1*(K - 1) - 858*bdd1 + 3432*gd2 - 1716*gdd2)) - 104*f*(fd**2*s*(50*C - 50)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 6864*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(3087*f**3*(4*s**2 - 2*s + 1) + f**2*(2600*C*(4*s**2 - 2*s + 1) - 3087*fd*(1 - 4*s)**2 - 10400*s**2 + 5200*s - 2600) - 52*f*(fd*(50*C - 50)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 3432*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(3087*f**2 + f*(2600*C - 2600) - 3432*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(3087*f**2 + f*(2600*C - 2600) - 3432*g2) + 1716*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(3003*d**2*k2*k3**4) - 40*D1**2*Pk2*Pk3*ct**5*k1**3*(b1*(D1**2*(56*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-112*fd**2*s*(3*s - 2) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(56*f**2*(4*s**2 - 2*s + 1) - 56*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(56*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(56*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(112*bd1 - 56*bdd1) + f*(-56*fd*(s**2*(6*bd1 - 3) - s*(2*bd1 - 2) - 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) - 2*D1*f*(28*Dd*f*(s**2*(8*bd1 - 4) - s*(2*bd1 - 2) - 1) + Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) + 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2**3*k3**2) + 20*D1**2*Pk2*Pk3*ct**5*k1*k2**5*st**2*(-600*C*D1**2*f**2*fd*r**2 - 1200*C*D1**2*f**2*fd*r*s + 800*C*D1**2*f**2*fd*r - 600*C*D1**2*f**2*fd*s**2 + 800*C*D1**2*f**2*fd*s - 400*C*D1**2*f**2*fd + 300*C*D1**2*f**2*fdd*r**2 + 600*C*D1**2*f**2*fdd*r*s - 400*C*D1**2*f**2*fdd*r + 300*C*D1**2*f**2*fdd*s**2 - 400*C*D1**2*f**2*fdd*s + 200*C*D1**2*f**2*fdd + 600*C*D1**2*f*fd**2*r**2 + 1200*C*D1**2*f*fd**2*r*s - 800*C*D1**2*f*fd**2*r + 600*C*D1**2*f*fd**2*s**2 - 800*C*D1**2*f*fd**2*s + 200*C*D1**2*f*fd**2 - 800*C*D1*Dd*f**3*r**2 - 1600*C*D1*Dd*f**3*r*s + 1200*C*D1*Dd*f**3*r - 800*C*D1*Dd*f**3*s**2 + 1200*C*D1*Dd*f**3*s - 600*C*D1*Dd*f**3 + 2400*C*D1*Dd*f**2*fd*r**2 + 4800*C*D1*Dd*f**2*fd*r*s - 3400*C*D1*Dd*f**2*fd*r + 2400*C*D1*Dd*f**2*fd*s**2 - 3400*C*D1*Dd*f**2*fd*s + 1200*C*D1*Dd*f**2*fd + 400*C*D1*Ddd*f**3*r**2 + 800*C*D1*Ddd*f**3*r*s - 600*C*D1*Ddd*f**3*r + 400*C*D1*Ddd*f**3*s**2 - 600*C*D1*Ddd*f**3*s + 300*C*D1*Ddd*f**3 + 1200*C*Dd**2*f**3*r**2 + 2400*C*Dd**2*f**3*r*s - 1800*C*Dd**2*f**3*r + 1200*C*Dd**2*f**3*s**2 - 1800*C*Dd**2*f**3*s + 600*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r**2 - 528*D1**2*K*b1*f*fd*r*s + 264*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 132*D1**2*K*b1*f*fdd*s**2 - 132*D1**2*K*b1*f*fdd*s + 66*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 132*D1**2*K*b1*fd**2*s**2 - 132*D1**2*K*b1*fd**2*s + 210*D1**2*b1*f**2*fd*r**2 + 420*D1**2*b1*f**2*fd*r*s - 280*D1**2*b1*f**2*fd*r + 210*D1**2*b1*f**2*fd*s**2 - 280*D1**2*b1*f**2*fd*s + 140*D1**2*b1*f**2*fd - 105*D1**2*b1*f**2*fdd*r**2 - 210*D1**2*b1*f**2*fdd*r*s + 140*D1**2*b1*f**2*fdd*r - 105*D1**2*b1*f**2*fdd*s**2 + 140*D1**2*b1*f**2*fdd*s - 70*D1**2*b1*f**2*fdd - 210*D1**2*b1*f*fd**2*r**2 - 420*D1**2*b1*f*fd**2*r*s + 280*D1**2*b1*f*fd**2*r - 210*D1**2*b1*f*fd**2*s**2 + 280*D1**2*b1*f*fd**2*s - 70*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-66*K + 35*f + 33)*(r + s - 1)**2 + 450*D1**2*f**2*fd*r**2 + 900*D1**2*f**2*fd*r*s - 600*D1**2*f**2*fd*r + 450*D1**2*f**2*fd*s**2 - 600*D1**2*f**2*fd*s + 300*D1**2*f**2*fd - 225*D1**2*f**2*fdd*r**2 - 450*D1**2*f**2*fdd*r*s + 300*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 300*D1**2*f**2*fdd*s - 150*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 450*D1**2*f*fd**2*r**2 - 900*D1**2*f*fd**2*r*s + 600*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 600*D1**2*f*fd**2*s - 150*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 - 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 792*D1*Dd*K*b1*f**2*s - 396*D1*Dd*K*b1*f**2 + 1056*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1320*D1*Dd*K*b1*f*fd*r + 1056*D1*Dd*K*b1*f*fd*s**2 - 1320*D1*Dd*K*b1*f*fd*s + 396*D1*Dd*K*b1*f*fd + 280*D1*Dd*b1*f**3*r**2 + 560*D1*Dd*b1*f**3*r*s - 420*D1*Dd*b1*f**3*r + 280*D1*Dd*b1*f**3*s**2 - 420*D1*Dd*b1*f**3*s + 210*D1*Dd*b1*f**3 - 840*D1*Dd*b1*f**2*fd*r**2 - 1680*D1*Dd*b1*f**2*fd*r*s + 1190*D1*Dd*b1*f**2*fd*r - 840*D1*Dd*b1*f**2*fd*s**2 + 1190*D1*Dd*b1*f**2*fd*s - 420*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 600*D1*Dd*f**3*r**2 + 1200*D1*Dd*f**3*r*s - 900*D1*Dd*f**3*r + 600*D1*Dd*f**3*s**2 - 900*D1*Dd*f**3*s + 450*D1*Dd*f**3 - 1800*D1*Dd*f**2*fd*r**2 - 3600*D1*Dd*f**2*fd*r*s + 2550*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 2550*D1*Dd*f**2*fd*s - 900*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r + 264*D1*Ddd*K*b1*f**2*s**2 - 396*D1*Ddd*K*b1*f**2*s + 198*D1*Ddd*K*b1*f**2 - 140*D1*Ddd*b1*f**3*r**2 - 280*D1*Ddd*b1*f**3*r*s + 210*D1*Ddd*b1*f**3*r - 140*D1*Ddd*b1*f**3*s**2 + 210*D1*Ddd*b1*f**3*s - 105*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 300*D1*Ddd*f**3*r**2 - 600*D1*Ddd*f**3*r*s + 450*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 450*D1*Ddd*f**3*s - 225*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(35*f**2*(r + s - 1) - 35*f*fd*(3*r + 3*s - 2) - 33*f*(2*K - 1)*(r + s - 1) + 33*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-66*K + 35*f + 33)*(4*r + 4*s - 3))*(r + s - 1) + 792*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r + 792*Dd**2*K*b1*f**2*s**2 - 1188*Dd**2*K*b1*f**2*s + 396*Dd**2*K*b1*f**2 - 420*Dd**2*b1*f**3*r**2 - 840*Dd**2*b1*f**3*r*s + 630*Dd**2*b1*f**3*r - 420*Dd**2*b1*f**3*s**2 + 630*Dd**2*b1*f**3*s - 210*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 900*Dd**2*f**3*r**2 - 1800*Dd**2*f**3*r*s + 1350*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 1350*Dd**2*f**3*s - 450*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2)/(77*d**2*k3**8) + 8*D1**2*Pk2*Pk3*ct**5*k1*k2**5*(660*C*D1**2*bdd1*f**2*r**2 + 1320*C*D1**2*bdd1*f**2*r*s - 1320*C*D1**2*bdd1*f**2*r + 660*C*D1**2*bdd1*f**2*s**2 - 1320*C*D1**2*bdd1*f**2*s + 660*C*D1**2*bdd1*f**2 - 2760*C*D1**2*f**2*fd*r**2 - 5520*C*D1**2*f**2*fd*r*s + 3680*C*D1**2*f**2*fd*r - 2760*C*D1**2*f**2*fd*s**2 + 3680*C*D1**2*f**2*fd*s - 1840*C*D1**2*f**2*fd + 3360*C*D1**2*f**2*fdd*r**2 + 6720*C*D1**2*f**2*fdd*r*s - 4480*C*D1**2*f**2*fdd*r + 3360*C*D1**2*f**2*fdd*s**2 - 4480*C*D1**2*f**2*fdd*s + 2240*C*D1**2*f**2*fdd + 6720*C*D1**2*f*fd**2*r**2 + 13440*C*D1**2*f*fd**2*r*s - 8960*C*D1**2*f*fd**2*r + 6720*C*D1**2*f*fd**2*s**2 - 8960*C*D1**2*f*fd**2*s + 2240*C*D1**2*f*fd**2 - 3680*C*D1*Dd*f**3*r**2 - 7360*C*D1*Dd*f**3*r*s + 5520*C*D1*Dd*f**3*r - 3680*C*D1*Dd*f**3*s**2 + 5520*C*D1*Dd*f**3*s - 2760*C*D1*Dd*f**3 + 26880*C*D1*Dd*f**2*fd*r**2 + 53760*C*D1*Dd*f**2*fd*r*s - 38080*C*D1*Dd*f**2*fd*r + 26880*C*D1*Dd*f**2*fd*s**2 - 38080*C*D1*Dd*f**2*fd*s + 13440*C*D1*Dd*f**2*fd + 4480*C*D1*Ddd*f**3*r**2 + 8960*C*D1*Ddd*f**3*r*s - 6720*C*D1*Ddd*f**3*r + 4480*C*D1*Ddd*f**3*s**2 - 6720*C*D1*Ddd*f**3*s + 3360*C*D1*Ddd*f**3 + 13440*C*Dd**2*f**3*r**2 + 26880*C*Dd**2*f**3*r*s - 20160*C*Dd**2*f**3*r + 13440*C*Dd**2*f**3*s**2 - 20160*C*Dd**2*f**3*s + 6720*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r**2 + 1320*D1**2*K*bdd1*f**2*r*s - 1320*D1**2*K*bdd1*f**2*r + 660*D1**2*K*bdd1*f**2*s**2 - 1320*D1**2*K*bdd1*f**2*s + 660*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(-12*K + 5*f + 6)*(r + s - 1)**2 - 495*D1**2*bdd1*f**2*r**2 - 990*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*r - 495*D1**2*bdd1*f**2*s**2 + 990*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r**2 - 1584*D1**2*bdd1*f*g2*r*s + 1584*D1**2*bdd1*f*g2*r - 792*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 + 885*D1**2*f**2*fd*r**2 + 1770*D1**2*f**2*fd*r*s - 1180*D1**2*f**2*fd*r + 885*D1**2*f**2*fd*s**2 - 1180*D1**2*f**2*fd*s + 590*D1**2*f**2*fd - 1680*D1**2*f**2*fdd*r**2 - 3360*D1**2*f**2*fdd*r*s + 2240*D1**2*f**2*fdd*r - 1680*D1**2*f**2*fdd*s**2 + 2240*D1**2*f**2*fdd*s - 1120*D1**2*f**2*fdd + 1056*D1**2*f**2*gd2*r**2 + 2112*D1**2*f**2*gd2*r*s - 2112*D1**2*f**2*gd2*r + 1056*D1**2*f**2*gd2*s**2 - 2112*D1**2*f**2*gd2*s + 1056*D1**2*f**2*gd2 - 1320*D1**2*f**2*gdd2*r**2 - 2640*D1**2*f**2*gdd2*r*s + 2640*D1**2*f**2*gdd2*r - 1320*D1**2*f**2*gdd2*s**2 + 2640*D1**2*f**2*gdd2*s - 1320*D1**2*f**2*gdd2 - 3360*D1**2*f*fd**2*r**2 - 6720*D1**2*f*fd**2*r*s + 4480*D1**2*f*fd**2*r - 3360*D1**2*f*fd**2*s**2 + 4480*D1**2*f*fd**2*s - 1120*D1**2*f*fd**2 + 2112*D1**2*f*fd*g2*r**2 + 4224*D1**2*f*fd*g2*r*s - 2112*D1**2*f*fd*g2*r + 2112*D1**2*f*fd*g2*s**2 - 2112*D1**2*f*fd*g2*s + 1056*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r**2 - 10560*D1**2*f*fd*gd2*r*s + 7920*D1**2*f*fd*gd2*r - 5280*D1**2*f*fd*gd2*s**2 + 7920*D1**2*f*fd*gd2*s - 2640*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r**2 - 5280*D1**2*f*fdd*g2*r*s + 2640*D1**2*f*fdd*g2*r - 2640*D1**2*f*fdd*g2*s**2 + 2640*D1**2*f*fdd*g2*s - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r**2 - 5280*D1**2*fd**2*g2*r*s + 2640*D1**2*fd**2*g2*r - 2640*D1**2*fd**2*g2*s**2 + 2640*D1**2*fd**2*g2*s + 1180*D1*Dd*f**3*r**2 + 2360*D1*Dd*f**3*r*s - 1770*D1*Dd*f**3*r + 1180*D1*Dd*f**3*s**2 - 1770*D1*Dd*f**3*s + 885*D1*Dd*f**3 - 13440*D1*Dd*f**2*fd*r**2 - 26880*D1*Dd*f**2*fd*r*s + 19040*D1*Dd*f**2*fd*r - 13440*D1*Dd*f**2*fd*s**2 + 19040*D1*Dd*f**2*fd*s - 6720*D1*Dd*f**2*fd + 4224*D1*Dd*f**2*g2*r**2 + 8448*D1*Dd*f**2*g2*r*s - 6336*D1*Dd*f**2*g2*r + 4224*D1*Dd*f**2*g2*s**2 - 6336*D1*Dd*f**2*g2*s + 3168*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r**2 - 21120*D1*Dd*f**2*gd2*r*s + 18480*D1*Dd*f**2*gd2*r - 10560*D1*Dd*f**2*gd2*s**2 + 18480*D1*Dd*f**2*gd2*s - 7920*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r**2 - 42240*D1*Dd*f*fd*g2*r*s + 26400*D1*Dd*f*fd*g2*r - 21120*D1*Dd*f*fd*g2*s**2 + 26400*D1*Dd*f*fd*g2*s - 7920*D1*Dd*f*fd*g2 - 2240*D1*Ddd*f**3*r**2 - 4480*D1*Ddd*f**3*r*s + 3360*D1*Ddd*f**3*r - 2240*D1*Ddd*f**3*s**2 + 3360*D1*Ddd*f**3*s - 1680*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r**2 - 10560*D1*Ddd*f**2*g2*r*s + 7920*D1*Ddd*f**2*g2*r - 5280*D1*Ddd*f**2*g2*s**2 + 7920*D1*Ddd*f**2*g2*s - 3960*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(r + s - 1) + 8*f**2*(5*C + 2*K - 3)*(r + s - 1) - 10*f*fd*(4*C + 4*K - 3)*(2*r + 2*s - 1) - 48*f*(g2 - gd2)*(r + s - 1) + 48*fd*g2*(r + s)) - 2*Dd*f*(5*f*(4*C + 4*K - 3) - 24*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6720*Dd**2*f**3*r**2 - 13440*Dd**2*f**3*r*s + 10080*Dd**2*f**3*r - 6720*Dd**2*f**3*s**2 + 10080*Dd**2*f**3*s - 3360*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r**2 - 31680*Dd**2*f**2*g2*r*s + 23760*Dd**2*f**2*g2*r - 15840*Dd**2*f**2*g2*s**2 + 23760*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(5*fd**2*(r + s - 1) + 6*fd*(2*K - 1)*(r + s) - 3*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (12*K - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-12*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-12*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-80*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s + 80*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 80*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 240*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 240*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 400*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 32*D1**2*K*f*fd*r**2 - 64*D1**2*K*f*fd*r*s + 32*D1**2*K*f*fd*r - 32*D1**2*K*f*fd*s**2 + 32*D1**2*K*f*fd*s - 16*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-12*K + 5*f + 6)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 48*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s - 48*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s + 24*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 48*D1**2*f*gd2*r**2 + 96*D1**2*f*gd2*r*s - 96*D1**2*f*gd2*r + 48*D1**2*f*gd2*s**2 - 96*D1**2*f*gd2*s + 48*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 48*D1**2*fd*g2*r**2 + 96*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 - 64*D1*Dd*K*f**2*r**2 - 128*D1*Dd*K*f**2*r*s + 96*D1*Dd*K*f**2*r - 64*D1*Dd*K*f**2*s**2 + 96*D1*Dd*K*f**2*s - 48*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 96*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s - 144*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 144*D1*Dd*f**2*s + 72*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 192*D1*Dd*f*g2*r**2 + 384*D1*Dd*f*g2*r*s - 288*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 288*D1*Dd*f*g2*s + 144*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 144*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 6*f*(2*K - 1)*(r + s - 1) + 6*fd*(2*K - 1)*(r + s)) - Dd*f*(-12*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(231*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**5*k1*k2**3*st**2*(-9336*C*D1**2*f**2*fd*r**2 + 8664*C*D1**2*f**2*fd*r*s + 3336*C*D1**2*f**2*fd*r + 18000*C*D1**2*f**2*fd*s**2 - 14888*C*D1**2*f**2*fd*s + 2888*C*D1**2*f**2*fd + 5460*C*D1**2*f**2*fdd*r**2 - 3540*C*D1**2*f**2*fdd*r*s - 2460*C*D1**2*f**2*fdd*r - 9000*C*D1**2*f**2*fdd*s**2 + 7180*C*D1**2*f**2*fdd*s - 1180*C*D1**2*f**2*fdd + 10920*C*D1**2*f*fd**2*r**2 - 7080*C*D1**2*f*fd**2*r*s - 4920*C*D1**2*f*fd**2*r - 18000*C*D1**2*f*fd**2*s**2 + 14360*C*D1**2*f*fd**2*s - 1180*C*D1**2*f*fd**2 - 12448*C*D1*Dd*f**3*r**2 + 11552*C*D1*Dd*f**3*r*s + 9560*C*D1*Dd*f**3*r + 24000*C*D1*Dd*f**3*s**2 - 17776*C*D1*Dd*f**3*s - 224*C*D1*Dd*f**3 + 43680*C*D1*Dd*f**2*fd*r**2 - 28320*C*D1*Dd*f**2*fd*r*s - 28140*C*D1*Dd*f**2*fd*r - 72000*C*D1*Dd*f**2*fd*s**2 + 53800*C*D1*Dd*f**2*fd*s - 2260*C*D1*Dd*f**2*fd + 7280*C*D1*Ddd*f**3*r**2 - 4720*C*D1*Ddd*f**3*r*s - 6100*C*D1*Ddd*f**3*r - 12000*C*D1*Ddd*f**3*s**2 + 8360*C*D1*Ddd*f**3*s + 640*C*D1*Ddd*f**3 + 21840*C*Dd**2*f**3*r**2 - 14160*C*Dd**2*f**3*r*s - 18300*C*Dd**2*f**3*r - 36000*C*Dd**2*f**3*s**2 + 25080*C*Dd**2*f**3*s + 1280*C*Dd**2*f**3 - 3960*D1**2*K*b1*f*fd*r**2 + 3960*D1**2*K*b1*f*fd*r*s - 1980*D1**2*K*b1*f*fd*r + 7920*D1**2*K*b1*f*fd*s**2 - 7920*D1**2*K*b1*f*fd*s + 3960*D1**2*K*b1*f*fd + 1980*D1**2*K*b1*f*fdd*r**2 - 1980*D1**2*K*b1*f*fdd*r*s + 990*D1**2*K*b1*f*fdd*r - 3960*D1**2*K*b1*f*fdd*s**2 + 3960*D1**2*K*b1*f*fdd*s - 1980*D1**2*K*b1*f*fdd + 1980*D1**2*K*b1*fd**2*r**2 - 1980*D1**2*K*b1*fd**2*r*s + 990*D1**2*K*b1*fd**2*r - 3960*D1**2*K*b1*fd**2*s**2 + 3960*D1**2*K*b1*fd**2*s + 3150*D1**2*b1*f**2*fd*r**2 - 2100*D1**2*b1*f**2*fd*r - 3150*D1**2*b1*f**2*fd*s**2 + 2100*D1**2*b1*f**2*fd*s - 1575*D1**2*b1*f**2*fdd*r**2 + 1050*D1**2*b1*f**2*fdd*r + 1575*D1**2*b1*f**2*fdd*s**2 - 1050*D1**2*b1*f**2*fdd*s - 3150*D1**2*b1*f*fd**2*r**2 + 2100*D1**2*b1*f*fd**2*r + 3150*D1**2*b1*f*fd**2*s**2 - 2100*D1**2*b1*f*fd**2*s + 5940*D1**2*b1*f*fd*r**2 + 3960*D1**2*b1*f*fd*r*s - 1980*D1**2*b1*f*fd*r - 1980*D1**2*b1*f*fd*s**2 + 1980*D1**2*b1*f*fd*s - 990*D1**2*b1*f*fd - 2970*D1**2*b1*f*fdd*r**2 - 1980*D1**2*b1*f*fdd*r*s + 990*D1**2*b1*f*fdd*r + 990*D1**2*b1*f*fdd*s**2 - 990*D1**2*b1*f*fdd*s + 495*D1**2*b1*f*fdd - 2970*D1**2*b1*fd**2*r**2 - 1980*D1**2*b1*fd**2*r*s + 990*D1**2*b1*fd**2*r + 990*D1**2*b1*fd**2*s**2 - 990*D1**2*b1*fd**2*s - 15*D1**2*bdd1*f**2*(r + s - 1)*(-66*K*(r - 2*s - 1) + 35*f*(r - s - 1) + 99*r - 33*s - 99) - 4200*D1**2*f**3*fd*r**2 - 4200*D1**2*f**3*fd*r*s + 5250*D1**2*f**3*fd*r + 2100*D1**2*f**3*fd*s - 2100*D1**2*f**3*fd + 4200*D1**2*f**3*fdd*r**2 + 4200*D1**2*f**3*fdd*r*s - 5250*D1**2*f**3*fdd*r - 2100*D1**2*f**3*fdd*s + 2100*D1**2*f**3*fdd + 12600*D1**2*f**2*fd**2*r**2 + 12600*D1**2*f**2*fd**2*r*s - 15750*D1**2*f**2*fd**2*r - 6300*D1**2*f**2*fd**2*s + 4200*D1**2*f**2*fd**2 + 11586*D1**2*f**2*fd*r**2 + 336*D1**2*f**2*fd*r*s - 7836*D1**2*f**2*fd*r - 11250*D1**2*f**2*fd*s**2 + 7388*D1**2*f**2*fd*s + 112*D1**2*f**2*fd - 6585*D1**2*f**2*fdd*r**2 - 960*D1**2*f**2*fdd*r*s + 4710*D1**2*f**2*fdd*r + 5625*D1**2*f**2*fdd*s**2 - 3430*D1**2*f**2*fdd*s - 320*D1**2*f**2*fdd + 3960*D1**2*f**2*gd2*r**2 - 3960*D1**2*f**2*gd2*r*s - 7920*D1**2*f**2*gd2*r - 7920*D1**2*f**2*gd2*s**2 + 3960*D1**2*f**2*gd2*s + 3960*D1**2*f**2*gd2 - 1980*D1**2*f**2*gdd2*r**2 + 1980*D1**2*f**2*gdd2*r*s + 3960*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s - 1980*D1**2*f**2*gdd2 - 13170*D1**2*f*fd**2*r**2 - 1920*D1**2*f*fd**2*r*s + 9420*D1**2*f*fd**2*r + 11250*D1**2*f*fd**2*s**2 - 6860*D1**2*f*fd**2*s - 320*D1**2*f*fd**2 + 7920*D1**2*f*fd*g2*r**2 - 7920*D1**2*f*fd*g2*r*s + 3960*D1**2*f*fd*g2*r - 15840*D1**2*f*fd*g2*s**2 + 15840*D1**2*f*fd*g2*s - 7920*D1**2*f*fd*g2 - 7920*D1**2*f*fd*gd2*r**2 + 7920*D1**2*f*fd*gd2*r*s + 5940*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 11880*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 - 3960*D1**2*f*fdd*g2*r**2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 7920*D1**2*f*fdd*g2*s + 3960*D1**2*f*fdd*g2 - 3960*D1**2*fd**2*g2*r**2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 7920*D1**2*fd**2*g2*s - 7920*D1*Dd*K*b1*f**2*r**2 + 7920*D1*Dd*K*b1*f**2*r*s + 5940*D1*Dd*K*b1*f**2*r + 15840*D1*Dd*K*b1*f**2*s**2 - 11880*D1*Dd*K*b1*f**2*s + 15840*D1*Dd*K*b1*f*fd*r**2 - 15840*D1*Dd*K*b1*f*fd*r*s - 1980*D1*Dd*K*b1*f*fd*r - 31680*D1*Dd*K*b1*f*fd*s**2 + 27720*D1*Dd*K*b1*f*fd*s - 5940*D1*Dd*K*b1*f*fd + 4200*D1*Dd*b1*f**3*r**2 - 4200*D1*Dd*b1*f**3*r - 4200*D1*Dd*b1*f**3*s**2 + 2100*D1*Dd*b1*f**3*s + 1050*D1*Dd*b1*f**3 - 12600*D1*Dd*b1*f**2*fd*r**2 + 10500*D1*Dd*b1*f**2*fd*r + 12600*D1*Dd*b1*f**2*fd*s**2 - 7350*D1*Dd*b1*f**2*fd*s - 1050*D1*Dd*b1*f**2*fd + 11880*D1*Dd*b1*f**2*r**2 + 7920*D1*Dd*b1*f**2*r*s - 13860*D1*Dd*b1*f**2*r - 3960*D1*Dd*b1*f**2*s**2 - 1980*D1*Dd*b1*f**2*s + 4950*D1*Dd*b1*f**2 - 23760*D1*Dd*b1*f*fd*r**2 - 15840*D1*Dd*b1*f*fd*r*s + 17820*D1*Dd*b1*f*fd*r + 7920*D1*Dd*b1*f*fd*s**2 - 1980*D1*Dd*b1*f*fd*s - 990*D1*Dd*b1*f*fd - 4200*D1*Dd*f**4*r**2 - 4200*D1*Dd*f**4*r*s + 5250*D1*Dd*f**4*r + 2100*D1*Dd*f**4*s - 2100*D1*Dd*f**4 + 33600*D1*Dd*f**3*fd*r**2 + 33600*D1*Dd*f**3*fd*r*s - 42000*D1*Dd*f**3*fd*r - 16800*D1*Dd*f**3*fd*s + 12600*D1*Dd*f**3*fd + 15448*D1*Dd*f**3*r**2 + 448*D1*Dd*f**3*r*s - 15560*D1*Dd*f**3*r - 15000*D1*Dd*f**3*s**2 + 7276*D1*Dd*f**3*s + 3974*D1*Dd*f**3 - 52680*D1*Dd*f**2*fd*r**2 - 7680*D1*Dd*f**2*fd*r*s + 46140*D1*Dd*f**2*fd*r + 45000*D1*Dd*f**2*fd*s**2 - 23050*D1*Dd*f**2*fd*s - 5990*D1*Dd*f**2*fd + 15840*D1*Dd*f**2*g2*r**2 - 15840*D1*Dd*f**2*g2*r*s - 11880*D1*Dd*f**2*g2*r - 31680*D1*Dd*f**2*g2*s**2 + 23760*D1*Dd*f**2*g2*s - 15840*D1*Dd*f**2*gd2*r**2 + 15840*D1*Dd*f**2*gd2*r*s + 21780*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 19800*D1*Dd*f**2*gd2*s - 5940*D1*Dd*f**2*gd2 - 31680*D1*Dd*f*fd*g2*r**2 + 31680*D1*Dd*f*fd*g2*r*s + 3960*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 55440*D1*Dd*f*fd*g2*s + 11880*D1*Dd*f*fd*g2 + 3960*D1*Ddd*K*b1*f**2*r**2 - 3960*D1*Ddd*K*b1*f**2*r*s - 2970*D1*Ddd*K*b1*f**2*r - 7920*D1*Ddd*K*b1*f**2*s**2 + 5940*D1*Ddd*K*b1*f**2*s - 2100*D1*Ddd*b1*f**3*r**2 + 2100*D1*Ddd*b1*f**3*r + 2100*D1*Ddd*b1*f**3*s**2 - 1050*D1*Ddd*b1*f**3*s - 525*D1*Ddd*b1*f**3 - 5940*D1*Ddd*b1*f**2*r**2 - 3960*D1*Ddd*b1*f**2*r*s + 6930*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s**2 + 990*D1*Ddd*b1*f**2*s - 2475*D1*Ddd*b1*f**2 + 4200*D1*Ddd*f**4*r**2 + 4200*D1*Ddd*f**4*r*s - 5250*D1*Ddd*f**4*r - 2100*D1*Ddd*f**4*s + 2100*D1*Ddd*f**4 - 8780*D1*Ddd*f**3*r**2 - 1280*D1*Ddd*f**3*r*s + 9100*D1*Ddd*f**3*r + 7500*D1*Ddd*f**3*s**2 - 3110*D1*Ddd*f**3*s - 2515*D1*Ddd*f**3 - 7920*D1*Ddd*f**2*g2*r**2 + 7920*D1*Ddd*f**2*g2*r*s + 5940*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 11880*D1*Ddd*f**2*g2*s + 30*D1*bd1*f*(D1*(35*f**2*(r**2 - 2*r - s**2 + 1) + f*(-35*fd*(3*r**2 - 4*r - 3*s**2 + s + 1) + (-33*r - 33*s + 33)*(2*K*(r - 2*s - 1) - 3*r + s + 3)) + 33*fd*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1)) + Dd*f*(33*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 35*f*(4*r**2 - 6*r - 4*s**2 + s + 2) - 396*r**2 - 264*r*s + 627*r + 132*s**2 + 165*s - 231)) + 11880*Dd**2*K*b1*f**2*r**2 - 11880*Dd**2*K*b1*f**2*r*s - 8910*Dd**2*K*b1*f**2*r - 23760*Dd**2*K*b1*f**2*s**2 + 17820*Dd**2*K*b1*f**2*s - 6300*Dd**2*b1*f**3*r**2 + 6300*Dd**2*b1*f**3*r + 6300*Dd**2*b1*f**3*s**2 - 3150*Dd**2*b1*f**3*s - 1050*Dd**2*b1*f**3 - 17820*Dd**2*b1*f**2*r**2 - 11880*Dd**2*b1*f**2*r*s + 20790*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s**2 + 2970*Dd**2*b1*f**2*s - 4950*Dd**2*b1*f**2 + 12600*Dd**2*f**4*r**2 + 12600*Dd**2*f**4*r*s - 15750*Dd**2*f**4*r - 6300*Dd**2*f**4*s + 4200*Dd**2*f**4 - 26340*Dd**2*f**3*r**2 - 3840*Dd**2*f**3*r*s + 27300*Dd**2*f**3*r + 22500*Dd**2*f**3*s**2 - 9330*Dd**2*f**3*s - 5030*Dd**2*f**3 - 23760*Dd**2*f**2*g2*r**2 + 23760*Dd**2*f**2*g2*r*s + 17820*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 35640*Dd**2*f**2*g2*s)/(693*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**5*k1*k2**3*(264*C*D1**2*bdd1*f**2*r**2 - 1056*C*D1**2*bdd1*f**2*r*s - 1584*C*D1**2*bdd1*f**2*r - 1320*C*D1**2*bdd1*f**2*s**2 - 34860*C*D1**2*f**2*fd*r**2 - 68880*C*D1**2*f**2*fd*r*s + 46200*C*D1**2*f**2*fd*r - 34020*C*D1**2*f**2*fd*s**2 + 45640*C*D1**2*f**2*fd*s - 22960*C*D1**2*f**2*fd + 30300*C*D1**2*f**2*fdd*r**2 + 58200*C*D1**2*f**2*fdd*r*s - 39600*C*D1**2*f**2*fdd*r + 27900*C*D1**2*f**2*fdd*s**2 - 38000*C*D1**2*f**2*fdd*s + 19400*C*D1**2*f**2*fdd + 60600*C*D1**2*f*fd**2*r**2 + 116400*C*D1**2*f*fd**2*r*s - 79200*C*D1**2*f*fd**2*r + 55800*C*D1**2*f*fd**2*s**2 - 76000*C*D1**2*f*fd**2*s + 19400*C*D1**2*f*fd**2 - 46480*C*D1*Dd*f**3*r**2 - 91840*C*D1*Dd*f**3*r*s + 69440*C*D1*Dd*f**3*r - 45360*C*D1*Dd*f**3*s**2 + 68600*C*D1*Dd*f**3*s - 34580*C*D1*Dd*f**3 + 242400*C*D1*Dd*f**2*fd*r**2 + 465600*C*D1*Dd*f**2*fd*r*s - 337800*C*D1*Dd*f**2*fd*r + 223200*C*D1*Dd*f**2*fd*s**2 - 324200*C*D1*Dd*f**2*fd*s + 117200*C*D1*Dd*f**2*fd + 40400*C*D1*Ddd*f**3*r**2 + 77600*C*D1*Ddd*f**3*r*s - 59800*C*D1*Ddd*f**3*r + 37200*C*D1*Ddd*f**3*s**2 - 57400*C*D1*Ddd*f**3*s + 29500*C*D1*Ddd*f**3 + 121200*C*Dd**2*f**3*r**2 + 232800*C*Dd**2*f**3*r*s - 179400*C*Dd**2*f**3*r + 111600*C*Dd**2*f**3*s**2 - 172200*C*Dd**2*f**3*s + 59000*C*Dd**2*f**3 + 5280*D1**2*K*bdd1*f**2*r**2 + 10824*D1**2*K*bdd1*f**2*r*s - 10560*D1**2*K*bdd1*f**2*r + 5544*D1**2*K*bdd1*f**2*s**2 - 10824*D1**2*K*bdd1*f**2*s + 5280*D1**2*K*bdd1*f**2 - 3696*D1**2*b2*f*fd*r**2 - 7392*D1**2*b2*f*fd*r*s + 3696*D1**2*b2*f*fd*r - 3696*D1**2*b2*f*fd*s**2 + 3696*D1**2*b2*f*fd*s - 1848*D1**2*b2*f*fd + 2640*D1**2*b2*f*fdd*r**2 + 5280*D1**2*b2*f*fdd*r*s - 2640*D1**2*b2*f*fdd*r + 2640*D1**2*b2*f*fdd*s**2 - 2640*D1**2*b2*f*fdd*s + 1320*D1**2*b2*f*fdd + 2640*D1**2*b2*fd**2*r**2 + 5280*D1**2*b2*fd**2*r*s - 2640*D1**2*b2*fd**2*r + 2640*D1**2*b2*fd**2*s**2 - 2640*D1**2*b2*fd**2*s + 132*D1**2*bd1**2*f*(r + s - 1)*(-12*K*s - 6*K + 5*f - 12*r + 12) - 1848*D1**2*bd2*f**2*r**2 - 3696*D1**2*bd2*f**2*r*s + 3696*D1**2*bd2*f**2*r - 1848*D1**2*bd2*f**2*s**2 + 3696*D1**2*bd2*f**2*s - 1848*D1**2*bd2*f**2 + 5280*D1**2*bd2*f*fd*r**2 + 10560*D1**2*bd2*f*fd*r*s - 7920*D1**2*bd2*f*fd*r + 5280*D1**2*bd2*f*fd*s**2 - 7920*D1**2*bd2*f*fd*s + 2640*D1**2*bd2*f*fd - 1815*D1**2*bdd1*f**3*r**2 - 3630*D1**2*bdd1*f**3*r*s + 4290*D1**2*bdd1*f**3*r - 1815*D1**2*bdd1*f**3*s**2 + 4290*D1**2*bdd1*f**3*s - 2475*D1**2*bdd1*f**3 - 2904*D1**2*bdd1*f**2*r**2 - 4356*D1**2*bdd1*f**2*r*s + 6204*D1**2*bdd1*f**2*r - 1452*D1**2*bdd1*f**2*s**2 + 4752*D1**2*bdd1*f**2*s - 2310*D1**2*bdd1*f**2 + 1584*D1**2*bdd1*f*g2*r*s + 1584*D1**2*bdd1*f*g2*r + 1584*D1**2*bdd1*f*g2*s**2 + 1320*D1**2*bdd2*f**2*r**2 + 2640*D1**2*bdd2*f**2*r*s - 2640*D1**2*bdd2*f**2*r + 1320*D1**2*bdd2*f**2*s**2 - 2640*D1**2*bdd2*f**2*s + 1320*D1**2*bdd2*f**2 + 21795*D1**2*f**2*fd*r**2 + 43950*D1**2*f**2*fd*r*s - 29180*D1**2*f**2*fd*r + 22155*D1**2*f**2*fd*s**2 - 29420*D1**2*f**2*fd*s + 14650*D1**2*f**2*fd - 21045*D1**2*f**2*fdd*r**2 - 40290*D1**2*f**2*fdd*r*s + 27460*D1**2*f**2*fdd*r - 19245*D1**2*f**2*fdd*s**2 + 26260*D1**2*f**2*fdd*s - 13430*D1**2*f**2*fdd + 10824*D1**2*f**2*gd2*r**2 + 24288*D1**2*f**2*gd2*r*s - 21648*D1**2*f**2*gd2*r + 13464*D1**2*f**2*gd2*s**2 - 24288*D1**2*f**2*gd2*s + 10824*D1**2*f**2*gd2 - 10560*D1**2*f**2*gdd2*r**2 - 21648*D1**2*f**2*gdd2*r*s + 21120*D1**2*f**2*gdd2*r - 11088*D1**2*f**2*gdd2*s**2 + 21648*D1**2*f**2*gdd2*s - 10560*D1**2*f**2*gdd2 - 42090*D1**2*f*fd**2*r**2 - 80580*D1**2*f*fd**2*r*s + 54920*D1**2*f*fd**2*r - 38490*D1**2*f*fd**2*s**2 + 52520*D1**2*f*fd**2*s - 13430*D1**2*f*fd**2 + 21648*D1**2*f*fd*g2*r**2 + 48576*D1**2*f*fd*g2*r*s - 24288*D1**2*f*fd*g2*r + 26928*D1**2*f*fd*g2*s**2 - 26928*D1**2*f*fd*g2*s + 13464*D1**2*f*fd*g2 - 42240*D1**2*f*fd*gd2*r**2 - 86592*D1**2*f*fd*gd2*r*s + 63888*D1**2*f*fd*gd2*r - 44352*D1**2*f*fd*gd2*s**2 + 65472*D1**2*f*fd*gd2*s - 21648*D1**2*f*fd*gd2 - 21120*D1**2*f*fdd*g2*r**2 - 43296*D1**2*f*fdd*g2*r*s + 21648*D1**2*f*fdd*g2*r - 22176*D1**2*f*fdd*g2*s**2 + 22176*D1**2*f*fdd*g2*s - 11088*D1**2*f*fdd*g2 - 21120*D1**2*fd**2*g2*r**2 - 43296*D1**2*fd**2*g2*r*s + 21648*D1**2*fd**2*g2*r - 22176*D1**2*fd**2*g2*s**2 + 22176*D1**2*fd**2*g2*s - 7392*D1*Dd*b2*f**2*r**2 - 14784*D1*Dd*b2*f**2*r*s + 11088*D1*Dd*b2*f**2*r - 7392*D1*Dd*b2*f**2*s**2 + 11088*D1*Dd*b2*f**2*s - 5544*D1*Dd*b2*f**2 + 21120*D1*Dd*b2*f*fd*r**2 + 42240*D1*Dd*b2*f*fd*r*s - 26400*D1*Dd*b2*f*fd*r + 21120*D1*Dd*b2*f*fd*s**2 - 26400*D1*Dd*b2*f*fd*s + 7920*D1*Dd*b2*f*fd + 10560*D1*Dd*bd2*f**2*r**2 + 21120*D1*Dd*bd2*f**2*r*s - 18480*D1*Dd*bd2*f**2*r + 10560*D1*Dd*bd2*f**2*s**2 - 18480*D1*Dd*bd2*f**2*s + 7920*D1*Dd*bd2*f**2 + 29060*D1*Dd*f**3*r**2 + 58600*D1*Dd*f**3*r*s - 43710*D1*Dd*f**3*r + 29540*D1*Dd*f**3*s**2 - 44070*D1*Dd*f**3*s + 21915*D1*Dd*f**3 - 168360*D1*Dd*f**2*fd*r**2 - 322320*D1*Dd*f**2*fd*r*s + 234310*D1*Dd*f**2*fd*r - 153960*D1*Dd*f**2*fd*s**2 + 224110*D1*Dd*f**2*fd*s - 81180*D1*Dd*f**2*fd + 43296*D1*Dd*f**2*g2*r**2 + 97152*D1*Dd*f**2*g2*r*s - 67584*D1*Dd*f**2*g2*r + 53856*D1*Dd*f**2*g2*s**2 - 75504*D1*Dd*f**2*g2*s + 35112*D1*Dd*f**2*g2 - 84480*D1*Dd*f**2*gd2*r**2 - 173184*D1*Dd*f**2*gd2*r*s + 148368*D1*Dd*f**2*gd2*r - 88704*D1*Dd*f**2*gd2*s**2 + 152064*D1*Dd*f**2*gd2*s - 63888*D1*Dd*f**2*gd2 - 168960*D1*Dd*f*fd*g2*r**2 - 346368*D1*Dd*f*fd*g2*r*s + 214368*D1*Dd*f*fd*g2*r - 177408*D1*Dd*f*fd*g2*s**2 + 219648*D1*Dd*f*fd*g2*s - 65472*D1*Dd*f*fd*g2 + 5280*D1*Ddd*b2*f**2*r**2 + 10560*D1*Ddd*b2*f**2*r*s - 7920*D1*Ddd*b2*f**2*r + 5280*D1*Ddd*b2*f**2*s**2 - 7920*D1*Ddd*b2*f**2*s + 3960*D1*Ddd*b2*f**2 - 28060*D1*Ddd*f**3*r**2 - 53720*D1*Ddd*f**3*r*s + 41490*D1*Ddd*f**3*r - 25660*D1*Ddd*f**3*s**2 + 39690*D1*Ddd*f**3*s - 20445*D1*Ddd*f**3 - 42240*D1*Ddd*f**2*g2*r**2 - 86592*D1*Ddd*f**2*g2*r*s + 63888*D1*Ddd*f**2*g2*r - 44352*D1*Ddd*f**2*g2*s**2 + 65472*D1*Ddd*f**2*g2*s - 32208*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(5*f**3*(7*r**2 + 18*r*(s - 1) + 11*(s - 1)**2) - 2*f**2*(8*C*r**2 - 32*C*r*s - 48*C*r - 40*C*s**2 + 2*K*(41*r**2 + 92*r*s - 82*r + 51*s**2 - 92*s + 41) + 5*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) - 43*r**2 - 54*r*s + 98*r - 11*s**2 + 66*s - 25) + 4*f*(fd*(4*C*(2*r**2 - 2*r*(4*s + 1) - 10*s**2 + 7*s + 3) + 2*K*(80*r**2 + 164*r*s - 121*r + 84*s**2 - 124*s + 41) - 88*r**2 - 132*r*s + 124*r - 44*s**2 + 91*s - 48) - 24*g2*(r*s + r + s**2) + 12*gd2*(2*s + 1)*(r + s - 1)) + 48*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) - 2*f*(4*C*(4*r**2 - 4*r*(4*s + 3) - 20*s**2 + 9*s + 6) + K*(320*r**2 + 656*r*s - 562*r + 336*s**2 - 576*s + 242) - 176*r**2 - 264*r*s + 309*r - 88*s**2 + 232*s - 130) - 24*g2*(r*(8*s + 3) + 8*s**2 - 4*s - 2))) + 15840*Dd**2*b2*f**2*r**2 + 31680*Dd**2*b2*f**2*r*s - 23760*Dd**2*b2*f**2*r + 15840*Dd**2*b2*f**2*s**2 - 23760*Dd**2*b2*f**2*s + 7920*Dd**2*b2*f**2 - 84180*Dd**2*f**3*r**2 - 161160*Dd**2*f**3*r*s + 124470*Dd**2*f**3*r - 76980*Dd**2*f**3*s**2 + 119070*Dd**2*f**3*s - 40890*Dd**2*f**3 - 126720*Dd**2*f**2*g2*r**2 - 259776*Dd**2*f**2*g2*r*s + 191664*Dd**2*f**2*g2*r - 133056*Dd**2*f**2*g2*s**2 + 196416*Dd**2*f**2*g2*s - 64416*Dd**2*f**2*g2 + 66*b1**2*(D1**2*(10*f*fd*(2*r + 2*s - 1) - 5*f*fdd*(2*r + 2*s - 1) - 10*fd**2*(r + s - 1) + 12*fd*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1) - 6*fdd*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1)) - 2*D1*(Dd*(f*(-12*K*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(4*r + 4*s - 3) - 48*r**2 - 48*r*s + 60*r + 24*s - 24) + 6*fd*(K*(8*r*s - 9*r + 8*s**2 - 12*s + 6) + 8*r**2 + 8*r*s - r + 2*s - 3)) + 6*Ddd*f*(K*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - 12*Dd**2*f*(K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) - 33*b1*(32*C*D1**2*f*fd*r**2 - 128*C*D1**2*f*fd*r*s + 128*C*D1**2*f*fd*r - 160*C*D1**2*f*fd*s**2 + 224*C*D1**2*f*fd*s - 64*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r**2 + 64*C*D1**2*f*fdd*r*s - 64*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 - 112*C*D1**2*f*fdd*s + 32*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r**2 + 64*C*D1**2*fd**2*r*s - 64*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 - 112*C*D1**2*fd**2*s + 80*C*D1**2*fd**2 + 64*C*D1*Dd*f**2*r**2 - 256*C*D1*Dd*f**2*r*s - 320*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 - 128*C*D1*Dd*f*fd*r**2 + 512*C*D1*Dd*f*fd*r*s - 256*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 736*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r**2 + 128*C*D1*Ddd*f**2*r*s + 160*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 24*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r**2 + 384*C*Dd**2*f**2*r*s + 480*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 + 328*D1**2*K*f*fd*r**2 + 736*D1**2*K*f*fd*r*s - 368*D1**2*K*f*fd*r + 408*D1**2*K*f*fd*s**2 - 408*D1**2*K*f*fd*s + 204*D1**2*K*f*fd - 320*D1**2*K*f*fdd*r**2 - 656*D1**2*K*f*fdd*r*s + 328*D1**2*K*f*fdd*r - 336*D1**2*K*f*fdd*s**2 + 336*D1**2*K*f*fdd*s - 168*D1**2*K*f*fdd - 320*D1**2*K*fd**2*r**2 - 656*D1**2*K*fd**2*r*s + 328*D1**2*K*fd**2*r - 336*D1**2*K*fd**2*s**2 + 336*D1**2*K*fd**2*s + 2*D1**2*bdd1*f*(24*K*s**2 - 5*f*(2*r + 2*s - 1) + 24*r**2 + 12*r*(2*K*s + K + 2*s - 4) - 6*s*(2*K + 4) + 18) - 105*D1**2*f**2*fd*r**2 - 270*D1**2*f**2*fd*r*s + 140*D1**2*f**2*fd*r - 165*D1**2*f**2*fd*s**2 + 180*D1**2*f**2*fd*s - 70*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 172*D1**2*f*fd*r**2 - 216*D1**2*f*fd*r*s + 84*D1**2*f*fd*r - 44*D1**2*f*fd*s**2 + 20*D1**2*f*fd*s - 58*D1**2*f*fd + 176*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 120*D1**2*f*fdd*r + 88*D1**2*f*fdd*s**2 - 76*D1**2*f*fdd*s + 62*D1**2*f*fdd + 96*D1**2*f*gd2*r*s + 96*D1**2*f*gd2*s**2 - 96*D1**2*f*gd2*s - 48*D1**2*f*gdd2*r*s - 48*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s + 176*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 120*D1**2*fd**2*r + 88*D1**2*fd**2*s**2 - 76*D1**2*fd**2*s - 60*D1**2*fd**2 + 96*D1**2*fd*g2*r*s - 192*D1**2*fd*g2*r + 96*D1**2*fd*g2*s**2 - 192*D1**2*fd*g2*s + 96*D1**2*fd*g2 - 96*D1**2*fd*gd2*r*s + 96*D1**2*fd*gd2*r - 96*D1**2*fd*gd2*s**2 + 144*D1**2*fd*gd2*s - 96*D1**2*fd*gd2 - 48*D1**2*fdd*g2*r*s + 96*D1**2*fdd*g2*r - 48*D1**2*fdd*g2*s**2 + 96*D1**2*fdd*g2*s - 48*D1**2*fdd*g2 + 656*D1*Dd*K*f**2*r**2 + 1472*D1*Dd*K*f**2*r*s - 1024*D1*Dd*K*f**2*r + 816*D1*Dd*K*f**2*s**2 - 1144*D1*Dd*K*f**2*s + 532*D1*Dd*K*f**2 - 2560*D1*Dd*K*f*fd*r**2 - 5248*D1*Dd*K*f*fd*r*s + 3248*D1*Dd*K*f*fd*r - 2688*D1*Dd*K*f*fd*s**2 + 3328*D1*Dd*K*f*fd*s - 992*D1*Dd*K*f*fd - 140*D1*Dd*f**3*r**2 - 360*D1*Dd*f**3*r*s + 230*D1*Dd*f**3*r - 220*D1*Dd*f**3*s**2 + 290*D1*Dd*f**3*s - 125*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1790*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 344*D1*Dd*f**2*r**2 - 432*D1*Dd*f**2*r*s + 452*D1*Dd*f**2*r - 88*D1*Dd*f**2*s**2 + 260*D1*Dd*f**2*s - 194*D1*Dd*f**2 + 1408*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 1448*D1*Dd*f*fd*r + 704*D1*Dd*f*fd*s**2 - 1008*D1*Dd*f*fd*s + 316*D1*Dd*f*fd + 384*D1*Dd*f*g2*r*s - 96*D1*Dd*f*g2*r + 384*D1*Dd*f*g2*s**2 - 384*D1*Dd*f*g2*s + 96*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r*s + 48*D1*Dd*f*gd2*r - 384*D1*Dd*f*gd2*s**2 + 384*D1*Dd*f*gd2*s - 48*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r*s + 432*D1*Dd*fd*g2*r - 384*D1*Dd*fd*g2*s**2 + 576*D1*Dd*fd*g2*s - 288*D1*Dd*fd*g2 - 640*D1*Ddd*K*f**2*r**2 - 1312*D1*Ddd*K*f**2*r*s + 968*D1*Ddd*K*f**2*r - 672*D1*Ddd*K*f**2*s**2 + 992*D1*Ddd*K*f**2*s - 488*D1*Ddd*K*f**2 + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 352*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 484*D1*Ddd*f**2*r + 176*D1*Ddd*f**2*s**2 - 352*D1*Ddd*f**2*s + 220*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r*s + 48*D1*Ddd*f*g2*r - 192*D1*Ddd*f*g2*s**2 + 192*D1*Ddd*f*g2*s - 48*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(2*r + 2*s - 1) - 6*f*(4*K*s**2 + 4*r**2 + 2*r*(2*K*s + K + 2*s - 4) - s*(2*K + 4) + 3) + 6*fd*(K*(r*(4*s - 3) + 4*s**2 - 5*s + 2) + 4*r**2 + r*(4*s - 2) - 1)) + Dd*f*(6*K*(2*r*(8*s + 1) + 16*s**2 - 12*s - 1) - 5*f*(4*r + 4*s - 3) + 96*r**2 + 12*r*(8*s - 13) - 72*s + 60)) - 1920*Dd**2*K*f**2*r**2 - 3936*Dd**2*K*f**2*r*s + 2904*Dd**2*K*f**2*r - 2016*Dd**2*K*f**2*s**2 + 2976*Dd**2*K*f**2*s - 976*Dd**2*K*f**2 + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 330*Dd**2*f**3 + 1056*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 1452*Dd**2*f**2*r + 528*Dd**2*f**2*s**2 - 1056*Dd**2*f**2*s + 440*Dd**2*f**2 - 576*Dd**2*f*g2*r*s + 144*Dd**2*f*g2*r - 576*Dd**2*f*g2*s**2 + 576*Dd**2*f*g2*s - 96*Dd**2*f*g2))/(693*d**2*k3**6) - 20*D1**2*Pk2*Pk3*ct**5*k1*st**2*(b1*(D1**2*(35*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-70*fd**2*s*(3*s - 2) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(35*f**2*(4*s**2 - 2*s + 1) - 35*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(35*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(35*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(70*bd1 - 35*bdd1) + f*(-10*fd*(s**2*(21*bd1 - 15) + s*(10 - 7*bd1) - 5) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(-10*Dd*f*(s**2*(28*bd1 - 20) + s*(10 - 7*bd1) - 5) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2*k3**2) - 8*D1**2*Pk2*Pk3*ct**5*k1*(-D1*f*s*(2*D1*bd1**2*s*(5*f + 6) + 5*D1*bdd1*f*s + 10*bd1*(-D1*(f*s - 2*fd*s + fd) + Dd*f*(4*s - 1))) + b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 12*fd*(s - 1)**2 - 6*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 6*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 6)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 6)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) + f*(-10*fd*(s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(24*bd1 - 12*bdd1)) - 2*fd*s*(12*bd1 + 5*fd)*(s - 1)) + D1*f*(-2*Dd*(5*f*(s**2*(8*bd1 - 4) - s*(2*bd1 - 2) - 1) + (4*s - 1)*(12*bd1*s + 5*fd*(2*s - 1))) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k2**3) - 160*D1**2*Pk2*Pk3*ct**4*f**2*k1**6*(D1**2*(f*(38*fd - 45*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 45*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(38*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 90*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) - 45*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 45*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1287*d**2*k2**2*k3**6) - 80*D1**2*Pk2*Pk3*ct**4*f*k1**2*k2**4*st**4*(D1**2*(70*f**2*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*f*(140*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - fd*(26*C - 26)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(13*C - 13)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2)) + fd**2*(78 - 78*C)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(70*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(39*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 70*fd*(4*r + 4*s - 3)**2 - 156*r**2 - 312*r*s + 234*r - 156*s**2 + 234*s - 117) - fd*(39*C - 39)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - Ddd*f*(39*C + 70*f - 39)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(39*C + 70*f - 39)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1001*d**2*k3**8) - 320*D1**2*Pk2*Pk3*ct**4*f*k1**2*k2**2*st**4*(D1**2*(70*f**2*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-70*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + fd*(78*C - 78)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(39*C - 39)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(39*C - 39)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(140*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(78*C*(r*(4*s - 1) + (1 - 2*s)**2) - 140*fd*(4*s - 1)*(4*r + 4*s - 3) - 78*r*(4*s - 1) - 78*(1 - 2*s)**2) - fd*(39*C - 39)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(39*C + 70*f - 39)) - Dd**2*f**2*(39*C + 70*f - 39)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k3**6) - 80*D1**2*Pk2*Pk3*ct**4*f*k1**2*st**4*(D1**2*(70*f**2*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 420*f*fd**2*s*(2*s - 1) + f*fd*(78*C - 78)*(3*s**2 - 2*s + 1) - f*fdd*(39*C - 39)*(3*s**2 - 2*s + 1) - fd**2*s*(78*C - 78)*(3*s - 2)) + D1*f*(2*Dd*(70*f**2*(4*s**2 - 2*s + 1) + f*(39*C*(4*s**2 - 2*s + 1) - 70*fd*(1 - 4*s)**2 - 156*s**2 + 78*s - 39) - fd*(39*C - 39)*(12*s**2 - 7*s + 1)) - Ddd*f*(39*C + 70*f - 39)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(39*C + 70*f - 39))/(1001*d**2*k3**4) - 8*D1**2*Pk2*Pk3*ct**4*k1**6*(8970*C*D1**2*f**2*fd*r**2 + 17940*C*D1**2*f**2*fd*r*s - 11960*C*D1**2*f**2*fd*r + 8970*C*D1**2*f**2*fd*s**2 - 11960*C*D1**2*f**2*fd*s + 5980*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r**2 - 21840*C*D1**2*f**2*fdd*r*s + 14560*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 14560*C*D1**2*f**2*fdd*s - 7280*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r**2 - 43680*C*D1**2*f*fd**2*r*s + 29120*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 29120*C*D1**2*f*fd**2*s - 7280*C*D1**2*f*fd**2 + 11960*C*D1*Dd*f**3*r**2 + 23920*C*D1*Dd*f**3*r*s - 17940*C*D1*Dd*f**3*r + 11960*C*D1*Dd*f**3*s**2 - 17940*C*D1*Dd*f**3*s + 8970*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r**2 - 174720*C*D1*Dd*f**2*fd*r*s + 123760*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 123760*C*D1*Dd*f**2*fd*s - 43680*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r**2 - 29120*C*D1*Ddd*f**3*r*s + 21840*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 21840*C*D1*Ddd*f**3*s - 10920*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r**2 - 87360*C*Dd**2*f**3*r*s + 65520*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 65520*C*Dd**2*f**3*s - 21840*C*Dd**2*f**3 + 3432*D1**2*K*b1*f*fd*r**2 + 6864*D1**2*K*b1*f*fd*r*s - 3432*D1**2*K*b1*f*fd*r + 3432*D1**2*K*b1*f*fd*s**2 - 3432*D1**2*K*b1*f*fd*s + 1716*D1**2*K*b1*f*fd - 4290*D1**2*K*b1*f*fdd*r**2 - 8580*D1**2*K*b1*f*fdd*r*s + 4290*D1**2*K*b1*f*fdd*r - 4290*D1**2*K*b1*f*fdd*s**2 + 4290*D1**2*K*b1*f*fdd*s - 2145*D1**2*K*b1*f*fdd - 4290*D1**2*K*b1*fd**2*r**2 - 8580*D1**2*K*b1*fd**2*r*s + 4290*D1**2*K*b1*fd**2*r - 4290*D1**2*K*b1*fd**2*s**2 + 4290*D1**2*K*b1*fd**2*s - 3432*D1**2*b1*f*fd*r**2 - 6864*D1**2*b1*f*fd*r*s + 3432*D1**2*b1*f*fd*r - 3432*D1**2*b1*f*fd*s**2 + 3432*D1**2*b1*f*fd*s - 1716*D1**2*b1*f*fd + 4290*D1**2*b1*f*fdd*r**2 + 8580*D1**2*b1*f*fdd*r*s - 4290*D1**2*b1*f*fdd*r + 4290*D1**2*b1*f*fdd*s**2 - 4290*D1**2*b1*f*fdd*s + 2145*D1**2*b1*f*fdd + 4290*D1**2*b1*fd**2*r**2 + 8580*D1**2*b1*fd**2*r*s - 4290*D1**2*b1*fd**2*r + 4290*D1**2*b1*fd**2*s**2 - 4290*D1**2*b1*fd**2*s - 2145*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 26600*D1**2*f**3*fd*r**2 + 53200*D1**2*f**3*fd*r*s - 39900*D1**2*f**3*fd*r + 26600*D1**2*f**3*fd*s**2 - 39900*D1**2*f**3*fd*s + 19950*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 - 8970*D1**2*f**2*fd*r**2 - 17940*D1**2*f**2*fd*r*s + 11960*D1**2*f**2*fd*r - 8970*D1**2*f**2*fd*s**2 + 11960*D1**2*f**2*fd*s - 5980*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r**2 + 21840*D1**2*f**2*fdd*r*s - 14560*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 14560*D1**2*f**2*fdd*s + 7280*D1**2*f**2*fdd - 3432*D1**2*f**2*gd2*r**2 - 6864*D1**2*f**2*gd2*r*s + 6864*D1**2*f**2*gd2*r - 3432*D1**2*f**2*gd2*s**2 + 6864*D1**2*f**2*gd2*s - 3432*D1**2*f**2*gd2 + 4290*D1**2*f**2*gdd2*r**2 + 8580*D1**2*f**2*gdd2*r*s - 8580*D1**2*f**2*gdd2*r + 4290*D1**2*f**2*gdd2*s**2 - 8580*D1**2*f**2*gdd2*s + 4290*D1**2*f**2*gdd2 + 21840*D1**2*f*fd**2*r**2 + 43680*D1**2*f*fd**2*r*s - 29120*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 29120*D1**2*f*fd**2*s + 7280*D1**2*f*fd**2 - 6864*D1**2*f*fd*g2*r**2 - 13728*D1**2*f*fd*g2*r*s + 6864*D1**2*f*fd*g2*r - 6864*D1**2*f*fd*g2*s**2 + 6864*D1**2*f*fd*g2*s - 3432*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r**2 + 34320*D1**2*f*fd*gd2*r*s - 25740*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 25740*D1**2*f*fd*gd2*s + 8580*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r**2 + 17160*D1**2*f*fdd*g2*r*s - 8580*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r**2 + 17160*D1**2*fd**2*g2*r*s - 8580*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 6864*D1*Dd*K*b1*f**2*r**2 + 13728*D1*Dd*K*b1*f**2*r*s - 10296*D1*Dd*K*b1*f**2*r + 6864*D1*Dd*K*b1*f**2*s**2 - 10296*D1*Dd*K*b1*f**2*s + 5148*D1*Dd*K*b1*f**2 - 34320*D1*Dd*K*b1*f*fd*r**2 - 68640*D1*Dd*K*b1*f*fd*r*s + 42900*D1*Dd*K*b1*f*fd*r - 34320*D1*Dd*K*b1*f*fd*s**2 + 42900*D1*Dd*K*b1*f*fd*s - 12870*D1*Dd*K*b1*f*fd - 6864*D1*Dd*b1*f**2*r**2 - 13728*D1*Dd*b1*f**2*r*s + 10296*D1*Dd*b1*f**2*r - 6864*D1*Dd*b1*f**2*s**2 + 10296*D1*Dd*b1*f**2*s - 5148*D1*Dd*b1*f**2 + 34320*D1*Dd*b1*f*fd*r**2 + 68640*D1*Dd*b1*f*fd*r*s - 42900*D1*Dd*b1*f*fd*r + 34320*D1*Dd*b1*f*fd*s**2 - 42900*D1*Dd*b1*f*fd*s + 12870*D1*Dd*b1*f*fd + 26600*D1*Dd*f**4*r**2 + 53200*D1*Dd*f**4*r*s - 39900*D1*Dd*f**4*r + 26600*D1*Dd*f**4*s**2 - 39900*D1*Dd*f**4*s + 19950*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd - 11960*D1*Dd*f**3*r**2 - 23920*D1*Dd*f**3*r*s + 17940*D1*Dd*f**3*r - 11960*D1*Dd*f**3*s**2 + 17940*D1*Dd*f**3*s - 8970*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r**2 + 174720*D1*Dd*f**2*fd*r*s - 123760*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 123760*D1*Dd*f**2*fd*s + 43680*D1*Dd*f**2*fd - 13728*D1*Dd*f**2*g2*r**2 - 27456*D1*Dd*f**2*g2*r*s + 20592*D1*Dd*f**2*g2*r - 13728*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 10296*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r**2 + 68640*D1*Dd*f**2*gd2*r*s - 60060*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 60060*D1*Dd*f**2*gd2*s + 25740*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r**2 + 137280*D1*Dd*f*fd*g2*r*s - 85800*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 85800*D1*Dd*f*fd*g2*s + 25740*D1*Dd*f*fd*g2 - 8580*D1*Ddd*K*b1*f**2*r**2 - 17160*D1*Ddd*K*b1*f**2*r*s + 12870*D1*Ddd*K*b1*f**2*r - 8580*D1*Ddd*K*b1*f**2*s**2 + 12870*D1*Ddd*K*b1*f**2*s - 6435*D1*Ddd*K*b1*f**2 + 8580*D1*Ddd*b1*f**2*r**2 + 17160*D1*Ddd*b1*f**2*r*s - 12870*D1*Ddd*b1*f**2*r + 8580*D1*Ddd*b1*f**2*s**2 - 12870*D1*Ddd*b1*f**2*s + 6435*D1*Ddd*b1*f**2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r**2 + 29120*D1*Ddd*f**3*r*s - 21840*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 21840*D1*Ddd*f**3*s + 10920*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r**2 + 34320*D1*Ddd*f**2*g2*r*s - 25740*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 25740*D1*Ddd*f**2*g2*s + 12870*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 25740*Dd**2*K*b1*f**2*r**2 - 51480*Dd**2*K*b1*f**2*r*s + 38610*Dd**2*K*b1*f**2*r - 25740*Dd**2*K*b1*f**2*s**2 + 38610*Dd**2*K*b1*f**2*s - 12870*Dd**2*K*b1*f**2 + 25740*Dd**2*b1*f**2*r**2 + 51480*Dd**2*b1*f**2*r*s - 38610*Dd**2*b1*f**2*r + 25740*Dd**2*b1*f**2*s**2 - 38610*Dd**2*b1*f**2*s + 12870*Dd**2*b1*f**2 - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 43680*Dd**2*f**3*r**2 + 87360*Dd**2*f**3*r*s - 65520*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 65520*Dd**2*f**3*s + 21840*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r**2 + 102960*Dd**2*f**2*g2*r*s - 77220*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 77220*Dd**2*f**2*g2*s + 25740*Dd**2*f**2*g2)/(3003*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**4*k1**4*k2**2*st**2*(31356*C*D1**2*f**2*fd*r**2 + 62712*C*D1**2*f**2*fd*r*s - 41808*C*D1**2*f**2*fd*r + 31356*C*D1**2*f**2*fd*s**2 - 41808*C*D1**2*f**2*fd*s + 20904*C*D1**2*f**2*fd - 23400*C*D1**2*f**2*fdd*r**2 - 46800*C*D1**2*f**2*fdd*r*s + 31200*C*D1**2*f**2*fdd*r - 23400*C*D1**2*f**2*fdd*s**2 + 31200*C*D1**2*f**2*fdd*s - 15600*C*D1**2*f**2*fdd - 46800*C*D1**2*f*fd**2*r**2 - 93600*C*D1**2*f*fd**2*r*s + 62400*C*D1**2*f*fd**2*r - 46800*C*D1**2*f*fd**2*s**2 + 62400*C*D1**2*f*fd**2*s - 15600*C*D1**2*f*fd**2 + 41808*C*D1*Dd*f**3*r**2 + 83616*C*D1*Dd*f**3*r*s - 62712*C*D1*Dd*f**3*r + 41808*C*D1*Dd*f**3*s**2 - 62712*C*D1*Dd*f**3*s + 31356*C*D1*Dd*f**3 - 187200*C*D1*Dd*f**2*fd*r**2 - 374400*C*D1*Dd*f**2*fd*r*s + 265200*C*D1*Dd*f**2*fd*r - 187200*C*D1*Dd*f**2*fd*s**2 + 265200*C*D1*Dd*f**2*fd*s - 93600*C*D1*Dd*f**2*fd - 31200*C*D1*Ddd*f**3*r**2 - 62400*C*D1*Ddd*f**3*r*s + 46800*C*D1*Ddd*f**3*r - 31200*C*D1*Ddd*f**3*s**2 + 46800*C*D1*Ddd*f**3*s - 23400*C*D1*Ddd*f**3 - 93600*C*Dd**2*f**3*r**2 - 187200*C*Dd**2*f**3*r*s + 140400*C*Dd**2*f**3*r - 93600*C*Dd**2*f**3*s**2 + 140400*C*Dd**2*f**3*s - 46800*C*Dd**2*f**3 + 15444*D1**2*K*b1*f*fd*r**2 + 30888*D1**2*K*b1*f*fd*r*s - 15444*D1**2*K*b1*f*fd*r + 15444*D1**2*K*b1*f*fd*s**2 - 15444*D1**2*K*b1*f*fd*s + 7722*D1**2*K*b1*f*fd - 10296*D1**2*K*b1*f*fdd*r**2 - 20592*D1**2*K*b1*f*fdd*r*s + 10296*D1**2*K*b1*f*fdd*r - 10296*D1**2*K*b1*f*fdd*s**2 + 10296*D1**2*K*b1*f*fdd*s - 5148*D1**2*K*b1*f*fdd - 10296*D1**2*K*b1*fd**2*r**2 - 20592*D1**2*K*b1*fd**2*r*s + 10296*D1**2*K*b1*fd**2*r - 10296*D1**2*K*b1*fd**2*s**2 + 10296*D1**2*K*b1*fd**2*s - 15444*D1**2*b1*f*fd*r**2 - 30888*D1**2*b1*f*fd*r*s + 15444*D1**2*b1*f*fd*r - 15444*D1**2*b1*f*fd*s**2 + 15444*D1**2*b1*f*fd*s - 7722*D1**2*b1*f*fd + 10296*D1**2*b1*f*fdd*r**2 + 20592*D1**2*b1*f*fdd*r*s - 10296*D1**2*b1*f*fdd*r + 10296*D1**2*b1*f*fdd*s**2 - 10296*D1**2*b1*f*fdd*s + 5148*D1**2*b1*f*fdd + 10296*D1**2*b1*fd**2*r**2 + 20592*D1**2*b1*fd**2*r*s - 10296*D1**2*b1*fd**2*r + 10296*D1**2*b1*fd**2*s**2 - 10296*D1**2*b1*fd**2*s - 5148*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 65500*D1**2*f**3*fd*r**2 + 131000*D1**2*f**3*fd*r*s - 98250*D1**2*f**3*fd*r + 65500*D1**2*f**3*fd*s**2 - 98250*D1**2*f**3*fd*s + 49125*D1**2*f**3*fd - 49000*D1**2*f**3*fdd*r**2 - 98000*D1**2*f**3*fdd*r*s + 73500*D1**2*f**3*fdd*r - 49000*D1**2*f**3*fdd*s**2 + 73500*D1**2*f**3*fdd*s - 36750*D1**2*f**3*fdd - 147000*D1**2*f**2*fd**2*r**2 - 294000*D1**2*f**2*fd**2*r*s + 220500*D1**2*f**2*fd**2*r - 147000*D1**2*f**2*fd**2*s**2 + 220500*D1**2*f**2*fd**2*s - 73500*D1**2*f**2*fd**2 - 31356*D1**2*f**2*fd*r**2 - 62712*D1**2*f**2*fd*r*s + 41808*D1**2*f**2*fd*r - 31356*D1**2*f**2*fd*s**2 + 41808*D1**2*f**2*fd*s - 20904*D1**2*f**2*fd + 23400*D1**2*f**2*fdd*r**2 + 46800*D1**2*f**2*fdd*r*s - 31200*D1**2*f**2*fdd*r + 23400*D1**2*f**2*fdd*s**2 - 31200*D1**2*f**2*fdd*s + 15600*D1**2*f**2*fdd - 15444*D1**2*f**2*gd2*r**2 - 30888*D1**2*f**2*gd2*r*s + 30888*D1**2*f**2*gd2*r - 15444*D1**2*f**2*gd2*s**2 + 30888*D1**2*f**2*gd2*s - 15444*D1**2*f**2*gd2 + 10296*D1**2*f**2*gdd2*r**2 + 20592*D1**2*f**2*gdd2*r*s - 20592*D1**2*f**2*gdd2*r + 10296*D1**2*f**2*gdd2*s**2 - 20592*D1**2*f**2*gdd2*s + 10296*D1**2*f**2*gdd2 + 46800*D1**2*f*fd**2*r**2 + 93600*D1**2*f*fd**2*r*s - 62400*D1**2*f*fd**2*r + 46800*D1**2*f*fd**2*s**2 - 62400*D1**2*f*fd**2*s + 15600*D1**2*f*fd**2 - 30888*D1**2*f*fd*g2*r**2 - 61776*D1**2*f*fd*g2*r*s + 30888*D1**2*f*fd*g2*r - 30888*D1**2*f*fd*g2*s**2 + 30888*D1**2*f*fd*g2*s - 15444*D1**2*f*fd*g2 + 41184*D1**2*f*fd*gd2*r**2 + 82368*D1**2*f*fd*gd2*r*s - 61776*D1**2*f*fd*gd2*r + 41184*D1**2*f*fd*gd2*s**2 - 61776*D1**2*f*fd*gd2*s + 20592*D1**2*f*fd*gd2 + 20592*D1**2*f*fdd*g2*r**2 + 41184*D1**2*f*fdd*g2*r*s - 20592*D1**2*f*fdd*g2*r + 20592*D1**2*f*fdd*g2*s**2 - 20592*D1**2*f*fdd*g2*s + 10296*D1**2*f*fdd*g2 + 20592*D1**2*fd**2*g2*r**2 + 41184*D1**2*fd**2*g2*r*s - 20592*D1**2*fd**2*g2*r + 20592*D1**2*fd**2*g2*s**2 - 20592*D1**2*fd**2*g2*s + 30888*D1*Dd*K*b1*f**2*r**2 + 61776*D1*Dd*K*b1*f**2*r*s - 46332*D1*Dd*K*b1*f**2*r + 30888*D1*Dd*K*b1*f**2*s**2 - 46332*D1*Dd*K*b1*f**2*s + 23166*D1*Dd*K*b1*f**2 - 82368*D1*Dd*K*b1*f*fd*r**2 - 164736*D1*Dd*K*b1*f*fd*r*s + 102960*D1*Dd*K*b1*f*fd*r - 82368*D1*Dd*K*b1*f*fd*s**2 + 102960*D1*Dd*K*b1*f*fd*s - 30888*D1*Dd*K*b1*f*fd - 30888*D1*Dd*b1*f**2*r**2 - 61776*D1*Dd*b1*f**2*r*s + 46332*D1*Dd*b1*f**2*r - 30888*D1*Dd*b1*f**2*s**2 + 46332*D1*Dd*b1*f**2*s - 23166*D1*Dd*b1*f**2 + 82368*D1*Dd*b1*f*fd*r**2 + 164736*D1*Dd*b1*f*fd*r*s - 102960*D1*Dd*b1*f*fd*r + 82368*D1*Dd*b1*f*fd*s**2 - 102960*D1*Dd*b1*f*fd*s + 30888*D1*Dd*b1*f*fd + 65500*D1*Dd*f**4*r**2 + 131000*D1*Dd*f**4*r*s - 98250*D1*Dd*f**4*r + 65500*D1*Dd*f**4*s**2 - 98250*D1*Dd*f**4*s + 49125*D1*Dd*f**4 - 392000*D1*Dd*f**3*fd*r**2 - 784000*D1*Dd*f**3*fd*r*s + 588000*D1*Dd*f**3*fd*r - 392000*D1*Dd*f**3*fd*s**2 + 588000*D1*Dd*f**3*fd*s - 220500*D1*Dd*f**3*fd - 41808*D1*Dd*f**3*r**2 - 83616*D1*Dd*f**3*r*s + 62712*D1*Dd*f**3*r - 41808*D1*Dd*f**3*s**2 + 62712*D1*Dd*f**3*s - 31356*D1*Dd*f**3 + 187200*D1*Dd*f**2*fd*r**2 + 374400*D1*Dd*f**2*fd*r*s - 265200*D1*Dd*f**2*fd*r + 187200*D1*Dd*f**2*fd*s**2 - 265200*D1*Dd*f**2*fd*s + 93600*D1*Dd*f**2*fd - 61776*D1*Dd*f**2*g2*r**2 - 123552*D1*Dd*f**2*g2*r*s + 92664*D1*Dd*f**2*g2*r - 61776*D1*Dd*f**2*g2*s**2 + 92664*D1*Dd*f**2*g2*s - 46332*D1*Dd*f**2*g2 + 82368*D1*Dd*f**2*gd2*r**2 + 164736*D1*Dd*f**2*gd2*r*s - 144144*D1*Dd*f**2*gd2*r + 82368*D1*Dd*f**2*gd2*s**2 - 144144*D1*Dd*f**2*gd2*s + 61776*D1*Dd*f**2*gd2 + 164736*D1*Dd*f*fd*g2*r**2 + 329472*D1*Dd*f*fd*g2*r*s - 205920*D1*Dd*f*fd*g2*r + 164736*D1*Dd*f*fd*g2*s**2 - 205920*D1*Dd*f*fd*g2*s + 61776*D1*Dd*f*fd*g2 - 20592*D1*Ddd*K*b1*f**2*r**2 - 41184*D1*Ddd*K*b1*f**2*r*s + 30888*D1*Ddd*K*b1*f**2*r - 20592*D1*Ddd*K*b1*f**2*s**2 + 30888*D1*Ddd*K*b1*f**2*s - 15444*D1*Ddd*K*b1*f**2 + 20592*D1*Ddd*b1*f**2*r**2 + 41184*D1*Ddd*b1*f**2*r*s - 30888*D1*Ddd*b1*f**2*r + 20592*D1*Ddd*b1*f**2*s**2 - 30888*D1*Ddd*b1*f**2*s + 15444*D1*Ddd*b1*f**2 - 49000*D1*Ddd*f**4*r**2 - 98000*D1*Ddd*f**4*r*s + 73500*D1*Ddd*f**4*r - 49000*D1*Ddd*f**4*s**2 + 73500*D1*Ddd*f**4*s - 36750*D1*Ddd*f**4 + 31200*D1*Ddd*f**3*r**2 + 62400*D1*Ddd*f**3*r*s - 46800*D1*Ddd*f**3*r + 31200*D1*Ddd*f**3*s**2 - 46800*D1*Ddd*f**3*s + 23400*D1*Ddd*f**3 + 41184*D1*Ddd*f**2*g2*r**2 + 82368*D1*Ddd*f**2*g2*r*s - 61776*D1*Ddd*f**2*g2*r + 41184*D1*Ddd*f**2*g2*s**2 - 61776*D1*Ddd*f**2*g2*s + 30888*D1*Ddd*f**2*g2 + 2574*D1*bd1*f*(K - 1)*(r + s - 1)*(3*D1*f*(r + s - 1) - 4*D1*fd*(2*r + 2*s - 1) - 4*Dd*f*(4*r + 4*s - 3)) - 61776*Dd**2*K*b1*f**2*r**2 - 123552*Dd**2*K*b1*f**2*r*s + 92664*Dd**2*K*b1*f**2*r - 61776*Dd**2*K*b1*f**2*s**2 + 92664*Dd**2*K*b1*f**2*s - 30888*Dd**2*K*b1*f**2 + 61776*Dd**2*b1*f**2*r**2 + 123552*Dd**2*b1*f**2*r*s - 92664*Dd**2*b1*f**2*r + 61776*Dd**2*b1*f**2*s**2 - 92664*Dd**2*b1*f**2*s + 30888*Dd**2*b1*f**2 - 147000*Dd**2*f**4*r**2 - 294000*Dd**2*f**4*r*s + 220500*Dd**2*f**4*r - 147000*Dd**2*f**4*s**2 + 220500*Dd**2*f**4*s - 73500*Dd**2*f**4 + 93600*Dd**2*f**3*r**2 + 187200*Dd**2*f**3*r*s - 140400*Dd**2*f**3*r + 93600*Dd**2*f**3*s**2 - 140400*Dd**2*f**3*s + 46800*Dd**2*f**3 + 123552*Dd**2*f**2*g2*r**2 + 247104*Dd**2*f**2*g2*r*s - 185328*Dd**2*f**2*g2*r + 123552*Dd**2*f**2*g2*s**2 - 185328*Dd**2*f**2*g2*s + 61776*Dd**2*f**2*g2)/(1001*d**2*k3**8) - 8*D1**2*Pk2*Pk3*ct**4*k1**4*k2**2*(4530*C*D1**2*f**2*fd*r**2 + 9060*C*D1**2*f**2*fd*r*s - 6040*C*D1**2*f**2*fd*r + 4530*C*D1**2*f**2*fd*s**2 - 6040*C*D1**2*f**2*fd*s + 3020*C*D1**2*f**2*fd - 6720*C*D1**2*f**2*fdd*r**2 - 13440*C*D1**2*f**2*fdd*r*s + 8960*C*D1**2*f**2*fdd*r - 6720*C*D1**2*f**2*fdd*s**2 + 8960*C*D1**2*f**2*fdd*s - 4480*C*D1**2*f**2*fdd - 13440*C*D1**2*f*fd**2*r**2 - 26880*C*D1**2*f*fd**2*r*s + 17920*C*D1**2*f*fd**2*r - 13440*C*D1**2*f*fd**2*s**2 + 17920*C*D1**2*f*fd**2*s - 4480*C*D1**2*f*fd**2 + 6040*C*D1*Dd*f**3*r**2 + 12080*C*D1*Dd*f**3*r*s - 9060*C*D1*Dd*f**3*r + 6040*C*D1*Dd*f**3*s**2 - 9060*C*D1*Dd*f**3*s + 4530*C*D1*Dd*f**3 - 53760*C*D1*Dd*f**2*fd*r**2 - 107520*C*D1*Dd*f**2*fd*r*s + 76160*C*D1*Dd*f**2*fd*r - 53760*C*D1*Dd*f**2*fd*s**2 + 76160*C*D1*Dd*f**2*fd*s - 26880*C*D1*Dd*f**2*fd - 8960*C*D1*Ddd*f**3*r**2 - 17920*C*D1*Ddd*f**3*r*s + 13440*C*D1*Ddd*f**3*r - 8960*C*D1*Ddd*f**3*s**2 + 13440*C*D1*Ddd*f**3*s - 6720*C*D1*Ddd*f**3 - 26880*C*Dd**2*f**3*r**2 - 53760*C*Dd**2*f**3*r*s + 40320*C*Dd**2*f**3*r - 26880*C*Dd**2*f**3*s**2 + 40320*C*Dd**2*f**3*s - 13440*C*Dd**2*f**3 - 2376*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 132*D1**2*bdd1*f*(5*f*(3*C + 2*K - 4) - 18*g2)*(r + s - 1)**2 - 1680*D1**2*f**3*fd*r**2 - 3360*D1**2*f**3*fd*r*s + 2520*D1**2*f**3*fd*r - 1680*D1**2*f**3*fd*s**2 + 2520*D1**2*f**3*fd*s - 1260*D1**2*f**3*fd - 3150*D1**2*f**2*fd*r**2 - 6300*D1**2*f**2*fd*r*s + 4200*D1**2*f**2*fd*r - 3150*D1**2*f**2*fd*s**2 + 4200*D1**2*f**2*fd*s - 2100*D1**2*f**2*fd + 5040*D1**2*f**2*fdd*r**2 + 10080*D1**2*f**2*fdd*r*s - 6720*D1**2*f**2*fdd*r + 5040*D1**2*f**2*fdd*s**2 - 6720*D1**2*f**2*fdd*s + 3360*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 2640*D1**2*f**2*gdd2*r**2 + 5280*D1**2*f**2*gdd2*r*s - 5280*D1**2*f**2*gdd2*r + 2640*D1**2*f**2*gdd2*s**2 - 5280*D1**2*f**2*gdd2*s + 2640*D1**2*f**2*gdd2 + 10080*D1**2*f*fd**2*r**2 + 20160*D1**2*f*fd**2*r*s - 13440*D1**2*f*fd**2*r + 10080*D1**2*f*fd**2*s**2 - 13440*D1**2*f*fd**2*s + 3360*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 10560*D1**2*f*fd*gd2*r**2 + 21120*D1**2*f*fd*gd2*r*s - 15840*D1**2*f*fd*gd2*r + 10560*D1**2*f*fd*gd2*s**2 - 15840*D1**2*f*fd*gd2*s + 5280*D1**2*f*fd*gd2 + 5280*D1**2*f*fdd*g2*r**2 + 10560*D1**2*f*fdd*g2*r*s - 5280*D1**2*f*fdd*g2*r + 5280*D1**2*f*fdd*g2*s**2 - 5280*D1**2*f*fdd*g2*s + 2640*D1**2*f*fdd*g2 + 5280*D1**2*fd**2*g2*r**2 + 10560*D1**2*fd**2*g2*r*s - 5280*D1**2*fd**2*g2*r + 5280*D1**2*fd**2*g2*s**2 - 5280*D1**2*fd**2*g2*s - 1680*D1*Dd*f**4*r**2 - 3360*D1*Dd*f**4*r*s + 2520*D1*Dd*f**4*r - 1680*D1*Dd*f**4*s**2 + 2520*D1*Dd*f**4*s - 1260*D1*Dd*f**4 - 4200*D1*Dd*f**3*r**2 - 8400*D1*Dd*f**3*r*s + 6300*D1*Dd*f**3*r - 4200*D1*Dd*f**3*s**2 + 6300*D1*Dd*f**3*s - 3150*D1*Dd*f**3 + 40320*D1*Dd*f**2*fd*r**2 + 80640*D1*Dd*f**2*fd*r*s - 57120*D1*Dd*f**2*fd*r + 40320*D1*Dd*f**2*fd*s**2 - 57120*D1*Dd*f**2*fd*s + 20160*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 21120*D1*Dd*f**2*gd2*r**2 + 42240*D1*Dd*f**2*gd2*r*s - 36960*D1*Dd*f**2*gd2*r + 21120*D1*Dd*f**2*gd2*s**2 - 36960*D1*Dd*f**2*gd2*s + 15840*D1*Dd*f**2*gd2 + 42240*D1*Dd*f*fd*g2*r**2 + 84480*D1*Dd*f*fd*g2*r*s - 52800*D1*Dd*f*fd*g2*r + 42240*D1*Dd*f*fd*g2*s**2 - 52800*D1*Dd*f*fd*g2*s + 15840*D1*Dd*f*fd*g2 + 6720*D1*Ddd*f**3*r**2 + 13440*D1*Ddd*f**3*r*s - 10080*D1*Ddd*f**3*r + 6720*D1*Ddd*f**3*s**2 - 10080*D1*Ddd*f**3*s + 5040*D1*Ddd*f**3 + 10560*D1*Ddd*f**2*g2*r**2 + 21120*D1*Ddd*f**2*g2*r*s - 15840*D1*Ddd*f**2*g2*r + 10560*D1*Ddd*f**2*g2*s**2 - 15840*D1*Ddd*f**2*g2*s + 7920*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(30*C + 13*K - 35)*(r + s - 1) - 20*f*fd*(3*C + 2*K - 4)*(2*r + 2*s - 1) - f*(37*g2 - 72*gd2)*(r + s - 1) + 72*fd*g2*(r + s)) - 4*Dd*f*(5*f*(3*C + 2*K - 4) - 18*g2)*(4*r + 4*s - 3))*(r + s - 1) + 20160*Dd**2*f**3*r**2 + 40320*Dd**2*f**3*r*s - 30240*Dd**2*f**3*r + 20160*Dd**2*f**3*s**2 - 30240*Dd**2*f**3*s + 10080*Dd**2*f**3 + 31680*Dd**2*f**2*g2*r**2 + 63360*Dd**2*f**2*g2*r*s - 47520*Dd**2*f**2*g2*r + 31680*Dd**2*f**2*g2*s**2 - 47520*Dd**2*f**2*g2*s + 15840*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*(37*fd - 36*fdd)*(r + s)**2 + D1*(Dd*(37*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 72*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 36*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 216*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(60*C*D1**2*f*fd*r**2 + 120*C*D1**2*f*fd*r*s - 60*C*D1**2*f*fd*r + 60*C*D1**2*f*fd*s**2 - 60*C*D1**2*f*fd*s + 30*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r**2 - 120*C*D1**2*f*fdd*r*s + 60*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 60*C*D1**2*f*fdd*s - 30*C*D1**2*f*fdd - 60*C*D1**2*fd**2*r**2 - 120*C*D1**2*fd**2*r*s + 60*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 60*C*D1**2*fd**2*s + 120*C*D1*Dd*f**2*r**2 + 240*C*D1*Dd*f**2*r*s - 180*C*D1*Dd*f**2*r + 120*C*D1*Dd*f**2*s**2 - 180*C*D1*Dd*f**2*s + 90*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r**2 - 960*C*D1*Dd*f*fd*r*s + 600*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 600*C*D1*Dd*f*fd*s - 180*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r**2 - 240*C*D1*Ddd*f**2*r*s + 180*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 180*C*D1*Ddd*f**2*s - 90*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r**2 - 720*C*Dd**2*f**2*r*s + 540*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 540*C*Dd**2*f**2*s - 180*C*Dd**2*f**2 + 26*D1**2*K*f*fd*r**2 + 52*D1**2*K*f*fd*r*s - 26*D1**2*K*f*fd*r + 26*D1**2*K*f*fd*s**2 - 26*D1**2*K*f*fd*s + 13*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r**2 - 80*D1**2*K*f*fdd*r*s + 40*D1**2*K*f*fdd*r - 40*D1**2*K*f*fdd*s**2 + 40*D1**2*K*f*fdd*s - 20*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r**2 - 80*D1**2*K*fd**2*r*s + 40*D1**2*K*fd**2*r - 40*D1**2*K*fd**2*s**2 + 40*D1**2*K*fd**2*s - 36*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd - 70*D1**2*f*fd*r**2 - 140*D1**2*f*fd*r*s + 70*D1**2*f*fd*r - 70*D1**2*f*fd*s**2 + 70*D1**2*f*fd*s - 35*D1**2*f*fd + 80*D1**2*f*fdd*r**2 + 160*D1**2*f*fdd*r*s - 80*D1**2*f*fdd*r + 80*D1**2*f*fdd*s**2 - 80*D1**2*f*fdd*s + 40*D1**2*f*fdd - 37*D1**2*f*gd2*r**2 - 74*D1**2*f*gd2*r*s + 74*D1**2*f*gd2*r - 37*D1**2*f*gd2*s**2 + 74*D1**2*f*gd2*s - 37*D1**2*f*gd2 + 36*D1**2*f*gdd2*r**2 + 72*D1**2*f*gdd2*r*s - 72*D1**2*f*gdd2*r + 36*D1**2*f*gdd2*s**2 - 72*D1**2*f*gdd2*s + 36*D1**2*f*gdd2 + 80*D1**2*fd**2*r**2 + 160*D1**2*fd**2*r*s - 80*D1**2*fd**2*r + 80*D1**2*fd**2*s**2 - 80*D1**2*fd**2*s - 37*D1**2*fd*g2*r**2 - 74*D1**2*fd*g2*r*s - 37*D1**2*fd*g2*s**2 + 72*D1**2*fd*gd2*r**2 + 144*D1**2*fd*gd2*r*s - 72*D1**2*fd*gd2*r + 72*D1**2*fd*gd2*s**2 - 72*D1**2*fd*gd2*s + 36*D1**2*fdd*g2*r**2 + 72*D1**2*fdd*g2*r*s + 36*D1**2*fdd*g2*s**2 + 52*D1*Dd*K*f**2*r**2 + 104*D1*Dd*K*f**2*r*s - 78*D1*Dd*K*f**2*r + 52*D1*Dd*K*f**2*s**2 - 78*D1*Dd*K*f**2*s + 39*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r**2 - 640*D1*Dd*K*f*fd*r*s + 400*D1*Dd*K*f*fd*r - 320*D1*Dd*K*f*fd*s**2 + 400*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 - 140*D1*Dd*f**2*r**2 - 280*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r - 140*D1*Dd*f**2*s**2 + 210*D1*Dd*f**2*s - 105*D1*Dd*f**2 + 640*D1*Dd*f*fd*r**2 + 1280*D1*Dd*f*fd*r*s - 800*D1*Dd*f*fd*r + 640*D1*Dd*f*fd*s**2 - 800*D1*Dd*f*fd*s + 240*D1*Dd*f*fd - 148*D1*Dd*f*g2*r**2 - 296*D1*Dd*f*g2*r*s + 222*D1*Dd*f*g2*r - 148*D1*Dd*f*g2*s**2 + 222*D1*Dd*f*g2*s - 111*D1*Dd*f*g2 + 288*D1*Dd*f*gd2*r**2 + 576*D1*Dd*f*gd2*r*s - 504*D1*Dd*f*gd2*r + 288*D1*Dd*f*gd2*s**2 - 504*D1*Dd*f*gd2*s + 216*D1*Dd*f*gd2 + 288*D1*Dd*fd*g2*r**2 + 576*D1*Dd*fd*g2*r*s - 216*D1*Dd*fd*g2*r + 288*D1*Dd*fd*g2*s**2 - 216*D1*Dd*fd*g2*s - 80*D1*Ddd*K*f**2*r**2 - 160*D1*Ddd*K*f**2*r*s + 120*D1*Ddd*K*f**2*r - 80*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 + 160*D1*Ddd*f**2*r**2 + 320*D1*Ddd*f**2*r*s - 240*D1*Ddd*f**2*r + 160*D1*Ddd*f**2*s**2 - 240*D1*Ddd*f**2*s + 120*D1*Ddd*f**2 + 144*D1*Ddd*f*g2*r**2 + 288*D1*Ddd*f*g2*r*s - 216*D1*Ddd*f*g2*r + 144*D1*Ddd*f*g2*s**2 - 216*D1*Ddd*f*g2*s + 108*D1*Ddd*f*g2 + D1*bd1*(K - 1)*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) - 240*Dd**2*K*f**2*r**2 - 480*Dd**2*K*f**2*r*s + 360*Dd**2*K*f**2*r - 240*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 + 480*Dd**2*f**2*r**2 + 960*Dd**2*f**2*r*s - 720*Dd**2*f**2*r + 480*Dd**2*f**2*s**2 - 720*Dd**2*f**2*s + 240*Dd**2*f**2 + 432*Dd**2*f*g2*r**2 + 864*Dd**2*f*g2*r*s - 648*Dd**2*f*g2*r + 432*Dd**2*f*g2*s**2 - 648*Dd**2*f*g2*s + 216*Dd**2*f*g2))/(231*d**2*k3**8) - 32*D1**2*Pk2*Pk3*ct**4*k1**4*st**2*(9126*C*D1**2*f**2*fd*r*s - 3042*C*D1**2*f**2*fd*r + 9126*C*D1**2*f**2*fd*s**2 - 9126*C*D1**2*f**2*fd*s + 3042*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 12168*C*D1*Dd*f**3*r*s - 3042*C*D1*Dd*f**3*r + 12168*C*D1*Dd*f**3*s**2 - 12168*C*D1*Dd*f**3*s + 3042*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 22900*D1**2*f**3*fd*r*s - 5725*D1**2*f**3*fd*r + 22900*D1**2*f**3*fd*s**2 - 22900*D1**2*f**3*fd*s + 5725*D1**2*f**3*fd - 14700*D1**2*f**3*fdd*r*s + 3675*D1**2*f**3*fdd*r - 14700*D1**2*f**3*fdd*s**2 + 14700*D1**2*f**3*fdd*s - 3675*D1**2*f**3*fdd - 44100*D1**2*f**2*fd**2*r*s + 11025*D1**2*f**2*fd**2*r - 44100*D1**2*f**2*fd**2*s**2 + 44100*D1**2*f**2*fd**2*s - 7350*D1**2*f**2*fd**2 - 9126*D1**2*f**2*fd*r*s + 3042*D1**2*f**2*fd*r - 9126*D1**2*f**2*fd*s**2 + 9126*D1**2*f**2*fd*s - 3042*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*s**2 + 4290*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 8580*D1**2*f*fd*g2*r*s + 4290*D1**2*f*fd*g2*r - 8580*D1**2*f*fd*g2*s**2 + 8580*D1**2*f*fd*g2*s - 4290*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 22900*D1*Dd*f**4*r*s - 5725*D1*Dd*f**4*r + 22900*D1*Dd*f**4*s**2 - 22900*D1*Dd*f**4*s + 5725*D1*Dd*f**4 - 117600*D1*Dd*f**3*fd*r*s + 29400*D1*Dd*f**3*fd*r - 117600*D1*Dd*f**3*fd*s**2 + 117600*D1*Dd*f**3*fd*s - 22050*D1*Dd*f**3*fd - 12168*D1*Dd*f**3*r*s + 3042*D1*Dd*f**3*r - 12168*D1*Dd*f**3*s**2 + 12168*D1*Dd*f**3*s - 3042*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 17160*D1*Dd*f**2*g2*r*s + 4290*D1*Dd*f**2*g2*r - 17160*D1*Dd*f**2*g2*s**2 + 17160*D1*Dd*f**2*g2*s - 4290*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 14700*D1*Ddd*f**4*r*s + 3675*D1*Ddd*f**4*r - 14700*D1*Ddd*f**4*s**2 + 14700*D1*Ddd*f**4*s - 3675*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 44100*Dd**2*f**4*r*s + 11025*Dd**2*f**4*r - 44100*Dd**2*f**4*s**2 + 44100*Dd**2*f**4*s - 7350*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**6) + 8*D1**2*Pk2*Pk3*ct**4*k1**4*(330*C*D1**2*bdd1*f**2*r**2 + 2640*C*D1**2*bdd1*f**2*r*s - 1980*C*D1**2*bdd1*f**2*r + 2310*C*D1**2*bdd1*f**2*s**2 - 3960*C*D1**2*bdd1*f**2*s + 1980*C*D1**2*bdd1*f**2 + 3465*C*D1**2*f**2*fd*r**2 + 16230*C*D1**2*f**2*fd*r*s - 7720*C*D1**2*f**2*fd*r + 12765*C*D1**2*f**2*fd*s**2 - 13920*C*D1**2*f**2*fd*s + 5410*C*D1**2*f**2*fd - 4455*C*D1**2*f**2*fdd*r**2 - 14550*C*D1**2*f**2*fdd*r*s + 7820*C*D1**2*f**2*fdd*r - 10095*C*D1**2*f**2*fdd*s**2 + 11580*C*D1**2*f**2*fdd*s - 4850*C*D1**2*f**2*fdd - 8910*C*D1**2*f*fd**2*r**2 - 29100*C*D1**2*f*fd**2*r*s + 15640*C*D1**2*f*fd**2*r - 20190*C*D1**2*f*fd**2*s**2 + 23160*C*D1**2*f*fd**2*s - 4850*C*D1**2*f*fd**2 + 4620*C*D1*Dd*f**3*r**2 + 21640*C*D1*Dd*f**3*r*s - 10030*C*D1*Dd*f**3*r + 17020*C*D1*Dd*f**3*s**2 - 19330*C*D1*Dd*f**3*s + 6565*C*D1*Dd*f**3 - 35640*C*D1*Dd*f**2*fd*r**2 - 116400*C*D1*Dd*f**2*fd*r*s + 63650*C*D1*Dd*f**2*fd*r - 80760*C*D1*Dd*f**2*fd*s**2 + 95610*C*D1*Dd*f**2*fd*s - 27220*C*D1*Dd*f**2*fd - 5940*C*D1*Ddd*f**3*r**2 - 19400*C*D1*Ddd*f**3*r*s + 10790*C*D1*Ddd*f**3*r - 13460*C*D1*Ddd*f**3*s**2 + 16430*C*D1*Ddd*f**3*s - 6335*C*D1*Ddd*f**3 - 17820*C*Dd**2*f**3*r**2 - 58200*C*Dd**2*f**3*r*s + 32370*C*Dd**2*f**3*r - 40380*C*Dd**2*f**3*s**2 + 49290*C*Dd**2*f**3*s - 12670*C*Dd**2*f**3 - 825*D1**2*K*bdd1*f**2*r**2 - 2838*D1**2*K*bdd1*f**2*r*s + 1650*D1**2*K*bdd1*f**2*r - 2013*D1**2*K*bdd1*f**2*s**2 + 2838*D1**2*K*bdd1*f**2*s - 825*D1**2*K*bdd1*f**2 + 396*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(8*s - 4) + 7*s**2 - 10*s + 3) + 980*D1**2*bdd1*f**3*r**2 + 2520*D1**2*bdd1*f**3*r*s - 2800*D1**2*bdd1*f**3*r + 1540*D1**2*bdd1*f**3*s**2 - 3360*D1**2*bdd1*f**3*s + 2240*D1**2*bdd1*f**3 + 1155*D1**2*bdd1*f**2*r**2 + 1848*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*r + 693*D1**2*bdd1*f**2*s**2 - 528*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 396*D1**2*bdd1*f*g2*r**2 - 3168*D1**2*bdd1*f*g2*r*s + 2376*D1**2*bdd1*f*g2*r - 2772*D1**2*bdd1*f*g2*s**2 + 4752*D1**2*bdd1*f*g2*s - 2376*D1**2*bdd1*f*g2 + 8680*D1**2*f**3*fd*r**2 + 29680*D1**2*f**3*fd*r*s - 16100*D1**2*f**3*fd*r + 21000*D1**2*f**3*fd*s**2 - 25340*D1**2*f**3*fd*s + 9590*D1**2*f**3*fd - 10360*D1**2*f**3*fdd*r**2 - 26320*D1**2*f**3*fdd*r*s + 16940*D1**2*f**3*fdd*r - 15960*D1**2*f**3*fdd*s**2 + 21140*D1**2*f**3*fdd*s - 9170*D1**2*f**3*fdd - 31080*D1**2*f**2*fd**2*r**2 - 78960*D1**2*f**2*fd**2*r*s + 50820*D1**2*f**2*fd**2*r - 47880*D1**2*f**2*fd**2*s**2 + 63420*D1**2*f**2*fd**2*s - 18340*D1**2*f**2*fd**2 - 4845*D1**2*f**2*fd*r**2 - 19680*D1**2*f**2*fd*r*s + 9790*D1**2*f**2*fd*r - 14835*D1**2*f**2*fd*s**2 + 16450*D1**2*f**2*fd*s - 6560*D1**2*f**2*fd + 6135*D1**2*f**2*fdd*r**2 + 18750*D1**2*f**2*fdd*r*s - 10340*D1**2*f**2*fdd*r + 12615*D1**2*f**2*fdd*s**2 - 14660*D1**2*f**2*fdd*s + 6250*D1**2*f**2*fdd - 1122*D1**2*f**2*gd2*r**2 - 6204*D1**2*f**2*gd2*r*s + 2244*D1**2*f**2*gd2*r - 5082*D1**2*f**2*gd2*s**2 + 6204*D1**2*f**2*gd2*s - 1122*D1**2*f**2*gd2 + 1650*D1**2*f**2*gdd2*r**2 + 5676*D1**2*f**2*gdd2*r*s - 3300*D1**2*f**2*gdd2*r + 4026*D1**2*f**2*gdd2*s**2 - 5676*D1**2*f**2*gdd2*s + 1650*D1**2*f**2*gdd2 + 12270*D1**2*f*fd**2*r**2 + 37500*D1**2*f*fd**2*r*s - 20680*D1**2*f*fd**2*r + 25230*D1**2*f*fd**2*s**2 - 29320*D1**2*f*fd**2*s + 6250*D1**2*f*fd**2 - 2244*D1**2*f*fd*g2*r**2 - 12408*D1**2*f*fd*g2*r*s + 6204*D1**2*f*fd*g2*r - 10164*D1**2*f*fd*g2*s**2 + 10164*D1**2*f*fd*g2*s - 5082*D1**2*f*fd*g2 + 6600*D1**2*f*fd*gd2*r**2 + 22704*D1**2*f*fd*gd2*r*s - 12276*D1**2*f*fd*gd2*r + 16104*D1**2*f*fd*gd2*s**2 - 19404*D1**2*f*fd*gd2*s + 5676*D1**2*f*fd*gd2 + 3300*D1**2*f*fdd*g2*r**2 + 11352*D1**2*f*fdd*g2*r*s - 5676*D1**2*f*fdd*g2*r + 8052*D1**2*f*fdd*g2*s**2 - 8052*D1**2*f*fdd*g2*s + 4026*D1**2*f*fdd*g2 + 3300*D1**2*fd**2*g2*r**2 + 11352*D1**2*fd**2*g2*r*s - 5676*D1**2*fd**2*g2*r + 8052*D1**2*fd**2*g2*s**2 - 8052*D1**2*fd**2*g2*s + 8680*D1*Dd*f**4*r**2 + 29680*D1*Dd*f**4*r*s - 16100*D1*Dd*f**4*r + 21000*D1*Dd*f**4*s**2 - 25340*D1*Dd*f**4*s + 9590*D1*Dd*f**4 - 82880*D1*Dd*f**3*fd*r**2 - 210560*D1*Dd*f**3*fd*r*s + 135520*D1*Dd*f**3*fd*r - 127680*D1*Dd*f**3*fd*s**2 + 169120*D1*Dd*f**3*fd*s - 55020*D1*Dd*f**3*fd - 6460*D1*Dd*f**3*r**2 - 26240*D1*Dd*f**3*r*s + 13020*D1*Dd*f**3*r - 19780*D1*Dd*f**3*s**2 + 23010*D1*Dd*f**3*s - 8175*D1*Dd*f**3 + 49080*D1*Dd*f**2*fd*r**2 + 150000*D1*Dd*f**2*fd*r*s - 84650*D1*Dd*f**2*fd*r + 100920*D1*Dd*f**2*fd*s**2 - 121370*D1*Dd*f**2*fd*s + 35340*D1*Dd*f**2*fd - 4488*D1*Dd*f**2*g2*r**2 - 24816*D1*Dd*f**2*g2*r*s + 10692*D1*Dd*f**2*g2*r - 20328*D1*Dd*f**2*g2*s**2 + 22572*D1*Dd*f**2*g2*s - 7326*D1*Dd*f**2*g2 + 13200*D1*Dd*f**2*gd2*r**2 + 45408*D1*Dd*f**2*gd2*r*s - 25476*D1*Dd*f**2*gd2*r + 32208*D1*Dd*f**2*gd2*s**2 - 42108*D1*Dd*f**2*gd2*s + 12276*D1*Dd*f**2*gd2 + 26400*D1*Dd*f*fd*g2*r**2 + 90816*D1*Dd*f*fd*g2*r*s - 47256*D1*Dd*f*fd*g2*r + 64416*D1*Dd*f*fd*g2*s**2 - 71016*D1*Dd*f*fd*g2*s + 19404*D1*Dd*f*fd*g2 - 10360*D1*Ddd*f**4*r**2 - 26320*D1*Ddd*f**4*r*s + 16940*D1*Ddd*f**4*r - 15960*D1*Ddd*f**4*s**2 + 21140*D1*Ddd*f**4*s - 9170*D1*Ddd*f**4 + 8180*D1*Ddd*f**3*r**2 + 25000*D1*Ddd*f**3*r*s - 14430*D1*Ddd*f**3*r + 16820*D1*Ddd*f**3*s**2 - 20910*D1*Ddd*f**3*s + 8295*D1*Ddd*f**3 + 6600*D1*Ddd*f**2*g2*r**2 + 22704*D1*Ddd*f**2*g2*r*s - 12276*D1*Ddd*f**2*g2*r + 16104*D1*Ddd*f**2*g2*s**2 - 19404*D1*Ddd*f**2*g2*s + 7326*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(5*f**3*(161*r**2 + 14*r*(39*s - 47) + 385*s**2 - 882*s + 566) + f**2*(264*C*(r**2 + r*(11*s - 9) + 10*s**2 - 18*s + 9) - 33*K*(17*r**2 + 94*r*s - 34*r + 77*s**2 - 94*s + 17) - 280*fd*(21*r**2 + r*(54*s - 43) + 33*s**2 - 53*s + 16) + 825*r**2 + 1518*r*s + 198*r + 693*s**2 + 330*s - 1287) - 66*f*(fd*(10*C*(2*r**2 + 8*r*(2*s - 1) + 14*s**2 - 17*s + 3) - K*(50*r**2 + 172*r*s - 93*r + 122*s**2 - 147*s + 43) + 70*r**2 + 112*r*s - 78*r + 42*s**2 - 57*s + 38) + g2*(5*r**2 + r*(54*s - 44) + 49*s**2 - 88*s + 44) - 12*gd2*(r**2 + r*(8*s - 4) + 7*s**2 - 10*s + 3)) + 792*fd*g2*(r**2 + r*(8*s - 4) + s*(7*s - 7))) + 2*Dd*f*(140*f**2*(28*r**2 + 9*r*(8*s - 7) + 44*s**2 - 77*s + 32) + 33*f*(10*C*(4*r**2 + 2*r*(16*s - 9) + 28*s**2 - 39*s + 12) - K*(100*r**2 + 344*r*s - 193*r + 244*s**2 - 319*s + 93) + 140*r**2 + 224*r*s - 158*r + 84*s**2 - 109*s + 38) - 396*g2*(4*r**2 + 2*r*(16*s - 9) + 28*s**2 - 39*s + 12))) - 31080*Dd**2*f**4*r**2 - 78960*Dd**2*f**4*r*s + 50820*Dd**2*f**4*r - 47880*Dd**2*f**4*s**2 + 63420*Dd**2*f**4*s - 18340*Dd**2*f**4 + 24540*Dd**2*f**3*r**2 + 75000*Dd**2*f**3*r*s - 43290*Dd**2*f**3*r + 50460*Dd**2*f**3*s**2 - 62730*Dd**2*f**3*s + 16590*Dd**2*f**3 + 19800*Dd**2*f**2*g2*r**2 + 68112*Dd**2*f**2*g2*r*s - 36828*Dd**2*f**2*g2*r + 48312*Dd**2*f**2*g2*s**2 - 58212*Dd**2*f**2*g2*s + 14652*Dd**2*f**2*g2 - 33*b1**2*(K - 1)*(D1**2*(fd*(5*r**2 + 54*r*s - 10*r + 49*s**2 - 10*s + 5) - 6*fdd*(r**2 + 8*r*s - 2*r + 7*s**2 - 2*s + 1)) + D1*(Dd*(f*(20*r**2 + 216*r*s - 74*r + 196*s**2 - 206*s + 59) - 12*fd*(4*r**2 + 32*r*s - 10*r + 28*s**2 - 19*s + 3)) - 6*Ddd*f*(4*r**2 + 4*r*(8*s - 3) + 28*s**2 - 30*s + 9)) - 36*Dd**2*f*(2*r**2 + 2*r*(8*s - 3) + 14*s**2 - 15*s + 3)) + b1*(-528*C*D1**2*f*fd*r**2 - 5808*C*D1**2*f*fd*r*s + 1056*C*D1**2*f*fd*r - 5280*C*D1**2*f*fd*s**2 + 3432*C*D1**2*f*fd*s - 528*C*D1**2*f*fd + 660*C*D1**2*f*fdd*r**2 + 5280*C*D1**2*f*fdd*r*s - 1320*C*D1**2*f*fdd*r + 4620*C*D1**2*f*fdd*s**2 - 3300*C*D1**2*f*fdd*s + 660*C*D1**2*f*fdd + 660*C*D1**2*fd**2*r**2 + 5280*C*D1**2*fd**2*r*s - 1320*C*D1**2*fd**2*r + 4620*C*D1**2*fd**2*s**2 - 3300*C*D1**2*fd**2*s + 660*C*D1**2*fd**2 - 1056*C*D1*Dd*f**2*r**2 - 11616*C*D1*Dd*f**2*r*s + 3960*C*D1*Dd*f**2*r - 10560*C*D1*Dd*f**2*s**2 + 11088*C*D1*Dd*f**2*s - 3168*C*D1*Dd*f**2 + 5280*C*D1*Dd*f*fd*r**2 + 42240*C*D1*Dd*f*fd*r*s - 13200*C*D1*Dd*f*fd*r + 36960*C*D1*Dd*f*fd*s**2 - 33000*C*D1*Dd*f*fd*s + 5940*C*D1*Dd*f*fd + 1320*C*D1*Ddd*f**2*r**2 + 10560*C*D1*Ddd*f**2*r*s - 3960*C*D1*Ddd*f**2*r + 9240*C*D1*Ddd*f**2*s**2 - 9900*C*D1*Ddd*f**2*s + 2970*C*D1*Ddd*f**2 + 3960*C*Dd**2*f**2*r**2 + 31680*C*Dd**2*f**2*r*s - 11880*C*Dd**2*f**2*r + 27720*C*Dd**2*f**2*s**2 - 29700*C*Dd**2*f**2*s + 5940*C*Dd**2*f**2 + 1122*D1**2*K*f*fd*r**2 + 6204*D1**2*K*f*fd*r*s - 3102*D1**2*K*f*fd*r + 5082*D1**2*K*f*fd*s**2 - 5082*D1**2*K*f*fd*s + 2541*D1**2*K*f*fd - 1650*D1**2*K*f*fdd*r**2 - 5676*D1**2*K*f*fdd*r*s + 2838*D1**2*K*f*fdd*r - 4026*D1**2*K*f*fdd*s**2 + 4026*D1**2*K*f*fdd*s - 2013*D1**2*K*f*fdd - 1650*D1**2*K*fd**2*r**2 - 5676*D1**2*K*fd**2*r*s + 2838*D1**2*K*fd**2*r - 4026*D1**2*K*fd**2*s**2 + 4026*D1**2*K*fd**2*s + 198*D1**2*bdd1*f*(K - 1)*(2*r**2 + 16*r*s - 8*r + 14*s**2 - 20*s + 7) - 2415*D1**2*f**2*fd*r**2 - 8190*D1**2*f**2*fd*r*s + 2660*D1**2*f**2*fd*r - 5775*D1**2*f**2*fd*s**2 + 4900*D1**2*f**2*fd*s - 705*D1**2*f**2*fd + 2940*D1**2*f**2*fdd*r**2 + 7560*D1**2*f**2*fdd*r*s - 3640*D1**2*f**2*fdd*r + 4620*D1**2*f**2*fdd*s**2 - 4760*D1**2*f**2*fdd*s + 1260*D1**2*f**2*fdd + 5880*D1**2*f*fd**2*r**2 + 15120*D1**2*f*fd**2*r*s - 7280*D1**2*f*fd**2*r + 9240*D1**2*f*fd**2*s**2 - 9520*D1**2*f*fd**2*s + 2520*D1**2*f*fd**2 - 1650*D1**2*f*fd*r**2 - 3036*D1**2*f*fd*r*s + 3366*D1**2*f*fd*r - 1386*D1**2*f*fd*s**2 + 3234*D1**2*f*fd*s - 2805*D1**2*f*fd + 2310*D1**2*f*fdd*r**2 + 3696*D1**2*f*fdd*r*s - 3168*D1**2*f*fdd*r + 1386*D1**2*f*fdd*s**2 - 2706*D1**2*f*fdd*s + 2343*D1**2*f*fdd + 330*D1**2*f*gd2*r**2 + 3564*D1**2*f*gd2*r*s - 660*D1**2*f*gd2*r + 3234*D1**2*f*gd2*s**2 - 3564*D1**2*f*gd2*s + 330*D1**2*f*gd2 - 396*D1**2*f*gdd2*r**2 - 3168*D1**2*f*gdd2*r*s + 792*D1**2*f*gdd2*r - 2772*D1**2*f*gdd2*s**2 + 3168*D1**2*f*gdd2*s - 396*D1**2*f*gdd2 + 2310*D1**2*fd**2*r**2 + 3696*D1**2*fd**2*r*s - 3168*D1**2*fd**2*r + 1386*D1**2*fd**2*s**2 - 2706*D1**2*fd**2*s - 660*D1**2*fd**2 + 330*D1**2*fd*g2*r**2 + 3564*D1**2*fd*g2*r*s - 660*D1**2*fd*g2*r + 3234*D1**2*fd*g2*s**2 - 660*D1**2*fd*g2*s + 330*D1**2*fd*g2 - 792*D1**2*fd*gd2*r**2 - 6336*D1**2*fd*gd2*r*s + 1584*D1**2*fd*gd2*r - 5544*D1**2*fd*gd2*s**2 + 3960*D1**2*fd*gd2*s - 792*D1**2*fd*gd2 - 396*D1**2*fdd*g2*r**2 - 3168*D1**2*fdd*g2*r*s + 792*D1**2*fdd*g2*r - 2772*D1**2*fdd*g2*s**2 + 792*D1**2*fdd*g2*s - 396*D1**2*fdd*g2 + 2244*D1*Dd*K*f**2*r**2 + 12408*D1*Dd*K*f**2*r*s - 5346*D1*Dd*K*f**2*r + 10164*D1*Dd*K*f**2*s**2 - 11286*D1*Dd*K*f**2*s + 3663*D1*Dd*K*f**2 - 13200*D1*Dd*K*f*fd*r**2 - 45408*D1*Dd*K*f*fd*r*s + 23628*D1*Dd*K*f*fd*r - 32208*D1*Dd*K*f*fd*s**2 + 35508*D1*Dd*K*f*fd*s - 9702*D1*Dd*K*f*fd - 3220*D1*Dd*f**3*r**2 - 10920*D1*Dd*f**3*r*s + 5950*D1*Dd*f**3*r - 7700*D1*Dd*f**3*s**2 + 9310*D1*Dd*f**3*s - 3535*D1*Dd*f**3 + 23520*D1*Dd*f**2*fd*r**2 + 60480*D1*Dd*f**2*fd*r*s - 33880*D1*Dd*f**2*fd*r + 36960*D1*Dd*f**2*fd*s**2 - 43400*D1*Dd*f**2*fd*s + 12040*D1*Dd*f**2*fd - 3300*D1*Dd*f**2*r**2 - 6072*D1*Dd*f**2*r*s + 4818*D1*Dd*f**2*r - 2772*D1*Dd*f**2*s**2 + 4422*D1*Dd*f**2*s - 2343*D1*Dd*f**2 + 18480*D1*Dd*f*fd*r**2 + 29568*D1*Dd*f*fd*r*s - 25608*D1*Dd*f*fd*r + 11088*D1*Dd*f*fd*s**2 - 20988*D1*Dd*f*fd*s + 9042*D1*Dd*f*fd + 1320*D1*Dd*f*g2*r**2 + 14256*D1*Dd*f*g2*r*s - 4884*D1*Dd*f*g2*r + 12936*D1*Dd*f*g2*s**2 - 13596*D1*Dd*f*g2*s + 3894*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 25344*D1*Dd*f*gd2*r*s + 7920*D1*Dd*f*gd2*r - 22176*D1*Dd*f*gd2*s**2 + 24552*D1*Dd*f*gd2*s - 4752*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 25344*D1*Dd*fd*g2*r*s + 7920*D1*Dd*fd*g2*r - 22176*D1*Dd*fd*g2*s**2 + 15048*D1*Dd*fd*g2*s - 2376*D1*Dd*fd*g2 - 3300*D1*Ddd*K*f**2*r**2 - 11352*D1*Ddd*K*f**2*r*s + 6138*D1*Ddd*K*f**2*r - 8052*D1*Ddd*K*f**2*s**2 + 9702*D1*Ddd*K*f**2*s - 3663*D1*Ddd*K*f**2 + 3920*D1*Ddd*f**3*r**2 + 10080*D1*Ddd*f**3*r*s - 6440*D1*Ddd*f**3*r + 6160*D1*Ddd*f**3*s**2 - 8120*D1*Ddd*f**3*s + 3500*D1*Ddd*f**3 + 4620*D1*Ddd*f**2*r**2 + 7392*D1*Ddd*f**2*r*s - 6468*D1*Ddd*f**2*r + 2772*D1*Ddd*f**2*s**2 - 5082*D1*Ddd*f**2*s + 3003*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 12672*D1*Ddd*f*g2*r*s + 4752*D1*Ddd*f*g2*r - 11088*D1*Ddd*f*g2*s**2 + 11880*D1*Ddd*f*g2*s - 3564*D1*Ddd*f*g2 - 33*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 54*r*(2*s - 1) + 98*s**2 - 142*s + 49) - 12*fd*(2*r**2 + 2*r*(8*s - 3) + 14*s**2 - 12*s + 1)) - 24*Dd*f*(4*r**2 + 2*r*(16*s - 7) + 28*s**2 - 35*s + 9)) - 9900*Dd**2*K*f**2*r**2 - 34056*Dd**2*K*f**2*r*s + 18414*Dd**2*K*f**2*r - 24156*Dd**2*K*f**2*s**2 + 29106*Dd**2*K*f**2*s - 7326*Dd**2*K*f**2 + 11760*Dd**2*f**3*r**2 + 30240*Dd**2*f**3*r*s - 19320*Dd**2*f**3*r + 18480*Dd**2*f**3*s**2 - 24360*Dd**2*f**3*s + 7000*Dd**2*f**3 + 13860*Dd**2*f**2*r**2 + 22176*Dd**2*f**2*r*s - 19404*Dd**2*f**2*r + 8316*Dd**2*f**2*s**2 - 15246*Dd**2*f**2*s + 6006*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 38016*Dd**2*f*g2*r*s + 14256*Dd**2*f*g2*r - 33264*Dd**2*f*g2*s**2 + 35640*Dd**2*f*g2*s - 7128*Dd**2*f*g2))/(693*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**4*k1**4*st**2*(D1**2*(3675*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(11025*fd**2*s*(2*s - 1) - fd*(1300*C - 1300)*(3*s**2 - 2*s + 1) + fdd*(650*C - 650)*(3*s**2 - 2*s + 1) + s**2*(429*K*bdd1 - 858*bd1*(K - 1) - 429*bdd1 + 1716*gd2 - 858*gdd2)) - 52*f*(fd**2*s*(50*C - 50)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 3432*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(3675*f**3*(4*s**2 - 2*s + 1) + 25*f**2*(52*C*(4*s**2 - 2*s + 1) - 147*fd*(1 - 4*s)**2 - 208*s**2 + 104*s - 52) - 26*f*(fd*(50*C - 50)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 1716*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(3675*f**2 + f*(1300*C - 1300) - 1716*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(3675*f**2 + f*(1300*C - 1300) - 1716*g2) + 858*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1001*d**2*k2**2*k3**4) + 8*D1**2*Pk2*Pk3*ct**4*k1**4*(330*C*D1**2*bdd1*f**2*s**2 - 660*C*D1**2*bdd1*f**2*s + 330*C*D1**2*bdd1*f**2 + 5835*C*D1**2*f**2*fd*s**2 - 3890*C*D1**2*f**2*fd*s + 1945*C*D1**2*f**2*fd - 4155*C*D1**2*f**2*fdd*s**2 + 2770*C*D1**2*f**2*fdd*s - 1385*C*D1**2*f**2*fdd - 8310*C*D1**2*f*fd**2*s**2 + 5540*C*D1**2*f*fd**2*s + 7780*C*D1*Dd*f**3*s**2 - 3890*C*D1*Dd*f**3*s + 1945*C*D1*Dd*f**3 - 33240*C*D1*Dd*f**2*fd*s**2 + 19390*C*D1*Dd*f**2*fd*s - 2770*C*D1*Dd*f**2*fd - 5540*C*D1*Ddd*f**3*s**2 + 2770*C*D1*Ddd*f**3*s - 1385*C*D1*Ddd*f**3 - 16620*C*Dd**2*f**3*s**2 + 8310*C*Dd**2*f**3*s - 825*D1**2*K*bdd1*f**2*s**2 + 396*D1**2*bd1**2*f*s*(K - 1)*(s - 1) + 560*D1**2*bdd1*f**3*r*s + 840*D1**2*bdd1*f**3*s**2 - 1120*D1**2*bdd1*f**3*s + 420*D1**2*bdd1*f**3 + 330*D1**2*bdd1*f**2*r*s + 825*D1**2*bdd1*f**2*s**2 + 330*D1**2*bdd1*f**2*s - 330*D1**2*bdd1*f**2 - 396*D1**2*bdd1*f*g2*s**2 + 792*D1**2*bdd1*f*g2*s - 396*D1**2*bdd1*f*g2 + 2800*D1**2*f**3*fd*r*s - 700*D1**2*f**3*fd*r + 10920*D1**2*f**3*fd*s**2 - 6860*D1**2*f**3*fd*s + 2730*D1**2*f**3*fd - 2800*D1**2*f**3*fdd*r*s + 700*D1**2*f**3*fdd*r - 7560*D1**2*f**3*fdd*s**2 + 5180*D1**2*f**3*fdd*s - 1890*D1**2*f**3*fdd - 8400*D1**2*f**2*fd**2*r*s + 2100*D1**2*f**2*fd**2*r - 22680*D1**2*f**2*fd**2*s**2 + 15540*D1**2*f**2*fd**2*s - 1400*D1**2*f**2*fd**2 - 690*D1**2*f**2*fd*r*s + 230*D1**2*f**2*fd*r - 6525*D1**2*f**2*fd*s**2 + 4580*D1**2*f**2*fd*s - 2175*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r*s - 280*D1**2*f**2*fdd*r + 4995*D1**2*f**2*fdd*s**2 - 3610*D1**2*f**2*fdd*s + 1665*D1**2*f**2*fdd - 2310*D1**2*f**2*gd2*s**2 + 1650*D1**2*f**2*gdd2*s**2 + 1680*D1**2*f*fd**2*r*s - 560*D1**2*f*fd**2*r + 9990*D1**2*f*fd**2*s**2 - 7220*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 4620*D1**2*f*fd*g2*s**2 + 4620*D1**2*f*fd*g2*s - 2310*D1**2*f*fd*g2 + 6600*D1**2*f*fd*gd2*s**2 - 3300*D1**2*f*fd*gd2*s + 3300*D1**2*f*fdd*g2*s**2 - 3300*D1**2*f*fdd*g2*s + 1650*D1**2*f*fdd*g2 + 3300*D1**2*fd**2*g2*s**2 - 3300*D1**2*fd**2*g2*s + 2800*D1*Dd*f**4*r*s - 700*D1*Dd*f**4*r + 10920*D1*Dd*f**4*s**2 - 6860*D1*Dd*f**4*s + 2730*D1*Dd*f**4 - 22400*D1*Dd*f**3*fd*r*s + 5600*D1*Dd*f**3*fd*r - 60480*D1*Dd*f**3*fd*s**2 + 41440*D1*Dd*f**3*fd*s - 6580*D1*Dd*f**3*fd - 920*D1*Dd*f**3*r*s + 230*D1*Dd*f**3*r - 8700*D1*Dd*f**3*s**2 + 4810*D1*Dd*f**3*s - 2175*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r*s - 1960*D1*Dd*f**2*fd*r + 39960*D1*Dd*f**2*fd*s**2 - 26110*D1*Dd*f**2*fd*s + 4170*D1*Dd*f**2*fd - 9240*D1*Dd*f**2*g2*s**2 + 4620*D1*Dd*f**2*g2*s - 2310*D1*Dd*f**2*g2 + 13200*D1*Dd*f**2*gd2*s**2 - 3300*D1*Dd*f**2*gd2*s + 26400*D1*Dd*f*fd*g2*s**2 - 19800*D1*Dd*f*fd*g2*s + 3300*D1*Dd*f*fd*g2 - 2800*D1*Ddd*f**4*r*s + 700*D1*Ddd*f**4*r - 7560*D1*Ddd*f**4*s**2 + 5180*D1*Ddd*f**4*s - 1890*D1*Ddd*f**4 + 1120*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r + 6660*D1*Ddd*f**3*s**2 - 3890*D1*Ddd*f**3*s + 1665*D1*Ddd*f**3 + 6600*D1*Ddd*f**2*g2*s**2 - 3300*D1*Ddd*f**2*g2*s + 1650*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-10*f**3*(102*s**2 + s*(46*r - 191) + 84) + f**2*(-660*C*(s - 1)**2 + 280*fd*(2*r*(6*s - 1) + 18*s**2 - 18*s + 1) + 33*s**2*(35*K - 23) - 33*s*(8*r + 32) + 660) + 66*f*(5*fd*(r*(4*s - 1) + s**2*(4*C - 10*K + 10) + s*(-4*C + 5*K - 5) + 1) + (12*s - 12)*(g2*(s - 1) - gd2*s)) - 792*fd*g2*s*(s - 1)) + 2*Dd*f*(280*f**2*(r*(8*s - 1) + 12*s**2 - 13*s + 2) - 165*f*(-2*C*(4*s**2 - 5*s + 1) + 20*K*s**2 - 5*K*s - 8*r*s + r - 20*s**2 + 3*s + 1) - 396*g2*(4*s**2 - 5*s + 1))) - 8400*Dd**2*f**4*r*s + 2100*Dd**2*f**4*r - 22680*Dd**2*f**4*s**2 + 15540*Dd**2*f**4*s - 1400*Dd**2*f**4 + 3360*Dd**2*f**3*r*s - 840*Dd**2*f**3*r + 19980*Dd**2*f**3*s**2 - 11670*Dd**2*f**3*s + 560*Dd**2*f**3 + 19800*Dd**2*f**2*g2*s**2 - 9900*Dd**2*f**2*g2*s - 198*b1**2*(K - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-1320*C*D1**2*f*fd*s**2 + 660*C*D1**2*f*fdd*s**2 + 660*C*D1**2*fd**2*s**2 - 2640*C*D1*Dd*f**2*s**2 + 1320*C*D1*Dd*f**2*s - 660*C*D1*Dd*f**2 + 5280*C*D1*Dd*f*fd*s**2 - 1320*C*D1*Dd*f*fd*s + 1320*C*D1*Ddd*f**2*s**2 - 660*C*D1*Ddd*f**2*s + 330*C*D1*Ddd*f**2 + 3960*C*Dd**2*f**2*s**2 - 1980*C*Dd**2*f**2*s + 2310*D1**2*K*f*fd*s**2 - 2310*D1**2*K*f*fd*s + 1155*D1**2*K*f*fd - 1650*D1**2*K*f*fdd*s**2 + 1650*D1**2*K*f*fdd*s - 825*D1**2*K*f*fdd - 1650*D1**2*K*fd**2*s**2 + 1650*D1**2*K*fd**2*s + 198*D1**2*bdd1*f*(K - 1)*(2*s**2 - 2*s + 1) - 1380*D1**2*f**2*fd*r*s + 460*D1**2*f**2*fd*r - 3060*D1**2*f**2*fd*s**2 + 1050*D1**2*f**2*fd*s - 180*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 2520*D1**2*f**2*fdd*s**2 - 1680*D1**2*f**2*fdd*s + 420*D1**2*f**2*fdd + 3360*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 5040*D1**2*f*fd**2*s**2 - 3360*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 1518*D1**2*f*fd*s**2 + 2838*D1**2*f*fd*s - 1419*D1**2*f*fd + 660*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 1650*D1**2*f*fdd*s**2 - 2310*D1**2*f*fdd*s + 1155*D1**2*f*fdd + 792*D1**2*f*gd2*s**2 - 396*D1**2*f*gdd2*s**2 + 660*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 1650*D1**2*fd**2*s**2 - 2310*D1**2*fd**2*s + 792*D1**2*fd*g2*s**2 - 792*D1**2*fd*gd2*s**2 - 396*D1**2*fdd*g2*s**2 + 4620*D1*Dd*K*f**2*s**2 - 2310*D1*Dd*K*f**2*s + 1155*D1*Dd*K*f**2 - 13200*D1*Dd*K*f*fd*s**2 + 9900*D1*Dd*K*f*fd*s - 1650*D1*Dd*K*f*fd - 1840*D1*Dd*f**3*r*s + 460*D1*Dd*f**3*r - 4080*D1*Dd*f**3*s**2 + 2960*D1*Dd*f**3*s - 1020*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*r*s - 3920*D1*Dd*f**2*fd*r + 20160*D1*Dd*f**2*fd*s**2 - 15120*D1*Dd*f**2*fd*s + 2800*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*r*s + 264*D1*Dd*f**2*r - 3036*D1*Dd*f**2*s**2 + 2046*D1*Dd*f**2*s - 759*D1*Dd*f**2 + 5280*D1*Dd*f*fd*r*s - 1980*D1*Dd*f*fd*r + 13200*D1*Dd*f*fd*s**2 - 13860*D1*Dd*f*fd*s + 2970*D1*Dd*f*fd + 3168*D1*Dd*f*g2*s**2 - 1584*D1*Dd*f*g2*s + 792*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*s**2 + 792*D1*Dd*f*gd2*s - 3168*D1*Dd*fd*g2*s**2 + 792*D1*Dd*fd*g2*s - 3300*D1*Ddd*K*f**2*s**2 + 1650*D1*Ddd*K*f**2*s - 825*D1*Ddd*K*f**2 + 2240*D1*Ddd*f**3*r*s - 560*D1*Ddd*f**3*r + 3360*D1*Ddd*f**3*s**2 - 2800*D1*Ddd*f**3*s + 840*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*r*s - 330*D1*Ddd*f**2*r + 3300*D1*Ddd*f**2*s**2 - 2310*D1*Ddd*f**2*s + 825*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*s**2 + 792*D1*Ddd*f*g2*s - 396*D1*Ddd*f*g2 - 396*D1*bd1*(K - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 9900*Dd**2*K*f**2*s**2 + 4950*Dd**2*K*f**2*s + 6720*Dd**2*f**3*r*s - 1680*Dd**2*f**3*r + 10080*Dd**2*f**3*s**2 - 8400*Dd**2*f**3*s + 1120*Dd**2*f**3 + 3960*Dd**2*f**2*r*s - 990*Dd**2*f**2*r + 9900*Dd**2*f**2*s**2 - 6930*Dd**2*f**2*s + 660*Dd**2*f**2 - 4752*Dd**2*f*g2*s**2 + 2376*Dd**2*f*g2*s))/(693*d**2*k2**2*k3**4) - 4*D1**2*Pk2*Pk3*ct**4*k1**2*k2**4*st**2*(-396*C*D1**2*bdd1*f**2*r**2 - 792*C*D1**2*bdd1*f**2*r*s + 792*C*D1**2*bdd1*f**2*r - 396*C*D1**2*bdd1*f**2*s**2 + 792*C*D1**2*bdd1*f**2*s - 396*C*D1**2*bdd1*f**2 + 18060*C*D1**2*f**2*fd*r**2 + 36120*C*D1**2*f**2*fd*r*s - 24080*C*D1**2*f**2*fd*r + 18060*C*D1**2*f**2*fd*s**2 - 24080*C*D1**2*f**2*fd*s + 12040*C*D1**2*f**2*fd - 12000*C*D1**2*f**2*fdd*r**2 - 24000*C*D1**2*f**2*fdd*r*s + 16000*C*D1**2*f**2*fdd*r - 12000*C*D1**2*f**2*fdd*s**2 + 16000*C*D1**2*f**2*fdd*s - 8000*C*D1**2*f**2*fdd - 24000*C*D1**2*f*fd**2*r**2 - 48000*C*D1**2*f*fd**2*r*s + 32000*C*D1**2*f*fd**2*r - 24000*C*D1**2*f*fd**2*s**2 + 32000*C*D1**2*f*fd**2*s - 8000*C*D1**2*f*fd**2 + 24080*C*D1*Dd*f**3*r**2 + 48160*C*D1*Dd*f**3*r*s - 36120*C*D1*Dd*f**3*r + 24080*C*D1*Dd*f**3*s**2 - 36120*C*D1*Dd*f**3*s + 18060*C*D1*Dd*f**3 - 96000*C*D1*Dd*f**2*fd*r**2 - 192000*C*D1*Dd*f**2*fd*r*s + 136000*C*D1*Dd*f**2*fd*r - 96000*C*D1*Dd*f**2*fd*s**2 + 136000*C*D1*Dd*f**2*fd*s - 48000*C*D1*Dd*f**2*fd - 16000*C*D1*Ddd*f**3*r**2 - 32000*C*D1*Ddd*f**3*r*s + 24000*C*D1*Ddd*f**3*r - 16000*C*D1*Ddd*f**3*s**2 + 24000*C*D1*Ddd*f**3*s - 12000*C*D1*Ddd*f**3 - 48000*C*Dd**2*f**3*r**2 - 96000*C*Dd**2*f**3*r*s + 72000*C*Dd**2*f**3*r - 48000*C*Dd**2*f**3*s**2 + 72000*C*Dd**2*f**3*s - 24000*C*Dd**2*f**3 - 2640*D1**2*K*bdd1*f**2*r**2 - 5280*D1**2*K*bdd1*f**2*r*s + 5280*D1**2*K*bdd1*f**2*r - 2640*D1**2*K*bdd1*f**2*s**2 + 5280*D1**2*K*bdd1*f**2*s - 2640*D1**2*K*bdd1*f**2 - 396*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 1500*D1**2*bdd1*f**3*r**2 + 3000*D1**2*bdd1*f**3*r*s - 3000*D1**2*bdd1*f**3*r + 1500*D1**2*bdd1*f**3*s**2 - 3000*D1**2*bdd1*f**3*s + 1500*D1**2*bdd1*f**3 + 1716*D1**2*bdd1*f**2*r**2 + 3432*D1**2*bdd1*f**2*r*s - 3432*D1**2*bdd1*f**2*r + 1716*D1**2*bdd1*f**2*s**2 - 3432*D1**2*bdd1*f**2*s + 1716*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r**2 + 792*D1**2*bdd1*f*g2*r*s - 792*D1**2*bdd1*f*g2*r + 396*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 1500*D1**2*f**3*fd*r**2 - 3000*D1**2*f**3*fd*r*s + 2250*D1**2*f**3*fd*r - 1500*D1**2*f**3*fd*s**2 + 2250*D1**2*f**3*fd*s - 1125*D1**2*f**3*fd - 13248*D1**2*f**2*fd*r**2 - 26496*D1**2*f**2*fd*r*s + 17664*D1**2*f**2*fd*r - 13248*D1**2*f**2*fd*s**2 + 17664*D1**2*f**2*fd*s - 8832*D1**2*f**2*fd + 9000*D1**2*f**2*fdd*r**2 + 18000*D1**2*f**2*fdd*r*s - 12000*D1**2*f**2*fdd*r + 9000*D1**2*f**2*fdd*s**2 - 12000*D1**2*f**2*fdd*s + 6000*D1**2*f**2*fdd - 8580*D1**2*f**2*gd2*r**2 - 17160*D1**2*f**2*gd2*r*s + 17160*D1**2*f**2*gd2*r - 8580*D1**2*f**2*gd2*s**2 + 17160*D1**2*f**2*gd2*s - 8580*D1**2*f**2*gd2 + 5280*D1**2*f**2*gdd2*r**2 + 10560*D1**2*f**2*gdd2*r*s - 10560*D1**2*f**2*gdd2*r + 5280*D1**2*f**2*gdd2*s**2 - 10560*D1**2*f**2*gdd2*s + 5280*D1**2*f**2*gdd2 + 18000*D1**2*f*fd**2*r**2 + 36000*D1**2*f*fd**2*r*s - 24000*D1**2*f*fd**2*r + 18000*D1**2*f*fd**2*s**2 - 24000*D1**2*f*fd**2*s + 6000*D1**2*f*fd**2 - 17160*D1**2*f*fd*g2*r**2 - 34320*D1**2*f*fd*g2*r*s + 17160*D1**2*f*fd*g2*r - 17160*D1**2*f*fd*g2*s**2 + 17160*D1**2*f*fd*g2*s - 8580*D1**2*f*fd*g2 + 21120*D1**2*f*fd*gd2*r**2 + 42240*D1**2*f*fd*gd2*r*s - 31680*D1**2*f*fd*gd2*r + 21120*D1**2*f*fd*gd2*s**2 - 31680*D1**2*f*fd*gd2*s + 10560*D1**2*f*fd*gd2 + 10560*D1**2*f*fdd*g2*r**2 + 21120*D1**2*f*fdd*g2*r*s - 10560*D1**2*f*fdd*g2*r + 10560*D1**2*f*fdd*g2*s**2 - 10560*D1**2*f*fdd*g2*s + 5280*D1**2*f*fdd*g2 + 10560*D1**2*fd**2*g2*r**2 + 21120*D1**2*fd**2*g2*r*s - 10560*D1**2*fd**2*g2*r + 10560*D1**2*fd**2*g2*s**2 - 10560*D1**2*fd**2*g2*s - 1500*D1*Dd*f**4*r**2 - 3000*D1*Dd*f**4*r*s + 2250*D1*Dd*f**4*r - 1500*D1*Dd*f**4*s**2 + 2250*D1*Dd*f**4*s - 1125*D1*Dd*f**4 - 17664*D1*Dd*f**3*r**2 - 35328*D1*Dd*f**3*r*s + 26496*D1*Dd*f**3*r - 17664*D1*Dd*f**3*s**2 + 26496*D1*Dd*f**3*s - 13248*D1*Dd*f**3 + 72000*D1*Dd*f**2*fd*r**2 + 144000*D1*Dd*f**2*fd*r*s - 102000*D1*Dd*f**2*fd*r + 72000*D1*Dd*f**2*fd*s**2 - 102000*D1*Dd*f**2*fd*s + 36000*D1*Dd*f**2*fd - 34320*D1*Dd*f**2*g2*r**2 - 68640*D1*Dd*f**2*g2*r*s + 51480*D1*Dd*f**2*g2*r - 34320*D1*Dd*f**2*g2*s**2 + 51480*D1*Dd*f**2*g2*s - 25740*D1*Dd*f**2*g2 + 42240*D1*Dd*f**2*gd2*r**2 + 84480*D1*Dd*f**2*gd2*r*s - 73920*D1*Dd*f**2*gd2*r + 42240*D1*Dd*f**2*gd2*s**2 - 73920*D1*Dd*f**2*gd2*s + 31680*D1*Dd*f**2*gd2 + 84480*D1*Dd*f*fd*g2*r**2 + 168960*D1*Dd*f*fd*g2*r*s - 105600*D1*Dd*f*fd*g2*r + 84480*D1*Dd*f*fd*g2*s**2 - 105600*D1*Dd*f*fd*g2*s + 31680*D1*Dd*f*fd*g2 + 12000*D1*Ddd*f**3*r**2 + 24000*D1*Ddd*f**3*r*s - 18000*D1*Ddd*f**3*r + 12000*D1*Ddd*f**3*s**2 - 18000*D1*Ddd*f**3*s + 9000*D1*Ddd*f**3 + 21120*D1*Ddd*f**2*g2*r**2 + 42240*D1*Ddd*f**2*g2*r*s - 31680*D1*Ddd*f**2*g2*r + 21120*D1*Ddd*f**2*g2*s**2 - 31680*D1*Ddd*f**2*g2*s + 15840*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(390*f**3*(r + s - 1) - f**2*(132*C*(r + s - 1) + 500*fd*(3*r + 3*s - 2) + (715*K - 473)*(r + s - 1)) + 44*f*(fd*(3*C + 20*K - 13)*(2*r + 2*s - 1) + (3*g2 - 3*gd2)*(r + s - 1)) - 132*fd*g2*(r + s)) - 4*Dd*f*(125*f**2 - 11*f*(3*C + 20*K - 13) + 33*g2)*(4*r + 4*s - 3))*(r + s - 1) + 36000*Dd**2*f**3*r**2 + 72000*Dd**2*f**3*r*s - 54000*Dd**2*f**3*r + 36000*Dd**2*f**3*s**2 - 54000*Dd**2*f**3*s + 18000*Dd**2*f**3 + 63360*Dd**2*f**2*g2*r**2 + 126720*Dd**2*f**2*g2*r*s - 95040*Dd**2*f**2*g2*r + 63360*Dd**2*f**2*g2*s**2 - 95040*Dd**2*f**2*g2*s + 31680*Dd**2*f**2*g2 + 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*b1*(264*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s - 264*C*D1**2*f*fd*r + 264*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s + 132*C*D1**2*f*fd - 132*C*D1**2*f*fdd*r**2 - 264*C*D1**2*f*fdd*r*s + 132*C*D1**2*f*fdd*r - 132*C*D1**2*f*fdd*s**2 + 132*C*D1**2*f*fdd*s - 66*C*D1**2*f*fdd - 132*C*D1**2*fd**2*r**2 - 264*C*D1**2*fd**2*r*s + 132*C*D1**2*fd**2*r - 132*C*D1**2*fd**2*s**2 + 132*C*D1**2*fd**2*s + 528*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 792*C*D1*Dd*f**2*r + 528*C*D1*Dd*f**2*s**2 - 792*C*D1*Dd*f**2*s + 396*C*D1*Dd*f**2 - 1056*C*D1*Dd*f*fd*r**2 - 2112*C*D1*Dd*f*fd*r*s + 1320*C*D1*Dd*f*fd*r - 1056*C*D1*Dd*f*fd*s**2 + 1320*C*D1*Dd*f*fd*s - 396*C*D1*Dd*f*fd - 264*C*D1*Ddd*f**2*r**2 - 528*C*D1*Ddd*f**2*r*s + 396*C*D1*Ddd*f**2*r - 264*C*D1*Ddd*f**2*s**2 + 396*C*D1*Ddd*f**2*s - 198*C*D1*Ddd*f**2 - 792*C*Dd**2*f**2*r**2 - 1584*C*Dd**2*f**2*r*s + 1188*C*Dd**2*f**2*r - 792*C*Dd**2*f**2*s**2 + 1188*C*Dd**2*f**2*s - 396*C*Dd**2*f**2 + 1430*D1**2*K*f*fd*r**2 + 2860*D1**2*K*f*fd*r*s - 1430*D1**2*K*f*fd*r + 1430*D1**2*K*f*fd*s**2 - 1430*D1**2*K*f*fd*s + 715*D1**2*K*f*fd - 880*D1**2*K*f*fdd*r**2 - 1760*D1**2*K*f*fdd*r*s + 880*D1**2*K*f*fdd*r - 880*D1**2*K*f*fdd*s**2 + 880*D1**2*K*f*fdd*s - 440*D1**2*K*f*fdd - 880*D1**2*K*fd**2*r**2 - 1760*D1**2*K*fd**2*r*s + 880*D1**2*K*fd**2*r - 880*D1**2*K*fd**2*s**2 + 880*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 1170*D1**2*f**2*fd*r**2 - 2340*D1**2*f**2*fd*r*s + 1560*D1**2*f**2*fd*r - 1170*D1**2*f**2*fd*s**2 + 1560*D1**2*f**2*fd*s - 780*D1**2*f**2*fd + 750*D1**2*f**2*fdd*r**2 + 1500*D1**2*f**2*fdd*r*s - 1000*D1**2*f**2*fdd*r + 750*D1**2*f**2*fdd*s**2 - 1000*D1**2*f**2*fdd*s + 500*D1**2*f**2*fdd + 1500*D1**2*f*fd**2*r**2 + 3000*D1**2*f*fd**2*r*s - 2000*D1**2*f*fd**2*r + 1500*D1**2*f*fd**2*s**2 - 2000*D1**2*f*fd**2*s + 500*D1**2*f*fd**2 - 946*D1**2*f*fd*r**2 - 1892*D1**2*f*fd*r*s + 946*D1**2*f*fd*r - 946*D1**2*f*fd*s**2 + 946*D1**2*f*fd*s - 473*D1**2*f*fd + 572*D1**2*f*fdd*r**2 + 1144*D1**2*f*fdd*r*s - 572*D1**2*f*fdd*r + 572*D1**2*f*fdd*s**2 - 572*D1**2*f*fdd*s + 286*D1**2*f*fdd - 132*D1**2*f*gd2*r**2 - 264*D1**2*f*gd2*r*s + 264*D1**2*f*gd2*r - 132*D1**2*f*gd2*s**2 + 264*D1**2*f*gd2*s - 132*D1**2*f*gd2 + 66*D1**2*f*gdd2*r**2 + 132*D1**2*f*gdd2*r*s - 132*D1**2*f*gdd2*r + 66*D1**2*f*gdd2*s**2 - 132*D1**2*f*gdd2*s + 66*D1**2*f*gdd2 + 572*D1**2*fd**2*r**2 + 1144*D1**2*fd**2*r*s - 572*D1**2*fd**2*r + 572*D1**2*fd**2*s**2 - 572*D1**2*fd**2*s - 132*D1**2*fd*g2*r**2 - 264*D1**2*fd*g2*r*s - 132*D1**2*fd*g2*s**2 + 132*D1**2*fd*gd2*r**2 + 264*D1**2*fd*gd2*r*s - 132*D1**2*fd*gd2*r + 132*D1**2*fd*gd2*s**2 - 132*D1**2*fd*gd2*s + 66*D1**2*fdd*g2*r**2 + 132*D1**2*fdd*g2*r*s + 66*D1**2*fdd*g2*s**2 + 2860*D1*Dd*K*f**2*r**2 + 5720*D1*Dd*K*f**2*r*s - 4290*D1*Dd*K*f**2*r + 2860*D1*Dd*K*f**2*s**2 - 4290*D1*Dd*K*f**2*s + 2145*D1*Dd*K*f**2 - 7040*D1*Dd*K*f*fd*r**2 - 14080*D1*Dd*K*f*fd*r*s + 8800*D1*Dd*K*f*fd*r - 7040*D1*Dd*K*f*fd*s**2 + 8800*D1*Dd*K*f*fd*s - 2640*D1*Dd*K*f*fd - 1560*D1*Dd*f**3*r**2 - 3120*D1*Dd*f**3*r*s + 2340*D1*Dd*f**3*r - 1560*D1*Dd*f**3*s**2 + 2340*D1*Dd*f**3*s - 1170*D1*Dd*f**3 + 6000*D1*Dd*f**2*fd*r**2 + 12000*D1*Dd*f**2*fd*r*s - 8500*D1*Dd*f**2*fd*r + 6000*D1*Dd*f**2*fd*s**2 - 8500*D1*Dd*f**2*fd*s + 3000*D1*Dd*f**2*fd - 1892*D1*Dd*f**2*r**2 - 3784*D1*Dd*f**2*r*s + 2838*D1*Dd*f**2*r - 1892*D1*Dd*f**2*s**2 + 2838*D1*Dd*f**2*s - 1419*D1*Dd*f**2 + 4576*D1*Dd*f*fd*r**2 + 9152*D1*Dd*f*fd*r*s - 5720*D1*Dd*f*fd*r + 4576*D1*Dd*f*fd*s**2 - 5720*D1*Dd*f*fd*s + 1716*D1*Dd*f*fd - 528*D1*Dd*f*g2*r**2 - 1056*D1*Dd*f*g2*r*s + 792*D1*Dd*f*g2*r - 528*D1*Dd*f*g2*s**2 + 792*D1*Dd*f*g2*s - 396*D1*Dd*f*g2 + 528*D1*Dd*f*gd2*r**2 + 1056*D1*Dd*f*gd2*r*s - 924*D1*Dd*f*gd2*r + 528*D1*Dd*f*gd2*s**2 - 924*D1*Dd*f*gd2*s + 396*D1*Dd*f*gd2 + 528*D1*Dd*fd*g2*r**2 + 1056*D1*Dd*fd*g2*r*s - 396*D1*Dd*fd*g2*r + 528*D1*Dd*fd*g2*s**2 - 396*D1*Dd*fd*g2*s - 1760*D1*Ddd*K*f**2*r**2 - 3520*D1*Ddd*K*f**2*r*s + 2640*D1*Ddd*K*f**2*r - 1760*D1*Ddd*K*f**2*s**2 + 2640*D1*Ddd*K*f**2*s - 1320*D1*Ddd*K*f**2 + 1000*D1*Ddd*f**3*r**2 + 2000*D1*Ddd*f**3*r*s - 1500*D1*Ddd*f**3*r + 1000*D1*Ddd*f**3*s**2 - 1500*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 + 1144*D1*Ddd*f**2*r**2 + 2288*D1*Ddd*f**2*r*s - 1716*D1*Ddd*f**2*r + 1144*D1*Ddd*f**2*s**2 - 1716*D1*Ddd*f**2*s + 858*D1*Ddd*f**2 + 264*D1*Ddd*f*g2*r**2 + 528*D1*Ddd*f*g2*r*s - 396*D1*Ddd*f*g2*r + 264*D1*Ddd*f*g2*s**2 - 396*D1*Ddd*f*g2*s + 198*D1*Ddd*f*g2 + 132*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 5280*Dd**2*K*f**2*r**2 - 10560*Dd**2*K*f**2*r*s + 7920*Dd**2*K*f**2*r - 5280*Dd**2*K*f**2*s**2 + 7920*Dd**2*K*f**2*s - 2640*Dd**2*K*f**2 + 3000*Dd**2*f**3*r**2 + 6000*Dd**2*f**3*r*s - 4500*Dd**2*f**3*r + 3000*Dd**2*f**3*s**2 - 4500*Dd**2*f**3*s + 1500*Dd**2*f**3 + 3432*Dd**2*f**2*r**2 + 6864*Dd**2*f**2*r*s - 5148*Dd**2*f**2*r + 3432*Dd**2*f**2*s**2 - 5148*Dd**2*f**2*s + 1716*Dd**2*f**2 + 792*Dd**2*f*g2*r**2 + 1584*Dd**2*f*g2*r*s - 1188*Dd**2*f*g2*r + 792*Dd**2*f*g2*s**2 - 1188*Dd**2*f*g2*s + 396*Dd**2*f*g2))/(231*d**2*k3**8) + 8*D1**2*Pk2*Pk3*ct**4*k1**2*k2**4*(880*C*D1**2*bdd1*f**2*r**2 + 1760*C*D1**2*bdd1*f**2*r*s - 1760*C*D1**2*bdd1*f**2*r + 880*C*D1**2*bdd1*f**2*s**2 - 1760*C*D1**2*bdd1*f**2*s + 880*C*D1**2*bdd1*f**2 - 390*C*D1**2*f**2*fd*r**2 - 780*C*D1**2*f**2*fd*r*s + 520*C*D1**2*f**2*fd*r - 390*C*D1**2*f**2*fd*s**2 + 520*C*D1**2*f**2*fd*s - 260*C*D1**2*f**2*fd + 1680*C*D1**2*f**2*fdd*r**2 + 3360*C*D1**2*f**2*fdd*r*s - 2240*C*D1**2*f**2*fdd*r + 1680*C*D1**2*f**2*fdd*s**2 - 2240*C*D1**2*f**2*fdd*s + 1120*C*D1**2*f**2*fdd + 3360*C*D1**2*f*fd**2*r**2 + 6720*C*D1**2*f*fd**2*r*s - 4480*C*D1**2*f*fd**2*r + 3360*C*D1**2*f*fd**2*s**2 - 4480*C*D1**2*f*fd**2*s + 1120*C*D1**2*f*fd**2 - 520*C*D1*Dd*f**3*r**2 - 1040*C*D1*Dd*f**3*r*s + 780*C*D1*Dd*f**3*r - 520*C*D1*Dd*f**3*s**2 + 780*C*D1*Dd*f**3*s - 390*C*D1*Dd*f**3 + 13440*C*D1*Dd*f**2*fd*r**2 + 26880*C*D1*Dd*f**2*fd*r*s - 19040*C*D1*Dd*f**2*fd*r + 13440*C*D1*Dd*f**2*fd*s**2 - 19040*C*D1*Dd*f**2*fd*s + 6720*C*D1*Dd*f**2*fd + 2240*C*D1*Ddd*f**3*r**2 + 4480*C*D1*Ddd*f**3*r*s - 3360*C*D1*Ddd*f**3*r + 2240*C*D1*Ddd*f**3*s**2 - 3360*C*D1*Ddd*f**3*s + 1680*C*D1*Ddd*f**3 + 6720*C*Dd**2*f**3*r**2 + 13440*C*Dd**2*f**3*r*s - 10080*C*Dd**2*f**3*r + 6720*C*Dd**2*f**3*s**2 - 10080*C*Dd**2*f**3*s + 3360*C*Dd**2*f**3 + 330*D1**2*K*bdd1*f**2*r**2 + 660*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*r + 330*D1**2*K*bdd1*f**2*s**2 - 660*D1**2*K*bdd1*f**2*s + 330*D1**2*K*bdd1*f**2 - 22*D1**2*bd1**2*f*(-48*K + 25*f + 24)*(r + s - 1)**2 - 660*D1**2*bdd1*f**2*r**2 - 1320*D1**2*bdd1*f**2*r*s + 1320*D1**2*bdd1*f**2*r - 660*D1**2*bdd1*f**2*s**2 + 1320*D1**2*bdd1*f**2*s - 660*D1**2*bdd1*f**2 - 1056*D1**2*bdd1*f*g2*r**2 - 2112*D1**2*bdd1*f*g2*r*s + 2112*D1**2*bdd1*f*g2*r - 1056*D1**2*bdd1*f*g2*s**2 + 2112*D1**2*bdd1*f*g2*s - 1056*D1**2*bdd1*f*g2 - 135*D1**2*f**2*fd*r**2 - 270*D1**2*f**2*fd*r*s + 180*D1**2*f**2*fd*r - 135*D1**2*f**2*fd*s**2 + 180*D1**2*f**2*fd*s - 90*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 - 1680*D1**2*f**2*fdd*r*s + 1120*D1**2*f**2*fdd*r - 840*D1**2*f**2*fdd*s**2 + 1120*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd + 132*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*r + 132*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gd2 - 660*D1**2*f**2*gdd2*r**2 - 1320*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*r - 660*D1**2*f**2*gdd2*s**2 + 1320*D1**2*f**2*gdd2*s - 660*D1**2*f**2*gdd2 - 1680*D1**2*f*fd**2*r**2 - 3360*D1**2*f*fd**2*r*s + 2240*D1**2*f*fd**2*r - 1680*D1**2*f*fd**2*s**2 + 2240*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 + 264*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r**2 - 5280*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r - 2640*D1**2*f*fd*gd2*s**2 + 3960*D1**2*f*fd*gd2*s - 1320*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r**2 - 2640*D1**2*f*fdd*g2*r*s + 1320*D1**2*f*fdd*g2*r - 1320*D1**2*f*fdd*g2*s**2 + 1320*D1**2*f*fdd*g2*s - 660*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r**2 - 2640*D1**2*fd**2*g2*r*s + 1320*D1**2*fd**2*g2*r - 1320*D1**2*fd**2*g2*s**2 + 1320*D1**2*fd**2*g2*s - 180*D1*Dd*f**3*r**2 - 360*D1*Dd*f**3*r*s + 270*D1*Dd*f**3*r - 180*D1*Dd*f**3*s**2 + 270*D1*Dd*f**3*s - 135*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 - 13440*D1*Dd*f**2*fd*r*s + 9520*D1*Dd*f**2*fd*r - 6720*D1*Dd*f**2*fd*s**2 + 9520*D1*Dd*f**2*fd*s - 3360*D1*Dd*f**2*fd + 528*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 396*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r**2 - 10560*D1*Dd*f**2*gd2*r*s + 9240*D1*Dd*f**2*gd2*r - 5280*D1*Dd*f**2*gd2*s**2 + 9240*D1*Dd*f**2*gd2*s - 3960*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r**2 - 21120*D1*Dd*f*fd*g2*r*s + 13200*D1*Dd*f*fd*g2*r - 10560*D1*Dd*f*fd*g2*s**2 + 13200*D1*Dd*f*fd*g2*s - 3960*D1*Dd*f*fd*g2 - 1120*D1*Ddd*f**3*r**2 - 2240*D1*Ddd*f**3*r*s + 1680*D1*Ddd*f**3*r - 1120*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 840*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r**2 - 5280*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r - 2640*D1*Ddd*f**2*g2*s**2 + 3960*D1*Ddd*f**2*g2*s - 1980*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(50*C + 3*K - 30)*(r + s - 1) - 10*f*fd*(8*C + 3*K - 6)*(2*r + 2*s - 1) - f*(61*g2 - 96*gd2)*(r + s - 1) + 96*fd*g2*(r + s)) - 2*Dd*f*(5*f*(8*C + 3*K - 6) - 48*g2)*(4*r + 4*s - 3))*(r + s - 1) - 3360*Dd**2*f**3*r**2 - 6720*Dd**2*f**3*r*s + 5040*Dd**2*f**3*r - 3360*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 1680*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r**2 - 15840*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r - 7920*Dd**2*f**2*g2*s**2 + 11880*Dd**2*f**2*g2*s - 3960*Dd**2*f**2*g2 + 11*b1**2*(D1**2*(f*(38*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + fd*(61*K - 27)*(r + s) - 24*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(38*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(50*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (61*K - 27)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 48*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-48*K + 25*f + 24)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-48*K + 25*f + 24)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*(-100*C*D1**2*f*fd*r**2 - 200*C*D1**2*f*fd*r*s + 100*C*D1**2*f*fd*r - 100*C*D1**2*f*fd*s**2 + 100*C*D1**2*f*fd*s - 50*C*D1**2*f*fd + 80*C*D1**2*f*fdd*r**2 + 160*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 - 80*C*D1**2*f*fdd*s + 40*C*D1**2*f*fdd + 80*C*D1**2*fd**2*r**2 + 160*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 - 80*C*D1**2*fd**2*s - 200*C*D1*Dd*f**2*r**2 - 400*C*D1*Dd*f**2*r*s + 300*C*D1*Dd*f**2*r - 200*C*D1*Dd*f**2*s**2 + 300*C*D1*Dd*f**2*s - 150*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*r**2 + 1280*C*D1*Dd*f*fd*r*s - 800*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 800*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r**2 + 320*C*D1*Ddd*f**2*r*s - 240*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 240*C*D1*Ddd*f**2*s + 120*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r**2 + 960*C*Dd**2*f**2*r*s - 720*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 720*C*Dd**2*f**2*s + 240*C*Dd**2*f**2 - 6*D1**2*K*f*fd*r**2 - 12*D1**2*K*f*fd*r*s + 6*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 + 60*D1**2*K*f*fdd*r*s - 30*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 + 60*D1**2*K*fd**2*r*s - 30*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(-48*K + 25*f + 24)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 60*D1**2*f*fd*r**2 + 120*D1**2*f*fd*r*s - 60*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 60*D1**2*f*fd*s + 30*D1**2*f*fd - 60*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 60*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s - 30*D1**2*f*fdd + 61*D1**2*f*gd2*r**2 + 122*D1**2*f*gd2*r*s - 122*D1**2*f*gd2*r + 61*D1**2*f*gd2*s**2 - 122*D1**2*f*gd2*s + 61*D1**2*f*gd2 - 48*D1**2*f*gdd2*r**2 - 96*D1**2*f*gdd2*r*s + 96*D1**2*f*gdd2*r - 48*D1**2*f*gdd2*s**2 + 96*D1**2*f*gdd2*s - 48*D1**2*f*gdd2 - 60*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 60*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s + 61*D1**2*fd*g2*r**2 + 122*D1**2*fd*g2*r*s + 61*D1**2*fd*g2*s**2 - 96*D1**2*fd*gd2*r**2 - 192*D1**2*fd*gd2*r*s + 96*D1**2*fd*gd2*r - 96*D1**2*fd*gd2*s**2 + 96*D1**2*fd*gd2*s - 48*D1**2*fdd*g2*r**2 - 96*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*s**2 - 12*D1*Dd*K*f**2*r**2 - 24*D1*Dd*K*f**2*r*s + 18*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 18*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 + 480*D1*Dd*K*f*fd*r*s - 300*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 300*D1*Dd*K*f*fd*s + 90*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 120*D1*Dd*f**2*r**2 + 240*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 180*D1*Dd*f**2*s + 90*D1*Dd*f**2 - 480*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 600*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 600*D1*Dd*f*fd*s - 180*D1*Dd*f*fd + 244*D1*Dd*f*g2*r**2 + 488*D1*Dd*f*g2*r*s - 366*D1*Dd*f*g2*r + 244*D1*Dd*f*g2*s**2 - 366*D1*Dd*f*g2*s + 183*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r**2 - 768*D1*Dd*f*gd2*r*s + 672*D1*Dd*f*gd2*r - 384*D1*Dd*f*gd2*s**2 + 672*D1*Dd*f*gd2*s - 288*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r**2 - 768*D1*Dd*fd*g2*r*s + 288*D1*Dd*fd*g2*r - 384*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r**2 + 120*D1*Ddd*K*f**2*r*s - 90*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 90*D1*Ddd*K*f**2*s + 45*D1*Ddd*K*f**2 - 120*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 90*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r**2 - 384*D1*Ddd*f*g2*r*s + 288*D1*Ddd*f*g2*r - 192*D1*Ddd*f*g2*s**2 + 288*D1*Ddd*f*g2*s - 144*D1*Ddd*f*g2 + D1*bd1*(D1*(38*f**2*(r + s - 1) - 50*f*fd*(2*r + 2*s - 1) - f*(61*K - 27)*(r + s - 1) + 48*fd*(2*K - 1)*(r + s)) - 2*Dd*f*(-48*K + 25*f + 24)*(4*r + 4*s - 3))*(r + s - 1) + 180*Dd**2*K*f**2*r**2 + 360*Dd**2*K*f**2*r*s - 270*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 270*Dd**2*K*f**2*s + 90*Dd**2*K*f**2 - 360*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 540*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 180*Dd**2*f**2 - 576*Dd**2*f*g2*r**2 - 1152*Dd**2*f*g2*r*s + 864*Dd**2*f*g2*r - 576*Dd**2*f*g2*s**2 + 864*Dd**2*f*g2*s - 288*Dd**2*f*g2))/(77*d**2*k3**8) - 2*D1**2*Pk2*Pk3*ct**4*k1**2*k2**2*st**2*(-792*C*D1**2*bdd1*f**2*r**2 - 3168*C*D1**2*bdd1*f**2*r*s + 1584*C*D1**2*bdd1*f**2*r - 2376*C*D1**2*bdd1*f**2*s**2 + 3168*C*D1**2*bdd1*f**2*s - 1584*C*D1**2*bdd1*f**2 - 36972*C*D1**2*f**2*fd*r**2 + 456*C*D1**2*f**2*fd*r*s + 24496*C*D1**2*f**2*fd*r + 37428*C*D1**2*f**2*fd*s**2 - 25104*C*D1**2*f**2*fd*s + 152*C*D1**2*f**2*fd + 27396*C*D1**2*f**2*fdd*r**2 + 8088*C*D1**2*f**2*fdd*r*s - 20960*C*D1**2*f**2*fdd*r - 19308*C*D1**2*f**2*fdd*s**2 + 10176*C*D1**2*f**2*fdd*s + 2696*C*D1**2*f**2*fdd + 54792*C*D1**2*f*fd**2*r**2 + 16176*C*D1**2*f*fd**2*r*s - 41920*C*D1**2*f*fd**2*r - 38616*C*D1**2*f*fd**2*s**2 + 20352*C*D1**2*f*fd**2*s + 2696*C*D1**2*f*fd**2 - 49296*C*D1*Dd*f**3*r**2 + 608*C*D1*Dd*f**3*r*s + 49144*C*D1*Dd*f**3*r + 49904*C*D1*Dd*f**3*s**2 - 25256*C*D1*Dd*f**3*s - 12172*C*D1*Dd*f**3 + 219168*C*D1*Dd*f**2*fd*r**2 + 64704*C*D1*Dd*f**2*fd*r*s - 201512*C*D1*Dd*f**2*fd*r - 154464*C*D1*Dd*f**2*fd*s**2 + 63144*C*D1*Dd*f**2*fd*s + 31744*C*D1*Dd*f**2*fd + 36528*C*D1*Ddd*f**3*r**2 + 10784*C*D1*Ddd*f**3*r*s - 39224*C*D1*Ddd*f**3*r - 25744*C*D1*Ddd*f**3*s**2 + 7480*C*D1*Ddd*f**3*s + 11828*C*D1*Ddd*f**3 + 109584*C*Dd**2*f**3*r**2 + 32352*C*Dd**2*f**3*r*s - 117672*C*Dd**2*f**3*r - 77232*C*Dd**2*f**3*s**2 + 22440*C*Dd**2*f**3*s + 23656*C*Dd**2*f**3 + 4950*D1**2*K*bdd1*f**2*r**2 + 132*D1**2*K*bdd1*f**2*r*s - 9900*D1**2*K*bdd1*f**2*r - 4818*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s + 4950*D1**2*K*bdd1*f**2 - 792*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1) - 3750*D1**2*bdd1*f**3*r**2 - 3000*D1**2*bdd1*f**3*r*s + 7500*D1**2*bdd1*f**3*r + 750*D1**2*bdd1*f**3*s**2 + 3000*D1**2*bdd1*f**3*s - 4500*D1**2*bdd1*f**3 - 6798*D1**2*bdd1*f**2*r**2 - 6204*D1**2*bdd1*f**2*r*s + 13596*D1**2*bdd1*f**2*r + 594*D1**2*bdd1*f**2*s**2 + 6204*D1**2*bdd1*f**2*s - 6006*D1**2*bdd1*f**2 + 792*D1**2*bdd1*f*g2*r**2 + 3168*D1**2*bdd1*f*g2*r*s - 1584*D1**2*bdd1*f*g2*r + 2376*D1**2*bdd1*f*g2*s**2 - 3168*D1**2*bdd1*f*g2*s + 1584*D1**2*bdd1*f*g2 - 31500*D1**2*f**3*fd*r**2 - 60000*D1**2*f**3*fd*r*s + 46500*D1**2*f**3*fd*r - 28500*D1**2*f**3*fd*s**2 + 44250*D1**2*f**3*fd*s - 22875*D1**2*f**3*fd + 34500*D1**2*f**3*fdd*r**2 + 54000*D1**2*f**3*fdd*r*s - 48000*D1**2*f**3*fdd*r + 19500*D1**2*f**3*fdd*s**2 - 36750*D1**2*f**3*fdd*s + 22125*D1**2*f**3*fdd + 103500*D1**2*f**2*fd**2*r**2 + 162000*D1**2*f**2*fd**2*r*s - 144000*D1**2*f**2*fd**2*r + 58500*D1**2*f**2*fd**2*s**2 - 110250*D1**2*f**2*fd**2*s + 44250*D1**2*f**2*fd**2 + 46596*D1**2*f**2*fd*r**2 + 34416*D1**2*f**2*fd*r*s - 42536*D1**2*f**2*fd*r - 12180*D1**2*f**2*fd*s**2 - 3352*D1**2*f**2*fd*s + 11472*D1**2*f**2*fd - 33396*D1**2*f**2*fdd*r**2 - 29088*D1**2*f**2*fdd*r*s + 31960*D1**2*f**2*fdd*r + 4308*D1**2*f**2*fdd*s**2 + 6824*D1**2*f**2*fdd*s - 9696*D1**2*f**2*fdd + 15444*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s - 30888*D1**2*f**2*gd2*r - 18876*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s + 15444*D1**2*f**2*gd2 - 9900*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 19800*D1**2*f**2*gdd2*r + 9636*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 9900*D1**2*f**2*gdd2 - 66792*D1**2*f*fd**2*r**2 - 58176*D1**2*f*fd**2*r*s + 63920*D1**2*f*fd**2*r + 8616*D1**2*f*fd**2*s**2 + 13648*D1**2*f*fd**2*s - 9696*D1**2*f*fd**2 + 30888*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 37752*D1**2*f*fd*g2*s**2 + 37752*D1**2*f*fd*g2*s - 18876*D1**2*f*fd*g2 - 39600*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 39864*D1**2*f*fd*gd2*r + 38544*D1**2*f*fd*gd2*s**2 - 18744*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 19800*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r + 19272*D1**2*f*fdd*g2*s**2 - 19272*D1**2*f*fdd*g2*s + 9636*D1**2*f*fdd*g2 - 19800*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r + 19272*D1**2*fd**2*g2*s**2 - 19272*D1**2*fd**2*g2*s - 31500*D1*Dd*f**4*r**2 - 60000*D1*Dd*f**4*r*s + 46500*D1*Dd*f**4*r - 28500*D1*Dd*f**4*s**2 + 44250*D1*Dd*f**4*s - 22875*D1*Dd*f**4 + 276000*D1*Dd*f**3*fd*r**2 + 432000*D1*Dd*f**3*fd*r*s - 384000*D1*Dd*f**3*fd*r + 156000*D1*Dd*f**3*fd*s**2 - 294000*D1*Dd*f**3*fd*s + 132750*D1*Dd*f**3*fd + 62128*D1*Dd*f**3*r**2 + 45888*D1*Dd*f**3*r*s - 73600*D1*Dd*f**3*r - 16240*D1*Dd*f**3*s**2 - 14824*D1*Dd*f**3*s + 27004*D1*Dd*f**3 - 267168*D1*Dd*f**2*fd*r**2 - 232704*D1*Dd*f**2*fd*r*s + 290512*D1*Dd*f**2*fd*r + 34464*D1*Dd*f**2*fd*s**2 + 76856*D1*Dd*f**2*fd*s - 70744*D1*Dd*f**2*fd + 61776*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s - 58344*D1*Dd*f**2*g2*r - 75504*D1*Dd*f**2*g2*s**2 + 44616*D1*Dd*f**2*g2*s + 12012*D1*Dd*f**2*g2 - 79200*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 119064*D1*Dd*f**2*gd2*r + 77088*D1*Dd*f**2*gd2*s**2 - 17688*D1*Dd*f**2*gd2*s - 39864*D1*Dd*f**2*gd2 - 158400*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 80784*D1*Dd*f*fd*g2*r + 154176*D1*Dd*f*fd*g2*s**2 - 114576*D1*Dd*f*fd*g2*s + 18744*D1*Dd*f*fd*g2 + 34500*D1*Ddd*f**4*r**2 + 54000*D1*Ddd*f**4*r*s - 48000*D1*Ddd*f**4*r + 19500*D1*Ddd*f**4*s**2 - 36750*D1*Ddd*f**4*s + 22125*D1*Ddd*f**4 - 44528*D1*Ddd*f**3*r**2 - 38784*D1*Ddd*f**3*r*s + 54224*D1*Ddd*f**3*r + 5744*D1*Ddd*f**3*s**2 + 16520*D1*Ddd*f**3*s - 20828*D1*Ddd*f**3 - 39600*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 39864*D1*Ddd*f**2*g2*r + 38544*D1*Ddd*f**2*g2*s**2 - 18744*D1*Ddd*f**2*g2*s - 10164*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(10*f**3*(103*r**2 + r*(78*s - 206) - 25*s**2 - 78*s + 128) + f**2*(264*C*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 2) - 143*K*(9*r**2 - 2*r*(s + 9) - 11*s**2 + 2*s + 9) - 250*fd*(15*r**2 + 2*r*(6*s - 11) - 3*s**2 - 7*s + 6) + 1771*r**2 + 1342*r*s - 3542*r - 429*s**2 - 1342*s + 1507) - 22*f*(fd*(12*C*(2*r**2 + r*(8*s - 4) + 6*s**2 - 7*s + 1) - K*(150*r**2 + 4*r*s - 151*r - 146*s**2 + 71*s + 1) + 206*r**2 + 188*r*s - 253*r - 18*s**2 - 85*s + 59) + 12*g2*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 2) - 12*gd2*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1)) + 264*fd*g2*(r**2 + r*(4*s - 2) + s*(3*s - 3))) - 2*Dd*f*(125*f**2*(20*r**2 + 16*r*(s - 2) - 4*s**2 - 11*s + 12) + 11*f*(12*C*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4) - K*(300*r**2 + 8*r*s - 451*r - 292*s**2 + 67*s + 151) + 412*r**2 + 376*r*s - 665*r - 36*s**2 - 273*s + 253) - 132*g2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4))) + 103500*Dd**2*f**4*r**2 + 162000*Dd**2*f**4*r*s - 144000*Dd**2*f**4*r + 58500*Dd**2*f**4*s**2 - 110250*Dd**2*f**4*s + 44250*Dd**2*f**4 - 133584*Dd**2*f**3*r**2 - 116352*Dd**2*f**3*r*s + 162672*Dd**2*f**3*r + 17232*Dd**2*f**3*s**2 + 49560*Dd**2*f**3*s - 41656*Dd**2*f**3 - 118800*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 119592*Dd**2*f**2*g2*r + 115632*Dd**2*f**2*g2*s**2 - 56232*Dd**2*f**2*g2*s - 20328*Dd**2*f**2*g2 + 396*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + D1*(2*Dd*(f*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 14*s + 5) - fd*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3)) - Ddd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 14*s + 5)) - 2*Dd**2*f*(6*r**2 + 12*r*(2*s - 1) + 18*s**2 - 21*s + 5)) + 6*b1*(528*C*D1**2*f*fd*r**2 + 2112*C*D1**2*f*fd*r*s - 1056*C*D1**2*f*fd*r + 1584*C*D1**2*f*fd*s**2 - 1584*C*D1**2*f*fd*s + 528*C*D1**2*f*fd - 264*C*D1**2*f*fdd*r**2 - 1056*C*D1**2*f*fdd*r*s + 528*C*D1**2*f*fdd*r - 792*C*D1**2*f*fdd*s**2 + 792*C*D1**2*f*fdd*s - 264*C*D1**2*f*fdd - 264*C*D1**2*fd**2*r**2 - 1056*C*D1**2*fd**2*r*s + 528*C*D1**2*fd**2*r - 792*C*D1**2*fd**2*s**2 + 792*C*D1**2*fd**2*s - 264*C*D1**2*fd**2 + 1056*C*D1*Dd*f**2*r**2 + 4224*C*D1*Dd*f**2*r*s - 2112*C*D1*Dd*f**2*r + 3168*C*D1*Dd*f**2*s**2 - 3696*C*D1*Dd*f**2*s + 1320*C*D1*Dd*f**2 - 2112*C*D1*Dd*f*fd*r**2 - 8448*C*D1*Dd*f*fd*r*s + 4224*C*D1*Dd*f*fd*r - 6336*C*D1*Dd*f*fd*s**2 + 6864*C*D1*Dd*f*fd*s - 1848*C*D1*Dd*f*fd - 528*C*D1*Ddd*f**2*r**2 - 2112*C*D1*Ddd*f**2*r*s + 1056*C*D1*Ddd*f**2*r - 1584*C*D1*Ddd*f**2*s**2 + 1848*C*D1*Ddd*f**2*s - 660*C*D1*Ddd*f**2 - 1584*C*Dd**2*f**2*r**2 - 6336*C*Dd**2*f**2*r*s + 3168*C*Dd**2*f**2*r - 4752*C*Dd**2*f**2*s**2 + 5544*C*Dd**2*f**2*s - 1320*C*Dd**2*f**2 - 2574*D1**2*K*f*fd*r**2 + 572*D1**2*K*f*fd*r*s - 286*D1**2*K*f*fd*r + 3146*D1**2*K*f*fd*s**2 - 3146*D1**2*K*f*fd*s + 1573*D1**2*K*f*fd + 1650*D1**2*K*f*fdd*r**2 + 44*D1**2*K*f*fdd*r*s - 22*D1**2*K*f*fdd*r - 1606*D1**2*K*f*fdd*s**2 + 1606*D1**2*K*f*fdd*s - 803*D1**2*K*f*fdd + 1650*D1**2*K*fd**2*r**2 + 44*D1**2*K*fd**2*r*s - 22*D1**2*K*fd**2*r - 1606*D1**2*K*fd**2*s**2 + 1606*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(K - 1)*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) + 3090*D1**2*f**2*fd*r**2 + 2340*D1**2*f**2*fd*r*s - 2840*D1**2*f**2*fd*r - 750*D1**2*f**2*fd*s**2 - 280*D1**2*f**2*fd*s + 530*D1**2*f**2*fd - 1875*D1**2*f**2*fdd*r**2 - 1500*D1**2*f**2*fdd*r*s + 1750*D1**2*f**2*fdd*r + 375*D1**2*f**2*fdd*s**2 + 250*D1**2*f**2*fdd*s - 375*D1**2*f**2*fdd - 3750*D1**2*f*fd**2*r**2 - 3000*D1**2*f*fd**2*r*s + 3500*D1**2*f*fd**2*r + 750*D1**2*f*fd**2*s**2 + 500*D1**2*f*fd**2*s - 750*D1**2*f*fd**2 + 3542*D1**2*f*fd*r**2 + 2684*D1**2*f*fd*r*s - 1342*D1**2*f*fd*r - 858*D1**2*f*fd*s**2 + 858*D1**2*f*fd*s - 165*D1**2*f*fd - 2266*D1**2*f*fdd*r**2 - 2068*D1**2*f*fdd*r*s + 1034*D1**2*f*fdd*r + 198*D1**2*f*fdd*s**2 - 198*D1**2*f*fdd*s - 33*D1**2*f*fdd - 264*D1**2*f*gd2*r**2 - 1056*D1**2*f*gd2*r*s + 528*D1**2*f*gd2*r - 792*D1**2*f*gd2*s**2 + 1056*D1**2*f*gd2*s - 264*D1**2*f*gd2 + 132*D1**2*f*gdd2*r**2 + 528*D1**2*f*gdd2*r*s - 264*D1**2*f*gdd2*r + 396*D1**2*f*gdd2*s**2 - 528*D1**2*f*gdd2*s + 132*D1**2*f*gdd2 - 2266*D1**2*fd**2*r**2 - 2068*D1**2*fd**2*r*s + 1034*D1**2*fd**2*r + 198*D1**2*fd**2*s**2 - 198*D1**2*fd**2*s + 264*D1**2*fd**2 - 264*D1**2*fd*g2*r**2 - 1056*D1**2*fd*g2*r*s + 528*D1**2*fd*g2*r - 792*D1**2*fd*g2*s**2 + 528*D1**2*fd*g2*s - 264*D1**2*fd*g2 + 264*D1**2*fd*gd2*r**2 + 1056*D1**2*fd*gd2*r*s - 528*D1**2*fd*gd2*r + 792*D1**2*fd*gd2*s**2 - 792*D1**2*fd*gd2*s + 264*D1**2*fd*gd2 + 132*D1**2*fdd*g2*r**2 + 528*D1**2*fdd*g2*r*s - 264*D1**2*fdd*g2*r + 396*D1**2*fdd*g2*s**2 - 264*D1**2*fdd*g2*s + 132*D1**2*fdd*g2 - 5148*D1*Dd*K*f**2*r**2 + 1144*D1*Dd*K*f**2*r*s + 4862*D1*Dd*K*f**2*r + 6292*D1*Dd*K*f**2*s**2 - 3718*D1*Dd*K*f**2*s - 1001*D1*Dd*K*f**2 + 13200*D1*Dd*K*f*fd*r**2 + 352*D1*Dd*K*f*fd*r*s - 6732*D1*Dd*K*f*fd*r - 12848*D1*Dd*K*f*fd*s**2 + 9548*D1*Dd*K*f*fd*s - 1562*D1*Dd*K*f*fd + 4120*D1*Dd*f**3*r**2 + 3120*D1*Dd*f**3*r*s - 4900*D1*Dd*f**3*r - 1000*D1*Dd*f**3*s**2 - 1060*D1*Dd*f**3*s + 1810*D1*Dd*f**3 - 15000*D1*Dd*f**2*fd*r**2 - 12000*D1*Dd*f**2*fd*r*s + 16000*D1*Dd*f**2*fd*r + 3000*D1*Dd*f**2*fd*s**2 + 3250*D1*Dd*f**2*fd*s - 3750*D1*Dd*f**2*fd + 7084*D1*Dd*f**2*r**2 + 5368*D1*Dd*f**2*r*s - 8426*D1*Dd*f**2*r - 1716*D1*Dd*f**2*s**2 - 1826*D1*Dd*f**2*s + 3113*D1*Dd*f**2 - 18128*D1*Dd*f*fd*r**2 - 16544*D1*Dd*f*fd*r*s + 15268*D1*Dd*f*fd*r + 1584*D1*Dd*f*fd*s**2 + 2948*D1*Dd*f*fd*s - 1870*D1*Dd*f*fd - 1056*D1*Dd*f*g2*r**2 - 4224*D1*Dd*f*g2*r*s + 2112*D1*Dd*f*g2*r - 3168*D1*Dd*f*g2*s**2 + 3696*D1*Dd*f*g2*s - 1320*D1*Dd*f*g2 + 1056*D1*Dd*f*gd2*r**2 + 4224*D1*Dd*f*gd2*r*s - 2112*D1*Dd*f*gd2*r + 3168*D1*Dd*f*gd2*s**2 - 3960*D1*Dd*f*gd2*s + 1056*D1*Dd*f*gd2 + 1056*D1*Dd*fd*g2*r**2 + 4224*D1*Dd*fd*g2*r*s - 2112*D1*Dd*fd*g2*r + 3168*D1*Dd*fd*g2*s**2 - 2904*D1*Dd*fd*g2*s + 792*D1*Dd*fd*g2 + 3300*D1*Ddd*K*f**2*r**2 + 88*D1*Ddd*K*f**2*r*s - 3322*D1*Ddd*K*f**2*r - 3212*D1*Ddd*K*f**2*s**2 + 1562*D1*Ddd*K*f**2*s + 847*D1*Ddd*K*f**2 - 2500*D1*Ddd*f**3*r**2 - 2000*D1*Ddd*f**3*r*s + 3000*D1*Ddd*f**3*r + 500*D1*Ddd*f**3*s**2 + 750*D1*Ddd*f**3*s - 1125*D1*Ddd*f**3 - 4532*D1*Ddd*f**2*r**2 - 4136*D1*Ddd*f**2*r*s + 5566*D1*Ddd*f**2*r + 396*D1*Ddd*f**2*s**2 + 1870*D1*Ddd*f**2*s - 2167*D1*Ddd*f**2 + 528*D1*Ddd*f*g2*r**2 + 2112*D1*Ddd*f*g2*r*s - 1056*D1*Ddd*f*g2*r + 1584*D1*Ddd*f*g2*s**2 - 1848*D1*Ddd*f*g2*s + 660*D1*Ddd*f*g2 + 132*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) - fd*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 6*s + 1)) - 2*Dd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 9900*Dd**2*K*f**2*r**2 + 264*Dd**2*K*f**2*r*s - 9966*Dd**2*K*f**2*r - 9636*Dd**2*K*f**2*s**2 + 4686*Dd**2*K*f**2*s + 1694*Dd**2*K*f**2 - 7500*Dd**2*f**3*r**2 - 6000*Dd**2*f**3*r*s + 9000*Dd**2*f**3*r + 1500*Dd**2*f**3*s**2 + 2250*Dd**2*f**3*s - 2250*Dd**2*f**3 - 13596*Dd**2*f**2*r**2 - 12408*Dd**2*f**2*r*s + 16698*Dd**2*f**2*r + 1188*Dd**2*f**2*s**2 + 5610*Dd**2*f**2*s - 4334*Dd**2*f**2 + 1584*Dd**2*f*g2*r**2 + 6336*Dd**2*f*g2*r*s - 3168*Dd**2*f*g2*r + 4752*Dd**2*f*g2*s**2 - 5544*Dd**2*f*g2*s + 1320*Dd**2*f*g2))/(693*d**2*k3**6) + 4*D1**2*Pk2*Pk3*ct**4*k1**2*k2**2*(-1364*C*D1**2*bdd1*f**2*r**2 - 1584*C*D1**2*bdd1*f**2*r*s + 3344*C*D1**2*bdd1*f**2*r - 220*C*D1**2*bdd1*f**2*s**2 + 2200*C*D1**2*bdd1*f**2*s - 1100*C*D1**2*bdd1*f**2 + 11220*C*D1**2*f**2*fd*r**2 + 34560*C*D1**2*f**2*fd*r*s - 19000*C*D1**2*f**2*fd*r + 23340*C*D1**2*f**2*fd*s**2 - 27080*C*D1**2*f**2*fd*s + 11520*C*D1**2*f**2*fd - 14520*C*D1**2*f**2*fdd*r**2 - 35760*C*D1**2*f**2*fdd*r*s + 21600*C*D1**2*f**2*fdd*r - 21240*C*D1**2*f**2*fdd*s**2 + 26080*C*D1**2*f**2*fdd*s - 11920*C*D1**2*f**2*fdd - 29040*C*D1**2*f*fd**2*r**2 - 71520*C*D1**2*f*fd**2*r*s + 43200*C*D1**2*f*fd**2*r - 42480*C*D1**2*f*fd**2*s**2 + 52160*C*D1**2*f*fd**2*s - 11920*C*D1**2*f*fd**2 + 14960*C*D1*Dd*f**3*r**2 + 46080*C*D1*Dd*f**3*r*s - 26480*C*D1*Dd*f**3*r + 31120*C*D1*Dd*f**3*s**2 - 38600*C*D1*Dd*f**3*s + 15260*C*D1*Dd*f**3 - 116160*C*D1*Dd*f**2*fd*r**2 - 286080*C*D1*Dd*f**2*fd*r*s + 180240*C*D1*Dd*f**2*fd*r - 169920*C*D1*Dd*f**2*fd*s**2 + 218320*C*D1*Dd*f**2*fd*s - 69280*C*D1*Dd*f**2*fd - 19360*C*D1*Ddd*f**3*r**2 - 47680*C*D1*Ddd*f**3*r*s + 31280*C*D1*Ddd*f**3*r - 28320*C*D1*Ddd*f**3*s**2 + 38000*C*D1*Ddd*f**3*s - 16760*C*D1*Ddd*f**3 - 58080*C*Dd**2*f**3*r**2 - 143040*C*Dd**2*f**3*r*s + 93840*C*Dd**2*f**3*r - 84960*C*Dd**2*f**3*s**2 + 114000*C*Dd**2*f**3*s - 33520*C*Dd**2*f**3 - 2640*D1**2*K*bdd1*f**2*r**2 - 6864*D1**2*K*bdd1*f**2*r*s + 5280*D1**2*K*bdd1*f**2*r - 4224*D1**2*K*bdd1*f**2*s**2 + 6864*D1**2*K*bdd1*f**2*s - 2640*D1**2*K*bdd1*f**2 + 1320*D1**2*b2*f*fd*r**2 + 2640*D1**2*b2*f*fd*r*s - 1320*D1**2*b2*f*fd*r + 1320*D1**2*b2*f*fd*s**2 - 1320*D1**2*b2*f*fd*s + 660*D1**2*b2*f*fd - 1320*D1**2*b2*f*fdd*r**2 - 2640*D1**2*b2*f*fdd*r*s + 1320*D1**2*b2*f*fdd*r - 1320*D1**2*b2*f*fdd*s**2 + 1320*D1**2*b2*f*fdd*s - 660*D1**2*b2*f*fdd - 1320*D1**2*b2*fd**2*r**2 - 2640*D1**2*b2*fd**2*r*s + 1320*D1**2*b2*fd**2*r - 1320*D1**2*b2*fd**2*s**2 + 1320*D1**2*b2*fd**2*s + 22*D1**2*bd1**2*(r + s - 1)*(20*f**2*(r + s - 2) + f*(24*C*r + 24*C*s + K*(-59*r - 11*s + 83) + 107*r + 59*s - 131) - 28*g2*(r + s)) + 550*D1**2*bdd1*f**3*r**2 + 2090*D1**2*bdd1*f**3*r*s - 1870*D1**2*bdd1*f**3*r + 1540*D1**2*bdd1*f**3*s**2 - 2860*D1**2*bdd1*f**3*s + 1320*D1**2*bdd1*f**3 + 3014*D1**2*bdd1*f**2*r**2 + 5676*D1**2*bdd1*f**2*r*s - 6204*D1**2*bdd1*f**2*r + 2662*D1**2*bdd1*f**2*s**2 - 5852*D1**2*bdd1*f**2*s + 2530*D1**2*bdd1*f**2 + 1298*D1**2*bdd1*f*g2*r**2 + 1540*D1**2*bdd1*f*g2*r*s - 3652*D1**2*bdd1*f*g2*r + 242*D1**2*bdd1*f*g2*s**2 - 2596*D1**2*bdd1*f*g2*s + 1298*D1**2*bdd1*f*g2 - 660*D1**2*bdd2*f**2*r**2 - 1320*D1**2*bdd2*f**2*r*s + 1320*D1**2*bdd2*f**2*r - 660*D1**2*bdd2*f**2*s**2 + 1320*D1**2*bdd2*f**2*s - 660*D1**2*bdd2*f**2 - 6240*D1**2*f**2*fd*r**2 - 22230*D1**2*f**2*fd*r*s + 11570*D1**2*f**2*fd*r - 15990*D1**2*f**2*fd*s**2 + 18070*D1**2*f**2*fd*s - 7410*D1**2*f**2*fd + 10050*D1**2*f**2*fdd*r**2 + 25140*D1**2*f**2*fdd*r*s - 15080*D1**2*f**2*fdd*r + 15090*D1**2*f**2*fdd*s**2 - 18440*D1**2*f**2*fdd*s + 8380*D1**2*f**2*fdd - 3432*D1**2*f**2*gd2*r**2 - 12672*D1**2*f**2*gd2*r*s + 6864*D1**2*f**2*gd2*r - 9240*D1**2*f**2*gd2*s**2 + 12672*D1**2*f**2*gd2*s - 3432*D1**2*f**2*gd2 + 5280*D1**2*f**2*gdd2*r**2 + 13728*D1**2*f**2*gdd2*r*s - 10560*D1**2*f**2*gdd2*r + 8448*D1**2*f**2*gdd2*s**2 - 13728*D1**2*f**2*gdd2*s + 5280*D1**2*f**2*gdd2 + 20100*D1**2*f*fd**2*r**2 + 50280*D1**2*f*fd**2*r*s - 30160*D1**2*f*fd**2*r + 30180*D1**2*f*fd**2*s**2 - 36880*D1**2*f*fd**2*s + 8380*D1**2*f*fd**2 - 6864*D1**2*f*fd*g2*r**2 - 25344*D1**2*f*fd*g2*r*s + 12672*D1**2*f*fd*g2*r - 18480*D1**2*f*fd*g2*s**2 + 18480*D1**2*f*fd*g2*s - 9240*D1**2*f*fd*g2 + 21120*D1**2*f*fd*gd2*r**2 + 54912*D1**2*f*fd*gd2*r*s - 34848*D1**2*f*fd*gd2*r + 33792*D1**2*f*fd*gd2*s**2 - 44352*D1**2*f*fd*gd2*s + 13728*D1**2*f*fd*gd2 + 10560*D1**2*f*fdd*g2*r**2 + 27456*D1**2*f*fdd*g2*r*s - 13728*D1**2*f*fdd*g2*r + 16896*D1**2*f*fdd*g2*s**2 - 16896*D1**2*f*fdd*g2*s + 8448*D1**2*f*fdd*g2 + 10560*D1**2*fd**2*g2*r**2 + 27456*D1**2*fd**2*g2*r*s - 13728*D1**2*fd**2*g2*r + 16896*D1**2*fd**2*g2*s**2 - 16896*D1**2*fd**2*g2*s + 2640*D1*Dd*b2*f**2*r**2 + 5280*D1*Dd*b2*f**2*r*s - 3960*D1*Dd*b2*f**2*r + 2640*D1*Dd*b2*f**2*s**2 - 3960*D1*Dd*b2*f**2*s + 1980*D1*Dd*b2*f**2 - 10560*D1*Dd*b2*f*fd*r**2 - 21120*D1*Dd*b2*f*fd*r*s + 13200*D1*Dd*b2*f*fd*r - 10560*D1*Dd*b2*f*fd*s**2 + 13200*D1*Dd*b2*f*fd*s - 3960*D1*Dd*b2*f*fd - 8320*D1*Dd*f**3*r**2 - 29640*D1*Dd*f**3*r*s + 15730*D1*Dd*f**3*r - 21320*D1*Dd*f**3*s**2 + 25480*D1*Dd*f**3*s - 9490*D1*Dd*f**3 + 80400*D1*Dd*f**2*fd*r**2 + 201120*D1*Dd*f**2*fd*r*s - 125660*D1*Dd*f**2*fd*r + 120720*D1*Dd*f**2*fd*s**2 - 154220*D1*Dd*f**2*fd*s + 48600*D1*Dd*f**2*fd - 13728*D1*Dd*f**2*g2*r**2 - 50688*D1*Dd*f**2*g2*r*s + 26400*D1*Dd*f**2*g2*r - 36960*D1*Dd*f**2*g2*s**2 + 43824*D1*Dd*f**2*g2*s - 16104*D1*Dd*f**2*g2 + 42240*D1*Dd*f**2*gd2*r**2 + 109824*D1*Dd*f**2*gd2*r*s - 77088*D1*Dd*f**2*gd2*r + 67584*D1*Dd*f**2*gd2*s**2 - 99264*D1*Dd*f**2*gd2*s + 34848*D1*Dd*f**2*gd2 + 84480*D1*Dd*f*fd*g2*r**2 + 219648*D1*Dd*f*fd*g2*r*s - 124608*D1*Dd*f*fd*g2*r + 135168*D1*Dd*f*fd*g2*s**2 - 156288*D1*Dd*f*fd*g2*s + 44352*D1*Dd*f*fd*g2 - 2640*D1*Ddd*b2*f**2*r**2 - 5280*D1*Ddd*b2*f**2*r*s + 3960*D1*Ddd*b2*f**2*r - 2640*D1*Ddd*b2*f**2*s**2 + 3960*D1*Ddd*b2*f**2*s - 1980*D1*Ddd*b2*f**2 + 13400*D1*Ddd*f**3*r**2 + 33520*D1*Ddd*f**3*r*s - 21780*D1*Ddd*f**3*r + 20120*D1*Ddd*f**3*s**2 - 26820*D1*Ddd*f**3*s + 11730*D1*Ddd*f**3 + 21120*D1*Ddd*f**2*g2*r**2 + 54912*D1*Ddd*f**2*g2*r*s - 34848*D1*Ddd*f**2*g2*r + 33792*D1*Ddd*f**2*g2*s**2 - 44352*D1*Ddd*f**2*g2*s + 19008*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(5*f**3*(r*(13*s - 7) + 13*s**2 - 20*s + 6) - f**2*(2*C*(59*r**2 + r*(78*s - 98) + 19*s**2 - 58*s + 29) + 6*K*(13*r**2 + 48*r*s - 26*r + 35*s**2 - 48*s + 13) + 5*fd*(30*r**2 + r*(114*s - 73) + 84*s**2 - 118*s + 36) - 154*r**2 - 306*r*s + 252*r - 152*s**2 + 250*s - 86) + f*(2*fd*(2*C*(62*r**2 + r*(72*s - 87) + 10*s**2 - 48*s + 38) + 12*K*(20*r**2 + 52*r*s - 33*r + 32*s**2 - 42*s + 13) - 274*r**2 - 516*r*s + 407*r - 242*s**2 + 383*s - 159) + g2*(111*r**2 + 2*r*(77*s - 103) + 43*s**2 - 138*s + 69) - 2*gd2*(59*r**2 + 2*r*(35*s - 71) + 11*s**2 - 94*s + 83)) - 2*fd*g2*(59*r**2 + 35*r*(2*s - 1) + s*(11*s - 11))) - Dd*f*(5*f**2*(40*r**2 + 152*r*s - 107*r + 112*s**2 - 170*s + 60) - 2*f*(C*(248*r**2 + 16*r*(18*s - 29) + 40*s**2 - 282*s + 202) + 12*K*(40*r**2 + 104*r*s - 73*r + 64*s**2 - 94*s + 33) - 548*r**2 - 1032*r*s + 967*r - 484*s**2 + 911*s - 415) + 2*g2*(236*r**2 + 5*r*(56*s - 97) + 44*s**2 - 317*s + 225))) + 660*D1*bd2*f*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 7920*Dd**2*b2*f**2*r**2 - 15840*Dd**2*b2*f**2*r*s + 11880*Dd**2*b2*f**2*r - 7920*Dd**2*b2*f**2*s**2 + 11880*Dd**2*b2*f**2*s - 3960*Dd**2*b2*f**2 + 40200*Dd**2*f**3*r**2 + 100560*Dd**2*f**3*r*s - 65340*Dd**2*f**3*r + 60360*Dd**2*f**3*s**2 - 80460*Dd**2*f**3*s + 23460*Dd**2*f**3 + 63360*Dd**2*f**2*g2*r**2 + 164736*Dd**2*f**2*g2*r*s - 104544*Dd**2*f**2*g2*r + 101376*Dd**2*f**2*g2*s**2 - 133056*Dd**2*f**2*g2*s + 38016*Dd**2*f**2*g2 - 154*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1**2*(48*C*D1**2*fd*r**2 + 96*C*D1**2*fd*r*s - 96*C*D1**2*fd*r + 48*C*D1**2*fd*s**2 - 96*C*D1**2*fd*s + 48*C*D1**2*fd - 24*C*D1**2*fdd*r**2 - 48*C*D1**2*fdd*r*s + 48*C*D1**2*fdd*r - 24*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s - 24*C*D1**2*fdd + 192*C*D1*Dd*f*r**2 + 384*C*D1*Dd*f*r*s - 288*C*D1*Dd*f*r + 192*C*D1*Dd*f*s**2 - 288*C*D1*Dd*f*s + 144*C*D1*Dd*f - 192*C*D1*Dd*fd*r**2 - 384*C*D1*Dd*fd*r*s + 336*C*D1*Dd*fd*r - 192*C*D1*Dd*fd*s**2 + 336*C*D1*Dd*fd*s - 144*C*D1*Dd*fd - 96*C*D1*Ddd*f*r**2 - 192*C*D1*Ddd*f*r*s + 144*C*D1*Ddd*f*r - 96*C*D1*Ddd*f*s**2 + 144*C*D1*Ddd*f*s - 72*C*D1*Ddd*f - 288*C*Dd**2*f*r**2 - 576*C*Dd**2*f*r*s + 432*C*Dd**2*f*r - 288*C*Dd**2*f*s**2 + 432*C*Dd**2*f*s - 144*C*Dd**2*f - 111*D1**2*K*fd*r**2 - 154*D1**2*K*fd*r*s - 52*D1**2*K*fd*r - 43*D1**2*K*fd*s**2 - 52*D1**2*K*fd*s + 26*D1**2*K*fd + 59*D1**2*K*fdd*r**2 + 70*D1**2*K*fdd*r*s + 96*D1**2*K*fdd*r + 11*D1**2*K*fdd*s**2 + 96*D1**2*K*fdd*s - 48*D1**2*K*fdd - 14*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 80*D1**2*f*fd*r**2 + 160*D1**2*f*fd*r*s - 48*D1**2*f*fd*r + 80*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s + 24*D1**2*f*fd - 40*D1**2*f*fdd*r**2 - 80*D1**2*f*fdd*r*s - 40*D1**2*f*fdd*s**2 - 40*D1**2*fd**2*r**2 - 80*D1**2*fd**2*r*s - 40*D1**2*fd**2*s**2 + 40*D1**2*fd**2 + 151*D1**2*fd*r**2 + 234*D1**2*fd*r*s + 108*D1**2*fd*r + 83*D1**2*fd*s**2 + 108*D1**2*fd*s - 54*D1**2*fd - 107*D1**2*fdd*r**2 - 166*D1**2*fdd*r*s - 96*D1**2*fdd*r - 59*D1**2*fdd*s**2 - 96*D1**2*fdd*s + 48*D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 - 444*D1*Dd*K*f*r**2 - 616*D1*Dd*K*f*r*s + 598*D1*Dd*K*f*r - 172*D1*Dd*K*f*s**2 + 394*D1*Dd*K*f*s - 265*D1*Dd*K*f + 472*D1*Dd*K*fd*r**2 + 560*D1*Dd*K*fd*r*s + 78*D1*Dd*K*fd*r + 88*D1*Dd*K*fd*s**2 + 222*D1*Dd*K*fd*s - 288*D1*Dd*K*fd + 160*D1*Dd*f**2*r**2 + 320*D1*Dd*f**2*r*s - 240*D1*Dd*f**2*r + 160*D1*Dd*f**2*s**2 - 240*D1*Dd*f**2*s + 120*D1*Dd*f**2 - 320*D1*Dd*f*fd*r**2 - 640*D1*Dd*f*fd*r*s + 240*D1*Dd*f*fd*r - 320*D1*Dd*f*fd*s**2 + 240*D1*Dd*f*fd*s + 604*D1*Dd*f*r**2 + 936*D1*Dd*f*r*s - 838*D1*Dd*f*r + 332*D1*Dd*f*s**2 - 634*D1*Dd*f*s + 385*D1*Dd*f - 856*D1*Dd*fd*r**2 - 1328*D1*Dd*fd*r*s + 210*D1*Dd*fd*r - 472*D1*Dd*fd*s**2 + 66*D1*Dd*fd*s + 288*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 + 236*D1*Ddd*K*f*r**2 + 280*D1*Ddd*K*f*r*s - 306*D1*Ddd*K*f*r + 44*D1*Ddd*K*f*s**2 - 162*D1*Ddd*K*f*s + 129*D1*Ddd*K*f - 80*D1*Ddd*f**2*r**2 - 160*D1*Ddd*f**2*r*s + 120*D1*Ddd*f**2*r - 80*D1*Ddd*f**2*s**2 + 120*D1*Ddd*f**2*s - 60*D1*Ddd*f**2 - 428*D1*Ddd*f*r**2 - 664*D1*Ddd*f*r*s + 594*D1*Ddd*f*r - 236*D1*Ddd*f*s**2 + 450*D1*Ddd*f*s - 273*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 708*Dd**2*K*f*r**2 + 840*Dd**2*K*f*r*s - 918*Dd**2*K*f*r + 132*Dd**2*K*f*s**2 - 486*Dd**2*K*f*s + 258*Dd**2*K*f - 240*Dd**2*f**2*r**2 - 480*Dd**2*f**2*r*s + 360*Dd**2*f**2*r - 240*Dd**2*f**2*s**2 + 360*Dd**2*f**2*s - 120*Dd**2*f**2 - 1284*Dd**2*f*r**2 - 1992*Dd**2*f*r*s + 1782*Dd**2*f*r - 708*Dd**2*f*s**2 + 1350*Dd**2*f*s - 546*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) + 22*b1*(236*C*D1**2*f*fd*r**2 + 312*C*D1**2*f*fd*r*s - 196*C*D1**2*f*fd*r + 76*C*D1**2*f*fd*s**2 - 116*C*D1**2*f*fd*s + 98*C*D1**2*f*fd - 124*C*D1**2*f*fdd*r**2 - 144*C*D1**2*f*fdd*r*s + 44*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s - 22*C*D1**2*f*fdd - 124*C*D1**2*fd**2*r**2 - 144*C*D1**2*fd**2*r*s + 44*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s + 80*C*D1**2*fd**2 + 472*C*D1*Dd*f**2*r**2 + 624*C*D1*Dd*f**2*r*s - 628*C*D1*Dd*f**2*r + 152*C*D1*Dd*f**2*s**2 - 388*C*D1*Dd*f**2*s + 274*C*D1*Dd*f**2 - 992*C*D1*Dd*f*fd*r**2 - 1152*C*D1*Dd*f*fd*r*s + 816*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 296*C*D1*Dd*f*fd*s - 80*C*D1*Dd*f*fd - 248*C*D1*Ddd*f**2*r**2 - 288*C*D1*Ddd*f**2*r*s + 320*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 164*C*D1*Ddd*f**2*s - 134*C*D1*Ddd*f**2 - 744*C*Dd**2*f**2*r**2 - 864*C*Dd**2*f**2*r*s + 960*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 492*C*Dd**2*f**2*s - 268*C*Dd**2*f**2 + 156*D1**2*K*f*fd*r**2 + 576*D1**2*K*f*fd*r*s - 288*D1**2*K*f*fd*r + 420*D1**2*K*f*fd*s**2 - 420*D1**2*K*f*fd*s + 210*D1**2*K*f*fd - 240*D1**2*K*f*fdd*r**2 - 624*D1**2*K*f*fdd*r*s + 312*D1**2*K*f*fdd*r - 384*D1**2*K*f*fdd*s**2 + 384*D1**2*K*f*fdd*s - 192*D1**2*K*f*fdd - 240*D1**2*K*fd**2*r**2 - 624*D1**2*K*fd**2*r*s + 312*D1**2*K*fd**2*r - 384*D1**2*K*fd**2*s**2 + 384*D1**2*K*fd**2*s + 14*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1**2*bdd1*(10*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + f*(12*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - K*(59*r**2 + 70*r*s - 142*r + 11*s**2 - 94*s + 59) + 107*r**2 + 166*r*s - 238*r + 59*s**2 - 190*s + 107) - 14*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 195*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r - 195*D1**2*f**2*fd*s**2 + 160*D1**2*f**2*fd*s - 35*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 285*D1**2*f**2*fdd*r*s - 110*D1**2*f**2*fdd*r + 210*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 60*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 570*D1**2*f*fd**2*r*s - 220*D1**2*f*fd**2*r + 420*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 60*D1**2*f*fd**2 - 308*D1**2*f*fd*r**2 - 612*D1**2*f*fd*r*s + 362*D1**2*f*fd*r - 304*D1**2*f*fd*s**2 + 360*D1**2*f*fd*s - 220*D1**2*f*fd + 274*D1**2*f*fdd*r**2 + 516*D1**2*f*fdd*r*s - 250*D1**2*f*fdd*r + 242*D1**2*f*fdd*s**2 - 234*D1**2*f*fdd*s + 143*D1**2*f*fdd - 111*D1**2*f*gd2*r**2 - 154*D1**2*f*gd2*r*s + 222*D1**2*f*gd2*r - 43*D1**2*f*gd2*s**2 + 154*D1**2*f*gd2*s - 111*D1**2*f*gd2 + 59*D1**2*f*gdd2*r**2 + 70*D1**2*f*gdd2*r*s - 118*D1**2*f*gdd2*r + 11*D1**2*f*gdd2*s**2 - 70*D1**2*f*gdd2*s + 59*D1**2*f*gdd2 + 274*D1**2*fd**2*r**2 + 516*D1**2*fd**2*r*s - 250*D1**2*fd**2*r + 242*D1**2*fd**2*s**2 - 234*D1**2*fd**2*s - 60*D1**2*fd**2 - 111*D1**2*fd*g2*r**2 - 154*D1**2*fd*g2*r*s - 52*D1**2*fd*g2*r - 43*D1**2*fd*g2*s**2 - 52*D1**2*fd*g2*s + 26*D1**2*fd*g2 + 118*D1**2*fd*gd2*r**2 + 140*D1**2*fd*gd2*r*s - 22*D1**2*fd*gd2*r + 22*D1**2*fd*gd2*s**2 + 26*D1**2*fd*gd2*s - 96*D1**2*fd*gd2 + 59*D1**2*fdd*g2*r**2 + 70*D1**2*fdd*g2*r*s + 96*D1**2*fdd*g2*r + 11*D1**2*fdd*g2*s**2 + 96*D1**2*fdd*g2*s - 48*D1**2*fdd*g2 + 312*D1*Dd*K*f**2*r**2 + 1152*D1*Dd*K*f**2*r*s - 600*D1*Dd*K*f**2*r + 840*D1*Dd*K*f**2*s**2 - 996*D1*Dd*K*f**2*s + 366*D1*Dd*K*f**2 - 1920*D1*Dd*K*f*fd*r**2 - 4992*D1*Dd*K*f*fd*r*s + 2832*D1*Dd*K*f*fd*r - 3072*D1*Dd*K*f*fd*s**2 + 3552*D1*Dd*K*f*fd*s - 1008*D1*Dd*K*f*fd - 260*D1*Dd*f**3*r*s + 65*D1*Dd*f**3*r - 260*D1*Dd*f**3*s**2 + 260*D1*Dd*f**3*s - 65*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 2280*D1*Dd*f**2*fd*r*s - 1025*D1*Dd*f**2*fd*r + 1680*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd - 616*D1*Dd*f**2*r**2 - 1224*D1*Dd*f**2*r*s + 922*D1*Dd*f**2*r - 608*D1*Dd*f**2*s**2 + 916*D1*Dd*f**2*s - 460*D1*Dd*f**2 + 2192*D1*Dd*f*fd*r**2 + 4128*D1*Dd*f*fd*r*s - 2612*D1*Dd*f*fd*r + 1936*D1*Dd*f*fd*s**2 - 2452*D1*Dd*f*fd*s + 734*D1*Dd*f*fd - 444*D1*Dd*f*g2*r**2 - 616*D1*Dd*f*g2*r*s + 598*D1*Dd*f*g2*r - 172*D1*Dd*f*g2*s**2 + 394*D1*Dd*f*g2*s - 265*D1*Dd*f*g2 + 472*D1*Dd*f*gd2*r**2 + 560*D1*Dd*f*gd2*r*s - 778*D1*Dd*f*gd2*r + 88*D1*Dd*f*gd2*s**2 - 442*D1*Dd*f*gd2*s + 306*D1*Dd*f*gd2 + 472*D1*Dd*fd*g2*r**2 + 560*D1*Dd*fd*g2*r*s + 78*D1*Dd*fd*g2*r + 88*D1*Dd*fd*g2*s**2 + 222*D1*Dd*fd*g2*s - 288*D1*Dd*fd*g2 - 480*D1*Ddd*K*f**2*r**2 - 1248*D1*Ddd*K*f**2*r*s + 792*D1*Ddd*K*f**2*r - 768*D1*Ddd*K*f**2*s**2 + 1008*D1*Ddd*K*f**2*s - 432*D1*Ddd*K*f**2 + 100*D1*Ddd*f**3*r**2 + 380*D1*Ddd*f**3*r*s - 195*D1*Ddd*f**3*r + 280*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 120*D1*Ddd*f**3 + 548*D1*Ddd*f**2*r**2 + 1032*D1*Ddd*f**2*r*s - 806*D1*Ddd*f**2*r + 484*D1*Ddd*f**2*s**2 - 758*D1*Ddd*f**2*s + 395*D1*Ddd*f**2 + 236*D1*Ddd*f*g2*r**2 + 280*D1*Ddd*f*g2*r*s - 306*D1*Ddd*f*g2*r + 44*D1*Ddd*f*g2*s**2 - 162*D1*Ddd*f*g2*s + 129*D1*Ddd*f*g2 + D1*bd1*(-D1*(8*f**2*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) + f*(24*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 111*K*r**2 - 154*K*r*s + 214*K*r - 43*K*s**2 + 146*K*s - 90*K - 40*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 151*r**2 + 234*r*s - 322*r + 83*s**2 - 254*s + 144) - 2*fd*(12*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - K*(59*r**2 + 70*r*s - 23*r + 11*s**2 + s - 24) + 107*r**2 + 166*r*s - 71*r + 59*s**2 - 47*s - 24) - 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(10*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + f*(12*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(236*r**2 + 280*r*s - 437*r + 44*s**2 - 269*s + 189) + 428*r**2 + 664*r*s - 773*r + 236*s**2 - 605*s + 333) - 14*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 1440*Dd**2*K*f**2*r**2 - 3744*Dd**2*K*f**2*r*s + 2376*Dd**2*K*f**2*r - 2304*Dd**2*K*f**2*s**2 + 3024*Dd**2*K*f**2*s - 864*Dd**2*K*f**2 + 300*Dd**2*f**3*r**2 + 1140*Dd**2*f**3*r*s - 585*Dd**2*f**3*r + 840*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 240*Dd**2*f**3 + 1644*Dd**2*f**2*r**2 + 3096*Dd**2*f**2*r*s - 2418*Dd**2*f**2*r + 1452*Dd**2*f**2*s**2 - 2274*Dd**2*f**2*s + 790*Dd**2*f**2 + 708*Dd**2*f*g2*r**2 + 840*Dd**2*f*g2*r*s - 918*Dd**2*f*g2*r + 132*Dd**2*f*g2*s**2 - 486*Dd**2*f*g2*s + 258*Dd**2*f*g2))/(231*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**4*k1**2*st**2*(D1**2*(792*bd1*fd*g2*s*(s - 1) + f**3*s**2*(2250*bd1 - 1125*bdd1) - 2*f**2*(125*fd*(s**2*(27*bd1 - 12) + s*(8 - 9*bd1) - 4) + 250*fdd*(3*s**2 - 2*s + 1) + s**2*(3*C + 2)*(-132*bd1 + 66*bdd1)) - 4*f*s*(99*bd1**2*s*(K - 1) + 66*bd1*(fd*(3*C + 2)*(2*s - 1) + s*(3*g2 - 3*gd2)) - 99*bdd1*g2*s + 250*fd**2*(3*s - 2))) - 2*D1*f*(Dd*(396*bd1*g2*s*(1 - 4*s) + 125*f**2*(s**2*(36*bd1 - 16) + s*(8 - 9*bd1) - 4) + 4*f*(4*s - 1)*(33*bd1*s*(3*C + 2) + 125*fd*(3*s - 1))) + 250*Ddd*f**2*(4*s**2 - 2*s + 1)) + 3000*Dd**2*f**3*s*(1 - 2*s) + 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(D1**2*(375*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) - 2*f*(375*fd**2*s*(3*s - 2) - fd*(132*C + 88)*(2*s**2 - 2*s + 1) + fdd*(66*C + 44)*(2*s**2 - 2*s + 1) + s**2*(66*K*bdd1 - 132*bd1*(K - 1) - 66*bdd1 + 132*gd2 - 66*gdd2)) + (44 - 44*s)*(fd**2*s*(6*C + 4) + 6*fd*g2*(s - 1) - 6*fd*s*(-K*bd1 + bd1 + gd2) - 3*fdd*g2*(s - 1))) + D1*(2*Dd*(375*f**3*(4*s**2 - 2*s + 1) + f**2*(132*C*(4*s**2 - 2*s + 1) - 375*fd*(12*s**2 - 7*s + 1) + 352*s**2 - 176*s + 88) - 44*f*(fd*(3*C + 2)*(8*s**2 - 6*s + 1) + 3*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(3*K*bd1 - 3*bd1 - 3*gd2)) + 132*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(375*f**2 + f*(132*C + 88) - 132*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(375*f**2 + f*(132*C + 88) - 132*g2)))/(231*d**2*k2**2*k3**2) - 4*D1**2*Pk2*Pk3*ct**4*k1**2*(3300*C*D1**2*bdd1*f**2*s**2 - 3360*C*D1**2*f**2*fd*s**2 + 2240*C*D1**2*f**2*fd*s - 1120*C*D1**2*f**2*fd + 1680*C*D1**2*f**2*fdd*s**2 - 1120*C*D1**2*f**2*fdd*s + 560*C*D1**2*f**2*fdd + 3360*C*D1**2*f*fd**2*s**2 - 2240*C*D1**2*f*fd**2*s - 4480*C*D1*Dd*f**3*s**2 + 2240*C*D1*Dd*f**3*s - 1120*C*D1*Dd*f**3 + 13440*C*D1*Dd*f**2*fd*s**2 - 7840*C*D1*Dd*f**2*fd*s + 1120*C*D1*Dd*f**2*fd + 2240*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 560*C*D1*Ddd*f**3 + 6720*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 330*D1**2*K*bdd1*f**2*s**2 - 1320*D1**2*b2*f*fd*s**2 + 1320*D1**2*b2*f*fd*s - 660*D1**2*b2*f*fd + 660*D1**2*b2*f*fdd*s**2 - 660*D1**2*b2*f*fdd*s + 330*D1**2*b2*f*fdd + 660*D1**2*b2*fd**2*s**2 - 660*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*s*(24*C*f*(s - 1) + 10*f**2*(2*s - 3) - 59*f*s*(K - 1) - 28*g2*(s - 1)) - 660*D1**2*bd2*f**2*s**2 + 1320*D1**2*bd2*f*fd*s**2 - 660*D1**2*bd2*f*fd*s + 1980*D1**2*bdd1*f**3*r*s + 4455*D1**2*bdd1*f**3*s**2 - 990*D1**2*bdd1*f**3*s + 1122*D1**2*bdd1*f**2*r*s - 528*D1**2*bdd1*f**2*s**2 + 198*D1**2*bdd1*f**2*s - 660*D1**2*bdd1*f**2 - 3894*D1**2*bdd1*f*g2*s**2 + 330*D1**2*bdd2*f**2*s**2 - 4260*D1**2*f**2*fd*r*s + 1420*D1**2*f**2*fd*r - 10590*D1**2*f**2*fd*s**2 + 8480*D1**2*f**2*fd*s - 3530*D1**2*f**2*fd + 3120*D1**2*f**2*fdd*r*s - 1040*D1**2*f**2*fdd*r + 7770*D1**2*f**2*fdd*s**2 - 6220*D1**2*f**2*fdd*s + 2590*D1**2*f**2*fdd + 1320*D1**2*f**2*gd2*s**2 - 660*D1**2*f**2*gdd2*s**2 + 6240*D1**2*f*fd**2*r*s - 2080*D1**2*f*fd**2*r + 15540*D1**2*f*fd**2*s**2 - 12440*D1**2*f*fd**2*s + 1040*D1**2*f*fd**2 + 2640*D1**2*f*fd*g2*s**2 - 2640*D1**2*f*fd*g2*s + 1320*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 1320*D1**2*f*fdd*g2*s**2 + 1320*D1**2*f*fdd*g2*s - 660*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*s**2 + 1320*D1**2*fd**2*g2*s - 2640*D1*Dd*b2*f**2*s**2 + 1320*D1*Dd*b2*f**2*s - 660*D1*Dd*b2*f**2 + 5280*D1*Dd*b2*f*fd*s**2 - 3960*D1*Dd*b2*f*fd*s + 660*D1*Dd*b2*f*fd + 2640*D1*Dd*bd2*f**2*s**2 - 660*D1*Dd*bd2*f**2*s - 5680*D1*Dd*f**3*r*s + 1420*D1*Dd*f**3*r - 14120*D1*Dd*f**3*s**2 + 9900*D1*Dd*f**3*s - 3530*D1*Dd*f**3 + 24960*D1*Dd*f**2*fd*r*s - 7280*D1*Dd*f**2*fd*r + 62160*D1*Dd*f**2*fd*s**2 - 46660*D1*Dd*f**2*fd*s + 8300*D1*Dd*f**2*fd + 5280*D1*Dd*f**2*g2*s**2 - 2640*D1*Dd*f**2*g2*s + 1320*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*s**2 + 1320*D1*Dd*f**2*gd2*s - 10560*D1*Dd*f*fd*g2*s**2 + 7920*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 + 1320*D1*Ddd*b2*f**2*s**2 - 660*D1*Ddd*b2*f**2*s + 330*D1*Ddd*b2*f**2 + 4160*D1*Ddd*f**3*r*s - 1040*D1*Ddd*f**3*r + 10360*D1*Ddd*f**3*s**2 - 7260*D1*Ddd*f**3*s + 2590*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 660*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(15*f**3*s*(4*r + 13*s - 2) + f**2*(-30*fd*(2*r*(6*s - 1) + 27*s**2 - 15*s + 1) + 4*s**2*(35*C + 5*K - 8) + 4*s*(11*r + 9) - 40) - 2*f*(fd*(17*r*(4*s - 1) + s**2*(200*C + 20*K - 32) - s*(100*C + 10*K - 2) + 17) + s**2*(83*g2 - 118*gd2)) + 236*fd*g2*s*(s - 1)) + 2*Dd*f*(-15*f**2*(2*r*(8*s - 1) + 36*s**2 - 17*s + 1) + f*(-17*r*(8*s - 1) - s**2*(400*C + 40*K - 64) + s*(100*C + 10*K + 6) + 3) + 118*g2*s*(4*s - 1))) + 3960*Dd**2*b2*f**2*s**2 - 1980*Dd**2*b2*f**2*s + 12480*Dd**2*f**3*r*s - 3120*Dd**2*f**3*r + 31080*Dd**2*f**3*s**2 - 21780*Dd**2*f**3*s + 2080*Dd**2*f**3 - 7920*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s + 462*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 33*b1**2*(48*C*D1**2*fd*s**2 - 24*C*D1**2*fdd*s**2 + 192*C*D1*Dd*f*s**2 - 96*C*D1*Dd*f*s + 48*C*D1*Dd*f - 192*C*D1*Dd*fd*s**2 + 48*C*D1*Dd*fd*s - 96*C*D1*Ddd*f*s**2 + 48*C*D1*Ddd*f*s - 24*C*D1*Ddd*f - 288*C*Dd**2*f*s**2 + 144*C*Dd**2*f*s - 83*D1**2*K*fd*s**2 + 166*D1**2*K*fd*s - 83*D1**2*K*fd + 59*D1**2*K*fdd*s**2 - 118*D1**2*K*fdd*s + 59*D1**2*K*fdd - 14*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) + 80*D1**2*f*fd*s**2 + 40*D1**2*f*fd*s - 20*D1**2*f*fd - 40*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 10*D1**2*f*fdd - 40*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s + 83*D1**2*fd*s**2 - 166*D1**2*fd*s + 83*D1**2*fd - 59*D1**2*fdd*s**2 + 118*D1**2*fdd*s - 59*D1**2*fdd - 56*D1**2*gd2*s**2 + 28*D1**2*gdd2*s**2 - 332*D1*Dd*K*f*s**2 + 166*D1*Dd*K*f*s - 83*D1*Dd*K*f + 472*D1*Dd*K*fd*s**2 - 590*D1*Dd*K*fd*s + 118*D1*Dd*K*fd + 160*D1*Dd*f**2*s**2 - 80*D1*Dd*f**2*s + 40*D1*Dd*f**2 - 320*D1*Dd*f*fd*s**2 + 20*D1*Dd*f*fd + 332*D1*Dd*f*s**2 - 166*D1*Dd*f*s + 83*D1*Dd*f - 472*D1*Dd*fd*s**2 + 590*D1*Dd*fd*s - 118*D1*Dd*fd - 224*D1*Dd*g2*s**2 + 112*D1*Dd*g2*s - 56*D1*Dd*g2 + 224*D1*Dd*gd2*s**2 - 56*D1*Dd*gd2*s + 236*D1*Ddd*K*f*s**2 - 118*D1*Ddd*K*f*s + 59*D1*Ddd*K*f - 80*D1*Ddd*f**2*s**2 + 40*D1*Ddd*f**2*s - 20*D1*Ddd*f**2 - 236*D1*Ddd*f*s**2 + 118*D1*Ddd*f*s - 59*D1*Ddd*f + 112*D1*Ddd*g2*s**2 - 56*D1*Ddd*g2*s + 28*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) + 708*Dd**2*K*f*s**2 - 354*Dd**2*K*f*s - 240*Dd**2*f**2*s**2 + 120*Dd**2*f**2*s - 708*Dd**2*f*s**2 + 354*Dd**2*f*s + 336*Dd**2*g2*s**2 - 168*Dd**2*g2*s) - 33*b1*(48*C*D1**2*bdd1*f*s**2 - 48*C*D1**2*bdd1*f*s + 24*C*D1**2*bdd1*f + 280*C*D1**2*f*fd*s**2 - 280*C*D1**2*f*fd*s + 140*C*D1**2*f*fd - 200*C*D1**2*f*fdd*s**2 + 200*C*D1**2*f*fdd*s - 100*C*D1**2*f*fdd - 200*C*D1**2*fd**2*s**2 + 200*C*D1**2*fd**2*s + 560*C*D1*Dd*f**2*s**2 - 280*C*D1*Dd*f**2*s + 140*C*D1*Dd*f**2 - 1600*C*D1*Dd*f*fd*s**2 + 1200*C*D1*Dd*f*fd*s - 200*C*D1*Dd*f*fd - 400*C*D1*Ddd*f**2*s**2 + 200*C*D1*Ddd*f**2*s - 100*C*D1*Ddd*f**2 - 1200*C*Dd**2*f**2*s**2 + 600*C*Dd**2*f**2*s - 118*D1**2*K*bdd1*f*s**2 + 40*D1**2*K*f*fd*s**2 - 40*D1**2*K*f*fd*s + 20*D1**2*K*f*fd - 20*D1**2*K*f*fdd*s**2 + 20*D1**2*K*f*fdd*s - 10*D1**2*K*f*fdd - 20*D1**2*K*fd**2*s**2 + 20*D1**2*K*fd**2*s + 28*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + 40*D1**2*bdd1*f**2*s**2 - 60*D1**2*bdd1*f**2*s + 30*D1**2*bdd1*f**2 + 118*D1**2*bdd1*f*s**2 - 56*D1**2*bdd1*g2*s**2 + 56*D1**2*bdd1*g2*s - 28*D1**2*bdd1*g2 + 180*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 585*D1**2*f**2*fd*s**2 - 480*D1**2*f**2*fd*s + 195*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 405*D1**2*f**2*fdd*s**2 + 360*D1**2*f**2*fdd*s - 135*D1**2*f**2*fdd - 360*D1**2*f*fd**2*r*s + 120*D1**2*f*fd**2*r - 810*D1**2*f*fd**2*s**2 + 720*D1**2*f*fd**2*s - 90*D1**2*f*fd**2 + 88*D1**2*f*fd*r*s - 44*D1**2*f*fd*r - 64*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 8*D1**2*f*fd - 68*D1**2*f*fdd*r*s + 34*D1**2*f*fdd*r + 32*D1**2*f*fdd*s**2 + 8*D1**2*f*fdd*s - 4*D1**2*f*fdd - 166*D1**2*f*gd2*s**2 + 118*D1**2*f*gdd2*s**2 - 68*D1**2*fd**2*r*s + 34*D1**2*fd**2*r + 32*D1**2*fd**2*s**2 + 8*D1**2*fd**2*s - 166*D1**2*fd*g2*s**2 + 332*D1**2*fd*g2*s - 166*D1**2*fd*g2 + 236*D1**2*fd*gd2*s**2 - 236*D1**2*fd*gd2*s + 118*D1**2*fdd*g2*s**2 - 236*D1**2*fdd*g2*s + 118*D1**2*fdd*g2 + 80*D1*Dd*K*f**2*s**2 - 40*D1*Dd*K*f**2*s + 20*D1*Dd*K*f**2 - 160*D1*Dd*K*f*fd*s**2 + 120*D1*Dd*K*f*fd*s - 20*D1*Dd*K*f*fd + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 780*D1*Dd*f**3*s**2 - 510*D1*Dd*f**3*s + 195*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r*s + 420*D1*Dd*f**2*fd*r - 3240*D1*Dd*f**2*fd*s**2 + 2610*D1*Dd*f**2*fd*s - 480*D1*Dd*f**2*fd + 176*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r - 128*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s - 32*D1*Dd*f**2 - 544*D1*Dd*f*fd*r*s + 204*D1*Dd*f*fd*r + 256*D1*Dd*f*fd*s**2 + 104*D1*Dd*f*fd*s - 76*D1*Dd*f*fd - 664*D1*Dd*f*g2*s**2 + 332*D1*Dd*f*g2*s - 166*D1*Dd*f*g2 + 944*D1*Dd*f*gd2*s**2 - 236*D1*Dd*f*gd2*s + 944*D1*Dd*fd*g2*s**2 - 1180*D1*Dd*fd*g2*s + 236*D1*Dd*fd*g2 - 40*D1*Ddd*K*f**2*s**2 + 20*D1*Ddd*K*f**2*s - 10*D1*Ddd*K*f**2 - 240*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 540*D1*Ddd*f**3*s**2 + 390*D1*Ddd*f**3*s - 135*D1*Ddd*f**3 - 136*D1*Ddd*f**2*r*s + 34*D1*Ddd*f**2*r + 64*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s + 16*D1*Ddd*f**2 + 472*D1*Ddd*f*g2*s**2 - 236*D1*Ddd*f*g2*s + 118*D1*Ddd*f*g2 - 2*D1*bd1*(24*C*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + D1*(10*f**2*(4*s**2 - 6*s + 3) + f*s*(fd*(40 - 80*s) - s*(83*K - 83)) + 118*fd*s*(K - 1)*(s - 1) - 28*g2*(2*s**2 - 2*s + 1) + 28*gd2*s*(2*s - 1)) - 2*Dd*(4*s - 1)*(5*f**2*(4*s - 3) - 59*f*s*(K - 1) + 14*g2*(1 - 2*s))) - 120*Dd**2*K*f**2*s**2 + 60*Dd**2*K*f**2*s - 720*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 1620*Dd**2*f**3*s**2 + 1170*Dd**2*f**3*s - 120*Dd**2*f**3 - 408*Dd**2*f**2*r*s + 102*Dd**2*f**2*r + 192*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 68*Dd**2*f**2 + 1416*Dd**2*f*g2*s**2 - 708*Dd**2*f*g2*s))/(693*d**2*k2**2*k3**2) - 20*D1**2*Pk2*Pk3*ct**4*k2**6*st**2*(D1**2*(f**2*(fd*(100*C - 50)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(50*C - 25)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(100*C - 50)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 66*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(50*C - 25)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(33*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(25 - 50*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 33*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(50*C*f + 33*K*b1 - 25*f - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(50*C*f + 33*K*b1 - 25*f - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**8) - 8*D1**2*Pk2*Pk3*ct**4*k2**6*(40*C*D1**2*b1*f*fd*r**2 + 80*C*D1**2*b1*f*fd*r*s - 40*C*D1**2*b1*f*fd*r + 40*C*D1**2*b1*f*fd*s**2 - 40*C*D1**2*b1*f*fd*s + 20*C*D1**2*b1*f*fd - 20*C*D1**2*b1*f*fdd*r**2 - 40*C*D1**2*b1*f*fdd*r*s + 20*C*D1**2*b1*f*fdd*r - 20*C*D1**2*b1*f*fdd*s**2 + 20*C*D1**2*b1*f*fdd*s - 10*C*D1**2*b1*f*fdd - 20*C*D1**2*b1*fd**2*r**2 - 40*C*D1**2*b1*fd**2*r*s + 20*C*D1**2*b1*fd**2*r - 20*C*D1**2*b1*fd**2*s**2 + 20*C*D1**2*b1*fd**2*s - 30*C*D1**2*f**2*fd*r**2 - 60*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 80*C*D1*Dd*b1*f**2*r**2 + 160*C*D1*Dd*b1*f**2*r*s - 120*C*D1*Dd*b1*f**2*r + 80*C*D1*Dd*b1*f**2*s**2 - 120*C*D1*Dd*b1*f**2*s + 60*C*D1*Dd*b1*f**2 - 160*C*D1*Dd*b1*f*fd*r**2 - 320*C*D1*Dd*b1*f*fd*r*s + 200*C*D1*Dd*b1*f*fd*r - 160*C*D1*Dd*b1*f*fd*s**2 + 200*C*D1*Dd*b1*f*fd*s - 60*C*D1*Dd*b1*f*fd - 40*C*D1*Dd*f**3*r**2 - 80*C*D1*Dd*f**3*r*s + 60*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 60*C*D1*Dd*f**3*s - 30*C*D1*Dd*f**3 - 40*C*D1*Ddd*b1*f**2*r**2 - 80*C*D1*Ddd*b1*f**2*r*s + 60*C*D1*Ddd*b1*f**2*r - 40*C*D1*Ddd*b1*f**2*s**2 + 60*C*D1*Ddd*b1*f**2*s - 30*C*D1*Ddd*b1*f**2 - 120*C*Dd**2*b1*f**2*r**2 - 240*C*Dd**2*b1*f**2*r*s + 180*C*Dd**2*b1*f**2*r - 120*C*Dd**2*b1*f**2*s**2 + 180*C*Dd**2*b1*f**2*s - 60*C*Dd**2*b1*f**2 + 12*D1**2*K*b1**2*fd*r**2 + 24*D1**2*K*b1**2*fd*r*s + 12*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r**2 - 12*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 - 12*D1**2*K*b1*f*fd*r**2 - 24*D1**2*K*b1*f*fd*r*s + 12*D1**2*K*b1*f*fd*r - 12*D1**2*K*b1*f*fd*s**2 + 12*D1**2*K*b1*f*fd*s - 6*D1**2*K*b1*f*fd - 12*D1**2*K*bd1**2*f*(r + s - 1)**2 - 20*D1**2*b1*f*fd*r**2 - 40*D1**2*b1*f*fd*r*s + 20*D1**2*b1*f*fd*r - 20*D1**2*b1*f*fd*s**2 + 20*D1**2*b1*f*fd*s - 10*D1**2*b1*f*fd + 10*D1**2*b1*f*fdd*r**2 + 20*D1**2*b1*f*fdd*r*s - 10*D1**2*b1*f*fdd*r + 10*D1**2*b1*f*fdd*s**2 - 10*D1**2*b1*f*fdd*s + 5*D1**2*b1*f*fdd - 24*D1**2*b1*f*gd2*r**2 - 48*D1**2*b1*f*gd2*r*s + 48*D1**2*b1*f*gd2*r - 24*D1**2*b1*f*gd2*s**2 + 48*D1**2*b1*f*gd2*s - 24*D1**2*b1*f*gd2 + 12*D1**2*b1*f*gdd2*r**2 + 24*D1**2*b1*f*gdd2*r*s - 24*D1**2*b1*f*gdd2*r + 12*D1**2*b1*f*gdd2*s**2 - 24*D1**2*b1*f*gdd2*s + 12*D1**2*b1*f*gdd2 + 10*D1**2*b1*fd**2*r**2 + 20*D1**2*b1*fd**2*r*s - 10*D1**2*b1*fd**2*r + 10*D1**2*b1*fd**2*s**2 - 10*D1**2*b1*fd**2*s - 24*D1**2*b1*fd*g2*r**2 - 48*D1**2*b1*fd*g2*r*s - 24*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r**2 + 48*D1**2*b1*fd*gd2*r*s - 24*D1**2*b1*fd*gd2*r + 24*D1**2*b1*fd*gd2*s**2 - 24*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r**2 + 24*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 12*K*b1 - 5*f - 12*g2) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 12*D1**2*f**2*gd2*r**2 + 24*D1**2*f**2*gd2*r*s - 24*D1**2*f**2*gd2*r + 12*D1**2*f**2*gd2*s**2 - 24*D1**2*f**2*gd2*s + 12*D1**2*f**2*gd2 + 24*D1**2*f*fd*g2*r**2 + 48*D1**2*f*fd*g2*r*s - 24*D1**2*f*fd*g2*r + 24*D1**2*f*fd*g2*s**2 - 24*D1**2*f*fd*g2*s + 12*D1**2*f*fd*g2 + 48*D1*Dd*K*b1**2*f*r**2 + 96*D1*Dd*K*b1**2*f*r*s - 72*D1*Dd*K*b1**2*f*r + 48*D1*Dd*K*b1**2*f*s**2 - 72*D1*Dd*K*b1**2*f*s + 36*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 96*D1*Dd*K*b1**2*fd*r*s + 36*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 36*D1*Dd*K*b1**2*fd*s - 24*D1*Dd*K*b1*f**2*r**2 - 48*D1*Dd*K*b1*f**2*r*s + 36*D1*Dd*K*b1*f**2*r - 24*D1*Dd*K*b1*f**2*s**2 + 36*D1*Dd*K*b1*f**2*s - 18*D1*Dd*K*b1*f**2 - 40*D1*Dd*b1*f**2*r**2 - 80*D1*Dd*b1*f**2*r*s + 60*D1*Dd*b1*f**2*r - 40*D1*Dd*b1*f**2*s**2 + 60*D1*Dd*b1*f**2*s - 30*D1*Dd*b1*f**2 + 80*D1*Dd*b1*f*fd*r**2 + 160*D1*Dd*b1*f*fd*r*s - 100*D1*Dd*b1*f*fd*r + 80*D1*Dd*b1*f*fd*s**2 - 100*D1*Dd*b1*f*fd*s + 30*D1*Dd*b1*f*fd - 96*D1*Dd*b1*f*g2*r**2 - 192*D1*Dd*b1*f*g2*r*s + 144*D1*Dd*b1*f*g2*r - 96*D1*Dd*b1*f*g2*s**2 + 144*D1*Dd*b1*f*g2*s - 72*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 192*D1*Dd*b1*f*gd2*r*s - 168*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 168*D1*Dd*b1*f*gd2*s + 72*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 192*D1*Dd*b1*fd*g2*r*s - 72*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 72*D1*Dd*b1*fd*g2*s + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 48*D1*Dd*f**2*g2*r**2 + 96*D1*Dd*f**2*g2*r*s - 72*D1*Dd*f**2*g2*r + 48*D1*Dd*f**2*g2*s**2 - 72*D1*Dd*f**2*g2*s + 36*D1*Dd*f**2*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 48*D1*Ddd*K*b1**2*f*r*s + 36*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 36*D1*Ddd*K*b1**2*f*s - 18*D1*Ddd*K*b1**2*f + 20*D1*Ddd*b1*f**2*r**2 + 40*D1*Ddd*b1*f**2*r*s - 30*D1*Ddd*b1*f**2*r + 20*D1*Ddd*b1*f**2*s**2 - 30*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 96*D1*Ddd*b1*f*g2*r*s - 72*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 72*D1*Ddd*b1*f*g2*s + 36*D1*Ddd*b1*f*g2 + 2*D1*bd1*(D1*(f**2*(10*C - 3*K - 5)*(r + s - 1) - f*fd*(10*C - 5)*(2*r + 2*s - 1) - 12*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 12*fd*(r + s)*(-K*b1 + g2)) - Dd*f*(4*r + 4*s - 3)*(10*C*f + 12*K*b1 - 5*f - 12*g2))*(r + s - 1) - 72*Dd**2*K*b1**2*f*r**2 - 144*Dd**2*K*b1**2*f*r*s + 108*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 108*Dd**2*K*b1**2*f*s - 36*Dd**2*K*b1**2*f + 60*Dd**2*b1*f**2*r**2 + 120*Dd**2*b1*f**2*r*s - 90*Dd**2*b1*f**2*r + 60*Dd**2*b1*f**2*s**2 - 90*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 288*Dd**2*b1*f*g2*r*s - 216*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 216*Dd**2*b1*f*g2*s + 72*Dd**2*b1*f*g2)/(7*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**4*k2**4*st**2*(14172*C*D1**2*f**2*fd*r**2 + 18672*C*D1**2*f**2*fd*r*s - 15672*C*D1**2*f**2*fd*r + 4500*C*D1**2*f**2*fd*s**2 - 9224*C*D1**2*f**2*fd*s + 6224*C*D1**2*f**2*fd - 8670*C*D1**2*f**2*fdd*r**2 - 10920*C*D1**2*f**2*fdd*r*s + 9420*C*D1**2*f**2*fdd*r - 2250*C*D1**2*f**2*fdd*s**2 + 5140*C*D1**2*f**2*fdd*s - 3640*C*D1**2*f**2*fdd - 17340*C*D1**2*f*fd**2*r**2 - 21840*C*D1**2*f*fd**2*r*s + 18840*C*D1**2*f*fd**2*r - 4500*C*D1**2*f*fd**2*s**2 + 10280*C*D1**2*f*fd**2*s - 3640*C*D1**2*f*fd**2 + 18896*C*D1*Dd*f**3*r**2 + 24896*C*D1*Dd*f**3*r*s - 25120*C*D1*Dd*f**3*r + 6000*C*D1*Dd*f**3*s**2 - 15448*C*D1*Dd*f**3*s + 10948*C*D1*Dd*f**3 - 69360*C*D1*Dd*f**2*fd*r**2 - 87360*C*D1*Dd*f**2*fd*r*s + 83280*C*D1*Dd*f**2*fd*r - 18000*C*D1*Dd*f**2*fd*s**2 + 46900*C*D1*Dd*f**2*fd*s - 23980*C*D1*Dd*f**2*fd - 11560*C*D1*Ddd*f**3*r**2 - 14560*C*D1*Ddd*f**3*r*s + 15200*C*D1*Ddd*f**3*r - 3000*C*D1*Ddd*f**3*s**2 + 8780*C*D1*Ddd*f**3*s - 6530*C*D1*Ddd*f**3 - 34680*C*Dd**2*f**3*r**2 - 43680*C*Dd**2*f**3*r*s + 45600*C*Dd**2*f**3*r - 9000*C*Dd**2*f**3*s**2 + 26340*C*Dd**2*f**3*s - 13060*C*Dd**2*f**3 + 5940*D1**2*K*b1*f*fd*r**2 + 7920*D1**2*K*b1*f*fd*r*s - 3960*D1**2*K*b1*f*fd*r + 1980*D1**2*K*b1*f*fd*s**2 - 1980*D1**2*K*b1*f*fd*s + 990*D1**2*K*b1*f*fd - 2970*D1**2*K*b1*f*fdd*r**2 - 3960*D1**2*K*b1*f*fdd*r*s + 1980*D1**2*K*b1*f*fdd*r - 990*D1**2*K*b1*f*fdd*s**2 + 990*D1**2*K*b1*f*fdd*s - 495*D1**2*K*b1*f*fdd - 2970*D1**2*K*b1*fd**2*r**2 - 3960*D1**2*K*b1*fd**2*r*s + 1980*D1**2*K*b1*fd**2*r - 990*D1**2*K*b1*fd**2*s**2 + 990*D1**2*K*b1*fd**2*s - 1485*D1**2*K*bdd1*f**2*r**2 - 1980*D1**2*K*bdd1*f**2*r*s + 2970*D1**2*K*bdd1*f**2*r - 495*D1**2*K*bdd1*f**2*s**2 + 1980*D1**2*K*bdd1*f**2*s - 1485*D1**2*K*bdd1*f**2 - 1485*D1**2*b1*f**2*fd*r**2 - 1485*D1**2*b1*f**2*fd*r*s + 1485*D1**2*b1*f**2*fd*r + 495*D1**2*b1*f**2*fd*s - 495*D1**2*b1*f**2*fd + 1485*D1**2*b1*f**2*fdd*r**2 + 1485*D1**2*b1*f**2*fdd*r*s - 1485*D1**2*b1*f**2*fdd*r - 495*D1**2*b1*f**2*fdd*s + 495*D1**2*b1*f**2*fdd + 2970*D1**2*b1*f*fd**2*r**2 + 2970*D1**2*b1*f*fd**2*r*s - 2970*D1**2*b1*f*fd**2*r - 990*D1**2*b1*f*fd**2*s + 495*D1**2*b1*f*fd**2 - 1980*D1**2*b1*f*fd*r**2 - 1980*D1**2*b1*f*fd*r*s + 990*D1**2*b1*f*fd*r + 990*D1**2*b1*f*fdd*r**2 + 990*D1**2*b1*f*fdd*r*s - 495*D1**2*b1*f*fdd*r + 990*D1**2*b1*fd**2*r**2 + 990*D1**2*b1*fd**2*r*s - 495*D1**2*b1*fd**2*r + 1980*D1**2*b2*f*fd*r**2 + 3960*D1**2*b2*f*fd*r*s - 1980*D1**2*b2*f*fd*r + 1980*D1**2*b2*f*fd*s**2 - 1980*D1**2*b2*f*fd*s + 990*D1**2*b2*f*fd - 990*D1**2*b2*f*fdd*r**2 - 1980*D1**2*b2*f*fdd*r*s + 990*D1**2*b2*f*fdd*r - 990*D1**2*b2*f*fdd*s**2 + 990*D1**2*b2*f*fdd*s - 495*D1**2*b2*f*fdd - 990*D1**2*b2*fd**2*r**2 - 1980*D1**2*b2*fd**2*r*s + 990*D1**2*b2*fd**2*r - 990*D1**2*b2*fd**2*s**2 + 990*D1**2*b2*fd**2*s + 495*D1**2*bdd1*f**3*r**2 + 495*D1**2*bdd1*f**3*r*s - 990*D1**2*bdd1*f**3*r - 495*D1**2*bdd1*f**3*s + 495*D1**2*bdd1*f**3 + 495*D1**2*bdd1*f**2*r**2 + 495*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*r - 495*D1**2*bdd1*f**2*s + 495*D1**2*bdd1*f**2 - 495*D1**2*bdd2*f**2*r**2 - 990*D1**2*bdd2*f**2*r*s + 990*D1**2*bdd2*f**2*r - 495*D1**2*bdd2*f**2*s**2 + 990*D1**2*bdd2*f**2*s - 495*D1**2*bdd2*f**2 - 9504*D1**2*f**2*fd*r**2 - 11754*D1**2*f**2*fd*r*s + 10254*D1**2*f**2*fd*r - 2250*D1**2*f**2*fd*s**2 + 5418*D1**2*f**2*fd*s - 3918*D1**2*f**2*fd + 5940*D1**2*f**2*fdd*r**2 + 7065*D1**2*f**2*fdd*r*s - 6315*D1**2*f**2*fdd*r + 1125*D1**2*f**2*fdd*s**2 - 3105*D1**2*f**2*fdd*s + 2355*D1**2*f**2*fdd - 5940*D1**2*f**2*gd2*r**2 - 7920*D1**2*f**2*gd2*r*s + 11880*D1**2*f**2*gd2*r - 1980*D1**2*f**2*gd2*s**2 + 7920*D1**2*f**2*gd2*s - 5940*D1**2*f**2*gd2 + 2970*D1**2*f**2*gdd2*r**2 + 3960*D1**2*f**2*gdd2*r*s - 5940*D1**2*f**2*gdd2*r + 990*D1**2*f**2*gdd2*s**2 - 3960*D1**2*f**2*gdd2*s + 2970*D1**2*f**2*gdd2 + 11880*D1**2*f*fd**2*r**2 + 14130*D1**2*f*fd**2*r*s - 12630*D1**2*f*fd**2*r + 2250*D1**2*f*fd**2*s**2 - 6210*D1**2*f*fd**2*s + 2355*D1**2*f*fd**2 - 11880*D1**2*f*fd*g2*r**2 - 15840*D1**2*f*fd*g2*r*s + 7920*D1**2*f*fd*g2*r - 3960*D1**2*f*fd*g2*s**2 + 3960*D1**2*f*fd*g2*s - 1980*D1**2*f*fd*g2 + 11880*D1**2*f*fd*gd2*r**2 + 15840*D1**2*f*fd*gd2*r*s - 15840*D1**2*f*fd*gd2*r + 3960*D1**2*f*fd*gd2*s**2 - 9900*D1**2*f*fd*gd2*s + 3960*D1**2*f*fd*gd2 + 5940*D1**2*f*fdd*g2*r**2 + 7920*D1**2*f*fdd*g2*r*s - 3960*D1**2*f*fdd*g2*r + 1980*D1**2*f*fdd*g2*s**2 - 1980*D1**2*f*fdd*g2*s + 990*D1**2*f*fdd*g2 + 5940*D1**2*fd**2*g2*r**2 + 7920*D1**2*fd**2*g2*r*s - 3960*D1**2*fd**2*g2*r + 1980*D1**2*fd**2*g2*s**2 - 1980*D1**2*fd**2*g2*s + 11880*D1*Dd*K*b1*f**2*r**2 + 15840*D1*Dd*K*b1*f**2*r*s - 15840*D1*Dd*K*b1*f**2*r + 3960*D1*Dd*K*b1*f**2*s**2 - 9900*D1*Dd*K*b1*f**2*s + 6930*D1*Dd*K*b1*f**2 - 23760*D1*Dd*K*b1*f*fd*r**2 - 31680*D1*Dd*K*b1*f*fd*r*s + 23760*D1*Dd*K*b1*f*fd*r - 7920*D1*Dd*K*b1*f*fd*s**2 + 13860*D1*Dd*K*b1*f*fd*s - 4950*D1*Dd*K*b1*f*fd - 1980*D1*Dd*b1*f**3*r**2 - 1980*D1*Dd*b1*f**3*r*s + 2475*D1*Dd*b1*f**3*r + 990*D1*Dd*b1*f**3*s - 990*D1*Dd*b1*f**3 + 11880*D1*Dd*b1*f**2*fd*r**2 + 11880*D1*Dd*b1*f**2*fd*r*s - 13365*D1*Dd*b1*f**2*fd*r - 4950*D1*Dd*b1*f**2*fd*s + 3465*D1*Dd*b1*f**2*fd - 3960*D1*Dd*b1*f**2*r**2 - 3960*D1*Dd*b1*f**2*r*s + 4950*D1*Dd*b1*f**2*r + 1980*D1*Dd*b1*f**2*s - 1980*D1*Dd*b1*f**2 + 7920*D1*Dd*b1*f*fd*r**2 + 7920*D1*Dd*b1*f*fd*r*s - 6930*D1*Dd*b1*f*fd*r - 1980*D1*Dd*b1*f*fd*s + 990*D1*Dd*b1*f*fd + 3960*D1*Dd*b2*f**2*r**2 + 7920*D1*Dd*b2*f**2*r*s - 5940*D1*Dd*b2*f**2*r + 3960*D1*Dd*b2*f**2*s**2 - 5940*D1*Dd*b2*f**2*s + 2970*D1*Dd*b2*f**2 - 7920*D1*Dd*b2*f*fd*r**2 - 15840*D1*Dd*b2*f*fd*r*s + 9900*D1*Dd*b2*f*fd*r - 7920*D1*Dd*b2*f*fd*s**2 + 9900*D1*Dd*b2*f*fd*s - 2970*D1*Dd*b2*f*fd - 12672*D1*Dd*f**3*r**2 - 15672*D1*Dd*f**3*r*s + 16590*D1*Dd*f**3*r - 3000*D1*Dd*f**3*s**2 + 9336*D1*Dd*f**3*s - 7086*D1*Dd*f**3 + 47520*D1*Dd*f**2*fd*r**2 + 56520*D1*Dd*f**2*fd*r*s - 56085*D1*Dd*f**2*fd*r + 9000*D1*Dd*f**2*fd*s**2 - 28800*D1*Dd*f**2*fd*s + 15735*D1*Dd*f**2*fd - 23760*D1*Dd*f**2*g2*r**2 - 31680*D1*Dd*f**2*g2*r*s + 31680*D1*Dd*f**2*g2*r - 7920*D1*Dd*f**2*g2*s**2 + 19800*D1*Dd*f**2*g2*s - 13860*D1*Dd*f**2*g2 + 23760*D1*Dd*f**2*gd2*r**2 + 31680*D1*Dd*f**2*gd2*r*s - 39600*D1*Dd*f**2*gd2*r + 7920*D1*Dd*f**2*gd2*s**2 - 25740*D1*Dd*f**2*gd2*s + 15840*D1*Dd*f**2*gd2 + 47520*D1*Dd*f*fd*g2*r**2 + 63360*D1*Dd*f*fd*g2*r*s - 47520*D1*Dd*f*fd*g2*r + 15840*D1*Dd*f*fd*g2*s**2 - 27720*D1*Dd*f*fd*g2*s + 9900*D1*Dd*f*fd*g2 - 5940*D1*Ddd*K*b1*f**2*r**2 - 7920*D1*Ddd*K*b1*f**2*r*s + 7920*D1*Ddd*K*b1*f**2*r - 1980*D1*Ddd*K*b1*f**2*s**2 + 4950*D1*Ddd*K*b1*f**2*s - 3465*D1*Ddd*K*b1*f**2 + 1980*D1*Ddd*b1*f**3*r**2 + 1980*D1*Ddd*b1*f**3*r*s - 2475*D1*Ddd*b1*f**3*r - 990*D1*Ddd*b1*f**3*s + 990*D1*Ddd*b1*f**3 + 1980*D1*Ddd*b1*f**2*r**2 + 1980*D1*Ddd*b1*f**2*r*s - 2475*D1*Ddd*b1*f**2*r - 990*D1*Ddd*b1*f**2*s + 990*D1*Ddd*b1*f**2 - 1980*D1*Ddd*b2*f**2*r**2 - 3960*D1*Ddd*b2*f**2*r*s + 2970*D1*Ddd*b2*f**2*r - 1980*D1*Ddd*b2*f**2*s**2 + 2970*D1*Ddd*b2*f**2*s - 1485*D1*Ddd*b2*f**2 + 7920*D1*Ddd*f**3*r**2 + 9420*D1*Ddd*f**3*r*s - 10275*D1*Ddd*f**3*r + 1500*D1*Ddd*f**3*s**2 - 5460*D1*Ddd*f**3*s + 4335*D1*Ddd*f**3 + 11880*D1*Ddd*f**2*g2*r**2 + 15840*D1*Ddd*f**2*g2*r*s - 15840*D1*Ddd*f**2*g2*r + 3960*D1*Ddd*f**2*g2*s**2 - 9900*D1*Ddd*f**2*g2*s + 6930*D1*Ddd*f**2*g2 - 495*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (2*r + 2*s - 2)*(K*(3*r + s - 3) - r + 1)) + fd*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(2*K*(12*r**2 + 4*r*(4*s - 5) + 4*s**2 - 13*s + 8) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) + 990*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 17820*Dd**2*K*b1*f**2*r**2 - 23760*Dd**2*K*b1*f**2*r*s + 23760*Dd**2*K*b1*f**2*r - 5940*Dd**2*K*b1*f**2*s**2 + 14850*Dd**2*K*b1*f**2*s - 6930*Dd**2*K*b1*f**2 + 5940*Dd**2*b1*f**3*r**2 + 5940*Dd**2*b1*f**3*r*s - 7425*Dd**2*b1*f**3*r - 2970*Dd**2*b1*f**3*s + 1980*Dd**2*b1*f**3 + 5940*Dd**2*b1*f**2*r**2 + 5940*Dd**2*b1*f**2*r*s - 7425*Dd**2*b1*f**2*r - 2970*Dd**2*b1*f**2*s + 1980*Dd**2*b1*f**2 - 5940*Dd**2*b2*f**2*r**2 - 11880*Dd**2*b2*f**2*r*s + 8910*Dd**2*b2*f**2*r - 5940*Dd**2*b2*f**2*s**2 + 8910*Dd**2*b2*f**2*s - 2970*Dd**2*b2*f**2 + 23760*Dd**2*f**3*r**2 + 28260*Dd**2*f**3*r*s - 30825*Dd**2*f**3*r + 4500*Dd**2*f**3*s**2 - 16380*Dd**2*f**3*s + 8670*Dd**2*f**3 + 35640*Dd**2*f**2*g2*r**2 + 47520*Dd**2*f**2*g2*r*s - 47520*Dd**2*f**2*g2*r + 11880*Dd**2*f**2*g2*s**2 - 29700*Dd**2*f**2*g2*s + 13860*Dd**2*f**2*g2)/(693*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**4*k2**4*(-1232*C*D1**2*bd1*f**2*r**2 - 2112*C*D1**2*bd1*f**2*r*s + 2992*C*D1**2*bd1*f**2*r - 880*C*D1**2*bd1*f**2*s**2 + 2640*C*D1**2*bd1*f**2*s - 1320*C*D1**2*bd1*f**2 + 2464*C*D1**2*bd1*f*fd*r**2 + 4224*C*D1**2*bd1*f*fd*r*s - 3784*C*D1**2*bd1*f*fd*r + 1760*C*D1**2*bd1*f*fd*s**2 - 3256*C*D1**2*bd1*f*fd*s + 1496*C*D1**2*bd1*f*fd + 616*C*D1**2*bdd1*f**2*r**2 + 1056*C*D1**2*bdd1*f**2*r*s - 1496*C*D1**2*bdd1*f**2*r + 440*C*D1**2*bdd1*f**2*s**2 - 1320*C*D1**2*bdd1*f**2*s + 660*C*D1**2*bdd1*f**2 - 210*C*D1**2*f**2*fd*r**2 - 1860*C*D1**2*f**2*fd*r*s + 760*C*D1**2*f**2*fd*r - 1650*C*D1**2*f**2*fd*s**2 + 1720*C*D1**2*f**2*fd*s - 620*C*D1**2*f**2*fd + 2250*C*D1**2*f**2*fdd*r**2 + 5220*C*D1**2*f**2*fdd*r*s - 3240*C*D1**2*f**2*fdd*r + 2970*C*D1**2*f**2*fdd*s**2 - 3720*C*D1**2*f**2*fdd*s + 1740*C*D1**2*f**2*fdd + 4500*C*D1**2*f*fd**2*r**2 + 10440*C*D1**2*f*fd**2*r*s - 6480*C*D1**2*f*fd**2*r + 5940*C*D1**2*f*fd**2*s**2 - 7440*C*D1**2*f*fd**2*s + 1740*C*D1**2*f*fd**2 + 4928*C*D1*Dd*bd1*f**2*r**2 + 8448*C*D1*Dd*bd1*f**2*r*s - 9504*C*D1*Dd*bd1*f**2*r + 3520*C*D1*Dd*bd1*f**2*s**2 - 8272*C*D1*Dd*bd1*f**2*s + 4312*C*D1*Dd*bd1*f**2 - 280*C*D1*Dd*f**3*r**2 - 2480*C*D1*Dd*f**3*r*s + 900*C*D1*Dd*f**3*r - 2200*C*D1*Dd*f**3*s**2 + 2340*C*D1*Dd*f**3*s - 690*C*D1*Dd*f**3 + 18000*C*D1*Dd*f**2*fd*r**2 + 41760*C*D1*Dd*f**2*fd*r*s - 27180*C*D1*Dd*f**2*fd*r + 23760*C*D1*Dd*f**2*fd*s**2 - 31260*C*D1*Dd*f**2*fd*s + 10200*C*D1*Dd*f**2*fd + 3000*C*D1*Ddd*f**3*r**2 + 6960*C*D1*Ddd*f**3*r*s - 4740*C*D1*Ddd*f**3*r + 3960*C*D1*Ddd*f**3*s**2 - 5460*C*D1*Ddd*f**3*s + 2490*C*D1*Ddd*f**3 + 9000*C*Dd**2*f**3*r**2 + 20880*C*Dd**2*f**3*r*s - 14220*C*Dd**2*f**3*r + 11880*C*Dd**2*f**3*s**2 - 16380*C*Dd**2*f**3*s + 4980*C*Dd**2*f**3 + 528*D1**2*K*bd1**2*f*r**2 + 1056*D1**2*K*bd1**2*f*r*s - 1320*D1**2*K*bd1**2*f*r + 528*D1**2*K*bd1**2*f*s**2 - 1320*D1**2*K*bd1**2*f*s + 792*D1**2*K*bd1**2*f + 198*D1**2*K*bd1*f**2*r**2 - 132*D1**2*K*bd1*f**2*r*s - 396*D1**2*K*bd1*f**2*r - 330*D1**2*K*bd1*f**2*s**2 + 132*D1**2*K*bd1*f**2*s + 198*D1**2*K*bd1*f**2 + 1320*D1**2*K*bd1*f*fd*r**2 + 3696*D1**2*K*bd1*f*fd*r*s - 2244*D1**2*K*bd1*f*fd*r + 2376*D1**2*K*bd1*f*fd*s**2 - 3036*D1**2*K*bd1*f*fd*s + 924*D1**2*K*bd1*f*fd + 330*D1**2*K*bdd1*f**2*r**2 + 924*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*r + 594*D1**2*K*bdd1*f**2*s**2 - 924*D1**2*K*bdd1*f**2*s + 330*D1**2*K*bdd1*f**2 - 264*D1**2*bd1**2*f**2*r**2 - 264*D1**2*bd1**2*f**2*r*s + 396*D1**2*bd1**2*f**2*r + 132*D1**2*bd1**2*f**2*s - 132*D1**2*bd1**2*f**2 - 264*D1**2*bd1**2*f*r**2 - 264*D1**2*bd1**2*f*r*s + 396*D1**2*bd1**2*f*r + 132*D1**2*bd1**2*f*s - 132*D1**2*bd1**2*f + 264*D1**2*bd1*bd2*f*r**2 + 528*D1**2*bd1*bd2*f*r*s - 528*D1**2*bd1*bd2*f*r + 264*D1**2*bd1*bd2*f*s**2 - 528*D1**2*bd1*bd2*f*s + 264*D1**2*bd1*bd2*f + 792*D1**2*bd1*f**2*r**2 + 1232*D1**2*bd1*f**2*r*s - 1540*D1**2*bd1*f**2*r + 440*D1**2*bd1*f**2*s**2 - 1188*D1**2*bd1*f**2*s + 528*D1**2*bd1*f**2 - 1848*D1**2*bd1*f*fd*r**2 - 2728*D1**2*bd1*f*fd*r*s + 2508*D1**2*bd1*f*fd*r - 880*D1**2*bd1*f*fd*s**2 + 1782*D1**2*bd1*f*fd*s - 902*D1**2*bd1*f*fd + 1056*D1**2*bd1*f*g2*r**2 + 2112*D1**2*bd1*f*g2*r*s - 3168*D1**2*bd1*f*g2*r + 1056*D1**2*bd1*f*g2*s**2 - 3168*D1**2*bd1*f*g2*s + 1584*D1**2*bd1*f*g2 - 1056*D1**2*bd1*f*gd2*r**2 - 2112*D1**2*bd1*f*gd2*r*s + 2640*D1**2*bd1*f*gd2*r - 1056*D1**2*bd1*f*gd2*s**2 + 2640*D1**2*bd1*f*gd2*s - 1584*D1**2*bd1*f*gd2 - 1056*D1**2*bd1*fd*g2*r**2 - 2112*D1**2*bd1*fd*g2*r*s + 1056*D1**2*bd1*fd*g2*r - 1056*D1**2*bd1*fd*g2*s**2 + 1056*D1**2*bd1*fd*g2*s + 132*D1**2*bd2*f**2*r**2 + 264*D1**2*bd2*f**2*r*s - 264*D1**2*bd2*f**2*r + 132*D1**2*bd2*f**2*s**2 - 264*D1**2*bd2*f**2*s + 132*D1**2*bd2*f**2 - 462*D1**2*bdd1*f**2*r**2 - 682*D1**2*bdd1*f**2*r*s + 902*D1**2*bdd1*f**2*r - 220*D1**2*bdd1*f**2*s**2 + 660*D1**2*bdd1*f**2*s - 330*D1**2*bdd1*f**2 - 528*D1**2*bdd1*f*g2*r**2 - 1056*D1**2*bdd1*f*g2*r*s + 1584*D1**2*bdd1*f*g2*r - 528*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 - 225*D1**2*f**2*fd*r**2 + 600*D1**2*f**2*fd*r*s - 50*D1**2*f**2*fd*r + 825*D1**2*f**2*fd*s**2 - 750*D1**2*f**2*fd*s + 200*D1**2*f**2*fd - 1125*D1**2*f**2*fdd*r**2 - 2610*D1**2*f**2*fdd*r*s + 1620*D1**2*f**2*fdd*r - 1485*D1**2*f**2*fdd*s**2 + 1860*D1**2*f**2*fdd*s - 870*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r + 660*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 - 660*D1**2*f**2*gdd2*r**2 - 1848*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*r - 1188*D1**2*f**2*gdd2*s**2 + 1848*D1**2*f**2*gdd2*s - 660*D1**2*f**2*gdd2 - 2250*D1**2*f*fd**2*r**2 - 5220*D1**2*f*fd**2*r*s + 3240*D1**2*f*fd**2*r - 2970*D1**2*f*fd**2*s**2 + 3720*D1**2*f*fd**2*s - 870*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 1320*D1**2*f*fd*g2*s**2 - 1320*D1**2*f*fd*g2*s + 660*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r**2 - 7392*D1**2*f*fd*gd2*r*s + 4488*D1**2*f*fd*gd2*r - 4752*D1**2*f*fd*gd2*s**2 + 6072*D1**2*f*fd*gd2*s - 1848*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r**2 - 3696*D1**2*f*fdd*g2*r*s + 1848*D1**2*f*fdd*g2*r - 2376*D1**2*f*fdd*g2*s**2 + 2376*D1**2*f*fdd*g2*s - 1188*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r**2 - 3696*D1**2*fd**2*g2*r*s + 1848*D1**2*fd**2*g2*r - 2376*D1**2*fd**2*g2*s**2 + 2376*D1**2*fd**2*g2*s + 2640*D1*Dd*K*bd1*f**2*r**2 + 7392*D1*Dd*K*bd1*f**2*r*s - 4884*D1*Dd*K*bd1*f**2*r + 4752*D1*Dd*K*bd1*f**2*s**2 - 6732*D1*Dd*K*bd1*f**2*s + 2244*D1*Dd*K*bd1*f**2 - 3696*D1*Dd*bd1*f**2*r**2 - 5456*D1*Dd*bd1*f**2*r*s + 6138*D1*Dd*bd1*f**2*r - 1760*D1*Dd*bd1*f**2*s**2 + 4444*D1*Dd*bd1*f**2*s - 2464*D1*Dd*bd1*f**2 - 4224*D1*Dd*bd1*f*g2*r**2 - 8448*D1*Dd*bd1*f*g2*r*s + 9504*D1*Dd*bd1*f*g2*r - 4224*D1*Dd*bd1*f*g2*s**2 + 9504*D1*Dd*bd1*f*g2*s - 4752*D1*Dd*bd1*f*g2 - 300*D1*Dd*f**3*r**2 + 800*D1*Dd*f**3*r*s + 100*D1*Dd*f**3*r + 1100*D1*Dd*f**3*s**2 - 950*D1*Dd*f**3*s + 125*D1*Dd*f**3 - 9000*D1*Dd*f**2*fd*r**2 - 20880*D1*Dd*f**2*fd*r*s + 13590*D1*Dd*f**2*fd*r - 11880*D1*Dd*f**2*fd*s**2 + 15630*D1*Dd*f**2*fd*s - 5100*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s + 1320*D1*Dd*f**2*g2*r + 2640*D1*Dd*f**2*g2*s**2 - 1848*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r**2 - 14784*D1*Dd*f**2*gd2*r*s + 9768*D1*Dd*f**2*gd2*r - 9504*D1*Dd*f**2*gd2*s**2 + 13464*D1*Dd*f**2*gd2*s - 4488*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r**2 - 29568*D1*Dd*f*fd*g2*r*s + 16368*D1*Dd*f*fd*g2*r - 19008*D1*Dd*f*fd*g2*s**2 + 21648*D1*Dd*f*fd*g2*s - 6072*D1*Dd*f*fd*g2 - 1500*D1*Ddd*f**3*r**2 - 3480*D1*Ddd*f**3*r*s + 2370*D1*Ddd*f**3*r - 1980*D1*Ddd*f**3*s**2 + 2730*D1*Ddd*f**3*s - 1245*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r**2 - 7392*D1*Ddd*f**2*g2*r*s + 4488*D1*Ddd*f**2*g2*r - 4752*D1*Ddd*f**2*g2*s**2 + 6072*D1*Ddd*f**2*g2*s - 2508*D1*Ddd*f**2*g2 - 132*D1*b2*(2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 4500*Dd**2*f**3*r**2 - 10440*Dd**2*f**3*r*s + 7110*Dd**2*f**3*r - 5940*Dd**2*f**3*s**2 + 8190*Dd**2*f**3*s - 2490*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r**2 - 22176*Dd**2*f**2*g2*r*s + 13464*Dd**2*f**2*g2*r - 14256*Dd**2*f**2*g2*s**2 + 18216*Dd**2*f**2*g2*s - 5016*Dd**2*f**2*g2 + 132*b1**2*(D1**2*(-2*K*fd*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-2*r**2 - 2*r*(s - 1) + s) + 2*fd*r*(r + s) + fdd*(K*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) - r*(r + s))) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(2*K*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 22*b1*(-112*C*D1**2*f*fd*r**2 - 192*C*D1**2*f*fd*r*s + 72*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 56*C*D1**2*f*fd*s - 36*C*D1**2*f*fd + 56*C*D1**2*f*fdd*r**2 + 96*C*D1**2*f*fdd*r*s - 36*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 28*C*D1**2*f*fdd*s + 18*C*D1**2*f*fdd + 56*C*D1**2*fd**2*r**2 + 96*C*D1**2*fd**2*r*s - 36*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 28*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 224*C*D1*Dd*f**2*r**2 - 384*C*D1*Dd*f**2*r*s + 320*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 272*C*D1*Dd*f**2*s - 152*C*D1*Dd*f**2 + 448*C*D1*Dd*f*fd*r**2 + 768*C*D1*Dd*f*fd*r*s - 464*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 384*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 112*C*D1*Ddd*f**2*r**2 + 192*C*D1*Ddd*f**2*r*s - 160*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 136*C*D1*Ddd*f**2*s + 76*C*D1*Ddd*f**2 + 336*C*Dd**2*f**2*r**2 + 576*C*Dd**2*f**2*r*s - 480*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 408*C*Dd**2*f**2*s + 152*C*Dd**2*f**2 + 24*D1**2*K*bdd1*f*r**2 + 48*D1**2*K*bdd1*f*r*s - 60*D1**2*K*bdd1*f*r + 24*D1**2*K*bdd1*f*s**2 - 60*D1**2*K*bdd1*f*s + 30*D1**2*K*bdd1*f + 18*D1**2*K*f*fd*r**2 - 12*D1**2*K*f*fd*r*s + 6*D1**2*K*f*fd*r - 30*D1**2*K*f*fd*s**2 + 30*D1**2*K*f*fd*s - 15*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 + 84*D1**2*K*f*fdd*r*s - 42*D1**2*K*f*fdd*r + 54*D1**2*K*f*fdd*s**2 - 54*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 + 84*D1**2*K*fd**2*r*s - 42*D1**2*K*fd**2*r + 54*D1**2*K*fd**2*s**2 - 54*D1**2*K*fd**2*s - 12*D1**2*b2*fd*r**2 - 24*D1**2*b2*fd*r*s - 12*D1**2*b2*fd*s**2 + 6*D1**2*b2*fdd*r**2 + 12*D1**2*b2*fdd*r*s + 6*D1**2*b2*fdd*s**2 - 12*D1**2*bdd1*f**2*r**2 - 12*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*r + 6*D1**2*bdd1*f**2*s - 6*D1**2*bdd1*f**2 - 12*D1**2*bdd1*f*r**2 - 12*D1**2*bdd1*f*r*s + 18*D1**2*bdd1*f*r + 6*D1**2*bdd1*f*s - 6*D1**2*bdd1*f + 6*D1**2*bdd2*f*r**2 + 12*D1**2*bdd2*f*r*s - 12*D1**2*bdd2*f*r + 6*D1**2*bdd2*f*s**2 - 12*D1**2*bdd2*f*s + 6*D1**2*bdd2*f + 72*D1**2*f*fd*r**2 + 112*D1**2*f*fd*r*s - 58*D1**2*f*fd*r + 40*D1**2*f*fd*s**2 - 42*D1**2*f*fd*s + 32*D1**2*f*fd - 42*D1**2*f*fdd*r**2 - 62*D1**2*f*fdd*r*s + 32*D1**2*f*fdd*r - 20*D1**2*f*fdd*s**2 + 21*D1**2*f*fdd*s - 16*D1**2*f*fdd + 48*D1**2*f*gd2*r**2 + 96*D1**2*f*gd2*r*s - 96*D1**2*f*gd2*r + 48*D1**2*f*gd2*s**2 - 96*D1**2*f*gd2*s + 48*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 42*D1**2*fd**2*r**2 - 62*D1**2*fd**2*r*s + 32*D1**2*fd**2*r - 20*D1**2*fd**2*s**2 + 21*D1**2*fd**2*s + 10*D1**2*fd**2 + 48*D1**2*fd*g2*r**2 + 96*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*r + 48*D1**2*fd*g2*s**2 + 48*D1**2*fd*g2*s - 24*D1**2*fd*g2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r - 24*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 + 36*D1*Dd*K*f**2*r**2 - 24*D1*Dd*K*f**2*r*s - 30*D1*Dd*K*f**2*r - 60*D1*Dd*K*f**2*s**2 + 42*D1*Dd*K*f**2*s + 3*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 + 672*D1*Dd*K*f*fd*r*s - 372*D1*Dd*K*f*fd*r + 432*D1*Dd*K*f*fd*s**2 - 492*D1*Dd*K*f*fd*s + 138*D1*Dd*K*f*fd - 48*D1*Dd*b2*f*r**2 - 96*D1*Dd*b2*f*r*s + 72*D1*Dd*b2*f*r - 48*D1*Dd*b2*f*s**2 + 72*D1*Dd*b2*f*s - 36*D1*Dd*b2*f + 48*D1*Dd*b2*fd*r**2 + 96*D1*Dd*b2*fd*r*s - 36*D1*Dd*b2*fd*r + 48*D1*Dd*b2*fd*s**2 - 36*D1*Dd*b2*fd*s + 144*D1*Dd*f**2*r**2 + 224*D1*Dd*f**2*r*s - 200*D1*Dd*f**2*r + 80*D1*Dd*f**2*s**2 - 152*D1*Dd*f**2*s + 92*D1*Dd*f**2 - 336*D1*Dd*f*fd*r**2 - 496*D1*Dd*f*fd*r*s + 358*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 248*D1*Dd*f*fd*s - 85*D1*Dd*f*fd + 192*D1*Dd*f*g2*r**2 + 384*D1*Dd*f*g2*r*s - 288*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 288*D1*Dd*f*g2*s + 144*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 48*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 48*D1*Dd*fd*g2*s + 72*D1*Dd*fd*g2 + 60*D1*Ddd*K*f**2*r**2 + 168*D1*Ddd*K*f**2*r*s - 102*D1*Ddd*K*f**2*r + 108*D1*Ddd*K*f**2*s**2 - 138*D1*Ddd*K*f**2*s + 57*D1*Ddd*K*f**2 + 24*D1*Ddd*b2*f*r**2 + 48*D1*Ddd*b2*f*r*s - 36*D1*Ddd*b2*f*r + 24*D1*Ddd*b2*f*s**2 - 36*D1*Ddd*b2*f*s + 18*D1*Ddd*b2*f - 84*D1*Ddd*f**2*r**2 - 124*D1*Ddd*f**2*r*s + 115*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 82*D1*Ddd*f**2*s - 52*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(2*K*(4*r**2 + 2*r*(4*s - 5) + 4*s**2 - 10*s + 5) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(2*K*(4*r**2 + 8*r*s - 3*r + 4*s**2 - 3*s - 1) - 4*r**2 - 4*r*s + 3*r + s)) + Dd*f*(K*(32*r**2 + 64*r*(s - 1) + 32*s**2 - 64*s + 30) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 12*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 180*Dd**2*K*f**2*r**2 + 504*Dd**2*K*f**2*r*s - 306*Dd**2*K*f**2*r + 324*Dd**2*K*f**2*s**2 - 414*Dd**2*K*f**2*s + 114*Dd**2*K*f**2 + 72*Dd**2*b2*f*r**2 + 144*Dd**2*b2*f*r*s - 108*Dd**2*b2*f*r + 72*Dd**2*b2*f*s**2 - 108*Dd**2*b2*f*s + 36*Dd**2*b2*f - 252*Dd**2*f**2*r**2 - 372*Dd**2*f**2*r*s + 345*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 246*Dd**2*f**2*s - 104*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(231*d**2*k3**6) - 8*D1**2*Pk2*Pk3*ct**4*(D1*(6*D1*bd1**2*f*s*(2*K*s + f*(2*r - 1) + 2*r - 1) + D1*bdd1*f*s*(7*f*r + f*s*(10*C - 5) + s*(6*b2 - 12*g2)) + bd1*(D1*(-2*f**2*s*(7*r + s*(10*C - 5)) + f*(7*fd*r*(4*s - 1) + fd*s*(20*C*(2*s - 1) - 20*s + 3) + s**2*(-12*b2 + 12*bd2 + 24*g2 - 24*gd2)) + 12*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(7*f*r*(8*s - 1) + 4*f*s*(5*C*(4*s - 1) - 10*s - 1) + s*(12*b2 - 24*g2)*(4*s - 1)))) + 6*b1**2*(D1*Dd*(f*(K*(-8*s**2 + 4*s - 2) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(2*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(2*s - 1) - s + 1) + fd*(-2*K*(s - 1)**2 + f*s + r*(-2*f*s + f - 2*s + 2)) + fdd*(K*(s - 1)**2 - f*s + r*(2*f*s - f + s - 1))) + Ddd*f*(K*(4*s**2 - 2*s + 1) + (f + 1)*(r*(4*s - 1) - 2*s))) + Dd**2*f*(12*K*s**2 - 6*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(-40*C*D1**2*f*fd*s**2 + 40*C*D1**2*f*fd*s - 20*C*D1**2*f*fd + 20*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd + 20*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 80*C*D1*Dd*f**2*s**2 + 40*C*D1*Dd*f**2*s - 20*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*s**2 - 120*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*s**2 - 20*C*D1*Ddd*f**2*s + 10*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*s**2 - 60*C*Dd**2*f**2*s + 12*D1**2*K*bdd1*f*s**2 - 12*D1**2*bd2*f*s**2 + 12*D1**2*bd2*fd*s**2 - 12*D1**2*bd2*fd*s + 12*D1**2*bdd1*f**2*r*s - 6*D1**2*bdd1*f**2*s + 12*D1**2*bdd1*f*r*s - 6*D1**2*bdd1*f*s + 6*D1**2*bdd2*f*s**2 - 28*D1**2*f*fd*r*s + 14*D1**2*f*fd*r + 20*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s + 10*D1**2*f*fd + 14*D1**2*f*fdd*r*s - 7*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s - 5*D1**2*f*fdd + 24*D1**2*f*gd2*s**2 - 12*D1**2*f*gdd2*s**2 + 14*D1**2*fd**2*r*s - 7*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s + 7*D1**2*fd**2 + 24*D1**2*fd*g2*s**2 - 48*D1**2*fd*g2*s + 24*D1**2*fd*g2 - 24*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*s**2 + 24*D1**2*fdd*g2*s - 12*D1**2*fdd*g2 + 48*D1*Dd*bd2*f*s**2 - 12*D1*Dd*bd2*f*s - 56*D1*Dd*f**2*r*s + 14*D1*Dd*f**2*r + 40*D1*Dd*f**2*s**2 + 8*D1*Dd*f**2*s + 10*D1*Dd*f**2 + 112*D1*Dd*f*fd*r*s - 42*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 4*D1*Dd*f*fd*s + 11*D1*Dd*f*fd + 96*D1*Dd*f*g2*s**2 - 48*D1*Dd*f*g2*s + 24*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*s**2 + 24*D1*Dd*f*gd2*s - 96*D1*Dd*fd*g2*s**2 + 120*D1*Dd*fd*g2*s - 24*D1*Dd*fd*g2 + 28*D1*Ddd*f**2*r*s - 7*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 - 4*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*s**2 + 24*D1*Ddd*f*g2*s - 12*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(f*s*(-4*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(4*K*s - 1))) + Dd*f*(16*K*s**2 - 4*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) + 84*Dd**2*f**2*r*s - 21*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 - 12*Dd**2*f**2*s + 14*Dd**2*f**2 - 144*Dd**2*f*g2*s**2 + 72*Dd**2*f*g2*s - 6*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(21*d**2*k2**2) - 40*D1**2*Pk2*Pk3*ct**3*f**2*k1**7*(D1**2*(f*(38*fd - 45*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 270*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(38*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 90*Dd*fd*(4*r + 4*s - 3)**2 - 45*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 270*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(429*d**2*k2*k3**8) - 1400*D1**2*Pk2*Pk3*ct**3*f**2*k1**5*st**2*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(429*d**2*k2**3*k3**4) + 80*D1**2*Pk2*Pk3*ct**3*f*k1**5*(-12*D1**2*b1*f*fd*s**2 + 6*D1**2*b1*f*fdd*s**2 + 12*D1**2*b1*fd**2*s**2 + 2*D1**2*bdd1*f**2*(s - 1)**2 + 44*D1**2*f**2*fd*s**2 - 22*D1**2*f**2*fd*s + 11*D1**2*f**2*fd - 28*D1**2*f**2*fdd*s**2 + 14*D1**2*f**2*fdd*s - 7*D1**2*f**2*fdd - 84*D1**2*f*fd**2*s**2 + 42*D1**2*f*fd**2*s - 16*D1*Dd*b1*f**2*s**2 + 8*D1*Dd*b1*f**2*s - 4*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*s**2 - 12*D1*Dd*b1*f*fd*s + 44*D1*Dd*f**3*s**2 - 22*D1*Dd*f**3*s + 11*D1*Dd*f**3 - 224*D1*Dd*f**2*fd*s**2 + 112*D1*Dd*f**2*fd*s - 14*D1*Dd*f**2*fd + 8*D1*Ddd*b1*f**2*s**2 - 4*D1*Ddd*b1*f**2*s + 2*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*s**2 + 14*D1*Ddd*f**3*s - 7*D1*Ddd*f**3 - 4*D1*bd1*f*(s - 1)*(D1*f*(s - 1) - 3*D1*fd*s + Dd*f*(1 - 4*s)) + 24*Dd**2*b1*f**2*s**2 - 12*Dd**2*b1*f**2*s - 84*Dd**2*f**3*s**2 + 42*Dd**2*f**3*s)/(99*d**2*k2**3*k3**4) - 16*D1**2*Pk2*Pk3*ct**3*f*k1**3*k2**3*st**4*(1560*C*D1**2*f*fd*r**2 + 3120*C*D1**2*f*fd*r*s - 2080*C*D1**2*f*fd*r + 1560*C*D1**2*f*fd*s**2 - 2080*C*D1**2*f*fd*s + 1040*C*D1**2*f*fd - 780*C*D1**2*f*fdd*r**2 - 1560*C*D1**2*f*fdd*r*s + 1040*C*D1**2*f*fdd*r - 780*C*D1**2*f*fdd*s**2 + 1040*C*D1**2*f*fdd*s - 520*C*D1**2*f*fdd - 1560*C*D1**2*fd**2*r**2 - 3120*C*D1**2*fd**2*r*s + 2080*C*D1**2*fd**2*r - 1560*C*D1**2*fd**2*s**2 + 2080*C*D1**2*fd**2*s - 520*C*D1**2*fd**2 + 2080*C*D1*Dd*f**2*r**2 + 4160*C*D1*Dd*f**2*r*s - 3120*C*D1*Dd*f**2*r + 2080*C*D1*Dd*f**2*s**2 - 3120*C*D1*Dd*f**2*s + 1560*C*D1*Dd*f**2 - 6240*C*D1*Dd*f*fd*r**2 - 12480*C*D1*Dd*f*fd*r*s + 8840*C*D1*Dd*f*fd*r - 6240*C*D1*Dd*f*fd*s**2 + 8840*C*D1*Dd*f*fd*s - 3120*C*D1*Dd*f*fd - 1040*C*D1*Ddd*f**2*r**2 - 2080*C*D1*Ddd*f**2*r*s + 1560*C*D1*Ddd*f**2*r - 1040*C*D1*Ddd*f**2*s**2 + 1560*C*D1*Ddd*f**2*s - 780*C*D1*Ddd*f**2 - 3120*C*Dd**2*f**2*r**2 - 6240*C*Dd**2*f**2*r*s + 4680*C*Dd**2*f**2*r - 3120*C*Dd**2*f**2*s**2 + 4680*C*Dd**2*f**2*s - 1560*C*Dd**2*f**2 + 429*D1**2*bd1*f*(K - 1)*(r + s - 1)**2 + 6220*D1**2*f**2*fd*r**2 + 12440*D1**2*f**2*fd*r*s - 9330*D1**2*f**2*fd*r + 6220*D1**2*f**2*fd*s**2 - 9330*D1**2*f**2*fd*s + 4665*D1**2*f**2*fd - 3500*D1**2*f**2*fdd*r**2 - 7000*D1**2*f**2*fdd*r*s + 5250*D1**2*f**2*fdd*r - 3500*D1**2*f**2*fdd*s**2 + 5250*D1**2*f**2*fdd*s - 2625*D1**2*f**2*fdd - 10500*D1**2*f*fd**2*r**2 - 21000*D1**2*f*fd**2*r*s + 15750*D1**2*f*fd**2*r - 10500*D1**2*f*fd**2*s**2 + 15750*D1**2*f*fd**2*s - 5250*D1**2*f*fd**2 - 1560*D1**2*f*fd*r**2 - 3120*D1**2*f*fd*r*s + 2080*D1**2*f*fd*r - 1560*D1**2*f*fd*s**2 + 2080*D1**2*f*fd*s - 1040*D1**2*f*fd + 780*D1**2*f*fdd*r**2 + 1560*D1**2*f*fdd*r*s - 1040*D1**2*f*fdd*r + 780*D1**2*f*fdd*s**2 - 1040*D1**2*f*fdd*s + 520*D1**2*f*fdd - 858*D1**2*f*gd2*r**2 - 1716*D1**2*f*gd2*r*s + 1716*D1**2*f*gd2*r - 858*D1**2*f*gd2*s**2 + 1716*D1**2*f*gd2*s - 858*D1**2*f*gd2 + 1560*D1**2*fd**2*r**2 + 3120*D1**2*fd**2*r*s - 2080*D1**2*fd**2*r + 1560*D1**2*fd**2*s**2 - 2080*D1**2*fd**2*s + 520*D1**2*fd**2 - 1716*D1**2*fd*g2*r**2 - 3432*D1**2*fd*g2*r*s + 1716*D1**2*fd*g2*r - 1716*D1**2*fd*g2*s**2 + 1716*D1**2*fd*g2*s - 858*D1**2*fd*g2 + 6220*D1*Dd*f**3*r**2 + 12440*D1*Dd*f**3*r*s - 9330*D1*Dd*f**3*r + 6220*D1*Dd*f**3*s**2 - 9330*D1*Dd*f**3*s + 4665*D1*Dd*f**3 - 28000*D1*Dd*f**2*fd*r**2 - 56000*D1*Dd*f**2*fd*r*s + 42000*D1*Dd*f**2*fd*r - 28000*D1*Dd*f**2*fd*s**2 + 42000*D1*Dd*f**2*fd*s - 15750*D1*Dd*f**2*fd - 2080*D1*Dd*f**2*r**2 - 4160*D1*Dd*f**2*r*s + 3120*D1*Dd*f**2*r - 2080*D1*Dd*f**2*s**2 + 3120*D1*Dd*f**2*s - 1560*D1*Dd*f**2 + 6240*D1*Dd*f*fd*r**2 + 12480*D1*Dd*f*fd*r*s - 8840*D1*Dd*f*fd*r + 6240*D1*Dd*f*fd*s**2 - 8840*D1*Dd*f*fd*s + 3120*D1*Dd*f*fd - 3432*D1*Dd*f*g2*r**2 - 6864*D1*Dd*f*g2*r*s + 5148*D1*Dd*f*g2*r - 3432*D1*Dd*f*g2*s**2 + 5148*D1*Dd*f*g2*s - 2574*D1*Dd*f*g2 - 3500*D1*Ddd*f**3*r**2 - 7000*D1*Ddd*f**3*r*s + 5250*D1*Ddd*f**3*r - 3500*D1*Ddd*f**3*s**2 + 5250*D1*Ddd*f**3*s - 2625*D1*Ddd*f**3 + 1040*D1*Ddd*f**2*r**2 + 2080*D1*Ddd*f**2*r*s - 1560*D1*Ddd*f**2*r + 1040*D1*Ddd*f**2*s**2 - 1560*D1*Ddd*f**2*s + 780*D1*Ddd*f**2 + 429*D1*b1*(K - 1)*(D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 10500*Dd**2*f**3*r**2 - 21000*Dd**2*f**3*r*s + 15750*Dd**2*f**3*r - 10500*Dd**2*f**3*s**2 + 15750*Dd**2*f**3*s - 5250*Dd**2*f**3 + 3120*Dd**2*f**2*r**2 + 6240*Dd**2*f**2*r*s - 4680*Dd**2*f**2*r + 3120*Dd**2*f**2*s**2 - 4680*Dd**2*f**2*s + 1560*Dd**2*f**2)/(1001*d**2*k3**8) - 32*D1**2*Pk2*Pk3*ct**3*f*k1**3*k2*st**4*(D1**2*(5*f**2*(521*fd - 280*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - f*(1400*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - fd*(780*C - 780)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(390*C - 390)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-429*K*bd1 + 429*bd1 + 858*gd2)) - 78*fd*(fd*(5*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 11*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1))) + 429*D1*b1*(K - 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*f*(Dd*(2605*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 20*f*(39*C*(r*(4*s - 1) + (1 - 2*s)**2) - 140*fd*(4*s - 1)*(4*r + 4*s - 3) - 39*r*(4*s - 1) - 39*(1 - 2*s)**2) - 78*fd*(5*C - 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 858*g2*(r*(4*s - 1) + (1 - 2*s)**2)) - 10*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(39*C + 140*f - 39)) - 10*Dd**2*f**2*(39*C + 140*f - 39)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k3**6) - 80*D1**2*Pk2*Pk3*ct**3*f*k1**3*st**4*(D1**2*(105*f**2*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 630*f*fd**2*s*(2*s - 1) + f*fd*(52*C - 52)*(3*s**2 - 2*s + 1) - f*fdd*(26*C - 26)*(3*s**2 - 2*s + 1) - fd**2*s*(52*C - 52)*(3*s - 2)) + D1*f*(2*Dd*(105*f**2*(4*s**2 - 2*s + 1) + f*(26*C*(4*s**2 - 2*s + 1) - 105*fd*(1 - 4*s)**2 - 104*s**2 + 52*s - 26) - fd*(26*C - 26)*(12*s**2 - 7*s + 1)) - Ddd*f*(26*C + 105*f - 26)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(26*C + 105*f - 26))/(1001*d**2*k2*k3**4) + 40*D1**2*Pk2*Pk3*ct**3*f*k1*k2**5*st**4*(-7*D1**2*bdd1*f**2*(r + s - 1)**2 + 14*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + (-12*C + 7*b1 + 9)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**8) + 40*D1**2*Pk2*Pk3*ct**3*f*k1*k2**3*st**4*(48*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*s**2 + 128*C*D1**2*f*fd*s - 32*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*s**2 - 64*C*D1**2*f*fdd*s + 16*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r**2 + 96*C*D1**2*fd**2*r*s + 144*C*D1**2*fd**2*s**2 - 128*C*D1**2*fd**2*s + 16*C*D1**2*fd**2 + 64*C*D1*Dd*f**2*r**2 - 128*C*D1*Dd*f**2*r*s - 32*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 16*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s + 48*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 496*C*D1*Dd*f*fd*s + 64*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r**2 + 64*C*D1*Ddd*f**2*r*s + 16*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 8*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r**2 + 192*C*Dd**2*f**2*r*s + 48*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 16*C*Dd**2*f**2 - 42*D1**2*b1*f*fd*r**2 + 28*D1**2*b1*f*fd*r + 42*D1**2*b1*f*fd*s**2 - 28*D1**2*b1*f*fd*s + 21*D1**2*b1*f*fdd*r**2 - 14*D1**2*b1*f*fdd*r - 21*D1**2*b1*f*fdd*s**2 + 14*D1**2*b1*f*fdd*s + 42*D1**2*b1*fd**2*r**2 - 28*D1**2*b1*fd**2*r - 42*D1**2*b1*fd**2*s**2 + 28*D1**2*b1*fd**2*s + 7*D1**2*bdd1*f**2*(r**2 - 2*r - s**2 + 1) + 56*D1**2*f**2*fd*r**2 + 56*D1**2*f**2*fd*r*s - 70*D1**2*f**2*fd*r - 28*D1**2*f**2*fd*s + 28*D1**2*f**2*fd - 56*D1**2*f**2*fdd*r**2 - 56*D1**2*f**2*fdd*r*s + 70*D1**2*f**2*fdd*r + 28*D1**2*f**2*fdd*s - 28*D1**2*f**2*fdd - 168*D1**2*f*fd**2*r**2 - 168*D1**2*f*fd**2*r*s + 210*D1**2*f*fd**2*r + 84*D1**2*f*fd**2*s - 56*D1**2*f*fd**2 - 66*D1**2*f*fd*r**2 + 24*D1**2*f*fd*r*s + 36*D1**2*f*fd*r + 90*D1**2*f*fd*s**2 - 68*D1**2*f*fd*s + 8*D1**2*f*fd + 33*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r - 45*D1**2*f*fdd*s**2 + 34*D1**2*f*fdd*s - 4*D1**2*f*fdd + 66*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s - 36*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 68*D1**2*fd**2*s - 4*D1**2*fd**2 - 56*D1*Dd*b1*f**2*r**2 + 56*D1*Dd*b1*f**2*r + 56*D1*Dd*b1*f**2*s**2 - 28*D1*Dd*b1*f**2*s - 14*D1*Dd*b1*f**2 + 168*D1*Dd*b1*f*fd*r**2 - 140*D1*Dd*b1*f*fd*r - 168*D1*Dd*b1*f*fd*s**2 + 98*D1*Dd*b1*f*fd*s + 14*D1*Dd*b1*f*fd + 56*D1*Dd*f**3*r**2 + 56*D1*Dd*f**3*r*s - 70*D1*Dd*f**3*r - 28*D1*Dd*f**3*s + 28*D1*Dd*f**3 - 448*D1*Dd*f**2*fd*r**2 - 448*D1*Dd*f**2*fd*r*s + 560*D1*Dd*f**2*fd*r + 224*D1*Dd*f**2*fd*s - 168*D1*Dd*f**2*fd - 88*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s + 80*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 76*D1*Dd*f**2*s - 14*D1*Dd*f**2 + 264*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s - 192*D1*Dd*f*fd*r - 360*D1*Dd*f*fd*s**2 + 250*D1*Dd*f*fd*s + 2*D1*Dd*f*fd + 28*D1*Ddd*b1*f**2*r**2 - 28*D1*Ddd*b1*f**2*r - 28*D1*Ddd*b1*f**2*s**2 + 14*D1*Ddd*b1*f**2*s + 7*D1*Ddd*b1*f**2 - 56*D1*Ddd*f**3*r**2 - 56*D1*Ddd*f**3*r*s + 70*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s - 28*D1*Ddd*f**3 + 44*D1*Ddd*f**2*r**2 - 16*D1*Ddd*f**2*r*s - 40*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 38*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 - 14*D1*bd1*f*(D1*f*(r**2 - 2*r - s**2 + 1) - D1*fd*(3*r**2 - 4*r - 3*s**2 + s + 1) - Dd*f*(4*r**2 - 6*r - 4*s**2 + s + 2)) + 84*Dd**2*b1*f**2*r**2 - 84*Dd**2*b1*f**2*r - 84*Dd**2*b1*f**2*s**2 + 42*Dd**2*b1*f**2*s + 14*Dd**2*b1*f**2 - 168*Dd**2*f**3*r**2 - 168*Dd**2*f**3*r*s + 210*Dd**2*f**3*r + 84*Dd**2*f**3*s - 56*Dd**2*f**3 + 132*Dd**2*f**2*r**2 - 48*Dd**2*f**2*r*s - 120*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 114*Dd**2*f**2*s + 14*Dd**2*f**2)/(231*d**2*k3**6) - 40*D1**2*Pk2*Pk3*ct**3*f*k1*st**4*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) + 2*f*fd*(7*b1*(3*s**2 - 2*s + 1) + s**2*(9 - 21*bd1) + s*(7*bd1 - 6) + 3) - f*fdd*(7*b1 + 3)*(3*s**2 - 2*s + 1) - fd**2*s*(14*b1 + 6)*(3*s - 2)) + D1*f*(2*Dd*f*(7*b1*(4*s**2 - 2*s + 1) - s**2*(28*bd1 - 12) + s*(7*bd1 - 6) + 3) - Dd*fd*(14*b1 + 6)*(12*s**2 - 7*s + 1) - Ddd*f*(7*b1 + 3)*(4*s**2 - 2*s + 1)) + Dd**2*f**2*s*(-42*b1 - 18)*(2*s - 1))/(77*d**2*k2*k3**2) + D1**2*Pk2*Pk3*ct**3*f*k2**5*st**2*(64*C - 32)*(D1**2*(f*(7*fd - 20*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 20*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(7*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 20*fd*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) - 20*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 20*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4))/(693*d**2*k1*k3**6) - 8*D1**2*Pk2*Pk3*ct**3*k1**5*k2*st**2*(13104*C*D1**2*f**2*fd*r**2 + 26208*C*D1**2*f**2*fd*r*s - 17472*C*D1**2*f**2*fd*r + 13104*C*D1**2*f**2*fd*s**2 - 17472*C*D1**2*f**2*fd*s + 8736*C*D1**2*f**2*fd - 11700*C*D1**2*f**2*fdd*r**2 - 23400*C*D1**2*f**2*fdd*r*s + 15600*C*D1**2*f**2*fdd*r - 11700*C*D1**2*f**2*fdd*s**2 + 15600*C*D1**2*f**2*fdd*s - 7800*C*D1**2*f**2*fdd - 23400*C*D1**2*f*fd**2*r**2 - 46800*C*D1**2*f*fd**2*r*s + 31200*C*D1**2*f*fd**2*r - 23400*C*D1**2*f*fd**2*s**2 + 31200*C*D1**2*f*fd**2*s - 7800*C*D1**2*f*fd**2 + 17472*C*D1*Dd*f**3*r**2 + 34944*C*D1*Dd*f**3*r*s - 26208*C*D1*Dd*f**3*r + 17472*C*D1*Dd*f**3*s**2 - 26208*C*D1*Dd*f**3*s + 13104*C*D1*Dd*f**3 - 93600*C*D1*Dd*f**2*fd*r**2 - 187200*C*D1*Dd*f**2*fd*r*s + 132600*C*D1*Dd*f**2*fd*r - 93600*C*D1*Dd*f**2*fd*s**2 + 132600*C*D1*Dd*f**2*fd*s - 46800*C*D1*Dd*f**2*fd - 15600*C*D1*Ddd*f**3*r**2 - 31200*C*D1*Ddd*f**3*r*s + 23400*C*D1*Ddd*f**3*r - 15600*C*D1*Ddd*f**3*s**2 + 23400*C*D1*Ddd*f**3*s - 11700*C*D1*Ddd*f**3 - 46800*C*Dd**2*f**3*r**2 - 93600*C*Dd**2*f**3*r*s + 70200*C*Dd**2*f**3*r - 46800*C*Dd**2*f**3*s**2 + 70200*C*Dd**2*f**3*s - 23400*C*Dd**2*f**3 + 6864*D1**2*K*b1*f*fd*r**2 + 13728*D1**2*K*b1*f*fd*r*s - 6864*D1**2*K*b1*f*fd*r + 6864*D1**2*K*b1*f*fd*s**2 - 6864*D1**2*K*b1*f*fd*s + 3432*D1**2*K*b1*f*fd - 5148*D1**2*K*b1*f*fdd*r**2 - 10296*D1**2*K*b1*f*fdd*r*s + 5148*D1**2*K*b1*f*fdd*r - 5148*D1**2*K*b1*f*fdd*s**2 + 5148*D1**2*K*b1*f*fdd*s - 2574*D1**2*K*b1*f*fdd - 5148*D1**2*K*b1*fd**2*r**2 - 10296*D1**2*K*b1*fd**2*r*s + 5148*D1**2*K*b1*fd**2*r - 5148*D1**2*K*b1*fd**2*s**2 + 5148*D1**2*K*b1*fd**2*s - 6864*D1**2*b1*f*fd*r**2 - 13728*D1**2*b1*f*fd*r*s + 6864*D1**2*b1*f*fd*r - 6864*D1**2*b1*f*fd*s**2 + 6864*D1**2*b1*f*fd*s - 3432*D1**2*b1*f*fd + 5148*D1**2*b1*f*fdd*r**2 + 10296*D1**2*b1*f*fdd*r*s - 5148*D1**2*b1*f*fdd*r + 5148*D1**2*b1*f*fdd*s**2 - 5148*D1**2*b1*f*fdd*s + 2574*D1**2*b1*f*fdd + 5148*D1**2*b1*fd**2*r**2 + 10296*D1**2*b1*fd**2*r*s - 5148*D1**2*b1*fd**2*r + 5148*D1**2*b1*fd**2*s**2 - 5148*D1**2*b1*fd**2*s - 2574*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 55100*D1**2*f**3*fd*r**2 + 110200*D1**2*f**3*fd*r*s - 82650*D1**2*f**3*fd*r + 55100*D1**2*f**3*fd*s**2 - 82650*D1**2*f**3*fd*s + 41325*D1**2*f**3*fd - 49000*D1**2*f**3*fdd*r**2 - 98000*D1**2*f**3*fdd*r*s + 73500*D1**2*f**3*fdd*r - 49000*D1**2*f**3*fdd*s**2 + 73500*D1**2*f**3*fdd*s - 36750*D1**2*f**3*fdd - 147000*D1**2*f**2*fd**2*r**2 - 294000*D1**2*f**2*fd**2*r*s + 220500*D1**2*f**2*fd**2*r - 147000*D1**2*f**2*fd**2*s**2 + 220500*D1**2*f**2*fd**2*s - 73500*D1**2*f**2*fd**2 - 13104*D1**2*f**2*fd*r**2 - 26208*D1**2*f**2*fd*r*s + 17472*D1**2*f**2*fd*r - 13104*D1**2*f**2*fd*s**2 + 17472*D1**2*f**2*fd*s - 8736*D1**2*f**2*fd + 11700*D1**2*f**2*fdd*r**2 + 23400*D1**2*f**2*fdd*r*s - 15600*D1**2*f**2*fdd*r + 11700*D1**2*f**2*fdd*s**2 - 15600*D1**2*f**2*fdd*s + 7800*D1**2*f**2*fdd - 6864*D1**2*f**2*gd2*r**2 - 13728*D1**2*f**2*gd2*r*s + 13728*D1**2*f**2*gd2*r - 6864*D1**2*f**2*gd2*s**2 + 13728*D1**2*f**2*gd2*s - 6864*D1**2*f**2*gd2 + 5148*D1**2*f**2*gdd2*r**2 + 10296*D1**2*f**2*gdd2*r*s - 10296*D1**2*f**2*gdd2*r + 5148*D1**2*f**2*gdd2*s**2 - 10296*D1**2*f**2*gdd2*s + 5148*D1**2*f**2*gdd2 + 23400*D1**2*f*fd**2*r**2 + 46800*D1**2*f*fd**2*r*s - 31200*D1**2*f*fd**2*r + 23400*D1**2*f*fd**2*s**2 - 31200*D1**2*f*fd**2*s + 7800*D1**2*f*fd**2 - 13728*D1**2*f*fd*g2*r**2 - 27456*D1**2*f*fd*g2*r*s + 13728*D1**2*f*fd*g2*r - 13728*D1**2*f*fd*g2*s**2 + 13728*D1**2*f*fd*g2*s - 6864*D1**2*f*fd*g2 + 20592*D1**2*f*fd*gd2*r**2 + 41184*D1**2*f*fd*gd2*r*s - 30888*D1**2*f*fd*gd2*r + 20592*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 10296*D1**2*f*fd*gd2 + 10296*D1**2*f*fdd*g2*r**2 + 20592*D1**2*f*fdd*g2*r*s - 10296*D1**2*f*fdd*g2*r + 10296*D1**2*f*fdd*g2*s**2 - 10296*D1**2*f*fdd*g2*s + 5148*D1**2*f*fdd*g2 + 10296*D1**2*fd**2*g2*r**2 + 20592*D1**2*fd**2*g2*r*s - 10296*D1**2*fd**2*g2*r + 10296*D1**2*fd**2*g2*s**2 - 10296*D1**2*fd**2*g2*s + 13728*D1*Dd*K*b1*f**2*r**2 + 27456*D1*Dd*K*b1*f**2*r*s - 20592*D1*Dd*K*b1*f**2*r + 13728*D1*Dd*K*b1*f**2*s**2 - 20592*D1*Dd*K*b1*f**2*s + 10296*D1*Dd*K*b1*f**2 - 41184*D1*Dd*K*b1*f*fd*r**2 - 82368*D1*Dd*K*b1*f*fd*r*s + 51480*D1*Dd*K*b1*f*fd*r - 41184*D1*Dd*K*b1*f*fd*s**2 + 51480*D1*Dd*K*b1*f*fd*s - 15444*D1*Dd*K*b1*f*fd - 13728*D1*Dd*b1*f**2*r**2 - 27456*D1*Dd*b1*f**2*r*s + 20592*D1*Dd*b1*f**2*r - 13728*D1*Dd*b1*f**2*s**2 + 20592*D1*Dd*b1*f**2*s - 10296*D1*Dd*b1*f**2 + 41184*D1*Dd*b1*f*fd*r**2 + 82368*D1*Dd*b1*f*fd*r*s - 51480*D1*Dd*b1*f*fd*r + 41184*D1*Dd*b1*f*fd*s**2 - 51480*D1*Dd*b1*f*fd*s + 15444*D1*Dd*b1*f*fd + 55100*D1*Dd*f**4*r**2 + 110200*D1*Dd*f**4*r*s - 82650*D1*Dd*f**4*r + 55100*D1*Dd*f**4*s**2 - 82650*D1*Dd*f**4*s + 41325*D1*Dd*f**4 - 392000*D1*Dd*f**3*fd*r**2 - 784000*D1*Dd*f**3*fd*r*s + 588000*D1*Dd*f**3*fd*r - 392000*D1*Dd*f**3*fd*s**2 + 588000*D1*Dd*f**3*fd*s - 220500*D1*Dd*f**3*fd - 17472*D1*Dd*f**3*r**2 - 34944*D1*Dd*f**3*r*s + 26208*D1*Dd*f**3*r - 17472*D1*Dd*f**3*s**2 + 26208*D1*Dd*f**3*s - 13104*D1*Dd*f**3 + 93600*D1*Dd*f**2*fd*r**2 + 187200*D1*Dd*f**2*fd*r*s - 132600*D1*Dd*f**2*fd*r + 93600*D1*Dd*f**2*fd*s**2 - 132600*D1*Dd*f**2*fd*s + 46800*D1*Dd*f**2*fd - 27456*D1*Dd*f**2*g2*r**2 - 54912*D1*Dd*f**2*g2*r*s + 41184*D1*Dd*f**2*g2*r - 27456*D1*Dd*f**2*g2*s**2 + 41184*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*g2 + 41184*D1*Dd*f**2*gd2*r**2 + 82368*D1*Dd*f**2*gd2*r*s - 72072*D1*Dd*f**2*gd2*r + 41184*D1*Dd*f**2*gd2*s**2 - 72072*D1*Dd*f**2*gd2*s + 30888*D1*Dd*f**2*gd2 + 82368*D1*Dd*f*fd*g2*r**2 + 164736*D1*Dd*f*fd*g2*r*s - 102960*D1*Dd*f*fd*g2*r + 82368*D1*Dd*f*fd*g2*s**2 - 102960*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 10296*D1*Ddd*K*b1*f**2*r**2 - 20592*D1*Ddd*K*b1*f**2*r*s + 15444*D1*Ddd*K*b1*f**2*r - 10296*D1*Ddd*K*b1*f**2*s**2 + 15444*D1*Ddd*K*b1*f**2*s - 7722*D1*Ddd*K*b1*f**2 + 10296*D1*Ddd*b1*f**2*r**2 + 20592*D1*Ddd*b1*f**2*r*s - 15444*D1*Ddd*b1*f**2*r + 10296*D1*Ddd*b1*f**2*s**2 - 15444*D1*Ddd*b1*f**2*s + 7722*D1*Ddd*b1*f**2 - 49000*D1*Ddd*f**4*r**2 - 98000*D1*Ddd*f**4*r*s + 73500*D1*Ddd*f**4*r - 49000*D1*Ddd*f**4*s**2 + 73500*D1*Ddd*f**4*s - 36750*D1*Ddd*f**4 + 15600*D1*Ddd*f**3*r**2 + 31200*D1*Ddd*f**3*r*s - 23400*D1*Ddd*f**3*r + 15600*D1*Ddd*f**3*s**2 - 23400*D1*Ddd*f**3*s + 11700*D1*Ddd*f**3 + 20592*D1*Ddd*f**2*g2*r**2 + 41184*D1*Ddd*f**2*g2*r*s - 30888*D1*Ddd*f**2*g2*r + 20592*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 15444*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 3*D1*fd*(2*r + 2*s - 1) - 3*Dd*f*(4*r + 4*s - 3)) - 30888*Dd**2*K*b1*f**2*r**2 - 61776*Dd**2*K*b1*f**2*r*s + 46332*Dd**2*K*b1*f**2*r - 30888*Dd**2*K*b1*f**2*s**2 + 46332*Dd**2*K*b1*f**2*s - 15444*Dd**2*K*b1*f**2 + 30888*Dd**2*b1*f**2*r**2 + 61776*Dd**2*b1*f**2*r*s - 46332*Dd**2*b1*f**2*r + 30888*Dd**2*b1*f**2*s**2 - 46332*Dd**2*b1*f**2*s + 15444*Dd**2*b1*f**2 - 147000*Dd**2*f**4*r**2 - 294000*Dd**2*f**4*r*s + 220500*Dd**2*f**4*r - 147000*Dd**2*f**4*s**2 + 220500*Dd**2*f**4*s - 73500*Dd**2*f**4 + 46800*Dd**2*f**3*r**2 + 93600*Dd**2*f**3*r*s - 70200*Dd**2*f**3*r + 46800*Dd**2*f**3*s**2 - 70200*Dd**2*f**3*s + 23400*Dd**2*f**3 + 61776*Dd**2*f**2*g2*r**2 + 123552*Dd**2*f**2*g2*r*s - 92664*Dd**2*f**2*g2*r + 61776*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 30888*Dd**2*f**2*g2)/(3003*d**2*k3**8) + 8*D1**2*Pk2*Pk3*ct**3*k1**5*k2*(1320*C*D1**2*bdd1*f**2*r**2 + 2640*C*D1**2*bdd1*f**2*r*s - 2640*C*D1**2*bdd1*f**2*r + 1320*C*D1**2*bdd1*f**2*s**2 - 2640*C*D1**2*bdd1*f**2*s + 1320*C*D1**2*bdd1*f**2 - 1380*C*D1**2*f**2*fd*r**2 - 2760*C*D1**2*f**2*fd*r*s + 1840*C*D1**2*f**2*fd*r - 1380*C*D1**2*f**2*fd*s**2 + 1840*C*D1**2*f**2*fd*s - 920*C*D1**2*f**2*fd + 1680*C*D1**2*f**2*fdd*r**2 + 3360*C*D1**2*f**2*fdd*r*s - 2240*C*D1**2*f**2*fdd*r + 1680*C*D1**2*f**2*fdd*s**2 - 2240*C*D1**2*f**2*fdd*s + 1120*C*D1**2*f**2*fdd + 3360*C*D1**2*f*fd**2*r**2 + 6720*C*D1**2*f*fd**2*r*s - 4480*C*D1**2*f*fd**2*r + 3360*C*D1**2*f*fd**2*s**2 - 4480*C*D1**2*f*fd**2*s + 1120*C*D1**2*f*fd**2 - 1840*C*D1*Dd*f**3*r**2 - 3680*C*D1*Dd*f**3*r*s + 2760*C*D1*Dd*f**3*r - 1840*C*D1*Dd*f**3*s**2 + 2760*C*D1*Dd*f**3*s - 1380*C*D1*Dd*f**3 + 13440*C*D1*Dd*f**2*fd*r**2 + 26880*C*D1*Dd*f**2*fd*r*s - 19040*C*D1*Dd*f**2*fd*r + 13440*C*D1*Dd*f**2*fd*s**2 - 19040*C*D1*Dd*f**2*fd*s + 6720*C*D1*Dd*f**2*fd + 2240*C*D1*Ddd*f**3*r**2 + 4480*C*D1*Ddd*f**3*r*s - 3360*C*D1*Ddd*f**3*r + 2240*C*D1*Ddd*f**3*s**2 - 3360*C*D1*Ddd*f**3*s + 1680*C*D1*Ddd*f**3 + 6720*C*Dd**2*f**3*r**2 + 13440*C*Dd**2*f**3*r*s - 10080*C*Dd**2*f**3*r + 6720*C*Dd**2*f**3*s**2 - 10080*C*Dd**2*f**3*s + 3360*C*Dd**2*f**3 + 330*D1**2*K*bdd1*f**2*r**2 + 660*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*r + 330*D1**2*K*bdd1*f**2*s**2 - 660*D1**2*K*bdd1*f**2*s + 330*D1**2*K*bdd1*f**2 + 1584*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 700*D1**2*bdd1*f**3*r**2 + 1400*D1**2*bdd1*f**3*r*s - 1400*D1**2*bdd1*f**3*r + 700*D1**2*bdd1*f**3*s**2 - 1400*D1**2*bdd1*f**3*s + 700*D1**2*bdd1*f**3 - 1485*D1**2*bdd1*f**2*r**2 - 2970*D1**2*bdd1*f**2*r*s + 2970*D1**2*bdd1*f**2*r - 1485*D1**2*bdd1*f**2*s**2 + 2970*D1**2*bdd1*f**2*s - 1485*D1**2*bdd1*f**2 - 1584*D1**2*bdd1*f*g2*r**2 - 3168*D1**2*bdd1*f*g2*r*s + 3168*D1**2*bdd1*f*g2*r - 1584*D1**2*bdd1*f*g2*s**2 + 3168*D1**2*bdd1*f*g2*s - 1584*D1**2*bdd1*f*g2 + 560*D1**2*f**3*fd*r**2 + 1120*D1**2*f**3*fd*r*s - 840*D1**2*f**3*fd*r + 560*D1**2*f**3*fd*s**2 - 840*D1**2*f**3*fd*s + 420*D1**2*f**3*fd + 1035*D1**2*f**2*fd*r**2 + 2070*D1**2*f**2*fd*r*s - 1380*D1**2*f**2*fd*r + 1035*D1**2*f**2*fd*s**2 - 1380*D1**2*f**2*fd*s + 690*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r**2 - 2520*D1**2*f**2*fdd*r*s + 1680*D1**2*f**2*fdd*r - 1260*D1**2*f**2*fdd*s**2 + 1680*D1**2*f**2*fdd*s - 840*D1**2*f**2*fdd + 528*D1**2*f**2*gd2*r**2 + 1056*D1**2*f**2*gd2*r*s - 1056*D1**2*f**2*gd2*r + 528*D1**2*f**2*gd2*s**2 - 1056*D1**2*f**2*gd2*s + 528*D1**2*f**2*gd2 - 660*D1**2*f**2*gdd2*r**2 - 1320*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*r - 660*D1**2*f**2*gdd2*s**2 + 1320*D1**2*f**2*gdd2*s - 660*D1**2*f**2*gdd2 - 2520*D1**2*f*fd**2*r**2 - 5040*D1**2*f*fd**2*r*s + 3360*D1**2*f*fd**2*r - 2520*D1**2*f*fd**2*s**2 + 3360*D1**2*f*fd**2*s - 840*D1**2*f*fd**2 + 1056*D1**2*f*fd*g2*r**2 + 2112*D1**2*f*fd*g2*r*s - 1056*D1**2*f*fd*g2*r + 1056*D1**2*f*fd*g2*s**2 - 1056*D1**2*f*fd*g2*s + 528*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r**2 - 5280*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r - 2640*D1**2*f*fd*gd2*s**2 + 3960*D1**2*f*fd*gd2*s - 1320*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r**2 - 2640*D1**2*f*fdd*g2*r*s + 1320*D1**2*f*fdd*g2*r - 1320*D1**2*f*fdd*g2*s**2 + 1320*D1**2*f*fdd*g2*s - 660*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r**2 - 2640*D1**2*fd**2*g2*r*s + 1320*D1**2*fd**2*g2*r - 1320*D1**2*fd**2*g2*s**2 + 1320*D1**2*fd**2*g2*s + 560*D1*Dd*f**4*r**2 + 1120*D1*Dd*f**4*r*s - 840*D1*Dd*f**4*r + 560*D1*Dd*f**4*s**2 - 840*D1*Dd*f**4*s + 420*D1*Dd*f**4 + 1380*D1*Dd*f**3*r**2 + 2760*D1*Dd*f**3*r*s - 2070*D1*Dd*f**3*r + 1380*D1*Dd*f**3*s**2 - 2070*D1*Dd*f**3*s + 1035*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r**2 - 20160*D1*Dd*f**2*fd*r*s + 14280*D1*Dd*f**2*fd*r - 10080*D1*Dd*f**2*fd*s**2 + 14280*D1*Dd*f**2*fd*s - 5040*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*g2*r**2 + 4224*D1*Dd*f**2*g2*r*s - 3168*D1*Dd*f**2*g2*r + 2112*D1*Dd*f**2*g2*s**2 - 3168*D1*Dd*f**2*g2*s + 1584*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r**2 - 10560*D1*Dd*f**2*gd2*r*s + 9240*D1*Dd*f**2*gd2*r - 5280*D1*Dd*f**2*gd2*s**2 + 9240*D1*Dd*f**2*gd2*s - 3960*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r**2 - 21120*D1*Dd*f*fd*g2*r*s + 13200*D1*Dd*f*fd*g2*r - 10560*D1*Dd*f*fd*g2*s**2 + 13200*D1*Dd*f*fd*g2*s - 3960*D1*Dd*f*fd*g2 - 1680*D1*Ddd*f**3*r**2 - 3360*D1*Ddd*f**3*r*s + 2520*D1*Ddd*f**3*r - 1680*D1*Ddd*f**3*s**2 + 2520*D1*Ddd*f**3*s - 1260*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r**2 - 5280*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r - 2640*D1*Ddd*f**2*g2*s**2 + 3960*D1*Ddd*f**2*g2*s - 1980*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(370*f**3*(r + s - 1) + 2*f**2*(264*C*(r + s - 1) - 350*fd*(3*r + 3*s - 2) + (66*K - 297)*(r + s - 1)) - 33*f*(5*fd*(8*C + 2*K - 9)*(2*r + 2*s - 1) + (20*g2 - 48*gd2)*(r + s - 1)) + 1584*fd*g2*(r + s)) - Dd*f*(700*f**2 + 165*f*(8*C + 2*K - 9) - 1584*g2)*(4*r + 4*s - 3))*(r + s - 1) - 5040*Dd**2*f**3*r**2 - 10080*Dd**2*f**3*r*s + 7560*Dd**2*f**3*r - 5040*Dd**2*f**3*s**2 + 7560*Dd**2*f**3*s - 2520*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r**2 - 15840*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r - 7920*Dd**2*f**2*g2*s**2 + 11880*Dd**2*f**2*g2*s - 3960*Dd**2*f**2*g2 - 132*b1**2*(K - 1)*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-2112*C*D1**2*f*fd*r**2 - 4224*C*D1**2*f*fd*r*s + 2112*C*D1**2*f*fd*r - 2112*C*D1**2*f*fd*s**2 + 2112*C*D1**2*f*fd*s - 1056*C*D1**2*f*fd + 2640*C*D1**2*f*fdd*r**2 + 5280*C*D1**2*f*fdd*r*s - 2640*C*D1**2*f*fdd*r + 2640*C*D1**2*f*fdd*s**2 - 2640*C*D1**2*f*fdd*s + 1320*C*D1**2*f*fdd + 2640*C*D1**2*fd**2*r**2 + 5280*C*D1**2*fd**2*r*s - 2640*C*D1**2*fd**2*r + 2640*C*D1**2*fd**2*s**2 - 2640*C*D1**2*fd**2*s - 4224*C*D1*Dd*f**2*r**2 - 8448*C*D1*Dd*f**2*r*s + 6336*C*D1*Dd*f**2*r - 4224*C*D1*Dd*f**2*s**2 + 6336*C*D1*Dd*f**2*s - 3168*C*D1*Dd*f**2 + 21120*C*D1*Dd*f*fd*r**2 + 42240*C*D1*Dd*f*fd*r*s - 26400*C*D1*Dd*f*fd*r + 21120*C*D1*Dd*f*fd*s**2 - 26400*C*D1*Dd*f*fd*s + 7920*C*D1*Dd*f*fd + 5280*C*D1*Ddd*f**2*r**2 + 10560*C*D1*Ddd*f**2*r*s - 7920*C*D1*Ddd*f**2*r + 5280*C*D1*Ddd*f**2*s**2 - 7920*C*D1*Ddd*f**2*s + 3960*C*D1*Ddd*f**2 + 15840*C*Dd**2*f**2*r**2 + 31680*C*Dd**2*f**2*r*s - 23760*C*Dd**2*f**2*r + 15840*C*Dd**2*f**2*s**2 - 23760*C*Dd**2*f**2*s + 7920*C*Dd**2*f**2 - 528*D1**2*K*f*fd*r**2 - 1056*D1**2*K*f*fd*r*s + 528*D1**2*K*f*fd*r - 528*D1**2*K*f*fd*s**2 + 528*D1**2*K*f*fd*s - 264*D1**2*K*f*fd + 660*D1**2*K*f*fdd*r**2 + 1320*D1**2*K*f*fdd*r*s - 660*D1**2*K*f*fdd*r + 660*D1**2*K*f*fdd*s**2 - 660*D1**2*K*f*fdd*s + 330*D1**2*K*f*fdd + 660*D1**2*K*fd**2*r**2 + 1320*D1**2*K*fd**2*r*s - 660*D1**2*K*fd**2*r + 660*D1**2*K*fd**2*s**2 - 660*D1**2*K*fd**2*s + 1584*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 2220*D1**2*f**2*fd*r**2 - 4440*D1**2*f**2*fd*r*s + 2960*D1**2*f**2*fd*r - 2220*D1**2*f**2*fd*s**2 + 2960*D1**2*f**2*fd*s - 1480*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 + 2376*D1**2*f*fd*r**2 + 4752*D1**2*f*fd*r*s - 2376*D1**2*f*fd*r + 2376*D1**2*f*fd*s**2 - 2376*D1**2*f*fd*s + 1188*D1**2*f*fd - 2970*D1**2*f*fdd*r**2 - 5940*D1**2*f*fdd*r*s + 2970*D1**2*f*fdd*r - 2970*D1**2*f*fdd*s**2 + 2970*D1**2*f*fdd*s - 1485*D1**2*f*fdd + 1320*D1**2*f*gd2*r**2 + 2640*D1**2*f*gd2*r*s - 2640*D1**2*f*gd2*r + 1320*D1**2*f*gd2*s**2 - 2640*D1**2*f*gd2*s + 1320*D1**2*f*gd2 - 1584*D1**2*f*gdd2*r**2 - 3168*D1**2*f*gdd2*r*s + 3168*D1**2*f*gdd2*r - 1584*D1**2*f*gdd2*s**2 + 3168*D1**2*f*gdd2*s - 1584*D1**2*f*gdd2 - 2970*D1**2*fd**2*r**2 - 5940*D1**2*fd**2*r*s + 2970*D1**2*fd**2*r - 2970*D1**2*fd**2*s**2 + 2970*D1**2*fd**2*s + 1320*D1**2*fd*g2*r**2 + 2640*D1**2*fd*g2*r*s + 1320*D1**2*fd*g2*s**2 - 3168*D1**2*fd*gd2*r**2 - 6336*D1**2*fd*gd2*r*s + 3168*D1**2*fd*gd2*r - 3168*D1**2*fd*gd2*s**2 + 3168*D1**2*fd*gd2*s - 1584*D1**2*fdd*g2*r**2 - 3168*D1**2*fdd*g2*r*s - 1584*D1**2*fdd*g2*s**2 - 1056*D1*Dd*K*f**2*r**2 - 2112*D1*Dd*K*f**2*r*s + 1584*D1*Dd*K*f**2*r - 1056*D1*Dd*K*f**2*s**2 + 1584*D1*Dd*K*f**2*s - 792*D1*Dd*K*f**2 + 5280*D1*Dd*K*f*fd*r**2 + 10560*D1*Dd*K*f*fd*r*s - 6600*D1*Dd*K*f*fd*r + 5280*D1*Dd*K*f*fd*s**2 - 6600*D1*Dd*K*f*fd*s + 1980*D1*Dd*K*f*fd - 2960*D1*Dd*f**3*r**2 - 5920*D1*Dd*f**3*r*s + 4440*D1*Dd*f**3*r - 2960*D1*Dd*f**3*s**2 + 4440*D1*Dd*f**3*s - 2220*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 23800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 23800*D1*Dd*f**2*fd*s + 8400*D1*Dd*f**2*fd + 4752*D1*Dd*f**2*r**2 + 9504*D1*Dd*f**2*r*s - 7128*D1*Dd*f**2*r + 4752*D1*Dd*f**2*s**2 - 7128*D1*Dd*f**2*s + 3564*D1*Dd*f**2 - 23760*D1*Dd*f*fd*r**2 - 47520*D1*Dd*f*fd*r*s + 29700*D1*Dd*f*fd*r - 23760*D1*Dd*f*fd*s**2 + 29700*D1*Dd*f*fd*s - 8910*D1*Dd*f*fd + 5280*D1*Dd*f*g2*r**2 + 10560*D1*Dd*f*g2*r*s - 7920*D1*Dd*f*g2*r + 5280*D1*Dd*f*g2*s**2 - 7920*D1*Dd*f*g2*s + 3960*D1*Dd*f*g2 - 12672*D1*Dd*f*gd2*r**2 - 25344*D1*Dd*f*gd2*r*s + 22176*D1*Dd*f*gd2*r - 12672*D1*Dd*f*gd2*s**2 + 22176*D1*Dd*f*gd2*s - 9504*D1*Dd*f*gd2 - 12672*D1*Dd*fd*g2*r**2 - 25344*D1*Dd*fd*g2*r*s + 9504*D1*Dd*fd*g2*r - 12672*D1*Dd*fd*g2*s**2 + 9504*D1*Dd*fd*g2*s + 1320*D1*Ddd*K*f**2*r**2 + 2640*D1*Ddd*K*f**2*r*s - 1980*D1*Ddd*K*f**2*r + 1320*D1*Ddd*K*f**2*s**2 - 1980*D1*Ddd*K*f**2*s + 990*D1*Ddd*K*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 - 5940*D1*Ddd*f**2*r**2 - 11880*D1*Ddd*f**2*r*s + 8910*D1*Ddd*f**2*r - 5940*D1*Ddd*f**2*s**2 + 8910*D1*Ddd*f**2*s - 4455*D1*Ddd*f**2 - 6336*D1*Ddd*f*g2*r**2 - 12672*D1*Ddd*f*g2*r*s + 9504*D1*Ddd*f*g2*r - 6336*D1*Ddd*f*g2*s**2 + 9504*D1*Ddd*f*g2*s - 4752*D1*Ddd*f*g2 - 264*D1*bd1*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 3960*Dd**2*K*f**2*r**2 + 7920*Dd**2*K*f**2*r*s - 5940*Dd**2*K*f**2*r + 3960*Dd**2*K*f**2*s**2 - 5940*Dd**2*K*f**2*s + 1980*Dd**2*K*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3 - 17820*Dd**2*f**2*r**2 - 35640*Dd**2*f**2*r*s + 26730*Dd**2*f**2*r - 17820*Dd**2*f**2*s**2 + 26730*Dd**2*f**2*s - 8910*Dd**2*f**2 - 19008*Dd**2*f*g2*r**2 - 38016*Dd**2*f*g2*r*s + 28512*Dd**2*f*g2*r - 19008*Dd**2*f*g2*s**2 + 28512*Dd**2*f*g2*s - 9504*Dd**2*f*g2))/(231*d**2*k3**8) - 16*D1**2*Pk2*Pk3*ct**3*k1**5*st**2*(9126*C*D1**2*f**2*fd*r*s - 3042*C*D1**2*f**2*fd*r + 9126*C*D1**2*f**2*fd*s**2 - 9126*C*D1**2*f**2*fd*s + 3042*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 12168*C*D1*Dd*f**3*r*s - 3042*C*D1*Dd*f**3*r + 12168*C*D1*Dd*f**3*s**2 - 12168*C*D1*Dd*f**3*s + 3042*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 55000*D1**2*f**3*fd*r*s - 13750*D1**2*f**3*fd*r + 55000*D1**2*f**3*fd*s**2 - 55000*D1**2*f**3*fd*s + 13750*D1**2*f**3*fd - 39200*D1**2*f**3*fdd*r*s + 9800*D1**2*f**3*fdd*r - 39200*D1**2*f**3*fdd*s**2 + 39200*D1**2*f**3*fdd*s - 9800*D1**2*f**3*fdd - 117600*D1**2*f**2*fd**2*r*s + 29400*D1**2*f**2*fd**2*r - 117600*D1**2*f**2*fd**2*s**2 + 117600*D1**2*f**2*fd**2*s - 19600*D1**2*f**2*fd**2 - 9126*D1**2*f**2*fd*r*s + 3042*D1**2*f**2*fd*r - 9126*D1**2*f**2*fd*s**2 + 9126*D1**2*f**2*fd*s - 3042*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*s**2 + 4290*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 8580*D1**2*f*fd*g2*r*s + 4290*D1**2*f*fd*g2*r - 8580*D1**2*f*fd*g2*s**2 + 8580*D1**2*f*fd*g2*s - 4290*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 55000*D1*Dd*f**4*r*s - 13750*D1*Dd*f**4*r + 55000*D1*Dd*f**4*s**2 - 55000*D1*Dd*f**4*s + 13750*D1*Dd*f**4 - 313600*D1*Dd*f**3*fd*r*s + 78400*D1*Dd*f**3*fd*r - 313600*D1*Dd*f**3*fd*s**2 + 313600*D1*Dd*f**3*fd*s - 58800*D1*Dd*f**3*fd - 12168*D1*Dd*f**3*r*s + 3042*D1*Dd*f**3*r - 12168*D1*Dd*f**3*s**2 + 12168*D1*Dd*f**3*s - 3042*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 17160*D1*Dd*f**2*g2*r*s + 4290*D1*Dd*f**2*g2*r - 17160*D1*Dd*f**2*g2*s**2 + 17160*D1*Dd*f**2*g2*s - 4290*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 39200*D1*Ddd*f**4*r*s + 9800*D1*Ddd*f**4*r - 39200*D1*Ddd*f**4*s**2 + 39200*D1*Ddd*f**4*s - 9800*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 117600*Dd**2*f**4*r*s + 29400*Dd**2*f**4*r - 117600*Dd**2*f**4*s**2 + 117600*Dd**2*f**4*s - 19600*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k2*k3**6) + 8*D1**2*Pk2*Pk3*ct**3*k1**5*(660*C*D1**2*bdd1*f**2*r*s - 660*C*D1**2*bdd1*f**2*r + 660*C*D1**2*bdd1*f**2*s**2 - 1320*C*D1**2*bdd1*f**2*s + 660*C*D1**2*bdd1*f**2 + 3360*C*D1**2*f**2*fd*r*s - 1120*C*D1**2*f**2*fd*r + 3360*C*D1**2*f**2*fd*s**2 - 3360*C*D1**2*f**2*fd*s + 1120*C*D1**2*f**2*fd - 3660*C*D1**2*f**2*fdd*r*s + 1220*C*D1**2*f**2*fdd*r - 3660*C*D1**2*f**2*fdd*s**2 + 3660*C*D1**2*f**2*fdd*s - 1220*C*D1**2*f**2*fdd - 7320*C*D1**2*f*fd**2*r*s + 2440*C*D1**2*f*fd**2*r - 7320*C*D1**2*f*fd**2*s**2 + 7320*C*D1**2*f*fd**2*s - 1220*C*D1**2*f*fd**2 + 4480*C*D1*Dd*f**3*r*s - 1120*C*D1*Dd*f**3*r + 4480*C*D1*Dd*f**3*s**2 - 4480*C*D1*Dd*f**3*s + 1120*C*D1*Dd*f**3 - 29280*C*D1*Dd*f**2*fd*r*s + 8540*C*D1*Dd*f**2*fd*r - 29280*C*D1*Dd*f**2*fd*s**2 + 29280*C*D1*Dd*f**2*fd*s - 6100*C*D1*Dd*f**2*fd - 4880*C*D1*Ddd*f**3*r*s + 1220*C*D1*Ddd*f**3*r - 4880*C*D1*Ddd*f**3*s**2 + 4880*C*D1*Ddd*f**3*s - 1220*C*D1*Ddd*f**3 - 14640*C*Dd**2*f**3*r*s + 3660*C*Dd**2*f**3*r - 14640*C*Dd**2*f**3*s**2 + 14640*C*Dd**2*f**3*s - 2440*C*Dd**2*f**3 - 726*D1**2*K*bdd1*f**2*r*s - 726*D1**2*K*bdd1*f**2*s**2 + 726*D1**2*K*bdd1*f**2*s + 396*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 280*D1**2*bdd1*f**3*r**2 + 1400*D1**2*bdd1*f**3*r*s - 1400*D1**2*bdd1*f**3*r + 1120*D1**2*bdd1*f**3*s**2 - 2240*D1**2*bdd1*f**3*s + 1260*D1**2*bdd1*f**3 + 165*D1**2*bdd1*f**2*r**2 + 396*D1**2*bdd1*f**2*r*s + 330*D1**2*bdd1*f**2*r + 231*D1**2*bdd1*f**2*s**2 + 264*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r - 792*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 + 2520*D1**2*f**3*fd*r**2 + 12880*D1**2*f**3*fd*r*s - 5740*D1**2*f**3*fd*r + 10360*D1**2*f**3*fd*s**2 - 11620*D1**2*f**3*fd*s + 3850*D1**2*f**3*fd - 3080*D1**2*f**3*fdd*r**2 - 11760*D1**2*f**3*fdd*r*s + 6020*D1**2*f**3*fdd*r - 8680*D1**2*f**3*fdd*s**2 + 10220*D1**2*f**3*fdd*s - 3710*D1**2*f**3*fdd - 9240*D1**2*f**2*fd**2*r**2 - 35280*D1**2*f**2*fd**2*r*s + 18060*D1**2*f**2*fd**2*r - 26040*D1**2*f**2*fd**2*s**2 + 30660*D1**2*f**2*fd**2*s - 7420*D1**2*f**2*fd**2 - 345*D1**2*f**2*fd*r**2 - 4050*D1**2*f**2*fd*r*s + 1580*D1**2*f**2*fd*r - 3705*D1**2*f**2*fd*s**2 + 3820*D1**2*f**2*fd*s - 1350*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 4500*D1**2*f**2*fdd*r*s - 1780*D1**2*f**2*fdd*r + 4080*D1**2*f**2*fdd*s**2 - 4220*D1**2*f**2*fdd*s + 1500*D1**2*f**2*fdd - 1320*D1**2*f**2*gd2*r*s - 1320*D1**2*f**2*gd2*s**2 + 1320*D1**2*f**2*gd2*s + 1452*D1**2*f**2*gdd2*r*s + 1452*D1**2*f**2*gdd2*s**2 - 1452*D1**2*f**2*gdd2*s + 840*D1**2*f*fd**2*r**2 + 9000*D1**2*f*fd**2*r*s - 3560*D1**2*f*fd**2*r + 8160*D1**2*f*fd**2*s**2 - 8440*D1**2*f*fd**2*s + 1500*D1**2*f*fd**2 - 2640*D1**2*f*fd*g2*r*s + 1320*D1**2*f*fd*g2*r - 2640*D1**2*f*fd*g2*s**2 + 2640*D1**2*f*fd*g2*s - 1320*D1**2*f*fd*g2 + 5808*D1**2*f*fd*gd2*r*s - 1452*D1**2*f*fd*gd2*r + 5808*D1**2*f*fd*gd2*s**2 - 5808*D1**2*f*fd*gd2*s + 1452*D1**2*f*fd*gd2 + 2904*D1**2*f*fdd*g2*r*s - 1452*D1**2*f*fdd*g2*r + 2904*D1**2*f*fdd*g2*s**2 - 2904*D1**2*f*fdd*g2*s + 1452*D1**2*f*fdd*g2 + 2904*D1**2*fd**2*g2*r*s - 1452*D1**2*fd**2*g2*r + 2904*D1**2*fd**2*g2*s**2 - 2904*D1**2*fd**2*g2*s + 2520*D1*Dd*f**4*r**2 + 12880*D1*Dd*f**4*r*s - 5740*D1*Dd*f**4*r + 10360*D1*Dd*f**4*s**2 - 11620*D1*Dd*f**4*s + 3850*D1*Dd*f**4 - 24640*D1*Dd*f**3*fd*r**2 - 94080*D1*Dd*f**3*fd*r*s + 48160*D1*Dd*f**3*fd*r - 69440*D1*Dd*f**3*fd*s**2 + 81760*D1*Dd*f**3*fd*s - 22260*D1*Dd*f**3*fd - 460*D1*Dd*f**3*r**2 - 5400*D1*Dd*f**3*r*s + 1810*D1*Dd*f**3*r - 4940*D1*Dd*f**3*s**2 + 5170*D1*Dd*f**3*s - 1465*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 36000*D1*Dd*f**2*fd*r*s - 13300*D1*Dd*f**2*fd*r + 32640*D1*Dd*f**2*fd*s**2 - 34040*D1*Dd*f**2*fd*s + 7780*D1*Dd*f**2*fd - 5280*D1*Dd*f**2*g2*r*s + 1320*D1*Dd*f**2*g2*r - 5280*D1*Dd*f**2*g2*s**2 + 5280*D1*Dd*f**2*g2*s - 1320*D1*Dd*f**2*g2 + 11616*D1*Dd*f**2*gd2*r*s - 1452*D1*Dd*f**2*gd2*r + 11616*D1*Dd*f**2*gd2*s**2 - 11616*D1*Dd*f**2*gd2*s + 1452*D1*Dd*f**2*gd2 + 23232*D1*Dd*f*fd*g2*r*s - 8712*D1*Dd*f*fd*g2*r + 23232*D1*Dd*f*fd*g2*s**2 - 23232*D1*Dd*f*fd*g2*s + 5808*D1*Dd*f*fd*g2 - 3080*D1*Ddd*f**4*r**2 - 11760*D1*Ddd*f**4*r*s + 6020*D1*Ddd*f**4*r - 8680*D1*Ddd*f**4*s**2 + 10220*D1*Ddd*f**4*s - 3710*D1*Ddd*f**4 + 560*D1*Ddd*f**3*r**2 + 6000*D1*Ddd*f**3*r*s - 2060*D1*Ddd*f**3*r + 5440*D1*Ddd*f**3*s**2 - 5720*D1*Ddd*f**3*s + 1640*D1*Ddd*f**3 + 5808*D1*Ddd*f**2*g2*r*s - 1452*D1*Ddd*f**2*g2*r + 5808*D1*Ddd*f**2*g2*s**2 - 5808*D1*Ddd*f**2*g2*s + 1452*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(5*f**3*(46*r**2 + 296*r*(s - 1) + 250*s**2 - 500*s + 273) + 4*f**2*(132*C*(s - 1)*(r + s - 1) - 70*fd*(6*r**2 + 30*r*s - 19*r + 24*s**2 - 34*s + 9) + (33*r + 33*s - 33)*(-5*K*s + r + 2*s + 3)) - 66*f*(fd*(10*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 11*K*(r*(4*s - 1) + (1 - 2*s)**2) + 10*r**2 + 24*r*s - 6*r + 14*s**2 - 9*s + 6) + (10*g2*(s - 1) + 12*gd2*(1 - 2*s))*(r + s - 1)) + 792*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*Dd*f*(140*f**2*(8*r**2 + r*(40*s - 29) + 32*s**2 - 50*s + 18) + 33*f*(10*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 11*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 20*r**2 + 48*r*s + 4*r + 28*s**2 - 3*s - 14) - 396*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 9240*Dd**2*f**4*r**2 - 35280*Dd**2*f**4*r*s + 18060*Dd**2*f**4*r - 26040*Dd**2*f**4*s**2 + 30660*Dd**2*f**4*s - 7420*Dd**2*f**4 + 1680*Dd**2*f**3*r**2 + 18000*Dd**2*f**3*r*s - 6180*Dd**2*f**3*r + 16320*Dd**2*f**3*s**2 - 17160*Dd**2*f**3*s + 3280*Dd**2*f**3 + 17424*Dd**2*f**2*g2*r*s - 4356*Dd**2*f**2*g2*r + 17424*Dd**2*f**2*g2*s**2 - 17424*Dd**2*f**2*g2*s + 2904*Dd**2*f**2*g2 - 66*b1**2*(K - 1)*(D1**2*s*(5*fd - 6*fdd)*(r + s) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) + 6*fd*(-8*r*s + r + s*(4 - 8*s))) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-1056*C*D1**2*f*fd*r*s - 1056*C*D1**2*f*fd*s**2 + 528*C*D1**2*f*fd*s + 1320*C*D1**2*f*fdd*r*s + 1320*C*D1**2*f*fdd*s**2 - 660*C*D1**2*f*fdd*s + 1320*C*D1**2*fd**2*r*s + 1320*C*D1**2*fd**2*s**2 - 660*C*D1**2*fd**2*s - 2112*C*D1*Dd*f**2*r*s + 528*C*D1*Dd*f**2*r - 2112*C*D1*Dd*f**2*s**2 + 2112*C*D1*Dd*f**2*s - 528*C*D1*Dd*f**2 + 10560*C*D1*Dd*f*fd*r*s - 1320*C*D1*Dd*f*fd*r + 10560*C*D1*Dd*f*fd*s**2 - 7920*C*D1*Dd*f*fd*s + 660*C*D1*Dd*f*fd + 2640*C*D1*Ddd*f**2*r*s - 660*C*D1*Ddd*f**2*r + 2640*C*D1*Ddd*f**2*s**2 - 2640*C*D1*Ddd*f**2*s + 660*C*D1*Ddd*f**2 + 7920*C*Dd**2*f**2*r*s - 1980*C*Dd**2*f**2*r + 7920*C*Dd**2*f**2*s**2 - 7920*C*Dd**2*f**2*s + 1320*C*Dd**2*f**2 + 1320*D1**2*K*f*fd*r*s - 660*D1**2*K*f*fd*r + 1320*D1**2*K*f*fd*s**2 - 1320*D1**2*K*f*fd*s + 660*D1**2*K*f*fd - 1452*D1**2*K*f*fdd*r*s + 726*D1**2*K*f*fdd*r - 1452*D1**2*K*f*fdd*s**2 + 1452*D1**2*K*f*fdd*s - 726*D1**2*K*f*fdd - 1452*D1**2*K*fd**2*r*s + 726*D1**2*K*fd**2*r - 1452*D1**2*K*fd**2*s**2 + 1452*D1**2*K*fd**2*s + 396*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 690*D1**2*f**2*fd*r**2 - 4440*D1**2*f**2*fd*r*s + 920*D1**2*f**2*fd*r - 3750*D1**2*f**2*fd*s**2 + 2960*D1**2*f**2*fd*s - 345*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 1120*D1**2*f**2*fdd*r + 3360*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 420*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 2240*D1**2*f*fd**2*r + 6720*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 792*D1**2*f*fd*r*s + 924*D1**2*f*fd*r - 528*D1**2*f*fd*s**2 + 1056*D1**2*f*fd*s - 792*D1**2*f*fd + 330*D1**2*f*fdd*r**2 + 792*D1**2*f*fdd*r*s - 1056*D1**2*f*fdd*r + 462*D1**2*f*fdd*s**2 - 1122*D1**2*f*fdd*s + 891*D1**2*f*fdd + 660*D1**2*f*gd2*r*s + 660*D1**2*f*gd2*s**2 - 660*D1**2*f*gd2*s - 792*D1**2*f*gdd2*r*s - 792*D1**2*f*gdd2*s**2 + 792*D1**2*f*gdd2*s + 330*D1**2*fd**2*r**2 + 792*D1**2*fd**2*r*s - 1056*D1**2*fd**2*r + 462*D1**2*fd**2*s**2 - 1122*D1**2*fd**2*s + 660*D1**2*fd*g2*r*s + 660*D1**2*fd*g2*s**2 - 1584*D1**2*fd*gd2*r*s - 1584*D1**2*fd*gd2*s**2 + 792*D1**2*fd*gd2*s - 792*D1**2*fdd*g2*r*s - 792*D1**2*fdd*g2*s**2 + 2640*D1*Dd*K*f**2*r*s - 660*D1*Dd*K*f**2*r + 2640*D1*Dd*K*f**2*s**2 - 2640*D1*Dd*K*f**2*s + 660*D1*Dd*K*f**2 - 11616*D1*Dd*K*f*fd*r*s + 4356*D1*Dd*K*f*fd*r - 11616*D1*Dd*K*f*fd*s**2 + 11616*D1*Dd*K*f*fd*s - 2904*D1*Dd*K*f*fd - 920*D1*Dd*f**3*r**2 - 5920*D1*Dd*f**3*r*s + 2400*D1*Dd*f**3*r - 5000*D1*Dd*f**3*s**2 + 5460*D1*Dd*f**3*s - 1710*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 12040*D1*Dd*f**2*fd*r + 26880*D1*Dd*f**2*fd*s**2 - 26320*D1*Dd*f**2*fd*s + 5040*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1584*D1*Dd*f**2*r*s + 924*D1*Dd*f**2*r - 1056*D1*Dd*f**2*s**2 + 1320*D1*Dd*f**2*s - 528*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 + 6336*D1*Dd*f*fd*r*s - 6336*D1*Dd*f*fd*r + 3696*D1*Dd*f*fd*s**2 - 6996*D1*Dd*f*fd*s + 3234*D1*Dd*f*fd + 2640*D1*Dd*f*g2*r*s - 660*D1*Dd*f*g2*r + 2640*D1*Dd*f*g2*s**2 - 2640*D1*Dd*f*g2*s + 660*D1*Dd*f*g2 - 6336*D1*Dd*f*gd2*r*s + 792*D1*Dd*f*gd2*r - 6336*D1*Dd*f*gd2*s**2 + 6336*D1*Dd*f*gd2*s - 792*D1*Dd*f*gd2 - 6336*D1*Dd*fd*g2*r*s + 792*D1*Dd*fd*g2*r - 6336*D1*Dd*fd*g2*s**2 + 3168*D1*Dd*fd*g2*s - 2904*D1*Ddd*K*f**2*r*s + 726*D1*Ddd*K*f**2*r - 2904*D1*Ddd*K*f**2*s**2 + 2904*D1*Ddd*K*f**2*s - 726*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 4480*D1*Ddd*f**3*s**2 - 5040*D1*Ddd*f**3*s + 1680*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 + 1584*D1*Ddd*f**2*r*s - 1056*D1*Ddd*f**2*r + 924*D1*Ddd*f**2*s**2 - 1254*D1*Ddd*f**2*s + 561*D1*Ddd*f**2 - 3168*D1*Ddd*f*g2*r*s + 792*D1*Ddd*f*g2*r - 3168*D1*Ddd*f*g2*s**2 + 3168*D1*Ddd*f*g2*s - 792*D1*Ddd*f*g2 - 66*D1*bd1*(K - 1)*(D1*(5*f*(2*s - 1)*(r + s - 1) + 6*fd*(-4*r*s + r + s*(3 - 4*s))) - 6*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 8712*Dd**2*K*f**2*r*s + 2178*Dd**2*K*f**2*r - 8712*Dd**2*K*f**2*s**2 + 8712*Dd**2*K*f**2*s - 1452*Dd**2*K*f**2 + 3360*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 13440*Dd**2*f**3*s**2 - 15120*Dd**2*f**3*s + 3360*Dd**2*f**3 + 1980*Dd**2*f**2*r**2 + 4752*Dd**2*f**2*r*s - 3168*Dd**2*f**2*r + 2772*Dd**2*f**2*s**2 - 3762*Dd**2*f**2*s + 1122*Dd**2*f**2 - 9504*Dd**2*f*g2*r*s + 2376*Dd**2*f*g2*r - 9504*Dd**2*f*g2*s**2 + 9504*Dd**2*f*g2*s - 1584*Dd**2*f*g2))/(693*d**2*k2*k3**6) - 8*D1**2*Pk2*Pk3*ct**3*k1**3*k2**3*st**2*(-396*C*D1**2*bdd1*f**2*r**2 - 792*C*D1**2*bdd1*f**2*r*s + 792*C*D1**2*bdd1*f**2*r - 396*C*D1**2*bdd1*f**2*s**2 + 792*C*D1**2*bdd1*f**2*s - 396*C*D1**2*bdd1*f**2 + 6642*C*D1**2*f**2*fd*r**2 + 13284*C*D1**2*f**2*fd*r*s - 8856*C*D1**2*f**2*fd*r + 6642*C*D1**2*f**2*fd*s**2 - 8856*C*D1**2*f**2*fd*s + 4428*C*D1**2*f**2*fd - 5400*C*D1**2*f**2*fdd*r**2 - 10800*C*D1**2*f**2*fdd*r*s + 7200*C*D1**2*f**2*fdd*r - 5400*C*D1**2*f**2*fdd*s**2 + 7200*C*D1**2*f**2*fdd*s - 3600*C*D1**2*f**2*fdd - 10800*C*D1**2*f*fd**2*r**2 - 21600*C*D1**2*f*fd**2*r*s + 14400*C*D1**2*f*fd**2*r - 10800*C*D1**2*f*fd**2*s**2 + 14400*C*D1**2*f*fd**2*s - 3600*C*D1**2*f*fd**2 + 8856*C*D1*Dd*f**3*r**2 + 17712*C*D1*Dd*f**3*r*s - 13284*C*D1*Dd*f**3*r + 8856*C*D1*Dd*f**3*s**2 - 13284*C*D1*Dd*f**3*s + 6642*C*D1*Dd*f**3 - 43200*C*D1*Dd*f**2*fd*r**2 - 86400*C*D1*Dd*f**2*fd*r*s + 61200*C*D1*Dd*f**2*fd*r - 43200*C*D1*Dd*f**2*fd*s**2 + 61200*C*D1*Dd*f**2*fd*s - 21600*C*D1*Dd*f**2*fd - 7200*C*D1*Ddd*f**3*r**2 - 14400*C*D1*Ddd*f**3*r*s + 10800*C*D1*Ddd*f**3*r - 7200*C*D1*Ddd*f**3*s**2 + 10800*C*D1*Ddd*f**3*s - 5400*C*D1*Ddd*f**3 - 21600*C*Dd**2*f**3*r**2 - 43200*C*Dd**2*f**3*r*s + 32400*C*Dd**2*f**3*r - 21600*C*Dd**2*f**3*s**2 + 32400*C*Dd**2*f**3*s - 10800*C*Dd**2*f**3 - 1188*D1**2*K*bdd1*f**2*r**2 - 2376*D1**2*K*bdd1*f**2*r*s + 2376*D1**2*K*bdd1*f**2*r - 1188*D1**2*K*bdd1*f**2*s**2 + 2376*D1**2*K*bdd1*f**2*s - 1188*D1**2*K*bdd1*f**2 - 396*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 625*D1**2*bdd1*f**3*r**2 + 1250*D1**2*bdd1*f**3*r*s - 1250*D1**2*bdd1*f**3*r + 625*D1**2*bdd1*f**3*s**2 - 1250*D1**2*bdd1*f**3*s + 625*D1**2*bdd1*f**3 + 990*D1**2*bdd1*f**2*r**2 + 1980*D1**2*bdd1*f**2*r*s - 1980*D1**2*bdd1*f**2*r + 990*D1**2*bdd1*f**2*s**2 - 1980*D1**2*bdd1*f**2*s + 990*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r**2 + 792*D1**2*bdd1*f*g2*r*s - 792*D1**2*bdd1*f*g2*r + 396*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 1500*D1**2*f**3*fd*r**2 - 3000*D1**2*f**3*fd*r*s + 2250*D1**2*f**3*fd*r - 1500*D1**2*f**3*fd*s**2 + 2250*D1**2*f**3*fd*s - 1125*D1**2*f**3*fd - 4833*D1**2*f**2*fd*r**2 - 9666*D1**2*f**2*fd*r*s + 6444*D1**2*f**2*fd*r - 4833*D1**2*f**2*fd*s**2 + 6444*D1**2*f**2*fd*s - 3222*D1**2*f**2*fd + 4050*D1**2*f**2*fdd*r**2 + 8100*D1**2*f**2*fdd*r*s - 5400*D1**2*f**2*fdd*r + 4050*D1**2*f**2*fdd*s**2 - 5400*D1**2*f**2*fdd*s + 2700*D1**2*f**2*fdd - 3366*D1**2*f**2*gd2*r**2 - 6732*D1**2*f**2*gd2*r*s + 6732*D1**2*f**2*gd2*r - 3366*D1**2*f**2*gd2*s**2 + 6732*D1**2*f**2*gd2*s - 3366*D1**2*f**2*gd2 + 2376*D1**2*f**2*gdd2*r**2 + 4752*D1**2*f**2*gdd2*r*s - 4752*D1**2*f**2*gdd2*r + 2376*D1**2*f**2*gdd2*s**2 - 4752*D1**2*f**2*gdd2*s + 2376*D1**2*f**2*gdd2 + 8100*D1**2*f*fd**2*r**2 + 16200*D1**2*f*fd**2*r*s - 10800*D1**2*f*fd**2*r + 8100*D1**2*f*fd**2*s**2 - 10800*D1**2*f*fd**2*s + 2700*D1**2*f*fd**2 - 6732*D1**2*f*fd*g2*r**2 - 13464*D1**2*f*fd*g2*r*s + 6732*D1**2*f*fd*g2*r - 6732*D1**2*f*fd*g2*s**2 + 6732*D1**2*f*fd*g2*s - 3366*D1**2*f*fd*g2 + 9504*D1**2*f*fd*gd2*r**2 + 19008*D1**2*f*fd*gd2*r*s - 14256*D1**2*f*fd*gd2*r + 9504*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4752*D1**2*f*fd*gd2 + 4752*D1**2*f*fdd*g2*r**2 + 9504*D1**2*f*fdd*g2*r*s - 4752*D1**2*f*fdd*g2*r + 4752*D1**2*f*fdd*g2*s**2 - 4752*D1**2*f*fdd*g2*s + 2376*D1**2*f*fdd*g2 + 4752*D1**2*fd**2*g2*r**2 + 9504*D1**2*fd**2*g2*r*s - 4752*D1**2*fd**2*g2*r + 4752*D1**2*fd**2*g2*s**2 - 4752*D1**2*fd**2*g2*s - 1500*D1*Dd*f**4*r**2 - 3000*D1*Dd*f**4*r*s + 2250*D1*Dd*f**4*r - 1500*D1*Dd*f**4*s**2 + 2250*D1*Dd*f**4*s - 1125*D1*Dd*f**4 - 6444*D1*Dd*f**3*r**2 - 12888*D1*Dd*f**3*r*s + 9666*D1*Dd*f**3*r - 6444*D1*Dd*f**3*s**2 + 9666*D1*Dd*f**3*s - 4833*D1*Dd*f**3 + 32400*D1*Dd*f**2*fd*r**2 + 64800*D1*Dd*f**2*fd*r*s - 45900*D1*Dd*f**2*fd*r + 32400*D1*Dd*f**2*fd*s**2 - 45900*D1*Dd*f**2*fd*s + 16200*D1*Dd*f**2*fd - 13464*D1*Dd*f**2*g2*r**2 - 26928*D1*Dd*f**2*g2*r*s + 20196*D1*Dd*f**2*g2*r - 13464*D1*Dd*f**2*g2*s**2 + 20196*D1*Dd*f**2*g2*s - 10098*D1*Dd*f**2*g2 + 19008*D1*Dd*f**2*gd2*r**2 + 38016*D1*Dd*f**2*gd2*r*s - 33264*D1*Dd*f**2*gd2*r + 19008*D1*Dd*f**2*gd2*s**2 - 33264*D1*Dd*f**2*gd2*s + 14256*D1*Dd*f**2*gd2 + 38016*D1*Dd*f*fd*g2*r**2 + 76032*D1*Dd*f*fd*g2*r*s - 47520*D1*Dd*f*fd*g2*r + 38016*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 + 5400*D1*Ddd*f**3*r**2 + 10800*D1*Ddd*f**3*r*s - 8100*D1*Ddd*f**3*r + 5400*D1*Ddd*f**3*s**2 - 8100*D1*Ddd*f**3*s + 4050*D1*Ddd*f**3 + 9504*D1*Ddd*f**2*g2*r**2 + 19008*D1*Ddd*f**2*g2*r*s - 14256*D1*Ddd*f**2*g2*r + 9504*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 7128*D1*Ddd*f**2*g2 - D1*bd1*(D1*(689*f**3*(r + s - 1) - f**2*(726*C*(r + s - 1) + 1250*fd*(3*r + 3*s - 2) + (1683*K - 1518)*(r + s - 1)) + 66*f*(6*fd*(2*C + 6*K - 5)*(2*r + 2*s - 1) + (19*g2 - 12*gd2)*(r + s - 1)) - 792*fd*g2*(r + s)) - 2*Dd*f*(625*f**2 - 198*f*(2*C + 6*K - 5) + 396*g2)*(4*r + 4*s - 3))*(r + s - 1) + 16200*Dd**2*f**3*r**2 + 32400*Dd**2*f**3*r*s - 24300*Dd**2*f**3*r + 16200*Dd**2*f**3*s**2 - 24300*Dd**2*f**3*s + 8100*Dd**2*f**3 + 28512*Dd**2*f**2*g2*r**2 + 57024*Dd**2*f**2*g2*r*s - 42768*Dd**2*f**2*g2*r + 28512*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 14256*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*(19*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(19*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(1452*C*D1**2*f*fd*r**2 + 2904*C*D1**2*f*fd*r*s - 1452*C*D1**2*f*fd*r + 1452*C*D1**2*f*fd*s**2 - 1452*C*D1**2*f*fd*s + 726*C*D1**2*f*fd - 792*C*D1**2*f*fdd*r**2 - 1584*C*D1**2*f*fdd*r*s + 792*C*D1**2*f*fdd*r - 792*C*D1**2*f*fdd*s**2 + 792*C*D1**2*f*fdd*s - 396*C*D1**2*f*fdd - 792*C*D1**2*fd**2*r**2 - 1584*C*D1**2*fd**2*r*s + 792*C*D1**2*fd**2*r - 792*C*D1**2*fd**2*s**2 + 792*C*D1**2*fd**2*s + 2904*C*D1*Dd*f**2*r**2 + 5808*C*D1*Dd*f**2*r*s - 4356*C*D1*Dd*f**2*r + 2904*C*D1*Dd*f**2*s**2 - 4356*C*D1*Dd*f**2*s + 2178*C*D1*Dd*f**2 - 6336*C*D1*Dd*f*fd*r**2 - 12672*C*D1*Dd*f*fd*r*s + 7920*C*D1*Dd*f*fd*r - 6336*C*D1*Dd*f*fd*s**2 + 7920*C*D1*Dd*f*fd*s - 2376*C*D1*Dd*f*fd - 1584*C*D1*Ddd*f**2*r**2 - 3168*C*D1*Ddd*f**2*r*s + 2376*C*D1*Ddd*f**2*r - 1584*C*D1*Ddd*f**2*s**2 + 2376*C*D1*Ddd*f**2*s - 1188*C*D1*Ddd*f**2 - 4752*C*Dd**2*f**2*r**2 - 9504*C*Dd**2*f**2*r*s + 7128*C*Dd**2*f**2*r - 4752*C*Dd**2*f**2*s**2 + 7128*C*Dd**2*f**2*s - 2376*C*Dd**2*f**2 + 3366*D1**2*K*f*fd*r**2 + 6732*D1**2*K*f*fd*r*s - 3366*D1**2*K*f*fd*r + 3366*D1**2*K*f*fd*s**2 - 3366*D1**2*K*f*fd*s + 1683*D1**2*K*f*fd - 2376*D1**2*K*f*fdd*r**2 - 4752*D1**2*K*f*fdd*r*s + 2376*D1**2*K*f*fdd*r - 2376*D1**2*K*f*fdd*s**2 + 2376*D1**2*K*f*fdd*s - 1188*D1**2*K*f*fdd - 2376*D1**2*K*fd**2*r**2 - 4752*D1**2*K*fd**2*r*s + 2376*D1**2*K*fd**2*r - 2376*D1**2*K*fd**2*s**2 + 2376*D1**2*K*fd**2*s - 396*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 2067*D1**2*f**2*fd*r**2 - 4134*D1**2*f**2*fd*r*s + 2756*D1**2*f**2*fd*r - 2067*D1**2*f**2*fd*s**2 + 2756*D1**2*f**2*fd*s - 1378*D1**2*f**2*fd + 1875*D1**2*f**2*fdd*r**2 + 3750*D1**2*f**2*fdd*r*s - 2500*D1**2*f**2*fdd*r + 1875*D1**2*f**2*fdd*s**2 - 2500*D1**2*f**2*fdd*s + 1250*D1**2*f**2*fdd + 3750*D1**2*f*fd**2*r**2 + 7500*D1**2*f*fd**2*r*s - 5000*D1**2*f*fd**2*r + 3750*D1**2*f*fd**2*s**2 - 5000*D1**2*f*fd**2*s + 1250*D1**2*f*fd**2 - 3036*D1**2*f*fd*r**2 - 6072*D1**2*f*fd*r*s + 3036*D1**2*f*fd*r - 3036*D1**2*f*fd*s**2 + 3036*D1**2*f*fd*s - 1518*D1**2*f*fd + 1980*D1**2*f*fdd*r**2 + 3960*D1**2*f*fdd*r*s - 1980*D1**2*f*fdd*r + 1980*D1**2*f*fdd*s**2 - 1980*D1**2*f*fdd*s + 990*D1**2*f*fdd - 1254*D1**2*f*gd2*r**2 - 2508*D1**2*f*gd2*r*s + 2508*D1**2*f*gd2*r - 1254*D1**2*f*gd2*s**2 + 2508*D1**2*f*gd2*s - 1254*D1**2*f*gd2 + 396*D1**2*f*gdd2*r**2 + 792*D1**2*f*gdd2*r*s - 792*D1**2*f*gdd2*r + 396*D1**2*f*gdd2*s**2 - 792*D1**2*f*gdd2*s + 396*D1**2*f*gdd2 + 1980*D1**2*fd**2*r**2 + 3960*D1**2*fd**2*r*s - 1980*D1**2*fd**2*r + 1980*D1**2*fd**2*s**2 - 1980*D1**2*fd**2*s - 1254*D1**2*fd*g2*r**2 - 2508*D1**2*fd*g2*r*s - 1254*D1**2*fd*g2*s**2 + 792*D1**2*fd*gd2*r**2 + 1584*D1**2*fd*gd2*r*s - 792*D1**2*fd*gd2*r + 792*D1**2*fd*gd2*s**2 - 792*D1**2*fd*gd2*s + 396*D1**2*fdd*g2*r**2 + 792*D1**2*fdd*g2*r*s + 396*D1**2*fdd*g2*s**2 + 6732*D1*Dd*K*f**2*r**2 + 13464*D1*Dd*K*f**2*r*s - 10098*D1*Dd*K*f**2*r + 6732*D1*Dd*K*f**2*s**2 - 10098*D1*Dd*K*f**2*s + 5049*D1*Dd*K*f**2 - 19008*D1*Dd*K*f*fd*r**2 - 38016*D1*Dd*K*f*fd*r*s + 23760*D1*Dd*K*f*fd*r - 19008*D1*Dd*K*f*fd*s**2 + 23760*D1*Dd*K*f*fd*s - 7128*D1*Dd*K*f*fd - 2756*D1*Dd*f**3*r**2 - 5512*D1*Dd*f**3*r*s + 4134*D1*Dd*f**3*r - 2756*D1*Dd*f**3*s**2 + 4134*D1*Dd*f**3*s - 2067*D1*Dd*f**3 + 15000*D1*Dd*f**2*fd*r**2 + 30000*D1*Dd*f**2*fd*r*s - 21250*D1*Dd*f**2*fd*r + 15000*D1*Dd*f**2*fd*s**2 - 21250*D1*Dd*f**2*fd*s + 7500*D1*Dd*f**2*fd - 6072*D1*Dd*f**2*r**2 - 12144*D1*Dd*f**2*r*s + 9108*D1*Dd*f**2*r - 6072*D1*Dd*f**2*s**2 + 9108*D1*Dd*f**2*s - 4554*D1*Dd*f**2 + 15840*D1*Dd*f*fd*r**2 + 31680*D1*Dd*f*fd*r*s - 19800*D1*Dd*f*fd*r + 15840*D1*Dd*f*fd*s**2 - 19800*D1*Dd*f*fd*s + 5940*D1*Dd*f*fd - 5016*D1*Dd*f*g2*r**2 - 10032*D1*Dd*f*g2*r*s + 7524*D1*Dd*f*g2*r - 5016*D1*Dd*f*g2*s**2 + 7524*D1*Dd*f*g2*s - 3762*D1*Dd*f*g2 + 3168*D1*Dd*f*gd2*r**2 + 6336*D1*Dd*f*gd2*r*s - 5544*D1*Dd*f*gd2*r + 3168*D1*Dd*f*gd2*s**2 - 5544*D1*Dd*f*gd2*s + 2376*D1*Dd*f*gd2 + 3168*D1*Dd*fd*g2*r**2 + 6336*D1*Dd*fd*g2*r*s - 2376*D1*Dd*fd*g2*r + 3168*D1*Dd*fd*g2*s**2 - 2376*D1*Dd*fd*g2*s - 4752*D1*Ddd*K*f**2*r**2 - 9504*D1*Ddd*K*f**2*r*s + 7128*D1*Ddd*K*f**2*r - 4752*D1*Ddd*K*f**2*s**2 + 7128*D1*Ddd*K*f**2*s - 3564*D1*Ddd*K*f**2 + 2500*D1*Ddd*f**3*r**2 + 5000*D1*Ddd*f**3*r*s - 3750*D1*Ddd*f**3*r + 2500*D1*Ddd*f**3*s**2 - 3750*D1*Ddd*f**3*s + 1875*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*r**2 + 7920*D1*Ddd*f**2*r*s - 5940*D1*Ddd*f**2*r + 3960*D1*Ddd*f**2*s**2 - 5940*D1*Ddd*f**2*s + 2970*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r**2 + 3168*D1*Ddd*f*g2*r*s - 2376*D1*Ddd*f*g2*r + 1584*D1*Ddd*f*g2*s**2 - 2376*D1*Ddd*f*g2*s + 1188*D1*Ddd*f*g2 + 66*D1*bd1*(K - 1)*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 14256*Dd**2*K*f**2*r**2 - 28512*Dd**2*K*f**2*r*s + 21384*Dd**2*K*f**2*r - 14256*Dd**2*K*f**2*s**2 + 21384*Dd**2*K*f**2*s - 7128*Dd**2*K*f**2 + 7500*Dd**2*f**3*r**2 + 15000*Dd**2*f**3*r*s - 11250*Dd**2*f**3*r + 7500*Dd**2*f**3*s**2 - 11250*Dd**2*f**3*s + 3750*Dd**2*f**3 + 11880*Dd**2*f**2*r**2 + 23760*Dd**2*f**2*r*s - 17820*Dd**2*f**2*r + 11880*Dd**2*f**2*s**2 - 17820*Dd**2*f**2*s + 5940*Dd**2*f**2 + 4752*Dd**2*f*g2*r**2 + 9504*Dd**2*f*g2*r*s - 7128*Dd**2*f*g2*r + 4752*Dd**2*f*g2*s**2 - 7128*Dd**2*f*g2*s + 2376*Dd**2*f*g2))/(231*d**2*k3**8) + 8*D1**2*Pk2*Pk3*ct**3*k1**3*k2**3*(3960*C*D1**2*bdd1*f**2*r**2 + 7920*C*D1**2*bdd1*f**2*r*s - 7920*C*D1**2*bdd1*f**2*r + 3960*C*D1**2*bdd1*f**2*s**2 - 7920*C*D1**2*bdd1*f**2*s + 3960*C*D1**2*bdd1*f**2 - 780*C*D1**2*f**2*fd*r**2 - 1560*C*D1**2*f**2*fd*r*s + 1040*C*D1**2*f**2*fd*r - 780*C*D1**2*f**2*fd*s**2 + 1040*C*D1**2*f**2*fd*s - 520*C*D1**2*f**2*fd + 3360*C*D1**2*f**2*fdd*r**2 + 6720*C*D1**2*f**2*fdd*r*s - 4480*C*D1**2*f**2*fdd*r + 3360*C*D1**2*f**2*fdd*s**2 - 4480*C*D1**2*f**2*fdd*s + 2240*C*D1**2*f**2*fdd + 6720*C*D1**2*f*fd**2*r**2 + 13440*C*D1**2*f*fd**2*r*s - 8960*C*D1**2*f*fd**2*r + 6720*C*D1**2*f*fd**2*s**2 - 8960*C*D1**2*f*fd**2*s + 2240*C*D1**2*f*fd**2 - 1040*C*D1*Dd*f**3*r**2 - 2080*C*D1*Dd*f**3*r*s + 1560*C*D1*Dd*f**3*r - 1040*C*D1*Dd*f**3*s**2 + 1560*C*D1*Dd*f**3*s - 780*C*D1*Dd*f**3 + 26880*C*D1*Dd*f**2*fd*r**2 + 53760*C*D1*Dd*f**2*fd*r*s - 38080*C*D1*Dd*f**2*fd*r + 26880*C*D1*Dd*f**2*fd*s**2 - 38080*C*D1*Dd*f**2*fd*s + 13440*C*D1*Dd*f**2*fd + 4480*C*D1*Ddd*f**3*r**2 + 8960*C*D1*Ddd*f**3*r*s - 6720*C*D1*Ddd*f**3*r + 4480*C*D1*Ddd*f**3*s**2 - 6720*C*D1*Ddd*f**3*s + 3360*C*D1*Ddd*f**3 + 13440*C*Dd**2*f**3*r**2 + 26880*C*Dd**2*f**3*r*s - 20160*C*Dd**2*f**3*r + 13440*C*Dd**2*f**3*s**2 - 20160*C*Dd**2*f**3*s + 6720*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r**2 + 1320*D1**2*K*bdd1*f**2*r*s - 1320*D1**2*K*bdd1*f**2*r + 660*D1**2*K*bdd1*f**2*s**2 - 1320*D1**2*K*bdd1*f**2*s + 660*D1**2*K*bdd1*f**2 - 132*D1**2*bd1**2*f*(-36*K + 25*f + 18)*(r + s - 1)**2 - 2970*D1**2*bdd1*f**2*r**2 - 5940*D1**2*bdd1*f**2*r*s + 5940*D1**2*bdd1*f**2*r - 2970*D1**2*bdd1*f**2*s**2 + 5940*D1**2*bdd1*f**2*s - 2970*D1**2*bdd1*f**2 - 4752*D1**2*bdd1*f*g2*r**2 - 9504*D1**2*bdd1*f*g2*r*s + 9504*D1**2*bdd1*f*g2*r - 4752*D1**2*bdd1*f*g2*s**2 + 9504*D1**2*bdd1*f*g2*s - 4752*D1**2*bdd1*f*g2 - 105*D1**2*f**2*fd*r**2 - 210*D1**2*f**2*fd*r*s + 140*D1**2*f**2*fd*r - 105*D1**2*f**2*fd*s**2 + 140*D1**2*f**2*fd*s - 70*D1**2*f**2*fd - 1680*D1**2*f**2*fdd*r**2 - 3360*D1**2*f**2*fdd*r*s + 2240*D1**2*f**2*fdd*r - 1680*D1**2*f**2*fdd*s**2 + 2240*D1**2*f**2*fdd*s - 1120*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 1320*D1**2*f**2*gdd2*r**2 - 2640*D1**2*f**2*gdd2*r*s + 2640*D1**2*f**2*gdd2*r - 1320*D1**2*f**2*gdd2*s**2 + 2640*D1**2*f**2*gdd2*s - 1320*D1**2*f**2*gdd2 - 3360*D1**2*f*fd**2*r**2 - 6720*D1**2*f*fd**2*r*s + 4480*D1**2*f*fd**2*r - 3360*D1**2*f*fd**2*s**2 + 4480*D1**2*f*fd**2*s - 1120*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r**2 - 10560*D1**2*f*fd*gd2*r*s + 7920*D1**2*f*fd*gd2*r - 5280*D1**2*f*fd*gd2*s**2 + 7920*D1**2*f*fd*gd2*s - 2640*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r**2 - 5280*D1**2*f*fdd*g2*r*s + 2640*D1**2*f*fdd*g2*r - 2640*D1**2*f*fdd*g2*s**2 + 2640*D1**2*f*fdd*g2*s - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r**2 - 5280*D1**2*fd**2*g2*r*s + 2640*D1**2*fd**2*g2*r - 2640*D1**2*fd**2*g2*s**2 + 2640*D1**2*fd**2*g2*s - 140*D1*Dd*f**3*r**2 - 280*D1*Dd*f**3*r*s + 210*D1*Dd*f**3*r - 140*D1*Dd*f**3*s**2 + 210*D1*Dd*f**3*s - 105*D1*Dd*f**3 - 13440*D1*Dd*f**2*fd*r**2 - 26880*D1*Dd*f**2*fd*r*s + 19040*D1*Dd*f**2*fd*r - 13440*D1*Dd*f**2*fd*s**2 + 19040*D1*Dd*f**2*fd*s - 6720*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r**2 - 21120*D1*Dd*f**2*gd2*r*s + 18480*D1*Dd*f**2*gd2*r - 10560*D1*Dd*f**2*gd2*s**2 + 18480*D1*Dd*f**2*gd2*s - 7920*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r**2 - 42240*D1*Dd*f*fd*g2*r*s + 26400*D1*Dd*f*fd*g2*r - 21120*D1*Dd*f*fd*g2*s**2 + 26400*D1*Dd*f*fd*g2*s - 7920*D1*Dd*f*fd*g2 - 2240*D1*Ddd*f**3*r**2 - 4480*D1*Ddd*f**3*r*s + 3360*D1*Ddd*f**3*r - 2240*D1*Ddd*f**3*s**2 + 3360*D1*Ddd*f**3*s - 1680*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r**2 - 10560*D1*Ddd*f**2*g2*r*s + 7920*D1*Ddd*f**2*g2*r - 5280*D1*Ddd*f**2*g2*s**2 + 7920*D1*Ddd*f**2*g2*s - 3960*D1*Ddd*f**2*g2 - 132*D1*bd1*(D1*(f**2*(24*C + K - 15)*(r + s - 1) - 5*f*fd*(12*C + 2*K - 9)*(2*r + 2*s - 1) - 6*f*(5*g2 - 12*gd2)*(r + s - 1) + 72*fd*g2*(r + s)) - Dd*f*(5*f*(12*C + 2*K - 9) - 72*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6720*Dd**2*f**3*r**2 - 13440*Dd**2*f**3*r*s + 10080*Dd**2*f**3*r - 6720*Dd**2*f**3*s**2 + 10080*Dd**2*f**3*s - 3360*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r**2 - 31680*Dd**2*f**2*g2*r*s + 23760*Dd**2*f**2*g2*r - 15840*Dd**2*f**2*g2*s**2 + 23760*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(2*f*(29*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(60*K - 23)*(r + s) - 36*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(58*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (60*K - 23)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 72*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(-36*K + 25*f + 18)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(-36*K + 25*f + 18)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(-96*C*D1**2*f*fd*r**2 - 192*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r - 96*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 48*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 192*C*D1*Dd*f**2*r**2 - 384*C*D1*Dd*f**2*r*s + 288*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 144*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 1200*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1200*C*D1*Dd*f*fd*s + 360*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 360*C*Dd**2*f**2 - 4*D1**2*K*f*fd*r**2 - 8*D1**2*K*f*fd*r*s + 4*D1**2*K*f*fd*r - 4*D1**2*K*f*fd*s**2 + 4*D1**2*K*f*fd*s - 2*D1**2*K*f*fd + 20*D1**2*K*f*fdd*r**2 + 40*D1**2*K*f*fdd*r*s - 20*D1**2*K*f*fdd*r + 20*D1**2*K*f*fdd*s**2 - 20*D1**2*K*f*fdd*s + 10*D1**2*K*f*fdd + 20*D1**2*K*fd**2*r**2 + 40*D1**2*K*fd**2*r*s - 20*D1**2*K*fd**2*r + 20*D1**2*K*fd**2*s**2 - 20*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-36*K + 25*f + 18)*(r + s - 1)**2 + 60*D1**2*f*fd*r**2 + 120*D1**2*f*fd*r*s - 60*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 60*D1**2*f*fd*s + 30*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 45*D1**2*f*fdd + 60*D1**2*f*gd2*r**2 + 120*D1**2*f*gd2*r*s - 120*D1**2*f*gd2*r + 60*D1**2*f*gd2*s**2 - 120*D1**2*f*gd2*s + 60*D1**2*f*gd2 - 72*D1**2*f*gdd2*r**2 - 144*D1**2*f*gdd2*r*s + 144*D1**2*f*gdd2*r - 72*D1**2*f*gdd2*s**2 + 144*D1**2*f*gdd2*s - 72*D1**2*f*gdd2 - 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 60*D1**2*fd*g2*r**2 + 120*D1**2*fd*g2*r*s + 60*D1**2*fd*g2*s**2 - 144*D1**2*fd*gd2*r**2 - 288*D1**2*fd*gd2*r*s + 144*D1**2*fd*gd2*r - 144*D1**2*fd*gd2*s**2 + 144*D1**2*fd*gd2*s - 72*D1**2*fdd*g2*r**2 - 144*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*s**2 - 8*D1*Dd*K*f**2*r**2 - 16*D1*Dd*K*f**2*r*s + 12*D1*Dd*K*f**2*r - 8*D1*Dd*K*f**2*s**2 + 12*D1*Dd*K*f**2*s - 6*D1*Dd*K*f**2 + 160*D1*Dd*K*f*fd*r**2 + 320*D1*Dd*K*f*fd*r*s - 200*D1*Dd*K*f*fd*r + 160*D1*Dd*K*f*fd*s**2 - 200*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd + 120*D1*Dd*f**2*r**2 + 240*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 180*D1*Dd*f**2*s + 90*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 900*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 270*D1*Dd*f*fd + 240*D1*Dd*f*g2*r**2 + 480*D1*Dd*f*g2*r*s - 360*D1*Dd*f*g2*r + 240*D1*Dd*f*g2*s**2 - 360*D1*Dd*f*g2*s + 180*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r**2 - 1152*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r - 576*D1*Dd*f*gd2*s**2 + 1008*D1*Dd*f*gd2*s - 432*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r**2 - 1152*D1*Dd*fd*g2*r*s + 432*D1*Dd*fd*g2*r - 576*D1*Dd*fd*g2*s**2 + 432*D1*Dd*fd*g2*s + 40*D1*Ddd*K*f**2*r**2 + 80*D1*Ddd*K*f**2*r*s - 60*D1*Ddd*K*f**2*r + 40*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 30*D1*Ddd*K*f**2 - 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r**2 - 576*D1*Ddd*f*g2*r*s + 432*D1*Ddd*f*g2*r - 288*D1*Ddd*f*g2*s**2 + 432*D1*Ddd*f*g2*s - 216*D1*Ddd*f*g2 + D1*bd1*(D1*(58*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(60*K - 23)*(r + s - 1) + 72*fd*(2*K - 1)*(r + s)) - 4*Dd*f*(-36*K + 25*f + 18)*(4*r + 4*s - 3))*(r + s - 1) + 120*Dd**2*K*f**2*r**2 + 240*Dd**2*K*f**2*r*s - 180*Dd**2*K*f**2*r + 120*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 60*Dd**2*K*f**2 - 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 270*Dd**2*f**2 - 864*Dd**2*f*g2*r**2 - 1728*Dd**2*f*g2*r*s + 1296*Dd**2*f*g2*r - 864*Dd**2*f*g2*s**2 + 1296*Dd**2*f*g2*s - 432*Dd**2*f*g2))/(231*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**3*k1**3*k2*st**2*(396*C*D1**2*bdd1*f**2*r**2 + 1980*C*D1**2*bdd1*f**2*r*s - 1188*C*D1**2*bdd1*f**2*r + 1584*C*D1**2*bdd1*f**2*s**2 - 2376*C*D1**2*bdd1*f**2*s + 1188*C*D1**2*bdd1*f**2 + 11142*C*D1**2*f**2*fd*r**2 + 10440*C*D1**2*f**2*fd*r*s - 10908*C*D1**2*f**2*fd*r - 702*C*D1**2*f**2*fd*s**2 - 3012*C*D1**2*f**2*fd*s + 3480*C*D1**2*f**2*fd - 9234*C*D1**2*f**2*fdd*r**2 - 10368*C*D1**2*f**2*fdd*r*s + 9612*C*D1**2*f**2*fdd*r - 1134*C*D1**2*f**2*fdd*s**2 + 4212*C*D1**2*f**2*fdd*s - 3456*C*D1**2*f**2*fdd - 18468*C*D1**2*f*fd**2*r**2 - 20736*C*D1**2*f*fd**2*r*s + 19224*C*D1**2*f*fd**2*r - 2268*C*D1**2*f*fd**2*s**2 + 8424*C*D1**2*f*fd**2*s - 3456*C*D1**2*f*fd**2 + 14856*C*D1*Dd*f**3*r**2 + 13920*C*D1*Dd*f**3*r*s - 18336*C*D1*Dd*f**3*r - 936*C*D1*Dd*f**3*s**2 - 6492*C*D1*Dd*f**3*s + 7194*C*D1*Dd*f**3 - 73872*C*D1*Dd*f**2*fd*r**2 - 82944*C*D1*Dd*f**2*fd*r*s + 85752*C*D1*Dd*f**2*fd*r - 9072*C*D1*Dd*f**2*fd*s**2 + 39852*C*D1*Dd*f**2*fd*s - 23436*C*D1*Dd*f**2*fd - 12312*C*D1*Ddd*f**3*r**2 - 13824*C*D1*Ddd*f**3*r*s + 15768*C*D1*Ddd*f**3*r - 1512*C*D1*Ddd*f**3*s**2 + 7668*C*D1*Ddd*f**3*s - 6534*C*D1*Ddd*f**3 - 36936*C*Dd**2*f**3*r**2 - 41472*C*Dd**2*f**3*r*s + 47304*C*Dd**2*f**3*r - 4536*C*Dd**2*f**3*s**2 + 23004*C*Dd**2*f**3*s - 13068*C*Dd**2*f**3 - 1683*D1**2*K*bdd1*f**2*r**2 - 1584*D1**2*K*bdd1*f**2*r*s + 3366*D1**2*K*bdd1*f**2*r + 99*D1**2*K*bdd1*f**2*s**2 + 1584*D1**2*K*bdd1*f**2*s - 1683*D1**2*K*bdd1*f**2 + 198*D1**2*bd1**2*f*(K - 1)*(2*r**2 + 5*r*(2*s - 1) + 8*s**2 - 11*s + 3) + 2250*D1**2*bdd1*f**3*r**2 + 3500*D1**2*bdd1*f**3*r*s - 5000*D1**2*bdd1*f**3*r + 1250*D1**2*bdd1*f**3*s**2 - 4000*D1**2*bdd1*f**3*s + 3500*D1**2*bdd1*f**3 + 2475*D1**2*bdd1*f**2*r**2 + 3168*D1**2*bdd1*f**2*r*s - 4554*D1**2*bdd1*f**2*r + 693*D1**2*bdd1*f**2*s**2 - 2772*D1**2*bdd1*f**2*s + 1683*D1**2*bdd1*f**2 - 396*D1**2*bdd1*f*g2*r**2 - 1980*D1**2*bdd1*f*g2*r*s + 1188*D1**2*bdd1*f*g2*r - 1584*D1**2*bdd1*f*g2*s**2 + 2376*D1**2*bdd1*f*g2*s - 1188*D1**2*bdd1*f*g2 + 19500*D1**2*f**3*fd*r**2 + 51000*D1**2*f**3*fd*r*s - 32250*D1**2*f**3*fd*r + 31500*D1**2*f**3*fd*s**2 - 41250*D1**2*f**3*fd*s + 17625*D1**2*f**3*fd - 22500*D1**2*f**3*fdd*r**2 - 45000*D1**2*f**3*fdd*r*s + 33750*D1**2*f**3*fdd*r - 22500*D1**2*f**3*fdd*s**2 + 33750*D1**2*f**3*fdd*s - 16875*D1**2*f**3*fdd - 67500*D1**2*f**2*fd**2*r**2 - 135000*D1**2*f**2*fd**2*r*s + 101250*D1**2*f**2*fd**2*r - 67500*D1**2*f**2*fd**2*s**2 + 101250*D1**2*f**2*fd**2*s - 33750*D1**2*f**2*fd**2 - 14760*D1**2*f**2*fd*r**2 - 21888*D1**2*f**2*fd*r*s + 17136*D1**2*f**2*fd*r - 7128*D1**2*f**2*fd*s**2 + 12048*D1**2*f**2*fd*s - 7296*D1**2*f**2*fd + 11934*D1**2*f**2*fdd*r**2 + 18468*D1**2*f**2*fdd*r*s - 14112*D1**2*f**2*fdd*r + 6534*D1**2*f**2*fdd*s**2 - 10512*D1**2*f**2*fdd*s + 6156*D1**2*f**2*fdd - 4554*D1**2*f**2*gd2*r**2 - 3168*D1**2*f**2*gd2*r*s + 9108*D1**2*f**2*gd2*r + 1386*D1**2*f**2*gd2*s**2 + 3168*D1**2*f**2*gd2*s - 4554*D1**2*f**2*gd2 + 3366*D1**2*f**2*gdd2*r**2 + 3168*D1**2*f**2*gdd2*r*s - 6732*D1**2*f**2*gdd2*r - 198*D1**2*f**2*gdd2*s**2 - 3168*D1**2*f**2*gdd2*s + 3366*D1**2*f**2*gdd2 + 23868*D1**2*f*fd**2*r**2 + 36936*D1**2*f*fd**2*r*s - 28224*D1**2*f*fd**2*r + 13068*D1**2*f*fd**2*s**2 - 21024*D1**2*f*fd**2*s + 6156*D1**2*f*fd**2 - 9108*D1**2*f*fd*g2*r**2 - 6336*D1**2*f*fd*g2*r*s + 3168*D1**2*f*fd*g2*r + 2772*D1**2*f*fd*g2*s**2 - 2772*D1**2*f*fd*g2*s + 1386*D1**2*f*fd*g2 + 13464*D1**2*f*fd*gd2*r**2 + 12672*D1**2*f*fd*gd2*r*s - 16632*D1**2*f*fd*gd2*r - 792*D1**2*f*fd*gd2*s**2 - 5940*D1**2*f*fd*gd2*s + 3168*D1**2*f*fd*gd2 + 6732*D1**2*f*fdd*g2*r**2 + 6336*D1**2*f*fdd*g2*r*s - 3168*D1**2*f*fdd*g2*r - 396*D1**2*f*fdd*g2*s**2 + 396*D1**2*f*fdd*g2*s - 198*D1**2*f*fdd*g2 + 6732*D1**2*fd**2*g2*r**2 + 6336*D1**2*fd**2*g2*r*s - 3168*D1**2*fd**2*g2*r - 396*D1**2*fd**2*g2*s**2 + 396*D1**2*fd**2*g2*s + 19500*D1*Dd*f**4*r**2 + 51000*D1*Dd*f**4*r*s - 32250*D1*Dd*f**4*r + 31500*D1*Dd*f**4*s**2 - 41250*D1*Dd*f**4*s + 17625*D1*Dd*f**4 - 180000*D1*Dd*f**3*fd*r**2 - 360000*D1*Dd*f**3*fd*r*s + 270000*D1*Dd*f**3*fd*r - 180000*D1*Dd*f**3*fd*s**2 + 270000*D1*Dd*f**3*fd*s - 101250*D1*Dd*f**3*fd - 19680*D1*Dd*f**3*r**2 - 29184*D1*Dd*f**3*r*s + 26976*D1*Dd*f**3*r - 9504*D1*Dd*f**3*s**2 + 19344*D1*Dd*f**3*s - 12216*D1*Dd*f**3 + 95472*D1*Dd*f**2*fd*r**2 + 147744*D1*Dd*f**2*fd*r*s - 122652*D1*Dd*f**2*fd*r + 52272*D1*Dd*f**2*fd*s**2 - 92052*D1*Dd*f**2*fd*s + 38736*D1*Dd*f**2*fd - 18216*D1*Dd*f**2*g2*r**2 - 12672*D1*Dd*f**2*g2*r*s + 21384*D1*Dd*f**2*g2*r + 5544*D1*Dd*f**2*g2*s**2 + 3564*D1*Dd*f**2*g2*s - 7722*D1*Dd*f**2*g2 + 26928*D1*Dd*f**2*gd2*r**2 + 25344*D1*Dd*f**2*gd2*r*s - 43560*D1*Dd*f**2*gd2*r - 1584*D1*Dd*f**2*gd2*s**2 - 18612*D1*Dd*f**2*gd2*s + 16632*D1*Dd*f**2*gd2 + 53856*D1*Dd*f*fd*g2*r**2 + 50688*D1*Dd*f*fd*g2*r*s - 45936*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s**2 - 10296*D1*Dd*f*fd*g2*s + 5940*D1*Dd*f*fd*g2 - 22500*D1*Ddd*f**4*r**2 - 45000*D1*Ddd*f**4*r*s + 33750*D1*Ddd*f**4*r - 22500*D1*Ddd*f**4*s**2 + 33750*D1*Ddd*f**4*s - 16875*D1*Ddd*f**4 + 15912*D1*Ddd*f**3*r**2 + 24624*D1*Ddd*f**3*r*s - 22068*D1*Ddd*f**3*r + 8712*D1*Ddd*f**3*s**2 - 16668*D1*Ddd*f**3*s + 10134*D1*Ddd*f**3 + 13464*D1*Ddd*f**2*g2*r**2 + 12672*D1*Ddd*f**2*g2*r*s - 16632*D1*Ddd*f**2*g2*r - 792*D1*Ddd*f**2*g2*s**2 - 5940*D1*Ddd*f**2*g2*s + 6534*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-2*f**3*(1491*r**2 + r*(2378*s - 3680) + 887*s**2 - 3076*s + 2741) - f**2*(132*C*(5*r**2 + r*(27*s - 17) + 22*s**2 - 34*s + 17) - 99*K*(23*r**2 + 16*r*s - 46*r - 7*s**2 - 16*s + 23) - 500*fd*(27*r**2 + r*(42*s - 45) + 15*s**2 - 35*s + 14) + 3399*r**2 + 3564*r*s - 5874*r + 165*s**2 - 2640*s + 1815) + 66*f*(3*fd*(C*(8*r**2 + 20*r*(2*s - 1) + 32*s**2 - 38*s + 6) + K*(-34*r**2 - 32*r*s + 42*r + 2*s**2 + 15*s - 8) + 50*r**2 + 64*r*s - 64*r + 14*s**2 - 37*s + 20) + 2*g2*(13*r**2 + r*(51*s - 25) + 38*s**2 - 50*s + 25) - 6*gd2*(2*r**2 + 5*r*(2*s - 1) + 8*s**2 - 11*s + 3)) - 396*fd*g2*(2*r**2 + 5*r*(2*s - 1) + s*(8*s - 8))) + 2*Dd*f*(250*f**2*(36*r**2 + r*(56*s - 65) + 20*s**2 - 51*s + 28) + 99*f*(2*C*(8*r**2 + r*(40*s - 21) + 32*s**2 - 42*s + 12) + K*(-68*r**2 - 64*r*s + 110*r + 4*s**2 + 47*s - 42) + 100*r**2 + 128*r*s - 158*r + 28*s**2 - 95*s + 60) - 198*g2*(8*r**2 + r*(40*s - 21) + 32*s**2 - 42*s + 12))) - 67500*Dd**2*f**4*r**2 - 135000*Dd**2*f**4*r*s + 101250*Dd**2*f**4*r - 67500*Dd**2*f**4*s**2 + 101250*Dd**2*f**4*s - 33750*Dd**2*f**4 + 47736*Dd**2*f**3*r**2 + 73872*Dd**2*f**3*r*s - 66204*Dd**2*f**3*r + 26136*Dd**2*f**3*s**2 - 50004*Dd**2*f**3*s + 20268*Dd**2*f**3 + 40392*Dd**2*f**2*g2*r**2 + 38016*Dd**2*f**2*g2*r*s - 49896*Dd**2*f**2*g2*r - 2376*Dd**2*f**2*g2*s**2 - 17820*Dd**2*f**2*g2*s + 13068*Dd**2*f**2*g2 - 66*b1**2*(K - 1)*(D1**2*(fd*(13*r**2 + 51*r*s - 26*r + 38*s**2 - 26*s + 13) - 3*fdd*(r**2 + 5*r*s - 2*r + 4*s**2 - 2*s + 1)) + D1*(Dd*f*(52*r**2 + 204*r*s - 103*r + 152*s**2 - 178*s + 64) - 3*Dd*fd*(8*r**2 + r*(40*s - 17) + 32*s**2 - 26*s + 6) - 3*Ddd*f*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 18*s + 6)) - 9*Dd**2*f*(4*r**2 + 20*r*s - 9*r + 16*s**2 - 18*s + 4)) + b1*(-1320*C*D1**2*f*fd*r**2 - 7128*C*D1**2*f*fd*r*s + 2640*C*D1**2*f*fd*r - 5808*C*D1**2*f*fd*s**2 + 4884*C*D1**2*f*fd*s - 1320*C*D1**2*f*fd + 792*C*D1**2*f*fdd*r**2 + 3960*C*D1**2*f*fdd*r*s - 1584*C*D1**2*f*fdd*r + 3168*C*D1**2*f*fdd*s**2 - 2772*C*D1**2*f*fdd*s + 792*C*D1**2*f*fdd + 792*C*D1**2*fd**2*r**2 + 3960*C*D1**2*fd**2*r*s - 1584*C*D1**2*fd**2*r + 3168*C*D1**2*fd**2*s**2 - 2772*C*D1**2*fd**2*s + 792*C*D1**2*fd**2 - 2640*C*D1*Dd*f**2*r**2 - 14256*C*D1*Dd*f**2*r*s + 6204*C*D1*Dd*f**2*r - 11616*C*D1*Dd*f**2*s**2 + 12936*C*D1*Dd*f**2*s - 4224*C*D1*Dd*f**2 + 6336*C*D1*Dd*f*fd*r**2 + 31680*C*D1*Dd*f*fd*r*s - 13464*C*D1*Dd*f*fd*r + 25344*C*D1*Dd*f*fd*s**2 - 25344*C*D1*Dd*f*fd*s + 5940*C*D1*Dd*f*fd + 1584*C*D1*Ddd*f**2*r**2 + 7920*C*D1*Ddd*f**2*r*s - 3564*C*D1*Ddd*f**2*r + 6336*C*D1*Ddd*f**2*s**2 - 7128*C*D1*Ddd*f**2*s + 2376*C*D1*Ddd*f**2 + 4752*C*Dd**2*f**2*r**2 + 23760*C*Dd**2*f**2*r*s - 10692*C*Dd**2*f**2*r + 19008*C*Dd**2*f**2*s**2 - 21384*C*Dd**2*f**2*s + 4752*C*Dd**2*f**2 + 4554*D1**2*K*f*fd*r**2 + 3168*D1**2*K*f*fd*r*s - 1584*D1**2*K*f*fd*r - 1386*D1**2*K*f*fd*s**2 + 1386*D1**2*K*f*fd*s - 693*D1**2*K*f*fd - 3366*D1**2*K*f*fdd*r**2 - 3168*D1**2*K*f*fdd*r*s + 1584*D1**2*K*f*fdd*r + 198*D1**2*K*f*fdd*s**2 - 198*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd - 3366*D1**2*K*fd**2*r**2 - 3168*D1**2*K*fd**2*r*s + 1584*D1**2*K*fd**2*r + 198*D1**2*K*fd**2*s**2 - 198*D1**2*K*fd**2*s + 198*D1**2*bdd1*f*(K - 1)*(2*r**2 + 10*r*s - 5*r + 8*s**2 - 11*s + 4) - 8946*D1**2*f**2*fd*r**2 - 14268*D1**2*f**2*fd*r*s + 9324*D1**2*f**2*fd*r - 5322*D1**2*f**2*fd*s**2 + 6908*D1**2*f**2*fd*s - 2256*D1**2*f**2*fd + 6750*D1**2*f**2*fdd*r**2 + 10500*D1**2*f**2*fdd*r*s - 7500*D1**2*f**2*fdd*r + 3750*D1**2*f**2*fdd*s**2 - 5500*D1**2*f**2*fdd*s + 2250*D1**2*f**2*fdd + 13500*D1**2*f*fd**2*r**2 + 21000*D1**2*f*fd**2*r*s - 15000*D1**2*f*fd**2*r + 7500*D1**2*f*fd**2*s**2 - 11000*D1**2*f*fd**2*s + 4500*D1**2*f*fd**2 - 6798*D1**2*f*fd*r**2 - 7128*D1**2*f*fd*r*s + 4488*D1**2*f*fd*r - 330*D1**2*f*fd*s**2 + 1254*D1**2*f*fd*s - 1749*D1**2*f*fd + 4950*D1**2*f*fdd*r**2 + 6336*D1**2*f*fdd*r*s - 3564*D1**2*f*fdd*r + 1386*D1**2*f*fdd*s**2 - 1782*D1**2*f*fdd*s + 1485*D1**2*f*fdd + 1716*D1**2*f*gd2*r**2 + 6732*D1**2*f*gd2*r*s - 3432*D1**2*f*gd2*r + 5016*D1**2*f*gd2*s**2 - 6732*D1**2*f*gd2*s + 1716*D1**2*f*gd2 - 396*D1**2*f*gdd2*r**2 - 1980*D1**2*f*gdd2*r*s + 792*D1**2*f*gdd2*r - 1584*D1**2*f*gdd2*s**2 + 1980*D1**2*f*gdd2*s - 396*D1**2*f*gdd2 + 4950*D1**2*fd**2*r**2 + 6336*D1**2*fd**2*r*s - 3564*D1**2*fd**2*r + 1386*D1**2*fd**2*s**2 - 1782*D1**2*fd**2*s - 792*D1**2*fd**2 + 1716*D1**2*fd*g2*r**2 + 6732*D1**2*fd*g2*r*s - 3432*D1**2*fd*g2*r + 5016*D1**2*fd*g2*s**2 - 3432*D1**2*fd*g2*s + 1716*D1**2*fd*g2 - 792*D1**2*fd*gd2*r**2 - 3960*D1**2*fd*gd2*r*s + 1584*D1**2*fd*gd2*r - 3168*D1**2*fd*gd2*s**2 + 2772*D1**2*fd*gd2*s - 792*D1**2*fd*gd2 - 396*D1**2*fdd*g2*r**2 - 1980*D1**2*fdd*g2*r*s + 792*D1**2*fdd*g2*r - 1584*D1**2*fdd*g2*s**2 + 792*D1**2*fdd*g2*s - 396*D1**2*fdd*g2 + 9108*D1*Dd*K*f**2*r**2 + 6336*D1*Dd*K*f**2*r*s - 10692*D1*Dd*K*f**2*r - 2772*D1*Dd*K*f**2*s**2 - 1782*D1*Dd*K*f**2*s + 3861*D1*Dd*K*f**2 - 26928*D1*Dd*K*f*fd*r**2 - 25344*D1*Dd*K*f*fd*r*s + 22968*D1*Dd*K*f*fd*r + 1584*D1*Dd*K*f*fd*s**2 + 5148*D1*Dd*K*f*fd*s - 2970*D1*Dd*K*f*fd - 11928*D1*Dd*f**3*r**2 - 19024*D1*Dd*f**3*r*s + 16684*D1*Dd*f**3*r - 7096*D1*Dd*f**3*s**2 + 13060*D1*Dd*f**3*s - 7738*D1*Dd*f**3 + 54000*D1*Dd*f**2*fd*r**2 + 84000*D1*Dd*f**2*fd*r*s - 67500*D1*Dd*f**2*fd*r + 30000*D1*Dd*f**2*fd*s**2 - 50500*D1*Dd*f**2*fd*s + 20500*D1*Dd*f**2*fd - 13596*D1*Dd*f**2*r**2 - 14256*D1*Dd*f**2*r*s + 17160*D1*Dd*f**2*r - 660*D1*Dd*f**2*s**2 + 7458*D1*Dd*f**2*s - 6963*D1*Dd*f**2 + 39600*D1*Dd*f*fd*r**2 + 50688*D1*Dd*f*fd*r*s - 40392*D1*Dd*f*fd*r + 11088*D1*Dd*f*fd*s**2 - 22572*D1*Dd*f*fd*s + 8910*D1*Dd*f*fd + 6864*D1*Dd*f*g2*r**2 + 26928*D1*Dd*f*g2*r*s - 13596*D1*Dd*f*g2*r + 20064*D1*Dd*f*g2*s**2 - 23496*D1*Dd*f*g2*s + 8448*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 15840*D1*Dd*f*gd2*r*s + 6732*D1*Dd*f*gd2*r - 12672*D1*Dd*f*gd2*s**2 + 15048*D1*Dd*f*gd2*s - 3564*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 15840*D1*Dd*fd*g2*r*s + 6732*D1*Dd*fd*g2*r - 12672*D1*Dd*fd*g2*s**2 + 10296*D1*Dd*fd*g2*s - 2376*D1*Dd*fd*g2 - 6732*D1*Ddd*K*f**2*r**2 - 6336*D1*Ddd*K*f**2*r*s + 8316*D1*Ddd*K*f**2*r + 396*D1*Ddd*K*f**2*s**2 + 2970*D1*Ddd*K*f**2*s - 3267*D1*Ddd*K*f**2 + 9000*D1*Ddd*f**3*r**2 + 14000*D1*Ddd*f**3*r*s - 12500*D1*Ddd*f**3*r + 5000*D1*Ddd*f**3*s**2 - 9500*D1*Ddd*f**3*s + 5750*D1*Ddd*f**3 + 9900*D1*Ddd*f**2*r**2 + 12672*D1*Ddd*f**2*r*s - 13068*D1*Ddd*f**2*r + 2772*D1*Ddd*f**2*s**2 - 7722*D1*Ddd*f**2*s + 5643*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 7920*D1*Ddd*f*g2*r*s + 3564*D1*Ddd*f*g2*r - 6336*D1*Ddd*f*g2*s**2 + 7128*D1*Ddd*f*g2*s - 2376*D1*Ddd*f*g2 - 66*D1*bd1*(K - 1)*(D1*(f*(26*r**2 + 51*r*(2*s - 1) + 76*s**2 - 101*s + 38) - 3*fd*(4*r**2 + r*(20*s - 9) + 16*s**2 - 15*s + 2)) - 3*Dd*f*(16*r**2 + r*(80*s - 38) + 64*s**2 - 80*s + 21)) - 20196*Dd**2*K*f**2*r**2 - 19008*Dd**2*K*f**2*r*s + 24948*Dd**2*K*f**2*r + 1188*Dd**2*K*f**2*s**2 + 8910*Dd**2*K*f**2*s - 6534*Dd**2*K*f**2 + 27000*Dd**2*f**3*r**2 + 42000*Dd**2*f**3*r*s - 37500*Dd**2*f**3*r + 15000*Dd**2*f**3*s**2 - 28500*Dd**2*f**3*s + 11500*Dd**2*f**3 + 29700*Dd**2*f**2*r**2 + 38016*Dd**2*f**2*r*s - 39204*Dd**2*f**2*r + 8316*Dd**2*f**2*s**2 - 23166*Dd**2*f**2*s + 11286*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 23760*Dd**2*f*g2*r*s + 10692*Dd**2*f*g2*r - 19008*Dd**2*f*g2*s**2 + 21384*Dd**2*f*g2*s - 4752*Dd**2*f*g2))/(693*d**2*k3**6) + 4*D1**2*Pk2*Pk3*ct**3*k1**3*k2*(-7392*C*D1**2*bdd1*f**2*r**2 - 13992*C*D1**2*bdd1*f**2*r*s + 16632*C*D1**2*bdd1*f**2*r - 6600*C*D1**2*bdd1*f**2*s**2 + 15840*C*D1**2*bdd1*f**2*s - 7920*C*D1**2*bdd1*f**2 + 12660*C*D1**2*f**2*fd*r**2 + 64080*C*D1**2*f**2*fd*r*s - 29800*C*D1**2*f**2*fd*r + 51420*C*D1**2*f**2*fd*s**2 - 55640*C*D1**2*f**2*fd*s + 21360*C*D1**2*f**2*fd - 21180*C*D1**2*f**2*fdd*r**2 - 71640*C*D1**2*f**2*fdd*r*s + 38000*C*D1**2*f**2*fdd*r - 50460*C*D1**2*f**2*fdd*s**2 + 57520*C*D1**2*f**2*fdd*s - 23880*C*D1**2*f**2*fdd - 42360*C*D1**2*f*fd**2*r**2 - 143280*C*D1**2*f*fd**2*r*s + 76000*C*D1**2*f*fd**2*r - 100920*C*D1**2*f*fd**2*s**2 + 115040*C*D1**2*f*fd**2*s - 23880*C*D1**2*f*fd**2 + 16880*C*D1*Dd*f**3*r**2 + 85440*C*D1*Dd*f**3*r*s - 38240*C*D1*Dd*f**3*r + 68560*C*D1*Dd*f**3*s**2 - 77000*C*D1*Dd*f**3*s + 25580*C*D1*Dd*f**3 - 169440*C*D1*Dd*f**2*fd*r**2 - 573120*C*D1*Dd*f**2*fd*r*s + 308360*C*D1*Dd*f**2*fd*r - 403680*C*D1*Dd*f**2*fd*s**2 + 474280*C*D1*Dd*f**2*fd*s - 133520*C*D1*Dd*f**2*fd - 28240*C*D1*Ddd*f**3*r**2 - 95520*C*D1*Ddd*f**3*r*s + 52120*C*D1*Ddd*f**3*r - 67280*C*D1*Ddd*f**3*s**2 + 81400*C*D1*Ddd*f**3*s - 30940*C*D1*Ddd*f**3 - 84720*C*Dd**2*f**3*r**2 - 286560*C*Dd**2*f**3*r*s + 156360*C*Dd**2*f**3*r - 201840*C*Dd**2*f**3*s**2 + 244200*C*Dd**2*f**3*s - 61880*C*Dd**2*f**3 - 3960*D1**2*K*bdd1*f**2*r**2 - 13992*D1**2*K*bdd1*f**2*r*s + 7920*D1**2*K*bdd1*f**2*r - 10032*D1**2*K*bdd1*f**2*s**2 + 13992*D1**2*K*bdd1*f**2*s - 3960*D1**2*K*bdd1*f**2 + 2112*D1**2*b2*f*fd*r**2 + 4224*D1**2*b2*f*fd*r*s - 2112*D1**2*b2*f*fd*r + 2112*D1**2*b2*f*fd*s**2 - 2112*D1**2*b2*f*fd*s + 1056*D1**2*b2*f*fd - 2640*D1**2*b2*f*fdd*r**2 - 5280*D1**2*b2*f*fdd*r*s + 2640*D1**2*b2*f*fdd*r - 2640*D1**2*b2*f*fdd*s**2 + 2640*D1**2*b2*f*fdd*s - 1320*D1**2*b2*f*fdd - 2640*D1**2*b2*fd**2*r**2 - 5280*D1**2*b2*fd**2*r*s + 2640*D1**2*b2*fd**2*r - 2640*D1**2*b2*fd**2*s**2 + 2640*D1**2*b2*fd**2*s + 132*D1**2*bd1**2*(r + s - 1)*(30*f**2*(r + s - 1) + f*(24*C*r + 24*C*s + K*(-59*r - 59*s + 71) + 77*r + 77*s - 107) - 28*g2*(r + s)) + 1056*D1**2*bd2*f**2*r**2 + 2112*D1**2*bd2*f**2*r*s - 2112*D1**2*bd2*f**2*r + 1056*D1**2*bd2*f**2*s**2 - 2112*D1**2*bd2*f**2*s + 1056*D1**2*bd2*f**2 - 5280*D1**2*bd2*f*fd*r**2 - 10560*D1**2*bd2*f*fd*r*s + 7920*D1**2*bd2*f*fd*r - 5280*D1**2*bd2*f*fd*s**2 + 7920*D1**2*bd2*f*fd*s - 2640*D1**2*bd2*f*fd - 2640*D1**2*bdd1*f**3*r**2 + 2640*D1**2*bdd1*f**3*r + 2640*D1**2*bdd1*f**3*s**2 - 2640*D1**2*bdd1*f**3*s + 11022*D1**2*bdd1*f**2*r**2 + 24288*D1**2*bdd1*f**2*r*s - 23232*D1**2*bdd1*f**2*r + 13266*D1**2*bdd1*f**2*s**2 - 25476*D1**2*bdd1*f**2*s + 11220*D1**2*bdd1*f**2 + 7788*D1**2*bdd1*f*g2*r**2 + 15576*D1**2*bdd1*f*g2*r*s - 18744*D1**2*bdd1*f*g2*r + 7788*D1**2*bdd1*f*g2*s**2 - 18744*D1**2*bdd1*f*g2*s + 9372*D1**2*bdd1*f*g2 - 1320*D1**2*bdd2*f**2*r**2 - 2640*D1**2*bdd2*f**2*r*s + 2640*D1**2*bdd2*f**2*r - 1320*D1**2*bdd2*f**2*s**2 + 2640*D1**2*bdd2*f**2*s - 1320*D1**2*bdd2*f**2 - 6135*D1**2*f**2*fd*r**2 - 42330*D1**2*f**2*fd*r*s + 18200*D1**2*f**2*fd*r - 36195*D1**2*f**2*fd*s**2 + 38240*D1**2*f**2*fd*s - 14110*D1**2*f**2*fd + 14205*D1**2*f**2*fdd*r**2 + 50370*D1**2*f**2*fdd*r*s - 26260*D1**2*f**2*fdd*r + 36165*D1**2*f**2*fdd*s**2 - 40900*D1**2*f**2*fdd*s + 16790*D1**2*f**2*fdd - 3960*D1**2*f**2*gd2*r**2 - 24288*D1**2*f**2*gd2*r*s + 7920*D1**2*f**2*gd2*r - 20328*D1**2*f**2*gd2*s**2 + 24288*D1**2*f**2*gd2*s - 3960*D1**2*f**2*gd2 + 7920*D1**2*f**2*gdd2*r**2 + 27984*D1**2*f**2*gdd2*r*s - 15840*D1**2*f**2*gdd2*r + 20064*D1**2*f**2*gdd2*s**2 - 27984*D1**2*f**2*gdd2*s + 7920*D1**2*f**2*gdd2 + 28410*D1**2*f*fd**2*r**2 + 100740*D1**2*f*fd**2*r*s - 52520*D1**2*f*fd**2*r + 72330*D1**2*f*fd**2*s**2 - 81800*D1**2*f*fd**2*s + 16790*D1**2*f*fd**2 - 7920*D1**2*f*fd*g2*r**2 - 48576*D1**2*f*fd*g2*r*s + 24288*D1**2*f*fd*g2*r - 40656*D1**2*f*fd*g2*s**2 + 40656*D1**2*f*fd*g2*s - 20328*D1**2*f*fd*g2 + 31680*D1**2*f*fd*gd2*r**2 + 111936*D1**2*f*fd*gd2*r*s - 59664*D1**2*f*fd*gd2*r + 80256*D1**2*f*fd*gd2*s**2 - 96096*D1**2*f*fd*gd2*s + 27984*D1**2*f*fd*gd2 + 15840*D1**2*f*fdd*g2*r**2 + 55968*D1**2*f*fdd*g2*r*s - 27984*D1**2*f*fdd*g2*r + 40128*D1**2*f*fdd*g2*s**2 - 40128*D1**2*f*fdd*g2*s + 20064*D1**2*f*fdd*g2 + 15840*D1**2*fd**2*g2*r**2 + 55968*D1**2*fd**2*g2*r*s - 27984*D1**2*fd**2*g2*r + 40128*D1**2*fd**2*g2*s**2 - 40128*D1**2*fd**2*g2*s + 4224*D1*Dd*b2*f**2*r**2 + 8448*D1*Dd*b2*f**2*r*s - 6336*D1*Dd*b2*f**2*r + 4224*D1*Dd*b2*f**2*s**2 - 6336*D1*Dd*b2*f**2*s + 3168*D1*Dd*b2*f**2 - 21120*D1*Dd*b2*f*fd*r**2 - 42240*D1*Dd*b2*f*fd*r*s + 26400*D1*Dd*b2*f*fd*r - 21120*D1*Dd*b2*f*fd*s**2 + 26400*D1*Dd*b2*f*fd*s - 7920*D1*Dd*b2*f*fd - 10560*D1*Dd*bd2*f**2*r**2 - 21120*D1*Dd*bd2*f**2*r*s + 18480*D1*Dd*bd2*f**2*r - 10560*D1*Dd*bd2*f**2*s**2 + 18480*D1*Dd*bd2*f**2*s - 7920*D1*Dd*bd2*f**2 - 8180*D1*Dd*f**3*r**2 - 56440*D1*Dd*f**3*r*s + 22290*D1*Dd*f**3*r - 48260*D1*Dd*f**3*s**2 + 52350*D1*Dd*f**3*s - 16155*D1*Dd*f**3 + 113640*D1*Dd*f**2*fd*r**2 + 402960*D1*Dd*f**2*fd*r*s - 212230*D1*Dd*f**2*fd*r + 289320*D1*Dd*f**2*fd*s**2 - 336670*D1*Dd*f**2*fd*s + 93420*D1*Dd*f**2*fd - 15840*D1*Dd*f**2*g2*r**2 - 97152*D1*Dd*f**2*g2*r*s + 40128*D1*Dd*f**2*g2*r - 81312*D1*Dd*f**2*g2*s**2 + 89232*D1*Dd*f**2*g2*s - 28248*D1*Dd*f**2*g2 + 63360*D1*Dd*f**2*gd2*r**2 + 223872*D1*Dd*f**2*gd2*r*s - 123024*D1*Dd*f**2*gd2*r + 160512*D1*Dd*f**2*gd2*s**2 - 208032*D1*Dd*f**2*gd2*s + 59664*D1*Dd*f**2*gd2 + 126720*D1*Dd*f*fd*g2*r**2 + 447744*D1*Dd*f*fd*g2*r*s - 231264*D1*Dd*f*fd*g2*r + 321024*D1*Dd*f*fd*g2*s**2 - 352704*D1*Dd*f*fd*g2*s + 96096*D1*Dd*f*fd*g2 - 5280*D1*Ddd*b2*f**2*r**2 - 10560*D1*Ddd*b2*f**2*r*s + 7920*D1*Ddd*b2*f**2*r - 5280*D1*Ddd*b2*f**2*s**2 + 7920*D1*Ddd*b2*f**2*s - 3960*D1*Ddd*b2*f**2 + 18940*D1*Ddd*f**3*r**2 + 67160*D1*Ddd*f**3*r*s - 35730*D1*Ddd*f**3*r + 48220*D1*Ddd*f**3*s**2 - 57690*D1*Ddd*f**3*s + 21525*D1*Ddd*f**3 + 31680*D1*Ddd*f**2*g2*r**2 + 111936*D1*Ddd*f**2*g2*r*s - 59664*D1*Ddd*f**2*g2*r + 80256*D1*Ddd*f**2*g2*s**2 - 96096*D1*Ddd*f**2*g2*s + 35904*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(5*f**3*(10*r**2 + 4*r*(s - 4) - 6*s**2 + 7) + f**2*(4*C*(29*r**2 + r*(58*s - 66) + 29*s**2 - 66*s + 33) + 30*K*r**2 + 184*K*r*s - 60*K*r + 154*K*s**2 - 184*K*s + 30*K - 40*fd*(6*r**2 - 6*r - 6*s**2 + 4*s + 1) - 145*r**2 - 358*r*s + 314*r - 213*s**2 + 382*s - 157) - 2*f*(fd*(2*C*(112*r**2 + 4*r*(53*s - 43) + 100*s**2 - 163*s + 63) + 2*K*(60*r**2 + 212*r*s - 113*r + 152*s**2 - 182*s + 53) - 334*r**2 - 736*r*s + 527*r - 402*s**2 + 578*s - 199) + g2*(55*r**2 + 4*r*(31*s - 36) + 69*s**2 - 158*s + 79) - 2*gd2*(59*r**2 + 2*r*(59*s - 65) + 59*s**2 - 130*s + 71)) + 236*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(20*f**2*(8*r**2 - 8*r - 8*s**2 + 6*s + 1) + f*(C*(448*r**2 + r*(848*s - 834) + 400*s**2 - 792*s + 372) + K*(240*r**2 + 848*r*s - 466*r + 608*s**2 - 788*s + 226) - 668*r**2 - 1472*r*s + 1222*r - 804*s**2 + 1341*s - 545) - 2*g2*(236*r**2 + r*(472*s - 461) + 236*s**2 - 461*s + 213))) - 15840*Dd**2*b2*f**2*r**2 - 31680*Dd**2*b2*f**2*r*s + 23760*Dd**2*b2*f**2*r - 15840*Dd**2*b2*f**2*s**2 + 23760*Dd**2*b2*f**2*s - 7920*Dd**2*b2*f**2 + 56820*Dd**2*f**3*r**2 + 201480*Dd**2*f**3*r*s - 107190*Dd**2*f**3*r + 144660*Dd**2*f**3*s**2 - 173070*Dd**2*f**3*s + 43050*Dd**2*f**3 + 95040*Dd**2*f**2*g2*r**2 + 335808*Dd**2*f**2*g2*r*s - 178992*Dd**2*f**2*g2*r + 240768*Dd**2*f**2*g2*s**2 - 288288*Dd**2*f**2*g2*s + 71808*Dd**2*f**2*g2 - 924*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 66*b1**2*(20*C*D1**2*fd*r**2 + 40*C*D1**2*fd*r*s - 40*C*D1**2*fd*r + 20*C*D1**2*fd*s**2 - 40*C*D1**2*fd*s + 20*C*D1**2*fd - 24*C*D1**2*fdd*r**2 - 48*C*D1**2*fdd*r*s + 48*C*D1**2*fdd*r - 24*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s - 24*C*D1**2*fdd + 80*C*D1*Dd*f*r**2 + 160*C*D1*Dd*f*r*s - 120*C*D1*Dd*f*r + 80*C*D1*Dd*f*s**2 - 120*C*D1*Dd*f*s + 60*C*D1*Dd*f - 192*C*D1*Dd*fd*r**2 - 384*C*D1*Dd*fd*r*s + 336*C*D1*Dd*fd*r - 192*C*D1*Dd*fd*s**2 + 336*C*D1*Dd*fd*s - 144*C*D1*Dd*fd - 96*C*D1*Ddd*f*r**2 - 192*C*D1*Ddd*f*r*s + 144*C*D1*Ddd*f*r - 96*C*D1*Ddd*f*s**2 + 144*C*D1*Ddd*f*s - 72*C*D1*Ddd*f - 288*C*Dd**2*f*r**2 - 576*C*Dd**2*f*r*s + 432*C*Dd**2*f*r - 288*C*Dd**2*f*s**2 + 432*C*Dd**2*f*s - 144*C*Dd**2*f - 55*D1**2*K*fd*r**2 - 124*D1**2*K*fd*r*s - 20*D1**2*K*fd*r - 69*D1**2*K*fd*s**2 - 20*D1**2*K*fd*s + 10*D1**2*K*fd + 59*D1**2*K*fdd*r**2 + 118*D1**2*K*fdd*r*s + 24*D1**2*K*fdd*r + 59*D1**2*K*fdd*s**2 + 24*D1**2*K*fdd*s - 12*D1**2*K*fdd - 14*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 72*D1**2*f*fd*r**2 + 144*D1**2*f*fd*r*s - 84*D1**2*f*fd*r + 72*D1**2*f*fd*s**2 - 84*D1**2*f*fd*s + 42*D1**2*f*fd - 60*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 60*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s - 30*D1**2*f*fdd - 60*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 60*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s + 77*D1**2*fd*r**2 + 168*D1**2*fd*r*s + 50*D1**2*fd*r + 91*D1**2*fd*s**2 + 50*D1**2*fd*s - 25*D1**2*fd - 77*D1**2*fdd*r**2 - 154*D1**2*fdd*r*s - 60*D1**2*fdd*r - 77*D1**2*fdd*s**2 - 60*D1**2*fdd*s + 30*D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 - 220*D1*Dd*K*f*r**2 - 496*D1*Dd*K*f*r*s + 344*D1*Dd*K*f*r - 276*D1*Dd*K*f*s**2 + 386*D1*Dd*K*f*s - 179*D1*Dd*K*f + 472*D1*Dd*K*fd*r**2 + 944*D1*Dd*K*fd*r*s - 258*D1*Dd*K*fd*r + 472*D1*Dd*K*fd*s**2 - 258*D1*Dd*K*fd*s - 72*D1*Dd*K*fd + 144*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 216*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 216*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 480*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 600*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 600*D1*Dd*f*fd*s - 180*D1*Dd*f*fd + 308*D1*Dd*f*r**2 + 672*D1*Dd*f*r*s - 476*D1*Dd*f*r + 364*D1*Dd*f*s**2 - 518*D1*Dd*f*s + 245*D1*Dd*f - 616*D1*Dd*fd*r**2 - 1232*D1*Dd*fd*r*s + 222*D1*Dd*fd*r - 616*D1*Dd*fd*s**2 + 222*D1*Dd*fd*s + 180*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 + 236*D1*Ddd*K*f*r**2 + 472*D1*Ddd*K*f*r*s - 354*D1*Ddd*K*f*r + 236*D1*Ddd*K*f*s**2 - 354*D1*Ddd*K*f*s + 177*D1*Ddd*K*f - 120*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 90*D1*Ddd*f**2 - 308*D1*Ddd*f*r**2 - 616*D1*Ddd*f*r*s + 462*D1*Ddd*f*r - 308*D1*Ddd*f*s**2 + 462*D1*Ddd*f*s - 231*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 708*Dd**2*K*f*r**2 + 1416*Dd**2*K*f*r*s - 1062*Dd**2*K*f*r + 708*Dd**2*K*f*s**2 - 1062*Dd**2*K*f*s + 354*Dd**2*K*f - 360*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 540*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 180*Dd**2*f**2 - 924*Dd**2*f*r**2 - 1848*Dd**2*f*r*s + 1386*Dd**2*f*r - 924*Dd**2*f*s**2 + 1386*Dd**2*f*s - 462*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) + 66*b1*(232*C*D1**2*f*fd*r**2 + 464*C*D1**2*f*fd*r*s - 200*C*D1**2*f*fd*r + 232*C*D1**2*f*fd*s**2 - 200*C*D1**2*f*fd*s + 100*C*D1**2*f*fd - 224*C*D1**2*f*fdd*r**2 - 424*C*D1**2*f*fdd*r*s + 184*C*D1**2*f*fdd*r - 200*C*D1**2*f*fdd*s**2 + 172*C*D1**2*f*fdd*s - 92*C*D1**2*f*fdd - 224*C*D1**2*fd**2*r**2 - 424*C*D1**2*fd**2*r*s + 184*C*D1**2*fd**2*r - 200*C*D1**2*fd**2*s**2 + 172*C*D1**2*fd**2*s + 40*C*D1**2*fd**2 + 464*C*D1*Dd*f**2*r**2 + 928*C*D1*Dd*f**2*r*s - 696*C*D1*Dd*f**2*r + 464*C*D1*Dd*f**2*s**2 - 696*C*D1*Dd*f**2*s + 348*C*D1*Dd*f**2 - 1792*C*D1*Dd*f*fd*r**2 - 3392*C*D1*Dd*f*fd*r*s + 2056*C*D1*Dd*f*fd*r - 1600*C*D1*Dd*f*fd*s**2 + 1936*C*D1*Dd*f*fd*s - 540*C*D1*Dd*f*fd - 448*C*D1*Ddd*f**2*r**2 - 848*C*D1*Ddd*f**2*r*s + 660*C*D1*Ddd*f**2*r - 400*C*D1*Ddd*f**2*s**2 + 624*C*D1*Ddd*f**2*s - 324*C*D1*Ddd*f**2 - 1344*C*Dd**2*f**2*r**2 - 2544*C*Dd**2*f**2*r*s + 1980*C*Dd**2*f**2*r - 1200*C*Dd**2*f**2*s**2 + 1872*C*Dd**2*f**2*s - 648*C*Dd**2*f**2 + 60*D1**2*K*f*fd*r**2 + 368*D1**2*K*f*fd*r*s - 184*D1**2*K*f*fd*r + 308*D1**2*K*f*fd*s**2 - 308*D1**2*K*f*fd*s + 154*D1**2*K*f*fd - 120*D1**2*K*f*fdd*r**2 - 424*D1**2*K*f*fdd*r*s + 212*D1**2*K*f*fdd*r - 304*D1**2*K*f*fdd*s**2 + 304*D1**2*K*f*fdd*s - 152*D1**2*K*f*fdd - 120*D1**2*K*fd**2*r**2 - 424*D1**2*K*fd**2*r*s + 212*D1**2*K*fd**2*r - 304*D1**2*K*fd**2*s**2 + 304*D1**2*K*fd**2*s + 28*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(30*f**2*(r + s - 1)**2 + f*(12*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - K*(59*r**2 + 2*r*(59*s - 65) + 59*s**2 - 130*s + 65) + 77*r**2 + 154*r*s - 184*r + 77*s**2 - 184*s + 92) - 14*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 150*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 140*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s + 35*D1**2*f**2*fd - 120*D1**2*f**2*fdd*r**2 + 120*D1**2*f**2*fdd*r + 120*D1**2*f**2*fdd*s**2 - 40*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd - 240*D1**2*f*fd**2*r**2 + 240*D1**2*f*fd**2*r + 240*D1**2*f*fd**2*s**2 - 80*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 - 290*D1**2*f*fd*r**2 - 716*D1**2*f*fd*r*s + 334*D1**2*f*fd*r - 426*D1**2*f*fd*s**2 + 402*D1**2*f*fd*s - 201*D1**2*f*fd + 334*D1**2*f*fdd*r**2 + 736*D1**2*f*fdd*r*s - 350*D1**2*f*fdd*r + 402*D1**2*f*fdd*s**2 - 384*D1**2*f*fdd*s + 198*D1**2*f*fdd - 110*D1**2*f*gd2*r**2 - 248*D1**2*f*gd2*r*s + 220*D1**2*f*gd2*r - 138*D1**2*f*gd2*s**2 + 248*D1**2*f*gd2*s - 110*D1**2*f*gd2 + 118*D1**2*f*gdd2*r**2 + 236*D1**2*f*gdd2*r*s - 236*D1**2*f*gdd2*r + 118*D1**2*f*gdd2*s**2 - 236*D1**2*f*gdd2*s + 118*D1**2*f*gdd2 + 334*D1**2*fd**2*r**2 + 736*D1**2*fd**2*r*s - 350*D1**2*fd**2*r + 402*D1**2*fd**2*s**2 - 384*D1**2*fd**2*s - 30*D1**2*fd**2 - 110*D1**2*fd*g2*r**2 - 248*D1**2*fd*g2*r*s - 40*D1**2*fd*g2*r - 138*D1**2*fd*g2*s**2 - 40*D1**2*fd*g2*s + 20*D1**2*fd*g2 + 236*D1**2*fd*gd2*r**2 + 472*D1**2*fd*gd2*r*s - 188*D1**2*fd*gd2*r + 236*D1**2*fd*gd2*s**2 - 188*D1**2*fd*gd2*s - 48*D1**2*fd*gd2 + 118*D1**2*fdd*g2*r**2 + 236*D1**2*fdd*g2*r*s + 48*D1**2*fdd*g2*r + 118*D1**2*fdd*g2*s**2 + 48*D1**2*fdd*g2*s - 24*D1**2*fdd*g2 + 120*D1*Dd*K*f**2*r**2 + 736*D1*Dd*K*f**2*r*s - 304*D1*Dd*K*f**2*r + 616*D1*Dd*K*f**2*s**2 - 676*D1*Dd*K*f**2*s + 214*D1*Dd*K*f**2 - 960*D1*Dd*K*f*fd*r**2 - 3392*D1*Dd*K*f*fd*r*s + 1752*D1*Dd*K*f*fd*r - 2432*D1*Dd*K*f*fd*s**2 + 2672*D1*Dd*K*f*fd*s - 728*D1*Dd*K*f*fd + 200*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 220*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s + 70*D1*Dd*f**3 - 960*D1*Dd*f**2*fd*r**2 + 960*D1*Dd*f**2*fd*r + 960*D1*Dd*f**2*fd*s**2 - 400*D1*Dd*f**2*fd*s - 200*D1*Dd*f**2*fd - 580*D1*Dd*f**2*r**2 - 1432*D1*Dd*f**2*r*s + 938*D1*Dd*f**2*r - 852*D1*Dd*f**2*s**2 + 1142*D1*Dd*f**2*s - 503*D1*Dd*f**2 + 2672*D1*Dd*f*fd*r**2 + 5888*D1*Dd*f*fd*r*s - 3472*D1*Dd*f*fd*r + 3216*D1*Dd*f*fd*s**2 - 3812*D1*Dd*f*fd*s + 1084*D1*Dd*f*fd - 440*D1*Dd*f*g2*r**2 - 992*D1*Dd*f*g2*r*s + 688*D1*Dd*f*g2*r - 552*D1*Dd*f*g2*s**2 + 772*D1*Dd*f*g2*s - 358*D1*Dd*f*g2 + 944*D1*Dd*f*gd2*r**2 + 1888*D1*Dd*f*gd2*r*s - 1652*D1*Dd*f*gd2*r + 944*D1*Dd*f*gd2*s**2 - 1652*D1*Dd*f*gd2*s + 708*D1*Dd*f*gd2 + 944*D1*Dd*fd*g2*r**2 + 1888*D1*Dd*fd*g2*r*s - 516*D1*Dd*fd*g2*r + 944*D1*Dd*fd*g2*s**2 - 516*D1*Dd*fd*g2*s - 144*D1*Dd*fd*g2 - 240*D1*Ddd*K*f**2*r**2 - 848*D1*Ddd*K*f**2*r*s + 452*D1*Ddd*K*f**2*r - 608*D1*Ddd*K*f**2*s**2 + 728*D1*Ddd*K*f**2*s - 272*D1*Ddd*K*f**2 - 160*D1*Ddd*f**3*r**2 + 160*D1*Ddd*f**3*r + 160*D1*Ddd*f**3*s**2 - 80*D1*Ddd*f**3*s - 40*D1*Ddd*f**3 + 668*D1*Ddd*f**2*r**2 + 1472*D1*Ddd*f**2*r*s - 1036*D1*Ddd*f**2*r + 804*D1*Ddd*f**2*s**2 - 1138*D1*Ddd*f**2*s + 535*D1*Ddd*f**2 + 472*D1*Ddd*f*g2*r**2 + 944*D1*Ddd*f*g2*r*s - 708*D1*Ddd*f*g2*r + 472*D1*Ddd*f*g2*s**2 - 708*D1*Ddd*f*g2*s + 354*D1*Ddd*f*g2 + D1*bd1*(D1*(-6*f**2*(12*r**2 + r*(24*s - 22) + 12*s**2 - 22*s + 11) + f*(-20*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 110*K*r**2 + 248*K*r*s - 254*K*r + 138*K*s**2 - 282*K*s + 134*K + 120*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 154*r**2 - 336*r*s + 372*r - 182*s**2 + 400*s - 193) + 4*fd*(r + s - 1)*(12*C*(2*r + 2*s - 1) - K*(59*r + 59*s + 6) + 77*r + 77*s + 15) + 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(4*r + 4*s - 3)*(30*f**2*(r + s - 1) + f*(12*C*(2*r + 2*s - 1) + K*(-59*r - 59*s + 65) + 77*r + 77*s - 92) - 14*g2*(2*r + 2*s - 1))) - 720*Dd**2*K*f**2*r**2 - 2544*Dd**2*K*f**2*r*s + 1356*Dd**2*K*f**2*r - 1824*Dd**2*K*f**2*s**2 + 2184*Dd**2*K*f**2*s - 544*Dd**2*K*f**2 - 480*Dd**2*f**3*r**2 + 480*Dd**2*f**3*r + 480*Dd**2*f**3*s**2 - 240*Dd**2*f**3*s - 80*Dd**2*f**3 + 2004*Dd**2*f**2*r**2 + 4416*Dd**2*f**2*r*s - 3108*Dd**2*f**2*r + 2412*Dd**2*f**2*s**2 - 3414*Dd**2*f**2*s + 1070*Dd**2*f**2 + 1416*Dd**2*f*g2*r**2 + 2832*Dd**2*f*g2*r*s - 2124*Dd**2*f*g2*r + 1416*Dd**2*f*g2*s**2 - 2124*Dd**2*f*g2*s + 708*Dd**2*f*g2))/(693*d**2*k3**6) - 8*D1**2*Pk2*Pk3*ct**3*k1**3*st**2*(b1*(D1**2*(250*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-500*fd**2*s*(3*s - 2) + 198*fd*(2*s**2 - 2*s + 1) - 99*fdd*(2*s**2 - 2*s + 1)) - 198*fd**2*s*(s - 1)) + D1*f*(2*Dd*(250*f**2*(4*s**2 - 2*s + 1) - 250*f*fd*(12*s**2 - 7*s + 1) + 99*f*(4*s**2 - 2*s + 1) - 99*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(250*f + 99)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(250*f + 99)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(500*bd1 - 250*bdd1) + f*(-50*fd*(s**2*(30*bd1 - 9) + s*(6 - 10*bd1) - 3) - 75*fdd*(3*s**2 - 2*s + 1) + s**2*(198*bd1 - 99*bdd1)) - 6*fd*s*(33*bd1*(2*s - 1) + 25*fd*(3*s - 2))) + D1*f*(-50*Dd*f*(s**2*(40*bd1 - 12) + s*(6 - 10*bd1) - 3) - 6*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 75*Ddd*f*(4*s**2 - 2*s + 1)) + 450*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2**3*k3**2) - 4*D1**2*Pk2*Pk3*ct**3*k1**3*(132*b1**2*(D1**2*s**2*(-10*fd**2 + fd*(20*f + 6) - fdd*(10*f + 3)) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(s**2*(12 - 40*fd) + s*(10*fd - 6) + 3) + 3*fd*s*(1 - 4*s)) - Ddd*f*(5*f + 3)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 3)*(2*s - 1)) + 66*b1*(-2*D1**2*bdd1*f*(5*f + 3)*(2*s**2 - 2*s + 1) - 165*D1**2*f**2*fd*s**2 + 110*D1**2*f**2*fd*s - 55*D1**2*f**2*fd + 105*D1**2*f**2*fdd*s**2 - 70*D1**2*f**2*fdd*s + 35*D1**2*f**2*fdd + 210*D1**2*f*fd**2*s**2 - 140*D1**2*f*fd**2*s - 42*D1**2*f*fd*s**2 + 62*D1**2*f*fd*s - 31*D1**2*f*fd + 30*D1**2*f*fdd*s**2 - 40*D1**2*f*fdd*s + 20*D1**2*f*fdd + 30*D1**2*fd**2*s**2 - 40*D1**2*fd**2*s - 220*D1*Dd*f**3*s**2 + 110*D1*Dd*f**3*s - 55*D1*Dd*f**3 + 840*D1*Dd*f**2*fd*s**2 - 490*D1*Dd*f**2*fd*s + 70*D1*Dd*f**2*fd - 84*D1*Dd*f**2*s**2 + 42*D1*Dd*f**2*s - 21*D1*Dd*f**2 + 240*D1*Dd*f*fd*s**2 - 220*D1*Dd*f*fd*s + 40*D1*Dd*f*fd + 140*D1*Ddd*f**3*s**2 - 70*D1*Ddd*f**3*s + 35*D1*Ddd*f**3 + 60*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 4*D1*bd1*(D1*(5*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(6 - 20*fd) + s*(10*fd - 6) + 3) + 3*fd*s*(1 - 2*s)) - Dd*f*(5*f + 3)*(8*s**2 - 6*s + 1)) + 420*Dd**2*f**3*s**2 - 210*Dd**2*f**3*s + 180*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s) + f*(-264*D1**2*bd1**2*s*(5*f + 3)*(s - 1) + 330*D1**2*bdd1*f*(s**2*(7*f + 3) + 2*s - 1) + 5*D1**2*(-f*(343*fd - 221*fdd)*(3*s**2 - 2*s + 1) + 442*fd**2*s*(3*s - 2)) - 66*D1*bd1*(D1*(55*f**2*s**2 + f*(s**2*(21 - 210*fd) + s*(70*fd + 20) - 10) + 20*fd*s*(1 - 3*s)) - 10*Dd*f*(4*s - 1)*(s*(7*f + 3) + 1)) + 5*D1*f*(-343*Dd*f*(4*s**2 - 2*s + 1) + 442*Dd*fd*(12*s**2 - 7*s + 1) + 221*Ddd*f*(4*s**2 - 2*s + 1)) + 6630*Dd**2*f**2*s*(2*s - 1)))/(693*d**2*k2**3*k3**2) + 8*D1**2*Pk2*Pk3*ct**3*k1*k2**5*st**2*(396*C*D1**2*bdd1*f**2*r**2 + 792*C*D1**2*bdd1*f**2*r*s - 792*C*D1**2*bdd1*f**2*r + 396*C*D1**2*bdd1*f**2*s**2 - 792*C*D1**2*bdd1*f**2*s + 396*C*D1**2*bdd1*f**2 - 3624*C*D1**2*f**2*fd*r**2 - 7248*C*D1**2*f**2*fd*r*s + 4832*C*D1**2*f**2*fd*r - 3624*C*D1**2*f**2*fd*s**2 + 4832*C*D1**2*f**2*fd*s - 2416*C*D1**2*f**2*fd + 3000*C*D1**2*f**2*fdd*r**2 + 6000*C*D1**2*f**2*fdd*r*s - 4000*C*D1**2*f**2*fdd*r + 3000*C*D1**2*f**2*fdd*s**2 - 4000*C*D1**2*f**2*fdd*s + 2000*C*D1**2*f**2*fdd + 6000*C*D1**2*f*fd**2*r**2 + 12000*C*D1**2*f*fd**2*r*s - 8000*C*D1**2*f*fd**2*r + 6000*C*D1**2*f*fd**2*s**2 - 8000*C*D1**2*f*fd**2*s + 2000*C*D1**2*f*fd**2 - 4832*C*D1*Dd*f**3*r**2 - 9664*C*D1*Dd*f**3*r*s + 7248*C*D1*Dd*f**3*r - 4832*C*D1*Dd*f**3*s**2 + 7248*C*D1*Dd*f**3*s - 3624*C*D1*Dd*f**3 + 24000*C*D1*Dd*f**2*fd*r**2 + 48000*C*D1*Dd*f**2*fd*r*s - 34000*C*D1*Dd*f**2*fd*r + 24000*C*D1*Dd*f**2*fd*s**2 - 34000*C*D1*Dd*f**2*fd*s + 12000*C*D1*Dd*f**2*fd + 4000*C*D1*Ddd*f**3*r**2 + 8000*C*D1*Ddd*f**3*r*s - 6000*C*D1*Ddd*f**3*r + 4000*C*D1*Ddd*f**3*s**2 - 6000*C*D1*Ddd*f**3*s + 3000*C*D1*Ddd*f**3 + 12000*C*Dd**2*f**3*r**2 + 24000*C*Dd**2*f**3*r*s - 18000*C*Dd**2*f**3*r + 12000*C*Dd**2*f**3*s**2 - 18000*C*Dd**2*f**3*s + 6000*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r**2 + 1320*D1**2*K*bdd1*f**2*r*s - 1320*D1**2*K*bdd1*f**2*r + 660*D1**2*K*bdd1*f**2*s**2 - 1320*D1**2*K*bdd1*f**2*s + 660*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(-6*K + 5*f + 3)*(r + s - 1)**2 - 297*D1**2*bdd1*f**2*r**2 - 594*D1**2*bdd1*f**2*r*s + 594*D1**2*bdd1*f**2*r - 297*D1**2*bdd1*f**2*s**2 + 594*D1**2*bdd1*f**2*s - 297*D1**2*bdd1*f**2 - 396*D1**2*bdd1*f*g2*r**2 - 792*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r - 396*D1**2*bdd1*f*g2*s**2 + 792*D1**2*bdd1*f*g2*s - 396*D1**2*bdd1*f*g2 + 1515*D1**2*f**2*fd*r**2 + 3030*D1**2*f**2*fd*r*s - 2020*D1**2*f**2*fd*r + 1515*D1**2*f**2*fd*s**2 - 2020*D1**2*f**2*fd*s + 1010*D1**2*f**2*fd - 1500*D1**2*f**2*fdd*r**2 - 3000*D1**2*f**2*fdd*r*s + 2000*D1**2*f**2*fdd*r - 1500*D1**2*f**2*fdd*s**2 + 2000*D1**2*f**2*fdd*s - 1000*D1**2*f**2*fdd + 1848*D1**2*f**2*gd2*r**2 + 3696*D1**2*f**2*gd2*r*s - 3696*D1**2*f**2*gd2*r + 1848*D1**2*f**2*gd2*s**2 - 3696*D1**2*f**2*gd2*s + 1848*D1**2*f**2*gd2 - 1320*D1**2*f**2*gdd2*r**2 - 2640*D1**2*f**2*gdd2*r*s + 2640*D1**2*f**2*gdd2*r - 1320*D1**2*f**2*gdd2*s**2 + 2640*D1**2*f**2*gdd2*s - 1320*D1**2*f**2*gdd2 - 3000*D1**2*f*fd**2*r**2 - 6000*D1**2*f*fd**2*r*s + 4000*D1**2*f*fd**2*r - 3000*D1**2*f*fd**2*s**2 + 4000*D1**2*f*fd**2*s - 1000*D1**2*f*fd**2 + 3696*D1**2*f*fd*g2*r**2 + 7392*D1**2*f*fd*g2*r*s - 3696*D1**2*f*fd*g2*r + 3696*D1**2*f*fd*g2*s**2 - 3696*D1**2*f*fd*g2*s + 1848*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r**2 - 10560*D1**2*f*fd*gd2*r*s + 7920*D1**2*f*fd*gd2*r - 5280*D1**2*f*fd*gd2*s**2 + 7920*D1**2*f*fd*gd2*s - 2640*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r**2 - 5280*D1**2*f*fdd*g2*r*s + 2640*D1**2*f*fdd*g2*r - 2640*D1**2*f*fdd*g2*s**2 + 2640*D1**2*f*fdd*g2*s - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r**2 - 5280*D1**2*fd**2*g2*r*s + 2640*D1**2*fd**2*g2*r - 2640*D1**2*fd**2*g2*s**2 + 2640*D1**2*fd**2*g2*s + 2020*D1*Dd*f**3*r**2 + 4040*D1*Dd*f**3*r*s - 3030*D1*Dd*f**3*r + 2020*D1*Dd*f**3*s**2 - 3030*D1*Dd*f**3*s + 1515*D1*Dd*f**3 - 12000*D1*Dd*f**2*fd*r**2 - 24000*D1*Dd*f**2*fd*r*s + 17000*D1*Dd*f**2*fd*r - 12000*D1*Dd*f**2*fd*s**2 + 17000*D1*Dd*f**2*fd*s - 6000*D1*Dd*f**2*fd + 7392*D1*Dd*f**2*g2*r**2 + 14784*D1*Dd*f**2*g2*r*s - 11088*D1*Dd*f**2*g2*r + 7392*D1*Dd*f**2*g2*s**2 - 11088*D1*Dd*f**2*g2*s + 5544*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r**2 - 21120*D1*Dd*f**2*gd2*r*s + 18480*D1*Dd*f**2*gd2*r - 10560*D1*Dd*f**2*gd2*s**2 + 18480*D1*Dd*f**2*gd2*s - 7920*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r**2 - 42240*D1*Dd*f*fd*g2*r*s + 26400*D1*Dd*f*fd*g2*r - 21120*D1*Dd*f*fd*g2*s**2 + 26400*D1*Dd*f*fd*g2*s - 7920*D1*Dd*f*fd*g2 - 2000*D1*Ddd*f**3*r**2 - 4000*D1*Ddd*f**3*r*s + 3000*D1*Ddd*f**3*r - 2000*D1*Ddd*f**3*s**2 + 3000*D1*Ddd*f**3*s - 1500*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r**2 - 10560*D1*Ddd*f**2*g2*r*s + 7920*D1*Ddd*f**2*g2*r - 5280*D1*Ddd*f**2*g2*s**2 + 7920*D1*Ddd*f**2*g2*s - 3960*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(24*C + 28*K - 15)*(r + s - 1) - 2*f*(fd*(12*C + 20*K - 9)*(2*r + 2*s - 1) + (12*g2 - 12*gd2)*(r + s - 1)) + 24*fd*g2*(r + s)) - 2*Dd*f*(f*(12*C + 20*K - 9) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6000*Dd**2*f**3*r**2 - 12000*Dd**2*f**3*r*s + 9000*Dd**2*f**3*r - 6000*Dd**2*f**3*s**2 + 9000*Dd**2*f**3*s - 3000*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r**2 - 31680*Dd**2*f**2*g2*r*s + 23760*Dd**2*f**2*g2*r - 15840*Dd**2*f**2*g2*s**2 + 23760*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 6*fd*(2*K - 1)*(r + s) - 3*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (6*K - 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 3*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-6*K + 5*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-6*K + 5*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-48*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 144*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 56*D1**2*K*f*fd*r**2 - 112*D1**2*K*f*fd*r*s + 56*D1**2*K*f*fd*r - 56*D1**2*K*f*fd*s**2 + 56*D1**2*K*f*fd*s - 28*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-6*K + 5*f + 3)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 30*D1**2*f*fd*r**2 + 60*D1**2*f*fd*r*s - 30*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 30*D1**2*f*fd*s + 15*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 24*D1**2*f*gd2*r**2 + 48*D1**2*f*gd2*r*s - 48*D1**2*f*gd2*r + 24*D1**2*f*gd2*s**2 - 48*D1**2*f*gd2*s + 24*D1**2*f*gd2 - 12*D1**2*f*gdd2*r**2 - 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*r - 12*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 12*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 24*D1**2*fd*g2*r**2 + 48*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r**2 - 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 24*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r**2 - 24*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 112*D1*Dd*K*f**2*r**2 - 224*D1*Dd*K*f**2*r*s + 168*D1*Dd*K*f**2*r - 112*D1*Dd*K*f**2*s**2 + 168*D1*Dd*K*f**2*s - 84*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 60*D1*Dd*f**2*r**2 + 120*D1*Dd*f**2*r*s - 90*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 90*D1*Dd*f**2*s + 45*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 96*D1*Dd*f*g2*r**2 + 192*D1*Dd*f*g2*r*s - 144*D1*Dd*f*g2*r + 96*D1*Dd*f*g2*s**2 - 144*D1*Dd*f*g2*s + 72*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r**2 - 192*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 168*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r**2 - 192*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 72*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r**2 - 96*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 72*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 3*f*(2*K - 1)*(r + s - 1) + 3*fd*(2*K - 1)*(r + s)) - Dd*f*(-6*K + 5*f + 3)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 144*Dd**2*f*g2*r**2 - 288*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 216*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(231*d**2*k3**8) - 8*D1**2*Pk2*Pk3*ct**3*k1*k2**5*(-2*D1*(24*D1*K*bd1**2*f*(r + s - 1)**2 - bd1*(D1*(f**2*(16*C - 6*K - 5)*(r + s - 1) - 4*f*(fd*(10*C - 5)*(2*r + 2*s - 1) + (5*g2 - 12*gd2)*(r + s - 1)) + 48*fd*g2*(r + s)) - 4*Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1) + f*(2*D1*bdd1*(f*(10*C - 5) - 12*g2)*(r + s - 1)**2 + D1*(f*(fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*gd2*(r + s - 1)**2) - 12*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**2*(D1**2*(6*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-24*K*fdd + fd*(20*K + 7))) + D1*(Dd*(-48*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 6*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(20*K + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 144*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(D1**2*(f*(fd*(16*C - 6*K - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*(r + s - 1)**2*(12*K*bdd1 + 10*gd2 - 12*gdd2)) + (-4*r - 4*s)*(fd**2*(10*C - 5)*(r + s - 1) + 5*fd*g2*(r + s) - 12*fd*gd2*(r + s - 1) - 6*fdd*g2*(r + s))) + D1*bd1*(D1*(-48*K*fd*(r + s) + 6*f**2*(r + s - 1) + f*(20*K + 7)*(r + s - 1)) - 48*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(16*C - 6*K - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 4*f*(fd*(10*C - 5)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 5*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 48*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(f*(10*C - 5) - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**3*k1*k2**3*st**2*(792*C*D1**2*bdd1*f**2*r*s + 792*C*D1**2*bdd1*f**2*r + 792*C*D1**2*bdd1*f**2*s**2 + 28596*C*D1**2*f**2*fd*r**2 + 54912*C*D1**2*f**2*fd*r*s - 37368*C*D1**2*f**2*fd*r + 26316*C*D1**2*f**2*fd*s**2 - 35848*C*D1**2*f**2*fd*s + 18304*C*D1**2*f**2*fd - 24396*C*D1**2*f**2*fdd*r**2 - 44088*C*D1**2*f**2*fdd*r*s + 30960*C*D1**2*f**2*fdd*r - 19692*C*D1**2*f**2*fdd*s**2 + 27824*C*D1**2*f**2*fdd*s - 14696*C*D1**2*f**2*fdd - 48792*C*D1**2*f*fd**2*r**2 - 88176*C*D1**2*f*fd**2*r*s + 61920*C*D1**2*f*fd**2*r - 39384*C*D1**2*f*fd**2*s**2 + 55648*C*D1**2*f*fd**2*s - 14696*C*D1**2*f*fd**2 + 38128*C*D1*Dd*f**3*r**2 + 73216*C*D1*Dd*f**3*r*s - 56432*C*D1*Dd*f**3*r + 35088*C*D1*Dd*f**3*s**2 - 54152*C*D1*Dd*f**3*s + 27836*C*D1*Dd*f**3 - 195168*C*D1*Dd*f**2*fd*r**2 - 352704*C*D1*Dd*f**2*fd*r*s + 265512*C*D1*Dd*f**2*fd*r - 157536*C*D1*Dd*f**2*fd*s**2 + 238856*C*D1*Dd*f**2*fd*s - 89744*C*D1*Dd*f**2*fd - 32528*C*D1*Ddd*f**3*r**2 - 58784*C*D1*Ddd*f**3*r*s + 47224*C*D1*Ddd*f**3*r - 26256*C*D1*Ddd*f**3*s**2 + 42520*C*D1*Ddd*f**3*s - 22828*C*D1*Ddd*f**3 - 97584*C*Dd**2*f**3*r**2 - 176352*C*Dd**2*f**3*r*s + 141672*C*Dd**2*f**3*r - 78768*C*Dd**2*f**3*s**2 + 127560*C*Dd**2*f**3*s - 45656*C*Dd**2*f**3 - 4290*D1**2*K*bdd1*f**2*r**2 - 8052*D1**2*K*bdd1*f**2*r*s + 8580*D1**2*K*bdd1*f**2*r - 3762*D1**2*K*bdd1*f**2*s**2 + 8052*D1**2*K*bdd1*f**2*s - 4290*D1**2*K*bdd1*f**2 + 4488*D1**2*b2*f*fd*r**2 + 8976*D1**2*b2*f*fd*r*s - 4488*D1**2*b2*f*fd*r + 4488*D1**2*b2*f*fd*s**2 - 4488*D1**2*b2*f*fd*s + 2244*D1**2*b2*f*fd - 2640*D1**2*b2*f*fdd*r**2 - 5280*D1**2*b2*f*fdd*r*s + 2640*D1**2*b2*f*fdd*r - 2640*D1**2*b2*f*fdd*s**2 + 2640*D1**2*b2*f*fdd*s - 1320*D1**2*b2*f*fdd - 2640*D1**2*b2*fd**2*r**2 - 5280*D1**2*b2*fd**2*r*s + 2640*D1**2*b2*fd**2*r - 2640*D1**2*b2*fd**2*s**2 + 2640*D1**2*b2*fd**2*s - 132*D1**2*bd1**2*f*(r + s - 1)*(-6*K*s - 3*K + 5*f - 6*r + 6) + 2244*D1**2*bd2*f**2*r**2 + 4488*D1**2*bd2*f**2*r*s - 4488*D1**2*bd2*f**2*r + 2244*D1**2*bd2*f**2*s**2 - 4488*D1**2*bd2*f**2*s + 2244*D1**2*bd2*f**2 - 5280*D1**2*bd2*f*fd*r**2 - 10560*D1**2*bd2*f*fd*r*s + 7920*D1**2*bd2*f*fd*r - 5280*D1**2*bd2*f*fd*s**2 + 7920*D1**2*bd2*f*fd*s - 2640*D1**2*bd2*f*fd + 1815*D1**2*bdd1*f**3*r**2 + 3630*D1**2*bdd1*f**3*r*s - 4290*D1**2*bdd1*f**3*r + 1815*D1**2*bdd1*f**3*s**2 - 4290*D1**2*bdd1*f**3*s + 2475*D1**2*bdd1*f**3 + 1881*D1**2*bdd1*f**2*r**2 + 2706*D1**2*bdd1*f**2*r*s - 4158*D1**2*bdd1*f**2*r + 825*D1**2*bdd1*f**2*s**2 - 3102*D1**2*bdd1*f**2*s + 1683*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r*s - 792*D1**2*bdd1*f*g2*r - 792*D1**2*bdd1*f*g2*s**2 - 1320*D1**2*bdd2*f**2*r**2 - 2640*D1**2*bdd2*f**2*r*s + 2640*D1**2*bdd2*f**2*r - 1320*D1**2*bdd2*f**2*s**2 + 2640*D1**2*bdd2*f**2*s - 1320*D1**2*bdd2*f**2 - 17853*D1**2*f**2*fd*r**2 - 34590*D1**2*f**2*fd*r*s + 23432*D1**2*f**2*fd*r - 16737*D1**2*f**2*fd*s**2 + 22688*D1**2*f**2*fd*s - 11530*D1**2*f**2*fd + 16797*D1**2*f**2*fdd*r**2 + 30066*D1**2*f**2*fdd*r*s - 21220*D1**2*f**2*fdd*r + 13269*D1**2*f**2*fdd*s**2 - 18868*D1**2*f**2*fdd*s + 10022*D1**2*f**2*fdd - 12012*D1**2*f**2*gd2*r**2 - 22704*D1**2*f**2*gd2*r*s + 24024*D1**2*f**2*gd2*r - 10692*D1**2*f**2*gd2*s**2 + 22704*D1**2*f**2*gd2*s - 12012*D1**2*f**2*gd2 + 8580*D1**2*f**2*gdd2*r**2 + 16104*D1**2*f**2*gdd2*r*s - 17160*D1**2*f**2*gdd2*r + 7524*D1**2*f**2*gdd2*s**2 - 16104*D1**2*f**2*gdd2*s + 8580*D1**2*f**2*gdd2 + 33594*D1**2*f*fd**2*r**2 + 60132*D1**2*f*fd**2*r*s - 42440*D1**2*f*fd**2*r + 26538*D1**2*f*fd**2*s**2 - 37736*D1**2*f*fd**2*s + 10022*D1**2*f*fd**2 - 24024*D1**2*f*fd*g2*r**2 - 45408*D1**2*f*fd*g2*r*s + 22704*D1**2*f*fd*g2*r - 21384*D1**2*f*fd*g2*s**2 + 21384*D1**2*f*fd*g2*s - 10692*D1**2*f*fd*g2 + 34320*D1**2*f*fd*gd2*r**2 + 64416*D1**2*f*fd*gd2*r*s - 50424*D1**2*f*fd*gd2*r + 30096*D1**2*f*fd*gd2*s**2 - 47256*D1**2*f*fd*gd2*s + 16104*D1**2*f*fd*gd2 + 17160*D1**2*f*fdd*g2*r**2 + 32208*D1**2*f*fdd*g2*r*s - 16104*D1**2*f*fdd*g2*r + 15048*D1**2*f*fdd*g2*s**2 - 15048*D1**2*f*fdd*g2*s + 7524*D1**2*f*fdd*g2 + 17160*D1**2*fd**2*g2*r**2 + 32208*D1**2*fd**2*g2*r*s - 16104*D1**2*fd**2*g2*r + 15048*D1**2*fd**2*g2*s**2 - 15048*D1**2*fd**2*g2*s + 8976*D1*Dd*b2*f**2*r**2 + 17952*D1*Dd*b2*f**2*r*s - 13464*D1*Dd*b2*f**2*r + 8976*D1*Dd*b2*f**2*s**2 - 13464*D1*Dd*b2*f**2*s + 6732*D1*Dd*b2*f**2 - 21120*D1*Dd*b2*f*fd*r**2 - 42240*D1*Dd*b2*f*fd*r*s + 26400*D1*Dd*b2*f*fd*r - 21120*D1*Dd*b2*f*fd*s**2 + 26400*D1*Dd*b2*f*fd*s - 7920*D1*Dd*b2*f*fd - 10560*D1*Dd*bd2*f**2*r**2 - 21120*D1*Dd*bd2*f**2*r*s + 18480*D1*Dd*bd2*f**2*r - 10560*D1*Dd*bd2*f**2*s**2 + 18480*D1*Dd*bd2*f**2*s - 7920*D1*Dd*bd2*f**2 - 23804*D1*Dd*f**3*r**2 - 46120*D1*Dd*f**3*r*s + 35334*D1*Dd*f**3*r - 22316*D1*Dd*f**3*s**2 + 34218*D1*Dd*f**3*s - 17481*D1*Dd*f**3 + 134376*D1*Dd*f**2*fd*r**2 + 240528*D1*Dd*f**2*fd*r*s - 182134*D1*Dd*f**2*fd*r + 106152*D1*Dd*f**2*fd*s**2 - 162142*D1*Dd*f**2*fd*s + 61308*D1*Dd*f**2*fd - 48048*D1*Dd*f**2*g2*r**2 - 90816*D1*Dd*f**2*g2*r*s + 70752*D1*Dd*f**2*g2*r - 42768*D1*Dd*f**2*g2*s**2 + 66792*D1*Dd*f**2*g2*s - 34716*D1*Dd*f**2*g2 + 68640*D1*Dd*f**2*gd2*r**2 + 128832*D1*Dd*f**2*gd2*r*s - 119064*D1*Dd*f**2*gd2*r + 60192*D1*Dd*f**2*gd2*s**2 - 111672*D1*Dd*f**2*gd2*s + 50424*D1*Dd*f**2*gd2 + 137280*D1*Dd*f*fd*g2*r**2 + 257664*D1*Dd*f*fd*g2*r*s - 165264*D1*Dd*f*fd*g2*r + 120384*D1*Dd*f*fd*g2*s**2 - 154704*D1*Dd*f*fd*g2*s + 47256*D1*Dd*f*fd*g2 - 5280*D1*Ddd*b2*f**2*r**2 - 10560*D1*Ddd*b2*f**2*r*s + 7920*D1*Ddd*b2*f**2*r - 5280*D1*Ddd*b2*f**2*s**2 + 7920*D1*Ddd*b2*f**2*s - 3960*D1*Ddd*b2*f**2 + 22396*D1*Ddd*f**3*r**2 + 40088*D1*Ddd*f**3*r*s - 32418*D1*Ddd*f**3*r + 17692*D1*Ddd*f**3*s**2 - 28890*D1*Ddd*f**3*s + 15621*D1*Ddd*f**3 + 34320*D1*Ddd*f**2*g2*r**2 + 64416*D1*Ddd*f**2*g2*r*s - 50424*D1*Ddd*f**2*g2*r + 30096*D1*Ddd*f**2*g2*s**2 - 47256*D1*Ddd*f**2*g2*s + 24684*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(7*r**2 + 18*r*(s - 1) + 11*(s - 1)**2) + f**2*(8*C*r**2 + 56*C*r*s + 40*C*r + 48*C*s**2 - 2*K*(91*r**2 + 2*r*(86*s - 91) + 81*s**2 - 172*s + 91) - 10*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) + 61*r**2 + 78*r*s - 154*r + 17*s**2 - 110*s + 57) - 2*f*(fd*(12*C*(4*s**2 + s*(4*r - 3) - 1) - 2*K*(130*r**2 + 244*r*s - 191*r + 114*s**2 - 179*s + 61) + 114*r**2 + 164*r*s - 161*r + 50*s**2 - 113*s + 59) + 24*g2*(r*s + r + s**2) - 12*gd2*(2*s + 1)*(r + s - 1)) + 24*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + f*(12*C*(r*(8*s + 3) + 8*s**2 - 4*s - 2) - 2*K*(260*r**2 + 488*r*s - 451*r + 228*s**2 - 423*s + 191) + 228*r**2 + 328*r*s - 407*r + 100*s**2 - 295*s + 173) - 12*g2*(r*(8*s + 3) + 8*s**2 - 4*s - 2))) - 15840*Dd**2*b2*f**2*r**2 - 31680*Dd**2*b2*f**2*r*s + 23760*Dd**2*b2*f**2*r - 15840*Dd**2*b2*f**2*s**2 + 23760*Dd**2*b2*f**2*s - 7920*Dd**2*b2*f**2 + 67188*Dd**2*f**3*r**2 + 120264*Dd**2*f**3*r*s - 97254*Dd**2*f**3*r + 53076*Dd**2*f**3*s**2 - 86670*Dd**2*f**3*s + 31242*Dd**2*f**3 + 102960*Dd**2*f**2*g2*r**2 + 193248*Dd**2*f**2*g2*r*s - 151272*Dd**2*f**2*g2*r + 90288*Dd**2*f**2*g2*s**2 - 141768*Dd**2*f**2*g2*s + 49368*Dd**2*f**2*g2 - 66*b1**2*(D1**2*(-10*fd**2*(r + s - 1) + 2*fd*(6*K*(r*(s - 2) + (s - 1)**2) + 5*f*(2*r + 2*s - 1) + 6*r**2 + 6*r*s + 6*r + 6*s - 3) - fdd*(6*K*(r*(s - 2) + (s - 1)**2) + 5*f*(2*r + 2*s - 1) + 6*r**2 + 6*r*s + 6*r + 6*s - 3)) - 2*D1*(Dd*(f*(-6*K*(r*(4*s - 1) + (1 - 2*s)**2) + 5*fd*(4*r + 4*s - 3) - 24*r**2 - 24*r*s + 30*r + 12*s - 12) + 3*fd*(K*(8*r*s - 9*r + 8*s**2 - 12*s + 6) + 8*r**2 + 8*r*s - r + 2*s - 3)) + 3*Ddd*f*(K*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - 6*Dd**2*f*(K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) + 33*b1*(-16*C*D1**2*f*fd*r**2 - 112*C*D1**2*f*fd*r*s + 112*C*D1**2*f*fd*r - 96*C*D1**2*f*fd*s**2 + 152*C*D1**2*f*fd*s - 56*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 48*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 48*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s + 48*C*D1**2*fd**2 - 32*C*D1*Dd*f**2*r**2 - 224*C*D1*Dd*f**2*r*s + 88*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 208*C*D1*Dd*f**2*s - 64*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 384*C*D1*Dd*f*fd*s**2 - 480*C*D1*Dd*f*fd*s + 168*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 96*C*D1*Ddd*f**2*s + 24*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 288*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 + 364*D1**2*K*f*fd*r**2 + 688*D1**2*K*f*fd*r*s - 344*D1**2*K*f*fd*r + 324*D1**2*K*f*fd*s**2 - 324*D1**2*K*f*fd*s + 162*D1**2*K*f*fd - 260*D1**2*K*f*fdd*r**2 - 488*D1**2*K*f*fdd*r*s + 244*D1**2*K*f*fdd*r - 228*D1**2*K*f*fdd*s**2 + 228*D1**2*K*f*fdd*s - 114*D1**2*K*f*fdd - 260*D1**2*K*fd**2*r**2 - 488*D1**2*K*fd**2*r*s + 244*D1**2*K*fd**2*r - 228*D1**2*K*fd**2*s**2 + 228*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-12*K*s**2 + 5*f*(2*r + 2*s - 1) - 12*r**2 - 6*r*(2*K*s + K + 2*s - 4) + 3*s*(2*K + 4) - 9) - 105*D1**2*f**2*fd*r**2 - 270*D1**2*f**2*fd*r*s + 140*D1**2*f**2*fd*r - 165*D1**2*f**2*fd*s**2 + 180*D1**2*f**2*fd*s - 70*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 122*D1**2*f*fd*r**2 - 156*D1**2*f*fd*r*s + 46*D1**2*f*fd*r - 34*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - 21*D1**2*f*fd + 114*D1**2*f*fdd*r**2 + 164*D1**2*f*fdd*r*s - 70*D1**2*f*fdd*r + 50*D1**2*f*fdd*s**2 - 38*D1**2*f*fdd*s + 31*D1**2*f*fdd + 48*D1**2*f*gd2*r*s + 48*D1**2*f*gd2*s**2 - 48*D1**2*f*gd2*s - 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s + 114*D1**2*fd**2*r**2 + 164*D1**2*fd**2*r*s - 70*D1**2*fd**2*r + 50*D1**2*fd**2*s**2 - 38*D1**2*fd**2*s - 36*D1**2*fd**2 + 48*D1**2*fd*g2*r*s - 96*D1**2*fd*g2*r + 48*D1**2*fd*g2*s**2 - 96*D1**2*fd*g2*s + 48*D1**2*fd*g2 - 48*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 72*D1**2*fd*gd2*s - 48*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r*s + 48*D1**2*fdd*g2*r - 24*D1**2*fdd*g2*s**2 + 48*D1**2*fdd*g2*s - 24*D1**2*fdd*g2 + 728*D1*Dd*K*f**2*r**2 + 1376*D1*Dd*K*f**2*r*s - 1072*D1*Dd*K*f**2*r + 648*D1*Dd*K*f**2*s**2 - 1012*D1*Dd*K*f**2*s + 526*D1*Dd*K*f**2 - 2080*D1*Dd*K*f*fd*r**2 - 3904*D1*Dd*K*f*fd*r*s + 2504*D1*Dd*K*f*fd*r - 1824*D1*Dd*K*f*fd*s**2 + 2344*D1*Dd*K*f*fd*s - 716*D1*Dd*K*f*fd - 140*D1*Dd*f**3*r**2 - 360*D1*Dd*f**3*r*s + 230*D1*Dd*f**3*r - 220*D1*Dd*f**3*s**2 + 290*D1*Dd*f**3*s - 125*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1790*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 244*D1*Dd*f**2*r**2 - 312*D1*Dd*f**2*r*s + 322*D1*Dd*f**2*r - 68*D1*Dd*f**2*s**2 + 190*D1*Dd*f**2*s - 139*D1*Dd*f**2 + 912*D1*Dd*f*fd*r**2 + 1312*D1*Dd*f*fd*r*s - 900*D1*Dd*f*fd*r + 400*D1*Dd*f*fd*s**2 - 580*D1*Dd*f*fd*s + 178*D1*Dd*f*fd + 192*D1*Dd*f*g2*r*s - 48*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 192*D1*Dd*f*g2*s + 48*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r*s + 24*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 192*D1*Dd*f*gd2*s - 24*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r*s + 216*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s - 144*D1*Dd*fd*g2 - 520*D1*Ddd*K*f**2*r**2 - 976*D1*Ddd*K*f**2*r*s + 764*D1*Ddd*K*f**2*r - 456*D1*Ddd*K*f**2*s**2 + 716*D1*Ddd*K*f**2*s - 374*D1*Ddd*K*f**2 + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 228*D1*Ddd*f**2*r**2 + 328*D1*Ddd*f**2*r*s - 310*D1*Ddd*f**2*r + 100*D1*Ddd*f**2*s**2 - 214*D1*Ddd*f**2*s + 139*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 96*D1*Ddd*f*g2*s - 24*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(2*r + 2*s - 1) - 3*f*(4*K*s**2 + 4*r**2 + 2*r*(2*K*s + K + 2*s - 4) - s*(2*K + 4) + 3) + 3*fd*(K*(r*(4*s - 3) + 4*s**2 - 5*s + 2) + 4*r**2 + r*(4*s - 2) - 1)) + Dd*f*(K*(48*r*s + 6*r + 48*s**2 - 36*s - 3) - 5*f*(4*r + 4*s - 3) + 48*r**2 + 48*r*s - 78*r - 36*s + 30)) - 1560*Dd**2*K*f**2*r**2 - 2928*Dd**2*K*f**2*r*s + 2292*Dd**2*K*f**2*r - 1368*Dd**2*K*f**2*s**2 + 2148*Dd**2*K*f**2*s - 748*Dd**2*K*f**2 + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 330*Dd**2*f**3 + 684*Dd**2*f**2*r**2 + 984*Dd**2*f**2*r*s - 930*Dd**2*f**2*r + 300*Dd**2*f**2*s**2 - 642*Dd**2*f**2*s + 278*Dd**2*f**2 - 288*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 288*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(693*d**2*k3**6) + 4*D1**2*Pk2*Pk3*ct**3*k1*k2**3*(-3608*C*D1**2*bdd1*f**2*r**2 - 7128*C*D1**2*bdd1*f**2*r*s + 8008*C*D1**2*bdd1*f**2*r - 3520*C*D1**2*bdd1*f**2*s**2 + 7920*C*D1**2*bdd1*f**2*s - 3960*C*D1**2*bdd1*f**2 - 780*C*D1**2*f**2*fd*r**2 + 3840*C*D1**2*f**2*fd*r*s - 760*C*D1**2*f**2*fd*r + 4620*C*D1**2*f**2*fd*s**2 - 4360*C*D1**2*f**2*fd*s + 1280*C*D1**2*f**2*fd - 3900*C*D1**2*f**2*fdd*r**2 - 11160*C*D1**2*f**2*fdd*r*s + 6320*C*D1**2*f**2*fdd*r - 7260*C*D1**2*f**2*fdd*s**2 + 8560*C*D1**2*f**2*fdd*s - 3720*C*D1**2*f**2*fdd - 7800*C*D1**2*f*fd**2*r**2 - 22320*C*D1**2*f*fd**2*r*s + 12640*C*D1**2*f*fd**2*r - 14520*C*D1**2*f*fd**2*s**2 + 17120*C*D1**2*f*fd**2*s - 3720*C*D1**2*f*fd**2 - 1040*C*D1*Dd*f**3*r**2 + 5120*C*D1*Dd*f**3*r*s - 240*C*D1*Dd*f**3*r + 6160*C*D1*Dd*f**3*s**2 - 5640*C*D1*Dd*f**3*s + 1020*C*D1*Dd*f**3 - 31200*C*D1*Dd*f**2*fd*r**2 - 89280*C*D1*Dd*f**2*fd*r*s + 52040*C*D1*Dd*f**2*fd*r - 58080*C*D1*Dd*f**2*fd*s**2 + 71080*C*D1*Dd*f**2*fd*s - 21200*C*D1*Dd*f**2*fd - 5200*C*D1*Ddd*f**3*r**2 - 14880*C*D1*Ddd*f**3*r*s + 8920*C*D1*Ddd*f**3*r - 9680*C*D1*Ddd*f**3*s**2 + 12280*C*D1*Ddd*f**3*s - 5020*C*D1*Ddd*f**3 - 15600*C*Dd**2*f**3*r**2 - 44640*C*Dd**2*f**3*r*s + 26760*C*Dd**2*f**3*r - 29040*C*Dd**2*f**3*s**2 + 36840*C*Dd**2*f**3*s - 10040*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r**2 - 2112*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 1452*D1**2*K*bdd1*f**2*s**2 + 2112*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 + 22*D1**2*bd1**2*(r + s - 1)*(6*f**2*(15*r + 7*s - 11) + f*(48*C*r + 48*C*s - 2*K*(83*r + 95*s - 101) + 35*r + 11*s - 59) - 56*g2*(r + s)) - 264*D1**2*bd2*f**2*r**2 - 528*D1**2*bd2*f**2*r*s + 528*D1**2*bd2*f**2*r - 264*D1**2*bd2*f**2*s**2 + 528*D1**2*bd2*f**2*s - 264*D1**2*bd2*f**2 + 2596*D1**2*bdd1*f**2*r**2 + 4796*D1**2*bdd1*f**2*r*s - 5236*D1**2*bdd1*f**2*r + 2200*D1**2*bdd1*f**2*s**2 - 4840*D1**2*bdd1*f**2*s + 2420*D1**2*bdd1*f**2 + 3652*D1**2*bdd1*f*g2*r**2 + 7832*D1**2*bdd1*f*g2*r*s - 8888*D1**2*bdd1*f*g2*r + 4180*D1**2*bdd1*f*g2*s**2 - 9416*D1**2*bdd1*f*g2*s + 4708*D1**2*bdd1*f*g2 + 1050*D1**2*f**2*fd*r**2 - 1260*D1**2*f**2*fd*r*s - 280*D1**2*f**2*fd*r - 2310*D1**2*f**2*fd*s**2 + 1960*D1**2*f**2*fd*s - 420*D1**2*f**2*fd + 1950*D1**2*f**2*fdd*r**2 + 5580*D1**2*f**2*fdd*r*s - 3160*D1**2*f**2*fdd*r + 3630*D1**2*f**2*fdd*s**2 - 4280*D1**2*f**2*fdd*s + 1860*D1**2*f**2*fdd + 792*D1**2*f**2*gd2*r**2 - 1056*D1**2*f**2*gd2*r*s - 1584*D1**2*f**2*gd2*r - 1848*D1**2*f**2*gd2*s**2 + 1056*D1**2*f**2*gd2*s + 792*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 4224*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 2904*D1**2*f**2*gdd2*s**2 - 4224*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 3900*D1**2*f*fd**2*r**2 + 11160*D1**2*f*fd**2*r*s - 6320*D1**2*f*fd**2*r + 7260*D1**2*f*fd**2*s**2 - 8560*D1**2*f*fd**2*s + 1860*D1**2*f*fd**2 + 1584*D1**2*f*fd*g2*r**2 - 2112*D1**2*f*fd*g2*r*s + 1056*D1**2*f*fd*g2*r - 3696*D1**2*f*fd*g2*s**2 + 3696*D1**2*f*fd*g2*s - 1848*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 16896*D1**2*f*fd*gd2*r*s - 9504*D1**2*f*fd*gd2*r + 11616*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4224*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 8448*D1**2*f*fdd*g2*r*s - 4224*D1**2*f*fdd*g2*r + 5808*D1**2*f*fdd*g2*s**2 - 5808*D1**2*f*fdd*g2*s + 2904*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 8448*D1**2*fd**2*g2*r*s - 4224*D1**2*fd**2*g2*r + 5808*D1**2*fd**2*g2*s**2 - 5808*D1**2*fd**2*g2*s + 1400*D1*Dd*f**3*r**2 - 1680*D1*Dd*f**3*r*s - 980*D1*Dd*f**3*r - 3080*D1*Dd*f**3*s**2 + 2380*D1*Dd*f**3*s - 70*D1*Dd*f**3 + 15600*D1*Dd*f**2*fd*r**2 + 44640*D1*Dd*f**2*fd*r*s - 26020*D1*Dd*f**2*fd*r + 29040*D1*Dd*f**2*fd*s**2 - 35540*D1*Dd*f**2*fd*s + 10600*D1*Dd*f**2*fd + 3168*D1*Dd*f**2*g2*r**2 - 4224*D1*Dd*f**2*g2*r*s - 2112*D1*Dd*f**2*g2*r - 7392*D1*Dd*f**2*g2*s**2 + 5808*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 33792*D1*Dd*f**2*gd2*r*s - 20064*D1*Dd*f**2*gd2*r + 23232*D1*Dd*f**2*gd2*s**2 - 31152*D1*Dd*f**2*gd2*s + 9504*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 67584*D1*Dd*f*fd*g2*r*s - 35904*D1*Dd*f*fd*g2*r + 46464*D1*Dd*f*fd*g2*s**2 - 51744*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 + 2600*D1*Ddd*f**3*r**2 + 7440*D1*Ddd*f**3*r*s - 4460*D1*Ddd*f**3*r + 4840*D1*Ddd*f**3*s**2 - 6140*D1*Ddd*f**3*s + 2510*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 16896*D1*Ddd*f**2*g2*r*s - 9504*D1*Ddd*f**2*g2*r + 11616*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 5544*D1*Ddd*f**2*g2 + 44*D1*b2*(bd1*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) - 6*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 22*D1*bd1*(48*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(-4*C*(55*r**2 + 4*r*(27*s - 26) + 53*s**2 - 102*s + 51) + 6*K*(3*r**2 - 4*r*s - 6*r - 7*s**2 + 4*s + 3) + 131*r**2 + 250*r*s - 218*r + 119*s**2 - 206*s + 97) + 2*f*(fd*(2*C*(164*r**2 + r*(324*s - 254) + 160*s**2 - 251*s + 91) + 6*K*(10*r**2 + 32*r*s - 18*r + 22*s**2 - 27*s + 8) - 236*r**2 - 436*r*s + 346*r - 200*s**2 + 319*s - 119) + g2*(103*r**2 + r*(230*s - 222) + 127*s**2 - 246*s + 123) - 2*gd2*(83*r**2 + 2*r*(89*s - 92) + 95*s**2 - 196*s + 101)) - 4*fd*g2*(83*r**2 + 89*r*(2*s - 1) + s*(95*s - 95))) + 2*Dd*f*(f*(2*C*(328*r**2 + r*(648*s - 609) + 320*s**2 - 602*s + 272) + 6*K*(20*r**2 + 64*r*s - 38*r + 44*s**2 - 59*s + 18) - 472*r**2 - 872*r*s + 821*r - 400*s**2 + 758*s - 348) - 2*g2*(332*r**2 + r*(712*s - 659) + 380*s**2 - 701*s + 309))) + 7800*Dd**2*f**3*r**2 + 22320*Dd**2*f**3*r*s - 13380*Dd**2*f**3*r + 14520*Dd**2*f**3*s**2 - 18420*Dd**2*f**3*s + 5020*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 50688*Dd**2*f**2*g2*r*s - 28512*Dd**2*f**2*g2*r + 34848*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 11088*Dd**2*f**2*g2 + 22*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(-96*C*D1**2*fd*r**2 - 192*C*D1**2*fd*r*s + 192*C*D1**2*fd*r - 96*C*D1**2*fd*s**2 + 192*C*D1**2*fd*s - 96*C*D1**2*fd + 48*C*D1**2*fdd*r**2 + 96*C*D1**2*fdd*r*s - 96*C*D1**2*fdd*r + 48*C*D1**2*fdd*s**2 - 96*C*D1**2*fdd*s + 48*C*D1**2*fdd - 384*C*D1*Dd*f*r**2 - 768*C*D1*Dd*f*r*s + 576*C*D1*Dd*f*r - 384*C*D1*Dd*f*s**2 + 576*C*D1*Dd*f*s - 288*C*D1*Dd*f + 384*C*D1*Dd*fd*r**2 + 768*C*D1*Dd*fd*r*s - 672*C*D1*Dd*fd*r + 384*C*D1*Dd*fd*s**2 - 672*C*D1*Dd*fd*s + 288*C*D1*Dd*fd + 192*C*D1*Ddd*f*r**2 + 384*C*D1*Ddd*f*r*s - 288*C*D1*Ddd*f*r + 192*C*D1*Ddd*f*s**2 - 288*C*D1*Ddd*f*s + 144*C*D1*Ddd*f + 576*C*Dd**2*f*r**2 + 1152*C*Dd**2*f*r*s - 864*C*Dd**2*f*r + 576*C*Dd**2*f*s**2 - 864*C*Dd**2*f*s + 288*C*Dd**2*f + 206*D1**2*K*fd*r**2 + 460*D1**2*K*fd*r*s - 16*D1**2*K*fd*r + 254*D1**2*K*fd*s**2 - 16*D1**2*K*fd*s + 8*D1**2*K*fd - 166*D1**2*K*fdd*r**2 - 356*D1**2*K*fdd*r*s - 48*D1**2*K*fdd*r - 190*D1**2*K*fdd*s**2 - 48*D1**2*K*fdd*s + 24*D1**2*K*fdd - 2*D1**2*bdd1*(-14*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 156*D1**2*f*fd*r**2 - 216*D1**2*f*fd*r*s + 180*D1**2*f*fd*r - 60*D1**2*f*fd*s**2 + 132*D1**2*f*fd*s - 90*D1**2*f*fd + 180*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 180*D1**2*f*fdd*r + 84*D1**2*f*fdd*s**2 - 132*D1**2*f*fdd*s + 90*D1**2*f*fdd + 180*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 180*D1**2*fd**2*r + 84*D1**2*fd**2*s**2 - 132*D1**2*fd**2*s + 21*D1**2*fd*r**2 + 62*D1**2*fd*r*s - 116*D1**2*fd*r + 41*D1**2*fd*s**2 - 116*D1**2*fd*s + 58*D1**2*fd + 35*D1**2*fdd*r**2 + 46*D1**2*fdd*r*s + 72*D1**2*fdd*r + 11*D1**2*fdd*s**2 + 72*D1**2*fdd*s - 36*D1**2*fdd + 112*D1**2*gd2*r**2 + 224*D1**2*gd2*r*s - 224*D1**2*gd2*r + 112*D1**2*gd2*s**2 - 224*D1**2*gd2*s + 112*D1**2*gd2 - 56*D1**2*gdd2*r**2 - 112*D1**2*gdd2*r*s + 112*D1**2*gdd2*r - 56*D1**2*gdd2*s**2 + 112*D1**2*gdd2*s - 56*D1**2*gdd2 + 824*D1*Dd*K*f*r**2 + 1840*D1*Dd*K*f*r*s - 1284*D1*Dd*K*f*r + 1016*D1*Dd*K*f*s**2 - 1428*D1*Dd*K*f*s + 666*D1*Dd*K*f - 1328*D1*Dd*K*fd*r**2 - 2848*D1*Dd*K*fd*r*s + 828*D1*Dd*K*fd*r - 1520*D1*Dd*K*fd*s**2 + 900*D1*Dd*K*fd*s + 144*D1*Dd*K*fd - 312*D1*Dd*f**2*r**2 - 432*D1*Dd*f**2*r*s + 420*D1*Dd*f**2*r - 120*D1*Dd*f**2*s**2 + 276*D1*Dd*f**2*s - 186*D1*Dd*f**2 + 1440*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 1704*D1*Dd*f*fd*r + 672*D1*Dd*f*fd*s**2 - 1224*D1*Dd*f*fd*s + 492*D1*Dd*f*fd + 84*D1*Dd*f*r**2 + 248*D1*Dd*f*r*s - 146*D1*Dd*f*r + 164*D1*Dd*f*s**2 - 206*D1*Dd*f*s + 83*D1*Dd*f + 280*D1*Dd*fd*r**2 + 368*D1*Dd*fd*r*s + 102*D1*Dd*fd*r + 88*D1*Dd*fd*s**2 + 174*D1*Dd*fd*s - 216*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 896*D1*Dd*g2*r*s - 672*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 672*D1*Dd*g2*s + 336*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 896*D1*Dd*gd2*r*s + 784*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 784*D1*Dd*gd2*s - 336*D1*Dd*gd2 - 664*D1*Ddd*K*f*r**2 - 1424*D1*Ddd*K*f*r*s + 1020*D1*Ddd*K*f*r - 760*D1*Ddd*K*f*s**2 + 1092*D1*Ddd*K*f*s - 522*D1*Ddd*K*f + 360*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 492*D1*Ddd*f**2*r + 168*D1*Ddd*f**2*s**2 - 348*D1*Ddd*f**2*s + 222*D1*Ddd*f**2 + 140*D1*Ddd*f*r**2 + 184*D1*Ddd*f*r*s - 186*D1*Ddd*f*r + 44*D1*Ddd*f*s**2 - 114*D1*Ddd*f*s + 81*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 448*D1*Ddd*g2*r*s + 336*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 336*D1*Ddd*g2*s - 168*D1*Ddd*g2 + 4*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-14*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 1992*Dd**2*K*f*r**2 - 4272*Dd**2*K*f*r*s + 3060*Dd**2*K*f*r - 2280*Dd**2*K*f*s**2 + 3276*Dd**2*K*f*s - 1044*Dd**2*K*f + 1080*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 1476*Dd**2*f**2*r + 504*Dd**2*f**2*s**2 - 1044*Dd**2*f**2*s + 444*Dd**2*f**2 + 420*Dd**2*f*r**2 + 552*Dd**2*f*r*s - 558*Dd**2*f*r + 132*Dd**2*f*s**2 - 342*Dd**2*f*s + 162*Dd**2*f - 672*Dd**2*g2*r**2 - 1344*Dd**2*g2*r*s + 1008*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 1008*Dd**2*g2*s - 336*Dd**2*g2) - 22*b1*(-48*C*D1**2*bdd1*f*r**2 - 96*C*D1**2*bdd1*f*r*s + 48*C*D1**2*bdd1*f*r - 48*C*D1**2*bdd1*f*s**2 + 48*C*D1**2*bdd1*f*s - 24*C*D1**2*bdd1*f - 440*C*D1**2*f*fd*r**2 - 864*C*D1**2*f*fd*r*s + 456*C*D1**2*f*fd*r - 424*C*D1**2*f*fd*s**2 + 448*C*D1**2*f*fd*s - 228*C*D1**2*f*fd + 328*C*D1**2*f*fdd*r**2 + 648*C*D1**2*f*fdd*r*s - 288*C*D1**2*f*fdd*r + 320*C*D1**2*f*fdd*s**2 - 284*C*D1**2*f*fdd*s + 144*C*D1**2*f*fdd + 328*C*D1**2*fd**2*r**2 + 648*C*D1**2*fd**2*r*s - 288*C*D1**2*fd**2*r + 320*C*D1**2*fd**2*s**2 - 284*C*D1**2*fd**2*s - 40*C*D1**2*fd**2 - 880*C*D1*Dd*f**2*r**2 - 1728*C*D1*Dd*f**2*r*s + 1312*C*D1*Dd*f**2*r - 848*C*D1*Dd*f**2*s**2 + 1288*C*D1*Dd*f**2*s - 652*C*D1*Dd*f**2 + 2624*C*D1*Dd*f*fd*r**2 + 5184*C*D1*Dd*f*fd*r*s - 3112*C*D1*Dd*f*fd*r + 2560*C*D1*Dd*f*fd*s**2 - 3072*C*D1*Dd*f*fd*s + 860*C*D1*Dd*f*fd + 656*C*D1*Ddd*f**2*r**2 + 1296*C*D1*Ddd*f**2*r*s - 980*C*D1*Ddd*f**2*r + 640*C*D1*Ddd*f**2*s**2 - 968*C*D1*Ddd*f**2*s + 488*C*D1*Ddd*f**2 + 1968*C*Dd**2*f**2*r**2 + 3888*C*Dd**2*f**2*r*s - 2940*C*Dd**2*f**2*r + 1920*C*Dd**2*f**2*s**2 - 2904*C*Dd**2*f**2*s + 976*C*Dd**2*f**2 + 166*D1**2*K*bdd1*f*r**2 + 356*D1**2*K*bdd1*f*r*s - 368*D1**2*K*bdd1*f*r + 190*D1**2*K*bdd1*f*s**2 - 392*D1**2*K*bdd1*f*s + 190*D1**2*K*bdd1*f + 36*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 84*D1**2*K*f*fd*s**2 + 84*D1**2*K*f*fd*s - 42*D1**2*K*f*fd + 60*D1**2*K*f*fdd*r**2 + 192*D1**2*K*f*fdd*r*s - 96*D1**2*K*f*fdd*r + 132*D1**2*K*f*fdd*s**2 - 132*D1**2*K*f*fdd*s + 66*D1**2*K*f*fdd + 60*D1**2*K*fd**2*r**2 + 192*D1**2*K*fd**2*r*s - 96*D1**2*K*fd**2*r + 132*D1**2*K*fd**2*s**2 - 132*D1**2*K*fd**2*s - 34*D1**2*b2*fd*r**2 - 68*D1**2*b2*fd*r*s - 34*D1**2*b2*fd*s**2 + 24*D1**2*b2*fdd*r**2 + 48*D1**2*b2*fdd*r*s + 24*D1**2*b2*fdd*s**2 + 2*D1**2*bd1**2*(-14*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 90*D1**2*bdd1*f**2*r**2 - 132*D1**2*bdd1*f**2*r*s + 156*D1**2*bdd1*f**2*r - 42*D1**2*bdd1*f**2*s**2 + 108*D1**2*bdd1*f**2*s - 66*D1**2*bdd1*f**2 - 35*D1**2*bdd1*f*r**2 - 46*D1**2*bdd1*f*r*s + 94*D1**2*bdd1*f*r - 11*D1**2*bdd1*f*s**2 + 70*D1**2*bdd1*f*s - 41*D1**2*bdd1*f + 56*D1**2*bdd1*g2*r**2 + 112*D1**2*bdd1*g2*r*s - 56*D1**2*bdd1*g2*r + 56*D1**2*bdd1*g2*s**2 - 56*D1**2*bdd1*g2*s + 28*D1**2*bdd1*g2 + 24*D1**2*bdd2*f*r**2 + 48*D1**2*bdd2*f*r*s - 48*D1**2*bdd2*f*r + 24*D1**2*bdd2*f*s**2 - 48*D1**2*bdd2*f*s + 24*D1**2*bdd2*f + 262*D1**2*f*fd*r**2 + 500*D1**2*f*fd*r*s - 294*D1**2*f*fd*r + 238*D1**2*f*fd*s**2 - 282*D1**2*f*fd*s + 153*D1**2*f*fd - 236*D1**2*f*fdd*r**2 - 436*D1**2*f*fdd*r*s + 216*D1**2*f*fdd*r - 200*D1**2*f*fdd*s**2 + 198*D1**2*f*fdd*s - 108*D1**2*f*fdd + 206*D1**2*f*gd2*r**2 + 460*D1**2*f*gd2*r*s - 412*D1**2*f*gd2*r + 254*D1**2*f*gd2*s**2 - 460*D1**2*f*gd2*s + 206*D1**2*f*gd2 - 166*D1**2*f*gdd2*r**2 - 356*D1**2*f*gdd2*r*s + 332*D1**2*f*gdd2*r - 190*D1**2*f*gdd2*s**2 + 356*D1**2*f*gdd2*s - 166*D1**2*f*gdd2 - 236*D1**2*fd**2*r**2 - 436*D1**2*fd**2*r*s + 216*D1**2*fd**2*r - 200*D1**2*fd**2*s**2 + 198*D1**2*fd**2*s + 20*D1**2*fd**2 + 206*D1**2*fd*g2*r**2 + 460*D1**2*fd*g2*r*s - 16*D1**2*fd*g2*r + 254*D1**2*fd*g2*s**2 - 16*D1**2*fd*g2*s + 8*D1**2*fd*g2 - 332*D1**2*fd*gd2*r**2 - 712*D1**2*fd*gd2*r*s + 284*D1**2*fd*gd2*r - 380*D1**2*fd*gd2*s**2 + 308*D1**2*fd*gd2*s + 48*D1**2*fd*gd2 - 166*D1**2*fdd*g2*r**2 - 356*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*r - 190*D1**2*fdd*g2*s**2 - 48*D1**2*fdd*g2*s + 24*D1**2*fdd*g2 + 72*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s - 48*D1*Dd*K*f**2*r - 168*D1*Dd*K*f**2*s**2 + 132*D1*Dd*K*f**2*s - 6*D1*Dd*K*f**2 + 480*D1*Dd*K*f*fd*r**2 + 1536*D1*Dd*K*f*fd*r*s - 816*D1*Dd*K*f*fd*r + 1056*D1*Dd*K*f*fd*s**2 - 1176*D1*Dd*K*f*fd*s + 324*D1*Dd*K*f*fd - 136*D1*Dd*b2*f*r**2 - 272*D1*Dd*b2*f*r*s + 204*D1*Dd*b2*f*r - 136*D1*Dd*b2*f*s**2 + 204*D1*Dd*b2*f*s - 102*D1*Dd*b2*f + 192*D1*Dd*b2*fd*r**2 + 384*D1*Dd*b2*fd*r*s - 144*D1*Dd*b2*fd*r + 192*D1*Dd*b2*fd*s**2 - 144*D1*Dd*b2*fd*s + 524*D1*Dd*f**2*r**2 + 1000*D1*Dd*f**2*r*s - 774*D1*Dd*f**2*r + 476*D1*Dd*f**2*s**2 - 738*D1*Dd*f**2*s + 381*D1*Dd*f**2 - 1888*D1*Dd*f*fd*r**2 - 3488*D1*Dd*f*fd*r*s + 2244*D1*Dd*f*fd*r - 1600*D1*Dd*f*fd*s**2 + 2064*D1*Dd*f*fd*s - 630*D1*Dd*f*fd + 824*D1*Dd*f*g2*r**2 + 1840*D1*Dd*f*g2*r*s - 1284*D1*Dd*f*g2*r + 1016*D1*Dd*f*g2*s**2 - 1428*D1*Dd*f*g2*s + 666*D1*Dd*f*g2 - 1328*D1*Dd*f*gd2*r**2 - 2848*D1*Dd*f*gd2*r*s + 2348*D1*Dd*f*gd2*r - 1520*D1*Dd*f*gd2*s**2 + 2516*D1*Dd*f*gd2*s - 1020*D1*Dd*f*gd2 - 1328*D1*Dd*fd*g2*r**2 - 2848*D1*Dd*fd*g2*r*s + 828*D1*Dd*fd*g2*r - 1520*D1*Dd*fd*g2*s**2 + 900*D1*Dd*fd*g2*s + 144*D1*Dd*fd*g2 + 120*D1*Ddd*K*f**2*r**2 + 384*D1*Ddd*K*f**2*r*s - 216*D1*Ddd*K*f**2*r + 264*D1*Ddd*K*f**2*s**2 - 324*D1*Ddd*K*f**2*s + 126*D1*Ddd*K*f**2 + 96*D1*Ddd*b2*f*r**2 + 192*D1*Ddd*b2*f*r*s - 144*D1*Ddd*b2*f*r + 96*D1*Ddd*b2*f*s**2 - 144*D1*Ddd*b2*f*s + 72*D1*Ddd*b2*f - 472*D1*Ddd*f**2*r**2 - 872*D1*Ddd*f**2*r*s + 690*D1*Ddd*f**2*r - 400*D1*Ddd*f**2*s**2 + 636*D1*Ddd*f**2*s - 336*D1*Ddd*f**2 - 664*D1*Ddd*f*g2*r**2 - 1424*D1*Ddd*f*g2*r*s + 1020*D1*Ddd*f*g2*r - 760*D1*Ddd*f*g2*s**2 + 1092*D1*Ddd*f*g2*s - 522*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(13*r**2 + 2*r*(9*s - 10) + 5*s**2 - 12*s + 8) + f*(48*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 206*K*r**2 - 460*K*r*s + 428*K*r - 254*K*s**2 + 476*K*s - 226*K - 12*fd*(30*r**2 + 44*r*s - 41*r + 14*s**2 - 29*s + 13) - 21*r**2 - 62*r*s - 6*r - 41*s**2 + 14*s - 2) - 2*fd*(24*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*K*(83*r**2 + 178*r*s - 80*r + 95*s**2 - 86*s - 6) + 35*r**2 + 46*r*s - 11*r + 11*s**2 + s - 18) - 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(6*f**2*(60*r**2 + r*(88*s - 93) + 28*s**2 - 65*s + 35) + f*(24*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 2*K*(332*r**2 + 89*r*(8*s - 7) + 380*s**2 - 665*s + 282) + 140*r**2 + 184*r*s - 281*r + 44*s**2 - 197*s + 129) - 28*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 2*D1*bd2*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) + 360*Dd**2*K*f**2*r**2 + 1152*Dd**2*K*f**2*r*s - 648*Dd**2*K*f**2*r + 792*Dd**2*K*f**2*s**2 - 972*Dd**2*K*f**2*s + 252*Dd**2*K*f**2 + 288*Dd**2*b2*f*r**2 + 576*Dd**2*b2*f*r*s - 432*Dd**2*b2*f*r + 288*Dd**2*b2*f*s**2 - 432*Dd**2*b2*f*s + 144*Dd**2*b2*f - 1416*Dd**2*f**2*r**2 - 2616*Dd**2*f**2*r*s + 2070*Dd**2*f**2*r - 1200*Dd**2*f**2*s**2 + 1908*Dd**2*f**2*s - 672*Dd**2*f**2 - 1992*Dd**2*f*g2*r**2 - 4272*Dd**2*f*g2*r*s + 3060*Dd**2*f*g2*r - 2280*Dd**2*f*g2*s**2 + 3276*Dd**2*f*g2*s - 1044*Dd**2*f*g2))/(231*d**2*k3**6) - 8*D1**2*Pk2*Pk3*ct**3*k1*st**2*(-D1*f*s*(2*D1*bd1**2*s*(5*f + 3) - 6*D1*bd1*(f*s - 2*fd*s + fd) + 3*D1*bdd1*f*s + 6*Dd*bd1*f*(4*s - 1)) + b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 6*fd*(s - 1)**2 - 3*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(-5*fd*(8*s**2 - 6*s + 1) + 12*s**2 - 6*s + 3) - 3*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 3)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 3)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) + f*fd*(s**2*(12 - 40*bd1) + s*(20*bd1 - 12) + 6) - 3*f*(fdd*(2*s**2 - 2*s + 1) + s**2*(-4*bd1 + 2*bdd1)) - 6*fd*s*(2*bd1 + fd)*(s - 1)) + D1*f*(-2*Dd*(f*(s**2*(40*bd1 - 12) + s*(6 - 10*bd1) - 3) + (12*s - 3)*(2*bd1*s + fd*(2*s - 1))) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k2**3) - 4*D1**2*Pk2*Pk3*ct**3*k1*(2*D1*f*s*(D1*bd1**2*(s*(42*f + 35) + 12) + 20*D1*bdd1*f*s + bd1*(-31*D1*f*s + 40*D1*fd*(2*s - 1) + 40*Dd*f*(4*s - 1))) + 2*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(6*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 28) + s*(6*fd - 14) + 7) - D1*Ddd*(6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(6*f + 7)*(2*s - 1)) + b1**2*(-2*D1**2*bdd1*(6*f + 7)*(3*s**2 - 2*s + 1) - 132*D1**2*f*fd*s**2 + 132*D1**2*f*fd*s - 66*D1**2*f*fd + 84*D1**2*f*fdd*s**2 - 84*D1**2*f*fdd*s + 42*D1**2*f*fdd + 84*D1**2*fd**2*s**2 - 84*D1**2*fd**2*s - 49*D1**2*fd*s**2 + 146*D1**2*fd*s - 73*D1**2*fd + 35*D1**2*fdd*s**2 - 94*D1**2*fdd*s + 47*D1**2*fdd - 264*D1*Dd*f**2*s**2 + 132*D1*Dd*f**2*s - 66*D1*Dd*f**2 + 672*D1*Dd*f*fd*s**2 - 504*D1*Dd*f*fd*s + 84*D1*Dd*f*fd - 196*D1*Dd*f*s**2 + 98*D1*Dd*f*s - 49*D1*Dd*f + 280*D1*Dd*fd*s**2 - 446*D1*Dd*fd*s + 94*D1*Dd*fd + 168*D1*Ddd*f**2*s**2 - 84*D1*Ddd*f**2*s + 42*D1*Ddd*f**2 + 140*D1*Ddd*f*s**2 - 70*D1*Ddd*f*s + 35*D1*Ddd*f + 4*D1*bd1*(D1*(6*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 21) + s*(6*fd - 14) + 7) - Dd*(6*f + 7)*(12*s**2 - 7*s + 1)) + 504*Dd**2*f**2*s**2 - 252*Dd**2*f**2*s + 420*Dd**2*f*s**2 - 210*Dd**2*f*s) - 2*b1*(2*D1**2*bd1**2*s*(6*f + 7)*(3*s - 2) - D1**2*bdd1*f*(s**2*(42*f + 35) + 12*s - 6) + 62*D1**2*f*fd*s**2 - 62*D1**2*f*fd*s + 31*D1**2*f*fd - 40*D1**2*f*fdd*s**2 + 40*D1**2*f*fdd*s - 20*D1**2*f*fdd - 40*D1**2*fd**2*s**2 + 40*D1**2*fd**2*s + 124*D1*Dd*f**2*s**2 - 62*D1*Dd*f**2*s + 31*D1*Dd*f**2 - 320*D1*Dd*f*fd*s**2 + 240*D1*Dd*f*fd*s - 40*D1*Dd*f*fd - 80*D1*Ddd*f**2*s**2 + 40*D1*Ddd*f**2*s - 20*D1*Ddd*f**2 + D1*bd1*(D1*(66*f**2*s**2 + f*(-s**2*(168*fd - 49) + s*(84*fd + 24) - 12) + 2*fd*s*(41 - 35*s)) - 2*Dd*f*(4*s - 1)*(s*(42*f + 35) + 6)) - 240*Dd**2*f**2*s**2 + 120*Dd**2*f**2*s))/(21*d**2*k2**3) + D1**2*Pk2*Pk3*ct**3*k2**5*(32*C - 16)*(D1*f*(-D1*bdd1*f*r*(r + s - 1) + bd1*(2*D1*f*r*(r + s - 1) + D1*fd*(-4*r**2 - 4*r*(s - 1) + s - 1) + Dd*f*(-8*r**2 - 8*r*s + 9*r + 2*s - 2))) + b1*(D1**2*(f*(2*fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-2*r**2 - 2*r*(s - 1) + s)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - Dd*fd*(2*r - 1)*(8*r + 8*s - 5) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)))/(21*d**2*k1*k3**6) - 80*D1**2*Pk2*Pk3*ct**2*f**2*k1**6*st**2*(D1**2*(f*(131*fd - 98*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 98*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(131*f*(r*(4*s - 1) + (1 - 2*s)**2) - 196*fd*(4*s - 1)*(4*r + 4*s - 3)) - 98*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 98*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k2**2*k3**6) + 80*D1**2*Pk2*Pk3*ct**2*f*k1**6*(-69*D1**2*b1*f*fd*r*s - 69*D1**2*b1*f*fd*s**2 + 46*D1**2*b1*f*fd*s + 84*D1**2*b1*f*fdd*r*s + 84*D1**2*b1*f*fdd*s**2 - 56*D1**2*b1*f*fdd*s + 168*D1**2*b1*fd**2*r*s + 168*D1**2*b1*fd**2*s**2 - 112*D1**2*b1*fd**2*s + 28*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + 168*D1**2*f**2*fd*r*s - 42*D1**2*f**2*fd*r + 168*D1**2*f**2*fd*s**2 - 168*D1**2*f**2*fd*s + 42*D1**2*f**2*fd - 168*D1**2*f**2*fdd*r*s + 42*D1**2*f**2*fdd*r - 168*D1**2*f**2*fdd*s**2 + 168*D1**2*f**2*fdd*s - 42*D1**2*f**2*fdd - 504*D1**2*f*fd**2*r*s + 126*D1**2*f*fd**2*r - 504*D1**2*f*fd**2*s**2 + 504*D1**2*f*fd**2*s - 84*D1**2*f*fd**2 - 92*D1*Dd*b1*f**2*r*s + 23*D1*Dd*b1*f**2*r - 92*D1*Dd*b1*f**2*s**2 + 92*D1*Dd*b1*f**2*s - 23*D1*Dd*b1*f**2 + 672*D1*Dd*b1*f*fd*r*s - 84*D1*Dd*b1*f*fd*r + 672*D1*Dd*b1*f*fd*s**2 - 560*D1*Dd*b1*f*fd*s + 56*D1*Dd*b1*f*fd + 168*D1*Dd*f**3*r*s - 42*D1*Dd*f**3*r + 168*D1*Dd*f**3*s**2 - 168*D1*Dd*f**3*s + 42*D1*Dd*f**3 - 1344*D1*Dd*f**2*fd*r*s + 336*D1*Dd*f**2*fd*r - 1344*D1*Dd*f**2*fd*s**2 + 1344*D1*Dd*f**2*fd*s - 252*D1*Dd*f**2*fd + 112*D1*Ddd*b1*f**2*r*s - 28*D1*Ddd*b1*f**2*r + 112*D1*Ddd*b1*f**2*s**2 - 112*D1*Ddd*b1*f**2*s + 28*D1*Ddd*b1*f**2 - 168*D1*Ddd*f**3*r*s + 42*D1*Ddd*f**3*r - 168*D1*Ddd*f**3*s**2 + 168*D1*Ddd*f**3*s - 42*D1*Ddd*f**3 + D1*bd1*f*(D1*(-23*f*(s - 1)*(r + s - 1) + 28*fd*(6*r*s - 3*r + 6*s**2 - 8*s + 2)) + 28*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 336*Dd**2*b1*f**2*r*s - 84*Dd**2*b1*f**2*r + 336*Dd**2*b1*f**2*s**2 - 336*Dd**2*b1*f**2*s + 56*Dd**2*b1*f**2 - 504*Dd**2*f**3*r*s + 126*Dd**2*f**3*r - 504*Dd**2*f**3*s**2 + 504*Dd**2*f**3*s - 84*Dd**2*f**3)/(693*d**2*k2**2*k3**6) - 24*D1**2*Pk2*Pk3*ct**2*f*k1**4*k2**2*st**4*(312*C*D1**2*f*fd*r**2 + 624*C*D1**2*f*fd*r*s - 416*C*D1**2*f*fd*r + 312*C*D1**2*f*fd*s**2 - 416*C*D1**2*f*fd*s + 208*C*D1**2*f*fd - 156*C*D1**2*f*fdd*r**2 - 312*C*D1**2*f*fdd*r*s + 208*C*D1**2*f*fdd*r - 156*C*D1**2*f*fdd*s**2 + 208*C*D1**2*f*fdd*s - 104*C*D1**2*f*fdd - 312*C*D1**2*fd**2*r**2 - 624*C*D1**2*fd**2*r*s + 416*C*D1**2*fd**2*r - 312*C*D1**2*fd**2*s**2 + 416*C*D1**2*fd**2*s - 104*C*D1**2*fd**2 + 416*C*D1*Dd*f**2*r**2 + 832*C*D1*Dd*f**2*r*s - 624*C*D1*Dd*f**2*r + 416*C*D1*Dd*f**2*s**2 - 624*C*D1*Dd*f**2*s + 312*C*D1*Dd*f**2 - 1248*C*D1*Dd*f*fd*r**2 - 2496*C*D1*Dd*f*fd*r*s + 1768*C*D1*Dd*f*fd*r - 1248*C*D1*Dd*f*fd*s**2 + 1768*C*D1*Dd*f*fd*s - 624*C*D1*Dd*f*fd - 208*C*D1*Ddd*f**2*r**2 - 416*C*D1*Ddd*f**2*r*s + 312*C*D1*Ddd*f**2*r - 208*C*D1*Ddd*f**2*s**2 + 312*C*D1*Ddd*f**2*s - 156*C*D1*Ddd*f**2 - 624*C*Dd**2*f**2*r**2 - 1248*C*Dd**2*f**2*r*s + 936*C*Dd**2*f**2*r - 624*C*Dd**2*f**2*s**2 + 936*C*Dd**2*f**2*s - 312*C*Dd**2*f**2 + 143*D1**2*bd1*f*(K - 1)*(r + s - 1)**2 + 3220*D1**2*f**2*fd*r**2 + 6440*D1**2*f**2*fd*r*s - 4830*D1**2*f**2*fd*r + 3220*D1**2*f**2*fd*s**2 - 4830*D1**2*f**2*fd*s + 2415*D1**2*f**2*fd - 2000*D1**2*f**2*fdd*r**2 - 4000*D1**2*f**2*fdd*r*s + 3000*D1**2*f**2*fdd*r - 2000*D1**2*f**2*fdd*s**2 + 3000*D1**2*f**2*fdd*s - 1500*D1**2*f**2*fdd - 6000*D1**2*f*fd**2*r**2 - 12000*D1**2*f*fd**2*r*s + 9000*D1**2*f*fd**2*r - 6000*D1**2*f*fd**2*s**2 + 9000*D1**2*f*fd**2*s - 3000*D1**2*f*fd**2 - 312*D1**2*f*fd*r**2 - 624*D1**2*f*fd*r*s + 416*D1**2*f*fd*r - 312*D1**2*f*fd*s**2 + 416*D1**2*f*fd*s - 208*D1**2*f*fd + 156*D1**2*f*fdd*r**2 + 312*D1**2*f*fdd*r*s - 208*D1**2*f*fdd*r + 156*D1**2*f*fdd*s**2 - 208*D1**2*f*fdd*s + 104*D1**2*f*fdd - 286*D1**2*f*gd2*r**2 - 572*D1**2*f*gd2*r*s + 572*D1**2*f*gd2*r - 286*D1**2*f*gd2*s**2 + 572*D1**2*f*gd2*s - 286*D1**2*f*gd2 + 312*D1**2*fd**2*r**2 + 624*D1**2*fd**2*r*s - 416*D1**2*fd**2*r + 312*D1**2*fd**2*s**2 - 416*D1**2*fd**2*s + 104*D1**2*fd**2 - 572*D1**2*fd*g2*r**2 - 1144*D1**2*fd*g2*r*s + 572*D1**2*fd*g2*r - 572*D1**2*fd*g2*s**2 + 572*D1**2*fd*g2*s - 286*D1**2*fd*g2 + 3220*D1*Dd*f**3*r**2 + 6440*D1*Dd*f**3*r*s - 4830*D1*Dd*f**3*r + 3220*D1*Dd*f**3*s**2 - 4830*D1*Dd*f**3*s + 2415*D1*Dd*f**3 - 16000*D1*Dd*f**2*fd*r**2 - 32000*D1*Dd*f**2*fd*r*s + 24000*D1*Dd*f**2*fd*r - 16000*D1*Dd*f**2*fd*s**2 + 24000*D1*Dd*f**2*fd*s - 9000*D1*Dd*f**2*fd - 416*D1*Dd*f**2*r**2 - 832*D1*Dd*f**2*r*s + 624*D1*Dd*f**2*r - 416*D1*Dd*f**2*s**2 + 624*D1*Dd*f**2*s - 312*D1*Dd*f**2 + 1248*D1*Dd*f*fd*r**2 + 2496*D1*Dd*f*fd*r*s - 1768*D1*Dd*f*fd*r + 1248*D1*Dd*f*fd*s**2 - 1768*D1*Dd*f*fd*s + 624*D1*Dd*f*fd - 1144*D1*Dd*f*g2*r**2 - 2288*D1*Dd*f*g2*r*s + 1716*D1*Dd*f*g2*r - 1144*D1*Dd*f*g2*s**2 + 1716*D1*Dd*f*g2*s - 858*D1*Dd*f*g2 - 2000*D1*Ddd*f**3*r**2 - 4000*D1*Ddd*f**3*r*s + 3000*D1*Ddd*f**3*r - 2000*D1*Ddd*f**3*s**2 + 3000*D1*Ddd*f**3*s - 1500*D1*Ddd*f**3 + 208*D1*Ddd*f**2*r**2 + 416*D1*Ddd*f**2*r*s - 312*D1*Ddd*f**2*r + 208*D1*Ddd*f**2*s**2 - 312*D1*Ddd*f**2*s + 156*D1*Ddd*f**2 + 143*D1*b1*(K - 1)*(D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 6000*Dd**2*f**3*r**2 - 12000*Dd**2*f**3*r*s + 9000*Dd**2*f**3*r - 6000*Dd**2*f**3*s**2 + 9000*Dd**2*f**3*s - 3000*Dd**2*f**3 + 624*Dd**2*f**2*r**2 + 1248*Dd**2*f**2*r*s - 936*Dd**2*f**2*r + 624*Dd**2*f**2*s**2 - 936*Dd**2*f**2*s + 312*Dd**2*f**2)/(1001*d**2*k3**8) - 32*D1**2*Pk2*Pk3*ct**2*f*k1**4*st**4*(D1**2*(5*f**2*(107*fd - 60*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(150*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - fd*(26*C - 26)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(13*C - 13)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(26*C - 26)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(535*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 4*f*(13*C*(r*(4*s - 1) + (1 - 2*s)**2) - 150*fd*(4*s - 1)*(4*r + 4*s - 3) - 13*r*(4*s - 1) - 13*(1 - 2*s)**2) - fd*(26*C - 26)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(13*C + 150*f - 13)) - 2*Dd**2*f**2*(13*C + 150*f - 13)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1001*d**2*k3**6) - 16*D1**2*Pk2*Pk3*ct**2*f*k1**4*st**4*(D1**2*(225*f**2*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f*(-1350*fd**2*s*(2*s - 1) + fd*(26*C - 26)*(3*s**2 - 2*s + 1) - fdd*(13*C - 13)*(3*s**2 - 2*s + 1)) + fd**2*s*(26 - 26*C)*(3*s - 2)) + D1*f*(2*Dd*(225*f**2*(4*s**2 - 2*s + 1) + f*(13*C*(4*s**2 - 2*s + 1) - 225*fd*(1 - 4*s)**2 - 52*s**2 + 26*s - 13) - fd*(13*C - 13)*(12*s**2 - 7*s + 1)) - Ddd*f*(13*C + 225*f - 13)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(13*C + 225*f - 13))/(1001*d**2*k2**2*k3**4) - D1**2*Pk2*Pk3*ct**2*f*k2**6*st**4*(240*C - 120)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**8) + 40*D1**2*Pk2*Pk3*ct**2*f*k2**4*st**4*(D1**2*(f*(2*fd - fdd)*(2*C*(15*r**2 + 6*r*(4*s - 3) + 9*s**2 - 14*s + 8) - 18*r**2 - 3*r*(9*s - 7) - 9*s**2 + 15*s - 9) + fd**2*(-4*C*(15*r**2 + 6*r*(4*s - 3) + 9*s**2 - 14*s + 4) + 36*r**2 + 6*r*(9*s - 7) + 18*s**2 - 30*s + 9)) + D1*f*(Dd*(2*C*f*(40*r**2 + 8*r*(8*s - 7) + 24*s**2 - 44*s + 26) - 4*C*fd*(60*r**2 + r*(96*s - 78) + 36*s**2 - 61*s + 25) - 6*f*(8*r**2 + r*(12*s - 11) + 4*s**2 - 8*s + 5) + 3*fd*(48*r**2 + r*(72*s - 61) + 24*s**2 - 44*s + 19)) + Ddd*f*(-2*C*(20*r**2 + 4*r*(8*s - 7) + 12*s**2 - 22*s + 13) + 24*r**2 + 3*r*(12*s - 11) + 12*s**2 - 24*s + 15)) + Dd**2*f**2*(-4*C*(30*r**2 + 6*r*(8*s - 7) + 18*s**2 - 33*s + 13) + 72*r**2 + 108*r*s - 99*r + 36*s**2 - 72*s + 30))/(231*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**2*k1**6*st**2*(1326*C*D1**2*f**2*fd*r**2 + 2652*C*D1**2*f**2*fd*r*s - 1768*C*D1**2*f**2*fd*r + 1326*C*D1**2*f**2*fd*s**2 - 1768*C*D1**2*f**2*fd*s + 884*C*D1**2*f**2*fd - 1950*C*D1**2*f**2*fdd*r**2 - 3900*C*D1**2*f**2*fdd*r*s + 2600*C*D1**2*f**2*fdd*r - 1950*C*D1**2*f**2*fdd*s**2 + 2600*C*D1**2*f**2*fdd*s - 1300*C*D1**2*f**2*fdd - 3900*C*D1**2*f*fd**2*r**2 - 7800*C*D1**2*f*fd**2*r*s + 5200*C*D1**2*f*fd**2*r - 3900*C*D1**2*f*fd**2*s**2 + 5200*C*D1**2*f*fd**2*s - 1300*C*D1**2*f*fd**2 + 1768*C*D1*Dd*f**3*r**2 + 3536*C*D1*Dd*f**3*r*s - 2652*C*D1*Dd*f**3*r + 1768*C*D1*Dd*f**3*s**2 - 2652*C*D1*Dd*f**3*s + 1326*C*D1*Dd*f**3 - 15600*C*D1*Dd*f**2*fd*r**2 - 31200*C*D1*Dd*f**2*fd*r*s + 22100*C*D1*Dd*f**2*fd*r - 15600*C*D1*Dd*f**2*fd*s**2 + 22100*C*D1*Dd*f**2*fd*s - 7800*C*D1*Dd*f**2*fd - 2600*C*D1*Ddd*f**3*r**2 - 5200*C*D1*Ddd*f**3*r*s + 3900*C*D1*Ddd*f**3*r - 2600*C*D1*Ddd*f**3*s**2 + 3900*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 7800*C*Dd**2*f**3*r**2 - 15600*C*Dd**2*f**3*r*s + 11700*C*Dd**2*f**3*r - 7800*C*Dd**2*f**3*s**2 + 11700*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 + 858*D1**2*K*b1*f*fd*r**2 + 1716*D1**2*K*b1*f*fd*r*s - 858*D1**2*K*b1*f*fd*r + 858*D1**2*K*b1*f*fd*s**2 - 858*D1**2*K*b1*f*fd*s + 429*D1**2*K*b1*f*fd - 858*D1**2*K*b1*f*fdd*r**2 - 1716*D1**2*K*b1*f*fdd*r*s + 858*D1**2*K*b1*f*fdd*r - 858*D1**2*K*b1*f*fdd*s**2 + 858*D1**2*K*b1*f*fdd*s - 429*D1**2*K*b1*f*fdd - 858*D1**2*K*b1*fd**2*r**2 - 1716*D1**2*K*b1*fd**2*r*s + 858*D1**2*K*b1*fd**2*r - 858*D1**2*K*b1*fd**2*s**2 + 858*D1**2*K*b1*fd**2*s - 858*D1**2*b1*f*fd*r**2 - 1716*D1**2*b1*f*fd*r*s + 858*D1**2*b1*f*fd*r - 858*D1**2*b1*f*fd*s**2 + 858*D1**2*b1*f*fd*s - 429*D1**2*b1*f*fd + 858*D1**2*b1*f*fdd*r**2 + 1716*D1**2*b1*f*fdd*r*s - 858*D1**2*b1*f*fdd*r + 858*D1**2*b1*f*fdd*s**2 - 858*D1**2*b1*f*fdd*s + 429*D1**2*b1*f*fdd + 858*D1**2*b1*fd**2*r**2 + 1716*D1**2*b1*fd**2*r*s - 858*D1**2*b1*fd**2*r + 858*D1**2*b1*fd**2*s**2 - 858*D1**2*b1*fd**2*s - 429*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 27600*D1**2*f**3*fd*r**2 + 55200*D1**2*f**3*fd*r*s - 41400*D1**2*f**3*fd*r + 27600*D1**2*f**3*fd*s**2 - 41400*D1**2*f**3*fd*s + 20700*D1**2*f**3*fd - 29400*D1**2*f**3*fdd*r**2 - 58800*D1**2*f**3*fdd*r*s + 44100*D1**2*f**3*fdd*r - 29400*D1**2*f**3*fdd*s**2 + 44100*D1**2*f**3*fdd*s - 22050*D1**2*f**3*fdd - 88200*D1**2*f**2*fd**2*r**2 - 176400*D1**2*f**2*fd**2*r*s + 132300*D1**2*f**2*fd**2*r - 88200*D1**2*f**2*fd**2*s**2 + 132300*D1**2*f**2*fd**2*s - 44100*D1**2*f**2*fd**2 - 1326*D1**2*f**2*fd*r**2 - 2652*D1**2*f**2*fd*r*s + 1768*D1**2*f**2*fd*r - 1326*D1**2*f**2*fd*s**2 + 1768*D1**2*f**2*fd*s - 884*D1**2*f**2*fd + 1950*D1**2*f**2*fdd*r**2 + 3900*D1**2*f**2*fdd*r*s - 2600*D1**2*f**2*fdd*r + 1950*D1**2*f**2*fdd*s**2 - 2600*D1**2*f**2*fdd*s + 1300*D1**2*f**2*fdd - 858*D1**2*f**2*gd2*r**2 - 1716*D1**2*f**2*gd2*r*s + 1716*D1**2*f**2*gd2*r - 858*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s - 858*D1**2*f**2*gd2 + 858*D1**2*f**2*gdd2*r**2 + 1716*D1**2*f**2*gdd2*r*s - 1716*D1**2*f**2*gdd2*r + 858*D1**2*f**2*gdd2*s**2 - 1716*D1**2*f**2*gdd2*s + 858*D1**2*f**2*gdd2 + 3900*D1**2*f*fd**2*r**2 + 7800*D1**2*f*fd**2*r*s - 5200*D1**2*f*fd**2*r + 3900*D1**2*f*fd**2*s**2 - 5200*D1**2*f*fd**2*s + 1300*D1**2*f*fd**2 - 1716*D1**2*f*fd*g2*r**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 1716*D1**2*f*fd*g2*s**2 + 1716*D1**2*f*fd*g2*s - 858*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r**2 + 6864*D1**2*f*fd*gd2*r*s - 5148*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1716*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r**2 + 3432*D1**2*f*fdd*g2*r*s - 1716*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r**2 + 3432*D1**2*fd**2*g2*r*s - 1716*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 1716*D1*Dd*K*b1*f**2*r**2 + 3432*D1*Dd*K*b1*f**2*r*s - 2574*D1*Dd*K*b1*f**2*r + 1716*D1*Dd*K*b1*f**2*s**2 - 2574*D1*Dd*K*b1*f**2*s + 1287*D1*Dd*K*b1*f**2 - 6864*D1*Dd*K*b1*f*fd*r**2 - 13728*D1*Dd*K*b1*f*fd*r*s + 8580*D1*Dd*K*b1*f*fd*r - 6864*D1*Dd*K*b1*f*fd*s**2 + 8580*D1*Dd*K*b1*f*fd*s - 2574*D1*Dd*K*b1*f*fd - 1716*D1*Dd*b1*f**2*r**2 - 3432*D1*Dd*b1*f**2*r*s + 2574*D1*Dd*b1*f**2*r - 1716*D1*Dd*b1*f**2*s**2 + 2574*D1*Dd*b1*f**2*s - 1287*D1*Dd*b1*f**2 + 6864*D1*Dd*b1*f*fd*r**2 + 13728*D1*Dd*b1*f*fd*r*s - 8580*D1*Dd*b1*f*fd*r + 6864*D1*Dd*b1*f*fd*s**2 - 8580*D1*Dd*b1*f*fd*s + 2574*D1*Dd*b1*f*fd + 27600*D1*Dd*f**4*r**2 + 55200*D1*Dd*f**4*r*s - 41400*D1*Dd*f**4*r + 27600*D1*Dd*f**4*s**2 - 41400*D1*Dd*f**4*s + 20700*D1*Dd*f**4 - 235200*D1*Dd*f**3*fd*r**2 - 470400*D1*Dd*f**3*fd*r*s + 352800*D1*Dd*f**3*fd*r - 235200*D1*Dd*f**3*fd*s**2 + 352800*D1*Dd*f**3*fd*s - 132300*D1*Dd*f**3*fd - 1768*D1*Dd*f**3*r**2 - 3536*D1*Dd*f**3*r*s + 2652*D1*Dd*f**3*r - 1768*D1*Dd*f**3*s**2 + 2652*D1*Dd*f**3*s - 1326*D1*Dd*f**3 + 15600*D1*Dd*f**2*fd*r**2 + 31200*D1*Dd*f**2*fd*r*s - 22100*D1*Dd*f**2*fd*r + 15600*D1*Dd*f**2*fd*s**2 - 22100*D1*Dd*f**2*fd*s + 7800*D1*Dd*f**2*fd - 3432*D1*Dd*f**2*g2*r**2 - 6864*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 3432*D1*Dd*f**2*g2*s**2 + 5148*D1*Dd*f**2*g2*s - 2574*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r**2 + 13728*D1*Dd*f**2*gd2*r*s - 12012*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 12012*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r**2 + 27456*D1*Dd*f*fd*g2*r*s - 17160*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 17160*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 - 1716*D1*Ddd*K*b1*f**2*r**2 - 3432*D1*Ddd*K*b1*f**2*r*s + 2574*D1*Ddd*K*b1*f**2*r - 1716*D1*Ddd*K*b1*f**2*s**2 + 2574*D1*Ddd*K*b1*f**2*s - 1287*D1*Ddd*K*b1*f**2 + 1716*D1*Ddd*b1*f**2*r**2 + 3432*D1*Ddd*b1*f**2*r*s - 2574*D1*Ddd*b1*f**2*r + 1716*D1*Ddd*b1*f**2*s**2 - 2574*D1*Ddd*b1*f**2*s + 1287*D1*Ddd*b1*f**2 - 29400*D1*Ddd*f**4*r**2 - 58800*D1*Ddd*f**4*r*s + 44100*D1*Ddd*f**4*r - 29400*D1*Ddd*f**4*s**2 + 44100*D1*Ddd*f**4*s - 22050*D1*Ddd*f**4 + 2600*D1*Ddd*f**3*r**2 + 5200*D1*Ddd*f**3*r*s - 3900*D1*Ddd*f**3*r + 2600*D1*Ddd*f**3*s**2 - 3900*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r**2 + 6864*D1*Ddd*f**2*g2*r*s - 5148*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 5148*Dd**2*K*b1*f**2*r**2 - 10296*Dd**2*K*b1*f**2*r*s + 7722*Dd**2*K*b1*f**2*r - 5148*Dd**2*K*b1*f**2*s**2 + 7722*Dd**2*K*b1*f**2*s - 2574*Dd**2*K*b1*f**2 + 5148*Dd**2*b1*f**2*r**2 + 10296*Dd**2*b1*f**2*r*s - 7722*Dd**2*b1*f**2*r + 5148*Dd**2*b1*f**2*s**2 - 7722*Dd**2*b1*f**2*s + 2574*Dd**2*b1*f**2 - 88200*Dd**2*f**4*r**2 - 176400*Dd**2*f**4*r*s + 132300*Dd**2*f**4*r - 88200*Dd**2*f**4*s**2 + 132300*Dd**2*f**4*s - 44100*Dd**2*f**4 + 7800*Dd**2*f**3*r**2 + 15600*Dd**2*f**3*r*s - 11700*Dd**2*f**3*r + 7800*Dd**2*f**3*s**2 - 11700*Dd**2*f**3*s + 3900*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r**2 + 20592*Dd**2*f**2*g2*r*s - 15444*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2)/(3003*d**2*k3**8) - 8*D1**2*Pk2*Pk3*ct**2*k1**6*(-2*D1*(r + s - 1)*(198*D1*bd1**2*f*(K - 1)*(r + s - 1) - D1*bd1*(230*f**3*(r + s - 1) + 4*f**2*(33*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) - 33*r - 33*s + 33) - 33*f*(fd*(10*C - 10)*(2*r + 2*s - 1) + (5*g2 - 12*gd2)*(r + s - 1)) + 396*fd*g2*(r + s)) + D1*bdd1*f*(280*f**2 + f*(165*C - 165) - 198*g2)*(r + s - 1) + 2*Dd*bd1*f*(280*f**2 + f*(165*C - 165) - 198*g2)*(4*r + 4*s - 3)) + 33*b1**2*(K - 1)*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(264*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s - 264*C*D1**2*f*fd*r + 264*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s + 132*C*D1**2*f*fd - 330*C*D1**2*f*fdd*r**2 - 660*C*D1**2*f*fdd*r*s + 330*C*D1**2*f*fdd*r - 330*C*D1**2*f*fdd*s**2 + 330*C*D1**2*f*fdd*s - 165*C*D1**2*f*fdd - 330*C*D1**2*fd**2*r**2 - 660*C*D1**2*fd**2*r*s + 330*C*D1**2*fd**2*r - 330*C*D1**2*fd**2*s**2 + 330*C*D1**2*fd**2*s + 528*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 792*C*D1*Dd*f**2*r + 528*C*D1*Dd*f**2*s**2 - 792*C*D1*Dd*f**2*s + 396*C*D1*Dd*f**2 - 2640*C*D1*Dd*f*fd*r**2 - 5280*C*D1*Dd*f*fd*r*s + 3300*C*D1*Dd*f*fd*r - 2640*C*D1*Dd*f*fd*s**2 + 3300*C*D1*Dd*f*fd*s - 990*C*D1*Dd*f*fd - 660*C*D1*Ddd*f**2*r**2 - 1320*C*D1*Ddd*f**2*r*s + 990*C*D1*Ddd*f**2*r - 660*C*D1*Ddd*f**2*s**2 + 990*C*D1*Ddd*f**2*s - 495*C*D1*Ddd*f**2 - 1980*C*Dd**2*f**2*r**2 - 3960*C*Dd**2*f**2*r*s + 2970*C*Dd**2*f**2*r - 1980*C*Dd**2*f**2*s**2 + 2970*C*Dd**2*f**2*s - 990*C*Dd**2*f**2 - 198*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 690*D1**2*f**2*fd*r**2 + 1380*D1**2*f**2*fd*r*s - 920*D1**2*f**2*fd*r + 690*D1**2*f**2*fd*s**2 - 920*D1**2*f**2*fd*s + 460*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 - 1680*D1**2*f**2*fdd*r*s + 1120*D1**2*f**2*fdd*r - 840*D1**2*f**2*fdd*s**2 + 1120*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd - 1680*D1**2*f*fd**2*r**2 - 3360*D1**2*f*fd**2*r*s + 2240*D1**2*f*fd**2*r - 1680*D1**2*f*fd**2*s**2 + 2240*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd + 330*D1**2*f*fdd*r**2 + 660*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 330*D1**2*f*fdd*s**2 - 330*D1**2*f*fdd*s + 165*D1**2*f*fdd - 165*D1**2*f*gd2*r**2 - 330*D1**2*f*gd2*r*s + 330*D1**2*f*gd2*r - 165*D1**2*f*gd2*s**2 + 330*D1**2*f*gd2*s - 165*D1**2*f*gd2 + 198*D1**2*f*gdd2*r**2 + 396*D1**2*f*gdd2*r*s - 396*D1**2*f*gdd2*r + 198*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s + 198*D1**2*f*gdd2 + 330*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 330*D1**2*fd**2*s**2 - 330*D1**2*fd**2*s - 165*D1**2*fd*g2*r**2 - 330*D1**2*fd*g2*r*s - 165*D1**2*fd*g2*s**2 + 396*D1**2*fd*gd2*r**2 + 792*D1**2*fd*gd2*r*s - 396*D1**2*fd*gd2*r + 396*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 198*D1**2*fdd*g2*r**2 + 396*D1**2*fdd*g2*r*s + 198*D1**2*fdd*g2*s**2 + 920*D1*Dd*f**3*r**2 + 1840*D1*Dd*f**3*r*s - 1380*D1*Dd*f**3*r + 920*D1*Dd*f**3*s**2 - 1380*D1*Dd*f**3*s + 690*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 - 13440*D1*Dd*f**2*fd*r*s + 9520*D1*Dd*f**2*fd*r - 6720*D1*Dd*f**2*fd*s**2 + 9520*D1*Dd*f**2*fd*s - 3360*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 + 5280*D1*Dd*f*fd*r*s - 3300*D1*Dd*f*fd*r + 2640*D1*Dd*f*fd*s**2 - 3300*D1*Dd*f*fd*s + 990*D1*Dd*f*fd - 660*D1*Dd*f*g2*r**2 - 1320*D1*Dd*f*g2*r*s + 990*D1*Dd*f*g2*r - 660*D1*Dd*f*g2*s**2 + 990*D1*Dd*f*g2*s - 495*D1*Dd*f*g2 + 1584*D1*Dd*f*gd2*r**2 + 3168*D1*Dd*f*gd2*r*s - 2772*D1*Dd*f*gd2*r + 1584*D1*Dd*f*gd2*s**2 - 2772*D1*Dd*f*gd2*s + 1188*D1*Dd*f*gd2 + 1584*D1*Dd*fd*g2*r**2 + 3168*D1*Dd*fd*g2*r*s - 1188*D1*Dd*fd*g2*r + 1584*D1*Dd*fd*g2*s**2 - 1188*D1*Dd*fd*g2*s - 1120*D1*Ddd*f**3*r**2 - 2240*D1*Ddd*f**3*r*s + 1680*D1*Ddd*f**3*r - 1120*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 840*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 + 1320*D1*Ddd*f**2*r*s - 990*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s**2 - 990*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 + 792*D1*Ddd*f*g2*r**2 + 1584*D1*Ddd*f*g2*r*s - 1188*D1*Ddd*f*g2*r + 792*D1*Ddd*f*g2*s**2 - 1188*D1*Ddd*f*g2*s + 594*D1*Ddd*f*g2 + 33*D1*bd1*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3360*Dd**2*f**3*r**2 - 6720*Dd**2*f**3*r*s + 5040*Dd**2*f**3*r - 3360*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 1680*Dd**2*f**3 + 1980*Dd**2*f**2*r**2 + 3960*Dd**2*f**2*r*s - 2970*Dd**2*f**2*r + 1980*Dd**2*f**2*s**2 - 2970*Dd**2*f**2*s + 990*Dd**2*f**2 + 2376*Dd**2*f*g2*r**2 + 4752*Dd**2*f*g2*r*s - 3564*Dd**2*f*g2*r + 2376*Dd**2*f*g2*s**2 - 3564*Dd**2*f*g2*s + 1188*Dd**2*f*g2))/(231*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**2*k1**4*k2**2*st**2*(-132*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 132*D1**2*bdd1*f*(f*(C + 2*K - 2) - g2)*(r + s - 1)**2 - 2*D1**2*(75*f**3*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-fd*(213*C - 157)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(200*C - 150)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (341*gd2 - 264*gdd2)*(r + s - 1)**2) + f*(fd**2*(400*C - 300)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 11*fd*(31*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 48*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 264*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 528*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 11*D1*bd1*(D1*(12*f**3*(r + s - 1) + f**2*(22*C + 31*K - 37)*(r + s - 1) - 24*f*fd*(C + 2*K - 2)*(2*r + 2*s - 1) - 2*f*(19*g2 - 12*gd2)*(r + s - 1) + 24*fd*g2*(r + s)) - 24*Dd*f*(f*(C + 2*K - 2) - g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(75*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(213*C - 157)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(fd*(400*C - 300)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 341*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 528*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - 528*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2*Ddd*f*(f*(100*C - 75) - 132*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Dd**2*f**2*(f*(100*C - 75) - 132*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 11*b1**2*(K - 1)*(D1**2*(19*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(19*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(44*C*D1**2*f*fd*r**2 + 88*C*D1**2*f*fd*r*s - 44*C*D1**2*f*fd*r + 44*C*D1**2*f*fd*s**2 - 44*C*D1**2*f*fd*s + 22*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 + 24*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 + 24*C*D1**2*fd**2*s + 88*C*D1*Dd*f**2*r**2 + 176*C*D1*Dd*f**2*r*s - 132*C*D1*Dd*f**2*r + 88*C*D1*Dd*f**2*s**2 - 132*C*D1*Dd*f**2*s + 66*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s + 240*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 240*C*D1*Dd*f*fd*s - 72*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r*s + 72*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 72*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r*s + 216*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 216*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 + 62*D1**2*K*f*fd*r**2 + 124*D1**2*K*f*fd*r*s - 62*D1**2*K*f*fd*r + 62*D1**2*K*f*fd*s**2 - 62*D1**2*K*f*fd*s + 31*D1**2*K*f*fd - 48*D1**2*K*f*fdd*r**2 - 96*D1**2*K*f*fdd*r*s + 48*D1**2*K*f*fdd*r - 48*D1**2*K*f*fdd*s**2 + 48*D1**2*K*f*fdd*s - 24*D1**2*K*f*fdd - 48*D1**2*K*fd**2*r**2 - 96*D1**2*K*fd**2*r*s + 48*D1**2*K*fd**2*r - 48*D1**2*K*fd**2*s**2 + 48*D1**2*K*fd**2*s - 12*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 36*D1**2*f**2*fd*r**2 + 72*D1**2*f**2*fd*r*s - 48*D1**2*f**2*fd*r + 36*D1**2*f**2*fd*s**2 - 48*D1**2*f**2*fd*s + 24*D1**2*f**2*fd - 74*D1**2*f*fd*r**2 - 148*D1**2*f*fd*r*s + 74*D1**2*f*fd*r - 74*D1**2*f*fd*s**2 + 74*D1**2*f*fd*s - 37*D1**2*f*fd + 48*D1**2*f*fdd*r**2 + 96*D1**2*f*fdd*r*s - 48*D1**2*f*fdd*r + 48*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 24*D1**2*f*fdd - 38*D1**2*f*gd2*r**2 - 76*D1**2*f*gd2*r*s + 76*D1**2*f*gd2*r - 38*D1**2*f*gd2*s**2 + 76*D1**2*f*gd2*s - 38*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*r + 12*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s + 12*D1**2*f*gdd2 + 48*D1**2*fd**2*r**2 + 96*D1**2*fd**2*r*s - 48*D1**2*fd**2*r + 48*D1**2*fd**2*s**2 - 48*D1**2*fd**2*s - 38*D1**2*fd*g2*r**2 - 76*D1**2*fd*g2*r*s - 38*D1**2*fd*g2*s**2 + 24*D1**2*fd*gd2*r**2 + 48*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 24*D1**2*fd*gd2*s + 12*D1**2*fdd*g2*r**2 + 24*D1**2*fdd*g2*r*s + 12*D1**2*fdd*g2*s**2 + 124*D1*Dd*K*f**2*r**2 + 248*D1*Dd*K*f**2*r*s - 186*D1*Dd*K*f**2*r + 124*D1*Dd*K*f**2*s**2 - 186*D1*Dd*K*f**2*s + 93*D1*Dd*K*f**2 - 384*D1*Dd*K*f*fd*r**2 - 768*D1*Dd*K*f*fd*r*s + 480*D1*Dd*K*f*fd*r - 384*D1*Dd*K*f*fd*s**2 + 480*D1*Dd*K*f*fd*s - 144*D1*Dd*K*f*fd + 48*D1*Dd*f**3*r**2 + 96*D1*Dd*f**3*r*s - 72*D1*Dd*f**3*r + 48*D1*Dd*f**3*s**2 - 72*D1*Dd*f**3*s + 36*D1*Dd*f**3 - 148*D1*Dd*f**2*r**2 - 296*D1*Dd*f**2*r*s + 222*D1*Dd*f**2*r - 148*D1*Dd*f**2*s**2 + 222*D1*Dd*f**2*s - 111*D1*Dd*f**2 + 384*D1*Dd*f*fd*r**2 + 768*D1*Dd*f*fd*r*s - 480*D1*Dd*f*fd*r + 384*D1*Dd*f*fd*s**2 - 480*D1*Dd*f*fd*s + 144*D1*Dd*f*fd - 152*D1*Dd*f*g2*r**2 - 304*D1*Dd*f*g2*r*s + 228*D1*Dd*f*g2*r - 152*D1*Dd*f*g2*s**2 + 228*D1*Dd*f*g2*s - 114*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 192*D1*Dd*f*gd2*r*s - 168*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 168*D1*Dd*f*gd2*s + 72*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 192*D1*Dd*fd*g2*r*s - 72*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 72*D1*Dd*fd*g2*s - 96*D1*Ddd*K*f**2*r**2 - 192*D1*Ddd*K*f**2*r*s + 144*D1*Ddd*K*f**2*r - 96*D1*Ddd*K*f**2*s**2 + 144*D1*Ddd*K*f**2*s - 72*D1*Ddd*K*f**2 + 96*D1*Ddd*f**2*r**2 + 192*D1*Ddd*f**2*r*s - 144*D1*Ddd*f**2*r + 96*D1*Ddd*f**2*s**2 - 144*D1*Ddd*f**2*s + 72*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 96*D1*Ddd*f*g2*r*s - 72*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 72*D1*Ddd*f*g2*s + 36*D1*Ddd*f*g2 + 2*D1*bd1*(K - 1)*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 288*Dd**2*K*f**2*r**2 - 576*Dd**2*K*f**2*r*s + 432*Dd**2*K*f**2*r - 288*Dd**2*K*f**2*s**2 + 432*Dd**2*K*f**2*s - 144*Dd**2*K*f**2 + 288*Dd**2*f**2*r**2 + 576*Dd**2*f**2*r*s - 432*Dd**2*f**2*r + 288*Dd**2*f**2*s**2 - 432*Dd**2*f**2*s + 144*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 288*Dd**2*f*g2*r*s - 216*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 216*Dd**2*f*g2*s + 72*Dd**2*f*g2))/(77*d**2*k3**8) + 8*D1**2*Pk2*Pk3*ct**2*k1**4*k2**2*(2640*C*D1**2*bdd1*f**2*r**2 + 5280*C*D1**2*bdd1*f**2*r*s - 5280*C*D1**2*bdd1*f**2*r + 2640*C*D1**2*bdd1*f**2*s**2 - 5280*C*D1**2*bdd1*f**2*s + 2640*C*D1**2*bdd1*f**2 - 690*C*D1**2*f**2*fd*r**2 - 1380*C*D1**2*f**2*fd*r*s + 920*C*D1**2*f**2*fd*r - 690*C*D1**2*f**2*fd*s**2 + 920*C*D1**2*f**2*fd*s - 460*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r**2 + 1680*C*D1**2*f**2*fdd*r*s - 1120*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 1120*C*D1**2*f**2*fdd*s + 560*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r**2 + 3360*C*D1**2*f*fd**2*r*s - 2240*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 2240*C*D1**2*f*fd**2*s + 560*C*D1**2*f*fd**2 - 920*C*D1*Dd*f**3*r**2 - 1840*C*D1*Dd*f**3*r*s + 1380*C*D1*Dd*f**3*r - 920*C*D1*Dd*f**3*s**2 + 1380*C*D1*Dd*f**3*s - 690*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r**2 + 13440*C*D1*Dd*f**2*fd*r*s - 9520*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 9520*C*D1*Dd*f**2*fd*s + 3360*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r**2 + 2240*C*D1*Ddd*f**3*r*s - 1680*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1680*C*D1*Ddd*f**3*s + 840*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r**2 + 6720*C*Dd**2*f**3*r*s - 5040*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 5040*C*Dd**2*f**3*s + 1680*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r**2 + 330*D1**2*K*bdd1*f**2*r*s - 330*D1**2*K*bdd1*f**2*r + 165*D1**2*K*bdd1*f**2*s**2 - 330*D1**2*K*bdd1*f**2*s + 165*D1**2*K*bdd1*f**2 - 132*D1**2*bd1**2*f*(-24*K + 25*f + 12)*(r + s - 1)**2 - 1980*D1**2*bdd1*f**2*r**2 - 3960*D1**2*bdd1*f**2*r*s + 3960*D1**2*bdd1*f**2*r - 1980*D1**2*bdd1*f**2*s**2 + 3960*D1**2*bdd1*f**2*s - 1980*D1**2*bdd1*f**2 - 3168*D1**2*bdd1*f*g2*r**2 - 6336*D1**2*bdd1*f*g2*r*s + 6336*D1**2*bdd1*f*g2*r - 3168*D1**2*bdd1*f*g2*s**2 + 6336*D1**2*bdd1*f*g2*s - 3168*D1**2*bdd1*f*g2 + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 330*D1**2*f**2*gdd2*r**2 - 660*D1**2*f**2*gdd2*r*s + 660*D1**2*f**2*gdd2*r - 330*D1**2*f**2*gdd2*s**2 + 660*D1**2*f**2*gdd2*s - 330*D1**2*f**2*gdd2 - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r**2 - 2640*D1**2*f*fd*gd2*r*s + 1980*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1980*D1**2*f*fd*gd2*s - 660*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r**2 - 1320*D1**2*f*fdd*g2*r*s + 660*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r**2 - 1320*D1**2*fd**2*g2*r*s + 660*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 690*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 690*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r**2 - 5280*D1*Dd*f**2*gd2*r*s + 4620*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 4620*D1*Dd*f**2*gd2*s - 1980*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r**2 - 10560*D1*Dd*f*fd*g2*r*s + 6600*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 6600*D1*Dd*f*fd*g2*s - 1980*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r**2 - 2640*D1*Ddd*f**2*g2*r*s + 1980*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1980*D1*Ddd*f**2*g2*s - 990*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(5*f**3*(r + s - 1) - 2*f**2*(13*C + K - 9)*(r + s - 1) + 5*f*fd*(16*C + K - 12)*(2*r + 2*s - 1) + 3*f*(11*g2 - 32*gd2)*(r + s - 1) - 96*fd*g2*(r + s)) + Dd*f*(5*f*(16*C + K - 12) - 96*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r**2 - 7920*Dd**2*f**2*g2*r*s + 5940*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 5940*Dd**2*f**2*g2*s - 1980*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(2*f*(23*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(33*K - 13)*(r + s) - 24*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(46*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (33*K - 13)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 48*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(-24*K + 25*f + 12)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(-24*K + 25*f + 12)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-104*C*D1**2*f*fd*r**2 - 208*C*D1**2*f*fd*r*s + 104*C*D1**2*f*fd*r - 104*C*D1**2*f*fd*s**2 + 104*C*D1**2*f*fd*s - 52*C*D1**2*f*fd + 160*C*D1**2*f*fdd*r**2 + 320*C*D1**2*f*fdd*r*s - 160*C*D1**2*f*fdd*r + 160*C*D1**2*f*fdd*s**2 - 160*C*D1**2*f*fdd*s + 80*C*D1**2*f*fdd + 160*C*D1**2*fd**2*r**2 + 320*C*D1**2*fd**2*r*s - 160*C*D1**2*fd**2*r + 160*C*D1**2*fd**2*s**2 - 160*C*D1**2*fd**2*s - 208*C*D1*Dd*f**2*r**2 - 416*C*D1*Dd*f**2*r*s + 312*C*D1*Dd*f**2*r - 208*C*D1*Dd*f**2*s**2 + 312*C*D1*Dd*f**2*s - 156*C*D1*Dd*f**2 + 1280*C*D1*Dd*f*fd*r**2 + 2560*C*D1*Dd*f*fd*r*s - 1600*C*D1*Dd*f*fd*r + 1280*C*D1*Dd*f*fd*s**2 - 1600*C*D1*Dd*f*fd*s + 480*C*D1*Dd*f*fd + 320*C*D1*Ddd*f**2*r**2 + 640*C*D1*Ddd*f**2*r*s - 480*C*D1*Ddd*f**2*r + 320*C*D1*Ddd*f**2*s**2 - 480*C*D1*Ddd*f**2*s + 240*C*D1*Ddd*f**2 + 960*C*Dd**2*f**2*r**2 + 1920*C*Dd**2*f**2*r*s - 1440*C*Dd**2*f**2*r + 960*C*Dd**2*f**2*s**2 - 1440*C*Dd**2*f**2*s + 480*C*Dd**2*f**2 - 8*D1**2*K*f*fd*r**2 - 16*D1**2*K*f*fd*r*s + 8*D1**2*K*f*fd*r - 8*D1**2*K*f*fd*s**2 + 8*D1**2*K*f*fd*s - 4*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r**2 + 20*D1**2*K*f*fdd*r*s - 10*D1**2*K*f*fdd*r + 10*D1**2*K*f*fdd*s**2 - 10*D1**2*K*f*fdd*s + 5*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r**2 + 20*D1**2*K*fd**2*r*s - 10*D1**2*K*fd**2*r + 10*D1**2*K*fd**2*s**2 - 10*D1**2*K*fd**2*s - 4*D1**2*bdd1*f*(-24*K + 25*f + 12)*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd + 72*D1**2*f*fd*r**2 + 144*D1**2*f*fd*r*s - 72*D1**2*f*fd*r + 72*D1**2*f*fd*s**2 - 72*D1**2*f*fd*s + 36*D1**2*f*fd - 120*D1**2*f*fdd*r**2 - 240*D1**2*f*fdd*r*s + 120*D1**2*f*fdd*r - 120*D1**2*f*fdd*s**2 + 120*D1**2*f*fdd*s - 60*D1**2*f*fdd + 66*D1**2*f*gd2*r**2 + 132*D1**2*f*gd2*r*s - 132*D1**2*f*gd2*r + 66*D1**2*f*gd2*s**2 - 132*D1**2*f*gd2*s + 66*D1**2*f*gd2 - 96*D1**2*f*gdd2*r**2 - 192*D1**2*f*gdd2*r*s + 192*D1**2*f*gdd2*r - 96*D1**2*f*gdd2*s**2 + 192*D1**2*f*gdd2*s - 96*D1**2*f*gdd2 - 120*D1**2*fd**2*r**2 - 240*D1**2*fd**2*r*s + 120*D1**2*fd**2*r - 120*D1**2*fd**2*s**2 + 120*D1**2*fd**2*s + 66*D1**2*fd*g2*r**2 + 132*D1**2*fd*g2*r*s + 66*D1**2*fd*g2*s**2 - 192*D1**2*fd*gd2*r**2 - 384*D1**2*fd*gd2*r*s + 192*D1**2*fd*gd2*r - 192*D1**2*fd*gd2*s**2 + 192*D1**2*fd*gd2*s - 96*D1**2*fdd*g2*r**2 - 192*D1**2*fdd*g2*r*s - 96*D1**2*fdd*g2*s**2 - 16*D1*Dd*K*f**2*r**2 - 32*D1*Dd*K*f**2*r*s + 24*D1*Dd*K*f**2*r - 16*D1*Dd*K*f**2*s**2 + 24*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r**2 + 160*D1*Dd*K*f*fd*r*s - 100*D1*Dd*K*f*fd*r + 80*D1*Dd*K*f*fd*s**2 - 100*D1*Dd*K*f*fd*s + 30*D1*Dd*K*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 + 144*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 216*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 216*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 960*D1*Dd*f*fd*r**2 - 1920*D1*Dd*f*fd*r*s + 1200*D1*Dd*f*fd*r - 960*D1*Dd*f*fd*s**2 + 1200*D1*Dd*f*fd*s - 360*D1*Dd*f*fd + 264*D1*Dd*f*g2*r**2 + 528*D1*Dd*f*g2*r*s - 396*D1*Dd*f*g2*r + 264*D1*Dd*f*g2*s**2 - 396*D1*Dd*f*g2*s + 198*D1*Dd*f*g2 - 768*D1*Dd*f*gd2*r**2 - 1536*D1*Dd*f*gd2*r*s + 1344*D1*Dd*f*gd2*r - 768*D1*Dd*f*gd2*s**2 + 1344*D1*Dd*f*gd2*s - 576*D1*Dd*f*gd2 - 768*D1*Dd*fd*g2*r**2 - 1536*D1*Dd*fd*g2*r*s + 576*D1*Dd*fd*g2*r - 768*D1*Dd*fd*g2*s**2 + 576*D1*Dd*fd*g2*s + 20*D1*Ddd*K*f**2*r**2 + 40*D1*Ddd*K*f**2*r*s - 30*D1*Ddd*K*f**2*r + 20*D1*Ddd*K*f**2*s**2 - 30*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 240*D1*Ddd*f**2*r**2 - 480*D1*Ddd*f**2*r*s + 360*D1*Ddd*f**2*r - 240*D1*Ddd*f**2*s**2 + 360*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 384*D1*Ddd*f*g2*r**2 - 768*D1*Ddd*f*g2*r*s + 576*D1*Ddd*f*g2*r - 384*D1*Ddd*f*g2*s**2 + 576*D1*Ddd*f*g2*s - 288*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(46*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(33*K - 13)*(r + s - 1) + 48*fd*(2*K - 1)*(r + s)) - 4*Dd*f*(-24*K + 25*f + 12)*(4*r + 4*s - 3))*(r + s - 1) + 60*Dd**2*K*f**2*r**2 + 120*Dd**2*K*f**2*r*s - 90*Dd**2*K*f**2*r + 60*Dd**2*K*f**2*s**2 - 90*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 720*Dd**2*f**2*r**2 - 1440*Dd**2*f**2*r*s + 1080*Dd**2*f**2*r - 720*Dd**2*f**2*s**2 + 1080*Dd**2*f**2*s - 360*Dd**2*f**2 - 1152*Dd**2*f*g2*r**2 - 2304*Dd**2*f*g2*r*s + 1728*Dd**2*f*g2*r - 1152*Dd**2*f*g2*s**2 + 1728*Dd**2*f*g2*s - 576*Dd**2*f*g2))/(231*d**2*k3**8) + 2*D1**2*Pk2*Pk3*ct**2*k1**4*st**2*(132*C*D1**2*bdd1*f**2*r**2 + 1056*C*D1**2*bdd1*f**2*r*s - 792*C*D1**2*bdd1*f**2*r + 924*C*D1**2*bdd1*f**2*s**2 - 1584*C*D1**2*bdd1*f**2*s + 792*C*D1**2*bdd1*f**2 + 3786*C*D1**2*f**2*fd*r**2 + 7980*C*D1**2*f**2*fd*r*s - 5184*C*D1**2*f**2*fd*r + 4194*C*D1**2*f**2*fd*s**2 - 5456*C*D1**2*f**2*fd*s + 2660*C*D1**2*f**2*fd - 2982*C*D1**2*f**2*fdd*r**2 - 8148*C*D1**2*f**2*fdd*r*s + 4704*C*D1**2*f**2*fdd*r - 5166*C*D1**2*f**2*fdd*s**2 + 6160*C*D1**2*f**2*fdd*s - 2716*C*D1**2*f**2*fdd - 5964*C*D1**2*f*fd**2*r**2 - 16296*C*D1**2*f*fd**2*r*s + 9408*C*D1**2*f*fd**2*r - 10332*C*D1**2*f*fd**2*s**2 + 12320*C*D1**2*f*fd**2*s - 2716*C*D1**2*f*fd**2 + 5048*C*D1*Dd*f**3*r**2 + 10640*C*D1*Dd*f**3*r*s - 7708*C*D1*Dd*f**3*r + 5592*C*D1*Dd*f**3*s**2 - 8116*C*D1*Dd*f**3*s + 3922*C*D1*Dd*f**3 - 23856*C*D1*Dd*f**2*fd*r**2 - 65184*C*D1*Dd*f**2*fd*r*s + 38892*C*D1*Dd*f**2*fd*r - 41328*C*D1*Dd*f**2*fd*s**2 + 51268*C*D1*Dd*f**2*fd*s - 15568*C*D1*Dd*f**2*fd - 3976*C*D1*Ddd*f**3*r**2 - 10864*C*D1*Ddd*f**3*r*s + 6692*C*D1*Ddd*f**3*r - 6888*C*D1*Ddd*f**3*s**2 + 8876*C*D1*Ddd*f**3*s - 3710*C*D1*Ddd*f**3 - 11928*C*Dd**2*f**3*r**2 - 32592*C*Dd**2*f**3*r*s + 20076*C*Dd**2*f**3*r - 20664*C*Dd**2*f**3*s**2 + 26628*C*Dd**2*f**3*s - 7420*C*Dd**2*f**3 - 561*D1**2*K*bdd1*f**2*r**2 - 1518*D1**2*K*bdd1*f**2*r*s + 1122*D1**2*K*bdd1*f**2*r - 957*D1**2*K*bdd1*f**2*s**2 + 1518*D1**2*K*bdd1*f**2*s - 561*D1**2*K*bdd1*f**2 + 132*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(8*s - 4) + 7*s**2 - 10*s + 3) + 2100*D1**2*bdd1*f**3*r**2 + 5400*D1**2*bdd1*f**3*r*s - 6000*D1**2*bdd1*f**3*r + 3300*D1**2*bdd1*f**3*s**2 - 7200*D1**2*bdd1*f**3*s + 4800*D1**2*bdd1*f**3 + 1221*D1**2*bdd1*f**2*r**2 + 2442*D1**2*bdd1*f**2*r*s - 1914*D1**2*bdd1*f**2*r + 1221*D1**2*bdd1*f**2*s**2 - 1914*D1**2*bdd1*f**2*s + 561*D1**2*bdd1*f**2 - 132*D1**2*bdd1*f*g2*r**2 - 1056*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r - 924*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 + 18600*D1**2*f**3*fd*r**2 + 63600*D1**2*f**3*fd*r*s - 34500*D1**2*f**3*fd*r + 45000*D1**2*f**3*fd*s**2 - 54300*D1**2*f**3*fd*s + 20550*D1**2*f**3*fd - 22200*D1**2*f**3*fdd*r**2 - 56400*D1**2*f**3*fdd*r*s + 36300*D1**2*f**3*fdd*r - 34200*D1**2*f**3*fdd*s**2 + 45300*D1**2*f**3*fdd*s - 19650*D1**2*f**3*fdd - 66600*D1**2*f**2*fd**2*r**2 - 169200*D1**2*f**2*fd**2*r*s + 108900*D1**2*f**2*fd**2*r - 102600*D1**2*f**2*fd**2*s**2 + 135900*D1**2*f**2*fd**2*s - 39300*D1**2*f**2*fd**2 - 5802*D1**2*f**2*fd*r**2 - 13416*D1**2*f**2*fd*r*s + 8340*D1**2*f**2*fd*r - 7614*D1**2*f**2*fd*s**2 + 9548*D1**2*f**2*fd*s - 4472*D1**2*f**2*fd + 4782*D1**2*f**2*fdd*r**2 + 12648*D1**2*f**2*fdd*r*s - 7404*D1**2*f**2*fdd*r + 7866*D1**2*f**2*fdd*s**2 - 9460*D1**2*f**2*fdd*s + 4216*D1**2*f**2*fdd - 1518*D1**2*f**2*gd2*r**2 - 3300*D1**2*f**2*gd2*r*s + 3036*D1**2*f**2*gd2*r - 1782*D1**2*f**2*gd2*s**2 + 3300*D1**2*f**2*gd2*s - 1518*D1**2*f**2*gd2 + 1122*D1**2*f**2*gdd2*r**2 + 3036*D1**2*f**2*gdd2*r*s - 2244*D1**2*f**2*gdd2*r + 1914*D1**2*f**2*gdd2*s**2 - 3036*D1**2*f**2*gdd2*s + 1122*D1**2*f**2*gdd2 + 9564*D1**2*f*fd**2*r**2 + 25296*D1**2*f*fd**2*r*s - 14808*D1**2*f*fd**2*r + 15732*D1**2*f*fd**2*s**2 - 18920*D1**2*f*fd**2*s + 4216*D1**2*f*fd**2 - 3036*D1**2*f*fd*g2*r**2 - 6600*D1**2*f*fd*g2*r*s + 3300*D1**2*f*fd*g2*r - 3564*D1**2*f*fd*g2*s**2 + 3564*D1**2*f*fd*g2*s - 1782*D1**2*f*fd*g2 + 4488*D1**2*f*fd*gd2*r**2 + 12144*D1**2*f*fd*gd2*r*s - 7524*D1**2*f*fd*gd2*r + 7656*D1**2*f*fd*gd2*s**2 - 9900*D1**2*f*fd*gd2*s + 3036*D1**2*f*fd*gd2 + 2244*D1**2*f*fdd*g2*r**2 + 6072*D1**2*f*fdd*g2*r*s - 3036*D1**2*f*fdd*g2*r + 3828*D1**2*f*fdd*g2*s**2 - 3828*D1**2*f*fdd*g2*s + 1914*D1**2*f*fdd*g2 + 2244*D1**2*fd**2*g2*r**2 + 6072*D1**2*fd**2*g2*r*s - 3036*D1**2*fd**2*g2*r + 3828*D1**2*fd**2*g2*s**2 - 3828*D1**2*fd**2*g2*s + 18600*D1*Dd*f**4*r**2 + 63600*D1*Dd*f**4*r*s - 34500*D1*Dd*f**4*r + 45000*D1*Dd*f**4*s**2 - 54300*D1*Dd*f**4*s + 20550*D1*Dd*f**4 - 177600*D1*Dd*f**3*fd*r**2 - 451200*D1*Dd*f**3*fd*r*s + 290400*D1*Dd*f**3*fd*r - 273600*D1*Dd*f**3*fd*s**2 + 362400*D1*Dd*f**3*fd*s - 117900*D1*Dd*f**3*fd - 7736*D1*Dd*f**3*r**2 - 17888*D1*Dd*f**3*r*s + 12208*D1*Dd*f**3*r - 10152*D1*Dd*f**3*s**2 + 14020*D1*Dd*f**3*s - 6406*D1*Dd*f**3 + 38256*D1*Dd*f**2*fd*r**2 + 101184*D1*Dd*f**2*fd*r*s - 61392*D1*Dd*f**2*fd*r + 62928*D1*Dd*f**2*fd*s**2 - 78868*D1*Dd*f**2*fd*s + 24268*D1*Dd*f**2*fd - 6072*D1*Dd*f**2*g2*r**2 - 13200*D1*Dd*f**2*g2*r*s + 9372*D1*Dd*f**2*g2*r - 7128*D1*Dd*f**2*g2*s**2 + 10164*D1*Dd*f**2*g2*s - 4818*D1*Dd*f**2*g2 + 8976*D1*Dd*f**2*gd2*r**2 + 24288*D1*Dd*f**2*gd2*r*s - 16500*D1*Dd*f**2*gd2*r + 15312*D1*Dd*f**2*gd2*s**2 - 22044*D1*Dd*f**2*gd2*s + 7524*D1*Dd*f**2*gd2 + 17952*D1*Dd*f*fd*g2*r**2 + 48576*D1*Dd*f*fd*g2*r*s - 27192*D1*Dd*f*fd*g2*r + 30624*D1*Dd*f*fd*g2*s**2 - 35112*D1*Dd*f*fd*g2*s + 9900*D1*Dd*f*fd*g2 - 22200*D1*Ddd*f**4*r**2 - 56400*D1*Ddd*f**4*r*s + 36300*D1*Ddd*f**4*r - 34200*D1*Ddd*f**4*s**2 + 45300*D1*Ddd*f**4*s - 19650*D1*Ddd*f**4 + 6376*D1*Ddd*f**3*r**2 + 16864*D1*Ddd*f**3*r*s - 10592*D1*Ddd*f**3*r + 10488*D1*Ddd*f**3*s**2 - 13676*D1*Ddd*f**3*s + 5810*D1*Ddd*f**3 + 4488*D1*Ddd*f**2*g2*r**2 + 12144*D1*Ddd*f**2*g2*r*s - 7524*D1*Ddd*f**2*g2*r + 7656*D1*Ddd*f**2*g2*s**2 - 9900*D1*Ddd*f**2*g2*s + 4158*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(4*f**3*(185*r**2 + 570*r*s - 703*r + 385*s**2 - 903*s + 602) + f**2*(44*C*(r**2 + 2*r*(7*s - 6) + 13*s**2 - 24*s + 12) - 11*K*(23*r**2 + 50*r*s - 46*r + 27*s**2 - 50*s + 23) - 200*fd*(21*r**2 + r*(54*s - 43) + 33*s**2 - 53*s + 16) + 561*r**2 + 858*r*s - 682*r + 297*s**2 - 418*s + 77) - 22*f*(fd*(4*C*(2*r**2 + 8*r*(2*s - 1) + 14*s**2 - 17*s + 3) - K*(34*r**2 + 92*r*s - 57*r + 58*s**2 - 75*s + 23) + 74*r**2 + 148*r*s - 103*r + 74*s**2 - 103*s + 41) + 6*g2*(3*r**2 + 2*r*(5*s - 2) + 7*s**2 - 8*s + 4) - 4*gd2*(r**2 + r*(8*s - 4) + 7*s**2 - 10*s + 3)) + 88*fd*g2*(r**2 + r*(8*s - 4) + s*(7*s - 7))) - 2*Dd*f*(100*f**2*(28*r**2 + 9*r*(8*s - 7) + 44*s**2 - 77*s + 32) + 11*f*(4*C*(4*r**2 + 2*r*(16*s - 9) + 28*s**2 - 39*s + 12) - K*(68*r**2 + 184*r*s - 125*r + 116*s**2 - 167*s + 57) + 148*r**2 + 296*r*s - 227*r + 148*s**2 - 227*s + 87) - 44*g2*(4*r**2 + 2*r*(16*s - 9) + 28*s**2 - 39*s + 12))) - 66600*Dd**2*f**4*r**2 - 169200*Dd**2*f**4*r*s + 108900*Dd**2*f**4*r - 102600*Dd**2*f**4*s**2 + 135900*Dd**2*f**4*s - 39300*Dd**2*f**4 + 19128*Dd**2*f**3*r**2 + 50592*Dd**2*f**3*r*s - 31776*Dd**2*f**3*r + 31464*Dd**2*f**3*s**2 - 41028*Dd**2*f**3*s + 11620*Dd**2*f**3 + 13464*Dd**2*f**2*g2*r**2 + 36432*Dd**2*f**2*g2*r*s - 22572*Dd**2*f**2*g2*r + 22968*Dd**2*f**2*g2*s**2 - 29700*Dd**2*f**2*g2*s + 8316*Dd**2*f**2*g2 - 66*b1**2*(K - 1)*(D1**2*(3*fd*(3*r**2 + 10*r*s - 6*r + 7*s**2 - 6*s + 3) - fdd*(r**2 + 8*r*s - 2*r + 7*s**2 - 2*s + 1)) + D1*(Dd*(3*f*(12*r**2 + 40*r*s - 22*r + 28*s**2 - 34*s + 13) - 2*fd*(4*r**2 + 32*r*s - 10*r + 28*s**2 - 19*s + 3)) - Ddd*f*(4*r**2 + 4*r*(8*s - 3) + 28*s**2 - 30*s + 9)) - 6*Dd**2*f*(2*r**2 + 2*r*(8*s - 3) + 14*s**2 - 15*s + 3)) - 3*b1*(88*C*D1**2*f*fd*r**2 + 1232*C*D1**2*f*fd*r*s - 176*C*D1**2*f*fd*r + 1144*C*D1**2*f*fd*s**2 - 704*C*D1**2*f*fd*s + 88*C*D1**2*f*fd - 88*C*D1**2*f*fdd*r**2 - 704*C*D1**2*f*fdd*r*s + 176*C*D1**2*f*fdd*r - 616*C*D1**2*f*fdd*s**2 + 440*C*D1**2*f*fdd*s - 88*C*D1**2*f*fdd - 88*C*D1**2*fd**2*r**2 - 704*C*D1**2*fd**2*r*s + 176*C*D1**2*fd**2*r - 616*C*D1**2*fd**2*s**2 + 440*C*D1**2*fd**2*s - 88*C*D1**2*fd**2 + 176*C*D1*Dd*f**2*r**2 + 2464*C*D1*Dd*f**2*r*s - 792*C*D1*Dd*f**2*r + 2288*C*D1*Dd*f**2*s**2 - 2376*C*D1*Dd*f**2*s + 660*C*D1*Dd*f**2 - 704*C*D1*Dd*f*fd*r**2 - 5632*C*D1*Dd*f*fd*r*s + 1760*C*D1*Dd*f*fd*r - 4928*C*D1*Dd*f*fd*s**2 + 4400*C*D1*Dd*f*fd*s - 792*C*D1*Dd*f*fd - 176*C*D1*Ddd*f**2*r**2 - 1408*C*D1*Ddd*f**2*r*s + 528*C*D1*Ddd*f**2*r - 1232*C*D1*Ddd*f**2*s**2 + 1320*C*D1*Ddd*f**2*s - 396*C*D1*Ddd*f**2 - 528*C*Dd**2*f**2*r**2 - 4224*C*Dd**2*f**2*r*s + 1584*C*Dd**2*f**2*r - 3696*C*Dd**2*f**2*s**2 + 3960*C*Dd**2*f**2*s - 792*C*Dd**2*f**2 - 506*D1**2*K*f*fd*r**2 - 1100*D1**2*K*f*fd*r*s + 550*D1**2*K*f*fd*r - 594*D1**2*K*f*fd*s**2 + 594*D1**2*K*f*fd*s - 297*D1**2*K*f*fd + 374*D1**2*K*f*fdd*r**2 + 1012*D1**2*K*f*fdd*r*s - 506*D1**2*K*f*fdd*r + 638*D1**2*K*f*fdd*s**2 - 638*D1**2*K*f*fdd*s + 319*D1**2*K*f*fdd + 374*D1**2*K*fd**2*r**2 + 1012*D1**2*K*fd**2*r*s - 506*D1**2*K*fd**2*r + 638*D1**2*K*fd**2*s**2 - 638*D1**2*K*fd**2*s - 22*D1**2*bdd1*f*(K - 1)*(2*r**2 + 16*r*s - 8*r + 14*s**2 - 20*s + 7) + 2220*D1**2*f**2*fd*r**2 + 6840*D1**2*f**2*fd*r*s - 2428*D1**2*f**2*fd*r + 4620*D1**2*f**2*fd*s**2 - 4028*D1**2*f**2*fd*s + 612*D1**2*f**2*fd - 2100*D1**2*f**2*fdd*r**2 - 5400*D1**2*f**2*fdd*r*s + 2600*D1**2*f**2*fdd*r - 3300*D1**2*f**2*fdd*s**2 + 3400*D1**2*f**2*fdd*s - 900*D1**2*f**2*fdd - 4200*D1**2*f*fd**2*r**2 - 10800*D1**2*f*fd**2*r*s + 5200*D1**2*f*fd**2*r - 6600*D1**2*f*fd**2*s**2 + 6800*D1**2*f*fd**2*s - 1800*D1**2*f*fd**2 + 1122*D1**2*f*fd*r**2 + 1716*D1**2*f*fd*r*s - 1298*D1**2*f*fd*r + 594*D1**2*f*fd*s**2 - 1034*D1**2*f*fd*s + 781*D1**2*f*fd - 814*D1**2*f*fdd*r**2 - 1628*D1**2*f*fdd*r*s + 990*D1**2*f*fdd*r - 814*D1**2*f*fdd*s**2 + 990*D1**2*f*fdd*s - 627*D1**2*f*fdd - 396*D1**2*f*gd2*r**2 - 1320*D1**2*f*gd2*r*s + 792*D1**2*f*gd2*r - 924*D1**2*f*gd2*s**2 + 1320*D1**2*f*gd2*s - 396*D1**2*f*gd2 + 44*D1**2*f*gdd2*r**2 + 352*D1**2*f*gdd2*r*s - 88*D1**2*f*gdd2*r + 308*D1**2*f*gdd2*s**2 - 352*D1**2*f*gdd2*s + 44*D1**2*f*gdd2 - 814*D1**2*fd**2*r**2 - 1628*D1**2*fd**2*r*s + 990*D1**2*fd**2*r - 814*D1**2*fd**2*s**2 + 990*D1**2*fd**2*s + 88*D1**2*fd**2 - 396*D1**2*fd*g2*r**2 - 1320*D1**2*fd*g2*r*s + 792*D1**2*fd*g2*r - 924*D1**2*fd*g2*s**2 + 792*D1**2*fd*g2*s - 396*D1**2*fd*g2 + 88*D1**2*fd*gd2*r**2 + 704*D1**2*fd*gd2*r*s - 176*D1**2*fd*gd2*r + 616*D1**2*fd*gd2*s**2 - 440*D1**2*fd*gd2*s + 88*D1**2*fd*gd2 + 44*D1**2*fdd*g2*r**2 + 352*D1**2*fdd*g2*r*s - 88*D1**2*fdd*g2*r + 308*D1**2*fdd*g2*s**2 - 88*D1**2*fdd*g2*s + 44*D1**2*fdd*g2 - 1012*D1*Dd*K*f**2*r**2 - 2200*D1*Dd*K*f**2*r*s + 1562*D1*Dd*K*f**2*r - 1188*D1*Dd*K*f**2*s**2 + 1694*D1*Dd*K*f**2*s - 803*D1*Dd*K*f**2 + 2992*D1*Dd*K*f*fd*r**2 + 8096*D1*Dd*K*f*fd*r*s - 4532*D1*Dd*K*f*fd*r + 5104*D1*Dd*K*f*fd*s**2 - 5852*D1*Dd*K*f*fd*s + 1650*D1*Dd*K*f*fd + 2960*D1*Dd*f**3*r**2 + 9120*D1*Dd*f**3*r*s - 5240*D1*Dd*f**3*r + 6160*D1*Dd*f**3*s**2 - 7640*D1*Dd*f**3*s + 3020*D1*Dd*f**3 - 16800*D1*Dd*f**2*fd*r**2 - 43200*D1*Dd*f**2*fd*r*s + 24200*D1*Dd*f**2*fd*r - 26400*D1*Dd*f**2*fd*s**2 + 31000*D1*Dd*f**2*fd*s - 8600*D1*Dd*f**2*fd + 2244*D1*Dd*f**2*r**2 + 3432*D1*Dd*f**2*r*s - 3102*D1*Dd*f**2*r + 1188*D1*Dd*f**2*s**2 - 2310*D1*Dd*f**2*s + 1419*D1*Dd*f**2 - 6512*D1*Dd*f*fd*r**2 - 13024*D1*Dd*f*fd*r*s + 8844*D1*Dd*f*fd*r - 6512*D1*Dd*f*fd*s**2 + 8844*D1*Dd*f*fd*s - 2970*D1*Dd*f*fd - 1584*D1*Dd*f*g2*r**2 - 5280*D1*Dd*f*g2*r*s + 2904*D1*Dd*f*g2*r - 3696*D1*Dd*f*g2*s**2 + 4488*D1*Dd*f*g2*s - 1716*D1*Dd*f*g2 + 352*D1*Dd*f*gd2*r**2 + 2816*D1*Dd*f*gd2*r*s - 880*D1*Dd*f*gd2*r + 2464*D1*Dd*f*gd2*s**2 - 2728*D1*Dd*f*gd2*s + 528*D1*Dd*f*gd2 + 352*D1*Dd*fd*g2*r**2 + 2816*D1*Dd*fd*g2*r*s - 880*D1*Dd*fd*g2*r + 2464*D1*Dd*fd*g2*s**2 - 1672*D1*Dd*fd*g2*s + 264*D1*Dd*fd*g2 + 748*D1*Ddd*K*f**2*r**2 + 2024*D1*Ddd*K*f**2*r*s - 1254*D1*Ddd*K*f**2*r + 1276*D1*Ddd*K*f**2*s**2 - 1650*D1*Ddd*K*f**2*s + 693*D1*Ddd*K*f**2 - 2800*D1*Ddd*f**3*r**2 - 7200*D1*Ddd*f**3*r*s + 4600*D1*Ddd*f**3*r - 4400*D1*Ddd*f**3*s**2 + 5800*D1*Ddd*f**3*s - 2500*D1*Ddd*f**3 - 1628*D1*Ddd*f**2*r**2 - 3256*D1*Ddd*f**2*r*s + 2442*D1*Ddd*f**2*r - 1628*D1*Ddd*f**2*s**2 + 2442*D1*Ddd*f**2*s - 1221*D1*Ddd*f**2 + 176*D1*Ddd*f*g2*r**2 + 1408*D1*Ddd*f*g2*r*s - 528*D1*Ddd*f*g2*r + 1232*D1*Ddd*f*g2*s**2 - 1320*D1*Ddd*f*g2*s + 396*D1*Ddd*f*g2 + 22*D1*bd1*(K - 1)*(D1*(3*f*(6*r**2 + 20*r*s - 10*r + 14*s**2 - 18*s + 7) - 2*fd*(2*r**2 + 16*r*s - 6*r + 14*s**2 - 12*s + 1)) - 4*Dd*f*(4*r**2 + 2*r*(16*s - 7) + 28*s**2 - 35*s + 9)) + 2244*Dd**2*K*f**2*r**2 + 6072*Dd**2*K*f**2*r*s - 3762*Dd**2*K*f**2*r + 3828*Dd**2*K*f**2*s**2 - 4950*Dd**2*K*f**2*s + 1386*Dd**2*K*f**2 - 8400*Dd**2*f**3*r**2 - 21600*Dd**2*f**3*r*s + 13800*Dd**2*f**3*r - 13200*Dd**2*f**3*s**2 + 17400*Dd**2*f**3*s - 5000*Dd**2*f**3 - 4884*Dd**2*f**2*r**2 - 9768*Dd**2*f**2*r*s + 7326*Dd**2*f**2*r - 4884*Dd**2*f**2*s**2 + 7326*Dd**2*f**2*s - 2442*Dd**2*f**2 + 528*Dd**2*f*g2*r**2 + 4224*Dd**2*f*g2*r*s - 1584*Dd**2*f*g2*r + 3696*Dd**2*f*g2*s**2 - 3960*Dd**2*f*g2*s + 792*Dd**2*f*g2))/(693*d**2*k3**6) + 4*D1**2*Pk2*Pk3*ct**2*k1**4*(-3564*C*D1**2*bdd1*f**2*r**2 - 9504*C*D1**2*bdd1*f**2*r*s + 9504*C*D1**2*bdd1*f**2*r - 5940*C*D1**2*bdd1*f**2*s**2 + 11880*C*D1**2*bdd1*f**2*s - 5940*C*D1**2*bdd1*f**2 + 1380*C*D1**2*f**2*fd*r**2 + 13440*C*D1**2*f**2*fd*r*s - 5400*C*D1**2*f**2*fd*r + 12060*C*D1**2*f**2*fd*s**2 - 12520*C*D1**2*f**2*fd*s + 4480*C*D1**2*f**2*fd - 1680*C*D1**2*f**2*fdd*r**2 - 14640*C*D1**2*f**2*fdd*r*s + 6000*C*D1**2*f**2*fdd*r - 12960*C*D1**2*f**2*fdd*s**2 + 13520*C*D1**2*f**2*fdd*s - 4880*C*D1**2*f**2*fdd - 3360*C*D1**2*f*fd**2*r**2 - 29280*C*D1**2*f*fd**2*r*s + 12000*C*D1**2*f*fd**2*r - 25920*C*D1**2*f*fd**2*s**2 + 27040*C*D1**2*f*fd**2*s - 4880*C*D1**2*f*fd**2 + 1840*C*D1*Dd*f**3*r**2 + 17920*C*D1*Dd*f**3*r*s - 6320*C*D1*Dd*f**3*r + 16080*C*D1*Dd*f**3*s**2 - 17000*C*D1*Dd*f**3*s + 4940*C*D1*Dd*f**3 - 13440*C*D1*Dd*f**2*fd*r**2 - 117120*C*D1*Dd*f**2*fd*r*s + 45360*C*D1*Dd*f**2*fd*r - 103680*C*D1*Dd*f**2*fd*s**2 + 109280*C*D1*Dd*f**2*fd*s - 25520*C*D1*Dd*f**2*fd - 2240*C*D1*Ddd*f**3*r**2 - 19520*C*D1*Ddd*f**3*r*s + 7120*C*D1*Ddd*f**3*r - 17280*C*D1*Ddd*f**3*s**2 + 18400*C*D1*Ddd*f**3*s - 5440*C*D1*Ddd*f**3 - 6720*C*Dd**2*f**3*r**2 - 58560*C*Dd**2*f**3*r*s + 21360*C*Dd**2*f**3*r - 51840*C*Dd**2*f**3*s**2 + 55200*C*Dd**2*f**3*s - 10880*C*Dd**2*f**3 - 330*D1**2*K*bdd1*f**2*r**2 - 2904*D1**2*K*bdd1*f**2*r*s + 660*D1**2*K*bdd1*f**2*r - 2574*D1**2*K*bdd1*f**2*s**2 + 2904*D1**2*K*bdd1*f**2*s - 330*D1**2*K*bdd1*f**2 + 528*D1**2*b2*f*fd*r**2 + 1056*D1**2*b2*f*fd*r*s - 528*D1**2*b2*f*fd*r + 528*D1**2*b2*f*fd*s**2 - 528*D1**2*b2*f*fd*s + 264*D1**2*b2*f*fd - 660*D1**2*b2*f*fdd*r**2 - 1320*D1**2*b2*f*fdd*r*s + 660*D1**2*b2*f*fdd*r - 660*D1**2*b2*f*fdd*s**2 + 660*D1**2*b2*f*fdd*s - 330*D1**2*b2*f*fdd - 660*D1**2*b2*fd**2*r**2 - 1320*D1**2*b2*fd**2*r*s + 660*D1**2*b2*fd**2*r - 660*D1**2*b2*fd**2*s**2 + 660*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*(r + s - 1)*(20*f**2*(3*r + 3*s - 2) + f*(24*C*r + 24*C*s + K*(-59*r - 107*s + 83) + 83*r + 131*s - 131) - 28*g2*(r + s)) - 4620*D1**2*bdd1*f**3*r**2 - 6270*D1**2*bdd1*f**3*r*s + 8580*D1**2*bdd1*f**3*r - 1650*D1**2*bdd1*f**3*s**2 + 5610*D1**2*bdd1*f**3*s - 3960*D1**2*bdd1*f**3 + 4884*D1**2*bdd1*f**2*r**2 + 13266*D1**2*bdd1*f**2*r*s - 12144*D1**2*bdd1*f**2*r + 8382*D1**2*bdd1*f**2*s**2 - 15642*D1**2*bdd1*f**2*s + 7260*D1**2*bdd1*f**2 + 3894*D1**2*bdd1*f*g2*r**2 + 10956*D1**2*bdd1*f*g2*r*s - 10956*D1**2*bdd1*f*g2*r + 7062*D1**2*bdd1*f*g2*s**2 - 14124*D1**2*bdd1*f*g2*s + 7062*D1**2*bdd1*f*g2 - 330*D1**2*bdd2*f**2*r**2 - 660*D1**2*bdd2*f**2*r*s + 660*D1**2*bdd2*f**2*r - 330*D1**2*bdd2*f**2*s**2 + 660*D1**2*bdd2*f**2*s - 330*D1**2*bdd2*f**2 - 690*D1**2*f**2*fd*r**2 - 9390*D1**2*f**2*fd*r*s + 3590*D1**2*f**2*fd*r - 8700*D1**2*f**2*fd*s**2 + 8930*D1**2*f**2*fd*s - 3130*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 + 10140*D1**2*f**2*fdd*r*s - 3940*D1**2*f**2*fdd*r + 9300*D1**2*f**2*fdd*s**2 - 9580*D1**2*f**2*fdd*s + 3380*D1**2*f**2*fdd - 528*D1**2*f**2*gd2*r**2 - 5280*D1**2*f**2*gd2*r*s + 1056*D1**2*f**2*gd2*r - 4752*D1**2*f**2*gd2*s**2 + 5280*D1**2*f**2*gd2*s - 528*D1**2*f**2*gd2 + 660*D1**2*f**2*gdd2*r**2 + 5808*D1**2*f**2*gdd2*r*s - 1320*D1**2*f**2*gdd2*r + 5148*D1**2*f**2*gdd2*s**2 - 5808*D1**2*f**2*gdd2*s + 660*D1**2*f**2*gdd2 + 1680*D1**2*f*fd**2*r**2 + 20280*D1**2*f*fd**2*r*s - 7880*D1**2*f*fd**2*r + 18600*D1**2*f*fd**2*s**2 - 19160*D1**2*f*fd**2*s + 3380*D1**2*f*fd**2 - 1056*D1**2*f*fd*g2*r**2 - 10560*D1**2*f*fd*g2*r*s + 5280*D1**2*f*fd*g2*r - 9504*D1**2*f*fd*g2*s**2 + 9504*D1**2*f*fd*g2*s - 4752*D1**2*f*fd*g2 + 2640*D1**2*f*fd*gd2*r**2 + 23232*D1**2*f*fd*gd2*r*s - 8448*D1**2*f*fd*gd2*r + 20592*D1**2*f*fd*gd2*s**2 - 21912*D1**2*f*fd*gd2*s + 5808*D1**2*f*fd*gd2 + 1320*D1**2*f*fdd*g2*r**2 + 11616*D1**2*f*fdd*g2*r*s - 5808*D1**2*f*fdd*g2*r + 10296*D1**2*f*fdd*g2*s**2 - 10296*D1**2*f*fdd*g2*s + 5148*D1**2*f*fdd*g2 + 1320*D1**2*fd**2*g2*r**2 + 11616*D1**2*fd**2*g2*r*s - 5808*D1**2*fd**2*g2*r + 10296*D1**2*fd**2*g2*s**2 - 10296*D1**2*fd**2*g2*s + 1056*D1*Dd*b2*f**2*r**2 + 2112*D1*Dd*b2*f**2*r*s - 1584*D1*Dd*b2*f**2*r + 1056*D1*Dd*b2*f**2*s**2 - 1584*D1*Dd*b2*f**2*s + 792*D1*Dd*b2*f**2 - 5280*D1*Dd*b2*f*fd*r**2 - 10560*D1*Dd*b2*f*fd*r*s + 6600*D1*Dd*b2*f*fd*r - 5280*D1*Dd*b2*f*fd*s**2 + 6600*D1*Dd*b2*f*fd*s - 1980*D1*Dd*b2*f*fd - 920*D1*Dd*f**3*r**2 - 12520*D1*Dd*f**3*r*s + 4050*D1*Dd*f**3*r - 11600*D1*Dd*f**3*s**2 + 12060*D1*Dd*f**3*s - 3360*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 + 81120*D1*Dd*f**2*fd*r*s - 29260*D1*Dd*f**2*fd*r + 74400*D1*Dd*f**2*fd*s**2 - 77200*D1*Dd*f**2*fd*s + 17460*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*g2*r**2 - 21120*D1*Dd*f**2*g2*r*s + 7392*D1*Dd*f**2*g2*r - 19008*D1*Dd*f**2*g2*s**2 + 20064*D1*Dd*f**2*g2*s - 5808*D1*Dd*f**2*g2 + 5280*D1*Dd*f**2*gd2*r**2 + 46464*D1*Dd*f**2*gd2*r*s - 13728*D1*Dd*f**2*gd2*r + 41184*D1*Dd*f**2*gd2*s**2 - 45144*D1*Dd*f**2*gd2*s + 8448*D1*Dd*f**2*gd2 + 10560*D1*Dd*f*fd*g2*r**2 + 92928*D1*Dd*f*fd*g2*r*s - 40128*D1*Dd*f*fd*g2*r + 82368*D1*Dd*f*fd*g2*s**2 - 85008*D1*Dd*f*fd*g2*s + 21912*D1*Dd*f*fd*g2 - 1320*D1*Ddd*b2*f**2*r**2 - 2640*D1*Ddd*b2*f**2*r*s + 1980*D1*Ddd*b2*f**2*r - 1320*D1*Ddd*b2*f**2*s**2 + 1980*D1*Ddd*b2*f**2*s - 990*D1*Ddd*b2*f**2 + 1120*D1*Ddd*f**3*r**2 + 13520*D1*Ddd*f**3*r*s - 4500*D1*Ddd*f**3*r + 12400*D1*Ddd*f**3*s**2 - 12960*D1*Ddd*f**3*s + 3660*D1*Ddd*f**3 + 2640*D1*Ddd*f**2*g2*r**2 + 23232*D1*Ddd*f**2*g2*r*s - 8448*D1*Ddd*f**2*g2*r + 20592*D1*Ddd*f**2*g2*s**2 - 21912*D1*Ddd*f**2*g2*s + 6468*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(5*f**3*(12*r**2 + r*(19*s - 28) + 7*s**2 - 23*s + 16) + f**2*(6*C*(7*r**2 + 22*r*(s - 1) + 15*(s - 1)**2) - 5*fd*(84*r**2 + r*(114*s - 127) + 30*s**2 - 82*s + 45) + (2*r + 2*s - 2)*(2*K*(r + 9*s - 1) - 29*r - 61*s + 53)) - f*(fd*(36*C*(6*r**2 + 16*r*s - 11*r + 10*s**2 - 14*s + 4) + 2*K*(10*r**2 + 88*r*s - 32*r + 78*s**2 - 83*s + 22) - 296*r**2 - 804*r*s + 533*r - 508*s**2 + 692*s - 201) + (r + s - 1)*(41*g2*r + 109*g2*(s - 1) - 2*gd2*(59*r + 107*s - 83))) + 2*fd*g2*(59*r**2 + 83*r*(2*s - 1) + s*(107*s - 107))) - Dd*f*(5*f**2*(112*r**2 + r*(152*s - 179) + 40*s**2 - 116*s + 69) + f*(36*C*(12*r**2 + r*(32*s - 26) + 20*s**2 - 33*s + 13) + 2*K*(20*r**2 + 176*r*s - 52*r + 156*s**2 - 171*s + 32) - 592*r**2 - 1608*r*s + 1233*r - 1016*s**2 + 1604*s - 605) - 2*g2*(236*r**2 + r*(664*s - 533) + 428*s**2 - 701*s + 273))) + 132*D1*bd2*f*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 3960*Dd**2*b2*f**2*r**2 - 7920*Dd**2*b2*f**2*r*s + 5940*Dd**2*b2*f**2*r - 3960*Dd**2*b2*f**2*s**2 + 5940*Dd**2*b2*f**2*s - 1980*Dd**2*b2*f**2 + 3360*Dd**2*f**3*r**2 + 40560*Dd**2*f**3*r*s - 13500*Dd**2*f**3*r + 37200*Dd**2*f**3*s**2 - 38880*Dd**2*f**3*s + 7320*Dd**2*f**3 + 7920*Dd**2*f**2*g2*r**2 + 69696*Dd**2*f**2*g2*r*s - 25344*Dd**2*f**2*g2*r + 61776*Dd**2*f**2*g2*s**2 - 65736*Dd**2*f**2*g2*s + 12936*Dd**2*f**2*g2 - 462*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1**2*(20*C*D1**2*fd*r**2 + 40*C*D1**2*fd*r*s - 40*C*D1**2*fd*r + 20*C*D1**2*fd*s**2 - 40*C*D1**2*fd*s + 20*C*D1**2*fd - 24*C*D1**2*fdd*r**2 - 48*C*D1**2*fdd*r*s + 48*C*D1**2*fdd*r - 24*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s - 24*C*D1**2*fdd + 80*C*D1*Dd*f*r**2 + 160*C*D1*Dd*f*r*s - 120*C*D1*Dd*f*r + 80*C*D1*Dd*f*s**2 - 120*C*D1*Dd*f*s + 60*C*D1*Dd*f - 192*C*D1*Dd*fd*r**2 - 384*C*D1*Dd*fd*r*s + 336*C*D1*Dd*fd*r - 192*C*D1*Dd*fd*s**2 + 336*C*D1*Dd*fd*s - 144*C*D1*Dd*fd - 96*C*D1*Ddd*f*r**2 - 192*C*D1*Ddd*f*r*s + 144*C*D1*Ddd*f*r - 96*C*D1*Ddd*f*s**2 + 144*C*D1*Ddd*f*s - 72*C*D1*Ddd*f - 288*C*Dd**2*f*r**2 - 576*C*Dd**2*f*r*s + 432*C*Dd**2*f*r - 288*C*Dd**2*f*s**2 + 432*C*Dd**2*f*s - 144*C*Dd**2*f - 41*D1**2*K*fd*r**2 - 150*D1**2*K*fd*r*s - 109*D1**2*K*fd*s**2 + 59*D1**2*K*fdd*r**2 + 166*D1**2*K*fdd*r*s + 107*D1**2*K*fdd*s**2 - 14*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 96*D1**2*f*fd*r**2 + 192*D1**2*f*fd*r*s - 128*D1**2*f*fd*r + 96*D1**2*f*fd*s**2 - 128*D1**2*f*fd*s + 64*D1**2*f*fd - 120*D1**2*f*fdd*r**2 - 240*D1**2*f*fdd*r*s + 160*D1**2*f*fdd*r - 120*D1**2*f*fdd*s**2 + 160*D1**2*f*fdd*s - 80*D1**2*f*fdd - 120*D1**2*fd**2*r**2 - 240*D1**2*fd**2*r*s + 160*D1**2*fd**2*r - 120*D1**2*fd**2*s**2 + 160*D1**2*fd**2*s - 40*D1**2*fd**2 + 61*D1**2*fd*r**2 + 190*D1**2*fd*r*s + 40*D1**2*fd*r + 129*D1**2*fd*s**2 + 40*D1**2*fd*s - 20*D1**2*fd - 83*D1**2*fdd*r**2 - 214*D1**2*fdd*r*s - 48*D1**2*fdd*r - 131*D1**2*fdd*s**2 - 48*D1**2*fdd*s + 24*D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 - 164*D1*Dd*K*f*r**2 - 600*D1*Dd*K*f*r*s + 314*D1*Dd*K*f*r - 436*D1*Dd*K*f*s**2 + 518*D1*Dd*K*f*s - 191*D1*Dd*K*f + 472*D1*Dd*K*fd*r**2 + 1328*D1*Dd*K*fd*r*s - 402*D1*Dd*K*fd*r + 856*D1*Dd*K*fd*s**2 - 546*D1*Dd*K*fd*s + 192*D1*Dd*f**2*r**2 + 384*D1*Dd*f**2*r*s - 288*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 288*D1*Dd*f**2*s + 144*D1*Dd*f**2 - 960*D1*Dd*f*fd*r**2 - 1920*D1*Dd*f*fd*r*s + 1360*D1*Dd*f*fd*r - 960*D1*Dd*f*fd*s**2 + 1360*D1*Dd*f*fd*s - 480*D1*Dd*f*fd + 244*D1*Dd*f*r**2 + 760*D1*Dd*f*r*s - 434*D1*Dd*f*r + 516*D1*Dd*f*s**2 - 638*D1*Dd*f*s + 251*D1*Dd*f - 664*D1*Dd*fd*r**2 - 1712*D1*Dd*fd*r*s + 354*D1*Dd*fd*r - 1048*D1*Dd*fd*s**2 + 498*D1*Dd*fd*s + 144*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 + 236*D1*Ddd*K*f*r**2 + 664*D1*Ddd*K*f*r*s - 402*D1*Ddd*K*f*r + 428*D1*Ddd*K*f*s**2 - 546*D1*Ddd*K*f*s + 225*D1*Ddd*K*f - 240*D1*Ddd*f**2*r**2 - 480*D1*Ddd*f**2*r*s + 360*D1*Ddd*f**2*r - 240*D1*Ddd*f**2*s**2 + 360*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 332*D1*Ddd*f*r**2 - 856*D1*Ddd*f*r*s + 546*D1*Ddd*f*r - 524*D1*Ddd*f*s**2 + 690*D1*Ddd*f*s - 297*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 708*Dd**2*K*f*r**2 + 1992*Dd**2*K*f*r*s - 1206*Dd**2*K*f*r + 1284*Dd**2*K*f*s**2 - 1638*Dd**2*K*f*s + 450*Dd**2*K*f - 720*Dd**2*f**2*r**2 - 1440*Dd**2*f**2*r*s + 1080*Dd**2*f**2*r - 720*Dd**2*f**2*s**2 + 1080*Dd**2*f**2*s - 360*Dd**2*f**2 - 996*Dd**2*f*r**2 - 2568*Dd**2*f*r*s + 1638*Dd**2*f*r - 1572*Dd**2*f*s**2 + 2070*Dd**2*f*s - 594*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) + 66*b1*(84*C*D1**2*f*fd*r**2 + 264*C*D1**2*f*fd*r*s - 84*C*D1**2*f*fd*r + 180*C*D1**2*f*fd*s**2 - 132*C*D1**2*f*fd*s + 42*C*D1**2*f*fd - 108*C*D1**2*f*fdd*r**2 - 288*C*D1**2*f*fdd*r*s + 108*C*D1**2*f*fdd*r - 180*C*D1**2*f*fdd*s**2 + 144*C*D1**2*f*fdd*s - 54*C*D1**2*f*fdd - 108*C*D1**2*fd**2*r**2 - 288*C*D1**2*fd**2*r*s + 108*C*D1**2*fd**2*r - 180*C*D1**2*fd**2*s**2 + 144*C*D1**2*fd**2*s + 168*C*D1*Dd*f**2*r**2 + 528*C*D1*Dd*f**2*r*s - 300*C*D1*Dd*f**2*r + 360*C*D1*Dd*f**2*s**2 - 444*C*D1*Dd*f**2*s + 174*C*D1*Dd*f**2 - 864*C*D1*Dd*f*fd*r**2 - 2304*C*D1*Dd*f*fd*r*s + 1152*C*D1*Dd*f*fd*r - 1440*C*D1*Dd*f*fd*s**2 + 1512*C*D1*Dd*f*fd*s - 360*C*D1*Dd*f*fd - 216*C*D1*Ddd*f**2*r**2 - 576*C*D1*Ddd*f**2*r*s + 360*C*D1*Ddd*f**2*r - 360*C*D1*Ddd*f**2*s**2 + 468*C*D1*Ddd*f**2*s - 198*C*D1*Ddd*f**2 - 648*C*Dd**2*f**2*r**2 - 1728*C*Dd**2*f**2*r*s + 1080*C*Dd**2*f**2*r - 1080*C*Dd**2*f**2*s**2 + 1404*C*Dd**2*f**2*s - 396*C*Dd**2*f**2 + 8*D1**2*K*f*fd*r**2 + 80*D1**2*K*f*fd*r*s - 40*D1**2*K*f*fd*r + 72*D1**2*K*f*fd*s**2 - 72*D1**2*K*f*fd*s + 36*D1**2*K*f*fd - 10*D1**2*K*f*fdd*r**2 - 88*D1**2*K*f*fdd*r*s + 44*D1**2*K*f*fdd*r - 78*D1**2*K*f*fdd*s**2 + 78*D1**2*K*f*fdd*s - 39*D1**2*K*f*fdd - 10*D1**2*K*fd**2*r**2 - 88*D1**2*K*fd**2*r*s + 44*D1**2*K*fd**2*r - 78*D1**2*K*fd**2*s**2 + 78*D1**2*K*fd**2*s + 14*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1**2*bdd1*(10*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + f*(12*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - K*(59*r**2 + 2*r*(83*s - 71) + 107*s**2 - 190*s + 83) + 83*r**2 + 214*r*s - 214*r + 131*s**2 - 262*s + 119) - 14*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 180*D1**2*f**2*fd*r**2 + 285*D1**2*f**2*fd*r*s - 195*D1**2*f**2*fd*r + 105*D1**2*f**2*fd*s**2 - 145*D1**2*f**2*fd*s + 75*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 285*D1**2*f**2*fdd*r*s + 245*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 155*D1**2*f**2*fdd*s - 105*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 - 570*D1**2*f*fd**2*r*s + 490*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 310*D1**2*f*fd**2*s - 105*D1**2*f*fd**2 - 116*D1**2*f*fd*r**2 - 360*D1**2*f*fd*r*s + 132*D1**2*f*fd*r - 244*D1**2*f*fd*s**2 + 196*D1**2*f*fd*s - 74*D1**2*f*fd + 148*D1**2*f*fdd*r**2 + 402*D1**2*f*fdd*r*s - 165*D1**2*f*fdd*r + 254*D1**2*f*fdd*s**2 - 218*D1**2*f*fdd*s + 91*D1**2*f*fdd - 41*D1**2*f*gd2*r**2 - 150*D1**2*f*gd2*r*s + 82*D1**2*f*gd2*r - 109*D1**2*f*gd2*s**2 + 150*D1**2*f*gd2*s - 41*D1**2*f*gd2 + 59*D1**2*f*gdd2*r**2 + 166*D1**2*f*gdd2*r*s - 118*D1**2*f*gdd2*r + 107*D1**2*f*gdd2*s**2 - 166*D1**2*f*gdd2*s + 59*D1**2*f*gdd2 + 148*D1**2*fd**2*r**2 + 402*D1**2*fd**2*r*s - 165*D1**2*fd**2*r + 254*D1**2*fd**2*s**2 - 218*D1**2*fd**2*s - 41*D1**2*fd*g2*r**2 - 150*D1**2*fd*g2*r*s - 109*D1**2*fd*g2*s**2 + 118*D1**2*fd*gd2*r**2 + 332*D1**2*fd*gd2*r*s - 118*D1**2*fd*gd2*r + 214*D1**2*fd*gd2*s**2 - 166*D1**2*fd*gd2*s + 59*D1**2*fdd*g2*r**2 + 166*D1**2*fdd*g2*r*s + 107*D1**2*fdd*g2*s**2 + 16*D1*Dd*K*f**2*r**2 + 160*D1*Dd*K*f**2*r*s - 56*D1*Dd*K*f**2*r + 144*D1*Dd*K*f**2*s**2 - 152*D1*Dd*K*f**2*s + 44*D1*Dd*K*f**2 - 80*D1*Dd*K*f*fd*r**2 - 704*D1*Dd*K*f*fd*r*s + 304*D1*Dd*K*f*fd*r - 624*D1*Dd*K*f*fd*s**2 + 644*D1*Dd*K*f*fd*s - 166*D1*Dd*K*f*fd + 240*D1*Dd*f**3*r**2 + 380*D1*Dd*f**3*r*s - 335*D1*Dd*f**3*r + 140*D1*Dd*f**3*s**2 - 260*D1*Dd*f**3*s + 155*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 2280*D1*Dd*f**2*fd*r*s + 2105*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 1340*D1*Dd*f**2*fd*s - 645*D1*Dd*f**2*fd - 232*D1*Dd*f**2*r**2 - 720*D1*Dd*f**2*r*s + 412*D1*Dd*f**2*r - 488*D1*Dd*f**2*s**2 + 604*D1*Dd*f**2*s - 238*D1*Dd*f**2 + 1184*D1*Dd*f*fd*r**2 + 3216*D1*Dd*f*fd*r*s - 1654*D1*Dd*f*fd*r + 2032*D1*Dd*f*fd*s**2 - 2184*D1*Dd*f*fd*s + 548*D1*Dd*f*fd - 164*D1*Dd*f*g2*r**2 - 600*D1*Dd*f*g2*r*s + 314*D1*Dd*f*g2*r - 436*D1*Dd*f*g2*s**2 + 518*D1*Dd*f*g2*s - 191*D1*Dd*f*g2 + 472*D1*Dd*f*gd2*r**2 + 1328*D1*Dd*f*gd2*r*s - 874*D1*Dd*f*gd2*r + 856*D1*Dd*f*gd2*s**2 - 1210*D1*Dd*f*gd2*s + 402*D1*Dd*f*gd2 + 472*D1*Dd*fd*g2*r**2 + 1328*D1*Dd*fd*g2*r*s - 402*D1*Dd*fd*g2*r + 856*D1*Dd*fd*g2*s**2 - 546*D1*Dd*fd*g2*s - 20*D1*Ddd*K*f**2*r**2 - 176*D1*Ddd*K*f**2*r*s + 64*D1*Ddd*K*f**2*r - 156*D1*Ddd*K*f**2*s**2 + 166*D1*Ddd*K*f**2*s - 49*D1*Ddd*K*f**2 - 280*D1*Ddd*f**3*r**2 - 380*D1*Ddd*f**3*r*s + 375*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 240*D1*Ddd*f**3*s - 165*D1*Ddd*f**3 + 296*D1*Ddd*f**2*r**2 + 804*D1*Ddd*f**2*r*s - 497*D1*Ddd*f**2*r + 508*D1*Ddd*f**2*s**2 - 656*D1*Ddd*f**2*s + 275*D1*Ddd*f**2 + 236*D1*Ddd*f*g2*r**2 + 664*D1*Ddd*f*g2*r*s - 402*D1*Ddd*f*g2*r + 428*D1*Ddd*f*g2*s**2 - 546*D1*Ddd*f*g2*s + 225*D1*Ddd*f*g2 + D1*bd1*(D1*(-8*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + f*(-10*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 41*K*r**2 + 150*K*r*s - 116*K*r + 109*K*s**2 - 184*K*s + 75*K + 120*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 61*r**2 - 190*r*s + 176*r - 129*s**2 + 244*s - 105) + 2*fd*(12*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 107*K*s**2 + 95*K*s + r**2*(83 - 59*K) + r*(-166*K*s + 71*K + 214*s - 83) + 131*s**2 - 107*s - 12) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(10*f**2*(24*r**2 + r*(48*s - 38) + 24*s**2 - 38*s + 15) + f*(12*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(236*r**2 + 664*r*s - 485*r + 428*s**2 - 653*s + 237) + 332*r**2 + 856*r*s - 701*r + 524*s**2 - 869*s + 345) - 14*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 60*Dd**2*K*f**2*r**2 - 528*Dd**2*K*f**2*r*s + 192*Dd**2*K*f**2*r - 468*Dd**2*K*f**2*s**2 + 498*Dd**2*K*f**2*s - 98*Dd**2*K*f**2 - 840*Dd**2*f**3*r**2 - 1140*Dd**2*f**3*r*s + 1125*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 720*Dd**2*f**3*s - 330*Dd**2*f**3 + 888*Dd**2*f**2*r**2 + 2412*Dd**2*f**2*r*s - 1491*Dd**2*f**2*r + 1524*Dd**2*f**2*s**2 - 1968*Dd**2*f**2*s + 550*Dd**2*f**2 + 708*Dd**2*f*g2*r**2 + 1992*Dd**2*f*g2*r*s - 1206*Dd**2*f*g2*r + 1284*Dd**2*f*g2*s**2 - 1638*Dd**2*f*g2*s + 450*Dd**2*f*g2))/(693*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**2*k1**4*st**2*(44*C*D1**2*bdd1*f**2*s**2 - 88*C*D1**2*bdd1*f**2*s + 44*C*D1**2*bdd1*f**2 + 1530*C*D1**2*f**2*fd*s**2 - 1020*C*D1**2*f**2*fd*s + 510*C*D1**2*f**2*fd - 930*C*D1**2*f**2*fdd*s**2 + 620*C*D1**2*f**2*fdd*s - 310*C*D1**2*f**2*fdd - 1860*C*D1**2*f*fd**2*s**2 + 1240*C*D1**2*f*fd**2*s + 2040*C*D1*Dd*f**3*s**2 - 1020*C*D1*Dd*f**3*s + 510*C*D1*Dd*f**3 - 7440*C*D1*Dd*f**2*fd*s**2 + 4340*C*D1*Dd*f**2*fd*s - 620*C*D1*Dd*f**2*fd - 1240*C*D1*Ddd*f**3*s**2 + 620*C*D1*Ddd*f**3*s - 310*C*D1*Ddd*f**3 - 3720*C*Dd**2*f**3*s**2 + 1860*C*Dd**2*f**3*s - 187*D1**2*K*bdd1*f**2*s**2 + 44*D1**2*bd1**2*f*s*(K - 1)*(s - 1) + 400*D1**2*bdd1*f**3*r*s + 600*D1**2*bdd1*f**3*s**2 - 800*D1**2*bdd1*f**3*s + 300*D1**2*bdd1*f**3 + 132*D1**2*bdd1*f**2*r*s + 275*D1**2*bdd1*f**2*s**2 - 44*D1**2*bdd1*f**2*s - 44*D1**2*bdd1*f**2 - 44*D1**2*bdd1*f*g2*s**2 + 88*D1**2*bdd1*f*g2*s - 44*D1**2*bdd1*f*g2 + 2000*D1**2*f**3*fd*r*s - 500*D1**2*f**3*fd*r + 7800*D1**2*f**3*fd*s**2 - 4900*D1**2*f**3*fd*s + 1950*D1**2*f**3*fd - 2000*D1**2*f**3*fdd*r*s + 500*D1**2*f**3*fdd*r - 5400*D1**2*f**3*fdd*s**2 + 3700*D1**2*f**3*fdd*s - 1350*D1**2*f**3*fdd - 6000*D1**2*f**2*fd**2*r*s + 1500*D1**2*f**2*fd**2*r - 16200*D1**2*f**2*fd**2*s**2 + 11100*D1**2*f**2*fd**2*s - 1000*D1**2*f**2*fd**2 - 468*D1**2*f**2*fd*r*s + 156*D1**2*f**2*fd*r - 1998*D1**2*f**2*fd*s**2 + 1488*D1**2*f**2*fd*s - 666*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 1230*D1**2*f**2*fdd*s**2 - 920*D1**2*f**2*fdd*s + 410*D1**2*f**2*fdd - 638*D1**2*f**2*gd2*s**2 + 374*D1**2*f**2*gdd2*s**2 + 600*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 2460*D1**2*f*fd**2*s**2 - 1840*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 1276*D1**2*f*fd*g2*s**2 + 1276*D1**2*f*fd*g2*s - 638*D1**2*f*fd*g2 + 1496*D1**2*f*fd*gd2*s**2 - 748*D1**2*f*fd*gd2*s + 748*D1**2*f*fdd*g2*s**2 - 748*D1**2*f*fdd*g2*s + 374*D1**2*f*fdd*g2 + 748*D1**2*fd**2*g2*s**2 - 748*D1**2*fd**2*g2*s + 2000*D1*Dd*f**4*r*s - 500*D1*Dd*f**4*r + 7800*D1*Dd*f**4*s**2 - 4900*D1*Dd*f**4*s + 1950*D1*Dd*f**4 - 16000*D1*Dd*f**3*fd*r*s + 4000*D1*Dd*f**3*fd*r - 43200*D1*Dd*f**3*fd*s**2 + 29600*D1*Dd*f**3*fd*s - 4700*D1*Dd*f**3*fd - 624*D1*Dd*f**3*r*s + 156*D1*Dd*f**3*r - 2664*D1*Dd*f**3*s**2 + 1644*D1*Dd*f**3*s - 666*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r*s - 700*D1*Dd*f**2*fd*r + 9840*D1*Dd*f**2*fd*s**2 - 6740*D1*Dd*f**2*fd*s + 1120*D1*Dd*f**2*fd - 2552*D1*Dd*f**2*g2*s**2 + 1276*D1*Dd*f**2*g2*s - 638*D1*Dd*f**2*g2 + 2992*D1*Dd*f**2*gd2*s**2 - 748*D1*Dd*f**2*gd2*s + 5984*D1*Dd*f*fd*g2*s**2 - 4488*D1*Dd*f*fd*g2*s + 748*D1*Dd*f*fd*g2 - 2000*D1*Ddd*f**4*r*s + 500*D1*Ddd*f**4*r - 5400*D1*Ddd*f**4*s**2 + 3700*D1*Ddd*f**4*s - 1350*D1*Ddd*f**4 + 400*D1*Ddd*f**3*r*s - 100*D1*Ddd*f**3*r + 1640*D1*Ddd*f**3*s**2 - 1020*D1*Ddd*f**3*s + 410*D1*Ddd*f**3 + 1496*D1*Ddd*f**2*g2*s**2 - 748*D1*Ddd*f**2*g2*s + 374*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-4*f**3*(234*s**2 + s*(134*r - 367) + 150) + f**2*(-88*C*(s - 1)**2 + 200*fd*(2*r*(6*s - 1) + 18*s**2 - 18*s + 1) + 11*s**2*(29*K - 41) + 11*s*(4 - 20*r) + 88) + 22*f*(fd*(6*r*(4*s - 1) + s**2*(8*C - 34*K + 50) + s*(-8*C + 17*K - 33) + 6) + (4*s - 4)*(g2*(s - 1) - gd2*s)) - 88*fd*g2*s*(s - 1)) + 2*Dd*f*(200*f**2*(r*(8*s - 1) + 12*s**2 - 13*s + 2) + 11*f*(4*C*(4*s**2 - 5*s + 1) - 68*K*s**2 + 17*K*s + 48*r*s - 6*r + 100*s**2 - 45*s + 2) - 44*g2*(4*s**2 - 5*s + 1))) - 6000*Dd**2*f**4*r*s + 1500*Dd**2*f**4*r - 16200*Dd**2*f**4*s**2 + 11100*Dd**2*f**4*s - 1000*Dd**2*f**4 + 1200*Dd**2*f**3*r*s - 300*Dd**2*f**3*r + 4920*Dd**2*f**3*s**2 - 3060*Dd**2*f**3*s + 200*Dd**2*f**3 + 4488*Dd**2*f**2*g2*s**2 - 2244*Dd**2*f**2*g2*s - 22*b1**2*(K - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-176*C*D1**2*f*fd*s**2 + 88*C*D1**2*f*fdd*s**2 + 88*C*D1**2*fd**2*s**2 - 352*C*D1*Dd*f**2*s**2 + 176*C*D1*Dd*f**2*s - 88*C*D1*Dd*f**2 + 704*C*D1*Dd*f*fd*s**2 - 176*C*D1*Dd*f*fd*s + 176*C*D1*Ddd*f**2*s**2 - 88*C*D1*Ddd*f**2*s + 44*C*D1*Ddd*f**2 + 528*C*Dd**2*f**2*s**2 - 264*C*Dd**2*f**2*s + 638*D1**2*K*f*fd*s**2 - 638*D1**2*K*f*fd*s + 319*D1**2*K*f*fd - 374*D1**2*K*f*fdd*s**2 + 374*D1**2*K*f*fdd*s - 187*D1**2*K*f*fdd - 374*D1**2*K*fd**2*s**2 + 374*D1**2*K*fd**2*s + 22*D1**2*bdd1*f*(K - 1)*(2*s**2 - 2*s + 1) - 1608*D1**2*f**2*fd*r*s + 536*D1**2*f**2*fd*r - 2808*D1**2*f**2*fd*s**2 + 1476*D1**2*f**2*fd*s - 336*D1**2*f**2*fd + 1200*D1**2*f**2*fdd*r*s - 400*D1**2*f**2*fdd*r + 1800*D1**2*f**2*fdd*s**2 - 1200*D1**2*f**2*fdd*s + 300*D1**2*f**2*fdd + 2400*D1**2*f*fd**2*r*s - 800*D1**2*f*fd**2*r + 3600*D1**2*f*fd**2*s**2 - 2400*D1**2*f*fd**2*s + 600*D1**2*f*fd**2 - 440*D1**2*f*fd*r*s + 220*D1**2*f*fd*r - 902*D1**2*f*fd*s**2 + 1078*D1**2*f*fd*s - 539*D1**2*f*fd + 264*D1**2*f*fdd*r*s - 132*D1**2*f*fdd*r + 550*D1**2*f*fdd*s**2 - 638*D1**2*f*fdd*s + 319*D1**2*f*fdd + 88*D1**2*f*gd2*s**2 - 44*D1**2*f*gdd2*s**2 + 264*D1**2*fd**2*r*s - 132*D1**2*fd**2*r + 550*D1**2*fd**2*s**2 - 638*D1**2*fd**2*s + 88*D1**2*fd*g2*s**2 - 88*D1**2*fd*gd2*s**2 - 44*D1**2*fdd*g2*s**2 + 1276*D1*Dd*K*f**2*s**2 - 638*D1*Dd*K*f**2*s + 319*D1*Dd*K*f**2 - 2992*D1*Dd*K*f*fd*s**2 + 2244*D1*Dd*K*f*fd*s - 374*D1*Dd*K*f*fd - 2144*D1*Dd*f**3*r*s + 536*D1*Dd*f**3*r - 3744*D1*Dd*f**3*s**2 + 2944*D1*Dd*f**3*s - 936*D1*Dd*f**3 + 9600*D1*Dd*f**2*fd*r*s - 2800*D1*Dd*f**2*fd*r + 14400*D1*Dd*f**2*fd*s**2 - 10800*D1*Dd*f**2*fd*s + 2000*D1*Dd*f**2*fd - 880*D1*Dd*f**2*r*s + 220*D1*Dd*f**2*r - 1804*D1*Dd*f**2*s**2 + 1342*D1*Dd*f**2*s - 451*D1*Dd*f**2 + 2112*D1*Dd*f*fd*r*s - 792*D1*Dd*f*fd*r + 4400*D1*Dd*f*fd*s**2 - 4180*D1*Dd*f*fd*s + 902*D1*Dd*f*fd + 352*D1*Dd*f*g2*s**2 - 176*D1*Dd*f*g2*s + 88*D1*Dd*f*g2 - 352*D1*Dd*f*gd2*s**2 + 88*D1*Dd*f*gd2*s - 352*D1*Dd*fd*g2*s**2 + 88*D1*Dd*fd*g2*s - 748*D1*Ddd*K*f**2*s**2 + 374*D1*Ddd*K*f**2*s - 187*D1*Ddd*K*f**2 + 1600*D1*Ddd*f**3*r*s - 400*D1*Ddd*f**3*r + 2400*D1*Ddd*f**3*s**2 - 2000*D1*Ddd*f**3*s + 600*D1*Ddd*f**3 + 528*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 1100*D1*Ddd*f**2*s**2 - 814*D1*Ddd*f**2*s + 275*D1*Ddd*f**2 - 176*D1*Ddd*f*g2*s**2 + 88*D1*Ddd*f*g2*s - 44*D1*Ddd*f*g2 - 44*D1*bd1*(K - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 2244*Dd**2*K*f**2*s**2 + 1122*Dd**2*K*f**2*s + 4800*Dd**2*f**3*r*s - 1200*Dd**2*f**3*r + 7200*Dd**2*f**3*s**2 - 6000*Dd**2*f**3*s + 800*Dd**2*f**3 + 1584*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 3300*Dd**2*f**2*s**2 - 2442*Dd**2*f**2*s + 264*Dd**2*f**2 - 528*Dd**2*f*g2*s**2 + 264*Dd**2*f*g2*s))/(231*d**2*k2**2*k3**4) - 2*D1**2*Pk2*Pk3*ct**2*k1**4*(1716*C*D1**2*bdd1*f**2*s**2 - 3432*C*D1**2*bdd1*f**2*s + 1716*C*D1**2*bdd1*f**2 + 5838*C*D1**2*f**2*fd*s**2 - 3892*C*D1**2*f**2*fd*s + 1946*C*D1**2*f**2*fd - 5988*C*D1**2*f**2*fdd*s**2 + 3992*C*D1**2*f**2*fdd*s - 1996*C*D1**2*f**2*fdd - 11976*C*D1**2*f*fd**2*s**2 + 7984*C*D1**2*f*fd**2*s + 7784*C*D1*Dd*f**3*s**2 - 3892*C*D1*Dd*f**3*s + 1946*C*D1*Dd*f**3 - 47904*C*D1*Dd*f**2*fd*s**2 + 27944*C*D1*Dd*f**2*fd*s - 3992*C*D1*Dd*f**2*fd - 7984*C*D1*Ddd*f**3*s**2 + 3992*C*D1*Ddd*f**3*s - 1996*C*D1*Ddd*f**3 - 23952*C*Dd**2*f**3*s**2 + 11976*C*Dd**2*f**3*s - 1188*D1**2*K*bdd1*f**2*s**2 - 66*D1**2*bd1**2*f*(10*f*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 12*r*(2*s - 1) - (s - 1)*(31*K*s - 55*s + 12)) + 3630*D1**2*bdd1*f**3*r*s - 1650*D1**2*bdd1*f**3*r + 3630*D1**2*bdd1*f**3*s**2 - 5940*D1**2*bdd1*f**3*s + 2475*D1**2*bdd1*f**3 + 462*D1**2*bdd1*f**2*r*s + 660*D1**2*bdd1*f**2*r - 66*D1**2*bdd1*f**2*s**2 + 3630*D1**2*bdd1*f**2*s - 2376*D1**2*bdd1*f**2 - 2046*D1**2*bdd1*f*g2*s**2 + 4092*D1**2*bdd1*f*g2*s - 2046*D1**2*bdd1*f*g2 + 9900*D1**2*f**3*fd*r*s - 2475*D1**2*f**3*fd*r + 11880*D1**2*f**3*fd*s**2 - 10890*D1**2*f**3*fd*s + 2970*D1**2*f**3*fd - 9900*D1**2*f**3*fdd*r*s + 2475*D1**2*f**3*fdd*r - 11880*D1**2*f**3*fdd*s**2 + 10890*D1**2*f**3*fdd*s - 2970*D1**2*f**3*fdd - 29700*D1**2*f**2*fd**2*r*s + 7425*D1**2*f**2*fd**2*r - 35640*D1**2*f**2*fd**2*s**2 + 32670*D1**2*f**2*fd**2*s - 4950*D1**2*f**2*fd**2 - 2670*D1**2*f**2*fd*r*s + 890*D1**2*f**2*fd*r - 8508*D1**2*f**2*fd*s**2 + 6562*D1**2*f**2*fd*s - 2836*D1**2*f**2*fd + 2820*D1**2*f**2*fdd*r*s - 940*D1**2*f**2*fdd*r + 8808*D1**2*f**2*fdd*s**2 - 6812*D1**2*f**2*fdd*s + 2936*D1**2*f**2*fdd - 2310*D1**2*f**2*gd2*s**2 + 2376*D1**2*f**2*gdd2*s**2 + 5640*D1**2*f*fd**2*r*s - 1880*D1**2*f*fd**2*r + 17616*D1**2*f*fd**2*s**2 - 13624*D1**2*f*fd**2*s + 940*D1**2*f*fd**2 - 4620*D1**2*f*fd*g2*s**2 + 4620*D1**2*f*fd*g2*s - 2310*D1**2*f*fd*g2 + 9504*D1**2*f*fd*gd2*s**2 - 4752*D1**2*f*fd*gd2*s + 4752*D1**2*f*fdd*g2*s**2 - 4752*D1**2*f*fdd*g2*s + 2376*D1**2*f*fdd*g2 + 4752*D1**2*fd**2*g2*s**2 - 4752*D1**2*fd**2*g2*s + 9900*D1*Dd*f**4*r*s - 2475*D1*Dd*f**4*r + 11880*D1*Dd*f**4*s**2 - 10890*D1*Dd*f**4*s + 2970*D1*Dd*f**4 - 79200*D1*Dd*f**3*fd*r*s + 19800*D1*Dd*f**3*fd*r - 95040*D1*Dd*f**3*fd*s**2 + 87120*D1*Dd*f**3*fd*s - 15840*D1*Dd*f**3*fd - 3560*D1*Dd*f**3*r*s + 890*D1*Dd*f**3*r - 11344*D1*Dd*f**3*s**2 + 7452*D1*Dd*f**3*s - 2836*D1*Dd*f**3 + 22560*D1*Dd*f**2*fd*r*s - 6580*D1*Dd*f**2*fd*r + 70464*D1*Dd*f**2*fd*s**2 - 50504*D1*Dd*f**2*fd*s + 8692*D1*Dd*f**2*fd - 9240*D1*Dd*f**2*g2*s**2 + 4620*D1*Dd*f**2*g2*s - 2310*D1*Dd*f**2*g2 + 19008*D1*Dd*f**2*gd2*s**2 - 4752*D1*Dd*f**2*gd2*s + 38016*D1*Dd*f*fd*g2*s**2 - 28512*D1*Dd*f*fd*g2*s + 4752*D1*Dd*f*fd*g2 - 9900*D1*Ddd*f**4*r*s + 2475*D1*Ddd*f**4*r - 11880*D1*Ddd*f**4*s**2 + 10890*D1*Ddd*f**4*s - 2970*D1*Ddd*f**4 + 3760*D1*Ddd*f**3*r*s - 940*D1*Ddd*f**3*r + 11744*D1*Ddd*f**3*s**2 - 7752*D1*Ddd*f**3*s + 2936*D1*Ddd*f**3 + 9504*D1*Ddd*f**2*g2*s**2 - 4752*D1*Ddd*f**2*g2*s + 2376*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(2*r*(11*s - 5) + 26*s**2 - 48*s + 21) + f**2*(68*C*(s - 1)**2 - 35*K*s**2 - 10*fd*(66*r*s - 21*r + 66*s**2 - 80*s + 13) + 16*r*s + 16*r - 17*s**2 + 136*s - 84) - 2*f*(fd*(r*(28*s + 3) + s**2*(104*C - 72*K - 4) + s*(-104*C + 36*K + 50) + 7) + (s - 1)*(41*g2*(s - 1) - 62*gd2*s)) + 124*fd*g2*s*(s - 1)) - 2*Dd*f*(5*f**2*(88*r*s - 31*r + 88*s**2 - 116*s + 28) + f*(52*C*(4*s**2 - 5*s + 1) - 144*K*s**2 + 36*K*s + 56*r*s + 33*r - 8*s**2 + 208*s - 75) - 62*g2*(4*s**2 - 5*s + 1))) - 29700*Dd**2*f**4*r*s + 7425*Dd**2*f**4*r - 35640*Dd**2*f**4*s**2 + 32670*Dd**2*f**4*s - 4950*Dd**2*f**4 + 11280*Dd**2*f**3*r*s - 2820*Dd**2*f**3*r + 35232*Dd**2*f**3*s**2 - 23256*Dd**2*f**3*s + 1880*Dd**2*f**3 + 28512*Dd**2*f**2*g2*s**2 - 14256*Dd**2*f**2*g2*s + 33*b1**2*(D1**2*s*(4*f*(4*fd - 5*fdd)*(4*r + 4*s - 3) - 20*fd**2*(4*r + 4*s - 3) + fd*(-41*K*s + 20*r + 61*s) + fdd*(31*K*s - 24*r - 55*s)) + D1*(Dd*(32*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-41*K*(4*s**2 - 2*s + 1) - 20*fd*(8*s - 1)*(4*r + 4*s - 3) + 80*r*s - 20*r + 244*s**2 - 162*s + 61) + 2*fd*(r*(12 - 96*s) + s*(31*K*(4*s - 1) - 220*s + 79))) + Ddd*f*(31*K*(4*s**2 - 2*s + 1) - 40*f*(r*(4*s - 1) + (1 - 2*s)**2) - 96*r*s + 24*r - 220*s**2 + 158*s - 55)) - 2*Dd**2*f*(20*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 36*r*(4*s - 1) + 3*s**2*(110 - 62*K) + 3*s*(31*K - 79) + 24)) + 33*b1*(-136*C*D1**2*f*fd*s**2 + 104*C*D1**2*f*fdd*s**2 + 104*C*D1**2*fd**2*s**2 - 272*C*D1*Dd*f**2*s**2 + 136*C*D1*Dd*f**2*s - 68*C*D1*Dd*f**2 + 832*C*D1*Dd*f*fd*s**2 - 208*C*D1*Dd*f*fd*s + 208*C*D1*Ddd*f**2*s**2 - 104*C*D1*Ddd*f**2*s + 52*C*D1*Ddd*f**2 + 624*C*Dd**2*f**2*s**2 - 312*C*Dd**2*f**2*s + 70*D1**2*K*f*fd*s**2 - 70*D1**2*K*f*fd*s + 35*D1**2*K*f*fd - 72*D1**2*K*f*fdd*s**2 + 72*D1**2*K*f*fdd*s - 36*D1**2*K*f*fdd - 72*D1**2*K*fd**2*s**2 + 72*D1**2*K*fd**2*s + D1**2*bdd1*f*(31*K*(2*s**2 - 2*s + 1) - 20*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 48*r*s + 24*r - 110*s**2 + 134*s - 55) - 330*D1**2*f**2*fd*r*s + 60*D1**2*f**2*fd*r - 390*D1**2*f**2*fd*s**2 + 240*D1**2*f**2*fd*s - 25*D1**2*f**2*fd + 330*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 330*D1**2*f**2*fdd*s**2 - 260*D1**2*f**2*fdd*s + 35*D1**2*f**2*fdd + 660*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 660*D1**2*f*fd**2*s**2 - 520*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 32*D1**2*f*fd*r*s + 32*D1**2*f*fd*r + 34*D1**2*f*fd*s**2 + 118*D1**2*f*fd*s - 67*D1**2*f*fd + 28*D1**2*f*fdd*r*s - 34*D1**2*f*fdd*r - 4*D1**2*f*fdd*s**2 - 120*D1**2*f*fdd*s + 70*D1**2*f*fdd + 82*D1**2*f*gd2*s**2 - 62*D1**2*f*gdd2*s**2 + 28*D1**2*fd**2*r*s - 34*D1**2*fd**2*r - 4*D1**2*fd**2*s**2 - 120*D1**2*fd**2*s + 82*D1**2*fd*g2*s**2 - 124*D1**2*fd*gd2*s**2 - 62*D1**2*fdd*g2*s**2 + 140*D1*Dd*K*f**2*s**2 - 70*D1*Dd*K*f**2*s + 35*D1*Dd*K*f**2 - 576*D1*Dd*K*f*fd*s**2 + 432*D1*Dd*K*f*fd*s - 72*D1*Dd*K*f*fd - 440*D1*Dd*f**3*r*s + 110*D1*Dd*f**3*r - 520*D1*Dd*f**3*s**2 + 480*D1*Dd*f**3*s - 130*D1*Dd*f**3 + 2640*D1*Dd*f**2*fd*r*s - 570*D1*Dd*f**2*fd*r + 2640*D1*Dd*f**2*fd*s**2 - 2360*D1*Dd*f**2*fd*s + 380*D1*Dd*f**2*fd - 64*D1*Dd*f**2*r*s + 16*D1*Dd*f**2*r + 68*D1*Dd*f**2*s**2 - 2*D1*Dd*f**2*s + 17*D1*Dd*f**2 + 224*D1*Dd*f*fd*r*s - 164*D1*Dd*f*fd*r - 32*D1*Dd*f*fd*s**2 - 528*D1*Dd*f*fd*s + 188*D1*Dd*f*fd + 328*D1*Dd*f*g2*s**2 - 164*D1*Dd*f*g2*s + 82*D1*Dd*f*g2 - 496*D1*Dd*f*gd2*s**2 + 124*D1*Dd*f*gd2*s - 496*D1*Dd*fd*g2*s**2 + 124*D1*Dd*fd*g2*s - 144*D1*Ddd*K*f**2*s**2 + 72*D1*Ddd*K*f**2*s - 36*D1*Ddd*K*f**2 + 440*D1*Ddd*f**3*r*s - 110*D1*Ddd*f**3*r + 440*D1*Ddd*f**3*s**2 - 440*D1*Ddd*f**3*s + 110*D1*Ddd*f**3 + 56*D1*Ddd*f**2*r*s - 14*D1*Ddd*f**2*r - 8*D1*Ddd*f**2*s**2 - 24*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 - 248*D1*Ddd*f*g2*s**2 + 124*D1*Ddd*f*g2*s - 62*D1*Ddd*f*g2 + D1*bd1*(D1*(16*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(-41*K*(2*s**2 - 2*s + 1) - 20*fd*(4*s - 1)*(4*r + 4*s - 3) + 40*r*s - 20*r + 122*s**2 - 142*s + 61) + 2*fd*(r*(12 - 48*s) + s*(31*K*(2*s - 1) - 110*s + 67))) - 2*Dd*f*(-31*K*(8*s**2 - 6*s + 1) + 10*f*(8*s - 3)*(4*r + 4*s - 3) + 192*r*s - 72*r + 440*s**2 - 426*s + 91)) - 432*Dd**2*K*f**2*s**2 + 216*Dd**2*K*f**2*s + 1320*Dd**2*f**3*r*s - 330*Dd**2*f**3*r + 1320*Dd**2*f**3*s**2 - 1320*Dd**2*f**3*s + 220*Dd**2*f**3 + 168*Dd**2*f**2*r*s - 42*Dd**2*f**2*r - 24*Dd**2*f**2*s**2 - 72*Dd**2*f**2*s + 28*Dd**2*f**2 - 744*Dd**2*f*g2*s**2 + 372*Dd**2*f*g2*s))/(693*d**2*k2**2*k3**4) + 20*D1**2*Pk2*Pk3*ct**2*k1**2*k2**4*st**6*(156*C*D1**2*f**2*fd*r**2 + 312*C*D1**2*f**2*fd*r*s - 208*C*D1**2*f**2*fd*r + 156*C*D1**2*f**2*fd*s**2 - 208*C*D1**2*f**2*fd*s + 104*C*D1**2*f**2*fd - 78*C*D1**2*f**2*fdd*r**2 - 156*C*D1**2*f**2*fdd*r*s + 104*C*D1**2*f**2*fdd*r - 78*C*D1**2*f**2*fdd*s**2 + 104*C*D1**2*f**2*fdd*s - 52*C*D1**2*f**2*fdd - 156*C*D1**2*f*fd**2*r**2 - 312*C*D1**2*f*fd**2*r*s + 208*C*D1**2*f*fd**2*r - 156*C*D1**2*f*fd**2*s**2 + 208*C*D1**2*f*fd**2*s - 52*C*D1**2*f*fd**2 + 208*C*D1*Dd*f**3*r**2 + 416*C*D1*Dd*f**3*r*s - 312*C*D1*Dd*f**3*r + 208*C*D1*Dd*f**3*s**2 - 312*C*D1*Dd*f**3*s + 156*C*D1*Dd*f**3 - 624*C*D1*Dd*f**2*fd*r**2 - 1248*C*D1*Dd*f**2*fd*r*s + 884*C*D1*Dd*f**2*fd*r - 624*C*D1*Dd*f**2*fd*s**2 + 884*C*D1*Dd*f**2*fd*s - 312*C*D1*Dd*f**2*fd - 104*C*D1*Ddd*f**3*r**2 - 208*C*D1*Ddd*f**3*r*s + 156*C*D1*Ddd*f**3*r - 104*C*D1*Ddd*f**3*s**2 + 156*C*D1*Ddd*f**3*s - 78*C*D1*Ddd*f**3 - 312*C*Dd**2*f**3*r**2 - 624*C*Dd**2*f**3*r*s + 468*C*Dd**2*f**3*r - 312*C*Dd**2*f**3*s**2 + 468*C*Dd**2*f**3*s - 156*C*Dd**2*f**3 + 1716*D1**2*K*b1*f*fd*r**2 + 3432*D1**2*K*b1*f*fd*r*s - 1716*D1**2*K*b1*f*fd*r + 1716*D1**2*K*b1*f*fd*s**2 - 1716*D1**2*K*b1*f*fd*s + 858*D1**2*K*b1*f*fd - 858*D1**2*K*b1*f*fdd*r**2 - 1716*D1**2*K*b1*f*fdd*r*s + 858*D1**2*K*b1*f*fdd*r - 858*D1**2*K*b1*f*fdd*s**2 + 858*D1**2*K*b1*f*fdd*s - 429*D1**2*K*b1*f*fdd - 858*D1**2*K*b1*fd**2*r**2 - 1716*D1**2*K*b1*fd**2*r*s + 858*D1**2*K*b1*fd**2*r - 858*D1**2*K*b1*fd**2*s**2 + 858*D1**2*K*b1*fd**2*s - 1716*D1**2*b1*f*fd*r**2 - 3432*D1**2*b1*f*fd*r*s + 1716*D1**2*b1*f*fd*r - 1716*D1**2*b1*f*fd*s**2 + 1716*D1**2*b1*f*fd*s - 858*D1**2*b1*f*fd + 858*D1**2*b1*f*fdd*r**2 + 1716*D1**2*b1*f*fdd*r*s - 858*D1**2*b1*f*fdd*r + 858*D1**2*b1*f*fdd*s**2 - 858*D1**2*b1*f*fdd*s + 429*D1**2*b1*f*fdd + 858*D1**2*b1*fd**2*r**2 + 1716*D1**2*b1*fd**2*r*s - 858*D1**2*b1*fd**2*r + 858*D1**2*b1*fd**2*s**2 - 858*D1**2*b1*fd**2*s - 429*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 - 672*D1**2*f**3*fd*r**2 - 1344*D1**2*f**3*fd*r*s + 1008*D1**2*f**3*fd*r - 672*D1**2*f**3*fd*s**2 + 1008*D1**2*f**3*fd*s - 504*D1**2*f**3*fd + 336*D1**2*f**3*fdd*r**2 + 672*D1**2*f**3*fdd*r*s - 504*D1**2*f**3*fdd*r + 336*D1**2*f**3*fdd*s**2 - 504*D1**2*f**3*fdd*s + 252*D1**2*f**3*fdd + 1008*D1**2*f**2*fd**2*r**2 + 2016*D1**2*f**2*fd**2*r*s - 1512*D1**2*f**2*fd**2*r + 1008*D1**2*f**2*fd**2*s**2 - 1512*D1**2*f**2*fd**2*s + 504*D1**2*f**2*fd**2 - 156*D1**2*f**2*fd*r**2 - 312*D1**2*f**2*fd*r*s + 208*D1**2*f**2*fd*r - 156*D1**2*f**2*fd*s**2 + 208*D1**2*f**2*fd*s - 104*D1**2*f**2*fd + 78*D1**2*f**2*fdd*r**2 + 156*D1**2*f**2*fdd*r*s - 104*D1**2*f**2*fdd*r + 78*D1**2*f**2*fdd*s**2 - 104*D1**2*f**2*fdd*s + 52*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 858*D1**2*f**2*gdd2*r**2 + 1716*D1**2*f**2*gdd2*r*s - 1716*D1**2*f**2*gdd2*r + 858*D1**2*f**2*gdd2*s**2 - 1716*D1**2*f**2*gdd2*s + 858*D1**2*f**2*gdd2 + 156*D1**2*f*fd**2*r**2 + 312*D1**2*f*fd**2*r*s - 208*D1**2*f*fd**2*r + 156*D1**2*f*fd**2*s**2 - 208*D1**2*f*fd**2*s + 52*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r**2 + 6864*D1**2*f*fd*gd2*r*s - 5148*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1716*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r**2 + 3432*D1**2*f*fdd*g2*r*s - 1716*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r**2 + 3432*D1**2*fd**2*g2*r*s - 1716*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 3432*D1*Dd*K*b1*f**2*r**2 + 6864*D1*Dd*K*b1*f**2*r*s - 5148*D1*Dd*K*b1*f**2*r + 3432*D1*Dd*K*b1*f**2*s**2 - 5148*D1*Dd*K*b1*f**2*s + 2574*D1*Dd*K*b1*f**2 - 6864*D1*Dd*K*b1*f*fd*r**2 - 13728*D1*Dd*K*b1*f*fd*r*s + 8580*D1*Dd*K*b1*f*fd*r - 6864*D1*Dd*K*b1*f*fd*s**2 + 8580*D1*Dd*K*b1*f*fd*s - 2574*D1*Dd*K*b1*f*fd - 3432*D1*Dd*b1*f**2*r**2 - 6864*D1*Dd*b1*f**2*r*s + 5148*D1*Dd*b1*f**2*r - 3432*D1*Dd*b1*f**2*s**2 + 5148*D1*Dd*b1*f**2*s - 2574*D1*Dd*b1*f**2 + 6864*D1*Dd*b1*f*fd*r**2 + 13728*D1*Dd*b1*f*fd*r*s - 8580*D1*Dd*b1*f*fd*r + 6864*D1*Dd*b1*f*fd*s**2 - 8580*D1*Dd*b1*f*fd*s + 2574*D1*Dd*b1*f*fd - 672*D1*Dd*f**4*r**2 - 1344*D1*Dd*f**4*r*s + 1008*D1*Dd*f**4*r - 672*D1*Dd*f**4*s**2 + 1008*D1*Dd*f**4*s - 504*D1*Dd*f**4 + 2688*D1*Dd*f**3*fd*r**2 + 5376*D1*Dd*f**3*fd*r*s - 4032*D1*Dd*f**3*fd*r + 2688*D1*Dd*f**3*fd*s**2 - 4032*D1*Dd*f**3*fd*s + 1512*D1*Dd*f**3*fd - 208*D1*Dd*f**3*r**2 - 416*D1*Dd*f**3*r*s + 312*D1*Dd*f**3*r - 208*D1*Dd*f**3*s**2 + 312*D1*Dd*f**3*s - 156*D1*Dd*f**3 + 624*D1*Dd*f**2*fd*r**2 + 1248*D1*Dd*f**2*fd*r*s - 884*D1*Dd*f**2*fd*r + 624*D1*Dd*f**2*fd*s**2 - 884*D1*Dd*f**2*fd*s + 312*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r**2 + 13728*D1*Dd*f**2*gd2*r*s - 12012*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 12012*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r**2 + 27456*D1*Dd*f*fd*g2*r*s - 17160*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 17160*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 - 1716*D1*Ddd*K*b1*f**2*r**2 - 3432*D1*Ddd*K*b1*f**2*r*s + 2574*D1*Ddd*K*b1*f**2*r - 1716*D1*Ddd*K*b1*f**2*s**2 + 2574*D1*Ddd*K*b1*f**2*s - 1287*D1*Ddd*K*b1*f**2 + 1716*D1*Ddd*b1*f**2*r**2 + 3432*D1*Ddd*b1*f**2*r*s - 2574*D1*Ddd*b1*f**2*r + 1716*D1*Ddd*b1*f**2*s**2 - 2574*D1*Ddd*b1*f**2*s + 1287*D1*Ddd*b1*f**2 + 336*D1*Ddd*f**4*r**2 + 672*D1*Ddd*f**4*r*s - 504*D1*Ddd*f**4*r + 336*D1*Ddd*f**4*s**2 - 504*D1*Ddd*f**4*s + 252*D1*Ddd*f**4 + 104*D1*Ddd*f**3*r**2 + 208*D1*Ddd*f**3*r*s - 156*D1*Ddd*f**3*r + 104*D1*Ddd*f**3*s**2 - 156*D1*Ddd*f**3*s + 78*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r**2 + 6864*D1*Ddd*f**2*g2*r*s - 5148*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 5148*Dd**2*K*b1*f**2*r**2 - 10296*Dd**2*K*b1*f**2*r*s + 7722*Dd**2*K*b1*f**2*r - 5148*Dd**2*K*b1*f**2*s**2 + 7722*Dd**2*K*b1*f**2*s - 2574*Dd**2*K*b1*f**2 + 5148*Dd**2*b1*f**2*r**2 + 10296*Dd**2*b1*f**2*r*s - 7722*Dd**2*b1*f**2*r + 5148*Dd**2*b1*f**2*s**2 - 7722*Dd**2*b1*f**2*s + 2574*Dd**2*b1*f**2 + 1008*Dd**2*f**4*r**2 + 2016*Dd**2*f**4*r*s - 1512*Dd**2*f**4*r + 1008*Dd**2*f**4*s**2 - 1512*Dd**2*f**4*s + 504*Dd**2*f**4 + 312*Dd**2*f**3*r**2 + 624*Dd**2*f**3*r*s - 468*Dd**2*f**3*r + 312*Dd**2*f**3*s**2 - 468*Dd**2*f**3*s + 156*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r**2 + 20592*Dd**2*f**2*g2*r*s - 15444*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2)/(3003*d**2*k3**8) + 8*D1**2*Pk2*Pk3*ct**2*k1**2*k2**4*st**4*(-66*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 3*D1*bd1*(D1*(40*f**3*(r + s - 1) + f**2*(-40*fd*(3*r + 3*s - 2) + (33 - 55*K)*(r + s - 1)) - 44*f*(g2 - gd2)*(r + s - 1) + 44*fd*g2*(r + s)) - 4*Dd*f*(10*f**2 - 11*g2)*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-110*D1**2*K*f*fd*r**2 - 220*D1**2*K*f*fd*r*s + 110*D1**2*K*f*fd*r - 110*D1**2*K*f*fd*s**2 + 110*D1**2*K*f*fd*s - 55*D1**2*K*f*fd - 22*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 120*D1**2*f**2*fd*r**2 + 240*D1**2*f**2*fd*r*s - 160*D1**2*f**2*fd*r + 120*D1**2*f**2*fd*s**2 - 160*D1**2*f**2*fd*s + 80*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 66*D1**2*f*fd*r**2 + 132*D1**2*f*fd*r*s - 66*D1**2*f*fd*r + 66*D1**2*f*fd*s**2 - 66*D1**2*f*fd*s + 33*D1**2*f*fd - 44*D1**2*f*gd2*r**2 - 88*D1**2*f*gd2*r*s + 88*D1**2*f*gd2*r - 44*D1**2*f*gd2*s**2 + 88*D1**2*f*gd2*s - 44*D1**2*f*gd2 + 22*D1**2*f*gdd2*r**2 + 44*D1**2*f*gdd2*r*s - 44*D1**2*f*gdd2*r + 22*D1**2*f*gdd2*s**2 - 44*D1**2*f*gdd2*s + 22*D1**2*f*gdd2 - 44*D1**2*fd*g2*r**2 - 88*D1**2*fd*g2*r*s - 44*D1**2*fd*g2*s**2 + 44*D1**2*fd*gd2*r**2 + 88*D1**2*fd*gd2*r*s - 44*D1**2*fd*gd2*r + 44*D1**2*fd*gd2*s**2 - 44*D1**2*fd*gd2*s + 22*D1**2*fdd*g2*r**2 + 44*D1**2*fdd*g2*r*s + 22*D1**2*fdd*g2*s**2 - 220*D1*Dd*K*f**2*r**2 - 440*D1*Dd*K*f**2*r*s + 330*D1*Dd*K*f**2*r - 220*D1*Dd*K*f**2*s**2 + 330*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 160*D1*Dd*f**3*r**2 + 320*D1*Dd*f**3*r*s - 240*D1*Dd*f**3*r + 160*D1*Dd*f**3*s**2 - 240*D1*Dd*f**3*s + 120*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 680*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 680*D1*Dd*f**2*fd*s - 240*D1*Dd*f**2*fd + 132*D1*Dd*f**2*r**2 + 264*D1*Dd*f**2*r*s - 198*D1*Dd*f**2*r + 132*D1*Dd*f**2*s**2 - 198*D1*Dd*f**2*s + 99*D1*Dd*f**2 - 176*D1*Dd*f*g2*r**2 - 352*D1*Dd*f*g2*r*s + 264*D1*Dd*f*g2*r - 176*D1*Dd*f*g2*s**2 + 264*D1*Dd*f*g2*s - 132*D1*Dd*f*g2 + 176*D1*Dd*f*gd2*r**2 + 352*D1*Dd*f*gd2*r*s - 308*D1*Dd*f*gd2*r + 176*D1*Dd*f*gd2*s**2 - 308*D1*Dd*f*gd2*s + 132*D1*Dd*f*gd2 + 176*D1*Dd*fd*g2*r**2 + 352*D1*Dd*fd*g2*r*s - 132*D1*Dd*fd*g2*r + 176*D1*Dd*fd*g2*s**2 - 132*D1*Dd*fd*g2*s - 80*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 120*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 + 88*D1*Ddd*f*g2*r**2 + 176*D1*Ddd*f*g2*r*s - 132*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2*s**2 - 132*D1*Ddd*f*g2*s + 66*D1*Ddd*f*g2 + 44*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 240*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 360*Dd**2*f**3*s - 120*Dd**2*f**3 + 264*Dd**2*f*g2*r**2 + 528*Dd**2*f*g2*r*s - 396*Dd**2*f*g2*r + 264*Dd**2*f*g2*s**2 - 396*Dd**2*f*g2*s + 132*Dd**2*f*g2) + f*(-6*D1**2*bdd1*(10*f**2 - 11*g2)*(r + s - 1)**2 + 5*D1**2*(3*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*fd*(32*C - 24)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*fdd*(16*C - 12)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 66*f*gd2*(r + s - 1)**2 + 2*fd*(fd*(16*C - 12)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 33*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1))) + 5*D1*f*(Dd*(3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(24 - 32*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(32*C - 24)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Ddd*f*(16*C - 12)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 5*Dd**2*f**2*(96*C - 72)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**8) + 4*D1**2*Pk2*Pk3*ct**2*k1**2*k2**4*st**2*(-132*D1**2*bd1**2*f*(-4*K + 5*f + 2)*(r + s - 1)**2 + 132*D1**2*bdd1*f*(f*(4*C + 3*K - 3) - 4*g2)*(r + s - 1)**2 - 12*D1**2*(f**2*(fd*(45*C - 17)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(50*C - 25)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (-77*gd2 + 66*gdd2)*(r + s - 1)**2) + f*(-fd**2*(100*C - 50)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 77*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 132*fd*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 66*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 132*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 22*D1*bd1*(D1*(6*f**3*(r + s - 1) + f**2*(43*C + 21*K - 29)*(r + s - 1) - 12*f*fd*(4*C + 3*K - 3)*(2*r + 2*s - 1) - f*(83*g2 - 48*gd2)*(r + s - 1) + 48*fd*g2*(r + s)) - 12*Dd*f*(f*(4*C + 3*K - 3) - 4*g2)*(4*r + 4*s - 3))*(r + s - 1) - 12*D1*f*(Dd*(f**2*(45*C - 17)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-fd*(100*C - 50)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 77*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 132*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 132*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(f*(50*C - 25) - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 72*Dd**2*f**2*(f*(50*C - 25) - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 11*b1**2*(D1**2*(6*f*(9*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(60*fd**2*(r + s - 1) + fd*(83*K - 45)*(r + s) - 12*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(54*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (83*K - 45)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 24*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-4*K + 5*f + 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-4*K + 5*f + 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*(-86*C*D1**2*f*fd*r**2 - 172*C*D1**2*f*fd*r*s + 86*C*D1**2*f*fd*r - 86*C*D1**2*f*fd*s**2 + 86*C*D1**2*f*fd*s - 43*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r**2 + 96*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 48*C*D1**2*f*fdd*s**2 - 48*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r**2 + 96*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 48*C*D1**2*fd**2*s**2 - 48*C*D1**2*fd**2*s - 172*C*D1*Dd*f**2*r**2 - 344*C*D1*Dd*f**2*r*s + 258*C*D1*Dd*f**2*r - 172*C*D1*Dd*f**2*s**2 + 258*C*D1*Dd*f**2*s - 129*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r**2 + 768*C*D1*Dd*f*fd*r*s - 480*C*D1*Dd*f*fd*r + 384*C*D1*Dd*f*fd*s**2 - 480*C*D1*Dd*f*fd*s + 144*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 + 192*C*D1*Ddd*f**2*r*s - 144*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r**2 + 576*C*Dd**2*f**2*r*s - 432*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 144*C*Dd**2*f**2 - 42*D1**2*K*f*fd*r**2 - 84*D1**2*K*f*fd*r*s + 42*D1**2*K*f*fd*r - 42*D1**2*K*f*fd*s**2 + 42*D1**2*K*f*fd*s - 21*D1**2*K*f*fd + 36*D1**2*K*f*fdd*r**2 + 72*D1**2*K*f*fdd*r*s - 36*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r**2 + 72*D1**2*K*fd**2*r*s - 36*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-4*K + 5*f + 2)*(r + s - 1)**2 - 18*D1**2*f**2*fd*r**2 - 36*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 24*D1**2*f**2*fd*s - 12*D1**2*f**2*fd + 58*D1**2*f*fd*r**2 + 116*D1**2*f*fd*r*s - 58*D1**2*f*fd*r + 58*D1**2*f*fd*s**2 - 58*D1**2*f*fd*s + 29*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd + 83*D1**2*f*gd2*r**2 + 166*D1**2*f*gd2*r*s - 166*D1**2*f*gd2*r + 83*D1**2*f*gd2*s**2 - 166*D1**2*f*gd2*s + 83*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 83*D1**2*fd*g2*r**2 + 166*D1**2*fd*g2*r*s + 83*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 - 84*D1*Dd*K*f**2*r**2 - 168*D1*Dd*K*f**2*r*s + 126*D1*Dd*K*f**2*r - 84*D1*Dd*K*f**2*s**2 + 126*D1*Dd*K*f**2*s - 63*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r**2 + 576*D1*Dd*K*f*fd*r*s - 360*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 360*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd - 24*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 36*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 116*D1*Dd*f**2*r**2 + 232*D1*Dd*f**2*r*s - 174*D1*Dd*f**2*r + 116*D1*Dd*f**2*s**2 - 174*D1*Dd*f**2*s + 87*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 332*D1*Dd*f*g2*r**2 + 664*D1*Dd*f*g2*r*s - 498*D1*Dd*f*g2*r + 332*D1*Dd*f*g2*s**2 - 498*D1*Dd*f*g2*s + 249*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 144*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s + 72*D1*Ddd*K*f**2*r**2 + 144*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 108*D1*Ddd*K*f**2*s + 54*D1*Ddd*K*f**2 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + D1*bd1*(D1*(54*f**2*(r + s - 1) - 60*f*fd*(2*r + 2*s - 1) - f*(83*K - 45)*(r + s - 1) + 24*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-4*K + 5*f + 2)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*f**2*r**2 + 432*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 324*Dd**2*K*f**2*s + 108*Dd**2*K*f**2 - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(77*d**2*k3**8) - 8*D1**2*Pk2*Pk3*ct**2*k1**2*k2**4*(D1*(-72*D1*K*bd1**2*f*(r + s - 1)**2 + 6*bd1*(D1*(f**2*(2*C - K + 1)*(r + s - 1) - f*fd*(20*C - 10)*(2*r + 2*s - 1) - 3*f*(g2 - 8*gd2)*(r + s - 1) + 24*fd*g2*(r + s)) - 2*Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1) + f*(-6*D1*bdd1*(f*(10*C - 5) - 12*g2)*(r + s - 1)**2 + D1*(f*(-fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 12*gd2*(r + s - 1)**2) + 12*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**2*(D1**2*(18*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-36*K*fdd + fd*(9*K + 14))) + D1*(Dd*(-72*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 216*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(3*D1**2*(f*(fd*(2*C - K + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s - 1)**2*(-12*K*bdd1 - 3*gd2 + 12*gdd2)) - (r + s)*(fd**2*(20*C - 10)*(r + s - 1) + 3*fd*(g2*(r + s) - 8*gd2*(r + s - 1)) - 12*fdd*g2*(r + s))) + D1*bd1*(D1*(-72*K*fd*(r + s) + 18*f**2*(r + s - 1) + f*(9*K + 14)*(r + s - 1)) - 72*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + 3*D1*(Dd*(f**2*(2*C - K + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 3*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 24*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 24*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(f*(10*C - 5) - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**8) + 80*D1**2*Pk2*Pk3*ct**2*k1**2*k2**2*st**6*(156*C*D1**2*f**2*fd*r*s - 52*C*D1**2*f**2*fd*r + 156*C*D1**2*f**2*fd*s**2 - 156*C*D1**2*f**2*fd*s + 52*C*D1**2*f**2*fd - 78*C*D1**2*f**2*fdd*r*s + 26*C*D1**2*f**2*fdd*r - 78*C*D1**2*f**2*fdd*s**2 + 78*C*D1**2*f**2*fdd*s - 26*C*D1**2*f**2*fdd - 156*C*D1**2*f*fd**2*r*s + 52*C*D1**2*f*fd**2*r - 156*C*D1**2*f*fd**2*s**2 + 156*C*D1**2*f*fd**2*s - 26*C*D1**2*f*fd**2 + 208*C*D1*Dd*f**3*r*s - 52*C*D1*Dd*f**3*r + 208*C*D1*Dd*f**3*s**2 - 208*C*D1*Dd*f**3*s + 52*C*D1*Dd*f**3 - 624*C*D1*Dd*f**2*fd*r*s + 182*C*D1*Dd*f**2*fd*r - 624*C*D1*Dd*f**2*fd*s**2 + 624*C*D1*Dd*f**2*fd*s - 130*C*D1*Dd*f**2*fd - 104*C*D1*Ddd*f**3*r*s + 26*C*D1*Ddd*f**3*r - 104*C*D1*Ddd*f**3*s**2 + 104*C*D1*Ddd*f**3*s - 26*C*D1*Ddd*f**3 - 312*C*Dd**2*f**3*r*s + 78*C*Dd**2*f**3*r - 312*C*Dd**2*f**3*s**2 + 312*C*Dd**2*f**3*s - 52*C*Dd**2*f**3 - 429*D1**2*K*bdd1*f**2*r*s - 429*D1**2*K*bdd1*f**2*s**2 + 429*D1**2*K*bdd1*f**2*s + 429*D1**2*bdd1*f**2*r*s + 429*D1**2*bdd1*f**2*s**2 - 429*D1**2*bdd1*f**2*s - 672*D1**2*f**3*fd*r*s + 168*D1**2*f**3*fd*r - 672*D1**2*f**3*fd*s**2 + 672*D1**2*f**3*fd*s - 168*D1**2*f**3*fd + 336*D1**2*f**3*fdd*r*s - 84*D1**2*f**3*fdd*r + 336*D1**2*f**3*fdd*s**2 - 336*D1**2*f**3*fdd*s + 84*D1**2*f**3*fdd + 1008*D1**2*f**2*fd**2*r*s - 252*D1**2*f**2*fd**2*r + 1008*D1**2*f**2*fd**2*s**2 - 1008*D1**2*f**2*fd**2*s + 168*D1**2*f**2*fd**2 - 156*D1**2*f**2*fd*r*s + 52*D1**2*f**2*fd*r - 156*D1**2*f**2*fd*s**2 + 156*D1**2*f**2*fd*s - 52*D1**2*f**2*fd + 78*D1**2*f**2*fdd*r*s - 26*D1**2*f**2*fdd*r + 78*D1**2*f**2*fdd*s**2 - 78*D1**2*f**2*fdd*s + 26*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r*s - 1716*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s + 858*D1**2*f**2*gdd2*r*s + 858*D1**2*f**2*gdd2*s**2 - 858*D1**2*f**2*gdd2*s + 156*D1**2*f*fd**2*r*s - 52*D1**2*f*fd**2*r + 156*D1**2*f*fd**2*s**2 - 156*D1**2*f*fd**2*s + 26*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r*s - 858*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 3432*D1**2*f*fd*gd2*s + 858*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r*s - 858*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r*s - 858*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s - 672*D1*Dd*f**4*r*s + 168*D1*Dd*f**4*r - 672*D1*Dd*f**4*s**2 + 672*D1*Dd*f**4*s - 168*D1*Dd*f**4 + 2688*D1*Dd*f**3*fd*r*s - 672*D1*Dd*f**3*fd*r + 2688*D1*Dd*f**3*fd*s**2 - 2688*D1*Dd*f**3*fd*s + 504*D1*Dd*f**3*fd - 208*D1*Dd*f**3*r*s + 52*D1*Dd*f**3*r - 208*D1*Dd*f**3*s**2 + 208*D1*Dd*f**3*s - 52*D1*Dd*f**3 + 624*D1*Dd*f**2*fd*r*s - 182*D1*Dd*f**2*fd*r + 624*D1*Dd*f**2*fd*s**2 - 624*D1*Dd*f**2*fd*s + 130*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r*s + 1716*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 6864*D1*Dd*f**2*g2*s - 1716*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r*s - 858*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 6864*D1*Dd*f**2*gd2*s + 858*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r*s - 5148*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 13728*D1*Dd*f*fd*g2*s + 3432*D1*Dd*f*fd*g2 + 336*D1*Ddd*f**4*r*s - 84*D1*Ddd*f**4*r + 336*D1*Ddd*f**4*s**2 - 336*D1*Ddd*f**4*s + 84*D1*Ddd*f**4 + 104*D1*Ddd*f**3*r*s - 26*D1*Ddd*f**3*r + 104*D1*Ddd*f**3*s**2 - 104*D1*Ddd*f**3*s + 26*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r*s - 858*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 3432*D1*Ddd*f**2*g2*s + 858*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 1008*Dd**2*f**4*r*s - 252*Dd**2*f**4*r + 1008*Dd**2*f**4*s**2 - 1008*Dd**2*f**4*s + 168*Dd**2*f**4 + 312*Dd**2*f**3*r*s - 78*Dd**2*f**3*r + 312*Dd**2*f**3*s**2 - 312*Dd**2*f**3*s + 52*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r*s - 2574*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 10296*Dd**2*f**2*g2*s + 1716*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**6) + 4*D1**2*Pk2*Pk3*ct**2*k1**2*k2**2*st**4*(576*C*D1**2*f**2*fd*r**2 - 624*C*D1**2*f**2*fd*r*s - 176*C*D1**2*f**2*fd*r - 1200*C*D1**2*f**2*fd*s**2 + 1008*C*D1**2*f**2*fd*s - 208*C*D1**2*f**2*fd - 288*C*D1**2*f**2*fdd*r**2 + 312*C*D1**2*f**2*fdd*r*s + 88*C*D1**2*f**2*fdd*r + 600*C*D1**2*f**2*fdd*s**2 - 504*C*D1**2*f**2*fdd*s + 104*C*D1**2*f**2*fdd - 576*C*D1**2*f*fd**2*r**2 + 624*C*D1**2*f*fd**2*r*s + 176*C*D1**2*f*fd**2*r + 1200*C*D1**2*f*fd**2*s**2 - 1008*C*D1**2*f*fd**2*s + 104*C*D1**2*f*fd**2 + 768*C*D1*Dd*f**3*r**2 - 832*C*D1*Dd*f**3*r*s - 560*C*D1*Dd*f**3*r - 1600*C*D1*Dd*f**3*s**2 + 1216*C*D1*Dd*f**3*s - 16*C*D1*Dd*f**3 - 2304*C*D1*Dd*f**2*fd*r**2 + 2496*C*D1*Dd*f**2*fd*r*s + 1192*C*D1*Dd*f**2*fd*r + 4800*C*D1*Dd*f**2*fd*s**2 - 3840*C*D1*Dd*f**2*fd*s + 328*C*D1*Dd*f**2*fd - 384*C*D1*Ddd*f**3*r**2 + 416*C*D1*Ddd*f**3*r*s + 280*C*D1*Ddd*f**3*r + 800*C*D1*Ddd*f**3*s**2 - 608*C*D1*Ddd*f**3*s + 8*C*D1*Ddd*f**3 - 1152*C*Dd**2*f**3*r**2 + 1248*C*Dd**2*f**3*r*s + 840*C*Dd**2*f**3*r + 2400*C*Dd**2*f**3*s**2 - 1824*C*Dd**2*f**3*s + 16*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r**2 + 462*D1**2*K*bdd1*f**2*r*s - 330*D1**2*K*bdd1*f**2*r + 297*D1**2*K*bdd1*f**2*s**2 - 462*D1**2*K*bdd1*f**2*s + 165*D1**2*K*bdd1*f**2 - 132*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(4*s - 2) + 3*s**2 - 4*s + 1) + 150*D1**2*bdd1*f**3*r**2 + 120*D1**2*bdd1*f**3*r*s - 300*D1**2*bdd1*f**3*r - 30*D1**2*bdd1*f**3*s**2 - 120*D1**2*bdd1*f**3*s + 180*D1**2*bdd1*f**3 - 165*D1**2*bdd1*f**2*r**2 - 462*D1**2*bdd1*f**2*r*s + 330*D1**2*bdd1*f**2*r - 297*D1**2*bdd1*f**2*s**2 + 462*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 + 132*D1**2*bdd1*f*g2*r**2 + 528*D1**2*bdd1*f*g2*r*s - 264*D1**2*bdd1*f*g2*r + 396*D1**2*bdd1*f*g2*s**2 - 528*D1**2*bdd1*f*g2*s + 264*D1**2*bdd1*f*g2 + 1260*D1**2*f**3*fd*r**2 + 2400*D1**2*f**3*fd*r*s - 1860*D1**2*f**3*fd*r + 1140*D1**2*f**3*fd*s**2 - 1770*D1**2*f**3*fd*s + 915*D1**2*f**3*fd - 1380*D1**2*f**3*fdd*r**2 - 2160*D1**2*f**3*fdd*r*s + 1920*D1**2*f**3*fdd*r - 780*D1**2*f**3*fdd*s**2 + 1470*D1**2*f**3*fdd*s - 885*D1**2*f**3*fdd - 4140*D1**2*f**2*fd**2*r**2 - 6480*D1**2*f**2*fd**2*r*s + 5760*D1**2*f**2*fd**2*r - 2340*D1**2*f**2*fd**2*s**2 + 4410*D1**2*f**2*fd**2*s - 1770*D1**2*f**2*fd**2 - 816*D1**2*f**2*fd*r**2 - 216*D1**2*f**2*fd*r*s + 616*D1**2*f**2*fd*r + 600*D1**2*f**2*fd*s**2 - 328*D1**2*f**2*fd*s - 72*D1**2*f**2*fd + 408*D1**2*f**2*fdd*r**2 + 108*D1**2*f**2*fdd*r*s - 308*D1**2*f**2*fdd*r - 300*D1**2*f**2*fdd*s**2 + 164*D1**2*f**2*fdd*s + 36*D1**2*f**2*fdd - 66*D1**2*f**2*gd2*r**2 + 1188*D1**2*f**2*gd2*r*s + 132*D1**2*f**2*gd2*r + 1254*D1**2*f**2*gd2*s**2 - 1188*D1**2*f**2*gd2*s - 66*D1**2*f**2*gd2 - 330*D1**2*f**2*gdd2*r**2 - 924*D1**2*f**2*gdd2*r*s + 660*D1**2*f**2*gdd2*r - 594*D1**2*f**2*gdd2*s**2 + 924*D1**2*f**2*gdd2*s - 330*D1**2*f**2*gdd2 + 816*D1**2*f*fd**2*r**2 + 216*D1**2*f*fd**2*r*s - 616*D1**2*f*fd**2*r - 600*D1**2*f*fd**2*s**2 + 328*D1**2*f*fd**2*s + 36*D1**2*f*fd**2 - 132*D1**2*f*fd*g2*r**2 + 2376*D1**2*f*fd*g2*r*s - 1188*D1**2*f*fd*g2*r + 2508*D1**2*f*fd*g2*s**2 - 2508*D1**2*f*fd*g2*s + 1254*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r**2 - 3696*D1**2*f*fd*gd2*r*s + 2244*D1**2*f*fd*gd2*r - 2376*D1**2*f*fd*gd2*s**2 + 3036*D1**2*f*fd*gd2*s - 924*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r**2 - 1848*D1**2*f*fdd*g2*r*s + 924*D1**2*f*fdd*g2*r - 1188*D1**2*f*fdd*g2*s**2 + 1188*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r**2 - 1848*D1**2*fd**2*g2*r*s + 924*D1**2*fd**2*g2*r - 1188*D1**2*fd**2*g2*s**2 + 1188*D1**2*fd**2*g2*s + 1260*D1*Dd*f**4*r**2 + 2400*D1*Dd*f**4*r*s - 1860*D1*Dd*f**4*r + 1140*D1*Dd*f**4*s**2 - 1770*D1*Dd*f**4*s + 915*D1*Dd*f**4 - 11040*D1*Dd*f**3*fd*r**2 - 17280*D1*Dd*f**3*fd*r*s + 15360*D1*Dd*f**3*fd*r - 6240*D1*Dd*f**3*fd*s**2 + 11760*D1*Dd*f**3*fd*s - 5310*D1*Dd*f**3*fd - 1088*D1*Dd*f**3*r**2 - 288*D1*Dd*f**3*r*s + 1160*D1*Dd*f**3*r + 800*D1*Dd*f**3*s**2 - 256*D1*Dd*f**3*s - 344*D1*Dd*f**3 + 3264*D1*Dd*f**2*fd*r**2 + 864*D1*Dd*f**2*fd*r*s - 2972*D1*Dd*f**2*fd*r - 2400*D1*Dd*f**2*fd*s**2 + 1040*D1*Dd*f**2*fd*s + 452*D1*Dd*f**2*fd - 264*D1*Dd*f**2*g2*r**2 + 4752*D1*Dd*f**2*g2*r*s - 924*D1*Dd*f**2*g2*r + 5016*D1*Dd*f**2*g2*s**2 - 4884*D1*Dd*f**2*g2*s + 1122*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r**2 - 7392*D1*Dd*f**2*gd2*r*s + 4884*D1*Dd*f**2*gd2*r - 4752*D1*Dd*f**2*gd2*s**2 + 6732*D1*Dd*f**2*gd2*s - 2244*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r**2 - 14784*D1*Dd*f*fd*g2*r*s + 8184*D1*Dd*f*fd*g2*r - 9504*D1*Dd*f*fd*g2*s**2 + 10824*D1*Dd*f*fd*g2*s - 3036*D1*Dd*f*fd*g2 - 1380*D1*Ddd*f**4*r**2 - 2160*D1*Ddd*f**4*r*s + 1920*D1*Ddd*f**4*r - 780*D1*Ddd*f**4*s**2 + 1470*D1*Ddd*f**4*s - 885*D1*Ddd*f**4 + 544*D1*Ddd*f**3*r**2 + 144*D1*Ddd*f**3*r*s - 580*D1*Ddd*f**3*r - 400*D1*Ddd*f**3*s**2 + 128*D1*Ddd*f**3*s + 172*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r**2 - 3696*D1*Ddd*f**2*g2*r*s + 2244*D1*Ddd*f**2*g2*r - 2376*D1*Ddd*f**2*g2*s**2 + 3036*D1*Ddd*f**2*g2*s - 1254*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(20*f**3*(5*r**2 + 2*r*(2*s - 5) - s**2 - 4*s + 6) + f**2*(-20*fd*(15*r**2 + 2*r*(6*s - 11) - 3*s**2 - 7*s + 6) + (-11*r - 11*s + 11)*(K*(r - 19*s - 1) - 5*r + 11*s + 5)) - 22*f*(fd*(K - 1)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) - 4*g2*(r**2 + 4*r*s - 2*r + 3*s**2 - 4*s + 2) + 4*gd2*(r**2 + 4*r*s - 2*r + 3*s**2 - 4*s + 1)) - 88*fd*g2*(r**2 + r*(4*s - 2) + s*(3*s - 3))) - 2*Dd*f*(10*f**2*(20*r**2 + 16*r*(s - 2) - 4*s**2 - 11*s + 12) + 11*f*(K - 1)*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) + 44*g2*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4))) - 4140*Dd**2*f**4*r**2 - 6480*Dd**2*f**4*r*s + 5760*Dd**2*f**4*r - 2340*Dd**2*f**4*s**2 + 4410*Dd**2*f**4*s - 1770*Dd**2*f**4 + 1632*Dd**2*f**3*r**2 + 432*Dd**2*f**3*r*s - 1740*Dd**2*f**3*r - 1200*Dd**2*f**3*s**2 + 384*Dd**2*f**3*s + 344*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r**2 - 11088*Dd**2*f**2*g2*r*s + 6732*Dd**2*f**2*g2*r - 7128*Dd**2*f**2*g2*s**2 + 9108*Dd**2*f**2*g2*s - 2508*Dd**2*f**2*g2 + 66*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r**2 + r*(4*s - 2) + 3*s**2 - 2*s + 1) + D1*(2*Dd*(f*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 14*s + 5) - fd*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 11*s + 3)) - Ddd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 14*s + 5)) - 2*Dd**2*f*(6*r**2 + 12*r*(2*s - 1) + 18*s**2 - 21*s + 5)) + 3*b1*(22*D1**2*K*f*fd*r**2 - 396*D1**2*K*f*fd*r*s + 198*D1**2*K*f*fd*r - 418*D1**2*K*f*fd*s**2 + 418*D1**2*K*f*fd*s - 209*D1**2*K*f*fd + 110*D1**2*K*f*fdd*r**2 + 308*D1**2*K*f*fdd*r*s - 154*D1**2*K*f*fdd*r + 198*D1**2*K*f*fdd*s**2 - 198*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 110*D1**2*K*fd**2*r**2 + 308*D1**2*K*fd**2*r*s - 154*D1**2*K*fd**2*r + 198*D1**2*K*fd**2*s**2 - 198*D1**2*K*fd**2*s - 22*D1**2*bdd1*f*(K - 1)*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) - 300*D1**2*f**2*fd*r**2 - 240*D1**2*f**2*fd*r*s + 280*D1**2*f**2*fd*r + 60*D1**2*f**2*fd*s**2 + 40*D1**2*f**2*fd*s - 60*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 + 120*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r - 30*D1**2*f**2*fdd*s**2 - 20*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 + 240*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r - 60*D1**2*f*fd**2*s**2 - 40*D1**2*f*fd**2*s + 60*D1**2*f*fd**2 - 110*D1**2*f*fd*r**2 + 132*D1**2*f*fd*r*s - 66*D1**2*f*fd*r + 242*D1**2*f*fd*s**2 - 242*D1**2*f*fd*s + 121*D1**2*f*fd - 110*D1**2*f*fdd*r**2 - 308*D1**2*f*fdd*r*s + 154*D1**2*f*fdd*r - 198*D1**2*f*fdd*s**2 + 198*D1**2*f*fdd*s - 99*D1**2*f*fdd - 88*D1**2*f*gd2*r**2 - 352*D1**2*f*gd2*r*s + 176*D1**2*f*gd2*r - 264*D1**2*f*gd2*s**2 + 352*D1**2*f*gd2*s - 88*D1**2*f*gd2 + 44*D1**2*f*gdd2*r**2 + 176*D1**2*f*gdd2*r*s - 88*D1**2*f*gdd2*r + 132*D1**2*f*gdd2*s**2 - 176*D1**2*f*gdd2*s + 44*D1**2*f*gdd2 - 110*D1**2*fd**2*r**2 - 308*D1**2*fd**2*r*s + 154*D1**2*fd**2*r - 198*D1**2*fd**2*s**2 + 198*D1**2*fd**2*s - 88*D1**2*fd*g2*r**2 - 352*D1**2*fd*g2*r*s + 176*D1**2*fd*g2*r - 264*D1**2*fd*g2*s**2 + 176*D1**2*fd*g2*s - 88*D1**2*fd*g2 + 88*D1**2*fd*gd2*r**2 + 352*D1**2*fd*gd2*r*s - 176*D1**2*fd*gd2*r + 264*D1**2*fd*gd2*s**2 - 264*D1**2*fd*gd2*s + 88*D1**2*fd*gd2 + 44*D1**2*fdd*g2*r**2 + 176*D1**2*fdd*g2*r*s - 88*D1**2*fdd*g2*r + 132*D1**2*fdd*g2*s**2 - 88*D1**2*fdd*g2*s + 44*D1**2*fdd*g2 + 44*D1*Dd*K*f**2*r**2 - 792*D1*Dd*K*f**2*r*s + 154*D1*Dd*K*f**2*r - 836*D1*Dd*K*f**2*s**2 + 814*D1*Dd*K*f**2*s - 187*D1*Dd*K*f**2 + 880*D1*Dd*K*f*fd*r**2 + 2464*D1*Dd*K*f*fd*r*s - 1364*D1*Dd*K*f*fd*r + 1584*D1*Dd*K*f*fd*s**2 - 1804*D1*Dd*K*f*fd*s + 506*D1*Dd*K*f*fd - 400*D1*Dd*f**3*r**2 - 320*D1*Dd*f**3*r*s + 480*D1*Dd*f**3*r + 80*D1*Dd*f**3*s**2 + 120*D1*Dd*f**3*s - 180*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 + 960*D1*Dd*f**2*fd*r*s - 1280*D1*Dd*f**2*fd*r - 240*D1*Dd*f**2*fd*s**2 - 260*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd - 220*D1*Dd*f**2*r**2 + 264*D1*Dd*f**2*r*s + 154*D1*Dd*f**2*r + 484*D1*Dd*f**2*s**2 - 374*D1*Dd*f**2*s + 11*D1*Dd*f**2 - 880*D1*Dd*f*fd*r**2 - 2464*D1*Dd*f*fd*r*s + 1364*D1*Dd*f*fd*r - 1584*D1*Dd*f*fd*s**2 + 1804*D1*Dd*f*fd*s - 506*D1*Dd*f*fd - 352*D1*Dd*f*g2*r**2 - 1408*D1*Dd*f*g2*r*s + 704*D1*Dd*f*g2*r - 1056*D1*Dd*f*g2*s**2 + 1232*D1*Dd*f*g2*s - 440*D1*Dd*f*g2 + 352*D1*Dd*f*gd2*r**2 + 1408*D1*Dd*f*gd2*r*s - 704*D1*Dd*f*gd2*r + 1056*D1*Dd*f*gd2*s**2 - 1320*D1*Dd*f*gd2*s + 352*D1*Dd*f*gd2 + 352*D1*Dd*fd*g2*r**2 + 1408*D1*Dd*fd*g2*r*s - 704*D1*Dd*fd*g2*r + 1056*D1*Dd*fd*g2*s**2 - 968*D1*Dd*fd*g2*s + 264*D1*Dd*fd*g2 + 220*D1*Ddd*K*f**2*r**2 + 616*D1*Ddd*K*f**2*r*s - 374*D1*Ddd*K*f**2*r + 396*D1*Ddd*K*f**2*s**2 - 506*D1*Ddd*K*f**2*s + 209*D1*Ddd*K*f**2 + 200*D1*Ddd*f**3*r**2 + 160*D1*Ddd*f**3*r*s - 240*D1*Ddd*f**3*r - 40*D1*Ddd*f**3*s**2 - 60*D1*Ddd*f**3*s + 90*D1*Ddd*f**3 - 220*D1*Ddd*f**2*r**2 - 616*D1*Ddd*f**2*r*s + 374*D1*Ddd*f**2*r - 396*D1*Ddd*f**2*s**2 + 506*D1*Ddd*f**2*s - 209*D1*Ddd*f**2 + 176*D1*Ddd*f*g2*r**2 + 704*D1*Ddd*f*g2*r*s - 352*D1*Ddd*f*g2*r + 528*D1*Ddd*f*g2*s**2 - 616*D1*Ddd*f*g2*s + 220*D1*Ddd*f*g2 + 44*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 8*s + 3) - fd*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 6*s + 1)) - 2*Dd*f*(4*r**2 + 8*r*(2*s - 1) + 12*s**2 - 15*s + 4)) + 660*Dd**2*K*f**2*r**2 + 1848*Dd**2*K*f**2*r*s - 1122*Dd**2*K*f**2*r + 1188*Dd**2*K*f**2*s**2 - 1518*Dd**2*K*f**2*s + 418*Dd**2*K*f**2 + 600*Dd**2*f**3*r**2 + 480*Dd**2*f**3*r*s - 720*Dd**2*f**3*r - 120*Dd**2*f**3*s**2 - 180*Dd**2*f**3*s + 180*Dd**2*f**3 - 660*Dd**2*f**2*r**2 - 1848*Dd**2*f**2*r*s + 1122*Dd**2*f**2*r - 1188*Dd**2*f**2*s**2 + 1518*Dd**2*f**2*s - 418*Dd**2*f**2 + 528*Dd**2*f*g2*r**2 + 2112*Dd**2*f*g2*r*s - 1056*Dd**2*f*g2*r + 1584*Dd**2*f*g2*s**2 - 1848*Dd**2*f*g2*s + 440*Dd**2*f*g2))/(231*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct**2*k1**2*k2**2*st**2*(-374*C*D1**2*bdd1*f**2*r**2 - 220*C*D1**2*bdd1*f**2*r*s + 1276*C*D1**2*bdd1*f**2*r + 154*C*D1**2*bdd1*f**2*s**2 + 748*C*D1**2*bdd1*f**2*s - 374*C*D1**2*bdd1*f**2 + 12480*C*D1**2*f**2*fd*r**2 + 31632*C*D1**2*f**2*fd*r*s - 18864*C*D1**2*f**2*fd*r + 19152*C*D1**2*f**2*fd*s**2 - 23312*C*D1**2*f**2*fd*s + 10544*C*D1**2*f**2*fd - 12312*C*D1**2*f**2*fdd*r**2 - 28224*C*D1**2*f**2*fdd*r*s + 17616*C*D1**2*f**2*fdd*r - 15912*C*D1**2*f**2*fdd*s**2 + 20016*C*D1**2*f**2*fdd*s - 9408*C*D1**2*f**2*fdd - 24624*C*D1**2*f*fd**2*r**2 - 56448*C*D1**2*f*fd**2*r*s + 35232*C*D1**2*f*fd**2*r - 31824*C*D1**2*f*fd**2*s**2 + 40032*C*D1**2*f*fd**2*s - 9408*C*D1**2*f*fd**2 + 16640*C*D1*Dd*f**3*r**2 + 42176*C*D1*Dd*f**3*r*s - 27184*C*D1*Dd*f**3*r + 25536*C*D1*Dd*f**3*s**2 - 33856*C*D1*Dd*f**3*s + 14704*C*D1*Dd*f**3 - 98496*C*D1*Dd*f**2*fd*r**2 - 225792*C*D1*Dd*f**2*fd*r*s + 147936*C*D1*Dd*f**2*fd*r - 127296*C*D1*Dd*f**2*fd*s**2 + 168336*C*D1*Dd*f**2*fd*s - 55248*C*D1*Dd*f**2*fd - 16416*C*D1*Ddd*f**3*r**2 - 37632*C*D1*Ddd*f**3*r*s + 25824*C*D1*Ddd*f**3*r - 21216*C*D1*Ddd*f**3*s**2 + 29424*C*D1*Ddd*f**3*s - 13512*C*D1*Ddd*f**3 - 49248*C*Dd**2*f**3*r**2 - 112896*C*Dd**2*f**3*r*s + 77472*C*Dd**2*f**3*r - 63648*C*Dd**2*f**3*s**2 + 88272*C*Dd**2*f**3*s - 27024*C*Dd**2*f**3 - 2244*D1**2*K*bdd1*f**2*r**2 - 5280*D1**2*K*bdd1*f**2*r*s + 4488*D1**2*K*bdd1*f**2*r - 3036*D1**2*K*bdd1*f**2*s**2 + 5280*D1**2*K*bdd1*f**2*s - 2244*D1**2*K*bdd1*f**2 + 2376*D1**2*b2*f*fd*r**2 + 4752*D1**2*b2*f*fd*r*s - 2376*D1**2*b2*f*fd*r + 2376*D1**2*b2*f*fd*s**2 - 2376*D1**2*b2*f*fd*s + 1188*D1**2*b2*f*fd - 1584*D1**2*b2*f*fdd*r**2 - 3168*D1**2*b2*f*fdd*r*s + 1584*D1**2*b2*f*fdd*r - 1584*D1**2*b2*f*fdd*s**2 + 1584*D1**2*b2*f*fdd*s - 792*D1**2*b2*f*fdd - 1584*D1**2*b2*fd**2*r**2 - 3168*D1**2*b2*fd**2*r*s + 1584*D1**2*b2*fd**2*r - 1584*D1**2*b2*fd**2*s**2 + 1584*D1**2*b2*fd**2*s + 22*D1**2*bd1**2*(r + s - 1)*(24*f**2*(r + s - 2) + f*(4*C*r + 4*C*s + K*(23*r + 47*s - 11) + 9*r - 15*s - 13) + 28*g2*(r + s)) + 660*D1**2*bdd1*f**3*r**2 + 2508*D1**2*bdd1*f**3*r*s - 2244*D1**2*bdd1*f**3*r + 1848*D1**2*bdd1*f**3*s**2 - 3432*D1**2*bdd1*f**3*s + 1584*D1**2*bdd1*f**3 + 1496*D1**2*bdd1*f**2*r**2 + 2860*D1**2*bdd1*f**2*r*s - 3256*D1**2*bdd1*f**2*r + 1364*D1**2*bdd1*f**2*s**2 - 3124*D1**2*bdd1*f**2*s + 1364*D1**2*bdd1*f**2 - 506*D1**2*bdd1*f*g2*r**2 - 1540*D1**2*bdd1*f*g2*r*s + 484*D1**2*bdd1*f*g2*r - 1034*D1**2*bdd1*f*g2*s**2 + 1012*D1**2*bdd1*f*g2*s - 506*D1**2*bdd1*f*g2 - 792*D1**2*bdd2*f**2*r**2 - 1584*D1**2*bdd2*f**2*r*s + 1584*D1**2*bdd2*f**2*r - 792*D1**2*bdd2*f**2*s**2 + 1584*D1**2*bdd2*f**2*s - 792*D1**2*bdd2*f**2 - 7362*D1**2*f**2*fd*r**2 - 20124*D1**2*f**2*fd*r*s + 11616*D1**2*f**2*fd*r - 12762*D1**2*f**2*fd*s**2 + 15216*D1**2*f**2*fd*s - 6708*D1**2*f**2*fd + 8334*D1**2*f**2*fdd*r**2 + 19368*D1**2*f**2*fdd*r*s - 12012*D1**2*f**2*fdd*r + 11034*D1**2*f**2*fdd*s**2 - 13812*D1**2*f**2*fdd*s + 6456*D1**2*f**2*fdd - 5280*D1**2*f**2*gd2*r**2 - 13200*D1**2*f**2*gd2*r*s + 10560*D1**2*f**2*gd2*r - 7920*D1**2*f**2*gd2*s**2 + 13200*D1**2*f**2*gd2*s - 5280*D1**2*f**2*gd2 + 4488*D1**2*f**2*gdd2*r**2 + 10560*D1**2*f**2*gdd2*r*s - 8976*D1**2*f**2*gdd2*r + 6072*D1**2*f**2*gdd2*s**2 - 10560*D1**2*f**2*gdd2*s + 4488*D1**2*f**2*gdd2 + 16668*D1**2*f*fd**2*r**2 + 38736*D1**2*f*fd**2*r*s - 24024*D1**2*f*fd**2*r + 22068*D1**2*f*fd**2*s**2 - 27624*D1**2*f*fd**2*s + 6456*D1**2*f*fd**2 - 10560*D1**2*f*fd*g2*r**2 - 26400*D1**2*f*fd*g2*r*s + 13200*D1**2*f*fd*g2*r - 15840*D1**2*f*fd*g2*s**2 + 15840*D1**2*f*fd*g2*s - 7920*D1**2*f*fd*g2 + 17952*D1**2*f*fd*gd2*r**2 + 42240*D1**2*f*fd*gd2*r*s - 28512*D1**2*f*fd*gd2*r + 24288*D1**2*f*fd*gd2*s**2 - 33264*D1**2*f*fd*gd2*s + 10560*D1**2*f*fd*gd2 + 8976*D1**2*f*fdd*g2*r**2 + 21120*D1**2*f*fdd*g2*r*s - 10560*D1**2*f*fdd*g2*r + 12144*D1**2*f*fdd*g2*s**2 - 12144*D1**2*f*fdd*g2*s + 6072*D1**2*f*fdd*g2 + 8976*D1**2*fd**2*g2*r**2 + 21120*D1**2*fd**2*g2*r*s - 10560*D1**2*fd**2*g2*r + 12144*D1**2*fd**2*g2*s**2 - 12144*D1**2*fd**2*g2*s + 4752*D1*Dd*b2*f**2*r**2 + 9504*D1*Dd*b2*f**2*r*s - 7128*D1*Dd*b2*f**2*r + 4752*D1*Dd*b2*f**2*s**2 - 7128*D1*Dd*b2*f**2*s + 3564*D1*Dd*b2*f**2 - 12672*D1*Dd*b2*f*fd*r**2 - 25344*D1*Dd*b2*f*fd*r*s + 15840*D1*Dd*b2*f*fd*r - 12672*D1*Dd*b2*f*fd*s**2 + 15840*D1*Dd*b2*f*fd*s - 4752*D1*Dd*b2*f*fd - 9816*D1*Dd*f**3*r**2 - 26832*D1*Dd*f**3*r*s + 16524*D1*Dd*f**3*r - 17016*D1*Dd*f**3*s**2 + 21924*D1*Dd*f**3*s - 9162*D1*Dd*f**3 + 66672*D1*Dd*f**2*fd*r**2 + 154944*D1*Dd*f**2*fd*r*s - 100752*D1*Dd*f**2*fd*r + 88272*D1*Dd*f**2*fd*s**2 - 116052*D1*Dd*f**2*fd*s + 37836*D1*Dd*f**2*fd - 21120*D1*Dd*f**2*g2*r**2 - 52800*D1*Dd*f**2*g2*r*s + 34320*D1*Dd*f**2*g2*r - 31680*D1*Dd*f**2*g2*s**2 + 42240*D1*Dd*f**2*g2*s - 18480*D1*Dd*f**2*g2 + 35904*D1*Dd*f**2*gd2*r**2 + 84480*D1*Dd*f**2*gd2*r*s - 64416*D1*Dd*f**2*gd2*r + 48576*D1*Dd*f**2*gd2*s**2 - 75504*D1*Dd*f**2*gd2*s + 28512*D1*Dd*f**2*gd2 + 71808*D1*Dd*f*fd*g2*r**2 + 168960*D1*Dd*f*fd*g2*r*s - 99264*D1*Dd*f*fd*g2*r + 97152*D1*Dd*f*fd*g2*s**2 - 115104*D1*Dd*f*fd*g2*s + 33264*D1*Dd*f*fd*g2 - 3168*D1*Ddd*b2*f**2*r**2 - 6336*D1*Ddd*b2*f**2*r*s + 4752*D1*Ddd*b2*f**2*r - 3168*D1*Ddd*b2*f**2*s**2 + 4752*D1*Ddd*b2*f**2*s - 2376*D1*Ddd*b2*f**2 + 11112*D1*Ddd*f**3*r**2 + 25824*D1*Ddd*f**3*r*s - 17568*D1*Ddd*f**3*r + 14712*D1*Ddd*f**3*s**2 - 20268*D1*Ddd*f**3*s + 9234*D1*Ddd*f**3 + 17952*D1*Ddd*f**2*g2*r**2 + 42240*D1*Ddd*f**2*g2*r*s - 28512*D1*Ddd*f**2*g2*r + 24288*D1*Ddd*f**2*g2*s**2 - 33264*D1*Ddd*f**2*g2*s + 15048*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(6*f**3*(r*(13*s - 7) + 13*s**2 - 20*s + 6) - f**2*(C*(25*r**2 + 2*r*(7*s - 45) - 11*s**2 - 54*s + 27) + 60*K*(2*r**2 + 5*r*s - 4*r + 3*s**2 - 5*s + 2) + 6*fd*(30*r**2 + r*(114*s - 73) + 84*s**2 - 118*s + 36) - 78*r**2 - 156*r*s + 176*r - 78*s**2 + 176*s - 70) + f*(2*fd*(C*(34*r**2 + r*(20*s - 51) - 14*s**2 - 15*s + 29) + 6*K*(34*r**2 + 80*r*s - 54*r + 46*s**2 - 63*s + 20) - 136*r**2 - 260*r*s + 207*r - 124*s**2 + 198*s - 83) - g2*(39*r**2 + 2*r*(77*s + 41) + 115*s**2 + 6*s - 3) + 2*gd2*(23*r**2 + r*(70*s - 34) + 47*s**2 - 58*s + 11)) + 2*fd*g2*(23*r**2 + 35*r*(2*s - 1) + s*(47*s - 47))) + 2*Dd*f*(-3*f**2*(40*r**2 + 152*r*s - 107*r + 112*s**2 - 170*s + 60) + f*(C*(68*r**2 + 5*r*(8*s - 31) - 28*s**2 - 71*s + 75) + 6*K*(68*r**2 + 2*r*(80*s - 61) + 92*s**2 - 143*s + 54) - 272*r**2 - 520*r*s + 497*r - 248*s**2 + 476*s - 219) + g2*(92*r**2 + 5*r*(56*s - 25) + 188*s**2 - 209*s + 45))) + 396*D1*bd2*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 4*D1*fd*(2*r + 2*s - 1) - 4*Dd*f*(4*r + 4*s - 3)) - 9504*Dd**2*b2*f**2*r**2 - 19008*Dd**2*b2*f**2*r*s + 14256*Dd**2*b2*f**2*r - 9504*Dd**2*b2*f**2*s**2 + 14256*Dd**2*b2*f**2*s - 4752*Dd**2*b2*f**2 + 33336*Dd**2*f**3*r**2 + 77472*Dd**2*f**3*r*s - 52704*Dd**2*f**3*r + 44136*Dd**2*f**3*s**2 - 60804*Dd**2*f**3*s + 18468*Dd**2*f**3 + 53856*Dd**2*f**2*g2*r**2 + 126720*Dd**2*f**2*g2*r*s - 85536*Dd**2*f**2*g2*r + 72864*Dd**2*f**2*g2*s**2 - 99792*Dd**2*f**2*g2*s + 30096*Dd**2*f**2*g2 + 154*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(-8*C*D1**2*fd*r**2 - 16*C*D1**2*fd*r*s + 16*C*D1**2*fd*r - 8*C*D1**2*fd*s**2 + 16*C*D1**2*fd*s - 8*C*D1**2*fd + 4*C*D1**2*fdd*r**2 + 8*C*D1**2*fdd*r*s - 8*C*D1**2*fdd*r + 4*C*D1**2*fdd*s**2 - 8*C*D1**2*fdd*s + 4*C*D1**2*fdd - 32*C*D1*Dd*f*r**2 - 64*C*D1*Dd*f*r*s + 48*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 + 48*C*D1*Dd*f*s - 24*C*D1*Dd*f + 32*C*D1*Dd*fd*r**2 + 64*C*D1*Dd*fd*r*s - 56*C*D1*Dd*fd*r + 32*C*D1*Dd*fd*s**2 - 56*C*D1*Dd*fd*s + 24*C*D1*Dd*fd + 16*C*D1*Ddd*f*r**2 + 32*C*D1*Ddd*f*r*s - 24*C*D1*Ddd*f*r + 16*C*D1*Ddd*f*s**2 - 24*C*D1*Ddd*f*s + 12*C*D1*Ddd*f + 48*C*Dd**2*f*r**2 + 96*C*Dd**2*f*r*s - 72*C*Dd**2*f*r + 48*C*Dd**2*f*s**2 - 72*C*Dd**2*f*s + 24*C*Dd**2*f - 39*D1**2*K*fd*r**2 - 154*D1**2*K*fd*r*s + 236*D1**2*K*fd*r - 115*D1**2*K*fd*s**2 + 236*D1**2*K*fd*s - 118*D1**2*K*fd + 23*D1**2*K*fdd*r**2 + 70*D1**2*K*fdd*r*s - 48*D1**2*K*fdd*r + 47*D1**2*K*fdd*s**2 - 48*D1**2*K*fdd*s + 24*D1**2*K*fdd - 14*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 96*D1**2*f*fd*r**2 - 192*D1**2*f*fd*r*s + 24*D1**2*f*fd*r - 96*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd + 48*D1**2*f*fdd*r**2 + 96*D1**2*f*fdd*r*s + 48*D1**2*f*fdd*s**2 + 48*D1**2*fd**2*r**2 + 96*D1**2*fd**2*r*s + 48*D1**2*fd**2*s**2 - 48*D1**2*fd**2 - 81*D1**2*fd*r**2 - 86*D1**2*fd*r*s - 148*D1**2*fd*r - 5*D1**2*fd*s**2 - 148*D1**2*fd*s + 74*D1**2*fd + 9*D1**2*fdd*r**2 - 6*D1**2*fdd*r*s + 32*D1**2*fdd*r - 15*D1**2*fdd*s**2 + 32*D1**2*fdd*s - 16*D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 - 156*D1*Dd*K*f*r**2 - 616*D1*Dd*K*f*r*s + 310*D1*Dd*K*f*r - 460*D1*Dd*K*f*s**2 + 538*D1*Dd*K*f*s - 193*D1*Dd*K*f + 184*D1*Dd*K*fd*r**2 + 560*D1*Dd*K*fd*r*s - 354*D1*Dd*K*fd*r + 376*D1*Dd*K*fd*s**2 - 426*D1*Dd*K*fd*s + 144*D1*Dd*K*fd - 192*D1*Dd*f**2*r**2 - 384*D1*Dd*f**2*r*s + 288*D1*Dd*f**2*r - 192*D1*Dd*f**2*s**2 + 288*D1*Dd*f**2*s - 144*D1*Dd*f**2 + 384*D1*Dd*f*fd*r**2 + 768*D1*Dd*f*fd*r*s - 288*D1*Dd*f*fd*r + 384*D1*Dd*f*fd*s**2 - 288*D1*Dd*f*fd*s - 324*D1*Dd*f*r**2 - 344*D1*Dd*f*r*s + 410*D1*Dd*f*r - 20*D1*Dd*f*s**2 + 182*D1*Dd*f*s - 167*D1*Dd*f + 72*D1*Dd*fd*r**2 - 48*D1*Dd*fd*r*s + 98*D1*Dd*fd*r - 120*D1*Dd*fd*s**2 + 170*D1*Dd*fd*s - 96*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 + 92*D1*Ddd*K*f*r**2 + 280*D1*Ddd*K*f*r*s - 162*D1*Ddd*K*f*r + 188*D1*Ddd*K*f*s**2 - 234*D1*Ddd*K*f*s + 93*D1*Ddd*K*f + 96*D1*Ddd*f**2*r**2 + 192*D1*Ddd*f**2*r*s - 144*D1*Ddd*f**2*r + 96*D1*Ddd*f**2*s**2 - 144*D1*Ddd*f**2*s + 72*D1*Ddd*f**2 + 36*D1*Ddd*f*r**2 - 24*D1*Ddd*f*r*s - 30*D1*Ddd*f*r - 60*D1*Ddd*f*s**2 + 42*D1*Ddd*f*s + 3*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 276*Dd**2*K*f*r**2 + 840*Dd**2*K*f*r*s - 486*Dd**2*K*f*r + 564*Dd**2*K*f*s**2 - 702*Dd**2*K*f*s + 186*Dd**2*K*f + 288*Dd**2*f**2*r**2 + 576*Dd**2*f**2*r*s - 432*Dd**2*f**2*r + 288*Dd**2*f**2*s**2 - 432*Dd**2*f**2*s + 144*Dd**2*f**2 + 108*Dd**2*f*r**2 - 72*Dd**2*f*r*s - 90*Dd**2*f*r - 180*Dd**2*f*s**2 + 126*Dd**2*f*s + 6*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) - 22*b1*(-50*C*D1**2*f*fd*r**2 - 28*C*D1**2*f*fd*r*s - 26*C*D1**2*f*fd*r + 22*C*D1**2*f*fd*s**2 - 62*C*D1**2*f*fd*s + 13*C*D1**2*f*fd + 34*C*D1**2*f*fdd*r**2 + 20*C*D1**2*f*fdd*r*s + 14*C*D1**2*f*fdd*r - 14*C*D1**2*f*fdd*s**2 + 38*C*D1**2*f*fdd*s - 7*C*D1**2*f*fdd + 34*C*D1**2*fd**2*r**2 + 20*C*D1**2*fd**2*r*s + 14*C*D1**2*fd**2*r - 14*C*D1**2*fd**2*s**2 + 38*C*D1**2*fd**2*s - 48*C*D1**2*fd**2 - 100*C*D1*Dd*f**2*r**2 - 56*C*D1*Dd*f**2*r*s + 114*C*D1*Dd*f**2*r + 44*C*D1*Dd*f**2*s**2 + 6*C*D1*Dd*f**2*s - 39*C*D1*Dd*f**2 + 272*C*D1*Dd*f*fd*r**2 + 160*C*D1*Dd*f*fd*r*s - 100*C*D1*Dd*f*fd*r - 112*C*D1*Dd*f*fd*s**2 + 140*C*D1*Dd*f*fd*s - 66*C*D1*Dd*f*fd + 68*C*D1*Ddd*f**2*r**2 + 40*C*D1*Ddd*f**2*r*s - 78*C*D1*Ddd*f**2*r - 28*C*D1*Ddd*f**2*s**2 - 6*C*D1*Ddd*f**2*s + 27*C*D1*Ddd*f**2 + 204*C*Dd**2*f**2*r**2 + 120*C*Dd**2*f**2*r*s - 234*C*Dd**2*f**2*r - 84*C*Dd**2*f**2*s**2 - 18*C*Dd**2*f**2*s + 54*C*Dd**2*f**2 - 240*D1**2*K*f*fd*r**2 - 600*D1**2*K*f*fd*r*s + 300*D1**2*K*f*fd*r - 360*D1**2*K*f*fd*s**2 + 360*D1**2*K*f*fd*s - 180*D1**2*K*f*fd + 204*D1**2*K*f*fdd*r**2 + 480*D1**2*K*f*fdd*r*s - 240*D1**2*K*f*fdd*r + 276*D1**2*K*f*fdd*s**2 - 276*D1**2*K*f*fdd*s + 138*D1**2*K*f*fdd + 204*D1**2*K*fd**2*r**2 + 480*D1**2*K*fd**2*r*s - 240*D1**2*K*fd**2*r + 276*D1**2*K*fd**2*s**2 - 276*D1**2*K*fd**2*s + 14*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - D1**2*bdd1*(12*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + f*(C*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) + K*(23*r**2 + 70*r*s - 34*r + 47*s**2 - 58*s + 23) + 9*r**2 - 6*r*s - 22*r - 15*s**2 + 2*s + 5) + 14*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 234*D1**2*f**2*fd*r*s - 36*D1**2*f**2*fd*r + 234*D1**2*f**2*fd*s**2 - 192*D1**2*f**2*fd*s + 42*D1**2*f**2*fd - 90*D1**2*f**2*fdd*r**2 - 342*D1**2*f**2*fdd*r*s + 132*D1**2*f**2*fdd*r - 252*D1**2*f**2*fdd*s**2 + 240*D1**2*f**2*fdd*s - 72*D1**2*f**2*fdd - 180*D1**2*f*fd**2*r**2 - 684*D1**2*f*fd**2*r*s + 264*D1**2*f*fd**2*r - 504*D1**2*f*fd**2*s**2 + 480*D1**2*f*fd**2*s - 72*D1**2*f*fd**2 + 156*D1**2*f*fd*r**2 + 312*D1**2*f*fd*r*s - 136*D1**2*f*fd*r + 156*D1**2*f*fd*s**2 - 136*D1**2*f*fd*s + 86*D1**2*f*fd - 136*D1**2*f*fdd*r**2 - 260*D1**2*f*fdd*r*s + 118*D1**2*f*fdd*r - 124*D1**2*f*fdd*s**2 + 112*D1**2*f*fdd*s - 68*D1**2*f*fdd - 39*D1**2*f*gd2*r**2 - 154*D1**2*f*gd2*r*s + 78*D1**2*f*gd2*r - 115*D1**2*f*gd2*s**2 + 154*D1**2*f*gd2*s - 39*D1**2*f*gd2 + 23*D1**2*f*gdd2*r**2 + 70*D1**2*f*gdd2*r*s - 46*D1**2*f*gdd2*r + 47*D1**2*f*gdd2*s**2 - 70*D1**2*f*gdd2*s + 23*D1**2*f*gdd2 - 136*D1**2*fd**2*r**2 - 260*D1**2*fd**2*r*s + 118*D1**2*fd**2*r - 124*D1**2*fd**2*s**2 + 112*D1**2*fd**2*s + 36*D1**2*fd**2 - 39*D1**2*fd*g2*r**2 - 154*D1**2*fd*g2*r*s + 236*D1**2*fd*g2*r - 115*D1**2*fd*g2*s**2 + 236*D1**2*fd*g2*s - 118*D1**2*fd*g2 + 46*D1**2*fd*gd2*r**2 + 140*D1**2*fd*gd2*r*s - 94*D1**2*fd*gd2*r + 94*D1**2*fd*gd2*s**2 - 118*D1**2*fd*gd2*s + 48*D1**2*fd*gd2 + 23*D1**2*fdd*g2*r**2 + 70*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*r + 47*D1**2*fdd*g2*s**2 - 48*D1**2*fdd*g2*s + 24*D1**2*fdd*g2 - 480*D1*Dd*K*f**2*r**2 - 1200*D1*Dd*K*f**2*r*s + 780*D1*Dd*K*f**2*r - 720*D1*Dd*K*f**2*s**2 + 960*D1*Dd*K*f**2*s - 420*D1*Dd*K*f**2 + 1632*D1*Dd*K*f*fd*r**2 + 3840*D1*Dd*K*f*fd*r*s - 2256*D1*Dd*K*f*fd*r + 2208*D1*Dd*K*f*fd*s**2 - 2616*D1*Dd*K*f*fd*s + 756*D1*Dd*K*f*fd + 312*D1*Dd*f**3*r*s - 78*D1*Dd*f**3*r + 312*D1*Dd*f**3*s**2 - 312*D1*Dd*f**3*s + 78*D1*Dd*f**3 - 720*D1*Dd*f**2*fd*r**2 - 2736*D1*Dd*f**2*fd*r*s + 1230*D1*Dd*f**2*fd*r - 2016*D1*Dd*f**2*fd*s**2 + 2148*D1*Dd*f**2*fd*s - 504*D1*Dd*f**2*fd + 312*D1*Dd*f**2*r**2 + 624*D1*Dd*f**2*r*s - 468*D1*Dd*f**2*r + 312*D1*Dd*f**2*s**2 - 468*D1*Dd*f**2*s + 234*D1*Dd*f**2 - 1088*D1*Dd*f*fd*r**2 - 2080*D1*Dd*f*fd*r*s + 1276*D1*Dd*f*fd*r - 992*D1*Dd*f*fd*s**2 + 1216*D1*Dd*f*fd*s - 348*D1*Dd*f*fd - 156*D1*Dd*f*g2*r**2 - 616*D1*Dd*f*g2*r*s + 310*D1*Dd*f*g2*r - 460*D1*Dd*f*g2*s**2 + 538*D1*Dd*f*g2*s - 193*D1*Dd*f*g2 + 184*D1*Dd*f*gd2*r**2 + 560*D1*Dd*f*gd2*r*s - 346*D1*Dd*f*gd2*r + 376*D1*Dd*f*gd2*s**2 - 514*D1*Dd*f*gd2*s + 162*D1*Dd*f*gd2 + 184*D1*Dd*fd*g2*r**2 + 560*D1*Dd*fd*g2*r*s - 354*D1*Dd*fd*g2*r + 376*D1*Dd*fd*g2*s**2 - 426*D1*Dd*fd*g2*s + 144*D1*Dd*fd*g2 + 408*D1*Ddd*K*f**2*r**2 + 960*D1*Ddd*K*f**2*r*s - 648*D1*Ddd*K*f**2*r + 552*D1*Ddd*K*f**2*s**2 - 756*D1*Ddd*K*f**2*s + 342*D1*Ddd*K*f**2 - 120*D1*Ddd*f**3*r**2 - 456*D1*Ddd*f**3*r*s + 234*D1*Ddd*f**3*r - 336*D1*Ddd*f**3*s**2 + 396*D1*Ddd*f**3*s - 144*D1*Ddd*f**3 - 272*D1*Ddd*f**2*r**2 - 520*D1*Ddd*f**2*r*s + 402*D1*Ddd*f**2*r - 248*D1*Ddd*f**2*s**2 + 384*D1*Ddd*f**2*s - 198*D1*Ddd*f**2 + 92*D1*Ddd*f*g2*r**2 + 280*D1*Ddd*f*g2*r*s - 162*D1*Ddd*f*g2*r + 188*D1*Ddd*f*g2*s**2 - 234*D1*Ddd*f*g2*s + 93*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(8*r**2 + 2*r*(8*s - 11) + 8*s**2 - 22*s + 11) + f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 39*K*r**2 + 154*K*r*s + 2*K*r + 115*K*s**2 - 74*K*s + 18*K - 48*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 81*r**2 + 86*r*s - 198*r + 5*s**2 - 122*s + 80) - 2*fd*(C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 2) + K*(23*r**2 + 70*r*s - 41*r + 47*s**2 - 53*s + 12) + 9*r**2 - 6*r*s + 5*r - 15*s**2 + 17*s - 8) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(12*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + f*(2*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + K*(92*r**2 + 280*r*s - 149*r + 188*s**2 - 233*s + 63) + 36*r**2 - 24*r*s - 59*r - 60*s**2 + 25*s + 21) + 14*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 1224*Dd**2*K*f**2*r**2 + 2880*Dd**2*K*f**2*r*s - 1944*Dd**2*K*f**2*r + 1656*Dd**2*K*f**2*s**2 - 2268*Dd**2*K*f**2*s + 684*Dd**2*K*f**2 - 360*Dd**2*f**3*r**2 - 1368*Dd**2*f**3*r*s + 702*Dd**2*f**3*r - 1008*Dd**2*f**3*s**2 + 1188*Dd**2*f**3*s - 288*Dd**2*f**3 - 816*Dd**2*f**2*r**2 - 1560*Dd**2*f**2*r*s + 1206*Dd**2*f**2*r - 744*Dd**2*f**2*s**2 + 1152*Dd**2*f**2*s - 396*Dd**2*f**2 + 276*Dd**2*f*g2*r**2 + 840*Dd**2*f*g2*r*s - 486*Dd**2*f*g2*r + 564*Dd**2*f*g2*s**2 - 702*Dd**2*f*g2*s + 186*Dd**2*f*g2))/(231*d**2*k3**6) + 4*D1**2*Pk2*Pk3*ct**2*k1**2*k2**2*(6336*C*D1**2*bd1**2*f*r**2 + 12672*C*D1**2*bd1**2*f*r*s - 6336*C*D1**2*bd1**2*f*r + 6336*C*D1**2*bd1**2*f*s**2 - 6336*C*D1**2*bd1**2*f*s + 12936*C*D1**2*bd1*f**2*r**2 + 29040*C*D1**2*bd1*f**2*r*s - 30096*C*D1**2*bd1*f**2*r + 16104*C*D1**2*bd1*f**2*s**2 - 33264*C*D1**2*bd1*f**2*s + 16632*C*D1**2*bd1*f**2 - 67056*C*D1**2*bd1*f*fd*r**2 - 143616*C*D1**2*bd1*f*fd*r*s + 106656*C*D1**2*bd1*f*fd*r - 76560*C*D1**2*bd1*f*fd*s**2 + 113784*C*D1**2*bd1*f*fd*s - 37224*C*D1**2*bd1*f*fd - 16764*C*D1**2*bdd1*f**2*r**2 - 35904*C*D1**2*bdd1*f**2*r*s + 37224*C*D1**2*bdd1*f**2*r - 19140*C*D1**2*bdd1*f**2*s**2 + 39600*C*D1**2*bdd1*f**2*s - 19800*C*D1**2*bdd1*f**2 - 1770*C*D1**2*f**2*fd*r**2 + 11100*C*D1**2*f**2*fd*r*s - 2520*C*D1**2*f**2*fd*r + 12870*C*D1**2*f**2*fd*s**2 - 12280*C*D1**2*f**2*fd*s + 3700*C*D1**2*f**2*fd - 5550*C*D1**2*f**2*fdd*r**2 - 22380*C*D1**2*f**2*fdd*r*s + 11160*C*D1**2*f**2*fdd*r - 16830*C*D1**2*f**2*fdd*s**2 + 18680*C*D1**2*f**2*fdd*s - 7460*C*D1**2*f**2*fdd - 11100*C*D1**2*f*fd**2*r**2 - 44760*C*D1**2*f*fd**2*r*s + 22320*C*D1**2*f*fd**2*r - 33660*C*D1**2*f*fd**2*s**2 + 37360*C*D1**2*f*fd**2*s - 7460*C*D1**2*f*fd**2 - 134112*C*D1*Dd*bd1*f**2*r**2 - 287232*C*D1*Dd*bd1*f**2*r*s + 251856*C*D1*Dd*bd1*f**2*r - 153120*C*D1*Dd*bd1*f**2*s**2 + 268488*C*D1*Dd*bd1*f**2*s - 114048*C*D1*Dd*bd1*f**2 - 2360*C*D1*Dd*f**3*r**2 + 14800*C*D1*Dd*f**3*r*s - 1340*C*D1*Dd*f**3*r + 17160*C*D1*Dd*f**3*s**2 - 15980*C*D1*Dd*f**3*s + 3110*C*D1*Dd*f**3 - 44400*C*D1*Dd*f**2*fd*r**2 - 179040*C*D1*Dd*f**2*fd*r*s + 89220*C*D1*Dd*f**2*fd*r - 134640*C*D1*Dd*f**2*fd*s**2 + 153140*C*D1*Dd*f**2*fd*s - 41000*C*D1*Dd*f**2*fd - 7400*C*D1*Ddd*f**3*r**2 - 29840*C*D1*Ddd*f**3*r*s + 14860*C*D1*Ddd*f**3*r - 22440*C*D1*Ddd*f**3*s**2 + 26140*C*D1*Ddd*f**3*s - 9310*C*D1*Ddd*f**3 - 22200*C*Dd**2*f**3*r**2 - 89520*C*Dd**2*f**3*r*s + 44580*C*Dd**2*f**3*r - 67320*C*Dd**2*f**3*s**2 + 78420*C*Dd**2*f**3*s - 18620*C*Dd**2*f**3 - 17952*D1**2*K*bd1**2*f*r**2 - 40656*D1**2*K*bd1**2*f*r*s + 39072*D1**2*K*bd1**2*f*r - 22704*D1**2*K*bd1**2*f*s**2 + 43824*D1**2*K*bd1**2*f*s - 21120*D1**2*K*bd1**2*f - 594*D1**2*K*bd1*f**2*r**2 + 1980*D1**2*K*bd1*f**2*r*s + 1188*D1**2*K*bd1*f**2*r + 2574*D1**2*K*bd1*f**2*s**2 - 1980*D1**2*K*bd1*f**2*s - 594*D1**2*K*bd1*f**2 - 3960*D1**2*K*bd1*f*fd*r**2 - 17424*D1**2*K*bd1*f*fd*r*s + 8316*D1**2*K*bd1*f*fd*r - 13464*D1**2*K*bd1*f*fd*s**2 + 15444*D1**2*K*bd1*f*fd*s - 4356*D1**2*K*bd1*f*fd - 990*D1**2*K*bdd1*f**2*r**2 - 4356*D1**2*K*bdd1*f**2*r*s + 1980*D1**2*K*bdd1*f**2*r - 3366*D1**2*K*bdd1*f**2*s**2 + 4356*D1**2*K*bdd1*f**2*s - 990*D1**2*K*bdd1*f**2 + 13068*D1**2*bd1**2*f**2*r**2 + 21384*D1**2*bd1**2*f**2*r*s - 23760*D1**2*bd1**2*f**2*r + 8316*D1**2*bd1**2*f**2*s**2 - 19008*D1**2*bd1**2*f**2*s + 10692*D1**2*bd1**2*f**2 + 2244*D1**2*bd1**2*f*r**2 + 4488*D1**2*bd1**2*f*r*s - 9240*D1**2*bd1**2*f*r + 2244*D1**2*bd1**2*f*s**2 - 9240*D1**2*bd1**2*f*s + 6996*D1**2*bd1**2*f - 7392*D1**2*bd1**2*g2*r**2 - 14784*D1**2*bd1**2*g2*r*s + 7392*D1**2*bd1**2*g2*r - 7392*D1**2*bd1**2*g2*s**2 + 7392*D1**2*bd1**2*g2*s - 4752*D1**2*bd1*bd2*f*r**2 - 9504*D1**2*bd1*bd2*f*r*s + 9504*D1**2*bd1*bd2*f*r - 4752*D1**2*bd1*bd2*f*s**2 + 9504*D1**2*bd1*bd2*f*s - 4752*D1**2*bd1*bd2*f - 6864*D1**2*bd1*f**2*r**2 - 16104*D1**2*bd1*f**2*r*s + 16236*D1**2*bd1*f**2*r - 9240*D1**2*bd1*f**2*s**2 + 18612*D1**2*bd1*f**2*s - 9108*D1**2*bd1*f**2 + 46992*D1**2*bd1*f*fd*r**2 + 97152*D1**2*bd1*f*fd*r*s - 72732*D1**2*bd1*f*fd*r + 50160*D1**2*bd1*f*fd*s**2 - 75108*D1**2*bd1*f*fd*s + 24948*D1**2*bd1*f*fd - 11880*D1**2*bd1*f*g2*r**2 - 31416*D1**2*bd1*f*g2*r*s + 32736*D1**2*bd1*f*g2*r - 19536*D1**2*bd1*f*g2*s**2 + 40392*D1**2*bd1*f*g2*s - 20196*D1**2*bd1*f*g2 + 35904*D1**2*bd1*f*gd2*r**2 + 81312*D1**2*bd1*f*gd2*r*s - 78144*D1**2*bd1*f*gd2*r + 45408*D1**2*bd1*f*gd2*s**2 - 87648*D1**2*bd1*f*gd2*s + 42240*D1**2*bd1*f*gd2 + 35904*D1**2*bd1*fd*g2*r**2 + 81312*D1**2*bd1*fd*g2*r*s - 40656*D1**2*bd1*fd*g2*r + 45408*D1**2*bd1*fd*g2*s**2 - 45408*D1**2*bd1*fd*g2*s - 396*D1**2*bd2*f**2*r**2 - 792*D1**2*bd2*f**2*r*s + 792*D1**2*bd2*f**2*r - 396*D1**2*bd2*f**2*s**2 + 792*D1**2*bd2*f**2*s - 396*D1**2*bd2*f**2 + 11748*D1**2*bdd1*f**2*r**2 + 24288*D1**2*bdd1*f**2*r*s - 24948*D1**2*bdd1*f**2*r + 12540*D1**2*bdd1*f**2*s**2 - 25740*D1**2*bdd1*f**2*s + 12870*D1**2*bdd1*f**2 + 17952*D1**2*bdd1*f*g2*r**2 + 40656*D1**2*bdd1*f*g2*r*s - 42240*D1**2*bdd1*f*g2*r + 22704*D1**2*bdd1*f*g2*s**2 - 46992*D1**2*bdd1*f*g2*s + 23496*D1**2*bdd1*f*g2 + 1875*D1**2*f**2*fd*r**2 - 4560*D1**2*f**2*fd*r*s + 270*D1**2*f**2*fd*r - 6435*D1**2*f**2*fd*s**2 + 5810*D1**2*f**2*fd*s - 1520*D1**2*f**2*fd + 2775*D1**2*f**2*fdd*r**2 + 11190*D1**2*f**2*fdd*r*s - 5580*D1**2*f**2*fdd*r + 8415*D1**2*f**2*fdd*s**2 - 9340*D1**2*f**2*fdd*s + 3730*D1**2*f**2*fdd + 1188*D1**2*f**2*gd2*r**2 - 3960*D1**2*f**2*gd2*r*s - 2376*D1**2*f**2*gd2*r - 5148*D1**2*f**2*gd2*s**2 + 3960*D1**2*f**2*gd2*s + 1188*D1**2*f**2*gd2 + 1980*D1**2*f**2*gdd2*r**2 + 8712*D1**2*f**2*gdd2*r*s - 3960*D1**2*f**2*gdd2*r + 6732*D1**2*f**2*gdd2*s**2 - 8712*D1**2*f**2*gdd2*s + 1980*D1**2*f**2*gdd2 + 5550*D1**2*f*fd**2*r**2 + 22380*D1**2*f*fd**2*r*s - 11160*D1**2*f*fd**2*r + 16830*D1**2*f*fd**2*s**2 - 18680*D1**2*f*fd**2*s + 3730*D1**2*f*fd**2 + 2376*D1**2*f*fd*g2*r**2 - 7920*D1**2*f*fd*g2*r*s + 3960*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r**2 + 34848*D1**2*f*fd*gd2*r*s - 16632*D1**2*f*fd*gd2*r + 26928*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 8712*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r**2 + 17424*D1**2*f*fdd*g2*r*s - 8712*D1**2*f*fdd*g2*r + 13464*D1**2*f*fdd*g2*s**2 - 13464*D1**2*f*fdd*g2*s + 6732*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r**2 + 17424*D1**2*fd**2*g2*r*s - 8712*D1**2*fd**2*g2*r + 13464*D1**2*fd**2*g2*s**2 - 13464*D1**2*fd**2*g2*s - 7920*D1*Dd*K*bd1*f**2*r**2 - 34848*D1*Dd*K*bd1*f**2*r*s + 16236*D1*Dd*K*bd1*f**2*r - 26928*D1*Dd*K*bd1*f**2*s**2 + 32868*D1*Dd*K*bd1*f**2*s - 8316*D1*Dd*K*bd1*f**2 + 93984*D1*Dd*bd1*f**2*r**2 + 194304*D1*Dd*bd1*f**2*r*s - 171072*D1*Dd*bd1*f**2*r + 100320*D1*Dd*bd1*f**2*s**2 - 176616*D1*Dd*bd1*f**2*s + 75636*D1*Dd*bd1*f**2 + 143616*D1*Dd*bd1*f*g2*r**2 + 325248*D1*Dd*bd1*f*g2*r*s - 281424*D1*Dd*bd1*f*g2*r + 181632*D1*Dd*bd1*f*g2*s**2 - 314688*D1*Dd*bd1*f*g2*s + 131472*D1*Dd*bd1*f*g2 + 2500*D1*Dd*f**3*r**2 - 6080*D1*Dd*f**3*r*s - 980*D1*Dd*f**3*r - 8580*D1*Dd*f**3*s**2 + 7330*D1*Dd*f**3*s - 895*D1*Dd*f**3 + 22200*D1*Dd*f**2*fd*r**2 + 89520*D1*Dd*f**2*fd*r*s - 44610*D1*Dd*f**2*fd*r + 67320*D1*Dd*f**2*fd*s**2 - 76570*D1*Dd*f**2*fd*s + 20500*D1*Dd*f**2*fd + 4752*D1*Dd*f**2*g2*r**2 - 15840*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 18216*D1*Dd*f**2*g2*s - 2772*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r**2 + 69696*D1*Dd*f**2*gd2*r*s - 32472*D1*Dd*f**2*gd2*r + 53856*D1*Dd*f**2*gd2*s**2 - 65736*D1*Dd*f**2*gd2*s + 16632*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r**2 + 139392*D1*Dd*f*fd*g2*r*s - 68112*D1*Dd*f*fd*g2*r + 107712*D1*Dd*f*fd*g2*s**2 - 115632*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 + 3700*D1*Ddd*f**3*r**2 + 14920*D1*Ddd*f**3*r*s - 7430*D1*Ddd*f**3*r + 11220*D1*Ddd*f**3*s**2 - 13070*D1*Ddd*f**3*s + 4655*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r**2 + 34848*D1*Ddd*f**2*g2*r*s - 16632*D1*Ddd*f**2*g2*r + 26928*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 10692*D1*Ddd*f**2*g2 + 66*D1*b2*(bd1*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) - 6*f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 11100*Dd**2*f**3*r**2 + 44760*Dd**2*f**3*r*s - 22290*Dd**2*f**3*r + 33660*Dd**2*f**3*s**2 - 39210*Dd**2*f**3*s + 9310*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r**2 + 104544*Dd**2*f**2*g2*r*s - 49896*Dd**2*f**2*g2*r + 80784*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 21384*Dd**2*f**2*g2 + 132*b1**3*(D1**2*(11*fd - 9*fdd)*(r + s - 1)**2 + D1*(Dd*(11*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 9*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 9*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1**2*(-26*C*D1**2*fd*r**2 - 52*C*D1**2*fd*r*s + 52*C*D1**2*fd*r - 26*C*D1**2*fd*s**2 + 52*C*D1**2*fd*s - 26*C*D1**2*fd + 48*C*D1**2*fdd*r**2 + 96*C*D1**2*fdd*r*s - 96*C*D1**2*fdd*r + 48*C*D1**2*fdd*s**2 - 96*C*D1**2*fdd*s + 48*C*D1**2*fdd - 104*C*D1*Dd*f*r**2 - 208*C*D1*Dd*f*r*s + 156*C*D1*Dd*f*r - 104*C*D1*Dd*f*s**2 + 156*C*D1*Dd*f*s - 78*C*D1*Dd*f + 384*C*D1*Dd*fd*r**2 + 768*C*D1*Dd*fd*r*s - 672*C*D1*Dd*fd*r + 384*C*D1*Dd*fd*s**2 - 672*C*D1*Dd*fd*s + 288*C*D1*Dd*fd + 192*C*D1*Ddd*f*r**2 + 384*C*D1*Ddd*f*r*s - 288*C*D1*Ddd*f*r + 192*C*D1*Ddd*f*s**2 - 288*C*D1*Ddd*f*s + 144*C*D1*Ddd*f + 576*C*Dd**2*f*r**2 + 1152*C*Dd**2*f*r*s - 864*C*Dd**2*f*r + 576*C*Dd**2*f*s**2 - 864*C*Dd**2*f*s + 288*C*Dd**2*f + 90*D1**2*K*fd*r**2 + 238*D1**2*K*fd*r*s + 10*D1**2*K*fd*r + 148*D1**2*K*fd*s**2 + 10*D1**2*K*fd*s - 5*D1**2*K*fd - 136*D1**2*K*fdd*r**2 - 308*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r - 172*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - 2*D1**2*bdd1*(-14*K + 9*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 138*D1**2*f*fd*r**2 - 204*D1**2*f*fd*r*s + 138*D1**2*f*fd*r - 66*D1**2*f*fd*s**2 + 102*D1**2*f*fd*s - 69*D1**2*f*fd + 198*D1**2*f*fdd*r**2 + 324*D1**2*f*fdd*r*s - 198*D1**2*f*fdd*r + 126*D1**2*f*fdd*s**2 - 162*D1**2*f*fdd*s + 99*D1**2*f*fdd + 198*D1**2*fd**2*r**2 + 324*D1**2*fd**2*r*s - 198*D1**2*fd**2*r + 126*D1**2*fd**2*s**2 - 162*D1**2*fd**2*s + 15*D1**2*fd*r**2 + 9*D1**2*fd*r*s - 32*D1**2*fd*r - 6*D1**2*fd*s**2 - 32*D1**2*fd*s + 16*D1**2*fd + 17*D1**2*fdd*r**2 + 34*D1**2*fdd*r*s + 72*D1**2*fdd*r + 17*D1**2*fdd*s**2 + 72*D1**2*fdd*s - 36*D1**2*fdd + 112*D1**2*gd2*r**2 + 224*D1**2*gd2*r*s - 224*D1**2*gd2*r + 112*D1**2*gd2*s**2 - 224*D1**2*gd2*s + 112*D1**2*gd2 - 56*D1**2*gdd2*r**2 - 112*D1**2*gdd2*r*s + 112*D1**2*gdd2*r - 56*D1**2*gdd2*s**2 + 112*D1**2*gdd2*s - 56*D1**2*gdd2 + 360*D1*Dd*K*f*r**2 + 952*D1*Dd*K*f*r*s - 598*D1*Dd*K*f*r + 592*D1*Dd*K*f*s**2 - 772*D1*Dd*K*f*s + 328*D1*Dd*K*f - 1088*D1*Dd*K*fd*r**2 - 2464*D1*Dd*K*fd*r*s + 804*D1*Dd*K*fd*r - 1376*D1*Dd*K*fd*s**2 + 912*D1*Dd*K*fd*s + 36*D1*Dd*K*fd - 276*D1*Dd*f**2*r**2 - 408*D1*Dd*f**2*r*s + 378*D1*Dd*f**2*r - 132*D1*Dd*f**2*s**2 + 270*D1*Dd*f**2*s - 171*D1*Dd*f**2 + 1584*D1*Dd*f*fd*r**2 + 2592*D1*Dd*f*fd*r*s - 1908*D1*Dd*f*fd*r + 1008*D1*Dd*f*fd*s**2 - 1548*D1*Dd*f*fd*s + 558*D1*Dd*f*fd + 60*D1*Dd*f*r**2 + 36*D1*Dd*f*r*s - 69*D1*Dd*f*r - 24*D1*Dd*f*s**2 - 6*D1*Dd*f*s + 24*D1*Dd*f + 136*D1*Dd*fd*r**2 + 272*D1*Dd*fd*r*s + 186*D1*Dd*fd*r + 136*D1*Dd*fd*s**2 + 186*D1*Dd*fd*s - 216*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 896*D1*Dd*g2*r*s - 672*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 672*D1*Dd*g2*s + 336*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 896*D1*Dd*gd2*r*s + 784*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 784*D1*Dd*gd2*s - 336*D1*Dd*gd2 - 544*D1*Ddd*K*f*r**2 - 1232*D1*Ddd*K*f*r*s + 852*D1*Ddd*K*f*r - 688*D1*Ddd*K*f*s**2 + 960*D1*Ddd*K*f*s - 444*D1*Ddd*K*f + 396*D1*Ddd*f**2*r**2 + 648*D1*Ddd*f**2*r*s - 558*D1*Ddd*f**2*r + 252*D1*Ddd*f**2*s**2 - 450*D1*Ddd*f**2*s + 261*D1*Ddd*f**2 + 68*D1*Ddd*f*r**2 + 136*D1*Ddd*f*r*s - 102*D1*Ddd*f*r + 68*D1*Ddd*f*s**2 - 102*D1*Ddd*f*s + 51*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 448*D1*Ddd*g2*r*s + 336*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 336*D1*Ddd*g2*s - 168*D1*Ddd*g2 + 2*D1*bd1*(D1*(11*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-14*K + 9*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 1632*Dd**2*K*f*r**2 - 3696*Dd**2*K*f*r*s + 2556*Dd**2*K*f*r - 2064*Dd**2*K*f*s**2 + 2880*Dd**2*K*f*s - 888*Dd**2*K*f + 1188*Dd**2*f**2*r**2 + 1944*Dd**2*f**2*r*s - 1674*Dd**2*f**2*r + 756*Dd**2*f**2*s**2 - 1350*Dd**2*f**2*s + 522*Dd**2*f**2 + 204*Dd**2*f*r**2 + 408*Dd**2*f*r*s - 306*Dd**2*f*r + 204*Dd**2*f*s**2 - 306*Dd**2*f*s + 102*Dd**2*f - 672*Dd**2*g2*r**2 - 1344*Dd**2*g2*r*s + 1008*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 1008*Dd**2*g2*s - 336*Dd**2*g2) - 66*b1*(-96*C*D1**2*bdd1*f*r**2 - 192*C*D1**2*bdd1*f*r*s + 96*C*D1**2*bdd1*f*r - 96*C*D1**2*bdd1*f*s**2 + 96*C*D1**2*bdd1*f*s - 48*C*D1**2*bdd1*f - 392*C*D1**2*f*fd*r**2 - 880*C*D1**2*f*fd*r*s + 376*C*D1**2*f*fd*r - 488*C*D1**2*f*fd*s**2 + 424*C*D1**2*f*fd*s - 188*C*D1**2*f*fd + 508*C*D1**2*f*fdd*r**2 + 1088*C*D1**2*f*fdd*r*s - 488*C*D1**2*f*fdd*r + 580*C*D1**2*f*fdd*s**2 - 524*C*D1**2*f*fdd*s + 244*C*D1**2*f*fdd + 508*C*D1**2*fd**2*r**2 + 1088*C*D1**2*fd**2*r*s - 488*C*D1**2*fd**2*r + 580*C*D1**2*fd**2*s**2 - 524*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 784*C*D1*Dd*f**2*r**2 - 1760*C*D1*Dd*f**2*r*s + 1224*C*D1*Dd*f**2*r - 976*C*D1*Dd*f**2*s**2 + 1368*C*D1*Dd*f**2*s - 636*C*D1*Dd*f**2 + 4064*C*D1*Dd*f*fd*r**2 + 8704*C*D1*Dd*f*fd*r*s - 5072*C*D1*Dd*f*fd*r + 4640*C*D1*Dd*f*fd*s**2 - 5432*C*D1*Dd*f*fd*s + 1500*C*D1*Dd*f*fd + 1016*C*D1*Ddd*f**2*r**2 + 2176*C*D1*Ddd*f**2*r*s - 1560*C*D1*Ddd*f**2*r + 1160*C*D1*Ddd*f**2*s**2 - 1668*C*D1*Ddd*f**2*s + 798*C*D1*Ddd*f**2 + 3048*C*Dd**2*f**2*r**2 + 6528*C*Dd**2*f**2*r*s - 4680*C*Dd**2*f**2*r + 3480*C*Dd**2*f**2*s**2 - 5004*C*Dd**2*f**2*s + 1596*C*Dd**2*f**2 + 272*D1**2*K*bdd1*f*r**2 + 616*D1**2*K*bdd1*f*r*s - 592*D1**2*K*bdd1*f*r + 344*D1**2*K*bdd1*f*s**2 - 664*D1**2*K*bdd1*f*s + 314*D1**2*K*bdd1*f + 18*D1**2*K*f*fd*r**2 - 60*D1**2*K*f*fd*r*s + 30*D1**2*K*f*fd*r - 78*D1**2*K*f*fd*s**2 + 78*D1**2*K*f*fd*s - 39*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 + 132*D1**2*K*f*fdd*r*s - 66*D1**2*K*f*fdd*r + 102*D1**2*K*f*fdd*s**2 - 102*D1**2*K*f*fdd*s + 51*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 + 132*D1**2*K*fd**2*r*s - 66*D1**2*K*fd**2*r + 102*D1**2*K*fd**2*s**2 - 102*D1**2*K*fd**2*s - 37*D1**2*b2*fd*r**2 - 74*D1**2*b2*fd*r*s - 37*D1**2*b2*fd*s**2 + 36*D1**2*b2*fdd*r**2 + 72*D1**2*b2*fdd*r*s + 36*D1**2*b2*fdd*s**2 + 4*D1**2*bd1**2*(-14*K + 9*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 198*D1**2*bdd1*f**2*r**2 - 324*D1**2*bdd1*f**2*r*s + 360*D1**2*bdd1*f**2*r - 126*D1**2*bdd1*f**2*s**2 + 288*D1**2*bdd1*f**2*s - 162*D1**2*bdd1*f**2 - 34*D1**2*bdd1*f*r**2 - 68*D1**2*bdd1*f*r*s + 140*D1**2*bdd1*f*r - 34*D1**2*bdd1*f*s**2 + 140*D1**2*bdd1*f*s - 70*D1**2*bdd1*f + 112*D1**2*bdd1*g2*r**2 + 224*D1**2*bdd1*g2*r*s - 112*D1**2*bdd1*g2*r + 112*D1**2*bdd1*g2*s**2 - 112*D1**2*bdd1*g2*s + 56*D1**2*bdd1*g2 + 36*D1**2*bdd2*f*r**2 + 72*D1**2*bdd2*f*r*s - 72*D1**2*bdd2*f*r + 36*D1**2*bdd2*f*s**2 - 72*D1**2*bdd2*f*s + 36*D1**2*bdd2*f + 208*D1**2*f*fd*r**2 + 488*D1**2*f*fd*r*s - 206*D1**2*f*fd*r + 280*D1**2*f*fd*s**2 - 242*D1**2*f*fd*s + 106*D1**2*f*fd - 356*D1**2*f*fdd*r**2 - 736*D1**2*f*fdd*r*s + 346*D1**2*f*fdd*r - 380*D1**2*f*fdd*s**2 + 358*D1**2*f*fdd*s - 173*D1**2*f*fdd + 180*D1**2*f*gd2*r**2 + 476*D1**2*f*gd2*r*s - 360*D1**2*f*gd2*r + 296*D1**2*f*gd2*s**2 - 476*D1**2*f*gd2*s + 180*D1**2*f*gd2 - 272*D1**2*f*gdd2*r**2 - 616*D1**2*f*gdd2*r*s + 544*D1**2*f*gdd2*r - 344*D1**2*f*gdd2*s**2 + 616*D1**2*f*gdd2*s - 272*D1**2*f*gdd2 - 356*D1**2*fd**2*r**2 - 736*D1**2*fd**2*r*s + 346*D1**2*fd**2*r - 380*D1**2*fd**2*s**2 + 358*D1**2*fd**2*s + 10*D1**2*fd**2 + 180*D1**2*fd*g2*r**2 + 476*D1**2*fd*g2*r*s + 20*D1**2*fd*g2*r + 296*D1**2*fd*g2*s**2 + 20*D1**2*fd*g2*s - 10*D1**2*fd*g2 - 544*D1**2*fd*gd2*r**2 - 1232*D1**2*fd*gd2*r*s + 520*D1**2*fd*gd2*r - 688*D1**2*fd*gd2*s**2 + 592*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 - 272*D1**2*fdd*g2*r**2 - 616*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r - 344*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 + 36*D1*Dd*K*f**2*r**2 - 120*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r - 156*D1*Dd*K*f**2*s**2 + 138*D1*Dd*K*f**2*s - 21*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 + 1056*D1*Dd*K*f*fd*r*s - 516*D1*Dd*K*f*fd*r + 816*D1*Dd*K*f*fd*s**2 - 876*D1*Dd*K*f*fd*s + 234*D1*Dd*K*f*fd - 148*D1*Dd*b2*f*r**2 - 296*D1*Dd*b2*f*r*s + 222*D1*Dd*b2*f*r - 148*D1*Dd*b2*f*s**2 + 222*D1*Dd*b2*f*s - 111*D1*Dd*b2*f + 288*D1*Dd*b2*fd*r**2 + 576*D1*Dd*b2*fd*r*s - 216*D1*Dd*b2*fd*r + 288*D1*Dd*b2*fd*s**2 - 216*D1*Dd*b2*fd*s + 416*D1*Dd*f**2*r**2 + 976*D1*Dd*f**2*r*s - 660*D1*Dd*f**2*r + 560*D1*Dd*f**2*s**2 - 768*D1*Dd*f**2*s + 348*D1*Dd*f**2 - 2848*D1*Dd*f*fd*r**2 - 5888*D1*Dd*f*fd*r*s + 3544*D1*Dd*f*fd*r - 3040*D1*Dd*f*fd*s**2 + 3664*D1*Dd*f*fd*s - 1050*D1*Dd*f*fd + 720*D1*Dd*f*g2*r**2 + 1904*D1*Dd*f*g2*r*s - 1196*D1*Dd*f*g2*r + 1184*D1*Dd*f*g2*s**2 - 1544*D1*Dd*f*g2*s + 656*D1*Dd*f*g2 - 2176*D1*Dd*f*gd2*r**2 - 4928*D1*Dd*f*gd2*r*s + 3880*D1*Dd*f*gd2*r - 2752*D1*Dd*f*gd2*s**2 + 4384*D1*Dd*f*gd2*s - 1704*D1*Dd*f*gd2 - 2176*D1*Dd*fd*g2*r**2 - 4928*D1*Dd*fd*g2*r*s + 1608*D1*Dd*fd*g2*r - 2752*D1*Dd*fd*g2*s**2 + 1824*D1*Dd*fd*g2*s + 72*D1*Dd*fd*g2 + 60*D1*Ddd*K*f**2*r**2 + 264*D1*Ddd*K*f**2*r*s - 126*D1*Ddd*K*f**2*r + 204*D1*Ddd*K*f**2*s**2 - 234*D1*Ddd*K*f**2*s + 81*D1*Ddd*K*f**2 + 144*D1*Ddd*b2*f*r**2 + 288*D1*Ddd*b2*f*r*s - 216*D1*Ddd*b2*f*r + 144*D1*Ddd*b2*f*s**2 - 216*D1*Ddd*b2*f*s + 108*D1*Ddd*b2*f - 712*D1*Ddd*f**2*r**2 - 1472*D1*Ddd*f**2*r*s + 1080*D1*Ddd*f**2*r - 760*D1*Ddd*f**2*s**2 + 1116*D1*Ddd*f**2*s - 546*D1*Ddd*f**2 - 1088*D1*Ddd*f*g2*r**2 - 2464*D1*Ddd*f*g2*r*s + 1704*D1*Ddd*f*g2*r - 1376*D1*Ddd*f*g2*s**2 + 1920*D1*Ddd*f*g2*s - 888*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(23*r**2 + r*(34*s - 40) + 11*s**2 - 28*s + 17) + f*(26*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 180*K*r**2 - 476*K*r*s + 428*K*r - 296*K*s**2 + 544*K*s - 243*K - 36*fd*(22*r**2 + 36*r*s - 31*r + 14*s**2 - 25*s + 10) - 30*r**2 - 18*r*s + 7*r + 12*s**2 - 35*s + 7) - 4*fd*(24*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-136*r**2 - 308*r*s + 142*r - 172*s**2 + 160*s + 3) + 17*r**2 + 34*r*s + r + 17*s**2 + s - 18) - 112*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 112*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(9*f**2*(44*r**2 + r*(72*s - 71) + 28*s**2 - 57*s + 28) + f*(24*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 2*K*(272*r**2 + 616*r*s - 509*r + 344*s**2 - 572*s + 231) + 68*r**2 + 136*r*s - 191*r + 68*s**2 - 191*s + 105) - 28*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - D1*bd2*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) + 180*Dd**2*K*f**2*r**2 + 792*Dd**2*K*f**2*r*s - 378*Dd**2*K*f**2*r + 612*Dd**2*K*f**2*s**2 - 702*Dd**2*K*f**2*s + 162*Dd**2*K*f**2 + 432*Dd**2*b2*f*r**2 + 864*Dd**2*b2*f*r*s - 648*Dd**2*b2*f*r + 432*Dd**2*b2*f*s**2 - 648*Dd**2*b2*f*s + 216*Dd**2*b2*f - 2136*Dd**2*f**2*r**2 - 4416*Dd**2*f**2*r*s + 3240*Dd**2*f**2*r - 2280*Dd**2*f**2*s**2 + 3348*Dd**2*f**2*s - 1092*Dd**2*f**2 - 3264*Dd**2*f*g2*r**2 - 7392*Dd**2*f*g2*r*s + 5112*Dd**2*f*g2*r - 4128*Dd**2*f*g2*s**2 + 5760*Dd**2*f*g2*s - 1776*Dd**2*f*g2))/(693*d**2*k3**6) + 20*D1**2*Pk2*Pk3*ct**2*k1**2*st**6*(D1**2*(-84*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(504*fd**2*s*(2*s - 1) + fd*(52*C - 52)*(3*s**2 - 2*s + 1) - fdd*(26*C - 26)*(3*s**2 - 2*s + 1) + s**2*(-429*K*bdd1 + 858*bd1*(K - 1) + 429*bdd1 - 1716*gd2 + 858*gdd2)) - 26*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 1716*fd**2*g2*s*(s - 1)) - 2*D1*f*(Dd*(84*f**3*(4*s**2 - 2*s + 1) - 2*f**2*(13*C*(4*s**2 - 2*s + 1) + 42*fd*(1 - 4*s)**2 - 52*s**2 + 26*s - 13) + 13*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 858*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(42*f**2 + f*(13 - 13*C) + 429*g2)*(4*s**2 - 2*s + 1)) + 12*Dd**2*f**2*s*(2*s - 1)*(42*f**2 + f*(13 - 13*C) + 429*g2) + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(3003*d**2*k3**4) + 8*D1**2*Pk2*Pk3*ct**2*k1**2*st**4*(D1**2*(132*bd1*fd*g2*s*(s - 1) + f**3*s**2*(-90*bd1 + 45*bdd1) + 10*f**2*(fd*(s**2*(27*bd1 - 6) + s*(4 - 9*bd1) - 2) + fdd*(3*s**2 - 2*s + 1)) + 2*f*s*(10*fd**2*(3*s - 2) + s*(-33*K*bd1**2 + 33*bd1**2 - 66*bd1*g2 + 66*bd1*gd2 + 33*bdd1*g2))) + 2*D1*f*(Dd*(66*bd1*g2*s*(4*s - 1) + 5*f**2*(s**2*(36*bd1 - 8) + s*(4 - 9*bd1) - 2) + 10*f*fd*(12*s**2 - 7*s + 1)) + 5*Ddd*f**2*(4*s**2 - 2*s + 1)) + 60*Dd**2*f**3*s*(2*s - 1) + 33*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 3*b1*(D1**2*(15*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*f*s*(fd**2*(30 - 45*s) - s*(-11*K*bdd1 + 22*bd1*(K - 1) + 11*bdd1 - 22*gd2 + 11*gdd2)) + (22*s - 22)*(2*fd*g2*(s - 1) - 2*fd*s*(-K*bd1 + bd1 + gd2) - fdd*g2*(s - 1))) + D1*(2*Dd*(15*f**3*(4*s**2 - 2*s + 1) - 15*f**2*fd*(12*s**2 - 7*s + 1) + 22*f*(g2*(4*s**2 - 2*s + 1) - s*(4*s - 1)*(-K*bd1 + bd1 + gd2)) - 22*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(15*f**2 + 22*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(15*f**2 + 22*g2)*(2*s - 1)))/(77*d**2*k2**2*k3**2) + 2*D1**2*Pk2*Pk3*ct**2*k1**2*st**2*(1200*C*D1**2*f**2*fd*s**2 - 800*C*D1**2*f**2*fd*s + 400*C*D1**2*f**2*fd - 600*C*D1**2*f**2*fdd*s**2 + 400*C*D1**2*f**2*fdd*s - 200*C*D1**2*f**2*fdd - 1200*C*D1**2*f*fd**2*s**2 + 800*C*D1**2*f*fd**2*s + 1600*C*D1*Dd*f**3*s**2 - 800*C*D1*Dd*f**3*s + 400*C*D1*Dd*f**3 - 4800*C*D1*Dd*f**2*fd*s**2 + 2800*C*D1*Dd*f**2*fd*s - 400*C*D1*Dd*f**2*fd - 800*C*D1*Ddd*f**3*s**2 + 400*C*D1*Ddd*f**3*s - 200*C*D1*Ddd*f**3 - 2400*C*Dd**2*f**3*s**2 + 1200*C*Dd**2*f**3*s + 528*D1**2*b2*f*fd*s**2 - 528*D1**2*b2*f*fd*s + 264*D1**2*b2*f*fd - 264*D1**2*b2*f*fdd*s**2 + 264*D1**2*b2*f*fdd*s - 132*D1**2*b2*f*fdd - 264*D1**2*b2*fd**2*s**2 + 264*D1**2*b2*fd**2*s + 22*D1**2*bd1**2*s*(12*f**2*(2*s - 3) + f*(4*C*(s - 1) + 23*K*s - 15*s - 8) + 28*g2*(s - 1)) + 264*D1**2*bd2*f**2*s**2 - 528*D1**2*bd2*f*fd*s**2 + 264*D1**2*bd2*f*fd*s - 22*D1**2*bdd1*f*(9*f**2*s*(4*r + 9*s - 2) + f*(12*r*s + s**2*(17*C + 6*K + 10) - 6) + 23*g2*s**2) - 132*D1**2*bdd2*f**2*s**2 + 924*D1**2*f**2*fd*r*s - 308*D1**2*f**2*fd*r + 2382*D1**2*f**2*fd*s**2 - 1896*D1**2*f**2*fd*s + 794*D1**2*f**2*fd - 792*D1**2*f**2*fdd*r*s + 264*D1**2*f**2*fdd*r - 1686*D1**2*f**2*fdd*s**2 + 1388*D1**2*f**2*fdd*s - 562*D1**2*f**2*fdd - 528*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gdd2*s**2 - 1584*D1**2*f*fd**2*r*s + 528*D1**2*f*fd**2*r - 3372*D1**2*f*fd**2*s**2 + 2776*D1**2*f*fd**2*s - 264*D1**2*f*fd**2 - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 + 1056*D1**2*f*fd*gd2*s**2 - 528*D1**2*f*fd*gd2*s + 528*D1**2*f*fdd*g2*s**2 - 528*D1**2*f*fdd*g2*s + 264*D1**2*f*fdd*g2 + 528*D1**2*fd**2*g2*s**2 - 528*D1**2*fd**2*g2*s + 1056*D1*Dd*b2*f**2*s**2 - 528*D1*Dd*b2*f**2*s + 264*D1*Dd*b2*f**2 - 2112*D1*Dd*b2*f*fd*s**2 + 1584*D1*Dd*b2*f*fd*s - 264*D1*Dd*b2*f*fd - 1056*D1*Dd*bd2*f**2*s**2 + 264*D1*Dd*bd2*f**2*s + 1232*D1*Dd*f**3*r*s - 308*D1*Dd*f**3*r + 3176*D1*Dd*f**3*s**2 - 2204*D1*Dd*f**3*s + 794*D1*Dd*f**3 - 6336*D1*Dd*f**2*fd*r*s + 1848*D1*Dd*f**2*fd*r - 13488*D1*Dd*f**2*fd*s**2 + 10508*D1*Dd*f**2*fd*s - 1916*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s - 528*D1*Dd*f**2*g2 + 2112*D1*Dd*f**2*gd2*s**2 - 528*D1*Dd*f**2*gd2*s + 4224*D1*Dd*f*fd*g2*s**2 - 3168*D1*Dd*f*fd*g2*s + 528*D1*Dd*f*fd*g2 - 528*D1*Ddd*b2*f**2*s**2 + 264*D1*Ddd*b2*f**2*s - 132*D1*Ddd*b2*f**2 - 1056*D1*Ddd*f**3*r*s + 264*D1*Ddd*f**3*r - 2248*D1*Ddd*f**3*s**2 + 1652*D1*Ddd*f**3*s - 562*D1*Ddd*f**3 + 1056*D1*Ddd*f**2*g2*s**2 - 528*D1*Ddd*f**2*g2*s + 264*D1*Ddd*f**2*g2 + 22*D1*bd1*(D1*(9*f**3*s*(4*r + 13*s - 2) + f**2*(-18*fd*(2*r*(6*s - 1) + 27*s**2 - 15*s + 1) + s**2*(29*C + 12*K + 10) + s*(18*r + 6) - 12) + f*(-2*fd*(6*r*(4*s - 1) + s**2*(34*C + 12*K + 20) - s*(17*C + 6*K + 16) + 6) + s**2*(11*g2 - 46*gd2)) - 46*fd*g2*s*(s - 1)) - 2*Dd*f*(9*f**2*(2*r*(8*s - 1) + 36*s**2 - 17*s + 1) + f*(6*r*(8*s - 1) + s*(68*C*s - 17*C + 24*K*s - 6*K + 40*s - 22)) + 23*g2*s*(4*s - 1))) - 1584*Dd**2*b2*f**2*s**2 + 792*Dd**2*b2*f**2*s - 3168*Dd**2*f**3*r*s + 792*Dd**2*f**3*r - 6744*Dd**2*f**3*s**2 + 4956*Dd**2*f**3*s - 528*Dd**2*f**3 + 3168*Dd**2*f**2*g2*s**2 - 1584*Dd**2*f**2*g2*s + 154*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 11*b1**2*(-8*C*D1**2*fd*s**2 + 4*C*D1**2*fdd*s**2 - 32*C*D1*Dd*f*s**2 + 16*C*D1*Dd*f*s - 8*C*D1*Dd*f + 32*C*D1*Dd*fd*s**2 - 8*C*D1*Dd*fd*s + 16*C*D1*Ddd*f*s**2 - 8*C*D1*Ddd*f*s + 4*C*D1*Ddd*f + 48*C*Dd**2*f*s**2 - 24*C*Dd**2*f*s - 11*D1**2*K*fd*s**2 + 22*D1**2*K*fd*s - 11*D1**2*K*fd + 23*D1**2*K*fdd*s**2 - 46*D1**2*K*fdd*s + 23*D1**2*K*fdd - 14*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) - 96*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s + 24*D1**2*f*fd + 48*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s - 12*D1**2*f*fdd + 48*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s - 5*D1**2*fd*s**2 - 22*D1**2*fd*s + 11*D1**2*fd - 15*D1**2*fdd*s**2 + 46*D1**2*fdd*s - 23*D1**2*fdd - 56*D1**2*gd2*s**2 + 28*D1**2*gdd2*s**2 - 44*D1*Dd*K*f*s**2 + 22*D1*Dd*K*f*s - 11*D1*Dd*K*f + 184*D1*Dd*K*fd*s**2 - 230*D1*Dd*K*fd*s + 46*D1*Dd*K*fd - 192*D1*Dd*f**2*s**2 + 96*D1*Dd*f**2*s - 48*D1*Dd*f**2 + 384*D1*Dd*f*fd*s**2 - 24*D1*Dd*f*fd - 20*D1*Dd*f*s**2 + 10*D1*Dd*f*s - 5*D1*Dd*f - 120*D1*Dd*fd*s**2 + 214*D1*Dd*fd*s - 46*D1*Dd*fd - 224*D1*Dd*g2*s**2 + 112*D1*Dd*g2*s - 56*D1*Dd*g2 + 224*D1*Dd*gd2*s**2 - 56*D1*Dd*gd2*s + 92*D1*Ddd*K*f*s**2 - 46*D1*Ddd*K*f*s + 23*D1*Ddd*K*f + 96*D1*Ddd*f**2*s**2 - 48*D1*Ddd*f**2*s + 24*D1*Ddd*f**2 - 60*D1*Ddd*f*s**2 + 30*D1*Ddd*f*s - 15*D1*Ddd*f + 112*D1*Ddd*g2*s**2 - 56*D1*Ddd*g2*s + 28*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) + 276*Dd**2*K*f*s**2 - 138*Dd**2*K*f*s + 288*Dd**2*f**2*s**2 - 144*Dd**2*f**2*s - 180*Dd**2*f*s**2 + 90*Dd**2*f*s + 336*Dd**2*g2*s**2 - 168*Dd**2*g2*s) - 22*b1*(-58*C*D1**2*f*fd*s**2 + 58*C*D1**2*f*fd*s - 29*C*D1**2*f*fd + 34*C*D1**2*f*fdd*s**2 - 34*C*D1**2*f*fdd*s + 17*C*D1**2*f*fdd + 34*C*D1**2*fd**2*s**2 - 34*C*D1**2*fd**2*s - 116*C*D1*Dd*f**2*s**2 + 58*C*D1*Dd*f**2*s - 29*C*D1*Dd*f**2 + 272*C*D1*Dd*f*fd*s**2 - 204*C*D1*Dd*f*fd*s + 34*C*D1*Dd*f*fd + 68*C*D1*Ddd*f**2*s**2 - 34*C*D1*Ddd*f**2*s + 17*C*D1*Ddd*f**2 + 204*C*Dd**2*f**2*s**2 - 102*C*Dd**2*f**2*s - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 12*D1**2*K*f*fdd*s**2 - 12*D1**2*K*f*fdd*s + 6*D1**2*K*f*fdd + 12*D1**2*K*fd**2*s**2 - 12*D1**2*K*fd**2*s + 14*D1**2*bd1**2*s*(K - 1)*(3*s - 2) - D1**2*bdd1*(6*f**2*(4*s**2 - 6*s + 3) + f*(C*(4*s**2 - 4*s + 2) + s**2*(23*K - 15) - 8*s + 4) + 14*g2*(2*s**2 - 2*s + 1)) - 108*D1**2*f**2*fd*r*s + 36*D1**2*f**2*fd*r - 351*D1**2*f**2*fd*s**2 + 288*D1**2*f**2*fd*s - 117*D1**2*f**2*fd + 108*D1**2*f**2*fdd*r*s - 36*D1**2*f**2*fdd*r + 243*D1**2*f**2*fdd*s**2 - 216*D1**2*f**2*fdd*s + 81*D1**2*f**2*fdd + 216*D1**2*f*fd**2*r*s - 72*D1**2*f*fd**2*r + 486*D1**2*f*fd**2*s**2 - 432*D1**2*f*fd**2*s + 54*D1**2*f*fd**2 - 36*D1**2*f*fd*r*s + 18*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 44*D1**2*f*fd*s - 22*D1**2*f*fd + 24*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 20*D1**2*f*fdd*s**2 - 32*D1**2*f*fdd*s + 16*D1**2*f*fdd - 11*D1**2*f*gd2*s**2 + 23*D1**2*f*gdd2*s**2 + 24*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 20*D1**2*fd**2*s**2 - 32*D1**2*fd**2*s - 11*D1**2*fd*g2*s**2 + 22*D1**2*fd*g2*s - 11*D1**2*fd*g2 + 46*D1**2*fd*gd2*s**2 - 46*D1**2*fd*gd2*s + 23*D1**2*fdd*g2*s**2 - 46*D1**2*fdd*g2*s + 23*D1**2*fdd*g2 - 48*D1*Dd*K*f**2*s**2 + 24*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 96*D1*Dd*K*f*fd*s**2 - 72*D1*Dd*K*f*fd*s + 12*D1*Dd*K*f*fd - 144*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 468*D1*Dd*f**3*s**2 + 306*D1*Dd*f**3*s - 117*D1*Dd*f**3 + 864*D1*Dd*f**2*fd*r*s - 252*D1*Dd*f**2*fd*r + 1944*D1*Dd*f**2*fd*s**2 - 1566*D1*Dd*f**2*fd*s + 288*D1*Dd*f**2*fd - 72*D1*Dd*f**2*r*s + 18*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 56*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r + 160*D1*Dd*f*fd*s**2 - 216*D1*Dd*f*fd*s + 56*D1*Dd*f*fd - 44*D1*Dd*f*g2*s**2 + 22*D1*Dd*f*g2*s - 11*D1*Dd*f*g2 + 184*D1*Dd*f*gd2*s**2 - 46*D1*Dd*f*gd2*s + 184*D1*Dd*fd*g2*s**2 - 230*D1*Dd*fd*g2*s + 46*D1*Dd*fd*g2 + 24*D1*Ddd*K*f**2*s**2 - 12*D1*Ddd*K*f**2*s + 6*D1*Ddd*K*f**2 + 144*D1*Ddd*f**3*r*s - 36*D1*Ddd*f**3*r + 324*D1*Ddd*f**3*s**2 - 234*D1*Ddd*f**3*s + 81*D1*Ddd*f**3 + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 44*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 + 92*D1*Ddd*f*g2*s**2 - 46*D1*Ddd*f*g2*s + 23*D1*Ddd*f*g2 + D1*bd1*(D1*(12*f**2*(4*s**2 - 6*s + 3) + f*(C*(8*s**2 - 8*s + 4) + s**2*(11*K - 96*fd + 5) + s*(48*fd - 16) + 8) + 2*fd*s*(C*(2 - 4*s) - 23*K*(s - 1) + 15*s - 19) + 28*g2*(2*s**2 - 2*s + 1) + 28*gd2*s*(1 - 2*s)) - 2*Dd*(4*s - 1)*(6*f**2*(4*s - 3) + f*(C*(4*s - 2) + 23*K*s - 15*s - 4) + 14*g2*(2*s - 1))) + 72*Dd**2*K*f**2*s**2 - 36*Dd**2*K*f**2*s + 432*Dd**2*f**3*r*s - 108*Dd**2*f**3*r + 972*Dd**2*f**3*s**2 - 702*Dd**2*f**3*s + 72*Dd**2*f**3 + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 132*Dd**2*f**2*s + 24*Dd**2*f**2 + 276*Dd**2*f*g2*s**2 - 138*Dd**2*f*g2*s))/(231*d**2*k2**2*k3**2) + 2*D1**2*Pk2*Pk3*ct**2*k1**2*(2376*C*D1**2*bdd1*f**2*s**2 - 6930*C*D1**2*f**2*fd*s**2 + 4620*C*D1**2*f**2*fd*s - 2310*C*D1**2*f**2*fd + 4950*C*D1**2*f**2*fdd*s**2 - 3300*C*D1**2*f**2*fdd*s + 1650*C*D1**2*f**2*fdd + 9900*C*D1**2*f*fd**2*s**2 - 6600*C*D1**2*f*fd**2*s - 9240*C*D1*Dd*f**3*s**2 + 4620*C*D1*Dd*f**3*s - 2310*C*D1*Dd*f**3 + 39600*C*D1*Dd*f**2*fd*s**2 - 23100*C*D1*Dd*f**2*fd*s + 3300*C*D1*Dd*f**2*fd + 6600*C*D1*Ddd*f**3*s**2 - 3300*C*D1*Ddd*f**3*s + 1650*C*D1*Ddd*f**3 + 19800*C*Dd**2*f**3*s**2 - 9900*C*Dd**2*f**3*s + 990*D1**2*K*bdd1*f**2*s**2 - 2772*D1**2*b2*f*fd*s**2 + 2772*D1**2*b2*f*fd*s - 1386*D1**2*b2*f*fd + 1980*D1**2*b2*f*fdd*s**2 - 1980*D1**2*b2*f*fdd*s + 990*D1**2*b2*f*fdd + 1980*D1**2*b2*fd**2*s**2 - 1980*D1**2*b2*fd**2*s - 132*D1**2*bd1**2*(3*f**2*(6*r*(2*s - 1) + 10*s**2 - 18*s + 3) + f*(10*r*(2*s - 1) + s**2*(31*C - 17*K + 19) - s*(31*C + 12) + 10) - 28*g2*s*(s - 1)) - 1386*D1**2*bd2*f**2*s**2 + 3960*D1**2*bd2*f*fd*s**2 - 1980*D1**2*bd2*f*fd*s + 3564*D1**2*bdd1*f**3*r*s + 3564*D1**2*bdd1*f**3*s**2 - 1782*D1**2*bdd1*f**3*s + 660*D1**2*bdd1*f**2*r*s + 1254*D1**2*bdd1*f**2*r - 1650*D1**2*bdd1*f**2*s**2 + 1782*D1**2*bdd1*f**2*s - 1848*D1**2*bdd1*f**2 - 2244*D1**2*bdd1*f*g2*s**2 + 990*D1**2*bdd2*f**2*s**2 - 6537*D1**2*f**2*fd*r*s + 2179*D1**2*f**2*fd*r - 3069*D1**2*f**2*fd*s**2 + 4225*D1**2*f**2*fd*s - 1023*D1**2*f**2*fd + 5397*D1**2*f**2*fdd*r*s - 1799*D1**2*f**2*fdd*r + 4059*D1**2*f**2*fdd*s**2 - 4505*D1**2*f**2*fdd*s + 1353*D1**2*f**2*fdd + 2772*D1**2*f**2*gd2*s**2 - 1980*D1**2*f**2*gdd2*s**2 + 10794*D1**2*f*fd**2*r*s - 3598*D1**2*f*fd**2*r + 8118*D1**2*f*fd**2*s**2 - 9010*D1**2*f*fd**2*s + 1799*D1**2*f*fd**2 + 5544*D1**2*f*fd*g2*s**2 - 5544*D1**2*f*fd*g2*s + 2772*D1**2*f*fd*g2 - 7920*D1**2*f*fd*gd2*s**2 + 3960*D1**2*f*fd*gd2*s - 3960*D1**2*f*fdd*g2*s**2 + 3960*D1**2*f*fdd*g2*s - 1980*D1**2*f*fdd*g2 - 3960*D1**2*fd**2*g2*s**2 + 3960*D1**2*fd**2*g2*s - 5544*D1*Dd*b2*f**2*s**2 + 2772*D1*Dd*b2*f**2*s - 1386*D1*Dd*b2*f**2 + 15840*D1*Dd*b2*f*fd*s**2 - 11880*D1*Dd*b2*f*fd*s + 1980*D1*Dd*b2*f*fd + 7920*D1*Dd*bd2*f**2*s**2 - 1980*D1*Dd*bd2*f**2*s - 8716*D1*Dd*f**3*r*s + 2179*D1*Dd*f**3*r - 4092*D1*Dd*f**3*s**2 + 6404*D1*Dd*f**3*s - 1023*D1*Dd*f**3 + 43176*D1*Dd*f**2*fd*r*s - 12593*D1*Dd*f**2*fd*r + 32472*D1*Dd*f**2*fd*s**2 - 36932*D1*Dd*f**2*fd*s + 8103*D1*Dd*f**2*fd + 11088*D1*Dd*f**2*g2*s**2 - 5544*D1*Dd*f**2*g2*s + 2772*D1*Dd*f**2*g2 - 15840*D1*Dd*f**2*gd2*s**2 + 3960*D1*Dd*f**2*gd2*s - 31680*D1*Dd*f*fd*g2*s**2 + 23760*D1*Dd*f*fd*g2*s - 3960*D1*Dd*f*fd*g2 + 3960*D1*Ddd*b2*f**2*s**2 - 1980*D1*Ddd*b2*f**2*s + 990*D1*Ddd*b2*f**2 + 7196*D1*Ddd*f**3*r*s - 1799*D1*Ddd*f**3*r + 5412*D1*Ddd*f**3*s**2 - 6304*D1*Ddd*f**3*s + 1353*D1*Ddd*f**3 - 7920*D1*Ddd*f**2*g2*s**2 + 3960*D1*Ddd*f**2*g2*s - 1980*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(27*f**3*s*(2*r + 2*s - 1) + f**2*(35*C*s**2 + 21*K*s**2 - 27*fd*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + r*(9*s + 26) - 34*s**2 + 41*s - 38) - f*(fd*(r*(40*s + 9) + s**2*(144*C + 60*K - 100) + s*(-72*C - 30*K + 67) + 10) + s**2*(33*g2 - 68*gd2)) + 68*fd*g2*s*(s - 1)) - Dd*f*(27*f**2*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + f*(r*(80*s + 66) + s**2*(288*C + 120*K - 200) - s*(72*C + 30*K - 138) - 65) + 68*g2*s*(1 - 4*s))) + 11880*Dd**2*b2*f**2*s**2 - 5940*Dd**2*b2*f**2*s + 21588*Dd**2*f**3*r*s - 5397*Dd**2*f**3*r + 16236*Dd**2*f**3*s**2 - 18912*Dd**2*f**3*s + 3598*Dd**2*f**3 - 23760*Dd**2*f**2*g2*s**2 + 11880*Dd**2*f**2*g2*s + 924*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 33*b1**2*(82*C*D1**2*fd*s**2 - 62*C*D1**2*fdd*s**2 + 328*C*D1*Dd*f*s**2 - 164*C*D1*Dd*f*s + 82*C*D1*Dd*f - 496*C*D1*Dd*fd*s**2 + 124*C*D1*Dd*fd*s - 248*C*D1*Ddd*f*s**2 + 124*C*D1*Ddd*f*s - 62*C*D1*Ddd*f - 744*C*Dd**2*f*s**2 + 372*C*Dd**2*f*s - 33*D1**2*K*fd*s**2 + 66*D1**2*K*fd*s - 33*D1**2*K*fd + 34*D1**2*K*fdd*s**2 - 68*D1**2*K*fdd*s + 34*D1**2*K*fdd - 28*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) + 144*D1**2*f*fd*r*s + 168*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s - 42*D1**2*f*fd - 144*D1**2*f*fdd*r*s - 120*D1**2*f*fdd*s**2 + 48*D1**2*f*fdd*s + 30*D1**2*f*fdd - 144*D1**2*fd**2*r*s - 120*D1**2*fd**2*s**2 + 48*D1**2*fd**2*s + 52*D1**2*fd*r*s + 41*D1**2*fd*s**2 - 66*D1**2*fd*s + 33*D1**2*fd - 40*D1**2*fdd*r*s - 38*D1**2*fdd*s**2 + 68*D1**2*fdd*s - 34*D1**2*fdd - 112*D1**2*gd2*s**2 + 56*D1**2*gdd2*s**2 - 132*D1*Dd*K*f*s**2 + 66*D1*Dd*K*f*s - 33*D1*Dd*K*f + 272*D1*Dd*K*fd*s**2 - 340*D1*Dd*K*fd*s + 68*D1*Dd*K*fd + 288*D1*Dd*f**2*r*s - 72*D1*Dd*f**2*r + 336*D1*Dd*f**2*s**2 - 312*D1*Dd*f**2*s + 84*D1*Dd*f**2 - 1152*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*r - 960*D1*Dd*f*fd*s**2 + 720*D1*Dd*f*fd*s - 48*D1*Dd*f*fd + 208*D1*Dd*f*r*s - 52*D1*Dd*f*r + 164*D1*Dd*f*s**2 - 186*D1*Dd*f*s + 41*D1*Dd*f - 320*D1*Dd*fd*r*s + 40*D1*Dd*fd*r - 304*D1*Dd*fd*s**2 + 428*D1*Dd*fd*s - 68*D1*Dd*fd - 448*D1*Dd*g2*s**2 + 224*D1*Dd*g2*s - 112*D1*Dd*g2 + 448*D1*Dd*gd2*s**2 - 112*D1*Dd*gd2*s + 136*D1*Ddd*K*f*s**2 - 68*D1*Ddd*K*f*s + 34*D1*Ddd*K*f - 288*D1*Ddd*f**2*r*s + 72*D1*Ddd*f**2*r - 240*D1*Ddd*f**2*s**2 + 264*D1*Ddd*f**2*s - 60*D1*Ddd*f**2 - 160*D1*Ddd*f*r*s + 40*D1*Ddd*f*r - 152*D1*Ddd*f*s**2 + 156*D1*Ddd*f*s - 38*D1*Ddd*f + 224*D1*Ddd*g2*s**2 - 112*D1*Ddd*g2*s + 56*D1*Ddd*g2 + 56*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) + 408*Dd**2*K*f*s**2 - 204*Dd**2*K*f*s - 864*Dd**2*f**2*r*s + 216*Dd**2*f**2*r - 720*Dd**2*f**2*s**2 + 792*Dd**2*f**2*s - 144*Dd**2*f**2 - 480*Dd**2*f*r*s + 120*Dd**2*f*r - 456*Dd**2*f*s**2 + 468*Dd**2*f*s - 80*Dd**2*f + 672*Dd**2*g2*s**2 - 336*Dd**2*g2*s) - 66*b1*(70*C*D1**2*f*fd*s**2 - 70*C*D1**2*f*fd*s + 35*C*D1**2*f*fd - 72*C*D1**2*f*fdd*s**2 + 72*C*D1**2*f*fdd*s - 36*C*D1**2*f*fdd - 72*C*D1**2*fd**2*s**2 + 72*C*D1**2*fd**2*s + 140*C*D1*Dd*f**2*s**2 - 70*C*D1*Dd*f**2*s + 35*C*D1*Dd*f**2 - 576*C*D1*Dd*f*fd*s**2 + 432*C*D1*Dd*f*fd*s - 72*C*D1*Dd*f*fd - 144*C*D1*Ddd*f**2*s**2 + 72*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 432*C*Dd**2*f**2*s**2 + 216*C*Dd**2*f**2*s + 42*D1**2*K*f*fd*s**2 - 42*D1**2*K*f*fd*s + 21*D1**2*K*f*fd - 30*D1**2*K*f*fdd*s**2 + 30*D1**2*K*f*fdd*s - 15*D1**2*K*f*fdd - 30*D1**2*K*fd**2*s**2 + 30*D1**2*K*fd**2*s + 28*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + D1**2*bdd1*(3*f**2*(12*r*(2*s - 1) + 20*s**2 - 36*s + 15) + f*(31*C*(2*s**2 - 2*s + 1) - 34*K*s**2 + 40*r*s - 20*r + 38*s**2 - 24*s + 2) - 28*g2*(2*s**2 - 2*s + 1)) + 162*D1**2*f**2*fd*r*s - 54*D1**2*f**2*fd*r + 162*D1**2*f**2*fd*s**2 - 189*D1**2*f**2*fd*s + 54*D1**2*f**2*fd - 162*D1**2*f**2*fdd*r*s + 54*D1**2*f**2*fdd*r - 162*D1**2*f**2*fdd*s**2 + 189*D1**2*f**2*fdd*s - 54*D1**2*f**2*fdd - 324*D1**2*f*fd**2*r*s + 108*D1**2*f*fd**2*r - 324*D1**2*f*fd**2*s**2 + 378*D1**2*f*fd**2*s - 81*D1**2*f*fd**2 + 18*D1**2*f*fd*r*s - 35*D1**2*f*fd*r - 68*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s + 4*D1**2*f*fd - 20*D1**2*f*fdd*r*s + 29*D1**2*f*fdd*r + 50*D1**2*f*fdd*s**2 - 13*D1**2*f*fdd*s - 3*D1**2*f*fdd - 33*D1**2*f*gd2*s**2 + 34*D1**2*f*gdd2*s**2 - 20*D1**2*fd**2*r*s + 29*D1**2*fd**2*r + 50*D1**2*fd**2*s**2 - 13*D1**2*fd**2*s - 33*D1**2*fd*g2*s**2 + 66*D1**2*fd*g2*s - 33*D1**2*fd*g2 + 68*D1**2*fd*gd2*s**2 - 68*D1**2*fd*gd2*s + 34*D1**2*fdd*g2*s**2 - 68*D1**2*fdd*g2*s + 34*D1**2*fdd*g2 + 84*D1*Dd*K*f**2*s**2 - 42*D1*Dd*K*f**2*s + 21*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*s**2 + 180*D1*Dd*K*f*fd*s - 30*D1*Dd*K*f*fd + 216*D1*Dd*f**3*r*s - 54*D1*Dd*f**3*r + 216*D1*Dd*f**3*s**2 - 216*D1*Dd*f**3*s + 54*D1*Dd*f**3 - 1296*D1*Dd*f**2*fd*r*s + 378*D1*Dd*f**2*fd*r - 1296*D1*Dd*f**2*fd*s**2 + 1404*D1*Dd*f**2*fd*s - 297*D1*Dd*f**2*fd + 36*D1*Dd*f**2*r*s - 9*D1*Dd*f**2*r - 136*D1*Dd*f**2*s**2 + 50*D1*Dd*f**2*s - 34*D1*Dd*f**2 - 160*D1*Dd*f*fd*r*s + 136*D1*Dd*f*fd*r + 400*D1*Dd*f*fd*s**2 - 112*D1*Dd*f*fd*s - 45*D1*Dd*f*fd - 132*D1*Dd*f*g2*s**2 + 66*D1*Dd*f*g2*s - 33*D1*Dd*f*g2 + 272*D1*Dd*f*gd2*s**2 - 68*D1*Dd*f*gd2*s + 272*D1*Dd*fd*g2*s**2 - 340*D1*Dd*fd*g2*s + 68*D1*Dd*fd*g2 - 60*D1*Ddd*K*f**2*s**2 + 30*D1*Ddd*K*f**2*s - 15*D1*Ddd*K*f**2 - 216*D1*Ddd*f**3*r*s + 54*D1*Ddd*f**3*r - 216*D1*Ddd*f**3*s**2 + 216*D1*Ddd*f**3*s - 54*D1*Ddd*f**3 - 40*D1*Ddd*f**2*r*s + 10*D1*Ddd*f**2*r + 100*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 25*D1*Ddd*f**2 + 136*D1*Ddd*f*g2*s**2 - 68*D1*Ddd*f*g2*s + 34*D1*Ddd*f*g2 + D1*bd1*(D1*(-3*f**2*(12*r*(2*s - 1) + 28*s**2 - 48*s + 21) + f*(-41*C*(2*s**2 - 2*s + 1) + 33*K*s**2 + 6*fd*(48*r*s - 12*r + 40*s**2 - 44*s + 9) - 52*r*s + 26*r - 41*s**2 + 34*s - 4) + 20*fd*r*(4*s - 1) + 2*fd*s*(31*C*(2*s - 1) - 34*K*(s - 1) + 38*s - 46) + 56*g2*(2*s**2 - 2*s + 1) + 56*gd2*s*(1 - 2*s)) + 2*Dd*(6*f**2*(6*r*(8*s - 3) + 40*s**2 - 58*s + 15) + f*(31*C*(8*s**2 - 6*s + 1) + 20*r*(8*s - 3) + s**2*(152 - 136*K) + s*(34*K - 126) + 32) - 28*g2*(8*s**2 - 6*s + 1))) - 180*Dd**2*K*f**2*s**2 + 90*Dd**2*K*f**2*s - 648*Dd**2*f**3*r*s + 162*Dd**2*f**3*r - 648*Dd**2*f**3*s**2 + 648*Dd**2*f**3*s - 108*Dd**2*f**3 - 120*Dd**2*f**2*r*s + 30*Dd**2*f**2*r + 300*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s - 20*Dd**2*f**2 + 408*Dd**2*f*g2*s**2 - 204*Dd**2*f*g2*s))/(693*d**2*k2**2*k3**2) - 24*D1**2*Pk2*Pk3*ct**2*k2**6*st**2*(8*C*D1**2*b1*f*fd*r**2 + 16*C*D1**2*b1*f*fd*r*s - 8*C*D1**2*b1*f*fd*r + 8*C*D1**2*b1*f*fd*s**2 - 8*C*D1**2*b1*f*fd*s + 4*C*D1**2*b1*f*fd - 4*C*D1**2*b1*f*fdd*r**2 - 8*C*D1**2*b1*f*fdd*r*s + 4*C*D1**2*b1*f*fdd*r - 4*C*D1**2*b1*f*fdd*s**2 + 4*C*D1**2*b1*f*fdd*s - 2*C*D1**2*b1*f*fdd - 4*C*D1**2*b1*fd**2*r**2 - 8*C*D1**2*b1*fd**2*r*s + 4*C*D1**2*b1*fd**2*r - 4*C*D1**2*b1*fd**2*s**2 + 4*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 16*C*D1*Dd*b1*f**2*r**2 + 32*C*D1*Dd*b1*f**2*r*s - 24*C*D1*Dd*b1*f**2*r + 16*C*D1*Dd*b1*f**2*s**2 - 24*C*D1*Dd*b1*f**2*s + 12*C*D1*Dd*b1*f**2 - 32*C*D1*Dd*b1*f*fd*r**2 - 64*C*D1*Dd*b1*f*fd*r*s + 40*C*D1*Dd*b1*f*fd*r - 32*C*D1*Dd*b1*f*fd*s**2 + 40*C*D1*Dd*b1*f*fd*s - 12*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 8*C*D1*Ddd*b1*f**2*r**2 - 16*C*D1*Ddd*b1*f**2*r*s + 12*C*D1*Ddd*b1*f**2*r - 8*C*D1*Ddd*b1*f**2*s**2 + 12*C*D1*Ddd*b1*f**2*s - 6*C*D1*Ddd*b1*f**2 - 24*C*Dd**2*b1*f**2*r**2 - 48*C*Dd**2*b1*f**2*r*s + 36*C*Dd**2*b1*f**2*r - 24*C*Dd**2*b1*f**2*s**2 + 36*C*Dd**2*b1*f**2*s - 12*C*Dd**2*b1*f**2 + 2*D1**2*K*b1**2*fd*r**2 + 4*D1**2*K*b1**2*fd*r*s + 2*D1**2*K*b1**2*fd*s**2 - D1**2*K*b1**2*fdd*r**2 - 2*D1**2*K*b1**2*fdd*r*s - D1**2*K*b1**2*fdd*s**2 - 2*D1**2*K*b1*f*fd*r**2 - 4*D1**2*K*b1*f*fd*r*s + 2*D1**2*K*b1*f*fd*r - 2*D1**2*K*b1*f*fd*s**2 + 2*D1**2*K*b1*f*fd*s - D1**2*K*b1*f*fd - 2*D1**2*K*bd1**2*f*(r + s - 1)**2 - 4*D1**2*b1*f*fd*r**2 - 8*D1**2*b1*f*fd*r*s + 4*D1**2*b1*f*fd*r - 4*D1**2*b1*f*fd*s**2 + 4*D1**2*b1*f*fd*s - 2*D1**2*b1*f*fd + 2*D1**2*b1*f*fdd*r**2 + 4*D1**2*b1*f*fdd*r*s - 2*D1**2*b1*f*fdd*r + 2*D1**2*b1*f*fdd*s**2 - 2*D1**2*b1*f*fdd*s + D1**2*b1*f*fdd - 4*D1**2*b1*f*gd2*r**2 - 8*D1**2*b1*f*gd2*r*s + 8*D1**2*b1*f*gd2*r - 4*D1**2*b1*f*gd2*s**2 + 8*D1**2*b1*f*gd2*s - 4*D1**2*b1*f*gd2 + 2*D1**2*b1*f*gdd2*r**2 + 4*D1**2*b1*f*gdd2*r*s - 4*D1**2*b1*f*gdd2*r + 2*D1**2*b1*f*gdd2*s**2 - 4*D1**2*b1*f*gdd2*s + 2*D1**2*b1*f*gdd2 + 2*D1**2*b1*fd**2*r**2 + 4*D1**2*b1*fd**2*r*s - 2*D1**2*b1*fd**2*r + 2*D1**2*b1*fd**2*s**2 - 2*D1**2*b1*fd**2*s - 4*D1**2*b1*fd*g2*r**2 - 8*D1**2*b1*fd*g2*r*s - 4*D1**2*b1*fd*g2*s**2 + 4*D1**2*b1*fd*gd2*r**2 + 8*D1**2*b1*fd*gd2*r*s - 4*D1**2*b1*fd*gd2*r + 4*D1**2*b1*fd*gd2*s**2 - 4*D1**2*b1*fd*gd2*s + 2*D1**2*b1*fdd*g2*r**2 + 4*D1**2*b1*fdd*g2*r*s + 2*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(2*C*f + 2*K*b1 - f - 2*g2) + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd + 2*D1**2*f**2*gd2*r**2 + 4*D1**2*f**2*gd2*r*s - 4*D1**2*f**2*gd2*r + 2*D1**2*f**2*gd2*s**2 - 4*D1**2*f**2*gd2*s + 2*D1**2*f**2*gd2 + 4*D1**2*f*fd*g2*r**2 + 8*D1**2*f*fd*g2*r*s - 4*D1**2*f*fd*g2*r + 4*D1**2*f*fd*g2*s**2 - 4*D1**2*f*fd*g2*s + 2*D1**2*f*fd*g2 + 8*D1*Dd*K*b1**2*f*r**2 + 16*D1*Dd*K*b1**2*f*r*s - 12*D1*Dd*K*b1**2*f*r + 8*D1*Dd*K*b1**2*f*s**2 - 12*D1*Dd*K*b1**2*f*s + 6*D1*Dd*K*b1**2*f - 8*D1*Dd*K*b1**2*fd*r**2 - 16*D1*Dd*K*b1**2*fd*r*s + 6*D1*Dd*K*b1**2*fd*r - 8*D1*Dd*K*b1**2*fd*s**2 + 6*D1*Dd*K*b1**2*fd*s - 4*D1*Dd*K*b1*f**2*r**2 - 8*D1*Dd*K*b1*f**2*r*s + 6*D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s**2 + 6*D1*Dd*K*b1*f**2*s - 3*D1*Dd*K*b1*f**2 - 8*D1*Dd*b1*f**2*r**2 - 16*D1*Dd*b1*f**2*r*s + 12*D1*Dd*b1*f**2*r - 8*D1*Dd*b1*f**2*s**2 + 12*D1*Dd*b1*f**2*s - 6*D1*Dd*b1*f**2 + 16*D1*Dd*b1*f*fd*r**2 + 32*D1*Dd*b1*f*fd*r*s - 20*D1*Dd*b1*f*fd*r + 16*D1*Dd*b1*f*fd*s**2 - 20*D1*Dd*b1*f*fd*s + 6*D1*Dd*b1*f*fd - 16*D1*Dd*b1*f*g2*r**2 - 32*D1*Dd*b1*f*g2*r*s + 24*D1*Dd*b1*f*g2*r - 16*D1*Dd*b1*f*g2*s**2 + 24*D1*Dd*b1*f*g2*s - 12*D1*Dd*b1*f*g2 + 16*D1*Dd*b1*f*gd2*r**2 + 32*D1*Dd*b1*f*gd2*r*s - 28*D1*Dd*b1*f*gd2*r + 16*D1*Dd*b1*f*gd2*s**2 - 28*D1*Dd*b1*f*gd2*s + 12*D1*Dd*b1*f*gd2 + 16*D1*Dd*b1*fd*g2*r**2 + 32*D1*Dd*b1*fd*g2*r*s - 12*D1*Dd*b1*fd*g2*r + 16*D1*Dd*b1*fd*g2*s**2 - 12*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 8*D1*Dd*f**2*g2*r**2 + 16*D1*Dd*f**2*g2*r*s - 12*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s**2 - 12*D1*Dd*f**2*g2*s + 6*D1*Dd*f**2*g2 - 4*D1*Ddd*K*b1**2*f*r**2 - 8*D1*Ddd*K*b1**2*f*r*s + 6*D1*Ddd*K*b1**2*f*r - 4*D1*Ddd*K*b1**2*f*s**2 + 6*D1*Ddd*K*b1**2*f*s - 3*D1*Ddd*K*b1**2*f + 4*D1*Ddd*b1*f**2*r**2 + 8*D1*Ddd*b1*f**2*r*s - 6*D1*Ddd*b1*f**2*r + 4*D1*Ddd*b1*f**2*s**2 - 6*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 8*D1*Ddd*b1*f*g2*r**2 + 16*D1*Ddd*b1*f*g2*r*s - 12*D1*Ddd*b1*f*g2*r + 8*D1*Ddd*b1*f*g2*s**2 - 12*D1*Ddd*b1*f*g2*s + 6*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(4*C - K - 2)*(r + s - 1) - f*fd*(4*C - 2)*(2*r + 2*s - 1) - 4*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 4*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(2*K*b1 + f*(2*C - 1) - 2*g2))*(r + s - 1) - 12*Dd**2*K*b1**2*f*r**2 - 24*Dd**2*K*b1**2*f*r*s + 18*Dd**2*K*b1**2*f*r - 12*Dd**2*K*b1**2*f*s**2 + 18*Dd**2*K*b1**2*f*s - 6*Dd**2*K*b1**2*f + 12*Dd**2*b1*f**2*r**2 + 24*Dd**2*b1*f**2*r*s - 18*Dd**2*b1*f**2*r + 12*Dd**2*b1*f**2*s**2 - 18*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 24*Dd**2*b1*f*g2*r**2 + 48*Dd**2*b1*f*g2*r*s - 36*Dd**2*b1*f*g2*r + 24*Dd**2*b1*f*g2*s**2 - 36*Dd**2*b1*f*g2*s + 12*Dd**2*b1*f*g2)/(7*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct**2*k2**4*st**2*(-352*C*D1**2*bd1*f**2*r**2 - 880*C*D1**2*bd1*f**2*r*s + 1408*C*D1**2*bd1*f**2*r - 528*C*D1**2*bd1*f**2*s**2 + 1584*C*D1**2*bd1*f**2*s - 792*C*D1**2*bd1*f**2 + 1056*C*D1**2*bd1*f*fd*r**2 + 2112*C*D1**2*bd1*f*fd*r*s - 1848*C*D1**2*bd1*f*fd*r + 1056*C*D1**2*bd1*f*fd*s**2 - 1848*C*D1**2*bd1*f*fd*s + 792*C*D1**2*bd1*f*fd + 264*C*D1**2*bdd1*f**2*r**2 + 528*C*D1**2*bdd1*f**2*r*s - 792*C*D1**2*bdd1*f**2*r + 264*C*D1**2*bdd1*f**2*s**2 - 792*C*D1**2*bdd1*f**2*s + 396*C*D1**2*bdd1*f**2 + 234*C*D1**2*f**2*fd*r**2 - 756*C*D1**2*f**2*fd*r*s + 96*C*D1**2*f**2*fd*r - 990*C*D1**2*f**2*fd*s**2 + 912*C*D1**2*f**2*fd*s - 252*C*D1**2*f**2*fd + 1566*C*D1**2*f**2*fdd*r**2 + 3348*C*D1**2*f**2*fdd*r*s - 2160*C*D1**2*f**2*fdd*r + 1782*C*D1**2*f**2*fdd*s**2 - 2304*C*D1**2*f**2*fdd*s + 1116*C*D1**2*f**2*fdd + 3132*C*D1**2*f*fd**2*r**2 + 6696*C*D1**2*f*fd**2*r*s - 4320*C*D1**2*f*fd**2*r + 3564*C*D1**2*f*fd**2*s**2 - 4608*C*D1**2*f*fd**2*s + 1116*C*D1**2*f*fd**2 + 2112*C*D1*Dd*bd1*f**2*r**2 + 4224*C*D1*Dd*bd1*f**2*r*s - 4752*C*D1*Dd*bd1*f**2*r + 2112*C*D1*Dd*bd1*f**2*s**2 - 4752*C*D1*Dd*bd1*f**2*s + 2376*C*D1*Dd*bd1*f**2 + 312*C*D1*Dd*f**3*r**2 - 1008*C*D1*Dd*f**3*r*s - 60*C*D1*Dd*f**3*r - 1320*C*D1*Dd*f**3*s**2 + 1164*C*D1*Dd*f**3*s - 174*C*D1*Dd*f**3 + 12528*C*D1*Dd*f**2*fd*r**2 + 26784*C*D1*Dd*f**2*fd*r*s - 18252*C*D1*Dd*f**2*fd*r + 14256*C*D1*Dd*f**2*fd*s**2 - 19476*C*D1*Dd*f**2*fd*s + 6624*C*D1*Dd*f**2*fd + 2088*C*D1*Ddd*f**3*r**2 + 4464*C*D1*Ddd*f**3*r*s - 3204*C*D1*Ddd*f**3*r + 2376*C*D1*Ddd*f**3*s**2 - 3420*C*D1*Ddd*f**3*s + 1638*C*D1*Ddd*f**3 + 6264*C*Dd**2*f**3*r**2 + 13392*C*Dd**2*f**3*r*s - 9612*C*Dd**2*f**3*r + 7128*C*Dd**2*f**3*s**2 - 10260*C*Dd**2*f**3*s + 3276*C*Dd**2*f**3 + 264*D1**2*K*bd1**2*f*r**2 + 528*D1**2*K*bd1**2*f*r*s - 660*D1**2*K*bd1**2*f*r + 264*D1**2*K*bd1**2*f*s**2 - 660*D1**2*K*bd1**2*f*s + 396*D1**2*K*bd1**2*f + 99*D1**2*K*bd1*f**2*r**2 - 66*D1**2*K*bd1*f**2*r*s - 198*D1**2*K*bd1*f**2*r - 165*D1**2*K*bd1*f**2*s**2 + 66*D1**2*K*bd1*f**2*s + 99*D1**2*K*bd1*f**2 + 660*D1**2*K*bd1*f*fd*r**2 + 1848*D1**2*K*bd1*f*fd*r*s - 1122*D1**2*K*bd1*f*fd*r + 1188*D1**2*K*bd1*f*fd*s**2 - 1518*D1**2*K*bd1*f*fd*s + 462*D1**2*K*bd1*f*fd + 165*D1**2*K*bdd1*f**2*r**2 + 462*D1**2*K*bdd1*f**2*r*s - 330*D1**2*K*bdd1*f**2*r + 297*D1**2*K*bdd1*f**2*s**2 - 462*D1**2*K*bdd1*f**2*s + 165*D1**2*K*bdd1*f**2 - 132*D1**2*bd1**2*f**2*r**2 - 132*D1**2*bd1**2*f**2*r*s + 198*D1**2*bd1**2*f**2*r + 66*D1**2*bd1**2*f**2*s - 66*D1**2*bd1**2*f**2 - 132*D1**2*bd1**2*f*r**2 - 132*D1**2*bd1**2*f*r*s + 198*D1**2*bd1**2*f*r + 66*D1**2*bd1**2*f*s - 66*D1**2*bd1**2*f + 132*D1**2*bd1*bd2*f*r**2 + 264*D1**2*bd1*bd2*f*r*s - 264*D1**2*bd1*bd2*f*r + 132*D1**2*bd1*bd2*f*s**2 - 264*D1**2*bd1*bd2*f*s + 132*D1**2*bd1*bd2*f + 198*D1**2*bd1*f**2*r**2 + 462*D1**2*bd1*f**2*r*s - 660*D1**2*bd1*f**2*r + 264*D1**2*bd1*f**2*s**2 - 726*D1**2*bd1*f**2*s + 330*D1**2*bd1*f**2 - 792*D1**2*bd1*f*fd*r**2 - 1320*D1**2*bd1*f*fd*r*s + 1188*D1**2*bd1*f*fd*r - 528*D1**2*bd1*f*fd*s**2 + 990*D1**2*bd1*f*fd*s - 462*D1**2*bd1*f*fd + 528*D1**2*bd1*f*g2*r**2 + 1056*D1**2*bd1*f*g2*r*s - 1584*D1**2*bd1*f*g2*r + 528*D1**2*bd1*f*g2*s**2 - 1584*D1**2*bd1*f*g2*s + 792*D1**2*bd1*f*g2 - 528*D1**2*bd1*f*gd2*r**2 - 1056*D1**2*bd1*f*gd2*r*s + 1320*D1**2*bd1*f*gd2*r - 528*D1**2*bd1*f*gd2*s**2 + 1320*D1**2*bd1*f*gd2*s - 792*D1**2*bd1*f*gd2 - 528*D1**2*bd1*fd*g2*r**2 - 1056*D1**2*bd1*fd*g2*r*s + 528*D1**2*bd1*fd*g2*r - 528*D1**2*bd1*fd*g2*s**2 + 528*D1**2*bd1*fd*g2*s + 66*D1**2*bd2*f**2*r**2 + 132*D1**2*bd2*f**2*r*s - 132*D1**2*bd2*f**2*r + 66*D1**2*bd2*f**2*s**2 - 132*D1**2*bd2*f**2*s + 66*D1**2*bd2*f**2 - 198*D1**2*bdd1*f**2*r**2 - 330*D1**2*bdd1*f**2*r*s + 462*D1**2*bdd1*f**2*r - 132*D1**2*bdd1*f**2*s**2 + 396*D1**2*bdd1*f**2*s - 198*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r**2 - 528*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r - 264*D1**2*bdd1*f*g2*s**2 + 792*D1**2*bdd1*f*g2*s - 396*D1**2*bdd1*f*g2 - 315*D1**2*f**2*fd*r**2 + 180*D1**2*f**2*fd*r*s + 150*D1**2*f**2*fd*r + 495*D1**2*f**2*fd*s**2 - 390*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 783*D1**2*f**2*fdd*r**2 - 1674*D1**2*f**2*fdd*r*s + 1080*D1**2*f**2*fdd*r - 891*D1**2*f**2*fdd*s**2 + 1152*D1**2*f**2*fdd*s - 558*D1**2*f**2*fdd - 198*D1**2*f**2*gd2*r**2 + 132*D1**2*f**2*gd2*r*s + 396*D1**2*f**2*gd2*r + 330*D1**2*f**2*gd2*s**2 - 132*D1**2*f**2*gd2*s - 198*D1**2*f**2*gd2 - 330*D1**2*f**2*gdd2*r**2 - 924*D1**2*f**2*gdd2*r*s + 660*D1**2*f**2*gdd2*r - 594*D1**2*f**2*gdd2*s**2 + 924*D1**2*f**2*gdd2*s - 330*D1**2*f**2*gdd2 - 1566*D1**2*f*fd**2*r**2 - 3348*D1**2*f*fd**2*r*s + 2160*D1**2*f*fd**2*r - 1782*D1**2*f*fd**2*s**2 + 2304*D1**2*f*fd**2*s - 558*D1**2*f*fd**2 - 396*D1**2*f*fd*g2*r**2 + 264*D1**2*f*fd*g2*r*s - 132*D1**2*f*fd*g2*r + 660*D1**2*f*fd*g2*s**2 - 660*D1**2*f*fd*g2*s + 330*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r**2 - 3696*D1**2*f*fd*gd2*r*s + 2244*D1**2*f*fd*gd2*r - 2376*D1**2*f*fd*gd2*s**2 + 3036*D1**2*f*fd*gd2*s - 924*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r**2 - 1848*D1**2*f*fdd*g2*r*s + 924*D1**2*f*fdd*g2*r - 1188*D1**2*f*fdd*g2*s**2 + 1188*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r**2 - 1848*D1**2*fd**2*g2*r*s + 924*D1**2*fd**2*g2*r - 1188*D1**2*fd**2*g2*s**2 + 1188*D1**2*fd**2*g2*s + 1320*D1*Dd*K*bd1*f**2*r**2 + 3696*D1*Dd*K*bd1*f**2*r*s - 2442*D1*Dd*K*bd1*f**2*r + 2376*D1*Dd*K*bd1*f**2*s**2 - 3366*D1*Dd*K*bd1*f**2*s + 1122*D1*Dd*K*bd1*f**2 - 1584*D1*Dd*bd1*f**2*r**2 - 2640*D1*Dd*bd1*f**2*r*s + 2970*D1*Dd*bd1*f**2*r - 1056*D1*Dd*bd1*f**2*s**2 + 2508*D1*Dd*bd1*f**2*s - 1320*D1*Dd*bd1*f**2 - 2112*D1*Dd*bd1*f*g2*r**2 - 4224*D1*Dd*bd1*f*g2*r*s + 4752*D1*Dd*bd1*f*g2*r - 2112*D1*Dd*bd1*f*g2*s**2 + 4752*D1*Dd*bd1*f*g2*s - 2376*D1*Dd*bd1*f*g2 - 420*D1*Dd*f**3*r**2 + 240*D1*Dd*f**3*r*s + 360*D1*Dd*f**3*r + 660*D1*Dd*f**3*s**2 - 450*D1*Dd*f**3*s - 45*D1*Dd*f**3 - 6264*D1*Dd*f**2*fd*r**2 - 13392*D1*Dd*f**2*fd*r*s + 9126*D1*Dd*f**2*fd*r - 7128*D1*Dd*f**2*fd*s**2 + 9738*D1*Dd*f**2*fd*s - 3312*D1*Dd*f**2*fd - 792*D1*Dd*f**2*g2*r**2 + 528*D1*Dd*f**2*g2*r*s + 660*D1*Dd*f**2*g2*r + 1320*D1*Dd*f**2*g2*s**2 - 924*D1*Dd*f**2*g2*s - 66*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r**2 - 7392*D1*Dd*f**2*gd2*r*s + 4884*D1*Dd*f**2*gd2*r - 4752*D1*Dd*f**2*gd2*s**2 + 6732*D1*Dd*f**2*gd2*s - 2244*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r**2 - 14784*D1*Dd*f*fd*g2*r*s + 8184*D1*Dd*f*fd*g2*r - 9504*D1*Dd*f*fd*g2*s**2 + 10824*D1*Dd*f*fd*g2*s - 3036*D1*Dd*f*fd*g2 - 1044*D1*Ddd*f**3*r**2 - 2232*D1*Ddd*f**3*r*s + 1602*D1*Ddd*f**3*r - 1188*D1*Ddd*f**3*s**2 + 1710*D1*Ddd*f**3*s - 819*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r**2 - 3696*D1*Ddd*f**2*g2*r*s + 2244*D1*Ddd*f**2*g2*r - 2376*D1*Ddd*f**2*g2*s**2 + 3036*D1*Ddd*f**2*g2*s - 1254*D1*Ddd*f**2*g2 - 66*D1*b2*(2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 3132*Dd**2*f**3*r**2 - 6696*Dd**2*f**3*r*s + 4806*Dd**2*f**3*r - 3564*Dd**2*f**3*s**2 + 5130*Dd**2*f**3*s - 1638*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r**2 - 11088*Dd**2*f**2*g2*r*s + 6732*Dd**2*f**2*g2*r - 7128*Dd**2*f**2*g2*s**2 + 9108*Dd**2*f**2*g2*s - 2508*Dd**2*f**2*g2 + 66*b1**2*(D1**2*(-2*K*fd*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-2*r**2 - 2*r*(s - 1) + s) + 2*fd*r*(r + s) + fdd*(K*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) - r*(r + s))) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(2*K*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 11*b1*(-64*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r - 96*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s - 8*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r**2 + 96*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 48*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r**2 + 96*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 48*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 128*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 208*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 256*C*D1*Dd*f**2*s - 112*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r**2 + 768*C*D1*Dd*f*fd*r*s - 384*C*D1*Dd*f*fd*r + 384*C*D1*Dd*f*fd*s**2 - 384*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 + 192*C*D1*Ddd*f**2*r*s - 144*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r**2 + 576*C*Dd**2*f**2*r*s - 432*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 144*C*Dd**2*f**2 + 24*D1**2*K*bdd1*f*r**2 + 48*D1**2*K*bdd1*f*r*s - 60*D1**2*K*bdd1*f*r + 24*D1**2*K*bdd1*f*s**2 - 60*D1**2*K*bdd1*f*s + 30*D1**2*K*bdd1*f + 18*D1**2*K*f*fd*r**2 - 12*D1**2*K*f*fd*r*s + 6*D1**2*K*f*fd*r - 30*D1**2*K*f*fd*s**2 + 30*D1**2*K*f*fd*s - 15*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 + 84*D1**2*K*f*fdd*r*s - 42*D1**2*K*f*fdd*r + 54*D1**2*K*f*fdd*s**2 - 54*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 + 84*D1**2*K*fd**2*r*s - 42*D1**2*K*fd**2*r + 54*D1**2*K*fd**2*s**2 - 54*D1**2*K*fd**2*s - 12*D1**2*b2*fd*r**2 - 24*D1**2*b2*fd*r*s - 12*D1**2*b2*fd*s**2 + 6*D1**2*b2*fdd*r**2 + 12*D1**2*b2*fdd*r*s + 6*D1**2*b2*fdd*s**2 - 12*D1**2*bdd1*f**2*r**2 - 12*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*r + 6*D1**2*bdd1*f**2*s - 6*D1**2*bdd1*f**2 - 12*D1**2*bdd1*f*r**2 - 12*D1**2*bdd1*f*r*s + 18*D1**2*bdd1*f*r + 6*D1**2*bdd1*f*s - 6*D1**2*bdd1*f + 6*D1**2*bdd2*f*r**2 + 12*D1**2*bdd2*f*r*s - 12*D1**2*bdd2*f*r + 6*D1**2*bdd2*f*s**2 - 12*D1**2*bdd2*f*s + 6*D1**2*bdd2*f + 36*D1**2*f*fd*r**2 + 84*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 12*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 24*D1**2*f*fdd*r - 24*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 12*D1**2*f*fdd + 48*D1**2*f*gd2*r**2 + 96*D1**2*f*gd2*r*s - 96*D1**2*f*gd2*r + 48*D1**2*f*gd2*s**2 - 96*D1**2*f*gd2*s + 48*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 24*D1**2*fd**2*r - 24*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 12*D1**2*fd**2 + 48*D1**2*fd*g2*r**2 + 96*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*r + 48*D1**2*fd*g2*s**2 + 48*D1**2*fd*g2*s - 24*D1**2*fd*g2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r - 24*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 + 36*D1*Dd*K*f**2*r**2 - 24*D1*Dd*K*f**2*r*s - 30*D1*Dd*K*f**2*r - 60*D1*Dd*K*f**2*s**2 + 42*D1*Dd*K*f**2*s + 3*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 + 672*D1*Dd*K*f*fd*r*s - 372*D1*Dd*K*f*fd*r + 432*D1*Dd*K*f*fd*s**2 - 492*D1*Dd*K*f*fd*s + 138*D1*Dd*K*f*fd - 48*D1*Dd*b2*f*r**2 - 96*D1*Dd*b2*f*r*s + 72*D1*Dd*b2*f*r - 48*D1*Dd*b2*f*s**2 + 72*D1*Dd*b2*f*s - 36*D1*Dd*b2*f + 48*D1*Dd*b2*fd*r**2 + 96*D1*Dd*b2*fd*r*s - 36*D1*Dd*b2*fd*r + 48*D1*Dd*b2*fd*s**2 - 36*D1*Dd*b2*fd*s + 72*D1*Dd*f**2*r**2 + 168*D1*Dd*f**2*r*s - 114*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 132*D1*Dd*f**2*s + 60*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 192*D1*Dd*f*fd*s**2 + 240*D1*Dd*f*fd*s - 66*D1*Dd*f*fd + 192*D1*Dd*f*g2*r**2 + 384*D1*Dd*f*g2*r*s - 288*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 288*D1*Dd*f*g2*s + 144*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 48*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 48*D1*Dd*fd*g2*s + 72*D1*Dd*fd*g2 + 60*D1*Ddd*K*f**2*r**2 + 168*D1*Ddd*K*f**2*r*s - 102*D1*Ddd*K*f**2*r + 108*D1*Ddd*K*f**2*s**2 - 138*D1*Ddd*K*f**2*s + 57*D1*Ddd*K*f**2 + 24*D1*Ddd*b2*f*r**2 + 48*D1*Ddd*b2*f*r*s - 36*D1*Ddd*b2*f*r + 24*D1*Ddd*b2*f*s**2 - 36*D1*Ddd*b2*f*s + 18*D1*Ddd*b2*f - 72*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 102*D1*Ddd*f**2*r - 48*D1*Ddd*f**2*s**2 + 84*D1*Ddd*f**2*s - 48*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(2*K*(4*r**2 + 2*r*(4*s - 5) + 4*s**2 - 10*s + 5) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(2*K*(4*r**2 + 8*r*s - 3*r + 4*s**2 - 3*s - 1) - 4*r**2 - 4*r*s + 3*r + s)) + Dd*f*(K*(32*r**2 + 64*r*(s - 1) + 32*s**2 - 64*s + 30) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 12*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 180*Dd**2*K*f**2*r**2 + 504*Dd**2*K*f**2*r*s - 306*Dd**2*K*f**2*r + 324*Dd**2*K*f**2*s**2 - 414*Dd**2*K*f**2*s + 114*Dd**2*K*f**2 + 72*Dd**2*b2*f*r**2 + 144*Dd**2*b2*f*r*s - 108*Dd**2*b2*f*r + 72*Dd**2*b2*f*s**2 - 108*Dd**2*b2*f*s + 36*Dd**2*b2*f - 216*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 306*Dd**2*f**2*r - 144*Dd**2*f**2*s**2 + 252*Dd**2*f**2*s - 96*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(231*d**2*k3**6) - 4*D1**2*Pk2*Pk3*ct**2*k2**4*(2*D1*(7*D1*b2*bd1*f*(r + s - 1)**2 + D1*bd1**2*(r + s - 1)*(35*K*f*(r + s - 1) - f*(24*C - 12)*(r + s) + 28*g2*(r + s)) + D1*bdd1*f*(f*(6*C - 3)*(7*r + 5*s - 5) - 35*g2*(r + s - 1))*(r + s - 1) - bd1*(D1*(3*f**2*(2*C*(3*r**2 + 2*r*(s + 1) - s**2 + 6*s - 3) - r**2 - 4*r + s**2 - 6*s + 3) + f*(-fd*(12*C - 6)*(14*r**2 + 24*r*s - 19*r + 10*s**2 - 16*s + 6) + 7*g2*(r**2 + 2*r*(s - 3) + s**2 - 6*s + 3) + 70*gd2*(r + s - 1)**2) + 70*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(-f*(6*C - 3)*(28*r**2 + r*(48*s - 44) + 20*s**2 - 37*s + 17) + 35*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 14*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(14*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(48*C*(r + s - 1)**2 + 7*K*(r**2 + 2*r*(s + 2) + s**2 + 4*s - 2) - 38*r**2 - 62*r*s + 48*r - 24*s**2 + 48*s - 24) + fdd*(-24*C*(r + s - 1)**2 + 35*K*s**2 + r**2*(35*K + 12) + r*(70*K*s + 24*s - 24) + 12*s**2 - 24*s + 12) - 56*gd2*(r + s - 1)**2 + 28*gdd2*(r + s - 1)**2) + D1*(Dd*(f*(48*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 7*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 152*r**2 - 248*r*s + 214*r - 96*s**2 + 172*s - 100) - 2*fd*(4*r + 4*s - 3)*(24*C*(r + s - 1) - 35*K*s - r*(35*K + 12) - 12*s + 12) - 56*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(112*r + 112*s - 84)) + Ddd*(f*(-24*C + 35*K + 12) + 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(-24*C + 35*K + 12) + 28*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*b1*(24*C*D1**2*bdd1*f*r**2 + 48*C*D1**2*bdd1*f*r*s - 24*C*D1**2*bdd1*f*r + 24*C*D1**2*bdd1*f*s**2 - 24*C*D1**2*bdd1*f*s + 12*C*D1**2*bdd1*f + 36*C*D1**2*f*fd*r**2 + 24*C*D1**2*f*fd*r*s - 60*C*D1**2*f*fd*r - 12*C*D1**2*f*fd*s**2 - 36*C*D1**2*f*fd*s + 30*C*D1**2*f*fd - 84*C*D1**2*f*fdd*r**2 - 144*C*D1**2*f*fdd*r*s + 84*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 72*C*D1**2*f*fdd*s - 42*C*D1**2*f*fdd - 84*C*D1**2*fd**2*r**2 - 144*C*D1**2*fd**2*r*s + 84*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 72*C*D1**2*fd**2*s + 72*C*D1*Dd*f**2*r**2 + 48*C*D1*Dd*f**2*r*s - 84*C*D1*Dd*f**2*r - 24*C*D1*Dd*f**2*s**2 - 12*C*D1*Dd*f**2*s + 30*C*D1*Dd*f**2 - 672*C*D1*Dd*f*fd*r**2 - 1152*C*D1*Dd*f*fd*r*s + 816*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 696*C*D1*Dd*f*fd*s - 240*C*D1*Dd*f*fd - 168*C*D1*Ddd*f**2*r**2 - 288*C*D1*Ddd*f**2*r*s + 240*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 204*C*D1*Ddd*f**2*s - 114*C*D1*Ddd*f**2 - 504*C*Dd**2*f**2*r**2 - 864*C*Dd**2*f**2*r*s + 720*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 612*C*Dd**2*f**2*s - 228*C*Dd**2*f**2 + 14*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 35*D1**2*K*bdd1*f*r**2 - 70*D1**2*K*bdd1*f*r*s + 70*D1**2*K*bdd1*f*r - 35*D1**2*K*bdd1*f*s**2 + 70*D1**2*K*bdd1*f*s - 35*D1**2*K*bdd1*f - 7*D1**2*b2*fd*r**2 - 14*D1**2*b2*fd*r*s - 7*D1**2*b2*fd*s**2 - 7*D1**2*bd2*f*(r + s - 1)**2 - 12*D1**2*bdd1*f*r**2 - 24*D1**2*bdd1*f*r*s + 12*D1**2*bdd1*f*r - 12*D1**2*bdd1*f*s**2 + 12*D1**2*bdd1*f*s - 6*D1**2*bdd1*f - 28*D1**2*bdd1*g2*r**2 - 56*D1**2*bdd1*g2*r*s + 28*D1**2*bdd1*g2*r - 28*D1**2*bdd1*g2*s**2 + 28*D1**2*bdd1*g2*s - 14*D1**2*bdd1*g2 - 6*D1**2*f*fd*r**2 + 18*D1**2*f*fd*r + 6*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 9*D1**2*f*fd + 42*D1**2*f*fdd*r**2 + 72*D1**2*f*fdd*r*s - 42*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 21*D1**2*f*fdd + 7*D1**2*f*gd2*r**2 + 14*D1**2*f*gd2*r*s - 14*D1**2*f*gd2*r + 7*D1**2*f*gd2*s**2 - 14*D1**2*f*gd2*s + 7*D1**2*f*gd2 + 35*D1**2*f*gdd2*r**2 + 70*D1**2*f*gdd2*r*s - 70*D1**2*f*gdd2*r + 35*D1**2*f*gdd2*s**2 - 70*D1**2*f*gdd2*s + 35*D1**2*f*gdd2 + 42*D1**2*fd**2*r**2 + 72*D1**2*fd**2*r*s - 42*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s + 7*D1**2*fd*g2*r**2 + 14*D1**2*fd*g2*r*s + 28*D1**2*fd*g2*r + 7*D1**2*fd*g2*s**2 + 28*D1**2*fd*g2*s - 14*D1**2*fd*g2 + 70*D1**2*fd*gd2*r**2 + 140*D1**2*fd*gd2*r*s - 70*D1**2*fd*gd2*r + 70*D1**2*fd*gd2*s**2 - 70*D1**2*fd*gd2*s + 35*D1**2*fdd*g2*r**2 + 70*D1**2*fdd*g2*r*s + 35*D1**2*fdd*g2*s**2 - 28*D1*Dd*b2*f*r**2 - 56*D1*Dd*b2*f*r*s + 42*D1*Dd*b2*f*r - 28*D1*Dd*b2*f*s**2 + 42*D1*Dd*b2*f*s - 21*D1*Dd*b2*f - 12*D1*Dd*f**2*r**2 + 12*D1*Dd*f**2*r + 12*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 336*D1*Dd*f*fd*r**2 + 576*D1*Dd*f*fd*r*s - 408*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 348*D1*Dd*f*fd*s + 120*D1*Dd*f*fd + 28*D1*Dd*f*g2*r**2 + 56*D1*Dd*f*g2*r*s - 42*D1*Dd*f*g2*r + 28*D1*Dd*f*g2*s**2 - 42*D1*Dd*f*g2*s + 21*D1*Dd*f*g2 + 280*D1*Dd*f*gd2*r**2 + 560*D1*Dd*f*gd2*r*s - 490*D1*Dd*f*gd2*r + 280*D1*Dd*f*gd2*s**2 - 490*D1*Dd*f*gd2*s + 210*D1*Dd*f*gd2 + 280*D1*Dd*fd*g2*r**2 + 560*D1*Dd*fd*g2*r*s - 210*D1*Dd*fd*g2*r + 280*D1*Dd*fd*g2*s**2 - 210*D1*Dd*fd*g2*s + 84*D1*Ddd*f**2*r**2 + 144*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 102*D1*Ddd*f**2*s + 57*D1*Ddd*f**2 + 140*D1*Ddd*f*g2*r**2 + 280*D1*Ddd*f*g2*r*s - 210*D1*Ddd*f*g2*r + 140*D1*Ddd*f*g2*s**2 - 210*D1*Ddd*f*g2*s + 105*D1*Ddd*f*g2 - D1*bd1*(D1*(f*(24*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) - 38*r**2 - 62*r*s + 45*r - 24*s**2 + 31*s - 19) + 2*fd*(r + s - 1)*(-12*C*(2*r + 2*s - 1) + 35*K*s + r*(35*K + 12) + 12*s - 6) - 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(12*C*(2*r + 2*s - 1) - 35*K*(r + s - 1) - 12*r - 12*s + 6) - 14*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 252*Dd**2*f**2*r**2 + 432*Dd**2*f**2*r*s - 360*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 306*Dd**2*f**2*s + 114*Dd**2*f**2 + 420*Dd**2*f*g2*r**2 + 840*Dd**2*f*g2*r*s - 630*Dd**2*f*g2*r + 420*Dd**2*f*g2*s**2 - 630*Dd**2*f*g2*s + 210*Dd**2*f*g2))/(21*d**2*k3**6) + 8*D1**2*Pk2*Pk3*ct**2*st**2*(D1*(3*D1*bd1**2*f*s*(-2*K*s - 2*f*r + f - 2*r + 1) - 3*D1*bdd1*f*s*(f*(2*C*s + r - s) + s*(b2 - 2*g2)) + bd1*(D1*(2*f**2*s*(6*C*s + 2*r - 3*s) - 3*f*(fd*r*(4*s - 1) + fd*s*(C*(8*s - 4) - 4*s + 1) + s**2*(-2*b2 + 2*bd2 + 4*g2 - 4*gd2)) - 6*fd*s*(b2 - 2*g2)*(s - 1)) - 3*Dd*f*(f*r*(8*s - 1) + 4*f*s*(C*(4*s - 1) - 2*s) + s*(2*b2 - 4*g2)*(4*s - 1)))) - 3*b1**2*(D1*Dd*(f*(K*(-8*s**2 + 4*s - 2) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(2*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(2*s - 1) - s + 1) + fd*(-2*K*(s - 1)**2 + f*s + r*(-2*f*s + f - 2*s + 2)) + fdd*(K*(s - 1)**2 - f*s + r*(2*f*s - f + s - 1))) + Ddd*f*(K*(4*s**2 - 2*s + 1) + (f + 1)*(r*(4*s - 1) - 2*s))) + Dd**2*f*(12*K*s**2 - 6*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(24*C*D1**2*f*fd*s**2 - 24*C*D1**2*f*fd*s + 12*C*D1**2*f*fd - 12*C*D1**2*f*fdd*s**2 + 12*C*D1**2*f*fdd*s - 6*C*D1**2*f*fdd - 12*C*D1**2*fd**2*s**2 + 12*C*D1**2*fd**2*s + 48*C*D1*Dd*f**2*s**2 - 24*C*D1*Dd*f**2*s + 12*C*D1*Dd*f**2 - 96*C*D1*Dd*f*fd*s**2 + 72*C*D1*Dd*f*fd*s - 12*C*D1*Dd*f*fd - 24*C*D1*Ddd*f**2*s**2 + 12*C*D1*Ddd*f**2*s - 6*C*D1*Ddd*f**2 - 72*C*Dd**2*f**2*s**2 + 36*C*Dd**2*f**2*s - 6*D1**2*K*bdd1*f*s**2 + 6*D1**2*bd2*f*s**2 - 6*D1**2*bd2*fd*s**2 + 6*D1**2*bd2*fd*s - 6*D1**2*bdd1*f**2*r*s + 3*D1**2*bdd1*f**2*s - 6*D1**2*bdd1*f*r*s + 3*D1**2*bdd1*f*s - 3*D1**2*bdd2*f*s**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 6*D1**2*f*fd - 6*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 3*D1**2*f*fdd*s + 3*D1**2*f*fdd - 12*D1**2*f*gd2*s**2 + 6*D1**2*f*gdd2*s**2 - 6*D1**2*fd**2*r*s + 3*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 3*D1**2*fd**2*s - 3*D1**2*fd**2 - 12*D1**2*fd*g2*s**2 + 24*D1**2*fd*g2*s - 12*D1**2*fd*g2 + 12*D1**2*fd*gd2*s**2 - 12*D1**2*fd*gd2*s + 6*D1**2*fdd*g2*s**2 - 12*D1**2*fdd*g2*s + 6*D1**2*fdd*g2 - 24*D1*Dd*bd2*f*s**2 + 6*D1*Dd*bd2*f*s + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - 6*D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 12*D1*Dd*f*fd*s - 3*D1*Dd*f*fd - 48*D1*Dd*f*g2*s**2 + 24*D1*Dd*f*g2*s - 12*D1*Dd*f*g2 + 48*D1*Dd*f*gd2*s**2 - 12*D1*Dd*f*gd2*s + 48*D1*Dd*fd*g2*s**2 - 60*D1*Dd*fd*g2*s + 12*D1*Dd*fd*g2 - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 + 3*D1*Ddd*f**2 + 24*D1*Ddd*f*g2*s**2 - 12*D1*Ddd*f*g2*s + 6*D1*Ddd*f*g2 + 3*D1*bd1*(-D1*(f*s*(-4*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(4*K*s - 1))) - Dd*f*(16*K*s**2 - 4*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 6*Dd**2*f**2 + 72*Dd**2*f*g2*s**2 - 36*Dd**2*f*g2*s + 3*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(21*d**2*k2**2) + 2*D1**2*Pk2*Pk3*ct**2*(D1*(D1*bd1**2*f*(2*r*(21*f*s + 5*s + 8) + 7*s*(10*K*s - 3*f - 3)) + D1*bdd1*f*s*(6*f*(10*C*s + 4*r - 5*s) + s*(35*b2 - 70*g2)) + bd1*(D1*(-2*f**2*s*(19*r + s*(42*C - 21)) + f*(12*fd*(r*(8*s - 2) + s*(20*C*s - 10*C - 10*s + 3)) + s**2*(-49*b2 + 70*bd2 + 98*g2 - 140*gd2)) + 70*fd*s*(b2 - 2*g2)*(s - 1)) + 2*Dd*f*(6*f*(2*r*(8*s - 1) + s*(40*C*s - 10*C - 20*s + 1)) + s*(35*b2 - 70*g2)*(4*s - 1)))) - 14*b1**3*(D1*Dd*(fd*(8*r*s - r - 6*s + 1) - (f + 2)*(4*r*s - r - 2*s)) + D1*(-D1*s*(fd - fdd)*(r - 1) + Ddd*(f + 1)*(4*r*s - r - 2*s)) + Dd**2*(f + 1)*(3*r*(4*s - 1) - 6*s + 2)) + b1**2*(D1*Dd*(f*(-49*K*(4*s**2 - 2*s + 1) - (21*f + 3)*(r*(4*s - 1) - 2*s)) + fd*(70*K*(4*s**2 - 5*s + 1) + 21*f*(2*r - 1)*(8*s - 3) + 40*r*s - 89*r + 54*s + 26)) + 14*D1*bd1*(-D1*fd*(r*(6*s - 1) - 4*s + 1) + D1*(f + 2)*(r*(3*s - 1) - s) - Dd*(f + 1)*(r*(24*s - 7) - 10*s + 3)) + D1*(D1*(-14*bdd1*(f + 1)*(r*(3*s - 1) - s) + 21*fd**2*(r*(2*s - 1) - s + 1) + fd*(-49*K*(s - 1)**2 + r*(-42*f*s + 21*f - 3*s + 35) + s*(21*f - 32)) + fdd*(35*K*(s - 1)**2 + r*(42*f*s - 21*f + 5*s - 21) + s*(16 - 21*f))) + Ddd*f*(35*K*(4*s**2 - 2*s + 1) + (21*f + 5)*(r*(4*s - 1) - 2*s))) + Dd**2*f*(420*K*s**2 + 21*f*(3*r*(4*s - 1) - 6*s + 2) + 15*r*(4*s - 1) - 5*s*(42*K + 6) + 10)) + b1*(-168*C*D1**2*f*fd*s**2 + 168*C*D1**2*f*fd*s - 84*C*D1**2*f*fd + 120*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 120*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 336*C*D1*Dd*f**2*s**2 + 168*C*D1*Dd*f**2*s - 84*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 70*D1**2*K*bdd1*f*s**2 - 14*D1**2*bd1**2*(f + 1)*(r*(6*s - 2) - 2*s + 1) - 49*D1**2*bd2*f*s**2 + 70*D1**2*bd2*fd*s**2 - 70*D1**2*bd2*fd*s + 42*D1**2*bdd1*f**2*r*s - 21*D1**2*bdd1*f**2*s + 10*D1**2*bdd1*f*r*s + 16*D1**2*bdd1*f*r - 21*D1**2*bdd1*f*s + 35*D1**2*bdd2*f*s**2 - 76*D1**2*f*fd*r*s + 38*D1**2*f*fd*r + 84*D1**2*f*fd*s**2 - 46*D1**2*f*fd*s + 42*D1**2*f*fd + 48*D1**2*f*fdd*r*s - 24*D1**2*f*fdd*r - 60*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 30*D1**2*f*fdd + 98*D1**2*f*gd2*s**2 - 70*D1**2*f*gdd2*s**2 + 48*D1**2*fd**2*r*s - 24*D1**2*fd**2*r - 60*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 24*D1**2*fd**2 + 98*D1**2*fd*g2*s**2 - 196*D1**2*fd*g2*s + 98*D1**2*fd*g2 - 140*D1**2*fd*gd2*s**2 + 140*D1**2*fd*gd2*s - 70*D1**2*fdd*g2*s**2 + 140*D1**2*fdd*g2*s - 70*D1**2*fdd*g2 + 280*D1*Dd*bd2*f*s**2 - 70*D1*Dd*bd2*f*s - 152*D1*Dd*f**2*r*s + 38*D1*Dd*f**2*r + 168*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 42*D1*Dd*f**2 + 384*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 168*D1*Dd*f*fd*s + 12*D1*Dd*f*fd + 392*D1*Dd*f*g2*s**2 - 196*D1*Dd*f*g2*s + 98*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*s**2 + 140*D1*Dd*f*gd2*s - 560*D1*Dd*fd*g2*s**2 + 700*D1*Dd*fd*g2*s - 140*D1*Dd*fd*g2 + 96*D1*Ddd*f**2*r*s - 24*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*s**2 + 140*D1*Ddd*f*g2*s - 70*D1*Ddd*f*g2 + D1*bd1*(D1*(-f*(r*(42*f*s + 6*s + 32) + 7*s*(14*K*s - 3*f - 5)) + fd*(140*K*s**2 - 140*K*s + 21*f*(2*r - 1)*(4*s - 1) + 20*r*s - 26*r + 11*s + 5)) + Dd*f*(560*K*s**2 - 140*K*s + 21*f*(2*r - 1)*(8*s - 1) + 80*r*s + 54*r - 104*s - 11)) + 288*Dd**2*f**2*r*s - 72*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s + 48*Dd**2*f**2 - 840*Dd**2*f*g2*s**2 + 420*Dd**2*f*g2*s - 7*b2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + D1*(7*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(4*s**2 - 5*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f*s*(1 - 2*s))))/(21*d**2*k2**2) - 20*D1**2*Pk2*Pk3*ct*f**2*k1**7*st**2*(D1**2*(f*(33*fd - 49*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 294*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(33*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 98*fd*(4*r + 4*s - 3)**2) - 49*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 294*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1001*d**2*k2*k3**8) - 8*D1**2*Pk2*Pk3*ct*f**2*k1**5*k2*st**4*(D1**2*(f*(727*fd - 500*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3000*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(727*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 1000*fd*(4*r + 4*s - 3)**2) - 500*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 3000*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1001*d**2*k3**8) - 32*D1**2*Pk2*Pk3*ct*f**2*k1**5*st**4*(D1**2*(f*(361*fd - 200*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 200*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(361*f*(r*(4*s - 1) + (1 - 2*s)**2) - 400*fd*(4*s - 1)*(4*r + 4*s - 3)) - 200*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 200*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k2*k3**6) - 400*D1**2*Pk2*Pk3*ct*f**2*k1**5*st**4*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(1001*d**2*k2**3*k3**4) - 20*D1**2*Pk2*Pk3*ct*f**2*k1**3*k2**3*st**6*(D1**2*(f*(236*fd - 105*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 630*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(236*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 210*Dd*fd*(4*r + 4*s - 3)**2 - 105*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 630*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(3003*d**2*k3**8) - 80*D1**2*Pk2*Pk3*ct*f**2*k1**3*k2*st**6*(D1**2*(f*(181*fd - 84*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 84*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(181*f*(r*(4*s - 1) + (1 - 2*s)**2) - 168*fd*(4*s - 1)*(4*r + 4*s - 3)) - 84*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 84*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(9009*d**2*k3**6) - 60*D1**2*Pk2*Pk3*ct*f**2*k1**3*st**6*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(143*d**2*k2*k3**4) - 40*D1**2*Pk2*Pk3*ct*f*k1**7*(-28*D1**2*bdd1*f**2*(r + s - 1)**2 + D1*bd1*f*(r + s - 1)*(23*D1*f*(r + s - 1) - 56*D1*fd*(3*r + 3*s - 2) - 56*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 56*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(23*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 56*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 28*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 168*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k2*k3**8) + 50*D1**2*Pk2*Pk3*ct*f*k1**5*st**2*(-12*D1**2*b1*f*fd*s**2 + 6*D1**2*b1*f*fdd*s**2 + 12*D1**2*b1*fd**2*s**2 + 2*D1**2*bdd1*f**2*(s - 1)**2 + 44*D1**2*f**2*fd*s**2 - 22*D1**2*f**2*fd*s + 11*D1**2*f**2*fd - 28*D1**2*f**2*fdd*s**2 + 14*D1**2*f**2*fdd*s - 7*D1**2*f**2*fdd - 84*D1**2*f*fd**2*s**2 + 42*D1**2*f*fd**2*s - 16*D1*Dd*b1*f**2*s**2 + 8*D1*Dd*b1*f**2*s - 4*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*s**2 - 12*D1*Dd*b1*f*fd*s + 44*D1*Dd*f**3*s**2 - 22*D1*Dd*f**3*s + 11*D1*Dd*f**3 - 224*D1*Dd*f**2*fd*s**2 + 112*D1*Dd*f**2*fd*s - 14*D1*Dd*f**2*fd + 8*D1*Ddd*b1*f**2*s**2 - 4*D1*Ddd*b1*f**2*s + 2*D1*Ddd*b1*f**2 - 28*D1*Ddd*f**3*s**2 + 14*D1*Ddd*f**3*s - 7*D1*Ddd*f**3 - 4*D1*bd1*f*(s - 1)*(D1*f*(s - 1) - 3*D1*fd*s + Dd*f*(1 - 4*s)) + 24*Dd**2*b1*f**2*s**2 - 12*Dd**2*b1*f**2*s - 84*Dd**2*f**3*s**2 + 42*Dd**2*f**3*s)/(231*d**2*k2**3*k3**4) + 10*D1**2*Pk2*Pk3*ct*f*k1**5*(15*D1**2*b1*f*fd*s**2 - 9*D1**2*b1*f*fdd*s**2 - 18*D1**2*b1*fd**2*s**2 - 3*D1**2*bdd1*f**2*(s - 1)**2 - 12*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 3*D1**2*f**2*fd + 12*D1**2*f**2*fdd*s**2 - 6*D1**2*f**2*fdd*s + 3*D1**2*f**2*fdd + 36*D1**2*f*fd**2*s**2 - 18*D1**2*f*fd**2*s + 20*D1*Dd*b1*f**2*s**2 - 10*D1*Dd*b1*f**2*s + 5*D1*Dd*b1*f**2 - 72*D1*Dd*b1*f*fd*s**2 + 18*D1*Dd*b1*f*fd*s - 12*D1*Dd*f**3*s**2 + 6*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*s**2 - 48*D1*Dd*f**2*fd*s + 6*D1*Dd*f**2*fd - 12*D1*Ddd*b1*f**2*s**2 + 6*D1*Ddd*b1*f**2*s - 3*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*s**2 - 6*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + D1*bd1*f*(s - 1)*(5*D1*f*(s - 1) - 18*D1*fd*s + 6*Dd*f*(1 - 4*s)) - 36*Dd**2*b1*f**2*s**2 + 18*Dd**2*b1*f**2*s + 36*Dd**2*f**3*s**2 - 18*Dd**2*f**3*s)/(21*d**2*k2**3*k3**4) + 8*D1**2*Pk2*Pk3*ct*f*k1**3*k2**3*st**4*(-144*C*D1**2*f*fd*r**2 - 288*C*D1**2*f*fd*r*s + 192*C*D1**2*f*fd*r - 144*C*D1**2*f*fd*s**2 + 192*C*D1**2*f*fd*s - 96*C*D1**2*f*fd + 72*C*D1**2*f*fdd*r**2 + 144*C*D1**2*f*fdd*r*s - 96*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s**2 - 96*C*D1**2*f*fdd*s + 48*C*D1**2*f*fdd + 144*C*D1**2*fd**2*r**2 + 288*C*D1**2*fd**2*r*s - 192*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 192*C*D1**2*fd**2*s + 48*C*D1**2*fd**2 - 192*C*D1*Dd*f**2*r**2 - 384*C*D1*Dd*f**2*r*s + 288*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 144*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 + 1152*C*D1*Dd*f*fd*r*s - 816*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 816*C*D1*Dd*f*fd*s + 288*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 + 192*C*D1*Ddd*f**2*r*s - 144*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r**2 + 576*C*Dd**2*f**2*r*s - 432*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 144*C*Dd**2*f**2 - 25*D1**2*bdd1*f**2*r**2 - 50*D1**2*bdd1*f**2*r*s + 50*D1**2*bdd1*f**2*r - 25*D1**2*bdd1*f**2*s**2 + 50*D1**2*bdd1*f**2*s - 25*D1**2*bdd1*f**2 + 60*D1**2*f**2*fd*r**2 + 120*D1**2*f**2*fd*r*s - 90*D1**2*f**2*fd*r + 60*D1**2*f**2*fd*s**2 - 90*D1**2*f**2*fd*s + 45*D1**2*f**2*fd + 108*D1**2*f*fd*r**2 + 216*D1**2*f*fd*r*s - 144*D1**2*f*fd*r + 108*D1**2*f*fd*s**2 - 144*D1**2*f*fd*s + 72*D1**2*f*fd - 54*D1**2*f*fdd*r**2 - 108*D1**2*f*fdd*r*s + 72*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 72*D1**2*f*fdd*s - 36*D1**2*f*fdd + 132*D1**2*f*gd2*r**2 + 264*D1**2*f*gd2*r*s - 264*D1**2*f*gd2*r + 132*D1**2*f*gd2*s**2 - 264*D1**2*f*gd2*s + 132*D1**2*f*gd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 144*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 144*D1**2*fd**2*s - 36*D1**2*fd**2 + 264*D1**2*fd*g2*r**2 + 528*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*r + 264*D1**2*fd*g2*s**2 - 264*D1**2*fd*g2*s + 132*D1**2*fd*g2 + 60*D1*Dd*f**3*r**2 + 120*D1*Dd*f**3*r*s - 90*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 90*D1*Dd*f**3*s + 45*D1*Dd*f**3 + 144*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 216*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 216*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 432*D1*Dd*f*fd*r**2 - 864*D1*Dd*f*fd*r*s + 612*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 612*D1*Dd*f*fd*s - 216*D1*Dd*f*fd + 528*D1*Dd*f*g2*r**2 + 1056*D1*Dd*f*g2*r*s - 792*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s**2 - 792*D1*Dd*f*g2*s + 396*D1*Dd*f*g2 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 + D1*bd1*f*(D1*(50*f*(r + s - 1) - 50*fd*(3*r + 3*s - 2) - (66*K - 33)*(r + s - 1)) - 50*Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 + b1*(-D1**2*(-50*f*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 25*f*fdd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 50*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 33*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + D1*f*(Dd*(50*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 50*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + (33 - 66*K)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 25*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 150*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct*f*k1**3*k2*st**4*(-144*C*D1**2*f*fd*r**2 + 96*C*D1**2*f*fd*r + 144*C*D1**2*f*fd*s**2 - 96*C*D1**2*f*fd*s + 72*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s**2 + 48*C*D1**2*f*fdd*s + 144*C*D1**2*fd**2*r**2 - 96*C*D1**2*fd**2*r - 144*C*D1**2*fd**2*s**2 + 96*C*D1**2*fd**2*s - 192*C*D1*Dd*f**2*r**2 + 192*C*D1*Dd*f**2*r + 192*C*D1*Dd*f**2*s**2 - 96*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 - 480*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 336*C*D1*Dd*f*fd*s + 48*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r - 96*C*D1*Ddd*f**2*s**2 + 48*C*D1*Ddd*f**2*s + 24*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r - 288*C*Dd**2*f**2*s**2 + 144*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 - 90*D1**2*bdd1*f**2*r**2 - 140*D1**2*bdd1*f**2*r*s + 200*D1**2*bdd1*f**2*r - 50*D1**2*bdd1*f**2*s**2 + 160*D1**2*bdd1*f**2*s - 140*D1**2*bdd1*f**2 - 780*D1**2*f**2*fd*r**2 - 2040*D1**2*f**2*fd*r*s + 1290*D1**2*f**2*fd*r - 1260*D1**2*f**2*fd*s**2 + 1650*D1**2*f**2*fd*s - 705*D1**2*f**2*fd + 900*D1**2*f**2*fdd*r**2 + 1800*D1**2*f**2*fdd*r*s - 1350*D1**2*f**2*fdd*r + 900*D1**2*f**2*fdd*s**2 - 1350*D1**2*f**2*fdd*s + 675*D1**2*f**2*fdd + 2700*D1**2*f*fd**2*r**2 + 5400*D1**2*f*fd**2*r*s - 4050*D1**2*f*fd**2*r + 2700*D1**2*f*fd**2*s**2 - 4050*D1**2*f*fd**2*s + 1350*D1**2*f*fd**2 + 216*D1**2*f*fd*r**2 + 216*D1**2*f*fd*r*s - 216*D1**2*f*fd*r - 72*D1**2*f*fd*s + 72*D1**2*f*fd - 108*D1**2*f*fdd*r**2 - 108*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*r + 36*D1**2*f*fdd*s - 36*D1**2*f*fdd + 264*D1**2*f*gd2*r*s + 264*D1**2*f*gd2*s**2 - 264*D1**2*f*gd2*s - 216*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 216*D1**2*fd**2*r + 72*D1**2*fd**2*s - 36*D1**2*fd**2 + 528*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*r + 528*D1**2*fd*g2*s**2 - 528*D1**2*fd*g2*s + 264*D1**2*fd*g2 - 780*D1*Dd*f**3*r**2 - 2040*D1*Dd*f**3*r*s + 1290*D1*Dd*f**3*r - 1260*D1*Dd*f**3*s**2 + 1650*D1*Dd*f**3*s - 705*D1*Dd*f**3 + 7200*D1*Dd*f**2*fd*r**2 + 14400*D1*Dd*f**2*fd*r*s - 10800*D1*Dd*f**2*fd*r + 7200*D1*Dd*f**2*fd*s**2 - 10800*D1*Dd*f**2*fd*s + 4050*D1*Dd*f**2*fd + 288*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 360*D1*Dd*f**2*r - 144*D1*Dd*f**2*s + 144*D1*Dd*f**2 - 864*D1*Dd*f*fd*r**2 - 864*D1*Dd*f*fd*r*s + 972*D1*Dd*f*fd*r + 360*D1*Dd*f*fd*s - 252*D1*Dd*f*fd + 1056*D1*Dd*f*g2*r*s - 264*D1*Dd*f*g2*r + 1056*D1*Dd*f*g2*s**2 - 1056*D1*Dd*f*g2*s + 264*D1*Dd*f*g2 + 900*D1*Ddd*f**3*r**2 + 1800*D1*Ddd*f**3*r*s - 1350*D1*Ddd*f**3*r + 900*D1*Ddd*f**3*s**2 - 1350*D1*Ddd*f**3*s + 675*D1*Ddd*f**3 - 144*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s - 72*D1*Ddd*f**2 + 2*D1*bd1*f*(D1*(10*f*(9*r**2 + 2*r*(7*s - 10) + 5*s**2 - 16*s + 14) - 10*fd*(27*r**2 + 42*r*s - 45*r + 15*s**2 - 35*s + 14) + (33*r + 33*s - 33)*(-2*K*s + r + 3*s - 1)) - 10*Dd*f*(36*r**2 + r*(56*s - 65) + 20*s**2 - 51*s + 28)) + 2700*Dd**2*f**3*r**2 + 5400*Dd**2*f**3*r*s - 4050*Dd**2*f**3*r + 2700*Dd**2*f**3*s**2 - 4050*Dd**2*f**3*s + 1350*Dd**2*f**3 - 432*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 540*Dd**2*f**2*r + 216*Dd**2*f**2*s - 144*Dd**2*f**2 + 2*b1*(D1**2*(-5*f*fdd*(27*r**2 + 6*r*(7*s - 5) + 15*s**2 - 22*s + 9) - 10*fd**2*(27*r**2 + 6*r*(7*s - 5) + 15*s**2 - 22*s + 9) + fd*(-33*K*(4*r*s - 2*r + 4*s**2 - 4*s + 2) + 10*f*(27*r**2 + 6*r*(7*s - 5) + 15*s**2 - 22*s + 9) + 66*r**2 + 264*r*s - 132*r + 198*s**2 - 198*s + 99)) + D1*f*(Dd*(-33*K*r*(8*s - 2) - 66*K*(1 - 2*s)**2 + 10*f*(36*r**2 + r*(56*s - 50) + 20*s**2 - 38*s + 23) - 10*fd*(108*r**2 + 3*r*(56*s - 45) + 60*s**2 - 101*s + 41) + 132*r**2 - 33*r*(8 - 16*s) + 396*s**2 - 462*s + 165) - 5*Ddd*f*(36*r**2 + r*(56*s - 50) + 20*s**2 - 38*s + 23)) - 10*Dd**2*f**2*(54*r**2 + r*(84*s - 75) + 30*s**2 - 57*s + 23)))/(231*d**2*k3**6) - 8*D1**2*Pk2*Pk3*ct*f*k1**3*st**4*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) + f*fd*(20*b1*(3*s**2 - 2*s + 1) + s**2*(6 - 60*bd1) + s*(20*bd1 - 4) + 2) - f*fdd*(10*b1 + 1)*(3*s**2 - 2*s + 1) - fd**2*s*(20*b1 + 2)*(3*s - 2)) + D1*f*(2*Dd*f*(10*b1*(4*s**2 - 2*s + 1) + s**2*(4 - 40*bd1) + s*(10*bd1 - 2) + 1) - Dd*fd*(20*b1 + 2)*(12*s**2 - 7*s + 1) - Ddd*f*(10*b1 + 1)*(4*s**2 - 2*s + 1)) + Dd**2*f**2*s*(-60*b1 - 6)*(2*s - 1))/(77*d**2*k2**3*k3**2) - D1**2*Pk2*Pk3*ct*f*k2**5*st**4*(160*C - 80)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4))/(231*d**2*k1*k3**6) - 4*D1**2*Pk2*Pk3*ct*k1**5*k2*st**2*(204*C*D1**2*f**2*fd*r**2 + 408*C*D1**2*f**2*fd*r*s - 272*C*D1**2*f**2*fd*r + 204*C*D1**2*f**2*fd*s**2 - 272*C*D1**2*f**2*fd*s + 136*C*D1**2*f**2*fd - 300*C*D1**2*f**2*fdd*r**2 - 600*C*D1**2*f**2*fdd*r*s + 400*C*D1**2*f**2*fdd*r - 300*C*D1**2*f**2*fdd*s**2 + 400*C*D1**2*f**2*fdd*s - 200*C*D1**2*f**2*fdd - 600*C*D1**2*f*fd**2*r**2 - 1200*C*D1**2*f*fd**2*r*s + 800*C*D1**2*f*fd**2*r - 600*C*D1**2*f*fd**2*s**2 + 800*C*D1**2*f*fd**2*s - 200*C*D1**2*f*fd**2 + 272*C*D1*Dd*f**3*r**2 + 544*C*D1*Dd*f**3*r*s - 408*C*D1*Dd*f**3*r + 272*C*D1*Dd*f**3*s**2 - 408*C*D1*Dd*f**3*s + 204*C*D1*Dd*f**3 - 2400*C*D1*Dd*f**2*fd*r**2 - 4800*C*D1*Dd*f**2*fd*r*s + 3400*C*D1*Dd*f**2*fd*r - 2400*C*D1*Dd*f**2*fd*s**2 + 3400*C*D1*Dd*f**2*fd*s - 1200*C*D1*Dd*f**2*fd - 400*C*D1*Ddd*f**3*r**2 - 800*C*D1*Ddd*f**3*r*s + 600*C*D1*Ddd*f**3*r - 400*C*D1*Ddd*f**3*s**2 + 600*C*D1*Ddd*f**3*s - 300*C*D1*Ddd*f**3 - 1200*C*Dd**2*f**3*r**2 - 2400*C*Dd**2*f**3*r*s + 1800*C*Dd**2*f**3*r - 1200*C*Dd**2*f**3*s**2 + 1800*C*Dd**2*f**3*s - 600*C*Dd**2*f**3 + 132*D1**2*K*b1*f*fd*r**2 + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r + 132*D1**2*K*b1*f*fd*s**2 - 132*D1**2*K*b1*f*fd*s + 66*D1**2*K*b1*f*fd - 132*D1**2*K*b1*f*fdd*r**2 - 264*D1**2*K*b1*f*fdd*r*s + 132*D1**2*K*b1*f*fdd*r - 132*D1**2*K*b1*f*fdd*s**2 + 132*D1**2*K*b1*f*fdd*s - 66*D1**2*K*b1*f*fdd - 132*D1**2*K*b1*fd**2*r**2 - 264*D1**2*K*b1*fd**2*r*s + 132*D1**2*K*b1*fd**2*r - 132*D1**2*K*b1*fd**2*s**2 + 132*D1**2*K*b1*fd**2*s + 1854*D1**2*b1*f**2*fd*r**2 + 3708*D1**2*b1*f**2*fd*r*s - 2472*D1**2*b1*f**2*fd*r + 1854*D1**2*b1*f**2*fd*s**2 - 2472*D1**2*b1*f**2*fd*s + 1236*D1**2*b1*f**2*fd - 1125*D1**2*b1*f**2*fdd*r**2 - 2250*D1**2*b1*f**2*fdd*r*s + 1500*D1**2*b1*f**2*fdd*r - 1125*D1**2*b1*f**2*fdd*s**2 + 1500*D1**2*b1*f**2*fdd*s - 750*D1**2*b1*f**2*fdd - 2250*D1**2*b1*f*fd**2*r**2 - 4500*D1**2*b1*f*fd**2*r*s + 3000*D1**2*b1*f*fd**2*r - 2250*D1**2*b1*f*fd**2*s**2 + 3000*D1**2*b1*f*fd**2*s - 750*D1**2*b1*f*fd**2 - 66*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fd*s**2 + 66*D1**2*b1*f*fd*s - 33*D1**2*b1*f*fd + 66*D1**2*b1*f*fdd*r**2 + 132*D1**2*b1*f*fdd*r*s - 66*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s**2 - 66*D1**2*b1*f*fdd*s + 33*D1**2*b1*f*fdd + 66*D1**2*b1*fd**2*r**2 + 132*D1**2*b1*fd**2*r*s - 66*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 66*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(22*K + 125*f - 11)*(r + s - 1)**2 - 300*D1**2*f**3*fd*r**2 - 600*D1**2*f**3*fd*r*s + 450*D1**2*f**3*fd*r - 300*D1**2*f**3*fd*s**2 + 450*D1**2*f**3*fd*s - 225*D1**2*f**3*fd - 153*D1**2*f**2*fd*r**2 - 306*D1**2*f**2*fd*r*s + 204*D1**2*f**2*fd*r - 153*D1**2*f**2*fd*s**2 + 204*D1**2*f**2*fd*s - 102*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 450*D1**2*f**2*fdd*r*s - 300*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 300*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*r - 132*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s - 132*D1**2*f**2*gd2 + 132*D1**2*f**2*gdd2*r**2 + 264*D1**2*f**2*gdd2*r*s - 264*D1**2*f**2*gdd2*r + 132*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 132*D1**2*f**2*gdd2 + 450*D1**2*f*fd**2*r**2 + 900*D1**2*f*fd**2*r*s - 600*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 600*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r**2 + 1056*D1**2*f*fd*gd2*r*s - 792*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r**2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r**2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s + 264*D1*Dd*K*b1*f**2*r**2 + 528*D1*Dd*K*b1*f**2*r*s - 396*D1*Dd*K*b1*f**2*r + 264*D1*Dd*K*b1*f**2*s**2 - 396*D1*Dd*K*b1*f**2*s + 198*D1*Dd*K*b1*f**2 - 1056*D1*Dd*K*b1*f*fd*r**2 - 2112*D1*Dd*K*b1*f*fd*r*s + 1320*D1*Dd*K*b1*f*fd*r - 1056*D1*Dd*K*b1*f*fd*s**2 + 1320*D1*Dd*K*b1*f*fd*s - 396*D1*Dd*K*b1*f*fd + 2472*D1*Dd*b1*f**3*r**2 + 4944*D1*Dd*b1*f**3*r*s - 3708*D1*Dd*b1*f**3*r + 2472*D1*Dd*b1*f**3*s**2 - 3708*D1*Dd*b1*f**3*s + 1854*D1*Dd*b1*f**3 - 9000*D1*Dd*b1*f**2*fd*r**2 - 18000*D1*Dd*b1*f**2*fd*r*s + 12750*D1*Dd*b1*f**2*fd*r - 9000*D1*Dd*b1*f**2*fd*s**2 + 12750*D1*Dd*b1*f**2*fd*s - 4500*D1*Dd*b1*f**2*fd - 132*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 198*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s**2 + 198*D1*Dd*b1*f**2*s - 99*D1*Dd*b1*f**2 + 528*D1*Dd*b1*f*fd*r**2 + 1056*D1*Dd*b1*f*fd*r*s - 660*D1*Dd*b1*f*fd*r + 528*D1*Dd*b1*f*fd*s**2 - 660*D1*Dd*b1*f*fd*s + 198*D1*Dd*b1*f*fd - 300*D1*Dd*f**4*r**2 - 600*D1*Dd*f**4*r*s + 450*D1*Dd*f**4*r - 300*D1*Dd*f**4*s**2 + 450*D1*Dd*f**4*s - 225*D1*Dd*f**4 - 204*D1*Dd*f**3*r**2 - 408*D1*Dd*f**3*r*s + 306*D1*Dd*f**3*r - 204*D1*Dd*f**3*s**2 + 306*D1*Dd*f**3*s - 153*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 3600*D1*Dd*f**2*fd*r*s - 2550*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 2550*D1*Dd*f**2*fd*s + 900*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s + 792*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 792*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r**2 + 2112*D1*Dd*f**2*gd2*r*s - 1848*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1848*D1*Dd*f**2*gd2*s + 792*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r**2 + 4224*D1*Dd*f*fd*g2*r*s - 2640*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2640*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 264*D1*Ddd*K*b1*f**2*r**2 - 528*D1*Ddd*K*b1*f**2*r*s + 396*D1*Ddd*K*b1*f**2*r - 264*D1*Ddd*K*b1*f**2*s**2 + 396*D1*Ddd*K*b1*f**2*s - 198*D1*Ddd*K*b1*f**2 - 1500*D1*Ddd*b1*f**3*r**2 - 3000*D1*Ddd*b1*f**3*r*s + 2250*D1*Ddd*b1*f**3*r - 1500*D1*Ddd*b1*f**3*s**2 + 2250*D1*Ddd*b1*f**3*s - 1125*D1*Ddd*b1*f**3 + 132*D1*Ddd*b1*f**2*r**2 + 264*D1*Ddd*b1*f**2*r*s - 198*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s**2 - 198*D1*Ddd*b1*f**2*s + 99*D1*Ddd*b1*f**2 + 300*D1*Ddd*f**3*r**2 + 600*D1*Ddd*f**3*r*s - 450*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 450*D1*Ddd*f**3*s + 225*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r**2 + 1056*D1*Ddd*f**2*g2*r*s - 792*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 396*D1*Ddd*f**2*g2 + 3*D1*bd1*f*(D1*(206*f**2*(r + s - 1) - 250*f*fd*(3*r + 3*s - 2) + 11*f*(2*K - 1)*(r + s - 1) - 22*fd*(2*K - 1)*(2*r + 2*s - 1)) - 2*Dd*f*(22*K + 125*f - 11)*(4*r + 4*s - 3))*(r + s - 1) - 792*Dd**2*K*b1*f**2*r**2 - 1584*Dd**2*K*b1*f**2*r*s + 1188*Dd**2*K*b1*f**2*r - 792*Dd**2*K*b1*f**2*s**2 + 1188*Dd**2*K*b1*f**2*s - 396*Dd**2*K*b1*f**2 - 4500*Dd**2*b1*f**3*r**2 - 9000*Dd**2*b1*f**3*r*s + 6750*Dd**2*b1*f**3*r - 4500*Dd**2*b1*f**3*s**2 + 6750*Dd**2*b1*f**3*s - 2250*Dd**2*b1*f**3 + 396*Dd**2*b1*f**2*r**2 + 792*Dd**2*b1*f**2*r*s - 594*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s**2 - 594*Dd**2*b1*f**2*s + 198*Dd**2*b1*f**2 + 900*Dd**2*f**3*r**2 + 1800*Dd**2*f**3*r*s - 1350*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 1350*Dd**2*f**3*s + 450*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r**2 + 3168*Dd**2*f**2*g2*r*s - 2376*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 792*Dd**2*f**2*g2)/(231*d**2*k3**8) + 8*D1**2*Pk2*Pk3*ct*k1**5*k2*(-D1*(r + s - 1)*(2*D1*bd1**2*f*(-12*K + 25*f + 6)*(r + s - 1) - D1*bdd1*f*(f*(20*C - 15) - 24*g2)*(r + s - 1) + bd1*(D1*(-5*f**3*(r + s - 1) + f**2*(16*C - 12)*(r + s - 1) - f*fd*(40*C - 30)*(2*r + 2*s - 1) - 4*f*(5*g2 - 12*gd2)*(r + s - 1) + 48*fd*g2*(r + s)) - 2*Dd*f*(f*(20*C - 15) - 24*g2)*(4*r + 4*s - 3))) + b1**2*(D1**2*(5*f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + 5*fd*(2*K - 1)*(r + s) - 6*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(20*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (2*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-12*K + 25*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-12*K + 25*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-32*C*D1**2*f*fd*r**2 - 64*C*D1**2*f*fd*r*s + 32*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s - 16*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 64*C*D1*Dd*f**2*r**2 - 128*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 400*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(-12*K + 25*f + 6)*(r + s - 1)**2 + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 24*D1**2*f*fd*r**2 + 48*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 12*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 20*D1**2*f*gd2*r**2 + 40*D1**2*f*gd2*r*s - 40*D1**2*f*gd2*r + 20*D1**2*f*gd2*s**2 - 40*D1**2*f*gd2*s + 20*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 20*D1**2*fd*g2*r**2 + 40*D1**2*fd*g2*r*s + 20*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 48*D1*Dd*f**2*r**2 + 96*D1*Dd*f**2*r*s - 72*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 36*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 80*D1*Dd*f*g2*r**2 + 160*D1*Dd*f*g2*r*s - 120*D1*Dd*f*g2*r + 80*D1*Dd*f*g2*s**2 - 120*D1*Dd*f*g2*s + 60*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 144*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(20*f**2*(r + s - 1) - 5*f*(10*fd*(2*r + 2*s - 1) + (2*K - 1)*(r + s - 1)) + 12*fd*(2*K - 1)*(r + s)) - 2*Dd*f*(-12*K + 25*f + 6)*(4*r + 4*s - 3))*(r + s - 1) - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(7*d**2*k3**8) - 2*D1**2*Pk2*Pk3*ct*k1**5*st**2*(-408*C*D1**2*f**2*fd*r*s + 136*C*D1**2*f**2*fd*r - 408*C*D1**2*f**2*fd*s**2 + 408*C*D1**2*f**2*fd*s - 136*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r*s - 200*C*D1**2*f**2*fdd*r + 600*C*D1**2*f**2*fdd*s**2 - 600*C*D1**2*f**2*fdd*s + 200*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r*s - 400*C*D1**2*f*fd**2*r + 1200*C*D1**2*f*fd**2*s**2 - 1200*C*D1**2*f*fd**2*s + 200*C*D1**2*f*fd**2 - 544*C*D1*Dd*f**3*r*s + 136*C*D1*Dd*f**3*r - 544*C*D1*Dd*f**3*s**2 + 544*C*D1*Dd*f**3*s - 136*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r*s - 1400*C*D1*Dd*f**2*fd*r + 4800*C*D1*Dd*f**2*fd*s**2 - 4800*C*D1*Dd*f**2*fd*s + 1000*C*D1*Dd*f**2*fd + 800*C*D1*Ddd*f**3*r*s - 200*C*D1*Ddd*f**3*r + 800*C*D1*Ddd*f**3*s**2 - 800*C*D1*Ddd*f**3*s + 200*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r*s - 600*C*Dd**2*f**3*r + 2400*C*Dd**2*f**3*s**2 - 2400*C*Dd**2*f**3*s + 400*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r*s + 132*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 264*D1**2*K*b1*f*fdd*s**2 - 264*D1**2*K*b1*f*fdd*s + 132*D1**2*K*b1*f*fdd + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 264*D1**2*K*b1*fd**2*s**2 - 264*D1**2*K*b1*fd**2*s + 612*D1**2*b1*f**2*fd*r**2 + 5832*D1**2*b1*f**2*fd*r*s - 552*D1**2*b1*f**2*fd*r + 5220*D1**2*b1*f**2*fd*s**2 - 3624*D1**2*b1*f**2*fd*s + 42*D1**2*b1*f**2*fd - 900*D1**2*b1*f**2*fdd*r**2 - 4500*D1**2*b1*f**2*fdd*r*s + 1200*D1**2*b1*f**2*fdd*r - 3600*D1**2*b1*f**2*fdd*s**2 + 3000*D1**2*b1*f**2*fdd*s - 450*D1**2*b1*f**2*fdd - 1800*D1**2*b1*f*fd**2*r**2 - 9000*D1**2*b1*f*fd**2*r*s + 2400*D1**2*b1*f*fd**2*r - 7200*D1**2*b1*f*fd**2*s**2 + 6000*D1**2*b1*f*fd**2*s - 900*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 528*D1**2*b1*f*fd*r*s - 264*D1**2*b1*f*fd*r + 396*D1**2*b1*f*fd*s**2 - 396*D1**2*b1*f*fd*s + 198*D1**2*b1*f*fd - 132*D1**2*b1*f*fdd*r**2 - 528*D1**2*b1*f*fdd*r*s + 264*D1**2*b1*f*fdd*r - 396*D1**2*b1*f*fdd*s**2 + 396*D1**2*b1*f*fdd*s - 198*D1**2*b1*f*fdd - 132*D1**2*b1*fd**2*r**2 - 528*D1**2*b1*fd**2*r*s + 264*D1**2*b1*fd**2*r - 396*D1**2*b1*fd**2*s**2 + 396*D1**2*b1*fd**2*s - 6*D1**2*bdd1*f**2*(25*f*(2*r**2 + 10*r*(s - 1) + 8*s**2 - 16*s + 9) + (11*r + 11*s - 11)*(-2*K*s + r + 3*s - 1)) - 2700*D1**2*f**3*fd*r**2 - 13800*D1**2*f**3*fd*r*s + 6150*D1**2*f**3*fd*r - 11100*D1**2*f**3*fd*s**2 + 12450*D1**2*f**3*fd*s - 4125*D1**2*f**3*fd + 3300*D1**2*f**3*fdd*r**2 + 12600*D1**2*f**3*fdd*r*s - 6450*D1**2*f**3*fdd*r + 9300*D1**2*f**3*fdd*s**2 - 10950*D1**2*f**3*fdd*s + 3975*D1**2*f**3*fdd + 9900*D1**2*f**2*fd**2*r**2 + 37800*D1**2*f**2*fd**2*r*s - 19350*D1**2*f**2*fd**2*r + 27900*D1**2*f**2*fd**2*s**2 - 32850*D1**2*f**2*fd**2*s + 7950*D1**2*f**2*fd**2 + 102*D1**2*f**2*fd*r**2 + 612*D1**2*f**2*fd*r*s - 272*D1**2*f**2*fd*r + 510*D1**2*f**2*fd*s**2 - 544*D1**2*f**2*fd*s + 204*D1**2*f**2*fd - 150*D1**2*f**2*fdd*r**2 - 900*D1**2*f**2*fdd*r*s + 400*D1**2*f**2*fdd*r - 750*D1**2*f**2*fdd*s**2 + 800*D1**2*f**2*fdd*s - 300*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s - 264*D1**2*f**2*gdd2*r*s - 264*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 300*D1**2*f*fd**2*r**2 - 1800*D1**2*f*fd**2*r*s + 800*D1**2*f*fd**2*r - 1500*D1**2*f*fd**2*s**2 + 1600*D1**2*f*fd**2*s - 300*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r*s + 264*D1**2*f*fd*gd2*r - 1056*D1**2*f*fd*gd2*s**2 + 1056*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 528*D1**2*f*fdd*g2*s**2 + 528*D1**2*f*fdd*g2*s - 264*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 528*D1**2*fd**2*g2*s**2 + 528*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r*s + 132*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 528*D1*Dd*K*b1*f**2*s - 132*D1*Dd*K*b1*f**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 792*D1*Dd*K*b1*f*fd*r + 2112*D1*Dd*K*b1*f*fd*s**2 - 2112*D1*Dd*K*b1*f*fd*s + 528*D1*Dd*K*b1*f*fd + 816*D1*Dd*b1*f**3*r**2 + 7776*D1*Dd*b1*f**3*r*s - 2760*D1*Dd*b1*f**3*r + 6960*D1*Dd*b1*f**3*s**2 - 7368*D1*Dd*b1*f**3*s + 2148*D1*Dd*b1*f**3 - 7200*D1*Dd*b1*f**2*fd*r**2 - 36000*D1*Dd*b1*f**2*fd*r*s + 12900*D1*Dd*b1*f**2*fd*r - 28800*D1*Dd*b1*f**2*fd*s**2 + 28200*D1*Dd*b1*f**2*fd*s - 5400*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 1056*D1*Dd*b1*f**2*r*s - 528*D1*Dd*b1*f**2*r + 792*D1*Dd*b1*f**2*s**2 - 924*D1*Dd*b1*f**2*s + 330*D1*Dd*b1*f**2 - 1056*D1*Dd*b1*f*fd*r**2 - 4224*D1*Dd*b1*f*fd*r*s + 2112*D1*Dd*b1*f*fd*r - 3168*D1*Dd*b1*f*fd*s**2 + 3432*D1*Dd*b1*f*fd*s - 924*D1*Dd*b1*f*fd - 2700*D1*Dd*f**4*r**2 - 13800*D1*Dd*f**4*r*s + 6150*D1*Dd*f**4*r - 11100*D1*Dd*f**4*s**2 + 12450*D1*Dd*f**4*s - 4125*D1*Dd*f**4 + 26400*D1*Dd*f**3*fd*r**2 + 100800*D1*Dd*f**3*fd*r*s - 51600*D1*Dd*f**3*fd*r + 74400*D1*Dd*f**3*fd*s**2 - 87600*D1*Dd*f**3*fd*s + 23850*D1*Dd*f**3*fd + 136*D1*Dd*f**3*r**2 + 816*D1*Dd*f**3*r*s - 340*D1*Dd*f**3*r + 680*D1*Dd*f**3*s**2 - 748*D1*Dd*f**3*s + 238*D1*Dd*f**3 - 1200*D1*Dd*f**2*fd*r**2 - 7200*D1*Dd*f**2*fd*r*s + 3100*D1*Dd*f**2*fd*r - 6000*D1*Dd*f**2*fd*s**2 + 6500*D1*Dd*f**2*fd*s - 1600*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r*s - 264*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1056*D1*Dd*f**2*g2*s + 264*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r*s + 264*D1*Dd*f**2*gd2*r - 2112*D1*Dd*f**2*gd2*s**2 + 2112*D1*Dd*f**2*gd2*s - 264*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r*s + 1584*D1*Dd*f*fd*g2*r - 4224*D1*Dd*f*fd*g2*s**2 + 4224*D1*Dd*f*fd*g2*s - 1056*D1*Dd*f*fd*g2 + 528*D1*Ddd*K*b1*f**2*r*s - 132*D1*Ddd*K*b1*f**2*r + 528*D1*Ddd*K*b1*f**2*s**2 - 528*D1*Ddd*K*b1*f**2*s + 132*D1*Ddd*K*b1*f**2 - 1200*D1*Ddd*b1*f**3*r**2 - 6000*D1*Ddd*b1*f**3*r*s + 2700*D1*Ddd*b1*f**3*r - 4800*D1*Ddd*b1*f**3*s**2 + 5400*D1*Ddd*b1*f**3*s - 1800*D1*Ddd*b1*f**3 - 264*D1*Ddd*b1*f**2*r**2 - 1056*D1*Ddd*b1*f**2*r*s + 528*D1*Ddd*b1*f**2*r - 792*D1*Ddd*b1*f**2*s**2 + 924*D1*Ddd*b1*f**2*s - 330*D1*Ddd*b1*f**2 + 3300*D1*Ddd*f**4*r**2 + 12600*D1*Ddd*f**4*r*s - 6450*D1*Ddd*f**4*r + 9300*D1*Ddd*f**4*s**2 - 10950*D1*Ddd*f**4*s + 3975*D1*Ddd*f**4 - 200*D1*Ddd*f**3*r**2 - 1200*D1*Ddd*f**3*r*s + 500*D1*Ddd*f**3*r - 1000*D1*Ddd*f**3*s**2 + 1100*D1*Ddd*f**3*s - 350*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r*s + 264*D1*Ddd*f**2*g2*r - 1056*D1*Ddd*f**2*g2*s**2 + 1056*D1*Ddd*f**2*g2*s - 264*D1*Ddd*f**2*g2 + 6*D1*bd1*f*(D1*(f**2*(34*r**2 + 4*r*(81*s - 92) + 290*s**2 - 624*s + 351) + f*(-50*fd*(6*r**2 + 30*r*s - 19*r + 24*s**2 - 34*s + 9) + (11*r + 11*s - 11)*(-2*K*s + r + 3*s - 1)) + 22*fd*(K*(r*(4*s - 1) + (1 - 2*s)**2) - 2*r**2 - 8*r*s + 4*r - 6*s**2 + 7*s - 2)) - 2*Dd*f*(11*K*(-8*r*s + r - 8*s**2 + 8*s - 1) + 25*f*(8*r**2 + r*(40*s - 29) + 32*s**2 - 50*s + 18) + 44*r**2 + 176*r*s - 88*r + 132*s**2 - 165*s + 44)) + 1584*Dd**2*K*b1*f**2*r*s - 396*Dd**2*K*b1*f**2*r + 1584*Dd**2*K*b1*f**2*s**2 - 1584*Dd**2*K*b1*f**2*s + 264*Dd**2*K*b1*f**2 - 3600*Dd**2*b1*f**3*r**2 - 18000*Dd**2*b1*f**3*r*s + 8100*Dd**2*b1*f**3*r - 14400*Dd**2*b1*f**3*s**2 + 16200*Dd**2*b1*f**3*s - 3600*Dd**2*b1*f**3 - 792*Dd**2*b1*f**2*r**2 - 3168*Dd**2*b1*f**2*r*s + 1584*Dd**2*b1*f**2*r - 2376*Dd**2*b1*f**2*s**2 + 2772*Dd**2*b1*f**2*s - 660*Dd**2*b1*f**2 + 9900*Dd**2*f**4*r**2 + 37800*Dd**2*f**4*r*s - 19350*Dd**2*f**4*r + 27900*Dd**2*f**4*s**2 - 32850*Dd**2*f**4*s + 7950*Dd**2*f**4 - 600*Dd**2*f**3*r**2 - 3600*Dd**2*f**3*r*s + 1500*Dd**2*f**3*r - 3000*Dd**2*f**3*s**2 + 3300*Dd**2*f**3*s - 700*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r*s + 792*Dd**2*f**2*g2*r - 3168*Dd**2*f**2*g2*s**2 + 3168*Dd**2*f**2*g2*s - 528*Dd**2*f**2*g2)/(693*d**2*k2*k3**6) - 4*D1**2*Pk2*Pk3*ct*k1**5*(-D1*(4*D1*bd1**2*f*(r + s - 1)*(-12*K*s + 6*K + 5*f*(2*r + 2*s - 1) + 6*r + 18*s - 12) - D1*bdd1*f*(r + s - 1)*(f**2*(55*r + 55*s - 75) - 10*f*(-4*C*(s - 1) + r + 5*s - 5) - 48*g2*(s - 1)) + bd1*(D1*(5*f**3*(9*r**2 + r*(22*s - 26) + 13*s**2 - 30*s + 17) + f**2*(32*C*(s - 1)*(r + s - 1) - 10*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) - 8*r**2 - 48*r*(s - 1) - 40*(s - 1)**2) - 4*f*(5*fd*(2*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 2*r**2 - 12*r*s + 7*r - 10*s**2 + 13*s - 3) + (10*g2*(s - 1) + 12*gd2*(1 - 2*s))*(r + s - 1)) + 48*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*Dd*f*(-5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) - 10*f*(2*C*(8*r*s - 5*r + 8*s**2 - 12*s + 4) - 4*r**2 - 24*r*s + 17*r - 20*s**2 + 31*s - 11) + 24*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)))) + 2*b1**2*(D1**2*(f*(4*fd - 5*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 5*fd*(r + s)*(r + s*(3 - 2*K)) - 6*fdd*(r + s)*(r + s*(3 - 2*K))) + D1*(Dd*(8*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) + 2*fd*(4*r + 4*s - 3)**2 - 4*r**2 - 16*r*s + 8*r - 12*s**2 + 14*s - 5) - 12*fd*(4*r**2 + r*(-8*K*s + K + 16*s - 4) + s*(K*(4 - 8*s) + 12*s - 7))) - 2*Ddd*f*(-3*K*r*(8*s - 2) - 6*K*(1 - 2*s)**2 + 5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 12*r**2 - 3*r*(8 - 16*s) + 36*s**2 - 42*s + 15)) - 12*Dd**2*f*(K*(-12*r*s + 3*r - 12*s**2 + 12*s - 2) + 5*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 6*r**2 + 24*r*s - 12*r + 18*s**2 - 21*s + 5)) + b1*(-64*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s + 80*C*D1**2*f*fdd*r*s + 80*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 80*C*D1**2*fd**2*r*s + 80*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 128*C*D1*Dd*f**2*r*s + 32*C*D1*Dd*f**2*r - 128*C*D1*Dd*f**2*s**2 + 128*C*D1*Dd*f**2*s - 32*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 480*C*D1*Dd*f*fd*s + 40*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r*s - 40*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 160*C*D1*Ddd*f**2*s + 40*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r*s - 120*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 480*C*Dd**2*f**2*s + 80*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (12*r + 12*s - 12)*(-2*K*s + K + r + 3*s - 2)) - 135*D1**2*f**2*fd*r**2 - 330*D1**2*f**2*fd*r*s + 160*D1**2*f**2*fd*r - 195*D1**2*f**2*fd*s**2 + 200*D1**2*f**2*fd*s - 70*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 + 16*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s - 16*D1**2*f*fd*r + 80*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s + 8*D1**2*f*fd - 20*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*r - 100*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s - 10*D1**2*f*fdd + 40*D1**2*f*gd2*r*s + 40*D1**2*f*gd2*s**2 - 40*D1**2*f*gd2*s - 48*D1**2*f*gdd2*r*s - 48*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 20*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s + 20*D1**2*fd**2*r - 100*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s + 40*D1**2*fd*g2*r*s + 40*D1**2*fd*g2*s**2 - 96*D1**2*fd*gd2*r*s - 96*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 48*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*s**2 - 180*D1*Dd*f**3*r**2 - 440*D1*Dd*f**3*r*s + 290*D1*Dd*f**3*r - 260*D1*Dd*f**3*s**2 + 350*D1*Dd*f**3*s - 155*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1790*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd + 32*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s - 80*D1*Dd*f**2*r + 160*D1*Dd*f**2*s**2 - 176*D1*Dd*f**2*s + 56*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 280*D1*Dd*f*fd*r - 800*D1*Dd*f*fd*s**2 + 680*D1*Dd*f*fd*s - 100*D1*Dd*f*fd + 160*D1*Dd*f*g2*r*s - 40*D1*Dd*f*g2*r + 160*D1*Dd*f*g2*s**2 - 160*D1*Dd*f*g2*s + 40*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r*s + 48*D1*Dd*f*gd2*r - 384*D1*Dd*f*gd2*s**2 + 384*D1*Dd*f*gd2*s - 48*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r*s + 48*D1*Dd*fd*g2*r - 384*D1*Dd*fd*g2*s**2 + 192*D1*Dd*fd*g2*s + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 - 40*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 100*D1*Ddd*f**2*r - 200*D1*Ddd*f**2*s**2 + 220*D1*Ddd*f**2*s - 70*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r*s + 48*D1*Ddd*f*g2*r - 192*D1*Ddd*f*g2*s**2 + 192*D1*Ddd*f*g2*s - 48*D1*Ddd*f*g2 + 4*D1*bd1*(2*D1*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*D1*f*(r + s - 1)*(2*K*s - K + fd*(8*r + 8*s - 4) - r - 3*s + 2) - 6*D1*fd*(2*r**2 + r*(-4*K*s + K + 8*s - 3) + s*(-4*K*s + 3*K + 6*s - 5)) - 5*Dd*f**2*(4*r + 4*s - 3)**2 + 6*Dd*f*(K*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - 8*r**2 - 32*r*s + 20*r - 24*s**2 + 34*s - 11)) + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 330*Dd**2*f**3 - 120*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 300*Dd**2*f**2*r - 600*Dd**2*f**2*s**2 + 660*Dd**2*f**2*s - 140*Dd**2*f**2 - 576*Dd**2*f*g2*r*s + 144*Dd**2*f*g2*r - 576*Dd**2*f*g2*s**2 + 576*Dd**2*f*g2*s - 96*Dd**2*f*g2))/(21*d**2*k2*k3**6) + 4*D1**2*Pk2*Pk3*ct*k1**3*k2**3*st**2*(264*C*D1**2*bdd1*f**2*r**2 + 528*C*D1**2*bdd1*f**2*r*s - 528*C*D1**2*bdd1*f**2*r + 264*C*D1**2*bdd1*f**2*s**2 - 528*C*D1**2*bdd1*f**2*s + 264*C*D1**2*bdd1*f**2 - 540*C*D1**2*f**2*fd*r**2 - 1080*C*D1**2*f**2*fd*r*s + 720*C*D1**2*f**2*fd*r - 540*C*D1**2*f**2*fd*s**2 + 720*C*D1**2*f**2*fd*s - 360*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r**2 + 1200*C*D1**2*f**2*fdd*r*s - 800*C*D1**2*f**2*fdd*r + 600*C*D1**2*f**2*fdd*s**2 - 800*C*D1**2*f**2*fdd*s + 400*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r**2 + 2400*C*D1**2*f*fd**2*r*s - 1600*C*D1**2*f*fd**2*r + 1200*C*D1**2*f*fd**2*s**2 - 1600*C*D1**2*f*fd**2*s + 400*C*D1**2*f*fd**2 - 720*C*D1*Dd*f**3*r**2 - 1440*C*D1*Dd*f**3*r*s + 1080*C*D1*Dd*f**3*r - 720*C*D1*Dd*f**3*s**2 + 1080*C*D1*Dd*f**3*s - 540*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r**2 + 9600*C*D1*Dd*f**2*fd*r*s - 6800*C*D1*Dd*f**2*fd*r + 4800*C*D1*Dd*f**2*fd*s**2 - 6800*C*D1*Dd*f**2*fd*s + 2400*C*D1*Dd*f**2*fd + 800*C*D1*Ddd*f**3*r**2 + 1600*C*D1*Ddd*f**3*r*s - 1200*C*D1*Ddd*f**3*r + 800*C*D1*Ddd*f**3*s**2 - 1200*C*D1*Ddd*f**3*s + 600*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r**2 + 4800*C*Dd**2*f**3*r*s - 3600*C*Dd**2*f**3*r + 2400*C*Dd**2*f**3*s**2 - 3600*C*Dd**2*f**3*s + 1200*C*Dd**2*f**3 + 132*D1**2*K*bdd1*f**2*r**2 + 264*D1**2*K*bdd1*f**2*r*s - 264*D1**2*K*bdd1*f**2*r + 132*D1**2*K*bdd1*f**2*s**2 - 264*D1**2*K*bdd1*f**2*s + 132*D1**2*K*bdd1*f**2 - 132*D1**2*bd1**2*f*(-2*K + 5*f + 1)*(r + s - 1)**2 - 198*D1**2*bdd1*f**2*r**2 - 396*D1**2*bdd1*f**2*r*s + 396*D1**2*bdd1*f**2*r - 198*D1**2*bdd1*f**2*s**2 + 396*D1**2*bdd1*f**2*s - 198*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r**2 - 528*D1**2*bdd1*f*g2*r*s + 528*D1**2*bdd1*f*g2*r - 264*D1**2*bdd1*f*g2*s**2 + 528*D1**2*bdd1*f*g2*s - 264*D1**2*bdd1*f*g2 + 237*D1**2*f**2*fd*r**2 + 474*D1**2*f**2*fd*r*s - 316*D1**2*f**2*fd*r + 237*D1**2*f**2*fd*s**2 - 316*D1**2*f**2*fd*s + 158*D1**2*f**2*fd - 300*D1**2*f**2*fdd*r**2 - 600*D1**2*f**2*fdd*r*s + 400*D1**2*f**2*fdd*r - 300*D1**2*f**2*fdd*s**2 + 400*D1**2*f**2*fdd*s - 200*D1**2*f**2*fdd + 308*D1**2*f**2*gd2*r**2 + 616*D1**2*f**2*gd2*r*s - 616*D1**2*f**2*gd2*r + 308*D1**2*f**2*gd2*s**2 - 616*D1**2*f**2*gd2*s + 308*D1**2*f**2*gd2 - 264*D1**2*f**2*gdd2*r**2 - 528*D1**2*f**2*gdd2*r*s + 528*D1**2*f**2*gdd2*r - 264*D1**2*f**2*gdd2*s**2 + 528*D1**2*f**2*gdd2*s - 264*D1**2*f**2*gdd2 - 600*D1**2*f*fd**2*r**2 - 1200*D1**2*f*fd**2*r*s + 800*D1**2*f*fd**2*r - 600*D1**2*f*fd**2*s**2 + 800*D1**2*f*fd**2*s - 200*D1**2*f*fd**2 + 616*D1**2*f*fd*g2*r**2 + 1232*D1**2*f*fd*g2*r*s - 616*D1**2*f*fd*g2*r + 616*D1**2*f*fd*g2*s**2 - 616*D1**2*f*fd*g2*s + 308*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r**2 - 2112*D1**2*f*fd*gd2*r*s + 1584*D1**2*f*fd*gd2*r - 1056*D1**2*f*fd*gd2*s**2 + 1584*D1**2*f*fd*gd2*s - 528*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r**2 - 1056*D1**2*f*fdd*g2*r*s + 528*D1**2*f*fdd*g2*r - 528*D1**2*f*fdd*g2*s**2 + 528*D1**2*f*fdd*g2*s - 264*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r**2 - 1056*D1**2*fd**2*g2*r*s + 528*D1**2*fd**2*g2*r - 528*D1**2*fd**2*g2*s**2 + 528*D1**2*fd**2*g2*s + 316*D1*Dd*f**3*r**2 + 632*D1*Dd*f**3*r*s - 474*D1*Dd*f**3*r + 316*D1*Dd*f**3*s**2 - 474*D1*Dd*f**3*s + 237*D1*Dd*f**3 - 2400*D1*Dd*f**2*fd*r**2 - 4800*D1*Dd*f**2*fd*r*s + 3400*D1*Dd*f**2*fd*r - 2400*D1*Dd*f**2*fd*s**2 + 3400*D1*Dd*f**2*fd*s - 1200*D1*Dd*f**2*fd + 1232*D1*Dd*f**2*g2*r**2 + 2464*D1*Dd*f**2*g2*r*s - 1848*D1*Dd*f**2*g2*r + 1232*D1*Dd*f**2*g2*s**2 - 1848*D1*Dd*f**2*g2*s + 924*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r**2 - 4224*D1*Dd*f**2*gd2*r*s + 3696*D1*Dd*f**2*gd2*r - 2112*D1*Dd*f**2*gd2*s**2 + 3696*D1*Dd*f**2*gd2*s - 1584*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r**2 - 8448*D1*Dd*f*fd*g2*r*s + 5280*D1*Dd*f*fd*g2*r - 4224*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1584*D1*Dd*f*fd*g2 - 400*D1*Ddd*f**3*r**2 - 800*D1*Ddd*f**3*r*s + 600*D1*Ddd*f**3*r - 400*D1*Ddd*f**3*s**2 + 600*D1*Ddd*f**3*s - 300*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r**2 - 2112*D1*Ddd*f**2*g2*r*s + 1584*D1*Ddd*f**2*g2*r - 1056*D1*Ddd*f**2*g2*s**2 + 1584*D1*Ddd*f**2*g2*s - 792*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(f**2*(22*C + 7*K - 16)*(r + s - 1) - 2*f*(3*fd*(4*C + 2*K - 3)*(2*r + 2*s - 1) + (19*g2 - 12*gd2)*(r + s - 1)) + 24*fd*g2*(r + s)) - 6*Dd*f*(f*(4*C + 2*K - 3) - 4*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1200*Dd**2*f**3*r**2 - 2400*Dd**2*f**3*r*s + 1800*Dd**2*f**3*r - 1200*Dd**2*f**3*s**2 + 1800*Dd**2*f**3*s - 600*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r**2 - 6336*Dd**2*f**2*g2*r*s + 4752*Dd**2*f**2*g2*r - 3168*Dd**2*f**2*g2*s**2 + 4752*Dd**2*f**2*g2*s - 1584*Dd**2*f**2*g2 + 11*b1**2*(D1**2*(3*f*(17*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(60*fd**2*(r + s - 1) + 19*fd*(2*K - 1)*(r + s) - 6*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(51*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (38*K - 19)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-2*K + 5*f + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-2*K + 5*f + 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*(-44*C*D1**2*f*fd*r**2 - 88*C*D1**2*f*fd*r*s + 44*C*D1**2*f*fd*r - 44*C*D1**2*f*fd*s**2 + 44*C*D1**2*f*fd*s - 22*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 88*C*D1*Dd*f**2*r**2 - 176*C*D1*Dd*f**2*r*s + 132*C*D1*Dd*f**2*r - 88*C*D1*Dd*f**2*s**2 + 132*C*D1*Dd*f**2*s - 66*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 14*D1**2*K*f*fd*r**2 - 28*D1**2*K*f*fd*r*s + 14*D1**2*K*f*fd*r - 14*D1**2*K*f*fd*s**2 + 14*D1**2*K*f*fd*s - 7*D1**2*K*f*fd + 12*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 12*D1**2*K*f*fdd*s**2 - 12*D1**2*K*f*fdd*s + 6*D1**2*K*f*fdd + 12*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 12*D1**2*K*fd**2*s**2 - 12*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-2*K + 5*f + 1)*(r + s - 1)**2 + 32*D1**2*f*fd*r**2 + 64*D1**2*f*fd*r*s - 32*D1**2*f*fd*r + 32*D1**2*f*fd*s**2 - 32*D1**2*f*fd*s + 16*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 38*D1**2*f*gd2*r**2 + 76*D1**2*f*gd2*r*s - 76*D1**2*f*gd2*r + 38*D1**2*f*gd2*s**2 - 76*D1**2*f*gd2*s + 38*D1**2*f*gd2 - 12*D1**2*f*gdd2*r**2 - 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*r - 12*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 12*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 38*D1**2*fd*g2*r**2 + 76*D1**2*fd*g2*r*s + 38*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r**2 - 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 24*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r**2 - 24*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 28*D1*Dd*K*f**2*r**2 - 56*D1*Dd*K*f**2*r*s + 42*D1*Dd*K*f**2*r - 28*D1*Dd*K*f**2*s**2 + 42*D1*Dd*K*f**2*s - 21*D1*Dd*K*f**2 + 96*D1*Dd*K*f*fd*r**2 + 192*D1*Dd*K*f*fd*r*s - 120*D1*Dd*K*f*fd*r + 96*D1*Dd*K*f*fd*s**2 - 120*D1*Dd*K*f*fd*s + 36*D1*Dd*K*f*fd + 64*D1*Dd*f**2*r**2 + 128*D1*Dd*f**2*r*s - 96*D1*Dd*f**2*r + 64*D1*Dd*f**2*s**2 - 96*D1*Dd*f**2*s + 48*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 152*D1*Dd*f*g2*r**2 + 304*D1*Dd*f*g2*r*s - 228*D1*Dd*f*g2*r + 152*D1*Dd*f*g2*s**2 - 228*D1*Dd*f*g2*s + 114*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r**2 - 192*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 168*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r**2 - 192*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 72*D1*Dd*fd*g2*s + 24*D1*Ddd*K*f**2*r**2 + 48*D1*Ddd*K*f**2*r*s - 36*D1*Ddd*K*f**2*r + 24*D1*Ddd*K*f**2*s**2 - 36*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r**2 - 96*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 72*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + D1*bd1*(D1*(51*f**2*(r + s - 1) - 60*f*fd*(2*r + 2*s - 1) - 19*f*(2*K - 1)*(r + s - 1) + 12*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-2*K + 5*f + 1)*(4*r + 4*s - 3))*(r + s - 1) + 72*Dd**2*K*f**2*r**2 + 144*Dd**2*K*f**2*r*s - 108*Dd**2*K*f**2*r + 72*Dd**2*K*f**2*s**2 - 108*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 144*Dd**2*f*g2*r**2 - 288*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 216*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(77*d**2*k3**8) - 8*D1**2*Pk2*Pk3*ct*k1**3*k2**3*(-2*D1*(r + s - 1)*(24*D1*K*bd1**2*f*(r + s - 1) - D1*bd1*(f**2*(4*C + 1)*(r + s - 1) - f*fd*(40*C - 20)*(2*r + 2*s - 1) - 6*f*(g2 - 8*gd2)*(r + s - 1) + 48*fd*g2*(r + s)) + 2*D1*bdd1*f*(f*(10*C - 5) - 12*g2)*(r + s - 1) + 4*Dd*bd1*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3)) + b1**2*(D1**2*(18*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-24*K*fdd + fd*(6*K + 7))) + D1*(Dd*(-48*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(6*K + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 144*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(D1**2*(f*(fd*(4*C + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*(r + s - 1)**2*(12*K*bdd1 + 3*gd2 - 12*gdd2)) + (-2*r - 2*s)*(fd**2*(20*C - 10)*(r + s - 1) + 3*fd*(g2*(r + s) - 8*gd2*(r + s - 1)) - 12*fdd*g2*(r + s))) + D1*bd1*(D1*(-48*K*fd*(r + s) + 18*f**2*(r + s - 1) + f*(6*K + 7)*(r + s - 1)) - 48*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(4*C + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 3*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 24*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 48*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(f*(10*C - 5) - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**8) + 2*D1**2*Pk2*Pk3*ct*k1**3*k2*st**2*(-528*C*D1**2*bdd1*f**2*r**2 - 1056*C*D1**2*bdd1*f**2*r*s + 1584*C*D1**2*bdd1*f**2*r - 528*C*D1**2*bdd1*f**2*s**2 + 1584*C*D1**2*bdd1*f**2*s - 792*C*D1**2*bdd1*f**2 + 8004*C*D1**2*f**2*fd*r**2 + 24816*C*D1**2*f**2*fd*r*s - 13608*C*D1**2*f**2*fd*r + 16812*C*D1**2*f**2*fd*s**2 - 19480*C*D1**2*f**2*fd*s + 8272*C*D1**2*f**2*fd - 7764*C*D1**2*f**2*fdd*r**2 - 23496*C*D1**2*f**2*fdd*r*s + 13008*C*D1**2*f**2*fdd*r - 15732*C*D1**2*f**2*fdd*s**2 + 18320*C*D1**2*f**2*fdd*s - 7832*C*D1**2*f**2*fdd - 15528*C*D1**2*f*fd**2*r**2 - 46992*C*D1**2*f*fd**2*r*s + 26016*C*D1**2*f*fd**2*r - 31464*C*D1**2*f*fd**2*s**2 + 36640*C*D1**2*f*fd**2*s - 7832*C*D1**2*f*fd**2 + 10672*C*D1*Dd*f**3*r**2 + 33088*C*D1*Dd*f**3*r*s - 18944*C*D1*Dd*f**3*r + 22416*C*D1*Dd*f**3*s**2 - 27752*C*D1*Dd*f**3*s + 10940*C*D1*Dd*f**3 - 62112*C*D1*Dd*f**2*fd*r**2 - 187968*C*D1*Dd*f**2*fd*r*s + 106584*C*D1*Dd*f**2*fd*r - 125856*C*D1*Dd*f**2*fd*s**2 + 151736*C*D1*Dd*f**2*fd*s - 44336*C*D1*Dd*f**2*fd - 10352*C*D1*Ddd*f**3*r**2 - 31328*C*D1*Ddd*f**3*r*s + 18184*C*D1*Ddd*f**3*r - 20976*C*D1*Ddd*f**3*s**2 + 26152*C*D1*Ddd*f**3*s - 10420*C*D1*Ddd*f**3 - 31056*C*Dd**2*f**3*r**2 - 93984*C*Dd**2*f**3*r*s + 54552*C*Dd**2*f**3*r - 62928*C*Dd**2*f**3*s**2 + 78456*C*Dd**2*f**3*s - 20840*C*Dd**2*f**3 - 1518*D1**2*K*bdd1*f**2*r**2 - 4620*D1**2*K*bdd1*f**2*r*s + 3036*D1**2*K*bdd1*f**2*r - 3102*D1**2*K*bdd1*f**2*s**2 + 4620*D1**2*K*bdd1*f**2*s - 1518*D1**2*K*bdd1*f**2 + 2112*D1**2*b2*f*fd*r**2 + 4224*D1**2*b2*f*fd*r*s - 2112*D1**2*b2*f*fd*r + 2112*D1**2*b2*f*fd*s**2 - 2112*D1**2*b2*f*fd*s + 1056*D1**2*b2*f*fd - 1584*D1**2*b2*f*fdd*r**2 - 3168*D1**2*b2*f*fdd*r*s + 1584*D1**2*b2*f*fdd*r - 1584*D1**2*b2*f*fdd*s**2 + 1584*D1**2*b2*f*fdd*s - 792*D1**2*b2*f*fdd - 1584*D1**2*b2*fd**2*r**2 - 3168*D1**2*b2*fd**2*r*s + 1584*D1**2*b2*fd**2*r - 1584*D1**2*b2*fd**2*s**2 + 1584*D1**2*b2*fd**2*s + 132*D1**2*bd1**2*f*(r + s - 1)*(K*(-4*r - 4*s + 6) + 18*f*(r + s - 1) + 11*r + 11*s - 12) + 1056*D1**2*bd2*f**2*r**2 + 2112*D1**2*bd2*f**2*r*s - 2112*D1**2*bd2*f**2*r + 1056*D1**2*bd2*f**2*s**2 - 2112*D1**2*bd2*f**2*s + 1056*D1**2*bd2*f**2 - 3168*D1**2*bd2*f*fd*r**2 - 6336*D1**2*bd2*f*fd*r*s + 4752*D1**2*bd2*f*fd*r - 3168*D1**2*bd2*f*fd*s**2 + 4752*D1**2*bd2*f*fd*s - 1584*D1**2*bd2*f*fd - 1584*D1**2*bdd1*f**3*r**2 + 1584*D1**2*bdd1*f**3*r + 1584*D1**2*bdd1*f**3*s**2 - 1584*D1**2*bdd1*f**3*s + 1353*D1**2*bdd1*f**2*r**2 + 3498*D1**2*bdd1*f**2*r*s - 3102*D1**2*bdd1*f**2*r + 2145*D1**2*bdd1*f**2*s**2 - 3894*D1**2*bdd1*f**2*s + 1551*D1**2*bdd1*f**2 + 528*D1**2*bdd1*f*g2*r**2 + 1056*D1**2*bdd1*f*g2*r*s - 1584*D1**2*bdd1*f*g2*r + 528*D1**2*bdd1*f*g2*s**2 - 1584*D1**2*bdd1*f*g2*s + 792*D1**2*bdd1*f*g2 - 792*D1**2*bdd2*f**2*r**2 - 1584*D1**2*bdd2*f**2*r*s + 1584*D1**2*bdd2*f**2*r - 792*D1**2*bdd2*f**2*s**2 + 1584*D1**2*bdd2*f**2*s - 792*D1**2*bdd2*f**2 - 4599*D1**2*f**2*fd*r**2 - 16002*D1**2*f**2*fd*r*s + 8400*D1**2*f**2*fd*r - 11403*D1**2*f**2*fd*s**2 + 12936*D1**2*f**2*fd*s - 5334*D1**2*f**2*fd + 4923*D1**2*f**2*fdd*r**2 + 15822*D1**2*f**2*fdd*r*s - 8556*D1**2*f**2*fdd*r + 10899*D1**2*f**2*fdd*s**2 - 12540*D1**2*f**2*fdd*s + 5274*D1**2*f**2*fdd - 3564*D1**2*f**2*gd2*r**2 - 11088*D1**2*f**2*gd2*r*s + 7128*D1**2*f**2*gd2*r - 7524*D1**2*f**2*gd2*s**2 + 11088*D1**2*f**2*gd2*s - 3564*D1**2*f**2*gd2 + 3036*D1**2*f**2*gdd2*r**2 + 9240*D1**2*f**2*gdd2*r*s - 6072*D1**2*f**2*gdd2*r + 6204*D1**2*f**2*gdd2*s**2 - 9240*D1**2*f**2*gdd2*s + 3036*D1**2*f**2*gdd2 + 9846*D1**2*f*fd**2*r**2 + 31644*D1**2*f*fd**2*r*s - 17112*D1**2*f*fd**2*r + 21798*D1**2*f*fd**2*s**2 - 25080*D1**2*f*fd**2*s + 5274*D1**2*f*fd**2 - 7128*D1**2*f*fd*g2*r**2 - 22176*D1**2*f*fd*g2*r*s + 11088*D1**2*f*fd*g2*r - 15048*D1**2*f*fd*g2*s**2 + 15048*D1**2*f*fd*g2*s - 7524*D1**2*f*fd*g2 + 12144*D1**2*f*fd*gd2*r**2 + 36960*D1**2*f*fd*gd2*r*s - 21384*D1**2*f*fd*gd2*r + 24816*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 9240*D1**2*f*fd*gd2 + 6072*D1**2*f*fdd*g2*r**2 + 18480*D1**2*f*fdd*g2*r*s - 9240*D1**2*f*fdd*g2*r + 12408*D1**2*f*fdd*g2*s**2 - 12408*D1**2*f*fdd*g2*s + 6204*D1**2*f*fdd*g2 + 6072*D1**2*fd**2*g2*r**2 + 18480*D1**2*fd**2*g2*r*s - 9240*D1**2*fd**2*g2*r + 12408*D1**2*fd**2*g2*s**2 - 12408*D1**2*fd**2*g2*s + 4224*D1*Dd*b2*f**2*r**2 + 8448*D1*Dd*b2*f**2*r*s - 6336*D1*Dd*b2*f**2*r + 4224*D1*Dd*b2*f**2*s**2 - 6336*D1*Dd*b2*f**2*s + 3168*D1*Dd*b2*f**2 - 12672*D1*Dd*b2*f*fd*r**2 - 25344*D1*Dd*b2*f*fd*r*s + 15840*D1*Dd*b2*f*fd*r - 12672*D1*Dd*b2*f*fd*s**2 + 15840*D1*Dd*b2*f*fd*s - 4752*D1*Dd*b2*f*fd - 6336*D1*Dd*bd2*f**2*r**2 - 12672*D1*Dd*bd2*f**2*r*s + 11088*D1*Dd*bd2*f**2*r - 6336*D1*Dd*bd2*f**2*s**2 + 11088*D1*Dd*bd2*f**2*s - 4752*D1*Dd*bd2*f**2 - 6132*D1*Dd*f**3*r**2 - 21336*D1*Dd*f**3*r*s + 11466*D1*Dd*f**3*r - 15204*D1*Dd*f**3*s**2 + 18270*D1*Dd*f**3*s - 6867*D1*Dd*f**3 + 39384*D1*Dd*f**2*fd*r**2 + 126576*D1*Dd*f**2*fd*r*s - 69738*D1*Dd*f**2*fd*r + 87192*D1*Dd*f**2*fd*s**2 - 103602*D1*Dd*f**2*fd*s + 29652*D1*Dd*f**2*fd - 14256*D1*Dd*f**2*g2*r**2 - 44352*D1*Dd*f**2*g2*r*s + 25344*D1*Dd*f**2*g2*r - 30096*D1*Dd*f**2*g2*s**2 + 37224*D1*Dd*f**2*g2*s - 14652*D1*Dd*f**2*g2 + 24288*D1*Dd*f**2*gd2*r**2 + 73920*D1*Dd*f**2*gd2*r*s - 45672*D1*Dd*f**2*gd2*r + 49632*D1*Dd*f**2*gd2*s**2 - 67848*D1*Dd*f**2*gd2*s + 21384*D1*Dd*f**2*gd2 + 48576*D1*Dd*f*fd*g2*r**2 + 147840*D1*Dd*f*fd*g2*r*s - 79728*D1*Dd*f*fd*g2*r + 99264*D1*Dd*f*fd*g2*s**2 - 111408*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 3168*D1*Ddd*b2*f**2*r**2 - 6336*D1*Ddd*b2*f**2*r*s + 4752*D1*Ddd*b2*f**2*r - 3168*D1*Ddd*b2*f**2*s**2 + 4752*D1*Ddd*b2*f**2*s - 2376*D1*Ddd*b2*f**2 + 6564*D1*Ddd*f**3*r**2 + 21096*D1*Ddd*f**3*r*s - 11838*D1*Ddd*f**3*r + 14532*D1*Ddd*f**3*s**2 - 17814*D1*Ddd*f**3*s + 6915*D1*Ddd*f**3 + 12144*D1*Ddd*f**2*g2*r**2 + 36960*D1*Ddd*f**2*g2*r*s - 21384*D1*Ddd*f**2*g2*r + 24816*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 12276*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(6*f**3*(10*r**2 + 4*r*(s - 4) - 6*s**2 + 7) + f**2*(8*C*(5*r**2 + r*(9*s - 11) + 4*s**2 - 10*s + 5) + 54*K*r**2 + 168*K*r*s - 108*K*r + 114*K*s**2 - 168*K*s + 54*K - 48*fd*(6*r**2 - 6*r - 6*s**2 + 4*s + 1) - 71*r**2 - 166*r*s + 146*r - 95*s**2 + 170*s - 69) - 2*f*fd*(8*C*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 2*K*(46*r**2 + 140*r*s - 81*r + 94*s**2 - 117*s + 35) - 82*r**2 - 212*r*s + 141*r - 130*s**2 + 177*s - 59) + 8*f*(g2*(3*r**2 - r*(s - 19) - 4*s**2 + 26*s - 13) + 2*gd2*(2*r**2 + r*(4*s - 5) + 2*s**2 - 5*s + 3)) + 32*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(24*f**2*(8*r**2 - 8*r - 8*s**2 + 6*s + 1) + f*(8*C*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + 2*K*(92*r**2 + 280*r*s - 173*r + 188*s**2 - 257*s + 81) - 164*r**2 - 424*r*s + 323*r - 260*s**2 + 407*s - 153) - 8*g2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9))) - 9504*Dd**2*b2*f**2*r**2 - 19008*Dd**2*b2*f**2*r*s + 14256*Dd**2*b2*f**2*r - 9504*Dd**2*b2*f**2*s**2 + 14256*Dd**2*b2*f**2*s - 4752*Dd**2*b2*f**2 + 19692*Dd**2*f**3*r**2 + 63288*Dd**2*f**3*r*s - 35514*Dd**2*f**3*r + 43596*Dd**2*f**3*s**2 - 53442*Dd**2*f**3*s + 13830*Dd**2*f**3 + 36432*Dd**2*f**2*g2*r**2 + 110880*Dd**2*f**2*g2*r*s - 64152*Dd**2*f**2*g2*r + 74448*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 24552*Dd**2*f**2*g2 - 66*b1**2*(D1**2*(-36*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*K*(3*r**2 - r*(s + 18) - 4*s**2 - 18*s + 9) + f*(64*r**2 + 2*r*(64*s - 35) + 64*s**2 - 70*s + 35) + 22*r**2 + 58*r*s + 18*r + 36*s**2 + 18*s - 9) - fdd*(-2*K*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) + 18*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 11*r**2 + 22*r*s + 2*r + 11*s**2 + 2*s - 1)) + D1*(2*Dd*(16*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(K*(12*r**2 - 4*r*s - 11*r - 16*s**2 + 10*s + 2) - 18*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 44*r**2 + 116*r*s - 73*r + 72*s**2 - 94*s + 40) + fd*(4*r + 4*s - 3)*(K*(4*r + 4*s + 2) - 11*r - 11*s - 1)) - Ddd*f*(-4*K + 18*f + 11)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-4*K + 18*f + 11)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-80*C*D1**2*f*fd*r**2 - 144*C*D1**2*f*fd*r*s + 64*C*D1**2*f*fd*r - 64*C*D1**2*f*fd*s**2 + 56*C*D1**2*f*fd*s - 32*C*D1**2*f*fd + 32*C*D1**2*f*fdd*r**2 + 64*C*D1**2*f*fdd*r*s - 16*C*D1**2*f*fdd*r + 32*C*D1**2*f*fdd*s**2 - 16*C*D1**2*f*fdd*s + 8*C*D1**2*f*fdd + 32*C*D1**2*fd**2*r**2 + 64*C*D1**2*fd**2*r*s - 16*C*D1**2*fd**2*r + 32*C*D1**2*fd**2*s**2 - 16*C*D1**2*fd**2*s - 16*C*D1**2*fd**2 - 160*C*D1*Dd*f**2*r**2 - 288*C*D1*Dd*f**2*r*s + 232*C*D1*Dd*f**2*r - 128*C*D1*Dd*f**2*s**2 + 208*C*D1*Dd*f**2*s - 112*C*D1*Dd*f**2 + 256*C*D1*Dd*f*fd*r**2 + 512*C*D1*Dd*f*fd*r*s - 256*C*D1*Dd*f*fd*r + 256*C*D1*Dd*f*fd*s**2 - 256*C*D1*Dd*f*fd*s + 48*C*D1*Dd*f*fd + 64*C*D1*Ddd*f**2*r**2 + 128*C*D1*Ddd*f**2*r*s - 96*C*D1*Ddd*f**2*r + 64*C*D1*Ddd*f**2*s**2 - 96*C*D1*Ddd*f**2*s + 48*C*D1*Ddd*f**2 + 192*C*Dd**2*f**2*r**2 + 384*C*Dd**2*f**2*r*s - 288*C*Dd**2*f**2*r + 192*C*Dd**2*f**2*s**2 - 288*C*Dd**2*f**2*s + 96*C*Dd**2*f**2 - 108*D1**2*K*f*fd*r**2 - 336*D1**2*K*f*fd*r*s + 168*D1**2*K*f*fd*r - 228*D1**2*K*f*fd*s**2 + 228*D1**2*K*f*fd*s - 114*D1**2*K*f*fd + 92*D1**2*K*f*fdd*r**2 + 280*D1**2*K*f*fdd*r*s - 140*D1**2*K*f*fdd*r + 188*D1**2*K*f*fdd*s**2 - 188*D1**2*K*f*fdd*s + 94*D1**2*K*f*fdd + 92*D1**2*K*fd**2*r**2 + 280*D1**2*K*fd**2*r*s - 140*D1**2*K*fd**2*r + 188*D1**2*K*fd**2*s**2 - 188*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-2*K*(4*r**2 + 8*r*s - 10*r + 4*s**2 - 10*s + 5) + 36*f*(r + s - 1)**2 + 22*r**2 + 44*r*s - 46*r + 22*s**2 - 46*s + 23) - 180*D1**2*f**2*fd*r**2 - 72*D1**2*f**2*fd*r*s + 168*D1**2*f**2*fd*r + 108*D1**2*f**2*fd*s**2 - 24*D1**2*f**2*fd*s - 42*D1**2*f**2*fd + 144*D1**2*f**2*fdd*r**2 - 144*D1**2*f**2*fdd*r - 144*D1**2*f**2*fdd*s**2 + 48*D1**2*f**2*fdd*s + 48*D1**2*f**2*fdd + 288*D1**2*f*fd**2*r**2 - 288*D1**2*f*fd**2*r - 288*D1**2*f*fd**2*s**2 + 96*D1**2*f*fd**2*s + 48*D1**2*f*fd**2 + 142*D1**2*f*fd*r**2 + 332*D1**2*f*fd*r*s - 162*D1**2*f*fd*r + 190*D1**2*f*fd*s**2 - 186*D1**2*f*fd*s + 97*D1**2*f*fd - 82*D1**2*f*fdd*r**2 - 212*D1**2*f*fdd*r*s + 94*D1**2*f*fdd*r - 130*D1**2*f*fdd*s**2 + 118*D1**2*f*fdd*s - 59*D1**2*f*fdd - 24*D1**2*f*gd2*r**2 + 8*D1**2*f*gd2*r*s + 48*D1**2*f*gd2*r + 32*D1**2*f*gd2*s**2 - 8*D1**2*f*gd2*s - 24*D1**2*f*gd2 - 16*D1**2*f*gdd2*r**2 - 32*D1**2*f*gdd2*r*s + 32*D1**2*f*gdd2*r - 16*D1**2*f*gdd2*s**2 + 32*D1**2*f*gdd2*s - 16*D1**2*f*gdd2 - 82*D1**2*fd**2*r**2 - 212*D1**2*fd**2*r*s + 94*D1**2*fd**2*r - 130*D1**2*fd**2*s**2 + 118*D1**2*fd**2*s + 12*D1**2*fd**2 - 24*D1**2*fd*g2*r**2 + 8*D1**2*fd*g2*r*s + 144*D1**2*fd*g2*r + 32*D1**2*fd*g2*s**2 + 144*D1**2*fd*g2*s - 72*D1**2*fd*g2 - 32*D1**2*fd*gd2*r**2 - 64*D1**2*fd*gd2*r*s + 16*D1**2*fd*gd2*r - 32*D1**2*fd*gd2*s**2 + 16*D1**2*fd*gd2*s + 16*D1**2*fd*gd2 - 16*D1**2*fdd*g2*r**2 - 32*D1**2*fdd*g2*r*s - 16*D1**2*fdd*g2*r - 16*D1**2*fdd*g2*s**2 - 16*D1**2*fdd*g2*s + 8*D1**2*fdd*g2 - 216*D1*Dd*K*f**2*r**2 - 672*D1*Dd*K*f**2*r*s + 384*D1*Dd*K*f**2*r - 456*D1*Dd*K*f**2*s**2 + 564*D1*Dd*K*f**2*s - 222*D1*Dd*K*f**2 + 736*D1*Dd*K*f*fd*r**2 + 2240*D1*Dd*K*f*fd*r*s - 1208*D1*Dd*K*f*fd*r + 1504*D1*Dd*K*f*fd*s**2 - 1688*D1*Dd*K*f*fd*s + 468*D1*Dd*K*f*fd - 240*D1*Dd*f**3*r**2 - 96*D1*Dd*f**3*r*s + 264*D1*Dd*f**3*r + 144*D1*Dd*f**3*s**2 - 24*D1*Dd*f**3*s - 84*D1*Dd*f**3 + 1152*D1*Dd*f**2*fd*r**2 - 1152*D1*Dd*f**2*fd*r - 1152*D1*Dd*f**2*fd*s**2 + 480*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd + 284*D1*Dd*f**2*r**2 + 664*D1*Dd*f**2*r*s - 450*D1*Dd*f**2*r + 380*D1*Dd*f**2*s**2 - 522*D1*Dd*f**2*s + 237*D1*Dd*f**2 - 656*D1*Dd*f*fd*r**2 - 1696*D1*Dd*f*fd*r*s + 916*D1*Dd*f*fd*r - 1040*D1*Dd*f*fd*s**2 + 1156*D1*Dd*f*fd*s - 306*D1*Dd*f*fd - 96*D1*Dd*f*g2*r**2 + 32*D1*Dd*f*g2*r*s + 88*D1*Dd*f*g2*r + 128*D1*Dd*f*g2*s**2 - 80*D1*Dd*f*g2*s - 16*D1*Dd*f*g2 - 128*D1*Dd*f*gd2*r**2 - 256*D1*Dd*f*gd2*r*s + 224*D1*Dd*f*gd2*r - 128*D1*Dd*f*gd2*s**2 + 224*D1*Dd*f*gd2*s - 96*D1*Dd*f*gd2 - 128*D1*Dd*fd*g2*r**2 - 256*D1*Dd*fd*g2*r*s + 32*D1*Dd*fd*g2*r - 128*D1*Dd*fd*g2*s**2 + 32*D1*Dd*fd*g2*s + 48*D1*Dd*fd*g2 + 184*D1*Ddd*K*f**2*r**2 + 560*D1*Ddd*K*f**2*r*s - 324*D1*Ddd*K*f**2*r + 376*D1*Ddd*K*f**2*s**2 - 468*D1*Ddd*K*f**2*s + 186*D1*Ddd*K*f**2 + 192*D1*Ddd*f**3*r**2 - 192*D1*Ddd*f**3*r - 192*D1*Ddd*f**3*s**2 + 96*D1*Ddd*f**3*s + 48*D1*Ddd*f**3 - 164*D1*Ddd*f**2*r**2 - 424*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 260*D1*Ddd*f**2*s**2 + 342*D1*Ddd*f**2*s - 147*D1*Ddd*f**2 - 64*D1*Ddd*f*g2*r**2 - 128*D1*Ddd*f*g2*r*s + 96*D1*Ddd*f*g2*r - 64*D1*Ddd*f*g2*s**2 + 96*D1*Ddd*f*g2*s - 48*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*(64*r**2 + 2*r*(64*s - 61) + 64*s**2 - 122*s + 61) + f*(2*K*(6*r**2 - 2*r*s + 13*r - 8*s**2 + 27*s - 10) - 72*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 44*r**2 + 116*r*s - 120*r + 72*s**2 - 148*s + 67) + 2*fd*(r + s - 1)*(K*(8*r + 8*s + 2) - 22*r - 22*s - 1)) - 2*Dd*f*(4*r + 4*s - 3)*(-2*K*(4*r + 4*s - 5) + 36*f*(r + s - 1) + 22*r + 22*s - 23)) + 552*Dd**2*K*f**2*r**2 + 1680*Dd**2*K*f**2*r*s - 972*Dd**2*K*f**2*r + 1128*Dd**2*K*f**2*s**2 - 1404*Dd**2*K*f**2*s + 372*Dd**2*K*f**2 + 576*Dd**2*f**3*r**2 - 576*Dd**2*f**3*r - 576*Dd**2*f**3*s**2 + 288*Dd**2*f**3*s + 96*Dd**2*f**3 - 492*Dd**2*f**2*r**2 - 1272*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 780*Dd**2*f**2*s**2 + 1026*Dd**2*f**2*s - 294*Dd**2*f**2 - 192*Dd**2*f*g2*r**2 - 384*Dd**2*f*g2*r*s + 288*Dd**2*f*g2*r - 192*Dd**2*f*g2*s**2 + 288*Dd**2*f*g2*s - 96*Dd**2*f*g2))/(693*d**2*k3**6) + 4*D1**2*Pk2*Pk3*ct*k1**3*k2*(2*D1**2*bd1**2*(r + s - 1)*(6*f**2*(29*r + 21*s - 25) + f*(48*C*r + 48*C*s - 2*K*(71*r + 107*s - 89) + 11*r + 35*s - 59) - 56*g2*(r + s)) - 4*D1**2*bdd1*f*(f*(64*C*r + 90*C*(s - 1) + 6*K*s - 43*r - 60*s + 60) + g2*(-71*r - 107*s + 107))*(r + s - 1) - 4*D1**2*(f**2*(-fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(12*gd2 - 12*gdd2)*(r + s - 1)) + f*(fd**2*(10*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 12*fd*(g2*(2*r*s - r + 2*s**2 - 2*s + 1) + gd2*(-4*r*s + r - 4*s**2 + 4*s - 1)) - 12*fdd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 12*fd**2*g2*(-2*r*s + r - s*(2*s - 2))) + 8*D1*b2*(-6*D1*bdd1*f*(r + s - 1) + bd1*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + 2*D1*bd1*(-48*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(r + s - 1)*(76*C*r + 132*C*(s - 1) + 12*K*s - 37*r - 81*s + 81) - 2*f*(fd*(2*C*(128*r**2 + r*(308*s - 218) + 180*s**2 - 257*s + 77) + 6*K*(r*(4*s - 1) + (1 - 2*s)**2) - 172*r**2 - 412*r*s + 292*r - 240*s**2 + 343*s - 103) + (r + s - 1)*(37*g2*r + 81*g2*(s - 1) - 2*gd2*(71*r + 107*s - 89))) + 4*fd*g2*(71*r**2 + 89*r*(2*s - 1) + s*(107*s - 107))) - 2*Dd*f*(f*(2*C*(256*r**2 + 616*r*s - 513*r + 360*s**2 - 604*s + 244) + 6*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 344*r**2 - 824*r*s + 687*r - 480*s**2 + 806*s - 326) - 2*g2*(284*r**2 + r*(712*s - 587) + 428*s**2 - 713*s + 285))) + 4*D1*f*(Dd*(f**2*(10*C - 5)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(5 - 10*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 12*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 12*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 24*fd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 4*Dd**2*f**2*(f*(10*C - 5) - 12*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 2*b1**3*(3*D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(15*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 36*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 18*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 18*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-40*C*D1**2*fd*r**2 - 80*C*D1**2*fd*r*s + 80*C*D1**2*fd*r - 40*C*D1**2*fd*s**2 + 80*C*D1**2*fd*s - 40*C*D1**2*fd + 48*C*D1**2*fdd*r**2 + 96*C*D1**2*fdd*r*s - 96*C*D1**2*fdd*r + 48*C*D1**2*fdd*s**2 - 96*C*D1**2*fdd*s + 48*C*D1**2*fdd - 160*C*D1*Dd*f*r**2 - 320*C*D1*Dd*f*r*s + 240*C*D1*Dd*f*r - 160*C*D1*Dd*f*s**2 + 240*C*D1*Dd*f*s - 120*C*D1*Dd*f + 384*C*D1*Dd*fd*r**2 + 768*C*D1*Dd*fd*r*s - 672*C*D1*Dd*fd*r + 384*C*D1*Dd*fd*s**2 - 672*C*D1*Dd*fd*s + 288*C*D1*Dd*fd + 192*C*D1*Ddd*f*r**2 + 384*C*D1*Ddd*f*r*s - 288*C*D1*Ddd*f*r + 192*C*D1*Ddd*f*s**2 - 288*C*D1*Ddd*f*s + 144*C*D1*Ddd*f + 576*C*Dd**2*f*r**2 + 1152*C*Dd**2*f*r*s - 864*C*Dd**2*f*r + 576*C*Dd**2*f*s**2 - 864*C*Dd**2*f*s + 288*C*Dd**2*f + 74*D1**2*K*fd*r**2 + 236*D1**2*K*fd*r*s + 162*D1**2*K*fd*s**2 - 142*D1**2*K*fdd*r**2 - 356*D1**2*K*fdd*r*s - 214*D1**2*K*fdd*s**2 - 2*D1**2*bdd1*(-14*K + 18*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 228*D1**2*f*fd*r**2 - 360*D1**2*f*fd*r*s + 204*D1**2*f*fd*r - 132*D1**2*f*fd*s**2 + 156*D1**2*f*fd*s - 102*D1**2*f*fd + 348*D1**2*f*fdd*r**2 + 600*D1**2*f*fdd*r*s - 348*D1**2*f*fdd*r + 252*D1**2*f*fdd*s**2 - 300*D1**2*f*fdd*s + 174*D1**2*f*fdd + 348*D1**2*fd**2*r**2 + 600*D1**2*fd**2*r*s - 348*D1**2*fd**2*r + 252*D1**2*fd**2*s**2 - 300*D1**2*fd**2*s + 41*D1**2*fd*r**2 + 34*D1**2*fd*r*s - 60*D1**2*fd*r - 7*D1**2*fd*s**2 - 60*D1**2*fd*s + 30*D1**2*fd + 11*D1**2*fdd*r**2 + 46*D1**2*fdd*r*s + 72*D1**2*fdd*r + 35*D1**2*fdd*s**2 + 72*D1**2*fdd*s - 36*D1**2*fdd + 112*D1**2*gd2*r**2 + 224*D1**2*gd2*r*s - 224*D1**2*gd2*r + 112*D1**2*gd2*s**2 - 224*D1**2*gd2*s + 112*D1**2*gd2 - 56*D1**2*gdd2*r**2 - 112*D1**2*gdd2*r*s + 112*D1**2*gdd2*r - 56*D1**2*gdd2*s**2 + 112*D1**2*gdd2*s - 56*D1**2*gdd2 + 296*D1*Dd*K*f*r**2 + 944*D1*Dd*K*f*r*s - 532*D1*Dd*K*f*r + 648*D1*Dd*K*f*s**2 - 796*D1*Dd*K*f*s + 310*D1*Dd*K*f - 1136*D1*Dd*K*fd*r**2 - 2848*D1*Dd*K*fd*r*s + 924*D1*Dd*K*fd*r - 1712*D1*Dd*K*fd*s**2 + 1140*D1*Dd*K*fd*s - 456*D1*Dd*f**2*r**2 - 720*D1*Dd*f**2*r*s + 636*D1*Dd*f**2*r - 264*D1*Dd*f**2*s**2 + 492*D1*Dd*f**2*s - 294*D1*Dd*f**2 + 2784*D1*Dd*f*fd*r**2 + 4800*D1*Dd*f*fd*r*s - 3384*D1*Dd*f*fd*r + 2016*D1*Dd*f*fd*s**2 - 2904*D1*Dd*f*fd*s + 996*D1*Dd*f*fd + 164*D1*Dd*f*r**2 + 136*D1*Dd*f*r*s - 198*D1*Dd*f*r - 28*D1*Dd*f*s**2 - 54*D1*Dd*f*s + 75*D1*Dd*f + 88*D1*Dd*fd*r**2 + 368*D1*Dd*fd*r*s + 198*D1*Dd*fd*r + 280*D1*Dd*fd*s**2 + 126*D1*Dd*fd*s - 216*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 896*D1*Dd*g2*r*s - 672*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 672*D1*Dd*g2*s + 336*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 896*D1*Dd*gd2*r*s + 784*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 784*D1*Dd*gd2*s - 336*D1*Dd*gd2 - 568*D1*Ddd*K*f*r**2 - 1424*D1*Ddd*K*f*r*s + 924*D1*Ddd*K*f*r - 856*D1*Ddd*K*f*s**2 + 1140*D1*Ddd*K*f*s - 498*D1*Ddd*K*f + 696*D1*Ddd*f**2*r**2 + 1200*D1*Ddd*f**2*r*s - 996*D1*Ddd*f**2*r + 504*D1*Ddd*f**2*s**2 - 852*D1*Ddd*f**2*s + 474*D1*Ddd*f**2 + 44*D1*Ddd*f*r**2 + 184*D1*Ddd*f*r*s - 90*D1*Ddd*f*r + 140*D1*Ddd*f*s**2 - 162*D1*Ddd*f*s + 57*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 448*D1*Ddd*g2*r*s + 336*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 336*D1*Ddd*g2*s - 168*D1*Ddd*g2 + 2*D1*bd1*(D1*(15*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 36*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-14*K + 18*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 1704*Dd**2*K*f*r**2 - 4272*Dd**2*K*f*r*s + 2772*Dd**2*K*f*r - 2568*Dd**2*K*f*s**2 + 3420*Dd**2*K*f*s - 996*Dd**2*K*f + 2088*Dd**2*f**2*r**2 + 3600*Dd**2*f**2*r*s - 2988*Dd**2*f**2*r + 1512*Dd**2*f**2*s**2 - 2556*Dd**2*f**2*s + 948*Dd**2*f**2 + 132*Dd**2*f*r**2 + 552*Dd**2*f*r*s - 270*Dd**2*f*r + 420*Dd**2*f*s**2 - 486*Dd**2*f*s + 114*Dd**2*f - 672*Dd**2*g2*r**2 - 1344*Dd**2*g2*r*s + 1008*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 1008*Dd**2*g2*s - 336*Dd**2*g2) - 2*b1*(-48*C*D1**2*bdd1*f*r**2 - 96*C*D1**2*bdd1*f*r*s + 48*C*D1**2*bdd1*f*r - 48*C*D1**2*bdd1*f*s**2 + 48*C*D1**2*bdd1*f*s - 24*C*D1**2*bdd1*f - 152*C*D1**2*f*fd*r**2 - 416*C*D1**2*f*fd*r*s + 152*C*D1**2*f*fd*r - 264*C*D1**2*f*fd*s**2 + 208*C*D1**2*f*fd*s - 76*C*D1**2*f*fd + 256*C*D1**2*f*fdd*r**2 + 616*C*D1**2*f*fdd*r*s - 256*C*D1**2*f*fdd*r + 360*C*D1**2*f*fdd*s**2 - 308*C*D1**2*f*fdd*s + 128*C*D1**2*f*fdd + 256*C*D1**2*fd**2*r**2 + 616*C*D1**2*fd**2*r*s - 256*C*D1**2*fd**2*r + 360*C*D1**2*fd**2*s**2 - 308*C*D1**2*fd**2*s - 304*C*D1*Dd*f**2*r**2 - 832*C*D1*Dd*f**2*r*s + 512*C*D1*Dd*f**2*r - 528*C*D1*Dd*f**2*s**2 + 680*C*D1*Dd*f**2*s - 284*C*D1*Dd*f**2 + 2048*C*D1*Dd*f*fd*r**2 + 4928*C*D1*Dd*f*fd*r*s - 2664*C*D1*Dd*f*fd*r + 2880*C*D1*Dd*f*fd*s**2 - 3184*C*D1*Dd*f*fd*s + 820*C*D1*Dd*f*fd + 512*C*D1*Ddd*f**2*r**2 + 1232*C*D1*Ddd*f**2*r*s - 820*C*D1*Ddd*f**2*r + 720*C*D1*Ddd*f**2*s**2 - 976*C*D1*Ddd*f**2*s + 436*C*D1*Ddd*f**2 + 1536*C*Dd**2*f**2*r**2 + 3696*C*Dd**2*f**2*r*s - 2460*C*Dd**2*f**2*r + 2160*C*Dd**2*f**2*s**2 - 2928*C*Dd**2*f**2*s + 872*C*Dd**2*f**2 + 142*D1**2*K*bdd1*f*r**2 + 356*D1**2*K*bdd1*f*r*s - 320*D1**2*K*bdd1*f*r + 214*D1**2*K*bdd1*f*s**2 - 392*D1**2*K*bdd1*f*s + 178*D1**2*K*bdd1*f - 24*D1**2*K*f*fd*r*s + 12*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 24*D1**2*K*f*fdd*s**2 - 24*D1**2*K*f*fdd*s + 12*D1**2*K*f*fdd + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 24*D1**2*K*fd**2*s**2 - 24*D1**2*K*fd**2*s - 20*D1**2*b2*fd*r**2 - 40*D1**2*b2*fd*r*s - 20*D1**2*b2*fd*s**2 + 24*D1**2*b2*fdd*r**2 + 48*D1**2*b2*fdd*r*s + 24*D1**2*b2*fdd*s**2 + 2*D1**2*bd1**2*(-14*K + 18*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 174*D1**2*bdd1*f**2*r**2 - 300*D1**2*bdd1*f**2*r*s + 324*D1**2*bdd1*f**2*r - 126*D1**2*bdd1*f**2*s**2 + 276*D1**2*bdd1*f**2*s - 150*D1**2*bdd1*f**2 - 11*D1**2*bdd1*f*r**2 - 46*D1**2*bdd1*f*r*s + 70*D1**2*bdd1*f*r - 35*D1**2*bdd1*f*s**2 + 94*D1**2*bdd1*f*s - 41*D1**2*bdd1*f + 56*D1**2*bdd1*g2*r**2 + 112*D1**2*bdd1*g2*r*s - 56*D1**2*bdd1*g2*r + 56*D1**2*bdd1*g2*s**2 - 56*D1**2*bdd1*g2*s + 28*D1**2*bdd1*g2 + 24*D1**2*bdd2*f*r**2 + 48*D1**2*bdd2*f*r*s - 48*D1**2*bdd2*f*r + 24*D1**2*bdd2*f*s**2 - 48*D1**2*bdd2*f*s + 24*D1**2*bdd2*f + 74*D1**2*f*fd*r**2 + 236*D1**2*f*fd*r*s - 74*D1**2*f*fd*r + 162*D1**2*f*fd*s**2 - 118*D1**2*f*fd*s + 37*D1**2*f*fd - 172*D1**2*f*fdd*r**2 - 412*D1**2*f*fdd*r*s + 172*D1**2*f*fdd*r - 240*D1**2*f*fdd*s**2 + 206*D1**2*f*fdd*s - 86*D1**2*f*fdd + 74*D1**2*f*gd2*r**2 + 236*D1**2*f*gd2*r*s - 148*D1**2*f*gd2*r + 162*D1**2*f*gd2*s**2 - 236*D1**2*f*gd2*s + 74*D1**2*f*gd2 - 142*D1**2*f*gdd2*r**2 - 356*D1**2*f*gdd2*r*s + 284*D1**2*f*gdd2*r - 214*D1**2*f*gdd2*s**2 + 356*D1**2*f*gdd2*s - 142*D1**2*f*gdd2 - 172*D1**2*fd**2*r**2 - 412*D1**2*fd**2*r*s + 172*D1**2*fd**2*r - 240*D1**2*fd**2*s**2 + 206*D1**2*fd**2*s + 74*D1**2*fd*g2*r**2 + 236*D1**2*fd*g2*r*s + 162*D1**2*fd*g2*s**2 - 284*D1**2*fd*gd2*r**2 - 712*D1**2*fd*gd2*r*s + 284*D1**2*fd*gd2*r - 428*D1**2*fd*gd2*s**2 + 356*D1**2*fd*gd2*s - 142*D1**2*fdd*g2*r**2 - 356*D1**2*fdd*g2*r*s - 214*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r*s + 12*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 48*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 192*D1*Dd*K*f*fd*r*s - 72*D1*Dd*K*f*fd*r + 192*D1*Dd*K*f*fd*s**2 - 192*D1*Dd*K*f*fd*s + 48*D1*Dd*K*f*fd - 80*D1*Dd*b2*f*r**2 - 160*D1*Dd*b2*f*r*s + 120*D1*Dd*b2*f*r - 80*D1*Dd*b2*f*s**2 + 120*D1*Dd*b2*f*s - 60*D1*Dd*b2*f + 192*D1*Dd*b2*fd*r**2 + 384*D1*Dd*b2*fd*r*s - 144*D1*Dd*b2*fd*r + 192*D1*Dd*b2*fd*s**2 - 144*D1*Dd*b2*fd*s + 148*D1*Dd*f**2*r**2 + 472*D1*Dd*f**2*r*s - 266*D1*Dd*f**2*r + 324*D1*Dd*f**2*s**2 - 398*D1*Dd*f**2*s + 155*D1*Dd*f**2 - 1376*D1*Dd*f*fd*r**2 - 3296*D1*Dd*f*fd*r*s + 1788*D1*Dd*f*fd*r - 1920*D1*Dd*f*fd*s**2 + 2128*D1*Dd*f*fd*s - 550*D1*Dd*f*fd + 296*D1*Dd*f*g2*r**2 + 944*D1*Dd*f*g2*r*s - 532*D1*Dd*f*g2*r + 648*D1*Dd*f*g2*s**2 - 796*D1*Dd*f*g2*s + 310*D1*Dd*f*g2 - 1136*D1*Dd*f*gd2*r**2 - 2848*D1*Dd*f*gd2*r*s + 2060*D1*Dd*f*gd2*r - 1712*D1*Dd*f*gd2*s**2 + 2564*D1*Dd*f*gd2*s - 924*D1*Dd*f*gd2 - 1136*D1*Dd*fd*g2*r**2 - 2848*D1*Dd*fd*g2*r*s + 924*D1*Dd*fd*g2*r - 1712*D1*Dd*fd*g2*s**2 + 1140*D1*Dd*fd*g2*s + 48*D1*Ddd*K*f**2*r*s - 12*D1*Ddd*K*f**2*r + 48*D1*Ddd*K*f**2*s**2 - 48*D1*Ddd*K*f**2*s + 12*D1*Ddd*K*f**2 + 96*D1*Ddd*b2*f*r**2 + 192*D1*Ddd*b2*f*r*s - 144*D1*Ddd*b2*f*r + 96*D1*Ddd*b2*f*s**2 - 144*D1*Ddd*b2*f*s + 72*D1*Ddd*b2*f - 344*D1*Ddd*f**2*r**2 - 824*D1*Ddd*f**2*r*s + 550*D1*Ddd*f**2*r - 480*D1*Ddd*f**2*s**2 + 652*D1*Ddd*f**2*s - 292*D1*Ddd*f**2 - 568*D1*Ddd*f*g2*r**2 - 1424*D1*Ddd*f*g2*r*s + 924*D1*Ddd*f*g2*r - 856*D1*Ddd*f*g2*s**2 + 1140*D1*Ddd*f*g2*s - 498*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(19*r**2 + 6*r*(5*s - 6) + 11*s**2 - 28*s + 16) + f*(20*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 74*K*r**2 - 236*K*r*s + 192*K*r - 162*K*s**2 + 280*K*s - 118*K - 12*fd*(58*r**2 + 100*r*s - 83*r + 42*s**2 - 71*s + 27) - 41*r**2 - 34*r*s + 28*r + 7*s**2 - 20*s - 2) - 2*fd*(24*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 214*K*s**2 + 196*K*s + r**2*(11 - 142*K) + r*(-356*K*s + 160*K + 46*s + 1) + 35*s**2 - 11*s - 18) - 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(6*f**2*(116*r**2 + r*(200*s - 191) + 84*s**2 - 163*s + 77) + f*(24*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 2*K*(284*r**2 + 712*r*s - 551*r + 428*s**2 - 677*s + 258) + 44*r**2 + 184*r*s - 185*r + 140*s**2 - 269*s + 117) - 28*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 4*D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 144*Dd**2*K*f**2*r*s - 36*Dd**2*K*f**2*r + 144*Dd**2*K*f**2*s**2 - 144*Dd**2*K*f**2*s + 24*Dd**2*K*f**2 + 288*Dd**2*b2*f*r**2 + 576*Dd**2*b2*f*r*s - 432*Dd**2*b2*f*r + 288*Dd**2*b2*f*s**2 - 432*Dd**2*b2*f*s + 144*Dd**2*b2*f - 1032*Dd**2*f**2*r**2 - 2472*Dd**2*f**2*r*s + 1650*Dd**2*f**2*r - 1440*Dd**2*f**2*s**2 + 1956*Dd**2*f**2*s - 584*Dd**2*f**2 - 1704*Dd**2*f*g2*r**2 - 4272*Dd**2*f*g2*r*s + 2772*Dd**2*f*g2*r - 2568*Dd**2*f*g2*s**2 + 3420*Dd**2*f*g2*s - 996*Dd**2*f*g2))/(21*d**2*k3**6) - 2*D1**2*Pk2*Pk3*ct*k1**3*st**2*(22*b1**2*(-D1**2*s**2*(12*f*fdd + 12*fd**2 + fd*(-24*f - 2) + fdd) + D1*(2*Dd*(6*f**2*(4*s**2 - 2*s + 1) + f*s**2*(4 - 48*fd) + 2*f*s*(6*fd - 1) + f + fd*s*(1 - 4*s)) - Ddd*f*(6*f + 1)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(6*f + 1)*(2*s - 1)) + 11*b1*(-2*D1**2*bdd1*f*(6*f + 1)*(2*s**2 - 2*s + 1) - 198*D1**2*f**2*fd*s**2 + 132*D1**2*f**2*fd*s - 66*D1**2*f**2*fd + 126*D1**2*f**2*fdd*s**2 - 84*D1**2*f**2*fdd*s + 42*D1**2*f**2*fdd + 252*D1**2*f*fd**2*s**2 - 168*D1**2*f*fd**2*s - 30*D1**2*f*fd*s**2 + 38*D1**2*f*fd*s - 19*D1**2*f*fd + 18*D1**2*f*fdd*s**2 - 22*D1**2*f*fdd*s + 11*D1**2*f*fdd + 18*D1**2*fd**2*s**2 - 22*D1**2*fd**2*s - 264*D1*Dd*f**3*s**2 + 132*D1*Dd*f**3*s - 66*D1*Dd*f**3 + 1008*D1*Dd*f**2*fd*s**2 - 588*D1*Dd*f**2*fd*s + 84*D1*Dd*f**2*fd - 60*D1*Dd*f**2*s**2 + 30*D1*Dd*f**2*s - 15*D1*Dd*f**2 + 144*D1*Dd*f*fd*s**2 - 124*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 168*D1*Ddd*f**3*s**2 - 84*D1*Ddd*f**3*s + 42*D1*Ddd*f**3 + 36*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 4*D1*bd1*(D1*(6*f**2*(2*s**2 - 2*s + 1) + f*s**2*(2 - 24*fd) + 2*f*s*(6*fd - 1) + f + fd*s*(1 - 2*s)) - Dd*f*(6*f + 1)*(8*s**2 - 6*s + 1)) + 504*Dd**2*f**3*s**2 - 252*Dd**2*f**3*s + 108*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s) + f*(-44*D1**2*bd1**2*s*(6*f + 1)*(s - 1) + 11*D1**2*bdd1*f*(s**2*(42*f + 9) + 4*s - 2) - 3*D1**2*(f*(59*fd - 35*fdd)*(3*s**2 - 2*s + 1) + 70*fd**2*s*(2 - 3*s)) - 11*D1*bd1*(D1*(66*f**2*s**2 + f*(-s**2*(252*fd - 15) + s*(84*fd + 8) - 4) + 2*fd*s*(7 - 18*s)) - 2*Dd*f*(4*s - 1)*(s*(42*f + 9) + 2)) - 3*D1*f*(59*Dd*f*(4*s**2 - 2*s + 1) - 70*Dd*fd*(12*s**2 - 7*s + 1) - 35*Ddd*f*(4*s**2 - 2*s + 1)) - 630*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2**3*k3**2) + 2*D1**2*Pk2*Pk3*ct*k1**3*(b1**2*(D1**2*s**2*(-72*fd**2 + fd*(120*f + 31) - fdd*(72*f + 19)) + D1*(Dd*(60*f**2*(4*s**2 - 2*s + 1) + f*(s**2*(124 - 576*fd) + s*(144*fd - 62) + 31) + 38*fd*s*(1 - 4*s)) - Ddd*f*(36*f + 19)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(36*f + 19)*(2*s - 1)) + b1*(-D1**2*bdd1*f*(36*f + 19)*(2*s**2 - 2*s + 1) - 108*D1**2*f**2*fd*s**2 + 72*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 108*D1**2*f**2*fdd*s**2 - 72*D1**2*f**2*fdd*s + 36*D1**2*f**2*fdd + 216*D1**2*f*fd**2*s**2 - 144*D1**2*f*fd**2*s + 14*D1**2*f*fd*s**2 + 38*D1**2*f*fd*s - 19*D1**2*f*fd + 6*D1**2*f*fdd*s**2 - 38*D1**2*f*fdd*s + 19*D1**2*f*fdd + 6*D1**2*fd**2*s**2 - 38*D1**2*fd**2*s - 144*D1*Dd*f**3*s**2 + 72*D1*Dd*f**3*s - 36*D1*Dd*f**3 + 864*D1*Dd*f**2*fd*s**2 - 504*D1*Dd*f**2*fd*s + 72*D1*Dd*f**2*fd + 28*D1*Dd*f**2*s**2 - 14*D1*Dd*f**2*s + 7*D1*Dd*f**2 + 48*D1*Dd*f*fd*s**2 - 164*D1*Dd*f*fd*s + 38*D1*Dd*f*fd + 144*D1*Ddd*f**3*s**2 - 72*D1*Ddd*f**3*s + 36*D1*Ddd*f**3 + 12*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + D1*bd1*(D1*(60*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(62 - 288*fd) + s*(144*fd - 62) + 31) + 38*fd*s*(1 - 2*s)) - 2*Dd*f*(36*f + 19)*(8*s**2 - 6*s + 1)) + 432*Dd**2*f**3*s**2 - 216*Dd**2*f**3*s + 36*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s) + f*(-2*D1**2*bd1**2*s*(36*f + 19)*(s - 1) + D1**2*bdd1*f*(s**2*(36*f + 3) + 32*s - 16) - 16*D1**2*(f*(fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*bd1*(D1*(-36*f**2*s**2 + f*(s**2*(216*fd + 7) - s*(72*fd + 52) + 26) + 2*fd*s*(6*s + 13)) + 2*Dd*f*(4*s - 1)*(s*(36*f + 3) + 16)) - 16*D1*f*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(12*s**2 - 7*s + 1) + Ddd*f*(-4*s**2 + 2*s - 1)) - 96*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2**3*k3**2) - 20*D1**2*Pk2*Pk3*ct*k1*k2**5*st**6*(-24*C*D1**2*f**2*fd*r**2 - 48*C*D1**2*f**2*fd*r*s + 32*C*D1**2*f**2*fd*r - 24*C*D1**2*f**2*fd*s**2 + 32*C*D1**2*f**2*fd*s - 16*C*D1**2*f**2*fd + 12*C*D1**2*f**2*fdd*r**2 + 24*C*D1**2*f**2*fdd*r*s - 16*C*D1**2*f**2*fdd*r + 12*C*D1**2*f**2*fdd*s**2 - 16*C*D1**2*f**2*fdd*s + 8*C*D1**2*f**2*fdd + 24*C*D1**2*f*fd**2*r**2 + 48*C*D1**2*f*fd**2*r*s - 32*C*D1**2*f*fd**2*r + 24*C*D1**2*f*fd**2*s**2 - 32*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 32*C*D1*Dd*f**3*r**2 - 64*C*D1*Dd*f**3*r*s + 48*C*D1*Dd*f**3*r - 32*C*D1*Dd*f**3*s**2 + 48*C*D1*Dd*f**3*s - 24*C*D1*Dd*f**3 + 96*C*D1*Dd*f**2*fd*r**2 + 192*C*D1*Dd*f**2*fd*r*s - 136*C*D1*Dd*f**2*fd*r + 96*C*D1*Dd*f**2*fd*s**2 - 136*C*D1*Dd*f**2*fd*s + 48*C*D1*Dd*f**2*fd + 16*C*D1*Ddd*f**3*r**2 + 32*C*D1*Ddd*f**3*r*s - 24*C*D1*Ddd*f**3*r + 16*C*D1*Ddd*f**3*s**2 - 24*C*D1*Ddd*f**3*s + 12*C*D1*Ddd*f**3 + 48*C*Dd**2*f**3*r**2 + 96*C*Dd**2*f**3*r*s - 72*C*Dd**2*f**3*r + 48*C*Dd**2*f**3*s**2 - 72*C*Dd**2*f**3*s + 24*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r**2 - 528*D1**2*K*b1*f*fd*r*s + 264*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 132*D1**2*K*b1*f*fdd*s**2 - 132*D1**2*K*b1*f*fdd*s + 66*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 132*D1**2*K*b1*fd**2*s**2 - 132*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-66*K + 7*f + 33)*(r + s - 1)**2 + 18*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 24*D1**2*f**2*fd*s + 12*D1**2*f**2*fd - 9*D1**2*f**2*fdd*r**2 - 18*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r - 9*D1**2*f**2*fdd*s**2 + 12*D1**2*f**2*fdd*s - 6*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 18*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 24*D1**2*f*fd**2*r - 18*D1**2*f*fd**2*s**2 + 24*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 - 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 792*D1*Dd*K*b1*f**2*s - 396*D1*Dd*K*b1*f**2 + 1056*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1320*D1*Dd*K*b1*f*fd*r + 1056*D1*Dd*K*b1*f*fd*s**2 - 1320*D1*Dd*K*b1*f*fd*s + 396*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 72*D1*Dd*f**2*fd*r**2 - 144*D1*Dd*f**2*fd*r*s + 102*D1*Dd*f**2*fd*r - 72*D1*Dd*f**2*fd*s**2 + 102*D1*Dd*f**2*fd*s - 36*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r + 264*D1*Ddd*K*b1*f**2*s**2 - 396*D1*Ddd*K*b1*f**2*s + 198*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 24*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 18*D1*Ddd*f**3*s - 9*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 33*f*(2*K - 1)*(r + s - 1) + 33*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-66*K + 7*f + 33)*(4*r + 4*s - 3))*(r + s - 1) + 792*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r + 792*Dd**2*K*b1*f**2*s**2 - 1188*Dd**2*K*b1*f**2*s + 396*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 72*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 54*Dd**2*f**3*s - 18*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2)/(231*d**2*k3**8) + 8*D1**2*Pk2*Pk3*ct*k1*k2**5*st**4*(-66*D1**2*bd1**2*f*(2*K - 1)*(r + s - 1)**2 - 33*D1*bd1*(D1*(f**2*(4*K - 1)*(r + s - 1) + 8*f*(g2 - gd2)*(r + s - 1) - 8*fd*g2*(r + s)) - 8*Dd*f*g2*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(2*K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-8*D1**2*K*f*fd*r**2 - 16*D1**2*K*f*fd*r*s + 8*D1**2*K*f*fd*r - 8*D1**2*K*f*fd*s**2 + 8*D1**2*K*f*fd*s - 4*D1**2*K*f*fd - 2*D1**2*bdd1*f*(2*K - 1)*(r + s - 1)**2 + 2*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + D1**2*f*fd - 8*D1**2*f*gd2*r**2 - 16*D1**2*f*gd2*r*s + 16*D1**2*f*gd2*r - 8*D1**2*f*gd2*s**2 + 16*D1**2*f*gd2*s - 8*D1**2*f*gd2 + 4*D1**2*f*gdd2*r**2 + 8*D1**2*f*gdd2*r*s - 8*D1**2*f*gdd2*r + 4*D1**2*f*gdd2*s**2 - 8*D1**2*f*gdd2*s + 4*D1**2*f*gdd2 - 8*D1**2*fd*g2*r**2 - 16*D1**2*fd*g2*r*s - 8*D1**2*fd*g2*s**2 + 8*D1**2*fd*gd2*r**2 + 16*D1**2*fd*gd2*r*s - 8*D1**2*fd*gd2*r + 8*D1**2*fd*gd2*s**2 - 8*D1**2*fd*gd2*s + 4*D1**2*fdd*g2*r**2 + 8*D1**2*fdd*g2*r*s + 4*D1**2*fdd*g2*s**2 - 16*D1*Dd*K*f**2*r**2 - 32*D1*Dd*K*f**2*r*s + 24*D1*Dd*K*f**2*r - 16*D1*Dd*K*f**2*s**2 + 24*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 32*D1*Dd*f*g2*r**2 - 64*D1*Dd*f*g2*r*s + 48*D1*Dd*f*g2*r - 32*D1*Dd*f*g2*s**2 + 48*D1*Dd*f*g2*s - 24*D1*Dd*f*g2 + 32*D1*Dd*f*gd2*r**2 + 64*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r + 32*D1*Dd*f*gd2*s**2 - 56*D1*Dd*f*gd2*s + 24*D1*Dd*f*gd2 + 32*D1*Dd*fd*g2*r**2 + 64*D1*Dd*fd*g2*r*s - 24*D1*Dd*fd*g2*r + 32*D1*Dd*fd*g2*s**2 - 24*D1*Dd*fd*g2*s + 16*D1*Ddd*f*g2*r**2 + 32*D1*Ddd*f*g2*r*s - 24*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s**2 - 24*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + 4*D1*bd1*(2*K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 48*Dd**2*f*g2*r**2 + 96*Dd**2*f*g2*r*s - 72*Dd**2*f*g2*r + 48*Dd**2*f*g2*s**2 - 72*Dd**2*f*g2*s + 24*Dd**2*f*g2) + 4*f*(D1**2*(33*bdd1*g2*(r + s - 1)**2 + f*(-fd*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 66*gd2*(r + s - 1)**2) + fd**2*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 66*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + D1*f*(-2*Dd*(f*(10*C - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(10*C - 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 33*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Ddd*f*(10*C - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Dd**2*f**2*(60*C - 30)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**8) - 4*D1**2*Pk2*Pk3*ct*k1*k2**5*st**2*(D1*(-24*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(f**2*(40*C - 6*K - 19)*(r + s - 1) - 8*f*(fd*(6*C - 3)*(2*r + 2*s - 1) + (13*g2 - 6*gd2)*(r + s - 1)) + 48*fd*g2*(r + s)) - 24*Dd*f*(f*(2*C - 1) - 2*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6*f*(2*D1*bdd1*(f*(2*C - 1) - 2*g2)*(r + s - 1)**2 + D1*(f*(fd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*gd2*(r + s - 1)**2) - 2*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(2*C - 1) - 2*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**2*(D1**2*(3*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-12*K*fdd + fd*(52*K - 7))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(52*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*(f*(fd*(40*C - 6*K - 19)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*fdd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*(r + s - 1)**2*(6*K*bdd1 + 26*gd2 - 6*gdd2)) + (-8*r - 8*s)*(fd**2*(6*C - 3)*(r + s - 1) + 13*fd*g2*(r + s) - 6*fd*gd2*(r + s - 1) - 3*fdd*g2*(r + s))) + 2*D1*bd1*(D1*(-24*K*fd*(r + s) + 3*f**2*(r + s - 1) + f*(52*K - 7)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(40*C - 6*K - 19)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*f*(fd*(6*C - 3)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 13*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 48*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(f*(2*C - 1) - 2*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(2*C - 1) - 2*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**8) + 20*D1**2*Pk2*Pk3*ct*k1*k2**3*st**6*(-24*C*D1**2*f**2*fd*r**2 + 24*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r + 48*C*D1**2*f**2*fd*s**2 - 40*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd + 12*C*D1**2*f**2*fdd*r**2 - 12*C*D1**2*f**2*fdd*r*s - 4*C*D1**2*f**2*fdd*r - 24*C*D1**2*f**2*fdd*s**2 + 20*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd + 24*C*D1**2*f*fd**2*r**2 - 24*C*D1**2*f*fd**2*r*s - 8*C*D1**2*f*fd**2*r - 48*C*D1**2*f*fd**2*s**2 + 40*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 - 32*C*D1*Dd*f**3*r**2 + 32*C*D1*Dd*f**3*r*s + 24*C*D1*Dd*f**3*r + 64*C*D1*Dd*f**3*s**2 - 48*C*D1*Dd*f**3*s + 96*C*D1*Dd*f**2*fd*r**2 - 96*C*D1*Dd*f**2*fd*r*s - 52*C*D1*Dd*f**2*fd*r - 192*C*D1*Dd*f**2*fd*s**2 + 152*C*D1*Dd*f**2*fd*s - 12*C*D1*Dd*f**2*fd + 16*C*D1*Ddd*f**3*r**2 - 16*C*D1*Ddd*f**3*r*s - 12*C*D1*Ddd*f**3*r - 32*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s + 48*C*Dd**2*f**3*r**2 - 48*C*Dd**2*f**3*r*s - 36*C*Dd**2*f**3*r - 96*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s - 264*D1**2*K*b1*f*fd*r**2 + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r + 528*D1**2*K*b1*f*fd*s**2 - 528*D1**2*K*b1*f*fd*s + 264*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 - 132*D1**2*K*b1*f*fdd*r*s + 66*D1**2*K*b1*f*fdd*r - 264*D1**2*K*b1*f*fdd*s**2 + 264*D1**2*K*b1*f*fdd*s - 132*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 - 132*D1**2*K*b1*fd**2*r*s + 66*D1**2*K*b1*fd**2*r - 264*D1**2*K*b1*fd**2*s**2 + 264*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 - 28*D1**2*b1*f**2*fd*r - 42*D1**2*b1*f**2*fd*s**2 + 28*D1**2*b1*f**2*fd*s - 21*D1**2*b1*f**2*fdd*r**2 + 14*D1**2*b1*f**2*fdd*r + 21*D1**2*b1*f**2*fdd*s**2 - 14*D1**2*b1*f**2*fdd*s - 42*D1**2*b1*f*fd**2*r**2 + 28*D1**2*b1*f*fd**2*r + 42*D1**2*b1*f*fd**2*s**2 - 28*D1**2*b1*f*fd**2*s + 396*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 132*D1**2*b1*f*fd*s**2 + 132*D1**2*b1*f*fd*s - 66*D1**2*b1*f*fd - 198*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s**2 - 66*D1**2*b1*f*fdd*s + 33*D1**2*b1*f*fdd - 198*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(r + s - 1)*(-66*K*(r - 2*s - 1) + 7*f*(r - s - 1) + 99*r - 33*s - 99) - 56*D1**2*f**3*fd*r**2 - 56*D1**2*f**3*fd*r*s + 70*D1**2*f**3*fd*r + 28*D1**2*f**3*fd*s - 28*D1**2*f**3*fd + 56*D1**2*f**3*fdd*r**2 + 56*D1**2*f**3*fdd*r*s - 70*D1**2*f**3*fdd*r - 28*D1**2*f**3*fdd*s + 28*D1**2*f**3*fdd + 168*D1**2*f**2*fd**2*r**2 + 168*D1**2*f**2*fd**2*r*s - 210*D1**2*f**2*fd**2*r - 84*D1**2*f**2*fd**2*s + 56*D1**2*f**2*fd**2 + 30*D1**2*f**2*fd*r**2 - 20*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 15*D1**2*f**2*fdd*r**2 + 10*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 10*D1**2*f**2*fdd*s + 264*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r - 528*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 + 132*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r + 264*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 30*D1**2*f*fd**2*r**2 + 20*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 20*D1**2*f*fd**2*s + 528*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 + 528*D1**2*f*fd*gd2*r*s + 396*D1**2*f*fd*gd2*r + 1056*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 528*D1**2*f*fdd*g2*s**2 - 528*D1**2*f*fdd*g2*s + 264*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 528*D1**2*fd**2*g2*s**2 - 528*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 + 528*D1*Dd*K*b1*f**2*r*s + 396*D1*Dd*K*b1*f**2*r + 1056*D1*Dd*K*b1*f**2*s**2 - 792*D1*Dd*K*b1*f**2*s + 1056*D1*Dd*K*b1*f*fd*r**2 - 1056*D1*Dd*K*b1*f*fd*r*s - 132*D1*Dd*K*b1*f*fd*r - 2112*D1*Dd*K*b1*f*fd*s**2 + 1848*D1*Dd*K*b1*f*fd*s - 396*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 - 56*D1*Dd*b1*f**3*r - 56*D1*Dd*b1*f**3*s**2 + 28*D1*Dd*b1*f**3*s + 14*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 + 140*D1*Dd*b1*f**2*fd*r + 168*D1*Dd*b1*f**2*fd*s**2 - 98*D1*Dd*b1*f**2*fd*s - 14*D1*Dd*b1*f**2*fd + 792*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 924*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s**2 - 132*D1*Dd*b1*f**2*s + 330*D1*Dd*b1*f**2 - 1584*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 1188*D1*Dd*b1*f*fd*r + 528*D1*Dd*b1*f*fd*s**2 - 132*D1*Dd*b1*f*fd*s - 66*D1*Dd*b1*f*fd - 56*D1*Dd*f**4*r**2 - 56*D1*Dd*f**4*r*s + 70*D1*Dd*f**4*r + 28*D1*Dd*f**4*s - 28*D1*Dd*f**4 + 448*D1*Dd*f**3*fd*r**2 + 448*D1*Dd*f**3*fd*r*s - 560*D1*Dd*f**3*fd*r - 224*D1*Dd*f**3*fd*s + 168*D1*Dd*f**3*fd + 40*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s + 10*D1*Dd*f**3 - 120*D1*Dd*f**2*fd*r**2 + 100*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 70*D1*Dd*f**2*fd*s - 10*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 1056*D1*Dd*f**2*gd2*r**2 + 1056*D1*Dd*f**2*gd2*r*s + 1452*D1*Dd*f**2*gd2*r + 2112*D1*Dd*f**2*gd2*s**2 - 1320*D1*Dd*f**2*gd2*s - 396*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 + 2112*D1*Dd*f*fd*g2*r*s + 264*D1*Dd*f*fd*g2*r + 4224*D1*Dd*f*fd*g2*s**2 - 3696*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 - 264*D1*Ddd*K*b1*f**2*r*s - 198*D1*Ddd*K*b1*f**2*r - 528*D1*Ddd*K*b1*f**2*s**2 + 396*D1*Ddd*K*b1*f**2*s - 28*D1*Ddd*b1*f**3*r**2 + 28*D1*Ddd*b1*f**3*r + 28*D1*Ddd*b1*f**3*s**2 - 14*D1*Ddd*b1*f**3*s - 7*D1*Ddd*b1*f**3 - 396*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 462*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s**2 + 66*D1*Ddd*b1*f**2*s - 165*D1*Ddd*b1*f**2 + 56*D1*Ddd*f**4*r**2 + 56*D1*Ddd*f**4*r*s - 70*D1*Ddd*f**4*r - 28*D1*Ddd*f**4*s + 28*D1*Ddd*f**4 - 20*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 10*D1*Ddd*f**3*s - 5*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 + 528*D1*Ddd*f**2*g2*r*s + 396*D1*Ddd*f**2*g2*r + 1056*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 2*D1*bd1*f*(D1*(7*f**2*(r**2 - 2*r - s**2 + 1) + f*(-7*fd*(3*r**2 - 4*r - 3*s**2 + s + 1) + (-33*r - 33*s + 33)*(2*K*(r - 2*s - 1) - 3*r + s + 3)) + 33*fd*(K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 6*r**2 - 4*r*s + 7*r + 2*s**2 + s - 1)) + Dd*f*(33*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 7*f*(4*r**2 - 6*r - 4*s**2 + s + 2) - 396*r**2 - 264*r*s + 627*r + 132*s**2 + 165*s - 231)) + 792*Dd**2*K*b1*f**2*r**2 - 792*Dd**2*K*b1*f**2*r*s - 594*Dd**2*K*b1*f**2*r - 1584*Dd**2*K*b1*f**2*s**2 + 1188*Dd**2*K*b1*f**2*s - 84*Dd**2*b1*f**3*r**2 + 84*Dd**2*b1*f**3*r + 84*Dd**2*b1*f**3*s**2 - 42*Dd**2*b1*f**3*s - 14*Dd**2*b1*f**3 - 1188*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 1386*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s**2 + 198*Dd**2*b1*f**2*s - 330*Dd**2*b1*f**2 + 168*Dd**2*f**4*r**2 + 168*Dd**2*f**4*r*s - 210*Dd**2*f**4*r - 84*Dd**2*f**4*s + 56*Dd**2*f**4 - 60*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 30*Dd**2*f**3*s - 10*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 + 1584*Dd**2*f**2*g2*r*s + 1188*Dd**2*f**2*g2*r + 3168*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s)/(693*d**2*k3**6) + 4*D1**2*Pk2*Pk3*ct*k1*k2**3*st**4*(912*C*D1**2*f**2*fd*r**2 + 1632*C*D1**2*f**2*fd*r*s - 1152*C*D1**2*f**2*fd*r + 720*C*D1**2*f**2*fd*s**2 - 1024*C*D1**2*f**2*fd*s + 544*C*D1**2*f**2*fd - 456*C*D1**2*f**2*fdd*r**2 - 816*C*D1**2*f**2*fdd*r*s + 576*C*D1**2*f**2*fdd*r - 360*C*D1**2*f**2*fdd*s**2 + 512*C*D1**2*f**2*fdd*s - 272*C*D1**2*f**2*fdd - 912*C*D1**2*f*fd**2*r**2 - 1632*C*D1**2*f*fd**2*r*s + 1152*C*D1**2*f*fd**2*r - 720*C*D1**2*f*fd**2*s**2 + 1024*C*D1**2*f*fd**2*s - 272*C*D1**2*f*fd**2 + 1216*C*D1*Dd*f**3*r**2 + 2176*C*D1*Dd*f**3*r*s - 1760*C*D1*Dd*f**3*r + 960*C*D1*Dd*f**3*s**2 - 1568*C*D1*Dd*f**3*s + 848*C*D1*Dd*f**3 - 3648*C*D1*Dd*f**2*fd*r**2 - 6528*C*D1*Dd*f**2*fd*r*s + 4944*C*D1*Dd*f**2*fd*r - 2880*C*D1*Dd*f**2*fd*s**2 + 4400*C*D1*Dd*f**2*fd*s - 1664*C*D1*Dd*f**2*fd - 608*C*D1*Ddd*f**3*r**2 - 1088*C*D1*Ddd*f**3*r*s + 880*C*D1*Ddd*f**3*r - 480*C*D1*Ddd*f**3*s**2 + 784*C*D1*Ddd*f**3*s - 424*C*D1*Ddd*f**3 - 1824*C*Dd**2*f**3*r**2 - 3264*C*Dd**2*f**3*r*s + 2640*C*Dd**2*f**3*r - 1440*C*Dd**2*f**3*s**2 + 2352*C*Dd**2*f**3*s - 848*C*Dd**2*f**3 + 330*D1**2*K*bdd1*f**2*r**2 + 924*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*r + 594*D1**2*K*bdd1*f**2*s**2 - 924*D1**2*K*bdd1*f**2*s + 330*D1**2*K*bdd1*f**2 + 264*D1**2*b2*f*fd*r**2 + 528*D1**2*b2*f*fd*r*s - 264*D1**2*b2*f*fd*r + 264*D1**2*b2*f*fd*s**2 - 264*D1**2*b2*f*fd*s + 132*D1**2*b2*f*fd - 132*D1**2*bd1**2*f*(r + s - 1)*(2*K*s + K + 2*r - 2) + 132*D1**2*bd2*f**2*r**2 + 264*D1**2*bd2*f**2*r*s - 264*D1**2*bd2*f**2*r + 132*D1**2*bd2*f**2*s**2 - 264*D1**2*bd2*f**2*s + 132*D1**2*bd2*f**2 - 165*D1**2*bdd1*f**2*r**2 - 462*D1**2*bdd1*f**2*r*s + 330*D1**2*bdd1*f**2*r - 297*D1**2*bdd1*f**2*s**2 + 462*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 + 264*D1**2*bdd1*f*g2*r*s + 264*D1**2*bdd1*f*g2*r + 264*D1**2*bdd1*f*g2*s**2 - 564*D1**2*f**2*fd*r**2 - 984*D1**2*f**2*fd*r*s + 704*D1**2*f**2*fd*r - 420*D1**2*f**2*fd*s**2 + 608*D1**2*f**2*fd*s - 328*D1**2*f**2*fd + 282*D1**2*f**2*fdd*r**2 + 492*D1**2*f**2*fdd*r*s - 352*D1**2*f**2*fdd*r + 210*D1**2*f**2*fdd*s**2 - 304*D1**2*f**2*fdd*s + 164*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r + 924*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 - 660*D1**2*f**2*gdd2*r**2 - 1848*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*r - 1188*D1**2*f**2*gdd2*s**2 + 1848*D1**2*f**2*gdd2*s - 660*D1**2*f**2*gdd2 + 564*D1**2*f*fd**2*r**2 + 984*D1**2*f*fd**2*r*s - 704*D1**2*f*fd**2*r + 420*D1**2*f*fd**2*s**2 - 608*D1**2*f*fd**2*s + 164*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 1848*D1**2*f*fd*g2*s**2 - 1848*D1**2*f*fd*g2*s + 924*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r**2 - 7392*D1**2*f*fd*gd2*r*s + 4488*D1**2*f*fd*gd2*r - 4752*D1**2*f*fd*gd2*s**2 + 6072*D1**2*f*fd*gd2*s - 1848*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r**2 - 3696*D1**2*f*fdd*g2*r*s + 1848*D1**2*f*fdd*g2*r - 2376*D1**2*f*fdd*g2*s**2 + 2376*D1**2*f*fdd*g2*s - 1188*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r**2 - 3696*D1**2*fd**2*g2*r*s + 1848*D1**2*fd**2*g2*r - 2376*D1**2*fd**2*g2*s**2 + 2376*D1**2*fd**2*g2*s + 528*D1*Dd*b2*f**2*r**2 + 1056*D1*Dd*b2*f**2*r*s - 792*D1*Dd*b2*f**2*r + 528*D1*Dd*b2*f**2*s**2 - 792*D1*Dd*b2*f**2*s + 396*D1*Dd*b2*f**2 - 752*D1*Dd*f**3*r**2 - 1312*D1*Dd*f**3*r*s + 1080*D1*Dd*f**3*r - 560*D1*Dd*f**3*s**2 + 936*D1*Dd*f**3*s - 516*D1*Dd*f**3 + 2256*D1*Dd*f**2*fd*r**2 + 3936*D1*Dd*f**2*fd*r*s - 3028*D1*Dd*f**2*fd*r + 1680*D1*Dd*f**2*fd*s**2 - 2620*D1*Dd*f**2*fd*s + 1008*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s + 1056*D1*Dd*f**2*g2*r + 3696*D1*Dd*f**2*g2*s**2 - 2904*D1*Dd*f**2*g2*s + 132*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r**2 - 14784*D1*Dd*f**2*gd2*r*s + 9768*D1*Dd*f**2*gd2*r - 9504*D1*Dd*f**2*gd2*s**2 + 13464*D1*Dd*f**2*gd2*s - 4488*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r**2 - 29568*D1*Dd*f*fd*g2*r*s + 16368*D1*Dd*f*fd*g2*r - 19008*D1*Dd*f*fd*g2*s**2 + 21648*D1*Dd*f*fd*g2*s - 6072*D1*Dd*f*fd*g2 + 376*D1*Ddd*f**3*r**2 + 656*D1*Ddd*f**3*r*s - 540*D1*Ddd*f**3*r + 280*D1*Ddd*f**3*s**2 - 468*D1*Ddd*f**3*s + 258*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r**2 - 7392*D1*Ddd*f**2*g2*r*s + 4488*D1*Ddd*f**2*g2*r - 4752*D1*Ddd*f**2*g2*s**2 + 6072*D1*Ddd*f**2*g2*s - 2508*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(f**2*(r + s - 1)*(2*K*(3*r - 7*s - 3) - 5*r + 7*s + 5) + 2*f*(fd*(2*K - 1)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) - 8*g2*(r*s + r + s**2) + 4*gd2*(2*s + 1)*(r + s - 1)) + 8*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*Dd*f*(f*(2*K - 1)*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) + 4*g2*(r*(8*s + 3) + 8*s**2 - 4*s - 2))) + 1128*Dd**2*f**3*r**2 + 1968*Dd**2*f**3*r*s - 1620*Dd**2*f**3*r + 840*Dd**2*f**3*s**2 - 1404*Dd**2*f**3*s + 516*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r**2 - 22176*Dd**2*f**2*g2*r*s + 13464*Dd**2*f**2*g2*r - 14256*Dd**2*f**2*g2*s**2 + 18216*Dd**2*f**2*g2*s - 5016*Dd**2*f**2*g2 + 66*b1**2*(D1**2*(2*fd - fdd)*(2*K*(r*(s - 2) + (s - 1)**2) + 2*r**2 + 2*r*(s + 1) + 2*s - 1) + 2*D1*(Dd*(2*f*(K*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2) + fd*(K*(-8*r*s + 9*r - 8*s**2 + 12*s - 6) - 8*r**2 - 8*r*s + r - 2*s + 3)) - Ddd*f*(K*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - 2*Dd**2*f*(K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) + 33*b1*(12*D1**2*K*f*fd*r**2 - 16*D1**2*K*f*fd*r*s + 8*D1**2*K*f*fd*r - 28*D1**2*K*f*fd*s**2 + 28*D1**2*K*f*fd*s - 14*D1**2*K*f*fd + 20*D1**2*K*f*fdd*r**2 + 56*D1**2*K*f*fdd*r*s - 28*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 20*D1**2*K*fd**2*r**2 + 56*D1**2*K*fd**2*r*s - 28*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(4*K*s**2 + 4*r**2 + 2*r*(2*K*s + K + 2*s - 4) - s*(2*K + 4) + 3) - 10*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 - 14*D1**2*f*fd*s + 7*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 16*D1**2*f*gd2*r*s - 16*D1**2*f*gd2*s**2 + 16*D1**2*f*gd2*s + 8*D1**2*f*gdd2*r*s + 8*D1**2*f*gdd2*s**2 - 8*D1**2*f*gdd2*s - 10*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s - 16*D1**2*fd*g2*r*s + 32*D1**2*fd*g2*r - 16*D1**2*fd*g2*s**2 + 32*D1**2*fd*g2*s - 16*D1**2*fd*g2 + 16*D1**2*fd*gd2*r*s - 16*D1**2*fd*gd2*r + 16*D1**2*fd*gd2*s**2 - 24*D1**2*fd*gd2*s + 16*D1**2*fd*gd2 + 8*D1**2*fdd*g2*r*s - 16*D1**2*fdd*g2*r + 8*D1**2*fdd*g2*s**2 - 16*D1**2*fdd*g2*s + 8*D1**2*fdd*g2 + 24*D1*Dd*K*f**2*r**2 - 32*D1*Dd*K*f**2*r*s - 16*D1*Dd*K*f**2*r - 56*D1*Dd*K*f**2*s**2 + 44*D1*Dd*K*f**2*s - 2*D1*Dd*K*f**2 + 160*D1*Dd*K*f*fd*r**2 + 448*D1*Dd*K*f*fd*r*s - 248*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 328*D1*Dd*K*f*fd*s + 92*D1*Dd*K*f*fd - 20*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s + 18*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 - 18*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 124*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 164*D1*Dd*f*fd*s - 46*D1*Dd*f*fd - 64*D1*Dd*f*g2*r*s + 16*D1*Dd*f*g2*r - 64*D1*Dd*f*g2*s**2 + 64*D1*Dd*f*g2*s - 16*D1*Dd*f*g2 + 64*D1*Dd*f*gd2*r*s - 8*D1*Dd*f*gd2*r + 64*D1*Dd*f*gd2*s**2 - 64*D1*Dd*f*gd2*s + 8*D1*Dd*f*gd2 + 64*D1*Dd*fd*g2*r*s - 72*D1*Dd*fd*g2*r + 64*D1*Dd*fd*g2*s**2 - 96*D1*Dd*fd*g2*s + 48*D1*Dd*fd*g2 + 40*D1*Ddd*K*f**2*r**2 + 112*D1*Ddd*K*f**2*r*s - 68*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 92*D1*Ddd*K*f**2*s + 38*D1*Ddd*K*f**2 - 20*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 34*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 46*D1*Ddd*f**2*s - 19*D1*Ddd*f**2 + 32*D1*Ddd*f*g2*r*s - 8*D1*Ddd*f*g2*r + 32*D1*Ddd*f*g2*s**2 - 32*D1*Ddd*f*g2*s + 8*D1*Ddd*f*g2 + 4*D1*bd1*(D1*f*(4*K*s**2 + 4*r**2 + 2*r*(2*K*s + K + 2*s - 4) - s*(2*K + 4) + 3) + D1*fd*(K*(r*(3 - 4*s) - 4*s**2 + 5*s - 2) - 4*r**2 + r*(2 - 4*s) + 1) + Dd*K*f*(-2*r*(8*s + 1) - 16*s**2 + 12*s + 1) - 2*Dd*f*(8*r**2 + r*(8*s - 13) - 6*s + 5)) + 120*Dd**2*K*f**2*r**2 + 336*Dd**2*K*f**2*r*s - 204*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 276*Dd**2*K*f**2*s + 76*Dd**2*K*f**2 - 60*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 102*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 138*Dd**2*f**2*s - 38*Dd**2*f**2 + 96*Dd**2*f*g2*r*s - 24*Dd**2*f*g2*r + 96*Dd**2*f*g2*s**2 - 96*Dd**2*f*g2*s + 16*Dd**2*f*g2))/(231*d**2*k3**6) + 2*D1**2*Pk2*Pk3*ct*k1*k2**3*st**2*(176*C*D1**2*bd1**2*f*r**2 + 352*C*D1**2*bd1**2*f*r*s - 176*C*D1**2*bd1**2*f*r + 176*C*D1**2*bd1**2*f*s**2 - 176*C*D1**2*bd1**2*f*s + 1804*C*D1**2*bd1*f**2*r**2 + 4488*C*D1**2*bd1*f**2*r*s - 5192*C*D1**2*bd1*f**2*r + 2684*C*D1**2*bd1*f**2*s**2 - 6072*C*D1**2*bd1*f**2*s + 3036*C*D1**2*bd1*f**2 - 5104*C*D1**2*bd1*f*fd*r**2 - 11264*C*D1**2*bd1*f*fd*r*s + 8712*C*D1**2*bd1*f*fd*r - 6160*C*D1**2*bd1*f*fd*s**2 + 9504*C*D1**2*bd1*f*fd*s - 3344*C*D1**2*bd1*f*fd - 1276*C*D1**2*bdd1*f**2*r**2 - 2816*C*D1**2*bdd1*f**2*r*s + 3344*C*D1**2*bdd1*f**2*r - 1540*C*D1**2*bdd1*f**2*s**2 + 3608*C*D1**2*bdd1*f**2*s - 1804*C*D1**2*bdd1*f**2 - 564*C*D1**2*f**2*fd*r**2 + 2208*C*D1**2*f**2*fd*r*s - 360*C*D1**2*f**2*fd*r + 2772*C*D1**2*f**2*fd*s**2 - 2584*C*D1**2*f**2*fd*s + 736*C*D1**2*f**2*fd - 2556*C*D1**2*f**2*fdd*r**2 - 6912*C*D1**2*f**2*fdd*r*s + 4008*C*D1**2*f**2*fdd*r - 4356*C*D1**2*f**2*fdd*s**2 + 5208*C*D1**2*f**2*fdd*s - 2304*C*D1**2*f**2*fdd - 5112*C*D1**2*f*fd**2*r**2 - 13824*C*D1**2*f*fd**2*r*s + 8016*C*D1**2*f*fd**2*r - 8712*C*D1**2*f*fd**2*s**2 + 10416*C*D1**2*f*fd**2*s - 2304*C*D1**2*f*fd**2 - 10208*C*D1*Dd*bd1*f**2*r**2 - 22528*C*D1*Dd*bd1*f**2*r*s + 21296*C*D1*Dd*bd1*f**2*r - 12320*C*D1*Dd*bd1*f**2*s**2 + 23144*C*D1*Dd*bd1*f**2*s - 10296*C*D1*Dd*bd1*f**2 - 752*C*D1*Dd*f**3*r**2 + 2944*C*D1*Dd*f**3*r*s + 16*C*D1*Dd*f**3*r + 3696*C*D1*Dd*f**3*s**2 - 3320*C*D1*Dd*f**3*s + 548*C*D1*Dd*f**3 - 20448*C*D1*Dd*f**2*fd*r**2 - 55296*C*D1*Dd*f**2*fd*r*s + 33168*C*D1*Dd*f**2*fd*r - 34848*C*D1*Dd*f**2*fd*s**2 + 43368*C*D1*Dd*f**2*fd*s - 13224*C*D1*Dd*f**2*fd - 3408*C*D1*Ddd*f**3*r**2 - 9216*C*D1*Ddd*f**3*r*s + 5712*C*D1*Ddd*f**3*r - 5808*C*D1*Ddd*f**3*s**2 + 7512*C*D1*Ddd*f**3*s - 3156*C*D1*Ddd*f**3 - 10224*C*Dd**2*f**3*r**2 - 27648*C*Dd**2*f**3*r*s + 17136*C*Dd**2*f**3*r - 17424*C*Dd**2*f**3*s**2 + 22536*C*Dd**2*f**3*s - 6312*C*Dd**2*f**3 + 484*D1**2*K*bd1**2*f*r**2 + 704*D1**2*K*bd1**2*f*r*s - 572*D1**2*K*bd1**2*f*r + 220*D1**2*K*bd1**2*f*s**2 - 308*D1**2*K*bd1**2*f*s + 88*D1**2*K*bd1**2*f - 198*D1**2*K*bd1*f**2*r**2 + 264*D1**2*K*bd1*f**2*r*s + 396*D1**2*K*bd1*f**2*r + 462*D1**2*K*bd1*f**2*s**2 - 264*D1**2*K*bd1*f**2*s - 198*D1**2*K*bd1*f**2 - 1320*D1**2*K*bd1*f*fd*r**2 - 4224*D1**2*K*bd1*f*fd*r*s + 2376*D1**2*K*bd1*f*fd*r - 2904*D1**2*K*bd1*f*fd*s**2 + 3564*D1**2*K*bd1*f*fd*s - 1056*D1**2*K*bd1*f*fd - 330*D1**2*K*bdd1*f**2*r**2 - 1056*D1**2*K*bdd1*f**2*r*s + 660*D1**2*K*bdd1*f**2*r - 726*D1**2*K*bdd1*f**2*s**2 + 1056*D1**2*K*bdd1*f**2*s - 330*D1**2*K*bdd1*f**2 + 990*D1**2*bd1**2*f**2*r**2 + 1452*D1**2*bd1**2*f**2*r*s - 1716*D1**2*bd1**2*f**2*r + 462*D1**2*bd1**2*f**2*s**2 - 1188*D1**2*bd1**2*f**2*s + 726*D1**2*bd1**2*f**2 - 506*D1**2*bd1**2*f*r**2 - 1276*D1**2*bd1**2*f*r*s + 1012*D1**2*bd1**2*f*r - 770*D1**2*bd1**2*f*s**2 + 1276*D1**2*bd1**2*f*s - 506*D1**2*bd1**2*f + 1232*D1**2*bd1**2*g2*r**2 + 2464*D1**2*bd1**2*g2*r*s - 1232*D1**2*bd1**2*g2*r + 1232*D1**2*bd1**2*g2*s**2 - 1232*D1**2*bd1**2*g2*s - 528*D1**2*bd1*bd2*f*r**2 - 1056*D1**2*bd1*bd2*f*r*s + 1056*D1**2*bd1*bd2*f*r - 528*D1**2*bd1*bd2*f*s**2 + 1056*D1**2*bd1*bd2*f*s - 528*D1**2*bd1*bd2*f - 1045*D1**2*bd1*f**2*r**2 - 2530*D1**2*bd1*f**2*r*s + 2706*D1**2*bd1*f**2*r - 1485*D1**2*bd1*f**2*s**2 + 3146*D1**2*bd1*f**2*s - 1507*D1**2*bd1*f**2 + 3564*D1**2*bd1*f*fd*r**2 + 7128*D1**2*bd1*f*fd*r*s - 5610*D1**2*bd1*f*fd*r + 3564*D1**2*bd1*f*fd*s**2 - 5610*D1**2*bd1*f*fd*s + 2046*D1**2*bd1*f*fd - 1804*D1**2*bd1*f*g2*r**2 - 4136*D1**2*bd1*f*g2*r*s + 7656*D1**2*bd1*f*g2*r - 2332*D1**2*bd1*f*g2*s**2 + 8184*D1**2*bd1*f*g2*s - 4092*D1**2*bd1*f*g2 - 968*D1**2*bd1*f*gd2*r**2 - 1408*D1**2*bd1*f*gd2*r*s + 1144*D1**2*bd1*f*gd2*r - 440*D1**2*bd1*f*gd2*s**2 + 616*D1**2*bd1*f*gd2*s - 176*D1**2*bd1*f*gd2 - 968*D1**2*bd1*fd*g2*r**2 - 1408*D1**2*bd1*fd*g2*r*s + 704*D1**2*bd1*fd*g2*r - 440*D1**2*bd1*fd*g2*s**2 + 440*D1**2*bd1*fd*g2*s - 132*D1**2*bd2*f**2*r**2 - 264*D1**2*bd2*f**2*r*s + 264*D1**2*bd2*f**2*r - 132*D1**2*bd2*f**2*s**2 + 264*D1**2*bd2*f**2*s - 132*D1**2*bd2*f**2 + 891*D1**2*bdd1*f**2*r**2 + 1782*D1**2*bdd1*f**2*r*s - 2046*D1**2*bdd1*f**2*r + 891*D1**2*bdd1*f**2*s**2 - 2046*D1**2*bdd1*f**2*s + 1023*D1**2*bdd1*f**2 - 484*D1**2*bdd1*f*g2*r**2 - 704*D1**2*bdd1*f*g2*r*s + 176*D1**2*bdd1*f*g2*r - 220*D1**2*bdd1*f*g2*s**2 - 88*D1**2*bdd1*f*g2*s + 44*D1**2*bdd1*f*g2 + 678*D1**2*f**2*fd*r**2 - 708*D1**2*f**2*fd*r*s - 216*D1**2*f**2*fd*r - 1386*D1**2*f**2*fd*s**2 + 1160*D1**2*f**2*fd*s - 236*D1**2*f**2*fd + 1278*D1**2*f**2*fdd*r**2 + 3456*D1**2*f**2*fdd*r*s - 2004*D1**2*f**2*fdd*r + 2178*D1**2*f**2*fdd*s**2 - 2604*D1**2*f**2*fdd*s + 1152*D1**2*f**2*fdd + 396*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s - 792*D1**2*f**2*gd2*r - 924*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s + 396*D1**2*f**2*gd2 + 660*D1**2*f**2*gdd2*r**2 + 2112*D1**2*f**2*gdd2*r*s - 1320*D1**2*f**2*gdd2*r + 1452*D1**2*f**2*gdd2*s**2 - 2112*D1**2*f**2*gdd2*s + 660*D1**2*f**2*gdd2 + 2556*D1**2*f*fd**2*r**2 + 6912*D1**2*f*fd**2*r*s - 4008*D1**2*f*fd**2*r + 4356*D1**2*f*fd**2*s**2 - 5208*D1**2*f*fd**2*s + 1152*D1**2*f*fd**2 + 792*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r - 1848*D1**2*f*fd*g2*s**2 + 1848*D1**2*f*fd*g2*s - 924*D1**2*f*fd*g2 + 2640*D1**2*f*fd*gd2*r**2 + 8448*D1**2*f*fd*gd2*r*s - 4752*D1**2*f*fd*gd2*r + 5808*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2112*D1**2*f*fd*gd2 + 1320*D1**2*f*fdd*g2*r**2 + 4224*D1**2*f*fdd*g2*r*s - 2112*D1**2*f*fdd*g2*r + 2904*D1**2*f*fdd*g2*s**2 - 2904*D1**2*f*fdd*g2*s + 1452*D1**2*f*fdd*g2 + 1320*D1**2*fd**2*g2*r**2 + 4224*D1**2*fd**2*g2*r*s - 2112*D1**2*fd**2*g2*r + 2904*D1**2*fd**2*g2*s**2 - 2904*D1**2*fd**2*g2*s - 2640*D1*Dd*K*bd1*f**2*r**2 - 8448*D1*Dd*K*bd1*f**2*r*s + 5016*D1*Dd*K*bd1*f**2*r - 5808*D1*Dd*K*bd1*f**2*s**2 + 7788*D1*Dd*K*bd1*f**2*s - 2376*D1*Dd*K*bd1*f**2 + 7128*D1*Dd*bd1*f**2*r**2 + 14256*D1*Dd*bd1*f**2*r*s - 13530*D1*Dd*bd1*f**2*r + 7128*D1*Dd*bd1*f**2*s**2 - 13530*D1*Dd*bd1*f**2*s + 6138*D1*Dd*bd1*f**2 - 3872*D1*Dd*bd1*f*g2*r**2 - 5632*D1*Dd*bd1*f*g2*r*s + 3344*D1*Dd*bd1*f*g2*r - 1760*D1*Dd*bd1*f*g2*s**2 + 1496*D1*Dd*bd1*f*g2*s - 264*D1*Dd*bd1*f*g2 + 904*D1*Dd*f**3*r**2 - 944*D1*Dd*f**3*r*s - 668*D1*Dd*f**3*r - 1848*D1*Dd*f**3*s**2 + 1396*D1*Dd*f**3*s - 10*D1*Dd*f**3 + 10224*D1*Dd*f**2*fd*r**2 + 27648*D1*Dd*f**2*fd*r*s - 16584*D1*Dd*f**2*fd*r + 17424*D1*Dd*f**2*fd*s**2 - 21684*D1*Dd*f**2*fd*s + 6612*D1*Dd*f**2*fd + 1584*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s - 1056*D1*Dd*f**2*g2*r - 3696*D1*Dd*f**2*g2*s**2 + 2904*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 + 5280*D1*Dd*f**2*gd2*r**2 + 16896*D1*Dd*f**2*gd2*r*s - 10032*D1*Dd*f**2*gd2*r + 11616*D1*Dd*f**2*gd2*s**2 - 15576*D1*Dd*f**2*gd2*s + 4752*D1*Dd*f**2*gd2 + 10560*D1*Dd*f*fd*g2*r**2 + 33792*D1*Dd*f*fd*g2*r*s - 17952*D1*Dd*f*fd*g2*r + 23232*D1*Dd*f*fd*g2*s**2 - 25872*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 + 1704*D1*Ddd*f**3*r**2 + 4608*D1*Ddd*f**3*r*s - 2856*D1*Ddd*f**3*r + 2904*D1*Ddd*f**3*s**2 - 3756*D1*Ddd*f**3*s + 1578*D1*Ddd*f**3 + 2640*D1*Ddd*f**2*g2*r**2 + 8448*D1*Ddd*f**2*g2*r*s - 4752*D1*Ddd*f**2*g2*r + 5808*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 2772*D1*Ddd*f**2*g2 + 44*D1*b2*(bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 5112*Dd**2*f**3*r**2 + 13824*Dd**2*f**3*r*s - 8568*Dd**2*f**3*r + 8712*Dd**2*f**3*s**2 - 11268*Dd**2*f**3*s + 3156*Dd**2*f**3 + 7920*Dd**2*f**2*g2*r**2 + 25344*Dd**2*f**2*g2*r*s - 14256*Dd**2*f**2*g2*r + 17424*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 5544*Dd**2*f**2*g2 + 22*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(14*K + 3*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(14*K + 3*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(-16*C*D1**2*fd*r**2 - 32*C*D1**2*fd*r*s + 32*C*D1**2*fd*r - 16*C*D1**2*fd*s**2 + 32*C*D1**2*fd*s - 16*C*D1**2*fd + 8*C*D1**2*fdd*r**2 + 16*C*D1**2*fdd*r*s - 16*C*D1**2*fdd*r + 8*C*D1**2*fdd*s**2 - 16*C*D1**2*fdd*s + 8*C*D1**2*fdd - 64*C*D1*Dd*f*r**2 - 128*C*D1*Dd*f*r*s + 96*C*D1*Dd*f*r - 64*C*D1*Dd*f*s**2 + 96*C*D1*Dd*f*s - 48*C*D1*Dd*f + 64*C*D1*Dd*fd*r**2 + 128*C*D1*Dd*fd*r*s - 112*C*D1*Dd*fd*r + 64*C*D1*Dd*fd*s**2 - 112*C*D1*Dd*fd*s + 48*C*D1*Dd*fd + 32*C*D1*Ddd*f*r**2 + 64*C*D1*Ddd*f*r*s - 48*C*D1*Ddd*f*r + 32*C*D1*Ddd*f*s**2 - 48*C*D1*Ddd*f*s + 24*C*D1*Ddd*f + 96*C*Dd**2*f*r**2 + 192*C*Dd**2*f*r*s - 144*C*Dd**2*f*r + 96*C*Dd**2*f*s**2 - 144*C*Dd**2*f*s + 48*C*Dd**2*f + 82*D1**2*K*fd*r**2 + 188*D1**2*K*fd*r*s + 160*D1**2*K*fd*r + 106*D1**2*K*fd*s**2 + 160*D1**2*K*fd*s - 80*D1**2*K*fd + 22*D1**2*K*fdd*r**2 + 32*D1**2*K*fdd*r*s - 24*D1**2*K*fdd*r + 10*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 2*D1**2*bdd1*(14*K + 3*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 78*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 90*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 45*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 132*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 45*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 132*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s - 45*D1**2*fd*r**2 - 38*D1**2*fd*r*s - 52*D1**2*fd*r + 7*D1**2*fd*s**2 - 52*D1**2*fd*s + 26*D1**2*fd - 23*D1**2*fdd*r**2 - 58*D1**2*fdd*r*s + 12*D1**2*fdd*r - 35*D1**2*fdd*s**2 + 12*D1**2*fdd*s - 6*D1**2*fdd - 112*D1**2*gd2*r**2 - 224*D1**2*gd2*r*s + 224*D1**2*gd2*r - 112*D1**2*gd2*s**2 + 224*D1**2*gd2*s - 112*D1**2*gd2 + 56*D1**2*gdd2*r**2 + 112*D1**2*gdd2*r*s - 112*D1**2*gdd2*r + 56*D1**2*gdd2*s**2 - 112*D1**2*gdd2*s + 56*D1**2*gdd2 + 328*D1*Dd*K*f*r**2 + 752*D1*Dd*K*f*r*s - 516*D1*Dd*K*f*r + 424*D1*Dd*K*f*s**2 - 588*D1*Dd*K*f*s + 270*D1*Dd*K*f + 176*D1*Dd*K*fd*r**2 + 256*D1*Dd*K*fd*r*s - 216*D1*Dd*K*fd*r + 80*D1*Dd*K*fd*s**2 - 180*D1*Dd*K*fd*s + 72*D1*Dd*K*fd - 156*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 93*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1056*D1*Dd*f*fd*r*s - 852*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 612*D1*Dd*f*fd*s + 246*D1*Dd*f*fd - 180*D1*Dd*f*r**2 - 152*D1*Dd*f*r*s + 218*D1*Dd*f*r + 28*D1*Dd*f*s**2 + 62*D1*Dd*f*s - 83*D1*Dd*f - 184*D1*Dd*fd*r**2 - 464*D1*Dd*fd*r*s + 198*D1*Dd*fd*r - 280*D1*Dd*fd*s**2 + 234*D1*Dd*fd*s - 36*D1*Dd*fd - 448*D1*Dd*g2*r**2 - 896*D1*Dd*g2*r*s + 672*D1*Dd*g2*r - 448*D1*Dd*g2*s**2 + 672*D1*Dd*g2*s - 336*D1*Dd*g2 + 448*D1*Dd*gd2*r**2 + 896*D1*Dd*gd2*r*s - 784*D1*Dd*gd2*r + 448*D1*Dd*gd2*s**2 - 784*D1*Dd*gd2*s + 336*D1*Dd*gd2 + 88*D1*Ddd*K*f*r**2 + 128*D1*Ddd*K*f*r*s - 120*D1*Ddd*K*f*r + 40*D1*Ddd*K*f*s**2 - 84*D1*Ddd*K*f*s + 54*D1*Ddd*K*f + 180*D1*Ddd*f**2*r**2 + 264*D1*Ddd*f**2*r*s - 246*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 174*D1*Ddd*f**2*s + 111*D1*Ddd*f**2 - 92*D1*Ddd*f*r**2 - 232*D1*Ddd*f*r*s + 150*D1*Ddd*f*r - 140*D1*Ddd*f*s**2 + 186*D1*Ddd*f*s - 81*D1*Ddd*f + 224*D1*Ddd*g2*r**2 + 448*D1*Ddd*g2*r*s - 336*D1*Ddd*g2*r + 224*D1*Ddd*g2*s**2 - 336*D1*Ddd*g2*s + 168*D1*Ddd*g2 + 4*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(14*K + 3*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 264*Dd**2*K*f*r**2 + 384*Dd**2*K*f*r*s - 360*Dd**2*K*f*r + 120*Dd**2*K*f*s**2 - 252*Dd**2*K*f*s + 108*Dd**2*K*f + 540*Dd**2*f**2*r**2 + 792*Dd**2*f**2*r*s - 738*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 522*Dd**2*f**2*s + 222*Dd**2*f**2 - 276*Dd**2*f*r**2 - 696*Dd**2*f*r*s + 450*Dd**2*f*r - 420*Dd**2*f*s**2 + 558*Dd**2*f*s - 162*Dd**2*f + 672*Dd**2*g2*r**2 + 1344*Dd**2*g2*r*s - 1008*Dd**2*g2*r + 672*Dd**2*g2*s**2 - 1008*Dd**2*g2*s + 336*Dd**2*g2) - 11*b1*(-16*C*D1**2*bdd1*f*r**2 - 32*C*D1**2*bdd1*f*r*s + 16*C*D1**2*bdd1*f*r - 16*C*D1**2*bdd1*f*s**2 + 16*C*D1**2*bdd1*f*s - 8*C*D1**2*bdd1*f - 328*C*D1**2*f*fd*r**2 - 816*C*D1**2*f*fd*r*s + 264*C*D1**2*f*fd*r - 488*C*D1**2*f*fd*s**2 + 344*C*D1**2*f*fd*s - 132*C*D1**2*f*fd + 232*C*D1**2*f*fdd*r**2 + 512*C*D1**2*f*fdd*r*s - 184*C*D1**2*f*fdd*r + 280*C*D1**2*f*fdd*s**2 - 208*C*D1**2*f*fdd*s + 92*C*D1**2*f*fdd + 232*C*D1**2*fd**2*r**2 + 512*C*D1**2*fd**2*r*s - 184*C*D1**2*fd**2*r + 280*C*D1**2*fd**2*s**2 - 208*C*D1**2*fd**2*s - 48*C*D1**2*fd**2 - 656*C*D1*Dd*f**2*r**2 - 1632*C*D1*Dd*f**2*r*s + 1064*C*D1*Dd*f**2*r - 976*C*D1*Dd*f**2*s**2 + 1304*C*D1*Dd*f**2*s - 572*C*D1*Dd*f**2 + 1856*C*D1*Dd*f*fd*r**2 + 4096*C*D1*Dd*f*fd*r*s - 2176*C*D1*Dd*f*fd*r + 2240*C*D1*Dd*f*fd*s**2 - 2416*C*D1*Dd*f*fd*s + 576*C*D1*Dd*f*fd + 464*C*D1*Ddd*f**2*r**2 + 1024*C*D1*Ddd*f**2*r*s - 720*C*D1*Ddd*f**2*r + 560*C*D1*Ddd*f**2*s**2 - 792*C*D1*Ddd*f**2*s + 372*C*D1*Ddd*f**2 + 1392*C*Dd**2*f**2*r**2 + 3072*C*Dd**2*f**2*r*s - 2160*C*Dd**2*f**2*r + 1680*C*Dd**2*f**2*s**2 - 2376*C*Dd**2*f**2*s + 744*C*Dd**2*f**2 - 44*D1**2*K*bdd1*f*r**2 - 64*D1**2*K*bdd1*f*r*s + 52*D1**2*K*bdd1*f*r - 20*D1**2*K*bdd1*f*s**2 + 28*D1**2*K*bdd1*f*s - 20*D1**2*K*bdd1*f + 36*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 84*D1**2*K*f*fd*s**2 + 84*D1**2*K*f*fd*s - 42*D1**2*K*f*fd + 60*D1**2*K*f*fdd*r**2 + 192*D1**2*K*f*fdd*r*s - 96*D1**2*K*f*fdd*r + 132*D1**2*K*f*fdd*s**2 - 132*D1**2*K*f*fdd*s + 66*D1**2*K*f*fdd + 60*D1**2*K*fd**2*r**2 + 192*D1**2*K*fd**2*r*s - 96*D1**2*K*fd**2*r + 132*D1**2*K*fd**2*s**2 - 132*D1**2*K*fd**2*s - 76*D1**2*b2*fd*r**2 - 152*D1**2*b2*fd*r*s - 76*D1**2*b2*fd*s**2 + 24*D1**2*b2*fdd*r**2 + 48*D1**2*b2*fdd*r*s + 24*D1**2*b2*fdd*s**2 + 4*D1**2*bd1**2*(14*K + 3*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 90*D1**2*bdd1*f**2*r**2 - 132*D1**2*bdd1*f**2*r*s + 156*D1**2*bdd1*f**2*r - 42*D1**2*bdd1*f**2*s**2 + 108*D1**2*bdd1*f**2*s - 66*D1**2*bdd1*f**2 + 46*D1**2*bdd1*f*r**2 + 116*D1**2*bdd1*f*r*s - 92*D1**2*bdd1*f*r + 70*D1**2*bdd1*f*s**2 - 116*D1**2*bdd1*f*s + 52*D1**2*bdd1*f - 112*D1**2*bdd1*g2*r**2 - 224*D1**2*bdd1*g2*r*s + 112*D1**2*bdd1*g2*r - 112*D1**2*bdd1*g2*s**2 + 112*D1**2*bdd1*g2*s - 56*D1**2*bdd1*g2 + 24*D1**2*bdd2*f*r**2 + 48*D1**2*bdd2*f*r*s - 48*D1**2*bdd2*f*r + 24*D1**2*bdd2*f*s**2 - 48*D1**2*bdd2*f*s + 24*D1**2*bdd2*f + 190*D1**2*f*fd*r**2 + 460*D1**2*f*fd*r*s - 174*D1**2*f*fd*r + 270*D1**2*f*fd*s**2 - 214*D1**2*f*fd*s + 93*D1**2*f*fd - 162*D1**2*f*fdd*r**2 - 324*D1**2*f*fdd*r*s + 138*D1**2*f*fdd*r - 162*D1**2*f*fdd*s**2 + 138*D1**2*f*fdd*s - 69*D1**2*f*fdd + 164*D1**2*f*gd2*r**2 + 376*D1**2*f*gd2*r*s - 328*D1**2*f*gd2*r + 212*D1**2*f*gd2*s**2 - 376*D1**2*f*gd2*s + 164*D1**2*f*gd2 + 44*D1**2*f*gdd2*r**2 + 64*D1**2*f*gdd2*r*s - 88*D1**2*f*gdd2*r + 20*D1**2*f*gdd2*s**2 - 64*D1**2*f*gdd2*s + 44*D1**2*f*gdd2 - 162*D1**2*fd**2*r**2 - 324*D1**2*fd**2*r*s + 138*D1**2*fd**2*r - 162*D1**2*fd**2*s**2 + 138*D1**2*fd**2*s + 24*D1**2*fd**2 + 164*D1**2*fd*g2*r**2 + 376*D1**2*fd*g2*r*s + 320*D1**2*fd*g2*r + 212*D1**2*fd*g2*s**2 + 320*D1**2*fd*g2*s - 160*D1**2*fd*g2 + 88*D1**2*fd*gd2*r**2 + 128*D1**2*fd*gd2*r*s - 136*D1**2*fd*gd2*r + 40*D1**2*fd*gd2*s**2 - 112*D1**2*fd*gd2*s + 48*D1**2*fd*gd2 + 44*D1**2*fdd*g2*r**2 + 64*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*r + 20*D1**2*fdd*g2*s**2 - 48*D1**2*fdd*g2*s + 24*D1**2*fdd*g2 + 72*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s - 48*D1*Dd*K*f**2*r - 168*D1*Dd*K*f**2*s**2 + 132*D1*Dd*K*f**2*s - 6*D1*Dd*K*f**2 + 480*D1*Dd*K*f*fd*r**2 + 1536*D1*Dd*K*f*fd*r*s - 816*D1*Dd*K*f*fd*r + 1056*D1*Dd*K*f*fd*s**2 - 1176*D1*Dd*K*f*fd*s + 324*D1*Dd*K*f*fd - 304*D1*Dd*b2*f*r**2 - 608*D1*Dd*b2*f*r*s + 456*D1*Dd*b2*f*r - 304*D1*Dd*b2*f*s**2 + 456*D1*Dd*b2*f*s - 228*D1*Dd*b2*f + 192*D1*Dd*b2*fd*r**2 + 384*D1*Dd*b2*fd*r*s - 144*D1*Dd*b2*fd*r + 192*D1*Dd*b2*fd*s**2 - 144*D1*Dd*b2*fd*s + 380*D1*Dd*f**2*r**2 + 920*D1*Dd*f**2*r*s - 610*D1*Dd*f**2*r + 540*D1*Dd*f**2*s**2 - 730*D1*Dd*f**2*s + 325*D1*Dd*f**2 - 1296*D1*Dd*f*fd*r**2 - 2592*D1*Dd*f*fd*r*s + 1524*D1*Dd*f*fd*r - 1296*D1*Dd*f*fd*s**2 + 1524*D1*Dd*f*fd*s - 414*D1*Dd*f*fd + 656*D1*Dd*f*g2*r**2 + 1504*D1*Dd*f*g2*r*s - 1032*D1*Dd*f*g2*r + 848*D1*Dd*f*g2*s**2 - 1176*D1*Dd*f*g2*s + 540*D1*Dd*f*g2 + 352*D1*Dd*f*gd2*r**2 + 512*D1*Dd*f*gd2*r*s - 592*D1*Dd*f*gd2*r + 160*D1*Dd*f*gd2*s**2 - 424*D1*Dd*f*gd2*s + 240*D1*Dd*f*gd2 + 352*D1*Dd*fd*g2*r**2 + 512*D1*Dd*fd*g2*r*s - 432*D1*Dd*fd*g2*r + 160*D1*Dd*fd*g2*s**2 - 360*D1*Dd*fd*g2*s + 144*D1*Dd*fd*g2 + 120*D1*Ddd*K*f**2*r**2 + 384*D1*Ddd*K*f**2*r*s - 216*D1*Ddd*K*f**2*r + 264*D1*Ddd*K*f**2*s**2 - 324*D1*Ddd*K*f**2*s + 126*D1*Ddd*K*f**2 + 96*D1*Ddd*b2*f*r**2 + 192*D1*Ddd*b2*f*r*s - 144*D1*Ddd*b2*f*r + 96*D1*Ddd*b2*f*s**2 - 144*D1*Ddd*b2*f*s + 72*D1*Ddd*b2*f - 324*D1*Ddd*f**2*r**2 - 648*D1*Ddd*f**2*r*s + 486*D1*Ddd*f**2*r - 324*D1*Ddd*f**2*s**2 + 486*D1*Ddd*f**2*s - 243*D1*Ddd*f**2 + 176*D1*Ddd*f*g2*r**2 + 256*D1*Ddd*f*g2*r*s - 240*D1*Ddd*f*g2*r + 80*D1*Ddd*f*g2*s**2 - 168*D1*Ddd*f*g2*s + 108*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(3*f**2*(13*r**2 + 2*r*(9*s - 10) + 5*s**2 - 12*s + 8) + f*(8*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 82*K*r**2 - 188*K*r*s + 256*K*r - 106*K*s**2 + 280*K*s - 134*K - 6*fd*(30*r**2 + 44*r*s - 41*r + 14*s**2 - 29*s + 13) + 45*r**2 + 38*r*s - 90*r - 7*s**2 - 38*s + 32) - 2*fd*(4*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(22*r**2 + 32*r*s - 25*r + 10*s**2 - 19*s + 6) - 23*r**2 - 58*r*s + 29*r - 35*s**2 + 35*s - 3) + 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(3*f**2*(60*r**2 + r*(88*s - 93) + 28*s**2 - 65*s + 35) + f*(4*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + K*(88*r**2 + 16*r*(8*s - 7) + 40*s**2 - 70*s + 33) - 92*r**2 - 232*r*s + 167*r - 140*s**2 + 209*s - 75) + 28*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 4*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 360*Dd**2*K*f**2*r**2 + 1152*Dd**2*K*f**2*r*s - 648*Dd**2*K*f**2*r + 792*Dd**2*K*f**2*s**2 - 972*Dd**2*K*f**2*s + 252*Dd**2*K*f**2 + 288*Dd**2*b2*f*r**2 + 576*Dd**2*b2*f*r*s - 432*Dd**2*b2*f*r + 288*Dd**2*b2*f*s**2 - 432*Dd**2*b2*f*s + 144*Dd**2*b2*f - 972*Dd**2*f**2*r**2 - 1944*Dd**2*f**2*r*s + 1458*Dd**2*f**2*r - 972*Dd**2*f**2*s**2 + 1458*Dd**2*f**2*s - 486*Dd**2*f**2 + 528*Dd**2*f*g2*r**2 + 768*Dd**2*f*g2*r*s - 720*Dd**2*f*g2*r + 240*Dd**2*f*g2*s**2 - 504*Dd**2*f*g2*s + 216*Dd**2*f*g2))/(231*d**2*k3**6) - 8*D1**2*Pk2*Pk3*ct*k1*k2**3*(2*D1*(7*D1*b2*bd1*f*(r + s - 1)**2 + D1*bd1**2*(r + s - 1)*(35*K*f*(r + s - 1) - f*(24*C - 12)*(r + s) + 28*g2*(r + s)) + D1*bdd1*f*(f*(6*C - 3)*(6*r + 5*s - 5) - 35*g2*(r + s - 1))*(r + s - 1) + bd1*(D1*(3*f**2*(r + s - 1)*(2*C*(r + 3*s - 3) - 3*r - 3*s + 3) + f*(fd*(6*C - 3)*(24*r**2 + r*(44*s - 34) + 20*s**2 - 31*s + 11) + (-21*g2 - 70*gd2)*(r + s - 1)**2) - 70*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + Dd*f*(f*(6*C - 3)*(48*r**2 + r*(88*s - 79) + 40*s**2 - 72*s + 32) - 70*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 7*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(4*K + f) - 2*Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(-14*K*bdd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(-8*C*(r + s - 1)**2 + 21*K*s**2 + r**2*(21*K - 3) + r*(42*K*s + 8*s - 22) + 11*s**2 - 22*s + 11) + fdd*(-24*C*(r + s - 1)**2 + 35*K*s**2 + r**2*(35*K + 12) + r*(70*K*s + 24*s - 24) + 12*s**2 - 24*s + 12) - 56*gd2*(r + s - 1)**2 + 28*gdd2*(r + s - 1)**2) + 7*D1*bd1*(D1*(4*K + f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 4*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(f*(-8*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 21*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*r**2 + 32*r*s + 4*r + 44*s**2 - 38*s + 5) - 2*fd*(4*r + 4*s - 3)*(24*C*(r + s - 1) - 35*K*s - r*(35*K + 12) - 12*s + 12) - 56*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 56*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*(f*(-24*C + 35*K + 12) + 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(-24*C + 35*K + 12) + 28*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - b1*(-24*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 12*C*D1**2*f*fd - 144*C*D1**2*f*fdd*r**2 - 264*C*D1**2*f*fdd*r*s + 144*C*D1**2*f*fdd*r - 120*C*D1**2*f*fdd*s**2 + 132*C*D1**2*f*fdd*s - 72*C*D1**2*f*fdd - 144*C*D1**2*fd**2*r**2 - 264*C*D1**2*fd**2*r*s + 144*C*D1**2*fd**2*r - 120*C*D1**2*fd**2*s**2 + 132*C*D1**2*fd**2*s - 48*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 168*C*D1*Dd*f**2*s - 60*C*D1*Dd*f**2 - 1152*C*D1*Dd*f*fd*r**2 - 2112*C*D1*Dd*f*fd*r*s + 1416*C*D1*Dd*f*fd*r - 960*C*D1*Dd*f*fd*s**2 + 1296*C*D1*Dd*f*fd*s - 420*C*D1*Dd*f*fd - 288*C*D1*Ddd*f**2*r**2 - 528*C*D1*Ddd*f**2*r*s + 420*C*D1*Ddd*f**2*r - 240*C*D1*Ddd*f**2*s**2 + 384*C*D1*Ddd*f**2*s - 204*C*D1*Ddd*f**2 - 864*C*Dd**2*f**2*r**2 - 1584*C*Dd**2*f**2*r*s + 1260*C*Dd**2*f**2*r - 720*C*Dd**2*f**2*s**2 + 1152*C*Dd**2*f**2*s - 408*C*Dd**2*f**2 + 28*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 14*D1**2*b2*fd*r**2 - 28*D1**2*b2*fd*r*s - 14*D1**2*b2*fd*s**2 - 14*D1**2*bd2*f*(r + s - 1)**2 - 2*D1**2*bdd1*(f*(-12*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 35*K*(r + s - 1)**2 + 12*r**2 + 24*r*s - 12*r + 12*s**2 - 12*s + 6) + 14*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 36*D1**2*f*fd*r**2 + 72*D1**2*f*fd*r*s - 36*D1**2*f*fd*r + 36*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s + 18*D1**2*f*fd + 72*D1**2*f*fdd*r**2 + 132*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 36*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 84*D1**2*f*gd2*r*s - 84*D1**2*f*gd2*r + 42*D1**2*f*gd2*s**2 - 84*D1**2*f*gd2*s + 42*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 140*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*r + 70*D1**2*f*gdd2*s**2 - 140*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 + 72*D1**2*fd**2*r**2 + 132*D1**2*fd**2*r*s - 72*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s + 42*D1**2*fd*g2*r**2 + 84*D1**2*fd*g2*r*s + 42*D1**2*fd*g2*s**2 + 140*D1**2*fd*gd2*r**2 + 280*D1**2*fd*gd2*r*s - 140*D1**2*fd*gd2*r + 140*D1**2*fd*gd2*s**2 - 140*D1**2*fd*gd2*s + 70*D1**2*fdd*g2*r**2 + 140*D1**2*fdd*g2*r*s + 70*D1**2*fdd*g2*s**2 - 56*D1*Dd*b2*f*r**2 - 112*D1*Dd*b2*f*r*s + 84*D1*Dd*b2*f*r - 56*D1*Dd*b2*f*s**2 + 84*D1*Dd*b2*f*s - 42*D1*Dd*b2*f + 72*D1*Dd*f**2*r**2 + 144*D1*Dd*f**2*r*s - 108*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 108*D1*Dd*f**2*s + 54*D1*Dd*f**2 + 576*D1*Dd*f*fd*r**2 + 1056*D1*Dd*f*fd*r*s - 708*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 648*D1*Dd*f*fd*s + 210*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 336*D1*Dd*f*g2*r*s - 252*D1*Dd*f*g2*r + 168*D1*Dd*f*g2*s**2 - 252*D1*Dd*f*g2*s + 126*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 1120*D1*Dd*f*gd2*r*s - 980*D1*Dd*f*gd2*r + 560*D1*Dd*f*gd2*s**2 - 980*D1*Dd*f*gd2*s + 420*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 1120*D1*Dd*fd*g2*r*s - 420*D1*Dd*fd*g2*r + 560*D1*Dd*fd*g2*s**2 - 420*D1*Dd*fd*g2*s + 144*D1*Ddd*f**2*r**2 + 264*D1*Ddd*f**2*r*s - 210*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 192*D1*Ddd*f**2*s + 102*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 560*D1*Ddd*f*g2*r*s - 420*D1*Ddd*f*g2*r + 280*D1*Ddd*f*g2*s**2 - 420*D1*Ddd*f*g2*s + 210*D1*Ddd*f*g2 + D1*bd1*(D1*(f*(8*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 42*K*(r + s - 1)**2 + 6*r**2 - 16*r*s - 20*r - 22*s**2 + 8*s + 3) + 4*fd*(r + s - 1)*(12*C*(2*r + 2*s - 1) - 35*K*s - r*(35*K + 12) - 12*s + 6) + 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(f*(12*C*(2*r + 2*s - 1) - 35*K*(r + s - 1) - 12*r - 12*s + 6) - 14*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 432*Dd**2*f**2*r**2 + 792*Dd**2*f**2*r*s - 630*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 576*Dd**2*f**2*s + 204*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 1680*Dd**2*f*g2*r*s - 1260*Dd**2*f*g2*r + 840*Dd**2*f*g2*s**2 - 1260*Dd**2*f*g2*s + 420*Dd**2*f*g2))/(21*d**2*k3**6) + 20*D1**2*Pk2*Pk3*ct*k1*st**6*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) - f*(2*fd*(s**2*(21*bd1 - 3) + s*(2 - 7*bd1) - 1) + fdd*(3*s**2 - 2*s + 1) + s**2*(-66*bd1 + 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) - D1*f*(2*Dd*(f*(s**2*(28*bd1 - 4) + s*(2 - 7*bd1) - 1) + (4*s - 1)*(33*bd1*s + fd*(3*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(231*d**2*k2*k3**2) + 24*D1**2*Pk2*Pk3*ct*k1*st**4*(-2*D1**2*bd1**2*f*s**2 + 2*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*(-4*f*s + f))) + b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)))/(7*d**2*k2**3) - 2*D1**2*Pk2*Pk3*ct*k1*st**2*(D1*f*s*(2*D1*bd1**2*(s*(21*f - 31) + 2) + 11*D1*bdd1*f*s + bd1*(-19*D1*f*s + 22*D1*fd*(2*s - 1) + 22*Dd*f*(4*s - 1))) + 2*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd + 28) + s*(3*fd + 14) - 7) - D1*Ddd*(3*f - 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f - 7)*(2*s - 1)) + b1**2*(-2*D1**2*bdd1*(3*f - 7)*(3*s**2 - 2*s + 1) - 66*D1**2*f*fd*s**2 + 66*D1**2*f*fd*s - 33*D1**2*f*fd + 42*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd + 42*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s + 41*D1**2*fd*s**2 - 74*D1**2*fd*s + 37*D1**2*fd - 31*D1**2*fdd*s**2 + 58*D1**2*fdd*s - 29*D1**2*fdd - 132*D1*Dd*f**2*s**2 + 66*D1*Dd*f**2*s - 33*D1*Dd*f**2 + 336*D1*Dd*f*fd*s**2 - 252*D1*Dd*f*fd*s + 42*D1*Dd*f*fd + 164*D1*Dd*f*s**2 - 82*D1*Dd*f*s + 41*D1*Dd*f - 248*D1*Dd*fd*s**2 + 294*D1*Dd*fd*s - 58*D1*Dd*fd + 84*D1*Ddd*f**2*s**2 - 42*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 - 124*D1*Ddd*f*s**2 + 62*D1*Ddd*f*s - 31*D1*Ddd*f + 4*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) - s**2*(9*fd + 21) + s*(3*fd + 14) - 7) - Dd*(3*f - 7)*(12*s**2 - 7*s + 1)) + 252*Dd**2*f**2*s**2 - 126*Dd**2*f**2*s - 372*Dd**2*f*s**2 + 186*Dd**2*f*s) + b1*(-4*D1**2*bd1**2*s*(3*f - 7)*(3*s - 2) + 2*D1**2*bdd1*f*(s**2*(21*f - 31) + 2*s - 1) - 38*D1**2*f*fd*s**2 + 38*D1**2*f*fd*s - 19*D1**2*f*fd + 22*D1**2*f*fdd*s**2 - 22*D1**2*f*fdd*s + 11*D1**2*f*fdd + 22*D1**2*fd**2*s**2 - 22*D1**2*fd**2*s - 76*D1*Dd*f**2*s**2 + 38*D1*Dd*f**2*s - 19*D1*Dd*f**2 + 176*D1*Dd*f*fd*s**2 - 132*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 44*D1*Ddd*f**2*s**2 - 22*D1*Ddd*f**2*s + 11*D1*Ddd*f**2 - 2*D1*bd1*(D1*(33*f**2*s**2 + f*(-s**2*(84*fd + 41) + s*(42*fd + 4) - 2) + 2*fd*s*(31*s - 30)) - 2*Dd*f*(4*s - 1)*(s*(21*f - 31) + 1)) + 132*Dd**2*f**2*s**2 - 66*Dd**2*f**2*s))/(21*d**2*k2**3) + 2*D1**2*Pk2*Pk3*ct*k1*(D1*f*s*(2*D1*bd1**2*(s*(21*f - 5) + 19) + 19*D1*bdd1*f*s - 19*bd1*(D1*f*s + D1*fd*(2 - 4*s) + Dd*f*(2 - 8*s))) + 7*b1**3*(D1**2*s**2*(5*fd - 3*fdd) + D1*Dd*(5*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 16) + s*(6*fd - 8) + 4) - D1*Ddd*(3*f + 2)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 2)*(2*s - 1)) + b1**2*(-7*D1**2*bdd1*(3*f + 2)*(3*s**2 - 2*s + 1) - 42*D1**2*f*fd*s**2 + 42*D1**2*f*fd*s - 21*D1**2*f*fd + 42*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd + 42*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s + 17*D1**2*fd*s**2 + 28*D1**2*fd*s - 14*D1**2*fd - 5*D1**2*fdd*s**2 - 28*D1**2*fdd*s + 14*D1**2*fdd - 84*D1*Dd*f**2*s**2 + 42*D1*Dd*f**2*s - 21*D1*Dd*f**2 + 336*D1*Dd*f*fd*s**2 - 252*D1*Dd*f*fd*s + 42*D1*Dd*f*fd + 68*D1*Dd*f*s**2 - 34*D1*Dd*f*s + 17*D1*Dd*f - 40*D1*Dd*fd*s**2 - 102*D1*Dd*fd*s + 28*D1*Dd*fd + 84*D1*Ddd*f**2*s**2 - 42*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 - 20*D1*Ddd*f*s**2 + 10*D1*Ddd*f*s - 5*D1*Ddd*f + 7*D1*bd1*(D1*(5*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 12) + s*(6*fd - 8) + 4) - 2*Dd*(3*f + 2)*(12*s**2 - 7*s + 1)) + 252*Dd**2*f**2*s**2 - 126*Dd**2*f**2*s - 60*Dd**2*f*s**2 + 30*Dd**2*f*s) - b1*(14*D1**2*bd1**2*s*(3*f + 2)*(3*s - 2) + D1**2*bdd1*f*(s**2*(10 - 42*f) - 38*s + 19) + 19*D1**2*(f*(fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*bd1*(D1*(42*f**2*s**2 + f*(-s**2*(168*fd + 34) + s*(84*fd + 62) - 31) + 2*fd*s*(10*s + 9)) - 2*Dd*f*(4*s - 1)*(s*(42*f - 10) + 19)) + 19*D1*f*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(8*s**2 - 6*s + 1) + Ddd*f*(-4*s**2 + 2*s - 1)) + 114*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2**3) - 8*D1**2*Pk2*Pk3*f**2*k1**6*st**4*(D1**2*(f*(61*fd - 50*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 300*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(61*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 100*fd*(4*r + 4*s - 3)**2) - 50*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 300*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1001*d**2*k3**8) - 320*D1**2*Pk2*Pk3*f**2*k1**6*st**4*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(3003*d**2*k2**2*k3**6) - 20*D1**2*Pk2*Pk3*f**2*k1**4*k2**2*st**6*(D1**2*(f*(73*fd - 30*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 180*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(73*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 60*fd*(4*r + 4*s - 3)**2) - 30*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(3003*d**2*k3**8) - 160*D1**2*Pk2*Pk3*f**2*k1**4*st**6*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(1001*d**2*k3**6) - 60*D1**2*Pk2*Pk3*f**2*k1**4*st**6*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(1001*d**2*k2**2*k3**4) + 40*D1**2*Pk2*Pk3*f**2*k1**2*k2**4*st**8*(D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(429*d**2*k3**8) + 160*D1**2*Pk2*Pk3*f**2*k1**2*k2**2*st**8*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(1287*d**2*k3**6) + 40*D1**2*Pk2*Pk3*f**2*k1**2*st**8*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(429*d**2*k3**4) - 8*D1**2*Pk2*Pk3*f*k1**6*st**2*(-50*D1**2*bdd1*f**2*(r + s - 1)**2 + D1*bd1*f*(r + s - 1)*(67*D1*f*(r + s - 1) - 100*D1*fd*(3*r + 3*s - 2) - 100*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(f*(67*fd - 50*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 100*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(67*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 100*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 50*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 300*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**8) + 100*D1**2*Pk2*Pk3*f*k1**6*st**2*(-12*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*s**2 + 8*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*s**2 - 4*D1**2*b1*f*fdd*s + 12*D1**2*b1*fd**2*r*s + 12*D1**2*b1*fd**2*s**2 - 8*D1**2*b1*fd**2*s + 2*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + 12*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 12*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 3*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r*s + 3*D1**2*f**2*fdd*r - 12*D1**2*f**2*fdd*s**2 + 12*D1**2*f**2*fdd*s - 3*D1**2*f**2*fdd - 36*D1**2*f*fd**2*r*s + 9*D1**2*f*fd**2*r - 36*D1**2*f*fd**2*s**2 + 36*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 - 16*D1*Dd*b1*f**2*r*s + 4*D1*Dd*b1*f**2*r - 16*D1*Dd*b1*f**2*s**2 + 16*D1*Dd*b1*f**2*s - 4*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r*s - 6*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 40*D1*Dd*b1*f*fd*s + 4*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r*s + 24*D1*Dd*f**2*fd*r - 96*D1*Dd*f**2*fd*s**2 + 96*D1*Dd*f**2*fd*s - 18*D1*Dd*f**2*fd + 8*D1*Ddd*b1*f**2*r*s - 2*D1*Ddd*b1*f**2*r + 8*D1*Ddd*b1*f**2*s**2 - 8*D1*Ddd*b1*f**2*s + 2*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r*s + 3*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 12*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) + 24*Dd**2*b1*f**2*r*s - 6*Dd**2*b1*f**2*r + 24*Dd**2*b1*f**2*s**2 - 24*Dd**2*b1*f**2*s + 4*Dd**2*b1*f**2 - 36*Dd**2*f**3*r*s + 9*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 36*Dd**2*f**3*s - 6*Dd**2*f**3)/(693*d**2*k2**2*k3**6) + 40*D1**2*Pk2*Pk3*f*k1**6*(-D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) + b1*(D1**2*s*(f*(fd - fdd) - 2*fd**2)*(3*r + 3*s - 2) + D1*f*(Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) + Dd*fd*(r*(3 - 24*s) - 24*s**2 + 20*s - 2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(21*d**2*k2**2*k3**6) + 4*D1**2*Pk2*Pk3*f*k1**4*st**4*(-84*D1**2*b1*f*fd*r**2 - 216*D1**2*b1*f*fd*r*s + 104*D1**2*b1*f*fd*r - 132*D1**2*b1*f*fd*s**2 + 136*D1**2*b1*f*fd*s - 36*D1**2*b1*f*fd + 42*D1**2*b1*f*fdd*r**2 + 108*D1**2*b1*f*fdd*r*s - 52*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s**2 - 68*D1**2*b1*f*fdd*s + 18*D1**2*b1*f*fdd + 84*D1**2*b1*fd**2*r**2 + 216*D1**2*b1*fd**2*r*s - 104*D1**2*b1*fd**2*r + 132*D1**2*b1*fd**2*s**2 - 136*D1**2*b1*fd**2*s + 36*D1**2*b1*fd**2 + 2*D1**2*bdd1*f**2*(7*r**2 + 18*r*s - 20*r + 11*s**2 - 24*s + 16) + 124*D1**2*f**2*fd*r**2 + 424*D1**2*f**2*fd*r*s - 230*D1**2*f**2*fd*r + 300*D1**2*f**2*fd*s**2 - 362*D1**2*f**2*fd*s + 137*D1**2*f**2*fd - 148*D1**2*f**2*fdd*r**2 - 376*D1**2*f**2*fdd*r*s + 242*D1**2*f**2*fdd*r - 228*D1**2*f**2*fdd*s**2 + 302*D1**2*f**2*fdd*s - 131*D1**2*f**2*fdd - 444*D1**2*f*fd**2*r**2 - 1128*D1**2*f*fd**2*r*s + 726*D1**2*f*fd**2*r - 684*D1**2*f*fd**2*s**2 + 906*D1**2*f*fd**2*s - 262*D1**2*f*fd**2 - 112*D1*Dd*b1*f**2*r**2 - 288*D1*Dd*b1*f**2*r*s + 184*D1*Dd*b1*f**2*r - 176*D1*Dd*b1*f**2*s**2 + 232*D1*Dd*b1*f**2*s - 100*D1*Dd*b1*f**2 + 336*D1*Dd*b1*f*fd*r**2 + 864*D1*Dd*b1*f*fd*r*s - 484*D1*Dd*b1*f*fd*r + 528*D1*Dd*b1*f*fd*s**2 - 620*D1*Dd*b1*f*fd*s + 172*D1*Dd*b1*f*fd + 124*D1*Dd*f**3*r**2 + 424*D1*Dd*f**3*r*s - 230*D1*Dd*f**3*r + 300*D1*Dd*f**3*s**2 - 362*D1*Dd*f**3*s + 137*D1*Dd*f**3 - 1184*D1*Dd*f**2*fd*r**2 - 3008*D1*Dd*f**2*fd*r*s + 1936*D1*Dd*f**2*fd*r - 1824*D1*Dd*f**2*fd*s**2 + 2416*D1*Dd*f**2*fd*s - 786*D1*Dd*f**2*fd + 56*D1*Ddd*b1*f**2*r**2 + 144*D1*Ddd*b1*f**2*r*s - 92*D1*Ddd*b1*f**2*r + 88*D1*Ddd*b1*f**2*s**2 - 116*D1*Ddd*b1*f**2*s + 50*D1*Ddd*b1*f**2 - 148*D1*Ddd*f**3*r**2 - 376*D1*Ddd*f**3*r*s + 242*D1*Ddd*f**3*r - 228*D1*Ddd*f**3*s**2 + 302*D1*Ddd*f**3*s - 131*D1*Ddd*f**3 - 4*D1*bd1*f*(D1*(f*(7*r**2 + 18*r*s - 20*r + 11*s**2 - 24*s + 16) - fd*(21*r**2 + 54*r*s - 43*r + 33*s**2 - 53*s + 16)) - Dd*f*(28*r**2 + 9*r*(8*s - 7) + 44*s**2 - 77*s + 32)) + 168*Dd**2*b1*f**2*r**2 + 432*Dd**2*b1*f**2*r*s - 276*Dd**2*b1*f**2*r + 264*Dd**2*b1*f**2*s**2 - 348*Dd**2*b1*f**2*s + 100*Dd**2*b1*f**2 - 444*Dd**2*f**3*r**2 - 1128*Dd**2*f**3*r*s + 726*Dd**2*f**3*r - 684*Dd**2*f**3*s**2 + 906*Dd**2*f**3*s - 262*Dd**2*f**3)/(231*d**2*k3**6) + 4*D1**2*Pk2*Pk3*f*k1**4*st**4*(-48*D1**2*b1*f*fd*r*s + 16*D1**2*b1*f*fd*r - 72*D1**2*b1*f*fd*s**2 + 48*D1**2*b1*f*fd*s - 12*D1**2*b1*f*fd + 24*D1**2*b1*f*fdd*r*s - 8*D1**2*b1*f*fdd*r + 36*D1**2*b1*f*fdd*s**2 - 24*D1**2*b1*f*fdd*s + 6*D1**2*b1*f*fdd + 48*D1**2*b1*fd**2*r*s - 16*D1**2*b1*fd**2*r + 72*D1**2*b1*fd**2*s**2 - 48*D1**2*b1*fd**2*s + 12*D1**2*b1*fd**2 + 2*D1**2*bdd1*f**2*(6*s**2 + s*(4*r - 8) + 3) + 40*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r + 156*D1**2*f**2*fd*s**2 - 98*D1**2*f**2*fd*s + 39*D1**2*f**2*fd - 40*D1**2*f**2*fdd*r*s + 10*D1**2*f**2*fdd*r - 108*D1**2*f**2*fdd*s**2 + 74*D1**2*f**2*fdd*s - 27*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r*s + 30*D1**2*f*fd**2*r - 324*D1**2*f*fd**2*s**2 + 222*D1**2*f*fd**2*s - 20*D1**2*f*fd**2 - 64*D1*Dd*b1*f**2*r*s + 16*D1*Dd*b1*f**2*r - 96*D1*Dd*b1*f**2*s**2 + 80*D1*Dd*b1*f**2*s - 24*D1*Dd*b1*f**2 + 192*D1*Dd*b1*f*fd*r*s - 56*D1*Dd*b1*f*fd*r + 288*D1*Dd*b1*f*fd*s**2 - 216*D1*Dd*b1*f*fd*s + 40*D1*Dd*b1*f*fd + 40*D1*Dd*f**3*r*s - 10*D1*Dd*f**3*r + 156*D1*Dd*f**3*s**2 - 98*D1*Dd*f**3*s + 39*D1*Dd*f**3 - 320*D1*Dd*f**2*fd*r*s + 80*D1*Dd*f**2*fd*r - 864*D1*Dd*f**2*fd*s**2 + 592*D1*Dd*f**2*fd*s - 94*D1*Dd*f**2*fd + 32*D1*Ddd*b1*f**2*r*s - 8*D1*Ddd*b1*f**2*r + 48*D1*Ddd*b1*f**2*s**2 - 40*D1*Ddd*b1*f**2*s + 12*D1*Ddd*b1*f**2 - 40*D1*Ddd*f**3*r*s + 10*D1*Ddd*f**3*r - 108*D1*Ddd*f**3*s**2 + 74*D1*Ddd*f**3*s - 27*D1*Ddd*f**3 - 4*D1*bd1*f*(D1*f*(6*s**2 + s*(4*r - 8) + 3) + D1*fd*(r*(2 - 12*s) - 18*s**2 + 18*s - 1) + 2*Dd*f*(-8*r*s + r - 12*s**2 + 13*s - 2)) + 96*Dd**2*b1*f**2*r*s - 24*Dd**2*b1*f**2*r + 144*Dd**2*b1*f**2*s**2 - 120*Dd**2*b1*f**2*s + 16*Dd**2*b1*f**2 - 120*Dd**2*f**3*r*s + 30*Dd**2*f**3*r - 324*Dd**2*f**3*s**2 + 222*Dd**2*f**3*s - 20*Dd**2*f**3)/(231*d**2*k2**2*k3**4) - 20*D1**2*Pk2*Pk3*f*k1**2*k2**4*st**6*(24*D1**2*b1*f*fd*r**2 + 48*D1**2*b1*f*fd*r*s - 32*D1**2*b1*f*fd*r + 24*D1**2*b1*f*fd*s**2 - 32*D1**2*b1*f*fd*s + 16*D1**2*b1*f*fd - 12*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 16*D1**2*b1*f*fdd*r - 12*D1**2*b1*f*fdd*s**2 + 16*D1**2*b1*f*fdd*s - 8*D1**2*b1*f*fdd - 24*D1**2*b1*fd**2*r**2 - 48*D1**2*b1*fd**2*r*s + 32*D1**2*b1*fd**2*r - 24*D1**2*b1*fd**2*s**2 + 32*D1**2*b1*fd**2*s - 8*D1**2*b1*fd**2 - 4*D1**2*bdd1*f**2*(r + s - 1)**2 + 4*D1**2*f**2*fd*r**2 + 8*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r + 4*D1**2*f**2*fd*s**2 - 6*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 32*D1*Dd*b1*f**2*r**2 + 64*D1*Dd*b1*f**2*r*s - 48*D1*Dd*b1*f**2*r + 32*D1*Dd*b1*f**2*s**2 - 48*D1*Dd*b1*f**2*s + 24*D1*Dd*b1*f**2 - 96*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 136*D1*Dd*b1*f*fd*r - 96*D1*Dd*b1*f*fd*s**2 + 136*D1*Dd*b1*f*fd*s - 48*D1*Dd*b1*f*fd + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 16*D1*Ddd*b1*f**2*r**2 - 32*D1*Ddd*b1*f**2*r*s + 24*D1*Ddd*b1*f**2*r - 16*D1*Ddd*b1*f**2*s**2 + 24*D1*Ddd*b1*f**2*s - 12*D1*Ddd*b1*f**2 + 8*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 48*Dd**2*b1*f**2*r**2 - 96*Dd**2*b1*f**2*r*s + 72*Dd**2*b1*f**2*r - 48*Dd**2*b1*f**2*s**2 + 72*Dd**2*b1*f**2*s - 24*Dd**2*b1*f**2)/(231*d**2*k3**8) - 24*D1**2*Pk2*Pk3*f*k1**2*k2**4*st**4*(D1**2*(f*(fd*(8*C - 4)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (11*K*bd1 - 22*gd2)*(r + s - 1)**2) + fd*(-fd*(8*C - 4)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + (11*K*b1 - 22*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1))) + D1*f*(Dd*(f*(8*C - 4)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*C - 4)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - (-11*K*b1 + 22*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Ddd*f*(2 - 4*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Dd**2*f**2*(12 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**8) + 10*D1**2*Pk2*Pk3*f*k1**2*k2**2*st**6*(60*D1**2*b1*f*fd*r**2 + 48*D1**2*b1*f*fd*r*s - 56*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s**2 - 8*D1**2*b1*f*fd*s + 12*D1**2*b1*f*fd - 30*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 28*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 + 4*D1**2*b1*f*fdd*s - 6*D1**2*b1*f*fdd - 60*D1**2*b1*fd**2*r**2 - 48*D1**2*b1*fd**2*r*s + 56*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 + 8*D1**2*b1*fd**2*s - 12*D1**2*b1*fd**2 - 2*D1**2*bdd1*f**2*(5*r**2 + 4*r*s - 10*r - s**2 - 4*s + 6) - 84*D1**2*f**2*fd*r**2 - 160*D1**2*f**2*fd*r*s + 124*D1**2*f**2*fd*r - 76*D1**2*f**2*fd*s**2 + 118*D1**2*f**2*fd*s - 61*D1**2*f**2*fd + 92*D1**2*f**2*fdd*r**2 + 144*D1**2*f**2*fdd*r*s - 128*D1**2*f**2*fdd*r + 52*D1**2*f**2*fdd*s**2 - 98*D1**2*f**2*fdd*s + 59*D1**2*f**2*fdd + 276*D1**2*f*fd**2*r**2 + 432*D1**2*f*fd**2*r*s - 384*D1**2*f*fd**2*r + 156*D1**2*f*fd**2*s**2 - 294*D1**2*f*fd**2*s + 118*D1**2*f*fd**2 + 80*D1*Dd*b1*f**2*r**2 + 64*D1*Dd*b1*f**2*r*s - 96*D1*Dd*b1*f**2*r - 16*D1*Dd*b1*f**2*s**2 - 24*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 240*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 256*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 + 52*D1*Dd*b1*f*fd*s - 60*D1*Dd*b1*f*fd - 84*D1*Dd*f**3*r**2 - 160*D1*Dd*f**3*r*s + 124*D1*Dd*f**3*r - 76*D1*Dd*f**3*s**2 + 118*D1*Dd*f**3*s - 61*D1*Dd*f**3 + 736*D1*Dd*f**2*fd*r**2 + 1152*D1*Dd*f**2*fd*r*s - 1024*D1*Dd*f**2*fd*r + 416*D1*Dd*f**2*fd*s**2 - 784*D1*Dd*f**2*fd*s + 354*D1*Dd*f**2*fd - 40*D1*Ddd*b1*f**2*r**2 - 32*D1*Ddd*b1*f**2*r*s + 48*D1*Ddd*b1*f**2*r + 8*D1*Ddd*b1*f**2*s**2 + 12*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 + 92*D1*Ddd*f**3*r**2 + 144*D1*Ddd*f**3*r*s - 128*D1*Ddd*f**3*r + 52*D1*Ddd*f**3*s**2 - 98*D1*Ddd*f**3*s + 59*D1*Ddd*f**3 + 4*D1*bd1*f*(D1*(f*(5*r**2 + 4*r*s - 10*r - s**2 - 4*s + 6) + fd*(-15*r**2 - 12*r*s + 22*r + 3*s**2 + 7*s - 6)) + Dd*f*(-20*r**2 - 16*r*(s - 2) + 4*s**2 + 11*s - 12)) - 120*Dd**2*b1*f**2*r**2 - 96*Dd**2*b1*f**2*r*s + 144*Dd**2*b1*f**2*r + 24*Dd**2*b1*f**2*s**2 + 36*Dd**2*b1*f**2*s - 36*Dd**2*b1*f**2 + 276*Dd**2*f**3*r**2 + 432*Dd**2*f**3*r*s - 384*Dd**2*f**3*r + 156*Dd**2*f**3*s**2 - 294*Dd**2*f**3*s + 118*Dd**2*f**3)/(693*d**2*k3**6) + 8*D1**2*Pk2*Pk3*f*k1**2*k2**2*st**4*(48*C*D1**2*f*fd*r**2 + 96*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*r + 48*C*D1**2*f*fd*s**2 - 64*C*D1**2*f*fd*s + 32*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s + 32*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 + 32*C*D1**2*f*fdd*s - 16*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r**2 - 96*C*D1**2*fd**2*r*s + 64*C*D1**2*fd**2*r - 48*C*D1**2*fd**2*s**2 + 64*C*D1**2*fd**2*s - 16*C*D1**2*fd**2 + 64*C*D1*Dd*f**2*r**2 + 128*C*D1*Dd*f**2*r*s - 96*C*D1*Dd*f**2*r + 64*C*D1*Dd*f**2*s**2 - 96*C*D1*Dd*f**2*s + 48*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s + 272*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 272*C*D1*Dd*f*fd*s - 96*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r**2 - 64*C*D1*Ddd*f**2*r*s + 48*C*D1*Ddd*f**2*r - 32*C*D1*Ddd*f**2*s**2 + 48*C*D1*Ddd*f**2*s - 24*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r**2 - 192*C*Dd**2*f**2*r*s + 144*C*Dd**2*f**2*r - 96*C*Dd**2*f**2*s**2 + 144*C*Dd**2*f**2*s - 48*C*Dd**2*f**2 + 11*D1**2*K*bd1*f*r**2 + 44*D1**2*K*bd1*f*r*s - 22*D1**2*K*bd1*f*r + 33*D1**2*K*bd1*f*s**2 - 44*D1**2*K*bd1*f*s + 11*D1**2*K*bd1*f + 22*D1**2*b2*fd*r**2 + 44*D1**2*b2*fd*r*s - 22*D1**2*b2*fd*r + 22*D1**2*b2*fd*s**2 - 22*D1**2*b2*fd*s + 11*D1**2*b2*fd - 11*D1**2*bd1*f*r*s - 11*D1**2*bd1*f*s**2 + 11*D1**2*bd1*f*s + 11*D1**2*bd2*f*(r + s - 1)**2 - 30*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s + 40*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 40*D1**2*f*fd*s - 20*D1**2*f*fd + 15*D1**2*f*fdd*r**2 + 30*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 15*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 10*D1**2*f*fdd - 22*D1**2*f*gd2*r**2 - 88*D1**2*f*gd2*r*s + 44*D1**2*f*gd2*r - 66*D1**2*f*gd2*s**2 + 88*D1**2*f*gd2*s - 22*D1**2*f*gd2 + 30*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 40*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 40*D1**2*fd**2*s + 10*D1**2*fd**2 - 44*D1**2*fd*g2*r**2 - 176*D1**2*fd*g2*r*s + 88*D1**2*fd*g2*r - 132*D1**2*fd*g2*s**2 + 132*D1**2*fd*g2*s - 66*D1**2*fd*g2 + 44*D1*Dd*b2*f*r**2 + 88*D1*Dd*b2*f*r*s - 66*D1*Dd*b2*f*r + 44*D1*Dd*b2*f*s**2 - 66*D1*Dd*b2*f*s + 33*D1*Dd*b2*f - 40*D1*Dd*f**2*r**2 - 80*D1*Dd*f**2*r*s + 60*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 60*D1*Dd*f**2*s - 30*D1*Dd*f**2 + 120*D1*Dd*f*fd*r**2 + 240*D1*Dd*f*fd*r*s - 170*D1*Dd*f*fd*r + 120*D1*Dd*f*fd*s**2 - 170*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 88*D1*Dd*f*g2*r**2 - 352*D1*Dd*f*g2*r*s + 176*D1*Dd*f*g2*r - 264*D1*Dd*f*g2*s**2 + 308*D1*Dd*f*g2*s - 110*D1*Dd*f*g2 + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 11*D1*b1*(D1*fd*(K*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 6*s + 3) - 2*r*s + r - 2*s**2 + 2*s - 1) + Dd*f*(K*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 14*s + 5) - 4*r*s + r - 4*s**2 + 4*s - 1)) + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2)/(77*d**2*k3**6) + 20*D1**2*Pk2*Pk3*f*k1**2*st**6*(D1*f*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - 3*fd*s + fd) + Dd*(-4*f*s + f))) + b1*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2**2*k3**2) + 8*D1**2*Pk2*Pk3*f*k1**2*st**4*(D1**2*(f*(2*fd - fdd)*(C*(6*s**2 - 4*s + 2) + r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(r*(2 - 6*s) - s**2*(12*C + 6) + s*(8*C + 6) - 1)) + D1*f*(Dd*(2*f*(C*(8*s**2 - 4*s + 2) + r*(4*s - 1) + (1 - 2*s)**2) - fd*(4*C*(12*s**2 - 7*s + 1) + r*(24*s - 7) + 24*s**2 - 24*s + 5)) + Ddd*f*(C*(-8*s**2 + 4*s - 2) - 4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(r*(3 - 12*s) - s**2*(24*C + 12) + s*(12*C + 12) - 2))/(231*d**2*k2**2*k3**2) + 8*D1**2*Pk2*Pk3*k1**6*(-10*D1**2*bd1**2*f**2*(r + s - 1)**2 + 2*D1*b1*f*(-5*D1*bdd1*f*(r + s - 1) + 2*bd1*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + b1**2*(D1**2*(f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**8) + 4*D1**2*Pk2*Pk3*k1**4*k2**2*st**2*(-102*C*D1**2*f**2*fd*r**2 - 204*C*D1**2*f**2*fd*r*s + 136*C*D1**2*f**2*fd*r - 102*C*D1**2*f**2*fd*s**2 + 136*C*D1**2*f**2*fd*s - 68*C*D1**2*f**2*fd + 150*C*D1**2*f**2*fdd*r**2 + 300*C*D1**2*f**2*fdd*r*s - 200*C*D1**2*f**2*fdd*r + 150*C*D1**2*f**2*fdd*s**2 - 200*C*D1**2*f**2*fdd*s + 100*C*D1**2*f**2*fdd + 300*C*D1**2*f*fd**2*r**2 + 600*C*D1**2*f*fd**2*r*s - 400*C*D1**2*f*fd**2*r + 300*C*D1**2*f*fd**2*s**2 - 400*C*D1**2*f*fd**2*s + 100*C*D1**2*f*fd**2 - 136*C*D1*Dd*f**3*r**2 - 272*C*D1*Dd*f**3*r*s + 204*C*D1*Dd*f**3*r - 136*C*D1*Dd*f**3*s**2 + 204*C*D1*Dd*f**3*s - 102*C*D1*Dd*f**3 + 1200*C*D1*Dd*f**2*fd*r**2 + 2400*C*D1*Dd*f**2*fd*r*s - 1700*C*D1*Dd*f**2*fd*r + 1200*C*D1*Dd*f**2*fd*s**2 - 1700*C*D1*Dd*f**2*fd*s + 600*C*D1*Dd*f**2*fd + 200*C*D1*Ddd*f**3*r**2 + 400*C*D1*Ddd*f**3*r*s - 300*C*D1*Ddd*f**3*r + 200*C*D1*Ddd*f**3*s**2 - 300*C*D1*Ddd*f**3*s + 150*C*D1*Ddd*f**3 + 600*C*Dd**2*f**3*r**2 + 1200*C*Dd**2*f**3*r*s - 900*C*Dd**2*f**3*r + 600*C*Dd**2*f**3*s**2 - 900*C*Dd**2*f**3*s + 300*C*Dd**2*f**3 + 33*D1**2*K*bdd1*f**2*r**2 + 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*r + 33*D1**2*K*bdd1*f**2*s**2 - 66*D1**2*K*bdd1*f**2*s + 33*D1**2*K*bdd1*f**2 - 660*D1**2*bd1**2*f**2*(r + s - 1)**2 + 51*D1**2*f**2*fd*r**2 + 102*D1**2*f**2*fd*r*s - 68*D1**2*f**2*fd*r + 51*D1**2*f**2*fd*s**2 - 68*D1**2*f**2*fd*s + 34*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd + 66*D1**2*f**2*gd2*r**2 + 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*r + 66*D1**2*f**2*gd2*s**2 - 132*D1**2*f**2*gd2*s + 66*D1**2*f**2*gd2 - 66*D1**2*f**2*gdd2*r**2 - 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*r - 66*D1**2*f**2*gdd2*s**2 + 132*D1**2*f**2*gdd2*s - 66*D1**2*f**2*gdd2 - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 132*D1**2*f*fd*g2*r**2 + 264*D1**2*f*fd*g2*r*s - 132*D1**2*f*fd*g2*r + 132*D1**2*f*fd*g2*s**2 - 132*D1**2*f*fd*g2*s + 66*D1**2*f*fd*g2 - 264*D1**2*f*fd*gd2*r**2 - 528*D1**2*f*fd*gd2*r*s + 396*D1**2*f*fd*gd2*r - 264*D1**2*f*fd*gd2*s**2 + 396*D1**2*f*fd*gd2*s - 132*D1**2*f*fd*gd2 - 132*D1**2*f*fdd*g2*r**2 - 264*D1**2*f*fdd*g2*r*s + 132*D1**2*f*fdd*g2*r - 132*D1**2*f*fdd*g2*s**2 + 132*D1**2*f*fdd*g2*s - 66*D1**2*f*fdd*g2 - 132*D1**2*fd**2*g2*r**2 - 264*D1**2*fd**2*g2*r*s + 132*D1**2*fd**2*g2*r - 132*D1**2*fd**2*g2*s**2 + 132*D1**2*fd**2*g2*s + 68*D1*Dd*f**3*r**2 + 136*D1*Dd*f**3*r*s - 102*D1*Dd*f**3*r + 68*D1*Dd*f**3*s**2 - 102*D1*Dd*f**3*s + 51*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd + 264*D1*Dd*f**2*g2*r**2 + 528*D1*Dd*f**2*g2*r*s - 396*D1*Dd*f**2*g2*r + 264*D1*Dd*f**2*g2*s**2 - 396*D1*Dd*f**2*g2*s + 198*D1*Dd*f**2*g2 - 528*D1*Dd*f**2*gd2*r**2 - 1056*D1*Dd*f**2*gd2*r*s + 924*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s**2 + 924*D1*Dd*f**2*gd2*s - 396*D1*Dd*f**2*gd2 - 1056*D1*Dd*f*fd*g2*r**2 - 2112*D1*Dd*f*fd*g2*r*s + 1320*D1*Dd*f*fd*g2*r - 1056*D1*Dd*f*fd*g2*s**2 + 1320*D1*Dd*f*fd*g2*s - 396*D1*Dd*f*fd*g2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 264*D1*Ddd*f**2*g2*r**2 - 528*D1*Ddd*f**2*g2*r*s + 396*D1*Ddd*f**2*g2*r - 264*D1*Ddd*f**2*g2*s**2 + 396*D1*Ddd*f**2*g2*s - 198*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(D1*(-K*f*(r + s - 1) + 2*K*fd*(2*r + 2*s - 1) + 2*f**2*(r + s - 1)) + 2*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3 - 792*Dd**2*f**2*g2*r**2 - 1584*Dd**2*f**2*g2*r*s + 1188*Dd**2*f**2*g2*r - 792*Dd**2*f**2*g2*s**2 + 1188*Dd**2*f**2*g2*s - 396*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(f*(17*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 20*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(17*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 20*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-2*D1**2*K*f*fd*r**2 - 4*D1**2*K*f*fd*r*s + 2*D1**2*K*f*fd*r - 2*D1**2*K*f*fd*s**2 + 2*D1**2*K*f*fd*s - D1**2*K*f*fd + 2*D1**2*K*f*fdd*r**2 + 4*D1**2*K*f*fdd*r*s - 2*D1**2*K*f*fdd*r + 2*D1**2*K*f*fdd*s**2 - 2*D1**2*K*f*fdd*s + D1**2*K*f*fdd + 2*D1**2*K*fd**2*r**2 + 4*D1**2*K*fd**2*r*s - 2*D1**2*K*fd**2*r + 2*D1**2*K*fd**2*s**2 - 2*D1**2*K*fd**2*s - 20*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 4*D1*Dd*K*f**2*r**2 - 8*D1*Dd*K*f**2*r*s + 6*D1*Dd*K*f**2*r - 4*D1*Dd*K*f**2*s**2 + 6*D1*Dd*K*f**2*s - 3*D1*Dd*K*f**2 + 16*D1*Dd*K*f*fd*r**2 + 32*D1*Dd*K*f*fd*r*s - 20*D1*Dd*K*f*fd*r + 16*D1*Dd*K*f*fd*s**2 - 20*D1*Dd*K*f*fd*s + 6*D1*Dd*K*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 + 4*D1*Ddd*K*f**2*r**2 + 8*D1*Ddd*K*f**2*r*s - 6*D1*Ddd*K*f**2*r + 4*D1*Ddd*K*f**2*s**2 - 6*D1*Ddd*K*f**2*s + 3*D1*Ddd*K*f**2 + 2*D1*bd1*f*(r + s - 1)*(17*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) + 12*Dd**2*K*f**2*r**2 + 24*Dd**2*K*f**2*r*s - 18*Dd**2*K*f**2*r + 12*Dd**2*K*f**2*s**2 - 18*Dd**2*K*f**2*s + 6*Dd**2*K*f**2))/(231*d**2*k3**8) - 8*D1**2*Pk2*Pk3*k1**4*k2**2*(-12*D1**2*K*bd1**2*f*(r + s - 1)**2 - D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 12*K*b1 - 5*f - 12*g2) + 2*D1*bd1*(D1*(f**2*(4*C + 6*b1 - 2)*(r + s - 1) - f*fd*(10*C - 5)*(2*r + 2*s - 1) - f*(r + s - 1)*(-5*K*b1 + 5*g2 - 12*gd2) + 12*fd*(r + s)*(-K*b1 + g2)) - Dd*f*(4*r + 4*s - 3)*(10*C*f + 12*K*b1 - 5*f - 12*g2))*(r + s - 1) + b1*(D1**2*(f*(fd*(8*C + 6*b1 - 4)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-10*gd2 + 12*gdd2)*(r + s - 1)**2) - (r + s)*(fd**2*(20*C - 10)*(r + s - 1) - 24*fd*gd2*(r + s - 1) + 5*fd*(r + s)*(-K*b1 + 2*g2) - 6*fdd*(r + s)*(-K*b1 + 2*g2))) + D1*(Dd*(f**2*(8*C + 6*b1 - 4)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(20*K*b1*r**2 + 40*K*b1*r*s - 30*K*b1*r + 20*K*b1*s**2 - 30*K*b1*s + 15*K*b1 - fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 10*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 96*gd2*r**2 + 192*gd2*r*s - 168*gd2*r + 96*gd2*s**2 - 168*gd2*s + 72*gd2) + 12*fd*(-K*b1 + 2*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(10*C*f + 6*K*b1 - 5*f - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(10*C*f + 6*K*b1 - 5*f - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**8) - 4*D1**2*Pk2*Pk3*k1**4*st**2*(-102*C*D1**2*f**2*fd*r**2 - 408*C*D1**2*f**2*fd*r*s + 204*C*D1**2*f**2*fd*r - 306*C*D1**2*f**2*fd*s**2 + 340*C*D1**2*f**2*fd*s - 136*C*D1**2*f**2*fd + 150*C*D1**2*f**2*fdd*r**2 + 600*C*D1**2*f**2*fdd*r*s - 300*C*D1**2*f**2*fdd*r + 450*C*D1**2*f**2*fdd*s**2 - 500*C*D1**2*f**2*fdd*s + 200*C*D1**2*f**2*fdd + 300*C*D1**2*f*fd**2*r**2 + 1200*C*D1**2*f*fd**2*r*s - 600*C*D1**2*f*fd**2*r + 900*C*D1**2*f*fd**2*s**2 - 1000*C*D1**2*f*fd**2*s + 200*C*D1**2*f*fd**2 - 136*C*D1*Dd*f**3*r**2 - 544*C*D1*Dd*f**3*r*s + 272*C*D1*Dd*f**3*r - 408*C*D1*Dd*f**3*s**2 + 476*C*D1*Dd*f**3*s - 170*C*D1*Dd*f**3 + 1200*C*D1*Dd*f**2*fd*r**2 + 4800*C*D1*Dd*f**2*fd*r*s - 2400*C*D1*Dd*f**2*fd*r + 3600*C*D1*Dd*f**2*fd*s**2 - 4100*C*D1*Dd*f**2*fd*s + 1100*C*D1*Dd*f**2*fd + 200*C*D1*Ddd*f**3*r**2 + 800*C*D1*Ddd*f**3*r*s - 400*C*D1*Ddd*f**3*r + 600*C*D1*Ddd*f**3*s**2 - 700*C*D1*Ddd*f**3*s + 250*C*D1*Ddd*f**3 + 600*C*Dd**2*f**3*r**2 + 2400*C*Dd**2*f**3*r*s - 1200*C*Dd**2*f**3*r + 1800*C*Dd**2*f**3*s**2 - 2100*C*Dd**2*f**3*s + 500*C*Dd**2*f**3 + 33*D1**2*K*bdd1*f**2*r**2 + 132*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*r + 99*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s + 33*D1**2*K*bdd1*f**2 - 66*D1**2*b2*f*fd*r**2 - 132*D1**2*b2*f*fd*r*s + 66*D1**2*b2*f*fd*r - 66*D1**2*b2*f*fd*s**2 + 66*D1**2*b2*f*fd*s - 33*D1**2*b2*f*fd + 66*D1**2*b2*f*fdd*r**2 + 132*D1**2*b2*f*fdd*r*s - 66*D1**2*b2*f*fdd*r + 66*D1**2*b2*f*fdd*s**2 - 66*D1**2*b2*f*fdd*s + 33*D1**2*b2*f*fdd + 66*D1**2*b2*fd**2*r**2 + 132*D1**2*b2*fd**2*r*s - 66*D1**2*b2*fd**2*r + 66*D1**2*b2*fd**2*s**2 - 66*D1**2*b2*fd**2*s - 132*D1**2*bd1**2*f**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 33*D1**2*bd2*f**2*r**2 - 66*D1**2*bd2*f**2*r*s + 66*D1**2*bd2*f**2*r - 33*D1**2*bd2*f**2*s**2 + 66*D1**2*bd2*f**2*s - 33*D1**2*bd2*f**2 + 132*D1**2*bd2*f*fd*r**2 + 264*D1**2*bd2*f*fd*r*s - 198*D1**2*bd2*f*fd*r + 132*D1**2*bd2*f*fd*s**2 - 198*D1**2*bd2*f*fd*s + 66*D1**2*bd2*f*fd + 462*D1**2*bdd1*f**3*r**2 + 627*D1**2*bdd1*f**3*r*s - 858*D1**2*bdd1*f**3*r + 165*D1**2*bdd1*f**3*s**2 - 561*D1**2*bdd1*f**3*s + 396*D1**2*bdd1*f**3 - 33*D1**2*bdd1*f**2*r*s - 33*D1**2*bdd1*f**2*s**2 + 33*D1**2*bdd1*f**2*s + 33*D1**2*bdd2*f**2*r**2 + 66*D1**2*bdd2*f**2*r*s - 66*D1**2*bdd2*f**2*r + 33*D1**2*bdd2*f**2*s**2 - 66*D1**2*bdd2*f**2*s + 33*D1**2*bdd2*f**2 + 51*D1**2*f**2*fd*r**2 + 255*D1**2*f**2*fd*r*s - 119*D1**2*f**2*fd*r + 204*D1**2*f**2*fd*s**2 - 221*D1**2*f**2*fd*s + 85*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 375*D1**2*f**2*fdd*r*s + 175*D1**2*f**2*fdd*r - 300*D1**2*f**2*fdd*s**2 + 325*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd + 66*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*r + 198*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 66*D1**2*f**2*gd2 - 66*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*r - 198*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 66*D1**2*f**2*gdd2 - 150*D1**2*f*fd**2*r**2 - 750*D1**2*f*fd**2*r*s + 350*D1**2*f*fd**2*r - 600*D1**2*f*fd**2*s**2 + 650*D1**2*f*fd**2*s - 125*D1**2*f*fd**2 + 132*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 396*D1**2*f*fd*g2*s**2 - 396*D1**2*f*fd*g2*s + 198*D1**2*f*fd*g2 - 264*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 528*D1**2*f*fd*gd2*r - 792*D1**2*f*fd*gd2*s**2 + 924*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 132*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 396*D1**2*f*fdd*g2*s**2 + 396*D1**2*f*fdd*g2*s - 198*D1**2*f*fdd*g2 - 132*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 396*D1**2*fd**2*g2*s**2 + 396*D1**2*fd**2*g2*s - 132*D1*Dd*b2*f**2*r**2 - 264*D1*Dd*b2*f**2*r*s + 198*D1*Dd*b2*f**2*r - 132*D1*Dd*b2*f**2*s**2 + 198*D1*Dd*b2*f**2*s - 99*D1*Dd*b2*f**2 + 528*D1*Dd*b2*f*fd*r**2 + 1056*D1*Dd*b2*f*fd*r*s - 660*D1*Dd*b2*f*fd*r + 528*D1*Dd*b2*f*fd*s**2 - 660*D1*Dd*b2*f*fd*s + 198*D1*Dd*b2*f*fd + 264*D1*Dd*bd2*f**2*r**2 + 528*D1*Dd*bd2*f**2*r*s - 462*D1*Dd*bd2*f**2*r + 264*D1*Dd*bd2*f**2*s**2 - 462*D1*Dd*bd2*f**2*s + 198*D1*Dd*bd2*f**2 + 68*D1*Dd*f**3*r**2 + 340*D1*Dd*f**3*r*s - 153*D1*Dd*f**3*r + 272*D1*Dd*f**3*s**2 - 306*D1*Dd*f**3*s + 102*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 3000*D1*Dd*f**2*fd*r*s + 1375*D1*Dd*f**2*fd*r - 2400*D1*Dd*f**2*fd*s**2 + 2650*D1*Dd*f**2*fd*s - 675*D1*Dd*f**2*fd + 264*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s - 528*D1*Dd*f**2*g2*r + 792*D1*Dd*f**2*g2*s**2 - 924*D1*Dd*f**2*g2*s + 330*D1*Dd*f**2*g2 - 528*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1056*D1*Dd*f**2*gd2*r - 1584*D1*Dd*f**2*gd2*s**2 + 1980*D1*Dd*f**2*gd2*s - 528*D1*Dd*f**2*gd2 - 1056*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2112*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s**2 + 3432*D1*Dd*f*fd*g2*s - 924*D1*Dd*f*fd*g2 + 132*D1*Ddd*b2*f**2*r**2 + 264*D1*Ddd*b2*f**2*r*s - 198*D1*Ddd*b2*f**2*r + 132*D1*Ddd*b2*f**2*s**2 - 198*D1*Ddd*b2*f**2*s + 99*D1*Ddd*b2*f**2 - 100*D1*Ddd*f**3*r**2 - 500*D1*Ddd*f**3*r*s + 225*D1*Ddd*f**3*r - 400*D1*Ddd*f**3*s**2 + 450*D1*Ddd*f**3*s - 150*D1*Ddd*f**3 - 264*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 528*D1*Ddd*f**2*g2*r - 792*D1*Ddd*f**2*g2*s**2 + 924*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 33*D1*bd1*f*(D1*(f**2*(12*r**2 + r*(19*s - 28) + 7*s**2 - 23*s + 16) + f*(-fd*(84*r**2 + r*(114*s - 127) + 30*s**2 - 82*s + 45) + (K*(r + 3*s - 1) - s)*(r + s - 1)) - fd*(2*K*(2*r**2 + 8*r*s - 4*r + 6*s**2 - 7*s + 2) - 4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(2*K*(4*r**2 + 16*r*s - 8*r + 12*s**2 - 15*s + 4) + f*(112*r**2 + r*(152*s - 179) + 40*s**2 - 116*s + 69) - 8*r*s + r - 8*s**2 + 8*s - 1)) + 396*Dd**2*b2*f**2*r**2 + 792*Dd**2*b2*f**2*r*s - 594*Dd**2*b2*f**2*r + 396*Dd**2*b2*f**2*s**2 - 594*Dd**2*b2*f**2*s + 198*Dd**2*b2*f**2 - 300*Dd**2*f**3*r**2 - 1500*Dd**2*f**3*r*s + 675*Dd**2*f**3*r - 1200*Dd**2*f**3*s**2 + 1350*Dd**2*f**3*s - 300*Dd**2*f**3 - 792*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 1584*Dd**2*f**2*g2*r - 2376*Dd**2*f**2*g2*s**2 + 2772*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 66*b1**2*(D1**2*(f*(fd*(10*r**2 + 20*r*s - 14*r + 10*s**2 - 14*s + 7) - 2*fdd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 4*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-2*D1**2*K*f*fd*r**2 - 8*D1**2*K*f*fd*r*s + 4*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd + 2*D1**2*K*f*fdd*r**2 + 8*D1**2*K*f*fdd*r*s - 4*D1**2*K*f*fdd*r + 6*D1**2*K*f*fdd*s**2 - 6*D1**2*K*f*fdd*s + 3*D1**2*K*f*fdd + 2*D1**2*K*fd**2*r**2 + 8*D1**2*K*fd**2*r*s - 4*D1**2*K*fd**2*r + 6*D1**2*K*fd**2*s**2 - 6*D1**2*K*fd**2*s - 2*D1**2*bdd1*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - 36*D1**2*f**2*fd*r**2 - 57*D1**2*f**2*fd*r*s + 39*D1**2*f**2*fd*r - 21*D1**2*f**2*fd*s**2 + 29*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 42*D1**2*f**2*fdd*r**2 + 57*D1**2*f**2*fdd*r*s - 49*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 31*D1**2*f**2*fdd*s + 21*D1**2*f**2*fdd + 84*D1**2*f*fd**2*r**2 + 114*D1**2*f*fd**2*r*s - 98*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 62*D1**2*f*fd**2*s + 21*D1**2*f*fd**2 + 2*D1**2*f*fd*r*s - D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + D1**2*f*fd - 2*D1**2*f*fdd*r*s + D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 2*D1**2*f*fdd*s - D1**2*f*fdd - 2*D1**2*fd**2*r*s + D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 2*D1**2*fd**2*s - 4*D1*Dd*K*f**2*r**2 - 16*D1*Dd*K*f**2*r*s + 8*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 14*D1*Dd*K*f**2*s - 5*D1*Dd*K*f**2 + 16*D1*Dd*K*f*fd*r**2 + 64*D1*Dd*K*f*fd*r*s - 32*D1*Dd*K*f*fd*r + 48*D1*Dd*K*f*fd*s**2 - 52*D1*Dd*K*f*fd*s + 14*D1*Dd*K*f*fd - 48*D1*Dd*f**3*r**2 - 76*D1*Dd*f**3*r*s + 67*D1*Dd*f**3*r - 28*D1*Dd*f**3*s**2 + 52*D1*Dd*f**3*s - 31*D1*Dd*f**3 + 336*D1*Dd*f**2*fd*r**2 + 456*D1*Dd*f**2*fd*r*s - 421*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 268*D1*Dd*f**2*fd*s + 129*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r*s - D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 4*D1*Dd*f**2*s + D1*Dd*f**2 - 16*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 16*D1*Dd*f*fd*s - 4*D1*Dd*f*fd + 4*D1*Ddd*K*f**2*r**2 + 16*D1*Ddd*K*f**2*r*s - 8*D1*Ddd*K*f**2*r + 12*D1*Ddd*K*f**2*s**2 - 14*D1*Ddd*K*f**2*s + 5*D1*Ddd*K*f**2 + 56*D1*Ddd*f**3*r**2 + 76*D1*Ddd*f**3*r*s - 75*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 48*D1*Ddd*f**3*s + 33*D1*Ddd*f**3 - 4*D1*Ddd*f**2*r*s + D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 4*D1*Ddd*f**2*s - D1*Ddd*f**2 + 4*D1*bd1*f*(D1*(f*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 4) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(24*r**2 + r*(48*s - 38) + 24*s**2 - 38*s + 15)) + 12*Dd**2*K*f**2*r**2 + 48*Dd**2*K*f**2*r*s - 24*Dd**2*K*f**2*r + 36*Dd**2*K*f**2*s**2 - 42*Dd**2*K*f**2*s + 10*Dd**2*K*f**2 + 168*Dd**2*f**3*r**2 + 228*Dd**2*f**3*r*s - 225*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 144*Dd**2*f**3*s + 66*Dd**2*f**3 - 12*Dd**2*f**2*r*s + 3*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 12*Dd**2*f**2*s - 2*Dd**2*f**2))/(693*d**2*k3**6) + 8*D1**2*Pk2*Pk3*k1**4*(D1*(6*D1*bd1**2*f*(r + s - 1)*(-2*K*(r + 3*s - 2) + f*(9*r + 7*s - 8) + 2*s - 1) - D1*bdd1*f*(5*f*(2*C*(r + 3*s - 3) - r - 4*s + 4) - 12*g2*(r + 3*s - 3))*(r + s - 1) + b2*(-6*D1*bdd1*f*(r + s - 1) + bd1*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + bd1*(-12*D1*bd2*f*(r + s - 1)**2 + D1*(4*f**2*(r + s - 1)*(2*C*(r + 3*s - 3) - r - 4*s + 4) + f*(-5*fd*(4*C*(2*r**2 + 8*r*s - 5*r + 6*s**2 - 8*s + 2) - 4*r**2 - 20*r*s + 12*r - 16*s**2 + 21*s - 5) + (5*g2*(r + 3*s - 3) - 12*gd2*(r + 3*s - 2))*(-2*r - 2*s + 2)) + 24*fd*g2*(r**2 + r*(4*s - 2) + s*(3*s - 3))) + Dd*f*(-5*f*(4*C*(4*r**2 + 4*r*(4*s - 3) + 12*s**2 - 19*s + 7) - 8*r**2 - 40*r*s + 29*r - 32*s**2 + 50*s - 18) + 24*g2*(4*r**2 + 4*r*(4*s - 3) + 12*s**2 - 19*s + 7)))) + b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(5*D1**2*K*fd*r**2 + 20*D1**2*K*fd*r*s + 15*D1**2*K*fd*s**2 - 6*D1**2*K*fdd*r**2 - 24*D1**2*K*fdd*r*s - 18*D1**2*K*fdd*s**2 - 6*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 42*D1**2*f*fd*r**2 - 72*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 21*D1**2*f*fd + 54*D1**2*f*fdd*r**2 + 96*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 27*D1**2*f*fdd + 54*D1**2*fd**2*r**2 + 96*D1**2*fd**2*r*s - 54*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 48*D1**2*fd**2*s - 5*D1**2*fd*r*s - 5*D1**2*fd*s**2 + 6*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 + 20*D1*Dd*K*f*r**2 + 80*D1*Dd*K*f*r*s - 40*D1*Dd*K*f*r + 60*D1*Dd*K*f*s**2 - 70*D1*Dd*K*f*s + 25*D1*Dd*K*f - 48*D1*Dd*K*fd*r**2 - 192*D1*Dd*K*fd*r*s + 48*D1*Dd*K*fd*r - 144*D1*Dd*K*fd*s**2 + 84*D1*Dd*K*fd*s - 84*D1*Dd*f**2*r**2 - 144*D1*Dd*f**2*r*s + 120*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 102*D1*Dd*f**2*s - 57*D1*Dd*f**2 + 432*D1*Dd*f*fd*r**2 + 768*D1*Dd*f*fd*r*s - 528*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 468*D1*Dd*f*fd*s + 156*D1*Dd*f*fd - 20*D1*Dd*f*r*s + 5*D1*Dd*f*r - 20*D1*Dd*f*s**2 + 20*D1*Dd*f*s - 5*D1*Dd*f + 48*D1*Dd*fd*r*s - 6*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 24*D1*Dd*fd*s - 24*D1*Ddd*K*f*r**2 - 96*D1*Ddd*K*f*r*s + 48*D1*Ddd*K*f*r - 72*D1*Ddd*K*f*s**2 + 84*D1*Ddd*K*f*s - 30*D1*Ddd*K*f + 108*D1*Ddd*f**2*r**2 + 192*D1*Ddd*f**2*r*s - 156*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 138*D1*Ddd*f**2*s + 75*D1*Ddd*f**2 + 24*D1*Ddd*f*r*s - 6*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 24*D1*Ddd*f*s + 6*D1*Ddd*f + D1*bd1*(D1*(5*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - 12*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 72*Dd**2*K*f*r**2 - 288*Dd**2*K*f*r*s + 144*Dd**2*K*f*r - 216*Dd**2*K*f*s**2 + 252*Dd**2*K*f*s - 60*Dd**2*K*f + 324*Dd**2*f**2*r**2 + 576*Dd**2*f**2*r*s - 468*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 414*Dd**2*f**2*s + 150*Dd**2*f**2 + 72*Dd**2*f*r*s - 18*Dd**2*f*r + 72*Dd**2*f*s**2 - 72*Dd**2*f*s + 12*Dd**2*f) + b1*(16*C*D1**2*f*fd*r**2 + 64*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 48*C*D1**2*f*fd*s**2 - 32*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 - 80*C*D1**2*f*fdd*r*s + 20*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 40*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 - 80*C*D1**2*fd**2*r*s + 20*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 40*C*D1**2*fd**2*s + 32*C*D1*Dd*f**2*r**2 + 128*C*D1*Dd*f**2*r*s - 64*C*D1*Dd*f**2*r + 96*C*D1*Dd*f**2*s**2 - 112*C*D1*Dd*f**2*s + 40*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 - 640*C*D1*Dd*f*fd*r*s + 240*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 440*C*D1*Dd*f*fd*s - 80*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 - 160*C*D1*Ddd*f**2*r*s + 80*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 140*C*D1*Ddd*f**2*s - 50*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 - 480*C*Dd**2*f**2*r*s + 240*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 420*C*Dd**2*f**2*s - 100*C*Dd**2*f**2 - 12*D1**2*K*bdd1*f*r**2 - 48*D1**2*K*bdd1*f*r*s + 36*D1**2*K*bdd1*f*r - 36*D1**2*K*bdd1*f*s**2 + 60*D1**2*K*bdd1*f*s - 24*D1**2*K*bdd1*f + 5*D1**2*b2*fd*r**2 + 10*D1**2*b2*fd*r*s + 5*D1**2*b2*fd*s**2 - 6*D1**2*b2*fdd*r**2 - 12*D1**2*b2*fdd*r*s - 6*D1**2*b2*fdd*s**2 - 12*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 54*D1**2*bdd1*f**2*r**2 + 96*D1**2*bdd1*f**2*r*s - 102*D1**2*bdd1*f**2*r + 42*D1**2*bdd1*f**2*s**2 - 90*D1**2*bdd1*f**2*s + 48*D1**2*bdd1*f**2 + 12*D1**2*bdd1*f*r*s - 6*D1**2*bdd1*f*r + 12*D1**2*bdd1*f*s**2 - 18*D1**2*bdd1*f*s + 6*D1**2*bdd1*f - 6*D1**2*bdd2*f*r**2 - 12*D1**2*bdd2*f*r*s + 12*D1**2*bdd2*f*r - 6*D1**2*bdd2*f*s**2 + 12*D1**2*bdd2*f*s - 6*D1**2*bdd2*f - 8*D1**2*f*fd*r**2 - 40*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 32*D1**2*f*fd*s**2 + 20*D1**2*f*fd*s - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 50*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r + 40*D1**2*f*fdd*s**2 - 25*D1**2*f*fdd*s + 5*D1**2*f*fdd - 10*D1**2*f*gd2*r**2 - 40*D1**2*f*gd2*r*s + 20*D1**2*f*gd2*r - 30*D1**2*f*gd2*s**2 + 40*D1**2*f*gd2*s - 10*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 48*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*r + 36*D1**2*f*gdd2*s**2 - 48*D1**2*f*gdd2*s + 12*D1**2*f*gdd2 + 10*D1**2*fd**2*r**2 + 50*D1**2*fd**2*r*s - 10*D1**2*fd**2*r + 40*D1**2*fd**2*s**2 - 25*D1**2*fd**2*s - 10*D1**2*fd*g2*r**2 - 40*D1**2*fd*g2*r*s - 30*D1**2*fd*g2*s**2 + 24*D1**2*fd*gd2*r**2 + 96*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*r + 72*D1**2*fd*gd2*s**2 - 48*D1**2*fd*gd2*s + 12*D1**2*fdd*g2*r**2 + 48*D1**2*fdd*g2*r*s + 36*D1**2*fdd*g2*s**2 + 20*D1*Dd*b2*f*r**2 + 40*D1*Dd*b2*f*r*s - 30*D1*Dd*b2*f*r + 20*D1*Dd*b2*f*s**2 - 30*D1*Dd*b2*f*s + 15*D1*Dd*b2*f - 48*D1*Dd*b2*fd*r**2 - 96*D1*Dd*b2*fd*r*s + 36*D1*Dd*b2*fd*r - 48*D1*Dd*b2*fd*s**2 + 36*D1*Dd*b2*fd*s - 16*D1*Dd*f**2*r**2 - 80*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 + 72*D1*Dd*f**2*s - 24*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 400*D1*Dd*f*fd*r*s - 130*D1*Dd*f*fd*r + 320*D1*Dd*f*fd*s**2 - 280*D1*Dd*f*fd*s + 45*D1*Dd*f*fd - 40*D1*Dd*f*g2*r**2 - 160*D1*Dd*f*g2*r*s + 80*D1*Dd*f*g2*r - 120*D1*Dd*f*g2*s**2 + 140*D1*Dd*f*g2*s - 50*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 384*D1*Dd*f*gd2*r*s - 192*D1*Dd*f*gd2*r + 288*D1*Dd*f*gd2*s**2 - 360*D1*Dd*f*gd2*s + 96*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 384*D1*Dd*fd*g2*r*s - 96*D1*Dd*fd*g2*r + 288*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s - 24*D1*Ddd*b2*f*r**2 - 48*D1*Ddd*b2*f*r*s + 36*D1*Ddd*b2*f*r - 24*D1*Ddd*b2*f*s**2 + 36*D1*Ddd*b2*f*s - 18*D1*Ddd*b2*f + 20*D1*Ddd*f**2*r**2 + 100*D1*Ddd*f**2*r*s - 45*D1*Ddd*f**2*r + 80*D1*Ddd*f**2*s**2 - 90*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 192*D1*Ddd*f*g2*r*s - 96*D1*Ddd*f*g2*r + 144*D1*Ddd*f*g2*s**2 - 168*D1*Ddd*f*g2*s + 60*D1*Ddd*f*g2 + D1*bd1*(D1*(-6*f**2*(7*r**2 + r*(12*s - 13) + 5*s**2 - 11*s + 6) + f*(6*fd*(36*r**2 + r*(64*s - 52) + 28*s**2 - 46*s + 17) + (5*r + 5*s - 5)*(2*K*(r + 3*s - 2) - 2*s + 1)) - 6*fd*(4*K*r**2 + r*(2*K*(8*s - 3) - 4*s + 1) + s*(2*K*(6*s - 5) - 4*s + 3))) + 6*Dd*f*(-2*K*(8*r**2 + 4*r*(8*s - 5) + 24*s**2 - 34*s + 11) + f*(72*r**2 + 8*r*(16*s - 15) + 56*s**2 - 106*s + 49) + 16*r*s - 6*r + 16*s**2 - 20*s + 5)) + D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 72*Dd**2*b2*f*r**2 - 144*Dd**2*b2*f*r*s + 108*Dd**2*b2*f*r - 72*Dd**2*b2*f*s**2 + 108*Dd**2*b2*f*s - 36*Dd**2*b2*f + 60*Dd**2*f**2*r**2 + 300*Dd**2*f**2*r*s - 135*Dd**2*f**2*r + 240*Dd**2*f**2*s**2 - 270*Dd**2*f**2*s + 60*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 576*Dd**2*f*g2*r*s - 288*Dd**2*f*g2*r + 432*Dd**2*f*g2*s**2 - 504*Dd**2*f*g2*s + 120*Dd**2*f*g2))/(21*d**2*k3**6) - D1**2*Pk2*Pk3*k1**4*st**2*(102*C*D1**2*f**2*fd*s**2 - 68*C*D1**2*f**2*fd*s + 34*C*D1**2*f**2*fd - 150*C*D1**2*f**2*fdd*s**2 + 100*C*D1**2*f**2*fdd*s - 50*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*s**2 + 200*C*D1**2*f*fd**2*s + 136*C*D1*Dd*f**3*s**2 - 68*C*D1*Dd*f**3*s + 34*C*D1*Dd*f**3 - 1200*C*D1*Dd*f**2*fd*s**2 + 700*C*D1*Dd*f**2*fd*s - 100*C*D1*Dd*f**2*fd - 200*C*D1*Ddd*f**3*s**2 + 100*C*D1*Ddd*f**3*s - 50*C*D1*Ddd*f**3 - 600*C*Dd**2*f**3*s**2 + 300*C*Dd**2*f**3*s - 33*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*bd1**2*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 726*D1**2*bdd1*f**3*r*s - 330*D1**2*bdd1*f**3*r + 726*D1**2*bdd1*f**3*s**2 - 1188*D1**2*bdd1*f**3*s + 495*D1**2*bdd1*f**3 + 66*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 - 66*D1**2*bdd1*f**2*s + 1980*D1**2*f**3*fd*r*s - 495*D1**2*f**3*fd*r + 2376*D1**2*f**3*fd*s**2 - 2178*D1**2*f**3*fd*s + 594*D1**2*f**3*fd - 1980*D1**2*f**3*fdd*r*s + 495*D1**2*f**3*fdd*r - 2376*D1**2*f**3*fdd*s**2 + 2178*D1**2*f**3*fdd*s - 594*D1**2*f**3*fdd - 5940*D1**2*f**2*fd**2*r*s + 1485*D1**2*f**2*fd**2*r - 7128*D1**2*f**2*fd**2*s**2 + 6534*D1**2*f**2*fd**2*s - 990*D1**2*f**2*fd**2 - 102*D1**2*f**2*fd*r*s + 34*D1**2*f**2*fd*r - 204*D1**2*f**2*fd*s**2 + 170*D1**2*f**2*fd*s - 68*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r*s - 50*D1**2*f**2*fdd*r + 300*D1**2*f**2*fdd*s**2 - 250*D1**2*f**2*fdd*s + 100*D1**2*f**2*fdd - 66*D1**2*f**2*gd2*s**2 + 66*D1**2*f**2*gdd2*s**2 + 300*D1**2*f*fd**2*r*s - 100*D1**2*f*fd**2*r + 600*D1**2*f*fd**2*s**2 - 500*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 - 132*D1**2*f*fd*g2*s**2 + 132*D1**2*f*fd*g2*s - 66*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*s**2 - 132*D1**2*f*fd*gd2*s + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 1980*D1*Dd*f**4*r*s - 495*D1*Dd*f**4*r + 2376*D1*Dd*f**4*s**2 - 2178*D1*Dd*f**4*s + 594*D1*Dd*f**4 - 15840*D1*Dd*f**3*fd*r*s + 3960*D1*Dd*f**3*fd*r - 19008*D1*Dd*f**3*fd*s**2 + 17424*D1*Dd*f**3*fd*s - 3168*D1*Dd*f**3*fd - 136*D1*Dd*f**3*r*s + 34*D1*Dd*f**3*r - 272*D1*Dd*f**3*s**2 + 204*D1*Dd*f**3*s - 68*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r*s - 350*D1*Dd*f**2*fd*r + 2400*D1*Dd*f**2*fd*s**2 - 1900*D1*Dd*f**2*fd*s + 350*D1*Dd*f**2*fd - 264*D1*Dd*f**2*g2*s**2 + 132*D1*Dd*f**2*g2*s - 66*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*s**2 - 132*D1*Dd*f**2*gd2*s + 1056*D1*Dd*f*fd*g2*s**2 - 792*D1*Dd*f*fd*g2*s + 132*D1*Dd*f*fd*g2 - 1980*D1*Ddd*f**4*r*s + 495*D1*Ddd*f**4*r - 2376*D1*Ddd*f**4*s**2 + 2178*D1*Ddd*f**4*s - 594*D1*Ddd*f**4 + 200*D1*Ddd*f**3*r*s - 50*D1*Ddd*f**3*r + 400*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 100*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*s**2 - 132*D1*Ddd*f**2*g2*s + 66*D1*Ddd*f**2*g2 - 33*D1*bd1*f*(D1*(f**2*(2*r*(11*s - 5) + 26*s**2 - 48*s + 21) - f*(2*fd*(3*r*(22*s - 7) + 66*s**2 - 80*s + 13) + s*(-2*r + s*(K - 3) + 2)) + 2*fd*(-4*r*s + r + (2*s - 1)*(s*(K - 3) + 1))) - 2*Dd*f*(-4*K*s**2 + K*s + f*(88*r*s - 31*r + 88*s**2 - 116*s + 28) + r*(8*s - 1) + 12*s**2 - 9*s + 1)) - 5940*Dd**2*f**4*r*s + 1485*Dd**2*f**4*r - 7128*Dd**2*f**4*s**2 + 6534*Dd**2*f**4*s - 990*Dd**2*f**4 + 600*Dd**2*f**3*r*s - 150*Dd**2*f**3*r + 1200*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 100*Dd**2*f**3 + 792*Dd**2*f**2*g2*s**2 - 396*Dd**2*f**2*g2*s + 132*b1**2*(D1**2*s*(4*r + 4*s - 3)*(2*f*fd - f*fdd - fd**2) + D1*f*(4*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - Dd*fd*(8*s - 1)*(4*r + 4*s - 3) + 2*Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 33*b1*(2*D1**2*K*f*fd*s**2 - 2*D1**2*K*f*fd*s + D1**2*K*f*fd - 2*D1**2*K*f*fdd*s**2 + 2*D1**2*K*f*fdd*s - D1**2*K*f*fdd - 2*D1**2*K*fd**2*s**2 + 2*D1**2*K*fd**2*s - 4*D1**2*bdd1*f**2*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 66*D1**2*f**2*fd*r*s + 12*D1**2*f**2*fd*r - 78*D1**2*f**2*fd*s**2 + 48*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 66*D1**2*f**2*fdd*r*s - 12*D1**2*f**2*fdd*r + 66*D1**2*f**2*fdd*s**2 - 52*D1**2*f**2*fdd*s + 7*D1**2*f**2*fdd + 132*D1**2*f*fd**2*r*s - 24*D1**2*f*fd**2*r + 132*D1**2*f*fd**2*s**2 - 104*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 6*D1**2*f*fdd*s + 3*D1**2*f*fdd + 4*D1**2*fd**2*r*s - 2*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 6*D1**2*fd**2*s + 4*D1*Dd*K*f**2*s**2 - 2*D1*Dd*K*f**2*s + D1*Dd*K*f**2 - 16*D1*Dd*K*f*fd*s**2 + 12*D1*Dd*K*f*fd*s - 2*D1*Dd*K*f*fd - 88*D1*Dd*f**3*r*s + 22*D1*Dd*f**3*r - 104*D1*Dd*f**3*s**2 + 96*D1*Dd*f**3*s - 26*D1*Dd*f**3 + 528*D1*Dd*f**2*fd*r*s - 114*D1*Dd*f**2*fd*r + 528*D1*Dd*f**2*fd*s**2 - 472*D1*Dd*f**2*fd*s + 76*D1*Dd*f**2*fd - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 10*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 44*D1*Dd*f*fd*s + 10*D1*Dd*f*fd - 4*D1*Ddd*K*f**2*s**2 + 2*D1*Ddd*K*f**2*s - D1*Ddd*K*f**2 + 88*D1*Ddd*f**3*r*s - 22*D1*Ddd*f**3*r + 88*D1*Ddd*f**3*s**2 - 88*D1*Ddd*f**3*s + 22*D1*Ddd*f**3 + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 10*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 4*D1*bd1*f*(2*D1*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - D1*fd*(4*s - 1)*(4*r + 4*s - 3) - Dd*f*(8*s - 3)*(4*r + 4*s - 3)) - 12*Dd**2*K*f**2*s**2 + 6*Dd**2*K*f**2*s + 264*Dd**2*f**3*r*s - 66*Dd**2*f**3*r + 264*Dd**2*f**3*s**2 - 264*Dd**2*f**3*s + 44*Dd**2*f**3 + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 30*Dd**2*f**2*s + 4*Dd**2*f**2))/(693*d**2*k2**2*k3**4) + 2*D1**2*Pk2*Pk3*k1**4*(-2*D1*(6*D1*bd1**2*f*(f*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + r*(2*s - 1) - (s - 1)*(s*(K - 3) + 1)) + D1*bdd1*f*(-3*f**2*(5*r*(s - 1) + 2*s**2 - 6*s + 3) + 5*f*(s - 1)*(-C*s + C + r + 2*s - 2) + 6*g2*(s - 1)**2) + bd1*(D1*(3*f**3*(5*r*(s - 1) + 2*s**2 - 6*s + 3) + f**2*(4*C*(s - 1)**2 - 3*fd*(2*s - 1)*(15*r + 6*s - 10) - (4*s - 4)*(r + 2*s - 2)) + f*(5*fd*(r*(4*s - 2) - (s - 1)*(s*(4*C - 8) + 1)) - (s - 1)*(5*g2*(s - 1) - 12*gd2*s)) + 12*fd*g2*s*(s - 1)) + Dd*f*(-3*f**2*(5*r*(8*s - 5) + 16*s**2 - 38*s + 16) + 5*f*(-2*C*(4*s**2 - 5*s + 1) + 8*r*s - 5*r + 16*s**2 - 22*s + 6) + 12*g2*(4*s**2 - 5*s + 1)))) + b1**2*(D1**2*s*(12*f*(fd - fdd)*(4*r + 4*s - 3) - 12*fd**2*(4*r + 4*s - 3) + 10*fd*r - 5*fd*s*(K - 3) - 12*fdd*r + 6*fdd*s*(K - 3)) + D1*(Dd*(24*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-20*K*s**2 + 10*K*s - 5*K - 12*fd*(8*s - 1)*(4*r + 4*s - 3) + 40*r*s - 10*r + 60*s**2 - 50*s + 15) + 12*fd*(-8*r*s + r + s*(4*K*s - K - 12*s + 5))) - 6*Ddd*f*(K*(-4*s**2 + 2*s - 1) + 4*f*(r*(4*s - 1) + (1 - 2*s)**2) + 8*r*s - 2*r + 12*s**2 - 10*s + 3)) - 12*Dd**2*f*(-6*K*s**2 + 3*K*s + f*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + 3*r*(4*s - 1) + 18*s**2 - 15*s + 2)) + b1*(-6*D1**2*bdd1*f*(K*(-2*s**2 + 2*s - 1) + 2*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + 4*r*s - 2*r + 6*s**2 - 8*s + 3) - 2*D1**2*(3*f**2*(fd - fdd)*(6*s**2 + s*(15*r - 8) - 1) + f*s*(-6*fd**2*(15*r + 6*s - 8) + fd*(-8*r + s*(8*C - 16) + 4) + 5*fdd*(2*r - s*(2*C - 4) - 1) - 5*gd2*s + 6*gdd2*s) + s*(5*fd**2*(-2*C*s + 2*r + 4*s - 1) + fd*(-5*g2*s + 12*gd2*s) + 6*fdd*g2*s)) + D1*bd1*(D1*(12*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(-10*K*s**2 + 10*K*s - 5*K - 12*fd*(4*s - 1)*(4*r + 4*s - 3) + 20*r*s - 10*r + 30*s**2 - 40*s + 15) + 12*fd*(-4*r*s + r + s*(2*K*s - K - 6*s + 4))) - 12*Dd*f*(K*(-8*s**2 + 6*s - 1) + f*(8*s - 3)*(4*r + 4*s - 3) + 16*r*s - 6*r + 24*s**2 - 26*s + 6)) - 2*D1*(Dd*(3*f**3*(5*r*(4*s - 1) + 8*s**2 - 14*s + 2) + f**2*(4*C*(4*s**2 - 2*s + 1) - 3*fd*(15*r*(8*s - 1) + 48*s**2 - 74*s + 8) - 4*r*(4*s - 1) - 32*s**2 + 24*s - 8) + f*(5*fd*(2*r*(8*s - 1) - s**2*(16*C - 32) + s*(4*C - 16) + 1) - 20*g2*s**2 + 10*g2*s - 5*g2 + 48*gd2*s**2 - 12*gd2*s) + 12*fd*g2*s*(4*s - 1)) + Ddd*f*(-3*f**2*(5*r*(4*s - 1) + 8*s**2 - 14*s + 2) - 5*f*(4*C*s**2 - 2*C*s + C - 4*r*s + r - 8*s**2 + 6*s - 2) + 6*g2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(-3*f**2*(15*r*(4*s - 1) + 24*s**2 - 42*s + 10) + 5*f*(3*r*(4*s - 1) - s**2*(12*C - 24) + s*(6*C - 18) + 2) + 36*g2*s*(2*s - 1))))/(21*d**2*k2**2*k3**4) - 4*D1**2*Pk2*Pk3*k1**2*k2**4*st**2*(44*C*D1**2*b1*f*fd*r**2 + 88*C*D1**2*b1*f*fd*r*s - 44*C*D1**2*b1*f*fd*r + 44*C*D1**2*b1*f*fd*s**2 - 44*C*D1**2*b1*f*fd*s + 22*C*D1**2*b1*f*fd - 24*C*D1**2*b1*f*fdd*r**2 - 48*C*D1**2*b1*f*fdd*r*s + 24*C*D1**2*b1*f*fdd*r - 24*C*D1**2*b1*f*fdd*s**2 + 24*C*D1**2*b1*f*fdd*s - 12*C*D1**2*b1*f*fdd - 24*C*D1**2*b1*fd**2*r**2 - 48*C*D1**2*b1*fd**2*r*s + 24*C*D1**2*b1*fd**2*r - 24*C*D1**2*b1*fd**2*s**2 + 24*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 88*C*D1*Dd*b1*f**2*r**2 + 176*C*D1*Dd*b1*f**2*r*s - 132*C*D1*Dd*b1*f**2*r + 88*C*D1*Dd*b1*f**2*s**2 - 132*C*D1*Dd*b1*f**2*s + 66*C*D1*Dd*b1*f**2 - 192*C*D1*Dd*b1*f*fd*r**2 - 384*C*D1*Dd*b1*f*fd*r*s + 240*C*D1*Dd*b1*f*fd*r - 192*C*D1*Dd*b1*f*fd*s**2 + 240*C*D1*Dd*b1*f*fd*s - 72*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 48*C*D1*Ddd*b1*f**2*r**2 - 96*C*D1*Ddd*b1*f**2*r*s + 72*C*D1*Ddd*b1*f**2*r - 48*C*D1*Ddd*b1*f**2*s**2 + 72*C*D1*Ddd*b1*f**2*s - 36*C*D1*Ddd*b1*f**2 - 144*C*Dd**2*b1*f**2*r**2 - 288*C*Dd**2*b1*f**2*r*s + 216*C*Dd**2*b1*f**2*r - 144*C*Dd**2*b1*f**2*s**2 + 216*C*Dd**2*b1*f**2*s - 72*C*Dd**2*b1*f**2 + 19*D1**2*K*b1**2*fd*r**2 + 38*D1**2*K*b1**2*fd*r*s + 19*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r**2 - 12*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 - 2*D1**2*K*b1*f*fd*r**2 - 4*D1**2*K*b1*f*fd*r*s + 2*D1**2*K*b1*f*fd*r - 2*D1**2*K*b1*f*fd*s**2 + 2*D1**2*K*b1*f*fd*s - D1**2*K*b1*f*fd - 12*D1**2*K*bd1**2*f*(r + s - 1)**2 + 6*D1**2*b1**2*f*fd*r**2 + 12*D1**2*b1**2*f*fd*r*s - 6*D1**2*b1**2*f*fd*r + 6*D1**2*b1**2*f*fd*s**2 - 6*D1**2*b1**2*f*fd*s + 3*D1**2*b1**2*f*fd - 22*D1**2*b1*f*fd*r**2 - 44*D1**2*b1*f*fd*r*s + 22*D1**2*b1*f*fd*r - 22*D1**2*b1*f*fd*s**2 + 22*D1**2*b1*f*fd*s - 11*D1**2*b1*f*fd + 12*D1**2*b1*f*fdd*r**2 + 24*D1**2*b1*f*fdd*r*s - 12*D1**2*b1*f*fdd*r + 12*D1**2*b1*f*fdd*s**2 - 12*D1**2*b1*f*fdd*s + 6*D1**2*b1*f*fdd - 38*D1**2*b1*f*gd2*r**2 - 76*D1**2*b1*f*gd2*r*s + 76*D1**2*b1*f*gd2*r - 38*D1**2*b1*f*gd2*s**2 + 76*D1**2*b1*f*gd2*s - 38*D1**2*b1*f*gd2 + 12*D1**2*b1*f*gdd2*r**2 + 24*D1**2*b1*f*gdd2*r*s - 24*D1**2*b1*f*gdd2*r + 12*D1**2*b1*f*gdd2*s**2 - 24*D1**2*b1*f*gdd2*s + 12*D1**2*b1*f*gdd2 + 12*D1**2*b1*fd**2*r**2 + 24*D1**2*b1*fd**2*r*s - 12*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 - 12*D1**2*b1*fd**2*s - 38*D1**2*b1*fd*g2*r**2 - 76*D1**2*b1*fd*g2*r*s - 38*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r**2 + 48*D1**2*b1*fd*gd2*r*s - 24*D1**2*b1*fd*gd2*r + 24*D1**2*b1*fd*gd2*s**2 - 24*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r**2 + 24*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - 6*D1**2*bdd1*f*(r + s - 1)**2*(2*C*f + 2*K*b1 - f - 2*g2) + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd + 2*D1**2*f**2*gd2*r**2 + 4*D1**2*f**2*gd2*r*s - 4*D1**2*f**2*gd2*r + 2*D1**2*f**2*gd2*s**2 - 4*D1**2*f**2*gd2*s + 2*D1**2*f**2*gd2 + 4*D1**2*f*fd*g2*r**2 + 8*D1**2*f*fd*g2*r*s - 4*D1**2*f*fd*g2*r + 4*D1**2*f*fd*g2*s**2 - 4*D1**2*f*fd*g2*s + 2*D1**2*f*fd*g2 + 76*D1*Dd*K*b1**2*f*r**2 + 152*D1*Dd*K*b1**2*f*r*s - 114*D1*Dd*K*b1**2*f*r + 76*D1*Dd*K*b1**2*f*s**2 - 114*D1*Dd*K*b1**2*f*s + 57*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 96*D1*Dd*K*b1**2*fd*r*s + 36*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 36*D1*Dd*K*b1**2*fd*s - 4*D1*Dd*K*b1*f**2*r**2 - 8*D1*Dd*K*b1*f**2*r*s + 6*D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s**2 + 6*D1*Dd*K*b1*f**2*s - 3*D1*Dd*K*b1*f**2 + 12*D1*Dd*b1**2*f**2*r**2 + 24*D1*Dd*b1**2*f**2*r*s - 18*D1*Dd*b1**2*f**2*r + 12*D1*Dd*b1**2*f**2*s**2 - 18*D1*Dd*b1**2*f**2*s + 9*D1*Dd*b1**2*f**2 - 44*D1*Dd*b1*f**2*r**2 - 88*D1*Dd*b1*f**2*r*s + 66*D1*Dd*b1*f**2*r - 44*D1*Dd*b1*f**2*s**2 + 66*D1*Dd*b1*f**2*s - 33*D1*Dd*b1*f**2 + 96*D1*Dd*b1*f*fd*r**2 + 192*D1*Dd*b1*f*fd*r*s - 120*D1*Dd*b1*f*fd*r + 96*D1*Dd*b1*f*fd*s**2 - 120*D1*Dd*b1*f*fd*s + 36*D1*Dd*b1*f*fd - 152*D1*Dd*b1*f*g2*r**2 - 304*D1*Dd*b1*f*g2*r*s + 228*D1*Dd*b1*f*g2*r - 152*D1*Dd*b1*f*g2*s**2 + 228*D1*Dd*b1*f*g2*s - 114*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 192*D1*Dd*b1*f*gd2*r*s - 168*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 168*D1*Dd*b1*f*gd2*s + 72*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 192*D1*Dd*b1*fd*g2*r*s - 72*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 72*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 8*D1*Dd*f**2*g2*r**2 + 16*D1*Dd*f**2*g2*r*s - 12*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s**2 - 12*D1*Dd*f**2*g2*s + 6*D1*Dd*f**2*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 48*D1*Ddd*K*b1**2*f*r*s + 36*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 36*D1*Ddd*K*b1**2*f*s - 18*D1*Ddd*K*b1**2*f + 24*D1*Ddd*b1*f**2*r**2 + 48*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r + 24*D1*Ddd*b1*f**2*s**2 - 36*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 96*D1*Ddd*b1*f*g2*r*s - 72*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 72*D1*Ddd*b1*f*g2*s + 36*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(22*C - K + 6*b1 - 11) - f*fd*(24*C - 12)*(2*r + 2*s - 1) - 2*f*(r + s - 1)*(-19*K*b1 + 19*g2 - 12*gd2) + 24*fd*(r + s)*(-K*b1 + g2)) - 12*Dd*f*(4*r + 4*s - 3)*(2*K*b1 + f*(2*C - 1) - 2*g2))*(r + s - 1) - 72*Dd**2*K*b1**2*f*r**2 - 144*Dd**2*K*b1**2*f*r*s + 108*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 108*Dd**2*K*b1**2*f*s - 36*Dd**2*K*b1**2*f + 72*Dd**2*b1*f**2*r**2 + 144*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r + 72*Dd**2*b1*f**2*s**2 - 108*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 288*Dd**2*b1*f*g2*r*s - 216*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 216*Dd**2*b1*f*g2*s + 72*Dd**2*b1*f*g2)/(7*d**2*k3**8) + 2*D1**2*Pk2*Pk3*k1**2*k2**2*st**2*(2904*C*D1**2*bd1*f**2*r**2 + 7128*C*D1**2*bd1*f**2*r*s - 7392*C*D1**2*bd1*f**2*r + 4224*C*D1**2*bd1*f**2*s**2 - 8712*C*D1**2*bd1*f**2*s + 4356*C*D1**2*bd1*f**2 - 5808*C*D1**2*bd1*f*fd*r**2 - 14784*C*D1**2*bd1*f*fd*r*s + 10560*C*D1**2*bd1*f*fd*r - 8976*C*D1**2*bd1*f*fd*s**2 + 12936*C*D1**2*bd1*f*fd*s - 3960*C*D1**2*bd1*f*fd - 1452*C*D1**2*bdd1*f**2*r**2 - 3696*C*D1**2*bdd1*f**2*r*s + 3960*C*D1**2*bdd1*f**2*r - 2244*C*D1**2*bdd1*f**2*s**2 + 4752*C*D1**2*bdd1*f**2*s - 2376*C*D1**2*bdd1*f**2 - 210*C*D1**2*f**2*fd*r**2 + 2364*C*D1**2*f**2*fd*r*s - 648*C*D1**2*f**2*fd*r + 2574*C*D1**2*f**2*fd*s**2 - 2504*C*D1**2*f**2*fd*s + 788*C*D1**2*f**2*fd - 1182*C*D1**2*f**2*fdd*r**2 - 4548*C*D1**2*f**2*fdd*r*s + 2304*C*D1**2*f**2*fdd*r - 3366*C*D1**2*f**2*fdd*s**2 + 3760*C*D1**2*f**2*fdd*s - 1516*C*D1**2*f**2*fdd - 2364*C*D1**2*f*fd**2*r**2 - 9096*C*D1**2*f*fd**2*r*s + 4608*C*D1**2*f*fd**2*r - 6732*C*D1**2*f*fd**2*s**2 + 7520*C*D1**2*f*fd**2*s - 1516*C*D1**2*f*fd**2 - 11616*C*D1*Dd*bd1*f**2*r**2 - 29568*C*D1*Dd*bd1*f**2*r*s + 25344*C*D1*Dd*bd1*f**2*r - 17952*C*D1*Dd*bd1*f**2*s**2 + 30888*C*D1*Dd*bd1*f**2*s - 12672*C*D1*Dd*bd1*f**2 - 280*C*D1*Dd*f**3*r**2 + 3152*C*D1*Dd*f**3*r*s - 508*C*D1*Dd*f**3*r + 3432*C*D1*Dd*f**3*s**2 - 3292*C*D1*Dd*f**3*s + 718*C*D1*Dd*f**3 - 9456*C*D1*Dd*f**2*fd*r**2 - 36384*C*D1*Dd*f**2*fd*r*s + 18492*C*D1*Dd*f**2*fd*r - 26928*C*D1*Dd*f**2*fd*s**2 + 30868*C*D1*Dd*f**2*fd*s - 8368*C*D1*Dd*f**2*fd - 1576*C*D1*Ddd*f**3*r**2 - 6064*C*D1*Ddd*f**3*r*s + 3092*C*D1*Ddd*f**3*r - 4488*C*D1*Ddd*f**3*s**2 + 5276*C*D1*Ddd*f**3*s - 1910*C*D1*Ddd*f**3 - 4728*C*Dd**2*f**3*r**2 - 18192*C*Dd**2*f**3*r*s + 9276*C*Dd**2*f**3*r - 13464*C*Dd**2*f**3*s**2 + 15828*C*Dd**2*f**3*s - 3820*C*Dd**2*f**3 - 1452*D1**2*K*bd1**2*f*r**2 - 3696*D1**2*K*bd1**2*f*r*s + 3432*D1**2*K*bd1**2*f*r - 2244*D1**2*K*bd1**2*f*s**2 + 4224*D1**2*K*bd1**2*f*s - 1980*D1**2*K*bd1**2*f - 99*D1**2*K*bd1*f**2*r**2 + 330*D1**2*K*bd1*f**2*r*s + 198*D1**2*K*bd1*f**2*r + 429*D1**2*K*bd1*f**2*s**2 - 330*D1**2*K*bd1*f**2*s - 99*D1**2*K*bd1*f**2 - 660*D1**2*K*bd1*f*fd*r**2 - 2904*D1**2*K*bd1*f*fd*r*s + 1386*D1**2*K*bd1*f*fd*r - 2244*D1**2*K*bd1*f*fd*s**2 + 2574*D1**2*K*bd1*f*fd*s - 726*D1**2*K*bd1*f*fd - 165*D1**2*K*bdd1*f**2*r**2 - 726*D1**2*K*bdd1*f**2*r*s + 330*D1**2*K*bdd1*f**2*r - 561*D1**2*K*bdd1*f**2*s**2 + 726*D1**2*K*bdd1*f**2*s - 165*D1**2*K*bdd1*f**2 + 2178*D1**2*bd1**2*f**2*r**2 + 3564*D1**2*bd1**2*f**2*r*s - 3960*D1**2*bd1**2*f**2*r + 1386*D1**2*bd1**2*f**2*s**2 - 3168*D1**2*bd1**2*f**2*s + 1782*D1**2*bd1**2*f**2 + 396*D1**2*bd1**2*f*r**2 + 792*D1**2*bd1**2*f*r*s - 792*D1**2*bd1**2*f*r + 396*D1**2*bd1**2*f*s**2 - 792*D1**2*bd1**2*f*s + 396*D1**2*bd1**2*f - 792*D1**2*bd1*bd2*f*r**2 - 1584*D1**2*bd1*bd2*f*r*s + 1584*D1**2*bd1*bd2*f*r - 792*D1**2*bd1*bd2*f*s**2 + 1584*D1**2*bd1*bd2*f*s - 792*D1**2*bd1*bd2*f - 1782*D1**2*bd1*f**2*r**2 - 4224*D1**2*bd1*f**2*r*s + 4290*D1**2*bd1*f**2*r - 2442*D1**2*bd1*f**2*s**2 + 4950*D1**2*bd1*f**2*s - 2442*D1**2*bd1*f**2 + 3696*D1**2*bd1*f*fd*r**2 + 8976*D1**2*bd1*f*fd*r*s - 6468*D1**2*bd1*f*fd*r + 5280*D1**2*bd1*f*fd*s**2 - 7656*D1**2*bd1*f*fd*s + 2376*D1**2*bd1*f*fd - 2904*D1**2*bd1*f*g2*r**2 - 9240*D1**2*bd1*f*g2*r*s + 11616*D1**2*bd1*f*g2*r - 6336*D1**2*bd1*f*g2*s**2 + 15048*D1**2*bd1*f*g2*s - 7524*D1**2*bd1*f*g2 + 2904*D1**2*bd1*f*gd2*r**2 + 7392*D1**2*bd1*f*gd2*r*s - 6864*D1**2*bd1*f*gd2*r + 4488*D1**2*bd1*f*gd2*s**2 - 8448*D1**2*bd1*f*gd2*s + 3960*D1**2*bd1*f*gd2 + 2904*D1**2*bd1*fd*g2*r**2 + 7392*D1**2*bd1*fd*g2*r*s - 3696*D1**2*bd1*fd*g2*r + 4488*D1**2*bd1*fd*g2*s**2 - 4488*D1**2*bd1*fd*g2*s - 66*D1**2*bd2*f**2*r**2 - 132*D1**2*bd2*f**2*r*s + 132*D1**2*bd2*f**2*r - 66*D1**2*bd2*f**2*s**2 + 132*D1**2*bd2*f**2*s - 66*D1**2*bd2*f**2 + 924*D1**2*bdd1*f**2*r**2 + 2244*D1**2*bdd1*f**2*r*s - 2376*D1**2*bdd1*f**2*r + 1320*D1**2*bdd1*f**2*s**2 - 2772*D1**2*bdd1*f**2*s + 1386*D1**2*bdd1*f**2 + 1452*D1**2*bdd1*f*g2*r**2 + 3696*D1**2*bdd1*f*g2*r*s - 3960*D1**2*bdd1*f*g2*r + 2244*D1**2*bdd1*f*g2*s**2 - 4752*D1**2*bdd1*f*g2*s + 2376*D1**2*bdd1*f*g2 + 303*D1**2*f**2*fd*r**2 - 984*D1**2*f**2*fd*r*s + 126*D1**2*f**2*fd*r - 1287*D1**2*f**2*fd*s**2 + 1186*D1**2*f**2*fd*s - 328*D1**2*f**2*fd + 591*D1**2*f**2*fdd*r**2 + 2274*D1**2*f**2*fdd*r*s - 1152*D1**2*f**2*fdd*r + 1683*D1**2*f**2*fdd*s**2 - 1880*D1**2*f**2*fdd*s + 758*D1**2*f**2*fdd + 198*D1**2*f**2*gd2*r**2 - 660*D1**2*f**2*gd2*r*s - 396*D1**2*f**2*gd2*r - 858*D1**2*f**2*gd2*s**2 + 660*D1**2*f**2*gd2*s + 198*D1**2*f**2*gd2 + 330*D1**2*f**2*gdd2*r**2 + 1452*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*r + 1122*D1**2*f**2*gdd2*s**2 - 1452*D1**2*f**2*gdd2*s + 330*D1**2*f**2*gdd2 + 1182*D1**2*f*fd**2*r**2 + 4548*D1**2*f*fd**2*r*s - 2304*D1**2*f*fd**2*r + 3366*D1**2*f*fd**2*s**2 - 3760*D1**2*f*fd**2*s + 758*D1**2*f*fd**2 + 396*D1**2*f*fd*g2*r**2 - 1320*D1**2*f*fd*g2*r*s + 660*D1**2*f*fd*g2*r - 1716*D1**2*f*fd*g2*s**2 + 1716*D1**2*f*fd*g2*s - 858*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*r**2 + 5808*D1**2*f*fd*gd2*r*s - 2772*D1**2*f*fd*gd2*r + 4488*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1452*D1**2*f*fd*gd2 + 660*D1**2*f*fdd*g2*r**2 + 2904*D1**2*f*fdd*g2*r*s - 1452*D1**2*f*fdd*g2*r + 2244*D1**2*f*fdd*g2*s**2 - 2244*D1**2*f*fdd*g2*s + 1122*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*r**2 + 2904*D1**2*fd**2*g2*r*s - 1452*D1**2*fd**2*g2*r + 2244*D1**2*fd**2*g2*s**2 - 2244*D1**2*fd**2*g2*s - 1320*D1*Dd*K*bd1*f**2*r**2 - 5808*D1*Dd*K*bd1*f**2*r*s + 2706*D1*Dd*K*bd1*f**2*r - 4488*D1*Dd*K*bd1*f**2*s**2 + 5478*D1*Dd*K*bd1*f**2*s - 1386*D1*Dd*K*bd1*f**2 + 7392*D1*Dd*bd1*f**2*r**2 + 17952*D1*Dd*bd1*f**2*r*s - 15444*D1*Dd*bd1*f**2*r + 10560*D1*Dd*bd1*f**2*s**2 - 18216*D1*Dd*bd1*f**2*s + 7524*D1*Dd*bd1*f**2 + 11616*D1*Dd*bd1*f*g2*r**2 + 29568*D1*Dd*bd1*f*g2*r*s - 25344*D1*Dd*bd1*f*g2*r + 17952*D1*Dd*bd1*f*g2*s**2 - 30888*D1*Dd*bd1*f*g2*s + 12672*D1*Dd*bd1*f*g2 + 404*D1*Dd*f**3*r**2 - 1312*D1*Dd*f**3*r*s - 76*D1*Dd*f**3*r - 1716*D1*Dd*f**3*s**2 + 1514*D1*Dd*f**3*s - 227*D1*Dd*f**3 + 4728*D1*Dd*f**2*fd*r**2 + 18192*D1*Dd*f**2*fd*r*s - 9246*D1*Dd*f**2*fd*r + 13464*D1*Dd*f**2*fd*s**2 - 15434*D1*Dd*f**2*fd*s + 4184*D1*Dd*f**2*fd + 792*D1*Dd*f**2*g2*r**2 - 2640*D1*Dd*f**2*g2*r*s - 132*D1*Dd*f**2*g2*r - 3432*D1*Dd*f**2*g2*s**2 + 3036*D1*Dd*f**2*g2*s - 462*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*r**2 + 11616*D1*Dd*f**2*gd2*r*s - 5412*D1*Dd*f**2*gd2*r + 8976*D1*Dd*f**2*gd2*s**2 - 10956*D1*Dd*f**2*gd2*s + 2772*D1*Dd*f**2*gd2 + 5280*D1*Dd*f*fd*g2*r**2 + 23232*D1*Dd*f*fd*g2*r*s - 11352*D1*Dd*f*fd*g2*r + 17952*D1*Dd*f*fd*g2*s**2 - 19272*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 + 788*D1*Ddd*f**3*r**2 + 3032*D1*Ddd*f**3*r*s - 1546*D1*Ddd*f**3*r + 2244*D1*Ddd*f**3*s**2 - 2638*D1*Ddd*f**3*s + 955*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*g2*r**2 + 5808*D1*Ddd*f**2*g2*r*s - 2772*D1*Ddd*f**2*g2*r + 4488*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 1782*D1*Ddd*f**2*g2 + 66*D1*b2*(bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 2364*Dd**2*f**3*r**2 + 9096*Dd**2*f**3*r*s - 4638*Dd**2*f**3*r + 6732*Dd**2*f**3*s**2 - 7914*Dd**2*f**3*s + 1910*Dd**2*f**3 + 3960*Dd**2*f**2*g2*r**2 + 17424*Dd**2*f**2*g2*r*s - 8316*Dd**2*f**2*g2*r + 13464*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 3564*Dd**2*f**2*g2 + 198*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(44*D1**2*K*fd*r**2 + 140*D1**2*K*fd*r*s + 36*D1**2*K*fd*r + 96*D1**2*K*fd*s**2 + 36*D1**2*K*fd*s - 18*D1**2*K*fd - 22*D1**2*K*fdd*r**2 - 56*D1**2*K*fdd*r*s - 4*D1**2*K*fdd*r - 34*D1**2*K*fdd*s**2 - 4*D1**2*K*fdd*s + 2*D1**2*K*fdd - 6*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 46*D1**2*f*fd*r**2 - 68*D1**2*f*fd*r*s + 46*D1**2*f*fd*r - 22*D1**2*f*fd*s**2 + 34*D1**2*f*fd*s - 23*D1**2*f*fd + 66*D1**2*f*fdd*r**2 + 108*D1**2*f*fdd*r*s - 66*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 33*D1**2*f*fdd + 66*D1**2*fd**2*r**2 + 108*D1**2*fd**2*r*s - 66*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s - 12*D1**2*fd*r**2 - 38*D1**2*fd*r*s - 26*D1**2*fd*s**2 + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 + 176*D1*Dd*K*f*r**2 + 560*D1*Dd*K*f*r*s - 316*D1*Dd*K*f*r + 384*D1*Dd*K*f*s**2 - 472*D1*Dd*K*f*s + 184*D1*Dd*K*f - 176*D1*Dd*K*fd*r**2 - 448*D1*Dd*K*fd*r*s + 128*D1*Dd*K*fd*r - 272*D1*Dd*K*fd*s**2 + 164*D1*Dd*K*fd*s + 12*D1*Dd*K*fd - 92*D1*Dd*f**2*r**2 - 136*D1*Dd*f**2*r*s + 126*D1*Dd*f**2*r - 44*D1*Dd*f**2*s**2 + 90*D1*Dd*f**2*s - 57*D1*Dd*f**2 + 528*D1*Dd*f*fd*r**2 + 864*D1*Dd*f*fd*r*s - 636*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 516*D1*Dd*f*fd*s + 186*D1*Dd*f*fd - 48*D1*Dd*f*r**2 - 152*D1*Dd*f*r*s + 86*D1*Dd*f*r - 104*D1*Dd*f*s**2 + 128*D1*Dd*f*s - 50*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 36*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 36*D1*Dd*fd*s - 88*D1*Ddd*K*f*r**2 - 224*D1*Ddd*K*f*r*s + 144*D1*Ddd*K*f*r - 136*D1*Ddd*K*f*s**2 + 180*D1*Ddd*K*f*s - 78*D1*Ddd*K*f + 132*D1*Ddd*f**2*r**2 + 216*D1*Ddd*f**2*r*s - 186*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 87*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f + 12*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 264*Dd**2*K*f*r**2 - 672*Dd**2*K*f*r*s + 432*Dd**2*K*f*r - 408*Dd**2*K*f*s**2 + 540*Dd**2*K*f*s - 156*Dd**2*K*f + 396*Dd**2*f**2*r**2 + 648*Dd**2*f**2*r*s - 558*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 174*Dd**2*f**2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f) - 33*b1*(-176*C*D1**2*f*fd*r**2 - 432*C*D1**2*f*fd*r*s + 168*C*D1**2*f*fd*r - 256*C*D1**2*f*fd*s**2 + 208*C*D1**2*f*fd*s - 84*C*D1**2*f*fd + 88*C*D1**2*f*fdd*r**2 + 224*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 136*C*D1**2*f*fdd*s**2 - 104*C*D1**2*f*fdd*s + 40*C*D1**2*f*fdd + 88*C*D1**2*fd**2*r**2 + 224*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 136*C*D1**2*fd**2*s**2 - 104*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 - 352*C*D1*Dd*f**2*r**2 - 864*C*D1*Dd*f**2*r*s + 568*C*D1*Dd*f**2*r - 512*C*D1*Dd*f**2*s**2 + 688*C*D1*Dd*f**2*s - 304*C*D1*Dd*f**2 + 704*C*D1*Dd*f*fd*r**2 + 1792*C*D1*Dd*f*fd*r*s - 896*C*D1*Dd*f*fd*r + 1088*C*D1*Dd*f*fd*s**2 - 1136*C*D1*Dd*f*fd*s + 264*C*D1*Dd*f*fd + 176*C*D1*Ddd*f**2*r**2 + 448*C*D1*Ddd*f**2*r*s - 288*C*D1*Ddd*f**2*r + 272*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 156*C*D1*Ddd*f**2 + 528*C*Dd**2*f**2*r**2 + 1344*C*Dd**2*f**2*r*s - 864*C*Dd**2*f**2*r + 816*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 312*C*Dd**2*f**2 + 44*D1**2*K*bdd1*f*r**2 + 112*D1**2*K*bdd1*f*r*s - 104*D1**2*K*bdd1*f*r + 68*D1**2*K*bdd1*f*s**2 - 128*D1**2*K*bdd1*f*s + 58*D1**2*K*bdd1*f + 6*D1**2*K*f*fd*r**2 - 20*D1**2*K*f*fd*r*s + 10*D1**2*K*f*fd*r - 26*D1**2*K*f*fd*s**2 + 26*D1**2*K*f*fd*s - 13*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r**2 + 44*D1**2*K*f*fdd*r*s - 22*D1**2*K*f*fdd*r + 34*D1**2*K*f*fdd*s**2 - 34*D1**2*K*f*fdd*s + 17*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r**2 + 44*D1**2*K*fd**2*r*s - 22*D1**2*K*fd**2*r + 34*D1**2*K*fd**2*s**2 - 34*D1**2*K*fd**2*s - 38*D1**2*b2*fd*r**2 - 76*D1**2*b2*fd*r*s - 38*D1**2*b2*fd*s**2 + 12*D1**2*b2*fdd*r**2 + 24*D1**2*b2*fdd*r*s + 12*D1**2*b2*fdd*s**2 + 12*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*D1**2*bdd1*f**2*r**2 - 108*D1**2*bdd1*f**2*r*s + 120*D1**2*bdd1*f**2*r - 42*D1**2*bdd1*f**2*s**2 + 96*D1**2*bdd1*f**2*s - 54*D1**2*bdd1*f**2 - 12*D1**2*bdd1*f*r**2 - 24*D1**2*bdd1*f*r*s + 24*D1**2*bdd1*f*r - 12*D1**2*bdd1*f*s**2 + 24*D1**2*bdd1*f*s - 12*D1**2*bdd1*f + 12*D1**2*bdd2*f*r**2 + 24*D1**2*bdd2*f*r*s - 24*D1**2*bdd2*f*r + 12*D1**2*bdd2*f*s**2 - 24*D1**2*bdd2*f*s + 12*D1**2*bdd2*f + 108*D1**2*f*fd*r**2 + 256*D1**2*f*fd*r*s - 106*D1**2*f*fd*r + 148*D1**2*f*fd*s**2 - 126*D1**2*f*fd*s + 54*D1**2*f*fd - 56*D1**2*f*fdd*r**2 - 136*D1**2*f*fdd*r*s + 52*D1**2*f*fdd*r - 80*D1**2*f*fdd*s**2 + 64*D1**2*f*fdd*s - 26*D1**2*f*fdd + 88*D1**2*f*gd2*r**2 + 280*D1**2*f*gd2*r*s - 176*D1**2*f*gd2*r + 192*D1**2*f*gd2*s**2 - 280*D1**2*f*gd2*s + 88*D1**2*f*gd2 - 44*D1**2*f*gdd2*r**2 - 112*D1**2*f*gdd2*r*s + 88*D1**2*f*gdd2*r - 68*D1**2*f*gdd2*s**2 + 112*D1**2*f*gdd2*s - 44*D1**2*f*gdd2 - 56*D1**2*fd**2*r**2 - 136*D1**2*fd**2*r*s + 52*D1**2*fd**2*r - 80*D1**2*fd**2*s**2 + 64*D1**2*fd**2*s + 4*D1**2*fd**2 + 88*D1**2*fd*g2*r**2 + 280*D1**2*fd*g2*r*s + 72*D1**2*fd*g2*r + 192*D1**2*fd*g2*s**2 + 72*D1**2*fd*g2*s - 36*D1**2*fd*g2 - 88*D1**2*fd*gd2*r**2 - 224*D1**2*fd*gd2*r*s + 80*D1**2*fd*gd2*r - 136*D1**2*fd*gd2*s**2 + 104*D1**2*fd*gd2*s + 8*D1**2*fd*gd2 - 44*D1**2*fdd*g2*r**2 - 112*D1**2*fdd*g2*r*s - 8*D1**2*fdd*g2*r - 68*D1**2*fdd*g2*s**2 - 8*D1**2*fdd*g2*s + 4*D1**2*fdd*g2 + 12*D1*Dd*K*f**2*r**2 - 40*D1*Dd*K*f**2*r*s - 2*D1*Dd*K*f**2*r - 52*D1*Dd*K*f**2*s**2 + 46*D1*Dd*K*f**2*s - 7*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r**2 + 352*D1*Dd*K*f*fd*r*s - 172*D1*Dd*K*f*fd*r + 272*D1*Dd*K*f*fd*s**2 - 292*D1*Dd*K*f*fd*s + 78*D1*Dd*K*f*fd - 152*D1*Dd*b2*f*r**2 - 304*D1*Dd*b2*f*r*s + 228*D1*Dd*b2*f*r - 152*D1*Dd*b2*f*s**2 + 228*D1*Dd*b2*f*s - 114*D1*Dd*b2*f + 96*D1*Dd*b2*fd*r**2 + 192*D1*Dd*b2*fd*r*s - 72*D1*Dd*b2*fd*r + 96*D1*Dd*b2*fd*s**2 - 72*D1*Dd*b2*fd*s + 216*D1*Dd*f**2*r**2 + 512*D1*Dd*f**2*r*s - 344*D1*Dd*f**2*r + 296*D1*Dd*f**2*s**2 - 404*D1*Dd*f**2*s + 182*D1*Dd*f**2 - 448*D1*Dd*f*fd*r**2 - 1088*D1*Dd*f*fd*r*s + 568*D1*Dd*f*fd*r - 640*D1*Dd*f*fd*s**2 + 688*D1*Dd*f*fd*s - 168*D1*Dd*f*fd + 352*D1*Dd*f*g2*r**2 + 1120*D1*Dd*f*g2*r*s - 632*D1*Dd*f*g2*r + 768*D1*Dd*f*g2*s**2 - 944*D1*Dd*f*g2*s + 368*D1*Dd*f*g2 - 352*D1*Dd*f*gd2*r**2 - 896*D1*Dd*f*gd2*r*s + 640*D1*Dd*f*gd2*r - 544*D1*Dd*f*gd2*s**2 + 808*D1*Dd*f*gd2*s - 288*D1*Dd*f*gd2 - 352*D1*Dd*fd*g2*r**2 - 896*D1*Dd*fd*g2*r*s + 256*D1*Dd*fd*g2*r - 544*D1*Dd*fd*g2*s**2 + 328*D1*Dd*fd*g2*s + 24*D1*Dd*fd*g2 + 20*D1*Ddd*K*f**2*r**2 + 88*D1*Ddd*K*f**2*r*s - 42*D1*Ddd*K*f**2*r + 68*D1*Ddd*K*f**2*s**2 - 78*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 + 48*D1*Ddd*b2*f*r**2 + 96*D1*Ddd*b2*f*r*s - 72*D1*Ddd*b2*f*r + 48*D1*Ddd*b2*f*s**2 - 72*D1*Ddd*b2*f*s + 36*D1*Ddd*b2*f - 112*D1*Ddd*f**2*r**2 - 272*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r - 160*D1*Ddd*f**2*s**2 + 216*D1*Ddd*f**2*s - 96*D1*Ddd*f**2 - 176*D1*Ddd*f*g2*r**2 - 448*D1*Ddd*f*g2*r*s + 288*D1*Ddd*f*g2*r - 272*D1*Ddd*f*g2*s**2 + 360*D1*Ddd*f*g2*s - 156*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*(23*r**2 + r*(34*s - 40) + 11*s**2 - 28*s + 17) - f*(K*(44*r**2 + 4*r*(35*s - 33) + 96*s**2 - 184*s + 79) + 6*fd*(22*r**2 + r*(36*s - 31) + 14*s**2 - 25*s + 10) - 12*r**2 - 38*r*s + 31*r - 26*s**2 + 45*s - 19) + 2*fd*(K*(22*r**2 + 8*r*(7*s - 3) + 34*s**2 - 30*s - 1) - 6*r**2 - 6*r*(2*s - 1) - 6*s*(s - 1))) - 2*Dd*f*(-2*K*(44*r**2 + 112*r*s - 88*r + 68*s**2 - 109*s + 42) + 3*f*(44*r**2 + r*(72*s - 71) + 28*s**2 - 57*s + 28) + 24*r**2 + 48*r*s - 42*r + 24*s**2 - 42*s + 18)) - 2*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 60*Dd**2*K*f**2*r**2 + 264*Dd**2*K*f**2*r*s - 126*Dd**2*K*f**2*r + 204*Dd**2*K*f**2*s**2 - 234*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 + 144*Dd**2*b2*f*r**2 + 288*Dd**2*b2*f*r*s - 216*Dd**2*b2*f*r + 144*Dd**2*b2*f*s**2 - 216*Dd**2*b2*f*s + 72*Dd**2*b2*f - 336*Dd**2*f**2*r**2 - 816*Dd**2*f**2*r*s + 540*Dd**2*f**2*r - 480*Dd**2*f**2*s**2 + 648*Dd**2*f**2*s - 192*Dd**2*f**2 - 528*Dd**2*f*g2*r**2 - 1344*Dd**2*f*g2*r*s + 864*Dd**2*f*g2*r - 816*Dd**2*f*g2*s**2 + 1080*Dd**2*f*g2*s - 312*Dd**2*f*g2))/(693*d**2*k3**6) - 4*D1**2*Pk2*Pk3*k1**2*k2**2*(2*D1*(7*D1*b2*bd1*f*(r + s - 1)**2 + D1*bd1**2*(r + s - 1)*(35*K*f*(r + s - 1) - f*(24*C - 12)*(r + s) + 28*g2*(r + s)) + D1*bdd1*f*(f*(2*C - 1)*(17*r + 15*s - 15) - 35*g2*(r + s - 1))*(r + s - 1) + bd1*(D1*(f**2*(r + s - 1)*(2*C*(5*r + 9*s - 9) - 11*r - 9*s + 9) + f*(fd*(4*C - 2)*(34*r**2 + r*(64*s - 49) + 30*s**2 - 46*s + 16) + (-21*g2 - 70*gd2)*(r + s - 1)**2) - 70*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(f*(2*C - 1)*(68*r**2 + 2*r*(64*s - 57) + 60*s**2 - 107*s + 47) - 35*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 14*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(2*K + f) - Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(-14*K*bdd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(20*C*(r + s - 1)**2 + 21*K*s**2 + r**2*(21*K - 24) + r*(42*K*s - 34*s + 20) - 10*s**2 + 20*s - 10) + fdd*(-24*C*(r + s - 1)**2 + 35*K*s**2 + r**2*(35*K + 12) + r*(70*K*s + 24*s - 24) + 12*s**2 - 24*s + 12) - 56*gd2*(r + s - 1)**2 + 28*gdd2*(r + s - 1)**2) + 14*D1*bd1*(D1*(2*K + f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(20*C*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 21*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(48*r**2 + r*(68*s - 65) + 20*s**2 - 44*s + 29) - 2*fd*(4*r + 4*s - 3)*(24*C*(r + s - 1) - 35*K*s - r*(35*K + 12) - 12*s + 12) - 56*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 56*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*(f*(-24*C + 35*K + 12) + 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(-24*C + 35*K + 12) + 28*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*b1*(24*C*D1**2*bdd1*f*r**2 + 48*C*D1**2*bdd1*f*r*s - 24*C*D1**2*bdd1*f*r + 24*C*D1**2*bdd1*f*s**2 - 24*C*D1**2*bdd1*f*s + 12*C*D1**2*bdd1*f - 20*C*D1**2*f*fd*r**2 - 56*C*D1**2*f*fd*r*s + 20*C*D1**2*f*fd*r - 36*C*D1**2*f*fd*s**2 + 28*C*D1**2*f*fd*s - 10*C*D1**2*f*fd - 68*C*D1**2*f*fdd*r**2 - 128*C*D1**2*f*fdd*r*s + 68*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 64*C*D1**2*f*fdd*s - 34*C*D1**2*f*fdd - 68*C*D1**2*fd**2*r**2 - 128*C*D1**2*fd**2*r*s + 68*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 64*C*D1**2*fd**2*s - 40*C*D1*Dd*f**2*r**2 - 112*C*D1*Dd*f**2*r*s + 68*C*D1*Dd*f**2*r - 72*C*D1*Dd*f**2*s**2 + 92*C*D1*Dd*f**2*s - 38*C*D1*Dd*f**2 - 544*C*D1*Dd*f*fd*r**2 - 1024*C*D1*Dd*f*fd*r*s + 672*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 632*C*D1*Dd*f*fd*s - 200*C*D1*Dd*f*fd - 136*C*D1*Ddd*f**2*r**2 - 256*C*D1*Ddd*f**2*r*s + 200*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 188*C*D1*Ddd*f**2*s - 98*C*D1*Ddd*f**2 - 408*C*Dd**2*f**2*r**2 - 768*C*Dd**2*f**2*r*s + 600*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 564*C*Dd**2*f**2*s - 196*C*Dd**2*f**2 + 14*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 35*D1**2*K*bdd1*f*r**2 - 70*D1**2*K*bdd1*f*r*s + 70*D1**2*K*bdd1*f*r - 35*D1**2*K*bdd1*f*s**2 + 70*D1**2*K*bdd1*f*s - 35*D1**2*K*bdd1*f - 7*D1**2*b2*fd*r**2 - 14*D1**2*b2*fd*r*s - 7*D1**2*b2*fd*s**2 - 7*D1**2*bd2*f*(r + s - 1)**2 - 12*D1**2*bdd1*f*r**2 - 24*D1**2*bdd1*f*r*s + 12*D1**2*bdd1*f*r - 12*D1**2*bdd1*f*s**2 + 12*D1**2*bdd1*f*s - 6*D1**2*bdd1*f - 28*D1**2*bdd1*g2*r**2 - 56*D1**2*bdd1*g2*r*s + 28*D1**2*bdd1*g2*r - 28*D1**2*bdd1*g2*s**2 + 28*D1**2*bdd1*g2*s - 14*D1**2*bdd1*g2 + 22*D1**2*f*fd*r**2 + 40*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 18*D1**2*f*fd*s**2 - 20*D1**2*f*fd*s + 11*D1**2*f*fd + 34*D1**2*f*fdd*r**2 + 64*D1**2*f*fdd*r*s - 34*D1**2*f*fdd*r + 30*D1**2*f*fdd*s**2 - 32*D1**2*f*fdd*s + 17*D1**2*f*fdd + 21*D1**2*f*gd2*r**2 + 42*D1**2*f*gd2*r*s - 42*D1**2*f*gd2*r + 21*D1**2*f*gd2*s**2 - 42*D1**2*f*gd2*s + 21*D1**2*f*gd2 + 35*D1**2*f*gdd2*r**2 + 70*D1**2*f*gdd2*r*s - 70*D1**2*f*gdd2*r + 35*D1**2*f*gdd2*s**2 - 70*D1**2*f*gdd2*s + 35*D1**2*f*gdd2 + 34*D1**2*fd**2*r**2 + 64*D1**2*fd**2*r*s - 34*D1**2*fd**2*r + 30*D1**2*fd**2*s**2 - 32*D1**2*fd**2*s + 21*D1**2*fd*g2*r**2 + 42*D1**2*fd*g2*r*s + 21*D1**2*fd*g2*s**2 + 70*D1**2*fd*gd2*r**2 + 140*D1**2*fd*gd2*r*s - 70*D1**2*fd*gd2*r + 70*D1**2*fd*gd2*s**2 - 70*D1**2*fd*gd2*s + 35*D1**2*fdd*g2*r**2 + 70*D1**2*fdd*g2*r*s + 35*D1**2*fdd*g2*s**2 - 28*D1*Dd*b2*f*r**2 - 56*D1*Dd*b2*f*r*s + 42*D1*Dd*b2*f*r - 28*D1*Dd*b2*f*s**2 + 42*D1*Dd*b2*f*s - 21*D1*Dd*b2*f + 44*D1*Dd*f**2*r**2 + 80*D1*Dd*f**2*r*s - 64*D1*Dd*f**2*r + 36*D1*Dd*f**2*s**2 - 58*D1*Dd*f**2*s + 31*D1*Dd*f**2 + 272*D1*Dd*f*fd*r**2 + 512*D1*Dd*f*fd*r*s - 336*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 316*D1*Dd*f*fd*s + 100*D1*Dd*f*fd + 84*D1*Dd*f*g2*r**2 + 168*D1*Dd*f*g2*r*s - 126*D1*Dd*f*g2*r + 84*D1*Dd*f*g2*s**2 - 126*D1*Dd*f*g2*s + 63*D1*Dd*f*g2 + 280*D1*Dd*f*gd2*r**2 + 560*D1*Dd*f*gd2*r*s - 490*D1*Dd*f*gd2*r + 280*D1*Dd*f*gd2*s**2 - 490*D1*Dd*f*gd2*s + 210*D1*Dd*f*gd2 + 280*D1*Dd*fd*g2*r**2 + 560*D1*Dd*fd*g2*r*s - 210*D1*Dd*fd*g2*r + 280*D1*Dd*fd*g2*s**2 - 210*D1*Dd*fd*g2*s + 68*D1*Ddd*f**2*r**2 + 128*D1*Ddd*f**2*r*s - 100*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 94*D1*Ddd*f**2*s + 49*D1*Ddd*f**2 + 140*D1*Ddd*f*g2*r**2 + 280*D1*Ddd*f*g2*r*s - 210*D1*Ddd*f*g2*r + 140*D1*Ddd*f*g2*s**2 - 210*D1*Ddd*f*g2*s + 105*D1*Ddd*f*g2 - D1*bd1*(D1*(f*(10*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 21*K*(r + s - 1)**2 - 24*r**2 - 34*r*s + 31*r - 10*s**2 + 17*s - 12) + 2*fd*(r + s - 1)*(-12*C*(2*r + 2*s - 1) + 35*K*s + r*(35*K + 12) + 12*s - 6) - 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(12*C*(2*r + 2*s - 1) - 35*K*(r + s - 1) - 12*r - 12*s + 6) - 14*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 204*Dd**2*f**2*r**2 + 384*Dd**2*f**2*r*s - 300*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 282*Dd**2*f**2*s + 98*Dd**2*f**2 + 420*Dd**2*f*g2*r**2 + 840*Dd**2*f*g2*r*s - 630*Dd**2*f*g2*r + 420*Dd**2*f*g2*s**2 - 630*Dd**2*f*g2*s + 210*Dd**2*f*g2))/(21*d**2*k3**6) + D1**2*Pk2*Pk3*k1**2*st**2*(66*C*D1**2*bdd1*f**2*s**2 - 1386*C*D1**2*f**2*fd*s**2 + 924*C*D1**2*f**2*fd*s - 462*C*D1**2*f**2*fd + 990*C*D1**2*f**2*fdd*s**2 - 660*C*D1**2*f**2*fdd*s + 330*C*D1**2*f**2*fdd + 1980*C*D1**2*f*fd**2*s**2 - 1320*C*D1**2*f*fd**2*s - 1848*C*D1*Dd*f**3*s**2 + 924*C*D1*Dd*f**3*s - 462*C*D1*Dd*f**3 + 7920*C*D1*Dd*f**2*fd*s**2 - 4620*C*D1*Dd*f**2*fd*s + 660*C*D1*Dd*f**2*fd + 1320*C*D1*Ddd*f**3*s**2 - 660*C*D1*Ddd*f**3*s + 330*C*D1*Ddd*f**3 + 3960*C*Dd**2*f**3*s**2 - 1980*C*Dd**2*f**3*s + 165*D1**2*K*bdd1*f**2*s**2 - 462*D1**2*b2*f*fd*s**2 + 462*D1**2*b2*f*fd*s - 231*D1**2*b2*f*fd + 330*D1**2*b2*f*fdd*s**2 - 330*D1**2*b2*f*fdd*s + 165*D1**2*b2*f*fdd + 330*D1**2*b2*fd**2*s**2 - 330*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*f*(-K*s**2 + f*(6*r*(2*s - 1) + 10*s**2 - 18*s + 3) + r*(2*s - 1) + 5*s**2 - 5*s + 1) - 231*D1**2*bd2*f**2*s**2 + 660*D1**2*bd2*f*fd*s**2 - 330*D1**2*bd2*f*fd*s + 594*D1**2*bdd1*f**3*r*s + 594*D1**2*bdd1*f**3*s**2 - 297*D1**2*bdd1*f**3*s + 99*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r + 99*D1**2*bdd1*f**2*s - 132*D1**2*bdd1*f**2 - 66*D1**2*bdd1*f*g2*s**2 + 165*D1**2*bdd2*f**2*s**2 - 789*D1**2*f**2*fd*r*s + 263*D1**2*f**2*fd*r + 99*D1**2*f**2*fd*s**2 + 197*D1**2*f**2*fd*s + 33*D1**2*f**2*fd + 543*D1**2*f**2*fdd*r*s - 181*D1**2*f**2*fdd*r + 99*D1**2*f**2*fdd*s**2 - 247*D1**2*f**2*fdd*s + 33*D1**2*f**2*fdd + 462*D1**2*f**2*gd2*s**2 - 330*D1**2*f**2*gdd2*s**2 + 1086*D1**2*f*fd**2*r*s - 362*D1**2*f*fd**2*r + 198*D1**2*f*fd**2*s**2 - 494*D1**2*f*fd**2*s + 181*D1**2*f*fd**2 + 924*D1**2*f*fd*g2*s**2 - 924*D1**2*f*fd*g2*s + 462*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*s**2 + 660*D1**2*f*fd*gd2*s - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s - 924*D1*Dd*b2*f**2*s**2 + 462*D1*Dd*b2*f**2*s - 231*D1*Dd*b2*f**2 + 2640*D1*Dd*b2*f*fd*s**2 - 1980*D1*Dd*b2*f*fd*s + 330*D1*Dd*b2*f*fd + 1320*D1*Dd*bd2*f**2*s**2 - 330*D1*Dd*bd2*f**2*s - 1052*D1*Dd*f**3*r*s + 263*D1*Dd*f**3*r + 132*D1*Dd*f**3*s**2 + 460*D1*Dd*f**3*s + 33*D1*Dd*f**3 + 4344*D1*Dd*f**2*fd*r*s - 1267*D1*Dd*f**2*fd*r + 792*D1*Dd*f**2*fd*s**2 - 2272*D1*Dd*f**2*fd*s + 609*D1*Dd*f**2*fd + 1848*D1*Dd*f**2*g2*s**2 - 924*D1*Dd*f**2*g2*s + 462*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*s**2 + 660*D1*Dd*f**2*gd2*s - 5280*D1*Dd*f*fd*g2*s**2 + 3960*D1*Dd*f*fd*g2*s - 660*D1*Dd*f*fd*g2 + 660*D1*Ddd*b2*f**2*s**2 - 330*D1*Ddd*b2*f**2*s + 165*D1*Ddd*b2*f**2 + 724*D1*Ddd*f**3*r*s - 181*D1*Ddd*f**3*r + 132*D1*Ddd*f**3*s**2 - 428*D1*Ddd*f**3*s + 33*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*s**2 + 660*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(9*f**3*s*(2*r + 2*s - 1) + f**2*(2*C*s**2 + 7*K*s**2 - 9*fd*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + r*(3*s + 4) - 4*s**2 + 9*s - 8) + f*(fd*(4*C*s*(1 - 2*s) - 20*K*s**2 + 10*K*s - 12*r*s + r - 3) + s**2*(-18*g2 + 4*gd2)) + 4*fd*g2*s*(s - 1)) - Dd*f*(9*f**2*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + f*(r*(24*s + 5) + s**2*(16*C + 40*K) - s*(4*C + 10*K - 6) - 7) + 4*g2*s*(1 - 4*s))) + 1980*Dd**2*b2*f**2*s**2 - 990*Dd**2*b2*f**2*s + 2172*Dd**2*f**3*r*s - 543*Dd**2*f**3*r + 396*Dd**2*f**3*s**2 - 1284*Dd**2*f**3*s + 362*Dd**2*f**3 - 3960*Dd**2*f**2*g2*s**2 + 1980*Dd**2*f**2*g2*s + 33*b1**2*(D1**2*(-4*fd**2*s*(6*r + 5*s - 2) + fd*(-9*K*(s - 1)**2 + f*(28*s**2 + s*(24*r - 4) - 7) + 4*r*s + 17*s**2 - 18*s + 9) + fdd*(K*(s - 1)**2 + f*(-20*s**2 + s*(8 - 24*r) + 5) - 2*r*s - 5*s**2 + 2*s - 1)) + D1*(Dd*(2*f**2*(6*r*(4*s - 1) + 28*s**2 - 26*s + 7) + f*(-9*K*(4*s**2 - 2*s + 1) - 8*fd*(3*r*(8*s - 1) + 20*s**2 - 15*s + 1) + 16*r*s - 4*r + 68*s**2 - 42*s + 17) + 2*fd*(4*K*s**2 - 5*K*s + K - 8*r*s + r - 20*s**2 + 11*s - 1)) + Ddd*f*(4*K*s**2 - 2*K*s + K - 2*f*(6*r*(4*s - 1) + 20*s**2 - 22*s + 5) - 8*r*s + 2*r - 20*s**2 + 14*s - 5)) - 2*Dd**2*f*(-6*K*s**2 + 3*K*s + 6*f*(3*r*(4*s - 1) + 10*s**2 - 11*s + 2) + 3*r*(4*s - 1) + 30*s**2 - 21*s + 2)) + 33*b1*(-4*C*D1**2*f*fd*s**2 + 4*C*D1**2*f*fd*s - 2*C*D1**2*f*fd + 4*C*D1**2*f*fdd*s**2 - 4*C*D1**2*f*fdd*s + 2*C*D1**2*f*fdd + 4*C*D1**2*fd**2*s**2 - 4*C*D1**2*fd**2*s - 8*C*D1*Dd*f**2*s**2 + 4*C*D1*Dd*f**2*s - 2*C*D1*Dd*f**2 + 32*C*D1*Dd*f*fd*s**2 - 24*C*D1*Dd*f*fd*s + 4*C*D1*Dd*f*fd + 8*C*D1*Ddd*f**2*s**2 - 4*C*D1*Ddd*f**2*s + 2*C*D1*Ddd*f**2 + 24*C*Dd**2*f**2*s**2 - 12*C*Dd**2*f**2*s - 14*D1**2*K*f*fd*s**2 + 14*D1**2*K*f*fd*s - 7*D1**2*K*f*fd + 10*D1**2*K*f*fdd*s**2 - 10*D1**2*K*f*fdd*s + 5*D1**2*K*f*fdd + 10*D1**2*K*fd**2*s**2 - 10*D1**2*K*fd**2*s + D1**2*bdd1*f*(f*(r*(12 - 24*s) - 20*s**2 + 36*s - 15) - 4*r*s + 2*r + 2*s**2*(K - 5) + 10*s - 4) - 54*D1**2*f**2*fd*r*s + 18*D1**2*f**2*fd*r - 54*D1**2*f**2*fd*s**2 + 63*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 54*D1**2*f**2*fdd*r*s - 18*D1**2*f**2*fdd*r + 54*D1**2*f**2*fdd*s**2 - 63*D1**2*f**2*fdd*s + 18*D1**2*f**2*fdd + 108*D1**2*f*fd**2*r*s - 36*D1**2*f*fd**2*r + 108*D1**2*f*fd**2*s**2 - 126*D1**2*f*fd**2*s + 27*D1**2*f*fd**2 - 6*D1**2*f*fd*r*s + 7*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 4*D1**2*f*fd + 6*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r - 6*D1**2*f*fdd*s + 4*D1**2*f*fdd + 18*D1**2*f*gd2*s**2 - 2*D1**2*f*gdd2*s**2 + 6*D1**2*fd**2*r*s - 5*D1**2*fd**2*r - 6*D1**2*fd**2*s + 18*D1**2*fd*g2*s**2 - 36*D1**2*fd*g2*s + 18*D1**2*fd*g2 - 4*D1**2*fd*gd2*s**2 + 4*D1**2*fd*gd2*s - 2*D1**2*fdd*g2*s**2 + 4*D1**2*fdd*g2*s - 2*D1**2*fdd*g2 - 28*D1*Dd*K*f**2*s**2 + 14*D1*Dd*K*f**2*s - 7*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*s**2 - 60*D1*Dd*K*f*fd*s + 10*D1*Dd*K*f*fd - 72*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 72*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 432*D1*Dd*f**2*fd*r*s - 126*D1*Dd*f**2*fd*r + 432*D1*Dd*f**2*fd*s**2 - 468*D1*Dd*f**2*fd*s + 99*D1*Dd*f**2*fd - 12*D1*Dd*f**2*r*s + 3*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 2*D1*Dd*f**2*s + 4*D1*Dd*f**2 + 48*D1*Dd*f*fd*r*s - 26*D1*Dd*f*fd*r - 36*D1*Dd*f*fd*s + 16*D1*Dd*f*fd + 72*D1*Dd*f*g2*s**2 - 36*D1*Dd*f*g2*s + 18*D1*Dd*f*g2 - 16*D1*Dd*f*gd2*s**2 + 4*D1*Dd*f*gd2*s - 16*D1*Dd*fd*g2*s**2 + 20*D1*Dd*fd*g2*s - 4*D1*Dd*fd*g2 + 20*D1*Ddd*K*f**2*s**2 - 10*D1*Ddd*K*f**2*s + 5*D1*Ddd*K*f**2 + 72*D1*Ddd*f**3*r*s - 18*D1*Ddd*f**3*r + 72*D1*Ddd*f**3*s**2 - 72*D1*Ddd*f**3*s + 18*D1*Ddd*f**3 + 12*D1*Ddd*f**2*r*s - 3*D1*Ddd*f**2*r - 6*D1*Ddd*f**2*s - 8*D1*Ddd*f*g2*s**2 + 4*D1*Ddd*f*g2*s - 2*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(12*r*(2*s - 1) + 28*s**2 - 48*s + 21) - 2*f*(9*K*s**2 + fd*(48*r*s - 12*r + 40*s**2 - 44*s + 9) - 4*r*s + 2*r - 17*s**2 + 10*s - 4) + 2*fd*(-4*r*s + r + s*(2*K*(s - 1) - 10*s + 7))) - 2*Dd*f*(-8*K*s**2 + 2*K*s + 2*f*(6*r*(8*s - 3) + 40*s**2 - 58*s + 15) + 16*r*s - 6*r + 40*s**2 - 34*s + 7)) + 60*Dd**2*K*f**2*s**2 - 30*Dd**2*K*f**2*s + 216*Dd**2*f**3*r*s - 54*Dd**2*f**3*r + 216*Dd**2*f**3*s**2 - 216*Dd**2*f**3*s + 36*Dd**2*f**3 + 36*Dd**2*f**2*r*s - 9*Dd**2*f**2*r - 18*Dd**2*f**2*s + 6*Dd**2*f**2 - 24*Dd**2*f*g2*s**2 + 12*Dd**2*f*g2*s))/(693*d**2*k2**2*k3**2) + 2*D1**2*Pk2*Pk3*k1**2*(36*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 12*C*D1**2*f**2*fd - 36*C*D1**2*f**2*fdd*s**2 + 24*C*D1**2*f**2*fdd*s - 12*C*D1**2*f**2*fdd - 72*C*D1**2*f*fd**2*s**2 + 48*C*D1**2*f*fd**2*s + 48*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 12*C*D1*Dd*f**3 - 288*C*D1*Dd*f**2*fd*s**2 + 168*C*D1*Dd*f**2*fd*s - 24*C*D1*Dd*f**2*fd - 48*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 144*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s - 7*D1**2*K*bdd1*f**2*s**2 + 14*D1**2*b2*f*fd*s**2 - 14*D1**2*b2*f*fd*s + 7*D1**2*b2*f*fd - 14*D1**2*b2*f*fdd*s**2 + 14*D1**2*b2*f*fdd*s - 7*D1**2*b2*f*fdd - 14*D1**2*b2*fd**2*s**2 + 14*D1**2*b2*fd**2*s + D1**2*bd1**2*(7*f**2*(6*r*(2*s - 1) + 4*s**2 - 9*s + 3) + f*(21*r*(2*s - 1) + (s - 1)*(24*C*s + 4*s - 21)) - 28*g2*s*(s - 1)) + 7*D1**2*bd2*f**2*s**2 - 28*D1**2*bd2*f*fd*s**2 + 14*D1**2*bd2*f*fd*s + 20*D1**2*bdd1*f**2*r*s - 20*D1**2*bdd1*f**2*r + 12*D1**2*bdd1*f**2*s**2 - 24*D1**2*bdd1*f**2*s + 12*D1**2*bdd1*f**2 - 7*D1**2*bdd2*f**2*s**2 - 18*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 18*D1**2*f**2*fdd*s**2 - 12*D1**2*f**2*fdd*s + 6*D1**2*f**2*fdd - 14*D1**2*f**2*gd2*s**2 + 14*D1**2*f**2*gdd2*s**2 + 36*D1**2*f*fd**2*s**2 - 24*D1**2*f*fd**2*s - 28*D1**2*f*fd*g2*s**2 + 28*D1**2*f*fd*g2*s - 14*D1**2*f*fd*g2 + 56*D1**2*f*fd*gd2*s**2 - 28*D1**2*f*fd*gd2*s + 28*D1**2*f*fdd*g2*s**2 - 28*D1**2*f*fdd*g2*s + 14*D1**2*f*fdd*g2 + 28*D1**2*fd**2*g2*s**2 - 28*D1**2*fd**2*g2*s + 28*D1*Dd*b2*f**2*s**2 - 14*D1*Dd*b2*f**2*s + 7*D1*Dd*b2*f**2 - 112*D1*Dd*b2*f*fd*s**2 + 84*D1*Dd*b2*f*fd*s - 14*D1*Dd*b2*f*fd - 56*D1*Dd*bd2*f**2*s**2 + 14*D1*Dd*bd2*f**2*s - 24*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 144*D1*Dd*f**2*fd*s**2 - 84*D1*Dd*f**2*fd*s + 12*D1*Dd*f**2*fd - 56*D1*Dd*f**2*g2*s**2 + 28*D1*Dd*f**2*g2*s - 14*D1*Dd*f**2*g2 + 112*D1*Dd*f**2*gd2*s**2 - 28*D1*Dd*f**2*gd2*s + 224*D1*Dd*f*fd*g2*s**2 - 168*D1*Dd*f*fd*g2*s + 28*D1*Dd*f*fd*g2 - 28*D1*Ddd*b2*f**2*s**2 + 14*D1*Ddd*b2*f**2*s - 7*D1*Ddd*b2*f**2 + 24*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 6*D1*Ddd*f**3 + 56*D1*Ddd*f**2*g2*s**2 - 28*D1*Ddd*f**2*g2*s + 14*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(f*(-22*r*(s - 1) + s**2*(7*K - 12) + 24*s - 12) + 2*fd*(20*r*(2*s - 1) + s**2*(24 - 14*K) + s*(7*K - 34) + 10)) + 2*Dd*f*(10*r*(8*s - 5) + s**2*(48 - 28*K) + s*(7*K - 80) + 32)) - 84*Dd**2*b2*f**2*s**2 + 42*Dd**2*b2*f**2*s + 72*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 168*Dd**2*f**2*g2*s**2 - 84*Dd**2*f**2*g2*s - 7*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + b1**2*(-10*C*D1**2*fd*s**2 + 12*C*D1**2*fdd*s**2 - 40*C*D1*Dd*f*s**2 + 20*C*D1*Dd*f*s - 10*C*D1*Dd*f + 96*C*D1*Dd*fd*s**2 - 24*C*D1*Dd*fd*s + 48*C*D1*Ddd*f*s**2 - 24*C*D1*Ddd*f*s + 12*C*D1*Ddd*f + 144*C*Dd**2*f*s**2 - 72*C*Dd**2*f*s + 7*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) - 84*D1**2*f*fd*r*s - 28*D1**2*f*fd*s**2 + 49*D1**2*f*fd*s + 7*D1**2*f*fd + 84*D1**2*f*fdd*r*s + 28*D1**2*f*fdd*s**2 - 49*D1**2*f*fdd*s - 7*D1**2*f*fdd + 84*D1**2*fd**2*r*s + 28*D1**2*fd**2*s**2 - 49*D1**2*fd**2*s - 21*D1**2*fd*r*s - 4*D1**2*fd*s**2 + 21*D1**2*fdd*r*s + 2*D1**2*fdd*s**2 + 28*D1**2*gd2*s**2 - 14*D1**2*gdd2*s**2 - 168*D1*Dd*f**2*r*s + 42*D1*Dd*f**2*r - 56*D1*Dd*f**2*s**2 + 112*D1*Dd*f**2*s - 14*D1*Dd*f**2 + 672*D1*Dd*f*fd*r*s - 84*D1*Dd*f*fd*r + 224*D1*Dd*f*fd*s**2 - 420*D1*Dd*f*fd*s + 49*D1*Dd*f*fd - 84*D1*Dd*f*r*s + 21*D1*Dd*f*r - 16*D1*Dd*f*s**2 + 50*D1*Dd*f*s - 4*D1*Dd*f + 168*D1*Dd*fd*r*s - 21*D1*Dd*fd*r + 16*D1*Dd*fd*s**2 - 46*D1*Dd*fd*s + 112*D1*Dd*g2*s**2 - 56*D1*Dd*g2*s + 28*D1*Dd*g2 - 112*D1*Dd*gd2*s**2 + 28*D1*Dd*gd2*s + 168*D1*Ddd*f**2*r*s - 42*D1*Ddd*f**2*r + 56*D1*Ddd*f**2*s**2 - 112*D1*Ddd*f**2*s + 14*D1*Ddd*f**2 + 84*D1*Ddd*f*r*s - 21*D1*Ddd*f*r + 8*D1*Ddd*f*s**2 - 46*D1*Ddd*f*s + 2*D1*Ddd*f - 56*D1*Ddd*g2*s**2 + 28*D1*Ddd*g2*s - 14*D1*Ddd*g2 - 14*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) + 504*Dd**2*f**2*r*s - 126*Dd**2*f**2*r + 168*Dd**2*f**2*s**2 - 336*Dd**2*f**2*s + 84*Dd**2*f**2 + 252*Dd**2*f*r*s - 63*Dd**2*f*r + 24*Dd**2*f*s**2 - 138*Dd**2*f*s + 42*Dd**2*f - 168*Dd**2*g2*s**2 + 84*Dd**2*g2*s) + b1*(14*D1**2*K*f*fd*s**2 - 14*D1**2*K*f*fd*s + 7*D1**2*K*f*fd - 14*D1**2*K*f*fdd*s**2 + 14*D1**2*K*f*fdd*s - 7*D1**2*K*f*fdd - 14*D1**2*K*fd**2*s**2 + 14*D1**2*K*fd**2*s + 14*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + D1**2*bdd1*(7*f**2*(6*r*(2*s - 1) + 4*s**2 - 9*s + 3) + f*(12*C*(2*s**2 - 2*s + 1) + 42*r*s - 21*r + 4*s**2 - 25*s + 2) - 14*g2*(2*s**2 - 2*s + 1)) - 44*D1**2*f*fd*r*s - 24*D1**2*f*fd*s**2 + 22*D1**2*f*fd*s + 40*D1**2*f*fdd*r*s + 24*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 40*D1**2*fd**2*r*s + 24*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s + 28*D1*Dd*K*f**2*s**2 - 14*D1*Dd*K*f**2*s + 7*D1*Dd*K*f**2 - 112*D1*Dd*K*f*fd*s**2 + 84*D1*Dd*K*f*fd*s - 14*D1*Dd*K*f*fd - 88*D1*Dd*f**2*r*s + 22*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 68*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 320*D1*Dd*f*fd*r*s - 40*D1*Dd*f*fd*r + 192*D1*Dd*f*fd*s**2 - 208*D1*Dd*f*fd*s + 20*D1*Dd*f*fd - 28*D1*Ddd*K*f**2*s**2 + 14*D1*Ddd*K*f**2*s - 7*D1*Ddd*K*f**2 + 80*D1*Ddd*f**2*r*s - 20*D1*Ddd*f**2*r + 48*D1*Ddd*f**2*s**2 - 64*D1*Ddd*f**2*s + 12*D1*Ddd*f**2 + D1*bd1*(D1*(48*C*fd*s**2 - 24*C*fd*s - 7*f**2*(6*r*(2*s - 1) + 4*s**2 - 9*s + 3) + f*(-10*C*(2*s**2 - 2*s + 1) + 7*fd*(48*r*s - 12*r + 16*s**2 - 32*s + 9) - 42*r*s + 21*r - 8*s**2 + 29*s - 4) + 84*fd*r*s - 21*fd*r + 8*fd*s**2 - 25*fd*s + 56*g2*s**2 - 56*g2*s + 28*g2 - 56*gd2*s**2 + 28*gd2*s) + Dd*(7*f**2*(8*s - 3)*(12*r + 4*s - 7) + f*(24*C*(8*s**2 - 6*s + 1) + 42*r*(8*s - 3) + 32*s**2 - 192*s + 67) - 28*g2*(8*s**2 - 6*s + 1))) - 84*Dd**2*K*f**2*s**2 + 42*Dd**2*K*f**2*s + 240*Dd**2*f**2*r*s - 60*Dd**2*f**2*r + 144*Dd**2*f**2*s**2 - 192*Dd**2*f**2*s + 40*Dd**2*f**2))/(21*d**2*k2**2*k3**2) + 20*D1**2*Pk2*Pk3*k2**6*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 66*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(33*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - fd*(2*C - 1)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 33*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(2*C*f + 33*K*b1 - f - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*C*f + 33*K*b1 - f - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(231*d**2*k3**8) - 24*D1**2*Pk2*Pk3*k2**6*st**4*(-2*D1**2*K*b1**2*fd*r**2 - 4*D1**2*K*b1**2*fd*r*s - 2*D1**2*K*b1**2*fd*s**2 + D1**2*K*b1**2*fdd*r**2 + 2*D1**2*K*b1**2*fdd*r*s + D1**2*K*b1**2*fdd*s**2 + 2*D1**2*K*b1*f*fd*r**2 + 4*D1**2*K*b1*f*fd*r*s - 2*D1**2*K*b1*f*fd*r + 2*D1**2*K*b1*f*fd*s**2 - 2*D1**2*K*b1*f*fd*s + D1**2*K*b1*f*fd + 2*D1**2*K*bd1**2*f*(r + s - 1)**2 + 4*D1**2*b1*f*gd2*r**2 + 8*D1**2*b1*f*gd2*r*s - 8*D1**2*b1*f*gd2*r + 4*D1**2*b1*f*gd2*s**2 - 8*D1**2*b1*f*gd2*s + 4*D1**2*b1*f*gd2 - 2*D1**2*b1*f*gdd2*r**2 - 4*D1**2*b1*f*gdd2*r*s + 4*D1**2*b1*f*gdd2*r - 2*D1**2*b1*f*gdd2*s**2 + 4*D1**2*b1*f*gdd2*s - 2*D1**2*b1*f*gdd2 + 4*D1**2*b1*fd*g2*r**2 + 8*D1**2*b1*fd*g2*r*s + 4*D1**2*b1*fd*g2*s**2 - 4*D1**2*b1*fd*gd2*r**2 - 8*D1**2*b1*fd*gd2*r*s + 4*D1**2*b1*fd*gd2*r - 4*D1**2*b1*fd*gd2*s**2 + 4*D1**2*b1*fd*gd2*s - 2*D1**2*b1*fdd*g2*r**2 - 4*D1**2*b1*fdd*g2*r*s - 2*D1**2*b1*fdd*g2*s**2 - 2*D1**2*bdd1*f*(-K*b1 + g2)*(r + s - 1)**2 - 2*D1**2*f**2*gd2*r**2 - 4*D1**2*f**2*gd2*r*s + 4*D1**2*f**2*gd2*r - 2*D1**2*f**2*gd2*s**2 + 4*D1**2*f**2*gd2*s - 2*D1**2*f**2*gd2 - 4*D1**2*f*fd*g2*r**2 - 8*D1**2*f*fd*g2*r*s + 4*D1**2*f*fd*g2*r - 4*D1**2*f*fd*g2*s**2 + 4*D1**2*f*fd*g2*s - 2*D1**2*f*fd*g2 - 8*D1*Dd*K*b1**2*f*r**2 - 16*D1*Dd*K*b1**2*f*r*s + 12*D1*Dd*K*b1**2*f*r - 8*D1*Dd*K*b1**2*f*s**2 + 12*D1*Dd*K*b1**2*f*s - 6*D1*Dd*K*b1**2*f + 8*D1*Dd*K*b1**2*fd*r**2 + 16*D1*Dd*K*b1**2*fd*r*s - 6*D1*Dd*K*b1**2*fd*r + 8*D1*Dd*K*b1**2*fd*s**2 - 6*D1*Dd*K*b1**2*fd*s + 4*D1*Dd*K*b1*f**2*r**2 + 8*D1*Dd*K*b1*f**2*r*s - 6*D1*Dd*K*b1*f**2*r + 4*D1*Dd*K*b1*f**2*s**2 - 6*D1*Dd*K*b1*f**2*s + 3*D1*Dd*K*b1*f**2 + 16*D1*Dd*b1*f*g2*r**2 + 32*D1*Dd*b1*f*g2*r*s - 24*D1*Dd*b1*f*g2*r + 16*D1*Dd*b1*f*g2*s**2 - 24*D1*Dd*b1*f*g2*s + 12*D1*Dd*b1*f*g2 - 16*D1*Dd*b1*f*gd2*r**2 - 32*D1*Dd*b1*f*gd2*r*s + 28*D1*Dd*b1*f*gd2*r - 16*D1*Dd*b1*f*gd2*s**2 + 28*D1*Dd*b1*f*gd2*s - 12*D1*Dd*b1*f*gd2 - 16*D1*Dd*b1*fd*g2*r**2 - 32*D1*Dd*b1*fd*g2*r*s + 12*D1*Dd*b1*fd*g2*r - 16*D1*Dd*b1*fd*g2*s**2 + 12*D1*Dd*b1*fd*g2*s - 8*D1*Dd*f**2*g2*r**2 - 16*D1*Dd*f**2*g2*r*s + 12*D1*Dd*f**2*g2*r - 8*D1*Dd*f**2*g2*s**2 + 12*D1*Dd*f**2*g2*s - 6*D1*Dd*f**2*g2 + 4*D1*Ddd*K*b1**2*f*r**2 + 8*D1*Ddd*K*b1**2*f*r*s - 6*D1*Ddd*K*b1**2*f*r + 4*D1*Ddd*K*b1**2*f*s**2 - 6*D1*Ddd*K*b1**2*f*s + 3*D1*Ddd*K*b1**2*f - 8*D1*Ddd*b1*f*g2*r**2 - 16*D1*Ddd*b1*f*g2*r*s + 12*D1*Ddd*b1*f*g2*r - 8*D1*Ddd*b1*f*g2*s**2 + 12*D1*Ddd*b1*f*g2*s - 6*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(K*f**2*(r + s - 1) + 4*f*(r + s - 1)*(-K*b1 + g2 - gd2) - 4*fd*(r + s)*(-K*b1 + g2)) - 4*Dd*f*(-K*b1 + g2)*(4*r + 4*s - 3))*(r + s - 1) + 12*Dd**2*K*b1**2*f*r**2 + 24*Dd**2*K*b1**2*f*r*s - 18*Dd**2*K*b1**2*f*r + 12*Dd**2*K*b1**2*f*s**2 - 18*Dd**2*K*b1**2*f*s + 6*Dd**2*K*b1**2*f - 24*Dd**2*b1*f*g2*r**2 - 48*Dd**2*b1*f*g2*r*s + 36*Dd**2*b1*f*g2*r - 24*Dd**2*b1*f*g2*s**2 + 36*Dd**2*b1*f*g2*s - 12*Dd**2*b1*f*g2)/(7*d**2*k3**8) + 20*D1**2*Pk2*Pk3*k2**4*st**6*(-36*C*D1**2*f**2*fd*r**2 - 48*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 12*C*D1**2*f**2*fd*s**2 + 24*C*D1**2*f**2*fd*s - 16*C*D1**2*f**2*fd + 18*C*D1**2*f**2*fdd*r**2 + 24*C*D1**2*f**2*fdd*r*s - 20*C*D1**2*f**2*fdd*r + 6*C*D1**2*f**2*fdd*s**2 - 12*C*D1**2*f**2*fdd*s + 8*C*D1**2*f**2*fdd + 36*C*D1**2*f*fd**2*r**2 + 48*C*D1**2*f*fd**2*r*s - 40*C*D1**2*f*fd**2*r + 12*C*D1**2*f*fd**2*s**2 - 24*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 48*C*D1*Dd*f**3*r**2 - 64*C*D1*Dd*f**3*r*s + 64*C*D1*Dd*f**3*r - 16*C*D1*Dd*f**3*s**2 + 40*C*D1*Dd*f**3*s - 28*C*D1*Dd*f**3 + 144*C*D1*Dd*f**2*fd*r**2 + 192*C*D1*Dd*f**2*fd*r*s - 176*C*D1*Dd*f**2*fd*r + 48*C*D1*Dd*f**2*fd*s**2 - 108*C*D1*Dd*f**2*fd*s + 52*C*D1*Dd*f**2*fd + 24*C*D1*Ddd*f**3*r**2 + 32*C*D1*Ddd*f**3*r*s - 32*C*D1*Ddd*f**3*r + 8*C*D1*Ddd*f**3*s**2 - 20*C*D1*Ddd*f**3*s + 14*C*D1*Ddd*f**3 + 72*C*Dd**2*f**3*r**2 + 96*C*Dd**2*f**3*r*s - 96*C*Dd**2*f**3*r + 24*C*Dd**2*f**3*s**2 - 60*C*Dd**2*f**3*s + 28*C*Dd**2*f**3 - 396*D1**2*K*b1*f*fd*r**2 - 528*D1**2*K*b1*f*fd*r*s + 264*D1**2*K*b1*f*fd*r - 132*D1**2*K*b1*f*fd*s**2 + 132*D1**2*K*b1*f*fd*s - 66*D1**2*K*b1*f*fd + 198*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 66*D1**2*K*b1*f*fdd*s**2 - 66*D1**2*K*b1*f*fdd*s + 33*D1**2*K*b1*f*fdd + 198*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 66*D1**2*K*b1*fd**2*s**2 - 66*D1**2*K*b1*fd**2*s + 99*D1**2*K*bdd1*f**2*r**2 + 132*D1**2*K*bdd1*f**2*r*s - 198*D1**2*K*bdd1*f**2*r + 33*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s + 99*D1**2*K*bdd1*f**2 + 99*D1**2*b1*f**2*fd*r**2 + 99*D1**2*b1*f**2*fd*r*s - 99*D1**2*b1*f**2*fd*r - 33*D1**2*b1*f**2*fd*s + 33*D1**2*b1*f**2*fd - 99*D1**2*b1*f**2*fdd*r**2 - 99*D1**2*b1*f**2*fdd*r*s + 99*D1**2*b1*f**2*fdd*r + 33*D1**2*b1*f**2*fdd*s - 33*D1**2*b1*f**2*fdd - 198*D1**2*b1*f*fd**2*r**2 - 198*D1**2*b1*f*fd**2*r*s + 198*D1**2*b1*f*fd**2*r + 66*D1**2*b1*f*fd**2*s - 33*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 33*D1**2*b1*fd**2*r - 132*D1**2*b2*f*fd*r**2 - 264*D1**2*b2*f*fd*r*s + 132*D1**2*b2*f*fd*r - 132*D1**2*b2*f*fd*s**2 + 132*D1**2*b2*f*fd*s - 66*D1**2*b2*f*fd + 66*D1**2*b2*f*fdd*r**2 + 132*D1**2*b2*f*fdd*r*s - 66*D1**2*b2*f*fdd*r + 66*D1**2*b2*f*fdd*s**2 - 66*D1**2*b2*f*fdd*s + 33*D1**2*b2*f*fdd + 66*D1**2*b2*fd**2*r**2 + 132*D1**2*b2*fd**2*r*s - 66*D1**2*b2*fd**2*r + 66*D1**2*b2*fd**2*s**2 - 66*D1**2*b2*fd**2*s - 33*D1**2*bdd1*f**3*r**2 - 33*D1**2*bdd1*f**3*r*s + 66*D1**2*bdd1*f**3*r + 33*D1**2*bdd1*f**3*s - 33*D1**2*bdd1*f**3 - 33*D1**2*bdd1*f**2*r**2 - 33*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r + 33*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 + 33*D1**2*bdd2*f**2*r**2 + 66*D1**2*bdd2*f**2*r*s - 66*D1**2*bdd2*f**2*r + 33*D1**2*bdd2*f**2*s**2 - 66*D1**2*bdd2*f**2*s + 33*D1**2*bdd2*f**2 + 24*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 26*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 14*D1**2*f**2*fd*s + 10*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 - 15*D1**2*f**2*fdd*r*s + 13*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 7*D1**2*f**2*fdd*s - 5*D1**2*f**2*fdd + 396*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 792*D1**2*f**2*gd2*r + 132*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 396*D1**2*f**2*gd2 - 198*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 396*D1**2*f**2*gdd2*r - 66*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 198*D1**2*f**2*gdd2 - 24*D1**2*f*fd**2*r**2 - 30*D1**2*f*fd**2*r*s + 26*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 14*D1**2*f*fd**2*s - 5*D1**2*f*fd**2 + 792*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 792*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 1056*D1**2*f*fd*gd2*r - 264*D1**2*f*fd*gd2*s**2 + 660*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 396*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 132*D1**2*f*fdd*g2*s**2 + 132*D1**2*f*fdd*g2*s - 66*D1**2*f*fdd*g2 - 396*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 132*D1**2*fd**2*g2*s**2 + 132*D1**2*fd**2*g2*s - 792*D1*Dd*K*b1*f**2*r**2 - 1056*D1*Dd*K*b1*f**2*r*s + 1056*D1*Dd*K*b1*f**2*r - 264*D1*Dd*K*b1*f**2*s**2 + 660*D1*Dd*K*b1*f**2*s - 462*D1*Dd*K*b1*f**2 + 1584*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1584*D1*Dd*K*b1*f*fd*r + 528*D1*Dd*K*b1*f*fd*s**2 - 924*D1*Dd*K*b1*f*fd*s + 330*D1*Dd*K*b1*f*fd + 132*D1*Dd*b1*f**3*r**2 + 132*D1*Dd*b1*f**3*r*s - 165*D1*Dd*b1*f**3*r - 66*D1*Dd*b1*f**3*s + 66*D1*Dd*b1*f**3 - 792*D1*Dd*b1*f**2*fd*r**2 - 792*D1*Dd*b1*f**2*fd*r*s + 891*D1*Dd*b1*f**2*fd*r + 330*D1*Dd*b1*f**2*fd*s - 231*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 330*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 462*D1*Dd*b1*f*fd*r + 132*D1*Dd*b1*f*fd*s - 66*D1*Dd*b1*f*fd - 264*D1*Dd*b2*f**2*r**2 - 528*D1*Dd*b2*f**2*r*s + 396*D1*Dd*b2*f**2*r - 264*D1*Dd*b2*f**2*s**2 + 396*D1*Dd*b2*f**2*s - 198*D1*Dd*b2*f**2 + 528*D1*Dd*b2*f*fd*r**2 + 1056*D1*Dd*b2*f*fd*r*s - 660*D1*Dd*b2*f*fd*r + 528*D1*Dd*b2*f*fd*s**2 - 660*D1*Dd*b2*f*fd*s + 198*D1*Dd*b2*f*fd + 32*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 42*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 24*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 - 120*D1*Dd*f**2*fd*r*s + 115*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 64*D1*Dd*f**2*fd*s - 33*D1*Dd*f**2*fd + 1584*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 2112*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 - 1320*D1*Dd*f**2*g2*s + 924*D1*Dd*f**2*g2 - 1584*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 2640*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s**2 + 1716*D1*Dd*f**2*gd2*s - 1056*D1*Dd*f**2*gd2 - 3168*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 3168*D1*Dd*f*fd*g2*r - 1056*D1*Dd*f*fd*g2*s**2 + 1848*D1*Dd*f*fd*g2*s - 660*D1*Dd*f*fd*g2 + 396*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 528*D1*Ddd*K*b1*f**2*r + 132*D1*Ddd*K*b1*f**2*s**2 - 330*D1*Ddd*K*b1*f**2*s + 231*D1*Ddd*K*b1*f**2 - 132*D1*Ddd*b1*f**3*r**2 - 132*D1*Ddd*b1*f**3*r*s + 165*D1*Ddd*b1*f**3*r + 66*D1*Ddd*b1*f**3*s - 66*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 165*D1*Ddd*b1*f**2*r + 66*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 + 132*D1*Ddd*b2*f**2*r**2 + 264*D1*Ddd*b2*f**2*r*s - 198*D1*Ddd*b2*f**2*r + 132*D1*Ddd*b2*f**2*s**2 - 198*D1*Ddd*b2*f**2*s + 99*D1*Ddd*b2*f**2 - 16*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r*s + 21*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 12*D1*Ddd*f**3*s - 9*D1*Ddd*f**3 - 792*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 1056*D1*Ddd*f**2*g2*r - 264*D1*Ddd*f**2*g2*s**2 + 660*D1*Ddd*f**2*g2*s - 462*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (2*r + 2*s - 2)*(K*(3*r + s - 3) - r + 1)) + fd*(2*K*(6*r**2 + 8*r*(s - 1) + 2*s**2 - 5*s + 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(2*K*(12*r**2 + 4*r*(4*s - 5) + 4*s**2 - 13*s + 8) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) - 66*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 1188*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1584*Dd**2*K*b1*f**2*r + 396*Dd**2*K*b1*f**2*s**2 - 990*Dd**2*K*b1*f**2*s + 462*Dd**2*K*b1*f**2 - 396*Dd**2*b1*f**3*r**2 - 396*Dd**2*b1*f**3*r*s + 495*Dd**2*b1*f**3*r + 198*Dd**2*b1*f**3*s - 132*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 495*Dd**2*b1*f**2*r + 198*Dd**2*b1*f**2*s - 132*Dd**2*b1*f**2 + 396*Dd**2*b2*f**2*r**2 + 792*Dd**2*b2*f**2*r*s - 594*Dd**2*b2*f**2*r + 396*Dd**2*b2*f**2*s**2 - 594*Dd**2*b2*f**2*s + 198*Dd**2*b2*f**2 - 48*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r*s + 63*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 36*Dd**2*f**3*s - 18*Dd**2*f**3 - 2376*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 3168*Dd**2*f**2*g2*r - 792*Dd**2*f**2*g2*s**2 + 1980*Dd**2*f**2*g2*s - 924*Dd**2*f**2*g2)/(693*d**2*k3**6) + 4*D1**2*Pk2*Pk3*k2**4*st**4*(-48*C*D1**2*f**2*fd*r**2 - 48*C*D1**2*f**2*fd*r*s + 48*C*D1**2*f**2*fd*r + 16*C*D1**2*f**2*fd*s - 16*C*D1**2*f**2*fd + 24*C*D1**2*f**2*fdd*r**2 + 24*C*D1**2*f**2*fdd*r*s - 24*C*D1**2*f**2*fdd*r - 8*C*D1**2*f**2*fdd*s + 8*C*D1**2*f**2*fdd + 48*C*D1**2*f*fd**2*r**2 + 48*C*D1**2*f*fd**2*r*s - 48*C*D1**2*f*fd**2*r - 16*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 64*C*D1*Dd*f**3*r**2 - 64*C*D1*Dd*f**3*r*s + 80*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s - 32*C*D1*Dd*f**3 + 192*C*D1*Dd*f**2*fd*r**2 + 192*C*D1*Dd*f**2*fd*r*s - 216*C*D1*Dd*f**2*fd*r - 80*C*D1*Dd*f**2*fd*s + 56*C*D1*Dd*f**2*fd + 32*C*D1*Ddd*f**3*r**2 + 32*C*D1*Ddd*f**3*r*s - 40*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s + 16*C*D1*Ddd*f**3 + 96*C*Dd**2*f**3*r**2 + 96*C*Dd**2*f**3*r*s - 120*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s + 32*C*Dd**2*f**3 + 88*D1**2*K*bd1**2*f*r**2 + 176*D1**2*K*bd1**2*f*r*s - 220*D1**2*K*bd1**2*f*r + 88*D1**2*K*bd1**2*f*s**2 - 220*D1**2*K*bd1**2*f*s + 132*D1**2*K*bd1**2*f + 33*D1**2*K*bd1*f**2*r**2 - 22*D1**2*K*bd1*f**2*r*s - 66*D1**2*K*bd1*f**2*r - 55*D1**2*K*bd1*f**2*s**2 + 22*D1**2*K*bd1*f**2*s + 33*D1**2*K*bd1*f**2 + 220*D1**2*K*bd1*f*fd*r**2 + 616*D1**2*K*bd1*f*fd*r*s - 374*D1**2*K*bd1*f*fd*r + 396*D1**2*K*bd1*f*fd*s**2 - 506*D1**2*K*bd1*f*fd*s + 154*D1**2*K*bd1*f*fd + 55*D1**2*K*bdd1*f**2*r**2 + 154*D1**2*K*bdd1*f**2*r*s - 110*D1**2*K*bdd1*f**2*r + 99*D1**2*K*bdd1*f**2*s**2 - 154*D1**2*K*bdd1*f**2*s + 55*D1**2*K*bdd1*f**2 - 44*D1**2*bd1**2*f**2*r**2 - 44*D1**2*bd1**2*f**2*r*s + 66*D1**2*bd1**2*f**2*r + 22*D1**2*bd1**2*f**2*s - 22*D1**2*bd1**2*f**2 - 44*D1**2*bd1**2*f*r**2 - 44*D1**2*bd1**2*f*r*s + 66*D1**2*bd1**2*f*r + 22*D1**2*bd1**2*f*s - 22*D1**2*bd1**2*f + 44*D1**2*bd1*bd2*f*r**2 + 88*D1**2*bd1*bd2*f*r*s - 88*D1**2*bd1*bd2*f*r + 44*D1**2*bd1*bd2*f*s**2 - 88*D1**2*bd1*bd2*f*s + 44*D1**2*bd1*bd2*f - 22*D1**2*bd1*f**2*r**2 - 22*D1**2*bd1*f**2*r*s + 44*D1**2*bd1*f**2*r + 22*D1**2*bd1*f**2*s - 22*D1**2*bd1*f**2 + 176*D1**2*bd1*f*g2*r**2 + 352*D1**2*bd1*f*g2*r*s - 528*D1**2*bd1*f*g2*r + 176*D1**2*bd1*f*g2*s**2 - 528*D1**2*bd1*f*g2*s + 264*D1**2*bd1*f*g2 - 176*D1**2*bd1*f*gd2*r**2 - 352*D1**2*bd1*f*gd2*r*s + 440*D1**2*bd1*f*gd2*r - 176*D1**2*bd1*f*gd2*s**2 + 440*D1**2*bd1*f*gd2*s - 264*D1**2*bd1*f*gd2 - 176*D1**2*bd1*fd*g2*r**2 - 352*D1**2*bd1*fd*g2*r*s + 176*D1**2*bd1*fd*g2*r - 176*D1**2*bd1*fd*g2*s**2 + 176*D1**2*bd1*fd*g2*s + 22*D1**2*bd2*f**2*r**2 + 44*D1**2*bd2*f**2*r*s - 44*D1**2*bd2*f**2*r + 22*D1**2*bd2*f**2*s**2 - 44*D1**2*bd2*f**2*s + 22*D1**2*bd2*f**2 - 88*D1**2*bdd1*f*g2*r**2 - 176*D1**2*bdd1*f*g2*r*s + 264*D1**2*bdd1*f*g2*r - 88*D1**2*bdd1*f*g2*s**2 + 264*D1**2*bdd1*f*g2*s - 132*D1**2*bdd1*f*g2 + 24*D1**2*f**2*fd*r**2 + 24*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r - 8*D1**2*f**2*fd*s + 8*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r + 4*D1**2*f**2*fdd*s - 4*D1**2*f**2*fdd - 66*D1**2*f**2*gd2*r**2 + 44*D1**2*f**2*gd2*r*s + 132*D1**2*f**2*gd2*r + 110*D1**2*f**2*gd2*s**2 - 44*D1**2*f**2*gd2*s - 66*D1**2*f**2*gd2 - 110*D1**2*f**2*gdd2*r**2 - 308*D1**2*f**2*gdd2*r*s + 220*D1**2*f**2*gdd2*r - 198*D1**2*f**2*gdd2*s**2 + 308*D1**2*f**2*gdd2*s - 110*D1**2*f**2*gdd2 - 24*D1**2*f*fd**2*r**2 - 24*D1**2*f*fd**2*r*s + 24*D1**2*f*fd**2*r + 8*D1**2*f*fd**2*s - 4*D1**2*f*fd**2 - 132*D1**2*f*fd*g2*r**2 + 88*D1**2*f*fd*g2*r*s - 44*D1**2*f*fd*g2*r + 220*D1**2*f*fd*g2*s**2 - 220*D1**2*f*fd*g2*s + 110*D1**2*f*fd*g2 - 440*D1**2*f*fd*gd2*r**2 - 1232*D1**2*f*fd*gd2*r*s + 748*D1**2*f*fd*gd2*r - 792*D1**2*f*fd*gd2*s**2 + 1012*D1**2*f*fd*gd2*s - 308*D1**2*f*fd*gd2 - 220*D1**2*f*fdd*g2*r**2 - 616*D1**2*f*fdd*g2*r*s + 308*D1**2*f*fdd*g2*r - 396*D1**2*f*fdd*g2*s**2 + 396*D1**2*f*fdd*g2*s - 198*D1**2*f*fdd*g2 - 220*D1**2*fd**2*g2*r**2 - 616*D1**2*fd**2*g2*r*s + 308*D1**2*fd**2*g2*r - 396*D1**2*fd**2*g2*s**2 + 396*D1**2*fd**2*g2*s + 440*D1*Dd*K*bd1*f**2*r**2 + 1232*D1*Dd*K*bd1*f**2*r*s - 814*D1*Dd*K*bd1*f**2*r + 792*D1*Dd*K*bd1*f**2*s**2 - 1122*D1*Dd*K*bd1*f**2*s + 374*D1*Dd*K*bd1*f**2 - 704*D1*Dd*bd1*f*g2*r**2 - 1408*D1*Dd*bd1*f*g2*r*s + 1584*D1*Dd*bd1*f*g2*r - 704*D1*Dd*bd1*f*g2*s**2 + 1584*D1*Dd*bd1*f*g2*s - 792*D1*Dd*bd1*f*g2 + 32*D1*Dd*f**3*r**2 + 32*D1*Dd*f**3*r*s - 40*D1*Dd*f**3*r - 16*D1*Dd*f**3*s + 16*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 108*D1*Dd*f**2*fd*r + 40*D1*Dd*f**2*fd*s - 28*D1*Dd*f**2*fd - 264*D1*Dd*f**2*g2*r**2 + 176*D1*Dd*f**2*g2*r*s + 220*D1*Dd*f**2*g2*r + 440*D1*Dd*f**2*g2*s**2 - 308*D1*Dd*f**2*g2*s - 22*D1*Dd*f**2*g2 - 880*D1*Dd*f**2*gd2*r**2 - 2464*D1*Dd*f**2*gd2*r*s + 1628*D1*Dd*f**2*gd2*r - 1584*D1*Dd*f**2*gd2*s**2 + 2244*D1*Dd*f**2*gd2*s - 748*D1*Dd*f**2*gd2 - 1760*D1*Dd*f*fd*g2*r**2 - 4928*D1*Dd*f*fd*g2*r*s + 2728*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s**2 + 3608*D1*Dd*f*fd*g2*s - 1012*D1*Dd*f*fd*g2 - 16*D1*Ddd*f**3*r**2 - 16*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r + 8*D1*Ddd*f**3*s - 8*D1*Ddd*f**3 - 440*D1*Ddd*f**2*g2*r**2 - 1232*D1*Ddd*f**2*g2*r*s + 748*D1*Ddd*f**2*g2*r - 792*D1*Ddd*f**2*g2*s**2 + 1012*D1*Ddd*f**2*g2*s - 418*D1*Ddd*f**2*g2 - 44*D1*b2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 22*D1*b2*f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 48*Dd**2*f**3*r**2 - 48*Dd**2*f**3*r*s + 60*Dd**2*f**3*r + 24*Dd**2*f**3*s - 16*Dd**2*f**3 - 1320*Dd**2*f**2*g2*r**2 - 3696*Dd**2*f**2*g2*r*s + 2244*Dd**2*f**2*g2*r - 2376*Dd**2*f**2*g2*s**2 + 3036*Dd**2*f**2*g2*s - 836*Dd**2*f**2*g2 + 22*b1**2*(D1**2*(-2*K*fd*(2*r**2 + r*(4*s + 2) + 2*s**2 + 2*s - 1) + f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-2*r**2 - 2*r*(s - 1) + s) + 2*fd*r*(r + s) + fdd*(K*(2*r**2 + 4*r*s + 2*r + 2*s**2 + 2*s - 1) - r*(r + s))) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(2*K*(8*r**2 + 16*r*s - 2*r + 8*s**2 - 2*s - 3) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 11*b1*(8*D1**2*K*bdd1*f*r**2 + 16*D1**2*K*bdd1*f*r*s - 20*D1**2*K*bdd1*f*r + 8*D1**2*K*bdd1*f*s**2 - 20*D1**2*K*bdd1*f*s + 10*D1**2*K*bdd1*f + 6*D1**2*K*f*fd*r**2 - 4*D1**2*K*f*fd*r*s + 2*D1**2*K*f*fd*r - 10*D1**2*K*f*fd*s**2 + 10*D1**2*K*f*fd*s - 5*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r**2 + 28*D1**2*K*f*fdd*r*s - 14*D1**2*K*f*fdd*r + 18*D1**2*K*f*fdd*s**2 - 18*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r**2 + 28*D1**2*K*fd**2*r*s - 14*D1**2*K*fd**2*r + 18*D1**2*K*fd**2*s**2 - 18*D1**2*K*fd**2*s - 4*D1**2*b2*fd*r**2 - 8*D1**2*b2*fd*r*s - 4*D1**2*b2*fd*s**2 + 2*D1**2*b2*fdd*r**2 + 4*D1**2*b2*fdd*r*s + 2*D1**2*b2*fdd*s**2 - 4*D1**2*bdd1*f**2*r**2 - 4*D1**2*bdd1*f**2*r*s + 6*D1**2*bdd1*f**2*r + 2*D1**2*bdd1*f**2*s - 2*D1**2*bdd1*f**2 - 4*D1**2*bdd1*f*r**2 - 4*D1**2*bdd1*f*r*s + 6*D1**2*bdd1*f*r + 2*D1**2*bdd1*f*s - 2*D1**2*bdd1*f + 2*D1**2*bdd2*f*r**2 + 4*D1**2*bdd2*f*r*s - 4*D1**2*bdd2*f*r + 2*D1**2*bdd2*f*s**2 - 4*D1**2*bdd2*f*s + 2*D1**2*bdd2*f - 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r + 16*D1**2*f*gd2*r**2 + 32*D1**2*f*gd2*r*s - 32*D1**2*f*gd2*r + 16*D1**2*f*gd2*s**2 - 32*D1**2*f*gd2*s + 16*D1**2*f*gd2 - 8*D1**2*f*gdd2*r**2 - 16*D1**2*f*gdd2*r*s + 16*D1**2*f*gdd2*r - 8*D1**2*f*gdd2*s**2 + 16*D1**2*f*gdd2*s - 8*D1**2*f*gdd2 + 16*D1**2*fd*g2*r**2 + 32*D1**2*fd*g2*r*s + 16*D1**2*fd*g2*r + 16*D1**2*fd*g2*s**2 + 16*D1**2*fd*g2*s - 8*D1**2*fd*g2 - 16*D1**2*fd*gd2*r**2 - 32*D1**2*fd*gd2*r*s + 8*D1**2*fd*gd2*r - 16*D1**2*fd*gd2*s**2 + 8*D1**2*fd*gd2*s + 8*D1**2*fd*gd2 - 8*D1**2*fdd*g2*r**2 - 16*D1**2*fdd*g2*r*s - 8*D1**2*fdd*g2*r - 8*D1**2*fdd*g2*s**2 - 8*D1**2*fdd*g2*s + 4*D1**2*fdd*g2 + 12*D1*Dd*K*f**2*r**2 - 8*D1*Dd*K*f**2*r*s - 10*D1*Dd*K*f**2*r - 20*D1*Dd*K*f**2*s**2 + 14*D1*Dd*K*f**2*s + D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r**2 + 224*D1*Dd*K*f*fd*r*s - 124*D1*Dd*K*f*fd*r + 144*D1*Dd*K*f*fd*s**2 - 164*D1*Dd*K*f*fd*s + 46*D1*Dd*K*f*fd - 16*D1*Dd*b2*f*r**2 - 32*D1*Dd*b2*f*r*s + 24*D1*Dd*b2*f*r - 16*D1*Dd*b2*f*s**2 + 24*D1*Dd*b2*f*s - 12*D1*Dd*b2*f + 16*D1*Dd*b2*fd*r**2 + 32*D1*Dd*b2*fd*r*s - 12*D1*Dd*b2*fd*r + 16*D1*Dd*b2*fd*s**2 - 12*D1*Dd*b2*fd*s - 8*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 10*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 64*D1*Dd*f*g2*r**2 + 128*D1*Dd*f*g2*r*s - 96*D1*Dd*f*g2*r + 64*D1*Dd*f*g2*s**2 - 96*D1*Dd*f*g2*s + 48*D1*Dd*f*g2 - 64*D1*Dd*f*gd2*r**2 - 128*D1*Dd*f*gd2*r*s + 112*D1*Dd*f*gd2*r - 64*D1*Dd*f*gd2*s**2 + 112*D1*Dd*f*gd2*s - 48*D1*Dd*f*gd2 - 64*D1*Dd*fd*g2*r**2 - 128*D1*Dd*fd*g2*r*s + 16*D1*Dd*fd*g2*r - 64*D1*Dd*fd*g2*s**2 + 16*D1*Dd*fd*g2*s + 24*D1*Dd*fd*g2 + 20*D1*Ddd*K*f**2*r**2 + 56*D1*Ddd*K*f**2*r*s - 34*D1*Ddd*K*f**2*r + 36*D1*Ddd*K*f**2*s**2 - 46*D1*Ddd*K*f**2*s + 19*D1*Ddd*K*f**2 + 8*D1*Ddd*b2*f*r**2 + 16*D1*Ddd*b2*f*r*s - 12*D1*Ddd*b2*f*r + 8*D1*Ddd*b2*f*s**2 - 12*D1*Ddd*b2*f*s + 6*D1*Ddd*b2*f - 32*D1*Ddd*f*g2*r**2 - 64*D1*Ddd*f*g2*r*s + 48*D1*Ddd*f*g2*r - 32*D1*Ddd*f*g2*s**2 + 48*D1*Ddd*f*g2*s - 24*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(2*K*(4*r**2 + 2*r*(4*s - 5) + 4*s**2 - 10*s + 5) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(2*K*(4*r**2 + 8*r*s - 3*r + 4*s**2 - 3*s - 1) - 4*r**2 - 4*r*s + 3*r + s)) + Dd*f*(K*(32*r**2 + 64*r*(s - 1) + 32*s**2 - 64*s + 30) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 4*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 60*Dd**2*K*f**2*r**2 + 168*Dd**2*K*f**2*r*s - 102*Dd**2*K*f**2*r + 108*Dd**2*K*f**2*s**2 - 138*Dd**2*K*f**2*s + 38*Dd**2*K*f**2 + 24*Dd**2*b2*f*r**2 + 48*Dd**2*b2*f*r*s - 36*Dd**2*b2*f*r + 24*Dd**2*b2*f*s**2 - 36*Dd**2*b2*f*s + 12*Dd**2*b2*f - 96*Dd**2*f*g2*r**2 - 192*Dd**2*f*g2*r*s + 144*Dd**2*f*g2*r - 96*Dd**2*f*g2*s**2 + 144*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(77*d**2*k3**6) + 2*D1**2*Pk2*Pk3*k2**4*st**2*(D1*(14*D1*b2*bd1*f*(r + s - 1)**2 + 2*D1*bd1**2*(r + s - 1)*(35*K*f*(r + s - 1) + f*(4*C - 2)*(r + s) + 28*g2*(r + s)) - 5*D1*bdd1*f*(f*(2*C - 1) + 14*g2)*(r + s - 1)**2 - bd1*(D1*(f**2*(2*C*(9*r**2 + 2*r*(5*s - 7) + s**2 - 6*s + 3) - 11*r**2 - 4*r*(3*s - 4) - s**2 + 6*s - 3) + 2*f*(fd*(10*C - 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*g2*(r**2 + 2*r*(s - 3) + s**2 - 6*s + 3) + 70*gd2*(r + s - 1)**2) + 140*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 10*Dd*f*(f*(2*C - 1) + 14*g2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + 14*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(14*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(-8*C*(r + s - 1)**2 + 7*K*(r**2 + 2*r*(s + 2) + s**2 + 4*s - 2) - 10*r**2 - 2*r*(3*s + 4) + 4*(s - 1)**2) + fdd*(4*C*(r + s - 1)**2 + 35*K*s**2 + r**2*(35*K - 2) + r*(70*K*s - 4*s + 4) - 2*s**2 + 4*s - 2) - 56*gd2*(r + s - 1)**2 + 28*gdd2*(r + s - 1)**2) + D1*(Dd*(f*(-8*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 7*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 40*r**2 - 24*r*s + 46*r + 16*s**2 + 4*s - 16) + 2*fd*(4*r + 4*s - 3)*(4*C*(r + s - 1) + 35*K*s + r*(35*K - 2) - 2*s + 2) - 56*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(112*r + 112*s - 84)) + Ddd*(f*(4*C + 35*K - 2) + 28*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(4*C + 35*K - 2) + 28*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - b1*(-8*C*D1**2*bdd1*f*r**2 - 16*C*D1**2*bdd1*f*r*s + 8*C*D1**2*bdd1*f*r - 8*C*D1**2*bdd1*f*s**2 + 8*C*D1**2*bdd1*f*s - 4*C*D1**2*bdd1*f + 36*C*D1**2*f*fd*r**2 + 40*C*D1**2*f*fd*r*s - 28*C*D1**2*f*fd*r + 4*C*D1**2*f*fd*s**2 - 12*C*D1**2*f*fd*s + 14*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r**2 + 40*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*r + 20*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r**2 + 40*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*r + 20*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s + 72*C*D1*Dd*f**2*r**2 + 80*C*D1*Dd*f**2*r*s - 92*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s**2 - 44*C*D1*Dd*f**2*s + 38*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*r**2 + 320*C*D1*Dd*f*fd*r*s - 200*C*D1*Dd*f*fd*r + 160*C*D1*Dd*f*fd*s**2 - 200*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*r**2 + 80*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 40*C*D1*Ddd*f**2*s**2 - 60*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*r**2 + 240*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 120*C*Dd**2*f**2*s**2 - 180*C*Dd**2*f**2*s + 60*C*Dd**2*f**2 + 28*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 70*D1**2*K*bdd1*f*r**2 - 140*D1**2*K*bdd1*f*r*s + 140*D1**2*K*bdd1*f*r - 70*D1**2*K*bdd1*f*s**2 + 140*D1**2*K*bdd1*f*s - 70*D1**2*K*bdd1*f - 14*D1**2*b2*fd*r**2 - 28*D1**2*b2*fd*r*s - 14*D1**2*b2*fd*s**2 - 14*D1**2*bd2*f*(r + s - 1)**2 + 4*D1**2*bdd1*f*r**2 + 8*D1**2*bdd1*f*r*s - 4*D1**2*bdd1*f*r + 4*D1**2*bdd1*f*s**2 - 4*D1**2*bdd1*f*s + 2*D1**2*bdd1*f - 56*D1**2*bdd1*g2*r**2 - 112*D1**2*bdd1*g2*r*s + 56*D1**2*bdd1*g2*r - 56*D1**2*bdd1*g2*s**2 + 56*D1**2*bdd1*g2*s - 28*D1**2*bdd1*g2 - 22*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 18*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 9*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd + 14*D1**2*f*gd2*r**2 + 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*r + 14*D1**2*f*gd2*s**2 - 28*D1**2*f*gd2*s + 14*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 140*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*r + 70*D1**2*f*gdd2*s**2 - 140*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 14*D1**2*fd*g2*r**2 + 28*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r + 14*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 + 140*D1**2*fd*gd2*r**2 + 280*D1**2*fd*gd2*r*s - 140*D1**2*fd*gd2*r + 140*D1**2*fd*gd2*s**2 - 140*D1**2*fd*gd2*s + 70*D1**2*fdd*g2*r**2 + 140*D1**2*fdd*g2*r*s + 70*D1**2*fdd*g2*s**2 - 56*D1*Dd*b2*f*r**2 - 112*D1*Dd*b2*f*r*s + 84*D1*Dd*b2*f*r - 56*D1*Dd*b2*f*s**2 + 84*D1*Dd*b2*f*s - 42*D1*Dd*b2*f - 44*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 56*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 26*D1*Dd*f**2*s - 23*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 100*D1*Dd*f*fd*s - 30*D1*Dd*f*fd + 56*D1*Dd*f*g2*r**2 + 112*D1*Dd*f*g2*r*s - 84*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s**2 - 84*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 1120*D1*Dd*f*gd2*r*s - 980*D1*Dd*f*gd2*r + 560*D1*Dd*f*gd2*s**2 - 980*D1*Dd*f*gd2*s + 420*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 1120*D1*Dd*fd*g2*r*s - 420*D1*Dd*fd*g2*r + 560*D1*Dd*fd*g2*s**2 - 420*D1*Dd*fd*g2*s - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 560*D1*Ddd*f*g2*r*s - 420*D1*Ddd*f*g2*r + 280*D1*Ddd*f*g2*s**2 - 420*D1*Ddd*f*g2*s + 210*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*K*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) + 10*r**2 + 6*r*s - 17*r - 4*s**2 - 3*s + 5) - 2*fd*(r + s - 1)*(C*(4*r + 4*s - 2) + 35*K*s + r*(35*K - 2) - 2*s + 1) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(C*(4*r + 4*s - 2) + 35*K*(r + s - 1) - 2*r - 2*s + 1) + 14*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 1680*Dd**2*f*g2*r*s - 1260*Dd**2*f*g2*r + 840*Dd**2*f*g2*s**2 - 1260*Dd**2*f*g2*s + 420*Dd**2*f*g2))/(21*d**2*k3**6) + 8*D1**2*Pk2*Pk3*st**4*(D1*s*(D1*bd1**2*f*(2*K*s + f*(2*r - 1) + 2*r - 1) + D1*bdd1*f*s*(b2 - 2*g2) + 2*bd1*(D1*f*s*(bd2 + 2*g2 - 2*gd2) - 2*D1*fd*g2*(s - 1) + 2*Dd*f*g2*(1 - 4*s) + b2*(-D1*f*s + D1*fd*(s - 1) + Dd*f*(4*s - 1)))) + b1**2*(D1*Dd*(f*(K*(-8*s**2 + 4*s - 2) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(2*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(2*s - 1) - s + 1) + fd*(-2*K*(s - 1)**2 + f*s + r*(-2*f*s + f - 2*s + 2)) + fdd*(K*(s - 1)**2 - f*s + r*(2*f*s - f + s - 1))) + Ddd*f*(K*(4*s**2 - 2*s + 1) + (f + 1)*(r*(4*s - 1) - 2*s))) + Dd**2*f*(12*K*s**2 - 6*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(2*D1**2*K*bdd1*f*s**2 - 2*D1**2*bd2*f*s**2 + 2*D1**2*bd2*fd*s**2 - 2*D1**2*bd2*fd*s + 2*D1**2*bdd1*f**2*r*s - D1**2*bdd1*f**2*s + 2*D1**2*bdd1*f*r*s - D1**2*bdd1*f*s + D1**2*bdd2*f*s**2 + 4*D1**2*f*gd2*s**2 - 2*D1**2*f*gdd2*s**2 + 4*D1**2*fd*g2*s**2 - 8*D1**2*fd*g2*s + 4*D1**2*fd*g2 - 4*D1**2*fd*gd2*s**2 + 4*D1**2*fd*gd2*s - 2*D1**2*fdd*g2*s**2 + 4*D1**2*fdd*g2*s - 2*D1**2*fdd*g2 + 8*D1*Dd*bd2*f*s**2 - 2*D1*Dd*bd2*f*s + 16*D1*Dd*f*g2*s**2 - 8*D1*Dd*f*g2*s + 4*D1*Dd*f*g2 - 16*D1*Dd*f*gd2*s**2 + 4*D1*Dd*f*gd2*s - 16*D1*Dd*fd*g2*s**2 + 20*D1*Dd*fd*g2*s - 4*D1*Dd*fd*g2 - 8*D1*Ddd*f*g2*s**2 + 4*D1*Ddd*f*g2*s - 2*D1*Ddd*f*g2 + D1*bd1*(D1*(f*s*(-4*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(4*K*s - 1))) + Dd*f*(16*K*s**2 - 4*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) - 24*Dd**2*f*g2*s**2 + 12*Dd**2*f*g2*s + b2*(-D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(-4*s**2 + 2*s - 1) + fd*(4*s**2 - 5*s + 1)) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1))))/(7*d**2*k2**2) - D1**2*Pk2*Pk3*st**2*(D1*(D1*bd1**2*f*(r*(s*(42*f + 46) - 2) + 7*s*(10*K*s - 3*f - 3)) + D1*bdd1*f*s*(-3*f*r + f*s*(5 - 10*C) + s*(35*b2 - 70*g2)) + bd1*(D1*(f**2*s*(5*r + s*(14*C - 7)) + f*(fd*r*(3 - 12*s) + fd*s*(C*(20 - 40*s) + 20*s - 7) + s**2*(-49*b2 + 70*bd2 + 98*g2 - 140*gd2)) + 70*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(f*r*(3 - 24*s) + 4*f*s*(C*(5 - 20*s) + 10*s - 1) + s*(70*b2 - 140*g2)*(4*s - 1)))) - 14*b1**3*(D1*Dd*(fd*(8*r*s - r - 6*s + 1) - (f + 2)*(4*r*s - r - 2*s)) + D1*(-D1*s*(fd - fdd)*(r - 1) + Ddd*(f + 1)*(4*r*s - r - 2*s)) + Dd**2*(f + 1)*(3*r*(4*s - 1) - 6*s + 2)) + b1**2*(D1*Dd*(f*(-49*K*(4*s**2 - 2*s + 1) - (21*f + 39)*(r*(4*s - 1) - 2*s)) + fd*(70*K*(4*s**2 - 5*s + 1) + 21*f*(2*r - 1)*(8*s - 3) + 184*r*s - 107*r - 54*s + 44)) + 14*D1*bd1*(-D1*fd*(r*(6*s - 1) - 4*s + 1) + D1*(f + 2)*(r*(3*s - 1) - s) - Dd*(f + 1)*(r*(24*s - 7) - 10*s + 3)) + D1*(D1*(-14*bdd1*(f + 1)*(r*(3*s - 1) - s) + 21*fd**2*(r*(2*s - 1) - s + 1) + fd*(-49*K*(s - 1)**2 + r*(-42*f*s + 21*f - 39*s + 35) + s*(21*f + 4)) + fdd*(35*K*(s - 1)**2 + r*(42*f*s - 21*f + 23*s - 21) - s*(21*f + 2))) + Ddd*f*(35*K*(4*s**2 - 2*s + 1) + (21*f + 23)*(r*(4*s - 1) - 2*s))) + Dd**2*f*(420*K*s**2 - 210*K*s + 21*f*(3*r*(4*s - 1) - 6*s + 2) + 69*r*(4*s - 1) - 138*s + 46)) + b1*(28*C*D1**2*f*fd*s**2 - 28*C*D1**2*f*fd*s + 14*C*D1**2*f*fd - 20*C*D1**2*f*fdd*s**2 + 20*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd - 20*C*D1**2*fd**2*s**2 + 20*C*D1**2*fd**2*s + 56*C*D1*Dd*f**2*s**2 - 28*C*D1*Dd*f**2*s + 14*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*s**2 + 120*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*s**2 + 20*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*s**2 + 60*C*Dd**2*f**2*s + 70*D1**2*K*bdd1*f*s**2 - 14*D1**2*bd1**2*(f + 1)*(r*(6*s - 2) - 2*s + 1) - 49*D1**2*bd2*f*s**2 + 70*D1**2*bd2*fd*s**2 - 70*D1**2*bd2*fd*s + 42*D1**2*bdd1*f**2*r*s - 21*D1**2*bdd1*f**2*s + 46*D1**2*bdd1*f*r*s - 2*D1**2*bdd1*f*r - 21*D1**2*bdd1*f*s + 35*D1**2*bdd2*f*s**2 + 10*D1**2*f*fd*r*s - 5*D1**2*f*fd*r - 14*D1**2*f*fd*s**2 + 9*D1**2*f*fd*s - 7*D1**2*f*fd - 6*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 7*D1**2*f*fdd*s + 5*D1**2*f*fdd + 98*D1**2*f*gd2*s**2 - 70*D1**2*f*gdd2*s**2 - 6*D1**2*fd**2*r*s + 3*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 7*D1**2*fd**2*s - 3*D1**2*fd**2 + 98*D1**2*fd*g2*s**2 - 196*D1**2*fd*g2*s + 98*D1**2*fd*g2 - 140*D1**2*fd*gd2*s**2 + 140*D1**2*fd*gd2*s - 70*D1**2*fdd*g2*s**2 + 140*D1**2*fdd*g2*s - 70*D1**2*fdd*g2 + 280*D1*Dd*bd2*f*s**2 - 70*D1*Dd*bd2*f*s + 20*D1*Dd*f**2*r*s - 5*D1*Dd*f**2*r - 28*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - 7*D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 36*D1*Dd*f*fd*s + D1*Dd*f*fd + 392*D1*Dd*f*g2*s**2 - 196*D1*Dd*f*g2*s + 98*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*s**2 + 140*D1*Dd*f*gd2*s - 560*D1*Dd*fd*g2*s**2 + 700*D1*Dd*fd*g2*s - 140*D1*Dd*fd*g2 - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 4*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*s**2 + 140*D1*Ddd*f*g2*s - 70*D1*Ddd*f*g2 + D1*bd1*(D1*(f*(r*(-s*(42*f + 78) + 4) + 7*s*(-14*K*s + 3*f + 5)) + fd*(140*K*s**2 - 140*K*s + 21*f*(2*r - 1)*(4*s - 1) + 92*r*s - 44*r - 25*s + 23)) + Dd*f*(560*K*s**2 - 140*K*s + 21*f*(2*r - 1)*(8*s - 1) + 368*r*s - 54*r - 176*s + 25)) - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 12*Dd**2*f**2*s - 6*Dd**2*f**2 - 840*Dd**2*f*g2*s**2 + 420*Dd**2*f*g2*s - 7*b2*(D1**2*(7*fd - 5*fdd)*(s - 1)**2 + D1*(7*Dd*f*(4*s**2 - 2*s + 1) - 10*Dd*fd*(4*s**2 - 5*s + 1) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f*s*(1 - 2*s))))/(21*d**2*k2**2) - 2*D1**2*Pk2*Pk3*(D1*f*(9*D1*bd1**2*r*(1 - 2*s) + 7*D1*bdd1*f*s**2*(2*C - 1) - 7*bd1*s*(2*C - 1)*(D1*f*s + D1*fd*(2 - 4*s) + Dd*f*(2 - 8*s))) + b1**2*(D1*Dd*(11*f*(4*r*s - r - 2*s) - 9*fd*(8*r*s - r - 6*s + 1)) + D1*(D1*s*(11*fd - 9*fdd)*(r - 1) + 9*Ddd*f*(-4*r*s + r + 2*s)) - 9*Dd**2*f*(3*r*(4*s - 1) - 6*s + 2)) + b1*(D1**2*(f*(9*bdd1*r*(1 - 2*s) - fd*(14*C - 7)*(2*s**2 - 2*s + 1) + fdd*(14*C - 7)*(2*s**2 - 2*s + 1)) + fd**2*s*(28*C - 14)*(s - 1)) + D1*bd1*(D1*(11*f*r*(2*s - 1) - 9*fd*(4*r*s - r - 2*s + 1)) - 18*Dd*f*(r*(8*s - 3) - 2*s + 1)) - D1*f*(14*C - 7)*(Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(8*s**2 - 6*s + 1) + Ddd*f*(-4*s**2 + 2*s - 1)) + Dd**2*f**2*s*(84*C - 42)*(2*s - 1)))/(21*d**2*k2**2) + 5*D1**2*Pk2*Pkd3*ct**8*k1**2*k2**4*(4368*C*D1**2*f**2*fd*r**2 + 8736*C*D1**2*f**2*fd*r*s - 5824*C*D1**2*f**2*fd*r + 4368*C*D1**2*f**2*fd*s**2 - 5824*C*D1**2*f**2*fd*s + 2912*C*D1**2*f**2*fd - 2184*C*D1**2*f**2*fdd*r**2 - 4368*C*D1**2*f**2*fdd*r*s + 2912*C*D1**2*f**2*fdd*r - 2184*C*D1**2*f**2*fdd*s**2 + 2912*C*D1**2*f**2*fdd*s - 1456*C*D1**2*f**2*fdd - 4368*C*D1**2*f*fd**2*r**2 - 8736*C*D1**2*f*fd**2*r*s + 5824*C*D1**2*f*fd**2*r - 4368*C*D1**2*f*fd**2*s**2 + 5824*C*D1**2*f*fd**2*s - 1456*C*D1**2*f*fd**2 + 5824*C*D1*Dd*f**3*r**2 + 11648*C*D1*Dd*f**3*r*s - 8736*C*D1*Dd*f**3*r + 5824*C*D1*Dd*f**3*s**2 - 8736*C*D1*Dd*f**3*s + 4368*C*D1*Dd*f**3 - 17472*C*D1*Dd*f**2*fd*r**2 - 34944*C*D1*Dd*f**2*fd*r*s + 24752*C*D1*Dd*f**2*fd*r - 17472*C*D1*Dd*f**2*fd*s**2 + 24752*C*D1*Dd*f**2*fd*s - 8736*C*D1*Dd*f**2*fd - 2912*C*D1*Ddd*f**3*r**2 - 5824*C*D1*Ddd*f**3*r*s + 4368*C*D1*Ddd*f**3*r - 2912*C*D1*Ddd*f**3*s**2 + 4368*C*D1*Ddd*f**3*s - 2184*C*D1*Ddd*f**3 - 8736*C*Dd**2*f**3*r**2 - 17472*C*Dd**2*f**3*r*s + 13104*C*Dd**2*f**3*r - 8736*C*Dd**2*f**3*s**2 + 13104*C*Dd**2*f**3*s - 4368*C*Dd**2*f**3 + 1716*D1**2*K*b1*f*fd*r**2 + 3432*D1**2*K*b1*f*fd*r*s - 1716*D1**2*K*b1*f*fd*r + 1716*D1**2*K*b1*f*fd*s**2 - 1716*D1**2*K*b1*f*fd*s + 858*D1**2*K*b1*f*fd - 858*D1**2*K*b1*f*fdd*r**2 - 1716*D1**2*K*b1*f*fdd*r*s + 858*D1**2*K*b1*f*fdd*r - 858*D1**2*K*b1*f*fdd*s**2 + 858*D1**2*K*b1*f*fdd*s - 429*D1**2*K*b1*f*fdd - 858*D1**2*K*b1*fd**2*r**2 - 1716*D1**2*K*b1*fd**2*r*s + 858*D1**2*K*b1*fd**2*r - 858*D1**2*K*b1*fd**2*s**2 + 858*D1**2*K*b1*fd**2*s - 1716*D1**2*b1*f*fd*r**2 - 3432*D1**2*b1*f*fd*r*s + 1716*D1**2*b1*f*fd*r - 1716*D1**2*b1*f*fd*s**2 + 1716*D1**2*b1*f*fd*s - 858*D1**2*b1*f*fd + 858*D1**2*b1*f*fdd*r**2 + 1716*D1**2*b1*f*fdd*r*s - 858*D1**2*b1*f*fdd*r + 858*D1**2*b1*f*fdd*s**2 - 858*D1**2*b1*f*fdd*s + 429*D1**2*b1*f*fdd + 858*D1**2*b1*fd**2*r**2 + 1716*D1**2*b1*fd**2*r*s - 858*D1**2*b1*fd**2*r + 858*D1**2*b1*fd**2*s**2 - 858*D1**2*b1*fd**2*s - 429*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 2520*D1**2*f**3*fd*r**2 + 5040*D1**2*f**3*fd*r*s - 3780*D1**2*f**3*fd*r + 2520*D1**2*f**3*fd*s**2 - 3780*D1**2*f**3*fd*s + 1890*D1**2*f**3*fd - 1260*D1**2*f**3*fdd*r**2 - 2520*D1**2*f**3*fdd*r*s + 1890*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s**2 + 1890*D1**2*f**3*fdd*s - 945*D1**2*f**3*fdd - 3780*D1**2*f**2*fd**2*r**2 - 7560*D1**2*f**2*fd**2*r*s + 5670*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s**2 + 5670*D1**2*f**2*fd**2*s - 1890*D1**2*f**2*fd**2 - 4368*D1**2*f**2*fd*r**2 - 8736*D1**2*f**2*fd*r*s + 5824*D1**2*f**2*fd*r - 4368*D1**2*f**2*fd*s**2 + 5824*D1**2*f**2*fd*s - 2912*D1**2*f**2*fd + 2184*D1**2*f**2*fdd*r**2 + 4368*D1**2*f**2*fdd*r*s - 2912*D1**2*f**2*fdd*r + 2184*D1**2*f**2*fdd*s**2 - 2912*D1**2*f**2*fdd*s + 1456*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 858*D1**2*f**2*gdd2*r**2 + 1716*D1**2*f**2*gdd2*r*s - 1716*D1**2*f**2*gdd2*r + 858*D1**2*f**2*gdd2*s**2 - 1716*D1**2*f**2*gdd2*s + 858*D1**2*f**2*gdd2 + 4368*D1**2*f*fd**2*r**2 + 8736*D1**2*f*fd**2*r*s - 5824*D1**2*f*fd**2*r + 4368*D1**2*f*fd**2*s**2 - 5824*D1**2*f*fd**2*s + 1456*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r**2 + 6864*D1**2*f*fd*gd2*r*s - 5148*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1716*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r**2 + 3432*D1**2*f*fdd*g2*r*s - 1716*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r**2 + 3432*D1**2*fd**2*g2*r*s - 1716*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 3432*D1*Dd*K*b1*f**2*r**2 + 6864*D1*Dd*K*b1*f**2*r*s - 5148*D1*Dd*K*b1*f**2*r + 3432*D1*Dd*K*b1*f**2*s**2 - 5148*D1*Dd*K*b1*f**2*s + 2574*D1*Dd*K*b1*f**2 - 6864*D1*Dd*K*b1*f*fd*r**2 - 13728*D1*Dd*K*b1*f*fd*r*s + 8580*D1*Dd*K*b1*f*fd*r - 6864*D1*Dd*K*b1*f*fd*s**2 + 8580*D1*Dd*K*b1*f*fd*s - 2574*D1*Dd*K*b1*f*fd - 3432*D1*Dd*b1*f**2*r**2 - 6864*D1*Dd*b1*f**2*r*s + 5148*D1*Dd*b1*f**2*r - 3432*D1*Dd*b1*f**2*s**2 + 5148*D1*Dd*b1*f**2*s - 2574*D1*Dd*b1*f**2 + 6864*D1*Dd*b1*f*fd*r**2 + 13728*D1*Dd*b1*f*fd*r*s - 8580*D1*Dd*b1*f*fd*r + 6864*D1*Dd*b1*f*fd*s**2 - 8580*D1*Dd*b1*f*fd*s + 2574*D1*Dd*b1*f*fd + 2520*D1*Dd*f**4*r**2 + 5040*D1*Dd*f**4*r*s - 3780*D1*Dd*f**4*r + 2520*D1*Dd*f**4*s**2 - 3780*D1*Dd*f**4*s + 1890*D1*Dd*f**4 - 10080*D1*Dd*f**3*fd*r**2 - 20160*D1*Dd*f**3*fd*r*s + 15120*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s**2 + 15120*D1*Dd*f**3*fd*s - 5670*D1*Dd*f**3*fd - 5824*D1*Dd*f**3*r**2 - 11648*D1*Dd*f**3*r*s + 8736*D1*Dd*f**3*r - 5824*D1*Dd*f**3*s**2 + 8736*D1*Dd*f**3*s - 4368*D1*Dd*f**3 + 17472*D1*Dd*f**2*fd*r**2 + 34944*D1*Dd*f**2*fd*r*s - 24752*D1*Dd*f**2*fd*r + 17472*D1*Dd*f**2*fd*s**2 - 24752*D1*Dd*f**2*fd*s + 8736*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r**2 + 13728*D1*Dd*f**2*gd2*r*s - 12012*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 12012*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r**2 + 27456*D1*Dd*f*fd*g2*r*s - 17160*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 17160*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 - 1716*D1*Ddd*K*b1*f**2*r**2 - 3432*D1*Ddd*K*b1*f**2*r*s + 2574*D1*Ddd*K*b1*f**2*r - 1716*D1*Ddd*K*b1*f**2*s**2 + 2574*D1*Ddd*K*b1*f**2*s - 1287*D1*Ddd*K*b1*f**2 + 1716*D1*Ddd*b1*f**2*r**2 + 3432*D1*Ddd*b1*f**2*r*s - 2574*D1*Ddd*b1*f**2*r + 1716*D1*Ddd*b1*f**2*s**2 - 2574*D1*Ddd*b1*f**2*s + 1287*D1*Ddd*b1*f**2 - 1260*D1*Ddd*f**4*r**2 - 2520*D1*Ddd*f**4*r*s + 1890*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s**2 + 1890*D1*Ddd*f**4*s - 945*D1*Ddd*f**4 + 2912*D1*Ddd*f**3*r**2 + 5824*D1*Ddd*f**3*r*s - 4368*D1*Ddd*f**3*r + 2912*D1*Ddd*f**3*s**2 - 4368*D1*Ddd*f**3*s + 2184*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r**2 + 6864*D1*Ddd*f**2*g2*r*s - 5148*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 5148*Dd**2*K*b1*f**2*r**2 - 10296*Dd**2*K*b1*f**2*r*s + 7722*Dd**2*K*b1*f**2*r - 5148*Dd**2*K*b1*f**2*s**2 + 7722*Dd**2*K*b1*f**2*s - 2574*Dd**2*K*b1*f**2 + 5148*Dd**2*b1*f**2*r**2 + 10296*Dd**2*b1*f**2*r*s - 7722*Dd**2*b1*f**2*r + 5148*Dd**2*b1*f**2*s**2 - 7722*Dd**2*b1*f**2*s + 2574*Dd**2*b1*f**2 - 3780*Dd**2*f**4*r**2 - 7560*Dd**2*f**4*r*s + 5670*Dd**2*f**4*r - 3780*Dd**2*f**4*s**2 + 5670*Dd**2*f**4*s - 1890*Dd**2*f**4 + 8736*Dd**2*f**3*r**2 + 17472*Dd**2*f**3*r*s - 13104*Dd**2*f**3*r + 8736*Dd**2*f**3*s**2 - 13104*Dd**2*f**3*s + 4368*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r**2 + 20592*Dd**2*f**2*g2*r*s - 15444*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2)/(1001*d**2*k3**7) + 40*D1**2*Pk2*Pkd3*ct**8*k1**2*k2**2*(4368*C*D1**2*f**2*fd*r*s - 1456*C*D1**2*f**2*fd*r + 4368*C*D1**2*f**2*fd*s**2 - 4368*C*D1**2*f**2*fd*s + 1456*C*D1**2*f**2*fd - 2184*C*D1**2*f**2*fdd*r*s + 728*C*D1**2*f**2*fdd*r - 2184*C*D1**2*f**2*fdd*s**2 + 2184*C*D1**2*f**2*fdd*s - 728*C*D1**2*f**2*fdd - 4368*C*D1**2*f*fd**2*r*s + 1456*C*D1**2*f*fd**2*r - 4368*C*D1**2*f*fd**2*s**2 + 4368*C*D1**2*f*fd**2*s - 728*C*D1**2*f*fd**2 + 5824*C*D1*Dd*f**3*r*s - 1456*C*D1*Dd*f**3*r + 5824*C*D1*Dd*f**3*s**2 - 5824*C*D1*Dd*f**3*s + 1456*C*D1*Dd*f**3 - 17472*C*D1*Dd*f**2*fd*r*s + 5096*C*D1*Dd*f**2*fd*r - 17472*C*D1*Dd*f**2*fd*s**2 + 17472*C*D1*Dd*f**2*fd*s - 3640*C*D1*Dd*f**2*fd - 2912*C*D1*Ddd*f**3*r*s + 728*C*D1*Ddd*f**3*r - 2912*C*D1*Ddd*f**3*s**2 + 2912*C*D1*Ddd*f**3*s - 728*C*D1*Ddd*f**3 - 8736*C*Dd**2*f**3*r*s + 2184*C*Dd**2*f**3*r - 8736*C*Dd**2*f**3*s**2 + 8736*C*Dd**2*f**3*s - 1456*C*Dd**2*f**3 - 429*D1**2*K*bdd1*f**2*r*s - 429*D1**2*K*bdd1*f**2*s**2 + 429*D1**2*K*bdd1*f**2*s + 429*D1**2*bdd1*f**2*r*s + 429*D1**2*bdd1*f**2*s**2 - 429*D1**2*bdd1*f**2*s + 2520*D1**2*f**3*fd*r*s - 630*D1**2*f**3*fd*r + 2520*D1**2*f**3*fd*s**2 - 2520*D1**2*f**3*fd*s + 630*D1**2*f**3*fd - 1260*D1**2*f**3*fdd*r*s + 315*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s**2 + 1260*D1**2*f**3*fdd*s - 315*D1**2*f**3*fdd - 3780*D1**2*f**2*fd**2*r*s + 945*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s**2 + 3780*D1**2*f**2*fd**2*s - 630*D1**2*f**2*fd**2 - 4368*D1**2*f**2*fd*r*s + 1456*D1**2*f**2*fd*r - 4368*D1**2*f**2*fd*s**2 + 4368*D1**2*f**2*fd*s - 1456*D1**2*f**2*fd + 2184*D1**2*f**2*fdd*r*s - 728*D1**2*f**2*fdd*r + 2184*D1**2*f**2*fdd*s**2 - 2184*D1**2*f**2*fdd*s + 728*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r*s - 1716*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s + 858*D1**2*f**2*gdd2*r*s + 858*D1**2*f**2*gdd2*s**2 - 858*D1**2*f**2*gdd2*s + 4368*D1**2*f*fd**2*r*s - 1456*D1**2*f*fd**2*r + 4368*D1**2*f*fd**2*s**2 - 4368*D1**2*f*fd**2*s + 728*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r*s - 858*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 3432*D1**2*f*fd*gd2*s + 858*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r*s - 858*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r*s - 858*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 2520*D1*Dd*f**4*r*s - 630*D1*Dd*f**4*r + 2520*D1*Dd*f**4*s**2 - 2520*D1*Dd*f**4*s + 630*D1*Dd*f**4 - 10080*D1*Dd*f**3*fd*r*s + 2520*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s**2 + 10080*D1*Dd*f**3*fd*s - 1890*D1*Dd*f**3*fd - 5824*D1*Dd*f**3*r*s + 1456*D1*Dd*f**3*r - 5824*D1*Dd*f**3*s**2 + 5824*D1*Dd*f**3*s - 1456*D1*Dd*f**3 + 17472*D1*Dd*f**2*fd*r*s - 5096*D1*Dd*f**2*fd*r + 17472*D1*Dd*f**2*fd*s**2 - 17472*D1*Dd*f**2*fd*s + 3640*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r*s + 1716*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 6864*D1*Dd*f**2*g2*s - 1716*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r*s - 858*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 6864*D1*Dd*f**2*gd2*s + 858*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r*s - 5148*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 13728*D1*Dd*f*fd*g2*s + 3432*D1*Dd*f*fd*g2 - 1260*D1*Ddd*f**4*r*s + 315*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s**2 + 1260*D1*Ddd*f**4*s - 315*D1*Ddd*f**4 + 2912*D1*Ddd*f**3*r*s - 728*D1*Ddd*f**3*r + 2912*D1*Ddd*f**3*s**2 - 2912*D1*Ddd*f**3*s + 728*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r*s - 858*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 3432*D1*Ddd*f**2*g2*s + 858*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 3780*Dd**2*f**4*r*s + 945*Dd**2*f**4*r - 3780*Dd**2*f**4*s**2 + 3780*Dd**2*f**4*s - 630*Dd**2*f**4 + 8736*Dd**2*f**3*r*s - 2184*Dd**2*f**3*r + 8736*Dd**2*f**3*s**2 - 8736*Dd**2*f**3*s + 1456*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r*s - 2574*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 10296*Dd**2*f**2*g2*s + 1716*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**7*k1**3*k2**3*(61620*C*D1**2*f**2*fd*r**2 + 123240*C*D1**2*f**2*fd*r*s - 82160*C*D1**2*f**2*fd*r + 61620*C*D1**2*f**2*fd*s**2 - 82160*C*D1**2*f**2*fd*s + 41080*C*D1**2*f**2*fd - 43680*C*D1**2*f**2*fdd*r**2 - 87360*C*D1**2*f**2*fdd*r*s + 58240*C*D1**2*f**2*fdd*r - 43680*C*D1**2*f**2*fdd*s**2 + 58240*C*D1**2*f**2*fdd*s - 29120*C*D1**2*f**2*fdd - 87360*C*D1**2*f*fd**2*r**2 - 174720*C*D1**2*f*fd**2*r*s + 116480*C*D1**2*f*fd**2*r - 87360*C*D1**2*f*fd**2*s**2 + 116480*C*D1**2*f*fd**2*s - 29120*C*D1**2*f*fd**2 + 82160*C*D1*Dd*f**3*r**2 + 164320*C*D1*Dd*f**3*r*s - 123240*C*D1*Dd*f**3*r + 82160*C*D1*Dd*f**3*s**2 - 123240*C*D1*Dd*f**3*s + 61620*C*D1*Dd*f**3 - 349440*C*D1*Dd*f**2*fd*r**2 - 698880*C*D1*Dd*f**2*fd*r*s + 495040*C*D1*Dd*f**2*fd*r - 349440*C*D1*Dd*f**2*fd*s**2 + 495040*C*D1*Dd*f**2*fd*s - 174720*C*D1*Dd*f**2*fd - 58240*C*D1*Ddd*f**3*r**2 - 116480*C*D1*Ddd*f**3*r*s + 87360*C*D1*Ddd*f**3*r - 58240*C*D1*Ddd*f**3*s**2 + 87360*C*D1*Ddd*f**3*s - 43680*C*D1*Ddd*f**3 - 174720*C*Dd**2*f**3*r**2 - 349440*C*Dd**2*f**3*r*s + 262080*C*Dd**2*f**3*r - 174720*C*Dd**2*f**3*s**2 + 262080*C*Dd**2*f**3*s - 87360*C*Dd**2*f**3 + 24024*D1**2*K*b1*f*fd*r**2 + 48048*D1**2*K*b1*f*fd*r*s - 24024*D1**2*K*b1*f*fd*r + 24024*D1**2*K*b1*f*fd*s**2 - 24024*D1**2*K*b1*f*fd*s + 12012*D1**2*K*b1*f*fd - 17160*D1**2*K*b1*f*fdd*r**2 - 34320*D1**2*K*b1*f*fdd*r*s + 17160*D1**2*K*b1*f*fdd*r - 17160*D1**2*K*b1*f*fdd*s**2 + 17160*D1**2*K*b1*f*fdd*s - 8580*D1**2*K*b1*f*fdd - 17160*D1**2*K*b1*fd**2*r**2 - 34320*D1**2*K*b1*fd**2*r*s + 17160*D1**2*K*b1*fd**2*r - 17160*D1**2*K*b1*fd**2*s**2 + 17160*D1**2*K*b1*fd**2*s - 24024*D1**2*b1*f*fd*r**2 - 48048*D1**2*b1*f*fd*r*s + 24024*D1**2*b1*f*fd*r - 24024*D1**2*b1*f*fd*s**2 + 24024*D1**2*b1*f*fd*s - 12012*D1**2*b1*f*fd + 17160*D1**2*b1*f*fdd*r**2 + 34320*D1**2*b1*f*fdd*r*s - 17160*D1**2*b1*f*fdd*r + 17160*D1**2*b1*f*fdd*s**2 - 17160*D1**2*b1*f*fdd*s + 8580*D1**2*b1*f*fdd + 17160*D1**2*b1*fd**2*r**2 + 34320*D1**2*b1*fd**2*r*s - 17160*D1**2*b1*fd**2*r + 17160*D1**2*b1*fd**2*s**2 - 17160*D1**2*b1*fd**2*s - 8580*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 48440*D1**2*f**3*fd*r**2 + 96880*D1**2*f**3*fd*r*s - 72660*D1**2*f**3*fd*r + 48440*D1**2*f**3*fd*s**2 - 72660*D1**2*f**3*fd*s + 36330*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 - 61620*D1**2*f**2*fd*r**2 - 123240*D1**2*f**2*fd*r*s + 82160*D1**2*f**2*fd*r - 61620*D1**2*f**2*fd*s**2 + 82160*D1**2*f**2*fd*s - 41080*D1**2*f**2*fd + 43680*D1**2*f**2*fdd*r**2 + 87360*D1**2*f**2*fdd*r*s - 58240*D1**2*f**2*fdd*r + 43680*D1**2*f**2*fdd*s**2 - 58240*D1**2*f**2*fdd*s + 29120*D1**2*f**2*fdd - 24024*D1**2*f**2*gd2*r**2 - 48048*D1**2*f**2*gd2*r*s + 48048*D1**2*f**2*gd2*r - 24024*D1**2*f**2*gd2*s**2 + 48048*D1**2*f**2*gd2*s - 24024*D1**2*f**2*gd2 + 17160*D1**2*f**2*gdd2*r**2 + 34320*D1**2*f**2*gdd2*r*s - 34320*D1**2*f**2*gdd2*r + 17160*D1**2*f**2*gdd2*s**2 - 34320*D1**2*f**2*gdd2*s + 17160*D1**2*f**2*gdd2 + 87360*D1**2*f*fd**2*r**2 + 174720*D1**2*f*fd**2*r*s - 116480*D1**2*f*fd**2*r + 87360*D1**2*f*fd**2*s**2 - 116480*D1**2*f*fd**2*s + 29120*D1**2*f*fd**2 - 48048*D1**2*f*fd*g2*r**2 - 96096*D1**2*f*fd*g2*r*s + 48048*D1**2*f*fd*g2*r - 48048*D1**2*f*fd*g2*s**2 + 48048*D1**2*f*fd*g2*s - 24024*D1**2*f*fd*g2 + 68640*D1**2*f*fd*gd2*r**2 + 137280*D1**2*f*fd*gd2*r*s - 102960*D1**2*f*fd*gd2*r + 68640*D1**2*f*fd*gd2*s**2 - 102960*D1**2*f*fd*gd2*s + 34320*D1**2*f*fd*gd2 + 34320*D1**2*f*fdd*g2*r**2 + 68640*D1**2*f*fdd*g2*r*s - 34320*D1**2*f*fdd*g2*r + 34320*D1**2*f*fdd*g2*s**2 - 34320*D1**2*f*fdd*g2*s + 17160*D1**2*f*fdd*g2 + 34320*D1**2*fd**2*g2*r**2 + 68640*D1**2*fd**2*g2*r*s - 34320*D1**2*fd**2*g2*r + 34320*D1**2*fd**2*g2*s**2 - 34320*D1**2*fd**2*g2*s + 48048*D1*Dd*K*b1*f**2*r**2 + 96096*D1*Dd*K*b1*f**2*r*s - 72072*D1*Dd*K*b1*f**2*r + 48048*D1*Dd*K*b1*f**2*s**2 - 72072*D1*Dd*K*b1*f**2*s + 36036*D1*Dd*K*b1*f**2 - 137280*D1*Dd*K*b1*f*fd*r**2 - 274560*D1*Dd*K*b1*f*fd*r*s + 171600*D1*Dd*K*b1*f*fd*r - 137280*D1*Dd*K*b1*f*fd*s**2 + 171600*D1*Dd*K*b1*f*fd*s - 51480*D1*Dd*K*b1*f*fd - 48048*D1*Dd*b1*f**2*r**2 - 96096*D1*Dd*b1*f**2*r*s + 72072*D1*Dd*b1*f**2*r - 48048*D1*Dd*b1*f**2*s**2 + 72072*D1*Dd*b1*f**2*s - 36036*D1*Dd*b1*f**2 + 137280*D1*Dd*b1*f*fd*r**2 + 274560*D1*Dd*b1*f*fd*r*s - 171600*D1*Dd*b1*f*fd*r + 137280*D1*Dd*b1*f*fd*s**2 - 171600*D1*Dd*b1*f*fd*s + 51480*D1*Dd*b1*f*fd + 48440*D1*Dd*f**4*r**2 + 96880*D1*Dd*f**4*r*s - 72660*D1*Dd*f**4*r + 48440*D1*Dd*f**4*s**2 - 72660*D1*Dd*f**4*s + 36330*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd - 82160*D1*Dd*f**3*r**2 - 164320*D1*Dd*f**3*r*s + 123240*D1*Dd*f**3*r - 82160*D1*Dd*f**3*s**2 + 123240*D1*Dd*f**3*s - 61620*D1*Dd*f**3 + 349440*D1*Dd*f**2*fd*r**2 + 698880*D1*Dd*f**2*fd*r*s - 495040*D1*Dd*f**2*fd*r + 349440*D1*Dd*f**2*fd*s**2 - 495040*D1*Dd*f**2*fd*s + 174720*D1*Dd*f**2*fd - 96096*D1*Dd*f**2*g2*r**2 - 192192*D1*Dd*f**2*g2*r*s + 144144*D1*Dd*f**2*g2*r - 96096*D1*Dd*f**2*g2*s**2 + 144144*D1*Dd*f**2*g2*s - 72072*D1*Dd*f**2*g2 + 137280*D1*Dd*f**2*gd2*r**2 + 274560*D1*Dd*f**2*gd2*r*s - 240240*D1*Dd*f**2*gd2*r + 137280*D1*Dd*f**2*gd2*s**2 - 240240*D1*Dd*f**2*gd2*s + 102960*D1*Dd*f**2*gd2 + 274560*D1*Dd*f*fd*g2*r**2 + 549120*D1*Dd*f*fd*g2*r*s - 343200*D1*Dd*f*fd*g2*r + 274560*D1*Dd*f*fd*g2*s**2 - 343200*D1*Dd*f*fd*g2*s + 102960*D1*Dd*f*fd*g2 - 34320*D1*Ddd*K*b1*f**2*r**2 - 68640*D1*Ddd*K*b1*f**2*r*s + 51480*D1*Ddd*K*b1*f**2*r - 34320*D1*Ddd*K*b1*f**2*s**2 + 51480*D1*Ddd*K*b1*f**2*s - 25740*D1*Ddd*K*b1*f**2 + 34320*D1*Ddd*b1*f**2*r**2 + 68640*D1*Ddd*b1*f**2*r*s - 51480*D1*Ddd*b1*f**2*r + 34320*D1*Ddd*b1*f**2*s**2 - 51480*D1*Ddd*b1*f**2*s + 25740*D1*Ddd*b1*f**2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 58240*D1*Ddd*f**3*r**2 + 116480*D1*Ddd*f**3*r*s - 87360*D1*Ddd*f**3*r + 58240*D1*Ddd*f**3*s**2 - 87360*D1*Ddd*f**3*s + 43680*D1*Ddd*f**3 + 68640*D1*Ddd*f**2*g2*r**2 + 137280*D1*Ddd*f**2*g2*r*s - 102960*D1*Ddd*f**2*g2*r + 68640*D1*Ddd*f**2*g2*s**2 - 102960*D1*Ddd*f**2*g2*s + 51480*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 102960*Dd**2*K*b1*f**2*r**2 - 205920*Dd**2*K*b1*f**2*r*s + 154440*Dd**2*K*b1*f**2*r - 102960*Dd**2*K*b1*f**2*s**2 + 154440*Dd**2*K*b1*f**2*s - 51480*Dd**2*K*b1*f**2 + 102960*Dd**2*b1*f**2*r**2 + 205920*Dd**2*b1*f**2*r*s - 154440*Dd**2*b1*f**2*r + 102960*Dd**2*b1*f**2*s**2 - 154440*Dd**2*b1*f**2*s + 51480*Dd**2*b1*f**2 - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 174720*Dd**2*f**3*r**2 + 349440*Dd**2*f**3*r*s - 262080*Dd**2*f**3*r + 174720*Dd**2*f**3*s**2 - 262080*Dd**2*f**3*s + 87360*Dd**2*f**3 + 205920*Dd**2*f**2*g2*r**2 + 411840*Dd**2*f**2*g2*r*s - 308880*Dd**2*f**2*g2*r + 205920*Dd**2*f**2*g2*s**2 - 308880*Dd**2*f**2*g2*s + 102960*Dd**2*f**2*g2)/(1001*d**2*k3**7) + 8*D1**2*Pk2*Pkd3*ct**7*k1**3*k2*(52650*C*D1**2*f**2*fd*r*s - 17550*C*D1**2*f**2*fd*r + 52650*C*D1**2*f**2*fd*s**2 - 52650*C*D1**2*f**2*fd*s + 17550*C*D1**2*f**2*fd - 32760*C*D1**2*f**2*fdd*r*s + 10920*C*D1**2*f**2*fdd*r - 32760*C*D1**2*f**2*fdd*s**2 + 32760*C*D1**2*f**2*fdd*s - 10920*C*D1**2*f**2*fdd - 65520*C*D1**2*f*fd**2*r*s + 21840*C*D1**2*f*fd**2*r - 65520*C*D1**2*f*fd**2*s**2 + 65520*C*D1**2*f*fd**2*s - 10920*C*D1**2*f*fd**2 + 70200*C*D1*Dd*f**3*r*s - 17550*C*D1*Dd*f**3*r + 70200*C*D1*Dd*f**3*s**2 - 70200*C*D1*Dd*f**3*s + 17550*C*D1*Dd*f**3 - 262080*C*D1*Dd*f**2*fd*r*s + 76440*C*D1*Dd*f**2*fd*r - 262080*C*D1*Dd*f**2*fd*s**2 + 262080*C*D1*Dd*f**2*fd*s - 54600*C*D1*Dd*f**2*fd - 43680*C*D1*Ddd*f**3*r*s + 10920*C*D1*Ddd*f**3*r - 43680*C*D1*Ddd*f**3*s**2 + 43680*C*D1*Ddd*f**3*s - 10920*C*D1*Ddd*f**3 - 131040*C*Dd**2*f**3*r*s + 32760*C*Dd**2*f**3*r - 131040*C*Dd**2*f**3*s**2 + 131040*C*Dd**2*f**3*s - 21840*C*Dd**2*f**3 - 6435*D1**2*K*bdd1*f**2*r*s - 6435*D1**2*K*bdd1*f**2*s**2 + 6435*D1**2*K*bdd1*f**2*s + 6435*D1**2*bdd1*f**2*r*s + 6435*D1**2*bdd1*f**2*s**2 - 6435*D1**2*bdd1*f**2*s + 43120*D1**2*f**3*fd*r*s - 10780*D1**2*f**3*fd*r + 43120*D1**2*f**3*fd*s**2 - 43120*D1**2*f**3*fd*s + 10780*D1**2*f**3*fd - 25200*D1**2*f**3*fdd*r*s + 6300*D1**2*f**3*fdd*r - 25200*D1**2*f**3*fdd*s**2 + 25200*D1**2*f**3*fdd*s - 6300*D1**2*f**3*fdd - 75600*D1**2*f**2*fd**2*r*s + 18900*D1**2*f**2*fd**2*r - 75600*D1**2*f**2*fd**2*s**2 + 75600*D1**2*f**2*fd**2*s - 12600*D1**2*f**2*fd**2 - 52650*D1**2*f**2*fd*r*s + 17550*D1**2*f**2*fd*r - 52650*D1**2*f**2*fd*s**2 + 52650*D1**2*f**2*fd*s - 17550*D1**2*f**2*fd + 32760*D1**2*f**2*fdd*r*s - 10920*D1**2*f**2*fdd*r + 32760*D1**2*f**2*fdd*s**2 - 32760*D1**2*f**2*fdd*s + 10920*D1**2*f**2*fdd - 20592*D1**2*f**2*gd2*r*s - 20592*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s + 12870*D1**2*f**2*gdd2*r*s + 12870*D1**2*f**2*gdd2*s**2 - 12870*D1**2*f**2*gdd2*s + 65520*D1**2*f*fd**2*r*s - 21840*D1**2*f*fd**2*r + 65520*D1**2*f*fd**2*s**2 - 65520*D1**2*f*fd**2*s + 10920*D1**2*f*fd**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 41184*D1**2*f*fd*g2*s**2 + 41184*D1**2*f*fd*g2*s - 20592*D1**2*f*fd*g2 + 51480*D1**2*f*fd*gd2*r*s - 12870*D1**2*f*fd*gd2*r + 51480*D1**2*f*fd*gd2*s**2 - 51480*D1**2*f*fd*gd2*s + 12870*D1**2*f*fd*gd2 + 25740*D1**2*f*fdd*g2*r*s - 12870*D1**2*f*fdd*g2*r + 25740*D1**2*f*fdd*g2*s**2 - 25740*D1**2*f*fdd*g2*s + 12870*D1**2*f*fdd*g2 + 25740*D1**2*fd**2*g2*r*s - 12870*D1**2*fd**2*g2*r + 25740*D1**2*fd**2*g2*s**2 - 25740*D1**2*fd**2*g2*s + 43120*D1*Dd*f**4*r*s - 10780*D1*Dd*f**4*r + 43120*D1*Dd*f**4*s**2 - 43120*D1*Dd*f**4*s + 10780*D1*Dd*f**4 - 201600*D1*Dd*f**3*fd*r*s + 50400*D1*Dd*f**3*fd*r - 201600*D1*Dd*f**3*fd*s**2 + 201600*D1*Dd*f**3*fd*s - 37800*D1*Dd*f**3*fd - 70200*D1*Dd*f**3*r*s + 17550*D1*Dd*f**3*r - 70200*D1*Dd*f**3*s**2 + 70200*D1*Dd*f**3*s - 17550*D1*Dd*f**3 + 262080*D1*Dd*f**2*fd*r*s - 76440*D1*Dd*f**2*fd*r + 262080*D1*Dd*f**2*fd*s**2 - 262080*D1*Dd*f**2*fd*s + 54600*D1*Dd*f**2*fd - 82368*D1*Dd*f**2*g2*r*s + 20592*D1*Dd*f**2*g2*r - 82368*D1*Dd*f**2*g2*s**2 + 82368*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*g2 + 102960*D1*Dd*f**2*gd2*r*s - 12870*D1*Dd*f**2*gd2*r + 102960*D1*Dd*f**2*gd2*s**2 - 102960*D1*Dd*f**2*gd2*s + 12870*D1*Dd*f**2*gd2 + 205920*D1*Dd*f*fd*g2*r*s - 77220*D1*Dd*f*fd*g2*r + 205920*D1*Dd*f*fd*g2*s**2 - 205920*D1*Dd*f*fd*g2*s + 51480*D1*Dd*f*fd*g2 - 25200*D1*Ddd*f**4*r*s + 6300*D1*Ddd*f**4*r - 25200*D1*Ddd*f**4*s**2 + 25200*D1*Ddd*f**4*s - 6300*D1*Ddd*f**4 + 43680*D1*Ddd*f**3*r*s - 10920*D1*Ddd*f**3*r + 43680*D1*Ddd*f**3*s**2 - 43680*D1*Ddd*f**3*s + 10920*D1*Ddd*f**3 + 51480*D1*Ddd*f**2*g2*r*s - 12870*D1*Ddd*f**2*g2*r + 51480*D1*Ddd*f**2*g2*s**2 - 51480*D1*Ddd*f**2*g2*s + 12870*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(D1*(8*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 75600*Dd**2*f**4*r*s + 18900*Dd**2*f**4*r - 75600*Dd**2*f**4*s**2 + 75600*Dd**2*f**4*s - 12600*Dd**2*f**4 + 131040*Dd**2*f**3*r*s - 32760*Dd**2*f**3*r + 131040*Dd**2*f**3*s**2 - 131040*Dd**2*f**3*s + 21840*Dd**2*f**3 + 154440*Dd**2*f**2*g2*r*s - 38610*Dd**2*f**2*g2*r + 154440*Dd**2*f**2*g2*s**2 - 154440*Dd**2*f**2*g2*s + 25740*Dd**2*f**2*g2 + 1287*b1*(K - 1)*(D1**2*(f*(8*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k3**5) - 5*D1**2*Pk2*Pkd3*ct**7*k1*k2**5*(-672*C*D1**2*f**2*fd*r**2 - 1344*C*D1**2*f**2*fd*r*s + 896*C*D1**2*f**2*fd*r - 672*C*D1**2*f**2*fd*s**2 + 896*C*D1**2*f**2*fd*s - 448*C*D1**2*f**2*fd + 336*C*D1**2*f**2*fdd*r**2 + 672*C*D1**2*f**2*fdd*r*s - 448*C*D1**2*f**2*fdd*r + 336*C*D1**2*f**2*fdd*s**2 - 448*C*D1**2*f**2*fdd*s + 224*C*D1**2*f**2*fdd + 672*C*D1**2*f*fd**2*r**2 + 1344*C*D1**2*f*fd**2*r*s - 896*C*D1**2*f*fd**2*r + 672*C*D1**2*f*fd**2*s**2 - 896*C*D1**2*f*fd**2*s + 224*C*D1**2*f*fd**2 - 896*C*D1*Dd*f**3*r**2 - 1792*C*D1*Dd*f**3*r*s + 1344*C*D1*Dd*f**3*r - 896*C*D1*Dd*f**3*s**2 + 1344*C*D1*Dd*f**3*s - 672*C*D1*Dd*f**3 + 2688*C*D1*Dd*f**2*fd*r**2 + 5376*C*D1*Dd*f**2*fd*r*s - 3808*C*D1*Dd*f**2*fd*r + 2688*C*D1*Dd*f**2*fd*s**2 - 3808*C*D1*Dd*f**2*fd*s + 1344*C*D1*Dd*f**2*fd + 448*C*D1*Ddd*f**3*r**2 + 896*C*D1*Ddd*f**3*r*s - 672*C*D1*Ddd*f**3*r + 448*C*D1*Ddd*f**3*s**2 - 672*C*D1*Ddd*f**3*s + 336*C*D1*Ddd*f**3 + 1344*C*Dd**2*f**3*r**2 + 2688*C*Dd**2*f**3*r*s - 2016*C*Dd**2*f**3*r + 1344*C*Dd**2*f**3*s**2 - 2016*C*Dd**2*f**3*s + 672*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r**2 - 528*D1**2*K*b1*f*fd*r*s + 264*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 132*D1**2*K*b1*f*fdd*s**2 - 132*D1**2*K*b1*f*fdd*s + 66*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 132*D1**2*K*b1*fd**2*s**2 - 132*D1**2*K*b1*fd**2*s + 168*D1**2*b1*f**2*fd*r**2 + 336*D1**2*b1*f**2*fd*r*s - 224*D1**2*b1*f**2*fd*r + 168*D1**2*b1*f**2*fd*s**2 - 224*D1**2*b1*f**2*fd*s + 112*D1**2*b1*f**2*fd - 84*D1**2*b1*f**2*fdd*r**2 - 168*D1**2*b1*f**2*fdd*r*s + 112*D1**2*b1*f**2*fdd*r - 84*D1**2*b1*f**2*fdd*s**2 + 112*D1**2*b1*f**2*fdd*s - 56*D1**2*b1*f**2*fdd - 168*D1**2*b1*f*fd**2*r**2 - 336*D1**2*b1*f*fd**2*r*s + 224*D1**2*b1*f*fd**2*r - 168*D1**2*b1*f*fd**2*s**2 + 224*D1**2*b1*f*fd**2*s - 56*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-66*K + 28*f + 33)*(r + s - 1)**2 + 504*D1**2*f**2*fd*r**2 + 1008*D1**2*f**2*fd*r*s - 672*D1**2*f**2*fd*r + 504*D1**2*f**2*fd*s**2 - 672*D1**2*f**2*fd*s + 336*D1**2*f**2*fd - 252*D1**2*f**2*fdd*r**2 - 504*D1**2*f**2*fdd*r*s + 336*D1**2*f**2*fdd*r - 252*D1**2*f**2*fdd*s**2 + 336*D1**2*f**2*fdd*s - 168*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 504*D1**2*f*fd**2*r**2 - 1008*D1**2*f*fd**2*r*s + 672*D1**2*f*fd**2*r - 504*D1**2*f*fd**2*s**2 + 672*D1**2*f*fd**2*s - 168*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 - 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 792*D1*Dd*K*b1*f**2*s - 396*D1*Dd*K*b1*f**2 + 1056*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1320*D1*Dd*K*b1*f*fd*r + 1056*D1*Dd*K*b1*f*fd*s**2 - 1320*D1*Dd*K*b1*f*fd*s + 396*D1*Dd*K*b1*f*fd + 224*D1*Dd*b1*f**3*r**2 + 448*D1*Dd*b1*f**3*r*s - 336*D1*Dd*b1*f**3*r + 224*D1*Dd*b1*f**3*s**2 - 336*D1*Dd*b1*f**3*s + 168*D1*Dd*b1*f**3 - 672*D1*Dd*b1*f**2*fd*r**2 - 1344*D1*Dd*b1*f**2*fd*r*s + 952*D1*Dd*b1*f**2*fd*r - 672*D1*Dd*b1*f**2*fd*s**2 + 952*D1*Dd*b1*f**2*fd*s - 336*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 672*D1*Dd*f**3*r**2 + 1344*D1*Dd*f**3*r*s - 1008*D1*Dd*f**3*r + 672*D1*Dd*f**3*s**2 - 1008*D1*Dd*f**3*s + 504*D1*Dd*f**3 - 2016*D1*Dd*f**2*fd*r**2 - 4032*D1*Dd*f**2*fd*r*s + 2856*D1*Dd*f**2*fd*r - 2016*D1*Dd*f**2*fd*s**2 + 2856*D1*Dd*f**2*fd*s - 1008*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r + 264*D1*Ddd*K*b1*f**2*s**2 - 396*D1*Ddd*K*b1*f**2*s + 198*D1*Ddd*K*b1*f**2 - 112*D1*Ddd*b1*f**3*r**2 - 224*D1*Ddd*b1*f**3*r*s + 168*D1*Ddd*b1*f**3*r - 112*D1*Ddd*b1*f**3*s**2 + 168*D1*Ddd*b1*f**3*s - 84*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 336*D1*Ddd*f**3*r**2 - 672*D1*Ddd*f**3*r*s + 504*D1*Ddd*f**3*r - 336*D1*Ddd*f**3*s**2 + 504*D1*Ddd*f**3*s - 252*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(28*f**2*(r + s - 1) - 28*f*fd*(3*r + 3*s - 2) - 33*f*(2*K - 1)*(r + s - 1) + 33*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-66*K + 28*f + 33)*(4*r + 4*s - 3))*(r + s - 1) + 792*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r + 792*Dd**2*K*b1*f**2*s**2 - 1188*Dd**2*K*b1*f**2*s + 396*Dd**2*K*b1*f**2 - 336*Dd**2*b1*f**3*r**2 - 672*Dd**2*b1*f**3*r*s + 504*Dd**2*b1*f**3*r - 336*Dd**2*b1*f**3*s**2 + 504*Dd**2*b1*f**3*s - 168*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 1008*Dd**2*f**3*r**2 - 2016*Dd**2*f**3*r*s + 1512*Dd**2*f**3*r - 1008*Dd**2*f**3*s**2 + 1512*Dd**2*f**3*s - 504*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2)/(77*d**2*k3**7) + 5*D1**2*Pk2*Pkd3*ct**7*k1*k2**3*(-1584*C*D1**2*f**2*fd*r**2 + 1104*C*D1**2*f**2*fd*r*s + 688*C*D1**2*f**2*fd*r + 2688*C*D1**2*f**2*fd*s**2 - 2160*C*D1**2*f**2*fd*s + 368*C*D1**2*f**2*fd + 792*C*D1**2*f**2*fdd*r**2 - 552*C*D1**2*f**2*fdd*r*s - 344*C*D1**2*f**2*fdd*r - 1344*C*D1**2*f**2*fdd*s**2 + 1080*C*D1**2*f**2*fdd*s - 184*C*D1**2*f**2*fdd + 1584*C*D1**2*f*fd**2*r**2 - 1104*C*D1**2*f*fd**2*r*s - 688*C*D1**2*f*fd**2*r - 2688*C*D1**2*f*fd**2*s**2 + 2160*C*D1**2*f*fd**2*s - 184*C*D1**2*f*fd**2 - 2112*C*D1*Dd*f**3*r**2 + 1472*C*D1*Dd*f**3*r*s + 1744*C*D1*Dd*f**3*r + 3584*C*D1*Dd*f**3*s**2 - 2528*C*D1*Dd*f**3*s - 160*C*D1*Dd*f**3 + 6336*C*D1*Dd*f**2*fd*r**2 - 4416*C*D1*Dd*f**2*fd*r*s - 3992*C*D1*Dd*f**2*fd*r - 10752*C*D1*Dd*f**2*fd*s**2 + 8112*C*D1*Dd*f**2*fd*s - 392*C*D1*Dd*f**2*fd + 1056*C*D1*Ddd*f**3*r**2 - 736*C*D1*Ddd*f**3*r*s - 872*C*D1*Ddd*f**3*r - 1792*C*D1*Ddd*f**3*s**2 + 1264*C*D1*Ddd*f**3*s + 80*C*D1*Ddd*f**3 + 3168*C*Dd**2*f**3*r**2 - 2208*C*Dd**2*f**3*r*s - 2616*C*Dd**2*f**3*r - 5376*C*Dd**2*f**3*s**2 + 3792*C*Dd**2*f**3*s + 160*C*Dd**2*f**3 - 528*D1**2*K*b1*f*fd*r**2 + 528*D1**2*K*b1*f*fd*r*s - 264*D1**2*K*b1*f*fd*r + 1056*D1**2*K*b1*f*fd*s**2 - 1056*D1**2*K*b1*f*fd*s + 528*D1**2*K*b1*f*fd + 264*D1**2*K*b1*f*fdd*r**2 - 264*D1**2*K*b1*f*fdd*r*s + 132*D1**2*K*b1*f*fdd*r - 528*D1**2*K*b1*f*fdd*s**2 + 528*D1**2*K*b1*f*fdd*s - 264*D1**2*K*b1*f*fdd + 264*D1**2*K*b1*fd**2*r**2 - 264*D1**2*K*b1*fd**2*r*s + 132*D1**2*K*b1*fd**2*r - 528*D1**2*K*b1*fd**2*s**2 + 528*D1**2*K*b1*fd**2*s + 840*D1**2*b1*f**2*fd*r**2 + 1008*D1**2*b1*f**2*fd*r*s - 896*D1**2*b1*f**2*fd*r + 168*D1**2*b1*f**2*fd*s**2 - 448*D1**2*b1*f**2*fd*s + 336*D1**2*b1*f**2*fd - 420*D1**2*b1*f**2*fdd*r**2 - 504*D1**2*b1*f**2*fdd*r*s + 448*D1**2*b1*f**2*fdd*r - 84*D1**2*b1*f**2*fdd*s**2 + 224*D1**2*b1*f**2*fdd*s - 168*D1**2*b1*f**2*fdd - 840*D1**2*b1*f*fd**2*r**2 - 1008*D1**2*b1*f*fd**2*r*s + 896*D1**2*b1*f*fd**2*r - 168*D1**2*b1*f*fd**2*s**2 + 448*D1**2*b1*f*fd**2*s - 168*D1**2*b1*f*fd**2 + 1188*D1**2*b1*f*fd*r**2 + 1320*D1**2*b1*f*fd*r*s - 660*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 594*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 594*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(r + s - 1)*(-132*K*(r - 2*s - 1) + 28*f*(5*r + s - 5) + 297*r + 33*s - 297) - 448*D1**2*f**3*fd*r**2 - 448*D1**2*f**3*fd*r*s + 560*D1**2*f**3*fd*r + 224*D1**2*f**3*fd*s - 224*D1**2*f**3*fd + 448*D1**2*f**3*fdd*r**2 + 448*D1**2*f**3*fdd*r*s - 560*D1**2*f**3*fdd*r - 224*D1**2*f**3*fdd*s + 224*D1**2*f**3*fdd + 1344*D1**2*f**2*fd**2*r**2 + 1344*D1**2*f**2*fd**2*r*s - 1680*D1**2*f**2*fd**2*r - 672*D1**2*f**2*fd**2*s + 448*D1**2*f**2*fd**2 + 2424*D1**2*f**2*fd*r**2 + 1248*D1**2*f**2*fd*r*s - 2032*D1**2*f**2*fd*r - 1176*D1**2*f**2*fd*s**2 + 368*D1**2*f**2*fd*s + 416*D1**2*f**2*fd - 1212*D1**2*f**2*fdd*r**2 - 624*D1**2*f**2*fdd*r*s + 1016*D1**2*f**2*fdd*r + 588*D1**2*f**2*fdd*s**2 - 184*D1**2*f**2*fdd*s - 208*D1**2*f**2*fdd + 528*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s - 1056*D1**2*f**2*gd2*r - 1056*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s + 528*D1**2*f**2*gd2 - 264*D1**2*f**2*gdd2*r**2 + 264*D1**2*f**2*gdd2*r*s + 528*D1**2*f**2*gdd2*r + 528*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s - 264*D1**2*f**2*gdd2 - 2424*D1**2*f*fd**2*r**2 - 1248*D1**2*f*fd**2*r*s + 2032*D1**2*f*fd**2*r + 1176*D1**2*f*fd**2*s**2 - 368*D1**2*f*fd**2*s - 208*D1**2*f*fd**2 + 1056*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s**2 + 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r**2 + 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r + 2112*D1**2*f*fd*gd2*s**2 - 1584*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r**2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 1056*D1**2*f*fdd*g2*s**2 - 1056*D1**2*f*fdd*g2*s + 528*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r**2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 1056*D1**2*fd**2*g2*s**2 - 1056*D1**2*fd**2*g2*s - 1056*D1*Dd*K*b1*f**2*r**2 + 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r + 2112*D1*Dd*K*b1*f**2*s**2 - 1584*D1*Dd*K*b1*f**2*s + 2112*D1*Dd*K*b1*f*fd*r**2 - 2112*D1*Dd*K*b1*f*fd*r*s - 264*D1*Dd*K*b1*f*fd*r - 4224*D1*Dd*K*b1*f*fd*s**2 + 3696*D1*Dd*K*b1*f*fd*s - 792*D1*Dd*K*b1*f*fd + 1120*D1*Dd*b1*f**3*r**2 + 1344*D1*Dd*b1*f**3*r*s - 1456*D1*Dd*b1*f**3*r + 224*D1*Dd*b1*f**3*s**2 - 784*D1*Dd*b1*f**3*s + 616*D1*Dd*b1*f**3 - 3360*D1*Dd*b1*f**2*fd*r**2 - 4032*D1*Dd*b1*f**2*fd*r*s + 3976*D1*Dd*b1*f**2*fd*r - 672*D1*Dd*b1*f**2*fd*s**2 + 2072*D1*Dd*b1*f**2*fd*s - 1120*D1*Dd*b1*f**2*fd + 2376*D1*Dd*b1*f**2*r**2 + 2640*D1*Dd*b1*f**2*r*s - 3036*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 1452*D1*Dd*b1*f**2*s + 1254*D1*Dd*b1*f**2 - 4752*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 4356*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 1716*D1*Dd*b1*f*fd*s - 726*D1*Dd*b1*f*fd - 448*D1*Dd*f**4*r**2 - 448*D1*Dd*f**4*r*s + 560*D1*Dd*f**4*r + 224*D1*Dd*f**4*s - 224*D1*Dd*f**4 + 3584*D1*Dd*f**3*fd*r**2 + 3584*D1*Dd*f**3*fd*r*s - 4480*D1*Dd*f**3*fd*r - 1792*D1*Dd*f**3*fd*s + 1344*D1*Dd*f**3*fd + 3232*D1*Dd*f**3*r**2 + 1664*D1*Dd*f**3*r*s - 3648*D1*Dd*f**3*r - 1568*D1*Dd*f**3*s**2 - 48*D1*Dd*f**3*s + 1224*D1*Dd*f**3 - 9696*D1*Dd*f**2*fd*r**2 - 4992*D1*Dd*f**2*fd*r*s + 9536*D1*Dd*f**2*fd*r + 4704*D1*Dd*f**2*fd*s**2 - 664*D1*Dd*f**2*fd*s - 1848*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r - 4224*D1*Dd*f**2*g2*s**2 + 3168*D1*Dd*f**2*g2*s - 2112*D1*Dd*f**2*gd2*r**2 + 2112*D1*Dd*f**2*gd2*r*s + 2904*D1*Dd*f**2*gd2*r + 4224*D1*Dd*f**2*gd2*s**2 - 2640*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r**2 + 4224*D1*Dd*f*fd*g2*r*s + 528*D1*Dd*f*fd*g2*r + 8448*D1*Dd*f*fd*g2*s**2 - 7392*D1*Dd*f*fd*g2*s + 1584*D1*Dd*f*fd*g2 + 528*D1*Ddd*K*b1*f**2*r**2 - 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r - 1056*D1*Ddd*K*b1*f**2*s**2 + 792*D1*Ddd*K*b1*f**2*s - 560*D1*Ddd*b1*f**3*r**2 - 672*D1*Ddd*b1*f**3*r*s + 728*D1*Ddd*b1*f**3*r - 112*D1*Ddd*b1*f**3*s**2 + 392*D1*Ddd*b1*f**3*s - 308*D1*Ddd*b1*f**3 - 1188*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 1518*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 726*D1*Ddd*b1*f**2*s - 627*D1*Ddd*b1*f**2 + 448*D1*Ddd*f**4*r**2 + 448*D1*Ddd*f**4*r*s - 560*D1*Ddd*f**4*r - 224*D1*Ddd*f**4*s + 224*D1*Ddd*f**4 - 1616*D1*Ddd*f**3*r**2 - 832*D1*Ddd*f**3*r*s + 1824*D1*Ddd*f**3*r + 784*D1*Ddd*f**3*s**2 + 24*D1*Ddd*f**3*s - 612*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r**2 + 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r + 2112*D1*Ddd*f**2*g2*s**2 - 1584*D1*Ddd*f**2*g2*s + 2*D1*bd1*f*(28*D1*f**2*(5*r**2 + 2*r*(3*s - 5) + s**2 - 6*s + 5) + D1*f*(-28*fd*(15*r**2 + r*(18*s - 23) + 3*s**2 - 13*s + 8) + (r + s - 1)*(-132*K*(r - 2*s - 1) + 297*r + 33*s - 297)) + 33*D1*fd*(2*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 18*r**2 - 20*r*s + 23*r - 2*s**2 + 11*s - 5) - 28*Dd*f**2*(20*r**2 + 3*r*(8*s - 11) + 4*s**2 - 19*s + 13) + 33*Dd*f*(2*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 36*r**2 - 40*r*s + 59*r - 4*s**2 + 31*s - 23)) + 1584*Dd**2*K*b1*f**2*r**2 - 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r - 3168*Dd**2*K*b1*f**2*s**2 + 2376*Dd**2*K*b1*f**2*s - 1680*Dd**2*b1*f**3*r**2 - 2016*Dd**2*b1*f**3*r*s + 2184*Dd**2*b1*f**3*r - 336*Dd**2*b1*f**3*s**2 + 1176*Dd**2*b1*f**3*s - 616*Dd**2*b1*f**3 - 3564*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 4554*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 2178*Dd**2*b1*f**2*s - 1254*Dd**2*b1*f**2 + 1344*Dd**2*f**4*r**2 + 1344*Dd**2*f**4*r*s - 1680*Dd**2*f**4*r - 672*Dd**2*f**4*s + 448*Dd**2*f**4 - 4848*Dd**2*f**3*r**2 - 2496*Dd**2*f**3*r*s + 5472*Dd**2*f**3*r + 2352*Dd**2*f**3*s**2 + 72*Dd**2*f**3*s - 1224*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r**2 + 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r + 6336*Dd**2*f**2*g2*s**2 - 4752*Dd**2*f**2*g2*s)/(693*d**2*k3**5) + 40*D1**2*Pk2*Pkd3*ct**7*k1*k2*(b1*(D1**2*(28*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(-28*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 66*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 33*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 33*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(28*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-14*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2) - 33*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(28*f + 33)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(28*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(28*bdd1*f**2*s*(r + s - 1) + f*(33*bdd1*s*(r + s - 1) - 56*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-28*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 2*f*s*(28*f + 33)*(r + s - 1) - 33*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(28*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 28*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 28*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**3) + 10*D1**2*Pk2*Pkd3*ct**6*k1**4*k2**2*(6669*C*D1**2*f**2*fd*r**2 + 13338*C*D1**2*f**2*fd*r*s - 8892*C*D1**2*f**2*fd*r + 6669*C*D1**2*f**2*fd*s**2 - 8892*C*D1**2*f**2*fd*s + 4446*C*D1**2*f**2*fd - 6552*C*D1**2*f**2*fdd*r**2 - 13104*C*D1**2*f**2*fdd*r*s + 8736*C*D1**2*f**2*fdd*r - 6552*C*D1**2*f**2*fdd*s**2 + 8736*C*D1**2*f**2*fdd*s - 4368*C*D1**2*f**2*fdd - 13104*C*D1**2*f*fd**2*r**2 - 26208*C*D1**2*f*fd**2*r*s + 17472*C*D1**2*f*fd**2*r - 13104*C*D1**2*f*fd**2*s**2 + 17472*C*D1**2*f*fd**2*s - 4368*C*D1**2*f*fd**2 + 8892*C*D1*Dd*f**3*r**2 + 17784*C*D1*Dd*f**3*r*s - 13338*C*D1*Dd*f**3*r + 8892*C*D1*Dd*f**3*s**2 - 13338*C*D1*Dd*f**3*s + 6669*C*D1*Dd*f**3 - 52416*C*D1*Dd*f**2*fd*r**2 - 104832*C*D1*Dd*f**2*fd*r*s + 74256*C*D1*Dd*f**2*fd*r - 52416*C*D1*Dd*f**2*fd*s**2 + 74256*C*D1*Dd*f**2*fd*s - 26208*C*D1*Dd*f**2*fd - 8736*C*D1*Ddd*f**3*r**2 - 17472*C*D1*Ddd*f**3*r*s + 13104*C*D1*Ddd*f**3*r - 8736*C*D1*Ddd*f**3*s**2 + 13104*C*D1*Ddd*f**3*s - 6552*C*D1*Ddd*f**3 - 26208*C*Dd**2*f**3*r**2 - 52416*C*Dd**2*f**3*r*s + 39312*C*Dd**2*f**3*r - 26208*C*Dd**2*f**3*s**2 + 39312*C*Dd**2*f**3*s - 13104*C*Dd**2*f**3 + 2574*D1**2*K*b1*f*fd*r**2 + 5148*D1**2*K*b1*f*fd*r*s - 2574*D1**2*K*b1*f*fd*r + 2574*D1**2*K*b1*f*fd*s**2 - 2574*D1**2*K*b1*f*fd*s + 1287*D1**2*K*b1*f*fd - 2574*D1**2*K*b1*f*fdd*r**2 - 5148*D1**2*K*b1*f*fdd*r*s + 2574*D1**2*K*b1*f*fdd*r - 2574*D1**2*K*b1*f*fdd*s**2 + 2574*D1**2*K*b1*f*fdd*s - 1287*D1**2*K*b1*f*fdd - 2574*D1**2*K*b1*fd**2*r**2 - 5148*D1**2*K*b1*fd**2*r*s + 2574*D1**2*K*b1*fd**2*r - 2574*D1**2*K*b1*fd**2*s**2 + 2574*D1**2*K*b1*fd**2*s - 2574*D1**2*b1*f*fd*r**2 - 5148*D1**2*b1*f*fd*r*s + 2574*D1**2*b1*f*fd*r - 2574*D1**2*b1*f*fd*s**2 + 2574*D1**2*b1*f*fd*s - 1287*D1**2*b1*f*fd + 2574*D1**2*b1*f*fdd*r**2 + 5148*D1**2*b1*f*fdd*r*s - 2574*D1**2*b1*f*fdd*r + 2574*D1**2*b1*f*fdd*s**2 - 2574*D1**2*b1*f*fdd*s + 1287*D1**2*b1*f*fdd + 2574*D1**2*b1*fd**2*r**2 + 5148*D1**2*b1*fd**2*r*s - 2574*D1**2*b1*fd**2*r + 2574*D1**2*b1*fd**2*s**2 - 2574*D1**2*b1*fd**2*s - 1287*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 7504*D1**2*f**3*fd*r**2 + 15008*D1**2*f**3*fd*r*s - 11256*D1**2*f**3*fd*r + 7504*D1**2*f**3*fd*s**2 - 11256*D1**2*f**3*fd*s + 5628*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 6669*D1**2*f**2*fd*r**2 - 13338*D1**2*f**2*fd*r*s + 8892*D1**2*f**2*fd*r - 6669*D1**2*f**2*fd*s**2 + 8892*D1**2*f**2*fd*s - 4446*D1**2*f**2*fd + 6552*D1**2*f**2*fdd*r**2 + 13104*D1**2*f**2*fdd*r*s - 8736*D1**2*f**2*fdd*r + 6552*D1**2*f**2*fdd*s**2 - 8736*D1**2*f**2*fdd*s + 4368*D1**2*f**2*fdd - 2574*D1**2*f**2*gd2*r**2 - 5148*D1**2*f**2*gd2*r*s + 5148*D1**2*f**2*gd2*r - 2574*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s - 2574*D1**2*f**2*gd2 + 2574*D1**2*f**2*gdd2*r**2 + 5148*D1**2*f**2*gdd2*r*s - 5148*D1**2*f**2*gdd2*r + 2574*D1**2*f**2*gdd2*s**2 - 5148*D1**2*f**2*gdd2*s + 2574*D1**2*f**2*gdd2 + 13104*D1**2*f*fd**2*r**2 + 26208*D1**2*f*fd**2*r*s - 17472*D1**2*f*fd**2*r + 13104*D1**2*f*fd**2*s**2 - 17472*D1**2*f*fd**2*s + 4368*D1**2*f*fd**2 - 5148*D1**2*f*fd*g2*r**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 5148*D1**2*f*fd*g2*s**2 + 5148*D1**2*f*fd*g2*s - 2574*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r**2 + 20592*D1**2*f*fd*gd2*r*s - 15444*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 15444*D1**2*f*fd*gd2*s + 5148*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r**2 + 10296*D1**2*f*fdd*g2*r*s - 5148*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r**2 + 10296*D1**2*fd**2*g2*r*s - 5148*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 5148*D1*Dd*K*b1*f**2*r**2 + 10296*D1*Dd*K*b1*f**2*r*s - 7722*D1*Dd*K*b1*f**2*r + 5148*D1*Dd*K*b1*f**2*s**2 - 7722*D1*Dd*K*b1*f**2*s + 3861*D1*Dd*K*b1*f**2 - 20592*D1*Dd*K*b1*f*fd*r**2 - 41184*D1*Dd*K*b1*f*fd*r*s + 25740*D1*Dd*K*b1*f*fd*r - 20592*D1*Dd*K*b1*f*fd*s**2 + 25740*D1*Dd*K*b1*f*fd*s - 7722*D1*Dd*K*b1*f*fd - 5148*D1*Dd*b1*f**2*r**2 - 10296*D1*Dd*b1*f**2*r*s + 7722*D1*Dd*b1*f**2*r - 5148*D1*Dd*b1*f**2*s**2 + 7722*D1*Dd*b1*f**2*s - 3861*D1*Dd*b1*f**2 + 20592*D1*Dd*b1*f*fd*r**2 + 41184*D1*Dd*b1*f*fd*r*s - 25740*D1*Dd*b1*f*fd*r + 20592*D1*Dd*b1*f*fd*s**2 - 25740*D1*Dd*b1*f*fd*s + 7722*D1*Dd*b1*f*fd + 7504*D1*Dd*f**4*r**2 + 15008*D1*Dd*f**4*r*s - 11256*D1*Dd*f**4*r + 7504*D1*Dd*f**4*s**2 - 11256*D1*Dd*f**4*s + 5628*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 8892*D1*Dd*f**3*r**2 - 17784*D1*Dd*f**3*r*s + 13338*D1*Dd*f**3*r - 8892*D1*Dd*f**3*s**2 + 13338*D1*Dd*f**3*s - 6669*D1*Dd*f**3 + 52416*D1*Dd*f**2*fd*r**2 + 104832*D1*Dd*f**2*fd*r*s - 74256*D1*Dd*f**2*fd*r + 52416*D1*Dd*f**2*fd*s**2 - 74256*D1*Dd*f**2*fd*s + 26208*D1*Dd*f**2*fd - 10296*D1*Dd*f**2*g2*r**2 - 20592*D1*Dd*f**2*g2*r*s + 15444*D1*Dd*f**2*g2*r - 10296*D1*Dd*f**2*g2*s**2 + 15444*D1*Dd*f**2*g2*s - 7722*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r**2 + 41184*D1*Dd*f**2*gd2*r*s - 36036*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 36036*D1*Dd*f**2*gd2*s + 15444*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r**2 + 82368*D1*Dd*f*fd*g2*r*s - 51480*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 51480*D1*Dd*f*fd*g2*s + 15444*D1*Dd*f*fd*g2 - 5148*D1*Ddd*K*b1*f**2*r**2 - 10296*D1*Ddd*K*b1*f**2*r*s + 7722*D1*Ddd*K*b1*f**2*r - 5148*D1*Ddd*K*b1*f**2*s**2 + 7722*D1*Ddd*K*b1*f**2*s - 3861*D1*Ddd*K*b1*f**2 + 5148*D1*Ddd*b1*f**2*r**2 + 10296*D1*Ddd*b1*f**2*r*s - 7722*D1*Ddd*b1*f**2*r + 5148*D1*Ddd*b1*f**2*s**2 - 7722*D1*Ddd*b1*f**2*s + 3861*D1*Ddd*b1*f**2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 8736*D1*Ddd*f**3*r**2 + 17472*D1*Ddd*f**3*r*s - 13104*D1*Ddd*f**3*r + 8736*D1*Ddd*f**3*s**2 - 13104*D1*Ddd*f**3*s + 6552*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r**2 + 20592*D1*Ddd*f**2*g2*r*s - 15444*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 15444*D1*Ddd*f**2*g2*s + 7722*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 15444*Dd**2*K*b1*f**2*r**2 - 30888*Dd**2*K*b1*f**2*r*s + 23166*Dd**2*K*b1*f**2*r - 15444*Dd**2*K*b1*f**2*s**2 + 23166*Dd**2*K*b1*f**2*s - 7722*Dd**2*K*b1*f**2 + 15444*Dd**2*b1*f**2*r**2 + 30888*Dd**2*b1*f**2*r*s - 23166*Dd**2*b1*f**2*r + 15444*Dd**2*b1*f**2*s**2 - 23166*Dd**2*b1*f**2*s + 7722*Dd**2*b1*f**2 - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 26208*Dd**2*f**3*r**2 + 52416*Dd**2*f**3*r*s - 39312*Dd**2*f**3*r + 26208*Dd**2*f**3*s**2 - 39312*Dd**2*f**3*s + 13104*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r**2 + 61776*Dd**2*f**2*g2*r*s - 46332*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 46332*Dd**2*f**2*g2*s + 15444*Dd**2*f**2*g2)/(1001*d**2*k3**7) + 8*D1**2*Pk2*Pkd3*ct**6*k1**4*(13260*C*D1**2*f**2*fd*r*s - 4420*C*D1**2*f**2*fd*r + 13260*C*D1**2*f**2*fd*s**2 - 13260*C*D1**2*f**2*fd*s + 4420*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r*s + 3640*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 10920*C*D1**2*f**2*fdd*s - 3640*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r*s + 7280*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 21840*C*D1**2*f*fd**2*s - 3640*C*D1**2*f*fd**2 + 17680*C*D1*Dd*f**3*r*s - 4420*C*D1*Dd*f**3*r + 17680*C*D1*Dd*f**3*s**2 - 17680*C*D1*Dd*f**3*s + 4420*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r*s + 25480*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 87360*C*D1*Dd*f**2*fd*s - 18200*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r*s + 3640*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 14560*C*D1*Ddd*f**3*s - 3640*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r*s + 10920*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 43680*C*Dd**2*f**3*s - 7280*C*Dd**2*f**3 - 2145*D1**2*K*bdd1*f**2*r*s - 2145*D1**2*K*bdd1*f**2*s**2 + 2145*D1**2*K*bdd1*f**2*s + 2145*D1**2*bdd1*f**2*r*s + 2145*D1**2*bdd1*f**2*s**2 - 2145*D1**2*bdd1*f**2*s + 17920*D1**2*f**3*fd*r*s - 4480*D1**2*f**3*fd*r + 17920*D1**2*f**3*fd*s**2 - 17920*D1**2*f**3*fd*s + 4480*D1**2*f**3*fd - 12600*D1**2*f**3*fdd*r*s + 3150*D1**2*f**3*fdd*r - 12600*D1**2*f**3*fdd*s**2 + 12600*D1**2*f**3*fdd*s - 3150*D1**2*f**3*fdd - 37800*D1**2*f**2*fd**2*r*s + 9450*D1**2*f**2*fd**2*r - 37800*D1**2*f**2*fd**2*s**2 + 37800*D1**2*f**2*fd**2*s - 6300*D1**2*f**2*fd**2 - 13260*D1**2*f**2*fd*r*s + 4420*D1**2*f**2*fd*r - 13260*D1**2*f**2*fd*s**2 + 13260*D1**2*f**2*fd*s - 4420*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r*s - 3640*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 10920*D1**2*f**2*fdd*s + 3640*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r*s - 5148*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s + 4290*D1**2*f**2*gdd2*r*s + 4290*D1**2*f**2*gdd2*s**2 - 4290*D1**2*f**2*gdd2*s + 21840*D1**2*f*fd**2*r*s - 7280*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 21840*D1**2*f*fd**2*s + 3640*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r*s - 4290*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 17160*D1**2*f*fd*gd2*s + 4290*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r*s - 4290*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r*s - 4290*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 17920*D1*Dd*f**4*r*s - 4480*D1*Dd*f**4*r + 17920*D1*Dd*f**4*s**2 - 17920*D1*Dd*f**4*s + 4480*D1*Dd*f**4 - 100800*D1*Dd*f**3*fd*r*s + 25200*D1*Dd*f**3*fd*r - 100800*D1*Dd*f**3*fd*s**2 + 100800*D1*Dd*f**3*fd*s - 18900*D1*Dd*f**3*fd - 17680*D1*Dd*f**3*r*s + 4420*D1*Dd*f**3*r - 17680*D1*Dd*f**3*s**2 + 17680*D1*Dd*f**3*s - 4420*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r*s - 25480*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 87360*D1*Dd*f**2*fd*s + 18200*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r*s - 4290*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 34320*D1*Dd*f**2*gd2*s + 4290*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r*s - 25740*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 68640*D1*Dd*f*fd*g2*s + 17160*D1*Dd*f*fd*g2 - 12600*D1*Ddd*f**4*r*s + 3150*D1*Ddd*f**4*r - 12600*D1*Ddd*f**4*s**2 + 12600*D1*Ddd*f**4*s - 3150*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r*s - 3640*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 14560*D1*Ddd*f**3*s + 3640*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r*s - 4290*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 17160*D1*Ddd*f**2*g2*s + 4290*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(6*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 37800*Dd**2*f**4*r*s + 9450*Dd**2*f**4*r - 37800*Dd**2*f**4*s**2 + 37800*Dd**2*f**4*s - 6300*Dd**2*f**4 + 43680*Dd**2*f**3*r*s - 10920*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 43680*Dd**2*f**3*s + 7280*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r*s - 12870*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 51480*Dd**2*f**2*g2*s + 8580*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(6*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**5) + 5*D1**2*Pk2*Pkd3*ct**6*k1**2*k2**4*st**2*(11700*C*D1**2*f**2*fd*r**2 + 23400*C*D1**2*f**2*fd*r*s - 15600*C*D1**2*f**2*fd*r + 11700*C*D1**2*f**2*fd*s**2 - 15600*C*D1**2*f**2*fd*s + 7800*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r**2 - 11700*C*D1**2*f**2*fdd*r*s + 7800*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 7800*C*D1**2*f**2*fdd*s - 3900*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r**2 - 23400*C*D1**2*f*fd**2*r*s + 15600*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 15600*C*D1**2*f*fd**2*s - 3900*C*D1**2*f*fd**2 + 15600*C*D1*Dd*f**3*r**2 + 31200*C*D1*Dd*f**3*r*s - 23400*C*D1*Dd*f**3*r + 15600*C*D1*Dd*f**3*s**2 - 23400*C*D1*Dd*f**3*s + 11700*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r**2 - 93600*C*D1*Dd*f**2*fd*r*s + 66300*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 66300*C*D1*Dd*f**2*fd*s - 23400*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r**2 - 15600*C*D1*Ddd*f**3*r*s + 11700*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 11700*C*D1*Ddd*f**3*s - 5850*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r**2 - 46800*C*Dd**2*f**3*r*s + 35100*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 35100*C*Dd**2*f**3*s - 11700*C*Dd**2*f**3 + 5148*D1**2*K*b1*f*fd*r**2 + 10296*D1**2*K*b1*f*fd*r*s - 5148*D1**2*K*b1*f*fd*r + 5148*D1**2*K*b1*f*fd*s**2 - 5148*D1**2*K*b1*f*fd*s + 2574*D1**2*K*b1*f*fd - 2574*D1**2*K*b1*f*fdd*r**2 - 5148*D1**2*K*b1*f*fdd*r*s + 2574*D1**2*K*b1*f*fdd*r - 2574*D1**2*K*b1*f*fdd*s**2 + 2574*D1**2*K*b1*f*fdd*s - 1287*D1**2*K*b1*f*fdd - 2574*D1**2*K*b1*fd**2*r**2 - 5148*D1**2*K*b1*fd**2*r*s + 2574*D1**2*K*b1*fd**2*r - 2574*D1**2*K*b1*fd**2*s**2 + 2574*D1**2*K*b1*fd**2*s - 5148*D1**2*b1*f*fd*r**2 - 10296*D1**2*b1*f*fd*r*s + 5148*D1**2*b1*f*fd*r - 5148*D1**2*b1*f*fd*s**2 + 5148*D1**2*b1*f*fd*s - 2574*D1**2*b1*f*fd + 2574*D1**2*b1*f*fdd*r**2 + 5148*D1**2*b1*f*fdd*r*s - 2574*D1**2*b1*f*fdd*r + 2574*D1**2*b1*f*fdd*s**2 - 2574*D1**2*b1*f*fdd*s + 1287*D1**2*b1*f*fdd + 2574*D1**2*b1*fd**2*r**2 + 5148*D1**2*b1*fd**2*r*s - 2574*D1**2*b1*fd**2*r + 2574*D1**2*b1*fd**2*s**2 - 2574*D1**2*b1*fd**2*s - 1287*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 10976*D1**2*f**3*fd*r**2 + 21952*D1**2*f**3*fd*r*s - 16464*D1**2*f**3*fd*r + 10976*D1**2*f**3*fd*s**2 - 16464*D1**2*f**3*fd*s + 8232*D1**2*f**3*fd - 5488*D1**2*f**3*fdd*r**2 - 10976*D1**2*f**3*fdd*r*s + 8232*D1**2*f**3*fdd*r - 5488*D1**2*f**3*fdd*s**2 + 8232*D1**2*f**3*fdd*s - 4116*D1**2*f**3*fdd - 16464*D1**2*f**2*fd**2*r**2 - 32928*D1**2*f**2*fd**2*r*s + 24696*D1**2*f**2*fd**2*r - 16464*D1**2*f**2*fd**2*s**2 + 24696*D1**2*f**2*fd**2*s - 8232*D1**2*f**2*fd**2 - 11700*D1**2*f**2*fd*r**2 - 23400*D1**2*f**2*fd*r*s + 15600*D1**2*f**2*fd*r - 11700*D1**2*f**2*fd*s**2 + 15600*D1**2*f**2*fd*s - 7800*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r**2 + 11700*D1**2*f**2*fdd*r*s - 7800*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 7800*D1**2*f**2*fdd*s + 3900*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r**2 - 10296*D1**2*f**2*gd2*r*s + 10296*D1**2*f**2*gd2*r - 5148*D1**2*f**2*gd2*s**2 + 10296*D1**2*f**2*gd2*s - 5148*D1**2*f**2*gd2 + 2574*D1**2*f**2*gdd2*r**2 + 5148*D1**2*f**2*gdd2*r*s - 5148*D1**2*f**2*gdd2*r + 2574*D1**2*f**2*gdd2*s**2 - 5148*D1**2*f**2*gdd2*s + 2574*D1**2*f**2*gdd2 + 11700*D1**2*f*fd**2*r**2 + 23400*D1**2*f*fd**2*r*s - 15600*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 15600*D1**2*f*fd**2*s + 3900*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r**2 - 20592*D1**2*f*fd*g2*r*s + 10296*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r**2 + 20592*D1**2*f*fd*gd2*r*s - 15444*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 15444*D1**2*f*fd*gd2*s + 5148*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r**2 + 10296*D1**2*f*fdd*g2*r*s - 5148*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r**2 + 10296*D1**2*fd**2*g2*r*s - 5148*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 10296*D1*Dd*K*b1*f**2*r**2 + 20592*D1*Dd*K*b1*f**2*r*s - 15444*D1*Dd*K*b1*f**2*r + 10296*D1*Dd*K*b1*f**2*s**2 - 15444*D1*Dd*K*b1*f**2*s + 7722*D1*Dd*K*b1*f**2 - 20592*D1*Dd*K*b1*f*fd*r**2 - 41184*D1*Dd*K*b1*f*fd*r*s + 25740*D1*Dd*K*b1*f*fd*r - 20592*D1*Dd*K*b1*f*fd*s**2 + 25740*D1*Dd*K*b1*f*fd*s - 7722*D1*Dd*K*b1*f*fd - 10296*D1*Dd*b1*f**2*r**2 - 20592*D1*Dd*b1*f**2*r*s + 15444*D1*Dd*b1*f**2*r - 10296*D1*Dd*b1*f**2*s**2 + 15444*D1*Dd*b1*f**2*s - 7722*D1*Dd*b1*f**2 + 20592*D1*Dd*b1*f*fd*r**2 + 41184*D1*Dd*b1*f*fd*r*s - 25740*D1*Dd*b1*f*fd*r + 20592*D1*Dd*b1*f*fd*s**2 - 25740*D1*Dd*b1*f*fd*s + 7722*D1*Dd*b1*f*fd + 10976*D1*Dd*f**4*r**2 + 21952*D1*Dd*f**4*r*s - 16464*D1*Dd*f**4*r + 10976*D1*Dd*f**4*s**2 - 16464*D1*Dd*f**4*s + 8232*D1*Dd*f**4 - 43904*D1*Dd*f**3*fd*r**2 - 87808*D1*Dd*f**3*fd*r*s + 65856*D1*Dd*f**3*fd*r - 43904*D1*Dd*f**3*fd*s**2 + 65856*D1*Dd*f**3*fd*s - 24696*D1*Dd*f**3*fd - 15600*D1*Dd*f**3*r**2 - 31200*D1*Dd*f**3*r*s + 23400*D1*Dd*f**3*r - 15600*D1*Dd*f**3*s**2 + 23400*D1*Dd*f**3*s - 11700*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r**2 + 93600*D1*Dd*f**2*fd*r*s - 66300*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 66300*D1*Dd*f**2*fd*s + 23400*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r**2 - 41184*D1*Dd*f**2*g2*r*s + 30888*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 30888*D1*Dd*f**2*g2*s - 15444*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r**2 + 41184*D1*Dd*f**2*gd2*r*s - 36036*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 36036*D1*Dd*f**2*gd2*s + 15444*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r**2 + 82368*D1*Dd*f*fd*g2*r*s - 51480*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 51480*D1*Dd*f*fd*g2*s + 15444*D1*Dd*f*fd*g2 - 5148*D1*Ddd*K*b1*f**2*r**2 - 10296*D1*Ddd*K*b1*f**2*r*s + 7722*D1*Ddd*K*b1*f**2*r - 5148*D1*Ddd*K*b1*f**2*s**2 + 7722*D1*Ddd*K*b1*f**2*s - 3861*D1*Ddd*K*b1*f**2 + 5148*D1*Ddd*b1*f**2*r**2 + 10296*D1*Ddd*b1*f**2*r*s - 7722*D1*Ddd*b1*f**2*r + 5148*D1*Ddd*b1*f**2*s**2 - 7722*D1*Ddd*b1*f**2*s + 3861*D1*Ddd*b1*f**2 - 5488*D1*Ddd*f**4*r**2 - 10976*D1*Ddd*f**4*r*s + 8232*D1*Ddd*f**4*r - 5488*D1*Ddd*f**4*s**2 + 8232*D1*Ddd*f**4*s - 4116*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r**2 + 15600*D1*Ddd*f**3*r*s - 11700*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 11700*D1*Ddd*f**3*s + 5850*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r**2 + 20592*D1*Ddd*f**2*g2*r*s - 15444*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 15444*D1*Ddd*f**2*g2*s + 7722*D1*Ddd*f**2*g2 + 2574*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 15444*Dd**2*K*b1*f**2*r**2 - 30888*Dd**2*K*b1*f**2*r*s + 23166*Dd**2*K*b1*f**2*r - 15444*Dd**2*K*b1*f**2*s**2 + 23166*Dd**2*K*b1*f**2*s - 7722*Dd**2*K*b1*f**2 + 15444*Dd**2*b1*f**2*r**2 + 30888*Dd**2*b1*f**2*r*s - 23166*Dd**2*b1*f**2*r + 15444*Dd**2*b1*f**2*s**2 - 23166*Dd**2*b1*f**2*s + 7722*Dd**2*b1*f**2 - 16464*Dd**2*f**4*r**2 - 32928*Dd**2*f**4*r*s + 24696*Dd**2*f**4*r - 16464*Dd**2*f**4*s**2 + 24696*Dd**2*f**4*s - 8232*Dd**2*f**4 + 23400*Dd**2*f**3*r**2 + 46800*Dd**2*f**3*r*s - 35100*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 35100*Dd**2*f**3*s + 11700*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r**2 + 61776*Dd**2*f**2*g2*r*s - 46332*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 46332*Dd**2*f**2*g2*s + 15444*Dd**2*f**2*g2)/(2002*d**2*k3**7) + 2*D1**2*Pk2*Pkd3*ct**6*k1**2*k2**4*(-165*C*D1**2*bdd1*f**2*r**2 - 330*C*D1**2*bdd1*f**2*r*s + 330*C*D1**2*bdd1*f**2*r - 165*C*D1**2*bdd1*f**2*s**2 + 330*C*D1**2*bdd1*f**2*s - 165*C*D1**2*bdd1*f**2 + 4245*C*D1**2*f**2*fd*r**2 + 8490*C*D1**2*f**2*fd*r*s - 5660*C*D1**2*f**2*fd*r + 4245*C*D1**2*f**2*fd*s**2 - 5660*C*D1**2*f**2*fd*s + 2830*C*D1**2*f**2*fd - 3360*C*D1**2*f**2*fdd*r**2 - 6720*C*D1**2*f**2*fdd*r*s + 4480*C*D1**2*f**2*fdd*r - 3360*C*D1**2*f**2*fdd*s**2 + 4480*C*D1**2*f**2*fdd*s - 2240*C*D1**2*f**2*fdd - 6720*C*D1**2*f*fd**2*r**2 - 13440*C*D1**2*f*fd**2*r*s + 8960*C*D1**2*f*fd**2*r - 6720*C*D1**2*f*fd**2*s**2 + 8960*C*D1**2*f*fd**2*s - 2240*C*D1**2*f*fd**2 + 5660*C*D1*Dd*f**3*r**2 + 11320*C*D1*Dd*f**3*r*s - 8490*C*D1*Dd*f**3*r + 5660*C*D1*Dd*f**3*s**2 - 8490*C*D1*Dd*f**3*s + 4245*C*D1*Dd*f**3 - 26880*C*D1*Dd*f**2*fd*r**2 - 53760*C*D1*Dd*f**2*fd*r*s + 38080*C*D1*Dd*f**2*fd*r - 26880*C*D1*Dd*f**2*fd*s**2 + 38080*C*D1*Dd*f**2*fd*s - 13440*C*D1*Dd*f**2*fd - 4480*C*D1*Ddd*f**3*r**2 - 8960*C*D1*Ddd*f**3*r*s + 6720*C*D1*Ddd*f**3*r - 4480*C*D1*Ddd*f**3*s**2 + 6720*C*D1*Ddd*f**3*s - 3360*C*D1*Ddd*f**3 - 13440*C*Dd**2*f**3*r**2 - 26880*C*Dd**2*f**3*r*s + 20160*C*Dd**2*f**3*r - 13440*C*Dd**2*f**3*s**2 + 20160*C*Dd**2*f**3*s - 6720*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r**2 - 1320*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 660*D1**2*K*bdd1*f**2*s**2 + 1320*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 280*D1**2*bdd1*f**3*r**2 + 560*D1**2*bdd1*f**3*r*s - 560*D1**2*bdd1*f**3*r + 280*D1**2*bdd1*f**3*s**2 - 560*D1**2*bdd1*f**3*s + 280*D1**2*bdd1*f**3 + 495*D1**2*bdd1*f**2*r**2 + 990*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*r + 495*D1**2*bdd1*f**2*s**2 - 990*D1**2*bdd1*f**2*s + 495*D1**2*bdd1*f**2 + 198*D1**2*bdd1*f*g2*r**2 + 396*D1**2*bdd1*f*g2*r*s - 396*D1**2*bdd1*f*g2*r + 198*D1**2*bdd1*f*g2*s**2 - 396*D1**2*bdd1*f*g2*s + 198*D1**2*bdd1*f*g2 - 280*D1**2*f**3*fd*r**2 - 560*D1**2*f**3*fd*r*s + 420*D1**2*f**3*fd*r - 280*D1**2*f**3*fd*s**2 + 420*D1**2*f**3*fd*s - 210*D1**2*f**3*fd - 3060*D1**2*f**2*fd*r**2 - 6120*D1**2*f**2*fd*r*s + 4080*D1**2*f**2*fd*r - 3060*D1**2*f**2*fd*s**2 + 4080*D1**2*f**2*fd*s - 2040*D1**2*f**2*fd + 2520*D1**2*f**2*fdd*r**2 + 5040*D1**2*f**2*fdd*r*s - 3360*D1**2*f**2*fdd*r + 2520*D1**2*f**2*fdd*s**2 - 3360*D1**2*f**2*fdd*s + 1680*D1**2*f**2*fdd - 1650*D1**2*f**2*gd2*r**2 - 3300*D1**2*f**2*gd2*r*s + 3300*D1**2*f**2*gd2*r - 1650*D1**2*f**2*gd2*s**2 + 3300*D1**2*f**2*gd2*s - 1650*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 5040*D1**2*f*fd**2*r**2 + 10080*D1**2*f*fd**2*r*s - 6720*D1**2*f*fd**2*r + 5040*D1**2*f*fd**2*s**2 - 6720*D1**2*f*fd**2*s + 1680*D1**2*f*fd**2 - 3300*D1**2*f*fd*g2*r**2 - 6600*D1**2*f*fd*g2*r*s + 3300*D1**2*f*fd*g2*r - 3300*D1**2*f*fd*g2*s**2 + 3300*D1**2*f*fd*g2*s - 1650*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s - 280*D1*Dd*f**4*r**2 - 560*D1*Dd*f**4*r*s + 420*D1*Dd*f**4*r - 280*D1*Dd*f**4*s**2 + 420*D1*Dd*f**4*s - 210*D1*Dd*f**4 - 4080*D1*Dd*f**3*r**2 - 8160*D1*Dd*f**3*r*s + 6120*D1*Dd*f**3*r - 4080*D1*Dd*f**3*s**2 + 6120*D1*Dd*f**3*s - 3060*D1*Dd*f**3 + 20160*D1*Dd*f**2*fd*r**2 + 40320*D1*Dd*f**2*fd*r*s - 28560*D1*Dd*f**2*fd*r + 20160*D1*Dd*f**2*fd*s**2 - 28560*D1*Dd*f**2*fd*s + 10080*D1*Dd*f**2*fd - 6600*D1*Dd*f**2*g2*r**2 - 13200*D1*Dd*f**2*g2*r*s + 9900*D1*Dd*f**2*g2*r - 6600*D1*Dd*f**2*g2*s**2 + 9900*D1*Dd*f**2*g2*s - 4950*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 3360*D1*Ddd*f**3*r**2 + 6720*D1*Ddd*f**3*r*s - 5040*D1*Ddd*f**3*r + 3360*D1*Ddd*f**3*s**2 - 5040*D1*Ddd*f**3*s + 2520*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 - D1*bd1*(D1*(395*f**3*(r + s - 1) - f**2*(330*C*(r + s - 1) + 560*fd*(3*r + 3*s - 2) + (825*K - 693)*(r + s - 1)) + 66*f*(5*fd*(C + 4*K - 3)*(2*r + 2*s - 1) + (6*g2 - 6*gd2)*(r + s - 1)) - 396*fd*g2*(r + s)) - 2*Dd*f*(280*f**2 - 165*f*(C + 4*K - 3) + 198*g2)*(4*r + 4*s - 3))*(r + s - 1) + 10080*Dd**2*f**3*r**2 + 20160*Dd**2*f**3*r*s - 15120*Dd**2*f**3*r + 10080*Dd**2*f**3*s**2 - 15120*Dd**2*f**3*s + 5040*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2 + 99*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(660*C*D1**2*f*fd*r**2 + 1320*C*D1**2*f*fd*r*s - 660*C*D1**2*f*fd*r + 660*C*D1**2*f*fd*s**2 - 660*C*D1**2*f*fd*s + 330*C*D1**2*f*fd - 330*C*D1**2*f*fdd*r**2 - 660*C*D1**2*f*fdd*r*s + 330*C*D1**2*f*fdd*r - 330*C*D1**2*f*fdd*s**2 + 330*C*D1**2*f*fdd*s - 165*C*D1**2*f*fdd - 330*C*D1**2*fd**2*r**2 - 660*C*D1**2*fd**2*r*s + 330*C*D1**2*fd**2*r - 330*C*D1**2*fd**2*s**2 + 330*C*D1**2*fd**2*s + 1320*C*D1*Dd*f**2*r**2 + 2640*C*D1*Dd*f**2*r*s - 1980*C*D1*Dd*f**2*r + 1320*C*D1*Dd*f**2*s**2 - 1980*C*D1*Dd*f**2*s + 990*C*D1*Dd*f**2 - 2640*C*D1*Dd*f*fd*r**2 - 5280*C*D1*Dd*f*fd*r*s + 3300*C*D1*Dd*f*fd*r - 2640*C*D1*Dd*f*fd*s**2 + 3300*C*D1*Dd*f*fd*s - 990*C*D1*Dd*f*fd - 660*C*D1*Ddd*f**2*r**2 - 1320*C*D1*Ddd*f**2*r*s + 990*C*D1*Ddd*f**2*r - 660*C*D1*Ddd*f**2*s**2 + 990*C*D1*Ddd*f**2*s - 495*C*D1*Ddd*f**2 - 1980*C*Dd**2*f**2*r**2 - 3960*C*Dd**2*f**2*r*s + 2970*C*Dd**2*f**2*r - 1980*C*Dd**2*f**2*s**2 + 2970*C*Dd**2*f**2*s - 990*C*Dd**2*f**2 + 1650*D1**2*K*f*fd*r**2 + 3300*D1**2*K*f*fd*r*s - 1650*D1**2*K*f*fd*r + 1650*D1**2*K*f*fd*s**2 - 1650*D1**2*K*f*fd*s + 825*D1**2*K*f*fd - 1320*D1**2*K*f*fdd*r**2 - 2640*D1**2*K*f*fdd*r*s + 1320*D1**2*K*f*fdd*r - 1320*D1**2*K*f*fdd*s**2 + 1320*D1**2*K*f*fdd*s - 660*D1**2*K*f*fdd - 1320*D1**2*K*fd**2*r**2 - 2640*D1**2*K*fd**2*r*s + 1320*D1**2*K*fd**2*r - 1320*D1**2*K*fd**2*s**2 + 1320*D1**2*K*fd**2*s - 198*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 1185*D1**2*f**2*fd*r**2 - 2370*D1**2*f**2*fd*r*s + 1580*D1**2*f**2*fd*r - 1185*D1**2*f**2*fd*s**2 + 1580*D1**2*f**2*fd*s - 790*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 + 1680*D1**2*f**2*fdd*r*s - 1120*D1**2*f**2*fdd*r + 840*D1**2*f**2*fdd*s**2 - 1120*D1**2*f**2*fdd*s + 560*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r**2 + 3360*D1**2*f*fd**2*r*s - 2240*D1**2*f*fd**2*r + 1680*D1**2*f*fd**2*s**2 - 2240*D1**2*f*fd**2*s + 560*D1**2*f*fd**2 - 1386*D1**2*f*fd*r**2 - 2772*D1**2*f*fd*r*s + 1386*D1**2*f*fd*r - 1386*D1**2*f*fd*s**2 + 1386*D1**2*f*fd*s - 693*D1**2*f*fd + 990*D1**2*f*fdd*r**2 + 1980*D1**2*f*fdd*r*s - 990*D1**2*f*fdd*r + 990*D1**2*f*fdd*s**2 - 990*D1**2*f*fdd*s + 495*D1**2*f*fdd - 396*D1**2*f*gd2*r**2 - 792*D1**2*f*gd2*r*s + 792*D1**2*f*gd2*r - 396*D1**2*f*gd2*s**2 + 792*D1**2*f*gd2*s - 396*D1**2*f*gd2 + 198*D1**2*f*gdd2*r**2 + 396*D1**2*f*gdd2*r*s - 396*D1**2*f*gdd2*r + 198*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s + 198*D1**2*f*gdd2 + 990*D1**2*fd**2*r**2 + 1980*D1**2*fd**2*r*s - 990*D1**2*fd**2*r + 990*D1**2*fd**2*s**2 - 990*D1**2*fd**2*s - 396*D1**2*fd*g2*r**2 - 792*D1**2*fd*g2*r*s - 396*D1**2*fd*g2*s**2 + 396*D1**2*fd*gd2*r**2 + 792*D1**2*fd*gd2*r*s - 396*D1**2*fd*gd2*r + 396*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 198*D1**2*fdd*g2*r**2 + 396*D1**2*fdd*g2*r*s + 198*D1**2*fdd*g2*s**2 + 3300*D1*Dd*K*f**2*r**2 + 6600*D1*Dd*K*f**2*r*s - 4950*D1*Dd*K*f**2*r + 3300*D1*Dd*K*f**2*s**2 - 4950*D1*Dd*K*f**2*s + 2475*D1*Dd*K*f**2 - 10560*D1*Dd*K*f*fd*r**2 - 21120*D1*Dd*K*f*fd*r*s + 13200*D1*Dd*K*f*fd*r - 10560*D1*Dd*K*f*fd*s**2 + 13200*D1*Dd*K*f*fd*s - 3960*D1*Dd*K*f*fd - 1580*D1*Dd*f**3*r**2 - 3160*D1*Dd*f**3*r*s + 2370*D1*Dd*f**3*r - 1580*D1*Dd*f**3*s**2 + 2370*D1*Dd*f**3*s - 1185*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 + 13440*D1*Dd*f**2*fd*r*s - 9520*D1*Dd*f**2*fd*r + 6720*D1*Dd*f**2*fd*s**2 - 9520*D1*Dd*f**2*fd*s + 3360*D1*Dd*f**2*fd - 2772*D1*Dd*f**2*r**2 - 5544*D1*Dd*f**2*r*s + 4158*D1*Dd*f**2*r - 2772*D1*Dd*f**2*s**2 + 4158*D1*Dd*f**2*s - 2079*D1*Dd*f**2 + 7920*D1*Dd*f*fd*r**2 + 15840*D1*Dd*f*fd*r*s - 9900*D1*Dd*f*fd*r + 7920*D1*Dd*f*fd*s**2 - 9900*D1*Dd*f*fd*s + 2970*D1*Dd*f*fd - 1584*D1*Dd*f*g2*r**2 - 3168*D1*Dd*f*g2*r*s + 2376*D1*Dd*f*g2*r - 1584*D1*Dd*f*g2*s**2 + 2376*D1*Dd*f*g2*s - 1188*D1*Dd*f*g2 + 1584*D1*Dd*f*gd2*r**2 + 3168*D1*Dd*f*gd2*r*s - 2772*D1*Dd*f*gd2*r + 1584*D1*Dd*f*gd2*s**2 - 2772*D1*Dd*f*gd2*s + 1188*D1*Dd*f*gd2 + 1584*D1*Dd*fd*g2*r**2 + 3168*D1*Dd*fd*g2*r*s - 1188*D1*Dd*fd*g2*r + 1584*D1*Dd*fd*g2*s**2 - 1188*D1*Dd*fd*g2*s - 2640*D1*Ddd*K*f**2*r**2 - 5280*D1*Ddd*K*f**2*r*s + 3960*D1*Ddd*K*f**2*r - 2640*D1*Ddd*K*f**2*s**2 + 3960*D1*Ddd*K*f**2*s - 1980*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r**2 + 2240*D1*Ddd*f**3*r*s - 1680*D1*Ddd*f**3*r + 1120*D1*Ddd*f**3*s**2 - 1680*D1*Ddd*f**3*s + 840*D1*Ddd*f**3 + 1980*D1*Ddd*f**2*r**2 + 3960*D1*Ddd*f**2*r*s - 2970*D1*Ddd*f**2*r + 1980*D1*Ddd*f**2*s**2 - 2970*D1*Ddd*f**2*s + 1485*D1*Ddd*f**2 + 792*D1*Ddd*f*g2*r**2 + 1584*D1*Ddd*f*g2*r*s - 1188*D1*Ddd*f*g2*r + 792*D1*Ddd*f*g2*s**2 - 1188*D1*Ddd*f*g2*s + 594*D1*Ddd*f*g2 + 396*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 7920*Dd**2*K*f**2*r**2 - 15840*Dd**2*K*f**2*r*s + 11880*Dd**2*K*f**2*r - 7920*Dd**2*K*f**2*s**2 + 11880*Dd**2*K*f**2*s - 3960*Dd**2*K*f**2 + 3360*Dd**2*f**3*r**2 + 6720*Dd**2*f**3*r*s - 5040*Dd**2*f**3*r + 3360*Dd**2*f**3*s**2 - 5040*Dd**2*f**3*s + 1680*Dd**2*f**3 + 5940*Dd**2*f**2*r**2 + 11880*Dd**2*f**2*r*s - 8910*Dd**2*f**2*r + 5940*Dd**2*f**2*s**2 - 8910*Dd**2*f**2*s + 2970*Dd**2*f**2 + 2376*Dd**2*f*g2*r**2 + 4752*Dd**2*f*g2*r*s - 3564*Dd**2*f*g2*r + 2376*Dd**2*f*g2*s**2 - 3564*Dd**2*f*g2*s + 1188*Dd**2*f*g2))/(77*d**2*k3**7) + 20*D1**2*Pk2*Pkd3*ct**6*k1**2*k2**2*st**2*(11700*C*D1**2*f**2*fd*r*s - 3900*C*D1**2*f**2*fd*r + 11700*C*D1**2*f**2*fd*s**2 - 11700*C*D1**2*f**2*fd*s + 3900*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 15600*C*D1*Dd*f**3*r*s - 3900*C*D1*Dd*f**3*r + 15600*C*D1*Dd*f**3*s**2 - 15600*C*D1*Dd*f**3*s + 3900*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 10976*D1**2*f**3*fd*r*s - 2744*D1**2*f**3*fd*r + 10976*D1**2*f**3*fd*s**2 - 10976*D1**2*f**3*fd*s + 2744*D1**2*f**3*fd - 5488*D1**2*f**3*fdd*r*s + 1372*D1**2*f**3*fdd*r - 5488*D1**2*f**3*fdd*s**2 + 5488*D1**2*f**3*fdd*s - 1372*D1**2*f**3*fdd - 16464*D1**2*f**2*fd**2*r*s + 4116*D1**2*f**2*fd**2*r - 16464*D1**2*f**2*fd**2*s**2 + 16464*D1**2*f**2*fd**2*s - 2744*D1**2*f**2*fd**2 - 11700*D1**2*f**2*fd*r*s + 3900*D1**2*f**2*fd*r - 11700*D1**2*f**2*fd*s**2 + 11700*D1**2*f**2*fd*s - 3900*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r*s - 5148*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 10976*D1*Dd*f**4*r*s - 2744*D1*Dd*f**4*r + 10976*D1*Dd*f**4*s**2 - 10976*D1*Dd*f**4*s + 2744*D1*Dd*f**4 - 43904*D1*Dd*f**3*fd*r*s + 10976*D1*Dd*f**3*fd*r - 43904*D1*Dd*f**3*fd*s**2 + 43904*D1*Dd*f**3*fd*s - 8232*D1*Dd*f**3*fd - 15600*D1*Dd*f**3*r*s + 3900*D1*Dd*f**3*r - 15600*D1*Dd*f**3*s**2 + 15600*D1*Dd*f**3*s - 3900*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 5488*D1*Ddd*f**4*r*s + 1372*D1*Ddd*f**4*r - 5488*D1*Ddd*f**4*s**2 + 5488*D1*Ddd*f**4*s - 1372*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 16464*Dd**2*f**4*r*s + 4116*Dd**2*f**4*r - 16464*Dd**2*f**4*s**2 + 16464*Dd**2*f**4*s - 2744*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 1287*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**5) - 2*D1**2*Pk2*Pkd3*ct**6*k1**2*k2**2*(825*C*D1**2*bdd1*f**2*r**2 + 2310*C*D1**2*bdd1*f**2*r*s - 660*C*D1**2*bdd1*f**2*r + 1485*C*D1**2*bdd1*f**2*s**2 - 1320*C*D1**2*bdd1*f**2*s + 660*C*D1**2*bdd1*f**2 + 11385*C*D1**2*f**2*fd*r**2 + 3990*C*D1**2*f**2*fd*r*s - 8920*C*D1**2*f**2*fd*r - 7395*C*D1**2*f**2*fd*s**2 + 3600*C*D1**2*f**2*fd*s + 1330*C*D1**2*f**2*fd - 8415*C*D1**2*f**2*fdd*r**2 - 4470*C*D1**2*f**2*fdd*r*s + 7100*C*D1**2*f**2*fdd*r + 3945*C*D1**2*f**2*fdd*s**2 - 1140*C*D1**2*f**2*fdd*s - 1490*C*D1**2*f**2*fdd - 16830*C*D1**2*f*fd**2*r**2 - 8940*C*D1**2*f*fd**2*r*s + 14200*C*D1**2*f*fd**2*r + 7890*C*D1**2*f*fd**2*s**2 - 2280*C*D1**2*f*fd**2*s - 1490*C*D1**2*f*fd**2 + 15180*C*D1*Dd*f**3*r**2 + 5320*C*D1*Dd*f**3*r*s - 16510*C*D1*Dd*f**3*r - 9860*C*D1*Dd*f**3*s**2 + 2270*C*D1*Dd*f**3*s + 5125*C*D1*Dd*f**3 - 67320*C*D1*Dd*f**2*fd*r**2 - 35760*C*D1*Dd*f**2*fd*r*s + 66530*C*D1*Dd*f**2*fd*r + 31560*C*D1*Dd*f**2*fd*s**2 - 3510*C*D1*Dd*f**2*fd*s - 13060*C*D1*Dd*f**2*fd - 11220*C*D1*Ddd*f**3*r**2 - 5960*C*D1*Ddd*f**3*r*s + 12710*C*D1*Ddd*f**3*r + 5260*C*D1*Ddd*f**3*s**2 + 350*C*D1*Ddd*f**3*s - 4295*C*D1*Ddd*f**3 - 33660*C*Dd**2*f**3*r**2 - 17880*C*Dd**2*f**3*r*s + 38130*C*Dd**2*f**3*r + 15780*C*Dd**2*f**3*s**2 + 1050*C*Dd**2*f**3*s - 8590*C*Dd**2*f**3 - 1485*D1**2*K*bdd1*f**2*r**2 - 726*D1**2*K*bdd1*f**2*r*s + 2970*D1**2*K*bdd1*f**2*r + 759*D1**2*K*bdd1*f**2*s**2 + 726*D1**2*K*bdd1*f**2*s - 1485*D1**2*K*bdd1*f**2 + 198*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2) + 1750*D1**2*bdd1*f**3*r**2 + 2660*D1**2*bdd1*f**3*r*s - 3080*D1**2*bdd1*f**3*r + 910*D1**2*bdd1*f**3*s**2 - 2240*D1**2*bdd1*f**3*s + 1680*D1**2*bdd1*f**3 + 2310*D1**2*bdd1*f**2*r**2 + 2706*D1**2*bdd1*f**2*r*s - 5610*D1**2*bdd1*f**2*r + 396*D1**2*bdd1*f**2*s**2 - 3696*D1**2*bdd1*f**2*s + 2475*D1**2*bdd1*f**2 - 990*D1**2*bdd1*f*g2*r**2 - 2772*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r - 1782*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 + 5880*D1**2*f**3*fd*r**2 + 11200*D1**2*f**3*fd*r*s - 8680*D1**2*f**3*fd*r + 5320*D1**2*f**3*fd*s**2 - 8260*D1**2*f**3*fd*s + 4270*D1**2*f**3*fd - 6440*D1**2*f**3*fdd*r**2 - 10080*D1**2*f**3*fdd*r*s + 8960*D1**2*f**3*fdd*r - 3640*D1**2*f**3*fdd*s**2 + 6860*D1**2*f**3*fdd*s - 4130*D1**2*f**3*fdd - 19320*D1**2*f**2*fd**2*r**2 - 30240*D1**2*f**2*fd**2*r*s + 26880*D1**2*f**2*fd**2*r - 10920*D1**2*f**2*fd**2*s**2 + 20580*D1**2*f**2*fd**2*s - 8260*D1**2*f**2*fd**2 - 17310*D1**2*f**2*fd*r**2 - 19890*D1**2*f**2*fd*r*s + 18170*D1**2*f**2*fd*r - 2580*D1**2*f**2*fd*s**2 + 8350*D1**2*f**2*fd*s - 6630*D1**2*f**2*fd + 12615*D1**2*f**2*fdd*r**2 + 15390*D1**2*f**2*fdd*r*s - 13540*D1**2*f**2*fdd*r + 2775*D1**2*f**2*fdd*s**2 - 6980*D1**2*f**2*fdd*s + 5130*D1**2*f**2*fdd - 3762*D1**2*f**2*gd2*r**2 - 924*D1**2*f**2*gd2*r*s + 7524*D1**2*f**2*gd2*r + 2838*D1**2*f**2*gd2*s**2 + 924*D1**2*f**2*gd2*s - 3762*D1**2*f**2*gd2 + 2970*D1**2*f**2*gdd2*r**2 + 1452*D1**2*f**2*gdd2*r*s - 5940*D1**2*f**2*gdd2*r - 1518*D1**2*f**2*gdd2*s**2 - 1452*D1**2*f**2*gdd2*s + 2970*D1**2*f**2*gdd2 + 25230*D1**2*f*fd**2*r**2 + 30780*D1**2*f*fd**2*r*s - 27080*D1**2*f*fd**2*r + 5550*D1**2*f*fd**2*s**2 - 13960*D1**2*f*fd**2*s + 5130*D1**2*f*fd**2 - 7524*D1**2*f*fd*g2*r**2 - 1848*D1**2*f*fd*g2*r*s + 924*D1**2*f*fd*g2*r + 5676*D1**2*f*fd*g2*s**2 - 5676*D1**2*f*fd*g2*s + 2838*D1**2*f*fd*g2 + 11880*D1**2*f*fd*gd2*r**2 + 5808*D1**2*f*fd*gd2*r*s - 13332*D1**2*f*fd*gd2*r - 6072*D1**2*f*fd*gd2*s**2 + 132*D1**2*f*fd*gd2*s + 1452*D1**2*f*fd*gd2 + 5940*D1**2*f*fdd*g2*r**2 + 2904*D1**2*f*fdd*g2*r*s - 1452*D1**2*f*fdd*g2*r - 3036*D1**2*f*fdd*g2*s**2 + 3036*D1**2*f*fdd*g2*s - 1518*D1**2*f*fdd*g2 + 5940*D1**2*fd**2*g2*r**2 + 2904*D1**2*fd**2*g2*r*s - 1452*D1**2*fd**2*g2*r - 3036*D1**2*fd**2*g2*s**2 + 3036*D1**2*fd**2*g2*s + 5880*D1*Dd*f**4*r**2 + 11200*D1*Dd*f**4*r*s - 8680*D1*Dd*f**4*r + 5320*D1*Dd*f**4*s**2 - 8260*D1*Dd*f**4*s + 4270*D1*Dd*f**4 - 51520*D1*Dd*f**3*fd*r**2 - 80640*D1*Dd*f**3*fd*r*s + 71680*D1*Dd*f**3*fd*r - 29120*D1*Dd*f**3*fd*s**2 + 54880*D1*Dd*f**3*fd*s - 24780*D1*Dd*f**3*fd - 23080*D1*Dd*f**3*r**2 - 26520*D1*Dd*f**3*r*s + 29710*D1*Dd*f**3*r - 3440*D1*Dd*f**3*s**2 + 14980*D1*Dd*f**3*s - 12400*D1*Dd*f**3 + 100920*D1*Dd*f**2*fd*r**2 + 123120*D1*Dd*f**2*fd*r*s - 120010*D1*Dd*f**2*fd*r + 22200*D1*Dd*f**2*fd*s**2 - 64250*D1*Dd*f**2*fd*s + 34060*D1*Dd*f**2*fd - 15048*D1*Dd*f**2*g2*r**2 - 3696*D1*Dd*f**2*g2*r*s + 15972*D1*Dd*f**2*g2*r + 11352*D1*Dd*f**2*g2*s**2 - 3828*D1*Dd*f**2*g2*s - 4686*D1*Dd*f**2*g2 + 23760*D1*Dd*f**2*gd2*r**2 + 11616*D1*Dd*f**2*gd2*r*s - 37092*D1*Dd*f**2*gd2*r - 12144*D1*Dd*f**2*gd2*s**2 - 5676*D1*Dd*f**2*gd2*s + 13332*D1*Dd*f**2*gd2 + 47520*D1*Dd*f*fd*g2*r**2 + 23232*D1*Dd*f*fd*g2*r*s - 32472*D1*Dd*f*fd*g2*r - 24288*D1*Dd*f*fd*g2*s**2 + 12408*D1*Dd*f*fd*g2*s - 132*D1*Dd*f*fd*g2 - 6440*D1*Ddd*f**4*r**2 - 10080*D1*Ddd*f**4*r*s + 8960*D1*Ddd*f**4*r - 3640*D1*Ddd*f**4*s**2 + 6860*D1*Ddd*f**4*s - 4130*D1*Ddd*f**4 + 16820*D1*Ddd*f**3*r**2 + 20520*D1*Ddd*f**3*r*s - 21950*D1*Ddd*f**3*r + 3700*D1*Ddd*f**3*s**2 - 12110*D1*Ddd*f**3*s + 9335*D1*Ddd*f**3 + 11880*D1*Ddd*f**2*g2*r**2 + 5808*D1*Ddd*f**2*g2*r*s - 13332*D1*Ddd*f**2*g2*r - 6072*D1*Ddd*f**2*g2*s**2 + 132*D1*Ddd*f**2*g2*s + 4422*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(535*r**2 + r*(800*s - 902) + 265*s**2 - 632*s + 507) + f**2*(-330*C*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) + 33*K*(57*r**2 + 2*r*(7*s - 57) - 43*s**2 - 14*s + 57) + 140*fd*(75*r**2 + r*(114*s - 113) + 39*s**2 - 83*s + 36) - 2541*r**2 - 2046*r*s + 7062*r + 495*s**2 + 4026*s - 2871) + 66*f*(fd*(10*C*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 10*s + 1) - K*(90*r**2 + 44*r*s - 101*r - 46*s**2 + s + 11) + 140*r**2 + 164*r*s - 196*r + 24*s**2 - 109*s + 66) + 6*g2*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) - 6*gd2*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2)) - 396*fd*g2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9))) + 2*Dd*f*(70*f**2*(100*r**2 + r*(152*s - 157) + 52*s**2 - 115*s + 60) + 33*f*(5*C*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8) + K*(-180*r**2 - 88*r*s + 281*r + 92*s**2 + 43*s - 101) + 280*r**2 + 328*r*s - 521*r + 48*s**2 - 318*s + 226) - 198*g2*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8))) - 19320*Dd**2*f**4*r**2 - 30240*Dd**2*f**4*r*s + 26880*Dd**2*f**4*r - 10920*Dd**2*f**4*s**2 + 20580*Dd**2*f**4*s - 8260*Dd**2*f**4 + 50460*Dd**2*f**3*r**2 + 61560*Dd**2*f**3*r*s - 65850*Dd**2*f**3*r + 11100*Dd**2*f**3*s**2 - 36330*Dd**2*f**3*s + 18670*Dd**2*f**3 + 35640*Dd**2*f**2*g2*r**2 + 17424*Dd**2*f**2*g2*r*s - 39996*Dd**2*f**2*g2*r - 18216*Dd**2*f**2*g2*s**2 + 396*Dd**2*f**2*g2*s + 8844*Dd**2*f**2*g2 - 99*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + D1*(2*Dd*(f*(20*r**2 + 56*r*s - 34*r + 36*s**2 - 46*s + 19) - fd*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15)) - Ddd*f*(20*r**2 + r*(56*s - 34) + 36*s**2 - 46*s + 19)) - 2*Dd**2*f*(30*r**2 + r*(84*s - 51) + 54*s**2 - 69*s + 19)) + b1*(-3300*C*D1**2*f*fd*r**2 - 9240*C*D1**2*f*fd*r*s + 6600*C*D1**2*f*fd*r - 5940*C*D1**2*f*fd*s**2 + 7920*C*D1**2*f*fd*s - 3300*C*D1**2*f*fd + 1650*C*D1**2*f*fdd*r**2 + 4620*C*D1**2*f*fdd*r*s - 3300*C*D1**2*f*fdd*r + 2970*C*D1**2*f*fdd*s**2 - 3960*C*D1**2*f*fdd*s + 1650*C*D1**2*f*fdd + 1650*C*D1**2*fd**2*r**2 + 4620*C*D1**2*fd**2*r*s - 3300*C*D1**2*fd**2*r + 2970*C*D1**2*fd**2*s**2 - 3960*C*D1**2*fd**2*s + 1650*C*D1**2*fd**2 - 6600*C*D1*Dd*f**2*r**2 - 18480*C*D1*Dd*f**2*r*s + 11220*C*D1*Dd*f**2*r - 11880*C*D1*Dd*f**2*s**2 + 15180*C*D1*Dd*f**2*s - 6270*C*D1*Dd*f**2 + 13200*C*D1*Dd*f*fd*r**2 + 36960*C*D1*Dd*f*fd*r*s - 24420*C*D1*Dd*f*fd*r + 23760*C*D1*Dd*f*fd*s**2 - 31020*C*D1*Dd*f*fd*s + 10560*C*D1*Dd*f*fd + 3300*C*D1*Ddd*f**2*r**2 + 9240*C*D1*Ddd*f**2*r*s - 5610*C*D1*Ddd*f**2*r + 5940*C*D1*Ddd*f**2*s**2 - 7590*C*D1*Ddd*f**2*s + 3135*C*D1*Ddd*f**2 + 9900*C*Dd**2*f**2*r**2 + 27720*C*Dd**2*f**2*r*s - 16830*C*Dd**2*f**2*r + 17820*C*Dd**2*f**2*s**2 - 22770*C*Dd**2*f**2*s + 6270*C*Dd**2*f**2 + 3762*D1**2*K*f*fd*r**2 + 924*D1**2*K*f*fd*r*s - 462*D1**2*K*f*fd*r - 2838*D1**2*K*f*fd*s**2 + 2838*D1**2*K*f*fd*s - 1419*D1**2*K*f*fd - 2970*D1**2*K*f*fdd*r**2 - 1452*D1**2*K*f*fdd*r*s + 726*D1**2*K*f*fdd*r + 1518*D1**2*K*f*fdd*s**2 - 1518*D1**2*K*f*fdd*s + 759*D1**2*K*f*fdd - 2970*D1**2*K*fd**2*r**2 - 1452*D1**2*K*fd**2*r*s + 726*D1**2*K*fd**2*r + 1518*D1**2*K*fd**2*s**2 - 1518*D1**2*K*fd**2*s + 99*D1**2*bdd1*f*(K - 1)*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) - 8025*D1**2*f**2*fd*r**2 - 12000*D1**2*f**2*fd*r*s + 10190*D1**2*f**2*fd*r - 3975*D1**2*f**2*fd*s**2 + 7490*D1**2*f**2*fd*s - 4140*D1**2*f**2*fd + 5250*D1**2*f**2*fdd*r**2 + 7980*D1**2*f**2*fdd*r*s - 6580*D1**2*f**2*fdd*r + 2730*D1**2*f**2*fdd*s**2 - 4900*D1**2*f**2*fdd*s + 2730*D1**2*f**2*fdd + 10500*D1**2*f*fd**2*r**2 + 15960*D1**2*f*fd**2*r*s - 13160*D1**2*f*fd**2*r + 5460*D1**2*f*fd**2*s**2 - 9800*D1**2*f*fd**2*s + 3780*D1**2*f*fd**2 - 5082*D1**2*f*fd*r**2 - 4092*D1**2*f*fd*r*s + 66*D1**2*f*fd*r + 990*D1**2*f*fd*s**2 - 2970*D1**2*f*fd*s + 825*D1**2*f*fd + 4620*D1**2*f*fdd*r**2 + 5412*D1**2*f*fdd*r*s - 1716*D1**2*f*fdd*r + 792*D1**2*f*fdd*s**2 + 198*D1**2*f*fdd*s + 231*D1**2*f*fdd + 1980*D1**2*f*gd2*r**2 + 5544*D1**2*f*gd2*r*s - 3960*D1**2*f*gd2*r + 3564*D1**2*f*gd2*s**2 - 5544*D1**2*f*gd2*s + 1980*D1**2*f*gd2 - 990*D1**2*f*gdd2*r**2 - 2772*D1**2*f*gdd2*r*s + 1980*D1**2*f*gdd2*r - 1782*D1**2*f*gdd2*s**2 + 2772*D1**2*f*gdd2*s - 990*D1**2*f*gdd2 + 4620*D1**2*fd**2*r**2 + 5412*D1**2*fd**2*r*s - 1716*D1**2*fd**2*r + 792*D1**2*fd**2*s**2 + 198*D1**2*fd**2*s - 1650*D1**2*fd**2 + 1980*D1**2*fd*g2*r**2 + 5544*D1**2*fd*g2*r*s - 3960*D1**2*fd*g2*r + 3564*D1**2*fd*g2*s**2 - 3960*D1**2*fd*g2*s + 1980*D1**2*fd*g2 - 1980*D1**2*fd*gd2*r**2 - 5544*D1**2*fd*gd2*r*s + 3960*D1**2*fd*gd2*r - 3564*D1**2*fd*gd2*s**2 + 4752*D1**2*fd*gd2*s - 1980*D1**2*fd*gd2 - 990*D1**2*fdd*g2*r**2 - 2772*D1**2*fdd*g2*r*s + 1980*D1**2*fdd*g2*r - 1782*D1**2*fdd*g2*s**2 + 1980*D1**2*fdd*g2*s - 990*D1**2*fdd*g2 + 7524*D1*Dd*K*f**2*r**2 + 1848*D1*Dd*K*f**2*r*s - 7986*D1*Dd*K*f**2*r - 5676*D1*Dd*K*f**2*s**2 + 1914*D1*Dd*K*f**2*s + 2343*D1*Dd*K*f**2 - 23760*D1*Dd*K*f*fd*r**2 - 11616*D1*Dd*K*f*fd*r*s + 16236*D1*Dd*K*f*fd*r + 12144*D1*Dd*K*f*fd*s**2 - 6204*D1*Dd*K*f*fd*s + 66*D1*Dd*K*f*fd - 10700*D1*Dd*f**3*r**2 - 16000*D1*Dd*f**3*r*s + 14700*D1*Dd*f**3*r - 5300*D1*Dd*f**3*s**2 + 10650*D1*Dd*f**3*s - 6675*D1*Dd*f**3 + 42000*D1*Dd*f**2*fd*r**2 + 63840*D1*Dd*f**2*fd*r*s - 55300*D1*Dd*f**2*fd*r + 21840*D1*Dd*f**2*fd*s**2 - 41020*D1*Dd*f**2*fd*s + 18060*D1*Dd*f**2*fd - 10164*D1*Dd*f**2*r**2 - 8184*D1*Dd*f**2*r*s + 12210*D1*Dd*f**2*r + 1980*D1*Dd*f**2*s**2 + 3102*D1*Dd*f**2*s - 4587*D1*Dd*f**2 + 36960*D1*Dd*f*fd*r**2 + 43296*D1*Dd*f*fd*r*s - 30756*D1*Dd*f*fd*r + 6336*D1*Dd*f*fd*s**2 - 11616*D1*Dd*f*fd*s + 3234*D1*Dd*f*fd + 7920*D1*Dd*f*g2*r**2 + 22176*D1*Dd*f*g2*r*s - 13464*D1*Dd*f*g2*r + 14256*D1*Dd*f*g2*s**2 - 18216*D1*Dd*f*g2*s + 7524*D1*Dd*f*g2 - 7920*D1*Dd*f*gd2*r**2 - 22176*D1*Dd*f*gd2*r*s + 14652*D1*Dd*f*gd2*r - 14256*D1*Dd*f*gd2*s**2 + 20196*D1*Dd*f*gd2*s - 6732*D1*Dd*f*gd2 - 7920*D1*Dd*fd*g2*r**2 - 22176*D1*Dd*fd*g2*r*s + 14652*D1*Dd*fd*g2*r - 14256*D1*Dd*fd*g2*s**2 + 17028*D1*Dd*fd*g2*s - 5940*D1*Dd*fd*g2 - 5940*D1*Ddd*K*f**2*r**2 - 2904*D1*Ddd*K*f**2*r*s + 6666*D1*Ddd*K*f**2*r + 3036*D1*Ddd*K*f**2*s**2 - 66*D1*Ddd*K*f**2*s - 2211*D1*Ddd*K*f**2 + 7000*D1*Ddd*f**3*r**2 + 10640*D1*Ddd*f**3*r*s - 9660*D1*Ddd*f**3*r + 3640*D1*Ddd*f**3*s**2 - 7140*D1*Ddd*f**3*s + 4410*D1*Ddd*f**3 + 9240*D1*Ddd*f**2*r**2 + 10824*D1*Ddd*f**2*r*s - 11946*D1*Ddd*f**2*r + 1584*D1*Ddd*f**2*s**2 - 6204*D1*Ddd*f**2*s + 5016*D1*Ddd*f**2 - 3960*D1*Ddd*f*g2*r**2 - 11088*D1*Ddd*f*g2*r*s + 6732*D1*Ddd*f*g2*r - 7128*D1*Ddd*f*g2*s**2 + 9108*D1*Ddd*f*g2*s - 3762*D1*Ddd*f*g2 - 198*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) - fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 21*s + 5)) - Dd*f*(40*r**2 + 2*r*(56*s - 31) + 72*s**2 - 90*s + 25)) - 17820*Dd**2*K*f**2*r**2 - 8712*Dd**2*K*f**2*r*s + 19998*Dd**2*K*f**2*r + 9108*Dd**2*K*f**2*s**2 - 198*Dd**2*K*f**2*s - 4422*Dd**2*K*f**2 + 21000*Dd**2*f**3*r**2 + 31920*Dd**2*f**3*r*s - 28980*Dd**2*f**3*r + 10920*Dd**2*f**3*s**2 - 21420*Dd**2*f**3*s + 8820*Dd**2*f**3 + 27720*Dd**2*f**2*r**2 + 32472*Dd**2*f**2*r*s - 35838*Dd**2*f**2*r + 4752*Dd**2*f**2*s**2 - 18612*Dd**2*f**2*s + 10032*Dd**2*f**2 - 11880*Dd**2*f*g2*r**2 - 33264*Dd**2*f*g2*r*s + 20196*Dd**2*f*g2*r - 21384*Dd**2*f*g2*s**2 + 27324*Dd**2*f*g2*s - 7524*Dd**2*f*g2))/(693*d**2*k3**5) + 8*D1**2*Pk2*Pkd3*ct**6*k1**2*(-198*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(5*f**3*s*(191*r + 191*s - 135) - 4*f**2*(35*fd*(6*s - 1)*(4*r + 4*s - 3) - 33*s*(5*C*r + 5*C*s + r + s - 6)) - 33*f*(5*fd*(r*(2*C + 1)*(4*s - 1) + s**2*(8*C + 4) - s*(6*C + 6) + 3) + 12*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 396*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(140*f**2*(8*s - 1)*(4*r + 4*s - 3) + 165*f*(r*(2*C + 1)*(8*s - 1) + s**2*(16*C + 8) - s*(8*C + 16) + 3) - 396*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(5*f**2*(fd*(191*r*(3*s - 1) + 573*s**2 - 629*s + 191) - 28*fdd*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4)) + f*(-140*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) + 132*fd*(5*C*(2*s - 1)*(r + s - 1) + r*(2*s - 1) + 2*s**2 + 3*s + 1) - 165*fdd*(2*C*(2*s - 1)*(r + s - 1) + r*(2*s - 1) + 2*s**2 + 1) - 198*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) - 165*fd**2*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 - 2) - 396*fd*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 396*fdd*g2*(s - 1)*(r + s - 1)) - 198*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(955*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + 4*f**2*(165*C*(r*(4*s - 1) + (1 - 2*s)**2) - 35*fd*(24*s - 7)*(4*r + 4*s - 3) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2) - 66*f*(5*fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + r*(8*s - 3) + 8*s**2 - 4*s + 1) + 6*g2*r*(8*s - 2) + 12*g2*(1 - 2*s)**2 + 6*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 396*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(560*f**2 + f*(330*C + 165) - 396*g2)) - Dd**2*f*(560*f**2 + f*(330*C + 165) - 396*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - f*(D1**2*(140*bdd1*f**2*s*(4*r + 4*s - 3) - 396*bdd1*g2*s*(r + s) - 15*f*(-11*bdd1*s*(2*C*r + 2*C*s + r + s - 3) + 45*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 420*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 15*D1*f*(Dd*(45*f*(r*(4*s - 1) + (1 - 2*s)**2) - 28*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 28*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 420*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**3) + 5*D1**2*Pk2*Pkd3*ct**6*k2**6*(D1**2*(f**2*(fd*(112*C - 56)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(56*C - 28)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(112*C - 56)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 66*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(56*C - 28)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(33*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(28 - 56*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 33*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(56*C*f + 33*K*b1 - 28*f - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(56*C*f + 33*K*b1 - 28*f - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**7) + 5*D1**2*Pk2*Pkd3*ct**6*k2**4*(-3504*C*D1**2*f**2*fd*r**2 - 5184*C*D1**2*f**2*fd*r*s + 4064*C*D1**2*f**2*fd*r - 1680*C*D1**2*f**2*fd*s**2 + 2848*C*D1**2*f**2*fd*s - 1728*C*D1**2*f**2*fd + 1752*C*D1**2*f**2*fdd*r**2 + 2592*C*D1**2*f**2*fdd*r*s - 2032*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 1424*C*D1**2*f**2*fdd*s + 864*C*D1**2*f**2*fdd + 3504*C*D1**2*f*fd**2*r**2 + 5184*C*D1**2*f*fd**2*r*s - 4064*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 2848*C*D1**2*f*fd**2*s + 864*C*D1**2*f*fd**2 - 4672*C*D1*Dd*f**3*r**2 - 6912*C*D1*Dd*f**3*r*s + 6400*C*D1*Dd*f**3*r - 2240*C*D1*Dd*f**3*s**2 + 4576*C*D1*Dd*f**3*s - 2896*C*D1*Dd*f**3 + 14016*C*D1*Dd*f**2*fd*r**2 + 20736*C*D1*Dd*f**2*fd*r*s - 17728*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 12560*C*D1*Dd*f**2*fd*s + 5488*C*D1*Dd*f**2*fd + 2336*C*D1*Ddd*f**3*r**2 + 3456*C*D1*Ddd*f**3*r*s - 3200*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 2288*C*D1*Ddd*f**3*s + 1448*C*D1*Ddd*f**3 + 7008*C*Dd**2*f**3*r**2 + 10368*C*Dd**2*f**3*r*s - 9600*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 6864*C*Dd**2*f**3*s + 2896*C*Dd**2*f**3 - 1188*D1**2*K*b1*f*fd*r**2 - 1848*D1**2*K*b1*f*fd*r*s + 924*D1**2*K*b1*f*fd*r - 660*D1**2*K*b1*f*fd*s**2 + 660*D1**2*K*b1*f*fd*s - 330*D1**2*K*b1*f*fd + 594*D1**2*K*b1*f*fdd*r**2 + 924*D1**2*K*b1*f*fdd*r*s - 462*D1**2*K*b1*f*fdd*r + 330*D1**2*K*b1*f*fdd*s**2 - 330*D1**2*K*b1*f*fdd*s + 165*D1**2*K*b1*f*fdd + 594*D1**2*K*b1*fd**2*r**2 + 924*D1**2*K*b1*fd**2*r*s - 462*D1**2*K*b1*fd**2*r + 330*D1**2*K*b1*fd**2*s**2 - 330*D1**2*K*b1*fd**2*s + 297*D1**2*K*bdd1*f**2*r**2 + 462*D1**2*K*bdd1*f**2*r*s - 594*D1**2*K*bdd1*f**2*r + 165*D1**2*K*bdd1*f**2*s**2 - 462*D1**2*K*bdd1*f**2*s + 297*D1**2*K*bdd1*f**2 + 198*D1**2*b1*f**2*fd*r**2 + 198*D1**2*b1*f**2*fd*r*s - 198*D1**2*b1*f**2*fd*r - 66*D1**2*b1*f**2*fd*s + 66*D1**2*b1*f**2*fd - 198*D1**2*b1*f**2*fdd*r**2 - 198*D1**2*b1*f**2*fdd*r*s + 198*D1**2*b1*f**2*fdd*r + 66*D1**2*b1*f**2*fdd*s - 66*D1**2*b1*f**2*fdd - 396*D1**2*b1*f*fd**2*r**2 - 396*D1**2*b1*f*fd**2*r*s + 396*D1**2*b1*f*fd**2*r + 132*D1**2*b1*f*fd**2*s - 66*D1**2*b1*f*fd**2 + 264*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 132*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 132*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 660*D1**2*b2*f*fd*r**2 - 1320*D1**2*b2*f*fd*r*s + 660*D1**2*b2*f*fd*r - 660*D1**2*b2*f*fd*s**2 + 660*D1**2*b2*f*fd*s - 330*D1**2*b2*f*fd + 330*D1**2*b2*f*fdd*r**2 + 660*D1**2*b2*f*fdd*r*s - 330*D1**2*b2*f*fdd*r + 330*D1**2*b2*f*fdd*s**2 - 330*D1**2*b2*f*fdd*s + 165*D1**2*b2*f*fdd + 330*D1**2*b2*fd**2*r**2 + 660*D1**2*b2*fd**2*r*s - 330*D1**2*b2*fd**2*r + 330*D1**2*b2*fd**2*s**2 - 330*D1**2*b2*fd**2*s - 66*D1**2*bdd1*f**3*r**2 - 66*D1**2*bdd1*f**3*r*s + 132*D1**2*bdd1*f**3*r + 66*D1**2*bdd1*f**3*s - 66*D1**2*bdd1*f**3 - 66*D1**2*bdd1*f**2*r**2 - 66*D1**2*bdd1*f**2*r*s + 132*D1**2*bdd1*f**2*r + 66*D1**2*bdd1*f**2*s - 66*D1**2*bdd1*f**2 + 165*D1**2*bdd2*f**2*r**2 + 330*D1**2*bdd2*f**2*r*s - 330*D1**2*bdd2*f**2*r + 165*D1**2*bdd2*f**2*s**2 - 330*D1**2*bdd2*f**2*s + 165*D1**2*bdd2*f**2 + 2208*D1**2*f**2*fd*r**2 + 3048*D1**2*f**2*fd*r*s - 2488*D1**2*f**2*fd*r + 840*D1**2*f**2*fd*s**2 - 1576*D1**2*f**2*fd*s + 1016*D1**2*f**2*fd - 1104*D1**2*f**2*fdd*r**2 - 1524*D1**2*f**2*fdd*r*s + 1244*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 788*D1**2*f**2*fdd*s - 508*D1**2*f**2*fdd + 1188*D1**2*f**2*gd2*r**2 + 1848*D1**2*f**2*gd2*r*s - 2376*D1**2*f**2*gd2*r + 660*D1**2*f**2*gd2*s**2 - 1848*D1**2*f**2*gd2*s + 1188*D1**2*f**2*gd2 - 594*D1**2*f**2*gdd2*r**2 - 924*D1**2*f**2*gdd2*r*s + 1188*D1**2*f**2*gdd2*r - 330*D1**2*f**2*gdd2*s**2 + 924*D1**2*f**2*gdd2*s - 594*D1**2*f**2*gdd2 - 2208*D1**2*f*fd**2*r**2 - 3048*D1**2*f*fd**2*r*s + 2488*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1576*D1**2*f*fd**2*s - 508*D1**2*f*fd**2 + 2376*D1**2*f*fd*g2*r**2 + 3696*D1**2*f*fd*g2*r*s - 1848*D1**2*f*fd*g2*r + 1320*D1**2*f*fd*g2*s**2 - 1320*D1**2*f*fd*g2*s + 660*D1**2*f*fd*g2 - 2376*D1**2*f*fd*gd2*r**2 - 3696*D1**2*f*fd*gd2*r*s + 3300*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 2508*D1**2*f*fd*gd2*s - 924*D1**2*f*fd*gd2 - 1188*D1**2*f*fdd*g2*r**2 - 1848*D1**2*f*fdd*g2*r*s + 924*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 1188*D1**2*fd**2*g2*r**2 - 1848*D1**2*fd**2*g2*r*s + 924*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s - 2376*D1*Dd*K*b1*f**2*r**2 - 3696*D1*Dd*K*b1*f**2*r*s + 3300*D1*Dd*K*b1*f**2*r - 1320*D1*Dd*K*b1*f**2*s**2 + 2508*D1*Dd*K*b1*f**2*s - 1518*D1*Dd*K*b1*f**2 + 4752*D1*Dd*K*b1*f*fd*r**2 + 7392*D1*Dd*K*b1*f*fd*r*s - 5148*D1*Dd*K*b1*f*fd*r + 2640*D1*Dd*K*b1*f*fd*s**2 - 3828*D1*Dd*K*b1*f*fd*s + 1254*D1*Dd*K*b1*f*fd + 264*D1*Dd*b1*f**3*r**2 + 264*D1*Dd*b1*f**3*r*s - 330*D1*Dd*b1*f**3*r - 132*D1*Dd*b1*f**3*s + 132*D1*Dd*b1*f**3 - 1584*D1*Dd*b1*f**2*fd*r**2 - 1584*D1*Dd*b1*f**2*fd*r*s + 1782*D1*Dd*b1*f**2*fd*r + 660*D1*Dd*b1*f**2*fd*s - 462*D1*Dd*b1*f**2*fd + 528*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 660*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s + 264*D1*Dd*b1*f**2 - 1056*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 924*D1*Dd*b1*f*fd*r + 264*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd - 1320*D1*Dd*b2*f**2*r**2 - 2640*D1*Dd*b2*f**2*r*s + 1980*D1*Dd*b2*f**2*r - 1320*D1*Dd*b2*f**2*s**2 + 1980*D1*Dd*b2*f**2*s - 990*D1*Dd*b2*f**2 + 2640*D1*Dd*b2*f*fd*r**2 + 5280*D1*Dd*b2*f*fd*r*s - 3300*D1*Dd*b2*f*fd*r + 2640*D1*Dd*b2*f*fd*s**2 - 3300*D1*Dd*b2*f*fd*s + 990*D1*Dd*b2*f*fd + 2944*D1*Dd*f**3*r**2 + 4064*D1*Dd*f**3*r*s - 3960*D1*Dd*f**3*r + 1120*D1*Dd*f**3*s**2 - 2592*D1*Dd*f**3*s + 1752*D1*Dd*f**3 - 8832*D1*Dd*f**2*fd*r**2 - 12192*D1*Dd*f**2*fd*r*s + 10916*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 7040*D1*Dd*f**2*fd*s - 3276*D1*Dd*f**2*fd + 4752*D1*Dd*f**2*g2*r**2 + 7392*D1*Dd*f**2*g2*r*s - 6600*D1*Dd*f**2*g2*r + 2640*D1*Dd*f**2*g2*s**2 - 5016*D1*Dd*f**2*g2*s + 3036*D1*Dd*f**2*g2 - 4752*D1*Dd*f**2*gd2*r**2 - 7392*D1*Dd*f**2*gd2*r*s + 8052*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 6204*D1*Dd*f**2*gd2*s - 3300*D1*Dd*f**2*gd2 - 9504*D1*Dd*f*fd*g2*r**2 - 14784*D1*Dd*f*fd*g2*r*s + 10296*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 7656*D1*Dd*f*fd*g2*s - 2508*D1*Dd*f*fd*g2 + 1188*D1*Ddd*K*b1*f**2*r**2 + 1848*D1*Ddd*K*b1*f**2*r*s - 1650*D1*Ddd*K*b1*f**2*r + 660*D1*Ddd*K*b1*f**2*s**2 - 1254*D1*Ddd*K*b1*f**2*s + 759*D1*Ddd*K*b1*f**2 - 264*D1*Ddd*b1*f**3*r**2 - 264*D1*Ddd*b1*f**3*r*s + 330*D1*Ddd*b1*f**3*r + 132*D1*Ddd*b1*f**3*s - 132*D1*Ddd*b1*f**3 - 264*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 330*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s - 132*D1*Ddd*b1*f**2 + 660*D1*Ddd*b2*f**2*r**2 + 1320*D1*Ddd*b2*f**2*r*s - 990*D1*Ddd*b2*f**2*r + 660*D1*Ddd*b2*f**2*s**2 - 990*D1*Ddd*b2*f**2*s + 495*D1*Ddd*b2*f**2 - 1472*D1*Ddd*f**3*r**2 - 2032*D1*Ddd*f**3*r*s + 1980*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 1296*D1*Ddd*f**3*s - 876*D1*Ddd*f**3 - 2376*D1*Ddd*f**2*g2*r**2 - 3696*D1*Ddd*f**2*g2*r*s + 3300*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 2508*D1*Ddd*f**2*g2*s - 1518*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (r + s - 1)*(K*(9*r + 5*s - 9) - 2*r + 2)) + fd*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(K*(36*r**2 + 56*r*s - 61*r + 20*s**2 - 47*s + 25) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) - 330*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 3564*Dd**2*K*b1*f**2*r**2 + 5544*Dd**2*K*b1*f**2*r*s - 4950*Dd**2*K*b1*f**2*r + 1980*Dd**2*K*b1*f**2*s**2 - 3762*Dd**2*K*b1*f**2*s + 1518*Dd**2*K*b1*f**2 - 792*Dd**2*b1*f**3*r**2 - 792*Dd**2*b1*f**3*r*s + 990*Dd**2*b1*f**3*r + 396*Dd**2*b1*f**3*s - 264*Dd**2*b1*f**3 - 792*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 990*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s - 264*Dd**2*b1*f**2 + 1980*Dd**2*b2*f**2*r**2 + 3960*Dd**2*b2*f**2*r*s - 2970*Dd**2*b2*f**2*r + 1980*Dd**2*b2*f**2*s**2 - 2970*Dd**2*b2*f**2*s + 990*Dd**2*b2*f**2 - 4416*Dd**2*f**3*r**2 - 6096*Dd**2*f**3*r*s + 5940*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 3888*Dd**2*f**3*s - 1752*Dd**2*f**3 - 7128*Dd**2*f**2*g2*r**2 - 11088*Dd**2*f**2*g2*r*s + 9900*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 7524*Dd**2*f**2*g2*s - 3036*Dd**2*f**2*g2)/(693*d**2*k3**5) - 10*D1**2*Pk2*Pkd3*ct**6*k2**2*(672*C*D1**2*f**2*fd*r*s - 224*C*D1**2*f**2*fd*r + 672*C*D1**2*f**2*fd*s**2 - 672*C*D1**2*f**2*fd*s + 224*C*D1**2*f**2*fd - 336*C*D1**2*f**2*fdd*r*s + 112*C*D1**2*f**2*fdd*r - 336*C*D1**2*f**2*fdd*s**2 + 336*C*D1**2*f**2*fdd*s - 112*C*D1**2*f**2*fdd - 672*C*D1**2*f*fd**2*r*s + 224*C*D1**2*f*fd**2*r - 672*C*D1**2*f*fd**2*s**2 + 672*C*D1**2*f*fd**2*s - 112*C*D1**2*f*fd**2 + 896*C*D1*Dd*f**3*r*s - 224*C*D1*Dd*f**3*r + 896*C*D1*Dd*f**3*s**2 - 896*C*D1*Dd*f**3*s + 224*C*D1*Dd*f**3 - 2688*C*D1*Dd*f**2*fd*r*s + 784*C*D1*Dd*f**2*fd*r - 2688*C*D1*Dd*f**2*fd*s**2 + 2688*C*D1*Dd*f**2*fd*s - 560*C*D1*Dd*f**2*fd - 448*C*D1*Ddd*f**3*r*s + 112*C*D1*Ddd*f**3*r - 448*C*D1*Ddd*f**3*s**2 + 448*C*D1*Ddd*f**3*s - 112*C*D1*Ddd*f**3 - 1344*C*Dd**2*f**3*r*s + 336*C*Dd**2*f**3*r - 1344*C*Dd**2*f**3*s**2 + 1344*C*Dd**2*f**3*s - 224*C*Dd**2*f**3 + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r + 264*D1**2*K*b1*f*fd*s**2 - 264*D1**2*K*b1*f*fd*s + 132*D1**2*K*b1*f*fd - 132*D1**2*K*b1*f*fdd*r*s + 66*D1**2*K*b1*f*fdd*r - 132*D1**2*K*b1*f*fdd*s**2 + 132*D1**2*K*b1*f*fdd*s - 66*D1**2*K*b1*f*fdd - 132*D1**2*K*b1*fd**2*r*s + 66*D1**2*K*b1*fd**2*r - 132*D1**2*K*b1*fd**2*s**2 + 132*D1**2*K*b1*fd**2*s + 99*D1**2*b1*f**2*fd*r**2 + 99*D1**2*b1*f**2*fd*r*s - 99*D1**2*b1*f**2*fd*r - 33*D1**2*b1*f**2*fd*s + 33*D1**2*b1*f**2*fd - 99*D1**2*b1*f**2*fdd*r**2 - 99*D1**2*b1*f**2*fdd*r*s + 99*D1**2*b1*f**2*fdd*r + 33*D1**2*b1*f**2*fdd*s - 33*D1**2*b1*f**2*fdd - 198*D1**2*b1*f*fd**2*r**2 - 198*D1**2*b1*f*fd**2*r*s + 198*D1**2*b1*f*fd**2*r + 66*D1**2*b1*f*fd**2*s - 33*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 33*D1**2*b1*fd**2*r + 264*D1**2*b2*f*fd*r*s - 132*D1**2*b2*f*fd*r + 264*D1**2*b2*f*fd*s**2 - 264*D1**2*b2*f*fd*s + 132*D1**2*b2*f*fd - 132*D1**2*b2*f*fdd*r*s + 66*D1**2*b2*f*fdd*r - 132*D1**2*b2*f*fdd*s**2 + 132*D1**2*b2*f*fdd*s - 66*D1**2*b2*f*fdd - 132*D1**2*b2*fd**2*r*s + 66*D1**2*b2*fd**2*r - 132*D1**2*b2*fd**2*s**2 + 132*D1**2*b2*fd**2*s + 132*D1**2*bd2*f**2*r*s + 132*D1**2*bd2*f**2*s**2 - 132*D1**2*bd2*f**2*s - 264*D1**2*bd2*f*fd*r*s + 66*D1**2*bd2*f*fd*r - 264*D1**2*bd2*f*fd*s**2 + 264*D1**2*bd2*f*fd*s - 66*D1**2*bd2*f*fd - 33*D1**2*bdd1*f**2*(r + s - 1)*(2*K*s + f*(r - 1) + r - 1) - 66*D1**2*bdd2*f**2*r*s - 66*D1**2*bdd2*f**2*s**2 + 66*D1**2*bdd2*f**2*s + 228*D1**2*f**2*fd*r**2 - 108*D1**2*f**2*fd*r*s - 116*D1**2*f**2*fd*r - 336*D1**2*f**2*fd*s**2 + 260*D1**2*f**2*fd*s - 36*D1**2*f**2*fd - 114*D1**2*f**2*fdd*r**2 + 54*D1**2*f**2*fdd*r*s + 58*D1**2*f**2*fdd*r + 168*D1**2*f**2*fdd*s**2 - 130*D1**2*f**2*fdd*s + 18*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s - 228*D1**2*f*fd**2*r**2 + 108*D1**2*f*fd**2*r*s + 116*D1**2*f*fd**2*r + 336*D1**2*f*fd**2*s**2 - 260*D1**2*f*fd**2*s + 18*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r*s - 132*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 528*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s + 528*D1*Dd*K*b1*f**2*r*s - 132*D1*Dd*K*b1*f**2*r + 528*D1*Dd*K*b1*f**2*s**2 - 528*D1*Dd*K*b1*f**2*s + 132*D1*Dd*K*b1*f**2 - 1056*D1*Dd*K*b1*f*fd*r*s + 396*D1*Dd*K*b1*f*fd*r - 1056*D1*Dd*K*b1*f*fd*s**2 + 1056*D1*Dd*K*b1*f*fd*s - 264*D1*Dd*K*b1*f*fd + 132*D1*Dd*b1*f**3*r**2 + 132*D1*Dd*b1*f**3*r*s - 165*D1*Dd*b1*f**3*r - 66*D1*Dd*b1*f**3*s + 66*D1*Dd*b1*f**3 - 792*D1*Dd*b1*f**2*fd*r**2 - 792*D1*Dd*b1*f**2*fd*r*s + 891*D1*Dd*b1*f**2*fd*r + 330*D1*Dd*b1*f**2*fd*s - 231*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 330*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 462*D1*Dd*b1*f*fd*r + 132*D1*Dd*b1*f*fd*s - 66*D1*Dd*b1*f*fd + 528*D1*Dd*b2*f**2*r*s - 132*D1*Dd*b2*f**2*r + 528*D1*Dd*b2*f**2*s**2 - 528*D1*Dd*b2*f**2*s + 132*D1*Dd*b2*f**2 - 1056*D1*Dd*b2*f*fd*r*s + 396*D1*Dd*b2*f*fd*r - 1056*D1*Dd*b2*f*fd*s**2 + 1056*D1*Dd*b2*f*fd*s - 264*D1*Dd*b2*f*fd - 528*D1*Dd*bd2*f**2*r*s + 66*D1*Dd*bd2*f**2*r - 528*D1*Dd*bd2*f**2*s**2 + 528*D1*Dd*bd2*f**2*s - 66*D1*Dd*bd2*f**2 + 304*D1*Dd*f**3*r**2 - 144*D1*Dd*f**3*r*s - 268*D1*Dd*f**3*r - 448*D1*Dd*f**3*s**2 + 296*D1*Dd*f**3*s + 40*D1*Dd*f**3 - 912*D1*Dd*f**2*fd*r**2 + 432*D1*Dd*f**2*fd*r*s + 634*D1*Dd*f**2*fd*r + 1344*D1*Dd*f**2*fd*s**2 - 964*D1*Dd*f**2*fd*s + 14*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r*s - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1056*D1*Dd*f**2*gd2*s + 132*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r*s - 792*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2112*D1*Dd*f*fd*g2*s + 528*D1*Dd*f*fd*g2 - 264*D1*Ddd*K*b1*f**2*r*s + 66*D1*Ddd*K*b1*f**2*r - 264*D1*Ddd*K*b1*f**2*s**2 + 264*D1*Ddd*K*b1*f**2*s - 66*D1*Ddd*K*b1*f**2 - 132*D1*Ddd*b1*f**3*r**2 - 132*D1*Ddd*b1*f**3*r*s + 165*D1*Ddd*b1*f**3*r + 66*D1*Ddd*b1*f**3*s - 66*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 165*D1*Ddd*b1*f**2*r + 66*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 264*D1*Ddd*b2*f**2*r*s + 66*D1*Ddd*b2*f**2*r - 264*D1*Ddd*b2*f**2*s**2 + 264*D1*Ddd*b2*f**2*s - 66*D1*Ddd*b2*f**2 - 152*D1*Ddd*f**3*r**2 + 72*D1*Ddd*f**3*r*s + 134*D1*Ddd*f**3*r + 224*D1*Ddd*f**3*s**2 - 148*D1*Ddd*f**3*s - 20*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r*s - 132*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 528*D1*Ddd*f**2*g2*s + 132*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) + f*(fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + (2*r + 2*s - 2)*(2*K*s + r - 1)) - fd*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(2*K*(8*r*s - r + 8*s**2 - 8*s + 1) + f*(8*r**2 + r*(8*s - 13) - 6*s + 5) + 8*r**2 + 8*r*s - 13*r - 6*s + 5)) - 792*Dd**2*K*b1*f**2*r*s + 198*Dd**2*K*b1*f**2*r - 792*Dd**2*K*b1*f**2*s**2 + 792*Dd**2*K*b1*f**2*s - 132*Dd**2*K*b1*f**2 - 396*Dd**2*b1*f**3*r**2 - 396*Dd**2*b1*f**3*r*s + 495*Dd**2*b1*f**3*r + 198*Dd**2*b1*f**3*s - 132*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 495*Dd**2*b1*f**2*r + 198*Dd**2*b1*f**2*s - 132*Dd**2*b1*f**2 - 792*Dd**2*b2*f**2*r*s + 198*Dd**2*b2*f**2*r - 792*Dd**2*b2*f**2*s**2 + 792*Dd**2*b2*f**2*s - 132*Dd**2*b2*f**2 - 456*Dd**2*f**3*r**2 + 216*Dd**2*f**3*r*s + 402*Dd**2*f**3*r + 672*Dd**2*f**3*s**2 - 444*Dd**2*f**3*s - 40*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r*s - 396*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 1584*Dd**2*f**2*g2*s + 264*Dd**2*f**2*g2)/(693*d**2*k3**3) - D1**2*Pk2*Pkd3*ct**5*f*k2**5*(200*C - 100)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4))/(693*d**2*k1*k3**5) + D1**2*Pk2*Pkd3*ct**5*f*k2**3*(200*C - 100)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4))/(693*d**2*k1*k3**3) + 2*D1**2*Pk2*Pkd3*ct**5*k1**5*k2*(17940*C*D1**2*f**2*fd*r**2 + 35880*C*D1**2*f**2*fd*r*s - 23920*C*D1**2*f**2*fd*r + 17940*C*D1**2*f**2*fd*s**2 - 23920*C*D1**2*f**2*fd*s + 11960*C*D1**2*f**2*fd - 21840*C*D1**2*f**2*fdd*r**2 - 43680*C*D1**2*f**2*fdd*r*s + 29120*C*D1**2*f**2*fdd*r - 21840*C*D1**2*f**2*fdd*s**2 + 29120*C*D1**2*f**2*fdd*s - 14560*C*D1**2*f**2*fdd - 43680*C*D1**2*f*fd**2*r**2 - 87360*C*D1**2*f*fd**2*r*s + 58240*C*D1**2*f*fd**2*r - 43680*C*D1**2*f*fd**2*s**2 + 58240*C*D1**2*f*fd**2*s - 14560*C*D1**2*f*fd**2 + 23920*C*D1*Dd*f**3*r**2 + 47840*C*D1*Dd*f**3*r*s - 35880*C*D1*Dd*f**3*r + 23920*C*D1*Dd*f**3*s**2 - 35880*C*D1*Dd*f**3*s + 17940*C*D1*Dd*f**3 - 174720*C*D1*Dd*f**2*fd*r**2 - 349440*C*D1*Dd*f**2*fd*r*s + 247520*C*D1*Dd*f**2*fd*r - 174720*C*D1*Dd*f**2*fd*s**2 + 247520*C*D1*Dd*f**2*fd*s - 87360*C*D1*Dd*f**2*fd - 29120*C*D1*Ddd*f**3*r**2 - 58240*C*D1*Ddd*f**3*r*s + 43680*C*D1*Ddd*f**3*r - 29120*C*D1*Ddd*f**3*s**2 + 43680*C*D1*Ddd*f**3*s - 21840*C*D1*Ddd*f**3 - 87360*C*Dd**2*f**3*r**2 - 174720*C*Dd**2*f**3*r*s + 131040*C*Dd**2*f**3*r - 87360*C*Dd**2*f**3*s**2 + 131040*C*Dd**2*f**3*s - 43680*C*Dd**2*f**3 + 6864*D1**2*K*b1*f*fd*r**2 + 13728*D1**2*K*b1*f*fd*r*s - 6864*D1**2*K*b1*f*fd*r + 6864*D1**2*K*b1*f*fd*s**2 - 6864*D1**2*K*b1*f*fd*s + 3432*D1**2*K*b1*f*fd - 8580*D1**2*K*b1*f*fdd*r**2 - 17160*D1**2*K*b1*f*fdd*r*s + 8580*D1**2*K*b1*f*fdd*r - 8580*D1**2*K*b1*f*fdd*s**2 + 8580*D1**2*K*b1*f*fdd*s - 4290*D1**2*K*b1*f*fdd - 8580*D1**2*K*b1*fd**2*r**2 - 17160*D1**2*K*b1*fd**2*r*s + 8580*D1**2*K*b1*fd**2*r - 8580*D1**2*K*b1*fd**2*s**2 + 8580*D1**2*K*b1*fd**2*s - 6864*D1**2*b1*f*fd*r**2 - 13728*D1**2*b1*f*fd*r*s + 6864*D1**2*b1*f*fd*r - 6864*D1**2*b1*f*fd*s**2 + 6864*D1**2*b1*f*fd*s - 3432*D1**2*b1*f*fd + 8580*D1**2*b1*f*fdd*r**2 + 17160*D1**2*b1*f*fdd*r*s - 8580*D1**2*b1*f*fdd*r + 8580*D1**2*b1*f*fdd*s**2 - 8580*D1**2*b1*f*fdd*s + 4290*D1**2*b1*f*fdd + 8580*D1**2*b1*fd**2*r**2 + 17160*D1**2*b1*fd**2*r*s - 8580*D1**2*b1*fd**2*r + 8580*D1**2*b1*fd**2*s**2 - 8580*D1**2*b1*fd**2*s - 4290*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 30240*D1**2*f**3*fd*r**2 + 60480*D1**2*f**3*fd*r*s - 45360*D1**2*f**3*fd*r + 30240*D1**2*f**3*fd*s**2 - 45360*D1**2*f**3*fd*s + 22680*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 - 17940*D1**2*f**2*fd*r**2 - 35880*D1**2*f**2*fd*r*s + 23920*D1**2*f**2*fd*r - 17940*D1**2*f**2*fd*s**2 + 23920*D1**2*f**2*fd*s - 11960*D1**2*f**2*fd + 21840*D1**2*f**2*fdd*r**2 + 43680*D1**2*f**2*fdd*r*s - 29120*D1**2*f**2*fdd*r + 21840*D1**2*f**2*fdd*s**2 - 29120*D1**2*f**2*fdd*s + 14560*D1**2*f**2*fdd - 6864*D1**2*f**2*gd2*r**2 - 13728*D1**2*f**2*gd2*r*s + 13728*D1**2*f**2*gd2*r - 6864*D1**2*f**2*gd2*s**2 + 13728*D1**2*f**2*gd2*s - 6864*D1**2*f**2*gd2 + 8580*D1**2*f**2*gdd2*r**2 + 17160*D1**2*f**2*gdd2*r*s - 17160*D1**2*f**2*gdd2*r + 8580*D1**2*f**2*gdd2*s**2 - 17160*D1**2*f**2*gdd2*s + 8580*D1**2*f**2*gdd2 + 43680*D1**2*f*fd**2*r**2 + 87360*D1**2*f*fd**2*r*s - 58240*D1**2*f*fd**2*r + 43680*D1**2*f*fd**2*s**2 - 58240*D1**2*f*fd**2*s + 14560*D1**2*f*fd**2 - 13728*D1**2*f*fd*g2*r**2 - 27456*D1**2*f*fd*g2*r*s + 13728*D1**2*f*fd*g2*r - 13728*D1**2*f*fd*g2*s**2 + 13728*D1**2*f*fd*g2*s - 6864*D1**2*f*fd*g2 + 34320*D1**2*f*fd*gd2*r**2 + 68640*D1**2*f*fd*gd2*r*s - 51480*D1**2*f*fd*gd2*r + 34320*D1**2*f*fd*gd2*s**2 - 51480*D1**2*f*fd*gd2*s + 17160*D1**2*f*fd*gd2 + 17160*D1**2*f*fdd*g2*r**2 + 34320*D1**2*f*fdd*g2*r*s - 17160*D1**2*f*fdd*g2*r + 17160*D1**2*f*fdd*g2*s**2 - 17160*D1**2*f*fdd*g2*s + 8580*D1**2*f*fdd*g2 + 17160*D1**2*fd**2*g2*r**2 + 34320*D1**2*fd**2*g2*r*s - 17160*D1**2*fd**2*g2*r + 17160*D1**2*fd**2*g2*s**2 - 17160*D1**2*fd**2*g2*s + 13728*D1*Dd*K*b1*f**2*r**2 + 27456*D1*Dd*K*b1*f**2*r*s - 20592*D1*Dd*K*b1*f**2*r + 13728*D1*Dd*K*b1*f**2*s**2 - 20592*D1*Dd*K*b1*f**2*s + 10296*D1*Dd*K*b1*f**2 - 68640*D1*Dd*K*b1*f*fd*r**2 - 137280*D1*Dd*K*b1*f*fd*r*s + 85800*D1*Dd*K*b1*f*fd*r - 68640*D1*Dd*K*b1*f*fd*s**2 + 85800*D1*Dd*K*b1*f*fd*s - 25740*D1*Dd*K*b1*f*fd - 13728*D1*Dd*b1*f**2*r**2 - 27456*D1*Dd*b1*f**2*r*s + 20592*D1*Dd*b1*f**2*r - 13728*D1*Dd*b1*f**2*s**2 + 20592*D1*Dd*b1*f**2*s - 10296*D1*Dd*b1*f**2 + 68640*D1*Dd*b1*f*fd*r**2 + 137280*D1*Dd*b1*f*fd*r*s - 85800*D1*Dd*b1*f*fd*r + 68640*D1*Dd*b1*f*fd*s**2 - 85800*D1*Dd*b1*f*fd*s + 25740*D1*Dd*b1*f*fd + 30240*D1*Dd*f**4*r**2 + 60480*D1*Dd*f**4*r*s - 45360*D1*Dd*f**4*r + 30240*D1*Dd*f**4*s**2 - 45360*D1*Dd*f**4*s + 22680*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd - 23920*D1*Dd*f**3*r**2 - 47840*D1*Dd*f**3*r*s + 35880*D1*Dd*f**3*r - 23920*D1*Dd*f**3*s**2 + 35880*D1*Dd*f**3*s - 17940*D1*Dd*f**3 + 174720*D1*Dd*f**2*fd*r**2 + 349440*D1*Dd*f**2*fd*r*s - 247520*D1*Dd*f**2*fd*r + 174720*D1*Dd*f**2*fd*s**2 - 247520*D1*Dd*f**2*fd*s + 87360*D1*Dd*f**2*fd - 27456*D1*Dd*f**2*g2*r**2 - 54912*D1*Dd*f**2*g2*r*s + 41184*D1*Dd*f**2*g2*r - 27456*D1*Dd*f**2*g2*s**2 + 41184*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*g2 + 68640*D1*Dd*f**2*gd2*r**2 + 137280*D1*Dd*f**2*gd2*r*s - 120120*D1*Dd*f**2*gd2*r + 68640*D1*Dd*f**2*gd2*s**2 - 120120*D1*Dd*f**2*gd2*s + 51480*D1*Dd*f**2*gd2 + 137280*D1*Dd*f*fd*g2*r**2 + 274560*D1*Dd*f*fd*g2*r*s - 171600*D1*Dd*f*fd*g2*r + 137280*D1*Dd*f*fd*g2*s**2 - 171600*D1*Dd*f*fd*g2*s + 51480*D1*Dd*f*fd*g2 - 17160*D1*Ddd*K*b1*f**2*r**2 - 34320*D1*Ddd*K*b1*f**2*r*s + 25740*D1*Ddd*K*b1*f**2*r - 17160*D1*Ddd*K*b1*f**2*s**2 + 25740*D1*Ddd*K*b1*f**2*s - 12870*D1*Ddd*K*b1*f**2 + 17160*D1*Ddd*b1*f**2*r**2 + 34320*D1*Ddd*b1*f**2*r*s - 25740*D1*Ddd*b1*f**2*r + 17160*D1*Ddd*b1*f**2*s**2 - 25740*D1*Ddd*b1*f**2*s + 12870*D1*Ddd*b1*f**2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 29120*D1*Ddd*f**3*r**2 + 58240*D1*Ddd*f**3*r*s - 43680*D1*Ddd*f**3*r + 29120*D1*Ddd*f**3*s**2 - 43680*D1*Ddd*f**3*s + 21840*D1*Ddd*f**3 + 34320*D1*Ddd*f**2*g2*r**2 + 68640*D1*Ddd*f**2*g2*r*s - 51480*D1*Ddd*f**2*g2*r + 34320*D1*Ddd*f**2*g2*s**2 - 51480*D1*Ddd*f**2*g2*s + 25740*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 51480*Dd**2*K*b1*f**2*r**2 - 102960*Dd**2*K*b1*f**2*r*s + 77220*Dd**2*K*b1*f**2*r - 51480*Dd**2*K*b1*f**2*s**2 + 77220*Dd**2*K*b1*f**2*s - 25740*Dd**2*K*b1*f**2 + 51480*Dd**2*b1*f**2*r**2 + 102960*Dd**2*b1*f**2*r*s - 77220*Dd**2*b1*f**2*r + 51480*Dd**2*b1*f**2*s**2 - 77220*Dd**2*b1*f**2*s + 25740*Dd**2*b1*f**2 - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 87360*Dd**2*f**3*r**2 + 174720*Dd**2*f**3*r*s - 131040*Dd**2*f**3*r + 87360*Dd**2*f**3*s**2 - 131040*Dd**2*f**3*s + 43680*Dd**2*f**3 + 102960*Dd**2*f**2*g2*r**2 + 205920*Dd**2*f**2*g2*r*s - 154440*Dd**2*f**2*g2*r + 102960*Dd**2*f**2*g2*s**2 - 154440*Dd**2*f**2*g2*s + 51480*Dd**2*f**2*g2)/(1001*d**2*k3**7) + 8*D1**2*Pk2*Pkd3*ct**5*k1**5*(8970*C*D1**2*f**2*fd*r*s - 2990*C*D1**2*f**2*fd*r + 8970*C*D1**2*f**2*fd*s**2 - 8970*C*D1**2*f**2*fd*s + 2990*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r*s + 3640*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 10920*C*D1**2*f**2*fdd*s - 3640*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r*s + 7280*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 21840*C*D1**2*f*fd**2*s - 3640*C*D1**2*f*fd**2 + 11960*C*D1*Dd*f**3*r*s - 2990*C*D1*Dd*f**3*r + 11960*C*D1*Dd*f**3*s**2 - 11960*C*D1*Dd*f**3*s + 2990*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r*s + 25480*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 87360*C*D1*Dd*f**2*fd*s - 18200*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r*s + 3640*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 14560*C*D1*Ddd*f**3*s - 3640*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r*s + 10920*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 43680*C*Dd**2*f**3*s - 7280*C*Dd**2*f**3 - 2145*D1**2*K*bdd1*f**2*r*s - 2145*D1**2*K*bdd1*f**2*s**2 + 2145*D1**2*K*bdd1*f**2*s + 2145*D1**2*bdd1*f**2*r*s + 2145*D1**2*bdd1*f**2*s**2 - 2145*D1**2*bdd1*f**2*s + 28560*D1**2*f**3*fd*r*s - 7140*D1**2*f**3*fd*r + 28560*D1**2*f**3*fd*s**2 - 28560*D1**2*f**3*fd*s + 7140*D1**2*f**3*fd - 25200*D1**2*f**3*fdd*r*s + 6300*D1**2*f**3*fdd*r - 25200*D1**2*f**3*fdd*s**2 + 25200*D1**2*f**3*fdd*s - 6300*D1**2*f**3*fdd - 75600*D1**2*f**2*fd**2*r*s + 18900*D1**2*f**2*fd**2*r - 75600*D1**2*f**2*fd**2*s**2 + 75600*D1**2*f**2*fd**2*s - 12600*D1**2*f**2*fd**2 - 8970*D1**2*f**2*fd*r*s + 2990*D1**2*f**2*fd*r - 8970*D1**2*f**2*fd*s**2 + 8970*D1**2*f**2*fd*s - 2990*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r*s - 3640*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 10920*D1**2*f**2*fdd*s + 3640*D1**2*f**2*fdd - 3432*D1**2*f**2*gd2*r*s - 3432*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s + 4290*D1**2*f**2*gdd2*r*s + 4290*D1**2*f**2*gdd2*s**2 - 4290*D1**2*f**2*gdd2*s + 21840*D1**2*f*fd**2*r*s - 7280*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 21840*D1**2*f*fd**2*s + 3640*D1**2*f*fd**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 6864*D1**2*f*fd*g2*s**2 + 6864*D1**2*f*fd*g2*s - 3432*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r*s - 4290*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 17160*D1**2*f*fd*gd2*s + 4290*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r*s - 4290*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r*s - 4290*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 28560*D1*Dd*f**4*r*s - 7140*D1*Dd*f**4*r + 28560*D1*Dd*f**4*s**2 - 28560*D1*Dd*f**4*s + 7140*D1*Dd*f**4 - 201600*D1*Dd*f**3*fd*r*s + 50400*D1*Dd*f**3*fd*r - 201600*D1*Dd*f**3*fd*s**2 + 201600*D1*Dd*f**3*fd*s - 37800*D1*Dd*f**3*fd - 11960*D1*Dd*f**3*r*s + 2990*D1*Dd*f**3*r - 11960*D1*Dd*f**3*s**2 + 11960*D1*Dd*f**3*s - 2990*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r*s - 25480*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 87360*D1*Dd*f**2*fd*s + 18200*D1*Dd*f**2*fd - 13728*D1*Dd*f**2*g2*r*s + 3432*D1*Dd*f**2*g2*r - 13728*D1*Dd*f**2*g2*s**2 + 13728*D1*Dd*f**2*g2*s - 3432*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r*s - 4290*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 34320*D1*Dd*f**2*gd2*s + 4290*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r*s - 25740*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 68640*D1*Dd*f*fd*g2*s + 17160*D1*Dd*f*fd*g2 - 25200*D1*Ddd*f**4*r*s + 6300*D1*Ddd*f**4*r - 25200*D1*Ddd*f**4*s**2 + 25200*D1*Ddd*f**4*s - 6300*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r*s - 3640*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 14560*D1*Ddd*f**3*s + 3640*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r*s - 4290*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 17160*D1*Ddd*f**2*g2*s + 4290*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(4*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 75600*Dd**2*f**4*r*s + 18900*Dd**2*f**4*r - 75600*Dd**2*f**4*s**2 + 75600*Dd**2*f**4*s - 12600*Dd**2*f**4 + 43680*Dd**2*f**3*r*s - 10920*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 43680*Dd**2*f**3*s + 7280*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r*s - 12870*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 51480*Dd**2*f**2*g2*s + 8580*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(4*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 5*fd*(8*r*s - 3*r + 8*s**2 - 8*s + 2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k2*k3**5) + D1**2*Pk2*Pkd3*ct**5*k1**3*k2**3*st**2*(125112*C*D1**2*f**2*fd*r**2 + 250224*C*D1**2*f**2*fd*r*s - 166816*C*D1**2*f**2*fd*r + 125112*C*D1**2*f**2*fd*s**2 - 166816*C*D1**2*f**2*fd*s + 83408*C*D1**2*f**2*fd - 78000*C*D1**2*f**2*fdd*r**2 - 156000*C*D1**2*f**2*fdd*r*s + 104000*C*D1**2*f**2*fdd*r - 78000*C*D1**2*f**2*fdd*s**2 + 104000*C*D1**2*f**2*fdd*s - 52000*C*D1**2*f**2*fdd - 156000*C*D1**2*f*fd**2*r**2 - 312000*C*D1**2*f*fd**2*r*s + 208000*C*D1**2*f*fd**2*r - 156000*C*D1**2*f*fd**2*s**2 + 208000*C*D1**2*f*fd**2*s - 52000*C*D1**2*f*fd**2 + 166816*C*D1*Dd*f**3*r**2 + 333632*C*D1*Dd*f**3*r*s - 250224*C*D1*Dd*f**3*r + 166816*C*D1*Dd*f**3*s**2 - 250224*C*D1*Dd*f**3*s + 125112*C*D1*Dd*f**3 - 624000*C*D1*Dd*f**2*fd*r**2 - 1248000*C*D1*Dd*f**2*fd*r*s + 884000*C*D1*Dd*f**2*fd*r - 624000*C*D1*Dd*f**2*fd*s**2 + 884000*C*D1*Dd*f**2*fd*s - 312000*C*D1*Dd*f**2*fd - 104000*C*D1*Ddd*f**3*r**2 - 208000*C*D1*Ddd*f**3*r*s + 156000*C*D1*Ddd*f**3*r - 104000*C*D1*Ddd*f**3*s**2 + 156000*C*D1*Ddd*f**3*s - 78000*C*D1*Ddd*f**3 - 312000*C*Dd**2*f**3*r**2 - 624000*C*Dd**2*f**3*r*s + 468000*C*Dd**2*f**3*r - 312000*C*Dd**2*f**3*s**2 + 468000*C*Dd**2*f**3*s - 156000*C*Dd**2*f**3 + 58344*D1**2*K*b1*f*fd*r**2 + 116688*D1**2*K*b1*f*fd*r*s - 58344*D1**2*K*b1*f*fd*r + 58344*D1**2*K*b1*f*fd*s**2 - 58344*D1**2*K*b1*f*fd*s + 29172*D1**2*K*b1*f*fd - 34320*D1**2*K*b1*f*fdd*r**2 - 68640*D1**2*K*b1*f*fdd*r*s + 34320*D1**2*K*b1*f*fdd*r - 34320*D1**2*K*b1*f*fdd*s**2 + 34320*D1**2*K*b1*f*fdd*s - 17160*D1**2*K*b1*f*fdd - 34320*D1**2*K*b1*fd**2*r**2 - 68640*D1**2*K*b1*fd**2*r*s + 34320*D1**2*K*b1*fd**2*r - 34320*D1**2*K*b1*fd**2*s**2 + 34320*D1**2*K*b1*fd**2*s - 58344*D1**2*b1*f*fd*r**2 - 116688*D1**2*b1*f*fd*r*s + 58344*D1**2*b1*f*fd*r - 58344*D1**2*b1*f*fd*s**2 + 58344*D1**2*b1*f*fd*s - 29172*D1**2*b1*f*fd + 34320*D1**2*b1*f*fdd*r**2 + 68640*D1**2*b1*f*fdd*r*s - 34320*D1**2*b1*f*fdd*r + 34320*D1**2*b1*f*fdd*s**2 - 34320*D1**2*b1*f*fdd*s + 17160*D1**2*b1*f*fdd + 34320*D1**2*b1*fd**2*r**2 + 68640*D1**2*b1*fd**2*r*s - 34320*D1**2*b1*fd**2*r + 34320*D1**2*b1*fd**2*s**2 - 34320*D1**2*b1*fd**2*s - 17160*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 166800*D1**2*f**3*fd*r**2 + 333600*D1**2*f**3*fd*r*s - 250200*D1**2*f**3*fd*r + 166800*D1**2*f**3*fd*s**2 - 250200*D1**2*f**3*fd*s + 125100*D1**2*f**3*fd - 102900*D1**2*f**3*fdd*r**2 - 205800*D1**2*f**3*fdd*r*s + 154350*D1**2*f**3*fdd*r - 102900*D1**2*f**3*fdd*s**2 + 154350*D1**2*f**3*fdd*s - 77175*D1**2*f**3*fdd - 308700*D1**2*f**2*fd**2*r**2 - 617400*D1**2*f**2*fd**2*r*s + 463050*D1**2*f**2*fd**2*r - 308700*D1**2*f**2*fd**2*s**2 + 463050*D1**2*f**2*fd**2*s - 154350*D1**2*f**2*fd**2 - 125112*D1**2*f**2*fd*r**2 - 250224*D1**2*f**2*fd*r*s + 166816*D1**2*f**2*fd*r - 125112*D1**2*f**2*fd*s**2 + 166816*D1**2*f**2*fd*s - 83408*D1**2*f**2*fd + 78000*D1**2*f**2*fdd*r**2 + 156000*D1**2*f**2*fdd*r*s - 104000*D1**2*f**2*fdd*r + 78000*D1**2*f**2*fdd*s**2 - 104000*D1**2*f**2*fdd*s + 52000*D1**2*f**2*fdd - 58344*D1**2*f**2*gd2*r**2 - 116688*D1**2*f**2*gd2*r*s + 116688*D1**2*f**2*gd2*r - 58344*D1**2*f**2*gd2*s**2 + 116688*D1**2*f**2*gd2*s - 58344*D1**2*f**2*gd2 + 34320*D1**2*f**2*gdd2*r**2 + 68640*D1**2*f**2*gdd2*r*s - 68640*D1**2*f**2*gdd2*r + 34320*D1**2*f**2*gdd2*s**2 - 68640*D1**2*f**2*gdd2*s + 34320*D1**2*f**2*gdd2 + 156000*D1**2*f*fd**2*r**2 + 312000*D1**2*f*fd**2*r*s - 208000*D1**2*f*fd**2*r + 156000*D1**2*f*fd**2*s**2 - 208000*D1**2*f*fd**2*s + 52000*D1**2*f*fd**2 - 116688*D1**2*f*fd*g2*r**2 - 233376*D1**2*f*fd*g2*r*s + 116688*D1**2*f*fd*g2*r - 116688*D1**2*f*fd*g2*s**2 + 116688*D1**2*f*fd*g2*s - 58344*D1**2*f*fd*g2 + 137280*D1**2*f*fd*gd2*r**2 + 274560*D1**2*f*fd*gd2*r*s - 205920*D1**2*f*fd*gd2*r + 137280*D1**2*f*fd*gd2*s**2 - 205920*D1**2*f*fd*gd2*s + 68640*D1**2*f*fd*gd2 + 68640*D1**2*f*fdd*g2*r**2 + 137280*D1**2*f*fdd*g2*r*s - 68640*D1**2*f*fdd*g2*r + 68640*D1**2*f*fdd*g2*s**2 - 68640*D1**2*f*fdd*g2*s + 34320*D1**2*f*fdd*g2 + 68640*D1**2*fd**2*g2*r**2 + 137280*D1**2*fd**2*g2*r*s - 68640*D1**2*fd**2*g2*r + 68640*D1**2*fd**2*g2*s**2 - 68640*D1**2*fd**2*g2*s + 116688*D1*Dd*K*b1*f**2*r**2 + 233376*D1*Dd*K*b1*f**2*r*s - 175032*D1*Dd*K*b1*f**2*r + 116688*D1*Dd*K*b1*f**2*s**2 - 175032*D1*Dd*K*b1*f**2*s + 87516*D1*Dd*K*b1*f**2 - 274560*D1*Dd*K*b1*f*fd*r**2 - 549120*D1*Dd*K*b1*f*fd*r*s + 343200*D1*Dd*K*b1*f*fd*r - 274560*D1*Dd*K*b1*f*fd*s**2 + 343200*D1*Dd*K*b1*f*fd*s - 102960*D1*Dd*K*b1*f*fd - 116688*D1*Dd*b1*f**2*r**2 - 233376*D1*Dd*b1*f**2*r*s + 175032*D1*Dd*b1*f**2*r - 116688*D1*Dd*b1*f**2*s**2 + 175032*D1*Dd*b1*f**2*s - 87516*D1*Dd*b1*f**2 + 274560*D1*Dd*b1*f*fd*r**2 + 549120*D1*Dd*b1*f*fd*r*s - 343200*D1*Dd*b1*f*fd*r + 274560*D1*Dd*b1*f*fd*s**2 - 343200*D1*Dd*b1*f*fd*s + 102960*D1*Dd*b1*f*fd + 166800*D1*Dd*f**4*r**2 + 333600*D1*Dd*f**4*r*s - 250200*D1*Dd*f**4*r + 166800*D1*Dd*f**4*s**2 - 250200*D1*Dd*f**4*s + 125100*D1*Dd*f**4 - 823200*D1*Dd*f**3*fd*r**2 - 1646400*D1*Dd*f**3*fd*r*s + 1234800*D1*Dd*f**3*fd*r - 823200*D1*Dd*f**3*fd*s**2 + 1234800*D1*Dd*f**3*fd*s - 463050*D1*Dd*f**3*fd - 166816*D1*Dd*f**3*r**2 - 333632*D1*Dd*f**3*r*s + 250224*D1*Dd*f**3*r - 166816*D1*Dd*f**3*s**2 + 250224*D1*Dd*f**3*s - 125112*D1*Dd*f**3 + 624000*D1*Dd*f**2*fd*r**2 + 1248000*D1*Dd*f**2*fd*r*s - 884000*D1*Dd*f**2*fd*r + 624000*D1*Dd*f**2*fd*s**2 - 884000*D1*Dd*f**2*fd*s + 312000*D1*Dd*f**2*fd - 233376*D1*Dd*f**2*g2*r**2 - 466752*D1*Dd*f**2*g2*r*s + 350064*D1*Dd*f**2*g2*r - 233376*D1*Dd*f**2*g2*s**2 + 350064*D1*Dd*f**2*g2*s - 175032*D1*Dd*f**2*g2 + 274560*D1*Dd*f**2*gd2*r**2 + 549120*D1*Dd*f**2*gd2*r*s - 480480*D1*Dd*f**2*gd2*r + 274560*D1*Dd*f**2*gd2*s**2 - 480480*D1*Dd*f**2*gd2*s + 205920*D1*Dd*f**2*gd2 + 549120*D1*Dd*f*fd*g2*r**2 + 1098240*D1*Dd*f*fd*g2*r*s - 686400*D1*Dd*f*fd*g2*r + 549120*D1*Dd*f*fd*g2*s**2 - 686400*D1*Dd*f*fd*g2*s + 205920*D1*Dd*f*fd*g2 - 68640*D1*Ddd*K*b1*f**2*r**2 - 137280*D1*Ddd*K*b1*f**2*r*s + 102960*D1*Ddd*K*b1*f**2*r - 68640*D1*Ddd*K*b1*f**2*s**2 + 102960*D1*Ddd*K*b1*f**2*s - 51480*D1*Ddd*K*b1*f**2 + 68640*D1*Ddd*b1*f**2*r**2 + 137280*D1*Ddd*b1*f**2*r*s - 102960*D1*Ddd*b1*f**2*r + 68640*D1*Ddd*b1*f**2*s**2 - 102960*D1*Ddd*b1*f**2*s + 51480*D1*Ddd*b1*f**2 - 102900*D1*Ddd*f**4*r**2 - 205800*D1*Ddd*f**4*r*s + 154350*D1*Ddd*f**4*r - 102900*D1*Ddd*f**4*s**2 + 154350*D1*Ddd*f**4*s - 77175*D1*Ddd*f**4 + 104000*D1*Ddd*f**3*r**2 + 208000*D1*Ddd*f**3*r*s - 156000*D1*Ddd*f**3*r + 104000*D1*Ddd*f**3*s**2 - 156000*D1*Ddd*f**3*s + 78000*D1*Ddd*f**3 + 137280*D1*Ddd*f**2*g2*r**2 + 274560*D1*Ddd*f**2*g2*r*s - 205920*D1*Ddd*f**2*g2*r + 137280*D1*Ddd*f**2*g2*s**2 - 205920*D1*Ddd*f**2*g2*s + 102960*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(17*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 205920*Dd**2*K*b1*f**2*r**2 - 411840*Dd**2*K*b1*f**2*r*s + 308880*Dd**2*K*b1*f**2*r - 205920*Dd**2*K*b1*f**2*s**2 + 308880*Dd**2*K*b1*f**2*s - 102960*Dd**2*K*b1*f**2 + 205920*Dd**2*b1*f**2*r**2 + 411840*Dd**2*b1*f**2*r*s - 308880*Dd**2*b1*f**2*r + 205920*Dd**2*b1*f**2*s**2 - 308880*Dd**2*b1*f**2*s + 102960*Dd**2*b1*f**2 - 308700*Dd**2*f**4*r**2 - 617400*Dd**2*f**4*r*s + 463050*Dd**2*f**4*r - 308700*Dd**2*f**4*s**2 + 463050*Dd**2*f**4*s - 154350*Dd**2*f**4 + 312000*Dd**2*f**3*r**2 + 624000*Dd**2*f**3*r*s - 468000*Dd**2*f**3*r + 312000*Dd**2*f**3*s**2 - 468000*Dd**2*f**3*s + 156000*Dd**2*f**3 + 411840*Dd**2*f**2*g2*r**2 + 823680*Dd**2*f**2*g2*r*s - 617760*Dd**2*f**2*g2*r + 411840*Dd**2*f**2*g2*s**2 - 617760*Dd**2*f**2*g2*s + 205920*Dd**2*f**2*g2)/(2002*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**5*k1**3*k2**3*(-1320*C*D1**2*bdd1*f**2*r**2 - 2640*C*D1**2*bdd1*f**2*r*s + 2640*C*D1**2*bdd1*f**2*r - 1320*C*D1**2*bdd1*f**2*s**2 + 2640*C*D1**2*bdd1*f**2*s - 1320*C*D1**2*bdd1*f**2 + 8280*C*D1**2*f**2*fd*r**2 + 16560*C*D1**2*f**2*fd*r*s - 11040*C*D1**2*f**2*fd*r + 8280*C*D1**2*f**2*fd*s**2 - 11040*C*D1**2*f**2*fd*s + 5520*C*D1**2*f**2*fd - 10080*C*D1**2*f**2*fdd*r**2 - 20160*C*D1**2*f**2*fdd*r*s + 13440*C*D1**2*f**2*fdd*r - 10080*C*D1**2*f**2*fdd*s**2 + 13440*C*D1**2*f**2*fdd*s - 6720*C*D1**2*f**2*fdd - 20160*C*D1**2*f*fd**2*r**2 - 40320*C*D1**2*f*fd**2*r*s + 26880*C*D1**2*f*fd**2*r - 20160*C*D1**2*f*fd**2*s**2 + 26880*C*D1**2*f*fd**2*s - 6720*C*D1**2*f*fd**2 + 11040*C*D1*Dd*f**3*r**2 + 22080*C*D1*Dd*f**3*r*s - 16560*C*D1*Dd*f**3*r + 11040*C*D1*Dd*f**3*s**2 - 16560*C*D1*Dd*f**3*s + 8280*C*D1*Dd*f**3 - 80640*C*D1*Dd*f**2*fd*r**2 - 161280*C*D1*Dd*f**2*fd*r*s + 114240*C*D1*Dd*f**2*fd*r - 80640*C*D1*Dd*f**2*fd*s**2 + 114240*C*D1*Dd*f**2*fd*s - 40320*C*D1*Dd*f**2*fd - 13440*C*D1*Ddd*f**3*r**2 - 26880*C*D1*Ddd*f**3*r*s + 20160*C*D1*Ddd*f**3*r - 13440*C*D1*Ddd*f**3*s**2 + 20160*C*D1*Ddd*f**3*s - 10080*C*D1*Ddd*f**3 - 40320*C*Dd**2*f**3*r**2 - 80640*C*Dd**2*f**3*r*s + 60480*C*Dd**2*f**3*r - 40320*C*Dd**2*f**3*s**2 + 60480*C*Dd**2*f**3*s - 20160*C*Dd**2*f**3 - 1980*D1**2*K*bdd1*f**2*r**2 - 3960*D1**2*K*bdd1*f**2*r*s + 3960*D1**2*K*bdd1*f**2*r - 1980*D1**2*K*bdd1*f**2*s**2 + 3960*D1**2*K*bdd1*f**2*s - 1980*D1**2*K*bdd1*f**2 - 1584*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 700*D1**2*bdd1*f**3*r**2 + 1400*D1**2*bdd1*f**3*r*s - 1400*D1**2*bdd1*f**3*r + 700*D1**2*bdd1*f**3*s**2 - 1400*D1**2*bdd1*f**3*s + 700*D1**2*bdd1*f**3 + 2310*D1**2*bdd1*f**2*r**2 + 4620*D1**2*bdd1*f**2*r*s - 4620*D1**2*bdd1*f**2*r + 2310*D1**2*bdd1*f**2*s**2 - 4620*D1**2*bdd1*f**2*s + 2310*D1**2*bdd1*f**2 + 1584*D1**2*bdd1*f*g2*r**2 + 3168*D1**2*bdd1*f*g2*r*s - 3168*D1**2*bdd1*f*g2*r + 1584*D1**2*bdd1*f*g2*s**2 - 3168*D1**2*bdd1*f*g2*s + 1584*D1**2*bdd1*f*g2 - 1680*D1**2*f**3*fd*r**2 - 3360*D1**2*f**3*fd*r*s + 2520*D1**2*f**3*fd*r - 1680*D1**2*f**3*fd*s**2 + 2520*D1**2*f**3*fd*s - 1260*D1**2*f**3*fd - 5715*D1**2*f**2*fd*r**2 - 11430*D1**2*f**2*fd*r*s + 7620*D1**2*f**2*fd*r - 5715*D1**2*f**2*fd*s**2 + 7620*D1**2*f**2*fd*s - 3810*D1**2*f**2*fd + 7560*D1**2*f**2*fdd*r**2 + 15120*D1**2*f**2*fdd*r*s - 10080*D1**2*f**2*fdd*r + 7560*D1**2*f**2*fdd*s**2 - 10080*D1**2*f**2*fdd*s + 5040*D1**2*f**2*fdd - 3168*D1**2*f**2*gd2*r**2 - 6336*D1**2*f**2*gd2*r*s + 6336*D1**2*f**2*gd2*r - 3168*D1**2*f**2*gd2*s**2 + 6336*D1**2*f**2*gd2*s - 3168*D1**2*f**2*gd2 + 3960*D1**2*f**2*gdd2*r**2 + 7920*D1**2*f**2*gdd2*r*s - 7920*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 7920*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 + 15120*D1**2*f*fd**2*r**2 + 30240*D1**2*f*fd**2*r*s - 20160*D1**2*f*fd**2*r + 15120*D1**2*f*fd**2*s**2 - 20160*D1**2*f*fd**2*s + 5040*D1**2*f*fd**2 - 6336*D1**2*f*fd*g2*r**2 - 12672*D1**2*f*fd*g2*r*s + 6336*D1**2*f*fd*g2*r - 6336*D1**2*f*fd*g2*s**2 + 6336*D1**2*f*fd*g2*s - 3168*D1**2*f*fd*g2 + 15840*D1**2*f*fd*gd2*r**2 + 31680*D1**2*f*fd*gd2*r*s - 23760*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 23760*D1**2*f*fd*gd2*s + 7920*D1**2*f*fd*gd2 + 7920*D1**2*f*fdd*g2*r**2 + 15840*D1**2*f*fdd*g2*r*s - 7920*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 7920*D1**2*f*fdd*g2*s + 3960*D1**2*f*fdd*g2 + 7920*D1**2*fd**2*g2*r**2 + 15840*D1**2*fd**2*g2*r*s - 7920*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 7920*D1**2*fd**2*g2*s - 1680*D1*Dd*f**4*r**2 - 3360*D1*Dd*f**4*r*s + 2520*D1*Dd*f**4*r - 1680*D1*Dd*f**4*s**2 + 2520*D1*Dd*f**4*s - 1260*D1*Dd*f**4 - 7620*D1*Dd*f**3*r**2 - 15240*D1*Dd*f**3*r*s + 11430*D1*Dd*f**3*r - 7620*D1*Dd*f**3*s**2 + 11430*D1*Dd*f**3*s - 5715*D1*Dd*f**3 + 60480*D1*Dd*f**2*fd*r**2 + 120960*D1*Dd*f**2*fd*r*s - 85680*D1*Dd*f**2*fd*r + 60480*D1*Dd*f**2*fd*s**2 - 85680*D1*Dd*f**2*fd*s + 30240*D1*Dd*f**2*fd - 12672*D1*Dd*f**2*g2*r**2 - 25344*D1*Dd*f**2*g2*r*s + 19008*D1*Dd*f**2*g2*r - 12672*D1*Dd*f**2*g2*s**2 + 19008*D1*Dd*f**2*g2*s - 9504*D1*Dd*f**2*g2 + 31680*D1*Dd*f**2*gd2*r**2 + 63360*D1*Dd*f**2*gd2*r*s - 55440*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 55440*D1*Dd*f**2*gd2*s + 23760*D1*Dd*f**2*gd2 + 63360*D1*Dd*f*fd*g2*r**2 + 126720*D1*Dd*f*fd*g2*r*s - 79200*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 79200*D1*Dd*f*fd*g2*s + 23760*D1*Dd*f*fd*g2 + 10080*D1*Ddd*f**3*r**2 + 20160*D1*Ddd*f**3*r*s - 15120*D1*Ddd*f**3*r + 10080*D1*Ddd*f**3*s**2 - 15120*D1*Ddd*f**3*s + 7560*D1*Ddd*f**3 + 15840*D1*Ddd*f**2*g2*r**2 + 31680*D1*Ddd*f**2*g2*r*s - 23760*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 23760*D1*Ddd*f**2*g2*s + 11880*D1*Ddd*f**2*g2 - D1*bd1*(D1*(575*f**3*(r + s - 1) - 2*f**2*(924*C*(r + s - 1) + 700*fd*(3*r + 3*s - 2) + (792*K - 1221)*(r + s - 1)) + 132*f*(5*fd*(4*C + 6*K - 7)*(2*r + 2*s - 1) + (17*g2 - 24*gd2)*(r + s - 1)) - 3168*fd*g2*(r + s)) - 4*Dd*f*(350*f**2 - 165*f*(4*C + 6*K - 7) + 792*g2)*(4*r + 4*s - 3))*(r + s - 1) + 30240*Dd**2*f**3*r**2 + 60480*Dd**2*f**3*r*s - 45360*Dd**2*f**3*r + 30240*Dd**2*f**3*s**2 - 45360*Dd**2*f**3*s + 15120*Dd**2*f**3 + 47520*Dd**2*f**2*g2*r**2 + 95040*Dd**2*f**2*g2*r*s - 71280*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 71280*Dd**2*f**2*g2*s + 23760*Dd**2*f**2*g2 + 66*b1**2*(K - 1)*(D1**2*(17*fd - 12*fdd)*(r + s)**2 + D1*(Dd*(17*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 24*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(3696*C*D1**2*f*fd*r**2 + 7392*C*D1**2*f*fd*r*s - 3696*C*D1**2*f*fd*r + 3696*C*D1**2*f*fd*s**2 - 3696*C*D1**2*f*fd*s + 1848*C*D1**2*f*fd - 2640*C*D1**2*f*fdd*r**2 - 5280*C*D1**2*f*fdd*r*s + 2640*C*D1**2*f*fdd*r - 2640*C*D1**2*f*fdd*s**2 + 2640*C*D1**2*f*fdd*s - 1320*C*D1**2*f*fdd - 2640*C*D1**2*fd**2*r**2 - 5280*C*D1**2*fd**2*r*s + 2640*C*D1**2*fd**2*r - 2640*C*D1**2*fd**2*s**2 + 2640*C*D1**2*fd**2*s + 7392*C*D1*Dd*f**2*r**2 + 14784*C*D1*Dd*f**2*r*s - 11088*C*D1*Dd*f**2*r + 7392*C*D1*Dd*f**2*s**2 - 11088*C*D1*Dd*f**2*s + 5544*C*D1*Dd*f**2 - 21120*C*D1*Dd*f*fd*r**2 - 42240*C*D1*Dd*f*fd*r*s + 26400*C*D1*Dd*f*fd*r - 21120*C*D1*Dd*f*fd*s**2 + 26400*C*D1*Dd*f*fd*s - 7920*C*D1*Dd*f*fd - 5280*C*D1*Ddd*f**2*r**2 - 10560*C*D1*Ddd*f**2*r*s + 7920*C*D1*Ddd*f**2*r - 5280*C*D1*Ddd*f**2*s**2 + 7920*C*D1*Ddd*f**2*s - 3960*C*D1*Ddd*f**2 - 15840*C*Dd**2*f**2*r**2 - 31680*C*Dd**2*f**2*r*s + 23760*C*Dd**2*f**2*r - 15840*C*Dd**2*f**2*s**2 + 23760*C*Dd**2*f**2*s - 7920*C*Dd**2*f**2 + 3168*D1**2*K*f*fd*r**2 + 6336*D1**2*K*f*fd*r*s - 3168*D1**2*K*f*fd*r + 3168*D1**2*K*f*fd*s**2 - 3168*D1**2*K*f*fd*s + 1584*D1**2*K*f*fd - 3960*D1**2*K*f*fdd*r**2 - 7920*D1**2*K*f*fdd*r*s + 3960*D1**2*K*f*fdd*r - 3960*D1**2*K*f*fdd*s**2 + 3960*D1**2*K*f*fdd*s - 1980*D1**2*K*f*fdd - 3960*D1**2*K*fd**2*r**2 - 7920*D1**2*K*fd**2*r*s + 3960*D1**2*K*fd**2*r - 3960*D1**2*K*fd**2*s**2 + 3960*D1**2*K*fd**2*s - 1584*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 1725*D1**2*f**2*fd*r**2 - 3450*D1**2*f**2*fd*r*s + 2300*D1**2*f**2*fd*r - 1725*D1**2*f**2*fd*s**2 + 2300*D1**2*f**2*fd*s - 1150*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 4884*D1**2*f*fd*r**2 - 9768*D1**2*f*fd*r*s + 4884*D1**2*f*fd*r - 4884*D1**2*f*fd*s**2 + 4884*D1**2*f*fd*s - 2442*D1**2*f*fd + 4620*D1**2*f*fdd*r**2 + 9240*D1**2*f*fdd*r*s - 4620*D1**2*f*fdd*r + 4620*D1**2*f*fdd*s**2 - 4620*D1**2*f*fdd*s + 2310*D1**2*f*fdd - 2244*D1**2*f*gd2*r**2 - 4488*D1**2*f*gd2*r*s + 4488*D1**2*f*gd2*r - 2244*D1**2*f*gd2*s**2 + 4488*D1**2*f*gd2*s - 2244*D1**2*f*gd2 + 1584*D1**2*f*gdd2*r**2 + 3168*D1**2*f*gdd2*r*s - 3168*D1**2*f*gdd2*r + 1584*D1**2*f*gdd2*s**2 - 3168*D1**2*f*gdd2*s + 1584*D1**2*f*gdd2 + 4620*D1**2*fd**2*r**2 + 9240*D1**2*fd**2*r*s - 4620*D1**2*fd**2*r + 4620*D1**2*fd**2*s**2 - 4620*D1**2*fd**2*s - 2244*D1**2*fd*g2*r**2 - 4488*D1**2*fd*g2*r*s - 2244*D1**2*fd*g2*s**2 + 3168*D1**2*fd*gd2*r**2 + 6336*D1**2*fd*gd2*r*s - 3168*D1**2*fd*gd2*r + 3168*D1**2*fd*gd2*s**2 - 3168*D1**2*fd*gd2*s + 1584*D1**2*fdd*g2*r**2 + 3168*D1**2*fdd*g2*r*s + 1584*D1**2*fdd*g2*s**2 + 6336*D1*Dd*K*f**2*r**2 + 12672*D1*Dd*K*f**2*r*s - 9504*D1*Dd*K*f**2*r + 6336*D1*Dd*K*f**2*s**2 - 9504*D1*Dd*K*f**2*s + 4752*D1*Dd*K*f**2 - 31680*D1*Dd*K*f*fd*r**2 - 63360*D1*Dd*K*f*fd*r*s + 39600*D1*Dd*K*f*fd*r - 31680*D1*Dd*K*f*fd*s**2 + 39600*D1*Dd*K*f*fd*s - 11880*D1*Dd*K*f*fd - 2300*D1*Dd*f**3*r**2 - 4600*D1*Dd*f**3*r*s + 3450*D1*Dd*f**3*r - 2300*D1*Dd*f**3*s**2 + 3450*D1*Dd*f**3*s - 1725*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 23800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 23800*D1*Dd*f**2*fd*s + 8400*D1*Dd*f**2*fd - 9768*D1*Dd*f**2*r**2 - 19536*D1*Dd*f**2*r*s + 14652*D1*Dd*f**2*r - 9768*D1*Dd*f**2*s**2 + 14652*D1*Dd*f**2*s - 7326*D1*Dd*f**2 + 36960*D1*Dd*f*fd*r**2 + 73920*D1*Dd*f*fd*r*s - 46200*D1*Dd*f*fd*r + 36960*D1*Dd*f*fd*s**2 - 46200*D1*Dd*f*fd*s + 13860*D1*Dd*f*fd - 8976*D1*Dd*f*g2*r**2 - 17952*D1*Dd*f*g2*r*s + 13464*D1*Dd*f*g2*r - 8976*D1*Dd*f*g2*s**2 + 13464*D1*Dd*f*g2*s - 6732*D1*Dd*f*g2 + 12672*D1*Dd*f*gd2*r**2 + 25344*D1*Dd*f*gd2*r*s - 22176*D1*Dd*f*gd2*r + 12672*D1*Dd*f*gd2*s**2 - 22176*D1*Dd*f*gd2*s + 9504*D1*Dd*f*gd2 + 12672*D1*Dd*fd*g2*r**2 + 25344*D1*Dd*fd*g2*r*s - 9504*D1*Dd*fd*g2*r + 12672*D1*Dd*fd*g2*s**2 - 9504*D1*Dd*fd*g2*s - 7920*D1*Ddd*K*f**2*r**2 - 15840*D1*Ddd*K*f**2*r*s + 11880*D1*Ddd*K*f**2*r - 7920*D1*Ddd*K*f**2*s**2 + 11880*D1*Ddd*K*f**2*s - 5940*D1*Ddd*K*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 + 9240*D1*Ddd*f**2*r**2 + 18480*D1*Ddd*f**2*r*s - 13860*D1*Ddd*f**2*r + 9240*D1*Ddd*f**2*s**2 - 13860*D1*Ddd*f**2*s + 6930*D1*Ddd*f**2 + 6336*D1*Ddd*f*g2*r**2 + 12672*D1*Ddd*f*g2*r*s - 9504*D1*Ddd*f*g2*r + 6336*D1*Ddd*f*g2*s**2 - 9504*D1*Ddd*f*g2*s + 4752*D1*Ddd*f*g2 + 132*D1*bd1*(K - 1)*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) - 23760*Dd**2*K*f**2*r**2 - 47520*Dd**2*K*f**2*r*s + 35640*Dd**2*K*f**2*r - 23760*Dd**2*K*f**2*s**2 + 35640*Dd**2*K*f**2*s - 11880*Dd**2*K*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3 + 27720*Dd**2*f**2*r**2 + 55440*Dd**2*f**2*r*s - 41580*Dd**2*f**2*r + 27720*Dd**2*f**2*s**2 - 41580*Dd**2*f**2*s + 13860*Dd**2*f**2 + 19008*Dd**2*f*g2*r**2 + 38016*Dd**2*f*g2*r*s - 28512*Dd**2*f*g2*r + 19008*Dd**2*f*g2*s**2 - 28512*Dd**2*f*g2*s + 9504*Dd**2*f*g2))/(77*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**5*k1**3*k2*st**2*(33852*C*D1**2*f**2*fd*r*s - 11284*C*D1**2*f**2*fd*r + 33852*C*D1**2*f**2*fd*s**2 - 33852*C*D1**2*f**2*fd*s + 11284*C*D1**2*f**2*fd - 19500*C*D1**2*f**2*fdd*r*s + 6500*C*D1**2*f**2*fdd*r - 19500*C*D1**2*f**2*fdd*s**2 + 19500*C*D1**2*f**2*fdd*s - 6500*C*D1**2*f**2*fdd - 39000*C*D1**2*f*fd**2*r*s + 13000*C*D1**2*f*fd**2*r - 39000*C*D1**2*f*fd**2*s**2 + 39000*C*D1**2*f*fd**2*s - 6500*C*D1**2*f*fd**2 + 45136*C*D1*Dd*f**3*r*s - 11284*C*D1*Dd*f**3*r + 45136*C*D1*Dd*f**3*s**2 - 45136*C*D1*Dd*f**3*s + 11284*C*D1*Dd*f**3 - 156000*C*D1*Dd*f**2*fd*r*s + 45500*C*D1*Dd*f**2*fd*r - 156000*C*D1*Dd*f**2*fd*s**2 + 156000*C*D1*Dd*f**2*fd*s - 32500*C*D1*Dd*f**2*fd - 26000*C*D1*Ddd*f**3*r*s + 6500*C*D1*Ddd*f**3*r - 26000*C*D1*Ddd*f**3*s**2 + 26000*C*D1*Ddd*f**3*s - 6500*C*D1*Ddd*f**3 - 78000*C*Dd**2*f**3*r*s + 19500*C*Dd**2*f**3*r - 78000*C*Dd**2*f**3*s**2 + 78000*C*Dd**2*f**3*s - 13000*C*Dd**2*f**3 - 4290*D1**2*K*bdd1*f**2*r*s - 4290*D1**2*K*bdd1*f**2*s**2 + 4290*D1**2*K*bdd1*f**2*s + 4290*D1**2*bdd1*f**2*r*s + 4290*D1**2*bdd1*f**2*s**2 - 4290*D1**2*bdd1*f**2*s + 48380*D1**2*f**3*fd*r*s - 12095*D1**2*f**3*fd*r + 48380*D1**2*f**3*fd*s**2 - 48380*D1**2*f**3*fd*s + 12095*D1**2*f**3*fd - 27440*D1**2*f**3*fdd*r*s + 6860*D1**2*f**3*fdd*r - 27440*D1**2*f**3*fdd*s**2 + 27440*D1**2*f**3*fdd*s - 6860*D1**2*f**3*fdd - 82320*D1**2*f**2*fd**2*r*s + 20580*D1**2*f**2*fd**2*r - 82320*D1**2*f**2*fd**2*s**2 + 82320*D1**2*f**2*fd**2*s - 13720*D1**2*f**2*fd**2 - 33852*D1**2*f**2*fd*r*s + 11284*D1**2*f**2*fd*r - 33852*D1**2*f**2*fd*s**2 + 33852*D1**2*f**2*fd*s - 11284*D1**2*f**2*fd + 19500*D1**2*f**2*fdd*r*s - 6500*D1**2*f**2*fdd*r + 19500*D1**2*f**2*fdd*s**2 - 19500*D1**2*f**2*fdd*s + 6500*D1**2*f**2*fdd - 15444*D1**2*f**2*gd2*r*s - 15444*D1**2*f**2*gd2*s**2 + 15444*D1**2*f**2*gd2*s + 8580*D1**2*f**2*gdd2*r*s + 8580*D1**2*f**2*gdd2*s**2 - 8580*D1**2*f**2*gdd2*s + 39000*D1**2*f*fd**2*r*s - 13000*D1**2*f*fd**2*r + 39000*D1**2*f*fd**2*s**2 - 39000*D1**2*f*fd**2*s + 6500*D1**2*f*fd**2 - 30888*D1**2*f*fd*g2*r*s + 15444*D1**2*f*fd*g2*r - 30888*D1**2*f*fd*g2*s**2 + 30888*D1**2*f*fd*g2*s - 15444*D1**2*f*fd*g2 + 34320*D1**2*f*fd*gd2*r*s - 8580*D1**2*f*fd*gd2*r + 34320*D1**2*f*fd*gd2*s**2 - 34320*D1**2*f*fd*gd2*s + 8580*D1**2*f*fd*gd2 + 17160*D1**2*f*fdd*g2*r*s - 8580*D1**2*f*fdd*g2*r + 17160*D1**2*f*fdd*g2*s**2 - 17160*D1**2*f*fdd*g2*s + 8580*D1**2*f*fdd*g2 + 17160*D1**2*fd**2*g2*r*s - 8580*D1**2*fd**2*g2*r + 17160*D1**2*fd**2*g2*s**2 - 17160*D1**2*fd**2*g2*s + 48380*D1*Dd*f**4*r*s - 12095*D1*Dd*f**4*r + 48380*D1*Dd*f**4*s**2 - 48380*D1*Dd*f**4*s + 12095*D1*Dd*f**4 - 219520*D1*Dd*f**3*fd*r*s + 54880*D1*Dd*f**3*fd*r - 219520*D1*Dd*f**3*fd*s**2 + 219520*D1*Dd*f**3*fd*s - 41160*D1*Dd*f**3*fd - 45136*D1*Dd*f**3*r*s + 11284*D1*Dd*f**3*r - 45136*D1*Dd*f**3*s**2 + 45136*D1*Dd*f**3*s - 11284*D1*Dd*f**3 + 156000*D1*Dd*f**2*fd*r*s - 45500*D1*Dd*f**2*fd*r + 156000*D1*Dd*f**2*fd*s**2 - 156000*D1*Dd*f**2*fd*s + 32500*D1*Dd*f**2*fd - 61776*D1*Dd*f**2*g2*r*s + 15444*D1*Dd*f**2*g2*r - 61776*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 15444*D1*Dd*f**2*g2 + 68640*D1*Dd*f**2*gd2*r*s - 8580*D1*Dd*f**2*gd2*r + 68640*D1*Dd*f**2*gd2*s**2 - 68640*D1*Dd*f**2*gd2*s + 8580*D1*Dd*f**2*gd2 + 137280*D1*Dd*f*fd*g2*r*s - 51480*D1*Dd*f*fd*g2*r + 137280*D1*Dd*f*fd*g2*s**2 - 137280*D1*Dd*f*fd*g2*s + 34320*D1*Dd*f*fd*g2 - 27440*D1*Ddd*f**4*r*s + 6860*D1*Ddd*f**4*r - 27440*D1*Ddd*f**4*s**2 + 27440*D1*Ddd*f**4*s - 6860*D1*Ddd*f**4 + 26000*D1*Ddd*f**3*r*s - 6500*D1*Ddd*f**3*r + 26000*D1*Ddd*f**3*s**2 - 26000*D1*Ddd*f**3*s + 6500*D1*Ddd*f**3 + 34320*D1*Ddd*f**2*g2*r*s - 8580*D1*Ddd*f**2*g2*r + 34320*D1*Ddd*f**2*g2*s**2 - 34320*D1*Ddd*f**2*g2*s + 8580*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(D1*(9*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 82320*Dd**2*f**4*r*s + 20580*Dd**2*f**4*r - 82320*Dd**2*f**4*s**2 + 82320*Dd**2*f**4*s - 13720*Dd**2*f**4 + 78000*Dd**2*f**3*r*s - 19500*Dd**2*f**3*r + 78000*Dd**2*f**3*s**2 - 78000*Dd**2*f**3*s + 13000*Dd**2*f**3 + 102960*Dd**2*f**2*g2*r*s - 25740*Dd**2*f**2*g2*r + 102960*Dd**2*f**2*g2*s**2 - 102960*Dd**2*f**2*g2*s + 17160*Dd**2*f**2*g2 + 858*b1*(K - 1)*(D1**2*(f*(9*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(9*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**5*k1**3*k2*(3300*C*D1**2*bdd1*f**2*r**2 + 10560*C*D1**2*bdd1*f**2*r*s - 3960*C*D1**2*bdd1*f**2*r + 7260*C*D1**2*bdd1*f**2*s**2 - 7920*C*D1**2*bdd1*f**2*s + 3960*C*D1**2*bdd1*f**2 + 21780*C*D1**2*f**2*fd*r**2 + 39240*C*D1**2*f**2*fd*r*s - 27600*C*D1**2*f**2*fd*r + 17460*C*D1**2*f**2*fd*s**2 - 24720*C*D1**2*f**2*fd*s + 13080*C*D1**2*f**2*fd - 21780*C*D1**2*f**2*fdd*r**2 - 33480*C*D1**2*f**2*fdd*r*s + 25680*C*D1**2*f**2*fdd*r - 11700*C*D1**2*f**2*fdd*s**2 + 18960*C*D1**2*f**2*fdd*s - 11160*C*D1**2*f**2*fdd - 43560*C*D1**2*f*fd**2*r**2 - 66960*C*D1**2*f*fd**2*r*s + 51360*C*D1**2*f*fd**2*r - 23400*C*D1**2*f*fd**2*s**2 + 37920*C*D1**2*f*fd**2*s - 11160*C*D1**2*f*fd**2 + 29040*C*D1*Dd*f**3*r**2 + 52320*C*D1*Dd*f**3*r*s - 42120*C*D1*Dd*f**3*r + 23280*C*D1*Dd*f**3*s**2 - 37800*C*D1*Dd*f**3*s + 20340*C*D1*Dd*f**3 - 174240*C*D1*Dd*f**2*fd*r**2 - 267840*C*D1*Dd*f**2*fd*r*s + 223320*C*D1*Dd*f**2*fd*r - 93600*C*D1*Dd*f**2*fd*s**2 + 166200*C*D1*Dd*f**2*fd*s - 70320*C*D1*Dd*f**2*fd - 29040*C*D1*Ddd*f**3*r**2 - 44640*C*D1*Ddd*f**3*r*s + 40200*C*D1*Ddd*f**3*r - 15600*C*D1*Ddd*f**3*s**2 + 30120*C*D1*Ddd*f**3*s - 18420*C*D1*Ddd*f**3 - 87120*C*Dd**2*f**3*r**2 - 133920*C*Dd**2*f**3*r*s + 120600*C*Dd**2*f**3*r - 46800*C*Dd**2*f**3*s**2 + 90360*C*Dd**2*f**3*s - 36840*C*Dd**2*f**3 - 3960*D1**2*K*bdd1*f**2*r**2 - 6336*D1**2*K*bdd1*f**2*r*s + 7920*D1**2*K*bdd1*f**2*r - 2376*D1**2*K*bdd1*f**2*s**2 + 6336*D1**2*K*bdd1*f**2*s - 3960*D1**2*K*bdd1*f**2 + 792*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 8*r*(2*s - 1) + 11*s**2 - 14*s + 3) + 6300*D1**2*bdd1*f**3*r**2 + 11480*D1**2*bdd1*f**3*r*s - 10640*D1**2*bdd1*f**3*r + 5180*D1**2*bdd1*f**3*s**2 - 9520*D1**2*bdd1*f**3*s + 6440*D1**2*bdd1*f**3 + 5610*D1**2*bdd1*f**2*r**2 + 7656*D1**2*bdd1*f**2*r*s - 13860*D1**2*bdd1*f**2*r + 2046*D1**2*bdd1*f**2*s**2 - 10296*D1**2*bdd1*f**2*s + 4950*D1**2*bdd1*f**2 - 3960*D1**2*bdd1*f*g2*r**2 - 12672*D1**2*bdd1*f*g2*r*s + 4752*D1**2*bdd1*f*g2*r - 8712*D1**2*bdd1*f*g2*s**2 + 9504*D1**2*bdd1*f*g2*s - 4752*D1**2*bdd1*f*g2 + 21840*D1**2*f**3*fd*r**2 + 57120*D1**2*f**3*fd*r*s - 36120*D1**2*f**3*fd*r + 35280*D1**2*f**3*fd*s**2 - 46200*D1**2*f**3*fd*s + 19740*D1**2*f**3*fd - 25200*D1**2*f**3*fdd*r**2 - 50400*D1**2*f**3*fdd*r*s + 37800*D1**2*f**3*fdd*r - 25200*D1**2*f**3*fdd*s**2 + 37800*D1**2*f**3*fdd*s - 18900*D1**2*f**3*fdd - 75600*D1**2*f**2*fd**2*r**2 - 151200*D1**2*f**2*fd**2*r*s + 113400*D1**2*f**2*fd**2*r - 75600*D1**2*f**2*fd**2*s**2 + 113400*D1**2*f**2*fd**2*s - 37800*D1**2*f**2*fd**2 - 34605*D1**2*f**2*fd*r**2 - 71010*D1**2*f**2*fd*r*s + 46740*D1**2*f**2*fd*r - 36405*D1**2*f**2*fd*s**2 + 47940*D1**2*f**2*fd*s - 23670*D1**2*f**2*fd + 34380*D1**2*f**2*fdd*r**2 + 63720*D1**2*f**2*fdd*r*s - 44160*D1**2*f**2*fdd*r + 29340*D1**2*f**2*fdd*s**2 - 40800*D1**2*f**2*fdd*s + 21240*D1**2*f**2*fdd - 7128*D1**2*f**2*gd2*r**2 - 14256*D1**2*f**2*gd2*r*s + 14256*D1**2*f**2*gd2*r - 7128*D1**2*f**2*gd2*s**2 + 14256*D1**2*f**2*gd2*s - 7128*D1**2*f**2*gd2 + 7920*D1**2*f**2*gdd2*r**2 + 12672*D1**2*f**2*gdd2*r*s - 15840*D1**2*f**2*gdd2*r + 4752*D1**2*f**2*gdd2*s**2 - 12672*D1**2*f**2*gdd2*s + 7920*D1**2*f**2*gdd2 + 68760*D1**2*f*fd**2*r**2 + 127440*D1**2*f*fd**2*r*s - 88320*D1**2*f*fd**2*r + 58680*D1**2*f*fd**2*s**2 - 81600*D1**2*f*fd**2*s + 21240*D1**2*f*fd**2 - 14256*D1**2*f*fd*g2*r**2 - 28512*D1**2*f*fd*g2*r*s + 14256*D1**2*f*fd*g2*r - 14256*D1**2*f*fd*g2*s**2 + 14256*D1**2*f*fd*g2*s - 7128*D1**2*f*fd*g2 + 31680*D1**2*f*fd*gd2*r**2 + 50688*D1**2*f*fd*gd2*r*s - 44352*D1**2*f*fd*gd2*r + 19008*D1**2*f*fd*gd2*s**2 - 34848*D1**2*f*fd*gd2*s + 12672*D1**2*f*fd*gd2 + 15840*D1**2*f*fdd*g2*r**2 + 25344*D1**2*f*fdd*g2*r*s - 12672*D1**2*f*fdd*g2*r + 9504*D1**2*f*fdd*g2*s**2 - 9504*D1**2*f*fdd*g2*s + 4752*D1**2*f*fdd*g2 + 15840*D1**2*fd**2*g2*r**2 + 25344*D1**2*fd**2*g2*r*s - 12672*D1**2*fd**2*g2*r + 9504*D1**2*fd**2*g2*s**2 - 9504*D1**2*fd**2*g2*s + 21840*D1*Dd*f**4*r**2 + 57120*D1*Dd*f**4*r*s - 36120*D1*Dd*f**4*r + 35280*D1*Dd*f**4*s**2 - 46200*D1*Dd*f**4*s + 19740*D1*Dd*f**4 - 201600*D1*Dd*f**3*fd*r**2 - 403200*D1*Dd*f**3*fd*r*s + 302400*D1*Dd*f**3*fd*r - 201600*D1*Dd*f**3*fd*s**2 + 302400*D1*Dd*f**3*fd*s - 113400*D1*Dd*f**3*fd - 46140*D1*Dd*f**3*r**2 - 94680*D1*Dd*f**3*r*s + 69810*D1*Dd*f**3*r - 48540*D1*Dd*f**3*s**2 + 71610*D1*Dd*f**3*s - 35205*D1*Dd*f**3 + 275040*D1*Dd*f**2*fd*r**2 + 509760*D1*Dd*f**2*fd*r*s - 377880*D1*Dd*f**2*fd*r + 234720*D1*Dd*f**2*fd*s**2 - 349320*D1*Dd*f**2*fd*s + 129120*D1*Dd*f**2*fd - 28512*D1*Dd*f**2*g2*r**2 - 57024*D1*Dd*f**2*g2*r*s + 42768*D1*Dd*f**2*g2*r - 28512*D1*Dd*f**2*g2*s**2 + 42768*D1*Dd*f**2*g2*s - 21384*D1*Dd*f**2*g2 + 63360*D1*Dd*f**2*gd2*r**2 + 101376*D1*Dd*f**2*gd2*r*s - 107712*D1*Dd*f**2*gd2*r + 38016*D1*Dd*f**2*gd2*s**2 - 85536*D1*Dd*f**2*gd2*s + 44352*D1*Dd*f**2*gd2 + 126720*D1*Dd*f*fd*g2*r**2 + 202752*D1*Dd*f*fd*g2*r*s - 139392*D1*Dd*f*fd*g2*r + 76032*D1*Dd*f*fd*g2*s**2 - 107712*D1*Dd*f*fd*g2*s + 34848*D1*Dd*f*fd*g2 - 25200*D1*Ddd*f**4*r**2 - 50400*D1*Ddd*f**4*r*s + 37800*D1*Ddd*f**4*r - 25200*D1*Ddd*f**4*s**2 + 37800*D1*Ddd*f**4*s - 18900*D1*Ddd*f**4 + 45840*D1*Ddd*f**3*r**2 + 84960*D1*Ddd*f**3*r*s - 67080*D1*Ddd*f**3*r + 39120*D1*Ddd*f**3*s**2 - 62040*D1*Ddd*f**3*s + 32700*D1*Ddd*f**3 + 31680*D1*Ddd*f**2*g2*r**2 + 50688*D1*Ddd*f**2*g2*r*s - 44352*D1*Ddd*f**2*g2*r + 19008*D1*Ddd*f**2*g2*s**2 - 34848*D1*Ddd*f**2*g2*s + 20592*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(1365*r**2 + r*(2546*s - 2474) + 1181*s**2 - 2290*s + 1619) - 2*f**2*(264*C*(5*r**2 + 2*r*(11*s - 6) + 17*s**2 - 24*s + 12) - 1782*K*(r + s - 1)**2 - 140*fd*(135*r**2 + 3*r*(82*s - 69) + 111*s**2 - 187*s + 64) + 2937*r**2 + 3894*r*s - 5346*r + 957*s**2 - 3366*s + 1089) + 132*f*(fd*(10*C*(10*r**2 + 16*r*(2*s - 1) + 22*s**2 - 25*s + 3) - 12*K*(10*r**2 + 2*r*(8*s - 7) + 6*s**2 - 11*s + 4) + 170*r**2 + 232*r*s - 248*r + 62*s**2 - 167*s + 108) + g2*(25*r**2 + 2*r*(54*s - 29) + 83*s**2 - 116*s + 58) - 12*gd2*(5*r**2 + 8*r*(2*s - 1) + 11*s**2 - 14*s + 3)) - 1584*fd*g2*(5*r**2 + 8*r*(2*s - 1) + s*(11*s - 11))) + 4*Dd*f*(70*f**2*(180*r**2 + r*(328*s - 283) + 148*s**2 - 255*s + 110) + 33*f*(10*C*(20*r**2 + r*(64*s - 30) + 44*s**2 - 51*s + 12) - 12*K*(20*r**2 + 32*r*s - 34*r + 12*s**2 - 27*s + 14) + 340*r**2 + 464*r*s - 648*r + 124*s**2 - 459*s + 288) - 396*g2*(20*r**2 + r*(64*s - 30) + 44*s**2 - 51*s + 12))) - 75600*Dd**2*f**4*r**2 - 151200*Dd**2*f**4*r*s + 113400*Dd**2*f**4*r - 75600*Dd**2*f**4*s**2 + 113400*Dd**2*f**4*s - 37800*Dd**2*f**4 + 137520*Dd**2*f**3*r**2 + 254880*Dd**2*f**3*r*s - 201240*Dd**2*f**3*r + 117360*Dd**2*f**3*s**2 - 186120*Dd**2*f**3*s + 65400*Dd**2*f**3 + 95040*Dd**2*f**2*g2*r**2 + 152064*Dd**2*f**2*g2*r*s - 133056*Dd**2*f**2*g2*r + 57024*Dd**2*f**2*g2*s**2 - 104544*Dd**2*f**2*g2*s + 41184*Dd**2*f**2*g2 - 66*b1**2*(K - 1)*(D1**2*(fd*(25*r**2 + 2*r*(54*s - 25) + 83*s**2 - 50*s + 25) - 6*fdd*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5)) + D1*(Dd*(f*(100*r**2 + 432*r*s - 208*r + 332*s**2 - 382*s + 133) - 12*fd*(20*r**2 + 64*r*s - 38*r + 44*s**2 - 47*s + 15)) - 6*Ddd*f*(20*r**2 + 4*r*(16*s - 9) + 44*s**2 - 54*s + 21)) - 36*Dd**2*f*(10*r**2 + 2*r*(16*s - 9) + 22*s**2 - 27*s + 7)) + b1*(-5280*C*D1**2*f*fd*r**2 - 23232*C*D1**2*f*fd*r*s + 10560*C*D1**2*f*fd*r - 17952*C*D1**2*f*fd*s**2 + 16896*C*D1**2*f*fd*s - 5280*C*D1**2*f*fd + 6600*C*D1**2*f*fdd*r**2 + 21120*C*D1**2*f*fdd*r*s - 13200*C*D1**2*f*fdd*r + 14520*C*D1**2*f*fdd*s**2 - 17160*C*D1**2*f*fdd*s + 6600*C*D1**2*f*fdd + 6600*C*D1**2*fd**2*r**2 + 21120*C*D1**2*fd**2*r*s - 13200*C*D1**2*fd**2*r + 14520*C*D1**2*fd**2*s**2 - 17160*C*D1**2*fd**2*s + 6600*C*D1**2*fd**2 - 10560*C*D1*Dd*f**2*r**2 - 46464*C*D1*Dd*f**2*r*s + 22176*C*D1*Dd*f**2*r - 35904*C*D1*Dd*f**2*s**2 + 41184*C*D1*Dd*f**2*s - 14256*C*D1*Dd*f**2 + 52800*C*D1*Dd*f*fd*r**2 + 168960*C*D1*Dd*f*fd*r*s - 100320*C*D1*Dd*f*fd*r + 116160*C*D1*Dd*f*fd*s**2 - 139920*C*D1*Dd*f*fd*s + 43560*C*D1*Dd*f*fd + 13200*C*D1*Ddd*f**2*r**2 + 42240*C*D1*Ddd*f**2*r*s - 23760*C*D1*Ddd*f**2*r + 29040*C*D1*Ddd*f**2*s**2 - 35640*C*D1*Ddd*f**2*s + 13860*C*D1*Ddd*f**2 + 39600*C*Dd**2*f**2*r**2 + 126720*C*Dd**2*f**2*r*s - 71280*C*Dd**2*f**2*r + 87120*C*Dd**2*f**2*s**2 - 106920*C*Dd**2*f**2*s + 27720*C*Dd**2*f**2 + 7128*D1**2*K*f*fd*r**2 + 14256*D1**2*K*f*fd*r*s - 7128*D1**2*K*f*fd*r + 7128*D1**2*K*f*fd*s**2 - 7128*D1**2*K*f*fd*s + 3564*D1**2*K*f*fd - 7920*D1**2*K*f*fdd*r**2 - 12672*D1**2*K*f*fdd*r*s + 6336*D1**2*K*f*fdd*r - 4752*D1**2*K*f*fdd*s**2 + 4752*D1**2*K*f*fdd*s - 2376*D1**2*K*f*fdd - 7920*D1**2*K*fd**2*r**2 - 12672*D1**2*K*fd**2*r*s + 6336*D1**2*K*fd**2*r - 4752*D1**2*K*fd**2*s**2 + 4752*D1**2*K*fd**2*s + 396*D1**2*bdd1*f*(K - 1)*(10*r**2 + 32*r*s - 16*r + 22*s**2 - 28*s + 11) - 20475*D1**2*f**2*fd*r**2 - 38190*D1**2*f**2*fd*r*s + 27660*D1**2*f**2*fd*r - 17715*D1**2*f**2*fd*s**2 + 25820*D1**2*f**2*fd*s - 11460*D1**2*f**2*fd + 18900*D1**2*f**2*fdd*r**2 + 34440*D1**2*f**2*fdd*r*s - 26040*D1**2*f**2*fdd*r + 15540*D1**2*f**2*fdd*s**2 - 23800*D1**2*f**2*fdd*s + 11340*D1**2*f**2*fdd + 37800*D1**2*f*fd**2*r**2 + 68880*D1**2*f*fd**2*r*s - 52080*D1**2*f*fd**2*r + 31080*D1**2*f*fd**2*s**2 - 47600*D1**2*f*fd**2*s + 17640*D1**2*f*fd**2 - 11748*D1**2*f*fd*r**2 - 15576*D1**2*f*fd*r*s + 8844*D1**2*f*fd*r - 3828*D1**2*f*fd*s**2 + 4884*D1**2*f*fd*s - 5610*D1**2*f*fd + 11220*D1**2*f*fdd*r**2 + 15312*D1**2*f*fdd*r*s - 5016*D1**2*f*fdd*r + 4092*D1**2*f*fdd*s**2 - 1452*D1**2*f*fdd*s + 2706*D1**2*f*fdd + 3300*D1**2*f*gd2*r**2 + 14256*D1**2*f*gd2*r*s - 6600*D1**2*f*gd2*r + 10956*D1**2*f*gd2*s**2 - 14256*D1**2*f*gd2*s + 3300*D1**2*f*gd2 - 3960*D1**2*f*gdd2*r**2 - 12672*D1**2*f*gdd2*r*s + 7920*D1**2*f*gdd2*r - 8712*D1**2*f*gdd2*s**2 + 12672*D1**2*f*gdd2*s - 3960*D1**2*f*gdd2 + 11220*D1**2*fd**2*r**2 + 15312*D1**2*fd**2*r*s - 5016*D1**2*fd**2*r + 4092*D1**2*fd**2*s**2 - 1452*D1**2*fd**2*s - 6600*D1**2*fd**2 + 3300*D1**2*fd*g2*r**2 + 14256*D1**2*fd*g2*r*s - 6600*D1**2*fd*g2*r + 10956*D1**2*fd*g2*s**2 - 6600*D1**2*fd*g2*s + 3300*D1**2*fd*g2 - 7920*D1**2*fd*gd2*r**2 - 25344*D1**2*fd*gd2*r*s + 15840*D1**2*fd*gd2*r - 17424*D1**2*fd*gd2*s**2 + 20592*D1**2*fd*gd2*s - 7920*D1**2*fd*gd2 - 3960*D1**2*fdd*g2*r**2 - 12672*D1**2*fdd*g2*r*s + 7920*D1**2*fdd*g2*r - 8712*D1**2*fdd*g2*s**2 + 7920*D1**2*fdd*g2*s - 3960*D1**2*fdd*g2 + 14256*D1*Dd*K*f**2*r**2 + 28512*D1*Dd*K*f**2*r*s - 21384*D1*Dd*K*f**2*r + 14256*D1*Dd*K*f**2*s**2 - 21384*D1*Dd*K*f**2*s + 10692*D1*Dd*K*f**2 - 63360*D1*Dd*K*f*fd*r**2 - 101376*D1*Dd*K*f*fd*r*s + 69696*D1*Dd*K*f*fd*r - 38016*D1*Dd*K*f*fd*s**2 + 53856*D1*Dd*K*f*fd*s - 17424*D1*Dd*K*f*fd - 27300*D1*Dd*f**3*r**2 - 50920*D1*Dd*f**3*r*s + 40030*D1*Dd*f**3*r - 23620*D1*Dd*f**3*s**2 + 37270*D1*Dd*f**3*s - 19555*D1*Dd*f**3 + 151200*D1*Dd*f**2*fd*r**2 + 275520*D1*Dd*f**2*fd*r*s - 214200*D1*Dd*f**2*fd*r + 124320*D1*Dd*f**2*fd*s**2 - 195160*D1*Dd*f**2*fd*s + 75880*D1*Dd*f**2*fd - 23496*D1*Dd*f**2*r**2 - 31152*D1*Dd*f**2*r*s + 31284*D1*Dd*f**2*r - 7656*D1*Dd*f**2*s**2 + 19404*D1*Dd*f**2*s - 13662*D1*Dd*f**2 + 89760*D1*Dd*f*fd*r**2 + 122496*D1*Dd*f*fd*r*s - 80256*D1*Dd*f*fd*r + 32736*D1*Dd*f*fd*s**2 - 44616*D1*Dd*f*fd*s + 11484*D1*Dd*f*fd + 13200*D1*Dd*f*g2*r**2 + 57024*D1*Dd*f*g2*r*s - 27456*D1*Dd*f*g2*r + 43824*D1*Dd*f*g2*s**2 - 50424*D1*Dd*f*g2*s + 17556*D1*Dd*f*g2 - 31680*D1*Dd*f*gd2*r**2 - 101376*D1*Dd*f*gd2*r*s + 60192*D1*Dd*f*gd2*r - 69696*D1*Dd*f*gd2*s**2 + 93456*D1*Dd*f*gd2*s - 28512*D1*Dd*f*gd2 - 31680*D1*Dd*fd*g2*r**2 - 101376*D1*Dd*fd*g2*r*s + 60192*D1*Dd*fd*g2*r - 69696*D1*Dd*fd*g2*s**2 + 74448*D1*Dd*fd*g2*s - 23760*D1*Dd*fd*g2 - 15840*D1*Ddd*K*f**2*r**2 - 25344*D1*Ddd*K*f**2*r*s + 22176*D1*Ddd*K*f**2*r - 9504*D1*Ddd*K*f**2*s**2 + 17424*D1*Ddd*K*f**2*s - 10296*D1*Ddd*K*f**2 + 25200*D1*Ddd*f**3*r**2 + 45920*D1*Ddd*f**3*r*s - 36680*D1*Ddd*f**3*r + 20720*D1*Ddd*f**3*s**2 - 33320*D1*Ddd*f**3*s + 17780*D1*Ddd*f**3 + 22440*D1*Ddd*f**2*r**2 + 30624*D1*Ddd*f**2*r*s - 30096*D1*Ddd*f**2*r + 8184*D1*Ddd*f**2*s**2 - 19404*D1*Ddd*f**2*s + 13266*D1*Ddd*f**2 - 15840*D1*Ddd*f*g2*r**2 - 50688*D1*Ddd*f*g2*r*s + 28512*D1*Ddd*f*g2*r - 34848*D1*Ddd*f*g2*s**2 + 42768*D1*Ddd*f*g2*s - 16632*D1*Ddd*f*g2 - 66*D1*bd1*(K - 1)*(D1*(f*(50*r**2 + 108*r*(2*s - 1) + 166*s**2 - 224*s + 83) - 12*fd*(10*r**2 + 2*r*(16*s - 9) + 22*s**2 - 24*s + 5)) - 24*Dd*f*(20*r**2 + r*(64*s - 34) + 44*s**2 - 55*s + 15)) - 47520*Dd**2*K*f**2*r**2 - 76032*Dd**2*K*f**2*r*s + 66528*Dd**2*K*f**2*r - 28512*Dd**2*K*f**2*s**2 + 52272*Dd**2*K*f**2*s - 20592*Dd**2*K*f**2 + 75600*Dd**2*f**3*r**2 + 137760*Dd**2*f**3*r*s - 110040*Dd**2*f**3*r + 62160*Dd**2*f**3*s**2 - 99960*Dd**2*f**3*s + 35560*Dd**2*f**3 + 67320*Dd**2*f**2*r**2 + 91872*Dd**2*f**2*r*s - 90288*Dd**2*f**2*r + 24552*Dd**2*f**2*s**2 - 58212*Dd**2*f**2*s + 26532*Dd**2*f**2 - 47520*Dd**2*f*g2*r**2 - 152064*Dd**2*f*g2*r*s + 85536*Dd**2*f*g2*r - 104544*Dd**2*f*g2*s**2 + 128304*Dd**2*f*g2*s - 33264*Dd**2*f*g2))/(693*d**2*k3**5) + 8*D1**2*Pk2*Pkd3*ct**5*k1**3*(-198*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(5*f**3*s*(181*r + 181*s - 102) + f**2*(-140*fd*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3) + 66*s*(4*C*s + r*(4*C + 5) + 5*s - 9)) - 33*f*(5*fd*(r*(2*C + 1)*(4*s - 1) + s**2*(8*C + 4) - s*(6*C + 6) + 3) + 2*s*(5*g2*(r + s) - 6*gd2*(2*r + 2*s - 1))) + 396*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(140*f**2*(5*r*(8*s - 1) + 40*s**2 - 32*s + 3) + 165*f*(r*(2*C + 1)*(8*s - 1) + s**2*(16*C + 8) - s*(8*C + 16) + 3) - 396*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 33*b1**2*(K - 1)*(D1**2*(5*fd - 6*fdd)*(s - 1)*(r + s - 1) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(5*f**2*(fd*(181*r*(3*s - 1) + 543*s**2 - 622*s + 181) - 28*fdd*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5)) - f*(140*fd**2*(10*r*(3*s - 1) + 30*s**2 - 34*s + 7) - 66*fd*(4*C*(2*s - 1)*(r + s - 1) + 5*r*(2*s - 1) + 10*s**2 - 6*s + 5) + 165*fdd*(2*C*(2*s - 1)*(r + s - 1) + r*(2*s - 1) + 2*s**2 + 1) + 66*s*(3*bdd1*(K - 1)*(2*r + 2*s - 1) + (5*gd2 - 6*gdd2)*(r + s - 1))) - 165*fd**2*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 - 2) - 66*fd*(5*g2*(s - 1) + 6*gd2*(1 - 2*s))*(r + s - 1) + 396*fdd*g2*(s - 1)*(r + s - 1)) - 33*D1*bd1*(K - 1)*(D1*(-5*f*s*(2*r + 2*s - 1) + 6*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 6*Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(905*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + 2*f**2*(132*C*(r*(4*s - 1) + (1 - 2*s)**2) - 70*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) + 165*r*(4*s - 1) + 165*(1 - 2*s)**2) - 66*f*(5*fd*(C*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + 8*r*s - 3*r + 8*s**2 - 4*s + 1) + 5*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 6*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 396*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(700*f**2 + f*(330*C + 165) - 396*g2)) - Dd**2*f*(700*f**2 + f*(330*C + 165) - 396*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - f*(D1**2*(140*bdd1*f**2*s*(5*r + 5*s - 3) - 396*bdd1*g2*s*(r + s) - 15*f*(-11*bdd1*s*(2*C*r + 2*C*s + r + s - 3) + 34*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 420*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 30*D1*f*(Dd*(17*f*(r*(4*s - 1) + (1 - 2*s)**2) - 14*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 14*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 420*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k2*k3**3) - 15*D1**2*Pk2*Pkd3*ct**5*k1*k2**5*st**2*(-600*C*D1**2*f**2*fd*r**2 - 1200*C*D1**2*f**2*fd*r*s + 800*C*D1**2*f**2*fd*r - 600*C*D1**2*f**2*fd*s**2 + 800*C*D1**2*f**2*fd*s - 400*C*D1**2*f**2*fd + 300*C*D1**2*f**2*fdd*r**2 + 600*C*D1**2*f**2*fdd*r*s - 400*C*D1**2*f**2*fdd*r + 300*C*D1**2*f**2*fdd*s**2 - 400*C*D1**2*f**2*fdd*s + 200*C*D1**2*f**2*fdd + 600*C*D1**2*f*fd**2*r**2 + 1200*C*D1**2*f*fd**2*r*s - 800*C*D1**2*f*fd**2*r + 600*C*D1**2*f*fd**2*s**2 - 800*C*D1**2*f*fd**2*s + 200*C*D1**2*f*fd**2 - 800*C*D1*Dd*f**3*r**2 - 1600*C*D1*Dd*f**3*r*s + 1200*C*D1*Dd*f**3*r - 800*C*D1*Dd*f**3*s**2 + 1200*C*D1*Dd*f**3*s - 600*C*D1*Dd*f**3 + 2400*C*D1*Dd*f**2*fd*r**2 + 4800*C*D1*Dd*f**2*fd*r*s - 3400*C*D1*Dd*f**2*fd*r + 2400*C*D1*Dd*f**2*fd*s**2 - 3400*C*D1*Dd*f**2*fd*s + 1200*C*D1*Dd*f**2*fd + 400*C*D1*Ddd*f**3*r**2 + 800*C*D1*Ddd*f**3*r*s - 600*C*D1*Ddd*f**3*r + 400*C*D1*Ddd*f**3*s**2 - 600*C*D1*Ddd*f**3*s + 300*C*D1*Ddd*f**3 + 1200*C*Dd**2*f**3*r**2 + 2400*C*Dd**2*f**3*r*s - 1800*C*Dd**2*f**3*r + 1200*C*Dd**2*f**3*s**2 - 1800*C*Dd**2*f**3*s + 600*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r**2 - 528*D1**2*K*b1*f*fd*r*s + 264*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 132*D1**2*K*b1*f*fdd*s**2 - 132*D1**2*K*b1*f*fdd*s + 66*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 132*D1**2*K*b1*fd**2*s**2 - 132*D1**2*K*b1*fd**2*s + 210*D1**2*b1*f**2*fd*r**2 + 420*D1**2*b1*f**2*fd*r*s - 280*D1**2*b1*f**2*fd*r + 210*D1**2*b1*f**2*fd*s**2 - 280*D1**2*b1*f**2*fd*s + 140*D1**2*b1*f**2*fd - 105*D1**2*b1*f**2*fdd*r**2 - 210*D1**2*b1*f**2*fdd*r*s + 140*D1**2*b1*f**2*fdd*r - 105*D1**2*b1*f**2*fdd*s**2 + 140*D1**2*b1*f**2*fdd*s - 70*D1**2*b1*f**2*fdd - 210*D1**2*b1*f*fd**2*r**2 - 420*D1**2*b1*f*fd**2*r*s + 280*D1**2*b1*f*fd**2*r - 210*D1**2*b1*f*fd**2*s**2 + 280*D1**2*b1*f*fd**2*s - 70*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-66*K + 35*f + 33)*(r + s - 1)**2 + 450*D1**2*f**2*fd*r**2 + 900*D1**2*f**2*fd*r*s - 600*D1**2*f**2*fd*r + 450*D1**2*f**2*fd*s**2 - 600*D1**2*f**2*fd*s + 300*D1**2*f**2*fd - 225*D1**2*f**2*fdd*r**2 - 450*D1**2*f**2*fdd*r*s + 300*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 300*D1**2*f**2*fdd*s - 150*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 450*D1**2*f*fd**2*r**2 - 900*D1**2*f*fd**2*r*s + 600*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 600*D1**2*f*fd**2*s - 150*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 - 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 792*D1*Dd*K*b1*f**2*s - 396*D1*Dd*K*b1*f**2 + 1056*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1320*D1*Dd*K*b1*f*fd*r + 1056*D1*Dd*K*b1*f*fd*s**2 - 1320*D1*Dd*K*b1*f*fd*s + 396*D1*Dd*K*b1*f*fd + 280*D1*Dd*b1*f**3*r**2 + 560*D1*Dd*b1*f**3*r*s - 420*D1*Dd*b1*f**3*r + 280*D1*Dd*b1*f**3*s**2 - 420*D1*Dd*b1*f**3*s + 210*D1*Dd*b1*f**3 - 840*D1*Dd*b1*f**2*fd*r**2 - 1680*D1*Dd*b1*f**2*fd*r*s + 1190*D1*Dd*b1*f**2*fd*r - 840*D1*Dd*b1*f**2*fd*s**2 + 1190*D1*Dd*b1*f**2*fd*s - 420*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 600*D1*Dd*f**3*r**2 + 1200*D1*Dd*f**3*r*s - 900*D1*Dd*f**3*r + 600*D1*Dd*f**3*s**2 - 900*D1*Dd*f**3*s + 450*D1*Dd*f**3 - 1800*D1*Dd*f**2*fd*r**2 - 3600*D1*Dd*f**2*fd*r*s + 2550*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 2550*D1*Dd*f**2*fd*s - 900*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r + 264*D1*Ddd*K*b1*f**2*s**2 - 396*D1*Ddd*K*b1*f**2*s + 198*D1*Ddd*K*b1*f**2 - 140*D1*Ddd*b1*f**3*r**2 - 280*D1*Ddd*b1*f**3*r*s + 210*D1*Ddd*b1*f**3*r - 140*D1*Ddd*b1*f**3*s**2 + 210*D1*Ddd*b1*f**3*s - 105*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 300*D1*Ddd*f**3*r**2 - 600*D1*Ddd*f**3*r*s + 450*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 450*D1*Ddd*f**3*s - 225*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(35*f**2*(r + s - 1) - 35*f*fd*(3*r + 3*s - 2) - 33*f*(2*K - 1)*(r + s - 1) + 33*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-66*K + 35*f + 33)*(4*r + 4*s - 3))*(r + s - 1) + 792*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r + 792*Dd**2*K*b1*f**2*s**2 - 1188*Dd**2*K*b1*f**2*s + 396*Dd**2*K*b1*f**2 - 420*Dd**2*b1*f**3*r**2 - 840*Dd**2*b1*f**3*r*s + 630*Dd**2*b1*f**3*r - 420*Dd**2*b1*f**3*s**2 + 630*Dd**2*b1*f**3*s - 210*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 900*Dd**2*f**3*r**2 - 1800*Dd**2*f**3*r*s + 1350*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 1350*Dd**2*f**3*s - 450*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2)/(154*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**5*k1*k2**5*(-660*C*D1**2*bdd1*f**2*r**2 - 1320*C*D1**2*bdd1*f**2*r*s + 1320*C*D1**2*bdd1*f**2*r - 660*C*D1**2*bdd1*f**2*s**2 + 1320*C*D1**2*bdd1*f**2*s - 660*C*D1**2*bdd1*f**2 + 2760*C*D1**2*f**2*fd*r**2 + 5520*C*D1**2*f**2*fd*r*s - 3680*C*D1**2*f**2*fd*r + 2760*C*D1**2*f**2*fd*s**2 - 3680*C*D1**2*f**2*fd*s + 1840*C*D1**2*f**2*fd - 3360*C*D1**2*f**2*fdd*r**2 - 6720*C*D1**2*f**2*fdd*r*s + 4480*C*D1**2*f**2*fdd*r - 3360*C*D1**2*f**2*fdd*s**2 + 4480*C*D1**2*f**2*fdd*s - 2240*C*D1**2*f**2*fdd - 6720*C*D1**2*f*fd**2*r**2 - 13440*C*D1**2*f*fd**2*r*s + 8960*C*D1**2*f*fd**2*r - 6720*C*D1**2*f*fd**2*s**2 + 8960*C*D1**2*f*fd**2*s - 2240*C*D1**2*f*fd**2 + 3680*C*D1*Dd*f**3*r**2 + 7360*C*D1*Dd*f**3*r*s - 5520*C*D1*Dd*f**3*r + 3680*C*D1*Dd*f**3*s**2 - 5520*C*D1*Dd*f**3*s + 2760*C*D1*Dd*f**3 - 26880*C*D1*Dd*f**2*fd*r**2 - 53760*C*D1*Dd*f**2*fd*r*s + 38080*C*D1*Dd*f**2*fd*r - 26880*C*D1*Dd*f**2*fd*s**2 + 38080*C*D1*Dd*f**2*fd*s - 13440*C*D1*Dd*f**2*fd - 4480*C*D1*Ddd*f**3*r**2 - 8960*C*D1*Ddd*f**3*r*s + 6720*C*D1*Ddd*f**3*r - 4480*C*D1*Ddd*f**3*s**2 + 6720*C*D1*Ddd*f**3*s - 3360*C*D1*Ddd*f**3 - 13440*C*Dd**2*f**3*r**2 - 26880*C*Dd**2*f**3*r*s + 20160*C*Dd**2*f**3*r - 13440*C*Dd**2*f**3*s**2 + 20160*C*Dd**2*f**3*s - 6720*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r**2 - 1320*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 660*D1**2*K*bdd1*f**2*s**2 + 1320*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 + 66*D1**2*bd1**2*f*(-12*K + 5*f + 6)*(r + s - 1)**2 + 495*D1**2*bdd1*f**2*r**2 + 990*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*r + 495*D1**2*bdd1*f**2*s**2 - 990*D1**2*bdd1*f**2*s + 495*D1**2*bdd1*f**2 + 792*D1**2*bdd1*f*g2*r**2 + 1584*D1**2*bdd1*f*g2*r*s - 1584*D1**2*bdd1*f*g2*r + 792*D1**2*bdd1*f*g2*s**2 - 1584*D1**2*bdd1*f*g2*s + 792*D1**2*bdd1*f*g2 - 885*D1**2*f**2*fd*r**2 - 1770*D1**2*f**2*fd*r*s + 1180*D1**2*f**2*fd*r - 885*D1**2*f**2*fd*s**2 + 1180*D1**2*f**2*fd*s - 590*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*r**2 + 3360*D1**2*f**2*fdd*r*s - 2240*D1**2*f**2*fdd*r + 1680*D1**2*f**2*fdd*s**2 - 2240*D1**2*f**2*fdd*s + 1120*D1**2*f**2*fdd - 1056*D1**2*f**2*gd2*r**2 - 2112*D1**2*f**2*gd2*r*s + 2112*D1**2*f**2*gd2*r - 1056*D1**2*f**2*gd2*s**2 + 2112*D1**2*f**2*gd2*s - 1056*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 3360*D1**2*f*fd**2*r**2 + 6720*D1**2*f*fd**2*r*s - 4480*D1**2*f*fd**2*r + 3360*D1**2*f*fd**2*s**2 - 4480*D1**2*f*fd**2*s + 1120*D1**2*f*fd**2 - 2112*D1**2*f*fd*g2*r**2 - 4224*D1**2*f*fd*g2*r*s + 2112*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s**2 + 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s - 1180*D1*Dd*f**3*r**2 - 2360*D1*Dd*f**3*r*s + 1770*D1*Dd*f**3*r - 1180*D1*Dd*f**3*s**2 + 1770*D1*Dd*f**3*s - 885*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*r**2 + 26880*D1*Dd*f**2*fd*r*s - 19040*D1*Dd*f**2*fd*r + 13440*D1*Dd*f**2*fd*s**2 - 19040*D1*Dd*f**2*fd*s + 6720*D1*Dd*f**2*fd - 4224*D1*Dd*f**2*g2*r**2 - 8448*D1*Dd*f**2*g2*r*s + 6336*D1*Dd*f**2*g2*r - 4224*D1*Dd*f**2*g2*s**2 + 6336*D1*Dd*f**2*g2*s - 3168*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 2240*D1*Ddd*f**3*r**2 + 4480*D1*Ddd*f**3*r*s - 3360*D1*Ddd*f**3*r + 2240*D1*Ddd*f**3*s**2 - 3360*D1*Ddd*f**3*s + 1680*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(5*f**3*(r + s - 1) + 8*f**2*(5*C + 2*K - 3)*(r + s - 1) - 10*f*fd*(4*C + 4*K - 3)*(2*r + 2*s - 1) - 48*f*(g2 - gd2)*(r + s - 1) + 48*fd*g2*(r + s)) - 2*Dd*f*(5*f*(4*C + 4*K - 3) - 24*g2)*(4*r + 4*s - 3))*(r + s - 1) + 6720*Dd**2*f**3*r**2 + 13440*Dd**2*f**3*r*s - 10080*Dd**2*f**3*r + 6720*Dd**2*f**3*s**2 - 10080*Dd**2*f**3*s + 3360*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(5*fd**2*(r + s - 1) + 6*fd*(2*K - 1)*(r + s) - 3*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (12*K - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-12*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-12*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-80*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s + 80*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 80*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 240*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 240*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 400*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 32*D1**2*K*f*fd*r**2 - 64*D1**2*K*f*fd*r*s + 32*D1**2*K*f*fd*r - 32*D1**2*K*f*fd*s**2 + 32*D1**2*K*f*fd*s - 16*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-12*K + 5*f + 6)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 48*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s - 48*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s + 24*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 48*D1**2*f*gd2*r**2 + 96*D1**2*f*gd2*r*s - 96*D1**2*f*gd2*r + 48*D1**2*f*gd2*s**2 - 96*D1**2*f*gd2*s + 48*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 48*D1**2*fd*g2*r**2 + 96*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 - 64*D1*Dd*K*f**2*r**2 - 128*D1*Dd*K*f**2*r*s + 96*D1*Dd*K*f**2*r - 64*D1*Dd*K*f**2*s**2 + 96*D1*Dd*K*f**2*s - 48*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 96*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s - 144*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 144*D1*Dd*f**2*s + 72*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 192*D1*Dd*f*g2*r**2 + 384*D1*Dd*f*g2*r*s - 288*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 288*D1*Dd*f*g2*s + 144*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 144*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 6*f*(2*K - 1)*(r + s - 1) + 6*fd*(2*K - 1)*(r + s)) - Dd*f*(-12*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(77*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**5*k1*k2**3*st**2*(-18672*C*D1**2*f**2*fd*r**2 + 17328*C*D1**2*f**2*fd*r*s + 6672*C*D1**2*f**2*fd*r + 36000*C*D1**2*f**2*fd*s**2 - 29776*C*D1**2*f**2*fd*s + 5776*C*D1**2*f**2*fd + 10920*C*D1**2*f**2*fdd*r**2 - 7080*C*D1**2*f**2*fdd*r*s - 4920*C*D1**2*f**2*fdd*r - 18000*C*D1**2*f**2*fdd*s**2 + 14360*C*D1**2*f**2*fdd*s - 2360*C*D1**2*f**2*fdd + 21840*C*D1**2*f*fd**2*r**2 - 14160*C*D1**2*f*fd**2*r*s - 9840*C*D1**2*f*fd**2*r - 36000*C*D1**2*f*fd**2*s**2 + 28720*C*D1**2*f*fd**2*s - 2360*C*D1**2*f*fd**2 - 24896*C*D1*Dd*f**3*r**2 + 23104*C*D1*Dd*f**3*r*s + 19120*C*D1*Dd*f**3*r + 48000*C*D1*Dd*f**3*s**2 - 35552*C*D1*Dd*f**3*s - 448*C*D1*Dd*f**3 + 87360*C*D1*Dd*f**2*fd*r**2 - 56640*C*D1*Dd*f**2*fd*r*s - 56280*C*D1*Dd*f**2*fd*r - 144000*C*D1*Dd*f**2*fd*s**2 + 107600*C*D1*Dd*f**2*fd*s - 4520*C*D1*Dd*f**2*fd + 14560*C*D1*Ddd*f**3*r**2 - 9440*C*D1*Ddd*f**3*r*s - 12200*C*D1*Ddd*f**3*r - 24000*C*D1*Ddd*f**3*s**2 + 16720*C*D1*Ddd*f**3*s + 1280*C*D1*Ddd*f**3 + 43680*C*Dd**2*f**3*r**2 - 28320*C*Dd**2*f**3*r*s - 36600*C*Dd**2*f**3*r - 72000*C*Dd**2*f**3*s**2 + 50160*C*Dd**2*f**3*s + 2560*C*Dd**2*f**3 - 7920*D1**2*K*b1*f*fd*r**2 + 7920*D1**2*K*b1*f*fd*r*s - 3960*D1**2*K*b1*f*fd*r + 15840*D1**2*K*b1*f*fd*s**2 - 15840*D1**2*K*b1*f*fd*s + 7920*D1**2*K*b1*f*fd + 3960*D1**2*K*b1*f*fdd*r**2 - 3960*D1**2*K*b1*f*fdd*r*s + 1980*D1**2*K*b1*f*fdd*r - 7920*D1**2*K*b1*f*fdd*s**2 + 7920*D1**2*K*b1*f*fdd*s - 3960*D1**2*K*b1*f*fdd + 3960*D1**2*K*b1*fd**2*r**2 - 3960*D1**2*K*b1*fd**2*r*s + 1980*D1**2*K*b1*fd**2*r - 7920*D1**2*K*b1*fd**2*s**2 + 7920*D1**2*K*b1*fd**2*s + 15750*D1**2*b1*f**2*fd*r**2 + 18900*D1**2*b1*f**2*fd*r*s - 16800*D1**2*b1*f**2*fd*r + 3150*D1**2*b1*f**2*fd*s**2 - 8400*D1**2*b1*f**2*fd*s + 6300*D1**2*b1*f**2*fd - 7875*D1**2*b1*f**2*fdd*r**2 - 9450*D1**2*b1*f**2*fdd*r*s + 8400*D1**2*b1*f**2*fdd*r - 1575*D1**2*b1*f**2*fdd*s**2 + 4200*D1**2*b1*f**2*fdd*s - 3150*D1**2*b1*f**2*fdd - 15750*D1**2*b1*f*fd**2*r**2 - 18900*D1**2*b1*f*fd**2*r*s + 16800*D1**2*b1*f*fd**2*r - 3150*D1**2*b1*f*fd**2*s**2 + 8400*D1**2*b1*f*fd**2*s - 3150*D1**2*b1*f*fd**2 + 17820*D1**2*b1*f*fd*r**2 + 19800*D1**2*b1*f*fd*r*s - 9900*D1**2*b1*f*fd*r + 1980*D1**2*b1*f*fd*s**2 - 1980*D1**2*b1*f*fd*s + 990*D1**2*b1*f*fd - 8910*D1**2*b1*f*fdd*r**2 - 9900*D1**2*b1*f*fdd*r*s + 4950*D1**2*b1*f*fdd*r - 990*D1**2*b1*f*fdd*s**2 + 990*D1**2*b1*f*fdd*s - 495*D1**2*b1*f*fdd - 8910*D1**2*b1*fd**2*r**2 - 9900*D1**2*b1*fd**2*r*s + 4950*D1**2*b1*fd**2*r - 990*D1**2*b1*fd**2*s**2 + 990*D1**2*b1*fd**2*s - 15*D1**2*bdd1*f**2*(r + s - 1)*(-132*K*(r - 2*s - 1) + 35*f*(5*r + s - 5) + 297*r + 33*s - 297) - 8400*D1**2*f**3*fd*r**2 - 8400*D1**2*f**3*fd*r*s + 10500*D1**2*f**3*fd*r + 4200*D1**2*f**3*fd*s - 4200*D1**2*f**3*fd + 8400*D1**2*f**3*fdd*r**2 + 8400*D1**2*f**3*fdd*r*s - 10500*D1**2*f**3*fdd*r - 4200*D1**2*f**3*fdd*s + 4200*D1**2*f**3*fdd + 25200*D1**2*f**2*fd**2*r**2 + 25200*D1**2*f**2*fd**2*r*s - 31500*D1**2*f**2*fd**2*r - 12600*D1**2*f**2*fd**2*s + 8400*D1**2*f**2*fd**2 + 29922*D1**2*f**2*fd*r**2 + 14172*D1**2*f**2*fd*r*s - 24672*D1**2*f**2*fd*r - 15750*D1**2*f**2*fd*s**2 + 5776*D1**2*f**2*fd*s + 4724*D1**2*f**2*fd - 16545*D1**2*f**2*fdd*r**2 - 8670*D1**2*f**2*fdd*r*s + 13920*D1**2*f**2*fdd*r + 7875*D1**2*f**2*fdd*s**2 - 2360*D1**2*f**2*fdd*s - 2890*D1**2*f**2*fdd + 7920*D1**2*f**2*gd2*r**2 - 7920*D1**2*f**2*gd2*r*s - 15840*D1**2*f**2*gd2*r - 15840*D1**2*f**2*gd2*s**2 + 7920*D1**2*f**2*gd2*s + 7920*D1**2*f**2*gd2 - 3960*D1**2*f**2*gdd2*r**2 + 3960*D1**2*f**2*gdd2*r*s + 7920*D1**2*f**2*gdd2*r + 7920*D1**2*f**2*gdd2*s**2 - 3960*D1**2*f**2*gdd2*s - 3960*D1**2*f**2*gdd2 - 33090*D1**2*f*fd**2*r**2 - 17340*D1**2*f*fd**2*r*s + 27840*D1**2*f*fd**2*r + 15750*D1**2*f*fd**2*s**2 - 4720*D1**2*f*fd**2*s - 2890*D1**2*f*fd**2 + 15840*D1**2*f*fd*g2*r**2 - 15840*D1**2*f*fd*g2*r*s + 7920*D1**2*f*fd*g2*r - 31680*D1**2*f*fd*g2*s**2 + 31680*D1**2*f*fd*g2*s - 15840*D1**2*f*fd*g2 - 15840*D1**2*f*fd*gd2*r**2 + 15840*D1**2*f*fd*gd2*r*s + 11880*D1**2*f*fd*gd2*r + 31680*D1**2*f*fd*gd2*s**2 - 23760*D1**2*f*fd*gd2*s + 3960*D1**2*f*fd*gd2 - 7920*D1**2*f*fdd*g2*r**2 + 7920*D1**2*f*fdd*g2*r*s - 3960*D1**2*f*fdd*g2*r + 15840*D1**2*f*fdd*g2*s**2 - 15840*D1**2*f*fdd*g2*s + 7920*D1**2*f*fdd*g2 - 7920*D1**2*fd**2*g2*r**2 + 7920*D1**2*fd**2*g2*r*s - 3960*D1**2*fd**2*g2*r + 15840*D1**2*fd**2*g2*s**2 - 15840*D1**2*fd**2*g2*s - 15840*D1*Dd*K*b1*f**2*r**2 + 15840*D1*Dd*K*b1*f**2*r*s + 11880*D1*Dd*K*b1*f**2*r + 31680*D1*Dd*K*b1*f**2*s**2 - 23760*D1*Dd*K*b1*f**2*s + 31680*D1*Dd*K*b1*f*fd*r**2 - 31680*D1*Dd*K*b1*f*fd*r*s - 3960*D1*Dd*K*b1*f*fd*r - 63360*D1*Dd*K*b1*f*fd*s**2 + 55440*D1*Dd*K*b1*f*fd*s - 11880*D1*Dd*K*b1*f*fd + 21000*D1*Dd*b1*f**3*r**2 + 25200*D1*Dd*b1*f**3*r*s - 27300*D1*Dd*b1*f**3*r + 4200*D1*Dd*b1*f**3*s**2 - 14700*D1*Dd*b1*f**3*s + 11550*D1*Dd*b1*f**3 - 63000*D1*Dd*b1*f**2*fd*r**2 - 75600*D1*Dd*b1*f**2*fd*r*s + 74550*D1*Dd*b1*f**2*fd*r - 12600*D1*Dd*b1*f**2*fd*s**2 + 38850*D1*Dd*b1*f**2*fd*s - 21000*D1*Dd*b1*f**2*fd + 35640*D1*Dd*b1*f**2*r**2 + 39600*D1*Dd*b1*f**2*r*s - 45540*D1*Dd*b1*f**2*r + 3960*D1*Dd*b1*f**2*s**2 - 21780*D1*Dd*b1*f**2*s + 18810*D1*Dd*b1*f**2 - 71280*D1*Dd*b1*f*fd*r**2 - 79200*D1*Dd*b1*f*fd*r*s + 65340*D1*Dd*b1*f*fd*r - 7920*D1*Dd*b1*f*fd*s**2 + 25740*D1*Dd*b1*f*fd*s - 10890*D1*Dd*b1*f*fd - 8400*D1*Dd*f**4*r**2 - 8400*D1*Dd*f**4*r*s + 10500*D1*Dd*f**4*r + 4200*D1*Dd*f**4*s - 4200*D1*Dd*f**4 + 67200*D1*Dd*f**3*fd*r**2 + 67200*D1*Dd*f**3*fd*r*s - 84000*D1*Dd*f**3*fd*r - 33600*D1*Dd*f**3*fd*s + 25200*D1*Dd*f**3*fd + 39896*D1*Dd*f**3*r**2 + 18896*D1*Dd*f**3*r*s - 44620*D1*Dd*f**3*r - 21000*D1*Dd*f**3*s**2 + 1052*D1*Dd*f**3*s + 14698*D1*Dd*f**3 - 132360*D1*Dd*f**2*fd*r**2 - 69360*D1*Dd*f**2*fd*r*s + 130530*D1*Dd*f**2*fd*r + 63000*D1*Dd*f**2*fd*s**2 - 7850*D1*Dd*f**2*fd*s - 25480*D1*Dd*f**2*fd + 31680*D1*Dd*f**2*g2*r**2 - 31680*D1*Dd*f**2*g2*r*s - 23760*D1*Dd*f**2*g2*r - 63360*D1*Dd*f**2*g2*s**2 + 47520*D1*Dd*f**2*g2*s - 31680*D1*Dd*f**2*gd2*r**2 + 31680*D1*Dd*f**2*gd2*r*s + 43560*D1*Dd*f**2*gd2*r + 63360*D1*Dd*f**2*gd2*s**2 - 39600*D1*Dd*f**2*gd2*s - 11880*D1*Dd*f**2*gd2 - 63360*D1*Dd*f*fd*g2*r**2 + 63360*D1*Dd*f*fd*g2*r*s + 7920*D1*Dd*f*fd*g2*r + 126720*D1*Dd*f*fd*g2*s**2 - 110880*D1*Dd*f*fd*g2*s + 23760*D1*Dd*f*fd*g2 + 7920*D1*Ddd*K*b1*f**2*r**2 - 7920*D1*Ddd*K*b1*f**2*r*s - 5940*D1*Ddd*K*b1*f**2*r - 15840*D1*Ddd*K*b1*f**2*s**2 + 11880*D1*Ddd*K*b1*f**2*s - 10500*D1*Ddd*b1*f**3*r**2 - 12600*D1*Ddd*b1*f**3*r*s + 13650*D1*Ddd*b1*f**3*r - 2100*D1*Ddd*b1*f**3*s**2 + 7350*D1*Ddd*b1*f**3*s - 5775*D1*Ddd*b1*f**3 - 17820*D1*Ddd*b1*f**2*r**2 - 19800*D1*Ddd*b1*f**2*r*s + 22770*D1*Ddd*b1*f**2*r - 1980*D1*Ddd*b1*f**2*s**2 + 10890*D1*Ddd*b1*f**2*s - 9405*D1*Ddd*b1*f**2 + 8400*D1*Ddd*f**4*r**2 + 8400*D1*Ddd*f**4*r*s - 10500*D1*Ddd*f**4*r - 4200*D1*Ddd*f**4*s + 4200*D1*Ddd*f**4 - 22060*D1*Ddd*f**3*r**2 - 11560*D1*Ddd*f**3*r*s + 24950*D1*Ddd*f**3*r + 10500*D1*Ddd*f**3*s**2 + 530*D1*Ddd*f**3*s - 8405*D1*Ddd*f**3 - 15840*D1*Ddd*f**2*g2*r**2 + 15840*D1*Ddd*f**2*g2*r*s + 11880*D1*Ddd*f**2*g2*r + 31680*D1*Ddd*f**2*g2*s**2 - 23760*D1*Ddd*f**2*g2*s + 30*D1*bd1*f*(35*D1*f**2*(5*r**2 + 2*r*(3*s - 5) + s**2 - 6*s + 5) + D1*f*(-35*fd*(15*r**2 + r*(18*s - 23) + 3*s**2 - 13*s + 8) + (r + s - 1)*(-132*K*(r - 2*s - 1) + 297*r + 33*s - 297)) + 33*D1*fd*(2*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 18*r**2 - 20*r*s + 23*r - 2*s**2 + 11*s - 5) - 35*Dd*f**2*(20*r**2 + 3*r*(8*s - 11) + 4*s**2 - 19*s + 13) + 33*Dd*f*(2*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 36*r**2 - 40*r*s + 59*r - 4*s**2 + 31*s - 23)) + 23760*Dd**2*K*b1*f**2*r**2 - 23760*Dd**2*K*b1*f**2*r*s - 17820*Dd**2*K*b1*f**2*r - 47520*Dd**2*K*b1*f**2*s**2 + 35640*Dd**2*K*b1*f**2*s - 31500*Dd**2*b1*f**3*r**2 - 37800*Dd**2*b1*f**3*r*s + 40950*Dd**2*b1*f**3*r - 6300*Dd**2*b1*f**3*s**2 + 22050*Dd**2*b1*f**3*s - 11550*Dd**2*b1*f**3 - 53460*Dd**2*b1*f**2*r**2 - 59400*Dd**2*b1*f**2*r*s + 68310*Dd**2*b1*f**2*r - 5940*Dd**2*b1*f**2*s**2 + 32670*Dd**2*b1*f**2*s - 18810*Dd**2*b1*f**2 + 25200*Dd**2*f**4*r**2 + 25200*Dd**2*f**4*r*s - 31500*Dd**2*f**4*r - 12600*Dd**2*f**4*s + 8400*Dd**2*f**4 - 66180*Dd**2*f**3*r**2 - 34680*Dd**2*f**3*r*s + 74850*Dd**2*f**3*r + 31500*Dd**2*f**3*s**2 + 1590*Dd**2*f**3*s - 16810*Dd**2*f**3 - 47520*Dd**2*f**2*g2*r**2 + 47520*Dd**2*f**2*g2*r*s + 35640*Dd**2*f**2*g2*r + 95040*Dd**2*f**2*g2*s**2 - 71280*Dd**2*f**2*g2*s)/(1386*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**5*k1*k2**3*(-1716*C*D1**2*bdd1*f**2*r**2 - 5016*C*D1**2*bdd1*f**2*r*s - 1584*C*D1**2*bdd1*f**2*r - 3300*C*D1**2*bdd1*f**2*s**2 - 49080*C*D1**2*f**2*fd*r**2 - 97320*C*D1**2*f**2*fd*r*s + 65160*C*D1**2*f**2*fd*r - 48240*C*D1**2*f**2*fd*s**2 + 64600*C*D1**2*f**2*fd*s - 32440*C*D1**2*f**2*fd + 40380*C*D1**2*f**2*fdd*r**2 + 78360*C*D1**2*f**2*fdd*r*s - 53040*C*D1**2*f**2*fdd*r + 37980*C*D1**2*f**2*fdd*s**2 - 51440*C*D1**2*f**2*fdd*s + 26120*C*D1**2*f**2*fdd + 80760*C*D1**2*f*fd**2*r**2 + 156720*C*D1**2*f*fd**2*r*s - 106080*C*D1**2*f*fd**2*r + 75960*C*D1**2*f*fd**2*s**2 - 102880*C*D1**2*f*fd**2*s + 26120*C*D1**2*f*fd**2 - 65440*C*D1*Dd*f**3*r**2 - 129760*C*D1*Dd*f**3*r*s + 97880*C*D1*Dd*f**3*r - 64320*C*D1*Dd*f**3*s**2 + 97040*C*D1*Dd*f**3*s - 48800*C*D1*Dd*f**3 + 323040*C*D1*Dd*f**2*fd*r**2 + 626880*C*D1*Dd*f**2*fd*r*s - 452040*C*D1*Dd*f**2*fd*r + 303840*C*D1*Dd*f**2*fd*s**2 - 438440*C*D1*Dd*f**2*fd*s + 157520*C*D1*Dd*f**2*fd + 53840*C*D1*Ddd*f**3*r**2 + 104480*C*D1*Ddd*f**3*r*s - 79960*C*D1*Ddd*f**3*r + 50640*C*D1*Ddd*f**3*s**2 - 77560*C*D1*Ddd*f**3*s + 39580*C*D1*Ddd*f**3 + 161520*C*Dd**2*f**3*r**2 + 313440*C*Dd**2*f**3*r*s - 239880*C*Dd**2*f**3*r + 151920*C*Dd**2*f**3*s**2 - 232680*C*Dd**2*f**3*s + 79160*C*Dd**2*f**3 + 7260*D1**2*K*bdd1*f**2*r**2 + 14784*D1**2*K*bdd1*f**2*r*s - 14520*D1**2*K*bdd1*f**2*r + 7524*D1**2*K*bdd1*f**2*s**2 - 14784*D1**2*K*bdd1*f**2*s + 7260*D1**2*K*bdd1*f**2 - 9240*D1**2*b2*f*fd*r**2 - 18480*D1**2*b2*f*fd*r*s + 9240*D1**2*b2*f*fd*r - 9240*D1**2*b2*f*fd*s**2 + 9240*D1**2*b2*f*fd*s - 4620*D1**2*b2*f*fd + 6600*D1**2*b2*f*fdd*r**2 + 13200*D1**2*b2*f*fdd*r*s - 6600*D1**2*b2*f*fdd*r + 6600*D1**2*b2*f*fdd*s**2 - 6600*D1**2*b2*f*fdd*s + 3300*D1**2*b2*f*fdd + 6600*D1**2*b2*fd**2*r**2 + 13200*D1**2*b2*fd**2*r*s - 6600*D1**2*b2*fd**2*r + 6600*D1**2*b2*fd**2*s**2 - 6600*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*f*(r + s - 1)*(-12*K*(3*r + 5*s + 1) + 25*f - 24*r + 42) - 4620*D1**2*bd2*f**2*r**2 - 9240*D1**2*bd2*f**2*r*s + 9240*D1**2*bd2*f**2*r - 4620*D1**2*bd2*f**2*s**2 + 9240*D1**2*bd2*f**2*s - 4620*D1**2*bd2*f**2 + 13200*D1**2*bd2*f*fd*r**2 + 26400*D1**2*bd2*f*fd*r*s - 19800*D1**2*bd2*f*fd*r + 13200*D1**2*bd2*f*fd*s**2 - 19800*D1**2*bd2*f*fd*s + 6600*D1**2*bd2*f*fd - 1815*D1**2*bdd1*f**3*r**2 - 3630*D1**2*bdd1*f**3*r*s + 4290*D1**2*bdd1*f**3*r - 1815*D1**2*bdd1*f**3*s**2 + 4290*D1**2*bdd1*f**3*s - 2475*D1**2*bdd1*f**3 - 1914*D1**2*bdd1*f**2*r**2 - 2376*D1**2*bdd1*f**2*r*s + 7194*D1**2*bdd1*f**2*r - 462*D1**2*bdd1*f**2*s**2 + 5742*D1**2*bdd1*f**2*s - 2805*D1**2*bdd1*f**2 + 2376*D1**2*bdd1*f*g2*r**2 + 6336*D1**2*bdd1*f*g2*r*s + 1584*D1**2*bdd1*f*g2*r + 3960*D1**2*bdd1*f*g2*s**2 + 3300*D1**2*bdd2*f**2*r**2 + 6600*D1**2*bdd2*f**2*r*s - 6600*D1**2*bdd2*f**2*r + 3300*D1**2*bdd2*f**2*s**2 - 6600*D1**2*bdd2*f**2*s + 3300*D1**2*bdd2*f**2 + 27420*D1**2*f**2*fd*r**2 + 55200*D1**2*f**2*fd*r*s - 36680*D1**2*f**2*fd*r + 27780*D1**2*f**2*fd*s**2 - 36920*D1**2*f**2*fd*s + 18400*D1**2*f**2*fd - 26085*D1**2*f**2*fdd*r**2 - 50370*D1**2*f**2*fdd*r*s + 34180*D1**2*f**2*fdd*r - 24285*D1**2*f**2*fdd*s**2 + 32980*D1**2*f**2*fdd*s - 16790*D1**2*f**2*fdd + 16368*D1**2*f**2*gd2*r**2 + 35376*D1**2*f**2*gd2*r*s - 32736*D1**2*f**2*gd2*r + 19008*D1**2*f**2*gd2*s**2 - 35376*D1**2*f**2*gd2*s + 16368*D1**2*f**2*gd2 - 14520*D1**2*f**2*gdd2*r**2 - 29568*D1**2*f**2*gdd2*r*s + 29040*D1**2*f**2*gdd2*r - 15048*D1**2*f**2*gdd2*s**2 + 29568*D1**2*f**2*gdd2*s - 14520*D1**2*f**2*gdd2 - 52170*D1**2*f*fd**2*r**2 - 100740*D1**2*f*fd**2*r*s + 68360*D1**2*f*fd**2*r - 48570*D1**2*f*fd**2*s**2 + 65960*D1**2*f*fd**2*s - 16790*D1**2*f*fd**2 + 32736*D1**2*f*fd*g2*r**2 + 70752*D1**2*f*fd*g2*r*s - 35376*D1**2*f*fd*g2*r + 38016*D1**2*f*fd*g2*s**2 - 38016*D1**2*f*fd*g2*s + 19008*D1**2*f*fd*g2 - 58080*D1**2*f*fd*gd2*r**2 - 118272*D1**2*f*fd*gd2*r*s + 87648*D1**2*f*fd*gd2*r - 60192*D1**2*f*fd*gd2*s**2 + 89232*D1**2*f*fd*gd2*s - 29568*D1**2*f*fd*gd2 - 29040*D1**2*f*fdd*g2*r**2 - 59136*D1**2*f*fdd*g2*r*s + 29568*D1**2*f*fdd*g2*r - 30096*D1**2*f*fdd*g2*s**2 + 30096*D1**2*f*fdd*g2*s - 15048*D1**2*f*fdd*g2 - 29040*D1**2*fd**2*g2*r**2 - 59136*D1**2*fd**2*g2*r*s + 29568*D1**2*fd**2*g2*r - 30096*D1**2*fd**2*g2*s**2 + 30096*D1**2*fd**2*g2*s - 18480*D1*Dd*b2*f**2*r**2 - 36960*D1*Dd*b2*f**2*r*s + 27720*D1*Dd*b2*f**2*r - 18480*D1*Dd*b2*f**2*s**2 + 27720*D1*Dd*b2*f**2*s - 13860*D1*Dd*b2*f**2 + 52800*D1*Dd*b2*f*fd*r**2 + 105600*D1*Dd*b2*f*fd*r*s - 66000*D1*Dd*b2*f*fd*r + 52800*D1*Dd*b2*f*fd*s**2 - 66000*D1*Dd*b2*f*fd*s + 19800*D1*Dd*b2*f*fd + 26400*D1*Dd*bd2*f**2*r**2 + 52800*D1*Dd*bd2*f**2*r*s - 46200*D1*Dd*bd2*f**2*r + 26400*D1*Dd*bd2*f**2*s**2 - 46200*D1*Dd*bd2*f**2*s + 19800*D1*Dd*bd2*f**2 + 36560*D1*Dd*f**3*r**2 + 73600*D1*Dd*f**3*r*s - 54960*D1*Dd*f**3*r + 37040*D1*Dd*f**3*s**2 - 55320*D1*Dd*f**3*s + 27540*D1*Dd*f**3 - 208680*D1*Dd*f**2*fd*r**2 - 402960*D1*Dd*f**2*fd*r*s + 291430*D1*Dd*f**2*fd*r - 194280*D1*Dd*f**2*fd*s**2 + 281230*D1*Dd*f**2*fd*s - 101340*D1*Dd*f**2*fd + 65472*D1*Dd*f**2*g2*r**2 + 141504*D1*Dd*f**2*g2*r*s - 100848*D1*Dd*f**2*g2*r + 76032*D1*Dd*f**2*g2*s**2 - 108768*D1*Dd*f**2*g2*s + 51744*D1*Dd*f**2*g2 - 116160*D1*Dd*f**2*gd2*r**2 - 236544*D1*Dd*f**2*gd2*r*s + 203808*D1*Dd*f**2*gd2*r - 120384*D1*Dd*f**2*gd2*s**2 + 207504*D1*Dd*f**2*gd2*s - 87648*D1*Dd*f**2*gd2 - 232320*D1*Dd*f*fd*g2*r**2 - 473088*D1*Dd*f*fd*g2*r*s + 293568*D1*Dd*f*fd*g2*r - 240768*D1*Dd*f*fd*g2*s**2 + 298848*D1*Dd*f*fd*g2*s - 89232*D1*Dd*f*fd*g2 + 13200*D1*Ddd*b2*f**2*r**2 + 26400*D1*Ddd*b2*f**2*r*s - 19800*D1*Ddd*b2*f**2*r + 13200*D1*Ddd*b2*f**2*s**2 - 19800*D1*Ddd*b2*f**2*s + 9900*D1*Ddd*b2*f**2 - 34780*D1*Ddd*f**3*r**2 - 67160*D1*Ddd*f**3*r*s + 51570*D1*Ddd*f**3*r - 32380*D1*Ddd*f**3*s**2 + 49770*D1*Ddd*f**3*s - 25485*D1*Ddd*f**3 - 58080*D1*Ddd*f**2*g2*r**2 - 118272*D1*Ddd*f**2*g2*r*s + 87648*D1*Ddd*f**2*g2*r - 60192*D1*Ddd*f**2*g2*s**2 + 89232*D1*Ddd*f**2*g2*s - 44088*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(10*f**3*(r**2 + 3*r*(s - 1) + 2*(s - 1)**2) - f**2*(-52*C*r**2 - 152*C*r*s - 48*C*r - 100*C*s**2 + 4*K*(31*r**2 + 67*r*s - 62*r + 36*s**2 - 67*s + 31) + 5*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) - 4*r**2 + 24*r*s + 110*r + 28*s**2 + 78*s - 31) - f*(fd*(8*C*(13*r**2 + r*(38*s - 13) + 25*s**2 - 22*s - 3) - 4*K*(110*r**2 + 224*r*s - 166*r + 114*s**2 - 169*s + 56) + 116*r**2 + 144*r*s - 203*r + 28*s**2 - 137*s + 111) + 24*g2*(3*r**2 + r*(8*s + 2) + 5*s**2) + 24*gd2*(-3*r**2 + r*(2 - 8*s) - 5*s**2 + 4*s + 1)) + 24*fd*g2*(3*r**2 + r*(8*s - 4) + s*(5*s - 5))) - Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + f*(4*C*(52*r**2 + r*(152*s - 21) + 100*s**2 - 63*s - 12) - 4*K*(220*r**2 + 448*r*s - 386*r + 228*s**2 - 393*s + 166) + 232*r**2 + 288*r*s - 588*r + 56*s**2 - 434*s + 305) - 24*g2*(12*r**2 + r*(32*s - 6) + 20*s**2 - 13*s - 2))) + 39600*Dd**2*b2*f**2*r**2 + 79200*Dd**2*b2*f**2*r*s - 59400*Dd**2*b2*f**2*r + 39600*Dd**2*b2*f**2*s**2 - 59400*Dd**2*b2*f**2*s + 19800*Dd**2*b2*f**2 - 104340*Dd**2*f**3*r**2 - 201480*Dd**2*f**3*r*s + 154710*Dd**2*f**3*r - 97140*Dd**2*f**3*s**2 + 149310*Dd**2*f**3*s - 50970*Dd**2*f**3 - 174240*Dd**2*f**2*g2*r**2 - 354816*Dd**2*f**2*g2*r*s + 262944*Dd**2*f**2*g2*r - 180576*Dd**2*f**2*g2*s**2 + 267696*Dd**2*f**2*g2*s - 88176*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(50*f*fd*(2*r + 2*s - 1) - 25*f*fdd*(2*r + 2*s - 1) - 50*fd**2*(r + s - 1) + 12*fd*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 2*r*(2*s + 5) + 10*s - 5) - 6*fdd*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 2*r*(2*s + 5) + 10*s - 5)) - 2*D1*(Dd*(f*(-12*K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 25*fd*(4*r + 4*s - 3) - 96*r**2 - 96*r*s + 120*r + 48*s - 48) + 6*fd*(K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 16*r**2 + 2*r*(8*s + 5) + 16*s - 15)) + 6*Ddd*f*(K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 8*r**2 + 2*r*(4*s - 5) - 4*s + 4)) - 24*Dd**2*f*(K*(18*r**2 + 6*r*(8*s - 5) + 30*s**2 - 39*s + 11) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) - 33*b1*(-208*C*D1**2*f*fd*r**2 - 608*C*D1**2*f*fd*r*s + 608*C*D1**2*f*fd*r - 400*C*D1**2*f*fd*s**2 + 704*C*D1**2*f*fd*s - 304*C*D1**2*f*fd + 104*C*D1**2*f*fdd*r**2 + 304*C*D1**2*f*fdd*r*s - 304*C*D1**2*f*fdd*r + 200*C*D1**2*f*fdd*s**2 - 352*C*D1**2*f*fdd*s + 152*C*D1**2*f*fdd + 104*C*D1**2*fd**2*r**2 + 304*C*D1**2*fd**2*r*s - 304*C*D1**2*fd**2*r + 200*C*D1**2*fd**2*s**2 - 352*C*D1**2*fd**2*s + 200*C*D1**2*fd**2 - 416*C*D1*Dd*f**2*r**2 - 1216*C*D1*Dd*f**2*r*s + 720*C*D1*Dd*f**2*r - 800*C*D1*Dd*f**2*s**2 + 1008*C*D1*Dd*f**2*s - 408*C*D1*Dd*f**2 + 832*C*D1*Dd*f*fd*r**2 + 2432*C*D1*Dd*f*fd*r*s - 1936*C*D1*Dd*f*fd*r + 1600*C*D1*Dd*f*fd*s**2 - 2416*C*D1*Dd*f*fd*s + 960*C*D1*Dd*f*fd + 208*C*D1*Ddd*f**2*r**2 + 608*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 400*C*D1*Ddd*f**2*s**2 - 504*C*D1*Ddd*f**2*s + 204*C*D1*Ddd*f**2 + 624*C*Dd**2*f**2*r**2 + 1824*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 1200*C*Dd**2*f**2*s**2 - 1512*C*Dd**2*f**2*s + 408*C*Dd**2*f**2 + 496*D1**2*K*f*fd*r**2 + 1072*D1**2*K*f*fd*r*s - 536*D1**2*K*f*fd*r + 576*D1**2*K*f*fd*s**2 - 576*D1**2*K*f*fd*s + 288*D1**2*K*f*fd - 440*D1**2*K*f*fdd*r**2 - 896*D1**2*K*f*fdd*r*s + 448*D1**2*K*f*fdd*r - 456*D1**2*K*f*fdd*s**2 + 456*D1**2*K*f*fdd*s - 228*D1**2*K*f*fdd - 440*D1**2*K*fd**2*r**2 - 896*D1**2*K*fd**2*r*s + 448*D1**2*K*fd**2*r - 456*D1**2*K*fd**2*s**2 + 456*D1**2*K*fd**2*s + D1**2*bdd1*f*(12*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) - 25*f*(2*r + 2*s - 1) + 48*r**2 + 48*r*s - 132*r - 84*s + 54) - 60*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 80*D1**2*f**2*fd*r - 120*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 40*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 16*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s - 252*D1**2*f*fd*r + 112*D1**2*f*fd*s**2 - 316*D1**2*f*fd*s + 110*D1**2*f*fd + 116*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r + 28*D1**2*f*fdd*s**2 + 74*D1**2*f*fdd*s - 13*D1**2*f*fdd + 144*D1**2*f*gd2*r**2 + 384*D1**2*f*gd2*r*s - 288*D1**2*f*gd2*r + 240*D1**2*f*gd2*s**2 - 384*D1**2*f*gd2*s + 144*D1**2*f*gd2 - 72*D1**2*f*gdd2*r**2 - 192*D1**2*f*gdd2*r*s + 144*D1**2*f*gdd2*r - 120*D1**2*f*gdd2*s**2 + 192*D1**2*f*gdd2*s - 72*D1**2*f*gdd2 + 116*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s + 30*D1**2*fd**2*r + 28*D1**2*fd**2*s**2 + 74*D1**2*fd**2*s - 150*D1**2*fd**2 + 144*D1**2*fd*g2*r**2 + 384*D1**2*fd*g2*r*s - 480*D1**2*fd*g2*r + 240*D1**2*fd*g2*s**2 - 480*D1**2*fd*g2*s + 240*D1**2*fd*g2 - 144*D1**2*fd*gd2*r**2 - 384*D1**2*fd*gd2*r*s + 384*D1**2*fd*gd2*r - 240*D1**2*fd*gd2*s**2 + 432*D1**2*fd*gd2*s - 240*D1**2*fd*gd2 - 72*D1**2*fdd*g2*r**2 - 192*D1**2*fdd*g2*r*s + 240*D1**2*fdd*g2*r - 120*D1**2*fdd*g2*s**2 + 240*D1**2*fdd*g2*s - 120*D1**2*fdd*g2 + 992*D1*Dd*K*f**2*r**2 + 2144*D1*Dd*K*f**2*r*s - 1528*D1*Dd*K*f**2*r + 1152*D1*Dd*K*f**2*s**2 - 1648*D1*Dd*K*f**2*s + 784*D1*Dd*K*f**2 - 3520*D1*Dd*K*f*fd*r**2 - 7168*D1*Dd*K*f*fd*r*s + 4448*D1*Dd*K*f*fd*r - 3648*D1*Dd*K*f*fd*s**2 + 4528*D1*Dd*K*f*fd*s - 1352*D1*Dd*K*f*fd - 80*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 140*D1*Dd*f**3*r - 160*D1*Dd*f**3*s**2 + 200*D1*Dd*f**3*s - 80*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1790*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 32*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r + 224*D1*Dd*f**2*s**2 - 208*D1*Dd*f**2*s + 40*D1*Dd*f**2 + 928*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 488*D1*Dd*f*fd*r + 224*D1*Dd*f*fd*s**2 - 48*D1*Dd*f*fd*s - 134*D1*Dd*f*fd + 576*D1*Dd*f*g2*r**2 + 1536*D1*Dd*f*g2*r*s - 960*D1*Dd*f*g2*r + 960*D1*Dd*f*g2*s**2 - 1248*D1*Dd*f*g2*s + 528*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r**2 - 1536*D1*Dd*f*gd2*r*s + 1056*D1*Dd*f*gd2*r - 960*D1*Dd*f*gd2*s**2 + 1392*D1*Dd*f*gd2*s - 480*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r**2 - 1536*D1*Dd*fd*g2*r*s + 1440*D1*Dd*fd*g2*r - 960*D1*Dd*fd*g2*s**2 + 1584*D1*Dd*fd*g2*s - 720*D1*Dd*fd*g2 - 880*D1*Ddd*K*f**2*r**2 - 1792*D1*Ddd*K*f**2*r*s + 1328*D1*Ddd*K*f**2*r - 912*D1*Ddd*K*f**2*s**2 + 1352*D1*Ddd*K*f**2*s - 668*D1*Ddd*K*f**2 + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 232*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 304*D1*Ddd*f**2*r + 56*D1*Ddd*f**2*s**2 - 172*D1*Ddd*f**2*s + 130*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r**2 - 768*D1*Ddd*f*g2*r*s + 480*D1*Ddd*f*g2*r - 480*D1*Ddd*f*g2*s**2 + 624*D1*Ddd*f*g2*s - 264*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(25*f**2*(2*r + 2*s - 1) - 6*f*(2*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) + 8*r**2 + 8*r*s - 22*r - 14*s + 9) + 6*fd*(2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) + 8*r**2 + 8*r*s - r + 3*s - 5)) + Dd*f*(24*K*(12*r**2 + 2*r*(16*s - 7) + 20*s**2 - 21*s + 4) - 25*f*(4*r + 4*s - 3) + 192*r**2 + 192*r*(s - 2) - 216*s + 174)) - 2640*Dd**2*K*f**2*r**2 - 5376*Dd**2*K*f**2*r*s + 3984*Dd**2*K*f**2*r - 2736*Dd**2*K*f**2*s**2 + 4056*Dd**2*K*f**2*s - 1336*Dd**2*K*f**2 + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 330*Dd**2*f**3 + 696*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 912*Dd**2*f**2*r + 168*Dd**2*f**2*s**2 - 516*Dd**2*f**2*s + 260*Dd**2*f**2 - 864*Dd**2*f*g2*r**2 - 2304*Dd**2*f*g2*r*s + 1440*Dd**2*f*g2*r - 1440*Dd**2*f*g2*s**2 + 1872*Dd**2*f*g2*s - 528*Dd**2*f*g2))/(693*d**2*k3**5) + 20*D1**2*Pk2*Pkd3*ct**5*k1*k2*st**2*(b1*(D1**2*(35*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(-35*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 66*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 33*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 33*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(70*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-35*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 66*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(35*f + 33)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(35*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(35*bdd1*f**2*s*(r + s - 1) + f*(33*bdd1*s*(r + s - 1) - 50*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-35*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 2*f*s*(35*f + 33)*(r + s - 1) - 33*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(35*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 25*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 25*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**5*k1*k2*(1584*C*D1**2*bdd1*f**2*r**2 - 1056*C*D1**2*bdd1*f**2*r*s - 2640*C*D1**2*bdd1*f**2*s**2 - 16200*C*D1**2*f**2*fd*r*s + 5400*C*D1**2*f**2*fd*r - 16200*C*D1**2*f**2*fd*s**2 + 16200*C*D1**2*f**2*fd*s - 5400*C*D1**2*f**2*fd + 10080*C*D1**2*f**2*fdd*r*s - 3360*C*D1**2*f**2*fdd*r + 10080*C*D1**2*f**2*fdd*s**2 - 10080*C*D1**2*f**2*fdd*s + 3360*C*D1**2*f**2*fdd + 20160*C*D1**2*f*fd**2*r*s - 6720*C*D1**2*f*fd**2*r + 20160*C*D1**2*f*fd**2*s**2 - 20160*C*D1**2*f*fd**2*s + 3360*C*D1**2*f*fd**2 - 21600*C*D1*Dd*f**3*r*s + 5400*C*D1*Dd*f**3*r - 21600*C*D1*Dd*f**3*s**2 + 21600*C*D1*Dd*f**3*s - 5400*C*D1*Dd*f**3 + 80640*C*D1*Dd*f**2*fd*r*s - 23520*C*D1*Dd*f**2*fd*r + 80640*C*D1*Dd*f**2*fd*s**2 - 80640*C*D1*Dd*f**2*fd*s + 16800*C*D1*Dd*f**2*fd + 13440*C*D1*Ddd*f**3*r*s - 3360*C*D1*Ddd*f**3*r + 13440*C*D1*Ddd*f**3*s**2 - 13440*C*D1*Ddd*f**3*s + 3360*C*D1*Ddd*f**3 + 40320*C*Dd**2*f**3*r*s - 10080*C*Dd**2*f**3*r + 40320*C*Dd**2*f**3*s**2 - 40320*C*Dd**2*f**3*s + 6720*C*Dd**2*f**3 + 1980*D1**2*K*bdd1*f**2*r*s + 1980*D1**2*K*bdd1*f**2*s**2 - 1980*D1**2*K*bdd1*f**2*s - 6336*D1**2*b2*f*fd*r*s + 3168*D1**2*b2*f*fd*r - 6336*D1**2*b2*f*fd*s**2 + 6336*D1**2*b2*f*fd*s - 3168*D1**2*b2*f*fd + 3960*D1**2*b2*f*fdd*r*s - 1980*D1**2*b2*f*fdd*r + 3960*D1**2*b2*f*fdd*s**2 - 3960*D1**2*b2*f*fdd*s + 1980*D1**2*b2*f*fdd + 3960*D1**2*b2*fd**2*r*s - 1980*D1**2*b2*fd**2*r + 3960*D1**2*b2*fd**2*s**2 - 3960*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*f*(5*f*(r**2 + r*(2*s - 3) + s**2 - 5*s + 2) + 6*r**2*(5 - 4*K) + 6*r*(4*K*(s + 1) + 6*s - 7) + 6*s**2*(8*K + 1) - 6*s*(2*K + 7) + 12) - 3168*D1**2*bd2*f**2*r*s - 3168*D1**2*bd2*f**2*s**2 + 3168*D1**2*bd2*f**2*s + 7920*D1**2*bd2*f*fd*r*s - 1980*D1**2*bd2*f*fd*r + 7920*D1**2*bd2*f*fd*s**2 - 7920*D1**2*bd2*f*fd*s + 1980*D1**2*bd2*f*fd + 2475*D1**2*bdd1*f**3*r**2 + 4290*D1**2*bdd1*f**3*r*s - 3630*D1**2*bdd1*f**3*r + 1815*D1**2*bdd1*f**3*s**2 - 3630*D1**2*bdd1*f**3*s + 1815*D1**2*bdd1*f**3 + 231*D1**2*bdd1*f**2*r**2 + 3498*D1**2*bdd1*f**2*r*s - 3300*D1**2*bdd1*f**2*r + 3267*D1**2*bdd1*f**2*s**2 - 2772*D1**2*bdd1*f**2*s + 1320*D1**2*bdd1*f**2 - 1584*D1**2*bdd1*f*g2*r**2 + 1584*D1**2*bdd1*f*g2*r*s + 3168*D1**2*bdd1*f*g2*s**2 + 1980*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*s**2 - 1980*D1**2*bdd2*f**2*s - 7335*D1**2*f**2*fd*r**2 - 7350*D1**2*f**2*fd*r*s + 7340*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 2460*D1**2*f**2*fd*s - 2450*D1**2*f**2*fd + 5895*D1**2*f**2*fdd*r**2 + 6150*D1**2*f**2*fdd*r*s - 5980*D1**2*f**2*fdd*r + 255*D1**2*f**2*fdd*s**2 - 2220*D1**2*f**2*fdd*s + 2050*D1**2*f**2*fdd + 6336*D1**2*f**2*gd2*r*s + 6336*D1**2*f**2*gd2*s**2 - 6336*D1**2*f**2*gd2*s - 3960*D1**2*f**2*gdd2*r*s - 3960*D1**2*f**2*gdd2*s**2 + 3960*D1**2*f**2*gdd2*s + 11790*D1**2*f*fd**2*r**2 + 12300*D1**2*f*fd**2*r*s - 11960*D1**2*f*fd**2*r + 510*D1**2*f*fd**2*s**2 - 4440*D1**2*f*fd**2*s + 2050*D1**2*f*fd**2 + 12672*D1**2*f*fd*g2*r*s - 6336*D1**2*f*fd*g2*r + 12672*D1**2*f*fd*g2*s**2 - 12672*D1**2*f*fd*g2*s + 6336*D1**2*f*fd*g2 - 15840*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r - 15840*D1**2*f*fd*gd2*s**2 + 15840*D1**2*f*fd*gd2*s - 3960*D1**2*f*fd*gd2 - 7920*D1**2*f*fdd*g2*r*s + 3960*D1**2*f*fdd*g2*r - 7920*D1**2*f*fdd*g2*s**2 + 7920*D1**2*f*fdd*g2*s - 3960*D1**2*f*fdd*g2 - 7920*D1**2*fd**2*g2*r*s + 3960*D1**2*fd**2*g2*r - 7920*D1**2*fd**2*g2*s**2 + 7920*D1**2*fd**2*g2*s - 12672*D1*Dd*b2*f**2*r*s + 3168*D1*Dd*b2*f**2*r - 12672*D1*Dd*b2*f**2*s**2 + 12672*D1*Dd*b2*f**2*s - 3168*D1*Dd*b2*f**2 + 31680*D1*Dd*b2*f*fd*r*s - 11880*D1*Dd*b2*f*fd*r + 31680*D1*Dd*b2*f*fd*s**2 - 31680*D1*Dd*b2*f*fd*s + 7920*D1*Dd*b2*f*fd + 15840*D1*Dd*bd2*f**2*r*s - 1980*D1*Dd*bd2*f**2*r + 15840*D1*Dd*bd2*f**2*s**2 - 15840*D1*Dd*bd2*f**2*s + 1980*D1*Dd*bd2*f**2 - 9780*D1*Dd*f**3*r**2 - 9800*D1*Dd*f**3*r*s + 12230*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 4910*D1*Dd*f**3*s - 4895*D1*Dd*f**3 + 47160*D1*Dd*f**2*fd*r**2 + 49200*D1*Dd*f**2*fd*r*s - 53650*D1*Dd*f**2*fd*r + 2040*D1*Dd*f**2*fd*s**2 - 21690*D1*Dd*f**2*fd*s + 14180*D1*Dd*f**2*fd + 25344*D1*Dd*f**2*g2*r*s - 6336*D1*Dd*f**2*g2*r + 25344*D1*Dd*f**2*g2*s**2 - 25344*D1*Dd*f**2*g2*s + 6336*D1*Dd*f**2*g2 - 31680*D1*Dd*f**2*gd2*r*s + 3960*D1*Dd*f**2*gd2*r - 31680*D1*Dd*f**2*gd2*s**2 + 31680*D1*Dd*f**2*gd2*s - 3960*D1*Dd*f**2*gd2 - 63360*D1*Dd*f*fd*g2*r*s + 23760*D1*Dd*f*fd*g2*r - 63360*D1*Dd*f*fd*g2*s**2 + 63360*D1*Dd*f*fd*g2*s - 15840*D1*Dd*f*fd*g2 + 7920*D1*Ddd*b2*f**2*r*s - 1980*D1*Ddd*b2*f**2*r + 7920*D1*Ddd*b2*f**2*s**2 - 7920*D1*Ddd*b2*f**2*s + 1980*D1*Ddd*b2*f**2 + 7860*D1*Ddd*f**3*r**2 + 8200*D1*Ddd*f**3*r*s - 9910*D1*Ddd*f**3*r + 340*D1*Ddd*f**3*s**2 - 4270*D1*Ddd*f**3*s + 4015*D1*Ddd*f**3 - 15840*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r - 15840*D1*Ddd*f**2*g2*s**2 + 15840*D1*Ddd*f**2*g2*s - 3960*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(13*r**2 + 6*r*(5*s - 3) + 17*s**2 - 26*s + 9) - 2*f**2*(80*C*s**2 - 48*K*s**2 + 48*K*s + 5*fd*(45*r**2 + 13*r*(6*s - 5) + 33*s**2 - 59*s + 22) + r**2*(20 - 48*C) + r*(s*(32*C - 48*K - 64) + 46) - 84*s**2 + 42*s - 13) - 4*f*(fd*(-80*C*s**2 + 48*C*s + 15*K*(r*(4*s - 1) + (1 - 2*s)**2) + r**2*(48*C + 7) - r*(32*C*s + 16*C - 106*s + 55) + 99*s**2 - 97*s + 26) + 24*g2*(r**2 - r*s - 2*s**2) + 12*gd2*(-2*r**2 + 2*r*(s + 1) + s*(4*s - 1))) + 48*fd*g2*(2*r**2 - 2*r*s + r - s*(4*s - 4))) - 2*Dd*f*(5*f**2*(60*r**2 + r*(104*s - 87) + 44*s**2 - 81*s + 33) + f*(-320*C*s**2 + 112*C*s + 30*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + r**2*(192*C + 28) - r*(16*C*(8*s + 5) - 424*s + 267) + 396*s**2 - 373*s + 142) - 24*g2*(8*r**2 - r*(8*s + 3) + s*(6 - 16*s)))) + 23760*Dd**2*b2*f**2*r*s - 5940*Dd**2*b2*f**2*r + 23760*Dd**2*b2*f**2*s**2 - 23760*Dd**2*b2*f**2*s + 3960*Dd**2*b2*f**2 + 23580*Dd**2*f**3*r**2 + 24600*Dd**2*f**3*r*s - 29730*Dd**2*f**3*r + 1020*Dd**2*f**3*s**2 - 12810*Dd**2*f**3*s + 8030*Dd**2*f**3 - 47520*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r - 47520*Dd**2*f**2*g2*s**2 + 47520*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 + 33*b1**2*(-2*D1**2*(5*fd**2*(r**2 + 2*r*s + s**2 + 2*s - 1) - 2*fd*(-12*K*(r**2 - r*s + r - 2*(s - 1)**2) + 5*f*(r**2 + 2*r*s + s**2 + 2*s - 1) + 15*r**2 + 18*r*s - 6*r + 3*s**2 + 18*s - 9) + fdd*(-12*K*(r**2 - r*s + r - 2*(s - 1)**2) + 5*f*(r**2 + 2*r*s + s**2 + 2*s - 1) + 15*r**2 + 18*r*s - 6*r + 3*s**2 + 18*s - 9)) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(-96*K*s**2 + 72*K*s + 5*fd*(4*r**2 + r*(8*s - 3) + 4*s**2 + s - 1) + r**2*(48*K - 60) - 6*r*(8*K*s + 6*K + 12*s - 13) - 12*s**2 + 42*s - 33) + 6*fd*(2*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) - 20*r**2 + r*(17 - 24*s) - 4*s**2 - 5*s + 1)) - Ddd*f*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*r**2*(16*K - 20) + 12*r*(K*(8*s + 6) + 12*s - 13) + 6*s**2*(32*K + 4) - 6*s*(24*K + 14) + 66)) - 6*Dd**2*f*(96*K*s**2 - 72*K*s + 5*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + r**2*(60 - 48*K) + 6*r*(8*K*s + 6*K + 12*s - 13) + 12*s**2 - 42*s + 22)) + 33*b1*(-192*C*D1**2*f*fd*r**2 + 128*C*D1**2*f*fd*r*s + 128*C*D1**2*f*fd*r + 320*C*D1**2*f*fd*s**2 - 384*C*D1**2*f*fd*s + 64*C*D1**2*f*fd + 96*C*D1**2*f*fdd*r**2 - 64*C*D1**2*f*fdd*r*s - 64*C*D1**2*f*fdd*r - 160*C*D1**2*f*fdd*s**2 + 192*C*D1**2*f*fdd*s - 32*C*D1**2*f*fdd + 96*C*D1**2*fd**2*r**2 - 64*C*D1**2*fd**2*r*s - 64*C*D1**2*fd**2*r - 160*C*D1**2*fd**2*s**2 + 192*C*D1**2*fd**2*s - 32*C*D1**2*fd**2 - 384*C*D1*Dd*f**2*r**2 + 256*C*D1*Dd*f**2*r*s + 320*C*D1*Dd*f**2*r + 640*C*D1*Dd*f**2*s**2 - 448*C*D1*Dd*f**2*s - 32*C*D1*Dd*f**2 + 768*C*D1*Dd*f*fd*r**2 - 512*C*D1*Dd*f*fd*r*s - 576*C*D1*Dd*f*fd*r - 1280*C*D1*Dd*f*fd*s**2 + 1216*C*D1*Dd*f*fd*s - 64*C*D1*Dd*f*fd + 192*C*D1*Ddd*f**2*r**2 - 128*C*D1*Ddd*f**2*r*s - 160*C*D1*Ddd*f**2*r - 320*C*D1*Ddd*f**2*s**2 + 224*C*D1*Ddd*f**2*s + 16*C*D1*Ddd*f**2 + 576*C*Dd**2*f**2*r**2 - 384*C*Dd**2*f**2*r*s - 480*C*Dd**2*f**2*r - 960*C*Dd**2*f**2*s**2 + 672*C*Dd**2*f**2*s + 32*C*Dd**2*f**2 - 192*D1**2*K*f*fd*r*s + 96*D1**2*K*f*fd*r - 192*D1**2*K*f*fd*s**2 + 192*D1**2*K*f*fd*s - 96*D1**2*K*f*fd + 120*D1**2*K*f*fdd*r*s - 60*D1**2*K*f*fdd*r + 120*D1**2*K*f*fdd*s**2 - 120*D1**2*K*f*fdd*s + 60*D1**2*K*f*fdd + 120*D1**2*K*fd**2*r*s - 60*D1**2*K*fd**2*r + 120*D1**2*K*fd**2*s**2 - 120*D1**2*K*fd**2*s - D1**2*bdd1*f*(-24*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) + 5*f*(2*r**2 + r*(4*s - 6) + 2*s**2 - 10*s + 5) + 60*r**2 + 12*r*(6*s - 7) + 12*s**2 - 84*s + 54) - 195*D1**2*f**2*fd*r**2 - 450*D1**2*f**2*fd*r*s + 320*D1**2*f**2*fd*r - 255*D1**2*f**2*fd*s**2 + 340*D1**2*f**2*fd*s - 170*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 390*D1**2*f**2*fdd*r*s - 320*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 260*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 780*D1**2*f*fd**2*r*s - 640*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 520*D1**2*f*fd**2*s + 190*D1**2*f*fd**2 + 80*D1**2*f*fd*r**2 - 256*D1**2*f*fd*r*s - 44*D1**2*f*fd*r - 336*D1**2*f*fd*s**2 + 380*D1**2*f*fd*s - 102*D1**2*f*fd + 14*D1**2*f*fdd*r**2 + 212*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 198*D1**2*f*fdd*s**2 - 220*D1**2*f*fdd*s + 66*D1**2*f*fdd + 96*D1**2*f*gd2*r**2 - 96*D1**2*f*gd2*r*s - 192*D1**2*f*gd2*r - 192*D1**2*f*gd2*s**2 + 96*D1**2*f*gd2*s + 96*D1**2*f*gd2 - 48*D1**2*f*gdd2*r**2 + 48*D1**2*f*gdd2*r*s + 96*D1**2*f*gdd2*r + 96*D1**2*f*gdd2*s**2 - 48*D1**2*f*gdd2*s - 48*D1**2*f*gdd2 + 14*D1**2*fd**2*r**2 + 212*D1**2*fd**2*r*s - 20*D1**2*fd**2*r + 198*D1**2*fd**2*s**2 - 220*D1**2*fd**2*s + 2*D1**2*fd**2 + 96*D1**2*fd*g2*r**2 - 96*D1**2*fd*g2*r*s + 96*D1**2*fd*g2*r - 192*D1**2*fd*g2*s**2 + 384*D1**2*fd*g2*s - 192*D1**2*fd*g2 - 96*D1**2*fd*gd2*r**2 + 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r + 192*D1**2*fd*gd2*s**2 - 240*D1**2*fd*gd2*s + 48*D1**2*fd*gd2 - 48*D1**2*fdd*g2*r**2 + 48*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*r + 96*D1**2*fdd*g2*s**2 - 192*D1**2*fdd*g2*s + 96*D1**2*fdd*g2 - 384*D1*Dd*K*f**2*r*s + 96*D1*Dd*K*f**2*r - 384*D1*Dd*K*f**2*s**2 + 384*D1*Dd*K*f**2*s - 96*D1*Dd*K*f**2 + 960*D1*Dd*K*f*fd*r*s - 360*D1*Dd*K*f*fd*r + 960*D1*Dd*K*f*fd*s**2 - 960*D1*Dd*K*f*fd*s + 240*D1*Dd*K*f*fd - 260*D1*Dd*f**3*r**2 - 600*D1*Dd*f**3*r*s + 410*D1*Dd*f**3*r - 340*D1*Dd*f**3*s**2 + 470*D1*Dd*f**3*s - 215*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 3120*D1*Dd*f**2*fd*r*s - 2570*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 2150*D1*Dd*f**2*fd*s + 900*D1*Dd*f**2*fd + 160*D1*Dd*f**2*r**2 - 512*D1*Dd*f**2*r*s - 32*D1*Dd*f**2*r - 672*D1*Dd*f**2*s**2 + 592*D1*Dd*f**2*s - 88*D1*Dd*f**2 + 112*D1*Dd*f*fd*r**2 + 1696*D1*Dd*f*fd*r*s - 348*D1*Dd*f*fd*r + 1584*D1*Dd*f*fd*s**2 - 1700*D1*Dd*f*fd*s + 260*D1*Dd*f*fd + 384*D1*Dd*f*g2*r**2 - 384*D1*Dd*f*g2*r*s - 288*D1*Dd*f*g2*r - 768*D1*Dd*f*g2*s**2 + 576*D1*Dd*f*g2*s - 384*D1*Dd*f*gd2*r**2 + 384*D1*Dd*f*gd2*r*s + 528*D1*Dd*f*gd2*r + 768*D1*Dd*f*gd2*s**2 - 480*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r**2 + 384*D1*Dd*fd*g2*r*s - 48*D1*Dd*fd*g2*r + 768*D1*Dd*fd*g2*s**2 - 1056*D1*Dd*fd*g2*s + 288*D1*Dd*fd*g2 + 240*D1*Ddd*K*f**2*r*s - 60*D1*Ddd*K*f**2*r + 240*D1*Ddd*K*f**2*s**2 - 240*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 + 300*D1*Ddd*f**3*r**2 + 520*D1*Ddd*f**3*r*s - 430*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 370*D1*Ddd*f**3*s + 205*D1*Ddd*f**3 + 28*D1*Ddd*f**2*r**2 + 424*D1*Ddd*f**2*r*s - 134*D1*Ddd*f**2*r + 396*D1*Ddd*f**2*s**2 - 410*D1*Ddd*f**2*s + 113*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r**2 + 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r + 384*D1*Ddd*f*g2*s**2 - 288*D1*Ddd*f*g2*s + 2*D1*bd1*(5*D1*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 10*s + 5) - 2*D1*f*(12*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) + 5*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 30*r**2 - 36*r*s + 42*r - 6*s**2 + 42*s - 27) + 6*D1*fd*(2*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) - 10*r**2 + r*(9 - 12*s) - 2*s**2 + s - 1) - 5*Dd*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 26*s + 11) + 6*Dd*f*(K*(32*r**2 - 4*r*(8*s + 7) - 64*s**2 + 32*s + 6) - 40*r**2 - 6*r*(8*s - 9) - 8*s**2 + 42*s - 21)) + 720*Dd**2*K*f**2*r*s - 180*Dd**2*K*f**2*r + 720*Dd**2*K*f**2*s**2 - 720*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 + 900*Dd**2*f**3*r**2 + 1560*Dd**2*f**3*r*s - 1290*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 1110*Dd**2*f**3*s + 410*Dd**2*f**3 + 84*Dd**2*f**2*r**2 + 1272*Dd**2*f**2*r*s - 402*Dd**2*f**2*r + 1188*Dd**2*f**2*s**2 - 1230*Dd**2*f**2*s + 226*Dd**2*f**2 - 576*Dd**2*f*g2*r**2 + 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r + 1152*Dd**2*f*g2*s**2 - 864*Dd**2*f*g2*s))/(693*d**2*k3**3) + 8*D1**2*Pk2*Pkd3*ct**5*k1*(-D1*f*(D1*bd1**2*s*(5*f + 6)*(2*r + 2*s - 1) + 5*D1*bdd1*f*s*(r + s) + 5*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1)))) + b1**2*(-D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) - 2*fd*(10*f*s - 5*f + 6*s - 6) + fdd*(10*f*s - 5*f + 6*s - 6)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 12*r*(4*s - 1) + 12*(1 - 2*s)**2) - 6*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(5*f + 6)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(5*f + 6)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(6*bdd1*s*(2*r + 2*s - 1) - 10*fd*(2*s - 1)*(r + s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) + 5*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + 2*f*s*(5*f + 6)*(2*r + 2*s - 1) - 6*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - Dd*f*(5*f + 6)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 5*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(6 - 16*s) - 16*s**2 + 20*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k2*k3) + 40*D1**2*Pk2*Pkd3*ct**4*f**2*k1**6*(D1**2*(f*(38*fd - 45*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 45*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(38*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 90*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) - 45*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 45*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1287*d**2*k2**2*k3**5) + 30*D1**2*Pk2*Pkd3*ct**4*f*k1**2*k2**4*st**4*(D1**2*(70*f**2*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*f*(140*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - fd*(26*C - 26)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(13*C - 13)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2)) + fd**2*(78 - 78*C)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(70*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(39*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 70*fd*(4*r + 4*s - 3)**2 - 156*r**2 - 312*r*s + 234*r - 156*s**2 + 234*s - 117) - fd*(39*C - 39)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - Ddd*f*(39*C + 70*f - 39)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(39*C + 70*f - 39)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1001*d**2*k3**7) + 80*D1**2*Pk2*Pkd3*ct**4*f*k1**2*k2**2*st**4*(D1**2*(70*f**2*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-70*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + fd*(78*C - 78)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(39*C - 39)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(39*C - 39)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(140*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(78*C*(r*(4*s - 1) + (1 - 2*s)**2) - 140*fd*(4*s - 1)*(4*r + 4*s - 3) - 78*r*(4*s - 1) - 78*(1 - 2*s)**2) - fd*(39*C - 39)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(39*C + 70*f - 39)) - Dd**2*f**2*(39*C + 70*f - 39)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**4*k1**6*(8970*C*D1**2*f**2*fd*r**2 + 17940*C*D1**2*f**2*fd*r*s - 11960*C*D1**2*f**2*fd*r + 8970*C*D1**2*f**2*fd*s**2 - 11960*C*D1**2*f**2*fd*s + 5980*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r**2 - 21840*C*D1**2*f**2*fdd*r*s + 14560*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 14560*C*D1**2*f**2*fdd*s - 7280*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r**2 - 43680*C*D1**2*f*fd**2*r*s + 29120*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 29120*C*D1**2*f*fd**2*s - 7280*C*D1**2*f*fd**2 + 11960*C*D1*Dd*f**3*r**2 + 23920*C*D1*Dd*f**3*r*s - 17940*C*D1*Dd*f**3*r + 11960*C*D1*Dd*f**3*s**2 - 17940*C*D1*Dd*f**3*s + 8970*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r**2 - 174720*C*D1*Dd*f**2*fd*r*s + 123760*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 123760*C*D1*Dd*f**2*fd*s - 43680*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r**2 - 29120*C*D1*Ddd*f**3*r*s + 21840*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 21840*C*D1*Ddd*f**3*s - 10920*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r**2 - 87360*C*Dd**2*f**3*r*s + 65520*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 65520*C*Dd**2*f**3*s - 21840*C*Dd**2*f**3 + 3432*D1**2*K*b1*f*fd*r**2 + 6864*D1**2*K*b1*f*fd*r*s - 3432*D1**2*K*b1*f*fd*r + 3432*D1**2*K*b1*f*fd*s**2 - 3432*D1**2*K*b1*f*fd*s + 1716*D1**2*K*b1*f*fd - 4290*D1**2*K*b1*f*fdd*r**2 - 8580*D1**2*K*b1*f*fdd*r*s + 4290*D1**2*K*b1*f*fdd*r - 4290*D1**2*K*b1*f*fdd*s**2 + 4290*D1**2*K*b1*f*fdd*s - 2145*D1**2*K*b1*f*fdd - 4290*D1**2*K*b1*fd**2*r**2 - 8580*D1**2*K*b1*fd**2*r*s + 4290*D1**2*K*b1*fd**2*r - 4290*D1**2*K*b1*fd**2*s**2 + 4290*D1**2*K*b1*fd**2*s - 3432*D1**2*b1*f*fd*r**2 - 6864*D1**2*b1*f*fd*r*s + 3432*D1**2*b1*f*fd*r - 3432*D1**2*b1*f*fd*s**2 + 3432*D1**2*b1*f*fd*s - 1716*D1**2*b1*f*fd + 4290*D1**2*b1*f*fdd*r**2 + 8580*D1**2*b1*f*fdd*r*s - 4290*D1**2*b1*f*fdd*r + 4290*D1**2*b1*f*fdd*s**2 - 4290*D1**2*b1*f*fdd*s + 2145*D1**2*b1*f*fdd + 4290*D1**2*b1*fd**2*r**2 + 8580*D1**2*b1*fd**2*r*s - 4290*D1**2*b1*fd**2*r + 4290*D1**2*b1*fd**2*s**2 - 4290*D1**2*b1*fd**2*s - 2145*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 26600*D1**2*f**3*fd*r**2 + 53200*D1**2*f**3*fd*r*s - 39900*D1**2*f**3*fd*r + 26600*D1**2*f**3*fd*s**2 - 39900*D1**2*f**3*fd*s + 19950*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 - 8970*D1**2*f**2*fd*r**2 - 17940*D1**2*f**2*fd*r*s + 11960*D1**2*f**2*fd*r - 8970*D1**2*f**2*fd*s**2 + 11960*D1**2*f**2*fd*s - 5980*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r**2 + 21840*D1**2*f**2*fdd*r*s - 14560*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 14560*D1**2*f**2*fdd*s + 7280*D1**2*f**2*fdd - 3432*D1**2*f**2*gd2*r**2 - 6864*D1**2*f**2*gd2*r*s + 6864*D1**2*f**2*gd2*r - 3432*D1**2*f**2*gd2*s**2 + 6864*D1**2*f**2*gd2*s - 3432*D1**2*f**2*gd2 + 4290*D1**2*f**2*gdd2*r**2 + 8580*D1**2*f**2*gdd2*r*s - 8580*D1**2*f**2*gdd2*r + 4290*D1**2*f**2*gdd2*s**2 - 8580*D1**2*f**2*gdd2*s + 4290*D1**2*f**2*gdd2 + 21840*D1**2*f*fd**2*r**2 + 43680*D1**2*f*fd**2*r*s - 29120*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 29120*D1**2*f*fd**2*s + 7280*D1**2*f*fd**2 - 6864*D1**2*f*fd*g2*r**2 - 13728*D1**2*f*fd*g2*r*s + 6864*D1**2*f*fd*g2*r - 6864*D1**2*f*fd*g2*s**2 + 6864*D1**2*f*fd*g2*s - 3432*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r**2 + 34320*D1**2*f*fd*gd2*r*s - 25740*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 25740*D1**2*f*fd*gd2*s + 8580*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r**2 + 17160*D1**2*f*fdd*g2*r*s - 8580*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r**2 + 17160*D1**2*fd**2*g2*r*s - 8580*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 6864*D1*Dd*K*b1*f**2*r**2 + 13728*D1*Dd*K*b1*f**2*r*s - 10296*D1*Dd*K*b1*f**2*r + 6864*D1*Dd*K*b1*f**2*s**2 - 10296*D1*Dd*K*b1*f**2*s + 5148*D1*Dd*K*b1*f**2 - 34320*D1*Dd*K*b1*f*fd*r**2 - 68640*D1*Dd*K*b1*f*fd*r*s + 42900*D1*Dd*K*b1*f*fd*r - 34320*D1*Dd*K*b1*f*fd*s**2 + 42900*D1*Dd*K*b1*f*fd*s - 12870*D1*Dd*K*b1*f*fd - 6864*D1*Dd*b1*f**2*r**2 - 13728*D1*Dd*b1*f**2*r*s + 10296*D1*Dd*b1*f**2*r - 6864*D1*Dd*b1*f**2*s**2 + 10296*D1*Dd*b1*f**2*s - 5148*D1*Dd*b1*f**2 + 34320*D1*Dd*b1*f*fd*r**2 + 68640*D1*Dd*b1*f*fd*r*s - 42900*D1*Dd*b1*f*fd*r + 34320*D1*Dd*b1*f*fd*s**2 - 42900*D1*Dd*b1*f*fd*s + 12870*D1*Dd*b1*f*fd + 26600*D1*Dd*f**4*r**2 + 53200*D1*Dd*f**4*r*s - 39900*D1*Dd*f**4*r + 26600*D1*Dd*f**4*s**2 - 39900*D1*Dd*f**4*s + 19950*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd - 11960*D1*Dd*f**3*r**2 - 23920*D1*Dd*f**3*r*s + 17940*D1*Dd*f**3*r - 11960*D1*Dd*f**3*s**2 + 17940*D1*Dd*f**3*s - 8970*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r**2 + 174720*D1*Dd*f**2*fd*r*s - 123760*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 123760*D1*Dd*f**2*fd*s + 43680*D1*Dd*f**2*fd - 13728*D1*Dd*f**2*g2*r**2 - 27456*D1*Dd*f**2*g2*r*s + 20592*D1*Dd*f**2*g2*r - 13728*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 10296*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r**2 + 68640*D1*Dd*f**2*gd2*r*s - 60060*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 60060*D1*Dd*f**2*gd2*s + 25740*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r**2 + 137280*D1*Dd*f*fd*g2*r*s - 85800*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 85800*D1*Dd*f*fd*g2*s + 25740*D1*Dd*f*fd*g2 - 8580*D1*Ddd*K*b1*f**2*r**2 - 17160*D1*Ddd*K*b1*f**2*r*s + 12870*D1*Ddd*K*b1*f**2*r - 8580*D1*Ddd*K*b1*f**2*s**2 + 12870*D1*Ddd*K*b1*f**2*s - 6435*D1*Ddd*K*b1*f**2 + 8580*D1*Ddd*b1*f**2*r**2 + 17160*D1*Ddd*b1*f**2*r*s - 12870*D1*Ddd*b1*f**2*r + 8580*D1*Ddd*b1*f**2*s**2 - 12870*D1*Ddd*b1*f**2*s + 6435*D1*Ddd*b1*f**2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r**2 + 29120*D1*Ddd*f**3*r*s - 21840*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 21840*D1*Ddd*f**3*s + 10920*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r**2 + 34320*D1*Ddd*f**2*g2*r*s - 25740*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 25740*D1*Ddd*f**2*g2*s + 12870*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 25740*Dd**2*K*b1*f**2*r**2 - 51480*Dd**2*K*b1*f**2*r*s + 38610*Dd**2*K*b1*f**2*r - 25740*Dd**2*K*b1*f**2*s**2 + 38610*Dd**2*K*b1*f**2*s - 12870*Dd**2*K*b1*f**2 + 25740*Dd**2*b1*f**2*r**2 + 51480*Dd**2*b1*f**2*r*s - 38610*Dd**2*b1*f**2*r + 25740*Dd**2*b1*f**2*s**2 - 38610*Dd**2*b1*f**2*s + 12870*Dd**2*b1*f**2 - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 43680*Dd**2*f**3*r**2 + 87360*Dd**2*f**3*r*s - 65520*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 65520*Dd**2*f**3*s + 21840*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r**2 + 102960*Dd**2*f**2*g2*r*s - 77220*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 77220*Dd**2*f**2*g2*s + 25740*Dd**2*f**2*g2)/(1001*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct**4*k1**4*k2**2*st**2*(31356*C*D1**2*f**2*fd*r**2 + 62712*C*D1**2*f**2*fd*r*s - 41808*C*D1**2*f**2*fd*r + 31356*C*D1**2*f**2*fd*s**2 - 41808*C*D1**2*f**2*fd*s + 20904*C*D1**2*f**2*fd - 23400*C*D1**2*f**2*fdd*r**2 - 46800*C*D1**2*f**2*fdd*r*s + 31200*C*D1**2*f**2*fdd*r - 23400*C*D1**2*f**2*fdd*s**2 + 31200*C*D1**2*f**2*fdd*s - 15600*C*D1**2*f**2*fdd - 46800*C*D1**2*f*fd**2*r**2 - 93600*C*D1**2*f*fd**2*r*s + 62400*C*D1**2*f*fd**2*r - 46800*C*D1**2*f*fd**2*s**2 + 62400*C*D1**2*f*fd**2*s - 15600*C*D1**2*f*fd**2 + 41808*C*D1*Dd*f**3*r**2 + 83616*C*D1*Dd*f**3*r*s - 62712*C*D1*Dd*f**3*r + 41808*C*D1*Dd*f**3*s**2 - 62712*C*D1*Dd*f**3*s + 31356*C*D1*Dd*f**3 - 187200*C*D1*Dd*f**2*fd*r**2 - 374400*C*D1*Dd*f**2*fd*r*s + 265200*C*D1*Dd*f**2*fd*r - 187200*C*D1*Dd*f**2*fd*s**2 + 265200*C*D1*Dd*f**2*fd*s - 93600*C*D1*Dd*f**2*fd - 31200*C*D1*Ddd*f**3*r**2 - 62400*C*D1*Ddd*f**3*r*s + 46800*C*D1*Ddd*f**3*r - 31200*C*D1*Ddd*f**3*s**2 + 46800*C*D1*Ddd*f**3*s - 23400*C*D1*Ddd*f**3 - 93600*C*Dd**2*f**3*r**2 - 187200*C*Dd**2*f**3*r*s + 140400*C*Dd**2*f**3*r - 93600*C*Dd**2*f**3*s**2 + 140400*C*Dd**2*f**3*s - 46800*C*Dd**2*f**3 + 15444*D1**2*K*b1*f*fd*r**2 + 30888*D1**2*K*b1*f*fd*r*s - 15444*D1**2*K*b1*f*fd*r + 15444*D1**2*K*b1*f*fd*s**2 - 15444*D1**2*K*b1*f*fd*s + 7722*D1**2*K*b1*f*fd - 10296*D1**2*K*b1*f*fdd*r**2 - 20592*D1**2*K*b1*f*fdd*r*s + 10296*D1**2*K*b1*f*fdd*r - 10296*D1**2*K*b1*f*fdd*s**2 + 10296*D1**2*K*b1*f*fdd*s - 5148*D1**2*K*b1*f*fdd - 10296*D1**2*K*b1*fd**2*r**2 - 20592*D1**2*K*b1*fd**2*r*s + 10296*D1**2*K*b1*fd**2*r - 10296*D1**2*K*b1*fd**2*s**2 + 10296*D1**2*K*b1*fd**2*s - 15444*D1**2*b1*f*fd*r**2 - 30888*D1**2*b1*f*fd*r*s + 15444*D1**2*b1*f*fd*r - 15444*D1**2*b1*f*fd*s**2 + 15444*D1**2*b1*f*fd*s - 7722*D1**2*b1*f*fd + 10296*D1**2*b1*f*fdd*r**2 + 20592*D1**2*b1*f*fdd*r*s - 10296*D1**2*b1*f*fdd*r + 10296*D1**2*b1*f*fdd*s**2 - 10296*D1**2*b1*f*fdd*s + 5148*D1**2*b1*f*fdd + 10296*D1**2*b1*fd**2*r**2 + 20592*D1**2*b1*fd**2*r*s - 10296*D1**2*b1*fd**2*r + 10296*D1**2*b1*fd**2*s**2 - 10296*D1**2*b1*fd**2*s - 5148*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 65500*D1**2*f**3*fd*r**2 + 131000*D1**2*f**3*fd*r*s - 98250*D1**2*f**3*fd*r + 65500*D1**2*f**3*fd*s**2 - 98250*D1**2*f**3*fd*s + 49125*D1**2*f**3*fd - 49000*D1**2*f**3*fdd*r**2 - 98000*D1**2*f**3*fdd*r*s + 73500*D1**2*f**3*fdd*r - 49000*D1**2*f**3*fdd*s**2 + 73500*D1**2*f**3*fdd*s - 36750*D1**2*f**3*fdd - 147000*D1**2*f**2*fd**2*r**2 - 294000*D1**2*f**2*fd**2*r*s + 220500*D1**2*f**2*fd**2*r - 147000*D1**2*f**2*fd**2*s**2 + 220500*D1**2*f**2*fd**2*s - 73500*D1**2*f**2*fd**2 - 31356*D1**2*f**2*fd*r**2 - 62712*D1**2*f**2*fd*r*s + 41808*D1**2*f**2*fd*r - 31356*D1**2*f**2*fd*s**2 + 41808*D1**2*f**2*fd*s - 20904*D1**2*f**2*fd + 23400*D1**2*f**2*fdd*r**2 + 46800*D1**2*f**2*fdd*r*s - 31200*D1**2*f**2*fdd*r + 23400*D1**2*f**2*fdd*s**2 - 31200*D1**2*f**2*fdd*s + 15600*D1**2*f**2*fdd - 15444*D1**2*f**2*gd2*r**2 - 30888*D1**2*f**2*gd2*r*s + 30888*D1**2*f**2*gd2*r - 15444*D1**2*f**2*gd2*s**2 + 30888*D1**2*f**2*gd2*s - 15444*D1**2*f**2*gd2 + 10296*D1**2*f**2*gdd2*r**2 + 20592*D1**2*f**2*gdd2*r*s - 20592*D1**2*f**2*gdd2*r + 10296*D1**2*f**2*gdd2*s**2 - 20592*D1**2*f**2*gdd2*s + 10296*D1**2*f**2*gdd2 + 46800*D1**2*f*fd**2*r**2 + 93600*D1**2*f*fd**2*r*s - 62400*D1**2*f*fd**2*r + 46800*D1**2*f*fd**2*s**2 - 62400*D1**2*f*fd**2*s + 15600*D1**2*f*fd**2 - 30888*D1**2*f*fd*g2*r**2 - 61776*D1**2*f*fd*g2*r*s + 30888*D1**2*f*fd*g2*r - 30888*D1**2*f*fd*g2*s**2 + 30888*D1**2*f*fd*g2*s - 15444*D1**2*f*fd*g2 + 41184*D1**2*f*fd*gd2*r**2 + 82368*D1**2*f*fd*gd2*r*s - 61776*D1**2*f*fd*gd2*r + 41184*D1**2*f*fd*gd2*s**2 - 61776*D1**2*f*fd*gd2*s + 20592*D1**2*f*fd*gd2 + 20592*D1**2*f*fdd*g2*r**2 + 41184*D1**2*f*fdd*g2*r*s - 20592*D1**2*f*fdd*g2*r + 20592*D1**2*f*fdd*g2*s**2 - 20592*D1**2*f*fdd*g2*s + 10296*D1**2*f*fdd*g2 + 20592*D1**2*fd**2*g2*r**2 + 41184*D1**2*fd**2*g2*r*s - 20592*D1**2*fd**2*g2*r + 20592*D1**2*fd**2*g2*s**2 - 20592*D1**2*fd**2*g2*s + 30888*D1*Dd*K*b1*f**2*r**2 + 61776*D1*Dd*K*b1*f**2*r*s - 46332*D1*Dd*K*b1*f**2*r + 30888*D1*Dd*K*b1*f**2*s**2 - 46332*D1*Dd*K*b1*f**2*s + 23166*D1*Dd*K*b1*f**2 - 82368*D1*Dd*K*b1*f*fd*r**2 - 164736*D1*Dd*K*b1*f*fd*r*s + 102960*D1*Dd*K*b1*f*fd*r - 82368*D1*Dd*K*b1*f*fd*s**2 + 102960*D1*Dd*K*b1*f*fd*s - 30888*D1*Dd*K*b1*f*fd - 30888*D1*Dd*b1*f**2*r**2 - 61776*D1*Dd*b1*f**2*r*s + 46332*D1*Dd*b1*f**2*r - 30888*D1*Dd*b1*f**2*s**2 + 46332*D1*Dd*b1*f**2*s - 23166*D1*Dd*b1*f**2 + 82368*D1*Dd*b1*f*fd*r**2 + 164736*D1*Dd*b1*f*fd*r*s - 102960*D1*Dd*b1*f*fd*r + 82368*D1*Dd*b1*f*fd*s**2 - 102960*D1*Dd*b1*f*fd*s + 30888*D1*Dd*b1*f*fd + 65500*D1*Dd*f**4*r**2 + 131000*D1*Dd*f**4*r*s - 98250*D1*Dd*f**4*r + 65500*D1*Dd*f**4*s**2 - 98250*D1*Dd*f**4*s + 49125*D1*Dd*f**4 - 392000*D1*Dd*f**3*fd*r**2 - 784000*D1*Dd*f**3*fd*r*s + 588000*D1*Dd*f**3*fd*r - 392000*D1*Dd*f**3*fd*s**2 + 588000*D1*Dd*f**3*fd*s - 220500*D1*Dd*f**3*fd - 41808*D1*Dd*f**3*r**2 - 83616*D1*Dd*f**3*r*s + 62712*D1*Dd*f**3*r - 41808*D1*Dd*f**3*s**2 + 62712*D1*Dd*f**3*s - 31356*D1*Dd*f**3 + 187200*D1*Dd*f**2*fd*r**2 + 374400*D1*Dd*f**2*fd*r*s - 265200*D1*Dd*f**2*fd*r + 187200*D1*Dd*f**2*fd*s**2 - 265200*D1*Dd*f**2*fd*s + 93600*D1*Dd*f**2*fd - 61776*D1*Dd*f**2*g2*r**2 - 123552*D1*Dd*f**2*g2*r*s + 92664*D1*Dd*f**2*g2*r - 61776*D1*Dd*f**2*g2*s**2 + 92664*D1*Dd*f**2*g2*s - 46332*D1*Dd*f**2*g2 + 82368*D1*Dd*f**2*gd2*r**2 + 164736*D1*Dd*f**2*gd2*r*s - 144144*D1*Dd*f**2*gd2*r + 82368*D1*Dd*f**2*gd2*s**2 - 144144*D1*Dd*f**2*gd2*s + 61776*D1*Dd*f**2*gd2 + 164736*D1*Dd*f*fd*g2*r**2 + 329472*D1*Dd*f*fd*g2*r*s - 205920*D1*Dd*f*fd*g2*r + 164736*D1*Dd*f*fd*g2*s**2 - 205920*D1*Dd*f*fd*g2*s + 61776*D1*Dd*f*fd*g2 - 20592*D1*Ddd*K*b1*f**2*r**2 - 41184*D1*Ddd*K*b1*f**2*r*s + 30888*D1*Ddd*K*b1*f**2*r - 20592*D1*Ddd*K*b1*f**2*s**2 + 30888*D1*Ddd*K*b1*f**2*s - 15444*D1*Ddd*K*b1*f**2 + 20592*D1*Ddd*b1*f**2*r**2 + 41184*D1*Ddd*b1*f**2*r*s - 30888*D1*Ddd*b1*f**2*r + 20592*D1*Ddd*b1*f**2*s**2 - 30888*D1*Ddd*b1*f**2*s + 15444*D1*Ddd*b1*f**2 - 49000*D1*Ddd*f**4*r**2 - 98000*D1*Ddd*f**4*r*s + 73500*D1*Ddd*f**4*r - 49000*D1*Ddd*f**4*s**2 + 73500*D1*Ddd*f**4*s - 36750*D1*Ddd*f**4 + 31200*D1*Ddd*f**3*r**2 + 62400*D1*Ddd*f**3*r*s - 46800*D1*Ddd*f**3*r + 31200*D1*Ddd*f**3*s**2 - 46800*D1*Ddd*f**3*s + 23400*D1*Ddd*f**3 + 41184*D1*Ddd*f**2*g2*r**2 + 82368*D1*Ddd*f**2*g2*r*s - 61776*D1*Ddd*f**2*g2*r + 41184*D1*Ddd*f**2*g2*s**2 - 61776*D1*Ddd*f**2*g2*s + 30888*D1*Ddd*f**2*g2 + 2574*D1*bd1*f*(K - 1)*(r + s - 1)*(3*D1*f*(r + s - 1) - 4*D1*fd*(2*r + 2*s - 1) - 4*Dd*f*(4*r + 4*s - 3)) - 61776*Dd**2*K*b1*f**2*r**2 - 123552*Dd**2*K*b1*f**2*r*s + 92664*Dd**2*K*b1*f**2*r - 61776*Dd**2*K*b1*f**2*s**2 + 92664*Dd**2*K*b1*f**2*s - 30888*Dd**2*K*b1*f**2 + 61776*Dd**2*b1*f**2*r**2 + 123552*Dd**2*b1*f**2*r*s - 92664*Dd**2*b1*f**2*r + 61776*Dd**2*b1*f**2*s**2 - 92664*Dd**2*b1*f**2*s + 30888*Dd**2*b1*f**2 - 147000*Dd**2*f**4*r**2 - 294000*Dd**2*f**4*r*s + 220500*Dd**2*f**4*r - 147000*Dd**2*f**4*s**2 + 220500*Dd**2*f**4*s - 73500*Dd**2*f**4 + 93600*Dd**2*f**3*r**2 + 187200*Dd**2*f**3*r*s - 140400*Dd**2*f**3*r + 93600*Dd**2*f**3*s**2 - 140400*Dd**2*f**3*s + 46800*Dd**2*f**3 + 123552*Dd**2*f**2*g2*r**2 + 247104*Dd**2*f**2*g2*r*s - 185328*Dd**2*f**2*g2*r + 123552*Dd**2*f**2*g2*s**2 - 185328*Dd**2*f**2*g2*s + 61776*Dd**2*f**2*g2)/(2002*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**4*k1**4*k2**2*(4530*C*D1**2*f**2*fd*r**2 + 9060*C*D1**2*f**2*fd*r*s - 6040*C*D1**2*f**2*fd*r + 4530*C*D1**2*f**2*fd*s**2 - 6040*C*D1**2*f**2*fd*s + 3020*C*D1**2*f**2*fd - 6720*C*D1**2*f**2*fdd*r**2 - 13440*C*D1**2*f**2*fdd*r*s + 8960*C*D1**2*f**2*fdd*r - 6720*C*D1**2*f**2*fdd*s**2 + 8960*C*D1**2*f**2*fdd*s - 4480*C*D1**2*f**2*fdd - 13440*C*D1**2*f*fd**2*r**2 - 26880*C*D1**2*f*fd**2*r*s + 17920*C*D1**2*f*fd**2*r - 13440*C*D1**2*f*fd**2*s**2 + 17920*C*D1**2*f*fd**2*s - 4480*C*D1**2*f*fd**2 + 6040*C*D1*Dd*f**3*r**2 + 12080*C*D1*Dd*f**3*r*s - 9060*C*D1*Dd*f**3*r + 6040*C*D1*Dd*f**3*s**2 - 9060*C*D1*Dd*f**3*s + 4530*C*D1*Dd*f**3 - 53760*C*D1*Dd*f**2*fd*r**2 - 107520*C*D1*Dd*f**2*fd*r*s + 76160*C*D1*Dd*f**2*fd*r - 53760*C*D1*Dd*f**2*fd*s**2 + 76160*C*D1*Dd*f**2*fd*s - 26880*C*D1*Dd*f**2*fd - 8960*C*D1*Ddd*f**3*r**2 - 17920*C*D1*Ddd*f**3*r*s + 13440*C*D1*Ddd*f**3*r - 8960*C*D1*Ddd*f**3*s**2 + 13440*C*D1*Ddd*f**3*s - 6720*C*D1*Ddd*f**3 - 26880*C*Dd**2*f**3*r**2 - 53760*C*Dd**2*f**3*r*s + 40320*C*Dd**2*f**3*r - 26880*C*Dd**2*f**3*s**2 + 40320*C*Dd**2*f**3*s - 13440*C*Dd**2*f**3 - 2376*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 132*D1**2*bdd1*f*(5*f*(3*C + 2*K - 4) - 18*g2)*(r + s - 1)**2 - 1680*D1**2*f**3*fd*r**2 - 3360*D1**2*f**3*fd*r*s + 2520*D1**2*f**3*fd*r - 1680*D1**2*f**3*fd*s**2 + 2520*D1**2*f**3*fd*s - 1260*D1**2*f**3*fd - 3150*D1**2*f**2*fd*r**2 - 6300*D1**2*f**2*fd*r*s + 4200*D1**2*f**2*fd*r - 3150*D1**2*f**2*fd*s**2 + 4200*D1**2*f**2*fd*s - 2100*D1**2*f**2*fd + 5040*D1**2*f**2*fdd*r**2 + 10080*D1**2*f**2*fdd*r*s - 6720*D1**2*f**2*fdd*r + 5040*D1**2*f**2*fdd*s**2 - 6720*D1**2*f**2*fdd*s + 3360*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 2640*D1**2*f**2*gdd2*r**2 + 5280*D1**2*f**2*gdd2*r*s - 5280*D1**2*f**2*gdd2*r + 2640*D1**2*f**2*gdd2*s**2 - 5280*D1**2*f**2*gdd2*s + 2640*D1**2*f**2*gdd2 + 10080*D1**2*f*fd**2*r**2 + 20160*D1**2*f*fd**2*r*s - 13440*D1**2*f*fd**2*r + 10080*D1**2*f*fd**2*s**2 - 13440*D1**2*f*fd**2*s + 3360*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 10560*D1**2*f*fd*gd2*r**2 + 21120*D1**2*f*fd*gd2*r*s - 15840*D1**2*f*fd*gd2*r + 10560*D1**2*f*fd*gd2*s**2 - 15840*D1**2*f*fd*gd2*s + 5280*D1**2*f*fd*gd2 + 5280*D1**2*f*fdd*g2*r**2 + 10560*D1**2*f*fdd*g2*r*s - 5280*D1**2*f*fdd*g2*r + 5280*D1**2*f*fdd*g2*s**2 - 5280*D1**2*f*fdd*g2*s + 2640*D1**2*f*fdd*g2 + 5280*D1**2*fd**2*g2*r**2 + 10560*D1**2*fd**2*g2*r*s - 5280*D1**2*fd**2*g2*r + 5280*D1**2*fd**2*g2*s**2 - 5280*D1**2*fd**2*g2*s - 1680*D1*Dd*f**4*r**2 - 3360*D1*Dd*f**4*r*s + 2520*D1*Dd*f**4*r - 1680*D1*Dd*f**4*s**2 + 2520*D1*Dd*f**4*s - 1260*D1*Dd*f**4 - 4200*D1*Dd*f**3*r**2 - 8400*D1*Dd*f**3*r*s + 6300*D1*Dd*f**3*r - 4200*D1*Dd*f**3*s**2 + 6300*D1*Dd*f**3*s - 3150*D1*Dd*f**3 + 40320*D1*Dd*f**2*fd*r**2 + 80640*D1*Dd*f**2*fd*r*s - 57120*D1*Dd*f**2*fd*r + 40320*D1*Dd*f**2*fd*s**2 - 57120*D1*Dd*f**2*fd*s + 20160*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 21120*D1*Dd*f**2*gd2*r**2 + 42240*D1*Dd*f**2*gd2*r*s - 36960*D1*Dd*f**2*gd2*r + 21120*D1*Dd*f**2*gd2*s**2 - 36960*D1*Dd*f**2*gd2*s + 15840*D1*Dd*f**2*gd2 + 42240*D1*Dd*f*fd*g2*r**2 + 84480*D1*Dd*f*fd*g2*r*s - 52800*D1*Dd*f*fd*g2*r + 42240*D1*Dd*f*fd*g2*s**2 - 52800*D1*Dd*f*fd*g2*s + 15840*D1*Dd*f*fd*g2 + 6720*D1*Ddd*f**3*r**2 + 13440*D1*Ddd*f**3*r*s - 10080*D1*Ddd*f**3*r + 6720*D1*Ddd*f**3*s**2 - 10080*D1*Ddd*f**3*s + 5040*D1*Ddd*f**3 + 10560*D1*Ddd*f**2*g2*r**2 + 21120*D1*Ddd*f**2*g2*r*s - 15840*D1*Ddd*f**2*g2*r + 10560*D1*Ddd*f**2*g2*s**2 - 15840*D1*Ddd*f**2*g2*s + 7920*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(30*C + 13*K - 35)*(r + s - 1) - 20*f*fd*(3*C + 2*K - 4)*(2*r + 2*s - 1) - f*(37*g2 - 72*gd2)*(r + s - 1) + 72*fd*g2*(r + s)) - 4*Dd*f*(5*f*(3*C + 2*K - 4) - 18*g2)*(4*r + 4*s - 3))*(r + s - 1) + 20160*Dd**2*f**3*r**2 + 40320*Dd**2*f**3*r*s - 30240*Dd**2*f**3*r + 20160*Dd**2*f**3*s**2 - 30240*Dd**2*f**3*s + 10080*Dd**2*f**3 + 31680*Dd**2*f**2*g2*r**2 + 63360*Dd**2*f**2*g2*r*s - 47520*Dd**2*f**2*g2*r + 31680*Dd**2*f**2*g2*s**2 - 47520*Dd**2*f**2*g2*s + 15840*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*(37*fd - 36*fdd)*(r + s)**2 + D1*(Dd*(37*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 72*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 36*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 216*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(60*C*D1**2*f*fd*r**2 + 120*C*D1**2*f*fd*r*s - 60*C*D1**2*f*fd*r + 60*C*D1**2*f*fd*s**2 - 60*C*D1**2*f*fd*s + 30*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r**2 - 120*C*D1**2*f*fdd*r*s + 60*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 60*C*D1**2*f*fdd*s - 30*C*D1**2*f*fdd - 60*C*D1**2*fd**2*r**2 - 120*C*D1**2*fd**2*r*s + 60*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 60*C*D1**2*fd**2*s + 120*C*D1*Dd*f**2*r**2 + 240*C*D1*Dd*f**2*r*s - 180*C*D1*Dd*f**2*r + 120*C*D1*Dd*f**2*s**2 - 180*C*D1*Dd*f**2*s + 90*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r**2 - 960*C*D1*Dd*f*fd*r*s + 600*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 600*C*D1*Dd*f*fd*s - 180*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r**2 - 240*C*D1*Ddd*f**2*r*s + 180*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 180*C*D1*Ddd*f**2*s - 90*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r**2 - 720*C*Dd**2*f**2*r*s + 540*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 540*C*Dd**2*f**2*s - 180*C*Dd**2*f**2 + 26*D1**2*K*f*fd*r**2 + 52*D1**2*K*f*fd*r*s - 26*D1**2*K*f*fd*r + 26*D1**2*K*f*fd*s**2 - 26*D1**2*K*f*fd*s + 13*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r**2 - 80*D1**2*K*f*fdd*r*s + 40*D1**2*K*f*fdd*r - 40*D1**2*K*f*fdd*s**2 + 40*D1**2*K*f*fdd*s - 20*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r**2 - 80*D1**2*K*fd**2*r*s + 40*D1**2*K*fd**2*r - 40*D1**2*K*fd**2*s**2 + 40*D1**2*K*fd**2*s - 36*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd - 70*D1**2*f*fd*r**2 - 140*D1**2*f*fd*r*s + 70*D1**2*f*fd*r - 70*D1**2*f*fd*s**2 + 70*D1**2*f*fd*s - 35*D1**2*f*fd + 80*D1**2*f*fdd*r**2 + 160*D1**2*f*fdd*r*s - 80*D1**2*f*fdd*r + 80*D1**2*f*fdd*s**2 - 80*D1**2*f*fdd*s + 40*D1**2*f*fdd - 37*D1**2*f*gd2*r**2 - 74*D1**2*f*gd2*r*s + 74*D1**2*f*gd2*r - 37*D1**2*f*gd2*s**2 + 74*D1**2*f*gd2*s - 37*D1**2*f*gd2 + 36*D1**2*f*gdd2*r**2 + 72*D1**2*f*gdd2*r*s - 72*D1**2*f*gdd2*r + 36*D1**2*f*gdd2*s**2 - 72*D1**2*f*gdd2*s + 36*D1**2*f*gdd2 + 80*D1**2*fd**2*r**2 + 160*D1**2*fd**2*r*s - 80*D1**2*fd**2*r + 80*D1**2*fd**2*s**2 - 80*D1**2*fd**2*s - 37*D1**2*fd*g2*r**2 - 74*D1**2*fd*g2*r*s - 37*D1**2*fd*g2*s**2 + 72*D1**2*fd*gd2*r**2 + 144*D1**2*fd*gd2*r*s - 72*D1**2*fd*gd2*r + 72*D1**2*fd*gd2*s**2 - 72*D1**2*fd*gd2*s + 36*D1**2*fdd*g2*r**2 + 72*D1**2*fdd*g2*r*s + 36*D1**2*fdd*g2*s**2 + 52*D1*Dd*K*f**2*r**2 + 104*D1*Dd*K*f**2*r*s - 78*D1*Dd*K*f**2*r + 52*D1*Dd*K*f**2*s**2 - 78*D1*Dd*K*f**2*s + 39*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r**2 - 640*D1*Dd*K*f*fd*r*s + 400*D1*Dd*K*f*fd*r - 320*D1*Dd*K*f*fd*s**2 + 400*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 - 140*D1*Dd*f**2*r**2 - 280*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r - 140*D1*Dd*f**2*s**2 + 210*D1*Dd*f**2*s - 105*D1*Dd*f**2 + 640*D1*Dd*f*fd*r**2 + 1280*D1*Dd*f*fd*r*s - 800*D1*Dd*f*fd*r + 640*D1*Dd*f*fd*s**2 - 800*D1*Dd*f*fd*s + 240*D1*Dd*f*fd - 148*D1*Dd*f*g2*r**2 - 296*D1*Dd*f*g2*r*s + 222*D1*Dd*f*g2*r - 148*D1*Dd*f*g2*s**2 + 222*D1*Dd*f*g2*s - 111*D1*Dd*f*g2 + 288*D1*Dd*f*gd2*r**2 + 576*D1*Dd*f*gd2*r*s - 504*D1*Dd*f*gd2*r + 288*D1*Dd*f*gd2*s**2 - 504*D1*Dd*f*gd2*s + 216*D1*Dd*f*gd2 + 288*D1*Dd*fd*g2*r**2 + 576*D1*Dd*fd*g2*r*s - 216*D1*Dd*fd*g2*r + 288*D1*Dd*fd*g2*s**2 - 216*D1*Dd*fd*g2*s - 80*D1*Ddd*K*f**2*r**2 - 160*D1*Ddd*K*f**2*r*s + 120*D1*Ddd*K*f**2*r - 80*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 + 160*D1*Ddd*f**2*r**2 + 320*D1*Ddd*f**2*r*s - 240*D1*Ddd*f**2*r + 160*D1*Ddd*f**2*s**2 - 240*D1*Ddd*f**2*s + 120*D1*Ddd*f**2 + 144*D1*Ddd*f*g2*r**2 + 288*D1*Ddd*f*g2*r*s - 216*D1*Ddd*f*g2*r + 144*D1*Ddd*f*g2*s**2 - 216*D1*Ddd*f*g2*s + 108*D1*Ddd*f*g2 + D1*bd1*(K - 1)*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) - 240*Dd**2*K*f**2*r**2 - 480*Dd**2*K*f**2*r*s + 360*Dd**2*K*f**2*r - 240*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 + 480*Dd**2*f**2*r**2 + 960*Dd**2*f**2*r*s - 720*Dd**2*f**2*r + 480*Dd**2*f**2*s**2 - 720*Dd**2*f**2*s + 240*Dd**2*f**2 + 432*Dd**2*f*g2*r**2 + 864*Dd**2*f*g2*r*s - 648*Dd**2*f*g2*r + 432*Dd**2*f*g2*s**2 - 648*Dd**2*f*g2*s + 216*Dd**2*f*g2))/(77*d**2*k3**7) + 8*D1**2*Pk2*Pkd3*ct**4*k1**4*st**2*(9126*C*D1**2*f**2*fd*r*s - 3042*C*D1**2*f**2*fd*r + 9126*C*D1**2*f**2*fd*s**2 - 9126*C*D1**2*f**2*fd*s + 3042*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 12168*C*D1*Dd*f**3*r*s - 3042*C*D1*Dd*f**3*r + 12168*C*D1*Dd*f**3*s**2 - 12168*C*D1*Dd*f**3*s + 3042*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 22900*D1**2*f**3*fd*r*s - 5725*D1**2*f**3*fd*r + 22900*D1**2*f**3*fd*s**2 - 22900*D1**2*f**3*fd*s + 5725*D1**2*f**3*fd - 14700*D1**2*f**3*fdd*r*s + 3675*D1**2*f**3*fdd*r - 14700*D1**2*f**3*fdd*s**2 + 14700*D1**2*f**3*fdd*s - 3675*D1**2*f**3*fdd - 44100*D1**2*f**2*fd**2*r*s + 11025*D1**2*f**2*fd**2*r - 44100*D1**2*f**2*fd**2*s**2 + 44100*D1**2*f**2*fd**2*s - 7350*D1**2*f**2*fd**2 - 9126*D1**2*f**2*fd*r*s + 3042*D1**2*f**2*fd*r - 9126*D1**2*f**2*fd*s**2 + 9126*D1**2*f**2*fd*s - 3042*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*s**2 + 4290*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 8580*D1**2*f*fd*g2*r*s + 4290*D1**2*f*fd*g2*r - 8580*D1**2*f*fd*g2*s**2 + 8580*D1**2*f*fd*g2*s - 4290*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 22900*D1*Dd*f**4*r*s - 5725*D1*Dd*f**4*r + 22900*D1*Dd*f**4*s**2 - 22900*D1*Dd*f**4*s + 5725*D1*Dd*f**4 - 117600*D1*Dd*f**3*fd*r*s + 29400*D1*Dd*f**3*fd*r - 117600*D1*Dd*f**3*fd*s**2 + 117600*D1*Dd*f**3*fd*s - 22050*D1*Dd*f**3*fd - 12168*D1*Dd*f**3*r*s + 3042*D1*Dd*f**3*r - 12168*D1*Dd*f**3*s**2 + 12168*D1*Dd*f**3*s - 3042*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 17160*D1*Dd*f**2*g2*r*s + 4290*D1*Dd*f**2*g2*r - 17160*D1*Dd*f**2*g2*s**2 + 17160*D1*Dd*f**2*g2*s - 4290*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 14700*D1*Ddd*f**4*r*s + 3675*D1*Ddd*f**4*r - 14700*D1*Ddd*f**4*s**2 + 14700*D1*Ddd*f**4*s - 3675*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 44100*Dd**2*f**4*r*s + 11025*Dd**2*f**4*r - 44100*Dd**2*f**4*s**2 + 44100*Dd**2*f**4*s - 7350*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**4*k1**4*(396*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 23*s + 6) + 2*D1**2*bdd1*f*(70*f**2*(35*r**2 + r*(78*s - 64) + 43*s**2 - 72*s + 44) + 33*f*(5*C*(5*r**2 + 2*r*(11*s - 6) + 17*s**2 - 24*s + 12) - K*(25*r**2 + 86*r*s - 50*r + 61*s**2 - 86*s + 25) + 50*r**2 + 86*r*s - 90*r + 36*s**2 - 76*s + 15) - 198*g2*(5*r**2 + 2*r*(11*s - 6) + 17*s**2 - 24*s + 12)) + 2*D1**2*(70*f**3*(fd*(124*r**2 + r*(424*s - 230) + 300*s**2 - 362*s + 137) - fdd*(148*r**2 + r*(376*s - 242) + 228*s**2 - 302*s + 131)) - f**2*(140*fd**2*(222*r**2 + r*(564*s - 363) + 342*s**2 - 453*s + 131) - 5*fd*(C*(693*r**2 + 3246*r*s - 1544*r + 2553*s**2 - 2784*s + 1082) - 1383*r**2 - 4764*r*s + 2510*r - 3381*s**2 + 3842*s - 1588) + 5*fdd*(C*(891*r**2 + 2910*r*s - 1564*r + 2019*s**2 - 2316*s + 970) - 1731*r**2 - 4758*r*s + 2740*r - 3027*s**2 + 3604*s - 1586) + (gd2*(17*r + 77*s - 17) + gdd2*(-25*r - 61*s + 25))*(66*r + 66*s - 66)) - 2*f*(5*fd**2*(C*(891*r**2 + 2910*r*s - 1564*r + 2019*s**2 - 2316*s + 485) - 1731*r**2 - 4758*r*s + 2740*r - 3027*s**2 + 3604*s - 793) + 33*fd*(g2*(34*r**2 + 94*r*(2*s - 1) + 154*s**2 - 154*s + 77) - 2*gd2*(50*r**2 + r*(172*s - 93) + 122*s**2 - 147*s + 43)) - 33*fdd*g2*(50*r**2 + 86*r*(2*s - 1) + 122*s**2 - 122*s + 61)) + 132*fd**2*g2*(25*r**2 + 43*r*(2*s - 1) + s*(61*s - 61))) + D1*bd1*(D1*(-5*f**3*(805*r**2 + 2*r*(1029*s - 934) + 1253*s**2 - 2316*s + 1408) - 2*f**2*(132*C*(5*r**2 + 2*r*(14*s - 9) + 23*s**2 - 36*s + 18) - 33*K*(17*r**2 + 94*r*s - 34*r + 77*s**2 - 94*s + 17) - 140*fd*(105*r**2 + r*(234*s - 173) + 129*s**2 - 193*s + 56) + 1221*r**2 + 2310*r*s - 1386*r + 1089*s**2 - 1254*s - 495) + 66*f*(2*fd*(10*C*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 20*s + 3) - K*(50*r**2 + 172*r*s - 93*r + 122*s**2 - 147*s + 43) + 100*r**2 + 172*r*s - 138*r + 72*s**2 - 117*s + 68) + g2*(25*r**2 + 2*r*(69*s - 44) + 113*s**2 - 176*s + 88) - 12*gd2*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 23*s + 6)) - 792*fd*g2*(5*r**2 + 11*r*(2*s - 1) + s*(17*s - 17))) + 4*Dd*f*(70*f**2*(140*r**2 + 3*r*(104*s - 79) + 172*s**2 - 265*s + 100) + 33*f*(5*C*(20*r**2 + r*(88*s - 45) + 68*s**2 - 87*s + 24) - K*(100*r**2 + 344*r*s - 193*r + 244*s**2 - 319*s + 93) + 200*r**2 + 344*r*s - 323*r + 144*s**2 - 274*s + 128) - 198*g2*(20*r**2 + r*(88*s - 45) + 68*s**2 - 87*s + 24))) + 2*D1*f*(Dd*(70*f**3*(124*r**2 + r*(424*s - 230) + 300*s**2 - 362*s + 137) + 5*f**2*(C*(924*r**2 + r*(4328*s - 2006) + 3404*s**2 - 3866*s + 1313) - 28*fd*(592*r**2 + 1504*r*s - 968*r + 912*s**2 - 1208*s + 393) - 1844*r**2 - 6352*r*s + 3432*r - 4508*s**2 + 5430*s - 2049) - 2*f*(5*fd*(C*(3564*r**2 + 11640*r*s - 6365*r + 8076*s**2 - 9561*s + 2722) - 6924*r**2 - 19032*r*s + 11321*r - 12108*s**2 + 14993*s - 4542) + 33*g2*(68*r**2 + 376*r*s - 162*r + 308*s**2 - 342*s + 111) - 66*gd2*(100*r**2 + 344*r*s - 193*r + 244*s**2 - 319*s + 93)) + 132*fd*g2*(200*r**2 + r*(688*s - 358) + 488*s**2 - 538*s + 147)) + Ddd*f*(-70*f**2*(148*r**2 + r*(376*s - 242) + 228*s**2 - 302*s + 131) - 5*f*(C*(1188*r**2 + 3880*r*s - 2158*r + 2692*s**2 - 3286*s + 1267) - 2308*r**2 - 6344*r*s + 3894*r - 4036*s**2 + 5190*s - 2163) + 66*g2*(100*r**2 + 2*r*(172*s - 93) + 244*s**2 - 294*s + 111))) - 4*Dd**2*f**2*(70*f**2*(222*r**2 + r*(564*s - 363) + 342*s**2 - 453*s + 131) + 5*f*(C*(1782*r**2 + 5820*r*s - 3237*r + 4038*s**2 - 4929*s + 1267) - 3462*r**2 - 9516*r*s + 5841*r - 6054*s**2 + 7785*s - 2163) - 198*g2*(50*r**2 + r*(172*s - 93) + 122*s**2 - 147*s + 37)) - 33*b1**2*(K - 1)*(D1**2*(fd*(25*r**2 + 138*r*s - 50*r + 113*s**2 - 50*s + 25) - 6*fdd*(5*r**2 + 22*r*s - 10*r + 17*s**2 - 10*s + 5)) + D1*(Dd*(f*(100*r**2 + 552*r*s - 238*r + 452*s**2 - 502*s + 163) - 12*fd*(20*r**2 + 88*r*s - 41*r + 68*s**2 - 59*s + 15)) - 6*Ddd*f*(20*r**2 + r*(88*s - 42) + 68*s**2 - 78*s + 27)) - 36*Dd**2*f*(10*r**2 + r*(44*s - 21) + 34*s**2 - 39*s + 9)) + b1*(-2640*C*D1**2*f*fd*r**2 - 14784*C*D1**2*f*fd*r*s + 5280*C*D1**2*f*fd*r - 12144*C*D1**2*f*fd*s**2 + 10032*C*D1**2*f*fd*s - 2640*C*D1**2*f*fd + 3300*C*D1**2*f*fdd*r**2 + 14520*C*D1**2*f*fdd*r*s - 6600*C*D1**2*f*fdd*r + 11220*C*D1**2*f*fdd*s**2 - 10560*C*D1**2*f*fdd*s + 3300*C*D1**2*f*fdd + 3300*C*D1**2*fd**2*r**2 + 14520*C*D1**2*fd**2*r*s - 6600*C*D1**2*fd**2*r + 11220*C*D1**2*fd**2*s**2 - 10560*C*D1**2*fd**2*s + 3300*C*D1**2*fd**2 - 5280*C*D1*Dd*f**2*r**2 - 29568*C*D1*Dd*f**2*r*s + 12672*C*D1*Dd*f**2*r - 24288*C*D1*Dd*f**2*s**2 + 26928*C*D1*Dd*f**2*s - 8712*C*D1*Dd*f**2 + 26400*C*D1*Dd*f*fd*r**2 + 116160*C*D1*Dd*f*fd*r*s - 54120*C*D1*Dd*f*fd*r + 89760*C*D1*Dd*f*fd*s**2 - 93720*C*D1*Dd*f*fd*s + 23760*C*D1*Dd*f*fd + 6600*C*D1*Ddd*f**2*r**2 + 29040*C*D1*Ddd*f**2*r*s - 13860*C*D1*Ddd*f**2*r + 22440*C*D1*Ddd*f**2*s**2 - 25740*C*D1*Ddd*f**2*s + 8910*C*D1*Ddd*f**2 + 19800*C*Dd**2*f**2*r**2 + 87120*C*Dd**2*f**2*r*s - 41580*C*Dd**2*f**2*r + 67320*C*Dd**2*f**2*s**2 - 77220*C*Dd**2*f**2*s + 17820*C*Dd**2*f**2 + 2244*D1**2*K*f*fd*r**2 + 12408*D1**2*K*f*fd*r*s - 6204*D1**2*K*f*fd*r + 10164*D1**2*K*f*fd*s**2 - 10164*D1**2*K*f*fd*s + 5082*D1**2*K*f*fd - 3300*D1**2*K*f*fdd*r**2 - 11352*D1**2*K*f*fdd*r*s + 5676*D1**2*K*f*fdd*r - 8052*D1**2*K*f*fdd*s**2 + 8052*D1**2*K*f*fdd*s - 4026*D1**2*K*f*fdd - 3300*D1**2*K*fd**2*r**2 - 11352*D1**2*K*fd**2*r*s + 5676*D1**2*K*fd**2*r - 8052*D1**2*K*fd**2*s**2 + 8052*D1**2*K*fd**2*s + 198*D1**2*bdd1*f*(K - 1)*(10*r**2 + 44*r*s - 22*r + 34*s**2 - 46*s + 17) - 12075*D1**2*f**2*fd*r**2 - 30870*D1**2*f**2*fd*r*s + 17050*D1**2*f**2*fd*r - 18795*D1**2*f**2*fd*s**2 + 21530*D1**2*f**2*fd*s - 7275*D1**2*f**2*fd + 14700*D1**2*f**2*fdd*r**2 + 32760*D1**2*f**2*fdd*r*s - 21560*D1**2*f**2*fdd*r + 18060*D1**2*f**2*fdd*s**2 - 23800*D1**2*f**2*fdd*s + 9660*D1**2*f**2*fdd + 29400*D1**2*f*fd**2*r**2 + 65520*D1**2*f*fd**2*r*s - 43120*D1**2*f*fd**2*r + 36120*D1**2*f*fd**2*s**2 - 47600*D1**2*f*fd**2*s + 15960*D1**2*f*fd**2 - 4884*D1**2*f*fd*r**2 - 9240*D1**2*f*fd*r*s + 6732*D1**2*f*fd*r - 4356*D1**2*f*fd*s**2 + 6468*D1**2*f*fd*s - 5610*D1**2*f*fd + 6600*D1**2*f*fdd*r**2 + 11352*D1**2*f*fdd*r*s - 6336*D1**2*f*fdd*r + 4752*D1**2*f*fdd*s**2 - 5412*D1**2*f*fdd*s + 4686*D1**2*f*fdd + 1650*D1**2*f*gd2*r**2 + 9108*D1**2*f*gd2*r*s - 3300*D1**2*f*gd2*r + 7458*D1**2*f*gd2*s**2 - 9108*D1**2*f*gd2*s + 1650*D1**2*f*gd2 - 1980*D1**2*f*gdd2*r**2 - 8712*D1**2*f*gdd2*r*s + 3960*D1**2*f*gdd2*r - 6732*D1**2*f*gdd2*s**2 + 8712*D1**2*f*gdd2*s - 1980*D1**2*f*gdd2 + 6600*D1**2*fd**2*r**2 + 11352*D1**2*fd**2*r*s - 6336*D1**2*fd**2*r + 4752*D1**2*fd**2*s**2 - 5412*D1**2*fd**2*s - 3300*D1**2*fd**2 + 1650*D1**2*fd*g2*r**2 + 9108*D1**2*fd*g2*r*s - 3300*D1**2*fd*g2*r + 7458*D1**2*fd*g2*s**2 - 3300*D1**2*fd*g2*s + 1650*D1**2*fd*g2 - 3960*D1**2*fd*gd2*r**2 - 17424*D1**2*fd*gd2*r*s + 7920*D1**2*fd*gd2*r - 13464*D1**2*fd*gd2*s**2 + 12672*D1**2*fd*gd2*s - 3960*D1**2*fd*gd2 - 1980*D1**2*fdd*g2*r**2 - 8712*D1**2*fdd*g2*r*s + 3960*D1**2*fdd*g2*r - 6732*D1**2*fdd*g2*s**2 + 3960*D1**2*fdd*g2*s - 1980*D1**2*fdd*g2 + 4488*D1*Dd*K*f**2*r**2 + 24816*D1*Dd*K*f**2*r*s - 10692*D1*Dd*K*f**2*r + 20328*D1*Dd*K*f**2*s**2 - 22572*D1*Dd*K*f**2*s + 7326*D1*Dd*K*f**2 - 26400*D1*Dd*K*f*fd*r**2 - 90816*D1*Dd*K*f*fd*r*s + 47256*D1*Dd*K*f*fd*r - 64416*D1*Dd*K*f*fd*s**2 + 71016*D1*Dd*K*f*fd*s - 19404*D1*Dd*K*f*fd - 16100*D1*Dd*f**3*r**2 - 41160*D1*Dd*f**3*r*s + 26390*D1*Dd*f**3*r - 25060*D1*Dd*f**3*s**2 + 33110*D1*Dd*f**3*s - 14315*D1*Dd*f**3 + 117600*D1*Dd*f**2*fd*r**2 + 262080*D1*Dd*f**2*fd*r*s - 177800*D1*Dd*f**2*fd*r + 144480*D1*Dd*f**2*fd*s**2 - 196840*D1*Dd*f**2*fd*s + 66920*D1*Dd*f**2*fd - 9768*D1*Dd*f**2*r**2 - 18480*D1*Dd*f**2*r*s + 14388*D1*Dd*f**2*r - 8712*D1*Dd*f**2*s**2 + 13596*D1*Dd*f**2*s - 7062*D1*Dd*f**2 + 52800*D1*Dd*f*fd*r**2 + 90816*D1*Dd*f*fd*r*s - 63096*D1*Dd*f*fd*r + 38016*D1*Dd*f*fd*s**2 - 53856*D1*Dd*f*fd*s + 18084*D1*Dd*f*fd + 6600*D1*Dd*f*g2*r**2 + 36432*D1*Dd*f*g2*r*s - 15708*D1*Dd*f*g2*r + 29832*D1*Dd*f*g2*s**2 - 33132*D1*Dd*f*g2*s + 10758*D1*Dd*f*g2 - 15840*D1*Dd*f*gd2*r**2 - 69696*D1*Dd*f*gd2*r*s + 32472*D1*Dd*f*gd2*r - 53856*D1*Dd*f*gd2*s**2 + 65736*D1*Dd*f*gd2*s - 16632*D1*Dd*f*gd2 - 15840*D1*Dd*fd*g2*r**2 - 69696*D1*Dd*fd*g2*r*s + 32472*D1*Dd*fd*g2*r - 53856*D1*Dd*fd*g2*s**2 + 46728*D1*Dd*fd*g2*s - 11880*D1*Dd*fd*g2 - 6600*D1*Ddd*K*f**2*r**2 - 22704*D1*Ddd*K*f**2*r*s + 12276*D1*Ddd*K*f**2*r - 16104*D1*Ddd*K*f**2*s**2 + 19404*D1*Ddd*K*f**2*s - 7326*D1*Ddd*K*f**2 + 19600*D1*Ddd*f**3*r**2 + 43680*D1*Ddd*f**3*r*s - 30520*D1*Ddd*f**3*r + 24080*D1*Ddd*f**3*s**2 - 33880*D1*Ddd*f**3*s + 15820*D1*Ddd*f**3 + 13200*D1*Ddd*f**2*r**2 + 22704*D1*Ddd*f**2*r*s - 18876*D1*Ddd*f**2*r + 9504*D1*Ddd*f**2*s**2 - 16104*D1*Ddd*f**2*s + 8976*D1*Ddd*f**2 - 7920*D1*Ddd*f*g2*r**2 - 34848*D1*Ddd*f*g2*r*s + 16632*D1*Ddd*f*g2*r - 26928*D1*Ddd*f*g2*s**2 + 30888*D1*Ddd*f*g2*s - 10692*D1*Ddd*f*g2 - 33*D1*bd1*(K - 1)*(D1*(f*(50*r**2 + 138*r*(2*s - 1) + 226*s**2 - 314*s + 113) - 12*fd*(10*r**2 + r*(44*s - 21) + 34*s**2 - 33*s + 5)) - 12*Dd*f*(40*r**2 + 2*r*(88*s - 43) + 136*s**2 - 170*s + 45)) - 19800*Dd**2*K*f**2*r**2 - 68112*Dd**2*K*f**2*r*s + 36828*Dd**2*K*f**2*r - 48312*Dd**2*K*f**2*s**2 + 58212*Dd**2*K*f**2*s - 14652*Dd**2*K*f**2 + 58800*Dd**2*f**3*r**2 + 131040*Dd**2*f**3*r*s - 91560*Dd**2*f**3*r + 72240*Dd**2*f**3*s**2 - 101640*Dd**2*f**3*s + 31640*Dd**2*f**3 + 39600*Dd**2*f**2*r**2 + 68112*Dd**2*f**2*r*s - 56628*Dd**2*f**2*r + 28512*Dd**2*f**2*s**2 - 48312*Dd**2*f**2*s + 17952*Dd**2*f**2 - 23760*Dd**2*f*g2*r**2 - 104544*Dd**2*f*g2*r*s + 49896*Dd**2*f*g2*r - 80784*Dd**2*f*g2*s**2 + 92664*Dd**2*f*g2*s - 21384*Dd**2*f*g2))/(693*d**2*k3**5) + 8*D1**2*Pk2*Pkd3*ct**4*k1**4*(D1**2*b1*(5*f**2*(23*fd - 28*fdd)*(r*(6*s - 2) + 6*s**2 - 7*s + 2) + f*(-140*fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3) + 132*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 165*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) - 165*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*b1*f*(2*Dd*(115*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-70*fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 165*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(56*f + 33)*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*bd1*f*(D1*(f*s*(115*f*(2*r + 2*s - 1) + 132*r + 132*s - 132) - 5*fd*(28*f*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2)) - 5*Dd*f*(28*f*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 264*r*s - 33*r + 264*s**2 - 264*s + 33)) - 5*Dd**2*b1*f**2*(56*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - 5*f*(D1**2*(28*bdd1*f**2*s*(2*r + 2*s - 1) + f*(33*bdd1*s*(r + s - 1) - 23*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(-23*f*(r*(4*s - 1) + (1 - 2*s)**2) + 28*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 28*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 28*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k2**2*k3**3) + D1**2*Pk2*Pkd3*ct**4*k1**2*k2**4*st**2*(-396*C*D1**2*bdd1*f**2*r**2 - 792*C*D1**2*bdd1*f**2*r*s + 792*C*D1**2*bdd1*f**2*r - 396*C*D1**2*bdd1*f**2*s**2 + 792*C*D1**2*bdd1*f**2*s - 396*C*D1**2*bdd1*f**2 + 18060*C*D1**2*f**2*fd*r**2 + 36120*C*D1**2*f**2*fd*r*s - 24080*C*D1**2*f**2*fd*r + 18060*C*D1**2*f**2*fd*s**2 - 24080*C*D1**2*f**2*fd*s + 12040*C*D1**2*f**2*fd - 12000*C*D1**2*f**2*fdd*r**2 - 24000*C*D1**2*f**2*fdd*r*s + 16000*C*D1**2*f**2*fdd*r - 12000*C*D1**2*f**2*fdd*s**2 + 16000*C*D1**2*f**2*fdd*s - 8000*C*D1**2*f**2*fdd - 24000*C*D1**2*f*fd**2*r**2 - 48000*C*D1**2*f*fd**2*r*s + 32000*C*D1**2*f*fd**2*r - 24000*C*D1**2*f*fd**2*s**2 + 32000*C*D1**2*f*fd**2*s - 8000*C*D1**2*f*fd**2 + 24080*C*D1*Dd*f**3*r**2 + 48160*C*D1*Dd*f**3*r*s - 36120*C*D1*Dd*f**3*r + 24080*C*D1*Dd*f**3*s**2 - 36120*C*D1*Dd*f**3*s + 18060*C*D1*Dd*f**3 - 96000*C*D1*Dd*f**2*fd*r**2 - 192000*C*D1*Dd*f**2*fd*r*s + 136000*C*D1*Dd*f**2*fd*r - 96000*C*D1*Dd*f**2*fd*s**2 + 136000*C*D1*Dd*f**2*fd*s - 48000*C*D1*Dd*f**2*fd - 16000*C*D1*Ddd*f**3*r**2 - 32000*C*D1*Ddd*f**3*r*s + 24000*C*D1*Ddd*f**3*r - 16000*C*D1*Ddd*f**3*s**2 + 24000*C*D1*Ddd*f**3*s - 12000*C*D1*Ddd*f**3 - 48000*C*Dd**2*f**3*r**2 - 96000*C*Dd**2*f**3*r*s + 72000*C*Dd**2*f**3*r - 48000*C*Dd**2*f**3*s**2 + 72000*C*Dd**2*f**3*s - 24000*C*Dd**2*f**3 - 2640*D1**2*K*bdd1*f**2*r**2 - 5280*D1**2*K*bdd1*f**2*r*s + 5280*D1**2*K*bdd1*f**2*r - 2640*D1**2*K*bdd1*f**2*s**2 + 5280*D1**2*K*bdd1*f**2*s - 2640*D1**2*K*bdd1*f**2 - 396*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 1500*D1**2*bdd1*f**3*r**2 + 3000*D1**2*bdd1*f**3*r*s - 3000*D1**2*bdd1*f**3*r + 1500*D1**2*bdd1*f**3*s**2 - 3000*D1**2*bdd1*f**3*s + 1500*D1**2*bdd1*f**3 + 1716*D1**2*bdd1*f**2*r**2 + 3432*D1**2*bdd1*f**2*r*s - 3432*D1**2*bdd1*f**2*r + 1716*D1**2*bdd1*f**2*s**2 - 3432*D1**2*bdd1*f**2*s + 1716*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r**2 + 792*D1**2*bdd1*f*g2*r*s - 792*D1**2*bdd1*f*g2*r + 396*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 1500*D1**2*f**3*fd*r**2 - 3000*D1**2*f**3*fd*r*s + 2250*D1**2*f**3*fd*r - 1500*D1**2*f**3*fd*s**2 + 2250*D1**2*f**3*fd*s - 1125*D1**2*f**3*fd - 13248*D1**2*f**2*fd*r**2 - 26496*D1**2*f**2*fd*r*s + 17664*D1**2*f**2*fd*r - 13248*D1**2*f**2*fd*s**2 + 17664*D1**2*f**2*fd*s - 8832*D1**2*f**2*fd + 9000*D1**2*f**2*fdd*r**2 + 18000*D1**2*f**2*fdd*r*s - 12000*D1**2*f**2*fdd*r + 9000*D1**2*f**2*fdd*s**2 - 12000*D1**2*f**2*fdd*s + 6000*D1**2*f**2*fdd - 8580*D1**2*f**2*gd2*r**2 - 17160*D1**2*f**2*gd2*r*s + 17160*D1**2*f**2*gd2*r - 8580*D1**2*f**2*gd2*s**2 + 17160*D1**2*f**2*gd2*s - 8580*D1**2*f**2*gd2 + 5280*D1**2*f**2*gdd2*r**2 + 10560*D1**2*f**2*gdd2*r*s - 10560*D1**2*f**2*gdd2*r + 5280*D1**2*f**2*gdd2*s**2 - 10560*D1**2*f**2*gdd2*s + 5280*D1**2*f**2*gdd2 + 18000*D1**2*f*fd**2*r**2 + 36000*D1**2*f*fd**2*r*s - 24000*D1**2*f*fd**2*r + 18000*D1**2*f*fd**2*s**2 - 24000*D1**2*f*fd**2*s + 6000*D1**2*f*fd**2 - 17160*D1**2*f*fd*g2*r**2 - 34320*D1**2*f*fd*g2*r*s + 17160*D1**2*f*fd*g2*r - 17160*D1**2*f*fd*g2*s**2 + 17160*D1**2*f*fd*g2*s - 8580*D1**2*f*fd*g2 + 21120*D1**2*f*fd*gd2*r**2 + 42240*D1**2*f*fd*gd2*r*s - 31680*D1**2*f*fd*gd2*r + 21120*D1**2*f*fd*gd2*s**2 - 31680*D1**2*f*fd*gd2*s + 10560*D1**2*f*fd*gd2 + 10560*D1**2*f*fdd*g2*r**2 + 21120*D1**2*f*fdd*g2*r*s - 10560*D1**2*f*fdd*g2*r + 10560*D1**2*f*fdd*g2*s**2 - 10560*D1**2*f*fdd*g2*s + 5280*D1**2*f*fdd*g2 + 10560*D1**2*fd**2*g2*r**2 + 21120*D1**2*fd**2*g2*r*s - 10560*D1**2*fd**2*g2*r + 10560*D1**2*fd**2*g2*s**2 - 10560*D1**2*fd**2*g2*s - 1500*D1*Dd*f**4*r**2 - 3000*D1*Dd*f**4*r*s + 2250*D1*Dd*f**4*r - 1500*D1*Dd*f**4*s**2 + 2250*D1*Dd*f**4*s - 1125*D1*Dd*f**4 - 17664*D1*Dd*f**3*r**2 - 35328*D1*Dd*f**3*r*s + 26496*D1*Dd*f**3*r - 17664*D1*Dd*f**3*s**2 + 26496*D1*Dd*f**3*s - 13248*D1*Dd*f**3 + 72000*D1*Dd*f**2*fd*r**2 + 144000*D1*Dd*f**2*fd*r*s - 102000*D1*Dd*f**2*fd*r + 72000*D1*Dd*f**2*fd*s**2 - 102000*D1*Dd*f**2*fd*s + 36000*D1*Dd*f**2*fd - 34320*D1*Dd*f**2*g2*r**2 - 68640*D1*Dd*f**2*g2*r*s + 51480*D1*Dd*f**2*g2*r - 34320*D1*Dd*f**2*g2*s**2 + 51480*D1*Dd*f**2*g2*s - 25740*D1*Dd*f**2*g2 + 42240*D1*Dd*f**2*gd2*r**2 + 84480*D1*Dd*f**2*gd2*r*s - 73920*D1*Dd*f**2*gd2*r + 42240*D1*Dd*f**2*gd2*s**2 - 73920*D1*Dd*f**2*gd2*s + 31680*D1*Dd*f**2*gd2 + 84480*D1*Dd*f*fd*g2*r**2 + 168960*D1*Dd*f*fd*g2*r*s - 105600*D1*Dd*f*fd*g2*r + 84480*D1*Dd*f*fd*g2*s**2 - 105600*D1*Dd*f*fd*g2*s + 31680*D1*Dd*f*fd*g2 + 12000*D1*Ddd*f**3*r**2 + 24000*D1*Ddd*f**3*r*s - 18000*D1*Ddd*f**3*r + 12000*D1*Ddd*f**3*s**2 - 18000*D1*Ddd*f**3*s + 9000*D1*Ddd*f**3 + 21120*D1*Ddd*f**2*g2*r**2 + 42240*D1*Ddd*f**2*g2*r*s - 31680*D1*Ddd*f**2*g2*r + 21120*D1*Ddd*f**2*g2*s**2 - 31680*D1*Ddd*f**2*g2*s + 15840*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(390*f**3*(r + s - 1) - f**2*(132*C*(r + s - 1) + 500*fd*(3*r + 3*s - 2) + (715*K - 473)*(r + s - 1)) + 44*f*(fd*(3*C + 20*K - 13)*(2*r + 2*s - 1) + (3*g2 - 3*gd2)*(r + s - 1)) - 132*fd*g2*(r + s)) - 4*Dd*f*(125*f**2 - 11*f*(3*C + 20*K - 13) + 33*g2)*(4*r + 4*s - 3))*(r + s - 1) + 36000*Dd**2*f**3*r**2 + 72000*Dd**2*f**3*r*s - 54000*Dd**2*f**3*r + 36000*Dd**2*f**3*s**2 - 54000*Dd**2*f**3*s + 18000*Dd**2*f**3 + 63360*Dd**2*f**2*g2*r**2 + 126720*Dd**2*f**2*g2*r*s - 95040*Dd**2*f**2*g2*r + 63360*Dd**2*f**2*g2*s**2 - 95040*Dd**2*f**2*g2*s + 31680*Dd**2*f**2*g2 + 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*b1*(264*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s - 264*C*D1**2*f*fd*r + 264*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s + 132*C*D1**2*f*fd - 132*C*D1**2*f*fdd*r**2 - 264*C*D1**2*f*fdd*r*s + 132*C*D1**2*f*fdd*r - 132*C*D1**2*f*fdd*s**2 + 132*C*D1**2*f*fdd*s - 66*C*D1**2*f*fdd - 132*C*D1**2*fd**2*r**2 - 264*C*D1**2*fd**2*r*s + 132*C*D1**2*fd**2*r - 132*C*D1**2*fd**2*s**2 + 132*C*D1**2*fd**2*s + 528*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 792*C*D1*Dd*f**2*r + 528*C*D1*Dd*f**2*s**2 - 792*C*D1*Dd*f**2*s + 396*C*D1*Dd*f**2 - 1056*C*D1*Dd*f*fd*r**2 - 2112*C*D1*Dd*f*fd*r*s + 1320*C*D1*Dd*f*fd*r - 1056*C*D1*Dd*f*fd*s**2 + 1320*C*D1*Dd*f*fd*s - 396*C*D1*Dd*f*fd - 264*C*D1*Ddd*f**2*r**2 - 528*C*D1*Ddd*f**2*r*s + 396*C*D1*Ddd*f**2*r - 264*C*D1*Ddd*f**2*s**2 + 396*C*D1*Ddd*f**2*s - 198*C*D1*Ddd*f**2 - 792*C*Dd**2*f**2*r**2 - 1584*C*Dd**2*f**2*r*s + 1188*C*Dd**2*f**2*r - 792*C*Dd**2*f**2*s**2 + 1188*C*Dd**2*f**2*s - 396*C*Dd**2*f**2 + 1430*D1**2*K*f*fd*r**2 + 2860*D1**2*K*f*fd*r*s - 1430*D1**2*K*f*fd*r + 1430*D1**2*K*f*fd*s**2 - 1430*D1**2*K*f*fd*s + 715*D1**2*K*f*fd - 880*D1**2*K*f*fdd*r**2 - 1760*D1**2*K*f*fdd*r*s + 880*D1**2*K*f*fdd*r - 880*D1**2*K*f*fdd*s**2 + 880*D1**2*K*f*fdd*s - 440*D1**2*K*f*fdd - 880*D1**2*K*fd**2*r**2 - 1760*D1**2*K*fd**2*r*s + 880*D1**2*K*fd**2*r - 880*D1**2*K*fd**2*s**2 + 880*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 1170*D1**2*f**2*fd*r**2 - 2340*D1**2*f**2*fd*r*s + 1560*D1**2*f**2*fd*r - 1170*D1**2*f**2*fd*s**2 + 1560*D1**2*f**2*fd*s - 780*D1**2*f**2*fd + 750*D1**2*f**2*fdd*r**2 + 1500*D1**2*f**2*fdd*r*s - 1000*D1**2*f**2*fdd*r + 750*D1**2*f**2*fdd*s**2 - 1000*D1**2*f**2*fdd*s + 500*D1**2*f**2*fdd + 1500*D1**2*f*fd**2*r**2 + 3000*D1**2*f*fd**2*r*s - 2000*D1**2*f*fd**2*r + 1500*D1**2*f*fd**2*s**2 - 2000*D1**2*f*fd**2*s + 500*D1**2*f*fd**2 - 946*D1**2*f*fd*r**2 - 1892*D1**2*f*fd*r*s + 946*D1**2*f*fd*r - 946*D1**2*f*fd*s**2 + 946*D1**2*f*fd*s - 473*D1**2*f*fd + 572*D1**2*f*fdd*r**2 + 1144*D1**2*f*fdd*r*s - 572*D1**2*f*fdd*r + 572*D1**2*f*fdd*s**2 - 572*D1**2*f*fdd*s + 286*D1**2*f*fdd - 132*D1**2*f*gd2*r**2 - 264*D1**2*f*gd2*r*s + 264*D1**2*f*gd2*r - 132*D1**2*f*gd2*s**2 + 264*D1**2*f*gd2*s - 132*D1**2*f*gd2 + 66*D1**2*f*gdd2*r**2 + 132*D1**2*f*gdd2*r*s - 132*D1**2*f*gdd2*r + 66*D1**2*f*gdd2*s**2 - 132*D1**2*f*gdd2*s + 66*D1**2*f*gdd2 + 572*D1**2*fd**2*r**2 + 1144*D1**2*fd**2*r*s - 572*D1**2*fd**2*r + 572*D1**2*fd**2*s**2 - 572*D1**2*fd**2*s - 132*D1**2*fd*g2*r**2 - 264*D1**2*fd*g2*r*s - 132*D1**2*fd*g2*s**2 + 132*D1**2*fd*gd2*r**2 + 264*D1**2*fd*gd2*r*s - 132*D1**2*fd*gd2*r + 132*D1**2*fd*gd2*s**2 - 132*D1**2*fd*gd2*s + 66*D1**2*fdd*g2*r**2 + 132*D1**2*fdd*g2*r*s + 66*D1**2*fdd*g2*s**2 + 2860*D1*Dd*K*f**2*r**2 + 5720*D1*Dd*K*f**2*r*s - 4290*D1*Dd*K*f**2*r + 2860*D1*Dd*K*f**2*s**2 - 4290*D1*Dd*K*f**2*s + 2145*D1*Dd*K*f**2 - 7040*D1*Dd*K*f*fd*r**2 - 14080*D1*Dd*K*f*fd*r*s + 8800*D1*Dd*K*f*fd*r - 7040*D1*Dd*K*f*fd*s**2 + 8800*D1*Dd*K*f*fd*s - 2640*D1*Dd*K*f*fd - 1560*D1*Dd*f**3*r**2 - 3120*D1*Dd*f**3*r*s + 2340*D1*Dd*f**3*r - 1560*D1*Dd*f**3*s**2 + 2340*D1*Dd*f**3*s - 1170*D1*Dd*f**3 + 6000*D1*Dd*f**2*fd*r**2 + 12000*D1*Dd*f**2*fd*r*s - 8500*D1*Dd*f**2*fd*r + 6000*D1*Dd*f**2*fd*s**2 - 8500*D1*Dd*f**2*fd*s + 3000*D1*Dd*f**2*fd - 1892*D1*Dd*f**2*r**2 - 3784*D1*Dd*f**2*r*s + 2838*D1*Dd*f**2*r - 1892*D1*Dd*f**2*s**2 + 2838*D1*Dd*f**2*s - 1419*D1*Dd*f**2 + 4576*D1*Dd*f*fd*r**2 + 9152*D1*Dd*f*fd*r*s - 5720*D1*Dd*f*fd*r + 4576*D1*Dd*f*fd*s**2 - 5720*D1*Dd*f*fd*s + 1716*D1*Dd*f*fd - 528*D1*Dd*f*g2*r**2 - 1056*D1*Dd*f*g2*r*s + 792*D1*Dd*f*g2*r - 528*D1*Dd*f*g2*s**2 + 792*D1*Dd*f*g2*s - 396*D1*Dd*f*g2 + 528*D1*Dd*f*gd2*r**2 + 1056*D1*Dd*f*gd2*r*s - 924*D1*Dd*f*gd2*r + 528*D1*Dd*f*gd2*s**2 - 924*D1*Dd*f*gd2*s + 396*D1*Dd*f*gd2 + 528*D1*Dd*fd*g2*r**2 + 1056*D1*Dd*fd*g2*r*s - 396*D1*Dd*fd*g2*r + 528*D1*Dd*fd*g2*s**2 - 396*D1*Dd*fd*g2*s - 1760*D1*Ddd*K*f**2*r**2 - 3520*D1*Ddd*K*f**2*r*s + 2640*D1*Ddd*K*f**2*r - 1760*D1*Ddd*K*f**2*s**2 + 2640*D1*Ddd*K*f**2*s - 1320*D1*Ddd*K*f**2 + 1000*D1*Ddd*f**3*r**2 + 2000*D1*Ddd*f**3*r*s - 1500*D1*Ddd*f**3*r + 1000*D1*Ddd*f**3*s**2 - 1500*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 + 1144*D1*Ddd*f**2*r**2 + 2288*D1*Ddd*f**2*r*s - 1716*D1*Ddd*f**2*r + 1144*D1*Ddd*f**2*s**2 - 1716*D1*Ddd*f**2*s + 858*D1*Ddd*f**2 + 264*D1*Ddd*f*g2*r**2 + 528*D1*Ddd*f*g2*r*s - 396*D1*Ddd*f*g2*r + 264*D1*Ddd*f*g2*s**2 - 396*D1*Ddd*f*g2*s + 198*D1*Ddd*f*g2 + 132*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 5280*Dd**2*K*f**2*r**2 - 10560*Dd**2*K*f**2*r*s + 7920*Dd**2*K*f**2*r - 5280*Dd**2*K*f**2*s**2 + 7920*Dd**2*K*f**2*s - 2640*Dd**2*K*f**2 + 3000*Dd**2*f**3*r**2 + 6000*Dd**2*f**3*r*s - 4500*Dd**2*f**3*r + 3000*Dd**2*f**3*s**2 - 4500*Dd**2*f**3*s + 1500*Dd**2*f**3 + 3432*Dd**2*f**2*r**2 + 6864*Dd**2*f**2*r*s - 5148*Dd**2*f**2*r + 3432*Dd**2*f**2*s**2 - 5148*Dd**2*f**2*s + 1716*Dd**2*f**2 + 792*Dd**2*f*g2*r**2 + 1584*Dd**2*f*g2*r*s - 1188*Dd**2*f*g2*r + 792*Dd**2*f*g2*s**2 - 1188*Dd**2*f*g2*s + 396*Dd**2*f*g2))/(154*d**2*k3**7) - 3*D1**2*Pk2*Pkd3*ct**4*k1**2*k2**4*(880*C*D1**2*bdd1*f**2*r**2 + 1760*C*D1**2*bdd1*f**2*r*s - 1760*C*D1**2*bdd1*f**2*r + 880*C*D1**2*bdd1*f**2*s**2 - 1760*C*D1**2*bdd1*f**2*s + 880*C*D1**2*bdd1*f**2 - 390*C*D1**2*f**2*fd*r**2 - 780*C*D1**2*f**2*fd*r*s + 520*C*D1**2*f**2*fd*r - 390*C*D1**2*f**2*fd*s**2 + 520*C*D1**2*f**2*fd*s - 260*C*D1**2*f**2*fd + 1680*C*D1**2*f**2*fdd*r**2 + 3360*C*D1**2*f**2*fdd*r*s - 2240*C*D1**2*f**2*fdd*r + 1680*C*D1**2*f**2*fdd*s**2 - 2240*C*D1**2*f**2*fdd*s + 1120*C*D1**2*f**2*fdd + 3360*C*D1**2*f*fd**2*r**2 + 6720*C*D1**2*f*fd**2*r*s - 4480*C*D1**2*f*fd**2*r + 3360*C*D1**2*f*fd**2*s**2 - 4480*C*D1**2*f*fd**2*s + 1120*C*D1**2*f*fd**2 - 520*C*D1*Dd*f**3*r**2 - 1040*C*D1*Dd*f**3*r*s + 780*C*D1*Dd*f**3*r - 520*C*D1*Dd*f**3*s**2 + 780*C*D1*Dd*f**3*s - 390*C*D1*Dd*f**3 + 13440*C*D1*Dd*f**2*fd*r**2 + 26880*C*D1*Dd*f**2*fd*r*s - 19040*C*D1*Dd*f**2*fd*r + 13440*C*D1*Dd*f**2*fd*s**2 - 19040*C*D1*Dd*f**2*fd*s + 6720*C*D1*Dd*f**2*fd + 2240*C*D1*Ddd*f**3*r**2 + 4480*C*D1*Ddd*f**3*r*s - 3360*C*D1*Ddd*f**3*r + 2240*C*D1*Ddd*f**3*s**2 - 3360*C*D1*Ddd*f**3*s + 1680*C*D1*Ddd*f**3 + 6720*C*Dd**2*f**3*r**2 + 13440*C*Dd**2*f**3*r*s - 10080*C*Dd**2*f**3*r + 6720*C*Dd**2*f**3*s**2 - 10080*C*Dd**2*f**3*s + 3360*C*Dd**2*f**3 + 330*D1**2*K*bdd1*f**2*r**2 + 660*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*r + 330*D1**2*K*bdd1*f**2*s**2 - 660*D1**2*K*bdd1*f**2*s + 330*D1**2*K*bdd1*f**2 - 22*D1**2*bd1**2*f*(-48*K + 25*f + 24)*(r + s - 1)**2 - 660*D1**2*bdd1*f**2*r**2 - 1320*D1**2*bdd1*f**2*r*s + 1320*D1**2*bdd1*f**2*r - 660*D1**2*bdd1*f**2*s**2 + 1320*D1**2*bdd1*f**2*s - 660*D1**2*bdd1*f**2 - 1056*D1**2*bdd1*f*g2*r**2 - 2112*D1**2*bdd1*f*g2*r*s + 2112*D1**2*bdd1*f*g2*r - 1056*D1**2*bdd1*f*g2*s**2 + 2112*D1**2*bdd1*f*g2*s - 1056*D1**2*bdd1*f*g2 - 135*D1**2*f**2*fd*r**2 - 270*D1**2*f**2*fd*r*s + 180*D1**2*f**2*fd*r - 135*D1**2*f**2*fd*s**2 + 180*D1**2*f**2*fd*s - 90*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 - 1680*D1**2*f**2*fdd*r*s + 1120*D1**2*f**2*fdd*r - 840*D1**2*f**2*fdd*s**2 + 1120*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd + 132*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*r + 132*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gd2 - 660*D1**2*f**2*gdd2*r**2 - 1320*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*r - 660*D1**2*f**2*gdd2*s**2 + 1320*D1**2*f**2*gdd2*s - 660*D1**2*f**2*gdd2 - 1680*D1**2*f*fd**2*r**2 - 3360*D1**2*f*fd**2*r*s + 2240*D1**2*f*fd**2*r - 1680*D1**2*f*fd**2*s**2 + 2240*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 + 264*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r**2 - 5280*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r - 2640*D1**2*f*fd*gd2*s**2 + 3960*D1**2*f*fd*gd2*s - 1320*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r**2 - 2640*D1**2*f*fdd*g2*r*s + 1320*D1**2*f*fdd*g2*r - 1320*D1**2*f*fdd*g2*s**2 + 1320*D1**2*f*fdd*g2*s - 660*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r**2 - 2640*D1**2*fd**2*g2*r*s + 1320*D1**2*fd**2*g2*r - 1320*D1**2*fd**2*g2*s**2 + 1320*D1**2*fd**2*g2*s - 180*D1*Dd*f**3*r**2 - 360*D1*Dd*f**3*r*s + 270*D1*Dd*f**3*r - 180*D1*Dd*f**3*s**2 + 270*D1*Dd*f**3*s - 135*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 - 13440*D1*Dd*f**2*fd*r*s + 9520*D1*Dd*f**2*fd*r - 6720*D1*Dd*f**2*fd*s**2 + 9520*D1*Dd*f**2*fd*s - 3360*D1*Dd*f**2*fd + 528*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 396*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r**2 - 10560*D1*Dd*f**2*gd2*r*s + 9240*D1*Dd*f**2*gd2*r - 5280*D1*Dd*f**2*gd2*s**2 + 9240*D1*Dd*f**2*gd2*s - 3960*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r**2 - 21120*D1*Dd*f*fd*g2*r*s + 13200*D1*Dd*f*fd*g2*r - 10560*D1*Dd*f*fd*g2*s**2 + 13200*D1*Dd*f*fd*g2*s - 3960*D1*Dd*f*fd*g2 - 1120*D1*Ddd*f**3*r**2 - 2240*D1*Ddd*f**3*r*s + 1680*D1*Ddd*f**3*r - 1120*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 840*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r**2 - 5280*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r - 2640*D1*Ddd*f**2*g2*s**2 + 3960*D1*Ddd*f**2*g2*s - 1980*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(50*C + 3*K - 30)*(r + s - 1) - 10*f*fd*(8*C + 3*K - 6)*(2*r + 2*s - 1) - f*(61*g2 - 96*gd2)*(r + s - 1) + 96*fd*g2*(r + s)) - 2*Dd*f*(5*f*(8*C + 3*K - 6) - 48*g2)*(4*r + 4*s - 3))*(r + s - 1) - 3360*Dd**2*f**3*r**2 - 6720*Dd**2*f**3*r*s + 5040*Dd**2*f**3*r - 3360*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 1680*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r**2 - 15840*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r - 7920*Dd**2*f**2*g2*s**2 + 11880*Dd**2*f**2*g2*s - 3960*Dd**2*f**2*g2 + 11*b1**2*(D1**2*(f*(38*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + fd*(61*K - 27)*(r + s) - 24*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(38*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(50*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (61*K - 27)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 48*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-48*K + 25*f + 24)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-48*K + 25*f + 24)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*(-100*C*D1**2*f*fd*r**2 - 200*C*D1**2*f*fd*r*s + 100*C*D1**2*f*fd*r - 100*C*D1**2*f*fd*s**2 + 100*C*D1**2*f*fd*s - 50*C*D1**2*f*fd + 80*C*D1**2*f*fdd*r**2 + 160*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 - 80*C*D1**2*f*fdd*s + 40*C*D1**2*f*fdd + 80*C*D1**2*fd**2*r**2 + 160*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 - 80*C*D1**2*fd**2*s - 200*C*D1*Dd*f**2*r**2 - 400*C*D1*Dd*f**2*r*s + 300*C*D1*Dd*f**2*r - 200*C*D1*Dd*f**2*s**2 + 300*C*D1*Dd*f**2*s - 150*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*r**2 + 1280*C*D1*Dd*f*fd*r*s - 800*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 800*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r**2 + 320*C*D1*Ddd*f**2*r*s - 240*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 240*C*D1*Ddd*f**2*s + 120*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r**2 + 960*C*Dd**2*f**2*r*s - 720*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 720*C*Dd**2*f**2*s + 240*C*Dd**2*f**2 - 6*D1**2*K*f*fd*r**2 - 12*D1**2*K*f*fd*r*s + 6*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 + 60*D1**2*K*f*fdd*r*s - 30*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 + 60*D1**2*K*fd**2*r*s - 30*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(-48*K + 25*f + 24)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 60*D1**2*f*fd*r**2 + 120*D1**2*f*fd*r*s - 60*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 60*D1**2*f*fd*s + 30*D1**2*f*fd - 60*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 60*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s - 30*D1**2*f*fdd + 61*D1**2*f*gd2*r**2 + 122*D1**2*f*gd2*r*s - 122*D1**2*f*gd2*r + 61*D1**2*f*gd2*s**2 - 122*D1**2*f*gd2*s + 61*D1**2*f*gd2 - 48*D1**2*f*gdd2*r**2 - 96*D1**2*f*gdd2*r*s + 96*D1**2*f*gdd2*r - 48*D1**2*f*gdd2*s**2 + 96*D1**2*f*gdd2*s - 48*D1**2*f*gdd2 - 60*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 60*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s + 61*D1**2*fd*g2*r**2 + 122*D1**2*fd*g2*r*s + 61*D1**2*fd*g2*s**2 - 96*D1**2*fd*gd2*r**2 - 192*D1**2*fd*gd2*r*s + 96*D1**2*fd*gd2*r - 96*D1**2*fd*gd2*s**2 + 96*D1**2*fd*gd2*s - 48*D1**2*fdd*g2*r**2 - 96*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*s**2 - 12*D1*Dd*K*f**2*r**2 - 24*D1*Dd*K*f**2*r*s + 18*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 18*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 + 480*D1*Dd*K*f*fd*r*s - 300*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 300*D1*Dd*K*f*fd*s + 90*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 120*D1*Dd*f**2*r**2 + 240*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 180*D1*Dd*f**2*s + 90*D1*Dd*f**2 - 480*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 600*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 600*D1*Dd*f*fd*s - 180*D1*Dd*f*fd + 244*D1*Dd*f*g2*r**2 + 488*D1*Dd*f*g2*r*s - 366*D1*Dd*f*g2*r + 244*D1*Dd*f*g2*s**2 - 366*D1*Dd*f*g2*s + 183*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r**2 - 768*D1*Dd*f*gd2*r*s + 672*D1*Dd*f*gd2*r - 384*D1*Dd*f*gd2*s**2 + 672*D1*Dd*f*gd2*s - 288*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r**2 - 768*D1*Dd*fd*g2*r*s + 288*D1*Dd*fd*g2*r - 384*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r**2 + 120*D1*Ddd*K*f**2*r*s - 90*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 90*D1*Ddd*K*f**2*s + 45*D1*Ddd*K*f**2 - 120*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 90*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r**2 - 384*D1*Ddd*f*g2*r*s + 288*D1*Ddd*f*g2*r - 192*D1*Ddd*f*g2*s**2 + 288*D1*Ddd*f*g2*s - 144*D1*Ddd*f*g2 + D1*bd1*(D1*(38*f**2*(r + s - 1) - 50*f*fd*(2*r + 2*s - 1) - f*(61*K - 27)*(r + s - 1) + 48*fd*(2*K - 1)*(r + s)) - 2*Dd*f*(-48*K + 25*f + 24)*(4*r + 4*s - 3))*(r + s - 1) + 180*Dd**2*K*f**2*r**2 + 360*Dd**2*K*f**2*r*s - 270*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 270*Dd**2*K*f**2*s + 90*Dd**2*K*f**2 - 360*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 540*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 180*Dd**2*f**2 - 576*Dd**2*f*g2*r**2 - 1152*Dd**2*f*g2*r*s + 864*Dd**2*f*g2*r - 576*Dd**2*f*g2*s**2 + 864*Dd**2*f*g2*s - 288*Dd**2*f*g2))/(77*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**4*k1**2*k2**2*st**2*(-1980*C*D1**2*bdd1*f**2*r**2 - 5544*C*D1**2*bdd1*f**2*r*s + 1584*C*D1**2*bdd1*f**2*r - 3564*C*D1**2*bdd1*f**2*s**2 + 3168*C*D1**2*bdd1*f**2*s - 1584*C*D1**2*bdd1*f**2 - 36972*C*D1**2*f**2*fd*r**2 + 456*C*D1**2*f**2*fd*r*s + 24496*C*D1**2*f**2*fd*r + 37428*C*D1**2*f**2*fd*s**2 - 25104*C*D1**2*f**2*fd*s + 152*C*D1**2*f**2*fd + 27396*C*D1**2*f**2*fdd*r**2 + 8088*C*D1**2*f**2*fdd*r*s - 20960*C*D1**2*f**2*fdd*r - 19308*C*D1**2*f**2*fdd*s**2 + 10176*C*D1**2*f**2*fdd*s + 2696*C*D1**2*f**2*fdd + 54792*C*D1**2*f*fd**2*r**2 + 16176*C*D1**2*f*fd**2*r*s - 41920*C*D1**2*f*fd**2*r - 38616*C*D1**2*f*fd**2*s**2 + 20352*C*D1**2*f*fd**2*s + 2696*C*D1**2*f*fd**2 - 49296*C*D1*Dd*f**3*r**2 + 608*C*D1*Dd*f**3*r*s + 49144*C*D1*Dd*f**3*r + 49904*C*D1*Dd*f**3*s**2 - 25256*C*D1*Dd*f**3*s - 12172*C*D1*Dd*f**3 + 219168*C*D1*Dd*f**2*fd*r**2 + 64704*C*D1*Dd*f**2*fd*r*s - 201512*C*D1*Dd*f**2*fd*r - 154464*C*D1*Dd*f**2*fd*s**2 + 63144*C*D1*Dd*f**2*fd*s + 31744*C*D1*Dd*f**2*fd + 36528*C*D1*Ddd*f**3*r**2 + 10784*C*D1*Ddd*f**3*r*s - 39224*C*D1*Ddd*f**3*r - 25744*C*D1*Ddd*f**3*s**2 + 7480*C*D1*Ddd*f**3*s + 11828*C*D1*Ddd*f**3 + 109584*C*Dd**2*f**3*r**2 + 32352*C*Dd**2*f**3*r*s - 117672*C*Dd**2*f**3*r - 77232*C*Dd**2*f**3*s**2 + 22440*C*Dd**2*f**3*s + 23656*C*Dd**2*f**3 + 4950*D1**2*K*bdd1*f**2*r**2 + 132*D1**2*K*bdd1*f**2*r*s - 9900*D1**2*K*bdd1*f**2*r - 4818*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s + 4950*D1**2*K*bdd1*f**2 - 396*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2) - 9375*D1**2*bdd1*f**3*r**2 - 14250*D1**2*bdd1*f**3*r*s + 16500*D1**2*bdd1*f**3*r - 4875*D1**2*bdd1*f**3*s**2 + 12000*D1**2*bdd1*f**3*s - 9000*D1**2*bdd1*f**3 - 9570*D1**2*bdd1*f**2*r**2 - 11748*D1**2*bdd1*f**2*r*s + 21516*D1**2*bdd1*f**2*r - 2178*D1**2*bdd1*f**2*s**2 + 14124*D1**2*bdd1*f**2*s - 9966*D1**2*bdd1*f**2 + 1980*D1**2*bdd1*f*g2*r**2 + 5544*D1**2*bdd1*f*g2*r*s - 1584*D1**2*bdd1*f*g2*r + 3564*D1**2*bdd1*f*g2*s**2 - 3168*D1**2*bdd1*f*g2*s + 1584*D1**2*bdd1*f*g2 - 31500*D1**2*f**3*fd*r**2 - 60000*D1**2*f**3*fd*r*s + 46500*D1**2*f**3*fd*r - 28500*D1**2*f**3*fd*s**2 + 44250*D1**2*f**3*fd*s - 22875*D1**2*f**3*fd + 34500*D1**2*f**3*fdd*r**2 + 54000*D1**2*f**3*fdd*r*s - 48000*D1**2*f**3*fdd*r + 19500*D1**2*f**3*fdd*s**2 - 36750*D1**2*f**3*fdd*s + 22125*D1**2*f**3*fdd + 103500*D1**2*f**2*fd**2*r**2 + 162000*D1**2*f**2*fd**2*r*s - 144000*D1**2*f**2*fd**2*r + 58500*D1**2*f**2*fd**2*s**2 - 110250*D1**2*f**2*fd**2*s + 44250*D1**2*f**2*fd**2 + 61032*D1**2*f**2*fd*r**2 + 63288*D1**2*f**2*fd*r*s - 61784*D1**2*f**2*fd*r + 2256*D1**2*f**2*fd*s**2 - 22600*D1**2*f**2*fd*s + 21096*D1**2*f**2*fd - 42396*D1**2*f**2*fdd*r**2 - 47088*D1**2*f**2*fdd*r*s + 43960*D1**2*f**2*fdd*r - 4692*D1**2*f**2*fdd*s**2 + 18824*D1**2*f**2*fdd*s - 15696*D1**2*f**2*fdd + 15444*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s - 30888*D1**2*f**2*gd2*r - 18876*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s + 15444*D1**2*f**2*gd2 - 9900*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 19800*D1**2*f**2*gdd2*r + 9636*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 9900*D1**2*f**2*gdd2 - 84792*D1**2*f*fd**2*r**2 - 94176*D1**2*f*fd**2*r*s + 87920*D1**2*f*fd**2*r - 9384*D1**2*f*fd**2*s**2 + 37648*D1**2*f*fd**2*s - 15696*D1**2*f*fd**2 + 30888*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 37752*D1**2*f*fd*g2*s**2 + 37752*D1**2*f*fd*g2*s - 18876*D1**2*f*fd*g2 - 39600*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 39864*D1**2*f*fd*gd2*r + 38544*D1**2*f*fd*gd2*s**2 - 18744*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 19800*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r + 19272*D1**2*f*fdd*g2*s**2 - 19272*D1**2*f*fdd*g2*s + 9636*D1**2*f*fdd*g2 - 19800*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r + 19272*D1**2*fd**2*g2*s**2 - 19272*D1**2*fd**2*g2*s - 31500*D1*Dd*f**4*r**2 - 60000*D1*Dd*f**4*r*s + 46500*D1*Dd*f**4*r - 28500*D1*Dd*f**4*s**2 + 44250*D1*Dd*f**4*s - 22875*D1*Dd*f**4 + 276000*D1*Dd*f**3*fd*r**2 + 432000*D1*Dd*f**3*fd*r*s - 384000*D1*Dd*f**3*fd*r + 156000*D1*Dd*f**3*fd*s**2 - 294000*D1*Dd*f**3*fd*s + 132750*D1*Dd*f**3*fd + 81376*D1*Dd*f**3*r**2 + 84384*D1*Dd*f**3*r*s - 102472*D1*Dd*f**3*r + 3008*D1*Dd*f**3*s**2 - 43696*D1*Dd*f**3*s + 41440*D1*Dd*f**3 - 339168*D1*Dd*f**2*fd*r**2 - 376704*D1*Dd*f**2*fd*r*s + 392512*D1*Dd*f**2*fd*r - 37536*D1*Dd*f**2*fd*s**2 + 178856*D1*Dd*f**2*fd*s - 106744*D1*Dd*f**2*fd + 61776*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s - 58344*D1*Dd*f**2*g2*r - 75504*D1*Dd*f**2*g2*s**2 + 44616*D1*Dd*f**2*g2*s + 12012*D1*Dd*f**2*g2 - 79200*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 119064*D1*Dd*f**2*gd2*r + 77088*D1*Dd*f**2*gd2*s**2 - 17688*D1*Dd*f**2*gd2*s - 39864*D1*Dd*f**2*gd2 - 158400*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 80784*D1*Dd*f*fd*g2*r + 154176*D1*Dd*f*fd*g2*s**2 - 114576*D1*Dd*f*fd*g2*s + 18744*D1*Dd*f*fd*g2 + 34500*D1*Ddd*f**4*r**2 + 54000*D1*Ddd*f**4*r*s - 48000*D1*Ddd*f**4*r + 19500*D1*Ddd*f**4*s**2 - 36750*D1*Ddd*f**4*s + 22125*D1*Ddd*f**4 - 56528*D1*Ddd*f**3*r**2 - 62784*D1*Ddd*f**3*r*s + 72224*D1*Ddd*f**3*r - 6256*D1*Ddd*f**3*s**2 + 34520*D1*Ddd*f**3*s - 29828*D1*Ddd*f**3 - 39600*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 39864*D1*Ddd*f**2*g2*r + 38544*D1*Ddd*f**2*g2*s**2 - 18744*D1*Ddd*f**2*g2*s - 10164*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(5*f**3*(515*r**2 + r*(774*s - 880) + 259*s**2 - 624*s + 490) + f**2*(132*C*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) - 143*K*(9*r**2 - 2*r*(s + 9) - 11*s**2 + 2*s + 9) - 125*fd*(75*r**2 + r*(114*s - 113) + 39*s**2 - 83*s + 36) + 2497*r**2 + 2794*r*s - 5786*r + 297*s**2 - 3586*s + 2629) - 22*f*(fd*(12*C*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 10*s + 1) - K*(150*r**2 + 4*r*s - 151*r - 146*s**2 + 71*s + 1) + 290*r**2 + 356*r*s - 397*r + 66*s**2 - 229*s + 119) + 6*g2*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) - 6*gd2*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2)) + 132*fd*g2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9))) - Dd*f*(125*f**2*(100*r**2 + r*(152*s - 157) + 52*s**2 - 115*s + 60) + 22*f*(6*C*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8) - K*(300*r**2 + 8*r*s - 451*r - 292*s**2 + 67*s + 151) + 580*r**2 + 712*r*s - 1031*r + 132*s**2 - 639*s + 433) - 132*g2*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8))) + 103500*Dd**2*f**4*r**2 + 162000*Dd**2*f**4*r*s - 144000*Dd**2*f**4*r + 58500*Dd**2*f**4*s**2 - 110250*Dd**2*f**4*s + 44250*Dd**2*f**4 - 169584*Dd**2*f**3*r**2 - 188352*Dd**2*f**3*r*s + 216672*Dd**2*f**3*r - 18768*Dd**2*f**3*s**2 + 103560*Dd**2*f**3*s - 59656*Dd**2*f**3 - 118800*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 119592*Dd**2*f**2*g2*r + 115632*Dd**2*f**2*g2*s**2 - 56232*Dd**2*f**2*g2*s - 20328*Dd**2*f**2*g2 + 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + D1*(2*Dd*(f*(20*r**2 + 56*r*s - 34*r + 36*s**2 - 46*s + 19) - fd*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15)) - Ddd*f*(20*r**2 + r*(56*s - 34) + 36*s**2 - 46*s + 19)) - 2*Dd**2*f*(30*r**2 + r*(84*s - 51) + 54*s**2 - 69*s + 19)) + 3*b1*(2640*C*D1**2*f*fd*r**2 + 7392*C*D1**2*f*fd*r*s - 5280*C*D1**2*f*fd*r + 4752*C*D1**2*f*fd*s**2 - 6336*C*D1**2*f*fd*s + 2640*C*D1**2*f*fd - 1320*C*D1**2*f*fdd*r**2 - 3696*C*D1**2*f*fdd*r*s + 2640*C*D1**2*f*fdd*r - 2376*C*D1**2*f*fdd*s**2 + 3168*C*D1**2*f*fdd*s - 1320*C*D1**2*f*fdd - 1320*C*D1**2*fd**2*r**2 - 3696*C*D1**2*fd**2*r*s + 2640*C*D1**2*fd**2*r - 2376*C*D1**2*fd**2*s**2 + 3168*C*D1**2*fd**2*s - 1320*C*D1**2*fd**2 + 5280*C*D1*Dd*f**2*r**2 + 14784*C*D1*Dd*f**2*r*s - 8976*C*D1*Dd*f**2*r + 9504*C*D1*Dd*f**2*s**2 - 12144*C*D1*Dd*f**2*s + 5016*C*D1*Dd*f**2 - 10560*C*D1*Dd*f*fd*r**2 - 29568*C*D1*Dd*f*fd*r*s + 19536*C*D1*Dd*f*fd*r - 19008*C*D1*Dd*f*fd*s**2 + 24816*C*D1*Dd*f*fd*s - 8448*C*D1*Dd*f*fd - 2640*C*D1*Ddd*f**2*r**2 - 7392*C*D1*Ddd*f**2*r*s + 4488*C*D1*Ddd*f**2*r - 4752*C*D1*Ddd*f**2*s**2 + 6072*C*D1*Ddd*f**2*s - 2508*C*D1*Ddd*f**2 - 7920*C*Dd**2*f**2*r**2 - 22176*C*Dd**2*f**2*r*s + 13464*C*Dd**2*f**2*r - 14256*C*Dd**2*f**2*s**2 + 18216*C*Dd**2*f**2*s - 5016*C*Dd**2*f**2 - 5148*D1**2*K*f*fd*r**2 + 1144*D1**2*K*f*fd*r*s - 572*D1**2*K*f*fd*r + 6292*D1**2*K*f*fd*s**2 - 6292*D1**2*K*f*fd*s + 3146*D1**2*K*f*fd + 3300*D1**2*K*f*fdd*r**2 + 88*D1**2*K*f*fdd*r*s - 44*D1**2*K*f*fdd*r - 3212*D1**2*K*f*fdd*s**2 + 3212*D1**2*K*f*fdd*s - 1606*D1**2*K*f*fdd + 3300*D1**2*K*fd**2*r**2 + 88*D1**2*K*fd**2*r*s - 44*D1**2*K*fd**2*r - 3212*D1**2*K*fd**2*s**2 + 3212*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(K - 1)*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) + 15450*D1**2*f**2*fd*r**2 + 23220*D1**2*f**2*fd*r*s - 19540*D1**2*f**2*fd*r + 7770*D1**2*f**2*fd*s**2 - 14420*D1**2*f**2*fd*s + 7990*D1**2*f**2*fd - 9375*D1**2*f**2*fdd*r**2 - 14250*D1**2*f**2*fdd*r*s + 11750*D1**2*f**2*fdd*r - 4875*D1**2*f**2*fdd*s**2 + 8750*D1**2*f**2*fdd*s - 4875*D1**2*f**2*fdd - 18750*D1**2*f*fd**2*r**2 - 28500*D1**2*f*fd**2*r*s + 23500*D1**2*f*fd**2*r - 9750*D1**2*f*fd**2*s**2 + 17500*D1**2*f*fd**2*s - 6750*D1**2*f*fd**2 + 9988*D1**2*f*fd*r**2 + 11176*D1**2*f*fd*r*s - 4004*D1**2*f*fd*r + 1188*D1**2*f*fd*s**2 + 396*D1**2*f*fd*s + 330*D1**2*f*fd - 6380*D1**2*f*fdd*r**2 - 7832*D1**2*f*fdd*r*s + 3124*D1**2*f*fdd*r - 1452*D1**2*f*fdd*s**2 + 660*D1**2*f*fdd*s - 594*D1**2*f*fdd - 1320*D1**2*f*gd2*r**2 - 3696*D1**2*f*gd2*r*s + 2640*D1**2*f*gd2*r - 2376*D1**2*f*gd2*s**2 + 3696*D1**2*f*gd2*s - 1320*D1**2*f*gd2 + 660*D1**2*f*gdd2*r**2 + 1848*D1**2*f*gdd2*r*s - 1320*D1**2*f*gdd2*r + 1188*D1**2*f*gdd2*s**2 - 1848*D1**2*f*gdd2*s + 660*D1**2*f*gdd2 - 6380*D1**2*fd**2*r**2 - 7832*D1**2*fd**2*r*s + 3124*D1**2*fd**2*r - 1452*D1**2*fd**2*s**2 + 660*D1**2*fd**2*s + 1320*D1**2*fd**2 - 1320*D1**2*fd*g2*r**2 - 3696*D1**2*fd*g2*r*s + 2640*D1**2*fd*g2*r - 2376*D1**2*fd*g2*s**2 + 2640*D1**2*fd*g2*s - 1320*D1**2*fd*g2 + 1320*D1**2*fd*gd2*r**2 + 3696*D1**2*fd*gd2*r*s - 2640*D1**2*fd*gd2*r + 2376*D1**2*fd*gd2*s**2 - 3168*D1**2*fd*gd2*s + 1320*D1**2*fd*gd2 + 660*D1**2*fdd*g2*r**2 + 1848*D1**2*fdd*g2*r*s - 1320*D1**2*fdd*g2*r + 1188*D1**2*fdd*g2*s**2 - 1320*D1**2*fdd*g2*s + 660*D1**2*fdd*g2 - 10296*D1*Dd*K*f**2*r**2 + 2288*D1*Dd*K*f**2*r*s + 9724*D1*Dd*K*f**2*r + 12584*D1*Dd*K*f**2*s**2 - 7436*D1*Dd*K*f**2*s - 2002*D1*Dd*K*f**2 + 26400*D1*Dd*K*f*fd*r**2 + 704*D1*Dd*K*f*fd*r*s - 13464*D1*Dd*K*f*fd*r - 25696*D1*Dd*K*f*fd*s**2 + 19096*D1*Dd*K*f*fd*s - 3124*D1*Dd*K*f*fd + 20600*D1*Dd*f**3*r**2 + 30960*D1*Dd*f**3*r*s - 28340*D1*Dd*f**3*r + 10360*D1*Dd*f**3*s**2 - 20660*D1*Dd*f**3*s + 12890*D1*Dd*f**3 - 75000*D1*Dd*f**2*fd*r**2 - 114000*D1*Dd*f**2*fd*r*s + 98750*D1*Dd*f**2*fd*r - 39000*D1*Dd*f**2*fd*s**2 + 73250*D1*Dd*f**2*fd*s - 32250*D1*Dd*f**2*fd + 19976*D1*Dd*f**2*r**2 + 22352*D1*Dd*f**2*r*s - 25564*D1*Dd*f**2*r + 2376*D1*Dd*f**2*s**2 - 12364*D1*Dd*f**2*s + 10582*D1*Dd*f**2 - 51040*D1*Dd*f*fd*r**2 - 62656*D1*Dd*f*fd*r*s + 45848*D1*Dd*f*fd*r - 11616*D1*Dd*f*fd*s**2 + 21208*D1*Dd*f*fd*s - 6908*D1*Dd*f*fd - 5280*D1*Dd*f*g2*r**2 - 14784*D1*Dd*f*g2*r*s + 8976*D1*Dd*f*g2*r - 9504*D1*Dd*f*g2*s**2 + 12144*D1*Dd*f*g2*s - 5016*D1*Dd*f*g2 + 5280*D1*Dd*f*gd2*r**2 + 14784*D1*Dd*f*gd2*r*s - 9768*D1*Dd*f*gd2*r + 9504*D1*Dd*f*gd2*s**2 - 13464*D1*Dd*f*gd2*s + 4488*D1*Dd*f*gd2 + 5280*D1*Dd*fd*g2*r**2 + 14784*D1*Dd*fd*g2*r*s - 9768*D1*Dd*fd*g2*r + 9504*D1*Dd*fd*g2*s**2 - 11352*D1*Dd*fd*g2*s + 3960*D1*Dd*fd*g2 + 6600*D1*Ddd*K*f**2*r**2 + 176*D1*Ddd*K*f**2*r*s - 6644*D1*Ddd*K*f**2*r - 6424*D1*Ddd*K*f**2*s**2 + 3124*D1*Ddd*K*f**2*s + 1694*D1*Ddd*K*f**2 - 12500*D1*Ddd*f**3*r**2 - 19000*D1*Ddd*f**3*r*s + 17250*D1*Ddd*f**3*r - 6500*D1*Ddd*f**3*s**2 + 12750*D1*Ddd*f**3*s - 7875*D1*Ddd*f**3 - 12760*D1*Ddd*f**2*r**2 - 15664*D1*Ddd*f**2*r*s + 16676*D1*Ddd*f**2*r - 2904*D1*Ddd*f**2*s**2 + 9284*D1*Ddd*f**2*s - 7106*D1*Ddd*f**2 + 2640*D1*Ddd*f*g2*r**2 + 7392*D1*Ddd*f*g2*r*s - 4488*D1*Ddd*f*g2*r + 4752*D1*Ddd*f*g2*s**2 - 6072*D1*Ddd*f*g2*s + 2508*D1*Ddd*f*g2 + 132*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) - fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 21*s + 5)) - Dd*f*(40*r**2 + 2*r*(56*s - 31) + 72*s**2 - 90*s + 25)) + 19800*Dd**2*K*f**2*r**2 + 528*Dd**2*K*f**2*r*s - 19932*Dd**2*K*f**2*r - 19272*Dd**2*K*f**2*s**2 + 9372*Dd**2*K*f**2*s + 3388*Dd**2*K*f**2 - 37500*Dd**2*f**3*r**2 - 57000*Dd**2*f**3*r*s + 51750*Dd**2*f**3*r - 19500*Dd**2*f**3*s**2 + 38250*Dd**2*f**3*s - 15750*Dd**2*f**3 - 38280*Dd**2*f**2*r**2 - 46992*Dd**2*f**2*r*s + 50028*Dd**2*f**2*r - 8712*Dd**2*f**2*s**2 + 27852*Dd**2*f**2*s - 14212*Dd**2*f**2 + 7920*Dd**2*f*g2*r**2 + 22176*Dd**2*f*g2*r*s - 13464*Dd**2*f*g2*r + 14256*Dd**2*f*g2*s**2 - 18216*Dd**2*f*g2*s + 5016*Dd**2*f*g2))/(1386*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**4*k1**2*k2**2*(44*C*D1**2*bdd1*f**2*r**2 - 1056*C*D1**2*bdd1*f**2*r*s - 3344*C*D1**2*bdd1*f**2*r - 1100*C*D1**2*bdd1*f**2*s**2 - 2200*C*D1**2*bdd1*f**2*s + 1100*C*D1**2*bdd1*f**2 - 16350*C*D1**2*f**2*fd*r**2 - 44820*C*D1**2*f**2*fd*r*s + 25840*C*D1**2*f**2*fd*r - 28470*C*D1**2*f**2*fd*s**2 + 33920*C*D1**2*f**2*fd*s - 14940*C*D1**2*f**2*fd + 19560*C*D1**2*f**2*fdd*r**2 + 45840*C*D1**2*f**2*fdd*r*s - 28320*C*D1**2*f**2*fdd*r + 26280*C*D1**2*f**2*fdd*s**2 - 32800*C*D1**2*f**2*fdd*s + 15280*C*D1**2*f**2*fdd + 39120*C*D1**2*f*fd**2*r**2 + 91680*C*D1**2*f*fd**2*r*s - 56640*C*D1**2*f*fd**2*r + 52560*C*D1**2*f*fd**2*s**2 - 65600*C*D1**2*f*fd**2*s + 15280*C*D1**2*f*fd**2 - 21800*C*D1*Dd*f**3*r**2 - 59760*C*D1*Dd*f**3*r*s + 36740*C*D1*Dd*f**3*r - 37960*C*D1*Dd*f**3*s**2 + 48860*C*D1*Dd*f**3*s - 20390*C*D1*Dd*f**3 + 156480*C*D1*Dd*f**2*fd*r**2 + 366720*C*D1*Dd*f**2*fd*r*s - 237360*C*D1*Dd*f**2*fd*r + 210240*C*D1*Dd*f**2*fd*s**2 - 275440*C*D1*Dd*f**2*fd*s + 89440*C*D1*Dd*f**2*fd + 26080*C*D1*Ddd*f**3*r**2 + 61120*C*D1*Ddd*f**3*r*s - 41360*C*D1*Ddd*f**3*r + 35040*C*D1*Ddd*f**3*s**2 - 48080*C*D1*Ddd*f**3*s + 21800*C*D1*Ddd*f**3 + 78240*C*Dd**2*f**3*r**2 + 183360*C*Dd**2*f**3*r*s - 124080*C*Dd**2*f**3*r + 105120*C*Dd**2*f**3*s**2 - 144240*C*Dd**2*f**3*s + 43600*C*Dd**2*f**3 + 3630*D1**2*K*bdd1*f**2*r**2 + 8844*D1**2*K*bdd1*f**2*r*s - 7260*D1**2*K*bdd1*f**2*r + 5214*D1**2*K*bdd1*f**2*s**2 - 8844*D1**2*K*bdd1*f**2*s + 3630*D1**2*K*bdd1*f**2 - 3300*D1**2*b2*f*fd*r**2 - 6600*D1**2*b2*f*fd*r*s + 3300*D1**2*b2*f*fd*r - 3300*D1**2*b2*f*fd*s**2 + 3300*D1**2*b2*f*fd*s - 1650*D1**2*b2*f*fd + 3300*D1**2*b2*f*fdd*r**2 + 6600*D1**2*b2*f*fdd*r*s - 3300*D1**2*b2*f*fdd*r + 3300*D1**2*b2*f*fdd*s**2 - 3300*D1**2*b2*f*fdd*s + 1650*D1**2*b2*f*fdd + 3300*D1**2*b2*fd**2*r**2 + 6600*D1**2*b2*fd**2*r*s - 3300*D1**2*b2*fd**2*r + 3300*D1**2*b2*fd**2*s**2 - 3300*D1**2*b2*fd**2*s - 22*D1**2*bd1**2*(r + s - 1)*(50*f**2*(r + s - 2) + f*(60*C*r + 60*C*s + K*(13*r + 61*s + 83) + 107*r + 59*s - 203) - 70*g2*(r + s)) - 1650*D1**2*bd2*f**2*r**2 - 3300*D1**2*bd2*f**2*r*s + 3300*D1**2*bd2*f**2*r - 1650*D1**2*bd2*f**2*s**2 + 3300*D1**2*bd2*f**2*s - 1650*D1**2*bd2*f**2 + 6600*D1**2*bd2*f*fd*r**2 + 13200*D1**2*bd2*f*fd*r*s - 9900*D1**2*bd2*f*fd*r + 6600*D1**2*bd2*f*fd*s**2 - 9900*D1**2*bd2*f*fd*s + 3300*D1**2*bd2*f*fd - 550*D1**2*bdd1*f**3*r**2 - 2090*D1**2*bdd1*f**3*r*s + 1870*D1**2*bdd1*f**3*r - 1540*D1**2*bdd1*f**3*s**2 + 2860*D1**2*bdd1*f**3*s - 1320*D1**2*bdd1*f**3 - 2684*D1**2*bdd1*f**2*r**2 - 5016*D1**2*bdd1*f**2*r*s + 7524*D1**2*bdd1*f**2*r - 2332*D1**2*bdd1*f**2*s**2 + 7172*D1**2*bdd1*f**2*s - 3190*D1**2*bdd1*f**2 + 286*D1**2*bdd1*f*g2*r**2 + 1628*D1**2*bdd1*f*g2*r*s + 3652*D1**2*bdd1*f*g2*r + 1342*D1**2*bdd1*f*g2*s**2 + 2596*D1**2*bdd1*f*g2*s - 1298*D1**2*bdd1*f*g2 + 1650*D1**2*bdd2*f**2*r**2 + 3300*D1**2*bdd2*f**2*r*s - 3300*D1**2*bdd2*f**2*r + 1650*D1**2*bdd2*f**2*s**2 - 3300*D1**2*bdd2*f**2*s + 1650*D1**2*bdd2*f**2 + 7815*D1**2*f**2*fd*r**2 + 25380*D1**2*f**2*fd*r*s - 13670*D1**2*f**2*fd*r + 17565*D1**2*f**2*fd*s**2 - 20170*D1**2*f**2*fd*s + 8460*D1**2*f**2*fd - 12570*D1**2*f**2*fdd*r**2 - 30180*D1**2*f**2*fdd*r*s + 18440*D1**2*f**2*fdd*r - 17610*D1**2*f**2*fdd*s**2 + 21800*D1**2*f**2*fdd*s - 10060*D1**2*f**2*fdd + 5412*D1**2*f**2*gd2*r**2 + 16632*D1**2*f**2*gd2*r*s - 10824*D1**2*f**2*gd2*r + 11220*D1**2*f**2*gd2*s**2 - 16632*D1**2*f**2*gd2*s + 5412*D1**2*f**2*gd2 - 7260*D1**2*f**2*gdd2*r**2 - 17688*D1**2*f**2*gdd2*r*s + 14520*D1**2*f**2*gdd2*r - 10428*D1**2*f**2*gdd2*s**2 + 17688*D1**2*f**2*gdd2*s - 7260*D1**2*f**2*gdd2 - 25140*D1**2*f*fd**2*r**2 - 60360*D1**2*f*fd**2*r*s + 36880*D1**2*f*fd**2*r - 35220*D1**2*f*fd**2*s**2 + 43600*D1**2*f*fd**2*s - 10060*D1**2*f*fd**2 + 10824*D1**2*f*fd*g2*r**2 + 33264*D1**2*f*fd*g2*r*s - 16632*D1**2*f*fd*g2*r + 22440*D1**2*f*fd*g2*s**2 - 22440*D1**2*f*fd*g2*s + 11220*D1**2*f*fd*g2 - 29040*D1**2*f*fd*gd2*r**2 - 70752*D1**2*f*fd*gd2*r*s + 46728*D1**2*f*fd*gd2*r - 41712*D1**2*f*fd*gd2*s**2 + 56232*D1**2*f*fd*gd2*s - 17688*D1**2*f*fd*gd2 - 14520*D1**2*f*fdd*g2*r**2 - 35376*D1**2*f*fdd*g2*r*s + 17688*D1**2*f*fdd*g2*r - 20856*D1**2*f*fdd*g2*s**2 + 20856*D1**2*f*fdd*g2*s - 10428*D1**2*f*fdd*g2 - 14520*D1**2*fd**2*g2*r**2 - 35376*D1**2*fd**2*g2*r*s + 17688*D1**2*fd**2*g2*r - 20856*D1**2*fd**2*g2*s**2 + 20856*D1**2*fd**2*g2*s - 6600*D1*Dd*b2*f**2*r**2 - 13200*D1*Dd*b2*f**2*r*s + 9900*D1*Dd*b2*f**2*r - 6600*D1*Dd*b2*f**2*s**2 + 9900*D1*Dd*b2*f**2*s - 4950*D1*Dd*b2*f**2 + 26400*D1*Dd*b2*f*fd*r**2 + 52800*D1*Dd*b2*f*fd*r*s - 33000*D1*Dd*b2*f*fd*r + 26400*D1*Dd*b2*f*fd*s**2 - 33000*D1*Dd*b2*f*fd*s + 9900*D1*Dd*b2*f*fd + 13200*D1*Dd*bd2*f**2*r**2 + 26400*D1*Dd*bd2*f**2*r*s - 23100*D1*Dd*bd2*f**2*r + 13200*D1*Dd*bd2*f**2*s**2 - 23100*D1*Dd*bd2*f**2*s + 9900*D1*Dd*bd2*f**2 + 10420*D1*Dd*f**3*r**2 + 33840*D1*Dd*f**3*r*s - 18880*D1*Dd*f**3*r + 23420*D1*Dd*f**3*s**2 - 28630*D1*Dd*f**3*s + 11065*D1*Dd*f**3 - 100560*D1*Dd*f**2*fd*r**2 - 241440*D1*Dd*f**2*fd*r*s + 154220*D1*Dd*f**2*fd*r - 140880*D1*Dd*f**2*fd*s**2 + 182780*D1*Dd*f**2*fd*s - 58680*D1*Dd*f**2*fd + 21648*D1*Dd*f**2*g2*r**2 + 66528*D1*Dd*f**2*g2*r*s - 38280*D1*Dd*f**2*g2*r + 44880*D1*Dd*f**2*g2*s**2 - 55704*D1*Dd*f**2*g2*s + 22044*D1*Dd*f**2*g2 - 58080*D1*Dd*f**2*gd2*r**2 - 141504*D1*Dd*f**2*gd2*r*s + 104808*D1*Dd*f**2*gd2*r - 83424*D1*Dd*f**2*gd2*s**2 + 126984*D1*Dd*f**2*gd2*s - 46728*D1*Dd*f**2*gd2 - 116160*D1*Dd*f*fd*g2*r**2 - 283008*D1*Dd*f*fd*g2*r*s + 164208*D1*Dd*f*fd*g2*r - 166848*D1*Dd*f*fd*g2*s**2 + 195888*D1*Dd*f*fd*g2*s - 56232*D1*Dd*f*fd*g2 + 6600*D1*Ddd*b2*f**2*r**2 + 13200*D1*Ddd*b2*f**2*r*s - 9900*D1*Ddd*b2*f**2*r + 6600*D1*Ddd*b2*f**2*s**2 - 9900*D1*Ddd*b2*f**2*s + 4950*D1*Ddd*b2*f**2 - 16760*D1*Ddd*f**3*r**2 - 40240*D1*Ddd*f**3*r*s + 26820*D1*Ddd*f**3*r - 23480*D1*Ddd*f**3*s**2 + 31860*D1*Ddd*f**3*s - 14250*D1*Ddd*f**3 - 29040*D1*Ddd*f**2*g2*r**2 - 70752*D1*Ddd*f**2*g2*r*s + 46728*D1*Ddd*f**2*g2*r - 41712*D1*Ddd*f**2*g2*s**2 + 56232*D1*Ddd*f**2*g2*s - 24948*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*(9*r**2 + r*(2 - 8*s) - 17*s**2 + 28*s - 6) + 2*f**2*(2*C*(44*r**2 + r*(48*s - 98) + 4*s**2 - 58*s + 29) + 123*K*r**2 + 378*K*r*s - 246*K*r + 255*K*s**2 - 378*K*s + 123*K + 5*fd*(30*r**2 + 114*r*s - 73*r + 84*s**2 - 118*s + 36) - 160*r**2 - 318*r*s + 300*r - 158*s**2 + 298*s - 110) - 2*f*(2*fd*(2*C*(2*r**2 - 3*r*(16*s + 9) - 50*s**2 + 12*s + 38) + 3*K*(110*r**2 + 268*r*s - 177*r + 158*s**2 - 213*s + 67) - 244*r**2 - 456*r*s + 407*r - 212*s**2 + 383*s - 189) + g2*(72*r**2 + r*(76*s - 206) + 4*s**2 - 138*s + 69) + 2*gd2*(13*r**2 + r*(74*s + 70) + 61*s**2 + 22*s - 83)) - 4*fd*g2*(13*r**2 + 37*r*(2*s - 1) + s*(61*s - 61))) + 2*Dd*f*(5*f**2*(40*r**2 + 152*r*s - 107*r + 112*s**2 - 170*s + 60) - 2*f*(2*C*(4*r**2 - 2*r*(48*s + 71) - 100*s**2 - 51*s + 101) + 3*K*(220*r**2 + 536*r*s - 397*r + 316*s**2 - 481*s + 177) - 488*r**2 - 912*r*s + 1042*r - 424*s**2 + 986*s - 505) - 2*g2*(52*r**2 + r*(296*s + 269) + 244*s**2 + 101*s - 225))) + 19800*Dd**2*b2*f**2*r**2 + 39600*Dd**2*b2*f**2*r*s - 29700*Dd**2*b2*f**2*r + 19800*Dd**2*b2*f**2*s**2 - 29700*Dd**2*b2*f**2*s + 9900*Dd**2*b2*f**2 - 50280*Dd**2*f**3*r**2 - 120720*Dd**2*f**3*r*s + 80460*Dd**2*f**3*r - 70440*Dd**2*f**3*s**2 + 95580*Dd**2*f**3*s - 28500*Dd**2*f**3 - 87120*Dd**2*f**2*g2*r**2 - 212256*Dd**2*f**2*g2*r*s + 140184*Dd**2*f**2*g2*r - 125136*Dd**2*f**2*g2*s**2 + 168696*Dd**2*f**2*g2*s - 49896*Dd**2*f**2*g2 + 385*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(120*C*D1**2*fd*r**2 + 240*C*D1**2*fd*r*s - 240*C*D1**2*fd*r + 120*C*D1**2*fd*s**2 - 240*C*D1**2*fd*s + 120*C*D1**2*fd - 60*C*D1**2*fdd*r**2 - 120*C*D1**2*fdd*r*s + 120*C*D1**2*fdd*r - 60*C*D1**2*fdd*s**2 + 120*C*D1**2*fdd*s - 60*C*D1**2*fdd + 480*C*D1*Dd*f*r**2 + 960*C*D1*Dd*f*r*s - 720*C*D1*Dd*f*r + 480*C*D1*Dd*f*s**2 - 720*C*D1*Dd*f*s + 360*C*D1*Dd*f - 480*C*D1*Dd*fd*r**2 - 960*C*D1*Dd*fd*r*s + 840*C*D1*Dd*fd*r - 480*C*D1*Dd*fd*s**2 + 840*C*D1*Dd*fd*s - 360*C*D1*Dd*fd - 240*C*D1*Ddd*f*r**2 - 480*C*D1*Ddd*f*r*s + 360*C*D1*Ddd*f*r - 240*C*D1*Ddd*f*s**2 + 360*C*D1*Ddd*f*s - 180*C*D1*Ddd*f - 720*C*Dd**2*f*r**2 - 1440*C*Dd**2*f*r*s + 1080*C*Dd**2*f*r - 720*C*Dd**2*f*s**2 + 1080*C*Dd**2*f*s - 360*C*Dd**2*f - 72*D1**2*K*fd*r**2 - 76*D1**2*K*fd*r*s - 130*D1**2*K*fd*r - 4*D1**2*K*fd*s**2 - 130*D1**2*K*fd*s + 65*D1**2*K*fd - 13*D1**2*K*fdd*r**2 - 74*D1**2*K*fdd*r*s + 240*D1**2*K*fdd*r - 61*D1**2*K*fdd*s**2 + 240*D1**2*K*fdd*s - 120*D1**2*K*fdd - 35*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 200*D1**2*f*fd*r**2 + 400*D1**2*f*fd*r*s - 120*D1**2*f*fd*r + 200*D1**2*f*fd*s**2 - 120*D1**2*f*fd*s + 60*D1**2*f*fd - 100*D1**2*f*fdd*r**2 - 200*D1**2*f*fdd*r*s - 100*D1**2*f*fdd*s**2 - 100*D1**2*fd**2*r**2 - 200*D1**2*fd**2*r*s - 100*D1**2*fd**2*s**2 + 100*D1**2*fd**2 + 172*D1**2*fd*r**2 + 276*D1**2*fd*r*s + 270*D1**2*fd*r + 104*D1**2*fd*s**2 + 270*D1**2*fd*s - 135*D1**2*fd - 107*D1**2*fdd*r**2 - 166*D1**2*fdd*r*s - 240*D1**2*fdd*r - 59*D1**2*fdd*s**2 - 240*D1**2*fdd*s + 120*D1**2*fdd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 + 70*D1**2*gdd2*r**2 + 140*D1**2*gdd2*r*s - 140*D1**2*gdd2*r + 70*D1**2*gdd2*s**2 - 140*D1**2*gdd2*s + 70*D1**2*gdd2 - 288*D1*Dd*K*f*r**2 - 304*D1*Dd*K*f*r*s + 364*D1*Dd*K*f*r - 16*D1*Dd*K*f*s**2 + 160*D1*Dd*K*f*s - 148*D1*Dd*K*f - 104*D1*Dd*K*fd*r**2 - 592*D1*Dd*K*fd*r*s + 1086*D1*Dd*K*fd*r - 488*D1*Dd*K*fd*s**2 + 1230*D1*Dd*K*fd*s - 720*D1*Dd*K*fd + 400*D1*Dd*f**2*r**2 + 800*D1*Dd*f**2*r*s - 600*D1*Dd*f**2*r + 400*D1*Dd*f**2*s**2 - 600*D1*Dd*f**2*s + 300*D1*Dd*f**2 - 800*D1*Dd*f*fd*r**2 - 1600*D1*Dd*f*fd*r*s + 600*D1*Dd*f*fd*r - 800*D1*Dd*f*fd*s**2 + 600*D1*Dd*f*fd*s + 688*D1*Dd*f*r**2 + 1104*D1*Dd*f*r*s - 964*D1*Dd*f*r + 416*D1*Dd*f*s**2 - 760*D1*Dd*f*s + 448*D1*Dd*f - 856*D1*Dd*fd*r**2 - 1328*D1*Dd*fd*r*s - 366*D1*Dd*fd*r - 472*D1*Dd*fd*s**2 - 510*D1*Dd*fd*s + 720*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 + 1120*D1*Dd*gd2*r*s - 980*D1*Dd*gd2*r + 560*D1*Dd*gd2*s**2 - 980*D1*Dd*gd2*s + 420*D1*Dd*gd2 - 52*D1*Ddd*K*f*r**2 - 296*D1*Ddd*K*f*r*s + 126*D1*Ddd*K*f*r - 244*D1*Ddd*K*f*s**2 + 270*D1*Ddd*K*f*s - 87*D1*Ddd*K*f - 200*D1*Ddd*f**2*r**2 - 400*D1*Ddd*f**2*r*s + 300*D1*Ddd*f**2*r - 200*D1*Ddd*f**2*s**2 + 300*D1*Ddd*f**2*s - 150*D1*Ddd*f**2 - 428*D1*Ddd*f*r**2 - 664*D1*Ddd*f*r*s + 594*D1*Ddd*f*r - 236*D1*Ddd*f*s**2 + 450*D1*Ddd*f*s - 273*D1*Ddd*f + 280*D1*Ddd*g2*r**2 + 560*D1*Ddd*g2*r*s - 420*D1*Ddd*g2*r + 280*D1*Ddd*g2*s**2 - 420*D1*Ddd*g2*s + 210*D1*Ddd*g2 + 70*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 156*Dd**2*K*f*r**2 - 888*Dd**2*K*f*r*s + 378*Dd**2*K*f*r - 732*Dd**2*K*f*s**2 + 810*Dd**2*K*f*s - 174*Dd**2*K*f - 600*Dd**2*f**2*r**2 - 1200*Dd**2*f**2*r*s + 900*Dd**2*f**2*r - 600*Dd**2*f**2*s**2 + 900*Dd**2*f**2*s - 300*Dd**2*f**2 - 1284*Dd**2*f*r**2 - 1992*Dd**2*f*r*s + 1782*Dd**2*f*r - 708*Dd**2*f*s**2 + 1350*Dd**2*f*s - 546*Dd**2*f + 840*Dd**2*g2*r**2 + 1680*Dd**2*g2*r*s - 1260*Dd**2*g2*r + 840*Dd**2*g2*s**2 - 1260*Dd**2*g2*s + 420*Dd**2*g2) - 11*b1*(352*C*D1**2*f*fd*r**2 + 384*C*D1**2*f*fd*r*s - 152*C*D1**2*f*fd*r + 32*C*D1**2*f*fd*s**2 + 8*C*D1**2*f*fd*s + 76*C*D1**2*f*fd - 8*C*D1**2*f*fdd*r**2 + 192*C*D1**2*f*fdd*r*s - 392*C*D1**2*f*fdd*r + 200*C*D1**2*f*fdd*s**2 - 496*C*D1**2*f*fdd*s + 196*C*D1**2*f*fdd - 8*C*D1**2*fd**2*r**2 + 192*C*D1**2*fd**2*r*s - 392*C*D1**2*fd**2*r + 200*C*D1**2*fd**2*s**2 - 496*C*D1**2*fd**2*s + 400*C*D1**2*fd**2 + 704*C*D1*Dd*f**2*r**2 + 768*C*D1*Dd*f**2*r*s - 896*C*D1*Dd*f**2*r + 64*C*D1*Dd*f**2*s**2 - 416*C*D1*Dd*f**2*s + 368*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r**2 + 1536*C*D1*Dd*f*fd*r*s - 1728*C*D1*Dd*f*fd*r + 1600*C*D1*Dd*f*fd*s**2 - 2768*C*D1*Dd*f*fd*s + 1280*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 + 384*C*D1*Ddd*f**2*r*s - 80*C*D1*Ddd*f**2*r + 400*C*D1*Ddd*f**2*s**2 - 392*C*D1*Ddd*f**2*s + 92*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 + 1152*C*Dd**2*f**2*r*s - 240*C*Dd**2*f**2*r + 1200*C*Dd**2*f**2*s**2 - 1176*C*Dd**2*f**2*s + 184*C*Dd**2*f**2 + 492*D1**2*K*f*fd*r**2 + 1512*D1**2*K*f*fd*r*s - 756*D1**2*K*f*fd*r + 1020*D1**2*K*f*fd*s**2 - 1020*D1**2*K*f*fd*s + 510*D1**2*K*f*fd - 660*D1**2*K*f*fdd*r**2 - 1608*D1**2*K*f*fdd*r*s + 804*D1**2*K*f*fdd*r - 948*D1**2*K*f*fdd*s**2 + 948*D1**2*K*f*fdd*s - 474*D1**2*K*f*fdd - 660*D1**2*K*fd**2*r**2 - 1608*D1**2*K*fd**2*r*s + 804*D1**2*K*fd**2*r - 948*D1**2*K*fd**2*s**2 + 948*D1**2*K*fd**2*s + 70*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(25*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + f*(30*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*(13*r**2 + 74*r*s + 70*r + 61*s**2 + 22*s - 23) + 107*r**2 + 166*r*s - 310*r + 59*s**2 - 262*s + 143) - 35*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 135*D1**2*f**2*fd*r**2 - 120*D1**2*f**2*fd*r*s - 150*D1**2*f**2*fd*r - 255*D1**2*f**2*fd*s**2 + 110*D1**2*f**2*fd*s + 35*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r**2 + 570*D1**2*f**2*fdd*r*s - 220*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 400*D1**2*f**2*fdd*s + 120*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r**2 + 1140*D1**2*f*fd**2*r*s - 440*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 800*D1**2*f*fd**2*s + 120*D1**2*f*fd**2 - 640*D1**2*f*fd*r**2 - 1272*D1**2*f*fd*r*s + 676*D1**2*f*fd*r - 632*D1**2*f*fd*s**2 + 672*D1**2*f*fd*s - 416*D1**2*f*fd + 488*D1**2*f*fdd*r**2 + 912*D1**2*f*fdd*r*s - 260*D1**2*f*fdd*r + 424*D1**2*f*fdd*s**2 - 228*D1**2*f*fdd*s + 166*D1**2*f*fdd - 144*D1**2*f*gd2*r**2 - 152*D1**2*f*gd2*r*s + 288*D1**2*f*gd2*r - 8*D1**2*f*gd2*s**2 + 152*D1**2*f*gd2*s - 144*D1**2*f*gd2 - 26*D1**2*f*gdd2*r**2 - 148*D1**2*f*gdd2*r*s + 52*D1**2*f*gdd2*r - 122*D1**2*f*gdd2*s**2 + 148*D1**2*f*gdd2*s - 26*D1**2*f*gdd2 + 488*D1**2*fd**2*r**2 + 912*D1**2*fd**2*r*s - 260*D1**2*fd**2*r + 424*D1**2*fd**2*s**2 - 228*D1**2*fd**2*s - 300*D1**2*fd**2 - 144*D1**2*fd*g2*r**2 - 152*D1**2*fd*g2*r*s - 260*D1**2*fd*g2*r - 8*D1**2*fd*g2*s**2 - 260*D1**2*fd*g2*s + 130*D1**2*fd*g2 - 52*D1**2*fd*gd2*r**2 - 296*D1**2*fd*gd2*r*s + 532*D1**2*fd*gd2*r - 244*D1**2*fd*gd2*s**2 + 628*D1**2*fd*gd2*s - 480*D1**2*fd*gd2 - 26*D1**2*fdd*g2*r**2 - 148*D1**2*fdd*g2*r*s + 480*D1**2*fdd*g2*r - 122*D1**2*fdd*g2*s**2 + 480*D1**2*fdd*g2*s - 240*D1**2*fdd*g2 + 984*D1*Dd*K*f**2*r**2 + 3024*D1*Dd*K*f**2*r*s - 1740*D1*Dd*K*f**2*r + 2040*D1*Dd*K*f**2*s**2 - 2532*D1*Dd*K*f**2*s + 1002*D1*Dd*K*f**2 - 5280*D1*Dd*K*f*fd*r**2 - 12864*D1*Dd*K*f*fd*r*s + 7464*D1*Dd*K*f*fd*r - 7584*D1*Dd*K*f*fd*s**2 + 8904*D1*Dd*K*f*fd*s - 2556*D1*Dd*K*f*fd + 180*D1*Dd*f**3*r**2 - 160*D1*Dd*f**3*r*s - 140*D1*Dd*f**3*r - 340*D1*Dd*f**3*s**2 + 250*D1*Dd*f**3*s + 5*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r**2 + 4560*D1*Dd*f**2*fd*r*s - 2050*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 3580*D1*Dd*f**2*fd*s + 840*D1*Dd*f**2*fd - 1280*D1*Dd*f**2*r**2 - 2544*D1*Dd*f**2*r*s + 1916*D1*Dd*f**2*r - 1264*D1*Dd*f**2*s**2 + 1904*D1*Dd*f**2*s - 956*D1*Dd*f**2 + 3904*D1*Dd*f*fd*r**2 + 7296*D1*Dd*f*fd*r*s - 3904*D1*Dd*f*fd*r + 3392*D1*Dd*f*fd*s**2 - 3584*D1*Dd*f*fd*s + 748*D1*Dd*f*fd - 576*D1*Dd*f*g2*r**2 - 608*D1*Dd*f*g2*r*s + 728*D1*Dd*f*g2*r - 32*D1*Dd*f*g2*s**2 + 320*D1*Dd*f*g2*s - 296*D1*Dd*f*g2 - 208*D1*Dd*f*gd2*r**2 - 1184*D1*Dd*f*gd2*r*s + 460*D1*Dd*f*gd2*r - 976*D1*Dd*f*gd2*s**2 + 1132*D1*Dd*f*gd2*s - 252*D1*Dd*f*gd2 - 208*D1*Dd*fd*g2*r**2 - 1184*D1*Dd*fd*g2*r*s + 2172*D1*Dd*fd*g2*r - 976*D1*Dd*fd*g2*s**2 + 2460*D1*Dd*fd*g2*s - 1440*D1*Dd*fd*g2 - 1320*D1*Ddd*K*f**2*r**2 - 3216*D1*Ddd*K*f**2*r*s + 2124*D1*Ddd*K*f**2*r - 1896*D1*Ddd*K*f**2*s**2 + 2556*D1*Ddd*K*f**2*s - 1134*D1*Ddd*K*f**2 + 200*D1*Ddd*f**3*r**2 + 760*D1*Ddd*f**3*r*s - 390*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 660*D1*Ddd*f**3*s + 240*D1*Ddd*f**3 + 976*D1*Ddd*f**2*r**2 + 1824*D1*Ddd*f**2*r*s - 1432*D1*Ddd*f**2*r + 848*D1*Ddd*f**2*s**2 - 1336*D1*Ddd*f**2*s + 700*D1*Ddd*f**2 - 104*D1*Ddd*f*g2*r**2 - 592*D1*Ddd*f*g2*r*s + 252*D1*Ddd*f*g2*r - 488*D1*Ddd*f*g2*s**2 + 540*D1*Ddd*f*g2*s - 174*D1*Ddd*f*g2 + D1*bd1*(D1*(-40*f**2*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) + f*(-120*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 144*K*r**2 + 152*K*r*s - 350*K*r + 8*K*s**2 - 214*K*s + 141*K + 200*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 344*r**2 - 552*r*s + 890*r - 208*s**2 + 754*s - 411) + 4*fd*(30*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(13*r**2 + 74*r*s - 85*r + 61*s**2 - 109*s + 60) + 107*r**2 + 166*r*s - 35*r + 59*s**2 - 11*s - 60) + 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(25*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + f*(30*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + K*(52*r**2 + 296*r*s + 77*r + 244*s**2 - 91*s - 81) + 428*r**2 + 664*r*s - 917*r + 236*s**2 - 749*s + 441) - 35*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 3960*Dd**2*K*f**2*r**2 - 9648*Dd**2*K*f**2*r*s + 6372*Dd**2*K*f**2*r - 5688*Dd**2*K*f**2*s**2 + 7668*Dd**2*K*f**2*s - 2268*Dd**2*K*f**2 + 600*Dd**2*f**3*r**2 + 2280*Dd**2*f**3*r*s - 1170*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 1980*Dd**2*f**3*s + 480*Dd**2*f**3 + 2928*Dd**2*f**2*r**2 + 5472*Dd**2*f**2*r*s - 4296*Dd**2*f**2*r + 2544*Dd**2*f**2*s**2 - 4008*Dd**2*f**2*s + 1400*Dd**2*f**2 - 312*Dd**2*f*g2*r**2 - 1776*Dd**2*f*g2*r*s + 756*Dd**2*f*g2*r - 1464*Dd**2*f*g2*s**2 + 1620*Dd**2*f*g2*s - 348*Dd**2*f*g2))/(231*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**4*k1**2*st**2*(-66*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(10*f**3*s*(89*r + 89*s - 64) + f**2*(-125*fd*(6*s - 1)*(4*r + 4*s - 3) + 66*s*(4*C*s + r*(4*C + 5) + 5*s - 9)) - 66*f*(fd*(r*(2*C + 3)*(4*s - 1) + s**2*(8*C + 12) - s*(6*C + 14) + 5) + 2*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 132*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(125*f**2*(8*s - 1)*(4*r + 4*s - 3) + 66*f*(r*(2*C + 3)*(8*s - 1) + s**2*(16*C + 24) - s*(8*C + 32) + 5) - 132*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 66*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(5*f**2*(2*fd*(89*r*(3*s - 1) + 267*s**2 - 292*s + 89) - 25*fdd*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4)) + f*(-125*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) + 66*fd*(4*C*(2*s - 1)*(r + s - 1) + 5*r*(2*s - 1) + 10*s**2 - 6*s + 5) - 66*fdd*(2*C*(2*s - 1)*(r + s - 1) + 6*r*s - 3*r + 6*s**2 - 4*s + 3) - 66*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) - 66*fd**2*(2*C*(2*s - 1)*(r + s - 1) + r*(6*s - 3) + 6*s**2 - 4*s - 2) - 132*fd*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 132*fdd*g2*(s - 1)*(r + s - 1)) - 66*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(890*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(264*C*(r*(4*s - 1) + (1 - 2*s)**2) - 125*fd*(24*s - 7)*(4*r + 4*s - 3) + 330*r*(4*s - 1) + 330*(1 - 2*s)**2) - 132*f*(fd*(C*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + 24*r*s - 9*r + 24*s**2 - 20*s + 5) + g2*(8*r*s - 2*r + 8*s**2 - 8*s + 2) + gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 132*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(250*f**2 + f*(66*C + 99) - 66*g2)) - 2*Dd**2*f*(250*f**2 + f*(66*C + 99) - 66*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - f*(D1**2*(125*bdd1*f**2*s*(4*r + 4*s - 3) + 66*bdd1*f*s*(r*(2*C + 3) + s*(2*C + 3) - 5) - 132*bdd1*g2*s*(r + s) - 434*f*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 250*f*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 250*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 2*D1*f*(Dd*(217*f*(r*(4*s - 1) + (1 - 2*s)**2) - 125*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 125*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 250*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**4*k1**2*(660*C*D1**2*bdd1*f**2*r**2 + 880*C*D1**2*bdd1*f**2*r*s + 220*C*D1**2*bdd1*f**2*s**2 - 4080*C*D1**2*f**2*fd*r*s + 1360*C*D1**2*f**2*fd*r - 4080*C*D1**2*f**2*fd*s**2 + 4080*C*D1**2*f**2*fd*s - 1360*C*D1**2*f**2*fd + 3360*C*D1**2*f**2*fdd*r*s - 1120*C*D1**2*f**2*fdd*r + 3360*C*D1**2*f**2*fdd*s**2 - 3360*C*D1**2*f**2*fdd*s + 1120*C*D1**2*f**2*fdd + 6720*C*D1**2*f*fd**2*r*s - 2240*C*D1**2*f*fd**2*r + 6720*C*D1**2*f*fd**2*s**2 - 6720*C*D1**2*f*fd**2*s + 1120*C*D1**2*f*fd**2 - 5440*C*D1*Dd*f**3*r*s + 1360*C*D1*Dd*f**3*r - 5440*C*D1*Dd*f**3*s**2 + 5440*C*D1*Dd*f**3*s - 1360*C*D1*Dd*f**3 + 26880*C*D1*Dd*f**2*fd*r*s - 7840*C*D1*Dd*f**2*fd*r + 26880*C*D1*Dd*f**2*fd*s**2 - 26880*C*D1*Dd*f**2*fd*s + 5600*C*D1*Dd*f**2*fd + 4480*C*D1*Ddd*f**3*r*s - 1120*C*D1*Ddd*f**3*r + 4480*C*D1*Ddd*f**3*s**2 - 4480*C*D1*Ddd*f**3*s + 1120*C*D1*Ddd*f**3 + 13440*C*Dd**2*f**3*r*s - 3360*C*Dd**2*f**3*r + 13440*C*Dd**2*f**3*s**2 - 13440*C*Dd**2*f**3*s + 2240*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r*s + 660*D1**2*K*bdd1*f**2*s**2 - 660*D1**2*K*bdd1*f**2*s - 1584*D1**2*b2*f*fd*r*s + 792*D1**2*b2*f*fd*r - 1584*D1**2*b2*f*fd*s**2 + 1584*D1**2*b2*f*fd*s - 792*D1**2*b2*f*fd + 1320*D1**2*b2*f*fdd*r*s - 660*D1**2*b2*f*fdd*r + 1320*D1**2*b2*f*fdd*s**2 - 1320*D1**2*b2*f*fdd*s + 660*D1**2*b2*f*fdd + 1320*D1**2*b2*fd**2*r*s - 660*D1**2*b2*fd**2*r + 1320*D1**2*b2*fd**2*s**2 - 1320*D1**2*b2*fd**2*s - 22*D1**2*bd1**2*(10*f**2*(r**2 + r*(6*s - 5) + 5*s**2 - 10*s + 3) + f*(r**2*(43 - 31*K) + r*(24*C*(2*s - 1) - 42*K*s + 31*K + 114*s - 55) + s**2*(48*C - 11*K + 71) - s*(48*C - 21*K + 105) + 36) + 28*g2*(-2*r*s + r - s*(2*s - 2))) - 792*D1**2*bd2*f**2*r*s - 792*D1**2*bd2*f**2*s**2 + 792*D1**2*bd2*f**2*s + 2640*D1**2*bd2*f*fd*r*s - 660*D1**2*bd2*f*fd*r + 2640*D1**2*bd2*f*fd*s**2 - 2640*D1**2*bd2*f*fd*s + 660*D1**2*bd2*f*fd + 1485*D1**2*bdd1*f**3*r**2 + 3520*D1**2*bdd1*f**3*r*s - 1760*D1**2*bdd1*f**3*r + 2035*D1**2*bdd1*f**3*s**2 - 2420*D1**2*bdd1*f**3*s + 880*D1**2*bdd1*f**3 + 220*D1**2*bdd1*f**2*r**2 + 792*D1**2*bdd1*f**2*r*s - 1320*D1**2*bdd1*f**2*r + 572*D1**2*bdd1*f**2*s**2 - 1452*D1**2*bdd1*f**2*s + 330*D1**2*bdd1*f**2 - 682*D1**2*bdd1*f*g2*r**2 - 924*D1**2*bdd1*f*g2*r*s - 242*D1**2*bdd1*f*g2*s**2 + 660*D1**2*bdd2*f**2*r*s + 660*D1**2*bdd2*f**2*s**2 - 660*D1**2*bdd2*f**2*s - 2610*D1**2*f**2*fd*r**2 - 6870*D1**2*f**2*fd*r*s + 4030*D1**2*f**2*fd*r - 4260*D1**2*f**2*fd*s**2 + 5130*D1**2*f**2*fd*s - 2290*D1**2*f**2*fd + 2790*D1**2*f**2*fdd*r**2 + 5580*D1**2*f**2*fdd*r*s - 3720*D1**2*f**2*fdd*r + 2790*D1**2*f**2*fdd*s**2 - 3720*D1**2*f**2*fdd*s + 1860*D1**2*f**2*fdd + 1584*D1**2*f**2*gd2*r*s + 1584*D1**2*f**2*gd2*s**2 - 1584*D1**2*f**2*gd2*s - 1320*D1**2*f**2*gdd2*r*s - 1320*D1**2*f**2*gdd2*s**2 + 1320*D1**2*f**2*gdd2*s + 5580*D1**2*f*fd**2*r**2 + 11160*D1**2*f*fd**2*r*s - 7440*D1**2*f*fd**2*r + 5580*D1**2*f*fd**2*s**2 - 7440*D1**2*f*fd**2*s + 1860*D1**2*f*fd**2 + 3168*D1**2*f*fd*g2*r*s - 1584*D1**2*f*fd*g2*r + 3168*D1**2*f*fd*g2*s**2 - 3168*D1**2*f*fd*g2*s + 1584*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r*s + 1320*D1**2*f*fd*gd2*r - 5280*D1**2*f*fd*gd2*s**2 + 5280*D1**2*f*fd*gd2*s - 1320*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r*s + 1320*D1**2*f*fdd*g2*r - 2640*D1**2*f*fdd*g2*s**2 + 2640*D1**2*f*fdd*g2*s - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r*s + 1320*D1**2*fd**2*g2*r - 2640*D1**2*fd**2*g2*s**2 + 2640*D1**2*fd**2*g2*s - 3168*D1*Dd*b2*f**2*r*s + 792*D1*Dd*b2*f**2*r - 3168*D1*Dd*b2*f**2*s**2 + 3168*D1*Dd*b2*f**2*s - 792*D1*Dd*b2*f**2 + 10560*D1*Dd*b2*f*fd*r*s - 3960*D1*Dd*b2*f*fd*r + 10560*D1*Dd*b2*f*fd*s**2 - 10560*D1*Dd*b2*f*fd*s + 2640*D1*Dd*b2*f*fd + 5280*D1*Dd*bd2*f**2*r*s - 660*D1*Dd*bd2*f**2*r + 5280*D1*Dd*bd2*f**2*s**2 - 5280*D1*Dd*bd2*f**2*s + 660*D1*Dd*bd2*f**2 - 3480*D1*Dd*f**3*r**2 - 9160*D1*Dd*f**3*r*s + 5770*D1*Dd*f**3*r - 5680*D1*Dd*f**3*s**2 + 7420*D1*Dd*f**3*s - 3160*D1*Dd*f**3 + 22320*D1*Dd*f**2*fd*r**2 + 44640*D1*Dd*f**2*fd*r*s - 31620*D1*Dd*f**2*fd*r + 22320*D1*Dd*f**2*fd*s**2 - 31620*D1*Dd*f**2*fd*s + 11160*D1*Dd*f**2*fd + 6336*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 6336*D1*Dd*f**2*g2*s**2 - 6336*D1*Dd*f**2*g2*s + 1584*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r*s + 1320*D1*Dd*f**2*gd2*r - 10560*D1*Dd*f**2*gd2*s**2 + 10560*D1*Dd*f**2*gd2*s - 1320*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r*s + 7920*D1*Dd*f*fd*g2*r - 21120*D1*Dd*f*fd*g2*s**2 + 21120*D1*Dd*f*fd*g2*s - 5280*D1*Dd*f*fd*g2 + 2640*D1*Ddd*b2*f**2*r*s - 660*D1*Ddd*b2*f**2*r + 2640*D1*Ddd*b2*f**2*s**2 - 2640*D1*Ddd*b2*f**2*s + 660*D1*Ddd*b2*f**2 + 3720*D1*Ddd*f**3*r**2 + 7440*D1*Ddd*f**3*r*s - 5580*D1*Ddd*f**3*r + 3720*D1*Ddd*f**3*s**2 - 5580*D1*Ddd*f**3*s + 2790*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r*s + 1320*D1*Ddd*f**2*g2*r - 5280*D1*Ddd*f**2*g2*s**2 + 5280*D1*Ddd*f**2*g2*s - 1320*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*(21*r**2 + 4*r*(19*s - 6) + 55*s**2 - 52*s + 12) - 2*f**2*(5*fd*(81*r**2 + 2*r*(96*s - 59) + 111*s**2 - 145*s + 38) - 2*r**2*(9*C + 7) - 2*r*(s*(34*C + 18*K + 9) - 12) - 2*s**2*(25*C + 18*K + 2) + 2*s*(18*K + 27) + 12) - 2*f*(2*fd*(20*C*s**2 - 30*C*s + 15*K*(r*(4*s - 1) + (1 - 2*s)**2) + r**2*(60*C + 20) + r*(80*C*s - 50*C + 72*s - 58) + 52*s**2 - 77*s + 48) + 13*g2*r**2 + 70*g2*r*s + 57*g2*s**2 - 62*gd2*r**2 - 84*gd2*r*s + 62*gd2*r - 22*gd2*s**2 + 42*gd2*s) + 4*fd*g2*(31*r**2 + 21*r*(2*s - 1) + s*(11*s - 11))) - 2*Dd*f*(5*f**2*(108*r**2 + 2*r*(128*s - 75) + 148*s**2 - 189*s + 54) + 2*f*(40*C*s**2 - 50*C*s + 15*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + r**2*(120*C + 40) + 2*r*(80*C*s - 40*C + 72*s - 79) + 104*s**2 - 194*s + 93) - 2*g2*(124*r**2 + r*(168*s - 83) + s*(44*s - 53)))) + 7920*Dd**2*b2*f**2*r*s - 1980*Dd**2*b2*f**2*r + 7920*Dd**2*b2*f**2*s**2 - 7920*Dd**2*b2*f**2*s + 1320*Dd**2*b2*f**2 + 11160*Dd**2*f**3*r**2 + 22320*Dd**2*f**3*r*s - 16740*Dd**2*f**3*r + 11160*Dd**2*f**3*s**2 - 16740*Dd**2*f**3*s + 5580*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r*s + 3960*Dd**2*f**2*g2*r - 15840*Dd**2*f**2*g2*s**2 + 15840*Dd**2*f**2*g2*s - 2640*Dd**2*f**2*g2 + 308*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 11*b1**2*(96*C*D1**2*fd*r*s + 96*C*D1**2*fd*s**2 - 96*C*D1**2*fd*s - 48*C*D1**2*fdd*r*s - 48*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s + 384*C*D1*Dd*f*r*s - 96*C*D1*Dd*f*r + 384*C*D1*Dd*f*s**2 - 384*C*D1*Dd*f*s + 96*C*D1*Dd*f - 384*C*D1*Dd*fd*r*s + 48*C*D1*Dd*fd*r - 384*C*D1*Dd*fd*s**2 + 384*C*D1*Dd*fd*s - 48*C*D1*Dd*fd - 192*C*D1*Ddd*f*r*s + 48*C*D1*Ddd*f*r - 192*C*D1*Ddd*f*s**2 + 192*C*D1*Ddd*f*s - 48*C*D1*Ddd*f - 576*C*Dd**2*f*r*s + 144*C*Dd**2*f*r - 576*C*Dd**2*f*s**2 + 576*C*Dd**2*f*s - 96*C*Dd**2*f - 13*D1**2*K*fd*r**2 - 70*D1**2*K*fd*r*s + 70*D1**2*K*fd*r - 57*D1**2*K*fd*s**2 + 114*D1**2*K*fd*s - 57*D1**2*K*fd + 31*D1**2*K*fdd*r**2 + 42*D1**2*K*fdd*r*s - 42*D1**2*K*fdd*r + 11*D1**2*K*fdd*s**2 - 22*D1**2*K*fdd*s + 11*D1**2*K*fdd - 28*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 16*D1**2*f*fd*r**2 + 192*D1**2*f*fd*r*s + 24*D1**2*f*fd*r + 176*D1**2*f*fd*s**2 - 40*D1**2*f*fd*s - 40*D1**2*f*fd - 20*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s - 100*D1**2*f*fdd*s**2 + 20*D1**2*f*fdd*s + 20*D1**2*f*fdd - 20*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s - 100*D1**2*fd**2*s**2 + 20*D1**2*fd**2*s + 20*D1**2*fd**2 + 23*D1**2*fd*r**2 + 130*D1**2*fd*r*s - 110*D1**2*fd*r + 107*D1**2*fd*s**2 - 78*D1**2*fd*s + 87*D1**2*fd - 43*D1**2*fdd*r**2 - 114*D1**2*fdd*r*s + 90*D1**2*fdd*r - 71*D1**2*fdd*s**2 + 46*D1**2*fdd*s - 47*D1**2*fdd - 112*D1**2*gd2*r*s - 112*D1**2*gd2*s**2 + 112*D1**2*gd2*s + 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s - 52*D1*Dd*K*f*r**2 - 280*D1*Dd*K*f*r*s + 122*D1*Dd*K*f*r - 228*D1*Dd*K*f*s**2 + 254*D1*Dd*K*f*s - 83*D1*Dd*K*f + 248*D1*Dd*K*fd*r**2 + 336*D1*Dd*K*fd*r*s - 334*D1*Dd*K*fd*r + 88*D1*Dd*K*fd*s**2 - 194*D1*Dd*K*fd*s + 106*D1*Dd*K*fd + 32*D1*Dd*f**2*r**2 + 384*D1*Dd*f**2*r*s - 128*D1*Dd*f**2*r + 352*D1*Dd*f**2*s**2 - 368*D1*Dd*f**2*s + 104*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 200*D1*Dd*f*fd*r - 800*D1*Dd*f*fd*s**2 + 520*D1*Dd*f*fd*s - 20*D1*Dd*f*fd + 92*D1*Dd*f*r**2 + 520*D1*Dd*f*r*s - 222*D1*Dd*f*r + 428*D1*Dd*f*s**2 - 474*D1*Dd*f*s + 153*D1*Dd*f - 344*D1*Dd*fd*r**2 - 912*D1*Dd*fd*r*s + 646*D1*Dd*fd*r - 568*D1*Dd*fd*s**2 + 554*D1*Dd*fd*s - 226*D1*Dd*fd - 448*D1*Dd*g2*r*s + 112*D1*Dd*g2*r - 448*D1*Dd*g2*s**2 + 448*D1*Dd*g2*s - 112*D1*Dd*g2 + 448*D1*Dd*gd2*r*s - 56*D1*Dd*gd2*r + 448*D1*Dd*gd2*s**2 - 448*D1*Dd*gd2*s + 56*D1*Dd*gd2 + 124*D1*Ddd*K*f*r**2 + 168*D1*Ddd*K*f*r*s - 166*D1*Ddd*K*f*r + 44*D1*Ddd*K*f*s**2 - 106*D1*Ddd*K*f*s + 73*D1*Ddd*K*f - 40*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 100*D1*Ddd*f**2*r - 200*D1*Ddd*f**2*s**2 + 220*D1*Ddd*f**2*s - 70*D1*Ddd*f**2 - 172*D1*Ddd*f*r**2 - 456*D1*Ddd*f*r*s + 286*D1*Ddd*f*r - 284*D1*Ddd*f*s**2 + 370*D1*Ddd*f*s - 157*D1*Ddd*f + 224*D1*Ddd*g2*r*s - 56*D1*Ddd*g2*r + 224*D1*Ddd*g2*s**2 - 224*D1*Ddd*g2*s + 56*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 372*Dd**2*K*f*r**2 + 504*Dd**2*K*f*r*s - 498*Dd**2*K*f*r + 132*Dd**2*K*f*s**2 - 318*Dd**2*K*f*s + 146*Dd**2*K*f - 120*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 300*Dd**2*f**2*r - 600*Dd**2*f**2*s**2 + 660*Dd**2*f**2*s - 140*Dd**2*f**2 - 516*Dd**2*f*r**2 - 1368*Dd**2*f*r*s + 858*Dd**2*f*r - 852*Dd**2*f*s**2 + 1110*Dd**2*f*s - 314*Dd**2*f + 672*Dd**2*g2*r*s - 168*Dd**2*g2*r + 672*Dd**2*g2*s**2 - 672*Dd**2*g2*s + 112*Dd**2*g2) - 11*b1*(72*C*D1**2*f*fd*r**2 + 272*C*D1**2*f*fd*r*s - 208*C*D1**2*f*fd*r + 200*C*D1**2*f*fd*s**2 - 336*C*D1**2*f*fd*s + 136*C*D1**2*f*fd - 120*C*D1**2*f*fdd*r**2 - 160*C*D1**2*f*fdd*r*s + 200*C*D1**2*f*fdd*r - 40*C*D1**2*f*fdd*s**2 + 120*C*D1**2*f*fdd*s - 80*C*D1**2*f*fdd - 120*C*D1**2*fd**2*r**2 - 160*C*D1**2*fd**2*r*s + 200*C*D1**2*fd**2*r - 40*C*D1**2*fd**2*s**2 + 120*C*D1**2*fd**2*s - 80*C*D1**2*fd**2 + 144*C*D1*Dd*f**2*r**2 + 544*C*D1*Dd*f**2*r*s - 280*C*D1*Dd*f**2*r + 400*C*D1*Dd*f**2*s**2 - 472*C*D1*Dd*f**2*s + 172*C*D1*Dd*f**2 - 960*C*D1*Dd*f*fd*r**2 - 1280*C*D1*Dd*f*fd*r*s + 1440*C*D1*Dd*f*fd*r - 320*C*D1*Dd*f*fd*s**2 + 880*C*D1*Dd*f*fd*s - 520*C*D1*Dd*f*fd - 240*C*D1*Ddd*f**2*r**2 - 320*C*D1*Ddd*f**2*r*s + 320*C*D1*Ddd*f**2*r - 80*C*D1*Ddd*f**2*s**2 + 200*C*D1*Ddd*f**2*s - 140*C*D1*Ddd*f**2 - 720*C*Dd**2*f**2*r**2 - 960*C*Dd**2*f**2*r*s + 960*C*Dd**2*f**2*r - 240*C*Dd**2*f**2*s**2 + 600*C*Dd**2*f**2*s - 280*C*Dd**2*f**2 + 144*D1**2*K*f*fd*r*s - 72*D1**2*K*f*fd*r + 144*D1**2*K*f*fd*s**2 - 144*D1**2*K*f*fd*s + 72*D1**2*K*f*fd - 120*D1**2*K*f*fdd*r*s + 60*D1**2*K*f*fdd*r - 120*D1**2*K*f*fdd*s**2 + 120*D1**2*K*f*fdd*s - 60*D1**2*K*f*fdd - 120*D1**2*K*fd**2*r*s + 60*D1**2*K*fd**2*r - 120*D1**2*K*fd**2*s**2 + 120*D1**2*K*fd**2*s + 28*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(10*f**2*(2*r**2 + 2*r*(6*s - 5) + 10*s**2 - 20*s + 9) + f*(48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - K*(62*r**2 + 84*r*s - 62*r + 22*s**2 - 42*s + 31) + 86*r**2 + 228*r*s - 110*r + 142*s**2 - 210*s + 67) - 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 315*D1**2*f**2*fd*r**2 + 1140*D1**2*f**2*fd*r*s - 680*D1**2*f**2*fd*r + 825*D1**2*f**2*fd*s**2 - 1050*D1**2*f**2*fd*s + 425*D1**2*f**2*fd - 405*D1**2*f**2*fdd*r**2 - 960*D1**2*f**2*fdd*r*s + 700*D1**2*f**2*fdd*r - 555*D1**2*f**2*fdd*s**2 + 790*D1**2*f**2*fdd*s - 375*D1**2*f**2*fdd - 810*D1**2*f*fd**2*r**2 - 1920*D1**2*f*fd**2*r*s + 1400*D1**2*f*fd**2*r - 1110*D1**2*f*fd**2*s**2 + 1580*D1**2*f*fd**2*s - 530*D1**2*f*fd**2 + 56*D1**2*f*fd*r**2 + 72*D1**2*f*fd*r*s - 44*D1**2*f*fd*r + 16*D1**2*f*fd*s**2 + 56*D1**2*f*fd*s + 60*D1**2*f*fd - 40*D1**2*f*fdd*r**2 - 144*D1**2*f*fdd*r*s - 8*D1**2*f*fdd*r - 104*D1**2*f*fdd*s**2 + 44*D1**2*f*fdd*s - 42*D1**2*f*fdd - 26*D1**2*f*gd2*r**2 - 140*D1**2*f*gd2*r*s + 52*D1**2*f*gd2*r - 114*D1**2*f*gd2*s**2 + 140*D1**2*f*gd2*s - 26*D1**2*f*gd2 + 62*D1**2*f*gdd2*r**2 + 84*D1**2*f*gdd2*r*s - 124*D1**2*f*gdd2*r + 22*D1**2*f*gdd2*s**2 - 84*D1**2*f*gdd2*s + 62*D1**2*f*gdd2 - 40*D1**2*fd**2*r**2 - 144*D1**2*fd**2*r*s - 8*D1**2*fd**2*r - 104*D1**2*fd**2*s**2 + 44*D1**2*fd**2*s + 120*D1**2*fd**2 - 26*D1**2*fd*g2*r**2 - 140*D1**2*fd*g2*r*s + 140*D1**2*fd*g2*r - 114*D1**2*fd*g2*s**2 + 228*D1**2*fd*g2*s - 114*D1**2*fd*g2 + 124*D1**2*fd*gd2*r**2 + 168*D1**2*fd*gd2*r*s - 208*D1**2*fd*gd2*r + 44*D1**2*fd*gd2*s**2 - 128*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 + 62*D1**2*fdd*g2*r**2 + 84*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r + 22*D1**2*fdd*g2*s**2 - 44*D1**2*fdd*g2*s + 22*D1**2*fdd*g2 + 288*D1*Dd*K*f**2*r*s - 72*D1*Dd*K*f**2*r + 288*D1*Dd*K*f**2*s**2 - 288*D1*Dd*K*f**2*s + 72*D1*Dd*K*f**2 - 960*D1*Dd*K*f*fd*r*s + 360*D1*Dd*K*f*fd*r - 960*D1*Dd*K*f*fd*s**2 + 960*D1*Dd*K*f*fd*s - 240*D1*Dd*K*f*fd + 420*D1*Dd*f**3*r**2 + 1520*D1*Dd*f**3*r*s - 800*D1*Dd*f**3*r + 1100*D1*Dd*f**3*s**2 - 1310*D1*Dd*f**3*s + 485*D1*Dd*f**3 - 3240*D1*Dd*f**2*fd*r**2 - 7680*D1*Dd*f**2*fd*r*s + 5380*D1*Dd*f**2*fd*r - 4440*D1*Dd*f**2*fd*s**2 + 6190*D1*Dd*f**2*fd*s - 2190*D1*Dd*f**2*fd + 112*D1*Dd*f**2*r**2 + 144*D1*Dd*f**2*r*s - 148*D1*Dd*f**2*r + 32*D1*Dd*f**2*s**2 - 88*D1*Dd*f**2*s + 64*D1*Dd*f**2 - 320*D1*Dd*f*fd*r**2 - 1152*D1*Dd*f*fd*r*s + 272*D1*Dd*f*fd*r - 832*D1*Dd*f*fd*s**2 + 672*D1*Dd*f*fd*s - 28*D1*Dd*f*fd - 104*D1*Dd*f*g2*r**2 - 560*D1*Dd*f*g2*r*s + 244*D1*Dd*f*g2*r - 456*D1*Dd*f*g2*s**2 + 508*D1*Dd*f*g2*s - 166*D1*Dd*f*g2 + 496*D1*Dd*f*gd2*r**2 + 672*D1*Dd*f*gd2*r*s - 828*D1*Dd*f*gd2*r + 176*D1*Dd*f*gd2*s**2 - 548*D1*Dd*f*gd2*s + 332*D1*Dd*f*gd2 + 496*D1*Dd*fd*g2*r**2 + 672*D1*Dd*fd*g2*r*s - 668*D1*Dd*fd*g2*r + 176*D1*Dd*fd*g2*s**2 - 388*D1*Dd*fd*g2*s + 212*D1*Dd*fd*g2 - 240*D1*Ddd*K*f**2*r*s + 60*D1*Ddd*K*f**2*r - 240*D1*Ddd*K*f**2*s**2 + 240*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 - 540*D1*Ddd*f**3*r**2 - 1280*D1*Ddd*f**3*r*s + 860*D1*Ddd*f**3*r - 740*D1*Ddd*f**3*s**2 + 1010*D1*Ddd*f**3*s - 455*D1*Ddd*f**3 - 80*D1*Ddd*f**2*r**2 - 288*D1*Ddd*f**2*r*s + 152*D1*Ddd*f**2*r - 208*D1*Ddd*f**2*s**2 + 248*D1*Ddd*f**2*s - 92*D1*Ddd*f**2 + 248*D1*Ddd*f*g2*r**2 + 336*D1*Ddd*f*g2*r*s - 332*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2*s**2 - 212*D1*Ddd*f*g2*s + 146*D1*Ddd*f*g2 + D1*bd1*(D1*(-8*f**2*(2*r**2 + r*(24*s - 19) + 22*s**2 - 41*s + 18) + f*(-96*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 26*K*r**2 + 140*K*r*s - 26*K*r + 114*K*s**2 - 70*K*s + 13*K + 20*fd*(4*r**2 + 24*r*s - 10*r + 20*s**2 - 22*s + 5) - 46*r**2 - 260*r*s + 66*r - 214*s**2 + 266*s - 43) + 2*fd*(24*C*(r*(4*s - 1) + (1 - 2*s)**2) - K*(62*r**2 + 84*r*s - 73*r + 22*s**2 - 43*s + 21) + 86*r**2 + 228*r*s - 145*r + 142*s**2 - 151*s + 21) + 56*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 56*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(20*f**2*(4*r**2 + 3*r*(8*s - 5) + 20*s**2 - 31*s + 10) + f*(48*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - K*(248*r**2 + 336*r*s - 290*r + 88*s**2 - 190*s + 83) + 344*r**2 + 912*r*s - 506*r + 568*s**2 - 790*s + 215) - 56*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 720*Dd**2*K*f**2*r*s + 180*Dd**2*K*f**2*r - 720*Dd**2*K*f**2*s**2 + 720*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 - 1620*Dd**2*f**3*r**2 - 3840*Dd**2*f**3*r*s + 2580*Dd**2*f**3*r - 2220*Dd**2*f**3*s**2 + 3030*Dd**2*f**3*s - 910*Dd**2*f**3 - 240*Dd**2*f**2*r**2 - 864*Dd**2*f**2*r*s + 456*Dd**2*f**2*r - 624*Dd**2*f**2*s**2 + 744*Dd**2*f**2*s - 184*Dd**2*f**2 + 744*Dd**2*f*g2*r**2 + 1008*Dd**2*f*g2*r*s - 996*Dd**2*f*g2*r + 264*Dd**2*f*g2*s**2 - 636*Dd**2*f*g2*s + 292*Dd**2*f*g2))/(231*d**2*k3**3) + 8*D1**2*Pk2*Pkd3*ct**4*k1**2*(-D1*f*(D1*bd1**2*s*(5*f + 6)*(2*r + 2*s - 1) + D1*bd1*(-4*f*s*(r + s) + 5*fd*(r*(4*s - 1) + s*(4*s - 3))) + 5*D1*bdd1*f*s*(r + s) + 5*Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + b1**2*(-D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) + fd*(f*(4 - 8*s) - 5*s + 5) + fdd*(10*f*s - 5*f + 6*s - 6)) + D1*(Dd*(4*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 5*f*(fd*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - 4*r*s + r - 4*s**2 + 4*s - 1) - 6*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(5*f + 6)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(5*f + 6)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(6*bdd1*s*(2*r + 2*s - 1) - 4*fd*(2*s - 1)*(r + s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) + 5*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + f*s*(4*f + 5)*(2*r + 2*s - 1) - 6*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - Dd*f*(5*f + 6)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*f*(Dd*(4*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k2**2*k3) + 15*D1**2*Pk2*Pkd3*ct**4*k2**6*st**2*(D1**2*(f**2*(fd*(100*C - 50)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(50*C - 25)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(100*C - 50)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 66*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(50*C - 25)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(33*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(25 - 50*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 33*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(50*C*f + 33*K*b1 - 25*f - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(50*C*f + 33*K*b1 - 25*f - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(154*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct**4*k2**6*(40*C*D1**2*b1*f*fd*r**2 + 80*C*D1**2*b1*f*fd*r*s - 40*C*D1**2*b1*f*fd*r + 40*C*D1**2*b1*f*fd*s**2 - 40*C*D1**2*b1*f*fd*s + 20*C*D1**2*b1*f*fd - 20*C*D1**2*b1*f*fdd*r**2 - 40*C*D1**2*b1*f*fdd*r*s + 20*C*D1**2*b1*f*fdd*r - 20*C*D1**2*b1*f*fdd*s**2 + 20*C*D1**2*b1*f*fdd*s - 10*C*D1**2*b1*f*fdd - 20*C*D1**2*b1*fd**2*r**2 - 40*C*D1**2*b1*fd**2*r*s + 20*C*D1**2*b1*fd**2*r - 20*C*D1**2*b1*fd**2*s**2 + 20*C*D1**2*b1*fd**2*s - 30*C*D1**2*f**2*fd*r**2 - 60*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 80*C*D1*Dd*b1*f**2*r**2 + 160*C*D1*Dd*b1*f**2*r*s - 120*C*D1*Dd*b1*f**2*r + 80*C*D1*Dd*b1*f**2*s**2 - 120*C*D1*Dd*b1*f**2*s + 60*C*D1*Dd*b1*f**2 - 160*C*D1*Dd*b1*f*fd*r**2 - 320*C*D1*Dd*b1*f*fd*r*s + 200*C*D1*Dd*b1*f*fd*r - 160*C*D1*Dd*b1*f*fd*s**2 + 200*C*D1*Dd*b1*f*fd*s - 60*C*D1*Dd*b1*f*fd - 40*C*D1*Dd*f**3*r**2 - 80*C*D1*Dd*f**3*r*s + 60*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 60*C*D1*Dd*f**3*s - 30*C*D1*Dd*f**3 - 40*C*D1*Ddd*b1*f**2*r**2 - 80*C*D1*Ddd*b1*f**2*r*s + 60*C*D1*Ddd*b1*f**2*r - 40*C*D1*Ddd*b1*f**2*s**2 + 60*C*D1*Ddd*b1*f**2*s - 30*C*D1*Ddd*b1*f**2 - 120*C*Dd**2*b1*f**2*r**2 - 240*C*Dd**2*b1*f**2*r*s + 180*C*Dd**2*b1*f**2*r - 120*C*Dd**2*b1*f**2*s**2 + 180*C*Dd**2*b1*f**2*s - 60*C*Dd**2*b1*f**2 + 12*D1**2*K*b1**2*fd*r**2 + 24*D1**2*K*b1**2*fd*r*s + 12*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r**2 - 12*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 - 12*D1**2*K*b1*f*fd*r**2 - 24*D1**2*K*b1*f*fd*r*s + 12*D1**2*K*b1*f*fd*r - 12*D1**2*K*b1*f*fd*s**2 + 12*D1**2*K*b1*f*fd*s - 6*D1**2*K*b1*f*fd - 12*D1**2*K*bd1**2*f*(r + s - 1)**2 - 20*D1**2*b1*f*fd*r**2 - 40*D1**2*b1*f*fd*r*s + 20*D1**2*b1*f*fd*r - 20*D1**2*b1*f*fd*s**2 + 20*D1**2*b1*f*fd*s - 10*D1**2*b1*f*fd + 10*D1**2*b1*f*fdd*r**2 + 20*D1**2*b1*f*fdd*r*s - 10*D1**2*b1*f*fdd*r + 10*D1**2*b1*f*fdd*s**2 - 10*D1**2*b1*f*fdd*s + 5*D1**2*b1*f*fdd - 24*D1**2*b1*f*gd2*r**2 - 48*D1**2*b1*f*gd2*r*s + 48*D1**2*b1*f*gd2*r - 24*D1**2*b1*f*gd2*s**2 + 48*D1**2*b1*f*gd2*s - 24*D1**2*b1*f*gd2 + 12*D1**2*b1*f*gdd2*r**2 + 24*D1**2*b1*f*gdd2*r*s - 24*D1**2*b1*f*gdd2*r + 12*D1**2*b1*f*gdd2*s**2 - 24*D1**2*b1*f*gdd2*s + 12*D1**2*b1*f*gdd2 + 10*D1**2*b1*fd**2*r**2 + 20*D1**2*b1*fd**2*r*s - 10*D1**2*b1*fd**2*r + 10*D1**2*b1*fd**2*s**2 - 10*D1**2*b1*fd**2*s - 24*D1**2*b1*fd*g2*r**2 - 48*D1**2*b1*fd*g2*r*s - 24*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r**2 + 48*D1**2*b1*fd*gd2*r*s - 24*D1**2*b1*fd*gd2*r + 24*D1**2*b1*fd*gd2*s**2 - 24*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r**2 + 24*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 12*K*b1 - 5*f - 12*g2) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 12*D1**2*f**2*gd2*r**2 + 24*D1**2*f**2*gd2*r*s - 24*D1**2*f**2*gd2*r + 12*D1**2*f**2*gd2*s**2 - 24*D1**2*f**2*gd2*s + 12*D1**2*f**2*gd2 + 24*D1**2*f*fd*g2*r**2 + 48*D1**2*f*fd*g2*r*s - 24*D1**2*f*fd*g2*r + 24*D1**2*f*fd*g2*s**2 - 24*D1**2*f*fd*g2*s + 12*D1**2*f*fd*g2 + 48*D1*Dd*K*b1**2*f*r**2 + 96*D1*Dd*K*b1**2*f*r*s - 72*D1*Dd*K*b1**2*f*r + 48*D1*Dd*K*b1**2*f*s**2 - 72*D1*Dd*K*b1**2*f*s + 36*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 96*D1*Dd*K*b1**2*fd*r*s + 36*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 36*D1*Dd*K*b1**2*fd*s - 24*D1*Dd*K*b1*f**2*r**2 - 48*D1*Dd*K*b1*f**2*r*s + 36*D1*Dd*K*b1*f**2*r - 24*D1*Dd*K*b1*f**2*s**2 + 36*D1*Dd*K*b1*f**2*s - 18*D1*Dd*K*b1*f**2 - 40*D1*Dd*b1*f**2*r**2 - 80*D1*Dd*b1*f**2*r*s + 60*D1*Dd*b1*f**2*r - 40*D1*Dd*b1*f**2*s**2 + 60*D1*Dd*b1*f**2*s - 30*D1*Dd*b1*f**2 + 80*D1*Dd*b1*f*fd*r**2 + 160*D1*Dd*b1*f*fd*r*s - 100*D1*Dd*b1*f*fd*r + 80*D1*Dd*b1*f*fd*s**2 - 100*D1*Dd*b1*f*fd*s + 30*D1*Dd*b1*f*fd - 96*D1*Dd*b1*f*g2*r**2 - 192*D1*Dd*b1*f*g2*r*s + 144*D1*Dd*b1*f*g2*r - 96*D1*Dd*b1*f*g2*s**2 + 144*D1*Dd*b1*f*g2*s - 72*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 192*D1*Dd*b1*f*gd2*r*s - 168*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 168*D1*Dd*b1*f*gd2*s + 72*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 192*D1*Dd*b1*fd*g2*r*s - 72*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 72*D1*Dd*b1*fd*g2*s + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 48*D1*Dd*f**2*g2*r**2 + 96*D1*Dd*f**2*g2*r*s - 72*D1*Dd*f**2*g2*r + 48*D1*Dd*f**2*g2*s**2 - 72*D1*Dd*f**2*g2*s + 36*D1*Dd*f**2*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 48*D1*Ddd*K*b1**2*f*r*s + 36*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 36*D1*Ddd*K*b1**2*f*s - 18*D1*Ddd*K*b1**2*f + 20*D1*Ddd*b1*f**2*r**2 + 40*D1*Ddd*b1*f**2*r*s - 30*D1*Ddd*b1*f**2*r + 20*D1*Ddd*b1*f**2*s**2 - 30*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 96*D1*Ddd*b1*f*g2*r*s - 72*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 72*D1*Ddd*b1*f*g2*s + 36*D1*Ddd*b1*f*g2 + 2*D1*bd1*(D1*(f**2*(10*C - 3*K - 5)*(r + s - 1) - f*fd*(10*C - 5)*(2*r + 2*s - 1) - 12*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 12*fd*(r + s)*(-K*b1 + g2)) - Dd*f*(4*r + 4*s - 3)*(10*C*f + 12*K*b1 - 5*f - 12*g2))*(r + s - 1) - 72*Dd**2*K*b1**2*f*r**2 - 144*Dd**2*K*b1**2*f*r*s + 108*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 108*Dd**2*K*b1**2*f*s - 36*Dd**2*K*b1**2*f + 60*Dd**2*b1*f**2*r**2 + 120*Dd**2*b1*f**2*r*s - 90*Dd**2*b1*f**2*r + 60*Dd**2*b1*f**2*s**2 - 90*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 288*Dd**2*b1*f*g2*r*s - 216*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 216*Dd**2*b1*f*g2*s + 72*Dd**2*b1*f*g2)/(7*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**4*k2**4*st**2*(-41844*C*D1**2*f**2*fd*r**2 - 64344*C*D1**2*f**2*fd*r*s + 49344*C*D1**2*f**2*fd*r - 22500*C*D1**2*f**2*fd*s**2 + 36448*C*D1**2*f**2*fd*s - 21448*C*D1**2*f**2*fd + 24090*C*D1**2*f**2*fdd*r**2 + 35340*C*D1**2*f**2*fdd*r*s - 27840*C*D1**2*f**2*fdd*r + 11250*C*D1**2*f**2*fdd*s**2 - 19280*C*D1**2*f**2*fdd*s + 11780*C*D1**2*f**2*fdd + 48180*C*D1**2*f*fd**2*r**2 + 70680*C*D1**2*f*fd**2*r*s - 55680*C*D1**2*f*fd**2*r + 22500*C*D1**2*f*fd**2*s**2 - 38560*C*D1**2*f*fd**2*s + 11780*C*D1**2*f*fd**2 - 55792*C*D1*Dd*f**3*r**2 - 85792*C*D1*Dd*f**3*r*s + 77240*C*D1*Dd*f**3*r - 30000*C*D1*Dd*f**3*s**2 + 57896*C*D1*Dd*f**3*s - 35396*C*D1*Dd*f**3 + 192720*C*D1*Dd*f**2*fd*r**2 + 282720*C*D1*Dd*f**2*fd*r*s - 243060*C*D1*Dd*f**2*fd*r + 90000*C*D1*Dd*f**2*fd*s**2 - 170300*C*D1*Dd*f**2*fd*s + 74960*C*D1*Dd*f**2*fd + 32120*C*D1*Ddd*f**3*r**2 + 47120*C*D1*Ddd*f**3*r*s - 43900*C*D1*Ddd*f**3*r + 15000*C*D1*Ddd*f**3*s**2 - 31060*C*D1*Ddd*f**3*s + 19810*C*D1*Ddd*f**3 + 96360*C*Dd**2*f**3*r**2 + 141360*C*Dd**2*f**3*r*s - 131700*C*Dd**2*f**3*r + 45000*C*Dd**2*f**3*s**2 - 93180*C*Dd**2*f**3*s + 39620*C*Dd**2*f**3 - 17820*D1**2*K*b1*f*fd*r**2 - 27720*D1**2*K*b1*f*fd*r*s + 13860*D1**2*K*b1*f*fd*r - 9900*D1**2*K*b1*f*fd*s**2 + 9900*D1**2*K*b1*f*fd*s - 4950*D1**2*K*b1*f*fd + 8910*D1**2*K*b1*f*fdd*r**2 + 13860*D1**2*K*b1*f*fdd*r*s - 6930*D1**2*K*b1*f*fdd*r + 4950*D1**2*K*b1*f*fdd*s**2 - 4950*D1**2*K*b1*f*fdd*s + 2475*D1**2*K*b1*f*fdd + 8910*D1**2*K*b1*fd**2*r**2 + 13860*D1**2*K*b1*fd**2*r*s - 6930*D1**2*K*b1*fd**2*r + 4950*D1**2*K*b1*fd**2*s**2 - 4950*D1**2*K*b1*fd**2*s + 4455*D1**2*K*bdd1*f**2*r**2 + 6930*D1**2*K*bdd1*f**2*r*s - 8910*D1**2*K*bdd1*f**2*r + 2475*D1**2*K*bdd1*f**2*s**2 - 6930*D1**2*K*bdd1*f**2*s + 4455*D1**2*K*bdd1*f**2 + 2970*D1**2*b1*f**2*fd*r**2 + 2970*D1**2*b1*f**2*fd*r*s - 2970*D1**2*b1*f**2*fd*r - 990*D1**2*b1*f**2*fd*s + 990*D1**2*b1*f**2*fd - 2970*D1**2*b1*f**2*fdd*r**2 - 2970*D1**2*b1*f**2*fdd*r*s + 2970*D1**2*b1*f**2*fdd*r + 990*D1**2*b1*f**2*fdd*s - 990*D1**2*b1*f**2*fdd - 5940*D1**2*b1*f*fd**2*r**2 - 5940*D1**2*b1*f*fd**2*r*s + 5940*D1**2*b1*f*fd**2*r + 1980*D1**2*b1*f*fd**2*s - 990*D1**2*b1*f*fd**2 + 3960*D1**2*b1*f*fd*r**2 + 3960*D1**2*b1*f*fd*r*s - 1980*D1**2*b1*f*fd*r - 1980*D1**2*b1*f*fdd*r**2 - 1980*D1**2*b1*f*fdd*r*s + 990*D1**2*b1*f*fdd*r - 1980*D1**2*b1*fd**2*r**2 - 1980*D1**2*b1*fd**2*r*s + 990*D1**2*b1*fd**2*r - 9900*D1**2*b2*f*fd*r**2 - 19800*D1**2*b2*f*fd*r*s + 9900*D1**2*b2*f*fd*r - 9900*D1**2*b2*f*fd*s**2 + 9900*D1**2*b2*f*fd*s - 4950*D1**2*b2*f*fd + 4950*D1**2*b2*f*fdd*r**2 + 9900*D1**2*b2*f*fdd*r*s - 4950*D1**2*b2*f*fdd*r + 4950*D1**2*b2*f*fdd*s**2 - 4950*D1**2*b2*f*fdd*s + 2475*D1**2*b2*f*fdd + 4950*D1**2*b2*fd**2*r**2 + 9900*D1**2*b2*fd**2*r*s - 4950*D1**2*b2*fd**2*r + 4950*D1**2*b2*fd**2*s**2 - 4950*D1**2*b2*fd**2*s - 990*D1**2*bdd1*f**3*r**2 - 990*D1**2*bdd1*f**3*r*s + 1980*D1**2*bdd1*f**3*r + 990*D1**2*bdd1*f**3*s - 990*D1**2*bdd1*f**3 - 990*D1**2*bdd1*f**2*r**2 - 990*D1**2*bdd1*f**2*r*s + 1980*D1**2*bdd1*f**2*r + 990*D1**2*bdd1*f**2*s - 990*D1**2*bdd1*f**2 + 2475*D1**2*bdd2*f**2*r**2 + 4950*D1**2*bdd2*f**2*r*s - 4950*D1**2*bdd2*f**2*r + 2475*D1**2*bdd2*f**2*s**2 - 4950*D1**2*bdd2*f**2*s + 2475*D1**2*bdd2*f**2 + 25758*D1**2*f**2*fd*r**2 + 37008*D1**2*f**2*fd*r*s - 29508*D1**2*f**2*fd*r + 11250*D1**2*f**2*fd*s**2 - 19836*D1**2*f**2*fd*s + 12336*D1**2*f**2*fd - 15255*D1**2*f**2*fdd*r**2 - 20880*D1**2*f**2*fdd*r*s + 17130*D1**2*f**2*fdd*r - 5625*D1**2*f**2*fdd*s**2 + 10710*D1**2*f**2*fdd*s - 6960*D1**2*f**2*fdd + 17820*D1**2*f**2*gd2*r**2 + 27720*D1**2*f**2*gd2*r*s - 35640*D1**2*f**2*gd2*r + 9900*D1**2*f**2*gd2*s**2 - 27720*D1**2*f**2*gd2*s + 17820*D1**2*f**2*gd2 - 8910*D1**2*f**2*gdd2*r**2 - 13860*D1**2*f**2*gdd2*r*s + 17820*D1**2*f**2*gdd2*r - 4950*D1**2*f**2*gdd2*s**2 + 13860*D1**2*f**2*gdd2*s - 8910*D1**2*f**2*gdd2 - 30510*D1**2*f*fd**2*r**2 - 41760*D1**2*f*fd**2*r*s + 34260*D1**2*f*fd**2*r - 11250*D1**2*f*fd**2*s**2 + 21420*D1**2*f*fd**2*s - 6960*D1**2*f*fd**2 + 35640*D1**2*f*fd*g2*r**2 + 55440*D1**2*f*fd*g2*r*s - 27720*D1**2*f*fd*g2*r + 19800*D1**2*f*fd*g2*s**2 - 19800*D1**2*f*fd*g2*s + 9900*D1**2*f*fd*g2 - 35640*D1**2*f*fd*gd2*r**2 - 55440*D1**2*f*fd*gd2*r*s + 49500*D1**2*f*fd*gd2*r - 19800*D1**2*f*fd*gd2*s**2 + 37620*D1**2*f*fd*gd2*s - 13860*D1**2*f*fd*gd2 - 17820*D1**2*f*fdd*g2*r**2 - 27720*D1**2*f*fdd*g2*r*s + 13860*D1**2*f*fdd*g2*r - 9900*D1**2*f*fdd*g2*s**2 + 9900*D1**2*f*fdd*g2*s - 4950*D1**2*f*fdd*g2 - 17820*D1**2*fd**2*g2*r**2 - 27720*D1**2*fd**2*g2*r*s + 13860*D1**2*fd**2*g2*r - 9900*D1**2*fd**2*g2*s**2 + 9900*D1**2*fd**2*g2*s - 35640*D1*Dd*K*b1*f**2*r**2 - 55440*D1*Dd*K*b1*f**2*r*s + 49500*D1*Dd*K*b1*f**2*r - 19800*D1*Dd*K*b1*f**2*s**2 + 37620*D1*Dd*K*b1*f**2*s - 22770*D1*Dd*K*b1*f**2 + 71280*D1*Dd*K*b1*f*fd*r**2 + 110880*D1*Dd*K*b1*f*fd*r*s - 77220*D1*Dd*K*b1*f*fd*r + 39600*D1*Dd*K*b1*f*fd*s**2 - 57420*D1*Dd*K*b1*f*fd*s + 18810*D1*Dd*K*b1*f*fd + 3960*D1*Dd*b1*f**3*r**2 + 3960*D1*Dd*b1*f**3*r*s - 4950*D1*Dd*b1*f**3*r - 1980*D1*Dd*b1*f**3*s + 1980*D1*Dd*b1*f**3 - 23760*D1*Dd*b1*f**2*fd*r**2 - 23760*D1*Dd*b1*f**2*fd*r*s + 26730*D1*Dd*b1*f**2*fd*r + 9900*D1*Dd*b1*f**2*fd*s - 6930*D1*Dd*b1*f**2*fd + 7920*D1*Dd*b1*f**2*r**2 + 7920*D1*Dd*b1*f**2*r*s - 9900*D1*Dd*b1*f**2*r - 3960*D1*Dd*b1*f**2*s + 3960*D1*Dd*b1*f**2 - 15840*D1*Dd*b1*f*fd*r**2 - 15840*D1*Dd*b1*f*fd*r*s + 13860*D1*Dd*b1*f*fd*r + 3960*D1*Dd*b1*f*fd*s - 1980*D1*Dd*b1*f*fd - 19800*D1*Dd*b2*f**2*r**2 - 39600*D1*Dd*b2*f**2*r*s + 29700*D1*Dd*b2*f**2*r - 19800*D1*Dd*b2*f**2*s**2 + 29700*D1*Dd*b2*f**2*s - 14850*D1*Dd*b2*f**2 + 39600*D1*Dd*b2*f*fd*r**2 + 79200*D1*Dd*b2*f*fd*r*s - 49500*D1*Dd*b2*f*fd*r + 39600*D1*Dd*b2*f*fd*s**2 - 49500*D1*Dd*b2*f*fd*s + 14850*D1*Dd*b2*f*fd + 34344*D1*Dd*f**3*r**2 + 49344*D1*Dd*f**3*r*s - 46680*D1*Dd*f**3*r + 15000*D1*Dd*f**3*s**2 - 32172*D1*Dd*f**3*s + 20922*D1*Dd*f**3 - 122040*D1*Dd*f**2*fd*r**2 - 167040*D1*Dd*f**2*fd*r*s + 150420*D1*Dd*f**2*fd*r - 45000*D1*Dd*f**2*fd*s**2 + 95850*D1*Dd*f**2*fd*s - 44970*D1*Dd*f**2*fd + 71280*D1*Dd*f**2*g2*r**2 + 110880*D1*Dd*f**2*g2*r*s - 99000*D1*Dd*f**2*g2*r + 39600*D1*Dd*f**2*g2*s**2 - 75240*D1*Dd*f**2*g2*s + 45540*D1*Dd*f**2*g2 - 71280*D1*Dd*f**2*gd2*r**2 - 110880*D1*Dd*f**2*gd2*r*s + 120780*D1*Dd*f**2*gd2*r - 39600*D1*Dd*f**2*gd2*s**2 + 93060*D1*Dd*f**2*gd2*s - 49500*D1*Dd*f**2*gd2 - 142560*D1*Dd*f*fd*g2*r**2 - 221760*D1*Dd*f*fd*g2*r*s + 154440*D1*Dd*f*fd*g2*r - 79200*D1*Dd*f*fd*g2*s**2 + 114840*D1*Dd*f*fd*g2*s - 37620*D1*Dd*f*fd*g2 + 17820*D1*Ddd*K*b1*f**2*r**2 + 27720*D1*Ddd*K*b1*f**2*r*s - 24750*D1*Ddd*K*b1*f**2*r + 9900*D1*Ddd*K*b1*f**2*s**2 - 18810*D1*Ddd*K*b1*f**2*s + 11385*D1*Ddd*K*b1*f**2 - 3960*D1*Ddd*b1*f**3*r**2 - 3960*D1*Ddd*b1*f**3*r*s + 4950*D1*Ddd*b1*f**3*r + 1980*D1*Ddd*b1*f**3*s - 1980*D1*Ddd*b1*f**3 - 3960*D1*Ddd*b1*f**2*r**2 - 3960*D1*Ddd*b1*f**2*r*s + 4950*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s - 1980*D1*Ddd*b1*f**2 + 9900*D1*Ddd*b2*f**2*r**2 + 19800*D1*Ddd*b2*f**2*r*s - 14850*D1*Ddd*b2*f**2*r + 9900*D1*Ddd*b2*f**2*s**2 - 14850*D1*Ddd*b2*f**2*s + 7425*D1*Ddd*b2*f**2 - 20340*D1*Ddd*f**3*r**2 - 27840*D1*Ddd*f**3*r*s + 27300*D1*Ddd*f**3*r - 7500*D1*Ddd*f**3*s**2 + 17670*D1*Ddd*f**3*s - 12045*D1*Ddd*f**3 - 35640*D1*Ddd*f**2*g2*r**2 - 55440*D1*Ddd*f**2*g2*r*s + 49500*D1*Ddd*f**2*g2*r - 19800*D1*Ddd*f**2*g2*s**2 + 37620*D1*Ddd*f**2*g2*s - 22770*D1*Ddd*f**2*g2 + 990*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (r + s - 1)*(K*(9*r + 5*s - 9) - 2*r + 2)) + fd*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(K*(36*r**2 + 56*r*s - 61*r + 20*s**2 - 47*s + 25) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) - 4950*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 53460*Dd**2*K*b1*f**2*r**2 + 83160*Dd**2*K*b1*f**2*r*s - 74250*Dd**2*K*b1*f**2*r + 29700*Dd**2*K*b1*f**2*s**2 - 56430*Dd**2*K*b1*f**2*s + 22770*Dd**2*K*b1*f**2 - 11880*Dd**2*b1*f**3*r**2 - 11880*Dd**2*b1*f**3*r*s + 14850*Dd**2*b1*f**3*r + 5940*Dd**2*b1*f**3*s - 3960*Dd**2*b1*f**3 - 11880*Dd**2*b1*f**2*r**2 - 11880*Dd**2*b1*f**2*r*s + 14850*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s - 3960*Dd**2*b1*f**2 + 29700*Dd**2*b2*f**2*r**2 + 59400*Dd**2*b2*f**2*r*s - 44550*Dd**2*b2*f**2*r + 29700*Dd**2*b2*f**2*s**2 - 44550*Dd**2*b2*f**2*s + 14850*Dd**2*b2*f**2 - 61020*Dd**2*f**3*r**2 - 83520*Dd**2*f**3*r*s + 81900*Dd**2*f**3*r - 22500*Dd**2*f**3*s**2 + 53010*Dd**2*f**3*s - 24090*Dd**2*f**3 - 106920*Dd**2*f**2*g2*r**2 - 166320*Dd**2*f**2*g2*r*s + 148500*Dd**2*f**2*g2*r - 59400*Dd**2*f**2*g2*s**2 + 112860*Dd**2*f**2*g2*s - 45540*Dd**2*f**2*g2)/(1386*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**4*k2**4*(-1232*C*D1**2*bd1*f**2*r**2 - 2112*C*D1**2*bd1*f**2*r*s + 4312*C*D1**2*bd1*f**2*r - 880*C*D1**2*bd1*f**2*s**2 + 3960*C*D1**2*bd1*f**2*s - 1980*C*D1**2*bd1*f**2 + 2464*C*D1**2*bd1*f*fd*r**2 + 4224*C*D1**2*bd1*f*fd*r*s - 4444*C*D1**2*bd1*f*fd*r + 1760*C*D1**2*bd1*f*fd*s**2 - 3916*C*D1**2*bd1*f*fd*s + 2156*C*D1**2*bd1*f*fd + 616*C*D1**2*bdd1*f**2*r**2 + 1056*C*D1**2*bdd1*f**2*r*s - 2156*C*D1**2*bdd1*f**2*r + 440*C*D1**2*bdd1*f**2*s**2 - 1980*C*D1**2*bdd1*f**2*s + 990*C*D1**2*bdd1*f**2 + 780*C*D1**2*f**2*fd*r**2 + 120*C*D1**2*f**2*fd*r*s - 560*C*D1**2*f**2*fd*r - 660*C*D1**2*f**2*fd*s**2 + 400*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd + 2250*C*D1**2*f**2*fdd*r**2 + 5220*C*D1**2*f**2*fdd*r*s - 3240*C*D1**2*f**2*fdd*r + 2970*C*D1**2*f**2*fdd*s**2 - 3720*C*D1**2*f**2*fdd*s + 1740*C*D1**2*f**2*fdd + 4500*C*D1**2*f*fd**2*r**2 + 10440*C*D1**2*f*fd**2*r*s - 6480*C*D1**2*f*fd**2*r + 5940*C*D1**2*f*fd**2*s**2 - 7440*C*D1**2*f*fd**2*s + 1740*C*D1**2*f*fd**2 + 4928*C*D1*Dd*bd1*f**2*r**2 + 8448*C*D1*Dd*bd1*f**2*r*s - 12144*C*D1*Dd*bd1*f**2*r + 3520*C*D1*Dd*bd1*f**2*s**2 - 10912*C*D1*Dd*bd1*f**2*s + 6292*C*D1*Dd*bd1*f**2 + 1040*C*D1*Dd*f**3*r**2 + 160*C*D1*Dd*f**3*r*s - 1080*C*D1*Dd*f**3*r - 880*C*D1*Dd*f**3*s**2 + 360*C*D1*Dd*f**3*s + 300*C*D1*Dd*f**3 + 18000*C*D1*Dd*f**2*fd*r**2 + 41760*C*D1*Dd*f**2*fd*r*s - 27180*C*D1*Dd*f**2*fd*r + 23760*C*D1*Dd*f**2*fd*s**2 - 31260*C*D1*Dd*f**2*fd*s + 10200*C*D1*Dd*f**2*fd + 3000*C*D1*Ddd*f**3*r**2 + 6960*C*D1*Ddd*f**3*r*s - 4740*C*D1*Ddd*f**3*r + 3960*C*D1*Ddd*f**3*s**2 - 5460*C*D1*Ddd*f**3*s + 2490*C*D1*Ddd*f**3 + 9000*C*Dd**2*f**3*r**2 + 20880*C*Dd**2*f**3*r*s - 14220*C*Dd**2*f**3*r + 11880*C*Dd**2*f**3*s**2 - 16380*C*Dd**2*f**3*s + 4980*C*Dd**2*f**3 + 528*D1**2*K*bd1**2*f*r**2 + 1056*D1**2*K*bd1**2*f*r*s - 1716*D1**2*K*bd1**2*f*r + 528*D1**2*K*bd1**2*f*s**2 - 1716*D1**2*K*bd1**2*f*s + 1188*D1**2*K*bd1**2*f + 396*D1**2*K*bd1*f**2*r**2 + 264*D1**2*K*bd1*f**2*r*s - 792*D1**2*K*bd1*f**2*r - 132*D1**2*K*bd1*f**2*s**2 - 264*D1**2*K*bd1*f**2*s + 396*D1**2*K*bd1*f**2 + 1320*D1**2*K*bd1*f*fd*r**2 + 3696*D1**2*K*bd1*f*fd*r*s - 2244*D1**2*K*bd1*f*fd*r + 2376*D1**2*K*bd1*f*fd*s**2 - 3036*D1**2*K*bd1*f*fd*s + 924*D1**2*K*bd1*f*fd + 330*D1**2*K*bdd1*f**2*r**2 + 924*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*r + 594*D1**2*K*bdd1*f**2*s**2 - 924*D1**2*K*bdd1*f**2*s + 330*D1**2*K*bdd1*f**2 - 264*D1**2*bd1**2*f**2*r**2 - 264*D1**2*bd1**2*f**2*r*s + 396*D1**2*bd1**2*f**2*r + 132*D1**2*bd1**2*f**2*s - 132*D1**2*bd1**2*f**2 - 264*D1**2*bd1**2*f*r**2 - 264*D1**2*bd1**2*f*r*s + 396*D1**2*bd1**2*f*r + 132*D1**2*bd1**2*f*s - 132*D1**2*bd1**2*f + 660*D1**2*bd1*bd2*f*r**2 + 1320*D1**2*bd1*bd2*f*r*s - 1320*D1**2*bd1*bd2*f*r + 660*D1**2*bd1*bd2*f*s**2 - 1320*D1**2*bd1*bd2*f*s + 660*D1**2*bd1*bd2*f + 792*D1**2*bd1*f**2*r**2 + 1232*D1**2*bd1*f**2*r*s - 2200*D1**2*bd1*f**2*r + 440*D1**2*bd1*f**2*s**2 - 1848*D1**2*bd1*f**2*s + 858*D1**2*bd1*f**2 - 1848*D1**2*bd1*f*fd*r**2 - 2728*D1**2*bd1*f*fd*r*s + 2838*D1**2*bd1*f*fd*r - 880*D1**2*bd1*f*fd*s**2 + 2112*D1**2*bd1*f*fd*s - 1232*D1**2*bd1*f*fd + 1056*D1**2*bd1*f*g2*r**2 + 2112*D1**2*bd1*f*g2*r*s - 4752*D1**2*bd1*f*g2*r + 1056*D1**2*bd1*f*g2*s**2 - 4752*D1**2*bd1*f*g2*s + 2376*D1**2*bd1*f*g2 - 1056*D1**2*bd1*f*gd2*r**2 - 2112*D1**2*bd1*f*gd2*r*s + 3432*D1**2*bd1*f*gd2*r - 1056*D1**2*bd1*f*gd2*s**2 + 3432*D1**2*bd1*f*gd2*s - 2376*D1**2*bd1*f*gd2 - 1056*D1**2*bd1*fd*g2*r**2 - 2112*D1**2*bd1*fd*g2*r*s + 1056*D1**2*bd1*fd*g2*r - 1056*D1**2*bd1*fd*g2*s**2 + 1056*D1**2*bd1*fd*g2*s + 330*D1**2*bd2*f**2*r**2 + 660*D1**2*bd2*f**2*r*s - 660*D1**2*bd2*f**2*r + 330*D1**2*bd2*f**2*s**2 - 660*D1**2*bd2*f**2*s + 330*D1**2*bd2*f**2 - 462*D1**2*bdd1*f**2*r**2 - 682*D1**2*bdd1*f**2*r*s + 1232*D1**2*bdd1*f**2*r - 220*D1**2*bdd1*f**2*s**2 + 990*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 528*D1**2*bdd1*f*g2*r**2 - 1056*D1**2*bdd1*f*g2*r*s + 2376*D1**2*bdd1*f*g2*r - 528*D1**2*bdd1*f*g2*s**2 + 2376*D1**2*bdd1*f*g2*s - 1188*D1**2*bdd1*f*g2 - 720*D1**2*f**2*fd*r**2 - 390*D1**2*f**2*fd*r*s + 610*D1**2*f**2*fd*r + 330*D1**2*f**2*fd*s**2 - 90*D1**2*f**2*fd*s - 130*D1**2*f**2*fd - 1125*D1**2*f**2*fdd*r**2 - 2610*D1**2*f**2*fdd*r*s + 1620*D1**2*f**2*fdd*r - 1485*D1**2*f**2*fdd*s**2 + 1860*D1**2*f**2*fdd*s - 870*D1**2*f**2*fdd - 792*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s + 1584*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s - 792*D1**2*f**2*gd2 - 660*D1**2*f**2*gdd2*r**2 - 1848*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*r - 1188*D1**2*f**2*gdd2*s**2 + 1848*D1**2*f**2*gdd2*s - 660*D1**2*f**2*gdd2 - 2250*D1**2*f*fd**2*r**2 - 5220*D1**2*f*fd**2*r*s + 3240*D1**2*f*fd**2*r - 2970*D1**2*f*fd**2*s**2 + 3720*D1**2*f*fd**2*s - 870*D1**2*f*fd**2 - 1584*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r**2 - 7392*D1**2*f*fd*gd2*r*s + 4488*D1**2*f*fd*gd2*r - 4752*D1**2*f*fd*gd2*s**2 + 6072*D1**2*f*fd*gd2*s - 1848*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r**2 - 3696*D1**2*f*fdd*g2*r*s + 1848*D1**2*f*fdd*g2*r - 2376*D1**2*f*fdd*g2*s**2 + 2376*D1**2*f*fdd*g2*s - 1188*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r**2 - 3696*D1**2*fd**2*g2*r*s + 1848*D1**2*fd**2*g2*r - 2376*D1**2*fd**2*g2*s**2 + 2376*D1**2*fd**2*g2*s + 2640*D1*Dd*K*bd1*f**2*r**2 + 7392*D1*Dd*K*bd1*f**2*r*s - 4884*D1*Dd*K*bd1*f**2*r + 4752*D1*Dd*K*bd1*f**2*s**2 - 6732*D1*Dd*K*bd1*f**2*s + 2244*D1*Dd*K*bd1*f**2 - 3696*D1*Dd*bd1*f**2*r**2 - 5456*D1*Dd*bd1*f**2*r*s + 7458*D1*Dd*bd1*f**2*r - 1760*D1*Dd*bd1*f**2*s**2 + 5764*D1*Dd*bd1*f**2*s - 3454*D1*Dd*bd1*f**2 - 4224*D1*Dd*bd1*f*g2*r**2 - 8448*D1*Dd*bd1*f*g2*r*s + 12672*D1*Dd*bd1*f*g2*r - 4224*D1*Dd*bd1*f*g2*s**2 + 12672*D1*Dd*bd1*f*g2*s - 7128*D1*Dd*bd1*f*g2 - 960*D1*Dd*f**3*r**2 - 520*D1*Dd*f**3*r*s + 1090*D1*Dd*f**3*r + 440*D1*Dd*f**3*s**2 + 40*D1*Dd*f**3*s - 370*D1*Dd*f**3 - 9000*D1*Dd*f**2*fd*r**2 - 20880*D1*Dd*f**2*fd*r*s + 13590*D1*Dd*f**2*fd*r - 11880*D1*Dd*f**2*fd*s**2 + 15630*D1*Dd*f**2*fd*s - 5100*D1*Dd*f**2*fd - 3168*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s + 3696*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 1320*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r**2 - 14784*D1*Dd*f**2*gd2*r*s + 9768*D1*Dd*f**2*gd2*r - 9504*D1*Dd*f**2*gd2*s**2 + 13464*D1*Dd*f**2*gd2*s - 4488*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r**2 - 29568*D1*Dd*f*fd*g2*r*s + 16368*D1*Dd*f*fd*g2*r - 19008*D1*Dd*f*fd*g2*s**2 + 21648*D1*Dd*f*fd*g2*s - 6072*D1*Dd*f*fd*g2 - 1500*D1*Ddd*f**3*r**2 - 3480*D1*Ddd*f**3*r*s + 2370*D1*Ddd*f**3*r - 1980*D1*Ddd*f**3*s**2 + 2730*D1*Ddd*f**3*s - 1245*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r**2 - 7392*D1*Ddd*f**2*g2*r*s + 4488*D1*Ddd*f**2*g2*r - 4752*D1*Ddd*f**2*g2*s**2 + 6072*D1*Ddd*f**2*g2*s - 2508*D1*Ddd*f**2*g2 - 330*D1*b2*(2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 4500*Dd**2*f**3*r**2 - 10440*Dd**2*f**3*r*s + 7110*Dd**2*f**3*r - 5940*Dd**2*f**3*s**2 + 8190*Dd**2*f**3*s - 2490*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r**2 - 22176*Dd**2*f**2*g2*r*s + 13464*Dd**2*f**2*g2*r - 14256*Dd**2*f**2*g2*s**2 + 18216*Dd**2*f**2*g2*s - 5016*Dd**2*f**2*g2 + 66*b1**2*(D1**2*(-2*K*fd*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-4*r**2 - 4*r*(s - 1) + 2*s) + 4*fd*r*(r + s) + fdd*(K*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) - 2*r*(r + s))) + 2*D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(K*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + 2*Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 11*b1*(-224*C*D1**2*f*fd*r**2 - 384*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r - 160*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd*s - 12*C*D1**2*f*fd + 112*C*D1**2*f*fdd*r**2 + 192*C*D1**2*f*fdd*r*s - 12*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 + 4*C*D1**2*f*fdd*s + 6*C*D1**2*f*fdd + 112*C*D1**2*fd**2*r**2 + 192*C*D1**2*fd**2*r*s - 12*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 + 4*C*D1**2*fd**2*s - 100*C*D1**2*fd**2 - 448*C*D1*Dd*f**2*r**2 - 768*C*D1*Dd*f**2*r*s + 640*C*D1*Dd*f**2*r - 320*C*D1*Dd*f**2*s**2 + 544*C*D1*Dd*f**2*s - 304*C*D1*Dd*f**2 + 896*C*D1*Dd*f*fd*r**2 + 1536*C*D1*Dd*f*fd*r*s - 688*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 528*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 224*C*D1*Ddd*f**2*r**2 + 384*C*D1*Ddd*f**2*r*s - 320*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 272*C*D1*Ddd*f**2*s + 152*C*D1*Ddd*f**2 + 672*C*Dd**2*f**2*r**2 + 1152*C*Dd**2*f**2*r*s - 960*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 816*C*Dd**2*f**2*s + 304*C*Dd**2*f**2 + 48*D1**2*K*bdd1*f*r**2 + 96*D1**2*K*bdd1*f*r*s - 156*D1**2*K*bdd1*f*r + 48*D1**2*K*bdd1*f*s**2 - 156*D1**2*K*bdd1*f*s + 78*D1**2*K*bdd1*f + 72*D1**2*K*f*fd*r**2 + 48*D1**2*K*f*fd*r*s - 24*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 60*D1**2*K*f*fdd*r**2 + 168*D1**2*K*f*fdd*r*s - 84*D1**2*K*f*fdd*r + 108*D1**2*K*f*fdd*s**2 - 108*D1**2*K*f*fdd*s + 54*D1**2*K*f*fdd + 60*D1**2*K*fd**2*r**2 + 168*D1**2*K*fd**2*r*s - 84*D1**2*K*fd**2*r + 108*D1**2*K*fd**2*s**2 - 108*D1**2*K*fd**2*s - 60*D1**2*b2*fd*r**2 - 120*D1**2*b2*fd*r*s - 60*D1**2*b2*fd*s**2 + 30*D1**2*b2*fdd*r**2 + 60*D1**2*b2*fdd*r*s + 30*D1**2*b2*fdd*s**2 - 24*D1**2*bdd1*f**2*r**2 - 24*D1**2*bdd1*f**2*r*s + 36*D1**2*bdd1*f**2*r + 12*D1**2*bdd1*f**2*s - 12*D1**2*bdd1*f**2 - 24*D1**2*bdd1*f*r**2 - 24*D1**2*bdd1*f*r*s + 36*D1**2*bdd1*f*r + 12*D1**2*bdd1*f*s - 12*D1**2*bdd1*f + 30*D1**2*bdd2*f*r**2 + 60*D1**2*bdd2*f*r*s - 60*D1**2*bdd2*f*r + 30*D1**2*bdd2*f*s**2 - 60*D1**2*bdd2*f*s + 30*D1**2*bdd2*f + 144*D1**2*f*fd*r**2 + 224*D1**2*f*fd*r*s - 56*D1**2*f*fd*r + 80*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 34*D1**2*f*fd - 84*D1**2*f*fdd*r**2 - 124*D1**2*f*fdd*r*s + 34*D1**2*f*fdd*r - 40*D1**2*f*fdd*s**2 + 12*D1**2*f*fdd*s - 17*D1**2*f*fdd + 96*D1**2*f*gd2*r**2 + 192*D1**2*f*gd2*r*s - 192*D1**2*f*gd2*r + 96*D1**2*f*gd2*s**2 - 192*D1**2*f*gd2*s + 96*D1**2*f*gd2 - 48*D1**2*f*gdd2*r**2 - 96*D1**2*f*gdd2*r*s + 96*D1**2*f*gdd2*r - 48*D1**2*f*gdd2*s**2 + 96*D1**2*f*gdd2*s - 48*D1**2*f*gdd2 - 84*D1**2*fd**2*r**2 - 124*D1**2*fd**2*r*s + 34*D1**2*fd**2*r - 40*D1**2*fd**2*s**2 + 12*D1**2*fd**2*s + 50*D1**2*fd**2 + 96*D1**2*fd*g2*r**2 + 192*D1**2*fd*g2*r*s + 240*D1**2*fd*g2*r + 96*D1**2*fd*g2*s**2 + 240*D1**2*fd*g2*s - 120*D1**2*fd*g2 - 96*D1**2*fd*gd2*r**2 - 192*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*r - 96*D1**2*fd*gd2*s**2 - 24*D1**2*fd*gd2*s + 120*D1**2*fd*gd2 - 48*D1**2*fdd*g2*r**2 - 96*D1**2*fdd*g2*r*s - 120*D1**2*fdd*g2*r - 48*D1**2*fdd*g2*s**2 - 120*D1**2*fdd*g2*s + 60*D1**2*fdd*g2 + 144*D1*Dd*K*f**2*r**2 + 96*D1*Dd*K*f**2*r*s - 168*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 - 24*D1*Dd*K*f**2*s + 60*D1*Dd*K*f**2 + 480*D1*Dd*K*f*fd*r**2 + 1344*D1*Dd*K*f*fd*r*s - 744*D1*Dd*K*f*fd*r + 864*D1*Dd*K*f*fd*s**2 - 984*D1*Dd*K*f*fd*s + 276*D1*Dd*K*f*fd - 240*D1*Dd*b2*f*r**2 - 480*D1*Dd*b2*f*r*s + 360*D1*Dd*b2*f*r - 240*D1*Dd*b2*f*s**2 + 360*D1*Dd*b2*f*s - 180*D1*Dd*b2*f + 240*D1*Dd*b2*fd*r**2 + 480*D1*Dd*b2*fd*r*s - 180*D1*Dd*b2*fd*r + 240*D1*Dd*b2*fd*s**2 - 180*D1*Dd*b2*fd*s + 288*D1*Dd*f**2*r**2 + 448*D1*Dd*f**2*r*s - 400*D1*Dd*f**2*r + 160*D1*Dd*f**2*s**2 - 304*D1*Dd*f**2*s + 184*D1*Dd*f**2 - 672*D1*Dd*f*fd*r**2 - 992*D1*Dd*f*fd*r*s + 596*D1*Dd*f*fd*r - 320*D1*Dd*f*fd*s**2 + 376*D1*Dd*f*fd*s - 80*D1*Dd*f*fd + 384*D1*Dd*f*g2*r**2 + 768*D1*Dd*f*g2*r*s - 576*D1*Dd*f*g2*r + 384*D1*Dd*f*g2*s**2 - 576*D1*Dd*f*g2*s + 288*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r**2 - 768*D1*Dd*f*gd2*r*s + 672*D1*Dd*f*gd2*r - 384*D1*Dd*f*gd2*s**2 + 672*D1*Dd*f*gd2*s - 288*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r**2 - 768*D1*Dd*fd*g2*r*s - 192*D1*Dd*fd*g2*r - 384*D1*Dd*fd*g2*s**2 - 192*D1*Dd*fd*g2*s + 360*D1*Dd*fd*g2 + 120*D1*Ddd*K*f**2*r**2 + 336*D1*Ddd*K*f**2*r*s - 204*D1*Ddd*K*f**2*r + 216*D1*Ddd*K*f**2*s**2 - 276*D1*Ddd*K*f**2*s + 114*D1*Ddd*K*f**2 + 120*D1*Ddd*b2*f*r**2 + 240*D1*Ddd*b2*f*r*s - 180*D1*Ddd*b2*f*r + 120*D1*Ddd*b2*f*s**2 - 180*D1*Ddd*b2*f*s + 90*D1*Ddd*b2*f - 168*D1*Ddd*f**2*r**2 - 248*D1*Ddd*f**2*r*s + 230*D1*Ddd*f**2*r - 80*D1*Ddd*f**2*s**2 + 164*D1*Ddd*f**2*s - 104*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r**2 - 384*D1*Ddd*f*g2*r*s + 288*D1*Ddd*f*g2*r - 192*D1*Ddd*f*g2*s**2 + 288*D1*Ddd*f*g2*s - 144*D1*Ddd*f*g2 + 12*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(K*(8*r**2 + 16*r*s - 26*r + 8*s**2 - 26*s + 13) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(K*(8*r**2 + r*(16*s - 3) + 8*s**2 - 3*s - 5) - 4*r**2 + r*(3 - 4*s) + s)) + Dd*f*(K*(32*r**2 + 64*r*s - 76*r + 32*s**2 - 76*s + 39) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 60*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 360*Dd**2*K*f**2*r**2 + 1008*Dd**2*K*f**2*r*s - 612*Dd**2*K*f**2*r + 648*Dd**2*K*f**2*s**2 - 828*Dd**2*K*f**2*s + 228*Dd**2*K*f**2 + 360*Dd**2*b2*f*r**2 + 720*Dd**2*b2*f*r*s - 540*Dd**2*b2*f*r + 360*Dd**2*b2*f*s**2 - 540*Dd**2*b2*f*s + 180*Dd**2*b2*f - 504*Dd**2*f**2*r**2 - 744*Dd**2*f**2*r*s + 690*Dd**2*f**2*r - 240*Dd**2*f**2*s**2 + 492*Dd**2*f**2*s - 208*Dd**2*f**2 - 576*Dd**2*f*g2*r**2 - 1152*Dd**2*f*g2*r*s + 864*Dd**2*f*g2*r - 576*Dd**2*f*g2*s**2 + 864*Dd**2*f*g2*s - 288*Dd**2*f*g2))/(231*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**4*k2**2*st**2*(-9000*C*D1**2*f**2*fd*r*s + 3000*C*D1**2*f**2*fd*r - 9000*C*D1**2*f**2*fd*s**2 + 9000*C*D1**2*f**2*fd*s - 3000*C*D1**2*f**2*fd + 4500*C*D1**2*f**2*fdd*r*s - 1500*C*D1**2*f**2*fdd*r + 4500*C*D1**2*f**2*fdd*s**2 - 4500*C*D1**2*f**2*fdd*s + 1500*C*D1**2*f**2*fdd + 9000*C*D1**2*f*fd**2*r*s - 3000*C*D1**2*f*fd**2*r + 9000*C*D1**2*f*fd**2*s**2 - 9000*C*D1**2*f*fd**2*s + 1500*C*D1**2*f*fd**2 - 12000*C*D1*Dd*f**3*r*s + 3000*C*D1*Dd*f**3*r - 12000*C*D1*Dd*f**3*s**2 + 12000*C*D1*Dd*f**3*s - 3000*C*D1*Dd*f**3 + 36000*C*D1*Dd*f**2*fd*r*s - 10500*C*D1*Dd*f**2*fd*r + 36000*C*D1*Dd*f**2*fd*s**2 - 36000*C*D1*Dd*f**2*fd*s + 7500*C*D1*Dd*f**2*fd + 6000*C*D1*Ddd*f**3*r*s - 1500*C*D1*Ddd*f**3*r + 6000*C*D1*Ddd*f**3*s**2 - 6000*C*D1*Ddd*f**3*s + 1500*C*D1*Ddd*f**3 + 18000*C*Dd**2*f**3*r*s - 4500*C*Dd**2*f**3*r + 18000*C*Dd**2*f**3*s**2 - 18000*C*Dd**2*f**3*s + 3000*C*Dd**2*f**3 - 3960*D1**2*K*b1*f*fd*r*s + 1980*D1**2*K*b1*f*fd*r - 3960*D1**2*K*b1*f*fd*s**2 + 3960*D1**2*K*b1*f*fd*s - 1980*D1**2*K*b1*f*fd + 1980*D1**2*K*b1*f*fdd*r*s - 990*D1**2*K*b1*f*fdd*r + 1980*D1**2*K*b1*f*fdd*s**2 - 1980*D1**2*K*b1*f*fdd*s + 990*D1**2*K*b1*f*fdd + 1980*D1**2*K*b1*fd**2*r*s - 990*D1**2*K*b1*fd**2*r + 1980*D1**2*K*b1*fd**2*s**2 - 1980*D1**2*K*b1*fd**2*s - 1485*D1**2*b1*f**2*fd*r**2 - 1485*D1**2*b1*f**2*fd*r*s + 1485*D1**2*b1*f**2*fd*r + 495*D1**2*b1*f**2*fd*s - 495*D1**2*b1*f**2*fd + 1485*D1**2*b1*f**2*fdd*r**2 + 1485*D1**2*b1*f**2*fdd*r*s - 1485*D1**2*b1*f**2*fdd*r - 495*D1**2*b1*f**2*fdd*s + 495*D1**2*b1*f**2*fdd + 2970*D1**2*b1*f*fd**2*r**2 + 2970*D1**2*b1*f*fd**2*r*s - 2970*D1**2*b1*f*fd**2*r - 990*D1**2*b1*f*fd**2*s + 495*D1**2*b1*f*fd**2 - 1980*D1**2*b1*f*fd*r**2 - 1980*D1**2*b1*f*fd*r*s + 990*D1**2*b1*f*fd*r + 990*D1**2*b1*f*fdd*r**2 + 990*D1**2*b1*f*fdd*r*s - 495*D1**2*b1*f*fdd*r + 990*D1**2*b1*fd**2*r**2 + 990*D1**2*b1*fd**2*r*s - 495*D1**2*b1*fd**2*r - 3960*D1**2*b2*f*fd*r*s + 1980*D1**2*b2*f*fd*r - 3960*D1**2*b2*f*fd*s**2 + 3960*D1**2*b2*f*fd*s - 1980*D1**2*b2*f*fd + 1980*D1**2*b2*f*fdd*r*s - 990*D1**2*b2*f*fdd*r + 1980*D1**2*b2*f*fdd*s**2 - 1980*D1**2*b2*f*fdd*s + 990*D1**2*b2*f*fdd + 1980*D1**2*b2*fd**2*r*s - 990*D1**2*b2*fd**2*r + 1980*D1**2*b2*fd**2*s**2 - 1980*D1**2*b2*fd**2*s - 1980*D1**2*bd2*f**2*r*s - 1980*D1**2*bd2*f**2*s**2 + 1980*D1**2*bd2*f**2*s + 3960*D1**2*bd2*f*fd*r*s - 990*D1**2*bd2*f*fd*r + 3960*D1**2*bd2*f*fd*s**2 - 3960*D1**2*bd2*f*fd*s + 990*D1**2*bd2*f*fd + 495*D1**2*bdd1*f**2*(r + s - 1)*(2*K*s + f*(r - 1) + r - 1) + 990*D1**2*bdd2*f**2*r*s + 990*D1**2*bdd2*f**2*s**2 - 990*D1**2*bdd2*f**2*s - 2418*D1**2*f**2*fd*r**2 + 2082*D1**2*f**2*fd*r*s + 918*D1**2*f**2*fd*r + 4500*D1**2*f**2*fd*s**2 - 3694*D1**2*f**2*fd*s + 694*D1**2*f**2*fd + 1605*D1**2*f**2*fdd*r**2 - 645*D1**2*f**2*fdd*r*s - 855*D1**2*f**2*fdd*r - 2250*D1**2*f**2*fdd*s**2 + 1715*D1**2*f**2*fdd*s - 215*D1**2*f**2*fdd + 3960*D1**2*f**2*gd2*r*s + 3960*D1**2*f**2*gd2*s**2 - 3960*D1**2*f**2*gd2*s - 1980*D1**2*f**2*gdd2*r*s - 1980*D1**2*f**2*gdd2*s**2 + 1980*D1**2*f**2*gdd2*s + 3210*D1**2*f*fd**2*r**2 - 1290*D1**2*f*fd**2*r*s - 1710*D1**2*f*fd**2*r - 4500*D1**2*f*fd**2*s**2 + 3430*D1**2*f*fd**2*s - 215*D1**2*f*fd**2 + 7920*D1**2*f*fd*g2*r*s - 3960*D1**2*f*fd*g2*r + 7920*D1**2*f*fd*g2*s**2 - 7920*D1**2*f*fd*g2*s + 3960*D1**2*f*fd*g2 - 7920*D1**2*f*fd*gd2*r*s + 1980*D1**2*f*fd*gd2*r - 7920*D1**2*f*fd*gd2*s**2 + 7920*D1**2*f*fd*gd2*s - 1980*D1**2*f*fd*gd2 - 3960*D1**2*f*fdd*g2*r*s + 1980*D1**2*f*fdd*g2*r - 3960*D1**2*f*fdd*g2*s**2 + 3960*D1**2*f*fdd*g2*s - 1980*D1**2*f*fdd*g2 - 3960*D1**2*fd**2*g2*r*s + 1980*D1**2*fd**2*g2*r - 3960*D1**2*fd**2*g2*s**2 + 3960*D1**2*fd**2*g2*s - 7920*D1*Dd*K*b1*f**2*r*s + 1980*D1*Dd*K*b1*f**2*r - 7920*D1*Dd*K*b1*f**2*s**2 + 7920*D1*Dd*K*b1*f**2*s - 1980*D1*Dd*K*b1*f**2 + 15840*D1*Dd*K*b1*f*fd*r*s - 5940*D1*Dd*K*b1*f*fd*r + 15840*D1*Dd*K*b1*f*fd*s**2 - 15840*D1*Dd*K*b1*f*fd*s + 3960*D1*Dd*K*b1*f*fd - 1980*D1*Dd*b1*f**3*r**2 - 1980*D1*Dd*b1*f**3*r*s + 2475*D1*Dd*b1*f**3*r + 990*D1*Dd*b1*f**3*s - 990*D1*Dd*b1*f**3 + 11880*D1*Dd*b1*f**2*fd*r**2 + 11880*D1*Dd*b1*f**2*fd*r*s - 13365*D1*Dd*b1*f**2*fd*r - 4950*D1*Dd*b1*f**2*fd*s + 3465*D1*Dd*b1*f**2*fd - 3960*D1*Dd*b1*f**2*r**2 - 3960*D1*Dd*b1*f**2*r*s + 4950*D1*Dd*b1*f**2*r + 1980*D1*Dd*b1*f**2*s - 1980*D1*Dd*b1*f**2 + 7920*D1*Dd*b1*f*fd*r**2 + 7920*D1*Dd*b1*f*fd*r*s - 6930*D1*Dd*b1*f*fd*r - 1980*D1*Dd*b1*f*fd*s + 990*D1*Dd*b1*f*fd - 7920*D1*Dd*b2*f**2*r*s + 1980*D1*Dd*b2*f**2*r - 7920*D1*Dd*b2*f**2*s**2 + 7920*D1*Dd*b2*f**2*s - 1980*D1*Dd*b2*f**2 + 15840*D1*Dd*b2*f*fd*r*s - 5940*D1*Dd*b2*f*fd*r + 15840*D1*Dd*b2*f*fd*s**2 - 15840*D1*Dd*b2*f*fd*s + 3960*D1*Dd*b2*f*fd + 7920*D1*Dd*bd2*f**2*r*s - 990*D1*Dd*bd2*f**2*r + 7920*D1*Dd*bd2*f**2*s**2 - 7920*D1*Dd*bd2*f**2*s + 990*D1*Dd*bd2*f**2 - 3224*D1*Dd*f**3*r**2 + 2776*D1*Dd*f**3*r*s + 2530*D1*Dd*f**3*r + 6000*D1*Dd*f**3*s**2 - 4388*D1*Dd*f**3*s - 112*D1*Dd*f**3 + 12840*D1*Dd*f**2*fd*r**2 - 5160*D1*Dd*f**2*fd*r*s - 9195*D1*Dd*f**2*fd*r - 18000*D1*Dd*f**2*fd*s**2 + 12650*D1*Dd*f**2*fd*s - 5*D1*Dd*f**2*fd + 15840*D1*Dd*f**2*g2*r*s - 3960*D1*Dd*f**2*g2*r + 15840*D1*Dd*f**2*g2*s**2 - 15840*D1*Dd*f**2*g2*s + 3960*D1*Dd*f**2*g2 - 15840*D1*Dd*f**2*gd2*r*s + 1980*D1*Dd*f**2*gd2*r - 15840*D1*Dd*f**2*gd2*s**2 + 15840*D1*Dd*f**2*gd2*s - 1980*D1*Dd*f**2*gd2 - 31680*D1*Dd*f*fd*g2*r*s + 11880*D1*Dd*f*fd*g2*r - 31680*D1*Dd*f*fd*g2*s**2 + 31680*D1*Dd*f*fd*g2*s - 7920*D1*Dd*f*fd*g2 + 3960*D1*Ddd*K*b1*f**2*r*s - 990*D1*Ddd*K*b1*f**2*r + 3960*D1*Ddd*K*b1*f**2*s**2 - 3960*D1*Ddd*K*b1*f**2*s + 990*D1*Ddd*K*b1*f**2 + 1980*D1*Ddd*b1*f**3*r**2 + 1980*D1*Ddd*b1*f**3*r*s - 2475*D1*Ddd*b1*f**3*r - 990*D1*Ddd*b1*f**3*s + 990*D1*Ddd*b1*f**3 + 1980*D1*Ddd*b1*f**2*r**2 + 1980*D1*Ddd*b1*f**2*r*s - 2475*D1*Ddd*b1*f**2*r - 990*D1*Ddd*b1*f**2*s + 990*D1*Ddd*b1*f**2 + 3960*D1*Ddd*b2*f**2*r*s - 990*D1*Ddd*b2*f**2*r + 3960*D1*Ddd*b2*f**2*s**2 - 3960*D1*Ddd*b2*f**2*s + 990*D1*Ddd*b2*f**2 + 2140*D1*Ddd*f**3*r**2 - 860*D1*Ddd*f**3*r*s - 1925*D1*Ddd*f**3*r - 3000*D1*Ddd*f**3*s**2 + 1930*D1*Ddd*f**3*s + 320*D1*Ddd*f**3 - 7920*D1*Ddd*f**2*g2*r*s + 1980*D1*Ddd*f**2*g2*r - 7920*D1*Ddd*f**2*g2*s**2 + 7920*D1*Ddd*f**2*g2*s - 1980*D1*Ddd*f**2*g2 - 495*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) + f*(fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + (2*r + 2*s - 2)*(2*K*s + r - 1)) - fd*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(2*K*(8*r*s - r + 8*s**2 - 8*s + 1) + f*(8*r**2 + r*(8*s - 13) - 6*s + 5) + 8*r**2 + 8*r*s - 13*r - 6*s + 5)) + 11880*Dd**2*K*b1*f**2*r*s - 2970*Dd**2*K*b1*f**2*r + 11880*Dd**2*K*b1*f**2*s**2 - 11880*Dd**2*K*b1*f**2*s + 1980*Dd**2*K*b1*f**2 + 5940*Dd**2*b1*f**3*r**2 + 5940*Dd**2*b1*f**3*r*s - 7425*Dd**2*b1*f**3*r - 2970*Dd**2*b1*f**3*s + 1980*Dd**2*b1*f**3 + 5940*Dd**2*b1*f**2*r**2 + 5940*Dd**2*b1*f**2*r*s - 7425*Dd**2*b1*f**2*r - 2970*Dd**2*b1*f**2*s + 1980*Dd**2*b1*f**2 + 11880*Dd**2*b2*f**2*r*s - 2970*Dd**2*b2*f**2*r + 11880*Dd**2*b2*f**2*s**2 - 11880*Dd**2*b2*f**2*s + 1980*Dd**2*b2*f**2 + 6420*Dd**2*f**3*r**2 - 2580*Dd**2*f**3*r*s - 5775*Dd**2*f**3*r - 9000*Dd**2*f**3*s**2 + 5790*Dd**2*f**3*s + 640*Dd**2*f**3 - 23760*Dd**2*f**2*g2*r*s + 5940*Dd**2*f**2*g2*r - 23760*Dd**2*f**2*g2*s**2 + 23760*Dd**2*f**2*g2*s - 3960*Dd**2*f**2*g2)/(693*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**4*k2**2*(726*C*D1**2*bdd1*f**2*r**2 + 836*C*D1**2*bdd1*f**2*r*s + 110*C*D1**2*bdd1*f**2*s**2 + 2190*C*D1**2*f**2*fd*r**2 + 5820*C*D1**2*f**2*fd*r*s - 3400*C*D1**2*f**2*fd*r + 3630*C*D1**2*f**2*fd*s**2 - 4360*C*D1**2*f**2*fd*s + 1940*C*D1**2*f**2*fd - 2250*C*D1**2*f**2*fdd*r**2 - 5220*C*D1**2*f**2*fdd*r*s + 3240*C*D1**2*f**2*fdd*r - 2970*C*D1**2*f**2*fdd*s**2 + 3720*C*D1**2*f**2*fdd*s - 1740*C*D1**2*f**2*fdd - 4500*C*D1**2*f*fd**2*r**2 - 10440*C*D1**2*f*fd**2*r*s + 6480*C*D1**2*f*fd**2*r - 5940*C*D1**2*f*fd**2*s**2 + 7440*C*D1**2*f*fd**2*s - 1740*C*D1**2*f*fd**2 + 2920*C*D1*Dd*f**3*r**2 + 7760*C*D1*Dd*f**3*r*s - 4860*C*D1*Dd*f**3*r + 4840*C*D1*Dd*f**3*s**2 - 6300*C*D1*Dd*f**3*s + 2670*C*D1*Dd*f**3 - 18000*C*D1*Dd*f**2*fd*r**2 - 41760*C*D1*Dd*f**2*fd*r*s + 27180*C*D1*Dd*f**2*fd*r - 23760*C*D1*Dd*f**2*fd*s**2 + 31260*C*D1*Dd*f**2*fd*s - 10200*C*D1*Dd*f**2*fd - 3000*C*D1*Ddd*f**3*r**2 - 6960*C*D1*Ddd*f**3*r*s + 4740*C*D1*Ddd*f**3*r - 3960*C*D1*Ddd*f**3*s**2 + 5460*C*D1*Ddd*f**3*s - 2490*C*D1*Ddd*f**3 - 9000*C*Dd**2*f**3*r**2 - 20880*C*Dd**2*f**3*r*s + 14220*C*Dd**2*f**3*r - 11880*C*Dd**2*f**3*s**2 + 16380*C*Dd**2*f**3*s - 4980*C*Dd**2*f**3 - 330*D1**2*K*bdd1*f**2*r**2 - 924*D1**2*K*bdd1*f**2*r*s + 660*D1**2*K*bdd1*f**2*r - 594*D1**2*K*bdd1*f**2*s**2 + 924*D1**2*K*bdd1*f**2*s - 330*D1**2*K*bdd1*f**2 + 66*D1**2*b2*bdd1*f*r**2 + 132*D1**2*b2*bdd1*f*r*s + 66*D1**2*b2*bdd1*f*s**2 + 396*D1**2*b2*f*fd*r**2 + 1848*D1**2*b2*f*fd*r*s - 924*D1**2*b2*f*fd*r + 1452*D1**2*b2*f*fd*s**2 - 1452*D1**2*b2*f*fd*s + 726*D1**2*b2*f*fd - 660*D1**2*b2*f*fdd*r**2 - 1848*D1**2*b2*f*fdd*r*s + 924*D1**2*b2*f*fdd*r - 1188*D1**2*b2*f*fdd*s**2 + 1188*D1**2*b2*f*fdd*s - 594*D1**2*b2*f*fdd - 660*D1**2*b2*fd**2*r**2 - 1848*D1**2*b2*fd**2*r*s + 924*D1**2*b2*fd**2*r - 1188*D1**2*b2*fd**2*s**2 + 1188*D1**2*b2*fd**2*s - 132*D1**2*bd1**2*f*(-5*K*r**2 - 6*K*r*s + 5*K*r - K*s**2 + 3*K*s + f*(r - 1) + r - 1) + 198*D1**2*bd2*f**2*r**2 + 924*D1**2*bd2*f**2*r*s - 396*D1**2*bd2*f**2*r + 726*D1**2*bd2*f**2*s**2 - 924*D1**2*bd2*f**2*s + 198*D1**2*bd2*f**2 - 1320*D1**2*bd2*f*fd*r**2 - 3696*D1**2*bd2*f*fd*r*s + 2244*D1**2*bd2*f*fd*r - 2376*D1**2*bd2*f*fd*s**2 + 3036*D1**2*bd2*f*fd*s - 924*D1**2*bd2*f*fd - 363*D1**2*bdd1*f**2*r**2 - 418*D1**2*bdd1*f**2*r*s - 154*D1**2*bdd1*f**2*r - 55*D1**2*bdd1*f**2*s**2 - 660*D1**2*bdd1*f*g2*r**2 - 792*D1**2*bdd1*f*g2*r*s - 132*D1**2*bdd1*f*g2*s**2 - 330*D1**2*bdd2*f**2*r**2 - 924*D1**2*bdd2*f**2*r*s + 660*D1**2*bdd2*f**2*r - 594*D1**2*bdd2*f**2*s**2 + 924*D1**2*bdd2*f**2*s - 330*D1**2*bdd2*f**2 - 765*D1**2*f**2*fd*r**2 - 2580*D1**2*f**2*fd*r*s + 1370*D1**2*f**2*fd*r - 1815*D1**2*f**2*fd*s**2 + 2070*D1**2*f**2*fd*s - 860*D1**2*f**2*fd + 1125*D1**2*f**2*fdd*r**2 + 2610*D1**2*f**2*fdd*r*s - 1620*D1**2*f**2*fdd*r + 1485*D1**2*f**2*fdd*s**2 - 1860*D1**2*f**2*fdd*s + 870*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 1848*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 1452*D1**2*f**2*gd2*s**2 + 1848*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 660*D1**2*f**2*gdd2*r**2 + 1848*D1**2*f**2*gdd2*r*s - 1320*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 1848*D1**2*f**2*gdd2*s + 660*D1**2*f**2*gdd2 + 2250*D1**2*f*fd**2*r**2 + 5220*D1**2*f*fd**2*r*s - 3240*D1**2*f*fd**2*r + 2970*D1**2*f*fd**2*s**2 - 3720*D1**2*f*fd**2*s + 870*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 3696*D1**2*f*fd*g2*r*s + 1848*D1**2*f*fd*g2*r - 2904*D1**2*f*fd*g2*s**2 + 2904*D1**2*f*fd*g2*s - 1452*D1**2*f*fd*g2 + 2640*D1**2*f*fd*gd2*r**2 + 7392*D1**2*f*fd*gd2*r*s - 4488*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 6072*D1**2*f*fd*gd2*s + 1848*D1**2*f*fd*gd2 + 1320*D1**2*f*fdd*g2*r**2 + 3696*D1**2*f*fdd*g2*r*s - 1848*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 1320*D1**2*fd**2*g2*r**2 + 3696*D1**2*fd**2*g2*r*s - 1848*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s + 792*D1*Dd*b2*f**2*r**2 + 3696*D1*Dd*b2*f**2*r*s - 1716*D1*Dd*b2*f**2*r + 2904*D1*Dd*b2*f**2*s**2 - 3300*D1*Dd*b2*f**2*s + 1122*D1*Dd*b2*f**2 - 5280*D1*Dd*b2*f*fd*r**2 - 14784*D1*Dd*b2*f*fd*r*s + 8184*D1*Dd*b2*f*fd*r - 9504*D1*Dd*b2*f*fd*s**2 + 10824*D1*Dd*b2*f*fd*s - 3036*D1*Dd*b2*f*fd - 2640*D1*Dd*bd2*f**2*r**2 - 7392*D1*Dd*bd2*f**2*r*s + 4884*D1*Dd*bd2*f**2*r - 4752*D1*Dd*bd2*f**2*s**2 + 6732*D1*Dd*bd2*f**2*s - 2244*D1*Dd*bd2*f**2 - 1020*D1*Dd*f**3*r**2 - 3440*D1*Dd*f**3*r*s + 1880*D1*Dd*f**3*r - 2420*D1*Dd*f**3*s**2 + 2930*D1*Dd*f**3*s - 1115*D1*Dd*f**3 + 9000*D1*Dd*f**2*fd*r**2 + 20880*D1*Dd*f**2*fd*r*s - 13590*D1*Dd*f**2*fd*r + 11880*D1*Dd*f**2*fd*s**2 - 15630*D1*Dd*f**2*fd*s + 5100*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 7392*D1*Dd*f**2*g2*r*s + 3432*D1*Dd*f**2*g2*r - 5808*D1*Dd*f**2*g2*s**2 + 6600*D1*Dd*f**2*g2*s - 2244*D1*Dd*f**2*g2 + 5280*D1*Dd*f**2*gd2*r**2 + 14784*D1*Dd*f**2*gd2*r*s - 9768*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 13464*D1*Dd*f**2*gd2*s + 4488*D1*Dd*f**2*gd2 + 10560*D1*Dd*f*fd*g2*r**2 + 29568*D1*Dd*f*fd*g2*r*s - 16368*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 21648*D1*Dd*f*fd*g2*s + 6072*D1*Dd*f*fd*g2 - 1320*D1*Ddd*b2*f**2*r**2 - 3696*D1*Ddd*b2*f**2*r*s + 2244*D1*Ddd*b2*f**2*r - 2376*D1*Ddd*b2*f**2*s**2 + 3036*D1*Ddd*b2*f**2*s - 1254*D1*Ddd*b2*f**2 + 1500*D1*Ddd*f**3*r**2 + 3480*D1*Ddd*f**3*r*s - 2370*D1*Ddd*f**3*r + 1980*D1*Ddd*f**3*s**2 - 2730*D1*Ddd*f**3*s + 1245*D1*Ddd*f**3 + 2640*D1*Ddd*f**2*g2*r**2 + 7392*D1*Ddd*f**2*g2*r*s - 4488*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 6072*D1*Ddd*f**2*g2*s + 2508*D1*Ddd*f**2*g2 + 22*D1*bd1*(6*D1*b1*(f*(-K*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) + r*(f + 2)) + fd*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1)) + D1*(f**2*(-10*C*s**2 + 3*K*(3*r**2 + 2*r*(7*s - 3) + 11*s**2 - 14*s + 3) + r**2*(39 - 66*C) + r*(-76*C*s + 44*s + 2) + 5*s**2 - 6*s + 6) + f*(-6*bd2*(-r**2 - 2*r*s + r - s**2 + s) + fd*(20*C*s**2 - 48*C*s - 6*K*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) + r**2*(132*C - 66) + r*(8*C*(19*s - 13) - 76*s + 45) - 10*s**2 + 24*s + 7) - 12*gd2*(5*r**2 + r*(6*s - 5) + s*(s - 3)) - 6*(r + s)*(b2*(r + s) - 2*g2*(5*r + s))) + 6*fd*(b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(5*r**2 + r*(6*s - 3) + s*(s - 1)))) - 6*Dd*b1*f*(-K*(40*r**2 + 48*r*s - 46*r + 8*s**2 - 26*s + 13) + f*(4*r - 2) + 4*r - 2) + Dd*f*(6*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f*(40*C*s**2 - 86*C*s - 6*K*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) + r**2*(264*C - 132) + r*(304*C*s - 170*C - 152*s + 57) - 20*s**2 + 43*s + 14) - 12*g2*(20*r**2 + r*(24*s - 13) + s*(4*s - 7)))) - 3960*Dd**2*b2*f**2*r**2 - 11088*Dd**2*b2*f**2*r*s + 6732*Dd**2*b2*f**2*r - 7128*Dd**2*b2*f**2*s**2 + 9108*Dd**2*b2*f**2*s - 2508*Dd**2*b2*f**2 + 4500*Dd**2*f**3*r**2 + 10440*Dd**2*f**3*r*s - 7110*Dd**2*f**3*r + 5940*Dd**2*f**3*s**2 - 8190*Dd**2*f**3*s + 2490*Dd**2*f**3 + 7920*Dd**2*f**2*g2*r**2 + 22176*Dd**2*f**2*g2*r*s - 13464*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 18216*Dd**2*f**2*g2*s + 5016*Dd**2*f**2*g2 + 66*b1**2*(D1**2*(2*fd**2*(r - 1) - 2*fd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(f + 2)) + fdd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(2*f + 2))) + D1*(2*Dd*(-K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11) + fd*(K*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + f*(4*r - 2) + 4*r - 2)) + Ddd*K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11)) + 2*Dd**2*K*f*(30*r**2 + r*(36*s - 39) + 6*s**2 - 21*s + 11)) - 11*b1*(264*C*D1**2*f*fd*r**2 + 304*C*D1**2*f*fd*r*s - 416*C*D1**2*f*fd*r + 40*C*D1**2*f*fd*s**2 - 192*C*D1**2*f*fd*s + 152*C*D1**2*f*fd - 132*C*D1**2*f*fdd*r**2 - 152*C*D1**2*f*fdd*r*s + 208*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 96*C*D1**2*f*fdd*s - 76*C*D1**2*f*fdd - 132*C*D1**2*fd**2*r**2 - 152*C*D1**2*fd**2*r*s + 208*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 96*C*D1**2*fd**2*s - 76*C*D1**2*fd**2 + 528*C*D1*Dd*f**2*r**2 + 608*C*D1*Dd*f**2*r*s - 680*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s**2 - 344*C*D1*Dd*f**2*s + 284*C*D1*Dd*f**2 - 1056*C*D1*Dd*f*fd*r**2 - 1216*C*D1*Dd*f*fd*r*s + 1512*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 728*C*D1*Dd*f*fd*s - 512*C*D1*Dd*f*fd - 264*C*D1*Ddd*f**2*r**2 - 304*C*D1*Ddd*f**2*r*s + 340*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 172*C*D1*Ddd*f**2*s - 142*C*D1*Ddd*f**2 - 792*C*Dd**2*f**2*r**2 - 912*C*Dd**2*f**2*r*s + 1020*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 516*C*Dd**2*f**2*s - 284*C*Dd**2*f**2 - 60*D1**2*K*bdd1*f*r**2 - 72*D1**2*K*bdd1*f*r*s + 60*D1**2*K*bdd1*f*r - 12*D1**2*K*bdd1*f*s**2 + 36*D1**2*K*bdd1*f*s - 30*D1**2*K*bdd1*f - 36*D1**2*K*f*fd*r**2 - 168*D1**2*K*f*fd*r*s + 84*D1**2*K*f*fd*r - 132*D1**2*K*f*fd*s**2 + 132*D1**2*K*f*fd*s - 66*D1**2*K*f*fd + 60*D1**2*K*f*fdd*r**2 + 168*D1**2*K*f*fdd*r*s - 84*D1**2*K*f*fdd*r + 108*D1**2*K*f*fdd*s**2 - 108*D1**2*K*f*fdd*s + 54*D1**2*K*f*fdd + 60*D1**2*K*fd**2*r**2 + 168*D1**2*K*fd**2*r*s - 84*D1**2*K*fd**2*r + 108*D1**2*K*fd**2*s**2 - 108*D1**2*K*fd**2*s + 12*D1**2*b2*fd*r**2 + 24*D1**2*b2*fd*r*s - 24*D1**2*b2*fd*r + 12*D1**2*b2*fd*s**2 - 24*D1**2*b2*fd*s + 12*D1**2*b2*fd - 6*D1**2*b2*fdd*r**2 - 12*D1**2*b2*fdd*r*s + 12*D1**2*b2*fdd*r - 6*D1**2*b2*fdd*s**2 + 12*D1**2*b2*fdd*s - 6*D1**2*b2*fdd + 12*D1**2*bdd1*f**2*r + 12*D1**2*bdd1*f*r - 6*D1**2*bdd2*f*(r + s - 1)**2 - 156*D1**2*f*fd*r**2 - 176*D1**2*f*fd*r*s + 248*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 96*D1**2*f*fd*s - 76*D1**2*f*fd + 66*D1**2*f*fdd*r**2 + 76*D1**2*f*fdd*r*s - 118*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 38*D1**2*f*fdd - 120*D1**2*f*gd2*r**2 - 144*D1**2*f*gd2*r*s + 240*D1**2*f*gd2*r - 24*D1**2*f*gd2*s**2 + 144*D1**2*f*gd2*s - 120*D1**2*f*gd2 + 60*D1**2*f*gdd2*r**2 + 72*D1**2*f*gdd2*r*s - 120*D1**2*f*gdd2*r + 12*D1**2*f*gdd2*s**2 - 72*D1**2*f*gdd2*s + 60*D1**2*f*gdd2 + 66*D1**2*fd**2*r**2 + 76*D1**2*fd**2*r*s - 118*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 48*D1**2*fd**2*s + 52*D1**2*fd**2 - 120*D1**2*fd*g2*r**2 - 144*D1**2*fd*g2*r*s + 144*D1**2*fd*g2*r - 24*D1**2*fd*g2*s**2 + 48*D1**2*fd*g2*s - 24*D1**2*fd*g2 + 120*D1**2*fd*gd2*r**2 + 144*D1**2*fd*gd2*r*s - 192*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 96*D1**2*fd*gd2*s + 72*D1**2*fd*gd2 + 60*D1**2*fdd*g2*r**2 + 72*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*r + 12*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 - 72*D1*Dd*K*f**2*r**2 - 336*D1*Dd*K*f**2*r*s + 156*D1*Dd*K*f**2*r - 264*D1*Dd*K*f**2*s**2 + 300*D1*Dd*K*f**2*s - 102*D1*Dd*K*f**2 + 480*D1*Dd*K*f*fd*r**2 + 1344*D1*Dd*K*f*fd*r*s - 744*D1*Dd*K*f*fd*r + 864*D1*Dd*K*f*fd*s**2 - 984*D1*Dd*K*f*fd*s + 276*D1*Dd*K*f*fd + 48*D1*Dd*b2*f*r**2 + 96*D1*Dd*b2*f*r*s - 72*D1*Dd*b2*f*r + 48*D1*Dd*b2*f*s**2 - 72*D1*Dd*b2*f*s + 36*D1*Dd*b2*f - 48*D1*Dd*b2*fd*r**2 - 96*D1*Dd*b2*fd*r*s + 84*D1*Dd*b2*fd*r - 48*D1*Dd*b2*fd*s**2 + 84*D1*Dd*b2*fd*s - 36*D1*Dd*b2*fd - 312*D1*Dd*f**2*r**2 - 352*D1*Dd*f**2*r*s + 400*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 196*D1*Dd*f**2*s - 166*D1*Dd*f**2 + 528*D1*Dd*f*fd*r**2 + 608*D1*Dd*f*fd*r*s - 812*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 364*D1*Dd*f*fd*s + 284*D1*Dd*f*fd - 480*D1*Dd*f*g2*r**2 - 576*D1*Dd*f*g2*r*s + 624*D1*Dd*f*g2*r - 96*D1*Dd*f*g2*s**2 + 336*D1*Dd*f*g2*s - 264*D1*Dd*f*g2 + 480*D1*Dd*f*gd2*r**2 + 576*D1*Dd*f*gd2*r*s - 792*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 456*D1*Dd*f*gd2*s + 312*D1*Dd*f*gd2 + 480*D1*Dd*fd*g2*r**2 + 576*D1*Dd*fd*g2*r*s - 600*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 264*D1*Dd*fd*g2*s + 168*D1*Dd*fd*g2 + 120*D1*Ddd*K*f**2*r**2 + 336*D1*Ddd*K*f**2*r*s - 204*D1*Ddd*K*f**2*r + 216*D1*Ddd*K*f**2*s**2 - 276*D1*Ddd*K*f**2*s + 114*D1*Ddd*K*f**2 - 24*D1*Ddd*b2*f*r**2 - 48*D1*Ddd*b2*f*r*s + 36*D1*Ddd*b2*f*r - 24*D1*Ddd*b2*f*s**2 + 36*D1*Ddd*b2*f*s - 18*D1*Ddd*b2*f + 132*D1*Ddd*f**2*r**2 + 152*D1*Ddd*f**2*r*s - 170*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 86*D1*Ddd*f**2*s + 71*D1*Ddd*f**2 + 240*D1*Ddd*f*g2*r**2 + 288*D1*Ddd*f*g2*r*s - 312*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 168*D1*Ddd*f*g2*s + 132*D1*Ddd*f*g2 + 12*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 360*Dd**2*K*f**2*r**2 + 1008*Dd**2*K*f**2*r*s - 612*Dd**2*K*f**2*r + 648*Dd**2*K*f**2*s**2 - 828*Dd**2*K*f**2*s + 228*Dd**2*K*f**2 - 72*Dd**2*b2*f*r**2 - 144*Dd**2*b2*f*r*s + 108*Dd**2*b2*f*r - 72*Dd**2*b2*f*s**2 + 108*Dd**2*b2*f*s - 36*Dd**2*b2*f + 396*Dd**2*f**2*r**2 + 456*Dd**2*f**2*r*s - 510*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 258*Dd**2*f**2*s + 142*Dd**2*f**2 + 720*Dd**2*f*g2*r**2 + 864*Dd**2*f*g2*r*s - 936*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 504*Dd**2*f*g2*s + 264*Dd**2*f*g2))/(231*d**2*k3**3) - 2*D1**2*Pk2*Pkd3*ct**4*(D1*(-6*D1*bd1**2*f*(r**2*(2*f + 2) + 2*r*(2*K*s + f*(s - 1) + s - 1) + s*(4*K*s - 2*K - f - 1)) - D1*bdd1*f*(r + s)*(7*f*r + f*s*(20*C - 10) + s*(12*b2 - 24*g2)) + bd1*(D1*(2*f**2*(r + s)*(7*r + s*(20*C - 10)) + f*(fd*(-28*r**2 + r*(C*(20 - 80*s) + 12*s + 11) + s*(C*(60 - 80*s) + 40*s - 23)) - 12*s*(bd2*(2*r + 2*s - 1) + 4*g2*(r + s) + gd2*(-4*r - 4*s + 2))) + 24*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(f*(-56*r**2 + r*(-160*C*s + 20*C + 24*s + 25) + 2*s*(-80*C*s + 40*C + 40*s - 13)) + 24*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - 12*b2*(D1*(-2*f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 6*b1**2*(D1**2*(r + s - 1)*(f*(fd - fdd)*(2*r - 1) + fd**2*(1 - 2*r) + 2*fd*(2*K*(s - 1) + r) - fdd*(2*K*(s - 1) + r)) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(2*r - 1)*(8*r + 8*s - 7) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) - fd*(2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + 8*r**2 + 8*r*s - 9*r - 2*s + 2)) - Ddd*f*(K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - Dd**2*f*(K*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + f*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 12*r**2 + 12*r*s - 15*r - 6*s + 4)) + b1*(80*C*D1**2*f*fd*r*s - 40*C*D1**2*f*fd*r + 80*C*D1**2*f*fd*s**2 - 120*C*D1**2*f*fd*s + 40*C*D1**2*f*fd - 40*C*D1**2*f*fdd*r*s + 20*C*D1**2*f*fdd*r - 40*C*D1**2*f*fdd*s**2 + 60*C*D1**2*f*fdd*s - 20*C*D1**2*f*fdd - 40*C*D1**2*fd**2*r*s + 20*C*D1**2*fd**2*r - 40*C*D1**2*fd**2*s**2 + 60*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 + 160*C*D1*Dd*f**2*r*s - 40*C*D1*Dd*f**2*r + 160*C*D1*Dd*f**2*s**2 - 160*C*D1*Dd*f**2*s + 40*C*D1*Dd*f**2 - 320*C*D1*Dd*f*fd*r*s + 120*C*D1*Dd*f*fd*r - 320*C*D1*Dd*f*fd*s**2 + 400*C*D1*Dd*f*fd*s - 100*C*D1*Dd*f*fd - 80*C*D1*Ddd*f**2*r*s + 20*C*D1*Ddd*f**2*r - 80*C*D1*Ddd*f**2*s**2 + 80*C*D1*Ddd*f**2*s - 20*C*D1*Ddd*f**2 - 240*C*Dd**2*f**2*r*s + 60*C*Dd**2*f**2*r - 240*C*Dd**2*f**2*s**2 + 240*C*Dd**2*f**2*s - 40*C*Dd**2*f**2 + 24*D1**2*b2*fd*r*s - 24*D1**2*b2*fd*r + 24*D1**2*b2*fd*s**2 - 48*D1**2*b2*fd*s + 24*D1**2*b2*fd - 12*D1**2*b2*fdd*r*s + 12*D1**2*b2*fdd*r - 12*D1**2*b2*fdd*s**2 + 24*D1**2*b2*fdd*s - 12*D1**2*b2*fdd + 24*D1**2*bd2*f*r*s + 24*D1**2*bd2*f*s**2 - 24*D1**2*bd2*f*s - 24*D1**2*bd2*fd*r*s + 12*D1**2*bd2*fd*r - 24*D1**2*bd2*fd*s**2 + 36*D1**2*bd2*fd*s - 12*D1**2*bd2*fd - 6*D1**2*bdd1*f*(4*K*s**2 - 2*K*s + f*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*r**2 + 2*r*(2*K*s + s - 1) - s + 1) - 12*D1**2*bdd2*f*r*s - 12*D1**2*bdd2*f*s**2 + 12*D1**2*bdd2*f*s + 28*D1**2*f*fd*r**2 - 12*D1**2*f*fd*r*s - 22*D1**2*f*fd*r - 40*D1**2*f*fd*s**2 + 46*D1**2*f*fd*s - 6*D1**2*f*fd - 14*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s + 11*D1**2*f*fdd*r + 20*D1**2*f*fdd*s**2 - 23*D1**2*f*fdd*s + 3*D1**2*f*fdd - 48*D1**2*f*gd2*r*s - 48*D1**2*f*gd2*s**2 + 48*D1**2*f*gd2*s + 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s - 14*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s + 11*D1**2*fd**2*r + 20*D1**2*fd**2*s**2 - 23*D1**2*fd**2*s + 3*D1**2*fd**2 - 48*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*r - 48*D1**2*fd*g2*s**2 + 96*D1**2*fd*g2*s - 48*D1**2*fd*g2 + 48*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*r + 48*D1**2*fd*gd2*s**2 - 72*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 + 24*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r + 24*D1**2*fdd*g2*s**2 - 48*D1**2*fdd*g2*s + 24*D1**2*fdd*g2 + 96*D1*Dd*b2*f*r*s - 24*D1*Dd*b2*f*r + 96*D1*Dd*b2*f*s**2 - 96*D1*Dd*b2*f*s + 24*D1*Dd*b2*f - 96*D1*Dd*b2*fd*r*s + 60*D1*Dd*b2*fd*r - 96*D1*Dd*b2*fd*s**2 + 144*D1*Dd*b2*fd*s - 48*D1*Dd*b2*fd - 96*D1*Dd*bd2*f*r*s + 12*D1*Dd*bd2*f*r - 96*D1*Dd*bd2*f*s**2 + 96*D1*Dd*bd2*f*s - 12*D1*Dd*bd2*f + 56*D1*Dd*f**2*r**2 - 24*D1*Dd*f**2*r*s - 50*D1*Dd*f**2*r - 80*D1*Dd*f**2*s**2 + 52*D1*Dd*f**2*s + 8*D1*Dd*f**2 - 112*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s + 94*D1*Dd*f*fd*r + 160*D1*Dd*f*fd*s**2 - 144*D1*Dd*f*fd*s + D1*Dd*f*fd - 192*D1*Dd*f*g2*r*s + 48*D1*Dd*f*g2*r - 192*D1*Dd*f*g2*s**2 + 192*D1*Dd*f*g2*s - 48*D1*Dd*f*g2 + 192*D1*Dd*f*gd2*r*s - 24*D1*Dd*f*gd2*r + 192*D1*Dd*f*gd2*s**2 - 192*D1*Dd*f*gd2*s + 24*D1*Dd*f*gd2 + 192*D1*Dd*fd*g2*r*s - 120*D1*Dd*fd*g2*r + 192*D1*Dd*fd*g2*s**2 - 288*D1*Dd*fd*g2*s + 96*D1*Dd*fd*g2 - 48*D1*Ddd*b2*f*r*s + 12*D1*Ddd*b2*f*r - 48*D1*Ddd*b2*f*s**2 + 48*D1*Ddd*b2*f*s - 12*D1*Ddd*b2*f - 28*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s + 25*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 26*D1*Ddd*f**2*s - 4*D1*Ddd*f**2 + 96*D1*Ddd*f*g2*r*s - 24*D1*Ddd*f*g2*r + 96*D1*Ddd*f*g2*s**2 - 96*D1*Ddd*f*g2*s + 24*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(f**2*(2*r**2 + 2*r*(s - 1) - s + 1) + f*(8*K*s**2 - 4*K*s - fd*(2*r - 1)*(4*r + 4*s - 3) + 4*r**2 + 4*r*(2*K*s + s - 1) - 2*s + 2) + fd*(-2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r**2 - 4*r*(s - 1) + s - 1)) - Dd*f*(K*(32*r*s - 4*r + 32*s**2 - 24*s + 2) + f*(2*r - 1)*(8*r + 8*s - 5) + (2*r - 1)*(8*r + 8*s - 5))) - 144*Dd**2*b2*f*r*s + 36*Dd**2*b2*f*r - 144*Dd**2*b2*f*s**2 + 144*Dd**2*b2*f*s - 24*Dd**2*b2*f - 84*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s + 75*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 78*Dd**2*f**2*s - 8*Dd**2*f**2 + 288*Dd**2*f*g2*r*s - 72*Dd**2*f*g2*r + 288*Dd**2*f*g2*s**2 - 288*Dd**2*f*g2*s + 48*Dd**2*f*g2))/(21*d**2*k3) + 5*D1**2*Pk2*Pkd3*ct**3*f**2*k1**7*(D1**2*(f*(38*fd - 45*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 270*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(38*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 90*Dd*fd*(4*r + 4*s - 3)**2 - 45*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 270*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(143*d**2*k2*k3**7) + 6*D1**2*Pk2*Pkd3*ct**3*f*k1**3*k2**3*st**4*(1560*C*D1**2*f*fd*r**2 + 3120*C*D1**2*f*fd*r*s - 2080*C*D1**2*f*fd*r + 1560*C*D1**2*f*fd*s**2 - 2080*C*D1**2*f*fd*s + 1040*C*D1**2*f*fd - 780*C*D1**2*f*fdd*r**2 - 1560*C*D1**2*f*fdd*r*s + 1040*C*D1**2*f*fdd*r - 780*C*D1**2*f*fdd*s**2 + 1040*C*D1**2*f*fdd*s - 520*C*D1**2*f*fdd - 1560*C*D1**2*fd**2*r**2 - 3120*C*D1**2*fd**2*r*s + 2080*C*D1**2*fd**2*r - 1560*C*D1**2*fd**2*s**2 + 2080*C*D1**2*fd**2*s - 520*C*D1**2*fd**2 + 2080*C*D1*Dd*f**2*r**2 + 4160*C*D1*Dd*f**2*r*s - 3120*C*D1*Dd*f**2*r + 2080*C*D1*Dd*f**2*s**2 - 3120*C*D1*Dd*f**2*s + 1560*C*D1*Dd*f**2 - 6240*C*D1*Dd*f*fd*r**2 - 12480*C*D1*Dd*f*fd*r*s + 8840*C*D1*Dd*f*fd*r - 6240*C*D1*Dd*f*fd*s**2 + 8840*C*D1*Dd*f*fd*s - 3120*C*D1*Dd*f*fd - 1040*C*D1*Ddd*f**2*r**2 - 2080*C*D1*Ddd*f**2*r*s + 1560*C*D1*Ddd*f**2*r - 1040*C*D1*Ddd*f**2*s**2 + 1560*C*D1*Ddd*f**2*s - 780*C*D1*Ddd*f**2 - 3120*C*Dd**2*f**2*r**2 - 6240*C*Dd**2*f**2*r*s + 4680*C*Dd**2*f**2*r - 3120*C*Dd**2*f**2*s**2 + 4680*C*Dd**2*f**2*s - 1560*C*Dd**2*f**2 + 429*D1**2*bd1*f*(K - 1)*(r + s - 1)**2 + 6220*D1**2*f**2*fd*r**2 + 12440*D1**2*f**2*fd*r*s - 9330*D1**2*f**2*fd*r + 6220*D1**2*f**2*fd*s**2 - 9330*D1**2*f**2*fd*s + 4665*D1**2*f**2*fd - 3500*D1**2*f**2*fdd*r**2 - 7000*D1**2*f**2*fdd*r*s + 5250*D1**2*f**2*fdd*r - 3500*D1**2*f**2*fdd*s**2 + 5250*D1**2*f**2*fdd*s - 2625*D1**2*f**2*fdd - 10500*D1**2*f*fd**2*r**2 - 21000*D1**2*f*fd**2*r*s + 15750*D1**2*f*fd**2*r - 10500*D1**2*f*fd**2*s**2 + 15750*D1**2*f*fd**2*s - 5250*D1**2*f*fd**2 - 1560*D1**2*f*fd*r**2 - 3120*D1**2*f*fd*r*s + 2080*D1**2*f*fd*r - 1560*D1**2*f*fd*s**2 + 2080*D1**2*f*fd*s - 1040*D1**2*f*fd + 780*D1**2*f*fdd*r**2 + 1560*D1**2*f*fdd*r*s - 1040*D1**2*f*fdd*r + 780*D1**2*f*fdd*s**2 - 1040*D1**2*f*fdd*s + 520*D1**2*f*fdd - 858*D1**2*f*gd2*r**2 - 1716*D1**2*f*gd2*r*s + 1716*D1**2*f*gd2*r - 858*D1**2*f*gd2*s**2 + 1716*D1**2*f*gd2*s - 858*D1**2*f*gd2 + 1560*D1**2*fd**2*r**2 + 3120*D1**2*fd**2*r*s - 2080*D1**2*fd**2*r + 1560*D1**2*fd**2*s**2 - 2080*D1**2*fd**2*s + 520*D1**2*fd**2 - 1716*D1**2*fd*g2*r**2 - 3432*D1**2*fd*g2*r*s + 1716*D1**2*fd*g2*r - 1716*D1**2*fd*g2*s**2 + 1716*D1**2*fd*g2*s - 858*D1**2*fd*g2 + 6220*D1*Dd*f**3*r**2 + 12440*D1*Dd*f**3*r*s - 9330*D1*Dd*f**3*r + 6220*D1*Dd*f**3*s**2 - 9330*D1*Dd*f**3*s + 4665*D1*Dd*f**3 - 28000*D1*Dd*f**2*fd*r**2 - 56000*D1*Dd*f**2*fd*r*s + 42000*D1*Dd*f**2*fd*r - 28000*D1*Dd*f**2*fd*s**2 + 42000*D1*Dd*f**2*fd*s - 15750*D1*Dd*f**2*fd - 2080*D1*Dd*f**2*r**2 - 4160*D1*Dd*f**2*r*s + 3120*D1*Dd*f**2*r - 2080*D1*Dd*f**2*s**2 + 3120*D1*Dd*f**2*s - 1560*D1*Dd*f**2 + 6240*D1*Dd*f*fd*r**2 + 12480*D1*Dd*f*fd*r*s - 8840*D1*Dd*f*fd*r + 6240*D1*Dd*f*fd*s**2 - 8840*D1*Dd*f*fd*s + 3120*D1*Dd*f*fd - 3432*D1*Dd*f*g2*r**2 - 6864*D1*Dd*f*g2*r*s + 5148*D1*Dd*f*g2*r - 3432*D1*Dd*f*g2*s**2 + 5148*D1*Dd*f*g2*s - 2574*D1*Dd*f*g2 - 3500*D1*Ddd*f**3*r**2 - 7000*D1*Ddd*f**3*r*s + 5250*D1*Ddd*f**3*r - 3500*D1*Ddd*f**3*s**2 + 5250*D1*Ddd*f**3*s - 2625*D1*Ddd*f**3 + 1040*D1*Ddd*f**2*r**2 + 2080*D1*Ddd*f**2*r*s - 1560*D1*Ddd*f**2*r + 1040*D1*Ddd*f**2*s**2 - 1560*D1*Ddd*f**2*s + 780*D1*Ddd*f**2 + 429*D1*b1*(K - 1)*(D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 10500*Dd**2*f**3*r**2 - 21000*Dd**2*f**3*r*s + 15750*Dd**2*f**3*r - 10500*Dd**2*f**3*s**2 + 15750*Dd**2*f**3*s - 5250*Dd**2*f**3 + 3120*Dd**2*f**2*r**2 + 6240*Dd**2*f**2*r*s - 4680*Dd**2*f**2*r + 3120*Dd**2*f**2*s**2 - 4680*Dd**2*f**2*s + 1560*Dd**2*f**2)/(1001*d**2*k3**7) + 8*D1**2*Pk2*Pkd3*ct**3*f*k1**3*k2*st**4*(D1**2*(5*f**2*(521*fd - 280*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - f*(1400*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - fd*(780*C - 780)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(390*C - 390)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-429*K*bd1 + 429*bd1 + 858*gd2)) - 78*fd*(fd*(5*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 11*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1))) + 429*D1*b1*(K - 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*f*(Dd*(2605*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 20*f*(39*C*(r*(4*s - 1) + (1 - 2*s)**2) - 140*fd*(4*s - 1)*(4*r + 4*s - 3) - 39*r*(4*s - 1) - 39*(1 - 2*s)**2) - 78*fd*(5*C - 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 858*g2*(r*(4*s - 1) + (1 - 2*s)**2)) - 10*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(39*C + 140*f - 39)) - 10*Dd**2*f**2*(39*C + 140*f - 39)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k3**5) - 15*D1**2*Pk2*Pkd3*ct**3*f*k1*k2**5*st**4*(-7*D1**2*bdd1*f**2*(r + s - 1)**2 + 14*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + (-12*C + 7*b1 + 9)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**7) - 5*D1**2*Pk2*Pkd3*ct**3*f*k1*k2**3*st**4*(96*C*D1**2*f*fd*r**2 - 192*C*D1**2*f*fd*r*s - 288*C*D1**2*f*fd*s**2 + 256*C*D1**2*f*fd*s - 64*C*D1**2*f*fd - 48*C*D1**2*f*fdd*r**2 + 96*C*D1**2*f*fdd*r*s + 144*C*D1**2*f*fdd*s**2 - 128*C*D1**2*f*fdd*s + 32*C*D1**2*f*fdd - 96*C*D1**2*fd**2*r**2 + 192*C*D1**2*fd**2*r*s + 288*C*D1**2*fd**2*s**2 - 256*C*D1**2*fd**2*s + 32*C*D1**2*fd**2 + 128*C*D1*Dd*f**2*r**2 - 256*C*D1*Dd*f**2*r*s - 64*C*D1*Dd*f**2*r - 384*C*D1*Dd*f**2*s**2 + 320*C*D1*Dd*f**2*s - 32*C*D1*Dd*f**2 - 384*C*D1*Dd*f*fd*r**2 + 768*C*D1*Dd*f*fd*r*s + 96*C*D1*Dd*f*fd*r + 1152*C*D1*Dd*f*fd*s**2 - 992*C*D1*Dd*f*fd*s + 128*C*D1*Dd*f*fd - 64*C*D1*Ddd*f**2*r**2 + 128*C*D1*Ddd*f**2*r*s + 32*C*D1*Ddd*f**2*r + 192*C*D1*Ddd*f**2*s**2 - 160*C*D1*Ddd*f**2*s + 16*C*D1*Ddd*f**2 - 192*C*Dd**2*f**2*r**2 + 384*C*Dd**2*f**2*r*s + 96*C*Dd**2*f**2*r + 576*C*Dd**2*f**2*s**2 - 480*C*Dd**2*f**2*s + 32*C*Dd**2*f**2 - 210*D1**2*b1*f*fd*r**2 - 252*D1**2*b1*f*fd*r*s + 224*D1**2*b1*f*fd*r - 42*D1**2*b1*f*fd*s**2 + 112*D1**2*b1*f*fd*s - 84*D1**2*b1*f*fd + 105*D1**2*b1*f*fdd*r**2 + 126*D1**2*b1*f*fdd*r*s - 112*D1**2*b1*f*fdd*r + 21*D1**2*b1*f*fdd*s**2 - 56*D1**2*b1*f*fdd*s + 42*D1**2*b1*f*fdd + 210*D1**2*b1*fd**2*r**2 + 252*D1**2*b1*fd**2*r*s - 224*D1**2*b1*fd**2*r + 42*D1**2*b1*fd**2*s**2 - 112*D1**2*b1*fd**2*s + 42*D1**2*b1*fd**2 + 7*D1**2*bdd1*f**2*(5*r**2 + 6*r*s - 10*r + s**2 - 6*s + 5) + 112*D1**2*f**2*fd*r**2 + 112*D1**2*f**2*fd*r*s - 140*D1**2*f**2*fd*r - 56*D1**2*f**2*fd*s + 56*D1**2*f**2*fd - 112*D1**2*f**2*fdd*r**2 - 112*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r + 56*D1**2*f**2*fdd*s - 56*D1**2*f**2*fdd - 336*D1**2*f*fd**2*r**2 - 336*D1**2*f*fd**2*r*s + 420*D1**2*f*fd**2*r + 168*D1**2*f*fd**2*s - 112*D1**2*f*fd**2 - 186*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s + 144*D1**2*f*fd*r + 126*D1**2*f*fd*s**2 - 64*D1**2*f*fd*s - 20*D1**2*f*fd + 93*D1**2*f*fdd*r**2 + 30*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*r - 63*D1**2*f*fdd*s**2 + 32*D1**2*f*fdd*s + 10*D1**2*f*fdd + 186*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 144*D1**2*fd**2*r - 126*D1**2*fd**2*s**2 + 64*D1**2*fd**2*s + 10*D1**2*fd**2 - 280*D1*Dd*b1*f**2*r**2 - 336*D1*Dd*b1*f**2*r*s + 364*D1*Dd*b1*f**2*r - 56*D1*Dd*b1*f**2*s**2 + 196*D1*Dd*b1*f**2*s - 154*D1*Dd*b1*f**2 + 840*D1*Dd*b1*f*fd*r**2 + 1008*D1*Dd*b1*f*fd*r*s - 994*D1*Dd*b1*f*fd*r + 168*D1*Dd*b1*f*fd*s**2 - 518*D1*Dd*b1*f*fd*s + 280*D1*Dd*b1*f*fd + 112*D1*Dd*f**3*r**2 + 112*D1*Dd*f**3*r*s - 140*D1*Dd*f**3*r - 56*D1*Dd*f**3*s + 56*D1*Dd*f**3 - 896*D1*Dd*f**2*fd*r**2 - 896*D1*Dd*f**2*fd*r*s + 1120*D1*Dd*f**2*fd*r + 448*D1*Dd*f**2*fd*s - 336*D1*Dd*f**2*fd - 248*D1*Dd*f**2*r**2 - 80*D1*Dd*f**2*r*s + 268*D1*Dd*f**2*r + 168*D1*Dd*f**2*s**2 - 44*D1*Dd*f**2*s - 82*D1*Dd*f**2 + 744*D1*Dd*f*fd*r**2 + 240*D1*Dd*f*fd*r*s - 690*D1*Dd*f*fd*r - 504*D1*Dd*f*fd*s**2 + 194*D1*Dd*f*fd*s + 112*D1*Dd*f*fd + 140*D1*Ddd*b1*f**2*r**2 + 168*D1*Ddd*b1*f**2*r*s - 182*D1*Ddd*b1*f**2*r + 28*D1*Ddd*b1*f**2*s**2 - 98*D1*Ddd*b1*f**2*s + 77*D1*Ddd*b1*f**2 - 112*D1*Ddd*f**3*r**2 - 112*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r + 56*D1*Ddd*f**3*s - 56*D1*Ddd*f**3 + 124*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 134*D1*Ddd*f**2*r - 84*D1*Ddd*f**2*s**2 + 22*D1*Ddd*f**2*s + 41*D1*Ddd*f**2 - 14*D1*bd1*f*(D1*(f*(5*r**2 + 6*r*s - 10*r + s**2 - 6*s + 5) - fd*(15*r**2 + 18*r*s - 23*r + 3*s**2 - 13*s + 8)) - Dd*f*(20*r**2 + 3*r*(8*s - 11) + 4*s**2 - 19*s + 13)) + 420*Dd**2*b1*f**2*r**2 + 504*Dd**2*b1*f**2*r*s - 546*Dd**2*b1*f**2*r + 84*Dd**2*b1*f**2*s**2 - 294*Dd**2*b1*f**2*s + 154*Dd**2*b1*f**2 - 336*Dd**2*f**3*r**2 - 336*Dd**2*f**3*r*s + 420*Dd**2*f**3*r + 168*Dd**2*f**3*s - 112*Dd**2*f**3 + 372*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 402*Dd**2*f**2*r - 252*Dd**2*f**2*s**2 + 66*Dd**2*f**2*s + 82*Dd**2*f**2)/(231*d**2*k3**5) + 40*D1**2*Pk2*Pkd3*ct**3*f*k1*k2*st**4*(D1**2*(f**2*s*(14*bd1 - 7*bdd1)*(r + s - 1) + f*(fd*(14*b1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*bd1*(6*r*s - r + 6*s**2 - 6*s + 1) + 18*r*s - 6*r + 18*s**2 - 18*s + 6) - fdd*(7*b1 + 3)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(7*b1 + 3)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(f*(14*b1*(r*(4*s - 1) + (1 - 2*s)**2) - 7*bd1*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 6*r*(4*s - 1) + 6*(1 - 2*s)**2) - fd*(7*b1 + 3)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - Ddd*f*(7*b1 + 3)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(7*b1 + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k3**3) - D1**2*Pk2*Pkd3*ct**3*f*k2**5*st**2*(16*C - 8)*(D1**2*(f*(7*fd - 20*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 20*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(7*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 20*fd*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) - 20*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 20*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4))/(693*d**2*k1*k3**5) + D1**2*Pk2*Pkd3*ct**3*f*k2**3*st**2*(16*C - 8)*(D1**2*(f*(7*fd - 20*fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) - 20*fd**2*(6*r**2 + 6*r*(s - 1) - 2*s + 1)) + D1*f*(Dd*(7*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 20*fd*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) - 20*Ddd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - 20*Dd**2*f**2*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4))/(693*d**2*k1*k3**3) + D1**2*Pk2*Pkd3*ct**3*k1**5*k2*st**2*(13104*C*D1**2*f**2*fd*r**2 + 26208*C*D1**2*f**2*fd*r*s - 17472*C*D1**2*f**2*fd*r + 13104*C*D1**2*f**2*fd*s**2 - 17472*C*D1**2*f**2*fd*s + 8736*C*D1**2*f**2*fd - 11700*C*D1**2*f**2*fdd*r**2 - 23400*C*D1**2*f**2*fdd*r*s + 15600*C*D1**2*f**2*fdd*r - 11700*C*D1**2*f**2*fdd*s**2 + 15600*C*D1**2*f**2*fdd*s - 7800*C*D1**2*f**2*fdd - 23400*C*D1**2*f*fd**2*r**2 - 46800*C*D1**2*f*fd**2*r*s + 31200*C*D1**2*f*fd**2*r - 23400*C*D1**2*f*fd**2*s**2 + 31200*C*D1**2*f*fd**2*s - 7800*C*D1**2*f*fd**2 + 17472*C*D1*Dd*f**3*r**2 + 34944*C*D1*Dd*f**3*r*s - 26208*C*D1*Dd*f**3*r + 17472*C*D1*Dd*f**3*s**2 - 26208*C*D1*Dd*f**3*s + 13104*C*D1*Dd*f**3 - 93600*C*D1*Dd*f**2*fd*r**2 - 187200*C*D1*Dd*f**2*fd*r*s + 132600*C*D1*Dd*f**2*fd*r - 93600*C*D1*Dd*f**2*fd*s**2 + 132600*C*D1*Dd*f**2*fd*s - 46800*C*D1*Dd*f**2*fd - 15600*C*D1*Ddd*f**3*r**2 - 31200*C*D1*Ddd*f**3*r*s + 23400*C*D1*Ddd*f**3*r - 15600*C*D1*Ddd*f**3*s**2 + 23400*C*D1*Ddd*f**3*s - 11700*C*D1*Ddd*f**3 - 46800*C*Dd**2*f**3*r**2 - 93600*C*Dd**2*f**3*r*s + 70200*C*Dd**2*f**3*r - 46800*C*Dd**2*f**3*s**2 + 70200*C*Dd**2*f**3*s - 23400*C*Dd**2*f**3 + 6864*D1**2*K*b1*f*fd*r**2 + 13728*D1**2*K*b1*f*fd*r*s - 6864*D1**2*K*b1*f*fd*r + 6864*D1**2*K*b1*f*fd*s**2 - 6864*D1**2*K*b1*f*fd*s + 3432*D1**2*K*b1*f*fd - 5148*D1**2*K*b1*f*fdd*r**2 - 10296*D1**2*K*b1*f*fdd*r*s + 5148*D1**2*K*b1*f*fdd*r - 5148*D1**2*K*b1*f*fdd*s**2 + 5148*D1**2*K*b1*f*fdd*s - 2574*D1**2*K*b1*f*fdd - 5148*D1**2*K*b1*fd**2*r**2 - 10296*D1**2*K*b1*fd**2*r*s + 5148*D1**2*K*b1*fd**2*r - 5148*D1**2*K*b1*fd**2*s**2 + 5148*D1**2*K*b1*fd**2*s - 6864*D1**2*b1*f*fd*r**2 - 13728*D1**2*b1*f*fd*r*s + 6864*D1**2*b1*f*fd*r - 6864*D1**2*b1*f*fd*s**2 + 6864*D1**2*b1*f*fd*s - 3432*D1**2*b1*f*fd + 5148*D1**2*b1*f*fdd*r**2 + 10296*D1**2*b1*f*fdd*r*s - 5148*D1**2*b1*f*fdd*r + 5148*D1**2*b1*f*fdd*s**2 - 5148*D1**2*b1*f*fdd*s + 2574*D1**2*b1*f*fdd + 5148*D1**2*b1*fd**2*r**2 + 10296*D1**2*b1*fd**2*r*s - 5148*D1**2*b1*fd**2*r + 5148*D1**2*b1*fd**2*s**2 - 5148*D1**2*b1*fd**2*s - 2574*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 55100*D1**2*f**3*fd*r**2 + 110200*D1**2*f**3*fd*r*s - 82650*D1**2*f**3*fd*r + 55100*D1**2*f**3*fd*s**2 - 82650*D1**2*f**3*fd*s + 41325*D1**2*f**3*fd - 49000*D1**2*f**3*fdd*r**2 - 98000*D1**2*f**3*fdd*r*s + 73500*D1**2*f**3*fdd*r - 49000*D1**2*f**3*fdd*s**2 + 73500*D1**2*f**3*fdd*s - 36750*D1**2*f**3*fdd - 147000*D1**2*f**2*fd**2*r**2 - 294000*D1**2*f**2*fd**2*r*s + 220500*D1**2*f**2*fd**2*r - 147000*D1**2*f**2*fd**2*s**2 + 220500*D1**2*f**2*fd**2*s - 73500*D1**2*f**2*fd**2 - 13104*D1**2*f**2*fd*r**2 - 26208*D1**2*f**2*fd*r*s + 17472*D1**2*f**2*fd*r - 13104*D1**2*f**2*fd*s**2 + 17472*D1**2*f**2*fd*s - 8736*D1**2*f**2*fd + 11700*D1**2*f**2*fdd*r**2 + 23400*D1**2*f**2*fdd*r*s - 15600*D1**2*f**2*fdd*r + 11700*D1**2*f**2*fdd*s**2 - 15600*D1**2*f**2*fdd*s + 7800*D1**2*f**2*fdd - 6864*D1**2*f**2*gd2*r**2 - 13728*D1**2*f**2*gd2*r*s + 13728*D1**2*f**2*gd2*r - 6864*D1**2*f**2*gd2*s**2 + 13728*D1**2*f**2*gd2*s - 6864*D1**2*f**2*gd2 + 5148*D1**2*f**2*gdd2*r**2 + 10296*D1**2*f**2*gdd2*r*s - 10296*D1**2*f**2*gdd2*r + 5148*D1**2*f**2*gdd2*s**2 - 10296*D1**2*f**2*gdd2*s + 5148*D1**2*f**2*gdd2 + 23400*D1**2*f*fd**2*r**2 + 46800*D1**2*f*fd**2*r*s - 31200*D1**2*f*fd**2*r + 23400*D1**2*f*fd**2*s**2 - 31200*D1**2*f*fd**2*s + 7800*D1**2*f*fd**2 - 13728*D1**2*f*fd*g2*r**2 - 27456*D1**2*f*fd*g2*r*s + 13728*D1**2*f*fd*g2*r - 13728*D1**2*f*fd*g2*s**2 + 13728*D1**2*f*fd*g2*s - 6864*D1**2*f*fd*g2 + 20592*D1**2*f*fd*gd2*r**2 + 41184*D1**2*f*fd*gd2*r*s - 30888*D1**2*f*fd*gd2*r + 20592*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 10296*D1**2*f*fd*gd2 + 10296*D1**2*f*fdd*g2*r**2 + 20592*D1**2*f*fdd*g2*r*s - 10296*D1**2*f*fdd*g2*r + 10296*D1**2*f*fdd*g2*s**2 - 10296*D1**2*f*fdd*g2*s + 5148*D1**2*f*fdd*g2 + 10296*D1**2*fd**2*g2*r**2 + 20592*D1**2*fd**2*g2*r*s - 10296*D1**2*fd**2*g2*r + 10296*D1**2*fd**2*g2*s**2 - 10296*D1**2*fd**2*g2*s + 13728*D1*Dd*K*b1*f**2*r**2 + 27456*D1*Dd*K*b1*f**2*r*s - 20592*D1*Dd*K*b1*f**2*r + 13728*D1*Dd*K*b1*f**2*s**2 - 20592*D1*Dd*K*b1*f**2*s + 10296*D1*Dd*K*b1*f**2 - 41184*D1*Dd*K*b1*f*fd*r**2 - 82368*D1*Dd*K*b1*f*fd*r*s + 51480*D1*Dd*K*b1*f*fd*r - 41184*D1*Dd*K*b1*f*fd*s**2 + 51480*D1*Dd*K*b1*f*fd*s - 15444*D1*Dd*K*b1*f*fd - 13728*D1*Dd*b1*f**2*r**2 - 27456*D1*Dd*b1*f**2*r*s + 20592*D1*Dd*b1*f**2*r - 13728*D1*Dd*b1*f**2*s**2 + 20592*D1*Dd*b1*f**2*s - 10296*D1*Dd*b1*f**2 + 41184*D1*Dd*b1*f*fd*r**2 + 82368*D1*Dd*b1*f*fd*r*s - 51480*D1*Dd*b1*f*fd*r + 41184*D1*Dd*b1*f*fd*s**2 - 51480*D1*Dd*b1*f*fd*s + 15444*D1*Dd*b1*f*fd + 55100*D1*Dd*f**4*r**2 + 110200*D1*Dd*f**4*r*s - 82650*D1*Dd*f**4*r + 55100*D1*Dd*f**4*s**2 - 82650*D1*Dd*f**4*s + 41325*D1*Dd*f**4 - 392000*D1*Dd*f**3*fd*r**2 - 784000*D1*Dd*f**3*fd*r*s + 588000*D1*Dd*f**3*fd*r - 392000*D1*Dd*f**3*fd*s**2 + 588000*D1*Dd*f**3*fd*s - 220500*D1*Dd*f**3*fd - 17472*D1*Dd*f**3*r**2 - 34944*D1*Dd*f**3*r*s + 26208*D1*Dd*f**3*r - 17472*D1*Dd*f**3*s**2 + 26208*D1*Dd*f**3*s - 13104*D1*Dd*f**3 + 93600*D1*Dd*f**2*fd*r**2 + 187200*D1*Dd*f**2*fd*r*s - 132600*D1*Dd*f**2*fd*r + 93600*D1*Dd*f**2*fd*s**2 - 132600*D1*Dd*f**2*fd*s + 46800*D1*Dd*f**2*fd - 27456*D1*Dd*f**2*g2*r**2 - 54912*D1*Dd*f**2*g2*r*s + 41184*D1*Dd*f**2*g2*r - 27456*D1*Dd*f**2*g2*s**2 + 41184*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*g2 + 41184*D1*Dd*f**2*gd2*r**2 + 82368*D1*Dd*f**2*gd2*r*s - 72072*D1*Dd*f**2*gd2*r + 41184*D1*Dd*f**2*gd2*s**2 - 72072*D1*Dd*f**2*gd2*s + 30888*D1*Dd*f**2*gd2 + 82368*D1*Dd*f*fd*g2*r**2 + 164736*D1*Dd*f*fd*g2*r*s - 102960*D1*Dd*f*fd*g2*r + 82368*D1*Dd*f*fd*g2*s**2 - 102960*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 10296*D1*Ddd*K*b1*f**2*r**2 - 20592*D1*Ddd*K*b1*f**2*r*s + 15444*D1*Ddd*K*b1*f**2*r - 10296*D1*Ddd*K*b1*f**2*s**2 + 15444*D1*Ddd*K*b1*f**2*s - 7722*D1*Ddd*K*b1*f**2 + 10296*D1*Ddd*b1*f**2*r**2 + 20592*D1*Ddd*b1*f**2*r*s - 15444*D1*Ddd*b1*f**2*r + 10296*D1*Ddd*b1*f**2*s**2 - 15444*D1*Ddd*b1*f**2*s + 7722*D1*Ddd*b1*f**2 - 49000*D1*Ddd*f**4*r**2 - 98000*D1*Ddd*f**4*r*s + 73500*D1*Ddd*f**4*r - 49000*D1*Ddd*f**4*s**2 + 73500*D1*Ddd*f**4*s - 36750*D1*Ddd*f**4 + 15600*D1*Ddd*f**3*r**2 + 31200*D1*Ddd*f**3*r*s - 23400*D1*Ddd*f**3*r + 15600*D1*Ddd*f**3*s**2 - 23400*D1*Ddd*f**3*s + 11700*D1*Ddd*f**3 + 20592*D1*Ddd*f**2*g2*r**2 + 41184*D1*Ddd*f**2*g2*r*s - 30888*D1*Ddd*f**2*g2*r + 20592*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 15444*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 3*D1*fd*(2*r + 2*s - 1) - 3*Dd*f*(4*r + 4*s - 3)) - 30888*Dd**2*K*b1*f**2*r**2 - 61776*Dd**2*K*b1*f**2*r*s + 46332*Dd**2*K*b1*f**2*r - 30888*Dd**2*K*b1*f**2*s**2 + 46332*Dd**2*K*b1*f**2*s - 15444*Dd**2*K*b1*f**2 + 30888*Dd**2*b1*f**2*r**2 + 61776*Dd**2*b1*f**2*r*s - 46332*Dd**2*b1*f**2*r + 30888*Dd**2*b1*f**2*s**2 - 46332*Dd**2*b1*f**2*s + 15444*Dd**2*b1*f**2 - 147000*Dd**2*f**4*r**2 - 294000*Dd**2*f**4*r*s + 220500*Dd**2*f**4*r - 147000*Dd**2*f**4*s**2 + 220500*Dd**2*f**4*s - 73500*Dd**2*f**4 + 46800*Dd**2*f**3*r**2 + 93600*Dd**2*f**3*r*s - 70200*Dd**2*f**3*r + 46800*Dd**2*f**3*s**2 - 70200*Dd**2*f**3*s + 23400*Dd**2*f**3 + 61776*Dd**2*f**2*g2*r**2 + 123552*Dd**2*f**2*g2*r*s - 92664*Dd**2*f**2*g2*r + 61776*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 30888*Dd**2*f**2*g2)/(1001*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**3*k1**5*k2*(-1320*C*D1**2*bdd1*f**2*r**2 - 2640*C*D1**2*bdd1*f**2*r*s + 2640*C*D1**2*bdd1*f**2*r - 1320*C*D1**2*bdd1*f**2*s**2 + 2640*C*D1**2*bdd1*f**2*s - 1320*C*D1**2*bdd1*f**2 + 1380*C*D1**2*f**2*fd*r**2 + 2760*C*D1**2*f**2*fd*r*s - 1840*C*D1**2*f**2*fd*r + 1380*C*D1**2*f**2*fd*s**2 - 1840*C*D1**2*f**2*fd*s + 920*C*D1**2*f**2*fd - 1680*C*D1**2*f**2*fdd*r**2 - 3360*C*D1**2*f**2*fdd*r*s + 2240*C*D1**2*f**2*fdd*r - 1680*C*D1**2*f**2*fdd*s**2 + 2240*C*D1**2*f**2*fdd*s - 1120*C*D1**2*f**2*fdd - 3360*C*D1**2*f*fd**2*r**2 - 6720*C*D1**2*f*fd**2*r*s + 4480*C*D1**2*f*fd**2*r - 3360*C*D1**2*f*fd**2*s**2 + 4480*C*D1**2*f*fd**2*s - 1120*C*D1**2*f*fd**2 + 1840*C*D1*Dd*f**3*r**2 + 3680*C*D1*Dd*f**3*r*s - 2760*C*D1*Dd*f**3*r + 1840*C*D1*Dd*f**3*s**2 - 2760*C*D1*Dd*f**3*s + 1380*C*D1*Dd*f**3 - 13440*C*D1*Dd*f**2*fd*r**2 - 26880*C*D1*Dd*f**2*fd*r*s + 19040*C*D1*Dd*f**2*fd*r - 13440*C*D1*Dd*f**2*fd*s**2 + 19040*C*D1*Dd*f**2*fd*s - 6720*C*D1*Dd*f**2*fd - 2240*C*D1*Ddd*f**3*r**2 - 4480*C*D1*Ddd*f**3*r*s + 3360*C*D1*Ddd*f**3*r - 2240*C*D1*Ddd*f**3*s**2 + 3360*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 6720*C*Dd**2*f**3*r**2 - 13440*C*Dd**2*f**3*r*s + 10080*C*Dd**2*f**3*r - 6720*C*Dd**2*f**3*s**2 + 10080*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 330*D1**2*K*bdd1*f**2*r**2 - 660*D1**2*K*bdd1*f**2*r*s + 660*D1**2*K*bdd1*f**2*r - 330*D1**2*K*bdd1*f**2*s**2 + 660*D1**2*K*bdd1*f**2*s - 330*D1**2*K*bdd1*f**2 - 1584*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 700*D1**2*bdd1*f**3*r**2 - 1400*D1**2*bdd1*f**3*r*s + 1400*D1**2*bdd1*f**3*r - 700*D1**2*bdd1*f**3*s**2 + 1400*D1**2*bdd1*f**3*s - 700*D1**2*bdd1*f**3 + 1485*D1**2*bdd1*f**2*r**2 + 2970*D1**2*bdd1*f**2*r*s - 2970*D1**2*bdd1*f**2*r + 1485*D1**2*bdd1*f**2*s**2 - 2970*D1**2*bdd1*f**2*s + 1485*D1**2*bdd1*f**2 + 1584*D1**2*bdd1*f*g2*r**2 + 3168*D1**2*bdd1*f*g2*r*s - 3168*D1**2*bdd1*f*g2*r + 1584*D1**2*bdd1*f*g2*s**2 - 3168*D1**2*bdd1*f*g2*s + 1584*D1**2*bdd1*f*g2 - 560*D1**2*f**3*fd*r**2 - 1120*D1**2*f**3*fd*r*s + 840*D1**2*f**3*fd*r - 560*D1**2*f**3*fd*s**2 + 840*D1**2*f**3*fd*s - 420*D1**2*f**3*fd - 1035*D1**2*f**2*fd*r**2 - 2070*D1**2*f**2*fd*r*s + 1380*D1**2*f**2*fd*r - 1035*D1**2*f**2*fd*s**2 + 1380*D1**2*f**2*fd*s - 690*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 2520*D1**2*f**2*fdd*r*s - 1680*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1680*D1**2*f**2*fdd*s + 840*D1**2*f**2*fdd - 528*D1**2*f**2*gd2*r**2 - 1056*D1**2*f**2*gd2*r*s + 1056*D1**2*f**2*gd2*r - 528*D1**2*f**2*gd2*s**2 + 1056*D1**2*f**2*gd2*s - 528*D1**2*f**2*gd2 + 660*D1**2*f**2*gdd2*r**2 + 1320*D1**2*f**2*gdd2*r*s - 1320*D1**2*f**2*gdd2*r + 660*D1**2*f**2*gdd2*s**2 - 1320*D1**2*f**2*gdd2*s + 660*D1**2*f**2*gdd2 + 2520*D1**2*f*fd**2*r**2 + 5040*D1**2*f*fd**2*r*s - 3360*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 3360*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 1056*D1**2*f*fd*g2*r**2 - 2112*D1**2*f*fd*g2*r*s + 1056*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 + 2640*D1**2*f*fd*gd2*r**2 + 5280*D1**2*f*fd*gd2*r*s - 3960*D1**2*f*fd*gd2*r + 2640*D1**2*f*fd*gd2*s**2 - 3960*D1**2*f*fd*gd2*s + 1320*D1**2*f*fd*gd2 + 1320*D1**2*f*fdd*g2*r**2 + 2640*D1**2*f*fdd*g2*r*s - 1320*D1**2*f*fdd*g2*r + 1320*D1**2*f*fdd*g2*s**2 - 1320*D1**2*f*fdd*g2*s + 660*D1**2*f*fdd*g2 + 1320*D1**2*fd**2*g2*r**2 + 2640*D1**2*fd**2*g2*r*s - 1320*D1**2*fd**2*g2*r + 1320*D1**2*fd**2*g2*s**2 - 1320*D1**2*fd**2*g2*s - 560*D1*Dd*f**4*r**2 - 1120*D1*Dd*f**4*r*s + 840*D1*Dd*f**4*r - 560*D1*Dd*f**4*s**2 + 840*D1*Dd*f**4*s - 420*D1*Dd*f**4 - 1380*D1*Dd*f**3*r**2 - 2760*D1*Dd*f**3*r*s + 2070*D1*Dd*f**3*r - 1380*D1*Dd*f**3*s**2 + 2070*D1*Dd*f**3*s - 1035*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 20160*D1*Dd*f**2*fd*r*s - 14280*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 14280*D1*Dd*f**2*fd*s + 5040*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*g2*r**2 - 4224*D1*Dd*f**2*g2*r*s + 3168*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s**2 + 3168*D1*Dd*f**2*g2*s - 1584*D1*Dd*f**2*g2 + 5280*D1*Dd*f**2*gd2*r**2 + 10560*D1*Dd*f**2*gd2*r*s - 9240*D1*Dd*f**2*gd2*r + 5280*D1*Dd*f**2*gd2*s**2 - 9240*D1*Dd*f**2*gd2*s + 3960*D1*Dd*f**2*gd2 + 10560*D1*Dd*f*fd*g2*r**2 + 21120*D1*Dd*f*fd*g2*r*s - 13200*D1*Dd*f*fd*g2*r + 10560*D1*Dd*f*fd*g2*s**2 - 13200*D1*Dd*f*fd*g2*s + 3960*D1*Dd*f*fd*g2 + 1680*D1*Ddd*f**3*r**2 + 3360*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 2520*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 2640*D1*Ddd*f**2*g2*r**2 + 5280*D1*Ddd*f**2*g2*r*s - 3960*D1*Ddd*f**2*g2*r + 2640*D1*Ddd*f**2*g2*s**2 - 3960*D1*Ddd*f**2*g2*s + 1980*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(370*f**3*(r + s - 1) + 2*f**2*(264*C*(r + s - 1) - 350*fd*(3*r + 3*s - 2) + (66*K - 297)*(r + s - 1)) - 33*f*(5*fd*(8*C + 2*K - 9)*(2*r + 2*s - 1) + (20*g2 - 48*gd2)*(r + s - 1)) + 1584*fd*g2*(r + s)) - Dd*f*(700*f**2 + 165*f*(8*C + 2*K - 9) - 1584*g2)*(4*r + 4*s - 3))*(r + s - 1) + 5040*Dd**2*f**3*r**2 + 10080*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 7560*Dd**2*f**3*s + 2520*Dd**2*f**3 + 7920*Dd**2*f**2*g2*r**2 + 15840*Dd**2*f**2*g2*r*s - 11880*Dd**2*f**2*g2*r + 7920*Dd**2*f**2*g2*s**2 - 11880*Dd**2*f**2*g2*s + 3960*Dd**2*f**2*g2 + 132*b1**2*(K - 1)*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(2112*C*D1**2*f*fd*r**2 + 4224*C*D1**2*f*fd*r*s - 2112*C*D1**2*f*fd*r + 2112*C*D1**2*f*fd*s**2 - 2112*C*D1**2*f*fd*s + 1056*C*D1**2*f*fd - 2640*C*D1**2*f*fdd*r**2 - 5280*C*D1**2*f*fdd*r*s + 2640*C*D1**2*f*fdd*r - 2640*C*D1**2*f*fdd*s**2 + 2640*C*D1**2*f*fdd*s - 1320*C*D1**2*f*fdd - 2640*C*D1**2*fd**2*r**2 - 5280*C*D1**2*fd**2*r*s + 2640*C*D1**2*fd**2*r - 2640*C*D1**2*fd**2*s**2 + 2640*C*D1**2*fd**2*s + 4224*C*D1*Dd*f**2*r**2 + 8448*C*D1*Dd*f**2*r*s - 6336*C*D1*Dd*f**2*r + 4224*C*D1*Dd*f**2*s**2 - 6336*C*D1*Dd*f**2*s + 3168*C*D1*Dd*f**2 - 21120*C*D1*Dd*f*fd*r**2 - 42240*C*D1*Dd*f*fd*r*s + 26400*C*D1*Dd*f*fd*r - 21120*C*D1*Dd*f*fd*s**2 + 26400*C*D1*Dd*f*fd*s - 7920*C*D1*Dd*f*fd - 5280*C*D1*Ddd*f**2*r**2 - 10560*C*D1*Ddd*f**2*r*s + 7920*C*D1*Ddd*f**2*r - 5280*C*D1*Ddd*f**2*s**2 + 7920*C*D1*Ddd*f**2*s - 3960*C*D1*Ddd*f**2 - 15840*C*Dd**2*f**2*r**2 - 31680*C*Dd**2*f**2*r*s + 23760*C*Dd**2*f**2*r - 15840*C*Dd**2*f**2*s**2 + 23760*C*Dd**2*f**2*s - 7920*C*Dd**2*f**2 + 528*D1**2*K*f*fd*r**2 + 1056*D1**2*K*f*fd*r*s - 528*D1**2*K*f*fd*r + 528*D1**2*K*f*fd*s**2 - 528*D1**2*K*f*fd*s + 264*D1**2*K*f*fd - 660*D1**2*K*f*fdd*r**2 - 1320*D1**2*K*f*fdd*r*s + 660*D1**2*K*f*fdd*r - 660*D1**2*K*f*fdd*s**2 + 660*D1**2*K*f*fdd*s - 330*D1**2*K*f*fdd - 660*D1**2*K*fd**2*r**2 - 1320*D1**2*K*fd**2*r*s + 660*D1**2*K*fd**2*r - 660*D1**2*K*fd**2*s**2 + 660*D1**2*K*fd**2*s - 1584*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 2220*D1**2*f**2*fd*r**2 + 4440*D1**2*f**2*fd*r*s - 2960*D1**2*f**2*fd*r + 2220*D1**2*f**2*fd*s**2 - 2960*D1**2*f**2*fd*s + 1480*D1**2*f**2*fd - 2100*D1**2*f**2*fdd*r**2 - 4200*D1**2*f**2*fdd*r*s + 2800*D1**2*f**2*fdd*r - 2100*D1**2*f**2*fdd*s**2 + 2800*D1**2*f**2*fdd*s - 1400*D1**2*f**2*fdd - 4200*D1**2*f*fd**2*r**2 - 8400*D1**2*f*fd**2*r*s + 5600*D1**2*f*fd**2*r - 4200*D1**2*f*fd**2*s**2 + 5600*D1**2*f*fd**2*s - 1400*D1**2*f*fd**2 - 2376*D1**2*f*fd*r**2 - 4752*D1**2*f*fd*r*s + 2376*D1**2*f*fd*r - 2376*D1**2*f*fd*s**2 + 2376*D1**2*f*fd*s - 1188*D1**2*f*fd + 2970*D1**2*f*fdd*r**2 + 5940*D1**2*f*fdd*r*s - 2970*D1**2*f*fdd*r + 2970*D1**2*f*fdd*s**2 - 2970*D1**2*f*fdd*s + 1485*D1**2*f*fdd - 1320*D1**2*f*gd2*r**2 - 2640*D1**2*f*gd2*r*s + 2640*D1**2*f*gd2*r - 1320*D1**2*f*gd2*s**2 + 2640*D1**2*f*gd2*s - 1320*D1**2*f*gd2 + 1584*D1**2*f*gdd2*r**2 + 3168*D1**2*f*gdd2*r*s - 3168*D1**2*f*gdd2*r + 1584*D1**2*f*gdd2*s**2 - 3168*D1**2*f*gdd2*s + 1584*D1**2*f*gdd2 + 2970*D1**2*fd**2*r**2 + 5940*D1**2*fd**2*r*s - 2970*D1**2*fd**2*r + 2970*D1**2*fd**2*s**2 - 2970*D1**2*fd**2*s - 1320*D1**2*fd*g2*r**2 - 2640*D1**2*fd*g2*r*s - 1320*D1**2*fd*g2*s**2 + 3168*D1**2*fd*gd2*r**2 + 6336*D1**2*fd*gd2*r*s - 3168*D1**2*fd*gd2*r + 3168*D1**2*fd*gd2*s**2 - 3168*D1**2*fd*gd2*s + 1584*D1**2*fdd*g2*r**2 + 3168*D1**2*fdd*g2*r*s + 1584*D1**2*fdd*g2*s**2 + 1056*D1*Dd*K*f**2*r**2 + 2112*D1*Dd*K*f**2*r*s - 1584*D1*Dd*K*f**2*r + 1056*D1*Dd*K*f**2*s**2 - 1584*D1*Dd*K*f**2*s + 792*D1*Dd*K*f**2 - 5280*D1*Dd*K*f*fd*r**2 - 10560*D1*Dd*K*f*fd*r*s + 6600*D1*Dd*K*f*fd*r - 5280*D1*Dd*K*f*fd*s**2 + 6600*D1*Dd*K*f*fd*s - 1980*D1*Dd*K*f*fd + 2960*D1*Dd*f**3*r**2 + 5920*D1*Dd*f**3*r*s - 4440*D1*Dd*f**3*r + 2960*D1*Dd*f**3*s**2 - 4440*D1*Dd*f**3*s + 2220*D1*Dd*f**3 - 16800*D1*Dd*f**2*fd*r**2 - 33600*D1*Dd*f**2*fd*r*s + 23800*D1*Dd*f**2*fd*r - 16800*D1*Dd*f**2*fd*s**2 + 23800*D1*Dd*f**2*fd*s - 8400*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*r**2 - 9504*D1*Dd*f**2*r*s + 7128*D1*Dd*f**2*r - 4752*D1*Dd*f**2*s**2 + 7128*D1*Dd*f**2*s - 3564*D1*Dd*f**2 + 23760*D1*Dd*f*fd*r**2 + 47520*D1*Dd*f*fd*r*s - 29700*D1*Dd*f*fd*r + 23760*D1*Dd*f*fd*s**2 - 29700*D1*Dd*f*fd*s + 8910*D1*Dd*f*fd - 5280*D1*Dd*f*g2*r**2 - 10560*D1*Dd*f*g2*r*s + 7920*D1*Dd*f*g2*r - 5280*D1*Dd*f*g2*s**2 + 7920*D1*Dd*f*g2*s - 3960*D1*Dd*f*g2 + 12672*D1*Dd*f*gd2*r**2 + 25344*D1*Dd*f*gd2*r*s - 22176*D1*Dd*f*gd2*r + 12672*D1*Dd*f*gd2*s**2 - 22176*D1*Dd*f*gd2*s + 9504*D1*Dd*f*gd2 + 12672*D1*Dd*fd*g2*r**2 + 25344*D1*Dd*fd*g2*r*s - 9504*D1*Dd*fd*g2*r + 12672*D1*Dd*fd*g2*s**2 - 9504*D1*Dd*fd*g2*s - 1320*D1*Ddd*K*f**2*r**2 - 2640*D1*Ddd*K*f**2*r*s + 1980*D1*Ddd*K*f**2*r - 1320*D1*Ddd*K*f**2*s**2 + 1980*D1*Ddd*K*f**2*s - 990*D1*Ddd*K*f**2 - 2800*D1*Ddd*f**3*r**2 - 5600*D1*Ddd*f**3*r*s + 4200*D1*Ddd*f**3*r - 2800*D1*Ddd*f**3*s**2 + 4200*D1*Ddd*f**3*s - 2100*D1*Ddd*f**3 + 5940*D1*Ddd*f**2*r**2 + 11880*D1*Ddd*f**2*r*s - 8910*D1*Ddd*f**2*r + 5940*D1*Ddd*f**2*s**2 - 8910*D1*Ddd*f**2*s + 4455*D1*Ddd*f**2 + 6336*D1*Ddd*f*g2*r**2 + 12672*D1*Ddd*f*g2*r*s - 9504*D1*Ddd*f*g2*r + 6336*D1*Ddd*f*g2*s**2 - 9504*D1*Ddd*f*g2*s + 4752*D1*Ddd*f*g2 + 264*D1*bd1*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3960*Dd**2*K*f**2*r**2 - 7920*Dd**2*K*f**2*r*s + 5940*Dd**2*K*f**2*r - 3960*Dd**2*K*f**2*s**2 + 5940*Dd**2*K*f**2*s - 1980*Dd**2*K*f**2 - 8400*Dd**2*f**3*r**2 - 16800*Dd**2*f**3*r*s + 12600*Dd**2*f**3*r - 8400*Dd**2*f**3*s**2 + 12600*Dd**2*f**3*s - 4200*Dd**2*f**3 + 17820*Dd**2*f**2*r**2 + 35640*Dd**2*f**2*r*s - 26730*Dd**2*f**2*r + 17820*Dd**2*f**2*s**2 - 26730*Dd**2*f**2*s + 8910*Dd**2*f**2 + 19008*Dd**2*f*g2*r**2 + 38016*Dd**2*f*g2*r*s - 28512*Dd**2*f*g2*r + 19008*Dd**2*f*g2*s**2 - 28512*Dd**2*f*g2*s + 9504*Dd**2*f*g2))/(77*d**2*k3**7) + 4*D1**2*Pk2*Pkd3*ct**3*k1**5*st**2*(9126*C*D1**2*f**2*fd*r*s - 3042*C*D1**2*f**2*fd*r + 9126*C*D1**2*f**2*fd*s**2 - 9126*C*D1**2*f**2*fd*s + 3042*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 12168*C*D1*Dd*f**3*r*s - 3042*C*D1*Dd*f**3*r + 12168*C*D1*Dd*f**3*s**2 - 12168*C*D1*Dd*f**3*s + 3042*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 55000*D1**2*f**3*fd*r*s - 13750*D1**2*f**3*fd*r + 55000*D1**2*f**3*fd*s**2 - 55000*D1**2*f**3*fd*s + 13750*D1**2*f**3*fd - 39200*D1**2*f**3*fdd*r*s + 9800*D1**2*f**3*fdd*r - 39200*D1**2*f**3*fdd*s**2 + 39200*D1**2*f**3*fdd*s - 9800*D1**2*f**3*fdd - 117600*D1**2*f**2*fd**2*r*s + 29400*D1**2*f**2*fd**2*r - 117600*D1**2*f**2*fd**2*s**2 + 117600*D1**2*f**2*fd**2*s - 19600*D1**2*f**2*fd**2 - 9126*D1**2*f**2*fd*r*s + 3042*D1**2*f**2*fd*r - 9126*D1**2*f**2*fd*s**2 + 9126*D1**2*f**2*fd*s - 3042*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*s**2 + 4290*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 8580*D1**2*f*fd*g2*r*s + 4290*D1**2*f*fd*g2*r - 8580*D1**2*f*fd*g2*s**2 + 8580*D1**2*f*fd*g2*s - 4290*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 55000*D1*Dd*f**4*r*s - 13750*D1*Dd*f**4*r + 55000*D1*Dd*f**4*s**2 - 55000*D1*Dd*f**4*s + 13750*D1*Dd*f**4 - 313600*D1*Dd*f**3*fd*r*s + 78400*D1*Dd*f**3*fd*r - 313600*D1*Dd*f**3*fd*s**2 + 313600*D1*Dd*f**3*fd*s - 58800*D1*Dd*f**3*fd - 12168*D1*Dd*f**3*r*s + 3042*D1*Dd*f**3*r - 12168*D1*Dd*f**3*s**2 + 12168*D1*Dd*f**3*s - 3042*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 17160*D1*Dd*f**2*g2*r*s + 4290*D1*Dd*f**2*g2*r - 17160*D1*Dd*f**2*g2*s**2 + 17160*D1*Dd*f**2*g2*s - 4290*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 39200*D1*Ddd*f**4*r*s + 9800*D1*Ddd*f**4*r - 39200*D1*Ddd*f**4*s**2 + 39200*D1*Ddd*f**4*s - 9800*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 117600*Dd**2*f**4*r*s + 29400*Dd**2*f**4*r - 117600*Dd**2*f**4*s**2 + 117600*Dd**2*f**4*s - 19600*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k2*k3**5) - D1**2*Pk2*Pkd3*ct**3*k1**5*(1320*C*D1**2*bdd1*f**2*r*s - 1320*C*D1**2*bdd1*f**2*r + 1320*C*D1**2*bdd1*f**2*s**2 - 2640*C*D1**2*bdd1*f**2*s + 1320*C*D1**2*bdd1*f**2 + 6720*C*D1**2*f**2*fd*r*s - 2240*C*D1**2*f**2*fd*r + 6720*C*D1**2*f**2*fd*s**2 - 6720*C*D1**2*f**2*fd*s + 2240*C*D1**2*f**2*fd - 7320*C*D1**2*f**2*fdd*r*s + 2440*C*D1**2*f**2*fdd*r - 7320*C*D1**2*f**2*fdd*s**2 + 7320*C*D1**2*f**2*fdd*s - 2440*C*D1**2*f**2*fdd - 14640*C*D1**2*f*fd**2*r*s + 4880*C*D1**2*f*fd**2*r - 14640*C*D1**2*f*fd**2*s**2 + 14640*C*D1**2*f*fd**2*s - 2440*C*D1**2*f*fd**2 + 8960*C*D1*Dd*f**3*r*s - 2240*C*D1*Dd*f**3*r + 8960*C*D1*Dd*f**3*s**2 - 8960*C*D1*Dd*f**3*s + 2240*C*D1*Dd*f**3 - 58560*C*D1*Dd*f**2*fd*r*s + 17080*C*D1*Dd*f**2*fd*r - 58560*C*D1*Dd*f**2*fd*s**2 + 58560*C*D1*Dd*f**2*fd*s - 12200*C*D1*Dd*f**2*fd - 9760*C*D1*Ddd*f**3*r*s + 2440*C*D1*Ddd*f**3*r - 9760*C*D1*Ddd*f**3*s**2 + 9760*C*D1*Ddd*f**3*s - 2440*C*D1*Ddd*f**3 - 29280*C*Dd**2*f**3*r*s + 7320*C*Dd**2*f**3*r - 29280*C*Dd**2*f**3*s**2 + 29280*C*Dd**2*f**3*s - 4880*C*Dd**2*f**3 - 1452*D1**2*K*bdd1*f**2*r*s - 1452*D1**2*K*bdd1*f**2*s**2 + 1452*D1**2*K*bdd1*f**2*s + 792*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 1400*D1**2*bdd1*f**3*r**2 + 4480*D1**2*bdd1*f**3*r*s - 3640*D1**2*bdd1*f**3*r + 3080*D1**2*bdd1*f**3*s**2 - 5320*D1**2*bdd1*f**3*s + 2940*D1**2*bdd1*f**3 + 825*D1**2*bdd1*f**2*r**2 + 1782*D1**2*bdd1*f**2*r*s - 330*D1**2*bdd1*f**2*r + 957*D1**2*bdd1*f**2*s**2 - 462*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 1584*D1**2*bdd1*f*g2*r*s + 1584*D1**2*bdd1*f*g2*r - 1584*D1**2*bdd1*f*g2*s**2 + 3168*D1**2*bdd1*f*g2*s - 1584*D1**2*bdd1*f*g2 + 5040*D1**2*f**3*fd*r**2 + 25760*D1**2*f**3*fd*r*s - 11480*D1**2*f**3*fd*r + 20720*D1**2*f**3*fd*s**2 - 23240*D1**2*f**3*fd*s + 7700*D1**2*f**3*fd - 6160*D1**2*f**3*fdd*r**2 - 23520*D1**2*f**3*fdd*r*s + 12040*D1**2*f**3*fdd*r - 17360*D1**2*f**3*fdd*s**2 + 20440*D1**2*f**3*fdd*s - 7420*D1**2*f**3*fdd - 18480*D1**2*f**2*fd**2*r**2 - 70560*D1**2*f**2*fd**2*r*s + 36120*D1**2*f**2*fd**2*r - 52080*D1**2*f**2*fd**2*s**2 + 61320*D1**2*f**2*fd**2*s - 14840*D1**2*f**2*fd**2 - 1725*D1**2*f**2*fd*r**2 - 10170*D1**2*f**2*fd*r*s + 4540*D1**2*f**2*fd*r - 8445*D1**2*f**2*fd*s**2 + 9020*D1**2*f**2*fd*s - 3390*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 11520*D1**2*f**2*fdd*r*s - 5240*D1**2*f**2*fdd*r + 9420*D1**2*f**2*fdd*s**2 - 10120*D1**2*f**2*fdd*s + 3840*D1**2*f**2*fdd - 2640*D1**2*f**2*gd2*r*s - 2640*D1**2*f**2*gd2*s**2 + 2640*D1**2*f**2*gd2*s + 2904*D1**2*f**2*gdd2*r*s + 2904*D1**2*f**2*gdd2*s**2 - 2904*D1**2*f**2*gdd2*s + 4200*D1**2*f*fd**2*r**2 + 23040*D1**2*f*fd**2*r*s - 10480*D1**2*f*fd**2*r + 18840*D1**2*f*fd**2*s**2 - 20240*D1**2*f*fd**2*s + 3840*D1**2*f*fd**2 - 5280*D1**2*f*fd*g2*r*s + 2640*D1**2*f*fd*g2*r - 5280*D1**2*f*fd*g2*s**2 + 5280*D1**2*f*fd*g2*s - 2640*D1**2*f*fd*g2 + 11616*D1**2*f*fd*gd2*r*s - 2904*D1**2*f*fd*gd2*r + 11616*D1**2*f*fd*gd2*s**2 - 11616*D1**2*f*fd*gd2*s + 2904*D1**2*f*fd*gd2 + 5808*D1**2*f*fdd*g2*r*s - 2904*D1**2*f*fdd*g2*r + 5808*D1**2*f*fdd*g2*s**2 - 5808*D1**2*f*fdd*g2*s + 2904*D1**2*f*fdd*g2 + 5808*D1**2*fd**2*g2*r*s - 2904*D1**2*fd**2*g2*r + 5808*D1**2*fd**2*g2*s**2 - 5808*D1**2*fd**2*g2*s + 5040*D1*Dd*f**4*r**2 + 25760*D1*Dd*f**4*r*s - 11480*D1*Dd*f**4*r + 20720*D1*Dd*f**4*s**2 - 23240*D1*Dd*f**4*s + 7700*D1*Dd*f**4 - 49280*D1*Dd*f**3*fd*r**2 - 188160*D1*Dd*f**3*fd*r*s + 96320*D1*Dd*f**3*fd*r - 138880*D1*Dd*f**3*fd*s**2 + 163520*D1*Dd*f**3*fd*s - 44520*D1*Dd*f**3*fd - 2300*D1*Dd*f**3*r**2 - 13560*D1*Dd*f**3*r*s + 5690*D1*Dd*f**3*r - 11260*D1*Dd*f**3*s**2 + 12410*D1*Dd*f**3*s - 3965*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 92160*D1*Dd*f**2*fd*r*s - 40880*D1*Dd*f**2*fd*r + 75360*D1*Dd*f**2*fd*s**2 - 82360*D1*Dd*f**2*fd*s + 20600*D1*Dd*f**2*fd - 10560*D1*Dd*f**2*g2*r*s + 2640*D1*Dd*f**2*g2*r - 10560*D1*Dd*f**2*g2*s**2 + 10560*D1*Dd*f**2*g2*s - 2640*D1*Dd*f**2*g2 + 23232*D1*Dd*f**2*gd2*r*s - 2904*D1*Dd*f**2*gd2*r + 23232*D1*Dd*f**2*gd2*s**2 - 23232*D1*Dd*f**2*gd2*s + 2904*D1*Dd*f**2*gd2 + 46464*D1*Dd*f*fd*g2*r*s - 17424*D1*Dd*f*fd*g2*r + 46464*D1*Dd*f*fd*g2*s**2 - 46464*D1*Dd*f*fd*g2*s + 11616*D1*Dd*f*fd*g2 - 6160*D1*Ddd*f**4*r**2 - 23520*D1*Ddd*f**4*r*s + 12040*D1*Ddd*f**4*r - 17360*D1*Ddd*f**4*s**2 + 20440*D1*Ddd*f**4*s - 7420*D1*Ddd*f**4 + 2800*D1*Ddd*f**3*r**2 + 15360*D1*Ddd*f**3*r*s - 6640*D1*Ddd*f**3*r + 12560*D1*Ddd*f**3*s**2 - 13960*D1*Ddd*f**3*s + 4540*D1*Ddd*f**3 + 11616*D1*Ddd*f**2*g2*r*s - 2904*D1*Ddd*f**2*g2*r + 11616*D1*Ddd*f**2*g2*s**2 - 11616*D1*Ddd*f**2*g2*s + 2904*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(230*r**2 + r*(868*s - 730) + 638*s**2 - 1138*s + 615) - 4*f**2*(264*C*(s - 1)*(r + s - 1) - 140*fd*(15*r**2 + 48*r*s - 31*r + 33*s**2 - 46*s + 12) + (33*r + 33*s - 33)*(-10*K*s + 5*r + 7*s + 3)) + 66*f*(fd*(20*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 22*K*(r*(4*s - 1) + (1 - 2*s)**2) + 50*r**2 + 108*r*s - 57*r + 58*s**2 - 63*s + 27) + (20*g2*(s - 1) + 24*gd2*(1 - 2*s))*(r + s - 1)) - 1584*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*Dd*f*(140*f**2*(40*r**2 + 8*r*(16*s - 11) + 88*s**2 - 130*s + 45) + 33*f*(20*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 22*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 100*r**2 + 216*r*s - 97*r + 116*s**2 - 111*s + 17) - 792*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 18480*Dd**2*f**4*r**2 - 70560*Dd**2*f**4*r*s + 36120*Dd**2*f**4*r - 52080*Dd**2*f**4*s**2 + 61320*Dd**2*f**4*s - 14840*Dd**2*f**4 + 8400*Dd**2*f**3*r**2 + 46080*Dd**2*f**3*r*s - 19920*Dd**2*f**3*r + 37680*Dd**2*f**3*s**2 - 41880*Dd**2*f**3*s + 9080*Dd**2*f**3 + 34848*Dd**2*f**2*g2*r*s - 8712*Dd**2*f**2*g2*r + 34848*Dd**2*f**2*g2*s**2 - 34848*Dd**2*f**2*g2*s + 5808*Dd**2*f**2*g2 - 132*b1**2*(K - 1)*(D1**2*s*(5*fd - 6*fdd)*(r + s) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) + 6*fd*(-8*r*s + r + s*(4 - 8*s))) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-2112*C*D1**2*f*fd*r*s - 2112*C*D1**2*f*fd*s**2 + 1056*C*D1**2*f*fd*s + 2640*C*D1**2*f*fdd*r*s + 2640*C*D1**2*f*fdd*s**2 - 1320*C*D1**2*f*fdd*s + 2640*C*D1**2*fd**2*r*s + 2640*C*D1**2*fd**2*s**2 - 1320*C*D1**2*fd**2*s - 4224*C*D1*Dd*f**2*r*s + 1056*C*D1*Dd*f**2*r - 4224*C*D1*Dd*f**2*s**2 + 4224*C*D1*Dd*f**2*s - 1056*C*D1*Dd*f**2 + 21120*C*D1*Dd*f*fd*r*s - 2640*C*D1*Dd*f*fd*r + 21120*C*D1*Dd*f*fd*s**2 - 15840*C*D1*Dd*f*fd*s + 1320*C*D1*Dd*f*fd + 5280*C*D1*Ddd*f**2*r*s - 1320*C*D1*Ddd*f**2*r + 5280*C*D1*Ddd*f**2*s**2 - 5280*C*D1*Ddd*f**2*s + 1320*C*D1*Ddd*f**2 + 15840*C*Dd**2*f**2*r*s - 3960*C*Dd**2*f**2*r + 15840*C*Dd**2*f**2*s**2 - 15840*C*Dd**2*f**2*s + 2640*C*Dd**2*f**2 + 2640*D1**2*K*f*fd*r*s - 1320*D1**2*K*f*fd*r + 2640*D1**2*K*f*fd*s**2 - 2640*D1**2*K*f*fd*s + 1320*D1**2*K*f*fd - 2904*D1**2*K*f*fdd*r*s + 1452*D1**2*K*f*fdd*r - 2904*D1**2*K*f*fdd*s**2 + 2904*D1**2*K*f*fdd*s - 1452*D1**2*K*f*fdd - 2904*D1**2*K*fd**2*r*s + 1452*D1**2*K*fd**2*r - 2904*D1**2*K*fd**2*s**2 + 2904*D1**2*K*fd**2*s + 792*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 3450*D1**2*f**2*fd*r**2 - 13020*D1**2*f**2*fd*r*s + 5290*D1**2*f**2*fd*r - 9570*D1**2*f**2*fd*s**2 + 9370*D1**2*f**2*fd*s - 2415*D1**2*f**2*fd + 4200*D1**2*f**2*fdd*r**2 + 13440*D1**2*f**2*fdd*r*s - 6440*D1**2*f**2*fdd*r + 9240*D1**2*f**2*fdd*s**2 - 9800*D1**2*f**2*fdd*s + 2940*D1**2*f**2*fdd + 8400*D1**2*f*fd**2*r**2 + 26880*D1**2*f*fd**2*r*s - 12880*D1**2*f*fd**2*r + 18480*D1**2*f*fd**2*s**2 - 19600*D1**2*f*fd**2*s + 5040*D1**2*f*fd**2 - 1320*D1**2*f*fd*r**2 - 3168*D1**2*f*fd*r*s + 2640*D1**2*f*fd*r - 1848*D1**2*f*fd*s**2 + 2904*D1**2*f*fd*s - 1980*D1**2*f*fd + 1650*D1**2*f*fdd*r**2 + 3564*D1**2*f*fdd*r*s - 3102*D1**2*f*fdd*r + 1914*D1**2*f*fdd*s**2 - 3234*D1**2*f*fdd*s + 2277*D1**2*f*fdd + 1320*D1**2*f*gd2*r*s + 1320*D1**2*f*gd2*s**2 - 1320*D1**2*f*gd2*s - 1584*D1**2*f*gdd2*r*s - 1584*D1**2*f*gdd2*s**2 + 1584*D1**2*f*gdd2*s + 1650*D1**2*fd**2*r**2 + 3564*D1**2*fd**2*r*s - 3102*D1**2*fd**2*r + 1914*D1**2*fd**2*s**2 - 3234*D1**2*fd**2*s + 1320*D1**2*fd*g2*r*s + 1320*D1**2*fd*g2*s**2 - 3168*D1**2*fd*gd2*r*s - 3168*D1**2*fd*gd2*s**2 + 1584*D1**2*fd*gd2*s - 1584*D1**2*fdd*g2*r*s - 1584*D1**2*fdd*g2*s**2 + 5280*D1*Dd*K*f**2*r*s - 1320*D1*Dd*K*f**2*r + 5280*D1*Dd*K*f**2*s**2 - 5280*D1*Dd*K*f**2*s + 1320*D1*Dd*K*f**2 - 23232*D1*Dd*K*f*fd*r*s + 8712*D1*Dd*K*f*fd*r - 23232*D1*Dd*K*f*fd*s**2 + 23232*D1*Dd*K*f*fd*s - 5808*D1*Dd*K*f*fd - 4600*D1*Dd*f**3*r**2 - 17360*D1*Dd*f**3*r*s + 8940*D1*Dd*f**3*r - 12760*D1*Dd*f**3*s**2 + 15060*D1*Dd*f**3*s - 5490*D1*Dd*f**3 + 33600*D1*Dd*f**2*fd*r**2 + 107520*D1*Dd*f**2*fd*r*s - 56000*D1*Dd*f**2*fd*r + 73920*D1*Dd*f**2*fd*s**2 - 84560*D1*Dd*f**2*fd*s + 22680*D1*Dd*f**2*fd - 2640*D1*Dd*f**2*r**2 - 6336*D1*Dd*f**2*r*s + 4224*D1*Dd*f**2*r - 3696*D1*Dd*f**2*s**2 + 5016*D1*Dd*f**2*s - 2244*D1*Dd*f**2 + 13200*D1*Dd*f*fd*r**2 + 28512*D1*Dd*f*fd*r*s - 22572*D1*Dd*f*fd*r + 15312*D1*Dd*f*fd*s**2 - 23892*D1*Dd*f*fd*s + 9438*D1*Dd*f*fd + 5280*D1*Dd*f*g2*r*s - 1320*D1*Dd*f*g2*r + 5280*D1*Dd*f*g2*s**2 - 5280*D1*Dd*f*g2*s + 1320*D1*Dd*f*g2 - 12672*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r - 12672*D1*Dd*f*gd2*s**2 + 12672*D1*Dd*f*gd2*s - 1584*D1*Dd*f*gd2 - 12672*D1*Dd*fd*g2*r*s + 1584*D1*Dd*fd*g2*r - 12672*D1*Dd*fd*g2*s**2 + 6336*D1*Dd*fd*g2*s - 5808*D1*Ddd*K*f**2*r*s + 1452*D1*Ddd*K*f**2*r - 5808*D1*Ddd*K*f**2*s**2 + 5808*D1*Ddd*K*f**2*s - 1452*D1*Ddd*K*f**2 + 5600*D1*Ddd*f**3*r**2 + 17920*D1*Ddd*f**3*r*s - 10080*D1*Ddd*f**3*r + 12320*D1*Ddd*f**3*s**2 - 15120*D1*Ddd*f**3*s + 5880*D1*Ddd*f**3 + 3300*D1*Ddd*f**2*r**2 + 7128*D1*Ddd*f**2*r*s - 5082*D1*Ddd*f**2*r + 3828*D1*Ddd*f**2*s**2 - 5478*D1*Ddd*f**2*s + 2607*D1*Ddd*f**2 - 6336*D1*Ddd*f*g2*r*s + 1584*D1*Ddd*f*g2*r - 6336*D1*Ddd*f*g2*s**2 + 6336*D1*Ddd*f*g2*s - 1584*D1*Ddd*f*g2 - 132*D1*bd1*(K - 1)*(D1*(5*f*(2*s - 1)*(r + s - 1) + 6*fd*(-4*r*s + r + s*(3 - 4*s))) - 6*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 17424*Dd**2*K*f**2*r*s + 4356*Dd**2*K*f**2*r - 17424*Dd**2*K*f**2*s**2 + 17424*Dd**2*K*f**2*s - 2904*Dd**2*K*f**2 + 16800*Dd**2*f**3*r**2 + 53760*Dd**2*f**3*r*s - 30240*Dd**2*f**3*r + 36960*Dd**2*f**3*s**2 - 45360*Dd**2*f**3*s + 11760*Dd**2*f**3 + 9900*Dd**2*f**2*r**2 + 21384*Dd**2*f**2*r*s - 15246*Dd**2*f**2*r + 11484*Dd**2*f**2*s**2 - 16434*Dd**2*f**2*s + 5214*Dd**2*f**2 - 19008*Dd**2*f*g2*r*s + 4752*Dd**2*f*g2*r - 19008*Dd**2*f*g2*s**2 + 19008*Dd**2*f*g2*s - 3168*Dd**2*f*g2))/(693*d**2*k2*k3**5) + D1**2*Pk2*Pkd3*ct**3*k1**3*k2**3*st**2*(-396*C*D1**2*bdd1*f**2*r**2 - 792*C*D1**2*bdd1*f**2*r*s + 792*C*D1**2*bdd1*f**2*r - 396*C*D1**2*bdd1*f**2*s**2 + 792*C*D1**2*bdd1*f**2*s - 396*C*D1**2*bdd1*f**2 + 6642*C*D1**2*f**2*fd*r**2 + 13284*C*D1**2*f**2*fd*r*s - 8856*C*D1**2*f**2*fd*r + 6642*C*D1**2*f**2*fd*s**2 - 8856*C*D1**2*f**2*fd*s + 4428*C*D1**2*f**2*fd - 5400*C*D1**2*f**2*fdd*r**2 - 10800*C*D1**2*f**2*fdd*r*s + 7200*C*D1**2*f**2*fdd*r - 5400*C*D1**2*f**2*fdd*s**2 + 7200*C*D1**2*f**2*fdd*s - 3600*C*D1**2*f**2*fdd - 10800*C*D1**2*f*fd**2*r**2 - 21600*C*D1**2*f*fd**2*r*s + 14400*C*D1**2*f*fd**2*r - 10800*C*D1**2*f*fd**2*s**2 + 14400*C*D1**2*f*fd**2*s - 3600*C*D1**2*f*fd**2 + 8856*C*D1*Dd*f**3*r**2 + 17712*C*D1*Dd*f**3*r*s - 13284*C*D1*Dd*f**3*r + 8856*C*D1*Dd*f**3*s**2 - 13284*C*D1*Dd*f**3*s + 6642*C*D1*Dd*f**3 - 43200*C*D1*Dd*f**2*fd*r**2 - 86400*C*D1*Dd*f**2*fd*r*s + 61200*C*D1*Dd*f**2*fd*r - 43200*C*D1*Dd*f**2*fd*s**2 + 61200*C*D1*Dd*f**2*fd*s - 21600*C*D1*Dd*f**2*fd - 7200*C*D1*Ddd*f**3*r**2 - 14400*C*D1*Ddd*f**3*r*s + 10800*C*D1*Ddd*f**3*r - 7200*C*D1*Ddd*f**3*s**2 + 10800*C*D1*Ddd*f**3*s - 5400*C*D1*Ddd*f**3 - 21600*C*Dd**2*f**3*r**2 - 43200*C*Dd**2*f**3*r*s + 32400*C*Dd**2*f**3*r - 21600*C*Dd**2*f**3*s**2 + 32400*C*Dd**2*f**3*s - 10800*C*Dd**2*f**3 - 1188*D1**2*K*bdd1*f**2*r**2 - 2376*D1**2*K*bdd1*f**2*r*s + 2376*D1**2*K*bdd1*f**2*r - 1188*D1**2*K*bdd1*f**2*s**2 + 2376*D1**2*K*bdd1*f**2*s - 1188*D1**2*K*bdd1*f**2 - 396*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 625*D1**2*bdd1*f**3*r**2 + 1250*D1**2*bdd1*f**3*r*s - 1250*D1**2*bdd1*f**3*r + 625*D1**2*bdd1*f**3*s**2 - 1250*D1**2*bdd1*f**3*s + 625*D1**2*bdd1*f**3 + 990*D1**2*bdd1*f**2*r**2 + 1980*D1**2*bdd1*f**2*r*s - 1980*D1**2*bdd1*f**2*r + 990*D1**2*bdd1*f**2*s**2 - 1980*D1**2*bdd1*f**2*s + 990*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r**2 + 792*D1**2*bdd1*f*g2*r*s - 792*D1**2*bdd1*f*g2*r + 396*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 1500*D1**2*f**3*fd*r**2 - 3000*D1**2*f**3*fd*r*s + 2250*D1**2*f**3*fd*r - 1500*D1**2*f**3*fd*s**2 + 2250*D1**2*f**3*fd*s - 1125*D1**2*f**3*fd - 4833*D1**2*f**2*fd*r**2 - 9666*D1**2*f**2*fd*r*s + 6444*D1**2*f**2*fd*r - 4833*D1**2*f**2*fd*s**2 + 6444*D1**2*f**2*fd*s - 3222*D1**2*f**2*fd + 4050*D1**2*f**2*fdd*r**2 + 8100*D1**2*f**2*fdd*r*s - 5400*D1**2*f**2*fdd*r + 4050*D1**2*f**2*fdd*s**2 - 5400*D1**2*f**2*fdd*s + 2700*D1**2*f**2*fdd - 3366*D1**2*f**2*gd2*r**2 - 6732*D1**2*f**2*gd2*r*s + 6732*D1**2*f**2*gd2*r - 3366*D1**2*f**2*gd2*s**2 + 6732*D1**2*f**2*gd2*s - 3366*D1**2*f**2*gd2 + 2376*D1**2*f**2*gdd2*r**2 + 4752*D1**2*f**2*gdd2*r*s - 4752*D1**2*f**2*gdd2*r + 2376*D1**2*f**2*gdd2*s**2 - 4752*D1**2*f**2*gdd2*s + 2376*D1**2*f**2*gdd2 + 8100*D1**2*f*fd**2*r**2 + 16200*D1**2*f*fd**2*r*s - 10800*D1**2*f*fd**2*r + 8100*D1**2*f*fd**2*s**2 - 10800*D1**2*f*fd**2*s + 2700*D1**2*f*fd**2 - 6732*D1**2*f*fd*g2*r**2 - 13464*D1**2*f*fd*g2*r*s + 6732*D1**2*f*fd*g2*r - 6732*D1**2*f*fd*g2*s**2 + 6732*D1**2*f*fd*g2*s - 3366*D1**2*f*fd*g2 + 9504*D1**2*f*fd*gd2*r**2 + 19008*D1**2*f*fd*gd2*r*s - 14256*D1**2*f*fd*gd2*r + 9504*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4752*D1**2*f*fd*gd2 + 4752*D1**2*f*fdd*g2*r**2 + 9504*D1**2*f*fdd*g2*r*s - 4752*D1**2*f*fdd*g2*r + 4752*D1**2*f*fdd*g2*s**2 - 4752*D1**2*f*fdd*g2*s + 2376*D1**2*f*fdd*g2 + 4752*D1**2*fd**2*g2*r**2 + 9504*D1**2*fd**2*g2*r*s - 4752*D1**2*fd**2*g2*r + 4752*D1**2*fd**2*g2*s**2 - 4752*D1**2*fd**2*g2*s - 1500*D1*Dd*f**4*r**2 - 3000*D1*Dd*f**4*r*s + 2250*D1*Dd*f**4*r - 1500*D1*Dd*f**4*s**2 + 2250*D1*Dd*f**4*s - 1125*D1*Dd*f**4 - 6444*D1*Dd*f**3*r**2 - 12888*D1*Dd*f**3*r*s + 9666*D1*Dd*f**3*r - 6444*D1*Dd*f**3*s**2 + 9666*D1*Dd*f**3*s - 4833*D1*Dd*f**3 + 32400*D1*Dd*f**2*fd*r**2 + 64800*D1*Dd*f**2*fd*r*s - 45900*D1*Dd*f**2*fd*r + 32400*D1*Dd*f**2*fd*s**2 - 45900*D1*Dd*f**2*fd*s + 16200*D1*Dd*f**2*fd - 13464*D1*Dd*f**2*g2*r**2 - 26928*D1*Dd*f**2*g2*r*s + 20196*D1*Dd*f**2*g2*r - 13464*D1*Dd*f**2*g2*s**2 + 20196*D1*Dd*f**2*g2*s - 10098*D1*Dd*f**2*g2 + 19008*D1*Dd*f**2*gd2*r**2 + 38016*D1*Dd*f**2*gd2*r*s - 33264*D1*Dd*f**2*gd2*r + 19008*D1*Dd*f**2*gd2*s**2 - 33264*D1*Dd*f**2*gd2*s + 14256*D1*Dd*f**2*gd2 + 38016*D1*Dd*f*fd*g2*r**2 + 76032*D1*Dd*f*fd*g2*r*s - 47520*D1*Dd*f*fd*g2*r + 38016*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 + 5400*D1*Ddd*f**3*r**2 + 10800*D1*Ddd*f**3*r*s - 8100*D1*Ddd*f**3*r + 5400*D1*Ddd*f**3*s**2 - 8100*D1*Ddd*f**3*s + 4050*D1*Ddd*f**3 + 9504*D1*Ddd*f**2*g2*r**2 + 19008*D1*Ddd*f**2*g2*r*s - 14256*D1*Ddd*f**2*g2*r + 9504*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 7128*D1*Ddd*f**2*g2 - D1*bd1*(D1*(689*f**3*(r + s - 1) - f**2*(726*C*(r + s - 1) + 1250*fd*(3*r + 3*s - 2) + (1683*K - 1518)*(r + s - 1)) + 66*f*(6*fd*(2*C + 6*K - 5)*(2*r + 2*s - 1) + (19*g2 - 12*gd2)*(r + s - 1)) - 792*fd*g2*(r + s)) - 2*Dd*f*(625*f**2 - 198*f*(2*C + 6*K - 5) + 396*g2)*(4*r + 4*s - 3))*(r + s - 1) + 16200*Dd**2*f**3*r**2 + 32400*Dd**2*f**3*r*s - 24300*Dd**2*f**3*r + 16200*Dd**2*f**3*s**2 - 24300*Dd**2*f**3*s + 8100*Dd**2*f**3 + 28512*Dd**2*f**2*g2*r**2 + 57024*Dd**2*f**2*g2*r*s - 42768*Dd**2*f**2*g2*r + 28512*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 14256*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*(19*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(19*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(1452*C*D1**2*f*fd*r**2 + 2904*C*D1**2*f*fd*r*s - 1452*C*D1**2*f*fd*r + 1452*C*D1**2*f*fd*s**2 - 1452*C*D1**2*f*fd*s + 726*C*D1**2*f*fd - 792*C*D1**2*f*fdd*r**2 - 1584*C*D1**2*f*fdd*r*s + 792*C*D1**2*f*fdd*r - 792*C*D1**2*f*fdd*s**2 + 792*C*D1**2*f*fdd*s - 396*C*D1**2*f*fdd - 792*C*D1**2*fd**2*r**2 - 1584*C*D1**2*fd**2*r*s + 792*C*D1**2*fd**2*r - 792*C*D1**2*fd**2*s**2 + 792*C*D1**2*fd**2*s + 2904*C*D1*Dd*f**2*r**2 + 5808*C*D1*Dd*f**2*r*s - 4356*C*D1*Dd*f**2*r + 2904*C*D1*Dd*f**2*s**2 - 4356*C*D1*Dd*f**2*s + 2178*C*D1*Dd*f**2 - 6336*C*D1*Dd*f*fd*r**2 - 12672*C*D1*Dd*f*fd*r*s + 7920*C*D1*Dd*f*fd*r - 6336*C*D1*Dd*f*fd*s**2 + 7920*C*D1*Dd*f*fd*s - 2376*C*D1*Dd*f*fd - 1584*C*D1*Ddd*f**2*r**2 - 3168*C*D1*Ddd*f**2*r*s + 2376*C*D1*Ddd*f**2*r - 1584*C*D1*Ddd*f**2*s**2 + 2376*C*D1*Ddd*f**2*s - 1188*C*D1*Ddd*f**2 - 4752*C*Dd**2*f**2*r**2 - 9504*C*Dd**2*f**2*r*s + 7128*C*Dd**2*f**2*r - 4752*C*Dd**2*f**2*s**2 + 7128*C*Dd**2*f**2*s - 2376*C*Dd**2*f**2 + 3366*D1**2*K*f*fd*r**2 + 6732*D1**2*K*f*fd*r*s - 3366*D1**2*K*f*fd*r + 3366*D1**2*K*f*fd*s**2 - 3366*D1**2*K*f*fd*s + 1683*D1**2*K*f*fd - 2376*D1**2*K*f*fdd*r**2 - 4752*D1**2*K*f*fdd*r*s + 2376*D1**2*K*f*fdd*r - 2376*D1**2*K*f*fdd*s**2 + 2376*D1**2*K*f*fdd*s - 1188*D1**2*K*f*fdd - 2376*D1**2*K*fd**2*r**2 - 4752*D1**2*K*fd**2*r*s + 2376*D1**2*K*fd**2*r - 2376*D1**2*K*fd**2*s**2 + 2376*D1**2*K*fd**2*s - 396*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 2067*D1**2*f**2*fd*r**2 - 4134*D1**2*f**2*fd*r*s + 2756*D1**2*f**2*fd*r - 2067*D1**2*f**2*fd*s**2 + 2756*D1**2*f**2*fd*s - 1378*D1**2*f**2*fd + 1875*D1**2*f**2*fdd*r**2 + 3750*D1**2*f**2*fdd*r*s - 2500*D1**2*f**2*fdd*r + 1875*D1**2*f**2*fdd*s**2 - 2500*D1**2*f**2*fdd*s + 1250*D1**2*f**2*fdd + 3750*D1**2*f*fd**2*r**2 + 7500*D1**2*f*fd**2*r*s - 5000*D1**2*f*fd**2*r + 3750*D1**2*f*fd**2*s**2 - 5000*D1**2*f*fd**2*s + 1250*D1**2*f*fd**2 - 3036*D1**2*f*fd*r**2 - 6072*D1**2*f*fd*r*s + 3036*D1**2*f*fd*r - 3036*D1**2*f*fd*s**2 + 3036*D1**2*f*fd*s - 1518*D1**2*f*fd + 1980*D1**2*f*fdd*r**2 + 3960*D1**2*f*fdd*r*s - 1980*D1**2*f*fdd*r + 1980*D1**2*f*fdd*s**2 - 1980*D1**2*f*fdd*s + 990*D1**2*f*fdd - 1254*D1**2*f*gd2*r**2 - 2508*D1**2*f*gd2*r*s + 2508*D1**2*f*gd2*r - 1254*D1**2*f*gd2*s**2 + 2508*D1**2*f*gd2*s - 1254*D1**2*f*gd2 + 396*D1**2*f*gdd2*r**2 + 792*D1**2*f*gdd2*r*s - 792*D1**2*f*gdd2*r + 396*D1**2*f*gdd2*s**2 - 792*D1**2*f*gdd2*s + 396*D1**2*f*gdd2 + 1980*D1**2*fd**2*r**2 + 3960*D1**2*fd**2*r*s - 1980*D1**2*fd**2*r + 1980*D1**2*fd**2*s**2 - 1980*D1**2*fd**2*s - 1254*D1**2*fd*g2*r**2 - 2508*D1**2*fd*g2*r*s - 1254*D1**2*fd*g2*s**2 + 792*D1**2*fd*gd2*r**2 + 1584*D1**2*fd*gd2*r*s - 792*D1**2*fd*gd2*r + 792*D1**2*fd*gd2*s**2 - 792*D1**2*fd*gd2*s + 396*D1**2*fdd*g2*r**2 + 792*D1**2*fdd*g2*r*s + 396*D1**2*fdd*g2*s**2 + 6732*D1*Dd*K*f**2*r**2 + 13464*D1*Dd*K*f**2*r*s - 10098*D1*Dd*K*f**2*r + 6732*D1*Dd*K*f**2*s**2 - 10098*D1*Dd*K*f**2*s + 5049*D1*Dd*K*f**2 - 19008*D1*Dd*K*f*fd*r**2 - 38016*D1*Dd*K*f*fd*r*s + 23760*D1*Dd*K*f*fd*r - 19008*D1*Dd*K*f*fd*s**2 + 23760*D1*Dd*K*f*fd*s - 7128*D1*Dd*K*f*fd - 2756*D1*Dd*f**3*r**2 - 5512*D1*Dd*f**3*r*s + 4134*D1*Dd*f**3*r - 2756*D1*Dd*f**3*s**2 + 4134*D1*Dd*f**3*s - 2067*D1*Dd*f**3 + 15000*D1*Dd*f**2*fd*r**2 + 30000*D1*Dd*f**2*fd*r*s - 21250*D1*Dd*f**2*fd*r + 15000*D1*Dd*f**2*fd*s**2 - 21250*D1*Dd*f**2*fd*s + 7500*D1*Dd*f**2*fd - 6072*D1*Dd*f**2*r**2 - 12144*D1*Dd*f**2*r*s + 9108*D1*Dd*f**2*r - 6072*D1*Dd*f**2*s**2 + 9108*D1*Dd*f**2*s - 4554*D1*Dd*f**2 + 15840*D1*Dd*f*fd*r**2 + 31680*D1*Dd*f*fd*r*s - 19800*D1*Dd*f*fd*r + 15840*D1*Dd*f*fd*s**2 - 19800*D1*Dd*f*fd*s + 5940*D1*Dd*f*fd - 5016*D1*Dd*f*g2*r**2 - 10032*D1*Dd*f*g2*r*s + 7524*D1*Dd*f*g2*r - 5016*D1*Dd*f*g2*s**2 + 7524*D1*Dd*f*g2*s - 3762*D1*Dd*f*g2 + 3168*D1*Dd*f*gd2*r**2 + 6336*D1*Dd*f*gd2*r*s - 5544*D1*Dd*f*gd2*r + 3168*D1*Dd*f*gd2*s**2 - 5544*D1*Dd*f*gd2*s + 2376*D1*Dd*f*gd2 + 3168*D1*Dd*fd*g2*r**2 + 6336*D1*Dd*fd*g2*r*s - 2376*D1*Dd*fd*g2*r + 3168*D1*Dd*fd*g2*s**2 - 2376*D1*Dd*fd*g2*s - 4752*D1*Ddd*K*f**2*r**2 - 9504*D1*Ddd*K*f**2*r*s + 7128*D1*Ddd*K*f**2*r - 4752*D1*Ddd*K*f**2*s**2 + 7128*D1*Ddd*K*f**2*s - 3564*D1*Ddd*K*f**2 + 2500*D1*Ddd*f**3*r**2 + 5000*D1*Ddd*f**3*r*s - 3750*D1*Ddd*f**3*r + 2500*D1*Ddd*f**3*s**2 - 3750*D1*Ddd*f**3*s + 1875*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*r**2 + 7920*D1*Ddd*f**2*r*s - 5940*D1*Ddd*f**2*r + 3960*D1*Ddd*f**2*s**2 - 5940*D1*Ddd*f**2*s + 2970*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r**2 + 3168*D1*Ddd*f*g2*r*s - 2376*D1*Ddd*f*g2*r + 1584*D1*Ddd*f*g2*s**2 - 2376*D1*Ddd*f*g2*s + 1188*D1*Ddd*f*g2 + 66*D1*bd1*(K - 1)*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 14256*Dd**2*K*f**2*r**2 - 28512*Dd**2*K*f**2*r*s + 21384*Dd**2*K*f**2*r - 14256*Dd**2*K*f**2*s**2 + 21384*Dd**2*K*f**2*s - 7128*Dd**2*K*f**2 + 7500*Dd**2*f**3*r**2 + 15000*Dd**2*f**3*r*s - 11250*Dd**2*f**3*r + 7500*Dd**2*f**3*s**2 - 11250*Dd**2*f**3*s + 3750*Dd**2*f**3 + 11880*Dd**2*f**2*r**2 + 23760*Dd**2*f**2*r*s - 17820*Dd**2*f**2*r + 11880*Dd**2*f**2*s**2 - 17820*Dd**2*f**2*s + 5940*Dd**2*f**2 + 4752*Dd**2*f*g2*r**2 + 9504*Dd**2*f*g2*r*s - 7128*Dd**2*f*g2*r + 4752*Dd**2*f*g2*s**2 - 7128*Dd**2*f*g2*s + 2376*Dd**2*f*g2))/(77*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**3*k1**3*k2**3*(-3960*C*D1**2*bdd1*f**2*r**2 - 7920*C*D1**2*bdd1*f**2*r*s + 7920*C*D1**2*bdd1*f**2*r - 3960*C*D1**2*bdd1*f**2*s**2 + 7920*C*D1**2*bdd1*f**2*s - 3960*C*D1**2*bdd1*f**2 + 780*C*D1**2*f**2*fd*r**2 + 1560*C*D1**2*f**2*fd*r*s - 1040*C*D1**2*f**2*fd*r + 780*C*D1**2*f**2*fd*s**2 - 1040*C*D1**2*f**2*fd*s + 520*C*D1**2*f**2*fd - 3360*C*D1**2*f**2*fdd*r**2 - 6720*C*D1**2*f**2*fdd*r*s + 4480*C*D1**2*f**2*fdd*r - 3360*C*D1**2*f**2*fdd*s**2 + 4480*C*D1**2*f**2*fdd*s - 2240*C*D1**2*f**2*fdd - 6720*C*D1**2*f*fd**2*r**2 - 13440*C*D1**2*f*fd**2*r*s + 8960*C*D1**2*f*fd**2*r - 6720*C*D1**2*f*fd**2*s**2 + 8960*C*D1**2*f*fd**2*s - 2240*C*D1**2*f*fd**2 + 1040*C*D1*Dd*f**3*r**2 + 2080*C*D1*Dd*f**3*r*s - 1560*C*D1*Dd*f**3*r + 1040*C*D1*Dd*f**3*s**2 - 1560*C*D1*Dd*f**3*s + 780*C*D1*Dd*f**3 - 26880*C*D1*Dd*f**2*fd*r**2 - 53760*C*D1*Dd*f**2*fd*r*s + 38080*C*D1*Dd*f**2*fd*r - 26880*C*D1*Dd*f**2*fd*s**2 + 38080*C*D1*Dd*f**2*fd*s - 13440*C*D1*Dd*f**2*fd - 4480*C*D1*Ddd*f**3*r**2 - 8960*C*D1*Ddd*f**3*r*s + 6720*C*D1*Ddd*f**3*r - 4480*C*D1*Ddd*f**3*s**2 + 6720*C*D1*Ddd*f**3*s - 3360*C*D1*Ddd*f**3 - 13440*C*Dd**2*f**3*r**2 - 26880*C*Dd**2*f**3*r*s + 20160*C*Dd**2*f**3*r - 13440*C*Dd**2*f**3*s**2 + 20160*C*Dd**2*f**3*s - 6720*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r**2 - 1320*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 660*D1**2*K*bdd1*f**2*s**2 + 1320*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 + 132*D1**2*bd1**2*f*(-36*K + 25*f + 18)*(r + s - 1)**2 + 2970*D1**2*bdd1*f**2*r**2 + 5940*D1**2*bdd1*f**2*r*s - 5940*D1**2*bdd1*f**2*r + 2970*D1**2*bdd1*f**2*s**2 - 5940*D1**2*bdd1*f**2*s + 2970*D1**2*bdd1*f**2 + 4752*D1**2*bdd1*f*g2*r**2 + 9504*D1**2*bdd1*f*g2*r*s - 9504*D1**2*bdd1*f*g2*r + 4752*D1**2*bdd1*f*g2*s**2 - 9504*D1**2*bdd1*f*g2*s + 4752*D1**2*bdd1*f*g2 + 105*D1**2*f**2*fd*r**2 + 210*D1**2*f**2*fd*r*s - 140*D1**2*f**2*fd*r + 105*D1**2*f**2*fd*s**2 - 140*D1**2*f**2*fd*s + 70*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*r**2 + 3360*D1**2*f**2*fdd*r*s - 2240*D1**2*f**2*fdd*r + 1680*D1**2*f**2*fdd*s**2 - 2240*D1**2*f**2*fdd*s + 1120*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s + 528*D1**2*f**2*gd2*r - 264*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s - 264*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 3360*D1**2*f*fd**2*r**2 + 6720*D1**2*f*fd**2*r*s - 4480*D1**2*f*fd**2*r + 3360*D1**2*f*fd**2*s**2 - 4480*D1**2*f*fd**2*s + 1120*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s + 140*D1*Dd*f**3*r**2 + 280*D1*Dd*f**3*r*s - 210*D1*Dd*f**3*r + 140*D1*Dd*f**3*s**2 - 210*D1*Dd*f**3*s + 105*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*r**2 + 26880*D1*Dd*f**2*fd*r*s - 19040*D1*Dd*f**2*fd*r + 13440*D1*Dd*f**2*fd*s**2 - 19040*D1*Dd*f**2*fd*s + 6720*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s + 1584*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 792*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 2240*D1*Ddd*f**3*r**2 + 4480*D1*Ddd*f**3*r*s - 3360*D1*Ddd*f**3*r + 2240*D1*Ddd*f**3*s**2 - 3360*D1*Ddd*f**3*s + 1680*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 + 132*D1*bd1*(D1*(f**2*(24*C + K - 15)*(r + s - 1) - 5*f*fd*(12*C + 2*K - 9)*(2*r + 2*s - 1) - 6*f*(5*g2 - 12*gd2)*(r + s - 1) + 72*fd*g2*(r + s)) - Dd*f*(5*f*(12*C + 2*K - 9) - 72*g2)*(4*r + 4*s - 3))*(r + s - 1) + 6720*Dd**2*f**3*r**2 + 13440*Dd**2*f**3*r*s - 10080*Dd**2*f**3*r + 6720*Dd**2*f**3*s**2 - 10080*Dd**2*f**3*s + 3360*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(2*f*(29*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(60*K - 23)*(r + s) - 36*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(58*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (60*K - 23)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 72*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(-36*K + 25*f + 18)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(-36*K + 25*f + 18)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 66*b1*(-96*C*D1**2*f*fd*r**2 - 192*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r - 96*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 48*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 192*C*D1*Dd*f**2*r**2 - 384*C*D1*Dd*f**2*r*s + 288*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 144*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 1200*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1200*C*D1*Dd*f*fd*s + 360*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 360*C*Dd**2*f**2 - 4*D1**2*K*f*fd*r**2 - 8*D1**2*K*f*fd*r*s + 4*D1**2*K*f*fd*r - 4*D1**2*K*f*fd*s**2 + 4*D1**2*K*f*fd*s - 2*D1**2*K*f*fd + 20*D1**2*K*f*fdd*r**2 + 40*D1**2*K*f*fdd*r*s - 20*D1**2*K*f*fdd*r + 20*D1**2*K*f*fdd*s**2 - 20*D1**2*K*f*fdd*s + 10*D1**2*K*f*fdd + 20*D1**2*K*fd**2*r**2 + 40*D1**2*K*fd**2*r*s - 20*D1**2*K*fd**2*r + 20*D1**2*K*fd**2*s**2 - 20*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-36*K + 25*f + 18)*(r + s - 1)**2 + 60*D1**2*f*fd*r**2 + 120*D1**2*f*fd*r*s - 60*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 60*D1**2*f*fd*s + 30*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 45*D1**2*f*fdd + 60*D1**2*f*gd2*r**2 + 120*D1**2*f*gd2*r*s - 120*D1**2*f*gd2*r + 60*D1**2*f*gd2*s**2 - 120*D1**2*f*gd2*s + 60*D1**2*f*gd2 - 72*D1**2*f*gdd2*r**2 - 144*D1**2*f*gdd2*r*s + 144*D1**2*f*gdd2*r - 72*D1**2*f*gdd2*s**2 + 144*D1**2*f*gdd2*s - 72*D1**2*f*gdd2 - 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 60*D1**2*fd*g2*r**2 + 120*D1**2*fd*g2*r*s + 60*D1**2*fd*g2*s**2 - 144*D1**2*fd*gd2*r**2 - 288*D1**2*fd*gd2*r*s + 144*D1**2*fd*gd2*r - 144*D1**2*fd*gd2*s**2 + 144*D1**2*fd*gd2*s - 72*D1**2*fdd*g2*r**2 - 144*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*s**2 - 8*D1*Dd*K*f**2*r**2 - 16*D1*Dd*K*f**2*r*s + 12*D1*Dd*K*f**2*r - 8*D1*Dd*K*f**2*s**2 + 12*D1*Dd*K*f**2*s - 6*D1*Dd*K*f**2 + 160*D1*Dd*K*f*fd*r**2 + 320*D1*Dd*K*f*fd*r*s - 200*D1*Dd*K*f*fd*r + 160*D1*Dd*K*f*fd*s**2 - 200*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd + 120*D1*Dd*f**2*r**2 + 240*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 180*D1*Dd*f**2*s + 90*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 900*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 270*D1*Dd*f*fd + 240*D1*Dd*f*g2*r**2 + 480*D1*Dd*f*g2*r*s - 360*D1*Dd*f*g2*r + 240*D1*Dd*f*g2*s**2 - 360*D1*Dd*f*g2*s + 180*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r**2 - 1152*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r - 576*D1*Dd*f*gd2*s**2 + 1008*D1*Dd*f*gd2*s - 432*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r**2 - 1152*D1*Dd*fd*g2*r*s + 432*D1*Dd*fd*g2*r - 576*D1*Dd*fd*g2*s**2 + 432*D1*Dd*fd*g2*s + 40*D1*Ddd*K*f**2*r**2 + 80*D1*Ddd*K*f**2*r*s - 60*D1*Ddd*K*f**2*r + 40*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 30*D1*Ddd*K*f**2 - 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r**2 - 576*D1*Ddd*f*g2*r*s + 432*D1*Ddd*f*g2*r - 288*D1*Ddd*f*g2*s**2 + 432*D1*Ddd*f*g2*s - 216*D1*Ddd*f*g2 + D1*bd1*(D1*(58*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(60*K - 23)*(r + s - 1) + 72*fd*(2*K - 1)*(r + s)) - 4*Dd*f*(-36*K + 25*f + 18)*(4*r + 4*s - 3))*(r + s - 1) + 120*Dd**2*K*f**2*r**2 + 240*Dd**2*K*f**2*r*s - 180*Dd**2*K*f**2*r + 120*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 60*Dd**2*K*f**2 - 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 270*Dd**2*f**2 - 864*Dd**2*f*g2*r**2 - 1728*Dd**2*f*g2*r*s + 1296*Dd**2*f*g2*r - 864*Dd**2*f*g2*s**2 + 1296*Dd**2*f*g2*s - 432*Dd**2*f*g2))/(77*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**3*k1**3*k2*st**2*(-990*C*D1**2*bdd1*f**2*r**2 - 3168*C*D1**2*bdd1*f**2*r*s + 1188*C*D1**2*bdd1*f**2*r - 2178*C*D1**2*bdd1*f**2*s**2 + 2376*C*D1**2*bdd1*f**2*s - 1188*C*D1**2*bdd1*f**2 - 11142*C*D1**2*f**2*fd*r**2 - 10440*C*D1**2*f**2*fd*r*s + 10908*C*D1**2*f**2*fd*r + 702*C*D1**2*f**2*fd*s**2 + 3012*C*D1**2*f**2*fd*s - 3480*C*D1**2*f**2*fd + 9234*C*D1**2*f**2*fdd*r**2 + 10368*C*D1**2*f**2*fdd*r*s - 9612*C*D1**2*f**2*fdd*r + 1134*C*D1**2*f**2*fdd*s**2 - 4212*C*D1**2*f**2*fdd*s + 3456*C*D1**2*f**2*fdd + 18468*C*D1**2*f*fd**2*r**2 + 20736*C*D1**2*f*fd**2*r*s - 19224*C*D1**2*f*fd**2*r + 2268*C*D1**2*f*fd**2*s**2 - 8424*C*D1**2*f*fd**2*s + 3456*C*D1**2*f*fd**2 - 14856*C*D1*Dd*f**3*r**2 - 13920*C*D1*Dd*f**3*r*s + 18336*C*D1*Dd*f**3*r + 936*C*D1*Dd*f**3*s**2 + 6492*C*D1*Dd*f**3*s - 7194*C*D1*Dd*f**3 + 73872*C*D1*Dd*f**2*fd*r**2 + 82944*C*D1*Dd*f**2*fd*r*s - 85752*C*D1*Dd*f**2*fd*r + 9072*C*D1*Dd*f**2*fd*s**2 - 39852*C*D1*Dd*f**2*fd*s + 23436*C*D1*Dd*f**2*fd + 12312*C*D1*Ddd*f**3*r**2 + 13824*C*D1*Ddd*f**3*r*s - 15768*C*D1*Ddd*f**3*r + 1512*C*D1*Ddd*f**3*s**2 - 7668*C*D1*Ddd*f**3*s + 6534*C*D1*Ddd*f**3 + 36936*C*Dd**2*f**3*r**2 + 41472*C*Dd**2*f**3*r*s - 47304*C*Dd**2*f**3*r + 4536*C*Dd**2*f**3*s**2 - 23004*C*Dd**2*f**3*s + 13068*C*Dd**2*f**3 + 1683*D1**2*K*bdd1*f**2*r**2 + 1584*D1**2*K*bdd1*f**2*r*s - 3366*D1**2*K*bdd1*f**2*r - 99*D1**2*K*bdd1*f**2*s**2 - 1584*D1**2*K*bdd1*f**2*s + 1683*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 8*r*(2*s - 1) + 11*s**2 - 14*s + 3) - 5625*D1**2*bdd1*f**3*r**2 - 10250*D1**2*bdd1*f**3*r*s + 9500*D1**2*bdd1*f**3*r - 4625*D1**2*bdd1*f**3*s**2 + 8500*D1**2*bdd1*f**3*s - 5750*D1**2*bdd1*f**3 - 3663*D1**2*bdd1*f**2*r**2 - 5544*D1**2*bdd1*f**2*r*s + 8118*D1**2*bdd1*f**2*r - 1881*D1**2*bdd1*f**2*s**2 + 6336*D1**2*bdd1*f**2*s - 3465*D1**2*bdd1*f**2 + 990*D1**2*bdd1*f*g2*r**2 + 3168*D1**2*bdd1*f*g2*r*s - 1188*D1**2*bdd1*f*g2*r + 2178*D1**2*bdd1*f*g2*s**2 - 2376*D1**2*bdd1*f*g2*s + 1188*D1**2*bdd1*f*g2 - 19500*D1**2*f**3*fd*r**2 - 51000*D1**2*f**3*fd*r*s + 32250*D1**2*f**3*fd*r - 31500*D1**2*f**3*fd*s**2 + 41250*D1**2*f**3*fd*s - 17625*D1**2*f**3*fd + 22500*D1**2*f**3*fdd*r**2 + 45000*D1**2*f**3*fdd*r*s - 33750*D1**2*f**3*fdd*r + 22500*D1**2*f**3*fdd*s**2 - 33750*D1**2*f**3*fdd*s + 16875*D1**2*f**3*fdd + 67500*D1**2*f**2*fd**2*r**2 + 135000*D1**2*f**2*fd**2*r*s - 101250*D1**2*f**2*fd**2*r + 67500*D1**2*f**2*fd**2*s**2 - 101250*D1**2*f**2*fd**2*s + 33750*D1**2*f**2*fd**2 + 20187*D1**2*f**2*fd*r**2 + 32742*D1**2*f**2*fd*r*s - 24372*D1**2*f**2*fd*r + 12555*D1**2*f**2*fd*s**2 - 19284*D1**2*f**2*fd*s + 10914*D1**2*f**2*fd - 15984*D1**2*f**2*fdd*r**2 - 26568*D1**2*f**2*fdd*r*s + 19512*D1**2*f**2*fdd*r - 10584*D1**2*f**2*fdd*s**2 + 15912*D1**2*f**2*fdd*s - 8856*D1**2*f**2*fdd + 4554*D1**2*f**2*gd2*r**2 + 3168*D1**2*f**2*gd2*r*s - 9108*D1**2*f**2*gd2*r - 1386*D1**2*f**2*gd2*s**2 - 3168*D1**2*f**2*gd2*s + 4554*D1**2*f**2*gd2 - 3366*D1**2*f**2*gdd2*r**2 - 3168*D1**2*f**2*gdd2*r*s + 6732*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 + 3168*D1**2*f**2*gdd2*s - 3366*D1**2*f**2*gdd2 - 31968*D1**2*f*fd**2*r**2 - 53136*D1**2*f*fd**2*r*s + 39024*D1**2*f*fd**2*r - 21168*D1**2*f*fd**2*s**2 + 31824*D1**2*f*fd**2*s - 8856*D1**2*f*fd**2 + 9108*D1**2*f*fd*g2*r**2 + 6336*D1**2*f*fd*g2*r*s - 3168*D1**2*f*fd*g2*r - 2772*D1**2*f*fd*g2*s**2 + 2772*D1**2*f*fd*g2*s - 1386*D1**2*f*fd*g2 - 13464*D1**2*f*fd*gd2*r**2 - 12672*D1**2*f*fd*gd2*r*s + 16632*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 + 5940*D1**2*f*fd*gd2*s - 3168*D1**2*f*fd*gd2 - 6732*D1**2*f*fdd*g2*r**2 - 6336*D1**2*f*fdd*g2*r*s + 3168*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 - 6732*D1**2*fd**2*g2*r**2 - 6336*D1**2*fd**2*g2*r*s + 3168*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s - 19500*D1*Dd*f**4*r**2 - 51000*D1*Dd*f**4*r*s + 32250*D1*Dd*f**4*r - 31500*D1*Dd*f**4*s**2 + 41250*D1*Dd*f**4*s - 17625*D1*Dd*f**4 + 180000*D1*Dd*f**3*fd*r**2 + 360000*D1*Dd*f**3*fd*r*s - 270000*D1*Dd*f**3*fd*r + 180000*D1*Dd*f**3*fd*s**2 - 270000*D1*Dd*f**3*fd*s + 101250*D1*Dd*f**3*fd + 26916*D1*Dd*f**3*r**2 + 43656*D1*Dd*f**3*r*s - 37830*D1*Dd*f**3*r + 16740*D1*Dd*f**3*s**2 - 30198*D1*Dd*f**3*s + 17643*D1*Dd*f**3 - 127872*D1*Dd*f**2*fd*r**2 - 212544*D1*Dd*f**2*fd*r*s + 168552*D1*Dd*f**2*fd*r - 84672*D1*Dd*f**2*fd*s**2 + 137952*D1*Dd*f**2*fd*s - 54936*D1*Dd*f**2*fd + 18216*D1*Dd*f**2*g2*r**2 + 12672*D1*Dd*f**2*g2*r*s - 21384*D1*Dd*f**2*g2*r - 5544*D1*Dd*f**2*g2*s**2 - 3564*D1*Dd*f**2*g2*s + 7722*D1*Dd*f**2*g2 - 26928*D1*Dd*f**2*gd2*r**2 - 25344*D1*Dd*f**2*gd2*r*s + 43560*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 + 18612*D1*Dd*f**2*gd2*s - 16632*D1*Dd*f**2*gd2 - 53856*D1*Dd*f*fd*g2*r**2 - 50688*D1*Dd*f*fd*g2*r*s + 45936*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 + 10296*D1*Dd*f*fd*g2*s - 5940*D1*Dd*f*fd*g2 + 22500*D1*Ddd*f**4*r**2 + 45000*D1*Ddd*f**4*r*s - 33750*D1*Ddd*f**4*r + 22500*D1*Ddd*f**4*s**2 - 33750*D1*Ddd*f**4*s + 16875*D1*Ddd*f**4 - 21312*D1*Ddd*f**3*r**2 - 35424*D1*Ddd*f**3*r*s + 30168*D1*Ddd*f**3*r - 14112*D1*Ddd*f**3*s**2 + 24768*D1*Ddd*f**3*s - 14184*D1*Ddd*f**3 - 13464*D1*Ddd*f**2*g2*r**2 - 12672*D1*Ddd*f**2*g2*r*s + 16632*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 + 5940*D1*Ddd*f**2*g2*s - 6534*D1*Ddd*f**2*g2 + D1*bd1*(D1*(f**3*(7455*r**2 + 2*r*(6851*s - 6497) + 6247*s**2 - 11786*s + 8299) + f**2*(66*C*(25*r**2 + r*(84*s - 34) + 59*s**2 - 68*s + 34) - 99*K*(23*r**2 + 2*r*(8*s - 23) - 7*s**2 - 16*s + 23) - 250*fd*(135*r**2 + 3*r*(82*s - 69) + 111*s**2 - 187*s + 64) + 5082*r**2 + 330*r*(21*s - 34) + 1848*s**2 - 7986*s + 4488) - 66*f*(3*fd*(C*(20*r**2 + 32*r*(2*s - 1) + 44*s**2 - 50*s + 6) + K*(-34*r**2 - 32*r*s + 42*r + 2*s**2 + 15*s - 8) + 74*r**2 + 112*r*s - 106*r + 38*s**2 - 79*s + 38) + 5*g2*(13*r**2 + 2*r*(18*s - 5) + 23*s**2 - 20*s + 10) - 6*gd2*(5*r**2 + 8*r*(2*s - 1) + 11*s**2 - 14*s + 3)) + 396*fd*g2*(5*r**2 + 8*r*(2*s - 1) + s*(11*s - 11))) - 2*Dd*f*(125*f**2*(180*r**2 + r*(328*s - 283) + 148*s**2 - 255*s + 110) + 99*f*(2*C*(20*r**2 + r*(64*s - 30) + 44*s**2 - 51*s + 12) + K*(-68*r**2 - 64*r*s + 110*r + 4*s**2 + 47*s - 42) + 148*r**2 + 224*r*s - 266*r + 76*s**2 - 203*s + 114) - 198*g2*(20*r**2 + r*(64*s - 30) + 44*s**2 - 51*s + 12))) + 67500*Dd**2*f**4*r**2 + 135000*Dd**2*f**4*r*s - 101250*Dd**2*f**4*r + 67500*Dd**2*f**4*s**2 - 101250*Dd**2*f**4*s + 33750*Dd**2*f**4 - 63936*Dd**2*f**3*r**2 - 106272*Dd**2*f**3*r*s + 90504*Dd**2*f**3*r - 42336*Dd**2*f**3*s**2 + 74304*Dd**2*f**3*s - 28368*Dd**2*f**3 - 40392*Dd**2*f**2*g2*r**2 - 38016*Dd**2*f**2*g2*r*s + 49896*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 + 17820*Dd**2*f**2*g2*s - 13068*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*(5*fd*(13*r**2 + r*(36*s - 26) + 23*s**2 - 26*s + 13) - 3*fdd*(5*r**2 + 2*r*(8*s - 5) + 11*s**2 - 10*s + 5)) + D1*(Dd*(5*f*(52*r**2 + 144*r*s - 88*r + 92*s**2 - 118*s + 49) - 6*fd*(20*r**2 + 64*r*s - 38*r + 44*s**2 - 47*s + 15)) - 3*Ddd*f*(20*r**2 + 4*r*(16*s - 9) + 44*s**2 - 54*s + 21)) - 18*Dd**2*f*(10*r**2 + 2*r*(16*s - 9) + 22*s**2 - 27*s + 7)) + b1*(3300*C*D1**2*f*fd*r**2 + 11088*C*D1**2*f*fd*r*s - 6600*C*D1**2*f*fd*r + 7788*C*D1**2*f*fd*s**2 - 8844*C*D1**2*f*fd*s + 3300*C*D1**2*f*fd - 1980*C*D1**2*f*fdd*r**2 - 6336*C*D1**2*f*fdd*r*s + 3960*C*D1**2*f*fdd*r - 4356*C*D1**2*f*fdd*s**2 + 5148*C*D1**2*f*fdd*s - 1980*C*D1**2*f*fdd - 1980*C*D1**2*fd**2*r**2 - 6336*C*D1**2*fd**2*r*s + 3960*C*D1**2*fd**2*r - 4356*C*D1**2*fd**2*s**2 + 5148*C*D1**2*fd**2*s - 1980*C*D1**2*fd**2 + 6600*C*D1*Dd*f**2*r**2 + 22176*C*D1*Dd*f**2*r*s - 12144*C*D1*Dd*f**2*r + 15576*C*D1*Dd*f**2*s**2 - 18876*C*D1*Dd*f**2*s + 7194*C*D1*Dd*f**2 - 15840*C*D1*Dd*f*fd*r**2 - 50688*C*D1*Dd*f*fd*r*s + 30096*C*D1*Dd*f*fd*r - 34848*C*D1*Dd*f*fd*s**2 + 41976*C*D1*Dd*f*fd*s - 13068*C*D1*Dd*f*fd - 3960*C*D1*Ddd*f**2*r**2 - 12672*C*D1*Ddd*f**2*r*s + 7128*C*D1*Ddd*f**2*r - 8712*C*D1*Ddd*f**2*s**2 + 10692*C*D1*Ddd*f**2*s - 4158*C*D1*Ddd*f**2 - 11880*C*Dd**2*f**2*r**2 - 38016*C*Dd**2*f**2*r*s + 21384*C*Dd**2*f**2*r - 26136*C*Dd**2*f**2*s**2 + 32076*C*Dd**2*f**2*s - 8316*C*Dd**2*f**2 - 4554*D1**2*K*f*fd*r**2 - 3168*D1**2*K*f*fd*r*s + 1584*D1**2*K*f*fd*r + 1386*D1**2*K*f*fd*s**2 - 1386*D1**2*K*f*fd*s + 693*D1**2*K*f*fd + 3366*D1**2*K*f*fdd*r**2 + 3168*D1**2*K*f*fdd*r*s - 1584*D1**2*K*f*fdd*r - 198*D1**2*K*f*fdd*s**2 + 198*D1**2*K*f*fdd*s - 99*D1**2*K*f*fdd + 3366*D1**2*K*fd**2*r**2 + 3168*D1**2*K*fd**2*r*s - 1584*D1**2*K*fd**2*r - 198*D1**2*K*fd**2*s**2 + 198*D1**2*K*fd**2*s - 99*D1**2*bdd1*f*(K - 1)*(10*r**2 + 32*r*s - 16*r + 22*s**2 - 28*s + 11) + 22365*D1**2*f**2*fd*r**2 + 41106*D1**2*f**2*fd*r*s - 30528*D1**2*f**2*fd*r + 18741*D1**2*f**2*fd*s**2 - 28112*D1**2*f**2*fd*s + 12858*D1**2*f**2*fd - 16875*D1**2*f**2*fdd*r**2 - 30750*D1**2*f**2*fdd*r*s + 23250*D1**2*f**2*fdd*r - 13875*D1**2*f**2*fdd*s**2 + 21250*D1**2*f**2*fdd*s - 10125*D1**2*f**2*fdd - 33750*D1**2*f*fd**2*r**2 - 61500*D1**2*f*fd**2*r*s + 46500*D1**2*f*fd**2*r - 27750*D1**2*f*fd**2*s**2 + 42500*D1**2*f*fd**2*s - 15750*D1**2*f*fd**2 + 10164*D1**2*f*fd*r**2 + 13860*D1**2*f*fd*r*s - 5874*D1**2*f*fd*r + 3696*D1**2*f*fd*s**2 - 2640*D1**2*f*fd*s + 2442*D1**2*f*fd - 7326*D1**2*f*fdd*r**2 - 11088*D1**2*f*fdd*r*s + 4752*D1**2*f*fdd*r - 3762*D1**2*f*fdd*s**2 + 2970*D1**2*f*fdd*s - 2079*D1**2*f*fdd - 4290*D1**2*f*gd2*r**2 - 11880*D1**2*f*gd2*r*s + 8580*D1**2*f*gd2*r - 7590*D1**2*f*gd2*s**2 + 11880*D1**2*f*gd2*s - 4290*D1**2*f*gd2 + 990*D1**2*f*gdd2*r**2 + 3168*D1**2*f*gdd2*r*s - 1980*D1**2*f*gdd2*r + 2178*D1**2*f*gdd2*s**2 - 3168*D1**2*f*gdd2*s + 990*D1**2*f*gdd2 - 7326*D1**2*fd**2*r**2 - 11088*D1**2*fd**2*r*s + 4752*D1**2*fd**2*r - 3762*D1**2*fd**2*s**2 + 2970*D1**2*fd**2*s + 1980*D1**2*fd**2 - 4290*D1**2*fd*g2*r**2 - 11880*D1**2*fd*g2*r*s + 8580*D1**2*fd*g2*r - 7590*D1**2*fd*g2*s**2 + 8580*D1**2*fd*g2*s - 4290*D1**2*fd*g2 + 1980*D1**2*fd*gd2*r**2 + 6336*D1**2*fd*gd2*r*s - 3960*D1**2*fd*gd2*r + 4356*D1**2*fd*gd2*s**2 - 5148*D1**2*fd*gd2*s + 1980*D1**2*fd*gd2 + 990*D1**2*fdd*g2*r**2 + 3168*D1**2*fdd*g2*r*s - 1980*D1**2*fdd*g2*r + 2178*D1**2*fdd*g2*s**2 - 1980*D1**2*fdd*g2*s + 990*D1**2*fdd*g2 - 9108*D1*Dd*K*f**2*r**2 - 6336*D1*Dd*K*f**2*r*s + 10692*D1*Dd*K*f**2*r + 2772*D1*Dd*K*f**2*s**2 + 1782*D1*Dd*K*f**2*s - 3861*D1*Dd*K*f**2 + 26928*D1*Dd*K*f*fd*r**2 + 25344*D1*Dd*K*f*fd*r*s - 22968*D1*Dd*K*f*fd*r - 1584*D1*Dd*K*f*fd*s**2 - 5148*D1*Dd*K*f*fd*s + 2970*D1*Dd*K*f*fd + 29820*D1*Dd*f**3*r**2 + 54808*D1*Dd*f**3*r*s - 43522*D1*Dd*f**3*r + 24988*D1*Dd*f**3*s**2 - 39898*D1*Dd*f**3*s + 21157*D1*Dd*f**3 - 135000*D1*Dd*f**2*fd*r**2 - 246000*D1*Dd*f**2*fd*r*s + 191250*D1*Dd*f**2*fd*r - 111000*D1*Dd*f**2*fd*s**2 + 174250*D1*Dd*f**2*fd*s - 67750*D1*Dd*f**2*fd + 20328*D1*Dd*f**2*r**2 + 27720*D1*Dd*f**2*r*s - 27258*D1*Dd*f**2*r + 7392*D1*Dd*f**2*s**2 - 17556*D1*Dd*f**2*s + 12012*D1*Dd*f**2 - 58608*D1*Dd*f*fd*r**2 - 88704*D1*Dd*f*fd*r*s + 59400*D1*Dd*f*fd*r - 30096*D1*Dd*f*fd*s**2 + 41580*D1*Dd*f*fd*s - 12474*D1*Dd*f*fd - 17160*D1*Dd*f*g2*r**2 - 47520*D1*Dd*f*g2*r*s + 29040*D1*Dd*f*g2*r - 30360*D1*Dd*f*g2*s**2 + 38940*D1*Dd*f*g2*s - 16170*D1*Dd*f*g2 + 7920*D1*Dd*f*gd2*r**2 + 25344*D1*Dd*f*gd2*r*s - 15048*D1*Dd*f*gd2*r + 17424*D1*Dd*f*gd2*s**2 - 23364*D1*Dd*f*gd2*s + 7128*D1*Dd*f*gd2 + 7920*D1*Dd*fd*g2*r**2 + 25344*D1*Dd*fd*g2*r*s - 15048*D1*Dd*fd*g2*r + 17424*D1*Dd*fd*g2*s**2 - 18612*D1*Dd*fd*g2*s + 5940*D1*Dd*fd*g2 + 6732*D1*Ddd*K*f**2*r**2 + 6336*D1*Ddd*K*f**2*r*s - 8316*D1*Ddd*K*f**2*r - 396*D1*Ddd*K*f**2*s**2 - 2970*D1*Ddd*K*f**2*s + 3267*D1*Ddd*K*f**2 - 22500*D1*Ddd*f**3*r**2 - 41000*D1*Ddd*f**3*r*s + 32750*D1*Ddd*f**3*r - 18500*D1*Ddd*f**3*s**2 + 29750*D1*Ddd*f**3*s - 15875*D1*Ddd*f**3 - 14652*D1*Ddd*f**2*r**2 - 22176*D1*Ddd*f**2*r*s + 20196*D1*Ddd*f**2*r - 7524*D1*Ddd*f**2*s**2 + 14850*D1*Ddd*f**2*s - 9207*D1*Ddd*f**2 + 3960*D1*Ddd*f*g2*r**2 + 12672*D1*Ddd*f*g2*r*s - 7128*D1*Ddd*f*g2*r + 8712*D1*Ddd*f*g2*s**2 - 10692*D1*Ddd*f*g2*s + 4158*D1*Ddd*f*g2 + 33*D1*bd1*(K - 1)*(D1*(5*f*(26*r**2 + 72*r*s - 36*r + 46*s**2 - 56*s + 23) - 6*fd*(10*r**2 + 32*r*s - 18*r + 22*s**2 - 24*s + 5)) - 12*Dd*f*(20*r**2 + r*(64*s - 34) + 44*s**2 - 55*s + 15)) + 20196*Dd**2*K*f**2*r**2 + 19008*Dd**2*K*f**2*r*s - 24948*Dd**2*K*f**2*r - 1188*Dd**2*K*f**2*s**2 - 8910*Dd**2*K*f**2*s + 6534*Dd**2*K*f**2 - 67500*Dd**2*f**3*r**2 - 123000*Dd**2*f**3*r*s + 98250*Dd**2*f**3*r - 55500*Dd**2*f**3*s**2 + 89250*Dd**2*f**3*s - 31750*Dd**2*f**3 - 43956*Dd**2*f**2*r**2 - 66528*Dd**2*f**2*r*s + 60588*Dd**2*f**2*r - 22572*Dd**2*f**2*s**2 + 44550*Dd**2*f**2*s - 18414*Dd**2*f**2 + 11880*Dd**2*f*g2*r**2 + 38016*Dd**2*f*g2*r*s - 21384*Dd**2*f*g2*r + 26136*Dd**2*f*g2*s**2 - 32076*Dd**2*f*g2*s + 8316*Dd**2*f*g2))/(693*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**3*k1**3*k2*(5412*C*D1**2*bdd1*f**2*r**2 + 10032*C*D1**2*bdd1*f**2*r*s - 16632*C*D1**2*bdd1*f**2*r + 4620*C*D1**2*bdd1*f**2*s**2 - 15840*C*D1**2*bdd1*f**2*s + 7920*C*D1**2*bdd1*f**2 - 20940*C*D1**2*f**2*fd*r**2 - 80640*C*D1**2*f**2*fd*r*s + 40840*C*D1**2*f**2*fd*r - 59700*C*D1**2*f**2*fd*s**2 + 66680*C*D1**2*f**2*fd*s - 26880*C*D1**2*f**2*fd + 31260*C*D1**2*f**2*fdd*r**2 + 91800*C*D1**2*f**2*fdd*r*s - 51440*C*D1**2*f**2*fdd*r + 60540*C*D1**2*f**2*fdd*s**2 - 70960*C*D1**2*f**2*fdd*s + 30600*C*D1**2*f**2*fdd + 62520*C*D1**2*f*fd**2*r**2 + 183600*C*D1**2*f*fd**2*r*s - 102880*C*D1**2*f*fd**2*r + 121080*C*D1**2*f*fd**2*s**2 - 141920*C*D1**2*f*fd**2*s + 30600*C*D1**2*f*fd**2 - 27920*C*D1*Dd*f**3*r**2 - 107520*C*D1*Dd*f**3*r*s + 54800*C*D1*Dd*f**3*r - 79600*C*D1*Dd*f**3*s**2 + 93560*C*D1*Dd*f**3*s - 33860*C*D1*Dd*f**3 + 250080*C*D1*Dd*f**2*fd*r**2 + 734400*C*D1*Dd*f**2*fd*r*s - 422600*C*D1*Dd*f**2*fd*r + 484320*C*D1*Dd*f**2*fd*s**2 - 588520*C*D1*Dd*f**2*fd*s + 173840*C*D1*Dd*f**2*fd + 41680*C*D1*Ddd*f**3*r**2 + 122400*C*D1*Ddd*f**3*r*s - 72280*C*D1*Ddd*f**3*r + 80720*C*D1*Ddd*f**3*s**2 - 101560*C*D1*Ddd*f**3*s + 41020*C*D1*Ddd*f**3 + 125040*C*Dd**2*f**3*r**2 + 367200*C*Dd**2*f**3*r*s - 216840*C*Dd**2*f**3*r + 242160*C*Dd**2*f**3*s**2 - 304680*C*Dd**2*f**3*s + 82040*C*Dd**2*f**3 + 5940*D1**2*K*bdd1*f**2*r**2 + 17952*D1**2*K*bdd1*f**2*r*s - 11880*D1**2*K*bdd1*f**2*r + 12012*D1**2*K*bdd1*f**2*s**2 - 17952*D1**2*K*bdd1*f**2*s + 5940*D1**2*K*bdd1*f**2 - 5280*D1**2*b2*f*fd*r**2 - 10560*D1**2*b2*f*fd*r*s + 5280*D1**2*b2*f*fd*r - 5280*D1**2*b2*f*fd*s**2 + 5280*D1**2*b2*f*fd*s - 2640*D1**2*b2*f*fd + 6600*D1**2*b2*f*fdd*r**2 + 13200*D1**2*b2*f*fdd*r*s - 6600*D1**2*b2*f*fdd*r + 6600*D1**2*b2*f*fdd*s**2 - 6600*D1**2*b2*f*fdd*s + 3300*D1**2*b2*f*fdd + 6600*D1**2*b2*fd**2*r**2 + 13200*D1**2*b2*fd**2*r*s - 6600*D1**2*b2*fd**2*r + 6600*D1**2*b2*fd**2*s**2 - 6600*D1**2*b2*fd**2*s - 132*D1**2*bd1**2*(r + s - 1)*(75*f**2*(r + s - 1) + f*(60*C*r + 60*C*s + K*(-41*r - 41*s + 71) + 86*r + 86*s - 161) - 70*g2*(r + s)) - 2640*D1**2*bd2*f**2*r**2 - 5280*D1**2*bd2*f**2*r*s + 5280*D1**2*bd2*f**2*r - 2640*D1**2*bd2*f**2*s**2 + 5280*D1**2*bd2*f**2*s - 2640*D1**2*bd2*f**2 + 13200*D1**2*bd2*f*fd*r**2 + 26400*D1**2*bd2*f*fd*r*s - 19800*D1**2*bd2*f*fd*r + 13200*D1**2*bd2*f*fd*s**2 - 19800*D1**2*bd2*f*fd*s + 6600*D1**2*bd2*f*fd + 2640*D1**2*bdd1*f**3*r**2 - 2640*D1**2*bdd1*f**3*r - 2640*D1**2*bdd1*f**3*s**2 + 2640*D1**2*bdd1*f**3*s - 12507*D1**2*bdd1*f**2*r**2 - 27258*D1**2*bdd1*f**2*r*s + 29172*D1**2*bdd1*f**2*r - 14751*D1**2*bdd1*f**2*s**2 + 31416*D1**2*bdd1*f**2*s - 14190*D1**2*bdd1*f**2 - 5412*D1**2*bdd1*f*g2*r**2 - 10824*D1**2*bdd1*f*g2*r*s + 18744*D1**2*bdd1*f*g2*r - 5412*D1**2*bdd1*f*g2*s**2 + 18744*D1**2*bdd1*f*g2*s - 9372*D1**2*bdd1*f*g2 + 3300*D1**2*bdd2*f**2*r**2 + 6600*D1**2*bdd2*f**2*r*s - 6600*D1**2*bdd2*f**2*r + 3300*D1**2*bdd2*f**2*s**2 - 6600*D1**2*bdd2*f**2*s + 3300*D1**2*bdd2*f**2 + 8790*D1**2*f**2*fd*r**2 + 47640*D1**2*f**2*fd*r*s - 21740*D1**2*f**2*fd*r + 38850*D1**2*f**2*fd*s**2 - 41780*D1**2*f**2*fd*s + 15880*D1**2*f**2*fd - 19245*D1**2*f**2*fdd*r**2 - 60450*D1**2*f**2*fdd*r*s + 32980*D1**2*f**2*fdd*r - 41205*D1**2*f**2*fdd*s**2 + 47620*D1**2*f**2*fdd*s - 20150*D1**2*f**2*fdd + 7128*D1**2*f**2*gd2*r**2 + 30624*D1**2*f**2*gd2*r*s - 14256*D1**2*f**2*gd2*r + 23496*D1**2*f**2*gd2*s**2 - 30624*D1**2*f**2*gd2*s + 7128*D1**2*f**2*gd2 - 11880*D1**2*f**2*gdd2*r**2 - 35904*D1**2*f**2*gdd2*r*s + 23760*D1**2*f**2*gdd2*r - 24024*D1**2*f**2*gdd2*s**2 + 35904*D1**2*f**2*gdd2*s - 11880*D1**2*f**2*gdd2 - 38490*D1**2*f*fd**2*r**2 - 120900*D1**2*f*fd**2*r*s + 65960*D1**2*f*fd**2*r - 82410*D1**2*f*fd**2*s**2 + 95240*D1**2*f*fd**2*s - 20150*D1**2*f*fd**2 + 14256*D1**2*f*fd*g2*r**2 + 61248*D1**2*f*fd*g2*r*s - 30624*D1**2*f*fd*g2*r + 46992*D1**2*f*fd*g2*s**2 - 46992*D1**2*f*fd*g2*s + 23496*D1**2*f*fd*g2 - 47520*D1**2*f*fd*gd2*r**2 - 143616*D1**2*f*fd*gd2*r*s + 83424*D1**2*f*fd*gd2*r - 96096*D1**2*f*fd*gd2*s**2 + 119856*D1**2*f*fd*gd2*s - 35904*D1**2*f*fd*gd2 - 23760*D1**2*f*fdd*g2*r**2 - 71808*D1**2*f*fdd*g2*r*s + 35904*D1**2*f*fdd*g2*r - 48048*D1**2*f*fdd*g2*s**2 + 48048*D1**2*f*fdd*g2*s - 24024*D1**2*f*fdd*g2 - 23760*D1**2*fd**2*g2*r**2 - 71808*D1**2*fd**2*g2*r*s + 35904*D1**2*fd**2*g2*r - 48048*D1**2*fd**2*g2*s**2 + 48048*D1**2*fd**2*g2*s - 10560*D1*Dd*b2*f**2*r**2 - 21120*D1*Dd*b2*f**2*r*s + 15840*D1*Dd*b2*f**2*r - 10560*D1*Dd*b2*f**2*s**2 + 15840*D1*Dd*b2*f**2*s - 7920*D1*Dd*b2*f**2 + 52800*D1*Dd*b2*f*fd*r**2 + 105600*D1*Dd*b2*f*fd*r*s - 66000*D1*Dd*b2*f*fd*r + 52800*D1*Dd*b2*f*fd*s**2 - 66000*D1*Dd*b2*f*fd*s + 19800*D1*Dd*b2*f*fd + 26400*D1*Dd*bd2*f**2*r**2 + 52800*D1*Dd*bd2*f**2*r*s - 46200*D1*Dd*bd2*f**2*r + 26400*D1*Dd*bd2*f**2*s**2 - 46200*D1*Dd*bd2*f**2*s + 19800*D1*Dd*bd2*f**2 + 11720*D1*Dd*f**3*r**2 + 63520*D1*Dd*f**3*r*s - 27600*D1*Dd*f**3*r + 51800*D1*Dd*f**3*s**2 - 57660*D1*Dd*f**3*s + 18810*D1*Dd*f**3 - 153960*D1*Dd*f**2*fd*r**2 - 483600*D1*Dd*f**2*fd*r*s + 269350*D1*Dd*f**2*fd*r - 329640*D1*Dd*f**2*fd*s**2 + 393790*D1*Dd*f**2*fd*s - 113580*D1*Dd*f**2*fd + 28512*D1*Dd*f**2*g2*r**2 + 122496*D1*Dd*f**2*g2*r*s - 59136*D1*Dd*f**2*g2*r + 93984*D1*Dd*f**2*g2*s**2 - 108240*D1*Dd*f**2*g2*s + 37752*D1*Dd*f**2*g2 - 95040*D1*Dd*f**2*gd2*r**2 - 287232*D1*Dd*f**2*gd2*r*s + 178464*D1*Dd*f**2*gd2*r - 192192*D1*Dd*f**2*gd2*s**2 + 263472*D1*Dd*f**2*gd2*s - 83424*D1*Dd*f**2*gd2 - 190080*D1*Dd*f*fd*g2*r**2 - 574464*D1*Dd*f*fd*g2*r*s + 310464*D1*Dd*f*fd*g2*r - 384384*D1*Dd*f*fd*g2*s**2 + 431904*D1*Dd*f*fd*g2*s - 119856*D1*Dd*f*fd*g2 + 13200*D1*Ddd*b2*f**2*r**2 + 26400*D1*Ddd*b2*f**2*r*s - 19800*D1*Ddd*b2*f**2*r + 13200*D1*Ddd*b2*f**2*s**2 - 19800*D1*Ddd*b2*f**2*s + 9900*D1*Ddd*b2*f**2 - 25660*D1*Ddd*f**3*r**2 - 80600*D1*Ddd*f**3*r*s + 45810*D1*Ddd*f**3*r - 54940*D1*Ddd*f**3*s**2 + 67770*D1*Ddd*f**3*s - 26565*D1*Ddd*f**3 - 47520*D1*Ddd*f**2*g2*r**2 - 143616*D1*Ddd*f**2*g2*r*s + 83424*D1*Ddd*f**2*g2*r - 96096*D1*Ddd*f**2*g2*s**2 + 119856*D1*Ddd*f**2*g2*s - 47784*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(26*r**2 + r*(20*s - 38) - 6*s**2 - 6*s + 17) + 2*f**2*(4*C*(23*r**2 + r*(46*s - 66) + 23*s**2 - 66*s + 33) + 54*K*r**2 + 232*K*r*s - 108*K*r + 178*K*s**2 - 232*K*s + 54*K - 40*fd*(6*r**2 - 6*r - 6*s**2 + 4*s + 1) - 163*r**2 - 394*r*s + 386*r - 231*s**2 + 454*s - 193) - 4*f*(fd*(2*C*(82*r**2 + 2*r*(76*s - 71) + 70*s**2 - 133*s + 63) + 2*K*(90*r**2 + 272*r*s - 158*r + 182*s**2 - 227*s + 68) - 379*r**2 - 826*r*s + 617*r - 447*s**2 + 668*s - 244) + g2*(40*r**2 + 2*r*(47*s - 72) + 54*s**2 - 158*s + 79) - 2*gd2*(41*r**2 + 2*r*(41*s - 56) + 41*s**2 - 112*s + 71)) + 328*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(40*f**2*(8*r**2 - 8*r - 8*s**2 + 6*s + 1) + f*(4*C*(164*r**2 + 4*r*(76*s - 93) + 140*s**2 - 351*s + 186) + 4*K*(180*r**2 + 544*r*s - 338*r + 364*s**2 - 499*s + 158) - 1516*r**2 - 3304*r*s + 2939*r - 1788*s**2 + 3177*s - 1360) - 4*g2*(164*r**2 + r*(328*s - 407) + 164*s**2 - 407*s + 213))) + 39600*Dd**2*b2*f**2*r**2 + 79200*Dd**2*b2*f**2*r*s - 59400*Dd**2*b2*f**2*r + 39600*Dd**2*b2*f**2*s**2 - 59400*Dd**2*b2*f**2*s + 19800*Dd**2*b2*f**2 - 76980*Dd**2*f**3*r**2 - 241800*Dd**2*f**3*r*s + 137430*Dd**2*f**3*r - 164820*Dd**2*f**3*s**2 + 203310*Dd**2*f**3*s - 53130*Dd**2*f**3 - 142560*Dd**2*f**2*g2*r**2 - 430848*Dd**2*f**2*g2*r*s + 250272*Dd**2*f**2*g2*r - 288288*Dd**2*f**2*g2*s**2 + 359568*Dd**2*f**2*g2*s - 95568*Dd**2*f**2*g2 + 2310*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(100*C*D1**2*fd*r**2 + 200*C*D1**2*fd*r*s - 200*C*D1**2*fd*r + 100*C*D1**2*fd*s**2 - 200*C*D1**2*fd*s + 100*C*D1**2*fd - 120*C*D1**2*fdd*r**2 - 240*C*D1**2*fdd*r*s + 240*C*D1**2*fdd*r - 120*C*D1**2*fdd*s**2 + 240*C*D1**2*fdd*s - 120*C*D1**2*fdd + 400*C*D1*Dd*f*r**2 + 800*C*D1*Dd*f*r*s - 600*C*D1*Dd*f*r + 400*C*D1*Dd*f*s**2 - 600*C*D1*Dd*f*s + 300*C*D1*Dd*f - 960*C*D1*Dd*fd*r**2 - 1920*C*D1*Dd*fd*r*s + 1680*C*D1*Dd*fd*r - 960*C*D1*Dd*fd*s**2 + 1680*C*D1*Dd*fd*s - 720*C*D1*Dd*fd - 480*C*D1*Ddd*f*r**2 - 960*C*D1*Ddd*f*r*s + 720*C*D1*Ddd*f*r - 480*C*D1*Ddd*f*s**2 + 720*C*D1*Ddd*f*s - 360*C*D1*Ddd*f - 1440*C*Dd**2*f*r**2 - 2880*C*Dd**2*f*r*s + 2160*C*Dd**2*f*r - 1440*C*Dd**2*f*s**2 + 2160*C*Dd**2*f*s - 720*C*Dd**2*f - 80*D1**2*K*fd*r**2 - 188*D1**2*K*fd*r*s - 100*D1**2*K*fd*r - 108*D1**2*K*fd*s**2 - 100*D1**2*K*fd*s + 50*D1**2*K*fd + 82*D1**2*K*fdd*r**2 + 164*D1**2*K*fdd*r*s + 120*D1**2*K*fdd*r + 82*D1**2*K*fdd*s**2 + 120*D1**2*K*fdd*s - 60*D1**2*K*fdd - 70*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 360*D1**2*f*fd*r**2 + 720*D1**2*f*fd*r*s - 420*D1**2*f*fd*r + 360*D1**2*f*fd*s**2 - 420*D1**2*f*fd*s + 210*D1**2*f*fd - 300*D1**2*f*fdd*r**2 - 600*D1**2*f*fdd*r*s + 300*D1**2*f*fdd*r - 300*D1**2*f*fdd*s**2 + 300*D1**2*f*fdd*s - 150*D1**2*f*fdd - 300*D1**2*fd**2*r**2 - 600*D1**2*fd**2*r*s + 300*D1**2*fd**2*r - 300*D1**2*fd**2*s**2 + 300*D1**2*fd**2*s + 190*D1**2*fd*r**2 + 408*D1**2*fd*r*s + 250*D1**2*fd*r + 218*D1**2*fd*s**2 + 250*D1**2*fd*s - 125*D1**2*fd - 172*D1**2*fdd*r**2 - 344*D1**2*fdd*r*s - 300*D1**2*fdd*r - 172*D1**2*fdd*s**2 - 300*D1**2*fdd*s + 150*D1**2*fdd - 280*D1**2*gd2*r**2 - 560*D1**2*gd2*r*s + 560*D1**2*gd2*r - 280*D1**2*gd2*s**2 + 560*D1**2*gd2*s - 280*D1**2*gd2 + 140*D1**2*gdd2*r**2 + 280*D1**2*gdd2*r*s - 280*D1**2*gdd2*r + 140*D1**2*gdd2*s**2 - 280*D1**2*gdd2*s + 140*D1**2*gdd2 - 320*D1*Dd*K*f*r**2 - 752*D1*Dd*K*f*r*s + 508*D1*Dd*K*f*r - 432*D1*Dd*K*f*s**2 + 592*D1*Dd*K*f*s - 268*D1*Dd*K*f + 656*D1*Dd*K*fd*r**2 + 1312*D1*Dd*K*fd*r*s - 12*D1*Dd*K*fd*r + 656*D1*Dd*K*fd*s**2 - 12*D1*Dd*K*fd*s - 360*D1*Dd*K*fd + 720*D1*Dd*f**2*r**2 + 1440*D1*Dd*f**2*r*s - 1080*D1*Dd*f**2*r + 720*D1*Dd*f**2*s**2 - 1080*D1*Dd*f**2*s + 540*D1*Dd*f**2 - 2400*D1*Dd*f*fd*r**2 - 4800*D1*Dd*f*fd*r*s + 3000*D1*Dd*f*fd*r - 2400*D1*Dd*f*fd*s**2 + 3000*D1*Dd*f*fd*s - 900*D1*Dd*f*fd + 760*D1*Dd*f*r**2 + 1632*D1*Dd*f*r*s - 1168*D1*Dd*f*r + 872*D1*Dd*f*s**2 - 1252*D1*Dd*f*s + 598*D1*Dd*f - 1376*D1*Dd*fd*r**2 - 2752*D1*Dd*fd*r*s - 168*D1*Dd*fd*r - 1376*D1*Dd*fd*s**2 - 168*D1*Dd*fd*s + 900*D1*Dd*fd - 1120*D1*Dd*g2*r**2 - 2240*D1*Dd*g2*r*s + 1680*D1*Dd*g2*r - 1120*D1*Dd*g2*s**2 + 1680*D1*Dd*g2*s - 840*D1*Dd*g2 + 1120*D1*Dd*gd2*r**2 + 2240*D1*Dd*gd2*r*s - 1960*D1*Dd*gd2*r + 1120*D1*Dd*gd2*s**2 - 1960*D1*Dd*gd2*s + 840*D1*Dd*gd2 + 328*D1*Ddd*K*f*r**2 + 656*D1*Ddd*K*f*r*s - 492*D1*Ddd*K*f*r + 328*D1*Ddd*K*f*s**2 - 492*D1*Ddd*K*f*s + 246*D1*Ddd*K*f - 600*D1*Ddd*f**2*r**2 - 1200*D1*Ddd*f**2*r*s + 900*D1*Ddd*f**2*r - 600*D1*Ddd*f**2*s**2 + 900*D1*Ddd*f**2*s - 450*D1*Ddd*f**2 - 688*D1*Ddd*f*r**2 - 1376*D1*Ddd*f*r*s + 1032*D1*Ddd*f*r - 688*D1*Ddd*f*s**2 + 1032*D1*Ddd*f*s - 516*D1*Ddd*f + 560*D1*Ddd*g2*r**2 + 1120*D1*Ddd*g2*r*s - 840*D1*Ddd*g2*r + 560*D1*Ddd*g2*s**2 - 840*D1*Ddd*g2*s + 420*D1*Ddd*g2 + 140*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 984*Dd**2*K*f*r**2 + 1968*Dd**2*K*f*r*s - 1476*Dd**2*K*f*r + 984*Dd**2*K*f*s**2 - 1476*Dd**2*K*f*s + 492*Dd**2*K*f - 1800*Dd**2*f**2*r**2 - 3600*Dd**2*f**2*r*s + 2700*Dd**2*f**2*r - 1800*Dd**2*f**2*s**2 + 2700*Dd**2*f**2*s - 900*Dd**2*f**2 - 2064*Dd**2*f*r**2 - 4128*Dd**2*f*r*s + 3096*Dd**2*f*r - 2064*Dd**2*f*s**2 + 3096*Dd**2*f*s - 1032*Dd**2*f + 1680*Dd**2*g2*r**2 + 3360*Dd**2*g2*r*s - 2520*Dd**2*g2*r + 1680*Dd**2*g2*s**2 - 2520*Dd**2*g2*s + 840*Dd**2*g2) - 33*b1*(368*C*D1**2*f*fd*r**2 + 736*C*D1**2*f*fd*r*s - 208*C*D1**2*f*fd*r + 368*C*D1**2*f*fd*s**2 - 208*C*D1**2*f*fd*s + 104*C*D1**2*f*fd - 328*C*D1**2*f*fdd*r**2 - 608*C*D1**2*f*fdd*r*s + 128*C*D1**2*f*fdd*r - 280*C*D1**2*f*fdd*s**2 + 104*C*D1**2*f*fdd*s - 64*C*D1**2*f*fdd - 328*C*D1**2*fd**2*r**2 - 608*C*D1**2*fd**2*r*s + 128*C*D1**2*fd**2*r - 280*C*D1**2*fd**2*s**2 + 104*C*D1**2*fd**2*s + 200*C*D1**2*fd**2 + 736*C*D1*Dd*f**2*r**2 + 1472*C*D1*Dd*f**2*r*s - 1104*C*D1*Dd*f**2*r + 736*C*D1*Dd*f**2*s**2 - 1104*C*D1*Dd*f**2*s + 552*C*D1*Dd*f**2 - 2624*C*D1*Dd*f*fd*r**2 - 4864*C*D1*Dd*f*fd*r*s + 2432*C*D1*Dd*f*fd*r - 2240*C*D1*Dd*f*fd*s**2 + 2192*C*D1*Dd*f*fd*s - 360*C*D1*Dd*f*fd - 656*C*D1*Ddd*f**2*r**2 - 1216*C*D1*Ddd*f**2*r*s + 960*C*D1*Ddd*f**2*r - 560*C*D1*Ddd*f**2*s**2 + 888*C*D1*Ddd*f**2*s - 468*C*D1*Ddd*f**2 - 1968*C*Dd**2*f**2*r**2 - 3648*C*Dd**2*f**2*r*s + 2880*C*Dd**2*f**2*r - 1680*C*Dd**2*f**2*s**2 + 2664*C*Dd**2*f**2*s - 936*C*Dd**2*f**2 + 216*D1**2*K*f*fd*r**2 + 928*D1**2*K*f*fd*r*s - 464*D1**2*K*f*fd*r + 712*D1**2*K*f*fd*s**2 - 712*D1**2*K*f*fd*s + 356*D1**2*K*f*fd - 360*D1**2*K*f*fdd*r**2 - 1088*D1**2*K*f*fdd*r*s + 544*D1**2*K*f*fdd*r - 728*D1**2*K*f*fdd*s**2 + 728*D1**2*K*f*fdd*s - 364*D1**2*K*f*fdd - 360*D1**2*K*fd**2*r**2 - 1088*D1**2*K*fd**2*r*s + 544*D1**2*K*fd**2*r - 728*D1**2*K*fd**2*s**2 + 728*D1**2*K*fd**2*s + 140*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(150*f**2*(r + s - 1)**2 + f*(60*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*K*(41*r**2 + 82*r*s - 112*r + 41*s**2 - 112*s + 56) + 172*r**2 + 344*r*s - 494*r + 172*s**2 - 494*s + 247) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 390*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 430*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 - 110*D1**2*f**2*fd*s + 145*D1**2*f**2*fd - 240*D1**2*f**2*fdd*r**2 + 240*D1**2*f**2*fdd*r + 240*D1**2*f**2*fdd*s**2 - 80*D1**2*f**2*fdd*s - 80*D1**2*f**2*fdd - 480*D1**2*f*fd**2*r**2 + 480*D1**2*f*fd**2*r + 480*D1**2*f*fd**2*s**2 - 160*D1**2*f*fd**2*s - 80*D1**2*f*fd**2 - 652*D1**2*f*fd*r**2 - 1576*D1**2*f*fd*r*s + 668*D1**2*f*fd*r - 924*D1**2*f*fd*s**2 + 804*D1**2*f*fd*s - 402*D1**2*f*fd + 758*D1**2*f*fdd*r**2 + 1652*D1**2*f*fdd*r*s - 700*D1**2*f*fdd*r + 894*D1**2*f*fdd*s**2 - 768*D1**2*f*fdd*s + 396*D1**2*f*fdd - 160*D1**2*f*gd2*r**2 - 376*D1**2*f*gd2*r*s + 320*D1**2*f*gd2*r - 216*D1**2*f*gd2*s**2 + 376*D1**2*f*gd2*s - 160*D1**2*f*gd2 + 164*D1**2*f*gdd2*r**2 + 328*D1**2*f*gdd2*r*s - 328*D1**2*f*gdd2*r + 164*D1**2*f*gdd2*s**2 - 328*D1**2*f*gdd2*s + 164*D1**2*f*gdd2 + 758*D1**2*fd**2*r**2 + 1652*D1**2*fd**2*r*s - 700*D1**2*fd**2*r + 894*D1**2*fd**2*s**2 - 768*D1**2*fd**2*s - 150*D1**2*fd**2 - 160*D1**2*fd*g2*r**2 - 376*D1**2*fd*g2*r*s - 200*D1**2*fd*g2*r - 216*D1**2*fd*g2*s**2 - 200*D1**2*fd*g2*s + 100*D1**2*fd*g2 + 328*D1**2*fd*gd2*r**2 + 656*D1**2*fd*gd2*r*s - 88*D1**2*fd*gd2*r + 328*D1**2*fd*gd2*s**2 - 88*D1**2*fd*gd2*s - 240*D1**2*fd*gd2 + 164*D1**2*fdd*g2*r**2 + 328*D1**2*fdd*g2*r*s + 240*D1**2*fdd*g2*r + 164*D1**2*fdd*g2*s**2 + 240*D1**2*fdd*g2*s - 120*D1**2*fdd*g2 + 432*D1*Dd*K*f**2*r**2 + 1856*D1*Dd*K*f**2*r*s - 896*D1*Dd*K*f**2*r + 1424*D1*Dd*K*f**2*s**2 - 1640*D1*Dd*K*f**2*s + 572*D1*Dd*K*f**2 - 2880*D1*Dd*K*f*fd*r**2 - 8704*D1*Dd*K*f*fd*r*s + 4704*D1*Dd*K*f*fd*r - 5824*D1*Dd*K*f*fd*s**2 + 6544*D1*Dd*K*f*fd*s - 1816*D1*Dd*K*f*fd + 520*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 620*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 - 140*D1*Dd*f**3*s + 230*D1*Dd*f**3 - 1920*D1*Dd*f**2*fd*r**2 + 1920*D1*Dd*f**2*fd*r + 1920*D1*Dd*f**2*fd*s**2 - 800*D1*Dd*f**2*fd*s - 400*D1*Dd*f**2*fd - 1304*D1*Dd*f**2*r**2 - 3152*D1*Dd*f**2*r*s + 2092*D1*Dd*f**2*r - 1848*D1*Dd*f**2*s**2 + 2500*D1*Dd*f**2*s - 1114*D1*Dd*f**2 + 6064*D1*Dd*f*fd*r**2 + 13216*D1*Dd*f*fd*r*s - 7484*D1*Dd*f*fd*r + 7152*D1*Dd*f*fd*s**2 - 8164*D1*Dd*f*fd*s + 2168*D1*Dd*f*fd - 640*D1*Dd*f*g2*r**2 - 1504*D1*Dd*f*g2*r*s + 1016*D1*Dd*f*g2*r - 864*D1*Dd*f*g2*s**2 + 1184*D1*Dd*f*g2*s - 536*D1*Dd*f*g2 + 1312*D1*Dd*f*gd2*r**2 + 2624*D1*Dd*f*gd2*r*s - 2296*D1*Dd*f*gd2*r + 1312*D1*Dd*f*gd2*s**2 - 2296*D1*Dd*f*gd2*s + 984*D1*Dd*f*gd2 + 1312*D1*Dd*fd*g2*r**2 + 2624*D1*Dd*fd*g2*r*s - 24*D1*Dd*fd*g2*r + 1312*D1*Dd*fd*g2*s**2 - 24*D1*Dd*fd*g2*s - 720*D1*Dd*fd*g2 - 720*D1*Ddd*K*f**2*r**2 - 2176*D1*Ddd*K*f**2*r*s + 1264*D1*Ddd*K*f**2*r - 1456*D1*Ddd*K*f**2*s**2 + 1816*D1*Ddd*K*f**2*s - 724*D1*Ddd*K*f**2 - 320*D1*Ddd*f**3*r**2 + 320*D1*Ddd*f**3*r + 320*D1*Ddd*f**3*s**2 - 160*D1*Ddd*f**3*s - 80*D1*Ddd*f**3 + 1516*D1*Ddd*f**2*r**2 + 3304*D1*Ddd*f**2*r*s - 2342*D1*Ddd*f**2*r + 1788*D1*Ddd*f**2*s**2 - 2546*D1*Ddd*f**2*s + 1205*D1*Ddd*f**2 + 656*D1*Ddd*f*g2*r**2 + 1312*D1*Ddd*f*g2*r*s - 984*D1*Ddd*f*g2*r + 656*D1*Ddd*f*g2*s**2 - 984*D1*Ddd*f*g2*s + 492*D1*Ddd*f*g2 + D1*bd1*(D1*(-30*f**2*(12*r**2 + r*(24*s - 22) + 12*s**2 - 22*s + 11) + f*(-100*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 160*K*r**2 + 376*K*r*s - 448*K*r + 216*K*s**2 - 504*K*s + 238*K + 600*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 380*r**2 - 816*r*s + 1038*r - 436*s**2 + 1094*s - 533) + 4*fd*(r + s - 1)*(60*C*(2*r + 2*s - 1) - 2*K*(41*r + 41*s + 15) + 172*r + 172*s + 75) + 280*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 280*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(4*r + 4*s - 3)*(150*f**2*(r + s - 1) + f*(60*C*(2*r + 2*s - 1) - 2*K*(41*r + 41*s - 56) + 172*r + 172*s - 247) - 70*g2*(2*r + 2*s - 1))) - 2160*Dd**2*K*f**2*r**2 - 6528*Dd**2*K*f**2*r*s + 3792*Dd**2*K*f**2*r - 4368*Dd**2*K*f**2*s**2 + 5448*Dd**2*K*f**2*s - 1448*Dd**2*K*f**2 - 960*Dd**2*f**3*r**2 + 960*Dd**2*f**3*r + 960*Dd**2*f**3*s**2 - 480*Dd**2*f**3*s - 160*Dd**2*f**3 + 4548*Dd**2*f**2*r**2 + 9912*Dd**2*f**2*r*s - 7026*Dd**2*f**2*r + 5364*Dd**2*f**2*s**2 - 7638*Dd**2*f**2*s + 2410*Dd**2*f**2 + 1968*Dd**2*f*g2*r**2 + 3936*Dd**2*f*g2*r*s - 2952*Dd**2*f*g2*r + 1968*Dd**2*f*g2*s**2 - 2952*Dd**2*f*g2*s + 984*Dd**2*f*g2))/(693*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**3*k1**3*st**2*(-99*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + 2*D1*bd1*(D1*(f**3*s*(953*r + 953*s - 552) - 5*f**2*(25*fd*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3) - 33*s*(r*(C + 2) + s*(C + 2) - 3)) - 33*f*(3*fd*(r*(C + 2)*(4*s - 1) + s**2*(4*C + 8) - s*(3*C + 9) + 3) + s*(13*g2*(r + s) + gd2*(-6*r - 6*s + 3))) + 99*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(125*f**2*(5*r*(8*s - 1) + 40*s**2 - 32*s + 3) + 99*f*(r*(C + 2)*(8*s - 1) + s**2*(8*C + 16) - s*(4*C + 20) + 3) - 99*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 33*b1**2*(K - 1)*(D1**2*(13*fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*Dd*(13*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(2*f**2*(fd*(953*r*(3*s - 1) + 2859*s**2 - 3260*s + 953) - 125*fdd*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5)) + f*(-250*fd**2*(10*r*(3*s - 1) + 30*s**2 - 34*s + 7) + 330*fd*(C*(2*s - 1)*(r + s - 1) + r*(4*s - 2) + 4*s**2 - 3*s + 2) - 198*fdd*(C*(2*s - 1)*(r + s - 1) + 4*r*s - 2*r + 4*s**2 - 3*s + 2) - 33*s*(3*bdd1*(K - 1)*(2*r + 2*s - 1) + (26*gd2 - 6*gdd2)*(r + s - 1))) - 198*fd**2*(C*(2*s - 1)*(r + s - 1) + r*(4*s - 2) + 4*s**2 - 3*s - 1) - 66*fd*(13*g2*(s - 1) + gd2*(3 - 6*s))*(r + s - 1) + 198*fdd*g2*(s - 1)*(r + s - 1)) - 33*D1*bd1*(K - 1)*(D1*(-13*f*s*(2*r + 2*s - 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 3*Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 2*D1*(Dd*(953*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + 5*f**2*(33*C*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 33*f*(3*fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 4*r*(8*s - 3) + 32*s**2 - 28*s + 7) + 13*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 3*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 99*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(625*f**2 + f*(99*C + 198) - 99*g2)) - 2*Dd**2*f*(625*f**2 + f*(99*C + 198) - 99*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 2*f*(D1**2*(125*bdd1*f**2*s*(5*r + 5*s - 3) - 99*bdd1*g2*s*(r + s) - 9*f*(-11*bdd1*s*(r*(C + 2) + s*(C + 2) - 3) + 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + 225*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 9*D1*f*(Dd*(39*f*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 25*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 225*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k2*k3**3) + D1**2*Pk2*Pkd3*ct**3*k1**3*(2904*C*D1**2*bdd1*f**2*r*s + 2904*C*D1**2*bdd1*f**2*s**2 - 2760*C*D1**2*f**2*fd*r*s + 920*C*D1**2*f**2*fd*r - 2760*C*D1**2*f**2*fd*s**2 + 2760*C*D1**2*f**2*fd*s - 920*C*D1**2*f**2*fd + 3360*C*D1**2*f**2*fdd*r*s - 1120*C*D1**2*f**2*fdd*r + 3360*C*D1**2*f**2*fdd*s**2 - 3360*C*D1**2*f**2*fdd*s + 1120*C*D1**2*f**2*fdd + 6720*C*D1**2*f*fd**2*r*s - 2240*C*D1**2*f*fd**2*r + 6720*C*D1**2*f*fd**2*s**2 - 6720*C*D1**2*f*fd**2*s + 1120*C*D1**2*f*fd**2 - 3680*C*D1*Dd*f**3*r*s + 920*C*D1*Dd*f**3*r - 3680*C*D1*Dd*f**3*s**2 + 3680*C*D1*Dd*f**3*s - 920*C*D1*Dd*f**3 + 26880*C*D1*Dd*f**2*fd*r*s - 7840*C*D1*Dd*f**2*fd*r + 26880*C*D1*Dd*f**2*fd*s**2 - 26880*C*D1*Dd*f**2*fd*s + 5600*C*D1*Dd*f**2*fd + 4480*C*D1*Ddd*f**3*r*s - 1120*C*D1*Ddd*f**3*r + 4480*C*D1*Ddd*f**3*s**2 - 4480*C*D1*Ddd*f**3*s + 1120*C*D1*Ddd*f**3 + 13440*C*Dd**2*f**3*r*s - 3360*C*Dd**2*f**3*r + 13440*C*Dd**2*f**3*s**2 - 13440*C*Dd**2*f**3*s + 2240*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r*s + 660*D1**2*K*bdd1*f**2*s**2 - 660*D1**2*K*bdd1*f**2*s - 1056*D1**2*b2*f*fd*r*s + 528*D1**2*b2*f*fd*r - 1056*D1**2*b2*f*fd*s**2 + 1056*D1**2*b2*f*fd*s - 528*D1**2*b2*f*fd + 1320*D1**2*b2*f*fdd*r*s - 660*D1**2*b2*f*fdd*r + 1320*D1**2*b2*f*fdd*s**2 - 1320*D1**2*b2*f*fdd*s + 660*D1**2*b2*f*fdd + 1320*D1**2*b2*fd**2*r*s - 660*D1**2*b2*fd**2*r + 1320*D1**2*b2*fd**2*s**2 - 1320*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*(5*f**2*(r**2 + r*(18*s - 11) + 17*s**2 - 25*s + 6) + 2*f*(3*r**2 + r*(12*C*(2*s - 1) - 26*K*s + 44*s - 9) + s**2*(24*C - 26*K + 41) + s*(-24*C + 13*K - 46) + 18) + 28*g2*(-2*r*s + r - s*(2*s - 2))) - 528*D1**2*bd2*f**2*r*s - 528*D1**2*bd2*f**2*s**2 + 528*D1**2*bd2*f**2*s + 2640*D1**2*bd2*f*fd*r*s - 660*D1**2*bd2*f*fd*r + 2640*D1**2*bd2*f*fd*s**2 - 2640*D1**2*bd2*f*fd*s + 660*D1**2*bd2*f*fd + 2310*D1**2*bdd1*f**3*r**2 + 8580*D1**2*bdd1*f**3*r*s - 2310*D1**2*bdd1*f**3*r + 6270*D1**2*bdd1*f**3*s**2 - 4950*D1**2*bdd1*f**3*s + 1155*D1**2*bdd1*f**3 + 1155*D1**2*bdd1*f**2*r**2 + 462*D1**2*bdd1*f**2*r*s - 660*D1**2*bdd1*f**2*r - 693*D1**2*bdd1*f**2*s**2 - 1716*D1**2*bdd1*f**2*s - 660*D1**2*bdd1*f**2 - 3432*D1**2*bdd1*f*g2*r*s - 3432*D1**2*bdd1*f*g2*s**2 + 660*D1**2*bdd2*f**2*r*s + 660*D1**2*bdd2*f**2*s**2 - 660*D1**2*bdd2*f**2*s - 2775*D1**2*f**2*fd*r**2 - 14850*D1**2*f**2*fd*r*s + 6800*D1**2*f**2*fd*r - 12075*D1**2*f**2*fd*s**2 + 13000*D1**2*f**2*fd*s - 4950*D1**2*f**2*fd + 3615*D1**2*f**2*fdd*r**2 + 12870*D1**2*f**2*fdd*r*s - 6700*D1**2*f**2*fdd*r + 9255*D1**2*f**2*fdd*s**2 - 10460*D1**2*f**2*fdd*s + 4290*D1**2*f**2*fdd + 1056*D1**2*f**2*gd2*r*s + 1056*D1**2*f**2*gd2*s**2 - 1056*D1**2*f**2*gd2*s - 1320*D1**2*f**2*gdd2*r*s - 1320*D1**2*f**2*gdd2*s**2 + 1320*D1**2*f**2*gdd2*s + 7230*D1**2*f*fd**2*r**2 + 25740*D1**2*f*fd**2*r*s - 13400*D1**2*f*fd**2*r + 18510*D1**2*f*fd**2*s**2 - 20920*D1**2*f*fd**2*s + 4290*D1**2*f*fd**2 + 2112*D1**2*f*fd*g2*r*s - 1056*D1**2*f*fd*g2*r + 2112*D1**2*f*fd*g2*s**2 - 2112*D1**2*f*fd*g2*s + 1056*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r*s + 1320*D1**2*f*fd*gd2*r - 5280*D1**2*f*fd*gd2*s**2 + 5280*D1**2*f*fd*gd2*s - 1320*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r*s + 1320*D1**2*f*fdd*g2*r - 2640*D1**2*f*fdd*g2*s**2 + 2640*D1**2*f*fdd*g2*s - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r*s + 1320*D1**2*fd**2*g2*r - 2640*D1**2*fd**2*g2*s**2 + 2640*D1**2*fd**2*g2*s - 2112*D1*Dd*b2*f**2*r*s + 528*D1*Dd*b2*f**2*r - 2112*D1*Dd*b2*f**2*s**2 + 2112*D1*Dd*b2*f**2*s - 528*D1*Dd*b2*f**2 + 10560*D1*Dd*b2*f*fd*r*s - 3960*D1*Dd*b2*f*fd*r + 10560*D1*Dd*b2*f*fd*s**2 - 10560*D1*Dd*b2*f*fd*s + 2640*D1*Dd*b2*f*fd + 5280*D1*Dd*bd2*f**2*r*s - 660*D1*Dd*bd2*f**2*r + 5280*D1*Dd*bd2*f**2*s**2 - 5280*D1*Dd*bd2*f**2*s + 660*D1*Dd*bd2*f**2 - 3700*D1*Dd*f**3*r**2 - 19800*D1*Dd*f**3*r*s + 8650*D1*Dd*f**3*r - 16100*D1*Dd*f**3*s**2 + 17950*D1*Dd*f**3*s - 5875*D1*Dd*f**3 + 28920*D1*Dd*f**2*fd*r**2 + 102960*D1*Dd*f**2*fd*r*s - 54130*D1*Dd*f**2*fd*r + 74040*D1*Dd*f**2*fd*s**2 - 86090*D1*Dd*f**2*fd*s + 23860*D1*Dd*f**2*fd + 4224*D1*Dd*f**2*g2*r*s - 1056*D1*Dd*f**2*g2*r + 4224*D1*Dd*f**2*g2*s**2 - 4224*D1*Dd*f**2*g2*s + 1056*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r*s + 1320*D1*Dd*f**2*gd2*r - 10560*D1*Dd*f**2*gd2*s**2 + 10560*D1*Dd*f**2*gd2*s - 1320*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r*s + 7920*D1*Dd*f*fd*g2*r - 21120*D1*Dd*f*fd*g2*s**2 + 21120*D1*Dd*f*fd*g2*s - 5280*D1*Dd*f*fd*g2 + 2640*D1*Ddd*b2*f**2*r*s - 660*D1*Ddd*b2*f**2*r + 2640*D1*Ddd*b2*f**2*s**2 - 2640*D1*Ddd*b2*f**2*s + 660*D1*Ddd*b2*f**2 + 4820*D1*Ddd*f**3*r**2 + 17160*D1*Ddd*f**3*r*s - 9110*D1*Ddd*f**3*r + 12340*D1*Ddd*f**3*s**2 - 14750*D1*Ddd*f**3*s + 5495*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r*s + 1320*D1*Ddd*f**2*g2*r - 5280*D1*Ddd*f**2*g2*s**2 + 5280*D1*Ddd*f**2*g2*s - 1320*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(10*r**2 + 10*r*(6*s - 1) + 50*s**2 - 34*s + 5) - 2*f**2*(-40*C*s**2 - 8*K*s**2 + 8*K*s + 10*fd*(21*r**2 + r*(78*s - 34) + 57*s**2 - 60*s + 11) - 11*r**2 - 2*r*(s*(20*C + 4*K + 7) + 5) - 3*s**2 + 22*s + 23) - 4*f*(fd*(88*C*s**2 - 66*C*s + 5*K*(r*(4*s - 1) + (1 - 2*s)**2) + 35*r**2 + 2*r*(44*C*s - 11*C + 7*s - 13) - 21*s**2 - 6*s + 28) + 24*g2*s*(r + s) - 26*gd2*s*(2*r + 2*s - 1)) + 104*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*Dd*f*(5*f**2*(56*r**2 + r*(208*s - 82) + 152*s**2 - 150*s + 29) + f*(352*C*s**2 - 176*C*s + 10*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 140*r**2 + r*(44*C*(8*s - 1) + 56*s - 117) - 84*s**2 - 97*s + 46) - 52*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 7920*Dd**2*b2*f**2*r*s - 1980*Dd**2*b2*f**2*r + 7920*Dd**2*b2*f**2*s**2 - 7920*Dd**2*b2*f**2*s + 1320*Dd**2*b2*f**2 + 14460*Dd**2*f**3*r**2 + 51480*Dd**2*f**3*r*s - 27330*Dd**2*f**3*r + 37020*Dd**2*f**3*s**2 - 44250*Dd**2*f**3*s + 10990*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r*s + 3960*Dd**2*f**2*g2*r - 15840*Dd**2*f**2*g2*s**2 + 15840*Dd**2*f**2*g2*s - 2640*Dd**2*f**2*g2 + 924*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 33*b1**2*(40*C*D1**2*fd*r*s + 40*C*D1**2*fd*s**2 - 40*C*D1**2*fd*s - 48*C*D1**2*fdd*r*s - 48*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s + 160*C*D1*Dd*f*r*s - 40*C*D1*Dd*f*r + 160*C*D1*Dd*f*s**2 - 160*C*D1*Dd*f*s + 40*C*D1*Dd*f - 384*C*D1*Dd*fd*r*s + 48*C*D1*Dd*fd*r - 384*C*D1*Dd*fd*s**2 + 384*C*D1*Dd*fd*s - 48*C*D1*Dd*fd - 192*C*D1*Ddd*f*r*s + 48*C*D1*Ddd*f*r - 192*C*D1*Ddd*f*s**2 + 192*C*D1*Ddd*f*s - 48*C*D1*Ddd*f - 576*C*Dd**2*f*r*s + 144*C*Dd**2*f*r - 576*C*Dd**2*f*s**2 + 576*C*Dd**2*f*s - 96*C*Dd**2*f - 48*D1**2*K*fd*r*s + 48*D1**2*K*fd*r - 48*D1**2*K*fd*s**2 + 96*D1**2*K*fd*s - 48*D1**2*K*fd + 52*D1**2*K*fdd*r*s - 52*D1**2*K*fdd*r + 52*D1**2*K*fdd*s**2 - 104*D1**2*K*fdd*s + 52*D1**2*K*fdd - 28*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 8*D1**2*f*fd*r**2 + 240*D1**2*f*fd*r*s + 232*D1**2*f*fd*s**2 - 152*D1**2*f*fd*s - 8*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s - 170*D1**2*f*fdd*s**2 + 100*D1**2*f*fdd*s + 10*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s - 170*D1**2*fd**2*s**2 + 100*D1**2*fd**2*s + 10*D1**2*fd**2 + 5*D1**2*fd*r**2 + 106*D1**2*fd*r*s - 58*D1**2*fd*r + 101*D1**2*fd*s**2 - 66*D1**2*fd*s + 53*D1**2*fd - 6*D1**2*fdd*r**2 - 88*D1**2*fdd*r*s + 64*D1**2*fdd*r - 82*D1**2*fdd*s**2 + 68*D1**2*fdd*s - 58*D1**2*fdd - 112*D1**2*gd2*r*s - 112*D1**2*gd2*s**2 + 112*D1**2*gd2*s + 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s - 192*D1*Dd*K*f*r*s + 48*D1*Dd*K*f*r - 192*D1*Dd*K*f*s**2 + 192*D1*Dd*K*f*s - 48*D1*Dd*K*f + 416*D1*Dd*K*fd*r*s - 260*D1*Dd*K*fd*r + 416*D1*Dd*K*fd*s**2 - 624*D1*Dd*K*fd*s + 208*D1*Dd*K*fd + 16*D1*Dd*f**2*r**2 + 480*D1*Dd*f**2*r*s - 136*D1*Dd*f**2*r + 464*D1*Dd*f**2*s**2 - 472*D1*Dd*f**2*s + 124*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 220*D1*Dd*f*fd*r - 1360*D1*Dd*f*fd*s**2 + 1100*D1*Dd*f*fd*s - 100*D1*Dd*f*fd + 20*D1*Dd*f*r**2 + 424*D1*Dd*f*r*s - 126*D1*Dd*f*r + 404*D1*Dd*f*s**2 - 414*D1*Dd*f*s + 111*D1*Dd*f - 48*D1*Dd*fd*r**2 - 704*D1*Dd*fd*r*s + 368*D1*Dd*fd*r - 656*D1*Dd*fd*s**2 + 612*D1*Dd*fd*s - 196*D1*Dd*fd - 448*D1*Dd*g2*r*s + 112*D1*Dd*g2*r - 448*D1*Dd*g2*s**2 + 448*D1*Dd*g2*s - 112*D1*Dd*g2 + 448*D1*Dd*gd2*r*s - 56*D1*Dd*gd2*r + 448*D1*Dd*gd2*s**2 - 448*D1*Dd*gd2*s + 56*D1*Dd*gd2 + 208*D1*Ddd*K*f*r*s - 52*D1*Ddd*K*f*r + 208*D1*Ddd*K*f*s**2 - 208*D1*Ddd*K*f*s + 52*D1*Ddd*K*f - 20*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 110*D1*Ddd*f**2*r - 340*D1*Ddd*f**2*s**2 + 350*D1*Ddd*f**2*s - 95*D1*Ddd*f**2 - 24*D1*Ddd*f*r**2 - 352*D1*Ddd*f*r*s + 112*D1*Ddd*f*r - 328*D1*Ddd*f*s**2 + 340*D1*Ddd*f*s - 94*D1*Ddd*f + 224*D1*Ddd*g2*r*s - 56*D1*Ddd*g2*r + 224*D1*Ddd*g2*s**2 - 224*D1*Ddd*g2*s + 56*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 624*Dd**2*K*f*r*s - 156*Dd**2*K*f*r + 624*Dd**2*K*f*s**2 - 624*Dd**2*K*f*s + 104*Dd**2*K*f - 60*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 330*Dd**2*f**2*r - 1020*Dd**2*f**2*s**2 + 1050*Dd**2*f**2*s - 190*Dd**2*f**2 - 72*Dd**2*f*r**2 - 1056*Dd**2*f*r*s + 336*Dd**2*f*r - 984*Dd**2*f*s**2 + 1020*Dd**2*f*s - 188*Dd**2*f + 672*Dd**2*g2*r*s - 168*Dd**2*g2*r + 672*Dd**2*g2*s**2 - 672*Dd**2*g2*s + 112*Dd**2*g2) - 33*b1*(160*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*r + 160*C*D1**2*f*fd*s**2 - 240*C*D1**2*f*fd*s + 80*C*D1**2*f*fd - 176*C*D1**2*f*fdd*r*s + 88*C*D1**2*f*fdd*r - 176*C*D1**2*f*fdd*s**2 + 264*C*D1**2*f*fdd*s - 88*C*D1**2*f*fdd - 176*C*D1**2*fd**2*r*s + 88*C*D1**2*fd**2*r - 176*C*D1**2*fd**2*s**2 + 264*C*D1**2*fd**2*s - 88*C*D1**2*fd**2 + 320*C*D1*Dd*f**2*r*s - 80*C*D1*Dd*f**2*r + 320*C*D1*Dd*f**2*s**2 - 320*C*D1*Dd*f**2*s + 80*C*D1*Dd*f**2 - 1408*C*D1*Dd*f*fd*r*s + 528*C*D1*Dd*f*fd*r - 1408*C*D1*Dd*f*fd*s**2 + 1760*C*D1*Dd*f*fd*s - 440*C*D1*Dd*f*fd - 352*C*D1*Ddd*f**2*r*s + 88*C*D1*Ddd*f**2*r - 352*C*D1*Ddd*f**2*s**2 + 352*C*D1*Ddd*f**2*s - 88*C*D1*Ddd*f**2 - 1056*C*Dd**2*f**2*r*s + 264*C*Dd**2*f**2*r - 1056*C*Dd**2*f**2*s**2 + 1056*C*Dd**2*f**2*s - 176*C*Dd**2*f**2 + 32*D1**2*K*f*fd*r*s - 16*D1**2*K*f*fd*r + 32*D1**2*K*f*fd*s**2 - 32*D1**2*K*f*fd*s + 16*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r*s + 20*D1**2*K*f*fdd*r - 40*D1**2*K*f*fdd*s**2 + 40*D1**2*K*f*fdd*s - 20*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r*s + 20*D1**2*K*fd**2*r - 40*D1**2*K*fd**2*s**2 + 40*D1**2*K*fd**2*s + 28*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(5*f**2*(2*r**2 + r*(36*s - 22) + 34*s**2 - 50*s + 21) + 2*f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 52*K*s**2 + 26*K*s + 6*r**2 - 2*r*(26*K*s - 44*s + 9) + 82*s**2 - 92*s + 15) - 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 150*D1**2*f**2*fd*r**2 + 900*D1**2*f**2*fd*r*s - 450*D1**2*f**2*fd*r + 750*D1**2*f**2*fd*s**2 - 930*D1**2*f**2*fd*s + 325*D1**2*f**2*fd - 210*D1**2*f**2*fdd*r**2 - 780*D1**2*f**2*fdd*r*s + 470*D1**2*f**2*fdd*r - 570*D1**2*f**2*fdd*s**2 + 750*D1**2*f**2*fdd*s - 295*D1**2*f**2*fdd - 420*D1**2*f*fd**2*r**2 - 1560*D1**2*f*fd**2*r*s + 940*D1**2*f*fd**2*r - 1140*D1**2*f*fd**2*s**2 + 1500*D1**2*f*fd**2*s - 440*D1**2*f*fd**2 + 44*D1**2*f*fd*r**2 + 56*D1**2*f*fd*r*s - 92*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s + 74*D1**2*f*fd - 70*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 64*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 80*D1**2*f*fdd*s - 34*D1**2*f*fdd - 96*D1**2*f*gd2*r*s - 96*D1**2*f*gd2*s**2 + 96*D1**2*f*gd2*s + 104*D1**2*f*gdd2*r*s + 104*D1**2*f*gdd2*s**2 - 104*D1**2*f*gdd2*s - 70*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 64*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 80*D1**2*fd**2*s + 98*D1**2*fd**2 - 96*D1**2*fd*g2*r*s + 96*D1**2*fd*g2*r - 96*D1**2*fd*g2*s**2 + 192*D1**2*fd*g2*s - 96*D1**2*fd*g2 + 208*D1**2*fd*gd2*r*s - 104*D1**2*fd*gd2*r + 208*D1**2*fd*gd2*s**2 - 312*D1**2*fd*gd2*s + 104*D1**2*fd*gd2 + 104*D1**2*fdd*g2*r*s - 104*D1**2*fdd*g2*r + 104*D1**2*fdd*g2*s**2 - 208*D1**2*fdd*g2*s + 104*D1**2*fdd*g2 + 64*D1*Dd*K*f**2*r*s - 16*D1*Dd*K*f**2*r + 64*D1*Dd*K*f**2*s**2 - 64*D1*Dd*K*f**2*s + 16*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r*s + 120*D1*Dd*K*f*fd*r - 320*D1*Dd*K*f*fd*s**2 + 320*D1*Dd*K*f*fd*s - 80*D1*Dd*K*f*fd + 200*D1*Dd*f**3*r**2 + 1200*D1*Dd*f**3*r*s - 500*D1*Dd*f**3*r + 1000*D1*Dd*f**3*s**2 - 1100*D1*Dd*f**3*s + 350*D1*Dd*f**3 - 1680*D1*Dd*f**2*fd*r**2 - 6240*D1*Dd*f**2*fd*r*s + 3500*D1*Dd*f**2*fd*r - 4560*D1*Dd*f**2*fd*s**2 + 5700*D1*Dd*f**2*fd*s - 1690*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r**2 + 112*D1*Dd*f**2*r*s - 116*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 68*D1*Dd*f**2*s + 50*D1*Dd*f**2 - 560*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 564*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 348*D1*Dd*f*fd*s - 48*D1*Dd*f*fd - 384*D1*Dd*f*g2*r*s + 96*D1*Dd*f*g2*r - 384*D1*Dd*f*g2*s**2 + 384*D1*Dd*f*g2*s - 96*D1*Dd*f*g2 + 832*D1*Dd*f*gd2*r*s - 104*D1*Dd*f*gd2*r + 832*D1*Dd*f*gd2*s**2 - 832*D1*Dd*f*gd2*s + 104*D1*Dd*f*gd2 + 832*D1*Dd*fd*g2*r*s - 520*D1*Dd*fd*g2*r + 832*D1*Dd*fd*g2*s**2 - 1248*D1*Dd*fd*g2*s + 416*D1*Dd*fd*g2 - 80*D1*Ddd*K*f**2*r*s + 20*D1*Ddd*K*f**2*r - 80*D1*Ddd*K*f**2*s**2 + 80*D1*Ddd*K*f**2*s - 20*D1*Ddd*K*f**2 - 280*D1*Ddd*f**3*r**2 - 1040*D1*Ddd*f**3*r*s + 540*D1*Ddd*f**3*r - 760*D1*Ddd*f**3*s**2 + 900*D1*Ddd*f**3*s - 330*D1*Ddd*f**3 - 140*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 154*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 14*D1*Ddd*f**2*s - 49*D1*Ddd*f**2 + 416*D1*Ddd*f*g2*r*s - 104*D1*Ddd*f*g2*r + 416*D1*Ddd*f*g2*s**2 - 416*D1*Ddd*f*g2*s + 104*D1*Ddd*f*g2 + D1*bd1*(D1*(-4*f**2*(2*r**2 + r*(60*s - 34) + 58*s**2 - 80*s + 33) + f*(-40*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 96*K*r*s + 96*K*s**2 - 48*K*s + 20*fd*(2*r**2 + 36*r*s - 11*r + 34*s**2 - 35*s + 7) - 10*r**2 - 212*r*s + 58*r - 202*s**2 + 242*s - 53) + 4*fd*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) - 13*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + 6*r**2 + 88*r*s - 41*r + 82*s**2 - 80*s + 4) + 56*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 56*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(5*f**2*(8*r**2 + 6*r*(24*s - 11) + 136*s**2 - 170*s + 47) + 2*f*(24*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 13*K*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 24*r**2 + 352*r*s - 92*r + 328*s**2 - 354*s + 64) - 56*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 240*Dd**2*K*f**2*r*s + 60*Dd**2*K*f**2*r - 240*Dd**2*K*f**2*s**2 + 240*Dd**2*K*f**2*s - 40*Dd**2*K*f**2 - 840*Dd**2*f**3*r**2 - 3120*Dd**2*f**3*r*s + 1620*Dd**2*f**3*r - 2280*Dd**2*f**3*s**2 + 2700*Dd**2*f**3*s - 660*Dd**2*f**3 - 420*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 462*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 42*Dd**2*f**2*s - 98*Dd**2*f**2 + 1248*Dd**2*f*g2*r*s - 312*Dd**2*f*g2*r + 1248*Dd**2*f*g2*s**2 - 1248*Dd**2*f*g2*s + 208*Dd**2*f*g2))/(693*d**2*k2*k3**3) + D1**2*Pk2*Pkd3*ct**3*k1*k2**5*st**2*(-396*C*D1**2*bdd1*f**2*r**2 - 792*C*D1**2*bdd1*f**2*r*s + 792*C*D1**2*bdd1*f**2*r - 396*C*D1**2*bdd1*f**2*s**2 + 792*C*D1**2*bdd1*f**2*s - 396*C*D1**2*bdd1*f**2 + 3624*C*D1**2*f**2*fd*r**2 + 7248*C*D1**2*f**2*fd*r*s - 4832*C*D1**2*f**2*fd*r + 3624*C*D1**2*f**2*fd*s**2 - 4832*C*D1**2*f**2*fd*s + 2416*C*D1**2*f**2*fd - 3000*C*D1**2*f**2*fdd*r**2 - 6000*C*D1**2*f**2*fdd*r*s + 4000*C*D1**2*f**2*fdd*r - 3000*C*D1**2*f**2*fdd*s**2 + 4000*C*D1**2*f**2*fdd*s - 2000*C*D1**2*f**2*fdd - 6000*C*D1**2*f*fd**2*r**2 - 12000*C*D1**2*f*fd**2*r*s + 8000*C*D1**2*f*fd**2*r - 6000*C*D1**2*f*fd**2*s**2 + 8000*C*D1**2*f*fd**2*s - 2000*C*D1**2*f*fd**2 + 4832*C*D1*Dd*f**3*r**2 + 9664*C*D1*Dd*f**3*r*s - 7248*C*D1*Dd*f**3*r + 4832*C*D1*Dd*f**3*s**2 - 7248*C*D1*Dd*f**3*s + 3624*C*D1*Dd*f**3 - 24000*C*D1*Dd*f**2*fd*r**2 - 48000*C*D1*Dd*f**2*fd*r*s + 34000*C*D1*Dd*f**2*fd*r - 24000*C*D1*Dd*f**2*fd*s**2 + 34000*C*D1*Dd*f**2*fd*s - 12000*C*D1*Dd*f**2*fd - 4000*C*D1*Ddd*f**3*r**2 - 8000*C*D1*Ddd*f**3*r*s + 6000*C*D1*Ddd*f**3*r - 4000*C*D1*Ddd*f**3*s**2 + 6000*C*D1*Ddd*f**3*s - 3000*C*D1*Ddd*f**3 - 12000*C*Dd**2*f**3*r**2 - 24000*C*Dd**2*f**3*r*s + 18000*C*Dd**2*f**3*r - 12000*C*Dd**2*f**3*s**2 + 18000*C*Dd**2*f**3*s - 6000*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r**2 - 1320*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 660*D1**2*K*bdd1*f**2*s**2 + 1320*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 + 66*D1**2*bd1**2*f*(-6*K + 5*f + 3)*(r + s - 1)**2 + 297*D1**2*bdd1*f**2*r**2 + 594*D1**2*bdd1*f**2*r*s - 594*D1**2*bdd1*f**2*r + 297*D1**2*bdd1*f**2*s**2 - 594*D1**2*bdd1*f**2*s + 297*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r**2 + 792*D1**2*bdd1*f*g2*r*s - 792*D1**2*bdd1*f*g2*r + 396*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 1515*D1**2*f**2*fd*r**2 - 3030*D1**2*f**2*fd*r*s + 2020*D1**2*f**2*fd*r - 1515*D1**2*f**2*fd*s**2 + 2020*D1**2*f**2*fd*s - 1010*D1**2*f**2*fd + 1500*D1**2*f**2*fdd*r**2 + 3000*D1**2*f**2*fdd*r*s - 2000*D1**2*f**2*fdd*r + 1500*D1**2*f**2*fdd*s**2 - 2000*D1**2*f**2*fdd*s + 1000*D1**2*f**2*fdd - 1848*D1**2*f**2*gd2*r**2 - 3696*D1**2*f**2*gd2*r*s + 3696*D1**2*f**2*gd2*r - 1848*D1**2*f**2*gd2*s**2 + 3696*D1**2*f**2*gd2*s - 1848*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 3000*D1**2*f*fd**2*r**2 + 6000*D1**2*f*fd**2*r*s - 4000*D1**2*f*fd**2*r + 3000*D1**2*f*fd**2*s**2 - 4000*D1**2*f*fd**2*s + 1000*D1**2*f*fd**2 - 3696*D1**2*f*fd*g2*r**2 - 7392*D1**2*f*fd*g2*r*s + 3696*D1**2*f*fd*g2*r - 3696*D1**2*f*fd*g2*s**2 + 3696*D1**2*f*fd*g2*s - 1848*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s - 2020*D1*Dd*f**3*r**2 - 4040*D1*Dd*f**3*r*s + 3030*D1*Dd*f**3*r - 2020*D1*Dd*f**3*s**2 + 3030*D1*Dd*f**3*s - 1515*D1*Dd*f**3 + 12000*D1*Dd*f**2*fd*r**2 + 24000*D1*Dd*f**2*fd*r*s - 17000*D1*Dd*f**2*fd*r + 12000*D1*Dd*f**2*fd*s**2 - 17000*D1*Dd*f**2*fd*s + 6000*D1*Dd*f**2*fd - 7392*D1*Dd*f**2*g2*r**2 - 14784*D1*Dd*f**2*g2*r*s + 11088*D1*Dd*f**2*g2*r - 7392*D1*Dd*f**2*g2*s**2 + 11088*D1*Dd*f**2*g2*s - 5544*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 2000*D1*Ddd*f**3*r**2 + 4000*D1*Ddd*f**3*r*s - 3000*D1*Ddd*f**3*r + 2000*D1*Ddd*f**3*s**2 - 3000*D1*Ddd*f**3*s + 1500*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(24*C + 28*K - 15)*(r + s - 1) - 2*f*(fd*(12*C + 20*K - 9)*(2*r + 2*s - 1) + (12*g2 - 12*gd2)*(r + s - 1)) + 24*fd*g2*(r + s)) - 2*Dd*f*(f*(12*C + 20*K - 9) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1) + 6000*Dd**2*f**3*r**2 + 12000*Dd**2*f**3*r*s - 9000*Dd**2*f**3*r + 6000*Dd**2*f**3*s**2 - 9000*Dd**2*f**3*s + 3000*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 6*fd*(2*K - 1)*(r + s) - 3*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (6*K - 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 3*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-6*K + 5*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-6*K + 5*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-48*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 144*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 56*D1**2*K*f*fd*r**2 - 112*D1**2*K*f*fd*r*s + 56*D1**2*K*f*fd*r - 56*D1**2*K*f*fd*s**2 + 56*D1**2*K*f*fd*s - 28*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-6*K + 5*f + 3)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 30*D1**2*f*fd*r**2 + 60*D1**2*f*fd*r*s - 30*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 30*D1**2*f*fd*s + 15*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 24*D1**2*f*gd2*r**2 + 48*D1**2*f*gd2*r*s - 48*D1**2*f*gd2*r + 24*D1**2*f*gd2*s**2 - 48*D1**2*f*gd2*s + 24*D1**2*f*gd2 - 12*D1**2*f*gdd2*r**2 - 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*r - 12*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 12*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 24*D1**2*fd*g2*r**2 + 48*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r**2 - 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 24*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r**2 - 24*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 112*D1*Dd*K*f**2*r**2 - 224*D1*Dd*K*f**2*r*s + 168*D1*Dd*K*f**2*r - 112*D1*Dd*K*f**2*s**2 + 168*D1*Dd*K*f**2*s - 84*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 60*D1*Dd*f**2*r**2 + 120*D1*Dd*f**2*r*s - 90*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 90*D1*Dd*f**2*s + 45*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 96*D1*Dd*f*g2*r**2 + 192*D1*Dd*f*g2*r*s - 144*D1*Dd*f*g2*r + 96*D1*Dd*f*g2*s**2 - 144*D1*Dd*f*g2*s + 72*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r**2 - 192*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 168*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r**2 - 192*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 72*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r**2 - 96*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 72*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 3*f*(2*K - 1)*(r + s - 1) + 3*fd*(2*K - 1)*(r + s)) - Dd*f*(-6*K + 5*f + 3)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 144*Dd**2*f*g2*r**2 - 288*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 216*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(77*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct**3*k1*k2**5*(-2*D1*(24*D1*K*bd1**2*f*(r + s - 1)**2 - bd1*(D1*(f**2*(16*C - 6*K - 5)*(r + s - 1) - 4*f*(fd*(10*C - 5)*(2*r + 2*s - 1) + (5*g2 - 12*gd2)*(r + s - 1)) + 48*fd*g2*(r + s)) - 4*Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1) + f*(2*D1*bdd1*(f*(10*C - 5) - 12*g2)*(r + s - 1)**2 + D1*(f*(fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*gd2*(r + s - 1)**2) - 12*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**2*(D1**2*(6*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-24*K*fdd + fd*(20*K + 7))) + D1*(Dd*(-48*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 6*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(20*K + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 144*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(D1**2*(f*(fd*(16*C - 6*K - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*(r + s - 1)**2*(12*K*bdd1 + 10*gd2 - 12*gdd2)) + (-4*r - 4*s)*(fd**2*(10*C - 5)*(r + s - 1) + 5*fd*g2*(r + s) - 12*fd*gd2*(r + s - 1) - 6*fdd*g2*(r + s))) + D1*bd1*(D1*(-48*K*fd*(r + s) + 6*f**2*(r + s - 1) + f*(20*K + 7)*(r + s - 1)) - 48*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(16*C - 6*K - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 4*f*(fd*(10*C - 5)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 5*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 48*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(f*(10*C - 5) - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**3*k1*k2**3*st**2*(-1188*C*D1**2*bdd1*f**2*r**2 - 3168*C*D1**2*bdd1*f**2*r*s - 792*C*D1**2*bdd1*f**2*r - 1980*C*D1**2*bdd1*f**2*s**2 - 43032*C*D1**2*f**2*fd*r**2 - 83784*C*D1**2*f**2*fd*r*s + 56616*C*D1**2*f**2*fd*r - 40752*C*D1**2*f**2*fd*s**2 + 55096*C*D1**2*f**2*fd*s - 27928*C*D1**2*f**2*fd + 33396*C*D1**2*f**2*fdd*r**2 + 62088*C*D1**2*f**2*fdd*r*s - 42960*C*D1**2*f**2*fdd*r + 28692*C*D1**2*f**2*fdd*s**2 - 39824*C*D1**2*f**2*fdd*s + 20696*C*D1**2*f**2*fdd + 66792*C*D1**2*f*fd**2*r**2 + 124176*C*D1**2*f*fd**2*r*s - 85920*C*D1**2*f*fd**2*r + 57384*C*D1**2*f*fd**2*s**2 - 79648*C*D1**2*f*fd**2*s + 20696*C*D1**2*f*fd**2 - 57376*C*D1*Dd*f**3*r**2 - 111712*C*D1*Dd*f**3*r*s + 85304*C*D1*Dd*f**3*r - 54336*C*D1*Dd*f**3*s**2 + 83024*C*D1*Dd*f**3*s - 42272*C*D1*Dd*f**3 + 267168*C*D1*Dd*f**2*fd*r**2 + 496704*C*D1*Dd*f**2*fd*r*s - 367512*C*D1*Dd*f**2*fd*r + 229536*C*D1*Dd*f**2*fd*s**2 - 340856*C*D1*Dd*f**2*fd*s + 125744*C*D1*Dd*f**2*fd + 44528*C*D1*Ddd*f**3*r**2 + 82784*C*D1*Ddd*f**3*r*s - 65224*C*D1*Ddd*f**3*r + 38256*C*D1*Ddd*f**3*s**2 - 60520*C*D1*Ddd*f**3*s + 31828*C*D1*Ddd*f**3 + 133584*C*Dd**2*f**3*r**2 + 248352*C*Dd**2*f**3*r*s - 195672*C*Dd**2*f**3*r + 114768*C*Dd**2*f**3*s**2 - 181560*C*Dd**2*f**3*s + 63656*C*Dd**2*f**3 + 6270*D1**2*K*bdd1*f**2*r**2 + 12012*D1**2*K*bdd1*f**2*r*s - 12540*D1**2*K*bdd1*f**2*r + 5742*D1**2*K*bdd1*f**2*s**2 - 12012*D1**2*K*bdd1*f**2*s + 6270*D1**2*K*bdd1*f**2 - 11220*D1**2*b2*f*fd*r**2 - 22440*D1**2*b2*f*fd*r*s + 11220*D1**2*b2*f*fd*r - 11220*D1**2*b2*f*fd*s**2 + 11220*D1**2*b2*f*fd*s - 5610*D1**2*b2*f*fd + 6600*D1**2*b2*f*fdd*r**2 + 13200*D1**2*b2*f*fdd*r*s - 6600*D1**2*b2*f*fdd*r + 6600*D1**2*b2*f*fdd*s**2 - 6600*D1**2*b2*f*fdd*s + 3300*D1**2*b2*f*fdd + 6600*D1**2*b2*fd**2*r**2 + 13200*D1**2*b2*fd**2*r*s - 6600*D1**2*b2*fd**2*r + 6600*D1**2*b2*fd**2*s**2 - 6600*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*f*(r + s - 1)*(-6*K*(3*r + 5*s + 1) + 25*f - 12*r + 21) - 5610*D1**2*bd2*f**2*r**2 - 11220*D1**2*bd2*f**2*r*s + 11220*D1**2*bd2*f**2*r - 5610*D1**2*bd2*f**2*s**2 + 11220*D1**2*bd2*f**2*s - 5610*D1**2*bd2*f**2 + 13200*D1**2*bd2*f*fd*r**2 + 26400*D1**2*bd2*f*fd*r*s - 19800*D1**2*bd2*f*fd*r + 13200*D1**2*bd2*f*fd*s**2 - 19800*D1**2*bd2*f*fd*s + 6600*D1**2*bd2*f*fd - 1815*D1**2*bdd1*f**3*r**2 - 3630*D1**2*bdd1*f**3*r*s + 4290*D1**2*bdd1*f**3*r - 1815*D1**2*bdd1*f**3*s**2 + 4290*D1**2*bdd1*f**3*s - 2475*D1**2*bdd1*f**3 - 1287*D1**2*bdd1*f**2*r**2 - 1518*D1**2*bdd1*f**2*r*s + 4752*D1**2*bdd1*f**2*r - 231*D1**2*bdd1*f**2*s**2 + 3696*D1**2*bdd1*f**2*s - 1980*D1**2*bdd1*f**2 + 1188*D1**2*bdd1*f*g2*r**2 + 3168*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r + 1980*D1**2*bdd1*f*g2*s**2 + 3300*D1**2*bdd2*f**2*r**2 + 6600*D1**2*bdd2*f**2*r*s - 6600*D1**2*bdd2*f**2*r + 3300*D1**2*bdd2*f**2*s**2 - 6600*D1**2*bdd2*f**2*s + 3300*D1**2*bdd2*f**2 + 24180*D1**2*f**2*fd*r**2 + 47244*D1**2*f**2*fd*r*s - 31868*D1**2*f**2*fd*r + 23064*D1**2*f**2*fd*s**2 - 31124*D1**2*f**2*fd*s + 15748*D1**2*f**2*fd - 21297*D1**2*f**2*fdd*r**2 - 39066*D1**2*f**2*fdd*r*s + 27220*D1**2*f**2*fdd*r - 17769*D1**2*f**2*fdd*s**2 + 24868*D1**2*f**2*fdd*s - 13022*D1**2*f**2*fdd + 18744*D1**2*f**2*gd2*r**2 + 36168*D1**2*f**2*gd2*r*s - 37488*D1**2*f**2*gd2*r + 17424*D1**2*f**2*gd2*s**2 - 36168*D1**2*f**2*gd2*s + 18744*D1**2*f**2*gd2 - 12540*D1**2*f**2*gdd2*r**2 - 24024*D1**2*f**2*gdd2*r*s + 25080*D1**2*f**2*gdd2*r - 11484*D1**2*f**2*gdd2*s**2 + 24024*D1**2*f**2*gdd2*s - 12540*D1**2*f**2*gdd2 - 42594*D1**2*f*fd**2*r**2 - 78132*D1**2*f*fd**2*r*s + 54440*D1**2*f*fd**2*r - 35538*D1**2*f*fd**2*s**2 + 49736*D1**2*f*fd**2*s - 13022*D1**2*f*fd**2 + 37488*D1**2*f*fd*g2*r**2 + 72336*D1**2*f*fd*g2*r*s - 36168*D1**2*f*fd*g2*r + 34848*D1**2*f*fd*g2*s**2 - 34848*D1**2*f*fd*g2*s + 17424*D1**2*f*fd*g2 - 50160*D1**2*f*fd*gd2*r**2 - 96096*D1**2*f*fd*gd2*r*s + 74184*D1**2*f*fd*gd2*r - 45936*D1**2*f*fd*gd2*s**2 + 71016*D1**2*f*fd*gd2*s - 24024*D1**2*f*fd*gd2 - 25080*D1**2*f*fdd*g2*r**2 - 48048*D1**2*f*fdd*g2*r*s + 24024*D1**2*f*fdd*g2*r - 22968*D1**2*f*fdd*g2*s**2 + 22968*D1**2*f*fdd*g2*s - 11484*D1**2*f*fdd*g2 - 25080*D1**2*fd**2*g2*r**2 - 48048*D1**2*fd**2*g2*r*s + 24024*D1**2*fd**2*g2*r - 22968*D1**2*fd**2*g2*s**2 + 22968*D1**2*fd**2*g2*s - 22440*D1*Dd*b2*f**2*r**2 - 44880*D1*Dd*b2*f**2*r*s + 33660*D1*Dd*b2*f**2*r - 22440*D1*Dd*b2*f**2*s**2 + 33660*D1*Dd*b2*f**2*s - 16830*D1*Dd*b2*f**2 + 52800*D1*Dd*b2*f*fd*r**2 + 105600*D1*Dd*b2*f*fd*r*s - 66000*D1*Dd*b2*f*fd*r + 52800*D1*Dd*b2*f*fd*s**2 - 66000*D1*Dd*b2*f*fd*s + 19800*D1*Dd*b2*f*fd + 26400*D1*Dd*bd2*f**2*r**2 + 52800*D1*Dd*bd2*f**2*r*s - 46200*D1*Dd*bd2*f**2*r + 26400*D1*Dd*bd2*f**2*s**2 - 46200*D1*Dd*bd2*f**2*s + 19800*D1*Dd*bd2*f**2 + 32240*D1*Dd*f**3*r**2 + 62992*D1*Dd*f**3*r*s - 47988*D1*Dd*f**3*r + 30752*D1*Dd*f**3*s**2 - 46872*D1*Dd*f**3*s + 23808*D1*Dd*f**3 - 170376*D1*Dd*f**2*fd*r**2 - 312528*D1*Dd*f**2*fd*r*s + 233134*D1*Dd*f**2*fd*r - 142152*D1*Dd*f**2*fd*s**2 + 213142*D1*Dd*f**2*fd*s - 79308*D1*Dd*f**2*fd + 74976*D1*Dd*f**2*g2*r**2 + 144672*D1*Dd*f**2*g2*r*s - 111144*D1*Dd*f**2*g2*r + 69696*D1*Dd*f**2*g2*s**2 - 107184*D1*Dd*f**2*g2*s + 54912*D1*Dd*f**2*g2 - 100320*D1*Dd*f**2*gd2*r**2 - 192192*D1*Dd*f**2*gd2*r*s + 174504*D1*Dd*f**2*gd2*r - 91872*D1*Dd*f**2*gd2*s**2 + 167112*D1*Dd*f**2*gd2*s - 74184*D1*Dd*f**2*gd2 - 200640*D1*Dd*f*fd*g2*r**2 - 384384*D1*Dd*f*fd*g2*r*s + 244464*D1*Dd*f*fd*g2*r - 183744*D1*Dd*f*fd*g2*s**2 + 233904*D1*Dd*f*fd*g2*s - 71016*D1*Dd*f*fd*g2 + 13200*D1*Ddd*b2*f**2*r**2 + 26400*D1*Ddd*b2*f**2*r*s - 19800*D1*Ddd*b2*f**2*r + 13200*D1*Ddd*b2*f**2*s**2 - 19800*D1*Ddd*b2*f**2*s + 9900*D1*Ddd*b2*f**2 - 28396*D1*Ddd*f**3*r**2 - 52088*D1*Ddd*f**3*r*s + 41418*D1*Ddd*f**3*r - 23692*D1*Ddd*f**3*s**2 + 37890*D1*Ddd*f**3*s - 20121*D1*Ddd*f**3 - 50160*D1*Ddd*f**2*g2*r**2 - 96096*D1*Ddd*f**2*g2*r*s + 74184*D1*Ddd*f**2*g2*r - 45936*D1*Ddd*f**2*g2*s**2 + 71016*D1*Ddd*f**2*g2*s - 36564*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(10*f**3*(r**2 + 3*r*(s - 1) + 2*(s - 1)**2) - f**2*(-40*C*r**2 - 100*C*r*s - 20*C*r - 60*C*s**2 + 2*K*(71*r**2 + 137*r*s - 142*r + 66*s**2 - 137*s + 71) + 5*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) - 8*r**2 + 6*r*s + 86*r + 14*s**2 + 64*s - 33) - 2*f*(fd*(6*C*(6*r**2 + 2*r*(8*s - 3) + 10*s**2 - 9*s - 1) - K*(190*r**2 + 364*r*s - 281*r + 174*s**2 - 269*s + 91) + 39*r**2 + 46*r*s - 67*r + 7*s**2 - 43*s + 34) + 6*g2*(3*r**2 + r*(8*s + 2) + 5*s**2) + 6*gd2*(-3*r**2 + r*(2 - 8*s) - 5*s**2 + 4*s + 1)) + 12*fd*g2*(3*r**2 + r*(8*s - 4) + s*(5*s - 5))) - Dd*f*(5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) + f*(12*C*(12*r**2 + r*(32*s - 6) + 20*s**2 - 13*s - 2) - 2*K*(380*r**2 + 728*r*s - 661*r + 348*s**2 - 633*s + 281) + 156*r**2 + 184*r*s - 389*r + 28*s**2 - 277*s + 200) - 12*g2*(12*r**2 + r*(32*s - 6) + 20*s**2 - 13*s - 2))) + 39600*Dd**2*b2*f**2*r**2 + 79200*Dd**2*b2*f**2*r*s - 59400*Dd**2*b2*f**2*r + 39600*Dd**2*b2*f**2*s**2 - 59400*Dd**2*b2*f**2*s + 19800*Dd**2*b2*f**2 - 85188*Dd**2*f**3*r**2 - 156264*Dd**2*f**3*r*s + 124254*Dd**2*f**3*r - 71076*Dd**2*f**3*s**2 + 113670*Dd**2*f**3*s - 40242*Dd**2*f**3 - 150480*Dd**2*f**2*g2*r**2 - 288288*Dd**2*f**2*g2*r*s + 222552*Dd**2*f**2*g2*r - 137808*Dd**2*f**2*g2*s**2 + 213048*Dd**2*f**2*g2*s - 73128*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(50*f*fd*(2*r + 2*s - 1) - 50*fd**2*(r + s - 1) + 6*fd*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 4*r*s + 10*r + 10*s - 5) - fdd*(6*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 25*f*(2*r + 2*s - 1) + 12*r**2 + 12*r*s + 30*r + 30*s - 15)) - 2*D1*(Dd*(f*(-6*K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 25*fd*(4*r + 4*s - 3) - 48*r**2 - 48*r*s + 60*r + 24*s - 24) + 3*fd*(K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 16*r**2 + 2*r*(8*s + 5) + 16*s - 15)) + 3*Ddd*f*(K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 8*r**2 + 2*r*(4*s - 5) - 4*s + 4)) - 12*Dd**2*f*(K*(18*r**2 + 6*r*(8*s - 5) + 30*s**2 - 39*s + 11) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) - 33*b1*(-160*C*D1**2*f*fd*r**2 - 400*C*D1**2*f*fd*r*s + 400*C*D1**2*f*fd*r - 240*C*D1**2*f*fd*s**2 + 440*C*D1**2*f*fd*s - 200*C*D1**2*f*fd + 72*C*D1**2*f*fdd*r**2 + 192*C*D1**2*f*fdd*r*s - 192*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 216*C*D1**2*f*fdd*s + 96*C*D1**2*f*fdd + 72*C*D1**2*fd**2*r**2 + 192*C*D1**2*fd**2*r*s - 192*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 216*C*D1**2*fd**2*s + 120*C*D1**2*fd**2 - 320*C*D1*Dd*f**2*r**2 - 800*C*D1*Dd*f**2*r*s + 520*C*D1*Dd*f**2*r - 480*C*D1*Dd*f**2*s**2 + 640*C*D1*Dd*f**2*s - 280*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 + 1536*C*D1*Dd*f*fd*r*s - 1248*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1488*C*D1*Dd*f*fd*s + 600*C*D1*Dd*f*fd + 144*C*D1*Ddd*f**2*r**2 + 384*C*D1*Ddd*f**2*r*s - 240*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 312*C*D1*Ddd*f**2*s + 132*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r**2 + 1152*C*Dd**2*f**2*r*s - 720*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 936*C*Dd**2*f**2*s + 264*C*Dd**2*f**2 + 568*D1**2*K*f*fd*r**2 + 1096*D1**2*K*f*fd*r*s - 548*D1**2*K*f*fd*r + 528*D1**2*K*f*fd*s**2 - 528*D1**2*K*f*fd*s + 264*D1**2*K*f*fd - 380*D1**2*K*f*fdd*r**2 - 728*D1**2*K*f*fdd*r*s + 364*D1**2*K*f*fdd*r - 348*D1**2*K*f*fdd*s**2 + 348*D1**2*K*f*fdd*s - 174*D1**2*K*f*fdd - 380*D1**2*K*fd**2*r**2 - 728*D1**2*K*fd**2*r*s + 364*D1**2*K*fd**2*r - 348*D1**2*K*fd**2*s**2 + 348*D1**2*K*fd**2*s + D1**2*bdd1*f*(6*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) - 25*f*(2*r + 2*s - 1) + 24*r**2 + 24*r*s - 66*r - 42*s + 27) - 60*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 80*D1**2*f**2*fd*r - 120*D1**2*f**2*fd*s**2 + 120*D1**2*f**2*fd*s - 40*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 32*D1**2*f*fd*r**2 + 24*D1**2*f*fd*r*s - 152*D1**2*f*fd*r + 56*D1**2*f*fd*s**2 - 196*D1**2*f*fd*s + 78*D1**2*f*fd + 78*D1**2*f*fdd*r**2 + 92*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*r + 14*D1**2*f*fdd*s**2 + 52*D1**2*f*fdd*s - 14*D1**2*f*fdd + 72*D1**2*f*gd2*r**2 + 192*D1**2*f*gd2*r*s - 144*D1**2*f*gd2*r + 120*D1**2*f*gd2*s**2 - 192*D1**2*f*gd2*s + 72*D1**2*f*gd2 - 36*D1**2*f*gdd2*r**2 - 96*D1**2*f*gdd2*r*s + 72*D1**2*f*gdd2*r - 60*D1**2*f*gdd2*s**2 + 96*D1**2*f*gdd2*s - 36*D1**2*f*gdd2 + 78*D1**2*fd**2*r**2 + 92*D1**2*fd**2*r*s + 20*D1**2*fd**2*r + 14*D1**2*fd**2*s**2 + 52*D1**2*fd**2*s - 90*D1**2*fd**2 + 72*D1**2*fd*g2*r**2 + 192*D1**2*fd*g2*r*s - 240*D1**2*fd*g2*r + 120*D1**2*fd*g2*s**2 - 240*D1**2*fd*g2*s + 120*D1**2*fd*g2 - 72*D1**2*fd*gd2*r**2 - 192*D1**2*fd*gd2*r*s + 192*D1**2*fd*gd2*r - 120*D1**2*fd*gd2*s**2 + 216*D1**2*fd*gd2*s - 120*D1**2*fd*gd2 - 36*D1**2*fdd*g2*r**2 - 96*D1**2*fdd*g2*r*s + 120*D1**2*fdd*g2*r - 60*D1**2*fdd*g2*s**2 + 120*D1**2*fdd*g2*s - 60*D1**2*fdd*g2 + 1136*D1*Dd*K*f**2*r**2 + 2192*D1*Dd*K*f**2*r*s - 1684*D1*Dd*K*f**2*r + 1056*D1*Dd*K*f**2*s**2 - 1624*D1*Dd*K*f**2*s + 832*D1*Dd*K*f**2 - 3040*D1*Dd*K*f*fd*r**2 - 5824*D1*Dd*K*f*fd*r*s + 3704*D1*Dd*K*f*fd*r - 2784*D1*Dd*K*f*fd*s**2 + 3544*D1*Dd*K*f*fd*s - 1076*D1*Dd*K*f*fd - 80*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 140*D1*Dd*f**3*r - 160*D1*Dd*f**3*s**2 + 200*D1*Dd*f**3*s - 80*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1790*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd - 64*D1*Dd*f**2*r**2 + 48*D1*Dd*f**2*r*s + 52*D1*Dd*f**2*r + 112*D1*Dd*f**2*s**2 - 80*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 624*D1*Dd*f*fd*r**2 + 736*D1*Dd*f*fd*r*s - 324*D1*Dd*f*fd*r + 112*D1*Dd*f*fd*s**2 - 4*D1*Dd*f*fd*s - 92*D1*Dd*f*fd + 288*D1*Dd*f*g2*r**2 + 768*D1*Dd*f*g2*r*s - 480*D1*Dd*f*g2*r + 480*D1*Dd*f*g2*s**2 - 624*D1*Dd*f*g2*s + 264*D1*Dd*f*g2 - 288*D1*Dd*f*gd2*r**2 - 768*D1*Dd*f*gd2*r*s + 528*D1*Dd*f*gd2*r - 480*D1*Dd*f*gd2*s**2 + 696*D1*Dd*f*gd2*s - 240*D1*Dd*f*gd2 - 288*D1*Dd*fd*g2*r**2 - 768*D1*Dd*fd*g2*r*s + 720*D1*Dd*fd*g2*r - 480*D1*Dd*fd*g2*s**2 + 792*D1*Dd*fd*g2*s - 360*D1*Dd*fd*g2 - 760*D1*Ddd*K*f**2*r**2 - 1456*D1*Ddd*K*f**2*r*s + 1124*D1*Ddd*K*f**2*r - 696*D1*Ddd*K*f**2*s**2 + 1076*D1*Ddd*K*f**2*s - 554*D1*Ddd*K*f**2 + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 + 156*D1*Ddd*f**2*r**2 + 184*D1*Ddd*f**2*r*s - 202*D1*Ddd*f**2*r + 28*D1*Ddd*f**2*s**2 - 106*D1*Ddd*f**2*s + 85*D1*Ddd*f**2 - 144*D1*Ddd*f*g2*r**2 - 384*D1*Ddd*f*g2*r*s + 240*D1*Ddd*f*g2*r - 240*D1*Ddd*f*g2*s**2 + 312*D1*Ddd*f*g2*s - 132*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(25*f**2*(2*r + 2*s - 1) - 3*f*(2*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) + 8*r**2 + 8*r*s - 22*r - 14*s + 9) + 3*fd*(2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) + 8*r**2 + 8*r*s - r + 3*s - 5)) + Dd*f*(12*K*(12*r**2 + 2*r*(16*s - 7) + 20*s**2 - 21*s + 4) - 25*f*(4*r + 4*s - 3) + 96*r**2 + 96*r*(s - 2) - 108*s + 87)) - 2280*Dd**2*K*f**2*r**2 - 4368*Dd**2*K*f**2*r*s + 3372*Dd**2*K*f**2*r - 2088*Dd**2*K*f**2*s**2 + 3228*Dd**2*K*f**2*s - 1108*Dd**2*K*f**2 + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 330*Dd**2*f**3 + 468*Dd**2*f**2*r**2 + 552*Dd**2*f**2*r*s - 606*Dd**2*f**2*r + 84*Dd**2*f**2*s**2 - 318*Dd**2*f**2*s + 170*Dd**2*f**2 - 432*Dd**2*f*g2*r**2 - 1152*Dd**2*f*g2*r*s + 720*Dd**2*f*g2*r - 720*Dd**2*f*g2*s**2 + 936*Dd**2*f*g2*s - 264*Dd**2*f*g2))/(693*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**3*k1*k2**3*(-4268*C*D1**2*bdd1*f**2*r**2 - 8448*C*D1**2*bdd1*f**2*r*s + 10648*C*D1**2*bdd1*f**2*r - 4180*C*D1**2*bdd1*f**2*s**2 + 10560*C*D1**2*bdd1*f**2*s - 5280*C*D1**2*bdd1*f**2 - 2760*C*D1**2*f**2*fd*r**2 - 120*C*D1**2*f**2*fd*r*s + 1880*C*D1**2*f**2*fd*r + 2640*C*D1**2*f**2*fd*s**2 - 1720*C*D1**2*f**2*fd*s - 40*C*D1**2*f**2*fd - 3900*C*D1**2*f**2*fdd*r**2 - 11160*C*D1**2*f**2*fdd*r*s + 6320*C*D1**2*f**2*fdd*r - 7260*C*D1**2*f**2*fdd*s**2 + 8560*C*D1**2*f**2*fdd*s - 3720*C*D1**2*f**2*fdd - 7800*C*D1**2*f*fd**2*r**2 - 22320*C*D1**2*f*fd**2*r*s + 12640*C*D1**2*f*fd**2*r - 14520*C*D1**2*f*fd**2*s**2 + 17120*C*D1**2*f*fd**2*s - 3720*C*D1**2*f*fd**2 - 3680*C*D1*Dd*f**3*r**2 - 160*C*D1*Dd*f**3*r*s + 3720*C*D1*Dd*f**3*r + 3520*C*D1*Dd*f**3*s**2 - 1680*C*D1*Dd*f**3*s - 960*C*D1*Dd*f**3 - 31200*C*D1*Dd*f**2*fd*r**2 - 89280*C*D1*Dd*f**2*fd*r*s + 52040*C*D1*Dd*f**2*fd*r - 58080*C*D1*Dd*f**2*fd*s**2 + 71080*C*D1*Dd*f**2*fd*s - 21200*C*D1*Dd*f**2*fd - 5200*C*D1*Ddd*f**3*r**2 - 14880*C*D1*Ddd*f**3*r*s + 8920*C*D1*Ddd*f**3*r - 9680*C*D1*Ddd*f**3*s**2 + 12280*C*D1*Ddd*f**3*s - 5020*C*D1*Ddd*f**3 - 15600*C*Dd**2*f**3*r**2 - 44640*C*Dd**2*f**3*r*s + 26760*C*Dd**2*f**3*r - 29040*C*Dd**2*f**3*s**2 + 36840*C*Dd**2*f**3*s - 10040*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r**2 - 2112*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 1452*D1**2*K*bdd1*f**2*s**2 + 2112*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 + 22*D1**2*bd1**2*(r + s - 1)*(6*f**2*(15*r + 7*s - 11) - f*(-120*C*r - 120*C*s + K*(202*r + 226*s - 274) + 19*r + 43*s + 59) - 140*g2*(r + s)) - 660*D1**2*bd2*f**2*r**2 - 1320*D1**2*bd2*f**2*r*s + 1320*D1**2*bd2*f**2*r - 660*D1**2*bd2*f**2*s**2 + 1320*D1**2*bd2*f**2*s - 660*D1**2*bd2*f**2 + 2926*D1**2*bdd1*f**2*r**2 + 5456*D1**2*bdd1*f**2*r*s - 6556*D1**2*bdd1*f**2*r + 2530*D1**2*bdd1*f**2*s**2 - 6160*D1**2*bdd1*f**2*s + 3080*D1**2*bdd1*f**2 + 4444*D1**2*bdd1*f*g2*r**2 + 9416*D1**2*bdd1*f*g2*r*s - 12056*D1**2*bdd1*f*g2*r + 4972*D1**2*bdd1*f*g2*s**2 - 12584*D1**2*bdd1*f*g2*s + 6292*D1**2*bdd1*f*g2 + 2040*D1**2*f**2*fd*r**2 + 720*D1**2*f**2*fd*r*s - 1600*D1**2*f**2*fd*r - 1320*D1**2*f**2*fd*s**2 + 640*D1**2*f**2*fd*s + 240*D1**2*f**2*fd + 1950*D1**2*f**2*fdd*r**2 + 5580*D1**2*f**2*fdd*r*s - 3160*D1**2*f**2*fdd*r + 3630*D1**2*f**2*fdd*s**2 - 4280*D1**2*f**2*fdd*s + 1860*D1**2*f**2*fdd + 1584*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 3168*D1**2*f**2*gd2*r - 1056*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 1584*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 4224*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 2904*D1**2*f**2*gdd2*s**2 - 4224*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 3900*D1**2*f*fd**2*r**2 + 11160*D1**2*f*fd**2*r*s - 6320*D1**2*f*fd**2*r + 7260*D1**2*f*fd**2*s**2 - 8560*D1**2*f*fd**2*s + 1860*D1**2*f*fd**2 + 3168*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s**2 + 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 16896*D1**2*f*fd*gd2*r*s - 9504*D1**2*f*fd*gd2*r + 11616*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4224*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 8448*D1**2*f*fdd*g2*r*s - 4224*D1**2*f*fdd*g2*r + 5808*D1**2*f*fdd*g2*s**2 - 5808*D1**2*f*fdd*g2*s + 2904*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 8448*D1**2*fd**2*g2*r*s - 4224*D1**2*fd**2*g2*r + 5808*D1**2*fd**2*g2*s**2 - 5808*D1**2*fd**2*g2*s + 2720*D1*Dd*f**3*r**2 + 960*D1*Dd*f**3*r*s - 2960*D1*Dd*f**3*r - 1760*D1*Dd*f**3*s**2 + 400*D1*Dd*f**3*s + 920*D1*Dd*f**3 + 15600*D1*Dd*f**2*fd*r**2 + 44640*D1*Dd*f**2*fd*r*s - 26020*D1*Dd*f**2*fd*r + 29040*D1*Dd*f**2*fd*s**2 - 35540*D1*Dd*f**2*fd*s + 10600*D1*Dd*f**2*fd + 6336*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 6864*D1*Dd*f**2*g2*r - 4224*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s + 2112*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 33792*D1*Dd*f**2*gd2*r*s - 20064*D1*Dd*f**2*gd2*r + 23232*D1*Dd*f**2*gd2*s**2 - 31152*D1*Dd*f**2*gd2*s + 9504*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 67584*D1*Dd*f*fd*g2*r*s - 35904*D1*Dd*f*fd*g2*r + 46464*D1*Dd*f*fd*g2*s**2 - 51744*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 + 2600*D1*Ddd*f**3*r**2 + 7440*D1*Ddd*f**3*r*s - 4460*D1*Ddd*f**3*r + 4840*D1*Ddd*f**3*s**2 - 6140*D1*Ddd*f**3*s + 2510*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 16896*D1*Ddd*f**2*g2*r*s - 9504*D1*Ddd*f**2*g2*r + 11616*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 5544*D1*Ddd*f**2*g2 + 110*D1*b2*(bd1*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) - 6*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 22*D1*bd1*(120*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(-4*C*(79*r**2 + 2*r*(78*s - 73) + 77*s**2 - 144*s + 72) + 12*K*(3*r**2 + r*(s - 6) - 2*s**2 - s + 3) + 179*r**2 + 346*r*s - 284*r + 167*s**2 - 272*s + 130) + 2*f*(fd*(C*(388*r**2 + r*(768*s - 628) + 380*s**2 - 622*s + 242) + 6*K*(10*r**2 + 32*r*s - 18*r + 22*s**2 - 27*s + 8) - 266*r**2 - 496*r*s + 406*r - 230*s**2 + 379*s - 149) + 2*g2*(80*r**2 + 2*r*(86*s - 81) + 92*s**2 - 174*s + 87) - 2*gd2*(101*r**2 + r*(214*s - 238) + 113*s**2 - 250*s + 137)) - 4*fd*g2*(101*r**2 + 107*r*(2*s - 1) + s*(113*s - 113))) + 2*Dd*f*(f*(2*C*(388*r**2 + r*(768*s - 774) + 380*s**2 - 767*s + 362) + 6*K*(20*r**2 + 64*r*s - 38*r + 44*s**2 - 59*s + 18) - 532*r**2 - 992*r*s + 986*r - 460*s**2 + 923*s - 438) - 2*g2*(404*r**2 + r*(856*s - 857) + 452*s**2 - 899*s + 417))) + 7800*Dd**2*f**3*r**2 + 22320*Dd**2*f**3*r*s - 13380*Dd**2*f**3*r + 14520*Dd**2*f**3*s**2 - 18420*Dd**2*f**3*s + 5020*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 50688*Dd**2*f**2*g2*r*s - 28512*Dd**2*f**2*g2*r + 34848*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 11088*Dd**2*f**2*g2 + 55*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(-240*C*D1**2*fd*r**2 - 480*C*D1**2*fd*r*s + 480*C*D1**2*fd*r - 240*C*D1**2*fd*s**2 + 480*C*D1**2*fd*s - 240*C*D1**2*fd + 120*C*D1**2*fdd*r**2 + 240*C*D1**2*fdd*r*s - 240*C*D1**2*fdd*r + 120*C*D1**2*fdd*s**2 - 240*C*D1**2*fdd*s + 120*C*D1**2*fdd - 960*C*D1*Dd*f*r**2 - 1920*C*D1*Dd*f*r*s + 1440*C*D1*Dd*f*r - 960*C*D1*Dd*f*s**2 + 1440*C*D1*Dd*f*s - 720*C*D1*Dd*f + 960*C*D1*Dd*fd*r**2 + 1920*C*D1*Dd*fd*r*s - 1680*C*D1*Dd*fd*r + 960*C*D1*Dd*fd*s**2 - 1680*C*D1*Dd*fd*s + 720*C*D1*Dd*fd + 480*C*D1*Ddd*f*r**2 + 960*C*D1*Ddd*f*r*s - 720*C*D1*Ddd*f*r + 480*C*D1*Ddd*f*s**2 - 720*C*D1*Ddd*f*s + 360*C*D1*Ddd*f + 1440*C*Dd**2*f*r**2 + 2880*C*Dd**2*f*r*s - 2160*C*Dd**2*f*r + 1440*C*Dd**2*f*s**2 - 2160*C*Dd**2*f*s + 720*C*Dd**2*f + 320*D1**2*K*fd*r**2 + 688*D1**2*K*fd*r*s - 40*D1**2*K*fd*r + 368*D1**2*K*fd*s**2 - 40*D1**2*K*fd*s + 20*D1**2*K*fd - 202*D1**2*K*fdd*r**2 - 428*D1**2*K*fdd*r*s - 120*D1**2*K*fdd*r - 226*D1**2*K*fdd*s**2 - 120*D1**2*K*fdd*s + 60*D1**2*K*fdd - 5*D1**2*bdd1*(-14*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 156*D1**2*f*fd*r**2 - 216*D1**2*f*fd*r*s + 216*D1**2*f*fd*r - 60*D1**2*f*fd*s**2 + 168*D1**2*f*fd*s - 108*D1**2*f*fd + 180*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 180*D1**2*f*fdd*r + 84*D1**2*f*fdd*s**2 - 132*D1**2*f*fdd*s + 90*D1**2*f*fdd + 180*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 180*D1**2*fd**2*r + 84*D1**2*fd**2*s**2 - 132*D1**2*fd**2*s + 129*D1**2*fd*r**2 + 278*D1**2*fd*r*s - 290*D1**2*fd*r + 149*D1**2*fd*s**2 - 290*D1**2*fd*s + 145*D1**2*fd - 19*D1**2*fdd*r**2 - 62*D1**2*fdd*r*s + 180*D1**2*fdd*r - 43*D1**2*fdd*s**2 + 180*D1**2*fdd*s - 90*D1**2*fdd + 280*D1**2*gd2*r**2 + 560*D1**2*gd2*r*s - 560*D1**2*gd2*r + 280*D1**2*gd2*s**2 - 560*D1**2*gd2*s + 280*D1**2*gd2 - 140*D1**2*gdd2*r**2 - 280*D1**2*gdd2*r*s + 280*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 280*D1**2*gdd2*s - 140*D1**2*gdd2 + 1280*D1*Dd*K*f*r**2 + 2752*D1*Dd*K*f*r*s - 1968*D1*Dd*K*f*r + 1472*D1*Dd*K*f*s**2 - 2112*D1*Dd*K*f*s + 1008*D1*Dd*K*f - 1616*D1*Dd*K*fd*r**2 - 3424*D1*Dd*K*fd*r*s + 756*D1*Dd*K*fd*r - 1808*D1*Dd*K*fd*s**2 + 828*D1*Dd*K*fd*s + 360*D1*Dd*K*fd - 312*D1*Dd*f**2*r**2 - 432*D1*Dd*f**2*r*s + 420*D1*Dd*f**2*r - 120*D1*Dd*f**2*s**2 + 276*D1*Dd*f**2*s - 186*D1*Dd*f**2 + 1440*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 1704*D1*Dd*f*fd*r + 672*D1*Dd*f*fd*s**2 - 1224*D1*Dd*f*fd*s + 492*D1*Dd*f*fd + 516*D1*Dd*f*r**2 + 1112*D1*Dd*f*r*s - 794*D1*Dd*f*r + 596*D1*Dd*f*s**2 - 854*D1*Dd*f*s + 407*D1*Dd*f - 152*D1*Dd*fd*r**2 - 496*D1*Dd*fd*r*s + 858*D1*Dd*fd*r - 344*D1*Dd*fd*s**2 + 930*D1*Dd*fd*s - 540*D1*Dd*fd + 1120*D1*Dd*g2*r**2 + 2240*D1*Dd*g2*r*s - 1680*D1*Dd*g2*r + 1120*D1*Dd*g2*s**2 - 1680*D1*Dd*g2*s + 840*D1*Dd*g2 - 1120*D1*Dd*gd2*r**2 - 2240*D1*Dd*gd2*r*s + 1960*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1960*D1*Dd*gd2*s - 840*D1*Dd*gd2 - 808*D1*Ddd*K*f*r**2 - 1712*D1*Ddd*K*f*r*s + 1236*D1*Ddd*K*f*r - 904*D1*Ddd*K*f*s**2 + 1308*D1*Ddd*K*f*s - 630*D1*Ddd*K*f + 360*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 492*D1*Ddd*f**2*r + 168*D1*Ddd*f**2*s**2 - 348*D1*Ddd*f**2*s + 222*D1*Ddd*f**2 - 76*D1*Ddd*f*r**2 - 248*D1*Ddd*f*r*s + 138*D1*Ddd*f*r - 172*D1*Ddd*f*s**2 + 210*D1*Ddd*f*s - 81*D1*Ddd*f - 560*D1*Ddd*g2*r**2 - 1120*D1*Ddd*g2*r*s + 840*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 840*D1*Ddd*g2*s - 420*D1*Ddd*g2 + 10*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-14*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 2424*Dd**2*K*f*r**2 - 5136*Dd**2*K*f*r*s + 3708*Dd**2*K*f*r - 2712*Dd**2*K*f*s**2 + 3924*Dd**2*K*f*s - 1260*Dd**2*K*f + 1080*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 1476*Dd**2*f**2*r + 504*Dd**2*f**2*s**2 - 1044*Dd**2*f**2*s + 444*Dd**2*f**2 - 228*Dd**2*f*r**2 - 744*Dd**2*f*r*s + 414*Dd**2*f*r - 516*Dd**2*f*s**2 + 630*Dd**2*f*s - 162*Dd**2*f - 1680*Dd**2*g2*r**2 - 3360*Dd**2*g2*r*s + 2520*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2520*Dd**2*g2*s - 840*Dd**2*g2) - 11*b1*(-1264*C*D1**2*f*fd*r**2 - 2496*C*D1**2*f*fd*r*s + 1344*C*D1**2*f*fd*r - 1232*C*D1**2*f*fd*s**2 + 1328*C*D1**2*f*fd*s - 672*C*D1**2*f*fd + 776*C*D1**2*f*fdd*r**2 + 1536*C*D1**2*f*fdd*r*s - 576*C*D1**2*f*fdd*r + 760*C*D1**2*f*fdd*s**2 - 568*C*D1**2*f*fdd*s + 288*C*D1**2*f*fdd + 776*C*D1**2*fd**2*r**2 + 1536*C*D1**2*fd**2*r*s - 576*C*D1**2*fd**2*r + 760*C*D1**2*fd**2*s**2 - 568*C*D1**2*fd**2*s - 200*C*D1**2*fd**2 - 2528*C*D1*Dd*f**2*r**2 - 4992*C*D1*Dd*f**2*r*s + 3776*C*D1*Dd*f**2*r - 2464*C*D1*Dd*f**2*s**2 + 3728*C*D1*Dd*f**2*s - 1880*C*D1*Dd*f**2 + 6208*C*D1*Dd*f*fd*r**2 + 12288*C*D1*Dd*f*fd*r*s - 6944*C*D1*Dd*f*fd*r + 6080*C*D1*Dd*f*fd*s**2 - 6864*C*D1*Dd*f*fd*s + 1720*C*D1*Dd*f*fd + 1552*C*D1*Ddd*f**2*r**2 + 3072*C*D1*Ddd*f**2*r*s - 2320*C*D1*Ddd*f**2*r + 1520*C*D1*Ddd*f**2*s**2 - 2296*C*D1*Ddd*f**2*s + 1156*C*D1*Ddd*f**2 + 4656*C*Dd**2*f**2*r**2 + 9216*C*Dd**2*f**2*r*s - 6960*C*Dd**2*f**2*r + 4560*C*Dd**2*f**2*s**2 - 6888*C*Dd**2*f**2*s + 2312*C*Dd**2*f**2 + 144*D1**2*K*f*fd*r**2 + 48*D1**2*K*f*fd*r*s - 24*D1**2*K*f*fd*r - 96*D1**2*K*f*fd*s**2 + 96*D1**2*K*f*fd*s - 48*D1**2*K*f*fd + 120*D1**2*K*f*fdd*r**2 + 384*D1**2*K*f*fdd*r*s - 192*D1**2*K*f*fdd*r + 264*D1**2*K*f*fdd*s**2 - 264*D1**2*K*f*fdd*s + 132*D1**2*K*f*fdd + 120*D1**2*K*fd**2*r**2 + 384*D1**2*K*fd**2*r*s - 192*D1**2*K*fd**2*r + 264*D1**2*K*fd**2*s**2 - 264*D1**2*K*fd**2*s - 170*D1**2*b2*fd*r**2 - 340*D1**2*b2*fd*r*s - 170*D1**2*b2*fd*s**2 + 120*D1**2*b2*fdd*r**2 + 240*D1**2*b2*fdd*r*s + 120*D1**2*b2*fdd*s**2 + 10*D1**2*bd1**2*(-14*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2*D1**2*bdd1*(6*f**2*(15*r**2 + r*(22*s - 26) + 7*s**2 - 18*s + 11) + f*(60*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*K*(101*r**2 + 214*r*s - 238*r + 113*s**2 - 250*s + 122) - 19*r**2 - 62*r*s - 40*r - 43*s**2 - 16*s + 14) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 120*D1**2*bdd2*f*r**2 + 240*D1**2*bdd2*f*r*s - 240*D1**2*bdd2*f*r + 120*D1**2*bdd2*f*s**2 - 240*D1**2*bdd2*f*s + 120*D1**2*bdd2*f + 716*D1**2*f*fd*r**2 + 1384*D1**2*f*fd*r*s - 840*D1**2*f*fd*r + 668*D1**2*f*fd*s**2 - 816*D1**2*f*fd*s + 432*D1**2*f*fd - 532*D1**2*f*fdd*r**2 - 992*D1**2*f*fdd*r*s + 432*D1**2*f*fdd*r - 460*D1**2*f*fdd*s**2 + 396*D1**2*f*fdd*s - 216*D1**2*f*fdd + 640*D1**2*f*gd2*r**2 + 1376*D1**2*f*gd2*r*s - 1280*D1**2*f*gd2*r + 736*D1**2*f*gd2*s**2 - 1376*D1**2*f*gd2*s + 640*D1**2*f*gd2 - 404*D1**2*f*gdd2*r**2 - 856*D1**2*f*gdd2*r*s + 808*D1**2*f*gdd2*r - 452*D1**2*f*gdd2*s**2 + 856*D1**2*f*gdd2*s - 404*D1**2*f*gdd2 - 532*D1**2*fd**2*r**2 - 992*D1**2*fd**2*r*s + 432*D1**2*fd**2*r - 460*D1**2*fd**2*s**2 + 396*D1**2*fd**2*s + 100*D1**2*fd**2 + 640*D1**2*fd*g2*r**2 + 1376*D1**2*fd*g2*r*s - 80*D1**2*fd*g2*r + 736*D1**2*fd*g2*s**2 - 80*D1**2*fd*g2*s + 40*D1**2*fd*g2 - 808*D1**2*fd*gd2*r**2 - 1712*D1**2*fd*gd2*r*s + 568*D1**2*fd*gd2*r - 904*D1**2*fd*gd2*s**2 + 616*D1**2*fd*gd2*s + 240*D1**2*fd*gd2 - 404*D1**2*fdd*g2*r**2 - 856*D1**2*fdd*g2*r*s - 240*D1**2*fdd*g2*r - 452*D1**2*fdd*g2*s**2 - 240*D1**2*fdd*g2*s + 120*D1**2*fdd*g2 + 288*D1*Dd*K*f**2*r**2 + 96*D1*Dd*K*f**2*r*s - 312*D1*Dd*K*f**2*r - 192*D1*Dd*K*f**2*s**2 + 48*D1*Dd*K*f**2*s + 96*D1*Dd*K*f**2 + 960*D1*Dd*K*f*fd*r**2 + 3072*D1*Dd*K*f*fd*r*s - 1632*D1*Dd*K*f*fd*r + 2112*D1*Dd*K*f*fd*s**2 - 2352*D1*Dd*K*f*fd*s + 648*D1*Dd*K*f*fd - 680*D1*Dd*b2*f*r**2 - 1360*D1*Dd*b2*f*r*s + 1020*D1*Dd*b2*f*r - 680*D1*Dd*b2*f*s**2 + 1020*D1*Dd*b2*f*s - 510*D1*Dd*b2*f + 960*D1*Dd*b2*fd*r**2 + 1920*D1*Dd*b2*fd*r*s - 720*D1*Dd*b2*fd*r + 960*D1*Dd*b2*fd*s**2 - 720*D1*Dd*b2*fd*s + 1432*D1*Dd*f**2*r**2 + 2768*D1*Dd*f**2*r*s - 2124*D1*Dd*f**2*r + 1336*D1*Dd*f**2*s**2 - 2052*D1*Dd*f**2*s + 1050*D1*Dd*f**2 - 4256*D1*Dd*f*fd*r**2 - 7936*D1*Dd*f*fd*r*s + 4848*D1*Dd*f*fd*r - 3680*D1*Dd*f*fd*s**2 + 4488*D1*Dd*f*fd*s - 1260*D1*Dd*f*fd + 2560*D1*Dd*f*g2*r**2 + 5504*D1*Dd*f*g2*r*s - 3936*D1*Dd*f*g2*r + 2944*D1*Dd*f*g2*s**2 - 4224*D1*Dd*f*g2*s + 2016*D1*Dd*f*g2 - 3232*D1*Dd*f*gd2*r**2 - 6848*D1*Dd*f*gd2*r*s + 5704*D1*Dd*f*gd2*r - 3616*D1*Dd*f*gd2*s**2 + 6040*D1*Dd*f*gd2*s - 2472*D1*Dd*f*gd2 - 3232*D1*Dd*fd*g2*r**2 - 6848*D1*Dd*fd*g2*r*s + 1512*D1*Dd*fd*g2*r - 3616*D1*Dd*fd*g2*s**2 + 1656*D1*Dd*fd*g2*s + 720*D1*Dd*fd*g2 + 240*D1*Ddd*K*f**2*r**2 + 768*D1*Ddd*K*f**2*r*s - 432*D1*Ddd*K*f**2*r + 528*D1*Ddd*K*f**2*s**2 - 648*D1*Ddd*K*f**2*s + 252*D1*Ddd*K*f**2 + 480*D1*Ddd*b2*f*r**2 + 960*D1*Ddd*b2*f*r*s - 720*D1*Ddd*b2*f*r + 480*D1*Ddd*b2*f*s**2 - 720*D1*Ddd*b2*f*s + 360*D1*Ddd*b2*f - 1064*D1*Ddd*f**2*r**2 - 1984*D1*Ddd*f**2*r*s + 1560*D1*Ddd*f**2*r - 920*D1*Ddd*f**2*s**2 + 1452*D1*Ddd*f**2*s - 762*D1*Ddd*f**2 - 1616*D1*Ddd*f*g2*r**2 - 3424*D1*Ddd*f*g2*r*s + 2472*D1*Ddd*f*g2*r - 1808*D1*Ddd*f*g2*s**2 + 2616*D1*Ddd*f*g2*s - 1260*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(26*r**2 + r*(36*s - 34) + 10*s**2 - 18*s + 13) + f*(240*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 640*K*r**2 - 1376*K*r*s + 1288*K*r - 736*K*s**2 + 1384*K*s - 668*K - 24*fd*(30*r**2 + 44*r*s - 41*r + 14*s**2 - 29*s + 13) - 258*r**2 - 556*r*s + 246*r - 298*s**2 + 286*s - 133) - 4*fd*(60*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 2*K*(101*r**2 + 214*r*s - 89*r + 113*s**2 - 95*s - 15) - 19*r**2 - 62*r*s + 70*r - 43*s**2 + 82*s - 45) - 280*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 280*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(6*f**2*(60*r**2 + r*(88*s - 93) + 28*s**2 - 65*s + 35) + f*(60*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 2*K*(404*r**2 + 856*r*s - 785*r + 452*s**2 - 827*s + 363) - 76*r**2 - 248*r*s - 11*r - 172*s**2 + 73*s + 48) - 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 10*D1*bd2*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) + 720*Dd**2*K*f**2*r**2 + 2304*Dd**2*K*f**2*r*s - 1296*Dd**2*K*f**2*r + 1584*Dd**2*K*f**2*s**2 - 1944*Dd**2*K*f**2*s + 504*Dd**2*K*f**2 + 1440*Dd**2*b2*f*r**2 + 2880*Dd**2*b2*f*r*s - 2160*Dd**2*b2*f*r + 1440*Dd**2*b2*f*s**2 - 2160*Dd**2*b2*f*s + 720*Dd**2*b2*f - 3192*Dd**2*f**2*r**2 - 5952*Dd**2*f**2*r*s + 4680*Dd**2*f**2*r - 2760*Dd**2*f**2*s**2 + 4356*Dd**2*f**2*s - 1524*Dd**2*f**2 - 4848*Dd**2*f*g2*r**2 - 10272*Dd**2*f*g2*r*s + 7416*Dd**2*f*g2*r - 5424*Dd**2*f*g2*s**2 + 7848*Dd**2*f*g2*s - 2520*Dd**2*f*g2))/(231*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**3*k1*k2*st**2*(792*C*D1**2*bdd1*f**2*r**2 - 792*C*D1**2*bdd1*f**2*r*s - 1584*C*D1**2*bdd1*f**2*s**2 - 15624*C*D1**2*f**2*fd*r*s + 5208*C*D1**2*f**2*fd*r - 15624*C*D1**2*f**2*fd*s**2 + 15624*C*D1**2*f**2*fd*s - 5208*C*D1**2*f**2*fd + 9000*C*D1**2*f**2*fdd*r*s - 3000*C*D1**2*f**2*fdd*r + 9000*C*D1**2*f**2*fdd*s**2 - 9000*C*D1**2*f**2*fdd*s + 3000*C*D1**2*f**2*fdd + 18000*C*D1**2*f*fd**2*r*s - 6000*C*D1**2*f*fd**2*r + 18000*C*D1**2*f*fd**2*s**2 - 18000*C*D1**2*f*fd**2*s + 3000*C*D1**2*f*fd**2 - 20832*C*D1*Dd*f**3*r*s + 5208*C*D1*Dd*f**3*r - 20832*C*D1*Dd*f**3*s**2 + 20832*C*D1*Dd*f**3*s - 5208*C*D1*Dd*f**3 + 72000*C*D1*Dd*f**2*fd*r*s - 21000*C*D1*Dd*f**2*fd*r + 72000*C*D1*Dd*f**2*fd*s**2 - 72000*C*D1*Dd*f**2*fd*s + 15000*C*D1*Dd*f**2*fd + 12000*C*D1*Ddd*f**3*r*s - 3000*C*D1*Ddd*f**3*r + 12000*C*D1*Ddd*f**3*s**2 - 12000*C*D1*Ddd*f**3*s + 3000*C*D1*Ddd*f**3 + 36000*C*Dd**2*f**3*r*s - 9000*C*Dd**2*f**3*r + 36000*C*Dd**2*f**3*s**2 - 36000*C*Dd**2*f**3*s + 6000*C*Dd**2*f**3 + 1980*D1**2*K*bdd1*f**2*r*s + 1980*D1**2*K*bdd1*f**2*s**2 - 1980*D1**2*K*bdd1*f**2*s - 7128*D1**2*b2*f*fd*r*s + 3564*D1**2*b2*f*fd*r - 7128*D1**2*b2*f*fd*s**2 + 7128*D1**2*b2*f*fd*s - 3564*D1**2*b2*f*fd + 3960*D1**2*b2*f*fdd*r*s - 1980*D1**2*b2*f*fdd*r + 3960*D1**2*b2*f*fdd*s**2 - 3960*D1**2*b2*f*fdd*s + 1980*D1**2*b2*f*fdd + 3960*D1**2*b2*fd**2*r*s - 1980*D1**2*b2*fd**2*r + 3960*D1**2*b2*fd**2*s**2 - 3960*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*f*(24*K*s**2 - 6*K*s + 5*f*(r**2 + r*(2*s - 3) + s**2 - 5*s + 2) + 3*r**2*(5 - 4*K) + 3*r*(4*K*(s + 1) + 6*s - 7) + 3*s**2 - 21*s + 6) - 3564*D1**2*bd2*f**2*r*s - 3564*D1**2*bd2*f**2*s**2 + 3564*D1**2*bd2*f**2*s + 7920*D1**2*bd2*f*fd*r*s - 1980*D1**2*bd2*f*fd*r + 7920*D1**2*bd2*f*fd*s**2 - 7920*D1**2*bd2*f*fd*s + 1980*D1**2*bd2*f*fd + 2475*D1**2*bdd1*f**3*r**2 + 4290*D1**2*bdd1*f**3*r*s - 3630*D1**2*bdd1*f**3*r + 1815*D1**2*bdd1*f**3*s**2 - 3630*D1**2*bdd1*f**3*s + 1815*D1**2*bdd1*f**3 + 594*D1**2*bdd1*f**2*r**2 + 2508*D1**2*bdd1*f**2*r*s - 2574*D1**2*bdd1*f**2*r + 1914*D1**2*bdd1*f**2*s**2 - 1914*D1**2*bdd1*f**2*s + 1089*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r**2 + 792*D1**2*bdd1*f*g2*r*s + 1584*D1**2*bdd1*f*g2*s**2 + 1980*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*s**2 - 1980*D1**2*bdd2*f**2*s - 5337*D1**2*f**2*fd*r**2 - 2886*D1**2*f**2*fd*r*s + 4520*D1**2*f**2*fd*r + 2451*D1**2*f**2*fd*s**2 - 672*D1**2*f**2*fd*s - 962*D1**2*f**2*fd + 4599*D1**2*f**2*fdd*r**2 + 3522*D1**2*f**2*fdd*r*s - 4240*D1**2*f**2*fdd*r - 1077*D1**2*f**2*fdd*s**2 - 456*D1**2*f**2*fdd*s + 1174*D1**2*f**2*fdd + 7128*D1**2*f**2*gd2*r*s + 7128*D1**2*f**2*gd2*s**2 - 7128*D1**2*f**2*gd2*s - 3960*D1**2*f**2*gdd2*r*s - 3960*D1**2*f**2*gdd2*s**2 + 3960*D1**2*f**2*gdd2*s + 9198*D1**2*f*fd**2*r**2 + 7044*D1**2*f*fd**2*r*s - 8480*D1**2*f*fd**2*r - 2154*D1**2*f*fd**2*s**2 - 912*D1**2*f*fd**2*s + 1174*D1**2*f*fd**2 + 14256*D1**2*f*fd*g2*r*s - 7128*D1**2*f*fd*g2*r + 14256*D1**2*f*fd*g2*s**2 - 14256*D1**2*f*fd*g2*s + 7128*D1**2*f*fd*g2 - 15840*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r - 15840*D1**2*f*fd*gd2*s**2 + 15840*D1**2*f*fd*gd2*s - 3960*D1**2*f*fd*gd2 - 7920*D1**2*f*fdd*g2*r*s + 3960*D1**2*f*fdd*g2*r - 7920*D1**2*f*fdd*g2*s**2 + 7920*D1**2*f*fdd*g2*s - 3960*D1**2*f*fdd*g2 - 7920*D1**2*fd**2*g2*r*s + 3960*D1**2*fd**2*g2*r - 7920*D1**2*fd**2*g2*s**2 + 7920*D1**2*fd**2*g2*s - 14256*D1*Dd*b2*f**2*r*s + 3564*D1*Dd*b2*f**2*r - 14256*D1*Dd*b2*f**2*s**2 + 14256*D1*Dd*b2*f**2*s - 3564*D1*Dd*b2*f**2 + 31680*D1*Dd*b2*f*fd*r*s - 11880*D1*Dd*b2*f*fd*r + 31680*D1*Dd*b2*f*fd*s**2 - 31680*D1*Dd*b2*f*fd*s + 7920*D1*Dd*b2*f*fd + 15840*D1*Dd*bd2*f**2*r*s - 1980*D1*Dd*bd2*f**2*r + 15840*D1*Dd*bd2*f**2*s**2 - 15840*D1*Dd*bd2*f**2*s + 1980*D1*Dd*bd2*f**2 - 7116*D1*Dd*f**3*r**2 - 3848*D1*Dd*f**3*r*s + 8078*D1*Dd*f**3*r + 3268*D1*Dd*f**3*s**2 + 290*D1*Dd*f**3*s - 2741*D1*Dd*f**3 + 36792*D1*Dd*f**2*fd*r**2 + 28176*D1*Dd*f**2*fd*r*s - 38878*D1*Dd*f**2*fd*r - 8616*D1*Dd*f**2*fd*s**2 - 6714*D1*Dd*f**2*fd*s + 8936*D1*Dd*f**2*fd + 28512*D1*Dd*f**2*g2*r*s - 7128*D1*Dd*f**2*g2*r + 28512*D1*Dd*f**2*g2*s**2 - 28512*D1*Dd*f**2*g2*s + 7128*D1*Dd*f**2*g2 - 31680*D1*Dd*f**2*gd2*r*s + 3960*D1*Dd*f**2*gd2*r - 31680*D1*Dd*f**2*gd2*s**2 + 31680*D1*Dd*f**2*gd2*s - 3960*D1*Dd*f**2*gd2 - 63360*D1*Dd*f*fd*g2*r*s + 23760*D1*Dd*f*fd*g2*r - 63360*D1*Dd*f*fd*g2*s**2 + 63360*D1*Dd*f*fd*g2*s - 15840*D1*Dd*f*fd*g2 + 7920*D1*Ddd*b2*f**2*r*s - 1980*D1*Ddd*b2*f**2*r + 7920*D1*Ddd*b2*f**2*s**2 - 7920*D1*Ddd*b2*f**2*s + 1980*D1*Ddd*b2*f**2 + 6132*D1*Ddd*f**3*r**2 + 4696*D1*Ddd*f**3*r*s - 7306*D1*Ddd*f**3*r - 1436*D1*Ddd*f**3*s**2 - 1630*D1*Ddd*f**3*s + 2707*D1*Ddd*f**3 - 15840*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r - 15840*D1*Ddd*f**2*g2*s**2 + 15840*D1*Ddd*f**2*g2*s - 3960*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(13*r**2 + 6*r*(5*s - 3) + 17*s**2 - 26*s + 9) + f**2*(-96*C*s**2 + 108*K*s**2 - 108*K*s - 10*fd*(45*r**2 + 13*r*(6*s - 5) + 33*s**2 - 59*s + 22) + r**2*(40*C + 17) - 2*r*(s*(28*C - 54*K - 59) + 51) + 101*s**2 - 74*s + 39) - 2*f*(fd*(-96*C*s**2 + 60*C*s + 30*K*(r*(4*s - 1) + (1 - 2*s)**2) + r**2*(48*C + 36) - r*(48*C*s + 12*C - 152*s + 95) + 116*s**2 - 125*s + 35) + 24*g2*(r**2 - r*s - 2*s**2) + 12*gd2*(-2*r**2 + 2*r*(s + 1) + s*(4*s - 1))) + 24*fd*g2*(2*r**2 - 2*r*s + r - s*(4*s - 4))) - 2*Dd*f*(5*f**2*(60*r**2 + r*(104*s - 87) + 44*s**2 - 81*s + 33) + f*(-192*C*s**2 + 72*C*s + 30*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + r**2*(96*C + 72) - 2*r*(6*C*(8*s + 3) - 152*s + 115) + 232*s**2 - 250*s + 107) + 12*g2*(-8*r**2 + r*(8*s + 3) + 2*s*(8*s - 3)))) + 23760*Dd**2*b2*f**2*r*s - 5940*Dd**2*b2*f**2*r + 23760*Dd**2*b2*f**2*s**2 - 23760*Dd**2*b2*f**2*s + 3960*Dd**2*b2*f**2 + 18396*Dd**2*f**3*r**2 + 14088*Dd**2*f**3*r*s - 21918*Dd**2*f**3*r - 4308*Dd**2*f**3*s**2 - 4890*Dd**2*f**3*s + 5414*Dd**2*f**3 - 47520*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r - 47520*Dd**2*f**2*g2*s**2 + 47520*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 + 33*b1**2*(-D1**2*(10*fd**2*(r**2 + 2*r*s + s**2 + 2*s - 1) - 2*fd*(-12*K*(r**2 - r*s + r - 2*(s - 1)**2) + 10*f*(r**2 + 2*r*s + s**2 + 2*s - 1) + 15*r**2 + 18*r*s - 6*r + 3*s**2 + 18*s - 9) + fdd*(-12*K*(r**2 - r*s + r - 2*(s - 1)**2) + 10*f*(r**2 + 2*r*s + s**2 + 2*s - 1) + 15*r**2 + 18*r*s - 6*r + 3*s**2 + 18*s - 9)) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(96*K*s**2 - 72*K*s - 10*fd*(4*r**2 + r*(8*s - 3) + 4*s**2 + s - 1) + r**2*(60 - 48*K) + 6*r*(8*K*s + 6*K + 12*s - 13) + 12*s**2 - 42*s + 33) + 3*fd*(2*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) - 20*r**2 + r*(17 - 24*s) - 4*s**2 - 5*s + 1)) - Ddd*f*(96*K*s**2 - 72*K*s + 5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + r**2*(60 - 48*K) + 6*r*(8*K*s + 6*K + 12*s - 13) + 12*s**2 - 42*s + 33)) - 6*Dd**2*f*(48*K*s**2 - 36*K*s + 5*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - r**2*(24*K - 30) + 3*r*(8*K*s + 6*K + 12*s - 13) + 6*s**2 - 21*s + 11)) + 33*b1*(-80*C*D1**2*f*fd*r**2 + 112*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r + 192*C*D1**2*f*fd*s**2 - 248*C*D1**2*f*fd*s + 56*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r - 96*C*D1**2*f*fdd*s**2 + 120*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r - 96*C*D1**2*fd**2*s**2 + 120*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 160*C*D1*Dd*f**2*r**2 + 224*C*D1*Dd*f**2*r*s + 104*C*D1*Dd*f**2*r + 384*C*D1*Dd*f**2*s**2 - 304*C*D1*Dd*f**2*s + 16*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r - 768*C*D1*Dd*f*fd*s**2 + 768*C*D1*Dd*f*fd*s - 72*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r - 192*C*D1*Ddd*f**2*s**2 + 144*C*D1*Ddd*f**2*s + 288*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r - 576*C*Dd**2*f**2*s**2 + 432*C*Dd**2*f**2*s - 216*D1**2*K*f*fd*r*s + 108*D1**2*K*f*fd*r - 216*D1**2*K*f*fd*s**2 + 216*D1**2*K*f*fd*s - 108*D1**2*K*f*fd + 120*D1**2*K*f*fdd*r*s - 60*D1**2*K*f*fdd*r + 120*D1**2*K*f*fdd*s**2 - 120*D1**2*K*f*fdd*s + 60*D1**2*K*f*fdd + 120*D1**2*K*fd**2*r*s - 60*D1**2*K*fd**2*r + 120*D1**2*K*fd**2*s**2 - 120*D1**2*K*fd**2*s - D1**2*bdd1*f*(-12*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) + 5*f*(2*r**2 + r*(4*s - 6) + 2*s**2 - 10*s + 5) + 30*r**2 + 36*r*s - 42*r + 6*s**2 - 42*s + 27) - 195*D1**2*f**2*fd*r**2 - 450*D1**2*f**2*fd*r*s + 320*D1**2*f**2*fd*r - 255*D1**2*f**2*fd*s**2 + 340*D1**2*f**2*fd*s - 170*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 390*D1**2*f**2*fdd*r*s - 320*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 260*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd + 450*D1**2*f*fd**2*r**2 + 780*D1**2*f*fd**2*r*s - 640*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 520*D1**2*f*fd**2*s + 190*D1**2*f*fd**2 - 34*D1**2*f*fd*r**2 - 236*D1**2*f*fd*r*s + 50*D1**2*f*fd*r - 202*D1**2*f*fd*s**2 + 246*D1**2*f*fd*s - 79*D1**2*f*fd + 36*D1**2*f*fdd*r**2 + 152*D1**2*f*fdd*r*s - 34*D1**2*f*fdd*r + 116*D1**2*f*fdd*s**2 - 134*D1**2*f*fdd*s + 43*D1**2*f*fdd + 48*D1**2*f*gd2*r**2 - 48*D1**2*f*gd2*r*s - 96*D1**2*f*gd2*r - 96*D1**2*f*gd2*s**2 + 48*D1**2*f*gd2*s + 48*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 + 24*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r + 48*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 + 36*D1**2*fd**2*r**2 + 152*D1**2*fd**2*r*s - 34*D1**2*fd**2*r + 116*D1**2*fd**2*s**2 - 134*D1**2*fd**2*s + 6*D1**2*fd**2 + 48*D1**2*fd*g2*r**2 - 48*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*r - 96*D1**2*fd*g2*s**2 + 192*D1**2*fd*g2*s - 96*D1**2*fd*g2 - 48*D1**2*fd*gd2*r**2 + 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r + 96*D1**2*fd*gd2*s**2 - 120*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r**2 + 24*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r + 48*D1**2*fdd*g2*s**2 - 96*D1**2*fdd*g2*s + 48*D1**2*fdd*g2 - 432*D1*Dd*K*f**2*r*s + 108*D1*Dd*K*f**2*r - 432*D1*Dd*K*f**2*s**2 + 432*D1*Dd*K*f**2*s - 108*D1*Dd*K*f**2 + 960*D1*Dd*K*f*fd*r*s - 360*D1*Dd*K*f*fd*r + 960*D1*Dd*K*f*fd*s**2 - 960*D1*Dd*K*f*fd*s + 240*D1*Dd*K*f*fd - 260*D1*Dd*f**3*r**2 - 600*D1*Dd*f**3*r*s + 410*D1*Dd*f**3*r - 340*D1*Dd*f**3*s**2 + 470*D1*Dd*f**3*s - 215*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 3120*D1*Dd*f**2*fd*r*s - 2570*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 2150*D1*Dd*f**2*fd*s + 900*D1*Dd*f**2*fd - 68*D1*Dd*f**2*r**2 - 472*D1*Dd*f**2*r*s + 186*D1*Dd*f**2*r - 404*D1*Dd*f**2*s**2 + 438*D1*Dd*f**2*s - 135*D1*Dd*f**2 + 288*D1*Dd*f*fd*r**2 + 1216*D1*Dd*f*fd*r*s - 432*D1*Dd*f*fd*r + 928*D1*Dd*f*fd*s**2 - 1072*D1*Dd*f*fd*s + 202*D1*Dd*f*fd + 192*D1*Dd*f*g2*r**2 - 192*D1*Dd*f*g2*r*s - 144*D1*Dd*f*g2*r - 384*D1*Dd*f*g2*s**2 + 288*D1*Dd*f*g2*s - 192*D1*Dd*f*gd2*r**2 + 192*D1*Dd*f*gd2*r*s + 264*D1*Dd*f*gd2*r + 384*D1*Dd*f*gd2*s**2 - 240*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 + 192*D1*Dd*fd*g2*r*s - 24*D1*Dd*fd*g2*r + 384*D1*Dd*fd*g2*s**2 - 528*D1*Dd*fd*g2*s + 144*D1*Dd*fd*g2 + 240*D1*Ddd*K*f**2*r*s - 60*D1*Ddd*K*f**2*r + 240*D1*Ddd*K*f**2*s**2 - 240*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 + 300*D1*Ddd*f**3*r**2 + 520*D1*Ddd*f**3*r*s - 430*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 370*D1*Ddd*f**3*s + 205*D1*Ddd*f**3 + 72*D1*Ddd*f**2*r**2 + 304*D1*Ddd*f**2*r*s - 148*D1*Ddd*f**2*r + 232*D1*Ddd*f**2*s**2 - 268*D1*Ddd*f**2*s + 94*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 + 96*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r + 192*D1*Ddd*f*g2*s**2 - 144*D1*Ddd*f*g2*s + 2*D1*bd1*(5*D1*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 10*s + 5) + D1*f*(-12*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) - 10*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 30*r**2 + 36*r*s - 42*r + 6*s**2 - 42*s + 27) + 3*D1*fd*(2*K*(4*r**2 - 4*r*s - 8*s**2 + 9*s - 1) - 10*r**2 - 12*r*s + 9*r - 2*s**2 + s - 1) - 5*Dd*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 26*s + 11) + 3*Dd*f*(K*(32*r**2 - 4*r*(8*s + 7) - 64*s**2 + 32*s + 6) - 40*r**2 - 48*r*s + 54*r - 8*s**2 + 42*s - 21)) + 720*Dd**2*K*f**2*r*s - 180*Dd**2*K*f**2*r + 720*Dd**2*K*f**2*s**2 - 720*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 + 900*Dd**2*f**3*r**2 + 1560*Dd**2*f**3*r*s - 1290*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 1110*Dd**2*f**3*s + 410*Dd**2*f**3 + 216*Dd**2*f**2*r**2 + 912*Dd**2*f**2*r*s - 444*Dd**2*f**2*r + 696*Dd**2*f**2*s**2 - 804*Dd**2*f**2*s + 188*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 + 288*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r + 576*Dd**2*f*g2*s**2 - 432*Dd**2*f*g2*s))/(693*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**3*k1*k2*(1100*C*D1**2*bdd1*f**2*r**2 + 3080*C*D1**2*bdd1*f**2*r*s + 1980*C*D1**2*bdd1*f**2*s**2 + 3180*C*D1**2*f**2*fd*r**2 + 11760*C*D1**2*f**2*fd*r*s - 6040*C*D1**2*f**2*fd*r + 8580*C*D1**2*f**2*fd*s**2 - 9640*C*D1**2*f**2*fd*s + 3920*C*D1**2*f**2*fd - 3900*C*D1**2*f**2*fdd*r**2 - 11160*C*D1**2*f**2*fdd*r*s + 6320*C*D1**2*f**2*fdd*r - 7260*C*D1**2*f**2*fdd*s**2 + 8560*C*D1**2*f**2*fdd*s - 3720*C*D1**2*f**2*fdd - 7800*C*D1**2*f*fd**2*r**2 - 22320*C*D1**2*f*fd**2*r*s + 12640*C*D1**2*f*fd**2*r - 14520*C*D1**2*f*fd**2*s**2 + 17120*C*D1**2*f*fd**2*s - 3720*C*D1**2*f*fd**2 + 4240*C*D1*Dd*f**3*r**2 + 15680*C*D1*Dd*f**3*r*s - 8160*C*D1*Dd*f**3*r + 11440*C*D1*Dd*f**3*s**2 - 13560*C*D1*Dd*f**3*s + 4980*C*D1*Dd*f**3 - 31200*C*D1*Dd*f**2*fd*r**2 - 89280*C*D1*Dd*f**2*fd*r*s + 52040*C*D1*Dd*f**2*fd*r - 58080*C*D1*Dd*f**2*fd*s**2 + 71080*C*D1*Dd*f**2*fd*s - 21200*C*D1*Dd*f**2*fd - 5200*C*D1*Ddd*f**3*r**2 - 14880*C*D1*Ddd*f**3*r*s + 8920*C*D1*Ddd*f**3*r - 9680*C*D1*Ddd*f**3*s**2 + 12280*C*D1*Ddd*f**3*s - 5020*C*D1*Ddd*f**3 - 15600*C*Dd**2*f**3*r**2 - 44640*C*Dd**2*f**3*r*s + 26760*C*Dd**2*f**3*r - 29040*C*Dd**2*f**3*s**2 + 36840*C*Dd**2*f**3*s - 10040*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r**2 - 2112*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 1452*D1**2*K*bdd1*f**2*s**2 + 2112*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 + 132*D1**2*b2*bdd1*f*r**2 + 264*D1**2*b2*bdd1*f*r*s + 132*D1**2*b2*bdd1*f*s**2 + 792*D1**2*b2*f*fd*r**2 + 4224*D1**2*b2*f*fd*r*s - 2112*D1**2*b2*f*fd*r + 3432*D1**2*b2*f*fd*s**2 - 3432*D1**2*b2*f*fd*s + 1716*D1**2*b2*f*fd - 1320*D1**2*b2*f*fdd*r**2 - 4224*D1**2*b2*f*fdd*r*s + 2112*D1**2*b2*f*fdd*r - 2904*D1**2*b2*f*fdd*s**2 + 2904*D1**2*b2*f*fdd*s - 1452*D1**2*b2*f*fdd - 1320*D1**2*b2*fd**2*r**2 - 4224*D1**2*b2*fd**2*r*s + 2112*D1**2*b2*fd**2*r - 2904*D1**2*b2*fd**2*s**2 + 2904*D1**2*b2*fd**2*s + 22*D1**2*bd1**2*(6*f**2*(8*r**2 + r*(8*s - 15) - 9*s + 9) + f*(r**2*(56*C + 50*K - 10) + r*(28*C*(2*s - 1) + 156*K*s - 50*K - 16*s - 77) + s**2*(106*K - 6) - s*(78*K + 67) + 59) - 28*g2*r*(2*r + 2*s - 1)) + 22*D1**2*bdd1*f**2*r**2 - 968*D1**2*bdd1*f**2*r*s - 1232*D1**2*bdd1*f**2*r - 990*D1**2*bdd1*f**2*s**2 - 880*D1**2*bdd1*f**2*s + 440*D1**2*bdd1*f**2 - 1100*D1**2*bdd1*f*g2*r**2 - 3432*D1**2*bdd1*f*g2*r*s - 2332*D1**2*bdd1*f*g2*s**2 - 660*D1**2*bdd2*f**2*r**2 - 2112*D1**2*bdd2*f**2*r*s + 1320*D1**2*bdd2*f**2*r - 1452*D1**2*bdd2*f**2*s**2 + 2112*D1**2*bdd2*f**2*s - 660*D1**2*bdd2*f**2 - 930*D1**2*f**2*fd*r**2 - 5220*D1**2*f**2*fd*r*s + 2360*D1**2*f**2*fd*r - 4290*D1**2*f**2*fd*s**2 + 4600*D1**2*f**2*fd*s - 1740*D1**2*f**2*fd + 1950*D1**2*f**2*fdd*r**2 + 5580*D1**2*f**2*fdd*r*s - 3160*D1**2*f**2*fdd*r + 3630*D1**2*f**2*fdd*s**2 - 4280*D1**2*f**2*fdd*s + 1860*D1**2*f**2*fdd - 792*D1**2*f**2*gd2*r**2 - 4224*D1**2*f**2*gd2*r*s + 1584*D1**2*f**2*gd2*r - 3432*D1**2*f**2*gd2*s**2 + 4224*D1**2*f**2*gd2*s - 792*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 4224*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 2904*D1**2*f**2*gdd2*s**2 - 4224*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 3900*D1**2*f*fd**2*r**2 + 11160*D1**2*f*fd**2*r*s - 6320*D1**2*f*fd**2*r + 7260*D1**2*f*fd**2*s**2 - 8560*D1**2*f*fd**2*s + 1860*D1**2*f*fd**2 - 1584*D1**2*f*fd*g2*r**2 - 8448*D1**2*f*fd*g2*r*s + 4224*D1**2*f*fd*g2*r - 6864*D1**2*f*fd*g2*s**2 + 6864*D1**2*f*fd*g2*s - 3432*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 16896*D1**2*f*fd*gd2*r*s - 9504*D1**2*f*fd*gd2*r + 11616*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4224*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 8448*D1**2*f*fdd*g2*r*s - 4224*D1**2*f*fdd*g2*r + 5808*D1**2*f*fdd*g2*s**2 - 5808*D1**2*f*fdd*g2*s + 2904*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 8448*D1**2*fd**2*g2*r*s - 4224*D1**2*fd**2*g2*r + 5808*D1**2*fd**2*g2*s**2 - 5808*D1**2*fd**2*g2*s + 1584*D1*Dd*b2*f**2*r**2 + 8448*D1*Dd*b2*f**2*r*s - 3696*D1*Dd*b2*f**2*r + 6864*D1*Dd*b2*f**2*s**2 - 7656*D1*Dd*b2*f**2*s + 2508*D1*Dd*b2*f**2 - 10560*D1*Dd*b2*f*fd*r**2 - 33792*D1*Dd*b2*f*fd*r*s + 17952*D1*Dd*b2*f*fd*r - 23232*D1*Dd*b2*f*fd*s**2 + 25872*D1*Dd*b2*f*fd*s - 7128*D1*Dd*b2*f*fd - 1240*D1*Dd*f**3*r**2 - 6960*D1*Dd*f**3*r*s + 2980*D1*Dd*f**3*r - 5720*D1*Dd*f**3*s**2 + 6340*D1*Dd*f**3*s - 2050*D1*Dd*f**3 + 15600*D1*Dd*f**2*fd*r**2 + 44640*D1*Dd*f**2*fd*r*s - 26020*D1*Dd*f**2*fd*r + 29040*D1*Dd*f**2*fd*s**2 - 35540*D1*Dd*f**2*fd*s + 10600*D1*Dd*f**2*fd - 3168*D1*Dd*f**2*g2*r**2 - 16896*D1*Dd*f**2*g2*r*s + 7392*D1*Dd*f**2*g2*r - 13728*D1*Dd*f**2*g2*s**2 + 15312*D1*Dd*f**2*g2*s - 5016*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 33792*D1*Dd*f**2*gd2*r*s - 20064*D1*Dd*f**2*gd2*r + 23232*D1*Dd*f**2*gd2*s**2 - 31152*D1*Dd*f**2*gd2*s + 9504*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 67584*D1*Dd*f*fd*g2*r*s - 35904*D1*Dd*f*fd*g2*r + 46464*D1*Dd*f*fd*g2*s**2 - 51744*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 - 2640*D1*Ddd*b2*f**2*r**2 - 8448*D1*Ddd*b2*f**2*r*s + 4752*D1*Ddd*b2*f**2*r - 5808*D1*Ddd*b2*f**2*s**2 + 7128*D1*Ddd*b2*f**2*s - 2772*D1*Ddd*b2*f**2 + 2600*D1*Ddd*f**3*r**2 + 7440*D1*Ddd*f**3*r*s - 4460*D1*Ddd*f**3*r + 4840*D1*Ddd*f**3*s**2 - 6140*D1*Ddd*f**3*s + 2510*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 16896*D1*Ddd*f**2*g2*r*s - 9504*D1*Ddd*f**2*g2*r + 11616*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 5544*D1*Ddd*f**2*g2 + 22*D1*bd1*(D1*(f**2*(-108*C*s**2 + 6*K*(3*r**2 + 2*r*(8*s - 3) + 13*s**2 - 16*s + 3) - r**2*(4*C + 41) + r*(-112*C*s + 10*s + 46) + 51*s**2 + 38*s - 13) - f*(5*b2*r**2 + 10*b2*r*s + 5*b2*s**2 - 12*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*fd*(-180*C*s**2 + 160*C*s + 6*K*(10*r**2 + 2*r*(16*s - 9) + 22*s**2 - 27*s + 8) - r**2*(100*C + 2) + r*(-40*C*(7*s - 3) + 88*s + 7) + 90*s**2 - 47*s - 28) + 12*g2*r**2 - 116*g2*r*s - 128*g2*s**2 + 100*gd2*r**2 + 312*gd2*r*s - 100*gd2*r + 212*gd2*s**2 - 156*gd2*s) + 4*fd*(3*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) + g2*(-25*r**2 + r*(39 - 78*s) - s*(53*s - 53)))) - 2*Dd*f*(-6*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f*(-360*C*s**2 + 230*C*s + 6*K*(20*r**2 + r*(64*s - 38) + 44*s**2 - 59*s + 18) - r**2*(200*C + 4) + r*(-560*C*s + 170*C + 176*s + 92) + 180*s**2 - 9*s - 76) + 2*g2*(100*r**2 + r*(312*s - 89) + s*(212*s - 131)))) + 132*D1*bd2*f*(D1*(f*(3*r**2 + 16*r*s - 6*r + 13*s**2 - 16*s + 3) - 2*fd*(10*r**2 + 32*r*s - 18*r + 22*s**2 - 27*s + 8)) - 2*Dd*f*(20*r**2 + r*(64*s - 38) + 44*s**2 - 59*s + 18)) - 7920*Dd**2*b2*f**2*r**2 - 25344*Dd**2*b2*f**2*r*s + 14256*Dd**2*b2*f**2*r - 17424*Dd**2*b2*f**2*s**2 + 21384*Dd**2*b2*f**2*s - 5544*Dd**2*b2*f**2 + 7800*Dd**2*f**3*r**2 + 22320*Dd**2*f**3*r*s - 13380*Dd**2*f**3*r + 14520*Dd**2*f**3*s**2 - 18420*Dd**2*f**3*s + 5020*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 50688*Dd**2*f**2*g2*r*s - 28512*Dd**2*f**2*g2*r + 34848*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 11088*Dd**2*f**2*g2 + 11*b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(-28*K*(4*r**2 + 4*r*s - 5*r - 2*s + 2) + 6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 140*r**2 + 168*r*s - 182*r + 28*s**2 - 98*s + 77) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 7*Ddd*(4*K*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 20*r**2 + r*(26 - 24*s) - 4*s**2 + 14*s - 11)) - 2*Dd**2*(-14*K*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 18*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 210*r**2 + 252*r*s - 273*r + 42*s**2 - 147*s + 77)) + 11*b1**2*(-112*C*D1**2*fd*r**2 - 112*C*D1**2*fd*r*s + 224*C*D1**2*fd*r + 112*C*D1**2*fd*s - 112*C*D1**2*fd + 56*C*D1**2*fdd*r**2 + 56*C*D1**2*fdd*r*s - 112*C*D1**2*fdd*r - 56*C*D1**2*fdd*s + 56*C*D1**2*fdd - 448*C*D1*Dd*f*r**2 - 448*C*D1*Dd*f*r*s + 560*C*D1*Dd*f*r + 224*C*D1*Dd*f*s - 224*C*D1*Dd*f + 448*C*D1*Dd*fd*r**2 + 448*C*D1*Dd*fd*r*s - 728*C*D1*Dd*fd*r - 336*C*D1*Dd*fd*s + 280*C*D1*Dd*fd + 224*C*D1*Ddd*f*r**2 + 224*C*D1*Ddd*f*r*s - 280*C*D1*Ddd*f*r - 112*C*D1*Ddd*f*s + 112*C*D1*Ddd*f + 672*C*Dd**2*f*r**2 + 672*C*Dd**2*f*r*s - 840*C*Dd**2*f*r - 336*C*Dd**2*f*s + 224*C*Dd**2*f + 12*D1**2*K*fd*r**2 - 116*D1**2*K*fd*r*s + 116*D1**2*K*fd*r - 128*D1**2*K*fd*s**2 + 256*D1**2*K*fd*s - 128*D1**2*K*fd + 50*D1**2*K*fdd*r**2 + 156*D1**2*K*fdd*r*s - 156*D1**2*K*fdd*r + 106*D1**2*K*fdd*s**2 - 212*D1**2*K*fdd*s + 106*D1**2*K*fdd - D1**2*bdd1*(-28*K*(3*r**2 + 3*r*(s - 1) - s + 1) + 6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 105*r**2 + 126*r*s - 112*r + 21*s**2 - 56*s + 42) - 108*D1**2*f*fd*r**2 - 120*D1**2*f*fd*r*s + 84*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s - 30*D1**2*f*fd + 96*D1**2*f*fdd*r**2 + 96*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*r + 12*D1**2*f*fdd*s + 30*D1**2*f*fdd + 96*D1**2*fd**2*r**2 + 96*D1**2*fd**2*r*s - 60*D1**2*fd**2*r + 12*D1**2*fd**2*s - 36*D1**2*fd**2 + 13*D1**2*fd*r**2 + 18*D1**2*fd*r*s - 268*D1**2*fd*r + 5*D1**2*fd*s**2 - 240*D1**2*fd*s + 176*D1**2*fd - 10*D1**2*fdd*r**2 - 16*D1**2*fdd*r*s + 190*D1**2*fdd*r - 6*D1**2*fdd*s**2 + 162*D1**2*fdd*s - 109*D1**2*fdd + 112*D1**2*gd2*r**2 + 112*D1**2*gd2*r*s - 224*D1**2*gd2*r - 112*D1**2*gd2*s + 112*D1**2*gd2 - 56*D1**2*gdd2*r**2 - 56*D1**2*gdd2*r*s + 112*D1**2*gdd2*r + 56*D1**2*gdd2*s - 56*D1**2*gdd2 + 48*D1*Dd*K*f*r**2 - 464*D1*Dd*K*f*r*s + 68*D1*Dd*K*f*r - 512*D1*Dd*K*f*s**2 + 488*D1*Dd*K*f*s - 104*D1*Dd*K*f + 400*D1*Dd*K*fd*r**2 + 1248*D1*Dd*K*fd*r*s - 980*D1*Dd*K*fd*r + 848*D1*Dd*K*fd*s**2 - 1372*D1*Dd*K*fd*s + 524*D1*Dd*K*fd - 216*D1*Dd*f**2*r**2 - 240*D1*Dd*f**2*r*s + 276*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 + 132*D1*Dd*f**2*s - 114*D1*Dd*f**2 + 768*D1*Dd*f*fd*r**2 + 768*D1*Dd*f*fd*r*s - 720*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s + 108*D1*Dd*f*fd + 52*D1*Dd*f*r**2 + 72*D1*Dd*f*r*s - 70*D1*Dd*f*r + 20*D1*Dd*f*s**2 - 46*D1*Dd*f*s + 31*D1*Dd*f - 80*D1*Dd*fd*r**2 - 128*D1*Dd*fd*r*s + 816*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 + 692*D1*Dd*fd*s - 542*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 448*D1*Dd*g2*r*s - 560*D1*Dd*g2*r - 224*D1*Dd*g2*s + 224*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 448*D1*Dd*gd2*r*s + 728*D1*Dd*gd2*r + 336*D1*Dd*gd2*s - 280*D1*Dd*gd2 + 200*D1*Ddd*K*f*r**2 + 624*D1*Ddd*K*f*r*s - 356*D1*Ddd*K*f*r + 424*D1*Ddd*K*f*s**2 - 524*D1*Ddd*K*f*s + 206*D1*Ddd*K*f + 192*D1*Ddd*f**2*r**2 + 192*D1*Ddd*f**2*r*s - 240*D1*Ddd*f**2*r - 96*D1*Ddd*f**2*s + 96*D1*Ddd*f**2 - 40*D1*Ddd*f*r**2 - 64*D1*Ddd*f*r*s + 56*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 44*D1*Ddd*f*s - 26*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 224*D1*Ddd*g2*r*s + 280*D1*Ddd*g2*r + 112*D1*Ddd*g2*s - 112*D1*Ddd*g2 + 2*D1*bd1*(D1*(-28*K*(3*r**2 + 3*r*(s - 1) - s + 1) + 6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 105*r**2 + 126*r*s - 112*r + 21*s**2 - 56*s + 42) - 6*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 7*Dd*(2*K*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7) - 60*r**2 + r*(71 - 72*s) - 12*s**2 + 37*s - 20)) + 600*Dd**2*K*f*r**2 + 1872*Dd**2*K*f*r*s - 1068*Dd**2*K*f*r + 1272*Dd**2*K*f*s**2 - 1572*Dd**2*K*f*s + 412*Dd**2*K*f + 576*Dd**2*f**2*r**2 + 576*Dd**2*f**2*r*s - 720*Dd**2*f**2*r - 288*Dd**2*f**2*s + 192*Dd**2*f**2 - 120*Dd**2*f*r**2 - 192*Dd**2*f*r*s + 168*Dd**2*f*r - 72*Dd**2*f*s**2 + 132*Dd**2*f*s - 52*Dd**2*f - 672*Dd**2*g2*r**2 - 672*Dd**2*g2*r*s + 840*Dd**2*g2*r + 336*Dd**2*g2*s - 224*Dd**2*g2) - 11*b1*(-112*C*D1**2*bdd1*f*r**2 - 112*C*D1**2*bdd1*f*r*s + 56*C*D1**2*bdd1*f*r + 16*C*D1**2*f*fd*r**2 + 448*C*D1**2*f*fd*r*s - 240*C*D1**2*f*fd*r + 432*C*D1**2*f*fd*s**2 - 656*C*D1**2*f*fd*s + 224*C*D1**2*f*fd - 200*C*D1**2*f*fdd*r**2 - 560*C*D1**2*f*fdd*r*s + 480*C*D1**2*f*fdd*r - 360*C*D1**2*f*fdd*s**2 + 640*C*D1**2*f*fdd*s - 280*C*D1**2*f*fdd - 200*C*D1**2*fd**2*r**2 - 560*C*D1**2*fd**2*r*s + 480*C*D1**2*fd**2*r - 360*C*D1**2*fd**2*s**2 + 640*C*D1**2*fd**2*s - 280*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r**2 + 896*C*D1*Dd*f**2*r*s - 256*C*D1*Dd*f**2*r + 864*C*D1*Dd*f**2*s**2 - 880*C*D1*Dd*f**2*s + 232*C*D1*Dd*f**2 - 1600*C*D1*Dd*f*fd*r**2 - 4480*C*D1*Dd*f*fd*r*s + 3280*C*D1*Dd*f*fd*r - 2880*C*D1*Dd*f*fd*s**2 + 4400*C*D1*Dd*f*fd*s - 1600*C*D1*Dd*f*fd - 400*C*D1*Ddd*f**2*r**2 - 1120*C*D1*Ddd*f**2*r*s + 680*C*D1*Ddd*f**2*r - 720*C*D1*Ddd*f**2*s**2 + 920*C*D1*Ddd*f**2*s - 380*C*D1*Ddd*f**2 - 1200*C*Dd**2*f**2*r**2 - 3360*C*Dd**2*f**2*r*s + 2040*C*Dd**2*f**2*r - 2160*C*Dd**2*f**2*s**2 + 2760*C*Dd**2*f**2*s - 760*C*Dd**2*f**2 - 100*D1**2*K*bdd1*f*r**2 - 312*D1**2*K*bdd1*f*r*s + 100*D1**2*K*bdd1*f*r - 212*D1**2*K*bdd1*f*s**2 + 156*D1**2*K*bdd1*f*s - 50*D1**2*K*bdd1*f - 72*D1**2*K*f*fd*r**2 - 384*D1**2*K*f*fd*r*s + 192*D1**2*K*f*fd*r - 312*D1**2*K*f*fd*s**2 + 312*D1**2*K*f*fd*s - 156*D1**2*K*f*fd + 120*D1**2*K*f*fdd*r**2 + 384*D1**2*K*f*fdd*r*s - 192*D1**2*K*f*fdd*r + 264*D1**2*K*f*fdd*s**2 - 264*D1**2*K*f*fdd*s + 132*D1**2*K*f*fdd + 120*D1**2*K*fd**2*r**2 + 384*D1**2*K*fd**2*r*s - 192*D1**2*K*fd**2*r + 264*D1**2*K*fd**2*s**2 - 264*D1**2*K*fd**2*s + 10*D1**2*b2*fd*r**2 + 20*D1**2*b2*fd*r*s - 20*D1**2*b2*fd*r + 10*D1**2*b2*fd*s**2 - 20*D1**2*b2*fd*s + 10*D1**2*b2*fd - 12*D1**2*b2*fdd*r**2 - 24*D1**2*b2*fdd*r*s + 24*D1**2*b2*fdd*r - 12*D1**2*b2*fdd*s**2 + 24*D1**2*b2*fdd*s - 12*D1**2*b2*fdd + 2*D1**2*bd1**2*(-14*K*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 105*r**2 + 126*r*s - 112*r + 21*s**2 - 56*s + 21) - 96*D1**2*bdd1*f**2*r**2 - 96*D1**2*bdd1*f**2*r*s + 180*D1**2*bdd1*f**2*r + 108*D1**2*bdd1*f**2*s - 66*D1**2*bdd1*f**2 + 20*D1**2*bdd1*f*r**2 + 32*D1**2*bdd1*f*r*s + 154*D1**2*bdd1*f*r + 12*D1**2*bdd1*f*s**2 + 134*D1**2*bdd1*f*s - 93*D1**2*bdd1*f + 112*D1**2*bdd1*g2*r**2 + 112*D1**2*bdd1*g2*r*s - 56*D1**2*bdd1*g2*r - 12*D1**2*bdd2*f*r**2 - 24*D1**2*bdd2*f*r*s + 24*D1**2*bdd2*f*r - 12*D1**2*bdd2*f*s**2 + 24*D1**2*bdd2*f*s - 12*D1**2*bdd2*f + 164*D1**2*f*fd*r**2 - 40*D1**2*f*fd*r*s - 52*D1**2*f*fd*r - 204*D1**2*f*fd*s**2 + 300*D1**2*f*fd*s - 46*D1**2*f*fd - 4*D1**2*f*fdd*r**2 + 176*D1**2*f*fdd*r*s - 196*D1**2*f*fdd*r + 180*D1**2*f*fdd*s**2 - 348*D1**2*f*fdd*s + 128*D1**2*f*fdd + 24*D1**2*f*gd2*r**2 - 232*D1**2*f*gd2*r*s - 48*D1**2*f*gd2*r - 256*D1**2*f*gd2*s**2 + 232*D1**2*f*gd2*s + 24*D1**2*f*gd2 + 100*D1**2*f*gdd2*r**2 + 312*D1**2*f*gdd2*r*s - 200*D1**2*f*gdd2*r + 212*D1**2*f*gdd2*s**2 - 312*D1**2*f*gdd2*s + 100*D1**2*f*gdd2 - 4*D1**2*fd**2*r**2 + 176*D1**2*fd**2*r*s - 196*D1**2*fd**2*r + 180*D1**2*fd**2*s**2 - 348*D1**2*fd**2*s + 200*D1**2*fd**2 + 24*D1**2*fd*g2*r**2 - 232*D1**2*fd*g2*r*s + 232*D1**2*fd*g2*r - 256*D1**2*fd*g2*s**2 + 512*D1**2*fd*g2*s - 256*D1**2*fd*g2 + 200*D1**2*fd*gd2*r**2 + 624*D1**2*fd*gd2*r*s - 512*D1**2*fd*gd2*r + 424*D1**2*fd*gd2*s**2 - 736*D1**2*fd*gd2*s + 312*D1**2*fd*gd2 + 100*D1**2*fdd*g2*r**2 + 312*D1**2*fdd*g2*r*s - 312*D1**2*fdd*g2*r + 212*D1**2*fdd*g2*s**2 - 424*D1**2*fdd*g2*s + 212*D1**2*fdd*g2 - 144*D1*Dd*K*f**2*r**2 - 768*D1*Dd*K*f**2*r*s + 336*D1*Dd*K*f**2*r - 624*D1*Dd*K*f**2*s**2 + 696*D1*Dd*K*f**2*s - 228*D1*Dd*K*f**2 + 960*D1*Dd*K*f*fd*r**2 + 3072*D1*Dd*K*f*fd*r*s - 1632*D1*Dd*K*f*fd*r + 2112*D1*Dd*K*f*fd*s**2 - 2352*D1*Dd*K*f*fd*s + 648*D1*Dd*K*f*fd + 40*D1*Dd*b2*f*r**2 + 80*D1*Dd*b2*f*r*s - 60*D1*Dd*b2*f*r + 40*D1*Dd*b2*f*s**2 - 60*D1*Dd*b2*f*s + 30*D1*Dd*b2*f - 96*D1*Dd*b2*fd*r**2 - 192*D1*Dd*b2*fd*r*s + 168*D1*Dd*b2*fd*r - 96*D1*Dd*b2*fd*s**2 + 168*D1*Dd*b2*fd*s - 72*D1*Dd*b2*fd + 328*D1*Dd*f**2*r**2 - 80*D1*Dd*f**2*r*s - 308*D1*Dd*f**2*r - 408*D1*Dd*f**2*s**2 + 244*D1*Dd*f**2*s + 62*D1*Dd*f**2 - 32*D1*Dd*f*fd*r**2 + 1408*D1*Dd*f*fd*r*s - 944*D1*Dd*f*fd*r + 1440*D1*Dd*f*fd*s**2 - 2104*D1*Dd*f*fd*s + 740*D1*Dd*f*fd + 96*D1*Dd*f*g2*r**2 - 928*D1*Dd*f*g2*r*s + 136*D1*Dd*f*g2*r - 1024*D1*Dd*f*g2*s**2 + 976*D1*Dd*f*g2*s - 208*D1*Dd*f*g2 + 800*D1*Dd*f*gd2*r**2 + 2496*D1*Dd*f*gd2*r*s - 1512*D1*Dd*f*gd2*r + 1696*D1*Dd*f*gd2*s**2 - 2296*D1*Dd*f*gd2*s + 712*D1*Dd*f*gd2 + 800*D1*Dd*fd*g2*r**2 + 2496*D1*Dd*fd*g2*r*s - 1960*D1*Dd*fd*g2*r + 1696*D1*Dd*fd*g2*s**2 - 2744*D1*Dd*fd*g2*s + 1048*D1*Dd*fd*g2 + 240*D1*Ddd*K*f**2*r**2 + 768*D1*Ddd*K*f**2*r*s - 432*D1*Ddd*K*f**2*r + 528*D1*Ddd*K*f**2*s**2 - 648*D1*Ddd*K*f**2*s + 252*D1*Ddd*K*f**2 - 48*D1*Ddd*b2*f*r**2 - 96*D1*Ddd*b2*f*r*s + 72*D1*Ddd*b2*f*r - 48*D1*Ddd*b2*f*s**2 + 72*D1*Ddd*b2*f*s - 36*D1*Ddd*b2*f - 8*D1*Ddd*f**2*r**2 + 352*D1*Ddd*f**2*r*s - 80*D1*Ddd*f**2*r + 360*D1*Ddd*f**2*s**2 - 356*D1*Ddd*f**2*s + 86*D1*Ddd*f**2 + 400*D1*Ddd*f*g2*r**2 + 1248*D1*Ddd*f*g2*r*s - 712*D1*Ddd*f*g2*r + 848*D1*Ddd*f*g2*s**2 - 1048*D1*Ddd*f*g2*s + 412*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(6*f**2*(9*r**2 + 2*r*(5*s - 8) + s**2 - 12*s + 7) - f*(-112*C*r**2 - 112*C*r*s + 56*C*r + 2*K*(6*r**2 - 58*r*s - 6*r - 64*s**2 + 29*s + 3) + 12*fd*(16*r**2 + 4*r*(4*s - 5) - 8*s + 5) + 13*r**2 + 18*r*s + 112*r + 5*s**2 + 106*s - 79) + fd*(-28*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) - 2*K*(50*r**2 + 156*r*s - 103*r + 106*s**2 - 145*s + 39) + 20*r**2 + 32*r*s - 113*r + 12*s**2 - 95*s + 67) - 56*g2*r*(2*r + 2*s - 1) + 28*gd2*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*(-6*f**2*(16*r - 13)*(4*r + 4*s - 3) + f*(-56*C*(8*r**2 + r*(8*s - 7) - 2*s + 1) - 2*K*(200*r**2 + 624*r*s - 278*r + 424*s**2 - 418*s + 89) + 80*r**2 + 128*r*s + 252*r + 48*s**2 + 224*s - 221) + 56*g2*(8*r**2 + r*(8*s - 7) - 2*s + 1))) + 2*D1*bd2*(D1*(5*f - 12*fd)*(r + s - 1) - 12*Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 720*Dd**2*K*f**2*r**2 + 2304*Dd**2*K*f**2*r*s - 1296*Dd**2*K*f**2*r + 1584*Dd**2*K*f**2*s**2 - 1944*Dd**2*K*f**2*s + 504*Dd**2*K*f**2 - 144*Dd**2*b2*f*r**2 - 288*Dd**2*b2*f*r*s + 216*Dd**2*b2*f*r - 144*Dd**2*b2*f*s**2 + 216*Dd**2*b2*f*s - 72*Dd**2*b2*f - 24*Dd**2*f**2*r**2 + 1056*Dd**2*f**2*r*s - 240*Dd**2*f**2*r + 1080*Dd**2*f**2*s**2 - 1068*Dd**2*f**2*s + 172*Dd**2*f**2 + 1200*Dd**2*f*g2*r**2 + 3744*Dd**2*f*g2*r*s - 2136*Dd**2*f*g2*r + 2544*Dd**2*f*g2*s**2 - 3144*Dd**2*f*g2*s + 824*Dd**2*f*g2))/(231*d**2*k3**3) + 8*D1**2*Pk2*Pkd3*ct**3*k1*st**2*(-D1*f*(D1*bd1**2*s*(5*f + 3)*(2*r + 2*s - 1) + 3*D1*bdd1*f*s*(r + s) + 3*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1)))) + b1**2*(-D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) + fd*(f*(10 - 20*s) - 6*s + 6) + fdd*(10*f*s - 5*f + 3*s - 3)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 6*r*(4*s - 1) + 6*(1 - 2*s)**2) - 3*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(5*f + 3)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(5*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) - 3*f*(bdd1*s*(-2*r - 2*s + 1) + 2*fd*(2*s - 1)*(r + s - 1) - fdd*(2*s - 1)*(r + s - 1)) + 3*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + 2*f*s*(5*f + 3)*(2*r + 2*s - 1) - 3*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - Dd*f*(5*f + 3)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 3*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(6 - 16*s) - 16*s**2 + 20*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k2*k3) + D1**2*Pk2*Pkd3*ct**3*k1*(2*D1*(D1*bd1**2*f*(r**2*(18*f + 19) + r*(6*f*(10*s - 3) + s*(24*K + 42) - 7) + s*(12*K*(2*s - 1) + 6*f*(7*s - 5) + 23*s - 9)) + 2*D1*bdd1*f*(r + s)*(5*f*(2*C*s + r + s) + s*(6*b2 - 12*g2)) + bd1*(-D1*(f**2*(r + s)*(5*r + s*(16*C + 29)) - 4*f*(5*fd*(2*r**2 + r*(C*(4*s - 1) + 4*s - 2) + s*(4*C*s - 3*C + 2*s - 2)) + s*(bd2*(6*r + 6*s - 3) + 5*g2*(r + s) - 6*gd2*(2*r + 2*s - 1))) + 24*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 4*Dd*f*(5*f*(4*r**2 + r*(8*C*s - C + 8*s - 3) + s*(8*C*s - 4*C + 4*s - 3)) + 6*g2*(-8*r*s + r + s*(4 - 8*s))) + 2*b2*(D1*(-5*f*s*(r + s) + 6*fd*(r*(2*s - 1) + s*(2*s - 2))) + 6*Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 4*b1**3*(6*D1**2*s*(2*fd - fdd)*(r + s - 1) + 2*D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 7*r*(4*s - 1) + 7*(1 - 2*s)**2) - D1*Ddd*(6*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(6*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-20*D1**2*K*fd*r*s + 20*D1**2*K*fd*r - 20*D1**2*K*fd*s**2 + 40*D1**2*K*fd*s - 20*D1**2*K*fd + 24*D1**2*K*fdd*r*s - 24*D1**2*K*fdd*r + 24*D1**2*K*fdd*s**2 - 48*D1**2*K*fdd*s + 24*D1**2*K*fdd - 4*D1**2*bdd1*(6*f + 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 12*D1**2*f*fd*r**2 - 168*D1**2*f*fd*r*s + 96*D1**2*f*fd*r - 156*D1**2*f*fd*s**2 + 240*D1**2*f*fd*s - 84*D1**2*f*fd + 36*D1**2*f*fdd*r**2 + 120*D1**2*f*fdd*r*s - 96*D1**2*f*fdd*r + 84*D1**2*f*fdd*s**2 - 144*D1**2*f*fdd*s + 60*D1**2*f*fdd + 36*D1**2*fd**2*r**2 + 120*D1**2*fd**2*r*s - 96*D1**2*fd**2*r + 84*D1**2*fd**2*s**2 - 144*D1**2*fd**2*s + 60*D1**2*fd**2 - 3*D1**2*fd*r**2 - 42*D1**2*fd*r*s + 90*D1**2*fd*r - 39*D1**2*fd*s**2 + 126*D1**2*fd*s - 87*D1**2*fd + 19*D1**2*fdd*r**2 + 42*D1**2*fdd*r*s - 66*D1**2*fdd*r + 23*D1**2*fdd*s**2 - 70*D1**2*fdd*s + 47*D1**2*fdd - 80*D1*Dd*K*f*r*s + 20*D1*Dd*K*f*r - 80*D1*Dd*K*f*s**2 + 80*D1*Dd*K*f*s - 20*D1*Dd*K*f + 192*D1*Dd*K*fd*r*s - 120*D1*Dd*K*fd*r + 192*D1*Dd*K*fd*s**2 - 288*D1*Dd*K*fd*s + 96*D1*Dd*K*fd - 24*D1*Dd*f**2*r**2 - 336*D1*Dd*f**2*r*s + 108*D1*Dd*f**2*r - 312*D1*Dd*f**2*s**2 + 324*D1*Dd*f**2*s - 90*D1*Dd*f**2 + 288*D1*Dd*f*fd*r**2 + 960*D1*Dd*f*fd*r*s - 648*D1*Dd*f*fd*r + 672*D1*Dd*f*fd*s**2 - 984*D1*Dd*f*fd*s + 336*D1*Dd*f*fd - 12*D1*Dd*f*r**2 - 168*D1*Dd*f*r*s + 54*D1*Dd*f*r - 156*D1*Dd*f*s**2 + 162*D1*Dd*f*s - 45*D1*Dd*f + 152*D1*Dd*fd*r**2 + 336*D1*Dd*fd*r*s - 382*D1*Dd*fd*r + 184*D1*Dd*fd*s**2 - 410*D1*Dd*fd*s + 202*D1*Dd*fd + 96*D1*Ddd*K*f*r*s - 24*D1*Ddd*K*f*r + 96*D1*Ddd*K*f*s**2 - 96*D1*Ddd*K*f*s + 24*D1*Ddd*K*f + 72*D1*Ddd*f**2*r**2 + 240*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 168*D1*Ddd*f**2*s**2 - 204*D1*Ddd*f**2*s + 78*D1*Ddd*f**2 + 76*D1*Ddd*f*r**2 + 168*D1*Ddd*f*r*s - 118*D1*Ddd*f*r + 92*D1*Ddd*f*s**2 - 130*D1*Ddd*f*s + 61*D1*Ddd*f + 4*D1*bd1*(2*D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + 21*r*s - 7*r + 21*s**2 - 21*s + 7) - Dd*(6*f + 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 288*Dd**2*K*f*r*s - 72*Dd**2*K*f*r + 288*Dd**2*K*f*s**2 - 288*Dd**2*K*f*s + 48*Dd**2*K*f + 216*Dd**2*f**2*r**2 + 720*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 504*Dd**2*f**2*s**2 - 612*Dd**2*f**2*s + 156*Dd**2*f**2 + 228*Dd**2*f*r**2 + 504*Dd**2*f*r*s - 354*Dd**2*f*r + 276*Dd**2*f*s**2 - 390*Dd**2*f*s + 122*Dd**2*f) + b1*(-64*C*D1**2*f*fd*r*s + 32*C*D1**2*f*fd*r - 64*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 32*C*D1**2*f*fd + 80*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 40*C*D1**2*f*fdd + 80*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s + 40*C*D1**2*fd**2 - 128*C*D1*Dd*f**2*r*s + 32*C*D1*Dd*f**2*r - 128*C*D1*Dd*f**2*s**2 + 128*C*D1*Dd*f**2*s - 32*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 800*C*D1*Dd*f*fd*s + 200*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r*s - 40*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 160*C*D1*Ddd*f**2*s + 40*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r*s - 120*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 480*C*Dd**2*f**2*s + 80*C*Dd**2*f**2 - 4*D1**2*bd1**2*(6*f + 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*f*(48*K*s**2 - 24*K*s + 6*f*(6*r**2 + r*(20*s - 6) + 14*s**2 - 10*s + 3) + 38*r**2 + 2*r*(s*(24*K + 42) - 7) + 46*s**2 - 18*s - 5) + 24*D1**2*bdd2*f*r*s + 24*D1**2*bdd2*f*s**2 - 24*D1**2*bdd2*f*s - 20*D1**2*f*fd*r**2 - 136*D1**2*f*fd*r*s + 88*D1**2*f*fd*r - 116*D1**2*f*fd*s**2 + 184*D1**2*f*fd*s - 68*D1**2*f*fd + 40*D1**2*f*fdd*r**2 + 80*D1**2*f*fdd*r*s - 80*D1**2*f*fdd*r + 40*D1**2*f*fdd*s**2 - 80*D1**2*f*fdd*s + 40*D1**2*f*fdd + 40*D1**2*f*gd2*r*s + 40*D1**2*f*gd2*s**2 - 40*D1**2*f*gd2*s - 48*D1**2*f*gdd2*r*s - 48*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s + 40*D1**2*fd**2*r**2 + 80*D1**2*fd**2*r*s - 80*D1**2*fd**2*r + 40*D1**2*fd**2*s**2 - 80*D1**2*fd**2*s + 40*D1**2*fd**2 + 40*D1**2*fd*g2*r*s - 40*D1**2*fd*g2*r + 40*D1**2*fd*g2*s**2 - 80*D1**2*fd*g2*s + 40*D1**2*fd*g2 - 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 96*D1**2*fd*gd2*s**2 + 144*D1**2*fd*gd2*s - 48*D1**2*fd*gd2 - 48*D1**2*fdd*g2*r*s + 48*D1**2*fdd*g2*r - 48*D1**2*fdd*g2*s**2 + 96*D1**2*fdd*g2*s - 48*D1**2*fdd*g2 - 40*D1*Dd*f**2*r**2 - 272*D1*Dd*f**2*r*s + 108*D1*Dd*f**2*r - 232*D1*Dd*f**2*s**2 + 252*D1*Dd*f**2*s - 78*D1*Dd*f**2 + 320*D1*Dd*f*fd*r**2 + 640*D1*Dd*f*fd*r*s - 560*D1*Dd*f*fd*r + 320*D1*Dd*f*fd*s**2 - 560*D1*Dd*f*fd*s + 240*D1*Dd*f*fd + 160*D1*Dd*f*g2*r*s - 40*D1*Dd*f*g2*r + 160*D1*Dd*f*g2*s**2 - 160*D1*Dd*f*g2*s + 40*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r*s + 48*D1*Dd*f*gd2*r - 384*D1*Dd*f*gd2*s**2 + 384*D1*Dd*f*gd2*s - 48*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r*s + 240*D1*Dd*fd*g2*r - 384*D1*Dd*fd*g2*s**2 + 576*D1*Dd*fd*g2*s - 192*D1*Dd*fd*g2 + 80*D1*Ddd*f**2*r**2 + 160*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r + 80*D1*Ddd*f**2*s**2 - 120*D1*Ddd*f**2*s + 60*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r*s + 48*D1*Ddd*f*g2*r - 192*D1*Ddd*f*g2*s**2 + 192*D1*Ddd*f*g2*s - 48*D1*Ddd*f*g2 + D1*bd1*(-D1*(6*f**2*(2*r**2 + r*(28*s - 2) + 26*s**2 - 14*s + 1) + f*(40*K*s**2 - 20*K*s - 24*fd*(6*r**2 + r*(20*s - 11) + 14*s**2 - 17*s + 4) + 6*r**2 + r*(40*K*s + 84*s + 42) + 78*s**2 + 6*s - 45) - 2*fd*(12*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 38*r**2 + r*(84*s - 73) + 46*s**2 - 79*s + 21)) + 2*Dd*f*(12*K*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 6*f*(24*r**2 + r*(80*s - 34) + 56*s**2 - 54*s + 11) + 152*r**2 + 336*r*s - 146*r + 184*s**2 - 166*s + 23)) - 4*D1*bd2*(D1*(5*f*s + fd*(6 - 12*s))*(r + s - 1) - 6*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 240*Dd**2*f**2*r**2 + 480*Dd**2*f**2*r*s - 360*Dd**2*f**2*r + 240*Dd**2*f**2*s**2 - 360*Dd**2*f**2*s + 120*Dd**2*f**2 - 576*Dd**2*f*g2*r*s + 144*Dd**2*f*g2*r - 576*Dd**2*f*g2*s**2 + 576*Dd**2*f*g2*s - 96*Dd**2*f*g2 - 4*b2*(D1**2*(5*fd - 6*fdd)*(s - 1)*(r + s - 1) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2))))/(21*d**2*k2*k3) - D1**2*Pk2*Pkd3*ct**3*k2**5*(8*C - 4)*(D1*f*(-D1*bdd1*f*r*(r + s - 1) + bd1*(2*D1*f*r*(r + s - 1) + D1*fd*(-4*r**2 - 4*r*(s - 1) + s - 1) + Dd*f*(-8*r**2 - 8*r*s + 9*r + 2*s - 2))) + b1*(D1**2*(f*(2*fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-2*r**2 - 2*r*(s - 1) + s)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - Dd*fd*(2*r - 1)*(8*r + 8*s - 5) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)))/(21*d**2*k1*k3**5) + D1**2*Pk2*Pkd3*ct**3*k2*(8*C - 4)*(D1*f*(D1*bd1*(2*f*r*(r + s) + fd*(-4*r**2 + r*(3 - 4*s) + s)) - D1*bdd1*f*r*(r + s) + Dd*bd1*f*(-8*r**2 + r*(5 - 8*s) + 2*s)) + b1*(D1**2*(2*r - 1)*(r + s - 1)*(2*f*fd - f*fdd - fd**2) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - Dd*fd*(2*r - 1)*(8*r + 8*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)))/(21*d**2*k1*k3) + 20*D1**2*Pk2*Pkd3*ct**2*f**2*k1**6*st**2*(D1**2*(f*(131*fd - 98*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 98*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(131*f*(r*(4*s - 1) + (1 - 2*s)**2) - 196*fd*(4*s - 1)*(4*r + 4*s - 3)) - 98*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 98*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k2**2*k3**5) - 20*D1**2*Pk2*Pkd3*ct**2*f*k1**6*(-69*D1**2*b1*f*fd*r*s - 69*D1**2*b1*f*fd*s**2 + 46*D1**2*b1*f*fd*s + 84*D1**2*b1*f*fdd*r*s + 84*D1**2*b1*f*fdd*s**2 - 56*D1**2*b1*f*fdd*s + 168*D1**2*b1*fd**2*r*s + 168*D1**2*b1*fd**2*s**2 - 112*D1**2*b1*fd**2*s + 28*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + 168*D1**2*f**2*fd*r*s - 42*D1**2*f**2*fd*r + 168*D1**2*f**2*fd*s**2 - 168*D1**2*f**2*fd*s + 42*D1**2*f**2*fd - 168*D1**2*f**2*fdd*r*s + 42*D1**2*f**2*fdd*r - 168*D1**2*f**2*fdd*s**2 + 168*D1**2*f**2*fdd*s - 42*D1**2*f**2*fdd - 504*D1**2*f*fd**2*r*s + 126*D1**2*f*fd**2*r - 504*D1**2*f*fd**2*s**2 + 504*D1**2*f*fd**2*s - 84*D1**2*f*fd**2 - 92*D1*Dd*b1*f**2*r*s + 23*D1*Dd*b1*f**2*r - 92*D1*Dd*b1*f**2*s**2 + 92*D1*Dd*b1*f**2*s - 23*D1*Dd*b1*f**2 + 672*D1*Dd*b1*f*fd*r*s - 84*D1*Dd*b1*f*fd*r + 672*D1*Dd*b1*f*fd*s**2 - 560*D1*Dd*b1*f*fd*s + 56*D1*Dd*b1*f*fd + 168*D1*Dd*f**3*r*s - 42*D1*Dd*f**3*r + 168*D1*Dd*f**3*s**2 - 168*D1*Dd*f**3*s + 42*D1*Dd*f**3 - 1344*D1*Dd*f**2*fd*r*s + 336*D1*Dd*f**2*fd*r - 1344*D1*Dd*f**2*fd*s**2 + 1344*D1*Dd*f**2*fd*s - 252*D1*Dd*f**2*fd + 112*D1*Ddd*b1*f**2*r*s - 28*D1*Ddd*b1*f**2*r + 112*D1*Ddd*b1*f**2*s**2 - 112*D1*Ddd*b1*f**2*s + 28*D1*Ddd*b1*f**2 - 168*D1*Ddd*f**3*r*s + 42*D1*Ddd*f**3*r - 168*D1*Ddd*f**3*s**2 + 168*D1*Ddd*f**3*s - 42*D1*Ddd*f**3 + D1*bd1*f*(D1*(-23*f*(s - 1)*(r + s - 1) + 28*fd*(6*r*s - 3*r + 6*s**2 - 8*s + 2)) + 28*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 336*Dd**2*b1*f**2*r*s - 84*Dd**2*b1*f**2*r + 336*Dd**2*b1*f**2*s**2 - 336*Dd**2*b1*f**2*s + 56*Dd**2*b1*f**2 - 504*Dd**2*f**3*r*s + 126*Dd**2*f**3*r - 504*Dd**2*f**3*s**2 + 504*Dd**2*f**3*s - 84*Dd**2*f**3)/(693*d**2*k2**2*k3**5) + 9*D1**2*Pk2*Pkd3*ct**2*f*k1**4*k2**2*st**4*(312*C*D1**2*f*fd*r**2 + 624*C*D1**2*f*fd*r*s - 416*C*D1**2*f*fd*r + 312*C*D1**2*f*fd*s**2 - 416*C*D1**2*f*fd*s + 208*C*D1**2*f*fd - 156*C*D1**2*f*fdd*r**2 - 312*C*D1**2*f*fdd*r*s + 208*C*D1**2*f*fdd*r - 156*C*D1**2*f*fdd*s**2 + 208*C*D1**2*f*fdd*s - 104*C*D1**2*f*fdd - 312*C*D1**2*fd**2*r**2 - 624*C*D1**2*fd**2*r*s + 416*C*D1**2*fd**2*r - 312*C*D1**2*fd**2*s**2 + 416*C*D1**2*fd**2*s - 104*C*D1**2*fd**2 + 416*C*D1*Dd*f**2*r**2 + 832*C*D1*Dd*f**2*r*s - 624*C*D1*Dd*f**2*r + 416*C*D1*Dd*f**2*s**2 - 624*C*D1*Dd*f**2*s + 312*C*D1*Dd*f**2 - 1248*C*D1*Dd*f*fd*r**2 - 2496*C*D1*Dd*f*fd*r*s + 1768*C*D1*Dd*f*fd*r - 1248*C*D1*Dd*f*fd*s**2 + 1768*C*D1*Dd*f*fd*s - 624*C*D1*Dd*f*fd - 208*C*D1*Ddd*f**2*r**2 - 416*C*D1*Ddd*f**2*r*s + 312*C*D1*Ddd*f**2*r - 208*C*D1*Ddd*f**2*s**2 + 312*C*D1*Ddd*f**2*s - 156*C*D1*Ddd*f**2 - 624*C*Dd**2*f**2*r**2 - 1248*C*Dd**2*f**2*r*s + 936*C*Dd**2*f**2*r - 624*C*Dd**2*f**2*s**2 + 936*C*Dd**2*f**2*s - 312*C*Dd**2*f**2 + 143*D1**2*bd1*f*(K - 1)*(r + s - 1)**2 + 3220*D1**2*f**2*fd*r**2 + 6440*D1**2*f**2*fd*r*s - 4830*D1**2*f**2*fd*r + 3220*D1**2*f**2*fd*s**2 - 4830*D1**2*f**2*fd*s + 2415*D1**2*f**2*fd - 2000*D1**2*f**2*fdd*r**2 - 4000*D1**2*f**2*fdd*r*s + 3000*D1**2*f**2*fdd*r - 2000*D1**2*f**2*fdd*s**2 + 3000*D1**2*f**2*fdd*s - 1500*D1**2*f**2*fdd - 6000*D1**2*f*fd**2*r**2 - 12000*D1**2*f*fd**2*r*s + 9000*D1**2*f*fd**2*r - 6000*D1**2*f*fd**2*s**2 + 9000*D1**2*f*fd**2*s - 3000*D1**2*f*fd**2 - 312*D1**2*f*fd*r**2 - 624*D1**2*f*fd*r*s + 416*D1**2*f*fd*r - 312*D1**2*f*fd*s**2 + 416*D1**2*f*fd*s - 208*D1**2*f*fd + 156*D1**2*f*fdd*r**2 + 312*D1**2*f*fdd*r*s - 208*D1**2*f*fdd*r + 156*D1**2*f*fdd*s**2 - 208*D1**2*f*fdd*s + 104*D1**2*f*fdd - 286*D1**2*f*gd2*r**2 - 572*D1**2*f*gd2*r*s + 572*D1**2*f*gd2*r - 286*D1**2*f*gd2*s**2 + 572*D1**2*f*gd2*s - 286*D1**2*f*gd2 + 312*D1**2*fd**2*r**2 + 624*D1**2*fd**2*r*s - 416*D1**2*fd**2*r + 312*D1**2*fd**2*s**2 - 416*D1**2*fd**2*s + 104*D1**2*fd**2 - 572*D1**2*fd*g2*r**2 - 1144*D1**2*fd*g2*r*s + 572*D1**2*fd*g2*r - 572*D1**2*fd*g2*s**2 + 572*D1**2*fd*g2*s - 286*D1**2*fd*g2 + 3220*D1*Dd*f**3*r**2 + 6440*D1*Dd*f**3*r*s - 4830*D1*Dd*f**3*r + 3220*D1*Dd*f**3*s**2 - 4830*D1*Dd*f**3*s + 2415*D1*Dd*f**3 - 16000*D1*Dd*f**2*fd*r**2 - 32000*D1*Dd*f**2*fd*r*s + 24000*D1*Dd*f**2*fd*r - 16000*D1*Dd*f**2*fd*s**2 + 24000*D1*Dd*f**2*fd*s - 9000*D1*Dd*f**2*fd - 416*D1*Dd*f**2*r**2 - 832*D1*Dd*f**2*r*s + 624*D1*Dd*f**2*r - 416*D1*Dd*f**2*s**2 + 624*D1*Dd*f**2*s - 312*D1*Dd*f**2 + 1248*D1*Dd*f*fd*r**2 + 2496*D1*Dd*f*fd*r*s - 1768*D1*Dd*f*fd*r + 1248*D1*Dd*f*fd*s**2 - 1768*D1*Dd*f*fd*s + 624*D1*Dd*f*fd - 1144*D1*Dd*f*g2*r**2 - 2288*D1*Dd*f*g2*r*s + 1716*D1*Dd*f*g2*r - 1144*D1*Dd*f*g2*s**2 + 1716*D1*Dd*f*g2*s - 858*D1*Dd*f*g2 - 2000*D1*Ddd*f**3*r**2 - 4000*D1*Ddd*f**3*r*s + 3000*D1*Ddd*f**3*r - 2000*D1*Ddd*f**3*s**2 + 3000*D1*Ddd*f**3*s - 1500*D1*Ddd*f**3 + 208*D1*Ddd*f**2*r**2 + 416*D1*Ddd*f**2*r*s - 312*D1*Ddd*f**2*r + 208*D1*Ddd*f**2*s**2 - 312*D1*Ddd*f**2*s + 156*D1*Ddd*f**2 + 143*D1*b1*(K - 1)*(D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 6000*Dd**2*f**3*r**2 - 12000*Dd**2*f**3*r*s + 9000*Dd**2*f**3*r - 6000*Dd**2*f**3*s**2 + 9000*Dd**2*f**3*s - 3000*Dd**2*f**3 + 624*Dd**2*f**2*r**2 + 1248*Dd**2*f**2*r*s - 936*Dd**2*f**2*r + 624*Dd**2*f**2*s**2 - 936*Dd**2*f**2*s + 312*Dd**2*f**2)/(1001*d**2*k3**7) + 8*D1**2*Pk2*Pkd3*ct**2*f*k1**4*st**4*(D1**2*(5*f**2*(107*fd - 60*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(150*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - fd*(26*C - 26)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(13*C - 13)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(26*C - 26)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(535*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 4*f*(13*C*(r*(4*s - 1) + (1 - 2*s)**2) - 150*fd*(4*s - 1)*(4*r + 4*s - 3) - 13*r*(4*s - 1) - 13*(1 - 2*s)**2) - fd*(26*C - 26)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(13*C + 150*f - 13)) - 2*Dd**2*f**2*(13*C + 150*f - 13)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1001*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**2*f*k2**6*st**4*(90*C - 45)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**7) - 5*D1**2*Pk2*Pkd3*ct**2*f*k2**4*st**4*(D1**2*(f*(2*fd - fdd)*(2*C*(57*r**2 + 6*r*(17*s - 12) + 45*s**2 - 64*s + 34) - 63*r**2 - 3*r*(36*s - 26) - 45*s**2 + 66*s - 36) - 2*fd**2*(2*C*(57*r**2 + 6*r*(17*s - 12) + 45*s**2 - 64*s + 17) - 63*r**2 - 3*r*(36*s - 26) - 45*s**2 + 66*s - 18)) + D1*f*(2*Dd*(2*C*f*(76*r**2 + 2*r*(68*s - 55) + 60*s**2 - 98*s + 53) - 2*C*fd*(228*r**2 + r*(408*s - 309) + 180*s**2 - 275*s + 104) - 3*f*(28*r**2 + 8*r*(6*s - 5) + 20*s**2 - 34*s + 19) + 3*fd*(84*r**2 + 16*r*(9*s - 7) + 60*s**2 - 95*s + 37)) + Ddd*f*(-2*C*(76*r**2 + 2*r*(68*s - 55) + 60*s**2 - 98*s + 53) + 84*r**2 + 24*r*(6*s - 5) + 60*s**2 - 102*s + 57)) + 2*Dd**2*f**2*(-2*C*(114*r**2 + 3*r*(68*s - 55) + 90*s**2 - 147*s + 53) + 126*r**2 + 36*r*(6*s - 5) + 90*s**2 - 153*s + 57))/(231*d**2*k3**5) - 10*D1**2*Pk2*Pkd3*ct**2*f*k2**2*st**4*(D1**2*(f*(2*fd - fdd)*(12*C*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 3*r**2 + r*(3 - 15*s) - 18*s**2 + 17*s - 5) + fd**2*(-12*C*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 6*r**2 + 6*r*(5*s - 1) + 36*s**2 - 34*s + 5)) + D1*f*(Dd*(2*f*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 - 20*r*s + r - 24*s**2 + 22*s - 4) + fd*(-12*C*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 24*r**2 + 15*r*(8*s - 1) + 144*s**2 - 134*s + 23)) - Ddd*f*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 - 20*r*s + r - 24*s**2 + 22*s - 4)) + Dd**2*f**2*(-12*C*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - 12*r**2 + r*(60*s - 3) + 72*s**2 - 66*s + 8))/(231*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**2*k1**6*st**2*(1326*C*D1**2*f**2*fd*r**2 + 2652*C*D1**2*f**2*fd*r*s - 1768*C*D1**2*f**2*fd*r + 1326*C*D1**2*f**2*fd*s**2 - 1768*C*D1**2*f**2*fd*s + 884*C*D1**2*f**2*fd - 1950*C*D1**2*f**2*fdd*r**2 - 3900*C*D1**2*f**2*fdd*r*s + 2600*C*D1**2*f**2*fdd*r - 1950*C*D1**2*f**2*fdd*s**2 + 2600*C*D1**2*f**2*fdd*s - 1300*C*D1**2*f**2*fdd - 3900*C*D1**2*f*fd**2*r**2 - 7800*C*D1**2*f*fd**2*r*s + 5200*C*D1**2*f*fd**2*r - 3900*C*D1**2*f*fd**2*s**2 + 5200*C*D1**2*f*fd**2*s - 1300*C*D1**2*f*fd**2 + 1768*C*D1*Dd*f**3*r**2 + 3536*C*D1*Dd*f**3*r*s - 2652*C*D1*Dd*f**3*r + 1768*C*D1*Dd*f**3*s**2 - 2652*C*D1*Dd*f**3*s + 1326*C*D1*Dd*f**3 - 15600*C*D1*Dd*f**2*fd*r**2 - 31200*C*D1*Dd*f**2*fd*r*s + 22100*C*D1*Dd*f**2*fd*r - 15600*C*D1*Dd*f**2*fd*s**2 + 22100*C*D1*Dd*f**2*fd*s - 7800*C*D1*Dd*f**2*fd - 2600*C*D1*Ddd*f**3*r**2 - 5200*C*D1*Ddd*f**3*r*s + 3900*C*D1*Ddd*f**3*r - 2600*C*D1*Ddd*f**3*s**2 + 3900*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 7800*C*Dd**2*f**3*r**2 - 15600*C*Dd**2*f**3*r*s + 11700*C*Dd**2*f**3*r - 7800*C*Dd**2*f**3*s**2 + 11700*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 + 858*D1**2*K*b1*f*fd*r**2 + 1716*D1**2*K*b1*f*fd*r*s - 858*D1**2*K*b1*f*fd*r + 858*D1**2*K*b1*f*fd*s**2 - 858*D1**2*K*b1*f*fd*s + 429*D1**2*K*b1*f*fd - 858*D1**2*K*b1*f*fdd*r**2 - 1716*D1**2*K*b1*f*fdd*r*s + 858*D1**2*K*b1*f*fdd*r - 858*D1**2*K*b1*f*fdd*s**2 + 858*D1**2*K*b1*f*fdd*s - 429*D1**2*K*b1*f*fdd - 858*D1**2*K*b1*fd**2*r**2 - 1716*D1**2*K*b1*fd**2*r*s + 858*D1**2*K*b1*fd**2*r - 858*D1**2*K*b1*fd**2*s**2 + 858*D1**2*K*b1*fd**2*s - 858*D1**2*b1*f*fd*r**2 - 1716*D1**2*b1*f*fd*r*s + 858*D1**2*b1*f*fd*r - 858*D1**2*b1*f*fd*s**2 + 858*D1**2*b1*f*fd*s - 429*D1**2*b1*f*fd + 858*D1**2*b1*f*fdd*r**2 + 1716*D1**2*b1*f*fdd*r*s - 858*D1**2*b1*f*fdd*r + 858*D1**2*b1*f*fdd*s**2 - 858*D1**2*b1*f*fdd*s + 429*D1**2*b1*f*fdd + 858*D1**2*b1*fd**2*r**2 + 1716*D1**2*b1*fd**2*r*s - 858*D1**2*b1*fd**2*r + 858*D1**2*b1*fd**2*s**2 - 858*D1**2*b1*fd**2*s - 429*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 27600*D1**2*f**3*fd*r**2 + 55200*D1**2*f**3*fd*r*s - 41400*D1**2*f**3*fd*r + 27600*D1**2*f**3*fd*s**2 - 41400*D1**2*f**3*fd*s + 20700*D1**2*f**3*fd - 29400*D1**2*f**3*fdd*r**2 - 58800*D1**2*f**3*fdd*r*s + 44100*D1**2*f**3*fdd*r - 29400*D1**2*f**3*fdd*s**2 + 44100*D1**2*f**3*fdd*s - 22050*D1**2*f**3*fdd - 88200*D1**2*f**2*fd**2*r**2 - 176400*D1**2*f**2*fd**2*r*s + 132300*D1**2*f**2*fd**2*r - 88200*D1**2*f**2*fd**2*s**2 + 132300*D1**2*f**2*fd**2*s - 44100*D1**2*f**2*fd**2 - 1326*D1**2*f**2*fd*r**2 - 2652*D1**2*f**2*fd*r*s + 1768*D1**2*f**2*fd*r - 1326*D1**2*f**2*fd*s**2 + 1768*D1**2*f**2*fd*s - 884*D1**2*f**2*fd + 1950*D1**2*f**2*fdd*r**2 + 3900*D1**2*f**2*fdd*r*s - 2600*D1**2*f**2*fdd*r + 1950*D1**2*f**2*fdd*s**2 - 2600*D1**2*f**2*fdd*s + 1300*D1**2*f**2*fdd - 858*D1**2*f**2*gd2*r**2 - 1716*D1**2*f**2*gd2*r*s + 1716*D1**2*f**2*gd2*r - 858*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s - 858*D1**2*f**2*gd2 + 858*D1**2*f**2*gdd2*r**2 + 1716*D1**2*f**2*gdd2*r*s - 1716*D1**2*f**2*gdd2*r + 858*D1**2*f**2*gdd2*s**2 - 1716*D1**2*f**2*gdd2*s + 858*D1**2*f**2*gdd2 + 3900*D1**2*f*fd**2*r**2 + 7800*D1**2*f*fd**2*r*s - 5200*D1**2*f*fd**2*r + 3900*D1**2*f*fd**2*s**2 - 5200*D1**2*f*fd**2*s + 1300*D1**2*f*fd**2 - 1716*D1**2*f*fd*g2*r**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 1716*D1**2*f*fd*g2*s**2 + 1716*D1**2*f*fd*g2*s - 858*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r**2 + 6864*D1**2*f*fd*gd2*r*s - 5148*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1716*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r**2 + 3432*D1**2*f*fdd*g2*r*s - 1716*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r**2 + 3432*D1**2*fd**2*g2*r*s - 1716*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 1716*D1*Dd*K*b1*f**2*r**2 + 3432*D1*Dd*K*b1*f**2*r*s - 2574*D1*Dd*K*b1*f**2*r + 1716*D1*Dd*K*b1*f**2*s**2 - 2574*D1*Dd*K*b1*f**2*s + 1287*D1*Dd*K*b1*f**2 - 6864*D1*Dd*K*b1*f*fd*r**2 - 13728*D1*Dd*K*b1*f*fd*r*s + 8580*D1*Dd*K*b1*f*fd*r - 6864*D1*Dd*K*b1*f*fd*s**2 + 8580*D1*Dd*K*b1*f*fd*s - 2574*D1*Dd*K*b1*f*fd - 1716*D1*Dd*b1*f**2*r**2 - 3432*D1*Dd*b1*f**2*r*s + 2574*D1*Dd*b1*f**2*r - 1716*D1*Dd*b1*f**2*s**2 + 2574*D1*Dd*b1*f**2*s - 1287*D1*Dd*b1*f**2 + 6864*D1*Dd*b1*f*fd*r**2 + 13728*D1*Dd*b1*f*fd*r*s - 8580*D1*Dd*b1*f*fd*r + 6864*D1*Dd*b1*f*fd*s**2 - 8580*D1*Dd*b1*f*fd*s + 2574*D1*Dd*b1*f*fd + 27600*D1*Dd*f**4*r**2 + 55200*D1*Dd*f**4*r*s - 41400*D1*Dd*f**4*r + 27600*D1*Dd*f**4*s**2 - 41400*D1*Dd*f**4*s + 20700*D1*Dd*f**4 - 235200*D1*Dd*f**3*fd*r**2 - 470400*D1*Dd*f**3*fd*r*s + 352800*D1*Dd*f**3*fd*r - 235200*D1*Dd*f**3*fd*s**2 + 352800*D1*Dd*f**3*fd*s - 132300*D1*Dd*f**3*fd - 1768*D1*Dd*f**3*r**2 - 3536*D1*Dd*f**3*r*s + 2652*D1*Dd*f**3*r - 1768*D1*Dd*f**3*s**2 + 2652*D1*Dd*f**3*s - 1326*D1*Dd*f**3 + 15600*D1*Dd*f**2*fd*r**2 + 31200*D1*Dd*f**2*fd*r*s - 22100*D1*Dd*f**2*fd*r + 15600*D1*Dd*f**2*fd*s**2 - 22100*D1*Dd*f**2*fd*s + 7800*D1*Dd*f**2*fd - 3432*D1*Dd*f**2*g2*r**2 - 6864*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 3432*D1*Dd*f**2*g2*s**2 + 5148*D1*Dd*f**2*g2*s - 2574*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r**2 + 13728*D1*Dd*f**2*gd2*r*s - 12012*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 12012*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r**2 + 27456*D1*Dd*f*fd*g2*r*s - 17160*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 17160*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 - 1716*D1*Ddd*K*b1*f**2*r**2 - 3432*D1*Ddd*K*b1*f**2*r*s + 2574*D1*Ddd*K*b1*f**2*r - 1716*D1*Ddd*K*b1*f**2*s**2 + 2574*D1*Ddd*K*b1*f**2*s - 1287*D1*Ddd*K*b1*f**2 + 1716*D1*Ddd*b1*f**2*r**2 + 3432*D1*Ddd*b1*f**2*r*s - 2574*D1*Ddd*b1*f**2*r + 1716*D1*Ddd*b1*f**2*s**2 - 2574*D1*Ddd*b1*f**2*s + 1287*D1*Ddd*b1*f**2 - 29400*D1*Ddd*f**4*r**2 - 58800*D1*Ddd*f**4*r*s + 44100*D1*Ddd*f**4*r - 29400*D1*Ddd*f**4*s**2 + 44100*D1*Ddd*f**4*s - 22050*D1*Ddd*f**4 + 2600*D1*Ddd*f**3*r**2 + 5200*D1*Ddd*f**3*r*s - 3900*D1*Ddd*f**3*r + 2600*D1*Ddd*f**3*s**2 - 3900*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r**2 + 6864*D1*Ddd*f**2*g2*r*s - 5148*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 5148*Dd**2*K*b1*f**2*r**2 - 10296*Dd**2*K*b1*f**2*r*s + 7722*Dd**2*K*b1*f**2*r - 5148*Dd**2*K*b1*f**2*s**2 + 7722*Dd**2*K*b1*f**2*s - 2574*Dd**2*K*b1*f**2 + 5148*Dd**2*b1*f**2*r**2 + 10296*Dd**2*b1*f**2*r*s - 7722*Dd**2*b1*f**2*r + 5148*Dd**2*b1*f**2*s**2 - 7722*Dd**2*b1*f**2*s + 2574*Dd**2*b1*f**2 - 88200*Dd**2*f**4*r**2 - 176400*Dd**2*f**4*r*s + 132300*Dd**2*f**4*r - 88200*Dd**2*f**4*s**2 + 132300*Dd**2*f**4*s - 44100*Dd**2*f**4 + 7800*Dd**2*f**3*r**2 + 15600*Dd**2*f**3*r*s - 11700*Dd**2*f**3*r + 7800*Dd**2*f**3*s**2 - 11700*Dd**2*f**3*s + 3900*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r**2 + 20592*Dd**2*f**2*g2*r*s - 15444*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2)/(2002*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**2*k1**6*(-2*D1*(r + s - 1)*(198*D1*bd1**2*f*(K - 1)*(r + s - 1) - D1*bd1*(230*f**3*(r + s - 1) + 4*f**2*(33*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) - 33*r - 33*s + 33) - 33*f*(fd*(10*C - 10)*(2*r + 2*s - 1) + (5*g2 - 12*gd2)*(r + s - 1)) + 396*fd*g2*(r + s)) + D1*bdd1*f*(280*f**2 + f*(165*C - 165) - 198*g2)*(r + s - 1) + 2*Dd*bd1*f*(280*f**2 + f*(165*C - 165) - 198*g2)*(4*r + 4*s - 3)) + 33*b1**2*(K - 1)*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(264*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s - 264*C*D1**2*f*fd*r + 264*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s + 132*C*D1**2*f*fd - 330*C*D1**2*f*fdd*r**2 - 660*C*D1**2*f*fdd*r*s + 330*C*D1**2*f*fdd*r - 330*C*D1**2*f*fdd*s**2 + 330*C*D1**2*f*fdd*s - 165*C*D1**2*f*fdd - 330*C*D1**2*fd**2*r**2 - 660*C*D1**2*fd**2*r*s + 330*C*D1**2*fd**2*r - 330*C*D1**2*fd**2*s**2 + 330*C*D1**2*fd**2*s + 528*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 792*C*D1*Dd*f**2*r + 528*C*D1*Dd*f**2*s**2 - 792*C*D1*Dd*f**2*s + 396*C*D1*Dd*f**2 - 2640*C*D1*Dd*f*fd*r**2 - 5280*C*D1*Dd*f*fd*r*s + 3300*C*D1*Dd*f*fd*r - 2640*C*D1*Dd*f*fd*s**2 + 3300*C*D1*Dd*f*fd*s - 990*C*D1*Dd*f*fd - 660*C*D1*Ddd*f**2*r**2 - 1320*C*D1*Ddd*f**2*r*s + 990*C*D1*Ddd*f**2*r - 660*C*D1*Ddd*f**2*s**2 + 990*C*D1*Ddd*f**2*s - 495*C*D1*Ddd*f**2 - 1980*C*Dd**2*f**2*r**2 - 3960*C*Dd**2*f**2*r*s + 2970*C*Dd**2*f**2*r - 1980*C*Dd**2*f**2*s**2 + 2970*C*Dd**2*f**2*s - 990*C*Dd**2*f**2 - 198*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 690*D1**2*f**2*fd*r**2 + 1380*D1**2*f**2*fd*r*s - 920*D1**2*f**2*fd*r + 690*D1**2*f**2*fd*s**2 - 920*D1**2*f**2*fd*s + 460*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 - 1680*D1**2*f**2*fdd*r*s + 1120*D1**2*f**2*fdd*r - 840*D1**2*f**2*fdd*s**2 + 1120*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd - 1680*D1**2*f*fd**2*r**2 - 3360*D1**2*f*fd**2*r*s + 2240*D1**2*f*fd**2*r - 1680*D1**2*f*fd**2*s**2 + 2240*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd + 330*D1**2*f*fdd*r**2 + 660*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 330*D1**2*f*fdd*s**2 - 330*D1**2*f*fdd*s + 165*D1**2*f*fdd - 165*D1**2*f*gd2*r**2 - 330*D1**2*f*gd2*r*s + 330*D1**2*f*gd2*r - 165*D1**2*f*gd2*s**2 + 330*D1**2*f*gd2*s - 165*D1**2*f*gd2 + 198*D1**2*f*gdd2*r**2 + 396*D1**2*f*gdd2*r*s - 396*D1**2*f*gdd2*r + 198*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s + 198*D1**2*f*gdd2 + 330*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 330*D1**2*fd**2*s**2 - 330*D1**2*fd**2*s - 165*D1**2*fd*g2*r**2 - 330*D1**2*fd*g2*r*s - 165*D1**2*fd*g2*s**2 + 396*D1**2*fd*gd2*r**2 + 792*D1**2*fd*gd2*r*s - 396*D1**2*fd*gd2*r + 396*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 198*D1**2*fdd*g2*r**2 + 396*D1**2*fdd*g2*r*s + 198*D1**2*fdd*g2*s**2 + 920*D1*Dd*f**3*r**2 + 1840*D1*Dd*f**3*r*s - 1380*D1*Dd*f**3*r + 920*D1*Dd*f**3*s**2 - 1380*D1*Dd*f**3*s + 690*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 - 13440*D1*Dd*f**2*fd*r*s + 9520*D1*Dd*f**2*fd*r - 6720*D1*Dd*f**2*fd*s**2 + 9520*D1*Dd*f**2*fd*s - 3360*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 + 5280*D1*Dd*f*fd*r*s - 3300*D1*Dd*f*fd*r + 2640*D1*Dd*f*fd*s**2 - 3300*D1*Dd*f*fd*s + 990*D1*Dd*f*fd - 660*D1*Dd*f*g2*r**2 - 1320*D1*Dd*f*g2*r*s + 990*D1*Dd*f*g2*r - 660*D1*Dd*f*g2*s**2 + 990*D1*Dd*f*g2*s - 495*D1*Dd*f*g2 + 1584*D1*Dd*f*gd2*r**2 + 3168*D1*Dd*f*gd2*r*s - 2772*D1*Dd*f*gd2*r + 1584*D1*Dd*f*gd2*s**2 - 2772*D1*Dd*f*gd2*s + 1188*D1*Dd*f*gd2 + 1584*D1*Dd*fd*g2*r**2 + 3168*D1*Dd*fd*g2*r*s - 1188*D1*Dd*fd*g2*r + 1584*D1*Dd*fd*g2*s**2 - 1188*D1*Dd*fd*g2*s - 1120*D1*Ddd*f**3*r**2 - 2240*D1*Ddd*f**3*r*s + 1680*D1*Ddd*f**3*r - 1120*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 840*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 + 1320*D1*Ddd*f**2*r*s - 990*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s**2 - 990*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 + 792*D1*Ddd*f*g2*r**2 + 1584*D1*Ddd*f*g2*r*s - 1188*D1*Ddd*f*g2*r + 792*D1*Ddd*f*g2*s**2 - 1188*D1*Ddd*f*g2*s + 594*D1*Ddd*f*g2 + 33*D1*bd1*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3360*Dd**2*f**3*r**2 - 6720*Dd**2*f**3*r*s + 5040*Dd**2*f**3*r - 3360*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 1680*Dd**2*f**3 + 1980*Dd**2*f**2*r**2 + 3960*Dd**2*f**2*r*s - 2970*Dd**2*f**2*r + 1980*Dd**2*f**2*s**2 - 2970*Dd**2*f**2*s + 990*Dd**2*f**2 + 2376*Dd**2*f*g2*r**2 + 4752*Dd**2*f*g2*r*s - 3564*Dd**2*f*g2*r + 2376*Dd**2*f*g2*s**2 - 3564*Dd**2*f*g2*s + 1188*Dd**2*f*g2))/(77*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct**2*k1**4*k2**2*st**2*(-132*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 132*D1**2*bdd1*f*(f*(C + 2*K - 2) - g2)*(r + s - 1)**2 - 2*D1**2*(75*f**3*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-fd*(213*C - 157)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(200*C - 150)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (341*gd2 - 264*gdd2)*(r + s - 1)**2) + f*(fd**2*(400*C - 300)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 11*fd*(31*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 48*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 264*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 528*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 11*D1*bd1*(D1*(12*f**3*(r + s - 1) + f**2*(22*C + 31*K - 37)*(r + s - 1) - 24*f*fd*(C + 2*K - 2)*(2*r + 2*s - 1) - 2*f*(19*g2 - 12*gd2)*(r + s - 1) + 24*fd*g2*(r + s)) - 24*Dd*f*(f*(C + 2*K - 2) - g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(75*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(213*C - 157)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(fd*(400*C - 300)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 341*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 528*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - 528*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2*Ddd*f*(f*(100*C - 75) - 132*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Dd**2*f**2*(f*(100*C - 75) - 132*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 11*b1**2*(K - 1)*(D1**2*(19*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(19*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(44*C*D1**2*f*fd*r**2 + 88*C*D1**2*f*fd*r*s - 44*C*D1**2*f*fd*r + 44*C*D1**2*f*fd*s**2 - 44*C*D1**2*f*fd*s + 22*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 + 24*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 + 24*C*D1**2*fd**2*s + 88*C*D1*Dd*f**2*r**2 + 176*C*D1*Dd*f**2*r*s - 132*C*D1*Dd*f**2*r + 88*C*D1*Dd*f**2*s**2 - 132*C*D1*Dd*f**2*s + 66*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s + 240*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 240*C*D1*Dd*f*fd*s - 72*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r*s + 72*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 72*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r*s + 216*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 216*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 + 62*D1**2*K*f*fd*r**2 + 124*D1**2*K*f*fd*r*s - 62*D1**2*K*f*fd*r + 62*D1**2*K*f*fd*s**2 - 62*D1**2*K*f*fd*s + 31*D1**2*K*f*fd - 48*D1**2*K*f*fdd*r**2 - 96*D1**2*K*f*fdd*r*s + 48*D1**2*K*f*fdd*r - 48*D1**2*K*f*fdd*s**2 + 48*D1**2*K*f*fdd*s - 24*D1**2*K*f*fdd - 48*D1**2*K*fd**2*r**2 - 96*D1**2*K*fd**2*r*s + 48*D1**2*K*fd**2*r - 48*D1**2*K*fd**2*s**2 + 48*D1**2*K*fd**2*s - 12*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 36*D1**2*f**2*fd*r**2 + 72*D1**2*f**2*fd*r*s - 48*D1**2*f**2*fd*r + 36*D1**2*f**2*fd*s**2 - 48*D1**2*f**2*fd*s + 24*D1**2*f**2*fd - 74*D1**2*f*fd*r**2 - 148*D1**2*f*fd*r*s + 74*D1**2*f*fd*r - 74*D1**2*f*fd*s**2 + 74*D1**2*f*fd*s - 37*D1**2*f*fd + 48*D1**2*f*fdd*r**2 + 96*D1**2*f*fdd*r*s - 48*D1**2*f*fdd*r + 48*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 24*D1**2*f*fdd - 38*D1**2*f*gd2*r**2 - 76*D1**2*f*gd2*r*s + 76*D1**2*f*gd2*r - 38*D1**2*f*gd2*s**2 + 76*D1**2*f*gd2*s - 38*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*r + 12*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s + 12*D1**2*f*gdd2 + 48*D1**2*fd**2*r**2 + 96*D1**2*fd**2*r*s - 48*D1**2*fd**2*r + 48*D1**2*fd**2*s**2 - 48*D1**2*fd**2*s - 38*D1**2*fd*g2*r**2 - 76*D1**2*fd*g2*r*s - 38*D1**2*fd*g2*s**2 + 24*D1**2*fd*gd2*r**2 + 48*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 24*D1**2*fd*gd2*s + 12*D1**2*fdd*g2*r**2 + 24*D1**2*fdd*g2*r*s + 12*D1**2*fdd*g2*s**2 + 124*D1*Dd*K*f**2*r**2 + 248*D1*Dd*K*f**2*r*s - 186*D1*Dd*K*f**2*r + 124*D1*Dd*K*f**2*s**2 - 186*D1*Dd*K*f**2*s + 93*D1*Dd*K*f**2 - 384*D1*Dd*K*f*fd*r**2 - 768*D1*Dd*K*f*fd*r*s + 480*D1*Dd*K*f*fd*r - 384*D1*Dd*K*f*fd*s**2 + 480*D1*Dd*K*f*fd*s - 144*D1*Dd*K*f*fd + 48*D1*Dd*f**3*r**2 + 96*D1*Dd*f**3*r*s - 72*D1*Dd*f**3*r + 48*D1*Dd*f**3*s**2 - 72*D1*Dd*f**3*s + 36*D1*Dd*f**3 - 148*D1*Dd*f**2*r**2 - 296*D1*Dd*f**2*r*s + 222*D1*Dd*f**2*r - 148*D1*Dd*f**2*s**2 + 222*D1*Dd*f**2*s - 111*D1*Dd*f**2 + 384*D1*Dd*f*fd*r**2 + 768*D1*Dd*f*fd*r*s - 480*D1*Dd*f*fd*r + 384*D1*Dd*f*fd*s**2 - 480*D1*Dd*f*fd*s + 144*D1*Dd*f*fd - 152*D1*Dd*f*g2*r**2 - 304*D1*Dd*f*g2*r*s + 228*D1*Dd*f*g2*r - 152*D1*Dd*f*g2*s**2 + 228*D1*Dd*f*g2*s - 114*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 192*D1*Dd*f*gd2*r*s - 168*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 168*D1*Dd*f*gd2*s + 72*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 192*D1*Dd*fd*g2*r*s - 72*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 72*D1*Dd*fd*g2*s - 96*D1*Ddd*K*f**2*r**2 - 192*D1*Ddd*K*f**2*r*s + 144*D1*Ddd*K*f**2*r - 96*D1*Ddd*K*f**2*s**2 + 144*D1*Ddd*K*f**2*s - 72*D1*Ddd*K*f**2 + 96*D1*Ddd*f**2*r**2 + 192*D1*Ddd*f**2*r*s - 144*D1*Ddd*f**2*r + 96*D1*Ddd*f**2*s**2 - 144*D1*Ddd*f**2*s + 72*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 96*D1*Ddd*f*g2*r*s - 72*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 72*D1*Ddd*f*g2*s + 36*D1*Ddd*f*g2 + 2*D1*bd1*(K - 1)*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 288*Dd**2*K*f**2*r**2 - 576*Dd**2*K*f**2*r*s + 432*Dd**2*K*f**2*r - 288*Dd**2*K*f**2*s**2 + 432*Dd**2*K*f**2*s - 144*Dd**2*K*f**2 + 288*Dd**2*f**2*r**2 + 576*Dd**2*f**2*r*s - 432*Dd**2*f**2*r + 288*Dd**2*f**2*s**2 - 432*Dd**2*f**2*s + 144*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 288*Dd**2*f*g2*r*s - 216*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 216*Dd**2*f*g2*s + 72*Dd**2*f*g2))/(154*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**2*k1**4*k2**2*(-2640*C*D1**2*bdd1*f**2*r**2 - 5280*C*D1**2*bdd1*f**2*r*s + 5280*C*D1**2*bdd1*f**2*r - 2640*C*D1**2*bdd1*f**2*s**2 + 5280*C*D1**2*bdd1*f**2*s - 2640*C*D1**2*bdd1*f**2 + 690*C*D1**2*f**2*fd*r**2 + 1380*C*D1**2*f**2*fd*r*s - 920*C*D1**2*f**2*fd*r + 690*C*D1**2*f**2*fd*s**2 - 920*C*D1**2*f**2*fd*s + 460*C*D1**2*f**2*fd - 840*C*D1**2*f**2*fdd*r**2 - 1680*C*D1**2*f**2*fdd*r*s + 1120*C*D1**2*f**2*fdd*r - 840*C*D1**2*f**2*fdd*s**2 + 1120*C*D1**2*f**2*fdd*s - 560*C*D1**2*f**2*fdd - 1680*C*D1**2*f*fd**2*r**2 - 3360*C*D1**2*f*fd**2*r*s + 2240*C*D1**2*f*fd**2*r - 1680*C*D1**2*f*fd**2*s**2 + 2240*C*D1**2*f*fd**2*s - 560*C*D1**2*f*fd**2 + 920*C*D1*Dd*f**3*r**2 + 1840*C*D1*Dd*f**3*r*s - 1380*C*D1*Dd*f**3*r + 920*C*D1*Dd*f**3*s**2 - 1380*C*D1*Dd*f**3*s + 690*C*D1*Dd*f**3 - 6720*C*D1*Dd*f**2*fd*r**2 - 13440*C*D1*Dd*f**2*fd*r*s + 9520*C*D1*Dd*f**2*fd*r - 6720*C*D1*Dd*f**2*fd*s**2 + 9520*C*D1*Dd*f**2*fd*s - 3360*C*D1*Dd*f**2*fd - 1120*C*D1*Ddd*f**3*r**2 - 2240*C*D1*Ddd*f**3*r*s + 1680*C*D1*Ddd*f**3*r - 1120*C*D1*Ddd*f**3*s**2 + 1680*C*D1*Ddd*f**3*s - 840*C*D1*Ddd*f**3 - 3360*C*Dd**2*f**3*r**2 - 6720*C*Dd**2*f**3*r*s + 5040*C*Dd**2*f**3*r - 3360*C*Dd**2*f**3*s**2 + 5040*C*Dd**2*f**3*s - 1680*C*Dd**2*f**3 - 165*D1**2*K*bdd1*f**2*r**2 - 330*D1**2*K*bdd1*f**2*r*s + 330*D1**2*K*bdd1*f**2*r - 165*D1**2*K*bdd1*f**2*s**2 + 330*D1**2*K*bdd1*f**2*s - 165*D1**2*K*bdd1*f**2 + 132*D1**2*bd1**2*f*(-24*K + 25*f + 12)*(r + s - 1)**2 + 1980*D1**2*bdd1*f**2*r**2 + 3960*D1**2*bdd1*f**2*r*s - 3960*D1**2*bdd1*f**2*r + 1980*D1**2*bdd1*f**2*s**2 - 3960*D1**2*bdd1*f**2*s + 1980*D1**2*bdd1*f**2 + 3168*D1**2*bdd1*f*g2*r**2 + 6336*D1**2*bdd1*f*g2*r*s - 6336*D1**2*bdd1*f*g2*r + 3168*D1**2*bdd1*f*g2*s**2 - 6336*D1**2*bdd1*f*g2*s + 3168*D1**2*bdd1*f*g2 - 345*D1**2*f**2*fd*r**2 - 690*D1**2*f**2*fd*r*s + 460*D1**2*f**2*fd*r - 345*D1**2*f**2*fd*s**2 + 460*D1**2*f**2*fd*s - 230*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s + 528*D1**2*f**2*gd2*r - 264*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s - 264*D1**2*f**2*gd2 + 330*D1**2*f**2*gdd2*r**2 + 660*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*r + 330*D1**2*f**2*gdd2*s**2 - 660*D1**2*f**2*gdd2*s + 330*D1**2*f**2*gdd2 + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*r**2 + 2640*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 1320*D1**2*f*fd*gd2*s**2 - 1980*D1**2*f*fd*gd2*s + 660*D1**2*f*fd*gd2 + 660*D1**2*f*fdd*g2*r**2 + 1320*D1**2*f*fdd*g2*r*s - 660*D1**2*f*fdd*g2*r + 660*D1**2*f*fdd*g2*s**2 - 660*D1**2*f*fdd*g2*s + 330*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*r**2 + 1320*D1**2*fd**2*g2*r*s - 660*D1**2*fd**2*g2*r + 660*D1**2*fd**2*g2*s**2 - 660*D1**2*fd**2*g2*s - 460*D1*Dd*f**3*r**2 - 920*D1*Dd*f**3*r*s + 690*D1*Dd*f**3*r - 460*D1*Dd*f**3*s**2 + 690*D1*Dd*f**3*s - 345*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s + 1584*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 792*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*r**2 + 5280*D1*Dd*f**2*gd2*r*s - 4620*D1*Dd*f**2*gd2*r + 2640*D1*Dd*f**2*gd2*s**2 - 4620*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 5280*D1*Dd*f*fd*g2*r**2 + 10560*D1*Dd*f*fd*g2*r*s - 6600*D1*Dd*f*fd*g2*r + 5280*D1*Dd*f*fd*g2*s**2 - 6600*D1*Dd*f*fd*g2*s + 1980*D1*Dd*f*fd*g2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*g2*r**2 + 2640*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 1320*D1*Ddd*f**2*g2*s**2 - 1980*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(5*f**3*(r + s - 1) - 2*f**2*(13*C + K - 9)*(r + s - 1) + 5*f*fd*(16*C + K - 12)*(2*r + 2*s - 1) + 3*f*(11*g2 - 32*gd2)*(r + s - 1) - 96*fd*g2*(r + s)) + Dd*f*(5*f*(16*C + K - 12) - 96*g2)*(4*r + 4*s - 3))*(r + s - 1) + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 3960*Dd**2*f**2*g2*r**2 + 7920*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 3960*Dd**2*f**2*g2*s**2 - 5940*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(2*f*(23*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(33*K - 13)*(r + s) - 24*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(46*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (33*K - 13)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 48*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(-24*K + 25*f + 12)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(-24*K + 25*f + 12)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-104*C*D1**2*f*fd*r**2 - 208*C*D1**2*f*fd*r*s + 104*C*D1**2*f*fd*r - 104*C*D1**2*f*fd*s**2 + 104*C*D1**2*f*fd*s - 52*C*D1**2*f*fd + 160*C*D1**2*f*fdd*r**2 + 320*C*D1**2*f*fdd*r*s - 160*C*D1**2*f*fdd*r + 160*C*D1**2*f*fdd*s**2 - 160*C*D1**2*f*fdd*s + 80*C*D1**2*f*fdd + 160*C*D1**2*fd**2*r**2 + 320*C*D1**2*fd**2*r*s - 160*C*D1**2*fd**2*r + 160*C*D1**2*fd**2*s**2 - 160*C*D1**2*fd**2*s - 208*C*D1*Dd*f**2*r**2 - 416*C*D1*Dd*f**2*r*s + 312*C*D1*Dd*f**2*r - 208*C*D1*Dd*f**2*s**2 + 312*C*D1*Dd*f**2*s - 156*C*D1*Dd*f**2 + 1280*C*D1*Dd*f*fd*r**2 + 2560*C*D1*Dd*f*fd*r*s - 1600*C*D1*Dd*f*fd*r + 1280*C*D1*Dd*f*fd*s**2 - 1600*C*D1*Dd*f*fd*s + 480*C*D1*Dd*f*fd + 320*C*D1*Ddd*f**2*r**2 + 640*C*D1*Ddd*f**2*r*s - 480*C*D1*Ddd*f**2*r + 320*C*D1*Ddd*f**2*s**2 - 480*C*D1*Ddd*f**2*s + 240*C*D1*Ddd*f**2 + 960*C*Dd**2*f**2*r**2 + 1920*C*Dd**2*f**2*r*s - 1440*C*Dd**2*f**2*r + 960*C*Dd**2*f**2*s**2 - 1440*C*Dd**2*f**2*s + 480*C*Dd**2*f**2 - 8*D1**2*K*f*fd*r**2 - 16*D1**2*K*f*fd*r*s + 8*D1**2*K*f*fd*r - 8*D1**2*K*f*fd*s**2 + 8*D1**2*K*f*fd*s - 4*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r**2 + 20*D1**2*K*f*fdd*r*s - 10*D1**2*K*f*fdd*r + 10*D1**2*K*f*fdd*s**2 - 10*D1**2*K*f*fdd*s + 5*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r**2 + 20*D1**2*K*fd**2*r*s - 10*D1**2*K*fd**2*r + 10*D1**2*K*fd**2*s**2 - 10*D1**2*K*fd**2*s - 4*D1**2*bdd1*f*(-24*K + 25*f + 12)*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd + 72*D1**2*f*fd*r**2 + 144*D1**2*f*fd*r*s - 72*D1**2*f*fd*r + 72*D1**2*f*fd*s**2 - 72*D1**2*f*fd*s + 36*D1**2*f*fd - 120*D1**2*f*fdd*r**2 - 240*D1**2*f*fdd*r*s + 120*D1**2*f*fdd*r - 120*D1**2*f*fdd*s**2 + 120*D1**2*f*fdd*s - 60*D1**2*f*fdd + 66*D1**2*f*gd2*r**2 + 132*D1**2*f*gd2*r*s - 132*D1**2*f*gd2*r + 66*D1**2*f*gd2*s**2 - 132*D1**2*f*gd2*s + 66*D1**2*f*gd2 - 96*D1**2*f*gdd2*r**2 - 192*D1**2*f*gdd2*r*s + 192*D1**2*f*gdd2*r - 96*D1**2*f*gdd2*s**2 + 192*D1**2*f*gdd2*s - 96*D1**2*f*gdd2 - 120*D1**2*fd**2*r**2 - 240*D1**2*fd**2*r*s + 120*D1**2*fd**2*r - 120*D1**2*fd**2*s**2 + 120*D1**2*fd**2*s + 66*D1**2*fd*g2*r**2 + 132*D1**2*fd*g2*r*s + 66*D1**2*fd*g2*s**2 - 192*D1**2*fd*gd2*r**2 - 384*D1**2*fd*gd2*r*s + 192*D1**2*fd*gd2*r - 192*D1**2*fd*gd2*s**2 + 192*D1**2*fd*gd2*s - 96*D1**2*fdd*g2*r**2 - 192*D1**2*fdd*g2*r*s - 96*D1**2*fdd*g2*s**2 - 16*D1*Dd*K*f**2*r**2 - 32*D1*Dd*K*f**2*r*s + 24*D1*Dd*K*f**2*r - 16*D1*Dd*K*f**2*s**2 + 24*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r**2 + 160*D1*Dd*K*f*fd*r*s - 100*D1*Dd*K*f*fd*r + 80*D1*Dd*K*f*fd*s**2 - 100*D1*Dd*K*f*fd*s + 30*D1*Dd*K*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 + 144*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 216*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 216*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 960*D1*Dd*f*fd*r**2 - 1920*D1*Dd*f*fd*r*s + 1200*D1*Dd*f*fd*r - 960*D1*Dd*f*fd*s**2 + 1200*D1*Dd*f*fd*s - 360*D1*Dd*f*fd + 264*D1*Dd*f*g2*r**2 + 528*D1*Dd*f*g2*r*s - 396*D1*Dd*f*g2*r + 264*D1*Dd*f*g2*s**2 - 396*D1*Dd*f*g2*s + 198*D1*Dd*f*g2 - 768*D1*Dd*f*gd2*r**2 - 1536*D1*Dd*f*gd2*r*s + 1344*D1*Dd*f*gd2*r - 768*D1*Dd*f*gd2*s**2 + 1344*D1*Dd*f*gd2*s - 576*D1*Dd*f*gd2 - 768*D1*Dd*fd*g2*r**2 - 1536*D1*Dd*fd*g2*r*s + 576*D1*Dd*fd*g2*r - 768*D1*Dd*fd*g2*s**2 + 576*D1*Dd*fd*g2*s + 20*D1*Ddd*K*f**2*r**2 + 40*D1*Ddd*K*f**2*r*s - 30*D1*Ddd*K*f**2*r + 20*D1*Ddd*K*f**2*s**2 - 30*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 240*D1*Ddd*f**2*r**2 - 480*D1*Ddd*f**2*r*s + 360*D1*Ddd*f**2*r - 240*D1*Ddd*f**2*s**2 + 360*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 384*D1*Ddd*f*g2*r**2 - 768*D1*Ddd*f*g2*r*s + 576*D1*Ddd*f*g2*r - 384*D1*Ddd*f*g2*s**2 + 576*D1*Ddd*f*g2*s - 288*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(46*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(33*K - 13)*(r + s - 1) + 48*fd*(2*K - 1)*(r + s)) - 4*Dd*f*(-24*K + 25*f + 12)*(4*r + 4*s - 3))*(r + s - 1) + 60*Dd**2*K*f**2*r**2 + 120*Dd**2*K*f**2*r*s - 90*Dd**2*K*f**2*r + 60*Dd**2*K*f**2*s**2 - 90*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 720*Dd**2*f**2*r**2 - 1440*Dd**2*f**2*r*s + 1080*Dd**2*f**2*r - 720*Dd**2*f**2*s**2 + 1080*Dd**2*f**2*s - 360*Dd**2*f**2 - 1152*Dd**2*f*g2*r**2 - 2304*Dd**2*f*g2*r*s + 1728*Dd**2*f*g2*r - 1152*Dd**2*f*g2*s**2 + 1728*Dd**2*f*g2*s - 576*Dd**2*f*g2))/(77*d**2*k3**7) - D1**2*Pk2*Pkd3*ct**2*k1**4*st**2*(330*C*D1**2*bdd1*f**2*r**2 + 1452*C*D1**2*bdd1*f**2*r*s - 792*C*D1**2*bdd1*f**2*r + 1122*C*D1**2*bdd1*f**2*s**2 - 1584*C*D1**2*bdd1*f**2*s + 792*C*D1**2*bdd1*f**2 + 3786*C*D1**2*f**2*fd*r**2 + 7980*C*D1**2*f**2*fd*r*s - 5184*C*D1**2*f**2*fd*r + 4194*C*D1**2*f**2*fd*s**2 - 5456*C*D1**2*f**2*fd*s + 2660*C*D1**2*f**2*fd - 2982*C*D1**2*f**2*fdd*r**2 - 8148*C*D1**2*f**2*fdd*r*s + 4704*C*D1**2*f**2*fdd*r - 5166*C*D1**2*f**2*fdd*s**2 + 6160*C*D1**2*f**2*fdd*s - 2716*C*D1**2*f**2*fdd - 5964*C*D1**2*f*fd**2*r**2 - 16296*C*D1**2*f*fd**2*r*s + 9408*C*D1**2*f*fd**2*r - 10332*C*D1**2*f*fd**2*s**2 + 12320*C*D1**2*f*fd**2*s - 2716*C*D1**2*f*fd**2 + 5048*C*D1*Dd*f**3*r**2 + 10640*C*D1*Dd*f**3*r*s - 7708*C*D1*Dd*f**3*r + 5592*C*D1*Dd*f**3*s**2 - 8116*C*D1*Dd*f**3*s + 3922*C*D1*Dd*f**3 - 23856*C*D1*Dd*f**2*fd*r**2 - 65184*C*D1*Dd*f**2*fd*r*s + 38892*C*D1*Dd*f**2*fd*r - 41328*C*D1*Dd*f**2*fd*s**2 + 51268*C*D1*Dd*f**2*fd*s - 15568*C*D1*Dd*f**2*fd - 3976*C*D1*Ddd*f**3*r**2 - 10864*C*D1*Ddd*f**3*r*s + 6692*C*D1*Ddd*f**3*r - 6888*C*D1*Ddd*f**3*s**2 + 8876*C*D1*Ddd*f**3*s - 3710*C*D1*Ddd*f**3 - 11928*C*Dd**2*f**3*r**2 - 32592*C*Dd**2*f**3*r*s + 20076*C*Dd**2*f**3*r - 20664*C*Dd**2*f**3*s**2 + 26628*C*Dd**2*f**3*s - 7420*C*Dd**2*f**3 - 561*D1**2*K*bdd1*f**2*r**2 - 1518*D1**2*K*bdd1*f**2*r*s + 1122*D1**2*K*bdd1*f**2*r - 957*D1**2*K*bdd1*f**2*s**2 + 1518*D1**2*K*bdd1*f**2*s - 561*D1**2*K*bdd1*f**2 + 66*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 23*s + 6) + 5250*D1**2*bdd1*f**3*r**2 + 11700*D1**2*bdd1*f**3*r*s - 9600*D1**2*bdd1*f**3*r + 6450*D1**2*bdd1*f**3*s**2 - 10800*D1**2*bdd1*f**3*s + 6600*D1**2*bdd1*f**3 + 2211*D1**2*bdd1*f**2*r**2 + 4422*D1**2*bdd1*f**2*r*s - 4290*D1**2*bdd1*f**2*r + 2211*D1**2*bdd1*f**2*s**2 - 4290*D1**2*bdd1*f**2*s + 1749*D1**2*bdd1*f**2 - 330*D1**2*bdd1*f*g2*r**2 - 1452*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r - 1122*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 + 18600*D1**2*f**3*fd*r**2 + 63600*D1**2*f**3*fd*r*s - 34500*D1**2*f**3*fd*r + 45000*D1**2*f**3*fd*s**2 - 54300*D1**2*f**3*fd*s + 20550*D1**2*f**3*fd - 22200*D1**2*f**3*fdd*r**2 - 56400*D1**2*f**3*fdd*r*s + 36300*D1**2*f**3*fdd*r - 34200*D1**2*f**3*fdd*s**2 + 45300*D1**2*f**3*fdd*s - 19650*D1**2*f**3*fdd - 66600*D1**2*f**2*fd**2*r**2 - 169200*D1**2*f**2*fd**2*r*s + 108900*D1**2*f**2*fd**2*r - 102600*D1**2*f**2*fd**2*s**2 + 135900*D1**2*f**2*fd**2*s - 39300*D1**2*f**2*fd**2 - 8826*D1**2*f**2*fd*r**2 - 19464*D1**2*f**2*fd*r*s + 12372*D1**2*f**2*fd*r - 10638*D1**2*f**2*fd*s**2 + 13580*D1**2*f**2*fd*s - 6488*D1**2*f**2*fd + 7482*D1**2*f**2*fdd*r**2 + 18048*D1**2*f**2*fdd*r*s - 11004*D1**2*f**2*fdd*r + 10566*D1**2*f**2*fdd*s**2 - 13060*D1**2*f**2*fdd*s + 6016*D1**2*f**2*fdd - 1518*D1**2*f**2*gd2*r**2 - 3300*D1**2*f**2*gd2*r*s + 3036*D1**2*f**2*gd2*r - 1782*D1**2*f**2*gd2*s**2 + 3300*D1**2*f**2*gd2*s - 1518*D1**2*f**2*gd2 + 1122*D1**2*f**2*gdd2*r**2 + 3036*D1**2*f**2*gdd2*r*s - 2244*D1**2*f**2*gdd2*r + 1914*D1**2*f**2*gdd2*s**2 - 3036*D1**2*f**2*gdd2*s + 1122*D1**2*f**2*gdd2 + 14964*D1**2*f*fd**2*r**2 + 36096*D1**2*f*fd**2*r*s - 22008*D1**2*f*fd**2*r + 21132*D1**2*f*fd**2*s**2 - 26120*D1**2*f*fd**2*s + 6016*D1**2*f*fd**2 - 3036*D1**2*f*fd*g2*r**2 - 6600*D1**2*f*fd*g2*r*s + 3300*D1**2*f*fd*g2*r - 3564*D1**2*f*fd*g2*s**2 + 3564*D1**2*f*fd*g2*s - 1782*D1**2*f*fd*g2 + 4488*D1**2*f*fd*gd2*r**2 + 12144*D1**2*f*fd*gd2*r*s - 7524*D1**2*f*fd*gd2*r + 7656*D1**2*f*fd*gd2*s**2 - 9900*D1**2*f*fd*gd2*s + 3036*D1**2*f*fd*gd2 + 2244*D1**2*f*fdd*g2*r**2 + 6072*D1**2*f*fdd*g2*r*s - 3036*D1**2*f*fdd*g2*r + 3828*D1**2*f*fdd*g2*s**2 - 3828*D1**2*f*fdd*g2*s + 1914*D1**2*f*fdd*g2 + 2244*D1**2*fd**2*g2*r**2 + 6072*D1**2*fd**2*g2*r*s - 3036*D1**2*fd**2*g2*r + 3828*D1**2*fd**2*g2*s**2 - 3828*D1**2*fd**2*g2*s + 18600*D1*Dd*f**4*r**2 + 63600*D1*Dd*f**4*r*s - 34500*D1*Dd*f**4*r + 45000*D1*Dd*f**4*s**2 - 54300*D1*Dd*f**4*s + 20550*D1*Dd*f**4 - 177600*D1*Dd*f**3*fd*r**2 - 451200*D1*Dd*f**3*fd*r*s + 290400*D1*Dd*f**3*fd*r - 273600*D1*Dd*f**3*fd*s**2 + 362400*D1*Dd*f**3*fd*s - 117900*D1*Dd*f**3*fd - 11768*D1*Dd*f**3*r**2 - 25952*D1*Dd*f**3*r*s + 18256*D1*Dd*f**3*r - 14184*D1*Dd*f**3*s**2 + 20068*D1*Dd*f**3*s - 9430*D1*Dd*f**3 + 59856*D1*Dd*f**2*fd*r**2 + 144384*D1*Dd*f**2*fd*r*s - 91992*D1*Dd*f**2*fd*r + 84528*D1*Dd*f**2*fd*s**2 - 109468*D1*Dd*f**2*fd*s + 35068*D1*Dd*f**2*fd - 6072*D1*Dd*f**2*g2*r**2 - 13200*D1*Dd*f**2*g2*r*s + 9372*D1*Dd*f**2*g2*r - 7128*D1*Dd*f**2*g2*s**2 + 10164*D1*Dd*f**2*g2*s - 4818*D1*Dd*f**2*g2 + 8976*D1*Dd*f**2*gd2*r**2 + 24288*D1*Dd*f**2*gd2*r*s - 16500*D1*Dd*f**2*gd2*r + 15312*D1*Dd*f**2*gd2*s**2 - 22044*D1*Dd*f**2*gd2*s + 7524*D1*Dd*f**2*gd2 + 17952*D1*Dd*f*fd*g2*r**2 + 48576*D1*Dd*f*fd*g2*r*s - 27192*D1*Dd*f*fd*g2*r + 30624*D1*Dd*f*fd*g2*s**2 - 35112*D1*Dd*f*fd*g2*s + 9900*D1*Dd*f*fd*g2 - 22200*D1*Ddd*f**4*r**2 - 56400*D1*Ddd*f**4*r*s + 36300*D1*Ddd*f**4*r - 34200*D1*Ddd*f**4*s**2 + 45300*D1*Ddd*f**4*s - 19650*D1*Ddd*f**4 + 9976*D1*Ddd*f**3*r**2 + 24064*D1*Ddd*f**3*r*s - 15992*D1*Ddd*f**3*r + 14088*D1*Ddd*f**3*s**2 - 19076*D1*Ddd*f**3*s + 8510*D1*Ddd*f**3 + 4488*D1*Ddd*f**2*g2*r**2 + 12144*D1*Ddd*f**2*g2*r*s - 7524*D1*Ddd*f**2*g2*r + 7656*D1*Ddd*f**2*g2*s**2 - 9900*D1*Ddd*f**2*g2*s + 4158*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(2*f**3*(925*r**2 + r*(2250*s - 2012) + 1325*s**2 - 2412*s + 1507) + f**2*(22*C*(5*r**2 + r*(34*s - 24) + 29*s**2 - 48*s + 24) - 11*K*(23*r**2 + 50*r*s - 46*r + 27*s**2 - 50*s + 23) - 100*fd*(105*r**2 + r*(234*s - 173) + 129*s**2 - 193*s + 56) + 1023*r**2 + 1782*r*s - 1738*r + 759*s**2 - 1474*s + 605) - 22*f*(fd*(4*C*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 20*s + 3) - K*(34*r**2 + 92*r*s - 57*r + 58*s**2 - 75*s + 23) + 134*r**2 + 268*r*s - 199*r + 134*s**2 - 199*s + 77) + 3*g2*(15*r**2 + r*(38*s - 8) + 23*s**2 - 16*s + 8) - 2*gd2*(5*r**2 + 11*r*(2*s - 1) + 17*s**2 - 23*s + 6)) + 44*fd*g2*(5*r**2 + 11*r*(2*s - 1) + s*(17*s - 17))) - 2*Dd*f*(50*f**2*(140*r**2 + 3*r*(104*s - 79) + 172*s**2 - 265*s + 100) + 11*f*(2*C*(20*r**2 + r*(88*s - 45) + 68*s**2 - 87*s + 24) - K*(68*r**2 + 184*r*s - 125*r + 116*s**2 - 167*s + 57) + 268*r**2 + 536*r*s - 461*r + 268*s**2 - 461*s + 195) - 22*g2*(20*r**2 + r*(88*s - 45) + 68*s**2 - 87*s + 24))) - 66600*Dd**2*f**4*r**2 - 169200*Dd**2*f**4*r*s + 108900*Dd**2*f**4*r - 102600*Dd**2*f**4*s**2 + 135900*Dd**2*f**4*s - 39300*Dd**2*f**4 + 29928*Dd**2*f**3*r**2 + 72192*Dd**2*f**3*r*s - 47976*Dd**2*f**3*r + 42264*Dd**2*f**3*s**2 - 57228*Dd**2*f**3*s + 17020*Dd**2*f**3 + 13464*Dd**2*f**2*g2*r**2 + 36432*Dd**2*f**2*g2*r*s - 22572*Dd**2*f**2*g2*r + 22968*Dd**2*f**2*g2*s**2 - 29700*Dd**2*f**2*g2*s + 8316*Dd**2*f**2*g2 - 33*b1**2*(K - 1)*(D1**2*(3*fd*(15*r**2 + 38*r*s - 30*r + 23*s**2 - 30*s + 15) - fdd*(5*r**2 + 22*r*s - 10*r + 17*s**2 - 10*s + 5)) + D1*(Dd*(3*f*(60*r**2 + 152*r*s - 98*r + 92*s**2 - 122*s + 53) - 2*fd*(20*r**2 + 88*r*s - 41*r + 68*s**2 - 59*s + 15)) - Ddd*f*(20*r**2 + r*(88*s - 42) + 68*s**2 - 78*s + 27)) - 6*Dd**2*f*(10*r**2 + r*(44*s - 21) + 34*s**2 - 39*s + 9)) - 3*b1*(220*C*D1**2*f*fd*r**2 + 1496*C*D1**2*f*fd*r*s - 440*C*D1**2*f*fd*r + 1276*C*D1**2*f*fd*s**2 - 968*C*D1**2*f*fd*s + 220*C*D1**2*f*fd - 220*C*D1**2*f*fdd*r**2 - 968*C*D1**2*f*fdd*r*s + 440*C*D1**2*f*fdd*r - 748*C*D1**2*f*fdd*s**2 + 704*C*D1**2*f*fdd*s - 220*C*D1**2*f*fdd - 220*C*D1**2*fd**2*r**2 - 968*C*D1**2*fd**2*r*s + 440*C*D1**2*fd**2*r - 748*C*D1**2*fd**2*s**2 + 704*C*D1**2*fd**2*s - 220*C*D1**2*fd**2 + 440*C*D1*Dd*f**2*r**2 + 2992*C*D1*Dd*f**2*r*s - 1188*C*D1*Dd*f**2*r + 2552*C*D1*Dd*f**2*s**2 - 2772*C*D1*Dd*f**2*s + 858*C*D1*Dd*f**2 - 1760*C*D1*Dd*f*fd*r**2 - 7744*C*D1*Dd*f*fd*r*s + 3608*C*D1*Dd*f*fd*r - 5984*C*D1*Dd*f*fd*s**2 + 6248*C*D1*Dd*f*fd*s - 1584*C*D1*Dd*f*fd - 440*C*D1*Ddd*f**2*r**2 - 1936*C*D1*Ddd*f**2*r*s + 924*C*D1*Ddd*f**2*r - 1496*C*D1*Ddd*f**2*s**2 + 1716*C*D1*Ddd*f**2*s - 594*C*D1*Ddd*f**2 - 1320*C*Dd**2*f**2*r**2 - 5808*C*Dd**2*f**2*r*s + 2772*C*Dd**2*f**2*r - 4488*C*Dd**2*f**2*s**2 + 5148*C*Dd**2*f**2*s - 1188*C*Dd**2*f**2 - 506*D1**2*K*f*fd*r**2 - 1100*D1**2*K*f*fd*r*s + 550*D1**2*K*f*fd*r - 594*D1**2*K*f*fd*s**2 + 594*D1**2*K*f*fd*s - 297*D1**2*K*f*fd + 374*D1**2*K*f*fdd*r**2 + 1012*D1**2*K*f*fdd*r*s - 506*D1**2*K*f*fdd*r + 638*D1**2*K*f*fdd*s**2 - 638*D1**2*K*f*fdd*s + 319*D1**2*K*f*fdd + 374*D1**2*K*fd**2*r**2 + 1012*D1**2*K*fd**2*r*s - 506*D1**2*K*fd**2*r + 638*D1**2*K*fd**2*s**2 - 638*D1**2*K*fd**2*s - 11*D1**2*bdd1*f*(K - 1)*(10*r**2 + 44*r*s - 22*r + 34*s**2 - 46*s + 17) + 5550*D1**2*f**2*fd*r**2 + 13500*D1**2*f**2*fd*r*s - 7876*D1**2*f**2*fd*r + 7950*D1**2*f**2*fd*s**2 - 9476*D1**2*f**2*fd*s + 3336*D1**2*f**2*fd - 5250*D1**2*f**2*fdd*r**2 - 11700*D1**2*f**2*fdd*r*s + 7700*D1**2*f**2*fdd*r - 6450*D1**2*f**2*fdd*s**2 + 8500*D1**2*f**2*fdd*s - 3450*D1**2*f**2*fdd - 10500*D1**2*f*fd**2*r**2 - 23400*D1**2*f*fd**2*r*s + 15400*D1**2*f*fd**2*r - 12900*D1**2*f*fd**2*s**2 + 17000*D1**2*f*fd**2*s - 5700*D1**2*f*fd**2 + 2046*D1**2*f*fd*r**2 + 3564*D1**2*f*fd*r*s - 2090*D1**2*f*fd*r + 1518*D1**2*f*fd*s**2 - 1826*D1**2*f*fd*s + 1177*D1**2*f*fd - 1474*D1**2*f*fdd*r**2 - 2948*D1**2*f*fdd*r*s + 1518*D1**2*f*fdd*r - 1474*D1**2*f*fdd*s**2 + 1518*D1**2*f*fdd*s - 891*D1**2*f*fdd - 990*D1**2*f*gd2*r**2 - 2508*D1**2*f*gd2*r*s + 1980*D1**2*f*gd2*r - 1518*D1**2*f*gd2*s**2 + 2508*D1**2*f*gd2*s - 990*D1**2*f*gd2 + 110*D1**2*f*gdd2*r**2 + 484*D1**2*f*gdd2*r*s - 220*D1**2*f*gdd2*r + 374*D1**2*f*gdd2*s**2 - 484*D1**2*f*gdd2*s + 110*D1**2*f*gdd2 - 1474*D1**2*fd**2*r**2 - 2948*D1**2*fd**2*r*s + 1518*D1**2*fd**2*r - 1474*D1**2*fd**2*s**2 + 1518*D1**2*fd**2*s + 220*D1**2*fd**2 - 990*D1**2*fd*g2*r**2 - 2508*D1**2*fd*g2*r*s + 1980*D1**2*fd*g2*r - 1518*D1**2*fd*g2*s**2 + 1980*D1**2*fd*g2*s - 990*D1**2*fd*g2 + 220*D1**2*fd*gd2*r**2 + 968*D1**2*fd*gd2*r*s - 440*D1**2*fd*gd2*r + 748*D1**2*fd*gd2*s**2 - 704*D1**2*fd*gd2*s + 220*D1**2*fd*gd2 + 110*D1**2*fdd*g2*r**2 + 484*D1**2*fdd*g2*r*s - 220*D1**2*fdd*g2*r + 374*D1**2*fdd*g2*s**2 - 220*D1**2*fdd*g2*s + 110*D1**2*fdd*g2 - 1012*D1*Dd*K*f**2*r**2 - 2200*D1*Dd*K*f**2*r*s + 1562*D1*Dd*K*f**2*r - 1188*D1*Dd*K*f**2*s**2 + 1694*D1*Dd*K*f**2*s - 803*D1*Dd*K*f**2 + 2992*D1*Dd*K*f*fd*r**2 + 8096*D1*Dd*K*f*fd*r*s - 4532*D1*Dd*K*f*fd*r + 5104*D1*Dd*K*f*fd*s**2 - 5852*D1*Dd*K*f*fd*s + 1650*D1*Dd*K*f*fd + 7400*D1*Dd*f**3*r**2 + 18000*D1*Dd*f**3*r*s - 11900*D1*Dd*f**3*r + 10600*D1*Dd*f**3*s**2 - 14300*D1*Dd*f**3*s + 6350*D1*Dd*f**3 - 42000*D1*Dd*f**2*fd*r**2 - 93600*D1*Dd*f**2*fd*r*s + 63500*D1*Dd*f**2*fd*r - 51600*D1*Dd*f**2*fd*s**2 + 70300*D1*Dd*f**2*fd*s - 23900*D1*Dd*f**2*fd + 4092*D1*Dd*f**2*r**2 + 7128*D1*Dd*f**2*r*s - 5874*D1*Dd*f**2*r + 3036*D1*Dd*f**2*s**2 - 5082*D1*Dd*f**2*s + 2805*D1*Dd*f**2 - 11792*D1*Dd*f*fd*r**2 - 23584*D1*Dd*f*fd*r*s + 14916*D1*Dd*f*fd*r - 11792*D1*Dd*f*fd*s**2 + 14916*D1*Dd*f*fd*s - 4554*D1*Dd*f*fd - 3960*D1*Dd*f*g2*r**2 - 10032*D1*Dd*f*g2*r*s + 6468*D1*Dd*f*g2*r - 6072*D1*Dd*f*g2*s**2 + 8052*D1*Dd*f*g2*s - 3498*D1*Dd*f*g2 + 880*D1*Dd*f*gd2*r**2 + 3872*D1*Dd*f*gd2*r*s - 1804*D1*Dd*f*gd2*r + 2992*D1*Dd*f*gd2*s**2 - 3652*D1*Dd*f*gd2*s + 924*D1*Dd*f*gd2 + 880*D1*Dd*fd*g2*r**2 + 3872*D1*Dd*fd*g2*r*s - 1804*D1*Dd*fd*g2*r + 2992*D1*Dd*fd*g2*s**2 - 2596*D1*Dd*fd*g2*s + 660*D1*Dd*fd*g2 + 748*D1*Ddd*K*f**2*r**2 + 2024*D1*Ddd*K*f**2*r*s - 1254*D1*Ddd*K*f**2*r + 1276*D1*Ddd*K*f**2*s**2 - 1650*D1*Ddd*K*f**2*s + 693*D1*Ddd*K*f**2 - 7000*D1*Ddd*f**3*r**2 - 15600*D1*Ddd*f**3*r*s + 10900*D1*Ddd*f**3*r - 8600*D1*Ddd*f**3*s**2 + 12100*D1*Ddd*f**3*s - 5650*D1*Ddd*f**3 - 2948*D1*Ddd*f**2*r**2 - 5896*D1*Ddd*f**2*r*s + 4422*D1*Ddd*f**2*r - 2948*D1*Ddd*f**2*s**2 + 4422*D1*Ddd*f**2*s - 2211*D1*Ddd*f**2 + 440*D1*Ddd*f*g2*r**2 + 1936*D1*Ddd*f*g2*r*s - 924*D1*Ddd*f*g2*r + 1496*D1*Ddd*f*g2*s**2 - 1716*D1*Ddd*f*g2*s + 594*D1*Ddd*f*g2 + 11*D1*bd1*(K - 1)*(D1*(3*f*(30*r**2 + 76*r*s - 38*r + 46*s**2 - 54*s + 23) - 2*fd*(10*r**2 + 44*r*s - 21*r + 34*s**2 - 33*s + 5)) - 2*Dd*f*(40*r**2 + 2*r*(88*s - 43) + 136*s**2 - 170*s + 45)) + 2244*Dd**2*K*f**2*r**2 + 6072*Dd**2*K*f**2*r*s - 3762*Dd**2*K*f**2*r + 3828*Dd**2*K*f**2*s**2 - 4950*Dd**2*K*f**2*s + 1386*Dd**2*K*f**2 - 21000*Dd**2*f**3*r**2 - 46800*Dd**2*f**3*r*s + 32700*Dd**2*f**3*r - 25800*Dd**2*f**3*s**2 + 36300*Dd**2*f**3*s - 11300*Dd**2*f**3 - 8844*Dd**2*f**2*r**2 - 17688*Dd**2*f**2*r*s + 13266*Dd**2*f**2*r - 8844*Dd**2*f**2*s**2 + 13266*Dd**2*f**2*s - 4422*Dd**2*f**2 + 1320*Dd**2*f*g2*r**2 + 5808*Dd**2*f*g2*r*s - 2772*Dd**2*f*g2*r + 4488*Dd**2*f*g2*s**2 - 5148*Dd**2*f*g2*s + 1188*Dd**2*f*g2))/(1386*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**2*k1**4*(3564*C*D1**2*bdd1*f**2*r**2 + 9504*C*D1**2*bdd1*f**2*r*s - 9504*C*D1**2*bdd1*f**2*r + 5940*C*D1**2*bdd1*f**2*s**2 - 11880*C*D1**2*bdd1*f**2*s + 5940*C*D1**2*bdd1*f**2 - 3450*C*D1**2*f**2*fd*r**2 - 17580*C*D1**2*f**2*fd*r*s + 8160*C*D1**2*f**2*fd*r - 14130*C*D1**2*f**2*fd*s**2 + 15280*C*D1**2*f**2*fd*s - 5860*C*D1**2*f**2*fd + 4200*C*D1**2*f**2*fdd*r**2 + 19680*C*D1**2*f**2*fdd*r*s - 9360*C*D1**2*f**2*fdd*r + 15480*C*D1**2*f**2*fdd*s**2 - 16880*C*D1**2*f**2*fdd*s + 6560*C*D1**2*f**2*fdd + 8400*C*D1**2*f*fd**2*r**2 + 39360*C*D1**2*f*fd**2*r*s - 18720*C*D1**2*f*fd**2*r + 30960*C*D1**2*f*fd**2*s**2 - 33760*C*D1**2*f*fd**2*s + 6560*C*D1**2*f*fd**2 - 4600*C*D1*Dd*f**3*r**2 - 23440*C*D1*Dd*f**3*r*s + 10460*C*D1*Dd*f**3*r - 18840*C*D1*Dd*f**3*s**2 + 21140*C*D1*Dd*f**3*s - 7010*C*D1*Dd*f**3 + 33600*C*D1*Dd*f**2*fd*r**2 + 157440*C*D1*Dd*f**2*fd*r*s - 73920*C*D1*Dd*f**2*fd*r + 123840*C*D1*Dd*f**2*fd*s**2 - 137840*C*D1*Dd*f**2*fd*s + 35600*C*D1*Dd*f**2*fd + 5600*C*D1*Ddd*f**3*r**2 + 26240*C*D1*Ddd*f**3*r*s - 12160*C*D1*Ddd*f**3*r + 20640*C*D1*Ddd*f**3*s**2 - 23440*C*D1*Ddd*f**3*s + 7960*C*D1*Ddd*f**3 + 16800*C*Dd**2*f**3*r**2 + 78720*C*Dd**2*f**3*r*s - 36480*C*Dd**2*f**3*r + 61920*C*Dd**2*f**3*s**2 - 70320*C*Dd**2*f**3*s + 15920*C*Dd**2*f**3 + 825*D1**2*K*bdd1*f**2*r**2 + 3894*D1**2*K*bdd1*f**2*r*s - 1650*D1**2*K*bdd1*f**2*r + 3069*D1**2*K*bdd1*f**2*s**2 - 3894*D1**2*K*bdd1*f**2*s + 825*D1**2*K*bdd1*f**2 - 1320*D1**2*b2*f*fd*r**2 - 2640*D1**2*b2*f*fd*r*s + 1320*D1**2*b2*f*fd*r - 1320*D1**2*b2*f*fd*s**2 + 1320*D1**2*b2*f*fd*s - 660*D1**2*b2*f*fd + 1650*D1**2*b2*f*fdd*r**2 + 3300*D1**2*b2*f*fdd*r*s - 1650*D1**2*b2*f*fdd*r + 1650*D1**2*b2*f*fdd*s**2 - 1650*D1**2*b2*f*fdd*s + 825*D1**2*b2*f*fdd + 1650*D1**2*b2*fd**2*r**2 + 3300*D1**2*b2*fd**2*r*s - 1650*D1**2*b2*fd**2*r + 1650*D1**2*b2*fd**2*s**2 - 1650*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*(r + s - 1)*(50*f**2*(3*r + 3*s - 2) + f*(60*C*r + 60*C*s + K*(-59*r - 107*s + 83) + 119*r + 167*s - 203) - 70*g2*(r + s)) - 660*D1**2*bd2*f**2*r**2 - 1320*D1**2*bd2*f**2*r*s + 1320*D1**2*bd2*f**2*r - 660*D1**2*bd2*f**2*s**2 + 1320*D1**2*bd2*f**2*s - 660*D1**2*bd2*f**2 + 3300*D1**2*bd2*f*fd*r**2 + 6600*D1**2*bd2*f*fd*r*s - 4950*D1**2*bd2*f*fd*r + 3300*D1**2*bd2*f*fd*s**2 - 4950*D1**2*bd2*f*fd*s + 1650*D1**2*bd2*f*fd + 4620*D1**2*bdd1*f**3*r**2 + 6270*D1**2*bdd1*f**3*r*s - 8580*D1**2*bdd1*f**3*r + 1650*D1**2*bdd1*f**3*s**2 - 5610*D1**2*bdd1*f**3*s + 3960*D1**2*bdd1*f**3 - 6864*D1**2*bdd1*f**2*r**2 - 17226*D1**2*bdd1*f**2*r*s + 16104*D1**2*bdd1*f**2*r - 10362*D1**2*bdd1*f**2*s**2 + 19602*D1**2*bdd1*f**2*s - 9240*D1**2*bdd1*f**2 - 3894*D1**2*bdd1*f*g2*r**2 - 10956*D1**2*bdd1*f*g2*r*s + 10956*D1**2*bdd1*f*g2*r - 7062*D1**2*bdd1*f*g2*s**2 + 14124*D1**2*bdd1*f*g2*s - 7062*D1**2*bdd1*f*g2 + 825*D1**2*bdd2*f**2*r**2 + 1650*D1**2*bdd2*f**2*r*s - 1650*D1**2*bdd2*f**2*r + 825*D1**2*bdd2*f**2*s**2 - 1650*D1**2*bdd2*f**2*s + 825*D1**2*bdd2*f**2 + 1725*D1**2*f**2*fd*r**2 + 11460*D1**2*f**2*fd*r*s - 4970*D1**2*f**2*fd*r + 9735*D1**2*f**2*fd*s**2 - 10310*D1**2*f**2*fd*s + 3820*D1**2*f**2*fd - 2100*D1**2*f**2*fdd*r**2 - 12660*D1**2*f**2*fdd*r*s + 5620*D1**2*f**2*fdd*r - 10560*D1**2*f**2*fdd*s**2 + 11260*D1**2*f**2*fdd*s - 4220*D1**2*f**2*fdd + 1320*D1**2*f**2*gd2*r**2 + 6864*D1**2*f**2*gd2*r*s - 2640*D1**2*f**2*gd2*r + 5544*D1**2*f**2*gd2*s**2 - 6864*D1**2*f**2*gd2*s + 1320*D1**2*f**2*gd2 - 1650*D1**2*f**2*gdd2*r**2 - 7788*D1**2*f**2*gdd2*r*s + 3300*D1**2*f**2*gdd2*r - 6138*D1**2*f**2*gdd2*s**2 + 7788*D1**2*f**2*gdd2*s - 1650*D1**2*f**2*gdd2 - 4200*D1**2*f*fd**2*r**2 - 25320*D1**2*f*fd**2*r*s + 11240*D1**2*f*fd**2*r - 21120*D1**2*f*fd**2*s**2 + 22520*D1**2*f*fd**2*s - 4220*D1**2*f*fd**2 + 2640*D1**2*f*fd*g2*r**2 + 13728*D1**2*f*fd*g2*r*s - 6864*D1**2*f*fd*g2*r + 11088*D1**2*f*fd*g2*s**2 - 11088*D1**2*f*fd*g2*s + 5544*D1**2*f*fd*g2 - 6600*D1**2*f*fd*gd2*r**2 - 31152*D1**2*f*fd*gd2*r*s + 14388*D1**2*f*fd*gd2*r - 24552*D1**2*f*fd*gd2*s**2 + 27852*D1**2*f*fd*gd2*s - 7788*D1**2*f*fd*gd2 - 3300*D1**2*f*fdd*g2*r**2 - 15576*D1**2*f*fdd*g2*r*s + 7788*D1**2*f*fdd*g2*r - 12276*D1**2*f*fdd*g2*s**2 + 12276*D1**2*f*fdd*g2*s - 6138*D1**2*f*fdd*g2 - 3300*D1**2*fd**2*g2*r**2 - 15576*D1**2*fd**2*g2*r*s + 7788*D1**2*fd**2*g2*r - 12276*D1**2*fd**2*g2*s**2 + 12276*D1**2*fd**2*g2*s - 2640*D1*Dd*b2*f**2*r**2 - 5280*D1*Dd*b2*f**2*r*s + 3960*D1*Dd*b2*f**2*r - 2640*D1*Dd*b2*f**2*s**2 + 3960*D1*Dd*b2*f**2*s - 1980*D1*Dd*b2*f**2 + 13200*D1*Dd*b2*f*fd*r**2 + 26400*D1*Dd*b2*f*fd*r*s - 16500*D1*Dd*b2*f*fd*r + 13200*D1*Dd*b2*f*fd*s**2 - 16500*D1*Dd*b2*f*fd*s + 4950*D1*Dd*b2*f*fd + 6600*D1*Dd*bd2*f**2*r**2 + 13200*D1*Dd*bd2*f**2*r*s - 11550*D1*Dd*bd2*f**2*r + 6600*D1*Dd*bd2*f**2*s**2 - 11550*D1*Dd*bd2*f**2*s + 4950*D1*Dd*bd2*f**2 + 2300*D1*Dd*f**3*r**2 + 15280*D1*Dd*f**3*r*s - 6120*D1*Dd*f**3*r + 12980*D1*Dd*f**3*s**2 - 14130*D1*Dd*f**3*s + 4395*D1*Dd*f**3 - 16800*D1*Dd*f**2*fd*r**2 - 101280*D1*Dd*f**2*fd*r*s + 43540*D1*Dd*f**2*fd*r - 84480*D1*Dd*f**2*fd*s**2 + 91480*D1*Dd*f**2*fd*s - 22500*D1*Dd*f**2*fd + 5280*D1*Dd*f**2*g2*r**2 + 27456*D1*Dd*f**2*g2*r*s - 12144*D1*Dd*f**2*g2*r + 22176*D1*Dd*f**2*g2*s**2 - 24816*D1*Dd*f**2*g2*s + 8184*D1*Dd*f**2*g2 - 13200*D1*Dd*f**2*gd2*r**2 - 62304*D1*Dd*f**2*gd2*r*s + 27588*D1*Dd*f**2*gd2*r - 49104*D1*Dd*f**2*gd2*s**2 + 59004*D1*Dd*f**2*gd2*s - 14388*D1*Dd*f**2*gd2 - 26400*D1*Dd*f*fd*g2*r**2 - 124608*D1*Dd*f*fd*g2*r*s + 59928*D1*Dd*f*fd*g2*r - 98208*D1*Dd*f*fd*g2*s**2 + 104808*D1*Dd*f*fd*g2*s - 27852*D1*Dd*f*fd*g2 + 3300*D1*Ddd*b2*f**2*r**2 + 6600*D1*Ddd*b2*f**2*r*s - 4950*D1*Ddd*b2*f**2*r + 3300*D1*Ddd*b2*f**2*s**2 - 4950*D1*Ddd*b2*f**2*s + 2475*D1*Ddd*b2*f**2 - 2800*D1*Ddd*f**3*r**2 - 16880*D1*Ddd*f**3*r*s + 7020*D1*Ddd*f**3*r - 14080*D1*Ddd*f**3*s**2 + 15480*D1*Ddd*f**3*s - 4920*D1*Ddd*f**3 - 6600*D1*Ddd*f**2*g2*r**2 - 31152*D1*Ddd*f**2*g2*r*s + 14388*D1*Ddd*f**2*g2*r - 24552*D1*Ddd*f**2*g2*s**2 + 27852*D1*Ddd*f**2*g2*s - 9438*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(5*f**3*(12*r**2 + r*(19*s - 28) + 7*s**2 - 23*s + 16) + f**2*(6*C*(7*r**2 + 22*r*(s - 1) + 15*(s - 1)**2) - 5*fd*(84*r**2 + r*(114*s - 127) + 30*s**2 - 82*s + 45) + (2*r + 2*s - 2)*(K*(5*r + 21*s - 5) - 41*r - 73*s + 65)) - f*(fd*(36*C*(6*r**2 + 16*r*s - 11*r + 10*s**2 - 14*s + 4) + K*(50*r**2 + 236*r*s - 109*r + 186*s**2 - 211*s + 59) - 416*r**2 - 1044*r*s + 713*r - 628*s**2 + 872*s - 261) + (r + s - 1)*(41*g2*r + 109*g2*(s - 1) - 2*gd2*(59*r + 107*s - 83))) + 2*fd*g2*(59*r**2 + 83*r*(2*s - 1) + s*(107*s - 107))) - Dd*f*(5*f**2*(112*r**2 + r*(152*s - 179) + 40*s**2 - 116*s + 69) + f*(36*C*(12*r**2 + r*(32*s - 26) + 20*s**2 - 33*s + 13) + K*(100*r**2 + 472*r*s - 209*r + 372*s**2 - 447*s + 109) - 832*r**2 - 2088*r*s + 1653*r - 1256*s**2 + 2024*s - 785) - 2*g2*(236*r**2 + r*(664*s - 533) + 428*s**2 - 701*s + 273))) + 9900*Dd**2*b2*f**2*r**2 + 19800*Dd**2*b2*f**2*r*s - 14850*Dd**2*b2*f**2*r + 9900*Dd**2*b2*f**2*s**2 - 14850*Dd**2*b2*f**2*s + 4950*Dd**2*b2*f**2 - 8400*Dd**2*f**3*r**2 - 50640*Dd**2*f**3*r*s + 21060*Dd**2*f**3*r - 42240*Dd**2*f**3*s**2 + 46440*Dd**2*f**3*s - 9840*Dd**2*f**3 - 19800*Dd**2*f**2*g2*r**2 - 93456*Dd**2*f**2*g2*r*s + 43164*Dd**2*f**2*g2*r - 73656*Dd**2*f**2*g2*s**2 + 83556*Dd**2*f**2*g2*s - 18876*Dd**2*f**2*g2 + 1155*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(50*C*D1**2*fd*r**2 + 100*C*D1**2*fd*r*s - 100*C*D1**2*fd*r + 50*C*D1**2*fd*s**2 - 100*C*D1**2*fd*s + 50*C*D1**2*fd - 60*C*D1**2*fdd*r**2 - 120*C*D1**2*fdd*r*s + 120*C*D1**2*fdd*r - 60*C*D1**2*fdd*s**2 + 120*C*D1**2*fdd*s - 60*C*D1**2*fdd + 200*C*D1*Dd*f*r**2 + 400*C*D1*Dd*f*r*s - 300*C*D1*Dd*f*r + 200*C*D1*Dd*f*s**2 - 300*C*D1*Dd*f*s + 150*C*D1*Dd*f - 480*C*D1*Dd*fd*r**2 - 960*C*D1*Dd*fd*r*s + 840*C*D1*Dd*fd*r - 480*C*D1*Dd*fd*s**2 + 840*C*D1*Dd*fd*s - 360*C*D1*Dd*fd - 240*C*D1*Ddd*f*r**2 - 480*C*D1*Ddd*f*r*s + 360*C*D1*Ddd*f*r - 240*C*D1*Ddd*f*s**2 + 360*C*D1*Ddd*f*s - 180*C*D1*Ddd*f - 720*C*Dd**2*f*r**2 - 1440*C*Dd**2*f*r*s + 1080*C*Dd**2*f*r - 720*C*Dd**2*f*s**2 + 1080*C*Dd**2*f*s - 360*C*Dd**2*f - 41*D1**2*K*fd*r**2 - 150*D1**2*K*fd*r*s - 109*D1**2*K*fd*s**2 + 59*D1**2*K*fdd*r**2 + 166*D1**2*K*fdd*r*s + 107*D1**2*K*fdd*s**2 - 35*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 240*D1**2*f*fd*r**2 + 480*D1**2*f*fd*r*s - 320*D1**2*f*fd*r + 240*D1**2*f*fd*s**2 - 320*D1**2*f*fd*s + 160*D1**2*f*fd - 300*D1**2*f*fdd*r**2 - 600*D1**2*f*fdd*r*s + 400*D1**2*f*fdd*r - 300*D1**2*f*fdd*s**2 + 400*D1**2*f*fdd*s - 200*D1**2*f*fdd - 300*D1**2*fd**2*r**2 - 600*D1**2*fd**2*r*s + 400*D1**2*fd**2*r - 300*D1**2*fd**2*s**2 + 400*D1**2*fd**2*s - 100*D1**2*fd**2 + 91*D1**2*fd*r**2 + 250*D1**2*fd*r*s + 100*D1**2*fd*r + 159*D1**2*fd*s**2 + 100*D1**2*fd*s - 50*D1**2*fd - 119*D1**2*fdd*r**2 - 286*D1**2*fdd*r*s - 120*D1**2*fdd*r - 167*D1**2*fdd*s**2 - 120*D1**2*fdd*s + 60*D1**2*fdd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 + 70*D1**2*gdd2*r**2 + 140*D1**2*gdd2*r*s - 140*D1**2*gdd2*r + 70*D1**2*gdd2*s**2 - 140*D1**2*gdd2*s + 70*D1**2*gdd2 - 164*D1*Dd*K*f*r**2 - 600*D1*Dd*K*f*r*s + 314*D1*Dd*K*f*r - 436*D1*Dd*K*f*s**2 + 518*D1*Dd*K*f*s - 191*D1*Dd*K*f + 472*D1*Dd*K*fd*r**2 + 1328*D1*Dd*K*fd*r*s - 402*D1*Dd*K*fd*r + 856*D1*Dd*K*fd*s**2 - 546*D1*Dd*K*fd*s + 480*D1*Dd*f**2*r**2 + 960*D1*Dd*f**2*r*s - 720*D1*Dd*f**2*r + 480*D1*Dd*f**2*s**2 - 720*D1*Dd*f**2*s + 360*D1*Dd*f**2 - 2400*D1*Dd*f*fd*r**2 - 4800*D1*Dd*f*fd*r*s + 3400*D1*Dd*f*fd*r - 2400*D1*Dd*f*fd*s**2 + 3400*D1*Dd*f*fd*s - 1200*D1*Dd*f*fd + 364*D1*Dd*f*r**2 + 1000*D1*Dd*f*r*s - 614*D1*Dd*f*r + 636*D1*Dd*f*s**2 - 818*D1*Dd*f*s + 341*D1*Dd*f - 952*D1*Dd*fd*r**2 - 2288*D1*Dd*fd*r*s + 282*D1*Dd*fd*r - 1336*D1*Dd*fd*s**2 + 426*D1*Dd*fd*s + 360*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 + 1120*D1*Dd*gd2*r*s - 980*D1*Dd*gd2*r + 560*D1*Dd*gd2*s**2 - 980*D1*Dd*gd2*s + 420*D1*Dd*gd2 + 236*D1*Ddd*K*f*r**2 + 664*D1*Ddd*K*f*r*s - 402*D1*Ddd*K*f*r + 428*D1*Ddd*K*f*s**2 - 546*D1*Ddd*K*f*s + 225*D1*Ddd*K*f - 600*D1*Ddd*f**2*r**2 - 1200*D1*Ddd*f**2*r*s + 900*D1*Ddd*f**2*r - 600*D1*Ddd*f**2*s**2 + 900*D1*Ddd*f**2*s - 450*D1*Ddd*f**2 - 476*D1*Ddd*f*r**2 - 1144*D1*Ddd*f*r*s + 762*D1*Ddd*f*r - 668*D1*Ddd*f*s**2 + 906*D1*Ddd*f*s - 405*D1*Ddd*f + 280*D1*Ddd*g2*r**2 + 560*D1*Ddd*g2*r*s - 420*D1*Ddd*g2*r + 280*D1*Ddd*g2*s**2 - 420*D1*Ddd*g2*s + 210*D1*Ddd*g2 + 70*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 708*Dd**2*K*f*r**2 + 1992*Dd**2*K*f*r*s - 1206*Dd**2*K*f*r + 1284*Dd**2*K*f*s**2 - 1638*Dd**2*K*f*s + 450*Dd**2*K*f - 1800*Dd**2*f**2*r**2 - 3600*Dd**2*f**2*r*s + 2700*Dd**2*f**2*r - 1800*Dd**2*f**2*s**2 + 2700*Dd**2*f**2*s - 900*Dd**2*f**2 - 1428*Dd**2*f*r**2 - 3432*Dd**2*f*r*s + 2286*Dd**2*f*r - 2004*Dd**2*f*s**2 + 2718*Dd**2*f*s - 810*Dd**2*f + 840*Dd**2*g2*r**2 + 1680*Dd**2*g2*r*s - 1260*Dd**2*g2*r + 840*Dd**2*g2*s**2 - 1260*Dd**2*g2*s + 420*Dd**2*g2) - 33*b1*(168*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*r + 360*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s + 84*C*D1**2*f*fd - 216*C*D1**2*f*fdd*r**2 - 576*C*D1**2*f*fdd*r*s + 216*C*D1**2*f*fdd*r - 360*C*D1**2*f*fdd*s**2 + 288*C*D1**2*f*fdd*s - 108*C*D1**2*f*fdd - 216*C*D1**2*fd**2*r**2 - 576*C*D1**2*fd**2*r*s + 216*C*D1**2*fd**2*r - 360*C*D1**2*fd**2*s**2 + 288*C*D1**2*fd**2*s + 336*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 600*C*D1*Dd*f**2*r + 720*C*D1*Dd*f**2*s**2 - 888*C*D1*Dd*f**2*s + 348*C*D1*Dd*f**2 - 1728*C*D1*Dd*f*fd*r**2 - 4608*C*D1*Dd*f*fd*r*s + 2304*C*D1*Dd*f*fd*r - 2880*C*D1*Dd*f*fd*s**2 + 3024*C*D1*Dd*f*fd*s - 720*C*D1*Dd*f*fd - 432*C*D1*Ddd*f**2*r**2 - 1152*C*D1*Ddd*f**2*r*s + 720*C*D1*Ddd*f**2*r - 720*C*D1*Ddd*f**2*s**2 + 936*C*D1*Ddd*f**2*s - 396*C*D1*Ddd*f**2 - 1296*C*Dd**2*f**2*r**2 - 3456*C*Dd**2*f**2*r*s + 2160*C*Dd**2*f**2*r - 2160*C*Dd**2*f**2*s**2 + 2808*C*Dd**2*f**2*s - 792*C*Dd**2*f**2 + 40*D1**2*K*f*fd*r**2 + 208*D1**2*K*f*fd*r*s - 104*D1**2*K*f*fd*r + 168*D1**2*K*f*fd*s**2 - 168*D1**2*K*f*fd*s + 84*D1**2*K*f*fd - 50*D1**2*K*f*fdd*r**2 - 236*D1**2*K*f*fdd*r*s + 118*D1**2*K*f*fdd*r - 186*D1**2*K*f*fdd*s**2 + 186*D1**2*K*f*fdd*s - 93*D1**2*K*f*fdd - 50*D1**2*K*fd**2*r**2 - 236*D1**2*K*fd**2*r*s + 118*D1**2*K*fd**2*r - 186*D1**2*K*fd**2*s**2 + 186*D1**2*K*fd**2*s + 70*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(25*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + f*(30*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - K*(59*r**2 + 2*r*(83*s - 71) + 107*s**2 - 190*s + 83) + 119*r**2 + 286*r*s - 322*r + 167*s**2 - 370*s + 173) - 35*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 360*D1**2*f**2*fd*r**2 + 570*D1**2*f**2*fd*r*s - 390*D1**2*f**2*fd*r + 210*D1**2*f**2*fd*s**2 - 290*D1**2*f**2*fd*s + 150*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 570*D1**2*f**2*fdd*r*s + 490*D1**2*f**2*fdd*r - 150*D1**2*f**2*fdd*s**2 + 310*D1**2*f**2*fdd*s - 210*D1**2*f**2*fdd - 840*D1**2*f*fd**2*r**2 - 1140*D1**2*f*fd**2*r*s + 980*D1**2*f*fd**2*r - 300*D1**2*f*fd**2*s**2 + 620*D1**2*f*fd**2*s - 210*D1**2*f*fd**2 - 328*D1**2*f*fd*r**2 - 912*D1**2*f*fd*r*s + 360*D1**2*f*fd*r - 584*D1**2*f*fd*s**2 + 488*D1**2*f*fd*s - 196*D1**2*f*fd + 416*D1**2*f*fdd*r**2 + 1044*D1**2*f*fdd*r*s - 450*D1**2*f*fdd*r + 628*D1**2*f*fdd*s**2 - 556*D1**2*f*fdd*s + 242*D1**2*f*fdd - 82*D1**2*f*gd2*r**2 - 300*D1**2*f*gd2*r*s + 164*D1**2*f*gd2*r - 218*D1**2*f*gd2*s**2 + 300*D1**2*f*gd2*s - 82*D1**2*f*gd2 + 118*D1**2*f*gdd2*r**2 + 332*D1**2*f*gdd2*r*s - 236*D1**2*f*gdd2*r + 214*D1**2*f*gdd2*s**2 - 332*D1**2*f*gdd2*s + 118*D1**2*f*gdd2 + 416*D1**2*fd**2*r**2 + 1044*D1**2*fd**2*r*s - 450*D1**2*fd**2*r + 628*D1**2*fd**2*s**2 - 556*D1**2*fd**2*s - 82*D1**2*fd*g2*r**2 - 300*D1**2*fd*g2*r*s - 218*D1**2*fd*g2*s**2 + 236*D1**2*fd*gd2*r**2 + 664*D1**2*fd*gd2*r*s - 236*D1**2*fd*gd2*r + 428*D1**2*fd*gd2*s**2 - 332*D1**2*fd*gd2*s + 118*D1**2*fdd*g2*r**2 + 332*D1**2*fdd*g2*r*s + 214*D1**2*fdd*g2*s**2 + 80*D1*Dd*K*f**2*r**2 + 416*D1*Dd*K*f**2*r*s - 184*D1*Dd*K*f**2*r + 336*D1*Dd*K*f**2*s**2 - 376*D1*Dd*K*f**2*s + 124*D1*Dd*K*f**2 - 400*D1*Dd*K*f*fd*r**2 - 1888*D1*Dd*K*f*fd*r*s + 908*D1*Dd*K*f*fd*r - 1488*D1*Dd*K*f*fd*s**2 + 1588*D1*Dd*K*f*fd*s - 422*D1*Dd*K*f*fd + 480*D1*Dd*f**3*r**2 + 760*D1*Dd*f**3*r*s - 670*D1*Dd*f**3*r + 280*D1*Dd*f**3*s**2 - 520*D1*Dd*f**3*s + 310*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 4560*D1*Dd*f**2*fd*r*s + 4210*D1*Dd*f**2*fd*r - 1200*D1*Dd*f**2*fd*s**2 + 2680*D1*Dd*f**2*fd*s - 1290*D1*Dd*f**2*fd - 656*D1*Dd*f**2*r**2 - 1824*D1*Dd*f**2*r*s + 1112*D1*Dd*f**2*r - 1168*D1*Dd*f**2*s**2 + 1496*D1*Dd*f**2*s - 620*D1*Dd*f**2 + 3328*D1*Dd*f*fd*r**2 + 8352*D1*Dd*f*fd*r*s - 4508*D1*Dd*f*fd*r + 5024*D1*Dd*f*fd*s**2 - 5568*D1*Dd*f*fd*s + 1456*D1*Dd*f*fd - 328*D1*Dd*f*g2*r**2 - 1200*D1*Dd*f*g2*r*s + 628*D1*Dd*f*g2*r - 872*D1*Dd*f*g2*s**2 + 1036*D1*Dd*f*g2*s - 382*D1*Dd*f*g2 + 944*D1*Dd*f*gd2*r**2 + 2656*D1*Dd*f*gd2*r*s - 1748*D1*Dd*f*gd2*r + 1712*D1*Dd*f*gd2*s**2 - 2420*D1*Dd*f*gd2*s + 804*D1*Dd*f*gd2 + 944*D1*Dd*fd*g2*r**2 + 2656*D1*Dd*fd*g2*r*s - 804*D1*Dd*fd*g2*r + 1712*D1*Dd*fd*g2*s**2 - 1092*D1*Dd*fd*g2*s - 100*D1*Ddd*K*f**2*r**2 - 472*D1*Ddd*K*f**2*r*s + 218*D1*Ddd*K*f**2*r - 372*D1*Ddd*K*f**2*s**2 + 422*D1*Ddd*K*f**2*s - 143*D1*Ddd*K*f**2 - 560*D1*Ddd*f**3*r**2 - 760*D1*Ddd*f**3*r*s + 750*D1*Ddd*f**3*r - 200*D1*Ddd*f**3*s**2 + 480*D1*Ddd*f**3*s - 330*D1*Ddd*f**3 + 832*D1*Ddd*f**2*r**2 + 2088*D1*Ddd*f**2*r*s - 1354*D1*Ddd*f**2*r + 1256*D1*Ddd*f**2*s**2 - 1672*D1*Ddd*f**2*s + 730*D1*Ddd*f**2 + 472*D1*Ddd*f*g2*r**2 + 1328*D1*Ddd*f*g2*r*s - 804*D1*Ddd*f*g2*r + 856*D1*Ddd*f*g2*s**2 - 1092*D1*Ddd*f*g2*s + 450*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(20*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + f*(25*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 41*K*r**2 - 150*K*r*s + 116*K*r - 109*K*s**2 + 184*K*s - 75*K - 300*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 91*r**2 + 250*r*s - 266*r + 159*s**2 - 334*s + 150) - 2*fd*(30*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 107*K*s**2 + 95*K*s + r**2*(119 - 59*K) + r*(-166*K*s + 71*K + 286*s - 101) + 167*s**2 - 125*s - 30) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 70*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(25*f**2*(24*r**2 + r*(48*s - 38) + 24*s**2 - 38*s + 15) + f*(30*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(236*r**2 + 664*r*s - 485*r + 428*s**2 - 653*s + 237) + 476*r**2 + 1144*r*s - 1025*r + 668*s**2 - 1193*s + 507) - 35*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 300*Dd**2*K*f**2*r**2 - 1416*Dd**2*K*f**2*r*s + 654*Dd**2*K*f**2*r - 1116*Dd**2*K*f**2*s**2 + 1266*Dd**2*K*f**2*s - 286*Dd**2*K*f**2 - 1680*Dd**2*f**3*r**2 - 2280*Dd**2*f**3*r*s + 2250*Dd**2*f**3*r - 600*Dd**2*f**3*s**2 + 1440*Dd**2*f**3*s - 660*Dd**2*f**3 + 2496*Dd**2*f**2*r**2 + 6264*Dd**2*f**2*r*s - 4062*Dd**2*f**2*r + 3768*Dd**2*f**2*s**2 - 5016*Dd**2*f**2*s + 1460*Dd**2*f**2 + 1416*Dd**2*f*g2*r**2 + 3984*Dd**2*f*g2*r*s - 2412*Dd**2*f*g2*r + 2568*Dd**2*f*g2*s**2 - 3276*Dd**2*f*g2*s + 900*Dd**2*f*g2))/(693*d**2*k3**5) + 4*D1**2*Pk2*Pkd3*ct**2*k1**4*st**2*(b1*(D1**2*(f**2*(67*fd - 50*fdd)*(r*(6*s - 2) + 6*s**2 - 7*s + 2) + f*(-50*fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3) + 55*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 33*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 33*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(134*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 50*f*fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11) + 55*f*(r*(4*s - 1) + (1 - 2*s)**2) - 66*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(100*f + 33)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(100*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(50*bdd1*f**2*s*(2*r + 2*s - 1) + f*(33*bdd1*s*(r + s - 1) - 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(f*s*(67*f*(2*r + 2*s - 1) + 55*r + 55*s - 55) - fd*(50*f*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2)) - Dd*f*(50*f*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 264*r*s - 33*r + 264*s**2 - 264*s + 33)) + D1*f*(Dd*(39*f*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 25*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 25*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k2**2*k3**3) + 2*D1**2*Pk2*Pkd3*ct**2*k1**4*(66*b1**2*(D1**2*s*(f*(4*fd - 5*fdd)*(4*r + 4*s - 3) - 5*fd**2*(4*r + 4*s - 3) + 5*fd*(r + s) - 6*fdd*(r + s)) + D1*(Dd*(8*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 5*f*(fd*(8*s - 1)*(4*r + 4*s - 3) - 4*r*s + r - 4*s**2 + 4*s - 1) + 6*fd*(-8*r*s + r + s*(4 - 8*s))) - 2*Ddd*f*(5*f + 3)*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd**2*f*(5*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 33*b1*(-2*D1**2*bdd1*f*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + (2*s - 1)*(6*r + 6*s - 6)) - 90*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r - 90*D1**2*f**2*fd*s**2 + 105*D1**2*f**2*fd*s - 30*D1**2*f**2*fd + 90*D1**2*f**2*fdd*r*s - 30*D1**2*f**2*fdd*r + 90*D1**2*f**2*fdd*s**2 - 105*D1**2*f**2*fdd*s + 30*D1**2*f**2*fdd + 180*D1**2*f*fd**2*r*s - 60*D1**2*f*fd**2*r + 180*D1**2*f*fd**2*s**2 - 210*D1**2*f*fd**2*s + 45*D1**2*f*fd**2 - 16*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 16*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 16*D1**2*f*fd + 14*D1**2*f*fdd*r*s - 17*D1**2*f*fdd*r + 14*D1**2*f*fdd*s**2 - 24*D1**2*f*fdd*s + 17*D1**2*f*fdd + 14*D1**2*fd**2*r*s - 17*D1**2*fd**2*r + 14*D1**2*fd**2*s**2 - 24*D1**2*fd**2*s - 120*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 120*D1*Dd*f**3*s**2 + 120*D1*Dd*f**3*s - 30*D1*Dd*f**3 + 720*D1*Dd*f**2*fd*r*s - 210*D1*Dd*f**2*fd*r + 720*D1*Dd*f**2*fd*s**2 - 780*D1*Dd*f**2*fd*s + 165*D1*Dd*f**2*fd - 32*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r - 32*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 112*D1*Dd*f*fd*r*s - 82*D1*Dd*f*fd*r + 112*D1*Dd*f*fd*s**2 - 152*D1*Dd*f*fd*s + 58*D1*Dd*f*fd + 120*D1*Ddd*f**3*r*s - 30*D1*Ddd*f**3*r + 120*D1*Ddd*f**3*s**2 - 120*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 + 28*D1*Ddd*f**2*r*s - 7*D1*Ddd*f**2*r + 28*D1*Ddd*f**2*s**2 - 28*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 + 2*D1*bd1*(D1*(4*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 5*f*fd*(4*s - 1)*(4*r + 4*s - 3) + 5*f*(2*s - 1)*(r + s - 1) + 6*fd*(-4*r*s + r + s*(3 - 4*s))) - Dd*f*(5*f*(8*s - 3)*(4*r + 4*s - 3) + 96*r*s - 36*r + 96*s**2 - 120*s + 30)) + 360*Dd**2*f**3*r*s - 90*Dd**2*f**3*r + 360*Dd**2*f**3*s**2 - 360*Dd**2*f**3*s + 60*Dd**2*f**3 + 84*Dd**2*f**2*r*s - 21*Dd**2*f**2*r + 84*Dd**2*f**2*s**2 - 84*Dd**2*f**2*s + 14*Dd**2*f**2) + f*(-66*D1**2*bd1**2*(5*f*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*s - 1)*(6*r + 6*s - 6)) + 33*D1**2*bdd1*f*(r*(s*(30*f + 7) + 10) + s**2*(30*f + 7) + s*(3 - 15*f) - 10) - 5*D1**2*(f*(89*fd - 94*fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 94*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 33*D1*bd1*(D1*(15*f**2*s*(2*r + 2*s - 1) + f*(-15*fd*(12*r*s - 2*r + 12*s**2 - 10*s + 1) + (8*s + 8)*(r + s - 1)) - fd*(r*(28*s + 3) + 28*s**2 - 18*s + 7)) - Dd*f*(15*f*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 56*r*s + 33*r + 56*s**2 - 16*s - 23)) - 5*D1*f*(Dd*(89*f*(r*(4*s - 1) + (1 - 2*s)**2) - 94*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 94*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 470*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k2**2*k3**3) - 5*D1**2*Pk2*Pkd3*ct**2*k1**2*k2**4*st**6*(156*C*D1**2*f**2*fd*r**2 + 312*C*D1**2*f**2*fd*r*s - 208*C*D1**2*f**2*fd*r + 156*C*D1**2*f**2*fd*s**2 - 208*C*D1**2*f**2*fd*s + 104*C*D1**2*f**2*fd - 78*C*D1**2*f**2*fdd*r**2 - 156*C*D1**2*f**2*fdd*r*s + 104*C*D1**2*f**2*fdd*r - 78*C*D1**2*f**2*fdd*s**2 + 104*C*D1**2*f**2*fdd*s - 52*C*D1**2*f**2*fdd - 156*C*D1**2*f*fd**2*r**2 - 312*C*D1**2*f*fd**2*r*s + 208*C*D1**2*f*fd**2*r - 156*C*D1**2*f*fd**2*s**2 + 208*C*D1**2*f*fd**2*s - 52*C*D1**2*f*fd**2 + 208*C*D1*Dd*f**3*r**2 + 416*C*D1*Dd*f**3*r*s - 312*C*D1*Dd*f**3*r + 208*C*D1*Dd*f**3*s**2 - 312*C*D1*Dd*f**3*s + 156*C*D1*Dd*f**3 - 624*C*D1*Dd*f**2*fd*r**2 - 1248*C*D1*Dd*f**2*fd*r*s + 884*C*D1*Dd*f**2*fd*r - 624*C*D1*Dd*f**2*fd*s**2 + 884*C*D1*Dd*f**2*fd*s - 312*C*D1*Dd*f**2*fd - 104*C*D1*Ddd*f**3*r**2 - 208*C*D1*Ddd*f**3*r*s + 156*C*D1*Ddd*f**3*r - 104*C*D1*Ddd*f**3*s**2 + 156*C*D1*Ddd*f**3*s - 78*C*D1*Ddd*f**3 - 312*C*Dd**2*f**3*r**2 - 624*C*Dd**2*f**3*r*s + 468*C*Dd**2*f**3*r - 312*C*Dd**2*f**3*s**2 + 468*C*Dd**2*f**3*s - 156*C*Dd**2*f**3 + 1716*D1**2*K*b1*f*fd*r**2 + 3432*D1**2*K*b1*f*fd*r*s - 1716*D1**2*K*b1*f*fd*r + 1716*D1**2*K*b1*f*fd*s**2 - 1716*D1**2*K*b1*f*fd*s + 858*D1**2*K*b1*f*fd - 858*D1**2*K*b1*f*fdd*r**2 - 1716*D1**2*K*b1*f*fdd*r*s + 858*D1**2*K*b1*f*fdd*r - 858*D1**2*K*b1*f*fdd*s**2 + 858*D1**2*K*b1*f*fdd*s - 429*D1**2*K*b1*f*fdd - 858*D1**2*K*b1*fd**2*r**2 - 1716*D1**2*K*b1*fd**2*r*s + 858*D1**2*K*b1*fd**2*r - 858*D1**2*K*b1*fd**2*s**2 + 858*D1**2*K*b1*fd**2*s - 1716*D1**2*b1*f*fd*r**2 - 3432*D1**2*b1*f*fd*r*s + 1716*D1**2*b1*f*fd*r - 1716*D1**2*b1*f*fd*s**2 + 1716*D1**2*b1*f*fd*s - 858*D1**2*b1*f*fd + 858*D1**2*b1*f*fdd*r**2 + 1716*D1**2*b1*f*fdd*r*s - 858*D1**2*b1*f*fdd*r + 858*D1**2*b1*f*fdd*s**2 - 858*D1**2*b1*f*fdd*s + 429*D1**2*b1*f*fdd + 858*D1**2*b1*fd**2*r**2 + 1716*D1**2*b1*fd**2*r*s - 858*D1**2*b1*fd**2*r + 858*D1**2*b1*fd**2*s**2 - 858*D1**2*b1*fd**2*s - 429*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 - 672*D1**2*f**3*fd*r**2 - 1344*D1**2*f**3*fd*r*s + 1008*D1**2*f**3*fd*r - 672*D1**2*f**3*fd*s**2 + 1008*D1**2*f**3*fd*s - 504*D1**2*f**3*fd + 336*D1**2*f**3*fdd*r**2 + 672*D1**2*f**3*fdd*r*s - 504*D1**2*f**3*fdd*r + 336*D1**2*f**3*fdd*s**2 - 504*D1**2*f**3*fdd*s + 252*D1**2*f**3*fdd + 1008*D1**2*f**2*fd**2*r**2 + 2016*D1**2*f**2*fd**2*r*s - 1512*D1**2*f**2*fd**2*r + 1008*D1**2*f**2*fd**2*s**2 - 1512*D1**2*f**2*fd**2*s + 504*D1**2*f**2*fd**2 - 156*D1**2*f**2*fd*r**2 - 312*D1**2*f**2*fd*r*s + 208*D1**2*f**2*fd*r - 156*D1**2*f**2*fd*s**2 + 208*D1**2*f**2*fd*s - 104*D1**2*f**2*fd + 78*D1**2*f**2*fdd*r**2 + 156*D1**2*f**2*fdd*r*s - 104*D1**2*f**2*fdd*r + 78*D1**2*f**2*fdd*s**2 - 104*D1**2*f**2*fdd*s + 52*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 858*D1**2*f**2*gdd2*r**2 + 1716*D1**2*f**2*gdd2*r*s - 1716*D1**2*f**2*gdd2*r + 858*D1**2*f**2*gdd2*s**2 - 1716*D1**2*f**2*gdd2*s + 858*D1**2*f**2*gdd2 + 156*D1**2*f*fd**2*r**2 + 312*D1**2*f*fd**2*r*s - 208*D1**2*f*fd**2*r + 156*D1**2*f*fd**2*s**2 - 208*D1**2*f*fd**2*s + 52*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r**2 + 6864*D1**2*f*fd*gd2*r*s - 5148*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1716*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r**2 + 3432*D1**2*f*fdd*g2*r*s - 1716*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r**2 + 3432*D1**2*fd**2*g2*r*s - 1716*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 3432*D1*Dd*K*b1*f**2*r**2 + 6864*D1*Dd*K*b1*f**2*r*s - 5148*D1*Dd*K*b1*f**2*r + 3432*D1*Dd*K*b1*f**2*s**2 - 5148*D1*Dd*K*b1*f**2*s + 2574*D1*Dd*K*b1*f**2 - 6864*D1*Dd*K*b1*f*fd*r**2 - 13728*D1*Dd*K*b1*f*fd*r*s + 8580*D1*Dd*K*b1*f*fd*r - 6864*D1*Dd*K*b1*f*fd*s**2 + 8580*D1*Dd*K*b1*f*fd*s - 2574*D1*Dd*K*b1*f*fd - 3432*D1*Dd*b1*f**2*r**2 - 6864*D1*Dd*b1*f**2*r*s + 5148*D1*Dd*b1*f**2*r - 3432*D1*Dd*b1*f**2*s**2 + 5148*D1*Dd*b1*f**2*s - 2574*D1*Dd*b1*f**2 + 6864*D1*Dd*b1*f*fd*r**2 + 13728*D1*Dd*b1*f*fd*r*s - 8580*D1*Dd*b1*f*fd*r + 6864*D1*Dd*b1*f*fd*s**2 - 8580*D1*Dd*b1*f*fd*s + 2574*D1*Dd*b1*f*fd - 672*D1*Dd*f**4*r**2 - 1344*D1*Dd*f**4*r*s + 1008*D1*Dd*f**4*r - 672*D1*Dd*f**4*s**2 + 1008*D1*Dd*f**4*s - 504*D1*Dd*f**4 + 2688*D1*Dd*f**3*fd*r**2 + 5376*D1*Dd*f**3*fd*r*s - 4032*D1*Dd*f**3*fd*r + 2688*D1*Dd*f**3*fd*s**2 - 4032*D1*Dd*f**3*fd*s + 1512*D1*Dd*f**3*fd - 208*D1*Dd*f**3*r**2 - 416*D1*Dd*f**3*r*s + 312*D1*Dd*f**3*r - 208*D1*Dd*f**3*s**2 + 312*D1*Dd*f**3*s - 156*D1*Dd*f**3 + 624*D1*Dd*f**2*fd*r**2 + 1248*D1*Dd*f**2*fd*r*s - 884*D1*Dd*f**2*fd*r + 624*D1*Dd*f**2*fd*s**2 - 884*D1*Dd*f**2*fd*s + 312*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r**2 + 13728*D1*Dd*f**2*gd2*r*s - 12012*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 12012*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r**2 + 27456*D1*Dd*f*fd*g2*r*s - 17160*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 17160*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 - 1716*D1*Ddd*K*b1*f**2*r**2 - 3432*D1*Ddd*K*b1*f**2*r*s + 2574*D1*Ddd*K*b1*f**2*r - 1716*D1*Ddd*K*b1*f**2*s**2 + 2574*D1*Ddd*K*b1*f**2*s - 1287*D1*Ddd*K*b1*f**2 + 1716*D1*Ddd*b1*f**2*r**2 + 3432*D1*Ddd*b1*f**2*r*s - 2574*D1*Ddd*b1*f**2*r + 1716*D1*Ddd*b1*f**2*s**2 - 2574*D1*Ddd*b1*f**2*s + 1287*D1*Ddd*b1*f**2 + 336*D1*Ddd*f**4*r**2 + 672*D1*Ddd*f**4*r*s - 504*D1*Ddd*f**4*r + 336*D1*Ddd*f**4*s**2 - 504*D1*Ddd*f**4*s + 252*D1*Ddd*f**4 + 104*D1*Ddd*f**3*r**2 + 208*D1*Ddd*f**3*r*s - 156*D1*Ddd*f**3*r + 104*D1*Ddd*f**3*s**2 - 156*D1*Ddd*f**3*s + 78*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r**2 + 6864*D1*Ddd*f**2*g2*r*s - 5148*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 5148*Dd**2*K*b1*f**2*r**2 - 10296*Dd**2*K*b1*f**2*r*s + 7722*Dd**2*K*b1*f**2*r - 5148*Dd**2*K*b1*f**2*s**2 + 7722*Dd**2*K*b1*f**2*s - 2574*Dd**2*K*b1*f**2 + 5148*Dd**2*b1*f**2*r**2 + 10296*Dd**2*b1*f**2*r*s - 7722*Dd**2*b1*f**2*r + 5148*Dd**2*b1*f**2*s**2 - 7722*Dd**2*b1*f**2*s + 2574*Dd**2*b1*f**2 + 1008*Dd**2*f**4*r**2 + 2016*Dd**2*f**4*r*s - 1512*Dd**2*f**4*r + 1008*Dd**2*f**4*s**2 - 1512*Dd**2*f**4*s + 504*Dd**2*f**4 + 312*Dd**2*f**3*r**2 + 624*Dd**2*f**3*r*s - 468*Dd**2*f**3*r + 312*Dd**2*f**3*s**2 - 468*Dd**2*f**3*s + 156*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r**2 + 20592*Dd**2*f**2*g2*r*s - 15444*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2)/(2002*d**2*k3**7) - 3*D1**2*Pk2*Pkd3*ct**2*k1**2*k2**4*st**4*(-66*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 3*D1*bd1*(D1*(40*f**3*(r + s - 1) + f**2*(-40*fd*(3*r + 3*s - 2) + (33 - 55*K)*(r + s - 1)) - 44*f*(g2 - gd2)*(r + s - 1) + 44*fd*g2*(r + s)) - 4*Dd*f*(10*f**2 - 11*g2)*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-110*D1**2*K*f*fd*r**2 - 220*D1**2*K*f*fd*r*s + 110*D1**2*K*f*fd*r - 110*D1**2*K*f*fd*s**2 + 110*D1**2*K*f*fd*s - 55*D1**2*K*f*fd - 22*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 120*D1**2*f**2*fd*r**2 + 240*D1**2*f**2*fd*r*s - 160*D1**2*f**2*fd*r + 120*D1**2*f**2*fd*s**2 - 160*D1**2*f**2*fd*s + 80*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 66*D1**2*f*fd*r**2 + 132*D1**2*f*fd*r*s - 66*D1**2*f*fd*r + 66*D1**2*f*fd*s**2 - 66*D1**2*f*fd*s + 33*D1**2*f*fd - 44*D1**2*f*gd2*r**2 - 88*D1**2*f*gd2*r*s + 88*D1**2*f*gd2*r - 44*D1**2*f*gd2*s**2 + 88*D1**2*f*gd2*s - 44*D1**2*f*gd2 + 22*D1**2*f*gdd2*r**2 + 44*D1**2*f*gdd2*r*s - 44*D1**2*f*gdd2*r + 22*D1**2*f*gdd2*s**2 - 44*D1**2*f*gdd2*s + 22*D1**2*f*gdd2 - 44*D1**2*fd*g2*r**2 - 88*D1**2*fd*g2*r*s - 44*D1**2*fd*g2*s**2 + 44*D1**2*fd*gd2*r**2 + 88*D1**2*fd*gd2*r*s - 44*D1**2*fd*gd2*r + 44*D1**2*fd*gd2*s**2 - 44*D1**2*fd*gd2*s + 22*D1**2*fdd*g2*r**2 + 44*D1**2*fdd*g2*r*s + 22*D1**2*fdd*g2*s**2 - 220*D1*Dd*K*f**2*r**2 - 440*D1*Dd*K*f**2*r*s + 330*D1*Dd*K*f**2*r - 220*D1*Dd*K*f**2*s**2 + 330*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 160*D1*Dd*f**3*r**2 + 320*D1*Dd*f**3*r*s - 240*D1*Dd*f**3*r + 160*D1*Dd*f**3*s**2 - 240*D1*Dd*f**3*s + 120*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 680*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 680*D1*Dd*f**2*fd*s - 240*D1*Dd*f**2*fd + 132*D1*Dd*f**2*r**2 + 264*D1*Dd*f**2*r*s - 198*D1*Dd*f**2*r + 132*D1*Dd*f**2*s**2 - 198*D1*Dd*f**2*s + 99*D1*Dd*f**2 - 176*D1*Dd*f*g2*r**2 - 352*D1*Dd*f*g2*r*s + 264*D1*Dd*f*g2*r - 176*D1*Dd*f*g2*s**2 + 264*D1*Dd*f*g2*s - 132*D1*Dd*f*g2 + 176*D1*Dd*f*gd2*r**2 + 352*D1*Dd*f*gd2*r*s - 308*D1*Dd*f*gd2*r + 176*D1*Dd*f*gd2*s**2 - 308*D1*Dd*f*gd2*s + 132*D1*Dd*f*gd2 + 176*D1*Dd*fd*g2*r**2 + 352*D1*Dd*fd*g2*r*s - 132*D1*Dd*fd*g2*r + 176*D1*Dd*fd*g2*s**2 - 132*D1*Dd*fd*g2*s - 80*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 120*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 + 88*D1*Ddd*f*g2*r**2 + 176*D1*Ddd*f*g2*r*s - 132*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2*s**2 - 132*D1*Ddd*f*g2*s + 66*D1*Ddd*f*g2 + 44*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 240*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 360*Dd**2*f**3*s - 120*Dd**2*f**3 + 264*Dd**2*f*g2*r**2 + 528*Dd**2*f*g2*r*s - 396*Dd**2*f*g2*r + 264*Dd**2*f*g2*s**2 - 396*Dd**2*f*g2*s + 132*Dd**2*f*g2) + f*(-6*D1**2*bdd1*(10*f**2 - 11*g2)*(r + s - 1)**2 + 5*D1**2*(3*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*fd*(32*C - 24)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*fdd*(16*C - 12)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 66*f*gd2*(r + s - 1)**2 + 2*fd*(fd*(16*C - 12)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 33*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1))) + 5*D1*f*(Dd*(3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(24 - 32*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(32*C - 24)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Ddd*f*(16*C - 12)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 5*Dd**2*f**2*(96*C - 72)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**7) - 3*D1**2*Pk2*Pkd3*ct**2*k1**2*k2**4*st**2*(-132*D1**2*bd1**2*f*(-4*K + 5*f + 2)*(r + s - 1)**2 + 132*D1**2*bdd1*f*(f*(4*C + 3*K - 3) - 4*g2)*(r + s - 1)**2 - 12*D1**2*(f**2*(fd*(45*C - 17)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(50*C - 25)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (-77*gd2 + 66*gdd2)*(r + s - 1)**2) + f*(-fd**2*(100*C - 50)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 77*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 132*fd*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 66*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 132*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 22*D1*bd1*(D1*(6*f**3*(r + s - 1) + f**2*(43*C + 21*K - 29)*(r + s - 1) - 12*f*fd*(4*C + 3*K - 3)*(2*r + 2*s - 1) - f*(83*g2 - 48*gd2)*(r + s - 1) + 48*fd*g2*(r + s)) - 12*Dd*f*(f*(4*C + 3*K - 3) - 4*g2)*(4*r + 4*s - 3))*(r + s - 1) - 12*D1*f*(Dd*(f**2*(45*C - 17)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-fd*(100*C - 50)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 77*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 132*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 132*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(f*(50*C - 25) - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 72*Dd**2*f**2*(f*(50*C - 25) - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 11*b1**2*(D1**2*(6*f*(9*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(60*fd**2*(r + s - 1) + fd*(83*K - 45)*(r + s) - 12*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(54*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (83*K - 45)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 24*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-4*K + 5*f + 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-4*K + 5*f + 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*(-86*C*D1**2*f*fd*r**2 - 172*C*D1**2*f*fd*r*s + 86*C*D1**2*f*fd*r - 86*C*D1**2*f*fd*s**2 + 86*C*D1**2*f*fd*s - 43*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r**2 + 96*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 48*C*D1**2*f*fdd*s**2 - 48*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r**2 + 96*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 48*C*D1**2*fd**2*s**2 - 48*C*D1**2*fd**2*s - 172*C*D1*Dd*f**2*r**2 - 344*C*D1*Dd*f**2*r*s + 258*C*D1*Dd*f**2*r - 172*C*D1*Dd*f**2*s**2 + 258*C*D1*Dd*f**2*s - 129*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r**2 + 768*C*D1*Dd*f*fd*r*s - 480*C*D1*Dd*f*fd*r + 384*C*D1*Dd*f*fd*s**2 - 480*C*D1*Dd*f*fd*s + 144*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 + 192*C*D1*Ddd*f**2*r*s - 144*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r**2 + 576*C*Dd**2*f**2*r*s - 432*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 144*C*Dd**2*f**2 - 42*D1**2*K*f*fd*r**2 - 84*D1**2*K*f*fd*r*s + 42*D1**2*K*f*fd*r - 42*D1**2*K*f*fd*s**2 + 42*D1**2*K*f*fd*s - 21*D1**2*K*f*fd + 36*D1**2*K*f*fdd*r**2 + 72*D1**2*K*f*fdd*r*s - 36*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r**2 + 72*D1**2*K*fd**2*r*s - 36*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-4*K + 5*f + 2)*(r + s - 1)**2 - 18*D1**2*f**2*fd*r**2 - 36*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 24*D1**2*f**2*fd*s - 12*D1**2*f**2*fd + 58*D1**2*f*fd*r**2 + 116*D1**2*f*fd*r*s - 58*D1**2*f*fd*r + 58*D1**2*f*fd*s**2 - 58*D1**2*f*fd*s + 29*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd + 83*D1**2*f*gd2*r**2 + 166*D1**2*f*gd2*r*s - 166*D1**2*f*gd2*r + 83*D1**2*f*gd2*s**2 - 166*D1**2*f*gd2*s + 83*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 83*D1**2*fd*g2*r**2 + 166*D1**2*fd*g2*r*s + 83*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 - 84*D1*Dd*K*f**2*r**2 - 168*D1*Dd*K*f**2*r*s + 126*D1*Dd*K*f**2*r - 84*D1*Dd*K*f**2*s**2 + 126*D1*Dd*K*f**2*s - 63*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r**2 + 576*D1*Dd*K*f*fd*r*s - 360*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 360*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd - 24*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 36*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 116*D1*Dd*f**2*r**2 + 232*D1*Dd*f**2*r*s - 174*D1*Dd*f**2*r + 116*D1*Dd*f**2*s**2 - 174*D1*Dd*f**2*s + 87*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 332*D1*Dd*f*g2*r**2 + 664*D1*Dd*f*g2*r*s - 498*D1*Dd*f*g2*r + 332*D1*Dd*f*g2*s**2 - 498*D1*Dd*f*g2*s + 249*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 144*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s + 72*D1*Ddd*K*f**2*r**2 + 144*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 108*D1*Ddd*K*f**2*s + 54*D1*Ddd*K*f**2 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + D1*bd1*(D1*(54*f**2*(r + s - 1) - 60*f*fd*(2*r + 2*s - 1) - f*(83*K - 45)*(r + s - 1) + 24*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-4*K + 5*f + 2)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*f**2*r**2 + 432*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 324*Dd**2*K*f**2*s + 108*Dd**2*K*f**2 - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(154*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct**2*k1**2*k2**4*(D1*(-72*D1*K*bd1**2*f*(r + s - 1)**2 + 6*bd1*(D1*(f**2*(2*C - K + 1)*(r + s - 1) - f*fd*(20*C - 10)*(2*r + 2*s - 1) - 3*f*(g2 - 8*gd2)*(r + s - 1) + 24*fd*g2*(r + s)) - 2*Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1) + f*(-6*D1*bdd1*(f*(10*C - 5) - 12*g2)*(r + s - 1)**2 + D1*(f*(-fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 12*gd2*(r + s - 1)**2) + 12*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**2*(D1**2*(18*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-36*K*fdd + fd*(9*K + 14))) + D1*(Dd*(-72*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 216*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(3*D1**2*(f*(fd*(2*C - K + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s - 1)**2*(-12*K*bdd1 - 3*gd2 + 12*gdd2)) - (r + s)*(fd**2*(20*C - 10)*(r + s - 1) + 3*fd*(g2*(r + s) - 8*gd2*(r + s - 1)) - 12*fdd*g2*(r + s))) + D1*bd1*(D1*(-72*K*fd*(r + s) + 18*f**2*(r + s - 1) + f*(9*K + 14)*(r + s - 1)) - 72*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + 3*D1*(Dd*(f**2*(2*C - K + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 3*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 24*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 24*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(f*(10*C - 5) - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**7) - 20*D1**2*Pk2*Pkd3*ct**2*k1**2*k2**2*st**6*(156*C*D1**2*f**2*fd*r*s - 52*C*D1**2*f**2*fd*r + 156*C*D1**2*f**2*fd*s**2 - 156*C*D1**2*f**2*fd*s + 52*C*D1**2*f**2*fd - 78*C*D1**2*f**2*fdd*r*s + 26*C*D1**2*f**2*fdd*r - 78*C*D1**2*f**2*fdd*s**2 + 78*C*D1**2*f**2*fdd*s - 26*C*D1**2*f**2*fdd - 156*C*D1**2*f*fd**2*r*s + 52*C*D1**2*f*fd**2*r - 156*C*D1**2*f*fd**2*s**2 + 156*C*D1**2*f*fd**2*s - 26*C*D1**2*f*fd**2 + 208*C*D1*Dd*f**3*r*s - 52*C*D1*Dd*f**3*r + 208*C*D1*Dd*f**3*s**2 - 208*C*D1*Dd*f**3*s + 52*C*D1*Dd*f**3 - 624*C*D1*Dd*f**2*fd*r*s + 182*C*D1*Dd*f**2*fd*r - 624*C*D1*Dd*f**2*fd*s**2 + 624*C*D1*Dd*f**2*fd*s - 130*C*D1*Dd*f**2*fd - 104*C*D1*Ddd*f**3*r*s + 26*C*D1*Ddd*f**3*r - 104*C*D1*Ddd*f**3*s**2 + 104*C*D1*Ddd*f**3*s - 26*C*D1*Ddd*f**3 - 312*C*Dd**2*f**3*r*s + 78*C*Dd**2*f**3*r - 312*C*Dd**2*f**3*s**2 + 312*C*Dd**2*f**3*s - 52*C*Dd**2*f**3 - 429*D1**2*K*bdd1*f**2*r*s - 429*D1**2*K*bdd1*f**2*s**2 + 429*D1**2*K*bdd1*f**2*s + 429*D1**2*bdd1*f**2*r*s + 429*D1**2*bdd1*f**2*s**2 - 429*D1**2*bdd1*f**2*s - 672*D1**2*f**3*fd*r*s + 168*D1**2*f**3*fd*r - 672*D1**2*f**3*fd*s**2 + 672*D1**2*f**3*fd*s - 168*D1**2*f**3*fd + 336*D1**2*f**3*fdd*r*s - 84*D1**2*f**3*fdd*r + 336*D1**2*f**3*fdd*s**2 - 336*D1**2*f**3*fdd*s + 84*D1**2*f**3*fdd + 1008*D1**2*f**2*fd**2*r*s - 252*D1**2*f**2*fd**2*r + 1008*D1**2*f**2*fd**2*s**2 - 1008*D1**2*f**2*fd**2*s + 168*D1**2*f**2*fd**2 - 156*D1**2*f**2*fd*r*s + 52*D1**2*f**2*fd*r - 156*D1**2*f**2*fd*s**2 + 156*D1**2*f**2*fd*s - 52*D1**2*f**2*fd + 78*D1**2*f**2*fdd*r*s - 26*D1**2*f**2*fdd*r + 78*D1**2*f**2*fdd*s**2 - 78*D1**2*f**2*fdd*s + 26*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r*s - 1716*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s + 858*D1**2*f**2*gdd2*r*s + 858*D1**2*f**2*gdd2*s**2 - 858*D1**2*f**2*gdd2*s + 156*D1**2*f*fd**2*r*s - 52*D1**2*f*fd**2*r + 156*D1**2*f*fd**2*s**2 - 156*D1**2*f*fd**2*s + 26*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r*s - 858*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 3432*D1**2*f*fd*gd2*s + 858*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r*s - 858*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r*s - 858*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s - 672*D1*Dd*f**4*r*s + 168*D1*Dd*f**4*r - 672*D1*Dd*f**4*s**2 + 672*D1*Dd*f**4*s - 168*D1*Dd*f**4 + 2688*D1*Dd*f**3*fd*r*s - 672*D1*Dd*f**3*fd*r + 2688*D1*Dd*f**3*fd*s**2 - 2688*D1*Dd*f**3*fd*s + 504*D1*Dd*f**3*fd - 208*D1*Dd*f**3*r*s + 52*D1*Dd*f**3*r - 208*D1*Dd*f**3*s**2 + 208*D1*Dd*f**3*s - 52*D1*Dd*f**3 + 624*D1*Dd*f**2*fd*r*s - 182*D1*Dd*f**2*fd*r + 624*D1*Dd*f**2*fd*s**2 - 624*D1*Dd*f**2*fd*s + 130*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r*s + 1716*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 6864*D1*Dd*f**2*g2*s - 1716*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r*s - 858*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 6864*D1*Dd*f**2*gd2*s + 858*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r*s - 5148*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 13728*D1*Dd*f*fd*g2*s + 3432*D1*Dd*f*fd*g2 + 336*D1*Ddd*f**4*r*s - 84*D1*Ddd*f**4*r + 336*D1*Ddd*f**4*s**2 - 336*D1*Ddd*f**4*s + 84*D1*Ddd*f**4 + 104*D1*Ddd*f**3*r*s - 26*D1*Ddd*f**3*r + 104*D1*Ddd*f**3*s**2 - 104*D1*Ddd*f**3*s + 26*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r*s - 858*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 3432*D1*Ddd*f**2*g2*s + 858*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 1008*Dd**2*f**4*r*s - 252*Dd**2*f**4*r + 1008*Dd**2*f**4*s**2 - 1008*Dd**2*f**4*s + 168*Dd**2*f**4 + 312*Dd**2*f**3*r*s - 78*Dd**2*f**3*r + 312*Dd**2*f**3*s**2 - 312*Dd**2*f**3*s + 52*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r*s - 2574*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 10296*Dd**2*f**2*g2*s + 1716*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**2*k1**2*k2**2*st**4*(576*C*D1**2*f**2*fd*r**2 - 624*C*D1**2*f**2*fd*r*s - 176*C*D1**2*f**2*fd*r - 1200*C*D1**2*f**2*fd*s**2 + 1008*C*D1**2*f**2*fd*s - 208*C*D1**2*f**2*fd - 288*C*D1**2*f**2*fdd*r**2 + 312*C*D1**2*f**2*fdd*r*s + 88*C*D1**2*f**2*fdd*r + 600*C*D1**2*f**2*fdd*s**2 - 504*C*D1**2*f**2*fdd*s + 104*C*D1**2*f**2*fdd - 576*C*D1**2*f*fd**2*r**2 + 624*C*D1**2*f*fd**2*r*s + 176*C*D1**2*f*fd**2*r + 1200*C*D1**2*f*fd**2*s**2 - 1008*C*D1**2*f*fd**2*s + 104*C*D1**2*f*fd**2 + 768*C*D1*Dd*f**3*r**2 - 832*C*D1*Dd*f**3*r*s - 560*C*D1*Dd*f**3*r - 1600*C*D1*Dd*f**3*s**2 + 1216*C*D1*Dd*f**3*s - 16*C*D1*Dd*f**3 - 2304*C*D1*Dd*f**2*fd*r**2 + 2496*C*D1*Dd*f**2*fd*r*s + 1192*C*D1*Dd*f**2*fd*r + 4800*C*D1*Dd*f**2*fd*s**2 - 3840*C*D1*Dd*f**2*fd*s + 328*C*D1*Dd*f**2*fd - 384*C*D1*Ddd*f**3*r**2 + 416*C*D1*Ddd*f**3*r*s + 280*C*D1*Ddd*f**3*r + 800*C*D1*Ddd*f**3*s**2 - 608*C*D1*Ddd*f**3*s + 8*C*D1*Ddd*f**3 - 1152*C*Dd**2*f**3*r**2 + 1248*C*Dd**2*f**3*r*s + 840*C*Dd**2*f**3*r + 2400*C*Dd**2*f**3*s**2 - 1824*C*Dd**2*f**3*s + 16*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r**2 + 462*D1**2*K*bdd1*f**2*r*s - 330*D1**2*K*bdd1*f**2*r + 297*D1**2*K*bdd1*f**2*s**2 - 462*D1**2*K*bdd1*f**2*s + 165*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(K - 1)*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2) + 375*D1**2*bdd1*f**3*r**2 + 570*D1**2*bdd1*f**3*r*s - 660*D1**2*bdd1*f**3*r + 195*D1**2*bdd1*f**3*s**2 - 480*D1**2*bdd1*f**3*s + 360*D1**2*bdd1*f**3 - 165*D1**2*bdd1*f**2*r**2 - 462*D1**2*bdd1*f**2*r*s + 330*D1**2*bdd1*f**2*r - 297*D1**2*bdd1*f**2*s**2 + 462*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 + 330*D1**2*bdd1*f*g2*r**2 + 924*D1**2*bdd1*f*g2*r*s - 264*D1**2*bdd1*f*g2*r + 594*D1**2*bdd1*f*g2*s**2 - 528*D1**2*bdd1*f*g2*s + 264*D1**2*bdd1*f*g2 + 1260*D1**2*f**3*fd*r**2 + 2400*D1**2*f**3*fd*r*s - 1860*D1**2*f**3*fd*r + 1140*D1**2*f**3*fd*s**2 - 1770*D1**2*f**3*fd*s + 915*D1**2*f**3*fd - 1380*D1**2*f**3*fdd*r**2 - 2160*D1**2*f**3*fdd*r*s + 1920*D1**2*f**3*fdd*r - 780*D1**2*f**3*fdd*s**2 + 1470*D1**2*f**3*fdd*s - 885*D1**2*f**3*fdd - 4140*D1**2*f**2*fd**2*r**2 - 6480*D1**2*f**2*fd**2*r*s + 5760*D1**2*f**2*fd**2*r - 2340*D1**2*f**2*fd**2*s**2 + 4410*D1**2*f**2*fd**2*s - 1770*D1**2*f**2*fd**2 - 1176*D1**2*f**2*fd*r**2 - 936*D1**2*f**2*fd*r*s + 1096*D1**2*f**2*fd*r + 240*D1**2*f**2*fd*s**2 + 152*D1**2*f**2*fd*s - 312*D1**2*f**2*fd + 588*D1**2*f**2*fdd*r**2 + 468*D1**2*f**2*fdd*r*s - 548*D1**2*f**2*fdd*r - 120*D1**2*f**2*fdd*s**2 - 76*D1**2*f**2*fdd*s + 156*D1**2*f**2*fdd - 66*D1**2*f**2*gd2*r**2 + 1188*D1**2*f**2*gd2*r*s + 132*D1**2*f**2*gd2*r + 1254*D1**2*f**2*gd2*s**2 - 1188*D1**2*f**2*gd2*s - 66*D1**2*f**2*gd2 - 330*D1**2*f**2*gdd2*r**2 - 924*D1**2*f**2*gdd2*r*s + 660*D1**2*f**2*gdd2*r - 594*D1**2*f**2*gdd2*s**2 + 924*D1**2*f**2*gdd2*s - 330*D1**2*f**2*gdd2 + 1176*D1**2*f*fd**2*r**2 + 936*D1**2*f*fd**2*r*s - 1096*D1**2*f*fd**2*r - 240*D1**2*f*fd**2*s**2 - 152*D1**2*f*fd**2*s + 156*D1**2*f*fd**2 - 132*D1**2*f*fd*g2*r**2 + 2376*D1**2*f*fd*g2*r*s - 1188*D1**2*f*fd*g2*r + 2508*D1**2*f*fd*g2*s**2 - 2508*D1**2*f*fd*g2*s + 1254*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r**2 - 3696*D1**2*f*fd*gd2*r*s + 2244*D1**2*f*fd*gd2*r - 2376*D1**2*f*fd*gd2*s**2 + 3036*D1**2*f*fd*gd2*s - 924*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r**2 - 1848*D1**2*f*fdd*g2*r*s + 924*D1**2*f*fdd*g2*r - 1188*D1**2*f*fdd*g2*s**2 + 1188*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r**2 - 1848*D1**2*fd**2*g2*r*s + 924*D1**2*fd**2*g2*r - 1188*D1**2*fd**2*g2*s**2 + 1188*D1**2*fd**2*g2*s + 1260*D1*Dd*f**4*r**2 + 2400*D1*Dd*f**4*r*s - 1860*D1*Dd*f**4*r + 1140*D1*Dd*f**4*s**2 - 1770*D1*Dd*f**4*s + 915*D1*Dd*f**4 - 11040*D1*Dd*f**3*fd*r**2 - 17280*D1*Dd*f**3*fd*r*s + 15360*D1*Dd*f**3*fd*r - 6240*D1*Dd*f**3*fd*s**2 + 11760*D1*Dd*f**3*fd*s - 5310*D1*Dd*f**3*fd - 1568*D1*Dd*f**3*r**2 - 1248*D1*Dd*f**3*r*s + 1880*D1*Dd*f**3*r + 320*D1*Dd*f**3*s**2 + 464*D1*Dd*f**3*s - 704*D1*Dd*f**3 + 4704*D1*Dd*f**2*fd*r**2 + 3744*D1*Dd*f**2*fd*r*s - 5012*D1*Dd*f**2*fd*r - 960*D1*Dd*f**2*fd*s**2 - 1000*D1*Dd*f**2*fd*s + 1172*D1*Dd*f**2*fd - 264*D1*Dd*f**2*g2*r**2 + 4752*D1*Dd*f**2*g2*r*s - 924*D1*Dd*f**2*g2*r + 5016*D1*Dd*f**2*g2*s**2 - 4884*D1*Dd*f**2*g2*s + 1122*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r**2 - 7392*D1*Dd*f**2*gd2*r*s + 4884*D1*Dd*f**2*gd2*r - 4752*D1*Dd*f**2*gd2*s**2 + 6732*D1*Dd*f**2*gd2*s - 2244*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r**2 - 14784*D1*Dd*f*fd*g2*r*s + 8184*D1*Dd*f*fd*g2*r - 9504*D1*Dd*f*fd*g2*s**2 + 10824*D1*Dd*f*fd*g2*s - 3036*D1*Dd*f*fd*g2 - 1380*D1*Ddd*f**4*r**2 - 2160*D1*Ddd*f**4*r*s + 1920*D1*Ddd*f**4*r - 780*D1*Ddd*f**4*s**2 + 1470*D1*Ddd*f**4*s - 885*D1*Ddd*f**4 + 784*D1*Ddd*f**3*r**2 + 624*D1*Ddd*f**3*r*s - 940*D1*Ddd*f**3*r - 160*D1*Ddd*f**3*s**2 - 232*D1*Ddd*f**3*s + 352*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r**2 - 3696*D1*Ddd*f**2*g2*r*s + 2244*D1*Ddd*f**2*g2*r - 2376*D1*Ddd*f**2*g2*s**2 + 3036*D1*Ddd*f**2*g2*s - 1254*D1*Ddd*f**2*g2 - 3*D1*bd1*(D1*(10*f**3*(25*r**2 + r*(38*s - 44) + 13*s**2 - 32*s + 24) - f**2*(10*fd*(75*r**2 + r*(114*s - 113) + 39*s**2 - 83*s + 36) + (11*r + 11*s - 11)*(K*(r - 19*s - 1) - 11*r + 5*s + 11)) - 22*f*(fd*(K - 1)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) - 2*g2*(5*r**2 + 2*r*(7*s - 2) + 9*s**2 - 8*s + 4) + 2*gd2*(5*r**2 + 7*r*(2*s - 1) + 9*s**2 - 11*s + 2)) - 44*fd*g2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9))) - 2*Dd*f*(5*f**2*(100*r**2 + r*(152*s - 157) + 52*s**2 - 115*s + 60) + 11*f*(K - 1)*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) + 22*g2*(20*r**2 + r*(56*s - 25) + 36*s**2 - 39*s + 8))) - 4140*Dd**2*f**4*r**2 - 6480*Dd**2*f**4*r*s + 5760*Dd**2*f**4*r - 2340*Dd**2*f**4*s**2 + 4410*Dd**2*f**4*s - 1770*Dd**2*f**4 + 2352*Dd**2*f**3*r**2 + 1872*Dd**2*f**3*r*s - 2820*Dd**2*f**3*r - 480*Dd**2*f**3*s**2 - 696*Dd**2*f**3*s + 704*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r**2 - 11088*Dd**2*f**2*g2*r*s + 6732*Dd**2*f**2*g2*r - 7128*Dd**2*f**2*g2*s**2 + 9108*Dd**2*f**2*g2*s - 2508*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 10*s + 5) + D1*(2*Dd*(f*(20*r**2 + 56*r*s - 34*r + 36*s**2 - 46*s + 19) - fd*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 43*s + 15)) - Ddd*f*(20*r**2 + r*(56*s - 34) + 36*s**2 - 46*s + 19)) - 2*Dd**2*f*(30*r**2 + r*(84*s - 51) + 54*s**2 - 69*s + 19)) + 3*b1*(22*D1**2*K*f*fd*r**2 - 396*D1**2*K*f*fd*r*s + 198*D1**2*K*f*fd*r - 418*D1**2*K*f*fd*s**2 + 418*D1**2*K*f*fd*s - 209*D1**2*K*f*fd + 110*D1**2*K*f*fdd*r**2 + 308*D1**2*K*f*fdd*r*s - 154*D1**2*K*f*fdd*r + 198*D1**2*K*f*fdd*s**2 - 198*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 110*D1**2*K*fd**2*r**2 + 308*D1**2*K*fd**2*r*s - 154*D1**2*K*fd**2*r + 198*D1**2*K*fd**2*s**2 - 198*D1**2*K*fd**2*s - 11*D1**2*bdd1*f*(K - 1)*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) - 750*D1**2*f**2*fd*r**2 - 1140*D1**2*f**2*fd*r*s + 940*D1**2*f**2*fd*r - 390*D1**2*f**2*fd*s**2 + 700*D1**2*f**2*fd*s - 390*D1**2*f**2*fd + 375*D1**2*f**2*fdd*r**2 + 570*D1**2*f**2*fdd*r*s - 470*D1**2*f**2*fdd*r + 195*D1**2*f**2*fdd*s**2 - 350*D1**2*f**2*fdd*s + 195*D1**2*f**2*fdd + 750*D1**2*f*fd**2*r**2 + 1140*D1**2*f*fd**2*r*s - 940*D1**2*f*fd**2*r + 390*D1**2*f*fd**2*s**2 - 700*D1**2*f*fd**2*s + 270*D1**2*f*fd**2 - 242*D1**2*f*fd*r**2 - 132*D1**2*f*fd*r*s + 66*D1**2*f*fd*r + 110*D1**2*f*fd*s**2 - 110*D1**2*f*fd*s + 55*D1**2*f*fd - 110*D1**2*f*fdd*r**2 - 308*D1**2*f*fdd*r*s + 154*D1**2*f*fdd*r - 198*D1**2*f*fdd*s**2 + 198*D1**2*f*fdd*s - 99*D1**2*f*fdd - 220*D1**2*f*gd2*r**2 - 616*D1**2*f*gd2*r*s + 440*D1**2*f*gd2*r - 396*D1**2*f*gd2*s**2 + 616*D1**2*f*gd2*s - 220*D1**2*f*gd2 + 110*D1**2*f*gdd2*r**2 + 308*D1**2*f*gdd2*r*s - 220*D1**2*f*gdd2*r + 198*D1**2*f*gdd2*s**2 - 308*D1**2*f*gdd2*s + 110*D1**2*f*gdd2 - 110*D1**2*fd**2*r**2 - 308*D1**2*fd**2*r*s + 154*D1**2*fd**2*r - 198*D1**2*fd**2*s**2 + 198*D1**2*fd**2*s - 220*D1**2*fd*g2*r**2 - 616*D1**2*fd*g2*r*s + 440*D1**2*fd*g2*r - 396*D1**2*fd*g2*s**2 + 440*D1**2*fd*g2*s - 220*D1**2*fd*g2 + 220*D1**2*fd*gd2*r**2 + 616*D1**2*fd*gd2*r*s - 440*D1**2*fd*gd2*r + 396*D1**2*fd*gd2*s**2 - 528*D1**2*fd*gd2*s + 220*D1**2*fd*gd2 + 110*D1**2*fdd*g2*r**2 + 308*D1**2*fdd*g2*r*s - 220*D1**2*fdd*g2*r + 198*D1**2*fdd*g2*s**2 - 220*D1**2*fdd*g2*s + 110*D1**2*fdd*g2 + 44*D1*Dd*K*f**2*r**2 - 792*D1*Dd*K*f**2*r*s + 154*D1*Dd*K*f**2*r - 836*D1*Dd*K*f**2*s**2 + 814*D1*Dd*K*f**2*s - 187*D1*Dd*K*f**2 + 880*D1*Dd*K*f*fd*r**2 + 2464*D1*Dd*K*f*fd*r*s - 1364*D1*Dd*K*f*fd*r + 1584*D1*Dd*K*f*fd*s**2 - 1804*D1*Dd*K*f*fd*s + 506*D1*Dd*K*f*fd - 1000*D1*Dd*f**3*r**2 - 1520*D1*Dd*f**3*r*s + 1380*D1*Dd*f**3*r - 520*D1*Dd*f**3*s**2 + 1020*D1*Dd*f**3*s - 630*D1*Dd*f**3 + 3000*D1*Dd*f**2*fd*r**2 + 4560*D1*Dd*f**2*fd*r*s - 3950*D1*Dd*f**2*fd*r + 1560*D1*Dd*f**2*fd*s**2 - 2930*D1*Dd*f**2*fd*s + 1290*D1*Dd*f**2*fd - 484*D1*Dd*f**2*r**2 - 264*D1*Dd*f**2*r*s + 550*D1*Dd*f**2*r + 220*D1*Dd*f**2*s**2 + 22*D1*Dd*f**2*s - 187*D1*Dd*f**2 - 880*D1*Dd*f*fd*r**2 - 2464*D1*Dd*f*fd*r*s + 1364*D1*Dd*f*fd*r - 1584*D1*Dd*f*fd*s**2 + 1804*D1*Dd*f*fd*s - 506*D1*Dd*f*fd - 880*D1*Dd*f*g2*r**2 - 2464*D1*Dd*f*g2*r*s + 1496*D1*Dd*f*g2*r - 1584*D1*Dd*f*g2*s**2 + 2024*D1*Dd*f*g2*s - 836*D1*Dd*f*g2 + 880*D1*Dd*f*gd2*r**2 + 2464*D1*Dd*f*gd2*r*s - 1628*D1*Dd*f*gd2*r + 1584*D1*Dd*f*gd2*s**2 - 2244*D1*Dd*f*gd2*s + 748*D1*Dd*f*gd2 + 880*D1*Dd*fd*g2*r**2 + 2464*D1*Dd*fd*g2*r*s - 1628*D1*Dd*fd*g2*r + 1584*D1*Dd*fd*g2*s**2 - 1892*D1*Dd*fd*g2*s + 660*D1*Dd*fd*g2 + 220*D1*Ddd*K*f**2*r**2 + 616*D1*Ddd*K*f**2*r*s - 374*D1*Ddd*K*f**2*r + 396*D1*Ddd*K*f**2*s**2 - 506*D1*Ddd*K*f**2*s + 209*D1*Ddd*K*f**2 + 500*D1*Ddd*f**3*r**2 + 760*D1*Ddd*f**3*r*s - 690*D1*Ddd*f**3*r + 260*D1*Ddd*f**3*s**2 - 510*D1*Ddd*f**3*s + 315*D1*Ddd*f**3 - 220*D1*Ddd*f**2*r**2 - 616*D1*Ddd*f**2*r*s + 374*D1*Ddd*f**2*r - 396*D1*Ddd*f**2*s**2 + 506*D1*Ddd*f**2*s - 209*D1*Ddd*f**2 + 440*D1*Ddd*f*g2*r**2 + 1232*D1*Ddd*f*g2*r*s - 748*D1*Ddd*f*g2*r + 792*D1*Ddd*f*g2*s**2 - 1012*D1*Ddd*f*g2*s + 418*D1*Ddd*f*g2 + 22*D1*bd1*(K - 1)*(D1*(f*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 22*s + 9) - fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 21*s + 5)) - Dd*f*(40*r**2 + 2*r*(56*s - 31) + 72*s**2 - 90*s + 25)) + 660*Dd**2*K*f**2*r**2 + 1848*Dd**2*K*f**2*r*s - 1122*Dd**2*K*f**2*r + 1188*Dd**2*K*f**2*s**2 - 1518*Dd**2*K*f**2*s + 418*Dd**2*K*f**2 + 1500*Dd**2*f**3*r**2 + 2280*Dd**2*f**3*r*s - 2070*Dd**2*f**3*r + 780*Dd**2*f**3*s**2 - 1530*Dd**2*f**3*s + 630*Dd**2*f**3 - 660*Dd**2*f**2*r**2 - 1848*Dd**2*f**2*r*s + 1122*Dd**2*f**2*r - 1188*Dd**2*f**2*s**2 + 1518*Dd**2*f**2*s - 418*Dd**2*f**2 + 1320*Dd**2*f*g2*r**2 + 3696*Dd**2*f*g2*r*s - 2244*Dd**2*f*g2*r + 2376*Dd**2*f*g2*s**2 - 3036*Dd**2*f*g2*s + 836*Dd**2*f*g2))/(231*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**2*k1**2*k2**2*st**2*(418*C*D1**2*bdd1*f**2*r**2 + 1364*C*D1**2*bdd1*f**2*r*s + 1276*C*D1**2*bdd1*f**2*r + 946*C*D1**2*bdd1*f**2*s**2 + 748*C*D1**2*bdd1*f**2*s - 374*C*D1**2*bdd1*f**2 + 19716*C*D1**2*f**2*fd*r**2 + 46104*C*D1**2*f**2*fd*r*s - 28512*C*D1**2*f**2*fd*r + 26388*C*D1**2*f**2*fd*s**2 - 32960*C*D1**2*f**2*fd*s + 15368*C*D1**2*f**2*fd - 17712*C*D1**2*f**2*fdd*r**2 - 39024*C*D1**2*f**2*fdd*r*s + 24816*C*D1**2*f**2*fdd*r - 21312*C*D1**2*f**2*fdd*s**2 + 27216*C*D1**2*f**2*fdd*s - 13008*C*D1**2*f**2*fdd - 35424*C*D1**2*f*fd**2*r**2 - 78048*C*D1**2*f*fd**2*r*s + 49632*C*D1**2*f*fd**2*r - 42624*C*D1**2*f*fd**2*s**2 + 54432*C*D1**2*f*fd**2*s - 13008*C*D1**2*f*fd**2 + 26288*C*D1*Dd*f**3*r**2 + 61472*C*D1*Dd*f**3*r*s - 41656*C*D1*Dd*f**3*r + 35184*C*D1*Dd*f**3*s**2 - 48328*C*D1*Dd*f**3*s + 21940*C*D1*Dd*f**3 - 141696*C*D1*Dd*f**2*fd*r**2 - 312192*C*D1*Dd*f**2*fd*r*s + 209136*C*D1*Dd*f**2*fd*r - 170496*C*D1*Dd*f**2*fd*s**2 + 229536*C*D1*Dd*f**2*fd*s - 76848*C*D1*Dd*f**2*fd - 23616*C*D1*Ddd*f**3*r**2 - 52032*C*D1*Ddd*f**3*r*s + 36624*C*D1*Ddd*f**3*r - 28416*C*D1*Ddd*f**3*s**2 + 40224*C*D1*Ddd*f**3*s - 18912*C*D1*Ddd*f**3 - 70848*C*Dd**2*f**3*r**2 - 156096*C*Dd**2*f**3*r*s + 109872*C*Dd**2*f**3*r - 85248*C*Dd**2*f**3*s**2 + 120672*C*Dd**2*f**3*s - 37824*C*Dd**2*f**3 - 3432*D1**2*K*bdd1*f**2*r**2 - 7656*D1**2*K*bdd1*f**2*r*s + 6864*D1**2*K*bdd1*f**2*r - 4224*D1**2*K*bdd1*f**2*s**2 + 7656*D1**2*K*bdd1*f**2*s - 3432*D1**2*K*bdd1*f**2 + 5940*D1**2*b2*f*fd*r**2 + 11880*D1**2*b2*f*fd*r*s - 5940*D1**2*b2*f*fd*r + 5940*D1**2*b2*f*fd*s**2 - 5940*D1**2*b2*f*fd*s + 2970*D1**2*b2*f*fd - 3960*D1**2*b2*f*fdd*r**2 - 7920*D1**2*b2*f*fdd*r*s + 3960*D1**2*b2*f*fdd*r - 3960*D1**2*b2*f*fdd*s**2 + 3960*D1**2*b2*f*fdd*s - 1980*D1**2*b2*f*fdd - 3960*D1**2*b2*fd**2*r**2 - 7920*D1**2*b2*fd**2*r*s + 3960*D1**2*b2*fd**2*r - 3960*D1**2*b2*fd**2*s**2 + 3960*D1**2*b2*fd**2*s + 22*D1**2*bd1**2*(r + s - 1)*(60*f**2*(r + s - 2) + f*(10*C*r + 10*C*s + K*(59*r + 83*s - 11) + 21*r - 3*s - 49) + 70*g2*(r + s)) + 660*D1**2*bdd1*f**3*r**2 + 2508*D1**2*bdd1*f**3*r*s - 2244*D1**2*bdd1*f**3*r + 1848*D1**2*bdd1*f**3*s**2 - 3432*D1**2*bdd1*f**3*s + 1584*D1**2*bdd1*f**3 + 1298*D1**2*bdd1*f**2*r**2 + 2464*D1**2*bdd1*f**2*r*s - 4048*D1**2*bdd1*f**2*r + 1166*D1**2*bdd1*f**2*s**2 - 3916*D1**2*bdd1*f**2*s + 1760*D1**2*bdd1*f**2 - 1298*D1**2*bdd1*f*g2*r**2 - 3124*D1**2*bdd1*f*g2*r*s + 484*D1**2*bdd1*f*g2*r - 1826*D1**2*bdd1*f*g2*s**2 + 1012*D1**2*bdd1*f*g2*s - 506*D1**2*bdd1*f*g2 - 1980*D1**2*bdd2*f**2*r**2 - 3960*D1**2*bdd2*f**2*r*s + 3960*D1**2*bdd2*f**2*r - 1980*D1**2*bdd2*f**2*s**2 + 3960*D1**2*bdd2*f**2*s - 1980*D1**2*bdd2*f**2 - 10386*D1**2*f**2*fd*r**2 - 26172*D1**2*f**2*fd*r*s + 15648*D1**2*f**2*fd*r - 15786*D1**2*f**2*fd*s**2 + 19248*D1**2*f**2*fd*s - 8724*D1**2*f**2*fd + 11034*D1**2*f**2*fdd*r**2 + 24768*D1**2*f**2*fdd*r*s - 15612*D1**2*f**2*fdd*r + 13734*D1**2*f**2*fdd*s**2 - 17412*D1**2*f**2*fdd*s + 8256*D1**2*f**2*fdd - 8844*D1**2*f**2*gd2*r**2 - 20328*D1**2*f**2*gd2*r*s + 17688*D1**2*f**2*gd2*r - 11484*D1**2*f**2*gd2*s**2 + 20328*D1**2*f**2*gd2*s - 8844*D1**2*f**2*gd2 + 6864*D1**2*f**2*gdd2*r**2 + 15312*D1**2*f**2*gdd2*r*s - 13728*D1**2*f**2*gdd2*r + 8448*D1**2*f**2*gdd2*s**2 - 15312*D1**2*f**2*gdd2*s + 6864*D1**2*f**2*gdd2 + 22068*D1**2*f*fd**2*r**2 + 49536*D1**2*f*fd**2*r*s - 31224*D1**2*f*fd**2*r + 27468*D1**2*f*fd**2*s**2 - 34824*D1**2*f*fd**2*s + 8256*D1**2*f*fd**2 - 17688*D1**2*f*fd*g2*r**2 - 40656*D1**2*f*fd*g2*r*s + 20328*D1**2*f*fd*g2*r - 22968*D1**2*f*fd*g2*s**2 + 22968*D1**2*f*fd*g2*s - 11484*D1**2*f*fd*g2 + 27456*D1**2*f*fd*gd2*r**2 + 61248*D1**2*f*fd*gd2*r*s - 42768*D1**2*f*fd*gd2*r + 33792*D1**2*f*fd*gd2*s**2 - 47520*D1**2*f*fd*gd2*s + 15312*D1**2*f*fd*gd2 + 13728*D1**2*f*fdd*g2*r**2 + 30624*D1**2*f*fdd*g2*r*s - 15312*D1**2*f*fdd*g2*r + 16896*D1**2*f*fdd*g2*s**2 - 16896*D1**2*f*fdd*g2*s + 8448*D1**2*f*fdd*g2 + 13728*D1**2*fd**2*g2*r**2 + 30624*D1**2*fd**2*g2*r*s - 15312*D1**2*fd**2*g2*r + 16896*D1**2*fd**2*g2*s**2 - 16896*D1**2*fd**2*g2*s + 11880*D1*Dd*b2*f**2*r**2 + 23760*D1*Dd*b2*f**2*r*s - 17820*D1*Dd*b2*f**2*r + 11880*D1*Dd*b2*f**2*s**2 - 17820*D1*Dd*b2*f**2*s + 8910*D1*Dd*b2*f**2 - 31680*D1*Dd*b2*f*fd*r**2 - 63360*D1*Dd*b2*f*fd*r*s + 39600*D1*Dd*b2*f*fd*r - 31680*D1*Dd*b2*f*fd*s**2 + 39600*D1*Dd*b2*f*fd*s - 11880*D1*Dd*b2*f*fd - 13848*D1*Dd*f**3*r**2 - 34896*D1*Dd*f**3*r*s + 22572*D1*Dd*f**3*r - 21048*D1*Dd*f**3*s**2 + 27972*D1*Dd*f**3*s - 12186*D1*Dd*f**3 + 88272*D1*Dd*f**2*fd*r**2 + 198144*D1*Dd*f**2*fd*r*s - 131352*D1*Dd*f**2*fd*r + 109872*D1*Dd*f**2*fd*s**2 - 146652*D1*Dd*f**2*fd*s + 48636*D1*Dd*f**2*fd - 35376*D1*Dd*f**2*g2*r**2 - 81312*D1*Dd*f**2*g2*r*s + 55704*D1*Dd*f**2*g2*r - 45936*D1*Dd*f**2*g2*s**2 + 63624*D1*Dd*f**2*g2*s - 29172*D1*Dd*f**2*g2 + 54912*D1*Dd*f**2*gd2*r**2 + 122496*D1*Dd*f**2*gd2*r*s - 97680*D1*Dd*f**2*gd2*r + 67584*D1*Dd*f**2*gd2*s**2 - 108768*D1*Dd*f**2*gd2*s + 42768*D1*Dd*f**2*gd2 + 109824*D1*Dd*f*fd*g2*r**2 + 244992*D1*Dd*f*fd*g2*r*s - 146784*D1*Dd*f*fd*g2*r + 135168*D1*Dd*f*fd*g2*s**2 - 162624*D1*Dd*f*fd*g2*s + 47520*D1*Dd*f*fd*g2 - 7920*D1*Ddd*b2*f**2*r**2 - 15840*D1*Ddd*b2*f**2*r*s + 11880*D1*Ddd*b2*f**2*r - 7920*D1*Ddd*b2*f**2*s**2 + 11880*D1*Ddd*b2*f**2*s - 5940*D1*Ddd*b2*f**2 + 14712*D1*Ddd*f**3*r**2 + 33024*D1*Ddd*f**3*r*s - 22968*D1*Ddd*f**3*r + 18312*D1*Ddd*f**3*s**2 - 25668*D1*Ddd*f**3*s + 11934*D1*Ddd*f**3 + 27456*D1*Ddd*f**2*g2*r**2 + 61248*D1*Ddd*f**2*g2*r*s - 42768*D1*Ddd*f**2*g2*r + 33792*D1*Ddd*f**2*g2*s**2 - 47520*D1*Ddd*f**2*g2*s + 22176*D1*Ddd*f**2*g2 + 22*D1*bd1*(D1*(3*f**3*(9*r**2 + r*(2 - 8*s) - 17*s**2 + 28*s - 6) - f**2*(C*(32*r**2 + 10*r*(10*s + 9) + 68*s**2 + 54*s - 27) - 201*K*r**2 - 462*K*r*s + 402*K*r - 261*K*s**2 + 462*K*s - 201*K - 6*fd*(30*r**2 + 114*r*s - 73*r + 84*s**2 - 118*s + 36) + 60*r**2 + 120*r*s - 224*r + 60*s**2 - 224*s + 94) + f*(2*fd*(C*(38*r**2 + r*(124*s - 21) + 86*s**2 - 57*s - 29) - 6*K*(52*r**2 + 116*r*s - 81*r + 64*s**2 - 90*s + 29) + 118*r**2 + 224*r*s - 207*r + 106*s**2 - 198*s + 101) + g2*(216*r**2 + r*(508*s + 82) + 292*s**2 + 6*s - 3) - 2*gd2*(59*r**2 + 2*r*(71*s - 35) + 83*s**2 - 94*s + 11)) - 2*fd*g2*(59*r**2 + 71*r*(2*s - 1) + s*(83*s - 83))) + 2*Dd*f*(3*f**2*(40*r**2 + 152*r*s - 107*r + 112*s**2 - 170*s + 60) + f*(C*(76*r**2 + r*(248*s + 47) + 172*s**2 - 37*s - 75) - 6*K*(104*r**2 + 232*r*s - 185*r + 128*s**2 - 206*s + 81) + 236*r**2 + 448*r*s - 542*r + 212*s**2 - 521*s + 273) - g2*(236*r**2 + r*(568*s - 233) + 332*s**2 - 317*s + 45))) + 990*D1*bd2*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 4*D1*fd*(2*r + 2*s - 1) - 4*Dd*f*(4*r + 4*s - 3)) - 23760*Dd**2*b2*f**2*r**2 - 47520*Dd**2*b2*f**2*r*s + 35640*Dd**2*b2*f**2*r - 23760*Dd**2*b2*f**2*s**2 + 35640*Dd**2*b2*f**2*s - 11880*Dd**2*b2*f**2 + 44136*Dd**2*f**3*r**2 + 99072*Dd**2*f**3*r*s - 68904*Dd**2*f**3*r + 54936*Dd**2*f**3*s**2 - 77004*Dd**2*f**3*s + 23868*Dd**2*f**3 + 82368*Dd**2*f**2*g2*r**2 + 183744*Dd**2*f**2*g2*r*s - 128304*Dd**2*f**2*g2*r + 101376*Dd**2*f**2*g2*s**2 - 142560*Dd**2*f**2*g2*s + 44352*Dd**2*f**2*g2 + 385*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(-20*C*D1**2*fd*r**2 - 40*C*D1**2*fd*r*s + 40*C*D1**2*fd*r - 20*C*D1**2*fd*s**2 + 40*C*D1**2*fd*s - 20*C*D1**2*fd + 10*C*D1**2*fdd*r**2 + 20*C*D1**2*fdd*r*s - 20*C*D1**2*fdd*r + 10*C*D1**2*fdd*s**2 - 20*C*D1**2*fdd*s + 10*C*D1**2*fdd - 80*C*D1*Dd*f*r**2 - 160*C*D1*Dd*f*r*s + 120*C*D1*Dd*f*r - 80*C*D1*Dd*f*s**2 + 120*C*D1*Dd*f*s - 60*C*D1*Dd*f + 80*C*D1*Dd*fd*r**2 + 160*C*D1*Dd*fd*r*s - 140*C*D1*Dd*fd*r + 80*C*D1*Dd*fd*s**2 - 140*C*D1*Dd*fd*s + 60*C*D1*Dd*fd + 40*C*D1*Ddd*f*r**2 + 80*C*D1*Ddd*f*r*s - 60*C*D1*Ddd*f*r + 40*C*D1*Ddd*f*s**2 - 60*C*D1*Ddd*f*s + 30*C*D1*Ddd*f + 120*C*Dd**2*f*r**2 + 240*C*Dd**2*f*r*s - 180*C*Dd**2*f*r + 120*C*Dd**2*f*s**2 - 180*C*Dd**2*f*s + 60*C*Dd**2*f - 216*D1**2*K*fd*r**2 - 508*D1**2*K*fd*r*s + 590*D1**2*K*fd*r - 292*D1**2*K*fd*s**2 + 590*D1**2*K*fd*s - 295*D1**2*K*fd + 59*D1**2*K*fdd*r**2 + 142*D1**2*K*fdd*r*s - 120*D1**2*K*fdd*r + 83*D1**2*K*fdd*s**2 - 120*D1**2*K*fdd*s + 60*D1**2*K*fdd - 35*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 240*D1**2*f*fd*r**2 - 480*D1**2*f*fd*r*s + 60*D1**2*f*fd*r - 240*D1**2*f*fd*s**2 + 60*D1**2*f*fd*s - 30*D1**2*f*fd + 120*D1**2*f*fdd*r**2 + 240*D1**2*f*fdd*r*s + 120*D1**2*f*fdd*s**2 + 120*D1**2*fd**2*r**2 + 240*D1**2*fd**2*r*s + 120*D1**2*fd**2*s**2 - 120*D1**2*fd**2 - 84*D1**2*fd*r**2 - 92*D1**2*fd*r*s - 370*D1**2*fd*r - 8*D1**2*fd*s**2 - 370*D1**2*fd*s + 185*D1**2*fd + 21*D1**2*fdd*r**2 + 18*D1**2*fdd*r*s + 80*D1**2*fdd*r - 3*D1**2*fdd*s**2 + 80*D1**2*fdd*s - 40*D1**2*fdd - 140*D1**2*gd2*r**2 - 280*D1**2*gd2*r*s + 280*D1**2*gd2*r - 140*D1**2*gd2*s**2 + 280*D1**2*gd2*s - 140*D1**2*gd2 + 70*D1**2*gdd2*r**2 + 140*D1**2*gdd2*r*s - 140*D1**2*gdd2*r + 70*D1**2*gdd2*s**2 - 140*D1**2*gdd2*s + 70*D1**2*gdd2 - 864*D1*Dd*K*f*r**2 - 2032*D1*Dd*K*f*r*s + 1372*D1*Dd*K*f*r - 1168*D1*Dd*K*f*s**2 + 1600*D1*Dd*K*f*s - 724*D1*Dd*K*f + 472*D1*Dd*K*fd*r**2 + 1136*D1*Dd*K*fd*r*s - 858*D1*Dd*K*fd*r + 664*D1*Dd*K*fd*s**2 - 930*D1*Dd*K*fd*s + 360*D1*Dd*K*fd - 480*D1*Dd*f**2*r**2 - 960*D1*Dd*f**2*r*s + 720*D1*Dd*f**2*r - 480*D1*Dd*f**2*s**2 + 720*D1*Dd*f**2*s - 360*D1*Dd*f**2 + 960*D1*Dd*f*fd*r**2 + 1920*D1*Dd*f*fd*r*s - 720*D1*Dd*f*fd*r + 960*D1*Dd*f*fd*s**2 - 720*D1*Dd*f*fd*s - 336*D1*Dd*f*r**2 - 368*D1*Dd*f*r*s + 428*D1*Dd*f*r - 32*D1*Dd*f*s**2 + 200*D1*Dd*f*s - 176*D1*Dd*f + 168*D1*Dd*fd*r**2 + 144*D1*Dd*fd*r*s + 218*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 290*D1*Dd*fd*s - 240*D1*Dd*fd - 560*D1*Dd*g2*r**2 - 1120*D1*Dd*g2*r*s + 840*D1*Dd*g2*r - 560*D1*Dd*g2*s**2 + 840*D1*Dd*g2*s - 420*D1*Dd*g2 + 560*D1*Dd*gd2*r**2 + 1120*D1*Dd*gd2*r*s - 980*D1*Dd*gd2*r + 560*D1*Dd*gd2*s**2 - 980*D1*Dd*gd2*s + 420*D1*Dd*gd2 + 236*D1*Ddd*K*f*r**2 + 568*D1*Ddd*K*f*r*s - 378*D1*Ddd*K*f*r + 332*D1*Ddd*K*f*s**2 - 450*D1*Ddd*K*f*s + 201*D1*Ddd*K*f + 240*D1*Ddd*f**2*r**2 + 480*D1*Ddd*f**2*r*s - 360*D1*Ddd*f**2*r + 240*D1*Ddd*f**2*s**2 - 360*D1*Ddd*f**2*s + 180*D1*Ddd*f**2 + 84*D1*Ddd*f*r**2 + 72*D1*Ddd*f*r*s - 102*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 - 30*D1*Ddd*f*s + 39*D1*Ddd*f + 280*D1*Ddd*g2*r**2 + 560*D1*Ddd*g2*r*s - 420*D1*Ddd*g2*r + 280*D1*Ddd*g2*s**2 - 420*D1*Ddd*g2*s + 210*D1*Ddd*g2 + 70*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 708*Dd**2*K*f*r**2 + 1704*Dd**2*K*f*r*s - 1134*Dd**2*K*f*r + 996*Dd**2*K*f*s**2 - 1350*Dd**2*K*f*s + 402*Dd**2*K*f + 720*Dd**2*f**2*r**2 + 1440*Dd**2*f**2*r*s - 1080*Dd**2*f**2*r + 720*Dd**2*f**2*s**2 - 1080*Dd**2*f**2*s + 360*Dd**2*f**2 + 252*Dd**2*f*r**2 + 216*Dd**2*f*r*s - 306*Dd**2*f*r - 36*Dd**2*f*s**2 - 90*Dd**2*f*s + 78*Dd**2*f + 840*Dd**2*g2*r**2 + 1680*Dd**2*g2*r*s - 1260*Dd**2*g2*r + 840*Dd**2*g2*s**2 - 1260*Dd**2*g2*s + 420*Dd**2*g2) - 11*b1*(70*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2*D1**2*bdd1*(30*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + f*(5*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*(59*r**2 + 142*r*s - 70*r + 83*s**2 - 94*s + 41) + 21*r**2 + 18*r*s - 70*r - 3*s**2 - 46*s + 29) + 35*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*D1**2*(3*f**2*(fd*(27*r**2 - 6*r*(4*s + 5) - 51*s**2 + 22*s + 7) + 2*fdd*(15*r**2 + r*(57*s - 22) + 42*s**2 - 40*s + 12)) + f*(12*fd**2*(15*r**2 + r*(57*s - 22) + 42*s**2 - 40*s + 6) - fd*(C*(64*r**2 + r*(200*s - 254) + 136*s**2 - 290*s + 127) - 3*K*(134*r**2 + 154*r*(2*s - 1) + 174*s**2 - 174*s + 87) + 120*r**2 + 16*r*(15*s - 1) + 120*s**2 - 16*s + 26) + fdd*(C*(38*r**2 + 2*r*(62*s - 79) + 86*s**2 - 182*s + 79) - 12*K*(26*r**2 + 58*r*s - 29*r + 32*s**2 - 32*s + 16) + 118*r**2 + 224*r*s - 46*r + 106*s**2 - 40*s + 32) + (4*gd2*(54*r + 73*s - 54) + gdd2*(-59*r - 83*s + 59))*(r + s - 1)) + 2*fd**2*(C*(19*r**2 + r*(62*s - 79) + 43*s**2 - 91*s + 60) - 192*K*s**2 + 192*K*s + r**2*(59 - 156*K) + r*(-348*K*s + 174*K + 112*s - 23) + 53*s**2 - 20*s - 45) + fd*(g2*(216*r**2 + r*(508*s - 590) + 292*s**2 - 590*s + 295) - 2*gd2*(59*r**2 + r*(142*s - 119) + 83*s**2 - 131*s + 60)) - fdd*g2*(59*r**2 + 2*r*(71*s - 60) + 83*s**2 - 120*s + 60)) + D1*bd1*(D1*(30*f**2*(8*r**2 + 2*r*(8*s - 11) + 8*s**2 - 22*s + 11) + f*(20*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 432*K*r**2 + 1016*K*r*s - 350*K*r + 584*K*s**2 - 502*K*s + 213*K - 240*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 168*r**2 + 184*r*s - 630*r + 16*s**2 - 478*s + 277) - 4*fd*(5*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(59*r**2 + 142*r*s - 95*r + 83*s**2 - 107*s + 30) + 21*r**2 + 18*r*s + 5*r - 3*s**2 + 17*s - 20) + 140*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 140*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(30*f**2*(8*r**2 + 2*r*(8*s - 9) + 8*s**2 - 18*s + 9) + f*(5*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + K*(236*r**2 + 568*r*s - 329*r + 332*s**2 - 413*s + 117) + 84*r**2 + 72*r*s - 191*r - 12*s**2 - 107*s + 93) + 35*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 2*D1*(Dd*(3*f**3*(36*r**2 - 4*r*(8*s + 7) - 68*s**2 + 50*s + 1) + f**2*(-4*C*(32*r**2 + r*(100*s - 57) + 68*s**2 - 84*s + 33) + 3*K*(268*r**2 + r*(616*s - 422) + 348*s**2 - 482*s + 221) + 6*fd*(120*r**2 + r*(456*s - 205) + 336*s**2 - 358*s + 84) - 240*r**2 - 60*r*(8*s - 6) - 240*s**2 + 360*s - 180) + 2*f*(fd*(C*(152*r**2 + r*(496*s - 454) + 344*s**2 - 574*s + 249) - 12*K*(104*r**2 + r*(232*s - 139) + 128*s**2 - 154*s + 45) + 472*r**2 + 896*r*s - 440*r + 424*s**2 - 410*s + 66) + 2*g2*(216*r**2 + 508*r*s - 343*r + 292*s**2 - 400*s + 181) - gd2*(236*r**2 + 568*r*s - 425*r + 332*s**2 - 509*s + 189)) - 2*fd*g2*(236*r**2 + r*(568*s - 429) + 332*s**2 - 465*s + 180)) + Ddd*f*(6*f**2*(20*r**2 + r*(76*s - 39) + 56*s**2 - 66*s + 24) + f*(C*(76*r**2 + 2*r*(124*s - 69) + 172*s**2 - 210*s + 81) - 12*K*(52*r**2 + 116*r*s - 81*r + 64*s**2 - 90*s + 42) + 236*r**2 + 448*r*s - 348*r + 212*s**2 - 330*s + 171) - g2*(236*r**2 + r*(568*s - 378) + 332*s**2 - 450*s + 201))) - 12*Dd**2*f*(3*f**2*(20*r**2 + r*(76*s - 39) + 56*s**2 - 66*s + 16) + f*(C*(38*r**2 + r*(124*s - 69) + 86*s**2 - 105*s + 27) - 6*K*(52*r**2 + 116*r*s - 81*r + 64*s**2 - 90*s + 28) + 118*r**2 + 224*r*s - 174*r + 106*s**2 - 165*s + 57) - g2*(118*r**2 + r*(284*s - 189) + 166*s**2 - 225*s + 67))))/(462*d**2*k3**5) - D1**2*Pk2*Pkd3*ct**2*k1**2*k2**2*(15840*C*D1**2*bd1**2*f*r**2 + 31680*C*D1**2*bd1**2*f*r*s - 15840*C*D1**2*bd1**2*f*r + 15840*C*D1**2*bd1**2*f*s**2 - 15840*C*D1**2*bd1**2*f*s + 18084*C*D1**2*bd1*f**2*r**2 + 39336*C*D1**2*bd1*f**2*r*s - 41976*C*D1**2*bd1*f**2*r + 21252*C*D1**2*bd1*f**2*s**2 - 45144*C*D1**2*bd1*f**2*s + 22572*C*D1**2*bd1*f**2 - 86856*C*D1**2*bd1*f*fd*r**2 - 183216*C*D1**2*bd1*f*fd*r*s + 138336*C*D1**2*bd1*f*fd*r - 96360*C*D1**2*bd1*f*fd*s**2 + 145464*C*D1**2*bd1*f*fd*s - 49104*C*D1**2*bd1*f*fd - 21714*C*D1**2*bdd1*f**2*r**2 - 45804*C*D1**2*bdd1*f**2*r*s + 49104*C*D1**2*bdd1*f**2*r - 24090*C*D1**2*bdd1*f**2*s**2 + 51480*C*D1**2*bdd1*f**2*s - 25740*C*D1**2*bdd1*f**2 - 4740*C*D1**2*f**2*fd*r**2 + 5160*C*D1**2*f**2*fd*r*s + 1440*C*D1**2*f**2*fd*r + 9900*C*D1**2*f**2*fd*s**2 - 8320*C*D1**2*f**2*fd*s + 1720*C*D1**2*f**2*fd - 5550*C*D1**2*f**2*fdd*r**2 - 22380*C*D1**2*f**2*fdd*r*s + 11160*C*D1**2*f**2*fdd*r - 16830*C*D1**2*f**2*fdd*s**2 + 18680*C*D1**2*f**2*fdd*s - 7460*C*D1**2*f**2*fdd - 11100*C*D1**2*f*fd**2*r**2 - 44760*C*D1**2*f*fd**2*r*s + 22320*C*D1**2*f*fd**2*r - 33660*C*D1**2*f*fd**2*s**2 + 37360*C*D1**2*f*fd**2*s - 7460*C*D1**2*f*fd**2 - 173712*C*D1*Dd*bd1*f**2*r**2 - 366432*C*D1*Dd*bd1*f**2*r*s + 329076*C*D1*Dd*bd1*f**2*r - 192720*C*D1*Dd*bd1*f**2*s**2 + 345708*C*D1*Dd*bd1*f**2*s - 149688*C*D1*Dd*bd1*f**2 - 6320*C*D1*Dd*f**3*r**2 + 6880*C*D1*Dd*f**3*r*s + 4600*C*D1*Dd*f**3*r + 13200*C*D1*Dd*f**3*s**2 - 10040*C*D1*Dd*f**3*s + 140*C*D1*Dd*f**3 - 44400*C*D1*Dd*f**2*fd*r**2 - 179040*C*D1*Dd*f**2*fd*r*s + 89220*C*D1*Dd*f**2*fd*r - 134640*C*D1*Dd*f**2*fd*s**2 + 153140*C*D1*Dd*f**2*fd*s - 41000*C*D1*Dd*f**2*fd - 7400*C*D1*Ddd*f**3*r**2 - 29840*C*D1*Ddd*f**3*r*s + 14860*C*D1*Ddd*f**3*r - 22440*C*D1*Ddd*f**3*s**2 + 26140*C*D1*Ddd*f**3*s - 9310*C*D1*Ddd*f**3 - 22200*C*Dd**2*f**3*r**2 - 89520*C*Dd**2*f**3*r*s + 44580*C*Dd**2*f**3*r - 67320*C*Dd**2*f**3*s**2 + 78420*C*Dd**2*f**3*s - 18620*C*Dd**2*f**3 - 23892*D1**2*K*bd1**2*f*r**2 - 52536*D1**2*K*bd1**2*f*r*s + 52140*D1**2*K*bd1**2*f*r - 28644*D1**2*K*bd1**2*f*s**2 + 56892*D1**2*K*bd1**2*f*s - 28248*D1**2*K*bd1**2*f - 1188*D1**2*K*bd1*f**2*r**2 + 792*D1**2*K*bd1*f**2*r*s + 2376*D1**2*K*bd1*f**2*r + 1980*D1**2*K*bd1*f**2*s**2 - 792*D1**2*K*bd1*f**2*s - 1188*D1**2*K*bd1*f**2 - 3960*D1**2*K*bd1*f*fd*r**2 - 17424*D1**2*K*bd1*f*fd*r*s + 8316*D1**2*K*bd1*f*fd*r - 13464*D1**2*K*bd1*f*fd*s**2 + 15444*D1**2*K*bd1*f*fd*s - 4356*D1**2*K*bd1*f*fd - 990*D1**2*K*bdd1*f**2*r**2 - 4356*D1**2*K*bdd1*f**2*r*s + 1980*D1**2*K*bdd1*f**2*r - 3366*D1**2*K*bdd1*f**2*s**2 + 4356*D1**2*K*bdd1*f**2*s - 990*D1**2*K*bdd1*f**2 + 13068*D1**2*bd1**2*f**2*r**2 + 21384*D1**2*bd1**2*f**2*r*s - 23760*D1**2*bd1**2*f**2*r + 8316*D1**2*bd1**2*f**2*s**2 - 19008*D1**2*bd1**2*f**2*s + 10692*D1**2*bd1**2*f**2 - 4884*D1**2*bd1**2*f*r**2 - 9768*D1**2*bd1**2*f*r*s - 2112*D1**2*bd1**2*f*r - 4884*D1**2*bd1**2*f*s**2 - 2112*D1**2*bd1**2*f*s + 6996*D1**2*bd1**2*f - 18480*D1**2*bd1**2*g2*r**2 - 36960*D1**2*bd1**2*g2*r*s + 18480*D1**2*bd1**2*g2*r - 18480*D1**2*bd1**2*g2*s**2 + 18480*D1**2*bd1**2*g2*s - 11880*D1**2*bd1*bd2*f*r**2 - 23760*D1**2*bd1*bd2*f*r*s + 23760*D1**2*bd1*bd2*f*r - 11880*D1**2*bd1*bd2*f*s**2 + 23760*D1**2*bd1*bd2*f*s - 11880*D1**2*bd1*bd2*f - 8250*D1**2*bd1*f**2*r**2 - 18876*D1**2*bd1*f**2*r*s + 19800*D1**2*bd1*f**2*r - 10626*D1**2*bd1*f**2*s**2 + 22176*D1**2*bd1*f**2*s - 10890*D1**2*bd1*f**2 + 56892*D1**2*bd1*f*fd*r**2 + 116952*D1**2*bd1*f*fd*r*s - 88572*D1**2*bd1*f*fd*r + 60060*D1**2*bd1*f*fd*s**2 - 90948*D1**2*bd1*f*fd*s + 30888*D1**2*bd1*f*fd - 18216*D1**2*bd1*f*g2*r**2 - 44088*D1**2*bd1*f*g2*r*s + 47388*D1**2*bd1*f*g2*r - 25872*D1**2*bd1*f*g2*s**2 + 55044*D1**2*bd1*f*g2*s - 27522*D1**2*bd1*f*g2 + 47784*D1**2*bd1*f*gd2*r**2 + 105072*D1**2*bd1*f*gd2*r*s - 104280*D1**2*bd1*f*gd2*r + 57288*D1**2*bd1*f*gd2*s**2 - 113784*D1**2*bd1*f*gd2*s + 56496*D1**2*bd1*f*gd2 + 47784*D1**2*bd1*fd*g2*r**2 + 105072*D1**2*bd1*fd*g2*r*s - 52536*D1**2*bd1*fd*g2*r + 57288*D1**2*bd1*fd*g2*s**2 - 57288*D1**2*bd1*fd*g2*s - 990*D1**2*bd2*f**2*r**2 - 1980*D1**2*bd2*f**2*r*s + 1980*D1**2*bd2*f**2*r - 990*D1**2*bd2*f**2*s**2 + 1980*D1**2*bd2*f**2*s - 990*D1**2*bd2*f**2 + 14223*D1**2*bdd1*f**2*r**2 + 29238*D1**2*bdd1*f**2*r*s - 30888*D1**2*bdd1*f**2*r + 15015*D1**2*bdd1*f**2*s**2 - 31680*D1**2*bdd1*f**2*s + 15840*D1**2*bdd1*f**2 + 23892*D1**2*bdd1*f*g2*r**2 + 52536*D1**2*bdd1*f*g2*r*s - 56496*D1**2*bdd1*f*g2*r + 28644*D1**2*bdd1*f*g2*s**2 - 61248*D1**2*bdd1*f*g2*s + 30624*D1**2*bdd1*f*g2 + 3360*D1**2*f**2*fd*r**2 - 1590*D1**2*f**2*fd*r*s - 1710*D1**2*f**2*fd*r - 4950*D1**2*f**2*fd*s**2 + 3830*D1**2*f**2*fd*s - 530*D1**2*f**2*fd + 2775*D1**2*f**2*fdd*r**2 + 11190*D1**2*f**2*fdd*r*s - 5580*D1**2*f**2*fdd*r + 8415*D1**2*f**2*fdd*s**2 - 9340*D1**2*f**2*fdd*s + 3730*D1**2*f**2*fdd + 2376*D1**2*f**2*gd2*r**2 - 1584*D1**2*f**2*gd2*r*s - 4752*D1**2*f**2*gd2*r - 3960*D1**2*f**2*gd2*s**2 + 1584*D1**2*f**2*gd2*s + 2376*D1**2*f**2*gd2 + 1980*D1**2*f**2*gdd2*r**2 + 8712*D1**2*f**2*gdd2*r*s - 3960*D1**2*f**2*gdd2*r + 6732*D1**2*f**2*gdd2*s**2 - 8712*D1**2*f**2*gdd2*s + 1980*D1**2*f**2*gdd2 + 5550*D1**2*f*fd**2*r**2 + 22380*D1**2*f*fd**2*r*s - 11160*D1**2*f*fd**2*r + 16830*D1**2*f*fd**2*s**2 - 18680*D1**2*f*fd**2*s + 3730*D1**2*f*fd**2 + 4752*D1**2*f*fd*g2*r**2 - 3168*D1**2*f*fd*g2*r*s + 1584*D1**2*f*fd*g2*r - 7920*D1**2*f*fd*g2*s**2 + 7920*D1**2*f*fd*g2*s - 3960*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r**2 + 34848*D1**2*f*fd*gd2*r*s - 16632*D1**2*f*fd*gd2*r + 26928*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 8712*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r**2 + 17424*D1**2*f*fdd*g2*r*s - 8712*D1**2*f*fdd*g2*r + 13464*D1**2*f*fdd*g2*s**2 - 13464*D1**2*f*fdd*g2*s + 6732*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r**2 + 17424*D1**2*fd**2*g2*r*s - 8712*D1**2*fd**2*g2*r + 13464*D1**2*fd**2*g2*s**2 - 13464*D1**2*fd**2*g2*s - 7920*D1*Dd*K*bd1*f**2*r**2 - 34848*D1*Dd*K*bd1*f**2*r*s + 16236*D1*Dd*K*bd1*f**2*r - 26928*D1*Dd*K*bd1*f**2*s**2 + 32868*D1*Dd*K*bd1*f**2*s - 8316*D1*Dd*K*bd1*f**2 + 113784*D1*Dd*bd1*f**2*r**2 + 233904*D1*Dd*bd1*f**2*r*s - 209682*D1*Dd*bd1*f**2*r + 120120*D1*Dd*bd1*f**2*s**2 - 215226*D1*Dd*bd1*f**2*s + 93456*D1*Dd*bd1*f**2 + 191136*D1*Dd*bd1*f*g2*r**2 + 420288*D1*Dd*bd1*f*g2*r*s - 374088*D1*Dd*bd1*f*g2*r + 229152*D1*Dd*bd1*f*g2*s**2 - 407352*D1*Dd*bd1*f*g2*s + 174240*D1*Dd*bd1*f*g2 + 4480*D1*Dd*f**3*r**2 - 2120*D1*Dd*f**3*r*s - 3950*D1*Dd*f**3*r - 6600*D1*Dd*f**3*s**2 + 4360*D1*Dd*f**3*s + 590*D1*Dd*f**3 + 22200*D1*Dd*f**2*fd*r**2 + 89520*D1*Dd*f**2*fd*r*s - 44610*D1*Dd*f**2*fd*r + 67320*D1*Dd*f**2*fd*s**2 - 76570*D1*Dd*f**2*fd*s + 20500*D1*Dd*f**2*fd + 9504*D1*Dd*f**2*g2*r**2 - 6336*D1*Dd*f**2*g2*r*s - 7920*D1*Dd*f**2*g2*r - 15840*D1*Dd*f**2*g2*s**2 + 11088*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r**2 + 69696*D1*Dd*f**2*gd2*r*s - 32472*D1*Dd*f**2*gd2*r + 53856*D1*Dd*f**2*gd2*s**2 - 65736*D1*Dd*f**2*gd2*s + 16632*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r**2 + 139392*D1*Dd*f*fd*g2*r*s - 68112*D1*Dd*f*fd*g2*r + 107712*D1*Dd*f*fd*g2*s**2 - 115632*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 + 3700*D1*Ddd*f**3*r**2 + 14920*D1*Ddd*f**3*r*s - 7430*D1*Ddd*f**3*r + 11220*D1*Ddd*f**3*s**2 - 13070*D1*Ddd*f**3*s + 4655*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r**2 + 34848*D1*Ddd*f**2*g2*r*s - 16632*D1*Ddd*f**2*g2*r + 26928*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 10692*D1*Ddd*f**2*g2 + 165*D1*b2*(bd1*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) - 6*f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 11100*Dd**2*f**3*r**2 + 44760*Dd**2*f**3*r*s - 22290*Dd**2*f**3*r + 33660*Dd**2*f**3*s**2 - 39210*Dd**2*f**3*s + 9310*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r**2 + 104544*Dd**2*f**2*g2*r*s - 49896*Dd**2*f**2*g2*r + 80784*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 21384*Dd**2*f**2*g2 + 330*b1**3*(D1**2*(11*fd - 9*fdd)*(r + s - 1)**2 + D1*(Dd*(11*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 9*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 9*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(-130*C*D1**2*fd*r**2 - 260*C*D1**2*fd*r*s + 260*C*D1**2*fd*r - 130*C*D1**2*fd*s**2 + 260*C*D1**2*fd*s - 130*C*D1**2*fd + 240*C*D1**2*fdd*r**2 + 480*C*D1**2*fdd*r*s - 480*C*D1**2*fdd*r + 240*C*D1**2*fdd*s**2 - 480*C*D1**2*fdd*s + 240*C*D1**2*fdd - 520*C*D1*Dd*f*r**2 - 1040*C*D1*Dd*f*r*s + 780*C*D1*Dd*f*r - 520*C*D1*Dd*f*s**2 + 780*C*D1*Dd*f*s - 390*C*D1*Dd*f + 1920*C*D1*Dd*fd*r**2 + 3840*C*D1*Dd*fd*r*s - 3360*C*D1*Dd*fd*r + 1920*C*D1*Dd*fd*s**2 - 3360*C*D1*Dd*fd*s + 1440*C*D1*Dd*fd + 960*C*D1*Ddd*f*r**2 + 1920*C*D1*Ddd*f*r*s - 1440*C*D1*Ddd*f*r + 960*C*D1*Ddd*f*s**2 - 1440*C*D1*Ddd*f*s + 720*C*D1*Ddd*f + 2880*C*Dd**2*f*r**2 + 5760*C*Dd**2*f*r*s - 4320*C*Dd**2*f*r + 2880*C*Dd**2*f*s**2 - 4320*C*Dd**2*f*s + 1440*C*Dd**2*f + 276*D1**2*K*fd*r**2 + 668*D1**2*K*fd*r*s + 50*D1**2*K*fd*r + 392*D1**2*K*fd*s**2 + 50*D1**2*K*fd*s - 25*D1**2*K*fd - 362*D1**2*K*fdd*r**2 - 796*D1**2*K*fdd*r*s - 60*D1**2*K*fdd*r - 434*D1**2*K*fdd*s**2 - 60*D1**2*K*fdd*s + 30*D1**2*K*fdd - 10*D1**2*bdd1*(-14*K + 9*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 204*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r*s + 204*D1**2*f*fd*r - 60*D1**2*f*fd*s**2 + 132*D1**2*f*fd*s - 102*D1**2*f*fd + 396*D1**2*f*fdd*r**2 + 648*D1**2*f*fdd*r*s - 396*D1**2*f*fdd*r + 252*D1**2*f*fdd*s**2 - 324*D1**2*f*fdd*s + 198*D1**2*f*fdd + 396*D1**2*fd**2*r**2 + 648*D1**2*fd**2*r*s - 396*D1**2*fd**2*r + 252*D1**2*fd**2*s**2 - 324*D1**2*fd**2*s + 120*D1**2*fd*r**2 + 198*D1**2*fd*r*s - 160*D1**2*fd*r + 78*D1**2*fd*s**2 - 160*D1**2*fd*s + 80*D1**2*fd - 74*D1**2*fdd*r**2 - 148*D1**2*fdd*r*s + 360*D1**2*fdd*r - 74*D1**2*fdd*s**2 + 360*D1**2*fdd*s - 180*D1**2*fdd + 560*D1**2*gd2*r**2 + 1120*D1**2*gd2*r*s - 1120*D1**2*gd2*r + 560*D1**2*gd2*s**2 - 1120*D1**2*gd2*s + 560*D1**2*gd2 - 280*D1**2*gdd2*r**2 - 560*D1**2*gdd2*r*s + 560*D1**2*gdd2*r - 280*D1**2*gdd2*s**2 + 560*D1**2*gdd2*s - 280*D1**2*gdd2 + 1104*D1*Dd*K*f*r**2 + 2672*D1*Dd*K*f*r*s - 1772*D1*Dd*K*f*r + 1568*D1*Dd*K*f*s**2 - 2120*D1*Dd*K*f*s + 944*D1*Dd*K*f - 2896*D1*Dd*K*fd*r**2 - 6368*D1*Dd*K*fd*r*s + 2004*D1*Dd*K*fd*r - 3472*D1*Dd*K*fd*s**2 + 2220*D1*Dd*K*fd*s + 180*D1*Dd*K*fd - 408*D1*Dd*f**2*r**2 - 528*D1*Dd*f**2*r*s + 540*D1*Dd*f**2*r - 120*D1*Dd*f**2*s**2 + 324*D1*Dd*f**2*s - 234*D1*Dd*f**2 + 3168*D1*Dd*f*fd*r**2 + 5184*D1*Dd*f*fd*r*s - 3816*D1*Dd*f*fd*r + 2016*D1*Dd*f*fd*s**2 - 3096*D1*Dd*f*fd*s + 1116*D1*Dd*f*fd + 480*D1*Dd*f*r**2 + 792*D1*Dd*f*r*s - 678*D1*Dd*f*r + 312*D1*Dd*f*s**2 - 552*D1*Dd*f*s + 318*D1*Dd*f - 592*D1*Dd*fd*r**2 - 1184*D1*Dd*fd*r*s + 1884*D1*Dd*fd*r - 592*D1*Dd*fd*s**2 + 1884*D1*Dd*fd*s - 1080*D1*Dd*fd + 2240*D1*Dd*g2*r**2 + 4480*D1*Dd*g2*r*s - 3360*D1*Dd*g2*r + 2240*D1*Dd*g2*s**2 - 3360*D1*Dd*g2*s + 1680*D1*Dd*g2 - 2240*D1*Dd*gd2*r**2 - 4480*D1*Dd*gd2*r*s + 3920*D1*Dd*gd2*r - 2240*D1*Dd*gd2*s**2 + 3920*D1*Dd*gd2*s - 1680*D1*Dd*gd2 - 1448*D1*Ddd*K*f*r**2 - 3184*D1*Ddd*K*f*r*s + 2244*D1*Ddd*K*f*r - 1736*D1*Ddd*K*f*s**2 + 2460*D1*Ddd*K*f*s - 1158*D1*Ddd*K*f + 792*D1*Ddd*f**2*r**2 + 1296*D1*Ddd*f**2*r*s - 1116*D1*Ddd*f**2*r + 504*D1*Ddd*f**2*s**2 - 900*D1*Ddd*f**2*s + 522*D1*Ddd*f**2 - 296*D1*Ddd*f*r**2 - 592*D1*Ddd*f*r*s + 444*D1*Ddd*f*r - 296*D1*Ddd*f*s**2 + 444*D1*Ddd*f*s - 222*D1*Ddd*f - 1120*D1*Ddd*g2*r**2 - 2240*D1*Ddd*g2*r*s + 1680*D1*Ddd*g2*r - 1120*D1*Ddd*g2*s**2 + 1680*D1*Ddd*g2*s - 840*D1*Ddd*g2 + 10*D1*bd1*(D1*(11*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-14*K + 9*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 4344*Dd**2*K*f*r**2 - 9552*Dd**2*K*f*r*s + 6732*Dd**2*K*f*r - 5208*Dd**2*K*f*s**2 + 7380*Dd**2*K*f*s - 2316*Dd**2*K*f + 2376*Dd**2*f**2*r**2 + 3888*Dd**2*f**2*r*s - 3348*Dd**2*f**2*r + 1512*Dd**2*f**2*s**2 - 2700*Dd**2*f**2*s + 1044*Dd**2*f**2 - 888*Dd**2*f*r**2 - 1776*Dd**2*f*r*s + 1332*Dd**2*f*r - 888*Dd**2*f*s**2 + 1332*Dd**2*f*s - 444*Dd**2*f - 3360*Dd**2*g2*r**2 - 6720*Dd**2*g2*r*s + 5040*Dd**2*g2*r - 3360*Dd**2*g2*s**2 + 5040*Dd**2*g2*s - 1680*Dd**2*g2) - 33*b1*(-480*C*D1**2*bdd1*f*r**2 - 960*C*D1**2*bdd1*f*r*s + 480*C*D1**2*bdd1*f*r - 480*C*D1**2*bdd1*f*s**2 + 480*C*D1**2*bdd1*f*s - 240*C*D1**2*bdd1*f - 1096*C*D1**2*f*fd*r**2 - 2384*C*D1**2*f*fd*r*s + 1016*C*D1**2*f*fd*r - 1288*C*D1**2*f*fd*s**2 + 1112*C*D1**2*f*fd*s - 508*C*D1**2*f*fd + 1316*C*D1**2*f*fdd*r**2 + 2776*C*D1**2*f*fdd*r*s - 1216*C*D1**2*f*fdd*r + 1460*C*D1**2*f*fdd*s**2 - 1288*C*D1**2*f*fdd*s + 608*C*D1**2*f*fdd + 1316*C*D1**2*fd**2*r**2 + 2776*C*D1**2*fd**2*r*s - 1216*C*D1**2*fd**2*r + 1460*C*D1**2*fd**2*s**2 - 1288*C*D1**2*fd**2*s - 100*C*D1**2*fd**2 - 2192*C*D1*Dd*f**2*r**2 - 4768*C*D1*Dd*f**2*r*s + 3384*C*D1*Dd*f**2*r - 2576*C*D1*Dd*f**2*s**2 + 3672*C*D1*Dd*f**2*s - 1740*C*D1*Dd*f**2 + 10528*C*D1*Dd*f*fd*r**2 + 22208*C*D1*Dd*f*fd*r*s - 12904*C*D1*Dd*f*fd*r + 11680*C*D1*Dd*f*fd*s**2 - 13624*C*D1*Dd*f*fd*s + 3720*C*D1*Dd*f*fd + 2632*C*D1*Ddd*f**2*r**2 + 5552*C*D1*Ddd*f**2*r*s - 4020*C*D1*Ddd*f**2*r + 2920*C*D1*Ddd*f**2*s**2 - 4236*C*D1*Ddd*f**2*s + 2046*C*D1*Ddd*f**2 + 7896*C*Dd**2*f**2*r**2 + 16656*C*Dd**2*f**2*r*s - 12060*C*Dd**2*f**2*r + 8760*C*Dd**2*f**2*s**2 - 12708*C*Dd**2*f**2*s + 4092*C*Dd**2*f**2 + 724*D1**2*K*bdd1*f*r**2 + 1592*D1**2*K*bdd1*f*r*s - 1580*D1**2*K*bdd1*f*r + 868*D1**2*K*bdd1*f*s**2 - 1724*D1**2*K*bdd1*f*s + 826*D1**2*K*bdd1*f + 72*D1**2*K*f*fd*r**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 120*D1**2*K*f*fd*s**2 + 120*D1**2*K*f*fd*s - 60*D1**2*K*f*fd + 60*D1**2*K*f*fdd*r**2 + 264*D1**2*K*f*fdd*r*s - 132*D1**2*K*f*fdd*r + 204*D1**2*K*f*fdd*s**2 - 204*D1**2*K*f*fdd*s + 102*D1**2*K*f*fdd + 60*D1**2*K*fd**2*r**2 + 264*D1**2*K*fd**2*r*s - 132*D1**2*K*fd**2*r + 204*D1**2*K*fd**2*s**2 - 204*D1**2*K*fd**2*s - 185*D1**2*b2*fd*r**2 - 370*D1**2*b2*fd*r*s - 185*D1**2*b2*fd*s**2 + 180*D1**2*b2*fdd*r**2 + 360*D1**2*b2*fdd*r*s + 180*D1**2*b2*fdd*s**2 + 20*D1**2*bd1**2*(-14*K + 9*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 396*D1**2*bdd1*f**2*r**2 - 648*D1**2*bdd1*f**2*r*s + 720*D1**2*bdd1*f**2*r - 252*D1**2*bdd1*f**2*s**2 + 576*D1**2*bdd1*f**2*s - 324*D1**2*bdd1*f**2 + 148*D1**2*bdd1*f*r**2 + 296*D1**2*bdd1*f*r*s + 64*D1**2*bdd1*f*r + 148*D1**2*bdd1*f*s**2 + 64*D1**2*bdd1*f*s - 32*D1**2*bdd1*f + 560*D1**2*bdd1*g2*r**2 + 1120*D1**2*bdd1*g2*r*s - 560*D1**2*bdd1*g2*r + 560*D1**2*bdd1*g2*s**2 - 560*D1**2*bdd1*g2*s + 280*D1**2*bdd1*g2 + 180*D1**2*bdd2*f*r**2 + 360*D1**2*bdd2*f*r*s - 360*D1**2*bdd2*f*r + 180*D1**2*bdd2*f*s**2 - 360*D1**2*bdd2*f*s + 180*D1**2*bdd2*f + 500*D1**2*f*fd*r**2 + 1144*D1**2*f*fd*r*s - 472*D1**2*f*fd*r + 644*D1**2*f*fd*s**2 - 544*D1**2*f*fd*s + 242*D1**2*f*fd - 862*D1**2*f*fdd*r**2 - 1772*D1**2*f*fdd*r*s + 812*D1**2*f*fdd*r - 910*D1**2*f*fdd*s**2 + 836*D1**2*f*fdd*s - 406*D1**2*f*fdd + 552*D1**2*f*gd2*r**2 + 1336*D1**2*f*gd2*r*s - 1104*D1**2*f*gd2*r + 784*D1**2*f*gd2*s**2 - 1336*D1**2*f*gd2*s + 552*D1**2*f*gd2 - 724*D1**2*f*gdd2*r**2 - 1592*D1**2*f*gdd2*r*s + 1448*D1**2*f*gdd2*r - 868*D1**2*f*gdd2*s**2 + 1592*D1**2*f*gdd2*s - 724*D1**2*f*gdd2 - 862*D1**2*fd**2*r**2 - 1772*D1**2*fd**2*r*s + 812*D1**2*fd**2*r - 910*D1**2*fd**2*s**2 + 836*D1**2*fd**2*s + 50*D1**2*fd**2 + 552*D1**2*fd*g2*r**2 + 1336*D1**2*fd*g2*r*s + 100*D1**2*fd*g2*r + 784*D1**2*fd*g2*s**2 + 100*D1**2*fd*g2*s - 50*D1**2*fd*g2 - 1448*D1**2*fd*gd2*r**2 - 3184*D1**2*fd*gd2*r*s + 1328*D1**2*fd*gd2*r - 1736*D1**2*fd*gd2*s**2 + 1472*D1**2*fd*gd2*s + 120*D1**2*fd*gd2 - 724*D1**2*fdd*g2*r**2 - 1592*D1**2*fdd*g2*r*s - 120*D1**2*fdd*g2*r - 868*D1**2*fdd*g2*s**2 - 120*D1**2*fdd*g2*s + 60*D1**2*fdd*g2 + 144*D1*Dd*K*f**2*r**2 - 96*D1*Dd*K*f**2*r*s - 120*D1*Dd*K*f**2*r - 240*D1*Dd*K*f**2*s**2 + 168*D1*Dd*K*f**2*s + 12*D1*Dd*K*f**2 + 480*D1*Dd*K*f*fd*r**2 + 2112*D1*Dd*K*f*fd*r*s - 1032*D1*Dd*K*f*fd*r + 1632*D1*Dd*K*f*fd*s**2 - 1752*D1*Dd*K*f*fd*s + 468*D1*Dd*K*f*fd - 740*D1*Dd*b2*f*r**2 - 1480*D1*Dd*b2*f*r*s + 1110*D1*Dd*b2*f*r - 740*D1*Dd*b2*f*s**2 + 1110*D1*Dd*b2*f*s - 555*D1*Dd*b2*f + 1440*D1*Dd*b2*fd*r**2 + 2880*D1*Dd*b2*fd*r*s - 1080*D1*Dd*b2*fd*r + 1440*D1*Dd*b2*fd*s**2 - 1080*D1*Dd*b2*fd*s + 1000*D1*Dd*f**2*r**2 + 2288*D1*Dd*f**2*r*s - 1572*D1*Dd*f**2*r + 1288*D1*Dd*f**2*s**2 - 1788*D1*Dd*f**2*s + 822*D1*Dd*f**2 - 6896*D1*Dd*f*fd*r**2 - 14176*D1*Dd*f*fd*r*s + 8468*D1*Dd*f*fd*r - 7280*D1*Dd*f*fd*s**2 + 8708*D1*Dd*f*fd*s - 2460*D1*Dd*f*fd + 2208*D1*Dd*f*g2*r**2 + 5344*D1*Dd*f*g2*r*s - 3544*D1*Dd*f*g2*r + 3136*D1*Dd*f*g2*s**2 - 4240*D1*Dd*f*g2*s + 1888*D1*Dd*f*g2 - 5792*D1*Dd*f*gd2*r**2 - 12736*D1*Dd*f*gd2*r*s + 10280*D1*Dd*f*gd2*r - 6944*D1*Dd*f*gd2*s**2 + 11288*D1*Dd*f*gd2*s - 4488*D1*Dd*f*gd2 - 5792*D1*Dd*fd*g2*r**2 - 12736*D1*Dd*fd*g2*r*s + 4008*D1*Dd*fd*g2*r - 6944*D1*Dd*fd*g2*s**2 + 4440*D1*Dd*fd*g2*s + 360*D1*Dd*fd*g2 + 120*D1*Ddd*K*f**2*r**2 + 528*D1*Ddd*K*f**2*r*s - 252*D1*Ddd*K*f**2*r + 408*D1*Ddd*K*f**2*s**2 - 468*D1*Ddd*K*f**2*s + 162*D1*Ddd*K*f**2 + 720*D1*Ddd*b2*f*r**2 + 1440*D1*Ddd*b2*f*r*s - 1080*D1*Ddd*b2*f*r + 720*D1*Ddd*b2*f*s**2 - 1080*D1*Ddd*b2*f*s + 540*D1*Ddd*b2*f - 1724*D1*Ddd*f**2*r**2 - 3544*D1*Ddd*f**2*r*s + 2610*D1*Ddd*f**2*r - 1820*D1*Ddd*f**2*s**2 + 2682*D1*Ddd*f**2*s - 1317*D1*Ddd*f**2 - 2896*D1*Ddd*f*g2*r**2 - 6368*D1*Ddd*f*g2*r*s + 4488*D1*Ddd*f*g2*r - 3472*D1*Ddd*f*g2*s**2 + 4920*D1*Ddd*f*g2*s - 2316*D1*Ddd*f*g2 + D1*bd1*(D1*(12*f**2*(17*r**2 + r*(22*s - 28) + 5*s**2 - 16*s + 11) + f*(130*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 552*K*r**2 - 1336*K*r*s + 1270*K*r - 784*K*s**2 + 1502*K*s - 693*K - 72*fd*(22*r**2 + 36*r*s - 31*r + 14*s**2 - 25*s + 10) - 240*r**2 - 396*r*s + 278*r - 156*s**2 + 194*s - 118) - 4*fd*(120*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + K*(-362*r**2 - 796*r*s + 365*r - 434*s**2 + 401*s + 15) - 74*r**2 - 148*r*s + 164*r - 74*s**2 + 164*s - 90) - 560*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 560*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(18*f**2*(44*r**2 + r*(72*s - 71) + 28*s**2 - 57*s + 28) + f*(120*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - K*(1448*r**2 + 3184*r*s - 2702*r + 1736*s**2 - 2954*s + 1221) - 296*r**2 - 592*r*s + 158*r - 296*s**2 + 158*s + 48) - 140*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 5*D1*bd2*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) + 360*Dd**2*K*f**2*r**2 + 1584*Dd**2*K*f**2*r*s - 756*Dd**2*K*f**2*r + 1224*Dd**2*K*f**2*s**2 - 1404*Dd**2*K*f**2*s + 324*Dd**2*K*f**2 + 2160*Dd**2*b2*f*r**2 + 4320*Dd**2*b2*f*r*s - 3240*Dd**2*b2*f*r + 2160*Dd**2*b2*f*s**2 - 3240*Dd**2*b2*f*s + 1080*Dd**2*b2*f - 5172*Dd**2*f**2*r**2 - 10632*Dd**2*f**2*r*s + 7830*Dd**2*f**2*r - 5460*Dd**2*f**2*s**2 + 8046*Dd**2*f**2*s - 2634*Dd**2*f**2 - 8688*Dd**2*f*g2*r**2 - 19104*Dd**2*f*g2*r*s + 13464*Dd**2*f*g2*r - 10416*Dd**2*f*g2*s**2 + 14760*Dd**2*f*g2*s - 4632*Dd**2*f*g2))/(693*d**2*k3**5) - 8*D1**2*Pk2*Pkd3*ct**2*k1**2*st**4*(D1**2*(22*bd1*fd*g2*(r*(2*s - 1) + s*(2*s - 2)) + f**3*s*(-10*bd1 + 5*bdd1)*(4*r + 4*s - 3) + f**2*(-11*bd1*s*(r + s - 1) + 5*fd*(bd1*(6*s - 1)*(4*r + 4*s - 3) - 6*r*s + 2*r - 6*s**2 + 6*s - 2) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + f*(5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 11*s*(bd1**2*(K - 1)*(2*r + 2*s - 1) + 4*bd1*g2*(r + s) + bd1*gd2*(-4*r - 4*s + 2) - 2*bdd1*g2*(r + s)))) + D1*f*(Dd*(22*bd1*g2*(r*(8*s - 1) + 4*s*(2*s - 1)) + 5*f**2*(bd1*(8*s - 1)*(4*r + 4*s - 3) - 8*r*s + 2*r - 8*s**2 + 8*s - 2) + 5*f*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 5*Ddd*f**2*(r*(4*s - 1) + (1 - 2*s)**2)) + 5*Dd**2*f**3*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 11*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(-5*f**2*(2*fd - fdd)*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4) + f*(5*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) - 11*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 11*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) - (fd*(2*g2*(s - 1) - 2*gd2*s + gd2) - fdd*g2*(s - 1))*(22*r + 22*s - 22)) - 11*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(-40*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(5*fd*(24*s - 7)*(4*r + 4*s - 3) - 11*r*(4*s - 1) - 11*(1 - 2*s)**2) - 22*f*(g2*r*(8*s - 2) + 2*g2*(1 - 2*s)**2 + gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 22*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 2*Ddd*f*(10*f**2 + 11*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd**2*f*(10*f**2 + 11*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(77*d**2*k3**3) - D1**2*Pk2*Pkd3*ct**2*k1**2*st**2*(5616*C*D1**2*f**2*fd*r*s - 1872*C*D1**2*f**2*fd*r + 5616*C*D1**2*f**2*fd*s**2 - 5616*C*D1**2*f**2*fd*s + 1872*C*D1**2*f**2*fd - 3600*C*D1**2*f**2*fdd*r*s + 1200*C*D1**2*f**2*fdd*r - 3600*C*D1**2*f**2*fdd*s**2 + 3600*C*D1**2*f**2*fdd*s - 1200*C*D1**2*f**2*fdd - 7200*C*D1**2*f*fd**2*r*s + 2400*C*D1**2*f*fd**2*r - 7200*C*D1**2*f*fd**2*s**2 + 7200*C*D1**2*f*fd**2*s - 1200*C*D1**2*f*fd**2 + 7488*C*D1*Dd*f**3*r*s - 1872*C*D1*Dd*f**3*r + 7488*C*D1*Dd*f**3*s**2 - 7488*C*D1*Dd*f**3*s + 1872*C*D1*Dd*f**3 - 28800*C*D1*Dd*f**2*fd*r*s + 8400*C*D1*Dd*f**2*fd*r - 28800*C*D1*Dd*f**2*fd*s**2 + 28800*C*D1*Dd*f**2*fd*s - 6000*C*D1*Dd*f**2*fd - 4800*C*D1*Ddd*f**3*r*s + 1200*C*D1*Ddd*f**3*r - 4800*C*D1*Ddd*f**3*s**2 + 4800*C*D1*Ddd*f**3*s - 1200*C*D1*Ddd*f**3 - 14400*C*Dd**2*f**3*r*s + 3600*C*Dd**2*f**3*r - 14400*C*Dd**2*f**3*s**2 + 14400*C*Dd**2*f**3*s - 2400*C*Dd**2*f**3 + 2640*D1**2*b2*f*fd*r*s - 1320*D1**2*b2*f*fd*r + 2640*D1**2*b2*f*fd*s**2 - 2640*D1**2*b2*f*fd*s + 1320*D1**2*b2*f*fd - 1584*D1**2*b2*f*fdd*r*s + 792*D1**2*b2*f*fdd*r - 1584*D1**2*b2*f*fdd*s**2 + 1584*D1**2*b2*f*fdd*s - 792*D1**2*b2*f*fdd - 1584*D1**2*b2*fd**2*r*s + 792*D1**2*b2*fd**2*r - 1584*D1**2*b2*fd**2*s**2 + 1584*D1**2*b2*fd**2*s + 22*D1**2*bd1**2*(12*f**2*(r**2 + r*(6*s - 5) + 5*s**2 - 10*s + 3) + f*(r**2*(11 - 5*K) + r*(C*(8*s - 4) + 42*K*s + 5*K + 10*s - 25) + s**2*(8*C + 47*K - 1) - s*(8*C + 21*K + 37) + 18) + 28*g2*(r*(2*s - 1) + s*(2*s - 2))) + 1320*D1**2*bd2*f**2*r*s + 1320*D1**2*bd2*f**2*s**2 - 1320*D1**2*bd2*f**2*s - 3168*D1**2*bd2*f*fd*r*s + 792*D1**2*bd2*f*fd*r - 3168*D1**2*bd2*f*fd*s**2 + 3168*D1**2*bd2*f*fd*s - 792*D1**2*bd2*f*fd - 22*D1**2*bdd1*f*(3*f**2*(27*r**2 + 32*r*(2*s - 1) + 37*s**2 - 44*s + 16) + f*(r**2*(13*C + 17) + 6*r*(s*(C + 6*K + 8) - 8) + s**2*(-7*C + 36*K + 31) - s*(36*K + 48) + 15) + g2*(-5*r**2 + 42*r*s + 47*s**2)) - 792*D1**2*bdd2*f**2*r*s - 792*D1**2*bdd2*f**2*s**2 + 792*D1**2*bdd2*f**2*s + 2310*D1**2*f**2*fd*r**2 + 3876*D1**2*f**2*fd*r*s - 2832*D1**2*f**2*fd*r + 1566*D1**2*f**2*fd*s**2 - 2336*D1**2*f**2*fd*s + 1292*D1**2*f**2*fd - 2178*D1**2*f**2*fdd*r**2 - 3456*D1**2*f**2*fdd*r*s + 2604*D1**2*f**2*fdd*r - 1278*D1**2*f**2*fdd*s**2 + 2004*D1**2*f**2*fdd*s - 1152*D1**2*f**2*fdd - 2640*D1**2*f**2*gd2*r*s - 2640*D1**2*f**2*gd2*s**2 + 2640*D1**2*f**2*gd2*s + 1584*D1**2*f**2*gdd2*r*s + 1584*D1**2*f**2*gdd2*s**2 - 1584*D1**2*f**2*gdd2*s - 4356*D1**2*f*fd**2*r**2 - 6912*D1**2*f*fd**2*r*s + 5208*D1**2*f*fd**2*r - 2556*D1**2*f*fd**2*s**2 + 4008*D1**2*f*fd**2*s - 1152*D1**2*f*fd**2 - 5280*D1**2*f*fd*g2*r*s + 2640*D1**2*f*fd*g2*r - 5280*D1**2*f*fd*g2*s**2 + 5280*D1**2*f*fd*g2*s - 2640*D1**2*f*fd*g2 + 6336*D1**2*f*fd*gd2*r*s - 1584*D1**2*f*fd*gd2*r + 6336*D1**2*f*fd*gd2*s**2 - 6336*D1**2*f*fd*gd2*s + 1584*D1**2*f*fd*gd2 + 3168*D1**2*f*fdd*g2*r*s - 1584*D1**2*f*fdd*g2*r + 3168*D1**2*f*fdd*g2*s**2 - 3168*D1**2*f*fdd*g2*s + 1584*D1**2*f*fdd*g2 + 3168*D1**2*fd**2*g2*r*s - 1584*D1**2*fd**2*g2*r + 3168*D1**2*fd**2*g2*s**2 - 3168*D1**2*fd**2*g2*s + 5280*D1*Dd*b2*f**2*r*s - 1320*D1*Dd*b2*f**2*r + 5280*D1*Dd*b2*f**2*s**2 - 5280*D1*Dd*b2*f**2*s + 1320*D1*Dd*b2*f**2 - 12672*D1*Dd*b2*f*fd*r*s + 4752*D1*Dd*b2*f*fd*r - 12672*D1*Dd*b2*f*fd*s**2 + 12672*D1*Dd*b2*f*fd*s - 3168*D1*Dd*b2*f*fd - 6336*D1*Dd*bd2*f**2*r*s + 792*D1*Dd*bd2*f**2*r - 6336*D1*Dd*bd2*f**2*s**2 + 6336*D1*Dd*bd2*f**2*s - 792*D1*Dd*bd2*f**2 + 3080*D1*Dd*f**3*r**2 + 5168*D1*Dd*f**3*r*s - 4372*D1*Dd*f**3*r + 2088*D1*Dd*f**3*s**2 - 3628*D1*Dd*f**3*s + 2062*D1*Dd*f**3 - 17424*D1*Dd*f**2*fd*r**2 - 27648*D1*Dd*f**2*fd*r*s + 22584*D1*Dd*f**2*fd*r - 10224*D1*Dd*f**2*fd*s**2 + 17484*D1*Dd*f**2*fd*s - 7212*D1*Dd*f**2*fd - 10560*D1*Dd*f**2*g2*r*s + 2640*D1*Dd*f**2*g2*r - 10560*D1*Dd*f**2*g2*s**2 + 10560*D1*Dd*f**2*g2*s - 2640*D1*Dd*f**2*g2 + 12672*D1*Dd*f**2*gd2*r*s - 1584*D1*Dd*f**2*gd2*r + 12672*D1*Dd*f**2*gd2*s**2 - 12672*D1*Dd*f**2*gd2*s + 1584*D1*Dd*f**2*gd2 + 25344*D1*Dd*f*fd*g2*r*s - 9504*D1*Dd*f*fd*g2*r + 25344*D1*Dd*f*fd*g2*s**2 - 25344*D1*Dd*f*fd*g2*s + 6336*D1*Dd*f*fd*g2 - 3168*D1*Ddd*b2*f**2*r*s + 792*D1*Ddd*b2*f**2*r - 3168*D1*Ddd*b2*f**2*s**2 + 3168*D1*Ddd*b2*f**2*s - 792*D1*Ddd*b2*f**2 - 2904*D1*Ddd*f**3*r**2 - 4608*D1*Ddd*f**3*r*s + 4056*D1*Ddd*f**3*r - 1704*D1*Ddd*f**3*s**2 + 3156*D1*Ddd*f**3*s - 1878*D1*Ddd*f**3 + 6336*D1*Ddd*f**2*g2*r*s - 1584*D1*Ddd*f**2*g2*r + 6336*D1*Ddd*f**2*g2*s**2 - 6336*D1*Ddd*f**2*g2*s + 1584*D1*Ddd*f**2*g2 + 22*D1*bd1*(D1*(3*f**3*(21*r**2 + 4*r*(19*s - 6) + 55*s**2 - 52*s + 12) + f**2*(-9*C*s**2 + 60*K*s**2 - 60*K*s - 6*fd*(81*r**2 + 2*r*(96*s - 59) + 111*s**2 - 145*s + 38) + r**2*(19*C + 15) + 2*r*(s*(5*C + 30*K + 25) - 22) + 35*s**2 - 46*s + 5) - f*(2*fd*(-14*C*s**2 + 4*C*s + 18*K*(r*(4*s - 1) + (1 - 2*s)**2) + r**2*(26*C + 34) + r*(4*C*(3*s - 4) + 96*s - 65) + 62*s**2 - 79*s + 33) + 59*g2*r**2 - 70*g2*r*s - 129*g2*s**2 - 10*gd2*r**2 + 84*gd2*r*s + 10*gd2*r + 94*gd2*s**2 - 42*gd2*s) + 2*fd*g2*(5*r**2 + r*(21 - 42*s) - s*(47*s - 47))) - 2*Dd*f*(3*f**2*(108*r**2 + 2*r*(128*s - 75) + 148*s**2 - 189*s + 54) + f*(-28*C*s**2 + C*s + 18*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + r**2*(52*C + 68) + r*(24*C*s - 29*C + 192*s - 154) + 124*s**2 - 175*s + 72) + g2*(-20*r**2 + r*(168*s - 11) + s*(188*s - 89)))) - 9504*Dd**2*b2*f**2*r*s + 2376*Dd**2*b2*f**2*r - 9504*Dd**2*b2*f**2*s**2 + 9504*Dd**2*b2*f**2*s - 1584*Dd**2*b2*f**2 - 8712*Dd**2*f**3*r**2 - 13824*Dd**2*f**3*r*s + 12168*Dd**2*f**3*r - 5112*Dd**2*f**3*s**2 + 9468*Dd**2*f**3*s - 3756*Dd**2*f**3 + 19008*Dd**2*f**2*g2*r*s - 4752*Dd**2*f**2*g2*r + 19008*Dd**2*f**2*g2*s**2 - 19008*Dd**2*f**2*g2*s + 3168*Dd**2*f**2*g2 + 308*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 11*b1**2*(-16*C*D1**2*fd*r*s - 16*C*D1**2*fd*s**2 + 16*C*D1**2*fd*s + 8*C*D1**2*fdd*r*s + 8*C*D1**2*fdd*s**2 - 8*C*D1**2*fdd*s - 64*C*D1*Dd*f*r*s + 16*C*D1*Dd*f*r - 64*C*D1*Dd*f*s**2 + 64*C*D1*Dd*f*s - 16*C*D1*Dd*f + 64*C*D1*Dd*fd*r*s - 8*C*D1*Dd*fd*r + 64*C*D1*Dd*fd*s**2 - 64*C*D1*Dd*fd*s + 8*C*D1*Dd*fd + 32*C*D1*Ddd*f*r*s - 8*C*D1*Ddd*f*r + 32*C*D1*Ddd*f*s**2 - 32*C*D1*Ddd*f*s + 8*C*D1*Ddd*f + 96*C*Dd**2*f*r*s - 24*C*Dd**2*f*r + 96*C*Dd**2*f*s**2 - 96*C*Dd**2*f*s + 16*C*Dd**2*f + 59*D1**2*K*fd*r**2 - 70*D1**2*K*fd*r*s + 70*D1**2*K*fd*r - 129*D1**2*K*fd*s**2 + 258*D1**2*K*fd*s - 129*D1**2*K*fd - 5*D1**2*K*fdd*r**2 + 42*D1**2*K*fdd*r*s - 42*D1**2*K*fdd*r + 47*D1**2*K*fdd*s**2 - 94*D1**2*K*fdd*s + 47*D1**2*K*fdd - 28*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 36*D1**2*f*fd*r**2 - 264*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 228*D1**2*f*fd*s**2 + 48*D1**2*f*fd*s + 48*D1**2*f*fd + 24*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s + 120*D1**2*f*fdd*s**2 - 24*D1**2*f*fdd*s - 24*D1**2*f*fdd + 24*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s + 120*D1**2*fd**2*s**2 - 24*D1**2*fd**2*s - 24*D1**2*fd**2 - 85*D1**2*fd*r**2 - 118*D1**2*fd*r*s + 34*D1**2*fd*r - 33*D1**2*fd*s**2 - 118*D1**2*fd*s + 51*D1**2*fd + 11*D1**2*fdd*r**2 + 10*D1**2*fdd*r*s + 18*D1**2*fdd*r - D1**2*fdd*s**2 + 66*D1**2*fdd*s - 29*D1**2*fdd - 112*D1**2*gd2*r*s - 112*D1**2*gd2*s**2 + 112*D1**2*gd2*s + 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 236*D1*Dd*K*f*r**2 - 280*D1*Dd*K*f*r*s - 166*D1*Dd*K*f*r - 516*D1*Dd*K*f*s**2 + 398*D1*Dd*K*f*s - 11*D1*Dd*K*f - 40*D1*Dd*K*fd*r**2 + 336*D1*Dd*K*fd*r*s - 190*D1*Dd*K*fd*r + 376*D1*Dd*K*fd*s**2 - 554*D1*Dd*K*fd*s + 178*D1*Dd*K*fd - 72*D1*Dd*f**2*r**2 - 528*D1*Dd*f**2*r*s + 204*D1*Dd*f**2*r - 456*D1*Dd*f**2*s**2 + 492*D1*Dd*f**2*s - 150*D1*Dd*f**2 + 192*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 240*D1*Dd*f*fd*r + 960*D1*Dd*f*fd*s**2 - 624*D1*Dd*f*fd*s + 24*D1*Dd*f*fd - 340*D1*Dd*f*r**2 - 472*D1*Dd*f*r*s + 458*D1*Dd*f*r - 132*D1*Dd*f*s**2 + 302*D1*Dd*f*s - 203*D1*Dd*f + 88*D1*Dd*fd*r**2 + 80*D1*Dd*fd*r*s + 18*D1*Dd*fd*r - 8*D1*Dd*fd*s**2 + 246*D1*Dd*fd*s - 102*D1*Dd*fd - 448*D1*Dd*g2*r*s + 112*D1*Dd*g2*r - 448*D1*Dd*g2*s**2 + 448*D1*Dd*g2*s - 112*D1*Dd*g2 + 448*D1*Dd*gd2*r*s - 56*D1*Dd*gd2*r + 448*D1*Dd*gd2*s**2 - 448*D1*Dd*gd2*s + 56*D1*Dd*gd2 - 20*D1*Ddd*K*f*r**2 + 168*D1*Ddd*K*f*r*s - 22*D1*Ddd*K*f*r + 188*D1*Ddd*K*f*s**2 - 178*D1*Ddd*K*f*s + 37*D1*Ddd*K*f + 48*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r + 240*D1*Ddd*f**2*s**2 - 264*D1*Ddd*f**2*s + 84*D1*Ddd*f**2 + 44*D1*Ddd*f*r**2 + 40*D1*Ddd*f*r*s - 54*D1*Ddd*f*r - 4*D1*Ddd*f*s**2 - 18*D1*Ddd*f*s + 21*D1*Ddd*f + 224*D1*Ddd*g2*r*s - 56*D1*Ddd*g2*r + 224*D1*Ddd*g2*s**2 - 224*D1*Ddd*g2*s + 56*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) - 60*Dd**2*K*f*r**2 + 504*Dd**2*K*f*r*s - 66*Dd**2*K*f*r + 564*Dd**2*K*f*s**2 - 534*Dd**2*K*f*s + 74*Dd**2*K*f + 144*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 360*Dd**2*f**2*r + 720*Dd**2*f**2*s**2 - 792*Dd**2*f**2*s + 168*Dd**2*f**2 + 132*Dd**2*f*r**2 + 120*Dd**2*f*r*s - 162*Dd**2*f*r - 12*Dd**2*f*s**2 - 54*Dd**2*f*s + 42*Dd**2*f + 672*Dd**2*g2*r*s - 168*Dd**2*g2*r + 672*Dd**2*g2*s**2 - 672*Dd**2*g2*s + 112*Dd**2*g2) - 11*b1*(28*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - D1**2*bdd1*(12*f**2*(2*r**2 + 2*r*(6*s - 5) + 10*s**2 - 20*s + 9) + f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-10*r**2 + 84*r*s + 10*r + 94*s**2 - 42*s - 5) + 22*r**2 + 20*r*s - 50*r - 2*s**2 - 74*s + 39) + 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 2*D1**2*(3*f**2*(fd*(63*r**2 + 4*r*(57*s - 34) + 165*s**2 - 210*s + 85) - fdd*(81*r**2 + 4*r*(48*s - 35) + 111*s**2 - 158*s + 75)) - f*(6*fd**2*(81*r**2 + 4*r*(48*s - 35) + 111*s**2 - 158*s + 53) - fd*(2*C*(19*r**2 + 2*r*(5*s - 12) - 9*s**2 + 4*s + 5) + 60*K*(2*r*s - r + 2*s**2 - 2*s + 1) + 30*r**2 + 100*r*s - 36*r + 70*s**2 - 74*s + 45) + fdd*(2*C*(13*r**2 + 2*r*(3*s - 8) - 7*s**2 + 4*s + 3) + 36*K*(2*r*s - r + 2*s**2 - 2*s + 1) + 34*r**2 + 96*r*s - 34*r + 62*s**2 - 62*s + 33) + (gd2*(59*r - 129*s - 59) + gdd2*(-5*r + 47*s + 5))*(r + s - 1)) - 2*fd**2*(C*(13*r**2 + 2*r*(3*s - 8) - 7*s**2 + 4*s + 3) + 36*K*s**2 - 36*K*s + 17*r**2 + r*(36*K*s - 18*K + 48*s - 17) + 31*s**2 - 31*s - 9) - fd*(r + s - 1)*(59*g2*r - 129*g2*(s - 1) - 2*gd2*(5*r - 47*s + 21)) + fdd*g2*(5*r**2 - 42*r*(s - 1) - 47*(s - 1)**2)) + D1*bd1*(D1*(6*f**2*(6*r**2 + 4*r*(11*s - 9) + 38*s**2 - 74*s + 33) + f*(16*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 118*K*r**2 + 140*K*r*s + 118*K*r + 258*K*s**2 - 70*K*s - 59*K - 24*fd*(4*r**2 + 24*r*s - 10*r + 20*s**2 - 22*s + 5) + 170*r**2 + 236*r*s - 254*r + 66*s**2 - 302*s + 169) - 2*fd*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(-10*r**2 + 84*r*s - 37*r + 94*s**2 - 115*s + 21) + 22*r**2 + 20*r*s - 7*r - 2*s**2 + 29*s - 13) + 56*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 56*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd*(24*f**2*(4*r**2 + 3*r*(8*s - 5) + 20*s**2 - 31*s + 10) + f*(8*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + K*(-40*r**2 + 336*r*s - 2*r + 376*s**2 - 262*s + 11) + 88*r**2 + 80*r*s - 154*r - 8*s**2 - 166*s + 87) + 56*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 2*D1*(Dd*(3*f**3*(84*r**2 + 16*r*(19*s - 10) + 220*s**2 - 262*s + 97) + f**2*(C*(76*r**2 + r*(40*s - 86) - 36*s**2 - 2*s + 29) + 60*K*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(324*r**2 + r*(768*s - 538) + 444*s**2 - 619*s + 219) + 60*r**2 + 200*r*s - 110*r + 140*s**2 - 170*s + 65) - f*(2*fd*(2*C*(52*r**2 + r*(24*s - 61) - 28*s**2 + 9*s + 14) + 36*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) + 136*r**2 + 384*r*s - 184*r + 248*s**2 - 282*s + 65) + 236*g2*r**2 - 280*g2*r*s - 166*g2*r - 516*g2*s**2 + 398*g2*s - 11*g2 - 40*gd2*r**2 + 336*gd2*r*s + 18*gd2*r + 376*gd2*s**2 - 346*gd2*s + 22*gd2) + 2*fd*g2*(20*r**2 + r*(95 - 168*s) - 188*s**2 + 277*s - 89)) - Ddd*f*(3*f**2*(108*r**2 + 4*r*(64*s - 43) + 148*s**2 - 202*s + 91) + f*(C*(52*r**2 + r*(24*s - 58) - 28*s**2 + 2*s + 19) + 36*K*(r*(4*s - 1) + (1 - 2*s)**2) + 68*r**2 + 192*r*s - 116*r + 124*s**2 - 158*s + 65) + g2*(-20*r**2 + 2*r*(84*s - 11) + 188*s**2 - 178*s + 37))) + 4*Dd**2*f*(3*f**2*(162*r**2 + 6*r*(64*s - 43) + 222*s**2 - 303*s + 91) + f*(C*(78*r**2 + r*(36*s - 87) - 42*s**2 + 3*s + 19) + 18*K*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 102*r**2 + 288*r*s - 174*r + 186*s**2 - 237*s + 65) + g2*(-30*r**2 + 3*r*(84*s - 11) + 282*s**2 - 267*s + 37))))/(462*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**2*k1**2*(330*C*D1**2*bdd1*f**2*r**2 + 5148*C*D1**2*bdd1*f**2*r*s + 4818*C*D1**2*bdd1*f**2*s**2 + 4170*C*D1**2*f**2*fd*r**2 + 22980*C*D1**2*f**2*fd*r*s - 10440*C*D1**2*f**2*fd*r + 18810*C*D1**2*f**2*fd*s**2 - 20200*C*D1**2*f**2*fd*s + 7660*C*D1**2*f**2*fd - 5550*C*D1**2*f**2*fdd*r**2 - 22380*C*D1**2*f**2*fdd*r*s + 11160*C*D1**2*f**2*fdd*r - 16830*C*D1**2*f**2*fdd*s**2 + 18680*C*D1**2*f**2*fdd*s - 7460*C*D1**2*f**2*fdd - 11100*C*D1**2*f*fd**2*r**2 - 44760*C*D1**2*f*fd**2*r*s + 22320*C*D1**2*f*fd**2*r - 33660*C*D1**2*f*fd**2*s**2 + 37360*C*D1**2*f*fd**2*s - 7460*C*D1**2*f*fd**2 + 5560*C*D1*Dd*f**3*r**2 + 30640*C*D1*Dd*f**3*r*s - 13220*C*D1*Dd*f**3*r + 25080*C*D1*Dd*f**3*s**2 - 27860*C*D1*Dd*f**3*s + 9050*C*D1*Dd*f**3 - 44400*C*D1*Dd*f**2*fd*r**2 - 179040*C*D1*Dd*f**2*fd*r*s + 89220*C*D1*Dd*f**2*fd*r - 134640*C*D1*Dd*f**2*fd*s**2 + 153140*C*D1*Dd*f**2*fd*s - 41000*C*D1*Dd*f**2*fd - 7400*C*D1*Ddd*f**3*r**2 - 29840*C*D1*Ddd*f**3*r*s + 14860*C*D1*Ddd*f**3*r - 22440*C*D1*Ddd*f**3*s**2 + 26140*C*D1*Ddd*f**3*s - 9310*C*D1*Ddd*f**3 - 22200*C*Dd**2*f**3*r**2 - 89520*C*Dd**2*f**3*r*s + 44580*C*Dd**2*f**3*r - 67320*C*Dd**2*f**3*s**2 + 78420*C*Dd**2*f**3*s - 18620*C*Dd**2*f**3 - 990*D1**2*K*bdd1*f**2*r**2 - 4356*D1**2*K*bdd1*f**2*r*s + 1980*D1**2*K*bdd1*f**2*r - 3366*D1**2*K*bdd1*f**2*s**2 + 4356*D1**2*K*bdd1*f**2*s - 990*D1**2*K*bdd1*f**2 + 198*D1**2*b2*bdd1*f*r**2 + 396*D1**2*b2*bdd1*f*r*s + 198*D1**2*b2*bdd1*f*s**2 + 1188*D1**2*b2*f*fd*r**2 + 8712*D1**2*b2*f*fd*r*s - 4356*D1**2*b2*f*fd*r + 7524*D1**2*b2*f*fd*s**2 - 7524*D1**2*b2*f*fd*s + 3762*D1**2*b2*f*fd - 1980*D1**2*b2*f*fdd*r**2 - 8712*D1**2*b2*f*fdd*r*s + 4356*D1**2*b2*f*fdd*r - 6732*D1**2*b2*f*fdd*s**2 + 6732*D1**2*b2*f*fdd*s - 3366*D1**2*b2*f*fdd - 1980*D1**2*b2*fd**2*r**2 - 8712*D1**2*b2*fd**2*r*s + 4356*D1**2*b2*fd**2*r - 6732*D1**2*b2*fd**2*s**2 + 6732*D1**2*b2*fd**2*s + 132*D1**2*bd1**2*(3*f**2*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + f*(r**2*(35*C + 3*K + 12) + r*(33*C*(2*s - 1) + 46*K*s - 3*K + 8*s - 67) + s**2*(31*C + 43*K - 4) - s*(31*C + 23*K + 59) + 53) - 28*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 594*D1**2*bd2*f**2*r**2 + 4356*D1**2*bd2*f**2*r*s - 1188*D1**2*bd2*f**2*r + 3762*D1**2*bd2*f**2*s**2 - 4356*D1**2*bd2*f**2*s + 594*D1**2*bd2*f**2 - 3960*D1**2*bd2*f*fd*r**2 - 17424*D1**2*bd2*f*fd*r*s + 8316*D1**2*bd2*f*fd*r - 13464*D1**2*bd2*f*fd*s**2 + 15444*D1**2*bd2*f*fd*s - 4356*D1**2*bd2*f*fd + 3201*D1**2*bdd1*f**2*r**2 + 2640*D1**2*bdd1*f**2*r*s - 6336*D1**2*bdd1*f**2*r - 561*D1**2*bdd1*f**2*s**2 - 5940*D1**2*bdd1*f**2*s + 2970*D1**2*bdd1*f**2 - 396*D1**2*bdd1*f*g2*r**2 - 6072*D1**2*bdd1*f*g2*r*s - 5676*D1**2*bdd1*f*g2*s**2 - 990*D1**2*bdd2*f**2*r**2 - 4356*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*r - 3366*D1**2*bdd2*f**2*s**2 + 4356*D1**2*bdd2*f**2*s - 990*D1**2*bdd2*f**2 - 1095*D1**2*f**2*fd*r**2 - 10500*D1**2*f**2*fd*r*s + 4230*D1**2*f**2*fd*r - 9405*D1**2*f**2*fd*s**2 + 9770*D1**2*f**2*fd*s - 3500*D1**2*f**2*fd + 2775*D1**2*f**2*fdd*r**2 + 11190*D1**2*f**2*fdd*r*s - 5580*D1**2*f**2*fdd*r + 8415*D1**2*f**2*fdd*s**2 - 9340*D1**2*f**2*fdd*s + 3730*D1**2*f**2*fdd - 1188*D1**2*f**2*gd2*r**2 - 8712*D1**2*f**2*gd2*r*s + 2376*D1**2*f**2*gd2*r - 7524*D1**2*f**2*gd2*s**2 + 8712*D1**2*f**2*gd2*s - 1188*D1**2*f**2*gd2 + 1980*D1**2*f**2*gdd2*r**2 + 8712*D1**2*f**2*gdd2*r*s - 3960*D1**2*f**2*gdd2*r + 6732*D1**2*f**2*gdd2*s**2 - 8712*D1**2*f**2*gdd2*s + 1980*D1**2*f**2*gdd2 + 5550*D1**2*f*fd**2*r**2 + 22380*D1**2*f*fd**2*r*s - 11160*D1**2*f*fd**2*r + 16830*D1**2*f*fd**2*s**2 - 18680*D1**2*f*fd**2*s + 3730*D1**2*f*fd**2 - 2376*D1**2*f*fd*g2*r**2 - 17424*D1**2*f*fd*g2*r*s + 8712*D1**2*f*fd*g2*r - 15048*D1**2*f*fd*g2*s**2 + 15048*D1**2*f*fd*g2*s - 7524*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r**2 + 34848*D1**2*f*fd*gd2*r*s - 16632*D1**2*f*fd*gd2*r + 26928*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 8712*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r**2 + 17424*D1**2*f*fdd*g2*r*s - 8712*D1**2*f*fdd*g2*r + 13464*D1**2*f*fdd*g2*s**2 - 13464*D1**2*f*fdd*g2*s + 6732*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r**2 + 17424*D1**2*fd**2*g2*r*s - 8712*D1**2*fd**2*g2*r + 13464*D1**2*fd**2*g2*s**2 - 13464*D1**2*fd**2*g2*s + 2376*D1*Dd*b2*f**2*r**2 + 17424*D1*Dd*b2*f**2*r*s - 6732*D1*Dd*b2*f**2*r + 15048*D1*Dd*b2*f**2*s**2 - 16236*D1*Dd*b2*f**2*s + 4950*D1*Dd*b2*f**2 - 15840*D1*Dd*b2*f*fd*r**2 - 69696*D1*Dd*b2*f*fd*r*s + 34056*D1*Dd*b2*f*fd*r - 53856*D1*Dd*b2*f*fd*s**2 + 57816*D1*Dd*b2*f*fd*s - 15444*D1*Dd*b2*f*fd - 7920*D1*Dd*bd2*f**2*r**2 - 34848*D1*Dd*bd2*f**2*r*s + 16236*D1*Dd*bd2*f**2*r - 26928*D1*Dd*bd2*f**2*s**2 + 32868*D1*Dd*bd2*f**2*s - 8316*D1*Dd*bd2*f**2 - 1460*D1*Dd*f**3*r**2 - 14000*D1*Dd*f**3*r*s + 4960*D1*Dd*f**3*r - 12540*D1*Dd*f**3*s**2 + 13270*D1*Dd*f**3*s - 3865*D1*Dd*f**3 + 22200*D1*Dd*f**2*fd*r**2 + 89520*D1*Dd*f**2*fd*r*s - 44610*D1*Dd*f**2*fd*r + 67320*D1*Dd*f**2*fd*s**2 - 76570*D1*Dd*f**2*fd*s + 20500*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*g2*r**2 - 34848*D1*Dd*f**2*g2*r*s + 13464*D1*Dd*f**2*g2*r - 30096*D1*Dd*f**2*g2*s**2 + 32472*D1*Dd*f**2*g2*s - 9900*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r**2 + 69696*D1*Dd*f**2*gd2*r*s - 32472*D1*Dd*f**2*gd2*r + 53856*D1*Dd*f**2*gd2*s**2 - 65736*D1*Dd*f**2*gd2*s + 16632*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r**2 + 139392*D1*Dd*f*fd*g2*r*s - 68112*D1*Dd*f*fd*g2*r + 107712*D1*Dd*f*fd*g2*s**2 - 115632*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 3960*D1*Ddd*b2*f**2*r**2 - 17424*D1*Ddd*b2*f**2*r*s + 8316*D1*Ddd*b2*f**2*r - 13464*D1*Ddd*b2*f**2*s**2 + 15444*D1*Ddd*b2*f**2*s - 5346*D1*Ddd*b2*f**2 + 3700*D1*Ddd*f**3*r**2 + 14920*D1*Ddd*f**3*r*s - 7430*D1*Ddd*f**3*r + 11220*D1*Ddd*f**3*s**2 - 13070*D1*Ddd*f**3*s + 4655*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r**2 + 34848*D1*Ddd*f**2*g2*r*s - 16632*D1*Ddd*f**2*g2*r + 26928*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 10692*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(2*f**2*(3*K*(3*r**2 + r*(22*s - 6) + 19*s**2 - 22*s + 3) - 2*r**2*(2*C + 20) - 2*r*(s*(36*C + 22) - 45) - 2*s**2*(34*C + 2) + 102*s - 48) + f*(-5*b2*r**2 - 10*b2*r*s - 5*b2*s**2 + 12*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*fd*(-292*C*s**2 + 224*C*s + 6*K*(10*r**2 + r*(44*s - 21) + 34*s**2 - 39*s + 11) - r**2*(20*C + 194) + r*(-312*C*s + 88*C - 160*s + 233) + 34*s**2 + 113*s - 96) + 10*g2*r**2 + 172*g2*r*s + 162*g2*s**2 - 24*gd2*r**2 - 368*gd2*r*s + 24*gd2*r - 344*gd2*s**2 + 184*gd2*s) + 4*fd*(3*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(3*r**2 + 23*r*(2*s - 1) + s*(43*s - 43)))) - 2*Dd*f*(-6*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f*(-584*C*s**2 + 302*C*s + 6*K*(20*r**2 + r*(88*s - 41) + 68*s**2 - 83*s + 21) - r**2*(40*C + 388) + r*(-624*C*s + 98*C - 320*s + 618) + 68*s**2 + 423*s - 282) + 4*g2*(12*r**2 + r*(184*s - 29) + s*(172*s - 89)))) - 11880*Dd**2*b2*f**2*r**2 - 52272*Dd**2*b2*f**2*r*s + 24948*Dd**2*b2*f**2*r - 40392*Dd**2*b2*f**2*s**2 + 46332*Dd**2*b2*f**2*s - 10692*Dd**2*b2*f**2 + 11100*Dd**2*f**3*r**2 + 44760*Dd**2*f**3*r*s - 22290*Dd**2*f**3*r + 33660*Dd**2*f**3*s**2 - 39210*Dd**2*f**3*s + 9310*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r**2 + 104544*Dd**2*f**2*g2*r*s - 49896*Dd**2*f**2*g2*r + 80784*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 21384*Dd**2*f**2*g2 + 66*b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(14*K - 21)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 6*f + 21)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 6*f + 21)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(-42*C*D1**2*fd*r**2 - 124*C*D1**2*fd*r*s + 84*C*D1**2*fd*r - 82*C*D1**2*fd*s**2 + 124*C*D1**2*fd*s - 42*C*D1**2*fd + 70*C*D1**2*fdd*r**2 + 132*C*D1**2*fdd*r*s - 140*C*D1**2*fdd*r + 62*C*D1**2*fdd*s**2 - 132*C*D1**2*fdd*s + 70*C*D1**2*fdd - 168*C*D1*Dd*f*r**2 - 496*C*D1*Dd*f*r*s + 292*C*D1*Dd*f*r - 328*C*D1*Dd*f*s**2 + 412*C*D1*Dd*f*s - 166*C*D1*Dd*f + 560*C*D1*Dd*fd*r**2 + 1056*C*D1*Dd*fd*r*s - 972*C*D1*Dd*fd*r + 496*C*D1*Dd*fd*s**2 - 916*C*D1*Dd*fd*s + 412*C*D1*Dd*fd + 280*C*D1*Ddd*f*r**2 + 528*C*D1*Ddd*f*r*s - 412*C*D1*Ddd*f*r + 248*C*D1*Ddd*f*s**2 - 388*C*D1*Ddd*f*s + 202*C*D1*Ddd*f + 840*C*Dd**2*f*r**2 + 1584*C*Dd**2*f*r*s - 1236*C*Dd**2*f*r + 744*C*Dd**2*f*s**2 - 1164*C*Dd**2*f*s + 404*C*Dd**2*f - 5*D1**2*K*fd*r**2 - 86*D1**2*K*fd*r*s + 86*D1**2*K*fd*r - 81*D1**2*K*fd*s**2 + 162*D1**2*K*fd*s - 81*D1**2*K*fd + 6*D1**2*K*fdd*r**2 + 92*D1**2*K*fdd*r*s - 92*D1**2*K*fdd*r + 86*D1**2*K*fdd*s**2 - 172*D1**2*K*fdd*s + 86*D1**2*K*fdd - 2*D1**2*bdd1*(-14*K + 6*f + 21)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 216*D1**2*f*fd*r**2 - 384*D1**2*f*fd*r*s + 228*D1**2*f*fd*r - 168*D1**2*f*fd*s**2 + 132*D1**2*f*fd*s - 84*D1**2*f*fd + 264*D1**2*f*fdd*r**2 + 384*D1**2*f*fdd*r*s - 300*D1**2*f*fdd*r + 120*D1**2*f*fdd*s**2 - 156*D1**2*f*fdd*s + 132*D1**2*f*fdd + 264*D1**2*fd**2*r**2 + 384*D1**2*fd**2*r*s - 300*D1**2*fd**2*r + 120*D1**2*fd**2*s**2 - 156*D1**2*fd**2*s + 36*D1**2*fd**2 - 34*D1**2*fd*r**2 - 32*D1**2*fd*r*s - 142*D1**2*fd*r + 2*D1**2*fd*s**2 - 220*D1**2*fd*s + 90*D1**2*fd + 24*D1**2*fdd*r**2 + 16*D1**2*fdd*r*s + 204*D1**2*fdd*r - 8*D1**2*fdd*s**2 + 236*D1**2*fdd*s - 122*D1**2*fdd + 112*D1**2*gd2*r**2 + 224*D1**2*gd2*r*s - 224*D1**2*gd2*r + 112*D1**2*gd2*s**2 - 224*D1**2*gd2*s + 112*D1**2*gd2 - 56*D1**2*gdd2*r**2 - 112*D1**2*gdd2*r*s + 112*D1**2*gdd2*r - 56*D1**2*gdd2*s**2 + 112*D1**2*gdd2*s - 56*D1**2*gdd2 - 20*D1*Dd*K*f*r**2 - 344*D1*Dd*K*f*r*s + 106*D1*Dd*K*f*r - 324*D1*Dd*K*f*s**2 + 334*D1*Dd*K*f*s - 91*D1*Dd*K*f + 48*D1*Dd*K*fd*r**2 + 736*D1*Dd*K*fd*r*s - 484*D1*Dd*K*fd*r + 688*D1*Dd*K*fd*s**2 - 1044*D1*Dd*K*fd*s + 356*D1*Dd*K*fd - 432*D1*Dd*f**2*r**2 - 768*D1*Dd*f**2*r*s + 624*D1*Dd*f**2*r - 336*D1*Dd*f**2*s**2 + 552*D1*Dd*f**2*s - 300*D1*Dd*f**2 + 2112*D1*Dd*f*fd*r**2 + 3072*D1*Dd*f*fd*r*s - 2640*D1*Dd*f*fd*r + 960*D1*Dd*f*fd*s**2 - 1632*D1*Dd*f*fd*s + 756*D1*Dd*f*fd - 136*D1*Dd*f*r**2 - 128*D1*Dd*f*r*s + 168*D1*Dd*f*r + 8*D1*Dd*f*s**2 + 60*D1*Dd*f*s - 66*D1*Dd*f + 192*D1*Dd*fd*r**2 + 128*D1*Dd*fd*r*s + 704*D1*Dd*fd*r - 64*D1*Dd*fd*s**2 + 928*D1*Dd*fd*s - 644*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 896*D1*Dd*g2*r*s - 672*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 672*D1*Dd*g2*s + 336*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 896*D1*Dd*gd2*r*s + 784*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 784*D1*Dd*gd2*s - 336*D1*Dd*gd2 + 24*D1*Ddd*K*f*r**2 + 368*D1*Ddd*K*f*r*s - 116*D1*Ddd*K*f*r + 344*D1*Ddd*K*f*s**2 - 356*D1*Ddd*K*f*s + 98*D1*Ddd*K*f + 528*D1*Ddd*f**2*r**2 + 768*D1*Ddd*f**2*r*s - 720*D1*Ddd*f**2*r + 240*D1*Ddd*f**2*s**2 - 504*D1*Ddd*f**2*s + 324*D1*Ddd*f**2 + 96*D1*Ddd*f*r**2 + 64*D1*Ddd*f*r*s - 112*D1*Ddd*f*r - 32*D1*Ddd*f*s**2 - 16*D1*Ddd*f*s + 40*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 448*D1*Ddd*g2*r*s + 336*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 336*D1*Ddd*g2*s - 168*D1*Ddd*g2 + 2*D1*bd1*(D1*(5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(14*K - 21)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-14*K + 6*f + 21)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 72*Dd**2*K*f*r**2 + 1104*Dd**2*K*f*r*s - 348*Dd**2*K*f*r + 1032*Dd**2*K*f*s**2 - 1068*Dd**2*K*f*s + 196*Dd**2*K*f + 1584*Dd**2*f**2*r**2 + 2304*Dd**2*f**2*r*s - 2160*Dd**2*f**2*r + 720*Dd**2*f**2*s**2 - 1512*Dd**2*f**2*s + 648*Dd**2*f**2 + 288*Dd**2*f*r**2 + 192*Dd**2*f*r*s - 336*Dd**2*f*r - 96*Dd**2*f*s**2 - 48*Dd**2*f*s + 80*Dd**2*f - 672*Dd**2*g2*r**2 - 1344*Dd**2*g2*r*s + 1008*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 1008*Dd**2*g2*s - 336*Dd**2*g2) - 33*b1*(-140*C*D1**2*bdd1*f*r**2 - 264*C*D1**2*bdd1*f*r*s + 132*C*D1**2*bdd1*f*r - 124*C*D1**2*bdd1*f*s**2 + 124*C*D1**2*bdd1*f*s - 62*C*D1**2*bdd1*f + 16*C*D1**2*f*fd*r**2 + 288*C*D1**2*f*fd*r*s - 160*C*D1**2*f*fd*r + 272*C*D1**2*f*fd*s**2 - 416*C*D1**2*f*fd*s + 144*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 - 312*C*D1**2*f*fdd*r*s + 176*C*D1**2*f*fdd*r - 292*C*D1**2*f*fdd*s**2 + 448*C*D1**2*f*fdd*s - 156*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 - 312*C*D1**2*fd**2*r*s + 176*C*D1**2*fd**2*r - 292*C*D1**2*fd**2*s**2 + 448*C*D1**2*fd**2*s - 156*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r**2 + 576*C*D1*Dd*f**2*r*s - 176*C*D1*Dd*f**2*r + 544*C*D1*Dd*f**2*s**2 - 560*C*D1*Dd*f**2*s + 152*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 - 2496*C*D1*Dd*f*fd*r*s + 1096*C*D1*Dd*f*fd*r - 2336*C*D1*Dd*f*fd*s**2 + 3000*C*D1*Dd*f*fd*s - 800*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 - 624*C*D1*Ddd*f**2*r*s + 196*C*D1*Ddd*f**2*r - 584*C*D1*Ddd*f**2*s**2 + 604*C*D1*Ddd*f**2*s - 166*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 - 1872*C*Dd**2*f**2*r*s + 588*C*Dd**2*f**2*r - 1752*C*Dd**2*f**2*s**2 + 1812*C*Dd**2*f**2*s - 332*C*Dd**2*f**2 - 12*D1**2*K*bdd1*f*r**2 - 184*D1**2*K*bdd1*f*r*s + 12*D1**2*K*bdd1*f*r - 172*D1**2*K*bdd1*f*s**2 + 92*D1**2*K*bdd1*f*s - 6*D1**2*K*bdd1*f - 36*D1**2*K*f*fd*r**2 - 264*D1**2*K*f*fd*r*s + 132*D1**2*K*f*fd*r - 228*D1**2*K*f*fd*s**2 + 228*D1**2*K*f*fd*s - 114*D1**2*K*f*fd + 60*D1**2*K*f*fdd*r**2 + 264*D1**2*K*f*fdd*r*s - 132*D1**2*K*f*fdd*r + 204*D1**2*K*f*fdd*s**2 - 204*D1**2*K*f*fdd*s + 102*D1**2*K*f*fdd + 60*D1**2*K*fd**2*r**2 + 264*D1**2*K*fd**2*r*s - 132*D1**2*K*fd**2*r + 204*D1**2*K*fd**2*s**2 - 204*D1**2*K*fd**2*s + 5*D1**2*b2*fd*r**2 + 10*D1**2*b2*fd*r*s - 10*D1**2*b2*fd*r + 5*D1**2*b2*fd*s**2 - 10*D1**2*b2*fd*s + 5*D1**2*b2*fd - 6*D1**2*b2*fdd*r**2 - 12*D1**2*b2*fdd*r*s + 12*D1**2*b2*fdd*r - 6*D1**2*b2*fdd*s**2 + 12*D1**2*b2*fdd*s - 6*D1**2*b2*fdd + 4*D1**2*bd1**2*(-14*K + 6*f + 21)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 264*D1**2*bdd1*f**2*r**2 - 384*D1**2*bdd1*f**2*r*s + 420*D1**2*bdd1*f**2*r - 120*D1**2*bdd1*f**2*s**2 + 348*D1**2*bdd1*f**2*s - 192*D1**2*bdd1*f**2 - 48*D1**2*bdd1*f*r**2 - 32*D1**2*bdd1*f*r*s + 268*D1**2*bdd1*f*r + 16*D1**2*bdd1*f*s**2 + 236*D1**2*bdd1*f*s - 138*D1**2*bdd1*f + 112*D1**2*bdd1*g2*r**2 + 224*D1**2*bdd1*g2*r*s - 112*D1**2*bdd1*g2*r + 112*D1**2*bdd1*g2*s**2 - 112*D1**2*bdd1*g2*s + 56*D1**2*bdd1*g2 - 6*D1**2*bdd2*f*r**2 - 12*D1**2*bdd2*f*r*s + 12*D1**2*bdd2*f*r - 6*D1**2*bdd2*f*s**2 + 12*D1**2*bdd2*f*s - 6*D1**2*bdd2*f + 160*D1**2*f*fd*r**2 + 176*D1**2*f*fd*r*s - 68*D1**2*f*fd*r + 16*D1**2*f*fd*s**2 + 100*D1**2*f*fd*s - 8*D1**2*f*fd - 194*D1**2*f*fdd*r**2 - 160*D1**2*f*fdd*r*s + 82*D1**2*f*fdd*r + 34*D1**2*f*fdd*s**2 - 134*D1**2*f*fdd*s + 10*D1**2*f*fdd - 10*D1**2*f*gd2*r**2 - 172*D1**2*f*gd2*r*s + 20*D1**2*f*gd2*r - 162*D1**2*f*gd2*s**2 + 172*D1**2*f*gd2*s - 10*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 184*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*r + 172*D1**2*f*gdd2*s**2 - 184*D1**2*f*gdd2*s + 12*D1**2*f*gdd2 - 194*D1**2*fd**2*r**2 - 160*D1**2*fd**2*r*s + 82*D1**2*fd**2*r + 34*D1**2*fd**2*s**2 - 134*D1**2*fd**2*s + 112*D1**2*fd**2 - 10*D1**2*fd*g2*r**2 - 172*D1**2*fd*g2*r*s + 172*D1**2*fd*g2*r - 162*D1**2*fd*g2*s**2 + 324*D1**2*fd*g2*s - 162*D1**2*fd*g2 + 24*D1**2*fd*gd2*r**2 + 368*D1**2*fd*gd2*r*s - 208*D1**2*fd*gd2*r + 344*D1**2*fd*gd2*s**2 - 528*D1**2*fd*gd2*s + 184*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r**2 + 184*D1**2*fdd*g2*r*s - 184*D1**2*fdd*g2*r + 172*D1**2*fdd*g2*s**2 - 344*D1**2*fdd*g2*s + 172*D1**2*fdd*g2 - 72*D1*Dd*K*f**2*r**2 - 528*D1*Dd*K*f**2*r*s + 204*D1*Dd*K*f**2*r - 456*D1*Dd*K*f**2*s**2 + 492*D1*Dd*K*f**2*s - 150*D1*Dd*K*f**2 + 480*D1*Dd*K*f*fd*r**2 + 2112*D1*Dd*K*f*fd*r*s - 1032*D1*Dd*K*f*fd*r + 1632*D1*Dd*K*f*fd*s**2 - 1752*D1*Dd*K*f*fd*s + 468*D1*Dd*K*f*fd + 20*D1*Dd*b2*f*r**2 + 40*D1*Dd*b2*f*r*s - 30*D1*Dd*b2*f*r + 20*D1*Dd*b2*f*s**2 - 30*D1*Dd*b2*f*s + 15*D1*Dd*b2*f - 48*D1*Dd*b2*fd*r**2 - 96*D1*Dd*b2*fd*r*s + 84*D1*Dd*b2*fd*r - 48*D1*Dd*b2*fd*s**2 + 84*D1*Dd*b2*fd*s - 36*D1*Dd*b2*fd + 320*D1*Dd*f**2*r**2 + 352*D1*Dd*f**2*r*s - 408*D1*Dd*f**2*r + 32*D1*Dd*f**2*s**2 - 192*D1*Dd*f**2*s + 168*D1*Dd*f**2 - 1552*D1*Dd*f*fd*r**2 - 1280*D1*Dd*f*fd*r*s + 1264*D1*Dd*f*fd*r + 272*D1*Dd*f*fd*s**2 - 284*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 40*D1*Dd*f*g2*r**2 - 688*D1*Dd*f*g2*r*s + 212*D1*Dd*f*g2*r - 648*D1*Dd*f*g2*s**2 + 668*D1*Dd*f*g2*s - 182*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 1472*D1*Dd*f*gd2*r*s - 328*D1*Dd*f*gd2*r + 1376*D1*Dd*f*gd2*s**2 - 1448*D1*Dd*f*gd2*s + 232*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 1472*D1*Dd*fd*g2*r*s - 968*D1*Dd*fd*g2*r + 1376*D1*Dd*fd*g2*s**2 - 2088*D1*Dd*fd*g2*s + 712*D1*Dd*fd*g2 + 120*D1*Ddd*K*f**2*r**2 + 528*D1*Ddd*K*f**2*r*s - 252*D1*Ddd*K*f**2*r + 408*D1*Ddd*K*f**2*s**2 - 468*D1*Ddd*K*f**2*s + 162*D1*Ddd*K*f**2 - 24*D1*Ddd*b2*f*r**2 - 48*D1*Ddd*b2*f*r*s + 36*D1*Ddd*b2*f*r - 24*D1*Ddd*b2*f*s**2 + 36*D1*Ddd*b2*f*s - 18*D1*Ddd*b2*f - 388*D1*Ddd*f**2*r**2 - 320*D1*Ddd*f**2*r*s + 468*D1*Ddd*f**2*r + 68*D1*Ddd*f**2*s**2 + 126*D1*Ddd*f**2*s - 177*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 736*D1*Ddd*f*g2*r*s - 232*D1*Ddd*f*g2*r + 688*D1*Ddd*f*g2*s**2 - 712*D1*Ddd*f*g2*s + 196*D1*Ddd*f*g2 + D1*bd1*(D1*(12*f**2*(18*r**2 + r*(32*s - 33) + 14*s**2 - 35*s + 18) + f*(2*C*(42*r**2 + 62*r*(2*s - 1) + 82*s**2 - 82*s + 41) + 10*K*r**2 + 172*K*r*s - 10*K*r + 162*K*s**2 - 86*K*s + 5*K - 12*fd*(88*r**2 + 8*r*(16*s - 15) + 40*s**2 - 84*s + 35) + 68*r**2 + 64*r*s - 242*r - 4*s**2 - 248*s + 122) - 4*fd*(C*(70*r**2 + r*(132*s - 103) + 62*s**2 - 97*s + 33) + K*(6*r**2 + 92*r*s - 49*r + 86*s**2 - 109*s + 23) + 24*r**2 + 16*r*s + 35*r - 8*s**2 + 59*s - 49) - 112*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 112*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(3*f**2*(176*r**2 + 4*r*(64*s - 65) + 80*s**2 - 200*s + 99) + f*(C*(280*r**2 + r*(528*s - 338) + 248*s**2 - 318*s + 97) + K*(24*r**2 + 368*r*s - 70*r + 344*s**2 - 270*s + 29) + 96*r**2 + 64*r*s - 324*r - 32*s**2 - 244*s + 193) - 28*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + D1*bd2*(D1*(5*f - 12*fd)*(r + s - 1) - 12*Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 360*Dd**2*K*f**2*r**2 + 1584*Dd**2*K*f**2*r*s - 756*Dd**2*K*f**2*r + 1224*Dd**2*K*f**2*s**2 - 1404*Dd**2*K*f**2*s + 324*Dd**2*K*f**2 - 72*Dd**2*b2*f*r**2 - 144*Dd**2*b2*f*r*s + 108*Dd**2*b2*f*r - 72*Dd**2*b2*f*s**2 + 108*Dd**2*b2*f*s - 36*Dd**2*b2*f - 1164*Dd**2*f**2*r**2 - 960*Dd**2*f**2*r*s + 1404*Dd**2*f**2*r + 204*Dd**2*f**2*s**2 + 378*Dd**2*f**2*s - 354*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 2208*Dd**2*f*g2*r*s - 696*Dd**2*f*g2*r + 2064*Dd**2*f*g2*s**2 - 2136*Dd**2*f*g2*s + 392*Dd**2*f*g2))/(693*d**2*k3**3) + 4*D1**2*Pk2*Pkd3*ct**2*k1**2*st**2*(-D1*f*(3*D1*bd1**2*s*(2*f + 1)*(2*r + 2*s - 1) + D1*bd1*(-5*f*s*(r + s) + 3*fd*(r*(4*s - 1) + s*(4*s - 3))) + 3*D1*bdd1*f*s*(r + s) + 3*Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + b1**2*(-D1**2*(r + s - 1)*(6*fd**2*(2*s - 1) + fd*(-18*f*s + 9*f - 13*s + 13) + 3*fdd*(f*(4*s - 2) + s - 1)) + D1*(Dd*(9*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-6*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 13*r*(4*s - 1) + 13*(1 - 2*s)**2) - 3*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*Ddd*f*(2*f + 1)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(2*f + 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(6*bdd1*f**2*s*(2*r + 2*s - 1) + f*(3*bdd1*s*(2*r + 2*s - 1) - 5*fd*(2*s - 1)*(r + s - 1) + 3*fdd*(2*s - 1)*(r + s - 1)) + 3*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(f*s*(9*f + 13)*(2*r + 2*s - 1) - 3*fd*(2*f*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + 4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 3*Dd*f*(2*f + 1)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k2**2*k3) + 2*D1**2*Pk2*Pkd3*ct**2*k1**2*(D1*f*(2*D1*bd1**2*(2*r*(9*f*s + 4*s + 3) + s*(18*f*s - 9*f + 8*s + 2)) + 17*D1*bdd1*f*s*(r + s) + bd1*(D1*(-16*f*s*(r + s) + 17*fd*(r*(4*s - 1) + s*(4*s - 3))) + 17*Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 2*b1**3*(D1**2*s*(5*fd - 6*fdd)*(r + s - 1) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 14*r*(4*s - 1) + 14*(1 - 2*s)**2) - D1*Ddd*(6*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(6*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-2*D1**2*bdd1*(6*f + 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 36*D1**2*f*fd*r*s + 18*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 54*D1**2*f*fd*s - 18*D1**2*f*fd + 36*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*r + 36*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 18*D1**2*f*fdd + 36*D1**2*fd**2*r*s - 18*D1**2*fd**2*r + 36*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s + 18*D1**2*fd**2 - 9*D1**2*fd*r*s + 19*D1**2*fd*r - 9*D1**2*fd*s**2 + 28*D1**2*fd*s - 19*D1**2*fd + 8*D1**2*fdd*r*s - 20*D1**2*fdd*r + 8*D1**2*fdd*s**2 - 28*D1**2*fdd*s + 20*D1**2*fdd - 72*D1*Dd*f**2*r*s + 18*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 72*D1*Dd*f**2*s - 18*D1*Dd*f**2 + 288*D1*Dd*f*fd*r*s - 108*D1*Dd*f*fd*r + 288*D1*Dd*f*fd*s**2 - 360*D1*Dd*f*fd*s + 90*D1*Dd*f*fd - 36*D1*Dd*f*r*s + 9*D1*Dd*f*r - 36*D1*Dd*f*s**2 + 36*D1*Dd*f*s - 9*D1*Dd*f + 64*D1*Dd*fd*r*s - 88*D1*Dd*fd*r + 64*D1*Dd*fd*s**2 - 144*D1*Dd*fd*s + 68*D1*Dd*fd + 72*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 72*D1*Ddd*f**2*s**2 - 72*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + 32*D1*Ddd*f*r*s - 8*D1*Ddd*f*r + 32*D1*Ddd*f*s**2 - 32*D1*Ddd*f*s + 8*D1*Ddd*f + 2*D1*bd1*(D1*(5*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 6*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + 42*r*s - 14*r + 42*s**2 - 42*s + 14) - Dd*(6*f + 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 216*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 216*Dd**2*f**2*s**2 - 216*Dd**2*f**2*s + 36*Dd**2*f**2 + 96*Dd**2*f*r*s - 24*Dd**2*f*r + 96*Dd**2*f*s**2 - 96*Dd**2*f*s + 16*Dd**2*f) + b1*(-2*D1**2*bd1**2*(6*f + 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 2*D1**2*bdd1*f*(2*r*(s*(9*f + 4) + 3) + s**2*(18*f + 8) + s*(2 - 9*f) - 6) - 32*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 32*D1**2*f*fd*s**2 + 48*D1**2*f*fd*s - 16*D1**2*f*fd + 34*D1**2*f*fdd*r*s - 17*D1**2*f*fdd*r + 34*D1**2*f*fdd*s**2 - 51*D1**2*f*fdd*s + 17*D1**2*f*fdd + 34*D1**2*fd**2*r*s - 17*D1**2*fd**2*r + 34*D1**2*fd**2*s**2 - 51*D1**2*fd**2*s + 17*D1**2*fd**2 - 64*D1*Dd*f**2*r*s + 16*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 + 64*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 272*D1*Dd*f*fd*r*s - 102*D1*Dd*f*fd*r + 272*D1*Dd*f*fd*s**2 - 340*D1*Dd*f*fd*s + 85*D1*Dd*f*fd + 68*D1*Ddd*f**2*r*s - 17*D1*Ddd*f**2*r + 68*D1*Ddd*f**2*s**2 - 68*D1*Ddd*f**2*s + 17*D1*Ddd*f**2 + D1*bd1*(-D1*(18*f**2*s*(2*r + 2*s - 1) + f*(-18*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + 2*r*(9*s + 5) + 18*s**2 + s - 10) - 4*fd*(r*(8*s - 7) + 8*s**2 - 13*s + 2)) + 2*Dd*f*(9*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 16*r*(4*s + 1) + 64*s**2 - 24*s - 14)) + 204*Dd**2*f**2*r*s - 51*Dd**2*f**2*r + 204*Dd**2*f**2*s**2 - 204*Dd**2*f**2*s + 34*Dd**2*f**2))/(21*d**2*k2**2*k3) + 9*D1**2*Pk2*Pkd3*ct**2*k2**6*st**2*(8*C*D1**2*b1*f*fd*r**2 + 16*C*D1**2*b1*f*fd*r*s - 8*C*D1**2*b1*f*fd*r + 8*C*D1**2*b1*f*fd*s**2 - 8*C*D1**2*b1*f*fd*s + 4*C*D1**2*b1*f*fd - 4*C*D1**2*b1*f*fdd*r**2 - 8*C*D1**2*b1*f*fdd*r*s + 4*C*D1**2*b1*f*fdd*r - 4*C*D1**2*b1*f*fdd*s**2 + 4*C*D1**2*b1*f*fdd*s - 2*C*D1**2*b1*f*fdd - 4*C*D1**2*b1*fd**2*r**2 - 8*C*D1**2*b1*fd**2*r*s + 4*C*D1**2*b1*fd**2*r - 4*C*D1**2*b1*fd**2*s**2 + 4*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 16*C*D1*Dd*b1*f**2*r**2 + 32*C*D1*Dd*b1*f**2*r*s - 24*C*D1*Dd*b1*f**2*r + 16*C*D1*Dd*b1*f**2*s**2 - 24*C*D1*Dd*b1*f**2*s + 12*C*D1*Dd*b1*f**2 - 32*C*D1*Dd*b1*f*fd*r**2 - 64*C*D1*Dd*b1*f*fd*r*s + 40*C*D1*Dd*b1*f*fd*r - 32*C*D1*Dd*b1*f*fd*s**2 + 40*C*D1*Dd*b1*f*fd*s - 12*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 8*C*D1*Ddd*b1*f**2*r**2 - 16*C*D1*Ddd*b1*f**2*r*s + 12*C*D1*Ddd*b1*f**2*r - 8*C*D1*Ddd*b1*f**2*s**2 + 12*C*D1*Ddd*b1*f**2*s - 6*C*D1*Ddd*b1*f**2 - 24*C*Dd**2*b1*f**2*r**2 - 48*C*Dd**2*b1*f**2*r*s + 36*C*Dd**2*b1*f**2*r - 24*C*Dd**2*b1*f**2*s**2 + 36*C*Dd**2*b1*f**2*s - 12*C*Dd**2*b1*f**2 + 2*D1**2*K*b1**2*fd*r**2 + 4*D1**2*K*b1**2*fd*r*s + 2*D1**2*K*b1**2*fd*s**2 - D1**2*K*b1**2*fdd*r**2 - 2*D1**2*K*b1**2*fdd*r*s - D1**2*K*b1**2*fdd*s**2 - 2*D1**2*K*b1*f*fd*r**2 - 4*D1**2*K*b1*f*fd*r*s + 2*D1**2*K*b1*f*fd*r - 2*D1**2*K*b1*f*fd*s**2 + 2*D1**2*K*b1*f*fd*s - D1**2*K*b1*f*fd - 2*D1**2*K*bd1**2*f*(r + s - 1)**2 - 4*D1**2*b1*f*fd*r**2 - 8*D1**2*b1*f*fd*r*s + 4*D1**2*b1*f*fd*r - 4*D1**2*b1*f*fd*s**2 + 4*D1**2*b1*f*fd*s - 2*D1**2*b1*f*fd + 2*D1**2*b1*f*fdd*r**2 + 4*D1**2*b1*f*fdd*r*s - 2*D1**2*b1*f*fdd*r + 2*D1**2*b1*f*fdd*s**2 - 2*D1**2*b1*f*fdd*s + D1**2*b1*f*fdd - 4*D1**2*b1*f*gd2*r**2 - 8*D1**2*b1*f*gd2*r*s + 8*D1**2*b1*f*gd2*r - 4*D1**2*b1*f*gd2*s**2 + 8*D1**2*b1*f*gd2*s - 4*D1**2*b1*f*gd2 + 2*D1**2*b1*f*gdd2*r**2 + 4*D1**2*b1*f*gdd2*r*s - 4*D1**2*b1*f*gdd2*r + 2*D1**2*b1*f*gdd2*s**2 - 4*D1**2*b1*f*gdd2*s + 2*D1**2*b1*f*gdd2 + 2*D1**2*b1*fd**2*r**2 + 4*D1**2*b1*fd**2*r*s - 2*D1**2*b1*fd**2*r + 2*D1**2*b1*fd**2*s**2 - 2*D1**2*b1*fd**2*s - 4*D1**2*b1*fd*g2*r**2 - 8*D1**2*b1*fd*g2*r*s - 4*D1**2*b1*fd*g2*s**2 + 4*D1**2*b1*fd*gd2*r**2 + 8*D1**2*b1*fd*gd2*r*s - 4*D1**2*b1*fd*gd2*r + 4*D1**2*b1*fd*gd2*s**2 - 4*D1**2*b1*fd*gd2*s + 2*D1**2*b1*fdd*g2*r**2 + 4*D1**2*b1*fdd*g2*r*s + 2*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(2*C*f + 2*K*b1 - f - 2*g2) + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd + 2*D1**2*f**2*gd2*r**2 + 4*D1**2*f**2*gd2*r*s - 4*D1**2*f**2*gd2*r + 2*D1**2*f**2*gd2*s**2 - 4*D1**2*f**2*gd2*s + 2*D1**2*f**2*gd2 + 4*D1**2*f*fd*g2*r**2 + 8*D1**2*f*fd*g2*r*s - 4*D1**2*f*fd*g2*r + 4*D1**2*f*fd*g2*s**2 - 4*D1**2*f*fd*g2*s + 2*D1**2*f*fd*g2 + 8*D1*Dd*K*b1**2*f*r**2 + 16*D1*Dd*K*b1**2*f*r*s - 12*D1*Dd*K*b1**2*f*r + 8*D1*Dd*K*b1**2*f*s**2 - 12*D1*Dd*K*b1**2*f*s + 6*D1*Dd*K*b1**2*f - 8*D1*Dd*K*b1**2*fd*r**2 - 16*D1*Dd*K*b1**2*fd*r*s + 6*D1*Dd*K*b1**2*fd*r - 8*D1*Dd*K*b1**2*fd*s**2 + 6*D1*Dd*K*b1**2*fd*s - 4*D1*Dd*K*b1*f**2*r**2 - 8*D1*Dd*K*b1*f**2*r*s + 6*D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s**2 + 6*D1*Dd*K*b1*f**2*s - 3*D1*Dd*K*b1*f**2 - 8*D1*Dd*b1*f**2*r**2 - 16*D1*Dd*b1*f**2*r*s + 12*D1*Dd*b1*f**2*r - 8*D1*Dd*b1*f**2*s**2 + 12*D1*Dd*b1*f**2*s - 6*D1*Dd*b1*f**2 + 16*D1*Dd*b1*f*fd*r**2 + 32*D1*Dd*b1*f*fd*r*s - 20*D1*Dd*b1*f*fd*r + 16*D1*Dd*b1*f*fd*s**2 - 20*D1*Dd*b1*f*fd*s + 6*D1*Dd*b1*f*fd - 16*D1*Dd*b1*f*g2*r**2 - 32*D1*Dd*b1*f*g2*r*s + 24*D1*Dd*b1*f*g2*r - 16*D1*Dd*b1*f*g2*s**2 + 24*D1*Dd*b1*f*g2*s - 12*D1*Dd*b1*f*g2 + 16*D1*Dd*b1*f*gd2*r**2 + 32*D1*Dd*b1*f*gd2*r*s - 28*D1*Dd*b1*f*gd2*r + 16*D1*Dd*b1*f*gd2*s**2 - 28*D1*Dd*b1*f*gd2*s + 12*D1*Dd*b1*f*gd2 + 16*D1*Dd*b1*fd*g2*r**2 + 32*D1*Dd*b1*fd*g2*r*s - 12*D1*Dd*b1*fd*g2*r + 16*D1*Dd*b1*fd*g2*s**2 - 12*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 8*D1*Dd*f**2*g2*r**2 + 16*D1*Dd*f**2*g2*r*s - 12*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s**2 - 12*D1*Dd*f**2*g2*s + 6*D1*Dd*f**2*g2 - 4*D1*Ddd*K*b1**2*f*r**2 - 8*D1*Ddd*K*b1**2*f*r*s + 6*D1*Ddd*K*b1**2*f*r - 4*D1*Ddd*K*b1**2*f*s**2 + 6*D1*Ddd*K*b1**2*f*s - 3*D1*Ddd*K*b1**2*f + 4*D1*Ddd*b1*f**2*r**2 + 8*D1*Ddd*b1*f**2*r*s - 6*D1*Ddd*b1*f**2*r + 4*D1*Ddd*b1*f**2*s**2 - 6*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 8*D1*Ddd*b1*f*g2*r**2 + 16*D1*Ddd*b1*f*g2*r*s - 12*D1*Ddd*b1*f*g2*r + 8*D1*Ddd*b1*f*g2*s**2 - 12*D1*Ddd*b1*f*g2*s + 6*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(4*C - K - 2)*(r + s - 1) - f*fd*(4*C - 2)*(2*r + 2*s - 1) - 4*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 4*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(2*K*b1 + f*(2*C - 1) - 2*g2))*(r + s - 1) - 12*Dd**2*K*b1**2*f*r**2 - 24*Dd**2*K*b1**2*f*r*s + 18*Dd**2*K*b1**2*f*r - 12*Dd**2*K*b1**2*f*s**2 + 18*Dd**2*K*b1**2*f*s - 6*Dd**2*K*b1**2*f + 12*Dd**2*b1*f**2*r**2 + 24*Dd**2*b1*f**2*r*s - 18*Dd**2*b1*f**2*r + 12*Dd**2*b1*f**2*s**2 - 18*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 24*Dd**2*b1*f*g2*r**2 + 48*Dd**2*b1*f*g2*r*s - 36*Dd**2*b1*f*g2*r + 24*Dd**2*b1*f*g2*s**2 - 36*Dd**2*b1*f*g2*s + 12*Dd**2*b1*f*g2)/(7*d**2*k3**7) + D1**2*Pk2*Pkd3*ct**2*k2**4*st**2*(-352*C*D1**2*bd1*f**2*r**2 - 880*C*D1**2*bd1*f**2*r*s + 2200*C*D1**2*bd1*f**2*r - 528*C*D1**2*bd1*f**2*s**2 + 2376*C*D1**2*bd1*f**2*s - 1188*C*D1**2*bd1*f**2 + 1056*C*D1**2*bd1*f*fd*r**2 + 2112*C*D1**2*bd1*f*fd*r*s - 2244*C*D1**2*bd1*f*fd*r + 1056*C*D1**2*bd1*f*fd*s**2 - 2244*C*D1**2*bd1*f*fd*s + 1188*C*D1**2*bd1*f*fd + 264*C*D1**2*bdd1*f**2*r**2 + 528*C*D1**2*bdd1*f**2*r*s - 1188*C*D1**2*bdd1*f**2*r + 264*C*D1**2*bdd1*f**2*s**2 - 1188*C*D1**2*bdd1*f**2*s + 594*C*D1**2*bdd1*f**2 + 828*C*D1**2*f**2*fd*r**2 + 432*C*D1**2*f**2*fd*r*s - 696*C*D1**2*f**2*fd*r - 396*C*D1**2*f**2*fd*s**2 + 120*C*D1**2*f**2*fd*s + 144*C*D1**2*f**2*fd + 1566*C*D1**2*f**2*fdd*r**2 + 3348*C*D1**2*f**2*fdd*r*s - 2160*C*D1**2*f**2*fdd*r + 1782*C*D1**2*f**2*fdd*s**2 - 2304*C*D1**2*f**2*fdd*s + 1116*C*D1**2*f**2*fdd + 3132*C*D1**2*f*fd**2*r**2 + 6696*C*D1**2*f*fd**2*r*s - 4320*C*D1**2*f*fd**2*r + 3564*C*D1**2*f*fd**2*s**2 - 4608*C*D1**2*f*fd**2*s + 1116*C*D1**2*f*fd**2 + 2112*C*D1*Dd*bd1*f**2*r**2 + 4224*C*D1*Dd*bd1*f**2*r*s - 6336*C*D1*Dd*bd1*f**2*r + 2112*C*D1*Dd*bd1*f**2*s**2 - 6336*C*D1*Dd*bd1*f**2*s + 3564*C*D1*Dd*bd1*f**2 + 1104*C*D1*Dd*f**3*r**2 + 576*C*D1*Dd*f**3*r*s - 1248*C*D1*Dd*f**3*r - 528*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 420*C*D1*Dd*f**3 + 12528*C*D1*Dd*f**2*fd*r**2 + 26784*C*D1*Dd*f**2*fd*r*s - 18252*C*D1*Dd*f**2*fd*r + 14256*C*D1*Dd*f**2*fd*s**2 - 19476*C*D1*Dd*f**2*fd*s + 6624*C*D1*Dd*f**2*fd + 2088*C*D1*Ddd*f**3*r**2 + 4464*C*D1*Ddd*f**3*r*s - 3204*C*D1*Ddd*f**3*r + 2376*C*D1*Ddd*f**3*s**2 - 3420*C*D1*Ddd*f**3*s + 1638*C*D1*Ddd*f**3 + 6264*C*Dd**2*f**3*r**2 + 13392*C*Dd**2*f**3*r*s - 9612*C*Dd**2*f**3*r + 7128*C*Dd**2*f**3*s**2 - 10260*C*Dd**2*f**3*s + 3276*C*Dd**2*f**3 + 264*D1**2*K*bd1**2*f*r**2 + 528*D1**2*K*bd1**2*f*r*s - 858*D1**2*K*bd1**2*f*r + 264*D1**2*K*bd1**2*f*s**2 - 858*D1**2*K*bd1**2*f*s + 594*D1**2*K*bd1**2*f + 198*D1**2*K*bd1*f**2*r**2 + 132*D1**2*K*bd1*f**2*r*s - 396*D1**2*K*bd1*f**2*r - 66*D1**2*K*bd1*f**2*s**2 - 132*D1**2*K*bd1*f**2*s + 198*D1**2*K*bd1*f**2 + 660*D1**2*K*bd1*f*fd*r**2 + 1848*D1**2*K*bd1*f*fd*r*s - 1122*D1**2*K*bd1*f*fd*r + 1188*D1**2*K*bd1*f*fd*s**2 - 1518*D1**2*K*bd1*f*fd*s + 462*D1**2*K*bd1*f*fd + 165*D1**2*K*bdd1*f**2*r**2 + 462*D1**2*K*bdd1*f**2*r*s - 330*D1**2*K*bdd1*f**2*r + 297*D1**2*K*bdd1*f**2*s**2 - 462*D1**2*K*bdd1*f**2*s + 165*D1**2*K*bdd1*f**2 - 132*D1**2*bd1**2*f**2*r**2 - 132*D1**2*bd1**2*f**2*r*s + 198*D1**2*bd1**2*f**2*r + 66*D1**2*bd1**2*f**2*s - 66*D1**2*bd1**2*f**2 - 132*D1**2*bd1**2*f*r**2 - 132*D1**2*bd1**2*f*r*s + 198*D1**2*bd1**2*f*r + 66*D1**2*bd1**2*f*s - 66*D1**2*bd1**2*f + 330*D1**2*bd1*bd2*f*r**2 + 660*D1**2*bd1*bd2*f*r*s - 660*D1**2*bd1*bd2*f*r + 330*D1**2*bd1*bd2*f*s**2 - 660*D1**2*bd1*bd2*f*s + 330*D1**2*bd1*bd2*f + 198*D1**2*bd1*f**2*r**2 + 462*D1**2*bd1*f**2*r*s - 1056*D1**2*bd1*f**2*r + 264*D1**2*bd1*f**2*s**2 - 1122*D1**2*bd1*f**2*s + 528*D1**2*bd1*f**2 - 792*D1**2*bd1*f*fd*r**2 - 1320*D1**2*bd1*f*fd*r*s + 1386*D1**2*bd1*f*fd*r - 528*D1**2*bd1*f*fd*s**2 + 1188*D1**2*bd1*f*fd*s - 660*D1**2*bd1*f*fd + 528*D1**2*bd1*f*g2*r**2 + 1056*D1**2*bd1*f*g2*r*s - 2376*D1**2*bd1*f*g2*r + 528*D1**2*bd1*f*g2*s**2 - 2376*D1**2*bd1*f*g2*s + 1188*D1**2*bd1*f*g2 - 528*D1**2*bd1*f*gd2*r**2 - 1056*D1**2*bd1*f*gd2*r*s + 1716*D1**2*bd1*f*gd2*r - 528*D1**2*bd1*f*gd2*s**2 + 1716*D1**2*bd1*f*gd2*s - 1188*D1**2*bd1*f*gd2 - 528*D1**2*bd1*fd*g2*r**2 - 1056*D1**2*bd1*fd*g2*r*s + 528*D1**2*bd1*fd*g2*r - 528*D1**2*bd1*fd*g2*s**2 + 528*D1**2*bd1*fd*g2*s + 165*D1**2*bd2*f**2*r**2 + 330*D1**2*bd2*f**2*r*s - 330*D1**2*bd2*f**2*r + 165*D1**2*bd2*f**2*s**2 - 330*D1**2*bd2*f**2*s + 165*D1**2*bd2*f**2 - 198*D1**2*bdd1*f**2*r**2 - 330*D1**2*bdd1*f**2*r*s + 660*D1**2*bdd1*f**2*r - 132*D1**2*bdd1*f**2*s**2 + 594*D1**2*bdd1*f**2*s - 297*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r**2 - 528*D1**2*bdd1*f*g2*r*s + 1188*D1**2*bdd1*f*g2*r - 264*D1**2*bdd1*f*g2*s**2 + 1188*D1**2*bdd1*f*g2*s - 594*D1**2*bdd1*f*g2 - 612*D1**2*f**2*fd*r**2 - 414*D1**2*f**2*fd*r*s + 546*D1**2*f**2*fd*r + 198*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 138*D1**2*f**2*fd - 783*D1**2*f**2*fdd*r**2 - 1674*D1**2*f**2*fdd*r*s + 1080*D1**2*f**2*fdd*r - 891*D1**2*f**2*fdd*s**2 + 1152*D1**2*f**2*fdd*s - 558*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r + 132*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 - 330*D1**2*f**2*gdd2*r**2 - 924*D1**2*f**2*gdd2*r*s + 660*D1**2*f**2*gdd2*r - 594*D1**2*f**2*gdd2*s**2 + 924*D1**2*f**2*gdd2*s - 330*D1**2*f**2*gdd2 - 1566*D1**2*f*fd**2*r**2 - 3348*D1**2*f*fd**2*r*s + 2160*D1**2*f*fd**2*r - 1782*D1**2*f*fd**2*s**2 + 2304*D1**2*f*fd**2*s - 558*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r**2 - 3696*D1**2*f*fd*gd2*r*s + 2244*D1**2*f*fd*gd2*r - 2376*D1**2*f*fd*gd2*s**2 + 3036*D1**2*f*fd*gd2*s - 924*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r**2 - 1848*D1**2*f*fdd*g2*r*s + 924*D1**2*f*fdd*g2*r - 1188*D1**2*f*fdd*g2*s**2 + 1188*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r**2 - 1848*D1**2*fd**2*g2*r*s + 924*D1**2*fd**2*g2*r - 1188*D1**2*fd**2*g2*s**2 + 1188*D1**2*fd**2*g2*s + 1320*D1*Dd*K*bd1*f**2*r**2 + 3696*D1*Dd*K*bd1*f**2*r*s - 2442*D1*Dd*K*bd1*f**2*r + 2376*D1*Dd*K*bd1*f**2*s**2 - 3366*D1*Dd*K*bd1*f**2*s + 1122*D1*Dd*K*bd1*f**2 - 1584*D1*Dd*bd1*f**2*r**2 - 2640*D1*Dd*bd1*f**2*r*s + 3762*D1*Dd*bd1*f**2*r - 1056*D1*Dd*bd1*f**2*s**2 + 3300*D1*Dd*bd1*f**2*s - 1914*D1*Dd*bd1*f**2 - 2112*D1*Dd*bd1*f*g2*r**2 - 4224*D1*Dd*bd1*f*g2*r*s + 6336*D1*Dd*bd1*f*g2*r - 2112*D1*Dd*bd1*f*g2*s**2 + 6336*D1*Dd*bd1*f*g2*s - 3564*D1*Dd*bd1*f*g2 - 816*D1*Dd*f**3*r**2 - 552*D1*Dd*f**3*r*s + 954*D1*Dd*f**3*r + 264*D1*Dd*f**3*s**2 + 144*D1*Dd*f**3*s - 342*D1*Dd*f**3 - 6264*D1*Dd*f**2*fd*r**2 - 13392*D1*Dd*f**2*fd*r*s + 9126*D1*Dd*f**2*fd*r - 7128*D1*Dd*f**2*fd*s**2 + 9738*D1*Dd*f**2*fd*s - 3312*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s + 1848*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 + 264*D1*Dd*f**2*g2*s - 660*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r**2 - 7392*D1*Dd*f**2*gd2*r*s + 4884*D1*Dd*f**2*gd2*r - 4752*D1*Dd*f**2*gd2*s**2 + 6732*D1*Dd*f**2*gd2*s - 2244*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r**2 - 14784*D1*Dd*f*fd*g2*r*s + 8184*D1*Dd*f*fd*g2*r - 9504*D1*Dd*f*fd*g2*s**2 + 10824*D1*Dd*f*fd*g2*s - 3036*D1*Dd*f*fd*g2 - 1044*D1*Ddd*f**3*r**2 - 2232*D1*Ddd*f**3*r*s + 1602*D1*Ddd*f**3*r - 1188*D1*Ddd*f**3*s**2 + 1710*D1*Ddd*f**3*s - 819*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r**2 - 3696*D1*Ddd*f**2*g2*r*s + 2244*D1*Ddd*f**2*g2*r - 2376*D1*Ddd*f**2*g2*s**2 + 3036*D1*Ddd*f**2*g2*s - 1254*D1*Ddd*f**2*g2 - 165*D1*b2*(2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 3132*Dd**2*f**3*r**2 - 6696*Dd**2*f**3*r*s + 4806*Dd**2*f**3*r - 3564*Dd**2*f**3*s**2 + 5130*Dd**2*f**3*s - 1638*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r**2 - 11088*Dd**2*f**2*g2*r*s + 6732*Dd**2*f**2*g2*r - 7128*Dd**2*f**2*g2*s**2 + 9108*Dd**2*f**2*g2*s - 2508*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(-2*K*fd*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-4*r**2 - 4*r*(s - 1) + 2*s) + 4*fd*r*(r + s) + fdd*(K*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) - 2*r*(r + s))) + 2*D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(K*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + 2*Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 11*b1*(-64*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s - 56*C*D1**2*f*fd*r - 96*C*D1**2*f*fd*s**2 - 40*C*D1**2*f*fd*s + 28*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r**2 + 96*C*D1**2*f*fdd*r*s + 12*C*D1**2*f*fdd*r + 48*C*D1**2*f*fdd*s**2 + 12*C*D1**2*f*fdd*s - 6*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r**2 + 96*C*D1**2*fd**2*r*s + 12*C*D1**2*fd**2*r + 48*C*D1**2*fd**2*s**2 + 12*C*D1**2*fd**2*s - 60*C*D1**2*fd**2 - 128*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 208*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 256*C*D1*Dd*f**2*s - 112*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r**2 + 768*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 384*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s - 36*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 + 192*C*D1*Ddd*f**2*r*s - 144*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r**2 + 576*C*Dd**2*f**2*r*s - 432*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 144*C*Dd**2*f**2 + 24*D1**2*K*bdd1*f*r**2 + 48*D1**2*K*bdd1*f*r*s - 78*D1**2*K*bdd1*f*r + 24*D1**2*K*bdd1*f*s**2 - 78*D1**2*K*bdd1*f*s + 39*D1**2*K*bdd1*f + 36*D1**2*K*f*fd*r**2 + 24*D1**2*K*f*fd*r*s - 12*D1**2*K*f*fd*r - 12*D1**2*K*f*fd*s**2 + 12*D1**2*K*f*fd*s - 6*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 + 84*D1**2*K*f*fdd*r*s - 42*D1**2*K*f*fdd*r + 54*D1**2*K*f*fdd*s**2 - 54*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 + 84*D1**2*K*fd**2*r*s - 42*D1**2*K*fd**2*r + 54*D1**2*K*fd**2*s**2 - 54*D1**2*K*fd**2*s - 30*D1**2*b2*fd*r**2 - 60*D1**2*b2*fd*r*s - 30*D1**2*b2*fd*s**2 + 15*D1**2*b2*fdd*r**2 + 30*D1**2*b2*fdd*r*s + 15*D1**2*b2*fdd*s**2 - 12*D1**2*bdd1*f**2*r**2 - 12*D1**2*bdd1*f**2*r*s + 18*D1**2*bdd1*f**2*r + 6*D1**2*bdd1*f**2*s - 6*D1**2*bdd1*f**2 - 12*D1**2*bdd1*f*r**2 - 12*D1**2*bdd1*f*r*s + 18*D1**2*bdd1*f*r + 6*D1**2*bdd1*f*s - 6*D1**2*bdd1*f + 15*D1**2*bdd2*f*r**2 + 30*D1**2*bdd2*f*r*s - 30*D1**2*bdd2*f*r + 15*D1**2*bdd2*f*s**2 - 30*D1**2*bdd2*f*s + 15*D1**2*bdd2*f + 36*D1**2*f*fd*r**2 + 84*D1**2*f*fd*r*s + 18*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 6*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*r - 24*D1**2*f*fdd*s**2 - 3*D1**2*f*fdd + 48*D1**2*f*gd2*r**2 + 96*D1**2*f*gd2*r*s - 96*D1**2*f*gd2*r + 48*D1**2*f*gd2*s**2 - 96*D1**2*f*gd2*s + 48*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 6*D1**2*fd**2*r - 24*D1**2*fd**2*s**2 + 30*D1**2*fd**2 + 48*D1**2*fd*g2*r**2 + 96*D1**2*fd*g2*r*s + 120*D1**2*fd*g2*r + 48*D1**2*fd*g2*s**2 + 120*D1**2*fd*g2*s - 60*D1**2*fd*g2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s - 12*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 - 12*D1**2*fd*gd2*s + 60*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 60*D1**2*fdd*g2*r - 24*D1**2*fdd*g2*s**2 - 60*D1**2*fdd*g2*s + 30*D1**2*fdd*g2 + 72*D1*Dd*K*f**2*r**2 + 48*D1*Dd*K*f**2*r*s - 84*D1*Dd*K*f**2*r - 24*D1*Dd*K*f**2*s**2 - 12*D1*Dd*K*f**2*s + 30*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 + 672*D1*Dd*K*f*fd*r*s - 372*D1*Dd*K*f*fd*r + 432*D1*Dd*K*f*fd*s**2 - 492*D1*Dd*K*f*fd*s + 138*D1*Dd*K*f*fd - 120*D1*Dd*b2*f*r**2 - 240*D1*Dd*b2*f*r*s + 180*D1*Dd*b2*f*r - 120*D1*Dd*b2*f*s**2 + 180*D1*Dd*b2*f*s - 90*D1*Dd*b2*f + 120*D1*Dd*b2*fd*r**2 + 240*D1*Dd*b2*fd*r*s - 90*D1*Dd*b2*fd*r + 120*D1*Dd*b2*fd*s**2 - 90*D1*Dd*b2*fd*s + 72*D1*Dd*f**2*r**2 + 168*D1*Dd*f**2*r*s - 114*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 132*D1*Dd*f**2*s + 60*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 228*D1*Dd*f*fd*r - 192*D1*Dd*f*fd*s**2 + 168*D1*Dd*f*fd*s - 12*D1*Dd*f*fd + 192*D1*Dd*f*g2*r**2 + 384*D1*Dd*f*g2*r*s - 288*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 288*D1*Dd*f*g2*s + 144*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s - 96*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 - 96*D1*Dd*fd*g2*s + 180*D1*Dd*fd*g2 + 60*D1*Ddd*K*f**2*r**2 + 168*D1*Ddd*K*f**2*r*s - 102*D1*Ddd*K*f**2*r + 108*D1*Ddd*K*f**2*s**2 - 138*D1*Ddd*K*f**2*s + 57*D1*Ddd*K*f**2 + 60*D1*Ddd*b2*f*r**2 + 120*D1*Ddd*b2*f*r*s - 90*D1*Ddd*b2*f*r + 60*D1*Ddd*b2*f*s**2 - 90*D1*Ddd*b2*f*s + 45*D1*Ddd*b2*f - 72*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 102*D1*Ddd*f**2*r - 48*D1*Ddd*f**2*s**2 + 84*D1*Ddd*f**2*s - 48*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(K*(8*r**2 + 16*r*s - 26*r + 8*s**2 - 26*s + 13) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(K*(8*r**2 + r*(16*s - 3) + 8*s**2 - 3*s - 5) - 4*r**2 + r*(3 - 4*s) + s)) + Dd*f*(K*(32*r**2 + 64*r*s - 76*r + 32*s**2 - 76*s + 39) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 30*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 180*Dd**2*K*f**2*r**2 + 504*Dd**2*K*f**2*r*s - 306*Dd**2*K*f**2*r + 324*Dd**2*K*f**2*s**2 - 414*Dd**2*K*f**2*s + 114*Dd**2*K*f**2 + 180*Dd**2*b2*f*r**2 + 360*Dd**2*b2*f*r*s - 270*Dd**2*b2*f*r + 180*Dd**2*b2*f*s**2 - 270*Dd**2*b2*f*s + 90*Dd**2*b2*f - 216*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 306*Dd**2*f**2*r - 144*Dd**2*f**2*s**2 + 252*Dd**2*f**2*s - 96*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(231*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**2*k2**4*(D1*(35*D1*b2*bd1*f*(r + s - 1)**2 + 10*D1*bd1**2*(r + s - 1)*(7*K*f*(r + s - 1) - f*(12*C - 6)*(r + s) + 14*g2*(r + s)) + 2*D1*bdd1*f*(f*(6*C - 3)*(7*r + 5*s - 5) - 35*g2*(r + s - 1))*(r + s - 1) - 2*bd1*(D1*(3*f**2*(2*C*(3*r**2 + 2*r*(s + 4) - s**2 + 12*s - 6) - r**2 - 10*r + s**2 - 12*s + 6) + f*(-fd*(12*C - 6)*(14*r**2 + 24*r*s - 19*r + 10*s**2 - 16*s + 6) + 7*g2*(r**2 + 2*r*(s - 6) + s**2 - 12*s + 6) + 70*gd2*(r + s - 1)**2) + 70*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(-f*(6*C - 3)*(28*r**2 + r*(48*s - 44) + 20*s**2 - 37*s + 17) + 35*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 35*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(35*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(120*C*(r + s - 1)**2 + 7*K*(r**2 + 2*r*(s + 5) + s**2 + 10*s - 5) - 74*r**2 - 2*r*(67*s - 60) - 60*(s - 1)**2) + 5*fdd*(-12*C*(r + s - 1)**2 + 7*K*s**2 + r**2*(7*K + 6) + 2*r*(7*K*s + 6*s - 6) + 6*s**2 - 12*s + 6) - 140*gd2*(r + s - 1)**2 + 70*gdd2*(r + s - 1)**2) + D1*(Dd*(f*(120*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 7*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 296*r**2 - 536*r*s + 430*r - 240*s**2 + 388*s - 208) - 10*fd*(4*r + 4*s - 3)*(12*C*(r + s - 1) - 7*K*s - r*(7*K + 6) - 6*s + 6) - 140*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*(K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(28*r + 28*s - 21)) + 5*Ddd*(f*(-12*C + 7*K + 6) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 30*Dd**2*(f*(-12*C + 7*K + 6) + 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - b1*(120*C*D1**2*bdd1*f*r**2 + 240*C*D1**2*bdd1*f*r*s - 120*C*D1**2*bdd1*f*r + 120*C*D1**2*bdd1*f*s**2 - 120*C*D1**2*bdd1*f*s + 60*C*D1**2*bdd1*f + 72*C*D1**2*f*fd*r**2 + 48*C*D1**2*f*fd*r*s - 192*C*D1**2*f*fd*r - 24*C*D1**2*f*fd*s**2 - 144*C*D1**2*f*fd*s + 96*C*D1**2*f*fd - 168*C*D1**2*f*fdd*r**2 - 288*C*D1**2*f*fdd*r*s + 168*C*D1**2*f*fdd*r - 120*C*D1**2*f*fdd*s**2 + 144*C*D1**2*f*fdd*s - 84*C*D1**2*f*fdd - 168*C*D1**2*fd**2*r**2 - 288*C*D1**2*fd**2*r*s + 168*C*D1**2*fd**2*r - 120*C*D1**2*fd**2*s**2 + 144*C*D1**2*fd**2*s + 144*C*D1*Dd*f**2*r**2 + 96*C*D1*Dd*f**2*r*s - 168*C*D1*Dd*f**2*r - 48*C*D1*Dd*f**2*s**2 - 24*C*D1*Dd*f**2*s + 60*C*D1*Dd*f**2 - 1344*C*D1*Dd*f*fd*r**2 - 2304*C*D1*Dd*f*fd*r*s + 1632*C*D1*Dd*f*fd*r - 960*C*D1*Dd*f*fd*s**2 + 1392*C*D1*Dd*f*fd*s - 480*C*D1*Dd*f*fd - 336*C*D1*Ddd*f**2*r**2 - 576*C*D1*Ddd*f**2*r*s + 480*C*D1*Ddd*f**2*r - 240*C*D1*Ddd*f**2*s**2 + 408*C*D1*Ddd*f**2*s - 228*C*D1*Ddd*f**2 - 1008*C*Dd**2*f**2*r**2 - 1728*C*Dd**2*f**2*r*s + 1440*C*Dd**2*f**2*r - 720*C*Dd**2*f**2*s**2 + 1224*C*Dd**2*f**2*s - 456*C*Dd**2*f**2 + 70*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 70*D1**2*K*bdd1*f*r**2 - 140*D1**2*K*bdd1*f*r*s + 140*D1**2*K*bdd1*f*r - 70*D1**2*K*bdd1*f*s**2 + 140*D1**2*K*bdd1*f*s - 70*D1**2*K*bdd1*f - 35*D1**2*b2*fd*r**2 - 70*D1**2*b2*fd*r*s - 35*D1**2*b2*fd*s**2 - 35*D1**2*bd2*f*(r + s - 1)**2 - 60*D1**2*bdd1*f*r**2 - 120*D1**2*bdd1*f*r*s + 60*D1**2*bdd1*f*r - 60*D1**2*bdd1*f*s**2 + 60*D1**2*bdd1*f*s - 30*D1**2*bdd1*f - 140*D1**2*bdd1*g2*r**2 - 280*D1**2*bdd1*g2*r*s + 140*D1**2*bdd1*g2*r - 140*D1**2*bdd1*g2*s**2 + 140*D1**2*bdd1*g2*s - 70*D1**2*bdd1*g2 - 12*D1**2*f*fd*r**2 + 72*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 + 60*D1**2*f*fd*s - 36*D1**2*f*fd + 84*D1**2*f*fdd*r**2 + 144*D1**2*f*fdd*r*s - 84*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 42*D1**2*f*fdd + 14*D1**2*f*gd2*r**2 + 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*r + 14*D1**2*f*gd2*s**2 - 28*D1**2*f*gd2*s + 14*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 140*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*r + 70*D1**2*f*gdd2*s**2 - 140*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 + 84*D1**2*fd**2*r**2 + 144*D1**2*fd**2*r*s - 84*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s + 14*D1**2*fd*g2*r**2 + 28*D1**2*fd*g2*r*s + 140*D1**2*fd*g2*r + 14*D1**2*fd*g2*s**2 + 140*D1**2*fd*g2*s - 70*D1**2*fd*g2 + 140*D1**2*fd*gd2*r**2 + 280*D1**2*fd*gd2*r*s - 140*D1**2*fd*gd2*r + 140*D1**2*fd*gd2*s**2 - 140*D1**2*fd*gd2*s + 70*D1**2*fdd*g2*r**2 + 140*D1**2*fdd*g2*r*s + 70*D1**2*fdd*g2*s**2 - 140*D1*Dd*b2*f*r**2 - 280*D1*Dd*b2*f*r*s + 210*D1*Dd*b2*f*r - 140*D1*Dd*b2*f*s**2 + 210*D1*Dd*b2*f*s - 105*D1*Dd*b2*f - 24*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 672*D1*Dd*f*fd*r**2 + 1152*D1*Dd*f*fd*r*s - 816*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 696*D1*Dd*f*fd*s + 240*D1*Dd*f*fd + 56*D1*Dd*f*g2*r**2 + 112*D1*Dd*f*g2*r*s - 84*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s**2 - 84*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 1120*D1*Dd*f*gd2*r*s - 980*D1*Dd*f*gd2*r + 560*D1*Dd*f*gd2*s**2 - 980*D1*Dd*f*gd2*s + 420*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 1120*D1*Dd*fd*g2*r*s - 420*D1*Dd*fd*g2*r + 560*D1*Dd*fd*g2*s**2 - 420*D1*Dd*fd*g2*s + 168*D1*Ddd*f**2*r**2 + 288*D1*Ddd*f**2*r*s - 240*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 204*D1*Ddd*f**2*s + 114*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 560*D1*Ddd*f*g2*r*s - 420*D1*Ddd*f*g2*r + 280*D1*Ddd*f*g2*s**2 - 420*D1*Ddd*f*g2*s + 210*D1*Ddd*f*g2 - D1*bd1*(D1*(f*(120*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(2*r**2 + 4*r*s - 14*r + 2*s**2 - 14*s + 7) - 148*r**2 - 268*r*s + 162*r - 120*s**2 + 134*s - 74) - 20*fd*(r + s - 1)*(6*C*(2*r + 2*s - 1) - 7*K*r - 7*K*s - 6*r - 6*s + 3) - 140*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 140*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 20*Dd*(f*(6*C*(2*r + 2*s - 1) - 7*K*(r + s - 1) - 6*r - 6*s + 3) - 7*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 504*Dd**2*f**2*r**2 + 864*Dd**2*f**2*r*s - 720*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 612*Dd**2*f**2*s + 228*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 1680*Dd**2*f*g2*r*s - 1260*Dd**2*f*g2*r + 840*Dd**2*f*g2*s**2 - 1260*Dd**2*f*g2*s + 420*Dd**2*f*g2))/(21*d**2*k3**5) + D1**2*Pk2*Pkd3*ct**2*k2**2*st**2*(330*C*D1**2*bdd1*f**2*r**2 + 396*C*D1**2*bdd1*f**2*r*s + 66*C*D1**2*bdd1*f**2*s**2 + 954*C*D1**2*f**2*fd*r**2 + 3132*C*D1**2*f**2*fd*r*s - 1680*C*D1**2*f**2*fd*r + 2178*C*D1**2*f**2*fd*s**2 - 2496*C*D1**2*f**2*fd*s + 1044*C*D1**2*f**2*fd - 1566*C*D1**2*f**2*fdd*r**2 - 3348*C*D1**2*f**2*fdd*r*s + 2160*C*D1**2*f**2*fdd*r - 1782*C*D1**2*f**2*fdd*s**2 + 2304*C*D1**2*f**2*fdd*s - 1116*C*D1**2*f**2*fdd - 3132*C*D1**2*f*fd**2*r**2 - 6696*C*D1**2*f*fd**2*r*s + 4320*C*D1**2*f*fd**2*r - 3564*C*D1**2*f*fd**2*s**2 + 4608*C*D1**2*f*fd**2*s - 1116*C*D1**2*f*fd**2 + 1272*C*D1*Dd*f**3*r**2 + 4176*C*D1*Dd*f**3*r*s - 2316*C*D1*Dd*f**3*r + 2904*C*D1*Dd*f**3*s**2 - 3540*C*D1*Dd*f**3*s + 1362*C*D1*Dd*f**3 - 12528*C*D1*Dd*f**2*fd*r**2 - 26784*C*D1*Dd*f**2*fd*r*s + 18252*C*D1*Dd*f**2*fd*r - 14256*C*D1*Dd*f**2*fd*s**2 + 19476*C*D1*Dd*f**2*fd*s - 6624*C*D1*Dd*f**2*fd - 2088*C*D1*Ddd*f**3*r**2 - 4464*C*D1*Ddd*f**3*r*s + 3204*C*D1*Ddd*f**3*r - 2376*C*D1*Ddd*f**3*s**2 + 3420*C*D1*Ddd*f**3*s - 1638*C*D1*Ddd*f**3 - 6264*C*Dd**2*f**3*r**2 - 13392*C*Dd**2*f**3*r*s + 9612*C*Dd**2*f**3*r - 7128*C*Dd**2*f**3*s**2 + 10260*C*Dd**2*f**3*s - 3276*C*Dd**2*f**3 - 165*D1**2*K*bdd1*f**2*r**2 - 462*D1**2*K*bdd1*f**2*r*s + 330*D1**2*K*bdd1*f**2*r - 297*D1**2*K*bdd1*f**2*s**2 + 462*D1**2*K*bdd1*f**2*s - 165*D1**2*K*bdd1*f**2 + 33*D1**2*b2*bdd1*f*r**2 + 66*D1**2*b2*bdd1*f*r*s + 33*D1**2*b2*bdd1*f*s**2 + 198*D1**2*b2*f*fd*r**2 + 924*D1**2*b2*f*fd*r*s - 462*D1**2*b2*f*fd*r + 726*D1**2*b2*f*fd*s**2 - 726*D1**2*b2*f*fd*s + 363*D1**2*b2*f*fd - 330*D1**2*b2*f*fdd*r**2 - 924*D1**2*b2*f*fdd*r*s + 462*D1**2*b2*f*fdd*r - 594*D1**2*b2*f*fdd*s**2 + 594*D1**2*b2*f*fdd*s - 297*D1**2*b2*f*fdd - 330*D1**2*b2*fd**2*r**2 - 924*D1**2*b2*fd**2*r*s + 462*D1**2*b2*fd**2*r - 594*D1**2*b2*fd**2*s**2 + 594*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*f*(-5*K*r**2 - 6*K*r*s + 5*K*r - K*s**2 + 3*K*s + f*(r - 1) + r - 1) - 165*D1**2*bdd1*f**2*r**2 - 198*D1**2*bdd1*f**2*r*s - 66*D1**2*bdd1*f**2*r - 33*D1**2*bdd1*f**2*s**2 - 330*D1**2*bdd1*f*g2*r**2 - 396*D1**2*bdd1*f*g2*r*s - 66*D1**2*bdd1*f*g2*s**2 - 33*D1**2*bdd2*f**2*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) - 279*D1**2*f**2*fd*r**2 - 1368*D1**2*f**2*fd*r*s + 642*D1**2*f**2*fd*r - 1089*D1**2*f**2*fd*s**2 + 1182*D1**2*f**2*fd*s - 456*D1**2*f**2*fd + 783*D1**2*f**2*fdd*r**2 + 1674*D1**2*f**2*fdd*r*s - 1080*D1**2*f**2*fdd*r + 891*D1**2*f**2*fdd*s**2 - 1152*D1**2*f**2*fdd*s + 558*D1**2*f**2*fdd - 198*D1**2*f**2*gd2*r**2 - 924*D1**2*f**2*gd2*r*s + 396*D1**2*f**2*gd2*r - 726*D1**2*f**2*gd2*s**2 + 924*D1**2*f**2*gd2*s - 198*D1**2*f**2*gd2 + 330*D1**2*f**2*gdd2*r**2 + 924*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*r + 594*D1**2*f**2*gdd2*s**2 - 924*D1**2*f**2*gdd2*s + 330*D1**2*f**2*gdd2 + 1566*D1**2*f*fd**2*r**2 + 3348*D1**2*f*fd**2*r*s - 2160*D1**2*f*fd**2*r + 1782*D1**2*f*fd**2*s**2 - 2304*D1**2*f*fd**2*s + 558*D1**2*f*fd**2 - 396*D1**2*f*fd*g2*r**2 - 1848*D1**2*f*fd*g2*r*s + 924*D1**2*f*fd*g2*r - 1452*D1**2*f*fd*g2*s**2 + 1452*D1**2*f*fd*g2*s - 726*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*r**2 + 3696*D1**2*f*fd*gd2*r*s - 2244*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 3036*D1**2*f*fd*gd2*s + 924*D1**2*f*fd*gd2 + 660*D1**2*f*fdd*g2*r**2 + 1848*D1**2*f*fdd*g2*r*s - 924*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*r**2 + 1848*D1**2*fd**2*g2*r*s - 924*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 396*D1*Dd*b2*f**2*r**2 + 1848*D1*Dd*b2*f**2*r*s - 858*D1*Dd*b2*f**2*r + 1452*D1*Dd*b2*f**2*s**2 - 1650*D1*Dd*b2*f**2*s + 561*D1*Dd*b2*f**2 - 2640*D1*Dd*b2*f*fd*r**2 - 7392*D1*Dd*b2*f*fd*r*s + 4092*D1*Dd*b2*f*fd*r - 4752*D1*Dd*b2*f*fd*s**2 + 5412*D1*Dd*b2*f*fd*s - 1518*D1*Dd*b2*f*fd - 372*D1*Dd*f**3*r**2 - 1824*D1*Dd*f**3*r*s + 828*D1*Dd*f**3*r - 1452*D1*Dd*f**3*s**2 + 1638*D1*Dd*f**3*s - 549*D1*Dd*f**3 + 6264*D1*Dd*f**2*fd*r**2 + 13392*D1*Dd*f**2*fd*r*s - 9126*D1*Dd*f**2*fd*r + 7128*D1*Dd*f**2*fd*s**2 - 9738*D1*Dd*f**2*fd*s + 3312*D1*Dd*f**2*fd - 792*D1*Dd*f**2*g2*r**2 - 3696*D1*Dd*f**2*g2*r*s + 1716*D1*Dd*f**2*g2*r - 2904*D1*Dd*f**2*g2*s**2 + 3300*D1*Dd*f**2*g2*s - 1122*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*r**2 + 7392*D1*Dd*f**2*gd2*r*s - 4884*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 6732*D1*Dd*f**2*gd2*s + 2244*D1*Dd*f**2*gd2 + 5280*D1*Dd*f*fd*g2*r**2 + 14784*D1*Dd*f*fd*g2*r*s - 8184*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 10824*D1*Dd*f*fd*g2*s + 3036*D1*Dd*f*fd*g2 - 660*D1*Ddd*b2*f**2*r**2 - 1848*D1*Ddd*b2*f**2*r*s + 1122*D1*Ddd*b2*f**2*r - 1188*D1*Ddd*b2*f**2*s**2 + 1518*D1*Ddd*b2*f**2*s - 627*D1*Ddd*b2*f**2 + 1044*D1*Ddd*f**3*r**2 + 2232*D1*Ddd*f**3*r*s - 1602*D1*Ddd*f**3*r + 1188*D1*Ddd*f**3*s**2 - 1710*D1*Ddd*f**3*s + 819*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*g2*r**2 + 3696*D1*Ddd*f**2*g2*r*s - 2244*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 3036*D1*Ddd*f**2*g2*s + 1254*D1*Ddd*f**2*g2 + 11*D1*bd1*(6*D1*b1*(f*(-K*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) + r*(f + 2)) + fd*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1)) + D1*(f**2*(3*K*(3*r**2 + 2*r*(7*s - 3) + 11*s**2 - 14*s + 3) + r**2*(28 - 44*C) + r*(s*(34 - 56*C) - 4) + s**2*(6 - 12*C) - 6*s + 6) - 6*f*(b2*r**2 + 2*b2*r*s + b2*s**2 + bd2*(-r**2 - 2*r*s + r - s**2 + s) + fd*(-4*C*s**2 + 8*C*s + K*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) + r**2*(10 - 20*C) + r*(-24*C*s + 16*C + 12*s - 7) + 2*s**2 - 4*s - 1) - 10*g2*r**2 - 12*g2*r*s - 2*g2*s**2 + 10*gd2*r**2 + 12*gd2*r*s - 10*gd2*r + 2*gd2*s**2 - 6*gd2*s) + 6*fd*(b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(5*r**2 + r*(6*s - 3) + s*(s - 1)))) - 6*Dd*b1*f*(-K*(40*r**2 + 48*r*s - 46*r + 8*s**2 - 26*s + 13) + f*(4*r - 2) + 4*r - 2) - 6*Dd*f*(b2*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s)) + f*(-8*C*s**2 + 14*C*s + K*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) + r**2*(20 - 40*C) + r*(-48*C*s + 26*C + 24*s - 9) + 4*s**2 - 7*s - 2) + 2*g2*(20*r**2 + r*(24*s - 13) + s*(4*s - 7)))) + 33*D1*bd2*f*(D1*(f*(3*r**2 + 14*r*s - 6*r + 11*s**2 - 14*s + 3) - 2*fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 23*s + 7)) - 2*Dd*f*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17)) - 1980*Dd**2*b2*f**2*r**2 - 5544*Dd**2*b2*f**2*r*s + 3366*Dd**2*b2*f**2*r - 3564*Dd**2*b2*f**2*s**2 + 4554*Dd**2*b2*f**2*s - 1254*Dd**2*b2*f**2 + 3132*Dd**2*f**3*r**2 + 6696*Dd**2*f**3*r*s - 4806*Dd**2*f**3*r + 3564*Dd**2*f**3*s**2 - 5130*Dd**2*f**3*s + 1638*Dd**2*f**3 + 3960*Dd**2*f**2*g2*r**2 + 11088*Dd**2*f**2*g2*r*s - 6732*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 9108*Dd**2*f**2*g2*s + 2508*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(2*fd**2*(r - 1) - 2*fd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(f + 2)) + fdd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(2*f + 2))) + D1*(2*Dd*(-K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11) + fd*(K*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + f*(4*r - 2) + 4*r - 2)) + Ddd*K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11)) + 2*Dd**2*K*f*(30*r**2 + r*(36*s - 39) + 6*s**2 - 21*s + 11)) - 11*b1*(88*C*D1**2*f*fd*r**2 + 112*C*D1**2*f*fd*r*s - 144*C*D1**2*f*fd*r + 24*C*D1**2*f*fd*s**2 - 80*C*D1**2*f*fd*s + 56*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r**2 - 72*C*D1**2*f*fdd*r*s + 96*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s**2 + 48*C*D1**2*f*fdd*s - 36*C*D1**2*f*fdd - 60*C*D1**2*fd**2*r**2 - 72*C*D1**2*fd**2*r*s + 96*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s**2 + 48*C*D1**2*fd**2*s - 36*C*D1**2*fd**2 + 176*C*D1*Dd*f**2*r**2 + 224*C*D1*Dd*f**2*r*s - 232*C*D1*Dd*f**2*r + 48*C*D1*Dd*f**2*s**2 - 136*C*D1*Dd*f**2*s + 100*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r**2 - 576*C*D1*Dd*f*fd*r*s + 696*C*D1*Dd*f*fd*r - 96*C*D1*Dd*f*fd*s**2 + 360*C*D1*Dd*f*fd*s - 240*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r**2 - 144*C*D1*Ddd*f**2*r*s + 156*C*D1*Ddd*f**2*r - 24*C*D1*Ddd*f**2*s**2 + 84*C*D1*Ddd*f**2*s - 66*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r**2 - 432*C*Dd**2*f**2*r*s + 468*C*Dd**2*f**2*r - 72*C*Dd**2*f**2*s**2 + 252*C*Dd**2*f**2*s - 132*C*Dd**2*f**2 - 30*D1**2*K*bdd1*f*r**2 - 36*D1**2*K*bdd1*f*r*s + 30*D1**2*K*bdd1*f*r - 6*D1**2*K*bdd1*f*s**2 + 18*D1**2*K*bdd1*f*s - 15*D1**2*K*bdd1*f - 18*D1**2*K*f*fd*r**2 - 84*D1**2*K*f*fd*r*s + 42*D1**2*K*f*fd*r - 66*D1**2*K*f*fd*s**2 + 66*D1**2*K*f*fd*s - 33*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 + 84*D1**2*K*f*fdd*r*s - 42*D1**2*K*f*fdd*r + 54*D1**2*K*f*fdd*s**2 - 54*D1**2*K*f*fdd*s + 27*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 + 84*D1**2*K*fd**2*r*s - 42*D1**2*K*fd**2*r + 54*D1**2*K*fd**2*s**2 - 54*D1**2*K*fd**2*s + 6*D1**2*b2*fd*r**2 + 12*D1**2*b2*fd*r*s - 12*D1**2*b2*fd*r + 6*D1**2*b2*fd*s**2 - 12*D1**2*b2*fd*s + 6*D1**2*b2*fd - 3*D1**2*b2*fdd*r**2 - 6*D1**2*b2*fdd*r*s + 6*D1**2*b2*fdd*r - 3*D1**2*b2*fdd*s**2 + 6*D1**2*b2*fdd*s - 3*D1**2*b2*fdd + 6*D1**2*bdd1*f**2*r + 6*D1**2*bdd1*f*r - 3*D1**2*bdd2*f*(r + s - 1)**2 - 56*D1**2*f*fd*r**2 - 68*D1**2*f*fd*r*s + 86*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 + 40*D1**2*f*fd*s - 28*D1**2*f*fd + 30*D1**2*f*fdd*r**2 + 36*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 24*D1**2*f*fdd*s + 18*D1**2*f*fdd - 60*D1**2*f*gd2*r**2 - 72*D1**2*f*gd2*r*s + 120*D1**2*f*gd2*r - 12*D1**2*f*gd2*s**2 + 72*D1**2*f*gd2*s - 60*D1**2*f*gd2 + 30*D1**2*f*gdd2*r**2 + 36*D1**2*f*gdd2*r*s - 60*D1**2*f*gdd2*r + 6*D1**2*f*gdd2*s**2 - 36*D1**2*f*gdd2*s + 30*D1**2*f*gdd2 + 30*D1**2*fd**2*r**2 + 36*D1**2*fd**2*r*s - 54*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 24*D1**2*fd**2*s + 24*D1**2*fd**2 - 60*D1**2*fd*g2*r**2 - 72*D1**2*fd*g2*r*s + 72*D1**2*fd*g2*r - 12*D1**2*fd*g2*s**2 + 24*D1**2*fd*g2*s - 12*D1**2*fd*g2 + 60*D1**2*fd*gd2*r**2 + 72*D1**2*fd*gd2*r*s - 96*D1**2*fd*gd2*r + 12*D1**2*fd*gd2*s**2 - 48*D1**2*fd*gd2*s + 36*D1**2*fd*gd2 + 30*D1**2*fdd*g2*r**2 + 36*D1**2*fdd*g2*r*s - 36*D1**2*fdd*g2*r + 6*D1**2*fdd*g2*s**2 - 12*D1**2*fdd*g2*s + 6*D1**2*fdd*g2 - 36*D1*Dd*K*f**2*r**2 - 168*D1*Dd*K*f**2*r*s + 78*D1*Dd*K*f**2*r - 132*D1*Dd*K*f**2*s**2 + 150*D1*Dd*K*f**2*s - 51*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 + 672*D1*Dd*K*f*fd*r*s - 372*D1*Dd*K*f*fd*r + 432*D1*Dd*K*f*fd*s**2 - 492*D1*Dd*K*f*fd*s + 138*D1*Dd*K*f*fd + 24*D1*Dd*b2*f*r**2 + 48*D1*Dd*b2*f*r*s - 36*D1*Dd*b2*f*r + 24*D1*Dd*b2*f*s**2 - 36*D1*Dd*b2*f*s + 18*D1*Dd*b2*f - 24*D1*Dd*b2*fd*r**2 - 48*D1*Dd*b2*fd*r*s + 42*D1*Dd*b2*fd*r - 24*D1*Dd*b2*fd*s**2 + 42*D1*Dd*b2*fd*s - 18*D1*Dd*b2*fd - 112*D1*Dd*f**2*r**2 - 136*D1*Dd*f**2*r*s + 146*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 + 80*D1*Dd*f**2*s - 62*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 288*D1*Dd*f*fd*r*s - 372*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 180*D1*Dd*f*fd*s + 132*D1*Dd*f*fd - 240*D1*Dd*f*g2*r**2 - 288*D1*Dd*f*g2*r*s + 312*D1*Dd*f*g2*r - 48*D1*Dd*f*g2*s**2 + 168*D1*Dd*f*g2*s - 132*D1*Dd*f*g2 + 240*D1*Dd*f*gd2*r**2 + 288*D1*Dd*f*gd2*r*s - 396*D1*Dd*f*gd2*r + 48*D1*Dd*f*gd2*s**2 - 228*D1*Dd*f*gd2*s + 156*D1*Dd*f*gd2 + 240*D1*Dd*fd*g2*r**2 + 288*D1*Dd*fd*g2*r*s - 300*D1*Dd*fd*g2*r + 48*D1*Dd*fd*g2*s**2 - 132*D1*Dd*fd*g2*s + 84*D1*Dd*fd*g2 + 60*D1*Ddd*K*f**2*r**2 + 168*D1*Ddd*K*f**2*r*s - 102*D1*Ddd*K*f**2*r + 108*D1*Ddd*K*f**2*s**2 - 138*D1*Ddd*K*f**2*s + 57*D1*Ddd*K*f**2 - 12*D1*Ddd*b2*f*r**2 - 24*D1*Ddd*b2*f*r*s + 18*D1*Ddd*b2*f*r - 12*D1*Ddd*b2*f*s**2 + 18*D1*Ddd*b2*f*s - 9*D1*Ddd*b2*f + 60*D1*Ddd*f**2*r**2 + 72*D1*Ddd*f**2*r*s - 78*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 42*D1*Ddd*f**2*s + 33*D1*Ddd*f**2 + 120*D1*Ddd*f*g2*r**2 + 144*D1*Ddd*f*g2*r*s - 156*D1*Ddd*f*g2*r + 24*D1*Ddd*f*g2*s**2 - 84*D1*Ddd*f*g2*s + 66*D1*Ddd*f*g2 + 6*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 180*Dd**2*K*f**2*r**2 + 504*Dd**2*K*f**2*r*s - 306*Dd**2*K*f**2*r + 324*Dd**2*K*f**2*s**2 - 414*Dd**2*K*f**2*s + 114*Dd**2*K*f**2 - 36*Dd**2*b2*f*r**2 - 72*Dd**2*b2*f*r*s + 54*Dd**2*b2*f*r - 36*Dd**2*b2*f*s**2 + 54*Dd**2*b2*f*s - 18*Dd**2*b2*f + 180*Dd**2*f**2*r**2 + 216*Dd**2*f**2*r*s - 234*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 126*Dd**2*f**2*s + 66*Dd**2*f**2 + 360*Dd**2*f*g2*r**2 + 432*Dd**2*f*g2*r*s - 468*Dd**2*f*g2*r + 72*Dd**2*f*g2*s**2 - 252*Dd**2*f*g2*s + 132*Dd**2*f*g2))/(231*d**2*k3**3) + D1**2*Pk2*Pkd3*ct**2*k2**2*(D1*(-2*D1*bd1**2*(f*(7*K*(4*r**2 + r*(4*s - 9) - 7*s + 5) + r**2*(54 - 76*C) - r*(68*C - 42)*(2*s - 1) - s*(60*C - 30)*(s - 1)) + 70*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*D1*bdd1*f*(-f*(2*C - 1)*(16*r**2 + 4*r*(4*s - 9) - 30*s + 15) + 7*g2*(4*r**2 + 2*r*(2*s - 5) - 10*s + 5)) + 7*b2*(2*D1*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 5*D1*bdd1*f*(r + s - 1)**2 + bd1*(D1*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 10*Dd*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + 2*bd1*(-35*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(2*C*(35*r**2 + 38*r*s - 30*r + 3*s**2 - 18*s + 9) - 35*r**2 - 38*r*s + 24*r - 3*s**2 + 18*s - 9) + f*(-fd*(4*C - 2)*(32*r**2 + r*(32*s - 42) - 23*s + 18) - 7*g2*(9*r**2 + 2*r*(5*s - 3) + s**2 - 6*s + 3) + 14*gd2*(4*r**2 + r*(4*s - 9) - 7*s + 5)) + 28*fd*g2*r*(2*r + 2*s - 1)) + 2*Dd*f*(-f*(2*C - 1)*(64*r**2 + 16*r*(4*s - 7) - 76*s + 51) + 7*g2*(16*r**2 + 2*r*(8*s - 15) - 24*s + 15)))) + 7*b1**3*(2*D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(2*Dd*(-20*K*r**2 - 40*K*r*s + 30*K*r - 20*K*s**2 + 30*K*s - 15*K + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 13*r + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) + Ddd*(5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 8*r**2 - 8*r*s + 10*r + 4*s - 4)) + 2*Dd**2*(15*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + b1**2*(-152*C*D1**2*fd*r**2 - 272*C*D1**2*fd*r*s + 304*C*D1**2*fd*r - 120*C*D1**2*fd*s**2 + 272*C*D1**2*fd*s - 152*C*D1**2*fd + 76*C*D1**2*fdd*r**2 + 136*C*D1**2*fdd*r*s - 152*C*D1**2*fdd*r + 60*C*D1**2*fdd*s**2 - 136*C*D1**2*fdd*s + 76*C*D1**2*fdd - 608*C*D1*Dd*f*r**2 - 1088*C*D1*Dd*f*r*s + 880*C*D1*Dd*f*r - 480*C*D1*Dd*f*s**2 + 784*C*D1*Dd*f*s - 424*C*D1*Dd*f + 608*C*D1*Dd*fd*r**2 + 1088*C*D1*Dd*fd*r*s - 1048*C*D1*Dd*fd*r + 480*C*D1*Dd*fd*s**2 - 936*C*D1*Dd*fd*s + 440*C*D1*Dd*fd + 304*C*D1*Ddd*f*r**2 + 544*C*D1*Ddd*f*r*s - 440*C*D1*Ddd*f*r + 240*C*D1*Ddd*f*s**2 - 392*C*D1*Ddd*f*s + 212*C*D1*Ddd*f + 912*C*Dd**2*f*r**2 + 1632*C*Dd**2*f*r*s - 1320*C*Dd**2*f*r + 720*C*Dd**2*f*s**2 - 1176*C*Dd**2*f*s + 424*C*Dd**2*f + 105*D1**2*K*bdd1*r**2 + 210*D1**2*K*bdd1*r*s - 140*D1**2*K*bdd1*r + 105*D1**2*K*bdd1*s**2 - 140*D1**2*K*bdd1*s + 70*D1**2*K*bdd1 + 63*D1**2*K*fd*r**2 + 70*D1**2*K*fd*r*s - 28*D1**2*K*fd*r + 7*D1**2*K*fd*s**2 + 28*D1**2*K*fd*s - 14*D1**2*K*fd - 28*D1**2*K*fdd*r**2 - 28*D1**2*K*fdd*r*s - 42*D1**2*K*fdd*r - 70*D1**2*K*fdd*s + 35*D1**2*K*fdd - 42*D1**2*bdd1*f*r**2 - 42*D1**2*bdd1*f*r*s + 42*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s - 14*D1**2*bdd1*f - 42*D1**2*bdd1*r**2 - 42*D1**2*bdd1*r*s + 42*D1**2*bdd1*r + 14*D1**2*bdd1*s - 14*D1**2*bdd1 + 7*D1**2*bdd2*r**2 + 14*D1**2*bdd2*r*s - 14*D1**2*bdd2*r + 7*D1**2*bdd2*s**2 - 14*D1**2*bdd2*s + 7*D1**2*bdd2 + 108*D1**2*fd*r**2 + 168*D1**2*fd*r*s - 202*D1**2*fd*r + 60*D1**2*fd*s**2 - 168*D1**2*fd*s + 108*D1**2*fd - 54*D1**2*fdd*r**2 - 84*D1**2*fdd*r*s + 108*D1**2*fdd*r - 30*D1**2*fdd*s**2 + 84*D1**2*fdd*s - 54*D1**2*fdd + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 + 252*D1*Dd*K*f*r**2 + 280*D1*Dd*K*f*r*s - 322*D1*Dd*K*f*r + 28*D1*Dd*K*f*s**2 - 154*D1*Dd*K*f*s + 133*D1*Dd*K*f - 224*D1*Dd*K*fd*r**2 - 224*D1*Dd*K*fd*r*s - 28*D1*Dd*K*fd*r - 224*D1*Dd*K*fd*s + 154*D1*Dd*K*fd - 56*D1*Dd*b2*r**2 - 112*D1*Dd*b2*r*s + 84*D1*Dd*b2*r - 56*D1*Dd*b2*s**2 + 84*D1*Dd*b2*s - 42*D1*Dd*b2 + 432*D1*Dd*f*r**2 + 672*D1*Dd*f*r*s - 600*D1*Dd*f*r + 240*D1*Dd*f*s**2 - 456*D1*Dd*f*s + 276*D1*Dd*f - 432*D1*Dd*fd*r**2 - 672*D1*Dd*fd*r*s + 732*D1*Dd*fd*r - 240*D1*Dd*fd*s**2 + 564*D1*Dd*fd*s - 300*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 - 112*D1*Ddd*K*f*r**2 - 112*D1*Ddd*K*f*r*s + 140*D1*Ddd*K*f*r + 56*D1*Ddd*K*f*s - 56*D1*Ddd*K*f + 28*D1*Ddd*b2*r**2 + 56*D1*Ddd*b2*r*s - 42*D1*Ddd*b2*r + 28*D1*Ddd*b2*s**2 - 42*D1*Ddd*b2*s + 21*D1*Ddd*b2 - 216*D1*Ddd*f*r**2 - 336*D1*Ddd*f*r*s + 300*D1*Ddd*f*r - 120*D1*Ddd*f*s**2 + 228*D1*Ddd*f*s - 138*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 14*D1*bd1*(D1*(-15*K*r**2 - 30*K*r*s + 20*K*r - 15*K*s**2 + 20*K*s - 10*K + f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 - 6*r*s + 9*r + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) + Dd*(5*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) - 24*r**2 - 24*r*s + 27*r + 10*s - 7)) - 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 336*Dd**2*K*f*r**2 - 336*Dd**2*K*f*r*s + 420*Dd**2*K*f*r + 168*Dd**2*K*f*s - 112*Dd**2*K*f + 84*Dd**2*b2*r**2 + 168*Dd**2*b2*r*s - 126*Dd**2*b2*r + 84*Dd**2*b2*s**2 - 126*Dd**2*b2*s + 42*Dd**2*b2 - 648*Dd**2*f*r**2 - 1008*Dd**2*f*r*s + 900*Dd**2*f*r - 360*Dd**2*f*s**2 + 684*Dd**2*f*s - 276*Dd**2*f - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) - b1*(-152*C*D1**2*bdd1*f*r**2 - 272*C*D1**2*bdd1*f*r*s + 136*C*D1**2*bdd1*f*r - 120*C*D1**2*bdd1*f*s**2 + 120*C*D1**2*bdd1*f*s - 60*C*D1**2*bdd1*f - 280*C*D1**2*f*fd*r**2 - 304*C*D1**2*f*fd*r*s + 312*C*D1**2*f*fd*r - 24*C*D1**2*f*fd*s**2 + 104*C*D1**2*f*fd*s - 116*C*D1**2*f*fd + 128*C*D1**2*f*fdd*r**2 + 128*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 56*C*D1**2*f*fdd*s + 4*C*D1**2*f*fdd + 128*C*D1**2*fd**2*r**2 + 128*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 56*C*D1**2*fd**2*s - 80*C*D1**2*fd**2 - 560*C*D1*Dd*f**2*r**2 - 608*C*D1*Dd*f**2*r*s + 712*C*D1*Dd*f**2*r - 48*C*D1*Dd*f**2*s**2 + 328*C*D1*Dd*f**2*s - 292*C*D1*Dd*f**2 + 1024*C*D1*Dd*f*fd*r**2 + 1024*C*D1*Dd*f*fd*r*s - 832*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s + 40*C*D1*Dd*f*fd + 256*C*D1*Ddd*f**2*r**2 + 256*C*D1*Ddd*f**2*r*s - 320*C*D1*Ddd*f**2*r - 128*C*D1*Ddd*f**2*s + 128*C*D1*Ddd*f**2 + 768*C*Dd**2*f**2*r**2 + 768*C*Dd**2*f**2*r*s - 960*C*Dd**2*f**2*r - 384*C*Dd**2*f**2*s + 256*C*Dd**2*f**2 + 56*D1**2*K*bdd1*f*r**2 + 56*D1**2*K*bdd1*f*r*s - 126*D1**2*K*bdd1*f*r - 98*D1**2*K*bdd1*f*s + 63*D1**2*K*bdd1*f + 14*D1**2*bd1**2*(-5*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*r**2 + 6*r*s - 6*r - 2*s + 1) - 28*D1**2*bd2*f*r**2 - 56*D1**2*bd2*f*r*s + 56*D1**2*bd2*f*r - 28*D1**2*bd2*f*s**2 + 56*D1**2*bd2*f*s - 28*D1**2*bd2*f + 70*D1**2*bd2*fd*r**2 + 140*D1**2*bd2*fd*r*s - 70*D1**2*bd2*fd*r + 70*D1**2*bd2*fd*s**2 - 70*D1**2*bd2*fd*s + 108*D1**2*bdd1*f*r**2 + 168*D1**2*bdd1*f*r*s - 84*D1**2*bdd1*f*r + 60*D1**2*bdd1*f*s**2 - 60*D1**2*bdd1*f*s + 30*D1**2*bdd1*f + 140*D1**2*bdd1*g2*r**2 + 280*D1**2*bdd1*g2*r*s - 140*D1**2*bdd1*g2*r + 140*D1**2*bdd1*g2*s**2 - 140*D1**2*bdd1*g2*s + 70*D1**2*bdd1*g2 + 35*D1**2*bdd2*f*r**2 + 70*D1**2*bdd2*f*r*s - 70*D1**2*bdd2*f*r + 35*D1**2*bdd2*f*s**2 - 70*D1**2*bdd2*f*s + 35*D1**2*bdd2*f + 140*D1**2*f*fd*r**2 + 152*D1**2*f*fd*r*s - 168*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 - 52*D1**2*f*fd*s + 58*D1**2*f*fd - 64*D1**2*f*fdd*r**2 - 64*D1**2*f*fdd*r*s + 24*D1**2*f*fdd*r - 28*D1**2*f*fdd*s - 2*D1**2*f*fdd + 126*D1**2*f*gd2*r**2 + 140*D1**2*f*gd2*r*s - 252*D1**2*f*gd2*r + 14*D1**2*f*gd2*s**2 - 140*D1**2*f*gd2*s + 126*D1**2*f*gd2 - 56*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 112*D1**2*f*gdd2*r + 56*D1**2*f*gdd2*s - 56*D1**2*f*gdd2 - 64*D1**2*fd**2*r**2 - 64*D1**2*fd**2*r*s + 24*D1**2*fd**2*r - 28*D1**2*fd**2*s + 40*D1**2*fd**2 + 126*D1**2*fd*g2*r**2 + 140*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 14*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 - 112*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 28*D1**2*fd*gd2*r - 84*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r - 140*D1**2*fdd*g2*s + 70*D1**2*fdd*g2 + 280*D1*Dd*bd2*f*r**2 + 560*D1*Dd*bd2*f*r*s - 490*D1*Dd*bd2*f*r + 280*D1*Dd*bd2*f*s**2 - 490*D1*Dd*bd2*f*s + 210*D1*Dd*bd2*f + 280*D1*Dd*f**2*r**2 + 304*D1*Dd*f**2*r*s - 356*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 164*D1*Dd*f**2*s + 146*D1*Dd*f**2 - 512*D1*Dd*f*fd*r**2 - 512*D1*Dd*f*fd*r*s + 416*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s - 20*D1*Dd*f*fd + 504*D1*Dd*f*g2*r**2 + 560*D1*Dd*f*g2*r*s - 644*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s**2 - 308*D1*Dd*f*g2*s + 266*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 728*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s - 280*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s - 56*D1*Dd*fd*g2*r - 448*D1*Dd*fd*g2*s + 308*D1*Dd*fd*g2 - 128*D1*Ddd*f**2*r**2 - 128*D1*Ddd*f**2*r*s + 160*D1*Ddd*f**2*r + 64*D1*Ddd*f**2*s - 64*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 280*D1*Ddd*f*g2*r + 112*D1*Ddd*f*g2*s - 112*D1*Ddd*f*g2 - 2*D1*bd1*(7*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f*(-4*C*(38*r**2 + 68*r*s - 34*r + 30*s**2 - 30*s + 15) + 7*K*(9*r**2 + 2*r*(5*s - 6) + s**2 - 8*s + 6) + 108*r**2 + 168*r*s - 91*r + 60*s**2 - 60*s + 30) + fd*(4*C*(38*r**2 + r*(68*s - 55) + 30*s**2 - 49*s + 17) - 7*K*(8*r**2 + 8*r*s - 3*r + 3*s - 3) - 108*r**2 - 168*r*s + 150*r - 60*s**2 + 114*s - 42) + 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 70*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + Dd*(f*(4*C*(152*r**2 + 2*r*(136*s - 89) + 120*s**2 - 158*s + 49) - 7*K*(32*r**2 + 8*r*(4*s - 7) - 36*s + 25) - 432*r**2 - 12*r*(56*s - 39) - 240*s**2 + 348*s - 114) - 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 384*Dd**2*f**2*r**2 - 384*Dd**2*f**2*r*s + 480*Dd**2*f**2*r + 192*Dd**2*f**2*s - 128*Dd**2*f**2 - 672*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 840*Dd**2*f*g2*r + 336*Dd**2*f*g2*s - 224*Dd**2*f*g2 + 7*b2*(-D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 4*D1**2*fd*r**2 - 8*D1**2*fd*r*s + 2*D1**2*fd*r - 4*D1**2*fd*s**2 + 2*D1**2*fd*s - D1**2*fd + 5*D1**2*fdd*r**2 + 10*D1**2*fdd*r*s + 5*D1**2*fdd*s**2 - 16*D1*Dd*f*r**2 - 32*D1*Dd*f*r*s + 24*D1*Dd*f*r - 16*D1*Dd*f*s**2 + 24*D1*Dd*f*s - 12*D1*Dd*f + 40*D1*Dd*fd*r**2 + 80*D1*Dd*fd*r*s - 30*D1*Dd*fd*r + 40*D1*Dd*fd*s**2 - 30*D1*Dd*fd*s + 20*D1*Ddd*f*r**2 + 40*D1*Ddd*f*r*s - 30*D1*Ddd*f*r + 20*D1*Ddd*f*s**2 - 30*D1*Ddd*f*s + 15*D1*Ddd*f + 2*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 60*Dd**2*f*r**2 + 120*Dd**2*f*r*s - 90*Dd**2*f*r + 60*Dd**2*f*s**2 - 90*Dd**2*f*s + 30*Dd**2*f)))/(21*d**2*k3**3) - 2*D1**2*Pk2*Pkd3*ct**2*st**2*(D1*(-3*D1*bd1**2*f*(r**2*(2*f + 2) + 2*r*(2*K*s + f*(s - 1) + s - 1) + s*(4*K*s - 2*K - f - 1)) - 3*D1*bdd1*f*(r + s)*(f*(4*C*s + r - 2*s) + s*(2*b2 - 4*g2)) + bd1*(D1*(4*f**2*(r + s)*(6*C*s + r - 3*s) - 3*f*(2*bd2*s*(2*r + 2*s - 1) + 4*fd*r**2 + fd*r*(4*C*(4*s - 1) - 4*s - 1) + fd*s*(4*C*(4*s - 3) - 8*s + 5) + 4*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(f*(8*r**2 + r*(32*C*s - 4*C - 8*s - 3) + 2*s*(16*C*s - 8*C - 8*s + 3)) + 4*g2*(-8*r*s + r + s*(4 - 8*s))) - 6*b2*(D1*(-2*f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 3*b1**2*(D1**2*(r + s - 1)*(f*(fd - fdd)*(2*r - 1) + fd**2*(1 - 2*r) + 2*fd*(2*K*(s - 1) + r) - fdd*(2*K*(s - 1) + r)) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(2*r - 1)*(8*r + 8*s - 7) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) - fd*(2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + 8*r**2 + 8*r*s - 9*r - 2*s + 2)) - Ddd*f*(K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - Dd**2*f*(K*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + f*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 12*r**2 + 12*r*s - 15*r - 6*s + 4)) + b1*(48*C*D1**2*f*fd*r*s - 24*C*D1**2*f*fd*r + 48*C*D1**2*f*fd*s**2 - 72*C*D1**2*f*fd*s + 24*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r*s + 12*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 + 36*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r*s + 12*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 + 36*C*D1**2*fd**2*s - 12*C*D1**2*fd**2 + 96*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r + 96*C*D1*Dd*f**2*s**2 - 96*C*D1*Dd*f**2*s + 24*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r*s + 72*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 240*C*D1*Dd*f*fd*s - 60*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 48*C*D1*Ddd*f**2*s - 12*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 144*C*Dd**2*f**2*s - 24*C*Dd**2*f**2 + 12*D1**2*b2*fd*r*s - 12*D1**2*b2*fd*r + 12*D1**2*b2*fd*s**2 - 24*D1**2*b2*fd*s + 12*D1**2*b2*fd - 6*D1**2*b2*fdd*r*s + 6*D1**2*b2*fdd*r - 6*D1**2*b2*fdd*s**2 + 12*D1**2*b2*fdd*s - 6*D1**2*b2*fdd + 12*D1**2*bd2*f*r*s + 12*D1**2*bd2*f*s**2 - 12*D1**2*bd2*f*s - 12*D1**2*bd2*fd*r*s + 6*D1**2*bd2*fd*r - 12*D1**2*bd2*fd*s**2 + 18*D1**2*bd2*fd*s - 6*D1**2*bd2*fd - 3*D1**2*bdd1*f*(4*K*s**2 - 2*K*s + f*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*r**2 + 2*r*(2*K*s + s - 1) - s + 1) - 6*D1**2*bdd2*f*r*s - 6*D1**2*bdd2*f*s**2 + 6*D1**2*bdd2*f*s + 8*D1**2*f*fd*r**2 - 16*D1**2*f*fd*r*s - 24*D1**2*f*fd*s**2 + 32*D1**2*f*fd*s - 8*D1**2*f*fd - 6*D1**2*f*fdd*r**2 + 6*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + 12*D1**2*f*fdd*s**2 - 15*D1**2*f*fdd*s + 3*D1**2*f*fdd - 24*D1**2*f*gd2*r*s - 24*D1**2*f*gd2*s**2 + 24*D1**2*f*gd2*s + 12*D1**2*f*gdd2*r*s + 12*D1**2*f*gdd2*s**2 - 12*D1**2*f*gdd2*s - 6*D1**2*fd**2*r**2 + 6*D1**2*fd**2*r*s + 3*D1**2*fd**2*r + 12*D1**2*fd**2*s**2 - 15*D1**2*fd**2*s + 3*D1**2*fd**2 - 24*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*r - 24*D1**2*fd*g2*s**2 + 48*D1**2*fd*g2*s - 24*D1**2*fd*g2 + 24*D1**2*fd*gd2*r*s - 12*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 36*D1**2*fd*gd2*s + 12*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*r + 12*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 + 48*D1*Dd*b2*f*r*s - 12*D1*Dd*b2*f*r + 48*D1*Dd*b2*f*s**2 - 48*D1*Dd*b2*f*s + 12*D1*Dd*b2*f - 48*D1*Dd*b2*fd*r*s + 30*D1*Dd*b2*fd*r - 48*D1*Dd*b2*fd*s**2 + 72*D1*Dd*b2*fd*s - 24*D1*Dd*b2*fd - 48*D1*Dd*bd2*f*r*s + 6*D1*Dd*bd2*f*r - 48*D1*Dd*bd2*f*s**2 + 48*D1*Dd*bd2*f*s - 6*D1*Dd*bd2*f + 16*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 40*D1*Dd*f**2*s - 4*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 + 48*D1*Dd*f*fd*r*s + 30*D1*Dd*f*fd*r + 96*D1*Dd*f*fd*s**2 - 96*D1*Dd*f*fd*s + 9*D1*Dd*f*fd - 96*D1*Dd*f*g2*r*s + 24*D1*Dd*f*g2*r - 96*D1*Dd*f*g2*s**2 + 96*D1*Dd*f*g2*s - 24*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r*s - 12*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 96*D1*Dd*f*gd2*s + 12*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r*s - 60*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 144*D1*Dd*fd*g2*s + 48*D1*Dd*fd*g2 - 24*D1*Ddd*b2*f*r*s + 6*D1*Ddd*b2*f*r - 24*D1*Ddd*b2*f*s**2 + 24*D1*Ddd*b2*f*s - 6*D1*Ddd*b2*f - 12*D1*Ddd*f**2*r**2 + 12*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 48*D1*Ddd*f*g2*r*s - 12*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 48*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(f**2*(2*r**2 + 2*r*(s - 1) - s + 1) + f*(8*K*s**2 - 4*K*s - fd*(2*r - 1)*(4*r + 4*s - 3) + 4*r**2 + 4*r*(2*K*s + s - 1) - 2*s + 2) + fd*(-2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r**2 - 4*r*(s - 1) + s - 1)) - Dd*f*(K*(32*r*s - 4*r + 32*s**2 - 24*s + 2) + f*(2*r - 1)*(8*r + 8*s - 5) + (2*r - 1)*(8*r + 8*s - 5))) - 72*Dd**2*b2*f*r*s + 18*Dd**2*b2*f*r - 72*Dd**2*b2*f*s**2 + 72*Dd**2*b2*f*s - 12*Dd**2*b2*f - 36*Dd**2*f**2*r**2 + 36*Dd**2*f**2*r*s + 27*Dd**2*f**2*r + 72*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 144*Dd**2*f*g2*r*s - 36*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 144*Dd**2*f*g2*s + 24*Dd**2*f*g2))/(21*d**2*k3) - D1**2*Pk2*Pkd3*ct**2*(D1*(2*D1*bd1**2*f*(7*K*s*(5*s - 3) + r**2*(7*K - 16) + r*(7*K*(6*s - 1) - 16*s + 8)) + D1*bdd1*f*(r + s)*(7*b2*(r + 5*s) + f*(20*C - 10)*(r + 3*s) - 14*g2*(r + 5*s)) + bd1*(14*D1*bd2*f*(r**2 + r*(6*s - 1) + s*(5*s - 3)) - 2*D1*(f**2*(r + s)*(r*(2*C + 5) + s*(42*C - 21)) + f*(fd*(10 - 20*C)*(2*r**2 + r*(8*s - 3) + s*(6*s - 5)) + 7*g2*(r**2 - 6*r*s - 7*s**2) + 14*gd2*(r**2 + r*(6*s - 1) + s*(5*s - 3))) + 14*fd*g2*(r**2 + r*(6*s - 3) + s*(5*s - 5))) + 4*Dd*f*(f*(10*C - 5)*(4*r**2 + 4*r*(4*s - 1) + s*(12*s - 7)) - 7*g2*(4*r**2 + r*(24*s - 5) + s*(20*s - 11))) + 7*b2*(D1*(f*(r**2 - 6*r*s - 7*s**2) + 2*fd*(r**2 + r*(6*s - 3) + s*(5*s - 5))) + 2*Dd*f*(4*r**2 + r*(24*s - 5) + s*(20*s - 11))))) + 14*b1**3*(D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 13*r + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) - Ddd*(f + 1)*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - Dd**2*(f + 1)*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) + b1**2*(7*D1**2*K*fd*r**2 - 42*D1**2*K*fd*r*s + 42*D1**2*K*fd*r - 49*D1**2*K*fd*s**2 + 98*D1**2*K*fd*s - 49*D1**2*K*fd + 7*D1**2*K*fdd*r**2 + 42*D1**2*K*fdd*r*s - 42*D1**2*K*fdd*r + 35*D1**2*K*fdd*s**2 - 70*D1**2*K*fdd*s + 35*D1**2*K*fdd - 14*D1**2*bdd1*(f + 1)*(3*r**2 + 3*r*(s - 1) - s + 1) + 18*D1**2*fd*r**2 + 18*D1**2*fd*r*s - 50*D1**2*fd*r - 32*D1**2*fd*s + 32*D1**2*fd - 16*D1**2*fdd*r**2 - 16*D1**2*fdd*r*s + 32*D1**2*fdd*r + 16*D1**2*fdd*s - 16*D1**2*fdd + 28*D1*Dd*K*f*r**2 - 168*D1*Dd*K*f*r*s + 14*D1*Dd*K*f*r - 196*D1*Dd*K*f*s**2 + 182*D1*Dd*K*f*s - 35*D1*Dd*K*f + 56*D1*Dd*K*fd*r**2 + 336*D1*Dd*K*fd*r*s - 238*D1*Dd*K*fd*r + 280*D1*Dd*K*fd*s**2 - 434*D1*Dd*K*fd*s + 154*D1*Dd*K*fd + 72*D1*Dd*f*r**2 + 72*D1*Dd*f*r*s - 90*D1*Dd*f*r - 36*D1*Dd*f*s + 36*D1*Dd*f - 128*D1*Dd*fd*r**2 - 128*D1*Dd*fd*r*s + 208*D1*Dd*fd*r + 96*D1*Dd*fd*s - 80*D1*Dd*fd + 28*D1*Ddd*K*f*r**2 + 168*D1*Ddd*K*f*r*s - 70*D1*Ddd*K*f*r + 140*D1*Ddd*K*f*s**2 - 154*D1*Ddd*K*f*s + 49*D1*Ddd*K*f - 64*D1*Ddd*f*r**2 - 64*D1*Ddd*f*r*s + 80*D1*Ddd*f*r + 32*D1*Ddd*f*s - 32*D1*Ddd*f + 14*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 - 6*r*s + 9*r + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) - Dd*(f + 1)*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) + 84*Dd**2*K*f*r**2 + 504*Dd**2*K*f*r*s - 210*Dd**2*K*f*r + 420*Dd**2*K*f*s**2 - 462*Dd**2*K*f*s + 98*Dd**2*K*f - 192*Dd**2*f*r**2 - 192*Dd**2*f*r*s + 240*Dd**2*f*r + 96*Dd**2*f*s - 64*Dd**2*f) + b1*(-8*C*D1**2*f*fd*r**2 - 176*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r - 168*C*D1**2*f*fd*s**2 + 256*C*D1**2*f*fd*s - 88*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 160*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 200*C*D1**2*f*fdd*s + 80*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 160*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 200*C*D1**2*fd**2*s + 80*C*D1**2*fd**2 - 16*C*D1*Dd*f**2*r**2 - 352*C*D1*Dd*f**2*r*s + 104*C*D1*Dd*f**2*r - 336*C*D1*Dd*f**2*s**2 + 344*C*D1*Dd*f**2*s - 92*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 1280*C*D1*Dd*f*fd*r*s - 800*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1360*C*D1*Dd*f*fd*s + 440*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 320*C*D1*Ddd*f**2*r*s - 160*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 280*C*D1*Ddd*f**2*s + 100*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 960*C*Dd**2*f**2*r*s - 480*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 840*C*Dd**2*f**2*s + 200*C*Dd**2*f**2 + 14*D1**2*K*bdd1*f*r**2 + 84*D1**2*K*bdd1*f*r*s - 14*D1**2*K*bdd1*f*r + 70*D1**2*K*bdd1*f*s**2 - 42*D1**2*K*bdd1*f*s + 7*D1**2*K*bdd1*f + 7*D1**2*b2*fd*r**2 - 42*D1**2*b2*fd*r*s + 42*D1**2*b2*fd*r - 49*D1**2*b2*fd*s**2 + 98*D1**2*b2*fd*s - 49*D1**2*b2*fd + 7*D1**2*b2*fdd*r**2 + 42*D1**2*b2*fdd*r*s - 42*D1**2*b2*fdd*r + 35*D1**2*b2*fdd*s**2 - 70*D1**2*b2*fdd*s + 35*D1**2*b2*fdd - 14*D1**2*bd1**2*(f + 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 32*D1**2*bdd1*f*r**2 - 32*D1**2*bdd1*f*r*s + 16*D1**2*bdd1*f*r + 7*D1**2*bdd2*f*r**2 + 42*D1**2*bdd2*f*r*s - 14*D1**2*bdd2*f*r + 35*D1**2*bdd2*f*s**2 - 42*D1**2*bdd2*f*s + 7*D1**2*bdd2*f - 20*D1**2*f*fd*r**2 + 64*D1**2*f*fd*r*s - 12*D1**2*f*fd*r + 84*D1**2*f*fd*s**2 - 116*D1**2*f*fd*s + 32*D1**2*f*fd - 20*D1**2*f*fdd*r**2 - 80*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 60*D1**2*f*fdd*s**2 + 100*D1**2*f*fdd*s - 40*D1**2*f*fdd - 14*D1**2*f*gd2*r**2 + 84*D1**2*f*gd2*r*s + 28*D1**2*f*gd2*r + 98*D1**2*f*gd2*s**2 - 84*D1**2*f*gd2*s - 14*D1**2*f*gd2 - 14*D1**2*f*gdd2*r**2 - 84*D1**2*f*gdd2*r*s + 28*D1**2*f*gdd2*r - 70*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s - 14*D1**2*f*gdd2 - 20*D1**2*fd**2*r**2 - 80*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 60*D1**2*fd**2*s**2 + 100*D1**2*fd**2*s - 40*D1**2*fd**2 - 14*D1**2*fd*g2*r**2 + 84*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*r + 98*D1**2*fd*g2*s**2 - 196*D1**2*fd*g2*s + 98*D1**2*fd*g2 - 28*D1**2*fd*gd2*r**2 - 168*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 140*D1**2*fd*gd2*s**2 + 224*D1**2*fd*gd2*s - 84*D1**2*fd*gd2 - 14*D1**2*fdd*g2*r**2 - 84*D1**2*fdd*g2*r*s + 84*D1**2*fdd*g2*r - 70*D1**2*fdd*g2*s**2 + 140*D1**2*fdd*g2*s - 70*D1**2*fdd*g2 + 28*D1*Dd*b2*f*r**2 - 168*D1*Dd*b2*f*r*s + 14*D1*Dd*b2*f*r - 196*D1*Dd*b2*f*s**2 + 182*D1*Dd*b2*f*s - 35*D1*Dd*b2*f + 56*D1*Dd*b2*fd*r**2 + 336*D1*Dd*b2*fd*r*s - 238*D1*Dd*b2*fd*r + 280*D1*Dd*b2*fd*s**2 - 434*D1*Dd*b2*fd*s + 154*D1*Dd*b2*fd - 40*D1*Dd*f**2*r**2 + 128*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r + 168*D1*Dd*f**2*s**2 - 148*D1*Dd*f**2*s + 22*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 - 640*D1*Dd*f*fd*r*s + 400*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 680*D1*Dd*f*fd*s - 220*D1*Dd*f*fd - 56*D1*Dd*f*g2*r**2 + 336*D1*Dd*f*g2*r*s - 28*D1*Dd*f*g2*r + 392*D1*Dd*f*g2*s**2 - 364*D1*Dd*f*g2*s + 70*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*r**2 - 672*D1*Dd*f*gd2*r*s + 252*D1*Dd*f*gd2*r - 560*D1*Dd*f*gd2*s**2 + 644*D1*Dd*f*gd2*s - 140*D1*Dd*f*gd2 - 112*D1*Dd*fd*g2*r**2 - 672*D1*Dd*fd*g2*r*s + 476*D1*Dd*fd*g2*r - 560*D1*Dd*fd*g2*s**2 + 868*D1*Dd*fd*g2*s - 308*D1*Dd*fd*g2 + 28*D1*Ddd*b2*f*r**2 + 168*D1*Ddd*b2*f*r*s - 70*D1*Ddd*b2*f*r + 140*D1*Ddd*b2*f*s**2 - 154*D1*Ddd*b2*f*s + 49*D1*Ddd*b2*f - 40*D1*Ddd*f**2*r**2 - 160*D1*Ddd*f**2*r*s + 80*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 140*D1*Ddd*f**2*s - 50*D1*Ddd*f**2 - 56*D1*Ddd*f*g2*r**2 - 336*D1*Ddd*f*g2*r*s + 140*D1*Ddd*f*g2*r - 280*D1*Ddd*f*g2*s**2 + 308*D1*Ddd*f*g2*s - 98*D1*Ddd*f*g2 + D1*bd1*(D1*(7*K*f*(2*r**2 - 2*r*(6*s + 1) - 14*s**2 + 6*s + 1) + 14*K*fd*(2*r**2 + r*(12*s - 7) + 10*s**2 - 13*s + 3) + 2*f*(18*r**2 + 18*r*s - 2*r + 7*s - 7) - 16*fd*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + 2*Dd*f*(7*K*(8*r**2 + 48*r*s - 14*r + 40*s**2 - 34*s + 5) - 128*r**2 - 128*r*s + 112*r + 32*s - 16)) + 7*D1*bd2*(D1*(f*(r - 7*s - 1) + 2*fd*(r + 5*s - 3))*(r + s - 1) + 2*Dd*f*(4*r**2 + 3*r*(8*s - 3) + 20*s**2 - 23*s + 5)) + 84*Dd**2*b2*f*r**2 + 504*Dd**2*b2*f*r*s - 210*Dd**2*b2*f*r + 420*Dd**2*b2*f*s**2 - 462*Dd**2*b2*f*s + 98*Dd**2*b2*f - 120*Dd**2*f**2*r**2 - 480*Dd**2*f**2*r*s + 240*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 420*Dd**2*f**2*s - 100*Dd**2*f**2 - 168*Dd**2*f*g2*r**2 - 1008*Dd**2*f*g2*r*s + 420*Dd**2*f*g2*r - 840*Dd**2*f*g2*s**2 + 924*Dd**2*f*g2*s - 196*Dd**2*f*g2))/(21*d**2*k3) + 15*D1**2*Pk2*Pkd3*ct*f**2*k1**7*st**2*(D1**2*(f*(33*fd - 49*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 294*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(33*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 98*fd*(4*r + 4*s - 3)**2) - 49*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 294*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(2002*d**2*k2*k3**7) + 3*D1**2*Pk2*Pkd3*ct*f**2*k1**5*k2*st**4*(D1**2*(f*(727*fd - 500*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3000*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(727*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 1000*fd*(4*r + 4*s - 3)**2) - 500*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 3000*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1001*d**2*k3**7) + 8*D1**2*Pk2*Pkd3*ct*f**2*k1**5*st**4*(D1**2*(f*(361*fd - 200*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 200*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(361*f*(r*(4*s - 1) + (1 - 2*s)**2) - 400*fd*(4*s - 1)*(4*r + 4*s - 3)) - 200*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 200*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k2*k3**5) + 5*D1**2*Pk2*Pkd3*ct*f**2*k1**3*k2**3*st**6*(D1**2*(f*(236*fd - 105*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 630*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(236*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 210*Dd*fd*(4*r + 4*s - 3)**2 - 105*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 630*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(2002*d**2*k3**7) + 20*D1**2*Pk2*Pkd3*ct*f**2*k1**3*k2*st**6*(D1**2*(f*(181*fd - 84*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 84*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(181*f*(r*(4*s - 1) + (1 - 2*s)**2) - 168*fd*(4*s - 1)*(4*r + 4*s - 3)) - 84*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 84*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(9009*d**2*k3**5) + 5*D1**2*Pk2*Pkd3*ct*f*k1**7*(-28*D1**2*bdd1*f**2*(r + s - 1)**2 + D1*bd1*f*(r + s - 1)*(23*D1*f*(r + s - 1) - 56*D1*fd*(3*r + 3*s - 2) - 56*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 56*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(23*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 56*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 28*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 168*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k2*k3**7) - 3*D1**2*Pk2*Pkd3*ct*f*k1**3*k2**3*st**4*(-144*C*D1**2*f*fd*r**2 - 288*C*D1**2*f*fd*r*s + 192*C*D1**2*f*fd*r - 144*C*D1**2*f*fd*s**2 + 192*C*D1**2*f*fd*s - 96*C*D1**2*f*fd + 72*C*D1**2*f*fdd*r**2 + 144*C*D1**2*f*fdd*r*s - 96*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s**2 - 96*C*D1**2*f*fdd*s + 48*C*D1**2*f*fdd + 144*C*D1**2*fd**2*r**2 + 288*C*D1**2*fd**2*r*s - 192*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 192*C*D1**2*fd**2*s + 48*C*D1**2*fd**2 - 192*C*D1*Dd*f**2*r**2 - 384*C*D1*Dd*f**2*r*s + 288*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 144*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 + 1152*C*D1*Dd*f*fd*r*s - 816*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 816*C*D1*Dd*f*fd*s + 288*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 + 192*C*D1*Ddd*f**2*r*s - 144*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r**2 + 576*C*Dd**2*f**2*r*s - 432*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 144*C*Dd**2*f**2 - 25*D1**2*bdd1*f**2*r**2 - 50*D1**2*bdd1*f**2*r*s + 50*D1**2*bdd1*f**2*r - 25*D1**2*bdd1*f**2*s**2 + 50*D1**2*bdd1*f**2*s - 25*D1**2*bdd1*f**2 + 60*D1**2*f**2*fd*r**2 + 120*D1**2*f**2*fd*r*s - 90*D1**2*f**2*fd*r + 60*D1**2*f**2*fd*s**2 - 90*D1**2*f**2*fd*s + 45*D1**2*f**2*fd + 108*D1**2*f*fd*r**2 + 216*D1**2*f*fd*r*s - 144*D1**2*f*fd*r + 108*D1**2*f*fd*s**2 - 144*D1**2*f*fd*s + 72*D1**2*f*fd - 54*D1**2*f*fdd*r**2 - 108*D1**2*f*fdd*r*s + 72*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 72*D1**2*f*fdd*s - 36*D1**2*f*fdd + 132*D1**2*f*gd2*r**2 + 264*D1**2*f*gd2*r*s - 264*D1**2*f*gd2*r + 132*D1**2*f*gd2*s**2 - 264*D1**2*f*gd2*s + 132*D1**2*f*gd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 144*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 144*D1**2*fd**2*s - 36*D1**2*fd**2 + 264*D1**2*fd*g2*r**2 + 528*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*r + 264*D1**2*fd*g2*s**2 - 264*D1**2*fd*g2*s + 132*D1**2*fd*g2 + 60*D1*Dd*f**3*r**2 + 120*D1*Dd*f**3*r*s - 90*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 90*D1*Dd*f**3*s + 45*D1*Dd*f**3 + 144*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 216*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 216*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 432*D1*Dd*f*fd*r**2 - 864*D1*Dd*f*fd*r*s + 612*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 612*D1*Dd*f*fd*s - 216*D1*Dd*f*fd + 528*D1*Dd*f*g2*r**2 + 1056*D1*Dd*f*g2*r*s - 792*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s**2 - 792*D1*Dd*f*g2*s + 396*D1*Dd*f*g2 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 + D1*bd1*f*(D1*(50*f*(r + s - 1) - 50*fd*(3*r + 3*s - 2) - (66*K - 33)*(r + s - 1)) - 50*Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 + b1*(-D1**2*(-50*f*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 25*f*fdd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 50*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 33*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + D1*f*(Dd*(50*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 50*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + (33 - 66*K)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 25*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 150*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**7) + D1**2*Pk2*Pkd3*ct*f*k1**3*k2*st**4*(-144*C*D1**2*f*fd*r**2 + 96*C*D1**2*f*fd*r + 144*C*D1**2*f*fd*s**2 - 96*C*D1**2*f*fd*s + 72*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r - 72*C*D1**2*f*fdd*s**2 + 48*C*D1**2*f*fdd*s + 144*C*D1**2*fd**2*r**2 - 96*C*D1**2*fd**2*r - 144*C*D1**2*fd**2*s**2 + 96*C*D1**2*fd**2*s - 192*C*D1*Dd*f**2*r**2 + 192*C*D1*Dd*f**2*r + 192*C*D1*Dd*f**2*s**2 - 96*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 - 480*C*D1*Dd*f*fd*r - 576*C*D1*Dd*f*fd*s**2 + 336*C*D1*Dd*f*fd*s + 48*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r - 96*C*D1*Ddd*f**2*s**2 + 48*C*D1*Ddd*f**2*s + 24*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r - 288*C*Dd**2*f**2*s**2 + 144*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 - 225*D1**2*bdd1*f**2*r**2 - 410*D1**2*bdd1*f**2*r*s + 380*D1**2*bdd1*f**2*r - 185*D1**2*bdd1*f**2*s**2 + 340*D1**2*bdd1*f**2*s - 230*D1**2*bdd1*f**2 - 780*D1**2*f**2*fd*r**2 - 2040*D1**2*f**2*fd*r*s + 1290*D1**2*f**2*fd*r - 1260*D1**2*f**2*fd*s**2 + 1650*D1**2*f**2*fd*s - 705*D1**2*f**2*fd + 900*D1**2*f**2*fdd*r**2 + 1800*D1**2*f**2*fdd*r*s - 1350*D1**2*f**2*fdd*r + 900*D1**2*f**2*fdd*s**2 - 1350*D1**2*f**2*fdd*s + 675*D1**2*f**2*fdd + 2700*D1**2*f*fd**2*r**2 + 5400*D1**2*f*fd**2*r*s - 4050*D1**2*f*fd**2*r + 2700*D1**2*f*fd**2*s**2 - 4050*D1**2*f*fd**2*s + 1350*D1**2*f*fd**2 + 324*D1**2*f*fd*r**2 + 432*D1**2*f*fd*r*s - 360*D1**2*f*fd*r + 108*D1**2*f*fd*s**2 - 216*D1**2*f*fd*s + 144*D1**2*f*fd - 162*D1**2*f*fdd*r**2 - 216*D1**2*f*fdd*r*s + 180*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 108*D1**2*f*fdd*s - 72*D1**2*f*fdd + 264*D1**2*f*gd2*r*s + 264*D1**2*f*gd2*s**2 - 264*D1**2*f*gd2*s - 324*D1**2*fd**2*r**2 - 432*D1**2*fd**2*r*s + 360*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 216*D1**2*fd**2*s - 72*D1**2*fd**2 + 528*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*r + 528*D1**2*fd*g2*s**2 - 528*D1**2*fd*g2*s + 264*D1**2*fd*g2 - 780*D1*Dd*f**3*r**2 - 2040*D1*Dd*f**3*r*s + 1290*D1*Dd*f**3*r - 1260*D1*Dd*f**3*s**2 + 1650*D1*Dd*f**3*s - 705*D1*Dd*f**3 + 7200*D1*Dd*f**2*fd*r**2 + 14400*D1*Dd*f**2*fd*r*s - 10800*D1*Dd*f**2*fd*r + 7200*D1*Dd*f**2*fd*s**2 - 10800*D1*Dd*f**2*fd*s + 4050*D1*Dd*f**2*fd + 432*D1*Dd*f**2*r**2 + 576*D1*Dd*f**2*r*s - 576*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 360*D1*Dd*f**2*s + 252*D1*Dd*f**2 - 1296*D1*Dd*f*fd*r**2 - 1728*D1*Dd*f*fd*r*s + 1584*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 972*D1*Dd*f*fd*s - 468*D1*Dd*f*fd + 1056*D1*Dd*f*g2*r*s - 264*D1*Dd*f*g2*r + 1056*D1*Dd*f*g2*s**2 - 1056*D1*Dd*f*g2*s + 264*D1*Dd*f*g2 + 900*D1*Ddd*f**3*r**2 + 1800*D1*Ddd*f**3*r*s - 1350*D1*Ddd*f**3*r + 900*D1*Ddd*f**3*s**2 - 1350*D1*Ddd*f**3*s + 675*D1*Ddd*f**3 - 216*D1*Ddd*f**2*r**2 - 288*D1*Ddd*f**2*r*s + 288*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 126*D1*Ddd*f**2 + D1*bd1*f*(D1*(10*f*(45*r**2 + r*(82*s - 76) + 37*s**2 - 68*s + 46) - 10*fd*(135*r**2 + 3*r*(82*s - 69) + 111*s**2 - 187*s + 64) + (33*r + 33*s - 33)*(-4*K*s + 5*r + 9*s - 5)) - 10*Dd*f*(180*r**2 + r*(328*s - 283) + 148*s**2 - 255*s + 110)) + 2700*Dd**2*f**3*r**2 + 5400*Dd**2*f**3*r*s - 4050*Dd**2*f**3*r + 2700*Dd**2*f**3*s**2 - 4050*Dd**2*f**3*s + 1350*Dd**2*f**3 - 648*Dd**2*f**2*r**2 - 864*Dd**2*f**2*r*s + 864*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 252*Dd**2*f**2 + b1*(D1**2*(-5*f*fdd*(135*r**2 + 6*r*(41*s - 31) + 111*s**2 - 170*s + 81) - 10*fd**2*(135*r**2 + 6*r*(41*s - 31) + 111*s**2 - 170*s + 63) + fd*(-33*K*(8*r*s - 4*r + 8*s**2 - 8*s + 4) + 10*f*(135*r**2 + 6*r*(41*s - 31) + 111*s**2 - 170*s + 81) + 330*r**2 + 924*r*s - 462*r + 594*s**2 - 594*s + 297)) + D1*f*(Dd*(-132*K*(r*(4*s - 1) + (1 - 2*s)**2) + 10*f*(180*r**2 + r*(328*s - 262) + 148*s**2 - 238*s + 127) - 10*fd*(540*r**2 + r*(984*s - 765) + 444*s**2 - 697*s + 271) + 660*r**2 + 1848*r*s - 1122*r + 1188*s**2 - 1518*s + 627) - 5*Ddd*f*(180*r**2 + r*(328*s - 262) + 148*s**2 - 238*s + 127)) - 10*Dd**2*f**2*(270*r**2 + r*(492*s - 393) + 222*s**2 - 357*s + 127)))/(231*d**2*k3**5) + 8*D1**2*Pk2*Pkd3*ct*f*k1**3*st**4*(D1**2*(f**2*s*(10*bd1 - 5*bdd1)*(5*r + 5*s - 3) + f*(fd*(10*b1*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5) - 5*bd1*(30*r*s - 5*r + 30*s**2 - 26*s + 3) + 18*r*s - 6*r + 18*s**2 - 18*s + 6) - fdd*(5*b1*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5) + r*(9*s - 3) + 9*s**2 - 9*s + 3)) - fd**2*(5*b1*(10*r*(3*s - 1) + 30*s**2 - 34*s + 7) + 3*r*(6*s - 2) + 18*s**2 - 18*s + 3)) + D1*f*(Dd*(50*b1*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*b1*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) - 5*bd1*f*(5*r*(8*s - 1) + 40*s**2 - 32*s + 3) + 6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - Ddd*f*(25*b1 + 3)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(25*b1 + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k2*k3**3) + D1**2*Pk2*Pkd3*ct*f*k2**5*st**4*(40*C - 20)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4))/(231*d**2*k1*k3**5) - D1**2*Pk2*Pkd3*ct*f*k2**3*st**4*(40*C - 20)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + 3*r*(s - 1) - s + 1) + fd**2*(-6*r**2 - 6*r*(s - 1) + 2*s - 1)) + D1*f*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4))/(231*d**2*k1*k3**3) + D1**2*Pk2*Pkd3*ct*k1**5*k2*st**2*(204*C*D1**2*f**2*fd*r**2 + 408*C*D1**2*f**2*fd*r*s - 272*C*D1**2*f**2*fd*r + 204*C*D1**2*f**2*fd*s**2 - 272*C*D1**2*f**2*fd*s + 136*C*D1**2*f**2*fd - 300*C*D1**2*f**2*fdd*r**2 - 600*C*D1**2*f**2*fdd*r*s + 400*C*D1**2*f**2*fdd*r - 300*C*D1**2*f**2*fdd*s**2 + 400*C*D1**2*f**2*fdd*s - 200*C*D1**2*f**2*fdd - 600*C*D1**2*f*fd**2*r**2 - 1200*C*D1**2*f*fd**2*r*s + 800*C*D1**2*f*fd**2*r - 600*C*D1**2*f*fd**2*s**2 + 800*C*D1**2*f*fd**2*s - 200*C*D1**2*f*fd**2 + 272*C*D1*Dd*f**3*r**2 + 544*C*D1*Dd*f**3*r*s - 408*C*D1*Dd*f**3*r + 272*C*D1*Dd*f**3*s**2 - 408*C*D1*Dd*f**3*s + 204*C*D1*Dd*f**3 - 2400*C*D1*Dd*f**2*fd*r**2 - 4800*C*D1*Dd*f**2*fd*r*s + 3400*C*D1*Dd*f**2*fd*r - 2400*C*D1*Dd*f**2*fd*s**2 + 3400*C*D1*Dd*f**2*fd*s - 1200*C*D1*Dd*f**2*fd - 400*C*D1*Ddd*f**3*r**2 - 800*C*D1*Ddd*f**3*r*s + 600*C*D1*Ddd*f**3*r - 400*C*D1*Ddd*f**3*s**2 + 600*C*D1*Ddd*f**3*s - 300*C*D1*Ddd*f**3 - 1200*C*Dd**2*f**3*r**2 - 2400*C*Dd**2*f**3*r*s + 1800*C*Dd**2*f**3*r - 1200*C*Dd**2*f**3*s**2 + 1800*C*Dd**2*f**3*s - 600*C*Dd**2*f**3 + 132*D1**2*K*b1*f*fd*r**2 + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r + 132*D1**2*K*b1*f*fd*s**2 - 132*D1**2*K*b1*f*fd*s + 66*D1**2*K*b1*f*fd - 132*D1**2*K*b1*f*fdd*r**2 - 264*D1**2*K*b1*f*fdd*r*s + 132*D1**2*K*b1*f*fdd*r - 132*D1**2*K*b1*f*fdd*s**2 + 132*D1**2*K*b1*f*fdd*s - 66*D1**2*K*b1*f*fdd - 132*D1**2*K*b1*fd**2*r**2 - 264*D1**2*K*b1*fd**2*r*s + 132*D1**2*K*b1*fd**2*r - 132*D1**2*K*b1*fd**2*s**2 + 132*D1**2*K*b1*fd**2*s + 1854*D1**2*b1*f**2*fd*r**2 + 3708*D1**2*b1*f**2*fd*r*s - 2472*D1**2*b1*f**2*fd*r + 1854*D1**2*b1*f**2*fd*s**2 - 2472*D1**2*b1*f**2*fd*s + 1236*D1**2*b1*f**2*fd - 1125*D1**2*b1*f**2*fdd*r**2 - 2250*D1**2*b1*f**2*fdd*r*s + 1500*D1**2*b1*f**2*fdd*r - 1125*D1**2*b1*f**2*fdd*s**2 + 1500*D1**2*b1*f**2*fdd*s - 750*D1**2*b1*f**2*fdd - 2250*D1**2*b1*f*fd**2*r**2 - 4500*D1**2*b1*f*fd**2*r*s + 3000*D1**2*b1*f*fd**2*r - 2250*D1**2*b1*f*fd**2*s**2 + 3000*D1**2*b1*f*fd**2*s - 750*D1**2*b1*f*fd**2 - 66*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fd*s**2 + 66*D1**2*b1*f*fd*s - 33*D1**2*b1*f*fd + 66*D1**2*b1*f*fdd*r**2 + 132*D1**2*b1*f*fdd*r*s - 66*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s**2 - 66*D1**2*b1*f*fdd*s + 33*D1**2*b1*f*fdd + 66*D1**2*b1*fd**2*r**2 + 132*D1**2*b1*fd**2*r*s - 66*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 66*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(22*K + 125*f - 11)*(r + s - 1)**2 - 300*D1**2*f**3*fd*r**2 - 600*D1**2*f**3*fd*r*s + 450*D1**2*f**3*fd*r - 300*D1**2*f**3*fd*s**2 + 450*D1**2*f**3*fd*s - 225*D1**2*f**3*fd - 153*D1**2*f**2*fd*r**2 - 306*D1**2*f**2*fd*r*s + 204*D1**2*f**2*fd*r - 153*D1**2*f**2*fd*s**2 + 204*D1**2*f**2*fd*s - 102*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r**2 + 450*D1**2*f**2*fdd*r*s - 300*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 300*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*r - 132*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s - 132*D1**2*f**2*gd2 + 132*D1**2*f**2*gdd2*r**2 + 264*D1**2*f**2*gdd2*r*s - 264*D1**2*f**2*gdd2*r + 132*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 132*D1**2*f**2*gdd2 + 450*D1**2*f*fd**2*r**2 + 900*D1**2*f*fd**2*r*s - 600*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 600*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r**2 + 1056*D1**2*f*fd*gd2*r*s - 792*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r**2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r**2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s + 264*D1*Dd*K*b1*f**2*r**2 + 528*D1*Dd*K*b1*f**2*r*s - 396*D1*Dd*K*b1*f**2*r + 264*D1*Dd*K*b1*f**2*s**2 - 396*D1*Dd*K*b1*f**2*s + 198*D1*Dd*K*b1*f**2 - 1056*D1*Dd*K*b1*f*fd*r**2 - 2112*D1*Dd*K*b1*f*fd*r*s + 1320*D1*Dd*K*b1*f*fd*r - 1056*D1*Dd*K*b1*f*fd*s**2 + 1320*D1*Dd*K*b1*f*fd*s - 396*D1*Dd*K*b1*f*fd + 2472*D1*Dd*b1*f**3*r**2 + 4944*D1*Dd*b1*f**3*r*s - 3708*D1*Dd*b1*f**3*r + 2472*D1*Dd*b1*f**3*s**2 - 3708*D1*Dd*b1*f**3*s + 1854*D1*Dd*b1*f**3 - 9000*D1*Dd*b1*f**2*fd*r**2 - 18000*D1*Dd*b1*f**2*fd*r*s + 12750*D1*Dd*b1*f**2*fd*r - 9000*D1*Dd*b1*f**2*fd*s**2 + 12750*D1*Dd*b1*f**2*fd*s - 4500*D1*Dd*b1*f**2*fd - 132*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 198*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s**2 + 198*D1*Dd*b1*f**2*s - 99*D1*Dd*b1*f**2 + 528*D1*Dd*b1*f*fd*r**2 + 1056*D1*Dd*b1*f*fd*r*s - 660*D1*Dd*b1*f*fd*r + 528*D1*Dd*b1*f*fd*s**2 - 660*D1*Dd*b1*f*fd*s + 198*D1*Dd*b1*f*fd - 300*D1*Dd*f**4*r**2 - 600*D1*Dd*f**4*r*s + 450*D1*Dd*f**4*r - 300*D1*Dd*f**4*s**2 + 450*D1*Dd*f**4*s - 225*D1*Dd*f**4 - 204*D1*Dd*f**3*r**2 - 408*D1*Dd*f**3*r*s + 306*D1*Dd*f**3*r - 204*D1*Dd*f**3*s**2 + 306*D1*Dd*f**3*s - 153*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r**2 + 3600*D1*Dd*f**2*fd*r*s - 2550*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 2550*D1*Dd*f**2*fd*s + 900*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s + 792*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 792*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r**2 + 2112*D1*Dd*f**2*gd2*r*s - 1848*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1848*D1*Dd*f**2*gd2*s + 792*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r**2 + 4224*D1*Dd*f*fd*g2*r*s - 2640*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2640*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 - 264*D1*Ddd*K*b1*f**2*r**2 - 528*D1*Ddd*K*b1*f**2*r*s + 396*D1*Ddd*K*b1*f**2*r - 264*D1*Ddd*K*b1*f**2*s**2 + 396*D1*Ddd*K*b1*f**2*s - 198*D1*Ddd*K*b1*f**2 - 1500*D1*Ddd*b1*f**3*r**2 - 3000*D1*Ddd*b1*f**3*r*s + 2250*D1*Ddd*b1*f**3*r - 1500*D1*Ddd*b1*f**3*s**2 + 2250*D1*Ddd*b1*f**3*s - 1125*D1*Ddd*b1*f**3 + 132*D1*Ddd*b1*f**2*r**2 + 264*D1*Ddd*b1*f**2*r*s - 198*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s**2 - 198*D1*Ddd*b1*f**2*s + 99*D1*Ddd*b1*f**2 + 300*D1*Ddd*f**3*r**2 + 600*D1*Ddd*f**3*r*s - 450*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 450*D1*Ddd*f**3*s + 225*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r**2 + 1056*D1*Ddd*f**2*g2*r*s - 792*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 396*D1*Ddd*f**2*g2 + 3*D1*bd1*f*(D1*(206*f**2*(r + s - 1) - 250*f*fd*(3*r + 3*s - 2) + 11*f*(2*K - 1)*(r + s - 1) - 22*fd*(2*K - 1)*(2*r + 2*s - 1)) - 2*Dd*f*(22*K + 125*f - 11)*(4*r + 4*s - 3))*(r + s - 1) - 792*Dd**2*K*b1*f**2*r**2 - 1584*Dd**2*K*b1*f**2*r*s + 1188*Dd**2*K*b1*f**2*r - 792*Dd**2*K*b1*f**2*s**2 + 1188*Dd**2*K*b1*f**2*s - 396*Dd**2*K*b1*f**2 - 4500*Dd**2*b1*f**3*r**2 - 9000*Dd**2*b1*f**3*r*s + 6750*Dd**2*b1*f**3*r - 4500*Dd**2*b1*f**3*s**2 + 6750*Dd**2*b1*f**3*s - 2250*Dd**2*b1*f**3 + 396*Dd**2*b1*f**2*r**2 + 792*Dd**2*b1*f**2*r*s - 594*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s**2 - 594*Dd**2*b1*f**2*s + 198*Dd**2*b1*f**2 + 900*Dd**2*f**3*r**2 + 1800*Dd**2*f**3*r*s - 1350*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 1350*Dd**2*f**3*s + 450*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r**2 + 3168*Dd**2*f**2*g2*r*s - 2376*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s + 792*Dd**2*f**2*g2)/(154*d**2*k3**7) - 3*D1**2*Pk2*Pkd3*ct*k1**5*k2*(-D1*(r + s - 1)*(2*D1*bd1**2*f*(-12*K + 25*f + 6)*(r + s - 1) - D1*bdd1*f*(f*(20*C - 15) - 24*g2)*(r + s - 1) + bd1*(D1*(-5*f**3*(r + s - 1) + f**2*(16*C - 12)*(r + s - 1) - f*fd*(40*C - 30)*(2*r + 2*s - 1) - 4*f*(5*g2 - 12*gd2)*(r + s - 1) + 48*fd*g2*(r + s)) - 2*Dd*f*(f*(20*C - 15) - 24*g2)*(4*r + 4*s - 3))) + b1**2*(D1**2*(5*f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + 5*fd*(2*K - 1)*(r + s) - 6*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(20*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (2*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-12*K + 25*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-12*K + 25*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-32*C*D1**2*f*fd*r**2 - 64*C*D1**2*f*fd*r*s + 32*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s - 16*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 64*C*D1*Dd*f**2*r**2 - 128*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 400*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(-12*K + 25*f + 6)*(r + s - 1)**2 + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 24*D1**2*f*fd*r**2 + 48*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 12*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 20*D1**2*f*gd2*r**2 + 40*D1**2*f*gd2*r*s - 40*D1**2*f*gd2*r + 20*D1**2*f*gd2*s**2 - 40*D1**2*f*gd2*s + 20*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 20*D1**2*fd*g2*r**2 + 40*D1**2*fd*g2*r*s + 20*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 48*D1*Dd*f**2*r**2 + 96*D1*Dd*f**2*r*s - 72*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 36*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 80*D1*Dd*f*g2*r**2 + 160*D1*Dd*f*g2*r*s - 120*D1*Dd*f*g2*r + 80*D1*Dd*f*g2*s**2 - 120*D1*Dd*f*g2*s + 60*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 144*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(20*f**2*(r + s - 1) - 5*f*(10*fd*(2*r + 2*s - 1) + (2*K - 1)*(r + s - 1)) + 12*fd*(2*K - 1)*(r + s)) - 2*Dd*f*(-12*K + 25*f + 6)*(4*r + 4*s - 3))*(r + s - 1) - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(7*d**2*k3**7) + D1**2*Pk2*Pkd3*ct*k1**5*st**2*(-408*C*D1**2*f**2*fd*r*s + 136*C*D1**2*f**2*fd*r - 408*C*D1**2*f**2*fd*s**2 + 408*C*D1**2*f**2*fd*s - 136*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r*s - 200*C*D1**2*f**2*fdd*r + 600*C*D1**2*f**2*fdd*s**2 - 600*C*D1**2*f**2*fdd*s + 200*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r*s - 400*C*D1**2*f*fd**2*r + 1200*C*D1**2*f*fd**2*s**2 - 1200*C*D1**2*f*fd**2*s + 200*C*D1**2*f*fd**2 - 544*C*D1*Dd*f**3*r*s + 136*C*D1*Dd*f**3*r - 544*C*D1*Dd*f**3*s**2 + 544*C*D1*Dd*f**3*s - 136*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r*s - 1400*C*D1*Dd*f**2*fd*r + 4800*C*D1*Dd*f**2*fd*s**2 - 4800*C*D1*Dd*f**2*fd*s + 1000*C*D1*Dd*f**2*fd + 800*C*D1*Ddd*f**3*r*s - 200*C*D1*Ddd*f**3*r + 800*C*D1*Ddd*f**3*s**2 - 800*C*D1*Ddd*f**3*s + 200*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r*s - 600*C*Dd**2*f**3*r + 2400*C*Dd**2*f**3*s**2 - 2400*C*Dd**2*f**3*s + 400*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r*s + 132*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 264*D1**2*K*b1*f*fdd*s**2 - 264*D1**2*K*b1*f*fdd*s + 132*D1**2*K*b1*f*fdd + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 264*D1**2*K*b1*fd**2*s**2 - 264*D1**2*K*b1*fd**2*s + 1530*D1**2*b1*f**2*fd*r**2 + 7668*D1**2*b1*f**2*fd*r*s - 2082*D1**2*b1*f**2*fd*r + 6138*D1**2*b1*f**2*fd*s**2 - 5154*D1**2*b1*f**2*fd*s + 807*D1**2*b1*f**2*fd - 2250*D1**2*b1*f**2*fdd*r**2 - 7200*D1**2*b1*f**2*fdd*r*s + 3450*D1**2*b1*f**2*fdd*r - 4950*D1**2*b1*f**2*fdd*s**2 + 5250*D1**2*b1*f**2*fdd*s - 1575*D1**2*b1*f**2*fdd - 4500*D1**2*b1*f*fd**2*r**2 - 14400*D1**2*b1*f*fd**2*r*s + 6900*D1**2*b1*f*fd**2*r - 9900*D1**2*b1*f*fd**2*s**2 + 10500*D1**2*b1*f*fd**2*s - 2700*D1**2*b1*f*fd**2 + 330*D1**2*b1*f*fd*r**2 + 924*D1**2*b1*f*fd*r*s - 462*D1**2*b1*f*fd*r + 594*D1**2*b1*f*fd*s**2 - 594*D1**2*b1*f*fd*s + 297*D1**2*b1*f*fd - 330*D1**2*b1*f*fdd*r**2 - 924*D1**2*b1*f*fdd*r*s + 462*D1**2*b1*f*fdd*r - 594*D1**2*b1*f*fdd*s**2 + 594*D1**2*b1*f*fdd*s - 297*D1**2*b1*f*fdd - 330*D1**2*b1*fd**2*r**2 - 924*D1**2*b1*fd**2*r*s + 462*D1**2*b1*fd**2*r - 594*D1**2*b1*fd**2*s**2 + 594*D1**2*b1*fd**2*s - 3*D1**2*bdd1*f**2*(25*f*(10*r**2 + r*(32*s - 26) + 22*s**2 - 38*s + 21) + (11*r + 11*s - 11)*(-4*K*s + 5*r + 9*s - 5)) - 2700*D1**2*f**3*fd*r**2 - 13800*D1**2*f**3*fd*r*s + 6150*D1**2*f**3*fd*r - 11100*D1**2*f**3*fd*s**2 + 12450*D1**2*f**3*fd*s - 4125*D1**2*f**3*fd + 3300*D1**2*f**3*fdd*r**2 + 12600*D1**2*f**3*fdd*r*s - 6450*D1**2*f**3*fdd*r + 9300*D1**2*f**3*fdd*s**2 - 10950*D1**2*f**3*fdd*s + 3975*D1**2*f**3*fdd + 9900*D1**2*f**2*fd**2*r**2 + 37800*D1**2*f**2*fd**2*r*s - 19350*D1**2*f**2*fd**2*r + 27900*D1**2*f**2*fd**2*s**2 - 32850*D1**2*f**2*fd**2*s + 7950*D1**2*f**2*fd**2 + 255*D1**2*f**2*fd*r**2 + 918*D1**2*f**2*fd*r*s - 476*D1**2*f**2*fd*r + 663*D1**2*f**2*fd*s**2 - 748*D1**2*f**2*fd*s + 306*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 1350*D1**2*f**2*fdd*r*s + 700*D1**2*f**2*fdd*r - 975*D1**2*f**2*fdd*s**2 + 1100*D1**2*f**2*fdd*s - 450*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s - 264*D1**2*f**2*gdd2*r*s - 264*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 750*D1**2*f*fd**2*r**2 - 2700*D1**2*f*fd**2*r*s + 1400*D1**2*f*fd**2*r - 1950*D1**2*f*fd**2*s**2 + 2200*D1**2*f*fd**2*s - 450*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r*s + 264*D1**2*f*fd*gd2*r - 1056*D1**2*f*fd*gd2*s**2 + 1056*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 528*D1**2*f*fdd*g2*s**2 + 528*D1**2*f*fdd*g2*s - 264*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 528*D1**2*fd**2*g2*s**2 + 528*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r*s + 132*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 528*D1*Dd*K*b1*f**2*s - 132*D1*Dd*K*b1*f**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 792*D1*Dd*K*b1*f*fd*r + 2112*D1*Dd*K*b1*f*fd*s**2 - 2112*D1*Dd*K*b1*f*fd*s + 528*D1*Dd*K*b1*f*fd + 2040*D1*Dd*b1*f**3*r**2 + 10224*D1*Dd*b1*f**3*r*s - 4596*D1*Dd*b1*f**3*r + 8184*D1*Dd*b1*f**3*s**2 - 9204*D1*Dd*b1*f**3*s + 3066*D1*Dd*b1*f**3 - 18000*D1*Dd*b1*f**2*fd*r**2 - 57600*D1*Dd*b1*f**2*fd*r*s + 30000*D1*Dd*b1*f**2*fd*r - 39600*D1*Dd*b1*f**2*fd*s**2 + 45300*D1*Dd*b1*f**2*fd*s - 12150*D1*Dd*b1*f**2*fd + 660*D1*Dd*b1*f**2*r**2 + 1848*D1*Dd*b1*f**2*r*s - 1122*D1*Dd*b1*f**2*r + 1188*D1*Dd*b1*f**2*s**2 - 1518*D1*Dd*b1*f**2*s + 627*D1*Dd*b1*f**2 - 2640*D1*Dd*b1*f*fd*r**2 - 7392*D1*Dd*b1*f*fd*r*s + 4092*D1*Dd*b1*f*fd*r - 4752*D1*Dd*b1*f*fd*s**2 + 5412*D1*Dd*b1*f*fd*s - 1518*D1*Dd*b1*f*fd - 2700*D1*Dd*f**4*r**2 - 13800*D1*Dd*f**4*r*s + 6150*D1*Dd*f**4*r - 11100*D1*Dd*f**4*s**2 + 12450*D1*Dd*f**4*s - 4125*D1*Dd*f**4 + 26400*D1*Dd*f**3*fd*r**2 + 100800*D1*Dd*f**3*fd*r*s - 51600*D1*Dd*f**3*fd*r + 74400*D1*Dd*f**3*fd*s**2 - 87600*D1*Dd*f**3*fd*s + 23850*D1*Dd*f**3*fd + 340*D1*Dd*f**3*r**2 + 1224*D1*Dd*f**3*r*s - 646*D1*Dd*f**3*r + 884*D1*Dd*f**3*s**2 - 1054*D1*Dd*f**3*s + 391*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 10800*D1*Dd*f**2*fd*r*s + 5650*D1*Dd*f**2*fd*r - 7800*D1*Dd*f**2*fd*s**2 + 9050*D1*Dd*f**2*fd*s - 2500*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r*s - 264*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1056*D1*Dd*f**2*g2*s + 264*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r*s + 264*D1*Dd*f**2*gd2*r - 2112*D1*Dd*f**2*gd2*s**2 + 2112*D1*Dd*f**2*gd2*s - 264*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r*s + 1584*D1*Dd*f*fd*g2*r - 4224*D1*Dd*f*fd*g2*s**2 + 4224*D1*Dd*f*fd*g2*s - 1056*D1*Dd*f*fd*g2 + 528*D1*Ddd*K*b1*f**2*r*s - 132*D1*Ddd*K*b1*f**2*r + 528*D1*Ddd*K*b1*f**2*s**2 - 528*D1*Ddd*K*b1*f**2*s + 132*D1*Ddd*K*b1*f**2 - 3000*D1*Ddd*b1*f**3*r**2 - 9600*D1*Ddd*b1*f**3*r*s + 5400*D1*Ddd*b1*f**3*r - 6600*D1*Ddd*b1*f**3*s**2 + 8100*D1*Ddd*b1*f**3*s - 3150*D1*Ddd*b1*f**3 - 660*D1*Ddd*b1*f**2*r**2 - 1848*D1*Ddd*b1*f**2*r*s + 1122*D1*Ddd*b1*f**2*r - 1188*D1*Ddd*b1*f**2*s**2 + 1518*D1*Ddd*b1*f**2*s - 627*D1*Ddd*b1*f**2 + 3300*D1*Ddd*f**4*r**2 + 12600*D1*Ddd*f**4*r*s - 6450*D1*Ddd*f**4*r + 9300*D1*Ddd*f**4*s**2 - 10950*D1*Ddd*f**4*s + 3975*D1*Ddd*f**4 - 500*D1*Ddd*f**3*r**2 - 1800*D1*Ddd*f**3*r*s + 950*D1*Ddd*f**3*r - 1300*D1*Ddd*f**3*s**2 + 1550*D1*Ddd*f**3*s - 575*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r*s + 264*D1*Ddd*f**2*g2*r - 1056*D1*Ddd*f**2*g2*s**2 + 1056*D1*Ddd*f**2*g2*s - 264*D1*Ddd*f**2*g2 + 3*D1*bd1*f*(D1*f**2*(170*r**2 + r*(852*s - 838) + 682*s**2 - 1350*s + 753) + D1*f*(-100*fd*(15*r**2 + r*(48*s - 31) + 33*s**2 - 46*s + 12) + (11*r + 11*s - 11)*(-4*K*s + 5*r + 9*s - 5)) + 22*D1*fd*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 - 10*r**2 + r*(17 - 28*s) - 18*s**2 + 23*s - 7) - 50*Dd*f**2*(40*r**2 + 8*r*(16*s - 11) + 88*s**2 - 130*s + 45) + 22*Dd*f*(2*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 20*r**2 + r*(37 - 56*s) - 36*s**2 + 51*s - 17)) + 1584*Dd**2*K*b1*f**2*r*s - 396*Dd**2*K*b1*f**2*r + 1584*Dd**2*K*b1*f**2*s**2 - 1584*Dd**2*K*b1*f**2*s + 264*Dd**2*K*b1*f**2 - 9000*Dd**2*b1*f**3*r**2 - 28800*Dd**2*b1*f**3*r*s + 16200*Dd**2*b1*f**3*r - 19800*Dd**2*b1*f**3*s**2 + 24300*Dd**2*b1*f**3*s - 6300*Dd**2*b1*f**3 - 1980*Dd**2*b1*f**2*r**2 - 5544*Dd**2*b1*f**2*r*s + 3366*Dd**2*b1*f**2*r - 3564*Dd**2*b1*f**2*s**2 + 4554*Dd**2*b1*f**2*s - 1254*Dd**2*b1*f**2 + 9900*Dd**2*f**4*r**2 + 37800*Dd**2*f**4*r*s - 19350*Dd**2*f**4*r + 27900*Dd**2*f**4*s**2 - 32850*Dd**2*f**4*s + 7950*Dd**2*f**4 - 1500*Dd**2*f**3*r**2 - 5400*Dd**2*f**3*r*s + 2850*Dd**2*f**3*r - 3900*Dd**2*f**3*s**2 + 4650*Dd**2*f**3*s - 1150*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r*s + 792*Dd**2*f**2*g2*r - 3168*Dd**2*f**2*g2*s**2 + 3168*Dd**2*f**2*g2*s - 528*Dd**2*f**2*g2)/(1386*d**2*k2*k3**5) + D1**2*Pk2*Pkd3*ct*k1**5*(-D1*(2*D1*bd1**2*f*(r + s - 1)*(6*K*(2 - 4*s) + 25*f*(2*r + 2*s - 1) + 30*r + 54*s - 42) - D1*bdd1*f*(r + s - 1)*(f**2*(55*r + 55*s - 75) + 5*f*(8*C*(s - 1) - 5*r - 13*s + 13) - 48*g2*(s - 1)) + bd1*(D1*(5*f**3*(9*r**2 + r*(22*s - 26) + 13*s**2 - 30*s + 17) + 2*f**2*(16*C*(s - 1)*(r + s - 1) - 5*fd*(33*r**2 + r*(66*s - 59) + 33*s**2 - 59*s + 24) - 10*r**2 - 36*r*(s - 1) - 26*(s - 1)**2) - 2*f*(5*fd*(4*C*(4*r*s - 2*r + 4*s**2 - 5*s + 1) - 10*r**2 - 36*r*s + 23*r - 26*s**2 + 35*s - 9) + (20*g2*(s - 1) + 24*gd2*(1 - 2*s))*(r + s - 1)) + 48*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*Dd*f*(-5*f**2*(44*r**2 + r*(88*s - 85) + 44*s**2 - 85*s + 39) - 5*f*(4*C*(8*r*s - 5*r + 8*s**2 - 12*s + 4) - 20*r**2 - 72*r*s + 55*r - 52*s**2 + 83*s - 31) + 24*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)))) + b1**2*(D1**2*(5*f*(4*fd - 5*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 50*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 5*fd*(r + s)*(5*r + s*(9 - 4*K)) - 6*fdd*(r + s)*(5*r + s*(9 - 4*K))) + D1*(40*Dd*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*Dd*f*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) + 10*fd*(4*r + 4*s - 3)**2 - 20*r**2 - 56*r*s + 34*r - 36*s**2 + 46*s - 19) - 12*Dd*fd*(20*r**2 + r*(K*(2 - 16*s) + 56*s - 17) + s*(K*(8 - 16*s) + 36*s - 23)) - 50*Ddd*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 6*Ddd*f*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r**2 + r*(34 - 56*s) - 36*s**2 + 46*s - 19)) - 12*Dd**2*f*(K*(-24*r*s + 6*r - 24*s**2 + 24*s - 4) + 25*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 30*r**2 + 84*r*s - 51*r + 54*s**2 - 69*s + 19)) + b1*(-64*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s + 80*C*D1**2*f*fdd*r*s + 80*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 80*C*D1**2*fd**2*r*s + 80*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 128*C*D1*Dd*f**2*r*s + 32*C*D1*Dd*f**2*r - 128*C*D1*Dd*f**2*s**2 + 128*C*D1*Dd*f**2*s - 32*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*r*s - 80*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 480*C*D1*Dd*f*fd*s + 40*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r*s - 40*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 160*C*D1*Ddd*f**2*s + 40*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r*s - 120*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 480*C*Dd**2*f**2*s + 80*C*Dd**2*f**2 - D1**2*bdd1*f*(25*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + (12*r + 12*s - 12)*(-4*K*s + 2*K + 5*r + 9*s - 7)) - 135*D1**2*f**2*fd*r**2 - 330*D1**2*f**2*fd*r*s + 160*D1**2*f**2*fd*r - 195*D1**2*f**2*fd*s**2 + 200*D1**2*f**2*fd*s - 70*D1**2*f**2*fd + 165*D1**2*f**2*fdd*r**2 + 330*D1**2*f**2*fdd*r*s - 200*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 90*D1**2*f**2*fdd + 330*D1**2*f*fd**2*r**2 + 660*D1**2*f*fd**2*r*s - 400*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 + 40*D1**2*f*fd*r**2 + 144*D1**2*f*fd*r*s - 40*D1**2*f*fd*r + 104*D1**2*f*fd*s**2 - 72*D1**2*f*fd*s + 20*D1**2*f*fd - 50*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 50*D1**2*f*fdd*r - 130*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 25*D1**2*f*fdd + 40*D1**2*f*gd2*r*s + 40*D1**2*f*gd2*s**2 - 40*D1**2*f*gd2*s - 48*D1**2*f*gdd2*r*s - 48*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 50*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 50*D1**2*fd**2*r - 130*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 40*D1**2*fd*g2*r*s + 40*D1**2*fd*g2*s**2 - 96*D1**2*fd*gd2*r*s - 96*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 48*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*s**2 - 180*D1*Dd*f**3*r**2 - 440*D1*Dd*f**3*r*s + 290*D1*Dd*f**3*r - 260*D1*Dd*f**3*s**2 + 350*D1*Dd*f**3*s - 155*D1*Dd*f**3 + 1320*D1*Dd*f**2*fd*r**2 + 2640*D1*Dd*f**2*fd*r*s - 1790*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1790*D1*Dd*f**2*fd*s + 600*D1*Dd*f**2*fd + 80*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 152*D1*Dd*f**2*r + 208*D1*Dd*f**2*s**2 - 248*D1*Dd*f**2*s + 92*D1*Dd*f**2 - 400*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 580*D1*Dd*f*fd*r - 1040*D1*Dd*f*fd*s**2 + 980*D1*Dd*f*fd*s - 190*D1*Dd*f*fd + 160*D1*Dd*f*g2*r*s - 40*D1*Dd*f*g2*r + 160*D1*Dd*f*g2*s**2 - 160*D1*Dd*f*g2*s + 40*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r*s + 48*D1*Dd*f*gd2*r - 384*D1*Dd*f*gd2*s**2 + 384*D1*Dd*f*gd2*s - 48*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r*s + 48*D1*Dd*fd*g2*r - 384*D1*Dd*fd*g2*s**2 + 192*D1*Dd*fd*g2*s + 220*D1*Ddd*f**3*r**2 + 440*D1*Ddd*f**3*r*s - 330*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 330*D1*Ddd*f**3*s + 165*D1*Ddd*f**3 - 100*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 190*D1*Ddd*f**2*r - 260*D1*Ddd*f**2*s**2 + 310*D1*Ddd*f**2*s - 115*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r*s + 48*D1*Ddd*f*g2*r - 192*D1*Ddd*f*g2*s**2 + 192*D1*Ddd*f*g2*s - 48*D1*Ddd*f*g2 + 2*D1*bd1*(10*D1*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*D1*f*(r + s - 1)*(4*K*s - 2*K + 20*fd*(2*r + 2*s - 1) - 5*r - 9*s + 7) - 12*D1*fd*(5*r**2 + r*(-4*K*s + K + 14*s - 6) + s*(-4*K*s + 3*K + 9*s - 8)) - 25*Dd*f**2*(4*r + 4*s - 3)**2 + 12*Dd*f*(K*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - 20*r**2 - 56*r*s + 41*r - 36*s**2 + 55*s - 20)) + 660*Dd**2*f**3*r**2 + 1320*Dd**2*f**3*r*s - 990*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 990*Dd**2*f**3*s + 330*Dd**2*f**3 - 300*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 570*Dd**2*f**2*r - 780*Dd**2*f**2*s**2 + 930*Dd**2*f**2*s - 230*Dd**2*f**2 - 576*Dd**2*f*g2*r*s + 144*Dd**2*f*g2*r - 576*Dd**2*f*g2*s**2 + 576*Dd**2*f*g2*s - 96*Dd**2*f*g2))/(21*d**2*k2*k3**5) - 3*D1**2*Pk2*Pkd3*ct*k1**3*k2**3*st**2*(264*C*D1**2*bdd1*f**2*r**2 + 528*C*D1**2*bdd1*f**2*r*s - 528*C*D1**2*bdd1*f**2*r + 264*C*D1**2*bdd1*f**2*s**2 - 528*C*D1**2*bdd1*f**2*s + 264*C*D1**2*bdd1*f**2 - 540*C*D1**2*f**2*fd*r**2 - 1080*C*D1**2*f**2*fd*r*s + 720*C*D1**2*f**2*fd*r - 540*C*D1**2*f**2*fd*s**2 + 720*C*D1**2*f**2*fd*s - 360*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r**2 + 1200*C*D1**2*f**2*fdd*r*s - 800*C*D1**2*f**2*fdd*r + 600*C*D1**2*f**2*fdd*s**2 - 800*C*D1**2*f**2*fdd*s + 400*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r**2 + 2400*C*D1**2*f*fd**2*r*s - 1600*C*D1**2*f*fd**2*r + 1200*C*D1**2*f*fd**2*s**2 - 1600*C*D1**2*f*fd**2*s + 400*C*D1**2*f*fd**2 - 720*C*D1*Dd*f**3*r**2 - 1440*C*D1*Dd*f**3*r*s + 1080*C*D1*Dd*f**3*r - 720*C*D1*Dd*f**3*s**2 + 1080*C*D1*Dd*f**3*s - 540*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r**2 + 9600*C*D1*Dd*f**2*fd*r*s - 6800*C*D1*Dd*f**2*fd*r + 4800*C*D1*Dd*f**2*fd*s**2 - 6800*C*D1*Dd*f**2*fd*s + 2400*C*D1*Dd*f**2*fd + 800*C*D1*Ddd*f**3*r**2 + 1600*C*D1*Ddd*f**3*r*s - 1200*C*D1*Ddd*f**3*r + 800*C*D1*Ddd*f**3*s**2 - 1200*C*D1*Ddd*f**3*s + 600*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r**2 + 4800*C*Dd**2*f**3*r*s - 3600*C*Dd**2*f**3*r + 2400*C*Dd**2*f**3*s**2 - 3600*C*Dd**2*f**3*s + 1200*C*Dd**2*f**3 + 132*D1**2*K*bdd1*f**2*r**2 + 264*D1**2*K*bdd1*f**2*r*s - 264*D1**2*K*bdd1*f**2*r + 132*D1**2*K*bdd1*f**2*s**2 - 264*D1**2*K*bdd1*f**2*s + 132*D1**2*K*bdd1*f**2 - 132*D1**2*bd1**2*f*(-2*K + 5*f + 1)*(r + s - 1)**2 - 198*D1**2*bdd1*f**2*r**2 - 396*D1**2*bdd1*f**2*r*s + 396*D1**2*bdd1*f**2*r - 198*D1**2*bdd1*f**2*s**2 + 396*D1**2*bdd1*f**2*s - 198*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r**2 - 528*D1**2*bdd1*f*g2*r*s + 528*D1**2*bdd1*f*g2*r - 264*D1**2*bdd1*f*g2*s**2 + 528*D1**2*bdd1*f*g2*s - 264*D1**2*bdd1*f*g2 + 237*D1**2*f**2*fd*r**2 + 474*D1**2*f**2*fd*r*s - 316*D1**2*f**2*fd*r + 237*D1**2*f**2*fd*s**2 - 316*D1**2*f**2*fd*s + 158*D1**2*f**2*fd - 300*D1**2*f**2*fdd*r**2 - 600*D1**2*f**2*fdd*r*s + 400*D1**2*f**2*fdd*r - 300*D1**2*f**2*fdd*s**2 + 400*D1**2*f**2*fdd*s - 200*D1**2*f**2*fdd + 308*D1**2*f**2*gd2*r**2 + 616*D1**2*f**2*gd2*r*s - 616*D1**2*f**2*gd2*r + 308*D1**2*f**2*gd2*s**2 - 616*D1**2*f**2*gd2*s + 308*D1**2*f**2*gd2 - 264*D1**2*f**2*gdd2*r**2 - 528*D1**2*f**2*gdd2*r*s + 528*D1**2*f**2*gdd2*r - 264*D1**2*f**2*gdd2*s**2 + 528*D1**2*f**2*gdd2*s - 264*D1**2*f**2*gdd2 - 600*D1**2*f*fd**2*r**2 - 1200*D1**2*f*fd**2*r*s + 800*D1**2*f*fd**2*r - 600*D1**2*f*fd**2*s**2 + 800*D1**2*f*fd**2*s - 200*D1**2*f*fd**2 + 616*D1**2*f*fd*g2*r**2 + 1232*D1**2*f*fd*g2*r*s - 616*D1**2*f*fd*g2*r + 616*D1**2*f*fd*g2*s**2 - 616*D1**2*f*fd*g2*s + 308*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r**2 - 2112*D1**2*f*fd*gd2*r*s + 1584*D1**2*f*fd*gd2*r - 1056*D1**2*f*fd*gd2*s**2 + 1584*D1**2*f*fd*gd2*s - 528*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r**2 - 1056*D1**2*f*fdd*g2*r*s + 528*D1**2*f*fdd*g2*r - 528*D1**2*f*fdd*g2*s**2 + 528*D1**2*f*fdd*g2*s - 264*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r**2 - 1056*D1**2*fd**2*g2*r*s + 528*D1**2*fd**2*g2*r - 528*D1**2*fd**2*g2*s**2 + 528*D1**2*fd**2*g2*s + 316*D1*Dd*f**3*r**2 + 632*D1*Dd*f**3*r*s - 474*D1*Dd*f**3*r + 316*D1*Dd*f**3*s**2 - 474*D1*Dd*f**3*s + 237*D1*Dd*f**3 - 2400*D1*Dd*f**2*fd*r**2 - 4800*D1*Dd*f**2*fd*r*s + 3400*D1*Dd*f**2*fd*r - 2400*D1*Dd*f**2*fd*s**2 + 3400*D1*Dd*f**2*fd*s - 1200*D1*Dd*f**2*fd + 1232*D1*Dd*f**2*g2*r**2 + 2464*D1*Dd*f**2*g2*r*s - 1848*D1*Dd*f**2*g2*r + 1232*D1*Dd*f**2*g2*s**2 - 1848*D1*Dd*f**2*g2*s + 924*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r**2 - 4224*D1*Dd*f**2*gd2*r*s + 3696*D1*Dd*f**2*gd2*r - 2112*D1*Dd*f**2*gd2*s**2 + 3696*D1*Dd*f**2*gd2*s - 1584*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r**2 - 8448*D1*Dd*f*fd*g2*r*s + 5280*D1*Dd*f*fd*g2*r - 4224*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1584*D1*Dd*f*fd*g2 - 400*D1*Ddd*f**3*r**2 - 800*D1*Ddd*f**3*r*s + 600*D1*Ddd*f**3*r - 400*D1*Ddd*f**3*s**2 + 600*D1*Ddd*f**3*s - 300*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r**2 - 2112*D1*Ddd*f**2*g2*r*s + 1584*D1*Ddd*f**2*g2*r - 1056*D1*Ddd*f**2*g2*s**2 + 1584*D1*Ddd*f**2*g2*s - 792*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(f**2*(22*C + 7*K - 16)*(r + s - 1) - 2*f*(3*fd*(4*C + 2*K - 3)*(2*r + 2*s - 1) + (19*g2 - 12*gd2)*(r + s - 1)) + 24*fd*g2*(r + s)) - 6*Dd*f*(f*(4*C + 2*K - 3) - 4*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1200*Dd**2*f**3*r**2 - 2400*Dd**2*f**3*r*s + 1800*Dd**2*f**3*r - 1200*Dd**2*f**3*s**2 + 1800*Dd**2*f**3*s - 600*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r**2 - 6336*Dd**2*f**2*g2*r*s + 4752*Dd**2*f**2*g2*r - 3168*Dd**2*f**2*g2*s**2 + 4752*Dd**2*f**2*g2*s - 1584*Dd**2*f**2*g2 + 11*b1**2*(D1**2*(3*f*(17*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(60*fd**2*(r + s - 1) + 19*fd*(2*K - 1)*(r + s) - 6*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(51*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (38*K - 19)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-2*K + 5*f + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-2*K + 5*f + 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*(-44*C*D1**2*f*fd*r**2 - 88*C*D1**2*f*fd*r*s + 44*C*D1**2*f*fd*r - 44*C*D1**2*f*fd*s**2 + 44*C*D1**2*f*fd*s - 22*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 88*C*D1*Dd*f**2*r**2 - 176*C*D1*Dd*f**2*r*s + 132*C*D1*Dd*f**2*r - 88*C*D1*Dd*f**2*s**2 + 132*C*D1*Dd*f**2*s - 66*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 14*D1**2*K*f*fd*r**2 - 28*D1**2*K*f*fd*r*s + 14*D1**2*K*f*fd*r - 14*D1**2*K*f*fd*s**2 + 14*D1**2*K*f*fd*s - 7*D1**2*K*f*fd + 12*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 12*D1**2*K*f*fdd*s**2 - 12*D1**2*K*f*fdd*s + 6*D1**2*K*f*fdd + 12*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 12*D1**2*K*fd**2*s**2 - 12*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-2*K + 5*f + 1)*(r + s - 1)**2 + 32*D1**2*f*fd*r**2 + 64*D1**2*f*fd*r*s - 32*D1**2*f*fd*r + 32*D1**2*f*fd*s**2 - 32*D1**2*f*fd*s + 16*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 38*D1**2*f*gd2*r**2 + 76*D1**2*f*gd2*r*s - 76*D1**2*f*gd2*r + 38*D1**2*f*gd2*s**2 - 76*D1**2*f*gd2*s + 38*D1**2*f*gd2 - 12*D1**2*f*gdd2*r**2 - 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*r - 12*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 12*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 38*D1**2*fd*g2*r**2 + 76*D1**2*fd*g2*r*s + 38*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r**2 - 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 24*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r**2 - 24*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 28*D1*Dd*K*f**2*r**2 - 56*D1*Dd*K*f**2*r*s + 42*D1*Dd*K*f**2*r - 28*D1*Dd*K*f**2*s**2 + 42*D1*Dd*K*f**2*s - 21*D1*Dd*K*f**2 + 96*D1*Dd*K*f*fd*r**2 + 192*D1*Dd*K*f*fd*r*s - 120*D1*Dd*K*f*fd*r + 96*D1*Dd*K*f*fd*s**2 - 120*D1*Dd*K*f*fd*s + 36*D1*Dd*K*f*fd + 64*D1*Dd*f**2*r**2 + 128*D1*Dd*f**2*r*s - 96*D1*Dd*f**2*r + 64*D1*Dd*f**2*s**2 - 96*D1*Dd*f**2*s + 48*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 152*D1*Dd*f*g2*r**2 + 304*D1*Dd*f*g2*r*s - 228*D1*Dd*f*g2*r + 152*D1*Dd*f*g2*s**2 - 228*D1*Dd*f*g2*s + 114*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r**2 - 192*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 168*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r**2 - 192*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 72*D1*Dd*fd*g2*s + 24*D1*Ddd*K*f**2*r**2 + 48*D1*Ddd*K*f**2*r*s - 36*D1*Ddd*K*f**2*r + 24*D1*Ddd*K*f**2*s**2 - 36*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r**2 - 96*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 72*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + D1*bd1*(D1*(51*f**2*(r + s - 1) - 60*f*fd*(2*r + 2*s - 1) - 19*f*(2*K - 1)*(r + s - 1) + 12*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-2*K + 5*f + 1)*(4*r + 4*s - 3))*(r + s - 1) + 72*Dd**2*K*f**2*r**2 + 144*Dd**2*K*f**2*r*s - 108*Dd**2*K*f**2*r + 72*Dd**2*K*f**2*s**2 - 108*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 144*Dd**2*f*g2*r**2 - 288*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 216*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(154*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct*k1**3*k2**3*(-2*D1*(r + s - 1)*(24*D1*K*bd1**2*f*(r + s - 1) - D1*bd1*(f**2*(4*C + 1)*(r + s - 1) - f*fd*(40*C - 20)*(2*r + 2*s - 1) - 6*f*(g2 - 8*gd2)*(r + s - 1) + 48*fd*g2*(r + s)) + 2*D1*bdd1*f*(f*(10*C - 5) - 12*g2)*(r + s - 1) + 4*Dd*bd1*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3)) + b1**2*(D1**2*(18*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-24*K*fdd + fd*(6*K + 7))) + D1*(Dd*(-48*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(6*K + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 144*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(D1**2*(f*(fd*(4*C + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*(r + s - 1)**2*(12*K*bdd1 + 3*gd2 - 12*gdd2)) + (-2*r - 2*s)*(fd**2*(20*C - 10)*(r + s - 1) + 3*fd*(g2*(r + s) - 8*gd2*(r + s - 1)) - 12*fdd*g2*(r + s))) + D1*bd1*(D1*(-48*K*fd*(r + s) + 18*f**2*(r + s - 1) + f*(6*K + 7)*(r + s - 1)) - 48*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(4*C + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 3*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 24*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 48*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(f*(10*C - 5) - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**7) + D1**2*Pk2*Pkd3*ct*k1**3*k2*st**2*(132*C*D1**2*bdd1*f**2*r**2 + 264*C*D1**2*bdd1*f**2*r*s - 1584*C*D1**2*bdd1*f**2*r + 132*C*D1**2*bdd1*f**2*s**2 - 1584*C*D1**2*bdd1*f**2*s + 792*C*D1**2*bdd1*f**2 - 14052*C*D1**2*f**2*fd*r**2 - 36912*C*D1**2*f**2*fd*r*s + 21672*C*D1**2*f**2*fd*r - 22860*C*D1**2*f**2*fd*s**2 + 27544*C*D1**2*f**2*fd*s - 12304*C*D1**2*f**2*fd + 13164*C*D1**2*f**2*fdd*r**2 + 34296*C*D1**2*f**2*fdd*r*s - 20208*C*D1**2*f**2*fdd*r + 21132*C*D1**2*f**2*fdd*s**2 - 25520*C*D1**2*f**2*fdd*s + 11432*C*D1**2*f**2*fdd + 26328*C*D1**2*f*fd**2*r**2 + 68592*C*D1**2*f*fd**2*r*s - 40416*C*D1**2*f*fd**2*r + 42264*C*D1**2*f*fd**2*s**2 - 51040*C*D1**2*f*fd**2*s + 11432*C*D1**2*f*fd**2 - 18736*C*D1*Dd*f**3*r**2 - 49216*C*D1*Dd*f**3*r*s + 31040*C*D1*Dd*f**3*r - 30480*C*D1*Dd*f**3*s**2 + 39848*C*D1*Dd*f**3*s - 16988*C*D1*Dd*f**3 + 105312*C*D1*Dd*f**2*fd*r**2 + 274368*C*D1*Dd*f**2*fd*r*s - 167784*C*D1*Dd*f**2*fd*r + 169056*C*D1*Dd*f**2*fd*s**2 - 212936*C*D1*Dd*f**2*fd*s + 65936*C*D1*Dd*f**2*fd + 17552*C*D1*Ddd*f**3*r**2 + 45728*C*D1*Ddd*f**3*r*s - 28984*C*D1*Ddd*f**3*r + 28176*C*D1*Ddd*f**3*s**2 - 36952*C*D1*Ddd*f**3*s + 15820*C*D1*Ddd*f**3 + 52656*C*Dd**2*f**3*r**2 + 137184*C*Dd**2*f**3*r*s - 86952*C*Dd**2*f**3*r + 84528*C*Dd**2*f**3*s**2 - 110856*C*Dd**2*f**3*s + 31640*C*Dd**2*f**3 + 2706*D1**2*K*bdd1*f**2*r**2 + 6996*D1**2*K*bdd1*f**2*r*s - 5412*D1**2*K*bdd1*f**2*r + 4290*D1**2*K*bdd1*f**2*s**2 - 6996*D1**2*K*bdd1*f**2*s + 2706*D1**2*K*bdd1*f**2 - 5280*D1**2*b2*f*fd*r**2 - 10560*D1**2*b2*f*fd*r*s + 5280*D1**2*b2*f*fd*r - 5280*D1**2*b2*f*fd*s**2 + 5280*D1**2*b2*f*fd*s - 2640*D1**2*b2*f*fd + 3960*D1**2*b2*f*fdd*r**2 + 7920*D1**2*b2*f*fdd*r*s - 3960*D1**2*b2*f*fdd*r + 3960*D1**2*b2*f*fdd*s**2 - 3960*D1**2*b2*f*fdd*s + 1980*D1**2*b2*f*fdd + 3960*D1**2*b2*fd**2*r**2 + 7920*D1**2*b2*fd**2*r*s - 3960*D1**2*b2*fd**2*r + 3960*D1**2*b2*fd**2*s**2 - 3960*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*f*(r + s - 1)*(-2*K*(r + s - 6) + 90*f*(r + s - 1) + 37*r + 37*s - 42) - 2640*D1**2*bd2*f**2*r**2 - 5280*D1**2*bd2*f**2*r*s + 5280*D1**2*bd2*f**2*r - 2640*D1**2*bd2*f**2*s**2 + 5280*D1**2*bd2*f**2*s - 2640*D1**2*bd2*f**2 + 7920*D1**2*bd2*f*fd*r**2 + 15840*D1**2*bd2*f*fd*r*s - 11880*D1**2*bd2*f*fd*r + 7920*D1**2*bd2*f*fd*s**2 - 11880*D1**2*bd2*f*fd*s + 3960*D1**2*bd2*f*fd + 1584*D1**2*bdd1*f**3*r**2 - 1584*D1**2*bdd1*f**3*r - 1584*D1**2*bdd1*f**3*s**2 + 1584*D1**2*bdd1*f**3*s - 1650*D1**2*bdd1*f**2*r**2 - 4092*D1**2*bdd1*f**2*r*s + 4290*D1**2*bdd1*f**2*r - 2442*D1**2*bdd1*f**2*s**2 + 5082*D1**2*bdd1*f**2*s - 2145*D1**2*bdd1*f**2 - 132*D1**2*bdd1*f*g2*r**2 - 264*D1**2*bdd1*f*g2*r*s + 1584*D1**2*bdd1*f*g2*r - 132*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 + 1980*D1**2*bdd2*f**2*r**2 + 3960*D1**2*bdd2*f**2*r*s - 3960*D1**2*bdd2*f**2*r + 1980*D1**2*bdd2*f**2*s**2 - 3960*D1**2*bdd2*f**2*s + 1980*D1**2*bdd2*f**2 + 7326*D1**2*f**2*fd*r**2 + 21456*D1**2*f**2*fd*r*s - 12036*D1**2*f**2*fd*r + 14130*D1**2*f**2*fd*s**2 - 16572*D1**2*f**2*fd*s + 7152*D1**2*f**2*fd - 7623*D1**2*f**2*fdd*r**2 - 21222*D1**2*f**2*fdd*r*s + 12156*D1**2*f**2*fdd*r - 13599*D1**2*f**2*fdd*s**2 + 16140*D1**2*f**2*fdd*s - 7074*D1**2*f**2*fdd + 6732*D1**2*f**2*gd2*r**2 + 17424*D1**2*f**2*gd2*r*s - 13464*D1**2*f**2*gd2*r + 10692*D1**2*f**2*gd2*s**2 - 17424*D1**2*f**2*gd2*s + 6732*D1**2*f**2*gd2 - 5412*D1**2*f**2*gdd2*r**2 - 13992*D1**2*f**2*gdd2*r*s + 10824*D1**2*f**2*gdd2*r - 8580*D1**2*f**2*gdd2*s**2 + 13992*D1**2*f**2*gdd2*s - 5412*D1**2*f**2*gdd2 - 15246*D1**2*f*fd**2*r**2 - 42444*D1**2*f*fd**2*r*s + 24312*D1**2*f*fd**2*r - 27198*D1**2*f*fd**2*s**2 + 32280*D1**2*f*fd**2*s - 7074*D1**2*f*fd**2 + 13464*D1**2*f*fd*g2*r**2 + 34848*D1**2*f*fd*g2*r*s - 17424*D1**2*f*fd*g2*r + 21384*D1**2*f*fd*g2*s**2 - 21384*D1**2*f*fd*g2*s + 10692*D1**2*f*fd*g2 - 21648*D1**2*f*fd*gd2*r**2 - 55968*D1**2*f*fd*gd2*r*s + 35640*D1**2*f*fd*gd2*r - 34320*D1**2*f*fd*gd2*s**2 + 45144*D1**2*f*fd*gd2*s - 13992*D1**2*f*fd*gd2 - 10824*D1**2*f*fdd*g2*r**2 - 27984*D1**2*f*fdd*g2*r*s + 13992*D1**2*f*fdd*g2*r - 17160*D1**2*f*fdd*g2*s**2 + 17160*D1**2*f*fdd*g2*s - 8580*D1**2*f*fdd*g2 - 10824*D1**2*fd**2*g2*r**2 - 27984*D1**2*fd**2*g2*r*s + 13992*D1**2*fd**2*g2*r - 17160*D1**2*fd**2*g2*s**2 + 17160*D1**2*fd**2*g2*s - 10560*D1*Dd*b2*f**2*r**2 - 21120*D1*Dd*b2*f**2*r*s + 15840*D1*Dd*b2*f**2*r - 10560*D1*Dd*b2*f**2*s**2 + 15840*D1*Dd*b2*f**2*s - 7920*D1*Dd*b2*f**2 + 31680*D1*Dd*b2*f*fd*r**2 + 63360*D1*Dd*b2*f*fd*r*s - 39600*D1*Dd*b2*f*fd*r + 31680*D1*Dd*b2*f*fd*s**2 - 39600*D1*Dd*b2*f*fd*s + 11880*D1*Dd*b2*f*fd + 15840*D1*Dd*bd2*f**2*r**2 + 31680*D1*Dd*bd2*f**2*r*s - 27720*D1*Dd*bd2*f**2*r + 15840*D1*Dd*bd2*f**2*s**2 - 27720*D1*Dd*bd2*f**2*s + 11880*D1*Dd*bd2*f**2 + 9768*D1*Dd*f**3*r**2 + 28608*D1*Dd*f**3*r*s - 16920*D1*Dd*f**3*r + 18840*D1*Dd*f**3*s**2 - 23724*D1*Dd*f**3*s + 9594*D1*Dd*f**3 - 60984*D1*Dd*f**2*fd*r**2 - 169776*D1*Dd*f**2*fd*r*s + 100338*D1*Dd*f**2*fd*r - 108792*D1*Dd*f**2*fd*s**2 + 134202*D1*Dd*f**2*fd*s - 40452*D1*Dd*f**2*fd + 26928*D1*Dd*f**2*g2*r**2 + 69696*D1*Dd*f**2*g2*r*s - 44352*D1*Dd*f**2*g2*r + 42768*D1*Dd*f**2*g2*s**2 - 56232*D1*Dd*f**2*g2*s + 24156*D1*Dd*f**2*g2 - 43296*D1*Dd*f**2*gd2*r**2 - 111936*D1*Dd*f**2*gd2*r*s + 78936*D1*Dd*f**2*gd2*r - 68640*D1*Dd*f**2*gd2*s**2 + 101112*D1*Dd*f**2*gd2*s - 35640*D1*Dd*f**2*gd2 - 86592*D1*Dd*f*fd*g2*r**2 - 223872*D1*Dd*f*fd*g2*r*s + 127248*D1*Dd*f*fd*g2*r - 137280*D1*Dd*f*fd*g2*s**2 + 158928*D1*Dd*f*fd*g2*s - 45144*D1*Dd*f*fd*g2 + 7920*D1*Ddd*b2*f**2*r**2 + 15840*D1*Ddd*b2*f**2*r*s - 11880*D1*Ddd*b2*f**2*r + 7920*D1*Ddd*b2*f**2*s**2 - 11880*D1*Ddd*b2*f**2*s + 5940*D1*Ddd*b2*f**2 - 10164*D1*Ddd*f**3*r**2 - 28296*D1*Ddd*f**3*r*s + 17238*D1*Ddd*f**3*r - 18132*D1*Ddd*f**3*s**2 + 23214*D1*Ddd*f**3*s - 9615*D1*Ddd*f**3 - 21648*D1*Ddd*f**2*g2*r**2 - 55968*D1*Ddd*f**2*g2*r*s + 35640*D1*Ddd*f**2*g2*r - 34320*D1*Ddd*f**2*g2*s**2 + 45144*D1*Ddd*f**2*g2*s - 19404*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(3*f**3*(26*r**2 + r*(20*s - 38) - 6*s**2 - 6*s + 17) + f**2*(4*C*(7*r**2 + 2*r*(6*s - 11) + 5*s**2 - 20*s + 10) + 102*K*r**2 + 264*K*r*s - 204*K*r + 162*K*s**2 - 264*K*s + 102*K - 48*fd*(6*r**2 - 6*r - 6*s**2 + 4*s + 1) - 92*r**2 - 208*r*s + 206*r - 116*s**2 + 230*s - 99) - 2*f*fd*(8*C*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 3) + 2*K*(82*r**2 + 212*r*s - 135*r + 130*s**2 - 171*s + 53) - 100*r**2 - 248*r*s + 177*r - 148*s**2 + 213*s - 77) + 4*f*(g2*(33*r**2 + r*(52*s + 38) + 19*s**2 + 52*s - 26) + 2*gd2*(r**2 + r*(2*s - 7) + s**2 - 7*s + 6)) + 8*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(24*f**2*(8*r**2 - 8*r - 8*s**2 + 6*s + 1) + f*(4*C*(4*r**2 + r*(8*s - 27) + 4*s**2 - 27*s + 18) + K*(328*r**2 + 848*r*s - 598*r + 520*s**2 - 766*s + 270) - 200*r**2 - 496*r*s + 422*r - 296*s**2 + 506*s - 207) - 4*g2*(4*r**2 + r*(8*s - 27) + 4*s**2 - 27*s + 18))) + 23760*Dd**2*b2*f**2*r**2 + 47520*Dd**2*b2*f**2*r*s - 35640*Dd**2*b2*f**2*r + 23760*Dd**2*b2*f**2*s**2 - 35640*Dd**2*b2*f**2*s + 11880*Dd**2*b2*f**2 - 30492*Dd**2*f**3*r**2 - 84888*Dd**2*f**3*r*s + 51714*Dd**2*f**3*r - 54396*Dd**2*f**3*s**2 + 69642*Dd**2*f**3*s - 19230*Dd**2*f**3 - 64944*Dd**2*f**2*g2*r**2 - 167904*Dd**2*f**2*g2*r*s + 106920*Dd**2*f**2*g2*r - 102960*Dd**2*f**2*g2*s**2 + 135432*Dd**2*f**2*g2*s - 38808*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(-180*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(2*K*(33*r**2 + 52*r*s - 90*r + 19*s**2 - 90*s + 45) + 5*f*(64*r**2 + 2*r*(64*s - 35) + 64*s**2 - 70*s + 35) + 74*r**2 + 176*r*s + 90*r + 102*s**2 + 90*s - 45) - fdd*(-2*K*(r**2 + 2*r*(s + 5) + s**2 + 10*s - 5) + 90*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 37*r**2 + 74*r*s + 10*r + 37*s**2 + 10*s - 5)) + D1*(2*Dd*(80*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(K*(132*r**2 + 8*r*(26*s - 23) + 76*s**2 - 142*s + 85) - 90*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 148*r**2 + 352*r*s - 236*r + 204*s**2 - 278*s + 125) + fd*(4*r + 4*s - 3)*(2*K*(r + s + 5) - 37*r - 37*s - 5)) - Ddd*f*(-2*K + 90*f + 37)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-2*K + 90*f + 37)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-56*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r - 40*C*D1**2*f*fd*s**2 + 8*C*D1**2*f*fd*s - 8*C*D1**2*f*fd + 8*C*D1**2*f*fdd*r**2 + 16*C*D1**2*f*fdd*r*s + 32*C*D1**2*f*fdd*r + 8*C*D1**2*f*fdd*s**2 + 32*C*D1**2*f*fdd*s - 16*C*D1**2*f*fdd + 8*C*D1**2*fd**2*r**2 + 16*C*D1**2*fd**2*r*s + 32*C*D1**2*fd**2*r + 8*C*D1**2*fd**2*s**2 + 32*C*D1**2*fd**2*s - 40*C*D1**2*fd**2 - 112*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 160*C*D1*Dd*f**2*r - 80*C*D1*Dd*f**2*s**2 + 136*C*D1*Dd*f**2*s - 76*C*D1*Dd*f**2 + 64*C*D1*Dd*f*fd*r**2 + 128*C*D1*Dd*f*fd*r*s + 80*C*D1*Dd*f*fd*r + 64*C*D1*Dd*f*fd*s**2 + 80*C*D1*Dd*f*fd*s - 96*C*D1*Dd*f*fd + 16*C*D1*Ddd*f**2*r**2 + 32*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s**2 - 24*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 48*C*Dd**2*f**2*r**2 + 96*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s**2 - 72*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 204*D1**2*K*f*fd*r**2 - 528*D1**2*K*f*fd*r*s + 264*D1**2*K*f*fd*r - 324*D1**2*K*f*fd*s**2 + 324*D1**2*K*f*fd*s - 162*D1**2*K*f*fd + 164*D1**2*K*f*fdd*r**2 + 424*D1**2*K*f*fdd*r*s - 212*D1**2*K*f*fdd*r + 260*D1**2*K*f*fdd*s**2 - 260*D1**2*K*f*fdd*s + 130*D1**2*K*f*fdd + 164*D1**2*K*fd**2*r**2 + 424*D1**2*K*fd**2*r*s - 212*D1**2*K*fd**2*r + 260*D1**2*K*fd**2*s**2 - 260*D1**2*K*fd**2*s - D1**2*bdd1*f*(-2*K*(2*r**2 + 4*r*s - 14*r + 2*s**2 - 14*s + 7) + 180*f*(r + s - 1)**2 + 74*r**2 + 148*r*s - 158*r + 74*s**2 - 158*s + 79) - 234*D1**2*f**2*fd*r**2 - 180*D1**2*f**2*fd*r*s + 258*D1**2*f**2*fd*r + 54*D1**2*f**2*fd*s**2 + 66*D1**2*f**2*fd*s - 87*D1**2*f**2*fd + 144*D1**2*f**2*fdd*r**2 - 144*D1**2*f**2*fdd*r - 144*D1**2*f**2*fdd*s**2 + 48*D1**2*f**2*fdd*s + 48*D1**2*f**2*fdd + 288*D1**2*f*fd**2*r**2 - 288*D1**2*f*fd**2*r - 288*D1**2*f*fd**2*s**2 + 96*D1**2*f*fd**2*s + 48*D1**2*f*fd**2 + 184*D1**2*f*fd*r**2 + 416*D1**2*f*fd*r*s - 186*D1**2*f*fd*r + 232*D1**2*f*fd*s**2 - 210*D1**2*f*fd*s + 109*D1**2*f*fd - 100*D1**2*f*fdd*r**2 - 248*D1**2*f*fdd*r*s + 94*D1**2*f*fdd*r - 148*D1**2*f*fdd*s**2 + 118*D1**2*f*fdd*s - 59*D1**2*f*fdd - 132*D1**2*f*gd2*r**2 - 208*D1**2*f*gd2*r*s + 264*D1**2*f*gd2*r - 76*D1**2*f*gd2*s**2 + 208*D1**2*f*gd2*s - 132*D1**2*f*gd2 - 4*D1**2*f*gdd2*r**2 - 8*D1**2*f*gdd2*r*s + 8*D1**2*f*gdd2*r - 4*D1**2*f*gdd2*s**2 + 8*D1**2*f*gdd2*s - 4*D1**2*f*gdd2 - 100*D1**2*fd**2*r**2 - 248*D1**2*fd**2*r*s + 94*D1**2*fd**2*r - 148*D1**2*fd**2*s**2 + 118*D1**2*fd**2*s + 30*D1**2*fd**2 - 132*D1**2*fd*g2*r**2 - 208*D1**2*fd*g2*r*s + 360*D1**2*fd*g2*r - 76*D1**2*fd*g2*s**2 + 360*D1**2*fd*g2*s - 180*D1**2*fd*g2 - 8*D1**2*fd*gd2*r**2 - 16*D1**2*fd*gd2*r*s - 32*D1**2*fd*gd2*r - 8*D1**2*fd*gd2*s**2 - 32*D1**2*fd*gd2*s + 40*D1**2*fd*gd2 - 4*D1**2*fdd*g2*r**2 - 8*D1**2*fdd*g2*r*s - 40*D1**2*fdd*g2*r - 4*D1**2*fdd*g2*s**2 - 40*D1**2*fdd*g2*s + 20*D1**2*fdd*g2 - 408*D1*Dd*K*f**2*r**2 - 1056*D1*Dd*K*f**2*r*s + 672*D1*Dd*K*f**2*r - 648*D1*Dd*K*f**2*s**2 + 852*D1*Dd*K*f**2*s - 366*D1*Dd*K*f**2 + 1312*D1*Dd*K*f*fd*r**2 + 3392*D1*Dd*K*f*fd*r*s - 1928*D1*Dd*K*f*fd*r + 2080*D1*Dd*K*f*fd*s**2 - 2408*D1*Dd*K*f*fd*s + 684*D1*Dd*K*f*fd - 312*D1*Dd*f**3*r**2 - 240*D1*Dd*f**3*r*s + 372*D1*Dd*f**3*r + 72*D1*Dd*f**3*s**2 + 84*D1*Dd*f**3*s - 138*D1*Dd*f**3 + 1152*D1*Dd*f**2*fd*r**2 - 1152*D1*Dd*f**2*fd*r - 1152*D1*Dd*f**2*fd*s**2 + 480*D1*Dd*f**2*fd*s + 240*D1*Dd*f**2*fd + 368*D1*Dd*f**2*r**2 + 832*D1*Dd*f**2*r*s - 576*D1*Dd*f**2*r + 464*D1*Dd*f**2*s**2 - 648*D1*Dd*f**2*s + 300*D1*Dd*f**2 - 800*D1*Dd*f*fd*r**2 - 1984*D1*Dd*f*fd*r*s + 1024*D1*Dd*f*fd*r - 1184*D1*Dd*f*fd*s**2 + 1264*D1*Dd*f*fd*s - 306*D1*Dd*f*fd - 528*D1*Dd*f*g2*r**2 - 832*D1*Dd*f*g2*r*s + 736*D1*Dd*f*g2*r - 304*D1*Dd*f*g2*s**2 + 568*D1*Dd*f*g2*s - 340*D1*Dd*f*g2 - 32*D1*Dd*f*gd2*r**2 - 64*D1*Dd*f*gd2*r*s + 56*D1*Dd*f*gd2*r - 32*D1*Dd*f*gd2*s**2 + 56*D1*Dd*f*gd2*s - 24*D1*Dd*f*gd2 - 32*D1*Dd*fd*g2*r**2 - 64*D1*Dd*fd*g2*r*s - 136*D1*Dd*fd*g2*r - 32*D1*Dd*fd*g2*s**2 - 136*D1*Dd*fd*g2*s + 120*D1*Dd*fd*g2 + 328*D1*Ddd*K*f**2*r**2 + 848*D1*Ddd*K*f**2*r*s - 540*D1*Ddd*K*f**2*r + 520*D1*Ddd*K*f**2*s**2 - 684*D1*Ddd*K*f**2*s + 294*D1*Ddd*K*f**2 + 192*D1*Ddd*f**3*r**2 - 192*D1*Ddd*f**3*r - 192*D1*Ddd*f**3*s**2 + 96*D1*Ddd*f**3*s + 48*D1*Ddd*f**3 - 200*D1*Ddd*f**2*r**2 - 496*D1*Ddd*f**2*r*s + 324*D1*Ddd*f**2*r - 296*D1*Ddd*f**2*s**2 + 396*D1*Ddd*f**2*s - 174*D1*Ddd*f**2 - 16*D1*Ddd*f*g2*r**2 - 32*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r - 16*D1*Ddd*f*g2*s**2 + 24*D1*Ddd*f*g2*s - 12*D1*Ddd*f*g2 + D1*bd1*(D1*(5*f**2*(64*r**2 + 2*r*(64*s - 61) + 64*s**2 - 122*s + 61) + f*(2*K*(66*r**2 + 4*r*(26*s - 7) + 38*s**2 + 7) - 360*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 148*r**2 + 352*r*s - 414*r + 204*s**2 - 470*s + 221) + 2*fd*(r + s - 1)*(2*K*(2*r + 2*s + 5) - 74*r - 74*s - 5)) - 2*Dd*f*(4*r + 4*s - 3)*(-2*K*(2*r + 2*s - 7) + 180*f*(r + s - 1) + 74*r + 74*s - 79)) + 984*Dd**2*K*f**2*r**2 + 2544*Dd**2*K*f**2*r*s - 1620*Dd**2*K*f**2*r + 1560*Dd**2*K*f**2*s**2 - 2052*Dd**2*K*f**2*s + 588*Dd**2*K*f**2 + 576*Dd**2*f**3*r**2 - 576*Dd**2*f**3*r - 576*Dd**2*f**3*s**2 + 288*Dd**2*f**3*s + 96*Dd**2*f**3 - 600*Dd**2*f**2*r**2 - 1488*Dd**2*f**2*r*s + 972*Dd**2*f**2*r - 888*Dd**2*f**2*s**2 + 1188*Dd**2*f**2*s - 348*Dd**2*f**2 - 48*Dd**2*f*g2*r**2 - 96*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r - 48*Dd**2*f*g2*s**2 + 72*Dd**2*f*g2*s - 24*Dd**2*f*g2))/(1386*d**2*k3**5) + D1**2*Pk2*Pkd3*ct*k1**3*k2*(-2*D1**2*bd1**2*(r + s - 1)*(6*f**2*(29*r + 21*s - 25) - f*(-120*C*r - 120*C*s + K*(214*r + 286*s - 250) + 43*r + 19*s + 59) - 140*g2*(r + s)) + 4*D1**2*bdd1*f*(f*(94*C*r + 120*C*(s - 1) + 6*K*s - 58*r - 75*s + 75) + g2*(-107*r - 143*s + 143))*(r + s - 1) + 4*D1**2*(f**2*(-fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(12*gd2 - 12*gdd2)*(r + s - 1)) + f*(fd**2*(10*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 12*fd*(g2*(2*r*s - r + 2*s**2 - 2*s + 1) + gd2*(-4*r*s + r - 4*s**2 + 4*s - 1)) - 12*fdd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 12*fd**2*g2*(-2*r*s + r - s*(2*s - 2))) - 20*D1*b2*(-6*D1*bdd1*f*(r + s - 1) + bd1*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + 4*D1*bd1*(60*D1*bd2*f*(r + s - 1)**2 + D1*(-2*f**2*(r + s - 1)*(31*C*r + 45*C*(s - 1) - 13*r + s*(3*K - 24) + 24) + f*(fd*(C*(376*r**2 + 8*r*(107*s - 77) + 480*s**2 - 694*s + 214) + 6*K*(r*(4*s - 1) + (1 - 2*s)**2) - 232*r**2 - 532*r*s + 382*r - 300*s**2 + 433*s - 133) + (r + s - 1)*(67*g2*r + 111*g2*(s - 1) - 2*gd2*(107*r + 143*s - 125))) - 2*fd*g2*(107*r**2 + 125*r*(2*s - 1) + s*(143*s - 143))) + Dd*f*(f*(2*C*(376*r**2 + r*(856*s - 723) + 480*s**2 - 814*s + 334) + 6*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 464*r**2 - 1064*r*s + 897*r - 600*s**2 + 1016*s - 416) - 2*g2*(428*r**2 + r*(1000*s - 839) + 572*s**2 - 965*s + 393))) - 4*D1*f*(Dd*(f**2*(10*C - 5)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(5 - 10*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 12*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 12*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 24*fd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 4*Dd**2*f**2*(f*(10*C - 5) - 12*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - 5*b1**3*(3*D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(15*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 36*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 18*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 18*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(100*C*D1**2*fd*r**2 + 200*C*D1**2*fd*r*s - 200*C*D1**2*fd*r + 100*C*D1**2*fd*s**2 - 200*C*D1**2*fd*s + 100*C*D1**2*fd - 120*C*D1**2*fdd*r**2 - 240*C*D1**2*fdd*r*s + 240*C*D1**2*fdd*r - 120*C*D1**2*fdd*s**2 + 240*C*D1**2*fdd*s - 120*C*D1**2*fdd + 400*C*D1*Dd*f*r**2 + 800*C*D1*Dd*f*r*s - 600*C*D1*Dd*f*r + 400*C*D1*Dd*f*s**2 - 600*C*D1*Dd*f*s + 300*C*D1*Dd*f - 960*C*D1*Dd*fd*r**2 - 1920*C*D1*Dd*fd*r*s + 1680*C*D1*Dd*fd*r - 960*C*D1*Dd*fd*s**2 + 1680*C*D1*Dd*fd*s - 720*C*D1*Dd*fd - 480*C*D1*Ddd*f*r**2 - 960*C*D1*Ddd*f*r*s + 720*C*D1*Ddd*f*r - 480*C*D1*Ddd*f*s**2 + 720*C*D1*Ddd*f*s - 360*C*D1*Ddd*f - 1440*C*Dd**2*f*r**2 - 2880*C*Dd**2*f*r*s + 2160*C*Dd**2*f*r - 1440*C*Dd**2*f*s**2 + 2160*C*Dd**2*f*s - 720*C*Dd**2*f - 134*D1**2*K*fd*r**2 - 356*D1**2*K*fd*r*s - 222*D1**2*K*fd*s**2 + 214*D1**2*K*fdd*r**2 + 500*D1**2*K*fdd*r*s + 286*D1**2*K*fdd*s**2 + 5*D1**2*bdd1*(-14*K + 18*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 156*D1**2*f*fd*r**2 + 216*D1**2*f*fd*r*s - 96*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s + 48*D1**2*f*fd - 348*D1**2*f*fdd*r**2 - 600*D1**2*f*fdd*r*s + 348*D1**2*f*fdd*r - 252*D1**2*f*fdd*s**2 + 300*D1**2*f*fdd*s - 174*D1**2*f*fdd - 348*D1**2*fd**2*r**2 - 600*D1**2*fd**2*r*s + 348*D1**2*fd**2*r - 252*D1**2*fd**2*s**2 + 300*D1**2*fd**2*s - 107*D1**2*fd*r**2 - 166*D1**2*fd*r*s + 150*D1**2*fd*r - 59*D1**2*fd*s**2 + 150*D1**2*fd*s - 75*D1**2*fd + 43*D1**2*fdd*r**2 + 62*D1**2*fdd*r*s - 180*D1**2*fdd*r + 19*D1**2*fdd*s**2 - 180*D1**2*fdd*s + 90*D1**2*fdd - 280*D1**2*gd2*r**2 - 560*D1**2*gd2*r*s + 560*D1**2*gd2*r - 280*D1**2*gd2*s**2 + 560*D1**2*gd2*s - 280*D1**2*gd2 + 140*D1**2*gdd2*r**2 + 280*D1**2*gdd2*r*s - 280*D1**2*gdd2*r + 140*D1**2*gdd2*s**2 - 280*D1**2*gdd2*s + 140*D1**2*gdd2 - 536*D1*Dd*K*f*r**2 - 1424*D1*Dd*K*f*r*s + 892*D1*Dd*K*f*r - 888*D1*Dd*K*f*s**2 + 1156*D1*Dd*K*f*s - 490*D1*Dd*K*f + 1712*D1*Dd*K*fd*r**2 + 4000*D1*Dd*K*fd*r*s - 1356*D1*Dd*K*fd*r + 2288*D1*Dd*K*fd*s**2 - 1572*D1*Dd*K*fd*s + 312*D1*Dd*f**2*r**2 + 432*D1*Dd*f**2*r*s - 420*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 276*D1*Dd*f**2*s + 186*D1*Dd*f**2 - 2784*D1*Dd*f*fd*r**2 - 4800*D1*Dd*f*fd*r*s + 3384*D1*Dd*f*fd*r - 2016*D1*Dd*f*fd*s**2 + 2904*D1*Dd*f*fd*s - 996*D1*Dd*f*fd - 428*D1*Dd*f*r**2 - 664*D1*Dd*f*r*s + 594*D1*Dd*f*r - 236*D1*Dd*f*s**2 + 450*D1*Dd*f*s - 273*D1*Dd*f + 344*D1*Dd*fd*r**2 + 496*D1*Dd*fd*r*s - 954*D1*Dd*fd*r + 152*D1*Dd*fd*s**2 - 882*D1*Dd*fd*s + 540*D1*Dd*fd - 1120*D1*Dd*g2*r**2 - 2240*D1*Dd*g2*r*s + 1680*D1*Dd*g2*r - 1120*D1*Dd*g2*s**2 + 1680*D1*Dd*g2*s - 840*D1*Dd*g2 + 1120*D1*Dd*gd2*r**2 + 2240*D1*Dd*gd2*r*s - 1960*D1*Dd*gd2*r + 1120*D1*Dd*gd2*s**2 - 1960*D1*Dd*gd2*s + 840*D1*Dd*gd2 + 856*D1*Ddd*K*f*r**2 + 2000*D1*Ddd*K*f*r*s - 1356*D1*Ddd*K*f*r + 1144*D1*Ddd*K*f*s**2 - 1572*D1*Ddd*K*f*s + 714*D1*Ddd*K*f - 696*D1*Ddd*f**2*r**2 - 1200*D1*Ddd*f**2*r*s + 996*D1*Ddd*f**2*r - 504*D1*Ddd*f**2*s**2 + 852*D1*Ddd*f**2*s - 474*D1*Ddd*f**2 + 172*D1*Ddd*f*r**2 + 248*D1*Ddd*f*r*s - 234*D1*Ddd*f*r + 76*D1*Ddd*f*s**2 - 162*D1*Ddd*f*s + 105*D1*Ddd*f + 560*D1*Ddd*g2*r**2 + 1120*D1*Ddd*g2*r*s - 840*D1*Ddd*g2*r + 560*D1*Ddd*g2*s**2 - 840*D1*Ddd*g2*s + 420*D1*Ddd*g2 - 5*D1*bd1*(D1*(15*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 36*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-14*K + 18*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 2568*Dd**2*K*f*r**2 + 6000*Dd**2*K*f*r*s - 4068*Dd**2*K*f*r + 3432*Dd**2*K*f*s**2 - 4716*Dd**2*K*f*s + 1428*Dd**2*K*f - 2088*Dd**2*f**2*r**2 - 3600*Dd**2*f**2*r*s + 2988*Dd**2*f**2*r - 1512*Dd**2*f**2*s**2 + 2556*Dd**2*f**2*s - 948*Dd**2*f**2 + 516*Dd**2*f*r**2 + 744*Dd**2*f*r*s - 702*Dd**2*f*r + 228*Dd**2*f*s**2 - 486*Dd**2*f*s + 210*Dd**2*f + 1680*Dd**2*g2*r**2 + 3360*Dd**2*g2*r*s - 2520*Dd**2*g2*r + 1680*Dd**2*g2*s**2 - 2520*Dd**2*g2*s + 840*Dd**2*g2) + b1*(-496*C*D1**2*f*fd*r**2 - 1216*C*D1**2*f*fd*r*s + 496*C*D1**2*f*fd*r - 720*C*D1**2*f*fd*s**2 + 608*C*D1**2*f*fd*s - 248*C*D1**2*f*fd + 752*C*D1**2*f*fdd*r**2 + 1712*C*D1**2*f*fdd*r*s - 752*C*D1**2*f*fdd*r + 960*C*D1**2*f*fdd*s**2 - 856*C*D1**2*f*fdd*s + 376*C*D1**2*f*fdd + 752*C*D1**2*fd**2*r**2 + 1712*C*D1**2*fd**2*r*s - 752*C*D1**2*fd**2*r + 960*C*D1**2*fd**2*s**2 - 856*C*D1**2*fd**2*s - 992*C*D1*Dd*f**2*r**2 - 2432*C*D1*Dd*f**2*r*s + 1600*C*D1*Dd*f**2*r - 1440*C*D1*Dd*f**2*s**2 + 1936*C*D1*Dd*f**2*s - 856*C*D1*Dd*f**2 + 6016*C*D1*Dd*f*fd*r**2 + 13696*C*D1*Dd*f*fd*r*s - 7728*C*D1*Dd*f*fd*r + 7680*C*D1*Dd*f*fd*s**2 - 8768*C*D1*Dd*f*fd*s + 2360*C*D1*Dd*f*fd + 1504*C*D1*Ddd*f**2*r**2 + 3424*C*D1*Ddd*f**2*r*s - 2360*C*D1*Ddd*f**2*r + 1920*C*D1*Ddd*f**2*s**2 - 2672*C*D1*Ddd*f**2*s + 1232*C*D1*Ddd*f**2 + 4512*C*Dd**2*f**2*r**2 + 10272*C*Dd**2*f**2*r*s - 7080*C*Dd**2*f**2*r + 5760*C*Dd**2*f**2*s**2 - 8016*C*Dd**2*f**2*s + 2464*C*Dd**2*f**2 - 48*D1**2*K*f*fd*r*s + 24*D1**2*K*f*fd*r - 48*D1**2*K*f*fd*s**2 + 48*D1**2*K*f*fd*s - 24*D1**2*K*f*fd + 48*D1**2*K*f*fdd*r*s - 24*D1**2*K*f*fdd*r + 48*D1**2*K*f*fdd*s**2 - 48*D1**2*K*f*fdd*s + 24*D1**2*K*f*fdd + 48*D1**2*K*fd**2*r*s - 24*D1**2*K*fd**2*r + 48*D1**2*K*fd**2*s**2 - 48*D1**2*K*fd**2*s + 10*D1**2*bd1**2*(-14*K + 18*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2*D1**2*bdd1*(6*f**2*(29*r**2 + r*(50*s - 54) + 21*s**2 - 46*s + 25) + f*(60*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*K*(107*r**2 + 250*r*s - 232*r + 143*s**2 - 268*s + 125) - 43*r**2 - 62*r*s - 16*r - 19*s**2 - 40*s + 14) - 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 120*D1**2*bdd2*f*(r + s - 1)**2 + 208*D1**2*f*fd*r**2 + 592*D1**2*f*fd*r*s - 208*D1**2*f*fd*r + 384*D1**2*f*fd*s**2 - 296*D1**2*f*fd*s + 104*D1**2*f*fd - 464*D1**2*f*fdd*r**2 - 1064*D1**2*f*fdd*r*s + 464*D1**2*f*fdd*r - 600*D1**2*f*fdd*s**2 + 532*D1**2*f*fdd*s - 232*D1**2*f*fdd + 268*D1**2*f*gd2*r**2 + 712*D1**2*f*gd2*r*s - 536*D1**2*f*gd2*r + 444*D1**2*f*gd2*s**2 - 712*D1**2*f*gd2*s + 268*D1**2*f*gd2 - 428*D1**2*f*gdd2*r**2 - 1000*D1**2*f*gdd2*r*s + 856*D1**2*f*gdd2*r - 572*D1**2*f*gdd2*s**2 + 1000*D1**2*f*gdd2*s - 428*D1**2*f*gdd2 - 464*D1**2*fd**2*r**2 - 1064*D1**2*fd**2*r*s + 464*D1**2*fd**2*r - 600*D1**2*fd**2*s**2 + 532*D1**2*fd**2*s + 268*D1**2*fd*g2*r**2 + 712*D1**2*fd*g2*r*s + 444*D1**2*fd*g2*s**2 - 856*D1**2*fd*gd2*r**2 - 2000*D1**2*fd*gd2*r*s + 856*D1**2*fd*gd2*r - 1144*D1**2*fd*gd2*s**2 + 1000*D1**2*fd*gd2*s - 428*D1**2*fdd*g2*r**2 - 1000*D1**2*fdd*g2*r*s - 572*D1**2*fdd*g2*s**2 - 96*D1*Dd*K*f**2*r*s + 24*D1*Dd*K*f**2*r - 96*D1*Dd*K*f**2*s**2 + 96*D1*Dd*K*f**2*s - 24*D1*Dd*K*f**2 + 384*D1*Dd*K*f*fd*r*s - 144*D1*Dd*K*f*fd*r + 384*D1*Dd*K*f*fd*s**2 - 384*D1*Dd*K*f*fd*s + 96*D1*Dd*K*f*fd + 416*D1*Dd*f**2*r**2 + 1184*D1*Dd*f**2*r*s - 712*D1*Dd*f**2*r + 768*D1*Dd*f**2*s**2 - 976*D1*Dd*f**2*s + 400*D1*Dd*f**2 - 3712*D1*Dd*f*fd*r**2 - 8512*D1*Dd*f*fd*r*s + 4776*D1*Dd*f*fd*r - 4800*D1*Dd*f*fd*s**2 + 5456*D1*Dd*f*fd*s - 1460*D1*Dd*f*fd + 1072*D1*Dd*f*g2*r**2 + 2848*D1*Dd*f*g2*r*s - 1784*D1*Dd*f*g2*r + 1776*D1*Dd*f*g2*s**2 - 2312*D1*Dd*f*g2*s + 980*D1*Dd*f*g2 - 3424*D1*Dd*f*gd2*r**2 - 8000*D1*Dd*f*gd2*r*s + 6136*D1*Dd*f*gd2*r - 4576*D1*Dd*f*gd2*s**2 + 7144*D1*Dd*f*gd2*s - 2712*D1*Dd*f*gd2 - 3424*D1*Dd*fd*g2*r**2 - 8000*D1*Dd*fd*g2*r*s + 2712*D1*Dd*fd*g2*r - 4576*D1*Dd*fd*g2*s**2 + 3144*D1*Dd*fd*g2*s + 96*D1*Ddd*K*f**2*r*s - 24*D1*Ddd*K*f**2*r + 96*D1*Ddd*K*f**2*s**2 - 96*D1*Ddd*K*f**2*s + 24*D1*Ddd*K*f**2 - 928*D1*Ddd*f**2*r**2 - 2128*D1*Ddd*f**2*r*s + 1460*D1*Ddd*f**2*r - 1200*D1*Ddd*f**2*s**2 + 1664*D1*Ddd*f**2*s - 764*D1*Ddd*f**2 - 1712*D1*Ddd*f*g2*r**2 - 4000*D1*Ddd*f*g2*r*s + 2712*D1*Ddd*f*g2*r - 2288*D1*Ddd*f*g2*s**2 + 3144*D1*Ddd*f*g2*s - 1428*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(26*r**2 + 18*r*(2*s - 3) + 10*s**2 - 38*s + 23) + f*(100*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 268*K*r**2 - 712*K*r*s + 624*K*r - 444*K*s**2 + 800*K*s - 356*K - 24*fd*(58*r**2 + 100*r*s - 83*r + 42*s**2 - 71*s + 27) - 214*r**2 - 332*r*s + 230*r - 118*s**2 + 134*s - 91) - 4*fd*(60*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 286*K*s**2 + 268*K*s - r**2*(214*K + 43) + r*(-500*K*s + 232*K - 62*s + 82) - 19*s**2 + 70*s - 45) - 280*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 280*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(6*f**2*(116*r**2 + r*(200*s - 191) + 84*s**2 - 163*s + 77) + f*(60*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 2*K*(428*r**2 + 1000*r*s - 803*r + 572*s**2 - 929*s + 366) - 172*r**2 - 248*r*s + 85*r - 76*s**2 + s + 36) - 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 20*D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 288*Dd**2*K*f**2*r*s - 72*Dd**2*K*f**2*r + 288*Dd**2*K*f**2*s**2 - 288*Dd**2*K*f**2*s + 48*Dd**2*K*f**2 - 2784*Dd**2*f**2*r**2 - 6384*Dd**2*f**2*r*s + 4380*Dd**2*f**2*r - 3600*Dd**2*f**2*s**2 + 4992*Dd**2*f**2*s - 1528*Dd**2*f**2 - 5136*Dd**2*f*g2*r**2 - 12000*Dd**2*f*g2*r*s + 8136*Dd**2*f*g2*r - 6864*Dd**2*f*g2*s**2 + 9432*Dd**2*f*g2*s - 2856*Dd**2*f*g2 - 20*b2*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(21*d**2*k3**5) + D1**2*Pk2*Pkd3*ct*k1**3*st**2*(264*C*D1**2*bdd1*f**2*r*s + 264*C*D1**2*bdd1*f**2*s**2 - 2808*C*D1**2*f**2*fd*r*s + 936*C*D1**2*f**2*fd*r - 2808*C*D1**2*f**2*fd*s**2 + 2808*C*D1**2*f**2*fd*s - 936*C*D1**2*f**2*fd + 1800*C*D1**2*f**2*fdd*r*s - 600*C*D1**2*f**2*fdd*r + 1800*C*D1**2*f**2*fdd*s**2 - 1800*C*D1**2*f**2*fdd*s + 600*C*D1**2*f**2*fdd + 3600*C*D1**2*f*fd**2*r*s - 1200*C*D1**2*f*fd**2*r + 3600*C*D1**2*f*fd**2*s**2 - 3600*C*D1**2*f*fd**2*s + 600*C*D1**2*f*fd**2 - 3744*C*D1*Dd*f**3*r*s + 936*C*D1*Dd*f**3*r - 3744*C*D1*Dd*f**3*s**2 + 3744*C*D1*Dd*f**3*s - 936*C*D1*Dd*f**3 + 14400*C*D1*Dd*f**2*fd*r*s - 4200*C*D1*Dd*f**2*fd*r + 14400*C*D1*Dd*f**2*fd*s**2 - 14400*C*D1*Dd*f**2*fd*s + 3000*C*D1*Dd*f**2*fd + 2400*C*D1*Ddd*f**3*r*s - 600*C*D1*Ddd*f**3*r + 2400*C*D1*Ddd*f**3*s**2 - 2400*C*D1*Ddd*f**3*s + 600*C*D1*Ddd*f**3 + 7200*C*Dd**2*f**3*r*s - 1800*C*Dd**2*f**3*r + 7200*C*Dd**2*f**3*s**2 - 7200*C*Dd**2*f**3*s + 1200*C*Dd**2*f**3 + 396*D1**2*K*bdd1*f**2*r*s + 396*D1**2*K*bdd1*f**2*s**2 - 396*D1**2*K*bdd1*f**2*s - 1320*D1**2*b2*f*fd*r*s + 660*D1**2*b2*f*fd*r - 1320*D1**2*b2*f*fd*s**2 + 1320*D1**2*b2*f*fd*s - 660*D1**2*b2*f*fd + 792*D1**2*b2*f*fdd*r*s - 396*D1**2*b2*f*fdd*r + 792*D1**2*b2*f*fdd*s**2 - 792*D1**2*b2*f*fdd*s + 396*D1**2*b2*f*fdd + 792*D1**2*b2*fd**2*r*s - 396*D1**2*b2*fd**2*r + 792*D1**2*b2*fd**2*s**2 - 792*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*f*(-4*K*s**2 + 2*K*s + 3*f*(r**2 + r*(18*s - 11) + 17*s**2 - 25*s + 6) + r**2 + r*(-4*K*s + 18*s - 7) + 17*s**2 - 21*s + 6) - 660*D1**2*bd2*f**2*r*s - 660*D1**2*bd2*f**2*s**2 + 660*D1**2*bd2*f**2*s + 1584*D1**2*bd2*f*fd*r*s - 396*D1**2*bd2*f*fd*r + 1584*D1**2*bd2*f*fd*s**2 - 1584*D1**2*bd2*f*fd*s + 396*D1**2*bd2*f*fd + 1386*D1**2*bdd1*f**3*r**2 + 5148*D1**2*bdd1*f**3*r*s - 1386*D1**2*bdd1*f**3*r + 3762*D1**2*bdd1*f**3*s**2 - 2970*D1**2*bdd1*f**3*s + 693*D1**2*bdd1*f**3 + 330*D1**2*bdd1*f**2*r**2 + 792*D1**2*bdd1*f**2*r*s - 330*D1**2*bdd1*f**2*r + 462*D1**2*bdd1*f**2*s**2 - 726*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r*s - 264*D1**2*bdd1*f*g2*s**2 + 396*D1**2*bdd2*f**2*r*s + 396*D1**2*bdd2*f**2*s**2 - 396*D1**2*bdd2*f**2*s - 1191*D1**2*f**2*fd*r**2 - 3378*D1**2*f**2*fd*r*s + 1920*D1**2*f**2*fd*r - 2187*D1**2*f**2*fd*s**2 + 2584*D1**2*f**2*fd*s - 1126*D1**2*f**2*fd + 1041*D1**2*f**2*fdd*r**2 + 3174*D1**2*f**2*fdd*r*s - 1752*D1**2*f**2*fdd*r + 2133*D1**2*f**2*fdd*s**2 - 2480*D1**2*f**2*fdd*s + 1058*D1**2*f**2*fdd + 1320*D1**2*f**2*gd2*r*s + 1320*D1**2*f**2*gd2*s**2 - 1320*D1**2*f**2*gd2*s - 792*D1**2*f**2*gdd2*r*s - 792*D1**2*f**2*gdd2*s**2 + 792*D1**2*f**2*gdd2*s + 2082*D1**2*f*fd**2*r**2 + 6348*D1**2*f*fd**2*r*s - 3504*D1**2*f*fd**2*r + 4266*D1**2*f*fd**2*s**2 - 4960*D1**2*f*fd**2*s + 1058*D1**2*f*fd**2 + 2640*D1**2*f*fd*g2*r*s - 1320*D1**2*f*fd*g2*r + 2640*D1**2*f*fd*g2*s**2 - 2640*D1**2*f*fd*g2*s + 1320*D1**2*f*fd*g2 - 3168*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 3168*D1**2*f*fd*gd2*s**2 + 3168*D1**2*f*fd*gd2*s - 792*D1**2*f*fd*gd2 - 1584*D1**2*f*fdd*g2*r*s + 792*D1**2*f*fdd*g2*r - 1584*D1**2*f*fdd*g2*s**2 + 1584*D1**2*f*fdd*g2*s - 792*D1**2*f*fdd*g2 - 1584*D1**2*fd**2*g2*r*s + 792*D1**2*fd**2*g2*r - 1584*D1**2*fd**2*g2*s**2 + 1584*D1**2*fd**2*g2*s - 2640*D1*Dd*b2*f**2*r*s + 660*D1*Dd*b2*f**2*r - 2640*D1*Dd*b2*f**2*s**2 + 2640*D1*Dd*b2*f**2*s - 660*D1*Dd*b2*f**2 + 6336*D1*Dd*b2*f*fd*r*s - 2376*D1*Dd*b2*f*fd*r + 6336*D1*Dd*b2*f*fd*s**2 - 6336*D1*Dd*b2*f*fd*s + 1584*D1*Dd*b2*f*fd + 3168*D1*Dd*bd2*f**2*r*s - 396*D1*Dd*bd2*f**2*r + 3168*D1*Dd*bd2*f**2*s**2 - 3168*D1*Dd*bd2*f**2*s + 396*D1*Dd*bd2*f**2 - 1588*D1*Dd*f**3*r**2 - 4504*D1*Dd*f**3*r*s + 2714*D1*Dd*f**3*r - 2916*D1*Dd*f**3*s**2 + 3710*D1*Dd*f**3*s - 1523*D1*Dd*f**3 + 8328*D1*Dd*f**2*fd*r**2 + 25392*D1*Dd*f**2*fd*r*s - 14346*D1*Dd*f**2*fd*r + 17064*D1*Dd*f**2*fd*s**2 - 20534*D1*Dd*f**2*fd*s + 5984*D1*Dd*f**2*fd + 5280*D1*Dd*f**2*g2*r*s - 1320*D1*Dd*f**2*g2*r + 5280*D1*Dd*f**2*g2*s**2 - 5280*D1*Dd*f**2*g2*s + 1320*D1*Dd*f**2*g2 - 6336*D1*Dd*f**2*gd2*r*s + 792*D1*Dd*f**2*gd2*r - 6336*D1*Dd*f**2*gd2*s**2 + 6336*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 12672*D1*Dd*f*fd*g2*r*s + 4752*D1*Dd*f*fd*g2*r - 12672*D1*Dd*f*fd*g2*s**2 + 12672*D1*Dd*f*fd*g2*s - 3168*D1*Dd*f*fd*g2 + 1584*D1*Ddd*b2*f**2*r*s - 396*D1*Ddd*b2*f**2*r + 1584*D1*Ddd*b2*f**2*s**2 - 1584*D1*Ddd*b2*f**2*s + 396*D1*Ddd*b2*f**2 + 1388*D1*Ddd*f**3*r**2 + 4232*D1*Ddd*f**3*r*s - 2446*D1*Ddd*f**3*r + 2844*D1*Ddd*f**3*s**2 - 3538*D1*Ddd*f**3*s + 1405*D1*Ddd*f**3 - 3168*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 3168*D1*Ddd*f**2*g2*s**2 + 3168*D1*Ddd*f**2*g2*s - 792*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(3*f**3*(10*r**2 + 10*r*(6*s - 1) + 50*s**2 - 34*s + 5) + f**2*(8*C*s**2 + 20*K*s**2 - 20*K*s - 12*fd*(21*r**2 + r*(78*s - 34) + 57*s**2 - 60*s + 11) + 12*r**2 + r*(s*(8*C + 20*K + 24) - 2) + 12*s**2 - 10*s - 11) - 2*f*(fd*(16*C*s**2 - 12*C*s + 6*K*(r*(4*s - 1) + (1 - 2*s)**2) + 20*r**2 + r*(16*C*s - 4*C + 48*s - 27) + 28*s**2 - 37*s + 17) + 4*s*(9*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 8*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*Dd*f*(3*f**2*(56*r**2 + r*(208*s - 82) + 152*s**2 - 150*s + 29) + f*(32*C*s**2 - 16*C*s + 6*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 40*r**2 + 4*r*(8*C*s - C + 24*s - 13) + 56*s**2 - 82*s + 21) + 4*g2*(-8*r*s + r + s*(4 - 8*s)))) + 4752*Dd**2*b2*f**2*r*s - 1188*Dd**2*b2*f**2*r + 4752*Dd**2*b2*f**2*s**2 - 4752*Dd**2*b2*f**2*s + 792*Dd**2*b2*f**2 + 4164*Dd**2*f**3*r**2 + 12696*Dd**2*f**3*r*s - 7338*Dd**2*f**3*r + 8532*Dd**2*f**3*s**2 - 10614*Dd**2*f**3*s + 2810*Dd**2*f**3 - 9504*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 9504*Dd**2*f**2*g2*s**2 + 9504*Dd**2*f**2*g2*s - 1584*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(-6*fd**2*(r**2 + 18*r*s + 17*s**2 - 10*s - 1) + fd*(-36*K*(s - 1)*(r + s - 1) + 2*f*(3*r**2 + r*(94*s + 4) + 91*s**2 - 52*s - 7) + 9*r**2 + 78*r*s - 54*r + 69*s**2 - 90*s + 45) - fdd*(-4*K*(s - 1)*(r + s - 1) + 6*f*(r**2 + 18*r*s + 17*s**2 - 10*s - 1) + r**2 + 18*r*s - 6*r + 17*s**2 - 10*s + 5)) + D1*(Dd*(f**2*(12*r**2 + 2*r*(188*s - 53) + 364*s**2 - 370*s + 97) - 3*f*(12*K*(r*(4*s - 1) + (1 - 2*s)**2) + 4*fd*(4*r**2 + r*(72*s - 11) + 68*s**2 - 55*s + 5) - 12*r**2 - 104*r*s + 38*r - 92*s**2 + 98*s - 29) + 2*fd*(2*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 4*r**2 + r*(23 - 72*s) - 68*s**2 + 55*s - 11)) - Ddd*f*(-4*K*(r*(4*s - 1) + (1 - 2*s)**2) + 3*f*(4*r**2 + r*(72*s - 22) + 68*s**2 - 70*s + 19) + 4*r**2 + 72*r*s - 22*r + 68*s**2 - 70*s + 19)) - 2*Dd**2*f*(K*(-24*r*s + 6*r - 24*s**2 + 24*s - 4) + 3*f*(6*r**2 + 3*r*(36*s - 11) + 102*s**2 - 105*s + 19) + 6*r**2 + 108*r*s - 33*r + 102*s**2 - 105*s + 19)) + 33*b1*(-16*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s - 8*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r + 16*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 8*C*D1**2*f*fdd + 16*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r + 16*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s + 8*C*D1**2*fd**2 - 32*C*D1*Dd*f**2*r*s + 8*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 32*C*D1*Dd*f**2*s - 8*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r*s - 48*C*D1*Dd*f*fd*r + 128*C*D1*Dd*f*fd*s**2 - 160*C*D1*Dd*f*fd*s + 40*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r*s - 8*C*D1*Ddd*f**2*r + 32*C*D1*Ddd*f**2*s**2 - 32*C*D1*Ddd*f**2*s + 8*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r*s - 24*C*Dd**2*f**2*r + 96*C*Dd**2*f**2*s**2 - 96*C*Dd**2*f**2*s + 16*C*Dd**2*f**2 - 40*D1**2*K*f*fd*r*s + 20*D1**2*K*f*fd*r - 40*D1**2*K*f*fd*s**2 + 40*D1**2*K*f*fd*s - 20*D1**2*K*f*fd + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 24*D1**2*K*f*fdd*s**2 - 24*D1**2*K*f*fdd*s + 12*D1**2*K*f*fdd + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 24*D1**2*K*fd**2*s**2 - 24*D1**2*K*fd**2*s - D1**2*bdd1*f*(-8*K*s**2 + 4*K*s + 3*f*(2*r**2 + r*(36*s - 22) + 34*s**2 - 50*s + 21) + 2*r**2 - 2*r*(4*K*s - 18*s + 7) + 34*s**2 - 42*s + 13) - 90*D1**2*f**2*fd*r**2 - 540*D1**2*f**2*fd*r*s + 270*D1**2*f**2*fd*r - 450*D1**2*f**2*fd*s**2 + 558*D1**2*f**2*fd*s - 195*D1**2*f**2*fd + 126*D1**2*f**2*fdd*r**2 + 468*D1**2*f**2*fdd*r*s - 282*D1**2*f**2*fdd*r + 342*D1**2*f**2*fdd*s**2 - 450*D1**2*f**2*fdd*s + 177*D1**2*f**2*fdd + 252*D1**2*f*fd**2*r**2 + 936*D1**2*f*fd**2*r*s - 564*D1**2*f*fd**2*r + 684*D1**2*f*fd**2*s**2 - 900*D1**2*f*fd**2*s + 264*D1**2*f*fd**2 - 24*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 46*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 38*D1**2*f*fd*s - 35*D1**2*f*fd + 20*D1**2*f*fdd*r**2 + 48*D1**2*f*fdd*r*s - 34*D1**2*f*fdd*r + 28*D1**2*f*fdd*s**2 - 30*D1**2*f*fdd*s + 25*D1**2*f*fdd + 72*D1**2*f*gd2*r*s + 72*D1**2*f*gd2*s**2 - 72*D1**2*f*gd2*s - 8*D1**2*f*gdd2*r*s - 8*D1**2*f*gdd2*s**2 + 8*D1**2*f*gdd2*s + 20*D1**2*fd**2*r**2 + 48*D1**2*fd**2*r*s - 34*D1**2*fd**2*r + 28*D1**2*fd**2*s**2 - 30*D1**2*fd**2*s - 10*D1**2*fd**2 + 72*D1**2*fd*g2*r*s - 72*D1**2*fd*g2*r + 72*D1**2*fd*g2*s**2 - 144*D1**2*fd*g2*s + 72*D1**2*fd*g2 - 16*D1**2*fd*gd2*r*s + 8*D1**2*fd*gd2*r - 16*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 8*D1**2*fd*gd2 - 8*D1**2*fdd*g2*r*s + 8*D1**2*fdd*g2*r - 8*D1**2*fdd*g2*s**2 + 16*D1**2*fdd*g2*s - 8*D1**2*fdd*g2 - 80*D1*Dd*K*f**2*r*s + 20*D1*Dd*K*f**2*r - 80*D1*Dd*K*f**2*s**2 + 80*D1*Dd*K*f**2*s - 20*D1*Dd*K*f**2 + 192*D1*Dd*K*f*fd*r*s - 72*D1*Dd*K*f*fd*r + 192*D1*Dd*K*f*fd*s**2 - 192*D1*Dd*K*f*fd*s + 48*D1*Dd*K*f*fd - 120*D1*Dd*f**3*r**2 - 720*D1*Dd*f**3*r*s + 300*D1*Dd*f**3*r - 600*D1*Dd*f**3*s**2 + 660*D1*Dd*f**3*s - 210*D1*Dd*f**3 + 1008*D1*Dd*f**2*fd*r**2 + 3744*D1*Dd*f**2*fd*r*s - 2100*D1*Dd*f**2*fd*r + 2736*D1*Dd*f**2*fd*s**2 - 3420*D1*Dd*f**2*fd*s + 1014*D1*Dd*f**2*fd - 48*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 72*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 + 384*D1*Dd*f*fd*r*s - 264*D1*Dd*f*fd*r + 224*D1*Dd*f*fd*s**2 - 272*D1*Dd*f*fd*s + 98*D1*Dd*f*fd + 288*D1*Dd*f*g2*r*s - 72*D1*Dd*f*g2*r + 288*D1*Dd*f*g2*s**2 - 288*D1*Dd*f*g2*s + 72*D1*Dd*f*g2 - 64*D1*Dd*f*gd2*r*s + 8*D1*Dd*f*gd2*r - 64*D1*Dd*f*gd2*s**2 + 64*D1*Dd*f*gd2*s - 8*D1*Dd*f*gd2 - 64*D1*Dd*fd*g2*r*s + 40*D1*Dd*fd*g2*r - 64*D1*Dd*fd*g2*s**2 + 96*D1*Dd*fd*g2*s - 32*D1*Dd*fd*g2 + 48*D1*Ddd*K*f**2*r*s - 12*D1*Ddd*K*f**2*r + 48*D1*Ddd*K*f**2*s**2 - 48*D1*Ddd*K*f**2*s + 12*D1*Ddd*K*f**2 + 168*D1*Ddd*f**3*r**2 + 624*D1*Ddd*f**3*r*s - 324*D1*Ddd*f**3*r + 456*D1*Ddd*f**3*s**2 - 540*D1*Ddd*f**3*s + 198*D1*Ddd*f**3 + 40*D1*Ddd*f**2*r**2 + 96*D1*Ddd*f**2*r*s - 64*D1*Ddd*f**2*r + 56*D1*Ddd*f**2*s**2 - 76*D1*Ddd*f**2*s + 34*D1*Ddd*f**2 - 32*D1*Ddd*f*g2*r*s + 8*D1*Ddd*f*g2*r - 32*D1*Ddd*f*g2*s**2 + 32*D1*Ddd*f*g2*s - 8*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(6*r**2 + 2*r*(94*s - 57) + 182*s**2 - 266*s + 111) - 3*f*(24*K*s**2 - 12*K*s + 4*fd*(2*r**2 + r*(36*s - 11) + 34*s**2 - 35*s + 7) - 6*r**2 + 2*r*(12*K*s - 26*s + 7) - 46*s**2 + 42*s - 11) + 2*fd*(2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 2*r**2 + r*(13 - 36*s) - 34*s**2 + 31*s - 3)) - 2*Dd*f*(K*(-32*r*s + 4*r - 32*s**2 + 24*s - 2) + 3*f*(8*r**2 + 6*r*(24*s - 11) + 136*s**2 - 170*s + 47) + 8*r**2 + 144*r*s - 50*r + 136*s**2 - 154*s + 35)) + 144*Dd**2*K*f**2*r*s - 36*Dd**2*K*f**2*r + 144*Dd**2*K*f**2*s**2 - 144*Dd**2*K*f**2*s + 24*Dd**2*K*f**2 + 504*Dd**2*f**3*r**2 + 1872*Dd**2*f**3*r*s - 972*Dd**2*f**3*r + 1368*Dd**2*f**3*s**2 - 1620*Dd**2*f**3*s + 396*Dd**2*f**3 + 120*Dd**2*f**2*r**2 + 288*Dd**2*f**2*r*s - 192*Dd**2*f**2*r + 168*Dd**2*f**2*s**2 - 228*Dd**2*f**2*s + 68*Dd**2*f**2 - 96*Dd**2*f*g2*r*s + 24*Dd**2*f*g2*r - 96*Dd**2*f*g2*s**2 + 96*Dd**2*f*g2*s - 16*Dd**2*f*g2))/(1386*d**2*k2*k3**3) + D1**2*Pk2*Pkd3*ct*k1**3*(120*C*D1**2*f**2*fd*r*s - 40*C*D1**2*f**2*fd*r + 120*C*D1**2*f**2*fd*s**2 - 120*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd - 120*C*D1**2*f**2*fdd*r*s + 40*C*D1**2*f**2*fdd*r - 120*C*D1**2*f**2*fdd*s**2 + 120*C*D1**2*f**2*fdd*s - 40*C*D1**2*f**2*fdd - 240*C*D1**2*f*fd**2*r*s + 80*C*D1**2*f*fd**2*r - 240*C*D1**2*f*fd**2*s**2 + 240*C*D1**2*f*fd**2*s - 40*C*D1**2*f*fd**2 + 160*C*D1*Dd*f**3*r*s - 40*C*D1*Dd*f**3*r + 160*C*D1*Dd*f**3*s**2 - 160*C*D1*Dd*f**3*s + 40*C*D1*Dd*f**3 - 960*C*D1*Dd*f**2*fd*r*s + 280*C*D1*Dd*f**2*fd*r - 960*C*D1*Dd*f**2*fd*s**2 + 960*C*D1*Dd*f**2*fd*s - 200*C*D1*Dd*f**2*fd - 160*C*D1*Ddd*f**3*r*s + 40*C*D1*Ddd*f**3*r - 160*C*D1*Ddd*f**3*s**2 + 160*C*D1*Ddd*f**3*s - 40*C*D1*Ddd*f**3 - 480*C*Dd**2*f**3*r*s + 120*C*Dd**2*f**3*r - 480*C*Dd**2*f**3*s**2 + 480*C*Dd**2*f**3*s - 80*C*Dd**2*f**3 + 2*D1**2*bd1**2*(6*f**2*(14*r**2 + r*(28*s - 23) + 14*s**2 - 25*s + 9) + f*(41*r**2 + r*(48*C*s - 24*C + 58*s - 76) + (s - 1)*(48*C*s + 17*s - 59)) + 28*g2*(-2*r*s + r - s*(2*s - 2))) + 24*D1**2*bd2*f**2*r*s + 24*D1**2*bd2*f**2*s**2 - 24*D1**2*bd2*f**2*s - 96*D1**2*bd2*f*fd*r*s + 24*D1**2*bd2*f*fd*r - 96*D1**2*bd2*f*fd*s**2 + 96*D1**2*bd2*f*fd*s - 24*D1**2*bd2*f*fd + 4*D1**2*bdd1*f**2*(r + s - 1)*(-6*K*s + 11*r + 15*s - 15) - 24*D1**2*bdd2*f**2*r*s - 24*D1**2*bdd2*f**2*s**2 + 24*D1**2*bdd2*f**2*s - 60*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 60*D1**2*f**2*fd*s**2 + 60*D1**2*f**2*fd*s - 20*D1**2*f**2*fd + 60*D1**2*f**2*fdd*r*s - 20*D1**2*f**2*fdd*r + 60*D1**2*f**2*fdd*s**2 - 60*D1**2*f**2*fdd*s + 20*D1**2*f**2*fdd - 48*D1**2*f**2*gd2*r*s - 48*D1**2*f**2*gd2*s**2 + 48*D1**2*f**2*gd2*s + 48*D1**2*f**2*gdd2*r*s + 48*D1**2*f**2*gdd2*s**2 - 48*D1**2*f**2*gdd2*s + 120*D1**2*f*fd**2*r*s - 40*D1**2*f*fd**2*r + 120*D1**2*f*fd**2*s**2 - 120*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 - 96*D1**2*f*fd*g2*r*s + 48*D1**2*f*fd*g2*r - 96*D1**2*f*fd*g2*s**2 + 96*D1**2*f*fd*g2*s - 48*D1**2*f*fd*g2 + 192*D1**2*f*fd*gd2*r*s - 48*D1**2*f*fd*gd2*r + 192*D1**2*f*fd*gd2*s**2 - 192*D1**2*f*fd*gd2*s + 48*D1**2*f*fd*gd2 + 96*D1**2*f*fdd*g2*r*s - 48*D1**2*f*fdd*g2*r + 96*D1**2*f*fdd*g2*s**2 - 96*D1**2*f*fdd*g2*s + 48*D1**2*f*fdd*g2 + 96*D1**2*fd**2*g2*r*s - 48*D1**2*fd**2*g2*r + 96*D1**2*fd**2*g2*s**2 - 96*D1**2*fd**2*g2*s - 192*D1*Dd*bd2*f**2*r*s + 24*D1*Dd*bd2*f**2*r - 192*D1*Dd*bd2*f**2*s**2 + 192*D1*Dd*bd2*f**2*s - 24*D1*Dd*bd2*f**2 - 80*D1*Dd*f**3*r*s + 20*D1*Dd*f**3*r - 80*D1*Dd*f**3*s**2 + 80*D1*Dd*f**3*s - 20*D1*Dd*f**3 + 480*D1*Dd*f**2*fd*r*s - 140*D1*Dd*f**2*fd*r + 480*D1*Dd*f**2*fd*s**2 - 480*D1*Dd*f**2*fd*s + 100*D1*Dd*f**2*fd - 192*D1*Dd*f**2*g2*r*s + 48*D1*Dd*f**2*g2*r - 192*D1*Dd*f**2*g2*s**2 + 192*D1*Dd*f**2*g2*s - 48*D1*Dd*f**2*g2 + 384*D1*Dd*f**2*gd2*r*s - 48*D1*Dd*f**2*gd2*r + 384*D1*Dd*f**2*gd2*s**2 - 384*D1*Dd*f**2*gd2*s + 48*D1*Dd*f**2*gd2 + 768*D1*Dd*f*fd*g2*r*s - 288*D1*Dd*f*fd*g2*r + 768*D1*Dd*f*fd*g2*s**2 - 768*D1*Dd*f*fd*g2*s + 192*D1*Dd*f*fd*g2 + 80*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r + 80*D1*Ddd*f**3*s**2 - 80*D1*Ddd*f**3*s + 20*D1*Ddd*f**3 + 192*D1*Ddd*f**2*g2*r*s - 48*D1*Ddd*f**2*g2*r + 192*D1*Ddd*f**2*g2*s**2 - 192*D1*Ddd*f**2*g2*s + 48*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(-f*(r + s - 1)*(-12*K*s + 17*r + 33*s - 33) - 4*fd*(3*K*(r*(4*s - 1) + (1 - 2*s)**2) - 22*r**2 - 52*r*s + 37*r - 30*s**2 + 43*s - 13)) - 4*Dd*f*(3*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 44*r**2 - 104*r*s + 87*r - 60*s**2 + 101*s - 41)) + 240*Dd**2*f**3*r*s - 60*Dd**2*f**3*r + 240*Dd**2*f**3*s**2 - 240*Dd**2*f**3*s + 40*Dd**2*f**3 + 576*Dd**2*f**2*g2*r*s - 144*Dd**2*f**2*g2*r + 576*Dd**2*f**2*g2*s**2 - 576*Dd**2*f**2*g2*s + 96*Dd**2*f**2*g2 + b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(-56*K*(r*(4*s - 1) + (1 - 2*s)**2) + 5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 56*r**2 + 336*r*s - 140*r + 280*s**2 - 308*s + 98) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 7*Ddd*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - 4*r**2 + r*(10 - 24*s) - 20*s**2 + 22*s - 7)) - 2*Dd**2*(-7*K*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + 18*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 42*r**2 + 252*r*s - 105*r + 210*s**2 - 231*s + 49)) + b1**2*(-40*C*D1**2*fd*r*s - 40*C*D1**2*fd*s**2 + 40*C*D1**2*fd*s + 48*C*D1**2*fdd*r*s + 48*C*D1**2*fdd*s**2 - 48*C*D1**2*fdd*s - 160*C*D1*Dd*f*r*s + 40*C*D1*Dd*f*r - 160*C*D1*Dd*f*s**2 + 160*C*D1*Dd*f*s - 40*C*D1*Dd*f + 384*C*D1*Dd*fd*r*s - 48*C*D1*Dd*fd*r + 384*C*D1*Dd*fd*s**2 - 384*C*D1*Dd*fd*s + 48*C*D1*Dd*fd + 192*C*D1*Ddd*f*r*s - 48*C*D1*Ddd*f*r + 192*C*D1*Ddd*f*s**2 - 192*C*D1*Ddd*f*s + 48*C*D1*Ddd*f + 576*C*Dd**2*f*r*s - 144*C*Dd**2*f*r + 576*C*Dd**2*f*s**2 - 576*C*Dd**2*f*s + 96*C*Dd**2*f - D1**2*bdd1*(-28*K*(3*r*s - r + 3*s**2 - 3*s + 1) + 6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 21*r**2 + 126*r*s - 56*r + 105*s**2 - 112*s + 42) - 120*D1**2*f*fd*r**2 - 336*D1**2*f*fd*r*s + 156*D1**2*f*fd*r - 216*D1**2*f*fd*s**2 + 204*D1**2*f*fd*s - 66*D1**2*f*fd + 168*D1**2*f*fdd*r**2 + 336*D1**2*f*fdd*r*s - 228*D1**2*f*fdd*r + 168*D1**2*f*fdd*s**2 - 204*D1**2*f*fdd*s + 102*D1**2*f*fdd + 168*D1**2*fd**2*r**2 + 336*D1**2*fd**2*r*s - 228*D1**2*fd**2*r + 168*D1**2*fd**2*s**2 - 204*D1**2*fd**2*s + 60*D1**2*fd**2 - 26*D1**2*fd*r**2 - 60*D1**2*fd*r*s - 10*D1**2*fd*r - 34*D1**2*fd*s**2 - 50*D1**2*fd*s + 5*D1**2*fd + 41*D1**2*fdd*r**2 + 58*D1**2*fdd*r*s + 12*D1**2*fdd*r + 17*D1**2*fdd*s**2 + 60*D1**2*fdd*s - 6*D1**2*fdd + 112*D1**2*gd2*r*s + 112*D1**2*gd2*s**2 - 112*D1**2*gd2*s - 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*s**2 + 56*D1**2*gdd2*s - 240*D1*Dd*f**2*r**2 - 672*D1*Dd*f**2*r*s + 408*D1*Dd*f**2*r - 432*D1*Dd*f**2*s**2 + 552*D1*Dd*f**2*s - 228*D1*Dd*f**2 + 1344*D1*Dd*f*fd*r**2 + 2688*D1*Dd*f*fd*r*s - 1920*D1*Dd*f*fd*r + 1344*D1*Dd*f*fd*s**2 - 1824*D1*Dd*f*fd*s + 660*D1*Dd*f*fd - 104*D1*Dd*f*r**2 - 240*D1*Dd*f*r*s + 164*D1*Dd*f*r - 136*D1*Dd*f*s**2 + 188*D1*Dd*f*s - 86*D1*Dd*f + 328*D1*Dd*fd*r**2 + 464*D1*Dd*fd*r*s - 174*D1*Dd*fd*r + 136*D1*Dd*fd*s**2 + 90*D1*Dd*fd*s - 84*D1*Dd*fd + 448*D1*Dd*g2*r*s - 112*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 448*D1*Dd*g2*s + 112*D1*Dd*g2 - 448*D1*Dd*gd2*r*s + 56*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 448*D1*Dd*gd2*s - 56*D1*Dd*gd2 + 336*D1*Ddd*f**2*r**2 + 672*D1*Ddd*f**2*r*s - 504*D1*Ddd*f**2*r + 336*D1*Ddd*f**2*s**2 - 504*D1*Ddd*f**2*s + 252*D1*Ddd*f**2 + 164*D1*Ddd*f*r**2 + 232*D1*Ddd*f*r*s - 222*D1*Ddd*f*r + 68*D1*Ddd*f*s**2 - 150*D1*Ddd*f*s + 99*D1*Ddd*f - 224*D1*Ddd*g2*r*s + 56*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 224*D1*Ddd*g2*s - 56*D1*Ddd*g2 + D1*bd1*(5*D1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*D1*(28*K*(3*r*s - r + 3*s**2 - 3*s + 1) + 6*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 21*r**2 - 126*r*s + 56*r - 105*s**2 + 112*s - 42) - 12*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 14*Dd*(2*K*(24*r*s - 7*r + 24*s**2 - 24*s + 5) - 12*r**2 - 72*r*s + 31*r - 60*s**2 + 65*s - 16)) + 1008*Dd**2*f**2*r**2 + 2016*Dd**2*f**2*r*s - 1512*Dd**2*f**2*r + 1008*Dd**2*f**2*s**2 - 1512*Dd**2*f**2*s + 504*Dd**2*f**2 + 492*Dd**2*f*r**2 + 696*Dd**2*f*r*s - 666*Dd**2*f*r + 204*Dd**2*f*s**2 - 450*Dd**2*f*s + 198*Dd**2*f - 672*Dd**2*g2*r*s + 168*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 672*Dd**2*g2*s - 112*Dd**2*g2) + b1*(-2*D1**2*bd1**2*(-14*K*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 21*r**2 + 126*r*s - 56*r + 105*s**2 - 112*s + 21) + 2*D1**2*bdd1*(3*f**2*(28*r**2 + r*(56*s - 46) + 28*s**2 - 50*s + 25) + f*(24*C*(2*r*s - r + 2*s**2 - 2*s + 1) + 41*r**2 + 58*r*s - 76*r + 17*s**2 - 76*s + 32) - 28*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 2*D1**2*(f*(fd*(12*K*(2*r*s - r + 2*s**2 - 2*s + 1) - 34*r**2 - 100*r*s + 34*r - 66*s**2 + 50*s - 17) + 2*fdd*(-6*K*(2*r*s - r + 2*s**2 - 2*s + 1) + 22*r**2 + 52*r*s - 22*r + 30*s**2 - 26*s + 11)) + 4*fd**2*(11*r**2 + r*(-6*K*s + 3*K + 26*s - 11) + s*(-6*K*s + 6*K + 15*s - 13))) + D1*bd1*(-D1*(6*f**2*(20*r**2 + 14*r*(4*s - 3) + 36*s**2 - 58*s + 27) + f*(40*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 336*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 52*r**2 + 120*r*s - 122*r + 68*s**2 - 178*s + 65) - 4*fd*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) + 41*r**2 + 58*r*s - 32*r + 17*s**2 - 8*s - 15) - 56*g2*(4*r*s - 2*r + 4*s**2 - 4*s + 2) - 56*gd2*(-4*r*s + r - 4*s**2 + 4*s - 1)) + 4*Dd*(3*f**2*(112*r**2 + 16*r*(14*s - 11) + 112*s**2 - 184*s + 71) + f*(24*C*(8*r*s - 3*r + 8*s**2 - 8*s + 2) + 164*r**2 + 232*r*s - 263*r + 68*s**2 - 227*s + 114) - 28*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 2*D1*f*(Dd*(f*(12*K*(r*(4*s - 1) + (1 - 2*s)**2) - 68*r**2 - 200*r*s + 118*r - 132*s**2 + 166*s - 67) - 4*fd*(6*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - 88*r**2 - 208*r*s + 114*r - 120*s**2 + 134*s - 35)) - 2*Ddd*f*(6*K*(r*(4*s - 1) + (1 - 2*s)**2) - 44*r**2 - 104*r*s + 70*r - 60*s**2 + 82*s - 37)) - 8*Dd**2*f**2*(K*(36*r*s - 9*r + 36*s**2 - 36*s + 6) - 66*r**2 - 156*r*s + 105*r - 90*s**2 + 123*s - 37)) + 24*b2*(D1**2*(f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(21*d**2*k2*k3**3) + 5*D1**2*Pk2*Pkd3*ct*k1*k2**5*st**6*(-24*C*D1**2*f**2*fd*r**2 - 48*C*D1**2*f**2*fd*r*s + 32*C*D1**2*f**2*fd*r - 24*C*D1**2*f**2*fd*s**2 + 32*C*D1**2*f**2*fd*s - 16*C*D1**2*f**2*fd + 12*C*D1**2*f**2*fdd*r**2 + 24*C*D1**2*f**2*fdd*r*s - 16*C*D1**2*f**2*fdd*r + 12*C*D1**2*f**2*fdd*s**2 - 16*C*D1**2*f**2*fdd*s + 8*C*D1**2*f**2*fdd + 24*C*D1**2*f*fd**2*r**2 + 48*C*D1**2*f*fd**2*r*s - 32*C*D1**2*f*fd**2*r + 24*C*D1**2*f*fd**2*s**2 - 32*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 32*C*D1*Dd*f**3*r**2 - 64*C*D1*Dd*f**3*r*s + 48*C*D1*Dd*f**3*r - 32*C*D1*Dd*f**3*s**2 + 48*C*D1*Dd*f**3*s - 24*C*D1*Dd*f**3 + 96*C*D1*Dd*f**2*fd*r**2 + 192*C*D1*Dd*f**2*fd*r*s - 136*C*D1*Dd*f**2*fd*r + 96*C*D1*Dd*f**2*fd*s**2 - 136*C*D1*Dd*f**2*fd*s + 48*C*D1*Dd*f**2*fd + 16*C*D1*Ddd*f**3*r**2 + 32*C*D1*Ddd*f**3*r*s - 24*C*D1*Ddd*f**3*r + 16*C*D1*Ddd*f**3*s**2 - 24*C*D1*Ddd*f**3*s + 12*C*D1*Ddd*f**3 + 48*C*Dd**2*f**3*r**2 + 96*C*Dd**2*f**3*r*s - 72*C*Dd**2*f**3*r + 48*C*Dd**2*f**3*s**2 - 72*C*Dd**2*f**3*s + 24*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r**2 - 528*D1**2*K*b1*f*fd*r*s + 264*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 132*D1**2*K*b1*f*fdd*s**2 - 132*D1**2*K*b1*f*fdd*s + 66*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 132*D1**2*K*b1*fd**2*s**2 - 132*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-66*K + 7*f + 33)*(r + s - 1)**2 + 18*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 24*D1**2*f**2*fd*s + 12*D1**2*f**2*fd - 9*D1**2*f**2*fdd*r**2 - 18*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r - 9*D1**2*f**2*fdd*s**2 + 12*D1**2*f**2*fdd*s - 6*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 18*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 24*D1**2*f*fd**2*r - 18*D1**2*f*fd**2*s**2 + 24*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 - 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 792*D1*Dd*K*b1*f**2*s - 396*D1*Dd*K*b1*f**2 + 1056*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1320*D1*Dd*K*b1*f*fd*r + 1056*D1*Dd*K*b1*f*fd*s**2 - 1320*D1*Dd*K*b1*f*fd*s + 396*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 72*D1*Dd*f**2*fd*r**2 - 144*D1*Dd*f**2*fd*r*s + 102*D1*Dd*f**2*fd*r - 72*D1*Dd*f**2*fd*s**2 + 102*D1*Dd*f**2*fd*s - 36*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r + 264*D1*Ddd*K*b1*f**2*s**2 - 396*D1*Ddd*K*b1*f**2*s + 198*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 24*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 18*D1*Ddd*f**3*s - 9*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 33*f*(2*K - 1)*(r + s - 1) + 33*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-66*K + 7*f + 33)*(4*r + 4*s - 3))*(r + s - 1) + 792*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r + 792*Dd**2*K*b1*f**2*s**2 - 1188*Dd**2*K*b1*f**2*s + 396*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 72*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 54*Dd**2*f**3*s - 18*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2)/(154*d**2*k3**7) - 3*D1**2*Pk2*Pkd3*ct*k1*k2**5*st**4*(-66*D1**2*bd1**2*f*(2*K - 1)*(r + s - 1)**2 - 33*D1*bd1*(D1*(f**2*(4*K - 1)*(r + s - 1) + 8*f*(g2 - gd2)*(r + s - 1) - 8*fd*g2*(r + s)) - 8*Dd*f*g2*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(2*K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-8*D1**2*K*f*fd*r**2 - 16*D1**2*K*f*fd*r*s + 8*D1**2*K*f*fd*r - 8*D1**2*K*f*fd*s**2 + 8*D1**2*K*f*fd*s - 4*D1**2*K*f*fd - 2*D1**2*bdd1*f*(2*K - 1)*(r + s - 1)**2 + 2*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + D1**2*f*fd - 8*D1**2*f*gd2*r**2 - 16*D1**2*f*gd2*r*s + 16*D1**2*f*gd2*r - 8*D1**2*f*gd2*s**2 + 16*D1**2*f*gd2*s - 8*D1**2*f*gd2 + 4*D1**2*f*gdd2*r**2 + 8*D1**2*f*gdd2*r*s - 8*D1**2*f*gdd2*r + 4*D1**2*f*gdd2*s**2 - 8*D1**2*f*gdd2*s + 4*D1**2*f*gdd2 - 8*D1**2*fd*g2*r**2 - 16*D1**2*fd*g2*r*s - 8*D1**2*fd*g2*s**2 + 8*D1**2*fd*gd2*r**2 + 16*D1**2*fd*gd2*r*s - 8*D1**2*fd*gd2*r + 8*D1**2*fd*gd2*s**2 - 8*D1**2*fd*gd2*s + 4*D1**2*fdd*g2*r**2 + 8*D1**2*fdd*g2*r*s + 4*D1**2*fdd*g2*s**2 - 16*D1*Dd*K*f**2*r**2 - 32*D1*Dd*K*f**2*r*s + 24*D1*Dd*K*f**2*r - 16*D1*Dd*K*f**2*s**2 + 24*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 32*D1*Dd*f*g2*r**2 - 64*D1*Dd*f*g2*r*s + 48*D1*Dd*f*g2*r - 32*D1*Dd*f*g2*s**2 + 48*D1*Dd*f*g2*s - 24*D1*Dd*f*g2 + 32*D1*Dd*f*gd2*r**2 + 64*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r + 32*D1*Dd*f*gd2*s**2 - 56*D1*Dd*f*gd2*s + 24*D1*Dd*f*gd2 + 32*D1*Dd*fd*g2*r**2 + 64*D1*Dd*fd*g2*r*s - 24*D1*Dd*fd*g2*r + 32*D1*Dd*fd*g2*s**2 - 24*D1*Dd*fd*g2*s + 16*D1*Ddd*f*g2*r**2 + 32*D1*Ddd*f*g2*r*s - 24*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s**2 - 24*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + 4*D1*bd1*(2*K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 48*Dd**2*f*g2*r**2 + 96*Dd**2*f*g2*r*s - 72*Dd**2*f*g2*r + 48*Dd**2*f*g2*s**2 - 72*Dd**2*f*g2*s + 24*Dd**2*f*g2) + 4*f*(D1**2*(33*bdd1*g2*(r + s - 1)**2 + f*(-fd*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 66*gd2*(r + s - 1)**2) + fd**2*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 66*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + D1*f*(-2*Dd*(f*(10*C - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(10*C - 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 33*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Ddd*f*(10*C - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Dd**2*f**2*(60*C - 30)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*ct*k1*k2**5*st**2*(D1*(-24*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(f**2*(40*C - 6*K - 19)*(r + s - 1) - 8*f*(fd*(6*C - 3)*(2*r + 2*s - 1) + (13*g2 - 6*gd2)*(r + s - 1)) + 48*fd*g2*(r + s)) - 24*Dd*f*(f*(2*C - 1) - 2*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6*f*(2*D1*bdd1*(f*(2*C - 1) - 2*g2)*(r + s - 1)**2 + D1*(f*(fd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*gd2*(r + s - 1)**2) - 2*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(2*C - 1) - 2*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**2*(D1**2*(3*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-12*K*fdd + fd*(52*K - 7))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(52*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*(f*(fd*(40*C - 6*K - 19)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*fdd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*(r + s - 1)**2*(6*K*bdd1 + 26*gd2 - 6*gdd2)) + (-8*r - 8*s)*(fd**2*(6*C - 3)*(r + s - 1) + 13*fd*g2*(r + s) - 6*fd*gd2*(r + s - 1) - 3*fdd*g2*(r + s))) + 2*D1*bd1*(D1*(-24*K*fd*(r + s) + 3*f**2*(r + s - 1) + f*(52*K - 7)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(40*C - 6*K - 19)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*f*(fd*(6*C - 3)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 13*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 48*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(f*(2*C - 1) - 2*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(2*C - 1) - 2*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(14*d**2*k3**7) - 5*D1**2*Pk2*Pkd3*ct*k1*k2**3*st**6*(-48*C*D1**2*f**2*fd*r**2 + 48*C*D1**2*f**2*fd*r*s + 16*C*D1**2*f**2*fd*r + 96*C*D1**2*f**2*fd*s**2 - 80*C*D1**2*f**2*fd*s + 16*C*D1**2*f**2*fd + 24*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s - 8*C*D1**2*f**2*fdd*r - 48*C*D1**2*f**2*fdd*s**2 + 40*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd + 48*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s - 16*C*D1**2*f*fd**2*r - 96*C*D1**2*f*fd**2*s**2 + 80*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 - 64*C*D1*Dd*f**3*r**2 + 64*C*D1*Dd*f**3*r*s + 48*C*D1*Dd*f**3*r + 128*C*D1*Dd*f**3*s**2 - 96*C*D1*Dd*f**3*s + 192*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s - 104*C*D1*Dd*f**2*fd*r - 384*C*D1*Dd*f**2*fd*s**2 + 304*C*D1*Dd*f**2*fd*s - 24*C*D1*Dd*f**2*fd + 32*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s - 24*C*D1*Ddd*f**3*r - 64*C*D1*Ddd*f**3*s**2 + 48*C*D1*Ddd*f**3*s + 96*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s - 72*C*Dd**2*f**3*r - 192*C*Dd**2*f**3*s**2 + 144*C*Dd**2*f**3*s - 528*D1**2*K*b1*f*fd*r**2 + 528*D1**2*K*b1*f*fd*r*s - 264*D1**2*K*b1*f*fd*r + 1056*D1**2*K*b1*f*fd*s**2 - 1056*D1**2*K*b1*f*fd*s + 528*D1**2*K*b1*f*fd + 264*D1**2*K*b1*f*fdd*r**2 - 264*D1**2*K*b1*f*fdd*r*s + 132*D1**2*K*b1*f*fdd*r - 528*D1**2*K*b1*f*fdd*s**2 + 528*D1**2*K*b1*f*fdd*s - 264*D1**2*K*b1*f*fdd + 264*D1**2*K*b1*fd**2*r**2 - 264*D1**2*K*b1*fd**2*r*s + 132*D1**2*K*b1*fd**2*r - 528*D1**2*K*b1*fd**2*s**2 + 528*D1**2*K*b1*fd**2*s + 210*D1**2*b1*f**2*fd*r**2 + 252*D1**2*b1*f**2*fd*r*s - 224*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 112*D1**2*b1*f**2*fd*s + 84*D1**2*b1*f**2*fd - 105*D1**2*b1*f**2*fdd*r**2 - 126*D1**2*b1*f**2*fdd*r*s + 112*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 56*D1**2*b1*f**2*fdd*s - 42*D1**2*b1*f**2*fdd - 210*D1**2*b1*f*fd**2*r**2 - 252*D1**2*b1*f*fd**2*r*s + 224*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 112*D1**2*b1*f*fd**2*s - 42*D1**2*b1*f*fd**2 + 1188*D1**2*b1*f*fd*r**2 + 1320*D1**2*b1*f*fd*r*s - 660*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 594*D1**2*b1*f*fdd*r**2 - 660*D1**2*b1*f*fdd*r*s + 330*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 594*D1**2*b1*fd**2*r**2 - 660*D1**2*b1*fd**2*r*s + 330*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(r + s - 1)*(-132*K*(r - 2*s - 1) + 7*f*(5*r + s - 5) + 297*r + 33*s - 297) - 112*D1**2*f**3*fd*r**2 - 112*D1**2*f**3*fd*r*s + 140*D1**2*f**3*fd*r + 56*D1**2*f**3*fd*s - 56*D1**2*f**3*fd + 112*D1**2*f**3*fdd*r**2 + 112*D1**2*f**3*fdd*r*s - 140*D1**2*f**3*fdd*r - 56*D1**2*f**3*fdd*s + 56*D1**2*f**3*fdd + 336*D1**2*f**2*fd**2*r**2 + 336*D1**2*f**2*fd**2*r*s - 420*D1**2*f**2*fd**2*r - 168*D1**2*f**2*fd**2*s + 112*D1**2*f**2*fd**2 + 78*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 64*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 16*D1**2*f**2*fd*s + 12*D1**2*f**2*fd - 39*D1**2*f**2*fdd*r**2 - 18*D1**2*f**2*fdd*r*s + 32*D1**2*f**2*fdd*r + 21*D1**2*f**2*fdd*s**2 - 8*D1**2*f**2*fdd*s - 6*D1**2*f**2*fdd + 528*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s - 1056*D1**2*f**2*gd2*r - 1056*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s + 528*D1**2*f**2*gd2 - 264*D1**2*f**2*gdd2*r**2 + 264*D1**2*f**2*gdd2*r*s + 528*D1**2*f**2*gdd2*r + 528*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s - 264*D1**2*f**2*gdd2 - 78*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 64*D1**2*f*fd**2*r + 42*D1**2*f*fd**2*s**2 - 16*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 + 1056*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s**2 + 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r**2 + 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r + 2112*D1**2*f*fd*gd2*s**2 - 1584*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r**2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 1056*D1**2*f*fdd*g2*s**2 - 1056*D1**2*f*fdd*g2*s + 528*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r**2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 1056*D1**2*fd**2*g2*s**2 - 1056*D1**2*fd**2*g2*s - 1056*D1*Dd*K*b1*f**2*r**2 + 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r + 2112*D1*Dd*K*b1*f**2*s**2 - 1584*D1*Dd*K*b1*f**2*s + 2112*D1*Dd*K*b1*f*fd*r**2 - 2112*D1*Dd*K*b1*f*fd*r*s - 264*D1*Dd*K*b1*f*fd*r - 4224*D1*Dd*K*b1*f*fd*s**2 + 3696*D1*Dd*K*b1*f*fd*s - 792*D1*Dd*K*b1*f*fd + 280*D1*Dd*b1*f**3*r**2 + 336*D1*Dd*b1*f**3*r*s - 364*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 196*D1*Dd*b1*f**3*s + 154*D1*Dd*b1*f**3 - 840*D1*Dd*b1*f**2*fd*r**2 - 1008*D1*Dd*b1*f**2*fd*r*s + 994*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 518*D1*Dd*b1*f**2*fd*s - 280*D1*Dd*b1*f**2*fd + 2376*D1*Dd*b1*f**2*r**2 + 2640*D1*Dd*b1*f**2*r*s - 3036*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 1452*D1*Dd*b1*f**2*s + 1254*D1*Dd*b1*f**2 - 4752*D1*Dd*b1*f*fd*r**2 - 5280*D1*Dd*b1*f*fd*r*s + 4356*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 1716*D1*Dd*b1*f*fd*s - 726*D1*Dd*b1*f*fd - 112*D1*Dd*f**4*r**2 - 112*D1*Dd*f**4*r*s + 140*D1*Dd*f**4*r + 56*D1*Dd*f**4*s - 56*D1*Dd*f**4 + 896*D1*Dd*f**3*fd*r**2 + 896*D1*Dd*f**3*fd*r*s - 1120*D1*Dd*f**3*fd*r - 448*D1*Dd*f**3*fd*s + 336*D1*Dd*f**3*fd + 104*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 116*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 4*D1*Dd*f**3*s + 38*D1*Dd*f**3 - 312*D1*Dd*f**2*fd*r**2 - 144*D1*Dd*f**2*fd*r*s + 302*D1*Dd*f**2*fd*r + 168*D1*Dd*f**2*fd*s**2 - 38*D1*Dd*f**2*fd*s - 56*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r - 4224*D1*Dd*f**2*g2*s**2 + 3168*D1*Dd*f**2*g2*s - 2112*D1*Dd*f**2*gd2*r**2 + 2112*D1*Dd*f**2*gd2*r*s + 2904*D1*Dd*f**2*gd2*r + 4224*D1*Dd*f**2*gd2*s**2 - 2640*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r**2 + 4224*D1*Dd*f*fd*g2*r*s + 528*D1*Dd*f*fd*g2*r + 8448*D1*Dd*f*fd*g2*s**2 - 7392*D1*Dd*f*fd*g2*s + 1584*D1*Dd*f*fd*g2 + 528*D1*Ddd*K*b1*f**2*r**2 - 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r - 1056*D1*Ddd*K*b1*f**2*s**2 + 792*D1*Ddd*K*b1*f**2*s - 140*D1*Ddd*b1*f**3*r**2 - 168*D1*Ddd*b1*f**3*r*s + 182*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 98*D1*Ddd*b1*f**3*s - 77*D1*Ddd*b1*f**3 - 1188*D1*Ddd*b1*f**2*r**2 - 1320*D1*Ddd*b1*f**2*r*s + 1518*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 726*D1*Ddd*b1*f**2*s - 627*D1*Ddd*b1*f**2 + 112*D1*Ddd*f**4*r**2 + 112*D1*Ddd*f**4*r*s - 140*D1*Ddd*f**4*r - 56*D1*Ddd*f**4*s + 56*D1*Ddd*f**4 - 52*D1*Ddd*f**3*r**2 - 24*D1*Ddd*f**3*r*s + 58*D1*Ddd*f**3*r + 28*D1*Ddd*f**3*s**2 - 2*D1*Ddd*f**3*s - 19*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r**2 + 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r + 2112*D1*Ddd*f**2*g2*s**2 - 1584*D1*Ddd*f**2*g2*s + 2*D1*bd1*f*(7*D1*f**2*(5*r**2 + 2*r*(3*s - 5) + s**2 - 6*s + 5) + D1*f*(-7*fd*(15*r**2 + r*(18*s - 23) + 3*s**2 - 13*s + 8) + (r + s - 1)*(-132*K*(r - 2*s - 1) + 297*r + 33*s - 297)) + 33*D1*fd*(2*K*(4*r**2 - 4*r*s - 3*r - 8*s**2 + 6*s - 1) - 18*r**2 - 20*r*s + 23*r - 2*s**2 + 11*s - 5) - 7*Dd*f**2*(20*r**2 + 3*r*(8*s - 11) + 4*s**2 - 19*s + 13) + 33*Dd*f*(2*K*(8*r**2 - 8*r*s - 11*r - 16*s**2 + 10*s + 3) - 36*r**2 - 40*r*s + 59*r - 4*s**2 + 31*s - 23)) + 1584*Dd**2*K*b1*f**2*r**2 - 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r - 3168*Dd**2*K*b1*f**2*s**2 + 2376*Dd**2*K*b1*f**2*s - 420*Dd**2*b1*f**3*r**2 - 504*Dd**2*b1*f**3*r*s + 546*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 294*Dd**2*b1*f**3*s - 154*Dd**2*b1*f**3 - 3564*Dd**2*b1*f**2*r**2 - 3960*Dd**2*b1*f**2*r*s + 4554*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 2178*Dd**2*b1*f**2*s - 1254*Dd**2*b1*f**2 + 336*Dd**2*f**4*r**2 + 336*Dd**2*f**4*r*s - 420*Dd**2*f**4*r - 168*Dd**2*f**4*s + 112*Dd**2*f**4 - 156*Dd**2*f**3*r**2 - 72*Dd**2*f**3*r*s + 174*Dd**2*f**3*r + 84*Dd**2*f**3*s**2 - 6*Dd**2*f**3*s - 38*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r**2 + 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r + 6336*Dd**2*f**2*g2*s**2 - 4752*Dd**2*f**2*g2*s)/(1386*d**2*k3**5) + D1**2*Pk2*Pkd3*ct*k1*k2**3*st**4*(-1632*C*D1**2*f**2*fd*r**2 - 3072*C*D1**2*f**2*fd*r*s + 2112*C*D1**2*f**2*fd*r - 1440*C*D1**2*f**2*fd*s**2 + 1984*C*D1**2*f**2*fd*s - 1024*C*D1**2*f**2*fd + 816*C*D1**2*f**2*fdd*r**2 + 1536*C*D1**2*f**2*fdd*r*s - 1056*C*D1**2*f**2*fdd*r + 720*C*D1**2*f**2*fdd*s**2 - 992*C*D1**2*f**2*fdd*s + 512*C*D1**2*f**2*fdd + 1632*C*D1**2*f*fd**2*r**2 + 3072*C*D1**2*f*fd**2*r*s - 2112*C*D1**2*f*fd**2*r + 1440*C*D1**2*f*fd**2*s**2 - 1984*C*D1**2*f*fd**2*s + 512*C*D1**2*f*fd**2 - 2176*C*D1*Dd*f**3*r**2 - 4096*C*D1*Dd*f**3*r*s + 3200*C*D1*Dd*f**3*r - 1920*C*D1*Dd*f**3*s**2 + 3008*C*D1*Dd*f**3*s - 1568*C*D1*Dd*f**3 + 6528*C*D1*Dd*f**2*fd*r**2 + 12288*C*D1*Dd*f**2*fd*r*s - 9024*C*D1*Dd*f**2*fd*r + 5760*C*D1*Dd*f**2*fd*s**2 - 8480*C*D1*Dd*f**2*fd*s + 3104*C*D1*Dd*f**2*fd + 1088*C*D1*Ddd*f**3*r**2 + 2048*C*D1*Ddd*f**3*r*s - 1600*C*D1*Ddd*f**3*r + 960*C*D1*Ddd*f**3*s**2 - 1504*C*D1*Ddd*f**3*s + 784*C*D1*Ddd*f**3 + 3264*C*Dd**2*f**3*r**2 + 6144*C*Dd**2*f**3*r*s - 4800*C*Dd**2*f**3*r + 2880*C*Dd**2*f**3*s**2 - 4512*C*Dd**2*f**3*s + 1568*C*Dd**2*f**3 - 330*D1**2*K*bdd1*f**2*r**2 - 924*D1**2*K*bdd1*f**2*r*s + 660*D1**2*K*bdd1*f**2*r - 594*D1**2*K*bdd1*f**2*s**2 + 924*D1**2*K*bdd1*f**2*s - 330*D1**2*K*bdd1*f**2 - 660*D1**2*b2*f*fd*r**2 - 1320*D1**2*b2*f*fd*r*s + 660*D1**2*b2*f*fd*r - 660*D1**2*b2*f*fd*s**2 + 660*D1**2*b2*f*fd*s - 330*D1**2*b2*f*fd + 66*D1**2*bd1**2*f*(r + s - 1)*(2*K*(3*r + 5*s + 1) + 4*r - 7) - 330*D1**2*bd2*f**2*r**2 - 660*D1**2*bd2*f**2*r*s + 660*D1**2*bd2*f**2*r - 330*D1**2*bd2*f**2*s**2 + 660*D1**2*bd2*f**2*s - 330*D1**2*bd2*f**2 + 165*D1**2*bdd1*f**2*r**2 + 462*D1**2*bdd1*f**2*r*s - 330*D1**2*bdd1*f**2*r + 297*D1**2*bdd1*f**2*s**2 - 462*D1**2*bdd1*f**2*s + 165*D1**2*bdd1*f**2 - 396*D1**2*bdd1*f*g2*r**2 - 1056*D1**2*bdd1*f*g2*r*s - 264*D1**2*bdd1*f*g2*r - 660*D1**2*bdd1*f*g2*s**2 + 924*D1**2*f**2*fd*r**2 + 1704*D1**2*f**2*fd*r*s - 1184*D1**2*f**2*fd*r + 780*D1**2*f**2*fd*s**2 - 1088*D1**2*f**2*fd*s + 568*D1**2*f**2*fd - 462*D1**2*f**2*fdd*r**2 - 852*D1**2*f**2*fdd*r*s + 592*D1**2*f**2*fdd*r - 390*D1**2*f**2*fdd*s**2 + 544*D1**2*f**2*fdd*s - 284*D1**2*f**2*fdd + 792*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s - 1584*D1**2*f**2*gd2*r - 528*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 792*D1**2*f**2*gd2 + 660*D1**2*f**2*gdd2*r**2 + 1848*D1**2*f**2*gdd2*r*s - 1320*D1**2*f**2*gdd2*r + 1188*D1**2*f**2*gdd2*s**2 - 1848*D1**2*f**2*gdd2*s + 660*D1**2*f**2*gdd2 - 924*D1**2*f*fd**2*r**2 - 1704*D1**2*f*fd**2*r*s + 1184*D1**2*f*fd**2*r - 780*D1**2*f*fd**2*s**2 + 1088*D1**2*f*fd**2*s - 284*D1**2*f*fd**2 + 1584*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 + 2640*D1**2*f*fd*gd2*r**2 + 7392*D1**2*f*fd*gd2*r*s - 4488*D1**2*f*fd*gd2*r + 4752*D1**2*f*fd*gd2*s**2 - 6072*D1**2*f*fd*gd2*s + 1848*D1**2*f*fd*gd2 + 1320*D1**2*f*fdd*g2*r**2 + 3696*D1**2*f*fdd*g2*r*s - 1848*D1**2*f*fdd*g2*r + 2376*D1**2*f*fdd*g2*s**2 - 2376*D1**2*f*fdd*g2*s + 1188*D1**2*f*fdd*g2 + 1320*D1**2*fd**2*g2*r**2 + 3696*D1**2*fd**2*g2*r*s - 1848*D1**2*fd**2*g2*r + 2376*D1**2*fd**2*g2*s**2 - 2376*D1**2*fd**2*g2*s - 1320*D1*Dd*b2*f**2*r**2 - 2640*D1*Dd*b2*f**2*r*s + 1980*D1*Dd*b2*f**2*r - 1320*D1*Dd*b2*f**2*s**2 + 1980*D1*Dd*b2*f**2*s - 990*D1*Dd*b2*f**2 + 1232*D1*Dd*f**3*r**2 + 2272*D1*Dd*f**3*r*s - 1800*D1*Dd*f**3*r + 1040*D1*Dd*f**3*s**2 - 1656*D1*Dd*f**3*s + 876*D1*Dd*f**3 - 3696*D1*Dd*f**2*fd*r**2 - 6816*D1*Dd*f**2*fd*r*s + 5068*D1*Dd*f**2*fd*r - 3120*D1*Dd*f**2*fd*s**2 + 4660*D1*Dd*f**2*fd*s - 1728*D1*Dd*f**2*fd + 3168*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s - 3432*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s + 1056*D1*Dd*f**2*g2 + 5280*D1*Dd*f**2*gd2*r**2 + 14784*D1*Dd*f**2*gd2*r*s - 9768*D1*Dd*f**2*gd2*r + 9504*D1*Dd*f**2*gd2*s**2 - 13464*D1*Dd*f**2*gd2*s + 4488*D1*Dd*f**2*gd2 + 10560*D1*Dd*f*fd*g2*r**2 + 29568*D1*Dd*f*fd*g2*r*s - 16368*D1*Dd*f*fd*g2*r + 19008*D1*Dd*f*fd*g2*s**2 - 21648*D1*Dd*f*fd*g2*s + 6072*D1*Dd*f*fd*g2 - 616*D1*Ddd*f**3*r**2 - 1136*D1*Ddd*f**3*r*s + 900*D1*Ddd*f**3*r - 520*D1*Ddd*f**3*s**2 + 828*D1*Ddd*f**3*s - 438*D1*Ddd*f**3 + 2640*D1*Ddd*f**2*g2*r**2 + 7392*D1*Ddd*f**2*g2*r*s - 4488*D1*Ddd*f**2*g2*r + 4752*D1*Ddd*f**2*g2*s**2 - 6072*D1*Ddd*f**2*g2*s + 2508*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(2*f**2*(r + s - 1)*(K*(3*r - 2*s - 3) - 2*r + s + 2) + f*(fd*(2*K - 1)*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) - 4*g2*(3*r**2 + 8*r*s + 2*r + 5*s**2) - 4*gd2*(-3*r**2 - 8*r*s + 2*r - 5*s**2 + 4*s + 1)) + 4*fd*g2*(3*r**2 + r*(8*s - 4) + s*(5*s - 5))) + Dd*f*(f*(2*K - 1)*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) + 4*g2*(12*r**2 + r*(32*s - 6) + 20*s**2 - 13*s - 2))) - 1848*Dd**2*f**3*r**2 - 3408*Dd**2*f**3*r*s + 2700*Dd**2*f**3*r - 1560*Dd**2*f**3*s**2 + 2484*Dd**2*f**3*s - 876*Dd**2*f**3 + 7920*Dd**2*f**2*g2*r**2 + 22176*Dd**2*f**2*g2*r*s - 13464*Dd**2*f**2*g2*r + 14256*Dd**2*f**2*g2*s**2 - 18216*Dd**2*f**2*g2*s + 5016*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(2*fd - fdd)*(2*K*(3*r**2 + 2*r*(4*s - 5) + 5*(s - 1)**2) + 4*r**2 + 2*r*(2*s + 5) + 10*s - 5) + 2*D1*(Dd*(2*f*(K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 8*r**2 + 2*r*(4*s - 5) - 4*s + 4) - fd*(K*(24*r**2 + r*(64*s - 60) + 40*s**2 - 66*s + 30) + 16*r**2 + 2*r*(8*s + 5) + 16*s - 15)) - Ddd*f*(K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 8*r**2 + 2*r*(4*s - 5) - 4*s + 4)) - 4*Dd**2*f*(K*(18*r**2 + 6*r*(8*s - 5) + 30*s**2 - 39*s + 11) + 12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) - 33*b1*(24*D1**2*K*f*fd*r**2 + 8*D1**2*K*f*fd*r*s - 4*D1**2*K*f*fd*r - 16*D1**2*K*f*fd*s**2 + 16*D1**2*K*f*fd*s - 8*D1**2*K*f*fd + 20*D1**2*K*f*fdd*r**2 + 56*D1**2*K*f*fdd*r*s - 28*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 20*D1**2*K*fd**2*r**2 + 56*D1**2*K*fd**2*r*s - 28*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*K*(6*r**2 + 4*r*(4*s - 1) + 10*s**2 - 8*s + 3) + 8*r**2 + r*(8*s - 22) - 14*s + 9) - 16*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 24*D1**2*f*gd2*r**2 - 64*D1**2*f*gd2*r*s + 48*D1**2*f*gd2*r - 40*D1**2*f*gd2*s**2 + 64*D1**2*f*gd2*s - 24*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 32*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*r + 20*D1**2*f*gdd2*s**2 - 32*D1**2*f*gdd2*s + 12*D1**2*f*gdd2 - 10*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s - 24*D1**2*fd*g2*r**2 - 64*D1**2*fd*g2*r*s + 80*D1**2*fd*g2*r - 40*D1**2*fd*g2*s**2 + 80*D1**2*fd*g2*s - 40*D1**2*fd*g2 + 24*D1**2*fd*gd2*r**2 + 64*D1**2*fd*gd2*r*s - 64*D1**2*fd*gd2*r + 40*D1**2*fd*gd2*s**2 - 72*D1**2*fd*gd2*s + 40*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r**2 + 32*D1**2*fdd*g2*r*s - 40*D1**2*fdd*g2*r + 20*D1**2*fdd*g2*s**2 - 40*D1**2*fdd*g2*s + 20*D1**2*fdd*g2 + 48*D1*Dd*K*f**2*r**2 + 16*D1*Dd*K*f**2*r*s - 52*D1*Dd*K*f**2*r - 32*D1*Dd*K*f**2*s**2 + 8*D1*Dd*K*f**2*s + 16*D1*Dd*K*f**2 + 160*D1*Dd*K*f*fd*r**2 + 448*D1*Dd*K*f*fd*r*s - 248*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 328*D1*Dd*K*f*fd*s + 92*D1*Dd*K*f*fd - 32*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 124*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 164*D1*Dd*f*fd*s - 46*D1*Dd*f*fd - 96*D1*Dd*f*g2*r**2 - 256*D1*Dd*f*g2*r*s + 160*D1*Dd*f*g2*r - 160*D1*Dd*f*g2*s**2 + 208*D1*Dd*f*g2*s - 88*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 256*D1*Dd*f*gd2*r*s - 176*D1*Dd*f*gd2*r + 160*D1*Dd*f*gd2*s**2 - 232*D1*Dd*f*gd2*s + 80*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 256*D1*Dd*fd*g2*r*s - 240*D1*Dd*fd*g2*r + 160*D1*Dd*fd*g2*s**2 - 264*D1*Dd*fd*g2*s + 120*D1*Dd*fd*g2 + 40*D1*Ddd*K*f**2*r**2 + 112*D1*Ddd*K*f**2*r*s - 68*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 92*D1*Ddd*K*f**2*s + 38*D1*Ddd*K*f**2 - 20*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 34*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 46*D1*Ddd*f**2*s - 19*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 128*D1*Ddd*f*g2*r*s - 80*D1*Ddd*f*g2*r + 80*D1*Ddd*f*g2*s**2 - 104*D1*Ddd*f*g2*s + 44*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f*(2*K*(6*r**2 + 16*r*s - 4*r + 10*s**2 - 8*s + 3) + 8*r**2 + 8*r*s - 22*r - 14*s + 9) + fd*(-2*K*(6*r**2 + 4*r*(4*s - 3) + 10*s**2 - 14*s + 5) - 8*r**2 - 8*r*s + r - 3*s + 5)) - Dd*f*(4*K*(12*r**2 + 2*r*(16*s - 7) + 20*s**2 - 21*s + 4) + 32*r**2 + 32*r*(s - 2) - 36*s + 29)) + 120*Dd**2*K*f**2*r**2 + 336*Dd**2*K*f**2*r*s - 204*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 276*Dd**2*K*f**2*s + 76*Dd**2*K*f**2 - 60*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 102*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 138*Dd**2*f**2*s - 38*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 384*Dd**2*f*g2*r*s - 240*Dd**2*f*g2*r + 240*Dd**2*f*g2*s**2 - 312*Dd**2*f*g2*s + 88*Dd**2*f*g2))/(231*d**2*k3**5) - D1**2*Pk2*Pkd3*ct*k1*k2**3*st**2*(440*C*D1**2*bd1**2*f*r**2 + 880*C*D1**2*bd1**2*f*r*s - 440*C*D1**2*bd1**2*f*r + 440*C*D1**2*bd1**2*f*s**2 - 440*C*D1**2*bd1**2*f*s + 2728*C*D1**2*bd1*f**2*r**2 + 6336*C*D1**2*bd1*f**2*r*s - 8096*C*D1**2*bd1*f**2*r + 3608*C*D1**2*bd1*f**2*s**2 - 8976*C*D1**2*bd1*f**2*s + 4488*C*D1**2*bd1*f**2 - 6688*C*D1**2*bd1*f*fd*r**2 - 14432*C*D1**2*bd1*f*fd*r*s + 11880*C*D1**2*bd1*f*fd*r - 7744*C*D1**2*bd1*f*fd*s**2 + 12672*C*D1**2*bd1*f*fd*s - 4928*C*D1**2*bd1*f*fd - 1672*C*D1**2*bdd1*f**2*r**2 - 3608*C*D1**2*bdd1*f**2*r*s + 4928*C*D1**2*bdd1*f**2*r - 1936*C*D1**2*bdd1*f**2*s**2 + 5192*C*D1**2*bdd1*f**2*s - 2596*C*D1**2*bdd1*f**2 - 1752*C*D1**2*f**2*fd*r**2 - 168*C*D1**2*f**2*fd*r*s + 1224*C*D1**2*f**2*fd*r + 1584*C*D1**2*f**2*fd*s**2 - 1000*C*D1**2*f**2*fd*s - 56*C*D1**2*f**2*fd - 2556*C*D1**2*f**2*fdd*r**2 - 6912*C*D1**2*f**2*fdd*r*s + 4008*C*D1**2*f**2*fdd*r - 4356*C*D1**2*f**2*fdd*s**2 + 5208*C*D1**2*f**2*fdd*s - 2304*C*D1**2*f**2*fdd - 5112*C*D1**2*f*fd**2*r**2 - 13824*C*D1**2*f*fd**2*r*s + 8016*C*D1**2*f*fd**2*r - 8712*C*D1**2*f*fd**2*s**2 + 10416*C*D1**2*f*fd**2*s - 2304*C*D1**2*f*fd**2 - 13376*C*D1*Dd*bd1*f**2*r**2 - 28864*C*D1*Dd*bd1*f**2*r*s + 30008*C*D1*Dd*bd1*f**2*r - 15488*C*D1*Dd*bd1*f**2*s**2 + 31856*C*D1*Dd*bd1*f**2*s - 15048*C*D1*Dd*bd1*f**2 - 2336*C*D1*Dd*f**3*r**2 - 224*C*D1*Dd*f**3*r*s + 2392*C*D1*Dd*f**3*r + 2112*C*D1*Dd*f**3*s**2 - 944*C*D1*Dd*f**3*s - 640*C*D1*Dd*f**3 - 20448*C*D1*Dd*f**2*fd*r**2 - 55296*C*D1*Dd*f**2*fd*r*s + 33168*C*D1*Dd*f**2*fd*r - 34848*C*D1*Dd*f**2*fd*s**2 + 43368*C*D1*Dd*f**2*fd*s - 13224*C*D1*Dd*f**2*fd - 3408*C*D1*Ddd*f**3*r**2 - 9216*C*D1*Ddd*f**3*r*s + 5712*C*D1*Ddd*f**3*r - 5808*C*D1*Ddd*f**3*s**2 + 7512*C*D1*Ddd*f**3*s - 3156*C*D1*Ddd*f**3 - 10224*C*Dd**2*f**3*r**2 - 27648*C*Dd**2*f**3*r*s + 17136*C*Dd**2*f**3*r - 17424*C*Dd**2*f**3*s**2 + 22536*C*Dd**2*f**3*s - 6312*C*Dd**2*f**3 + 88*D1**2*K*bd1**2*f*r**2 - 88*D1**2*K*bd1**2*f*r*s + 616*D1**2*K*bd1**2*f*r - 176*D1**2*K*bd1**2*f*s**2 + 880*D1**2*K*bd1**2*f*s - 704*D1**2*K*bd1**2*f - 396*D1**2*K*bd1*f**2*r**2 - 132*D1**2*K*bd1*f**2*r*s + 792*D1**2*K*bd1*f**2*r + 264*D1**2*K*bd1*f**2*s**2 + 132*D1**2*K*bd1*f**2*s - 396*D1**2*K*bd1*f**2 - 1320*D1**2*K*bd1*f*fd*r**2 - 4224*D1**2*K*bd1*f*fd*r*s + 2376*D1**2*K*bd1*f*fd*r - 2904*D1**2*K*bd1*f*fd*s**2 + 3564*D1**2*K*bd1*f*fd*s - 1056*D1**2*K*bd1*f*fd - 330*D1**2*K*bdd1*f**2*r**2 - 1056*D1**2*K*bdd1*f**2*r*s + 660*D1**2*K*bdd1*f**2*r - 726*D1**2*K*bdd1*f**2*s**2 + 1056*D1**2*K*bdd1*f**2*s - 330*D1**2*K*bdd1*f**2 + 990*D1**2*bd1**2*f**2*r**2 + 1452*D1**2*bd1**2*f**2*r*s - 1716*D1**2*bd1**2*f**2*r + 462*D1**2*bd1**2*f**2*s**2 - 1188*D1**2*bd1**2*f**2*s + 726*D1**2*bd1**2*f**2 - 704*D1**2*bd1**2*f*r**2 - 1672*D1**2*bd1**2*f*r*s + 1210*D1**2*bd1**2*f*r - 968*D1**2*bd1**2*f*s**2 + 1474*D1**2*bd1**2*f*s - 506*D1**2*bd1**2*f + 3080*D1**2*bd1**2*g2*r**2 + 6160*D1**2*bd1**2*g2*r*s - 3080*D1**2*bd1**2*g2*r + 3080*D1**2*bd1**2*g2*s**2 - 3080*D1**2*bd1**2*g2*s - 1320*D1**2*bd1*bd2*f*r**2 - 2640*D1**2*bd1*bd2*f*r*s + 2640*D1**2*bd1*bd2*f*r - 1320*D1**2*bd1*bd2*f*s**2 + 2640*D1**2*bd1*bd2*f*s - 1320*D1**2*bd1*bd2*f - 1507*D1**2*bd1*f**2*r**2 - 3454*D1**2*bd1*f**2*r*s + 4092*D1**2*bd1*f**2*r - 1947*D1**2*bd1*f**2*s**2 + 4532*D1**2*bd1*f**2*s - 2200*D1**2*bd1*f**2 + 4356*D1**2*bd1*f*fd*r**2 + 8712*D1**2*bd1*f*fd*r*s - 7194*D1**2*bd1*f*fd*r + 4356*D1**2*bd1*f*fd*s**2 - 7194*D1**2*bd1*f*fd*s + 2838*D1**2*bd1*f*fd - 1672*D1**2*bd1*f*g2*r**2 - 3872*D1**2*bd1*f*g2*r*s + 12672*D1**2*bd1*f*g2*r - 2200*D1**2*bd1*f*g2*s**2 + 13200*D1**2*bd1*f*g2*s - 6600*D1**2*bd1*f*g2 - 176*D1**2*bd1*f*gd2*r**2 + 176*D1**2*bd1*f*gd2*r*s - 1232*D1**2*bd1*f*gd2*r + 352*D1**2*bd1*f*gd2*s**2 - 1760*D1**2*bd1*f*gd2*s + 1408*D1**2*bd1*f*gd2 - 176*D1**2*bd1*fd*g2*r**2 + 176*D1**2*bd1*fd*g2*r*s - 88*D1**2*bd1*fd*g2*r + 352*D1**2*bd1*fd*g2*s**2 - 352*D1**2*bd1*fd*g2*s - 330*D1**2*bd2*f**2*r**2 - 660*D1**2*bd2*f**2*r*s + 660*D1**2*bd2*f**2*r - 330*D1**2*bd2*f**2*s**2 + 660*D1**2*bd2*f**2*s - 330*D1**2*bd2*f**2 + 1089*D1**2*bdd1*f**2*r**2 + 2178*D1**2*bdd1*f**2*r*s - 2838*D1**2*bdd1*f**2*r + 1089*D1**2*bdd1*f**2*s**2 - 2838*D1**2*bdd1*f**2*s + 1419*D1**2*bdd1*f**2 - 88*D1**2*bdd1*f*g2*r**2 + 88*D1**2*bdd1*f*g2*r*s - 1408*D1**2*bdd1*f*g2*r + 176*D1**2*bdd1*f*g2*s**2 - 1672*D1**2*bdd1*f*g2*s + 836*D1**2*bdd1*f*g2 + 1272*D1**2*f**2*fd*r**2 + 480*D1**2*f**2*fd*r*s - 1008*D1**2*f**2*fd*r - 792*D1**2*f**2*fd*s**2 + 368*D1**2*f**2*fd*s + 160*D1**2*f**2*fd + 1278*D1**2*f**2*fdd*r**2 + 3456*D1**2*f**2*fdd*r*s - 2004*D1**2*f**2*fdd*r + 2178*D1**2*f**2*fdd*s**2 - 2604*D1**2*f**2*fdd*s + 1152*D1**2*f**2*fdd + 792*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s - 1584*D1**2*f**2*gd2*r - 528*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 792*D1**2*f**2*gd2 + 660*D1**2*f**2*gdd2*r**2 + 2112*D1**2*f**2*gdd2*r*s - 1320*D1**2*f**2*gdd2*r + 1452*D1**2*f**2*gdd2*s**2 - 2112*D1**2*f**2*gdd2*s + 660*D1**2*f**2*gdd2 + 2556*D1**2*f*fd**2*r**2 + 6912*D1**2*f*fd**2*r*s - 4008*D1**2*f*fd**2*r + 4356*D1**2*f*fd**2*s**2 - 5208*D1**2*f*fd**2*s + 1152*D1**2*f*fd**2 + 1584*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 + 2640*D1**2*f*fd*gd2*r**2 + 8448*D1**2*f*fd*gd2*r*s - 4752*D1**2*f*fd*gd2*r + 5808*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2112*D1**2*f*fd*gd2 + 1320*D1**2*f*fdd*g2*r**2 + 4224*D1**2*f*fdd*g2*r*s - 2112*D1**2*f*fdd*g2*r + 2904*D1**2*f*fdd*g2*s**2 - 2904*D1**2*f*fdd*g2*s + 1452*D1**2*f*fdd*g2 + 1320*D1**2*fd**2*g2*r**2 + 4224*D1**2*fd**2*g2*r*s - 2112*D1**2*fd**2*g2*r + 2904*D1**2*fd**2*g2*s**2 - 2904*D1**2*fd**2*g2*s - 2640*D1*Dd*K*bd1*f**2*r**2 - 8448*D1*Dd*K*bd1*f**2*r*s + 5016*D1*Dd*K*bd1*f**2*r - 5808*D1*Dd*K*bd1*f**2*s**2 + 7788*D1*Dd*K*bd1*f**2*s - 2376*D1*Dd*K*bd1*f**2 + 8712*D1*Dd*bd1*f**2*r**2 + 17424*D1*Dd*bd1*f**2*r*s - 17886*D1*Dd*bd1*f**2*r + 8712*D1*Dd*bd1*f**2*s**2 - 17886*D1*Dd*bd1*f**2*s + 8514*D1*Dd*bd1*f**2 - 704*D1*Dd*bd1*f*g2*r**2 + 704*D1*Dd*bd1*f*g2*r*s - 5368*D1*Dd*bd1*f*g2*r + 1408*D1*Dd*bd1*f*g2*s**2 - 7216*D1*Dd*bd1*f*g2*s + 4488*D1*Dd*bd1*f*g2 + 1696*D1*Dd*f**3*r**2 + 640*D1*Dd*f**3*r*s - 1856*D1*Dd*f**3*r - 1056*D1*Dd*f**3*s**2 + 208*D1*Dd*f**3*s + 584*D1*Dd*f**3 + 10224*D1*Dd*f**2*fd*r**2 + 27648*D1*Dd*f**2*fd*r*s - 16584*D1*Dd*f**2*fd*r + 17424*D1*Dd*f**2*fd*s**2 - 21684*D1*Dd*f**2*fd*s + 6612*D1*Dd*f**2*fd + 3168*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s - 3432*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s + 1056*D1*Dd*f**2*g2 + 5280*D1*Dd*f**2*gd2*r**2 + 16896*D1*Dd*f**2*gd2*r*s - 10032*D1*Dd*f**2*gd2*r + 11616*D1*Dd*f**2*gd2*s**2 - 15576*D1*Dd*f**2*gd2*s + 4752*D1*Dd*f**2*gd2 + 10560*D1*Dd*f*fd*g2*r**2 + 33792*D1*Dd*f*fd*g2*r*s - 17952*D1*Dd*f*fd*g2*r + 23232*D1*Dd*f*fd*g2*s**2 - 25872*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 + 1704*D1*Ddd*f**3*r**2 + 4608*D1*Ddd*f**3*r*s - 2856*D1*Ddd*f**3*r + 2904*D1*Ddd*f**3*s**2 - 3756*D1*Ddd*f**3*s + 1578*D1*Ddd*f**3 + 2640*D1*Ddd*f**2*g2*r**2 + 8448*D1*Ddd*f**2*g2*r*s - 4752*D1*Ddd*f**2*g2*r + 5808*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 2772*D1*Ddd*f**2*g2 + 110*D1*b2*(bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 5112*Dd**2*f**3*r**2 + 13824*Dd**2*f**3*r*s - 8568*Dd**2*f**3*r + 8712*Dd**2*f**3*s**2 - 11268*Dd**2*f**3*s + 3156*Dd**2*f**3 + 7920*Dd**2*f**2*g2*r**2 + 25344*Dd**2*f**2*g2*r*s - 14256*Dd**2*f**2*g2*r + 17424*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 5544*Dd**2*f**2*g2 + 55*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(14*K + 3*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(14*K + 3*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(-40*C*D1**2*fd*r**2 - 80*C*D1**2*fd*r*s + 80*C*D1**2*fd*r - 40*C*D1**2*fd*s**2 + 80*C*D1**2*fd*s - 40*C*D1**2*fd + 20*C*D1**2*fdd*r**2 + 40*C*D1**2*fdd*r*s - 40*C*D1**2*fdd*r + 20*C*D1**2*fdd*s**2 - 40*C*D1**2*fdd*s + 20*C*D1**2*fdd - 160*C*D1*Dd*f*r**2 - 320*C*D1*Dd*f*r*s + 240*C*D1*Dd*f*r - 160*C*D1*Dd*f*s**2 + 240*C*D1*Dd*f*s - 120*C*D1*Dd*f + 160*C*D1*Dd*fd*r**2 + 320*C*D1*Dd*fd*r*s - 280*C*D1*Dd*fd*r + 160*C*D1*Dd*fd*s**2 - 280*C*D1*Dd*fd*s + 120*C*D1*Dd*fd + 80*C*D1*Ddd*f*r**2 + 160*C*D1*Ddd*f*r*s - 120*C*D1*Ddd*f*r + 80*C*D1*Ddd*f*s**2 - 120*C*D1*Ddd*f*s + 60*C*D1*Ddd*f + 240*C*Dd**2*f*r**2 + 480*C*Dd**2*f*r*s - 360*C*Dd**2*f*r + 240*C*Dd**2*f*s**2 - 360*C*Dd**2*f*s + 120*C*Dd**2*f + 76*D1**2*K*fd*r**2 + 176*D1**2*K*fd*r*s + 400*D1**2*K*fd*r + 100*D1**2*K*fd*s**2 + 400*D1**2*K*fd*s - 200*D1**2*K*fd + 4*D1**2*K*fdd*r**2 - 4*D1**2*K*fdd*r*s - 60*D1**2*K*fdd*r - 8*D1**2*K*fdd*s**2 - 60*D1**2*K*fdd*s + 30*D1**2*K*fdd - 5*D1**2*bdd1*(14*K + 3*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 78*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 108*D1**2*f*fd*r - 30*D1**2*f*fd*s**2 + 84*D1**2*f*fd*s - 54*D1**2*f*fd + 90*D1**2*f*fdd*r**2 + 132*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 66*D1**2*f*fdd*s + 45*D1**2*f*fdd + 90*D1**2*fd**2*r**2 + 132*D1**2*fd**2*r*s - 90*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 66*D1**2*fd**2*s - 27*D1**2*fd*r**2 - 2*D1**2*fd*r*s - 130*D1**2*fd*r + 25*D1**2*fd*s**2 - 130*D1**2*fd*s + 65*D1**2*fd - 32*D1**2*fdd*r**2 - 76*D1**2*fdd*r*s + 30*D1**2*fdd*r - 44*D1**2*fdd*s**2 + 30*D1**2*fdd*s - 15*D1**2*fdd - 280*D1**2*gd2*r**2 - 560*D1**2*gd2*r*s + 560*D1**2*gd2*r - 280*D1**2*gd2*s**2 + 560*D1**2*gd2*s - 280*D1**2*gd2 + 140*D1**2*gdd2*r**2 + 280*D1**2*gdd2*r*s - 280*D1**2*gdd2*r + 140*D1**2*gdd2*s**2 - 280*D1**2*gdd2*s + 140*D1**2*gdd2 + 304*D1*Dd*K*f*r**2 + 704*D1*Dd*K*f*r*s - 480*D1*Dd*K*f*r + 400*D1*Dd*K*f*s**2 - 552*D1*Dd*K*f*s + 252*D1*Dd*K*f + 32*D1*Dd*K*fd*r**2 - 32*D1*Dd*K*fd*r*s - 252*D1*Dd*K*fd*r - 64*D1*Dd*K*fd*s**2 - 216*D1*Dd*K*fd*s + 180*D1*Dd*K*fd - 156*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r - 60*D1*Dd*f**2*s**2 + 138*D1*Dd*f**2*s - 93*D1*Dd*f**2 + 720*D1*Dd*f*fd*r**2 + 1056*D1*Dd*f*fd*r*s - 852*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 612*D1*Dd*f*fd*s + 246*D1*Dd*f*fd - 108*D1*Dd*f*r**2 - 8*D1*Dd*f*r*s + 110*D1*Dd*f*r + 100*D1*Dd*f*s**2 - 46*D1*Dd*f*s - 29*D1*Dd*f - 256*D1*Dd*fd*r**2 - 608*D1*Dd*fd*r*s + 324*D1*Dd*fd*r - 352*D1*Dd*fd*s**2 + 360*D1*Dd*fd*s - 90*D1*Dd*fd - 1120*D1*Dd*g2*r**2 - 2240*D1*Dd*g2*r*s + 1680*D1*Dd*g2*r - 1120*D1*Dd*g2*s**2 + 1680*D1*Dd*g2*s - 840*D1*Dd*g2 + 1120*D1*Dd*gd2*r**2 + 2240*D1*Dd*gd2*r*s - 1960*D1*Dd*gd2*r + 1120*D1*Dd*gd2*s**2 - 1960*D1*Dd*gd2*s + 840*D1*Dd*gd2 + 16*D1*Ddd*K*f*r**2 - 16*D1*Ddd*K*f*r*s - 12*D1*Ddd*K*f*r - 32*D1*Ddd*K*f*s**2 + 24*D1*Ddd*K*f*s + 180*D1*Ddd*f**2*r**2 + 264*D1*Ddd*f**2*r*s - 246*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 174*D1*Ddd*f**2*s + 111*D1*Ddd*f**2 - 128*D1*Ddd*f*r**2 - 304*D1*Ddd*f*r*s + 204*D1*Ddd*f*r - 176*D1*Ddd*f*s**2 + 240*D1*Ddd*f*s - 108*D1*Ddd*f + 560*D1*Ddd*g2*r**2 + 1120*D1*Ddd*g2*r*s - 840*D1*Ddd*g2*r + 560*D1*Ddd*g2*s**2 - 840*D1*Ddd*g2*s + 420*D1*Ddd*g2 + 10*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(14*K + 3*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 48*Dd**2*K*f*r**2 - 48*Dd**2*K*f*r*s - 36*Dd**2*K*f*r - 96*Dd**2*K*f*s**2 + 72*Dd**2*K*f*s + 540*Dd**2*f**2*r**2 + 792*Dd**2*f**2*r*s - 738*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 522*Dd**2*f**2*s + 222*Dd**2*f**2 - 384*Dd**2*f*r**2 - 912*Dd**2*f*r*s + 612*Dd**2*f*r - 528*Dd**2*f*s**2 + 720*Dd**2*f*s - 216*Dd**2*f + 1680*Dd**2*g2*r**2 + 3360*Dd**2*g2*r*s - 2520*Dd**2*g2*r + 1680*Dd**2*g2*s**2 - 2520*Dd**2*g2*s + 840*Dd**2*g2) - 11*b1*(-40*C*D1**2*bdd1*f*r**2 - 80*C*D1**2*bdd1*f*r*s + 40*C*D1**2*bdd1*f*r - 40*C*D1**2*bdd1*f*s**2 + 40*C*D1**2*bdd1*f*s - 20*C*D1**2*bdd1*f - 496*C*D1**2*f*fd*r**2 - 1152*C*D1**2*f*fd*r*s + 336*C*D1**2*f*fd*r - 656*C*D1**2*f*fd*s**2 + 416*C*D1**2*f*fd*s - 168*C*D1**2*f*fd + 304*C*D1**2*f*fdd*r**2 + 656*C*D1**2*f*fdd*r*s - 184*C*D1**2*f*fdd*r + 352*C*D1**2*f*fdd*s**2 - 208*C*D1**2*f*fdd*s + 92*C*D1**2*f*fdd + 304*C*D1**2*fd**2*r**2 + 656*C*D1**2*fd**2*r*s - 184*C*D1**2*fd**2*r + 352*C*D1**2*fd**2*s**2 - 208*C*D1**2*fd**2*s - 120*C*D1**2*fd**2 - 992*C*D1*Dd*f**2*r**2 - 2304*C*D1*Dd*f**2*r*s + 1568*C*D1*Dd*f**2*r - 1312*C*D1*Dd*f**2*s**2 + 1808*C*D1*Dd*f**2*s - 824*C*D1*Dd*f**2 + 2432*C*D1*Dd*f*fd*r**2 + 5248*C*D1*Dd*f*fd*r*s - 2608*C*D1*Dd*f*fd*r + 2816*C*D1*Dd*f*fd*s**2 - 2848*C*D1*Dd*f*fd*s + 576*C*D1*Dd*f*fd + 608*C*D1*Ddd*f**2*r**2 + 1312*C*D1*Ddd*f**2*r*s - 936*C*D1*Ddd*f**2*r + 704*C*D1*Ddd*f**2*s**2 - 1008*C*D1*Ddd*f**2*s + 480*C*D1*Ddd*f**2 + 1824*C*Dd**2*f**2*r**2 + 3936*C*Dd**2*f**2*r*s - 2808*C*Dd**2*f**2*r + 2112*C*Dd**2*f**2*s**2 - 3024*C*Dd**2*f**2*s + 960*C*Dd**2*f**2 - 8*D1**2*K*bdd1*f*r**2 + 8*D1**2*K*bdd1*f*r*s - 56*D1**2*K*bdd1*f*r + 16*D1**2*K*bdd1*f*s**2 - 80*D1**2*K*bdd1*f*s + 34*D1**2*K*bdd1*f + 72*D1**2*K*f*fd*r**2 + 24*D1**2*K*f*fd*r*s - 12*D1**2*K*f*fd*r - 48*D1**2*K*f*fd*s**2 + 48*D1**2*K*f*fd*s - 24*D1**2*K*f*fd + 60*D1**2*K*f*fdd*r**2 + 192*D1**2*K*f*fdd*r*s - 96*D1**2*K*f*fdd*r + 132*D1**2*K*f*fdd*s**2 - 132*D1**2*K*f*fdd*s + 66*D1**2*K*f*fdd + 60*D1**2*K*fd**2*r**2 + 192*D1**2*K*fd**2*r*s - 96*D1**2*K*fd**2*r + 132*D1**2*K*fd**2*s**2 - 132*D1**2*K*fd**2*s - 190*D1**2*b2*fd*r**2 - 380*D1**2*b2*fd*r*s - 190*D1**2*b2*fd*s**2 + 60*D1**2*b2*fdd*r**2 + 120*D1**2*b2*fdd*r*s + 60*D1**2*b2*fdd*s**2 + 10*D1**2*bd1**2*(14*K + 3*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 90*D1**2*bdd1*f**2*r**2 - 132*D1**2*bdd1*f**2*r*s + 156*D1**2*bdd1*f**2*r - 42*D1**2*bdd1*f**2*s**2 + 108*D1**2*bdd1*f**2*s - 66*D1**2*bdd1*f**2 + 64*D1**2*bdd1*f*r**2 + 152*D1**2*bdd1*f*r*s - 110*D1**2*bdd1*f*r + 88*D1**2*bdd1*f*s**2 - 134*D1**2*bdd1*f*s + 61*D1**2*bdd1*f - 280*D1**2*bdd1*g2*r**2 - 560*D1**2*bdd1*g2*r*s + 280*D1**2*bdd1*g2*r - 280*D1**2*bdd1*g2*s**2 + 280*D1**2*bdd1*g2*s - 140*D1**2*bdd1*g2 + 60*D1**2*bdd2*f*r**2 + 120*D1**2*bdd2*f*r*s - 120*D1**2*bdd2*f*r + 60*D1**2*bdd2*f*s**2 - 120*D1**2*bdd2*f*s + 60*D1**2*bdd2*f + 274*D1**2*f*fd*r**2 + 628*D1**2*f*fd*r*s - 216*D1**2*f*fd*r + 354*D1**2*f*fd*s**2 - 256*D1**2*f*fd*s + 114*D1**2*f*fd - 198*D1**2*f*fdd*r**2 - 396*D1**2*f*fdd*r*s + 138*D1**2*f*fdd*r - 198*D1**2*f*fdd*s**2 + 138*D1**2*f*fdd*s - 69*D1**2*f*fdd + 152*D1**2*f*gd2*r**2 + 352*D1**2*f*gd2*r*s - 304*D1**2*f*gd2*r + 200*D1**2*f*gd2*s**2 - 352*D1**2*f*gd2*s + 152*D1**2*f*gd2 + 8*D1**2*f*gdd2*r**2 - 8*D1**2*f*gdd2*r*s - 16*D1**2*f*gdd2*r - 16*D1**2*f*gdd2*s**2 + 8*D1**2*f*gdd2*s + 8*D1**2*f*gdd2 - 198*D1**2*fd**2*r**2 - 396*D1**2*fd**2*r*s + 138*D1**2*fd**2*r - 198*D1**2*fd**2*s**2 + 138*D1**2*fd**2*s + 60*D1**2*fd**2 + 152*D1**2*fd*g2*r**2 + 352*D1**2*fd*g2*r*s + 800*D1**2*fd*g2*r + 200*D1**2*fd*g2*s**2 + 800*D1**2*fd*g2*s - 400*D1**2*fd*g2 + 16*D1**2*fd*gd2*r**2 - 16*D1**2*fd*gd2*r*s - 136*D1**2*fd*gd2*r - 32*D1**2*fd*gd2*s**2 - 112*D1**2*fd*gd2*s + 120*D1**2*fd*gd2 + 8*D1**2*fdd*g2*r**2 - 8*D1**2*fdd*g2*r*s - 120*D1**2*fdd*g2*r - 16*D1**2*fdd*g2*s**2 - 120*D1**2*fdd*g2*s + 60*D1**2*fdd*g2 + 144*D1*Dd*K*f**2*r**2 + 48*D1*Dd*K*f**2*r*s - 156*D1*Dd*K*f**2*r - 96*D1*Dd*K*f**2*s**2 + 24*D1*Dd*K*f**2*s + 48*D1*Dd*K*f**2 + 480*D1*Dd*K*f*fd*r**2 + 1536*D1*Dd*K*f*fd*r*s - 816*D1*Dd*K*f*fd*r + 1056*D1*Dd*K*f*fd*s**2 - 1176*D1*Dd*K*f*fd*s + 324*D1*Dd*K*f*fd - 760*D1*Dd*b2*f*r**2 - 1520*D1*Dd*b2*f*r*s + 1140*D1*Dd*b2*f*r - 760*D1*Dd*b2*f*s**2 + 1140*D1*Dd*b2*f*s - 570*D1*Dd*b2*f + 480*D1*Dd*b2*fd*r**2 + 960*D1*Dd*b2*fd*r*s - 360*D1*Dd*b2*fd*r + 480*D1*Dd*b2*fd*s**2 - 360*D1*Dd*b2*fd*s + 548*D1*Dd*f**2*r**2 + 1256*D1*Dd*f**2*r*s - 862*D1*Dd*f**2*r + 708*D1*Dd*f**2*s**2 - 982*D1*Dd*f**2*s + 451*D1*Dd*f**2 - 1584*D1*Dd*f*fd*r**2 - 3168*D1*Dd*f*fd*r*s + 1740*D1*Dd*f*fd*r - 1584*D1*Dd*f*fd*s**2 + 1740*D1*Dd*f*fd*s - 414*D1*Dd*f*fd + 608*D1*Dd*f*g2*r**2 + 1408*D1*Dd*f*g2*r*s - 960*D1*Dd*f*g2*r + 800*D1*Dd*f*g2*s**2 - 1104*D1*Dd*f*g2*s + 504*D1*Dd*f*g2 + 64*D1*Dd*f*gd2*r**2 - 64*D1*Dd*f*gd2*r*s - 88*D1*Dd*f*gd2*r - 128*D1*Dd*f*gd2*s**2 + 80*D1*Dd*f*gd2*s + 24*D1*Dd*f*gd2 + 64*D1*Dd*fd*g2*r**2 - 64*D1*Dd*fd*g2*r*s - 504*D1*Dd*fd*g2*r - 128*D1*Dd*fd*g2*s**2 - 432*D1*Dd*fd*g2*s + 360*D1*Dd*fd*g2 + 120*D1*Ddd*K*f**2*r**2 + 384*D1*Ddd*K*f**2*r*s - 216*D1*Ddd*K*f**2*r + 264*D1*Ddd*K*f**2*s**2 - 324*D1*Ddd*K*f**2*s + 126*D1*Ddd*K*f**2 + 240*D1*Ddd*b2*f*r**2 + 480*D1*Ddd*b2*f*r*s - 360*D1*Ddd*b2*f*r + 240*D1*Ddd*b2*f*s**2 - 360*D1*Ddd*b2*f*s + 180*D1*Ddd*b2*f - 396*D1*Ddd*f**2*r**2 - 792*D1*Ddd*f**2*r*s + 594*D1*Ddd*f**2*r - 396*D1*Ddd*f**2*s**2 + 594*D1*Ddd*f**2*s - 297*D1*Ddd*f**2 + 32*D1*Ddd*f*g2*r**2 - 32*D1*Ddd*f*g2*r*s - 24*D1*Ddd*f*g2*r - 64*D1*Ddd*f*g2*s**2 + 48*D1*Ddd*f*g2*s + D1*bd1*(D1*(3*f**2*(26*r**2 + r*(36*s - 34) + 10*s**2 - 18*s + 13) + f*(40*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 152*K*r**2 - 352*K*r*s + 728*K*r - 200*K*s**2 + 776*K*s - 376*K - 12*fd*(30*r**2 + 44*r*s - 41*r + 14*s**2 - 29*s + 13) + 54*r**2 + 4*r*s - 186*r - 50*s**2 - 82*s + 67) - 2*fd*(20*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 2*K*(4*r**2 - 4*r*(s + 4) - 8*s**2 - 10*s + 15) - 64*r**2 - 152*r*s + 85*r - 88*s**2 + 97*s - 15) + 280*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 280*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(6*f**2*(60*r**2 + r*(88*s - 93) + 28*s**2 - 65*s + 35) + f*(20*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 4*K*(8*r**2 - 8*r*s + 25*r - 16*s**2 + 46*s - 24) - 256*r**2 - 608*r*s + 424*r - 352*s**2 + 508*s - 177) + 140*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 10*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 360*Dd**2*K*f**2*r**2 + 1152*Dd**2*K*f**2*r*s - 648*Dd**2*K*f**2*r + 792*Dd**2*K*f**2*s**2 - 972*Dd**2*K*f**2*s + 252*Dd**2*K*f**2 + 720*Dd**2*b2*f*r**2 + 1440*Dd**2*b2*f*r*s - 1080*Dd**2*b2*f*r + 720*Dd**2*b2*f*s**2 - 1080*Dd**2*b2*f*s + 360*Dd**2*b2*f - 1188*Dd**2*f**2*r**2 - 2376*Dd**2*f**2*r*s + 1782*Dd**2*f**2*r - 1188*Dd**2*f**2*s**2 + 1782*Dd**2*f**2*s - 594*Dd**2*f**2 + 96*Dd**2*f*g2*r**2 - 96*Dd**2*f*g2*r*s - 72*Dd**2*f*g2*r - 192*Dd**2*f*g2*s**2 + 144*Dd**2*f*g2*s))/(462*d**2*k3**5) + D1**2*Pk2*Pkd3*ct*k1*k2**3*(2*D1*(35*D1*b2*bd1*f*(r + s - 1)**2 + 10*D1*bd1**2*(r + s - 1)*(7*K*f*(r + s - 1) - f*(12*C - 6)*(r + s) + 14*g2*(r + s)) + 2*D1*bdd1*f*(f*(6*C - 3)*(6*r + 5*s - 5) - 35*g2*(r + s - 1))*(r + s - 1) - 2*bd1*(D1*(-6*f**2*(r + s - 1)*(C*(4*r + 6*s - 6) - 3*r - 3*s + 3) + f*(-fd*(6*C - 3)*(24*r**2 + r*(44*s - 34) + 20*s**2 - 31*s + 11) + (42*g2 + 70*gd2)*(r + s - 1)**2) + 70*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + Dd*f*(-f*(6*C - 3)*(48*r**2 + r*(88*s - 79) + 40*s**2 - 72*s + 32) + 70*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 35*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(4*K + f) - 2*Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(-70*K*bdd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(-40*C*(r + s - 1)**2 + 84*K*s**2 + r**2*(84*K + 27) + 2*r*(84*K*s + 41*s - 55) + 55*s**2 - 110*s + 55) - 10*fdd*(12*C*(r + s - 1)**2 - 7*K*s**2 - r**2*(7*K + 6) - 2*r*(7*K*s + 6*s - 6) - 6*s**2 + 12*s - 6) - 280*gd2*(r + s - 1)**2 + 140*gdd2*(r + s - 1)**2) + 35*D1*bd1*(D1*(4*K + f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 4*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(f*(-40*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 84*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 108*r**2 + 328*r*s - 190*r + 220*s**2 - 274*s + 109) - 20*fd*(4*r + 4*s - 3)*(12*C*(r + s - 1) - 7*K*r - 7*K*s - 6*r - 6*s + 6) - 280*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 280*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 10*Ddd*(f*(-12*C + 7*K + 6) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 60*Dd**2*(f*(-12*C + 7*K + 6) + 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - b1*(-192*C*D1**2*f*fd*r**2 - 480*C*D1**2*f*fd*r*s + 192*C*D1**2*f*fd*r - 288*C*D1**2*f*fd*s**2 + 240*C*D1**2*f*fd*s - 96*C*D1**2*f*fd - 288*C*D1**2*f*fdd*r**2 - 528*C*D1**2*f*fdd*r*s + 288*C*D1**2*f*fdd*r - 240*C*D1**2*f*fdd*s**2 + 264*C*D1**2*f*fdd*s - 144*C*D1**2*f*fdd - 288*C*D1**2*fd**2*r**2 - 528*C*D1**2*fd**2*r*s + 288*C*D1**2*fd**2*r - 240*C*D1**2*fd**2*s**2 + 264*C*D1**2*fd**2*s - 384*C*D1*Dd*f**2*r**2 - 960*C*D1*Dd*f**2*r*s + 624*C*D1*Dd*f**2*r - 576*C*D1*Dd*f**2*s**2 + 768*C*D1*Dd*f**2*s - 336*C*D1*Dd*f**2 - 2304*C*D1*Dd*f*fd*r**2 - 4224*C*D1*Dd*f*fd*r*s + 2832*C*D1*Dd*f*fd*r - 1920*C*D1*Dd*f*fd*s**2 + 2592*C*D1*Dd*f*fd*s - 840*C*D1*Dd*f*fd - 576*C*D1*Ddd*f**2*r**2 - 1056*C*D1*Ddd*f**2*r*s + 840*C*D1*Ddd*f**2*r - 480*C*D1*Ddd*f**2*s**2 + 768*C*D1*Ddd*f**2*s - 408*C*D1*Ddd*f**2 - 1728*C*Dd**2*f**2*r**2 - 3168*C*Dd**2*f**2*r*s + 2520*C*Dd**2*f**2*r - 1440*C*Dd**2*f**2*s**2 + 2304*C*Dd**2*f**2*s - 816*C*Dd**2*f**2 + 140*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 70*D1**2*b2*fd*r**2 - 140*D1**2*b2*fd*r*s - 70*D1**2*b2*fd*s**2 - 70*D1**2*bd2*f*(r + s - 1)**2 + 20*D1**2*bdd1*(f*(6*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*K*(r + s - 1)**2 - 6*r**2 - 12*r*s + 6*r - 6*s**2 + 6*s - 3) - 7*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 144*D1**2*f*fd*r**2 + 288*D1**2*f*fd*r*s - 144*D1**2*f*fd*r + 144*D1**2*f*fd*s**2 - 144*D1**2*f*fd*s + 72*D1**2*f*fd + 144*D1**2*f*fdd*r**2 + 264*D1**2*f*fdd*r*s - 144*D1**2*f*fdd*r + 120*D1**2*f*fdd*s**2 - 132*D1**2*f*fdd*s + 72*D1**2*f*fdd + 168*D1**2*f*gd2*r**2 + 336*D1**2*f*gd2*r*s - 336*D1**2*f*gd2*r + 168*D1**2*f*gd2*s**2 - 336*D1**2*f*gd2*s + 168*D1**2*f*gd2 + 140*D1**2*f*gdd2*r**2 + 280*D1**2*f*gdd2*r*s - 280*D1**2*f*gdd2*r + 140*D1**2*f*gdd2*s**2 - 280*D1**2*f*gdd2*s + 140*D1**2*f*gdd2 + 144*D1**2*fd**2*r**2 + 264*D1**2*fd**2*r*s - 144*D1**2*fd**2*r + 120*D1**2*fd**2*s**2 - 132*D1**2*fd**2*s + 168*D1**2*fd*g2*r**2 + 336*D1**2*fd*g2*r*s + 168*D1**2*fd*g2*s**2 + 280*D1**2*fd*gd2*r**2 + 560*D1**2*fd*gd2*r*s - 280*D1**2*fd*gd2*r + 280*D1**2*fd*gd2*s**2 - 280*D1**2*fd*gd2*s + 140*D1**2*fdd*g2*r**2 + 280*D1**2*fdd*g2*r*s + 140*D1**2*fdd*g2*s**2 - 280*D1*Dd*b2*f*r**2 - 560*D1*Dd*b2*f*r*s + 420*D1*Dd*b2*f*r - 280*D1*Dd*b2*f*s**2 + 420*D1*Dd*b2*f*s - 210*D1*Dd*b2*f + 288*D1*Dd*f**2*r**2 + 576*D1*Dd*f**2*r*s - 432*D1*Dd*f**2*r + 288*D1*Dd*f**2*s**2 - 432*D1*Dd*f**2*s + 216*D1*Dd*f**2 + 1152*D1*Dd*f*fd*r**2 + 2112*D1*Dd*f*fd*r*s - 1416*D1*Dd*f*fd*r + 960*D1*Dd*f*fd*s**2 - 1296*D1*Dd*f*fd*s + 420*D1*Dd*f*fd + 672*D1*Dd*f*g2*r**2 + 1344*D1*Dd*f*g2*r*s - 1008*D1*Dd*f*g2*r + 672*D1*Dd*f*g2*s**2 - 1008*D1*Dd*f*g2*s + 504*D1*Dd*f*g2 + 1120*D1*Dd*f*gd2*r**2 + 2240*D1*Dd*f*gd2*r*s - 1960*D1*Dd*f*gd2*r + 1120*D1*Dd*f*gd2*s**2 - 1960*D1*Dd*f*gd2*s + 840*D1*Dd*f*gd2 + 1120*D1*Dd*fd*g2*r**2 + 2240*D1*Dd*fd*g2*r*s - 840*D1*Dd*fd*g2*r + 1120*D1*Dd*fd*g2*s**2 - 840*D1*Dd*fd*g2*s + 288*D1*Ddd*f**2*r**2 + 528*D1*Ddd*f**2*r*s - 420*D1*Ddd*f**2*r + 240*D1*Ddd*f**2*s**2 - 384*D1*Ddd*f**2*s + 204*D1*Ddd*f**2 + 560*D1*Ddd*f*g2*r**2 + 1120*D1*Ddd*f*g2*r*s - 840*D1*Ddd*f*g2*r + 560*D1*Ddd*f*g2*s**2 - 840*D1*Ddd*f*g2*s + 420*D1*Ddd*f*g2 + D1*bd1*(D1*(f*(40*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 168*K*(r + s - 1)**2 - 54*r**2 - 164*r*s + 26*r - 110*s**2 + 82*s - 27) + 40*fd*(r + s - 1)*(6*C*(2*r + 2*s - 1) - 7*K*r - 7*K*s - 6*r - 6*s + 3) + 280*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 280*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 40*Dd*(f*(6*C*(2*r + 2*s - 1) - 7*K*(r + s - 1) - 6*r - 6*s + 3) - 7*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 864*Dd**2*f**2*r**2 + 1584*Dd**2*f**2*r*s - 1260*Dd**2*f**2*r + 720*Dd**2*f**2*s**2 - 1152*Dd**2*f**2*s + 408*Dd**2*f**2 + 1680*Dd**2*f*g2*r**2 + 3360*Dd**2*f*g2*r*s - 2520*Dd**2*f*g2*r + 1680*Dd**2*f*g2*s**2 - 2520*Dd**2*f*g2*s + 840*Dd**2*f*g2))/(21*d**2*k3**5) - 20*D1**2*Pk2*Pkd3*ct*k1*k2*st**6*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(-7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 66*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 33*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 33*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 66*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(7*f + 33)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(7*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(7*bdd1*f**2*s*(r + s - 1) + f*(33*bdd1*s*(r + s - 1) + fd*(r*(2 - 6*s) - 6*s**2 + 6*s - 2) + fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 2*f*s*(7*f + 33)*(r + s - 1) - 33*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(7*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**3) + D1**2*Pk2*Pkd3*ct*k1*k2*st**4*(-66*D1**2*bd1**2*f*(r**2*(4*K - 5) - r*(4*K*(s + 1) + 6*s - 7) - s**2*(8*K + 1) + s*(2*K + 7) - 2) + 33*D1*bd1*(D1*(f**2*(r + s - 1)*(-4*K*s + r + 13*s - 1) - 2*f*(fd*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) + 8*g2*(r**2 - r*s - 2*s**2) + 4*gd2*(-2*r**2 + 2*r*(s + 1) + s*(4*s - 1))) + 8*fd*g2*(2*r**2 - 2*r*s + r - s*(4*s - 4))) - 2*Dd*f*(f*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) + 4*g2*(-8*r**2 + r*(8*s + 3) + 2*s*(8*s - 3)))) + 33*b1**2*(D1**2*(2*fd - fdd)*(4*K*(r**2 - r*s + r - 2*(s - 1)**2) - 5*r**2 + r*(2 - 6*s) - s**2 - 6*s + 3) + D1*(2*Dd*(f*(r**2*(16*K - 20) - 2*r*(K*(8*s + 6) + 12*s - 13) - s**2*(32*K + 4) + s*(24*K + 14) - 11) + fd*(-2*K*(8*r**2 - 8*r*s + r - 16*s**2 + 22*s - 6) + 20*r**2 + r*(24*s - 17) + 4*s**2 + 5*s - 1)) + Ddd*f*(-r**2*(16*K - 20) + 2*r*(K*(8*s + 6) + 12*s - 13) + s**2*(32*K + 4) - s*(24*K + 14) + 11)) + 2*Dd**2*f*(-r**2*(24*K - 30) + 3*r*(K*(8*s + 6) + 12*s - 13) + s**2*(48*K + 6) - s*(36*K + 21) + 11)) + 33*b1*(-8*D1**2*K*f*fd*r*s + 4*D1**2*K*f*fd*r - 8*D1**2*K*f*fd*s**2 + 8*D1**2*K*f*fd*s - 4*D1**2*K*f*fd + D1**2*bdd1*f*(-4*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) + 10*r**2 + 2*r*(6*s - 7) + 2*s**2 - 14*s + 9) + 2*D1**2*f*fd*r**2 + 28*D1**2*f*fd*r*s - 14*D1**2*f*fd*r + 26*D1**2*f*fd*s**2 - 26*D1**2*f*fd*s + 13*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 28*D1**2*f*fdd*r*s + 14*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 16*D1**2*f*gd2*r**2 + 16*D1**2*f*gd2*r*s + 32*D1**2*f*gd2*r + 32*D1**2*f*gd2*s**2 - 16*D1**2*f*gd2*s - 16*D1**2*f*gd2 + 8*D1**2*f*gdd2*r**2 - 8*D1**2*f*gdd2*r*s - 16*D1**2*f*gdd2*r - 16*D1**2*f*gdd2*s**2 + 8*D1**2*f*gdd2*s + 8*D1**2*f*gdd2 - 10*D1**2*fd**2*r**2 - 28*D1**2*fd**2*r*s + 14*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s - 16*D1**2*fd*g2*r**2 + 16*D1**2*fd*g2*r*s - 16*D1**2*fd*g2*r + 32*D1**2*fd*g2*s**2 - 64*D1**2*fd*g2*s + 32*D1**2*fd*g2 + 16*D1**2*fd*gd2*r**2 - 16*D1**2*fd*gd2*r*s - 8*D1**2*fd*gd2*r - 32*D1**2*fd*gd2*s**2 + 40*D1**2*fd*gd2*s - 8*D1**2*fd*gd2 + 8*D1**2*fdd*g2*r**2 - 8*D1**2*fdd*g2*r*s + 8*D1**2*fdd*g2*r - 16*D1**2*fdd*g2*s**2 + 32*D1**2*fdd*g2*s - 16*D1**2*fdd*g2 - 16*D1*Dd*K*f**2*r*s + 4*D1*Dd*K*f**2*r - 16*D1*Dd*K*f**2*s**2 + 16*D1*Dd*K*f**2*s - 4*D1*Dd*K*f**2 + 4*D1*Dd*f**2*r**2 + 56*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 52*D1*Dd*f**2*s**2 - 54*D1*Dd*f**2*s + 15*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 224*D1*Dd*f*fd*r*s + 124*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 164*D1*Dd*f*fd*s - 46*D1*Dd*f*fd - 64*D1*Dd*f*g2*r**2 + 64*D1*Dd*f*g2*r*s + 48*D1*Dd*f*g2*r + 128*D1*Dd*f*g2*s**2 - 96*D1*Dd*f*g2*s + 64*D1*Dd*f*gd2*r**2 - 64*D1*Dd*f*gd2*r*s - 88*D1*Dd*f*gd2*r - 128*D1*Dd*f*gd2*s**2 + 80*D1*Dd*f*gd2*s + 24*D1*Dd*f*gd2 + 64*D1*Dd*fd*g2*r**2 - 64*D1*Dd*fd*g2*r*s + 8*D1*Dd*fd*g2*r - 128*D1*Dd*fd*g2*s**2 + 176*D1*Dd*fd*g2*s - 48*D1*Dd*fd*g2 - 20*D1*Ddd*f**2*r**2 - 56*D1*Ddd*f**2*r*s + 34*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 46*D1*Ddd*f**2*s - 19*D1*Ddd*f**2 + 32*D1*Ddd*f*g2*r**2 - 32*D1*Ddd*f*g2*r*s - 24*D1*Ddd*f*g2*r - 64*D1*Ddd*f*g2*s**2 + 48*D1*Ddd*f*g2*s + 2*D1*bd1*(D1*(f*(4*K*(2*r**2 - 2*r*(s + 1) - 4*s**2 + s + 1) - 10*r**2 - 12*r*s + 14*r - 2*s**2 + 14*s - 9) + fd*(K*(-8*r**2 + 8*r*s + 16*s**2 - 18*s + 2) + 10*r**2 + 12*r*s - 9*r + 2*s**2 - s + 1)) + Dd*f*(K*(-32*r**2 + 4*r*(8*s + 7) + 64*s**2 - 32*s - 6) + 40*r**2 + 6*r*(8*s - 9) + 8*s**2 - 42*s + 21)) - 60*Dd**2*f**2*r**2 - 168*Dd**2*f**2*r*s + 102*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 138*Dd**2*f**2*s - 38*Dd**2*f**2 + 96*Dd**2*f*g2*r**2 - 96*Dd**2*f*g2*r*s - 72*Dd**2*f*g2*r - 192*Dd**2*f*g2*s**2 + 144*Dd**2*f*g2*s) - f*(33*D1**2*bdd1*(f*(5*r**2 + 2*r*(7*s - 5) + 9*s**2 - 14*s + 5) + 8*g2*(-r**2 + r*s + 2*s**2)) + 2*D1**2*(f*(2*fd*(60*C*(3*r*s - r + 3*s**2 - 3*s + 1) + 27*r**2 - 48*r*s - 2*r - 75*s**2 + 66*s - 16) + fdd*(-60*C*(3*r*s - r + 3*s**2 - 3*s + 1) - 27*r**2 + 48*r*s + 2*r + 75*s**2 - 66*s + 16) + s*(66*bd2 - 132*gd2)*(r + s - 1)) - 2*fd*(fd*(30*C*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 27*r**2 - 48*r*s - 2*r - 75*s**2 + 66*s - 8) + 66*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1))) + 132*D1*b2*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*D1*f*(2*Dd*(f*(60*C*(r*(4*s - 1) + (1 - 2*s)**2) + 36*r**2 - 4*r*(16*s + 5) - 100*s**2 + 82*s - 7) + fd*(-30*C*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 108*r**2 + 2*r*(96*s + 17) + 300*s**2 - 255*s + 31) - 66*g2*(r*(4*s - 1) + (1 - 2*s)**2)) + Ddd*f*(-60*C*(r*(4*s - 1) + (1 - 2*s)**2) - 36*r**2 + 4*r*(16*s + 5) + 100*s**2 - 82*s + 7)) - 4*Dd**2*f**2*(30*C*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 54*r**2 - 6*r*(16*s + 5) - 150*s**2 + 123*s - 7)))/(231*d**2*k3**3) + D1**2*Pk2*Pkd3*ct*k1*k2*st**2*(440*C*D1**2*bdd1*f**2*r**2 + 1056*C*D1**2*bdd1*f**2*r*s + 616*C*D1**2*bdd1*f**2*s**2 + 1812*C*D1**2*f**2*fd*r**2 + 6960*C*D1**2*f**2*fd*r*s - 3528*C*D1**2*f**2*fd*r + 5148*C*D1**2*f**2*fd*s**2 - 5752*C*D1**2*f**2*fd*s + 2320*C*D1**2*f**2*fd - 2556*C*D1**2*f**2*fdd*r**2 - 6912*C*D1**2*f**2*fdd*r*s + 4008*C*D1**2*f**2*fdd*r - 4356*C*D1**2*f**2*fdd*s**2 + 5208*C*D1**2*f**2*fdd*s - 2304*C*D1**2*f**2*fdd - 5112*C*D1**2*f*fd**2*r**2 - 13824*C*D1**2*f*fd**2*r*s + 8016*C*D1**2*f*fd**2*r - 8712*C*D1**2*f*fd**2*s**2 + 10416*C*D1**2*f*fd**2*s - 2304*C*D1**2*f*fd**2 + 2416*C*D1*Dd*f**3*r**2 + 9280*C*D1*Dd*f**3*r*s - 4736*C*D1*Dd*f**3*r + 6864*C*D1*Dd*f**3*s**2 - 8072*C*D1*Dd*f**3*s + 2924*C*D1*Dd*f**3 - 20448*C*D1*Dd*f**2*fd*r**2 - 55296*C*D1*Dd*f**2*fd*r*s + 33168*C*D1*Dd*f**2*fd*r - 34848*C*D1*Dd*f**2*fd*s**2 + 43368*C*D1*Dd*f**2*fd*s - 13224*C*D1*Dd*f**2*fd - 3408*C*D1*Ddd*f**3*r**2 - 9216*C*D1*Ddd*f**3*r*s + 5712*C*D1*Ddd*f**3*r - 5808*C*D1*Ddd*f**3*s**2 + 7512*C*D1*Ddd*f**3*s - 3156*C*D1*Ddd*f**3 - 10224*C*Dd**2*f**3*r**2 - 27648*C*Dd**2*f**3*r*s + 17136*C*Dd**2*f**3*r - 17424*C*Dd**2*f**3*s**2 + 22536*C*Dd**2*f**3*s - 6312*C*Dd**2*f**3 - 330*D1**2*K*bdd1*f**2*r**2 - 1056*D1**2*K*bdd1*f**2*r*s + 660*D1**2*K*bdd1*f**2*r - 726*D1**2*K*bdd1*f**2*s**2 + 1056*D1**2*K*bdd1*f**2*s - 330*D1**2*K*bdd1*f**2 + 66*D1**2*b2*bdd1*f*r**2 + 132*D1**2*b2*bdd1*f*r*s + 66*D1**2*b2*bdd1*f*s**2 + 396*D1**2*b2*f*fd*r**2 + 2112*D1**2*b2*f*fd*r*s - 1056*D1**2*b2*f*fd*r + 1716*D1**2*b2*f*fd*s**2 - 1716*D1**2*b2*f*fd*s + 858*D1**2*b2*f*fd - 660*D1**2*b2*f*fdd*r**2 - 2112*D1**2*b2*f*fdd*r*s + 1056*D1**2*b2*f*fdd*r - 1452*D1**2*b2*f*fdd*s**2 + 1452*D1**2*b2*f*fdd*s - 726*D1**2*b2*f*fdd - 660*D1**2*b2*fd**2*r**2 - 2112*D1**2*b2*fd**2*r*s + 1056*D1**2*b2*fd**2*r - 1452*D1**2*b2*fd**2*s**2 + 1452*D1**2*b2*fd**2*s + 22*D1**2*bd1**2*(3*f**2*(8*r**2 + r*(8*s - 15) - 9*s + 9) + f*(r**2*(8*C + 4*K - 25) - 2*r*(C*(2 - 4*s) + 24*K*s + 2*K + 13*s - 22) - s**2*(52*K + 1) + s*(24*K + 38) - 23) + 28*g2*r*(2*r + 2*s - 1)) + 198*D1**2*bd2*f**2*r**2 + 1056*D1**2*bd2*f**2*r*s - 396*D1**2*bd2*f**2*r + 858*D1**2*bd2*f**2*s**2 - 1056*D1**2*bd2*f**2*s + 198*D1**2*bd2*f**2 - 1320*D1**2*bd2*f*fd*r**2 - 4224*D1**2*bd2*f*fd*r*s + 2376*D1**2*bd2*f*fd*r - 2904*D1**2*bd2*f*fd*s**2 + 3564*D1**2*bd2*f*fd*s - 1056*D1**2*bd2*f*fd - 44*D1**2*bdd1*f**2*r**2 - 352*D1**2*bdd1*f**2*r*s - 374*D1**2*bdd1*f**2*r - 308*D1**2*bdd1*f**2*s**2 - 242*D1**2*bdd1*f**2*s + 121*D1**2*bdd1*f**2 - 88*D1**2*bdd1*f*g2*r**2 + 1056*D1**2*bdd1*f*g2*r*s + 1144*D1**2*bdd1*f*g2*s**2 - 330*D1**2*bdd2*f**2*r**2 - 1056*D1**2*bdd2*f**2*r*s + 660*D1**2*bdd2*f**2*r - 726*D1**2*bdd2*f**2*s**2 + 1056*D1**2*bdd2*f**2*s - 330*D1**2*bdd2*f**2 - 510*D1**2*f**2*fd*r**2 - 3084*D1**2*f**2*fd*r*s + 1368*D1**2*f**2*fd*r - 2574*D1**2*f**2*fd*s**2 + 2744*D1**2*f**2*fd*s - 1028*D1**2*f**2*fd + 1278*D1**2*f**2*fdd*r**2 + 3456*D1**2*f**2*fdd*r*s - 2004*D1**2*f**2*fdd*r + 2178*D1**2*f**2*fdd*s**2 - 2604*D1**2*f**2*fdd*s + 1152*D1**2*f**2*fdd - 396*D1**2*f**2*gd2*r**2 - 2112*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 2112*D1**2*f**2*gd2*s - 396*D1**2*f**2*gd2 + 660*D1**2*f**2*gdd2*r**2 + 2112*D1**2*f**2*gdd2*r*s - 1320*D1**2*f**2*gdd2*r + 1452*D1**2*f**2*gdd2*s**2 - 2112*D1**2*f**2*gdd2*s + 660*D1**2*f**2*gdd2 + 2556*D1**2*f*fd**2*r**2 + 6912*D1**2*f*fd**2*r*s - 4008*D1**2*f*fd**2*r + 4356*D1**2*f*fd**2*s**2 - 5208*D1**2*f*fd**2*s + 1152*D1**2*f*fd**2 - 792*D1**2*f*fd*g2*r**2 - 4224*D1**2*f*fd*g2*r*s + 2112*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 2640*D1**2*f*fd*gd2*r**2 + 8448*D1**2*f*fd*gd2*r*s - 4752*D1**2*f*fd*gd2*r + 5808*D1**2*f*fd*gd2*s**2 - 7128*D1**2*f*fd*gd2*s + 2112*D1**2*f*fd*gd2 + 1320*D1**2*f*fdd*g2*r**2 + 4224*D1**2*f*fdd*g2*r*s - 2112*D1**2*f*fdd*g2*r + 2904*D1**2*f*fdd*g2*s**2 - 2904*D1**2*f*fdd*g2*s + 1452*D1**2*f*fdd*g2 + 1320*D1**2*fd**2*g2*r**2 + 4224*D1**2*fd**2*g2*r*s - 2112*D1**2*fd**2*g2*r + 2904*D1**2*fd**2*g2*s**2 - 2904*D1**2*fd**2*g2*s + 792*D1*Dd*b2*f**2*r**2 + 4224*D1*Dd*b2*f**2*r*s - 1848*D1*Dd*b2*f**2*r + 3432*D1*Dd*b2*f**2*s**2 - 3828*D1*Dd*b2*f**2*s + 1254*D1*Dd*b2*f**2 - 5280*D1*Dd*b2*f*fd*r**2 - 16896*D1*Dd*b2*f*fd*r*s + 8976*D1*Dd*b2*f*fd*r - 11616*D1*Dd*b2*f*fd*s**2 + 12936*D1*Dd*b2*f*fd*s - 3564*D1*Dd*b2*f*fd - 2640*D1*Dd*bd2*f**2*r**2 - 8448*D1*Dd*bd2*f**2*r*s + 5016*D1*Dd*bd2*f**2*r - 5808*D1*Dd*bd2*f**2*s**2 + 7788*D1*Dd*bd2*f**2*s - 2376*D1*Dd*bd2*f**2 - 680*D1*Dd*f**3*r**2 - 4112*D1*Dd*f**3*r*s + 1708*D1*Dd*f**3*r - 3432*D1*Dd*f**3*s**2 + 3772*D1*Dd*f**3*s - 1198*D1*Dd*f**3 + 10224*D1*Dd*f**2*fd*r**2 + 27648*D1*Dd*f**2*fd*r*s - 16584*D1*Dd*f**2*fd*r + 17424*D1*Dd*f**2*fd*s**2 - 21684*D1*Dd*f**2*fd*s + 6612*D1*Dd*f**2*fd - 1584*D1*Dd*f**2*g2*r**2 - 8448*D1*Dd*f**2*g2*r*s + 3696*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 7656*D1*Dd*f**2*g2*s - 2508*D1*Dd*f**2*g2 + 5280*D1*Dd*f**2*gd2*r**2 + 16896*D1*Dd*f**2*gd2*r*s - 10032*D1*Dd*f**2*gd2*r + 11616*D1*Dd*f**2*gd2*s**2 - 15576*D1*Dd*f**2*gd2*s + 4752*D1*Dd*f**2*gd2 + 10560*D1*Dd*f*fd*g2*r**2 + 33792*D1*Dd*f*fd*g2*r*s - 17952*D1*Dd*f*fd*g2*r + 23232*D1*Dd*f*fd*g2*s**2 - 25872*D1*Dd*f*fd*g2*s + 7128*D1*Dd*f*fd*g2 - 1320*D1*Ddd*b2*f**2*r**2 - 4224*D1*Ddd*b2*f**2*r*s + 2376*D1*Ddd*b2*f**2*r - 2904*D1*Ddd*b2*f**2*s**2 + 3564*D1*Ddd*b2*f**2*s - 1386*D1*Ddd*b2*f**2 + 1704*D1*Ddd*f**3*r**2 + 4608*D1*Ddd*f**3*r*s - 2856*D1*Ddd*f**3*r + 2904*D1*Ddd*f**3*s**2 - 3756*D1*Ddd*f**3*s + 1578*D1*Ddd*f**3 + 2640*D1*Ddd*f**2*g2*r**2 + 8448*D1*Ddd*f**2*g2*r*s - 4752*D1*Ddd*f**2*g2*r + 5808*D1*Ddd*f**2*g2*s**2 - 7128*D1*Ddd*f**2*g2*s + 2772*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(f**2*(-88*C*s**2 + 6*K*(3*r**2 + 2*r*(8*s - 3) + 13*s**2 - 16*s + 3) + r**2*(11 - 48*C) + r*(-136*C*s + 54*s + 22) + 43*s**2 + 22*s - 5) - 2*f*(13*b2*r**2 + 26*b2*r*s + 13*b2*s**2 - 6*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(-112*C*s**2 + 104*C*s + 6*K*(10*r**2 + 2*r*(16*s - 9) + 22*s**2 - 27*s + 8) + r**2*(8 - 80*C) + r*(-192*C*s + 88*C + 64*s - 3) + 56*s**2 - 33*s - 17) - 120*g2*r**2 - 100*g2*r*s + 20*g2*s**2 + 8*gd2*r**2 - 96*gd2*r*s - 8*gd2*r - 104*gd2*s**2 + 48*gd2*s) + 4*fd*(3*b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 4*g2*(r**2 + r*(6 - 12*s) - s*(13*s - 13)))) - 2*Dd*f*(-6*b2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + f*(-224*C*s**2 + 152*C*s + 6*K*(20*r**2 + r*(64*s - 38) + 44*s**2 - 59*s + 18) + r**2*(16 - 160*C) + 4*r*(-96*C*s + 32*C + 32*s + 11) + 112*s**2 - 16*s - 45) + 8*g2*(4*r**2 + r*(4 - 48*s) + s*(25 - 52*s)))) - 3960*Dd**2*b2*f**2*r**2 - 12672*Dd**2*b2*f**2*r*s + 7128*Dd**2*b2*f**2*r - 8712*Dd**2*b2*f**2*s**2 + 10692*Dd**2*b2*f**2*s - 2772*Dd**2*b2*f**2 + 5112*Dd**2*f**3*r**2 + 13824*Dd**2*f**3*r*s - 8568*Dd**2*f**3*r + 8712*Dd**2*f**3*s**2 - 11268*Dd**2*f**3*s + 3156*Dd**2*f**3 + 7920*Dd**2*f**2*g2*r**2 + 25344*Dd**2*f**2*g2*r*s - 14256*Dd**2*f**2*g2*r + 17424*Dd**2*f**2*g2*s**2 - 21384*Dd**2*f**2*g2*s + 5544*Dd**2*f**2*g2 + 11*b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(6*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 14*Dd*(4*K*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 20*r**2 + r*(26 - 24*s) - 4*s**2 + 14*s - 11) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*Ddd*(4*K*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 20*r**2 + r*(26 - 24*s) - 4*s**2 + 14*s - 11)) - 2*Dd**2*(14*K*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 9*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 210*r**2 - 252*r*s + 273*r - 42*s**2 + 147*s - 77)) + 11*b1**2*(-16*C*D1**2*fd*r**2 - 16*C*D1**2*fd*r*s + 32*C*D1**2*fd*r + 16*C*D1**2*fd*s - 16*C*D1**2*fd + 8*C*D1**2*fdd*r**2 + 8*C*D1**2*fdd*r*s - 16*C*D1**2*fdd*r - 8*C*D1**2*fdd*s + 8*C*D1**2*fdd - 64*C*D1*Dd*f*r**2 - 64*C*D1*Dd*f*r*s + 80*C*D1*Dd*f*r + 32*C*D1*Dd*f*s - 32*C*D1*Dd*f + 64*C*D1*Dd*fd*r**2 + 64*C*D1*Dd*fd*r*s - 104*C*D1*Dd*fd*r - 48*C*D1*Dd*fd*s + 40*C*D1*Dd*fd + 32*C*D1*Ddd*f*r**2 + 32*C*D1*Ddd*f*r*s - 40*C*D1*Ddd*f*r - 16*C*D1*Ddd*f*s + 16*C*D1*Ddd*f + 96*C*Dd**2*f*r**2 + 96*C*Dd**2*f*r*s - 120*C*Dd**2*f*r - 48*C*Dd**2*f*s + 32*C*Dd**2*f - 120*D1**2*K*fd*r**2 - 100*D1**2*K*fd*r*s + 100*D1**2*K*fd*r + 20*D1**2*K*fd*s**2 - 40*D1**2*K*fd*s + 20*D1**2*K*fd + 4*D1**2*K*fdd*r**2 - 48*D1**2*K*fdd*r*s + 48*D1**2*K*fdd*r - 52*D1**2*K*fdd*s**2 + 104*D1**2*K*fdd*s - 52*D1**2*K*fdd + D1**2*bdd1*(-28*K*(3*r**2 + 3*r*(s - 1) - s + 1) - 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 105*r**2 + 126*r*s - 112*r + 21*s**2 - 56*s + 42) - 54*D1**2*f*fd*r**2 - 60*D1**2*f*fd*r*s + 42*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s - 15*D1**2*f*fd + 48*D1**2*f*fdd*r**2 + 48*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*r + 6*D1**2*f*fdd*s + 15*D1**2*f*fdd + 48*D1**2*fd**2*r**2 + 48*D1**2*fd**2*r*s - 30*D1**2*fd**2*r + 6*D1**2*fd**2*s - 18*D1**2*fd**2 + 57*D1**2*fd*r**2 + 66*D1**2*fd*r*s - 88*D1**2*fd*r + 9*D1**2*fd*s**2 + 12*D1**2*fd*s + 2*D1**2*fd - 25*D1**2*fdd*r**2 - 26*D1**2*fdd*r*s - 12*D1**2*fdd*r - D1**2*fdd*s**2 - 48*D1**2*fdd*s + 20*D1**2*fdd - 112*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 224*D1**2*gd2*r + 112*D1**2*gd2*s - 112*D1**2*gd2 + 56*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 112*D1**2*gdd2*r - 56*D1**2*gdd2*s + 56*D1**2*gdd2 - 480*D1*Dd*K*f*r**2 - 400*D1*Dd*K*f*r*s + 580*D1*Dd*K*f*r + 80*D1*Dd*K*f*s**2 + 160*D1*Dd*K*f*s - 220*D1*Dd*K*f + 32*D1*Dd*K*fd*r**2 - 384*D1*Dd*K*fd*r*s + 224*D1*Dd*K*fd*r - 416*D1*Dd*K*fd*s**2 + 616*D1*Dd*K*fd*s - 200*D1*Dd*K*fd - 108*D1*Dd*f**2*r**2 - 120*D1*Dd*f**2*r*s + 138*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 66*D1*Dd*f**2*s - 57*D1*Dd*f**2 + 384*D1*Dd*f*fd*r**2 + 384*D1*Dd*f*fd*r*s - 360*D1*Dd*f*fd*r - 72*D1*Dd*f*fd*s + 54*D1*Dd*f*fd + 228*D1*Dd*f*r**2 + 264*D1*Dd*f*r*s - 294*D1*Dd*f*r + 36*D1*Dd*f*s**2 - 150*D1*Dd*f*s + 123*D1*Dd*f - 200*D1*Dd*fd*r**2 - 208*D1*Dd*fd*r*s + 78*D1*Dd*fd*r - 8*D1*Dd*fd*s**2 - 138*D1*Dd*fd*s + 72*D1*Dd*fd - 448*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 560*D1*Dd*g2*r + 224*D1*Dd*g2*s - 224*D1*Dd*g2 + 448*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 728*D1*Dd*gd2*r - 336*D1*Dd*gd2*s + 280*D1*Dd*gd2 + 16*D1*Ddd*K*f*r**2 - 192*D1*Ddd*K*f*r*s + 32*D1*Ddd*K*f*r - 208*D1*Ddd*K*f*s**2 + 200*D1*Ddd*K*f*s - 44*D1*Ddd*K*f + 96*D1*Ddd*f**2*r**2 + 96*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r - 48*D1*Ddd*f**2*s + 48*D1*Ddd*f**2 - 100*D1*Ddd*f*r**2 - 104*D1*Ddd*f*r*s + 126*D1*Ddd*f*r - 4*D1*Ddd*f*s**2 + 54*D1*Ddd*f*s - 51*D1*Ddd*f + 224*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 280*D1*Ddd*g2*r - 112*D1*Ddd*g2*s + 112*D1*Ddd*g2 + 2*D1*bd1*(3*D1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*D1*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 7*D1*(4*K*(3*r**2 + 3*r*(s - 1) - s + 1) - 15*r**2 - 2*r*(9*s - 8) - 3*s**2 + 8*s - 6) - 3*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 7*Dd*(2*K*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7) - 60*r**2 + r*(71 - 72*s) - 12*s**2 + 37*s - 20)) + 48*Dd**2*K*f*r**2 - 576*Dd**2*K*f*r*s + 96*Dd**2*K*f*r - 624*Dd**2*K*f*s**2 + 600*Dd**2*K*f*s - 88*Dd**2*K*f + 288*Dd**2*f**2*r**2 + 288*Dd**2*f**2*r*s - 360*Dd**2*f**2*r - 144*Dd**2*f**2*s + 96*Dd**2*f**2 - 300*Dd**2*f*r**2 - 312*Dd**2*f*r*s + 378*Dd**2*f*r - 12*Dd**2*f*s**2 + 162*Dd**2*f*s - 102*Dd**2*f + 672*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 840*Dd**2*g2*r - 336*Dd**2*g2*s + 224*Dd**2*g2) - 11*b1*(-16*C*D1**2*bdd1*f*r**2 - 16*C*D1**2*bdd1*f*r*s + 8*C*D1**2*bdd1*f*r + 96*C*D1**2*f*fd*r**2 + 272*C*D1**2*f*fd*r*s - 232*C*D1**2*f*fd*r + 176*C*D1**2*f*fd*s**2 - 312*C*D1**2*f*fd*s + 136*C*D1**2*f*fd - 80*C*D1**2*f*fdd*r**2 - 192*C*D1**2*f*fdd*r*s + 176*C*D1**2*f*fdd*r - 112*C*D1**2*f*fdd*s**2 + 208*C*D1**2*f*fdd*s - 96*C*D1**2*f*fdd - 80*C*D1**2*fd**2*r**2 - 192*C*D1**2*fd**2*r*s + 176*C*D1**2*fd**2*r - 112*C*D1**2*fd**2*s**2 + 208*C*D1**2*fd**2*s - 96*C*D1**2*fd**2 + 192*C*D1*Dd*f**2*r**2 + 544*C*D1*Dd*f**2*r*s - 328*C*D1*Dd*f**2*r + 352*C*D1*Dd*f**2*s**2 - 448*C*D1*Dd*f**2*s + 184*C*D1*Dd*f**2 - 640*C*D1*Dd*f*fd*r**2 - 1536*C*D1*Dd*f*fd*r*s + 1216*C*D1*Dd*f*fd*r - 896*C*D1*Dd*f*fd*s**2 + 1440*C*D1*Dd*f*fd*s - 560*C*D1*Dd*f*fd - 160*C*D1*Ddd*f**2*r**2 - 384*C*D1*Ddd*f**2*r*s + 256*C*D1*Ddd*f**2*r - 224*C*D1*Ddd*f**2*s**2 + 304*C*D1*Ddd*f**2*s - 136*C*D1*Ddd*f**2 - 480*C*Dd**2*f**2*r**2 - 1152*C*Dd**2*f**2*r*s + 768*C*Dd**2*f**2*r - 672*C*Dd**2*f**2*s**2 + 912*C*Dd**2*f**2*s - 272*C*Dd**2*f**2 - 8*D1**2*K*bdd1*f*r**2 + 96*D1**2*K*bdd1*f*r*s + 8*D1**2*K*bdd1*f*r + 104*D1**2*K*bdd1*f*s**2 - 48*D1**2*K*bdd1*f*s - 4*D1**2*K*bdd1*f - 36*D1**2*K*f*fd*r**2 - 192*D1**2*K*f*fd*r*s + 96*D1**2*K*f*fd*r - 156*D1**2*K*f*fd*s**2 + 156*D1**2*K*f*fd*s - 78*D1**2*K*f*fd + 60*D1**2*K*f*fdd*r**2 + 192*D1**2*K*f*fdd*r*s - 96*D1**2*K*f*fdd*r + 132*D1**2*K*f*fdd*s**2 - 132*D1**2*K*f*fdd*s + 66*D1**2*K*f*fdd + 60*D1**2*K*fd**2*r**2 + 192*D1**2*K*fd**2*r*s - 96*D1**2*K*fd**2*r + 132*D1**2*K*fd**2*s**2 - 132*D1**2*K*fd**2*s + 26*D1**2*b2*fd*r**2 + 52*D1**2*b2*fd*r*s - 52*D1**2*b2*fd*r + 26*D1**2*b2*fd*s**2 - 52*D1**2*b2*fd*s + 26*D1**2*b2*fd - 6*D1**2*b2*fdd*r**2 - 12*D1**2*b2*fdd*r*s + 12*D1**2*b2*fdd*r - 6*D1**2*b2*fdd*s**2 + 12*D1**2*b2*fdd*s - 6*D1**2*b2*fdd + 2*D1**2*bd1**2*(14*K*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 105*r**2 - 126*r*s + 112*r - 21*s**2 + 56*s - 21) - 48*D1**2*bdd1*f**2*r**2 - 48*D1**2*bdd1*f**2*r*s + 90*D1**2*bdd1*f**2*r + 54*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 + 50*D1**2*bdd1*f*r**2 + 52*D1**2*bdd1*f*r*s - 88*D1**2*bdd1*f*r + 2*D1**2*bdd1*f*s**2 - 76*D1**2*bdd1*f*s + 46*D1**2*bdd1*f - 112*D1**2*bdd1*g2*r**2 - 112*D1**2*bdd1*g2*r*s + 56*D1**2*bdd1*g2*r - 6*D1**2*bdd2*f*r**2 - 12*D1**2*bdd2*f*r*s + 12*D1**2*bdd2*f*r - 6*D1**2*bdd2*f*s**2 + 12*D1**2*bdd2*f*s - 6*D1**2*bdd2*f - 22*D1**2*f*fd*r**2 - 108*D1**2*f*fd*r*s + 98*D1**2*f*fd*r - 86*D1**2*f*fd*s**2 + 162*D1**2*f*fd*s - 59*D1**2*f*fd + 8*D1**2*f*fdd*r**2 + 64*D1**2*f*fdd*r*s - 74*D1**2*f*fdd*r + 56*D1**2*f*fdd*s**2 - 110*D1**2*f*fdd*s + 43*D1**2*f*fdd - 240*D1**2*f*gd2*r**2 - 200*D1**2*f*gd2*r*s + 480*D1**2*f*gd2*r + 40*D1**2*f*gd2*s**2 + 200*D1**2*f*gd2*s - 240*D1**2*f*gd2 + 8*D1**2*f*gdd2*r**2 - 96*D1**2*f*gdd2*r*s - 16*D1**2*f*gdd2*r - 104*D1**2*f*gdd2*s**2 + 96*D1**2*f*gdd2*s + 8*D1**2*f*gdd2 + 8*D1**2*fd**2*r**2 + 64*D1**2*fd**2*r*s - 74*D1**2*fd**2*r + 56*D1**2*fd**2*s**2 - 110*D1**2*fd**2*s + 66*D1**2*fd**2 - 240*D1**2*fd*g2*r**2 - 200*D1**2*fd*g2*r*s + 200*D1**2*fd*g2*r + 40*D1**2*fd*g2*s**2 - 80*D1**2*fd*g2*s + 40*D1**2*fd*g2 + 16*D1**2*fd*gd2*r**2 - 192*D1**2*fd*gd2*r*s + 80*D1**2*fd*gd2*r - 208*D1**2*fd*gd2*s**2 + 304*D1**2*fd*gd2*s - 96*D1**2*fd*gd2 + 8*D1**2*fdd*g2*r**2 - 96*D1**2*fdd*g2*r*s + 96*D1**2*fdd*g2*r - 104*D1**2*fdd*g2*s**2 + 208*D1**2*fdd*g2*s - 104*D1**2*fdd*g2 - 72*D1*Dd*K*f**2*r**2 - 384*D1*Dd*K*f**2*r*s + 168*D1*Dd*K*f**2*r - 312*D1*Dd*K*f**2*s**2 + 348*D1*Dd*K*f**2*s - 114*D1*Dd*K*f**2 + 480*D1*Dd*K*f*fd*r**2 + 1536*D1*Dd*K*f*fd*r*s - 816*D1*Dd*K*f*fd*r + 1056*D1*Dd*K*f*fd*s**2 - 1176*D1*Dd*K*f*fd*s + 324*D1*Dd*K*f*fd + 104*D1*Dd*b2*f*r**2 + 208*D1*Dd*b2*f*r*s - 156*D1*Dd*b2*f*r + 104*D1*Dd*b2*f*s**2 - 156*D1*Dd*b2*f*s + 78*D1*Dd*b2*f - 48*D1*Dd*b2*fd*r**2 - 96*D1*Dd*b2*fd*r*s + 84*D1*Dd*b2*fd*r - 48*D1*Dd*b2*fd*s**2 + 84*D1*Dd*b2*fd*s - 36*D1*Dd*b2*fd - 44*D1*Dd*f**2*r**2 - 216*D1*Dd*f**2*r*s + 98*D1*Dd*f**2*r - 172*D1*Dd*f**2*s**2 + 194*D1*Dd*f**2*s - 65*D1*Dd*f**2 + 64*D1*Dd*f*fd*r**2 + 512*D1*Dd*f*fd*r*s - 392*D1*Dd*f*fd*r + 448*D1*Dd*f*fd*s**2 - 680*D1*Dd*f*fd*s + 258*D1*Dd*f*fd - 960*D1*Dd*f*g2*r**2 - 800*D1*Dd*f*g2*r*s + 1160*D1*Dd*f*g2*r + 160*D1*Dd*f*g2*s**2 + 320*D1*Dd*f*g2*s - 440*D1*Dd*f*g2 + 64*D1*Dd*f*gd2*r**2 - 768*D1*Dd*f*gd2*r*s - 832*D1*Dd*f*gd2*s**2 + 784*D1*Dd*f*gd2*s - 64*D1*Dd*f*gd2 + 64*D1*Dd*fd*g2*r**2 - 768*D1*Dd*fd*g2*r*s + 448*D1*Dd*fd*g2*r - 832*D1*Dd*fd*g2*s**2 + 1232*D1*Dd*fd*g2*s - 400*D1*Dd*fd*g2 + 120*D1*Ddd*K*f**2*r**2 + 384*D1*Ddd*K*f**2*r*s - 216*D1*Ddd*K*f**2*r + 264*D1*Ddd*K*f**2*s**2 - 324*D1*Ddd*K*f**2*s + 126*D1*Ddd*K*f**2 - 24*D1*Ddd*b2*f*r**2 - 48*D1*Ddd*b2*f*r*s + 36*D1*Ddd*b2*f*r - 24*D1*Ddd*b2*f*s**2 + 36*D1*Ddd*b2*f*s - 18*D1*Ddd*b2*f + 16*D1*Ddd*f**2*r**2 + 128*D1*Ddd*f**2*r*s - 48*D1*Ddd*f**2*r + 112*D1*Ddd*f**2*s**2 - 120*D1*Ddd*f**2*s + 36*D1*Ddd*f**2 + 32*D1*Ddd*f*g2*r**2 - 384*D1*Ddd*f*g2*r*s + 64*D1*Ddd*f*g2*r - 416*D1*Ddd*f*g2*s**2 + 400*D1*Ddd*f*g2*s - 88*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(3*f**2*(9*r**2 + 2*r*(5*s - 8) + s**2 - 12*s + 7) - f*(-16*C*r**2 - 16*C*r*s + 8*C*r - 10*K*(12*r**2 + 2*r*(5*s - 6) - 2*s**2 - 5*s + 6) + 6*fd*(16*r**2 + 4*r*(4*s - 5) - 8*s + 5) + 57*r**2 + 66*r*s - 46*r + 9*s**2 - 48*s + 32) - 2*fd*(2*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 2*K*(2*r**2 - 24*r*s + 11*r - 26*s**2 + 32*s - 6) - 25*r**2 - 26*r*s + 16*r - s**2 - 5*s + 5) + 56*g2*r*(2*r + 2*s - 1) - 28*gd2*(4*r**2 + r*(4*s - 5) - 2*s + 1)) + Dd*(-3*f**2*(16*r - 13)*(4*r + 4*s - 3) - 2*f*(4*C*(8*r**2 + r*(8*s - 7) - 2*s + 1) + 4*K*(4*r**2 - 48*r*s + 2*r - 52*s**2 + 37*s - 2) - 100*r**2 - 104*r*s + 151*r - 4*s**2 + 103*s - 63) - 56*g2*(8*r**2 + r*(8*s - 7) - 2*s + 1))) + 2*D1*bd2*(D1*(13*f - 6*fd)*(r + s - 1) - 6*Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 360*Dd**2*K*f**2*r**2 + 1152*Dd**2*K*f**2*r*s - 648*Dd**2*K*f**2*r + 792*Dd**2*K*f**2*s**2 - 972*Dd**2*K*f**2*s + 252*Dd**2*K*f**2 - 72*Dd**2*b2*f*r**2 - 144*Dd**2*b2*f*r*s + 108*Dd**2*b2*f*r - 72*Dd**2*b2*f*s**2 + 108*Dd**2*b2*f*s - 36*Dd**2*b2*f + 48*Dd**2*f**2*r**2 + 384*Dd**2*f**2*r*s - 144*Dd**2*f**2*r + 336*Dd**2*f**2*s**2 - 360*Dd**2*f**2*s + 72*Dd**2*f**2 + 96*Dd**2*f*g2*r**2 - 1152*Dd**2*f*g2*r*s + 192*Dd**2*f*g2*r - 1248*Dd**2*f*g2*s**2 + 1200*Dd**2*f*g2*s - 176*Dd**2*f*g2))/(462*d**2*k3**3) + D1**2*Pk2*Pkd3*ct*k1*k2*(2*D1*(-D1*bd1**2*(f*(14*K*(5*r**2 + 2*r*(4*s - 5) + 3*s**2 - 9*s + 5) + r**2*(81 - 116*C) - r*(132*C - 87)*(2*s - 1) - s*(148*C - 93)*(s - 1)) + 28*g2*(3*r**2 + r*(8*s - 4) + s*(5*s - 5))) - 2*D1*bdd1*f*(f*(6*C - 3)*(6*r**2 + r*(9*s - 11) + 3*s**2 - 10*s + 5) - 7*g2*(5*r**2 + 2*r*(4*s - 5) + 3*s**2 - 10*s + 5)) + 7*b2*(r + s - 1)*(2*D1*bd1**2*(r + s) - 5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3))) - 2*bd1*(35*D1*bd2*f*(r + s - 1)**2 + D1*(-3*f**2*(2*C*(5*r**2 + 6*r*s - 8*r + s**2 - 6*s + 3) - 3*r**2 - 4*r*s + 6*r - s**2 + 6*s - 3) + f*(fd*(6*C - 3)*(24*r**2 + 4*r*(9*s - 8) + 12*s**2 - 25*s + 11) + 7*g2*(3*r**2 + 4*r*s - 6*r + s**2 - 6*s + 3) - 14*gd2*(5*r**2 + 8*r*s - 10*r + 3*s**2 - 9*s + 5)) - 14*fd*g2*(5*r**2 + r*(8*s - 4) + s*(3*s - 3))) + Dd*f*(f*(6*C - 3)*(48*r**2 + r*(72*s - 77) + 24*s**2 - 64*s + 32) - 14*g2*(20*r**2 + r*(32*s - 34) + 12*s**2 - 31*s + 15)))) + 7*b1**3*(D1**2*(4*fd*(r - 1) + fdd*(-7*r - 3*s + 7))*(r + s - 1) + D1*(4*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 2*Dd*fd*(28*r**2 + r*(40*s - 47) + 12*s**2 - 33*s + 19) + 4*Dd*(-K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - Ddd*f*(28*r**2 + r*(40*s - 38) + 12*s**2 - 26*s + 17) - 2*Ddd*(-K*(12*r**2 + 4*r*(8*s - 5) + 20*s**2 - 26*s + 11) + 4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 2*Dd**2*(-2*K*(18*r**2 + 6*r*(8*s - 5) + 30*s**2 - 39*s + 11) + f*(42*r**2 + r*(60*s - 57) + 18*s**2 - 39*s + 17) + 12*r**2 + 6*r*(4*s - 3) + 12*s**2 - 18*s + 6)) + b1**2*(-8*C*D1**2*fd*r**2 - 80*C*D1**2*fd*r*s + 16*C*D1**2*fd*r - 72*C*D1**2*fd*s**2 + 80*C*D1**2*fd*s - 8*C*D1**2*fd + 116*C*D1**2*fdd*r**2 + 264*C*D1**2*fdd*r*s - 232*C*D1**2*fdd*r + 148*C*D1**2*fdd*s**2 - 264*C*D1**2*fdd*s + 116*C*D1**2*fdd - 32*C*D1*Dd*f*r**2 - 320*C*D1*Dd*f*r*s + 112*C*D1*Dd*f*r - 288*C*D1*Dd*f*s**2 + 304*C*D1*Dd*f*s - 88*C*D1*Dd*f + 928*C*D1*Dd*fd*r**2 + 2112*C*D1*Dd*fd*r*s - 1656*C*D1*Dd*fd*r + 1184*C*D1*Dd*fd*s**2 - 1880*C*D1*Dd*fd*s + 728*C*D1*Dd*fd + 464*C*D1*Ddd*f*r**2 + 1056*C*D1*Ddd*f*r*s - 728*C*D1*Ddd*f*r + 592*C*D1*Ddd*f*s**2 - 824*C*D1*Ddd*f*s + 380*C*D1*Ddd*f + 1392*C*Dd**2*f*r**2 + 3168*C*Dd**2*f*r*s - 2184*C*Dd**2*f*r + 1776*C*Dd**2*f*s**2 - 2472*C*Dd**2*f*s + 760*C*Dd**2*f + 126*D1**2*K*bdd1*r**2 + 336*D1**2*K*bdd1*r*s - 196*D1**2*K*bdd1*r + 210*D1**2*K*bdd1*s**2 - 252*D1**2*K*bdd1*s + 112*D1**2*K*bdd1 + 42*D1**2*K*fd*r**2 + 56*D1**2*K*fd*r*s + 28*D1**2*K*fd*r + 14*D1**2*K*fd*s**2 + 56*D1**2*K*fd*s - 28*D1**2*K*fd - 70*D1**2*K*fdd*r**2 - 112*D1**2*K*fdd*r*s - 28*D1**2*K*fdd*r - 42*D1**2*K*fdd*s**2 - 56*D1**2*K*fdd*s + 28*D1**2*K*fdd - 147*D1**2*bdd1*f*r**2 - 210*D1**2*bdd1*f*r*s + 168*D1**2*bdd1*f*r - 63*D1**2*bdd1*f*s**2 + 112*D1**2*bdd1*f*s - 70*D1**2*bdd1*f - 42*D1**2*bdd1*r**2 - 84*D1**2*bdd1*r*s + 56*D1**2*bdd1*r - 42*D1**2*bdd1*s**2 + 56*D1**2*bdd1*s - 28*D1**2*bdd1 + 14*D1**2*bdd2*r**2 + 28*D1**2*bdd2*r*s - 28*D1**2*bdd2*r + 14*D1**2*bdd2*s**2 - 28*D1**2*bdd2*s + 14*D1**2*bdd2 + 8*D1**2*fd*r**2 + 40*D1**2*fd*r*s + 40*D1**2*fd*r + 32*D1**2*fd*s**2 - 12*D1**2*fd*s - 20*D1**2*fd - 81*D1**2*fdd*r**2 - 174*D1**2*fdd*r*s + 162*D1**2*fdd*r - 93*D1**2*fdd*s**2 + 174*D1**2*fdd*s - 81*D1**2*fdd + 168*D1**2*gd2*r**2 + 448*D1**2*gd2*r*s - 336*D1**2*gd2*r + 280*D1**2*gd2*s**2 - 448*D1**2*gd2*s + 168*D1**2*gd2 - 84*D1**2*gdd2*r**2 - 224*D1**2*gdd2*r*s + 168*D1**2*gdd2*r - 140*D1**2*gdd2*s**2 + 224*D1**2*gdd2*s - 84*D1**2*gdd2 + 168*D1*Dd*K*f*r**2 + 224*D1*Dd*K*f*r*s - 224*D1*Dd*K*f*r + 56*D1*Dd*K*f*s**2 - 140*D1*Dd*K*f*s + 98*D1*Dd*K*f - 560*D1*Dd*K*fd*r**2 - 896*D1*Dd*K*fd*r*s + 280*D1*Dd*K*fd*r - 336*D1*Dd*K*fd*s**2 + 84*D1*Dd*K*fd*s + 112*D1*Dd*K*fd - 112*D1*Dd*b2*r**2 - 224*D1*Dd*b2*r*s + 168*D1*Dd*b2*r - 112*D1*Dd*b2*s**2 + 168*D1*Dd*b2*s - 84*D1*Dd*b2 + 32*D1*Dd*f*r**2 + 160*D1*Dd*f*r*s - 72*D1*Dd*f*r + 128*D1*Dd*f*s**2 - 144*D1*Dd*f*s + 48*D1*Dd*f - 648*D1*Dd*fd*r**2 - 1392*D1*Dd*fd*r*s + 1146*D1*Dd*fd*r - 744*D1*Dd*fd*s**2 + 1230*D1*Dd*fd*s - 498*D1*Dd*fd + 672*D1*Dd*g2*r**2 + 1792*D1*Dd*g2*r*s - 1120*D1*Dd*g2*r + 1120*D1*Dd*g2*s**2 - 1456*D1*Dd*g2*s + 616*D1*Dd*g2 - 672*D1*Dd*gd2*r**2 - 1792*D1*Dd*gd2*r*s + 1232*D1*Dd*gd2*r - 1120*D1*Dd*gd2*s**2 + 1624*D1*Dd*gd2*s - 560*D1*Dd*gd2 - 280*D1*Ddd*K*f*r**2 - 448*D1*Ddd*K*f*r*s + 392*D1*Ddd*K*f*r - 168*D1*Ddd*K*f*s**2 + 308*D1*Ddd*K*f*s - 182*D1*Ddd*K*f + 56*D1*Ddd*b2*r**2 + 112*D1*Ddd*b2*r*s - 84*D1*Ddd*b2*r + 56*D1*Ddd*b2*s**2 - 84*D1*Ddd*b2*s + 42*D1*Ddd*b2 - 324*D1*Ddd*f*r**2 - 696*D1*Ddd*f*r*s + 498*D1*Ddd*f*r - 372*D1*Ddd*f*s**2 + 534*D1*Ddd*f*s - 255*D1*Ddd*f - 336*D1*Ddd*g2*r**2 - 896*D1*Ddd*g2*r*s + 560*D1*Ddd*g2*r - 560*D1*Ddd*g2*s**2 + 728*D1*Ddd*g2*s - 308*D1*Ddd*g2 + 14*D1*bd1*(D1*(-2*K*(9*r**2 + 2*r*(12*s - 7) + 15*s**2 - 18*s + 8) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 2) - fd*(21*r**2 + r*(30*s - 33) + 9*s**2 - 23*s + 12) + 6*r**2 + 12*r*s - 8*r + 6*s**2 - 8*s + 4) - Dd*(-2*K*(36*r**2 + 96*r*s - 58*r + 60*s**2 - 75*s + 23) + f*(84*r**2 + 15*r*(8*s - 7) + 36*s**2 - 71*s + 32) + 24*r**2 + 48*r*s - 34*r + 24*s**2 - 34*s + 12)) - 28*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 840*Dd**2*K*f*r**2 - 1344*Dd**2*K*f*r*s + 1176*Dd**2*K*f*r - 504*Dd**2*K*f*s**2 + 924*Dd**2*K*f*s - 364*Dd**2*K*f + 168*Dd**2*b2*r**2 + 336*Dd**2*b2*r*s - 252*Dd**2*b2*r + 168*Dd**2*b2*s**2 - 252*Dd**2*b2*s + 84*Dd**2*b2 - 972*Dd**2*f*r**2 - 2088*Dd**2*f*r*s + 1494*Dd**2*f*r - 1116*Dd**2*f*s**2 + 1602*Dd**2*f*s - 510*Dd**2*f - 1008*Dd**2*g2*r**2 - 2688*Dd**2*g2*r*s + 1680*Dd**2*g2*r - 1680*Dd**2*g2*s**2 + 2184*Dd**2*g2*s - 616*Dd**2*g2) - b1*(-232*C*D1**2*bdd1*f*r**2 - 528*C*D1**2*bdd1*f*r*s + 264*C*D1**2*bdd1*f*r - 296*C*D1**2*bdd1*f*s**2 + 296*C*D1**2*bdd1*f*s - 148*C*D1**2*bdd1*f - 240*C*D1**2*f*fd*r**2 - 288*C*D1**2*f*fd*r*s + 192*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 72*C*D1**2*f*fd + 288*C*D1**2*f*fdd*r**2 + 432*C*D1**2*f*fdd*r*s - 240*C*D1**2*f*fdd*r + 144*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 96*C*D1**2*f*fdd + 288*C*D1**2*fd**2*r**2 + 432*C*D1**2*fd**2*r*s - 240*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 48*C*D1**2*fd**2 - 480*C*D1*Dd*f**2*r**2 - 576*C*D1*Dd*f**2*r*s + 624*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 336*C*D1*Dd*f**2*s - 264*C*D1*Dd*f**2 + 2304*C*D1*Dd*f*fd*r**2 + 3456*C*D1*Dd*f*fd*r*s - 2544*C*D1*Dd*f*fd*r + 1152*C*D1*Dd*f*fd*s**2 - 1632*C*D1*Dd*f*fd*s + 600*C*D1*Dd*f*fd + 576*C*D1*Ddd*f**2*r**2 + 864*C*D1*Ddd*f**2*r*s - 792*C*D1*Ddd*f**2*r + 288*C*D1*Ddd*f**2*s**2 - 576*C*D1*Ddd*f**2*s + 360*C*D1*Ddd*f**2 + 1728*C*Dd**2*f**2*r**2 + 2592*C*Dd**2*f**2*r*s - 2376*C*Dd**2*f**2*r + 864*C*Dd**2*f**2*s**2 - 1728*C*Dd**2*f**2*s + 720*C*Dd**2*f**2 + 140*D1**2*K*bdd1*f*r**2 + 224*D1**2*K*bdd1*f*r*s - 280*D1**2*K*bdd1*f*r + 84*D1**2*K*bdd1*f*s**2 - 252*D1**2*K*bdd1*f*s + 140*D1**2*K*bdd1*f + 14*D1**2*bd1**2*(-2*K*(9*r**2 + 24*r*s - 14*r + 15*s**2 - 18*s + 4) + f*(21*r**2 + 6*r*(5*s - 4) + 9*s**2 - 16*s + 5) + 6*r**2 + 12*r*s - 8*r + 6*s**2 - 8*s + 2) - 42*D1**2*bd2*f*r**2 - 84*D1**2*bd2*f*r*s + 84*D1**2*bd2*f*r - 42*D1**2*bd2*f*s**2 + 84*D1**2*bd2*f*s - 42*D1**2*bd2*f + 140*D1**2*bd2*fd*r**2 + 280*D1**2*bd2*fd*r*s - 140*D1**2*bd2*fd*r + 140*D1**2*bd2*fd*s**2 - 140*D1**2*bd2*fd*s + 162*D1**2*bdd1*f*r**2 + 348*D1**2*bdd1*f*r*s - 174*D1**2*bdd1*f*r + 186*D1**2*bdd1*f*s**2 - 186*D1**2*bdd1*f*s + 93*D1**2*bdd1*f + 168*D1**2*bdd1*g2*r**2 + 448*D1**2*bdd1*g2*r*s - 224*D1**2*bdd1*g2*r + 280*D1**2*bdd1*g2*s**2 - 280*D1**2*bdd1*g2*s + 140*D1**2*bdd1*g2 + 70*D1**2*bdd2*f*r**2 + 140*D1**2*bdd2*f*r*s - 140*D1**2*bdd2*f*r + 70*D1**2*bdd2*f*s**2 - 140*D1**2*bdd2*f*s + 70*D1**2*bdd2*f + 72*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s - 48*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 + 12*D1**2*f*fd - 144*D1**2*f*fdd*r**2 - 216*D1**2*f*fdd*r*s + 120*D1**2*f*fdd*r - 72*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s - 48*D1**2*f*fdd + 84*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 168*D1**2*f*gd2*r + 28*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 84*D1**2*f*gd2 - 140*D1**2*f*gdd2*r**2 - 224*D1**2*f*gdd2*r*s + 280*D1**2*f*gdd2*r - 84*D1**2*f*gdd2*s**2 + 224*D1**2*f*gdd2*s - 140*D1**2*f*gdd2 - 144*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 120*D1**2*fd**2*r - 72*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s + 24*D1**2*fd**2 + 84*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r + 28*D1**2*fd*g2*s**2 + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 - 280*D1**2*fd*gd2*r**2 - 448*D1**2*fd*gd2*r*s + 224*D1**2*fd*gd2*r - 168*D1**2*fd*gd2*s**2 + 112*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 - 140*D1**2*fdd*g2*r**2 - 224*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r - 84*D1**2*fdd*g2*s**2 - 112*D1**2*fdd*g2*s + 56*D1**2*fdd*g2 + 560*D1*Dd*bd2*f*r**2 + 1120*D1*Dd*bd2*f*r*s - 980*D1*Dd*bd2*f*r + 560*D1*Dd*bd2*f*s**2 - 980*D1*Dd*bd2*f*s + 420*D1*Dd*bd2*f + 144*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s - 192*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 120*D1*Dd*f**2*s + 84*D1*Dd*f**2 - 1152*D1*Dd*f*fd*r**2 - 1728*D1*Dd*f*fd*r*s + 1272*D1*Dd*f*fd*r - 576*D1*Dd*f*fd*s**2 + 816*D1*Dd*f*fd*s - 300*D1*Dd*f*fd + 336*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 448*D1*Dd*f*g2*r + 112*D1*Dd*f*g2*s**2 - 280*D1*Dd*f*g2*s + 196*D1*Dd*f*g2 - 1120*D1*Dd*f*gd2*r**2 - 1792*D1*Dd*f*gd2*r*s + 1904*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 1512*D1*Dd*f*gd2*s - 784*D1*Dd*f*gd2 - 1120*D1*Dd*fd*g2*r**2 - 1792*D1*Dd*fd*g2*r*s + 560*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s + 224*D1*Dd*fd*g2 - 288*D1*Ddd*f**2*r**2 - 432*D1*Ddd*f**2*r*s + 396*D1*Ddd*f**2*r - 144*D1*Ddd*f**2*s**2 + 288*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 560*D1*Ddd*f*g2*r**2 - 896*D1*Ddd*f*g2*r*s + 784*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 616*D1*Ddd*f*g2*s - 364*D1*Ddd*f*g2 - 2*D1*bd1*(14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f*(-4*C*(2*r**2 + 20*r*s - 10*r + 18*s**2 - 18*s + 9) + 14*K*(3*r**2 + 4*r*s - 6*r + s**2 - 5*s + 3) + 8*r**2 + 40*r*s - 48*r + 32*s**2 - 46*s + 30) + fd*(4*C*(58*r**2 + r*(132*s - 91) + 74*s**2 - 103*s + 33) - 14*K*(10*r**2 + 16*r*s - 8*r + 6*s**2 - 5*s - 1) - 162*r**2 - 348*r*s + 249*r - 186*s**2 + 267*s - 87) + 28*g2*(6*r**2 + 16*r*s - 8*r + 10*s**2 - 10*s + 5) - 28*gd2*(6*r**2 + 2*r*(8*s - 5) + 10*s**2 - 13*s + 4)) + Dd*(f*(4*C*(232*r**2 + r*(528*s - 314) + 296*s**2 - 354*s + 103) - 14*K*(40*r**2 + 64*r*s - 68*r + 24*s**2 - 58*s + 29) - 648*r**2 - 1392*r*s + 846*r - 744*s**2 + 906*s - 267) - 28*g2*(24*r**2 + 4*r*(16*s - 9) + 40*s**2 - 46*s + 13))) - 864*Dd**2*f**2*r**2 - 1296*Dd**2*f**2*r*s + 1188*Dd**2*f**2*r - 432*Dd**2*f**2*s**2 + 864*Dd**2*f**2*s - 360*Dd**2*f**2 - 1680*Dd**2*f*g2*r**2 - 2688*Dd**2*f*g2*r*s + 2352*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 1848*Dd**2*f*g2*s - 728*Dd**2*f*g2 + 14*b2*(-D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 3*D1**2*fd*r**2 - 6*D1**2*fd*r*s - 3*D1**2*fd*s**2 + 5*D1**2*fdd*r**2 + 10*D1**2*fdd*r*s + 5*D1**2*fdd*s**2 - 12*D1*Dd*f*r**2 - 24*D1*Dd*f*r*s + 18*D1*Dd*f*r - 12*D1*Dd*f*s**2 + 18*D1*Dd*f*s - 9*D1*Dd*f + 40*D1*Dd*fd*r**2 + 80*D1*Dd*fd*r*s - 30*D1*Dd*fd*r + 40*D1*Dd*fd*s**2 - 30*D1*Dd*fd*s + 20*D1*Ddd*f*r**2 + 40*D1*Ddd*f*r*s - 30*D1*Ddd*f*r + 20*D1*Ddd*f*s**2 - 30*D1*Ddd*f*s + 15*D1*Ddd*f + 2*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 60*Dd**2*f*r**2 + 120*Dd**2*f*r*s - 90*Dd**2*f*r + 60*Dd**2*f*s**2 - 90*Dd**2*f*s + 30*Dd**2*f)))/(21*d**2*k3**3) - 8*D1**2*Pk2*Pkd3*ct*k1*st**4*(D1**2*bd1**2*f*s*(-2*r - 2*s + 1) + D1*b1*(D1*bdd1*f*s*(-2*r - 2*s + 1) - bd1*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(7*d**2*k2*k3) + D1**2*Pk2*Pkd3*ct*k1*st**2*(D1*(2*D1*bd1**2*f*(r**2*(9*f - 1) + r*(12*K*s + f*(30*s - 9) - 34*s + 3) + s*(12*K*s - 6*K + 3*f*(7*s - 5) - 33*s + 19)) + D1*bdd1*f*(r + s)*(7*f*r + f*s*(24*C - 1) + s*(12*b2 - 24*g2)) + bd1*(-D1*(f**2*(r + s)*(40*C*s + 9*r + s) - 4*f*(bd2*s*(6*r + 6*s - 3) + 7*fd*r**2 + fd*r*(6*C*(4*s - 1) + 6*s - 5) + fd*s*(6*C*(4*s - 3) - s - 1) + 2*s*(13*g2*(r + s) + gd2*(-6*r - 6*s + 3))) + 24*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*Dd*f*(f*(28*r**2 + r*(96*C*s - 12*C + 24*s - 17) + s*(96*C*s - 48*C - 4*s - 5)) + 12*g2*(-8*r*s + r + s*(4 - 8*s))) + 4*b2*(D1*(-13*f*s*(r + s) + fd*r*(6*s - 3) + 6*fd*s*(s - 1)) + 3*Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + 4*b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 14*r*(4*s - 1) - 14*(1 - 2*s)**2) - D1*Ddd*(3*f - 7)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(3*f - 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-52*D1**2*K*fd*r*s + 52*D1**2*K*fd*r - 52*D1**2*K*fd*s**2 + 104*D1**2*K*fd*s - 52*D1**2*K*fd + 12*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r + 12*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 4*D1**2*bdd1*(3*f - 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 6*D1**2*f*fd*r**2 - 84*D1**2*f*fd*r*s + 48*D1**2*f*fd*r - 78*D1**2*f*fd*s**2 + 120*D1**2*f*fd*s - 42*D1**2*f*fd + 18*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s - 48*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 30*D1**2*f*fdd + 18*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s - 48*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s + 30*D1**2*fd**2 - 33*D1**2*fd*r**2 + 26*D1**2*fd*r*s - 18*D1**2*fd*r + 59*D1**2*fd*s**2 - 110*D1**2*fd*s + 51*D1**2*fd - D1**2*fdd*r**2 - 34*D1**2*fdd*r*s + 30*D1**2*fdd*r - 33*D1**2*fdd*s**2 + 62*D1**2*fdd*s - 29*D1**2*fdd - 208*D1*Dd*K*f*r*s + 52*D1*Dd*K*f*r - 208*D1*Dd*K*f*s**2 + 208*D1*Dd*K*f*s - 52*D1*Dd*K*f + 96*D1*Dd*K*fd*r*s - 60*D1*Dd*K*fd*r + 96*D1*Dd*K*fd*s**2 - 144*D1*Dd*K*fd*s + 48*D1*Dd*K*fd - 12*D1*Dd*f**2*r**2 - 168*D1*Dd*f**2*r*s + 54*D1*Dd*f**2*r - 156*D1*Dd*f**2*s**2 + 162*D1*Dd*f**2*s - 45*D1*Dd*f**2 + 144*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 324*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 492*D1*Dd*f*fd*s + 168*D1*Dd*f*fd - 132*D1*Dd*f*r**2 + 104*D1*Dd*f*r*s + 106*D1*Dd*f*r + 236*D1*Dd*f*s**2 - 170*D1*Dd*f*s - 7*D1*Dd*f - 8*D1*Dd*fd*r**2 - 272*D1*Dd*fd*r*s + 158*D1*Dd*fd*r - 264*D1*Dd*fd*s**2 + 382*D1*Dd*fd*s - 122*D1*Dd*fd + 48*D1*Ddd*K*f*r*s - 12*D1*Ddd*K*f*r + 48*D1*Ddd*K*f*s**2 - 48*D1*Ddd*K*f*s + 12*D1*Ddd*K*f + 36*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 66*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 102*D1*Ddd*f**2*s + 39*D1*Ddd*f**2 - 4*D1*Ddd*f*r**2 - 136*D1*Ddd*f*r*s + 38*D1*Ddd*f*r - 132*D1*Ddd*f*s**2 + 134*D1*Ddd*f*s - 35*D1*Ddd*f + 4*D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) - 42*r*s + 14*r - 42*s**2 + 42*s - 14) - Dd*(3*f - 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 144*Dd**2*K*f*r*s - 36*Dd**2*K*f*r + 144*Dd**2*K*f*s**2 - 144*Dd**2*K*f*s + 24*Dd**2*K*f + 108*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 198*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 306*Dd**2*f**2*s + 78*Dd**2*f**2 - 12*Dd**2*f*r**2 - 408*Dd**2*f*r*s + 114*Dd**2*f*r - 396*Dd**2*f*s**2 + 402*Dd**2*f*s - 70*Dd**2*f) + b1*(-80*C*D1**2*f*fd*r*s + 40*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 120*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 48*C*D1**2*f*fdd*s**2 - 72*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 48*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s + 24*C*D1**2*fd**2 - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r*s - 144*C*D1*Dd*f*fd*r + 384*C*D1*Dd*f*fd*s**2 - 480*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 96*C*D1*Ddd*f**2*s + 24*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 288*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 - 52*D1**2*b2*fd*r*s + 52*D1**2*b2*fd*r - 52*D1**2*b2*fd*s**2 + 104*D1**2*b2*fd*s - 52*D1**2*b2*fd + 12*D1**2*b2*fdd*r*s - 12*D1**2*b2*fdd*r + 12*D1**2*b2*fdd*s**2 - 24*D1**2*b2*fdd*s + 12*D1**2*b2*fdd - 4*D1**2*bd1**2*(3*f - 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 52*D1**2*bd2*f*r*s - 52*D1**2*bd2*f*s**2 + 52*D1**2*bd2*f*s + 24*D1**2*bd2*fd*r*s - 12*D1**2*bd2*fd*r + 24*D1**2*bd2*fd*s**2 - 36*D1**2*bd2*fd*s + 12*D1**2*bd2*fd + D1**2*bdd1*f*(24*K*s**2 - 12*K*s + 3*f*(6*r**2 + r*(20*s - 6) + 14*s**2 - 10*s + 3) - 2*r**2 + r*(24*K*s - 68*s + 6) - 66*s**2 + 38*s - 5) + 12*D1**2*bdd2*f*r*s + 12*D1**2*bdd2*f*s**2 - 12*D1**2*bdd2*f*s - 18*D1**2*f*fd*r**2 - 20*D1**2*f*fd*r*s + 28*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 10*D1**2*f*fd + 14*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 - 4*D1**2*f*fdd*s + 6*D1**2*f*fdd + 104*D1**2*f*gd2*r*s + 104*D1**2*f*gd2*s**2 - 104*D1**2*f*gd2*s - 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s + 14*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 20*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 - 4*D1**2*fd**2*s + 6*D1**2*fd**2 + 104*D1**2*fd*g2*r*s - 104*D1**2*fd*g2*r + 104*D1**2*fd*g2*s**2 - 208*D1**2*fd*g2*s + 104*D1**2*fd*g2 - 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 72*D1**2*fd*gd2*s - 24*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r*s + 24*D1**2*fdd*g2*r - 24*D1**2*fdd*g2*s**2 + 48*D1**2*fdd*g2*s - 24*D1**2*fdd*g2 - 208*D1*Dd*b2*f*r*s + 52*D1*Dd*b2*f*r - 208*D1*Dd*b2*f*s**2 + 208*D1*Dd*b2*f*s - 52*D1*Dd*b2*f + 96*D1*Dd*b2*fd*r*s - 60*D1*Dd*b2*fd*r + 96*D1*Dd*b2*fd*s**2 - 144*D1*Dd*b2*fd*s + 48*D1*Dd*b2*fd + 96*D1*Dd*bd2*f*r*s - 12*D1*Dd*bd2*f*r + 96*D1*Dd*bd2*f*s**2 - 96*D1*Dd*bd2*f*s + 12*D1*Dd*bd2*f - 36*D1*Dd*f**2*r**2 - 40*D1*Dd*f**2*r*s + 46*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 22*D1*Dd*f**2*s - 19*D1*Dd*f**2 + 112*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 148*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 - 36*D1*Dd*f*fd*s + 44*D1*Dd*f*fd + 416*D1*Dd*f*g2*r*s - 104*D1*Dd*f*g2*r + 416*D1*Dd*f*g2*s**2 - 416*D1*Dd*f*g2*s + 104*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r*s + 24*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 192*D1*Dd*f*gd2*s - 24*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r*s + 120*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s - 96*D1*Dd*fd*g2 + 48*D1*Ddd*b2*f*r*s - 12*D1*Ddd*b2*f*r + 48*D1*Ddd*b2*f*s**2 - 48*D1*Ddd*b2*f*s + 12*D1*Ddd*b2*f + 28*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 34*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 - 10*D1*Ddd*f**2*s + 13*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 96*D1*Ddd*f*g2*s - 24*D1*Ddd*f*g2 + D1*bd1*(-D1*(f**2*(6*r**2 + r*(84*s - 6) + 78*s**2 - 42*s + 3) + f*(104*K*s**2 - 52*K*s - 12*fd*(6*r**2 + r*(20*s - 11) + 14*s**2 - 17*s + 4) + 66*r**2 + 2*r*(52*K*s - 26*s - 29) - 118*s**2 + 34*s + 25) + 2*fd*(-6*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 2*r**2 + r*(68*s - 33) + 66*s**2 - 81*s + 17)) + 2*Dd*f*(6*K*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 3*f*(24*r**2 + r*(80*s - 34) + 56*s**2 - 54*s + 11) - 8*r**2 - 272*r*s + 50*r - 264*s**2 + 210*s - 25)) + 144*Dd**2*b2*f*r*s - 36*Dd**2*b2*f*r + 144*Dd**2*b2*f*s**2 - 144*Dd**2*b2*f*s + 24*Dd**2*b2*f + 84*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 102*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 - 30*Dd**2*f**2*s + 26*Dd**2*f**2 - 288*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 288*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(42*d**2*k2*k3) + D1**2*Pk2*Pkd3*ct*k1*(2*D1*(D1*bd1**2*f*(23*r**2 - 7*r*(s*(4*K - 6) + 3) + s*(K*(14 - 28*s) + 19*s - 19)) - 2*D1*bdd1*f*s*(r + s)*(12*C*f + 7*b2 - 6*f - 14*g2) - 2*bd1*(D1*(f**2*s*(6 - 12*C)*(r + s) + f*(fd*(12*C - 6)*(r*(4*s - 1) + s*(4*s - 3)) + 7*s*(bd2*(2*r + 2*s - 1) + 2*g2*(r + s) - 2*gd2*(2*r + 2*s - 1))) + 14*fd*g2*(-2*r*s + r - s*(2*s - 2))) + 2*Dd*f*(f*(6*C - 3) - 7*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + 7*b2*(D1*(-f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) - 7*b1**3*(D1**2*(fd*(r + 5*s - 1) - 3*fdd*(r + s - 1))*(r + s - 1) + D1*(Dd*(f*(4*r**2 + 2*r*(12*s - 5) + 20*s**2 - 22*s + 7) - 6*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 16*r**2 + 4*r*(8*s - 6) + 16*s**2 - 24*s + 12) - Ddd*(3*f + 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(3*f + 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(28*D1**2*K*fd*r*s - 28*D1**2*K*fd*r + 28*D1**2*K*fd*s**2 - 56*D1**2*K*fd*s + 28*D1**2*K*fd - 28*D1**2*K*fdd*r*s + 28*D1**2*K*fdd*r - 28*D1**2*K*fdd*s**2 + 56*D1**2*K*fdd*s - 28*D1**2*K*fdd + 7*D1**2*bdd1*(3*f + 2)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 11*D1**2*fd*r**2 - 42*D1**2*fd*r*s + 22*D1**2*fd*r - 31*D1**2*fd*s**2 + 42*D1**2*fd*s - 11*D1**2*fd + 23*D1**2*fdd*r**2 + 42*D1**2*fdd*r*s - 46*D1**2*fdd*r + 19*D1**2*fdd*s**2 - 42*D1**2*fdd*s + 23*D1**2*fdd + 112*D1*Dd*K*f*r*s - 28*D1*Dd*K*f*r + 112*D1*Dd*K*f*s**2 - 112*D1*Dd*K*f*s + 28*D1*Dd*K*f - 224*D1*Dd*K*fd*r*s + 140*D1*Dd*K*fd*r - 224*D1*Dd*K*fd*s**2 + 336*D1*Dd*K*fd*s - 112*D1*Dd*K*fd - 44*D1*Dd*f*r**2 - 168*D1*Dd*f*r*s + 86*D1*Dd*f*r - 124*D1*Dd*f*s**2 + 146*D1*Dd*f*s - 53*D1*Dd*f + 184*D1*Dd*fd*r**2 + 336*D1*Dd*fd*r*s - 318*D1*Dd*fd*r + 152*D1*Dd*fd*s**2 - 290*D1*Dd*fd*s + 134*D1*Dd*fd - 112*D1*Ddd*K*f*r*s + 28*D1*Ddd*K*f*r - 112*D1*Ddd*K*f*s**2 + 112*D1*Ddd*K*f*s - 28*D1*Ddd*K*f + 92*D1*Ddd*f*r**2 + 168*D1*Ddd*f*r*s - 134*D1*Ddd*f*r + 76*D1*Ddd*f*s**2 - 122*D1*Ddd*f*s + 65*D1*Ddd*f - 7*D1*bd1*(D1*(f*(3*r**2 + 2*r*(9*s - 4) + 15*s**2 - 16*s + 6) - 6*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 12*r**2 + 4*r*(6*s - 4) + 12*s**2 - 16*s + 8) - 2*Dd*(3*f + 2)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 336*Dd**2*K*f*r*s + 84*Dd**2*K*f*r - 336*Dd**2*K*f*s**2 + 336*Dd**2*K*f*s - 56*Dd**2*K*f + 276*Dd**2*f*r**2 + 504*Dd**2*f*r*s - 402*Dd**2*f*r + 228*Dd**2*f*s**2 - 366*Dd**2*f*s + 130*Dd**2*f) + b1*(96*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*r + 96*C*D1**2*f*fd*s**2 - 144*C*D1**2*f*fd*s + 48*C*D1**2*f*fd - 96*C*D1**2*f*fdd*r*s + 48*C*D1**2*f*fdd*r - 96*C*D1**2*f*fdd*s**2 + 144*C*D1**2*f*fdd*s - 48*C*D1**2*f*fdd - 96*C*D1**2*fd**2*r*s + 48*C*D1**2*fd**2*r - 96*C*D1**2*fd**2*s**2 + 144*C*D1**2*fd**2*s - 48*C*D1**2*fd**2 + 192*C*D1*Dd*f**2*r*s - 48*C*D1*Dd*f**2*r + 192*C*D1*Dd*f**2*s**2 - 192*C*D1*Dd*f**2*s + 48*C*D1*Dd*f**2 - 768*C*D1*Dd*f*fd*r*s + 288*C*D1*Dd*f*fd*r - 768*C*D1*Dd*f*fd*s**2 + 960*C*D1*Dd*f*fd*s - 240*C*D1*Dd*f*fd - 192*C*D1*Ddd*f**2*r*s + 48*C*D1*Ddd*f**2*r - 192*C*D1*Ddd*f**2*s**2 + 192*C*D1*Ddd*f**2*s - 48*C*D1*Ddd*f**2 - 576*C*Dd**2*f**2*r*s + 144*C*Dd**2*f**2*r - 576*C*Dd**2*f**2*s**2 + 576*C*Dd**2*f**2*s - 96*C*Dd**2*f**2 + 14*D1**2*bd1**2*(3*f + 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1**2*bdd1*f*(46*r**2 - 14*r*(s*(4*K - 6) + 3) + s**2*(38 - 56*K) + s*(28*K - 38) + 19) - 28*D1**2*bdd2*f*r*s - 28*D1**2*bdd2*f*s**2 + 28*D1**2*bdd2*f*s - 48*D1**2*f*fd*r*s + 24*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 72*D1**2*f*fd*s - 24*D1**2*f*fd + 48*D1**2*f*fdd*r*s - 24*D1**2*f*fdd*r + 48*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 24*D1**2*f*fdd - 56*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*s**2 + 56*D1**2*f*gd2*s + 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*s**2 - 56*D1**2*f*gdd2*s + 48*D1**2*fd**2*r*s - 24*D1**2*fd**2*r + 48*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s + 24*D1**2*fd**2 - 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*r - 56*D1**2*fd*g2*s**2 + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 + 112*D1**2*fd*gd2*r*s - 56*D1**2*fd*gd2*r + 112*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 56*D1**2*fd*gd2 + 56*D1**2*fdd*g2*r*s - 56*D1**2*fdd*g2*r + 56*D1**2*fdd*g2*s**2 - 112*D1**2*fdd*g2*s + 56*D1**2*fdd*g2 - 96*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 96*D1*Dd*f**2*s - 24*D1*Dd*f**2 + 384*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r + 384*D1*Dd*f*fd*s**2 - 480*D1*Dd*f*fd*s + 120*D1*Dd*f*fd - 224*D1*Dd*f*g2*r*s + 56*D1*Dd*f*g2*r - 224*D1*Dd*f*g2*s**2 + 224*D1*Dd*f*g2*s - 56*D1*Dd*f*g2 + 448*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r + 448*D1*Dd*f*gd2*s**2 - 448*D1*Dd*f*gd2*s + 56*D1*Dd*f*gd2 + 448*D1*Dd*fd*g2*r*s - 280*D1*Dd*fd*g2*r + 448*D1*Dd*fd*g2*s**2 - 672*D1*Dd*fd*g2*s + 224*D1*Dd*fd*g2 + 96*D1*Ddd*f**2*r*s - 24*D1*Ddd*f**2*r + 96*D1*Ddd*f**2*s**2 - 96*D1*Ddd*f**2*s + 24*D1*Ddd*f**2 + 224*D1*Ddd*f*g2*r*s - 56*D1*Ddd*f*g2*r + 224*D1*Ddd*f*g2*s**2 - 224*D1*Ddd*f*g2*s + 56*D1*Ddd*f*g2 + D1*bd1*(D1*(f*(-22*r**2 + 14*r*(s*(4*K - 6) + 3) + s**2*(56*K - 62) + s*(62 - 28*K) - 31) - 2*fd*(14*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 46*r**2 + r*(67 - 84*s) - 38*s**2 + 61*s - 21)) + 2*Dd*f*(-14*K*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 184*r**2 + r*(336*s - 218) + 152*s**2 - 198*s + 61)) + 28*D1*bd2*(D1*(r + s - 1)*(f*s - 2*fd*s + fd) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 288*Dd**2*f**2*r*s - 72*Dd**2*f**2*r + 288*Dd**2*f**2*s**2 - 288*Dd**2*f**2*s + 48*Dd**2*f**2 + 672*Dd**2*f*g2*r*s - 168*Dd**2*f*g2*r + 672*Dd**2*f*g2*s**2 - 672*Dd**2*f*g2*s + 112*Dd**2*f*g2 + 28*b2*(D1**2*(fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(21*d**2*k2*k3) - D1**2*Pk2*Pkd3*ct*k2**3*(8*C - 4)*(D1**2*bd1**2*f*r*(-2*r - 2*s + 1) + D1*b1*(D1*bdd1*f*r*(-2*r - 2*s + 1) - bd1*(D1*(-2*f*r*(2*r + 2*s - 1) + fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 2*Dd*f*(8*r**2 + r*(8*s - 7) - 2*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(r - 1)*(r + s - 1) + D1*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)))/(21*d**2*k1*k3**3) + D1**2*Pk2*Pkd3*ct*k2*(8*C - 4)*(D1**2*bd1**2*f*r*(-2*r - 2*s + 1) + D1*b1*(D1*bdd1*f*r*(-2*r - 2*s + 1) - bd1*(D1*(-2*f*r*(2*r + 2*s - 1) + fd*(4*r**2 + 4*r*s - 5*r - 2*s + 1)) + 2*Dd*f*(8*r**2 + r*(8*s - 7) - 2*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(r - 1)*(r + s - 1) + D1*(2*Dd*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd*fd*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) + Ddd*f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)))/(21*d**2*k1*k3) + 3*D1**2*Pk2*Pkd3*f**2*k1**6*st**4*(D1**2*(f*(61*fd - 50*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 300*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(61*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 100*fd*(4*r + 4*s - 3)**2) - 50*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 300*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1001*d**2*k3**7) + 80*D1**2*Pk2*Pkd3*f**2*k1**6*st**4*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(3003*d**2*k2**2*k3**5) + 5*D1**2*Pk2*Pkd3*f**2*k1**4*k2**2*st**6*(D1**2*(f*(73*fd - 30*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 180*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(73*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 60*fd*(4*r + 4*s - 3)**2) - 30*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(2002*d**2*k3**7) + 40*D1**2*Pk2*Pkd3*f**2*k1**4*st**6*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(1001*d**2*k3**5) - 5*D1**2*Pk2*Pkd3*f**2*k1**2*k2**4*st**8*(D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(143*d**2*k3**7) - 40*D1**2*Pk2*Pkd3*f**2*k1**2*k2**2*st**8*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(1287*d**2*k3**5) + D1**2*Pk2*Pkd3*f*k1**6*st**2*(-50*D1**2*bdd1*f**2*(r + s - 1)**2 + D1*bd1*f*(r + s - 1)*(67*D1*f*(r + s - 1) - 100*D1*fd*(3*r + 3*s - 2) - 100*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(f*(67*fd - 50*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 100*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(67*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 100*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 50*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 300*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**7) + 25*D1**2*Pk2*Pkd3*f*k1**6*st**2*(12*D1**2*b1*f*fd*r*s + 12*D1**2*b1*f*fd*s**2 - 8*D1**2*b1*f*fd*s - 6*D1**2*b1*f*fdd*r*s - 6*D1**2*b1*f*fdd*s**2 + 4*D1**2*b1*f*fdd*s - 12*D1**2*b1*fd**2*r*s - 12*D1**2*b1*fd**2*s**2 + 8*D1**2*b1*fd**2*s - 2*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) - 12*D1**2*f**2*fd*r*s + 3*D1**2*f**2*fd*r - 12*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 3*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r + 12*D1**2*f**2*fdd*s**2 - 12*D1**2*f**2*fdd*s + 3*D1**2*f**2*fdd + 36*D1**2*f*fd**2*r*s - 9*D1**2*f*fd**2*r + 36*D1**2*f*fd**2*s**2 - 36*D1**2*f*fd**2*s + 6*D1**2*f*fd**2 + 16*D1*Dd*b1*f**2*r*s - 4*D1*Dd*b1*f**2*r + 16*D1*Dd*b1*f**2*s**2 - 16*D1*Dd*b1*f**2*s + 4*D1*Dd*b1*f**2 - 48*D1*Dd*b1*f*fd*r*s + 6*D1*Dd*b1*f*fd*r - 48*D1*Dd*b1*f*fd*s**2 + 40*D1*Dd*b1*f*fd*s - 4*D1*Dd*b1*f*fd - 12*D1*Dd*f**3*r*s + 3*D1*Dd*f**3*r - 12*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 3*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r*s - 24*D1*Dd*f**2*fd*r + 96*D1*Dd*f**2*fd*s**2 - 96*D1*Dd*f**2*fd*s + 18*D1*Dd*f**2*fd - 8*D1*Ddd*b1*f**2*r*s + 2*D1*Ddd*b1*f**2*r - 8*D1*Ddd*b1*f**2*s**2 + 8*D1*Ddd*b1*f**2*s - 2*D1*Ddd*b1*f**2 + 12*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 2*D1*bd1*f*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 24*Dd**2*b1*f**2*r*s + 6*Dd**2*b1*f**2*r - 24*Dd**2*b1*f**2*s**2 + 24*Dd**2*b1*f**2*s - 4*Dd**2*b1*f**2 + 36*Dd**2*f**3*r*s - 9*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 6*Dd**2*f**3)/(693*d**2*k2**2*k3**5) - 10*D1**2*Pk2*Pkd3*f*k1**6*(-D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) + b1*(D1**2*s*(f*(fd - fdd) - 2*fd**2)*(3*r + 3*s - 2) + D1*f*(Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) + Dd*fd*(r*(3 - 24*s) - 24*s**2 + 20*s - 2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(21*d**2*k2**2*k3**5) + D1**2*Pk2*Pkd3*f*k1**4*st**4*(210*D1**2*b1*f*fd*r**2 + 468*D1**2*b1*f*fd*r*s - 308*D1**2*b1*f*fd*r + 258*D1**2*b1*f*fd*s**2 - 340*D1**2*b1*f*fd*s + 138*D1**2*b1*f*fd - 105*D1**2*b1*f*fdd*r**2 - 234*D1**2*b1*f*fdd*r*s + 154*D1**2*b1*f*fdd*r - 129*D1**2*b1*f*fdd*s**2 + 170*D1**2*b1*f*fdd*s - 69*D1**2*b1*f*fdd - 210*D1**2*b1*fd**2*r**2 - 468*D1**2*b1*fd**2*r*s + 308*D1**2*b1*fd**2*r - 258*D1**2*b1*fd**2*s**2 + 340*D1**2*b1*fd**2*s - 114*D1**2*b1*fd**2 - D1**2*bdd1*f**2*(35*r**2 + 78*r*s - 64*r + 43*s**2 - 72*s + 44) - 124*D1**2*f**2*fd*r**2 - 424*D1**2*f**2*fd*r*s + 230*D1**2*f**2*fd*r - 300*D1**2*f**2*fd*s**2 + 362*D1**2*f**2*fd*s - 137*D1**2*f**2*fd + 148*D1**2*f**2*fdd*r**2 + 376*D1**2*f**2*fdd*r*s - 242*D1**2*f**2*fdd*r + 228*D1**2*f**2*fdd*s**2 - 302*D1**2*f**2*fdd*s + 131*D1**2*f**2*fdd + 444*D1**2*f*fd**2*r**2 + 1128*D1**2*f*fd**2*r*s - 726*D1**2*f*fd**2*r + 684*D1**2*f*fd**2*s**2 - 906*D1**2*f*fd**2*s + 262*D1**2*f*fd**2 + 280*D1*Dd*b1*f**2*r**2 + 624*D1*Dd*b1*f**2*r*s - 436*D1*Dd*b1*f**2*r + 344*D1*Dd*b1*f**2*s**2 - 484*D1*Dd*b1*f**2*s + 226*D1*Dd*b1*f**2 - 840*D1*Dd*b1*f*fd*r**2 - 1872*D1*Dd*b1*f*fd*r*s + 1270*D1*Dd*b1*f*fd*r - 1032*D1*Dd*b1*f*fd*s**2 + 1406*D1*Dd*b1*f*fd*s - 478*D1*Dd*b1*f*fd - 124*D1*Dd*f**3*r**2 - 424*D1*Dd*f**3*r*s + 230*D1*Dd*f**3*r - 300*D1*Dd*f**3*s**2 + 362*D1*Dd*f**3*s - 137*D1*Dd*f**3 + 1184*D1*Dd*f**2*fd*r**2 + 3008*D1*Dd*f**2*fd*r*s - 1936*D1*Dd*f**2*fd*r + 1824*D1*Dd*f**2*fd*s**2 - 2416*D1*Dd*f**2*fd*s + 786*D1*Dd*f**2*fd - 140*D1*Ddd*b1*f**2*r**2 - 312*D1*Ddd*b1*f**2*r*s + 218*D1*Ddd*b1*f**2*r - 172*D1*Ddd*b1*f**2*s**2 + 242*D1*Ddd*b1*f**2*s - 113*D1*Ddd*b1*f**2 + 148*D1*Ddd*f**3*r**2 + 376*D1*Ddd*f**3*r*s - 242*D1*Ddd*f**3*r + 228*D1*Ddd*f**3*s**2 - 302*D1*Ddd*f**3*s + 131*D1*Ddd*f**3 + 2*D1*bd1*f*(D1*(f*(35*r**2 + 78*r*s - 64*r + 43*s**2 - 72*s + 44) - fd*(105*r**2 + 234*r*s - 173*r + 129*s**2 - 193*s + 56)) - Dd*f*(140*r**2 + 3*r*(104*s - 79) + 172*s**2 - 265*s + 100)) - 420*Dd**2*b1*f**2*r**2 - 936*Dd**2*b1*f**2*r*s + 654*Dd**2*b1*f**2*r - 516*Dd**2*b1*f**2*s**2 + 726*Dd**2*b1*f**2*s - 226*Dd**2*b1*f**2 + 444*Dd**2*f**3*r**2 + 1128*Dd**2*f**3*r*s - 726*Dd**2*f**3*r + 684*Dd**2*f**3*s**2 - 906*Dd**2*f**3*s + 262*Dd**2*f**3)/(231*d**2*k3**5) - 8*D1**2*Pk2*Pkd3*f*k1**4*st**4*(D1*f*(D1*bd1*(-2*f*s*(2*r + 2*s - 1) + fd*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1)) + D1*bdd1*f*s*(2*r + 2*s - 1) + Dd*bd1*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + b1*(D1**2*(-f*(2*fd - fdd)*(6*r*s - 2*r + 6*s**2 - 7*s + 2) + fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3)) + D1*f*(Dd*(-4*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11)) + 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k2**2*k3**3) + 5*D1**2*Pk2*Pkd3*f*k1**2*k2**4*st**6*(24*D1**2*b1*f*fd*r**2 + 48*D1**2*b1*f*fd*r*s - 32*D1**2*b1*f*fd*r + 24*D1**2*b1*f*fd*s**2 - 32*D1**2*b1*f*fd*s + 16*D1**2*b1*f*fd - 12*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 16*D1**2*b1*f*fdd*r - 12*D1**2*b1*f*fdd*s**2 + 16*D1**2*b1*f*fdd*s - 8*D1**2*b1*f*fdd - 24*D1**2*b1*fd**2*r**2 - 48*D1**2*b1*fd**2*r*s + 32*D1**2*b1*fd**2*r - 24*D1**2*b1*fd**2*s**2 + 32*D1**2*b1*fd**2*s - 8*D1**2*b1*fd**2 - 4*D1**2*bdd1*f**2*(r + s - 1)**2 + 4*D1**2*f**2*fd*r**2 + 8*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r + 4*D1**2*f**2*fd*s**2 - 6*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 32*D1*Dd*b1*f**2*r**2 + 64*D1*Dd*b1*f**2*r*s - 48*D1*Dd*b1*f**2*r + 32*D1*Dd*b1*f**2*s**2 - 48*D1*Dd*b1*f**2*s + 24*D1*Dd*b1*f**2 - 96*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 136*D1*Dd*b1*f*fd*r - 96*D1*Dd*b1*f*fd*s**2 + 136*D1*Dd*b1*f*fd*s - 48*D1*Dd*b1*f*fd + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 16*D1*Ddd*b1*f**2*r**2 - 32*D1*Ddd*b1*f**2*r*s + 24*D1*Ddd*b1*f**2*r - 16*D1*Ddd*b1*f**2*s**2 + 24*D1*Ddd*b1*f**2*s - 12*D1*Ddd*b1*f**2 + 8*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 48*Dd**2*b1*f**2*r**2 - 96*Dd**2*b1*f**2*r*s + 72*Dd**2*b1*f**2*r - 48*Dd**2*b1*f**2*s**2 + 72*Dd**2*b1*f**2*s - 24*Dd**2*b1*f**2)/(154*d**2*k3**7) + 9*D1**2*Pk2*Pkd3*f*k1**2*k2**4*st**4*(D1**2*(f*(fd*(8*C - 4)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (11*K*bd1 - 22*gd2)*(r + s - 1)**2) + fd*(-fd*(8*C - 4)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + (11*K*b1 - 22*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1))) + D1*f*(Dd*(f*(8*C - 4)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(8*C - 4)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - (-11*K*b1 + 22*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Ddd*f*(2 - 4*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Dd**2*f**2*(12 - 24*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**7) + 5*D1**2*Pk2*Pkd3*f*k1**2*k2**2*st**6*(-150*D1**2*b1*f*fd*r**2 - 228*D1**2*b1*f*fd*r*s + 188*D1**2*b1*f*fd*r - 78*D1**2*b1*f*fd*s**2 + 140*D1**2*b1*f*fd*s - 78*D1**2*b1*f*fd + 75*D1**2*b1*f*fdd*r**2 + 114*D1**2*b1*f*fdd*r*s - 94*D1**2*b1*f*fdd*r + 39*D1**2*b1*f*fdd*s**2 - 70*D1**2*b1*f*fdd*s + 39*D1**2*b1*f*fdd + 150*D1**2*b1*fd**2*r**2 + 228*D1**2*b1*fd**2*r*s - 188*D1**2*b1*fd**2*r + 78*D1**2*b1*fd**2*s**2 - 140*D1**2*b1*fd**2*s + 54*D1**2*b1*fd**2 + D1**2*bdd1*f**2*(25*r**2 + 38*r*s - 44*r + 13*s**2 - 32*s + 24) + 84*D1**2*f**2*fd*r**2 + 160*D1**2*f**2*fd*r*s - 124*D1**2*f**2*fd*r + 76*D1**2*f**2*fd*s**2 - 118*D1**2*f**2*fd*s + 61*D1**2*f**2*fd - 92*D1**2*f**2*fdd*r**2 - 144*D1**2*f**2*fdd*r*s + 128*D1**2*f**2*fdd*r - 52*D1**2*f**2*fdd*s**2 + 98*D1**2*f**2*fdd*s - 59*D1**2*f**2*fdd - 276*D1**2*f*fd**2*r**2 - 432*D1**2*f*fd**2*r*s + 384*D1**2*f*fd**2*r - 156*D1**2*f*fd**2*s**2 + 294*D1**2*f*fd**2*s - 118*D1**2*f*fd**2 - 200*D1*Dd*b1*f**2*r**2 - 304*D1*Dd*b1*f**2*r*s + 276*D1*Dd*b1*f**2*r - 104*D1*Dd*b1*f**2*s**2 + 204*D1*Dd*b1*f**2*s - 126*D1*Dd*b1*f**2 + 600*D1*Dd*b1*f*fd*r**2 + 912*D1*Dd*b1*f*fd*r*s - 790*D1*Dd*b1*f*fd*r + 312*D1*Dd*b1*f*fd*s**2 - 586*D1*Dd*b1*f*fd*s + 258*D1*Dd*b1*f*fd + 84*D1*Dd*f**3*r**2 + 160*D1*Dd*f**3*r*s - 124*D1*Dd*f**3*r + 76*D1*Dd*f**3*s**2 - 118*D1*Dd*f**3*s + 61*D1*Dd*f**3 - 736*D1*Dd*f**2*fd*r**2 - 1152*D1*Dd*f**2*fd*r*s + 1024*D1*Dd*f**2*fd*r - 416*D1*Dd*f**2*fd*s**2 + 784*D1*Dd*f**2*fd*s - 354*D1*Dd*f**2*fd + 100*D1*Ddd*b1*f**2*r**2 + 152*D1*Ddd*b1*f**2*r*s - 138*D1*Ddd*b1*f**2*r + 52*D1*Ddd*b1*f**2*s**2 - 102*D1*Ddd*b1*f**2*s + 63*D1*Ddd*b1*f**2 - 92*D1*Ddd*f**3*r**2 - 144*D1*Ddd*f**3*r*s + 128*D1*Ddd*f**3*r - 52*D1*Ddd*f**3*s**2 + 98*D1*Ddd*f**3*s - 59*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(f*(25*r**2 + 38*r*s - 44*r + 13*s**2 - 32*s + 24) - fd*(75*r**2 + 114*r*s - 113*r + 39*s**2 - 83*s + 36)) - Dd*f*(100*r**2 + r*(152*s - 157) + 52*s**2 - 115*s + 60)) + 300*Dd**2*b1*f**2*r**2 + 456*Dd**2*b1*f**2*r*s - 414*Dd**2*b1*f**2*r + 156*Dd**2*b1*f**2*s**2 - 306*Dd**2*b1*f**2*s + 126*Dd**2*b1*f**2 - 276*Dd**2*f**3*r**2 - 432*Dd**2*f**3*r*s + 384*Dd**2*f**3*r - 156*Dd**2*f**3*s**2 + 294*Dd**2*f**3*s - 118*Dd**2*f**3)/(1386*d**2*k3**5) - D1**2*Pk2*Pkd3*f*k1**2*k2**2*st**4*(168*C*D1**2*f*fd*r**2 + 336*C*D1**2*f*fd*r*s - 224*C*D1**2*f*fd*r + 168*C*D1**2*f*fd*s**2 - 224*C*D1**2*f*fd*s + 112*C*D1**2*f*fd - 84*C*D1**2*f*fdd*r**2 - 168*C*D1**2*f*fdd*r*s + 112*C*D1**2*f*fdd*r - 84*C*D1**2*f*fdd*s**2 + 112*C*D1**2*f*fdd*s - 56*C*D1**2*f*fdd - 168*C*D1**2*fd**2*r**2 - 336*C*D1**2*fd**2*r*s + 224*C*D1**2*fd**2*r - 168*C*D1**2*fd**2*s**2 + 224*C*D1**2*fd**2*s - 56*C*D1**2*fd**2 + 224*C*D1*Dd*f**2*r**2 + 448*C*D1*Dd*f**2*r*s - 336*C*D1*Dd*f**2*r + 224*C*D1*Dd*f**2*s**2 - 336*C*D1*Dd*f**2*s + 168*C*D1*Dd*f**2 - 672*C*D1*Dd*f*fd*r**2 - 1344*C*D1*Dd*f*fd*r*s + 952*C*D1*Dd*f*fd*r - 672*C*D1*Dd*f*fd*s**2 + 952*C*D1*Dd*f*fd*s - 336*C*D1*Dd*f*fd - 112*C*D1*Ddd*f**2*r**2 - 224*C*D1*Ddd*f**2*r*s + 168*C*D1*Ddd*f**2*r - 112*C*D1*Ddd*f**2*s**2 + 168*C*D1*Ddd*f**2*s - 84*C*D1*Ddd*f**2 - 336*C*Dd**2*f**2*r**2 - 672*C*Dd**2*f**2*r*s + 504*C*Dd**2*f**2*r - 336*C*Dd**2*f**2*s**2 + 504*C*Dd**2*f**2*s - 168*C*Dd**2*f**2 + 55*D1**2*K*bd1*f*r**2 + 154*D1**2*K*bd1*f*r*s - 110*D1**2*K*bd1*f*r + 99*D1**2*K*bd1*f*s**2 - 154*D1**2*K*bd1*f*s + 55*D1**2*K*bd1*f + 110*D1**2*b2*fd*r**2 + 220*D1**2*b2*fd*r*s - 110*D1**2*b2*fd*r + 110*D1**2*b2*fd*s**2 - 110*D1**2*b2*fd*s + 55*D1**2*b2*fd - 22*D1**2*bd1*f*r*s - 22*D1**2*bd1*f*s**2 + 22*D1**2*bd1*f*s + 55*D1**2*bd2*f*(r + s - 1)**2 - 96*D1**2*f*fd*r**2 - 192*D1**2*f*fd*r*s + 128*D1**2*f*fd*r - 96*D1**2*f*fd*s**2 + 128*D1**2*f*fd*s - 64*D1**2*f*fd + 48*D1**2*f*fdd*r**2 + 96*D1**2*f*fdd*r*s - 64*D1**2*f*fdd*r + 48*D1**2*f*fdd*s**2 - 64*D1**2*f*fdd*s + 32*D1**2*f*fdd - 110*D1**2*f*gd2*r**2 - 308*D1**2*f*gd2*r*s + 220*D1**2*f*gd2*r - 198*D1**2*f*gd2*s**2 + 308*D1**2*f*gd2*s - 110*D1**2*f*gd2 + 96*D1**2*fd**2*r**2 + 192*D1**2*fd**2*r*s - 128*D1**2*fd**2*r + 96*D1**2*fd**2*s**2 - 128*D1**2*fd**2*s + 32*D1**2*fd**2 - 220*D1**2*fd*g2*r**2 - 616*D1**2*fd*g2*r*s + 308*D1**2*fd*g2*r - 396*D1**2*fd*g2*s**2 + 396*D1**2*fd*g2*s - 198*D1**2*fd*g2 + 220*D1*Dd*b2*f*r**2 + 440*D1*Dd*b2*f*r*s - 330*D1*Dd*b2*f*r + 220*D1*Dd*b2*f*s**2 - 330*D1*Dd*b2*f*s + 165*D1*Dd*b2*f - 128*D1*Dd*f**2*r**2 - 256*D1*Dd*f**2*r*s + 192*D1*Dd*f**2*r - 128*D1*Dd*f**2*s**2 + 192*D1*Dd*f**2*s - 96*D1*Dd*f**2 + 384*D1*Dd*f*fd*r**2 + 768*D1*Dd*f*fd*r*s - 544*D1*Dd*f*fd*r + 384*D1*Dd*f*fd*s**2 - 544*D1*Dd*f*fd*s + 192*D1*Dd*f*fd - 440*D1*Dd*f*g2*r**2 - 1232*D1*Dd*f*g2*r*s + 748*D1*Dd*f*g2*r - 792*D1*Dd*f*g2*s**2 + 1012*D1*Dd*f*g2*s - 418*D1*Dd*f*g2 + 64*D1*Ddd*f**2*r**2 + 128*D1*Ddd*f**2*r*s - 96*D1*Ddd*f**2*r + 64*D1*Ddd*f**2*s**2 - 96*D1*Ddd*f**2*s + 48*D1*Ddd*f**2 + 11*D1*b1*(D1*fd*(K*(10*r**2 + 28*r*s - 14*r + 18*s**2 - 18*s + 9) - 4*r*s + 2*r - 4*s**2 + 4*s - 2) + Dd*f*(K*(20*r**2 + 56*r*s - 34*r + 36*s**2 - 46*s + 19) - 8*r*s + 2*r - 8*s**2 + 8*s - 2)) + 192*Dd**2*f**2*r**2 + 384*Dd**2*f**2*r*s - 288*Dd**2*f**2*r + 192*Dd**2*f**2*s**2 - 288*Dd**2*f**2*s + 96*Dd**2*f**2)/(77*d**2*k3**5) - 20*D1**2*Pk2*Pkd3*f*k1**2*st**6*(-D1*f*(4*r + 4*s - 3)*(-D1*bd1*(2*f*s - 6*fd*s + fd) + D1*bdd1*f*s + Dd*bd1*f*(8*s - 1)) + b1*(D1**2*(f*(2*fd - fdd)*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4) + fd**2*(r*(8 - 24*s) - 24*s**2 + 26*s - 5)) + D1*f*(Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(24*s - 7)*(4*r + 4*s - 3)) - 4*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 4*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**3) - 2*D1**2*Pk2*Pkd3*f*k1**2*st**4*(D1**2*(4*C*(f*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd**2*(r*(2 - 6*s) - 6*s**2 + 6*s - 1)) + f*(11*bd1*s*(r + s - 1) + fd*(6*r**2 - 4*r + s*(4 - 6*s)) + fdd*(-3*r**2 + 2*r + s*(3*s - 2))) + 2*fd**2*(-3*r**2 + 2*r + s*(3*s - 2))) + 11*D1*b1*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*f*(2*Dd*(f*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 - 4*r - 4*s**2 + 2*s + 1) - fd*(2*C*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + 12*r**2 - 10*r - 12*s**2 + 7*s + 1)) - Ddd*f*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + 4*r**2 - 4*r - 4*s**2 + 2*s + 1)) - 2*Dd**2*f**2*(C*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + 6*r**2 - 6*r - 6*s**2 + 3*s + 1))/(77*d**2*k3**3) - 3*D1**2*Pk2*Pkd3*k1**6*(-10*D1**2*bd1**2*f**2*(r + s - 1)**2 + 2*D1*b1*f*(-5*D1*bdd1*f*(r + s - 1) + 2*bd1*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + b1**2*(D1**2*(f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**7) + D1**2*Pk2*Pkd3*k1**4*k2**2*st**2*(102*C*D1**2*f**2*fd*r**2 + 204*C*D1**2*f**2*fd*r*s - 136*C*D1**2*f**2*fd*r + 102*C*D1**2*f**2*fd*s**2 - 136*C*D1**2*f**2*fd*s + 68*C*D1**2*f**2*fd - 150*C*D1**2*f**2*fdd*r**2 - 300*C*D1**2*f**2*fdd*r*s + 200*C*D1**2*f**2*fdd*r - 150*C*D1**2*f**2*fdd*s**2 + 200*C*D1**2*f**2*fdd*s - 100*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*r**2 - 600*C*D1**2*f*fd**2*r*s + 400*C*D1**2*f*fd**2*r - 300*C*D1**2*f*fd**2*s**2 + 400*C*D1**2*f*fd**2*s - 100*C*D1**2*f*fd**2 + 136*C*D1*Dd*f**3*r**2 + 272*C*D1*Dd*f**3*r*s - 204*C*D1*Dd*f**3*r + 136*C*D1*Dd*f**3*s**2 - 204*C*D1*Dd*f**3*s + 102*C*D1*Dd*f**3 - 1200*C*D1*Dd*f**2*fd*r**2 - 2400*C*D1*Dd*f**2*fd*r*s + 1700*C*D1*Dd*f**2*fd*r - 1200*C*D1*Dd*f**2*fd*s**2 + 1700*C*D1*Dd*f**2*fd*s - 600*C*D1*Dd*f**2*fd - 200*C*D1*Ddd*f**3*r**2 - 400*C*D1*Ddd*f**3*r*s + 300*C*D1*Ddd*f**3*r - 200*C*D1*Ddd*f**3*s**2 + 300*C*D1*Ddd*f**3*s - 150*C*D1*Ddd*f**3 - 600*C*Dd**2*f**3*r**2 - 1200*C*Dd**2*f**3*r*s + 900*C*Dd**2*f**3*r - 600*C*Dd**2*f**3*s**2 + 900*C*Dd**2*f**3*s - 300*C*Dd**2*f**3 - 33*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*K*bdd1*f**2*r*s + 66*D1**2*K*bdd1*f**2*r - 33*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s - 33*D1**2*K*bdd1*f**2 + 660*D1**2*bd1**2*f**2*(r + s - 1)**2 - 51*D1**2*f**2*fd*r**2 - 102*D1**2*f**2*fd*r*s + 68*D1**2*f**2*fd*r - 51*D1**2*f**2*fd*s**2 + 68*D1**2*f**2*fd*s - 34*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd - 66*D1**2*f**2*gd2*r**2 - 132*D1**2*f**2*gd2*r*s + 132*D1**2*f**2*gd2*r - 66*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s - 66*D1**2*f**2*gd2 + 66*D1**2*f**2*gdd2*r**2 + 132*D1**2*f**2*gdd2*r*s - 132*D1**2*f**2*gdd2*r + 66*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 66*D1**2*f**2*gdd2 + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 - 132*D1**2*f*fd*g2*r**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 132*D1**2*f*fd*g2*s**2 + 132*D1**2*f*fd*g2*s - 66*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 + 528*D1**2*f*fd*gd2*r*s - 396*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 396*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r**2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s - 68*D1*Dd*f**3*r**2 - 136*D1*Dd*f**3*r*s + 102*D1*Dd*f**3*r - 68*D1*Dd*f**3*s**2 + 102*D1*Dd*f**3*s - 51*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 850*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 850*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd - 264*D1*Dd*f**2*g2*r**2 - 528*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 264*D1*Dd*f**2*g2*s**2 + 396*D1*Dd*f**2*g2*s - 198*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 + 1056*D1*Dd*f**2*gd2*r*s - 924*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 924*D1*Dd*f**2*gd2*s + 396*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r**2 + 2112*D1*Dd*f*fd*g2*r*s - 1320*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1320*D1*Dd*f*fd*g2*s + 396*D1*Dd*f*fd*g2 + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r**2 + 528*D1*Ddd*f**2*g2*r*s - 396*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 396*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 - 33*D1*bd1*f*(D1*(-K*f*(r + s - 1) + 2*K*fd*(2*r + 2*s - 1) + 2*f**2*(r + s - 1)) + 2*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 + 792*Dd**2*f**2*g2*r**2 + 1584*Dd**2*f**2*g2*r*s - 1188*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 1188*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(f*(17*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 20*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(17*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 20*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-2*D1**2*K*f*fd*r**2 - 4*D1**2*K*f*fd*r*s + 2*D1**2*K*f*fd*r - 2*D1**2*K*f*fd*s**2 + 2*D1**2*K*f*fd*s - D1**2*K*f*fd + 2*D1**2*K*f*fdd*r**2 + 4*D1**2*K*f*fdd*r*s - 2*D1**2*K*f*fdd*r + 2*D1**2*K*f*fdd*s**2 - 2*D1**2*K*f*fdd*s + D1**2*K*f*fdd + 2*D1**2*K*fd**2*r**2 + 4*D1**2*K*fd**2*r*s - 2*D1**2*K*fd**2*r + 2*D1**2*K*fd**2*s**2 - 2*D1**2*K*fd**2*s - 20*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 4*D1*Dd*K*f**2*r**2 - 8*D1*Dd*K*f**2*r*s + 6*D1*Dd*K*f**2*r - 4*D1*Dd*K*f**2*s**2 + 6*D1*Dd*K*f**2*s - 3*D1*Dd*K*f**2 + 16*D1*Dd*K*f*fd*r**2 + 32*D1*Dd*K*f*fd*r*s - 20*D1*Dd*K*f*fd*r + 16*D1*Dd*K*f*fd*s**2 - 20*D1*Dd*K*f*fd*s + 6*D1*Dd*K*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 + 4*D1*Ddd*K*f**2*r**2 + 8*D1*Ddd*K*f**2*r*s - 6*D1*Ddd*K*f**2*r + 4*D1*Ddd*K*f**2*s**2 - 6*D1*Ddd*K*f**2*s + 3*D1*Ddd*K*f**2 + 2*D1*bd1*f*(r + s - 1)*(17*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) + 12*Dd**2*K*f**2*r**2 + 24*Dd**2*K*f**2*r*s - 18*Dd**2*K*f**2*r + 12*Dd**2*K*f**2*s**2 - 18*Dd**2*K*f**2*s + 6*Dd**2*K*f**2))/(154*d**2*k3**7) + 3*D1**2*Pk2*Pkd3*k1**4*k2**2*(-12*D1**2*K*bd1**2*f*(r + s - 1)**2 - D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 12*K*b1 - 5*f - 12*g2) + 2*D1*bd1*(D1*(f**2*(4*C + 6*b1 - 2)*(r + s - 1) - f*fd*(10*C - 5)*(2*r + 2*s - 1) - f*(r + s - 1)*(-5*K*b1 + 5*g2 - 12*gd2) + 12*fd*(r + s)*(-K*b1 + g2)) - Dd*f*(4*r + 4*s - 3)*(10*C*f + 12*K*b1 - 5*f - 12*g2))*(r + s - 1) + b1*(D1**2*(f*(fd*(8*C + 6*b1 - 4)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-10*gd2 + 12*gdd2)*(r + s - 1)**2) - (r + s)*(fd**2*(20*C - 10)*(r + s - 1) - 24*fd*gd2*(r + s - 1) + 5*fd*(r + s)*(-K*b1 + 2*g2) - 6*fdd*(r + s)*(-K*b1 + 2*g2))) + D1*(Dd*(f**2*(8*C + 6*b1 - 4)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(20*K*b1*r**2 + 40*K*b1*r*s - 30*K*b1*r + 20*K*b1*s**2 - 30*K*b1*s + 15*K*b1 - fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 10*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 96*gd2*r**2 + 192*gd2*r*s - 168*gd2*r + 96*gd2*s**2 - 168*gd2*s + 72*gd2) + 12*fd*(-K*b1 + 2*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(10*C*f + 6*K*b1 - 5*f - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(10*C*f + 6*K*b1 - 5*f - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**7) + D1**2*Pk2*Pkd3*k1**4*st**2*(-510*C*D1**2*f**2*fd*r**2 - 1428*C*D1**2*f**2*fd*r*s + 816*C*D1**2*f**2*fd*r - 918*C*D1**2*f**2*fd*s**2 + 1088*C*D1**2*f**2*fd*s - 476*C*D1**2*f**2*fd + 750*C*D1**2*f**2*fdd*r**2 + 2100*C*D1**2*f**2*fdd*r*s - 1200*C*D1**2*f**2*fdd*r + 1350*C*D1**2*f**2*fdd*s**2 - 1600*C*D1**2*f**2*fdd*s + 700*C*D1**2*f**2*fdd + 1500*C*D1**2*f*fd**2*r**2 + 4200*C*D1**2*f*fd**2*r*s - 2400*C*D1**2*f*fd**2*r + 2700*C*D1**2*f*fd**2*s**2 - 3200*C*D1**2*f*fd**2*s + 700*C*D1**2*f*fd**2 - 680*C*D1*Dd*f**3*r**2 - 1904*C*D1*Dd*f**3*r*s + 1156*C*D1*Dd*f**3*r - 1224*C*D1*Dd*f**3*s**2 + 1564*C*D1*Dd*f**3*s - 646*C*D1*Dd*f**3 + 6000*C*D1*Dd*f**2*fd*r**2 + 16800*C*D1*Dd*f**2*fd*r*s - 9900*C*D1*Dd*f**2*fd*r + 10800*C*D1*Dd*f**2*fd*s**2 - 13300*C*D1*Dd*f**2*fd*s + 4000*C*D1*Dd*f**2*fd + 1000*C*D1*Ddd*f**3*r**2 + 2800*C*D1*Ddd*f**3*r*s - 1700*C*D1*Ddd*f**3*r + 1800*C*D1*Ddd*f**3*s**2 - 2300*C*D1*Ddd*f**3*s + 950*C*D1*Ddd*f**3 + 3000*C*Dd**2*f**3*r**2 + 8400*C*Dd**2*f**3*r*s - 5100*C*Dd**2*f**3*r + 5400*C*Dd**2*f**3*s**2 - 6900*C*Dd**2*f**3*s + 1900*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r**2 + 462*D1**2*K*bdd1*f**2*r*s - 330*D1**2*K*bdd1*f**2*r + 297*D1**2*K*bdd1*f**2*s**2 - 462*D1**2*K*bdd1*f**2*s + 165*D1**2*K*bdd1*f**2 - 330*D1**2*b2*f*fd*r**2 - 660*D1**2*b2*f*fd*r*s + 330*D1**2*b2*f*fd*r - 330*D1**2*b2*f*fd*s**2 + 330*D1**2*b2*f*fd*s - 165*D1**2*b2*f*fd + 330*D1**2*b2*f*fdd*r**2 + 660*D1**2*b2*f*fdd*r*s - 330*D1**2*b2*f*fdd*r + 330*D1**2*b2*f*fdd*s**2 - 330*D1**2*b2*f*fdd*s + 165*D1**2*b2*f*fdd + 330*D1**2*b2*fd**2*r**2 + 660*D1**2*b2*fd**2*r*s - 330*D1**2*b2*fd**2*r + 330*D1**2*b2*fd**2*s**2 - 330*D1**2*b2*fd**2*s - 660*D1**2*bd1**2*f**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) - 165*D1**2*bd2*f**2*r**2 - 330*D1**2*bd2*f**2*r*s + 330*D1**2*bd2*f**2*r - 165*D1**2*bd2*f**2*s**2 + 330*D1**2*bd2*f**2*s - 165*D1**2*bd2*f**2 + 660*D1**2*bd2*f*fd*r**2 + 1320*D1**2*bd2*f*fd*r*s - 990*D1**2*bd2*f*fd*r + 660*D1**2*bd2*f*fd*s**2 - 990*D1**2*bd2*f*fd*s + 330*D1**2*bd2*f*fd + 924*D1**2*bdd1*f**3*r**2 + 1254*D1**2*bdd1*f**3*r*s - 1716*D1**2*bdd1*f**3*r + 330*D1**2*bdd1*f**3*s**2 - 1122*D1**2*bdd1*f**3*s + 792*D1**2*bdd1*f**3 - 66*D1**2*bdd1*f**2*r*s - 66*D1**2*bdd1*f**2*s**2 + 66*D1**2*bdd1*f**2*s + 165*D1**2*bdd2*f**2*r**2 + 330*D1**2*bdd2*f**2*r*s - 330*D1**2*bdd2*f**2*r + 165*D1**2*bdd2*f**2*s**2 - 330*D1**2*bdd2*f**2*s + 165*D1**2*bdd2*f**2 + 255*D1**2*f**2*fd*r**2 + 816*D1**2*f**2*fd*r*s - 442*D1**2*f**2*fd*r + 561*D1**2*f**2*fd*s**2 - 646*D1**2*f**2*fd*s + 272*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r**2 - 1200*D1**2*f**2*fdd*r*s + 650*D1**2*f**2*fdd*r - 825*D1**2*f**2*fdd*s**2 + 950*D1**2*f**2*fdd*s - 400*D1**2*f**2*fdd + 330*D1**2*f**2*gd2*r**2 + 924*D1**2*f**2*gd2*r*s - 660*D1**2*f**2*gd2*r + 594*D1**2*f**2*gd2*s**2 - 924*D1**2*f**2*gd2*s + 330*D1**2*f**2*gd2 - 330*D1**2*f**2*gdd2*r**2 - 924*D1**2*f**2*gdd2*r*s + 660*D1**2*f**2*gdd2*r - 594*D1**2*f**2*gdd2*s**2 + 924*D1**2*f**2*gdd2*s - 330*D1**2*f**2*gdd2 - 750*D1**2*f*fd**2*r**2 - 2400*D1**2*f*fd**2*r*s + 1300*D1**2*f*fd**2*r - 1650*D1**2*f*fd**2*s**2 + 1900*D1**2*f*fd**2*s - 400*D1**2*f*fd**2 + 660*D1**2*f*fd*g2*r**2 + 1848*D1**2*f*fd*g2*r*s - 924*D1**2*f*fd*g2*r + 1188*D1**2*f*fd*g2*s**2 - 1188*D1**2*f*fd*g2*s + 594*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r**2 - 3696*D1**2*f*fd*gd2*r*s + 2244*D1**2*f*fd*gd2*r - 2376*D1**2*f*fd*gd2*s**2 + 3036*D1**2*f*fd*gd2*s - 924*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r**2 - 1848*D1**2*f*fdd*g2*r*s + 924*D1**2*f*fdd*g2*r - 1188*D1**2*f*fdd*g2*s**2 + 1188*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r**2 - 1848*D1**2*fd**2*g2*r*s + 924*D1**2*fd**2*g2*r - 1188*D1**2*fd**2*g2*s**2 + 1188*D1**2*fd**2*g2*s - 660*D1*Dd*b2*f**2*r**2 - 1320*D1*Dd*b2*f**2*r*s + 990*D1*Dd*b2*f**2*r - 660*D1*Dd*b2*f**2*s**2 + 990*D1*Dd*b2*f**2*s - 495*D1*Dd*b2*f**2 + 2640*D1*Dd*b2*f*fd*r**2 + 5280*D1*Dd*b2*f*fd*r*s - 3300*D1*Dd*b2*f*fd*r + 2640*D1*Dd*b2*f*fd*s**2 - 3300*D1*Dd*b2*f*fd*s + 990*D1*Dd*b2*f*fd + 1320*D1*Dd*bd2*f**2*r**2 + 2640*D1*Dd*bd2*f**2*r*s - 2310*D1*Dd*bd2*f**2*r + 1320*D1*Dd*bd2*f**2*s**2 - 2310*D1*Dd*bd2*f**2*s + 990*D1*Dd*bd2*f**2 + 340*D1*Dd*f**3*r**2 + 1088*D1*Dd*f**3*r*s - 612*D1*Dd*f**3*r + 748*D1*Dd*f**3*s**2 - 918*D1*Dd*f**3*s + 357*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r**2 - 9600*D1*Dd*f**2*fd*r*s + 5300*D1*Dd*f**2*fd*r - 6600*D1*Dd*f**2*fd*s**2 + 7850*D1*Dd*f**2*fd*s - 2250*D1*Dd*f**2*fd + 1320*D1*Dd*f**2*g2*r**2 + 3696*D1*Dd*f**2*g2*r*s - 2244*D1*Dd*f**2*g2*r + 2376*D1*Dd*f**2*g2*s**2 - 3036*D1*Dd*f**2*g2*s + 1254*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r**2 - 7392*D1*Dd*f**2*gd2*r*s + 4884*D1*Dd*f**2*gd2*r - 4752*D1*Dd*f**2*gd2*s**2 + 6732*D1*Dd*f**2*gd2*s - 2244*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r**2 - 14784*D1*Dd*f*fd*g2*r*s + 8184*D1*Dd*f*fd*g2*r - 9504*D1*Dd*f*fd*g2*s**2 + 10824*D1*Dd*f*fd*g2*s - 3036*D1*Dd*f*fd*g2 + 660*D1*Ddd*b2*f**2*r**2 + 1320*D1*Ddd*b2*f**2*r*s - 990*D1*Ddd*b2*f**2*r + 660*D1*Ddd*b2*f**2*s**2 - 990*D1*Ddd*b2*f**2*s + 495*D1*Ddd*b2*f**2 - 500*D1*Ddd*f**3*r**2 - 1600*D1*Ddd*f**3*r*s + 900*D1*Ddd*f**3*r - 1100*D1*Ddd*f**3*s**2 + 1350*D1*Ddd*f**3*s - 525*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r**2 - 3696*D1*Ddd*f**2*g2*r*s + 2244*D1*Ddd*f**2*g2*r - 2376*D1*Ddd*f**2*g2*s**2 + 3036*D1*Ddd*f**2*g2*s - 1254*D1*Ddd*f**2*g2 - 33*D1*bd1*f*(D1*(2*f**2*(12*r**2 + r*(19*s - 28) + 7*s**2 - 23*s + 16) + f*(-2*fd*(84*r**2 + r*(114*s - 127) + 30*s**2 - 82*s + 45) + (K*(5*r + 9*s - 5) - 2*s)*(r + s - 1)) - 2*fd*(K*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 23*s + 7) - 4*r*s + r - 4*s**2 + 4*s - 1)) - 2*Dd*f*(K*(20*r**2 + 56*r*s - 37*r + 36*s**2 - 51*s + 17) + f*(112*r**2 + r*(152*s - 179) + 40*s**2 - 116*s + 69) - 8*r*s + r - 8*s**2 + 8*s - 1)) + 1980*Dd**2*b2*f**2*r**2 + 3960*Dd**2*b2*f**2*r*s - 2970*Dd**2*b2*f**2*r + 1980*Dd**2*b2*f**2*s**2 - 2970*Dd**2*b2*f**2*s + 990*Dd**2*b2*f**2 - 1500*Dd**2*f**3*r**2 - 4800*Dd**2*f**3*r*s + 2700*Dd**2*f**3*r - 3300*Dd**2*f**3*s**2 + 4050*Dd**2*f**3*s - 1050*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r**2 - 11088*Dd**2*f**2*g2*r*s + 6732*Dd**2*f**2*g2*r - 7128*Dd**2*f**2*g2*s**2 + 9108*Dd**2*f**2*g2*s - 2508*Dd**2*f**2*g2 + 330*b1**2*(D1**2*(f*(fd*(10*r**2 + 20*r*s - 14*r + 10*s**2 - 14*s + 7) - 2*fdd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 4*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-10*D1**2*K*f*fd*r**2 - 28*D1**2*K*f*fd*r*s + 14*D1**2*K*f*fd*r - 18*D1**2*K*f*fd*s**2 + 18*D1**2*K*f*fd*s - 9*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r**2 + 28*D1**2*K*f*fdd*r*s - 14*D1**2*K*f*fdd*r + 18*D1**2*K*f*fdd*s**2 - 18*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r**2 + 28*D1**2*K*fd**2*r*s - 14*D1**2*K*fd**2*r + 18*D1**2*K*fd**2*s**2 - 18*D1**2*K*fd**2*s - 10*D1**2*bdd1*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) - 72*D1**2*f**2*fd*r**2 - 114*D1**2*f**2*fd*r*s + 78*D1**2*f**2*fd*r - 42*D1**2*f**2*fd*s**2 + 58*D1**2*f**2*fd*s - 30*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r**2 + 114*D1**2*f**2*fdd*r*s - 98*D1**2*f**2*fdd*r + 30*D1**2*f**2*fdd*s**2 - 62*D1**2*f**2*fdd*s + 42*D1**2*f**2*fdd + 168*D1**2*f*fd**2*r**2 + 228*D1**2*f*fd**2*r*s - 196*D1**2*f*fd**2*r + 60*D1**2*f*fd**2*s**2 - 124*D1**2*f*fd**2*s + 42*D1**2*f*fd**2 + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 4*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r - 4*D1**2*f*fdd*s**2 + 4*D1**2*f*fdd*s - 2*D1**2*f*fdd - 4*D1**2*fd**2*r*s + 2*D1**2*fd**2*r - 4*D1**2*fd**2*s**2 + 4*D1**2*fd**2*s - 20*D1*Dd*K*f**2*r**2 - 56*D1*Dd*K*f**2*r*s + 34*D1*Dd*K*f**2*r - 36*D1*Dd*K*f**2*s**2 + 46*D1*Dd*K*f**2*s - 19*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r**2 + 224*D1*Dd*K*f*fd*r*s - 124*D1*Dd*K*f*fd*r + 144*D1*Dd*K*f*fd*s**2 - 164*D1*Dd*K*f*fd*s + 46*D1*Dd*K*f*fd - 96*D1*Dd*f**3*r**2 - 152*D1*Dd*f**3*r*s + 134*D1*Dd*f**3*r - 56*D1*Dd*f**3*s**2 + 104*D1*Dd*f**3*s - 62*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r**2 + 912*D1*Dd*f**2*fd*r*s - 842*D1*Dd*f**2*fd*r + 240*D1*Dd*f**2*fd*s**2 - 536*D1*Dd*f**2*fd*s + 258*D1*Dd*f**2*fd + 8*D1*Dd*f**2*r*s - 2*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 32*D1*Dd*f*fd*r*s + 12*D1*Dd*f*fd*r - 32*D1*Dd*f*fd*s**2 + 32*D1*Dd*f*fd*s - 8*D1*Dd*f*fd + 20*D1*Ddd*K*f**2*r**2 + 56*D1*Ddd*K*f**2*r*s - 34*D1*Ddd*K*f**2*r + 36*D1*Ddd*K*f**2*s**2 - 46*D1*Ddd*K*f**2*s + 19*D1*Ddd*K*f**2 + 112*D1*Ddd*f**3*r**2 + 152*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 40*D1*Ddd*f**3*s**2 - 96*D1*Ddd*f**3*s + 66*D1*Ddd*f**3 - 8*D1*Ddd*f**2*r*s + 2*D1*Ddd*f**2*r - 8*D1*Ddd*f**2*s**2 + 8*D1*Ddd*f**2*s - 2*D1*Ddd*f**2 + 20*D1*bd1*f*(D1*(f*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 4) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(24*r**2 + r*(48*s - 38) + 24*s**2 - 38*s + 15)) + 60*Dd**2*K*f**2*r**2 + 168*Dd**2*K*f**2*r*s - 102*Dd**2*K*f**2*r + 108*Dd**2*K*f**2*s**2 - 138*Dd**2*K*f**2*s + 38*Dd**2*K*f**2 + 336*Dd**2*f**3*r**2 + 456*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 120*Dd**2*f**3*s**2 - 288*Dd**2*f**3*s + 132*Dd**2*f**3 - 24*Dd**2*f**2*r*s + 6*Dd**2*f**2*r - 24*Dd**2*f**2*s**2 + 24*Dd**2*f**2*s - 4*Dd**2*f**2))/(1386*d**2*k3**5) - D1**2*Pk2*Pkd3*k1**4*(D1*(12*D1*bd1**2*f*(r + s - 1)*(K*(-5*r - 9*s + 7) + f*(9*r + 7*s - 8) + 2*s - 1) - D1*bdd1*f*(5*f*(2*C*(5*r + 9*s - 9) - 5*r - 11*s + 11) - 12*g2*(5*r + 9*s - 9))*(r + s - 1) + 5*b2*(-6*D1*bdd1*f*(r + s - 1) + bd1*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) - 2*bd1*(30*D1*bd2*f*(r + s - 1)**2 + D1*(-2*f**2*(r + s - 1)*(2*C*(5*r + 9*s - 9) - 5*r - 11*s + 11) + f*(5*fd*(2*C*(10*r**2 + 28*r*s - 19*r + 18*s**2 - 25*s + 7) - 10*r**2 - 32*r*s + 21*r - 22*s**2 + 30*s - 8) + (5*g2*(5*r + 9*s - 9) - 12*gd2*(5*r + 9*s - 7))*(r + s - 1)) - 12*fd*g2*(5*r**2 + 7*r*(2*s - 1) + s*(9*s - 9))) + Dd*f*(5*f*(2*C*(20*r**2 + 56*r*s - 45*r + 36*s**2 - 59*s + 23) - 20*r**2 - 64*r*s + 50*r - 44*s**2 + 71*s - 27) - 12*g2*(20*r**2 + r*(56*s - 45) + 36*s**2 - 59*s + 23)))) + 5*b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(25*D1**2*K*fd*r**2 + 70*D1**2*K*fd*r*s + 45*D1**2*K*fd*s**2 - 30*D1**2*K*fdd*r**2 - 84*D1**2*K*fdd*r*s - 54*D1**2*K*fdd*s**2 - 30*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 84*D1**2*f*fd*r**2 - 144*D1**2*f*fd*r*s + 84*D1**2*f*fd*r - 60*D1**2*f*fd*s**2 + 72*D1**2*f*fd*s - 42*D1**2*f*fd + 108*D1**2*f*fdd*r**2 + 192*D1**2*f*fdd*r*s - 108*D1**2*f*fdd*r + 84*D1**2*f*fdd*s**2 - 96*D1**2*f*fdd*s + 54*D1**2*f*fdd + 108*D1**2*fd**2*r**2 + 192*D1**2*fd**2*r*s - 108*D1**2*fd**2*r + 84*D1**2*fd**2*s**2 - 96*D1**2*fd**2*s - 10*D1**2*fd*r*s - 10*D1**2*fd*s**2 + 12*D1**2*fdd*r*s + 12*D1**2*fdd*s**2 + 100*D1*Dd*K*f*r**2 + 280*D1*Dd*K*f*r*s - 170*D1*Dd*K*f*r + 180*D1*Dd*K*f*s**2 - 230*D1*Dd*K*f*s + 95*D1*Dd*K*f - 240*D1*Dd*K*fd*r**2 - 672*D1*Dd*K*fd*r*s + 204*D1*Dd*K*fd*r - 432*D1*Dd*K*fd*s**2 + 276*D1*Dd*K*fd*s - 168*D1*Dd*f**2*r**2 - 288*D1*Dd*f**2*r*s + 240*D1*Dd*f**2*r - 120*D1*Dd*f**2*s**2 + 204*D1*Dd*f**2*s - 114*D1*Dd*f**2 + 864*D1*Dd*f*fd*r**2 + 1536*D1*Dd*f*fd*r*s - 1056*D1*Dd*f*fd*r + 672*D1*Dd*f*fd*s**2 - 936*D1*Dd*f*fd*s + 312*D1*Dd*f*fd - 40*D1*Dd*f*r*s + 10*D1*Dd*f*r - 40*D1*Dd*f*s**2 + 40*D1*Dd*f*s - 10*D1*Dd*f + 96*D1*Dd*fd*r*s - 12*D1*Dd*fd*r + 96*D1*Dd*fd*s**2 - 48*D1*Dd*fd*s - 120*D1*Ddd*K*f*r**2 - 336*D1*Ddd*K*f*r*s + 204*D1*Ddd*K*f*r - 216*D1*Ddd*K*f*s**2 + 276*D1*Ddd*K*f*s - 114*D1*Ddd*K*f + 216*D1*Ddd*f**2*r**2 + 384*D1*Ddd*f**2*r*s - 312*D1*Ddd*f**2*r + 168*D1*Ddd*f**2*s**2 - 276*D1*Ddd*f**2*s + 150*D1*Ddd*f**2 + 48*D1*Ddd*f*r*s - 12*D1*Ddd*f*r + 48*D1*Ddd*f*s**2 - 48*D1*Ddd*f*s + 12*D1*Ddd*f + 5*D1*bd1*(D1*(5*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - 12*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 360*Dd**2*K*f*r**2 - 1008*Dd**2*K*f*r*s + 612*Dd**2*K*f*r - 648*Dd**2*K*f*s**2 + 828*Dd**2*K*f*s - 228*Dd**2*K*f + 648*Dd**2*f**2*r**2 + 1152*Dd**2*f**2*r*s - 936*Dd**2*f**2*r + 504*Dd**2*f**2*s**2 - 828*Dd**2*f**2*s + 300*Dd**2*f**2 + 144*Dd**2*f*r*s - 36*Dd**2*f*r + 144*Dd**2*f*s**2 - 144*Dd**2*f*s + 24*Dd**2*f) + b1*(80*C*D1**2*f*fd*r**2 + 224*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*r + 144*C*D1**2*f*fd*s**2 - 112*C*D1**2*f*fd*s + 40*C*D1**2*f*fd - 100*C*D1**2*f*fdd*r**2 - 280*C*D1**2*f*fdd*r*s + 100*C*D1**2*f*fdd*r - 180*C*D1**2*f*fdd*s**2 + 140*C*D1**2*f*fdd*s - 50*C*D1**2*f*fdd - 100*C*D1**2*fd**2*r**2 - 280*C*D1**2*fd**2*r*s + 100*C*D1**2*fd**2*r - 180*C*D1**2*fd**2*s**2 + 140*C*D1**2*fd**2*s + 160*C*D1*Dd*f**2*r**2 + 448*C*D1*Dd*f**2*r*s - 272*C*D1*Dd*f**2*r + 288*C*D1*Dd*f**2*s**2 - 368*C*D1*Dd*f**2*s + 152*C*D1*Dd*f**2 - 800*C*D1*Dd*f*fd*r**2 - 2240*C*D1*Dd*f*fd*r*s + 1080*C*D1*Dd*f*fd*r - 1440*C*D1*Dd*f*fd*s**2 + 1480*C*D1*Dd*f*fd*s - 340*C*D1*Dd*f*fd - 200*C*D1*Ddd*f**2*r**2 - 560*C*D1*Ddd*f**2*r*s + 340*C*D1*Ddd*f**2*r - 360*C*D1*Ddd*f**2*s**2 + 460*C*D1*Ddd*f**2*s - 190*C*D1*Ddd*f**2 - 600*C*Dd**2*f**2*r**2 - 1680*C*Dd**2*f**2*r*s + 1020*C*Dd**2*f**2*r - 1080*C*Dd**2*f**2*s**2 + 1380*C*Dd**2*f**2*s - 380*C*Dd**2*f**2 - 60*D1**2*K*bdd1*f*r**2 - 168*D1**2*K*bdd1*f*r*s + 144*D1**2*K*bdd1*f*r - 108*D1**2*K*bdd1*f*s**2 + 192*D1**2*K*bdd1*f*s - 84*D1**2*K*bdd1*f + 25*D1**2*b2*fd*r**2 + 50*D1**2*b2*fd*r*s + 25*D1**2*b2*fd*s**2 - 30*D1**2*b2*fdd*r**2 - 60*D1**2*b2*fdd*r*s - 30*D1**2*b2*fdd*s**2 - 60*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 108*D1**2*bdd1*f**2*r**2 + 192*D1**2*bdd1*f**2*r*s - 204*D1**2*bdd1*f**2*r + 84*D1**2*bdd1*f**2*s**2 - 180*D1**2*bdd1*f**2*s + 96*D1**2*bdd1*f**2 + 24*D1**2*bdd1*f*r*s - 12*D1**2*bdd1*f*r + 24*D1**2*bdd1*f*s**2 - 36*D1**2*bdd1*f*s + 12*D1**2*bdd1*f - 30*D1**2*bdd2*f*r**2 - 60*D1**2*bdd2*f*r*s + 60*D1**2*bdd2*f*r - 30*D1**2*bdd2*f*s**2 + 60*D1**2*bdd2*f*s - 30*D1**2*bdd2*f - 40*D1**2*f*fd*r**2 - 128*D1**2*f*fd*r*s + 40*D1**2*f*fd*r - 88*D1**2*f*fd*s**2 + 64*D1**2*f*fd*s - 20*D1**2*f*fd + 50*D1**2*f*fdd*r**2 + 160*D1**2*f*fdd*r*s - 50*D1**2*f*fdd*r + 110*D1**2*f*fdd*s**2 - 80*D1**2*f*fdd*s + 25*D1**2*f*fdd - 50*D1**2*f*gd2*r**2 - 140*D1**2*f*gd2*r*s + 100*D1**2*f*gd2*r - 90*D1**2*f*gd2*s**2 + 140*D1**2*f*gd2*s - 50*D1**2*f*gd2 + 60*D1**2*f*gdd2*r**2 + 168*D1**2*f*gdd2*r*s - 120*D1**2*f*gdd2*r + 108*D1**2*f*gdd2*s**2 - 168*D1**2*f*gdd2*s + 60*D1**2*f*gdd2 + 50*D1**2*fd**2*r**2 + 160*D1**2*fd**2*r*s - 50*D1**2*fd**2*r + 110*D1**2*fd**2*s**2 - 80*D1**2*fd**2*s - 50*D1**2*fd*g2*r**2 - 140*D1**2*fd*g2*r*s - 90*D1**2*fd*g2*s**2 + 120*D1**2*fd*gd2*r**2 + 336*D1**2*fd*gd2*r*s - 120*D1**2*fd*gd2*r + 216*D1**2*fd*gd2*s**2 - 168*D1**2*fd*gd2*s + 60*D1**2*fdd*g2*r**2 + 168*D1**2*fdd*g2*r*s + 108*D1**2*fdd*g2*s**2 + 100*D1*Dd*b2*f*r**2 + 200*D1*Dd*b2*f*r*s - 150*D1*Dd*b2*f*r + 100*D1*Dd*b2*f*s**2 - 150*D1*Dd*b2*f*s + 75*D1*Dd*b2*f - 240*D1*Dd*b2*fd*r**2 - 480*D1*Dd*b2*fd*r*s + 180*D1*Dd*b2*fd*r - 240*D1*Dd*b2*fd*s**2 + 180*D1*Dd*b2*fd*s - 80*D1*Dd*f**2*r**2 - 256*D1*Dd*f**2*r*s + 144*D1*Dd*f**2*r - 176*D1*Dd*f**2*s**2 + 216*D1*Dd*f**2*s - 84*D1*Dd*f**2 + 400*D1*Dd*f*fd*r**2 + 1280*D1*Dd*f*fd*r*s - 560*D1*Dd*f*fd*r + 880*D1*Dd*f*fd*s**2 - 860*D1*Dd*f*fd*s + 180*D1*Dd*f*fd - 200*D1*Dd*f*g2*r**2 - 560*D1*Dd*f*g2*r*s + 340*D1*Dd*f*g2*r - 360*D1*Dd*f*g2*s**2 + 460*D1*Dd*f*g2*s - 190*D1*Dd*f*g2 + 480*D1*Dd*f*gd2*r**2 + 1344*D1*Dd*f*gd2*r*s - 888*D1*Dd*f*gd2*r + 864*D1*Dd*f*gd2*s**2 - 1224*D1*Dd*f*gd2*s + 408*D1*Dd*f*gd2 + 480*D1*Dd*fd*g2*r**2 + 1344*D1*Dd*fd*g2*r*s - 408*D1*Dd*fd*g2*r + 864*D1*Dd*fd*g2*s**2 - 552*D1*Dd*fd*g2*s - 120*D1*Ddd*b2*f*r**2 - 240*D1*Ddd*b2*f*r*s + 180*D1*Ddd*b2*f*r - 120*D1*Ddd*b2*f*s**2 + 180*D1*Ddd*b2*f*s - 90*D1*Ddd*b2*f + 100*D1*Ddd*f**2*r**2 + 320*D1*Ddd*f**2*r*s - 180*D1*Ddd*f**2*r + 220*D1*Ddd*f**2*s**2 - 270*D1*Ddd*f**2*s + 105*D1*Ddd*f**2 + 240*D1*Ddd*f*g2*r**2 + 672*D1*Ddd*f*g2*r*s - 408*D1*Ddd*f*g2*r + 432*D1*Ddd*f*g2*s**2 - 552*D1*Ddd*f*g2*s + 228*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(6*f**2*(7*r**2 + r*(12*s - 13) + 5*s**2 - 11*s + 6) - f*(6*fd*(36*r**2 + r*(64*s - 52) + 28*s**2 - 46*s + 17) + (5*r + 5*s - 5)*(K*(5*r + 9*s - 7) - 2*s + 1)) + 6*fd*(10*K*r**2 + r*(4*K*(7*s - 3) - 4*s + 1) + s*(2*K*(9*s - 8) - 4*s + 3))) - 6*Dd*f*(-2*K*(20*r**2 + 56*r*s - 41*r + 36*s**2 - 55*s + 20) + f*(72*r**2 + 8*r*(16*s - 15) + 56*s**2 - 106*s + 49) + 16*r*s - 6*r + 16*s**2 - 20*s + 5)) + 5*D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 360*Dd**2*b2*f*r**2 - 720*Dd**2*b2*f*r*s + 540*Dd**2*b2*f*r - 360*Dd**2*b2*f*s**2 + 540*Dd**2*b2*f*s - 180*Dd**2*b2*f + 300*Dd**2*f**2*r**2 + 960*Dd**2*f**2*r*s - 540*Dd**2*f**2*r + 660*Dd**2*f**2*s**2 - 810*Dd**2*f**2*s + 210*Dd**2*f**2 + 720*Dd**2*f*g2*r**2 + 2016*Dd**2*f*g2*r*s - 1224*Dd**2*f*g2*r + 1296*Dd**2*f*g2*s**2 - 1656*Dd**2*f*g2*s + 456*Dd**2*f*g2))/(21*d**2*k3**5) + D1**2*Pk2*Pkd3*k1**4*st**2*(66*b1**2*(D1**2*s*(4*r + 4*s - 3)*(2*f*fd - f*fdd - fd**2) + D1*f*(4*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - Dd*fd*(8*s - 1)*(4*r + 4*s - 3) + 2*Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 33*b1*(-2*D1**2*bdd1*f**2*(4*r*s - 2*r + 4*s**2 - 5*s + 2) - 18*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 21*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 18*D1**2*f**2*fdd*r*s - 6*D1**2*f**2*fdd*r + 18*D1**2*f**2*fdd*s**2 - 21*D1**2*f**2*fdd*s + 6*D1**2*f**2*fdd + 36*D1**2*f*fd**2*r*s - 12*D1**2*f*fd**2*r + 36*D1**2*f*fd**2*s**2 - 42*D1**2*f*fd**2*s + 9*D1**2*f*fd**2 - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 2*D1**2*f*fdd*r*s - D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 2*D1**2*f*fdd*s + D1**2*f*fdd + 2*D1**2*fd**2*r*s - D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 2*D1**2*fd**2*s - 24*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 24*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 144*D1*Dd*f**2*fd*r*s - 42*D1*Dd*f**2*fd*r + 144*D1*Dd*f**2*fd*s**2 - 156*D1*Dd*f**2*fd*s + 33*D1*Dd*f**2*fd - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 + 16*D1*Dd*f*fd*r*s - 6*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 16*D1*Dd*f*fd*s + 4*D1*Dd*f*fd + 24*D1*Ddd*f**3*r*s - 6*D1*Ddd*f**3*r + 24*D1*Ddd*f**3*s**2 - 24*D1*Ddd*f**3*s + 6*D1*Ddd*f**3 + 4*D1*Ddd*f**2*r*s - D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 4*D1*Ddd*f**2*s + D1*Ddd*f**2 + 2*D1*bd1*f*(2*D1*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - D1*fd*(4*s - 1)*(4*r + 4*s - 3) - Dd*f*(8*s - 3)*(4*r + 4*s - 3)) + 72*Dd**2*f**3*r*s - 18*Dd**2*f**3*r + 72*Dd**2*f**3*s**2 - 72*Dd**2*f**3*s + 12*Dd**2*f**3 + 12*Dd**2*f**2*r*s - 3*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 12*Dd**2*f**2*s + 2*Dd**2*f**2) + f*(-66*D1**2*bd1**2*f*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1**2*(99*bdd1*f**2*s*(2*r + 2*s - 1) + f*(33*bdd1*s*(r + s - 1) - 17*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 33*D1*bd1*(D1*(f*s*(f*(6*r + 6*s - 3) + r + s - 1) + fd*(f*(-36*r*s + 6*r - 36*s**2 + 30*s - 3) - 4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(f*(48*r*s - 6*r + 48*s**2 - 36*s + 3) + 8*r*s - r + 8*s**2 - 8*s + 1)) + D1*f*(Dd*(-17*f*(r*(4*s - 1) + (1 - 2*s)**2) + 25*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 25*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 25*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k2**2*k3**3) - 2*D1**2*Pk2*Pkd3*k1**4*(-D1*f*(6*D1*bd1**2*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + (2*s - 1)*(r + s - 1)) + 5*D1*bdd1*f*(s - 1)*(r + s - 1) + bd1*(D1*(-4*f*(s - 1)*(r + s - 1) + 5*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + b1**2*(D1**2*s*(6*f*(fd - fdd)*(4*r + 4*s - 3) - 6*fd**2*(4*r + 4*s - 3) + 5*fd*(r + s) - 6*fdd*(r + s)) + D1*(Dd*(12*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-6*fd*(8*s - 1)*(4*r + 4*s - 3) + 5*r*(4*s - 1) + 5*(1 - 2*s)**2) + 6*fd*(-8*r*s + r + s*(4 - 8*s))) - 6*Ddd*f*(2*f + 1)*(r*(4*s - 1) + (1 - 2*s)**2)) - 6*Dd**2*f*(2*f + 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-6*D1**2*bdd1*f*(f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + (2*s - 1)*(r + s - 1)) + 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s - 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*s**2 + 5*D1**2*f*fdd*s - 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*s**2 + 5*D1**2*fd**2*s + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r*s + 10*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 20*D1*Ddd*f**2*r*s + 5*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 20*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(6*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(-6*fd*(4*s - 1)*(4*r + 4*s - 3) + (2*s - 1)*(5*r + 5*s - 5)) + 6*fd*(-4*r*s + r + s*(3 - 4*s))) - 6*Dd*f*(f*(8*s - 3)*(4*r + 4*s - 3) + 16*r*s - 6*r + 16*s**2 - 20*s + 5)) - 60*Dd**2*f**2*r*s + 15*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 60*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k2**2*k3**3) + 3*D1**2*Pk2*Pkd3*k1**2*k2**4*st**2*(44*C*D1**2*b1*f*fd*r**2 + 88*C*D1**2*b1*f*fd*r*s - 44*C*D1**2*b1*f*fd*r + 44*C*D1**2*b1*f*fd*s**2 - 44*C*D1**2*b1*f*fd*s + 22*C*D1**2*b1*f*fd - 24*C*D1**2*b1*f*fdd*r**2 - 48*C*D1**2*b1*f*fdd*r*s + 24*C*D1**2*b1*f*fdd*r - 24*C*D1**2*b1*f*fdd*s**2 + 24*C*D1**2*b1*f*fdd*s - 12*C*D1**2*b1*f*fdd - 24*C*D1**2*b1*fd**2*r**2 - 48*C*D1**2*b1*fd**2*r*s + 24*C*D1**2*b1*fd**2*r - 24*C*D1**2*b1*fd**2*s**2 + 24*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 88*C*D1*Dd*b1*f**2*r**2 + 176*C*D1*Dd*b1*f**2*r*s - 132*C*D1*Dd*b1*f**2*r + 88*C*D1*Dd*b1*f**2*s**2 - 132*C*D1*Dd*b1*f**2*s + 66*C*D1*Dd*b1*f**2 - 192*C*D1*Dd*b1*f*fd*r**2 - 384*C*D1*Dd*b1*f*fd*r*s + 240*C*D1*Dd*b1*f*fd*r - 192*C*D1*Dd*b1*f*fd*s**2 + 240*C*D1*Dd*b1*f*fd*s - 72*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 48*C*D1*Ddd*b1*f**2*r**2 - 96*C*D1*Ddd*b1*f**2*r*s + 72*C*D1*Ddd*b1*f**2*r - 48*C*D1*Ddd*b1*f**2*s**2 + 72*C*D1*Ddd*b1*f**2*s - 36*C*D1*Ddd*b1*f**2 - 144*C*Dd**2*b1*f**2*r**2 - 288*C*Dd**2*b1*f**2*r*s + 216*C*Dd**2*b1*f**2*r - 144*C*Dd**2*b1*f**2*s**2 + 216*C*Dd**2*b1*f**2*s - 72*C*Dd**2*b1*f**2 + 19*D1**2*K*b1**2*fd*r**2 + 38*D1**2*K*b1**2*fd*r*s + 19*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r**2 - 12*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 - 2*D1**2*K*b1*f*fd*r**2 - 4*D1**2*K*b1*f*fd*r*s + 2*D1**2*K*b1*f*fd*r - 2*D1**2*K*b1*f*fd*s**2 + 2*D1**2*K*b1*f*fd*s - D1**2*K*b1*f*fd - 12*D1**2*K*bd1**2*f*(r + s - 1)**2 + 6*D1**2*b1**2*f*fd*r**2 + 12*D1**2*b1**2*f*fd*r*s - 6*D1**2*b1**2*f*fd*r + 6*D1**2*b1**2*f*fd*s**2 - 6*D1**2*b1**2*f*fd*s + 3*D1**2*b1**2*f*fd - 22*D1**2*b1*f*fd*r**2 - 44*D1**2*b1*f*fd*r*s + 22*D1**2*b1*f*fd*r - 22*D1**2*b1*f*fd*s**2 + 22*D1**2*b1*f*fd*s - 11*D1**2*b1*f*fd + 12*D1**2*b1*f*fdd*r**2 + 24*D1**2*b1*f*fdd*r*s - 12*D1**2*b1*f*fdd*r + 12*D1**2*b1*f*fdd*s**2 - 12*D1**2*b1*f*fdd*s + 6*D1**2*b1*f*fdd - 38*D1**2*b1*f*gd2*r**2 - 76*D1**2*b1*f*gd2*r*s + 76*D1**2*b1*f*gd2*r - 38*D1**2*b1*f*gd2*s**2 + 76*D1**2*b1*f*gd2*s - 38*D1**2*b1*f*gd2 + 12*D1**2*b1*f*gdd2*r**2 + 24*D1**2*b1*f*gdd2*r*s - 24*D1**2*b1*f*gdd2*r + 12*D1**2*b1*f*gdd2*s**2 - 24*D1**2*b1*f*gdd2*s + 12*D1**2*b1*f*gdd2 + 12*D1**2*b1*fd**2*r**2 + 24*D1**2*b1*fd**2*r*s - 12*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 - 12*D1**2*b1*fd**2*s - 38*D1**2*b1*fd*g2*r**2 - 76*D1**2*b1*fd*g2*r*s - 38*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r**2 + 48*D1**2*b1*fd*gd2*r*s - 24*D1**2*b1*fd*gd2*r + 24*D1**2*b1*fd*gd2*s**2 - 24*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r**2 + 24*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - 6*D1**2*bdd1*f*(r + s - 1)**2*(2*C*f + 2*K*b1 - f - 2*g2) + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd + 2*D1**2*f**2*gd2*r**2 + 4*D1**2*f**2*gd2*r*s - 4*D1**2*f**2*gd2*r + 2*D1**2*f**2*gd2*s**2 - 4*D1**2*f**2*gd2*s + 2*D1**2*f**2*gd2 + 4*D1**2*f*fd*g2*r**2 + 8*D1**2*f*fd*g2*r*s - 4*D1**2*f*fd*g2*r + 4*D1**2*f*fd*g2*s**2 - 4*D1**2*f*fd*g2*s + 2*D1**2*f*fd*g2 + 76*D1*Dd*K*b1**2*f*r**2 + 152*D1*Dd*K*b1**2*f*r*s - 114*D1*Dd*K*b1**2*f*r + 76*D1*Dd*K*b1**2*f*s**2 - 114*D1*Dd*K*b1**2*f*s + 57*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 96*D1*Dd*K*b1**2*fd*r*s + 36*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 36*D1*Dd*K*b1**2*fd*s - 4*D1*Dd*K*b1*f**2*r**2 - 8*D1*Dd*K*b1*f**2*r*s + 6*D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s**2 + 6*D1*Dd*K*b1*f**2*s - 3*D1*Dd*K*b1*f**2 + 12*D1*Dd*b1**2*f**2*r**2 + 24*D1*Dd*b1**2*f**2*r*s - 18*D1*Dd*b1**2*f**2*r + 12*D1*Dd*b1**2*f**2*s**2 - 18*D1*Dd*b1**2*f**2*s + 9*D1*Dd*b1**2*f**2 - 44*D1*Dd*b1*f**2*r**2 - 88*D1*Dd*b1*f**2*r*s + 66*D1*Dd*b1*f**2*r - 44*D1*Dd*b1*f**2*s**2 + 66*D1*Dd*b1*f**2*s - 33*D1*Dd*b1*f**2 + 96*D1*Dd*b1*f*fd*r**2 + 192*D1*Dd*b1*f*fd*r*s - 120*D1*Dd*b1*f*fd*r + 96*D1*Dd*b1*f*fd*s**2 - 120*D1*Dd*b1*f*fd*s + 36*D1*Dd*b1*f*fd - 152*D1*Dd*b1*f*g2*r**2 - 304*D1*Dd*b1*f*g2*r*s + 228*D1*Dd*b1*f*g2*r - 152*D1*Dd*b1*f*g2*s**2 + 228*D1*Dd*b1*f*g2*s - 114*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 192*D1*Dd*b1*f*gd2*r*s - 168*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 168*D1*Dd*b1*f*gd2*s + 72*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 192*D1*Dd*b1*fd*g2*r*s - 72*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 72*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 8*D1*Dd*f**2*g2*r**2 + 16*D1*Dd*f**2*g2*r*s - 12*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s**2 - 12*D1*Dd*f**2*g2*s + 6*D1*Dd*f**2*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 48*D1*Ddd*K*b1**2*f*r*s + 36*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 36*D1*Ddd*K*b1**2*f*s - 18*D1*Ddd*K*b1**2*f + 24*D1*Ddd*b1*f**2*r**2 + 48*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r + 24*D1*Ddd*b1*f**2*s**2 - 36*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 96*D1*Ddd*b1*f*g2*r*s - 72*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 72*D1*Ddd*b1*f*g2*s + 36*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(22*C - K + 6*b1 - 11) - f*fd*(24*C - 12)*(2*r + 2*s - 1) - 2*f*(r + s - 1)*(-19*K*b1 + 19*g2 - 12*gd2) + 24*fd*(r + s)*(-K*b1 + g2)) - 12*Dd*f*(4*r + 4*s - 3)*(2*K*b1 + f*(2*C - 1) - 2*g2))*(r + s - 1) - 72*Dd**2*K*b1**2*f*r**2 - 144*Dd**2*K*b1**2*f*r*s + 108*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 108*Dd**2*K*b1**2*f*s - 36*Dd**2*K*b1**2*f + 72*Dd**2*b1*f**2*r**2 + 144*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r + 72*Dd**2*b1*f**2*s**2 - 108*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 288*Dd**2*b1*f*g2*r*s - 216*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 216*Dd**2*b1*f*g2*s + 72*Dd**2*b1*f*g2)/(14*d**2*k3**7) - D1**2*Pk2*Pkd3*k1**2*k2**2*st**2*(4884*C*D1**2*bd1*f**2*r**2 + 11088*C*D1**2*bd1*f**2*r*s - 11748*C*D1**2*bd1*f**2*r + 6204*C*D1**2*bd1*f**2*s**2 - 13068*C*D1**2*bd1*f**2*s + 6534*C*D1**2*bd1*f**2 - 9768*C*D1**2*bd1*f*fd*r**2 - 22704*C*D1**2*bd1*f*fd*r*s + 16896*C*D1**2*bd1*f*fd*r - 12936*C*D1**2*bd1*f*fd*s**2 + 19272*C*D1**2*bd1*f*fd*s - 6336*C*D1**2*bd1*f*fd - 2442*C*D1**2*bdd1*f**2*r**2 - 5676*C*D1**2*bdd1*f**2*r*s + 6336*C*D1**2*bdd1*f**2*r - 3234*C*D1**2*bdd1*f**2*s**2 + 7128*C*D1**2*bdd1*f**2*s - 3564*C*D1**2*bdd1*f**2 - 804*C*D1**2*f**2*fd*r**2 + 1176*C*D1**2*f**2*fd*r*s + 144*C*D1**2*f**2*fd*r + 1980*C*D1**2*f**2*fd*s**2 - 1712*C*D1**2*f**2*fd*s + 392*C*D1**2*f**2*fd - 1182*C*D1**2*f**2*fdd*r**2 - 4548*C*D1**2*f**2*fdd*r*s + 2304*C*D1**2*f**2*fdd*r - 3366*C*D1**2*f**2*fdd*s**2 + 3760*C*D1**2*f**2*fdd*s - 1516*C*D1**2*f**2*fdd - 2364*C*D1**2*f*fd**2*r**2 - 9096*C*D1**2*f*fd**2*r*s + 4608*C*D1**2*f*fd**2*r - 6732*C*D1**2*f*fd**2*s**2 + 7520*C*D1**2*f*fd**2*s - 1516*C*D1**2*f*fd**2 - 19536*C*D1*Dd*bd1*f**2*r**2 - 45408*C*D1*Dd*bd1*f**2*r*s + 40788*C*D1*Dd*bd1*f**2*r - 25872*C*D1*Dd*bd1*f**2*s**2 + 46332*C*D1*Dd*bd1*f**2*s - 19800*C*D1*Dd*bd1*f**2 - 1072*C*D1*Dd*f**3*r**2 + 1568*C*D1*Dd*f**3*r*s + 680*C*D1*Dd*f**3*r + 2640*C*D1*Dd*f**3*s**2 - 2104*C*D1*Dd*f**3*s + 124*C*D1*Dd*f**3 - 9456*C*D1*Dd*f**2*fd*r**2 - 36384*C*D1*Dd*f**2*fd*r*s + 18492*C*D1*Dd*f**2*fd*r - 26928*C*D1*Dd*f**2*fd*s**2 + 30868*C*D1*Dd*f**2*fd*s - 8368*C*D1*Dd*f**2*fd - 1576*C*D1*Ddd*f**3*r**2 - 6064*C*D1*Ddd*f**3*r*s + 3092*C*D1*Ddd*f**3*r - 4488*C*D1*Ddd*f**3*s**2 + 5276*C*D1*Ddd*f**3*s - 1910*C*D1*Ddd*f**3 - 4728*C*Dd**2*f**3*r**2 - 18192*C*Dd**2*f**3*r*s + 9276*C*Dd**2*f**3*r - 13464*C*Dd**2*f**3*s**2 + 15828*C*Dd**2*f**3*s - 3820*C*Dd**2*f**3 - 2442*D1**2*K*bd1**2*f*r**2 - 5676*D1**2*K*bd1**2*f*r*s + 5610*D1**2*K*bd1**2*f*r - 3234*D1**2*K*bd1**2*f*s**2 + 6402*D1**2*K*bd1**2*f*s - 3168*D1**2*K*bd1**2*f - 198*D1**2*K*bd1*f**2*r**2 + 132*D1**2*K*bd1*f**2*r*s + 396*D1**2*K*bd1*f**2*r + 330*D1**2*K*bd1*f**2*s**2 - 132*D1**2*K*bd1*f**2*s - 198*D1**2*K*bd1*f**2 - 660*D1**2*K*bd1*f*fd*r**2 - 2904*D1**2*K*bd1*f*fd*r*s + 1386*D1**2*K*bd1*f*fd*r - 2244*D1**2*K*bd1*f*fd*s**2 + 2574*D1**2*K*bd1*f*fd*s - 726*D1**2*K*bd1*f*fd - 165*D1**2*K*bdd1*f**2*r**2 - 726*D1**2*K*bdd1*f**2*r*s + 330*D1**2*K*bdd1*f**2*r - 561*D1**2*K*bdd1*f**2*s**2 + 726*D1**2*K*bdd1*f**2*s - 165*D1**2*K*bdd1*f**2 + 2178*D1**2*bd1**2*f**2*r**2 + 3564*D1**2*bd1**2*f**2*r*s - 3960*D1**2*bd1**2*f**2*r + 1386*D1**2*bd1**2*f**2*s**2 - 3168*D1**2*bd1**2*f**2*s + 1782*D1**2*bd1**2*f**2 + 396*D1**2*bd1**2*f*r**2 + 792*D1**2*bd1**2*f*r*s - 792*D1**2*bd1**2*f*r + 396*D1**2*bd1**2*f*s**2 - 792*D1**2*bd1**2*f*s + 396*D1**2*bd1**2*f - 1980*D1**2*bd1*bd2*f*r**2 - 3960*D1**2*bd1*bd2*f*r*s + 3960*D1**2*bd1*bd2*f*r - 1980*D1**2*bd1*bd2*f*s**2 + 3960*D1**2*bd1*bd2*f*s - 1980*D1**2*bd1*bd2*f - 2772*D1**2*bd1*f**2*r**2 - 6204*D1**2*bd1*f**2*r*s + 6468*D1**2*bd1*f**2*r - 3432*D1**2*bd1*f**2*s**2 + 7128*D1**2*bd1*f**2*s - 3531*D1**2*bd1*f**2 + 5676*D1**2*bd1*f*fd*r**2 + 12936*D1**2*bd1*f*fd*r*s - 9636*D1**2*bd1*f*fd*r + 7260*D1**2*bd1*f*fd*s**2 - 10824*D1**2*bd1*f*fd*s + 3564*D1**2*bd1*f*fd - 4884*D1**2*bd1*f*g2*r**2 - 13200*D1**2*bd1*f*g2*r*s + 19140*D1**2*bd1*f*g2*r - 8316*D1**2*bd1*f*g2*s**2 + 22572*D1**2*bd1*f*g2*s - 11286*D1**2*bd1*f*g2 + 4884*D1**2*bd1*f*gd2*r**2 + 11352*D1**2*bd1*f*gd2*r*s - 11220*D1**2*bd1*f*gd2*r + 6468*D1**2*bd1*f*gd2*s**2 - 12804*D1**2*bd1*f*gd2*s + 6336*D1**2*bd1*f*gd2 + 4884*D1**2*bd1*fd*g2*r**2 + 11352*D1**2*bd1*fd*g2*r*s - 5676*D1**2*bd1*fd*g2*r + 6468*D1**2*bd1*fd*g2*s**2 - 6468*D1**2*bd1*fd*g2*s - 165*D1**2*bd2*f**2*r**2 - 330*D1**2*bd2*f**2*r*s + 330*D1**2*bd2*f**2*r - 165*D1**2*bd2*f**2*s**2 + 330*D1**2*bd2*f**2*s - 165*D1**2*bd2*f**2 + 1419*D1**2*bdd1*f**2*r**2 + 3234*D1**2*bdd1*f**2*r*s - 3564*D1**2*bdd1*f**2*r + 1815*D1**2*bdd1*f**2*s**2 - 3960*D1**2*bdd1*f**2*s + 1980*D1**2*bdd1*f**2 + 2442*D1**2*bdd1*f*g2*r**2 + 5676*D1**2*bdd1*f*g2*r*s - 6336*D1**2*bdd1*f*g2*r + 3234*D1**2*bdd1*f*g2*s**2 - 7128*D1**2*bdd1*f*g2*s + 3564*D1**2*bdd1*f*g2 + 600*D1**2*f**2*fd*r**2 - 390*D1**2*f**2*fd*r*s - 270*D1**2*f**2*fd*r - 990*D1**2*f**2*fd*s**2 + 790*D1**2*f**2*fd*s - 130*D1**2*f**2*fd + 591*D1**2*f**2*fdd*r**2 + 2274*D1**2*f**2*fdd*r*s - 1152*D1**2*f**2*fdd*r + 1683*D1**2*f**2*fdd*s**2 - 1880*D1**2*f**2*fdd*s + 758*D1**2*f**2*fdd + 396*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s - 792*D1**2*f**2*gd2*r - 660*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 396*D1**2*f**2*gd2 + 330*D1**2*f**2*gdd2*r**2 + 1452*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*r + 1122*D1**2*f**2*gdd2*s**2 - 1452*D1**2*f**2*gdd2*s + 330*D1**2*f**2*gdd2 + 1182*D1**2*f*fd**2*r**2 + 4548*D1**2*f*fd**2*r*s - 2304*D1**2*f*fd**2*r + 3366*D1**2*f*fd**2*s**2 - 3760*D1**2*f*fd**2*s + 758*D1**2*f*fd**2 + 792*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 1320*D1**2*f*fd*g2*s**2 + 1320*D1**2*f*fd*g2*s - 660*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*r**2 + 5808*D1**2*f*fd*gd2*r*s - 2772*D1**2*f*fd*gd2*r + 4488*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1452*D1**2*f*fd*gd2 + 660*D1**2*f*fdd*g2*r**2 + 2904*D1**2*f*fdd*g2*r*s - 1452*D1**2*f*fdd*g2*r + 2244*D1**2*f*fdd*g2*s**2 - 2244*D1**2*f*fdd*g2*s + 1122*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*r**2 + 2904*D1**2*fd**2*g2*r*s - 1452*D1**2*fd**2*g2*r + 2244*D1**2*fd**2*g2*s**2 - 2244*D1**2*fd**2*g2*s - 1320*D1*Dd*K*bd1*f**2*r**2 - 5808*D1*Dd*K*bd1*f**2*r*s + 2706*D1*Dd*K*bd1*f**2*r - 4488*D1*Dd*K*bd1*f**2*s**2 + 5478*D1*Dd*K*bd1*f**2*s - 1386*D1*Dd*K*bd1*f**2 + 11352*D1*Dd*bd1*f**2*r**2 + 25872*D1*Dd*bd1*f**2*r*s - 23166*D1*Dd*bd1*f**2*r + 14520*D1*Dd*bd1*f**2*s**2 - 25938*D1*Dd*bd1*f**2*s + 11088*D1*Dd*bd1*f**2 + 19536*D1*Dd*bd1*f*g2*r**2 + 45408*D1*Dd*bd1*f*g2*r*s - 40788*D1*Dd*bd1*f*g2*r + 25872*D1*Dd*bd1*f*g2*s**2 - 46332*D1*Dd*bd1*f*g2*s + 19800*D1*Dd*bd1*f*g2 + 800*D1*Dd*f**3*r**2 - 520*D1*Dd*f**3*r*s - 670*D1*Dd*f**3*r - 1320*D1*Dd*f**3*s**2 + 920*D1*Dd*f**3*s + 70*D1*Dd*f**3 + 4728*D1*Dd*f**2*fd*r**2 + 18192*D1*Dd*f**2*fd*r*s - 9246*D1*Dd*f**2*fd*r + 13464*D1*Dd*f**2*fd*s**2 - 15434*D1*Dd*f**2*fd*s + 4184*D1*Dd*f**2*fd + 1584*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s - 1320*D1*Dd*f**2*g2*r - 2640*D1*Dd*f**2*g2*s**2 + 1848*D1*Dd*f**2*g2*s + 132*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*r**2 + 11616*D1*Dd*f**2*gd2*r*s - 5412*D1*Dd*f**2*gd2*r + 8976*D1*Dd*f**2*gd2*s**2 - 10956*D1*Dd*f**2*gd2*s + 2772*D1*Dd*f**2*gd2 + 5280*D1*Dd*f*fd*g2*r**2 + 23232*D1*Dd*f*fd*g2*r*s - 11352*D1*Dd*f*fd*g2*r + 17952*D1*Dd*f*fd*g2*s**2 - 19272*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 + 788*D1*Ddd*f**3*r**2 + 3032*D1*Ddd*f**3*r*s - 1546*D1*Ddd*f**3*r + 2244*D1*Ddd*f**3*s**2 - 2638*D1*Ddd*f**3*s + 955*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*g2*r**2 + 5808*D1*Ddd*f**2*g2*r*s - 2772*D1*Ddd*f**2*g2*r + 4488*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 1782*D1*Ddd*f**2*g2 + 165*D1*b2*(bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 2364*Dd**2*f**3*r**2 + 9096*Dd**2*f**3*r*s - 4638*Dd**2*f**3*r + 6732*Dd**2*f**3*s**2 - 7914*Dd**2*f**3*s + 1910*Dd**2*f**3 + 3960*Dd**2*f**2*g2*r**2 + 17424*Dd**2*f**2*g2*r*s - 8316*Dd**2*f**2*g2*r + 13464*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 3564*Dd**2*f**2*g2 + 495*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(74*D1**2*K*fd*r**2 + 200*D1**2*K*fd*r*s + 90*D1**2*K*fd*r + 126*D1**2*K*fd*s**2 + 90*D1**2*K*fd*s - 45*D1**2*K*fd - 37*D1**2*K*fdd*r**2 - 86*D1**2*K*fdd*r*s - 10*D1**2*K*fdd*r - 49*D1**2*K*fdd*s**2 - 10*D1**2*K*fdd*s + 5*D1**2*K*fdd - 15*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 34*D1**2*f*fd*r**2 - 44*D1**2*f*fd*r*s + 34*D1**2*f*fd*r - 10*D1**2*f*fd*s**2 + 22*D1**2*f*fd*s - 17*D1**2*f*fd + 66*D1**2*f*fdd*r**2 + 108*D1**2*f*fdd*r*s - 66*D1**2*f*fdd*r + 42*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 33*D1**2*f*fdd + 66*D1**2*fd**2*r**2 + 108*D1**2*fd**2*r*s - 66*D1**2*fd**2*r + 42*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s - 12*D1**2*fd*r**2 - 38*D1**2*fd*r*s - 26*D1**2*fd*s**2 + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 + 296*D1*Dd*K*f*r**2 + 800*D1*Dd*K*f*r*s - 496*D1*Dd*K*f*r + 504*D1*Dd*K*f*s**2 - 652*D1*Dd*K*f*s + 274*D1*Dd*K*f - 296*D1*Dd*K*fd*r**2 - 688*D1*Dd*K*fd*r*s + 194*D1*Dd*K*fd*r - 392*D1*Dd*K*fd*s**2 + 230*D1*Dd*K*fd*s + 30*D1*Dd*K*fd - 68*D1*Dd*f**2*r**2 - 88*D1*Dd*f**2*r*s + 90*D1*Dd*f**2*r - 20*D1*Dd*f**2*s**2 + 54*D1*Dd*f**2*s - 39*D1*Dd*f**2 + 528*D1*Dd*f*fd*r**2 + 864*D1*Dd*f*fd*r*s - 636*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 516*D1*Dd*f*fd*s + 186*D1*Dd*f*fd - 48*D1*Dd*f*r**2 - 152*D1*Dd*f*r*s + 86*D1*Dd*f*r - 104*D1*Dd*f*s**2 + 128*D1*Dd*f*s - 50*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 36*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 36*D1*Dd*fd*s - 148*D1*Ddd*K*f*r**2 - 344*D1*Ddd*K*f*r*s + 234*D1*Ddd*K*f*r - 196*D1*Ddd*K*f*s**2 + 270*D1*Ddd*K*f*s - 123*D1*Ddd*K*f + 132*D1*Ddd*f**2*r**2 + 216*D1*Ddd*f**2*r*s - 186*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 150*D1*Ddd*f**2*s + 87*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f + 30*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 444*Dd**2*K*f*r**2 - 1032*Dd**2*K*f*r*s + 702*Dd**2*K*f*r - 588*Dd**2*K*f*s**2 + 810*Dd**2*K*f*s - 246*Dd**2*K*f + 396*Dd**2*f**2*r**2 + 648*Dd**2*f**2*r*s - 558*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 450*Dd**2*f**2*s + 174*Dd**2*f**2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f) - 33*b1*(-296*C*D1**2*f*fd*r**2 - 672*C*D1**2*f*fd*r*s + 276*C*D1**2*f*fd*r - 376*C*D1**2*f*fd*s**2 + 316*C*D1**2*f*fd*s - 138*C*D1**2*f*fd + 148*C*D1**2*f*fdd*r**2 + 344*C*D1**2*f*fdd*r*s - 128*C*D1**2*f*fdd*r + 196*C*D1**2*f*fdd*s**2 - 152*C*D1**2*f*fdd*s + 64*C*D1**2*f*fdd + 148*C*D1**2*fd**2*r**2 + 344*C*D1**2*fd**2*r*s - 128*C*D1**2*fd**2*r + 196*C*D1**2*fd**2*s**2 - 152*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 592*C*D1*Dd*f**2*r**2 - 1344*C*D1*Dd*f**2*r*s + 928*C*D1*Dd*f**2*r - 752*C*D1*Dd*f**2*s**2 + 1048*C*D1*Dd*f**2*s - 484*C*D1*Dd*f**2 + 1184*C*D1*Dd*f*fd*r**2 + 2752*C*D1*Dd*f*fd*r*s - 1448*C*D1*Dd*f*fd*r + 1568*C*D1*Dd*f*fd*s**2 - 1688*C*D1*Dd*f*fd*s + 408*C*D1*Dd*f*fd + 296*C*D1*Ddd*f**2*r**2 + 688*C*D1*Ddd*f**2*r*s - 468*C*D1*Ddd*f**2*r + 392*C*D1*Ddd*f**2*s**2 - 540*C*D1*Ddd*f**2*s + 246*C*D1*Ddd*f**2 + 888*C*Dd**2*f**2*r**2 + 2064*C*Dd**2*f**2*r*s - 1404*C*Dd**2*f**2*r + 1176*C*Dd**2*f**2*s**2 - 1620*C*Dd**2*f**2*s + 492*C*Dd**2*f**2 + 74*D1**2*K*bdd1*f*r**2 + 172*D1**2*K*bdd1*f*r*s - 170*D1**2*K*bdd1*f*r + 98*D1**2*K*bdd1*f*s**2 - 194*D1**2*K*bdd1*f*s + 91*D1**2*K*bdd1*f + 12*D1**2*K*f*fd*r**2 - 8*D1**2*K*f*fd*r*s + 4*D1**2*K*f*fd*r - 20*D1**2*K*f*fd*s**2 + 20*D1**2*K*f*fd*s - 10*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r**2 + 44*D1**2*K*f*fdd*r*s - 22*D1**2*K*f*fdd*r + 34*D1**2*K*f*fdd*s**2 - 34*D1**2*K*f*fdd*s + 17*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r**2 + 44*D1**2*K*fd**2*r*s - 22*D1**2*K*fd**2*r + 34*D1**2*K*fd**2*s**2 - 34*D1**2*K*fd**2*s - 95*D1**2*b2*fd*r**2 - 190*D1**2*b2*fd*r*s - 95*D1**2*b2*fd*s**2 + 30*D1**2*b2*fdd*r**2 + 60*D1**2*b2*fdd*r*s + 30*D1**2*b2*fdd*s**2 + 30*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*D1**2*bdd1*f**2*r**2 - 108*D1**2*bdd1*f**2*r*s + 120*D1**2*bdd1*f**2*r - 42*D1**2*bdd1*f**2*s**2 + 96*D1**2*bdd1*f**2*s - 54*D1**2*bdd1*f**2 - 12*D1**2*bdd1*f*r**2 - 24*D1**2*bdd1*f*r*s + 24*D1**2*bdd1*f*r - 12*D1**2*bdd1*f*s**2 + 24*D1**2*bdd1*f*s - 12*D1**2*bdd1*f + 30*D1**2*bdd2*f*r**2 + 60*D1**2*bdd2*f*r*s - 60*D1**2*bdd2*f*r + 30*D1**2*bdd2*f*s**2 - 60*D1**2*bdd2*f*s + 30*D1**2*bdd2*f + 168*D1**2*f*fd*r**2 + 376*D1**2*f*fd*r*s - 160*D1**2*f*fd*r + 208*D1**2*f*fd*s**2 - 180*D1**2*f*fd*s + 81*D1**2*f*fd - 86*D1**2*f*fdd*r**2 - 196*D1**2*f*fdd*r*s + 76*D1**2*f*fdd*r - 110*D1**2*f*fdd*s**2 + 88*D1**2*f*fdd*s - 38*D1**2*f*fdd + 148*D1**2*f*gd2*r**2 + 400*D1**2*f*gd2*r*s - 296*D1**2*f*gd2*r + 252*D1**2*f*gd2*s**2 - 400*D1**2*f*gd2*s + 148*D1**2*f*gd2 - 74*D1**2*f*gdd2*r**2 - 172*D1**2*f*gdd2*r*s + 148*D1**2*f*gdd2*r - 98*D1**2*f*gdd2*s**2 + 172*D1**2*f*gdd2*s - 74*D1**2*f*gdd2 - 86*D1**2*fd**2*r**2 - 196*D1**2*fd**2*r*s + 76*D1**2*fd**2*r - 110*D1**2*fd**2*s**2 + 88*D1**2*fd**2*s + 10*D1**2*fd**2 + 148*D1**2*fd*g2*r**2 + 400*D1**2*fd*g2*r*s + 180*D1**2*fd*g2*r + 252*D1**2*fd*g2*s**2 + 180*D1**2*fd*g2*s - 90*D1**2*fd*g2 - 148*D1**2*fd*gd2*r**2 - 344*D1**2*fd*gd2*r*s + 128*D1**2*fd*gd2*r - 196*D1**2*fd*gd2*s**2 + 152*D1**2*fd*gd2*s + 20*D1**2*fd*gd2 - 74*D1**2*fdd*g2*r**2 - 172*D1**2*fdd*g2*r*s - 20*D1**2*fdd*g2*r - 98*D1**2*fdd*g2*s**2 - 20*D1**2*fdd*g2*s + 10*D1**2*fdd*g2 + 24*D1*Dd*K*f**2*r**2 - 16*D1*Dd*K*f**2*r*s - 20*D1*Dd*K*f**2*r - 40*D1*Dd*K*f**2*s**2 + 28*D1*Dd*K*f**2*s + 2*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r**2 + 352*D1*Dd*K*f*fd*r*s - 172*D1*Dd*K*f*fd*r + 272*D1*Dd*K*f*fd*s**2 - 292*D1*Dd*K*f*fd*s + 78*D1*Dd*K*f*fd - 380*D1*Dd*b2*f*r**2 - 760*D1*Dd*b2*f*r*s + 570*D1*Dd*b2*f*r - 380*D1*Dd*b2*f*s**2 + 570*D1*Dd*b2*f*s - 285*D1*Dd*b2*f + 240*D1*Dd*b2*fd*r**2 + 480*D1*Dd*b2*fd*r*s - 180*D1*Dd*b2*fd*r + 240*D1*Dd*b2*fd*s**2 - 180*D1*Dd*b2*fd*s + 336*D1*Dd*f**2*r**2 + 752*D1*Dd*f**2*r*s - 524*D1*Dd*f**2*r + 416*D1*Dd*f**2*s**2 - 584*D1*Dd*f**2*s + 272*D1*Dd*f**2 - 688*D1*Dd*f*fd*r**2 - 1568*D1*Dd*f*fd*r*s + 844*D1*Dd*f*fd*r - 880*D1*Dd*f*fd*s**2 + 964*D1*Dd*f*fd*s - 240*D1*Dd*f*fd + 592*D1*Dd*f*g2*r**2 + 1600*D1*Dd*f*g2*r*s - 992*D1*Dd*f*g2*r + 1008*D1*Dd*f*g2*s**2 - 1304*D1*Dd*f*g2*s + 548*D1*Dd*f*g2 - 592*D1*Dd*f*gd2*r**2 - 1376*D1*Dd*f*gd2*r*s + 1060*D1*Dd*f*gd2*r - 784*D1*Dd*f*gd2*s**2 + 1228*D1*Dd*f*gd2*s - 468*D1*Dd*f*gd2 - 592*D1*Dd*fd*g2*r**2 - 1376*D1*Dd*fd*g2*r*s + 388*D1*Dd*fd*g2*r - 784*D1*Dd*fd*g2*s**2 + 460*D1*Dd*fd*g2*s + 60*D1*Dd*fd*g2 + 20*D1*Ddd*K*f**2*r**2 + 88*D1*Ddd*K*f**2*r*s - 42*D1*Ddd*K*f**2*r + 68*D1*Ddd*K*f**2*s**2 - 78*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 + 120*D1*Ddd*b2*f*r**2 + 240*D1*Ddd*b2*f*r*s - 180*D1*Ddd*b2*f*r + 120*D1*Ddd*b2*f*s**2 - 180*D1*Ddd*b2*f*s + 90*D1*Ddd*b2*f - 172*D1*Ddd*f**2*r**2 - 392*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 220*D1*Ddd*f**2*s**2 + 306*D1*Ddd*f**2*s - 141*D1*Ddd*f**2 - 296*D1*Ddd*f*g2*r**2 - 688*D1*Ddd*f*g2*r*s + 468*D1*Ddd*f*g2*r - 392*D1*Ddd*f*g2*s**2 + 540*D1*Ddd*f*g2*s - 246*D1*Ddd*f*g2 + D1*bd1*(D1*(2*f**2*(17*r**2 + r*(22*s - 28) + 5*s**2 - 16*s + 11) - f*(K*(148*r**2 + 400*r*s - 438*r + 252*s**2 - 542*s + 245) + 12*fd*(22*r**2 + r*(36*s - 31) + 14*s**2 - 25*s + 10) - 24*r**2 - 76*r*s + 62*r - 52*s**2 + 90*s - 38) + 2*fd*(K*(74*r**2 + r*(172*s - 75) + 98*s**2 - 87*s - 5) - 12*r**2 - 12*r*(2*s - 1) - 12*s*(s - 1))) - 2*Dd*f*(-K*(296*r**2 + 688*r*s - 574*r + 392*s**2 - 658*s + 267) + 6*f*(44*r**2 + r*(72*s - 71) + 28*s**2 - 57*s + 28) + 48*r**2 + 96*r*s - 84*r + 48*s**2 - 84*s + 36)) - 5*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 60*Dd**2*K*f**2*r**2 + 264*Dd**2*K*f**2*r*s - 126*Dd**2*K*f**2*r + 204*Dd**2*K*f**2*s**2 - 234*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 + 360*Dd**2*b2*f*r**2 + 720*Dd**2*b2*f*r*s - 540*Dd**2*b2*f*r + 360*Dd**2*b2*f*s**2 - 540*Dd**2*b2*f*s + 180*Dd**2*b2*f - 516*Dd**2*f**2*r**2 - 1176*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 660*Dd**2*f**2*s**2 + 918*Dd**2*f**2*s - 282*Dd**2*f**2 - 888*Dd**2*f*g2*r**2 - 2064*Dd**2*f*g2*r*s + 1404*Dd**2*f*g2*r - 1176*Dd**2*f*g2*s**2 + 1620*Dd**2*f*g2*s - 492*Dd**2*f*g2))/(1386*d**2*k3**5) + D1**2*Pk2*Pkd3*k1**2*k2**2*(D1*(35*D1*b2*bd1*f*(r + s - 1)**2 + 10*D1*bd1**2*(r + s - 1)*(7*K*f*(r + s - 1) - f*(12*C - 6)*(r + s) + 14*g2*(r + s)) + 2*D1*bdd1*f*(f*(2*C - 1)*(17*r + 15*s - 15) - 35*g2*(r + s - 1))*(r + s - 1) + 4*bd1*(D1*(f**2*(r + s - 1)*(2*C*(7*r + 9*s - 9) - 10*r - 9*s + 9) + f*(fd*(2*C - 1)*(34*r**2 + r*(64*s - 49) + 30*s**2 - 46*s + 16) + (-21*g2 - 35*gd2)*(r + s - 1)**2) - 35*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + Dd*f*(f*(2*C - 1)*(68*r**2 + 2*r*(64*s - 57) + 60*s**2 - 107*s + 47) - 35*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 35*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(2*K + f) - Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(-35*K*bdd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(50*C*(r + s - 1)**2 + 42*K*s**2 + r**2*(42*K - 39) + r*(84*K*s - 64*s + 50) - 25*s**2 + 50*s - 25) - 5*fdd*(12*C*(r + s - 1)**2 - 7*K*s**2 - r**2*(7*K + 6) - 2*r*(7*K*s + 6*s - 6) - 6*s**2 + 12*s - 6) - 140*gd2*(r + s - 1)**2 + 70*gdd2*(r + s - 1)**2) + 35*D1*bd1*(D1*(2*K + f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(f*(50*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 42*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 156*r**2 - 256*r*s + 220*r - 100*s**2 + 178*s - 103) - 10*fd*(4*r + 4*s - 3)*(12*C*(r + s - 1) - 7*K*r - 7*K*s - 6*r - 6*s + 6) - 140*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 140*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 5*Ddd*(f*(-12*C + 7*K + 6) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 30*Dd**2*(f*(-12*C + 7*K + 6) + 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - b1*(120*C*D1**2*bdd1*f*r**2 + 240*C*D1**2*bdd1*f*r*s - 120*C*D1**2*bdd1*f*r + 120*C*D1**2*bdd1*f*s**2 - 120*C*D1**2*bdd1*f*s + 60*C*D1**2*bdd1*f - 112*C*D1**2*f*fd*r**2 - 256*C*D1**2*f*fd*r*s + 112*C*D1**2*f*fd*r - 144*C*D1**2*f*fd*s**2 + 128*C*D1**2*f*fd*s - 56*C*D1**2*f*fd - 136*C*D1**2*f*fdd*r**2 - 256*C*D1**2*f*fdd*r*s + 136*C*D1**2*f*fdd*r - 120*C*D1**2*f*fdd*s**2 + 128*C*D1**2*f*fdd*s - 68*C*D1**2*f*fdd - 136*C*D1**2*fd**2*r**2 - 256*C*D1**2*fd**2*r*s + 136*C*D1**2*fd**2*r - 120*C*D1**2*fd**2*s**2 + 128*C*D1**2*fd**2*s - 224*C*D1*Dd*f**2*r**2 - 512*C*D1*Dd*f**2*r*s + 352*C*D1*Dd*f**2*r - 288*C*D1*Dd*f**2*s**2 + 400*C*D1*Dd*f**2*s - 184*C*D1*Dd*f**2 - 1088*C*D1*Dd*f*fd*r**2 - 2048*C*D1*Dd*f*fd*r*s + 1344*C*D1*Dd*f*fd*r - 960*C*D1*Dd*f*fd*s**2 + 1264*C*D1*Dd*f*fd*s - 400*C*D1*Dd*f*fd - 272*C*D1*Ddd*f**2*r**2 - 512*C*D1*Ddd*f**2*r*s + 400*C*D1*Ddd*f**2*r - 240*C*D1*Ddd*f**2*s**2 + 376*C*D1*Ddd*f**2*s - 196*C*D1*Ddd*f**2 - 816*C*Dd**2*f**2*r**2 - 1536*C*Dd**2*f**2*r*s + 1200*C*Dd**2*f**2*r - 720*C*Dd**2*f**2*s**2 + 1128*C*Dd**2*f**2*s - 392*C*Dd**2*f**2 + 70*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 70*D1**2*K*bdd1*f*r**2 - 140*D1**2*K*bdd1*f*r*s + 140*D1**2*K*bdd1*f*r - 70*D1**2*K*bdd1*f*s**2 + 140*D1**2*K*bdd1*f*s - 70*D1**2*K*bdd1*f - 35*D1**2*b2*fd*r**2 - 70*D1**2*b2*fd*r*s - 35*D1**2*b2*fd*s**2 - 35*D1**2*bd2*f*(r + s - 1)**2 - 60*D1**2*bdd1*f*r**2 - 120*D1**2*bdd1*f*r*s + 60*D1**2*bdd1*f*r - 60*D1**2*bdd1*f*s**2 + 60*D1**2*bdd1*f*s - 30*D1**2*bdd1*f - 140*D1**2*bdd1*g2*r**2 - 280*D1**2*bdd1*g2*r*s + 140*D1**2*bdd1*g2*r - 140*D1**2*bdd1*g2*s**2 + 140*D1**2*bdd1*g2*s - 70*D1**2*bdd1*g2 + 80*D1**2*f*fd*r**2 + 152*D1**2*f*fd*r*s - 80*D1**2*f*fd*r + 72*D1**2*f*fd*s**2 - 76*D1**2*f*fd*s + 40*D1**2*f*fd + 68*D1**2*f*fdd*r**2 + 128*D1**2*f*fdd*r*s - 68*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 - 64*D1**2*f*fdd*s + 34*D1**2*f*fdd + 84*D1**2*f*gd2*r**2 + 168*D1**2*f*gd2*r*s - 168*D1**2*f*gd2*r + 84*D1**2*f*gd2*s**2 - 168*D1**2*f*gd2*s + 84*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 140*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*r + 70*D1**2*f*gdd2*s**2 - 140*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 + 68*D1**2*fd**2*r**2 + 128*D1**2*fd**2*r*s - 68*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 - 64*D1**2*fd**2*s + 84*D1**2*fd*g2*r**2 + 168*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*s**2 + 140*D1**2*fd*gd2*r**2 + 280*D1**2*fd*gd2*r*s - 140*D1**2*fd*gd2*r + 140*D1**2*fd*gd2*s**2 - 140*D1**2*fd*gd2*s + 70*D1**2*fdd*g2*r**2 + 140*D1**2*fdd*g2*r*s + 70*D1**2*fdd*g2*s**2 - 140*D1*Dd*b2*f*r**2 - 280*D1*Dd*b2*f*r*s + 210*D1*Dd*b2*f*r - 140*D1*Dd*b2*f*s**2 + 210*D1*Dd*b2*f*s - 105*D1*Dd*b2*f + 160*D1*Dd*f**2*r**2 + 304*D1*Dd*f**2*r*s - 236*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 224*D1*Dd*f**2*s + 116*D1*Dd*f**2 + 544*D1*Dd*f*fd*r**2 + 1024*D1*Dd*f*fd*r*s - 672*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 632*D1*Dd*f*fd*s + 200*D1*Dd*f*fd + 336*D1*Dd*f*g2*r**2 + 672*D1*Dd*f*g2*r*s - 504*D1*Dd*f*g2*r + 336*D1*Dd*f*g2*s**2 - 504*D1*Dd*f*g2*s + 252*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 1120*D1*Dd*f*gd2*r*s - 980*D1*Dd*f*gd2*r + 560*D1*Dd*f*gd2*s**2 - 980*D1*Dd*f*gd2*s + 420*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 1120*D1*Dd*fd*g2*r*s - 420*D1*Dd*fd*g2*r + 560*D1*Dd*fd*g2*s**2 - 420*D1*Dd*fd*g2*s + 136*D1*Ddd*f**2*r**2 + 256*D1*Ddd*f**2*r*s - 200*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 188*D1*Ddd*f**2*s + 98*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 560*D1*Ddd*f*g2*r*s - 420*D1*Ddd*f*g2*r + 280*D1*Ddd*f*g2*s**2 - 420*D1*Ddd*f*g2*s + 210*D1*Ddd*f*g2 - D1*bd1*(D1*(f*(50*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 84*K*(r + s - 1)**2 - 78*r**2 - 128*r*s + 92*r - 50*s**2 + 64*s - 39) - 20*fd*(r + s - 1)*(6*C*(2*r + 2*s - 1) - 7*K*r - 7*K*s - 6*r - 6*s + 3) - 140*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 140*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 20*Dd*(f*(6*C*(2*r + 2*s - 1) - 7*K*(r + s - 1) - 6*r - 6*s + 3) - 7*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 408*Dd**2*f**2*r**2 + 768*Dd**2*f**2*r*s - 600*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 564*Dd**2*f**2*s + 196*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 1680*Dd**2*f*g2*r*s - 1260*Dd**2*f*g2*r + 840*Dd**2*f*g2*s**2 - 1260*Dd**2*f*g2*s + 420*Dd**2*f*g2))/(21*d**2*k3**5) + D1**2*Pk2*Pkd3*k1**2*st**2*(66*C*D1**2*bdd1*f**2*r**2 + 396*C*D1**2*bdd1*f**2*r*s + 330*C*D1**2*bdd1*f**2*s**2 + 978*C*D1**2*f**2*fd*r**2 + 4740*C*D1**2*f**2*fd*r*s - 2232*C*D1**2*f**2*fd*r + 3762*C*D1**2*f**2*fd*s**2 - 4088*C*D1**2*f**2*fd*s + 1580*C*D1**2*f**2*fd - 1182*C*D1**2*f**2*fdd*r**2 - 4548*C*D1**2*f**2*fdd*r*s + 2304*C*D1**2*f**2*fdd*r - 3366*C*D1**2*f**2*fdd*s**2 + 3760*C*D1**2*f**2*fdd*s - 1516*C*D1**2*f**2*fdd - 2364*C*D1**2*f*fd**2*r**2 - 9096*C*D1**2*f*fd**2*r*s + 4608*C*D1**2*f*fd**2*r - 6732*C*D1**2*f*fd**2*s**2 + 7520*C*D1**2*f*fd**2*s - 1516*C*D1**2*f*fd**2 + 1304*C*D1*Dd*f**3*r**2 + 6320*C*D1*Dd*f**3*r*s - 2884*C*D1*Dd*f**3*r + 5016*C*D1*Dd*f**3*s**2 - 5668*C*D1*Dd*f**3*s + 1906*C*D1*Dd*f**3 - 9456*C*D1*Dd*f**2*fd*r**2 - 36384*C*D1*Dd*f**2*fd*r*s + 18492*C*D1*Dd*f**2*fd*r - 26928*C*D1*Dd*f**2*fd*s**2 + 30868*C*D1*Dd*f**2*fd*s - 8368*C*D1*Dd*f**2*fd - 1576*C*D1*Ddd*f**3*r**2 - 6064*C*D1*Ddd*f**3*r*s + 3092*C*D1*Ddd*f**3*r - 4488*C*D1*Ddd*f**3*s**2 + 5276*C*D1*Ddd*f**3*s - 1910*C*D1*Ddd*f**3 - 4728*C*Dd**2*f**3*r**2 - 18192*C*Dd**2*f**3*r*s + 9276*C*Dd**2*f**3*r - 13464*C*Dd**2*f**3*s**2 + 15828*C*Dd**2*f**3*s - 3820*C*Dd**2*f**3 - 165*D1**2*K*bdd1*f**2*r**2 - 726*D1**2*K*bdd1*f**2*r*s + 330*D1**2*K*bdd1*f**2*r - 561*D1**2*K*bdd1*f**2*s**2 + 726*D1**2*K*bdd1*f**2*s - 165*D1**2*K*bdd1*f**2 + 33*D1**2*b2*bdd1*f*r**2 + 66*D1**2*b2*bdd1*f*r*s + 33*D1**2*b2*bdd1*f*s**2 + 198*D1**2*b2*f*fd*r**2 + 1452*D1**2*b2*f*fd*r*s - 726*D1**2*b2*f*fd*r + 1254*D1**2*b2*f*fd*s**2 - 1254*D1**2*b2*f*fd*s + 627*D1**2*b2*f*fd - 330*D1**2*b2*f*fdd*r**2 - 1452*D1**2*b2*f*fdd*r*s + 726*D1**2*b2*f*fdd*r - 1122*D1**2*b2*f*fdd*s**2 + 1122*D1**2*b2*f*fdd*s - 561*D1**2*b2*f*fdd - 330*D1**2*b2*fd**2*r**2 - 1452*D1**2*b2*fd**2*r*s + 726*D1**2*b2*fd**2*r - 1122*D1**2*b2*fd**2*s**2 + 1122*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*f*(5*K*s**2 - 3*K*s + f*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + r**2*(K + 6) + r*(6*K*s - K + 10*s - 12) + 4*s**2 - 11*s + 6) + 99*D1**2*bd2*f**2*r**2 + 726*D1**2*bd2*f**2*r*s - 198*D1**2*bd2*f**2*r + 627*D1**2*bd2*f**2*s**2 - 726*D1**2*bd2*f**2*s + 99*D1**2*bd2*f**2 - 660*D1**2*bd2*f*fd*r**2 - 2904*D1**2*bd2*f*fd*r*s + 1386*D1**2*bd2*f*fd*r - 2244*D1**2*bd2*f*fd*s**2 + 2574*D1**2*bd2*f*fd*s - 726*D1**2*bd2*f*fd + 165*D1**2*bdd1*f**2*r**2 + 132*D1**2*bdd1*f**2*r*s - 396*D1**2*bdd1*f**2*r - 33*D1**2*bdd1*f**2*s**2 - 396*D1**2*bdd1*f**2*s + 198*D1**2*bdd1*f**2 - 66*D1**2*bdd1*f*g2*r**2 - 396*D1**2*bdd1*f*g2*r*s - 330*D1**2*bdd1*f*g2*s**2 - 165*D1**2*bdd2*f**2*r**2 - 726*D1**2*bdd2*f**2*r*s + 330*D1**2*bdd2*f**2*r - 561*D1**2*bdd2*f**2*s**2 + 726*D1**2*bdd2*f**2*s - 165*D1**2*bdd2*f**2 - 291*D1**2*f**2*fd*r**2 - 2172*D1**2*f**2*fd*r*s + 918*D1**2*f**2*fd*r - 1881*D1**2*f**2*fd*s**2 + 1978*D1**2*f**2*fd*s - 724*D1**2*f**2*fd + 591*D1**2*f**2*fdd*r**2 + 2274*D1**2*f**2*fdd*r*s - 1152*D1**2*f**2*fdd*r + 1683*D1**2*f**2*fdd*s**2 - 1880*D1**2*f**2*fdd*s + 758*D1**2*f**2*fdd - 198*D1**2*f**2*gd2*r**2 - 1452*D1**2*f**2*gd2*r*s + 396*D1**2*f**2*gd2*r - 1254*D1**2*f**2*gd2*s**2 + 1452*D1**2*f**2*gd2*s - 198*D1**2*f**2*gd2 + 330*D1**2*f**2*gdd2*r**2 + 1452*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*r + 1122*D1**2*f**2*gdd2*s**2 - 1452*D1**2*f**2*gdd2*s + 330*D1**2*f**2*gdd2 + 1182*D1**2*f*fd**2*r**2 + 4548*D1**2*f*fd**2*r*s - 2304*D1**2*f*fd**2*r + 3366*D1**2*f*fd**2*s**2 - 3760*D1**2*f*fd**2*s + 758*D1**2*f*fd**2 - 396*D1**2*f*fd*g2*r**2 - 2904*D1**2*f*fd*g2*r*s + 1452*D1**2*f*fd*g2*r - 2508*D1**2*f*fd*g2*s**2 + 2508*D1**2*f*fd*g2*s - 1254*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*r**2 + 5808*D1**2*f*fd*gd2*r*s - 2772*D1**2*f*fd*gd2*r + 4488*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1452*D1**2*f*fd*gd2 + 660*D1**2*f*fdd*g2*r**2 + 2904*D1**2*f*fdd*g2*r*s - 1452*D1**2*f*fdd*g2*r + 2244*D1**2*f*fdd*g2*s**2 - 2244*D1**2*f*fdd*g2*s + 1122*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*r**2 + 2904*D1**2*fd**2*g2*r*s - 1452*D1**2*fd**2*g2*r + 2244*D1**2*fd**2*g2*s**2 - 2244*D1**2*fd**2*g2*s + 396*D1*Dd*b2*f**2*r**2 + 2904*D1*Dd*b2*f**2*r*s - 1122*D1*Dd*b2*f**2*r + 2508*D1*Dd*b2*f**2*s**2 - 2706*D1*Dd*b2*f**2*s + 825*D1*Dd*b2*f**2 - 2640*D1*Dd*b2*f*fd*r**2 - 11616*D1*Dd*b2*f*fd*r*s + 5676*D1*Dd*b2*f*fd*r - 8976*D1*Dd*b2*f*fd*s**2 + 9636*D1*Dd*b2*f*fd*s - 2574*D1*Dd*b2*f*fd - 1320*D1*Dd*bd2*f**2*r**2 - 5808*D1*Dd*bd2*f**2*r*s + 2706*D1*Dd*bd2*f**2*r - 4488*D1*Dd*bd2*f**2*s**2 + 5478*D1*Dd*bd2*f**2*s - 1386*D1*Dd*bd2*f**2 - 388*D1*Dd*f**3*r**2 - 2896*D1*Dd*f**3*r*s + 1112*D1*Dd*f**3*r - 2508*D1*Dd*f**3*s**2 + 2702*D1*Dd*f**3*s - 821*D1*Dd*f**3 + 4728*D1*Dd*f**2*fd*r**2 + 18192*D1*Dd*f**2*fd*r*s - 9246*D1*Dd*f**2*fd*r + 13464*D1*Dd*f**2*fd*s**2 - 15434*D1*Dd*f**2*fd*s + 4184*D1*Dd*f**2*fd - 792*D1*Dd*f**2*g2*r**2 - 5808*D1*Dd*f**2*g2*r*s + 2244*D1*Dd*f**2*g2*r - 5016*D1*Dd*f**2*g2*s**2 + 5412*D1*Dd*f**2*g2*s - 1650*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*r**2 + 11616*D1*Dd*f**2*gd2*r*s - 5412*D1*Dd*f**2*gd2*r + 8976*D1*Dd*f**2*gd2*s**2 - 10956*D1*Dd*f**2*gd2*s + 2772*D1*Dd*f**2*gd2 + 5280*D1*Dd*f*fd*g2*r**2 + 23232*D1*Dd*f*fd*g2*r*s - 11352*D1*Dd*f*fd*g2*r + 17952*D1*Dd*f*fd*g2*s**2 - 19272*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 - 660*D1*Ddd*b2*f**2*r**2 - 2904*D1*Ddd*b2*f**2*r*s + 1386*D1*Ddd*b2*f**2*r - 2244*D1*Ddd*b2*f**2*s**2 + 2574*D1*Ddd*b2*f**2*s - 891*D1*Ddd*b2*f**2 + 788*D1*Ddd*f**3*r**2 + 3032*D1*Ddd*f**3*r*s - 1546*D1*Ddd*f**3*r + 2244*D1*Ddd*f**3*s**2 - 2638*D1*Ddd*f**3*s + 955*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*g2*r**2 + 5808*D1*Ddd*f**2*g2*r*s - 2772*D1*Ddd*f**2*g2*r + 4488*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 1782*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(f**2*(-10*C*s**2 + K*(3*r**2 + r*(22*s - 6) + 19*s**2 - 22*s + 3) - r**2*(2*C + 9) - 6*r*(s*(2*C + 2) - 3) - 3*s**2 + 18*s - 8) + f*(-9*b2*r**2 - 18*b2*r*s - 9*b2*s**2 + 2*bd2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*fd*(-20*C*s**2 + 16*C*s + K*(10*r**2 + r*(44*s - 21) + 34*s**2 - 39*s + 11) - r**2*(4*C + 10) + r*(-24*C*s + 8*C - 8*s + 13) + 2*s**2 + 7*s - 6) + 18*g2*r**2 + 108*g2*r*s + 90*g2*s**2 - 4*gd2*r**2 - 24*gd2*r*s + 4*gd2*r - 20*gd2*s**2 + 12*gd2*s) + 2*fd*(b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(r**2 + r*(6*s - 3) + s*(5*s - 5)))) - 2*Dd*f*(b2*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s)) + f*(-40*C*s**2 + 22*C*s + K*(20*r**2 + r*(88*s - 41) + 68*s**2 - 83*s + 21) - r**2*(8*C + 20) - 2*r*(24*C*s - 5*C + 8*s - 18) + 4*s**2 + 27*s - 18) + 2*g2*(4*r**2 + r*(24*s - 5) + s*(20*s - 11)))) - 1980*Dd**2*b2*f**2*r**2 - 8712*Dd**2*b2*f**2*r*s + 4158*Dd**2*b2*f**2*r - 6732*Dd**2*b2*f**2*s**2 + 7722*Dd**2*b2*f**2*s - 1782*Dd**2*b2*f**2 + 2364*Dd**2*f**3*r**2 + 9096*Dd**2*f**3*r*s - 4638*Dd**2*f**3*r + 6732*Dd**2*f**3*s**2 - 7914*Dd**2*f**3*s + 1910*Dd**2*f**3 + 3960*Dd**2*f**2*g2*r**2 + 17424*Dd**2*f**2*g2*r*s - 8316*Dd**2*f**2*g2*r + 13464*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 3564*Dd**2*f**2*g2 + 66*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1**2*(-9*D1**2*K*fd*r**2 - 54*D1**2*K*fd*r*s + 54*D1**2*K*fd*r - 45*D1**2*K*fd*s**2 + 90*D1**2*K*fd*s - 45*D1**2*K*fd + D1**2*K*fdd*r**2 + 6*D1**2*K*fdd*r*s - 6*D1**2*K*fdd*r + 5*D1**2*K*fdd*s**2 - 10*D1**2*K*fdd*s + 5*D1**2*K*fdd - 2*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 36*D1**2*f*fd*r**2 - 64*D1**2*f*fd*r*s + 38*D1**2*f*fd*r - 28*D1**2*f*fd*s**2 + 22*D1**2*f*fd*s - 14*D1**2*f*fd + 44*D1**2*f*fdd*r**2 + 64*D1**2*f*fdd*r*s - 50*D1**2*f*fdd*r + 20*D1**2*f*fdd*s**2 - 26*D1**2*f*fdd*s + 22*D1**2*f*fdd + 44*D1**2*fd**2*r**2 + 64*D1**2*fd**2*r*s - 50*D1**2*fd**2*r + 20*D1**2*fd**2*s**2 - 26*D1**2*fd**2*s + 6*D1**2*fd**2 - 12*D1**2*fd*r**2 - 20*D1**2*fd*r*s - 18*D1**2*fd*r - 8*D1**2*fd*s**2 - 36*D1**2*fd*s + 18*D1**2*fd + 6*D1**2*fdd*r**2 + 10*D1**2*fdd*r*s + 2*D1**2*fdd*r + 4*D1**2*fdd*s**2 + 4*D1**2*fdd*s - 2*D1**2*fdd - 36*D1*Dd*K*f*r**2 - 216*D1*Dd*K*f*r*s + 90*D1*Dd*K*f*r - 180*D1*Dd*K*f*s**2 + 198*D1*Dd*K*f*s - 63*D1*Dd*K*f + 8*D1*Dd*K*fd*r**2 + 48*D1*Dd*K*fd*r*s - 34*D1*Dd*K*fd*r + 40*D1*Dd*K*fd*s**2 - 62*D1*Dd*K*fd*s + 22*D1*Dd*K*fd - 72*D1*Dd*f**2*r**2 - 128*D1*Dd*f**2*r*s + 104*D1*Dd*f**2*r - 56*D1*Dd*f**2*s**2 + 92*D1*Dd*f**2*s - 50*D1*Dd*f**2 + 352*D1*Dd*f*fd*r**2 + 512*D1*Dd*f*fd*r*s - 440*D1*Dd*f*fd*r + 160*D1*Dd*f*fd*s**2 - 272*D1*Dd*f*fd*s + 126*D1*Dd*f*fd - 48*D1*Dd*f*r**2 - 80*D1*Dd*f*r*s + 68*D1*Dd*f*r - 32*D1*Dd*f*s**2 + 56*D1*Dd*f*s - 32*D1*Dd*f + 48*D1*Dd*fd*r**2 + 80*D1*Dd*fd*r*s - 26*D1*Dd*fd*r + 32*D1*Dd*fd*s**2 - 12*D1*Dd*fd*s - 8*D1*Dd*fd + 4*D1*Ddd*K*f*r**2 + 24*D1*Ddd*K*f*r*s - 10*D1*Ddd*K*f*r + 20*D1*Ddd*K*f*s**2 - 22*D1*Ddd*K*f*s + 7*D1*Ddd*K*f + 88*D1*Ddd*f**2*r**2 + 128*D1*Ddd*f**2*r*s - 120*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 84*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 24*D1*Ddd*f*r**2 + 40*D1*Ddd*f*r*s - 34*D1*Ddd*f*r + 16*D1*Ddd*f*s**2 - 28*D1*Ddd*f*s + 16*D1*Ddd*f + 4*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 12*Dd**2*K*f*r**2 + 72*Dd**2*K*f*r*s - 30*Dd**2*K*f*r + 60*Dd**2*K*f*s**2 - 66*Dd**2*K*f*s + 14*Dd**2*K*f + 264*Dd**2*f**2*r**2 + 384*Dd**2*f**2*r*s - 360*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 252*Dd**2*f**2*s + 108*Dd**2*f**2 + 72*Dd**2*f*r**2 + 120*Dd**2*f*r*s - 102*Dd**2*f*r + 48*Dd**2*f*s**2 - 84*Dd**2*f*s + 32*Dd**2*f) - 33*b1*(4*C*D1**2*f*fd*r**2 + 24*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 20*C*D1**2*f*fd*s**2 - 32*C*D1**2*f*fd*s + 12*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r*s + 16*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 32*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r*s + 16*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 32*C*D1**2*fd**2*s - 12*C*D1**2*fd**2 + 8*C*D1*Dd*f**2*r**2 + 48*C*D1*Dd*f**2*r*s - 20*C*D1*Dd*f**2*r + 40*C*D1*Dd*f**2*s**2 - 44*C*D1*Dd*f**2*s + 14*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 - 192*C*D1*Dd*f*fd*r*s + 104*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 216*C*D1*Dd*f*fd*s - 64*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 - 48*C*D1*Ddd*f**2*r*s + 20*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 44*C*D1*Ddd*f**2*s - 14*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 - 144*C*Dd**2*f**2*r*s + 60*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 132*C*Dd**2*f**2*s - 28*C*Dd**2*f**2 - 2*D1**2*K*bdd1*f*r**2 - 12*D1**2*K*bdd1*f*r*s + 2*D1**2*K*bdd1*f*r - 10*D1**2*K*bdd1*f*s**2 + 6*D1**2*K*bdd1*f*s - D1**2*K*bdd1*f - 6*D1**2*K*f*fd*r**2 - 44*D1**2*K*f*fd*r*s + 22*D1**2*K*f*fd*r - 38*D1**2*K*f*fd*s**2 + 38*D1**2*K*f*fd*s - 19*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r**2 + 44*D1**2*K*f*fdd*r*s - 22*D1**2*K*f*fdd*r + 34*D1**2*K*f*fdd*s**2 - 34*D1**2*K*f*fdd*s + 17*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r**2 + 44*D1**2*K*fd**2*r*s - 22*D1**2*K*fd**2*r + 34*D1**2*K*fd**2*s**2 - 34*D1**2*K*fd**2*s + 9*D1**2*b2*fd*r**2 + 18*D1**2*b2*fd*r*s - 18*D1**2*b2*fd*r + 9*D1**2*b2*fd*s**2 - 18*D1**2*b2*fd*s + 9*D1**2*b2*fd - D1**2*b2*fdd*r**2 - 2*D1**2*b2*fdd*r*s + 2*D1**2*b2*fdd*r - D1**2*b2*fdd*s**2 + 2*D1**2*b2*fdd*s - D1**2*b2*fdd + 4*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 44*D1**2*bdd1*f**2*r**2 - 64*D1**2*bdd1*f**2*r*s + 70*D1**2*bdd1*f**2*r - 20*D1**2*bdd1*f**2*s**2 + 58*D1**2*bdd1*f**2*s - 32*D1**2*bdd1*f**2 - 12*D1**2*bdd1*f*r**2 - 20*D1**2*bdd1*f*r*s + 24*D1**2*bdd1*f*r - 8*D1**2*bdd1*f*s**2 + 22*D1**2*bdd1*f*s - 12*D1**2*bdd1*f - D1**2*bdd2*f*r**2 - 2*D1**2*bdd2*f*r*s + 2*D1**2*bdd2*f*r - D1**2*bdd2*f*s**2 + 2*D1**2*bdd2*f*s - D1**2*bdd2*f + 18*D1**2*f*fd*r**2 + 24*D1**2*f*fd*r*s - 12*D1**2*f*fd*r + 6*D1**2*f*fd*s**2 + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 8*D1**2*f*fdd*r*s + 2*D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 2*D1**2*f*fdd - 18*D1**2*f*gd2*r**2 - 108*D1**2*f*gd2*r*s + 36*D1**2*f*gd2*r - 90*D1**2*f*gd2*s**2 + 108*D1**2*f*gd2*s - 18*D1**2*f*gd2 + 2*D1**2*f*gdd2*r**2 + 12*D1**2*f*gdd2*r*s - 4*D1**2*f*gdd2*r + 10*D1**2*f*gdd2*s**2 - 12*D1**2*f*gdd2*s + 2*D1**2*f*gdd2 - 10*D1**2*fd**2*r**2 - 8*D1**2*fd**2*r*s + 2*D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s + 8*D1**2*fd**2 - 18*D1**2*fd*g2*r**2 - 108*D1**2*fd*g2*r*s + 108*D1**2*fd*g2*r - 90*D1**2*fd*g2*s**2 + 180*D1**2*fd*g2*s - 90*D1**2*fd*g2 + 4*D1**2*fd*gd2*r**2 + 24*D1**2*fd*gd2*r*s - 16*D1**2*fd*gd2*r + 20*D1**2*fd*gd2*s**2 - 32*D1**2*fd*gd2*s + 12*D1**2*fd*gd2 + 2*D1**2*fdd*g2*r**2 + 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*r + 10*D1**2*fdd*g2*s**2 - 20*D1**2*fdd*g2*s + 10*D1**2*fdd*g2 - 12*D1*Dd*K*f**2*r**2 - 88*D1*Dd*K*f**2*r*s + 34*D1*Dd*K*f**2*r - 76*D1*Dd*K*f**2*s**2 + 82*D1*Dd*K*f**2*s - 25*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r**2 + 352*D1*Dd*K*f*fd*r*s - 172*D1*Dd*K*f*fd*r + 272*D1*Dd*K*f*fd*s**2 - 292*D1*Dd*K*f*fd*s + 78*D1*Dd*K*f*fd + 36*D1*Dd*b2*f*r**2 + 72*D1*Dd*b2*f*r*s - 54*D1*Dd*b2*f*r + 36*D1*Dd*b2*f*s**2 - 54*D1*Dd*b2*f*s + 27*D1*Dd*b2*f - 8*D1*Dd*b2*fd*r**2 - 16*D1*Dd*b2*fd*r*s + 14*D1*Dd*b2*fd*r - 8*D1*Dd*b2*fd*s**2 + 14*D1*Dd*b2*fd*s - 6*D1*Dd*b2*fd + 36*D1*Dd*f**2*r**2 + 48*D1*Dd*f**2*r*s - 48*D1*Dd*f**2*r + 12*D1*Dd*f**2*s**2 - 30*D1*Dd*f**2*s + 21*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 64*D1*Dd*f*fd*r*s + 56*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 28*D1*Dd*f*fd*s + 6*D1*Dd*f*fd - 72*D1*Dd*f*g2*r**2 - 432*D1*Dd*f*g2*r*s + 180*D1*Dd*f*g2*r - 360*D1*Dd*f*g2*s**2 + 396*D1*Dd*f*g2*s - 126*D1*Dd*f*g2 + 16*D1*Dd*f*gd2*r**2 + 96*D1*Dd*f*gd2*r*s - 36*D1*Dd*f*gd2*r + 80*D1*Dd*f*gd2*s**2 - 92*D1*Dd*f*gd2*s + 20*D1*Dd*f*gd2 + 16*D1*Dd*fd*g2*r**2 + 96*D1*Dd*fd*g2*r*s - 68*D1*Dd*fd*g2*r + 80*D1*Dd*fd*g2*s**2 - 124*D1*Dd*fd*g2*s + 44*D1*Dd*fd*g2 + 20*D1*Ddd*K*f**2*r**2 + 88*D1*Ddd*K*f**2*r*s - 42*D1*Ddd*K*f**2*r + 68*D1*Ddd*K*f**2*s**2 - 78*D1*Ddd*K*f**2*s + 27*D1*Ddd*K*f**2 - 4*D1*Ddd*b2*f*r**2 - 8*D1*Ddd*b2*f*r*s + 6*D1*Ddd*b2*f*r - 4*D1*Ddd*b2*f*s**2 + 6*D1*Ddd*b2*f*s - 3*D1*Ddd*b2*f - 20*D1*Ddd*f**2*r**2 - 16*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 8*D1*Ddd*f*g2*r**2 + 48*D1*Ddd*f*g2*r*s - 20*D1*Ddd*f*g2*r + 40*D1*Ddd*f*g2*s**2 - 44*D1*Ddd*f*g2*s + 14*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(36*r**2 + r*(64*s - 66) + 28*s**2 - 70*s + 36) + f*(9*K*(2*r**2 + 12*r*s - 2*r + 10*s**2 - 6*s + 1) - 2*fd*(88*r**2 + 8*r*(16*s - 15) + 40*s**2 - 84*s + 35) + 24*r**2 + 40*r*s - 62*r + 16*s**2 - 72*s + 38) - 2*fd*(K*(2*r**2 + r*(12*s - 7) + 10*s**2 - 13*s + 3) + 12*r**2 + 10*r*(2*s - 1) + 8*s**2 - 7*s - 1)) - 2*Dd*f*(K*(8*r**2 + 48*r*s - 14*r + 40*s**2 - 34*s + 5) + f*(176*r**2 + 4*r*(64*s - 65) + 80*s**2 - 200*s + 99) + 48*r**2 + 80*r*s - 82*r + 32*s**2 - 72*s + 35)) + D1*bd2*(D1*(9*f - 2*fd)*(r + s - 1) - 2*Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 60*Dd**2*K*f**2*r**2 + 264*Dd**2*K*f**2*r*s - 126*Dd**2*K*f**2*r + 204*Dd**2*K*f**2*s**2 - 234*Dd**2*K*f**2*s + 54*Dd**2*K*f**2 - 12*Dd**2*b2*f*r**2 - 24*Dd**2*b2*f*r*s + 18*Dd**2*b2*f*r - 12*Dd**2*b2*f*s**2 + 18*Dd**2*b2*f*s - 6*Dd**2*b2*f - 60*Dd**2*f**2*r**2 - 48*Dd**2*f**2*r*s + 72*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 18*Dd**2*f**2 + 24*Dd**2*f*g2*r**2 + 144*Dd**2*f*g2*r*s - 60*Dd**2*f*g2*r + 120*Dd**2*f*g2*s**2 - 132*Dd**2*f*g2*s + 28*Dd**2*f*g2))/(1386*d**2*k3**3) + D1**2*Pk2*Pkd3*k1**2*(D1*(-2*D1*bd1**2*(f*(35*K*(r + s - 1)**2 - 6*r**2*(2*C - 1) - 6*r*(6*C - 4)*(2*s - 1) - 6*s*(10*C - 7)*(s - 1)) + 14*g2*(r**2 + r*(6*s - 3) + s*(5*s - 5))) - 2*D1*bdd1*f*(f*(2*C - 1)*(17*r + 15*s - 15) - 35*g2*(r + s - 1))*(r + s - 1) + 7*b2*(r + s - 1)*(2*D1*bd1**2*(r + s) - 5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3))) + 2*bd1*(-35*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(r + s - 1)*(2*C*(13*r + 9*s - 9) - 7*r - 9*s + 9) + f*(-fd*(4*C - 2)*(34*r**2 + r*(64*s - 49) + 30*s**2 - 46*s + 16) + (-21*g2 + 70*gd2)*(r + s - 1)**2) + 70*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(-f*(2*C - 1)*(68*r**2 + 2*r*(64*s - 57) + 60*s**2 - 107*s + 47) + 35*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)))) + 7*b1**3*(D1**2*(fd*(3*r + s - 3) + fdd*(-5*r - 3*s + 5))*(r + s - 1) + D1*(Dd*(-2*K*(4*r**2 + 24*r*s - 10*r + 20*s**2 - 22*s + 7) + f*(12*r**2 + 16*r*(s - 1) + 4*s**2 - 10*s + 7) - 2*fd*(20*r**2 + r*(32*s - 34) + 12*s**2 - 27*s + 14) + 16*r*s - 4*r + 16*s**2 - 16*s + 4) + Ddd*(K*(4*r**2 + 24*r*s - 10*r + 20*s**2 - 22*s + 7) - f*(20*r**2 + 4*r*(8*s - 7) + 12*s**2 - 22*s + 13) - 8*r*s + 2*r - 8*s**2 + 8*s - 2)) - 2*Dd**2*(-K*(6*r**2 + 36*r*s - 15*r + 30*s**2 - 33*s + 7) + f*(30*r**2 + 6*r*(8*s - 7) + 18*s**2 - 33*s + 13) + 12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-10*C*D1**2*fd*r**2 - 60*C*D1**2*fd*r*s + 20*C*D1**2*fd*r - 50*C*D1**2*fd*s**2 + 60*C*D1**2*fd*s - 10*C*D1**2*fd + 12*C*D1**2*fdd*r**2 + 72*C*D1**2*fdd*r*s - 24*C*D1**2*fdd*r + 60*C*D1**2*fdd*s**2 - 72*C*D1**2*fdd*s + 12*C*D1**2*fdd - 40*C*D1*Dd*f*r**2 - 240*C*D1*Dd*f*r*s + 100*C*D1*Dd*f*r - 200*C*D1*Dd*f*s**2 + 220*C*D1*Dd*f*s - 70*C*D1*Dd*f + 96*C*D1*Dd*fd*r**2 + 576*C*D1*Dd*fd*r*s - 216*C*D1*Dd*fd*r + 480*C*D1*Dd*fd*s**2 - 552*C*D1*Dd*fd*s + 120*C*D1*Dd*fd + 48*C*D1*Ddd*f*r**2 + 288*C*D1*Ddd*f*r*s - 120*C*D1*Ddd*f*r + 240*C*D1*Ddd*f*s**2 - 264*C*D1*Ddd*f*s + 84*C*D1*Ddd*f + 144*C*Dd**2*f*r**2 + 864*C*Dd**2*f*r*s - 360*C*Dd**2*f*r + 720*C*Dd**2*f*s**2 - 792*C*Dd**2*f*s + 168*C*Dd**2*f + 21*D1**2*K*bdd1*r**2 + 126*D1**2*K*bdd1*r*s - 56*D1**2*K*bdd1*r + 105*D1**2*K*bdd1*s**2 - 112*D1**2*K*bdd1*s + 42*D1**2*K*bdd1 + 21*D1**2*K*fd*r**2 + 42*D1**2*K*fd*r*s + 21*D1**2*K*fd*s**2 - 35*D1**2*K*fdd*r**2 - 70*D1**2*K*fdd*r*s - 35*D1**2*K*fdd*s**2 - 105*D1**2*bdd1*f*r**2 - 168*D1**2*bdd1*f*r*s + 126*D1**2*bdd1*f*r - 63*D1**2*bdd1*f*s**2 + 98*D1**2*bdd1*f*s - 56*D1**2*bdd1*f - 42*D1**2*bdd1*r*s + 14*D1**2*bdd1*r - 42*D1**2*bdd1*s**2 + 42*D1**2*bdd1*s - 14*D1**2*bdd1 + 7*D1**2*bdd2*r**2 + 14*D1**2*bdd2*r*s - 14*D1**2*bdd2*r + 7*D1**2*bdd2*s**2 - 14*D1**2*bdd2*s + 7*D1**2*bdd2 + 19*D1**2*fd*r**2 + 54*D1**2*fd*r*s - 10*D1**2*fd*r + 35*D1**2*fd*s**2 - 40*D1**2*fd*s + 5*D1**2*fd - 6*D1**2*fdd*r**2 - 48*D1**2*fdd*r*s + 12*D1**2*fdd*r - 42*D1**2*fdd*s**2 + 48*D1**2*fdd*s - 6*D1**2*fdd + 28*D1**2*gd2*r**2 + 168*D1**2*gd2*r*s - 56*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 168*D1**2*gd2*s + 28*D1**2*gd2 - 14*D1**2*gdd2*r**2 - 84*D1**2*gdd2*r*s + 28*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 84*D1**2*gdd2*s - 14*D1**2*gdd2 + 84*D1*Dd*K*f*r**2 + 168*D1*Dd*K*f*r*s - 126*D1*Dd*K*f*r + 84*D1*Dd*K*f*s**2 - 126*D1*Dd*K*f*s + 63*D1*Dd*K*f - 280*D1*Dd*K*fd*r**2 - 560*D1*Dd*K*fd*r*s + 210*D1*Dd*K*fd*r - 280*D1*Dd*K*fd*s**2 + 210*D1*Dd*K*fd*s - 56*D1*Dd*b2*r**2 - 112*D1*Dd*b2*r*s + 84*D1*Dd*b2*r - 56*D1*Dd*b2*s**2 + 84*D1*Dd*b2*s - 42*D1*Dd*b2 + 76*D1*Dd*f*r**2 + 216*D1*Dd*f*r*s - 130*D1*Dd*f*r + 140*D1*Dd*f*s**2 - 178*D1*Dd*f*s + 73*D1*Dd*f - 48*D1*Dd*fd*r**2 - 384*D1*Dd*fd*r*s + 120*D1*Dd*fd*r - 336*D1*Dd*fd*s**2 + 372*D1*Dd*fd*s - 72*D1*Dd*fd + 112*D1*Dd*g2*r**2 + 672*D1*Dd*g2*r*s - 280*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 616*D1*Dd*g2*s + 196*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 - 672*D1*Dd*gd2*r*s + 252*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 644*D1*Dd*gd2*s - 140*D1*Dd*gd2 - 140*D1*Ddd*K*f*r**2 - 280*D1*Ddd*K*f*r*s + 210*D1*Ddd*K*f*r - 140*D1*Ddd*K*f*s**2 + 210*D1*Ddd*K*f*s - 105*D1*Ddd*K*f + 28*D1*Ddd*b2*r**2 + 56*D1*Ddd*b2*r*s - 42*D1*Ddd*b2*r + 28*D1*Ddd*b2*s**2 - 42*D1*Ddd*b2*s + 21*D1*Ddd*b2 - 24*D1*Ddd*f*r**2 - 192*D1*Ddd*f*r*s + 72*D1*Ddd*f*r - 168*D1*Ddd*f*s**2 + 180*D1*Ddd*f*s - 54*D1*Ddd*f - 56*D1*Ddd*g2*r**2 - 336*D1*Ddd*g2*r*s + 140*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 308*D1*Ddd*g2*s - 98*D1*Ddd*g2 + 7*D1*bd1*(D1*(-2*K*(3*r**2 + 18*r*s - 8*r + 15*s**2 - 16*s + 6) + f*(9*r**2 + 2*r*(6*s - 5) + 3*s**2 - 6*s + 4) - 2*fd*(15*r**2 + 24*r*(s - 1) + 9*s**2 - 19*s + 9) + 12*r*s - 4*r + 12*s**2 - 12*s + 4) - 2*Dd*(-K*(12*r**2 + 72*r*s - 31*r + 60*s**2 - 65*s + 16) + f*(60*r**2 + r*(96*s - 78) + 36*s**2 - 61*s + 25) + 24*r*s - 7*r + 24*s**2 - 24*s + 5)) - 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 420*Dd**2*K*f*r**2 - 840*Dd**2*K*f*r*s + 630*Dd**2*K*f*r - 420*Dd**2*K*f*s**2 + 630*Dd**2*K*f*s - 210*Dd**2*K*f + 84*Dd**2*b2*r**2 + 168*Dd**2*b2*r*s - 126*Dd**2*b2*r + 84*Dd**2*b2*s**2 - 126*Dd**2*b2*s + 42*Dd**2*b2 - 72*Dd**2*f*r**2 - 576*Dd**2*f*r*s + 216*Dd**2*f*r - 504*Dd**2*f*s**2 + 540*Dd**2*f*s - 108*Dd**2*f - 168*Dd**2*g2*r**2 - 1008*Dd**2*g2*r*s + 420*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 924*Dd**2*g2*s - 196*Dd**2*g2) - b1*(-24*C*D1**2*bdd1*f*r**2 - 144*C*D1**2*bdd1*f*r*s + 72*C*D1**2*bdd1*f*r - 120*C*D1**2*bdd1*f*s**2 + 120*C*D1**2*bdd1*f*s - 60*C*D1**2*bdd1*f - 104*C*D1**2*f*fd*r**2 - 176*C*D1**2*f*fd*r*s + 104*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 88*C*D1**2*f*fd*s - 52*C*D1**2*f*fd + 136*C*D1**2*f*fdd*r**2 + 256*C*D1**2*f*fdd*r*s - 136*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 128*C*D1**2*f*fdd*s + 68*C*D1**2*f*fdd + 136*C*D1**2*fd**2*r**2 + 256*C*D1**2*fd**2*r*s - 136*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 128*C*D1**2*fd**2*s - 208*C*D1*Dd*f**2*r**2 - 352*C*D1*Dd*f**2*r*s + 296*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 248*C*D1*Dd*f**2*s - 140*C*D1*Dd*f**2 + 1088*C*D1*Dd*f*fd*r**2 + 2048*C*D1*Dd*f*fd*r*s - 1344*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1264*C*D1*Dd*f*fd*s + 400*C*D1*Dd*f*fd + 272*C*D1*Ddd*f**2*r**2 + 512*C*D1*Ddd*f**2*r*s - 400*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 376*C*D1*Ddd*f**2*s + 196*C*D1*Ddd*f**2 + 816*C*Dd**2*f**2*r**2 + 1536*C*Dd**2*f**2*r*s - 1200*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1128*C*Dd**2*f**2*s + 392*C*Dd**2*f**2 + 70*D1**2*K*bdd1*f*r**2 + 140*D1**2*K*bdd1*f*r*s - 140*D1**2*K*bdd1*f*r + 70*D1**2*K*bdd1*f*s**2 - 140*D1**2*K*bdd1*f*s + 70*D1**2*K*bdd1*f + 14*D1**2*bd1**2*(-K*(3*r**2 + 18*r*s - 8*r + 15*s**2 - 16*s + 3) + f*(15*r**2 + 6*r*(4*s - 3) + 9*s**2 - 14*s + 4) + 6*r*s - 2*r + 6*s**2 - 6*s + 1) - 21*D1**2*bd2*f*r**2 - 42*D1**2*bd2*f*r*s + 42*D1**2*bd2*f*r - 21*D1**2*bd2*f*s**2 + 42*D1**2*bd2*f*s - 21*D1**2*bd2*f + 70*D1**2*bd2*fd*r**2 + 140*D1**2*bd2*fd*r*s - 70*D1**2*bd2*fd*r + 70*D1**2*bd2*fd*s**2 - 70*D1**2*bd2*fd*s + 12*D1**2*bdd1*f*r**2 + 96*D1**2*bdd1*f*r*s - 48*D1**2*bdd1*f*r + 84*D1**2*bdd1*f*s**2 - 84*D1**2*bdd1*f*s + 42*D1**2*bdd1*f + 28*D1**2*bdd1*g2*r**2 + 168*D1**2*bdd1*g2*r*s - 84*D1**2*bdd1*g2*r + 140*D1**2*bdd1*g2*s**2 - 140*D1**2*bdd1*g2*s + 70*D1**2*bdd1*g2 + 35*D1**2*bdd2*f*r**2 + 70*D1**2*bdd2*f*r*s - 70*D1**2*bdd2*f*r + 35*D1**2*bdd2*f*s**2 - 70*D1**2*bdd2*f*s + 35*D1**2*bdd2*f + 28*D1**2*f*fd*r**2 + 64*D1**2*f*fd*r*s - 28*D1**2*f*fd*r + 36*D1**2*f*fd*s**2 - 32*D1**2*f*fd*s + 14*D1**2*f*fd - 68*D1**2*f*fdd*r**2 - 128*D1**2*f*fdd*r*s + 68*D1**2*f*fdd*r - 60*D1**2*f*fdd*s**2 + 64*D1**2*f*fdd*s - 34*D1**2*f*fdd + 42*D1**2*f*gd2*r**2 + 84*D1**2*f*gd2*r*s - 84*D1**2*f*gd2*r + 42*D1**2*f*gd2*s**2 - 84*D1**2*f*gd2*s + 42*D1**2*f*gd2 - 70*D1**2*f*gdd2*r**2 - 140*D1**2*f*gdd2*r*s + 140*D1**2*f*gdd2*r - 70*D1**2*f*gdd2*s**2 + 140*D1**2*f*gdd2*s - 70*D1**2*f*gdd2 - 68*D1**2*fd**2*r**2 - 128*D1**2*fd**2*r*s + 68*D1**2*fd**2*r - 60*D1**2*fd**2*s**2 + 64*D1**2*fd**2*s + 42*D1**2*fd*g2*r**2 + 84*D1**2*fd*g2*r*s + 42*D1**2*fd*g2*s**2 - 140*D1**2*fd*gd2*r**2 - 280*D1**2*fd*gd2*r*s + 140*D1**2*fd*gd2*r - 140*D1**2*fd*gd2*s**2 + 140*D1**2*fd*gd2*s - 70*D1**2*fdd*g2*r**2 - 140*D1**2*fdd*g2*r*s - 70*D1**2*fdd*g2*s**2 + 280*D1*Dd*bd2*f*r**2 + 560*D1*Dd*bd2*f*r*s - 490*D1*Dd*bd2*f*r + 280*D1*Dd*bd2*f*s**2 - 490*D1*Dd*bd2*f*s + 210*D1*Dd*bd2*f + 56*D1*Dd*f**2*r**2 + 128*D1*Dd*f**2*r*s - 88*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 100*D1*Dd*f**2*s + 46*D1*Dd*f**2 - 544*D1*Dd*f*fd*r**2 - 1024*D1*Dd*f*fd*r*s + 672*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 632*D1*Dd*f*fd*s - 200*D1*Dd*f*fd + 168*D1*Dd*f*g2*r**2 + 336*D1*Dd*f*g2*r*s - 252*D1*Dd*f*g2*r + 168*D1*Dd*f*g2*s**2 - 252*D1*Dd*f*g2*s + 126*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*r**2 - 1120*D1*Dd*f*gd2*r*s + 980*D1*Dd*f*gd2*r - 560*D1*Dd*f*gd2*s**2 + 980*D1*Dd*f*gd2*s - 420*D1*Dd*f*gd2 - 560*D1*Dd*fd*g2*r**2 - 1120*D1*Dd*fd*g2*r*s + 420*D1*Dd*fd*g2*r - 560*D1*Dd*fd*g2*s**2 + 420*D1*Dd*fd*g2*s - 136*D1*Ddd*f**2*r**2 - 256*D1*Ddd*f**2*r*s + 200*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 188*D1*Ddd*f**2*s - 98*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*r**2 - 560*D1*Ddd*f*g2*r*s + 420*D1*Ddd*f*g2*r - 280*D1*Ddd*f*g2*s**2 + 420*D1*Ddd*f*g2*s - 210*D1*Ddd*f*g2 + D1*bd1*(-14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*f*(10*C*(2*r**2 + 12*r*s - 6*r + 10*s**2 - 10*s + 5) - 42*K*(r + s - 1)**2 - 38*r**2 - 108*r*s + 82*r - 70*s**2 + 84*s - 49) - 4*D1*(fd*(6*C*(2*r**2 + r*(12*s - 5) + 10*s**2 - 11*s + 3) - 35*K*s**2 + 35*K*s - r**2*(35*K + 6) + r*(-70*K*s + 35*K - 48*s + 18) - 42*s**2 + 45*s - 12) + 7*g2*(2*r**2 + 12*r*s - 6*r + 10*s**2 - 10*s + 5) - 7*gd2*(2*r**2 + r*(12*s - 5) + 10*s**2 - 11*s + 3)) - 4*Dd*f*(6*C*(8*r**2 + r*(48*s - 22) + 40*s**2 - 42*s + 11) - 35*K*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 24*r**2 - 192*r*s + 84*r - 168*s**2 + 174*s - 45) + 28*Dd*g2*(8*r**2 + r*(48*s - 22) + 40*s**2 - 42*s + 11)) - 408*Dd**2*f**2*r**2 - 768*Dd**2*f**2*r*s + 600*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 564*Dd**2*f**2*s - 196*Dd**2*f**2 - 840*Dd**2*f*g2*r**2 - 1680*Dd**2*f*g2*r*s + 1260*Dd**2*f*g2*r - 840*Dd**2*f*g2*s**2 + 1260*Dd**2*f*g2*s - 420*Dd**2*f*g2 + 7*b2*(-D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 3*D1**2*fd*r**2 - 6*D1**2*fd*r*s - 3*D1**2*fd*s**2 + 5*D1**2*fdd*r**2 + 10*D1**2*fdd*r*s + 5*D1**2*fdd*s**2 - 12*D1*Dd*f*r**2 - 24*D1*Dd*f*r*s + 18*D1*Dd*f*r - 12*D1*Dd*f*s**2 + 18*D1*Dd*f*s - 9*D1*Dd*f + 40*D1*Dd*fd*r**2 + 80*D1*Dd*fd*r*s - 30*D1*Dd*fd*r + 40*D1*Dd*fd*s**2 - 30*D1*Dd*fd*s + 20*D1*Ddd*f*r**2 + 40*D1*Ddd*f*r*s - 30*D1*Ddd*f*r + 20*D1*Ddd*f*s**2 - 30*D1*Ddd*f*s + 15*D1*Ddd*f + 2*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 60*Dd**2*f*r**2 + 120*Dd**2*f*r*s - 90*Dd**2*f*r + 60*Dd**2*f*s**2 - 90*Dd**2*f*s + 30*Dd**2*f)))/(21*d**2*k3**3) + D1**2*Pk2*Pkd3*k1**2*st**2*(D1*f*(D1*bd1**2*s*(3*f + 1)*(2*r + 2*s - 1) + D1*bd1*(-f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + D1*bdd1*f*s*(r + s) + Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + 2*b1**3*(D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r - 8*s**2 + 8*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(-2*D1**2*bdd1*f*(3*r*s - r + 3*s**2 - 3*s + 1) - 6*D1**2*f*fd*r*s + 3*D1**2*f*fd*r - 6*D1**2*f*fd*s**2 + 9*D1**2*f*fd*s - 3*D1**2*f*fd + 6*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 9*D1**2*f*fdd*s + 3*D1**2*f*fdd + 6*D1**2*fd**2*r*s - 3*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 9*D1**2*fd**2*s + 3*D1**2*fd**2 - 9*D1**2*fd*r*s + 9*D1**2*fd*r - 9*D1**2*fd*s**2 + 18*D1**2*fd*s - 9*D1**2*fd + D1**2*fdd*r*s - D1**2*fdd*r + D1**2*fdd*s**2 - 2*D1**2*fdd*s + D1**2*fdd - 12*D1*Dd*f**2*r*s + 3*D1*Dd*f**2*r - 12*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 48*D1*Dd*f*fd*r*s - 18*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 15*D1*Dd*f*fd - 36*D1*Dd*f*r*s + 9*D1*Dd*f*r - 36*D1*Dd*f*s**2 + 36*D1*Dd*f*s - 9*D1*Dd*f + 8*D1*Dd*fd*r*s - 5*D1*Dd*fd*r + 8*D1*Dd*fd*s**2 - 12*D1*Dd*fd*s + 4*D1*Dd*fd + 12*D1*Ddd*f**2*r*s - 3*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 4*D1*Ddd*f*r*s - D1*Ddd*f*r + 4*D1*Ddd*f*s**2 - 4*D1*Ddd*f*s + D1*Ddd*f + 2*D1*bd1*(D1*(f*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + fd*(-6*r*s + r - 6*s**2 + 6*s - 1)) + Dd*f*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) + 36*Dd**2*f**2*r*s - 9*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 6*Dd**2*f**2 + 12*Dd**2*f*r*s - 3*Dd**2*f*r + 12*Dd**2*f*s**2 - 12*Dd**2*f*s + 2*Dd**2*f) + b1*(-2*D1**2*bd1**2*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*(3*bdd1*f**2*s*(2*r + 2*s - 1) + f*(bdd1*s*(2*r + 2*s - 1) - fd*(2*s - 1)*(r + s - 1) + fdd*(2*s - 1)*(r + s - 1)) + fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-3*f*s*(f + 3)*(2*r + 2*s - 1) + fd*(3*f*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + 4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(3*f + 1)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*f*(Dd*(f*(-4*r*s + r - 4*s**2 + 4*s - 1) + fd*(16*r*s - 6*r + 16*s**2 - 20*s + 5)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k2**2*k3) - 2*D1**2*Pk2*Pkd3*k1**2*(6*D1**2*bd1**2*f*(-2*r*s + r - s*(2*s - 2)) - D1*b1*(7*D1*bd1**2*(f + 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*D1*bdd1*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + bd1*(D1*(-5*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 6*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + 12*Dd*f*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 7*b1**3*(D1**2*s*(fd - fdd)*(r + s - 1) + D1*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(-8*r*s + r - 8*s**2 + 8*s - 1) + 8*r*s - 2*r + 8*s**2 - 8*s + 2) - D1*Ddd*(f + 1)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(f + 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-7*D1**2*bdd1*(f + 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 5*D1**2*fd*r*s + 5*D1**2*fd*s**2 - 5*D1**2*fd*s - 6*D1**2*fdd*r*s - 6*D1**2*fdd*s**2 + 6*D1**2*fdd*s + 20*D1*Dd*f*r*s - 5*D1*Dd*f*r + 20*D1*Dd*f*s**2 - 20*D1*Dd*f*s + 5*D1*Dd*f - 48*D1*Dd*fd*r*s + 6*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 + 48*D1*Dd*fd*s - 6*D1*Dd*fd - 24*D1*Ddd*f*r*s + 6*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 24*D1*Ddd*f*s - 6*D1*Ddd*f + 7*D1*bd1*(D1*(f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fd*(-6*r*s + r - 6*s**2 + 6*s - 1) + 6*r*s - 2*r + 6*s**2 - 6*s + 2) - Dd*(f + 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 72*Dd**2*f*r*s + 18*Dd**2*f*r - 72*Dd**2*f*s**2 + 72*Dd**2*f*s - 12*Dd**2*f))/(21*d**2*k2**2*k3) - 5*D1**2*Pk2*Pkd3*k2**6*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 66*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(33*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - fd*(2*C - 1)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 33*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(2*C*f + 33*K*b1 - f - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*C*f + 33*K*b1 - f - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(154*d**2*k3**7) + 9*D1**2*Pk2*Pkd3*k2**6*st**4*(-2*D1**2*K*b1**2*fd*r**2 - 4*D1**2*K*b1**2*fd*r*s - 2*D1**2*K*b1**2*fd*s**2 + D1**2*K*b1**2*fdd*r**2 + 2*D1**2*K*b1**2*fdd*r*s + D1**2*K*b1**2*fdd*s**2 + 2*D1**2*K*b1*f*fd*r**2 + 4*D1**2*K*b1*f*fd*r*s - 2*D1**2*K*b1*f*fd*r + 2*D1**2*K*b1*f*fd*s**2 - 2*D1**2*K*b1*f*fd*s + D1**2*K*b1*f*fd + 2*D1**2*K*bd1**2*f*(r + s - 1)**2 + 4*D1**2*b1*f*gd2*r**2 + 8*D1**2*b1*f*gd2*r*s - 8*D1**2*b1*f*gd2*r + 4*D1**2*b1*f*gd2*s**2 - 8*D1**2*b1*f*gd2*s + 4*D1**2*b1*f*gd2 - 2*D1**2*b1*f*gdd2*r**2 - 4*D1**2*b1*f*gdd2*r*s + 4*D1**2*b1*f*gdd2*r - 2*D1**2*b1*f*gdd2*s**2 + 4*D1**2*b1*f*gdd2*s - 2*D1**2*b1*f*gdd2 + 4*D1**2*b1*fd*g2*r**2 + 8*D1**2*b1*fd*g2*r*s + 4*D1**2*b1*fd*g2*s**2 - 4*D1**2*b1*fd*gd2*r**2 - 8*D1**2*b1*fd*gd2*r*s + 4*D1**2*b1*fd*gd2*r - 4*D1**2*b1*fd*gd2*s**2 + 4*D1**2*b1*fd*gd2*s - 2*D1**2*b1*fdd*g2*r**2 - 4*D1**2*b1*fdd*g2*r*s - 2*D1**2*b1*fdd*g2*s**2 - 2*D1**2*bdd1*f*(-K*b1 + g2)*(r + s - 1)**2 - 2*D1**2*f**2*gd2*r**2 - 4*D1**2*f**2*gd2*r*s + 4*D1**2*f**2*gd2*r - 2*D1**2*f**2*gd2*s**2 + 4*D1**2*f**2*gd2*s - 2*D1**2*f**2*gd2 - 4*D1**2*f*fd*g2*r**2 - 8*D1**2*f*fd*g2*r*s + 4*D1**2*f*fd*g2*r - 4*D1**2*f*fd*g2*s**2 + 4*D1**2*f*fd*g2*s - 2*D1**2*f*fd*g2 - 8*D1*Dd*K*b1**2*f*r**2 - 16*D1*Dd*K*b1**2*f*r*s + 12*D1*Dd*K*b1**2*f*r - 8*D1*Dd*K*b1**2*f*s**2 + 12*D1*Dd*K*b1**2*f*s - 6*D1*Dd*K*b1**2*f + 8*D1*Dd*K*b1**2*fd*r**2 + 16*D1*Dd*K*b1**2*fd*r*s - 6*D1*Dd*K*b1**2*fd*r + 8*D1*Dd*K*b1**2*fd*s**2 - 6*D1*Dd*K*b1**2*fd*s + 4*D1*Dd*K*b1*f**2*r**2 + 8*D1*Dd*K*b1*f**2*r*s - 6*D1*Dd*K*b1*f**2*r + 4*D1*Dd*K*b1*f**2*s**2 - 6*D1*Dd*K*b1*f**2*s + 3*D1*Dd*K*b1*f**2 + 16*D1*Dd*b1*f*g2*r**2 + 32*D1*Dd*b1*f*g2*r*s - 24*D1*Dd*b1*f*g2*r + 16*D1*Dd*b1*f*g2*s**2 - 24*D1*Dd*b1*f*g2*s + 12*D1*Dd*b1*f*g2 - 16*D1*Dd*b1*f*gd2*r**2 - 32*D1*Dd*b1*f*gd2*r*s + 28*D1*Dd*b1*f*gd2*r - 16*D1*Dd*b1*f*gd2*s**2 + 28*D1*Dd*b1*f*gd2*s - 12*D1*Dd*b1*f*gd2 - 16*D1*Dd*b1*fd*g2*r**2 - 32*D1*Dd*b1*fd*g2*r*s + 12*D1*Dd*b1*fd*g2*r - 16*D1*Dd*b1*fd*g2*s**2 + 12*D1*Dd*b1*fd*g2*s - 8*D1*Dd*f**2*g2*r**2 - 16*D1*Dd*f**2*g2*r*s + 12*D1*Dd*f**2*g2*r - 8*D1*Dd*f**2*g2*s**2 + 12*D1*Dd*f**2*g2*s - 6*D1*Dd*f**2*g2 + 4*D1*Ddd*K*b1**2*f*r**2 + 8*D1*Ddd*K*b1**2*f*r*s - 6*D1*Ddd*K*b1**2*f*r + 4*D1*Ddd*K*b1**2*f*s**2 - 6*D1*Ddd*K*b1**2*f*s + 3*D1*Ddd*K*b1**2*f - 8*D1*Ddd*b1*f*g2*r**2 - 16*D1*Ddd*b1*f*g2*r*s + 12*D1*Ddd*b1*f*g2*r - 8*D1*Ddd*b1*f*g2*s**2 + 12*D1*Ddd*b1*f*g2*s - 6*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(K*f**2*(r + s - 1) + 4*f*(r + s - 1)*(-K*b1 + g2 - gd2) - 4*fd*(r + s)*(-K*b1 + g2)) - 4*Dd*f*(-K*b1 + g2)*(4*r + 4*s - 3))*(r + s - 1) + 12*Dd**2*K*b1**2*f*r**2 + 24*Dd**2*K*b1**2*f*r*s - 18*Dd**2*K*b1**2*f*r + 12*Dd**2*K*b1**2*f*s**2 - 18*Dd**2*K*b1**2*f*s + 6*Dd**2*K*b1**2*f - 24*Dd**2*b1*f*g2*r**2 - 48*Dd**2*b1*f*g2*r*s + 36*Dd**2*b1*f*g2*r - 24*Dd**2*b1*f*g2*s**2 + 36*Dd**2*b1*f*g2*s - 12*Dd**2*b1*f*g2)/(7*d**2*k3**7) + 5*D1**2*Pk2*Pkd3*k2**4*st**6*(108*C*D1**2*f**2*fd*r**2 + 168*C*D1**2*f**2*fd*r*s - 128*C*D1**2*f**2*fd*r + 60*C*D1**2*f**2*fd*s**2 - 96*C*D1**2*f**2*fd*s + 56*C*D1**2*f**2*fd - 54*C*D1**2*f**2*fdd*r**2 - 84*C*D1**2*f**2*fdd*r*s + 64*C*D1**2*f**2*fdd*r - 30*C*D1**2*f**2*fdd*s**2 + 48*C*D1**2*f**2*fdd*s - 28*C*D1**2*f**2*fdd - 108*C*D1**2*f*fd**2*r**2 - 168*C*D1**2*f*fd**2*r*s + 128*C*D1**2*f*fd**2*r - 60*C*D1**2*f*fd**2*s**2 + 96*C*D1**2*f*fd**2*s - 28*C*D1**2*f*fd**2 + 144*C*D1*Dd*f**3*r**2 + 224*C*D1*Dd*f**3*r*s - 200*C*D1*Dd*f**3*r + 80*C*D1*Dd*f**3*s**2 - 152*C*D1*Dd*f**3*s + 92*C*D1*Dd*f**3 - 432*C*D1*Dd*f**2*fd*r**2 - 672*C*D1*Dd*f**2*fd*r*s + 556*C*D1*Dd*f**2*fd*r - 240*C*D1*Dd*f**2*fd*s**2 + 420*C*D1*Dd*f**2*fd*s - 176*C*D1*Dd*f**2*fd - 72*C*D1*Ddd*f**3*r**2 - 112*C*D1*Ddd*f**3*r*s + 100*C*D1*Ddd*f**3*r - 40*C*D1*Ddd*f**3*s**2 + 76*C*D1*Ddd*f**3*s - 46*C*D1*Ddd*f**3 - 216*C*Dd**2*f**3*r**2 - 336*C*Dd**2*f**3*r*s + 300*C*Dd**2*f**3*r - 120*C*Dd**2*f**3*s**2 + 228*C*Dd**2*f**3*s - 92*C*Dd**2*f**3 + 1188*D1**2*K*b1*f*fd*r**2 + 1848*D1**2*K*b1*f*fd*r*s - 924*D1**2*K*b1*f*fd*r + 660*D1**2*K*b1*f*fd*s**2 - 660*D1**2*K*b1*f*fd*s + 330*D1**2*K*b1*f*fd - 594*D1**2*K*b1*f*fdd*r**2 - 924*D1**2*K*b1*f*fdd*r*s + 462*D1**2*K*b1*f*fdd*r - 330*D1**2*K*b1*f*fdd*s**2 + 330*D1**2*K*b1*f*fdd*s - 165*D1**2*K*b1*f*fdd - 594*D1**2*K*b1*fd**2*r**2 - 924*D1**2*K*b1*fd**2*r*s + 462*D1**2*K*b1*fd**2*r - 330*D1**2*K*b1*fd**2*s**2 + 330*D1**2*K*b1*fd**2*s - 297*D1**2*K*bdd1*f**2*r**2 - 462*D1**2*K*bdd1*f**2*r*s + 594*D1**2*K*bdd1*f**2*r - 165*D1**2*K*bdd1*f**2*s**2 + 462*D1**2*K*bdd1*f**2*s - 297*D1**2*K*bdd1*f**2 - 198*D1**2*b1*f**2*fd*r**2 - 198*D1**2*b1*f**2*fd*r*s + 198*D1**2*b1*f**2*fd*r + 66*D1**2*b1*f**2*fd*s - 66*D1**2*b1*f**2*fd + 198*D1**2*b1*f**2*fdd*r**2 + 198*D1**2*b1*f**2*fdd*r*s - 198*D1**2*b1*f**2*fdd*r - 66*D1**2*b1*f**2*fdd*s + 66*D1**2*b1*f**2*fdd + 396*D1**2*b1*f*fd**2*r**2 + 396*D1**2*b1*f*fd**2*r*s - 396*D1**2*b1*f*fd**2*r - 132*D1**2*b1*f*fd**2*s + 66*D1**2*b1*f*fd**2 - 264*D1**2*b1*f*fd*r**2 - 264*D1**2*b1*f*fd*r*s + 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fdd*r**2 + 132*D1**2*b1*f*fdd*r*s - 66*D1**2*b1*f*fdd*r + 132*D1**2*b1*fd**2*r**2 + 132*D1**2*b1*fd**2*r*s - 66*D1**2*b1*fd**2*r + 660*D1**2*b2*f*fd*r**2 + 1320*D1**2*b2*f*fd*r*s - 660*D1**2*b2*f*fd*r + 660*D1**2*b2*f*fd*s**2 - 660*D1**2*b2*f*fd*s + 330*D1**2*b2*f*fd - 330*D1**2*b2*f*fdd*r**2 - 660*D1**2*b2*f*fdd*r*s + 330*D1**2*b2*f*fdd*r - 330*D1**2*b2*f*fdd*s**2 + 330*D1**2*b2*f*fdd*s - 165*D1**2*b2*f*fdd - 330*D1**2*b2*fd**2*r**2 - 660*D1**2*b2*fd**2*r*s + 330*D1**2*b2*fd**2*r - 330*D1**2*b2*fd**2*s**2 + 330*D1**2*b2*fd**2*s + 66*D1**2*bdd1*f**3*r**2 + 66*D1**2*bdd1*f**3*r*s - 132*D1**2*bdd1*f**3*r - 66*D1**2*bdd1*f**3*s + 66*D1**2*bdd1*f**3 + 66*D1**2*bdd1*f**2*r**2 + 66*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*r - 66*D1**2*bdd1*f**2*s + 66*D1**2*bdd1*f**2 - 165*D1**2*bdd2*f**2*r**2 - 330*D1**2*bdd2*f**2*r*s + 330*D1**2*bdd2*f**2*r - 165*D1**2*bdd2*f**2*s**2 + 330*D1**2*bdd2*f**2*s - 165*D1**2*bdd2*f**2 - 66*D1**2*f**2*fd*r**2 - 96*D1**2*f**2*fd*r*s + 76*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 52*D1**2*f**2*fd*s - 32*D1**2*f**2*fd + 33*D1**2*f**2*fdd*r**2 + 48*D1**2*f**2*fdd*r*s - 38*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 26*D1**2*f**2*fdd*s + 16*D1**2*f**2*fdd - 1188*D1**2*f**2*gd2*r**2 - 1848*D1**2*f**2*gd2*r*s + 2376*D1**2*f**2*gd2*r - 660*D1**2*f**2*gd2*s**2 + 1848*D1**2*f**2*gd2*s - 1188*D1**2*f**2*gd2 + 594*D1**2*f**2*gdd2*r**2 + 924*D1**2*f**2*gdd2*r*s - 1188*D1**2*f**2*gdd2*r + 330*D1**2*f**2*gdd2*s**2 - 924*D1**2*f**2*gdd2*s + 594*D1**2*f**2*gdd2 + 66*D1**2*f*fd**2*r**2 + 96*D1**2*f*fd**2*r*s - 76*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 52*D1**2*f*fd**2*s + 16*D1**2*f*fd**2 - 2376*D1**2*f*fd*g2*r**2 - 3696*D1**2*f*fd*g2*r*s + 1848*D1**2*f*fd*g2*r - 1320*D1**2*f*fd*g2*s**2 + 1320*D1**2*f*fd*g2*s - 660*D1**2*f*fd*g2 + 2376*D1**2*f*fd*gd2*r**2 + 3696*D1**2*f*fd*gd2*r*s - 3300*D1**2*f*fd*gd2*r + 1320*D1**2*f*fd*gd2*s**2 - 2508*D1**2*f*fd*gd2*s + 924*D1**2*f*fd*gd2 + 1188*D1**2*f*fdd*g2*r**2 + 1848*D1**2*f*fdd*g2*r*s - 924*D1**2*f*fdd*g2*r + 660*D1**2*f*fdd*g2*s**2 - 660*D1**2*f*fdd*g2*s + 330*D1**2*f*fdd*g2 + 1188*D1**2*fd**2*g2*r**2 + 1848*D1**2*fd**2*g2*r*s - 924*D1**2*fd**2*g2*r + 660*D1**2*fd**2*g2*s**2 - 660*D1**2*fd**2*g2*s + 2376*D1*Dd*K*b1*f**2*r**2 + 3696*D1*Dd*K*b1*f**2*r*s - 3300*D1*Dd*K*b1*f**2*r + 1320*D1*Dd*K*b1*f**2*s**2 - 2508*D1*Dd*K*b1*f**2*s + 1518*D1*Dd*K*b1*f**2 - 4752*D1*Dd*K*b1*f*fd*r**2 - 7392*D1*Dd*K*b1*f*fd*r*s + 5148*D1*Dd*K*b1*f*fd*r - 2640*D1*Dd*K*b1*f*fd*s**2 + 3828*D1*Dd*K*b1*f*fd*s - 1254*D1*Dd*K*b1*f*fd - 264*D1*Dd*b1*f**3*r**2 - 264*D1*Dd*b1*f**3*r*s + 330*D1*Dd*b1*f**3*r + 132*D1*Dd*b1*f**3*s - 132*D1*Dd*b1*f**3 + 1584*D1*Dd*b1*f**2*fd*r**2 + 1584*D1*Dd*b1*f**2*fd*r*s - 1782*D1*Dd*b1*f**2*fd*r - 660*D1*Dd*b1*f**2*fd*s + 462*D1*Dd*b1*f**2*fd - 528*D1*Dd*b1*f**2*r**2 - 528*D1*Dd*b1*f**2*r*s + 660*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s - 264*D1*Dd*b1*f**2 + 1056*D1*Dd*b1*f*fd*r**2 + 1056*D1*Dd*b1*f*fd*r*s - 924*D1*Dd*b1*f*fd*r - 264*D1*Dd*b1*f*fd*s + 132*D1*Dd*b1*f*fd + 1320*D1*Dd*b2*f**2*r**2 + 2640*D1*Dd*b2*f**2*r*s - 1980*D1*Dd*b2*f**2*r + 1320*D1*Dd*b2*f**2*s**2 - 1980*D1*Dd*b2*f**2*s + 990*D1*Dd*b2*f**2 - 2640*D1*Dd*b2*f*fd*r**2 - 5280*D1*Dd*b2*f*fd*r*s + 3300*D1*Dd*b2*f*fd*r - 2640*D1*Dd*b2*f*fd*s**2 + 3300*D1*Dd*b2*f*fd*s - 990*D1*Dd*b2*f*fd - 88*D1*Dd*f**3*r**2 - 128*D1*Dd*f**3*r*s + 120*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 84*D1*Dd*f**3*s - 54*D1*Dd*f**3 + 264*D1*Dd*f**2*fd*r**2 + 384*D1*Dd*f**2*fd*r*s - 332*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 230*D1*Dd*f**2*fd*s + 102*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*g2*r**2 - 7392*D1*Dd*f**2*g2*r*s + 6600*D1*Dd*f**2*g2*r - 2640*D1*Dd*f**2*g2*s**2 + 5016*D1*Dd*f**2*g2*s - 3036*D1*Dd*f**2*g2 + 4752*D1*Dd*f**2*gd2*r**2 + 7392*D1*Dd*f**2*gd2*r*s - 8052*D1*Dd*f**2*gd2*r + 2640*D1*Dd*f**2*gd2*s**2 - 6204*D1*Dd*f**2*gd2*s + 3300*D1*Dd*f**2*gd2 + 9504*D1*Dd*f*fd*g2*r**2 + 14784*D1*Dd*f*fd*g2*r*s - 10296*D1*Dd*f*fd*g2*r + 5280*D1*Dd*f*fd*g2*s**2 - 7656*D1*Dd*f*fd*g2*s + 2508*D1*Dd*f*fd*g2 - 1188*D1*Ddd*K*b1*f**2*r**2 - 1848*D1*Ddd*K*b1*f**2*r*s + 1650*D1*Ddd*K*b1*f**2*r - 660*D1*Ddd*K*b1*f**2*s**2 + 1254*D1*Ddd*K*b1*f**2*s - 759*D1*Ddd*K*b1*f**2 + 264*D1*Ddd*b1*f**3*r**2 + 264*D1*Ddd*b1*f**3*r*s - 330*D1*Ddd*b1*f**3*r - 132*D1*Ddd*b1*f**3*s + 132*D1*Ddd*b1*f**3 + 264*D1*Ddd*b1*f**2*r**2 + 264*D1*Ddd*b1*f**2*r*s - 330*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s + 132*D1*Ddd*b1*f**2 - 660*D1*Ddd*b2*f**2*r**2 - 1320*D1*Ddd*b2*f**2*r*s + 990*D1*Ddd*b2*f**2*r - 660*D1*Ddd*b2*f**2*s**2 + 990*D1*Ddd*b2*f**2*s - 495*D1*Ddd*b2*f**2 + 44*D1*Ddd*f**3*r**2 + 64*D1*Ddd*f**3*r*s - 60*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 42*D1*Ddd*f**3*s + 27*D1*Ddd*f**3 + 2376*D1*Ddd*f**2*g2*r**2 + 3696*D1*Ddd*f**2*g2*r*s - 3300*D1*Ddd*f**2*g2*r + 1320*D1*Ddd*f**2*g2*s**2 - 2508*D1*Ddd*f**2*g2*s + 1518*D1*Ddd*f**2*g2 - 66*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) - f*(fd*(6*r**2 + r*(6*s - 9) - 4*s + 3) + (r + s - 1)*(K*(9*r + 5*s - 9) - 2*r + 2)) + fd*(K*(18*r**2 + 28*r*s - 25*r + 10*s**2 - 19*s + 7) - 4*r**2 - 4*r*s + 5*r + 2*s - 1)) + Dd*f*(K*(36*r**2 + 56*r*s - 61*r + 20*s**2 - 47*s + 25) + f*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) - 8*r**2 - 8*r*s + 13*r + 6*s - 5)) + 330*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 3564*Dd**2*K*b1*f**2*r**2 - 5544*Dd**2*K*b1*f**2*r*s + 4950*Dd**2*K*b1*f**2*r - 1980*Dd**2*K*b1*f**2*s**2 + 3762*Dd**2*K*b1*f**2*s - 1518*Dd**2*K*b1*f**2 + 792*Dd**2*b1*f**3*r**2 + 792*Dd**2*b1*f**3*r*s - 990*Dd**2*b1*f**3*r - 396*Dd**2*b1*f**3*s + 264*Dd**2*b1*f**3 + 792*Dd**2*b1*f**2*r**2 + 792*Dd**2*b1*f**2*r*s - 990*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s + 264*Dd**2*b1*f**2 - 1980*Dd**2*b2*f**2*r**2 - 3960*Dd**2*b2*f**2*r*s + 2970*Dd**2*b2*f**2*r - 1980*Dd**2*b2*f**2*s**2 + 2970*Dd**2*b2*f**2*s - 990*Dd**2*b2*f**2 + 132*Dd**2*f**3*r**2 + 192*Dd**2*f**3*r*s - 180*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 126*Dd**2*f**3*s + 54*Dd**2*f**3 + 7128*Dd**2*f**2*g2*r**2 + 11088*Dd**2*f**2*g2*r*s - 9900*Dd**2*f**2*g2*r + 3960*Dd**2*f**2*g2*s**2 - 7524*Dd**2*f**2*g2*s + 3036*Dd**2*f**2*g2)/(1386*d**2*k3**5) + D1**2*Pk2*Pkd3*k2**4*st**4*(48*C*D1**2*f**2*fd*r**2 + 48*C*D1**2*f**2*fd*r*s - 48*C*D1**2*f**2*fd*r - 16*C*D1**2*f**2*fd*s + 16*C*D1**2*f**2*fd - 24*C*D1**2*f**2*fdd*r**2 - 24*C*D1**2*f**2*fdd*r*s + 24*C*D1**2*f**2*fdd*r + 8*C*D1**2*f**2*fdd*s - 8*C*D1**2*f**2*fdd - 48*C*D1**2*f*fd**2*r**2 - 48*C*D1**2*f*fd**2*r*s + 48*C*D1**2*f*fd**2*r + 16*C*D1**2*f*fd**2*s - 8*C*D1**2*f*fd**2 + 64*C*D1*Dd*f**3*r**2 + 64*C*D1*Dd*f**3*r*s - 80*C*D1*Dd*f**3*r - 32*C*D1*Dd*f**3*s + 32*C*D1*Dd*f**3 - 192*C*D1*Dd*f**2*fd*r**2 - 192*C*D1*Dd*f**2*fd*r*s + 216*C*D1*Dd*f**2*fd*r + 80*C*D1*Dd*f**2*fd*s - 56*C*D1*Dd*f**2*fd - 32*C*D1*Ddd*f**3*r**2 - 32*C*D1*Ddd*f**3*r*s + 40*C*D1*Ddd*f**3*r + 16*C*D1*Ddd*f**3*s - 16*C*D1*Ddd*f**3 - 96*C*Dd**2*f**3*r**2 - 96*C*Dd**2*f**3*r*s + 120*C*Dd**2*f**3*r + 48*C*Dd**2*f**3*s - 32*C*Dd**2*f**3 - 88*D1**2*K*bd1**2*f*r**2 - 176*D1**2*K*bd1**2*f*r*s + 286*D1**2*K*bd1**2*f*r - 88*D1**2*K*bd1**2*f*s**2 + 286*D1**2*K*bd1**2*f*s - 198*D1**2*K*bd1**2*f - 66*D1**2*K*bd1*f**2*r**2 - 44*D1**2*K*bd1*f**2*r*s + 132*D1**2*K*bd1*f**2*r + 22*D1**2*K*bd1*f**2*s**2 + 44*D1**2*K*bd1*f**2*s - 66*D1**2*K*bd1*f**2 - 220*D1**2*K*bd1*f*fd*r**2 - 616*D1**2*K*bd1*f*fd*r*s + 374*D1**2*K*bd1*f*fd*r - 396*D1**2*K*bd1*f*fd*s**2 + 506*D1**2*K*bd1*f*fd*s - 154*D1**2*K*bd1*f*fd - 55*D1**2*K*bdd1*f**2*r**2 - 154*D1**2*K*bdd1*f**2*r*s + 110*D1**2*K*bdd1*f**2*r - 99*D1**2*K*bdd1*f**2*s**2 + 154*D1**2*K*bdd1*f**2*s - 55*D1**2*K*bdd1*f**2 + 44*D1**2*bd1**2*f**2*r**2 + 44*D1**2*bd1**2*f**2*r*s - 66*D1**2*bd1**2*f**2*r - 22*D1**2*bd1**2*f**2*s + 22*D1**2*bd1**2*f**2 + 44*D1**2*bd1**2*f*r**2 + 44*D1**2*bd1**2*f*r*s - 66*D1**2*bd1**2*f*r - 22*D1**2*bd1**2*f*s + 22*D1**2*bd1**2*f - 110*D1**2*bd1*bd2*f*r**2 - 220*D1**2*bd1*bd2*f*r*s + 220*D1**2*bd1*bd2*f*r - 110*D1**2*bd1*bd2*f*s**2 + 220*D1**2*bd1*bd2*f*s - 110*D1**2*bd1*bd2*f + 22*D1**2*bd1*f**2*r**2 + 22*D1**2*bd1*f**2*r*s - 44*D1**2*bd1*f**2*r - 22*D1**2*bd1*f**2*s + 22*D1**2*bd1*f**2 - 176*D1**2*bd1*f*g2*r**2 - 352*D1**2*bd1*f*g2*r*s + 792*D1**2*bd1*f*g2*r - 176*D1**2*bd1*f*g2*s**2 + 792*D1**2*bd1*f*g2*s - 396*D1**2*bd1*f*g2 + 176*D1**2*bd1*f*gd2*r**2 + 352*D1**2*bd1*f*gd2*r*s - 572*D1**2*bd1*f*gd2*r + 176*D1**2*bd1*f*gd2*s**2 - 572*D1**2*bd1*f*gd2*s + 396*D1**2*bd1*f*gd2 + 176*D1**2*bd1*fd*g2*r**2 + 352*D1**2*bd1*fd*g2*r*s - 176*D1**2*bd1*fd*g2*r + 176*D1**2*bd1*fd*g2*s**2 - 176*D1**2*bd1*fd*g2*s - 55*D1**2*bd2*f**2*r**2 - 110*D1**2*bd2*f**2*r*s + 110*D1**2*bd2*f**2*r - 55*D1**2*bd2*f**2*s**2 + 110*D1**2*bd2*f**2*s - 55*D1**2*bd2*f**2 + 88*D1**2*bdd1*f*g2*r**2 + 176*D1**2*bdd1*f*g2*r*s - 396*D1**2*bdd1*f*g2*r + 88*D1**2*bdd1*f*g2*s**2 - 396*D1**2*bdd1*f*g2*s + 198*D1**2*bdd1*f*g2 - 24*D1**2*f**2*fd*r**2 - 24*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r + 8*D1**2*f**2*fd*s - 8*D1**2*f**2*fd + 12*D1**2*f**2*fdd*r**2 + 12*D1**2*f**2*fdd*r*s - 12*D1**2*f**2*fdd*r - 4*D1**2*f**2*fdd*s + 4*D1**2*f**2*fdd + 132*D1**2*f**2*gd2*r**2 + 88*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*r - 44*D1**2*f**2*gd2*s**2 - 88*D1**2*f**2*gd2*s + 132*D1**2*f**2*gd2 + 110*D1**2*f**2*gdd2*r**2 + 308*D1**2*f**2*gdd2*r*s - 220*D1**2*f**2*gdd2*r + 198*D1**2*f**2*gdd2*s**2 - 308*D1**2*f**2*gdd2*s + 110*D1**2*f**2*gdd2 + 24*D1**2*f*fd**2*r**2 + 24*D1**2*f*fd**2*r*s - 24*D1**2*f*fd**2*r - 8*D1**2*f*fd**2*s + 4*D1**2*f*fd**2 + 264*D1**2*f*fd*g2*r**2 + 176*D1**2*f*fd*g2*r*s - 88*D1**2*f*fd*g2*r - 88*D1**2*f*fd*g2*s**2 + 88*D1**2*f*fd*g2*s - 44*D1**2*f*fd*g2 + 440*D1**2*f*fd*gd2*r**2 + 1232*D1**2*f*fd*gd2*r*s - 748*D1**2*f*fd*gd2*r + 792*D1**2*f*fd*gd2*s**2 - 1012*D1**2*f*fd*gd2*s + 308*D1**2*f*fd*gd2 + 220*D1**2*f*fdd*g2*r**2 + 616*D1**2*f*fdd*g2*r*s - 308*D1**2*f*fdd*g2*r + 396*D1**2*f*fdd*g2*s**2 - 396*D1**2*f*fdd*g2*s + 198*D1**2*f*fdd*g2 + 220*D1**2*fd**2*g2*r**2 + 616*D1**2*fd**2*g2*r*s - 308*D1**2*fd**2*g2*r + 396*D1**2*fd**2*g2*s**2 - 396*D1**2*fd**2*g2*s - 440*D1*Dd*K*bd1*f**2*r**2 - 1232*D1*Dd*K*bd1*f**2*r*s + 814*D1*Dd*K*bd1*f**2*r - 792*D1*Dd*K*bd1*f**2*s**2 + 1122*D1*Dd*K*bd1*f**2*s - 374*D1*Dd*K*bd1*f**2 + 704*D1*Dd*bd1*f*g2*r**2 + 1408*D1*Dd*bd1*f*g2*r*s - 2112*D1*Dd*bd1*f*g2*r + 704*D1*Dd*bd1*f*g2*s**2 - 2112*D1*Dd*bd1*f*g2*s + 1188*D1*Dd*bd1*f*g2 - 32*D1*Dd*f**3*r**2 - 32*D1*Dd*f**3*r*s + 40*D1*Dd*f**3*r + 16*D1*Dd*f**3*s - 16*D1*Dd*f**3 + 96*D1*Dd*f**2*fd*r**2 + 96*D1*Dd*f**2*fd*r*s - 108*D1*Dd*f**2*fd*r - 40*D1*Dd*f**2*fd*s + 28*D1*Dd*f**2*fd + 528*D1*Dd*f**2*g2*r**2 + 352*D1*Dd*f**2*g2*r*s - 616*D1*Dd*f**2*g2*r - 176*D1*Dd*f**2*g2*s**2 - 88*D1*Dd*f**2*g2*s + 220*D1*Dd*f**2*g2 + 880*D1*Dd*f**2*gd2*r**2 + 2464*D1*Dd*f**2*gd2*r*s - 1628*D1*Dd*f**2*gd2*r + 1584*D1*Dd*f**2*gd2*s**2 - 2244*D1*Dd*f**2*gd2*s + 748*D1*Dd*f**2*gd2 + 1760*D1*Dd*f*fd*g2*r**2 + 4928*D1*Dd*f*fd*g2*r*s - 2728*D1*Dd*f*fd*g2*r + 3168*D1*Dd*f*fd*g2*s**2 - 3608*D1*Dd*f*fd*g2*s + 1012*D1*Dd*f*fd*g2 + 16*D1*Ddd*f**3*r**2 + 16*D1*Ddd*f**3*r*s - 20*D1*Ddd*f**3*r - 8*D1*Ddd*f**3*s + 8*D1*Ddd*f**3 + 440*D1*Ddd*f**2*g2*r**2 + 1232*D1*Ddd*f**2*g2*r*s - 748*D1*Ddd*f**2*g2*r + 792*D1*Ddd*f**2*g2*s**2 - 1012*D1*Ddd*f**2*g2*s + 418*D1*Ddd*f**2*g2 + 55*D1*b2*(2*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - f*(D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + 48*Dd**2*f**3*r**2 + 48*Dd**2*f**3*r*s - 60*Dd**2*f**3*r - 24*Dd**2*f**3*s + 16*Dd**2*f**3 + 1320*Dd**2*f**2*g2*r**2 + 3696*Dd**2*f**2*g2*r*s - 2244*Dd**2*f**2*g2*r + 2376*Dd**2*f**2*g2*s**2 - 3036*Dd**2*f**2*g2*s + 836*Dd**2*f**2*g2 - 11*b1**2*(D1**2*(-2*K*fd*(4*r**2 + 2*r*(4*s + 5) + 4*s**2 + 10*s - 5) + 2*f*(fd - fdd)*(2*r**2 + 2*r*(s - 1) - s + 1) + fd**2*(-4*r**2 - 4*r*(s - 1) + 2*s) + 4*fd*r*(r + s) + fdd*(K*(4*r**2 + 8*r*s + 10*r + 4*s**2 + 10*s - 5) - 2*r*(r + s))) + 2*D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) - f*(4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*r - 1)*(8*r + 8*s - 5) - 8*r**2 - 8*r*s + 10*r + 4*s - 4) + fd*(K*(16*r**2 + 32*r*s + 8*r + 16*s**2 + 8*s - 15) - 8*r**2 - 8*r*s + 5*r + 2*s)) + Ddd*f*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + 2*Dd**2*f*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) - 11*b1*(8*D1**2*K*bdd1*f*r**2 + 16*D1**2*K*bdd1*f*r*s - 26*D1**2*K*bdd1*f*r + 8*D1**2*K*bdd1*f*s**2 - 26*D1**2*K*bdd1*f*s + 13*D1**2*K*bdd1*f + 12*D1**2*K*f*fd*r**2 + 8*D1**2*K*f*fd*r*s - 4*D1**2*K*f*fd*r - 4*D1**2*K*f*fd*s**2 + 4*D1**2*K*f*fd*s - 2*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r**2 + 28*D1**2*K*f*fdd*r*s - 14*D1**2*K*f*fdd*r + 18*D1**2*K*f*fdd*s**2 - 18*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r**2 + 28*D1**2*K*fd**2*r*s - 14*D1**2*K*fd**2*r + 18*D1**2*K*fd**2*s**2 - 18*D1**2*K*fd**2*s - 10*D1**2*b2*fd*r**2 - 20*D1**2*b2*fd*r*s - 10*D1**2*b2*fd*s**2 + 5*D1**2*b2*fdd*r**2 + 10*D1**2*b2*fdd*r*s + 5*D1**2*b2*fdd*s**2 - 4*D1**2*bdd1*f**2*r**2 - 4*D1**2*bdd1*f**2*r*s + 6*D1**2*bdd1*f**2*r + 2*D1**2*bdd1*f**2*s - 2*D1**2*bdd1*f**2 - 4*D1**2*bdd1*f*r**2 - 4*D1**2*bdd1*f*r*s + 6*D1**2*bdd1*f*r + 2*D1**2*bdd1*f*s - 2*D1**2*bdd1*f + 5*D1**2*bdd2*f*r**2 + 10*D1**2*bdd2*f*r*s - 10*D1**2*bdd2*f*r + 5*D1**2*bdd2*f*s**2 - 10*D1**2*bdd2*f*s + 5*D1**2*bdd2*f - 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r + 16*D1**2*f*gd2*r**2 + 32*D1**2*f*gd2*r*s - 32*D1**2*f*gd2*r + 16*D1**2*f*gd2*s**2 - 32*D1**2*f*gd2*s + 16*D1**2*f*gd2 - 8*D1**2*f*gdd2*r**2 - 16*D1**2*f*gdd2*r*s + 16*D1**2*f*gdd2*r - 8*D1**2*f*gdd2*s**2 + 16*D1**2*f*gdd2*s - 8*D1**2*f*gdd2 + 16*D1**2*fd*g2*r**2 + 32*D1**2*fd*g2*r*s + 40*D1**2*fd*g2*r + 16*D1**2*fd*g2*s**2 + 40*D1**2*fd*g2*s - 20*D1**2*fd*g2 - 16*D1**2*fd*gd2*r**2 - 32*D1**2*fd*gd2*r*s - 4*D1**2*fd*gd2*r - 16*D1**2*fd*gd2*s**2 - 4*D1**2*fd*gd2*s + 20*D1**2*fd*gd2 - 8*D1**2*fdd*g2*r**2 - 16*D1**2*fdd*g2*r*s - 20*D1**2*fdd*g2*r - 8*D1**2*fdd*g2*s**2 - 20*D1**2*fdd*g2*s + 10*D1**2*fdd*g2 + 24*D1*Dd*K*f**2*r**2 + 16*D1*Dd*K*f**2*r*s - 28*D1*Dd*K*f**2*r - 8*D1*Dd*K*f**2*s**2 - 4*D1*Dd*K*f**2*s + 10*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r**2 + 224*D1*Dd*K*f*fd*r*s - 124*D1*Dd*K*f*fd*r + 144*D1*Dd*K*f*fd*s**2 - 164*D1*Dd*K*f*fd*s + 46*D1*Dd*K*f*fd - 40*D1*Dd*b2*f*r**2 - 80*D1*Dd*b2*f*r*s + 60*D1*Dd*b2*f*r - 40*D1*Dd*b2*f*s**2 + 60*D1*Dd*b2*f*s - 30*D1*Dd*b2*f + 40*D1*Dd*b2*fd*r**2 + 80*D1*Dd*b2*fd*r*s - 30*D1*Dd*b2*fd*r + 40*D1*Dd*b2*fd*s**2 - 30*D1*Dd*b2*fd*s - 8*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 10*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 64*D1*Dd*f*g2*r**2 + 128*D1*Dd*f*g2*r*s - 96*D1*Dd*f*g2*r + 64*D1*Dd*f*g2*s**2 - 96*D1*Dd*f*g2*s + 48*D1*Dd*f*g2 - 64*D1*Dd*f*gd2*r**2 - 128*D1*Dd*f*gd2*r*s + 112*D1*Dd*f*gd2*r - 64*D1*Dd*f*gd2*s**2 + 112*D1*Dd*f*gd2*s - 48*D1*Dd*f*gd2 - 64*D1*Dd*fd*g2*r**2 - 128*D1*Dd*fd*g2*r*s - 32*D1*Dd*fd*g2*r - 64*D1*Dd*fd*g2*s**2 - 32*D1*Dd*fd*g2*s + 60*D1*Dd*fd*g2 + 20*D1*Ddd*K*f**2*r**2 + 56*D1*Ddd*K*f**2*r*s - 34*D1*Ddd*K*f**2*r + 36*D1*Ddd*K*f**2*s**2 - 46*D1*Ddd*K*f**2*s + 19*D1*Ddd*K*f**2 + 20*D1*Ddd*b2*f*r**2 + 40*D1*Ddd*b2*f*r*s - 30*D1*Ddd*b2*f*r + 20*D1*Ddd*b2*f*s**2 - 30*D1*Ddd*b2*f*s + 15*D1*Ddd*b2*f - 32*D1*Ddd*f*g2*r**2 - 64*D1*Ddd*f*g2*r*s + 48*D1*Ddd*f*g2*r - 32*D1*Ddd*f*g2*s**2 + 48*D1*Ddd*f*g2*s - 24*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*(2*r - 1)*(r + s - 1) - f*(K*(8*r**2 + 16*r*s - 26*r + 8*s**2 - 26*s + 13) + fd*(2*r - 1)*(4*r + 4*s - 3) + (2 - 4*r)*(r + s - 1)) + fd*(K*(8*r**2 + r*(16*s - 3) + 8*s**2 - 3*s - 5) - 4*r**2 + r*(3 - 4*s) + s)) + Dd*f*(K*(32*r**2 + 64*r*s - 76*r + 32*s**2 - 76*s + 39) - f*(2*r - 1)*(8*r + 8*s - 7) - (2*r - 1)*(8*r + 8*s - 7))) - 10*D1*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 60*Dd**2*K*f**2*r**2 + 168*Dd**2*K*f**2*r*s - 102*Dd**2*K*f**2*r + 108*Dd**2*K*f**2*s**2 - 138*Dd**2*K*f**2*s + 38*Dd**2*K*f**2 + 60*Dd**2*b2*f*r**2 + 120*Dd**2*b2*f*r*s - 90*Dd**2*b2*f*r + 60*Dd**2*b2*f*s**2 - 90*Dd**2*b2*f*s + 30*Dd**2*b2*f - 96*Dd**2*f*g2*r**2 - 192*Dd**2*f*g2*r*s + 144*Dd**2*f*g2*r - 96*Dd**2*f*g2*s**2 + 144*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(77*d**2*k3**5) + D1**2*Pk2*Pkd3*k2**4*st**2*(D1*(-35*D1*b2*bd1*f*(r + s - 1)**2 - 10*D1*bd1**2*(r + s - 1)*(7*K*f*(r + s - 1) + f*(2*C - 1)*(r + s) + 14*g2*(r + s)) + 5*D1*bdd1*f*(f*(2*C - 1) + 14*g2)*(r + s - 1)**2 + bd1*(D1*(f**2*(2*C*(9*r**2 + 10*r*(s - 2) + s**2 - 12*s + 6) - 11*r**2 + r*(22 - 12*s) - s**2 + 12*s - 6) + 2*f*(fd*(10*C - 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 7*g2*(r**2 + 2*r*(s - 6) + s**2 - 12*s + 6) + 70*gd2*(r + s - 1)**2) + 140*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 10*Dd*f*(f*(2*C - 1) + 14*g2)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) - 35*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(-35*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(20*C*(r + s - 1)**2 - 7*K*(r**2 + 2*r*(s + 5) + s**2 + 10*s - 5) + 4*r**2 + 2*r*(10 - 3*s) - 10*(s - 1)**2) - 5*fdd*(2*C*(r + s - 1)**2 + 7*K*s**2 + r**2*(7*K - 1) + 2*r*(7*K*s - s + 1) - s**2 + 2*s - 1) + 140*gd2*(r + s - 1)**2 - 70*gdd2*(r + s - 1)**2) + D1*(Dd*(f*(20*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 7*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 16*r**2 - 2*r*(12*s + 5) - 40*s**2 + 32*s - 2) - 10*fd*(4*r + 4*s - 3)*(2*C*(r + s - 1) + 7*K*s + r*(7*K - 1) - s + 1) + 140*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*(K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(28*r + 28*s - 21)) - 5*Ddd*(f*(2*C + 7*K - 1) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*(f*(2*C + 7*K - 1) + 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-20*C*D1**2*bdd1*f*r**2 - 40*C*D1**2*bdd1*f*r*s + 20*C*D1**2*bdd1*f*r - 20*C*D1**2*bdd1*f*s**2 + 20*C*D1**2*bdd1*f*s - 10*C*D1**2*bdd1*f + 36*C*D1**2*f*fd*r**2 + 40*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 4*C*D1**2*f*fd*s**2 + 8*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r**2 + 40*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*r + 20*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r**2 + 40*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*r + 20*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s + 72*C*D1*Dd*f**2*r**2 + 80*C*D1*Dd*f**2*r*s - 92*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s**2 - 44*C*D1*Dd*f**2*s + 38*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*r**2 + 320*C*D1*Dd*f*fd*r*s - 200*C*D1*Dd*f*fd*r + 160*C*D1*Dd*f*fd*s**2 - 200*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*r**2 + 80*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 40*C*D1*Ddd*f**2*s**2 - 60*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*r**2 + 240*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 120*C*Dd**2*f**2*s**2 - 180*C*Dd**2*f**2*s + 60*C*Dd**2*f**2 + 70*D1**2*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 70*D1**2*K*bdd1*f*r**2 - 140*D1**2*K*bdd1*f*r*s + 140*D1**2*K*bdd1*f*r - 70*D1**2*K*bdd1*f*s**2 + 140*D1**2*K*bdd1*f*s - 70*D1**2*K*bdd1*f - 35*D1**2*b2*fd*r**2 - 70*D1**2*b2*fd*r*s - 35*D1**2*b2*fd*s**2 - 35*D1**2*bd2*f*(r + s - 1)**2 + 10*D1**2*bdd1*f*r**2 + 20*D1**2*bdd1*f*r*s - 10*D1**2*bdd1*f*r + 10*D1**2*bdd1*f*s**2 - 10*D1**2*bdd1*f*s + 5*D1**2*bdd1*f - 140*D1**2*bdd1*g2*r**2 - 280*D1**2*bdd1*g2*r*s + 140*D1**2*bdd1*g2*r - 140*D1**2*bdd1*g2*s**2 + 140*D1**2*bdd1*g2*s - 70*D1**2*bdd1*g2 - 22*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - 6*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd + 14*D1**2*f*gd2*r**2 + 28*D1**2*f*gd2*r*s - 28*D1**2*f*gd2*r + 14*D1**2*f*gd2*s**2 - 28*D1**2*f*gd2*s + 14*D1**2*f*gd2 + 70*D1**2*f*gdd2*r**2 + 140*D1**2*f*gdd2*r*s - 140*D1**2*f*gdd2*r + 70*D1**2*f*gdd2*s**2 - 140*D1**2*f*gdd2*s + 70*D1**2*f*gdd2 - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 14*D1**2*fd*g2*r**2 + 28*D1**2*fd*g2*r*s + 140*D1**2*fd*g2*r + 14*D1**2*fd*g2*s**2 + 140*D1**2*fd*g2*s - 70*D1**2*fd*g2 + 140*D1**2*fd*gd2*r**2 + 280*D1**2*fd*gd2*r*s - 140*D1**2*fd*gd2*r + 140*D1**2*fd*gd2*s**2 - 140*D1**2*fd*gd2*s + 70*D1**2*fdd*g2*r**2 + 140*D1**2*fdd*g2*r*s + 70*D1**2*fdd*g2*s**2 - 140*D1*Dd*b2*f*r**2 - 280*D1*Dd*b2*f*r*s + 210*D1*Dd*b2*f*r - 140*D1*Dd*b2*f*s**2 + 210*D1*Dd*b2*f*s - 105*D1*Dd*b2*f - 44*D1*Dd*f**2*r**2 - 48*D1*Dd*f**2*r*s + 56*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 26*D1*Dd*f**2*s - 23*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 100*D1*Dd*f*fd*s - 30*D1*Dd*f*fd + 56*D1*Dd*f*g2*r**2 + 112*D1*Dd*f*g2*r*s - 84*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s**2 - 84*D1*Dd*f*g2*s + 42*D1*Dd*f*g2 + 560*D1*Dd*f*gd2*r**2 + 1120*D1*Dd*f*gd2*r*s - 980*D1*Dd*f*gd2*r + 560*D1*Dd*f*gd2*s**2 - 980*D1*Dd*f*gd2*s + 420*D1*Dd*f*gd2 + 560*D1*Dd*fd*g2*r**2 + 1120*D1*Dd*fd*g2*r*s - 420*D1*Dd*fd*g2*r + 560*D1*Dd*fd*g2*s**2 - 420*D1*Dd*fd*g2*s - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + 280*D1*Ddd*f*g2*r**2 + 560*D1*Ddd*f*g2*r*s - 420*D1*Ddd*f*g2*r + 280*D1*Ddd*f*g2*s**2 - 420*D1*Ddd*f*g2*s + 210*D1*Ddd*f*g2 + D1*bd1*(D1*(f*(20*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*K*(2*r**2 + 4*r*s - 14*r + 2*s**2 - 14*s + 7) + 8*r**2 - 12*r*s - 22*r - 20*s**2 + 6*s + 4) - 10*fd*(r + s - 1)*(C*(4*r + 4*s - 2) + 14*K*r + 14*K*s - 2*r - 2*s + 1) + 140*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 140*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 10*Dd*(f*(C*(4*r + 4*s - 2) + 14*K*(r + s - 1) - 2*r - 2*s + 1) + 14*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2 + 840*Dd**2*f*g2*r**2 + 1680*Dd**2*f*g2*r*s - 1260*Dd**2*f*g2*r + 840*Dd**2*f*g2*s**2 - 1260*Dd**2*f*g2*s + 420*Dd**2*f*g2))/(42*d**2*k3**5) + 5*D1**2*Pk2*Pkd3*k2**2*st**6*(24*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r + 24*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r*s + 4*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r*s + 8*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 32*C*D1*Dd*f**3*r*s - 8*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s**2 - 32*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r*s + 28*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 96*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 16*C*D1*Ddd*f**3*r*s + 4*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 16*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 48*C*Dd**2*f**3*r*s + 12*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 48*C*Dd**2*f**3*s - 8*C*Dd**2*f**3 + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r + 264*D1**2*K*b1*f*fd*s**2 - 264*D1**2*K*b1*f*fd*s + 132*D1**2*K*b1*f*fd - 132*D1**2*K*b1*f*fdd*r*s + 66*D1**2*K*b1*f*fdd*r - 132*D1**2*K*b1*f*fdd*s**2 + 132*D1**2*K*b1*f*fdd*s - 66*D1**2*K*b1*f*fdd - 132*D1**2*K*b1*fd**2*r*s + 66*D1**2*K*b1*fd**2*r - 132*D1**2*K*b1*fd**2*s**2 + 132*D1**2*K*b1*fd**2*s + 99*D1**2*b1*f**2*fd*r**2 + 99*D1**2*b1*f**2*fd*r*s - 99*D1**2*b1*f**2*fd*r - 33*D1**2*b1*f**2*fd*s + 33*D1**2*b1*f**2*fd - 99*D1**2*b1*f**2*fdd*r**2 - 99*D1**2*b1*f**2*fdd*r*s + 99*D1**2*b1*f**2*fdd*r + 33*D1**2*b1*f**2*fdd*s - 33*D1**2*b1*f**2*fdd - 198*D1**2*b1*f*fd**2*r**2 - 198*D1**2*b1*f*fd**2*r*s + 198*D1**2*b1*f*fd**2*r + 66*D1**2*b1*f*fd**2*s - 33*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fdd*r**2 - 66*D1**2*b1*f*fdd*r*s + 33*D1**2*b1*f*fdd*r - 66*D1**2*b1*fd**2*r**2 - 66*D1**2*b1*fd**2*r*s + 33*D1**2*b1*fd**2*r + 264*D1**2*b2*f*fd*r*s - 132*D1**2*b2*f*fd*r + 264*D1**2*b2*f*fd*s**2 - 264*D1**2*b2*f*fd*s + 132*D1**2*b2*f*fd - 132*D1**2*b2*f*fdd*r*s + 66*D1**2*b2*f*fdd*r - 132*D1**2*b2*f*fdd*s**2 + 132*D1**2*b2*f*fdd*s - 66*D1**2*b2*f*fdd - 132*D1**2*b2*fd**2*r*s + 66*D1**2*b2*fd**2*r - 132*D1**2*b2*fd**2*s**2 + 132*D1**2*b2*fd**2*s + 132*D1**2*bd2*f**2*r*s + 132*D1**2*bd2*f**2*s**2 - 132*D1**2*bd2*f**2*s - 264*D1**2*bd2*f*fd*r*s + 66*D1**2*bd2*f*fd*r - 264*D1**2*bd2*f*fd*s**2 + 264*D1**2*bd2*f*fd*s - 66*D1**2*bd2*f*fd - 33*D1**2*bdd1*f**2*(r + s - 1)*(2*K*s + f*(r - 1) + r - 1) - 66*D1**2*bdd2*f**2*r*s - 66*D1**2*bdd2*f**2*s**2 + 66*D1**2*bdd2*f**2*s + 6*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s - 2*D1**2*f**2*fd*r - 12*D1**2*f**2*fd*s**2 + 10*D1**2*f**2*fd*s - 2*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 + 3*D1**2*f**2*fdd*r*s + D1**2*f**2*fdd*r + 6*D1**2*f**2*fdd*s**2 - 5*D1**2*f**2*fdd*s + D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s - 6*D1**2*f*fd**2*r**2 + 6*D1**2*f*fd**2*r*s + 2*D1**2*f*fd**2*r + 12*D1**2*f*fd**2*s**2 - 10*D1**2*f*fd**2*s + D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r*s - 132*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 528*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s + 528*D1*Dd*K*b1*f**2*r*s - 132*D1*Dd*K*b1*f**2*r + 528*D1*Dd*K*b1*f**2*s**2 - 528*D1*Dd*K*b1*f**2*s + 132*D1*Dd*K*b1*f**2 - 1056*D1*Dd*K*b1*f*fd*r*s + 396*D1*Dd*K*b1*f*fd*r - 1056*D1*Dd*K*b1*f*fd*s**2 + 1056*D1*Dd*K*b1*f*fd*s - 264*D1*Dd*K*b1*f*fd + 132*D1*Dd*b1*f**3*r**2 + 132*D1*Dd*b1*f**3*r*s - 165*D1*Dd*b1*f**3*r - 66*D1*Dd*b1*f**3*s + 66*D1*Dd*b1*f**3 - 792*D1*Dd*b1*f**2*fd*r**2 - 792*D1*Dd*b1*f**2*fd*r*s + 891*D1*Dd*b1*f**2*fd*r + 330*D1*Dd*b1*f**2*fd*s - 231*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 330*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s + 132*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 528*D1*Dd*b1*f*fd*r*s + 462*D1*Dd*b1*f*fd*r + 132*D1*Dd*b1*f*fd*s - 66*D1*Dd*b1*f*fd + 528*D1*Dd*b2*f**2*r*s - 132*D1*Dd*b2*f**2*r + 528*D1*Dd*b2*f**2*s**2 - 528*D1*Dd*b2*f**2*s + 132*D1*Dd*b2*f**2 - 1056*D1*Dd*b2*f*fd*r*s + 396*D1*Dd*b2*f*fd*r - 1056*D1*Dd*b2*f*fd*s**2 + 1056*D1*Dd*b2*f*fd*s - 264*D1*Dd*b2*f*fd - 528*D1*Dd*bd2*f**2*r*s + 66*D1*Dd*bd2*f**2*r - 528*D1*Dd*bd2*f**2*s**2 + 528*D1*Dd*bd2*f**2*s - 66*D1*Dd*bd2*f**2 + 8*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r - 16*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 24*D1*Dd*f**2*fd*r**2 + 24*D1*Dd*f**2*fd*r*s + 13*D1*Dd*f**2*fd*r + 48*D1*Dd*f**2*fd*s**2 - 38*D1*Dd*f**2*fd*s + 3*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r*s - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1056*D1*Dd*f**2*gd2*s + 132*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r*s - 792*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2112*D1*Dd*f*fd*g2*s + 528*D1*Dd*f*fd*g2 - 264*D1*Ddd*K*b1*f**2*r*s + 66*D1*Ddd*K*b1*f**2*r - 264*D1*Ddd*K*b1*f**2*s**2 + 264*D1*Ddd*K*b1*f**2*s - 66*D1*Ddd*K*b1*f**2 - 132*D1*Ddd*b1*f**3*r**2 - 132*D1*Ddd*b1*f**3*r*s + 165*D1*Ddd*b1*f**3*r + 66*D1*Ddd*b1*f**3*s - 66*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 132*D1*Ddd*b1*f**2*r*s + 165*D1*Ddd*b1*f**2*r + 66*D1*Ddd*b1*f**2*s - 66*D1*Ddd*b1*f**2 - 264*D1*Ddd*b2*f**2*r*s + 66*D1*Ddd*b2*f**2*r - 264*D1*Ddd*b2*f**2*s**2 + 264*D1*Ddd*b2*f**2*s - 66*D1*Ddd*b2*f**2 - 4*D1*Ddd*f**3*r**2 + 4*D1*Ddd*f**3*r*s + 3*D1*Ddd*f**3*r + 8*D1*Ddd*f**3*s**2 - 6*D1*Ddd*f**3*s + 528*D1*Ddd*f**2*g2*r*s - 132*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 528*D1*Ddd*f**2*g2*s + 132*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(D1*(f**2*(r - 1)*(r + s - 1) + f*(fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + (2*r + 2*s - 2)*(2*K*s + r - 1)) - fd*(K*r*(8*s - 2) + 2*K*(1 - 2*s)**2 + 4*r**2 + r*(4*s - 5) - 2*s + 1)) - Dd*f*(2*K*(8*r*s - r + 8*s**2 - 8*s + 1) + f*(8*r**2 + r*(8*s - 13) - 6*s + 5) + 8*r**2 + 8*r*s - 13*r - 6*s + 5)) - 792*Dd**2*K*b1*f**2*r*s + 198*Dd**2*K*b1*f**2*r - 792*Dd**2*K*b1*f**2*s**2 + 792*Dd**2*K*b1*f**2*s - 132*Dd**2*K*b1*f**2 - 396*Dd**2*b1*f**3*r**2 - 396*Dd**2*b1*f**3*r*s + 495*Dd**2*b1*f**3*r + 198*Dd**2*b1*f**3*s - 132*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 396*Dd**2*b1*f**2*r*s + 495*Dd**2*b1*f**2*r + 198*Dd**2*b1*f**2*s - 132*Dd**2*b1*f**2 - 792*Dd**2*b2*f**2*r*s + 198*Dd**2*b2*f**2*r - 792*Dd**2*b2*f**2*s**2 + 792*Dd**2*b2*f**2*s - 132*Dd**2*b2*f**2 - 12*Dd**2*f**3*r**2 + 12*Dd**2*f**3*r*s + 9*Dd**2*f**3*r + 24*Dd**2*f**3*s**2 - 18*Dd**2*f**3*s + 1584*Dd**2*f**2*g2*r*s - 396*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 1584*Dd**2*f**2*g2*s + 264*Dd**2*f**2*g2)/(693*d**2*k3**3) + D1**2*Pk2*Pkd3*k2**2*st**4*(-48*C*D1**2*f**2*fd*r**2 - 48*C*D1**2*f**2*fd*r*s + 48*C*D1**2*f**2*fd*r + 16*C*D1**2*f**2*fd*s - 16*C*D1**2*f**2*fd + 24*C*D1**2*f**2*fdd*r**2 + 24*C*D1**2*f**2*fdd*r*s - 24*C*D1**2*f**2*fdd*r - 8*C*D1**2*f**2*fdd*s + 8*C*D1**2*f**2*fdd + 48*C*D1**2*f*fd**2*r**2 + 48*C*D1**2*f*fd**2*r*s - 48*C*D1**2*f*fd**2*r - 16*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 64*C*D1*Dd*f**3*r**2 - 64*C*D1*Dd*f**3*r*s + 80*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s - 32*C*D1*Dd*f**3 + 192*C*D1*Dd*f**2*fd*r**2 + 192*C*D1*Dd*f**2*fd*r*s - 216*C*D1*Dd*f**2*fd*r - 80*C*D1*Dd*f**2*fd*s + 56*C*D1*Dd*f**2*fd + 32*C*D1*Ddd*f**3*r**2 + 32*C*D1*Ddd*f**3*r*s - 40*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s + 16*C*D1*Ddd*f**3 + 96*C*Dd**2*f**3*r**2 + 96*C*Dd**2*f**3*r*s - 120*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s + 32*C*Dd**2*f**3 + 55*D1**2*K*bdd1*f**2*r**2 + 154*D1**2*K*bdd1*f**2*r*s - 110*D1**2*K*bdd1*f**2*r + 99*D1**2*K*bdd1*f**2*s**2 - 154*D1**2*K*bdd1*f**2*s + 55*D1**2*K*bdd1*f**2 - 11*D1**2*b2*bdd1*f*r**2 - 22*D1**2*b2*bdd1*f*r*s - 11*D1**2*b2*bdd1*f*s**2 - 66*D1**2*b2*f*fd*r**2 - 308*D1**2*b2*f*fd*r*s + 154*D1**2*b2*f*fd*r - 242*D1**2*b2*f*fd*s**2 + 242*D1**2*b2*f*fd*s - 121*D1**2*b2*f*fd + 110*D1**2*b2*f*fdd*r**2 + 308*D1**2*b2*f*fdd*r*s - 154*D1**2*b2*f*fdd*r + 198*D1**2*b2*f*fdd*s**2 - 198*D1**2*b2*f*fdd*s + 99*D1**2*b2*f*fdd + 110*D1**2*b2*fd**2*r**2 + 308*D1**2*b2*fd**2*r*s - 154*D1**2*b2*fd**2*r + 198*D1**2*b2*fd**2*s**2 - 198*D1**2*b2*fd**2*s + 22*D1**2*bd1**2*f*(-5*K*r**2 - 6*K*r*s + 5*K*r - K*s**2 + 3*K*s + f*(r - 1) + r - 1) - 33*D1**2*bd2*f**2*r**2 - 154*D1**2*bd2*f**2*r*s + 66*D1**2*bd2*f**2*r - 121*D1**2*bd2*f**2*s**2 + 154*D1**2*bd2*f**2*s - 33*D1**2*bd2*f**2 + 220*D1**2*bd2*f*fd*r**2 + 616*D1**2*bd2*f*fd*r*s - 374*D1**2*bd2*f*fd*r + 396*D1**2*bd2*f*fd*s**2 - 506*D1**2*bd2*f*fd*s + 154*D1**2*bd2*f*fd + 110*D1**2*bdd1*f*g2*r**2 + 132*D1**2*bdd1*f*g2*r*s + 22*D1**2*bdd1*f*g2*s**2 + 55*D1**2*bdd2*f**2*r**2 + 154*D1**2*bdd2*f**2*r*s - 110*D1**2*bdd2*f**2*r + 99*D1**2*bdd2*f**2*s**2 - 154*D1**2*bdd2*f**2*s + 55*D1**2*bdd2*f**2 + 24*D1**2*f**2*fd*r**2 + 24*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r - 8*D1**2*f**2*fd*s + 8*D1**2*f**2*fd - 12*D1**2*f**2*fdd*r**2 - 12*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r + 4*D1**2*f**2*fdd*s - 4*D1**2*f**2*fdd + 66*D1**2*f**2*gd2*r**2 + 308*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*r + 242*D1**2*f**2*gd2*s**2 - 308*D1**2*f**2*gd2*s + 66*D1**2*f**2*gd2 - 110*D1**2*f**2*gdd2*r**2 - 308*D1**2*f**2*gdd2*r*s + 220*D1**2*f**2*gdd2*r - 198*D1**2*f**2*gdd2*s**2 + 308*D1**2*f**2*gdd2*s - 110*D1**2*f**2*gdd2 - 24*D1**2*f*fd**2*r**2 - 24*D1**2*f*fd**2*r*s + 24*D1**2*f*fd**2*r + 8*D1**2*f*fd**2*s - 4*D1**2*f*fd**2 + 132*D1**2*f*fd*g2*r**2 + 616*D1**2*f*fd*g2*r*s - 308*D1**2*f*fd*g2*r + 484*D1**2*f*fd*g2*s**2 - 484*D1**2*f*fd*g2*s + 242*D1**2*f*fd*g2 - 440*D1**2*f*fd*gd2*r**2 - 1232*D1**2*f*fd*gd2*r*s + 748*D1**2*f*fd*gd2*r - 792*D1**2*f*fd*gd2*s**2 + 1012*D1**2*f*fd*gd2*s - 308*D1**2*f*fd*gd2 - 220*D1**2*f*fdd*g2*r**2 - 616*D1**2*f*fdd*g2*r*s + 308*D1**2*f*fdd*g2*r - 396*D1**2*f*fdd*g2*s**2 + 396*D1**2*f*fdd*g2*s - 198*D1**2*f*fdd*g2 - 220*D1**2*fd**2*g2*r**2 - 616*D1**2*fd**2*g2*r*s + 308*D1**2*fd**2*g2*r - 396*D1**2*fd**2*g2*s**2 + 396*D1**2*fd**2*g2*s - 132*D1*Dd*b2*f**2*r**2 - 616*D1*Dd*b2*f**2*r*s + 286*D1*Dd*b2*f**2*r - 484*D1*Dd*b2*f**2*s**2 + 550*D1*Dd*b2*f**2*s - 187*D1*Dd*b2*f**2 + 880*D1*Dd*b2*f*fd*r**2 + 2464*D1*Dd*b2*f*fd*r*s - 1364*D1*Dd*b2*f*fd*r + 1584*D1*Dd*b2*f*fd*s**2 - 1804*D1*Dd*b2*f*fd*s + 506*D1*Dd*b2*f*fd + 440*D1*Dd*bd2*f**2*r**2 + 1232*D1*Dd*bd2*f**2*r*s - 814*D1*Dd*bd2*f**2*r + 792*D1*Dd*bd2*f**2*s**2 - 1122*D1*Dd*bd2*f**2*s + 374*D1*Dd*bd2*f**2 + 32*D1*Dd*f**3*r**2 + 32*D1*Dd*f**3*r*s - 40*D1*Dd*f**3*r - 16*D1*Dd*f**3*s + 16*D1*Dd*f**3 - 96*D1*Dd*f**2*fd*r**2 - 96*D1*Dd*f**2*fd*r*s + 108*D1*Dd*f**2*fd*r + 40*D1*Dd*f**2*fd*s - 28*D1*Dd*f**2*fd + 264*D1*Dd*f**2*g2*r**2 + 1232*D1*Dd*f**2*g2*r*s - 572*D1*Dd*f**2*g2*r + 968*D1*Dd*f**2*g2*s**2 - 1100*D1*Dd*f**2*g2*s + 374*D1*Dd*f**2*g2 - 880*D1*Dd*f**2*gd2*r**2 - 2464*D1*Dd*f**2*gd2*r*s + 1628*D1*Dd*f**2*gd2*r - 1584*D1*Dd*f**2*gd2*s**2 + 2244*D1*Dd*f**2*gd2*s - 748*D1*Dd*f**2*gd2 - 1760*D1*Dd*f*fd*g2*r**2 - 4928*D1*Dd*f*fd*g2*r*s + 2728*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s**2 + 3608*D1*Dd*f*fd*g2*s - 1012*D1*Dd*f*fd*g2 + 220*D1*Ddd*b2*f**2*r**2 + 616*D1*Ddd*b2*f**2*r*s - 374*D1*Ddd*b2*f**2*r + 396*D1*Ddd*b2*f**2*s**2 - 506*D1*Ddd*b2*f**2*s + 209*D1*Ddd*b2*f**2 - 16*D1*Ddd*f**3*r**2 - 16*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r + 8*D1*Ddd*f**3*s - 8*D1*Ddd*f**3 - 440*D1*Ddd*f**2*g2*r**2 - 1232*D1*Ddd*f**2*g2*r*s + 748*D1*Ddd*f**2*g2*r - 792*D1*Ddd*f**2*g2*s**2 + 1012*D1*Ddd*f**2*g2*s - 418*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(f**2*(r + s - 1)*(K*(3*r + 11*s - 3) + 2*r - 2) - 2*f*(K*fd*(10*r**2 + r*(28*s - 17) + 18*s**2 - 23*s + 7) + b2*r**2 + 2*b2*r*s + b2*s**2 + bd2*(-r**2 - 2*r*s + r - s**2 + s) - 10*g2*r**2 - 12*g2*r*s - 2*g2*s**2 + 10*gd2*r**2 + 12*gd2*r*s - 10*gd2*r + 2*gd2*s**2 - 6*gd2*s) + 2*fd*(b2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 2*g2*(5*r**2 + r*(6*s - 3) + s*(s - 1)))) - 2*Dd*f*(K*f*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17) + b2*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s)) + 2*g2*(20*r**2 + r*(24*s - 13) + s*(4*s - 7))) + 2*b1*(D1*(f*(-K*(10*r**2 + 2*r*(6*s - 5) + 2*s**2 - 6*s + 5) + r*(f + 2)) + fd*(K*(10*r**2 + 12*r*s - 11*r + 2*s**2 - 5*s + 3) + r - 1)) + Dd*f*(K*(40*r**2 + 48*r*s - 46*r + 8*s**2 - 26*s + 13) + f*(2 - 4*r) - 4*r + 2))) + 660*Dd**2*b2*f**2*r**2 + 1848*Dd**2*b2*f**2*r*s - 1122*Dd**2*b2*f**2*r + 1188*Dd**2*b2*f**2*s**2 - 1518*Dd**2*b2*f**2*s + 418*Dd**2*b2*f**2 - 48*Dd**2*f**3*r**2 - 48*Dd**2*f**3*r*s + 60*Dd**2*f**3*r + 24*Dd**2*f**3*s - 16*Dd**2*f**3 - 1320*Dd**2*f**2*g2*r**2 - 3696*Dd**2*f**2*g2*r*s + 2244*Dd**2*f**2*g2*r - 2376*Dd**2*f**2*g2*s**2 + 3036*Dd**2*f**2*g2*s - 836*Dd**2*f**2*g2 - 11*b1**2*(D1**2*(2*fd**2*(r - 1) - 2*fd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(f + 2)) + fdd*(K*(5*r**2 + 6*r*(s - 1) + (s - 1)**2) + r*(2*f + 2))) + D1*(2*Dd*(-K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11) + fd*(K*(20*r**2 + 24*r*s - 25*r + 4*s**2 - 11*s + 7) + f*(4*r - 2) + 4*r - 2)) + Ddd*K*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11)) + 2*Dd**2*K*f*(30*r**2 + r*(36*s - 39) + 6*s**2 - 21*s + 11)) + 11*b1*(-10*D1**2*K*bdd1*f*r**2 - 12*D1**2*K*bdd1*f*r*s + 10*D1**2*K*bdd1*f*r - 2*D1**2*K*bdd1*f*s**2 + 6*D1**2*K*bdd1*f*s - 5*D1**2*K*bdd1*f - 6*D1**2*K*f*fd*r**2 - 28*D1**2*K*f*fd*r*s + 14*D1**2*K*f*fd*r - 22*D1**2*K*f*fd*s**2 + 22*D1**2*K*f*fd*s - 11*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r**2 + 28*D1**2*K*f*fdd*r*s - 14*D1**2*K*f*fdd*r + 18*D1**2*K*f*fdd*s**2 - 18*D1**2*K*f*fdd*s + 9*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r**2 + 28*D1**2*K*fd**2*r*s - 14*D1**2*K*fd**2*r + 18*D1**2*K*fd**2*s**2 - 18*D1**2*K*fd**2*s + 2*D1**2*b2*fd*r**2 + 4*D1**2*b2*fd*r*s - 4*D1**2*b2*fd*r + 2*D1**2*b2*fd*s**2 - 4*D1**2*b2*fd*s + 2*D1**2*b2*fd - D1**2*b2*fdd*r**2 - 2*D1**2*b2*fdd*r*s + 2*D1**2*b2*fdd*r - D1**2*b2*fdd*s**2 + 2*D1**2*b2*fdd*s - D1**2*b2*fdd + 2*D1**2*bdd1*f**2*r + 2*D1**2*bdd1*f*r - D1**2*bdd2*f*(r + s - 1)**2 - 4*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 20*D1**2*f*gd2*r**2 - 24*D1**2*f*gd2*r*s + 40*D1**2*f*gd2*r - 4*D1**2*f*gd2*s**2 + 24*D1**2*f*gd2*s - 20*D1**2*f*gd2 + 10*D1**2*f*gdd2*r**2 + 12*D1**2*f*gdd2*r*s - 20*D1**2*f*gdd2*r + 2*D1**2*f*gdd2*s**2 - 12*D1**2*f*gdd2*s + 10*D1**2*f*gdd2 - 20*D1**2*fd*g2*r**2 - 24*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*r - 4*D1**2*fd*g2*s**2 + 8*D1**2*fd*g2*s - 4*D1**2*fd*g2 + 20*D1**2*fd*gd2*r**2 + 24*D1**2*fd*gd2*r*s - 32*D1**2*fd*gd2*r + 4*D1**2*fd*gd2*s**2 - 16*D1**2*fd*gd2*s + 12*D1**2*fd*gd2 + 10*D1**2*fdd*g2*r**2 + 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*r + 2*D1**2*fdd*g2*s**2 - 4*D1**2*fdd*g2*s + 2*D1**2*fdd*g2 - 12*D1*Dd*K*f**2*r**2 - 56*D1*Dd*K*f**2*r*s + 26*D1*Dd*K*f**2*r - 44*D1*Dd*K*f**2*s**2 + 50*D1*Dd*K*f**2*s - 17*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r**2 + 224*D1*Dd*K*f*fd*r*s - 124*D1*Dd*K*f*fd*r + 144*D1*Dd*K*f*fd*s**2 - 164*D1*Dd*K*f*fd*s + 46*D1*Dd*K*f*fd + 8*D1*Dd*b2*f*r**2 + 16*D1*Dd*b2*f*r*s - 12*D1*Dd*b2*f*r + 8*D1*Dd*b2*f*s**2 - 12*D1*Dd*b2*f*s + 6*D1*Dd*b2*f - 8*D1*Dd*b2*fd*r**2 - 16*D1*Dd*b2*fd*r*s + 14*D1*Dd*b2*fd*r - 8*D1*Dd*b2*fd*s**2 + 14*D1*Dd*b2*fd*s - 6*D1*Dd*b2*fd - 8*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 10*D1*Dd*f**2*r + 4*D1*Dd*f**2*s - 4*D1*Dd*f**2 - 80*D1*Dd*f*g2*r**2 - 96*D1*Dd*f*g2*r*s + 104*D1*Dd*f*g2*r - 16*D1*Dd*f*g2*s**2 + 56*D1*Dd*f*g2*s - 44*D1*Dd*f*g2 + 80*D1*Dd*f*gd2*r**2 + 96*D1*Dd*f*gd2*r*s - 132*D1*Dd*f*gd2*r + 16*D1*Dd*f*gd2*s**2 - 76*D1*Dd*f*gd2*s + 52*D1*Dd*f*gd2 + 80*D1*Dd*fd*g2*r**2 + 96*D1*Dd*fd*g2*r*s - 100*D1*Dd*fd*g2*r + 16*D1*Dd*fd*g2*s**2 - 44*D1*Dd*fd*g2*s + 28*D1*Dd*fd*g2 + 20*D1*Ddd*K*f**2*r**2 + 56*D1*Ddd*K*f**2*r*s - 34*D1*Ddd*K*f**2*r + 36*D1*Ddd*K*f**2*s**2 - 46*D1*Ddd*K*f**2*s + 19*D1*Ddd*K*f**2 - 4*D1*Ddd*b2*f*r**2 - 8*D1*Ddd*b2*f*r*s + 6*D1*Ddd*b2*f*r - 4*D1*Ddd*b2*f*s**2 + 6*D1*Ddd*b2*f*s - 3*D1*Ddd*b2*f + 40*D1*Ddd*f*g2*r**2 + 48*D1*Ddd*f*g2*r*s - 52*D1*Ddd*f*g2*r + 8*D1*Ddd*f*g2*s**2 - 28*D1*Ddd*f*g2*s + 22*D1*Ddd*f*g2 + 2*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 60*Dd**2*K*f**2*r**2 + 168*Dd**2*K*f**2*r*s - 102*Dd**2*K*f**2*r + 108*Dd**2*K*f**2*s**2 - 138*Dd**2*K*f**2*s + 38*Dd**2*K*f**2 - 12*Dd**2*b2*f*r**2 - 24*Dd**2*b2*f*r*s + 18*Dd**2*b2*f*r - 12*Dd**2*b2*f*s**2 + 18*Dd**2*b2*f*s - 6*Dd**2*b2*f + 120*Dd**2*f*g2*r**2 + 144*Dd**2*f*g2*r*s - 156*Dd**2*f*g2*r + 24*Dd**2*f*g2*s**2 - 84*Dd**2*f*g2*s + 44*Dd**2*f*g2))/(77*d**2*k3**3) - D1**2*Pk2*Pkd3*k2**2*st**2*(D1*(-2*D1*bd1**2*(f*(7*K*(4*r**2 + r*(4*s - 9) - 7*s + 5) + r**2*(10*C - 7) + r*(10*C - 6)*(2*s - 1) + s*(10*C - 5)*(s - 1)) + 70*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*bdd1*f*(f*(2*C - 1) + 14*g2)*(4*r**2 + 2*r*(2*s - 5) - 10*s + 5) + 7*b2*(2*D1*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1)) - 5*D1*bdd1*f*(r + s - 1)**2 + bd1*(D1*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - 10*Dd*f*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3))) + bd1*(-70*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(-2*C*(r**2 + 2*r*(s + 1) + s**2 - 6*s + 3) + r**2 + 2*r*(s + 2) + s**2 - 6*s + 3) + 2*f*(fd*(2*C - 1)*(8*r**2 + r*(8*s - 11) - 7*s + 5) - 7*g2*(9*r**2 + 10*r*s - 6*r + s**2 - 6*s + 3) + 14*gd2*(4*r**2 + 4*r*s - 9*r - 7*s + 5)) + 56*fd*g2*r*(2*r + 2*s - 1)) + 2*Dd*f*(f*(2*C - 1) + 14*g2)*(16*r**2 + 2*r*(8*s - 15) - 24*s + 15))) + 7*b1**3*(2*D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(2*Dd*(-20*K*r**2 - 40*K*r*s + 30*K*r - 20*K*s**2 + 30*K*s - 15*K + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 13*r + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) + Ddd*(5*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*f*(4*r**2 + r*(4*s - 5) - 2*s + 2) - 8*r**2 - 8*r*s + 10*r + 4*s - 4)) + 2*Dd**2*(15*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + b1**2*(20*C*D1**2*fd*r**2 + 40*C*D1**2*fd*r*s - 40*C*D1**2*fd*r + 20*C*D1**2*fd*s**2 - 40*C*D1**2*fd*s + 20*C*D1**2*fd - 10*C*D1**2*fdd*r**2 - 20*C*D1**2*fdd*r*s + 20*C*D1**2*fdd*r - 10*C*D1**2*fdd*s**2 + 20*C*D1**2*fdd*s - 10*C*D1**2*fdd + 80*C*D1*Dd*f*r**2 + 160*C*D1*Dd*f*r*s - 120*C*D1*Dd*f*r + 80*C*D1*Dd*f*s**2 - 120*C*D1*Dd*f*s + 60*C*D1*Dd*f - 80*C*D1*Dd*fd*r**2 - 160*C*D1*Dd*fd*r*s + 140*C*D1*Dd*fd*r - 80*C*D1*Dd*fd*s**2 + 140*C*D1*Dd*fd*s - 60*C*D1*Dd*fd - 40*C*D1*Ddd*f*r**2 - 80*C*D1*Ddd*f*r*s + 60*C*D1*Ddd*f*r - 40*C*D1*Ddd*f*s**2 + 60*C*D1*Ddd*f*s - 30*C*D1*Ddd*f - 120*C*Dd**2*f*r**2 - 240*C*Dd**2*f*r*s + 180*C*Dd**2*f*r - 120*C*Dd**2*f*s**2 + 180*C*Dd**2*f*s - 60*C*Dd**2*f + 105*D1**2*K*bdd1*r**2 + 210*D1**2*K*bdd1*r*s - 140*D1**2*K*bdd1*r + 105*D1**2*K*bdd1*s**2 - 140*D1**2*K*bdd1*s + 70*D1**2*K*bdd1 + 63*D1**2*K*fd*r**2 + 70*D1**2*K*fd*r*s - 28*D1**2*K*fd*r + 7*D1**2*K*fd*s**2 + 28*D1**2*K*fd*s - 14*D1**2*K*fd - 28*D1**2*K*fdd*r**2 - 28*D1**2*K*fdd*r*s - 42*D1**2*K*fdd*r - 70*D1**2*K*fdd*s + 35*D1**2*K*fdd - 42*D1**2*bdd1*f*r**2 - 42*D1**2*bdd1*f*r*s + 42*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s - 14*D1**2*bdd1*f - 42*D1**2*bdd1*r**2 - 42*D1**2*bdd1*r*s + 42*D1**2*bdd1*r + 14*D1**2*bdd1*s - 14*D1**2*bdd1 + 7*D1**2*bdd2*r**2 + 14*D1**2*bdd2*r*s - 14*D1**2*bdd2*r + 7*D1**2*bdd2*s**2 - 14*D1**2*bdd2*s + 7*D1**2*bdd2 - 14*D1**2*fd*r**2 - 24*D1**2*fd*r*s + 42*D1**2*fd*r - 10*D1**2*fd*s**2 + 24*D1**2*fd*s - 14*D1**2*fd + 7*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s - 14*D1**2*fdd*r + 5*D1**2*fdd*s**2 - 12*D1**2*fdd*s + 7*D1**2*fdd + 140*D1**2*gd2*r**2 + 280*D1**2*gd2*r*s - 280*D1**2*gd2*r + 140*D1**2*gd2*s**2 - 280*D1**2*gd2*s + 140*D1**2*gd2 - 70*D1**2*gdd2*r**2 - 140*D1**2*gdd2*r*s + 140*D1**2*gdd2*r - 70*D1**2*gdd2*s**2 + 140*D1**2*gdd2*s - 70*D1**2*gdd2 + 252*D1*Dd*K*f*r**2 + 280*D1*Dd*K*f*r*s - 322*D1*Dd*K*f*r + 28*D1*Dd*K*f*s**2 - 154*D1*Dd*K*f*s + 133*D1*Dd*K*f - 224*D1*Dd*K*fd*r**2 - 224*D1*Dd*K*fd*r*s - 28*D1*Dd*K*fd*r - 224*D1*Dd*K*fd*s + 154*D1*Dd*K*fd - 56*D1*Dd*b2*r**2 - 112*D1*Dd*b2*r*s + 84*D1*Dd*b2*r - 56*D1*Dd*b2*s**2 + 84*D1*Dd*b2*s - 42*D1*Dd*b2 - 56*D1*Dd*f*r**2 - 96*D1*Dd*f*r*s + 80*D1*Dd*f*r - 40*D1*Dd*f*s**2 + 68*D1*Dd*f*s - 38*D1*Dd*f + 56*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 96*D1*Dd*fd*r + 40*D1*Dd*fd*s**2 - 82*D1*Dd*fd*s + 40*D1*Dd*fd + 560*D1*Dd*g2*r**2 + 1120*D1*Dd*g2*r*s - 840*D1*Dd*g2*r + 560*D1*Dd*g2*s**2 - 840*D1*Dd*g2*s + 420*D1*Dd*g2 - 560*D1*Dd*gd2*r**2 - 1120*D1*Dd*gd2*r*s + 980*D1*Dd*gd2*r - 560*D1*Dd*gd2*s**2 + 980*D1*Dd*gd2*s - 420*D1*Dd*gd2 - 112*D1*Ddd*K*f*r**2 - 112*D1*Ddd*K*f*r*s + 140*D1*Ddd*K*f*r + 56*D1*Ddd*K*f*s - 56*D1*Ddd*K*f + 28*D1*Ddd*b2*r**2 + 56*D1*Ddd*b2*r*s - 42*D1*Ddd*b2*r + 28*D1*Ddd*b2*s**2 - 42*D1*Ddd*b2*s + 21*D1*Ddd*b2 + 28*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 40*D1*Ddd*f*r + 20*D1*Ddd*f*s**2 - 34*D1*Ddd*f*s + 19*D1*Ddd*f - 280*D1*Ddd*g2*r**2 - 560*D1*Ddd*g2*r*s + 420*D1*Ddd*g2*r - 280*D1*Ddd*g2*s**2 + 420*D1*Ddd*g2*s - 210*D1*Ddd*g2 + 14*D1*bd1*(D1*(-15*K*r**2 - 30*K*r*s + 20*K*r - 15*K*s**2 + 20*K*s - 10*K + f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 - 6*r*s + 9*r + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) + Dd*(5*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) - 24*r**2 - 24*r*s + 27*r + 10*s - 7)) - 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 336*Dd**2*K*f*r**2 - 336*Dd**2*K*f*r*s + 420*Dd**2*K*f*r + 168*Dd**2*K*f*s - 112*Dd**2*K*f + 84*Dd**2*b2*r**2 + 168*Dd**2*b2*r*s - 126*Dd**2*b2*r + 84*Dd**2*b2*s**2 - 126*Dd**2*b2*s + 42*Dd**2*b2 + 84*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 120*Dd**2*f*r + 60*Dd**2*f*s**2 - 102*Dd**2*f*s + 38*Dd**2*f - 840*Dd**2*g2*r**2 - 1680*Dd**2*g2*r*s + 1260*Dd**2*g2*r - 840*Dd**2*g2*s**2 + 1260*Dd**2*g2*s - 420*Dd**2*g2) - b1*(20*C*D1**2*bdd1*f*r**2 + 40*C*D1**2*bdd1*f*r*s - 20*C*D1**2*bdd1*f*r + 20*C*D1**2*bdd1*f*s**2 - 20*C*D1**2*bdd1*f*s + 10*C*D1**2*bdd1*f + 4*C*D1**2*f*fd*r**2 + 8*C*D1**2*f*fd*r*s - 12*C*D1**2*f*fd*r + 4*C*D1**2*f*fd*s**2 + 4*C*D1**2*f*fd*s - 2*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r**2 - 16*C*D1**2*f*fdd*r*s + 4*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s + 2*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r**2 - 16*C*D1**2*fd**2*r*s + 4*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 + 8*C*D1*Dd*f**2*r**2 + 16*C*D1*Dd*f**2*r*s - 12*C*D1*Dd*f**2*r + 8*C*D1*Dd*f**2*s**2 - 12*C*D1*Dd*f**2*s + 6*C*D1*Dd*f**2 - 128*C*D1*Dd*f*fd*r**2 - 128*C*D1*Dd*f*fd*r*s + 96*C*D1*Dd*f*fd*r - 16*C*D1*Dd*f*fd*s + 4*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r**2 - 32*C*D1*Ddd*f**2*r*s + 40*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s - 16*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r**2 - 96*C*Dd**2*f**2*r*s + 120*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s - 32*C*Dd**2*f**2 + 56*D1**2*K*bdd1*f*r**2 + 56*D1**2*K*bdd1*f*r*s - 126*D1**2*K*bdd1*f*r - 98*D1**2*K*bdd1*f*s + 63*D1**2*K*bdd1*f + 14*D1**2*bd1**2*(-5*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*r**2 + 6*r*s - 6*r - 2*s + 1) - 28*D1**2*bd2*f*r**2 - 56*D1**2*bd2*f*r*s + 56*D1**2*bd2*f*r - 28*D1**2*bd2*f*s**2 + 56*D1**2*bd2*f*s - 28*D1**2*bd2*f + 70*D1**2*bd2*fd*r**2 + 140*D1**2*bd2*fd*r*s - 70*D1**2*bd2*fd*r + 70*D1**2*bd2*fd*s**2 - 70*D1**2*bd2*fd*s - 14*D1**2*bdd1*f*r**2 - 24*D1**2*bdd1*f*r*s + 12*D1**2*bdd1*f*r - 10*D1**2*bdd1*f*s**2 + 10*D1**2*bdd1*f*s - 5*D1**2*bdd1*f + 140*D1**2*bdd1*g2*r**2 + 280*D1**2*bdd1*g2*r*s - 140*D1**2*bdd1*g2*r + 140*D1**2*bdd1*g2*s**2 - 140*D1**2*bdd1*g2*s + 70*D1**2*bdd1*g2 + 35*D1**2*bdd2*f*r**2 + 70*D1**2*bdd2*f*r*s - 70*D1**2*bdd2*f*r + 35*D1**2*bdd2*f*s**2 - 70*D1**2*bdd2*f*s + 35*D1**2*bdd2*f - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + D1**2*f*fd + 8*D1**2*f*fdd*r**2 + 8*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r + 6*D1**2*f*fdd*s - D1**2*f*fdd + 126*D1**2*f*gd2*r**2 + 140*D1**2*f*gd2*r*s - 252*D1**2*f*gd2*r + 14*D1**2*f*gd2*s**2 - 140*D1**2*f*gd2*s + 126*D1**2*f*gd2 - 56*D1**2*f*gdd2*r**2 - 56*D1**2*f*gdd2*r*s + 112*D1**2*f*gdd2*r + 56*D1**2*f*gdd2*s - 56*D1**2*f*gdd2 + 8*D1**2*fd**2*r**2 + 8*D1**2*fd**2*r*s - 2*D1**2*fd**2*r + 6*D1**2*fd**2*s - 6*D1**2*fd**2 + 126*D1**2*fd*g2*r**2 + 140*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 14*D1**2*fd*g2*s**2 + 56*D1**2*fd*g2*s - 28*D1**2*fd*g2 - 112*D1**2*fd*gd2*r**2 - 112*D1**2*fd*gd2*r*s + 28*D1**2*fd*gd2*r - 84*D1**2*fd*gd2*s + 84*D1**2*fd*gd2 - 56*D1**2*fdd*g2*r**2 - 56*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*r - 140*D1**2*fdd*g2*s + 70*D1**2*fdd*g2 + 280*D1*Dd*bd2*f*r**2 + 560*D1*Dd*bd2*f*r*s - 490*D1*Dd*bd2*f*r + 280*D1*Dd*bd2*f*s**2 - 490*D1*Dd*bd2*f*s + 210*D1*Dd*bd2*f - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 64*D1*Dd*f*fd*r**2 + 64*D1*Dd*f*fd*r*s - 48*D1*Dd*f*fd*r + 8*D1*Dd*f*fd*s - 2*D1*Dd*f*fd + 504*D1*Dd*f*g2*r**2 + 560*D1*Dd*f*g2*r*s - 644*D1*Dd*f*g2*r + 56*D1*Dd*f*g2*s**2 - 308*D1*Dd*f*g2*s + 266*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r**2 - 448*D1*Dd*f*gd2*r*s + 728*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s - 280*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r**2 - 448*D1*Dd*fd*g2*r*s - 56*D1*Dd*fd*g2*r - 448*D1*Dd*fd*g2*s + 308*D1*Dd*fd*g2 + 16*D1*Ddd*f**2*r**2 + 16*D1*Ddd*f**2*r*s - 20*D1*Ddd*f**2*r - 8*D1*Ddd*f**2*s + 8*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r**2 - 224*D1*Ddd*f*g2*r*s + 280*D1*Ddd*f*g2*r + 112*D1*Ddd*f*g2*s - 112*D1*Ddd*f*g2 - 2*D1*bd1*(7*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f*(10*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*K*(9*r**2 + 2*r*(5*s - 6) + s**2 - 8*s + 6) - 14*r**2 - 24*r*s + 5*r - 10*s**2 + 10*s - 5) + fd*(-10*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 7*K*(8*r**2 + 8*r*s - 3*r + 3*s - 3) + 14*r**2 + 24*r*s - 20*r + 10*s**2 - 17*s + 6) + 70*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 70*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - Dd*(f*(10*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 7*K*(32*r**2 + 8*r*(4*s - 7) - 36*s + 25) - 56*r**2 - 96*r*s + 64*r - 40*s**2 + 54*s - 17) + 70*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 48*Dd**2*f**2*r**2 + 48*Dd**2*f**2*r*s - 60*Dd**2*f**2*r - 24*Dd**2*f**2*s + 16*Dd**2*f**2 - 672*Dd**2*f*g2*r**2 - 672*Dd**2*f*g2*r*s + 840*Dd**2*f*g2*r + 336*Dd**2*f*g2*s - 224*Dd**2*f*g2 + 7*b2*(-D1**2*bdd1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 4*D1**2*fd*r**2 - 8*D1**2*fd*r*s + 2*D1**2*fd*r - 4*D1**2*fd*s**2 + 2*D1**2*fd*s - D1**2*fd + 5*D1**2*fdd*r**2 + 10*D1**2*fdd*r*s + 5*D1**2*fdd*s**2 - 16*D1*Dd*f*r**2 - 32*D1*Dd*f*r*s + 24*D1*Dd*f*r - 16*D1*Dd*f*s**2 + 24*D1*Dd*f*s - 12*D1*Dd*f + 40*D1*Dd*fd*r**2 + 80*D1*Dd*fd*r*s - 30*D1*Dd*fd*r + 40*D1*Dd*fd*s**2 - 30*D1*Dd*fd*s + 20*D1*Ddd*f*r**2 + 40*D1*Ddd*f*r*s - 30*D1*Ddd*f*r + 20*D1*Ddd*f*s**2 - 30*D1*Ddd*f*s + 15*D1*Ddd*f + 2*D1*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 60*Dd**2*f*r**2 + 120*Dd**2*f*r*s - 90*Dd**2*f*r + 60*Dd**2*f*s**2 - 90*Dd**2*f*s + 30*Dd**2*f)))/(42*d**2*k3**3) + D1**2*Pk2*Pkd3*k2**2*(2*D1**2*bd1**2*f*(2*C - 1)*(11*r**2 + 9*r*(2*s - 1) + s*(7*s - 7)) + D1*b1*(D1*bdd1*f*(2*C - 1)*(22*r**2 + 36*r*s - 18*r + 14*s**2 - 14*s + 7) + 2*bd1*(D1*(f*(2*C*(34*r**2 + 76*r*s - 38*r + 42*s**2 - 42*s + 21) - 48*r**2 - 90*r*s + 45*r - 42*s**2 + 42*s - 21) + fd*(2*C - 1)*(22*r**2 + r*(36*s - 31) + 14*s**2 - 25*s + 9)) + Dd*f*(2*C - 1)*(88*r**2 + 2*r*(72*s - 49) + 56*s**2 - 78*s + 25))) + b1**2*(D1**2*(r + s - 1)*(C*fd*(68*r + 84*s - 68) - 6*fd*(8*r + 7*s - 8) + fdd*(2*C - 1)*(11*r + 7*s - 11)) + D1*(2*Dd*(f*(2*C*(68*r**2 + 2*r*(76*s - 53) + 84*s**2 - 118*s + 55) - 96*r**2 - 3*r*(60*s - 47) - 84*s**2 + 132*s - 69) + fd*(2*C - 1)*(44*r**2 + r*(72*s - 75) + 28*s**2 - 61*s + 31)) + Ddd*f*(2*C - 1)*(44*r**2 + r*(72*s - 62) + 28*s**2 - 50*s + 29)) + Dd**2*f*(4*C - 2)*(66*r**2 + 3*r*(36*s - 31) + 42*s**2 - 75*s + 29)))/(21*d**2*k3**3) + 2*D1**2*Pk2*Pkd3*st**4*(D1*(D1*bd1**2*f*(r**2*(-2*f - 2) - 2*r*(2*K*s + f*(s - 1) + s - 1) + s*(-4*K*s + 2*K + f + 1)) - 2*D1*bdd1*f*s*(b2 - 2*g2)*(r + s) - 2*bd1*(D1*(f*s*(bd2*(2*r + 2*s - 1) + 4*g2*(r + s) + gd2*(-4*r - 4*s + 2)) + 2*fd*g2*(-2*r*s + r - s*(2*s - 2))) - 2*Dd*f*g2*(r*(8*s - 1) + 4*s*(2*s - 1)) + b2*(D1*(-2*f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + b1**2*(D1**2*(r + s - 1)*(f*(fd - fdd)*(2*r - 1) + fd**2*(1 - 2*r) + 2*fd*(2*K*(s - 1) + r) - fdd*(2*K*(s - 1) + r)) + D1*(Dd*(f**2*(4*r**2 + r*(4*s - 5) - 2*s + 2) + f*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(2*r - 1)*(8*r + 8*s - 7) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) - fd*(2*K*(8*r*s - 5*r + 8*s**2 - 12*s + 4) + 8*r**2 + 8*r*s - 9*r - 2*s + 2)) - Ddd*f*(K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + 4*r**2 + 4*r*s - 5*r - 2*s + 2)) - Dd**2*f*(K*(24*r*s - 6*r + 24*s**2 - 24*s + 4) + f*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4) + 12*r**2 + 12*r*s - 15*r - 6*s + 4)) + b1*(-D1**2*bdd1*f*(4*K*s**2 - 2*K*s + f*(2*r**2 + 2*r*(s - 1) - s + 1) + 2*r**2 + 2*r*(2*K*s + s - 1) - s + 1) - 2*D1**2*bdd2*f*r*s - 2*D1**2*bdd2*f*s**2 + 2*D1**2*bdd2*f*s - 8*D1**2*f*gd2*r*s - 8*D1**2*f*gd2*s**2 + 8*D1**2*f*gd2*s + 4*D1**2*f*gdd2*r*s + 4*D1**2*f*gdd2*s**2 - 4*D1**2*f*gdd2*s - 8*D1**2*fd*g2*r*s + 8*D1**2*fd*g2*r - 8*D1**2*fd*g2*s**2 + 16*D1**2*fd*g2*s - 8*D1**2*fd*g2 + 8*D1**2*fd*gd2*r*s - 4*D1**2*fd*gd2*r + 8*D1**2*fd*gd2*s**2 - 12*D1**2*fd*gd2*s + 4*D1**2*fd*gd2 + 4*D1**2*fdd*g2*r*s - 4*D1**2*fdd*g2*r + 4*D1**2*fdd*g2*s**2 - 8*D1**2*fdd*g2*s + 4*D1**2*fdd*g2 - 32*D1*Dd*f*g2*r*s + 8*D1*Dd*f*g2*r - 32*D1*Dd*f*g2*s**2 + 32*D1*Dd*f*g2*s - 8*D1*Dd*f*g2 + 32*D1*Dd*f*gd2*r*s - 4*D1*Dd*f*gd2*r + 32*D1*Dd*f*gd2*s**2 - 32*D1*Dd*f*gd2*s + 4*D1*Dd*f*gd2 + 32*D1*Dd*fd*g2*r*s - 20*D1*Dd*fd*g2*r + 32*D1*Dd*fd*g2*s**2 - 48*D1*Dd*fd*g2*s + 16*D1*Dd*fd*g2 + 16*D1*Ddd*f*g2*r*s - 4*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s**2 - 16*D1*Ddd*f*g2*s + 4*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(2*r**2 + 2*r*(s - 1) - s + 1) + f*(8*K*s**2 - 4*K*s - fd*(2*r - 1)*(4*r + 4*s - 3) + 4*r**2 + 4*r*(2*K*s + s - 1) - 2*s + 2) + fd*(-2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r**2 - 4*r*(s - 1) + s - 1)) - Dd*f*(K*(32*r*s - 4*r + 32*s**2 - 24*s + 2) + f*(2*r - 1)*(8*r + 8*s - 5) + (2*r - 1)*(8*r + 8*s - 5))) + 2*D1*bd2*(D1*(r + s - 1)*(2*f*s - 2*fd*s + fd) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 48*Dd**2*f*g2*r*s - 12*Dd**2*f*g2*r + 48*Dd**2*f*g2*s**2 - 48*Dd**2*f*g2*s + 8*Dd**2*f*g2 + 2*b2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(7*d**2*k3) + D1**2*Pk2*Pkd3*st**2*(D1*(2*D1*bd1**2*f*(7*K*s*(5*s - 3) + r**2*(7*K + 2) + r*(7*K*(6*s - 1) + 2*s - 1)) + D1*bdd1*f*(r**2 + 6*r*s + 5*s**2)*(-2*C*f + 7*b2 + f - 14*g2) + bd1*(-2*C*D1*f**2*r**2 + 12*C*D1*f**2*r*s + 14*C*D1*f**2*s**2 - 8*C*D1*f*fd*r**2 - 48*C*D1*f*fd*r*s + 16*C*D1*f*fd*r - 40*C*D1*f*fd*s**2 + 32*C*D1*f*fd*s - 16*C*Dd*f**2*r**2 - 96*C*Dd*f**2*r*s + 20*C*Dd*f**2*r - 80*C*Dd*f**2*s**2 + 44*C*Dd*f**2*s + 14*D1*bd2*f*(r**2 + r*(6*s - 1) + s*(5*s - 3)) + 3*D1*f**2*r**2 - 4*D1*f**2*r*s - 7*D1*f**2*s**2 + 4*D1*f*fd*r**2 + 24*D1*f*fd*r*s - 8*D1*f*fd*r + 20*D1*f*fd*s**2 - 16*D1*f*fd*s - 14*D1*f*g2*r**2 + 84*D1*f*g2*r*s + 98*D1*f*g2*s**2 - 28*D1*f*gd2*r**2 - 168*D1*f*gd2*r*s + 28*D1*f*gd2*r - 140*D1*f*gd2*s**2 + 84*D1*f*gd2*s - 28*D1*fd*g2*r**2 - 168*D1*fd*g2*r*s + 84*D1*fd*g2*r - 140*D1*fd*g2*s**2 + 140*D1*fd*g2*s + 8*Dd*f**2*r**2 + 48*Dd*f**2*r*s - 10*Dd*f**2*r + 40*Dd*f**2*s**2 - 22*Dd*f**2*s - 112*Dd*f*g2*r**2 - 672*Dd*f*g2*r*s + 140*Dd*f*g2*r - 560*Dd*f*g2*s**2 + 308*Dd*f*g2*s + 7*b2*(D1*(f*(r**2 - 6*r*s - 7*s**2) + 2*fd*(r**2 + r*(6*s - 3) + s*(5*s - 5))) + 2*Dd*f*(4*r**2 + r*(24*s - 5) + s*(20*s - 11))))) + 14*b1**3*(D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(Dd*(f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 - 8*r*s + 13*r + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) - Ddd*(f + 1)*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - Dd**2*(f + 1)*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) + b1**2*(7*D1**2*K*fd*r**2 - 42*D1**2*K*fd*r*s + 42*D1**2*K*fd*r - 49*D1**2*K*fd*s**2 + 98*D1**2*K*fd*s - 49*D1**2*K*fd + 7*D1**2*K*fdd*r**2 + 42*D1**2*K*fdd*r*s - 42*D1**2*K*fdd*r + 35*D1**2*K*fdd*s**2 - 70*D1**2*K*fdd*s + 35*D1**2*K*fdd - 14*D1**2*bdd1*(f + 1)*(3*r**2 + 3*r*(s - 1) - s + 1) - 18*D1**2*fd*r**2 - 18*D1**2*fd*r*s + 22*D1**2*fd*r + 4*D1**2*fd*s - 4*D1**2*fd + 2*D1**2*fdd*r**2 + 2*D1**2*fdd*r*s - 4*D1**2*fdd*r - 2*D1**2*fdd*s + 2*D1**2*fdd + 28*D1*Dd*K*f*r**2 - 168*D1*Dd*K*f*r*s + 14*D1*Dd*K*f*r - 196*D1*Dd*K*f*s**2 + 182*D1*Dd*K*f*s - 35*D1*Dd*K*f + 56*D1*Dd*K*fd*r**2 + 336*D1*Dd*K*fd*r*s - 238*D1*Dd*K*fd*r + 280*D1*Dd*K*fd*s**2 - 434*D1*Dd*K*fd*s + 154*D1*Dd*K*fd - 72*D1*Dd*f*r**2 - 72*D1*Dd*f*r*s + 90*D1*Dd*f*r + 36*D1*Dd*f*s - 36*D1*Dd*f + 16*D1*Dd*fd*r**2 + 16*D1*Dd*fd*r*s - 26*D1*Dd*fd*r - 12*D1*Dd*fd*s + 10*D1*Dd*fd + 28*D1*Ddd*K*f*r**2 + 168*D1*Ddd*K*f*r*s - 70*D1*Ddd*K*f*r + 140*D1*Ddd*K*f*s**2 - 154*D1*Ddd*K*f*s + 49*D1*Ddd*K*f + 8*D1*Ddd*f*r**2 + 8*D1*Ddd*f*r*s - 10*D1*Ddd*f*r - 4*D1*Ddd*f*s + 4*D1*Ddd*f + 14*D1*bd1*(D1*(f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 - 6*r*s + 9*r + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) - Dd*(f + 1)*(24*r**2 + 3*r*(8*s - 9) - 10*s + 7)) + 84*Dd**2*K*f*r**2 + 504*Dd**2*K*f*r*s - 210*Dd**2*K*f*r + 420*Dd**2*K*f*s**2 - 462*Dd**2*K*f*s + 98*Dd**2*K*f + 24*Dd**2*f*r**2 + 24*Dd**2*f*r*s - 30*Dd**2*f*r - 12*Dd**2*f*s + 8*Dd**2*f) + b1*(-4*C*D1**2*f*fd*r**2 + 24*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r + 28*C*D1**2*f*fd*s**2 - 40*C*D1**2*f*fd*s + 12*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r*s + 16*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 32*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 - 24*C*D1**2*fd**2*r*s + 16*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 32*C*D1**2*fd**2*s - 12*C*D1**2*fd**2 - 8*C*D1*Dd*f**2*r**2 + 48*C*D1*Dd*f**2*r*s - 4*C*D1*Dd*f**2*r + 56*C*D1*Dd*f**2*s**2 - 52*C*D1*Dd*f**2*s + 10*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 - 192*C*D1*Dd*f*fd*r*s + 104*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 216*C*D1*Dd*f*fd*s - 64*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 - 48*C*D1*Ddd*f**2*r*s + 20*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 44*C*D1*Ddd*f**2*s - 14*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 - 144*C*Dd**2*f**2*r*s + 60*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 132*C*Dd**2*f**2*s - 28*C*Dd**2*f**2 + 14*D1**2*K*bdd1*f*r**2 + 84*D1**2*K*bdd1*f*r*s - 14*D1**2*K*bdd1*f*r + 70*D1**2*K*bdd1*f*s**2 - 42*D1**2*K*bdd1*f*s + 7*D1**2*K*bdd1*f + 7*D1**2*b2*fd*r**2 - 42*D1**2*b2*fd*r*s + 42*D1**2*b2*fd*r - 49*D1**2*b2*fd*s**2 + 98*D1**2*b2*fd*s - 49*D1**2*b2*fd + 7*D1**2*b2*fdd*r**2 + 42*D1**2*b2*fdd*r*s - 42*D1**2*b2*fdd*r + 35*D1**2*b2*fdd*s**2 - 70*D1**2*b2*fdd*s + 35*D1**2*b2*fdd - 14*D1**2*bd1**2*(f + 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 4*D1**2*bdd1*f*r**2 + 4*D1**2*bdd1*f*r*s - 2*D1**2*bdd1*f*r + 7*D1**2*bdd2*f*r**2 + 42*D1**2*bdd2*f*r*s - 14*D1**2*bdd2*f*r + 35*D1**2*bdd2*f*s**2 - 42*D1**2*bdd2*f*s + 7*D1**2*bdd2*f + 6*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s - 2*D1**2*f*fd*r - 14*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s - 4*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 8*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 16*D1**2*f*fdd*s + 6*D1**2*f*fdd - 14*D1**2*f*gd2*r**2 + 84*D1**2*f*gd2*r*s + 28*D1**2*f*gd2*r + 98*D1**2*f*gd2*s**2 - 84*D1**2*f*gd2*s - 14*D1**2*f*gd2 - 14*D1**2*f*gdd2*r**2 - 84*D1**2*f*gdd2*r*s + 28*D1**2*f*gdd2*r - 70*D1**2*f*gdd2*s**2 + 84*D1**2*f*gdd2*s - 14*D1**2*f*gdd2 + 2*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 8*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 16*D1**2*fd**2*s + 6*D1**2*fd**2 - 14*D1**2*fd*g2*r**2 + 84*D1**2*fd*g2*r*s - 84*D1**2*fd*g2*r + 98*D1**2*fd*g2*s**2 - 196*D1**2*fd*g2*s + 98*D1**2*fd*g2 - 28*D1**2*fd*gd2*r**2 - 168*D1**2*fd*gd2*r*s + 112*D1**2*fd*gd2*r - 140*D1**2*fd*gd2*s**2 + 224*D1**2*fd*gd2*s - 84*D1**2*fd*gd2 - 14*D1**2*fdd*g2*r**2 - 84*D1**2*fdd*g2*r*s + 84*D1**2*fdd*g2*r - 70*D1**2*fdd*g2*s**2 + 140*D1**2*fdd*g2*s - 70*D1**2*fdd*g2 + 28*D1*Dd*b2*f*r**2 - 168*D1*Dd*b2*f*r*s + 14*D1*Dd*b2*f*r - 196*D1*Dd*b2*f*s**2 + 182*D1*Dd*b2*f*s - 35*D1*Dd*b2*f + 56*D1*Dd*b2*fd*r**2 + 336*D1*Dd*b2*fd*r*s - 238*D1*Dd*b2*fd*r + 280*D1*Dd*b2*fd*s**2 - 434*D1*Dd*b2*fd*s + 154*D1*Dd*b2*fd + 12*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r - 28*D1*Dd*f**2*s**2 + 22*D1*Dd*f**2*s - D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 52*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 108*D1*Dd*f*fd*s + 32*D1*Dd*f*fd - 56*D1*Dd*f*g2*r**2 + 336*D1*Dd*f*g2*r*s - 28*D1*Dd*f*g2*r + 392*D1*Dd*f*g2*s**2 - 364*D1*Dd*f*g2*s + 70*D1*Dd*f*g2 - 112*D1*Dd*f*gd2*r**2 - 672*D1*Dd*f*gd2*r*s + 252*D1*Dd*f*gd2*r - 560*D1*Dd*f*gd2*s**2 + 644*D1*Dd*f*gd2*s - 140*D1*Dd*f*gd2 - 112*D1*Dd*fd*g2*r**2 - 672*D1*Dd*fd*g2*r*s + 476*D1*Dd*fd*g2*r - 560*D1*Dd*fd*g2*s**2 + 868*D1*Dd*fd*g2*s - 308*D1*Dd*fd*g2 + 28*D1*Ddd*b2*f*r**2 + 168*D1*Ddd*b2*f*r*s - 70*D1*Ddd*b2*f*r + 140*D1*Ddd*b2*f*s**2 - 154*D1*Ddd*b2*f*s + 49*D1*Ddd*b2*f + 4*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 10*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 22*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 - 56*D1*Ddd*f*g2*r**2 - 336*D1*Ddd*f*g2*r*s + 140*D1*Ddd*f*g2*r - 280*D1*Ddd*f*g2*s**2 + 308*D1*Ddd*f*g2*s - 98*D1*Ddd*f*g2 + D1*bd1*(D1*f*(7*K*(2*r**2 - 2*r*(6*s + 1) - 14*s**2 + 6*s + 1) - 36*r**2 - 4*r*(9*s - 8) + 14*s - 14) + 2*D1*fd*(7*K*(2*r**2 + 12*r*s - 7*r + 10*s**2 - 13*s + 3) + 4*r**2 + 4*r*s - 5*r - 2*s + 1) + 14*Dd*K*f*(8*r**2 + 2*r*(24*s - 7) + 40*s**2 - 34*s + 5) + 4*Dd*f*(8*r**2 + r*(8*s - 7) - 2*s + 1)) + 7*D1*bd2*(D1*(f*(r - 7*s - 1) + 2*fd*(r + 5*s - 3))*(r + s - 1) + 2*Dd*f*(4*r**2 + 3*r*(8*s - 3) + 20*s**2 - 23*s + 5)) + 84*Dd**2*b2*f*r**2 + 504*Dd**2*b2*f*r*s - 210*Dd**2*b2*f*r + 420*Dd**2*b2*f*s**2 - 462*Dd**2*b2*f*s + 98*Dd**2*b2*f + 12*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 30*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 66*Dd**2*f**2*s + 14*Dd**2*f**2 - 168*Dd**2*f*g2*r**2 - 1008*Dd**2*f*g2*r*s + 420*Dd**2*f*g2*r - 840*Dd**2*f*g2*s**2 + 924*Dd**2*f*g2*s - 196*Dd**2*f*g2))/(42*d**2*k3) + D1**2*Pk2*Pkd3*(-2*D1**2*bd1**2*f*(2*C - 1)*(11*r**2 + 9*r*(2*s - 1) + s*(7*s - 7)) + D1*b1*(D1*bd1*(f*(2*C*(2*r**2 - 12*r*s + 6*r - 14*s**2 + 14*s - 7) + 26*r**2 + 40*r*s - 20*r + 14*s**2 - 14*s + 7) + fd*(2 - 4*C)*(22*r**2 + r*(36*s - 31) + 14*s**2 - 25*s + 9)) - D1*bdd1*f*(2*C - 1)*(22*r**2 + 36*r*s - 18*r + 14*s**2 - 14*s + 7) - 2*Dd*bd1*f*(2*C - 1)*(88*r**2 + 2*r*(72*s - 49) + 56*s**2 - 78*s + 25)) + b1**2*(D1**2*(fd*(2*C*(r - 7*s - 1) + 13*r + 7*s - 13) - fdd*(2*C - 1)*(11*r + 7*s - 11))*(r + s - 1) + D1*(Dd*(f*(2*C*(4*r**2 - 24*r*s + 2*r - 28*s**2 + 26*s - 5) + 52*r**2 + 80*r*s - 72*r + 28*s**2 - 54*s + 33) + fd*(2 - 4*C)*(44*r**2 + r*(72*s - 75) + 28*s**2 - 61*s + 31)) - Ddd*f*(2*C - 1)*(44*r**2 + r*(72*s - 62) + 28*s**2 - 50*s + 29)) - Dd**2*f*(4*C - 2)*(66*r**2 + 3*r*(36*s - 31) + 42*s**2 - 75*s + 29)))/(21*d**2*k3) - 5*D1**2*Pk2*Pkdd3*ct**8*k1**2*k2**4*(4368*C*D1**2*f**2*fd*r**2 + 8736*C*D1**2*f**2*fd*r*s - 5824*C*D1**2*f**2*fd*r + 4368*C*D1**2*f**2*fd*s**2 - 5824*C*D1**2*f**2*fd*s + 2912*C*D1**2*f**2*fd - 2184*C*D1**2*f**2*fdd*r**2 - 4368*C*D1**2*f**2*fdd*r*s + 2912*C*D1**2*f**2*fdd*r - 2184*C*D1**2*f**2*fdd*s**2 + 2912*C*D1**2*f**2*fdd*s - 1456*C*D1**2*f**2*fdd - 4368*C*D1**2*f*fd**2*r**2 - 8736*C*D1**2*f*fd**2*r*s + 5824*C*D1**2*f*fd**2*r - 4368*C*D1**2*f*fd**2*s**2 + 5824*C*D1**2*f*fd**2*s - 1456*C*D1**2*f*fd**2 + 5824*C*D1*Dd*f**3*r**2 + 11648*C*D1*Dd*f**3*r*s - 8736*C*D1*Dd*f**3*r + 5824*C*D1*Dd*f**3*s**2 - 8736*C*D1*Dd*f**3*s + 4368*C*D1*Dd*f**3 - 17472*C*D1*Dd*f**2*fd*r**2 - 34944*C*D1*Dd*f**2*fd*r*s + 24752*C*D1*Dd*f**2*fd*r - 17472*C*D1*Dd*f**2*fd*s**2 + 24752*C*D1*Dd*f**2*fd*s - 8736*C*D1*Dd*f**2*fd - 2912*C*D1*Ddd*f**3*r**2 - 5824*C*D1*Ddd*f**3*r*s + 4368*C*D1*Ddd*f**3*r - 2912*C*D1*Ddd*f**3*s**2 + 4368*C*D1*Ddd*f**3*s - 2184*C*D1*Ddd*f**3 - 8736*C*Dd**2*f**3*r**2 - 17472*C*Dd**2*f**3*r*s + 13104*C*Dd**2*f**3*r - 8736*C*Dd**2*f**3*s**2 + 13104*C*Dd**2*f**3*s - 4368*C*Dd**2*f**3 + 1716*D1**2*K*b1*f*fd*r**2 + 3432*D1**2*K*b1*f*fd*r*s - 1716*D1**2*K*b1*f*fd*r + 1716*D1**2*K*b1*f*fd*s**2 - 1716*D1**2*K*b1*f*fd*s + 858*D1**2*K*b1*f*fd - 858*D1**2*K*b1*f*fdd*r**2 - 1716*D1**2*K*b1*f*fdd*r*s + 858*D1**2*K*b1*f*fdd*r - 858*D1**2*K*b1*f*fdd*s**2 + 858*D1**2*K*b1*f*fdd*s - 429*D1**2*K*b1*f*fdd - 858*D1**2*K*b1*fd**2*r**2 - 1716*D1**2*K*b1*fd**2*r*s + 858*D1**2*K*b1*fd**2*r - 858*D1**2*K*b1*fd**2*s**2 + 858*D1**2*K*b1*fd**2*s - 1716*D1**2*b1*f*fd*r**2 - 3432*D1**2*b1*f*fd*r*s + 1716*D1**2*b1*f*fd*r - 1716*D1**2*b1*f*fd*s**2 + 1716*D1**2*b1*f*fd*s - 858*D1**2*b1*f*fd + 858*D1**2*b1*f*fdd*r**2 + 1716*D1**2*b1*f*fdd*r*s - 858*D1**2*b1*f*fdd*r + 858*D1**2*b1*f*fdd*s**2 - 858*D1**2*b1*f*fdd*s + 429*D1**2*b1*f*fdd + 858*D1**2*b1*fd**2*r**2 + 1716*D1**2*b1*fd**2*r*s - 858*D1**2*b1*fd**2*r + 858*D1**2*b1*fd**2*s**2 - 858*D1**2*b1*fd**2*s - 429*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 2520*D1**2*f**3*fd*r**2 + 5040*D1**2*f**3*fd*r*s - 3780*D1**2*f**3*fd*r + 2520*D1**2*f**3*fd*s**2 - 3780*D1**2*f**3*fd*s + 1890*D1**2*f**3*fd - 1260*D1**2*f**3*fdd*r**2 - 2520*D1**2*f**3*fdd*r*s + 1890*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s**2 + 1890*D1**2*f**3*fdd*s - 945*D1**2*f**3*fdd - 3780*D1**2*f**2*fd**2*r**2 - 7560*D1**2*f**2*fd**2*r*s + 5670*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s**2 + 5670*D1**2*f**2*fd**2*s - 1890*D1**2*f**2*fd**2 - 4368*D1**2*f**2*fd*r**2 - 8736*D1**2*f**2*fd*r*s + 5824*D1**2*f**2*fd*r - 4368*D1**2*f**2*fd*s**2 + 5824*D1**2*f**2*fd*s - 2912*D1**2*f**2*fd + 2184*D1**2*f**2*fdd*r**2 + 4368*D1**2*f**2*fdd*r*s - 2912*D1**2*f**2*fdd*r + 2184*D1**2*f**2*fdd*s**2 - 2912*D1**2*f**2*fdd*s + 1456*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 858*D1**2*f**2*gdd2*r**2 + 1716*D1**2*f**2*gdd2*r*s - 1716*D1**2*f**2*gdd2*r + 858*D1**2*f**2*gdd2*s**2 - 1716*D1**2*f**2*gdd2*s + 858*D1**2*f**2*gdd2 + 4368*D1**2*f*fd**2*r**2 + 8736*D1**2*f*fd**2*r*s - 5824*D1**2*f*fd**2*r + 4368*D1**2*f*fd**2*s**2 - 5824*D1**2*f*fd**2*s + 1456*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r**2 + 6864*D1**2*f*fd*gd2*r*s - 5148*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1716*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r**2 + 3432*D1**2*f*fdd*g2*r*s - 1716*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r**2 + 3432*D1**2*fd**2*g2*r*s - 1716*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 3432*D1*Dd*K*b1*f**2*r**2 + 6864*D1*Dd*K*b1*f**2*r*s - 5148*D1*Dd*K*b1*f**2*r + 3432*D1*Dd*K*b1*f**2*s**2 - 5148*D1*Dd*K*b1*f**2*s + 2574*D1*Dd*K*b1*f**2 - 6864*D1*Dd*K*b1*f*fd*r**2 - 13728*D1*Dd*K*b1*f*fd*r*s + 8580*D1*Dd*K*b1*f*fd*r - 6864*D1*Dd*K*b1*f*fd*s**2 + 8580*D1*Dd*K*b1*f*fd*s - 2574*D1*Dd*K*b1*f*fd - 3432*D1*Dd*b1*f**2*r**2 - 6864*D1*Dd*b1*f**2*r*s + 5148*D1*Dd*b1*f**2*r - 3432*D1*Dd*b1*f**2*s**2 + 5148*D1*Dd*b1*f**2*s - 2574*D1*Dd*b1*f**2 + 6864*D1*Dd*b1*f*fd*r**2 + 13728*D1*Dd*b1*f*fd*r*s - 8580*D1*Dd*b1*f*fd*r + 6864*D1*Dd*b1*f*fd*s**2 - 8580*D1*Dd*b1*f*fd*s + 2574*D1*Dd*b1*f*fd + 2520*D1*Dd*f**4*r**2 + 5040*D1*Dd*f**4*r*s - 3780*D1*Dd*f**4*r + 2520*D1*Dd*f**4*s**2 - 3780*D1*Dd*f**4*s + 1890*D1*Dd*f**4 - 10080*D1*Dd*f**3*fd*r**2 - 20160*D1*Dd*f**3*fd*r*s + 15120*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s**2 + 15120*D1*Dd*f**3*fd*s - 5670*D1*Dd*f**3*fd - 5824*D1*Dd*f**3*r**2 - 11648*D1*Dd*f**3*r*s + 8736*D1*Dd*f**3*r - 5824*D1*Dd*f**3*s**2 + 8736*D1*Dd*f**3*s - 4368*D1*Dd*f**3 + 17472*D1*Dd*f**2*fd*r**2 + 34944*D1*Dd*f**2*fd*r*s - 24752*D1*Dd*f**2*fd*r + 17472*D1*Dd*f**2*fd*s**2 - 24752*D1*Dd*f**2*fd*s + 8736*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r**2 + 13728*D1*Dd*f**2*gd2*r*s - 12012*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 12012*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r**2 + 27456*D1*Dd*f*fd*g2*r*s - 17160*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 17160*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 - 1716*D1*Ddd*K*b1*f**2*r**2 - 3432*D1*Ddd*K*b1*f**2*r*s + 2574*D1*Ddd*K*b1*f**2*r - 1716*D1*Ddd*K*b1*f**2*s**2 + 2574*D1*Ddd*K*b1*f**2*s - 1287*D1*Ddd*K*b1*f**2 + 1716*D1*Ddd*b1*f**2*r**2 + 3432*D1*Ddd*b1*f**2*r*s - 2574*D1*Ddd*b1*f**2*r + 1716*D1*Ddd*b1*f**2*s**2 - 2574*D1*Ddd*b1*f**2*s + 1287*D1*Ddd*b1*f**2 - 1260*D1*Ddd*f**4*r**2 - 2520*D1*Ddd*f**4*r*s + 1890*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s**2 + 1890*D1*Ddd*f**4*s - 945*D1*Ddd*f**4 + 2912*D1*Ddd*f**3*r**2 + 5824*D1*Ddd*f**3*r*s - 4368*D1*Ddd*f**3*r + 2912*D1*Ddd*f**3*s**2 - 4368*D1*Ddd*f**3*s + 2184*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r**2 + 6864*D1*Ddd*f**2*g2*r*s - 5148*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 5148*Dd**2*K*b1*f**2*r**2 - 10296*Dd**2*K*b1*f**2*r*s + 7722*Dd**2*K*b1*f**2*r - 5148*Dd**2*K*b1*f**2*s**2 + 7722*Dd**2*K*b1*f**2*s - 2574*Dd**2*K*b1*f**2 + 5148*Dd**2*b1*f**2*r**2 + 10296*Dd**2*b1*f**2*r*s - 7722*Dd**2*b1*f**2*r + 5148*Dd**2*b1*f**2*s**2 - 7722*Dd**2*b1*f**2*s + 2574*Dd**2*b1*f**2 - 3780*Dd**2*f**4*r**2 - 7560*Dd**2*f**4*r*s + 5670*Dd**2*f**4*r - 3780*Dd**2*f**4*s**2 + 5670*Dd**2*f**4*s - 1890*Dd**2*f**4 + 8736*Dd**2*f**3*r**2 + 17472*Dd**2*f**3*r*s - 13104*Dd**2*f**3*r + 8736*Dd**2*f**3*s**2 - 13104*Dd**2*f**3*s + 4368*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r**2 + 20592*Dd**2*f**2*g2*r*s - 15444*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2)/(9009*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**7*k1**3*k2**3*(61620*C*D1**2*f**2*fd*r**2 + 123240*C*D1**2*f**2*fd*r*s - 82160*C*D1**2*f**2*fd*r + 61620*C*D1**2*f**2*fd*s**2 - 82160*C*D1**2*f**2*fd*s + 41080*C*D1**2*f**2*fd - 43680*C*D1**2*f**2*fdd*r**2 - 87360*C*D1**2*f**2*fdd*r*s + 58240*C*D1**2*f**2*fdd*r - 43680*C*D1**2*f**2*fdd*s**2 + 58240*C*D1**2*f**2*fdd*s - 29120*C*D1**2*f**2*fdd - 87360*C*D1**2*f*fd**2*r**2 - 174720*C*D1**2*f*fd**2*r*s + 116480*C*D1**2*f*fd**2*r - 87360*C*D1**2*f*fd**2*s**2 + 116480*C*D1**2*f*fd**2*s - 29120*C*D1**2*f*fd**2 + 82160*C*D1*Dd*f**3*r**2 + 164320*C*D1*Dd*f**3*r*s - 123240*C*D1*Dd*f**3*r + 82160*C*D1*Dd*f**3*s**2 - 123240*C*D1*Dd*f**3*s + 61620*C*D1*Dd*f**3 - 349440*C*D1*Dd*f**2*fd*r**2 - 698880*C*D1*Dd*f**2*fd*r*s + 495040*C*D1*Dd*f**2*fd*r - 349440*C*D1*Dd*f**2*fd*s**2 + 495040*C*D1*Dd*f**2*fd*s - 174720*C*D1*Dd*f**2*fd - 58240*C*D1*Ddd*f**3*r**2 - 116480*C*D1*Ddd*f**3*r*s + 87360*C*D1*Ddd*f**3*r - 58240*C*D1*Ddd*f**3*s**2 + 87360*C*D1*Ddd*f**3*s - 43680*C*D1*Ddd*f**3 - 174720*C*Dd**2*f**3*r**2 - 349440*C*Dd**2*f**3*r*s + 262080*C*Dd**2*f**3*r - 174720*C*Dd**2*f**3*s**2 + 262080*C*Dd**2*f**3*s - 87360*C*Dd**2*f**3 + 24024*D1**2*K*b1*f*fd*r**2 + 48048*D1**2*K*b1*f*fd*r*s - 24024*D1**2*K*b1*f*fd*r + 24024*D1**2*K*b1*f*fd*s**2 - 24024*D1**2*K*b1*f*fd*s + 12012*D1**2*K*b1*f*fd - 17160*D1**2*K*b1*f*fdd*r**2 - 34320*D1**2*K*b1*f*fdd*r*s + 17160*D1**2*K*b1*f*fdd*r - 17160*D1**2*K*b1*f*fdd*s**2 + 17160*D1**2*K*b1*f*fdd*s - 8580*D1**2*K*b1*f*fdd - 17160*D1**2*K*b1*fd**2*r**2 - 34320*D1**2*K*b1*fd**2*r*s + 17160*D1**2*K*b1*fd**2*r - 17160*D1**2*K*b1*fd**2*s**2 + 17160*D1**2*K*b1*fd**2*s - 24024*D1**2*b1*f*fd*r**2 - 48048*D1**2*b1*f*fd*r*s + 24024*D1**2*b1*f*fd*r - 24024*D1**2*b1*f*fd*s**2 + 24024*D1**2*b1*f*fd*s - 12012*D1**2*b1*f*fd + 17160*D1**2*b1*f*fdd*r**2 + 34320*D1**2*b1*f*fdd*r*s - 17160*D1**2*b1*f*fdd*r + 17160*D1**2*b1*f*fdd*s**2 - 17160*D1**2*b1*f*fdd*s + 8580*D1**2*b1*f*fdd + 17160*D1**2*b1*fd**2*r**2 + 34320*D1**2*b1*fd**2*r*s - 17160*D1**2*b1*fd**2*r + 17160*D1**2*b1*fd**2*s**2 - 17160*D1**2*b1*fd**2*s - 8580*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 48440*D1**2*f**3*fd*r**2 + 96880*D1**2*f**3*fd*r*s - 72660*D1**2*f**3*fd*r + 48440*D1**2*f**3*fd*s**2 - 72660*D1**2*f**3*fd*s + 36330*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 - 61620*D1**2*f**2*fd*r**2 - 123240*D1**2*f**2*fd*r*s + 82160*D1**2*f**2*fd*r - 61620*D1**2*f**2*fd*s**2 + 82160*D1**2*f**2*fd*s - 41080*D1**2*f**2*fd + 43680*D1**2*f**2*fdd*r**2 + 87360*D1**2*f**2*fdd*r*s - 58240*D1**2*f**2*fdd*r + 43680*D1**2*f**2*fdd*s**2 - 58240*D1**2*f**2*fdd*s + 29120*D1**2*f**2*fdd - 24024*D1**2*f**2*gd2*r**2 - 48048*D1**2*f**2*gd2*r*s + 48048*D1**2*f**2*gd2*r - 24024*D1**2*f**2*gd2*s**2 + 48048*D1**2*f**2*gd2*s - 24024*D1**2*f**2*gd2 + 17160*D1**2*f**2*gdd2*r**2 + 34320*D1**2*f**2*gdd2*r*s - 34320*D1**2*f**2*gdd2*r + 17160*D1**2*f**2*gdd2*s**2 - 34320*D1**2*f**2*gdd2*s + 17160*D1**2*f**2*gdd2 + 87360*D1**2*f*fd**2*r**2 + 174720*D1**2*f*fd**2*r*s - 116480*D1**2*f*fd**2*r + 87360*D1**2*f*fd**2*s**2 - 116480*D1**2*f*fd**2*s + 29120*D1**2*f*fd**2 - 48048*D1**2*f*fd*g2*r**2 - 96096*D1**2*f*fd*g2*r*s + 48048*D1**2*f*fd*g2*r - 48048*D1**2*f*fd*g2*s**2 + 48048*D1**2*f*fd*g2*s - 24024*D1**2*f*fd*g2 + 68640*D1**2*f*fd*gd2*r**2 + 137280*D1**2*f*fd*gd2*r*s - 102960*D1**2*f*fd*gd2*r + 68640*D1**2*f*fd*gd2*s**2 - 102960*D1**2*f*fd*gd2*s + 34320*D1**2*f*fd*gd2 + 34320*D1**2*f*fdd*g2*r**2 + 68640*D1**2*f*fdd*g2*r*s - 34320*D1**2*f*fdd*g2*r + 34320*D1**2*f*fdd*g2*s**2 - 34320*D1**2*f*fdd*g2*s + 17160*D1**2*f*fdd*g2 + 34320*D1**2*fd**2*g2*r**2 + 68640*D1**2*fd**2*g2*r*s - 34320*D1**2*fd**2*g2*r + 34320*D1**2*fd**2*g2*s**2 - 34320*D1**2*fd**2*g2*s + 48048*D1*Dd*K*b1*f**2*r**2 + 96096*D1*Dd*K*b1*f**2*r*s - 72072*D1*Dd*K*b1*f**2*r + 48048*D1*Dd*K*b1*f**2*s**2 - 72072*D1*Dd*K*b1*f**2*s + 36036*D1*Dd*K*b1*f**2 - 137280*D1*Dd*K*b1*f*fd*r**2 - 274560*D1*Dd*K*b1*f*fd*r*s + 171600*D1*Dd*K*b1*f*fd*r - 137280*D1*Dd*K*b1*f*fd*s**2 + 171600*D1*Dd*K*b1*f*fd*s - 51480*D1*Dd*K*b1*f*fd - 48048*D1*Dd*b1*f**2*r**2 - 96096*D1*Dd*b1*f**2*r*s + 72072*D1*Dd*b1*f**2*r - 48048*D1*Dd*b1*f**2*s**2 + 72072*D1*Dd*b1*f**2*s - 36036*D1*Dd*b1*f**2 + 137280*D1*Dd*b1*f*fd*r**2 + 274560*D1*Dd*b1*f*fd*r*s - 171600*D1*Dd*b1*f*fd*r + 137280*D1*Dd*b1*f*fd*s**2 - 171600*D1*Dd*b1*f*fd*s + 51480*D1*Dd*b1*f*fd + 48440*D1*Dd*f**4*r**2 + 96880*D1*Dd*f**4*r*s - 72660*D1*Dd*f**4*r + 48440*D1*Dd*f**4*s**2 - 72660*D1*Dd*f**4*s + 36330*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd - 82160*D1*Dd*f**3*r**2 - 164320*D1*Dd*f**3*r*s + 123240*D1*Dd*f**3*r - 82160*D1*Dd*f**3*s**2 + 123240*D1*Dd*f**3*s - 61620*D1*Dd*f**3 + 349440*D1*Dd*f**2*fd*r**2 + 698880*D1*Dd*f**2*fd*r*s - 495040*D1*Dd*f**2*fd*r + 349440*D1*Dd*f**2*fd*s**2 - 495040*D1*Dd*f**2*fd*s + 174720*D1*Dd*f**2*fd - 96096*D1*Dd*f**2*g2*r**2 - 192192*D1*Dd*f**2*g2*r*s + 144144*D1*Dd*f**2*g2*r - 96096*D1*Dd*f**2*g2*s**2 + 144144*D1*Dd*f**2*g2*s - 72072*D1*Dd*f**2*g2 + 137280*D1*Dd*f**2*gd2*r**2 + 274560*D1*Dd*f**2*gd2*r*s - 240240*D1*Dd*f**2*gd2*r + 137280*D1*Dd*f**2*gd2*s**2 - 240240*D1*Dd*f**2*gd2*s + 102960*D1*Dd*f**2*gd2 + 274560*D1*Dd*f*fd*g2*r**2 + 549120*D1*Dd*f*fd*g2*r*s - 343200*D1*Dd*f*fd*g2*r + 274560*D1*Dd*f*fd*g2*s**2 - 343200*D1*Dd*f*fd*g2*s + 102960*D1*Dd*f*fd*g2 - 34320*D1*Ddd*K*b1*f**2*r**2 - 68640*D1*Ddd*K*b1*f**2*r*s + 51480*D1*Ddd*K*b1*f**2*r - 34320*D1*Ddd*K*b1*f**2*s**2 + 51480*D1*Ddd*K*b1*f**2*s - 25740*D1*Ddd*K*b1*f**2 + 34320*D1*Ddd*b1*f**2*r**2 + 68640*D1*Ddd*b1*f**2*r*s - 51480*D1*Ddd*b1*f**2*r + 34320*D1*Ddd*b1*f**2*s**2 - 51480*D1*Ddd*b1*f**2*s + 25740*D1*Ddd*b1*f**2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 58240*D1*Ddd*f**3*r**2 + 116480*D1*Ddd*f**3*r*s - 87360*D1*Ddd*f**3*r + 58240*D1*Ddd*f**3*s**2 - 87360*D1*Ddd*f**3*s + 43680*D1*Ddd*f**3 + 68640*D1*Ddd*f**2*g2*r**2 + 137280*D1*Ddd*f**2*g2*r*s - 102960*D1*Ddd*f**2*g2*r + 68640*D1*Ddd*f**2*g2*s**2 - 102960*D1*Ddd*f**2*g2*s + 51480*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(7*D1*f*(r + s - 1) - 10*D1*fd*(2*r + 2*s - 1) - 10*Dd*f*(4*r + 4*s - 3)) - 102960*Dd**2*K*b1*f**2*r**2 - 205920*Dd**2*K*b1*f**2*r*s + 154440*Dd**2*K*b1*f**2*r - 102960*Dd**2*K*b1*f**2*s**2 + 154440*Dd**2*K*b1*f**2*s - 51480*Dd**2*K*b1*f**2 + 102960*Dd**2*b1*f**2*r**2 + 205920*Dd**2*b1*f**2*r*s - 154440*Dd**2*b1*f**2*r + 102960*Dd**2*b1*f**2*s**2 - 154440*Dd**2*b1*f**2*s + 51480*Dd**2*b1*f**2 - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 174720*Dd**2*f**3*r**2 + 349440*Dd**2*f**3*r*s - 262080*Dd**2*f**3*r + 174720*Dd**2*f**3*s**2 - 262080*Dd**2*f**3*s + 87360*Dd**2*f**3 + 205920*Dd**2*f**2*g2*r**2 + 411840*Dd**2*f**2*g2*r*s - 308880*Dd**2*f**2*g2*r + 205920*Dd**2*f**2*g2*s**2 - 308880*Dd**2*f**2*g2*s + 102960*Dd**2*f**2*g2)/(9009*d**2*k3**6) + 5*D1**2*Pk2*Pkdd3*ct**7*k1*k2**5*(-672*C*D1**2*f**2*fd*r**2 - 1344*C*D1**2*f**2*fd*r*s + 896*C*D1**2*f**2*fd*r - 672*C*D1**2*f**2*fd*s**2 + 896*C*D1**2*f**2*fd*s - 448*C*D1**2*f**2*fd + 336*C*D1**2*f**2*fdd*r**2 + 672*C*D1**2*f**2*fdd*r*s - 448*C*D1**2*f**2*fdd*r + 336*C*D1**2*f**2*fdd*s**2 - 448*C*D1**2*f**2*fdd*s + 224*C*D1**2*f**2*fdd + 672*C*D1**2*f*fd**2*r**2 + 1344*C*D1**2*f*fd**2*r*s - 896*C*D1**2*f*fd**2*r + 672*C*D1**2*f*fd**2*s**2 - 896*C*D1**2*f*fd**2*s + 224*C*D1**2*f*fd**2 - 896*C*D1*Dd*f**3*r**2 - 1792*C*D1*Dd*f**3*r*s + 1344*C*D1*Dd*f**3*r - 896*C*D1*Dd*f**3*s**2 + 1344*C*D1*Dd*f**3*s - 672*C*D1*Dd*f**3 + 2688*C*D1*Dd*f**2*fd*r**2 + 5376*C*D1*Dd*f**2*fd*r*s - 3808*C*D1*Dd*f**2*fd*r + 2688*C*D1*Dd*f**2*fd*s**2 - 3808*C*D1*Dd*f**2*fd*s + 1344*C*D1*Dd*f**2*fd + 448*C*D1*Ddd*f**3*r**2 + 896*C*D1*Ddd*f**3*r*s - 672*C*D1*Ddd*f**3*r + 448*C*D1*Ddd*f**3*s**2 - 672*C*D1*Ddd*f**3*s + 336*C*D1*Ddd*f**3 + 1344*C*Dd**2*f**3*r**2 + 2688*C*Dd**2*f**3*r*s - 2016*C*Dd**2*f**3*r + 1344*C*Dd**2*f**3*s**2 - 2016*C*Dd**2*f**3*s + 672*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r**2 - 528*D1**2*K*b1*f*fd*r*s + 264*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 132*D1**2*K*b1*f*fdd*s**2 - 132*D1**2*K*b1*f*fdd*s + 66*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 132*D1**2*K*b1*fd**2*s**2 - 132*D1**2*K*b1*fd**2*s + 168*D1**2*b1*f**2*fd*r**2 + 336*D1**2*b1*f**2*fd*r*s - 224*D1**2*b1*f**2*fd*r + 168*D1**2*b1*f**2*fd*s**2 - 224*D1**2*b1*f**2*fd*s + 112*D1**2*b1*f**2*fd - 84*D1**2*b1*f**2*fdd*r**2 - 168*D1**2*b1*f**2*fdd*r*s + 112*D1**2*b1*f**2*fdd*r - 84*D1**2*b1*f**2*fdd*s**2 + 112*D1**2*b1*f**2*fdd*s - 56*D1**2*b1*f**2*fdd - 168*D1**2*b1*f*fd**2*r**2 - 336*D1**2*b1*f*fd**2*r*s + 224*D1**2*b1*f*fd**2*r - 168*D1**2*b1*f*fd**2*s**2 + 224*D1**2*b1*f*fd**2*s - 56*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-66*K + 28*f + 33)*(r + s - 1)**2 + 504*D1**2*f**2*fd*r**2 + 1008*D1**2*f**2*fd*r*s - 672*D1**2*f**2*fd*r + 504*D1**2*f**2*fd*s**2 - 672*D1**2*f**2*fd*s + 336*D1**2*f**2*fd - 252*D1**2*f**2*fdd*r**2 - 504*D1**2*f**2*fdd*r*s + 336*D1**2*f**2*fdd*r - 252*D1**2*f**2*fdd*s**2 + 336*D1**2*f**2*fdd*s - 168*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 504*D1**2*f*fd**2*r**2 - 1008*D1**2*f*fd**2*r*s + 672*D1**2*f*fd**2*r - 504*D1**2*f*fd**2*s**2 + 672*D1**2*f*fd**2*s - 168*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 - 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 792*D1*Dd*K*b1*f**2*s - 396*D1*Dd*K*b1*f**2 + 1056*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1320*D1*Dd*K*b1*f*fd*r + 1056*D1*Dd*K*b1*f*fd*s**2 - 1320*D1*Dd*K*b1*f*fd*s + 396*D1*Dd*K*b1*f*fd + 224*D1*Dd*b1*f**3*r**2 + 448*D1*Dd*b1*f**3*r*s - 336*D1*Dd*b1*f**3*r + 224*D1*Dd*b1*f**3*s**2 - 336*D1*Dd*b1*f**3*s + 168*D1*Dd*b1*f**3 - 672*D1*Dd*b1*f**2*fd*r**2 - 1344*D1*Dd*b1*f**2*fd*r*s + 952*D1*Dd*b1*f**2*fd*r - 672*D1*Dd*b1*f**2*fd*s**2 + 952*D1*Dd*b1*f**2*fd*s - 336*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 672*D1*Dd*f**3*r**2 + 1344*D1*Dd*f**3*r*s - 1008*D1*Dd*f**3*r + 672*D1*Dd*f**3*s**2 - 1008*D1*Dd*f**3*s + 504*D1*Dd*f**3 - 2016*D1*Dd*f**2*fd*r**2 - 4032*D1*Dd*f**2*fd*r*s + 2856*D1*Dd*f**2*fd*r - 2016*D1*Dd*f**2*fd*s**2 + 2856*D1*Dd*f**2*fd*s - 1008*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r + 264*D1*Ddd*K*b1*f**2*s**2 - 396*D1*Ddd*K*b1*f**2*s + 198*D1*Ddd*K*b1*f**2 - 112*D1*Ddd*b1*f**3*r**2 - 224*D1*Ddd*b1*f**3*r*s + 168*D1*Ddd*b1*f**3*r - 112*D1*Ddd*b1*f**3*s**2 + 168*D1*Ddd*b1*f**3*s - 84*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 336*D1*Ddd*f**3*r**2 - 672*D1*Ddd*f**3*r*s + 504*D1*Ddd*f**3*r - 336*D1*Ddd*f**3*s**2 + 504*D1*Ddd*f**3*s - 252*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(28*f**2*(r + s - 1) - 28*f*fd*(3*r + 3*s - 2) - 33*f*(2*K - 1)*(r + s - 1) + 33*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-66*K + 28*f + 33)*(4*r + 4*s - 3))*(r + s - 1) + 792*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r + 792*Dd**2*K*b1*f**2*s**2 - 1188*Dd**2*K*b1*f**2*s + 396*Dd**2*K*b1*f**2 - 336*Dd**2*b1*f**3*r**2 - 672*Dd**2*b1*f**3*r*s + 504*Dd**2*b1*f**3*r - 336*Dd**2*b1*f**3*s**2 + 504*Dd**2*b1*f**3*s - 168*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 1008*Dd**2*f**3*r**2 - 2016*Dd**2*f**3*r*s + 1512*Dd**2*f**3*r - 1008*Dd**2*f**3*s**2 + 1512*Dd**2*f**3*s - 504*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2)/(693*d**2*k3**6) - 5*D1**2*Pk2*Pkdd3*ct**7*k1*k2**3*(168*D1**2*b1*f**2*fd*r**2 + 336*D1**2*b1*f**2*fd*r*s - 224*D1**2*b1*f**2*fd*r + 168*D1**2*b1*f**2*fd*s**2 - 224*D1**2*b1*f**2*fd*s + 112*D1**2*b1*f**2*fd - 84*D1**2*b1*f**2*fdd*r**2 - 168*D1**2*b1*f**2*fdd*r*s + 112*D1**2*b1*f**2*fdd*r - 84*D1**2*b1*f**2*fdd*s**2 + 112*D1**2*b1*f**2*fdd*s - 56*D1**2*b1*f**2*fdd - 168*D1**2*b1*f*fd**2*r**2 - 336*D1**2*b1*f*fd**2*r*s + 224*D1**2*b1*f*fd**2*r - 168*D1**2*b1*f*fd**2*s**2 + 224*D1**2*b1*f*fd**2*s - 56*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(28*f + 33)*(r + s - 1)**2 + 168*D1**2*f**2*fd*r**2 + 336*D1**2*f**2*fd*r*s - 224*D1**2*f**2*fd*r + 168*D1**2*f**2*fd*s**2 - 224*D1**2*f**2*fd*s + 112*D1**2*f**2*fd - 84*D1**2*f**2*fdd*r**2 - 168*D1**2*f**2*fdd*r*s + 112*D1**2*f**2*fdd*r - 84*D1**2*f**2*fdd*s**2 + 112*D1**2*f**2*fdd*s - 56*D1**2*f**2*fdd - 168*D1**2*f*fd**2*r**2 - 336*D1**2*f*fd**2*r*s + 224*D1**2*f*fd**2*r - 168*D1**2*f*fd**2*s**2 + 224*D1**2*f*fd**2*s - 56*D1**2*f*fd**2 + 224*D1*Dd*b1*f**3*r**2 + 448*D1*Dd*b1*f**3*r*s - 336*D1*Dd*b1*f**3*r + 224*D1*Dd*b1*f**3*s**2 - 336*D1*Dd*b1*f**3*s + 168*D1*Dd*b1*f**3 - 672*D1*Dd*b1*f**2*fd*r**2 - 1344*D1*Dd*b1*f**2*fd*r*s + 952*D1*Dd*b1*f**2*fd*r - 672*D1*Dd*b1*f**2*fd*s**2 + 952*D1*Dd*b1*f**2*fd*s - 336*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 224*D1*Dd*f**3*r**2 + 448*D1*Dd*f**3*r*s - 336*D1*Dd*f**3*r + 224*D1*Dd*f**3*s**2 - 336*D1*Dd*f**3*s + 168*D1*Dd*f**3 - 672*D1*Dd*f**2*fd*r**2 - 1344*D1*Dd*f**2*fd*r*s + 952*D1*Dd*f**2*fd*r - 672*D1*Dd*f**2*fd*s**2 + 952*D1*Dd*f**2*fd*s - 336*D1*Dd*f**2*fd - 112*D1*Ddd*b1*f**3*r**2 - 224*D1*Ddd*b1*f**3*r*s + 168*D1*Ddd*b1*f**3*r - 112*D1*Ddd*b1*f**3*s**2 + 168*D1*Ddd*b1*f**3*s - 84*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 112*D1*Ddd*f**3*r**2 - 224*D1*Ddd*f**3*r*s + 168*D1*Ddd*f**3*r - 112*D1*Ddd*f**3*s**2 + 168*D1*Ddd*f**3*s - 84*D1*Ddd*f**3 + 2*D1*bd1*f*(D1*(28*f**2*(r + s - 1) - 28*f*fd*(3*r + 3*s - 2) + 33*f*(r + s - 1) - 33*fd*(2*r + 2*s - 1)) - Dd*f*(28*f + 33)*(4*r + 4*s - 3))*(r + s - 1) - 336*Dd**2*b1*f**3*r**2 - 672*Dd**2*b1*f**3*r*s + 504*Dd**2*b1*f**3*r - 336*Dd**2*b1*f**3*s**2 + 504*Dd**2*b1*f**3*s - 168*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 336*Dd**2*f**3*r**2 - 672*Dd**2*f**3*r*s + 504*Dd**2*f**3*r - 336*Dd**2*f**3*s**2 + 504*Dd**2*f**3*s - 168*Dd**2*f**3)/(693*d**2*k3**4) - 10*D1**2*Pk2*Pkdd3*ct**6*k1**4*k2**2*(6669*C*D1**2*f**2*fd*r**2 + 13338*C*D1**2*f**2*fd*r*s - 8892*C*D1**2*f**2*fd*r + 6669*C*D1**2*f**2*fd*s**2 - 8892*C*D1**2*f**2*fd*s + 4446*C*D1**2*f**2*fd - 6552*C*D1**2*f**2*fdd*r**2 - 13104*C*D1**2*f**2*fdd*r*s + 8736*C*D1**2*f**2*fdd*r - 6552*C*D1**2*f**2*fdd*s**2 + 8736*C*D1**2*f**2*fdd*s - 4368*C*D1**2*f**2*fdd - 13104*C*D1**2*f*fd**2*r**2 - 26208*C*D1**2*f*fd**2*r*s + 17472*C*D1**2*f*fd**2*r - 13104*C*D1**2*f*fd**2*s**2 + 17472*C*D1**2*f*fd**2*s - 4368*C*D1**2*f*fd**2 + 8892*C*D1*Dd*f**3*r**2 + 17784*C*D1*Dd*f**3*r*s - 13338*C*D1*Dd*f**3*r + 8892*C*D1*Dd*f**3*s**2 - 13338*C*D1*Dd*f**3*s + 6669*C*D1*Dd*f**3 - 52416*C*D1*Dd*f**2*fd*r**2 - 104832*C*D1*Dd*f**2*fd*r*s + 74256*C*D1*Dd*f**2*fd*r - 52416*C*D1*Dd*f**2*fd*s**2 + 74256*C*D1*Dd*f**2*fd*s - 26208*C*D1*Dd*f**2*fd - 8736*C*D1*Ddd*f**3*r**2 - 17472*C*D1*Ddd*f**3*r*s + 13104*C*D1*Ddd*f**3*r - 8736*C*D1*Ddd*f**3*s**2 + 13104*C*D1*Ddd*f**3*s - 6552*C*D1*Ddd*f**3 - 26208*C*Dd**2*f**3*r**2 - 52416*C*Dd**2*f**3*r*s + 39312*C*Dd**2*f**3*r - 26208*C*Dd**2*f**3*s**2 + 39312*C*Dd**2*f**3*s - 13104*C*Dd**2*f**3 + 2574*D1**2*K*b1*f*fd*r**2 + 5148*D1**2*K*b1*f*fd*r*s - 2574*D1**2*K*b1*f*fd*r + 2574*D1**2*K*b1*f*fd*s**2 - 2574*D1**2*K*b1*f*fd*s + 1287*D1**2*K*b1*f*fd - 2574*D1**2*K*b1*f*fdd*r**2 - 5148*D1**2*K*b1*f*fdd*r*s + 2574*D1**2*K*b1*f*fdd*r - 2574*D1**2*K*b1*f*fdd*s**2 + 2574*D1**2*K*b1*f*fdd*s - 1287*D1**2*K*b1*f*fdd - 2574*D1**2*K*b1*fd**2*r**2 - 5148*D1**2*K*b1*fd**2*r*s + 2574*D1**2*K*b1*fd**2*r - 2574*D1**2*K*b1*fd**2*s**2 + 2574*D1**2*K*b1*fd**2*s - 2574*D1**2*b1*f*fd*r**2 - 5148*D1**2*b1*f*fd*r*s + 2574*D1**2*b1*f*fd*r - 2574*D1**2*b1*f*fd*s**2 + 2574*D1**2*b1*f*fd*s - 1287*D1**2*b1*f*fd + 2574*D1**2*b1*f*fdd*r**2 + 5148*D1**2*b1*f*fdd*r*s - 2574*D1**2*b1*f*fdd*r + 2574*D1**2*b1*f*fdd*s**2 - 2574*D1**2*b1*f*fdd*s + 1287*D1**2*b1*f*fdd + 2574*D1**2*b1*fd**2*r**2 + 5148*D1**2*b1*fd**2*r*s - 2574*D1**2*b1*fd**2*r + 2574*D1**2*b1*fd**2*s**2 - 2574*D1**2*b1*fd**2*s - 1287*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 7504*D1**2*f**3*fd*r**2 + 15008*D1**2*f**3*fd*r*s - 11256*D1**2*f**3*fd*r + 7504*D1**2*f**3*fd*s**2 - 11256*D1**2*f**3*fd*s + 5628*D1**2*f**3*fd - 6300*D1**2*f**3*fdd*r**2 - 12600*D1**2*f**3*fdd*r*s + 9450*D1**2*f**3*fdd*r - 6300*D1**2*f**3*fdd*s**2 + 9450*D1**2*f**3*fdd*s - 4725*D1**2*f**3*fdd - 18900*D1**2*f**2*fd**2*r**2 - 37800*D1**2*f**2*fd**2*r*s + 28350*D1**2*f**2*fd**2*r - 18900*D1**2*f**2*fd**2*s**2 + 28350*D1**2*f**2*fd**2*s - 9450*D1**2*f**2*fd**2 - 6669*D1**2*f**2*fd*r**2 - 13338*D1**2*f**2*fd*r*s + 8892*D1**2*f**2*fd*r - 6669*D1**2*f**2*fd*s**2 + 8892*D1**2*f**2*fd*s - 4446*D1**2*f**2*fd + 6552*D1**2*f**2*fdd*r**2 + 13104*D1**2*f**2*fdd*r*s - 8736*D1**2*f**2*fdd*r + 6552*D1**2*f**2*fdd*s**2 - 8736*D1**2*f**2*fdd*s + 4368*D1**2*f**2*fdd - 2574*D1**2*f**2*gd2*r**2 - 5148*D1**2*f**2*gd2*r*s + 5148*D1**2*f**2*gd2*r - 2574*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s - 2574*D1**2*f**2*gd2 + 2574*D1**2*f**2*gdd2*r**2 + 5148*D1**2*f**2*gdd2*r*s - 5148*D1**2*f**2*gdd2*r + 2574*D1**2*f**2*gdd2*s**2 - 5148*D1**2*f**2*gdd2*s + 2574*D1**2*f**2*gdd2 + 13104*D1**2*f*fd**2*r**2 + 26208*D1**2*f*fd**2*r*s - 17472*D1**2*f*fd**2*r + 13104*D1**2*f*fd**2*s**2 - 17472*D1**2*f*fd**2*s + 4368*D1**2*f*fd**2 - 5148*D1**2*f*fd*g2*r**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 5148*D1**2*f*fd*g2*s**2 + 5148*D1**2*f*fd*g2*s - 2574*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r**2 + 20592*D1**2*f*fd*gd2*r*s - 15444*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 15444*D1**2*f*fd*gd2*s + 5148*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r**2 + 10296*D1**2*f*fdd*g2*r*s - 5148*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r**2 + 10296*D1**2*fd**2*g2*r*s - 5148*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 5148*D1*Dd*K*b1*f**2*r**2 + 10296*D1*Dd*K*b1*f**2*r*s - 7722*D1*Dd*K*b1*f**2*r + 5148*D1*Dd*K*b1*f**2*s**2 - 7722*D1*Dd*K*b1*f**2*s + 3861*D1*Dd*K*b1*f**2 - 20592*D1*Dd*K*b1*f*fd*r**2 - 41184*D1*Dd*K*b1*f*fd*r*s + 25740*D1*Dd*K*b1*f*fd*r - 20592*D1*Dd*K*b1*f*fd*s**2 + 25740*D1*Dd*K*b1*f*fd*s - 7722*D1*Dd*K*b1*f*fd - 5148*D1*Dd*b1*f**2*r**2 - 10296*D1*Dd*b1*f**2*r*s + 7722*D1*Dd*b1*f**2*r - 5148*D1*Dd*b1*f**2*s**2 + 7722*D1*Dd*b1*f**2*s - 3861*D1*Dd*b1*f**2 + 20592*D1*Dd*b1*f*fd*r**2 + 41184*D1*Dd*b1*f*fd*r*s - 25740*D1*Dd*b1*f*fd*r + 20592*D1*Dd*b1*f*fd*s**2 - 25740*D1*Dd*b1*f*fd*s + 7722*D1*Dd*b1*f*fd + 7504*D1*Dd*f**4*r**2 + 15008*D1*Dd*f**4*r*s - 11256*D1*Dd*f**4*r + 7504*D1*Dd*f**4*s**2 - 11256*D1*Dd*f**4*s + 5628*D1*Dd*f**4 - 50400*D1*Dd*f**3*fd*r**2 - 100800*D1*Dd*f**3*fd*r*s + 75600*D1*Dd*f**3*fd*r - 50400*D1*Dd*f**3*fd*s**2 + 75600*D1*Dd*f**3*fd*s - 28350*D1*Dd*f**3*fd - 8892*D1*Dd*f**3*r**2 - 17784*D1*Dd*f**3*r*s + 13338*D1*Dd*f**3*r - 8892*D1*Dd*f**3*s**2 + 13338*D1*Dd*f**3*s - 6669*D1*Dd*f**3 + 52416*D1*Dd*f**2*fd*r**2 + 104832*D1*Dd*f**2*fd*r*s - 74256*D1*Dd*f**2*fd*r + 52416*D1*Dd*f**2*fd*s**2 - 74256*D1*Dd*f**2*fd*s + 26208*D1*Dd*f**2*fd - 10296*D1*Dd*f**2*g2*r**2 - 20592*D1*Dd*f**2*g2*r*s + 15444*D1*Dd*f**2*g2*r - 10296*D1*Dd*f**2*g2*s**2 + 15444*D1*Dd*f**2*g2*s - 7722*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r**2 + 41184*D1*Dd*f**2*gd2*r*s - 36036*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 36036*D1*Dd*f**2*gd2*s + 15444*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r**2 + 82368*D1*Dd*f*fd*g2*r*s - 51480*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 51480*D1*Dd*f*fd*g2*s + 15444*D1*Dd*f*fd*g2 - 5148*D1*Ddd*K*b1*f**2*r**2 - 10296*D1*Ddd*K*b1*f**2*r*s + 7722*D1*Ddd*K*b1*f**2*r - 5148*D1*Ddd*K*b1*f**2*s**2 + 7722*D1*Ddd*K*b1*f**2*s - 3861*D1*Ddd*K*b1*f**2 + 5148*D1*Ddd*b1*f**2*r**2 + 10296*D1*Ddd*b1*f**2*r*s - 7722*D1*Ddd*b1*f**2*r + 5148*D1*Ddd*b1*f**2*s**2 - 7722*D1*Ddd*b1*f**2*s + 3861*D1*Ddd*b1*f**2 - 6300*D1*Ddd*f**4*r**2 - 12600*D1*Ddd*f**4*r*s + 9450*D1*Ddd*f**4*r - 6300*D1*Ddd*f**4*s**2 + 9450*D1*Ddd*f**4*s - 4725*D1*Ddd*f**4 + 8736*D1*Ddd*f**3*r**2 + 17472*D1*Ddd*f**3*r*s - 13104*D1*Ddd*f**3*r + 8736*D1*Ddd*f**3*s**2 - 13104*D1*Ddd*f**3*s + 6552*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r**2 + 20592*D1*Ddd*f**2*g2*r*s - 15444*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 15444*D1*Ddd*f**2*g2*s + 7722*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 15444*Dd**2*K*b1*f**2*r**2 - 30888*Dd**2*K*b1*f**2*r*s + 23166*Dd**2*K*b1*f**2*r - 15444*Dd**2*K*b1*f**2*s**2 + 23166*Dd**2*K*b1*f**2*s - 7722*Dd**2*K*b1*f**2 + 15444*Dd**2*b1*f**2*r**2 + 30888*Dd**2*b1*f**2*r*s - 23166*Dd**2*b1*f**2*r + 15444*Dd**2*b1*f**2*s**2 - 23166*Dd**2*b1*f**2*s + 7722*Dd**2*b1*f**2 - 18900*Dd**2*f**4*r**2 - 37800*Dd**2*f**4*r*s + 28350*Dd**2*f**4*r - 18900*Dd**2*f**4*s**2 + 28350*Dd**2*f**4*s - 9450*Dd**2*f**4 + 26208*Dd**2*f**3*r**2 + 52416*Dd**2*f**3*r*s - 39312*Dd**2*f**3*r + 26208*Dd**2*f**3*s**2 - 39312*Dd**2*f**3*s + 13104*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r**2 + 61776*Dd**2*f**2*g2*r*s - 46332*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 46332*Dd**2*f**2*g2*s + 15444*Dd**2*f**2*g2)/(9009*d**2*k3**6) - 5*D1**2*Pk2*Pkdd3*ct**6*k1**2*k2**4*st**2*(11700*C*D1**2*f**2*fd*r**2 + 23400*C*D1**2*f**2*fd*r*s - 15600*C*D1**2*f**2*fd*r + 11700*C*D1**2*f**2*fd*s**2 - 15600*C*D1**2*f**2*fd*s + 7800*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r**2 - 11700*C*D1**2*f**2*fdd*r*s + 7800*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 7800*C*D1**2*f**2*fdd*s - 3900*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r**2 - 23400*C*D1**2*f*fd**2*r*s + 15600*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 15600*C*D1**2*f*fd**2*s - 3900*C*D1**2*f*fd**2 + 15600*C*D1*Dd*f**3*r**2 + 31200*C*D1*Dd*f**3*r*s - 23400*C*D1*Dd*f**3*r + 15600*C*D1*Dd*f**3*s**2 - 23400*C*D1*Dd*f**3*s + 11700*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r**2 - 93600*C*D1*Dd*f**2*fd*r*s + 66300*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 66300*C*D1*Dd*f**2*fd*s - 23400*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r**2 - 15600*C*D1*Ddd*f**3*r*s + 11700*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 11700*C*D1*Ddd*f**3*s - 5850*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r**2 - 46800*C*Dd**2*f**3*r*s + 35100*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 35100*C*Dd**2*f**3*s - 11700*C*Dd**2*f**3 + 5148*D1**2*K*b1*f*fd*r**2 + 10296*D1**2*K*b1*f*fd*r*s - 5148*D1**2*K*b1*f*fd*r + 5148*D1**2*K*b1*f*fd*s**2 - 5148*D1**2*K*b1*f*fd*s + 2574*D1**2*K*b1*f*fd - 2574*D1**2*K*b1*f*fdd*r**2 - 5148*D1**2*K*b1*f*fdd*r*s + 2574*D1**2*K*b1*f*fdd*r - 2574*D1**2*K*b1*f*fdd*s**2 + 2574*D1**2*K*b1*f*fdd*s - 1287*D1**2*K*b1*f*fdd - 2574*D1**2*K*b1*fd**2*r**2 - 5148*D1**2*K*b1*fd**2*r*s + 2574*D1**2*K*b1*fd**2*r - 2574*D1**2*K*b1*fd**2*s**2 + 2574*D1**2*K*b1*fd**2*s - 5148*D1**2*b1*f*fd*r**2 - 10296*D1**2*b1*f*fd*r*s + 5148*D1**2*b1*f*fd*r - 5148*D1**2*b1*f*fd*s**2 + 5148*D1**2*b1*f*fd*s - 2574*D1**2*b1*f*fd + 2574*D1**2*b1*f*fdd*r**2 + 5148*D1**2*b1*f*fdd*r*s - 2574*D1**2*b1*f*fdd*r + 2574*D1**2*b1*f*fdd*s**2 - 2574*D1**2*b1*f*fdd*s + 1287*D1**2*b1*f*fdd + 2574*D1**2*b1*fd**2*r**2 + 5148*D1**2*b1*fd**2*r*s - 2574*D1**2*b1*fd**2*r + 2574*D1**2*b1*fd**2*s**2 - 2574*D1**2*b1*fd**2*s - 1287*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 10976*D1**2*f**3*fd*r**2 + 21952*D1**2*f**3*fd*r*s - 16464*D1**2*f**3*fd*r + 10976*D1**2*f**3*fd*s**2 - 16464*D1**2*f**3*fd*s + 8232*D1**2*f**3*fd - 5488*D1**2*f**3*fdd*r**2 - 10976*D1**2*f**3*fdd*r*s + 8232*D1**2*f**3*fdd*r - 5488*D1**2*f**3*fdd*s**2 + 8232*D1**2*f**3*fdd*s - 4116*D1**2*f**3*fdd - 16464*D1**2*f**2*fd**2*r**2 - 32928*D1**2*f**2*fd**2*r*s + 24696*D1**2*f**2*fd**2*r - 16464*D1**2*f**2*fd**2*s**2 + 24696*D1**2*f**2*fd**2*s - 8232*D1**2*f**2*fd**2 - 11700*D1**2*f**2*fd*r**2 - 23400*D1**2*f**2*fd*r*s + 15600*D1**2*f**2*fd*r - 11700*D1**2*f**2*fd*s**2 + 15600*D1**2*f**2*fd*s - 7800*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r**2 + 11700*D1**2*f**2*fdd*r*s - 7800*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 7800*D1**2*f**2*fdd*s + 3900*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r**2 - 10296*D1**2*f**2*gd2*r*s + 10296*D1**2*f**2*gd2*r - 5148*D1**2*f**2*gd2*s**2 + 10296*D1**2*f**2*gd2*s - 5148*D1**2*f**2*gd2 + 2574*D1**2*f**2*gdd2*r**2 + 5148*D1**2*f**2*gdd2*r*s - 5148*D1**2*f**2*gdd2*r + 2574*D1**2*f**2*gdd2*s**2 - 5148*D1**2*f**2*gdd2*s + 2574*D1**2*f**2*gdd2 + 11700*D1**2*f*fd**2*r**2 + 23400*D1**2*f*fd**2*r*s - 15600*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 15600*D1**2*f*fd**2*s + 3900*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r**2 - 20592*D1**2*f*fd*g2*r*s + 10296*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r**2 + 20592*D1**2*f*fd*gd2*r*s - 15444*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 15444*D1**2*f*fd*gd2*s + 5148*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r**2 + 10296*D1**2*f*fdd*g2*r*s - 5148*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r**2 + 10296*D1**2*fd**2*g2*r*s - 5148*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 10296*D1*Dd*K*b1*f**2*r**2 + 20592*D1*Dd*K*b1*f**2*r*s - 15444*D1*Dd*K*b1*f**2*r + 10296*D1*Dd*K*b1*f**2*s**2 - 15444*D1*Dd*K*b1*f**2*s + 7722*D1*Dd*K*b1*f**2 - 20592*D1*Dd*K*b1*f*fd*r**2 - 41184*D1*Dd*K*b1*f*fd*r*s + 25740*D1*Dd*K*b1*f*fd*r - 20592*D1*Dd*K*b1*f*fd*s**2 + 25740*D1*Dd*K*b1*f*fd*s - 7722*D1*Dd*K*b1*f*fd - 10296*D1*Dd*b1*f**2*r**2 - 20592*D1*Dd*b1*f**2*r*s + 15444*D1*Dd*b1*f**2*r - 10296*D1*Dd*b1*f**2*s**2 + 15444*D1*Dd*b1*f**2*s - 7722*D1*Dd*b1*f**2 + 20592*D1*Dd*b1*f*fd*r**2 + 41184*D1*Dd*b1*f*fd*r*s - 25740*D1*Dd*b1*f*fd*r + 20592*D1*Dd*b1*f*fd*s**2 - 25740*D1*Dd*b1*f*fd*s + 7722*D1*Dd*b1*f*fd + 10976*D1*Dd*f**4*r**2 + 21952*D1*Dd*f**4*r*s - 16464*D1*Dd*f**4*r + 10976*D1*Dd*f**4*s**2 - 16464*D1*Dd*f**4*s + 8232*D1*Dd*f**4 - 43904*D1*Dd*f**3*fd*r**2 - 87808*D1*Dd*f**3*fd*r*s + 65856*D1*Dd*f**3*fd*r - 43904*D1*Dd*f**3*fd*s**2 + 65856*D1*Dd*f**3*fd*s - 24696*D1*Dd*f**3*fd - 15600*D1*Dd*f**3*r**2 - 31200*D1*Dd*f**3*r*s + 23400*D1*Dd*f**3*r - 15600*D1*Dd*f**3*s**2 + 23400*D1*Dd*f**3*s - 11700*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r**2 + 93600*D1*Dd*f**2*fd*r*s - 66300*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 66300*D1*Dd*f**2*fd*s + 23400*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r**2 - 41184*D1*Dd*f**2*g2*r*s + 30888*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 30888*D1*Dd*f**2*g2*s - 15444*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r**2 + 41184*D1*Dd*f**2*gd2*r*s - 36036*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 36036*D1*Dd*f**2*gd2*s + 15444*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r**2 + 82368*D1*Dd*f*fd*g2*r*s - 51480*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 51480*D1*Dd*f*fd*g2*s + 15444*D1*Dd*f*fd*g2 - 5148*D1*Ddd*K*b1*f**2*r**2 - 10296*D1*Ddd*K*b1*f**2*r*s + 7722*D1*Ddd*K*b1*f**2*r - 5148*D1*Ddd*K*b1*f**2*s**2 + 7722*D1*Ddd*K*b1*f**2*s - 3861*D1*Ddd*K*b1*f**2 + 5148*D1*Ddd*b1*f**2*r**2 + 10296*D1*Ddd*b1*f**2*r*s - 7722*D1*Ddd*b1*f**2*r + 5148*D1*Ddd*b1*f**2*s**2 - 7722*D1*Ddd*b1*f**2*s + 3861*D1*Ddd*b1*f**2 - 5488*D1*Ddd*f**4*r**2 - 10976*D1*Ddd*f**4*r*s + 8232*D1*Ddd*f**4*r - 5488*D1*Ddd*f**4*s**2 + 8232*D1*Ddd*f**4*s - 4116*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r**2 + 15600*D1*Ddd*f**3*r*s - 11700*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 11700*D1*Ddd*f**3*s + 5850*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r**2 + 20592*D1*Ddd*f**2*g2*r*s - 15444*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 15444*D1*Ddd*f**2*g2*s + 7722*D1*Ddd*f**2*g2 + 2574*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 15444*Dd**2*K*b1*f**2*r**2 - 30888*Dd**2*K*b1*f**2*r*s + 23166*Dd**2*K*b1*f**2*r - 15444*Dd**2*K*b1*f**2*s**2 + 23166*Dd**2*K*b1*f**2*s - 7722*Dd**2*K*b1*f**2 + 15444*Dd**2*b1*f**2*r**2 + 30888*Dd**2*b1*f**2*r*s - 23166*Dd**2*b1*f**2*r + 15444*Dd**2*b1*f**2*s**2 - 23166*Dd**2*b1*f**2*s + 7722*Dd**2*b1*f**2 - 16464*Dd**2*f**4*r**2 - 32928*Dd**2*f**4*r*s + 24696*Dd**2*f**4*r - 16464*Dd**2*f**4*s**2 + 24696*Dd**2*f**4*s - 8232*Dd**2*f**4 + 23400*Dd**2*f**3*r**2 + 46800*Dd**2*f**3*r*s - 35100*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 35100*Dd**2*f**3*s + 11700*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r**2 + 61776*Dd**2*f**2*g2*r*s - 46332*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 46332*Dd**2*f**2*g2*s + 15444*Dd**2*f**2*g2)/(18018*d**2*k3**6) - 2*D1**2*Pk2*Pkdd3*ct**6*k1**2*k2**4*(-165*C*D1**2*bdd1*f**2*r**2 - 330*C*D1**2*bdd1*f**2*r*s + 330*C*D1**2*bdd1*f**2*r - 165*C*D1**2*bdd1*f**2*s**2 + 330*C*D1**2*bdd1*f**2*s - 165*C*D1**2*bdd1*f**2 + 4245*C*D1**2*f**2*fd*r**2 + 8490*C*D1**2*f**2*fd*r*s - 5660*C*D1**2*f**2*fd*r + 4245*C*D1**2*f**2*fd*s**2 - 5660*C*D1**2*f**2*fd*s + 2830*C*D1**2*f**2*fd - 3360*C*D1**2*f**2*fdd*r**2 - 6720*C*D1**2*f**2*fdd*r*s + 4480*C*D1**2*f**2*fdd*r - 3360*C*D1**2*f**2*fdd*s**2 + 4480*C*D1**2*f**2*fdd*s - 2240*C*D1**2*f**2*fdd - 6720*C*D1**2*f*fd**2*r**2 - 13440*C*D1**2*f*fd**2*r*s + 8960*C*D1**2*f*fd**2*r - 6720*C*D1**2*f*fd**2*s**2 + 8960*C*D1**2*f*fd**2*s - 2240*C*D1**2*f*fd**2 + 5660*C*D1*Dd*f**3*r**2 + 11320*C*D1*Dd*f**3*r*s - 8490*C*D1*Dd*f**3*r + 5660*C*D1*Dd*f**3*s**2 - 8490*C*D1*Dd*f**3*s + 4245*C*D1*Dd*f**3 - 26880*C*D1*Dd*f**2*fd*r**2 - 53760*C*D1*Dd*f**2*fd*r*s + 38080*C*D1*Dd*f**2*fd*r - 26880*C*D1*Dd*f**2*fd*s**2 + 38080*C*D1*Dd*f**2*fd*s - 13440*C*D1*Dd*f**2*fd - 4480*C*D1*Ddd*f**3*r**2 - 8960*C*D1*Ddd*f**3*r*s + 6720*C*D1*Ddd*f**3*r - 4480*C*D1*Ddd*f**3*s**2 + 6720*C*D1*Ddd*f**3*s - 3360*C*D1*Ddd*f**3 - 13440*C*Dd**2*f**3*r**2 - 26880*C*Dd**2*f**3*r*s + 20160*C*Dd**2*f**3*r - 13440*C*Dd**2*f**3*s**2 + 20160*C*Dd**2*f**3*s - 6720*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r**2 - 1320*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 660*D1**2*K*bdd1*f**2*s**2 + 1320*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 - 198*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 280*D1**2*bdd1*f**3*r**2 + 560*D1**2*bdd1*f**3*r*s - 560*D1**2*bdd1*f**3*r + 280*D1**2*bdd1*f**3*s**2 - 560*D1**2*bdd1*f**3*s + 280*D1**2*bdd1*f**3 + 495*D1**2*bdd1*f**2*r**2 + 990*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*r + 495*D1**2*bdd1*f**2*s**2 - 990*D1**2*bdd1*f**2*s + 495*D1**2*bdd1*f**2 + 198*D1**2*bdd1*f*g2*r**2 + 396*D1**2*bdd1*f*g2*r*s - 396*D1**2*bdd1*f*g2*r + 198*D1**2*bdd1*f*g2*s**2 - 396*D1**2*bdd1*f*g2*s + 198*D1**2*bdd1*f*g2 - 280*D1**2*f**3*fd*r**2 - 560*D1**2*f**3*fd*r*s + 420*D1**2*f**3*fd*r - 280*D1**2*f**3*fd*s**2 + 420*D1**2*f**3*fd*s - 210*D1**2*f**3*fd - 3060*D1**2*f**2*fd*r**2 - 6120*D1**2*f**2*fd*r*s + 4080*D1**2*f**2*fd*r - 3060*D1**2*f**2*fd*s**2 + 4080*D1**2*f**2*fd*s - 2040*D1**2*f**2*fd + 2520*D1**2*f**2*fdd*r**2 + 5040*D1**2*f**2*fdd*r*s - 3360*D1**2*f**2*fdd*r + 2520*D1**2*f**2*fdd*s**2 - 3360*D1**2*f**2*fdd*s + 1680*D1**2*f**2*fdd - 1650*D1**2*f**2*gd2*r**2 - 3300*D1**2*f**2*gd2*r*s + 3300*D1**2*f**2*gd2*r - 1650*D1**2*f**2*gd2*s**2 + 3300*D1**2*f**2*gd2*s - 1650*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 5040*D1**2*f*fd**2*r**2 + 10080*D1**2*f*fd**2*r*s - 6720*D1**2*f*fd**2*r + 5040*D1**2*f*fd**2*s**2 - 6720*D1**2*f*fd**2*s + 1680*D1**2*f*fd**2 - 3300*D1**2*f*fd*g2*r**2 - 6600*D1**2*f*fd*g2*r*s + 3300*D1**2*f*fd*g2*r - 3300*D1**2*f*fd*g2*s**2 + 3300*D1**2*f*fd*g2*s - 1650*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s - 280*D1*Dd*f**4*r**2 - 560*D1*Dd*f**4*r*s + 420*D1*Dd*f**4*r - 280*D1*Dd*f**4*s**2 + 420*D1*Dd*f**4*s - 210*D1*Dd*f**4 - 4080*D1*Dd*f**3*r**2 - 8160*D1*Dd*f**3*r*s + 6120*D1*Dd*f**3*r - 4080*D1*Dd*f**3*s**2 + 6120*D1*Dd*f**3*s - 3060*D1*Dd*f**3 + 20160*D1*Dd*f**2*fd*r**2 + 40320*D1*Dd*f**2*fd*r*s - 28560*D1*Dd*f**2*fd*r + 20160*D1*Dd*f**2*fd*s**2 - 28560*D1*Dd*f**2*fd*s + 10080*D1*Dd*f**2*fd - 6600*D1*Dd*f**2*g2*r**2 - 13200*D1*Dd*f**2*g2*r*s + 9900*D1*Dd*f**2*g2*r - 6600*D1*Dd*f**2*g2*s**2 + 9900*D1*Dd*f**2*g2*s - 4950*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 3360*D1*Ddd*f**3*r**2 + 6720*D1*Ddd*f**3*r*s - 5040*D1*Ddd*f**3*r + 3360*D1*Ddd*f**3*s**2 - 5040*D1*Ddd*f**3*s + 2520*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 - D1*bd1*(D1*(395*f**3*(r + s - 1) - f**2*(330*C*(r + s - 1) + 560*fd*(3*r + 3*s - 2) + (825*K - 693)*(r + s - 1)) + 66*f*(5*fd*(C + 4*K - 3)*(2*r + 2*s - 1) + (6*g2 - 6*gd2)*(r + s - 1)) - 396*fd*g2*(r + s)) - 2*Dd*f*(280*f**2 - 165*f*(C + 4*K - 3) + 198*g2)*(4*r + 4*s - 3))*(r + s - 1) + 10080*Dd**2*f**3*r**2 + 20160*Dd**2*f**3*r*s - 15120*Dd**2*f**3*r + 10080*Dd**2*f**3*s**2 - 15120*Dd**2*f**3*s + 5040*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2 + 99*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(660*C*D1**2*f*fd*r**2 + 1320*C*D1**2*f*fd*r*s - 660*C*D1**2*f*fd*r + 660*C*D1**2*f*fd*s**2 - 660*C*D1**2*f*fd*s + 330*C*D1**2*f*fd - 330*C*D1**2*f*fdd*r**2 - 660*C*D1**2*f*fdd*r*s + 330*C*D1**2*f*fdd*r - 330*C*D1**2*f*fdd*s**2 + 330*C*D1**2*f*fdd*s - 165*C*D1**2*f*fdd - 330*C*D1**2*fd**2*r**2 - 660*C*D1**2*fd**2*r*s + 330*C*D1**2*fd**2*r - 330*C*D1**2*fd**2*s**2 + 330*C*D1**2*fd**2*s + 1320*C*D1*Dd*f**2*r**2 + 2640*C*D1*Dd*f**2*r*s - 1980*C*D1*Dd*f**2*r + 1320*C*D1*Dd*f**2*s**2 - 1980*C*D1*Dd*f**2*s + 990*C*D1*Dd*f**2 - 2640*C*D1*Dd*f*fd*r**2 - 5280*C*D1*Dd*f*fd*r*s + 3300*C*D1*Dd*f*fd*r - 2640*C*D1*Dd*f*fd*s**2 + 3300*C*D1*Dd*f*fd*s - 990*C*D1*Dd*f*fd - 660*C*D1*Ddd*f**2*r**2 - 1320*C*D1*Ddd*f**2*r*s + 990*C*D1*Ddd*f**2*r - 660*C*D1*Ddd*f**2*s**2 + 990*C*D1*Ddd*f**2*s - 495*C*D1*Ddd*f**2 - 1980*C*Dd**2*f**2*r**2 - 3960*C*Dd**2*f**2*r*s + 2970*C*Dd**2*f**2*r - 1980*C*Dd**2*f**2*s**2 + 2970*C*Dd**2*f**2*s - 990*C*Dd**2*f**2 + 1650*D1**2*K*f*fd*r**2 + 3300*D1**2*K*f*fd*r*s - 1650*D1**2*K*f*fd*r + 1650*D1**2*K*f*fd*s**2 - 1650*D1**2*K*f*fd*s + 825*D1**2*K*f*fd - 1320*D1**2*K*f*fdd*r**2 - 2640*D1**2*K*f*fdd*r*s + 1320*D1**2*K*f*fdd*r - 1320*D1**2*K*f*fdd*s**2 + 1320*D1**2*K*f*fdd*s - 660*D1**2*K*f*fdd - 1320*D1**2*K*fd**2*r**2 - 2640*D1**2*K*fd**2*r*s + 1320*D1**2*K*fd**2*r - 1320*D1**2*K*fd**2*s**2 + 1320*D1**2*K*fd**2*s - 198*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 1185*D1**2*f**2*fd*r**2 - 2370*D1**2*f**2*fd*r*s + 1580*D1**2*f**2*fd*r - 1185*D1**2*f**2*fd*s**2 + 1580*D1**2*f**2*fd*s - 790*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r**2 + 1680*D1**2*f**2*fdd*r*s - 1120*D1**2*f**2*fdd*r + 840*D1**2*f**2*fdd*s**2 - 1120*D1**2*f**2*fdd*s + 560*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r**2 + 3360*D1**2*f*fd**2*r*s - 2240*D1**2*f*fd**2*r + 1680*D1**2*f*fd**2*s**2 - 2240*D1**2*f*fd**2*s + 560*D1**2*f*fd**2 - 1386*D1**2*f*fd*r**2 - 2772*D1**2*f*fd*r*s + 1386*D1**2*f*fd*r - 1386*D1**2*f*fd*s**2 + 1386*D1**2*f*fd*s - 693*D1**2*f*fd + 990*D1**2*f*fdd*r**2 + 1980*D1**2*f*fdd*r*s - 990*D1**2*f*fdd*r + 990*D1**2*f*fdd*s**2 - 990*D1**2*f*fdd*s + 495*D1**2*f*fdd - 396*D1**2*f*gd2*r**2 - 792*D1**2*f*gd2*r*s + 792*D1**2*f*gd2*r - 396*D1**2*f*gd2*s**2 + 792*D1**2*f*gd2*s - 396*D1**2*f*gd2 + 198*D1**2*f*gdd2*r**2 + 396*D1**2*f*gdd2*r*s - 396*D1**2*f*gdd2*r + 198*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s + 198*D1**2*f*gdd2 + 990*D1**2*fd**2*r**2 + 1980*D1**2*fd**2*r*s - 990*D1**2*fd**2*r + 990*D1**2*fd**2*s**2 - 990*D1**2*fd**2*s - 396*D1**2*fd*g2*r**2 - 792*D1**2*fd*g2*r*s - 396*D1**2*fd*g2*s**2 + 396*D1**2*fd*gd2*r**2 + 792*D1**2*fd*gd2*r*s - 396*D1**2*fd*gd2*r + 396*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 198*D1**2*fdd*g2*r**2 + 396*D1**2*fdd*g2*r*s + 198*D1**2*fdd*g2*s**2 + 3300*D1*Dd*K*f**2*r**2 + 6600*D1*Dd*K*f**2*r*s - 4950*D1*Dd*K*f**2*r + 3300*D1*Dd*K*f**2*s**2 - 4950*D1*Dd*K*f**2*s + 2475*D1*Dd*K*f**2 - 10560*D1*Dd*K*f*fd*r**2 - 21120*D1*Dd*K*f*fd*r*s + 13200*D1*Dd*K*f*fd*r - 10560*D1*Dd*K*f*fd*s**2 + 13200*D1*Dd*K*f*fd*s - 3960*D1*Dd*K*f*fd - 1580*D1*Dd*f**3*r**2 - 3160*D1*Dd*f**3*r*s + 2370*D1*Dd*f**3*r - 1580*D1*Dd*f**3*s**2 + 2370*D1*Dd*f**3*s - 1185*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r**2 + 13440*D1*Dd*f**2*fd*r*s - 9520*D1*Dd*f**2*fd*r + 6720*D1*Dd*f**2*fd*s**2 - 9520*D1*Dd*f**2*fd*s + 3360*D1*Dd*f**2*fd - 2772*D1*Dd*f**2*r**2 - 5544*D1*Dd*f**2*r*s + 4158*D1*Dd*f**2*r - 2772*D1*Dd*f**2*s**2 + 4158*D1*Dd*f**2*s - 2079*D1*Dd*f**2 + 7920*D1*Dd*f*fd*r**2 + 15840*D1*Dd*f*fd*r*s - 9900*D1*Dd*f*fd*r + 7920*D1*Dd*f*fd*s**2 - 9900*D1*Dd*f*fd*s + 2970*D1*Dd*f*fd - 1584*D1*Dd*f*g2*r**2 - 3168*D1*Dd*f*g2*r*s + 2376*D1*Dd*f*g2*r - 1584*D1*Dd*f*g2*s**2 + 2376*D1*Dd*f*g2*s - 1188*D1*Dd*f*g2 + 1584*D1*Dd*f*gd2*r**2 + 3168*D1*Dd*f*gd2*r*s - 2772*D1*Dd*f*gd2*r + 1584*D1*Dd*f*gd2*s**2 - 2772*D1*Dd*f*gd2*s + 1188*D1*Dd*f*gd2 + 1584*D1*Dd*fd*g2*r**2 + 3168*D1*Dd*fd*g2*r*s - 1188*D1*Dd*fd*g2*r + 1584*D1*Dd*fd*g2*s**2 - 1188*D1*Dd*fd*g2*s - 2640*D1*Ddd*K*f**2*r**2 - 5280*D1*Ddd*K*f**2*r*s + 3960*D1*Ddd*K*f**2*r - 2640*D1*Ddd*K*f**2*s**2 + 3960*D1*Ddd*K*f**2*s - 1980*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r**2 + 2240*D1*Ddd*f**3*r*s - 1680*D1*Ddd*f**3*r + 1120*D1*Ddd*f**3*s**2 - 1680*D1*Ddd*f**3*s + 840*D1*Ddd*f**3 + 1980*D1*Ddd*f**2*r**2 + 3960*D1*Ddd*f**2*r*s - 2970*D1*Ddd*f**2*r + 1980*D1*Ddd*f**2*s**2 - 2970*D1*Ddd*f**2*s + 1485*D1*Ddd*f**2 + 792*D1*Ddd*f*g2*r**2 + 1584*D1*Ddd*f*g2*r*s - 1188*D1*Ddd*f*g2*r + 792*D1*Ddd*f*g2*s**2 - 1188*D1*Ddd*f*g2*s + 594*D1*Ddd*f*g2 + 396*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 7920*Dd**2*K*f**2*r**2 - 15840*Dd**2*K*f**2*r*s + 11880*Dd**2*K*f**2*r - 7920*Dd**2*K*f**2*s**2 + 11880*Dd**2*K*f**2*s - 3960*Dd**2*K*f**2 + 3360*Dd**2*f**3*r**2 + 6720*Dd**2*f**3*r*s - 5040*Dd**2*f**3*r + 3360*Dd**2*f**3*s**2 - 5040*Dd**2*f**3*s + 1680*Dd**2*f**3 + 5940*Dd**2*f**2*r**2 + 11880*Dd**2*f**2*r*s - 8910*Dd**2*f**2*r + 5940*Dd**2*f**2*s**2 - 8910*Dd**2*f**2*s + 2970*Dd**2*f**2 + 2376*Dd**2*f*g2*r**2 + 4752*Dd**2*f*g2*r*s - 3564*Dd**2*f*g2*r + 2376*Dd**2*f*g2*s**2 - 3564*Dd**2*f*g2*s + 1188*Dd**2*f*g2))/(693*d**2*k3**6) + 2*D1**2*Pk2*Pkdd3*ct**6*k1**2*k2**2*(198*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*bd1*(D1*(-5*f**3*(107*r**2 + 2*r*(107*s - 79) + 107*s**2 - 158*s + 79) + 2*f**2*(70*fd*(15*r**2 + r*(30*s - 23) + 15*s**2 - 23*s + 8) - 33*r**2*(5*C + 2) - 66*r*(s*(5*C + 2) - 7) - 33*s**2*(5*C + 2) + 462*s - 231) + 132*f*(5*fd*(r + s - 1)*(C*r + C*s + r + s - 1) - (3*r + 3*s)*(-g2*(r + s) + gd2*(r + s - 1))) - 396*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(4*r + 4*s - 3)*(70*f**2*(5*r + 5*s - 4) + 165*f*(C*r + C*s + r + s - 2) - 198*g2*(r + s))) - 99*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-660*C*D1**2*f*fd*r**2 - 1320*C*D1**2*f*fd*r*s + 1320*C*D1**2*f*fd*r - 660*C*D1**2*f*fd*s**2 + 1320*C*D1**2*f*fd*s - 660*C*D1**2*f*fd + 330*C*D1**2*f*fdd*r**2 + 660*C*D1**2*f*fdd*r*s - 660*C*D1**2*f*fdd*r + 330*C*D1**2*f*fdd*s**2 - 660*C*D1**2*f*fdd*s + 330*C*D1**2*f*fdd + 330*C*D1**2*fd**2*r**2 + 660*C*D1**2*fd**2*r*s - 660*C*D1**2*fd**2*r + 330*C*D1**2*fd**2*s**2 - 660*C*D1**2*fd**2*s + 330*C*D1**2*fd**2 - 1320*C*D1*Dd*f**2*r**2 - 2640*C*D1*Dd*f**2*r*s + 1980*C*D1*Dd*f**2*r - 1320*C*D1*Dd*f**2*s**2 + 1980*C*D1*Dd*f**2*s - 990*C*D1*Dd*f**2 + 2640*C*D1*Dd*f*fd*r**2 + 5280*C*D1*Dd*f*fd*r*s - 4620*C*D1*Dd*f*fd*r + 2640*C*D1*Dd*f*fd*s**2 - 4620*C*D1*Dd*f*fd*s + 1980*C*D1*Dd*f*fd + 660*C*D1*Ddd*f**2*r**2 + 1320*C*D1*Ddd*f**2*r*s - 990*C*D1*Ddd*f**2*r + 660*C*D1*Ddd*f**2*s**2 - 990*C*D1*Ddd*f**2*s + 495*C*D1*Ddd*f**2 + 1980*C*Dd**2*f**2*r**2 + 3960*C*Dd**2*f**2*r*s - 2970*C*Dd**2*f**2*r + 1980*C*Dd**2*f**2*s**2 - 2970*C*Dd**2*f**2*s + 990*C*Dd**2*f**2 + 99*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 1605*D1**2*f**2*fd*r**2 - 3210*D1**2*f**2*fd*r*s + 2420*D1**2*f**2*fd*r - 1605*D1**2*f**2*fd*s**2 + 2420*D1**2*f**2*fd*s - 1210*D1**2*f**2*fd + 1050*D1**2*f**2*fdd*r**2 + 2100*D1**2*f**2*fdd*r*s - 1540*D1**2*f**2*fdd*r + 1050*D1**2*f**2*fdd*s**2 - 1540*D1**2*f**2*fdd*s + 770*D1**2*f**2*fdd + 2100*D1**2*f*fd**2*r**2 + 4200*D1**2*f*fd**2*r*s - 3080*D1**2*f*fd**2*r + 2100*D1**2*f*fd**2*s**2 - 3080*D1**2*f*fd**2*s + 980*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s - 396*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 - 396*D1**2*f*fd*s + 198*D1**2*f*fd + 330*D1**2*f*fdd*r**2 + 660*D1**2*f*fdd*r*s + 330*D1**2*f*fdd*s**2 + 396*D1**2*f*gd2*r**2 + 792*D1**2*f*gd2*r*s - 792*D1**2*f*gd2*r + 396*D1**2*f*gd2*s**2 - 792*D1**2*f*gd2*s + 396*D1**2*f*gd2 - 198*D1**2*f*gdd2*r**2 - 396*D1**2*f*gdd2*r*s + 396*D1**2*f*gdd2*r - 198*D1**2*f*gdd2*s**2 + 396*D1**2*f*gdd2*s - 198*D1**2*f*gdd2 + 330*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s + 330*D1**2*fd**2*s**2 - 330*D1**2*fd**2 + 396*D1**2*fd*g2*r**2 + 792*D1**2*fd*g2*r*s - 792*D1**2*fd*g2*r + 396*D1**2*fd*g2*s**2 - 792*D1**2*fd*g2*s + 396*D1**2*fd*g2 - 396*D1**2*fd*gd2*r**2 - 792*D1**2*fd*gd2*r*s + 792*D1**2*fd*gd2*r - 396*D1**2*fd*gd2*s**2 + 792*D1**2*fd*gd2*s - 396*D1**2*fd*gd2 - 198*D1**2*fdd*g2*r**2 - 396*D1**2*fdd*g2*r*s + 396*D1**2*fdd*g2*r - 198*D1**2*fdd*g2*s**2 + 396*D1**2*fdd*g2*s - 198*D1**2*fdd*g2 - 2140*D1*Dd*f**3*r**2 - 4280*D1*Dd*f**3*r*s + 3210*D1*Dd*f**3*r - 2140*D1*Dd*f**3*s**2 + 3210*D1*Dd*f**3*s - 1605*D1*Dd*f**3 + 8400*D1*Dd*f**2*fd*r**2 + 16800*D1*Dd*f**2*fd*r*s - 12460*D1*Dd*f**2*fd*r + 8400*D1*Dd*f**2*fd*s**2 - 12460*D1*Dd*f**2*fd*s + 4620*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 + 5280*D1*Dd*f*fd*r*s - 1980*D1*Dd*f*fd*r + 2640*D1*Dd*f*fd*s**2 - 1980*D1*Dd*f*fd*s + 1584*D1*Dd*f*g2*r**2 + 3168*D1*Dd*f*g2*r*s - 2376*D1*Dd*f*g2*r + 1584*D1*Dd*f*g2*s**2 - 2376*D1*Dd*f*g2*s + 1188*D1*Dd*f*g2 - 1584*D1*Dd*f*gd2*r**2 - 3168*D1*Dd*f*gd2*r*s + 2772*D1*Dd*f*gd2*r - 1584*D1*Dd*f*gd2*s**2 + 2772*D1*Dd*f*gd2*s - 1188*D1*Dd*f*gd2 - 1584*D1*Dd*fd*g2*r**2 - 3168*D1*Dd*fd*g2*r*s + 2772*D1*Dd*fd*g2*r - 1584*D1*Dd*fd*g2*s**2 + 2772*D1*Dd*fd*g2*s - 1188*D1*Dd*fd*g2 + 1400*D1*Ddd*f**3*r**2 + 2800*D1*Ddd*f**3*r*s - 2100*D1*Ddd*f**3*r + 1400*D1*Ddd*f**3*s**2 - 2100*D1*Ddd*f**3*s + 1050*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 + 1320*D1*Ddd*f**2*r*s - 990*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s**2 - 990*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 - 792*D1*Ddd*f*g2*r**2 - 1584*D1*Ddd*f*g2*r*s + 1188*D1*Ddd*f*g2*r - 792*D1*Ddd*f*g2*s**2 + 1188*D1*Ddd*f*g2*s - 594*D1*Ddd*f*g2 - 198*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 4200*Dd**2*f**3*r**2 + 8400*Dd**2*f**3*r*s - 6300*Dd**2*f**3*r + 4200*Dd**2*f**3*s**2 - 6300*Dd**2*f**3*s + 2100*Dd**2*f**3 + 1980*Dd**2*f**2*r**2 + 3960*Dd**2*f**2*r*s - 2970*Dd**2*f**2*r + 1980*Dd**2*f**2*s**2 - 2970*Dd**2*f**2*s + 990*Dd**2*f**2 - 2376*Dd**2*f*g2*r**2 - 4752*Dd**2*f*g2*r*s + 3564*Dd**2*f*g2*r - 2376*Dd**2*f*g2*s**2 + 3564*Dd**2*f*g2*s - 1188*Dd**2*f*g2) + f*(D1**2*bdd1*(70*f**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 4) + 165*f*(r**2*(C + 1) + 2*r*(C*s + s - 2) + s**2*(C + 1) - 4*s + 2) - 198*g2*(r + s)**2) - 5*D1**2*(f*(79*fd - 56*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 112*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 5*D1*f*(Dd*(79*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 112*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 56*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 1680*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k3**4) - 5*D1**2*Pk2*Pkdd3*ct**6*k2**6*(D1**2*(f**2*(fd*(112*C - 56)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(56*C - 28)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(112*C - 56)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 66*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(56*C - 28)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(33*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(28 - 56*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 33*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(56*C*f + 33*K*b1 - 28*f - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(56*C*f + 33*K*b1 - 28*f - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(693*d**2*k3**6) + 5*D1**2*Pk2*Pkdd3*ct**6*k2**4*(336*C*D1**2*f**2*fd*r**2 + 672*C*D1**2*f**2*fd*r*s - 448*C*D1**2*f**2*fd*r + 336*C*D1**2*f**2*fd*s**2 - 448*C*D1**2*f**2*fd*s + 224*C*D1**2*f**2*fd - 168*C*D1**2*f**2*fdd*r**2 - 336*C*D1**2*f**2*fdd*r*s + 224*C*D1**2*f**2*fdd*r - 168*C*D1**2*f**2*fdd*s**2 + 224*C*D1**2*f**2*fdd*s - 112*C*D1**2*f**2*fdd - 336*C*D1**2*f*fd**2*r**2 - 672*C*D1**2*f*fd**2*r*s + 448*C*D1**2*f*fd**2*r - 336*C*D1**2*f*fd**2*s**2 + 448*C*D1**2*f*fd**2*s - 112*C*D1**2*f*fd**2 + 448*C*D1*Dd*f**3*r**2 + 896*C*D1*Dd*f**3*r*s - 672*C*D1*Dd*f**3*r + 448*C*D1*Dd*f**3*s**2 - 672*C*D1*Dd*f**3*s + 336*C*D1*Dd*f**3 - 1344*C*D1*Dd*f**2*fd*r**2 - 2688*C*D1*Dd*f**2*fd*r*s + 1904*C*D1*Dd*f**2*fd*r - 1344*C*D1*Dd*f**2*fd*s**2 + 1904*C*D1*Dd*f**2*fd*s - 672*C*D1*Dd*f**2*fd - 224*C*D1*Ddd*f**3*r**2 - 448*C*D1*Ddd*f**3*r*s + 336*C*D1*Ddd*f**3*r - 224*C*D1*Ddd*f**3*s**2 + 336*C*D1*Ddd*f**3*s - 168*C*D1*Ddd*f**3 - 672*C*Dd**2*f**3*r**2 - 1344*C*Dd**2*f**3*r*s + 1008*C*Dd**2*f**3*r - 672*C*Dd**2*f**3*s**2 + 1008*C*Dd**2*f**3*s - 336*C*Dd**2*f**3 + 132*D1**2*K*b1*f*fd*r**2 + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r + 132*D1**2*K*b1*f*fd*s**2 - 132*D1**2*K*b1*f*fd*s + 66*D1**2*K*b1*f*fd - 66*D1**2*K*b1*f*fdd*r**2 - 132*D1**2*K*b1*f*fdd*r*s + 66*D1**2*K*b1*f*fdd*r - 66*D1**2*K*b1*f*fdd*s**2 + 66*D1**2*K*b1*f*fdd*s - 33*D1**2*K*b1*f*fdd - 66*D1**2*K*b1*fd**2*r**2 - 132*D1**2*K*b1*fd**2*r*s + 66*D1**2*K*b1*fd**2*r - 66*D1**2*K*b1*fd**2*s**2 + 66*D1**2*K*b1*fd**2*s + 66*D1**2*K*bd1*f**2*r**2 + 132*D1**2*K*bd1*f**2*r*s - 132*D1**2*K*bd1*f**2*r + 66*D1**2*K*bd1*f**2*s**2 - 132*D1**2*K*bd1*f**2*s + 66*D1**2*K*bd1*f**2 - 132*D1**2*K*bd1*f*fd*r**2 - 264*D1**2*K*bd1*f*fd*r*s + 198*D1**2*K*bd1*f*fd*r - 132*D1**2*K*bd1*f*fd*s**2 + 198*D1**2*K*bd1*f*fd*s - 66*D1**2*K*bd1*f*fd - 33*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*K*bdd1*f**2*r*s + 66*D1**2*K*bdd1*f**2*r - 33*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s - 33*D1**2*K*bdd1*f**2 + 132*D1**2*b2*f*fd*r**2 + 264*D1**2*b2*f*fd*r*s - 132*D1**2*b2*f*fd*r + 132*D1**2*b2*f*fd*s**2 - 132*D1**2*b2*f*fd*s + 66*D1**2*b2*f*fd - 66*D1**2*b2*f*fdd*r**2 - 132*D1**2*b2*f*fdd*r*s + 66*D1**2*b2*f*fdd*r - 66*D1**2*b2*f*fdd*s**2 + 66*D1**2*b2*f*fdd*s - 33*D1**2*b2*f*fdd - 66*D1**2*b2*fd**2*r**2 - 132*D1**2*b2*fd**2*r*s + 66*D1**2*b2*fd**2*r - 66*D1**2*b2*fd**2*s**2 + 66*D1**2*b2*fd**2*s - 33*D1**2*bdd2*f**2*(r + s - 1)**2 - 168*D1**2*f**2*fd*r**2 - 336*D1**2*f**2*fd*r*s + 224*D1**2*f**2*fd*r - 168*D1**2*f**2*fd*s**2 + 224*D1**2*f**2*fd*s - 112*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r**2 + 168*D1**2*f**2*fdd*r*s - 112*D1**2*f**2*fdd*r + 84*D1**2*f**2*fdd*s**2 - 112*D1**2*f**2*fdd*s + 56*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*r - 132*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s - 132*D1**2*f**2*gd2 + 66*D1**2*f**2*gdd2*r**2 + 132*D1**2*f**2*gdd2*r*s - 132*D1**2*f**2*gdd2*r + 66*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 66*D1**2*f**2*gdd2 + 168*D1**2*f*fd**2*r**2 + 336*D1**2*f*fd**2*r*s - 224*D1**2*f*fd**2*r + 168*D1**2*f*fd**2*s**2 - 224*D1**2*f*fd**2*s + 56*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 + 528*D1**2*f*fd*gd2*r*s - 396*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 396*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r**2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 264*D1*Dd*K*b1*f**2*r**2 + 528*D1*Dd*K*b1*f**2*r*s - 396*D1*Dd*K*b1*f**2*r + 264*D1*Dd*K*b1*f**2*s**2 - 396*D1*Dd*K*b1*f**2*s + 198*D1*Dd*K*b1*f**2 - 528*D1*Dd*K*b1*f*fd*r**2 - 1056*D1*Dd*K*b1*f*fd*r*s + 660*D1*Dd*K*b1*f*fd*r - 528*D1*Dd*K*b1*f*fd*s**2 + 660*D1*Dd*K*b1*f*fd*s - 198*D1*Dd*K*b1*f*fd - 264*D1*Dd*K*bd1*f**2*r**2 - 528*D1*Dd*K*bd1*f**2*r*s + 462*D1*Dd*K*bd1*f**2*r - 264*D1*Dd*K*bd1*f**2*s**2 + 462*D1*Dd*K*bd1*f**2*s - 198*D1*Dd*K*bd1*f**2 + 264*D1*Dd*b2*f**2*r**2 + 528*D1*Dd*b2*f**2*r*s - 396*D1*Dd*b2*f**2*r + 264*D1*Dd*b2*f**2*s**2 - 396*D1*Dd*b2*f**2*s + 198*D1*Dd*b2*f**2 - 528*D1*Dd*b2*f*fd*r**2 - 1056*D1*Dd*b2*f*fd*r*s + 660*D1*Dd*b2*f*fd*r - 528*D1*Dd*b2*f*fd*s**2 + 660*D1*Dd*b2*f*fd*s - 198*D1*Dd*b2*f*fd - 224*D1*Dd*f**3*r**2 - 448*D1*Dd*f**3*r*s + 336*D1*Dd*f**3*r - 224*D1*Dd*f**3*s**2 + 336*D1*Dd*f**3*s - 168*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r**2 + 1344*D1*Dd*f**2*fd*r*s - 952*D1*Dd*f**2*fd*r + 672*D1*Dd*f**2*fd*s**2 - 952*D1*Dd*f**2*fd*s + 336*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s + 792*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 792*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 + 1056*D1*Dd*f**2*gd2*r*s - 924*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 924*D1*Dd*f**2*gd2*s + 396*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r**2 + 2112*D1*Dd*f*fd*g2*r*s - 1320*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1320*D1*Dd*f*fd*g2*s + 396*D1*Dd*f*fd*g2 - 132*D1*Ddd*K*b1*f**2*r**2 - 264*D1*Ddd*K*b1*f**2*r*s + 198*D1*Ddd*K*b1*f**2*r - 132*D1*Ddd*K*b1*f**2*s**2 + 198*D1*Ddd*K*b1*f**2*s - 99*D1*Ddd*K*b1*f**2 - 132*D1*Ddd*b2*f**2*r**2 - 264*D1*Ddd*b2*f**2*r*s + 198*D1*Ddd*b2*f**2*r - 132*D1*Ddd*b2*f**2*s**2 + 198*D1*Ddd*b2*f**2*s - 99*D1*Ddd*b2*f**2 + 112*D1*Ddd*f**3*r**2 + 224*D1*Ddd*f**3*r*s - 168*D1*Ddd*f**3*r + 112*D1*Ddd*f**3*s**2 - 168*D1*Ddd*f**3*s + 84*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r**2 + 528*D1*Ddd*f**2*g2*r*s - 396*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 396*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 66*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*K*b1*f**2*r**2 - 792*Dd**2*K*b1*f**2*r*s + 594*Dd**2*K*b1*f**2*r - 396*Dd**2*K*b1*f**2*s**2 + 594*Dd**2*K*b1*f**2*s - 198*Dd**2*K*b1*f**2 - 396*Dd**2*b2*f**2*r**2 - 792*Dd**2*b2*f**2*r*s + 594*Dd**2*b2*f**2*r - 396*Dd**2*b2*f**2*s**2 + 594*Dd**2*b2*f**2*s - 198*Dd**2*b2*f**2 + 336*Dd**2*f**3*r**2 + 672*Dd**2*f**3*r*s - 504*Dd**2*f**3*r + 336*Dd**2*f**3*s**2 - 504*Dd**2*f**3*s + 168*Dd**2*f**3 + 792*Dd**2*f**2*g2*r**2 + 1584*Dd**2*f**2*g2*r*s - 1188*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 1188*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2)/(693*d**2*k3**4) - 2*D1**2*Pk2*Pkdd3*ct**5*k1**5*k2*(17940*C*D1**2*f**2*fd*r**2 + 35880*C*D1**2*f**2*fd*r*s - 23920*C*D1**2*f**2*fd*r + 17940*C*D1**2*f**2*fd*s**2 - 23920*C*D1**2*f**2*fd*s + 11960*C*D1**2*f**2*fd - 21840*C*D1**2*f**2*fdd*r**2 - 43680*C*D1**2*f**2*fdd*r*s + 29120*C*D1**2*f**2*fdd*r - 21840*C*D1**2*f**2*fdd*s**2 + 29120*C*D1**2*f**2*fdd*s - 14560*C*D1**2*f**2*fdd - 43680*C*D1**2*f*fd**2*r**2 - 87360*C*D1**2*f*fd**2*r*s + 58240*C*D1**2*f*fd**2*r - 43680*C*D1**2*f*fd**2*s**2 + 58240*C*D1**2*f*fd**2*s - 14560*C*D1**2*f*fd**2 + 23920*C*D1*Dd*f**3*r**2 + 47840*C*D1*Dd*f**3*r*s - 35880*C*D1*Dd*f**3*r + 23920*C*D1*Dd*f**3*s**2 - 35880*C*D1*Dd*f**3*s + 17940*C*D1*Dd*f**3 - 174720*C*D1*Dd*f**2*fd*r**2 - 349440*C*D1*Dd*f**2*fd*r*s + 247520*C*D1*Dd*f**2*fd*r - 174720*C*D1*Dd*f**2*fd*s**2 + 247520*C*D1*Dd*f**2*fd*s - 87360*C*D1*Dd*f**2*fd - 29120*C*D1*Ddd*f**3*r**2 - 58240*C*D1*Ddd*f**3*r*s + 43680*C*D1*Ddd*f**3*r - 29120*C*D1*Ddd*f**3*s**2 + 43680*C*D1*Ddd*f**3*s - 21840*C*D1*Ddd*f**3 - 87360*C*Dd**2*f**3*r**2 - 174720*C*Dd**2*f**3*r*s + 131040*C*Dd**2*f**3*r - 87360*C*Dd**2*f**3*s**2 + 131040*C*Dd**2*f**3*s - 43680*C*Dd**2*f**3 + 6864*D1**2*K*b1*f*fd*r**2 + 13728*D1**2*K*b1*f*fd*r*s - 6864*D1**2*K*b1*f*fd*r + 6864*D1**2*K*b1*f*fd*s**2 - 6864*D1**2*K*b1*f*fd*s + 3432*D1**2*K*b1*f*fd - 8580*D1**2*K*b1*f*fdd*r**2 - 17160*D1**2*K*b1*f*fdd*r*s + 8580*D1**2*K*b1*f*fdd*r - 8580*D1**2*K*b1*f*fdd*s**2 + 8580*D1**2*K*b1*f*fdd*s - 4290*D1**2*K*b1*f*fdd - 8580*D1**2*K*b1*fd**2*r**2 - 17160*D1**2*K*b1*fd**2*r*s + 8580*D1**2*K*b1*fd**2*r - 8580*D1**2*K*b1*fd**2*s**2 + 8580*D1**2*K*b1*fd**2*s - 6864*D1**2*b1*f*fd*r**2 - 13728*D1**2*b1*f*fd*r*s + 6864*D1**2*b1*f*fd*r - 6864*D1**2*b1*f*fd*s**2 + 6864*D1**2*b1*f*fd*s - 3432*D1**2*b1*f*fd + 8580*D1**2*b1*f*fdd*r**2 + 17160*D1**2*b1*f*fdd*r*s - 8580*D1**2*b1*f*fdd*r + 8580*D1**2*b1*f*fdd*s**2 - 8580*D1**2*b1*f*fdd*s + 4290*D1**2*b1*f*fdd + 8580*D1**2*b1*fd**2*r**2 + 17160*D1**2*b1*fd**2*r*s - 8580*D1**2*b1*fd**2*r + 8580*D1**2*b1*fd**2*s**2 - 8580*D1**2*b1*fd**2*s - 4290*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 30240*D1**2*f**3*fd*r**2 + 60480*D1**2*f**3*fd*r*s - 45360*D1**2*f**3*fd*r + 30240*D1**2*f**3*fd*s**2 - 45360*D1**2*f**3*fd*s + 22680*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 - 17940*D1**2*f**2*fd*r**2 - 35880*D1**2*f**2*fd*r*s + 23920*D1**2*f**2*fd*r - 17940*D1**2*f**2*fd*s**2 + 23920*D1**2*f**2*fd*s - 11960*D1**2*f**2*fd + 21840*D1**2*f**2*fdd*r**2 + 43680*D1**2*f**2*fdd*r*s - 29120*D1**2*f**2*fdd*r + 21840*D1**2*f**2*fdd*s**2 - 29120*D1**2*f**2*fdd*s + 14560*D1**2*f**2*fdd - 6864*D1**2*f**2*gd2*r**2 - 13728*D1**2*f**2*gd2*r*s + 13728*D1**2*f**2*gd2*r - 6864*D1**2*f**2*gd2*s**2 + 13728*D1**2*f**2*gd2*s - 6864*D1**2*f**2*gd2 + 8580*D1**2*f**2*gdd2*r**2 + 17160*D1**2*f**2*gdd2*r*s - 17160*D1**2*f**2*gdd2*r + 8580*D1**2*f**2*gdd2*s**2 - 17160*D1**2*f**2*gdd2*s + 8580*D1**2*f**2*gdd2 + 43680*D1**2*f*fd**2*r**2 + 87360*D1**2*f*fd**2*r*s - 58240*D1**2*f*fd**2*r + 43680*D1**2*f*fd**2*s**2 - 58240*D1**2*f*fd**2*s + 14560*D1**2*f*fd**2 - 13728*D1**2*f*fd*g2*r**2 - 27456*D1**2*f*fd*g2*r*s + 13728*D1**2*f*fd*g2*r - 13728*D1**2*f*fd*g2*s**2 + 13728*D1**2*f*fd*g2*s - 6864*D1**2*f*fd*g2 + 34320*D1**2*f*fd*gd2*r**2 + 68640*D1**2*f*fd*gd2*r*s - 51480*D1**2*f*fd*gd2*r + 34320*D1**2*f*fd*gd2*s**2 - 51480*D1**2*f*fd*gd2*s + 17160*D1**2*f*fd*gd2 + 17160*D1**2*f*fdd*g2*r**2 + 34320*D1**2*f*fdd*g2*r*s - 17160*D1**2*f*fdd*g2*r + 17160*D1**2*f*fdd*g2*s**2 - 17160*D1**2*f*fdd*g2*s + 8580*D1**2*f*fdd*g2 + 17160*D1**2*fd**2*g2*r**2 + 34320*D1**2*fd**2*g2*r*s - 17160*D1**2*fd**2*g2*r + 17160*D1**2*fd**2*g2*s**2 - 17160*D1**2*fd**2*g2*s + 13728*D1*Dd*K*b1*f**2*r**2 + 27456*D1*Dd*K*b1*f**2*r*s - 20592*D1*Dd*K*b1*f**2*r + 13728*D1*Dd*K*b1*f**2*s**2 - 20592*D1*Dd*K*b1*f**2*s + 10296*D1*Dd*K*b1*f**2 - 68640*D1*Dd*K*b1*f*fd*r**2 - 137280*D1*Dd*K*b1*f*fd*r*s + 85800*D1*Dd*K*b1*f*fd*r - 68640*D1*Dd*K*b1*f*fd*s**2 + 85800*D1*Dd*K*b1*f*fd*s - 25740*D1*Dd*K*b1*f*fd - 13728*D1*Dd*b1*f**2*r**2 - 27456*D1*Dd*b1*f**2*r*s + 20592*D1*Dd*b1*f**2*r - 13728*D1*Dd*b1*f**2*s**2 + 20592*D1*Dd*b1*f**2*s - 10296*D1*Dd*b1*f**2 + 68640*D1*Dd*b1*f*fd*r**2 + 137280*D1*Dd*b1*f*fd*r*s - 85800*D1*Dd*b1*f*fd*r + 68640*D1*Dd*b1*f*fd*s**2 - 85800*D1*Dd*b1*f*fd*s + 25740*D1*Dd*b1*f*fd + 30240*D1*Dd*f**4*r**2 + 60480*D1*Dd*f**4*r*s - 45360*D1*Dd*f**4*r + 30240*D1*Dd*f**4*s**2 - 45360*D1*Dd*f**4*s + 22680*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd - 23920*D1*Dd*f**3*r**2 - 47840*D1*Dd*f**3*r*s + 35880*D1*Dd*f**3*r - 23920*D1*Dd*f**3*s**2 + 35880*D1*Dd*f**3*s - 17940*D1*Dd*f**3 + 174720*D1*Dd*f**2*fd*r**2 + 349440*D1*Dd*f**2*fd*r*s - 247520*D1*Dd*f**2*fd*r + 174720*D1*Dd*f**2*fd*s**2 - 247520*D1*Dd*f**2*fd*s + 87360*D1*Dd*f**2*fd - 27456*D1*Dd*f**2*g2*r**2 - 54912*D1*Dd*f**2*g2*r*s + 41184*D1*Dd*f**2*g2*r - 27456*D1*Dd*f**2*g2*s**2 + 41184*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*g2 + 68640*D1*Dd*f**2*gd2*r**2 + 137280*D1*Dd*f**2*gd2*r*s - 120120*D1*Dd*f**2*gd2*r + 68640*D1*Dd*f**2*gd2*s**2 - 120120*D1*Dd*f**2*gd2*s + 51480*D1*Dd*f**2*gd2 + 137280*D1*Dd*f*fd*g2*r**2 + 274560*D1*Dd*f*fd*g2*r*s - 171600*D1*Dd*f*fd*g2*r + 137280*D1*Dd*f*fd*g2*s**2 - 171600*D1*Dd*f*fd*g2*s + 51480*D1*Dd*f*fd*g2 - 17160*D1*Ddd*K*b1*f**2*r**2 - 34320*D1*Ddd*K*b1*f**2*r*s + 25740*D1*Ddd*K*b1*f**2*r - 17160*D1*Ddd*K*b1*f**2*s**2 + 25740*D1*Ddd*K*b1*f**2*s - 12870*D1*Ddd*K*b1*f**2 + 17160*D1*Ddd*b1*f**2*r**2 + 34320*D1*Ddd*b1*f**2*r*s - 25740*D1*Ddd*b1*f**2*r + 17160*D1*Ddd*b1*f**2*s**2 - 25740*D1*Ddd*b1*f**2*s + 12870*D1*Ddd*b1*f**2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 29120*D1*Ddd*f**3*r**2 + 58240*D1*Ddd*f**3*r*s - 43680*D1*Ddd*f**3*r + 29120*D1*Ddd*f**3*s**2 - 43680*D1*Ddd*f**3*s + 21840*D1*Ddd*f**3 + 34320*D1*Ddd*f**2*g2*r**2 + 68640*D1*Ddd*f**2*g2*r*s - 51480*D1*Ddd*f**2*g2*r + 34320*D1*Ddd*f**2*g2*s**2 - 51480*D1*Ddd*f**2*g2*s + 25740*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 51480*Dd**2*K*b1*f**2*r**2 - 102960*Dd**2*K*b1*f**2*r*s + 77220*Dd**2*K*b1*f**2*r - 51480*Dd**2*K*b1*f**2*s**2 + 77220*Dd**2*K*b1*f**2*s - 25740*Dd**2*K*b1*f**2 + 51480*Dd**2*b1*f**2*r**2 + 102960*Dd**2*b1*f**2*r*s - 77220*Dd**2*b1*f**2*r + 51480*Dd**2*b1*f**2*s**2 - 77220*Dd**2*b1*f**2*s + 25740*Dd**2*b1*f**2 - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 87360*Dd**2*f**3*r**2 + 174720*Dd**2*f**3*r*s - 131040*Dd**2*f**3*r + 87360*Dd**2*f**3*s**2 - 131040*Dd**2*f**3*s + 43680*Dd**2*f**3 + 102960*Dd**2*f**2*g2*r**2 + 205920*Dd**2*f**2*g2*r*s - 154440*Dd**2*f**2*g2*r + 102960*Dd**2*f**2*g2*s**2 - 154440*Dd**2*f**2*g2*s + 51480*Dd**2*f**2*g2)/(9009*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**5*k1**3*k2**3*st**2*(125112*C*D1**2*f**2*fd*r**2 + 250224*C*D1**2*f**2*fd*r*s - 166816*C*D1**2*f**2*fd*r + 125112*C*D1**2*f**2*fd*s**2 - 166816*C*D1**2*f**2*fd*s + 83408*C*D1**2*f**2*fd - 78000*C*D1**2*f**2*fdd*r**2 - 156000*C*D1**2*f**2*fdd*r*s + 104000*C*D1**2*f**2*fdd*r - 78000*C*D1**2*f**2*fdd*s**2 + 104000*C*D1**2*f**2*fdd*s - 52000*C*D1**2*f**2*fdd - 156000*C*D1**2*f*fd**2*r**2 - 312000*C*D1**2*f*fd**2*r*s + 208000*C*D1**2*f*fd**2*r - 156000*C*D1**2*f*fd**2*s**2 + 208000*C*D1**2*f*fd**2*s - 52000*C*D1**2*f*fd**2 + 166816*C*D1*Dd*f**3*r**2 + 333632*C*D1*Dd*f**3*r*s - 250224*C*D1*Dd*f**3*r + 166816*C*D1*Dd*f**3*s**2 - 250224*C*D1*Dd*f**3*s + 125112*C*D1*Dd*f**3 - 624000*C*D1*Dd*f**2*fd*r**2 - 1248000*C*D1*Dd*f**2*fd*r*s + 884000*C*D1*Dd*f**2*fd*r - 624000*C*D1*Dd*f**2*fd*s**2 + 884000*C*D1*Dd*f**2*fd*s - 312000*C*D1*Dd*f**2*fd - 104000*C*D1*Ddd*f**3*r**2 - 208000*C*D1*Ddd*f**3*r*s + 156000*C*D1*Ddd*f**3*r - 104000*C*D1*Ddd*f**3*s**2 + 156000*C*D1*Ddd*f**3*s - 78000*C*D1*Ddd*f**3 - 312000*C*Dd**2*f**3*r**2 - 624000*C*Dd**2*f**3*r*s + 468000*C*Dd**2*f**3*r - 312000*C*Dd**2*f**3*s**2 + 468000*C*Dd**2*f**3*s - 156000*C*Dd**2*f**3 + 58344*D1**2*K*b1*f*fd*r**2 + 116688*D1**2*K*b1*f*fd*r*s - 58344*D1**2*K*b1*f*fd*r + 58344*D1**2*K*b1*f*fd*s**2 - 58344*D1**2*K*b1*f*fd*s + 29172*D1**2*K*b1*f*fd - 34320*D1**2*K*b1*f*fdd*r**2 - 68640*D1**2*K*b1*f*fdd*r*s + 34320*D1**2*K*b1*f*fdd*r - 34320*D1**2*K*b1*f*fdd*s**2 + 34320*D1**2*K*b1*f*fdd*s - 17160*D1**2*K*b1*f*fdd - 34320*D1**2*K*b1*fd**2*r**2 - 68640*D1**2*K*b1*fd**2*r*s + 34320*D1**2*K*b1*fd**2*r - 34320*D1**2*K*b1*fd**2*s**2 + 34320*D1**2*K*b1*fd**2*s - 58344*D1**2*b1*f*fd*r**2 - 116688*D1**2*b1*f*fd*r*s + 58344*D1**2*b1*f*fd*r - 58344*D1**2*b1*f*fd*s**2 + 58344*D1**2*b1*f*fd*s - 29172*D1**2*b1*f*fd + 34320*D1**2*b1*f*fdd*r**2 + 68640*D1**2*b1*f*fdd*r*s - 34320*D1**2*b1*f*fdd*r + 34320*D1**2*b1*f*fdd*s**2 - 34320*D1**2*b1*f*fdd*s + 17160*D1**2*b1*f*fdd + 34320*D1**2*b1*fd**2*r**2 + 68640*D1**2*b1*fd**2*r*s - 34320*D1**2*b1*fd**2*r + 34320*D1**2*b1*fd**2*s**2 - 34320*D1**2*b1*fd**2*s - 17160*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 166800*D1**2*f**3*fd*r**2 + 333600*D1**2*f**3*fd*r*s - 250200*D1**2*f**3*fd*r + 166800*D1**2*f**3*fd*s**2 - 250200*D1**2*f**3*fd*s + 125100*D1**2*f**3*fd - 102900*D1**2*f**3*fdd*r**2 - 205800*D1**2*f**3*fdd*r*s + 154350*D1**2*f**3*fdd*r - 102900*D1**2*f**3*fdd*s**2 + 154350*D1**2*f**3*fdd*s - 77175*D1**2*f**3*fdd - 308700*D1**2*f**2*fd**2*r**2 - 617400*D1**2*f**2*fd**2*r*s + 463050*D1**2*f**2*fd**2*r - 308700*D1**2*f**2*fd**2*s**2 + 463050*D1**2*f**2*fd**2*s - 154350*D1**2*f**2*fd**2 - 125112*D1**2*f**2*fd*r**2 - 250224*D1**2*f**2*fd*r*s + 166816*D1**2*f**2*fd*r - 125112*D1**2*f**2*fd*s**2 + 166816*D1**2*f**2*fd*s - 83408*D1**2*f**2*fd + 78000*D1**2*f**2*fdd*r**2 + 156000*D1**2*f**2*fdd*r*s - 104000*D1**2*f**2*fdd*r + 78000*D1**2*f**2*fdd*s**2 - 104000*D1**2*f**2*fdd*s + 52000*D1**2*f**2*fdd - 58344*D1**2*f**2*gd2*r**2 - 116688*D1**2*f**2*gd2*r*s + 116688*D1**2*f**2*gd2*r - 58344*D1**2*f**2*gd2*s**2 + 116688*D1**2*f**2*gd2*s - 58344*D1**2*f**2*gd2 + 34320*D1**2*f**2*gdd2*r**2 + 68640*D1**2*f**2*gdd2*r*s - 68640*D1**2*f**2*gdd2*r + 34320*D1**2*f**2*gdd2*s**2 - 68640*D1**2*f**2*gdd2*s + 34320*D1**2*f**2*gdd2 + 156000*D1**2*f*fd**2*r**2 + 312000*D1**2*f*fd**2*r*s - 208000*D1**2*f*fd**2*r + 156000*D1**2*f*fd**2*s**2 - 208000*D1**2*f*fd**2*s + 52000*D1**2*f*fd**2 - 116688*D1**2*f*fd*g2*r**2 - 233376*D1**2*f*fd*g2*r*s + 116688*D1**2*f*fd*g2*r - 116688*D1**2*f*fd*g2*s**2 + 116688*D1**2*f*fd*g2*s - 58344*D1**2*f*fd*g2 + 137280*D1**2*f*fd*gd2*r**2 + 274560*D1**2*f*fd*gd2*r*s - 205920*D1**2*f*fd*gd2*r + 137280*D1**2*f*fd*gd2*s**2 - 205920*D1**2*f*fd*gd2*s + 68640*D1**2*f*fd*gd2 + 68640*D1**2*f*fdd*g2*r**2 + 137280*D1**2*f*fdd*g2*r*s - 68640*D1**2*f*fdd*g2*r + 68640*D1**2*f*fdd*g2*s**2 - 68640*D1**2*f*fdd*g2*s + 34320*D1**2*f*fdd*g2 + 68640*D1**2*fd**2*g2*r**2 + 137280*D1**2*fd**2*g2*r*s - 68640*D1**2*fd**2*g2*r + 68640*D1**2*fd**2*g2*s**2 - 68640*D1**2*fd**2*g2*s + 116688*D1*Dd*K*b1*f**2*r**2 + 233376*D1*Dd*K*b1*f**2*r*s - 175032*D1*Dd*K*b1*f**2*r + 116688*D1*Dd*K*b1*f**2*s**2 - 175032*D1*Dd*K*b1*f**2*s + 87516*D1*Dd*K*b1*f**2 - 274560*D1*Dd*K*b1*f*fd*r**2 - 549120*D1*Dd*K*b1*f*fd*r*s + 343200*D1*Dd*K*b1*f*fd*r - 274560*D1*Dd*K*b1*f*fd*s**2 + 343200*D1*Dd*K*b1*f*fd*s - 102960*D1*Dd*K*b1*f*fd - 116688*D1*Dd*b1*f**2*r**2 - 233376*D1*Dd*b1*f**2*r*s + 175032*D1*Dd*b1*f**2*r - 116688*D1*Dd*b1*f**2*s**2 + 175032*D1*Dd*b1*f**2*s - 87516*D1*Dd*b1*f**2 + 274560*D1*Dd*b1*f*fd*r**2 + 549120*D1*Dd*b1*f*fd*r*s - 343200*D1*Dd*b1*f*fd*r + 274560*D1*Dd*b1*f*fd*s**2 - 343200*D1*Dd*b1*f*fd*s + 102960*D1*Dd*b1*f*fd + 166800*D1*Dd*f**4*r**2 + 333600*D1*Dd*f**4*r*s - 250200*D1*Dd*f**4*r + 166800*D1*Dd*f**4*s**2 - 250200*D1*Dd*f**4*s + 125100*D1*Dd*f**4 - 823200*D1*Dd*f**3*fd*r**2 - 1646400*D1*Dd*f**3*fd*r*s + 1234800*D1*Dd*f**3*fd*r - 823200*D1*Dd*f**3*fd*s**2 + 1234800*D1*Dd*f**3*fd*s - 463050*D1*Dd*f**3*fd - 166816*D1*Dd*f**3*r**2 - 333632*D1*Dd*f**3*r*s + 250224*D1*Dd*f**3*r - 166816*D1*Dd*f**3*s**2 + 250224*D1*Dd*f**3*s - 125112*D1*Dd*f**3 + 624000*D1*Dd*f**2*fd*r**2 + 1248000*D1*Dd*f**2*fd*r*s - 884000*D1*Dd*f**2*fd*r + 624000*D1*Dd*f**2*fd*s**2 - 884000*D1*Dd*f**2*fd*s + 312000*D1*Dd*f**2*fd - 233376*D1*Dd*f**2*g2*r**2 - 466752*D1*Dd*f**2*g2*r*s + 350064*D1*Dd*f**2*g2*r - 233376*D1*Dd*f**2*g2*s**2 + 350064*D1*Dd*f**2*g2*s - 175032*D1*Dd*f**2*g2 + 274560*D1*Dd*f**2*gd2*r**2 + 549120*D1*Dd*f**2*gd2*r*s - 480480*D1*Dd*f**2*gd2*r + 274560*D1*Dd*f**2*gd2*s**2 - 480480*D1*Dd*f**2*gd2*s + 205920*D1*Dd*f**2*gd2 + 549120*D1*Dd*f*fd*g2*r**2 + 1098240*D1*Dd*f*fd*g2*r*s - 686400*D1*Dd*f*fd*g2*r + 549120*D1*Dd*f*fd*g2*s**2 - 686400*D1*Dd*f*fd*g2*s + 205920*D1*Dd*f*fd*g2 - 68640*D1*Ddd*K*b1*f**2*r**2 - 137280*D1*Ddd*K*b1*f**2*r*s + 102960*D1*Ddd*K*b1*f**2*r - 68640*D1*Ddd*K*b1*f**2*s**2 + 102960*D1*Ddd*K*b1*f**2*s - 51480*D1*Ddd*K*b1*f**2 + 68640*D1*Ddd*b1*f**2*r**2 + 137280*D1*Ddd*b1*f**2*r*s - 102960*D1*Ddd*b1*f**2*r + 68640*D1*Ddd*b1*f**2*s**2 - 102960*D1*Ddd*b1*f**2*s + 51480*D1*Ddd*b1*f**2 - 102900*D1*Ddd*f**4*r**2 - 205800*D1*Ddd*f**4*r*s + 154350*D1*Ddd*f**4*r - 102900*D1*Ddd*f**4*s**2 + 154350*D1*Ddd*f**4*s - 77175*D1*Ddd*f**4 + 104000*D1*Ddd*f**3*r**2 + 208000*D1*Ddd*f**3*r*s - 156000*D1*Ddd*f**3*r + 104000*D1*Ddd*f**3*s**2 - 156000*D1*Ddd*f**3*s + 78000*D1*Ddd*f**3 + 137280*D1*Ddd*f**2*g2*r**2 + 274560*D1*Ddd*f**2*g2*r*s - 205920*D1*Ddd*f**2*g2*r + 137280*D1*Ddd*f**2*g2*s**2 - 205920*D1*Ddd*f**2*g2*s + 102960*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(17*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) - 205920*Dd**2*K*b1*f**2*r**2 - 411840*Dd**2*K*b1*f**2*r*s + 308880*Dd**2*K*b1*f**2*r - 205920*Dd**2*K*b1*f**2*s**2 + 308880*Dd**2*K*b1*f**2*s - 102960*Dd**2*K*b1*f**2 + 205920*Dd**2*b1*f**2*r**2 + 411840*Dd**2*b1*f**2*r*s - 308880*Dd**2*b1*f**2*r + 205920*Dd**2*b1*f**2*s**2 - 308880*Dd**2*b1*f**2*s + 102960*Dd**2*b1*f**2 - 308700*Dd**2*f**4*r**2 - 617400*Dd**2*f**4*r*s + 463050*Dd**2*f**4*r - 308700*Dd**2*f**4*s**2 + 463050*Dd**2*f**4*s - 154350*Dd**2*f**4 + 312000*Dd**2*f**3*r**2 + 624000*Dd**2*f**3*r*s - 468000*Dd**2*f**3*r + 312000*Dd**2*f**3*s**2 - 468000*Dd**2*f**3*s + 156000*Dd**2*f**3 + 411840*Dd**2*f**2*g2*r**2 + 823680*Dd**2*f**2*g2*r*s - 617760*Dd**2*f**2*g2*r + 411840*Dd**2*f**2*g2*s**2 - 617760*Dd**2*f**2*g2*s + 205920*Dd**2*f**2*g2)/(18018*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**5*k1**3*k2**3*(-1320*C*D1**2*bdd1*f**2*r**2 - 2640*C*D1**2*bdd1*f**2*r*s + 2640*C*D1**2*bdd1*f**2*r - 1320*C*D1**2*bdd1*f**2*s**2 + 2640*C*D1**2*bdd1*f**2*s - 1320*C*D1**2*bdd1*f**2 + 8280*C*D1**2*f**2*fd*r**2 + 16560*C*D1**2*f**2*fd*r*s - 11040*C*D1**2*f**2*fd*r + 8280*C*D1**2*f**2*fd*s**2 - 11040*C*D1**2*f**2*fd*s + 5520*C*D1**2*f**2*fd - 10080*C*D1**2*f**2*fdd*r**2 - 20160*C*D1**2*f**2*fdd*r*s + 13440*C*D1**2*f**2*fdd*r - 10080*C*D1**2*f**2*fdd*s**2 + 13440*C*D1**2*f**2*fdd*s - 6720*C*D1**2*f**2*fdd - 20160*C*D1**2*f*fd**2*r**2 - 40320*C*D1**2*f*fd**2*r*s + 26880*C*D1**2*f*fd**2*r - 20160*C*D1**2*f*fd**2*s**2 + 26880*C*D1**2*f*fd**2*s - 6720*C*D1**2*f*fd**2 + 11040*C*D1*Dd*f**3*r**2 + 22080*C*D1*Dd*f**3*r*s - 16560*C*D1*Dd*f**3*r + 11040*C*D1*Dd*f**3*s**2 - 16560*C*D1*Dd*f**3*s + 8280*C*D1*Dd*f**3 - 80640*C*D1*Dd*f**2*fd*r**2 - 161280*C*D1*Dd*f**2*fd*r*s + 114240*C*D1*Dd*f**2*fd*r - 80640*C*D1*Dd*f**2*fd*s**2 + 114240*C*D1*Dd*f**2*fd*s - 40320*C*D1*Dd*f**2*fd - 13440*C*D1*Ddd*f**3*r**2 - 26880*C*D1*Ddd*f**3*r*s + 20160*C*D1*Ddd*f**3*r - 13440*C*D1*Ddd*f**3*s**2 + 20160*C*D1*Ddd*f**3*s - 10080*C*D1*Ddd*f**3 - 40320*C*Dd**2*f**3*r**2 - 80640*C*Dd**2*f**3*r*s + 60480*C*Dd**2*f**3*r - 40320*C*Dd**2*f**3*s**2 + 60480*C*Dd**2*f**3*s - 20160*C*Dd**2*f**3 - 1980*D1**2*K*bdd1*f**2*r**2 - 3960*D1**2*K*bdd1*f**2*r*s + 3960*D1**2*K*bdd1*f**2*r - 1980*D1**2*K*bdd1*f**2*s**2 + 3960*D1**2*K*bdd1*f**2*s - 1980*D1**2*K*bdd1*f**2 - 1584*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 700*D1**2*bdd1*f**3*r**2 + 1400*D1**2*bdd1*f**3*r*s - 1400*D1**2*bdd1*f**3*r + 700*D1**2*bdd1*f**3*s**2 - 1400*D1**2*bdd1*f**3*s + 700*D1**2*bdd1*f**3 + 2310*D1**2*bdd1*f**2*r**2 + 4620*D1**2*bdd1*f**2*r*s - 4620*D1**2*bdd1*f**2*r + 2310*D1**2*bdd1*f**2*s**2 - 4620*D1**2*bdd1*f**2*s + 2310*D1**2*bdd1*f**2 + 1584*D1**2*bdd1*f*g2*r**2 + 3168*D1**2*bdd1*f*g2*r*s - 3168*D1**2*bdd1*f*g2*r + 1584*D1**2*bdd1*f*g2*s**2 - 3168*D1**2*bdd1*f*g2*s + 1584*D1**2*bdd1*f*g2 - 1680*D1**2*f**3*fd*r**2 - 3360*D1**2*f**3*fd*r*s + 2520*D1**2*f**3*fd*r - 1680*D1**2*f**3*fd*s**2 + 2520*D1**2*f**3*fd*s - 1260*D1**2*f**3*fd - 5715*D1**2*f**2*fd*r**2 - 11430*D1**2*f**2*fd*r*s + 7620*D1**2*f**2*fd*r - 5715*D1**2*f**2*fd*s**2 + 7620*D1**2*f**2*fd*s - 3810*D1**2*f**2*fd + 7560*D1**2*f**2*fdd*r**2 + 15120*D1**2*f**2*fdd*r*s - 10080*D1**2*f**2*fdd*r + 7560*D1**2*f**2*fdd*s**2 - 10080*D1**2*f**2*fdd*s + 5040*D1**2*f**2*fdd - 3168*D1**2*f**2*gd2*r**2 - 6336*D1**2*f**2*gd2*r*s + 6336*D1**2*f**2*gd2*r - 3168*D1**2*f**2*gd2*s**2 + 6336*D1**2*f**2*gd2*s - 3168*D1**2*f**2*gd2 + 3960*D1**2*f**2*gdd2*r**2 + 7920*D1**2*f**2*gdd2*r*s - 7920*D1**2*f**2*gdd2*r + 3960*D1**2*f**2*gdd2*s**2 - 7920*D1**2*f**2*gdd2*s + 3960*D1**2*f**2*gdd2 + 15120*D1**2*f*fd**2*r**2 + 30240*D1**2*f*fd**2*r*s - 20160*D1**2*f*fd**2*r + 15120*D1**2*f*fd**2*s**2 - 20160*D1**2*f*fd**2*s + 5040*D1**2*f*fd**2 - 6336*D1**2*f*fd*g2*r**2 - 12672*D1**2*f*fd*g2*r*s + 6336*D1**2*f*fd*g2*r - 6336*D1**2*f*fd*g2*s**2 + 6336*D1**2*f*fd*g2*s - 3168*D1**2*f*fd*g2 + 15840*D1**2*f*fd*gd2*r**2 + 31680*D1**2*f*fd*gd2*r*s - 23760*D1**2*f*fd*gd2*r + 15840*D1**2*f*fd*gd2*s**2 - 23760*D1**2*f*fd*gd2*s + 7920*D1**2*f*fd*gd2 + 7920*D1**2*f*fdd*g2*r**2 + 15840*D1**2*f*fdd*g2*r*s - 7920*D1**2*f*fdd*g2*r + 7920*D1**2*f*fdd*g2*s**2 - 7920*D1**2*f*fdd*g2*s + 3960*D1**2*f*fdd*g2 + 7920*D1**2*fd**2*g2*r**2 + 15840*D1**2*fd**2*g2*r*s - 7920*D1**2*fd**2*g2*r + 7920*D1**2*fd**2*g2*s**2 - 7920*D1**2*fd**2*g2*s - 1680*D1*Dd*f**4*r**2 - 3360*D1*Dd*f**4*r*s + 2520*D1*Dd*f**4*r - 1680*D1*Dd*f**4*s**2 + 2520*D1*Dd*f**4*s - 1260*D1*Dd*f**4 - 7620*D1*Dd*f**3*r**2 - 15240*D1*Dd*f**3*r*s + 11430*D1*Dd*f**3*r - 7620*D1*Dd*f**3*s**2 + 11430*D1*Dd*f**3*s - 5715*D1*Dd*f**3 + 60480*D1*Dd*f**2*fd*r**2 + 120960*D1*Dd*f**2*fd*r*s - 85680*D1*Dd*f**2*fd*r + 60480*D1*Dd*f**2*fd*s**2 - 85680*D1*Dd*f**2*fd*s + 30240*D1*Dd*f**2*fd - 12672*D1*Dd*f**2*g2*r**2 - 25344*D1*Dd*f**2*g2*r*s + 19008*D1*Dd*f**2*g2*r - 12672*D1*Dd*f**2*g2*s**2 + 19008*D1*Dd*f**2*g2*s - 9504*D1*Dd*f**2*g2 + 31680*D1*Dd*f**2*gd2*r**2 + 63360*D1*Dd*f**2*gd2*r*s - 55440*D1*Dd*f**2*gd2*r + 31680*D1*Dd*f**2*gd2*s**2 - 55440*D1*Dd*f**2*gd2*s + 23760*D1*Dd*f**2*gd2 + 63360*D1*Dd*f*fd*g2*r**2 + 126720*D1*Dd*f*fd*g2*r*s - 79200*D1*Dd*f*fd*g2*r + 63360*D1*Dd*f*fd*g2*s**2 - 79200*D1*Dd*f*fd*g2*s + 23760*D1*Dd*f*fd*g2 + 10080*D1*Ddd*f**3*r**2 + 20160*D1*Ddd*f**3*r*s - 15120*D1*Ddd*f**3*r + 10080*D1*Ddd*f**3*s**2 - 15120*D1*Ddd*f**3*s + 7560*D1*Ddd*f**3 + 15840*D1*Ddd*f**2*g2*r**2 + 31680*D1*Ddd*f**2*g2*r*s - 23760*D1*Ddd*f**2*g2*r + 15840*D1*Ddd*f**2*g2*s**2 - 23760*D1*Ddd*f**2*g2*s + 11880*D1*Ddd*f**2*g2 - D1*bd1*(D1*(575*f**3*(r + s - 1) - 2*f**2*(924*C*(r + s - 1) + 700*fd*(3*r + 3*s - 2) + (792*K - 1221)*(r + s - 1)) + 132*f*(5*fd*(4*C + 6*K - 7)*(2*r + 2*s - 1) + (17*g2 - 24*gd2)*(r + s - 1)) - 3168*fd*g2*(r + s)) - 4*Dd*f*(350*f**2 - 165*f*(4*C + 6*K - 7) + 792*g2)*(4*r + 4*s - 3))*(r + s - 1) + 30240*Dd**2*f**3*r**2 + 60480*Dd**2*f**3*r*s - 45360*Dd**2*f**3*r + 30240*Dd**2*f**3*s**2 - 45360*Dd**2*f**3*s + 15120*Dd**2*f**3 + 47520*Dd**2*f**2*g2*r**2 + 95040*Dd**2*f**2*g2*r*s - 71280*Dd**2*f**2*g2*r + 47520*Dd**2*f**2*g2*s**2 - 71280*Dd**2*f**2*g2*s + 23760*Dd**2*f**2*g2 + 66*b1**2*(K - 1)*(D1**2*(17*fd - 12*fdd)*(r + s)**2 + D1*(Dd*(17*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 24*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(3696*C*D1**2*f*fd*r**2 + 7392*C*D1**2*f*fd*r*s - 3696*C*D1**2*f*fd*r + 3696*C*D1**2*f*fd*s**2 - 3696*C*D1**2*f*fd*s + 1848*C*D1**2*f*fd - 2640*C*D1**2*f*fdd*r**2 - 5280*C*D1**2*f*fdd*r*s + 2640*C*D1**2*f*fdd*r - 2640*C*D1**2*f*fdd*s**2 + 2640*C*D1**2*f*fdd*s - 1320*C*D1**2*f*fdd - 2640*C*D1**2*fd**2*r**2 - 5280*C*D1**2*fd**2*r*s + 2640*C*D1**2*fd**2*r - 2640*C*D1**2*fd**2*s**2 + 2640*C*D1**2*fd**2*s + 7392*C*D1*Dd*f**2*r**2 + 14784*C*D1*Dd*f**2*r*s - 11088*C*D1*Dd*f**2*r + 7392*C*D1*Dd*f**2*s**2 - 11088*C*D1*Dd*f**2*s + 5544*C*D1*Dd*f**2 - 21120*C*D1*Dd*f*fd*r**2 - 42240*C*D1*Dd*f*fd*r*s + 26400*C*D1*Dd*f*fd*r - 21120*C*D1*Dd*f*fd*s**2 + 26400*C*D1*Dd*f*fd*s - 7920*C*D1*Dd*f*fd - 5280*C*D1*Ddd*f**2*r**2 - 10560*C*D1*Ddd*f**2*r*s + 7920*C*D1*Ddd*f**2*r - 5280*C*D1*Ddd*f**2*s**2 + 7920*C*D1*Ddd*f**2*s - 3960*C*D1*Ddd*f**2 - 15840*C*Dd**2*f**2*r**2 - 31680*C*Dd**2*f**2*r*s + 23760*C*Dd**2*f**2*r - 15840*C*Dd**2*f**2*s**2 + 23760*C*Dd**2*f**2*s - 7920*C*Dd**2*f**2 + 3168*D1**2*K*f*fd*r**2 + 6336*D1**2*K*f*fd*r*s - 3168*D1**2*K*f*fd*r + 3168*D1**2*K*f*fd*s**2 - 3168*D1**2*K*f*fd*s + 1584*D1**2*K*f*fd - 3960*D1**2*K*f*fdd*r**2 - 7920*D1**2*K*f*fdd*r*s + 3960*D1**2*K*f*fdd*r - 3960*D1**2*K*f*fdd*s**2 + 3960*D1**2*K*f*fdd*s - 1980*D1**2*K*f*fdd - 3960*D1**2*K*fd**2*r**2 - 7920*D1**2*K*fd**2*r*s + 3960*D1**2*K*fd**2*r - 3960*D1**2*K*fd**2*s**2 + 3960*D1**2*K*fd**2*s - 1584*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 1725*D1**2*f**2*fd*r**2 - 3450*D1**2*f**2*fd*r*s + 2300*D1**2*f**2*fd*r - 1725*D1**2*f**2*fd*s**2 + 2300*D1**2*f**2*fd*s - 1150*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 4884*D1**2*f*fd*r**2 - 9768*D1**2*f*fd*r*s + 4884*D1**2*f*fd*r - 4884*D1**2*f*fd*s**2 + 4884*D1**2*f*fd*s - 2442*D1**2*f*fd + 4620*D1**2*f*fdd*r**2 + 9240*D1**2*f*fdd*r*s - 4620*D1**2*f*fdd*r + 4620*D1**2*f*fdd*s**2 - 4620*D1**2*f*fdd*s + 2310*D1**2*f*fdd - 2244*D1**2*f*gd2*r**2 - 4488*D1**2*f*gd2*r*s + 4488*D1**2*f*gd2*r - 2244*D1**2*f*gd2*s**2 + 4488*D1**2*f*gd2*s - 2244*D1**2*f*gd2 + 1584*D1**2*f*gdd2*r**2 + 3168*D1**2*f*gdd2*r*s - 3168*D1**2*f*gdd2*r + 1584*D1**2*f*gdd2*s**2 - 3168*D1**2*f*gdd2*s + 1584*D1**2*f*gdd2 + 4620*D1**2*fd**2*r**2 + 9240*D1**2*fd**2*r*s - 4620*D1**2*fd**2*r + 4620*D1**2*fd**2*s**2 - 4620*D1**2*fd**2*s - 2244*D1**2*fd*g2*r**2 - 4488*D1**2*fd*g2*r*s - 2244*D1**2*fd*g2*s**2 + 3168*D1**2*fd*gd2*r**2 + 6336*D1**2*fd*gd2*r*s - 3168*D1**2*fd*gd2*r + 3168*D1**2*fd*gd2*s**2 - 3168*D1**2*fd*gd2*s + 1584*D1**2*fdd*g2*r**2 + 3168*D1**2*fdd*g2*r*s + 1584*D1**2*fdd*g2*s**2 + 6336*D1*Dd*K*f**2*r**2 + 12672*D1*Dd*K*f**2*r*s - 9504*D1*Dd*K*f**2*r + 6336*D1*Dd*K*f**2*s**2 - 9504*D1*Dd*K*f**2*s + 4752*D1*Dd*K*f**2 - 31680*D1*Dd*K*f*fd*r**2 - 63360*D1*Dd*K*f*fd*r*s + 39600*D1*Dd*K*f*fd*r - 31680*D1*Dd*K*f*fd*s**2 + 39600*D1*Dd*K*f*fd*s - 11880*D1*Dd*K*f*fd - 2300*D1*Dd*f**3*r**2 - 4600*D1*Dd*f**3*r*s + 3450*D1*Dd*f**3*r - 2300*D1*Dd*f**3*s**2 + 3450*D1*Dd*f**3*s - 1725*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 23800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 23800*D1*Dd*f**2*fd*s + 8400*D1*Dd*f**2*fd - 9768*D1*Dd*f**2*r**2 - 19536*D1*Dd*f**2*r*s + 14652*D1*Dd*f**2*r - 9768*D1*Dd*f**2*s**2 + 14652*D1*Dd*f**2*s - 7326*D1*Dd*f**2 + 36960*D1*Dd*f*fd*r**2 + 73920*D1*Dd*f*fd*r*s - 46200*D1*Dd*f*fd*r + 36960*D1*Dd*f*fd*s**2 - 46200*D1*Dd*f*fd*s + 13860*D1*Dd*f*fd - 8976*D1*Dd*f*g2*r**2 - 17952*D1*Dd*f*g2*r*s + 13464*D1*Dd*f*g2*r - 8976*D1*Dd*f*g2*s**2 + 13464*D1*Dd*f*g2*s - 6732*D1*Dd*f*g2 + 12672*D1*Dd*f*gd2*r**2 + 25344*D1*Dd*f*gd2*r*s - 22176*D1*Dd*f*gd2*r + 12672*D1*Dd*f*gd2*s**2 - 22176*D1*Dd*f*gd2*s + 9504*D1*Dd*f*gd2 + 12672*D1*Dd*fd*g2*r**2 + 25344*D1*Dd*fd*g2*r*s - 9504*D1*Dd*fd*g2*r + 12672*D1*Dd*fd*g2*s**2 - 9504*D1*Dd*fd*g2*s - 7920*D1*Ddd*K*f**2*r**2 - 15840*D1*Ddd*K*f**2*r*s + 11880*D1*Ddd*K*f**2*r - 7920*D1*Ddd*K*f**2*s**2 + 11880*D1*Ddd*K*f**2*s - 5940*D1*Ddd*K*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 + 9240*D1*Ddd*f**2*r**2 + 18480*D1*Ddd*f**2*r*s - 13860*D1*Ddd*f**2*r + 9240*D1*Ddd*f**2*s**2 - 13860*D1*Ddd*f**2*s + 6930*D1*Ddd*f**2 + 6336*D1*Ddd*f*g2*r**2 + 12672*D1*Ddd*f*g2*r*s - 9504*D1*Ddd*f*g2*r + 6336*D1*Ddd*f*g2*s**2 - 9504*D1*Ddd*f*g2*s + 4752*D1*Ddd*f*g2 + 132*D1*bd1*(K - 1)*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) - 23760*Dd**2*K*f**2*r**2 - 47520*Dd**2*K*f**2*r*s + 35640*Dd**2*K*f**2*r - 23760*Dd**2*K*f**2*s**2 + 35640*Dd**2*K*f**2*s - 11880*Dd**2*K*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3 + 27720*Dd**2*f**2*r**2 + 55440*Dd**2*f**2*r*s - 41580*Dd**2*f**2*r + 27720*Dd**2*f**2*s**2 - 41580*Dd**2*f**2*s + 13860*Dd**2*f**2 + 19008*Dd**2*f*g2*r**2 + 38016*Dd**2*f*g2*r*s - 28512*Dd**2*f*g2*r + 19008*Dd**2*f*g2*s**2 - 28512*Dd**2*f*g2*s + 9504*Dd**2*f*g2))/(693*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**5*k1**3*k2*(264*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*bd1*(D1*(-5*f**3*(91*r**2 + 2*r*(91*s - 57) + 91*s**2 - 114*s + 57) + 2*f**2*(140*fd*(9*r**2 + r*(18*s - 13) + 9*s**2 - 13*s + 4) - 11*r**2*(8*C + 7) - 22*r*(s*(8*C + 7) - 15) - 11*s**2*(8*C + 7) + 330*s - 165) + 44*f*(5*fd*(r + s - 1)*(r*(4*C + 2) + s*(4*C + 2) - 3) - (r + s)*(-5*g2*(r + s) + 12*gd2*(r + s - 1))) - 528*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*Dd*f*(4*r + 4*s - 3)*(70*f**2*(3*r + 3*s - 2) + 55*f*(2*C*r + 2*C*s + r + s - 3) - 132*g2*(r + s))) - 22*b1**2*(K - 1)*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-352*C*D1**2*f*fd*r**2 - 704*C*D1**2*f*fd*r*s + 704*C*D1**2*f*fd*r - 352*C*D1**2*f*fd*s**2 + 704*C*D1**2*f*fd*s - 352*C*D1**2*f*fd + 440*C*D1**2*f*fdd*r**2 + 880*C*D1**2*f*fdd*r*s - 880*C*D1**2*f*fdd*r + 440*C*D1**2*f*fdd*s**2 - 880*C*D1**2*f*fdd*s + 440*C*D1**2*f*fdd + 440*C*D1**2*fd**2*r**2 + 880*C*D1**2*fd**2*r*s - 880*C*D1**2*fd**2*r + 440*C*D1**2*fd**2*s**2 - 880*C*D1**2*fd**2*s + 440*C*D1**2*fd**2 - 704*C*D1*Dd*f**2*r**2 - 1408*C*D1*Dd*f**2*r*s + 1056*C*D1*Dd*f**2*r - 704*C*D1*Dd*f**2*s**2 + 1056*C*D1*Dd*f**2*s - 528*C*D1*Dd*f**2 + 3520*C*D1*Dd*f*fd*r**2 + 7040*C*D1*Dd*f*fd*r*s - 6160*C*D1*Dd*f*fd*r + 3520*C*D1*Dd*f*fd*s**2 - 6160*C*D1*Dd*f*fd*s + 2640*C*D1*Dd*f*fd + 880*C*D1*Ddd*f**2*r**2 + 1760*C*D1*Ddd*f**2*r*s - 1320*C*D1*Ddd*f**2*r + 880*C*D1*Ddd*f**2*s**2 - 1320*C*D1*Ddd*f**2*s + 660*C*D1*Ddd*f**2 + 2640*C*Dd**2*f**2*r**2 + 5280*C*Dd**2*f**2*r*s - 3960*C*Dd**2*f**2*r + 2640*C*Dd**2*f**2*s**2 - 3960*C*Dd**2*f**2*s + 1320*C*Dd**2*f**2 + 132*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 1365*D1**2*f**2*fd*r**2 - 2730*D1**2*f**2*fd*r*s + 2160*D1**2*f**2*fd*r - 1365*D1**2*f**2*fd*s**2 + 2160*D1**2*f**2*fd*s - 1080*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r**2 + 2520*D1**2*f**2*fdd*r*s - 1960*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1960*D1**2*f**2*fdd*s + 980*D1**2*f**2*fdd + 2520*D1**2*f*fd**2*r**2 + 5040*D1**2*f*fd**2*r*s - 3920*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 3920*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 - 308*D1**2*f*fd*r**2 - 616*D1**2*f*fd*r*s - 44*D1**2*f*fd*r - 308*D1**2*f*fd*s**2 - 44*D1**2*f*fd*s + 22*D1**2*f*fd + 220*D1**2*f*fdd*r**2 + 440*D1**2*f*fdd*r*s + 220*D1**2*f*fdd*r + 220*D1**2*f*fdd*s**2 + 220*D1**2*f*fdd*s - 110*D1**2*f*fdd + 220*D1**2*f*gd2*r**2 + 440*D1**2*f*gd2*r*s - 440*D1**2*f*gd2*r + 220*D1**2*f*gd2*s**2 - 440*D1**2*f*gd2*s + 220*D1**2*f*gd2 - 264*D1**2*f*gdd2*r**2 - 528*D1**2*f*gdd2*r*s + 528*D1**2*f*gdd2*r - 264*D1**2*f*gdd2*s**2 + 528*D1**2*f*gdd2*s - 264*D1**2*f*gdd2 + 220*D1**2*fd**2*r**2 + 440*D1**2*fd**2*r*s + 220*D1**2*fd**2*r + 220*D1**2*fd**2*s**2 + 220*D1**2*fd**2*s - 440*D1**2*fd**2 + 220*D1**2*fd*g2*r**2 + 440*D1**2*fd*g2*r*s - 440*D1**2*fd*g2*r + 220*D1**2*fd*g2*s**2 - 440*D1**2*fd*g2*s + 220*D1**2*fd*g2 - 528*D1**2*fd*gd2*r**2 - 1056*D1**2*fd*gd2*r*s + 1056*D1**2*fd*gd2*r - 528*D1**2*fd*gd2*s**2 + 1056*D1**2*fd*gd2*s - 528*D1**2*fd*gd2 - 264*D1**2*fdd*g2*r**2 - 528*D1**2*fdd*g2*r*s + 528*D1**2*fdd*g2*r - 264*D1**2*fdd*g2*s**2 + 528*D1**2*fdd*g2*s - 264*D1**2*fdd*g2 - 1820*D1*Dd*f**3*r**2 - 3640*D1*Dd*f**3*r*s + 2730*D1*Dd*f**3*r - 1820*D1*Dd*f**3*s**2 + 2730*D1*Dd*f**3*s - 1365*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r**2 + 20160*D1*Dd*f**2*fd*r*s - 15400*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 15400*D1*Dd*f**2*fd*s + 5880*D1*Dd*f**2*fd - 616*D1*Dd*f**2*r**2 - 1232*D1*Dd*f**2*r*s + 924*D1*Dd*f**2*r - 616*D1*Dd*f**2*s**2 + 924*D1*Dd*f**2*s - 462*D1*Dd*f**2 + 1760*D1*Dd*f*fd*r**2 + 3520*D1*Dd*f*fd*r*s - 440*D1*Dd*f*fd*r + 1760*D1*Dd*f*fd*s**2 - 440*D1*Dd*f*fd*s - 660*D1*Dd*f*fd + 880*D1*Dd*f*g2*r**2 + 1760*D1*Dd*f*g2*r*s - 1320*D1*Dd*f*g2*r + 880*D1*Dd*f*g2*s**2 - 1320*D1*Dd*f*g2*s + 660*D1*Dd*f*g2 - 2112*D1*Dd*f*gd2*r**2 - 4224*D1*Dd*f*gd2*r*s + 3696*D1*Dd*f*gd2*r - 2112*D1*Dd*f*gd2*s**2 + 3696*D1*Dd*f*gd2*s - 1584*D1*Dd*f*gd2 - 2112*D1*Dd*fd*g2*r**2 - 4224*D1*Dd*fd*g2*r*s + 3696*D1*Dd*fd*g2*r - 2112*D1*Dd*fd*g2*s**2 + 3696*D1*Dd*fd*g2*s - 1584*D1*Dd*fd*g2 + 1680*D1*Ddd*f**3*r**2 + 3360*D1*Ddd*f**3*r*s - 2520*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 2520*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 440*D1*Ddd*f**2*r**2 + 880*D1*Ddd*f**2*r*s - 660*D1*Ddd*f**2*r + 440*D1*Ddd*f**2*s**2 - 660*D1*Ddd*f**2*s + 330*D1*Ddd*f**2 - 1056*D1*Ddd*f*g2*r**2 - 2112*D1*Ddd*f*g2*r*s + 1584*D1*Ddd*f*g2*r - 1056*D1*Ddd*f*g2*s**2 + 1584*D1*Ddd*f*g2*s - 792*D1*Ddd*f*g2 - 22*D1*bd1*(K - 1)*(D1*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 12*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 5040*Dd**2*f**3*r**2 + 10080*Dd**2*f**3*r*s - 7560*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 7560*Dd**2*f**3*s + 2520*Dd**2*f**3 + 1320*Dd**2*f**2*r**2 + 2640*Dd**2*f**2*r*s - 1980*Dd**2*f**2*r + 1320*Dd**2*f**2*s**2 - 1980*Dd**2*f**2*s + 660*Dd**2*f**2 - 3168*Dd**2*f*g2*r**2 - 6336*Dd**2*f*g2*r*s + 4752*Dd**2*f*g2*r - 3168*Dd**2*f*g2*s**2 + 4752*Dd**2*f*g2*s - 1584*Dd**2*f*g2) + f*(2*D1**2*bdd1*(70*f**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 55*f*(2*C*s**2 + r**2*(2*C + 1) + 2*r*(2*C*s + s - 3) + s**2 - 6*s + 3) - 132*g2*(r + s)**2) - 5*D1**2*(f*(57*fd - 56*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 112*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 5*D1*f*(Dd*(57*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 112*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 56*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 1680*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**4) + 5*D1**2*Pk2*Pkdd3*ct**5*k1*k2**5*st**2*(-600*C*D1**2*f**2*fd*r**2 - 1200*C*D1**2*f**2*fd*r*s + 800*C*D1**2*f**2*fd*r - 600*C*D1**2*f**2*fd*s**2 + 800*C*D1**2*f**2*fd*s - 400*C*D1**2*f**2*fd + 300*C*D1**2*f**2*fdd*r**2 + 600*C*D1**2*f**2*fdd*r*s - 400*C*D1**2*f**2*fdd*r + 300*C*D1**2*f**2*fdd*s**2 - 400*C*D1**2*f**2*fdd*s + 200*C*D1**2*f**2*fdd + 600*C*D1**2*f*fd**2*r**2 + 1200*C*D1**2*f*fd**2*r*s - 800*C*D1**2*f*fd**2*r + 600*C*D1**2*f*fd**2*s**2 - 800*C*D1**2*f*fd**2*s + 200*C*D1**2*f*fd**2 - 800*C*D1*Dd*f**3*r**2 - 1600*C*D1*Dd*f**3*r*s + 1200*C*D1*Dd*f**3*r - 800*C*D1*Dd*f**3*s**2 + 1200*C*D1*Dd*f**3*s - 600*C*D1*Dd*f**3 + 2400*C*D1*Dd*f**2*fd*r**2 + 4800*C*D1*Dd*f**2*fd*r*s - 3400*C*D1*Dd*f**2*fd*r + 2400*C*D1*Dd*f**2*fd*s**2 - 3400*C*D1*Dd*f**2*fd*s + 1200*C*D1*Dd*f**2*fd + 400*C*D1*Ddd*f**3*r**2 + 800*C*D1*Ddd*f**3*r*s - 600*C*D1*Ddd*f**3*r + 400*C*D1*Ddd*f**3*s**2 - 600*C*D1*Ddd*f**3*s + 300*C*D1*Ddd*f**3 + 1200*C*Dd**2*f**3*r**2 + 2400*C*Dd**2*f**3*r*s - 1800*C*Dd**2*f**3*r + 1200*C*Dd**2*f**3*s**2 - 1800*C*Dd**2*f**3*s + 600*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r**2 - 528*D1**2*K*b1*f*fd*r*s + 264*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 132*D1**2*K*b1*f*fdd*s**2 - 132*D1**2*K*b1*f*fdd*s + 66*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 132*D1**2*K*b1*fd**2*s**2 - 132*D1**2*K*b1*fd**2*s + 210*D1**2*b1*f**2*fd*r**2 + 420*D1**2*b1*f**2*fd*r*s - 280*D1**2*b1*f**2*fd*r + 210*D1**2*b1*f**2*fd*s**2 - 280*D1**2*b1*f**2*fd*s + 140*D1**2*b1*f**2*fd - 105*D1**2*b1*f**2*fdd*r**2 - 210*D1**2*b1*f**2*fdd*r*s + 140*D1**2*b1*f**2*fdd*r - 105*D1**2*b1*f**2*fdd*s**2 + 140*D1**2*b1*f**2*fdd*s - 70*D1**2*b1*f**2*fdd - 210*D1**2*b1*f*fd**2*r**2 - 420*D1**2*b1*f*fd**2*r*s + 280*D1**2*b1*f*fd**2*r - 210*D1**2*b1*f*fd**2*s**2 + 280*D1**2*b1*f*fd**2*s - 70*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-66*K + 35*f + 33)*(r + s - 1)**2 + 450*D1**2*f**2*fd*r**2 + 900*D1**2*f**2*fd*r*s - 600*D1**2*f**2*fd*r + 450*D1**2*f**2*fd*s**2 - 600*D1**2*f**2*fd*s + 300*D1**2*f**2*fd - 225*D1**2*f**2*fdd*r**2 - 450*D1**2*f**2*fdd*r*s + 300*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 300*D1**2*f**2*fdd*s - 150*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 450*D1**2*f*fd**2*r**2 - 900*D1**2*f*fd**2*r*s + 600*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 600*D1**2*f*fd**2*s - 150*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 - 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 792*D1*Dd*K*b1*f**2*s - 396*D1*Dd*K*b1*f**2 + 1056*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1320*D1*Dd*K*b1*f*fd*r + 1056*D1*Dd*K*b1*f*fd*s**2 - 1320*D1*Dd*K*b1*f*fd*s + 396*D1*Dd*K*b1*f*fd + 280*D1*Dd*b1*f**3*r**2 + 560*D1*Dd*b1*f**3*r*s - 420*D1*Dd*b1*f**3*r + 280*D1*Dd*b1*f**3*s**2 - 420*D1*Dd*b1*f**3*s + 210*D1*Dd*b1*f**3 - 840*D1*Dd*b1*f**2*fd*r**2 - 1680*D1*Dd*b1*f**2*fd*r*s + 1190*D1*Dd*b1*f**2*fd*r - 840*D1*Dd*b1*f**2*fd*s**2 + 1190*D1*Dd*b1*f**2*fd*s - 420*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 600*D1*Dd*f**3*r**2 + 1200*D1*Dd*f**3*r*s - 900*D1*Dd*f**3*r + 600*D1*Dd*f**3*s**2 - 900*D1*Dd*f**3*s + 450*D1*Dd*f**3 - 1800*D1*Dd*f**2*fd*r**2 - 3600*D1*Dd*f**2*fd*r*s + 2550*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 2550*D1*Dd*f**2*fd*s - 900*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r + 264*D1*Ddd*K*b1*f**2*s**2 - 396*D1*Ddd*K*b1*f**2*s + 198*D1*Ddd*K*b1*f**2 - 140*D1*Ddd*b1*f**3*r**2 - 280*D1*Ddd*b1*f**3*r*s + 210*D1*Ddd*b1*f**3*r - 140*D1*Ddd*b1*f**3*s**2 + 210*D1*Ddd*b1*f**3*s - 105*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 300*D1*Ddd*f**3*r**2 - 600*D1*Ddd*f**3*r*s + 450*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 450*D1*Ddd*f**3*s - 225*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(35*f**2*(r + s - 1) - 35*f*fd*(3*r + 3*s - 2) - 33*f*(2*K - 1)*(r + s - 1) + 33*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-66*K + 35*f + 33)*(4*r + 4*s - 3))*(r + s - 1) + 792*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r + 792*Dd**2*K*b1*f**2*s**2 - 1188*Dd**2*K*b1*f**2*s + 396*Dd**2*K*b1*f**2 - 420*Dd**2*b1*f**3*r**2 - 840*Dd**2*b1*f**3*r*s + 630*Dd**2*b1*f**3*r - 420*Dd**2*b1*f**3*s**2 + 630*Dd**2*b1*f**3*s - 210*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 900*Dd**2*f**3*r**2 - 1800*Dd**2*f**3*r*s + 1350*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 1350*Dd**2*f**3*s - 450*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2)/(462*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**5*k1*k2**5*(660*C*D1**2*bdd1*f**2*r**2 + 1320*C*D1**2*bdd1*f**2*r*s - 1320*C*D1**2*bdd1*f**2*r + 660*C*D1**2*bdd1*f**2*s**2 - 1320*C*D1**2*bdd1*f**2*s + 660*C*D1**2*bdd1*f**2 - 2760*C*D1**2*f**2*fd*r**2 - 5520*C*D1**2*f**2*fd*r*s + 3680*C*D1**2*f**2*fd*r - 2760*C*D1**2*f**2*fd*s**2 + 3680*C*D1**2*f**2*fd*s - 1840*C*D1**2*f**2*fd + 3360*C*D1**2*f**2*fdd*r**2 + 6720*C*D1**2*f**2*fdd*r*s - 4480*C*D1**2*f**2*fdd*r + 3360*C*D1**2*f**2*fdd*s**2 - 4480*C*D1**2*f**2*fdd*s + 2240*C*D1**2*f**2*fdd + 6720*C*D1**2*f*fd**2*r**2 + 13440*C*D1**2*f*fd**2*r*s - 8960*C*D1**2*f*fd**2*r + 6720*C*D1**2*f*fd**2*s**2 - 8960*C*D1**2*f*fd**2*s + 2240*C*D1**2*f*fd**2 - 3680*C*D1*Dd*f**3*r**2 - 7360*C*D1*Dd*f**3*r*s + 5520*C*D1*Dd*f**3*r - 3680*C*D1*Dd*f**3*s**2 + 5520*C*D1*Dd*f**3*s - 2760*C*D1*Dd*f**3 + 26880*C*D1*Dd*f**2*fd*r**2 + 53760*C*D1*Dd*f**2*fd*r*s - 38080*C*D1*Dd*f**2*fd*r + 26880*C*D1*Dd*f**2*fd*s**2 - 38080*C*D1*Dd*f**2*fd*s + 13440*C*D1*Dd*f**2*fd + 4480*C*D1*Ddd*f**3*r**2 + 8960*C*D1*Ddd*f**3*r*s - 6720*C*D1*Ddd*f**3*r + 4480*C*D1*Ddd*f**3*s**2 - 6720*C*D1*Ddd*f**3*s + 3360*C*D1*Ddd*f**3 + 13440*C*Dd**2*f**3*r**2 + 26880*C*Dd**2*f**3*r*s - 20160*C*Dd**2*f**3*r + 13440*C*Dd**2*f**3*s**2 - 20160*C*Dd**2*f**3*s + 6720*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r**2 + 1320*D1**2*K*bdd1*f**2*r*s - 1320*D1**2*K*bdd1*f**2*r + 660*D1**2*K*bdd1*f**2*s**2 - 1320*D1**2*K*bdd1*f**2*s + 660*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(-12*K + 5*f + 6)*(r + s - 1)**2 - 495*D1**2*bdd1*f**2*r**2 - 990*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*r - 495*D1**2*bdd1*f**2*s**2 + 990*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r**2 - 1584*D1**2*bdd1*f*g2*r*s + 1584*D1**2*bdd1*f*g2*r - 792*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 + 885*D1**2*f**2*fd*r**2 + 1770*D1**2*f**2*fd*r*s - 1180*D1**2*f**2*fd*r + 885*D1**2*f**2*fd*s**2 - 1180*D1**2*f**2*fd*s + 590*D1**2*f**2*fd - 1680*D1**2*f**2*fdd*r**2 - 3360*D1**2*f**2*fdd*r*s + 2240*D1**2*f**2*fdd*r - 1680*D1**2*f**2*fdd*s**2 + 2240*D1**2*f**2*fdd*s - 1120*D1**2*f**2*fdd + 1056*D1**2*f**2*gd2*r**2 + 2112*D1**2*f**2*gd2*r*s - 2112*D1**2*f**2*gd2*r + 1056*D1**2*f**2*gd2*s**2 - 2112*D1**2*f**2*gd2*s + 1056*D1**2*f**2*gd2 - 1320*D1**2*f**2*gdd2*r**2 - 2640*D1**2*f**2*gdd2*r*s + 2640*D1**2*f**2*gdd2*r - 1320*D1**2*f**2*gdd2*s**2 + 2640*D1**2*f**2*gdd2*s - 1320*D1**2*f**2*gdd2 - 3360*D1**2*f*fd**2*r**2 - 6720*D1**2*f*fd**2*r*s + 4480*D1**2*f*fd**2*r - 3360*D1**2*f*fd**2*s**2 + 4480*D1**2*f*fd**2*s - 1120*D1**2*f*fd**2 + 2112*D1**2*f*fd*g2*r**2 + 4224*D1**2*f*fd*g2*r*s - 2112*D1**2*f*fd*g2*r + 2112*D1**2*f*fd*g2*s**2 - 2112*D1**2*f*fd*g2*s + 1056*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r**2 - 10560*D1**2*f*fd*gd2*r*s + 7920*D1**2*f*fd*gd2*r - 5280*D1**2*f*fd*gd2*s**2 + 7920*D1**2*f*fd*gd2*s - 2640*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r**2 - 5280*D1**2*f*fdd*g2*r*s + 2640*D1**2*f*fdd*g2*r - 2640*D1**2*f*fdd*g2*s**2 + 2640*D1**2*f*fdd*g2*s - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r**2 - 5280*D1**2*fd**2*g2*r*s + 2640*D1**2*fd**2*g2*r - 2640*D1**2*fd**2*g2*s**2 + 2640*D1**2*fd**2*g2*s + 1180*D1*Dd*f**3*r**2 + 2360*D1*Dd*f**3*r*s - 1770*D1*Dd*f**3*r + 1180*D1*Dd*f**3*s**2 - 1770*D1*Dd*f**3*s + 885*D1*Dd*f**3 - 13440*D1*Dd*f**2*fd*r**2 - 26880*D1*Dd*f**2*fd*r*s + 19040*D1*Dd*f**2*fd*r - 13440*D1*Dd*f**2*fd*s**2 + 19040*D1*Dd*f**2*fd*s - 6720*D1*Dd*f**2*fd + 4224*D1*Dd*f**2*g2*r**2 + 8448*D1*Dd*f**2*g2*r*s - 6336*D1*Dd*f**2*g2*r + 4224*D1*Dd*f**2*g2*s**2 - 6336*D1*Dd*f**2*g2*s + 3168*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r**2 - 21120*D1*Dd*f**2*gd2*r*s + 18480*D1*Dd*f**2*gd2*r - 10560*D1*Dd*f**2*gd2*s**2 + 18480*D1*Dd*f**2*gd2*s - 7920*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r**2 - 42240*D1*Dd*f*fd*g2*r*s + 26400*D1*Dd*f*fd*g2*r - 21120*D1*Dd*f*fd*g2*s**2 + 26400*D1*Dd*f*fd*g2*s - 7920*D1*Dd*f*fd*g2 - 2240*D1*Ddd*f**3*r**2 - 4480*D1*Ddd*f**3*r*s + 3360*D1*Ddd*f**3*r - 2240*D1*Ddd*f**3*s**2 + 3360*D1*Ddd*f**3*s - 1680*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r**2 - 10560*D1*Ddd*f**2*g2*r*s + 7920*D1*Ddd*f**2*g2*r - 5280*D1*Ddd*f**2*g2*s**2 + 7920*D1*Ddd*f**2*g2*s - 3960*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(r + s - 1) + 8*f**2*(5*C + 2*K - 3)*(r + s - 1) - 10*f*fd*(4*C + 4*K - 3)*(2*r + 2*s - 1) - 48*f*(g2 - gd2)*(r + s - 1) + 48*fd*g2*(r + s)) - 2*Dd*f*(5*f*(4*C + 4*K - 3) - 24*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6720*Dd**2*f**3*r**2 - 13440*Dd**2*f**3*r*s + 10080*Dd**2*f**3*r - 6720*Dd**2*f**3*s**2 + 10080*Dd**2*f**3*s - 3360*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r**2 - 31680*Dd**2*f**2*g2*r*s + 23760*Dd**2*f**2*g2*r - 15840*Dd**2*f**2*g2*s**2 + 23760*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-2*r - 2*s)*(5*fd**2*(r + s - 1) + 6*fd*(2*K - 1)*(r + s) - 3*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (12*K - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-12*K + 5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-12*K + 5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-80*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s + 80*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 80*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 240*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 240*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 400*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 32*D1**2*K*f*fd*r**2 - 64*D1**2*K*f*fd*r*s + 32*D1**2*K*f*fd*r - 32*D1**2*K*f*fd*s**2 + 32*D1**2*K*f*fd*s - 16*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-12*K + 5*f + 6)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 48*D1**2*f*fd*r**2 + 96*D1**2*f*fd*r*s - 48*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 48*D1**2*f*fd*s + 24*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 48*D1**2*f*gd2*r**2 + 96*D1**2*f*gd2*r*s - 96*D1**2*f*gd2*r + 48*D1**2*f*gd2*s**2 - 96*D1**2*f*gd2*s + 48*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 48*D1**2*fd*g2*r**2 + 96*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 - 64*D1*Dd*K*f**2*r**2 - 128*D1*Dd*K*f**2*r*s + 96*D1*Dd*K*f**2*r - 64*D1*Dd*K*f**2*s**2 + 96*D1*Dd*K*f**2*s - 48*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 96*D1*Dd*f**2*r**2 + 192*D1*Dd*f**2*r*s - 144*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 144*D1*Dd*f**2*s + 72*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 192*D1*Dd*f*g2*r**2 + 384*D1*Dd*f*g2*r*s - 288*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 288*D1*Dd*f*g2*s + 144*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 144*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 6*f*(2*K - 1)*(r + s - 1) + 6*fd*(2*K - 1)*(r + s)) - Dd*f*(-12*K + 5*f + 6)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(693*d**2*k3**6) - 5*D1**2*Pk2*Pkdd3*ct**5*k1*k2**3*st**2*(210*D1**2*b1*f**2*fd*r**2 + 420*D1**2*b1*f**2*fd*r*s - 280*D1**2*b1*f**2*fd*r + 210*D1**2*b1*f**2*fd*s**2 - 280*D1**2*b1*f**2*fd*s + 140*D1**2*b1*f**2*fd - 105*D1**2*b1*f**2*fdd*r**2 - 210*D1**2*b1*f**2*fdd*r*s + 140*D1**2*b1*f**2*fdd*r - 105*D1**2*b1*f**2*fdd*s**2 + 140*D1**2*b1*f**2*fdd*s - 70*D1**2*b1*f**2*fdd - 210*D1**2*b1*f*fd**2*r**2 - 420*D1**2*b1*f*fd**2*r*s + 280*D1**2*b1*f*fd**2*r - 210*D1**2*b1*f*fd**2*s**2 + 280*D1**2*b1*f*fd**2*s - 70*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(35*f + 33)*(r + s - 1)**2 + 150*D1**2*f**2*fd*r**2 + 300*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 150*D1**2*f**2*fd*s**2 - 200*D1**2*f**2*fd*s + 100*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 280*D1*Dd*b1*f**3*r**2 + 560*D1*Dd*b1*f**3*r*s - 420*D1*Dd*b1*f**3*r + 280*D1*Dd*b1*f**3*s**2 - 420*D1*Dd*b1*f**3*s + 210*D1*Dd*b1*f**3 - 840*D1*Dd*b1*f**2*fd*r**2 - 1680*D1*Dd*b1*f**2*fd*r*s + 1190*D1*Dd*b1*f**2*fd*r - 840*D1*Dd*b1*f**2*fd*s**2 + 1190*D1*Dd*b1*f**2*fd*s - 420*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 200*D1*Dd*f**3*r**2 + 400*D1*Dd*f**3*r*s - 300*D1*Dd*f**3*r + 200*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 150*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd - 140*D1*Ddd*b1*f**3*r**2 - 280*D1*Ddd*b1*f**3*r*s + 210*D1*Ddd*b1*f**3*r - 140*D1*Ddd*b1*f**3*s**2 + 210*D1*Ddd*b1*f**3*s - 105*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 + 2*D1*bd1*f*(D1*(35*f**2*(r + s - 1) - 35*f*fd*(3*r + 3*s - 2) + 33*f*(r + s - 1) - 33*fd*(2*r + 2*s - 1)) - Dd*f*(35*f + 33)*(4*r + 4*s - 3))*(r + s - 1) - 420*Dd**2*b1*f**3*r**2 - 840*Dd**2*b1*f**3*r*s + 630*Dd**2*b1*f**3*r - 420*Dd**2*b1*f**3*s**2 + 630*Dd**2*b1*f**3*s - 210*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3)/(462*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**5*k1*k2**3*(-660*C*D1**2*bdd1*f**2*r**2 - 1320*C*D1**2*bdd1*f**2*r*s - 660*C*D1**2*bdd1*f**2*s**2 - 4740*C*D1**2*f**2*fd*r**2 - 9480*C*D1**2*f**2*fd*r*s + 6320*C*D1**2*f**2*fd*r - 4740*C*D1**2*f**2*fd*s**2 + 6320*C*D1**2*f**2*fd*s - 3160*C*D1**2*f**2*fd + 3360*C*D1**2*f**2*fdd*r**2 + 6720*C*D1**2*f**2*fdd*r*s - 4480*C*D1**2*f**2*fdd*r + 3360*C*D1**2*f**2*fdd*s**2 - 4480*C*D1**2*f**2*fdd*s + 2240*C*D1**2*f**2*fdd + 6720*C*D1**2*f*fd**2*r**2 + 13440*C*D1**2*f*fd**2*r*s - 8960*C*D1**2*f*fd**2*r + 6720*C*D1**2*f*fd**2*s**2 - 8960*C*D1**2*f*fd**2*s + 2240*C*D1**2*f*fd**2 - 6320*C*D1*Dd*f**3*r**2 - 12640*C*D1*Dd*f**3*r*s + 9480*C*D1*Dd*f**3*r - 6320*C*D1*Dd*f**3*s**2 + 9480*C*D1*Dd*f**3*s - 4740*C*D1*Dd*f**3 + 26880*C*D1*Dd*f**2*fd*r**2 + 53760*C*D1*Dd*f**2*fd*r*s - 38080*C*D1*Dd*f**2*fd*r + 26880*C*D1*Dd*f**2*fd*s**2 - 38080*C*D1*Dd*f**2*fd*s + 13440*C*D1*Dd*f**2*fd + 4480*C*D1*Ddd*f**3*r**2 + 8960*C*D1*Ddd*f**3*r*s - 6720*C*D1*Ddd*f**3*r + 4480*C*D1*Ddd*f**3*s**2 - 6720*C*D1*Ddd*f**3*s + 3360*C*D1*Ddd*f**3 + 13440*C*Dd**2*f**3*r**2 + 26880*C*Dd**2*f**3*r*s - 20160*C*Dd**2*f**3*r + 13440*C*Dd**2*f**3*s**2 - 20160*C*Dd**2*f**3*s + 6720*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r**2 + 1320*D1**2*K*bdd1*f**2*r*s - 1320*D1**2*K*bdd1*f**2*r + 660*D1**2*K*bdd1*f**2*s**2 - 1320*D1**2*K*bdd1*f**2*s + 660*D1**2*K*bdd1*f**2 - 1848*D1**2*b2*f*fd*r**2 - 3696*D1**2*b2*f*fd*r*s + 1848*D1**2*b2*f*fd*r - 1848*D1**2*b2*f*fd*s**2 + 1848*D1**2*b2*f*fd*s - 924*D1**2*b2*f*fd + 1320*D1**2*b2*f*fdd*r**2 + 2640*D1**2*b2*f*fdd*r*s - 1320*D1**2*b2*f*fdd*r + 1320*D1**2*b2*f*fdd*s**2 - 1320*D1**2*b2*f*fdd*s + 660*D1**2*b2*f*fdd + 1320*D1**2*b2*fd**2*r**2 + 2640*D1**2*b2*fd**2*r*s - 1320*D1**2*b2*fd**2*r + 1320*D1**2*b2*fd**2*s**2 - 1320*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*f*(r + s - 1)*(-12*K*(r + s) + 5*f + 6) - 924*D1**2*bd2*f**2*r**2 - 1848*D1**2*bd2*f**2*r*s + 1848*D1**2*bd2*f**2*r - 924*D1**2*bd2*f**2*s**2 + 1848*D1**2*bd2*f**2*s - 924*D1**2*bd2*f**2 + 2640*D1**2*bd2*f*fd*r**2 + 5280*D1**2*bd2*f*fd*r*s - 3960*D1**2*bd2*f*fd*r + 2640*D1**2*bd2*f*fd*s**2 - 3960*D1**2*bd2*f*fd*s + 1320*D1**2*bd2*f*fd + 330*D1**2*bdd1*f**2*r**2 + 660*D1**2*bdd1*f**2*r*s + 330*D1**2*bdd1*f**2*r + 330*D1**2*bdd1*f**2*s**2 + 330*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 + 792*D1**2*bdd1*f*g2*r**2 + 1584*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*s**2 + 660*D1**2*bdd2*f**2*r**2 + 1320*D1**2*bdd2*f**2*r*s - 1320*D1**2*bdd2*f**2*r + 660*D1**2*bdd2*f**2*s**2 - 1320*D1**2*bdd2*f**2*s + 660*D1**2*bdd2*f**2 + 1875*D1**2*f**2*fd*r**2 + 3750*D1**2*f**2*fd*r*s - 2500*D1**2*f**2*fd*r + 1875*D1**2*f**2*fd*s**2 - 2500*D1**2*f**2*fd*s + 1250*D1**2*f**2*fd - 1680*D1**2*f**2*fdd*r**2 - 3360*D1**2*f**2*fdd*r*s + 2240*D1**2*f**2*fdd*r - 1680*D1**2*f**2*fdd*s**2 + 2240*D1**2*f**2*fdd*s - 1120*D1**2*f**2*fdd + 1848*D1**2*f**2*gd2*r**2 + 3696*D1**2*f**2*gd2*r*s - 3696*D1**2*f**2*gd2*r + 1848*D1**2*f**2*gd2*s**2 - 3696*D1**2*f**2*gd2*s + 1848*D1**2*f**2*gd2 - 1320*D1**2*f**2*gdd2*r**2 - 2640*D1**2*f**2*gdd2*r*s + 2640*D1**2*f**2*gdd2*r - 1320*D1**2*f**2*gdd2*s**2 + 2640*D1**2*f**2*gdd2*s - 1320*D1**2*f**2*gdd2 - 3360*D1**2*f*fd**2*r**2 - 6720*D1**2*f*fd**2*r*s + 4480*D1**2*f*fd**2*r - 3360*D1**2*f*fd**2*s**2 + 4480*D1**2*f*fd**2*s - 1120*D1**2*f*fd**2 + 3696*D1**2*f*fd*g2*r**2 + 7392*D1**2*f*fd*g2*r*s - 3696*D1**2*f*fd*g2*r + 3696*D1**2*f*fd*g2*s**2 - 3696*D1**2*f*fd*g2*s + 1848*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r**2 - 10560*D1**2*f*fd*gd2*r*s + 7920*D1**2*f*fd*gd2*r - 5280*D1**2*f*fd*gd2*s**2 + 7920*D1**2*f*fd*gd2*s - 2640*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r**2 - 5280*D1**2*f*fdd*g2*r*s + 2640*D1**2*f*fdd*g2*r - 2640*D1**2*f*fdd*g2*s**2 + 2640*D1**2*f*fdd*g2*s - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r**2 - 5280*D1**2*fd**2*g2*r*s + 2640*D1**2*fd**2*g2*r - 2640*D1**2*fd**2*g2*s**2 + 2640*D1**2*fd**2*g2*s - 3696*D1*Dd*b2*f**2*r**2 - 7392*D1*Dd*b2*f**2*r*s + 5544*D1*Dd*b2*f**2*r - 3696*D1*Dd*b2*f**2*s**2 + 5544*D1*Dd*b2*f**2*s - 2772*D1*Dd*b2*f**2 + 10560*D1*Dd*b2*f*fd*r**2 + 21120*D1*Dd*b2*f*fd*r*s - 13200*D1*Dd*b2*f*fd*r + 10560*D1*Dd*b2*f*fd*s**2 - 13200*D1*Dd*b2*f*fd*s + 3960*D1*Dd*b2*f*fd + 5280*D1*Dd*bd2*f**2*r**2 + 10560*D1*Dd*bd2*f**2*r*s - 9240*D1*Dd*bd2*f**2*r + 5280*D1*Dd*bd2*f**2*s**2 - 9240*D1*Dd*bd2*f**2*s + 3960*D1*Dd*bd2*f**2 + 2500*D1*Dd*f**3*r**2 + 5000*D1*Dd*f**3*r*s - 3750*D1*Dd*f**3*r + 2500*D1*Dd*f**3*s**2 - 3750*D1*Dd*f**3*s + 1875*D1*Dd*f**3 - 13440*D1*Dd*f**2*fd*r**2 - 26880*D1*Dd*f**2*fd*r*s + 19040*D1*Dd*f**2*fd*r - 13440*D1*Dd*f**2*fd*s**2 + 19040*D1*Dd*f**2*fd*s - 6720*D1*Dd*f**2*fd + 7392*D1*Dd*f**2*g2*r**2 + 14784*D1*Dd*f**2*g2*r*s - 11088*D1*Dd*f**2*g2*r + 7392*D1*Dd*f**2*g2*s**2 - 11088*D1*Dd*f**2*g2*s + 5544*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r**2 - 21120*D1*Dd*f**2*gd2*r*s + 18480*D1*Dd*f**2*gd2*r - 10560*D1*Dd*f**2*gd2*s**2 + 18480*D1*Dd*f**2*gd2*s - 7920*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r**2 - 42240*D1*Dd*f*fd*g2*r*s + 26400*D1*Dd*f*fd*g2*r - 21120*D1*Dd*f*fd*g2*s**2 + 26400*D1*Dd*f*fd*g2*s - 7920*D1*Dd*f*fd*g2 + 2640*D1*Ddd*b2*f**2*r**2 + 5280*D1*Ddd*b2*f**2*r*s - 3960*D1*Ddd*b2*f**2*r + 2640*D1*Ddd*b2*f**2*s**2 - 3960*D1*Ddd*b2*f**2*s + 1980*D1*Ddd*b2*f**2 - 2240*D1*Ddd*f**3*r**2 - 4480*D1*Ddd*f**3*r*s + 3360*D1*Ddd*f**3*r - 2240*D1*Ddd*f**3*s**2 + 3360*D1*Ddd*f**3*s - 1680*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r**2 - 10560*D1*Ddd*f**2*g2*r*s + 7920*D1*Ddd*f**2*g2*r - 5280*D1*Ddd*f**2*g2*s**2 + 7920*D1*Ddd*f**2*g2*s - 3960*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(r + s - 1)**2 + f**2*(-40*C*s**2 + 28*K*(r + s - 1)**2 + r**2*(26 - 40*C) + r*(-80*C*s + 52*s + 8) + 26*s**2 + 8*s - 4) - 2*f*(5*fd*(r + s - 1)*(-8*C*s + K*(8*r + 8*s - 4) + r*(4 - 8*C) + 4*s + 1) + (24*r + 24*s)*(-g2*(r + s) + gd2*(r + s - 1))) - 48*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(5*f*(-4*C*r - 4*C*s + 4*K*(r + s - 1) + 2*r + 2*s + 1) + 24*g2*(r + s))*(4*r + 4*s - 3)) + 7920*Dd**2*b2*f**2*r**2 + 15840*Dd**2*b2*f**2*r*s - 11880*Dd**2*b2*f**2*r + 7920*Dd**2*b2*f**2*s**2 - 11880*Dd**2*b2*f**2*s + 3960*Dd**2*b2*f**2 - 6720*Dd**2*f**3*r**2 - 13440*Dd**2*f**3*r*s + 10080*Dd**2*f**3*r - 6720*Dd**2*f**3*s**2 + 10080*Dd**2*f**3*s - 3360*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r**2 - 31680*Dd**2*f**2*g2*r*s + 23760*Dd**2*f**2*g2*r - 15840*Dd**2*f**2*g2*s**2 + 23760*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(10*fd**2*(r + s - 1) - 2*fd*(12*K*(r + s - 1)**2 + 5*f*(2*r + 2*s - 1) + 12*r + 12*s - 6) + fdd*(12*K*(r + s - 1)**2 + 5*f*(2*r + 2*s - 1) + 12*r + 12*s - 6)) + 2*D1*(Dd*(-12*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(4*r + 4*s - 3)*(12*K*(r + s - 1) + 5*f + 6)) + 6*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-80*C*D1**2*f*fd*r**2 - 160*C*D1**2*f*fd*r*s + 160*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 160*C*D1**2*f*fd*s - 80*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 80*C*D1**2*f*fdd*s + 40*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 80*C*D1**2*fd**2*s + 40*C*D1**2*fd**2 - 160*C*D1*Dd*f**2*r**2 - 320*C*D1*Dd*f**2*r*s + 240*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 240*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 560*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 560*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 + 56*D1**2*K*f*fd*r**2 + 112*D1**2*K*f*fd*r*s - 56*D1**2*K*f*fd*r + 56*D1**2*K*f*fd*s**2 - 56*D1**2*K*f*fd*s + 28*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r**2 - 80*D1**2*K*f*fdd*r*s + 40*D1**2*K*f*fdd*r - 40*D1**2*K*f*fdd*s**2 + 40*D1**2*K*f*fdd*s - 20*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r**2 - 80*D1**2*K*fd**2*r*s + 40*D1**2*K*fd**2*r - 40*D1**2*K*fd**2*s**2 + 40*D1**2*K*fd**2*s + D1**2*bdd1*f*(6*K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 5*f*(2*r + 2*s - 1) - 12*r - 12*s + 6) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 52*D1**2*f*fd*r**2 + 104*D1**2*f*fd*r*s - 112*D1**2*f*fd*r + 52*D1**2*f*fd*s**2 - 112*D1**2*f*fd*s + 56*D1**2*f*fd - 20*D1**2*f*fdd*r**2 - 40*D1**2*f*fdd*r*s + 50*D1**2*f*fdd*r - 20*D1**2*f*fdd*s**2 + 50*D1**2*f*fdd*s - 25*D1**2*f*fdd + 48*D1**2*f*gd2*r**2 + 96*D1**2*f*gd2*r*s - 96*D1**2*f*gd2*r + 48*D1**2*f*gd2*s**2 - 96*D1**2*f*gd2*s + 48*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 20*D1**2*fd**2*r**2 - 40*D1**2*fd**2*r*s + 50*D1**2*fd**2*r - 20*D1**2*fd**2*s**2 + 50*D1**2*fd**2*s - 30*D1**2*fd**2 + 48*D1**2*fd*g2*r**2 + 96*D1**2*fd*g2*r*s - 96*D1**2*fd*g2*r + 48*D1**2*fd*g2*s**2 - 96*D1**2*fd*g2*s + 48*D1**2*fd*g2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 96*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 96*D1**2*fd*gd2*s - 48*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s + 48*D1**2*fdd*g2*r - 24*D1**2*fdd*g2*s**2 + 48*D1**2*fdd*g2*s - 24*D1**2*fdd*g2 + 112*D1*Dd*K*f**2*r**2 + 224*D1*Dd*K*f**2*r*s - 168*D1*Dd*K*f**2*r + 112*D1*Dd*K*f**2*s**2 - 168*D1*Dd*K*f**2*s + 84*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r**2 - 640*D1*Dd*K*f*fd*r*s + 400*D1*Dd*K*f*fd*r - 320*D1*Dd*K*f*fd*s**2 + 400*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 104*D1*Dd*f**2*r**2 + 208*D1*Dd*f**2*r*s - 156*D1*Dd*f**2*r + 104*D1*Dd*f**2*s**2 - 156*D1*Dd*f**2*s + 78*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 - 320*D1*Dd*f*fd*r*s + 320*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 320*D1*Dd*f*fd*s - 150*D1*Dd*f*fd + 192*D1*Dd*f*g2*r**2 + 384*D1*Dd*f*g2*r*s - 288*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 288*D1*Dd*f*g2*s + 144*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 336*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 336*D1*Dd*fd*g2*s - 144*D1*Dd*fd*g2 - 80*D1*Ddd*K*f**2*r**2 - 160*D1*Ddd*K*f**2*r*s + 120*D1*Ddd*K*f**2*r - 80*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 - 40*D1*Ddd*f**2*r**2 - 80*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*f**2*(2*r + 2*s - 1) - 6*f*(K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 2*r - 2*s + 1) + 6*fd*(K*(4*r + 4*s - 2) + 1)*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(6*K*(4*r + 4*s - 2) - 5*f - 6)) - 240*Dd**2*K*f**2*r**2 - 480*Dd**2*K*f**2*r*s + 360*Dd**2*K*f**2*r - 240*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 - 120*Dd**2*f**2*r**2 - 240*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 60*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(693*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**5*k1*k2*(D1*f*(r + s)*(2*D1*bd1**2*(5*f + 6)*(r + s - 1) + 5*D1*bdd1*f*(r + s) + 10*bd1*(-D1*f*(r + s) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + b1**2*(2*D1**2*(5*fd**2 + fd*(-10*f - 6) + fdd*(5*f + 3))*(r + s - 1)**2 + D1*(-2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-10*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 24*r**2 + 48*r*s - 36*r + 24*s**2 - 36*s + 18) - 6*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*bdd1*f*(5*f + 6)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*D1**2*(r + s - 1)**2*(2*f*fd - f*fdd - fd**2) - 2*D1*bd1*(D1*(5*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*f*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 6*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - Dd*f*(5*f + 6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k3**2) - 10*D1**2*Pk2*Pkdd3*ct**4*f*k1**2*k2**4*st**4*(D1**2*(70*f**2*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*f*(140*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - fd*(26*C - 26)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(13*C - 13)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2)) + fd**2*(78 - 78*C)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(70*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(39*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 70*fd*(4*r + 4*s - 3)**2 - 156*r**2 - 312*r*s + 234*r - 156*s**2 + 234*s - 117) - fd*(39*C - 39)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - Ddd*f*(39*C + 70*f - 39)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(39*C + 70*f - 39)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(3003*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**4*k1**6*(8970*C*D1**2*f**2*fd*r**2 + 17940*C*D1**2*f**2*fd*r*s - 11960*C*D1**2*f**2*fd*r + 8970*C*D1**2*f**2*fd*s**2 - 11960*C*D1**2*f**2*fd*s + 5980*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r**2 - 21840*C*D1**2*f**2*fdd*r*s + 14560*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 14560*C*D1**2*f**2*fdd*s - 7280*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r**2 - 43680*C*D1**2*f*fd**2*r*s + 29120*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 29120*C*D1**2*f*fd**2*s - 7280*C*D1**2*f*fd**2 + 11960*C*D1*Dd*f**3*r**2 + 23920*C*D1*Dd*f**3*r*s - 17940*C*D1*Dd*f**3*r + 11960*C*D1*Dd*f**3*s**2 - 17940*C*D1*Dd*f**3*s + 8970*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r**2 - 174720*C*D1*Dd*f**2*fd*r*s + 123760*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 123760*C*D1*Dd*f**2*fd*s - 43680*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r**2 - 29120*C*D1*Ddd*f**3*r*s + 21840*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 21840*C*D1*Ddd*f**3*s - 10920*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r**2 - 87360*C*Dd**2*f**3*r*s + 65520*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 65520*C*Dd**2*f**3*s - 21840*C*Dd**2*f**3 + 3432*D1**2*K*b1*f*fd*r**2 + 6864*D1**2*K*b1*f*fd*r*s - 3432*D1**2*K*b1*f*fd*r + 3432*D1**2*K*b1*f*fd*s**2 - 3432*D1**2*K*b1*f*fd*s + 1716*D1**2*K*b1*f*fd - 4290*D1**2*K*b1*f*fdd*r**2 - 8580*D1**2*K*b1*f*fdd*r*s + 4290*D1**2*K*b1*f*fdd*r - 4290*D1**2*K*b1*f*fdd*s**2 + 4290*D1**2*K*b1*f*fdd*s - 2145*D1**2*K*b1*f*fdd - 4290*D1**2*K*b1*fd**2*r**2 - 8580*D1**2*K*b1*fd**2*r*s + 4290*D1**2*K*b1*fd**2*r - 4290*D1**2*K*b1*fd**2*s**2 + 4290*D1**2*K*b1*fd**2*s - 3432*D1**2*b1*f*fd*r**2 - 6864*D1**2*b1*f*fd*r*s + 3432*D1**2*b1*f*fd*r - 3432*D1**2*b1*f*fd*s**2 + 3432*D1**2*b1*f*fd*s - 1716*D1**2*b1*f*fd + 4290*D1**2*b1*f*fdd*r**2 + 8580*D1**2*b1*f*fdd*r*s - 4290*D1**2*b1*f*fdd*r + 4290*D1**2*b1*f*fdd*s**2 - 4290*D1**2*b1*f*fdd*s + 2145*D1**2*b1*f*fdd + 4290*D1**2*b1*fd**2*r**2 + 8580*D1**2*b1*fd**2*r*s - 4290*D1**2*b1*fd**2*r + 4290*D1**2*b1*fd**2*s**2 - 4290*D1**2*b1*fd**2*s - 2145*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 26600*D1**2*f**3*fd*r**2 + 53200*D1**2*f**3*fd*r*s - 39900*D1**2*f**3*fd*r + 26600*D1**2*f**3*fd*s**2 - 39900*D1**2*f**3*fd*s + 19950*D1**2*f**3*fd - 31500*D1**2*f**3*fdd*r**2 - 63000*D1**2*f**3*fdd*r*s + 47250*D1**2*f**3*fdd*r - 31500*D1**2*f**3*fdd*s**2 + 47250*D1**2*f**3*fdd*s - 23625*D1**2*f**3*fdd - 94500*D1**2*f**2*fd**2*r**2 - 189000*D1**2*f**2*fd**2*r*s + 141750*D1**2*f**2*fd**2*r - 94500*D1**2*f**2*fd**2*s**2 + 141750*D1**2*f**2*fd**2*s - 47250*D1**2*f**2*fd**2 - 8970*D1**2*f**2*fd*r**2 - 17940*D1**2*f**2*fd*r*s + 11960*D1**2*f**2*fd*r - 8970*D1**2*f**2*fd*s**2 + 11960*D1**2*f**2*fd*s - 5980*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r**2 + 21840*D1**2*f**2*fdd*r*s - 14560*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 14560*D1**2*f**2*fdd*s + 7280*D1**2*f**2*fdd - 3432*D1**2*f**2*gd2*r**2 - 6864*D1**2*f**2*gd2*r*s + 6864*D1**2*f**2*gd2*r - 3432*D1**2*f**2*gd2*s**2 + 6864*D1**2*f**2*gd2*s - 3432*D1**2*f**2*gd2 + 4290*D1**2*f**2*gdd2*r**2 + 8580*D1**2*f**2*gdd2*r*s - 8580*D1**2*f**2*gdd2*r + 4290*D1**2*f**2*gdd2*s**2 - 8580*D1**2*f**2*gdd2*s + 4290*D1**2*f**2*gdd2 + 21840*D1**2*f*fd**2*r**2 + 43680*D1**2*f*fd**2*r*s - 29120*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 29120*D1**2*f*fd**2*s + 7280*D1**2*f*fd**2 - 6864*D1**2*f*fd*g2*r**2 - 13728*D1**2*f*fd*g2*r*s + 6864*D1**2*f*fd*g2*r - 6864*D1**2*f*fd*g2*s**2 + 6864*D1**2*f*fd*g2*s - 3432*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r**2 + 34320*D1**2*f*fd*gd2*r*s - 25740*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 25740*D1**2*f*fd*gd2*s + 8580*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r**2 + 17160*D1**2*f*fdd*g2*r*s - 8580*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r**2 + 17160*D1**2*fd**2*g2*r*s - 8580*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 6864*D1*Dd*K*b1*f**2*r**2 + 13728*D1*Dd*K*b1*f**2*r*s - 10296*D1*Dd*K*b1*f**2*r + 6864*D1*Dd*K*b1*f**2*s**2 - 10296*D1*Dd*K*b1*f**2*s + 5148*D1*Dd*K*b1*f**2 - 34320*D1*Dd*K*b1*f*fd*r**2 - 68640*D1*Dd*K*b1*f*fd*r*s + 42900*D1*Dd*K*b1*f*fd*r - 34320*D1*Dd*K*b1*f*fd*s**2 + 42900*D1*Dd*K*b1*f*fd*s - 12870*D1*Dd*K*b1*f*fd - 6864*D1*Dd*b1*f**2*r**2 - 13728*D1*Dd*b1*f**2*r*s + 10296*D1*Dd*b1*f**2*r - 6864*D1*Dd*b1*f**2*s**2 + 10296*D1*Dd*b1*f**2*s - 5148*D1*Dd*b1*f**2 + 34320*D1*Dd*b1*f*fd*r**2 + 68640*D1*Dd*b1*f*fd*r*s - 42900*D1*Dd*b1*f*fd*r + 34320*D1*Dd*b1*f*fd*s**2 - 42900*D1*Dd*b1*f*fd*s + 12870*D1*Dd*b1*f*fd + 26600*D1*Dd*f**4*r**2 + 53200*D1*Dd*f**4*r*s - 39900*D1*Dd*f**4*r + 26600*D1*Dd*f**4*s**2 - 39900*D1*Dd*f**4*s + 19950*D1*Dd*f**4 - 252000*D1*Dd*f**3*fd*r**2 - 504000*D1*Dd*f**3*fd*r*s + 378000*D1*Dd*f**3*fd*r - 252000*D1*Dd*f**3*fd*s**2 + 378000*D1*Dd*f**3*fd*s - 141750*D1*Dd*f**3*fd - 11960*D1*Dd*f**3*r**2 - 23920*D1*Dd*f**3*r*s + 17940*D1*Dd*f**3*r - 11960*D1*Dd*f**3*s**2 + 17940*D1*Dd*f**3*s - 8970*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r**2 + 174720*D1*Dd*f**2*fd*r*s - 123760*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 123760*D1*Dd*f**2*fd*s + 43680*D1*Dd*f**2*fd - 13728*D1*Dd*f**2*g2*r**2 - 27456*D1*Dd*f**2*g2*r*s + 20592*D1*Dd*f**2*g2*r - 13728*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 10296*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r**2 + 68640*D1*Dd*f**2*gd2*r*s - 60060*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 60060*D1*Dd*f**2*gd2*s + 25740*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r**2 + 137280*D1*Dd*f*fd*g2*r*s - 85800*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 85800*D1*Dd*f*fd*g2*s + 25740*D1*Dd*f*fd*g2 - 8580*D1*Ddd*K*b1*f**2*r**2 - 17160*D1*Ddd*K*b1*f**2*r*s + 12870*D1*Ddd*K*b1*f**2*r - 8580*D1*Ddd*K*b1*f**2*s**2 + 12870*D1*Ddd*K*b1*f**2*s - 6435*D1*Ddd*K*b1*f**2 + 8580*D1*Ddd*b1*f**2*r**2 + 17160*D1*Ddd*b1*f**2*r*s - 12870*D1*Ddd*b1*f**2*r + 8580*D1*Ddd*b1*f**2*s**2 - 12870*D1*Ddd*b1*f**2*s + 6435*D1*Ddd*b1*f**2 - 31500*D1*Ddd*f**4*r**2 - 63000*D1*Ddd*f**4*r*s + 47250*D1*Ddd*f**4*r - 31500*D1*Ddd*f**4*s**2 + 47250*D1*Ddd*f**4*s - 23625*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r**2 + 29120*D1*Ddd*f**3*r*s - 21840*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 21840*D1*Ddd*f**3*s + 10920*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r**2 + 34320*D1*Ddd*f**2*g2*r*s - 25740*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 25740*D1*Ddd*f**2*g2*s + 12870*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 25740*Dd**2*K*b1*f**2*r**2 - 51480*Dd**2*K*b1*f**2*r*s + 38610*Dd**2*K*b1*f**2*r - 25740*Dd**2*K*b1*f**2*s**2 + 38610*Dd**2*K*b1*f**2*s - 12870*Dd**2*K*b1*f**2 + 25740*Dd**2*b1*f**2*r**2 + 51480*Dd**2*b1*f**2*r*s - 38610*Dd**2*b1*f**2*r + 25740*Dd**2*b1*f**2*s**2 - 38610*Dd**2*b1*f**2*s + 12870*Dd**2*b1*f**2 - 94500*Dd**2*f**4*r**2 - 189000*Dd**2*f**4*r*s + 141750*Dd**2*f**4*r - 94500*Dd**2*f**4*s**2 + 141750*Dd**2*f**4*s - 47250*Dd**2*f**4 + 43680*Dd**2*f**3*r**2 + 87360*Dd**2*f**3*r*s - 65520*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 65520*Dd**2*f**3*s + 21840*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r**2 + 102960*Dd**2*f**2*g2*r*s - 77220*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 77220*Dd**2*f**2*g2*s + 25740*Dd**2*f**2*g2)/(9009*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**4*k1**4*k2**2*st**2*(31356*C*D1**2*f**2*fd*r**2 + 62712*C*D1**2*f**2*fd*r*s - 41808*C*D1**2*f**2*fd*r + 31356*C*D1**2*f**2*fd*s**2 - 41808*C*D1**2*f**2*fd*s + 20904*C*D1**2*f**2*fd - 23400*C*D1**2*f**2*fdd*r**2 - 46800*C*D1**2*f**2*fdd*r*s + 31200*C*D1**2*f**2*fdd*r - 23400*C*D1**2*f**2*fdd*s**2 + 31200*C*D1**2*f**2*fdd*s - 15600*C*D1**2*f**2*fdd - 46800*C*D1**2*f*fd**2*r**2 - 93600*C*D1**2*f*fd**2*r*s + 62400*C*D1**2*f*fd**2*r - 46800*C*D1**2*f*fd**2*s**2 + 62400*C*D1**2*f*fd**2*s - 15600*C*D1**2*f*fd**2 + 41808*C*D1*Dd*f**3*r**2 + 83616*C*D1*Dd*f**3*r*s - 62712*C*D1*Dd*f**3*r + 41808*C*D1*Dd*f**3*s**2 - 62712*C*D1*Dd*f**3*s + 31356*C*D1*Dd*f**3 - 187200*C*D1*Dd*f**2*fd*r**2 - 374400*C*D1*Dd*f**2*fd*r*s + 265200*C*D1*Dd*f**2*fd*r - 187200*C*D1*Dd*f**2*fd*s**2 + 265200*C*D1*Dd*f**2*fd*s - 93600*C*D1*Dd*f**2*fd - 31200*C*D1*Ddd*f**3*r**2 - 62400*C*D1*Ddd*f**3*r*s + 46800*C*D1*Ddd*f**3*r - 31200*C*D1*Ddd*f**3*s**2 + 46800*C*D1*Ddd*f**3*s - 23400*C*D1*Ddd*f**3 - 93600*C*Dd**2*f**3*r**2 - 187200*C*Dd**2*f**3*r*s + 140400*C*Dd**2*f**3*r - 93600*C*Dd**2*f**3*s**2 + 140400*C*Dd**2*f**3*s - 46800*C*Dd**2*f**3 + 15444*D1**2*K*b1*f*fd*r**2 + 30888*D1**2*K*b1*f*fd*r*s - 15444*D1**2*K*b1*f*fd*r + 15444*D1**2*K*b1*f*fd*s**2 - 15444*D1**2*K*b1*f*fd*s + 7722*D1**2*K*b1*f*fd - 10296*D1**2*K*b1*f*fdd*r**2 - 20592*D1**2*K*b1*f*fdd*r*s + 10296*D1**2*K*b1*f*fdd*r - 10296*D1**2*K*b1*f*fdd*s**2 + 10296*D1**2*K*b1*f*fdd*s - 5148*D1**2*K*b1*f*fdd - 10296*D1**2*K*b1*fd**2*r**2 - 20592*D1**2*K*b1*fd**2*r*s + 10296*D1**2*K*b1*fd**2*r - 10296*D1**2*K*b1*fd**2*s**2 + 10296*D1**2*K*b1*fd**2*s - 15444*D1**2*b1*f*fd*r**2 - 30888*D1**2*b1*f*fd*r*s + 15444*D1**2*b1*f*fd*r - 15444*D1**2*b1*f*fd*s**2 + 15444*D1**2*b1*f*fd*s - 7722*D1**2*b1*f*fd + 10296*D1**2*b1*f*fdd*r**2 + 20592*D1**2*b1*f*fdd*r*s - 10296*D1**2*b1*f*fdd*r + 10296*D1**2*b1*f*fdd*s**2 - 10296*D1**2*b1*f*fdd*s + 5148*D1**2*b1*f*fdd + 10296*D1**2*b1*fd**2*r**2 + 20592*D1**2*b1*fd**2*r*s - 10296*D1**2*b1*fd**2*r + 10296*D1**2*b1*fd**2*s**2 - 10296*D1**2*b1*fd**2*s - 5148*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 65500*D1**2*f**3*fd*r**2 + 131000*D1**2*f**3*fd*r*s - 98250*D1**2*f**3*fd*r + 65500*D1**2*f**3*fd*s**2 - 98250*D1**2*f**3*fd*s + 49125*D1**2*f**3*fd - 49000*D1**2*f**3*fdd*r**2 - 98000*D1**2*f**3*fdd*r*s + 73500*D1**2*f**3*fdd*r - 49000*D1**2*f**3*fdd*s**2 + 73500*D1**2*f**3*fdd*s - 36750*D1**2*f**3*fdd - 147000*D1**2*f**2*fd**2*r**2 - 294000*D1**2*f**2*fd**2*r*s + 220500*D1**2*f**2*fd**2*r - 147000*D1**2*f**2*fd**2*s**2 + 220500*D1**2*f**2*fd**2*s - 73500*D1**2*f**2*fd**2 - 31356*D1**2*f**2*fd*r**2 - 62712*D1**2*f**2*fd*r*s + 41808*D1**2*f**2*fd*r - 31356*D1**2*f**2*fd*s**2 + 41808*D1**2*f**2*fd*s - 20904*D1**2*f**2*fd + 23400*D1**2*f**2*fdd*r**2 + 46800*D1**2*f**2*fdd*r*s - 31200*D1**2*f**2*fdd*r + 23400*D1**2*f**2*fdd*s**2 - 31200*D1**2*f**2*fdd*s + 15600*D1**2*f**2*fdd - 15444*D1**2*f**2*gd2*r**2 - 30888*D1**2*f**2*gd2*r*s + 30888*D1**2*f**2*gd2*r - 15444*D1**2*f**2*gd2*s**2 + 30888*D1**2*f**2*gd2*s - 15444*D1**2*f**2*gd2 + 10296*D1**2*f**2*gdd2*r**2 + 20592*D1**2*f**2*gdd2*r*s - 20592*D1**2*f**2*gdd2*r + 10296*D1**2*f**2*gdd2*s**2 - 20592*D1**2*f**2*gdd2*s + 10296*D1**2*f**2*gdd2 + 46800*D1**2*f*fd**2*r**2 + 93600*D1**2*f*fd**2*r*s - 62400*D1**2*f*fd**2*r + 46800*D1**2*f*fd**2*s**2 - 62400*D1**2*f*fd**2*s + 15600*D1**2*f*fd**2 - 30888*D1**2*f*fd*g2*r**2 - 61776*D1**2*f*fd*g2*r*s + 30888*D1**2*f*fd*g2*r - 30888*D1**2*f*fd*g2*s**2 + 30888*D1**2*f*fd*g2*s - 15444*D1**2*f*fd*g2 + 41184*D1**2*f*fd*gd2*r**2 + 82368*D1**2*f*fd*gd2*r*s - 61776*D1**2*f*fd*gd2*r + 41184*D1**2*f*fd*gd2*s**2 - 61776*D1**2*f*fd*gd2*s + 20592*D1**2*f*fd*gd2 + 20592*D1**2*f*fdd*g2*r**2 + 41184*D1**2*f*fdd*g2*r*s - 20592*D1**2*f*fdd*g2*r + 20592*D1**2*f*fdd*g2*s**2 - 20592*D1**2*f*fdd*g2*s + 10296*D1**2*f*fdd*g2 + 20592*D1**2*fd**2*g2*r**2 + 41184*D1**2*fd**2*g2*r*s - 20592*D1**2*fd**2*g2*r + 20592*D1**2*fd**2*g2*s**2 - 20592*D1**2*fd**2*g2*s + 30888*D1*Dd*K*b1*f**2*r**2 + 61776*D1*Dd*K*b1*f**2*r*s - 46332*D1*Dd*K*b1*f**2*r + 30888*D1*Dd*K*b1*f**2*s**2 - 46332*D1*Dd*K*b1*f**2*s + 23166*D1*Dd*K*b1*f**2 - 82368*D1*Dd*K*b1*f*fd*r**2 - 164736*D1*Dd*K*b1*f*fd*r*s + 102960*D1*Dd*K*b1*f*fd*r - 82368*D1*Dd*K*b1*f*fd*s**2 + 102960*D1*Dd*K*b1*f*fd*s - 30888*D1*Dd*K*b1*f*fd - 30888*D1*Dd*b1*f**2*r**2 - 61776*D1*Dd*b1*f**2*r*s + 46332*D1*Dd*b1*f**2*r - 30888*D1*Dd*b1*f**2*s**2 + 46332*D1*Dd*b1*f**2*s - 23166*D1*Dd*b1*f**2 + 82368*D1*Dd*b1*f*fd*r**2 + 164736*D1*Dd*b1*f*fd*r*s - 102960*D1*Dd*b1*f*fd*r + 82368*D1*Dd*b1*f*fd*s**2 - 102960*D1*Dd*b1*f*fd*s + 30888*D1*Dd*b1*f*fd + 65500*D1*Dd*f**4*r**2 + 131000*D1*Dd*f**4*r*s - 98250*D1*Dd*f**4*r + 65500*D1*Dd*f**4*s**2 - 98250*D1*Dd*f**4*s + 49125*D1*Dd*f**4 - 392000*D1*Dd*f**3*fd*r**2 - 784000*D1*Dd*f**3*fd*r*s + 588000*D1*Dd*f**3*fd*r - 392000*D1*Dd*f**3*fd*s**2 + 588000*D1*Dd*f**3*fd*s - 220500*D1*Dd*f**3*fd - 41808*D1*Dd*f**3*r**2 - 83616*D1*Dd*f**3*r*s + 62712*D1*Dd*f**3*r - 41808*D1*Dd*f**3*s**2 + 62712*D1*Dd*f**3*s - 31356*D1*Dd*f**3 + 187200*D1*Dd*f**2*fd*r**2 + 374400*D1*Dd*f**2*fd*r*s - 265200*D1*Dd*f**2*fd*r + 187200*D1*Dd*f**2*fd*s**2 - 265200*D1*Dd*f**2*fd*s + 93600*D1*Dd*f**2*fd - 61776*D1*Dd*f**2*g2*r**2 - 123552*D1*Dd*f**2*g2*r*s + 92664*D1*Dd*f**2*g2*r - 61776*D1*Dd*f**2*g2*s**2 + 92664*D1*Dd*f**2*g2*s - 46332*D1*Dd*f**2*g2 + 82368*D1*Dd*f**2*gd2*r**2 + 164736*D1*Dd*f**2*gd2*r*s - 144144*D1*Dd*f**2*gd2*r + 82368*D1*Dd*f**2*gd2*s**2 - 144144*D1*Dd*f**2*gd2*s + 61776*D1*Dd*f**2*gd2 + 164736*D1*Dd*f*fd*g2*r**2 + 329472*D1*Dd*f*fd*g2*r*s - 205920*D1*Dd*f*fd*g2*r + 164736*D1*Dd*f*fd*g2*s**2 - 205920*D1*Dd*f*fd*g2*s + 61776*D1*Dd*f*fd*g2 - 20592*D1*Ddd*K*b1*f**2*r**2 - 41184*D1*Ddd*K*b1*f**2*r*s + 30888*D1*Ddd*K*b1*f**2*r - 20592*D1*Ddd*K*b1*f**2*s**2 + 30888*D1*Ddd*K*b1*f**2*s - 15444*D1*Ddd*K*b1*f**2 + 20592*D1*Ddd*b1*f**2*r**2 + 41184*D1*Ddd*b1*f**2*r*s - 30888*D1*Ddd*b1*f**2*r + 20592*D1*Ddd*b1*f**2*s**2 - 30888*D1*Ddd*b1*f**2*s + 15444*D1*Ddd*b1*f**2 - 49000*D1*Ddd*f**4*r**2 - 98000*D1*Ddd*f**4*r*s + 73500*D1*Ddd*f**4*r - 49000*D1*Ddd*f**4*s**2 + 73500*D1*Ddd*f**4*s - 36750*D1*Ddd*f**4 + 31200*D1*Ddd*f**3*r**2 + 62400*D1*Ddd*f**3*r*s - 46800*D1*Ddd*f**3*r + 31200*D1*Ddd*f**3*s**2 - 46800*D1*Ddd*f**3*s + 23400*D1*Ddd*f**3 + 41184*D1*Ddd*f**2*g2*r**2 + 82368*D1*Ddd*f**2*g2*r*s - 61776*D1*Ddd*f**2*g2*r + 41184*D1*Ddd*f**2*g2*s**2 - 61776*D1*Ddd*f**2*g2*s + 30888*D1*Ddd*f**2*g2 + 2574*D1*bd1*f*(K - 1)*(r + s - 1)*(3*D1*f*(r + s - 1) - 4*D1*fd*(2*r + 2*s - 1) - 4*Dd*f*(4*r + 4*s - 3)) - 61776*Dd**2*K*b1*f**2*r**2 - 123552*Dd**2*K*b1*f**2*r*s + 92664*Dd**2*K*b1*f**2*r - 61776*Dd**2*K*b1*f**2*s**2 + 92664*Dd**2*K*b1*f**2*s - 30888*Dd**2*K*b1*f**2 + 61776*Dd**2*b1*f**2*r**2 + 123552*Dd**2*b1*f**2*r*s - 92664*Dd**2*b1*f**2*r + 61776*Dd**2*b1*f**2*s**2 - 92664*Dd**2*b1*f**2*s + 30888*Dd**2*b1*f**2 - 147000*Dd**2*f**4*r**2 - 294000*Dd**2*f**4*r*s + 220500*Dd**2*f**4*r - 147000*Dd**2*f**4*s**2 + 220500*Dd**2*f**4*s - 73500*Dd**2*f**4 + 93600*Dd**2*f**3*r**2 + 187200*Dd**2*f**3*r*s - 140400*Dd**2*f**3*r + 93600*Dd**2*f**3*s**2 - 140400*Dd**2*f**3*s + 46800*Dd**2*f**3 + 123552*Dd**2*f**2*g2*r**2 + 247104*Dd**2*f**2*g2*r*s - 185328*Dd**2*f**2*g2*r + 123552*Dd**2*f**2*g2*s**2 - 185328*Dd**2*f**2*g2*s + 61776*Dd**2*f**2*g2)/(6006*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**4*k1**4*k2**2*(4530*C*D1**2*f**2*fd*r**2 + 9060*C*D1**2*f**2*fd*r*s - 6040*C*D1**2*f**2*fd*r + 4530*C*D1**2*f**2*fd*s**2 - 6040*C*D1**2*f**2*fd*s + 3020*C*D1**2*f**2*fd - 6720*C*D1**2*f**2*fdd*r**2 - 13440*C*D1**2*f**2*fdd*r*s + 8960*C*D1**2*f**2*fdd*r - 6720*C*D1**2*f**2*fdd*s**2 + 8960*C*D1**2*f**2*fdd*s - 4480*C*D1**2*f**2*fdd - 13440*C*D1**2*f*fd**2*r**2 - 26880*C*D1**2*f*fd**2*r*s + 17920*C*D1**2*f*fd**2*r - 13440*C*D1**2*f*fd**2*s**2 + 17920*C*D1**2*f*fd**2*s - 4480*C*D1**2*f*fd**2 + 6040*C*D1*Dd*f**3*r**2 + 12080*C*D1*Dd*f**3*r*s - 9060*C*D1*Dd*f**3*r + 6040*C*D1*Dd*f**3*s**2 - 9060*C*D1*Dd*f**3*s + 4530*C*D1*Dd*f**3 - 53760*C*D1*Dd*f**2*fd*r**2 - 107520*C*D1*Dd*f**2*fd*r*s + 76160*C*D1*Dd*f**2*fd*r - 53760*C*D1*Dd*f**2*fd*s**2 + 76160*C*D1*Dd*f**2*fd*s - 26880*C*D1*Dd*f**2*fd - 8960*C*D1*Ddd*f**3*r**2 - 17920*C*D1*Ddd*f**3*r*s + 13440*C*D1*Ddd*f**3*r - 8960*C*D1*Ddd*f**3*s**2 + 13440*C*D1*Ddd*f**3*s - 6720*C*D1*Ddd*f**3 - 26880*C*Dd**2*f**3*r**2 - 53760*C*Dd**2*f**3*r*s + 40320*C*Dd**2*f**3*r - 26880*C*Dd**2*f**3*s**2 + 40320*C*Dd**2*f**3*s - 13440*C*Dd**2*f**3 - 2376*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 132*D1**2*bdd1*f*(5*f*(3*C + 2*K - 4) - 18*g2)*(r + s - 1)**2 - 1680*D1**2*f**3*fd*r**2 - 3360*D1**2*f**3*fd*r*s + 2520*D1**2*f**3*fd*r - 1680*D1**2*f**3*fd*s**2 + 2520*D1**2*f**3*fd*s - 1260*D1**2*f**3*fd - 3150*D1**2*f**2*fd*r**2 - 6300*D1**2*f**2*fd*r*s + 4200*D1**2*f**2*fd*r - 3150*D1**2*f**2*fd*s**2 + 4200*D1**2*f**2*fd*s - 2100*D1**2*f**2*fd + 5040*D1**2*f**2*fdd*r**2 + 10080*D1**2*f**2*fdd*r*s - 6720*D1**2*f**2*fdd*r + 5040*D1**2*f**2*fdd*s**2 - 6720*D1**2*f**2*fdd*s + 3360*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 2640*D1**2*f**2*gdd2*r**2 + 5280*D1**2*f**2*gdd2*r*s - 5280*D1**2*f**2*gdd2*r + 2640*D1**2*f**2*gdd2*s**2 - 5280*D1**2*f**2*gdd2*s + 2640*D1**2*f**2*gdd2 + 10080*D1**2*f*fd**2*r**2 + 20160*D1**2*f*fd**2*r*s - 13440*D1**2*f*fd**2*r + 10080*D1**2*f*fd**2*s**2 - 13440*D1**2*f*fd**2*s + 3360*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 10560*D1**2*f*fd*gd2*r**2 + 21120*D1**2*f*fd*gd2*r*s - 15840*D1**2*f*fd*gd2*r + 10560*D1**2*f*fd*gd2*s**2 - 15840*D1**2*f*fd*gd2*s + 5280*D1**2*f*fd*gd2 + 5280*D1**2*f*fdd*g2*r**2 + 10560*D1**2*f*fdd*g2*r*s - 5280*D1**2*f*fdd*g2*r + 5280*D1**2*f*fdd*g2*s**2 - 5280*D1**2*f*fdd*g2*s + 2640*D1**2*f*fdd*g2 + 5280*D1**2*fd**2*g2*r**2 + 10560*D1**2*fd**2*g2*r*s - 5280*D1**2*fd**2*g2*r + 5280*D1**2*fd**2*g2*s**2 - 5280*D1**2*fd**2*g2*s - 1680*D1*Dd*f**4*r**2 - 3360*D1*Dd*f**4*r*s + 2520*D1*Dd*f**4*r - 1680*D1*Dd*f**4*s**2 + 2520*D1*Dd*f**4*s - 1260*D1*Dd*f**4 - 4200*D1*Dd*f**3*r**2 - 8400*D1*Dd*f**3*r*s + 6300*D1*Dd*f**3*r - 4200*D1*Dd*f**3*s**2 + 6300*D1*Dd*f**3*s - 3150*D1*Dd*f**3 + 40320*D1*Dd*f**2*fd*r**2 + 80640*D1*Dd*f**2*fd*r*s - 57120*D1*Dd*f**2*fd*r + 40320*D1*Dd*f**2*fd*s**2 - 57120*D1*Dd*f**2*fd*s + 20160*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 21120*D1*Dd*f**2*gd2*r**2 + 42240*D1*Dd*f**2*gd2*r*s - 36960*D1*Dd*f**2*gd2*r + 21120*D1*Dd*f**2*gd2*s**2 - 36960*D1*Dd*f**2*gd2*s + 15840*D1*Dd*f**2*gd2 + 42240*D1*Dd*f*fd*g2*r**2 + 84480*D1*Dd*f*fd*g2*r*s - 52800*D1*Dd*f*fd*g2*r + 42240*D1*Dd*f*fd*g2*s**2 - 52800*D1*Dd*f*fd*g2*s + 15840*D1*Dd*f*fd*g2 + 6720*D1*Ddd*f**3*r**2 + 13440*D1*Ddd*f**3*r*s - 10080*D1*Ddd*f**3*r + 6720*D1*Ddd*f**3*s**2 - 10080*D1*Ddd*f**3*s + 5040*D1*Ddd*f**3 + 10560*D1*Ddd*f**2*g2*r**2 + 21120*D1*Ddd*f**2*g2*r*s - 15840*D1*Ddd*f**2*g2*r + 10560*D1*Ddd*f**2*g2*s**2 - 15840*D1*Ddd*f**2*g2*s + 7920*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(30*C + 13*K - 35)*(r + s - 1) - 20*f*fd*(3*C + 2*K - 4)*(2*r + 2*s - 1) - f*(37*g2 - 72*gd2)*(r + s - 1) + 72*fd*g2*(r + s)) - 4*Dd*f*(5*f*(3*C + 2*K - 4) - 18*g2)*(4*r + 4*s - 3))*(r + s - 1) + 20160*Dd**2*f**3*r**2 + 40320*Dd**2*f**3*r*s - 30240*Dd**2*f**3*r + 20160*Dd**2*f**3*s**2 - 30240*Dd**2*f**3*s + 10080*Dd**2*f**3 + 31680*Dd**2*f**2*g2*r**2 + 63360*Dd**2*f**2*g2*r*s - 47520*Dd**2*f**2*g2*r + 31680*Dd**2*f**2*g2*s**2 - 47520*Dd**2*f**2*g2*s + 15840*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*(37*fd - 36*fdd)*(r + s)**2 + D1*(Dd*(37*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 72*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 36*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 216*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(60*C*D1**2*f*fd*r**2 + 120*C*D1**2*f*fd*r*s - 60*C*D1**2*f*fd*r + 60*C*D1**2*f*fd*s**2 - 60*C*D1**2*f*fd*s + 30*C*D1**2*f*fd - 60*C*D1**2*f*fdd*r**2 - 120*C*D1**2*f*fdd*r*s + 60*C*D1**2*f*fdd*r - 60*C*D1**2*f*fdd*s**2 + 60*C*D1**2*f*fdd*s - 30*C*D1**2*f*fdd - 60*C*D1**2*fd**2*r**2 - 120*C*D1**2*fd**2*r*s + 60*C*D1**2*fd**2*r - 60*C*D1**2*fd**2*s**2 + 60*C*D1**2*fd**2*s + 120*C*D1*Dd*f**2*r**2 + 240*C*D1*Dd*f**2*r*s - 180*C*D1*Dd*f**2*r + 120*C*D1*Dd*f**2*s**2 - 180*C*D1*Dd*f**2*s + 90*C*D1*Dd*f**2 - 480*C*D1*Dd*f*fd*r**2 - 960*C*D1*Dd*f*fd*r*s + 600*C*D1*Dd*f*fd*r - 480*C*D1*Dd*f*fd*s**2 + 600*C*D1*Dd*f*fd*s - 180*C*D1*Dd*f*fd - 120*C*D1*Ddd*f**2*r**2 - 240*C*D1*Ddd*f**2*r*s + 180*C*D1*Ddd*f**2*r - 120*C*D1*Ddd*f**2*s**2 + 180*C*D1*Ddd*f**2*s - 90*C*D1*Ddd*f**2 - 360*C*Dd**2*f**2*r**2 - 720*C*Dd**2*f**2*r*s + 540*C*Dd**2*f**2*r - 360*C*Dd**2*f**2*s**2 + 540*C*Dd**2*f**2*s - 180*C*Dd**2*f**2 + 26*D1**2*K*f*fd*r**2 + 52*D1**2*K*f*fd*r*s - 26*D1**2*K*f*fd*r + 26*D1**2*K*f*fd*s**2 - 26*D1**2*K*f*fd*s + 13*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r**2 - 80*D1**2*K*f*fdd*r*s + 40*D1**2*K*f*fdd*r - 40*D1**2*K*f*fdd*s**2 + 40*D1**2*K*f*fdd*s - 20*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r**2 - 80*D1**2*K*fd**2*r*s + 40*D1**2*K*fd**2*r - 40*D1**2*K*fd**2*s**2 + 40*D1**2*K*fd**2*s - 36*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd - 70*D1**2*f*fd*r**2 - 140*D1**2*f*fd*r*s + 70*D1**2*f*fd*r - 70*D1**2*f*fd*s**2 + 70*D1**2*f*fd*s - 35*D1**2*f*fd + 80*D1**2*f*fdd*r**2 + 160*D1**2*f*fdd*r*s - 80*D1**2*f*fdd*r + 80*D1**2*f*fdd*s**2 - 80*D1**2*f*fdd*s + 40*D1**2*f*fdd - 37*D1**2*f*gd2*r**2 - 74*D1**2*f*gd2*r*s + 74*D1**2*f*gd2*r - 37*D1**2*f*gd2*s**2 + 74*D1**2*f*gd2*s - 37*D1**2*f*gd2 + 36*D1**2*f*gdd2*r**2 + 72*D1**2*f*gdd2*r*s - 72*D1**2*f*gdd2*r + 36*D1**2*f*gdd2*s**2 - 72*D1**2*f*gdd2*s + 36*D1**2*f*gdd2 + 80*D1**2*fd**2*r**2 + 160*D1**2*fd**2*r*s - 80*D1**2*fd**2*r + 80*D1**2*fd**2*s**2 - 80*D1**2*fd**2*s - 37*D1**2*fd*g2*r**2 - 74*D1**2*fd*g2*r*s - 37*D1**2*fd*g2*s**2 + 72*D1**2*fd*gd2*r**2 + 144*D1**2*fd*gd2*r*s - 72*D1**2*fd*gd2*r + 72*D1**2*fd*gd2*s**2 - 72*D1**2*fd*gd2*s + 36*D1**2*fdd*g2*r**2 + 72*D1**2*fdd*g2*r*s + 36*D1**2*fdd*g2*s**2 + 52*D1*Dd*K*f**2*r**2 + 104*D1*Dd*K*f**2*r*s - 78*D1*Dd*K*f**2*r + 52*D1*Dd*K*f**2*s**2 - 78*D1*Dd*K*f**2*s + 39*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r**2 - 640*D1*Dd*K*f*fd*r*s + 400*D1*Dd*K*f*fd*r - 320*D1*Dd*K*f*fd*s**2 + 400*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 - 140*D1*Dd*f**2*r**2 - 280*D1*Dd*f**2*r*s + 210*D1*Dd*f**2*r - 140*D1*Dd*f**2*s**2 + 210*D1*Dd*f**2*s - 105*D1*Dd*f**2 + 640*D1*Dd*f*fd*r**2 + 1280*D1*Dd*f*fd*r*s - 800*D1*Dd*f*fd*r + 640*D1*Dd*f*fd*s**2 - 800*D1*Dd*f*fd*s + 240*D1*Dd*f*fd - 148*D1*Dd*f*g2*r**2 - 296*D1*Dd*f*g2*r*s + 222*D1*Dd*f*g2*r - 148*D1*Dd*f*g2*s**2 + 222*D1*Dd*f*g2*s - 111*D1*Dd*f*g2 + 288*D1*Dd*f*gd2*r**2 + 576*D1*Dd*f*gd2*r*s - 504*D1*Dd*f*gd2*r + 288*D1*Dd*f*gd2*s**2 - 504*D1*Dd*f*gd2*s + 216*D1*Dd*f*gd2 + 288*D1*Dd*fd*g2*r**2 + 576*D1*Dd*fd*g2*r*s - 216*D1*Dd*fd*g2*r + 288*D1*Dd*fd*g2*s**2 - 216*D1*Dd*fd*g2*s - 80*D1*Ddd*K*f**2*r**2 - 160*D1*Ddd*K*f**2*r*s + 120*D1*Ddd*K*f**2*r - 80*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 + 160*D1*Ddd*f**2*r**2 + 320*D1*Ddd*f**2*r*s - 240*D1*Ddd*f**2*r + 160*D1*Ddd*f**2*s**2 - 240*D1*Ddd*f**2*s + 120*D1*Ddd*f**2 + 144*D1*Ddd*f*g2*r**2 + 288*D1*Ddd*f*g2*r*s - 216*D1*Ddd*f*g2*r + 144*D1*Ddd*f*g2*s**2 - 216*D1*Ddd*f*g2*s + 108*D1*Ddd*f*g2 + D1*bd1*(K - 1)*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) - 240*Dd**2*K*f**2*r**2 - 480*Dd**2*K*f**2*r*s + 360*Dd**2*K*f**2*r - 240*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 + 480*Dd**2*f**2*r**2 + 960*Dd**2*f**2*r*s - 720*Dd**2*f**2*r + 480*Dd**2*f**2*s**2 - 720*Dd**2*f**2*s + 240*Dd**2*f**2 + 432*Dd**2*f*g2*r**2 + 864*Dd**2*f*g2*r*s - 648*Dd**2*f*g2*r + 432*Dd**2*f*g2*s**2 - 648*Dd**2*f*g2*s + 216*Dd**2*f*g2))/(693*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**4*k1**4*(396*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*bd1*(D1*(-115*f**3*(7*r**2 + 2*r*(7*s - 4) + 7*s**2 - 8*s + 4) + 8*f**2*(35*fd*(21*r**2 + r*(42*s - 29) + 21*s**2 - 29*s + 8) - 33*r**2*(C + 1) - 66*r*(C*s + s - 2) - 33*s**2*(C + 1) + 132*s - 66) + 66*f*(20*fd*(r + s - 1)*(C*r + C*s + r + s - 1) - (r + s)*(-5*g2*(r + s) + 12*gd2*(r + s - 1))) - 792*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 4*Dd*f*(4*r + 4*s - 3)*(70*f**2*(7*r + 7*s - 4) + 165*f*(C*r + C*s + r + s - 2) - 198*g2*(r + s))) - 33*b1**2*(K - 1)*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-528*C*D1**2*f*fd*r**2 - 1056*C*D1**2*f*fd*r*s + 1056*C*D1**2*f*fd*r - 528*C*D1**2*f*fd*s**2 + 1056*C*D1**2*f*fd*s - 528*C*D1**2*f*fd + 660*C*D1**2*f*fdd*r**2 + 1320*C*D1**2*f*fdd*r*s - 1320*C*D1**2*f*fdd*r + 660*C*D1**2*f*fdd*s**2 - 1320*C*D1**2*f*fdd*s + 660*C*D1**2*f*fdd + 660*C*D1**2*fd**2*r**2 + 1320*C*D1**2*fd**2*r*s - 1320*C*D1**2*fd**2*r + 660*C*D1**2*fd**2*s**2 - 1320*C*D1**2*fd**2*s + 660*C*D1**2*fd**2 - 1056*C*D1*Dd*f**2*r**2 - 2112*C*D1*Dd*f**2*r*s + 1584*C*D1*Dd*f**2*r - 1056*C*D1*Dd*f**2*s**2 + 1584*C*D1*Dd*f**2*s - 792*C*D1*Dd*f**2 + 5280*C*D1*Dd*f*fd*r**2 + 10560*C*D1*Dd*f*fd*r*s - 9240*C*D1*Dd*f*fd*r + 5280*C*D1*Dd*f*fd*s**2 - 9240*C*D1*Dd*f*fd*s + 3960*C*D1*Dd*f*fd + 1320*C*D1*Ddd*f**2*r**2 + 2640*C*D1*Ddd*f**2*r*s - 1980*C*D1*Ddd*f**2*r + 1320*C*D1*Ddd*f**2*s**2 - 1980*C*D1*Ddd*f**2*s + 990*C*D1*Ddd*f**2 + 3960*C*Dd**2*f**2*r**2 + 7920*C*Dd**2*f**2*r*s - 5940*C*Dd**2*f**2*r + 3960*C*Dd**2*f**2*s**2 - 5940*C*Dd**2*f**2*s + 1980*C*Dd**2*f**2 + 198*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 2415*D1**2*f**2*fd*r**2 - 4830*D1**2*f**2*fd*r*s + 3910*D1**2*f**2*fd*r - 2415*D1**2*f**2*fd*s**2 + 3910*D1**2*f**2*fd*s - 1955*D1**2*f**2*fd + 2940*D1**2*f**2*fdd*r**2 + 5880*D1**2*f**2*fdd*r*s - 4760*D1**2*f**2*fdd*r + 2940*D1**2*f**2*fdd*s**2 - 4760*D1**2*f**2*fdd*s + 2380*D1**2*f**2*fdd + 5880*D1**2*f*fd**2*r**2 + 11760*D1**2*f*fd**2*r*s - 9520*D1**2*f*fd**2*r + 5880*D1**2*f*fd**2*s**2 - 9520*D1**2*f*fd**2*s + 3640*D1**2*f*fd**2 - 528*D1**2*f*fd*r**2 - 1056*D1**2*f*fd*r*s - 528*D1**2*f*fd*s**2 + 660*D1**2*f*fdd*r**2 + 1320*D1**2*f*fdd*r*s + 660*D1**2*f*fdd*s**2 + 330*D1**2*f*gd2*r**2 + 660*D1**2*f*gd2*r*s - 660*D1**2*f*gd2*r + 330*D1**2*f*gd2*s**2 - 660*D1**2*f*gd2*s + 330*D1**2*f*gd2 - 396*D1**2*f*gdd2*r**2 - 792*D1**2*f*gdd2*r*s + 792*D1**2*f*gdd2*r - 396*D1**2*f*gdd2*s**2 + 792*D1**2*f*gdd2*s - 396*D1**2*f*gdd2 + 660*D1**2*fd**2*r**2 + 1320*D1**2*fd**2*r*s + 660*D1**2*fd**2*s**2 - 660*D1**2*fd**2 + 330*D1**2*fd*g2*r**2 + 660*D1**2*fd*g2*r*s - 660*D1**2*fd*g2*r + 330*D1**2*fd*g2*s**2 - 660*D1**2*fd*g2*s + 330*D1**2*fd*g2 - 792*D1**2*fd*gd2*r**2 - 1584*D1**2*fd*gd2*r*s + 1584*D1**2*fd*gd2*r - 792*D1**2*fd*gd2*s**2 + 1584*D1**2*fd*gd2*s - 792*D1**2*fd*gd2 - 396*D1**2*fdd*g2*r**2 - 792*D1**2*fdd*g2*r*s + 792*D1**2*fdd*g2*r - 396*D1**2*fdd*g2*s**2 + 792*D1**2*fdd*g2*s - 396*D1**2*fdd*g2 - 3220*D1*Dd*f**3*r**2 - 6440*D1*Dd*f**3*r*s + 4830*D1*Dd*f**3*r - 3220*D1*Dd*f**3*s**2 + 4830*D1*Dd*f**3*s - 2415*D1*Dd*f**3 + 23520*D1*Dd*f**2*fd*r**2 + 47040*D1*Dd*f**2*fd*r*s - 36680*D1*Dd*f**2*fd*r + 23520*D1*Dd*f**2*fd*s**2 - 36680*D1*Dd*f**2*fd*s + 14280*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*r**2 - 2112*D1*Dd*f**2*r*s + 1584*D1*Dd*f**2*r - 1056*D1*Dd*f**2*s**2 + 1584*D1*Dd*f**2*s - 792*D1*Dd*f**2 + 5280*D1*Dd*f*fd*r**2 + 10560*D1*Dd*f*fd*r*s - 3960*D1*Dd*f*fd*r + 5280*D1*Dd*f*fd*s**2 - 3960*D1*Dd*f*fd*s + 1320*D1*Dd*f*g2*r**2 + 2640*D1*Dd*f*g2*r*s - 1980*D1*Dd*f*g2*r + 1320*D1*Dd*f*g2*s**2 - 1980*D1*Dd*f*g2*s + 990*D1*Dd*f*g2 - 3168*D1*Dd*f*gd2*r**2 - 6336*D1*Dd*f*gd2*r*s + 5544*D1*Dd*f*gd2*r - 3168*D1*Dd*f*gd2*s**2 + 5544*D1*Dd*f*gd2*s - 2376*D1*Dd*f*gd2 - 3168*D1*Dd*fd*g2*r**2 - 6336*D1*Dd*fd*g2*r*s + 5544*D1*Dd*fd*g2*r - 3168*D1*Dd*fd*g2*s**2 + 5544*D1*Dd*fd*g2*s - 2376*D1*Dd*fd*g2 + 3920*D1*Ddd*f**3*r**2 + 7840*D1*Ddd*f**3*r*s - 5880*D1*Ddd*f**3*r + 3920*D1*Ddd*f**3*s**2 - 5880*D1*Ddd*f**3*s + 2940*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*r**2 + 2640*D1*Ddd*f**2*r*s - 1980*D1*Ddd*f**2*r + 1320*D1*Ddd*f**2*s**2 - 1980*D1*Ddd*f**2*s + 990*D1*Ddd*f**2 - 1584*D1*Ddd*f*g2*r**2 - 3168*D1*Ddd*f*g2*r*s + 2376*D1*Ddd*f*g2*r - 1584*D1*Ddd*f*g2*s**2 + 2376*D1*Ddd*f*g2*s - 1188*D1*Ddd*f*g2 - 33*D1*bd1*(K - 1)*(D1*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 12*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 11760*Dd**2*f**3*r**2 + 23520*Dd**2*f**3*r*s - 17640*Dd**2*f**3*r + 11760*Dd**2*f**3*s**2 - 17640*Dd**2*f**3*s + 5880*Dd**2*f**3 + 3960*Dd**2*f**2*r**2 + 7920*Dd**2*f**2*r*s - 5940*Dd**2*f**2*r + 3960*Dd**2*f**2*s**2 - 5940*Dd**2*f**2*s + 1980*Dd**2*f**2 - 4752*Dd**2*f*g2*r**2 - 9504*Dd**2*f*g2*r*s + 7128*Dd**2*f*g2*r - 4752*Dd**2*f*g2*s**2 + 7128*Dd**2*f*g2*s - 2376*Dd**2*f*g2) + 2*f*(D1**2*bdd1*(70*f**2*(7*r**2 + 2*r*(7*s - 4) + 7*s**2 - 8*s + 4) + 165*f*(r**2*(C + 1) + 2*r*(C*s + s - 2) + s**2*(C + 1) - 4*s + 2) - 198*g2*(r + s)**2) - 10*D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 56*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 10*D1*f*(Dd*(23*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 56*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 28*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 1680*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**4*k1**2*k2**4*st**2*(-396*C*D1**2*bdd1*f**2*r**2 - 792*C*D1**2*bdd1*f**2*r*s + 792*C*D1**2*bdd1*f**2*r - 396*C*D1**2*bdd1*f**2*s**2 + 792*C*D1**2*bdd1*f**2*s - 396*C*D1**2*bdd1*f**2 + 18060*C*D1**2*f**2*fd*r**2 + 36120*C*D1**2*f**2*fd*r*s - 24080*C*D1**2*f**2*fd*r + 18060*C*D1**2*f**2*fd*s**2 - 24080*C*D1**2*f**2*fd*s + 12040*C*D1**2*f**2*fd - 12000*C*D1**2*f**2*fdd*r**2 - 24000*C*D1**2*f**2*fdd*r*s + 16000*C*D1**2*f**2*fdd*r - 12000*C*D1**2*f**2*fdd*s**2 + 16000*C*D1**2*f**2*fdd*s - 8000*C*D1**2*f**2*fdd - 24000*C*D1**2*f*fd**2*r**2 - 48000*C*D1**2*f*fd**2*r*s + 32000*C*D1**2*f*fd**2*r - 24000*C*D1**2*f*fd**2*s**2 + 32000*C*D1**2*f*fd**2*s - 8000*C*D1**2*f*fd**2 + 24080*C*D1*Dd*f**3*r**2 + 48160*C*D1*Dd*f**3*r*s - 36120*C*D1*Dd*f**3*r + 24080*C*D1*Dd*f**3*s**2 - 36120*C*D1*Dd*f**3*s + 18060*C*D1*Dd*f**3 - 96000*C*D1*Dd*f**2*fd*r**2 - 192000*C*D1*Dd*f**2*fd*r*s + 136000*C*D1*Dd*f**2*fd*r - 96000*C*D1*Dd*f**2*fd*s**2 + 136000*C*D1*Dd*f**2*fd*s - 48000*C*D1*Dd*f**2*fd - 16000*C*D1*Ddd*f**3*r**2 - 32000*C*D1*Ddd*f**3*r*s + 24000*C*D1*Ddd*f**3*r - 16000*C*D1*Ddd*f**3*s**2 + 24000*C*D1*Ddd*f**3*s - 12000*C*D1*Ddd*f**3 - 48000*C*Dd**2*f**3*r**2 - 96000*C*Dd**2*f**3*r*s + 72000*C*Dd**2*f**3*r - 48000*C*Dd**2*f**3*s**2 + 72000*C*Dd**2*f**3*s - 24000*C*Dd**2*f**3 - 2640*D1**2*K*bdd1*f**2*r**2 - 5280*D1**2*K*bdd1*f**2*r*s + 5280*D1**2*K*bdd1*f**2*r - 2640*D1**2*K*bdd1*f**2*s**2 + 5280*D1**2*K*bdd1*f**2*s - 2640*D1**2*K*bdd1*f**2 - 396*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 1500*D1**2*bdd1*f**3*r**2 + 3000*D1**2*bdd1*f**3*r*s - 3000*D1**2*bdd1*f**3*r + 1500*D1**2*bdd1*f**3*s**2 - 3000*D1**2*bdd1*f**3*s + 1500*D1**2*bdd1*f**3 + 1716*D1**2*bdd1*f**2*r**2 + 3432*D1**2*bdd1*f**2*r*s - 3432*D1**2*bdd1*f**2*r + 1716*D1**2*bdd1*f**2*s**2 - 3432*D1**2*bdd1*f**2*s + 1716*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r**2 + 792*D1**2*bdd1*f*g2*r*s - 792*D1**2*bdd1*f*g2*r + 396*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 1500*D1**2*f**3*fd*r**2 - 3000*D1**2*f**3*fd*r*s + 2250*D1**2*f**3*fd*r - 1500*D1**2*f**3*fd*s**2 + 2250*D1**2*f**3*fd*s - 1125*D1**2*f**3*fd - 13248*D1**2*f**2*fd*r**2 - 26496*D1**2*f**2*fd*r*s + 17664*D1**2*f**2*fd*r - 13248*D1**2*f**2*fd*s**2 + 17664*D1**2*f**2*fd*s - 8832*D1**2*f**2*fd + 9000*D1**2*f**2*fdd*r**2 + 18000*D1**2*f**2*fdd*r*s - 12000*D1**2*f**2*fdd*r + 9000*D1**2*f**2*fdd*s**2 - 12000*D1**2*f**2*fdd*s + 6000*D1**2*f**2*fdd - 8580*D1**2*f**2*gd2*r**2 - 17160*D1**2*f**2*gd2*r*s + 17160*D1**2*f**2*gd2*r - 8580*D1**2*f**2*gd2*s**2 + 17160*D1**2*f**2*gd2*s - 8580*D1**2*f**2*gd2 + 5280*D1**2*f**2*gdd2*r**2 + 10560*D1**2*f**2*gdd2*r*s - 10560*D1**2*f**2*gdd2*r + 5280*D1**2*f**2*gdd2*s**2 - 10560*D1**2*f**2*gdd2*s + 5280*D1**2*f**2*gdd2 + 18000*D1**2*f*fd**2*r**2 + 36000*D1**2*f*fd**2*r*s - 24000*D1**2*f*fd**2*r + 18000*D1**2*f*fd**2*s**2 - 24000*D1**2*f*fd**2*s + 6000*D1**2*f*fd**2 - 17160*D1**2*f*fd*g2*r**2 - 34320*D1**2*f*fd*g2*r*s + 17160*D1**2*f*fd*g2*r - 17160*D1**2*f*fd*g2*s**2 + 17160*D1**2*f*fd*g2*s - 8580*D1**2*f*fd*g2 + 21120*D1**2*f*fd*gd2*r**2 + 42240*D1**2*f*fd*gd2*r*s - 31680*D1**2*f*fd*gd2*r + 21120*D1**2*f*fd*gd2*s**2 - 31680*D1**2*f*fd*gd2*s + 10560*D1**2*f*fd*gd2 + 10560*D1**2*f*fdd*g2*r**2 + 21120*D1**2*f*fdd*g2*r*s - 10560*D1**2*f*fdd*g2*r + 10560*D1**2*f*fdd*g2*s**2 - 10560*D1**2*f*fdd*g2*s + 5280*D1**2*f*fdd*g2 + 10560*D1**2*fd**2*g2*r**2 + 21120*D1**2*fd**2*g2*r*s - 10560*D1**2*fd**2*g2*r + 10560*D1**2*fd**2*g2*s**2 - 10560*D1**2*fd**2*g2*s - 1500*D1*Dd*f**4*r**2 - 3000*D1*Dd*f**4*r*s + 2250*D1*Dd*f**4*r - 1500*D1*Dd*f**4*s**2 + 2250*D1*Dd*f**4*s - 1125*D1*Dd*f**4 - 17664*D1*Dd*f**3*r**2 - 35328*D1*Dd*f**3*r*s + 26496*D1*Dd*f**3*r - 17664*D1*Dd*f**3*s**2 + 26496*D1*Dd*f**3*s - 13248*D1*Dd*f**3 + 72000*D1*Dd*f**2*fd*r**2 + 144000*D1*Dd*f**2*fd*r*s - 102000*D1*Dd*f**2*fd*r + 72000*D1*Dd*f**2*fd*s**2 - 102000*D1*Dd*f**2*fd*s + 36000*D1*Dd*f**2*fd - 34320*D1*Dd*f**2*g2*r**2 - 68640*D1*Dd*f**2*g2*r*s + 51480*D1*Dd*f**2*g2*r - 34320*D1*Dd*f**2*g2*s**2 + 51480*D1*Dd*f**2*g2*s - 25740*D1*Dd*f**2*g2 + 42240*D1*Dd*f**2*gd2*r**2 + 84480*D1*Dd*f**2*gd2*r*s - 73920*D1*Dd*f**2*gd2*r + 42240*D1*Dd*f**2*gd2*s**2 - 73920*D1*Dd*f**2*gd2*s + 31680*D1*Dd*f**2*gd2 + 84480*D1*Dd*f*fd*g2*r**2 + 168960*D1*Dd*f*fd*g2*r*s - 105600*D1*Dd*f*fd*g2*r + 84480*D1*Dd*f*fd*g2*s**2 - 105600*D1*Dd*f*fd*g2*s + 31680*D1*Dd*f*fd*g2 + 12000*D1*Ddd*f**3*r**2 + 24000*D1*Ddd*f**3*r*s - 18000*D1*Ddd*f**3*r + 12000*D1*Ddd*f**3*s**2 - 18000*D1*Ddd*f**3*s + 9000*D1*Ddd*f**3 + 21120*D1*Ddd*f**2*g2*r**2 + 42240*D1*Ddd*f**2*g2*r*s - 31680*D1*Ddd*f**2*g2*r + 21120*D1*Ddd*f**2*g2*s**2 - 31680*D1*Ddd*f**2*g2*s + 15840*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(390*f**3*(r + s - 1) - f**2*(132*C*(r + s - 1) + 500*fd*(3*r + 3*s - 2) + (715*K - 473)*(r + s - 1)) + 44*f*(fd*(3*C + 20*K - 13)*(2*r + 2*s - 1) + (3*g2 - 3*gd2)*(r + s - 1)) - 132*fd*g2*(r + s)) - 4*Dd*f*(125*f**2 - 11*f*(3*C + 20*K - 13) + 33*g2)*(4*r + 4*s - 3))*(r + s - 1) + 36000*Dd**2*f**3*r**2 + 72000*Dd**2*f**3*r*s - 54000*Dd**2*f**3*r + 36000*Dd**2*f**3*s**2 - 54000*Dd**2*f**3*s + 18000*Dd**2*f**3 + 63360*Dd**2*f**2*g2*r**2 + 126720*Dd**2*f**2*g2*r*s - 95040*Dd**2*f**2*g2*r + 63360*Dd**2*f**2*g2*s**2 - 95040*Dd**2*f**2*g2*s + 31680*Dd**2*f**2*g2 + 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*b1*(264*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s - 264*C*D1**2*f*fd*r + 264*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s + 132*C*D1**2*f*fd - 132*C*D1**2*f*fdd*r**2 - 264*C*D1**2*f*fdd*r*s + 132*C*D1**2*f*fdd*r - 132*C*D1**2*f*fdd*s**2 + 132*C*D1**2*f*fdd*s - 66*C*D1**2*f*fdd - 132*C*D1**2*fd**2*r**2 - 264*C*D1**2*fd**2*r*s + 132*C*D1**2*fd**2*r - 132*C*D1**2*fd**2*s**2 + 132*C*D1**2*fd**2*s + 528*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 792*C*D1*Dd*f**2*r + 528*C*D1*Dd*f**2*s**2 - 792*C*D1*Dd*f**2*s + 396*C*D1*Dd*f**2 - 1056*C*D1*Dd*f*fd*r**2 - 2112*C*D1*Dd*f*fd*r*s + 1320*C*D1*Dd*f*fd*r - 1056*C*D1*Dd*f*fd*s**2 + 1320*C*D1*Dd*f*fd*s - 396*C*D1*Dd*f*fd - 264*C*D1*Ddd*f**2*r**2 - 528*C*D1*Ddd*f**2*r*s + 396*C*D1*Ddd*f**2*r - 264*C*D1*Ddd*f**2*s**2 + 396*C*D1*Ddd*f**2*s - 198*C*D1*Ddd*f**2 - 792*C*Dd**2*f**2*r**2 - 1584*C*Dd**2*f**2*r*s + 1188*C*Dd**2*f**2*r - 792*C*Dd**2*f**2*s**2 + 1188*C*Dd**2*f**2*s - 396*C*Dd**2*f**2 + 1430*D1**2*K*f*fd*r**2 + 2860*D1**2*K*f*fd*r*s - 1430*D1**2*K*f*fd*r + 1430*D1**2*K*f*fd*s**2 - 1430*D1**2*K*f*fd*s + 715*D1**2*K*f*fd - 880*D1**2*K*f*fdd*r**2 - 1760*D1**2*K*f*fdd*r*s + 880*D1**2*K*f*fdd*r - 880*D1**2*K*f*fdd*s**2 + 880*D1**2*K*f*fdd*s - 440*D1**2*K*f*fdd - 880*D1**2*K*fd**2*r**2 - 1760*D1**2*K*fd**2*r*s + 880*D1**2*K*fd**2*r - 880*D1**2*K*fd**2*s**2 + 880*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 1170*D1**2*f**2*fd*r**2 - 2340*D1**2*f**2*fd*r*s + 1560*D1**2*f**2*fd*r - 1170*D1**2*f**2*fd*s**2 + 1560*D1**2*f**2*fd*s - 780*D1**2*f**2*fd + 750*D1**2*f**2*fdd*r**2 + 1500*D1**2*f**2*fdd*r*s - 1000*D1**2*f**2*fdd*r + 750*D1**2*f**2*fdd*s**2 - 1000*D1**2*f**2*fdd*s + 500*D1**2*f**2*fdd + 1500*D1**2*f*fd**2*r**2 + 3000*D1**2*f*fd**2*r*s - 2000*D1**2*f*fd**2*r + 1500*D1**2*f*fd**2*s**2 - 2000*D1**2*f*fd**2*s + 500*D1**2*f*fd**2 - 946*D1**2*f*fd*r**2 - 1892*D1**2*f*fd*r*s + 946*D1**2*f*fd*r - 946*D1**2*f*fd*s**2 + 946*D1**2*f*fd*s - 473*D1**2*f*fd + 572*D1**2*f*fdd*r**2 + 1144*D1**2*f*fdd*r*s - 572*D1**2*f*fdd*r + 572*D1**2*f*fdd*s**2 - 572*D1**2*f*fdd*s + 286*D1**2*f*fdd - 132*D1**2*f*gd2*r**2 - 264*D1**2*f*gd2*r*s + 264*D1**2*f*gd2*r - 132*D1**2*f*gd2*s**2 + 264*D1**2*f*gd2*s - 132*D1**2*f*gd2 + 66*D1**2*f*gdd2*r**2 + 132*D1**2*f*gdd2*r*s - 132*D1**2*f*gdd2*r + 66*D1**2*f*gdd2*s**2 - 132*D1**2*f*gdd2*s + 66*D1**2*f*gdd2 + 572*D1**2*fd**2*r**2 + 1144*D1**2*fd**2*r*s - 572*D1**2*fd**2*r + 572*D1**2*fd**2*s**2 - 572*D1**2*fd**2*s - 132*D1**2*fd*g2*r**2 - 264*D1**2*fd*g2*r*s - 132*D1**2*fd*g2*s**2 + 132*D1**2*fd*gd2*r**2 + 264*D1**2*fd*gd2*r*s - 132*D1**2*fd*gd2*r + 132*D1**2*fd*gd2*s**2 - 132*D1**2*fd*gd2*s + 66*D1**2*fdd*g2*r**2 + 132*D1**2*fdd*g2*r*s + 66*D1**2*fdd*g2*s**2 + 2860*D1*Dd*K*f**2*r**2 + 5720*D1*Dd*K*f**2*r*s - 4290*D1*Dd*K*f**2*r + 2860*D1*Dd*K*f**2*s**2 - 4290*D1*Dd*K*f**2*s + 2145*D1*Dd*K*f**2 - 7040*D1*Dd*K*f*fd*r**2 - 14080*D1*Dd*K*f*fd*r*s + 8800*D1*Dd*K*f*fd*r - 7040*D1*Dd*K*f*fd*s**2 + 8800*D1*Dd*K*f*fd*s - 2640*D1*Dd*K*f*fd - 1560*D1*Dd*f**3*r**2 - 3120*D1*Dd*f**3*r*s + 2340*D1*Dd*f**3*r - 1560*D1*Dd*f**3*s**2 + 2340*D1*Dd*f**3*s - 1170*D1*Dd*f**3 + 6000*D1*Dd*f**2*fd*r**2 + 12000*D1*Dd*f**2*fd*r*s - 8500*D1*Dd*f**2*fd*r + 6000*D1*Dd*f**2*fd*s**2 - 8500*D1*Dd*f**2*fd*s + 3000*D1*Dd*f**2*fd - 1892*D1*Dd*f**2*r**2 - 3784*D1*Dd*f**2*r*s + 2838*D1*Dd*f**2*r - 1892*D1*Dd*f**2*s**2 + 2838*D1*Dd*f**2*s - 1419*D1*Dd*f**2 + 4576*D1*Dd*f*fd*r**2 + 9152*D1*Dd*f*fd*r*s - 5720*D1*Dd*f*fd*r + 4576*D1*Dd*f*fd*s**2 - 5720*D1*Dd*f*fd*s + 1716*D1*Dd*f*fd - 528*D1*Dd*f*g2*r**2 - 1056*D1*Dd*f*g2*r*s + 792*D1*Dd*f*g2*r - 528*D1*Dd*f*g2*s**2 + 792*D1*Dd*f*g2*s - 396*D1*Dd*f*g2 + 528*D1*Dd*f*gd2*r**2 + 1056*D1*Dd*f*gd2*r*s - 924*D1*Dd*f*gd2*r + 528*D1*Dd*f*gd2*s**2 - 924*D1*Dd*f*gd2*s + 396*D1*Dd*f*gd2 + 528*D1*Dd*fd*g2*r**2 + 1056*D1*Dd*fd*g2*r*s - 396*D1*Dd*fd*g2*r + 528*D1*Dd*fd*g2*s**2 - 396*D1*Dd*fd*g2*s - 1760*D1*Ddd*K*f**2*r**2 - 3520*D1*Ddd*K*f**2*r*s + 2640*D1*Ddd*K*f**2*r - 1760*D1*Ddd*K*f**2*s**2 + 2640*D1*Ddd*K*f**2*s - 1320*D1*Ddd*K*f**2 + 1000*D1*Ddd*f**3*r**2 + 2000*D1*Ddd*f**3*r*s - 1500*D1*Ddd*f**3*r + 1000*D1*Ddd*f**3*s**2 - 1500*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 + 1144*D1*Ddd*f**2*r**2 + 2288*D1*Ddd*f**2*r*s - 1716*D1*Ddd*f**2*r + 1144*D1*Ddd*f**2*s**2 - 1716*D1*Ddd*f**2*s + 858*D1*Ddd*f**2 + 264*D1*Ddd*f*g2*r**2 + 528*D1*Ddd*f*g2*r*s - 396*D1*Ddd*f*g2*r + 264*D1*Ddd*f*g2*s**2 - 396*D1*Ddd*f*g2*s + 198*D1*Ddd*f*g2 + 132*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 5280*Dd**2*K*f**2*r**2 - 10560*Dd**2*K*f**2*r*s + 7920*Dd**2*K*f**2*r - 5280*Dd**2*K*f**2*s**2 + 7920*Dd**2*K*f**2*s - 2640*Dd**2*K*f**2 + 3000*Dd**2*f**3*r**2 + 6000*Dd**2*f**3*r*s - 4500*Dd**2*f**3*r + 3000*Dd**2*f**3*s**2 - 4500*Dd**2*f**3*s + 1500*Dd**2*f**3 + 3432*Dd**2*f**2*r**2 + 6864*Dd**2*f**2*r*s - 5148*Dd**2*f**2*r + 3432*Dd**2*f**2*s**2 - 5148*Dd**2*f**2*s + 1716*Dd**2*f**2 + 792*Dd**2*f*g2*r**2 + 1584*Dd**2*f*g2*r*s - 1188*Dd**2*f*g2*r + 792*Dd**2*f*g2*s**2 - 1188*Dd**2*f*g2*s + 396*Dd**2*f*g2))/(1386*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**4*k1**2*k2**4*(880*C*D1**2*bdd1*f**2*r**2 + 1760*C*D1**2*bdd1*f**2*r*s - 1760*C*D1**2*bdd1*f**2*r + 880*C*D1**2*bdd1*f**2*s**2 - 1760*C*D1**2*bdd1*f**2*s + 880*C*D1**2*bdd1*f**2 - 390*C*D1**2*f**2*fd*r**2 - 780*C*D1**2*f**2*fd*r*s + 520*C*D1**2*f**2*fd*r - 390*C*D1**2*f**2*fd*s**2 + 520*C*D1**2*f**2*fd*s - 260*C*D1**2*f**2*fd + 1680*C*D1**2*f**2*fdd*r**2 + 3360*C*D1**2*f**2*fdd*r*s - 2240*C*D1**2*f**2*fdd*r + 1680*C*D1**2*f**2*fdd*s**2 - 2240*C*D1**2*f**2*fdd*s + 1120*C*D1**2*f**2*fdd + 3360*C*D1**2*f*fd**2*r**2 + 6720*C*D1**2*f*fd**2*r*s - 4480*C*D1**2*f*fd**2*r + 3360*C*D1**2*f*fd**2*s**2 - 4480*C*D1**2*f*fd**2*s + 1120*C*D1**2*f*fd**2 - 520*C*D1*Dd*f**3*r**2 - 1040*C*D1*Dd*f**3*r*s + 780*C*D1*Dd*f**3*r - 520*C*D1*Dd*f**3*s**2 + 780*C*D1*Dd*f**3*s - 390*C*D1*Dd*f**3 + 13440*C*D1*Dd*f**2*fd*r**2 + 26880*C*D1*Dd*f**2*fd*r*s - 19040*C*D1*Dd*f**2*fd*r + 13440*C*D1*Dd*f**2*fd*s**2 - 19040*C*D1*Dd*f**2*fd*s + 6720*C*D1*Dd*f**2*fd + 2240*C*D1*Ddd*f**3*r**2 + 4480*C*D1*Ddd*f**3*r*s - 3360*C*D1*Ddd*f**3*r + 2240*C*D1*Ddd*f**3*s**2 - 3360*C*D1*Ddd*f**3*s + 1680*C*D1*Ddd*f**3 + 6720*C*Dd**2*f**3*r**2 + 13440*C*Dd**2*f**3*r*s - 10080*C*Dd**2*f**3*r + 6720*C*Dd**2*f**3*s**2 - 10080*C*Dd**2*f**3*s + 3360*C*Dd**2*f**3 + 330*D1**2*K*bdd1*f**2*r**2 + 660*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*r + 330*D1**2*K*bdd1*f**2*s**2 - 660*D1**2*K*bdd1*f**2*s + 330*D1**2*K*bdd1*f**2 - 22*D1**2*bd1**2*f*(-48*K + 25*f + 24)*(r + s - 1)**2 - 660*D1**2*bdd1*f**2*r**2 - 1320*D1**2*bdd1*f**2*r*s + 1320*D1**2*bdd1*f**2*r - 660*D1**2*bdd1*f**2*s**2 + 1320*D1**2*bdd1*f**2*s - 660*D1**2*bdd1*f**2 - 1056*D1**2*bdd1*f*g2*r**2 - 2112*D1**2*bdd1*f*g2*r*s + 2112*D1**2*bdd1*f*g2*r - 1056*D1**2*bdd1*f*g2*s**2 + 2112*D1**2*bdd1*f*g2*s - 1056*D1**2*bdd1*f*g2 - 135*D1**2*f**2*fd*r**2 - 270*D1**2*f**2*fd*r*s + 180*D1**2*f**2*fd*r - 135*D1**2*f**2*fd*s**2 + 180*D1**2*f**2*fd*s - 90*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 - 1680*D1**2*f**2*fdd*r*s + 1120*D1**2*f**2*fdd*r - 840*D1**2*f**2*fdd*s**2 + 1120*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd + 132*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*r + 132*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gd2 - 660*D1**2*f**2*gdd2*r**2 - 1320*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*r - 660*D1**2*f**2*gdd2*s**2 + 1320*D1**2*f**2*gdd2*s - 660*D1**2*f**2*gdd2 - 1680*D1**2*f*fd**2*r**2 - 3360*D1**2*f*fd**2*r*s + 2240*D1**2*f*fd**2*r - 1680*D1**2*f*fd**2*s**2 + 2240*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 + 264*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r**2 - 5280*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r - 2640*D1**2*f*fd*gd2*s**2 + 3960*D1**2*f*fd*gd2*s - 1320*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r**2 - 2640*D1**2*f*fdd*g2*r*s + 1320*D1**2*f*fdd*g2*r - 1320*D1**2*f*fdd*g2*s**2 + 1320*D1**2*f*fdd*g2*s - 660*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r**2 - 2640*D1**2*fd**2*g2*r*s + 1320*D1**2*fd**2*g2*r - 1320*D1**2*fd**2*g2*s**2 + 1320*D1**2*fd**2*g2*s - 180*D1*Dd*f**3*r**2 - 360*D1*Dd*f**3*r*s + 270*D1*Dd*f**3*r - 180*D1*Dd*f**3*s**2 + 270*D1*Dd*f**3*s - 135*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 - 13440*D1*Dd*f**2*fd*r*s + 9520*D1*Dd*f**2*fd*r - 6720*D1*Dd*f**2*fd*s**2 + 9520*D1*Dd*f**2*fd*s - 3360*D1*Dd*f**2*fd + 528*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 396*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r**2 - 10560*D1*Dd*f**2*gd2*r*s + 9240*D1*Dd*f**2*gd2*r - 5280*D1*Dd*f**2*gd2*s**2 + 9240*D1*Dd*f**2*gd2*s - 3960*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r**2 - 21120*D1*Dd*f*fd*g2*r*s + 13200*D1*Dd*f*fd*g2*r - 10560*D1*Dd*f*fd*g2*s**2 + 13200*D1*Dd*f*fd*g2*s - 3960*D1*Dd*f*fd*g2 - 1120*D1*Ddd*f**3*r**2 - 2240*D1*Ddd*f**3*r*s + 1680*D1*Ddd*f**3*r - 1120*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 840*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r**2 - 5280*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r - 2640*D1*Ddd*f**2*g2*s**2 + 3960*D1*Ddd*f**2*g2*s - 1980*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(50*C + 3*K - 30)*(r + s - 1) - 10*f*fd*(8*C + 3*K - 6)*(2*r + 2*s - 1) - f*(61*g2 - 96*gd2)*(r + s - 1) + 96*fd*g2*(r + s)) - 2*Dd*f*(5*f*(8*C + 3*K - 6) - 48*g2)*(4*r + 4*s - 3))*(r + s - 1) - 3360*Dd**2*f**3*r**2 - 6720*Dd**2*f**3*r*s + 5040*Dd**2*f**3*r - 3360*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 1680*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r**2 - 15840*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r - 7920*Dd**2*f**2*g2*s**2 + 11880*Dd**2*f**2*g2*s - 3960*Dd**2*f**2*g2 + 11*b1**2*(D1**2*(f*(38*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + fd*(61*K - 27)*(r + s) - 24*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(38*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(50*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (61*K - 27)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 48*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-48*K + 25*f + 24)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-48*K + 25*f + 24)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*(-100*C*D1**2*f*fd*r**2 - 200*C*D1**2*f*fd*r*s + 100*C*D1**2*f*fd*r - 100*C*D1**2*f*fd*s**2 + 100*C*D1**2*f*fd*s - 50*C*D1**2*f*fd + 80*C*D1**2*f*fdd*r**2 + 160*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 - 80*C*D1**2*f*fdd*s + 40*C*D1**2*f*fdd + 80*C*D1**2*fd**2*r**2 + 160*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 - 80*C*D1**2*fd**2*s - 200*C*D1*Dd*f**2*r**2 - 400*C*D1*Dd*f**2*r*s + 300*C*D1*Dd*f**2*r - 200*C*D1*Dd*f**2*s**2 + 300*C*D1*Dd*f**2*s - 150*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*r**2 + 1280*C*D1*Dd*f*fd*r*s - 800*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 800*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r**2 + 320*C*D1*Ddd*f**2*r*s - 240*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 240*C*D1*Ddd*f**2*s + 120*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r**2 + 960*C*Dd**2*f**2*r*s - 720*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 720*C*Dd**2*f**2*s + 240*C*Dd**2*f**2 - 6*D1**2*K*f*fd*r**2 - 12*D1**2*K*f*fd*r*s + 6*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r**2 + 60*D1**2*K*f*fdd*r*s - 30*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r**2 + 60*D1**2*K*fd**2*r*s - 30*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(-48*K + 25*f + 24)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 60*D1**2*f*fd*r**2 + 120*D1**2*f*fd*r*s - 60*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 60*D1**2*f*fd*s + 30*D1**2*f*fd - 60*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 60*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s - 30*D1**2*f*fdd + 61*D1**2*f*gd2*r**2 + 122*D1**2*f*gd2*r*s - 122*D1**2*f*gd2*r + 61*D1**2*f*gd2*s**2 - 122*D1**2*f*gd2*s + 61*D1**2*f*gd2 - 48*D1**2*f*gdd2*r**2 - 96*D1**2*f*gdd2*r*s + 96*D1**2*f*gdd2*r - 48*D1**2*f*gdd2*s**2 + 96*D1**2*f*gdd2*s - 48*D1**2*f*gdd2 - 60*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 60*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s + 61*D1**2*fd*g2*r**2 + 122*D1**2*fd*g2*r*s + 61*D1**2*fd*g2*s**2 - 96*D1**2*fd*gd2*r**2 - 192*D1**2*fd*gd2*r*s + 96*D1**2*fd*gd2*r - 96*D1**2*fd*gd2*s**2 + 96*D1**2*fd*gd2*s - 48*D1**2*fdd*g2*r**2 - 96*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*s**2 - 12*D1*Dd*K*f**2*r**2 - 24*D1*Dd*K*f**2*r*s + 18*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 18*D1*Dd*K*f**2*s - 9*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r**2 + 480*D1*Dd*K*f*fd*r*s - 300*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 300*D1*Dd*K*f*fd*s + 90*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 120*D1*Dd*f**2*r**2 + 240*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 180*D1*Dd*f**2*s + 90*D1*Dd*f**2 - 480*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 600*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 600*D1*Dd*f*fd*s - 180*D1*Dd*f*fd + 244*D1*Dd*f*g2*r**2 + 488*D1*Dd*f*g2*r*s - 366*D1*Dd*f*g2*r + 244*D1*Dd*f*g2*s**2 - 366*D1*Dd*f*g2*s + 183*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r**2 - 768*D1*Dd*f*gd2*r*s + 672*D1*Dd*f*gd2*r - 384*D1*Dd*f*gd2*s**2 + 672*D1*Dd*f*gd2*s - 288*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r**2 - 768*D1*Dd*fd*g2*r*s + 288*D1*Dd*fd*g2*r - 384*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r**2 + 120*D1*Ddd*K*f**2*r*s - 90*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 90*D1*Ddd*K*f**2*s + 45*D1*Ddd*K*f**2 - 120*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 90*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r**2 - 384*D1*Ddd*f*g2*r*s + 288*D1*Ddd*f*g2*r - 192*D1*Ddd*f*g2*s**2 + 288*D1*Ddd*f*g2*s - 144*D1*Ddd*f*g2 + D1*bd1*(D1*(38*f**2*(r + s - 1) - 50*f*fd*(2*r + 2*s - 1) - f*(61*K - 27)*(r + s - 1) + 48*fd*(2*K - 1)*(r + s)) - 2*Dd*f*(-48*K + 25*f + 24)*(4*r + 4*s - 3))*(r + s - 1) + 180*Dd**2*K*f**2*r**2 + 360*Dd**2*K*f**2*r*s - 270*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 270*Dd**2*K*f**2*s + 90*Dd**2*K*f**2 - 360*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 540*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 180*Dd**2*f**2 - 576*Dd**2*f*g2*r**2 - 1152*Dd**2*f*g2*r*s + 864*Dd**2*f*g2*r - 576*Dd**2*f*g2*s**2 + 864*Dd**2*f*g2*s - 288*Dd**2*f*g2))/(231*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**4*k1**2*k2**2*st**2*(396*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 6*D1*bd1*(D1*(5*f**3*(103*r**2 + 2*r*(103*s - 78) + 103*s**2 - 156*s + 78) + f**2*(-125*fd*(15*r**2 + r*(30*s - 23) + 15*s**2 - 23*s + 8) + 22*r**2*(6*C + 11) + 44*r*(s*(6*C + 11) - 17) + 22*s**2*(6*C + 11) - 748*s + 374) - 44*f*(2*fd*(r + s - 1)*(r*(3*C + 7) + s*(3*C + 7) - 5) - (3*r + 3*s)*(-g2*(r + s) + gd2*(r + s - 1))) + 132*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(125*f**2*(5*r + 5*s - 4) + 44*f*(3*C*s + r*(3*C + 7) + 7*s - 10) - 132*g2*(r + s))) - 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 3*b1*(528*C*D1**2*f*fd*r**2 + 1056*C*D1**2*f*fd*r*s - 1056*C*D1**2*f*fd*r + 528*C*D1**2*f*fd*s**2 - 1056*C*D1**2*f*fd*s + 528*C*D1**2*f*fd - 264*C*D1**2*f*fdd*r**2 - 528*C*D1**2*f*fdd*r*s + 528*C*D1**2*f*fdd*r - 264*C*D1**2*f*fdd*s**2 + 528*C*D1**2*f*fdd*s - 264*C*D1**2*f*fdd - 264*C*D1**2*fd**2*r**2 - 528*C*D1**2*fd**2*r*s + 528*C*D1**2*fd**2*r - 264*C*D1**2*fd**2*s**2 + 528*C*D1**2*fd**2*s - 264*C*D1**2*fd**2 + 1056*C*D1*Dd*f**2*r**2 + 2112*C*D1*Dd*f**2*r*s - 1584*C*D1*Dd*f**2*r + 1056*C*D1*Dd*f**2*s**2 - 1584*C*D1*Dd*f**2*s + 792*C*D1*Dd*f**2 - 2112*C*D1*Dd*f*fd*r**2 - 4224*C*D1*Dd*f*fd*r*s + 3696*C*D1*Dd*f*fd*r - 2112*C*D1*Dd*f*fd*s**2 + 3696*C*D1*Dd*f*fd*s - 1584*C*D1*Dd*f*fd - 528*C*D1*Ddd*f**2*r**2 - 1056*C*D1*Ddd*f**2*r*s + 792*C*D1*Ddd*f**2*r - 528*C*D1*Ddd*f**2*s**2 + 792*C*D1*Ddd*f**2*s - 396*C*D1*Ddd*f**2 - 1584*C*Dd**2*f**2*r**2 - 3168*C*Dd**2*f**2*r*s + 2376*C*Dd**2*f**2*r - 1584*C*Dd**2*f**2*s**2 + 2376*C*Dd**2*f**2*s - 792*C*Dd**2*f**2 - 66*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 3090*D1**2*f**2*fd*r**2 + 6180*D1**2*f**2*fd*r*s - 4620*D1**2*f**2*fd*r + 3090*D1**2*f**2*fd*s**2 - 4620*D1**2*f**2*fd*s + 2310*D1**2*f**2*fd - 1875*D1**2*f**2*fdd*r**2 - 3750*D1**2*f**2*fdd*r*s + 2750*D1**2*f**2*fdd*r - 1875*D1**2*f**2*fdd*s**2 + 2750*D1**2*f**2*fdd*s - 1375*D1**2*f**2*fdd - 3750*D1**2*f*fd**2*r**2 - 7500*D1**2*f*fd**2*r*s + 5500*D1**2*f*fd**2*r - 3750*D1**2*f*fd**2*s**2 + 5500*D1**2*f*fd**2*s - 1750*D1**2*f*fd**2 + 968*D1**2*f*fd*r**2 + 1936*D1**2*f*fd*r*s - 440*D1**2*f*fd*r + 968*D1**2*f*fd*s**2 - 440*D1**2*f*fd*s + 220*D1**2*f*fd - 616*D1**2*f*fdd*r**2 - 1232*D1**2*f*fdd*r*s + 352*D1**2*f*fdd*r - 616*D1**2*f*fdd*s**2 + 352*D1**2*f*fdd*s - 176*D1**2*f*fdd - 264*D1**2*f*gd2*r**2 - 528*D1**2*f*gd2*r*s + 528*D1**2*f*gd2*r - 264*D1**2*f*gd2*s**2 + 528*D1**2*f*gd2*s - 264*D1**2*f*gd2 + 132*D1**2*f*gdd2*r**2 + 264*D1**2*f*gdd2*r*s - 264*D1**2*f*gdd2*r + 132*D1**2*f*gdd2*s**2 - 264*D1**2*f*gdd2*s + 132*D1**2*f*gdd2 - 616*D1**2*fd**2*r**2 - 1232*D1**2*fd**2*r*s + 352*D1**2*fd**2*r - 616*D1**2*fd**2*s**2 + 352*D1**2*fd**2*s + 264*D1**2*fd**2 - 264*D1**2*fd*g2*r**2 - 528*D1**2*fd*g2*r*s + 528*D1**2*fd*g2*r - 264*D1**2*fd*g2*s**2 + 528*D1**2*fd*g2*s - 264*D1**2*fd*g2 + 264*D1**2*fd*gd2*r**2 + 528*D1**2*fd*gd2*r*s - 528*D1**2*fd*gd2*r + 264*D1**2*fd*gd2*s**2 - 528*D1**2*fd*gd2*s + 264*D1**2*fd*gd2 + 132*D1**2*fdd*g2*r**2 + 264*D1**2*fdd*g2*r*s - 264*D1**2*fdd*g2*r + 132*D1**2*fdd*g2*s**2 - 264*D1**2*fdd*g2*s + 132*D1**2*fdd*g2 + 4120*D1*Dd*f**3*r**2 + 8240*D1*Dd*f**3*r*s - 6180*D1*Dd*f**3*r + 4120*D1*Dd*f**3*s**2 - 6180*D1*Dd*f**3*s + 3090*D1*Dd*f**3 - 15000*D1*Dd*f**2*fd*r**2 - 30000*D1*Dd*f**2*fd*r*s + 22250*D1*Dd*f**2*fd*r - 15000*D1*Dd*f**2*fd*s**2 + 22250*D1*Dd*f**2*fd*s - 8250*D1*Dd*f**2*fd + 1936*D1*Dd*f**2*r**2 + 3872*D1*Dd*f**2*r*s - 2904*D1*Dd*f**2*r + 1936*D1*Dd*f**2*s**2 - 2904*D1*Dd*f**2*s + 1452*D1*Dd*f**2 - 4928*D1*Dd*f*fd*r**2 - 9856*D1*Dd*f*fd*r*s + 5104*D1*Dd*f*fd*r - 4928*D1*Dd*f*fd*s**2 + 5104*D1*Dd*f*fd*s - 1056*D1*Dd*f*fd - 1056*D1*Dd*f*g2*r**2 - 2112*D1*Dd*f*g2*r*s + 1584*D1*Dd*f*g2*r - 1056*D1*Dd*f*g2*s**2 + 1584*D1*Dd*f*g2*s - 792*D1*Dd*f*g2 + 1056*D1*Dd*f*gd2*r**2 + 2112*D1*Dd*f*gd2*r*s - 1848*D1*Dd*f*gd2*r + 1056*D1*Dd*f*gd2*s**2 - 1848*D1*Dd*f*gd2*s + 792*D1*Dd*f*gd2 + 1056*D1*Dd*fd*g2*r**2 + 2112*D1*Dd*fd*g2*r*s - 1848*D1*Dd*fd*g2*r + 1056*D1*Dd*fd*g2*s**2 - 1848*D1*Dd*fd*g2*s + 792*D1*Dd*fd*g2 - 2500*D1*Ddd*f**3*r**2 - 5000*D1*Ddd*f**3*r*s + 3750*D1*Ddd*f**3*r - 2500*D1*Ddd*f**3*s**2 + 3750*D1*Ddd*f**3*s - 1875*D1*Ddd*f**3 - 1232*D1*Ddd*f**2*r**2 - 2464*D1*Ddd*f**2*r*s + 1848*D1*Ddd*f**2*r - 1232*D1*Ddd*f**2*s**2 + 1848*D1*Ddd*f**2*s - 924*D1*Ddd*f**2 + 528*D1*Ddd*f*g2*r**2 + 1056*D1*Ddd*f*g2*r*s - 792*D1*Ddd*f*g2*r + 528*D1*Ddd*f*g2*s**2 - 792*D1*Ddd*f*g2*s + 396*D1*Ddd*f*g2 + 132*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 7500*Dd**2*f**3*r**2 - 15000*Dd**2*f**3*r*s + 11250*Dd**2*f**3*r - 7500*Dd**2*f**3*s**2 + 11250*Dd**2*f**3*s - 3750*Dd**2*f**3 - 3696*Dd**2*f**2*r**2 - 7392*Dd**2*f**2*r*s + 5544*Dd**2*f**2*r - 3696*Dd**2*f**2*s**2 + 5544*Dd**2*f**2*s - 1848*Dd**2*f**2 + 1584*Dd**2*f*g2*r**2 + 3168*Dd**2*f*g2*r*s - 2376*Dd**2*f*g2*r + 1584*Dd**2*f*g2*s**2 - 2376*Dd**2*f*g2*s + 792*Dd**2*f*g2) + f*(3*D1**2*bdd1*(125*f**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 4) + 44*f*(r**2*(3*C + 7) + 2*r*(s*(3*C + 7) - 10) + s**2*(3*C + 7) - 20*s + 10) - 132*g2*(r + s)**2) - 4*D1**2*(f*(401*fd - 250*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 500*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 4*D1*f*(Dd*(401*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 500*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 250*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6000*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(1386*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**4*k1**2*k2**2*(-440*C*D1**2*bdd1*f**2*r**2 - 880*C*D1**2*bdd1*f**2*r*s - 440*C*D1**2*bdd1*f**2*s**2 - 1710*C*D1**2*f**2*fd*r**2 - 3420*C*D1**2*f**2*fd*r*s + 2280*C*D1**2*f**2*fd*r - 1710*C*D1**2*f**2*fd*s**2 + 2280*C*D1**2*f**2*fd*s - 1140*C*D1**2*f**2*fd + 1680*C*D1**2*f**2*fdd*r**2 + 3360*C*D1**2*f**2*fdd*r*s - 2240*C*D1**2*f**2*fdd*r + 1680*C*D1**2*f**2*fdd*s**2 - 2240*C*D1**2*f**2*fdd*s + 1120*C*D1**2*f**2*fdd + 3360*C*D1**2*f*fd**2*r**2 + 6720*C*D1**2*f*fd**2*r*s - 4480*C*D1**2*f*fd**2*r + 3360*C*D1**2*f*fd**2*s**2 - 4480*C*D1**2*f*fd**2*s + 1120*C*D1**2*f*fd**2 - 2280*C*D1*Dd*f**3*r**2 - 4560*C*D1*Dd*f**3*r*s + 3420*C*D1*Dd*f**3*r - 2280*C*D1*Dd*f**3*s**2 + 3420*C*D1*Dd*f**3*s - 1710*C*D1*Dd*f**3 + 13440*C*D1*Dd*f**2*fd*r**2 + 26880*C*D1*Dd*f**2*fd*r*s - 19040*C*D1*Dd*f**2*fd*r + 13440*C*D1*Dd*f**2*fd*s**2 - 19040*C*D1*Dd*f**2*fd*s + 6720*C*D1*Dd*f**2*fd + 2240*C*D1*Ddd*f**3*r**2 + 4480*C*D1*Ddd*f**3*r*s - 3360*C*D1*Ddd*f**3*r + 2240*C*D1*Ddd*f**3*s**2 - 3360*C*D1*Ddd*f**3*s + 1680*C*D1*Ddd*f**3 + 6720*C*Dd**2*f**3*r**2 + 13440*C*Dd**2*f**3*r*s - 10080*C*Dd**2*f**3*r + 6720*C*Dd**2*f**3*s**2 - 10080*C*Dd**2*f**3*s + 3360*C*Dd**2*f**3 + 330*D1**2*K*bdd1*f**2*r**2 + 660*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*r + 330*D1**2*K*bdd1*f**2*s**2 - 660*D1**2*K*bdd1*f**2*s + 330*D1**2*K*bdd1*f**2 - 660*D1**2*b2*f*fd*r**2 - 1320*D1**2*b2*f*fd*r*s + 660*D1**2*b2*f*fd*r - 660*D1**2*b2*f*fd*s**2 + 660*D1**2*b2*f*fd*s - 330*D1**2*b2*f*fd + 660*D1**2*b2*f*fdd*r**2 + 1320*D1**2*b2*f*fdd*r*s - 660*D1**2*b2*f*fdd*r + 660*D1**2*b2*f*fdd*s**2 - 660*D1**2*b2*f*fdd*s + 330*D1**2*b2*f*fdd + 660*D1**2*b2*fd**2*r**2 + 1320*D1**2*b2*fd**2*r*s - 660*D1**2*b2*fd**2*r + 660*D1**2*b2*fd**2*s**2 - 660*D1**2*b2*fd**2*s - 44*D1**2*bd1**2*(r + s - 1)*(5*f**2*(r + s - 2) + 6*f*(C*(r + s) + 2*K*(r + s) - 2) - 7*g2*(r + s)) - 330*D1**2*bd2*f**2*r**2 - 660*D1**2*bd2*f**2*r*s + 660*D1**2*bd2*f**2*r - 330*D1**2*bd2*f**2*s**2 + 660*D1**2*bd2*f**2*s - 330*D1**2*bd2*f**2 + 1320*D1**2*bd2*f*fd*r**2 + 2640*D1**2*bd2*f*fd*r*s - 1980*D1**2*bd2*f*fd*r + 1320*D1**2*bd2*f*fd*s**2 - 1980*D1**2*bd2*f*fd*s + 660*D1**2*bd2*f*fd + 110*D1**2*bdd1*f**2*r**2 + 220*D1**2*bdd1*f**2*r*s + 440*D1**2*bdd1*f**2*r + 110*D1**2*bdd1*f**2*s**2 + 440*D1**2*bdd1*f**2*s - 220*D1**2*bdd1*f**2 + 528*D1**2*bdd1*f*g2*r**2 + 1056*D1**2*bdd1*f*g2*r*s + 528*D1**2*bdd1*f*g2*s**2 + 330*D1**2*bdd2*f**2*r**2 + 660*D1**2*bdd2*f**2*r*s - 660*D1**2*bdd2*f**2*r + 330*D1**2*bdd2*f**2*s**2 - 660*D1**2*bdd2*f**2*s + 330*D1**2*bdd2*f**2 + 525*D1**2*f**2*fd*r**2 + 1050*D1**2*f**2*fd*r*s - 700*D1**2*f**2*fd*r + 525*D1**2*f**2*fd*s**2 - 700*D1**2*f**2*fd*s + 350*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 - 1680*D1**2*f**2*fdd*r*s + 1120*D1**2*f**2*fdd*r - 840*D1**2*f**2*fdd*s**2 + 1120*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd + 660*D1**2*f**2*gd2*r**2 + 1320*D1**2*f**2*gd2*r*s - 1320*D1**2*f**2*gd2*r + 660*D1**2*f**2*gd2*s**2 - 1320*D1**2*f**2*gd2*s + 660*D1**2*f**2*gd2 - 660*D1**2*f**2*gdd2*r**2 - 1320*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*r - 660*D1**2*f**2*gdd2*s**2 + 1320*D1**2*f**2*gdd2*s - 660*D1**2*f**2*gdd2 - 1680*D1**2*f*fd**2*r**2 - 3360*D1**2*f*fd**2*r*s + 2240*D1**2*f*fd**2*r - 1680*D1**2*f*fd**2*s**2 + 2240*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 + 1320*D1**2*f*fd*g2*r**2 + 2640*D1**2*f*fd*g2*r*s - 1320*D1**2*f*fd*g2*r + 1320*D1**2*f*fd*g2*s**2 - 1320*D1**2*f*fd*g2*s + 660*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r**2 - 5280*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r - 2640*D1**2*f*fd*gd2*s**2 + 3960*D1**2*f*fd*gd2*s - 1320*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r**2 - 2640*D1**2*f*fdd*g2*r*s + 1320*D1**2*f*fdd*g2*r - 1320*D1**2*f*fdd*g2*s**2 + 1320*D1**2*f*fdd*g2*s - 660*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r**2 - 2640*D1**2*fd**2*g2*r*s + 1320*D1**2*fd**2*g2*r - 1320*D1**2*fd**2*g2*s**2 + 1320*D1**2*fd**2*g2*s - 1320*D1*Dd*b2*f**2*r**2 - 2640*D1*Dd*b2*f**2*r*s + 1980*D1*Dd*b2*f**2*r - 1320*D1*Dd*b2*f**2*s**2 + 1980*D1*Dd*b2*f**2*s - 990*D1*Dd*b2*f**2 + 5280*D1*Dd*b2*f*fd*r**2 + 10560*D1*Dd*b2*f*fd*r*s - 6600*D1*Dd*b2*f*fd*r + 5280*D1*Dd*b2*f*fd*s**2 - 6600*D1*Dd*b2*f*fd*s + 1980*D1*Dd*b2*f*fd + 2640*D1*Dd*bd2*f**2*r**2 + 5280*D1*Dd*bd2*f**2*r*s - 4620*D1*Dd*bd2*f**2*r + 2640*D1*Dd*bd2*f**2*s**2 - 4620*D1*Dd*bd2*f**2*s + 1980*D1*Dd*bd2*f**2 + 700*D1*Dd*f**3*r**2 + 1400*D1*Dd*f**3*r*s - 1050*D1*Dd*f**3*r + 700*D1*Dd*f**3*s**2 - 1050*D1*Dd*f**3*s + 525*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 - 13440*D1*Dd*f**2*fd*r*s + 9520*D1*Dd*f**2*fd*r - 6720*D1*Dd*f**2*fd*s**2 + 9520*D1*Dd*f**2*fd*s - 3360*D1*Dd*f**2*fd + 2640*D1*Dd*f**2*g2*r**2 + 5280*D1*Dd*f**2*g2*r*s - 3960*D1*Dd*f**2*g2*r + 2640*D1*Dd*f**2*g2*s**2 - 3960*D1*Dd*f**2*g2*s + 1980*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r**2 - 10560*D1*Dd*f**2*gd2*r*s + 9240*D1*Dd*f**2*gd2*r - 5280*D1*Dd*f**2*gd2*s**2 + 9240*D1*Dd*f**2*gd2*s - 3960*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r**2 - 21120*D1*Dd*f*fd*g2*r*s + 13200*D1*Dd*f*fd*g2*r - 10560*D1*Dd*f*fd*g2*s**2 + 13200*D1*Dd*f*fd*g2*s - 3960*D1*Dd*f*fd*g2 + 1320*D1*Ddd*b2*f**2*r**2 + 2640*D1*Ddd*b2*f**2*r*s - 1980*D1*Ddd*b2*f**2*r + 1320*D1*Ddd*b2*f**2*s**2 - 1980*D1*Ddd*b2*f**2*s + 990*D1*Ddd*b2*f**2 - 1120*D1*Ddd*f**3*r**2 - 2240*D1*Ddd*f**3*r*s + 1680*D1*Ddd*f**3*r - 1120*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 840*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r**2 - 5280*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r - 2640*D1*Ddd*f**2*g2*s**2 + 3960*D1*Ddd*f**2*g2*s - 1980*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 2*f**2*(-10*C*s**2 + 15*K*(r + s - 1)**2 - 2*r**2*(5*C + 1) - 4*r*(5*C*s + s - 4) - 2*s**2 + 16*s - 8) - 2*f*(10*fd*(r + s - 1)*(-8*C*r - 8*C*s + K*(6*r + 6*s - 3) + 2*r + 2*s + 2) + (r + s)*(-13*g2*(r + s) + 48*gd2*(r + s - 1))) - 96*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 4*Dd*f*(5*f*(-4*C*r - 4*C*s + 3*K*(r + s - 1) + r + s + 2) + 24*g2*(r + s))*(4*r + 4*s - 3)) + 3960*Dd**2*b2*f**2*r**2 + 7920*Dd**2*b2*f**2*r*s - 5940*Dd**2*b2*f**2*r + 3960*Dd**2*b2*f**2*s**2 - 5940*Dd**2*b2*f**2*s + 1980*Dd**2*b2*f**2 - 3360*Dd**2*f**3*r**2 - 6720*Dd**2*f**3*r*s + 5040*Dd**2*f**3*r - 3360*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 1680*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r**2 - 15840*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r - 7920*Dd**2*f**2*g2*s**2 + 11880*Dd**2*f**2*g2*s - 3960*Dd**2*f**2*g2 + 77*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(24*C*D1**2*fd*r**2 + 48*C*D1**2*fd*r*s - 48*C*D1**2*fd*r + 24*C*D1**2*fd*s**2 - 48*C*D1**2*fd*s + 24*C*D1**2*fd - 12*C*D1**2*fdd*r**2 - 24*C*D1**2*fdd*r*s + 24*C*D1**2*fdd*r - 12*C*D1**2*fdd*s**2 + 24*C*D1**2*fdd*s - 12*C*D1**2*fdd + 96*C*D1*Dd*f*r**2 + 192*C*D1*Dd*f*r*s - 144*C*D1*Dd*f*r + 96*C*D1*Dd*f*s**2 - 144*C*D1*Dd*f*s + 72*C*D1*Dd*f - 96*C*D1*Dd*fd*r**2 - 192*C*D1*Dd*fd*r*s + 168*C*D1*Dd*fd*r - 96*C*D1*Dd*fd*s**2 + 168*C*D1*Dd*fd*s - 72*C*D1*Dd*fd - 48*C*D1*Ddd*f*r**2 - 96*C*D1*Ddd*f*r*s + 72*C*D1*Ddd*f*r - 48*C*D1*Ddd*f*s**2 + 72*C*D1*Ddd*f*s - 36*C*D1*Ddd*f - 144*C*Dd**2*f*r**2 - 288*C*Dd**2*f*r*s + 216*C*Dd**2*f*r - 144*C*Dd**2*f*s**2 + 216*C*Dd**2*f*s - 72*C*Dd**2*f + 13*D1**2*K*fd*r**2 + 26*D1**2*K*fd*r*s - 26*D1**2*K*fd*r + 13*D1**2*K*fd*s**2 - 26*D1**2*K*fd*s + 13*D1**2*K*fd - 24*D1**2*K*fdd*r**2 - 48*D1**2*K*fdd*r*s + 48*D1**2*K*fdd*r - 24*D1**2*K*fdd*s**2 + 48*D1**2*K*fdd*s - 24*D1**2*K*fdd - 7*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 40*D1**2*f*fd*r**2 + 80*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 40*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 12*D1**2*f*fd - 20*D1**2*f*fdd*r**2 - 40*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*s**2 - 20*D1**2*fd**2*r**2 - 40*D1**2*fd**2*r*s - 20*D1**2*fd**2*s**2 + 20*D1**2*fd**2 + 7*D1**2*fd*r**2 + 14*D1**2*fd*r*s + 54*D1**2*fd*r + 7*D1**2*fd*s**2 + 54*D1**2*fd*s - 27*D1**2*fd - 48*D1**2*fdd*r - 48*D1**2*fdd*s + 24*D1**2*fdd - 28*D1**2*gd2*r**2 - 56*D1**2*gd2*r*s + 56*D1**2*gd2*r - 28*D1**2*gd2*s**2 + 56*D1**2*gd2*s - 28*D1**2*gd2 + 14*D1**2*gdd2*r**2 + 28*D1**2*gdd2*r*s - 28*D1**2*gdd2*r + 14*D1**2*gdd2*s**2 - 28*D1**2*gdd2*s + 14*D1**2*gdd2 + 52*D1*Dd*K*f*r**2 + 104*D1*Dd*K*f*r*s - 78*D1*Dd*K*f*r + 52*D1*Dd*K*f*s**2 - 78*D1*Dd*K*f*s + 39*D1*Dd*K*f - 192*D1*Dd*K*fd*r**2 - 384*D1*Dd*K*fd*r*s + 336*D1*Dd*K*fd*r - 192*D1*Dd*K*fd*s**2 + 336*D1*Dd*K*fd*s - 144*D1*Dd*K*fd + 80*D1*Dd*f**2*r**2 + 160*D1*Dd*f**2*r*s - 120*D1*Dd*f**2*r + 80*D1*Dd*f**2*s**2 - 120*D1*Dd*f**2*s + 60*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 - 320*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 120*D1*Dd*f*fd*s + 28*D1*Dd*f*r**2 + 56*D1*Dd*f*r*s - 42*D1*Dd*f*r + 28*D1*Dd*f*s**2 - 42*D1*Dd*f*s + 21*D1*Dd*f - 192*D1*Dd*fd*r - 192*D1*Dd*fd*s + 144*D1*Dd*fd - 112*D1*Dd*g2*r**2 - 224*D1*Dd*g2*r*s + 168*D1*Dd*g2*r - 112*D1*Dd*g2*s**2 + 168*D1*Dd*g2*s - 84*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 + 224*D1*Dd*gd2*r*s - 196*D1*Dd*gd2*r + 112*D1*Dd*gd2*s**2 - 196*D1*Dd*gd2*s + 84*D1*Dd*gd2 - 96*D1*Ddd*K*f*r**2 - 192*D1*Ddd*K*f*r*s + 144*D1*Ddd*K*f*r - 96*D1*Ddd*K*f*s**2 + 144*D1*Ddd*K*f*s - 72*D1*Ddd*K*f - 40*D1*Ddd*f**2*r**2 - 80*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 + 56*D1*Ddd*g2*r**2 + 112*D1*Ddd*g2*r*s - 84*D1*Ddd*g2*r + 56*D1*Ddd*g2*s**2 - 84*D1*Ddd*g2*s + 42*D1*Ddd*g2 + 14*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 288*Dd**2*K*f*r**2 - 576*Dd**2*K*f*r*s + 432*Dd**2*K*f*r - 288*Dd**2*K*f*s**2 + 432*Dd**2*K*f*s - 144*Dd**2*K*f - 120*Dd**2*f**2*r**2 - 240*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 60*Dd**2*f**2 + 168*Dd**2*g2*r**2 + 336*Dd**2*g2*r*s - 252*Dd**2*g2*r + 168*Dd**2*g2*s**2 - 252*Dd**2*g2*s + 84*Dd**2*g2) - 11*b1*(-40*C*D1**2*f*fd*r**2 - 80*C*D1**2*f*fd*r*s + 80*C*D1**2*f*fd*r - 40*C*D1**2*f*fd*s**2 + 80*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 80*C*D1**2*f*fdd*r**2 + 160*C*D1**2*f*fdd*r*s - 160*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 - 160*C*D1**2*f*fdd*s + 80*C*D1**2*f*fdd + 80*C*D1**2*fd**2*r**2 + 160*C*D1**2*fd**2*r*s - 160*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 - 160*C*D1**2*fd**2*s + 80*C*D1**2*fd**2 - 80*C*D1*Dd*f**2*r**2 - 160*C*D1*Dd*f**2*r*s + 120*C*D1*Dd*f**2*r - 80*C*D1*Dd*f**2*s**2 + 120*C*D1*Dd*f**2*s - 60*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*r**2 + 1280*C*D1*Dd*f*fd*r*s - 1120*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 1120*C*D1*Dd*f*fd*s + 480*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r**2 + 320*C*D1*Ddd*f**2*r*s - 240*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 240*C*D1*Ddd*f**2*s + 120*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r**2 + 960*C*Dd**2*f**2*r*s - 720*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 720*C*Dd**2*f**2*s + 240*C*Dd**2*f**2 + 60*D1**2*K*f*fd*r**2 + 120*D1**2*K*f*fd*r*s - 60*D1**2*K*f*fd*r + 60*D1**2*K*f*fd*s**2 - 60*D1**2*K*f*fd*s + 30*D1**2*K*f*fd - 60*D1**2*K*f*fdd*r**2 - 120*D1**2*K*f*fdd*r*s + 60*D1**2*K*f*fdd*r - 60*D1**2*K*f*fdd*s**2 + 60*D1**2*K*f*fdd*s - 30*D1**2*K*f*fdd - 60*D1**2*K*fd**2*r**2 - 120*D1**2*K*fd**2*r*s + 60*D1**2*K*fd**2*r - 60*D1**2*K*fd**2*s**2 + 60*D1**2*K*fd**2*s + 14*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(5*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + 6*f*(C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 4*r - 4*s + 2) - 7*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 45*D1**2*f**2*fd*r**2 + 90*D1**2*f**2*fd*r*s - 70*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s**2 - 70*D1**2*f**2*fd*s + 35*D1**2*f**2*fd - 8*D1**2*f*fd*r**2 - 16*D1**2*f*fd*r*s - 16*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 8*D1**2*f*fd - 20*D1**2*f*fdd*r**2 - 40*D1**2*f*fdd*r*s + 80*D1**2*f*fdd*r - 20*D1**2*f*fdd*s**2 + 80*D1**2*f*fdd*s - 40*D1**2*f*fdd + 26*D1**2*f*gd2*r**2 + 52*D1**2*f*gd2*r*s - 52*D1**2*f*gd2*r + 26*D1**2*f*gd2*s**2 - 52*D1**2*f*gd2*s + 26*D1**2*f*gd2 - 48*D1**2*f*gdd2*r**2 - 96*D1**2*f*gdd2*r*s + 96*D1**2*f*gdd2*r - 48*D1**2*f*gdd2*s**2 + 96*D1**2*f*gdd2*s - 48*D1**2*f*gdd2 - 20*D1**2*fd**2*r**2 - 40*D1**2*fd**2*r*s + 80*D1**2*fd**2*r - 20*D1**2*fd**2*s**2 + 80*D1**2*fd**2*s - 60*D1**2*fd**2 + 26*D1**2*fd*g2*r**2 + 52*D1**2*fd*g2*r*s - 52*D1**2*fd*g2*r + 26*D1**2*fd*g2*s**2 - 52*D1**2*fd*g2*s + 26*D1**2*fd*g2 - 96*D1**2*fd*gd2*r**2 - 192*D1**2*fd*gd2*r*s + 192*D1**2*fd*gd2*r - 96*D1**2*fd*gd2*s**2 + 192*D1**2*fd*gd2*s - 96*D1**2*fd*gd2 - 48*D1**2*fdd*g2*r**2 - 96*D1**2*fdd*g2*r*s + 96*D1**2*fdd*g2*r - 48*D1**2*fdd*g2*s**2 + 96*D1**2*fdd*g2*s - 48*D1**2*fdd*g2 + 120*D1*Dd*K*f**2*r**2 + 240*D1*Dd*K*f**2*r*s - 180*D1*Dd*K*f**2*r + 120*D1*Dd*K*f**2*s**2 - 180*D1*Dd*K*f**2*s + 90*D1*Dd*K*f**2 - 480*D1*Dd*K*f*fd*r**2 - 960*D1*Dd*K*f*fd*r*s + 600*D1*Dd*K*f*fd*r - 480*D1*Dd*K*f*fd*s**2 + 600*D1*Dd*K*f*fd*s - 180*D1*Dd*K*f*fd + 60*D1*Dd*f**3*r**2 + 120*D1*Dd*f**3*r*s - 90*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 90*D1*Dd*f**3*s + 45*D1*Dd*f**3 - 16*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 - 320*D1*Dd*f*fd*r*s + 440*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 440*D1*Dd*f*fd*s - 240*D1*Dd*f*fd + 104*D1*Dd*f*g2*r**2 + 208*D1*Dd*f*g2*r*s - 156*D1*Dd*f*g2*r + 104*D1*Dd*f*g2*s**2 - 156*D1*Dd*f*g2*s + 78*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r**2 - 768*D1*Dd*f*gd2*r*s + 672*D1*Dd*f*gd2*r - 384*D1*Dd*f*gd2*s**2 + 672*D1*Dd*f*gd2*s - 288*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r**2 - 768*D1*Dd*fd*g2*r*s + 672*D1*Dd*fd*g2*r - 384*D1*Dd*fd*g2*s**2 + 672*D1*Dd*fd*g2*s - 288*D1*Dd*fd*g2 - 120*D1*Ddd*K*f**2*r**2 - 240*D1*Ddd*K*f**2*r*s + 180*D1*Ddd*K*f**2*r - 120*D1*Ddd*K*f**2*s**2 + 180*D1*Ddd*K*f**2*s - 90*D1*Ddd*K*f**2 - 40*D1*Ddd*f**2*r**2 - 80*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r**2 - 384*D1*Ddd*f*g2*r*s + 288*D1*Ddd*f*g2*r - 192*D1*Ddd*f*g2*s**2 + 288*D1*Ddd*f*g2*s - 144*D1*Ddd*f*g2 + D1*bd1*(D1*(-8*f**2*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) - f*(24*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 26*K*r**2 + 52*K*r*s - 26*K*r + 26*K*s**2 - 26*K*s + 13*K - 40*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 14*r**2 + 28*r*s - 82*r + 14*s**2 - 82*s + 41) + 24*fd*(r + s - 1)*(C*(2*r + 2*s - 1) + K*(4*r + 4*s - 2) + 2) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(4*r + 4*s - 3)*(5*f**2*(2*r + 2*s - 3) + 6*f*(C*(2*r + 2*s - 1) + K*(4*r + 4*s - 2) - 2) - 7*g2*(2*r + 2*s - 1))) - 360*Dd**2*K*f**2*r**2 - 720*Dd**2*K*f**2*r*s + 540*Dd**2*K*f**2*r - 360*Dd**2*K*f**2*s**2 + 540*Dd**2*K*f**2*s - 180*Dd**2*K*f**2 - 120*Dd**2*f**2*r**2 - 240*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 60*Dd**2*f**2 - 576*Dd**2*f*g2*r**2 - 1152*Dd**2*f*g2*r*s + 864*Dd**2*f*g2*r - 576*Dd**2*f*g2*s**2 + 864*Dd**2*f*g2*s - 288*Dd**2*f*g2))/(231*d**2*k3**4) - 2*D1**2*Pk2*Pkdd3*ct**4*k1**2*(-D1*f*(r + s)*(2*D1*bd1**2*(5*f + 6)*(r + s - 1) + 5*D1*bdd1*f*(r + s) + bd1*(-4*D1*f*(r + s) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(-10*fd**2 + fd*(8*f + 5) - fdd*(10*f + 6))*(r + s - 1)**2 + D1*(Dd*(4*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(4*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 4*r**2 - 8*r*s + 6*r - 4*s**2 + 6*s - 3) - 12*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-D1**2*bdd1*f*(5*f + 6)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 16*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 8*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 20*D1**2*f*fdd*s - 10*D1**2*f*fdd - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 20*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 20*D1**2*fd**2*s - 10*D1**2*fd**2 + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 140*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 140*D1*Dd*f*fd*s - 60*D1*Dd*f*fd - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 + D1*bd1*(D1*(4*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 5*f*(4*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 2*r**2 - 4*r*s + 2*r - 2*s**2 + 2*s - 1) - 12*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*f*(5*f + 6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2))/(21*d**2*k3**2) - 5*D1**2*Pk2*Pkdd3*ct**4*k2**6*st**2*(D1**2*(f**2*(fd*(100*C - 50)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(50*C - 25)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(100*C - 50)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 66*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(50*C - 25)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(33*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + fd*(25 - 50*C)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 33*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(50*C*f + 33*K*b1 - 25*f - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(50*C*f + 33*K*b1 - 25*f - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(462*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**4*k2**6*(40*C*D1**2*b1*f*fd*r**2 + 80*C*D1**2*b1*f*fd*r*s - 40*C*D1**2*b1*f*fd*r + 40*C*D1**2*b1*f*fd*s**2 - 40*C*D1**2*b1*f*fd*s + 20*C*D1**2*b1*f*fd - 20*C*D1**2*b1*f*fdd*r**2 - 40*C*D1**2*b1*f*fdd*r*s + 20*C*D1**2*b1*f*fdd*r - 20*C*D1**2*b1*f*fdd*s**2 + 20*C*D1**2*b1*f*fdd*s - 10*C*D1**2*b1*f*fdd - 20*C*D1**2*b1*fd**2*r**2 - 40*C*D1**2*b1*fd**2*r*s + 20*C*D1**2*b1*fd**2*r - 20*C*D1**2*b1*fd**2*s**2 + 20*C*D1**2*b1*fd**2*s - 30*C*D1**2*f**2*fd*r**2 - 60*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 40*C*D1**2*f**2*fd*s - 20*C*D1**2*f**2*fd + 80*C*D1*Dd*b1*f**2*r**2 + 160*C*D1*Dd*b1*f**2*r*s - 120*C*D1*Dd*b1*f**2*r + 80*C*D1*Dd*b1*f**2*s**2 - 120*C*D1*Dd*b1*f**2*s + 60*C*D1*Dd*b1*f**2 - 160*C*D1*Dd*b1*f*fd*r**2 - 320*C*D1*Dd*b1*f*fd*r*s + 200*C*D1*Dd*b1*f*fd*r - 160*C*D1*Dd*b1*f*fd*s**2 + 200*C*D1*Dd*b1*f*fd*s - 60*C*D1*Dd*b1*f*fd - 40*C*D1*Dd*f**3*r**2 - 80*C*D1*Dd*f**3*r*s + 60*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 60*C*D1*Dd*f**3*s - 30*C*D1*Dd*f**3 - 40*C*D1*Ddd*b1*f**2*r**2 - 80*C*D1*Ddd*b1*f**2*r*s + 60*C*D1*Ddd*b1*f**2*r - 40*C*D1*Ddd*b1*f**2*s**2 + 60*C*D1*Ddd*b1*f**2*s - 30*C*D1*Ddd*b1*f**2 - 120*C*Dd**2*b1*f**2*r**2 - 240*C*Dd**2*b1*f**2*r*s + 180*C*Dd**2*b1*f**2*r - 120*C*Dd**2*b1*f**2*s**2 + 180*C*Dd**2*b1*f**2*s - 60*C*Dd**2*b1*f**2 + 12*D1**2*K*b1**2*fd*r**2 + 24*D1**2*K*b1**2*fd*r*s + 12*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r**2 - 12*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 - 12*D1**2*K*b1*f*fd*r**2 - 24*D1**2*K*b1*f*fd*r*s + 12*D1**2*K*b1*f*fd*r - 12*D1**2*K*b1*f*fd*s**2 + 12*D1**2*K*b1*f*fd*s - 6*D1**2*K*b1*f*fd - 12*D1**2*K*bd1**2*f*(r + s - 1)**2 - 20*D1**2*b1*f*fd*r**2 - 40*D1**2*b1*f*fd*r*s + 20*D1**2*b1*f*fd*r - 20*D1**2*b1*f*fd*s**2 + 20*D1**2*b1*f*fd*s - 10*D1**2*b1*f*fd + 10*D1**2*b1*f*fdd*r**2 + 20*D1**2*b1*f*fdd*r*s - 10*D1**2*b1*f*fdd*r + 10*D1**2*b1*f*fdd*s**2 - 10*D1**2*b1*f*fdd*s + 5*D1**2*b1*f*fdd - 24*D1**2*b1*f*gd2*r**2 - 48*D1**2*b1*f*gd2*r*s + 48*D1**2*b1*f*gd2*r - 24*D1**2*b1*f*gd2*s**2 + 48*D1**2*b1*f*gd2*s - 24*D1**2*b1*f*gd2 + 12*D1**2*b1*f*gdd2*r**2 + 24*D1**2*b1*f*gdd2*r*s - 24*D1**2*b1*f*gdd2*r + 12*D1**2*b1*f*gdd2*s**2 - 24*D1**2*b1*f*gdd2*s + 12*D1**2*b1*f*gdd2 + 10*D1**2*b1*fd**2*r**2 + 20*D1**2*b1*fd**2*r*s - 10*D1**2*b1*fd**2*r + 10*D1**2*b1*fd**2*s**2 - 10*D1**2*b1*fd**2*s - 24*D1**2*b1*fd*g2*r**2 - 48*D1**2*b1*fd*g2*r*s - 24*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r**2 + 48*D1**2*b1*fd*gd2*r*s - 24*D1**2*b1*fd*gd2*r + 24*D1**2*b1*fd*gd2*s**2 - 24*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r**2 + 24*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 12*K*b1 - 5*f - 12*g2) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 12*D1**2*f**2*gd2*r**2 + 24*D1**2*f**2*gd2*r*s - 24*D1**2*f**2*gd2*r + 12*D1**2*f**2*gd2*s**2 - 24*D1**2*f**2*gd2*s + 12*D1**2*f**2*gd2 + 24*D1**2*f*fd*g2*r**2 + 48*D1**2*f*fd*g2*r*s - 24*D1**2*f*fd*g2*r + 24*D1**2*f*fd*g2*s**2 - 24*D1**2*f*fd*g2*s + 12*D1**2*f*fd*g2 + 48*D1*Dd*K*b1**2*f*r**2 + 96*D1*Dd*K*b1**2*f*r*s - 72*D1*Dd*K*b1**2*f*r + 48*D1*Dd*K*b1**2*f*s**2 - 72*D1*Dd*K*b1**2*f*s + 36*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 96*D1*Dd*K*b1**2*fd*r*s + 36*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 36*D1*Dd*K*b1**2*fd*s - 24*D1*Dd*K*b1*f**2*r**2 - 48*D1*Dd*K*b1*f**2*r*s + 36*D1*Dd*K*b1*f**2*r - 24*D1*Dd*K*b1*f**2*s**2 + 36*D1*Dd*K*b1*f**2*s - 18*D1*Dd*K*b1*f**2 - 40*D1*Dd*b1*f**2*r**2 - 80*D1*Dd*b1*f**2*r*s + 60*D1*Dd*b1*f**2*r - 40*D1*Dd*b1*f**2*s**2 + 60*D1*Dd*b1*f**2*s - 30*D1*Dd*b1*f**2 + 80*D1*Dd*b1*f*fd*r**2 + 160*D1*Dd*b1*f*fd*r*s - 100*D1*Dd*b1*f*fd*r + 80*D1*Dd*b1*f*fd*s**2 - 100*D1*Dd*b1*f*fd*s + 30*D1*Dd*b1*f*fd - 96*D1*Dd*b1*f*g2*r**2 - 192*D1*Dd*b1*f*g2*r*s + 144*D1*Dd*b1*f*g2*r - 96*D1*Dd*b1*f*g2*s**2 + 144*D1*Dd*b1*f*g2*s - 72*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 192*D1*Dd*b1*f*gd2*r*s - 168*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 168*D1*Dd*b1*f*gd2*s + 72*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 192*D1*Dd*b1*fd*g2*r*s - 72*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 72*D1*Dd*b1*fd*g2*s + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 48*D1*Dd*f**2*g2*r**2 + 96*D1*Dd*f**2*g2*r*s - 72*D1*Dd*f**2*g2*r + 48*D1*Dd*f**2*g2*s**2 - 72*D1*Dd*f**2*g2*s + 36*D1*Dd*f**2*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 48*D1*Ddd*K*b1**2*f*r*s + 36*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 36*D1*Ddd*K*b1**2*f*s - 18*D1*Ddd*K*b1**2*f + 20*D1*Ddd*b1*f**2*r**2 + 40*D1*Ddd*b1*f**2*r*s - 30*D1*Ddd*b1*f**2*r + 20*D1*Ddd*b1*f**2*s**2 - 30*D1*Ddd*b1*f**2*s + 15*D1*Ddd*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 96*D1*Ddd*b1*f*g2*r*s - 72*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 72*D1*Ddd*b1*f*g2*s + 36*D1*Ddd*b1*f*g2 + 2*D1*bd1*(D1*(f**2*(10*C - 3*K - 5)*(r + s - 1) - f*fd*(10*C - 5)*(2*r + 2*s - 1) - 12*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 12*fd*(r + s)*(-K*b1 + g2)) - Dd*f*(4*r + 4*s - 3)*(10*C*f + 12*K*b1 - 5*f - 12*g2))*(r + s - 1) - 72*Dd**2*K*b1**2*f*r**2 - 144*Dd**2*K*b1**2*f*r*s + 108*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 108*Dd**2*K*b1**2*f*s - 36*Dd**2*K*b1**2*f + 60*Dd**2*b1*f**2*r**2 + 120*Dd**2*b1*f**2*r*s - 90*Dd**2*b1*f**2*r + 60*Dd**2*b1*f**2*s**2 - 90*Dd**2*b1*f**2*s + 30*Dd**2*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 288*Dd**2*b1*f*g2*r*s - 216*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 216*Dd**2*b1*f*g2*s + 72*Dd**2*b1*f*g2)/(21*d**2*k3**6) + 5*D1**2*Pk2*Pkdd3*ct**4*k2**4*st**2*(300*C*D1**2*f**2*fd*r**2 + 600*C*D1**2*f**2*fd*r*s - 400*C*D1**2*f**2*fd*r + 300*C*D1**2*f**2*fd*s**2 - 400*C*D1**2*f**2*fd*s + 200*C*D1**2*f**2*fd - 150*C*D1**2*f**2*fdd*r**2 - 300*C*D1**2*f**2*fdd*r*s + 200*C*D1**2*f**2*fdd*r - 150*C*D1**2*f**2*fdd*s**2 + 200*C*D1**2*f**2*fdd*s - 100*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*r**2 - 600*C*D1**2*f*fd**2*r*s + 400*C*D1**2*f*fd**2*r - 300*C*D1**2*f*fd**2*s**2 + 400*C*D1**2*f*fd**2*s - 100*C*D1**2*f*fd**2 + 400*C*D1*Dd*f**3*r**2 + 800*C*D1*Dd*f**3*r*s - 600*C*D1*Dd*f**3*r + 400*C*D1*Dd*f**3*s**2 - 600*C*D1*Dd*f**3*s + 300*C*D1*Dd*f**3 - 1200*C*D1*Dd*f**2*fd*r**2 - 2400*C*D1*Dd*f**2*fd*r*s + 1700*C*D1*Dd*f**2*fd*r - 1200*C*D1*Dd*f**2*fd*s**2 + 1700*C*D1*Dd*f**2*fd*s - 600*C*D1*Dd*f**2*fd - 200*C*D1*Ddd*f**3*r**2 - 400*C*D1*Ddd*f**3*r*s + 300*C*D1*Ddd*f**3*r - 200*C*D1*Ddd*f**3*s**2 + 300*C*D1*Ddd*f**3*s - 150*C*D1*Ddd*f**3 - 600*C*Dd**2*f**3*r**2 - 1200*C*Dd**2*f**3*r*s + 900*C*Dd**2*f**3*r - 600*C*Dd**2*f**3*s**2 + 900*C*Dd**2*f**3*s - 300*C*Dd**2*f**3 + 132*D1**2*K*b1*f*fd*r**2 + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r + 132*D1**2*K*b1*f*fd*s**2 - 132*D1**2*K*b1*f*fd*s + 66*D1**2*K*b1*f*fd - 66*D1**2*K*b1*f*fdd*r**2 - 132*D1**2*K*b1*f*fdd*r*s + 66*D1**2*K*b1*f*fdd*r - 66*D1**2*K*b1*f*fdd*s**2 + 66*D1**2*K*b1*f*fdd*s - 33*D1**2*K*b1*f*fdd - 66*D1**2*K*b1*fd**2*r**2 - 132*D1**2*K*b1*fd**2*r*s + 66*D1**2*K*b1*fd**2*r - 66*D1**2*K*b1*fd**2*s**2 + 66*D1**2*K*b1*fd**2*s + 66*D1**2*K*bd1*f**2*r**2 + 132*D1**2*K*bd1*f**2*r*s - 132*D1**2*K*bd1*f**2*r + 66*D1**2*K*bd1*f**2*s**2 - 132*D1**2*K*bd1*f**2*s + 66*D1**2*K*bd1*f**2 - 132*D1**2*K*bd1*f*fd*r**2 - 264*D1**2*K*bd1*f*fd*r*s + 198*D1**2*K*bd1*f*fd*r - 132*D1**2*K*bd1*f*fd*s**2 + 198*D1**2*K*bd1*f*fd*s - 66*D1**2*K*bd1*f*fd - 33*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*K*bdd1*f**2*r*s + 66*D1**2*K*bdd1*f**2*r - 33*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s - 33*D1**2*K*bdd1*f**2 + 132*D1**2*b2*f*fd*r**2 + 264*D1**2*b2*f*fd*r*s - 132*D1**2*b2*f*fd*r + 132*D1**2*b2*f*fd*s**2 - 132*D1**2*b2*f*fd*s + 66*D1**2*b2*f*fd - 66*D1**2*b2*f*fdd*r**2 - 132*D1**2*b2*f*fdd*r*s + 66*D1**2*b2*f*fdd*r - 66*D1**2*b2*f*fdd*s**2 + 66*D1**2*b2*f*fdd*s - 33*D1**2*b2*f*fdd - 66*D1**2*b2*fd**2*r**2 - 132*D1**2*b2*fd**2*r*s + 66*D1**2*b2*fd**2*r - 66*D1**2*b2*fd**2*s**2 + 66*D1**2*b2*fd**2*s - 33*D1**2*bdd2*f**2*(r + s - 1)**2 - 150*D1**2*f**2*fd*r**2 - 300*D1**2*f**2*fd*r*s + 200*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 200*D1**2*f**2*fd*s - 100*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*r - 132*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s - 132*D1**2*f**2*gd2 + 66*D1**2*f**2*gdd2*r**2 + 132*D1**2*f**2*gdd2*r*s - 132*D1**2*f**2*gdd2*r + 66*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 66*D1**2*f**2*gdd2 + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 + 528*D1**2*f*fd*gd2*r*s - 396*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 396*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r**2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 264*D1*Dd*K*b1*f**2*r**2 + 528*D1*Dd*K*b1*f**2*r*s - 396*D1*Dd*K*b1*f**2*r + 264*D1*Dd*K*b1*f**2*s**2 - 396*D1*Dd*K*b1*f**2*s + 198*D1*Dd*K*b1*f**2 - 528*D1*Dd*K*b1*f*fd*r**2 - 1056*D1*Dd*K*b1*f*fd*r*s + 660*D1*Dd*K*b1*f*fd*r - 528*D1*Dd*K*b1*f*fd*s**2 + 660*D1*Dd*K*b1*f*fd*s - 198*D1*Dd*K*b1*f*fd - 264*D1*Dd*K*bd1*f**2*r**2 - 528*D1*Dd*K*bd1*f**2*r*s + 462*D1*Dd*K*bd1*f**2*r - 264*D1*Dd*K*bd1*f**2*s**2 + 462*D1*Dd*K*bd1*f**2*s - 198*D1*Dd*K*bd1*f**2 + 264*D1*Dd*b2*f**2*r**2 + 528*D1*Dd*b2*f**2*r*s - 396*D1*Dd*b2*f**2*r + 264*D1*Dd*b2*f**2*s**2 - 396*D1*Dd*b2*f**2*s + 198*D1*Dd*b2*f**2 - 528*D1*Dd*b2*f*fd*r**2 - 1056*D1*Dd*b2*f*fd*r*s + 660*D1*Dd*b2*f*fd*r - 528*D1*Dd*b2*f*fd*s**2 + 660*D1*Dd*b2*f*fd*s - 198*D1*Dd*b2*f*fd - 200*D1*Dd*f**3*r**2 - 400*D1*Dd*f**3*r*s + 300*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 300*D1*Dd*f**3*s - 150*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 850*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 850*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s + 792*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 792*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 + 1056*D1*Dd*f**2*gd2*r*s - 924*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 924*D1*Dd*f**2*gd2*s + 396*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r**2 + 2112*D1*Dd*f*fd*g2*r*s - 1320*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1320*D1*Dd*f*fd*g2*s + 396*D1*Dd*f*fd*g2 - 132*D1*Ddd*K*b1*f**2*r**2 - 264*D1*Ddd*K*b1*f**2*r*s + 198*D1*Ddd*K*b1*f**2*r - 132*D1*Ddd*K*b1*f**2*s**2 + 198*D1*Ddd*K*b1*f**2*s - 99*D1*Ddd*K*b1*f**2 - 132*D1*Ddd*b2*f**2*r**2 - 264*D1*Ddd*b2*f**2*r*s + 198*D1*Ddd*b2*f**2*r - 132*D1*Ddd*b2*f**2*s**2 + 198*D1*Ddd*b2*f**2*s - 99*D1*Ddd*b2*f**2 + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r**2 + 528*D1*Ddd*f**2*g2*r*s - 396*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 396*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 66*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*K*b1*f**2*r**2 - 792*Dd**2*K*b1*f**2*r*s + 594*Dd**2*K*b1*f**2*r - 396*Dd**2*K*b1*f**2*s**2 + 594*Dd**2*K*b1*f**2*s - 198*Dd**2*K*b1*f**2 - 396*Dd**2*b2*f**2*r**2 - 792*Dd**2*b2*f**2*r*s + 594*Dd**2*b2*f**2*r - 396*Dd**2*b2*f**2*s**2 + 594*Dd**2*b2*f**2*s - 198*Dd**2*b2*f**2 + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 + 792*Dd**2*f**2*g2*r**2 + 1584*Dd**2*f**2*g2*r*s - 1188*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 1188*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2)/(462*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**4*k2**4*(D1*(6*K*b1**2*(D1*(2*fd - fdd)*(2*r + 2*s - 1) - 2*Dd*fd*(4*r + 4*s - 3)) + b1*(40*C*D1*f*fd*r + 40*C*D1*f*fd*s - 20*C*D1*f*fd - 20*C*D1*f*fdd*r - 20*C*D1*f*fdd*s + 10*C*D1*f*fdd - 20*C*D1*fd**2*r - 20*C*D1*fd**2*s + 20*C*D1*fd**2 - 80*C*Dd*f*fd*r - 80*C*Dd*f*fd*s + 60*C*Dd*f*fd - 24*D1*K*bd1*f*r - 24*D1*K*bd1*f*s + 12*D1*K*bd1*f - 12*D1*K*bd1*fd*r - 12*D1*K*bd1*fd*s + 12*D1*K*bd1*fd + 12*D1*K*bdd1*f*r + 12*D1*K*bdd1*f*s - 6*D1*K*bdd1*f - 12*D1*K*f*fd*r**2 - 24*D1*K*f*fd*r*s + 12*D1*K*f*fd*r - 12*D1*K*f*fd*s**2 + 12*D1*K*f*fd*s - 6*D1*K*f*fd - 6*D1*bdd2*f*(r + s - 1)**2 - 20*D1*f*fd*r - 20*D1*f*fd*s + 10*D1*f*fd + 10*D1*f*fdd*r + 10*D1*f*fdd*s - 5*D1*f*fdd + 10*D1*fd**2*r + 10*D1*fd**2*s - 10*D1*fd**2 - 48*D1*fd*g2*r - 48*D1*fd*g2*s + 24*D1*fd*g2 + 24*D1*fd*gd2*r + 24*D1*fd*gd2*s - 24*D1*fd*gd2 + 24*D1*fdd*g2*r + 24*D1*fdd*g2*s - 12*D1*fdd*g2 + 48*Dd*K*bd1*f*r + 48*Dd*K*bd1*f*s - 36*Dd*K*bd1*f - 24*Dd*K*f**2*r**2 - 48*Dd*K*f**2*r*s + 36*Dd*K*f**2*r - 24*Dd*K*f**2*s**2 + 36*Dd*K*f**2*s - 18*Dd*K*f**2 + 40*Dd*f*fd*r + 40*Dd*f*fd*s - 30*Dd*f*fd + 96*Dd*fd*g2*r + 96*Dd*fd*g2*s - 72*Dd*fd*g2 + 12*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3))) + f*(20*C*D1*bdd1*f*r + 20*C*D1*bdd1*f*s - 10*C*D1*bdd1*f - 30*C*D1*f*fd*r**2 - 60*C*D1*f*fd*r*s + 40*C*D1*f*fd*r - 30*C*D1*f*fd*s**2 + 40*C*D1*f*fd*s - 20*C*D1*f*fd - 40*C*Dd*f**2*r**2 - 80*C*Dd*f**2*r*s + 60*C*Dd*f**2*r - 40*C*Dd*f**2*s**2 + 60*C*Dd*f**2*s - 30*C*Dd*f**2 + 12*D1*K*bd1**2*(r + s - 1) - 6*D1*bd2*f*r**2 - 12*D1*bd2*f*r*s + 12*D1*bd2*f*r - 6*D1*bd2*f*s**2 + 12*D1*bd2*f*s - 6*D1*bd2*f - 10*D1*bdd1*f*r - 10*D1*bdd1*f*s + 5*D1*bdd1*f - 24*D1*bdd1*g2*r - 24*D1*bdd1*g2*s + 12*D1*bdd1*g2 + 15*D1*f*fd*r**2 + 30*D1*f*fd*r*s - 20*D1*f*fd*r + 15*D1*f*fd*s**2 - 20*D1*f*fd*s + 10*D1*f*fd + 12*D1*f*gd2*r**2 + 24*D1*f*gd2*r*s - 24*D1*f*gd2*r + 12*D1*f*gd2*s**2 - 24*D1*f*gd2*s + 12*D1*f*gd2 + 24*D1*fd*g2*r**2 + 48*D1*fd*g2*r*s - 24*D1*fd*g2*r + 24*D1*fd*g2*s**2 - 24*D1*fd*g2*s + 12*D1*fd*g2 + 20*Dd*f**2*r**2 + 40*Dd*f**2*r*s - 30*Dd*f**2*r + 20*Dd*f**2*s**2 - 30*Dd*f**2*s + 15*Dd*f**2 + 48*Dd*f*g2*r**2 + 96*Dd*f*g2*r*s - 72*Dd*f*g2*r + 48*Dd*f*g2*s**2 - 72*Dd*f*g2*s + 36*Dd*f*g2 - 2*bd1*(6*D1*bd2*(r + s - 1)**2 + D1*(f*(10*C*(2*r + 2*s - 1) + 3*K*(r + s - 1)**2 - 10*r - 10*s + 5) + fd*(5 - 10*C)*(r + s - 1) - 12*g2*(2*r + 2*s - 1) + 12*gd2*(r + s - 1)) - Dd*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3)))) + 6*b2*(2*D1**2*b1*fd*r**2 + 4*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r**2 - 2*D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r**2 + 16*D1*Dd*b1*f*r*s - 12*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 12*D1*Dd*b1*f*s + 6*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r**2 - 16*D1*Dd*b1*fd*r*s + 6*D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 6*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 4*D1*Ddd*b1*f*r**2 - 8*D1*Ddd*b1*f*r*s + 6*D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 6*D1*Ddd*b1*f*s - 3*D1*Ddd*b1*f + 2*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*b1*f*r**2 - 24*Dd**2*b1*f*r*s + 18*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 18*Dd**2*b1*f*s - 6*Dd**2*b1*f))/(21*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**4*k2**2*(-D1*(r + s)*(12*D1*K*bd1**2*f*(r + s - 1) + D1*bdd1*f*(r + s)*(6*b2 + f*(10*C - 5) - 12*g2) + 2*bd1*(-10*C*D1*f**2*r - 10*C*D1*f**2*s + 20*C*D1*f*fd*r + 20*C*D1*f*fd*s - 20*C*D1*f*fd + 40*C*Dd*f**2*r + 40*C*Dd*f**2*s - 30*C*Dd*f**2 + 6*D1*bd2*f*(r + s - 1) + 5*D1*f**2*r + 5*D1*f**2*s - 10*D1*f*fd*r - 10*D1*f*fd*s + 10*D1*f*fd + 12*D1*f*g2*r + 12*D1*f*g2*s - 12*D1*f*gd2*r - 12*D1*f*gd2*s + 12*D1*f*gd2 - 12*D1*fd*g2*r - 12*D1*fd*g2*s + 12*D1*fd*g2 - 20*Dd*f**2*r - 20*Dd*f**2*s + 15*Dd*f**2 - 48*Dd*f*g2*r - 48*Dd*f*g2*s + 36*Dd*f*g2 + 6*b2*(-D1*f*(r + s) + D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))) + 6*K*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(40*C*D1**2*f*fd*r**2 + 80*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*r + 40*C*D1**2*f*fd*s**2 - 80*C*D1**2*f*fd*s + 40*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 - 40*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 40*C*D1**2*f*fdd*s - 20*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 - 40*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 40*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 + 80*C*D1*Dd*f**2*r**2 + 160*C*D1*Dd*f**2*r*s - 120*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s**2 - 120*C*D1*Dd*f**2*s + 60*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 - 320*C*D1*Dd*f*fd*r*s + 280*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 280*C*D1*Dd*f*fd*s - 120*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 - 80*C*D1*Ddd*f**2*r*s + 60*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 60*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 - 240*C*Dd**2*f**2*r*s + 180*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 180*C*Dd**2*f**2*s - 60*C*Dd**2*f**2 + 24*D1**2*K*bd1*f*r**2 + 48*D1**2*K*bd1*f*r*s - 24*D1**2*K*bd1*f*r + 24*D1**2*K*bd1*f*s**2 - 24*D1**2*K*bd1*f*s + 12*D1**2*K*bd1*f - 24*D1**2*K*bd1*fd*r**2 - 48*D1**2*K*bd1*fd*r*s + 36*D1**2*K*bd1*fd*r - 24*D1**2*K*bd1*fd*s**2 + 36*D1**2*K*bd1*fd*s - 12*D1**2*K*bd1*fd - 12*D1**2*K*bdd1*f*r**2 - 24*D1**2*K*bdd1*f*r*s + 12*D1**2*K*bdd1*f*r - 12*D1**2*K*bdd1*f*s**2 + 12*D1**2*K*bdd1*f*s - 6*D1**2*K*bdd1*f + 12*D1**2*b2*fd*r**2 + 24*D1**2*b2*fd*r*s - 24*D1**2*b2*fd*r + 12*D1**2*b2*fd*s**2 - 24*D1**2*b2*fd*s + 12*D1**2*b2*fd - 6*D1**2*b2*fdd*r**2 - 12*D1**2*b2*fdd*r*s + 12*D1**2*b2*fdd*r - 6*D1**2*b2*fdd*s**2 + 12*D1**2*b2*fdd*s - 6*D1**2*b2*fdd - 6*D1**2*bdd2*f*(r + s - 1)**2 - 20*D1**2*f*fd*r**2 - 40*D1**2*f*fd*r*s + 40*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 40*D1**2*f*fd*s - 20*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 10*D1**2*f*fdd - 24*D1**2*f*gd2*r**2 - 48*D1**2*f*gd2*r*s + 48*D1**2*f*gd2*r - 24*D1**2*f*gd2*s**2 + 48*D1**2*f*gd2*s - 24*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*r + 12*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s + 12*D1**2*f*gdd2 + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 20*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s + 10*D1**2*fd**2 - 24*D1**2*fd*g2*r**2 - 48*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*r - 24*D1**2*fd*g2*s**2 + 48*D1**2*fd*g2*s - 24*D1**2*fd*g2 + 24*D1**2*fd*gd2*r**2 + 48*D1**2*fd*gd2*r*s - 48*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 48*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r**2 + 24*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r + 12*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 - 96*D1*Dd*K*bd1*f*r**2 - 192*D1*Dd*K*bd1*f*r*s + 120*D1*Dd*K*bd1*f*r - 96*D1*Dd*K*bd1*f*s**2 + 120*D1*Dd*K*bd1*f*s - 36*D1*Dd*K*bd1*f + 48*D1*Dd*b2*f*r**2 + 96*D1*Dd*b2*f*r*s - 72*D1*Dd*b2*f*r + 48*D1*Dd*b2*f*s**2 - 72*D1*Dd*b2*f*s + 36*D1*Dd*b2*f - 48*D1*Dd*b2*fd*r**2 - 96*D1*Dd*b2*fd*r*s + 84*D1*Dd*b2*fd*r - 48*D1*Dd*b2*fd*s**2 + 84*D1*Dd*b2*fd*s - 36*D1*Dd*b2*fd - 40*D1*Dd*f**2*r**2 - 80*D1*Dd*f**2*r*s + 60*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 60*D1*Dd*f**2*s - 30*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 140*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 140*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 96*D1*Dd*f*g2*r**2 - 192*D1*Dd*f*g2*r*s + 144*D1*Dd*f*g2*r - 96*D1*Dd*f*g2*s**2 + 144*D1*Dd*f*g2*s - 72*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 192*D1*Dd*f*gd2*r*s - 168*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 168*D1*Dd*f*gd2*s + 72*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 192*D1*Dd*fd*g2*r*s - 168*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s + 72*D1*Dd*fd*g2 - 24*D1*Ddd*b2*f*r**2 - 48*D1*Ddd*b2*f*r*s + 36*D1*Ddd*b2*f*r - 24*D1*Ddd*b2*f*s**2 + 36*D1*Ddd*b2*f*s - 18*D1*Ddd*b2*f + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 96*D1*Ddd*f*g2*r*s - 72*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 72*D1*Ddd*f*g2*s + 36*D1*Ddd*f*g2 + 12*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 72*Dd**2*b2*f*r**2 - 144*Dd**2*b2*f*r*s + 108*Dd**2*b2*f*r - 72*Dd**2*b2*f*s**2 + 108*Dd**2*b2*f*s - 36*Dd**2*b2*f + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 288*Dd**2*f*g2*r*s - 216*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 216*Dd**2*f*g2*s + 72*Dd**2*f*g2))/(21*d**2*k3**2) - 5*D1**2*Pk2*Pkdd3*ct**3*f**2*k1**7*(D1**2*(f*(38*fd - 45*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 270*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(38*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 90*Dd*fd*(4*r + 4*s - 3)**2 - 45*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 270*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1287*d**2*k2*k3**6) - 2*D1**2*Pk2*Pkdd3*ct**3*f*k1**3*k2**3*st**4*(1560*C*D1**2*f*fd*r**2 + 3120*C*D1**2*f*fd*r*s - 2080*C*D1**2*f*fd*r + 1560*C*D1**2*f*fd*s**2 - 2080*C*D1**2*f*fd*s + 1040*C*D1**2*f*fd - 780*C*D1**2*f*fdd*r**2 - 1560*C*D1**2*f*fdd*r*s + 1040*C*D1**2*f*fdd*r - 780*C*D1**2*f*fdd*s**2 + 1040*C*D1**2*f*fdd*s - 520*C*D1**2*f*fdd - 1560*C*D1**2*fd**2*r**2 - 3120*C*D1**2*fd**2*r*s + 2080*C*D1**2*fd**2*r - 1560*C*D1**2*fd**2*s**2 + 2080*C*D1**2*fd**2*s - 520*C*D1**2*fd**2 + 2080*C*D1*Dd*f**2*r**2 + 4160*C*D1*Dd*f**2*r*s - 3120*C*D1*Dd*f**2*r + 2080*C*D1*Dd*f**2*s**2 - 3120*C*D1*Dd*f**2*s + 1560*C*D1*Dd*f**2 - 6240*C*D1*Dd*f*fd*r**2 - 12480*C*D1*Dd*f*fd*r*s + 8840*C*D1*Dd*f*fd*r - 6240*C*D1*Dd*f*fd*s**2 + 8840*C*D1*Dd*f*fd*s - 3120*C*D1*Dd*f*fd - 1040*C*D1*Ddd*f**2*r**2 - 2080*C*D1*Ddd*f**2*r*s + 1560*C*D1*Ddd*f**2*r - 1040*C*D1*Ddd*f**2*s**2 + 1560*C*D1*Ddd*f**2*s - 780*C*D1*Ddd*f**2 - 3120*C*Dd**2*f**2*r**2 - 6240*C*Dd**2*f**2*r*s + 4680*C*Dd**2*f**2*r - 3120*C*Dd**2*f**2*s**2 + 4680*C*Dd**2*f**2*s - 1560*C*Dd**2*f**2 + 429*D1**2*bd1*f*(K - 1)*(r + s - 1)**2 + 6220*D1**2*f**2*fd*r**2 + 12440*D1**2*f**2*fd*r*s - 9330*D1**2*f**2*fd*r + 6220*D1**2*f**2*fd*s**2 - 9330*D1**2*f**2*fd*s + 4665*D1**2*f**2*fd - 3500*D1**2*f**2*fdd*r**2 - 7000*D1**2*f**2*fdd*r*s + 5250*D1**2*f**2*fdd*r - 3500*D1**2*f**2*fdd*s**2 + 5250*D1**2*f**2*fdd*s - 2625*D1**2*f**2*fdd - 10500*D1**2*f*fd**2*r**2 - 21000*D1**2*f*fd**2*r*s + 15750*D1**2*f*fd**2*r - 10500*D1**2*f*fd**2*s**2 + 15750*D1**2*f*fd**2*s - 5250*D1**2*f*fd**2 - 1560*D1**2*f*fd*r**2 - 3120*D1**2*f*fd*r*s + 2080*D1**2*f*fd*r - 1560*D1**2*f*fd*s**2 + 2080*D1**2*f*fd*s - 1040*D1**2*f*fd + 780*D1**2*f*fdd*r**2 + 1560*D1**2*f*fdd*r*s - 1040*D1**2*f*fdd*r + 780*D1**2*f*fdd*s**2 - 1040*D1**2*f*fdd*s + 520*D1**2*f*fdd - 858*D1**2*f*gd2*r**2 - 1716*D1**2*f*gd2*r*s + 1716*D1**2*f*gd2*r - 858*D1**2*f*gd2*s**2 + 1716*D1**2*f*gd2*s - 858*D1**2*f*gd2 + 1560*D1**2*fd**2*r**2 + 3120*D1**2*fd**2*r*s - 2080*D1**2*fd**2*r + 1560*D1**2*fd**2*s**2 - 2080*D1**2*fd**2*s + 520*D1**2*fd**2 - 1716*D1**2*fd*g2*r**2 - 3432*D1**2*fd*g2*r*s + 1716*D1**2*fd*g2*r - 1716*D1**2*fd*g2*s**2 + 1716*D1**2*fd*g2*s - 858*D1**2*fd*g2 + 6220*D1*Dd*f**3*r**2 + 12440*D1*Dd*f**3*r*s - 9330*D1*Dd*f**3*r + 6220*D1*Dd*f**3*s**2 - 9330*D1*Dd*f**3*s + 4665*D1*Dd*f**3 - 28000*D1*Dd*f**2*fd*r**2 - 56000*D1*Dd*f**2*fd*r*s + 42000*D1*Dd*f**2*fd*r - 28000*D1*Dd*f**2*fd*s**2 + 42000*D1*Dd*f**2*fd*s - 15750*D1*Dd*f**2*fd - 2080*D1*Dd*f**2*r**2 - 4160*D1*Dd*f**2*r*s + 3120*D1*Dd*f**2*r - 2080*D1*Dd*f**2*s**2 + 3120*D1*Dd*f**2*s - 1560*D1*Dd*f**2 + 6240*D1*Dd*f*fd*r**2 + 12480*D1*Dd*f*fd*r*s - 8840*D1*Dd*f*fd*r + 6240*D1*Dd*f*fd*s**2 - 8840*D1*Dd*f*fd*s + 3120*D1*Dd*f*fd - 3432*D1*Dd*f*g2*r**2 - 6864*D1*Dd*f*g2*r*s + 5148*D1*Dd*f*g2*r - 3432*D1*Dd*f*g2*s**2 + 5148*D1*Dd*f*g2*s - 2574*D1*Dd*f*g2 - 3500*D1*Ddd*f**3*r**2 - 7000*D1*Ddd*f**3*r*s + 5250*D1*Ddd*f**3*r - 3500*D1*Ddd*f**3*s**2 + 5250*D1*Ddd*f**3*s - 2625*D1*Ddd*f**3 + 1040*D1*Ddd*f**2*r**2 + 2080*D1*Ddd*f**2*r*s - 1560*D1*Ddd*f**2*r + 1040*D1*Ddd*f**2*s**2 - 1560*D1*Ddd*f**2*s + 780*D1*Ddd*f**2 + 429*D1*b1*(K - 1)*(D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 10500*Dd**2*f**3*r**2 - 21000*Dd**2*f**3*r*s + 15750*Dd**2*f**3*r - 10500*Dd**2*f**3*s**2 + 15750*Dd**2*f**3*s - 5250*Dd**2*f**3 + 3120*Dd**2*f**2*r**2 + 6240*Dd**2*f**2*r*s - 4680*Dd**2*f**2*r + 3120*Dd**2*f**2*s**2 - 4680*Dd**2*f**2*s + 1560*Dd**2*f**2)/(3003*d**2*k3**6) + 5*D1**2*Pk2*Pkdd3*ct**3*f*k1*k2**5*st**4*(-7*D1**2*bdd1*f**2*(r + s - 1)**2 + 14*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + (-12*C + 7*b1 + 9)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**6) - 5*D1**2*Pk2*Pkdd3*ct**3*f*k1*k2**3*st**4*(-7*D1**2*bdd1*f**2*(r + s - 1)**2 + 14*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) + (7*b1 + 3)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**3*k1**5*k2*st**2*(13104*C*D1**2*f**2*fd*r**2 + 26208*C*D1**2*f**2*fd*r*s - 17472*C*D1**2*f**2*fd*r + 13104*C*D1**2*f**2*fd*s**2 - 17472*C*D1**2*f**2*fd*s + 8736*C*D1**2*f**2*fd - 11700*C*D1**2*f**2*fdd*r**2 - 23400*C*D1**2*f**2*fdd*r*s + 15600*C*D1**2*f**2*fdd*r - 11700*C*D1**2*f**2*fdd*s**2 + 15600*C*D1**2*f**2*fdd*s - 7800*C*D1**2*f**2*fdd - 23400*C*D1**2*f*fd**2*r**2 - 46800*C*D1**2*f*fd**2*r*s + 31200*C*D1**2*f*fd**2*r - 23400*C*D1**2*f*fd**2*s**2 + 31200*C*D1**2*f*fd**2*s - 7800*C*D1**2*f*fd**2 + 17472*C*D1*Dd*f**3*r**2 + 34944*C*D1*Dd*f**3*r*s - 26208*C*D1*Dd*f**3*r + 17472*C*D1*Dd*f**3*s**2 - 26208*C*D1*Dd*f**3*s + 13104*C*D1*Dd*f**3 - 93600*C*D1*Dd*f**2*fd*r**2 - 187200*C*D1*Dd*f**2*fd*r*s + 132600*C*D1*Dd*f**2*fd*r - 93600*C*D1*Dd*f**2*fd*s**2 + 132600*C*D1*Dd*f**2*fd*s - 46800*C*D1*Dd*f**2*fd - 15600*C*D1*Ddd*f**3*r**2 - 31200*C*D1*Ddd*f**3*r*s + 23400*C*D1*Ddd*f**3*r - 15600*C*D1*Ddd*f**3*s**2 + 23400*C*D1*Ddd*f**3*s - 11700*C*D1*Ddd*f**3 - 46800*C*Dd**2*f**3*r**2 - 93600*C*Dd**2*f**3*r*s + 70200*C*Dd**2*f**3*r - 46800*C*Dd**2*f**3*s**2 + 70200*C*Dd**2*f**3*s - 23400*C*Dd**2*f**3 + 6864*D1**2*K*b1*f*fd*r**2 + 13728*D1**2*K*b1*f*fd*r*s - 6864*D1**2*K*b1*f*fd*r + 6864*D1**2*K*b1*f*fd*s**2 - 6864*D1**2*K*b1*f*fd*s + 3432*D1**2*K*b1*f*fd - 5148*D1**2*K*b1*f*fdd*r**2 - 10296*D1**2*K*b1*f*fdd*r*s + 5148*D1**2*K*b1*f*fdd*r - 5148*D1**2*K*b1*f*fdd*s**2 + 5148*D1**2*K*b1*f*fdd*s - 2574*D1**2*K*b1*f*fdd - 5148*D1**2*K*b1*fd**2*r**2 - 10296*D1**2*K*b1*fd**2*r*s + 5148*D1**2*K*b1*fd**2*r - 5148*D1**2*K*b1*fd**2*s**2 + 5148*D1**2*K*b1*fd**2*s - 6864*D1**2*b1*f*fd*r**2 - 13728*D1**2*b1*f*fd*r*s + 6864*D1**2*b1*f*fd*r - 6864*D1**2*b1*f*fd*s**2 + 6864*D1**2*b1*f*fd*s - 3432*D1**2*b1*f*fd + 5148*D1**2*b1*f*fdd*r**2 + 10296*D1**2*b1*f*fdd*r*s - 5148*D1**2*b1*f*fdd*r + 5148*D1**2*b1*f*fdd*s**2 - 5148*D1**2*b1*f*fdd*s + 2574*D1**2*b1*f*fdd + 5148*D1**2*b1*fd**2*r**2 + 10296*D1**2*b1*fd**2*r*s - 5148*D1**2*b1*fd**2*r + 5148*D1**2*b1*fd**2*s**2 - 5148*D1**2*b1*fd**2*s - 2574*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 55100*D1**2*f**3*fd*r**2 + 110200*D1**2*f**3*fd*r*s - 82650*D1**2*f**3*fd*r + 55100*D1**2*f**3*fd*s**2 - 82650*D1**2*f**3*fd*s + 41325*D1**2*f**3*fd - 49000*D1**2*f**3*fdd*r**2 - 98000*D1**2*f**3*fdd*r*s + 73500*D1**2*f**3*fdd*r - 49000*D1**2*f**3*fdd*s**2 + 73500*D1**2*f**3*fdd*s - 36750*D1**2*f**3*fdd - 147000*D1**2*f**2*fd**2*r**2 - 294000*D1**2*f**2*fd**2*r*s + 220500*D1**2*f**2*fd**2*r - 147000*D1**2*f**2*fd**2*s**2 + 220500*D1**2*f**2*fd**2*s - 73500*D1**2*f**2*fd**2 - 13104*D1**2*f**2*fd*r**2 - 26208*D1**2*f**2*fd*r*s + 17472*D1**2*f**2*fd*r - 13104*D1**2*f**2*fd*s**2 + 17472*D1**2*f**2*fd*s - 8736*D1**2*f**2*fd + 11700*D1**2*f**2*fdd*r**2 + 23400*D1**2*f**2*fdd*r*s - 15600*D1**2*f**2*fdd*r + 11700*D1**2*f**2*fdd*s**2 - 15600*D1**2*f**2*fdd*s + 7800*D1**2*f**2*fdd - 6864*D1**2*f**2*gd2*r**2 - 13728*D1**2*f**2*gd2*r*s + 13728*D1**2*f**2*gd2*r - 6864*D1**2*f**2*gd2*s**2 + 13728*D1**2*f**2*gd2*s - 6864*D1**2*f**2*gd2 + 5148*D1**2*f**2*gdd2*r**2 + 10296*D1**2*f**2*gdd2*r*s - 10296*D1**2*f**2*gdd2*r + 5148*D1**2*f**2*gdd2*s**2 - 10296*D1**2*f**2*gdd2*s + 5148*D1**2*f**2*gdd2 + 23400*D1**2*f*fd**2*r**2 + 46800*D1**2*f*fd**2*r*s - 31200*D1**2*f*fd**2*r + 23400*D1**2*f*fd**2*s**2 - 31200*D1**2*f*fd**2*s + 7800*D1**2*f*fd**2 - 13728*D1**2*f*fd*g2*r**2 - 27456*D1**2*f*fd*g2*r*s + 13728*D1**2*f*fd*g2*r - 13728*D1**2*f*fd*g2*s**2 + 13728*D1**2*f*fd*g2*s - 6864*D1**2*f*fd*g2 + 20592*D1**2*f*fd*gd2*r**2 + 41184*D1**2*f*fd*gd2*r*s - 30888*D1**2*f*fd*gd2*r + 20592*D1**2*f*fd*gd2*s**2 - 30888*D1**2*f*fd*gd2*s + 10296*D1**2*f*fd*gd2 + 10296*D1**2*f*fdd*g2*r**2 + 20592*D1**2*f*fdd*g2*r*s - 10296*D1**2*f*fdd*g2*r + 10296*D1**2*f*fdd*g2*s**2 - 10296*D1**2*f*fdd*g2*s + 5148*D1**2*f*fdd*g2 + 10296*D1**2*fd**2*g2*r**2 + 20592*D1**2*fd**2*g2*r*s - 10296*D1**2*fd**2*g2*r + 10296*D1**2*fd**2*g2*s**2 - 10296*D1**2*fd**2*g2*s + 13728*D1*Dd*K*b1*f**2*r**2 + 27456*D1*Dd*K*b1*f**2*r*s - 20592*D1*Dd*K*b1*f**2*r + 13728*D1*Dd*K*b1*f**2*s**2 - 20592*D1*Dd*K*b1*f**2*s + 10296*D1*Dd*K*b1*f**2 - 41184*D1*Dd*K*b1*f*fd*r**2 - 82368*D1*Dd*K*b1*f*fd*r*s + 51480*D1*Dd*K*b1*f*fd*r - 41184*D1*Dd*K*b1*f*fd*s**2 + 51480*D1*Dd*K*b1*f*fd*s - 15444*D1*Dd*K*b1*f*fd - 13728*D1*Dd*b1*f**2*r**2 - 27456*D1*Dd*b1*f**2*r*s + 20592*D1*Dd*b1*f**2*r - 13728*D1*Dd*b1*f**2*s**2 + 20592*D1*Dd*b1*f**2*s - 10296*D1*Dd*b1*f**2 + 41184*D1*Dd*b1*f*fd*r**2 + 82368*D1*Dd*b1*f*fd*r*s - 51480*D1*Dd*b1*f*fd*r + 41184*D1*Dd*b1*f*fd*s**2 - 51480*D1*Dd*b1*f*fd*s + 15444*D1*Dd*b1*f*fd + 55100*D1*Dd*f**4*r**2 + 110200*D1*Dd*f**4*r*s - 82650*D1*Dd*f**4*r + 55100*D1*Dd*f**4*s**2 - 82650*D1*Dd*f**4*s + 41325*D1*Dd*f**4 - 392000*D1*Dd*f**3*fd*r**2 - 784000*D1*Dd*f**3*fd*r*s + 588000*D1*Dd*f**3*fd*r - 392000*D1*Dd*f**3*fd*s**2 + 588000*D1*Dd*f**3*fd*s - 220500*D1*Dd*f**3*fd - 17472*D1*Dd*f**3*r**2 - 34944*D1*Dd*f**3*r*s + 26208*D1*Dd*f**3*r - 17472*D1*Dd*f**3*s**2 + 26208*D1*Dd*f**3*s - 13104*D1*Dd*f**3 + 93600*D1*Dd*f**2*fd*r**2 + 187200*D1*Dd*f**2*fd*r*s - 132600*D1*Dd*f**2*fd*r + 93600*D1*Dd*f**2*fd*s**2 - 132600*D1*Dd*f**2*fd*s + 46800*D1*Dd*f**2*fd - 27456*D1*Dd*f**2*g2*r**2 - 54912*D1*Dd*f**2*g2*r*s + 41184*D1*Dd*f**2*g2*r - 27456*D1*Dd*f**2*g2*s**2 + 41184*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*g2 + 41184*D1*Dd*f**2*gd2*r**2 + 82368*D1*Dd*f**2*gd2*r*s - 72072*D1*Dd*f**2*gd2*r + 41184*D1*Dd*f**2*gd2*s**2 - 72072*D1*Dd*f**2*gd2*s + 30888*D1*Dd*f**2*gd2 + 82368*D1*Dd*f*fd*g2*r**2 + 164736*D1*Dd*f*fd*g2*r*s - 102960*D1*Dd*f*fd*g2*r + 82368*D1*Dd*f*fd*g2*s**2 - 102960*D1*Dd*f*fd*g2*s + 30888*D1*Dd*f*fd*g2 - 10296*D1*Ddd*K*b1*f**2*r**2 - 20592*D1*Ddd*K*b1*f**2*r*s + 15444*D1*Ddd*K*b1*f**2*r - 10296*D1*Ddd*K*b1*f**2*s**2 + 15444*D1*Ddd*K*b1*f**2*s - 7722*D1*Ddd*K*b1*f**2 + 10296*D1*Ddd*b1*f**2*r**2 + 20592*D1*Ddd*b1*f**2*r*s - 15444*D1*Ddd*b1*f**2*r + 10296*D1*Ddd*b1*f**2*s**2 - 15444*D1*Ddd*b1*f**2*s + 7722*D1*Ddd*b1*f**2 - 49000*D1*Ddd*f**4*r**2 - 98000*D1*Ddd*f**4*r*s + 73500*D1*Ddd*f**4*r - 49000*D1*Ddd*f**4*s**2 + 73500*D1*Ddd*f**4*s - 36750*D1*Ddd*f**4 + 15600*D1*Ddd*f**3*r**2 + 31200*D1*Ddd*f**3*r*s - 23400*D1*Ddd*f**3*r + 15600*D1*Ddd*f**3*s**2 - 23400*D1*Ddd*f**3*s + 11700*D1*Ddd*f**3 + 20592*D1*Ddd*f**2*g2*r**2 + 41184*D1*Ddd*f**2*g2*r*s - 30888*D1*Ddd*f**2*g2*r + 20592*D1*Ddd*f**2*g2*s**2 - 30888*D1*Ddd*f**2*g2*s + 15444*D1*Ddd*f**2*g2 + 1716*D1*bd1*f*(K - 1)*(r + s - 1)*(2*D1*f*(r + s - 1) - 3*D1*fd*(2*r + 2*s - 1) - 3*Dd*f*(4*r + 4*s - 3)) - 30888*Dd**2*K*b1*f**2*r**2 - 61776*Dd**2*K*b1*f**2*r*s + 46332*Dd**2*K*b1*f**2*r - 30888*Dd**2*K*b1*f**2*s**2 + 46332*Dd**2*K*b1*f**2*s - 15444*Dd**2*K*b1*f**2 + 30888*Dd**2*b1*f**2*r**2 + 61776*Dd**2*b1*f**2*r*s - 46332*Dd**2*b1*f**2*r + 30888*Dd**2*b1*f**2*s**2 - 46332*Dd**2*b1*f**2*s + 15444*Dd**2*b1*f**2 - 147000*Dd**2*f**4*r**2 - 294000*Dd**2*f**4*r*s + 220500*Dd**2*f**4*r - 147000*Dd**2*f**4*s**2 + 220500*Dd**2*f**4*s - 73500*Dd**2*f**4 + 46800*Dd**2*f**3*r**2 + 93600*Dd**2*f**3*r*s - 70200*Dd**2*f**3*r + 46800*Dd**2*f**3*s**2 - 70200*Dd**2*f**3*s + 23400*Dd**2*f**3 + 61776*Dd**2*f**2*g2*r**2 + 123552*Dd**2*f**2*g2*r*s - 92664*Dd**2*f**2*g2*r + 61776*Dd**2*f**2*g2*s**2 - 92664*Dd**2*f**2*g2*s + 30888*Dd**2*f**2*g2)/(9009*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**3*k1**5*k2*(1320*C*D1**2*bdd1*f**2*r**2 + 2640*C*D1**2*bdd1*f**2*r*s - 2640*C*D1**2*bdd1*f**2*r + 1320*C*D1**2*bdd1*f**2*s**2 - 2640*C*D1**2*bdd1*f**2*s + 1320*C*D1**2*bdd1*f**2 - 1380*C*D1**2*f**2*fd*r**2 - 2760*C*D1**2*f**2*fd*r*s + 1840*C*D1**2*f**2*fd*r - 1380*C*D1**2*f**2*fd*s**2 + 1840*C*D1**2*f**2*fd*s - 920*C*D1**2*f**2*fd + 1680*C*D1**2*f**2*fdd*r**2 + 3360*C*D1**2*f**2*fdd*r*s - 2240*C*D1**2*f**2*fdd*r + 1680*C*D1**2*f**2*fdd*s**2 - 2240*C*D1**2*f**2*fdd*s + 1120*C*D1**2*f**2*fdd + 3360*C*D1**2*f*fd**2*r**2 + 6720*C*D1**2*f*fd**2*r*s - 4480*C*D1**2*f*fd**2*r + 3360*C*D1**2*f*fd**2*s**2 - 4480*C*D1**2*f*fd**2*s + 1120*C*D1**2*f*fd**2 - 1840*C*D1*Dd*f**3*r**2 - 3680*C*D1*Dd*f**3*r*s + 2760*C*D1*Dd*f**3*r - 1840*C*D1*Dd*f**3*s**2 + 2760*C*D1*Dd*f**3*s - 1380*C*D1*Dd*f**3 + 13440*C*D1*Dd*f**2*fd*r**2 + 26880*C*D1*Dd*f**2*fd*r*s - 19040*C*D1*Dd*f**2*fd*r + 13440*C*D1*Dd*f**2*fd*s**2 - 19040*C*D1*Dd*f**2*fd*s + 6720*C*D1*Dd*f**2*fd + 2240*C*D1*Ddd*f**3*r**2 + 4480*C*D1*Ddd*f**3*r*s - 3360*C*D1*Ddd*f**3*r + 2240*C*D1*Ddd*f**3*s**2 - 3360*C*D1*Ddd*f**3*s + 1680*C*D1*Ddd*f**3 + 6720*C*Dd**2*f**3*r**2 + 13440*C*Dd**2*f**3*r*s - 10080*C*Dd**2*f**3*r + 6720*C*Dd**2*f**3*s**2 - 10080*C*Dd**2*f**3*s + 3360*C*Dd**2*f**3 + 330*D1**2*K*bdd1*f**2*r**2 + 660*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*r + 330*D1**2*K*bdd1*f**2*s**2 - 660*D1**2*K*bdd1*f**2*s + 330*D1**2*K*bdd1*f**2 + 1584*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 700*D1**2*bdd1*f**3*r**2 + 1400*D1**2*bdd1*f**3*r*s - 1400*D1**2*bdd1*f**3*r + 700*D1**2*bdd1*f**3*s**2 - 1400*D1**2*bdd1*f**3*s + 700*D1**2*bdd1*f**3 - 1485*D1**2*bdd1*f**2*r**2 - 2970*D1**2*bdd1*f**2*r*s + 2970*D1**2*bdd1*f**2*r - 1485*D1**2*bdd1*f**2*s**2 + 2970*D1**2*bdd1*f**2*s - 1485*D1**2*bdd1*f**2 - 1584*D1**2*bdd1*f*g2*r**2 - 3168*D1**2*bdd1*f*g2*r*s + 3168*D1**2*bdd1*f*g2*r - 1584*D1**2*bdd1*f*g2*s**2 + 3168*D1**2*bdd1*f*g2*s - 1584*D1**2*bdd1*f*g2 + 560*D1**2*f**3*fd*r**2 + 1120*D1**2*f**3*fd*r*s - 840*D1**2*f**3*fd*r + 560*D1**2*f**3*fd*s**2 - 840*D1**2*f**3*fd*s + 420*D1**2*f**3*fd + 1035*D1**2*f**2*fd*r**2 + 2070*D1**2*f**2*fd*r*s - 1380*D1**2*f**2*fd*r + 1035*D1**2*f**2*fd*s**2 - 1380*D1**2*f**2*fd*s + 690*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r**2 - 2520*D1**2*f**2*fdd*r*s + 1680*D1**2*f**2*fdd*r - 1260*D1**2*f**2*fdd*s**2 + 1680*D1**2*f**2*fdd*s - 840*D1**2*f**2*fdd + 528*D1**2*f**2*gd2*r**2 + 1056*D1**2*f**2*gd2*r*s - 1056*D1**2*f**2*gd2*r + 528*D1**2*f**2*gd2*s**2 - 1056*D1**2*f**2*gd2*s + 528*D1**2*f**2*gd2 - 660*D1**2*f**2*gdd2*r**2 - 1320*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*r - 660*D1**2*f**2*gdd2*s**2 + 1320*D1**2*f**2*gdd2*s - 660*D1**2*f**2*gdd2 - 2520*D1**2*f*fd**2*r**2 - 5040*D1**2*f*fd**2*r*s + 3360*D1**2*f*fd**2*r - 2520*D1**2*f*fd**2*s**2 + 3360*D1**2*f*fd**2*s - 840*D1**2*f*fd**2 + 1056*D1**2*f*fd*g2*r**2 + 2112*D1**2*f*fd*g2*r*s - 1056*D1**2*f*fd*g2*r + 1056*D1**2*f*fd*g2*s**2 - 1056*D1**2*f*fd*g2*s + 528*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r**2 - 5280*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r - 2640*D1**2*f*fd*gd2*s**2 + 3960*D1**2*f*fd*gd2*s - 1320*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r**2 - 2640*D1**2*f*fdd*g2*r*s + 1320*D1**2*f*fdd*g2*r - 1320*D1**2*f*fdd*g2*s**2 + 1320*D1**2*f*fdd*g2*s - 660*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r**2 - 2640*D1**2*fd**2*g2*r*s + 1320*D1**2*fd**2*g2*r - 1320*D1**2*fd**2*g2*s**2 + 1320*D1**2*fd**2*g2*s + 560*D1*Dd*f**4*r**2 + 1120*D1*Dd*f**4*r*s - 840*D1*Dd*f**4*r + 560*D1*Dd*f**4*s**2 - 840*D1*Dd*f**4*s + 420*D1*Dd*f**4 + 1380*D1*Dd*f**3*r**2 + 2760*D1*Dd*f**3*r*s - 2070*D1*Dd*f**3*r + 1380*D1*Dd*f**3*s**2 - 2070*D1*Dd*f**3*s + 1035*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r**2 - 20160*D1*Dd*f**2*fd*r*s + 14280*D1*Dd*f**2*fd*r - 10080*D1*Dd*f**2*fd*s**2 + 14280*D1*Dd*f**2*fd*s - 5040*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*g2*r**2 + 4224*D1*Dd*f**2*g2*r*s - 3168*D1*Dd*f**2*g2*r + 2112*D1*Dd*f**2*g2*s**2 - 3168*D1*Dd*f**2*g2*s + 1584*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r**2 - 10560*D1*Dd*f**2*gd2*r*s + 9240*D1*Dd*f**2*gd2*r - 5280*D1*Dd*f**2*gd2*s**2 + 9240*D1*Dd*f**2*gd2*s - 3960*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r**2 - 21120*D1*Dd*f*fd*g2*r*s + 13200*D1*Dd*f*fd*g2*r - 10560*D1*Dd*f*fd*g2*s**2 + 13200*D1*Dd*f*fd*g2*s - 3960*D1*Dd*f*fd*g2 - 1680*D1*Ddd*f**3*r**2 - 3360*D1*Ddd*f**3*r*s + 2520*D1*Ddd*f**3*r - 1680*D1*Ddd*f**3*s**2 + 2520*D1*Ddd*f**3*s - 1260*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r**2 - 5280*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r - 2640*D1*Ddd*f**2*g2*s**2 + 3960*D1*Ddd*f**2*g2*s - 1980*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(370*f**3*(r + s - 1) + 2*f**2*(264*C*(r + s - 1) - 350*fd*(3*r + 3*s - 2) + (66*K - 297)*(r + s - 1)) - 33*f*(5*fd*(8*C + 2*K - 9)*(2*r + 2*s - 1) + (20*g2 - 48*gd2)*(r + s - 1)) + 1584*fd*g2*(r + s)) - Dd*f*(700*f**2 + 165*f*(8*C + 2*K - 9) - 1584*g2)*(4*r + 4*s - 3))*(r + s - 1) - 5040*Dd**2*f**3*r**2 - 10080*Dd**2*f**3*r*s + 7560*Dd**2*f**3*r - 5040*Dd**2*f**3*s**2 + 7560*Dd**2*f**3*s - 2520*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r**2 - 15840*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r - 7920*Dd**2*f**2*g2*s**2 + 11880*Dd**2*f**2*g2*s - 3960*Dd**2*f**2*g2 - 132*b1**2*(K - 1)*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-2112*C*D1**2*f*fd*r**2 - 4224*C*D1**2*f*fd*r*s + 2112*C*D1**2*f*fd*r - 2112*C*D1**2*f*fd*s**2 + 2112*C*D1**2*f*fd*s - 1056*C*D1**2*f*fd + 2640*C*D1**2*f*fdd*r**2 + 5280*C*D1**2*f*fdd*r*s - 2640*C*D1**2*f*fdd*r + 2640*C*D1**2*f*fdd*s**2 - 2640*C*D1**2*f*fdd*s + 1320*C*D1**2*f*fdd + 2640*C*D1**2*fd**2*r**2 + 5280*C*D1**2*fd**2*r*s - 2640*C*D1**2*fd**2*r + 2640*C*D1**2*fd**2*s**2 - 2640*C*D1**2*fd**2*s - 4224*C*D1*Dd*f**2*r**2 - 8448*C*D1*Dd*f**2*r*s + 6336*C*D1*Dd*f**2*r - 4224*C*D1*Dd*f**2*s**2 + 6336*C*D1*Dd*f**2*s - 3168*C*D1*Dd*f**2 + 21120*C*D1*Dd*f*fd*r**2 + 42240*C*D1*Dd*f*fd*r*s - 26400*C*D1*Dd*f*fd*r + 21120*C*D1*Dd*f*fd*s**2 - 26400*C*D1*Dd*f*fd*s + 7920*C*D1*Dd*f*fd + 5280*C*D1*Ddd*f**2*r**2 + 10560*C*D1*Ddd*f**2*r*s - 7920*C*D1*Ddd*f**2*r + 5280*C*D1*Ddd*f**2*s**2 - 7920*C*D1*Ddd*f**2*s + 3960*C*D1*Ddd*f**2 + 15840*C*Dd**2*f**2*r**2 + 31680*C*Dd**2*f**2*r*s - 23760*C*Dd**2*f**2*r + 15840*C*Dd**2*f**2*s**2 - 23760*C*Dd**2*f**2*s + 7920*C*Dd**2*f**2 - 528*D1**2*K*f*fd*r**2 - 1056*D1**2*K*f*fd*r*s + 528*D1**2*K*f*fd*r - 528*D1**2*K*f*fd*s**2 + 528*D1**2*K*f*fd*s - 264*D1**2*K*f*fd + 660*D1**2*K*f*fdd*r**2 + 1320*D1**2*K*f*fdd*r*s - 660*D1**2*K*f*fdd*r + 660*D1**2*K*f*fdd*s**2 - 660*D1**2*K*f*fdd*s + 330*D1**2*K*f*fdd + 660*D1**2*K*fd**2*r**2 + 1320*D1**2*K*fd**2*r*s - 660*D1**2*K*fd**2*r + 660*D1**2*K*fd**2*s**2 - 660*D1**2*K*fd**2*s + 1584*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 2220*D1**2*f**2*fd*r**2 - 4440*D1**2*f**2*fd*r*s + 2960*D1**2*f**2*fd*r - 2220*D1**2*f**2*fd*s**2 + 2960*D1**2*f**2*fd*s - 1480*D1**2*f**2*fd + 2100*D1**2*f**2*fdd*r**2 + 4200*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 2100*D1**2*f**2*fdd*s**2 - 2800*D1**2*f**2*fdd*s + 1400*D1**2*f**2*fdd + 4200*D1**2*f*fd**2*r**2 + 8400*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 4200*D1**2*f*fd**2*s**2 - 5600*D1**2*f*fd**2*s + 1400*D1**2*f*fd**2 + 2376*D1**2*f*fd*r**2 + 4752*D1**2*f*fd*r*s - 2376*D1**2*f*fd*r + 2376*D1**2*f*fd*s**2 - 2376*D1**2*f*fd*s + 1188*D1**2*f*fd - 2970*D1**2*f*fdd*r**2 - 5940*D1**2*f*fdd*r*s + 2970*D1**2*f*fdd*r - 2970*D1**2*f*fdd*s**2 + 2970*D1**2*f*fdd*s - 1485*D1**2*f*fdd + 1320*D1**2*f*gd2*r**2 + 2640*D1**2*f*gd2*r*s - 2640*D1**2*f*gd2*r + 1320*D1**2*f*gd2*s**2 - 2640*D1**2*f*gd2*s + 1320*D1**2*f*gd2 - 1584*D1**2*f*gdd2*r**2 - 3168*D1**2*f*gdd2*r*s + 3168*D1**2*f*gdd2*r - 1584*D1**2*f*gdd2*s**2 + 3168*D1**2*f*gdd2*s - 1584*D1**2*f*gdd2 - 2970*D1**2*fd**2*r**2 - 5940*D1**2*fd**2*r*s + 2970*D1**2*fd**2*r - 2970*D1**2*fd**2*s**2 + 2970*D1**2*fd**2*s + 1320*D1**2*fd*g2*r**2 + 2640*D1**2*fd*g2*r*s + 1320*D1**2*fd*g2*s**2 - 3168*D1**2*fd*gd2*r**2 - 6336*D1**2*fd*gd2*r*s + 3168*D1**2*fd*gd2*r - 3168*D1**2*fd*gd2*s**2 + 3168*D1**2*fd*gd2*s - 1584*D1**2*fdd*g2*r**2 - 3168*D1**2*fdd*g2*r*s - 1584*D1**2*fdd*g2*s**2 - 1056*D1*Dd*K*f**2*r**2 - 2112*D1*Dd*K*f**2*r*s + 1584*D1*Dd*K*f**2*r - 1056*D1*Dd*K*f**2*s**2 + 1584*D1*Dd*K*f**2*s - 792*D1*Dd*K*f**2 + 5280*D1*Dd*K*f*fd*r**2 + 10560*D1*Dd*K*f*fd*r*s - 6600*D1*Dd*K*f*fd*r + 5280*D1*Dd*K*f*fd*s**2 - 6600*D1*Dd*K*f*fd*s + 1980*D1*Dd*K*f*fd - 2960*D1*Dd*f**3*r**2 - 5920*D1*Dd*f**3*r*s + 4440*D1*Dd*f**3*r - 2960*D1*Dd*f**3*s**2 + 4440*D1*Dd*f**3*s - 2220*D1*Dd*f**3 + 16800*D1*Dd*f**2*fd*r**2 + 33600*D1*Dd*f**2*fd*r*s - 23800*D1*Dd*f**2*fd*r + 16800*D1*Dd*f**2*fd*s**2 - 23800*D1*Dd*f**2*fd*s + 8400*D1*Dd*f**2*fd + 4752*D1*Dd*f**2*r**2 + 9504*D1*Dd*f**2*r*s - 7128*D1*Dd*f**2*r + 4752*D1*Dd*f**2*s**2 - 7128*D1*Dd*f**2*s + 3564*D1*Dd*f**2 - 23760*D1*Dd*f*fd*r**2 - 47520*D1*Dd*f*fd*r*s + 29700*D1*Dd*f*fd*r - 23760*D1*Dd*f*fd*s**2 + 29700*D1*Dd*f*fd*s - 8910*D1*Dd*f*fd + 5280*D1*Dd*f*g2*r**2 + 10560*D1*Dd*f*g2*r*s - 7920*D1*Dd*f*g2*r + 5280*D1*Dd*f*g2*s**2 - 7920*D1*Dd*f*g2*s + 3960*D1*Dd*f*g2 - 12672*D1*Dd*f*gd2*r**2 - 25344*D1*Dd*f*gd2*r*s + 22176*D1*Dd*f*gd2*r - 12672*D1*Dd*f*gd2*s**2 + 22176*D1*Dd*f*gd2*s - 9504*D1*Dd*f*gd2 - 12672*D1*Dd*fd*g2*r**2 - 25344*D1*Dd*fd*g2*r*s + 9504*D1*Dd*fd*g2*r - 12672*D1*Dd*fd*g2*s**2 + 9504*D1*Dd*fd*g2*s + 1320*D1*Ddd*K*f**2*r**2 + 2640*D1*Ddd*K*f**2*r*s - 1980*D1*Ddd*K*f**2*r + 1320*D1*Ddd*K*f**2*s**2 - 1980*D1*Ddd*K*f**2*s + 990*D1*Ddd*K*f**2 + 2800*D1*Ddd*f**3*r**2 + 5600*D1*Ddd*f**3*r*s - 4200*D1*Ddd*f**3*r + 2800*D1*Ddd*f**3*s**2 - 4200*D1*Ddd*f**3*s + 2100*D1*Ddd*f**3 - 5940*D1*Ddd*f**2*r**2 - 11880*D1*Ddd*f**2*r*s + 8910*D1*Ddd*f**2*r - 5940*D1*Ddd*f**2*s**2 + 8910*D1*Ddd*f**2*s - 4455*D1*Ddd*f**2 - 6336*D1*Ddd*f*g2*r**2 - 12672*D1*Ddd*f*g2*r*s + 9504*D1*Ddd*f*g2*r - 6336*D1*Ddd*f*g2*s**2 + 9504*D1*Ddd*f*g2*s - 4752*D1*Ddd*f*g2 - 264*D1*bd1*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 3960*Dd**2*K*f**2*r**2 + 7920*Dd**2*K*f**2*r*s - 5940*Dd**2*K*f**2*r + 3960*Dd**2*K*f**2*s**2 - 5940*Dd**2*K*f**2*s + 1980*Dd**2*K*f**2 + 8400*Dd**2*f**3*r**2 + 16800*Dd**2*f**3*r*s - 12600*Dd**2*f**3*r + 8400*Dd**2*f**3*s**2 - 12600*Dd**2*f**3*s + 4200*Dd**2*f**3 - 17820*Dd**2*f**2*r**2 - 35640*Dd**2*f**2*r*s + 26730*Dd**2*f**2*r - 17820*Dd**2*f**2*s**2 + 26730*Dd**2*f**2*s - 8910*Dd**2*f**2 - 19008*Dd**2*f*g2*r**2 - 38016*Dd**2*f*g2*r*s + 28512*Dd**2*f*g2*r - 19008*Dd**2*f*g2*s**2 + 28512*Dd**2*f*g2*s - 9504*Dd**2*f*g2))/(693*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**3*k1**5*(-690*D1**2*b1*f**2*fd*r**2 - 1380*D1**2*b1*f**2*fd*r*s + 1150*D1**2*b1*f**2*fd*r - 690*D1**2*b1*f**2*fd*s**2 + 1150*D1**2*b1*f**2*fd*s - 575*D1**2*b1*f**2*fd + 840*D1**2*b1*f**2*fdd*r**2 + 1680*D1**2*b1*f**2*fdd*r*s - 1400*D1**2*b1*f**2*fdd*r + 840*D1**2*b1*f**2*fdd*s**2 - 1400*D1**2*b1*f**2*fdd*s + 700*D1**2*b1*f**2*fdd + 1680*D1**2*b1*f*fd**2*r**2 + 3360*D1**2*b1*f*fd**2*r*s - 2800*D1**2*b1*f*fd**2*r + 1680*D1**2*b1*f*fd**2*s**2 - 2800*D1**2*b1*f*fd**2*s + 1120*D1**2*b1*f*fd**2 - 264*D1**2*b1*f*fd*r**2 - 528*D1**2*b1*f*fd*r*s + 264*D1**2*b1*f*fd*r - 264*D1**2*b1*f*fd*s**2 + 264*D1**2*b1*f*fd*s - 132*D1**2*b1*f*fd + 330*D1**2*b1*f*fdd*r**2 + 660*D1**2*b1*f*fdd*r*s - 330*D1**2*b1*f*fdd*r + 330*D1**2*b1*f*fdd*s**2 - 330*D1**2*b1*f*fdd*s + 165*D1**2*b1*f*fdd + 330*D1**2*b1*fd**2*r**2 + 660*D1**2*b1*fd**2*r*s - 330*D1**2*b1*fd**2*r + 330*D1**2*b1*fd**2*s**2 - 330*D1**2*b1*fd**2*s + 5*D1**2*bdd1*f**2*(28*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 33*(r + s - 1)**2) - 345*D1**2*f**2*fd*r**2 - 690*D1**2*f**2*fd*r*s + 460*D1**2*f**2*fd*r - 345*D1**2*f**2*fd*s**2 + 460*D1**2*f**2*fd*s - 230*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 920*D1*Dd*b1*f**3*r**2 - 1840*D1*Dd*b1*f**3*r*s + 1380*D1*Dd*b1*f**3*r - 920*D1*Dd*b1*f**3*s**2 + 1380*D1*Dd*b1*f**3*s - 690*D1*Dd*b1*f**3 + 6720*D1*Dd*b1*f**2*fd*r**2 + 13440*D1*Dd*b1*f**2*fd*r*s - 10640*D1*Dd*b1*f**2*fd*r + 6720*D1*Dd*b1*f**2*fd*s**2 - 10640*D1*Dd*b1*f**2*fd*s + 4200*D1*Dd*b1*f**2*fd - 528*D1*Dd*b1*f**2*r**2 - 1056*D1*Dd*b1*f**2*r*s + 792*D1*Dd*b1*f**2*r - 528*D1*Dd*b1*f**2*s**2 + 792*D1*Dd*b1*f**2*s - 396*D1*Dd*b1*f**2 + 2640*D1*Dd*b1*f*fd*r**2 + 5280*D1*Dd*b1*f*fd*r*s - 3300*D1*Dd*b1*f*fd*r + 2640*D1*Dd*b1*f*fd*s**2 - 3300*D1*Dd*b1*f*fd*s + 990*D1*Dd*b1*f*fd - 460*D1*Dd*f**3*r**2 - 920*D1*Dd*f**3*r*s + 690*D1*Dd*f**3*r - 460*D1*Dd*f**3*s**2 + 690*D1*Dd*f**3*s - 345*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd + 1120*D1*Ddd*b1*f**3*r**2 + 2240*D1*Ddd*b1*f**3*r*s - 1680*D1*Ddd*b1*f**3*r + 1120*D1*Ddd*b1*f**3*s**2 - 1680*D1*Ddd*b1*f**3*s + 840*D1*Ddd*b1*f**3 + 660*D1*Ddd*b1*f**2*r**2 + 1320*D1*Ddd*b1*f**2*r*s - 990*D1*Ddd*b1*f**2*r + 660*D1*Ddd*b1*f**2*s**2 - 990*D1*Ddd*b1*f**2*s + 495*D1*Ddd*b1*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + D1*bd1*f*(D1*(-115*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*f*(r + s - 1)*(140*fd*(3*r + 3*s - 1) - 33*r - 33*s + 33) + 330*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 10*Dd*f*(4*r + 4*s - 3)*(28*f*(2*r + 2*s - 1) + 33*r + 33*s - 33)) + 3360*Dd**2*b1*f**3*r**2 + 6720*Dd**2*b1*f**3*r*s - 5040*Dd**2*b1*f**3*r + 3360*Dd**2*b1*f**3*s**2 - 5040*Dd**2*b1*f**3*s + 1680*Dd**2*b1*f**3 + 1980*Dd**2*b1*f**2*r**2 + 3960*Dd**2*b1*f**2*r*s - 2970*Dd**2*b1*f**2*r + 1980*Dd**2*b1*f**2*s**2 - 2970*Dd**2*b1*f**2*s + 990*Dd**2*b1*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3)/(693*d**2*k2*k3**4) - D1**2*Pk2*Pkdd3*ct**3*k1**3*k2**3*st**2*(-396*C*D1**2*bdd1*f**2*r**2 - 792*C*D1**2*bdd1*f**2*r*s + 792*C*D1**2*bdd1*f**2*r - 396*C*D1**2*bdd1*f**2*s**2 + 792*C*D1**2*bdd1*f**2*s - 396*C*D1**2*bdd1*f**2 + 6642*C*D1**2*f**2*fd*r**2 + 13284*C*D1**2*f**2*fd*r*s - 8856*C*D1**2*f**2*fd*r + 6642*C*D1**2*f**2*fd*s**2 - 8856*C*D1**2*f**2*fd*s + 4428*C*D1**2*f**2*fd - 5400*C*D1**2*f**2*fdd*r**2 - 10800*C*D1**2*f**2*fdd*r*s + 7200*C*D1**2*f**2*fdd*r - 5400*C*D1**2*f**2*fdd*s**2 + 7200*C*D1**2*f**2*fdd*s - 3600*C*D1**2*f**2*fdd - 10800*C*D1**2*f*fd**2*r**2 - 21600*C*D1**2*f*fd**2*r*s + 14400*C*D1**2*f*fd**2*r - 10800*C*D1**2*f*fd**2*s**2 + 14400*C*D1**2*f*fd**2*s - 3600*C*D1**2*f*fd**2 + 8856*C*D1*Dd*f**3*r**2 + 17712*C*D1*Dd*f**3*r*s - 13284*C*D1*Dd*f**3*r + 8856*C*D1*Dd*f**3*s**2 - 13284*C*D1*Dd*f**3*s + 6642*C*D1*Dd*f**3 - 43200*C*D1*Dd*f**2*fd*r**2 - 86400*C*D1*Dd*f**2*fd*r*s + 61200*C*D1*Dd*f**2*fd*r - 43200*C*D1*Dd*f**2*fd*s**2 + 61200*C*D1*Dd*f**2*fd*s - 21600*C*D1*Dd*f**2*fd - 7200*C*D1*Ddd*f**3*r**2 - 14400*C*D1*Ddd*f**3*r*s + 10800*C*D1*Ddd*f**3*r - 7200*C*D1*Ddd*f**3*s**2 + 10800*C*D1*Ddd*f**3*s - 5400*C*D1*Ddd*f**3 - 21600*C*Dd**2*f**3*r**2 - 43200*C*Dd**2*f**3*r*s + 32400*C*Dd**2*f**3*r - 21600*C*Dd**2*f**3*s**2 + 32400*C*Dd**2*f**3*s - 10800*C*Dd**2*f**3 - 1188*D1**2*K*bdd1*f**2*r**2 - 2376*D1**2*K*bdd1*f**2*r*s + 2376*D1**2*K*bdd1*f**2*r - 1188*D1**2*K*bdd1*f**2*s**2 + 2376*D1**2*K*bdd1*f**2*s - 1188*D1**2*K*bdd1*f**2 - 396*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 625*D1**2*bdd1*f**3*r**2 + 1250*D1**2*bdd1*f**3*r*s - 1250*D1**2*bdd1*f**3*r + 625*D1**2*bdd1*f**3*s**2 - 1250*D1**2*bdd1*f**3*s + 625*D1**2*bdd1*f**3 + 990*D1**2*bdd1*f**2*r**2 + 1980*D1**2*bdd1*f**2*r*s - 1980*D1**2*bdd1*f**2*r + 990*D1**2*bdd1*f**2*s**2 - 1980*D1**2*bdd1*f**2*s + 990*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r**2 + 792*D1**2*bdd1*f*g2*r*s - 792*D1**2*bdd1*f*g2*r + 396*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 1500*D1**2*f**3*fd*r**2 - 3000*D1**2*f**3*fd*r*s + 2250*D1**2*f**3*fd*r - 1500*D1**2*f**3*fd*s**2 + 2250*D1**2*f**3*fd*s - 1125*D1**2*f**3*fd - 4833*D1**2*f**2*fd*r**2 - 9666*D1**2*f**2*fd*r*s + 6444*D1**2*f**2*fd*r - 4833*D1**2*f**2*fd*s**2 + 6444*D1**2*f**2*fd*s - 3222*D1**2*f**2*fd + 4050*D1**2*f**2*fdd*r**2 + 8100*D1**2*f**2*fdd*r*s - 5400*D1**2*f**2*fdd*r + 4050*D1**2*f**2*fdd*s**2 - 5400*D1**2*f**2*fdd*s + 2700*D1**2*f**2*fdd - 3366*D1**2*f**2*gd2*r**2 - 6732*D1**2*f**2*gd2*r*s + 6732*D1**2*f**2*gd2*r - 3366*D1**2*f**2*gd2*s**2 + 6732*D1**2*f**2*gd2*s - 3366*D1**2*f**2*gd2 + 2376*D1**2*f**2*gdd2*r**2 + 4752*D1**2*f**2*gdd2*r*s - 4752*D1**2*f**2*gdd2*r + 2376*D1**2*f**2*gdd2*s**2 - 4752*D1**2*f**2*gdd2*s + 2376*D1**2*f**2*gdd2 + 8100*D1**2*f*fd**2*r**2 + 16200*D1**2*f*fd**2*r*s - 10800*D1**2*f*fd**2*r + 8100*D1**2*f*fd**2*s**2 - 10800*D1**2*f*fd**2*s + 2700*D1**2*f*fd**2 - 6732*D1**2*f*fd*g2*r**2 - 13464*D1**2*f*fd*g2*r*s + 6732*D1**2*f*fd*g2*r - 6732*D1**2*f*fd*g2*s**2 + 6732*D1**2*f*fd*g2*s - 3366*D1**2*f*fd*g2 + 9504*D1**2*f*fd*gd2*r**2 + 19008*D1**2*f*fd*gd2*r*s - 14256*D1**2*f*fd*gd2*r + 9504*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 4752*D1**2*f*fd*gd2 + 4752*D1**2*f*fdd*g2*r**2 + 9504*D1**2*f*fdd*g2*r*s - 4752*D1**2*f*fdd*g2*r + 4752*D1**2*f*fdd*g2*s**2 - 4752*D1**2*f*fdd*g2*s + 2376*D1**2*f*fdd*g2 + 4752*D1**2*fd**2*g2*r**2 + 9504*D1**2*fd**2*g2*r*s - 4752*D1**2*fd**2*g2*r + 4752*D1**2*fd**2*g2*s**2 - 4752*D1**2*fd**2*g2*s - 1500*D1*Dd*f**4*r**2 - 3000*D1*Dd*f**4*r*s + 2250*D1*Dd*f**4*r - 1500*D1*Dd*f**4*s**2 + 2250*D1*Dd*f**4*s - 1125*D1*Dd*f**4 - 6444*D1*Dd*f**3*r**2 - 12888*D1*Dd*f**3*r*s + 9666*D1*Dd*f**3*r - 6444*D1*Dd*f**3*s**2 + 9666*D1*Dd*f**3*s - 4833*D1*Dd*f**3 + 32400*D1*Dd*f**2*fd*r**2 + 64800*D1*Dd*f**2*fd*r*s - 45900*D1*Dd*f**2*fd*r + 32400*D1*Dd*f**2*fd*s**2 - 45900*D1*Dd*f**2*fd*s + 16200*D1*Dd*f**2*fd - 13464*D1*Dd*f**2*g2*r**2 - 26928*D1*Dd*f**2*g2*r*s + 20196*D1*Dd*f**2*g2*r - 13464*D1*Dd*f**2*g2*s**2 + 20196*D1*Dd*f**2*g2*s - 10098*D1*Dd*f**2*g2 + 19008*D1*Dd*f**2*gd2*r**2 + 38016*D1*Dd*f**2*gd2*r*s - 33264*D1*Dd*f**2*gd2*r + 19008*D1*Dd*f**2*gd2*s**2 - 33264*D1*Dd*f**2*gd2*s + 14256*D1*Dd*f**2*gd2 + 38016*D1*Dd*f*fd*g2*r**2 + 76032*D1*Dd*f*fd*g2*r*s - 47520*D1*Dd*f*fd*g2*r + 38016*D1*Dd*f*fd*g2*s**2 - 47520*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 + 5400*D1*Ddd*f**3*r**2 + 10800*D1*Ddd*f**3*r*s - 8100*D1*Ddd*f**3*r + 5400*D1*Ddd*f**3*s**2 - 8100*D1*Ddd*f**3*s + 4050*D1*Ddd*f**3 + 9504*D1*Ddd*f**2*g2*r**2 + 19008*D1*Ddd*f**2*g2*r*s - 14256*D1*Ddd*f**2*g2*r + 9504*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 7128*D1*Ddd*f**2*g2 - D1*bd1*(D1*(689*f**3*(r + s - 1) - f**2*(726*C*(r + s - 1) + 1250*fd*(3*r + 3*s - 2) + (1683*K - 1518)*(r + s - 1)) + 66*f*(6*fd*(2*C + 6*K - 5)*(2*r + 2*s - 1) + (19*g2 - 12*gd2)*(r + s - 1)) - 792*fd*g2*(r + s)) - 2*Dd*f*(625*f**2 - 198*f*(2*C + 6*K - 5) + 396*g2)*(4*r + 4*s - 3))*(r + s - 1) + 16200*Dd**2*f**3*r**2 + 32400*Dd**2*f**3*r*s - 24300*Dd**2*f**3*r + 16200*Dd**2*f**3*s**2 - 24300*Dd**2*f**3*s + 8100*Dd**2*f**3 + 28512*Dd**2*f**2*g2*r**2 + 57024*Dd**2*f**2*g2*r*s - 42768*Dd**2*f**2*g2*r + 28512*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 14256*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*(19*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(19*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(1452*C*D1**2*f*fd*r**2 + 2904*C*D1**2*f*fd*r*s - 1452*C*D1**2*f*fd*r + 1452*C*D1**2*f*fd*s**2 - 1452*C*D1**2*f*fd*s + 726*C*D1**2*f*fd - 792*C*D1**2*f*fdd*r**2 - 1584*C*D1**2*f*fdd*r*s + 792*C*D1**2*f*fdd*r - 792*C*D1**2*f*fdd*s**2 + 792*C*D1**2*f*fdd*s - 396*C*D1**2*f*fdd - 792*C*D1**2*fd**2*r**2 - 1584*C*D1**2*fd**2*r*s + 792*C*D1**2*fd**2*r - 792*C*D1**2*fd**2*s**2 + 792*C*D1**2*fd**2*s + 2904*C*D1*Dd*f**2*r**2 + 5808*C*D1*Dd*f**2*r*s - 4356*C*D1*Dd*f**2*r + 2904*C*D1*Dd*f**2*s**2 - 4356*C*D1*Dd*f**2*s + 2178*C*D1*Dd*f**2 - 6336*C*D1*Dd*f*fd*r**2 - 12672*C*D1*Dd*f*fd*r*s + 7920*C*D1*Dd*f*fd*r - 6336*C*D1*Dd*f*fd*s**2 + 7920*C*D1*Dd*f*fd*s - 2376*C*D1*Dd*f*fd - 1584*C*D1*Ddd*f**2*r**2 - 3168*C*D1*Ddd*f**2*r*s + 2376*C*D1*Ddd*f**2*r - 1584*C*D1*Ddd*f**2*s**2 + 2376*C*D1*Ddd*f**2*s - 1188*C*D1*Ddd*f**2 - 4752*C*Dd**2*f**2*r**2 - 9504*C*Dd**2*f**2*r*s + 7128*C*Dd**2*f**2*r - 4752*C*Dd**2*f**2*s**2 + 7128*C*Dd**2*f**2*s - 2376*C*Dd**2*f**2 + 3366*D1**2*K*f*fd*r**2 + 6732*D1**2*K*f*fd*r*s - 3366*D1**2*K*f*fd*r + 3366*D1**2*K*f*fd*s**2 - 3366*D1**2*K*f*fd*s + 1683*D1**2*K*f*fd - 2376*D1**2*K*f*fdd*r**2 - 4752*D1**2*K*f*fdd*r*s + 2376*D1**2*K*f*fdd*r - 2376*D1**2*K*f*fdd*s**2 + 2376*D1**2*K*f*fdd*s - 1188*D1**2*K*f*fdd - 2376*D1**2*K*fd**2*r**2 - 4752*D1**2*K*fd**2*r*s + 2376*D1**2*K*fd**2*r - 2376*D1**2*K*fd**2*s**2 + 2376*D1**2*K*fd**2*s - 396*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 - 2067*D1**2*f**2*fd*r**2 - 4134*D1**2*f**2*fd*r*s + 2756*D1**2*f**2*fd*r - 2067*D1**2*f**2*fd*s**2 + 2756*D1**2*f**2*fd*s - 1378*D1**2*f**2*fd + 1875*D1**2*f**2*fdd*r**2 + 3750*D1**2*f**2*fdd*r*s - 2500*D1**2*f**2*fdd*r + 1875*D1**2*f**2*fdd*s**2 - 2500*D1**2*f**2*fdd*s + 1250*D1**2*f**2*fdd + 3750*D1**2*f*fd**2*r**2 + 7500*D1**2*f*fd**2*r*s - 5000*D1**2*f*fd**2*r + 3750*D1**2*f*fd**2*s**2 - 5000*D1**2*f*fd**2*s + 1250*D1**2*f*fd**2 - 3036*D1**2*f*fd*r**2 - 6072*D1**2*f*fd*r*s + 3036*D1**2*f*fd*r - 3036*D1**2*f*fd*s**2 + 3036*D1**2*f*fd*s - 1518*D1**2*f*fd + 1980*D1**2*f*fdd*r**2 + 3960*D1**2*f*fdd*r*s - 1980*D1**2*f*fdd*r + 1980*D1**2*f*fdd*s**2 - 1980*D1**2*f*fdd*s + 990*D1**2*f*fdd - 1254*D1**2*f*gd2*r**2 - 2508*D1**2*f*gd2*r*s + 2508*D1**2*f*gd2*r - 1254*D1**2*f*gd2*s**2 + 2508*D1**2*f*gd2*s - 1254*D1**2*f*gd2 + 396*D1**2*f*gdd2*r**2 + 792*D1**2*f*gdd2*r*s - 792*D1**2*f*gdd2*r + 396*D1**2*f*gdd2*s**2 - 792*D1**2*f*gdd2*s + 396*D1**2*f*gdd2 + 1980*D1**2*fd**2*r**2 + 3960*D1**2*fd**2*r*s - 1980*D1**2*fd**2*r + 1980*D1**2*fd**2*s**2 - 1980*D1**2*fd**2*s - 1254*D1**2*fd*g2*r**2 - 2508*D1**2*fd*g2*r*s - 1254*D1**2*fd*g2*s**2 + 792*D1**2*fd*gd2*r**2 + 1584*D1**2*fd*gd2*r*s - 792*D1**2*fd*gd2*r + 792*D1**2*fd*gd2*s**2 - 792*D1**2*fd*gd2*s + 396*D1**2*fdd*g2*r**2 + 792*D1**2*fdd*g2*r*s + 396*D1**2*fdd*g2*s**2 + 6732*D1*Dd*K*f**2*r**2 + 13464*D1*Dd*K*f**2*r*s - 10098*D1*Dd*K*f**2*r + 6732*D1*Dd*K*f**2*s**2 - 10098*D1*Dd*K*f**2*s + 5049*D1*Dd*K*f**2 - 19008*D1*Dd*K*f*fd*r**2 - 38016*D1*Dd*K*f*fd*r*s + 23760*D1*Dd*K*f*fd*r - 19008*D1*Dd*K*f*fd*s**2 + 23760*D1*Dd*K*f*fd*s - 7128*D1*Dd*K*f*fd - 2756*D1*Dd*f**3*r**2 - 5512*D1*Dd*f**3*r*s + 4134*D1*Dd*f**3*r - 2756*D1*Dd*f**3*s**2 + 4134*D1*Dd*f**3*s - 2067*D1*Dd*f**3 + 15000*D1*Dd*f**2*fd*r**2 + 30000*D1*Dd*f**2*fd*r*s - 21250*D1*Dd*f**2*fd*r + 15000*D1*Dd*f**2*fd*s**2 - 21250*D1*Dd*f**2*fd*s + 7500*D1*Dd*f**2*fd - 6072*D1*Dd*f**2*r**2 - 12144*D1*Dd*f**2*r*s + 9108*D1*Dd*f**2*r - 6072*D1*Dd*f**2*s**2 + 9108*D1*Dd*f**2*s - 4554*D1*Dd*f**2 + 15840*D1*Dd*f*fd*r**2 + 31680*D1*Dd*f*fd*r*s - 19800*D1*Dd*f*fd*r + 15840*D1*Dd*f*fd*s**2 - 19800*D1*Dd*f*fd*s + 5940*D1*Dd*f*fd - 5016*D1*Dd*f*g2*r**2 - 10032*D1*Dd*f*g2*r*s + 7524*D1*Dd*f*g2*r - 5016*D1*Dd*f*g2*s**2 + 7524*D1*Dd*f*g2*s - 3762*D1*Dd*f*g2 + 3168*D1*Dd*f*gd2*r**2 + 6336*D1*Dd*f*gd2*r*s - 5544*D1*Dd*f*gd2*r + 3168*D1*Dd*f*gd2*s**2 - 5544*D1*Dd*f*gd2*s + 2376*D1*Dd*f*gd2 + 3168*D1*Dd*fd*g2*r**2 + 6336*D1*Dd*fd*g2*r*s - 2376*D1*Dd*fd*g2*r + 3168*D1*Dd*fd*g2*s**2 - 2376*D1*Dd*fd*g2*s - 4752*D1*Ddd*K*f**2*r**2 - 9504*D1*Ddd*K*f**2*r*s + 7128*D1*Ddd*K*f**2*r - 4752*D1*Ddd*K*f**2*s**2 + 7128*D1*Ddd*K*f**2*s - 3564*D1*Ddd*K*f**2 + 2500*D1*Ddd*f**3*r**2 + 5000*D1*Ddd*f**3*r*s - 3750*D1*Ddd*f**3*r + 2500*D1*Ddd*f**3*s**2 - 3750*D1*Ddd*f**3*s + 1875*D1*Ddd*f**3 + 3960*D1*Ddd*f**2*r**2 + 7920*D1*Ddd*f**2*r*s - 5940*D1*Ddd*f**2*r + 3960*D1*Ddd*f**2*s**2 - 5940*D1*Ddd*f**2*s + 2970*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r**2 + 3168*D1*Ddd*f*g2*r*s - 2376*D1*Ddd*f*g2*r + 1584*D1*Ddd*f*g2*s**2 - 2376*D1*Ddd*f*g2*s + 1188*D1*Ddd*f*g2 + 66*D1*bd1*(K - 1)*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 14256*Dd**2*K*f**2*r**2 - 28512*Dd**2*K*f**2*r*s + 21384*Dd**2*K*f**2*r - 14256*Dd**2*K*f**2*s**2 + 21384*Dd**2*K*f**2*s - 7128*Dd**2*K*f**2 + 7500*Dd**2*f**3*r**2 + 15000*Dd**2*f**3*r*s - 11250*Dd**2*f**3*r + 7500*Dd**2*f**3*s**2 - 11250*Dd**2*f**3*s + 3750*Dd**2*f**3 + 11880*Dd**2*f**2*r**2 + 23760*Dd**2*f**2*r*s - 17820*Dd**2*f**2*r + 11880*Dd**2*f**2*s**2 - 17820*Dd**2*f**2*s + 5940*Dd**2*f**2 + 4752*Dd**2*f*g2*r**2 + 9504*Dd**2*f*g2*r*s - 7128*Dd**2*f*g2*r + 4752*Dd**2*f*g2*s**2 - 7128*Dd**2*f*g2*s + 2376*Dd**2*f*g2))/(693*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**3*k1**3*k2**3*(3960*C*D1**2*bdd1*f**2*r**2 + 7920*C*D1**2*bdd1*f**2*r*s - 7920*C*D1**2*bdd1*f**2*r + 3960*C*D1**2*bdd1*f**2*s**2 - 7920*C*D1**2*bdd1*f**2*s + 3960*C*D1**2*bdd1*f**2 - 780*C*D1**2*f**2*fd*r**2 - 1560*C*D1**2*f**2*fd*r*s + 1040*C*D1**2*f**2*fd*r - 780*C*D1**2*f**2*fd*s**2 + 1040*C*D1**2*f**2*fd*s - 520*C*D1**2*f**2*fd + 3360*C*D1**2*f**2*fdd*r**2 + 6720*C*D1**2*f**2*fdd*r*s - 4480*C*D1**2*f**2*fdd*r + 3360*C*D1**2*f**2*fdd*s**2 - 4480*C*D1**2*f**2*fdd*s + 2240*C*D1**2*f**2*fdd + 6720*C*D1**2*f*fd**2*r**2 + 13440*C*D1**2*f*fd**2*r*s - 8960*C*D1**2*f*fd**2*r + 6720*C*D1**2*f*fd**2*s**2 - 8960*C*D1**2*f*fd**2*s + 2240*C*D1**2*f*fd**2 - 1040*C*D1*Dd*f**3*r**2 - 2080*C*D1*Dd*f**3*r*s + 1560*C*D1*Dd*f**3*r - 1040*C*D1*Dd*f**3*s**2 + 1560*C*D1*Dd*f**3*s - 780*C*D1*Dd*f**3 + 26880*C*D1*Dd*f**2*fd*r**2 + 53760*C*D1*Dd*f**2*fd*r*s - 38080*C*D1*Dd*f**2*fd*r + 26880*C*D1*Dd*f**2*fd*s**2 - 38080*C*D1*Dd*f**2*fd*s + 13440*C*D1*Dd*f**2*fd + 4480*C*D1*Ddd*f**3*r**2 + 8960*C*D1*Ddd*f**3*r*s - 6720*C*D1*Ddd*f**3*r + 4480*C*D1*Ddd*f**3*s**2 - 6720*C*D1*Ddd*f**3*s + 3360*C*D1*Ddd*f**3 + 13440*C*Dd**2*f**3*r**2 + 26880*C*Dd**2*f**3*r*s - 20160*C*Dd**2*f**3*r + 13440*C*Dd**2*f**3*s**2 - 20160*C*Dd**2*f**3*s + 6720*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r**2 + 1320*D1**2*K*bdd1*f**2*r*s - 1320*D1**2*K*bdd1*f**2*r + 660*D1**2*K*bdd1*f**2*s**2 - 1320*D1**2*K*bdd1*f**2*s + 660*D1**2*K*bdd1*f**2 - 132*D1**2*bd1**2*f*(-36*K + 25*f + 18)*(r + s - 1)**2 - 2970*D1**2*bdd1*f**2*r**2 - 5940*D1**2*bdd1*f**2*r*s + 5940*D1**2*bdd1*f**2*r - 2970*D1**2*bdd1*f**2*s**2 + 5940*D1**2*bdd1*f**2*s - 2970*D1**2*bdd1*f**2 - 4752*D1**2*bdd1*f*g2*r**2 - 9504*D1**2*bdd1*f*g2*r*s + 9504*D1**2*bdd1*f*g2*r - 4752*D1**2*bdd1*f*g2*s**2 + 9504*D1**2*bdd1*f*g2*s - 4752*D1**2*bdd1*f*g2 - 105*D1**2*f**2*fd*r**2 - 210*D1**2*f**2*fd*r*s + 140*D1**2*f**2*fd*r - 105*D1**2*f**2*fd*s**2 + 140*D1**2*f**2*fd*s - 70*D1**2*f**2*fd - 1680*D1**2*f**2*fdd*r**2 - 3360*D1**2*f**2*fdd*r*s + 2240*D1**2*f**2*fdd*r - 1680*D1**2*f**2*fdd*s**2 + 2240*D1**2*f**2*fdd*s - 1120*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 1320*D1**2*f**2*gdd2*r**2 - 2640*D1**2*f**2*gdd2*r*s + 2640*D1**2*f**2*gdd2*r - 1320*D1**2*f**2*gdd2*s**2 + 2640*D1**2*f**2*gdd2*s - 1320*D1**2*f**2*gdd2 - 3360*D1**2*f*fd**2*r**2 - 6720*D1**2*f*fd**2*r*s + 4480*D1**2*f*fd**2*r - 3360*D1**2*f*fd**2*s**2 + 4480*D1**2*f*fd**2*s - 1120*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r**2 - 10560*D1**2*f*fd*gd2*r*s + 7920*D1**2*f*fd*gd2*r - 5280*D1**2*f*fd*gd2*s**2 + 7920*D1**2*f*fd*gd2*s - 2640*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r**2 - 5280*D1**2*f*fdd*g2*r*s + 2640*D1**2*f*fdd*g2*r - 2640*D1**2*f*fdd*g2*s**2 + 2640*D1**2*f*fdd*g2*s - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r**2 - 5280*D1**2*fd**2*g2*r*s + 2640*D1**2*fd**2*g2*r - 2640*D1**2*fd**2*g2*s**2 + 2640*D1**2*fd**2*g2*s - 140*D1*Dd*f**3*r**2 - 280*D1*Dd*f**3*r*s + 210*D1*Dd*f**3*r - 140*D1*Dd*f**3*s**2 + 210*D1*Dd*f**3*s - 105*D1*Dd*f**3 - 13440*D1*Dd*f**2*fd*r**2 - 26880*D1*Dd*f**2*fd*r*s + 19040*D1*Dd*f**2*fd*r - 13440*D1*Dd*f**2*fd*s**2 + 19040*D1*Dd*f**2*fd*s - 6720*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r**2 - 21120*D1*Dd*f**2*gd2*r*s + 18480*D1*Dd*f**2*gd2*r - 10560*D1*Dd*f**2*gd2*s**2 + 18480*D1*Dd*f**2*gd2*s - 7920*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r**2 - 42240*D1*Dd*f*fd*g2*r*s + 26400*D1*Dd*f*fd*g2*r - 21120*D1*Dd*f*fd*g2*s**2 + 26400*D1*Dd*f*fd*g2*s - 7920*D1*Dd*f*fd*g2 - 2240*D1*Ddd*f**3*r**2 - 4480*D1*Ddd*f**3*r*s + 3360*D1*Ddd*f**3*r - 2240*D1*Ddd*f**3*s**2 + 3360*D1*Ddd*f**3*s - 1680*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r**2 - 10560*D1*Ddd*f**2*g2*r*s + 7920*D1*Ddd*f**2*g2*r - 5280*D1*Ddd*f**2*g2*s**2 + 7920*D1*Ddd*f**2*g2*s - 3960*D1*Ddd*f**2*g2 - 132*D1*bd1*(D1*(f**2*(24*C + K - 15)*(r + s - 1) - 5*f*fd*(12*C + 2*K - 9)*(2*r + 2*s - 1) - 6*f*(5*g2 - 12*gd2)*(r + s - 1) + 72*fd*g2*(r + s)) - Dd*f*(5*f*(12*C + 2*K - 9) - 72*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6720*Dd**2*f**3*r**2 - 13440*Dd**2*f**3*r*s + 10080*Dd**2*f**3*r - 6720*Dd**2*f**3*s**2 + 10080*Dd**2*f**3*s - 3360*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r**2 - 31680*Dd**2*f**2*g2*r*s + 23760*Dd**2*f**2*g2*r - 15840*Dd**2*f**2*g2*s**2 + 23760*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(2*f*(29*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(60*K - 23)*(r + s) - 36*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(58*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (60*K - 23)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 72*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(-36*K + 25*f + 18)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(-36*K + 25*f + 18)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 66*b1*(-96*C*D1**2*f*fd*r**2 - 192*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r - 96*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 48*C*D1**2*f*fd + 120*C*D1**2*f*fdd*r**2 + 240*C*D1**2*f*fdd*r*s - 120*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 120*C*D1**2*fd**2*r**2 + 240*C*D1**2*fd**2*r*s - 120*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 192*C*D1*Dd*f**2*r**2 - 384*C*D1*Dd*f**2*r*s + 288*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 144*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r**2 + 1920*C*D1*Dd*f*fd*r*s - 1200*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 1200*C*D1*Dd*f*fd*s + 360*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r**2 + 480*C*D1*Ddd*f**2*r*s - 360*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 360*C*D1*Ddd*f**2*s + 180*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r**2 + 1440*C*Dd**2*f**2*r*s - 1080*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 1080*C*Dd**2*f**2*s + 360*C*Dd**2*f**2 - 4*D1**2*K*f*fd*r**2 - 8*D1**2*K*f*fd*r*s + 4*D1**2*K*f*fd*r - 4*D1**2*K*f*fd*s**2 + 4*D1**2*K*f*fd*s - 2*D1**2*K*f*fd + 20*D1**2*K*f*fdd*r**2 + 40*D1**2*K*f*fdd*r*s - 20*D1**2*K*f*fdd*r + 20*D1**2*K*f*fdd*s**2 - 20*D1**2*K*f*fdd*s + 10*D1**2*K*f*fdd + 20*D1**2*K*fd**2*r**2 + 40*D1**2*K*fd**2*r*s - 20*D1**2*K*fd**2*r + 20*D1**2*K*fd**2*s**2 - 20*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-36*K + 25*f + 18)*(r + s - 1)**2 + 60*D1**2*f*fd*r**2 + 120*D1**2*f*fd*r*s - 60*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 60*D1**2*f*fd*s + 30*D1**2*f*fd - 90*D1**2*f*fdd*r**2 - 180*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*r - 90*D1**2*f*fdd*s**2 + 90*D1**2*f*fdd*s - 45*D1**2*f*fdd + 60*D1**2*f*gd2*r**2 + 120*D1**2*f*gd2*r*s - 120*D1**2*f*gd2*r + 60*D1**2*f*gd2*s**2 - 120*D1**2*f*gd2*s + 60*D1**2*f*gd2 - 72*D1**2*f*gdd2*r**2 - 144*D1**2*f*gdd2*r*s + 144*D1**2*f*gdd2*r - 72*D1**2*f*gdd2*s**2 + 144*D1**2*f*gdd2*s - 72*D1**2*f*gdd2 - 90*D1**2*fd**2*r**2 - 180*D1**2*fd**2*r*s + 90*D1**2*fd**2*r - 90*D1**2*fd**2*s**2 + 90*D1**2*fd**2*s + 60*D1**2*fd*g2*r**2 + 120*D1**2*fd*g2*r*s + 60*D1**2*fd*g2*s**2 - 144*D1**2*fd*gd2*r**2 - 288*D1**2*fd*gd2*r*s + 144*D1**2*fd*gd2*r - 144*D1**2*fd*gd2*s**2 + 144*D1**2*fd*gd2*s - 72*D1**2*fdd*g2*r**2 - 144*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*s**2 - 8*D1*Dd*K*f**2*r**2 - 16*D1*Dd*K*f**2*r*s + 12*D1*Dd*K*f**2*r - 8*D1*Dd*K*f**2*s**2 + 12*D1*Dd*K*f**2*s - 6*D1*Dd*K*f**2 + 160*D1*Dd*K*f*fd*r**2 + 320*D1*Dd*K*f*fd*r*s - 200*D1*Dd*K*f*fd*r + 160*D1*Dd*K*f*fd*s**2 - 200*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd + 120*D1*Dd*f**2*r**2 + 240*D1*Dd*f**2*r*s - 180*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 180*D1*Dd*f**2*s + 90*D1*Dd*f**2 - 720*D1*Dd*f*fd*r**2 - 1440*D1*Dd*f*fd*r*s + 900*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 270*D1*Dd*f*fd + 240*D1*Dd*f*g2*r**2 + 480*D1*Dd*f*g2*r*s - 360*D1*Dd*f*g2*r + 240*D1*Dd*f*g2*s**2 - 360*D1*Dd*f*g2*s + 180*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r**2 - 1152*D1*Dd*f*gd2*r*s + 1008*D1*Dd*f*gd2*r - 576*D1*Dd*f*gd2*s**2 + 1008*D1*Dd*f*gd2*s - 432*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r**2 - 1152*D1*Dd*fd*g2*r*s + 432*D1*Dd*fd*g2*r - 576*D1*Dd*fd*g2*s**2 + 432*D1*Dd*fd*g2*s + 40*D1*Ddd*K*f**2*r**2 + 80*D1*Ddd*K*f**2*r*s - 60*D1*Ddd*K*f**2*r + 40*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 30*D1*Ddd*K*f**2 - 180*D1*Ddd*f**2*r**2 - 360*D1*Ddd*f**2*r*s + 270*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 270*D1*Ddd*f**2*s - 135*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r**2 - 576*D1*Ddd*f*g2*r*s + 432*D1*Ddd*f*g2*r - 288*D1*Ddd*f*g2*s**2 + 432*D1*Ddd*f*g2*s - 216*D1*Ddd*f*g2 + D1*bd1*(D1*(58*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(60*K - 23)*(r + s - 1) + 72*fd*(2*K - 1)*(r + s)) - 4*Dd*f*(-36*K + 25*f + 18)*(4*r + 4*s - 3))*(r + s - 1) + 120*Dd**2*K*f**2*r**2 + 240*Dd**2*K*f**2*r*s - 180*Dd**2*K*f**2*r + 120*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 60*Dd**2*K*f**2 - 540*Dd**2*f**2*r**2 - 1080*Dd**2*f**2*r*s + 810*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 810*Dd**2*f**2*s - 270*Dd**2*f**2 - 864*Dd**2*f*g2*r**2 - 1728*Dd**2*f*g2*r*s + 1296*Dd**2*f*g2*r - 864*Dd**2*f*g2*s**2 + 1296*Dd**2*f*g2*s - 432*Dd**2*f*g2))/(693*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**3*k1**3*k2*st**2*(66*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*bd1*(D1*(-f**3*(497*r**2 + r*(994*s - 626) + 497*s**2 - 626*s + 313) + f**2*(250*fd*(9*r**2 + r*(18*s - 13) + 9*s**2 - 13*s + 4) - 11*r**2*(10*C + 17) - 11*r*(s*(20*C + 34) - 54) - 11*s**2*(10*C + 17) + 594*s - 297) + 22*f*(6*fd*(r + s - 1)*(r*(2*C + 4) + s*(2*C + 4) - 3) - (r + s)*(-13*g2*(r + s) + 6*gd2*(r + s - 1))) - 132*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(4*r + 4*s - 3)*(125*f**2*(3*r + 3*s - 2) + 66*f*(r*(C + 2) + s*(C + 2) - 3) - 66*g2*(r + s))) - 11*b1**2*(K - 1)*(D1**2*(13*fd - 3*fdd)*(r + s - 1)**2 + D1*(Dd*(13*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-220*C*D1**2*f*fd*r**2 - 440*C*D1**2*f*fd*r*s + 440*C*D1**2*f*fd*r - 220*C*D1**2*f*fd*s**2 + 440*C*D1**2*f*fd*s - 220*C*D1**2*f*fd + 132*C*D1**2*f*fdd*r**2 + 264*C*D1**2*f*fdd*r*s - 264*C*D1**2*f*fdd*r + 132*C*D1**2*f*fdd*s**2 - 264*C*D1**2*f*fdd*s + 132*C*D1**2*f*fdd + 132*C*D1**2*fd**2*r**2 + 264*C*D1**2*fd**2*r*s - 264*C*D1**2*fd**2*r + 132*C*D1**2*fd**2*s**2 - 264*C*D1**2*fd**2*s + 132*C*D1**2*fd**2 - 440*C*D1*Dd*f**2*r**2 - 880*C*D1*Dd*f**2*r*s + 660*C*D1*Dd*f**2*r - 440*C*D1*Dd*f**2*s**2 + 660*C*D1*Dd*f**2*s - 330*C*D1*Dd*f**2 + 1056*C*D1*Dd*f*fd*r**2 + 2112*C*D1*Dd*f*fd*r*s - 1848*C*D1*Dd*f*fd*r + 1056*C*D1*Dd*f*fd*s**2 - 1848*C*D1*Dd*f*fd*s + 792*C*D1*Dd*f*fd + 264*C*D1*Ddd*f**2*r**2 + 528*C*D1*Ddd*f**2*r*s - 396*C*D1*Ddd*f**2*r + 264*C*D1*Ddd*f**2*s**2 - 396*C*D1*Ddd*f**2*s + 198*C*D1*Ddd*f**2 + 792*C*Dd**2*f**2*r**2 + 1584*C*Dd**2*f**2*r*s - 1188*C*Dd**2*f**2*r + 792*C*Dd**2*f**2*s**2 - 1188*C*Dd**2*f**2*s + 396*C*Dd**2*f**2 + 33*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 1491*D1**2*f**2*fd*r**2 - 2982*D1**2*f**2*fd*r*s + 2356*D1**2*f**2*fd*r - 1491*D1**2*f**2*fd*s**2 + 2356*D1**2*f**2*fd*s - 1178*D1**2*f**2*fd + 1125*D1**2*f**2*fdd*r**2 + 2250*D1**2*f**2*fdd*r*s - 1750*D1**2*f**2*fdd*r + 1125*D1**2*f**2*fdd*s**2 - 1750*D1**2*f**2*fdd*s + 875*D1**2*f**2*fdd + 2250*D1**2*f*fd**2*r**2 + 4500*D1**2*f*fd**2*r*s - 3500*D1**2*f*fd**2*r + 2250*D1**2*f*fd**2*s**2 - 3500*D1**2*f*fd**2*s + 1250*D1**2*f*fd**2 - 374*D1**2*f*fd*r**2 - 748*D1**2*f*fd*r*s + 154*D1**2*f*fd*r - 374*D1**2*f*fd*s**2 + 154*D1**2*f*fd*s - 77*D1**2*f*fd + 264*D1**2*f*fdd*r**2 + 528*D1**2*f*fdd*r*s - 132*D1**2*f*fdd*r + 264*D1**2*f*fdd*s**2 - 132*D1**2*f*fdd*s + 66*D1**2*f*fdd + 286*D1**2*f*gd2*r**2 + 572*D1**2*f*gd2*r*s - 572*D1**2*f*gd2*r + 286*D1**2*f*gd2*s**2 - 572*D1**2*f*gd2*s + 286*D1**2*f*gd2 - 66*D1**2*f*gdd2*r**2 - 132*D1**2*f*gdd2*r*s + 132*D1**2*f*gdd2*r - 66*D1**2*f*gdd2*s**2 + 132*D1**2*f*gdd2*s - 66*D1**2*f*gdd2 + 264*D1**2*fd**2*r**2 + 528*D1**2*fd**2*r*s - 132*D1**2*fd**2*r + 264*D1**2*fd**2*s**2 - 132*D1**2*fd**2*s - 132*D1**2*fd**2 + 286*D1**2*fd*g2*r**2 + 572*D1**2*fd*g2*r*s - 572*D1**2*fd*g2*r + 286*D1**2*fd*g2*s**2 - 572*D1**2*fd*g2*s + 286*D1**2*fd*g2 - 132*D1**2*fd*gd2*r**2 - 264*D1**2*fd*gd2*r*s + 264*D1**2*fd*gd2*r - 132*D1**2*fd*gd2*s**2 + 264*D1**2*fd*gd2*s - 132*D1**2*fd*gd2 - 66*D1**2*fdd*g2*r**2 - 132*D1**2*fdd*g2*r*s + 132*D1**2*fdd*g2*r - 66*D1**2*fdd*g2*s**2 + 132*D1**2*fdd*g2*s - 66*D1**2*fdd*g2 - 1988*D1*Dd*f**3*r**2 - 3976*D1*Dd*f**3*r*s + 2982*D1*Dd*f**3*r - 1988*D1*Dd*f**3*s**2 + 2982*D1*Dd*f**3*s - 1491*D1*Dd*f**3 + 9000*D1*Dd*f**2*fd*r**2 + 18000*D1*Dd*f**2*fd*r*s - 13750*D1*Dd*f**2*fd*r + 9000*D1*Dd*f**2*fd*s**2 - 13750*D1*Dd*f**2*fd*s + 5250*D1*Dd*f**2*fd - 748*D1*Dd*f**2*r**2 - 1496*D1*Dd*f**2*r*s + 1122*D1*Dd*f**2*r - 748*D1*Dd*f**2*s**2 + 1122*D1*Dd*f**2*s - 561*D1*Dd*f**2 + 2112*D1*Dd*f*fd*r**2 + 4224*D1*Dd*f*fd*r*s - 2112*D1*Dd*f*fd*r + 2112*D1*Dd*f*fd*s**2 - 2112*D1*Dd*f*fd*s + 396*D1*Dd*f*fd + 1144*D1*Dd*f*g2*r**2 + 2288*D1*Dd*f*g2*r*s - 1716*D1*Dd*f*g2*r + 1144*D1*Dd*f*g2*s**2 - 1716*D1*Dd*f*g2*s + 858*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r**2 - 1056*D1*Dd*f*gd2*r*s + 924*D1*Dd*f*gd2*r - 528*D1*Dd*f*gd2*s**2 + 924*D1*Dd*f*gd2*s - 396*D1*Dd*f*gd2 - 528*D1*Dd*fd*g2*r**2 - 1056*D1*Dd*fd*g2*r*s + 924*D1*Dd*fd*g2*r - 528*D1*Dd*fd*g2*s**2 + 924*D1*Dd*fd*g2*s - 396*D1*Dd*fd*g2 + 1500*D1*Ddd*f**3*r**2 + 3000*D1*Ddd*f**3*r*s - 2250*D1*Ddd*f**3*r + 1500*D1*Ddd*f**3*s**2 - 2250*D1*Ddd*f**3*s + 1125*D1*Ddd*f**3 + 528*D1*Ddd*f**2*r**2 + 1056*D1*Ddd*f**2*r*s - 792*D1*Ddd*f**2*r + 528*D1*Ddd*f**2*s**2 - 792*D1*Ddd*f**2*s + 396*D1*Ddd*f**2 - 264*D1*Ddd*f*g2*r**2 - 528*D1*Ddd*f*g2*r*s + 396*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2*s**2 + 396*D1*Ddd*f*g2*s - 198*D1*Ddd*f*g2 - 11*D1*bd1*(K - 1)*(D1*(13*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 6*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 4500*Dd**2*f**3*r**2 + 9000*Dd**2*f**3*r*s - 6750*Dd**2*f**3*r + 4500*Dd**2*f**3*s**2 - 6750*Dd**2*f**3*s + 2250*Dd**2*f**3 + 1584*Dd**2*f**2*r**2 + 3168*Dd**2*f**2*r*s - 2376*Dd**2*f**2*r + 1584*Dd**2*f**2*s**2 - 2376*Dd**2*f**2*s + 792*Dd**2*f**2 - 792*Dd**2*f*g2*r**2 - 1584*Dd**2*f*g2*r*s + 1188*Dd**2*f*g2*r - 792*Dd**2*f*g2*s**2 + 1188*Dd**2*f*g2*s - 396*Dd**2*f*g2) + f*(D1**2*bdd1*(125*f**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 66*f*(r**2*(C + 2) + 2*r*(s*(C + 2) - 3) + s**2*(C + 2) - 6*s + 3) - 66*g2*(r + s)**2) - 3*D1**2*(f*(67*fd - 50*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 100*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 3*D1*f*(Dd*(67*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 100*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 50*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 900*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**3*k1**3*k2*(660*C*D1**2*bdd1*f**2*r**2 + 1320*C*D1**2*bdd1*f**2*r*s + 660*C*D1**2*bdd1*f**2*s**2 + 2760*C*D1**2*f**2*fd*r**2 + 5520*C*D1**2*f**2*fd*r*s - 3680*C*D1**2*f**2*fd*r + 2760*C*D1**2*f**2*fd*s**2 - 3680*C*D1**2*f**2*fd*s + 1840*C*D1**2*f**2*fd - 3360*C*D1**2*f**2*fdd*r**2 - 6720*C*D1**2*f**2*fdd*r*s + 4480*C*D1**2*f**2*fdd*r - 3360*C*D1**2*f**2*fdd*s**2 + 4480*C*D1**2*f**2*fdd*s - 2240*C*D1**2*f**2*fdd - 6720*C*D1**2*f*fd**2*r**2 - 13440*C*D1**2*f*fd**2*r*s + 8960*C*D1**2*f*fd**2*r - 6720*C*D1**2*f*fd**2*s**2 + 8960*C*D1**2*f*fd**2*s - 2240*C*D1**2*f*fd**2 + 3680*C*D1*Dd*f**3*r**2 + 7360*C*D1*Dd*f**3*r*s - 5520*C*D1*Dd*f**3*r + 3680*C*D1*Dd*f**3*s**2 - 5520*C*D1*Dd*f**3*s + 2760*C*D1*Dd*f**3 - 26880*C*D1*Dd*f**2*fd*r**2 - 53760*C*D1*Dd*f**2*fd*r*s + 38080*C*D1*Dd*f**2*fd*r - 26880*C*D1*Dd*f**2*fd*s**2 + 38080*C*D1*Dd*f**2*fd*s - 13440*C*D1*Dd*f**2*fd - 4480*C*D1*Ddd*f**3*r**2 - 8960*C*D1*Ddd*f**3*r*s + 6720*C*D1*Ddd*f**3*r - 4480*C*D1*Ddd*f**3*s**2 + 6720*C*D1*Ddd*f**3*s - 3360*C*D1*Ddd*f**3 - 13440*C*Dd**2*f**3*r**2 - 26880*C*Dd**2*f**3*r*s + 20160*C*Dd**2*f**3*r - 13440*C*Dd**2*f**3*s**2 + 20160*C*Dd**2*f**3*s - 6720*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r**2 - 1320*D1**2*K*bdd1*f**2*r*s + 1320*D1**2*K*bdd1*f**2*r - 660*D1**2*K*bdd1*f**2*s**2 + 1320*D1**2*K*bdd1*f**2*s - 660*D1**2*K*bdd1*f**2 + 1056*D1**2*b2*f*fd*r**2 + 2112*D1**2*b2*f*fd*r*s - 1056*D1**2*b2*f*fd*r + 1056*D1**2*b2*f*fd*s**2 - 1056*D1**2*b2*f*fd*s + 528*D1**2*b2*f*fd - 1320*D1**2*b2*f*fdd*r**2 - 2640*D1**2*b2*f*fdd*r*s + 1320*D1**2*b2*f*fdd*r - 1320*D1**2*b2*f*fdd*s**2 + 1320*D1**2*b2*f*fdd*s - 660*D1**2*b2*f*fdd - 1320*D1**2*b2*fd**2*r**2 - 2640*D1**2*b2*fd**2*r*s + 1320*D1**2*b2*fd**2*r - 1320*D1**2*b2*fd**2*s**2 + 1320*D1**2*b2*fd**2*s + 132*D1**2*bd1**2*(r + s - 1)*(15*f**2*(r + s - 1) + 3*f*(4*C*r + 4*C*s + 2*K*r + 2*K*s + r + s - 6) - 14*g2*(r + s)) + 528*D1**2*bd2*f**2*r**2 + 1056*D1**2*bd2*f**2*r*s - 1056*D1**2*bd2*f**2*r + 528*D1**2*bd2*f**2*s**2 - 1056*D1**2*bd2*f**2*s + 528*D1**2*bd2*f**2 - 2640*D1**2*bd2*f*fd*r**2 - 5280*D1**2*bd2*f*fd*r*s + 3960*D1**2*bd2*f*fd*r - 2640*D1**2*bd2*f*fd*s**2 + 3960*D1**2*bd2*f*fd*s - 1320*D1**2*bd2*f*fd + 495*D1**2*bdd1*f**2*r**2 + 990*D1**2*bdd1*f**2*r*s - 1980*D1**2*bdd1*f**2*r + 495*D1**2*bdd1*f**2*s**2 - 1980*D1**2*bdd1*f**2*s + 990*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r**2 - 1584*D1**2*bdd1*f*g2*r*s - 792*D1**2*bdd1*f*g2*s**2 - 660*D1**2*bdd2*f**2*r**2 - 1320*D1**2*bdd2*f**2*r*s + 1320*D1**2*bdd2*f**2*r - 660*D1**2*bdd2*f**2*s**2 + 1320*D1**2*bdd2*f**2*s - 660*D1**2*bdd2*f**2 - 885*D1**2*f**2*fd*r**2 - 1770*D1**2*f**2*fd*r*s + 1180*D1**2*f**2*fd*r - 885*D1**2*f**2*fd*s**2 + 1180*D1**2*f**2*fd*s - 590*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*r**2 + 3360*D1**2*f**2*fdd*r*s - 2240*D1**2*f**2*fdd*r + 1680*D1**2*f**2*fdd*s**2 - 2240*D1**2*f**2*fdd*s + 1120*D1**2*f**2*fdd - 1056*D1**2*f**2*gd2*r**2 - 2112*D1**2*f**2*gd2*r*s + 2112*D1**2*f**2*gd2*r - 1056*D1**2*f**2*gd2*s**2 + 2112*D1**2*f**2*gd2*s - 1056*D1**2*f**2*gd2 + 1320*D1**2*f**2*gdd2*r**2 + 2640*D1**2*f**2*gdd2*r*s - 2640*D1**2*f**2*gdd2*r + 1320*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 1320*D1**2*f**2*gdd2 + 3360*D1**2*f*fd**2*r**2 + 6720*D1**2*f*fd**2*r*s - 4480*D1**2*f*fd**2*r + 3360*D1**2*f*fd**2*s**2 - 4480*D1**2*f*fd**2*s + 1120*D1**2*f*fd**2 - 2112*D1**2*f*fd*g2*r**2 - 4224*D1**2*f*fd*g2*r*s + 2112*D1**2*f*fd*g2*r - 2112*D1**2*f*fd*g2*s**2 + 2112*D1**2*f*fd*g2*s - 1056*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r**2 + 10560*D1**2*f*fd*gd2*r*s - 7920*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r**2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r**2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s + 2112*D1*Dd*b2*f**2*r**2 + 4224*D1*Dd*b2*f**2*r*s - 3168*D1*Dd*b2*f**2*r + 2112*D1*Dd*b2*f**2*s**2 - 3168*D1*Dd*b2*f**2*s + 1584*D1*Dd*b2*f**2 - 10560*D1*Dd*b2*f*fd*r**2 - 21120*D1*Dd*b2*f*fd*r*s + 13200*D1*Dd*b2*f*fd*r - 10560*D1*Dd*b2*f*fd*s**2 + 13200*D1*Dd*b2*f*fd*s - 3960*D1*Dd*b2*f*fd - 5280*D1*Dd*bd2*f**2*r**2 - 10560*D1*Dd*bd2*f**2*r*s + 9240*D1*Dd*bd2*f**2*r - 5280*D1*Dd*bd2*f**2*s**2 + 9240*D1*Dd*bd2*f**2*s - 3960*D1*Dd*bd2*f**2 - 1180*D1*Dd*f**3*r**2 - 2360*D1*Dd*f**3*r*s + 1770*D1*Dd*f**3*r - 1180*D1*Dd*f**3*s**2 + 1770*D1*Dd*f**3*s - 885*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*r**2 + 26880*D1*Dd*f**2*fd*r*s - 19040*D1*Dd*f**2*fd*r + 13440*D1*Dd*f**2*fd*s**2 - 19040*D1*Dd*f**2*fd*s + 6720*D1*Dd*f**2*fd - 4224*D1*Dd*f**2*g2*r**2 - 8448*D1*Dd*f**2*g2*r*s + 6336*D1*Dd*f**2*g2*r - 4224*D1*Dd*f**2*g2*s**2 + 6336*D1*Dd*f**2*g2*s - 3168*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r**2 + 21120*D1*Dd*f**2*gd2*r*s - 18480*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 18480*D1*Dd*f**2*gd2*s + 7920*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r**2 + 42240*D1*Dd*f*fd*g2*r*s - 26400*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 26400*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 - 2640*D1*Ddd*b2*f**2*r**2 - 5280*D1*Ddd*b2*f**2*r*s + 3960*D1*Ddd*b2*f**2*r - 2640*D1*Ddd*b2*f**2*s**2 + 3960*D1*Ddd*b2*f**2*s - 1980*D1*Ddd*b2*f**2 + 2240*D1*Ddd*f**3*r**2 + 4480*D1*Ddd*f**3*r*s - 3360*D1*Ddd*f**3*r + 2240*D1*Ddd*f**3*s**2 - 3360*D1*Ddd*f**3*s + 1680*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r**2 + 10560*D1*Ddd*f**2*g2*r*s - 7920*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 3960*D1*Ddd*f**2*g2 + 33*D1*bd1*(D1*(5*f**3*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*f**2*(-4*C*s**2 + 4*K*(r + s - 1)**2 - r**2*(4*C + 3) - 2*r*(4*C*s + 3*s - 6) - 3*s**2 + 12*s - 6) - 4*f*(-5*fd*(r + s - 1)*(4*C*s + K*(-4*r - 4*s + 2) + r*(4*C + 3) + 3*s - 3) + (r + s)*(-5*g2*(r + s) + 12*gd2*(r + s - 1))) - 48*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(5*f*(-4*C*r - 4*C*s + 4*K*(r + s - 1) - 3*r - 3*s + 6) + 24*g2*(r + s))*(4*r + 4*s - 3)) - 7920*Dd**2*b2*f**2*r**2 - 15840*Dd**2*b2*f**2*r*s + 11880*Dd**2*b2*f**2*r - 7920*Dd**2*b2*f**2*s**2 + 11880*Dd**2*b2*f**2*s - 3960*Dd**2*b2*f**2 + 6720*Dd**2*f**3*r**2 + 13440*Dd**2*f**3*r*s - 10080*Dd**2*f**3*r + 6720*Dd**2*f**3*s**2 - 10080*Dd**2*f**3*s + 3360*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r**2 + 31680*Dd**2*f**2*g2*r*s - 23760*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 7920*Dd**2*f**2*g2 - 462*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1**2*(20*C*D1**2*fd*r**2 + 40*C*D1**2*fd*r*s - 40*C*D1**2*fd*r + 20*C*D1**2*fd*s**2 - 40*C*D1**2*fd*s + 20*C*D1**2*fd - 24*C*D1**2*fdd*r**2 - 48*C*D1**2*fdd*r*s + 48*C*D1**2*fdd*r - 24*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s - 24*C*D1**2*fdd + 80*C*D1*Dd*f*r**2 + 160*C*D1*Dd*f*r*s - 120*C*D1*Dd*f*r + 80*C*D1*Dd*f*s**2 - 120*C*D1*Dd*f*s + 60*C*D1*Dd*f - 192*C*D1*Dd*fd*r**2 - 384*C*D1*Dd*fd*r*s + 336*C*D1*Dd*fd*r - 192*C*D1*Dd*fd*s**2 + 336*C*D1*Dd*fd*s - 144*C*D1*Dd*fd - 96*C*D1*Ddd*f*r**2 - 192*C*D1*Ddd*f*r*s + 144*C*D1*Ddd*f*r - 96*C*D1*Ddd*f*s**2 + 144*C*D1*Ddd*f*s - 72*C*D1*Ddd*f - 288*C*Dd**2*f*r**2 - 576*C*Dd**2*f*r*s + 432*C*Dd**2*f*r - 288*C*Dd**2*f*s**2 + 432*C*Dd**2*f*s - 144*C*Dd**2*f + 10*D1**2*K*fd*r**2 + 20*D1**2*K*fd*r*s - 20*D1**2*K*fd*r + 10*D1**2*K*fd*s**2 - 20*D1**2*K*fd*s + 10*D1**2*K*fd - 12*D1**2*K*fdd*r**2 - 24*D1**2*K*fdd*r*s + 24*D1**2*K*fdd*r - 12*D1**2*K*fdd*s**2 + 24*D1**2*K*fdd*s - 12*D1**2*K*fdd - 14*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 72*D1**2*f*fd*r**2 + 144*D1**2*f*fd*r*s - 84*D1**2*f*fd*r + 72*D1**2*f*fd*s**2 - 84*D1**2*f*fd*s + 42*D1**2*f*fd - 60*D1**2*f*fdd*r**2 - 120*D1**2*f*fdd*r*s + 60*D1**2*f*fdd*r - 60*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s - 30*D1**2*f*fdd - 60*D1**2*fd**2*r**2 - 120*D1**2*fd**2*r*s + 60*D1**2*fd**2*r - 60*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s + 12*D1**2*fd*r**2 + 24*D1**2*fd*r*s + 50*D1**2*fd*r + 12*D1**2*fd*s**2 + 50*D1**2*fd*s - 25*D1**2*fd - 6*D1**2*fdd*r**2 - 12*D1**2*fdd*r*s - 60*D1**2*fdd*r - 6*D1**2*fdd*s**2 - 60*D1**2*fdd*s + 30*D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 + 40*D1*Dd*K*f*r**2 + 80*D1*Dd*K*f*r*s - 60*D1*Dd*K*f*r + 40*D1*Dd*K*f*s**2 - 60*D1*Dd*K*f*s + 30*D1*Dd*K*f - 96*D1*Dd*K*fd*r**2 - 192*D1*Dd*K*fd*r*s + 168*D1*Dd*K*fd*r - 96*D1*Dd*K*fd*s**2 + 168*D1*Dd*K*fd*s - 72*D1*Dd*K*fd + 144*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 216*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 216*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 480*D1*Dd*f*fd*r**2 - 960*D1*Dd*f*fd*r*s + 600*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 600*D1*Dd*f*fd*s - 180*D1*Dd*f*fd + 48*D1*Dd*f*r**2 + 96*D1*Dd*f*r*s - 72*D1*Dd*f*r + 48*D1*Dd*f*s**2 - 72*D1*Dd*f*s + 36*D1*Dd*f - 48*D1*Dd*fd*r**2 - 96*D1*Dd*fd*r*s - 204*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 - 204*D1*Dd*fd*s + 180*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 - 48*D1*Ddd*K*f*r**2 - 96*D1*Ddd*K*f*r*s + 72*D1*Ddd*K*f*r - 48*D1*Ddd*K*f*s**2 + 72*D1*Ddd*K*f*s - 36*D1*Ddd*K*f - 120*D1*Ddd*f**2*r**2 - 240*D1*Ddd*f**2*r*s + 180*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 90*D1*Ddd*f**2 - 24*D1*Ddd*f*r**2 - 48*D1*Ddd*f*r*s + 36*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 36*D1*Ddd*f*s - 18*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 144*Dd**2*K*f*r**2 - 288*Dd**2*K*f*r*s + 216*Dd**2*K*f*r - 144*Dd**2*K*f*s**2 + 216*Dd**2*K*f*s - 72*Dd**2*K*f - 360*Dd**2*f**2*r**2 - 720*Dd**2*f**2*r*s + 540*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 180*Dd**2*f**2 - 72*Dd**2*f*r**2 - 144*Dd**2*f*r*s + 108*Dd**2*f*r - 72*Dd**2*f*s**2 + 108*Dd**2*f*s - 36*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) + 33*b1*(-32*C*D1**2*f*fd*r**2 - 64*C*D1**2*f*fd*r*s + 64*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s**2 + 64*C*D1**2*f*fd*s - 32*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 80*C*D1**2*f*fdd*s + 40*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 80*C*D1**2*fd**2*s + 40*C*D1**2*fd**2 - 64*C*D1*Dd*f**2*r**2 - 128*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 560*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 560*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 + 32*D1**2*K*f*fd*r**2 + 64*D1**2*K*f*fd*r*s - 32*D1**2*K*f*fd*r + 32*D1**2*K*f*fd*s**2 - 32*D1**2*K*f*fd*s + 16*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r**2 - 80*D1**2*K*f*fdd*r*s + 40*D1**2*K*f*fdd*r - 40*D1**2*K*f*fdd*s**2 + 40*D1**2*K*f*fdd*s - 20*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r**2 - 80*D1**2*K*fd**2*r*s + 40*D1**2*K*fd**2*r - 40*D1**2*K*fd**2*s**2 + 40*D1**2*K*fd**2*s + 28*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(30*f**2*(r + s - 1)**2 + 3*f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) + 2*r**2 + 4*r*s - 14*r + 2*s**2 - 14*s + 7) - 14*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 50*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 50*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 24*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s - 24*D1**2*f*fd*s**2 + 30*D1**2*f*fdd*r**2 + 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*s**2 + 20*D1**2*f*gd2*r**2 + 40*D1**2*f*gd2*r*s - 40*D1**2*f*gd2*r + 20*D1**2*f*gd2*s**2 - 40*D1**2*f*gd2*s + 20*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 + 30*D1**2*fd**2*r**2 + 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*s**2 - 30*D1**2*fd**2 + 20*D1**2*fd*g2*r**2 + 40*D1**2*fd*g2*r*s - 40*D1**2*fd*g2*r + 20*D1**2*fd*g2*s**2 - 40*D1**2*fd*g2*s + 20*D1**2*fd*g2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 96*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 96*D1**2*fd*gd2*s - 48*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s + 48*D1**2*fdd*g2*r - 24*D1**2*fdd*g2*s**2 + 48*D1**2*fdd*g2*s - 24*D1**2*fdd*g2 + 64*D1*Dd*K*f**2*r**2 + 128*D1*Dd*K*f**2*r*s - 96*D1*Dd*K*f**2*r + 64*D1*Dd*K*f**2*s**2 - 96*D1*Dd*K*f**2*s + 48*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r**2 - 640*D1*Dd*K*f*fd*r*s + 400*D1*Dd*K*f*fd*r - 320*D1*Dd*K*f*fd*s**2 + 400*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 - 48*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 72*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 240*D1*Dd*f*fd*r**2 + 480*D1*Dd*f*fd*r*s - 180*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 180*D1*Dd*f*fd*s + 80*D1*Dd*f*g2*r**2 + 160*D1*Dd*f*g2*r*s - 120*D1*Dd*f*g2*r + 80*D1*Dd*f*g2*s**2 - 120*D1*Dd*f*g2*s + 60*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 336*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 336*D1*Dd*fd*g2*s - 144*D1*Dd*fd*g2 - 80*D1*Ddd*K*f**2*r**2 - 160*D1*Ddd*K*f**2*r*s + 120*D1*Ddd*K*f**2*r - 80*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 + 60*D1*Ddd*f**2*r**2 + 120*D1*Ddd*f**2*r*s - 90*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 90*D1*Ddd*f**2*s + 45*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + D1*bd1*(D1*(-6*f**2*(12*r**2 + r*(24*s - 22) + 12*s**2 - 22*s + 11) - f*(20*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 20*K*r**2 + 40*K*r*s - 20*K*r + 20*K*s**2 - 20*K*s + 10*K - 120*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 24*r**2 + 48*r*s - 98*r + 24*s**2 - 98*s + 49) + 12*fd*(r + s - 1)*(C*(8*r + 8*s - 4) + K*(4*r + 4*s - 2) + 2*r + 2*s + 5) + 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(4*r + 4*s - 3)*(30*f**2*(r + s - 1) + 3*f*(C*(8*r + 8*s - 4) + K*(4*r + 4*s - 2) + 2*r + 2*s - 7) - 14*g2*(2*r + 2*s - 1))) - 240*Dd**2*K*f**2*r**2 - 480*Dd**2*K*f**2*r*s + 360*Dd**2*K*f**2*r - 240*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 + 180*Dd**2*f**2*r**2 + 360*Dd**2*f**2*r*s - 270*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 270*Dd**2*f**2*s + 90*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(693*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**3*k1**3*(D1*f*(r + s)*(2*D1*bd1**2*(5*f + 6)*(r + s - 1) + 5*D1*bdd1*f*(r + s) + bd1*(-4*D1*f*(r + s) + 20*D1*fd*(r + s - 1) + 10*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(10*fd**2 - fd*(8*f + 5) + fdd*(10*f + 6))*(r + s - 1)**2 + D1*(Dd*(-4*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*f*(4*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 4*r**2 - 8*r*s + 6*r - 4*s**2 + 6*s - 3) + 12*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(5*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(5*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*bdd1*f*(5*f + 6)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 8*D1**2*f*fd*r**2 - 16*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 10*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 20*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s + 10*D1**2*fd**2 - 16*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 140*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 140*D1*Dd*f*fd*s + 60*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + D1*bd1*(D1*(-4*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*f*(4*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 2*r**2 - 4*r*s + 2*r - 2*s**2 + 2*s - 1) + 12*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(5*f + 6)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2))/(21*d**2*k2*k3**2) + D1**2*Pk2*Pkdd3*ct**3*k1*k2**5*st**2*(396*C*D1**2*bdd1*f**2*r**2 + 792*C*D1**2*bdd1*f**2*r*s - 792*C*D1**2*bdd1*f**2*r + 396*C*D1**2*bdd1*f**2*s**2 - 792*C*D1**2*bdd1*f**2*s + 396*C*D1**2*bdd1*f**2 - 3624*C*D1**2*f**2*fd*r**2 - 7248*C*D1**2*f**2*fd*r*s + 4832*C*D1**2*f**2*fd*r - 3624*C*D1**2*f**2*fd*s**2 + 4832*C*D1**2*f**2*fd*s - 2416*C*D1**2*f**2*fd + 3000*C*D1**2*f**2*fdd*r**2 + 6000*C*D1**2*f**2*fdd*r*s - 4000*C*D1**2*f**2*fdd*r + 3000*C*D1**2*f**2*fdd*s**2 - 4000*C*D1**2*f**2*fdd*s + 2000*C*D1**2*f**2*fdd + 6000*C*D1**2*f*fd**2*r**2 + 12000*C*D1**2*f*fd**2*r*s - 8000*C*D1**2*f*fd**2*r + 6000*C*D1**2*f*fd**2*s**2 - 8000*C*D1**2*f*fd**2*s + 2000*C*D1**2*f*fd**2 - 4832*C*D1*Dd*f**3*r**2 - 9664*C*D1*Dd*f**3*r*s + 7248*C*D1*Dd*f**3*r - 4832*C*D1*Dd*f**3*s**2 + 7248*C*D1*Dd*f**3*s - 3624*C*D1*Dd*f**3 + 24000*C*D1*Dd*f**2*fd*r**2 + 48000*C*D1*Dd*f**2*fd*r*s - 34000*C*D1*Dd*f**2*fd*r + 24000*C*D1*Dd*f**2*fd*s**2 - 34000*C*D1*Dd*f**2*fd*s + 12000*C*D1*Dd*f**2*fd + 4000*C*D1*Ddd*f**3*r**2 + 8000*C*D1*Ddd*f**3*r*s - 6000*C*D1*Ddd*f**3*r + 4000*C*D1*Ddd*f**3*s**2 - 6000*C*D1*Ddd*f**3*s + 3000*C*D1*Ddd*f**3 + 12000*C*Dd**2*f**3*r**2 + 24000*C*Dd**2*f**3*r*s - 18000*C*Dd**2*f**3*r + 12000*C*Dd**2*f**3*s**2 - 18000*C*Dd**2*f**3*s + 6000*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r**2 + 1320*D1**2*K*bdd1*f**2*r*s - 1320*D1**2*K*bdd1*f**2*r + 660*D1**2*K*bdd1*f**2*s**2 - 1320*D1**2*K*bdd1*f**2*s + 660*D1**2*K*bdd1*f**2 - 66*D1**2*bd1**2*f*(-6*K + 5*f + 3)*(r + s - 1)**2 - 297*D1**2*bdd1*f**2*r**2 - 594*D1**2*bdd1*f**2*r*s + 594*D1**2*bdd1*f**2*r - 297*D1**2*bdd1*f**2*s**2 + 594*D1**2*bdd1*f**2*s - 297*D1**2*bdd1*f**2 - 396*D1**2*bdd1*f*g2*r**2 - 792*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r - 396*D1**2*bdd1*f*g2*s**2 + 792*D1**2*bdd1*f*g2*s - 396*D1**2*bdd1*f*g2 + 1515*D1**2*f**2*fd*r**2 + 3030*D1**2*f**2*fd*r*s - 2020*D1**2*f**2*fd*r + 1515*D1**2*f**2*fd*s**2 - 2020*D1**2*f**2*fd*s + 1010*D1**2*f**2*fd - 1500*D1**2*f**2*fdd*r**2 - 3000*D1**2*f**2*fdd*r*s + 2000*D1**2*f**2*fdd*r - 1500*D1**2*f**2*fdd*s**2 + 2000*D1**2*f**2*fdd*s - 1000*D1**2*f**2*fdd + 1848*D1**2*f**2*gd2*r**2 + 3696*D1**2*f**2*gd2*r*s - 3696*D1**2*f**2*gd2*r + 1848*D1**2*f**2*gd2*s**2 - 3696*D1**2*f**2*gd2*s + 1848*D1**2*f**2*gd2 - 1320*D1**2*f**2*gdd2*r**2 - 2640*D1**2*f**2*gdd2*r*s + 2640*D1**2*f**2*gdd2*r - 1320*D1**2*f**2*gdd2*s**2 + 2640*D1**2*f**2*gdd2*s - 1320*D1**2*f**2*gdd2 - 3000*D1**2*f*fd**2*r**2 - 6000*D1**2*f*fd**2*r*s + 4000*D1**2*f*fd**2*r - 3000*D1**2*f*fd**2*s**2 + 4000*D1**2*f*fd**2*s - 1000*D1**2*f*fd**2 + 3696*D1**2*f*fd*g2*r**2 + 7392*D1**2*f*fd*g2*r*s - 3696*D1**2*f*fd*g2*r + 3696*D1**2*f*fd*g2*s**2 - 3696*D1**2*f*fd*g2*s + 1848*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r**2 - 10560*D1**2*f*fd*gd2*r*s + 7920*D1**2*f*fd*gd2*r - 5280*D1**2*f*fd*gd2*s**2 + 7920*D1**2*f*fd*gd2*s - 2640*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r**2 - 5280*D1**2*f*fdd*g2*r*s + 2640*D1**2*f*fdd*g2*r - 2640*D1**2*f*fdd*g2*s**2 + 2640*D1**2*f*fdd*g2*s - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r**2 - 5280*D1**2*fd**2*g2*r*s + 2640*D1**2*fd**2*g2*r - 2640*D1**2*fd**2*g2*s**2 + 2640*D1**2*fd**2*g2*s + 2020*D1*Dd*f**3*r**2 + 4040*D1*Dd*f**3*r*s - 3030*D1*Dd*f**3*r + 2020*D1*Dd*f**3*s**2 - 3030*D1*Dd*f**3*s + 1515*D1*Dd*f**3 - 12000*D1*Dd*f**2*fd*r**2 - 24000*D1*Dd*f**2*fd*r*s + 17000*D1*Dd*f**2*fd*r - 12000*D1*Dd*f**2*fd*s**2 + 17000*D1*Dd*f**2*fd*s - 6000*D1*Dd*f**2*fd + 7392*D1*Dd*f**2*g2*r**2 + 14784*D1*Dd*f**2*g2*r*s - 11088*D1*Dd*f**2*g2*r + 7392*D1*Dd*f**2*g2*s**2 - 11088*D1*Dd*f**2*g2*s + 5544*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r**2 - 21120*D1*Dd*f**2*gd2*r*s + 18480*D1*Dd*f**2*gd2*r - 10560*D1*Dd*f**2*gd2*s**2 + 18480*D1*Dd*f**2*gd2*s - 7920*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r**2 - 42240*D1*Dd*f*fd*g2*r*s + 26400*D1*Dd*f*fd*g2*r - 21120*D1*Dd*f*fd*g2*s**2 + 26400*D1*Dd*f*fd*g2*s - 7920*D1*Dd*f*fd*g2 - 2000*D1*Ddd*f**3*r**2 - 4000*D1*Ddd*f**3*r*s + 3000*D1*Ddd*f**3*r - 2000*D1*Ddd*f**3*s**2 + 3000*D1*Ddd*f**3*s - 1500*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r**2 - 10560*D1*Ddd*f**2*g2*r*s + 7920*D1*Ddd*f**2*g2*r - 5280*D1*Ddd*f**2*g2*s**2 + 7920*D1*Ddd*f**2*g2*s - 3960*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(r + s - 1) + f**2*(24*C + 28*K - 15)*(r + s - 1) - 2*f*(fd*(12*C + 20*K - 9)*(2*r + 2*s - 1) + (12*g2 - 12*gd2)*(r + s - 1)) + 24*fd*g2*(r + s)) - 2*Dd*f*(f*(12*C + 20*K - 9) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6000*Dd**2*f**3*r**2 - 12000*Dd**2*f**3*r*s + 9000*Dd**2*f**3*r - 6000*Dd**2*f**3*s**2 + 9000*Dd**2*f**3*s - 3000*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r**2 - 31680*Dd**2*f**2*g2*r*s + 23760*Dd**2*f**2*g2*r - 15840*Dd**2*f**2*g2*s**2 + 23760*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(5*f*(2*fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(10*fd**2*(r + s - 1) + 6*fd*(2*K - 1)*(r + s) - 3*fdd*(2*K - 1)*(r + s))) + D1*(2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (6*K - 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 3*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-6*K + 5*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-6*K + 5*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-48*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 144*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 56*D1**2*K*f*fd*r**2 - 112*D1**2*K*f*fd*r*s + 56*D1**2*K*f*fd*r - 56*D1**2*K*f*fd*s**2 + 56*D1**2*K*f*fd*s - 28*D1**2*K*f*fd + 40*D1**2*K*f*fdd*r**2 + 80*D1**2*K*f*fdd*r*s - 40*D1**2*K*f*fdd*r + 40*D1**2*K*f*fdd*s**2 - 40*D1**2*K*f*fdd*s + 20*D1**2*K*f*fdd + 40*D1**2*K*fd**2*r**2 + 80*D1**2*K*fd**2*r*s - 40*D1**2*K*fd**2*r + 40*D1**2*K*fd**2*s**2 - 40*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(-6*K + 5*f + 3)*(r + s - 1)**2 - 15*D1**2*f**2*fd*r**2 - 30*D1**2*f**2*fd*r*s + 20*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 30*D1**2*f*fd*r**2 + 60*D1**2*f*fd*r*s - 30*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 30*D1**2*f*fd*s + 15*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 24*D1**2*f*gd2*r**2 + 48*D1**2*f*gd2*r*s - 48*D1**2*f*gd2*r + 24*D1**2*f*gd2*s**2 - 48*D1**2*f*gd2*s + 24*D1**2*f*gd2 - 12*D1**2*f*gdd2*r**2 - 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*r - 12*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 12*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 24*D1**2*fd*g2*r**2 + 48*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r**2 - 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 24*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r**2 - 24*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 112*D1*Dd*K*f**2*r**2 - 224*D1*Dd*K*f**2*r*s + 168*D1*Dd*K*f**2*r - 112*D1*Dd*K*f**2*s**2 + 168*D1*Dd*K*f**2*s - 84*D1*Dd*K*f**2 + 320*D1*Dd*K*f*fd*r**2 + 640*D1*Dd*K*f*fd*r*s - 400*D1*Dd*K*f*fd*r + 320*D1*Dd*K*f*fd*s**2 - 400*D1*Dd*K*f*fd*s + 120*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r**2 - 40*D1*Dd*f**3*r*s + 30*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 30*D1*Dd*f**3*s - 15*D1*Dd*f**3 + 60*D1*Dd*f**2*r**2 + 120*D1*Dd*f**2*r*s - 90*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 90*D1*Dd*f**2*s + 45*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 96*D1*Dd*f*g2*r**2 + 192*D1*Dd*f*g2*r*s - 144*D1*Dd*f*g2*r + 96*D1*Dd*f*g2*s**2 - 144*D1*Dd*f*g2*s + 72*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r**2 - 192*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 168*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r**2 - 192*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 72*D1*Dd*fd*g2*s + 80*D1*Ddd*K*f**2*r**2 + 160*D1*Ddd*K*f**2*r*s - 120*D1*Ddd*K*f**2*r + 80*D1*Ddd*K*f**2*s**2 - 120*D1*Ddd*K*f**2*s + 60*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r**2 - 96*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 72*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(5*f**2*(r + s - 1) - 5*f*fd*(2*r + 2*s - 1) - 3*f*(2*K - 1)*(r + s - 1) + 3*fd*(2*K - 1)*(r + s)) - Dd*f*(-6*K + 5*f + 3)*(4*r + 4*s - 3))*(r + s - 1) + 240*Dd**2*K*f**2*r**2 + 480*Dd**2*K*f**2*r*s - 360*Dd**2*K*f**2*r + 240*Dd**2*K*f**2*s**2 - 360*Dd**2*K*f**2*s + 120*Dd**2*K*f**2 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 144*Dd**2*f*g2*r**2 - 288*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 216*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(693*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**3*k1*k2**5*(-2*D1*(24*D1*K*bd1**2*f*(r + s - 1)**2 - bd1*(D1*(f**2*(16*C - 6*K - 5)*(r + s - 1) - 4*f*(fd*(10*C - 5)*(2*r + 2*s - 1) + (5*g2 - 12*gd2)*(r + s - 1)) + 48*fd*g2*(r + s)) - 4*Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1) + f*(2*D1*bdd1*(f*(10*C - 5) - 12*g2)*(r + s - 1)**2 + D1*(f*(fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*gd2*(r + s - 1)**2) - 12*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**2*(D1**2*(6*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-24*K*fdd + fd*(20*K + 7))) + D1*(Dd*(-48*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 6*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(20*K + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 144*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(D1**2*(f*(fd*(16*C - 6*K - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*(r + s - 1)**2*(12*K*bdd1 + 10*gd2 - 12*gdd2)) + (-4*r - 4*s)*(fd**2*(10*C - 5)*(r + s - 1) + 5*fd*g2*(r + s) - 12*fd*gd2*(r + s - 1) - 6*fdd*g2*(r + s))) + D1*bd1*(D1*(-48*K*fd*(r + s) + 6*f**2*(r + s - 1) + f*(20*K + 7)*(r + s - 1)) - 48*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(16*C - 6*K - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 4*f*(fd*(10*C - 5)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 5*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 48*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(f*(10*C - 5) - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**3*k1*k2**3*st**2*(-396*C*D1**2*bdd1*f**2*r**2 - 792*C*D1**2*bdd1*f**2*r*s - 396*C*D1**2*bdd1*f**2*s**2 - 4812*C*D1**2*f**2*fd*r**2 - 9624*C*D1**2*f**2*fd*r*s + 6416*C*D1**2*f**2*fd*r - 4812*C*D1**2*f**2*fd*s**2 + 6416*C*D1**2*f**2*fd*s - 3208*C*D1**2*f**2*fd + 3000*C*D1**2*f**2*fdd*r**2 + 6000*C*D1**2*f**2*fdd*r*s - 4000*C*D1**2*f**2*fdd*r + 3000*C*D1**2*f**2*fdd*s**2 - 4000*C*D1**2*f**2*fdd*s + 2000*C*D1**2*f**2*fdd + 6000*C*D1**2*f*fd**2*r**2 + 12000*C*D1**2*f*fd**2*r*s - 8000*C*D1**2*f*fd**2*r + 6000*C*D1**2*f*fd**2*s**2 - 8000*C*D1**2*f*fd**2*s + 2000*C*D1**2*f*fd**2 - 6416*C*D1*Dd*f**3*r**2 - 12832*C*D1*Dd*f**3*r*s + 9624*C*D1*Dd*f**3*r - 6416*C*D1*Dd*f**3*s**2 + 9624*C*D1*Dd*f**3*s - 4812*C*D1*Dd*f**3 + 24000*C*D1*Dd*f**2*fd*r**2 + 48000*C*D1*Dd*f**2*fd*r*s - 34000*C*D1*Dd*f**2*fd*r + 24000*C*D1*Dd*f**2*fd*s**2 - 34000*C*D1*Dd*f**2*fd*s + 12000*C*D1*Dd*f**2*fd + 4000*C*D1*Ddd*f**3*r**2 + 8000*C*D1*Ddd*f**3*r*s - 6000*C*D1*Ddd*f**3*r + 4000*C*D1*Ddd*f**3*s**2 - 6000*C*D1*Ddd*f**3*s + 3000*C*D1*Ddd*f**3 + 12000*C*Dd**2*f**3*r**2 + 24000*C*Dd**2*f**3*r*s - 18000*C*Dd**2*f**3*r + 12000*C*Dd**2*f**3*s**2 - 18000*C*Dd**2*f**3*s + 6000*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r**2 + 1320*D1**2*K*bdd1*f**2*r*s - 1320*D1**2*K*bdd1*f**2*r + 660*D1**2*K*bdd1*f**2*s**2 - 1320*D1**2*K*bdd1*f**2*s + 660*D1**2*K*bdd1*f**2 - 2244*D1**2*b2*f*fd*r**2 - 4488*D1**2*b2*f*fd*r*s + 2244*D1**2*b2*f*fd*r - 2244*D1**2*b2*f*fd*s**2 + 2244*D1**2*b2*f*fd*s - 1122*D1**2*b2*f*fd + 1320*D1**2*b2*f*fdd*r**2 + 2640*D1**2*b2*f*fdd*r*s - 1320*D1**2*b2*f*fdd*r + 1320*D1**2*b2*f*fdd*s**2 - 1320*D1**2*b2*f*fdd*s + 660*D1**2*b2*f*fdd + 1320*D1**2*b2*fd**2*r**2 + 2640*D1**2*b2*fd**2*r*s - 1320*D1**2*b2*fd**2*r + 1320*D1**2*b2*fd**2*s**2 - 1320*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*f*(r + s - 1)*(-6*K*(r + s) + 5*f + 3) - 1122*D1**2*bd2*f**2*r**2 - 2244*D1**2*bd2*f**2*r*s + 2244*D1**2*bd2*f**2*r - 1122*D1**2*bd2*f**2*s**2 + 2244*D1**2*bd2*f**2*s - 1122*D1**2*bd2*f**2 + 2640*D1**2*bd2*f*fd*r**2 + 5280*D1**2*bd2*f*fd*r*s - 3960*D1**2*bd2*f*fd*r + 2640*D1**2*bd2*f*fd*s**2 - 3960*D1**2*bd2*f*fd*s + 1320*D1**2*bd2*f*fd + 198*D1**2*bdd1*f**2*r**2 + 396*D1**2*bdd1*f**2*r*s + 198*D1**2*bdd1*f**2*r + 198*D1**2*bdd1*f**2*s**2 + 198*D1**2*bdd1*f**2*s - 99*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r**2 + 792*D1**2*bdd1*f*g2*r*s + 396*D1**2*bdd1*f*g2*s**2 + 660*D1**2*bdd2*f**2*r**2 + 1320*D1**2*bdd2*f**2*r*s - 1320*D1**2*bdd2*f**2*r + 660*D1**2*bdd2*f**2*s**2 - 1320*D1**2*bdd2*f**2*s + 660*D1**2*bdd2*f**2 + 2109*D1**2*f**2*fd*r**2 + 4218*D1**2*f**2*fd*r*s - 2812*D1**2*f**2*fd*r + 2109*D1**2*f**2*fd*s**2 - 2812*D1**2*f**2*fd*s + 1406*D1**2*f**2*fd - 1500*D1**2*f**2*fdd*r**2 - 3000*D1**2*f**2*fdd*r*s + 2000*D1**2*f**2*fdd*r - 1500*D1**2*f**2*fdd*s**2 + 2000*D1**2*f**2*fdd*s - 1000*D1**2*f**2*fdd + 2244*D1**2*f**2*gd2*r**2 + 4488*D1**2*f**2*gd2*r*s - 4488*D1**2*f**2*gd2*r + 2244*D1**2*f**2*gd2*s**2 - 4488*D1**2*f**2*gd2*s + 2244*D1**2*f**2*gd2 - 1320*D1**2*f**2*gdd2*r**2 - 2640*D1**2*f**2*gdd2*r*s + 2640*D1**2*f**2*gdd2*r - 1320*D1**2*f**2*gdd2*s**2 + 2640*D1**2*f**2*gdd2*s - 1320*D1**2*f**2*gdd2 - 3000*D1**2*f*fd**2*r**2 - 6000*D1**2*f*fd**2*r*s + 4000*D1**2*f*fd**2*r - 3000*D1**2*f*fd**2*s**2 + 4000*D1**2*f*fd**2*s - 1000*D1**2*f*fd**2 + 4488*D1**2*f*fd*g2*r**2 + 8976*D1**2*f*fd*g2*r*s - 4488*D1**2*f*fd*g2*r + 4488*D1**2*f*fd*g2*s**2 - 4488*D1**2*f*fd*g2*s + 2244*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r**2 - 10560*D1**2*f*fd*gd2*r*s + 7920*D1**2*f*fd*gd2*r - 5280*D1**2*f*fd*gd2*s**2 + 7920*D1**2*f*fd*gd2*s - 2640*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r**2 - 5280*D1**2*f*fdd*g2*r*s + 2640*D1**2*f*fdd*g2*r - 2640*D1**2*f*fdd*g2*s**2 + 2640*D1**2*f*fdd*g2*s - 1320*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r**2 - 5280*D1**2*fd**2*g2*r*s + 2640*D1**2*fd**2*g2*r - 2640*D1**2*fd**2*g2*s**2 + 2640*D1**2*fd**2*g2*s - 4488*D1*Dd*b2*f**2*r**2 - 8976*D1*Dd*b2*f**2*r*s + 6732*D1*Dd*b2*f**2*r - 4488*D1*Dd*b2*f**2*s**2 + 6732*D1*Dd*b2*f**2*s - 3366*D1*Dd*b2*f**2 + 10560*D1*Dd*b2*f*fd*r**2 + 21120*D1*Dd*b2*f*fd*r*s - 13200*D1*Dd*b2*f*fd*r + 10560*D1*Dd*b2*f*fd*s**2 - 13200*D1*Dd*b2*f*fd*s + 3960*D1*Dd*b2*f*fd + 5280*D1*Dd*bd2*f**2*r**2 + 10560*D1*Dd*bd2*f**2*r*s - 9240*D1*Dd*bd2*f**2*r + 5280*D1*Dd*bd2*f**2*s**2 - 9240*D1*Dd*bd2*f**2*s + 3960*D1*Dd*bd2*f**2 + 2812*D1*Dd*f**3*r**2 + 5624*D1*Dd*f**3*r*s - 4218*D1*Dd*f**3*r + 2812*D1*Dd*f**3*s**2 - 4218*D1*Dd*f**3*s + 2109*D1*Dd*f**3 - 12000*D1*Dd*f**2*fd*r**2 - 24000*D1*Dd*f**2*fd*r*s + 17000*D1*Dd*f**2*fd*r - 12000*D1*Dd*f**2*fd*s**2 + 17000*D1*Dd*f**2*fd*s - 6000*D1*Dd*f**2*fd + 8976*D1*Dd*f**2*g2*r**2 + 17952*D1*Dd*f**2*g2*r*s - 13464*D1*Dd*f**2*g2*r + 8976*D1*Dd*f**2*g2*s**2 - 13464*D1*Dd*f**2*g2*s + 6732*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r**2 - 21120*D1*Dd*f**2*gd2*r*s + 18480*D1*Dd*f**2*gd2*r - 10560*D1*Dd*f**2*gd2*s**2 + 18480*D1*Dd*f**2*gd2*s - 7920*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r**2 - 42240*D1*Dd*f*fd*g2*r*s + 26400*D1*Dd*f*fd*g2*r - 21120*D1*Dd*f*fd*g2*s**2 + 26400*D1*Dd*f*fd*g2*s - 7920*D1*Dd*f*fd*g2 + 2640*D1*Ddd*b2*f**2*r**2 + 5280*D1*Ddd*b2*f**2*r*s - 3960*D1*Ddd*b2*f**2*r + 2640*D1*Ddd*b2*f**2*s**2 - 3960*D1*Ddd*b2*f**2*s + 1980*D1*Ddd*b2*f**2 - 2000*D1*Ddd*f**3*r**2 - 4000*D1*Ddd*f**3*r*s + 3000*D1*Ddd*f**3*r - 2000*D1*Ddd*f**3*s**2 + 3000*D1*Ddd*f**3*s - 1500*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r**2 - 10560*D1*Ddd*f**2*g2*r*s + 7920*D1*Ddd*f**2*g2*r - 5280*D1*Ddd*f**2*g2*s**2 + 7920*D1*Ddd*f**2*g2*s - 3960*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(5*f**3*(r + s - 1)**2 + f**2*(34*K*(r + s - 1)**2 + 3*r**2*(5 - 8*C) + 3*r*(-s*(16*C - 10) + 2) + 3*s**2*(5 - 8*C) + 6*s - 3) - 2*f*(fd*(r + s - 1)*(-24*C*s + 20*K*(2*r + 2*s - 1) + 3*r*(4 - 8*C) + 12*s + 3) + (12*r + 12*s)*(-g2*(r + s) + gd2*(r + s - 1))) - 24*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(f*(-12*C*r - 12*C*s + 20*K*(r + s - 1) + 6*r + 6*s + 3) + 12*g2*(r + s))*(4*r + 4*s - 3)) + 7920*Dd**2*b2*f**2*r**2 + 15840*Dd**2*b2*f**2*r*s - 11880*Dd**2*b2*f**2*r + 7920*Dd**2*b2*f**2*s**2 - 11880*Dd**2*b2*f**2*s + 3960*Dd**2*b2*f**2 - 6000*Dd**2*f**3*r**2 - 12000*Dd**2*f**3*r*s + 9000*Dd**2*f**3*r - 6000*Dd**2*f**3*s**2 + 9000*Dd**2*f**3*s - 3000*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r**2 - 31680*Dd**2*f**2*g2*r*s + 23760*Dd**2*f**2*g2*r - 15840*Dd**2*f**2*g2*s**2 + 23760*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 - 33*b1**2*(D1**2*(-10*f*fd*(2*r + 2*s - 1) + 5*f*fdd*(2*r + 2*s - 1) + 10*fd**2*(r + s - 1) - 6*fd*(2*K*(r + s - 1)**2 + 2*r + 2*s - 1) + 3*fdd*(2*K*(r + s - 1)**2 + 2*r + 2*s - 1)) + 2*D1*(Dd*(-6*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(4*r + 4*s - 3)*(6*K*(r + s - 1) + 5*f + 3)) + 3*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 36*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-48*C*D1**2*f*fd*r**2 - 96*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 96*C*D1**2*f*fd*s - 48*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 48*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 48*C*D1**2*fd**2*s + 24*C*D1**2*fd**2 - 96*C*D1*Dd*f**2*r**2 - 192*C*D1*Dd*f**2*r*s + 144*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 72*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 336*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 336*C*D1*Dd*f*fd*s + 144*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 + 68*D1**2*K*f*fd*r**2 + 136*D1**2*K*f*fd*r*s - 68*D1**2*K*f*fd*r + 68*D1**2*K*f*fd*s**2 - 68*D1**2*K*f*fd*s + 34*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r**2 - 80*D1**2*K*f*fdd*r*s + 40*D1**2*K*f*fdd*r - 40*D1**2*K*f*fdd*s**2 + 40*D1**2*K*f*fdd*s - 20*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r**2 - 80*D1**2*K*fd**2*r*s + 40*D1**2*K*fd**2*r - 40*D1**2*K*fd**2*s**2 + 40*D1**2*K*fd**2*s + D1**2*bdd1*f*(6*K*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 5*f*(2*r + 2*s - 1) - 6*r - 6*s + 3) + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 30*D1**2*f*fd*r**2 + 60*D1**2*f*fd*r*s - 66*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 66*D1**2*f*fd*s + 33*D1**2*f*fd - 12*D1**2*f*fdd*r**2 - 24*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 24*D1**2*f*gd2*r**2 + 48*D1**2*f*gd2*r*s - 48*D1**2*f*gd2*r + 24*D1**2*f*gd2*s**2 - 48*D1**2*f*gd2*s + 24*D1**2*f*gd2 - 12*D1**2*f*gdd2*r**2 - 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*r - 12*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 12*D1**2*f*gdd2 - 12*D1**2*fd**2*r**2 - 24*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s - 18*D1**2*fd**2 + 24*D1**2*fd*g2*r**2 + 48*D1**2*fd*g2*r*s - 48*D1**2*fd*g2*r + 24*D1**2*fd*g2*s**2 - 48*D1**2*fd*g2*s + 24*D1**2*fd*g2 - 24*D1**2*fd*gd2*r**2 - 48*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 24*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fd*gd2 - 12*D1**2*fdd*g2*r**2 - 24*D1**2*fdd*g2*r*s + 24*D1**2*fdd*g2*r - 12*D1**2*fdd*g2*s**2 + 24*D1**2*fdd*g2*s - 12*D1**2*fdd*g2 + 136*D1*Dd*K*f**2*r**2 + 272*D1*Dd*K*f**2*r*s - 204*D1*Dd*K*f**2*r + 136*D1*Dd*K*f**2*s**2 - 204*D1*Dd*K*f**2*s + 102*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r**2 - 640*D1*Dd*K*f*fd*r*s + 400*D1*Dd*K*f*fd*r - 320*D1*Dd*K*f*fd*s**2 + 400*D1*Dd*K*f*fd*s - 120*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 60*D1*Dd*f**2*r**2 + 120*D1*Dd*f**2*r*s - 90*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 90*D1*Dd*f**2*s + 45*D1*Dd*f**2 - 96*D1*Dd*f*fd*r**2 - 192*D1*Dd*f*fd*r*s + 192*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 192*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 96*D1*Dd*f*g2*r**2 + 192*D1*Dd*f*g2*r*s - 144*D1*Dd*f*g2*r + 96*D1*Dd*f*g2*s**2 - 144*D1*Dd*f*g2*s + 72*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r**2 - 192*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 168*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r**2 - 192*D1*Dd*fd*g2*r*s + 168*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 168*D1*Dd*fd*g2*s - 72*D1*Dd*fd*g2 - 80*D1*Ddd*K*f**2*r**2 - 160*D1*Ddd*K*f**2*r*s + 120*D1*Ddd*K*f**2*r - 80*D1*Ddd*K*f**2*s**2 + 120*D1*Ddd*K*f**2*s - 60*D1*Ddd*K*f**2 - 24*D1*Ddd*f**2*r**2 - 48*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 18*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r**2 - 96*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 72*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*f**2*(2*r + 2*s - 1) - 3*f*(K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 2*r - 2*s + 1) + 3*fd*(K*(4*r + 4*s - 2) + 1)*(r + s - 1)) + Dd*f*(4*r + 4*s - 3)*(6*K*(2*r + 2*s - 1) - 5*f - 3)) - 240*Dd**2*K*f**2*r**2 - 480*Dd**2*K*f**2*r*s + 360*Dd**2*K*f**2*r - 240*Dd**2*K*f**2*s**2 + 360*Dd**2*K*f**2*s - 120*Dd**2*K*f**2 - 72*Dd**2*f**2*r**2 - 144*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 36*Dd**2*f**2 - 144*Dd**2*f*g2*r**2 - 288*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 216*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(693*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**3*k1*k2**3*(2*D1*(-2*D1*bd1**2*(r + s - 1)*(6*K*f*(r + s - 2) - f*(12*C - 9)*(r + s) + 14*g2*(r + s)) + b2*(bd1*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) - 6*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + bd1*(-24*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(4*C*(8*r**2 + 2*r*(8*s - 7) + 8*s**2 - 14*s + 7) - 6*K*(r + s - 1)**2 - 16*r**2 - 32*r*s + 22*r - 16*s**2 + 22*s - 11) + f*(fd*(20 - 40*C)*(r + s - 1)**2 - 2*g2*(19*r**2 + r*(38*s - 34) + 19*s**2 - 34*s + 17) + 24*gd2*(r**2 + r*(2*s - 3) + s**2 - 3*s + 2)) + 24*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 11) + 4*s**2 - 11*s + 6)) + f*(-30*C*D1*f*fd*r**2 - 60*C*D1*f*fd*r*s + 40*C*D1*f*fd*r - 30*C*D1*f*fd*s**2 + 40*C*D1*f*fd*s - 20*C*D1*f*fd - 40*C*Dd*f**2*r**2 - 80*C*Dd*f**2*r*s + 60*C*Dd*f**2*r - 40*C*Dd*f**2*s**2 + 60*C*Dd*f**2*s - 30*C*Dd*f**2 - 6*D1*bd2*f*(r + s - 1)**2 - D1*bdd1*(f*(10*C - 5) - 12*g2)*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) + 15*D1*f*fd*r**2 + 30*D1*f*fd*r*s - 20*D1*f*fd*r + 15*D1*f*fd*s**2 - 20*D1*f*fd*s + 10*D1*f*fd + 12*D1*f*gd2*r**2 + 24*D1*f*gd2*r*s - 24*D1*f*gd2*r + 12*D1*f*gd2*s**2 - 24*D1*f*gd2*s + 12*D1*f*gd2 + 24*D1*fd*g2*r**2 + 48*D1*fd*g2*r*s - 24*D1*fd*g2*r + 24*D1*fd*g2*s**2 - 24*D1*fd*g2*s + 12*D1*fd*g2 + 20*Dd*f**2*r**2 + 40*Dd*f**2*r*s - 30*Dd*f**2*r + 20*Dd*f**2*s**2 - 30*Dd*f**2*s + 15*Dd*f**2 + 48*Dd*f*g2*r**2 + 96*Dd*f*g2*r*s - 72*Dd*f*g2*r + 48*Dd*f*g2*s**2 - 72*Dd*f*g2*s + 36*Dd*f*g2)) + b1**3*(6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - (14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-48*C*D1**2*fd*r**2 - 96*C*D1**2*fd*r*s + 96*C*D1**2*fd*r - 48*C*D1**2*fd*s**2 + 96*C*D1**2*fd*s - 48*C*D1**2*fd + 24*C*D1**2*fdd*r**2 + 48*C*D1**2*fdd*r*s - 48*C*D1**2*fdd*r + 24*C*D1**2*fdd*s**2 - 48*C*D1**2*fdd*s + 24*C*D1**2*fdd - 192*C*D1*Dd*f*r**2 - 384*C*D1*Dd*f*r*s + 288*C*D1*Dd*f*r - 192*C*D1*Dd*f*s**2 + 288*C*D1*Dd*f*s - 144*C*D1*Dd*f + 192*C*D1*Dd*fd*r**2 + 384*C*D1*Dd*fd*r*s - 336*C*D1*Dd*fd*r + 192*C*D1*Dd*fd*s**2 - 336*C*D1*Dd*fd*s + 144*C*D1*Dd*fd + 96*C*D1*Ddd*f*r**2 + 192*C*D1*Ddd*f*r*s - 144*C*D1*Ddd*f*r + 96*C*D1*Ddd*f*s**2 - 144*C*D1*Ddd*f*s + 72*C*D1*Ddd*f + 288*C*Dd**2*f*r**2 + 576*C*Dd**2*f*r*s - 432*C*Dd**2*f*r + 288*C*Dd**2*f*s**2 - 432*C*Dd**2*f*s + 144*C*Dd**2*f + 38*D1**2*K*fd*r**2 + 76*D1**2*K*fd*r*s - 8*D1**2*K*fd*r + 38*D1**2*K*fd*s**2 - 8*D1**2*K*fd*s + 4*D1**2*K*fd - 12*D1**2*K*fdd*r**2 - 24*D1**2*K*fdd*r*s - 24*D1**2*K*fdd*r - 12*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - D1**2*bdd1*(-14*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 12*D1**2*f*fd*r + 12*D1**2*f*fd*s - 6*D1**2*f*fd + 36*D1**2*fd*r**2 + 72*D1**2*fd*r*s - 58*D1**2*fd*r + 36*D1**2*fd*s**2 - 58*D1**2*fd*s + 29*D1**2*fd - 18*D1**2*fdd*r**2 - 36*D1**2*fdd*r*s + 36*D1**2*fdd*r - 18*D1**2*fdd*s**2 + 36*D1**2*fdd*s - 18*D1**2*fdd + 56*D1**2*gd2*r**2 + 112*D1**2*gd2*r*s - 112*D1**2*gd2*r + 56*D1**2*gd2*s**2 - 112*D1**2*gd2*s + 56*D1**2*gd2 - 28*D1**2*gdd2*r**2 - 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*r - 28*D1**2*gdd2*s**2 + 56*D1**2*gdd2*s - 28*D1**2*gdd2 + 152*D1*Dd*K*f*r**2 + 304*D1*Dd*K*f*r*s - 228*D1*Dd*K*f*r + 152*D1*Dd*K*f*s**2 - 228*D1*Dd*K*f*s + 114*D1*Dd*K*f - 96*D1*Dd*K*fd*r**2 - 192*D1*Dd*K*fd*r*s - 24*D1*Dd*K*fd*r - 96*D1*Dd*K*fd*s**2 - 24*D1*Dd*K*fd*s + 72*D1*Dd*K*fd + 144*D1*Dd*f*r**2 + 288*D1*Dd*f*r*s - 216*D1*Dd*f*r + 144*D1*Dd*f*s**2 - 216*D1*Dd*f*s + 108*D1*Dd*f - 144*D1*Dd*fd*r**2 - 288*D1*Dd*fd*r*s + 252*D1*Dd*fd*r - 144*D1*Dd*fd*s**2 + 252*D1*Dd*fd*s - 108*D1*Dd*fd + 224*D1*Dd*g2*r**2 + 448*D1*Dd*g2*r*s - 336*D1*Dd*g2*r + 224*D1*Dd*g2*s**2 - 336*D1*Dd*g2*s + 168*D1*Dd*g2 - 224*D1*Dd*gd2*r**2 - 448*D1*Dd*gd2*r*s + 392*D1*Dd*gd2*r - 224*D1*Dd*gd2*s**2 + 392*D1*Dd*gd2*s - 168*D1*Dd*gd2 - 48*D1*Ddd*K*f*r**2 - 96*D1*Ddd*K*f*r*s + 72*D1*Ddd*K*f*r - 48*D1*Ddd*K*f*s**2 + 72*D1*Ddd*K*f*s - 36*D1*Ddd*K*f - 72*D1*Ddd*f*r**2 - 144*D1*Ddd*f*r*s + 108*D1*Ddd*f*r - 72*D1*Ddd*f*s**2 + 108*D1*Ddd*f*s - 54*D1*Ddd*f - 112*D1*Ddd*g2*r**2 - 224*D1*Ddd*g2*r*s + 168*D1*Ddd*g2*r - 112*D1*Ddd*g2*s**2 + 168*D1*Ddd*g2*s - 84*D1*Ddd*g2 + 2*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - (14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(-14*K + 6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 144*Dd**2*K*f*r**2 - 288*Dd**2*K*f*r*s + 216*Dd**2*K*f*r - 144*Dd**2*K*f*s**2 + 216*Dd**2*K*f*s - 72*Dd**2*K*f - 216*Dd**2*f*r**2 - 432*Dd**2*f*r*s + 324*Dd**2*f*r - 216*Dd**2*f*s**2 + 324*Dd**2*f*s - 108*Dd**2*f - 336*Dd**2*g2*r**2 - 672*Dd**2*g2*r*s + 504*Dd**2*g2*r - 336*Dd**2*g2*s**2 + 504*Dd**2*g2*s - 168*Dd**2*g2) - b1*(-128*C*D1**2*f*fd*r**2 - 256*C*D1**2*f*fd*r*s + 144*C*D1**2*f*fd*r - 128*C*D1**2*f*fd*s**2 + 144*C*D1**2*f*fd*s - 72*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*s**2 + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2 - 256*C*D1*Dd*f**2*r**2 - 512*C*D1*Dd*f**2*r*s + 384*C*D1*Dd*f**2*r - 256*C*D1*Dd*f**2*s**2 + 384*C*D1*Dd*f**2*s - 192*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 + 24*D1**2*K*f*fd*r**2 + 48*D1**2*K*f*fd*r*s - 24*D1**2*K*f*fd*r + 24*D1**2*K*f*fd*s**2 - 24*D1**2*K*f*fd*s + 12*D1**2*K*f*fd - 34*D1**2*b2*fd*r**2 - 68*D1**2*b2*fd*r*s - 34*D1**2*b2*fd*s**2 + 24*D1**2*b2*fdd*r**2 + 48*D1**2*b2*fdd*r*s + 24*D1**2*b2*fdd*s**2 + 2*D1**2*bd1**2*(-14*K + 6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2*D1**2*bdd1*(3*f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*K*(2*r**2 + 4*r*s - 6*r + 2*s**2 - 6*s + 3) - 6*r**2 - 12*r*s + 6*r - 6*s**2 + 6*s - 3) - 14*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 24*D1**2*bdd2*f*r**2 + 48*D1**2*bdd2*f*r*s - 48*D1**2*bdd2*f*r + 24*D1**2*bdd2*f*s**2 - 48*D1**2*bdd2*f*s + 24*D1**2*bdd2*f + 64*D1**2*f*fd*r**2 + 128*D1**2*f*fd*r*s - 84*D1**2*f*fd*r + 64*D1**2*f*fd*s**2 - 84*D1**2*f*fd*s + 42*D1**2*f*fd - 20*D1**2*f*fdd*r**2 - 40*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*s**2 + 76*D1**2*f*gd2*r**2 + 152*D1**2*f*gd2*r*s - 152*D1**2*f*gd2*r + 76*D1**2*f*gd2*s**2 - 152*D1**2*f*gd2*s + 76*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 20*D1**2*fd**2*r**2 - 40*D1**2*fd**2*r*s - 20*D1**2*fd**2*s**2 + 20*D1**2*fd**2 + 76*D1**2*fd*g2*r**2 + 152*D1**2*fd*g2*r*s - 16*D1**2*fd*g2*r + 76*D1**2*fd*g2*s**2 - 16*D1**2*fd*g2*s + 8*D1**2*fd*g2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s - 48*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*r - 24*D1**2*fdd*g2*s**2 - 48*D1**2*fdd*g2*s + 24*D1**2*fdd*g2 + 48*D1*Dd*K*f**2*r**2 + 96*D1*Dd*K*f**2*r*s - 72*D1*Dd*K*f**2*r + 48*D1*Dd*K*f**2*s**2 - 72*D1*Dd*K*f**2*s + 36*D1*Dd*K*f**2 - 136*D1*Dd*b2*f*r**2 - 272*D1*Dd*b2*f*r*s + 204*D1*Dd*b2*f*r - 136*D1*Dd*b2*f*s**2 + 204*D1*Dd*b2*f*s - 102*D1*Dd*b2*f + 192*D1*Dd*b2*fd*r**2 + 384*D1*Dd*b2*fd*r*s - 144*D1*Dd*b2*fd*r + 192*D1*Dd*b2*fd*s**2 - 144*D1*Dd*b2*fd*s + 128*D1*Dd*f**2*r**2 + 256*D1*Dd*f**2*r*s - 192*D1*Dd*f**2*r + 128*D1*Dd*f**2*s**2 - 192*D1*Dd*f**2*s + 96*D1*Dd*f**2 - 160*D1*Dd*f*fd*r**2 - 320*D1*Dd*f*fd*r*s + 120*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 120*D1*Dd*f*fd*s + 304*D1*Dd*f*g2*r**2 + 608*D1*Dd*f*g2*r*s - 456*D1*Dd*f*g2*r + 304*D1*Dd*f*g2*s**2 - 456*D1*Dd*f*g2*s + 228*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s - 48*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 - 48*D1*Dd*fd*g2*s + 144*D1*Dd*fd*g2 + 96*D1*Ddd*b2*f*r**2 + 192*D1*Ddd*b2*f*r*s - 144*D1*Ddd*b2*f*r + 96*D1*Ddd*b2*f*s**2 - 144*D1*Ddd*b2*f*s + 72*D1*Ddd*b2*f - 40*D1*Ddd*f**2*r**2 - 80*D1*Ddd*f**2*r*s + 60*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(2*r + 2*s - 1) + f*(48*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*K*(19*r**2 + 38*r*s - 36*r + 19*s**2 - 36*s + 18) - 72*r**2 - 144*r*s + 86*r - 72*s**2 + 86*s - 43) + 12*fd*(r + s - 1)*(C*(-8*r - 8*s + 4) + K*(4*r + 4*s + 2) + 6*r + 6*s - 3) - 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(3*f*(C*(8*r + 8*s - 4) + K*(-4*r - 4*s + 6) - 6*r - 6*s + 3) - 14*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 2*D1*bd2*(r + s - 1)*(17*D1*f*(r + s - 1) - 24*D1*fd*(r + s) - 24*Dd*f*(4*r + 4*s - 3)) + 288*Dd**2*b2*f*r**2 + 576*Dd**2*b2*f*r*s - 432*Dd**2*b2*f*r + 288*Dd**2*b2*f*s**2 - 432*Dd**2*b2*f*s + 144*Dd**2*b2*f - 120*Dd**2*f**2*r**2 - 240*Dd**2*f**2*r*s + 180*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 60*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(21*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**3*k1*k2*st**2*(D1*f*(r + s)*(2*D1*bd1**2*(5*f + 3)*(r + s - 1) + 3*D1*bdd1*f*(r + s) + 6*bd1*(-D1*f*(r + s) + 2*D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(10*fd**2 + fd*(-20*f - 6) + fdd*(10*f + 3))*(r + s - 1)**2 + D1*(-2*Dd*(5*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-10*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 12*r**2 + 24*r*s - 18*r + 12*s**2 - 18*s + 9) - 3*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(5*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(5*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*bdd1*f*(5*f + 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 6*D1**2*(r + s - 1)**2*(2*f*fd - f*fdd - fd**2) - 2*D1*bd1*(D1*(5*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(-10*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 6*r**2 + 12*r*s - 6*r + 6*s**2 - 6*s + 3) - 3*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - Dd*f*(5*f + 3)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 3*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**3*k1*k2*(-2*D1*(r + s)*(6*D1*bd1**2*f*(2*K - 1)*(r + s - 1) + D1*bdd1*f*(r + s)*(6*b2 + f*(10*C - 5) - 12*g2) + bd1*(-8*C*D1*f**2*r - 8*C*D1*f**2*s + 40*C*D1*f*fd*r + 40*C*D1*f*fd*s - 40*C*D1*f*fd + 80*C*Dd*f**2*r + 80*C*Dd*f**2*s - 60*C*Dd*f**2 + 12*D1*bd2*f*(r + s - 1) + D1*f**2*r + D1*f**2*s - 20*D1*f*fd*r - 20*D1*f*fd*s + 20*D1*f*fd + 10*D1*f*g2*r + 10*D1*f*g2*s - 24*D1*f*gd2*r - 24*D1*f*gd2*s + 24*D1*f*gd2 - 24*D1*fd*g2*r - 24*D1*fd*g2*s + 24*D1*fd*g2 - 40*Dd*f**2*r - 40*Dd*f**2*s + 30*Dd*f**2 - 96*Dd*f*g2*r - 96*Dd*f*g2*s + 72*Dd*f*g2 + b2*(-5*D1*f*(r + s) + 12*D1*fd*(r + s - 1) + 12*Dd*f*(4*r + 4*s - 3)))) + b1**3*(-6*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(-2*Dd*(6*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) + Ddd*(6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(10*D1**2*K*fd*r**2 + 20*D1**2*K*fd*r*s - 20*D1**2*K*fd*r + 10*D1**2*K*fd*s**2 - 20*D1**2*K*fd*s + 10*D1**2*K*fd - 12*D1**2*K*fdd*r**2 - 24*D1**2*K*fdd*r*s + 24*D1**2*K*fdd*r - 12*D1**2*K*fdd*s**2 + 24*D1**2*K*fdd*s - 12*D1**2*K*fdd + D1**2*bdd1*(6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 12*D1**2*f*fd*r**2 + 24*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 12*D1**2*f*fd - 5*D1**2*fd*r**2 - 10*D1**2*fd*r*s + 10*D1**2*fd*r - 5*D1**2*fd*s**2 + 10*D1**2*fd*s - 5*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r + 6*D1**2*fdd*s**2 - 12*D1**2*fdd*s + 6*D1**2*fdd + 40*D1*Dd*K*f*r**2 + 80*D1*Dd*K*f*r*s - 60*D1*Dd*K*f*r + 40*D1*Dd*K*f*s**2 - 60*D1*Dd*K*f*s + 30*D1*Dd*K*f - 96*D1*Dd*K*fd*r**2 - 192*D1*Dd*K*fd*r*s + 168*D1*Dd*K*fd*r - 96*D1*Dd*K*fd*s**2 + 168*D1*Dd*K*fd*s - 72*D1*Dd*K*fd + 24*D1*Dd*f**2*r**2 + 48*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 36*D1*Dd*f**2*s + 18*D1*Dd*f**2 - 20*D1*Dd*f*r**2 - 40*D1*Dd*f*r*s + 30*D1*Dd*f*r - 20*D1*Dd*f*s**2 + 30*D1*Dd*f*s - 15*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 84*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 84*D1*Dd*fd*s + 36*D1*Dd*fd - 48*D1*Ddd*K*f*r**2 - 96*D1*Ddd*K*f*r*s + 72*D1*Ddd*K*f*r - 48*D1*Ddd*K*f*s**2 + 72*D1*Ddd*K*f*s - 36*D1*Ddd*K*f + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f - 2*D1*bd1*(D1*(6*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 6*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 21*r**2 + 42*r*s - 28*r + 21*s**2 - 28*s + 14) - Dd*(6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 144*Dd**2*K*f*r**2 - 288*Dd**2*K*f*r*s + 216*Dd**2*K*f*r - 144*Dd**2*K*f*s**2 + 216*Dd**2*K*f*s - 72*Dd**2*K*f + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f) + b1*(32*C*D1**2*f*fd*r**2 + 64*C*D1**2*f*fd*r*s - 64*C*D1**2*f*fd*r + 32*C*D1**2*f*fd*s**2 - 64*C*D1**2*f*fd*s + 32*C*D1**2*f*fd - 40*C*D1**2*f*fdd*r**2 - 80*C*D1**2*f*fdd*r*s + 80*C*D1**2*f*fdd*r - 40*C*D1**2*f*fdd*s**2 + 80*C*D1**2*f*fdd*s - 40*C*D1**2*f*fdd - 40*C*D1**2*fd**2*r**2 - 80*C*D1**2*fd**2*r*s + 80*C*D1**2*fd**2*r - 40*C*D1**2*fd**2*s**2 + 80*C*D1**2*fd**2*s - 40*C*D1**2*fd**2 + 64*C*D1*Dd*f**2*r**2 + 128*C*D1*Dd*f**2*r*s - 96*C*D1*Dd*f**2*r + 64*C*D1*Dd*f**2*s**2 - 96*C*D1*Dd*f**2*s + 48*C*D1*Dd*f**2 - 320*C*D1*Dd*f*fd*r**2 - 640*C*D1*Dd*f*fd*r*s + 560*C*D1*Dd*f*fd*r - 320*C*D1*Dd*f*fd*s**2 + 560*C*D1*Dd*f*fd*s - 240*C*D1*Dd*f*fd - 80*C*D1*Ddd*f**2*r**2 - 160*C*D1*Ddd*f**2*r*s + 120*C*D1*Ddd*f**2*r - 80*C*D1*Ddd*f**2*s**2 + 120*C*D1*Ddd*f**2*s - 60*C*D1*Ddd*f**2 - 240*C*Dd**2*f**2*r**2 - 480*C*Dd**2*f**2*r*s + 360*C*Dd**2*f**2*r - 240*C*Dd**2*f**2*s**2 + 360*C*Dd**2*f**2*s - 120*C*Dd**2*f**2 + 10*D1**2*b2*fd*r**2 + 20*D1**2*b2*fd*r*s - 20*D1**2*b2*fd*r + 10*D1**2*b2*fd*s**2 - 20*D1**2*b2*fd*s + 10*D1**2*b2*fd - 12*D1**2*b2*fdd*r**2 - 24*D1**2*b2*fdd*r*s + 24*D1**2*b2*fdd*r - 12*D1**2*b2*fdd*s**2 + 24*D1**2*b2*fdd*s - 12*D1**2*b2*fdd + 2*D1**2*bd1**2*(6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 6*D1**2*bdd1*f*(2*K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*D1**2*bdd2*f*r**2 - 24*D1**2*bdd2*f*r*s + 24*D1**2*bdd2*f*r - 12*D1**2*bdd2*f*s**2 + 24*D1**2*bdd2*f*s - 12*D1**2*bdd2*f - 4*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 4*D1**2*f*fd + 20*D1**2*f*fdd*r**2 + 40*D1**2*f*fdd*r*s - 40*D1**2*f*fdd*r + 20*D1**2*f*fdd*s**2 - 40*D1**2*f*fdd*s + 20*D1**2*f*fdd - 20*D1**2*f*gd2*r**2 - 40*D1**2*f*gd2*r*s + 40*D1**2*f*gd2*r - 20*D1**2*f*gd2*s**2 + 40*D1**2*f*gd2*s - 20*D1**2*f*gd2 + 24*D1**2*f*gdd2*r**2 + 48*D1**2*f*gdd2*r*s - 48*D1**2*f*gdd2*r + 24*D1**2*f*gdd2*s**2 - 48*D1**2*f*gdd2*s + 24*D1**2*f*gdd2 + 20*D1**2*fd**2*r**2 + 40*D1**2*fd**2*r*s - 40*D1**2*fd**2*r + 20*D1**2*fd**2*s**2 - 40*D1**2*fd**2*s + 20*D1**2*fd**2 - 20*D1**2*fd*g2*r**2 - 40*D1**2*fd*g2*r*s + 40*D1**2*fd*g2*r - 20*D1**2*fd*g2*s**2 + 40*D1**2*fd*g2*s - 20*D1**2*fd*g2 + 48*D1**2*fd*gd2*r**2 + 96*D1**2*fd*gd2*r*s - 96*D1**2*fd*gd2*r + 48*D1**2*fd*gd2*s**2 - 96*D1**2*fd*gd2*s + 48*D1**2*fd*gd2 + 24*D1**2*fdd*g2*r**2 + 48*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*r + 24*D1**2*fdd*g2*s**2 - 48*D1**2*fdd*g2*s + 24*D1**2*fdd*g2 + 40*D1*Dd*b2*f*r**2 + 80*D1*Dd*b2*f*r*s - 60*D1*Dd*b2*f*r + 40*D1*Dd*b2*f*s**2 - 60*D1*Dd*b2*f*s + 30*D1*Dd*b2*f - 96*D1*Dd*b2*fd*r**2 - 192*D1*Dd*b2*fd*r*s + 168*D1*Dd*b2*fd*r - 96*D1*Dd*b2*fd*s**2 + 168*D1*Dd*b2*fd*s - 72*D1*Dd*b2*fd - 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 160*D1*Dd*f*fd*r**2 + 320*D1*Dd*f*fd*r*s - 280*D1*Dd*f*fd*r + 160*D1*Dd*f*fd*s**2 - 280*D1*Dd*f*fd*s + 120*D1*Dd*f*fd - 80*D1*Dd*f*g2*r**2 - 160*D1*Dd*f*g2*r*s + 120*D1*Dd*f*g2*r - 80*D1*Dd*f*g2*s**2 + 120*D1*Dd*f*g2*s - 60*D1*Dd*f*g2 + 192*D1*Dd*f*gd2*r**2 + 384*D1*Dd*f*gd2*r*s - 336*D1*Dd*f*gd2*r + 192*D1*Dd*f*gd2*s**2 - 336*D1*Dd*f*gd2*s + 144*D1*Dd*f*gd2 + 192*D1*Dd*fd*g2*r**2 + 384*D1*Dd*fd*g2*r*s - 336*D1*Dd*fd*g2*r + 192*D1*Dd*fd*g2*s**2 - 336*D1*Dd*fd*g2*s + 144*D1*Dd*fd*g2 - 48*D1*Ddd*b2*f*r**2 - 96*D1*Ddd*b2*f*r*s + 72*D1*Ddd*b2*f*r - 48*D1*Ddd*b2*f*s**2 + 72*D1*Ddd*b2*f*s - 36*D1*Ddd*b2*f + 40*D1*Ddd*f**2*r**2 + 80*D1*Ddd*f**2*r*s - 60*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 60*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + 96*D1*Ddd*f*g2*r**2 + 192*D1*Ddd*f*g2*r*s - 144*D1*Ddd*f*g2*r + 96*D1*Ddd*f*g2*s**2 - 144*D1*Ddd*f*g2*s + 72*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*f*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 12*Dd*f*(2*K - 1)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2*D1*bd2*(D1*(5*f - 12*fd)*(r + s - 1) - 12*Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 144*Dd**2*b2*f*r**2 - 288*Dd**2*b2*f*r*s + 216*Dd**2*b2*f*r - 144*Dd**2*b2*f*s**2 + 216*Dd**2*b2*f*s - 72*Dd**2*b2*f + 120*Dd**2*f**2*r**2 + 240*Dd**2*f**2*r*s - 180*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 180*Dd**2*f**2*s + 60*Dd**2*f**2 + 288*Dd**2*f*g2*r**2 + 576*Dd**2*f*g2*r*s - 432*Dd**2*f*g2*r + 288*Dd**2*f*g2*s**2 - 432*Dd**2*f*g2*s + 144*Dd**2*f*g2))/(21*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**2*f*k1**4*k2**2*st**4*(-312*C*D1**2*f*fd*r**2 - 624*C*D1**2*f*fd*r*s + 416*C*D1**2*f*fd*r - 312*C*D1**2*f*fd*s**2 + 416*C*D1**2*f*fd*s - 208*C*D1**2*f*fd + 156*C*D1**2*f*fdd*r**2 + 312*C*D1**2*f*fdd*r*s - 208*C*D1**2*f*fdd*r + 156*C*D1**2*f*fdd*s**2 - 208*C*D1**2*f*fdd*s + 104*C*D1**2*f*fdd + 312*C*D1**2*fd**2*r**2 + 624*C*D1**2*fd**2*r*s - 416*C*D1**2*fd**2*r + 312*C*D1**2*fd**2*s**2 - 416*C*D1**2*fd**2*s + 104*C*D1**2*fd**2 - 416*C*D1*Dd*f**2*r**2 - 832*C*D1*Dd*f**2*r*s + 624*C*D1*Dd*f**2*r - 416*C*D1*Dd*f**2*s**2 + 624*C*D1*Dd*f**2*s - 312*C*D1*Dd*f**2 + 1248*C*D1*Dd*f*fd*r**2 + 2496*C*D1*Dd*f*fd*r*s - 1768*C*D1*Dd*f*fd*r + 1248*C*D1*Dd*f*fd*s**2 - 1768*C*D1*Dd*f*fd*s + 624*C*D1*Dd*f*fd + 208*C*D1*Ddd*f**2*r**2 + 416*C*D1*Ddd*f**2*r*s - 312*C*D1*Ddd*f**2*r + 208*C*D1*Ddd*f**2*s**2 - 312*C*D1*Ddd*f**2*s + 156*C*D1*Ddd*f**2 + 624*C*Dd**2*f**2*r**2 + 1248*C*Dd**2*f**2*r*s - 936*C*Dd**2*f**2*r + 624*C*Dd**2*f**2*s**2 - 936*C*Dd**2*f**2*s + 312*C*Dd**2*f**2 - 143*D1**2*bd1*f*(K - 1)*(r + s - 1)**2 - 3220*D1**2*f**2*fd*r**2 - 6440*D1**2*f**2*fd*r*s + 4830*D1**2*f**2*fd*r - 3220*D1**2*f**2*fd*s**2 + 4830*D1**2*f**2*fd*s - 2415*D1**2*f**2*fd + 2000*D1**2*f**2*fdd*r**2 + 4000*D1**2*f**2*fdd*r*s - 3000*D1**2*f**2*fdd*r + 2000*D1**2*f**2*fdd*s**2 - 3000*D1**2*f**2*fdd*s + 1500*D1**2*f**2*fdd + 6000*D1**2*f*fd**2*r**2 + 12000*D1**2*f*fd**2*r*s - 9000*D1**2*f*fd**2*r + 6000*D1**2*f*fd**2*s**2 - 9000*D1**2*f*fd**2*s + 3000*D1**2*f*fd**2 + 312*D1**2*f*fd*r**2 + 624*D1**2*f*fd*r*s - 416*D1**2*f*fd*r + 312*D1**2*f*fd*s**2 - 416*D1**2*f*fd*s + 208*D1**2*f*fd - 156*D1**2*f*fdd*r**2 - 312*D1**2*f*fdd*r*s + 208*D1**2*f*fdd*r - 156*D1**2*f*fdd*s**2 + 208*D1**2*f*fdd*s - 104*D1**2*f*fdd + 286*D1**2*f*gd2*r**2 + 572*D1**2*f*gd2*r*s - 572*D1**2*f*gd2*r + 286*D1**2*f*gd2*s**2 - 572*D1**2*f*gd2*s + 286*D1**2*f*gd2 - 312*D1**2*fd**2*r**2 - 624*D1**2*fd**2*r*s + 416*D1**2*fd**2*r - 312*D1**2*fd**2*s**2 + 416*D1**2*fd**2*s - 104*D1**2*fd**2 + 572*D1**2*fd*g2*r**2 + 1144*D1**2*fd*g2*r*s - 572*D1**2*fd*g2*r + 572*D1**2*fd*g2*s**2 - 572*D1**2*fd*g2*s + 286*D1**2*fd*g2 - 3220*D1*Dd*f**3*r**2 - 6440*D1*Dd*f**3*r*s + 4830*D1*Dd*f**3*r - 3220*D1*Dd*f**3*s**2 + 4830*D1*Dd*f**3*s - 2415*D1*Dd*f**3 + 16000*D1*Dd*f**2*fd*r**2 + 32000*D1*Dd*f**2*fd*r*s - 24000*D1*Dd*f**2*fd*r + 16000*D1*Dd*f**2*fd*s**2 - 24000*D1*Dd*f**2*fd*s + 9000*D1*Dd*f**2*fd + 416*D1*Dd*f**2*r**2 + 832*D1*Dd*f**2*r*s - 624*D1*Dd*f**2*r + 416*D1*Dd*f**2*s**2 - 624*D1*Dd*f**2*s + 312*D1*Dd*f**2 - 1248*D1*Dd*f*fd*r**2 - 2496*D1*Dd*f*fd*r*s + 1768*D1*Dd*f*fd*r - 1248*D1*Dd*f*fd*s**2 + 1768*D1*Dd*f*fd*s - 624*D1*Dd*f*fd + 1144*D1*Dd*f*g2*r**2 + 2288*D1*Dd*f*g2*r*s - 1716*D1*Dd*f*g2*r + 1144*D1*Dd*f*g2*s**2 - 1716*D1*Dd*f*g2*s + 858*D1*Dd*f*g2 + 2000*D1*Ddd*f**3*r**2 + 4000*D1*Ddd*f**3*r*s - 3000*D1*Ddd*f**3*r + 2000*D1*Ddd*f**3*s**2 - 3000*D1*Ddd*f**3*s + 1500*D1*Ddd*f**3 - 208*D1*Ddd*f**2*r**2 - 416*D1*Ddd*f**2*r*s + 312*D1*Ddd*f**2*r - 208*D1*Ddd*f**2*s**2 + 312*D1*Ddd*f**2*s - 156*D1*Ddd*f**2 - 143*D1*b1*(K - 1)*(D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + 6000*Dd**2*f**3*r**2 + 12000*Dd**2*f**3*r*s - 9000*Dd**2*f**3*r + 6000*Dd**2*f**3*s**2 - 9000*Dd**2*f**3*s + 3000*Dd**2*f**3 - 624*Dd**2*f**2*r**2 - 1248*Dd**2*f**2*r*s + 936*Dd**2*f**2*r - 624*Dd**2*f**2*s**2 + 936*Dd**2*f**2*s - 312*Dd**2*f**2)/(1001*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**2*f*k2**6*st**4*(10*C - 5)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*f*k2**4*st**4*(10*C - 5)*(D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**2*k1**6*st**2*(1326*C*D1**2*f**2*fd*r**2 + 2652*C*D1**2*f**2*fd*r*s - 1768*C*D1**2*f**2*fd*r + 1326*C*D1**2*f**2*fd*s**2 - 1768*C*D1**2*f**2*fd*s + 884*C*D1**2*f**2*fd - 1950*C*D1**2*f**2*fdd*r**2 - 3900*C*D1**2*f**2*fdd*r*s + 2600*C*D1**2*f**2*fdd*r - 1950*C*D1**2*f**2*fdd*s**2 + 2600*C*D1**2*f**2*fdd*s - 1300*C*D1**2*f**2*fdd - 3900*C*D1**2*f*fd**2*r**2 - 7800*C*D1**2*f*fd**2*r*s + 5200*C*D1**2*f*fd**2*r - 3900*C*D1**2*f*fd**2*s**2 + 5200*C*D1**2*f*fd**2*s - 1300*C*D1**2*f*fd**2 + 1768*C*D1*Dd*f**3*r**2 + 3536*C*D1*Dd*f**3*r*s - 2652*C*D1*Dd*f**3*r + 1768*C*D1*Dd*f**3*s**2 - 2652*C*D1*Dd*f**3*s + 1326*C*D1*Dd*f**3 - 15600*C*D1*Dd*f**2*fd*r**2 - 31200*C*D1*Dd*f**2*fd*r*s + 22100*C*D1*Dd*f**2*fd*r - 15600*C*D1*Dd*f**2*fd*s**2 + 22100*C*D1*Dd*f**2*fd*s - 7800*C*D1*Dd*f**2*fd - 2600*C*D1*Ddd*f**3*r**2 - 5200*C*D1*Ddd*f**3*r*s + 3900*C*D1*Ddd*f**3*r - 2600*C*D1*Ddd*f**3*s**2 + 3900*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 7800*C*Dd**2*f**3*r**2 - 15600*C*Dd**2*f**3*r*s + 11700*C*Dd**2*f**3*r - 7800*C*Dd**2*f**3*s**2 + 11700*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 + 858*D1**2*K*b1*f*fd*r**2 + 1716*D1**2*K*b1*f*fd*r*s - 858*D1**2*K*b1*f*fd*r + 858*D1**2*K*b1*f*fd*s**2 - 858*D1**2*K*b1*f*fd*s + 429*D1**2*K*b1*f*fd - 858*D1**2*K*b1*f*fdd*r**2 - 1716*D1**2*K*b1*f*fdd*r*s + 858*D1**2*K*b1*f*fdd*r - 858*D1**2*K*b1*f*fdd*s**2 + 858*D1**2*K*b1*f*fdd*s - 429*D1**2*K*b1*f*fdd - 858*D1**2*K*b1*fd**2*r**2 - 1716*D1**2*K*b1*fd**2*r*s + 858*D1**2*K*b1*fd**2*r - 858*D1**2*K*b1*fd**2*s**2 + 858*D1**2*K*b1*fd**2*s - 858*D1**2*b1*f*fd*r**2 - 1716*D1**2*b1*f*fd*r*s + 858*D1**2*b1*f*fd*r - 858*D1**2*b1*f*fd*s**2 + 858*D1**2*b1*f*fd*s - 429*D1**2*b1*f*fd + 858*D1**2*b1*f*fdd*r**2 + 1716*D1**2*b1*f*fdd*r*s - 858*D1**2*b1*f*fdd*r + 858*D1**2*b1*f*fdd*s**2 - 858*D1**2*b1*f*fdd*s + 429*D1**2*b1*f*fdd + 858*D1**2*b1*fd**2*r**2 + 1716*D1**2*b1*fd**2*r*s - 858*D1**2*b1*fd**2*r + 858*D1**2*b1*fd**2*s**2 - 858*D1**2*b1*fd**2*s - 429*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 + 27600*D1**2*f**3*fd*r**2 + 55200*D1**2*f**3*fd*r*s - 41400*D1**2*f**3*fd*r + 27600*D1**2*f**3*fd*s**2 - 41400*D1**2*f**3*fd*s + 20700*D1**2*f**3*fd - 29400*D1**2*f**3*fdd*r**2 - 58800*D1**2*f**3*fdd*r*s + 44100*D1**2*f**3*fdd*r - 29400*D1**2*f**3*fdd*s**2 + 44100*D1**2*f**3*fdd*s - 22050*D1**2*f**3*fdd - 88200*D1**2*f**2*fd**2*r**2 - 176400*D1**2*f**2*fd**2*r*s + 132300*D1**2*f**2*fd**2*r - 88200*D1**2*f**2*fd**2*s**2 + 132300*D1**2*f**2*fd**2*s - 44100*D1**2*f**2*fd**2 - 1326*D1**2*f**2*fd*r**2 - 2652*D1**2*f**2*fd*r*s + 1768*D1**2*f**2*fd*r - 1326*D1**2*f**2*fd*s**2 + 1768*D1**2*f**2*fd*s - 884*D1**2*f**2*fd + 1950*D1**2*f**2*fdd*r**2 + 3900*D1**2*f**2*fdd*r*s - 2600*D1**2*f**2*fdd*r + 1950*D1**2*f**2*fdd*s**2 - 2600*D1**2*f**2*fdd*s + 1300*D1**2*f**2*fdd - 858*D1**2*f**2*gd2*r**2 - 1716*D1**2*f**2*gd2*r*s + 1716*D1**2*f**2*gd2*r - 858*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s - 858*D1**2*f**2*gd2 + 858*D1**2*f**2*gdd2*r**2 + 1716*D1**2*f**2*gdd2*r*s - 1716*D1**2*f**2*gdd2*r + 858*D1**2*f**2*gdd2*s**2 - 1716*D1**2*f**2*gdd2*s + 858*D1**2*f**2*gdd2 + 3900*D1**2*f*fd**2*r**2 + 7800*D1**2*f*fd**2*r*s - 5200*D1**2*f*fd**2*r + 3900*D1**2*f*fd**2*s**2 - 5200*D1**2*f*fd**2*s + 1300*D1**2*f*fd**2 - 1716*D1**2*f*fd*g2*r**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 1716*D1**2*f*fd*g2*s**2 + 1716*D1**2*f*fd*g2*s - 858*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r**2 + 6864*D1**2*f*fd*gd2*r*s - 5148*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1716*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r**2 + 3432*D1**2*f*fdd*g2*r*s - 1716*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r**2 + 3432*D1**2*fd**2*g2*r*s - 1716*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 1716*D1*Dd*K*b1*f**2*r**2 + 3432*D1*Dd*K*b1*f**2*r*s - 2574*D1*Dd*K*b1*f**2*r + 1716*D1*Dd*K*b1*f**2*s**2 - 2574*D1*Dd*K*b1*f**2*s + 1287*D1*Dd*K*b1*f**2 - 6864*D1*Dd*K*b1*f*fd*r**2 - 13728*D1*Dd*K*b1*f*fd*r*s + 8580*D1*Dd*K*b1*f*fd*r - 6864*D1*Dd*K*b1*f*fd*s**2 + 8580*D1*Dd*K*b1*f*fd*s - 2574*D1*Dd*K*b1*f*fd - 1716*D1*Dd*b1*f**2*r**2 - 3432*D1*Dd*b1*f**2*r*s + 2574*D1*Dd*b1*f**2*r - 1716*D1*Dd*b1*f**2*s**2 + 2574*D1*Dd*b1*f**2*s - 1287*D1*Dd*b1*f**2 + 6864*D1*Dd*b1*f*fd*r**2 + 13728*D1*Dd*b1*f*fd*r*s - 8580*D1*Dd*b1*f*fd*r + 6864*D1*Dd*b1*f*fd*s**2 - 8580*D1*Dd*b1*f*fd*s + 2574*D1*Dd*b1*f*fd + 27600*D1*Dd*f**4*r**2 + 55200*D1*Dd*f**4*r*s - 41400*D1*Dd*f**4*r + 27600*D1*Dd*f**4*s**2 - 41400*D1*Dd*f**4*s + 20700*D1*Dd*f**4 - 235200*D1*Dd*f**3*fd*r**2 - 470400*D1*Dd*f**3*fd*r*s + 352800*D1*Dd*f**3*fd*r - 235200*D1*Dd*f**3*fd*s**2 + 352800*D1*Dd*f**3*fd*s - 132300*D1*Dd*f**3*fd - 1768*D1*Dd*f**3*r**2 - 3536*D1*Dd*f**3*r*s + 2652*D1*Dd*f**3*r - 1768*D1*Dd*f**3*s**2 + 2652*D1*Dd*f**3*s - 1326*D1*Dd*f**3 + 15600*D1*Dd*f**2*fd*r**2 + 31200*D1*Dd*f**2*fd*r*s - 22100*D1*Dd*f**2*fd*r + 15600*D1*Dd*f**2*fd*s**2 - 22100*D1*Dd*f**2*fd*s + 7800*D1*Dd*f**2*fd - 3432*D1*Dd*f**2*g2*r**2 - 6864*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 3432*D1*Dd*f**2*g2*s**2 + 5148*D1*Dd*f**2*g2*s - 2574*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r**2 + 13728*D1*Dd*f**2*gd2*r*s - 12012*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 12012*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r**2 + 27456*D1*Dd*f*fd*g2*r*s - 17160*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 17160*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 - 1716*D1*Ddd*K*b1*f**2*r**2 - 3432*D1*Ddd*K*b1*f**2*r*s + 2574*D1*Ddd*K*b1*f**2*r - 1716*D1*Ddd*K*b1*f**2*s**2 + 2574*D1*Ddd*K*b1*f**2*s - 1287*D1*Ddd*K*b1*f**2 + 1716*D1*Ddd*b1*f**2*r**2 + 3432*D1*Ddd*b1*f**2*r*s - 2574*D1*Ddd*b1*f**2*r + 1716*D1*Ddd*b1*f**2*s**2 - 2574*D1*Ddd*b1*f**2*s + 1287*D1*Ddd*b1*f**2 - 29400*D1*Ddd*f**4*r**2 - 58800*D1*Ddd*f**4*r*s + 44100*D1*Ddd*f**4*r - 29400*D1*Ddd*f**4*s**2 + 44100*D1*Ddd*f**4*s - 22050*D1*Ddd*f**4 + 2600*D1*Ddd*f**3*r**2 + 5200*D1*Ddd*f**3*r*s - 3900*D1*Ddd*f**3*r + 2600*D1*Ddd*f**3*s**2 - 3900*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r**2 + 6864*D1*Ddd*f**2*g2*r*s - 5148*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 5148*Dd**2*K*b1*f**2*r**2 - 10296*Dd**2*K*b1*f**2*r*s + 7722*Dd**2*K*b1*f**2*r - 5148*Dd**2*K*b1*f**2*s**2 + 7722*Dd**2*K*b1*f**2*s - 2574*Dd**2*K*b1*f**2 + 5148*Dd**2*b1*f**2*r**2 + 10296*Dd**2*b1*f**2*r*s - 7722*Dd**2*b1*f**2*r + 5148*Dd**2*b1*f**2*s**2 - 7722*Dd**2*b1*f**2*s + 2574*Dd**2*b1*f**2 - 88200*Dd**2*f**4*r**2 - 176400*Dd**2*f**4*r*s + 132300*Dd**2*f**4*r - 88200*Dd**2*f**4*s**2 + 132300*Dd**2*f**4*s - 44100*Dd**2*f**4 + 7800*Dd**2*f**3*r**2 + 15600*Dd**2*f**3*r*s - 11700*Dd**2*f**3*r + 7800*Dd**2*f**3*s**2 - 11700*Dd**2*f**3*s + 3900*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r**2 + 20592*Dd**2*f**2*g2*r*s - 15444*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2)/(18018*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**6*(2*D1*(r + s - 1)*(198*D1*bd1**2*f*(K - 1)*(r + s - 1) - D1*bd1*(230*f**3*(r + s - 1) + 4*f**2*(33*C*(r + s - 1) - 140*fd*(3*r + 3*s - 2) - 33*r - 33*s + 33) - 33*f*(fd*(10*C - 10)*(2*r + 2*s - 1) + (5*g2 - 12*gd2)*(r + s - 1)) + 396*fd*g2*(r + s)) + D1*bdd1*f*(280*f**2 + f*(165*C - 165) - 198*g2)*(r + s - 1) + 2*Dd*bd1*f*(280*f**2 + f*(165*C - 165) - 198*g2)*(4*r + 4*s - 3)) - 33*b1**2*(K - 1)*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*b1*(264*C*D1**2*f*fd*r**2 + 528*C*D1**2*f*fd*r*s - 264*C*D1**2*f*fd*r + 264*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s + 132*C*D1**2*f*fd - 330*C*D1**2*f*fdd*r**2 - 660*C*D1**2*f*fdd*r*s + 330*C*D1**2*f*fdd*r - 330*C*D1**2*f*fdd*s**2 + 330*C*D1**2*f*fdd*s - 165*C*D1**2*f*fdd - 330*C*D1**2*fd**2*r**2 - 660*C*D1**2*fd**2*r*s + 330*C*D1**2*fd**2*r - 330*C*D1**2*fd**2*s**2 + 330*C*D1**2*fd**2*s + 528*C*D1*Dd*f**2*r**2 + 1056*C*D1*Dd*f**2*r*s - 792*C*D1*Dd*f**2*r + 528*C*D1*Dd*f**2*s**2 - 792*C*D1*Dd*f**2*s + 396*C*D1*Dd*f**2 - 2640*C*D1*Dd*f*fd*r**2 - 5280*C*D1*Dd*f*fd*r*s + 3300*C*D1*Dd*f*fd*r - 2640*C*D1*Dd*f*fd*s**2 + 3300*C*D1*Dd*f*fd*s - 990*C*D1*Dd*f*fd - 660*C*D1*Ddd*f**2*r**2 - 1320*C*D1*Ddd*f**2*r*s + 990*C*D1*Ddd*f**2*r - 660*C*D1*Ddd*f**2*s**2 + 990*C*D1*Ddd*f**2*s - 495*C*D1*Ddd*f**2 - 1980*C*Dd**2*f**2*r**2 - 3960*C*Dd**2*f**2*r*s + 2970*C*Dd**2*f**2*r - 1980*C*Dd**2*f**2*s**2 + 2970*C*Dd**2*f**2*s - 990*C*Dd**2*f**2 - 198*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 690*D1**2*f**2*fd*r**2 + 1380*D1**2*f**2*fd*r*s - 920*D1**2*f**2*fd*r + 690*D1**2*f**2*fd*s**2 - 920*D1**2*f**2*fd*s + 460*D1**2*f**2*fd - 840*D1**2*f**2*fdd*r**2 - 1680*D1**2*f**2*fdd*r*s + 1120*D1**2*f**2*fdd*r - 840*D1**2*f**2*fdd*s**2 + 1120*D1**2*f**2*fdd*s - 560*D1**2*f**2*fdd - 1680*D1**2*f*fd**2*r**2 - 3360*D1**2*f*fd**2*r*s + 2240*D1**2*f*fd**2*r - 1680*D1**2*f*fd**2*s**2 + 2240*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 - 264*D1**2*f*fd*r**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 264*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s - 132*D1**2*f*fd + 330*D1**2*f*fdd*r**2 + 660*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 330*D1**2*f*fdd*s**2 - 330*D1**2*f*fdd*s + 165*D1**2*f*fdd - 165*D1**2*f*gd2*r**2 - 330*D1**2*f*gd2*r*s + 330*D1**2*f*gd2*r - 165*D1**2*f*gd2*s**2 + 330*D1**2*f*gd2*s - 165*D1**2*f*gd2 + 198*D1**2*f*gdd2*r**2 + 396*D1**2*f*gdd2*r*s - 396*D1**2*f*gdd2*r + 198*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s + 198*D1**2*f*gdd2 + 330*D1**2*fd**2*r**2 + 660*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 330*D1**2*fd**2*s**2 - 330*D1**2*fd**2*s - 165*D1**2*fd*g2*r**2 - 330*D1**2*fd*g2*r*s - 165*D1**2*fd*g2*s**2 + 396*D1**2*fd*gd2*r**2 + 792*D1**2*fd*gd2*r*s - 396*D1**2*fd*gd2*r + 396*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 198*D1**2*fdd*g2*r**2 + 396*D1**2*fdd*g2*r*s + 198*D1**2*fdd*g2*s**2 + 920*D1*Dd*f**3*r**2 + 1840*D1*Dd*f**3*r*s - 1380*D1*Dd*f**3*r + 920*D1*Dd*f**3*s**2 - 1380*D1*Dd*f**3*s + 690*D1*Dd*f**3 - 6720*D1*Dd*f**2*fd*r**2 - 13440*D1*Dd*f**2*fd*r*s + 9520*D1*Dd*f**2*fd*r - 6720*D1*Dd*f**2*fd*s**2 + 9520*D1*Dd*f**2*fd*s - 3360*D1*Dd*f**2*fd - 528*D1*Dd*f**2*r**2 - 1056*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 528*D1*Dd*f**2*s**2 + 792*D1*Dd*f**2*s - 396*D1*Dd*f**2 + 2640*D1*Dd*f*fd*r**2 + 5280*D1*Dd*f*fd*r*s - 3300*D1*Dd*f*fd*r + 2640*D1*Dd*f*fd*s**2 - 3300*D1*Dd*f*fd*s + 990*D1*Dd*f*fd - 660*D1*Dd*f*g2*r**2 - 1320*D1*Dd*f*g2*r*s + 990*D1*Dd*f*g2*r - 660*D1*Dd*f*g2*s**2 + 990*D1*Dd*f*g2*s - 495*D1*Dd*f*g2 + 1584*D1*Dd*f*gd2*r**2 + 3168*D1*Dd*f*gd2*r*s - 2772*D1*Dd*f*gd2*r + 1584*D1*Dd*f*gd2*s**2 - 2772*D1*Dd*f*gd2*s + 1188*D1*Dd*f*gd2 + 1584*D1*Dd*fd*g2*r**2 + 3168*D1*Dd*fd*g2*r*s - 1188*D1*Dd*fd*g2*r + 1584*D1*Dd*fd*g2*s**2 - 1188*D1*Dd*fd*g2*s - 1120*D1*Ddd*f**3*r**2 - 2240*D1*Ddd*f**3*r*s + 1680*D1*Ddd*f**3*r - 1120*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 840*D1*Ddd*f**3 + 660*D1*Ddd*f**2*r**2 + 1320*D1*Ddd*f**2*r*s - 990*D1*Ddd*f**2*r + 660*D1*Ddd*f**2*s**2 - 990*D1*Ddd*f**2*s + 495*D1*Ddd*f**2 + 792*D1*Ddd*f*g2*r**2 + 1584*D1*Ddd*f*g2*r*s - 1188*D1*Ddd*f*g2*r + 792*D1*Ddd*f*g2*s**2 - 1188*D1*Ddd*f*g2*s + 594*D1*Ddd*f*g2 + 33*D1*bd1*(K - 1)*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3360*Dd**2*f**3*r**2 - 6720*Dd**2*f**3*r*s + 5040*Dd**2*f**3*r - 3360*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 1680*Dd**2*f**3 + 1980*Dd**2*f**2*r**2 + 3960*Dd**2*f**2*r*s - 2970*Dd**2*f**2*r + 1980*Dd**2*f**2*s**2 - 2970*Dd**2*f**2*s + 990*Dd**2*f**2 + 2376*Dd**2*f*g2*r**2 + 4752*Dd**2*f*g2*r*s - 3564*Dd**2*f*g2*r + 2376*Dd**2*f*g2*s**2 - 3564*Dd**2*f*g2*s + 1188*Dd**2*f*g2))/(693*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**2*k1**4*k2**2*st**2*(-132*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 - 132*D1**2*bdd1*f*(f*(C + 2*K - 2) - g2)*(r + s - 1)**2 - 2*D1**2*(75*f**3*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(-fd*(213*C - 157)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(200*C - 150)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (341*gd2 - 264*gdd2)*(r + s - 1)**2) + f*(fd**2*(400*C - 300)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 11*fd*(31*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 48*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 264*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 528*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 11*D1*bd1*(D1*(12*f**3*(r + s - 1) + f**2*(22*C + 31*K - 37)*(r + s - 1) - 24*f*fd*(C + 2*K - 2)*(2*r + 2*s - 1) - 2*f*(19*g2 - 12*gd2)*(r + s - 1) + 24*fd*g2*(r + s)) - 24*Dd*f*(f*(C + 2*K - 2) - g2)*(4*r + 4*s - 3))*(r + s - 1) - 2*D1*f*(Dd*(75*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(213*C - 157)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(fd*(400*C - 300)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 341*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 528*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - 528*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2*Ddd*f*(f*(100*C - 75) - 132*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Dd**2*f**2*(f*(100*C - 75) - 132*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 11*b1**2*(K - 1)*(D1**2*(19*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(19*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1*(44*C*D1**2*f*fd*r**2 + 88*C*D1**2*f*fd*r*s - 44*C*D1**2*f*fd*r + 44*C*D1**2*f*fd*s**2 - 44*C*D1**2*f*fd*s + 22*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 + 24*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 + 24*C*D1**2*fd**2*s + 88*C*D1*Dd*f**2*r**2 + 176*C*D1*Dd*f**2*r*s - 132*C*D1*Dd*f**2*r + 88*C*D1*Dd*f**2*s**2 - 132*C*D1*Dd*f**2*s + 66*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s + 240*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 240*C*D1*Dd*f*fd*s - 72*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r*s + 72*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 72*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r*s + 216*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 216*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 + 62*D1**2*K*f*fd*r**2 + 124*D1**2*K*f*fd*r*s - 62*D1**2*K*f*fd*r + 62*D1**2*K*f*fd*s**2 - 62*D1**2*K*f*fd*s + 31*D1**2*K*f*fd - 48*D1**2*K*f*fdd*r**2 - 96*D1**2*K*f*fdd*r*s + 48*D1**2*K*f*fdd*r - 48*D1**2*K*f*fdd*s**2 + 48*D1**2*K*f*fdd*s - 24*D1**2*K*f*fdd - 48*D1**2*K*fd**2*r**2 - 96*D1**2*K*fd**2*r*s + 48*D1**2*K*fd**2*r - 48*D1**2*K*fd**2*s**2 + 48*D1**2*K*fd**2*s - 12*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 36*D1**2*f**2*fd*r**2 + 72*D1**2*f**2*fd*r*s - 48*D1**2*f**2*fd*r + 36*D1**2*f**2*fd*s**2 - 48*D1**2*f**2*fd*s + 24*D1**2*f**2*fd - 74*D1**2*f*fd*r**2 - 148*D1**2*f*fd*r*s + 74*D1**2*f*fd*r - 74*D1**2*f*fd*s**2 + 74*D1**2*f*fd*s - 37*D1**2*f*fd + 48*D1**2*f*fdd*r**2 + 96*D1**2*f*fdd*r*s - 48*D1**2*f*fdd*r + 48*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 24*D1**2*f*fdd - 38*D1**2*f*gd2*r**2 - 76*D1**2*f*gd2*r*s + 76*D1**2*f*gd2*r - 38*D1**2*f*gd2*s**2 + 76*D1**2*f*gd2*s - 38*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*r + 12*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s + 12*D1**2*f*gdd2 + 48*D1**2*fd**2*r**2 + 96*D1**2*fd**2*r*s - 48*D1**2*fd**2*r + 48*D1**2*fd**2*s**2 - 48*D1**2*fd**2*s - 38*D1**2*fd*g2*r**2 - 76*D1**2*fd*g2*r*s - 38*D1**2*fd*g2*s**2 + 24*D1**2*fd*gd2*r**2 + 48*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 24*D1**2*fd*gd2*s + 12*D1**2*fdd*g2*r**2 + 24*D1**2*fdd*g2*r*s + 12*D1**2*fdd*g2*s**2 + 124*D1*Dd*K*f**2*r**2 + 248*D1*Dd*K*f**2*r*s - 186*D1*Dd*K*f**2*r + 124*D1*Dd*K*f**2*s**2 - 186*D1*Dd*K*f**2*s + 93*D1*Dd*K*f**2 - 384*D1*Dd*K*f*fd*r**2 - 768*D1*Dd*K*f*fd*r*s + 480*D1*Dd*K*f*fd*r - 384*D1*Dd*K*f*fd*s**2 + 480*D1*Dd*K*f*fd*s - 144*D1*Dd*K*f*fd + 48*D1*Dd*f**3*r**2 + 96*D1*Dd*f**3*r*s - 72*D1*Dd*f**3*r + 48*D1*Dd*f**3*s**2 - 72*D1*Dd*f**3*s + 36*D1*Dd*f**3 - 148*D1*Dd*f**2*r**2 - 296*D1*Dd*f**2*r*s + 222*D1*Dd*f**2*r - 148*D1*Dd*f**2*s**2 + 222*D1*Dd*f**2*s - 111*D1*Dd*f**2 + 384*D1*Dd*f*fd*r**2 + 768*D1*Dd*f*fd*r*s - 480*D1*Dd*f*fd*r + 384*D1*Dd*f*fd*s**2 - 480*D1*Dd*f*fd*s + 144*D1*Dd*f*fd - 152*D1*Dd*f*g2*r**2 - 304*D1*Dd*f*g2*r*s + 228*D1*Dd*f*g2*r - 152*D1*Dd*f*g2*s**2 + 228*D1*Dd*f*g2*s - 114*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 192*D1*Dd*f*gd2*r*s - 168*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 168*D1*Dd*f*gd2*s + 72*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 192*D1*Dd*fd*g2*r*s - 72*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 72*D1*Dd*fd*g2*s - 96*D1*Ddd*K*f**2*r**2 - 192*D1*Ddd*K*f**2*r*s + 144*D1*Ddd*K*f**2*r - 96*D1*Ddd*K*f**2*s**2 + 144*D1*Ddd*K*f**2*s - 72*D1*Ddd*K*f**2 + 96*D1*Ddd*f**2*r**2 + 192*D1*Ddd*f**2*r*s - 144*D1*Ddd*f**2*r + 96*D1*Ddd*f**2*s**2 - 144*D1*Ddd*f**2*s + 72*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 96*D1*Ddd*f*g2*r*s - 72*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 72*D1*Ddd*f*g2*s + 36*D1*Ddd*f*g2 + 2*D1*bd1*(K - 1)*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 288*Dd**2*K*f**2*r**2 - 576*Dd**2*K*f**2*r*s + 432*Dd**2*K*f**2*r - 288*Dd**2*K*f**2*s**2 + 432*Dd**2*K*f**2*s - 144*Dd**2*K*f**2 + 288*Dd**2*f**2*r**2 + 576*Dd**2*f**2*r*s - 432*Dd**2*f**2*r + 288*Dd**2*f**2*s**2 - 432*Dd**2*f**2*s + 144*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 288*Dd**2*f*g2*r*s - 216*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 216*Dd**2*f*g2*s + 72*Dd**2*f*g2))/(462*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**4*k2**2*(2640*C*D1**2*bdd1*f**2*r**2 + 5280*C*D1**2*bdd1*f**2*r*s - 5280*C*D1**2*bdd1*f**2*r + 2640*C*D1**2*bdd1*f**2*s**2 - 5280*C*D1**2*bdd1*f**2*s + 2640*C*D1**2*bdd1*f**2 - 690*C*D1**2*f**2*fd*r**2 - 1380*C*D1**2*f**2*fd*r*s + 920*C*D1**2*f**2*fd*r - 690*C*D1**2*f**2*fd*s**2 + 920*C*D1**2*f**2*fd*s - 460*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r**2 + 1680*C*D1**2*f**2*fdd*r*s - 1120*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 1120*C*D1**2*f**2*fdd*s + 560*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r**2 + 3360*C*D1**2*f*fd**2*r*s - 2240*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 2240*C*D1**2*f*fd**2*s + 560*C*D1**2*f*fd**2 - 920*C*D1*Dd*f**3*r**2 - 1840*C*D1*Dd*f**3*r*s + 1380*C*D1*Dd*f**3*r - 920*C*D1*Dd*f**3*s**2 + 1380*C*D1*Dd*f**3*s - 690*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r**2 + 13440*C*D1*Dd*f**2*fd*r*s - 9520*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 9520*C*D1*Dd*f**2*fd*s + 3360*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r**2 + 2240*C*D1*Ddd*f**3*r*s - 1680*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1680*C*D1*Ddd*f**3*s + 840*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r**2 + 6720*C*Dd**2*f**3*r*s - 5040*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 5040*C*Dd**2*f**3*s + 1680*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r**2 + 330*D1**2*K*bdd1*f**2*r*s - 330*D1**2*K*bdd1*f**2*r + 165*D1**2*K*bdd1*f**2*s**2 - 330*D1**2*K*bdd1*f**2*s + 165*D1**2*K*bdd1*f**2 - 132*D1**2*bd1**2*f*(-24*K + 25*f + 12)*(r + s - 1)**2 - 1980*D1**2*bdd1*f**2*r**2 - 3960*D1**2*bdd1*f**2*r*s + 3960*D1**2*bdd1*f**2*r - 1980*D1**2*bdd1*f**2*s**2 + 3960*D1**2*bdd1*f**2*s - 1980*D1**2*bdd1*f**2 - 3168*D1**2*bdd1*f*g2*r**2 - 6336*D1**2*bdd1*f*g2*r*s + 6336*D1**2*bdd1*f*g2*r - 3168*D1**2*bdd1*f*g2*s**2 + 6336*D1**2*bdd1*f*g2*s - 3168*D1**2*bdd1*f*g2 + 345*D1**2*f**2*fd*r**2 + 690*D1**2*f**2*fd*r*s - 460*D1**2*f**2*fd*r + 345*D1**2*f**2*fd*s**2 - 460*D1**2*f**2*fd*s + 230*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r**2 - 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 560*D1**2*f**2*fdd*s - 280*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 330*D1**2*f**2*gdd2*r**2 - 660*D1**2*f**2*gdd2*r*s + 660*D1**2*f**2*gdd2*r - 330*D1**2*f**2*gdd2*s**2 + 660*D1**2*f**2*gdd2*s - 330*D1**2*f**2*gdd2 - 840*D1**2*f*fd**2*r**2 - 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 1120*D1**2*f*fd**2*s - 280*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r**2 - 2640*D1**2*f*fd*gd2*r*s + 1980*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1980*D1**2*f*fd*gd2*s - 660*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r**2 - 1320*D1**2*f*fdd*g2*r*s + 660*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r**2 - 1320*D1**2*fd**2*g2*r*s + 660*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s + 460*D1*Dd*f**3*r**2 + 920*D1*Dd*f**3*r*s - 690*D1*Dd*f**3*r + 460*D1*Dd*f**3*s**2 - 690*D1*Dd*f**3*s + 345*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r**2 - 6720*D1*Dd*f**2*fd*r*s + 4760*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 4760*D1*Dd*f**2*fd*s - 1680*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r**2 - 5280*D1*Dd*f**2*gd2*r*s + 4620*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 4620*D1*Dd*f**2*gd2*s - 1980*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r**2 - 10560*D1*Dd*f*fd*g2*r*s + 6600*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 6600*D1*Dd*f*fd*g2*s - 1980*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r**2 - 1120*D1*Ddd*f**3*r*s + 840*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 840*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r**2 - 2640*D1*Ddd*f**2*g2*r*s + 1980*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1980*D1*Ddd*f**2*g2*s - 990*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(5*f**3*(r + s - 1) - 2*f**2*(13*C + K - 9)*(r + s - 1) + 5*f*fd*(16*C + K - 12)*(2*r + 2*s - 1) + 3*f*(11*g2 - 32*gd2)*(r + s - 1) - 96*fd*g2*(r + s)) + Dd*f*(5*f*(16*C + K - 12) - 96*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1680*Dd**2*f**3*r**2 - 3360*Dd**2*f**3*r*s + 2520*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 2520*Dd**2*f**3*s - 840*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r**2 - 7920*Dd**2*f**2*g2*r*s + 5940*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 5940*Dd**2*f**2*g2*s - 1980*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(2*f*(23*fd - 25*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(100*fd**2*(r + s - 1) + fd*(33*K - 13)*(r + s) - 24*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(46*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(100*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (33*K - 13)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 48*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(-24*K + 25*f + 12)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(-24*K + 25*f + 12)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-104*C*D1**2*f*fd*r**2 - 208*C*D1**2*f*fd*r*s + 104*C*D1**2*f*fd*r - 104*C*D1**2*f*fd*s**2 + 104*C*D1**2*f*fd*s - 52*C*D1**2*f*fd + 160*C*D1**2*f*fdd*r**2 + 320*C*D1**2*f*fdd*r*s - 160*C*D1**2*f*fdd*r + 160*C*D1**2*f*fdd*s**2 - 160*C*D1**2*f*fdd*s + 80*C*D1**2*f*fdd + 160*C*D1**2*fd**2*r**2 + 320*C*D1**2*fd**2*r*s - 160*C*D1**2*fd**2*r + 160*C*D1**2*fd**2*s**2 - 160*C*D1**2*fd**2*s - 208*C*D1*Dd*f**2*r**2 - 416*C*D1*Dd*f**2*r*s + 312*C*D1*Dd*f**2*r - 208*C*D1*Dd*f**2*s**2 + 312*C*D1*Dd*f**2*s - 156*C*D1*Dd*f**2 + 1280*C*D1*Dd*f*fd*r**2 + 2560*C*D1*Dd*f*fd*r*s - 1600*C*D1*Dd*f*fd*r + 1280*C*D1*Dd*f*fd*s**2 - 1600*C*D1*Dd*f*fd*s + 480*C*D1*Dd*f*fd + 320*C*D1*Ddd*f**2*r**2 + 640*C*D1*Ddd*f**2*r*s - 480*C*D1*Ddd*f**2*r + 320*C*D1*Ddd*f**2*s**2 - 480*C*D1*Ddd*f**2*s + 240*C*D1*Ddd*f**2 + 960*C*Dd**2*f**2*r**2 + 1920*C*Dd**2*f**2*r*s - 1440*C*Dd**2*f**2*r + 960*C*Dd**2*f**2*s**2 - 1440*C*Dd**2*f**2*s + 480*C*Dd**2*f**2 - 8*D1**2*K*f*fd*r**2 - 16*D1**2*K*f*fd*r*s + 8*D1**2*K*f*fd*r - 8*D1**2*K*f*fd*s**2 + 8*D1**2*K*f*fd*s - 4*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r**2 + 20*D1**2*K*f*fdd*r*s - 10*D1**2*K*f*fdd*r + 10*D1**2*K*f*fdd*s**2 - 10*D1**2*K*f*fdd*s + 5*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r**2 + 20*D1**2*K*fd**2*r*s - 10*D1**2*K*fd**2*r + 10*D1**2*K*fd**2*s**2 - 10*D1**2*K*fd**2*s - 4*D1**2*bdd1*f*(-24*K + 25*f + 12)*(r + s - 1)**2 + 30*D1**2*f**2*fd*r**2 + 60*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s + 20*D1**2*f**2*fd + 72*D1**2*f*fd*r**2 + 144*D1**2*f*fd*r*s - 72*D1**2*f*fd*r + 72*D1**2*f*fd*s**2 - 72*D1**2*f*fd*s + 36*D1**2*f*fd - 120*D1**2*f*fdd*r**2 - 240*D1**2*f*fdd*r*s + 120*D1**2*f*fdd*r - 120*D1**2*f*fdd*s**2 + 120*D1**2*f*fdd*s - 60*D1**2*f*fdd + 66*D1**2*f*gd2*r**2 + 132*D1**2*f*gd2*r*s - 132*D1**2*f*gd2*r + 66*D1**2*f*gd2*s**2 - 132*D1**2*f*gd2*s + 66*D1**2*f*gd2 - 96*D1**2*f*gdd2*r**2 - 192*D1**2*f*gdd2*r*s + 192*D1**2*f*gdd2*r - 96*D1**2*f*gdd2*s**2 + 192*D1**2*f*gdd2*s - 96*D1**2*f*gdd2 - 120*D1**2*fd**2*r**2 - 240*D1**2*fd**2*r*s + 120*D1**2*fd**2*r - 120*D1**2*fd**2*s**2 + 120*D1**2*fd**2*s + 66*D1**2*fd*g2*r**2 + 132*D1**2*fd*g2*r*s + 66*D1**2*fd*g2*s**2 - 192*D1**2*fd*gd2*r**2 - 384*D1**2*fd*gd2*r*s + 192*D1**2*fd*gd2*r - 192*D1**2*fd*gd2*s**2 + 192*D1**2*fd*gd2*s - 96*D1**2*fdd*g2*r**2 - 192*D1**2*fdd*g2*r*s - 96*D1**2*fdd*g2*s**2 - 16*D1*Dd*K*f**2*r**2 - 32*D1*Dd*K*f**2*r*s + 24*D1*Dd*K*f**2*r - 16*D1*Dd*K*f**2*s**2 + 24*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r**2 + 160*D1*Dd*K*f*fd*r*s - 100*D1*Dd*K*f*fd*r + 80*D1*Dd*K*f*fd*s**2 - 100*D1*Dd*K*f*fd*s + 30*D1*Dd*K*f*fd + 40*D1*Dd*f**3*r**2 + 80*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 30*D1*Dd*f**3 + 144*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 216*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 216*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 960*D1*Dd*f*fd*r**2 - 1920*D1*Dd*f*fd*r*s + 1200*D1*Dd*f*fd*r - 960*D1*Dd*f*fd*s**2 + 1200*D1*Dd*f*fd*s - 360*D1*Dd*f*fd + 264*D1*Dd*f*g2*r**2 + 528*D1*Dd*f*g2*r*s - 396*D1*Dd*f*g2*r + 264*D1*Dd*f*g2*s**2 - 396*D1*Dd*f*g2*s + 198*D1*Dd*f*g2 - 768*D1*Dd*f*gd2*r**2 - 1536*D1*Dd*f*gd2*r*s + 1344*D1*Dd*f*gd2*r - 768*D1*Dd*f*gd2*s**2 + 1344*D1*Dd*f*gd2*s - 576*D1*Dd*f*gd2 - 768*D1*Dd*fd*g2*r**2 - 1536*D1*Dd*fd*g2*r*s + 576*D1*Dd*fd*g2*r - 768*D1*Dd*fd*g2*s**2 + 576*D1*Dd*fd*g2*s + 20*D1*Ddd*K*f**2*r**2 + 40*D1*Ddd*K*f**2*r*s - 30*D1*Ddd*K*f**2*r + 20*D1*Ddd*K*f**2*s**2 - 30*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 240*D1*Ddd*f**2*r**2 - 480*D1*Ddd*f**2*r*s + 360*D1*Ddd*f**2*r - 240*D1*Ddd*f**2*s**2 + 360*D1*Ddd*f**2*s - 180*D1*Ddd*f**2 - 384*D1*Ddd*f*g2*r**2 - 768*D1*Ddd*f*g2*r*s + 576*D1*Ddd*f*g2*r - 384*D1*Ddd*f*g2*s**2 + 576*D1*Ddd*f*g2*s - 288*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(46*f**2*(r + s - 1) - 100*f*fd*(2*r + 2*s - 1) - f*(33*K - 13)*(r + s - 1) + 48*fd*(2*K - 1)*(r + s)) - 4*Dd*f*(-24*K + 25*f + 12)*(4*r + 4*s - 3))*(r + s - 1) + 60*Dd**2*K*f**2*r**2 + 120*Dd**2*K*f**2*r*s - 90*Dd**2*K*f**2*r + 60*Dd**2*K*f**2*s**2 - 90*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 720*Dd**2*f**2*r**2 - 1440*Dd**2*f**2*r*s + 1080*Dd**2*f**2*r - 720*Dd**2*f**2*s**2 + 1080*Dd**2*f**2*s - 360*Dd**2*f**2 - 1152*Dd**2*f*g2*r**2 - 2304*Dd**2*f*g2*r*s + 1728*Dd**2*f*g2*r - 1152*Dd**2*f*g2*s**2 + 1728*Dd**2*f*g2*s - 576*Dd**2*f*g2))/(693*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**4*st**2*(22*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) + 2*D1*bd1*(D1*(-f**3*(185*r**2 + r*(370*s - 202) + 185*s**2 - 202*s + 101) + f**2*(50*fd*(21*r**2 + r*(42*s - 29) + 21*s**2 - 29*s + 8) - 11*r**2*(C + 7) - 22*r*(s*(C + 7) - 8) - 11*s**2*(C + 7) + 176*s - 88) + 11*f*(4*fd*(r + s - 1)*(r*(C + 5) + s*(C + 5) - 3) - (r + s)*(-9*g2*(r + s) + 2*gd2*(r + s - 1))) - 22*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(4*r + 4*s - 3)*(25*f**2*(7*r + 7*s - 4) + 11*f*(r*(C + 5) + s*(C + 5) - 6) - 11*g2*(r + s))) - 11*b1**2*(K - 1)*(D1**2*(9*fd - fdd)*(r + s - 1)**2 + D1*(Dd*(9*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(11*D1**2*bdd1*f*(K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*D1**2*(f**2*(fd*(555*r**2 + 2*r*(555*s - 454) + 555*s**2 - 908*s + 454) - 25*fdd*(21*r**2 + r*(42*s - 34) + 21*s**2 - 34*s + 17)) - f*(50*fd**2*(21*r**2 + r*(42*s - 34) + 21*s**2 - 34*s + 13) - 22*fd*(C*(r + s - 1)**2 + 7*r**2 + 2*r*(7*s - 3) + 7*s**2 - 6*s + 3) + 22*fdd*(C*(r + s - 1)**2 + 5*r**2 + 2*r*(5*s - 2) + 5*s**2 - 4*s + 2) + 11*(9*gd2 - gdd2)*(r + s - 1)**2) + (-11*r - 11*s + 11)*(2*fd**2*(C*(r + s - 1) + 5*r + 5*s + 1) + fd*(9*g2 - 2*gd2)*(r + s - 1) - fdd*g2*(r + s - 1))) - 11*D1*bd1*(K - 1)*(D1*(9*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 2*D1*(Dd*(185*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f**2*(11*C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 50*fd*(84*r**2 + 168*r*s - 131*r + 84*s**2 - 131*s + 51) + 308*r**2 + 616*r*s - 462*r + 308*s**2 - 462*s + 231) - 11*f*(4*fd*(4*r + 4*s - 3)*(C*(r + s - 1) + 5*r + 5*s - 2) + 9*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 2*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 22*fd*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - Ddd*f*(175*f**2 + f*(11*C + 55) - 11*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f*(175*f**2 + f*(11*C + 55) - 11*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*f*(D1**2*bdd1*(25*f**2*(7*r**2 + 2*r*(7*s - 4) + 7*s**2 - 8*s + 4) + 11*f*(r**2*(C + 5) + 2*r*(s*(C + 5) - 6) + s**2*(C + 5) - 12*s + 6) - 11*g2*(r + s)**2) - 2*D1**2*(f*(28*fd - 25*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 50*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 2*D1*f*(28*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 50*Dd*fd*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 25*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 300*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(462*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k1**4*(690*C*D1**2*f**2*fd*r**2 + 1380*C*D1**2*f**2*fd*r*s - 920*C*D1**2*f**2*fd*r + 690*C*D1**2*f**2*fd*s**2 - 920*C*D1**2*f**2*fd*s + 460*C*D1**2*f**2*fd - 840*C*D1**2*f**2*fdd*r**2 - 1680*C*D1**2*f**2*fdd*r*s + 1120*C*D1**2*f**2*fdd*r - 840*C*D1**2*f**2*fdd*s**2 + 1120*C*D1**2*f**2*fdd*s - 560*C*D1**2*f**2*fdd - 1680*C*D1**2*f*fd**2*r**2 - 3360*C*D1**2*f*fd**2*r*s + 2240*C*D1**2*f*fd**2*r - 1680*C*D1**2*f*fd**2*s**2 + 2240*C*D1**2*f*fd**2*s - 560*C*D1**2*f*fd**2 + 920*C*D1*Dd*f**3*r**2 + 1840*C*D1*Dd*f**3*r*s - 1380*C*D1*Dd*f**3*r + 920*C*D1*Dd*f**3*s**2 - 1380*C*D1*Dd*f**3*s + 690*C*D1*Dd*f**3 - 6720*C*D1*Dd*f**2*fd*r**2 - 13440*C*D1*Dd*f**2*fd*r*s + 9520*C*D1*Dd*f**2*fd*r - 6720*C*D1*Dd*f**2*fd*s**2 + 9520*C*D1*Dd*f**2*fd*s - 3360*C*D1*Dd*f**2*fd - 1120*C*D1*Ddd*f**3*r**2 - 2240*C*D1*Ddd*f**3*r*s + 1680*C*D1*Ddd*f**3*r - 1120*C*D1*Ddd*f**3*s**2 + 1680*C*D1*Ddd*f**3*s - 840*C*D1*Ddd*f**3 - 3360*C*Dd**2*f**3*r**2 - 6720*C*Dd**2*f**3*r*s + 5040*C*Dd**2*f**3*r - 3360*C*Dd**2*f**3*s**2 + 5040*C*Dd**2*f**3*s - 1680*C*Dd**2*f**3 - 165*D1**2*K*bdd1*f**2*r**2 - 330*D1**2*K*bdd1*f**2*r*s + 330*D1**2*K*bdd1*f**2*r - 165*D1**2*K*bdd1*f**2*s**2 + 330*D1**2*K*bdd1*f**2*s - 165*D1**2*K*bdd1*f**2 + 264*D1**2*b2*f*fd*r**2 + 528*D1**2*b2*f*fd*r*s - 264*D1**2*b2*f*fd*r + 264*D1**2*b2*f*fd*s**2 - 264*D1**2*b2*f*fd*s + 132*D1**2*b2*f*fd - 330*D1**2*b2*f*fdd*r**2 - 660*D1**2*b2*f*fdd*r*s + 330*D1**2*b2*f*fdd*r - 330*D1**2*b2*f*fdd*s**2 + 330*D1**2*b2*f*fdd*s - 165*D1**2*b2*f*fdd - 330*D1**2*b2*fd**2*r**2 - 660*D1**2*b2*fd**2*r*s + 330*D1**2*b2*fd**2*r - 330*D1**2*b2*fd**2*s**2 + 330*D1**2*b2*fd**2*s + 132*D1**2*bd1**2*(r + s - 1)*(5*f**2*(3*r + 3*s - 2) + 6*f*(C*r + C*s + r + s - 2) - 7*g2*(r + s)) + 132*D1**2*bd2*f**2*r**2 + 264*D1**2*bd2*f**2*r*s - 264*D1**2*bd2*f**2*r + 132*D1**2*bd2*f**2*s**2 - 264*D1**2*bd2*f**2*s + 132*D1**2*bd2*f**2 - 660*D1**2*bd2*f*fd*r**2 - 1320*D1**2*bd2*f*fd*r*s + 990*D1**2*bd2*f*fd*r - 660*D1**2*bd2*f*fd*s**2 + 990*D1**2*bd2*f*fd*s - 330*D1**2*bd2*f*fd + 660*D1**2*bdd1*f**2*r**2 + 1320*D1**2*bdd1*f**2*r*s - 1320*D1**2*bdd1*f**2*r + 660*D1**2*bdd1*f**2*s**2 - 1320*D1**2*bdd1*f**2*s + 660*D1**2*bdd1*f**2 - 165*D1**2*bdd2*f**2*r**2 - 330*D1**2*bdd2*f**2*r*s + 330*D1**2*bdd2*f**2*r - 165*D1**2*bdd2*f**2*s**2 + 330*D1**2*bdd2*f**2*s - 165*D1**2*bdd2*f**2 - 345*D1**2*f**2*fd*r**2 - 690*D1**2*f**2*fd*r*s + 460*D1**2*f**2*fd*r - 345*D1**2*f**2*fd*s**2 + 460*D1**2*f**2*fd*s - 230*D1**2*f**2*fd + 420*D1**2*f**2*fdd*r**2 + 840*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd*s + 280*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r**2 - 528*D1**2*f**2*gd2*r*s + 528*D1**2*f**2*gd2*r - 264*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s - 264*D1**2*f**2*gd2 + 330*D1**2*f**2*gdd2*r**2 + 660*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*r + 330*D1**2*f**2*gdd2*s**2 - 660*D1**2*f**2*gdd2*s + 330*D1**2*f**2*gdd2 + 840*D1**2*f*fd**2*r**2 + 1680*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 1120*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*r**2 + 2640*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 1320*D1**2*f*fd*gd2*s**2 - 1980*D1**2*f*fd*gd2*s + 660*D1**2*f*fd*gd2 + 660*D1**2*f*fdd*g2*r**2 + 1320*D1**2*f*fdd*g2*r*s - 660*D1**2*f*fdd*g2*r + 660*D1**2*f*fdd*g2*s**2 - 660*D1**2*f*fdd*g2*s + 330*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*r**2 + 1320*D1**2*fd**2*g2*r*s - 660*D1**2*fd**2*g2*r + 660*D1**2*fd**2*g2*s**2 - 660*D1**2*fd**2*g2*s + 528*D1*Dd*b2*f**2*r**2 + 1056*D1*Dd*b2*f**2*r*s - 792*D1*Dd*b2*f**2*r + 528*D1*Dd*b2*f**2*s**2 - 792*D1*Dd*b2*f**2*s + 396*D1*Dd*b2*f**2 - 2640*D1*Dd*b2*f*fd*r**2 - 5280*D1*Dd*b2*f*fd*r*s + 3300*D1*Dd*b2*f*fd*r - 2640*D1*Dd*b2*f*fd*s**2 + 3300*D1*Dd*b2*f*fd*s - 990*D1*Dd*b2*f*fd - 1320*D1*Dd*bd2*f**2*r**2 - 2640*D1*Dd*bd2*f**2*r*s + 2310*D1*Dd*bd2*f**2*r - 1320*D1*Dd*bd2*f**2*s**2 + 2310*D1*Dd*bd2*f**2*s - 990*D1*Dd*bd2*f**2 - 460*D1*Dd*f**3*r**2 - 920*D1*Dd*f**3*r*s + 690*D1*Dd*f**3*r - 460*D1*Dd*f**3*s**2 + 690*D1*Dd*f**3*s - 345*D1*Dd*f**3 + 3360*D1*Dd*f**2*fd*r**2 + 6720*D1*Dd*f**2*fd*r*s - 4760*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 4760*D1*Dd*f**2*fd*s + 1680*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r**2 - 2112*D1*Dd*f**2*g2*r*s + 1584*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 792*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*r**2 + 5280*D1*Dd*f**2*gd2*r*s - 4620*D1*Dd*f**2*gd2*r + 2640*D1*Dd*f**2*gd2*s**2 - 4620*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 5280*D1*Dd*f*fd*g2*r**2 + 10560*D1*Dd*f*fd*g2*r*s - 6600*D1*Dd*f*fd*g2*r + 5280*D1*Dd*f*fd*g2*s**2 - 6600*D1*Dd*f*fd*g2*s + 1980*D1*Dd*f*fd*g2 - 660*D1*Ddd*b2*f**2*r**2 - 1320*D1*Ddd*b2*f**2*r*s + 990*D1*Ddd*b2*f**2*r - 660*D1*Ddd*b2*f**2*s**2 + 990*D1*Ddd*b2*f**2*s - 495*D1*Ddd*b2*f**2 + 560*D1*Ddd*f**3*r**2 + 1120*D1*Ddd*f**3*r*s - 840*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 840*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*g2*r**2 + 2640*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 1320*D1*Ddd*f**2*g2*s**2 - 1980*D1*Ddd*f**2*g2*s + 990*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(K - 4)*(r + s - 1)*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)) - 1980*Dd**2*b2*f**2*r**2 - 3960*Dd**2*b2*f**2*r*s + 2970*Dd**2*b2*f**2*r - 1980*Dd**2*b2*f**2*s**2 + 2970*Dd**2*b2*f**2*s - 990*Dd**2*b2*f**2 + 1680*Dd**2*f**3*r**2 + 3360*Dd**2*f**3*r*s - 2520*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 2520*Dd**2*f**3*s + 840*Dd**2*f**3 + 3960*Dd**2*f**2*g2*r**2 + 7920*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 3960*Dd**2*f**2*g2*s**2 - 5940*Dd**2*f**2*g2*s + 1980*Dd**2*f**2*g2 - 231*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1**2*(-7*D1**2*bdd1*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*D1**2*(10*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - fd*(5*C*(r + s - 1)**2 + 8*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 5*r**2 + 10*r*(s + 1) + 5*s**2 + 10*s - 5) + 2*fdd*(3*C*(r + s - 1)**2 + 5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 3*r**2 + 6*r*(s + 1) + 3*s**2 + 6*s - 3) + (14*gd2 - 7*gdd2)*(r + s - 1)**2) + 14*D1*bd1*(K - 1)*(D1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 2*D1*(Dd*(12*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*f*(C*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 4*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + 4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r + 4*s - 3)*(C*(r + s - 1) + r + s + 1) - 14*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 14*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*(15*f**2 + f*(6*C + 6) - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*(15*f**2 + f*(6*C + 6) - 7*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(14*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*(5*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 6*f*(C*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*r**2 + 4*r*s - 6*r + 2*s**2 - 6*s + 3) - 7*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*D1*bd1*(D1*(4*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 5*f*(C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 2*r**2 + 4*r*s - 6*r + 2*s**2 - 6*s + 3) - 12*fd*(r + s - 1)*(C*(2*r + 2*s - 1) + 2*r + 2*s + 1) - 14*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 14*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 2*Dd*(4*r + 4*s - 3)*(5*f**2*(6*r + 6*s - 5) + 6*f*(C*(2*r + 2*s - 1) + 2*r + 2*s - 3) - 7*g2*(2*r + 2*s - 1))) + (K - 4)*(D1**2*(f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(693*d**2*k3**4) + 5*D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**4*st**6*(156*C*D1**2*f**2*fd*r**2 + 312*C*D1**2*f**2*fd*r*s - 208*C*D1**2*f**2*fd*r + 156*C*D1**2*f**2*fd*s**2 - 208*C*D1**2*f**2*fd*s + 104*C*D1**2*f**2*fd - 78*C*D1**2*f**2*fdd*r**2 - 156*C*D1**2*f**2*fdd*r*s + 104*C*D1**2*f**2*fdd*r - 78*C*D1**2*f**2*fdd*s**2 + 104*C*D1**2*f**2*fdd*s - 52*C*D1**2*f**2*fdd - 156*C*D1**2*f*fd**2*r**2 - 312*C*D1**2*f*fd**2*r*s + 208*C*D1**2*f*fd**2*r - 156*C*D1**2*f*fd**2*s**2 + 208*C*D1**2*f*fd**2*s - 52*C*D1**2*f*fd**2 + 208*C*D1*Dd*f**3*r**2 + 416*C*D1*Dd*f**3*r*s - 312*C*D1*Dd*f**3*r + 208*C*D1*Dd*f**3*s**2 - 312*C*D1*Dd*f**3*s + 156*C*D1*Dd*f**3 - 624*C*D1*Dd*f**2*fd*r**2 - 1248*C*D1*Dd*f**2*fd*r*s + 884*C*D1*Dd*f**2*fd*r - 624*C*D1*Dd*f**2*fd*s**2 + 884*C*D1*Dd*f**2*fd*s - 312*C*D1*Dd*f**2*fd - 104*C*D1*Ddd*f**3*r**2 - 208*C*D1*Ddd*f**3*r*s + 156*C*D1*Ddd*f**3*r - 104*C*D1*Ddd*f**3*s**2 + 156*C*D1*Ddd*f**3*s - 78*C*D1*Ddd*f**3 - 312*C*Dd**2*f**3*r**2 - 624*C*Dd**2*f**3*r*s + 468*C*Dd**2*f**3*r - 312*C*Dd**2*f**3*s**2 + 468*C*Dd**2*f**3*s - 156*C*Dd**2*f**3 + 1716*D1**2*K*b1*f*fd*r**2 + 3432*D1**2*K*b1*f*fd*r*s - 1716*D1**2*K*b1*f*fd*r + 1716*D1**2*K*b1*f*fd*s**2 - 1716*D1**2*K*b1*f*fd*s + 858*D1**2*K*b1*f*fd - 858*D1**2*K*b1*f*fdd*r**2 - 1716*D1**2*K*b1*f*fdd*r*s + 858*D1**2*K*b1*f*fdd*r - 858*D1**2*K*b1*f*fdd*s**2 + 858*D1**2*K*b1*f*fdd*s - 429*D1**2*K*b1*f*fdd - 858*D1**2*K*b1*fd**2*r**2 - 1716*D1**2*K*b1*fd**2*r*s + 858*D1**2*K*b1*fd**2*r - 858*D1**2*K*b1*fd**2*s**2 + 858*D1**2*K*b1*fd**2*s - 1716*D1**2*b1*f*fd*r**2 - 3432*D1**2*b1*f*fd*r*s + 1716*D1**2*b1*f*fd*r - 1716*D1**2*b1*f*fd*s**2 + 1716*D1**2*b1*f*fd*s - 858*D1**2*b1*f*fd + 858*D1**2*b1*f*fdd*r**2 + 1716*D1**2*b1*f*fdd*r*s - 858*D1**2*b1*f*fdd*r + 858*D1**2*b1*f*fdd*s**2 - 858*D1**2*b1*f*fdd*s + 429*D1**2*b1*f*fdd + 858*D1**2*b1*fd**2*r**2 + 1716*D1**2*b1*fd**2*r*s - 858*D1**2*b1*fd**2*r + 858*D1**2*b1*fd**2*s**2 - 858*D1**2*b1*fd**2*s - 429*D1**2*bdd1*f**2*(K - 1)*(r + s - 1)**2 - 672*D1**2*f**3*fd*r**2 - 1344*D1**2*f**3*fd*r*s + 1008*D1**2*f**3*fd*r - 672*D1**2*f**3*fd*s**2 + 1008*D1**2*f**3*fd*s - 504*D1**2*f**3*fd + 336*D1**2*f**3*fdd*r**2 + 672*D1**2*f**3*fdd*r*s - 504*D1**2*f**3*fdd*r + 336*D1**2*f**3*fdd*s**2 - 504*D1**2*f**3*fdd*s + 252*D1**2*f**3*fdd + 1008*D1**2*f**2*fd**2*r**2 + 2016*D1**2*f**2*fd**2*r*s - 1512*D1**2*f**2*fd**2*r + 1008*D1**2*f**2*fd**2*s**2 - 1512*D1**2*f**2*fd**2*s + 504*D1**2*f**2*fd**2 - 156*D1**2*f**2*fd*r**2 - 312*D1**2*f**2*fd*r*s + 208*D1**2*f**2*fd*r - 156*D1**2*f**2*fd*s**2 + 208*D1**2*f**2*fd*s - 104*D1**2*f**2*fd + 78*D1**2*f**2*fdd*r**2 + 156*D1**2*f**2*fdd*r*s - 104*D1**2*f**2*fdd*r + 78*D1**2*f**2*fdd*s**2 - 104*D1**2*f**2*fdd*s + 52*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r**2 - 3432*D1**2*f**2*gd2*r*s + 3432*D1**2*f**2*gd2*r - 1716*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s - 1716*D1**2*f**2*gd2 + 858*D1**2*f**2*gdd2*r**2 + 1716*D1**2*f**2*gdd2*r*s - 1716*D1**2*f**2*gdd2*r + 858*D1**2*f**2*gdd2*s**2 - 1716*D1**2*f**2*gdd2*s + 858*D1**2*f**2*gdd2 + 156*D1**2*f*fd**2*r**2 + 312*D1**2*f*fd**2*r*s - 208*D1**2*f*fd**2*r + 156*D1**2*f*fd**2*s**2 - 208*D1**2*f*fd**2*s + 52*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r**2 + 6864*D1**2*f*fd*gd2*r*s - 5148*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 5148*D1**2*f*fd*gd2*s + 1716*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r**2 + 3432*D1**2*f*fdd*g2*r*s - 1716*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r**2 + 3432*D1**2*fd**2*g2*r*s - 1716*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 3432*D1*Dd*K*b1*f**2*r**2 + 6864*D1*Dd*K*b1*f**2*r*s - 5148*D1*Dd*K*b1*f**2*r + 3432*D1*Dd*K*b1*f**2*s**2 - 5148*D1*Dd*K*b1*f**2*s + 2574*D1*Dd*K*b1*f**2 - 6864*D1*Dd*K*b1*f*fd*r**2 - 13728*D1*Dd*K*b1*f*fd*r*s + 8580*D1*Dd*K*b1*f*fd*r - 6864*D1*Dd*K*b1*f*fd*s**2 + 8580*D1*Dd*K*b1*f*fd*s - 2574*D1*Dd*K*b1*f*fd - 3432*D1*Dd*b1*f**2*r**2 - 6864*D1*Dd*b1*f**2*r*s + 5148*D1*Dd*b1*f**2*r - 3432*D1*Dd*b1*f**2*s**2 + 5148*D1*Dd*b1*f**2*s - 2574*D1*Dd*b1*f**2 + 6864*D1*Dd*b1*f*fd*r**2 + 13728*D1*Dd*b1*f*fd*r*s - 8580*D1*Dd*b1*f*fd*r + 6864*D1*Dd*b1*f*fd*s**2 - 8580*D1*Dd*b1*f*fd*s + 2574*D1*Dd*b1*f*fd - 672*D1*Dd*f**4*r**2 - 1344*D1*Dd*f**4*r*s + 1008*D1*Dd*f**4*r - 672*D1*Dd*f**4*s**2 + 1008*D1*Dd*f**4*s - 504*D1*Dd*f**4 + 2688*D1*Dd*f**3*fd*r**2 + 5376*D1*Dd*f**3*fd*r*s - 4032*D1*Dd*f**3*fd*r + 2688*D1*Dd*f**3*fd*s**2 - 4032*D1*Dd*f**3*fd*s + 1512*D1*Dd*f**3*fd - 208*D1*Dd*f**3*r**2 - 416*D1*Dd*f**3*r*s + 312*D1*Dd*f**3*r - 208*D1*Dd*f**3*s**2 + 312*D1*Dd*f**3*s - 156*D1*Dd*f**3 + 624*D1*Dd*f**2*fd*r**2 + 1248*D1*Dd*f**2*fd*r*s - 884*D1*Dd*f**2*fd*r + 624*D1*Dd*f**2*fd*s**2 - 884*D1*Dd*f**2*fd*s + 312*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r**2 - 13728*D1*Dd*f**2*g2*r*s + 10296*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 10296*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r**2 + 13728*D1*Dd*f**2*gd2*r*s - 12012*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 12012*D1*Dd*f**2*gd2*s + 5148*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r**2 + 27456*D1*Dd*f*fd*g2*r*s - 17160*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 17160*D1*Dd*f*fd*g2*s + 5148*D1*Dd*f*fd*g2 - 1716*D1*Ddd*K*b1*f**2*r**2 - 3432*D1*Ddd*K*b1*f**2*r*s + 2574*D1*Ddd*K*b1*f**2*r - 1716*D1*Ddd*K*b1*f**2*s**2 + 2574*D1*Ddd*K*b1*f**2*s - 1287*D1*Ddd*K*b1*f**2 + 1716*D1*Ddd*b1*f**2*r**2 + 3432*D1*Ddd*b1*f**2*r*s - 2574*D1*Ddd*b1*f**2*r + 1716*D1*Ddd*b1*f**2*s**2 - 2574*D1*Ddd*b1*f**2*s + 1287*D1*Ddd*b1*f**2 + 336*D1*Ddd*f**4*r**2 + 672*D1*Ddd*f**4*r*s - 504*D1*Ddd*f**4*r + 336*D1*Ddd*f**4*s**2 - 504*D1*Ddd*f**4*s + 252*D1*Ddd*f**4 + 104*D1*Ddd*f**3*r**2 + 208*D1*Ddd*f**3*r*s - 156*D1*Ddd*f**3*r + 104*D1*Ddd*f**3*s**2 - 156*D1*Ddd*f**3*s + 78*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r**2 + 6864*D1*Ddd*f**2*g2*r*s - 5148*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 5148*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 5148*Dd**2*K*b1*f**2*r**2 - 10296*Dd**2*K*b1*f**2*r*s + 7722*Dd**2*K*b1*f**2*r - 5148*Dd**2*K*b1*f**2*s**2 + 7722*Dd**2*K*b1*f**2*s - 2574*Dd**2*K*b1*f**2 + 5148*Dd**2*b1*f**2*r**2 + 10296*Dd**2*b1*f**2*r*s - 7722*Dd**2*b1*f**2*r + 5148*Dd**2*b1*f**2*s**2 - 7722*Dd**2*b1*f**2*s + 2574*Dd**2*b1*f**2 + 1008*Dd**2*f**4*r**2 + 2016*Dd**2*f**4*r*s - 1512*Dd**2*f**4*r + 1008*Dd**2*f**4*s**2 - 1512*Dd**2*f**4*s + 504*Dd**2*f**4 + 312*Dd**2*f**3*r**2 + 624*Dd**2*f**3*r*s - 468*Dd**2*f**3*r + 312*Dd**2*f**3*s**2 - 468*Dd**2*f**3*s + 156*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r**2 + 20592*Dd**2*f**2*g2*r*s - 15444*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 15444*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2)/(18018*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**4*st**4*(-66*D1**2*bd1**2*f*(K - 1)*(r + s - 1)**2 + 3*D1*bd1*(D1*(40*f**3*(r + s - 1) + f**2*(-40*fd*(3*r + 3*s - 2) + (33 - 55*K)*(r + s - 1)) - 44*f*(g2 - gd2)*(r + s - 1) + 44*fd*g2*(r + s)) - 4*Dd*f*(10*f**2 - 11*g2)*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-110*D1**2*K*f*fd*r**2 - 220*D1**2*K*f*fd*r*s + 110*D1**2*K*f*fd*r - 110*D1**2*K*f*fd*s**2 + 110*D1**2*K*f*fd*s - 55*D1**2*K*f*fd - 22*D1**2*bdd1*f*(K - 1)*(r + s - 1)**2 + 120*D1**2*f**2*fd*r**2 + 240*D1**2*f**2*fd*r*s - 160*D1**2*f**2*fd*r + 120*D1**2*f**2*fd*s**2 - 160*D1**2*f**2*fd*s + 80*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r**2 - 120*D1**2*f**2*fdd*r*s + 80*D1**2*f**2*fdd*r - 60*D1**2*f**2*fdd*s**2 + 80*D1**2*f**2*fdd*s - 40*D1**2*f**2*fdd - 120*D1**2*f*fd**2*r**2 - 240*D1**2*f*fd**2*r*s + 160*D1**2*f*fd**2*r - 120*D1**2*f*fd**2*s**2 + 160*D1**2*f*fd**2*s - 40*D1**2*f*fd**2 + 66*D1**2*f*fd*r**2 + 132*D1**2*f*fd*r*s - 66*D1**2*f*fd*r + 66*D1**2*f*fd*s**2 - 66*D1**2*f*fd*s + 33*D1**2*f*fd - 44*D1**2*f*gd2*r**2 - 88*D1**2*f*gd2*r*s + 88*D1**2*f*gd2*r - 44*D1**2*f*gd2*s**2 + 88*D1**2*f*gd2*s - 44*D1**2*f*gd2 + 22*D1**2*f*gdd2*r**2 + 44*D1**2*f*gdd2*r*s - 44*D1**2*f*gdd2*r + 22*D1**2*f*gdd2*s**2 - 44*D1**2*f*gdd2*s + 22*D1**2*f*gdd2 - 44*D1**2*fd*g2*r**2 - 88*D1**2*fd*g2*r*s - 44*D1**2*fd*g2*s**2 + 44*D1**2*fd*gd2*r**2 + 88*D1**2*fd*gd2*r*s - 44*D1**2*fd*gd2*r + 44*D1**2*fd*gd2*s**2 - 44*D1**2*fd*gd2*s + 22*D1**2*fdd*g2*r**2 + 44*D1**2*fdd*g2*r*s + 22*D1**2*fdd*g2*s**2 - 220*D1*Dd*K*f**2*r**2 - 440*D1*Dd*K*f**2*r*s + 330*D1*Dd*K*f**2*r - 220*D1*Dd*K*f**2*s**2 + 330*D1*Dd*K*f**2*s - 165*D1*Dd*K*f**2 + 160*D1*Dd*f**3*r**2 + 320*D1*Dd*f**3*r*s - 240*D1*Dd*f**3*r + 160*D1*Dd*f**3*s**2 - 240*D1*Dd*f**3*s + 120*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r**2 - 960*D1*Dd*f**2*fd*r*s + 680*D1*Dd*f**2*fd*r - 480*D1*Dd*f**2*fd*s**2 + 680*D1*Dd*f**2*fd*s - 240*D1*Dd*f**2*fd + 132*D1*Dd*f**2*r**2 + 264*D1*Dd*f**2*r*s - 198*D1*Dd*f**2*r + 132*D1*Dd*f**2*s**2 - 198*D1*Dd*f**2*s + 99*D1*Dd*f**2 - 176*D1*Dd*f*g2*r**2 - 352*D1*Dd*f*g2*r*s + 264*D1*Dd*f*g2*r - 176*D1*Dd*f*g2*s**2 + 264*D1*Dd*f*g2*s - 132*D1*Dd*f*g2 + 176*D1*Dd*f*gd2*r**2 + 352*D1*Dd*f*gd2*r*s - 308*D1*Dd*f*gd2*r + 176*D1*Dd*f*gd2*s**2 - 308*D1*Dd*f*gd2*s + 132*D1*Dd*f*gd2 + 176*D1*Dd*fd*g2*r**2 + 352*D1*Dd*fd*g2*r*s - 132*D1*Dd*fd*g2*r + 176*D1*Dd*fd*g2*s**2 - 132*D1*Dd*fd*g2*s - 80*D1*Ddd*f**3*r**2 - 160*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 80*D1*Ddd*f**3*s**2 + 120*D1*Ddd*f**3*s - 60*D1*Ddd*f**3 + 88*D1*Ddd*f*g2*r**2 + 176*D1*Ddd*f*g2*r*s - 132*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2*s**2 - 132*D1*Ddd*f*g2*s + 66*D1*Ddd*f*g2 + 44*D1*bd1*(K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 240*Dd**2*f**3*r**2 - 480*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 240*Dd**2*f**3*s**2 + 360*Dd**2*f**3*s - 120*Dd**2*f**3 + 264*Dd**2*f*g2*r**2 + 528*Dd**2*f*g2*r*s - 396*Dd**2*f*g2*r + 264*Dd**2*f*g2*s**2 - 396*Dd**2*f*g2*s + 132*Dd**2*f*g2) + f*(-6*D1**2*bdd1*(10*f**2 - 11*g2)*(r + s - 1)**2 + 5*D1**2*(3*f**2*fd*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*fd*(32*C - 24)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*fdd*(16*C - 12)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 66*f*gd2*(r + s - 1)**2 + 2*fd*(fd*(16*C - 12)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 33*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1))) + 5*D1*f*(Dd*(3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(24 - 32*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(32*C - 24)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Ddd*f*(16*C - 12)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 5*Dd**2*f**2*(96*C - 72)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**4*st**2*(-132*D1**2*bd1**2*f*(-4*K + 5*f + 2)*(r + s - 1)**2 + 132*D1**2*bdd1*f*(f*(4*C + 3*K - 3) - 4*g2)*(r + s - 1)**2 - 12*D1**2*(f**2*(fd*(45*C - 17)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(50*C - 25)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (-77*gd2 + 66*gdd2)*(r + s - 1)**2) + f*(-fd**2*(100*C - 50)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 77*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 132*fd*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 66*fdd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 132*fd**2*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 22*D1*bd1*(D1*(6*f**3*(r + s - 1) + f**2*(43*C + 21*K - 29)*(r + s - 1) - 12*f*fd*(4*C + 3*K - 3)*(2*r + 2*s - 1) - f*(83*g2 - 48*gd2)*(r + s - 1) + 48*fd*g2*(r + s)) - 12*Dd*f*(f*(4*C + 3*K - 3) - 4*g2)*(4*r + 4*s - 3))*(r + s - 1) - 12*D1*f*(Dd*(f**2*(45*C - 17)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-fd*(100*C - 50)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 77*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 132*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 132*fd*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(f*(50*C - 25) - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 72*Dd**2*f**2*(f*(50*C - 25) - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 11*b1**2*(D1**2*(6*f*(9*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(60*fd**2*(r + s - 1) + fd*(83*K - 45)*(r + s) - 12*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(54*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (83*K - 45)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 24*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-4*K + 5*f + 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-4*K + 5*f + 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*(-86*C*D1**2*f*fd*r**2 - 172*C*D1**2*f*fd*r*s + 86*C*D1**2*f*fd*r - 86*C*D1**2*f*fd*s**2 + 86*C*D1**2*f*fd*s - 43*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r**2 + 96*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 48*C*D1**2*f*fdd*s**2 - 48*C*D1**2*f*fdd*s + 24*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r**2 + 96*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 48*C*D1**2*fd**2*s**2 - 48*C*D1**2*fd**2*s - 172*C*D1*Dd*f**2*r**2 - 344*C*D1*Dd*f**2*r*s + 258*C*D1*Dd*f**2*r - 172*C*D1*Dd*f**2*s**2 + 258*C*D1*Dd*f**2*s - 129*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r**2 + 768*C*D1*Dd*f*fd*r*s - 480*C*D1*Dd*f*fd*r + 384*C*D1*Dd*f*fd*s**2 - 480*C*D1*Dd*f*fd*s + 144*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 + 192*C*D1*Ddd*f**2*r*s - 144*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r**2 + 576*C*Dd**2*f**2*r*s - 432*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 144*C*Dd**2*f**2 - 42*D1**2*K*f*fd*r**2 - 84*D1**2*K*f*fd*r*s + 42*D1**2*K*f*fd*r - 42*D1**2*K*f*fd*s**2 + 42*D1**2*K*f*fd*s - 21*D1**2*K*f*fd + 36*D1**2*K*f*fdd*r**2 + 72*D1**2*K*f*fdd*r*s - 36*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r**2 + 72*D1**2*K*fd**2*r*s - 36*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-4*K + 5*f + 2)*(r + s - 1)**2 - 18*D1**2*f**2*fd*r**2 - 36*D1**2*f**2*fd*r*s + 24*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 24*D1**2*f**2*fd*s - 12*D1**2*f**2*fd + 58*D1**2*f*fd*r**2 + 116*D1**2*f*fd*r*s - 58*D1**2*f*fd*r + 58*D1**2*f*fd*s**2 - 58*D1**2*f*fd*s + 29*D1**2*f*fd - 36*D1**2*f*fdd*r**2 - 72*D1**2*f*fdd*r*s + 36*D1**2*f*fdd*r - 36*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 18*D1**2*f*fdd + 83*D1**2*f*gd2*r**2 + 166*D1**2*f*gd2*r*s - 166*D1**2*f*gd2*r + 83*D1**2*f*gd2*s**2 - 166*D1**2*f*gd2*s + 83*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 36*D1**2*fd**2*r**2 - 72*D1**2*fd**2*r*s + 36*D1**2*fd**2*r - 36*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 83*D1**2*fd*g2*r**2 + 166*D1**2*fd*g2*r*s + 83*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 - 84*D1*Dd*K*f**2*r**2 - 168*D1*Dd*K*f**2*r*s + 126*D1*Dd*K*f**2*r - 84*D1*Dd*K*f**2*s**2 + 126*D1*Dd*K*f**2*s - 63*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r**2 + 576*D1*Dd*K*f*fd*r*s - 360*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 360*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd - 24*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 36*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 116*D1*Dd*f**2*r**2 + 232*D1*Dd*f**2*r*s - 174*D1*Dd*f**2*r + 116*D1*Dd*f**2*s**2 - 174*D1*Dd*f**2*s + 87*D1*Dd*f**2 - 288*D1*Dd*f*fd*r**2 - 576*D1*Dd*f*fd*r*s + 360*D1*Dd*f*fd*r - 288*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 108*D1*Dd*f*fd + 332*D1*Dd*f*g2*r**2 + 664*D1*Dd*f*g2*r*s - 498*D1*Dd*f*g2*r + 332*D1*Dd*f*g2*s**2 - 498*D1*Dd*f*g2*s + 249*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 144*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s + 72*D1*Ddd*K*f**2*r**2 + 144*D1*Ddd*K*f**2*r*s - 108*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 108*D1*Ddd*K*f**2*s + 54*D1*Ddd*K*f**2 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + D1*bd1*(D1*(54*f**2*(r + s - 1) - 60*f*fd*(2*r + 2*s - 1) - f*(83*K - 45)*(r + s - 1) + 24*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-4*K + 5*f + 2)*(4*r + 4*s - 3))*(r + s - 1) + 216*Dd**2*K*f**2*r**2 + 432*Dd**2*K*f**2*r*s - 324*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 324*Dd**2*K*f**2*s + 108*Dd**2*K*f**2 - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(462*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**4*(D1*(-72*D1*K*bd1**2*f*(r + s - 1)**2 + 6*bd1*(D1*(f**2*(2*C - K + 1)*(r + s - 1) - f*fd*(20*C - 10)*(2*r + 2*s - 1) - 3*f*(g2 - 8*gd2)*(r + s - 1) + 24*fd*g2*(r + s)) - 2*Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))*(r + s - 1) + f*(-6*D1*bdd1*(f*(10*C - 5) - 12*g2)*(r + s - 1)**2 + D1*(f*(-fd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 12*gd2*(r + s - 1)**2) + 12*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**2*(D1**2*(18*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-36*K*fdd + fd*(9*K + 14))) + D1*(Dd*(-72*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(9*K + 14)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 216*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(3*D1**2*(f*(fd*(2*C - K + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s - 1)**2*(-12*K*bdd1 - 3*gd2 + 12*gdd2)) - (r + s)*(fd**2*(20*C - 10)*(r + s - 1) + 3*fd*(g2*(r + s) - 8*gd2*(r + s - 1)) - 12*fdd*g2*(r + s))) + D1*bd1*(D1*(-72*K*fd*(r + s) + 18*f**2*(r + s - 1) + f*(9*K + 14)*(r + s - 1)) - 72*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + 3*D1*(Dd*(f**2*(2*C - K + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 3*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 24*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 24*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f*(f*(10*C - 5) - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**2*st**4*(-66*D1**2*bd1**2*f*(K - 1)*(r**2 + r*(2*s - 1) + s*(s - 1)) - 6*D1*bd1*(D1*(5*f**3*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 4) - f**2*(r + s - 1)*(5*fd*(15*r + 15*s - 8) - 11*r - 11*s + 11) - 22*f*(r + s)*(-g2*(r + s) + gd2*(r + s - 1)) - 22*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(5*f**2*(5*r + 5*s - 4) + 22*g2*(r + s))*(4*r + 4*s - 3)) + 33*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 3*b1*(-11*D1**2*bdd1*f*(K - 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 150*D1**2*f**2*fd*r**2 - 300*D1**2*f**2*fd*r*s + 220*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 220*D1**2*f**2*fd*s - 110*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 110*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 110*D1**2*f**2*fdd*s + 55*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 220*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 220*D1**2*f*fd**2*s + 70*D1**2*f*fd**2 - 44*D1**2*f*fd*r**2 - 88*D1**2*f*fd*r*s + 44*D1**2*f*fd*r - 44*D1**2*f*fd*s**2 + 44*D1**2*f*fd*s - 22*D1**2*f*fd - 44*D1**2*f*gd2*r**2 - 88*D1**2*f*gd2*r*s + 88*D1**2*f*gd2*r - 44*D1**2*f*gd2*s**2 + 88*D1**2*f*gd2*s - 44*D1**2*f*gd2 + 22*D1**2*f*gdd2*r**2 + 44*D1**2*f*gdd2*r*s - 44*D1**2*f*gdd2*r + 22*D1**2*f*gdd2*s**2 - 44*D1**2*f*gdd2*s + 22*D1**2*f*gdd2 - 44*D1**2*fd*g2*r**2 - 88*D1**2*fd*g2*r*s + 88*D1**2*fd*g2*r - 44*D1**2*fd*g2*s**2 + 88*D1**2*fd*g2*s - 44*D1**2*fd*g2 + 44*D1**2*fd*gd2*r**2 + 88*D1**2*fd*gd2*r*s - 88*D1**2*fd*gd2*r + 44*D1**2*fd*gd2*s**2 - 88*D1**2*fd*gd2*s + 44*D1**2*fd*gd2 + 22*D1**2*fdd*g2*r**2 + 44*D1**2*fdd*g2*r*s - 44*D1**2*fdd*g2*r + 22*D1**2*fdd*g2*s**2 - 44*D1**2*fdd*g2*s + 22*D1**2*fdd*g2 - 200*D1*Dd*f**3*r**2 - 400*D1*Dd*f**3*r*s + 300*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 300*D1*Dd*f**3*s - 150*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 890*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 890*D1*Dd*f**2*fd*s + 330*D1*Dd*f**2*fd - 88*D1*Dd*f**2*r**2 - 176*D1*Dd*f**2*r*s + 132*D1*Dd*f**2*r - 88*D1*Dd*f**2*s**2 + 132*D1*Dd*f**2*s - 66*D1*Dd*f**2 - 176*D1*Dd*f*g2*r**2 - 352*D1*Dd*f*g2*r*s + 264*D1*Dd*f*g2*r - 176*D1*Dd*f*g2*s**2 + 264*D1*Dd*f*g2*s - 132*D1*Dd*f*g2 + 176*D1*Dd*f*gd2*r**2 + 352*D1*Dd*f*gd2*r*s - 308*D1*Dd*f*gd2*r + 176*D1*Dd*f*gd2*s**2 - 308*D1*Dd*f*gd2*s + 132*D1*Dd*f*gd2 + 176*D1*Dd*fd*g2*r**2 + 352*D1*Dd*fd*g2*r*s - 308*D1*Dd*fd*g2*r + 176*D1*Dd*fd*g2*s**2 - 308*D1*Dd*fd*g2*s + 132*D1*Dd*fd*g2 + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 88*D1*Ddd*f*g2*r**2 + 176*D1*Ddd*f*g2*r*s - 132*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2*s**2 - 132*D1*Ddd*f*g2*s + 66*D1*Ddd*f*g2 + 22*D1*bd1*(K - 1)*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 + 264*Dd**2*f*g2*r**2 + 528*Dd**2*f*g2*r*s - 396*Dd**2*f*g2*r + 264*Dd**2*f*g2*s**2 - 396*Dd**2*f*g2*s + 132*Dd**2*f*g2) + f*(3*D1**2*bdd1*(5*f**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 4) + 22*g2*(r + s)**2) - 20*D1**2*(f*(2*fd - fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) - 20*D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 120*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**2*st**2*(2412*C*D1**2*f**2*fd*r**2 + 4824*C*D1**2*f**2*fd*r*s - 3216*C*D1**2*f**2*fd*r + 2412*C*D1**2*f**2*fd*s**2 - 3216*C*D1**2*f**2*fd*s + 1608*C*D1**2*f**2*fd - 1800*C*D1**2*f**2*fdd*r**2 - 3600*C*D1**2*f**2*fdd*r*s + 2400*C*D1**2*f**2*fdd*r - 1800*C*D1**2*f**2*fdd*s**2 + 2400*C*D1**2*f**2*fdd*s - 1200*C*D1**2*f**2*fdd - 3600*C*D1**2*f*fd**2*r**2 - 7200*C*D1**2*f*fd**2*r*s + 4800*C*D1**2*f*fd**2*r - 3600*C*D1**2*f*fd**2*s**2 + 4800*C*D1**2*f*fd**2*s - 1200*C*D1**2*f*fd**2 + 3216*C*D1*Dd*f**3*r**2 + 6432*C*D1*Dd*f**3*r*s - 4824*C*D1*Dd*f**3*r + 3216*C*D1*Dd*f**3*s**2 - 4824*C*D1*Dd*f**3*s + 2412*C*D1*Dd*f**3 - 14400*C*D1*Dd*f**2*fd*r**2 - 28800*C*D1*Dd*f**2*fd*r*s + 20400*C*D1*Dd*f**2*fd*r - 14400*C*D1*Dd*f**2*fd*s**2 + 20400*C*D1*Dd*f**2*fd*s - 7200*C*D1*Dd*f**2*fd - 2400*C*D1*Ddd*f**3*r**2 - 4800*C*D1*Ddd*f**3*r*s + 3600*C*D1*Ddd*f**3*r - 2400*C*D1*Ddd*f**3*s**2 + 3600*C*D1*Ddd*f**3*s - 1800*C*D1*Ddd*f**3 - 7200*C*Dd**2*f**3*r**2 - 14400*C*Dd**2*f**3*r*s + 10800*C*Dd**2*f**3*r - 7200*C*Dd**2*f**3*s**2 + 10800*C*Dd**2*f**3*s - 3600*C*Dd**2*f**3 + 1188*D1**2*b2*f*fd*r**2 + 2376*D1**2*b2*f*fd*r*s - 1188*D1**2*b2*f*fd*r + 1188*D1**2*b2*f*fd*s**2 - 1188*D1**2*b2*f*fd*s + 594*D1**2*b2*f*fd - 792*D1**2*b2*f*fdd*r**2 - 1584*D1**2*b2*f*fdd*r*s + 792*D1**2*b2*f*fdd*r - 792*D1**2*b2*f*fdd*s**2 + 792*D1**2*b2*f*fdd*s - 396*D1**2*b2*f*fdd - 792*D1**2*b2*fd**2*r**2 - 1584*D1**2*b2*fd**2*r*s + 792*D1**2*b2*fd**2*r - 792*D1**2*b2*fd**2*s**2 + 792*D1**2*b2*fd**2*s + 44*D1**2*bd1**2*(r + s - 1)*(6*f**2*(r + s - 2) + f*(r*(C + 6*K + 2) + s*(C + 6*K + 2) - 6) + 7*g2*(r + s)) - 66*D1**2*bdd1*f*(f*(-4*C*s**2 + 6*K*(r + s - 1)**2 + r**2*(1 - 4*C) + r*(-8*C*s + 2*s + 4) + s**2 + 4*s - 2) + 4*g2*(r + s)**2) - 396*D1**2*bdd2*f**2*r**2 - 792*D1**2*bdd2*f**2*r*s + 792*D1**2*bdd2*f**2*r - 396*D1**2*bdd2*f**2*s**2 + 792*D1**2*bdd2*f**2*s - 396*D1**2*bdd2*f**2 - 1008*D1**2*f**2*fd*r**2 - 2016*D1**2*f**2*fd*r*s + 1344*D1**2*f**2*fd*r - 1008*D1**2*f**2*fd*s**2 + 1344*D1**2*f**2*fd*s - 672*D1**2*f**2*fd + 900*D1**2*f**2*fdd*r**2 + 1800*D1**2*f**2*fdd*r*s - 1200*D1**2*f**2*fdd*r + 900*D1**2*f**2*fdd*s**2 - 1200*D1**2*f**2*fdd*s + 600*D1**2*f**2*fdd - 1188*D1**2*f**2*gd2*r**2 - 2376*D1**2*f**2*gd2*r*s + 2376*D1**2*f**2*gd2*r - 1188*D1**2*f**2*gd2*s**2 + 2376*D1**2*f**2*gd2*s - 1188*D1**2*f**2*gd2 + 792*D1**2*f**2*gdd2*r**2 + 1584*D1**2*f**2*gdd2*r*s - 1584*D1**2*f**2*gdd2*r + 792*D1**2*f**2*gdd2*s**2 - 1584*D1**2*f**2*gdd2*s + 792*D1**2*f**2*gdd2 + 1800*D1**2*f*fd**2*r**2 + 3600*D1**2*f*fd**2*r*s - 2400*D1**2*f*fd**2*r + 1800*D1**2*f*fd**2*s**2 - 2400*D1**2*f*fd**2*s + 600*D1**2*f*fd**2 - 2376*D1**2*f*fd*g2*r**2 - 4752*D1**2*f*fd*g2*r*s + 2376*D1**2*f*fd*g2*r - 2376*D1**2*f*fd*g2*s**2 + 2376*D1**2*f*fd*g2*s - 1188*D1**2*f*fd*g2 + 3168*D1**2*f*fd*gd2*r**2 + 6336*D1**2*f*fd*gd2*r*s - 4752*D1**2*f*fd*gd2*r + 3168*D1**2*f*fd*gd2*s**2 - 4752*D1**2*f*fd*gd2*s + 1584*D1**2*f*fd*gd2 + 1584*D1**2*f*fdd*g2*r**2 + 3168*D1**2*f*fdd*g2*r*s - 1584*D1**2*f*fdd*g2*r + 1584*D1**2*f*fdd*g2*s**2 - 1584*D1**2*f*fdd*g2*s + 792*D1**2*f*fdd*g2 + 1584*D1**2*fd**2*g2*r**2 + 3168*D1**2*fd**2*g2*r*s - 1584*D1**2*fd**2*g2*r + 1584*D1**2*fd**2*g2*s**2 - 1584*D1**2*fd**2*g2*s + 2376*D1*Dd*b2*f**2*r**2 + 4752*D1*Dd*b2*f**2*r*s - 3564*D1*Dd*b2*f**2*r + 2376*D1*Dd*b2*f**2*s**2 - 3564*D1*Dd*b2*f**2*s + 1782*D1*Dd*b2*f**2 - 6336*D1*Dd*b2*f*fd*r**2 - 12672*D1*Dd*b2*f*fd*r*s + 7920*D1*Dd*b2*f*fd*r - 6336*D1*Dd*b2*f*fd*s**2 + 7920*D1*Dd*b2*f*fd*s - 2376*D1*Dd*b2*f*fd - 1344*D1*Dd*f**3*r**2 - 2688*D1*Dd*f**3*r*s + 2016*D1*Dd*f**3*r - 1344*D1*Dd*f**3*s**2 + 2016*D1*Dd*f**3*s - 1008*D1*Dd*f**3 + 7200*D1*Dd*f**2*fd*r**2 + 14400*D1*Dd*f**2*fd*r*s - 10200*D1*Dd*f**2*fd*r + 7200*D1*Dd*f**2*fd*s**2 - 10200*D1*Dd*f**2*fd*s + 3600*D1*Dd*f**2*fd - 4752*D1*Dd*f**2*g2*r**2 - 9504*D1*Dd*f**2*g2*r*s + 7128*D1*Dd*f**2*g2*r - 4752*D1*Dd*f**2*g2*s**2 + 7128*D1*Dd*f**2*g2*s - 3564*D1*Dd*f**2*g2 + 6336*D1*Dd*f**2*gd2*r**2 + 12672*D1*Dd*f**2*gd2*r*s - 11088*D1*Dd*f**2*gd2*r + 6336*D1*Dd*f**2*gd2*s**2 - 11088*D1*Dd*f**2*gd2*s + 4752*D1*Dd*f**2*gd2 + 12672*D1*Dd*f*fd*g2*r**2 + 25344*D1*Dd*f*fd*g2*r*s - 15840*D1*Dd*f*fd*g2*r + 12672*D1*Dd*f*fd*g2*s**2 - 15840*D1*Dd*f*fd*g2*s + 4752*D1*Dd*f*fd*g2 - 1584*D1*Ddd*b2*f**2*r**2 - 3168*D1*Ddd*b2*f**2*r*s + 2376*D1*Ddd*b2*f**2*r - 1584*D1*Ddd*b2*f**2*s**2 + 2376*D1*Ddd*b2*f**2*s - 1188*D1*Ddd*b2*f**2 + 1200*D1*Ddd*f**3*r**2 + 2400*D1*Ddd*f**3*r*s - 1800*D1*Ddd*f**3*r + 1200*D1*Ddd*f**3*s**2 - 1800*D1*Ddd*f**3*s + 900*D1*Ddd*f**3 + 3168*D1*Ddd*f**2*g2*r**2 + 6336*D1*Ddd*f**2*g2*r*s - 4752*D1*Ddd*f**2*g2*r + 3168*D1*Ddd*f**2*g2*s**2 - 4752*D1*Ddd*f**2*g2*s + 2376*D1*Ddd*f**2*g2 + 22*D1*bd1*(D1*(3*f**3*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f**2*(-19*C*s**2 + 27*K*(r + s - 1)**2 + r**2*(6 - 19*C) + r*(-38*C*s + 12*s + 16) + 6*s**2 + 16*s - 8) + f*(-12*fd*(r + s - 1)*(-4*C*r - 4*C*s + K*(6*r + 6*s - 3) + r + s + 1) - (r + s)*(-59*g2*(r + s) + 24*gd2*(r + s - 1))) - 24*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 6*Dd*f*(f*(-4*C*r - 4*C*s + 6*K*(r + s - 1) + r + s + 2) + 4*g2*(r + s))*(4*r + 4*s - 3)) + 198*D1*bd2*f*(r + s - 1)*(3*D1*f*(r + s - 1) - 4*D1*fd*(2*r + 2*s - 1) - 4*Dd*f*(4*r + 4*s - 3)) - 4752*Dd**2*b2*f**2*r**2 - 9504*Dd**2*b2*f**2*r*s + 7128*Dd**2*b2*f**2*r - 4752*Dd**2*b2*f**2*s**2 + 7128*Dd**2*b2*f**2*s - 2376*Dd**2*b2*f**2 + 3600*Dd**2*f**3*r**2 + 7200*Dd**2*f**3*r*s - 5400*Dd**2*f**3*r + 3600*Dd**2*f**3*s**2 - 5400*Dd**2*f**3*s + 1800*Dd**2*f**3 + 9504*Dd**2*f**2*g2*r**2 + 19008*Dd**2*f**2*g2*r*s - 14256*Dd**2*f**2*g2*r + 9504*Dd**2*f**2*g2*s**2 - 14256*Dd**2*f**2*g2*s + 4752*Dd**2*f**2*g2 + 77*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 11*b1**2*(-4*C*D1**2*fd*r**2 - 8*C*D1**2*fd*r*s + 8*C*D1**2*fd*r - 4*C*D1**2*fd*s**2 + 8*C*D1**2*fd*s - 4*C*D1**2*fd + 2*C*D1**2*fdd*r**2 + 4*C*D1**2*fdd*r*s - 4*C*D1**2*fdd*r + 2*C*D1**2*fdd*s**2 - 4*C*D1**2*fdd*s + 2*C*D1**2*fdd - 16*C*D1*Dd*f*r**2 - 32*C*D1*Dd*f*r*s + 24*C*D1*Dd*f*r - 16*C*D1*Dd*f*s**2 + 24*C*D1*Dd*f*s - 12*C*D1*Dd*f + 16*C*D1*Dd*fd*r**2 + 32*C*D1*Dd*fd*r*s - 28*C*D1*Dd*fd*r + 16*C*D1*Dd*fd*s**2 - 28*C*D1*Dd*fd*s + 12*C*D1*Dd*fd + 8*C*D1*Ddd*f*r**2 + 16*C*D1*Ddd*f*r*s - 12*C*D1*Ddd*f*r + 8*C*D1*Ddd*f*s**2 - 12*C*D1*Ddd*f*s + 6*C*D1*Ddd*f + 24*C*Dd**2*f*r**2 + 48*C*Dd**2*f*r*s - 36*C*Dd**2*f*r + 24*C*Dd**2*f*s**2 - 36*C*Dd**2*f*s + 12*C*Dd**2*f - 59*D1**2*K*fd*r**2 - 118*D1**2*K*fd*r*s + 118*D1**2*K*fd*r - 59*D1**2*K*fd*s**2 + 118*D1**2*K*fd*s - 59*D1**2*K*fd + 12*D1**2*K*fdd*r**2 + 24*D1**2*K*fdd*r*s - 24*D1**2*K*fdd*r + 12*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 7*D1**2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 48*D1**2*f*fd*r**2 - 96*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 6*D1**2*f*fd + 24*D1**2*f*fdd*r**2 + 48*D1**2*f*fdd*r*s + 24*D1**2*f*fdd*s**2 + 24*D1**2*fd**2*r**2 + 48*D1**2*fd**2*r*s + 24*D1**2*fd**2*s**2 - 24*D1**2*fd**2 - D1**2*fd*r**2 - 2*D1**2*fd*r*s - 74*D1**2*fd*r - D1**2*fd*s**2 - 74*D1**2*fd*s + 37*D1**2*fd + 4*D1**2*fdd*r**2 + 8*D1**2*fdd*r*s + 16*D1**2*fdd*r + 4*D1**2*fdd*s**2 + 16*D1**2*fdd*s - 8*D1**2*fdd - 28*D1**2*gd2*r**2 - 56*D1**2*gd2*r*s + 56*D1**2*gd2*r - 28*D1**2*gd2*s**2 + 56*D1**2*gd2*s - 28*D1**2*gd2 + 14*D1**2*gdd2*r**2 + 28*D1**2*gdd2*r*s - 28*D1**2*gdd2*r + 14*D1**2*gdd2*s**2 - 28*D1**2*gdd2*s + 14*D1**2*gdd2 - 236*D1*Dd*K*f*r**2 - 472*D1*Dd*K*f*r*s + 354*D1*Dd*K*f*r - 236*D1*Dd*K*f*s**2 + 354*D1*Dd*K*f*s - 177*D1*Dd*K*f + 96*D1*Dd*K*fd*r**2 + 192*D1*Dd*K*fd*r*s - 168*D1*Dd*K*fd*r + 96*D1*Dd*K*fd*s**2 - 168*D1*Dd*K*fd*s + 72*D1*Dd*K*fd - 96*D1*Dd*f**2*r**2 - 192*D1*Dd*f**2*r*s + 144*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 144*D1*Dd*f**2*s - 72*D1*Dd*f**2 + 192*D1*Dd*f*fd*r**2 + 384*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r + 192*D1*Dd*f*fd*s**2 - 144*D1*Dd*f*fd*s - 4*D1*Dd*f*r**2 - 8*D1*Dd*f*r*s + 6*D1*Dd*f*r - 4*D1*Dd*f*s**2 + 6*D1*Dd*f*s - 3*D1*Dd*f + 32*D1*Dd*fd*r**2 + 64*D1*Dd*fd*r*s + 40*D1*Dd*fd*r + 32*D1*Dd*fd*s**2 + 40*D1*Dd*fd*s - 48*D1*Dd*fd - 112*D1*Dd*g2*r**2 - 224*D1*Dd*g2*r*s + 168*D1*Dd*g2*r - 112*D1*Dd*g2*s**2 + 168*D1*Dd*g2*s - 84*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 + 224*D1*Dd*gd2*r*s - 196*D1*Dd*gd2*r + 112*D1*Dd*gd2*s**2 - 196*D1*Dd*gd2*s + 84*D1*Dd*gd2 + 48*D1*Ddd*K*f*r**2 + 96*D1*Ddd*K*f*r*s - 72*D1*Ddd*K*f*r + 48*D1*Ddd*K*f*s**2 - 72*D1*Ddd*K*f*s + 36*D1*Ddd*K*f + 48*D1*Ddd*f**2*r**2 + 96*D1*Ddd*f**2*r*s - 72*D1*Ddd*f**2*r + 48*D1*Ddd*f**2*s**2 - 72*D1*Ddd*f**2*s + 36*D1*Ddd*f**2 + 16*D1*Ddd*f*r**2 + 32*D1*Ddd*f*r*s - 24*D1*Ddd*f*r + 16*D1*Ddd*f*s**2 - 24*D1*Ddd*f*s + 12*D1*Ddd*f + 56*D1*Ddd*g2*r**2 + 112*D1*Ddd*g2*r*s - 84*D1*Ddd*g2*r + 56*D1*Ddd*g2*s**2 - 84*D1*Ddd*g2*s + 42*D1*Ddd*g2 + 14*D1*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 144*Dd**2*K*f*r**2 + 288*Dd**2*K*f*r*s - 216*Dd**2*K*f*r + 144*Dd**2*K*f*s**2 - 216*Dd**2*K*f*s + 72*Dd**2*K*f + 144*Dd**2*f**2*r**2 + 288*Dd**2*f**2*r*s - 216*Dd**2*f**2*r + 144*Dd**2*f**2*s**2 - 216*Dd**2*f**2*s + 72*Dd**2*f**2 + 48*Dd**2*f*r**2 + 96*Dd**2*f*r*s - 72*Dd**2*f*r + 48*Dd**2*f*s**2 - 72*Dd**2*f*s + 24*Dd**2*f + 168*Dd**2*g2*r**2 + 336*Dd**2*g2*r*s - 252*Dd**2*g2*r + 168*Dd**2*g2*s**2 - 252*Dd**2*g2*s + 84*Dd**2*g2) - 11*b1*(14*D1**2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2*D1**2*bdd1*(6*f**2*(2*r**2 + r*(4*s - 6) + 2*s**2 - 6*s + 3) + f*(C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 6*K*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*r**2 + 8*r*(s - 2) + 4*s**2 - 16*s + 8) + 7*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) - 2*D1**2*(3*f**2*fd*(9*r**2 + 2*r*(9*s - 7) + 9*s**2 - 14*s + 7) + f*(fd*(-38*C*(r + s - 1)**2 + 27*K*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 12*r**2 + 24*r*s - 40*r + 12*s**2 - 40*s + 20) + 6*fdd*(4*C*(r + s - 1)**2 - 3*K*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - r**2 - 2*r*s + 4*r - s**2 + 4*s - 2) + (59*gd2 - 12*gdd2)*(r + s - 1)**2) + (r + s - 1)*(-6*fd**2*(-4*C*(r + s - 1) + 6*K*r + 6*K*s + r + s - 3) + fd*(59*g2 - 24*gd2)*(r + s - 1) - 12*fdd*g2*(r + s - 1))) + D1*bd1*(D1*(6*f**2*(8*r**2 + 2*r*(8*s - 11) + 8*s**2 - 22*s + 11) + f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 118*K*r**2 + 236*K*r*s - 118*K*r + 118*K*s**2 - 118*K*s + 59*K - 48*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 2*r**2 + 4*r*s - 78*r + 2*s**2 - 78*s + 39) - 4*fd*(r + s - 1)*(C*(2*r + 2*s - 1) + 6*K*(2*r + 2*s - 1) + 4*r + 4*s + 4) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(4*r + 4*s - 3)*(6*f**2*(2*r + 2*s - 3) + f*(C*(2*r + 2*s - 1) + 6*K*(2*r + 2*s - 1) + 4*r + 4*s - 8) + 7*g2*(2*r + 2*s - 1))) - 2*D1*(Dd*(9*f**3*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f**2*(19*C - 27*K - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-12*fd*(4*r + 4*s - 3)*(-4*C*(r + s - 1) + K*(6*r + 6*s - 3) + r + s - 2) + 59*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 24*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) - 24*fd*g2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*Ddd*f*(f*(4*C - 6*K - 1) - 4*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(f*(4*C - 6*K - 1) - 4*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(462*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k1**2*k2**2*(D1*(-4*D1*bd1**2*(r + s - 1)*(3*K*f*(5*r + 5*s - 6) + f*(18 - 24*C)*(r + s) + 28*g2*(r + s)) + b2*(bd1*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) - 6*f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - 2*bd1*(36*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(-2*C*(13*r**2 + r*(26*s - 30) + 13*s**2 - 30*s + 15) + 3*K*(r + s - 1)**2 + 7*r**2 + 14*r*s - 18*r + 7*s**2 - 18*s + 9) + f*(fd*(20*C - 10)*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) + g2*(32*r**2 + 64*r*s - 74*r + 32*s**2 - 74*s + 37) - 12*gd2*(5*r**2 + 10*r*s - 11*r + 5*s**2 - 11*s + 6)) - 60*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + Dd*f*(f*(10*C - 5) - 12*g2)*(20*r**2 + r*(40*s - 39) + 20*s**2 - 39*s + 18)) + f*(-30*C*D1*f*fd*r**2 - 60*C*D1*f*fd*r*s + 40*C*D1*f*fd*r - 30*C*D1*f*fd*s**2 + 40*C*D1*f*fd*s - 20*C*D1*f*fd - 40*C*Dd*f**2*r**2 - 80*C*Dd*f**2*r*s + 60*C*Dd*f**2*r - 40*C*Dd*f**2*s**2 + 60*C*Dd*f**2*s - 30*C*Dd*f**2 - 6*D1*bd2*f*(r + s - 1)**2 - D1*bdd1*(f*(10*C - 5) - 12*g2)*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) + 15*D1*f*fd*r**2 + 30*D1*f*fd*r*s - 20*D1*f*fd*r + 15*D1*f*fd*s**2 - 20*D1*f*fd*s + 10*D1*f*fd + 12*D1*f*gd2*r**2 + 24*D1*f*gd2*r*s - 24*D1*f*gd2*r + 12*D1*f*gd2*s**2 - 24*D1*f*gd2*s + 12*D1*f*gd2 + 24*D1*fd*g2*r**2 + 48*D1*fd*g2*r*s - 24*D1*fd*g2*r + 24*D1*fd*g2*s**2 - 24*D1*fd*g2*s + 12*D1*fd*g2 + 20*Dd*f**2*r**2 + 40*Dd*f**2*r*s - 30*Dd*f**2*r + 20*Dd*f**2*s**2 - 30*Dd*f**2*s + 15*Dd*f**2 + 48*Dd*f*g2*r**2 + 96*Dd*f*g2*r*s - 72*Dd*f*g2*r + 48*Dd*f*g2*s**2 - 72*Dd*f*g2*s + 36*Dd*f*g2)) + 2*b1**3*(D1**2*(11*fd - 9*fdd)*(r + s - 1)**2 + D1*(Dd*(11*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 18*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 2*(14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(-14*K + 9*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(-14*K + 9*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-26*C*D1**2*fd*r**2 - 52*C*D1**2*fd*r*s + 52*C*D1**2*fd*r - 26*C*D1**2*fd*s**2 + 52*C*D1**2*fd*s - 26*C*D1**2*fd + 48*C*D1**2*fdd*r**2 + 96*C*D1**2*fdd*r*s - 96*C*D1**2*fdd*r + 48*C*D1**2*fdd*s**2 - 96*C*D1**2*fdd*s + 48*C*D1**2*fdd - 104*C*D1*Dd*f*r**2 - 208*C*D1*Dd*f*r*s + 156*C*D1*Dd*f*r - 104*C*D1*Dd*f*s**2 + 156*C*D1*Dd*f*s - 78*C*D1*Dd*f + 384*C*D1*Dd*fd*r**2 + 768*C*D1*Dd*fd*r*s - 672*C*D1*Dd*fd*r + 384*C*D1*Dd*fd*s**2 - 672*C*D1*Dd*fd*s + 288*C*D1*Dd*fd + 192*C*D1*Ddd*f*r**2 + 384*C*D1*Ddd*f*r*s - 288*C*D1*Ddd*f*r + 192*C*D1*Ddd*f*s**2 - 288*C*D1*Ddd*f*s + 144*C*D1*Ddd*f + 576*C*Dd**2*f*r**2 + 1152*C*Dd**2*f*r*s - 864*C*Dd**2*f*r + 576*C*Dd**2*f*s**2 - 864*C*Dd**2*f*s + 288*C*Dd**2*f + 32*D1**2*K*fd*r**2 + 64*D1**2*K*fd*r*s + 10*D1**2*K*fd*r + 32*D1**2*K*fd*s**2 + 10*D1**2*K*fd*s - 5*D1**2*K*fd - 30*D1**2*K*fdd*r**2 - 60*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r - 30*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - 2*D1**2*bdd1*(-14*K + 9*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 24*D1**2*f*fd*r**2 + 48*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 12*D1**2*f*fd + 30*D1**2*fd*r**2 + 60*D1**2*fd*r*s - 32*D1**2*fd*r + 30*D1**2*fd*s**2 - 32*D1**2*fd*s + 16*D1**2*fd - 36*D1**2*fdd*r**2 - 72*D1**2*fdd*r*s + 72*D1**2*fdd*r - 36*D1**2*fdd*s**2 + 72*D1**2*fdd*s - 36*D1**2*fdd + 112*D1**2*gd2*r**2 + 224*D1**2*gd2*r*s - 224*D1**2*gd2*r + 112*D1**2*gd2*s**2 - 224*D1**2*gd2*s + 112*D1**2*gd2 - 56*D1**2*gdd2*r**2 - 112*D1**2*gdd2*r*s + 112*D1**2*gdd2*r - 56*D1**2*gdd2*s**2 + 112*D1**2*gdd2*s - 56*D1**2*gdd2 + 128*D1*Dd*K*f*r**2 + 256*D1*Dd*K*f*r*s - 192*D1*Dd*K*f*r + 128*D1*Dd*K*f*s**2 - 192*D1*Dd*K*f*s + 96*D1*Dd*K*f - 240*D1*Dd*K*fd*r**2 - 480*D1*Dd*K*fd*r*s + 132*D1*Dd*K*fd*r - 240*D1*Dd*K*fd*s**2 + 132*D1*Dd*K*fd*s + 36*D1*Dd*K*fd + 48*D1*Dd*f**2*r**2 + 96*D1*Dd*f**2*r*s - 72*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 36*D1*Dd*f**2 + 120*D1*Dd*f*r**2 + 240*D1*Dd*f*r*s - 180*D1*Dd*f*r + 120*D1*Dd*f*s**2 - 180*D1*Dd*f*s + 90*D1*Dd*f - 288*D1*Dd*fd*r**2 - 576*D1*Dd*fd*r*s + 504*D1*Dd*fd*r - 288*D1*Dd*fd*s**2 + 504*D1*Dd*fd*s - 216*D1*Dd*fd + 448*D1*Dd*g2*r**2 + 896*D1*Dd*g2*r*s - 672*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 672*D1*Dd*g2*s + 336*D1*Dd*g2 - 448*D1*Dd*gd2*r**2 - 896*D1*Dd*gd2*r*s + 784*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 784*D1*Dd*gd2*s - 336*D1*Dd*gd2 - 120*D1*Ddd*K*f*r**2 - 240*D1*Ddd*K*f*r*s + 180*D1*Ddd*K*f*r - 120*D1*Ddd*K*f*s**2 + 180*D1*Ddd*K*f*s - 90*D1*Ddd*K*f - 144*D1*Ddd*f*r**2 - 288*D1*Ddd*f*r*s + 216*D1*Ddd*f*r - 144*D1*Ddd*f*s**2 + 216*D1*Ddd*f*s - 108*D1*Ddd*f - 224*D1*Ddd*g2*r**2 - 448*D1*Ddd*g2*r*s + 336*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 336*D1*Ddd*g2*s - 168*D1*Ddd*g2 + 2*D1*bd1*(D1*(11*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 18*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 2*(14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*Dd*(-14*K + 9*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 360*Dd**2*K*f*r**2 - 720*Dd**2*K*f*r*s + 540*Dd**2*K*f*r - 360*Dd**2*K*f*s**2 + 540*Dd**2*K*f*s - 180*Dd**2*K*f - 432*Dd**2*f*r**2 - 864*Dd**2*f*r*s + 648*Dd**2*f*r - 432*Dd**2*f*s**2 + 648*Dd**2*f*s - 216*Dd**2*f - 672*Dd**2*g2*r**2 - 1344*Dd**2*g2*r*s + 1008*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 1008*Dd**2*g2*s - 336*Dd**2*g2) - b1*(-96*C*D1**2*bdd1*f*r**2 - 192*C*D1**2*bdd1*f*r*s + 96*C*D1**2*bdd1*f*r - 96*C*D1**2*bdd1*f*s**2 + 96*C*D1**2*bdd1*f*s - 48*C*D1**2*bdd1*f - 104*C*D1**2*f*fd*r**2 - 208*C*D1**2*f*fd*r*s + 88*C*D1**2*f*fd*r - 104*C*D1**2*f*fd*s**2 + 88*C*D1**2*f*fd*s - 44*C*D1**2*f*fd + 100*C*D1**2*f*fdd*r**2 + 200*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 100*C*D1**2*f*fdd*s**2 - 80*C*D1**2*f*fdd*s + 40*C*D1**2*f*fdd + 100*C*D1**2*fd**2*r**2 + 200*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 100*C*D1**2*fd**2*s**2 - 80*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 - 208*C*D1*Dd*f**2*r**2 - 416*C*D1*Dd*f**2*r*s + 312*C*D1*Dd*f**2*r - 208*C*D1*Dd*f**2*s**2 + 312*C*D1*Dd*f**2*s - 156*C*D1*Dd*f**2 + 800*C*D1*Dd*f*fd*r**2 + 1600*C*D1*Dd*f*fd*r*s - 920*C*D1*Dd*f*fd*r + 800*C*D1*Dd*f*fd*s**2 - 920*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*r**2 + 400*C*D1*Ddd*f**2*r*s - 300*C*D1*Ddd*f**2*r + 200*C*D1*Ddd*f**2*s**2 - 300*C*D1*Ddd*f**2*s + 150*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*r**2 + 1200*C*Dd**2*f**2*r*s - 900*C*Dd**2*f**2*r + 600*C*Dd**2*f**2*s**2 - 900*C*Dd**2*f**2*s + 300*C*Dd**2*f**2 + 60*D1**2*K*bdd1*f*r**2 + 120*D1**2*K*bdd1*f*r*s - 132*D1**2*K*bdd1*f*r + 60*D1**2*K*bdd1*f*s**2 - 132*D1**2*K*bdd1*f*s + 66*D1**2*K*bdd1*f + 12*D1**2*K*f*fd*r**2 + 24*D1**2*K*f*fd*r*s - 12*D1**2*K*f*fd*r + 12*D1**2*K*f*fd*s**2 - 12*D1**2*K*f*fd*s + 6*D1**2*K*f*fd - 37*D1**2*b2*fd*r**2 - 74*D1**2*b2*fd*r*s - 37*D1**2*b2*fd*s**2 + 36*D1**2*b2*fdd*r**2 + 72*D1**2*b2*fdd*r*s + 36*D1**2*b2*fdd*s**2 + 4*D1**2*bd1**2*(-14*K + 9*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 72*D1**2*bdd1*f*r**2 + 144*D1**2*bdd1*f*r*s - 72*D1**2*bdd1*f*r + 72*D1**2*bdd1*f*s**2 - 72*D1**2*bdd1*f*s + 36*D1**2*bdd1*f + 112*D1**2*bdd1*g2*r**2 + 224*D1**2*bdd1*g2*r*s - 112*D1**2*bdd1*g2*r + 112*D1**2*bdd1*g2*s**2 - 112*D1**2*bdd1*g2*s + 56*D1**2*bdd1*g2 + 36*D1**2*bdd2*f*r**2 + 72*D1**2*bdd2*f*r*s - 72*D1**2*bdd2*f*r + 36*D1**2*bdd2*f*s**2 - 72*D1**2*bdd2*f*s + 36*D1**2*bdd2*f + 28*D1**2*f*fd*r**2 + 56*D1**2*f*fd*r*s - 20*D1**2*f*fd*r + 28*D1**2*f*fd*s**2 - 20*D1**2*f*fd*s + 10*D1**2*f*fd - 50*D1**2*f*fdd*r**2 - 100*D1**2*f*fdd*r*s + 40*D1**2*f*fdd*r - 50*D1**2*f*fdd*s**2 + 40*D1**2*f*fdd*s - 20*D1**2*f*fdd + 64*D1**2*f*gd2*r**2 + 128*D1**2*f*gd2*r*s - 128*D1**2*f*gd2*r + 64*D1**2*f*gd2*s**2 - 128*D1**2*f*gd2*s + 64*D1**2*f*gd2 - 60*D1**2*f*gdd2*r**2 - 120*D1**2*f*gdd2*r*s + 120*D1**2*f*gdd2*r - 60*D1**2*f*gdd2*s**2 + 120*D1**2*f*gdd2*s - 60*D1**2*f*gdd2 - 50*D1**2*fd**2*r**2 - 100*D1**2*fd**2*r*s + 40*D1**2*fd**2*r - 50*D1**2*fd**2*s**2 + 40*D1**2*fd**2*s + 10*D1**2*fd**2 + 64*D1**2*fd*g2*r**2 + 128*D1**2*fd*g2*r*s + 20*D1**2*fd*g2*r + 64*D1**2*fd*g2*s**2 + 20*D1**2*fd*g2*s - 10*D1**2*fd*g2 - 120*D1**2*fd*gd2*r**2 - 240*D1**2*fd*gd2*r*s + 96*D1**2*fd*gd2*r - 120*D1**2*fd*gd2*s**2 + 96*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 - 60*D1**2*fdd*g2*r**2 - 120*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r - 60*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 + 24*D1*Dd*K*f**2*r**2 + 48*D1*Dd*K*f**2*r*s - 36*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s**2 - 36*D1*Dd*K*f**2*s + 18*D1*Dd*K*f**2 - 148*D1*Dd*b2*f*r**2 - 296*D1*Dd*b2*f*r*s + 222*D1*Dd*b2*f*r - 148*D1*Dd*b2*f*s**2 + 222*D1*Dd*b2*f*s - 111*D1*Dd*b2*f + 288*D1*Dd*b2*fd*r**2 + 576*D1*Dd*b2*fd*r*s - 216*D1*Dd*b2*fd*r + 288*D1*Dd*b2*fd*s**2 - 216*D1*Dd*b2*fd*s + 56*D1*Dd*f**2*r**2 + 112*D1*Dd*f**2*r*s - 84*D1*Dd*f**2*r + 56*D1*Dd*f**2*s**2 - 84*D1*Dd*f**2*s + 42*D1*Dd*f**2 - 400*D1*Dd*f*fd*r**2 - 800*D1*Dd*f*fd*r*s + 460*D1*Dd*f*fd*r - 400*D1*Dd*f*fd*s**2 + 460*D1*Dd*f*fd*s - 120*D1*Dd*f*fd + 256*D1*Dd*f*g2*r**2 + 512*D1*Dd*f*g2*r*s - 384*D1*Dd*f*g2*r + 256*D1*Dd*f*g2*s**2 - 384*D1*Dd*f*g2*s + 192*D1*Dd*f*g2 - 480*D1*Dd*f*gd2*r**2 - 960*D1*Dd*f*gd2*r*s + 840*D1*Dd*f*gd2*r - 480*D1*Dd*f*gd2*s**2 + 840*D1*Dd*f*gd2*s - 360*D1*Dd*f*gd2 - 480*D1*Dd*fd*g2*r**2 - 960*D1*Dd*fd*g2*r*s + 264*D1*Dd*fd*g2*r - 480*D1*Dd*fd*g2*s**2 + 264*D1*Dd*fd*g2*s + 72*D1*Dd*fd*g2 + 144*D1*Ddd*b2*f*r**2 + 288*D1*Ddd*b2*f*r*s - 216*D1*Ddd*b2*f*r + 144*D1*Ddd*b2*f*s**2 - 216*D1*Ddd*b2*f*s + 108*D1*Ddd*b2*f - 100*D1*Ddd*f**2*r**2 - 200*D1*Ddd*f**2*r*s + 150*D1*Ddd*f**2*r - 100*D1*Ddd*f**2*s**2 + 150*D1*Ddd*f**2*s - 75*D1*Ddd*f**2 - 240*D1*Ddd*f*g2*r**2 - 480*D1*Ddd*f*g2*r*s + 360*D1*Ddd*f*g2*r - 240*D1*Ddd*f*g2*s**2 + 360*D1*Ddd*f*g2*s - 180*D1*Ddd*f*g2 + D1*bd1*(-D1*(24*f**2*(r + s - 1)**2 + f*(-26*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + K*(64*r**2 + 2*r*(64*s - 69) + 64*s**2 - 138*s + 69) + 60*r**2 + 120*r*s - 88*r + 60*s**2 - 88*s + 44) - 12*fd*(r + s - 1)*(-8*C*(2*r + 2*s - 1) + 10*K*r + 10*K*s + K + 12*r + 12*s - 6) + 112*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 112*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 4*Dd*(3*f*(8*C*(2*r + 2*s - 1) - 10*K*r - 10*K*s + 11*K - 12*r - 12*s + 6) - 28*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - D1*bd2*(r + s - 1)*(37*D1*f*(r + s - 1) - 72*D1*fd*(r + s) - 72*Dd*f*(4*r + 4*s - 3)) + 432*Dd**2*b2*f*r**2 + 864*Dd**2*b2*f*r*s - 648*Dd**2*b2*f*r + 432*Dd**2*b2*f*s**2 - 648*Dd**2*b2*f*s + 216*Dd**2*b2*f - 300*Dd**2*f**2*r**2 - 600*Dd**2*f**2*r*s + 450*Dd**2*f**2*r - 300*Dd**2*f**2*s**2 + 450*Dd**2*f**2*s - 150*Dd**2*f**2 - 720*Dd**2*f*g2*r**2 - 1440*Dd**2*f*g2*r*s + 1080*Dd**2*f*g2*r - 720*Dd**2*f*g2*s**2 + 1080*Dd**2*f*g2*s - 360*Dd**2*f*g2))/(21*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k1**2*st**2*(D1*f*(r + s)*(6*D1*bd1**2*(2*f + 1)*(r + s - 1) + 3*D1*bdd1*f*(r + s) + bd1*(-5*D1*f*(r + s) + 12*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(r + s - 1)**2*(12*f*fdd + 12*fd**2 - fd*(18*f + 13) + 3*fdd) + D1*(Dd*(-9*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(24*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 52*r**2 - 104*r*s + 78*r - 52*s**2 + 78*s - 39) + 6*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 3*Ddd*f*(2*f + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 18*Dd**2*f*(2*f + 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(3*D1**2*bdd1*f*(2*f + 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 10*D1**2*f*fd*r**2 - 20*D1**2*f*fd*r*s + 20*D1**2*f*fd*r - 10*D1**2*f*fd*s**2 + 20*D1**2*f*fd*s - 10*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 12*D1**2*f*fdd*s + 6*D1**2*f*fdd + 6*D1**2*fd**2*r**2 + 12*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 12*D1**2*fd**2*s + 6*D1**2*fd**2 - 20*D1*Dd*f**2*r**2 - 40*D1*Dd*f**2*r*s + 30*D1*Dd*f**2*r - 20*D1*Dd*f**2*s**2 + 30*D1*Dd*f**2*s - 15*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 84*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 84*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 12*D1*Ddd*f**2*r**2 + 24*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + D1*bd1*(D1*(-9*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(24*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 26*r**2 - 52*r*s + 26*r - 26*s**2 + 26*s - 13) + 6*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 6*Dd*f*(2*f + 1)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 36*Dd**2*f**2*r**2 + 72*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 18*Dd**2*f**2))/(21*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**2*k1**2*(-D1*(r + s)*(12*D1*bd1**2*f*(K - 2)*(r + s - 1) + D1*bdd1*f*(r + s)*(6*b2 + f*(10*C - 5) - 12*g2) + bd1*(12*D1*bd2*f*(r + s - 1) - 2*D1*(f**2*(4*C - 2)*(r + s) + f*(fd*(10 - 20*C)*(r + s - 1) - 5*g2*(r + s) + 12*gd2*(r + s - 1)) + 12*fd*g2*(r + s - 1)) + 2*Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3) + b2*(-5*D1*f*(r + s) + 12*D1*fd*(r + s - 1) + 12*Dd*f*(4*r + 4*s - 3)))) - 2*b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 56*r**2 + 112*r*s - 84*r + 56*s**2 - 84*s + 42) - Ddd*(6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(2*D1**2*bdd1*(6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*D1*bd1*(D1*(5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 42*r**2 + 84*r*s - 56*r + 42*s**2 - 56*s + 28) - 2*Dd*(6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + (K - 2)*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + b1*(16*C*D1**2*f*fd*r**2 + 32*C*D1**2*f*fd*r*s - 32*C*D1**2*f*fd*r + 16*C*D1**2*f*fd*s**2 - 32*C*D1**2*f*fd*s + 16*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r**2 - 40*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 40*C*D1**2*f*fdd*s - 20*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r**2 - 40*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 40*C*D1**2*fd**2*s - 20*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r**2 + 64*C*D1*Dd*f**2*r*s - 48*C*D1*Dd*f**2*r + 32*C*D1*Dd*f**2*s**2 - 48*C*D1*Dd*f**2*s + 24*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r**2 - 320*C*D1*Dd*f*fd*r*s + 280*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 280*C*D1*Dd*f*fd*s - 120*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r**2 - 80*C*D1*Ddd*f**2*r*s + 60*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 60*C*D1*Ddd*f**2*s - 30*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r**2 - 240*C*Dd**2*f**2*r*s + 180*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 180*C*Dd**2*f**2*s - 60*C*Dd**2*f**2 - 12*D1**2*K*bdd1*f*r**2 - 24*D1**2*K*bdd1*f*r*s + 12*D1**2*K*bdd1*f*r - 12*D1**2*K*bdd1*f*s**2 + 12*D1**2*K*bdd1*f*s - 6*D1**2*K*bdd1*f + 5*D1**2*b2*fd*r**2 + 10*D1**2*b2*fd*r*s - 10*D1**2*b2*fd*r + 5*D1**2*b2*fd*s**2 - 10*D1**2*b2*fd*s + 5*D1**2*b2*fd - 6*D1**2*b2*fdd*r**2 - 12*D1**2*b2*fdd*r*s + 12*D1**2*b2*fdd*r - 6*D1**2*b2*fdd*s**2 + 12*D1**2*b2*fdd*s - 6*D1**2*b2*fdd + 4*D1**2*bd1**2*(6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 24*D1**2*bdd1*f*r**2 + 48*D1**2*bdd1*f*r*s - 24*D1**2*bdd1*f*r + 24*D1**2*bdd1*f*s**2 - 24*D1**2*bdd1*f*s + 12*D1**2*bdd1*f - 6*D1**2*bdd2*f*r**2 - 12*D1**2*bdd2*f*r*s + 12*D1**2*bdd2*f*r - 6*D1**2*bdd2*f*s**2 + 12*D1**2*bdd2*f*s - 6*D1**2*bdd2*f - 8*D1**2*f*fd*r**2 - 16*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 10*D1**2*f*fdd - 10*D1**2*f*gd2*r**2 - 20*D1**2*f*gd2*r*s + 20*D1**2*f*gd2*r - 10*D1**2*f*gd2*s**2 + 20*D1**2*f*gd2*s - 10*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*r + 12*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s + 12*D1**2*f*gdd2 + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 20*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s + 10*D1**2*fd**2 - 10*D1**2*fd*g2*r**2 - 20*D1**2*fd*g2*r*s + 20*D1**2*fd*g2*r - 10*D1**2*fd*g2*s**2 + 20*D1**2*fd*g2*s - 10*D1**2*fd*g2 + 24*D1**2*fd*gd2*r**2 + 48*D1**2*fd*gd2*r*s - 48*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 48*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r**2 + 24*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r + 12*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 + 20*D1*Dd*b2*f*r**2 + 40*D1*Dd*b2*f*r*s - 30*D1*Dd*b2*f*r + 20*D1*Dd*b2*f*s**2 - 30*D1*Dd*b2*f*s + 15*D1*Dd*b2*f - 48*D1*Dd*b2*fd*r**2 - 96*D1*Dd*b2*fd*r*s + 84*D1*Dd*b2*fd*r - 48*D1*Dd*b2*fd*s**2 + 84*D1*Dd*b2*fd*s - 36*D1*Dd*b2*fd - 16*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 140*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 140*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 40*D1*Dd*f*g2*r**2 - 80*D1*Dd*f*g2*r*s + 60*D1*Dd*f*g2*r - 40*D1*Dd*f*g2*s**2 + 60*D1*Dd*f*g2*s - 30*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 192*D1*Dd*f*gd2*r*s - 168*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 168*D1*Dd*f*gd2*s + 72*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 192*D1*Dd*fd*g2*r*s - 168*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s + 72*D1*Dd*fd*g2 - 24*D1*Ddd*b2*f*r**2 - 48*D1*Ddd*b2*f*r*s + 36*D1*Ddd*b2*f*r - 24*D1*Ddd*b2*f*s**2 + 36*D1*Ddd*b2*f*s - 18*D1*Ddd*b2*f + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 96*D1*Ddd*f*g2*r*s - 72*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 72*D1*Ddd*f*g2*s + 36*D1*Ddd*f*g2 + D1*bd1*(K - 2)*(D1*(5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 12*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + D1*bd2*(D1*(5*f - 12*fd)*(r + s - 1) - 12*Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 72*Dd**2*b2*f*r**2 - 144*Dd**2*b2*f*r*s + 108*Dd**2*b2*f*r - 72*Dd**2*b2*f*s**2 + 108*Dd**2*b2*f*s - 36*Dd**2*b2*f + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 288*Dd**2*f*g2*r*s - 216*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 216*Dd**2*f*g2*s + 72*Dd**2*f*g2))/(21*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**2*k2**6*st**2*(-8*C*D1**2*b1*f*fd*r**2 - 16*C*D1**2*b1*f*fd*r*s + 8*C*D1**2*b1*f*fd*r - 8*C*D1**2*b1*f*fd*s**2 + 8*C*D1**2*b1*f*fd*s - 4*C*D1**2*b1*f*fd + 4*C*D1**2*b1*f*fdd*r**2 + 8*C*D1**2*b1*f*fdd*r*s - 4*C*D1**2*b1*f*fdd*r + 4*C*D1**2*b1*f*fdd*s**2 - 4*C*D1**2*b1*f*fdd*s + 2*C*D1**2*b1*f*fdd + 4*C*D1**2*b1*fd**2*r**2 + 8*C*D1**2*b1*fd**2*r*s - 4*C*D1**2*b1*fd**2*r + 4*C*D1**2*b1*fd**2*s**2 - 4*C*D1**2*b1*fd**2*s + 6*C*D1**2*f**2*fd*r**2 + 12*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r + 6*C*D1**2*f**2*fd*s**2 - 8*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd - 16*C*D1*Dd*b1*f**2*r**2 - 32*C*D1*Dd*b1*f**2*r*s + 24*C*D1*Dd*b1*f**2*r - 16*C*D1*Dd*b1*f**2*s**2 + 24*C*D1*Dd*b1*f**2*s - 12*C*D1*Dd*b1*f**2 + 32*C*D1*Dd*b1*f*fd*r**2 + 64*C*D1*Dd*b1*f*fd*r*s - 40*C*D1*Dd*b1*f*fd*r + 32*C*D1*Dd*b1*f*fd*s**2 - 40*C*D1*Dd*b1*f*fd*s + 12*C*D1*Dd*b1*f*fd + 8*C*D1*Dd*f**3*r**2 + 16*C*D1*Dd*f**3*r*s - 12*C*D1*Dd*f**3*r + 8*C*D1*Dd*f**3*s**2 - 12*C*D1*Dd*f**3*s + 6*C*D1*Dd*f**3 + 8*C*D1*Ddd*b1*f**2*r**2 + 16*C*D1*Ddd*b1*f**2*r*s - 12*C*D1*Ddd*b1*f**2*r + 8*C*D1*Ddd*b1*f**2*s**2 - 12*C*D1*Ddd*b1*f**2*s + 6*C*D1*Ddd*b1*f**2 + 24*C*Dd**2*b1*f**2*r**2 + 48*C*Dd**2*b1*f**2*r*s - 36*C*Dd**2*b1*f**2*r + 24*C*Dd**2*b1*f**2*s**2 - 36*C*Dd**2*b1*f**2*s + 12*C*Dd**2*b1*f**2 - 2*D1**2*K*b1**2*fd*r**2 - 4*D1**2*K*b1**2*fd*r*s - 2*D1**2*K*b1**2*fd*s**2 + D1**2*K*b1**2*fdd*r**2 + 2*D1**2*K*b1**2*fdd*r*s + D1**2*K*b1**2*fdd*s**2 + 2*D1**2*K*b1*f*fd*r**2 + 4*D1**2*K*b1*f*fd*r*s - 2*D1**2*K*b1*f*fd*r + 2*D1**2*K*b1*f*fd*s**2 - 2*D1**2*K*b1*f*fd*s + D1**2*K*b1*f*fd + 2*D1**2*K*bd1**2*f*(r + s - 1)**2 + 4*D1**2*b1*f*fd*r**2 + 8*D1**2*b1*f*fd*r*s - 4*D1**2*b1*f*fd*r + 4*D1**2*b1*f*fd*s**2 - 4*D1**2*b1*f*fd*s + 2*D1**2*b1*f*fd - 2*D1**2*b1*f*fdd*r**2 - 4*D1**2*b1*f*fdd*r*s + 2*D1**2*b1*f*fdd*r - 2*D1**2*b1*f*fdd*s**2 + 2*D1**2*b1*f*fdd*s - D1**2*b1*f*fdd + 4*D1**2*b1*f*gd2*r**2 + 8*D1**2*b1*f*gd2*r*s - 8*D1**2*b1*f*gd2*r + 4*D1**2*b1*f*gd2*s**2 - 8*D1**2*b1*f*gd2*s + 4*D1**2*b1*f*gd2 - 2*D1**2*b1*f*gdd2*r**2 - 4*D1**2*b1*f*gdd2*r*s + 4*D1**2*b1*f*gdd2*r - 2*D1**2*b1*f*gdd2*s**2 + 4*D1**2*b1*f*gdd2*s - 2*D1**2*b1*f*gdd2 - 2*D1**2*b1*fd**2*r**2 - 4*D1**2*b1*fd**2*r*s + 2*D1**2*b1*fd**2*r - 2*D1**2*b1*fd**2*s**2 + 2*D1**2*b1*fd**2*s + 4*D1**2*b1*fd*g2*r**2 + 8*D1**2*b1*fd*g2*r*s + 4*D1**2*b1*fd*g2*s**2 - 4*D1**2*b1*fd*gd2*r**2 - 8*D1**2*b1*fd*gd2*r*s + 4*D1**2*b1*fd*gd2*r - 4*D1**2*b1*fd*gd2*s**2 + 4*D1**2*b1*fd*gd2*s - 2*D1**2*b1*fdd*g2*r**2 - 4*D1**2*b1*fdd*g2*r*s - 2*D1**2*b1*fdd*g2*s**2 + D1**2*bdd1*f*(r + s - 1)**2*(2*C*f + 2*K*b1 - f - 2*g2) - 3*D1**2*f**2*fd*r**2 - 6*D1**2*f**2*fd*r*s + 4*D1**2*f**2*fd*r - 3*D1**2*f**2*fd*s**2 + 4*D1**2*f**2*fd*s - 2*D1**2*f**2*fd - 2*D1**2*f**2*gd2*r**2 - 4*D1**2*f**2*gd2*r*s + 4*D1**2*f**2*gd2*r - 2*D1**2*f**2*gd2*s**2 + 4*D1**2*f**2*gd2*s - 2*D1**2*f**2*gd2 - 4*D1**2*f*fd*g2*r**2 - 8*D1**2*f*fd*g2*r*s + 4*D1**2*f*fd*g2*r - 4*D1**2*f*fd*g2*s**2 + 4*D1**2*f*fd*g2*s - 2*D1**2*f*fd*g2 - 8*D1*Dd*K*b1**2*f*r**2 - 16*D1*Dd*K*b1**2*f*r*s + 12*D1*Dd*K*b1**2*f*r - 8*D1*Dd*K*b1**2*f*s**2 + 12*D1*Dd*K*b1**2*f*s - 6*D1*Dd*K*b1**2*f + 8*D1*Dd*K*b1**2*fd*r**2 + 16*D1*Dd*K*b1**2*fd*r*s - 6*D1*Dd*K*b1**2*fd*r + 8*D1*Dd*K*b1**2*fd*s**2 - 6*D1*Dd*K*b1**2*fd*s + 4*D1*Dd*K*b1*f**2*r**2 + 8*D1*Dd*K*b1*f**2*r*s - 6*D1*Dd*K*b1*f**2*r + 4*D1*Dd*K*b1*f**2*s**2 - 6*D1*Dd*K*b1*f**2*s + 3*D1*Dd*K*b1*f**2 + 8*D1*Dd*b1*f**2*r**2 + 16*D1*Dd*b1*f**2*r*s - 12*D1*Dd*b1*f**2*r + 8*D1*Dd*b1*f**2*s**2 - 12*D1*Dd*b1*f**2*s + 6*D1*Dd*b1*f**2 - 16*D1*Dd*b1*f*fd*r**2 - 32*D1*Dd*b1*f*fd*r*s + 20*D1*Dd*b1*f*fd*r - 16*D1*Dd*b1*f*fd*s**2 + 20*D1*Dd*b1*f*fd*s - 6*D1*Dd*b1*f*fd + 16*D1*Dd*b1*f*g2*r**2 + 32*D1*Dd*b1*f*g2*r*s - 24*D1*Dd*b1*f*g2*r + 16*D1*Dd*b1*f*g2*s**2 - 24*D1*Dd*b1*f*g2*s + 12*D1*Dd*b1*f*g2 - 16*D1*Dd*b1*f*gd2*r**2 - 32*D1*Dd*b1*f*gd2*r*s + 28*D1*Dd*b1*f*gd2*r - 16*D1*Dd*b1*f*gd2*s**2 + 28*D1*Dd*b1*f*gd2*s - 12*D1*Dd*b1*f*gd2 - 16*D1*Dd*b1*fd*g2*r**2 - 32*D1*Dd*b1*fd*g2*r*s + 12*D1*Dd*b1*fd*g2*r - 16*D1*Dd*b1*fd*g2*s**2 + 12*D1*Dd*b1*fd*g2*s - 4*D1*Dd*f**3*r**2 - 8*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 4*D1*Dd*f**3*s**2 + 6*D1*Dd*f**3*s - 3*D1*Dd*f**3 - 8*D1*Dd*f**2*g2*r**2 - 16*D1*Dd*f**2*g2*r*s + 12*D1*Dd*f**2*g2*r - 8*D1*Dd*f**2*g2*s**2 + 12*D1*Dd*f**2*g2*s - 6*D1*Dd*f**2*g2 + 4*D1*Ddd*K*b1**2*f*r**2 + 8*D1*Ddd*K*b1**2*f*r*s - 6*D1*Ddd*K*b1**2*f*r + 4*D1*Ddd*K*b1**2*f*s**2 - 6*D1*Ddd*K*b1**2*f*s + 3*D1*Ddd*K*b1**2*f - 4*D1*Ddd*b1*f**2*r**2 - 8*D1*Ddd*b1*f**2*r*s + 6*D1*Ddd*b1*f**2*r - 4*D1*Ddd*b1*f**2*s**2 + 6*D1*Ddd*b1*f**2*s - 3*D1*Ddd*b1*f**2 - 8*D1*Ddd*b1*f*g2*r**2 - 16*D1*Ddd*b1*f*g2*r*s + 12*D1*Ddd*b1*f*g2*r - 8*D1*Ddd*b1*f*g2*s**2 + 12*D1*Ddd*b1*f*g2*s - 6*D1*Ddd*b1*f*g2 - D1*bd1*(D1*(f**2*(4*C - K - 2)*(r + s - 1) - f*fd*(4*C - 2)*(2*r + 2*s - 1) - 4*f*(r + s - 1)*(-K*b1 + g2 - gd2) + 4*fd*(r + s)*(-K*b1 + g2)) - 2*Dd*f*(4*r + 4*s - 3)*(2*K*b1 + f*(2*C - 1) - 2*g2))*(r + s - 1) + 12*Dd**2*K*b1**2*f*r**2 + 24*Dd**2*K*b1**2*f*r*s - 18*Dd**2*K*b1**2*f*r + 12*Dd**2*K*b1**2*f*s**2 - 18*Dd**2*K*b1**2*f*s + 6*Dd**2*K*b1**2*f - 12*Dd**2*b1*f**2*r**2 - 24*Dd**2*b1*f**2*r*s + 18*Dd**2*b1*f**2*r - 12*Dd**2*b1*f**2*s**2 + 18*Dd**2*b1*f**2*s - 6*Dd**2*b1*f**2 - 24*Dd**2*b1*f*g2*r**2 - 48*Dd**2*b1*f*g2*r*s + 36*Dd**2*b1*f*g2*r - 24*Dd**2*b1*f*g2*s**2 + 36*Dd**2*b1*f*g2*s - 12*Dd**2*b1*f*g2)/(7*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct**2*k2**4*st**2*(D1*(K*b1**2*(D1*(2*fd - fdd)*(2*r + 2*s - 1) - 2*Dd*fd*(4*r + 4*s - 3)) + b1*(8*C*D1*f*fd*r + 8*C*D1*f*fd*s - 4*C*D1*f*fd - 4*C*D1*f*fdd*r - 4*C*D1*f*fdd*s + 2*C*D1*f*fdd - 4*C*D1*fd**2*r - 4*C*D1*fd**2*s + 4*C*D1*fd**2 - 16*C*Dd*f*fd*r - 16*C*Dd*f*fd*s + 12*C*Dd*f*fd - 4*D1*K*bd1*f*r - 4*D1*K*bd1*f*s + 2*D1*K*bd1*f - 2*D1*K*bd1*fd*r - 2*D1*K*bd1*fd*s + 2*D1*K*bd1*fd + 2*D1*K*bdd1*f*r + 2*D1*K*bdd1*f*s - D1*K*bdd1*f - 2*D1*K*f*fd*r**2 - 4*D1*K*f*fd*r*s + 2*D1*K*f*fd*r - 2*D1*K*f*fd*s**2 + 2*D1*K*f*fd*s - D1*K*f*fd - D1*bdd2*f*(r + s - 1)**2 - 4*D1*f*fd*r - 4*D1*f*fd*s + 2*D1*f*fd + 2*D1*f*fdd*r + 2*D1*f*fdd*s - D1*f*fdd + 2*D1*fd**2*r + 2*D1*fd**2*s - 2*D1*fd**2 - 8*D1*fd*g2*r - 8*D1*fd*g2*s + 4*D1*fd*g2 + 4*D1*fd*gd2*r + 4*D1*fd*gd2*s - 4*D1*fd*gd2 + 4*D1*fdd*g2*r + 4*D1*fdd*g2*s - 2*D1*fdd*g2 + 8*Dd*K*bd1*f*r + 8*Dd*K*bd1*f*s - 6*Dd*K*bd1*f - 4*Dd*K*f**2*r**2 - 8*Dd*K*f**2*r*s + 6*Dd*K*f**2*r - 4*Dd*K*f**2*s**2 + 6*Dd*K*f**2*s - 3*Dd*K*f**2 + 8*Dd*f*fd*r + 8*Dd*f*fd*s - 6*Dd*f*fd + 16*Dd*fd*g2*r + 16*Dd*fd*g2*s - 12*Dd*fd*g2 + 2*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3))) - f*(-4*C*D1*bdd1*f*r - 4*C*D1*bdd1*f*s + 2*C*D1*bdd1*f + 6*C*D1*f*fd*r**2 + 12*C*D1*f*fd*r*s - 8*C*D1*f*fd*r + 6*C*D1*f*fd*s**2 - 8*C*D1*f*fd*s + 4*C*D1*f*fd + 8*C*Dd*f**2*r**2 + 16*C*Dd*f**2*r*s - 12*C*Dd*f**2*r + 8*C*Dd*f**2*s**2 - 12*C*Dd*f**2*s + 6*C*Dd*f**2 - 2*D1*K*bd1**2*(r + s - 1) + D1*bd2*f*r**2 + 2*D1*bd2*f*r*s - 2*D1*bd2*f*r + D1*bd2*f*s**2 - 2*D1*bd2*f*s + D1*bd2*f + 2*D1*bdd1*f*r + 2*D1*bdd1*f*s - D1*bdd1*f + 4*D1*bdd1*g2*r + 4*D1*bdd1*g2*s - 2*D1*bdd1*g2 - 3*D1*f*fd*r**2 - 6*D1*f*fd*r*s + 4*D1*f*fd*r - 3*D1*f*fd*s**2 + 4*D1*f*fd*s - 2*D1*f*fd - 2*D1*f*gd2*r**2 - 4*D1*f*gd2*r*s + 4*D1*f*gd2*r - 2*D1*f*gd2*s**2 + 4*D1*f*gd2*s - 2*D1*f*gd2 - 4*D1*fd*g2*r**2 - 8*D1*fd*g2*r*s + 4*D1*fd*g2*r - 4*D1*fd*g2*s**2 + 4*D1*fd*g2*s - 2*D1*fd*g2 - 4*Dd*f**2*r**2 - 8*Dd*f**2*r*s + 6*Dd*f**2*r - 4*Dd*f**2*s**2 + 6*Dd*f**2*s - 3*Dd*f**2 - 8*Dd*f*g2*r**2 - 16*Dd*f*g2*r*s + 12*Dd*f*g2*r - 8*Dd*f*g2*s**2 + 12*Dd*f*g2*s - 6*Dd*f*g2 + bd1*(2*D1*bd2*(r + s - 1)**2 + D1*(f*(C*(8*r + 8*s - 4) + K*(r + s - 1)**2 - 4*r - 4*s + 2) + fd*(2 - 4*C)*(r + s - 1) - 4*g2*(2*r + 2*s - 1) + 4*gd2*(r + s - 1)) - 2*Dd*(f*(2*C - 1) - 2*g2)*(4*r + 4*s - 3)))) + b2*(2*D1**2*b1*fd*r**2 + 4*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r**2 - 2*D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(r + s - 1)**2 - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r**2 + 16*D1*Dd*b1*f*r*s - 12*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 12*D1*Dd*b1*f*s + 6*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r**2 - 16*D1*Dd*b1*fd*r*s + 6*D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 6*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 4*D1*Ddd*b1*f*r**2 - 8*D1*Ddd*b1*f*r*s + 6*D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 6*D1*Ddd*b1*f*s - 3*D1*Ddd*b1*f + 2*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) - 12*Dd**2*b1*f*r**2 - 24*Dd**2*b1*f*r*s + 18*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 18*Dd**2*b1*f*s - 6*Dd**2*b1*f))/(7*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct**2*k2**4*(D1**2*bd1*(7*b2*f*(r + s - 1)**2 - (2*bd1*(r**2 + r*(2*s - 1) + s*(s - 1)) + f*(2*r + 2*s - 1))*(2*f*(6*C - 3) - 14*g2)) + D1*b1*(-24*C*D1*bdd1*f*r**2 - 48*C*D1*bdd1*f*r*s + 24*C*D1*bdd1*f*r - 24*C*D1*bdd1*f*s**2 + 24*C*D1*bdd1*f*s - 12*C*D1*bdd1*f + 24*C*D1*f*fd*r + 24*C*D1*f*fd*s - 12*C*D1*f*fd - 14*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*D1*b2*fd*r**2 + 14*D1*b2*fd*r*s + 7*D1*b2*fd*s**2 + 7*D1*bd2*f*(r + s - 1)**2 + 12*D1*bdd1*f*r**2 + 24*D1*bdd1*f*r*s - 12*D1*bdd1*f*r + 12*D1*bdd1*f*s**2 - 12*D1*bdd1*f*s + 6*D1*bdd1*f + 28*D1*bdd1*g2*r**2 + 56*D1*bdd1*g2*r*s - 28*D1*bdd1*g2*r + 28*D1*bdd1*g2*s**2 - 28*D1*bdd1*g2*s + 14*D1*bdd1*g2 - 12*D1*f*fd*r - 12*D1*f*fd*s + 6*D1*f*fd - 28*D1*fd*g2*r - 28*D1*fd*g2*s + 14*D1*fd*g2 + 28*Dd*b2*f*r**2 + 56*Dd*b2*f*r*s - 42*Dd*b2*f*r + 28*Dd*b2*f*s**2 - 42*Dd*b2*f*s + 21*Dd*b2*f + bd1*(D1*(f*(24*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*K*(2*r + 2*s - 1) - 24*r**2 - 48*r*s + 24*r - 24*s**2 + 24*s - 12) - 4*fd*(6*C - 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 28*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 28*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 4*Dd*(f*(6*C - 3) - 7*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(7*K*(2*bd1 - bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(24*C*(r + s - 1)**2 + 7*K*(2*r + 2*s - 1) - 12*(r + s - 1)**2) + fdd*(6 - 12*C)*(r + s - 1)**2 - 28*gd2*(r + s - 1)**2 + 14*gdd2*(r + s - 1)**2) + 2*D1*(Dd*(f*(12*C - 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(12*C - 6)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 14*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(28*r + 28*s - 21)) - Ddd*(f*(6*C - 3) - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*(f*(6*C - 3) - 7*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct**2*k2**2*st**2*(-D1*(r + s)*(2*D1*K*bd1**2*f*(r + s - 1) + D1*bdd1*f*(r + s)*(b2 + f*(2*C - 1) - 2*g2) + 2*bd1*(-2*C*D1*f**2*r - 2*C*D1*f**2*s + 4*C*D1*f*fd*r + 4*C*D1*f*fd*s - 4*C*D1*f*fd + 8*C*Dd*f**2*r + 8*C*Dd*f**2*s - 6*C*Dd*f**2 + D1*bd2*f*(r + s - 1) + D1*f**2*r + D1*f**2*s - 2*D1*f*fd*r - 2*D1*f*fd*s + 2*D1*f*fd + 2*D1*f*g2*r + 2*D1*f*g2*s - 2*D1*f*gd2*r - 2*D1*f*gd2*s + 2*D1*f*gd2 - 2*D1*fd*g2*r - 2*D1*fd*g2*s + 2*D1*fd*g2 - 4*Dd*f**2*r - 4*Dd*f**2*s + 3*Dd*f**2 - 8*Dd*f*g2*r - 8*Dd*f*g2*s + 6*Dd*f*g2 + b2*(-D1*f*(r + s) + D1*fd*(r + s - 1) + Dd*f*(4*r + 4*s - 3)))) + K*b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(8*C*D1**2*f*fd*r**2 + 16*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 16*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r**2 - 8*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 8*C*D1**2*f*fdd*s - 4*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r**2 - 8*C*D1**2*fd**2*r*s + 8*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 8*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 + 16*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 24*C*D1*Dd*f**2*s + 12*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r**2 - 64*C*D1*Dd*f*fd*r*s + 56*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 56*C*D1*Dd*f*fd*s - 24*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r**2 - 16*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 12*C*D1*Ddd*f**2*s - 6*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r**2 - 48*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 36*C*Dd**2*f**2*s - 12*C*Dd**2*f**2 + 4*D1**2*K*bd1*f*r**2 + 8*D1**2*K*bd1*f*r*s - 4*D1**2*K*bd1*f*r + 4*D1**2*K*bd1*f*s**2 - 4*D1**2*K*bd1*f*s + 2*D1**2*K*bd1*f - 4*D1**2*K*bd1*fd*r**2 - 8*D1**2*K*bd1*fd*r*s + 6*D1**2*K*bd1*fd*r - 4*D1**2*K*bd1*fd*s**2 + 6*D1**2*K*bd1*fd*s - 2*D1**2*K*bd1*fd - 2*D1**2*K*bdd1*f*r**2 - 4*D1**2*K*bdd1*f*r*s + 2*D1**2*K*bdd1*f*r - 2*D1**2*K*bdd1*f*s**2 + 2*D1**2*K*bdd1*f*s - D1**2*K*bdd1*f + 2*D1**2*b2*fd*r**2 + 4*D1**2*b2*fd*r*s - 4*D1**2*b2*fd*r + 2*D1**2*b2*fd*s**2 - 4*D1**2*b2*fd*s + 2*D1**2*b2*fd - D1**2*b2*fdd*r**2 - 2*D1**2*b2*fdd*r*s + 2*D1**2*b2*fdd*r - D1**2*b2*fdd*s**2 + 2*D1**2*b2*fdd*s - D1**2*b2*fdd - D1**2*bdd2*f*(r + s - 1)**2 - 4*D1**2*f*fd*r**2 - 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 4*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 4*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 4*D1**2*f*fdd*s + 2*D1**2*f*fdd - 4*D1**2*f*gd2*r**2 - 8*D1**2*f*gd2*r*s + 8*D1**2*f*gd2*r - 4*D1**2*f*gd2*s**2 + 8*D1**2*f*gd2*s - 4*D1**2*f*gd2 + 2*D1**2*f*gdd2*r**2 + 4*D1**2*f*gdd2*r*s - 4*D1**2*f*gdd2*r + 2*D1**2*f*gdd2*s**2 - 4*D1**2*f*gdd2*s + 2*D1**2*f*gdd2 + 2*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 4*D1**2*fd**2*s + 2*D1**2*fd**2 - 4*D1**2*fd*g2*r**2 - 8*D1**2*fd*g2*r*s + 8*D1**2*fd*g2*r - 4*D1**2*fd*g2*s**2 + 8*D1**2*fd*g2*s - 4*D1**2*fd*g2 + 4*D1**2*fd*gd2*r**2 + 8*D1**2*fd*gd2*r*s - 8*D1**2*fd*gd2*r + 4*D1**2*fd*gd2*s**2 - 8*D1**2*fd*gd2*s + 4*D1**2*fd*gd2 + 2*D1**2*fdd*g2*r**2 + 4*D1**2*fdd*g2*r*s - 4*D1**2*fdd*g2*r + 2*D1**2*fdd*g2*s**2 - 4*D1**2*fdd*g2*s + 2*D1**2*fdd*g2 - 16*D1*Dd*K*bd1*f*r**2 - 32*D1*Dd*K*bd1*f*r*s + 20*D1*Dd*K*bd1*f*r - 16*D1*Dd*K*bd1*f*s**2 + 20*D1*Dd*K*bd1*f*s - 6*D1*Dd*K*bd1*f + 8*D1*Dd*b2*f*r**2 + 16*D1*Dd*b2*f*r*s - 12*D1*Dd*b2*f*r + 8*D1*Dd*b2*f*s**2 - 12*D1*Dd*b2*f*s + 6*D1*Dd*b2*f - 8*D1*Dd*b2*fd*r**2 - 16*D1*Dd*b2*fd*r*s + 14*D1*Dd*b2*fd*r - 8*D1*Dd*b2*fd*s**2 + 14*D1*Dd*b2*fd*s - 6*D1*Dd*b2*fd - 8*D1*Dd*f**2*r**2 - 16*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 32*D1*Dd*f*fd*r*s - 28*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 28*D1*Dd*f*fd*s + 12*D1*Dd*f*fd - 16*D1*Dd*f*g2*r**2 - 32*D1*Dd*f*g2*r*s + 24*D1*Dd*f*g2*r - 16*D1*Dd*f*g2*s**2 + 24*D1*Dd*f*g2*s - 12*D1*Dd*f*g2 + 16*D1*Dd*f*gd2*r**2 + 32*D1*Dd*f*gd2*r*s - 28*D1*Dd*f*gd2*r + 16*D1*Dd*f*gd2*s**2 - 28*D1*Dd*f*gd2*s + 12*D1*Dd*f*gd2 + 16*D1*Dd*fd*g2*r**2 + 32*D1*Dd*fd*g2*r*s - 28*D1*Dd*fd*g2*r + 16*D1*Dd*fd*g2*s**2 - 28*D1*Dd*fd*g2*s + 12*D1*Dd*fd*g2 - 4*D1*Ddd*b2*f*r**2 - 8*D1*Ddd*b2*f*r*s + 6*D1*Ddd*b2*f*r - 4*D1*Ddd*b2*f*s**2 + 6*D1*Ddd*b2*f*s - 3*D1*Ddd*b2*f + 4*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 8*D1*Ddd*f*g2*r**2 + 16*D1*Ddd*f*g2*r*s - 12*D1*Ddd*f*g2*r + 8*D1*Ddd*f*g2*s**2 - 12*D1*Ddd*f*g2*s + 6*D1*Ddd*f*g2 + 2*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 12*Dd**2*b2*f*r**2 - 24*Dd**2*b2*f*r*s + 18*Dd**2*b2*f*r - 12*Dd**2*b2*f*s**2 + 18*Dd**2*b2*f*s - 6*Dd**2*b2*f + 12*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 18*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s + 6*Dd**2*f**2 + 24*Dd**2*f*g2*r**2 + 48*Dd**2*f*g2*r*s - 36*Dd**2*f*g2*r + 24*Dd**2*f*g2*s**2 - 36*Dd**2*f*g2*s + 12*Dd**2*f*g2))/(7*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct**2*k2**2*(-D1**2*bd1*(r + s)*(2*bd1*(r + s - 1) + f*(r + s))*(12*C*f + 7*b2 - 6*f - 14*g2) + D1*b1*(-24*C*D1*bdd1*f*r**2 - 48*C*D1*bdd1*f*r*s + 24*C*D1*bdd1*f*r - 24*C*D1*bdd1*f*s**2 + 24*C*D1*bdd1*f*s - 12*C*D1*bdd1*f - 24*C*D1*f*fd*r**2 - 48*C*D1*f*fd*r*s + 48*C*D1*f*fd*r - 24*C*D1*f*fd*s**2 + 48*C*D1*f*fd*s - 24*C*D1*f*fd - 48*C*Dd*f**2*r**2 - 96*C*Dd*f**2*r*s + 72*C*Dd*f**2*r - 48*C*Dd*f**2*s**2 + 72*C*Dd*f**2*s - 36*C*Dd*f**2 - 14*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 7*D1*bd2*f*r**2 - 14*D1*bd2*f*r*s + 14*D1*bd2*f*r - 7*D1*bd2*f*s**2 + 14*D1*bd2*f*s - 7*D1*bd2*f + 12*D1*bdd1*f*r**2 + 24*D1*bdd1*f*r*s - 12*D1*bdd1*f*r + 12*D1*bdd1*f*s**2 - 12*D1*bdd1*f*s + 6*D1*bdd1*f + 28*D1*bdd1*g2*r**2 + 56*D1*bdd1*g2*r*s - 28*D1*bdd1*g2*r + 28*D1*bdd1*g2*s**2 - 28*D1*bdd1*g2*s + 14*D1*bdd1*g2 + 12*D1*f*fd*r**2 + 24*D1*f*fd*r*s - 24*D1*f*fd*r + 12*D1*f*fd*s**2 - 24*D1*f*fd*s + 12*D1*f*fd + 14*D1*f*gd2*r**2 + 28*D1*f*gd2*r*s - 28*D1*f*gd2*r + 14*D1*f*gd2*s**2 - 28*D1*f*gd2*s + 14*D1*f*gd2 + 14*D1*fd*g2*r**2 + 28*D1*fd*g2*r*s - 28*D1*fd*g2*r + 14*D1*fd*g2*s**2 - 28*D1*fd*g2*s + 14*D1*fd*g2 + 24*Dd*f**2*r**2 + 48*Dd*f**2*r*s - 36*Dd*f**2*r + 24*Dd*f**2*s**2 - 36*Dd*f**2*s + 18*Dd*f**2 + 56*Dd*f*g2*r**2 + 112*Dd*f*g2*r*s - 84*Dd*f*g2*r + 56*Dd*f*g2*s**2 - 84*Dd*f*g2*s + 42*Dd*f*g2 + 7*b2*(2*D1*bd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - D1*fd*r**2 - 2*D1*fd*r*s + 2*D1*fd*r - D1*fd*s**2 + 2*D1*fd*s - D1*fd - 2*Dd*bd1*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 4*Dd*f*r**2 - 8*Dd*f*r*s + 6*Dd*f*r - 4*Dd*f*s**2 + 6*Dd*f*s - 3*Dd*f) - bd1*(14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(-f*(24*C - 7*K - 12)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*fd*(6*C - 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 28*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 4*Dd*(f*(6*C - 3) - 7*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(24*C*D1**2*fd*r**2 + 48*C*D1**2*fd*r*s - 48*C*D1**2*fd*r + 24*C*D1**2*fd*s**2 - 48*C*D1**2*fd*s + 24*C*D1**2*fd - 12*C*D1**2*fdd*r**2 - 24*C*D1**2*fdd*r*s + 24*C*D1**2*fdd*r - 12*C*D1**2*fdd*s**2 + 24*C*D1**2*fdd*s - 12*C*D1**2*fdd + 96*C*D1*Dd*f*r**2 + 192*C*D1*Dd*f*r*s - 144*C*D1*Dd*f*r + 96*C*D1*Dd*f*s**2 - 144*C*D1*Dd*f*s + 72*C*D1*Dd*f - 96*C*D1*Dd*fd*r**2 - 192*C*D1*Dd*fd*r*s + 168*C*D1*Dd*fd*r - 96*C*D1*Dd*fd*s**2 + 168*C*D1*Dd*fd*s - 72*C*D1*Dd*fd - 48*C*D1*Ddd*f*r**2 - 96*C*D1*Ddd*f*r*s + 72*C*D1*Ddd*f*r - 48*C*D1*Ddd*f*s**2 + 72*C*D1*Ddd*f*s - 36*C*D1*Ddd*f - 144*C*Dd**2*f*r**2 - 288*C*Dd**2*f*r*s + 216*C*Dd**2*f*r - 144*C*Dd**2*f*s**2 + 216*C*Dd**2*f*s - 72*C*Dd**2*f + 42*D1**2*K*bd1*r**2 + 84*D1**2*K*bd1*r*s - 56*D1**2*K*bd1*r + 42*D1**2*K*bd1*s**2 - 56*D1**2*K*bd1*s + 28*D1**2*K*bd1 - 21*D1**2*K*bdd1*r**2 - 42*D1**2*K*bdd1*r*s + 28*D1**2*K*bdd1*r - 21*D1**2*K*bdd1*s**2 + 28*D1**2*K*bdd1*s - 14*D1**2*K*bdd1 - 7*D1**2*K*fd*r**2 - 14*D1**2*K*fd*r*s + 14*D1**2*K*fd*r - 7*D1**2*K*fd*s**2 + 14*D1**2*K*fd*s - 7*D1**2*K*fd - 7*D1**2*bdd2*(r + s - 1)**2 - 12*D1**2*fd*r**2 - 24*D1**2*fd*r*s + 24*D1**2*fd*r - 12*D1**2*fd*s**2 + 24*D1**2*fd*s - 12*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r + 6*D1**2*fdd*s**2 - 12*D1**2*fdd*s + 6*D1**2*fdd - 28*D1**2*gd2*r**2 - 56*D1**2*gd2*r*s + 56*D1**2*gd2*r - 28*D1**2*gd2*s**2 + 56*D1**2*gd2*s - 28*D1**2*gd2 + 14*D1**2*gdd2*r**2 + 28*D1**2*gdd2*r*s - 28*D1**2*gdd2*r + 14*D1**2*gdd2*s**2 - 28*D1**2*gdd2*s + 14*D1**2*gdd2 - 168*D1*Dd*K*bd1*r**2 - 336*D1*Dd*K*bd1*r*s + 238*D1*Dd*K*bd1*r - 168*D1*Dd*K*bd1*s**2 + 238*D1*Dd*K*bd1*s - 84*D1*Dd*K*bd1 - 28*D1*Dd*K*f*r**2 - 56*D1*Dd*K*f*r*s + 42*D1*Dd*K*f*r - 28*D1*Dd*K*f*s**2 + 42*D1*Dd*K*f*s - 21*D1*Dd*K*f + 56*D1*Dd*b2*r**2 + 112*D1*Dd*b2*r*s - 84*D1*Dd*b2*r + 56*D1*Dd*b2*s**2 - 84*D1*Dd*b2*s + 42*D1*Dd*b2 - 48*D1*Dd*f*r**2 - 96*D1*Dd*f*r*s + 72*D1*Dd*f*r - 48*D1*Dd*f*s**2 + 72*D1*Dd*f*s - 36*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 84*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 84*D1*Dd*fd*s + 36*D1*Dd*fd - 112*D1*Dd*g2*r**2 - 224*D1*Dd*g2*r*s + 168*D1*Dd*g2*r - 112*D1*Dd*g2*s**2 + 168*D1*Dd*g2*s - 84*D1*Dd*g2 + 112*D1*Dd*gd2*r**2 + 224*D1*Dd*gd2*r*s - 196*D1*Dd*gd2*r + 112*D1*Dd*gd2*s**2 - 196*D1*Dd*gd2*s + 84*D1*Dd*gd2 - 28*D1*Ddd*b2*r**2 - 56*D1*Ddd*b2*r*s + 42*D1*Ddd*b2*r - 28*D1*Ddd*b2*s**2 + 42*D1*Ddd*b2*s - 21*D1*Ddd*b2 + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f + 56*D1*Ddd*g2*r**2 + 112*D1*Ddd*g2*r*s - 84*D1*Ddd*g2*r + 56*D1*Ddd*g2*s**2 - 84*D1*Ddd*g2*s + 42*D1*Ddd*g2 + 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 84*Dd**2*b2*r**2 - 168*Dd**2*b2*r*s + 126*Dd**2*b2*r - 84*Dd**2*b2*s**2 + 126*Dd**2*b2*s - 42*Dd**2*b2 + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f + 168*Dd**2*g2*r**2 + 336*Dd**2*g2*r*s - 252*Dd**2*g2*r + 168*Dd**2*g2*s**2 - 252*Dd**2*g2*s + 84*Dd**2*g2))/(21*d**2*k3**2) - 5*D1**2*Pk2*Pkdd3*ct*f**2*k1**7*st**2*(D1**2*(f*(33*fd - 49*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 294*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(33*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 98*fd*(4*r + 4*s - 3)**2) - 49*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 294*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(6006*d**2*k2*k3**6) + D1**2*Pk2*Pkdd3*ct*f**2*k1**5*k2*st**4*(D1**2*(-f*(727*fd - 500*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 3000*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(-727*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 1000*fd*(4*r + 4*s - 3)**2) + 500*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 3000*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(3003*d**2*k3**6) - 5*D1**2*Pk2*Pkdd3*ct*f**2*k1**3*k2**3*st**6*(D1**2*(f*(236*fd - 105*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 630*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(236*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 210*Dd*fd*(4*r + 4*s - 3)**2 - 105*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 630*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(18018*d**2*k3**6) - 5*D1**2*Pk2*Pkdd3*ct*f*k1**7*(-28*D1**2*bdd1*f**2*(r + s - 1)**2 + D1*bd1*f*(r + s - 1)*(23*D1*f*(r + s - 1) - 56*D1*fd*(3*r + 3*s - 2) - 56*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(f*(23*fd - 28*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 56*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(23*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 56*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 28*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 168*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k2*k3**6) + D1**2*Pk2*Pkdd3*ct*f*k1**3*k2**3*st**4*(-144*C*D1**2*f*fd*r**2 - 288*C*D1**2*f*fd*r*s + 192*C*D1**2*f*fd*r - 144*C*D1**2*f*fd*s**2 + 192*C*D1**2*f*fd*s - 96*C*D1**2*f*fd + 72*C*D1**2*f*fdd*r**2 + 144*C*D1**2*f*fdd*r*s - 96*C*D1**2*f*fdd*r + 72*C*D1**2*f*fdd*s**2 - 96*C*D1**2*f*fdd*s + 48*C*D1**2*f*fdd + 144*C*D1**2*fd**2*r**2 + 288*C*D1**2*fd**2*r*s - 192*C*D1**2*fd**2*r + 144*C*D1**2*fd**2*s**2 - 192*C*D1**2*fd**2*s + 48*C*D1**2*fd**2 - 192*C*D1*Dd*f**2*r**2 - 384*C*D1*Dd*f**2*r*s + 288*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 288*C*D1*Dd*f**2*s - 144*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r**2 + 1152*C*D1*Dd*f*fd*r*s - 816*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 816*C*D1*Dd*f*fd*s + 288*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r**2 + 192*C*D1*Ddd*f**2*r*s - 144*C*D1*Ddd*f**2*r + 96*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r**2 + 576*C*Dd**2*f**2*r*s - 432*C*Dd**2*f**2*r + 288*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 144*C*Dd**2*f**2 - 25*D1**2*bdd1*f**2*r**2 - 50*D1**2*bdd1*f**2*r*s + 50*D1**2*bdd1*f**2*r - 25*D1**2*bdd1*f**2*s**2 + 50*D1**2*bdd1*f**2*s - 25*D1**2*bdd1*f**2 + 60*D1**2*f**2*fd*r**2 + 120*D1**2*f**2*fd*r*s - 90*D1**2*f**2*fd*r + 60*D1**2*f**2*fd*s**2 - 90*D1**2*f**2*fd*s + 45*D1**2*f**2*fd + 108*D1**2*f*fd*r**2 + 216*D1**2*f*fd*r*s - 144*D1**2*f*fd*r + 108*D1**2*f*fd*s**2 - 144*D1**2*f*fd*s + 72*D1**2*f*fd - 54*D1**2*f*fdd*r**2 - 108*D1**2*f*fdd*r*s + 72*D1**2*f*fdd*r - 54*D1**2*f*fdd*s**2 + 72*D1**2*f*fdd*s - 36*D1**2*f*fdd + 132*D1**2*f*gd2*r**2 + 264*D1**2*f*gd2*r*s - 264*D1**2*f*gd2*r + 132*D1**2*f*gd2*s**2 - 264*D1**2*f*gd2*s + 132*D1**2*f*gd2 - 108*D1**2*fd**2*r**2 - 216*D1**2*fd**2*r*s + 144*D1**2*fd**2*r - 108*D1**2*fd**2*s**2 + 144*D1**2*fd**2*s - 36*D1**2*fd**2 + 264*D1**2*fd*g2*r**2 + 528*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*r + 264*D1**2*fd*g2*s**2 - 264*D1**2*fd*g2*s + 132*D1**2*fd*g2 + 60*D1*Dd*f**3*r**2 + 120*D1*Dd*f**3*r*s - 90*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 90*D1*Dd*f**3*s + 45*D1*Dd*f**3 + 144*D1*Dd*f**2*r**2 + 288*D1*Dd*f**2*r*s - 216*D1*Dd*f**2*r + 144*D1*Dd*f**2*s**2 - 216*D1*Dd*f**2*s + 108*D1*Dd*f**2 - 432*D1*Dd*f*fd*r**2 - 864*D1*Dd*f*fd*r*s + 612*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 612*D1*Dd*f*fd*s - 216*D1*Dd*f*fd + 528*D1*Dd*f*g2*r**2 + 1056*D1*Dd*f*g2*r*s - 792*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s**2 - 792*D1*Dd*f*g2*s + 396*D1*Dd*f*g2 - 72*D1*Ddd*f**2*r**2 - 144*D1*Ddd*f**2*r*s + 108*D1*Ddd*f**2*r - 72*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 54*D1*Ddd*f**2 + D1*bd1*f*(D1*(50*f*(r + s - 1) - 50*fd*(3*r + 3*s - 2) - (66*K - 33)*(r + s - 1)) - 50*Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 216*Dd**2*f**2*r**2 - 432*Dd**2*f**2*r*s + 324*Dd**2*f**2*r - 216*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 108*Dd**2*f**2 + b1*(-D1**2*(-50*f*fd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 25*f*fdd*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 50*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 33*fd*(2*K - 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + D1*f*(Dd*(50*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 50*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + (33 - 66*K)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 25*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 150*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*f*k1**3*k2*st**4*(15*D1**2*bdd1*f**2*r**2 + 30*D1**2*bdd1*f**2*r*s - 20*D1**2*bdd1*f**2*r + 15*D1**2*bdd1*f**2*s**2 - 20*D1**2*bdd1*f**2*s + 10*D1**2*bdd1*f**2 - 12*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 8*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s + 4*D1**2*f*fdd + 12*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 16*D1**2*fd**2*r + 12*D1**2*fd**2*s**2 - 16*D1**2*fd**2*s + 4*D1**2*fd**2 - 16*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 68*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 68*D1*Dd*f*fd*s + 24*D1*Dd*f*fd + 8*D1*Ddd*f**2*r**2 + 16*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 8*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + D1*bd1*f*(-10*D1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*(r + s - 1)*(10*fd*(9*r + 9*s - 4) - 11*r - 11*s + 11) + 10*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 24*Dd**2*f**2*r**2 + 48*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 24*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 12*Dd**2*f**2 + b1*(D1**2*(5*f*fdd*(9*r**2 + 2*r*(9*s - 7) + 9*s**2 - 14*s + 7) + 10*fd**2*(9*r**2 + 2*r*(9*s - 7) + 9*s**2 - 14*s + 5) - fd*(10*f*(9*r**2 + 2*r*(9*s - 7) + 9*s**2 - 14*s + 7) + 22*r**2 + 11*r*(4*s - 2) + 22*s**2 - 22*s + 11)) + D1*f*(-Dd*(30*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 10*fd*(36*r**2 + 72*r*s - 55*r + 36*s**2 - 55*s + 21) + 44*r**2 + 88*r*s - 66*r + 44*s**2 - 66*s + 33) + 15*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 90*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(77*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1**5*k2*st**2*(-204*C*D1**2*f**2*fd*r**2 - 408*C*D1**2*f**2*fd*r*s + 272*C*D1**2*f**2*fd*r - 204*C*D1**2*f**2*fd*s**2 + 272*C*D1**2*f**2*fd*s - 136*C*D1**2*f**2*fd + 300*C*D1**2*f**2*fdd*r**2 + 600*C*D1**2*f**2*fdd*r*s - 400*C*D1**2*f**2*fdd*r + 300*C*D1**2*f**2*fdd*s**2 - 400*C*D1**2*f**2*fdd*s + 200*C*D1**2*f**2*fdd + 600*C*D1**2*f*fd**2*r**2 + 1200*C*D1**2*f*fd**2*r*s - 800*C*D1**2*f*fd**2*r + 600*C*D1**2*f*fd**2*s**2 - 800*C*D1**2*f*fd**2*s + 200*C*D1**2*f*fd**2 - 272*C*D1*Dd*f**3*r**2 - 544*C*D1*Dd*f**3*r*s + 408*C*D1*Dd*f**3*r - 272*C*D1*Dd*f**3*s**2 + 408*C*D1*Dd*f**3*s - 204*C*D1*Dd*f**3 + 2400*C*D1*Dd*f**2*fd*r**2 + 4800*C*D1*Dd*f**2*fd*r*s - 3400*C*D1*Dd*f**2*fd*r + 2400*C*D1*Dd*f**2*fd*s**2 - 3400*C*D1*Dd*f**2*fd*s + 1200*C*D1*Dd*f**2*fd + 400*C*D1*Ddd*f**3*r**2 + 800*C*D1*Ddd*f**3*r*s - 600*C*D1*Ddd*f**3*r + 400*C*D1*Ddd*f**3*s**2 - 600*C*D1*Ddd*f**3*s + 300*C*D1*Ddd*f**3 + 1200*C*Dd**2*f**3*r**2 + 2400*C*Dd**2*f**3*r*s - 1800*C*Dd**2*f**3*r + 1200*C*Dd**2*f**3*s**2 - 1800*C*Dd**2*f**3*s + 600*C*Dd**2*f**3 - 132*D1**2*K*b1*f*fd*r**2 - 264*D1**2*K*b1*f*fd*r*s + 132*D1**2*K*b1*f*fd*r - 132*D1**2*K*b1*f*fd*s**2 + 132*D1**2*K*b1*f*fd*s - 66*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 132*D1**2*K*b1*f*fdd*s**2 - 132*D1**2*K*b1*f*fdd*s + 66*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 132*D1**2*K*b1*fd**2*s**2 - 132*D1**2*K*b1*fd**2*s - 1854*D1**2*b1*f**2*fd*r**2 - 3708*D1**2*b1*f**2*fd*r*s + 2472*D1**2*b1*f**2*fd*r - 1854*D1**2*b1*f**2*fd*s**2 + 2472*D1**2*b1*f**2*fd*s - 1236*D1**2*b1*f**2*fd + 1125*D1**2*b1*f**2*fdd*r**2 + 2250*D1**2*b1*f**2*fdd*r*s - 1500*D1**2*b1*f**2*fdd*r + 1125*D1**2*b1*f**2*fdd*s**2 - 1500*D1**2*b1*f**2*fdd*s + 750*D1**2*b1*f**2*fdd + 2250*D1**2*b1*f*fd**2*r**2 + 4500*D1**2*b1*f*fd**2*r*s - 3000*D1**2*b1*f*fd**2*r + 2250*D1**2*b1*f*fd**2*s**2 - 3000*D1**2*b1*f*fd**2*s + 750*D1**2*b1*f*fd**2 + 66*D1**2*b1*f*fd*r**2 + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r + 66*D1**2*b1*f*fd*s**2 - 66*D1**2*b1*f*fd*s + 33*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s + 3*D1**2*bdd1*f**2*(22*K + 125*f - 11)*(r + s - 1)**2 + 300*D1**2*f**3*fd*r**2 + 600*D1**2*f**3*fd*r*s - 450*D1**2*f**3*fd*r + 300*D1**2*f**3*fd*s**2 - 450*D1**2*f**3*fd*s + 225*D1**2*f**3*fd + 153*D1**2*f**2*fd*r**2 + 306*D1**2*f**2*fd*r*s - 204*D1**2*f**2*fd*r + 153*D1**2*f**2*fd*s**2 - 204*D1**2*f**2*fd*s + 102*D1**2*f**2*fd - 225*D1**2*f**2*fdd*r**2 - 450*D1**2*f**2*fdd*r*s + 300*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 300*D1**2*f**2*fdd*s - 150*D1**2*f**2*fdd + 132*D1**2*f**2*gd2*r**2 + 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*r + 132*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 450*D1**2*f*fd**2*r**2 - 900*D1**2*f*fd**2*r*s + 600*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 600*D1**2*f*fd**2*s - 150*D1**2*f*fd**2 + 264*D1**2*f*fd*g2*r**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 264*D1*Dd*K*b1*f**2*r**2 - 528*D1*Dd*K*b1*f**2*r*s + 396*D1*Dd*K*b1*f**2*r - 264*D1*Dd*K*b1*f**2*s**2 + 396*D1*Dd*K*b1*f**2*s - 198*D1*Dd*K*b1*f**2 + 1056*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1320*D1*Dd*K*b1*f*fd*r + 1056*D1*Dd*K*b1*f*fd*s**2 - 1320*D1*Dd*K*b1*f*fd*s + 396*D1*Dd*K*b1*f*fd - 2472*D1*Dd*b1*f**3*r**2 - 4944*D1*Dd*b1*f**3*r*s + 3708*D1*Dd*b1*f**3*r - 2472*D1*Dd*b1*f**3*s**2 + 3708*D1*Dd*b1*f**3*s - 1854*D1*Dd*b1*f**3 + 9000*D1*Dd*b1*f**2*fd*r**2 + 18000*D1*Dd*b1*f**2*fd*r*s - 12750*D1*Dd*b1*f**2*fd*r + 9000*D1*Dd*b1*f**2*fd*s**2 - 12750*D1*Dd*b1*f**2*fd*s + 4500*D1*Dd*b1*f**2*fd + 132*D1*Dd*b1*f**2*r**2 + 264*D1*Dd*b1*f**2*r*s - 198*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2*s**2 - 198*D1*Dd*b1*f**2*s + 99*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 300*D1*Dd*f**4*r**2 + 600*D1*Dd*f**4*r*s - 450*D1*Dd*f**4*r + 300*D1*Dd*f**4*s**2 - 450*D1*Dd*f**4*s + 225*D1*Dd*f**4 + 204*D1*Dd*f**3*r**2 + 408*D1*Dd*f**3*r*s - 306*D1*Dd*f**3*r + 204*D1*Dd*f**3*s**2 - 306*D1*Dd*f**3*s + 153*D1*Dd*f**3 - 1800*D1*Dd*f**2*fd*r**2 - 3600*D1*Dd*f**2*fd*r*s + 2550*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 2550*D1*Dd*f**2*fd*s - 900*D1*Dd*f**2*fd + 528*D1*Dd*f**2*g2*r**2 + 1056*D1*Dd*f**2*g2*r*s - 792*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 396*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r + 264*D1*Ddd*K*b1*f**2*s**2 - 396*D1*Ddd*K*b1*f**2*s + 198*D1*Ddd*K*b1*f**2 + 1500*D1*Ddd*b1*f**3*r**2 + 3000*D1*Ddd*b1*f**3*r*s - 2250*D1*Ddd*b1*f**3*r + 1500*D1*Ddd*b1*f**3*s**2 - 2250*D1*Ddd*b1*f**3*s + 1125*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 300*D1*Ddd*f**3*r**2 - 600*D1*Ddd*f**3*r*s + 450*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 450*D1*Ddd*f**3*s - 225*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 - 3*D1*bd1*f*(D1*(206*f**2*(r + s - 1) - 250*f*fd*(3*r + 3*s - 2) + 11*f*(2*K - 1)*(r + s - 1) - 22*fd*(2*K - 1)*(2*r + 2*s - 1)) - 2*Dd*f*(22*K + 125*f - 11)*(4*r + 4*s - 3))*(r + s - 1) + 792*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r + 792*Dd**2*K*b1*f**2*s**2 - 1188*Dd**2*K*b1*f**2*s + 396*Dd**2*K*b1*f**2 + 4500*Dd**2*b1*f**3*r**2 + 9000*Dd**2*b1*f**3*r*s - 6750*Dd**2*b1*f**3*r + 4500*Dd**2*b1*f**3*s**2 - 6750*Dd**2*b1*f**3*s + 2250*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 900*Dd**2*f**3*r**2 - 1800*Dd**2*f**3*r*s + 1350*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 1350*Dd**2*f**3*s - 450*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2)/(1386*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*k1**5*k2*(-D1*(r + s - 1)*(2*D1*bd1**2*f*(-12*K + 25*f + 6)*(r + s - 1) - D1*bdd1*f*(f*(20*C - 15) - 24*g2)*(r + s - 1) + bd1*(D1*(-5*f**3*(r + s - 1) + f**2*(16*C - 12)*(r + s - 1) - f*fd*(40*C - 30)*(2*r + 2*s - 1) - 4*f*(5*g2 - 12*gd2)*(r + s - 1) + 48*fd*g2*(r + s)) - 2*Dd*f*(f*(20*C - 15) - 24*g2)*(4*r + 4*s - 3))) + b1**2*(D1**2*(5*f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(50*fd**2*(r + s - 1) + 5*fd*(2*K - 1)*(r + s) - 6*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(20*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(10*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (2*K - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(-12*K + 25*f + 6)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(-12*K + 25*f + 6)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-32*C*D1**2*f*fd*r**2 - 64*C*D1**2*f*fd*r*s + 32*C*D1**2*f*fd*r - 32*C*D1**2*f*fd*s**2 + 32*C*D1**2*f*fd*s - 16*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r**2 + 80*C*D1**2*f*fdd*r*s - 40*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 40*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r**2 + 80*C*D1**2*fd**2*r*s - 40*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 40*C*D1**2*fd**2*s - 64*C*D1*Dd*f**2*r**2 - 128*C*D1*Dd*f**2*r*s + 96*C*D1*Dd*f**2*r - 64*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r**2 + 640*C*D1*Dd*f*fd*r*s - 400*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r**2 + 160*C*D1*Ddd*f**2*r*s - 120*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r**2 + 480*C*Dd**2*f**2*r*s - 360*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(-12*K + 25*f + 6)*(r + s - 1)**2 + 15*D1**2*f**2*fd*r**2 + 30*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 20*D1**2*f**2*fd*s + 10*D1**2*f**2*fd + 24*D1**2*f*fd*r**2 + 48*D1**2*f*fd*r*s - 24*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 12*D1**2*f*fd - 30*D1**2*f*fdd*r**2 - 60*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 20*D1**2*f*gd2*r**2 + 40*D1**2*f*gd2*r*s - 40*D1**2*f*gd2*r + 20*D1**2*f*gd2*s**2 - 40*D1**2*f*gd2*s + 20*D1**2*f*gd2 - 24*D1**2*f*gdd2*r**2 - 48*D1**2*f*gdd2*r*s + 48*D1**2*f*gdd2*r - 24*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s - 24*D1**2*f*gdd2 - 30*D1**2*fd**2*r**2 - 60*D1**2*fd**2*r*s + 30*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 30*D1**2*fd**2*s + 20*D1**2*fd*g2*r**2 + 40*D1**2*fd*g2*r*s + 20*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r**2 - 96*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 48*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r**2 - 48*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 + 20*D1*Dd*f**3*r**2 + 40*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 30*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 48*D1*Dd*f**2*r**2 + 96*D1*Dd*f**2*r*s - 72*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 36*D1*Dd*f**2 - 240*D1*Dd*f*fd*r**2 - 480*D1*Dd*f*fd*r*s + 300*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 300*D1*Dd*f*fd*s - 90*D1*Dd*f*fd + 80*D1*Dd*f*g2*r**2 + 160*D1*Dd*f*g2*r*s - 120*D1*Dd*f*g2*r + 80*D1*Dd*f*g2*s**2 - 120*D1*Dd*f*g2*s + 60*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r**2 - 384*D1*Dd*f*gd2*r*s + 336*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 336*D1*Dd*f*gd2*s - 144*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r**2 - 384*D1*Dd*fd*g2*r*s + 144*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s - 60*D1*Ddd*f**2*r**2 - 120*D1*Ddd*f**2*r*s + 90*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 90*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r**2 - 192*D1*Ddd*f*g2*r*s + 144*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(20*f**2*(r + s - 1) - 5*f*(10*fd*(2*r + 2*s - 1) + (2*K - 1)*(r + s - 1)) + 12*fd*(2*K - 1)*(r + s)) - 2*Dd*f*(-12*K + 25*f + 6)*(4*r + 4*s - 3))*(r + s - 1) - 180*Dd**2*f**2*r**2 - 360*Dd**2*f**2*r*s + 270*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 270*Dd**2*f**2*s - 90*Dd**2*f**2 - 288*Dd**2*f*g2*r**2 - 576*Dd**2*f*g2*r*s + 432*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(21*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*k1**5*st**2*(-306*D1**2*b1*f**2*fd*r**2 - 612*D1**2*b1*f**2*fd*r*s + 510*D1**2*b1*f**2*fd*r - 306*D1**2*b1*f**2*fd*s**2 + 510*D1**2*b1*f**2*fd*s - 255*D1**2*b1*f**2*fd + 450*D1**2*b1*f**2*fdd*r**2 + 900*D1**2*b1*f**2*fdd*r*s - 750*D1**2*b1*f**2*fdd*r + 450*D1**2*b1*f**2*fdd*s**2 - 750*D1**2*b1*f**2*fdd*s + 375*D1**2*b1*f**2*fdd + 900*D1**2*b1*f*fd**2*r**2 + 1800*D1**2*b1*f*fd**2*r*s - 1500*D1**2*b1*f*fd**2*r + 900*D1**2*b1*f*fd**2*s**2 - 1500*D1**2*b1*f*fd**2*s + 600*D1**2*b1*f*fd**2 - 66*D1**2*b1*f*fd*r**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r - 66*D1**2*b1*f*fd*s**2 + 66*D1**2*b1*f*fd*s - 33*D1**2*b1*f*fd + 66*D1**2*b1*f*fdd*r**2 + 132*D1**2*b1*f*fdd*r*s - 66*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s**2 - 66*D1**2*b1*f*fdd*s + 33*D1**2*b1*f*fdd + 66*D1**2*b1*fd**2*r**2 + 132*D1**2*b1*fd**2*r*s - 66*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s**2 - 66*D1**2*b1*fd**2*s + 3*D1**2*bdd1*f**2*(25*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 11*(r + s - 1)**2) - 51*D1**2*f**2*fd*r**2 - 102*D1**2*f**2*fd*r*s + 68*D1**2*f**2*fd*r - 51*D1**2*f**2*fd*s**2 + 68*D1**2*f**2*fd*s - 34*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 - 408*D1*Dd*b1*f**3*r**2 - 816*D1*Dd*b1*f**3*r*s + 612*D1*Dd*b1*f**3*r - 408*D1*Dd*b1*f**3*s**2 + 612*D1*Dd*b1*f**3*s - 306*D1*Dd*b1*f**3 + 3600*D1*Dd*b1*f**2*fd*r**2 + 7200*D1*Dd*b1*f**2*fd*r*s - 5700*D1*Dd*b1*f**2*fd*r + 3600*D1*Dd*b1*f**2*fd*s**2 - 5700*D1*Dd*b1*f**2*fd*s + 2250*D1*Dd*b1*f**2*fd - 132*D1*Dd*b1*f**2*r**2 - 264*D1*Dd*b1*f**2*r*s + 198*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s**2 + 198*D1*Dd*b1*f**2*s - 99*D1*Dd*b1*f**2 + 528*D1*Dd*b1*f*fd*r**2 + 1056*D1*Dd*b1*f*fd*r*s - 660*D1*Dd*b1*f*fd*r + 528*D1*Dd*b1*f*fd*s**2 - 660*D1*Dd*b1*f*fd*s + 198*D1*Dd*b1*f*fd - 68*D1*Dd*f**3*r**2 - 136*D1*Dd*f**3*r*s + 102*D1*Dd*f**3*r - 68*D1*Dd*f**3*s**2 + 102*D1*Dd*f**3*s - 51*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 850*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 850*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd + 600*D1*Ddd*b1*f**3*r**2 + 1200*D1*Ddd*b1*f**3*r*s - 900*D1*Ddd*b1*f**3*r + 600*D1*Ddd*b1*f**3*s**2 - 900*D1*Ddd*b1*f**3*s + 450*D1*Ddd*b1*f**3 + 132*D1*Ddd*b1*f**2*r**2 + 264*D1*Ddd*b1*f**2*r*s - 198*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s**2 - 198*D1*Ddd*b1*f**2*s + 99*D1*Ddd*b1*f**2 + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 - 3*D1*bd1*f*(D1*(17*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - f*(r + s - 1)*(100*fd*(3*r + 3*s - 1) - 11*r - 11*s + 11) - 22*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*f*(4*r + 4*s - 3)*(25*f*(2*r + 2*s - 1) + 11*r + 11*s - 11)) + 1800*Dd**2*b1*f**3*r**2 + 3600*Dd**2*b1*f**3*r*s - 2700*Dd**2*b1*f**3*r + 1800*Dd**2*b1*f**3*s**2 - 2700*Dd**2*b1*f**3*s + 900*Dd**2*b1*f**3 + 396*Dd**2*b1*f**2*r**2 + 792*Dd**2*b1*f**2*r*s - 594*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s**2 - 594*Dd**2*b1*f**2*s + 198*Dd**2*b1*f**2 + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3)/(1386*d**2*k2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1**5*(D1*f*(r + s - 1)*(2*D1*bd1**2*(5*f*(2*r + 2*s - 1) + 6*r + 6*s - 6) + 5*D1*bdd1*f*(r + s - 1) + bd1*(-4*D1*f*(r + s - 1) + 10*D1*fd*(2*r + 2*s - 1) + 10*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(-f*(4*fd - 5*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 10*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 5*fd*(r + s)**2 + 6*fdd*(r + s)**2) + D1*(Dd*(-8*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 5*f*(2*fd*(4*r + 4*s - 3)**2 - 4*r**2 - 8*r*s + 6*r - 4*s**2 + 6*s - 3) + 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 2*Ddd*f*(5*f + 3)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*Dd**2*f*(5*f + 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*bdd1*f*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 12*(r + s - 1)**2) - 8*D1**2*f*fd*r**2 - 16*D1**2*f*fd*r*s + 8*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + 8*D1**2*f*fd*s - 4*D1**2*f*fd + 10*D1**2*f*fdd*r**2 + 20*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*r**2 + 20*D1**2*fd**2*r*s - 10*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s - 16*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 80*D1*Dd*f*fd*r**2 + 160*D1*Dd*f*fd*r*s - 100*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 100*D1*Dd*f*fd*s + 30*D1*Dd*f*fd + 20*D1*Ddd*f**2*r**2 + 40*D1*Ddd*f**2*r*s - 30*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 30*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 - 2*D1*bd1*(D1*(2*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*f*(r + s - 1)*(fd*(8*r + 8*s - 4) - r - s + 1) - 12*fd*(r**2 + r*(2*s - 1) + s*(s - 1))) - Dd*f*(4*r + 4*s - 3)*(5*f*(4*r + 4*s - 3) + 12*r + 12*s - 12)) + 60*Dd**2*f**2*r**2 + 120*Dd**2*f**2*r*s - 90*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 90*Dd**2*f**2*s + 30*Dd**2*f**2))/(21*d**2*k2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1**3*k2**3*st**2*(264*C*D1**2*bdd1*f**2*r**2 + 528*C*D1**2*bdd1*f**2*r*s - 528*C*D1**2*bdd1*f**2*r + 264*C*D1**2*bdd1*f**2*s**2 - 528*C*D1**2*bdd1*f**2*s + 264*C*D1**2*bdd1*f**2 - 540*C*D1**2*f**2*fd*r**2 - 1080*C*D1**2*f**2*fd*r*s + 720*C*D1**2*f**2*fd*r - 540*C*D1**2*f**2*fd*s**2 + 720*C*D1**2*f**2*fd*s - 360*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r**2 + 1200*C*D1**2*f**2*fdd*r*s - 800*C*D1**2*f**2*fdd*r + 600*C*D1**2*f**2*fdd*s**2 - 800*C*D1**2*f**2*fdd*s + 400*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r**2 + 2400*C*D1**2*f*fd**2*r*s - 1600*C*D1**2*f*fd**2*r + 1200*C*D1**2*f*fd**2*s**2 - 1600*C*D1**2*f*fd**2*s + 400*C*D1**2*f*fd**2 - 720*C*D1*Dd*f**3*r**2 - 1440*C*D1*Dd*f**3*r*s + 1080*C*D1*Dd*f**3*r - 720*C*D1*Dd*f**3*s**2 + 1080*C*D1*Dd*f**3*s - 540*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r**2 + 9600*C*D1*Dd*f**2*fd*r*s - 6800*C*D1*Dd*f**2*fd*r + 4800*C*D1*Dd*f**2*fd*s**2 - 6800*C*D1*Dd*f**2*fd*s + 2400*C*D1*Dd*f**2*fd + 800*C*D1*Ddd*f**3*r**2 + 1600*C*D1*Ddd*f**3*r*s - 1200*C*D1*Ddd*f**3*r + 800*C*D1*Ddd*f**3*s**2 - 1200*C*D1*Ddd*f**3*s + 600*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r**2 + 4800*C*Dd**2*f**3*r*s - 3600*C*Dd**2*f**3*r + 2400*C*Dd**2*f**3*s**2 - 3600*C*Dd**2*f**3*s + 1200*C*Dd**2*f**3 + 132*D1**2*K*bdd1*f**2*r**2 + 264*D1**2*K*bdd1*f**2*r*s - 264*D1**2*K*bdd1*f**2*r + 132*D1**2*K*bdd1*f**2*s**2 - 264*D1**2*K*bdd1*f**2*s + 132*D1**2*K*bdd1*f**2 - 132*D1**2*bd1**2*f*(-2*K + 5*f + 1)*(r + s - 1)**2 - 198*D1**2*bdd1*f**2*r**2 - 396*D1**2*bdd1*f**2*r*s + 396*D1**2*bdd1*f**2*r - 198*D1**2*bdd1*f**2*s**2 + 396*D1**2*bdd1*f**2*s - 198*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r**2 - 528*D1**2*bdd1*f*g2*r*s + 528*D1**2*bdd1*f*g2*r - 264*D1**2*bdd1*f*g2*s**2 + 528*D1**2*bdd1*f*g2*s - 264*D1**2*bdd1*f*g2 + 237*D1**2*f**2*fd*r**2 + 474*D1**2*f**2*fd*r*s - 316*D1**2*f**2*fd*r + 237*D1**2*f**2*fd*s**2 - 316*D1**2*f**2*fd*s + 158*D1**2*f**2*fd - 300*D1**2*f**2*fdd*r**2 - 600*D1**2*f**2*fdd*r*s + 400*D1**2*f**2*fdd*r - 300*D1**2*f**2*fdd*s**2 + 400*D1**2*f**2*fdd*s - 200*D1**2*f**2*fdd + 308*D1**2*f**2*gd2*r**2 + 616*D1**2*f**2*gd2*r*s - 616*D1**2*f**2*gd2*r + 308*D1**2*f**2*gd2*s**2 - 616*D1**2*f**2*gd2*s + 308*D1**2*f**2*gd2 - 264*D1**2*f**2*gdd2*r**2 - 528*D1**2*f**2*gdd2*r*s + 528*D1**2*f**2*gdd2*r - 264*D1**2*f**2*gdd2*s**2 + 528*D1**2*f**2*gdd2*s - 264*D1**2*f**2*gdd2 - 600*D1**2*f*fd**2*r**2 - 1200*D1**2*f*fd**2*r*s + 800*D1**2*f*fd**2*r - 600*D1**2*f*fd**2*s**2 + 800*D1**2*f*fd**2*s - 200*D1**2*f*fd**2 + 616*D1**2*f*fd*g2*r**2 + 1232*D1**2*f*fd*g2*r*s - 616*D1**2*f*fd*g2*r + 616*D1**2*f*fd*g2*s**2 - 616*D1**2*f*fd*g2*s + 308*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r**2 - 2112*D1**2*f*fd*gd2*r*s + 1584*D1**2*f*fd*gd2*r - 1056*D1**2*f*fd*gd2*s**2 + 1584*D1**2*f*fd*gd2*s - 528*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r**2 - 1056*D1**2*f*fdd*g2*r*s + 528*D1**2*f*fdd*g2*r - 528*D1**2*f*fdd*g2*s**2 + 528*D1**2*f*fdd*g2*s - 264*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r**2 - 1056*D1**2*fd**2*g2*r*s + 528*D1**2*fd**2*g2*r - 528*D1**2*fd**2*g2*s**2 + 528*D1**2*fd**2*g2*s + 316*D1*Dd*f**3*r**2 + 632*D1*Dd*f**3*r*s - 474*D1*Dd*f**3*r + 316*D1*Dd*f**3*s**2 - 474*D1*Dd*f**3*s + 237*D1*Dd*f**3 - 2400*D1*Dd*f**2*fd*r**2 - 4800*D1*Dd*f**2*fd*r*s + 3400*D1*Dd*f**2*fd*r - 2400*D1*Dd*f**2*fd*s**2 + 3400*D1*Dd*f**2*fd*s - 1200*D1*Dd*f**2*fd + 1232*D1*Dd*f**2*g2*r**2 + 2464*D1*Dd*f**2*g2*r*s - 1848*D1*Dd*f**2*g2*r + 1232*D1*Dd*f**2*g2*s**2 - 1848*D1*Dd*f**2*g2*s + 924*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r**2 - 4224*D1*Dd*f**2*gd2*r*s + 3696*D1*Dd*f**2*gd2*r - 2112*D1*Dd*f**2*gd2*s**2 + 3696*D1*Dd*f**2*gd2*s - 1584*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r**2 - 8448*D1*Dd*f*fd*g2*r*s + 5280*D1*Dd*f*fd*g2*r - 4224*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1584*D1*Dd*f*fd*g2 - 400*D1*Ddd*f**3*r**2 - 800*D1*Ddd*f**3*r*s + 600*D1*Ddd*f**3*r - 400*D1*Ddd*f**3*s**2 + 600*D1*Ddd*f**3*s - 300*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r**2 - 2112*D1*Ddd*f**2*g2*r*s + 1584*D1*Ddd*f**2*g2*r - 1056*D1*Ddd*f**2*g2*s**2 + 1584*D1*Ddd*f**2*g2*s - 792*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(f**2*(22*C + 7*K - 16)*(r + s - 1) - 2*f*(3*fd*(4*C + 2*K - 3)*(2*r + 2*s - 1) + (19*g2 - 12*gd2)*(r + s - 1)) + 24*fd*g2*(r + s)) - 6*Dd*f*(f*(4*C + 2*K - 3) - 4*g2)*(4*r + 4*s - 3))*(r + s - 1) - 1200*Dd**2*f**3*r**2 - 2400*Dd**2*f**3*r*s + 1800*Dd**2*f**3*r - 1200*Dd**2*f**3*s**2 + 1800*Dd**2*f**3*s - 600*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r**2 - 6336*Dd**2*f**2*g2*r*s + 4752*Dd**2*f**2*g2*r - 3168*Dd**2*f**2*g2*s**2 + 4752*Dd**2*f**2*g2*s - 1584*Dd**2*f**2*g2 + 11*b1**2*(D1**2*(3*f*(17*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - (r + s)*(60*fd**2*(r + s - 1) + 19*fd*(2*K - 1)*(r + s) - 6*fdd*(2*K - 1)*(r + s))) + D1*(Dd*(51*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - f*(60*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (38*K - 19)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 12*fd*(2*K - 1)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(-2*K + 5*f + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(-2*K + 5*f + 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 22*b1*(-44*C*D1**2*f*fd*r**2 - 88*C*D1**2*f*fd*r*s + 44*C*D1**2*f*fd*r - 44*C*D1**2*f*fd*s**2 + 44*C*D1**2*f*fd*s - 22*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r**2 + 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 24*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r**2 + 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 24*C*D1**2*fd**2*s - 88*C*D1*Dd*f**2*r**2 - 176*C*D1*Dd*f**2*r*s + 132*C*D1*Dd*f**2*r - 88*C*D1*Dd*f**2*s**2 + 132*C*D1*Dd*f**2*s - 66*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 72*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r**2 + 96*C*D1*Ddd*f**2*r*s - 72*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r**2 + 288*C*Dd**2*f**2*r*s - 216*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 14*D1**2*K*f*fd*r**2 - 28*D1**2*K*f*fd*r*s + 14*D1**2*K*f*fd*r - 14*D1**2*K*f*fd*s**2 + 14*D1**2*K*f*fd*s - 7*D1**2*K*f*fd + 12*D1**2*K*f*fdd*r**2 + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 12*D1**2*K*f*fdd*s**2 - 12*D1**2*K*f*fdd*s + 6*D1**2*K*f*fdd + 12*D1**2*K*fd**2*r**2 + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 12*D1**2*K*fd**2*s**2 - 12*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(-2*K + 5*f + 1)*(r + s - 1)**2 + 32*D1**2*f*fd*r**2 + 64*D1**2*f*fd*r*s - 32*D1**2*f*fd*r + 32*D1**2*f*fd*s**2 - 32*D1**2*f*fd*s + 16*D1**2*f*fd - 18*D1**2*f*fdd*r**2 - 36*D1**2*f*fdd*r*s + 18*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd + 38*D1**2*f*gd2*r**2 + 76*D1**2*f*gd2*r*s - 76*D1**2*f*gd2*r + 38*D1**2*f*gd2*s**2 - 76*D1**2*f*gd2*s + 38*D1**2*f*gd2 - 12*D1**2*f*gdd2*r**2 - 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*r - 12*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 12*D1**2*f*gdd2 - 18*D1**2*fd**2*r**2 - 36*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s + 38*D1**2*fd*g2*r**2 + 76*D1**2*fd*g2*r*s + 38*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r**2 - 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 24*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r**2 - 24*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 28*D1*Dd*K*f**2*r**2 - 56*D1*Dd*K*f**2*r*s + 42*D1*Dd*K*f**2*r - 28*D1*Dd*K*f**2*s**2 + 42*D1*Dd*K*f**2*s - 21*D1*Dd*K*f**2 + 96*D1*Dd*K*f*fd*r**2 + 192*D1*Dd*K*f*fd*r*s - 120*D1*Dd*K*f*fd*r + 96*D1*Dd*K*f*fd*s**2 - 120*D1*Dd*K*f*fd*s + 36*D1*Dd*K*f*fd + 64*D1*Dd*f**2*r**2 + 128*D1*Dd*f**2*r*s - 96*D1*Dd*f**2*r + 64*D1*Dd*f**2*s**2 - 96*D1*Dd*f**2*s + 48*D1*Dd*f**2 - 144*D1*Dd*f*fd*r**2 - 288*D1*Dd*f*fd*r*s + 180*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 54*D1*Dd*f*fd + 152*D1*Dd*f*g2*r**2 + 304*D1*Dd*f*g2*r*s - 228*D1*Dd*f*g2*r + 152*D1*Dd*f*g2*s**2 - 228*D1*Dd*f*g2*s + 114*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r**2 - 192*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 168*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r**2 - 192*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 72*D1*Dd*fd*g2*s + 24*D1*Ddd*K*f**2*r**2 + 48*D1*Ddd*K*f**2*r*s - 36*D1*Ddd*K*f**2*r + 24*D1*Ddd*K*f**2*s**2 - 36*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r**2 - 72*D1*Ddd*f**2*r*s + 54*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 54*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r**2 - 96*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 72*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + D1*bd1*(D1*(51*f**2*(r + s - 1) - 60*f*fd*(2*r + 2*s - 1) - 19*f*(2*K - 1)*(r + s - 1) + 12*fd*(2*K - 1)*(r + s)) - 12*Dd*f*(-2*K + 5*f + 1)*(4*r + 4*s - 3))*(r + s - 1) + 72*Dd**2*K*f**2*r**2 + 144*Dd**2*K*f**2*r*s - 108*Dd**2*K*f**2*r + 72*Dd**2*K*f**2*s**2 - 108*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 - 108*Dd**2*f**2*r**2 - 216*Dd**2*f**2*r*s + 162*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 162*Dd**2*f**2*s - 54*Dd**2*f**2 - 144*Dd**2*f*g2*r**2 - 288*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 216*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(462*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct*k1**3*k2**3*(-2*D1*(r + s - 1)*(24*D1*K*bd1**2*f*(r + s - 1) - D1*bd1*(f**2*(4*C + 1)*(r + s - 1) - f*fd*(40*C - 20)*(2*r + 2*s - 1) - 6*f*(g2 - 8*gd2)*(r + s - 1) + 48*fd*g2*(r + s)) + 2*D1*bdd1*f*(f*(10*C - 5) - 12*g2)*(r + s - 1) + 4*Dd*bd1*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3)) + b1**2*(D1**2*(18*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-24*K*fdd + fd*(6*K + 7))) + D1*(Dd*(-48*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 18*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(6*K + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 144*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*b1*(D1**2*(f*(fd*(4*C + 1)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*(r + s - 1)**2*(12*K*bdd1 + 3*gd2 - 12*gdd2)) + (-2*r - 2*s)*(fd**2*(20*C - 10)*(r + s - 1) + 3*fd*(g2*(r + s) - 8*gd2*(r + s - 1)) - 12*fdd*g2*(r + s))) + D1*bd1*(D1*(-48*K*fd*(r + s) + 18*f**2*(r + s - 1) + f*(6*K + 7)*(r + s - 1)) - 48*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(4*C + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 2*f*(fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 3*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 24*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 48*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 2*Ddd*f*(f*(10*C - 5) - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*f*(f*(10*C - 5) - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*k1**3*k2*st**2*(44*C*D1**2*bdd1*f**2*r**2 + 88*C*D1**2*bdd1*f**2*r*s + 44*C*D1**2*bdd1*f**2*s**2 + 672*C*D1**2*f**2*fd*r**2 + 1344*C*D1**2*f**2*fd*r*s - 896*C*D1**2*f**2*fd*r + 672*C*D1**2*f**2*fd*s**2 - 896*C*D1**2*f**2*fd*s + 448*C*D1**2*f**2*fd - 600*C*D1**2*f**2*fdd*r**2 - 1200*C*D1**2*f**2*fdd*r*s + 800*C*D1**2*f**2*fdd*r - 600*C*D1**2*f**2*fdd*s**2 + 800*C*D1**2*f**2*fdd*s - 400*C*D1**2*f**2*fdd - 1200*C*D1**2*f*fd**2*r**2 - 2400*C*D1**2*f*fd**2*r*s + 1600*C*D1**2*f*fd**2*r - 1200*C*D1**2*f*fd**2*s**2 + 1600*C*D1**2*f*fd**2*s - 400*C*D1**2*f*fd**2 + 896*C*D1*Dd*f**3*r**2 + 1792*C*D1*Dd*f**3*r*s - 1344*C*D1*Dd*f**3*r + 896*C*D1*Dd*f**3*s**2 - 1344*C*D1*Dd*f**3*s + 672*C*D1*Dd*f**3 - 4800*C*D1*Dd*f**2*fd*r**2 - 9600*C*D1*Dd*f**2*fd*r*s + 6800*C*D1*Dd*f**2*fd*r - 4800*C*D1*Dd*f**2*fd*s**2 + 6800*C*D1*Dd*f**2*fd*s - 2400*C*D1*Dd*f**2*fd - 800*C*D1*Ddd*f**3*r**2 - 1600*C*D1*Ddd*f**3*r*s + 1200*C*D1*Ddd*f**3*r - 800*C*D1*Ddd*f**3*s**2 + 1200*C*D1*Ddd*f**3*s - 600*C*D1*Ddd*f**3 - 2400*C*Dd**2*f**3*r**2 - 4800*C*Dd**2*f**3*r*s + 3600*C*Dd**2*f**3*r - 2400*C*Dd**2*f**3*s**2 + 3600*C*Dd**2*f**3*s - 1200*C*Dd**2*f**3 - 132*D1**2*K*bdd1*f**2*r**2 - 264*D1**2*K*bdd1*f**2*r*s + 264*D1**2*K*bdd1*f**2*r - 132*D1**2*K*bdd1*f**2*s**2 + 264*D1**2*K*bdd1*f**2*s - 132*D1**2*K*bdd1*f**2 + 352*D1**2*b2*f*fd*r**2 + 704*D1**2*b2*f*fd*r*s - 352*D1**2*b2*f*fd*r + 352*D1**2*b2*f*fd*s**2 - 352*D1**2*b2*f*fd*s + 176*D1**2*b2*f*fd - 264*D1**2*b2*f*fdd*r**2 - 528*D1**2*b2*f*fdd*r*s + 264*D1**2*b2*f*fdd*r - 264*D1**2*b2*f*fdd*s**2 + 264*D1**2*b2*f*fdd*s - 132*D1**2*b2*f*fdd - 264*D1**2*b2*fd**2*r**2 - 528*D1**2*b2*fd**2*r*s + 264*D1**2*b2*fd**2*r - 264*D1**2*b2*fd**2*s**2 + 264*D1**2*b2*fd**2*s + 22*D1**2*bd1**2*f*(r + s - 1)*(2*K*s + 18*f*(r + s - 1) + r*(2*K + 5) + 5*s - 6) + 176*D1**2*bd2*f**2*r**2 + 352*D1**2*bd2*f**2*r*s - 352*D1**2*bd2*f**2*r + 176*D1**2*bd2*f**2*s**2 - 352*D1**2*bd2*f**2*s + 176*D1**2*bd2*f**2 - 528*D1**2*bd2*f*fd*r**2 - 1056*D1**2*bd2*f*fd*r*s + 792*D1**2*bd2*f*fd*r - 528*D1**2*bd2*f*fd*s**2 + 792*D1**2*bd2*f*fd*s - 264*D1**2*bd2*f*fd + 33*D1**2*bdd1*f**2*r**2 + 66*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*r + 33*D1**2*bdd1*f**2*s**2 - 132*D1**2*bdd1*f**2*s + 66*D1**2*bdd1*f**2 - 44*D1**2*bdd1*f*g2*r**2 - 88*D1**2*bdd1*f*g2*r*s - 44*D1**2*bdd1*f*g2*s**2 - 132*D1**2*bdd2*f**2*r**2 - 264*D1**2*bdd2*f**2*r*s + 264*D1**2*bdd2*f**2*r - 132*D1**2*bdd2*f**2*s**2 + 264*D1**2*bdd2*f**2*s - 132*D1**2*bdd2*f**2 - 303*D1**2*f**2*fd*r**2 - 606*D1**2*f**2*fd*r*s + 404*D1**2*f**2*fd*r - 303*D1**2*f**2*fd*s**2 + 404*D1**2*f**2*fd*s - 202*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r**2 + 600*D1**2*f**2*fdd*r*s - 400*D1**2*f**2*fdd*r + 300*D1**2*f**2*fdd*s**2 - 400*D1**2*f**2*fdd*s + 200*D1**2*f**2*fdd - 352*D1**2*f**2*gd2*r**2 - 704*D1**2*f**2*gd2*r*s + 704*D1**2*f**2*gd2*r - 352*D1**2*f**2*gd2*s**2 + 704*D1**2*f**2*gd2*s - 352*D1**2*f**2*gd2 + 264*D1**2*f**2*gdd2*r**2 + 528*D1**2*f**2*gdd2*r*s - 528*D1**2*f**2*gdd2*r + 264*D1**2*f**2*gdd2*s**2 - 528*D1**2*f**2*gdd2*s + 264*D1**2*f**2*gdd2 + 600*D1**2*f*fd**2*r**2 + 1200*D1**2*f*fd**2*r*s - 800*D1**2*f*fd**2*r + 600*D1**2*f*fd**2*s**2 - 800*D1**2*f*fd**2*s + 200*D1**2*f*fd**2 - 704*D1**2*f*fd*g2*r**2 - 1408*D1**2*f*fd*g2*r*s + 704*D1**2*f*fd*g2*r - 704*D1**2*f*fd*g2*s**2 + 704*D1**2*f*fd*g2*s - 352*D1**2*f*fd*g2 + 1056*D1**2*f*fd*gd2*r**2 + 2112*D1**2*f*fd*gd2*r*s - 1584*D1**2*f*fd*gd2*r + 1056*D1**2*f*fd*gd2*s**2 - 1584*D1**2*f*fd*gd2*s + 528*D1**2*f*fd*gd2 + 528*D1**2*f*fdd*g2*r**2 + 1056*D1**2*f*fdd*g2*r*s - 528*D1**2*f*fdd*g2*r + 528*D1**2*f*fdd*g2*s**2 - 528*D1**2*f*fdd*g2*s + 264*D1**2*f*fdd*g2 + 528*D1**2*fd**2*g2*r**2 + 1056*D1**2*fd**2*g2*r*s - 528*D1**2*fd**2*g2*r + 528*D1**2*fd**2*g2*s**2 - 528*D1**2*fd**2*g2*s + 704*D1*Dd*b2*f**2*r**2 + 1408*D1*Dd*b2*f**2*r*s - 1056*D1*Dd*b2*f**2*r + 704*D1*Dd*b2*f**2*s**2 - 1056*D1*Dd*b2*f**2*s + 528*D1*Dd*b2*f**2 - 2112*D1*Dd*b2*f*fd*r**2 - 4224*D1*Dd*b2*f*fd*r*s + 2640*D1*Dd*b2*f*fd*r - 2112*D1*Dd*b2*f*fd*s**2 + 2640*D1*Dd*b2*f*fd*s - 792*D1*Dd*b2*f*fd - 1056*D1*Dd*bd2*f**2*r**2 - 2112*D1*Dd*bd2*f**2*r*s + 1848*D1*Dd*bd2*f**2*r - 1056*D1*Dd*bd2*f**2*s**2 + 1848*D1*Dd*bd2*f**2*s - 792*D1*Dd*bd2*f**2 - 404*D1*Dd*f**3*r**2 - 808*D1*Dd*f**3*r*s + 606*D1*Dd*f**3*r - 404*D1*Dd*f**3*s**2 + 606*D1*Dd*f**3*s - 303*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r**2 + 4800*D1*Dd*f**2*fd*r*s - 3400*D1*Dd*f**2*fd*r + 2400*D1*Dd*f**2*fd*s**2 - 3400*D1*Dd*f**2*fd*s + 1200*D1*Dd*f**2*fd - 1408*D1*Dd*f**2*g2*r**2 - 2816*D1*Dd*f**2*g2*r*s + 2112*D1*Dd*f**2*g2*r - 1408*D1*Dd*f**2*g2*s**2 + 2112*D1*Dd*f**2*g2*s - 1056*D1*Dd*f**2*g2 + 2112*D1*Dd*f**2*gd2*r**2 + 4224*D1*Dd*f**2*gd2*r*s - 3696*D1*Dd*f**2*gd2*r + 2112*D1*Dd*f**2*gd2*s**2 - 3696*D1*Dd*f**2*gd2*s + 1584*D1*Dd*f**2*gd2 + 4224*D1*Dd*f*fd*g2*r**2 + 8448*D1*Dd*f*fd*g2*r*s - 5280*D1*Dd*f*fd*g2*r + 4224*D1*Dd*f*fd*g2*s**2 - 5280*D1*Dd*f*fd*g2*s + 1584*D1*Dd*f*fd*g2 - 528*D1*Ddd*b2*f**2*r**2 - 1056*D1*Ddd*b2*f**2*r*s + 792*D1*Ddd*b2*f**2*r - 528*D1*Ddd*b2*f**2*s**2 + 792*D1*Ddd*b2*f**2*s - 396*D1*Ddd*b2*f**2 + 400*D1*Ddd*f**3*r**2 + 800*D1*Ddd*f**3*r*s - 600*D1*Ddd*f**3*r + 400*D1*Ddd*f**3*s**2 - 600*D1*Ddd*f**3*s + 300*D1*Ddd*f**3 + 1056*D1*Ddd*f**2*g2*r**2 + 2112*D1*Ddd*f**2*g2*r*s - 1584*D1*Ddd*f**2*g2*r + 1056*D1*Ddd*f**2*g2*s**2 - 1584*D1*Ddd*f**2*g2*s + 792*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(3*f**3*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f**2*(-4*C*s**2 + 16*K*(r + s - 1)**2 - r**2*(4*C + 7) - 2*r*(4*C*s + 7*s - 10) - 7*s**2 + 20*s - 10) - 4*f*(fd*(r + s - 1)*(-4*C*s + 6*K*(2*r + 2*s - 1) - r*(4*C + 3) - 3*s + 3) + (r + s)*(-9*g2*(r + s) + 2*gd2*(r + s - 1))) - 8*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 2*Dd*f*(f*(-4*C*r - 4*C*s + 12*K*(r + s - 1) - 3*r - 3*s + 6) + 4*g2*(r + s))*(4*r + 4*s - 3)) - 1584*Dd**2*b2*f**2*r**2 - 3168*Dd**2*b2*f**2*r*s + 2376*Dd**2*b2*f**2*r - 1584*Dd**2*b2*f**2*s**2 + 2376*Dd**2*b2*f**2*s - 792*Dd**2*b2*f**2 + 1200*Dd**2*f**3*r**2 + 2400*Dd**2*f**3*r*s - 1800*Dd**2*f**3*r + 1200*Dd**2*f**3*s**2 - 1800*Dd**2*f**3*s + 600*Dd**2*f**3 + 3168*Dd**2*f**2*g2*r**2 + 6336*Dd**2*f**2*g2*r*s - 4752*Dd**2*f**2*g2*r + 3168*Dd**2*f**2*g2*s**2 - 4752*Dd**2*f**2*g2*s + 1584*Dd**2*f**2*g2 - 11*b1**2*(D1**2*(-36*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1)) + fd*(18*K*(r + s - 1)**2 + f*(64*r**2 + 2*r*(64*s - 35) + 64*s**2 - 70*s + 35) + 10*r**2 + 20*r*s + 18*r + 10*s**2 + 18*s - 9) - fdd*(2*K*(r + s - 1)**2 + 18*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 5*r**2 + 10*r*s + 2*r + 5*s**2 + 2*s - 1)) + D1*(2*Dd*(16*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-18*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + (9*K + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - fd*(4*r + 4*s - 3)*(2*K*(r + s - 1) + 5*r + 5*s + 1)) - Ddd*f*(2*K + 18*f + 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*K + 18*f + 5)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 11*b1*(8*C*D1**2*f*fd*r**2 + 16*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 16*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 8*C*D1**2*f*fdd*r**2 - 16*C*D1**2*f*fdd*r*s + 16*C*D1**2*f*fdd*r - 8*C*D1**2*f*fdd*s**2 + 16*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd - 8*C*D1**2*fd**2*r**2 - 16*C*D1**2*fd**2*r*s + 16*C*D1**2*fd**2*r - 8*C*D1**2*fd**2*s**2 + 16*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 + 16*C*D1*Dd*f**2*r**2 + 32*C*D1*Dd*f**2*r*s - 24*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 24*C*D1*Dd*f**2*s + 12*C*D1*Dd*f**2 - 64*C*D1*Dd*f*fd*r**2 - 128*C*D1*Dd*f*fd*r*s + 112*C*D1*Dd*f*fd*r - 64*C*D1*Dd*f*fd*s**2 + 112*C*D1*Dd*f*fd*s - 48*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 - 32*C*D1*Ddd*f**2*r*s + 24*C*D1*Ddd*f**2*r - 16*C*D1*Ddd*f**2*s**2 + 24*C*D1*Ddd*f**2*s - 12*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 - 96*C*Dd**2*f**2*r*s + 72*C*Dd**2*f**2*r - 48*C*Dd**2*f**2*s**2 + 72*C*Dd**2*f**2*s - 24*C*Dd**2*f**2 - 32*D1**2*K*f*fd*r**2 - 64*D1**2*K*f*fd*r*s + 32*D1**2*K*f*fd*r - 32*D1**2*K*f*fd*s**2 + 32*D1**2*K*f*fd*s - 16*D1**2*K*f*fd + 24*D1**2*K*f*fdd*r**2 + 48*D1**2*K*f*fdd*r*s - 24*D1**2*K*f*fdd*r + 24*D1**2*K*f*fdd*s**2 - 24*D1**2*K*f*fdd*s + 12*D1**2*K*f*fdd + 24*D1**2*K*fd**2*r**2 + 48*D1**2*K*fd**2*r*s - 24*D1**2*K*fd**2*r + 24*D1**2*K*fd**2*s**2 - 24*D1**2*K*fd**2*s - D1**2*bdd1*f*(K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) + 36*f*(r + s - 1)**2 + 10*r**2 + 20*r*s - 22*r + 10*s**2 - 22*s + 11) - 18*D1**2*f**2*fd*r**2 - 36*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 30*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 14*D1**2*f*fd*r**2 + 28*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 14*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 6*D1**2*f*fdd*r**2 - 12*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*s**2 - 36*D1**2*f*gd2*r**2 - 72*D1**2*f*gd2*r*s + 72*D1**2*f*gd2*r - 36*D1**2*f*gd2*s**2 + 72*D1**2*f*gd2*s - 36*D1**2*f*gd2 + 4*D1**2*f*gdd2*r**2 + 8*D1**2*f*gdd2*r*s - 8*D1**2*f*gdd2*r + 4*D1**2*f*gdd2*s**2 - 8*D1**2*f*gdd2*s + 4*D1**2*f*gdd2 - 6*D1**2*fd**2*r**2 - 12*D1**2*fd**2*r*s - 6*D1**2*fd**2*s**2 + 6*D1**2*fd**2 - 36*D1**2*fd*g2*r**2 - 72*D1**2*fd*g2*r*s + 72*D1**2*fd*g2*r - 36*D1**2*fd*g2*s**2 + 72*D1**2*fd*g2*s - 36*D1**2*fd*g2 + 8*D1**2*fd*gd2*r**2 + 16*D1**2*fd*gd2*r*s - 16*D1**2*fd*gd2*r + 8*D1**2*fd*gd2*s**2 - 16*D1**2*fd*gd2*s + 8*D1**2*fd*gd2 + 4*D1**2*fdd*g2*r**2 + 8*D1**2*fdd*g2*r*s - 8*D1**2*fdd*g2*r + 4*D1**2*fdd*g2*s**2 - 8*D1**2*fdd*g2*s + 4*D1**2*fdd*g2 - 64*D1*Dd*K*f**2*r**2 - 128*D1*Dd*K*f**2*r*s + 96*D1*Dd*K*f**2*r - 64*D1*Dd*K*f**2*s**2 + 96*D1*Dd*K*f**2*s - 48*D1*Dd*K*f**2 + 192*D1*Dd*K*f*fd*r**2 + 384*D1*Dd*K*f*fd*r*s - 240*D1*Dd*K*f*fd*r + 192*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 72*D1*Dd*K*f*fd - 24*D1*Dd*f**3*r**2 - 48*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 36*D1*Dd*f**3*s - 18*D1*Dd*f**3 + 28*D1*Dd*f**2*r**2 + 56*D1*Dd*f**2*r*s - 42*D1*Dd*f**2*r + 28*D1*Dd*f**2*s**2 - 42*D1*Dd*f**2*s + 21*D1*Dd*f**2 - 48*D1*Dd*f*fd*r**2 - 96*D1*Dd*f*fd*r*s + 36*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 36*D1*Dd*f*fd*s - 144*D1*Dd*f*g2*r**2 - 288*D1*Dd*f*g2*r*s + 216*D1*Dd*f*g2*r - 144*D1*Dd*f*g2*s**2 + 216*D1*Dd*f*g2*s - 108*D1*Dd*f*g2 + 32*D1*Dd*f*gd2*r**2 + 64*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r + 32*D1*Dd*f*gd2*s**2 - 56*D1*Dd*f*gd2*s + 24*D1*Dd*f*gd2 + 32*D1*Dd*fd*g2*r**2 + 64*D1*Dd*fd*g2*r*s - 56*D1*Dd*fd*g2*r + 32*D1*Dd*fd*g2*s**2 - 56*D1*Dd*fd*g2*s + 24*D1*Dd*fd*g2 + 48*D1*Ddd*K*f**2*r**2 + 96*D1*Ddd*K*f**2*r*s - 72*D1*Ddd*K*f**2*r + 48*D1*Ddd*K*f**2*s**2 - 72*D1*Ddd*K*f**2*s + 36*D1*Ddd*K*f**2 - 12*D1*Ddd*f**2*r**2 - 24*D1*Ddd*f**2*r*s + 18*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 16*D1*Ddd*f*g2*r**2 + 32*D1*Ddd*f*g2*r*s - 24*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s**2 - 24*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(64*r**2 + 2*r*(64*s - 61) + 64*s**2 - 122*s + 61) + f*(18*K*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 72*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 20*r**2 + 40*r*s - 58*r + 20*s**2 - 58*s + 29) - 2*fd*(r + s - 1)*(K*(4*r + 4*s - 2) + 10*r + 10*s + 1)) - 2*Dd*f*(4*r + 4*s - 3)*(K*(4*r + 4*s - 2) + 36*f*(r + s - 1) + 10*r + 10*s - 11)) + 144*Dd**2*K*f**2*r**2 + 288*Dd**2*K*f**2*r*s - 216*Dd**2*K*f**2*r + 144*Dd**2*K*f**2*s**2 - 216*Dd**2*K*f**2*s + 72*Dd**2*K*f**2 - 36*Dd**2*f**2*r**2 - 72*Dd**2*f**2*r*s + 54*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 18*Dd**2*f**2 + 48*Dd**2*f*g2*r**2 + 96*Dd**2*f*g2*r*s - 72*Dd**2*f*g2*r + 48*Dd**2*f*g2*s**2 - 72*Dd**2*f*g2*s + 24*Dd**2*f*g2))/(462*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct*k1**3*k2*(-2*D1*(r + s - 1)*(-2*D1*bd1**2*(12*K*f*(r + s - 1) - f*(12*C - 9)*(r + s) + 14*g2*(r + s)) - 2*D1*bdd1*f*(f*(10*C - 5) - 12*g2)*(r + s - 1) + 2*b2*(-6*D1*bdd1*f*(r + s - 1) + bd1*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3))) + bd1*(-24*D1*bd2*f*(r + s - 1) + D1*(f**2*(16*C - 5)*(r + s - 1) - 4*f*(fd*(10*C - 5)*(2*r + 2*s - 1) + (5*g2 - 12*gd2)*(r + s - 1)) + 48*fd*g2*(r + s)) - 4*Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))) + b1**3*(-3*D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(-15*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 36*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (28*K - 14)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + Ddd*(-14*K + 18*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(-14*K + 18*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(20*C*D1**2*fd*r**2 + 40*C*D1**2*fd*r*s - 40*C*D1**2*fd*r + 20*C*D1**2*fd*s**2 - 40*C*D1**2*fd*s + 20*C*D1**2*fd - 24*C*D1**2*fdd*r**2 - 48*C*D1**2*fdd*r*s + 48*C*D1**2*fdd*r - 24*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s - 24*C*D1**2*fdd + 80*C*D1*Dd*f*r**2 + 160*C*D1*Dd*f*r*s - 120*C*D1*Dd*f*r + 80*C*D1*Dd*f*s**2 - 120*C*D1*Dd*f*s + 60*C*D1*Dd*f - 192*C*D1*Dd*fd*r**2 - 384*C*D1*Dd*fd*r*s + 336*C*D1*Dd*fd*r - 192*C*D1*Dd*fd*s**2 + 336*C*D1*Dd*fd*s - 144*C*D1*Dd*fd - 96*C*D1*Ddd*f*r**2 - 192*C*D1*Ddd*f*r*s + 144*C*D1*Ddd*f*r - 96*C*D1*Ddd*f*s**2 + 144*C*D1*Ddd*f*s - 72*C*D1*Ddd*f - 288*C*Dd**2*f*r**2 - 576*C*Dd**2*f*r*s + 432*C*Dd**2*f*r - 288*C*Dd**2*f*s**2 + 432*C*Dd**2*f*s - 144*C*Dd**2*f - 20*D1**2*K*fd*r**2 - 40*D1**2*K*fd*r*s - 20*D1**2*K*fd*s**2 + 24*D1**2*K*fdd*r**2 + 48*D1**2*K*fdd*r*s + 24*D1**2*K*fdd*s**2 + D1**2*bdd1*(-14*K + 18*f + 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 24*D1**2*f*fd*r**2 - 48*D1**2*f*fd*r*s + 36*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 18*D1**2*f*fd - 22*D1**2*fd*r**2 - 44*D1**2*fd*r*s + 30*D1**2*fd*r - 22*D1**2*fd*s**2 + 30*D1**2*fd*s - 15*D1**2*fd + 18*D1**2*fdd*r**2 + 36*D1**2*fdd*r*s - 36*D1**2*fdd*r + 18*D1**2*fdd*s**2 - 36*D1**2*fdd*s + 18*D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 - 80*D1*Dd*K*f*r**2 - 160*D1*Dd*K*f*r*s + 120*D1*Dd*K*f*r - 80*D1*Dd*K*f*s**2 + 120*D1*Dd*K*f*s - 60*D1*Dd*K*f + 192*D1*Dd*K*fd*r**2 + 384*D1*Dd*K*fd*r*s - 144*D1*Dd*K*fd*r + 192*D1*Dd*K*fd*s**2 - 144*D1*Dd*K*fd*s - 48*D1*Dd*f**2*r**2 - 96*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 72*D1*Dd*f**2*s - 36*D1*Dd*f**2 - 88*D1*Dd*f*r**2 - 176*D1*Dd*f*r*s + 132*D1*Dd*f*r - 88*D1*Dd*f*s**2 + 132*D1*Dd*f*s - 66*D1*Dd*f + 144*D1*Dd*fd*r**2 + 288*D1*Dd*fd*r*s - 252*D1*Dd*fd*r + 144*D1*Dd*fd*s**2 - 252*D1*Dd*fd*s + 108*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 + 96*D1*Ddd*K*f*r**2 + 192*D1*Ddd*K*f*r*s - 144*D1*Ddd*K*f*r + 96*D1*Ddd*K*f*s**2 - 144*D1*Ddd*K*f*s + 72*D1*Ddd*K*f + 72*D1*Ddd*f*r**2 + 144*D1*Ddd*f*r*s - 108*D1*Ddd*f*r + 72*D1*Ddd*f*s**2 - 108*D1*Ddd*f*s + 54*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + D1*bd1*(D1*(-15*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 36*fd*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + (28*K - 14)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2)) + 2*Dd*(-14*K + 18*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 288*Dd**2*K*f*r**2 + 576*Dd**2*K*f*r*s - 432*Dd**2*K*f*r + 288*Dd**2*K*f*s**2 - 432*Dd**2*K*f*s + 144*Dd**2*K*f + 216*Dd**2*f*r**2 + 432*Dd**2*f*r*s - 324*Dd**2*f*r + 216*Dd**2*f*s**2 - 324*Dd**2*f*s + 108*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) + b1*(-64*C*D1**2*f*fd*r**2 - 128*C*D1**2*f*fd*r*s + 64*C*D1**2*f*fd*r - 64*C*D1**2*f*fd*s**2 + 64*C*D1**2*f*fd*s - 32*C*D1**2*f*fd + 80*C*D1**2*f*fdd*r**2 + 160*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 80*C*D1**2*f*fdd*s**2 - 80*C*D1**2*f*fdd*s + 40*C*D1**2*f*fdd + 80*C*D1**2*fd**2*r**2 + 160*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 80*C*D1**2*fd**2*s**2 - 80*C*D1**2*fd**2*s - 128*C*D1*Dd*f**2*r**2 - 256*C*D1*Dd*f**2*r*s + 192*C*D1*Dd*f**2*r - 128*C*D1*Dd*f**2*s**2 + 192*C*D1*Dd*f**2*s - 96*C*D1*Dd*f**2 + 640*C*D1*Dd*f*fd*r**2 + 1280*C*D1*Dd*f*fd*r*s - 800*C*D1*Dd*f*fd*r + 640*C*D1*Dd*f*fd*s**2 - 800*C*D1*Dd*f*fd*s + 240*C*D1*Dd*f*fd + 160*C*D1*Ddd*f**2*r**2 + 320*C*D1*Ddd*f**2*r*s - 240*C*D1*Ddd*f**2*r + 160*C*D1*Ddd*f**2*s**2 - 240*C*D1*Ddd*f**2*s + 120*C*D1*Ddd*f**2 + 480*C*Dd**2*f**2*r**2 + 960*C*Dd**2*f**2*r*s - 720*C*Dd**2*f**2*r + 480*C*Dd**2*f**2*s**2 - 720*C*Dd**2*f**2*s + 240*C*Dd**2*f**2 - 20*D1**2*b2*fd*r**2 - 40*D1**2*b2*fd*r*s - 20*D1**2*b2*fd*s**2 + 24*D1**2*b2*fdd*r**2 + 48*D1**2*b2*fdd*r*s + 24*D1**2*b2*fdd*s**2 + 2*D1**2*bd1**2*(-14*K + 18*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 2*D1**2*bdd1*(3*f*(4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 8*K*(r + s - 1)**2 - 6*r**2 - 12*r*s + 6*r - 6*s**2 + 6*s - 3) - 14*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 24*D1**2*bdd2*f*r**2 + 48*D1**2*bdd2*f*r*s - 48*D1**2*bdd2*f*r + 24*D1**2*bdd2*f*s**2 - 48*D1**2*bdd2*f*s + 24*D1**2*bdd2*f + 20*D1**2*f*fd*r**2 + 40*D1**2*f*fd*r*s - 20*D1**2*f*fd*r + 20*D1**2*f*fd*s**2 - 20*D1**2*f*fd*s + 10*D1**2*f*fd - 40*D1**2*f*fdd*r**2 - 80*D1**2*f*fdd*r*s + 40*D1**2*f*fdd*r - 40*D1**2*f*fdd*s**2 + 40*D1**2*f*fdd*s - 20*D1**2*f*fdd + 40*D1**2*f*gd2*r**2 + 80*D1**2*f*gd2*r*s - 80*D1**2*f*gd2*r + 40*D1**2*f*gd2*s**2 - 80*D1**2*f*gd2*s + 40*D1**2*f*gd2 - 48*D1**2*f*gdd2*r**2 - 96*D1**2*f*gdd2*r*s + 96*D1**2*f*gdd2*r - 48*D1**2*f*gdd2*s**2 + 96*D1**2*f*gdd2*s - 48*D1**2*f*gdd2 - 40*D1**2*fd**2*r**2 - 80*D1**2*fd**2*r*s + 40*D1**2*fd**2*r - 40*D1**2*fd**2*s**2 + 40*D1**2*fd**2*s + 40*D1**2*fd*g2*r**2 + 80*D1**2*fd*g2*r*s + 40*D1**2*fd*g2*s**2 - 96*D1**2*fd*gd2*r**2 - 192*D1**2*fd*gd2*r*s + 96*D1**2*fd*gd2*r - 96*D1**2*fd*gd2*s**2 + 96*D1**2*fd*gd2*s - 48*D1**2*fdd*g2*r**2 - 96*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*s**2 - 80*D1*Dd*b2*f*r**2 - 160*D1*Dd*b2*f*r*s + 120*D1*Dd*b2*f*r - 80*D1*Dd*b2*f*s**2 + 120*D1*Dd*b2*f*s - 60*D1*Dd*b2*f + 192*D1*Dd*b2*fd*r**2 + 384*D1*Dd*b2*fd*r*s - 144*D1*Dd*b2*fd*r + 192*D1*Dd*b2*fd*s**2 - 144*D1*Dd*b2*fd*s + 40*D1*Dd*f**2*r**2 + 80*D1*Dd*f**2*r*s - 60*D1*Dd*f**2*r + 40*D1*Dd*f**2*s**2 - 60*D1*Dd*f**2*s + 30*D1*Dd*f**2 - 320*D1*Dd*f*fd*r**2 - 640*D1*Dd*f*fd*r*s + 400*D1*Dd*f*fd*r - 320*D1*Dd*f*fd*s**2 + 400*D1*Dd*f*fd*s - 120*D1*Dd*f*fd + 160*D1*Dd*f*g2*r**2 + 320*D1*Dd*f*g2*r*s - 240*D1*Dd*f*g2*r + 160*D1*Dd*f*g2*s**2 - 240*D1*Dd*f*g2*s + 120*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r**2 - 768*D1*Dd*f*gd2*r*s + 672*D1*Dd*f*gd2*r - 384*D1*Dd*f*gd2*s**2 + 672*D1*Dd*f*gd2*s - 288*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r**2 - 768*D1*Dd*fd*g2*r*s + 288*D1*Dd*fd*g2*r - 384*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s + 96*D1*Ddd*b2*f*r**2 + 192*D1*Ddd*b2*f*r*s - 144*D1*Ddd*b2*f*r + 96*D1*Ddd*b2*f*s**2 - 144*D1*Ddd*b2*f*s + 72*D1*Ddd*b2*f - 80*D1*Ddd*f**2*r**2 - 160*D1*Ddd*f**2*r*s + 120*D1*Ddd*f**2*r - 80*D1*Ddd*f**2*s**2 + 120*D1*Ddd*f**2*s - 60*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r**2 - 384*D1*Ddd*f*g2*r*s + 288*D1*Ddd*f*g2*r - 192*D1*Ddd*f*g2*s**2 + 288*D1*Ddd*f*g2*s - 144*D1*Ddd*f*g2 + D1*bd1*(-D1*(6*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(-20*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 40*K*(r + s - 1)**2 + 44*r**2 + 88*r*s - 58*r + 44*s**2 - 58*s + 29) - 12*fd*(r + s - 1)*(C*(-8*r - 8*s + 4) + 8*K*s + r*(8*K + 6) + 6*s - 3) + 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 4*Dd*(3*f*(C*(8*r + 8*s - 4) - 8*K*(r + s - 1) - 6*r - 6*s + 3) - 14*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) - 4*D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 288*Dd**2*b2*f*r**2 + 576*Dd**2*b2*f*r*s - 432*Dd**2*b2*f*r + 288*Dd**2*b2*f*s**2 - 432*Dd**2*b2*f*s + 144*Dd**2*b2*f - 240*Dd**2*f**2*r**2 - 480*Dd**2*f**2*r*s + 360*Dd**2*f**2*r - 240*Dd**2*f**2*s**2 + 360*Dd**2*f**2*s - 120*Dd**2*f**2 - 576*Dd**2*f*g2*r**2 - 1152*Dd**2*f*g2*r*s + 864*Dd**2*f*g2*r - 576*Dd**2*f*g2*s**2 + 864*Dd**2*f*g2*s - 288*Dd**2*f*g2))/(21*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1**3*st**2*(D1*f*(r + s)*(2*D1*bd1**2*(3*f + 1)*(r + s - 1) + D1*bdd1*f*(r + s) + bd1*(-D1*f*(r + s) + 4*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3))) + b1**2*(D1**2*(r + s - 1)**2*(6*f*fdd + 6*fd**2 + fd*(-6*f - 9) + fdd) + D1*(Dd*(-3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 3*f*(4*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) - 12*r**2 - 24*r*s + 18*r - 12*s**2 + 18*s - 9) + 2*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + Ddd*f*(3*f + 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(3*f + 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*bdd1*f*(3*f + 1)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s - 2*D1**2*f*fd + 2*D1**2*f*fdd*r**2 + 4*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 4*D1**2*f*fdd*s + 2*D1**2*f*fdd + 2*D1**2*fd**2*r**2 + 4*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 4*D1**2*fd**2*s + 2*D1**2*fd**2 - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 + 16*D1*Dd*f*fd*r**2 + 32*D1*Dd*f*fd*r*s - 28*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 28*D1*Dd*f*fd*s + 12*D1*Dd*f*fd + 4*D1*Ddd*f**2*r**2 + 8*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + D1*bd1*(D1*(-3*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 3*f*(4*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) - 6*r**2 - 12*r*s + 6*r - 6*s**2 + 6*s - 3) + 2*fd*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*f*(3*f + 1)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 12*Dd**2*f**2*r**2 + 24*Dd**2*f**2*r*s - 18*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s + 6*Dd**2*f**2))/(42*d**2*k2*k3**2) + D1**2*Pk2*Pkdd3*ct*k1**3*(12*D1**2*bd1**2*f*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*b1*(2*D1*bd1**2*(6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 6*D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + bd1*(D1*(-5*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 12*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 12*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + b1**3*(-D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(-Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 56*r**2 + 112*r*s - 84*r + 56*s**2 - 84*s + 42) + Ddd*(6*f + 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(6*f + 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*bdd1*(6*f + 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 5*D1**2*fd*r**2 - 10*D1**2*fd*r*s + 10*D1**2*fd*r - 5*D1**2*fd*s**2 + 10*D1**2*fd*s - 5*D1**2*fd + 6*D1**2*fdd*r**2 + 12*D1**2*fdd*r*s - 12*D1**2*fdd*r + 6*D1**2*fdd*s**2 - 12*D1**2*fdd*s + 6*D1**2*fdd - 20*D1*Dd*f*r**2 - 40*D1*Dd*f*r*s + 30*D1*Dd*f*r - 20*D1*Dd*f*s**2 + 30*D1*Dd*f*s - 15*D1*Dd*f + 48*D1*Dd*fd*r**2 + 96*D1*Dd*fd*r*s - 84*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 84*D1*Dd*fd*s + 36*D1*Dd*fd + 24*D1*Ddd*f*r**2 + 48*D1*Ddd*f*r*s - 36*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 36*D1*Ddd*f*s + 18*D1*Ddd*f + D1*bd1*(-D1*(5*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + 42*r**2 + 84*r*s - 56*r + 42*s**2 - 56*s + 28) + 2*Dd*(6*f + 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + 72*Dd**2*f*r**2 + 144*Dd**2*f*r*s - 108*Dd**2*f*r + 72*Dd**2*f*s**2 - 108*Dd**2*f*s + 36*Dd**2*f))/(21*d**2*k2*k3**2) - 5*D1**2*Pk2*Pkdd3*ct*k1*k2**5*st**6*(-24*C*D1**2*f**2*fd*r**2 - 48*C*D1**2*f**2*fd*r*s + 32*C*D1**2*f**2*fd*r - 24*C*D1**2*f**2*fd*s**2 + 32*C*D1**2*f**2*fd*s - 16*C*D1**2*f**2*fd + 12*C*D1**2*f**2*fdd*r**2 + 24*C*D1**2*f**2*fdd*r*s - 16*C*D1**2*f**2*fdd*r + 12*C*D1**2*f**2*fdd*s**2 - 16*C*D1**2*f**2*fdd*s + 8*C*D1**2*f**2*fdd + 24*C*D1**2*f*fd**2*r**2 + 48*C*D1**2*f*fd**2*r*s - 32*C*D1**2*f*fd**2*r + 24*C*D1**2*f*fd**2*s**2 - 32*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 32*C*D1*Dd*f**3*r**2 - 64*C*D1*Dd*f**3*r*s + 48*C*D1*Dd*f**3*r - 32*C*D1*Dd*f**3*s**2 + 48*C*D1*Dd*f**3*s - 24*C*D1*Dd*f**3 + 96*C*D1*Dd*f**2*fd*r**2 + 192*C*D1*Dd*f**2*fd*r*s - 136*C*D1*Dd*f**2*fd*r + 96*C*D1*Dd*f**2*fd*s**2 - 136*C*D1*Dd*f**2*fd*s + 48*C*D1*Dd*f**2*fd + 16*C*D1*Ddd*f**3*r**2 + 32*C*D1*Ddd*f**3*r*s - 24*C*D1*Ddd*f**3*r + 16*C*D1*Ddd*f**3*s**2 - 24*C*D1*Ddd*f**3*s + 12*C*D1*Ddd*f**3 + 48*C*Dd**2*f**3*r**2 + 96*C*Dd**2*f**3*r*s - 72*C*Dd**2*f**3*r + 48*C*Dd**2*f**3*s**2 - 72*C*Dd**2*f**3*s + 24*C*Dd**2*f**3 - 264*D1**2*K*b1*f*fd*r**2 - 528*D1**2*K*b1*f*fd*r*s + 264*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 132*D1**2*K*b1*f*fdd*r**2 + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 132*D1**2*K*b1*f*fdd*s**2 - 132*D1**2*K*b1*f*fdd*s + 66*D1**2*K*b1*f*fdd + 132*D1**2*K*b1*fd**2*r**2 + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 132*D1**2*K*b1*fd**2*s**2 - 132*D1**2*K*b1*fd**2*s + 42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(-66*K + 7*f + 33)*(r + s - 1)**2 + 18*D1**2*f**2*fd*r**2 + 36*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 24*D1**2*f**2*fd*s + 12*D1**2*f**2*fd - 9*D1**2*f**2*fdd*r**2 - 18*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r - 9*D1**2*f**2*fdd*s**2 + 12*D1**2*f**2*fdd*s - 6*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r**2 + 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*r + 264*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s + 264*D1**2*f**2*gd2 - 132*D1**2*f**2*gdd2*r**2 - 264*D1**2*f**2*gdd2*r*s + 264*D1**2*f**2*gdd2*r - 132*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 132*D1**2*f**2*gdd2 - 18*D1**2*f*fd**2*r**2 - 36*D1**2*f*fd**2*r*s + 24*D1**2*f*fd**2*r - 18*D1**2*f*fd**2*s**2 + 24*D1**2*f*fd**2*s - 6*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r**2 - 1056*D1**2*f*fd*gd2*r*s + 792*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r**2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r**2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s - 528*D1*Dd*K*b1*f**2*r**2 - 1056*D1*Dd*K*b1*f**2*r*s + 792*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 + 792*D1*Dd*K*b1*f**2*s - 396*D1*Dd*K*b1*f**2 + 1056*D1*Dd*K*b1*f*fd*r**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 1320*D1*Dd*K*b1*f*fd*r + 1056*D1*Dd*K*b1*f*fd*s**2 - 1320*D1*Dd*K*b1*f*fd*s + 396*D1*Dd*K*b1*f*fd + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 24*D1*Dd*f**3*r**2 + 48*D1*Dd*f**3*r*s - 36*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 36*D1*Dd*f**3*s + 18*D1*Dd*f**3 - 72*D1*Dd*f**2*fd*r**2 - 144*D1*Dd*f**2*fd*r*s + 102*D1*Dd*f**2*fd*r - 72*D1*Dd*f**2*fd*s**2 + 102*D1*Dd*f**2*fd*s - 36*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r**2 + 2112*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r**2 - 2112*D1*Dd*f**2*gd2*r*s + 1848*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1848*D1*Dd*f**2*gd2*s - 792*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r**2 - 4224*D1*Dd*f*fd*g2*r*s + 2640*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2640*D1*Dd*f*fd*g2*s - 792*D1*Dd*f*fd*g2 + 264*D1*Ddd*K*b1*f**2*r**2 + 528*D1*Ddd*K*b1*f**2*r*s - 396*D1*Ddd*K*b1*f**2*r + 264*D1*Ddd*K*b1*f**2*s**2 - 396*D1*Ddd*K*b1*f**2*s + 198*D1*Ddd*K*b1*f**2 - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 12*D1*Ddd*f**3*r**2 - 24*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 18*D1*Ddd*f**3*s - 9*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r**2 - 1056*D1*Ddd*f**2*g2*r*s + 792*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 792*D1*Ddd*f**2*g2*s - 396*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) - 33*f*(2*K - 1)*(r + s - 1) + 33*fd*(2*K - 1)*(2*r + 2*s - 1)) - Dd*f*(-66*K + 7*f + 33)*(4*r + 4*s - 3))*(r + s - 1) + 792*Dd**2*K*b1*f**2*r**2 + 1584*Dd**2*K*b1*f**2*r*s - 1188*Dd**2*K*b1*f**2*r + 792*Dd**2*K*b1*f**2*s**2 - 1188*Dd**2*K*b1*f**2*s + 396*Dd**2*K*b1*f**2 - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 36*Dd**2*f**3*r**2 - 72*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 54*Dd**2*f**3*s - 18*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r**2 - 3168*Dd**2*f**2*g2*r*s + 2376*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 2376*Dd**2*f**2*g2*s - 792*Dd**2*f**2*g2)/(1386*d**2*k3**6) + D1**2*Pk2*Pkdd3*ct*k1*k2**5*st**4*(-66*D1**2*bd1**2*f*(2*K - 1)*(r + s - 1)**2 - 33*D1*bd1*(D1*(f**2*(4*K - 1)*(r + s - 1) + 8*f*(g2 - gd2)*(r + s - 1) - 8*fd*g2*(r + s)) - 8*Dd*f*g2*(4*r + 4*s - 3))*(r + s - 1) + 33*b1**2*(2*K - 1)*(D1**2*(2*fd - fdd)*(r + s)**2 + D1*(2*Dd*(f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(-4*r**2 + r*(3 - 8*s) + s*(3 - 4*s))) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-8*D1**2*K*f*fd*r**2 - 16*D1**2*K*f*fd*r*s + 8*D1**2*K*f*fd*r - 8*D1**2*K*f*fd*s**2 + 8*D1**2*K*f*fd*s - 4*D1**2*K*f*fd - 2*D1**2*bdd1*f*(2*K - 1)*(r + s - 1)**2 + 2*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + D1**2*f*fd - 8*D1**2*f*gd2*r**2 - 16*D1**2*f*gd2*r*s + 16*D1**2*f*gd2*r - 8*D1**2*f*gd2*s**2 + 16*D1**2*f*gd2*s - 8*D1**2*f*gd2 + 4*D1**2*f*gdd2*r**2 + 8*D1**2*f*gdd2*r*s - 8*D1**2*f*gdd2*r + 4*D1**2*f*gdd2*s**2 - 8*D1**2*f*gdd2*s + 4*D1**2*f*gdd2 - 8*D1**2*fd*g2*r**2 - 16*D1**2*fd*g2*r*s - 8*D1**2*fd*g2*s**2 + 8*D1**2*fd*gd2*r**2 + 16*D1**2*fd*gd2*r*s - 8*D1**2*fd*gd2*r + 8*D1**2*fd*gd2*s**2 - 8*D1**2*fd*gd2*s + 4*D1**2*fdd*g2*r**2 + 8*D1**2*fdd*g2*r*s + 4*D1**2*fdd*g2*s**2 - 16*D1*Dd*K*f**2*r**2 - 32*D1*Dd*K*f**2*r*s + 24*D1*Dd*K*f**2*r - 16*D1*Dd*K*f**2*s**2 + 24*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 32*D1*Dd*f*g2*r**2 - 64*D1*Dd*f*g2*r*s + 48*D1*Dd*f*g2*r - 32*D1*Dd*f*g2*s**2 + 48*D1*Dd*f*g2*s - 24*D1*Dd*f*g2 + 32*D1*Dd*f*gd2*r**2 + 64*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r + 32*D1*Dd*f*gd2*s**2 - 56*D1*Dd*f*gd2*s + 24*D1*Dd*f*gd2 + 32*D1*Dd*fd*g2*r**2 + 64*D1*Dd*fd*g2*r*s - 24*D1*Dd*fd*g2*r + 32*D1*Dd*fd*g2*s**2 - 24*D1*Dd*fd*g2*s + 16*D1*Ddd*f*g2*r**2 + 32*D1*Ddd*f*g2*r*s - 24*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s**2 - 24*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + 4*D1*bd1*(2*K - 1)*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 48*Dd**2*f*g2*r**2 + 96*Dd**2*f*g2*r*s - 72*Dd**2*f*g2*r + 48*Dd**2*f*g2*s**2 - 72*Dd**2*f*g2*s + 24*Dd**2*f*g2) + 4*f*(D1**2*(33*bdd1*g2*(r + s - 1)**2 + f*(-fd*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 66*gd2*(r + s - 1)**2) + fd**2*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 66*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + D1*f*(-2*Dd*(f*(10*C - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(10*C - 5)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 33*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Ddd*f*(10*C - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Dd**2*f**2*(60*C - 30)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**6) - D1**2*Pk2*Pkdd3*ct*k1*k2**5*st**2*(D1*(-24*D1*K*bd1**2*f*(r + s - 1)**2 + bd1*(D1*(f**2*(40*C - 6*K - 19)*(r + s - 1) - 8*f*(fd*(6*C - 3)*(2*r + 2*s - 1) + (13*g2 - 6*gd2)*(r + s - 1)) + 48*fd*g2*(r + s)) - 24*Dd*f*(f*(2*C - 1) - 2*g2)*(4*r + 4*s - 3))*(r + s - 1) - 6*f*(2*D1*bdd1*(f*(2*C - 1) - 2*g2)*(r + s - 1)**2 + D1*(f*(fd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*gd2*(r + s - 1)**2) - 2*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + Dd*f*(f*(2*C - 1) - 2*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3))) + b1**2*(D1**2*(3*f*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (r + s)**2*(-12*K*fdd + fd*(52*K - 7))) + D1*(Dd*(-24*K*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3)) + 3*f**2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(52*K - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(D1**2*(f*(fd*(40*C - 6*K - 19)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*fdd*(6*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 4*(r + s - 1)**2*(6*K*bdd1 + 26*gd2 - 6*gdd2)) + (-8*r - 8*s)*(fd**2*(6*C - 3)*(r + s - 1) + 13*fd*g2*(r + s) - 6*fd*gd2*(r + s - 1) - 3*fdd*g2*(r + s))) + 2*D1*bd1*(D1*(-24*K*fd*(r + s) + 3*f**2*(r + s - 1) + f*(52*K - 7)*(r + s - 1)) - 24*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) + D1*(Dd*(f**2*(40*C - 6*K - 19)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*f*(fd*(6*C - 3)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 13*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 6*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + 48*fd*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 12*Ddd*f*(f*(2*C - 1) - 2*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 72*Dd**2*f*(f*(2*C - 1) - 2*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(42*d**2*k3**6) + 5*D1**2*Pk2*Pkdd3*ct*k1*k2**3*st**6*(42*D1**2*b1*f**2*fd*r**2 + 84*D1**2*b1*f**2*fd*r*s - 56*D1**2*b1*f**2*fd*r + 42*D1**2*b1*f**2*fd*s**2 - 56*D1**2*b1*f**2*fd*s + 28*D1**2*b1*f**2*fd - 21*D1**2*b1*f**2*fdd*r**2 - 42*D1**2*b1*f**2*fdd*r*s + 28*D1**2*b1*f**2*fdd*r - 21*D1**2*b1*f**2*fdd*s**2 + 28*D1**2*b1*f**2*fdd*s - 14*D1**2*b1*f**2*fdd - 42*D1**2*b1*f*fd**2*r**2 - 84*D1**2*b1*f*fd**2*r*s + 56*D1**2*b1*f*fd**2*r - 42*D1**2*b1*f*fd**2*s**2 + 56*D1**2*b1*f*fd**2*s - 14*D1**2*b1*f*fd**2 + 132*D1**2*b1*f*fd*r**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r + 132*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s + 66*D1**2*b1*f*fd - 66*D1**2*b1*f*fdd*r**2 - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 66*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s - 33*D1**2*b1*f*fdd - 66*D1**2*b1*fd**2*r**2 - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 66*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s - D1**2*bdd1*f**2*(7*f + 33)*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 3*D1**2*f**2*fdd*r**2 - 6*D1**2*f**2*fdd*r*s + 4*D1**2*f**2*fdd*r - 3*D1**2*f**2*fdd*s**2 + 4*D1**2*f**2*fdd*s - 2*D1**2*f**2*fdd - 6*D1**2*f*fd**2*r**2 - 12*D1**2*f*fd**2*r*s + 8*D1**2*f*fd**2*r - 6*D1**2*f*fd**2*s**2 + 8*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 + 56*D1*Dd*b1*f**3*r**2 + 112*D1*Dd*b1*f**3*r*s - 84*D1*Dd*b1*f**3*r + 56*D1*Dd*b1*f**3*s**2 - 84*D1*Dd*b1*f**3*s + 42*D1*Dd*b1*f**3 - 168*D1*Dd*b1*f**2*fd*r**2 - 336*D1*Dd*b1*f**2*fd*r*s + 238*D1*Dd*b1*f**2*fd*r - 168*D1*Dd*b1*f**2*fd*s**2 + 238*D1*Dd*b1*f**2*fd*s - 84*D1*Dd*b1*f**2*fd + 264*D1*Dd*b1*f**2*r**2 + 528*D1*Dd*b1*f**2*r*s - 396*D1*Dd*b1*f**2*r + 264*D1*Dd*b1*f**2*s**2 - 396*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 528*D1*Dd*b1*f*fd*r**2 - 1056*D1*Dd*b1*f*fd*r*s + 660*D1*Dd*b1*f*fd*r - 528*D1*Dd*b1*f*fd*s**2 + 660*D1*Dd*b1*f*fd*s - 198*D1*Dd*b1*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 24*D1*Dd*f**2*fd*r**2 - 48*D1*Dd*f**2*fd*r*s + 34*D1*Dd*f**2*fd*r - 24*D1*Dd*f**2*fd*s**2 + 34*D1*Dd*f**2*fd*s - 12*D1*Dd*f**2*fd - 28*D1*Ddd*b1*f**3*r**2 - 56*D1*Ddd*b1*f**3*r*s + 42*D1*Ddd*b1*f**3*r - 28*D1*Ddd*b1*f**3*s**2 + 42*D1*Ddd*b1*f**3*s - 21*D1*Ddd*b1*f**3 - 132*D1*Ddd*b1*f**2*r**2 - 264*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 132*D1*Ddd*b1*f**2*s**2 + 198*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 4*D1*Ddd*f**3*r**2 - 8*D1*Ddd*f**3*r*s + 6*D1*Ddd*f**3*r - 4*D1*Ddd*f**3*s**2 + 6*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 + 2*D1*bd1*f*(D1*(7*f**2*(r + s - 1) - 7*f*fd*(3*r + 3*s - 2) + 33*f*(r + s - 1) - 33*fd*(2*r + 2*s - 1)) - Dd*f*(7*f + 33)*(4*r + 4*s - 3))*(r + s - 1) - 84*Dd**2*b1*f**3*r**2 - 168*Dd**2*b1*f**3*r*s + 126*Dd**2*b1*f**3*r - 84*Dd**2*b1*f**3*s**2 + 126*Dd**2*b1*f**3*s - 42*Dd**2*b1*f**3 - 396*Dd**2*b1*f**2*r**2 - 792*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 396*Dd**2*b1*f**2*s**2 + 594*Dd**2*b1*f**2*s - 198*Dd**2*b1*f**2 - 12*Dd**2*f**3*r**2 - 24*Dd**2*f**3*r*s + 18*Dd**2*f**3*r - 12*Dd**2*f**3*s**2 + 18*Dd**2*f**3*s - 6*Dd**2*f**3)/(1386*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1*k2**3*st**4*(-66*D1**2*bd1**2*f*(2*K*(r + s) - 1)*(r + s - 1) + 33*D1*bd1*(D1*(f**2*(2*K - 1)*(r + s - 1)**2 + 8*f*(r + s)*(-g2*(r + s) + gd2*(r + s - 1)) + 8*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 8*Dd*f*g2*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) + 33*b1**2*(D1**2*(2*fd - fdd)*(2*K*(r + s - 1)**2 + 2*r + 2*s - 1) - 2*D1*(Dd*(-2*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(2*K*(r + s - 1) + 1)*(4*r + 4*s - 3)) + Ddd*K*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*K*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(4*D1**2*K*f*fd*r**2 + 8*D1**2*K*f*fd*r*s - 4*D1**2*K*f*fd*r + 4*D1**2*K*f*fd*s**2 - 4*D1**2*K*f*fd*s + 2*D1**2*K*f*fd - D1**2*bdd1*f*(K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 2*r - 2*s + 1) - 2*D1**2*f*fd*r**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd - 8*D1**2*f*gd2*r**2 - 16*D1**2*f*gd2*r*s + 16*D1**2*f*gd2*r - 8*D1**2*f*gd2*s**2 + 16*D1**2*f*gd2*s - 8*D1**2*f*gd2 + 4*D1**2*f*gdd2*r**2 + 8*D1**2*f*gdd2*r*s - 8*D1**2*f*gdd2*r + 4*D1**2*f*gdd2*s**2 - 8*D1**2*f*gdd2*s + 4*D1**2*f*gdd2 - 8*D1**2*fd*g2*r**2 - 16*D1**2*fd*g2*r*s + 16*D1**2*fd*g2*r - 8*D1**2*fd*g2*s**2 + 16*D1**2*fd*g2*s - 8*D1**2*fd*g2 + 8*D1**2*fd*gd2*r**2 + 16*D1**2*fd*gd2*r*s - 16*D1**2*fd*gd2*r + 8*D1**2*fd*gd2*s**2 - 16*D1**2*fd*gd2*s + 8*D1**2*fd*gd2 + 4*D1**2*fdd*g2*r**2 + 8*D1**2*fdd*g2*r*s - 8*D1**2*fdd*g2*r + 4*D1**2*fdd*g2*s**2 - 8*D1**2*fdd*g2*s + 4*D1**2*fdd*g2 + 8*D1*Dd*K*f**2*r**2 + 16*D1*Dd*K*f**2*r*s - 12*D1*Dd*K*f**2*r + 8*D1*Dd*K*f**2*s**2 - 12*D1*Dd*K*f**2*s + 6*D1*Dd*K*f**2 - 4*D1*Dd*f**2*r**2 - 8*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 6*D1*Dd*f**2*s - 3*D1*Dd*f**2 - 32*D1*Dd*f*g2*r**2 - 64*D1*Dd*f*g2*r*s + 48*D1*Dd*f*g2*r - 32*D1*Dd*f*g2*s**2 + 48*D1*Dd*f*g2*s - 24*D1*Dd*f*g2 + 32*D1*Dd*f*gd2*r**2 + 64*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r + 32*D1*Dd*f*gd2*s**2 - 56*D1*Dd*f*gd2*s + 24*D1*Dd*f*gd2 + 32*D1*Dd*fd*g2*r**2 + 64*D1*Dd*fd*g2*r*s - 56*D1*Dd*fd*g2*r + 32*D1*Dd*fd*g2*s**2 - 56*D1*Dd*fd*g2*s + 24*D1*Dd*fd*g2 + 16*D1*Ddd*f*g2*r**2 + 32*D1*Ddd*f*g2*r*s - 24*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s**2 - 24*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f*(K*(4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) - 2*r - 2*s + 1) - fd*(K*(4*r + 4*s - 2) + 1)*(r + s - 1)) - Dd*f*(K*(4*r + 4*s - 2) - 1)*(4*r + 4*s - 3)) + 48*Dd**2*f*g2*r**2 + 96*Dd**2*f*g2*r*s - 72*Dd**2*f*g2*r + 48*Dd**2*f*g2*s**2 - 72*Dd**2*f*g2*s + 24*Dd**2*f*g2) + 2*f*(33*D1**2*bd2*f*(r + s - 1)**2 + 2*D1**2*(33*bdd1*g2*(r + s)**2 + f*(fd*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(10*C - 5)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 33*gd2*(r + s - 1)**2) - fd**2*(20*C - 10)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 33*fd*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 33*D1*b2*(D1*fd*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*D1*f*(Dd*(f*(20*C - 10)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(20*C - 10)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 33*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Ddd*f*(5 - 10*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 2*Dd**2*f**2*(30 - 60*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1*k2**3*st**2*(D1*(-2*D1*bd1**2*(r + s - 1)*(6*K*f*(r + s - 2) - f*(4*C - 3)*(r + s) - 28*g2*(r + s)) + 2*b2*(bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 3*f*(2*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) + bd1*(-24*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(4*C*(7*r**2 + 2*r*(7*s - 11) + 7*s**2 - 22*s + 11) - 6*K*(r + s - 1)**2 - 14*r**2 - 28*r*s + 42*r - 14*s**2 + 42*s - 21) + 4*f*(fd*(6 - 12*C)*(r + s - 1)**2 + g2*(r**2 + 2*r*(s + 19) + s**2 + 38*s - 19) + 6*gd2*(r**2 + r*(2*s - 3) + s**2 - 3*s + 2)) + 24*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) - 12*Dd*f*(f*(2*C - 1) - 2*g2)*(4*r**2 + r*(8*s - 11) + 4*s**2 - 11*s + 6)) - 6*f*(6*C*D1*f*fd*r**2 + 12*C*D1*f*fd*r*s - 8*C*D1*f*fd*r + 6*C*D1*f*fd*s**2 - 8*C*D1*f*fd*s + 4*C*D1*f*fd + 8*C*Dd*f**2*r**2 + 16*C*Dd*f**2*r*s - 12*C*Dd*f**2*r + 8*C*Dd*f**2*s**2 - 12*C*Dd*f**2*s + 6*C*Dd*f**2 + D1*bd2*f*(r + s - 1)**2 + D1*bdd1*(f*(2*C - 1) - 2*g2)*(r**2 + 2*r*(s - 2) + s**2 - 4*s + 2) - 3*D1*f*fd*r**2 - 6*D1*f*fd*r*s + 4*D1*f*fd*r - 3*D1*f*fd*s**2 + 4*D1*f*fd*s - 2*D1*f*fd - 2*D1*f*gd2*r**2 - 4*D1*f*gd2*r*s + 4*D1*f*gd2*r - 2*D1*f*gd2*s**2 + 4*D1*f*gd2*s - 2*D1*f*gd2 - 4*D1*fd*g2*r**2 - 8*D1*fd*g2*r*s + 4*D1*fd*g2*r - 4*D1*fd*g2*s**2 + 4*D1*fd*g2*s - 2*D1*fd*g2 - 4*Dd*f**2*r**2 - 8*Dd*f**2*r*s + 6*Dd*f**2*r - 4*Dd*f**2*s**2 + 6*Dd*f**2*s - 3*Dd*f**2 - 8*Dd*f*g2*r**2 - 16*Dd*f*g2*r*s + 12*Dd*f*g2*r - 8*Dd*f*g2*s**2 + 12*Dd*f*g2*s - 6*Dd*f*g2)) + b1**3*(3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + (14*K - 7)*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - Ddd*(14*K + 3*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*(14*K + 3*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-8*C*D1**2*fd*r**2 - 16*C*D1**2*fd*r*s + 16*C*D1**2*fd*r - 8*C*D1**2*fd*s**2 + 16*C*D1**2*fd*s - 8*C*D1**2*fd + 4*C*D1**2*fdd*r**2 + 8*C*D1**2*fdd*r*s - 8*C*D1**2*fdd*r + 4*C*D1**2*fdd*s**2 - 8*C*D1**2*fdd*s + 4*C*D1**2*fdd - 32*C*D1*Dd*f*r**2 - 64*C*D1*Dd*f*r*s + 48*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 + 48*C*D1*Dd*f*s - 24*C*D1*Dd*f + 32*C*D1*Dd*fd*r**2 + 64*C*D1*Dd*fd*r*s - 56*C*D1*Dd*fd*r + 32*C*D1*Dd*fd*s**2 - 56*C*D1*Dd*fd*s + 24*C*D1*Dd*fd + 16*C*D1*Ddd*f*r**2 + 32*C*D1*Ddd*f*r*s - 24*C*D1*Ddd*f*r + 16*C*D1*Ddd*f*s**2 - 24*C*D1*Ddd*f*s + 12*C*D1*Ddd*f + 48*C*Dd**2*f*r**2 + 96*C*Dd**2*f*r*s - 72*C*Dd**2*f*r + 48*C*Dd**2*f*s**2 - 72*C*Dd**2*f*s + 24*C*Dd**2*f - 2*D1**2*K*fd*r**2 - 4*D1**2*K*fd*r*s + 80*D1**2*K*fd*r - 2*D1**2*K*fd*s**2 + 80*D1**2*K*fd*s - 40*D1**2*K*fd - 6*D1**2*K*fdd*r**2 - 12*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r - 6*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - D1**2*bdd1*(14*K + 3*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 6*D1**2*f*fd*r + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 6*D1**2*fd*r**2 + 12*D1**2*fd*r*s - 26*D1**2*fd*r + 6*D1**2*fd*s**2 - 26*D1**2*fd*s + 13*D1**2*fd - 3*D1**2*fdd*r**2 - 6*D1**2*fdd*r*s + 6*D1**2*fdd*r - 3*D1**2*fdd*s**2 + 6*D1**2*fdd*s - 3*D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 - 8*D1*Dd*K*f*r**2 - 16*D1*Dd*K*f*r*s + 12*D1*Dd*K*f*r - 8*D1*Dd*K*f*s**2 + 12*D1*Dd*K*f*s - 6*D1*Dd*K*f - 48*D1*Dd*K*fd*r**2 - 96*D1*Dd*K*fd*r*s - 12*D1*Dd*K*fd*r - 48*D1*Dd*K*fd*s**2 - 12*D1*Dd*K*fd*s + 36*D1*Dd*K*fd + 24*D1*Dd*f*r**2 + 48*D1*Dd*f*r*s - 36*D1*Dd*f*r + 24*D1*Dd*f*s**2 - 36*D1*Dd*f*s + 18*D1*Dd*f - 24*D1*Dd*fd*r**2 - 48*D1*Dd*fd*r*s + 42*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 42*D1*Dd*fd*s - 18*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 - 24*D1*Ddd*K*f*r**2 - 48*D1*Ddd*K*f*r*s + 36*D1*Ddd*K*f*r - 24*D1*Ddd*K*f*s**2 + 36*D1*Ddd*K*f*s - 18*D1*Ddd*K*f - 12*D1*Ddd*f*r**2 - 24*D1*Ddd*f*r*s + 18*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 18*D1*Ddd*f*s - 9*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + 2*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) + (14*K - 7)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - Dd*(14*K + 3*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 72*Dd**2*K*f*r**2 - 144*Dd**2*K*f*r*s + 108*Dd**2*K*f*r - 72*Dd**2*K*f*s**2 + 108*Dd**2*K*f*s - 36*Dd**2*K*f - 36*Dd**2*f*r**2 - 72*Dd**2*f*r*s + 54*Dd**2*f*r - 36*Dd**2*f*s**2 + 54*Dd**2*f*s - 18*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2) + b1*(8*C*D1**2*bdd1*f*r**2 + 16*C*D1**2*bdd1*f*r*s - 8*C*D1**2*bdd1*f*r + 8*C*D1**2*bdd1*f*s**2 - 8*C*D1**2*bdd1*f*s + 4*C*D1**2*bdd1*f + 56*C*D1**2*f*fd*r**2 + 112*C*D1**2*f*fd*r*s - 24*C*D1**2*f*fd*r + 56*C*D1**2*f*fd*s**2 - 24*C*D1**2*f*fd*s + 12*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s - 24*C*D1**2*f*fdd*s**2 - 24*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*s**2 + 24*C*D1**2*fd**2 + 112*C*D1*Dd*f**2*r**2 + 224*C*D1*Dd*f**2*r*s - 168*C*D1*Dd*f**2*r + 112*C*D1*Dd*f**2*s**2 - 168*C*D1*Dd*f**2*s + 84*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s + 144*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 144*C*D1*Dd*f*fd*s - 48*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r*s + 72*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 72*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r*s + 216*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 216*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 - 12*D1**2*K*bdd1*f*r**2 - 24*D1**2*K*bdd1*f*r*s + 36*D1**2*K*bdd1*f*r - 12*D1**2*K*bdd1*f*s**2 + 36*D1**2*K*bdd1*f*s - 18*D1**2*K*bdd1*f - 12*D1**2*K*f*fd*r**2 - 24*D1**2*K*f*fd*r*s + 12*D1**2*K*f*fd*r - 12*D1**2*K*f*fd*s**2 + 12*D1**2*K*f*fd*s - 6*D1**2*K*f*fd + 38*D1**2*b2*fd*r**2 + 76*D1**2*b2*fd*r*s + 38*D1**2*b2*fd*s**2 - 12*D1**2*b2*fdd*r**2 - 24*D1**2*b2*fdd*r*s - 12*D1**2*b2*fdd*s**2 - 2*D1**2*bd1**2*(14*K + 3*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 6*D1**2*bdd1*f*r**2 - 12*D1**2*bdd1*f*r*s + 6*D1**2*bdd1*f*r - 6*D1**2*bdd1*f*s**2 + 6*D1**2*bdd1*f*s - 3*D1**2*bdd1*f + 56*D1**2*bdd1*g2*r**2 + 112*D1**2*bdd1*g2*r*s - 56*D1**2*bdd1*g2*r + 56*D1**2*bdd1*g2*s**2 - 56*D1**2*bdd1*g2*s + 28*D1**2*bdd1*g2 - 12*D1**2*bdd2*f*r**2 - 24*D1**2*bdd2*f*r*s + 24*D1**2*bdd2*f*r - 12*D1**2*bdd2*f*s**2 + 24*D1**2*bdd2*f*s - 12*D1**2*bdd2*f - 28*D1**2*f*fd*r**2 - 56*D1**2*f*fd*r*s + 14*D1**2*f*fd*r - 28*D1**2*f*fd*s**2 + 14*D1**2*f*fd*s - 7*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*s**2 + 4*D1**2*f*gd2*r**2 + 8*D1**2*f*gd2*r*s - 8*D1**2*f*gd2*r + 4*D1**2*f*gd2*s**2 - 8*D1**2*f*gd2*s + 4*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*r + 12*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s + 12*D1**2*f*gdd2 + 12*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*s**2 - 12*D1**2*fd**2 + 4*D1**2*fd*g2*r**2 + 8*D1**2*fd*g2*r*s - 160*D1**2*fd*g2*r + 4*D1**2*fd*g2*s**2 - 160*D1**2*fd*g2*s + 80*D1**2*fd*g2 + 24*D1**2*fd*gd2*r**2 + 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*s**2 - 24*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r**2 + 24*D1**2*fdd*g2*r*s + 24*D1**2*fdd*g2*r + 12*D1**2*fdd*g2*s**2 + 24*D1**2*fdd*g2*s - 12*D1**2*fdd*g2 - 24*D1*Dd*K*f**2*r**2 - 48*D1*Dd*K*f**2*r*s + 36*D1*Dd*K*f**2*r - 24*D1*Dd*K*f**2*s**2 + 36*D1*Dd*K*f**2*s - 18*D1*Dd*K*f**2 + 152*D1*Dd*b2*f*r**2 + 304*D1*Dd*b2*f*r*s - 228*D1*Dd*b2*f*r + 152*D1*Dd*b2*f*s**2 - 228*D1*Dd*b2*f*s + 114*D1*Dd*b2*f - 96*D1*Dd*b2*fd*r**2 - 192*D1*Dd*b2*fd*r*s + 72*D1*Dd*b2*fd*r - 96*D1*Dd*b2*fd*s**2 + 72*D1*Dd*b2*fd*s - 56*D1*Dd*f**2*r**2 - 112*D1*Dd*f**2*r*s + 84*D1*Dd*f**2*r - 56*D1*Dd*f**2*s**2 + 84*D1*Dd*f**2*s - 42*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r + 96*D1*Dd*f*fd*s**2 - 72*D1*Dd*f*fd*s + 16*D1*Dd*f*g2*r**2 + 32*D1*Dd*f*g2*r*s - 24*D1*Dd*f*g2*r + 16*D1*Dd*f*g2*s**2 - 24*D1*Dd*f*g2*s + 12*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 192*D1*Dd*f*gd2*r*s - 168*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 168*D1*Dd*f*gd2*s + 72*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 192*D1*Dd*fd*g2*r*s + 24*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 + 24*D1*Dd*fd*g2*s - 72*D1*Dd*fd*g2 - 48*D1*Ddd*b2*f*r**2 - 96*D1*Ddd*b2*f*r*s + 72*D1*Ddd*b2*f*r - 48*D1*Ddd*b2*f*s**2 + 72*D1*Ddd*b2*f*s - 36*D1*Ddd*b2*f + 24*D1*Ddd*f**2*r**2 + 48*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 96*D1*Ddd*f*g2*r*s - 72*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 72*D1*Ddd*f*g2*s + 36*D1*Ddd*f*g2 - D1*bd1*(D1*(f**2*(6*r + 6*s - 3) + f*(8*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*K*(r**2 + 2*r*(s + 9) + s**2 + 18*s - 9) - 12*r**2 - 24*r*s - 2*r - 12*s**2 - 2*s + 1) - 2*fd*(r + s - 1)*(C*(8*r + 8*s - 4) - 6*K*(2*r + 2*s + 1) - 6*r - 6*s + 3) + 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(C*(8*r + 8*s - 4) - 6*K*(2*r + 2*s - 3) - 6*r - 6*s + 3) + 28*g2*(2*r + 2*s - 1))*(4*r + 4*s - 3)) + 2*D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - 144*Dd**2*b2*f*r**2 - 288*Dd**2*b2*f*r*s + 216*Dd**2*b2*f*r - 144*Dd**2*b2*f*s**2 + 216*Dd**2*b2*f*s - 72*Dd**2*b2*f + 72*Dd**2*f**2*r**2 + 144*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 72*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 36*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 288*Dd**2*f*g2*r*s - 216*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 216*Dd**2*f*g2*s + 72*Dd**2*f*g2))/(42*d**2*k3**4) - D1**2*Pk2*Pkdd3*ct*k1*k2**3*(2*D1**2*bd1*(7*b2*f*(r + s - 1) + (-2*bd1*(r + s) + f*(r + s - 1))*(2*f*(6*C - 3) - 14*g2))*(r + s - 1) + D1*b1*(48*C*D1*f*fd*r**2 + 96*C*D1*f*fd*r*s - 48*C*D1*f*fd*r + 48*C*D1*f*fd*s**2 - 48*C*D1*f*fd*s + 24*C*D1*f*fd + 96*C*Dd*f**2*r**2 + 192*C*Dd*f**2*r*s - 144*C*Dd*f**2*r + 96*C*Dd*f**2*s**2 - 144*C*Dd*f**2*s + 72*C*Dd*f**2 - 28*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 14*D1*b2*fd*r**2 + 28*D1*b2*fd*r*s + 14*D1*b2*fd*s**2 + 14*D1*bd2*f*(r + s - 1)**2 - 4*D1*bdd1*(6*C*f - 3*f - 7*g2)*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - 24*D1*f*fd*r**2 - 48*D1*f*fd*r*s + 24*D1*f*fd*r - 24*D1*f*fd*s**2 + 24*D1*f*fd*s - 12*D1*f*fd - 28*D1*f*gd2*r**2 - 56*D1*f*gd2*r*s + 56*D1*f*gd2*r - 28*D1*f*gd2*s**2 + 56*D1*f*gd2*s - 28*D1*f*gd2 - 28*D1*fd*g2*r**2 - 56*D1*fd*g2*r*s - 28*D1*fd*g2*s**2 + 56*Dd*b2*f*r**2 + 112*Dd*b2*f*r*s - 84*Dd*b2*f*r + 56*Dd*b2*f*s**2 - 84*Dd*b2*f*s + 42*Dd*b2*f - 48*Dd*f**2*r**2 - 96*Dd*f**2*r*s + 72*Dd*f**2*r - 48*Dd*f**2*s**2 + 72*Dd*f**2*s - 36*Dd*f**2 - 112*Dd*f*g2*r**2 - 224*Dd*f*g2*r*s + 168*Dd*f*g2*r - 112*Dd*f*g2*s**2 + 168*Dd*f*g2*s - 84*Dd*f*g2 + bd1*(D1*(f*(-8*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*K*(r + s - 1)**2 + 22*r**2 + 44*r*s - 22*r + 22*s**2 - 22*s + 11) - 8*fd*(6*C - 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 56*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 56*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 8*Dd*(f*(6*C - 3) - 7*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 7*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(4*K + f) - 2*Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(-14*K*bdd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(-8*C*(r + s - 1)**2 + 14*K*s**2 + r**2*(14*K + 11) + r*(28*K*s + 22*s - 22) + 11*s**2 - 22*s + 11) - 2*fdd*(12*C - 6)*(r + s - 1)**2 - 56*gd2*(r + s - 1)**2 + 28*gdd2*(r + s - 1)**2) + 7*D1*bd1*(D1*(4*K + f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 4*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(-f*(8*C - 14*K - 11)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 8*fd*(6*C - 3)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 56*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 56*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 4*Ddd*(f*(6*C - 3) - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 24*Dd**2*(f*(6*C - 3) - 7*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k3**4) + D1**2*Pk2*Pkdd3*ct*k1*k2*st**4*(-2*D1**2*bd1**2*f*(r**2 + r*(2*s - 1) + s*(s - 1)) + D1*b1*(-D1*bdd1*f*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*bd1*(D1*(f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) - fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + b1**2*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(7*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct*k1*k2*st**2*(-D1*(r + s)*(2*D1*bd1**2*f*(6*K - 1)*(r + s - 1) + 6*D1*bdd1*f*(r + s)*(b2 + f*(2*C - 1) - 2*g2) + bd1*(-20*C*D1*f**2*r - 20*C*D1*f**2*s + 48*C*D1*f*fd*r + 48*C*D1*f*fd*s - 48*C*D1*f*fd + 96*C*Dd*f**2*r + 96*C*Dd*f**2*s - 72*C*Dd*f**2 + 12*D1*bd2*f*(r + s - 1) + 9*D1*f**2*r + 9*D1*f**2*s - 24*D1*f*fd*r - 24*D1*f*fd*s + 24*D1*f*fd + 52*D1*f*g2*r + 52*D1*f*g2*s - 24*D1*f*gd2*r - 24*D1*f*gd2*s + 24*D1*f*gd2 - 24*D1*fd*g2*r - 24*D1*fd*g2*s + 24*D1*fd*g2 - 48*Dd*f**2*r - 48*Dd*f**2*s + 36*Dd*f**2 - 96*Dd*f*g2*r - 96*Dd*f*g2*s + 72*Dd*f*g2 + 2*b2*(-13*D1*f*(r + s) + 6*D1*fd*(r + s - 1) + 6*Dd*f*(4*r + 4*s - 3)))) + b1**3*(-3*D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(-3*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 3*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3) + 28*r**2 + 56*r*s - 42*r + 28*s**2 - 42*s + 21) + Ddd*(3*f - 7)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(3*f - 7)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(26*D1**2*K*fd*r**2 + 52*D1**2*K*fd*r*s - 52*D1**2*K*fd*r + 26*D1**2*K*fd*s**2 - 52*D1**2*K*fd*s + 26*D1**2*K*fd - 6*D1**2*K*fdd*r**2 - 12*D1**2*K*fdd*r*s + 12*D1**2*K*fdd*r - 6*D1**2*K*fdd*s**2 + 12*D1**2*K*fdd*s - 6*D1**2*K*fdd + D1**2*bdd1*(3*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 6*D1**2*f*fd*r**2 + 12*D1**2*f*fd*r*s - 12*D1**2*f*fd*r + 6*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s + 6*D1**2*f*fd - 9*D1**2*fd*r**2 - 18*D1**2*fd*r*s + 18*D1**2*fd*r - 9*D1**2*fd*s**2 + 18*D1**2*fd*s - 9*D1**2*fd + D1**2*fdd*r**2 + 2*D1**2*fdd*r*s - 2*D1**2*fdd*r + D1**2*fdd*s**2 - 2*D1**2*fdd*s + D1**2*fdd + 104*D1*Dd*K*f*r**2 + 208*D1*Dd*K*f*r*s - 156*D1*Dd*K*f*r + 104*D1*Dd*K*f*s**2 - 156*D1*Dd*K*f*s + 78*D1*Dd*K*f - 48*D1*Dd*K*fd*r**2 - 96*D1*Dd*K*fd*r*s + 84*D1*Dd*K*fd*r - 48*D1*Dd*K*fd*s**2 + 84*D1*Dd*K*fd*s - 36*D1*Dd*K*fd + 12*D1*Dd*f**2*r**2 + 24*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 12*D1*Dd*f**2*s**2 - 18*D1*Dd*f**2*s + 9*D1*Dd*f**2 - 36*D1*Dd*f*r**2 - 72*D1*Dd*f*r*s + 54*D1*Dd*f*r - 36*D1*Dd*f*s**2 + 54*D1*Dd*f*s - 27*D1*Dd*f + 8*D1*Dd*fd*r**2 + 16*D1*Dd*fd*r*s - 14*D1*Dd*fd*r + 8*D1*Dd*fd*s**2 - 14*D1*Dd*fd*s + 6*D1*Dd*fd - 24*D1*Ddd*K*f*r**2 - 48*D1*Ddd*K*f*r*s + 36*D1*Ddd*K*f*r - 24*D1*Ddd*K*f*s**2 + 36*D1*Ddd*K*f*s - 18*D1*Ddd*K*f + 4*D1*Ddd*f*r**2 + 8*D1*Ddd*f*r*s - 6*D1*Ddd*f*r + 4*D1*Ddd*f*s**2 - 6*D1*Ddd*f*s + 3*D1*Ddd*f - 2*D1*bd1*(D1*(3*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 3*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2) - 21*r**2 - 42*r*s + 28*r - 21*s**2 + 28*s - 14) - Dd*(3*f - 7)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 72*Dd**2*K*f*r**2 - 144*Dd**2*K*f*r*s + 108*Dd**2*K*f*r - 72*Dd**2*K*f*s**2 + 108*Dd**2*K*f*s - 36*Dd**2*K*f + 12*Dd**2*f*r**2 + 24*Dd**2*f*r*s - 18*Dd**2*f*r + 12*Dd**2*f*s**2 - 18*Dd**2*f*s + 6*Dd**2*f) + b1*(40*C*D1**2*f*fd*r**2 + 80*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*r + 40*C*D1**2*f*fd*s**2 - 80*C*D1**2*f*fd*s + 40*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r**2 - 48*C*D1**2*f*fdd*r*s + 48*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 + 48*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s + 48*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 + 48*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 + 80*C*D1*Dd*f**2*r**2 + 160*C*D1*Dd*f**2*r*s - 120*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s**2 - 120*C*D1*Dd*f**2*s + 60*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r**2 - 384*C*D1*Dd*f*fd*r*s + 336*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 336*C*D1*Dd*f*fd*s - 144*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r**2 - 96*C*D1*Ddd*f**2*r*s + 72*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 72*C*D1*Ddd*f**2*s - 36*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r**2 - 288*C*Dd**2*f**2*r*s + 216*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 216*C*Dd**2*f**2*s - 72*C*Dd**2*f**2 - 12*D1**2*K*bdd1*f*r**2 - 24*D1**2*K*bdd1*f*r*s + 12*D1**2*K*bdd1*f*r - 12*D1**2*K*bdd1*f*s**2 + 12*D1**2*K*bdd1*f*s - 6*D1**2*K*bdd1*f + 26*D1**2*b2*fd*r**2 + 52*D1**2*b2*fd*r*s - 52*D1**2*b2*fd*r + 26*D1**2*b2*fd*s**2 - 52*D1**2*b2*fd*s + 26*D1**2*b2*fd - 6*D1**2*b2*fdd*r**2 - 12*D1**2*b2*fdd*r*s + 12*D1**2*b2*fdd*r - 6*D1**2*b2*fdd*s**2 + 12*D1**2*b2*fdd*s - 6*D1**2*b2*fdd + 2*D1**2*bd1**2*(3*f - 7)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1**2*bdd1*f*r**2 + 4*D1**2*bdd1*f*r*s - 2*D1**2*bdd1*f*r + 2*D1**2*bdd1*f*s**2 - 2*D1**2*bdd1*f*s + D1**2*bdd1*f - 6*D1**2*bdd2*f*r**2 - 12*D1**2*bdd2*f*r*s + 12*D1**2*bdd2*f*r - 6*D1**2*bdd2*f*s**2 + 12*D1**2*bdd2*f*s - 6*D1**2*bdd2*f - 18*D1**2*f*fd*r**2 - 36*D1**2*f*fd*r*s + 36*D1**2*f*fd*r - 18*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s - 18*D1**2*f*fd + 12*D1**2*f*fdd*r**2 + 24*D1**2*f*fdd*r*s - 24*D1**2*f*fdd*r + 12*D1**2*f*fdd*s**2 - 24*D1**2*f*fdd*s + 12*D1**2*f*fdd - 52*D1**2*f*gd2*r**2 - 104*D1**2*f*gd2*r*s + 104*D1**2*f*gd2*r - 52*D1**2*f*gd2*s**2 + 104*D1**2*f*gd2*s - 52*D1**2*f*gd2 + 12*D1**2*f*gdd2*r**2 + 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*r + 12*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s + 12*D1**2*f*gdd2 + 12*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 24*D1**2*fd**2*r + 12*D1**2*fd**2*s**2 - 24*D1**2*fd**2*s + 12*D1**2*fd**2 - 52*D1**2*fd*g2*r**2 - 104*D1**2*fd*g2*r*s + 104*D1**2*fd*g2*r - 52*D1**2*fd*g2*s**2 + 104*D1**2*fd*g2*s - 52*D1**2*fd*g2 + 24*D1**2*fd*gd2*r**2 + 48*D1**2*fd*gd2*r*s - 48*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 48*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r**2 + 24*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r + 12*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 + 104*D1*Dd*b2*f*r**2 + 208*D1*Dd*b2*f*r*s - 156*D1*Dd*b2*f*r + 104*D1*Dd*b2*f*s**2 - 156*D1*Dd*b2*f*s + 78*D1*Dd*b2*f - 48*D1*Dd*b2*fd*r**2 - 96*D1*Dd*b2*fd*r*s + 84*D1*Dd*b2*fd*r - 48*D1*Dd*b2*fd*s**2 + 84*D1*Dd*b2*fd*s - 36*D1*Dd*b2*fd - 36*D1*Dd*f**2*r**2 - 72*D1*Dd*f**2*r*s + 54*D1*Dd*f**2*r - 36*D1*Dd*f**2*s**2 + 54*D1*Dd*f**2*s - 27*D1*Dd*f**2 + 96*D1*Dd*f*fd*r**2 + 192*D1*Dd*f*fd*r*s - 168*D1*Dd*f*fd*r + 96*D1*Dd*f*fd*s**2 - 168*D1*Dd*f*fd*s + 72*D1*Dd*f*fd - 208*D1*Dd*f*g2*r**2 - 416*D1*Dd*f*g2*r*s + 312*D1*Dd*f*g2*r - 208*D1*Dd*f*g2*s**2 + 312*D1*Dd*f*g2*s - 156*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r**2 + 192*D1*Dd*f*gd2*r*s - 168*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 168*D1*Dd*f*gd2*s + 72*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r**2 + 192*D1*Dd*fd*g2*r*s - 168*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 168*D1*Dd*fd*g2*s + 72*D1*Dd*fd*g2 - 24*D1*Ddd*b2*f*r**2 - 48*D1*Ddd*b2*f*r*s + 36*D1*Ddd*b2*f*r - 24*D1*Ddd*b2*f*s**2 + 36*D1*Ddd*b2*f*s - 18*D1*Ddd*b2*f + 24*D1*Ddd*f**2*r**2 + 48*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s**2 - 36*D1*Ddd*f**2*s + 18*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r**2 + 96*D1*Ddd*f*g2*r*s - 72*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 72*D1*Ddd*f*g2*s + 36*D1*Ddd*f*g2 + D1*bd1*(D1*(3*f**2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f*(26*K - 9)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 2*fd*(6*K - 1)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*f*(6*K - 1)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + 2*D1*bd2*(D1*(13*f - 6*fd)*(r + s - 1) - 6*Dd*f*(4*r + 4*s - 3))*(r + s - 1) - 72*Dd**2*b2*f*r**2 - 144*Dd**2*b2*f*r*s + 108*Dd**2*b2*f*r - 72*Dd**2*b2*f*s**2 + 108*Dd**2*b2*f*s - 36*Dd**2*b2*f + 72*Dd**2*f**2*r**2 + 144*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 72*Dd**2*f**2*s**2 - 108*Dd**2*f**2*s + 36*Dd**2*f**2 + 144*Dd**2*f*g2*r**2 + 288*Dd**2*f*g2*r*s - 216*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 216*Dd**2*f*g2*s + 72*Dd**2*f*g2))/(42*d**2*k3**2) + D1**2*Pk2*Pkdd3*ct*k1*k2*(-4*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(12*C*f + 7*b2 - 6*f - 14*g2) + D1*b1*(-28*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 4*D1*bdd1*(f*(6*C - 3) - 7*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*b2*(-D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*bd1*(D1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - Dd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + bd1*(-28*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f*(20*C - 3)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 8*fd*(6*C - 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 56*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 56*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 8*Dd*(f*(6*C - 3) - 7*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 7*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(4*K + f) - 2*Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(20*C*D1**2*fd*r**2 + 40*C*D1**2*fd*r*s - 40*C*D1**2*fd*r + 20*C*D1**2*fd*s**2 - 40*C*D1**2*fd*s + 20*C*D1**2*fd - 24*C*D1**2*fdd*r**2 - 48*C*D1**2*fdd*r*s + 48*C*D1**2*fdd*r - 24*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s - 24*C*D1**2*fdd + 80*C*D1*Dd*f*r**2 + 160*C*D1*Dd*f*r*s - 120*C*D1*Dd*f*r + 80*C*D1*Dd*f*s**2 - 120*C*D1*Dd*f*s + 60*C*D1*Dd*f - 192*C*D1*Dd*fd*r**2 - 384*C*D1*Dd*fd*r*s + 336*C*D1*Dd*fd*r - 192*C*D1*Dd*fd*s**2 + 336*C*D1*Dd*fd*s - 144*C*D1*Dd*fd - 96*C*D1*Ddd*f*r**2 - 192*C*D1*Ddd*f*r*s + 144*C*D1*Ddd*f*r - 96*C*D1*Ddd*f*s**2 + 144*C*D1*Ddd*f*s - 72*C*D1*Ddd*f - 288*C*Dd**2*f*r**2 - 576*C*Dd**2*f*r*s + 432*C*Dd**2*f*r - 288*C*Dd**2*f*s**2 + 432*C*Dd**2*f*s - 144*C*Dd**2*f + 84*D1**2*K*bd1*r**2 + 168*D1**2*K*bd1*r*s - 112*D1**2*K*bd1*r + 84*D1**2*K*bd1*s**2 - 112*D1**2*K*bd1*s + 56*D1**2*K*bd1 - 42*D1**2*K*bdd1*r**2 - 84*D1**2*K*bdd1*r*s + 56*D1**2*K*bdd1*r - 42*D1**2*K*bdd1*s**2 + 56*D1**2*K*bdd1*s - 28*D1**2*K*bdd1 + 21*D1**2*bd1*f*r**2 + 42*D1**2*bd1*f*r*s - 28*D1**2*bd1*f*r + 21*D1**2*bd1*f*s**2 - 28*D1**2*bd1*f*s + 14*D1**2*bd1*f - 14*D1**2*bdd2*(r + s - 1)**2 - 3*D1**2*fd*r**2 - 6*D1**2*fd*r*s + 6*D1**2*fd*r - 3*D1**2*fd*s**2 + 6*D1**2*fd*s - 3*D1**2*fd + 12*D1**2*fdd*r**2 + 24*D1**2*fdd*r*s - 24*D1**2*fdd*r + 12*D1**2*fdd*s**2 - 24*D1**2*fdd*s + 12*D1**2*fdd - 56*D1**2*gd2*r**2 - 112*D1**2*gd2*r*s + 112*D1**2*gd2*r - 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s - 56*D1**2*gd2 + 28*D1**2*gdd2*r**2 + 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*r + 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s + 28*D1**2*gdd2 - 336*D1*Dd*K*bd1*r**2 - 672*D1*Dd*K*bd1*r*s + 476*D1*Dd*K*bd1*r - 336*D1*Dd*K*bd1*s**2 + 476*D1*Dd*K*bd1*s - 168*D1*Dd*K*bd1 + 112*D1*Dd*b2*r**2 + 224*D1*Dd*b2*r*s - 168*D1*Dd*b2*r + 112*D1*Dd*b2*s**2 - 168*D1*Dd*b2*s + 84*D1*Dd*b2 - 12*D1*Dd*f*r**2 - 24*D1*Dd*f*r*s + 18*D1*Dd*f*r - 12*D1*Dd*f*s**2 + 18*D1*Dd*f*s - 9*D1*Dd*f + 96*D1*Dd*fd*r**2 + 192*D1*Dd*fd*r*s - 168*D1*Dd*fd*r + 96*D1*Dd*fd*s**2 - 168*D1*Dd*fd*s + 72*D1*Dd*fd - 224*D1*Dd*g2*r**2 - 448*D1*Dd*g2*r*s + 336*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 336*D1*Dd*g2*s - 168*D1*Dd*g2 + 224*D1*Dd*gd2*r**2 + 448*D1*Dd*gd2*r*s - 392*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 392*D1*Dd*gd2*s + 168*D1*Dd*gd2 - 56*D1*Ddd*b2*r**2 - 112*D1*Ddd*b2*r*s + 84*D1*Ddd*b2*r - 56*D1*Ddd*b2*s**2 + 84*D1*Ddd*b2*s - 42*D1*Ddd*b2 + 48*D1*Ddd*f*r**2 + 96*D1*Ddd*f*r*s - 72*D1*Ddd*f*r + 48*D1*Ddd*f*s**2 - 72*D1*Ddd*f*s + 36*D1*Ddd*f + 112*D1*Ddd*g2*r**2 + 224*D1*Ddd*g2*r*s - 168*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 168*D1*Ddd*g2*s + 84*D1*Ddd*g2 + 28*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) - 168*Dd**2*b2*r**2 - 336*Dd**2*b2*r*s + 252*Dd**2*b2*r - 168*Dd**2*b2*s**2 + 252*Dd**2*b2*s - 84*Dd**2*b2 + 144*Dd**2*f*r**2 + 288*Dd**2*f*r*s - 216*Dd**2*f*r + 144*Dd**2*f*s**2 - 216*Dd**2*f*s + 72*Dd**2*f + 336*Dd**2*g2*r**2 + 672*Dd**2*g2*r*s - 504*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 504*Dd**2*g2*s + 168*Dd**2*g2))/(21*d**2*k3**2) + D1**2*Pk2*Pkdd3*f**2*k1**6*st**4*(D1**2*(-f*(61*fd - 50*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 300*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(-61*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 100*fd*(4*r + 4*s - 3)**2) + 50*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 300*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(3003*d**2*k3**6) - 5*D1**2*Pk2*Pkdd3*f**2*k1**4*k2**2*st**6*(D1**2*(f*(73*fd - 30*fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 180*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(Dd*(73*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 60*fd*(4*r + 4*s - 3)**2) - 30*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 180*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(18018*d**2*k3**6) + 5*D1**2*Pk2*Pkdd3*f**2*k1**2*k2**4*st**8*(D1**2*(f*(2*fd - fdd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*fd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + D1*f*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r + 4*s - 3)**2) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1287*d**2*k3**6) + D1**2*Pk2*Pkdd3*f*k1**6*st**2*(50*D1**2*bdd1*f**2*(r + s - 1)**2 - D1*bd1*f*(r + s - 1)*(67*D1*f*(r + s - 1) - 100*D1*fd*(3*r + 3*s - 2) - 100*Dd*f*(4*r + 4*s - 3)) + b1*(D1**2*(-f*(67*fd - 50*fdd)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 100*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(-67*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 100*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 50*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 300*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(693*d**2*k3**6) + D1**2*Pk2*Pkdd3*f*k1**4*st**4*(D1**2*bdd1*f**2*(7*r**2 + 2*r*(7*s - 4) + 7*s**2 - 8*s + 4) - 2*D1*bd1*f*(D1*(f*(7*r**2 + 14*r*s - 8*r + 7*s**2 - 8*s + 4) - fd*(21*r**2 + 42*r*s - 29*r + 21*s**2 - 29*s + 8)) - Dd*f*(28*r**2 + r*(56*s - 37) + 28*s**2 - 37*s + 12)) + b1*(D1**2*(-f*(2*fd - fdd)*(21*r**2 + r*(42*s - 34) + 21*s**2 - 34*s + 17) + 2*fd**2*(21*r**2 + r*(42*s - 34) + 21*s**2 - 34*s + 13)) + D1*f*(2*Dd*(-7*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + fd*(84*r**2 + 168*r*s - 131*r + 84*s**2 - 131*s + 51)) + 7*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 42*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(231*d**2*k3**4) - 5*D1**2*Pk2*Pkdd3*f*k1**2*k2**4*st**6*(24*D1**2*b1*f*fd*r**2 + 48*D1**2*b1*f*fd*r*s - 32*D1**2*b1*f*fd*r + 24*D1**2*b1*f*fd*s**2 - 32*D1**2*b1*f*fd*s + 16*D1**2*b1*f*fd - 12*D1**2*b1*f*fdd*r**2 - 24*D1**2*b1*f*fdd*r*s + 16*D1**2*b1*f*fdd*r - 12*D1**2*b1*f*fdd*s**2 + 16*D1**2*b1*f*fdd*s - 8*D1**2*b1*f*fdd - 24*D1**2*b1*fd**2*r**2 - 48*D1**2*b1*fd**2*r*s + 32*D1**2*b1*fd**2*r - 24*D1**2*b1*fd**2*s**2 + 32*D1**2*b1*fd**2*s - 8*D1**2*b1*fd**2 - 4*D1**2*bdd1*f**2*(r + s - 1)**2 + 4*D1**2*f**2*fd*r**2 + 8*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r + 4*D1**2*f**2*fd*s**2 - 6*D1**2*f**2*fd*s + 3*D1**2*f**2*fd + 32*D1*Dd*b1*f**2*r**2 + 64*D1*Dd*b1*f**2*r*s - 48*D1*Dd*b1*f**2*r + 32*D1*Dd*b1*f**2*s**2 - 48*D1*Dd*b1*f**2*s + 24*D1*Dd*b1*f**2 - 96*D1*Dd*b1*f*fd*r**2 - 192*D1*Dd*b1*f*fd*r*s + 136*D1*Dd*b1*f*fd*r - 96*D1*Dd*b1*f*fd*s**2 + 136*D1*Dd*b1*f*fd*s - 48*D1*Dd*b1*f*fd + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 - 16*D1*Ddd*b1*f**2*r**2 - 32*D1*Ddd*b1*f**2*r*s + 24*D1*Ddd*b1*f**2*r - 16*D1*Ddd*b1*f**2*s**2 + 24*D1*Ddd*b1*f**2*s - 12*D1*Ddd*b1*f**2 + 8*D1*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) + D1*fd*(-3*r - 3*s + 2) + Dd*f*(-4*r - 4*s + 3)) - 48*Dd**2*b1*f**2*r**2 - 96*Dd**2*b1*f**2*r*s + 72*Dd**2*b1*f**2*r - 48*Dd**2*b1*f**2*s**2 + 72*Dd**2*b1*f**2*s - 24*Dd**2*b1*f**2)/(1386*d**2*k3**6) + D1**2*Pk2*Pkdd3*f*k1**2*k2**4*st**4*(D1**2*(f*(-fd*(8*C - 4)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fdd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (-11*K*bd1 + 22*gd2)*(r + s - 1)**2) + fd*(fd*(8*C - 4)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + (-11*K*b1 + 22*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1))) + D1*f*(Dd*(f*(4 - 8*C)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + fd*(8*C - 4)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) + (-11*K*b1 + 22*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Ddd*f*(4*C - 2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + Dd**2*f**2*(24*C - 12)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(77*d**2*k3**6) + 5*D1**2*Pk2*Pkdd3*f*k1**2*k2**2*st**6*(-D1**2*bdd1*f**2*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 4) + 2*D1*bd1*f*(D1*(f*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 4) - fd*(15*r**2 + 30*r*s - 23*r + 15*s**2 - 23*s + 8)) - Dd*f*(20*r**2 + r*(40*s - 31) + 20*s**2 - 31*s + 12)) + b1*(D1**2*(f*(2*fd - fdd)*(15*r**2 + r*(30*s - 22) + 15*s**2 - 22*s + 11) - 2*fd**2*(15*r**2 + r*(30*s - 22) + 15*s**2 - 22*s + 7)) + D1*f*(2*Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(60*r**2 + 120*r*s - 89*r + 60*s**2 - 89*s + 33)) - 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(1386*d**2*k3**4) + D1**2*Pk2*Pkdd3*f*k1**2*k2**2*st**4*(24*C*D1**2*f*fd*r**2 + 48*C*D1**2*f*fd*r*s - 32*C*D1**2*f*fd*r + 24*C*D1**2*f*fd*s**2 - 32*C*D1**2*f*fd*s + 16*C*D1**2*f*fd - 12*C*D1**2*f*fdd*r**2 - 24*C*D1**2*f*fdd*r*s + 16*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s**2 + 16*C*D1**2*f*fdd*s - 8*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r**2 - 48*C*D1**2*fd**2*r*s + 32*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 + 32*C*D1**2*fd**2*s - 8*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r**2 + 64*C*D1*Dd*f**2*r*s - 48*C*D1*Dd*f**2*r + 32*C*D1*Dd*f**2*s**2 - 48*C*D1*Dd*f**2*s + 24*C*D1*Dd*f**2 - 96*C*D1*Dd*f*fd*r**2 - 192*C*D1*Dd*f*fd*r*s + 136*C*D1*Dd*f*fd*r - 96*C*D1*Dd*f*fd*s**2 + 136*C*D1*Dd*f*fd*s - 48*C*D1*Dd*f*fd - 16*C*D1*Ddd*f**2*r**2 - 32*C*D1*Ddd*f**2*r*s + 24*C*D1*Ddd*f**2*r - 16*C*D1*Ddd*f**2*s**2 + 24*C*D1*Ddd*f**2*s - 12*C*D1*Ddd*f**2 - 48*C*Dd**2*f**2*r**2 - 96*C*Dd**2*f**2*r*s + 72*C*Dd**2*f**2*r - 48*C*Dd**2*f**2*s**2 + 72*C*Dd**2*f**2*s - 24*C*Dd**2*f**2 + 22*D1**2*K*b1*fd*r**2 + 44*D1**2*K*b1*fd*r*s - 22*D1**2*K*b1*fd*r + 22*D1**2*K*b1*fd*s**2 - 22*D1**2*K*b1*fd*s + 11*D1**2*K*b1*fd + 11*D1**2*K*bd1*f*r**2 + 22*D1**2*K*bd1*f*r*s - 22*D1**2*K*bd1*f*r + 11*D1**2*K*bd1*f*s**2 - 22*D1**2*K*bd1*f*s + 11*D1**2*K*bd1*f + 11*D1**2*bd2*f*(r + s - 1)**2 - 12*D1**2*f*fd*r**2 - 24*D1**2*f*fd*r*s + 16*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 6*D1**2*f*fdd*r**2 + 12*D1**2*f*fdd*r*s - 8*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s + 4*D1**2*f*fdd - 22*D1**2*f*gd2*r**2 - 44*D1**2*f*gd2*r*s + 44*D1**2*f*gd2*r - 22*D1**2*f*gd2*s**2 + 44*D1**2*f*gd2*s - 22*D1**2*f*gd2 + 12*D1**2*fd**2*r**2 + 24*D1**2*fd**2*r*s - 16*D1**2*fd**2*r + 12*D1**2*fd**2*s**2 - 16*D1**2*fd**2*s + 4*D1**2*fd**2 - 44*D1**2*fd*g2*r**2 - 88*D1**2*fd*g2*r*s + 44*D1**2*fd*g2*r - 44*D1**2*fd*g2*s**2 + 44*D1**2*fd*g2*s - 22*D1**2*fd*g2 + 44*D1*Dd*K*b1*f*r**2 + 88*D1*Dd*K*b1*f*r*s - 66*D1*Dd*K*b1*f*r + 44*D1*Dd*K*b1*f*s**2 - 66*D1*Dd*K*b1*f*s + 33*D1*Dd*K*b1*f - 16*D1*Dd*f**2*r**2 - 32*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 48*D1*Dd*f*fd*r**2 + 96*D1*Dd*f*fd*r*s - 68*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 68*D1*Dd*f*fd*s + 24*D1*Dd*f*fd - 88*D1*Dd*f*g2*r**2 - 176*D1*Dd*f*g2*r*s + 132*D1*Dd*f*g2*r - 88*D1*Dd*f*g2*s**2 + 132*D1*Dd*f*g2*s - 66*D1*Dd*f*g2 + 8*D1*Ddd*f**2*r**2 + 16*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 8*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 11*D1*b2*(D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) + 24*Dd**2*f**2*r**2 + 48*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 24*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 12*Dd**2*f**2)/(77*d**2*k3**4) + D1**2*Pk2*Pkdd3*k1**6*(-10*D1**2*bd1**2*f**2*(r + s - 1)**2 + 2*D1*b1*f*(-5*D1*bdd1*f*(r + s - 1) + 2*bd1*(2*D1*f*(r + s - 1) - 5*D1*fd*(2*r + 2*s - 1) - 5*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + b1**2*(D1**2*(f*(4*fd - 5*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 10*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(2*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 5*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 5*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 30*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k3**6) + D1**2*Pk2*Pkdd3*k1**4*k2**2*st**2*(-102*C*D1**2*f**2*fd*r**2 - 204*C*D1**2*f**2*fd*r*s + 136*C*D1**2*f**2*fd*r - 102*C*D1**2*f**2*fd*s**2 + 136*C*D1**2*f**2*fd*s - 68*C*D1**2*f**2*fd + 150*C*D1**2*f**2*fdd*r**2 + 300*C*D1**2*f**2*fdd*r*s - 200*C*D1**2*f**2*fdd*r + 150*C*D1**2*f**2*fdd*s**2 - 200*C*D1**2*f**2*fdd*s + 100*C*D1**2*f**2*fdd + 300*C*D1**2*f*fd**2*r**2 + 600*C*D1**2*f*fd**2*r*s - 400*C*D1**2*f*fd**2*r + 300*C*D1**2*f*fd**2*s**2 - 400*C*D1**2*f*fd**2*s + 100*C*D1**2*f*fd**2 - 136*C*D1*Dd*f**3*r**2 - 272*C*D1*Dd*f**3*r*s + 204*C*D1*Dd*f**3*r - 136*C*D1*Dd*f**3*s**2 + 204*C*D1*Dd*f**3*s - 102*C*D1*Dd*f**3 + 1200*C*D1*Dd*f**2*fd*r**2 + 2400*C*D1*Dd*f**2*fd*r*s - 1700*C*D1*Dd*f**2*fd*r + 1200*C*D1*Dd*f**2*fd*s**2 - 1700*C*D1*Dd*f**2*fd*s + 600*C*D1*Dd*f**2*fd + 200*C*D1*Ddd*f**3*r**2 + 400*C*D1*Ddd*f**3*r*s - 300*C*D1*Ddd*f**3*r + 200*C*D1*Ddd*f**3*s**2 - 300*C*D1*Ddd*f**3*s + 150*C*D1*Ddd*f**3 + 600*C*Dd**2*f**3*r**2 + 1200*C*Dd**2*f**3*r*s - 900*C*Dd**2*f**3*r + 600*C*Dd**2*f**3*s**2 - 900*C*Dd**2*f**3*s + 300*C*Dd**2*f**3 + 33*D1**2*K*bdd1*f**2*r**2 + 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*r + 33*D1**2*K*bdd1*f**2*s**2 - 66*D1**2*K*bdd1*f**2*s + 33*D1**2*K*bdd1*f**2 - 660*D1**2*bd1**2*f**2*(r + s - 1)**2 + 51*D1**2*f**2*fd*r**2 + 102*D1**2*f**2*fd*r*s - 68*D1**2*f**2*fd*r + 51*D1**2*f**2*fd*s**2 - 68*D1**2*f**2*fd*s + 34*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r**2 - 150*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 100*D1**2*f**2*fdd*s - 50*D1**2*f**2*fdd + 66*D1**2*f**2*gd2*r**2 + 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*r + 66*D1**2*f**2*gd2*s**2 - 132*D1**2*f**2*gd2*s + 66*D1**2*f**2*gd2 - 66*D1**2*f**2*gdd2*r**2 - 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*r - 66*D1**2*f**2*gdd2*s**2 + 132*D1**2*f**2*gdd2*s - 66*D1**2*f**2*gdd2 - 150*D1**2*f*fd**2*r**2 - 300*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 200*D1**2*f*fd**2*s - 50*D1**2*f*fd**2 + 132*D1**2*f*fd*g2*r**2 + 264*D1**2*f*fd*g2*r*s - 132*D1**2*f*fd*g2*r + 132*D1**2*f*fd*g2*s**2 - 132*D1**2*f*fd*g2*s + 66*D1**2*f*fd*g2 - 264*D1**2*f*fd*gd2*r**2 - 528*D1**2*f*fd*gd2*r*s + 396*D1**2*f*fd*gd2*r - 264*D1**2*f*fd*gd2*s**2 + 396*D1**2*f*fd*gd2*s - 132*D1**2*f*fd*gd2 - 132*D1**2*f*fdd*g2*r**2 - 264*D1**2*f*fdd*g2*r*s + 132*D1**2*f*fdd*g2*r - 132*D1**2*f*fdd*g2*s**2 + 132*D1**2*f*fdd*g2*s - 66*D1**2*f*fdd*g2 - 132*D1**2*fd**2*g2*r**2 - 264*D1**2*fd**2*g2*r*s + 132*D1**2*fd**2*g2*r - 132*D1**2*fd**2*g2*s**2 + 132*D1**2*fd**2*g2*s + 68*D1*Dd*f**3*r**2 + 136*D1*Dd*f**3*r*s - 102*D1*Dd*f**3*r + 68*D1*Dd*f**3*s**2 - 102*D1*Dd*f**3*s + 51*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r**2 - 1200*D1*Dd*f**2*fd*r*s + 850*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 850*D1*Dd*f**2*fd*s - 300*D1*Dd*f**2*fd + 264*D1*Dd*f**2*g2*r**2 + 528*D1*Dd*f**2*g2*r*s - 396*D1*Dd*f**2*g2*r + 264*D1*Dd*f**2*g2*s**2 - 396*D1*Dd*f**2*g2*s + 198*D1*Dd*f**2*g2 - 528*D1*Dd*f**2*gd2*r**2 - 1056*D1*Dd*f**2*gd2*r*s + 924*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s**2 + 924*D1*Dd*f**2*gd2*s - 396*D1*Dd*f**2*gd2 - 1056*D1*Dd*f*fd*g2*r**2 - 2112*D1*Dd*f*fd*g2*r*s + 1320*D1*Dd*f*fd*g2*r - 1056*D1*Dd*f*fd*g2*s**2 + 1320*D1*Dd*f*fd*g2*s - 396*D1*Dd*f*fd*g2 - 100*D1*Ddd*f**3*r**2 - 200*D1*Ddd*f**3*r*s + 150*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 150*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 264*D1*Ddd*f**2*g2*r**2 - 528*D1*Ddd*f**2*g2*r*s + 396*D1*Ddd*f**2*g2*r - 264*D1*Ddd*f**2*g2*s**2 + 396*D1*Ddd*f**2*g2*s - 198*D1*Ddd*f**2*g2 + 33*D1*bd1*f*(D1*(-K*f*(r + s - 1) + 2*K*fd*(2*r + 2*s - 1) + 2*f**2*(r + s - 1)) + 2*Dd*K*f*(4*r + 4*s - 3))*(r + s - 1) - 300*Dd**2*f**3*r**2 - 600*Dd**2*f**3*r*s + 450*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 450*Dd**2*f**3*s - 150*Dd**2*f**3 - 792*Dd**2*f**2*g2*r**2 - 1584*Dd**2*f**2*g2*r*s + 1188*Dd**2*f**2*g2*r - 792*Dd**2*f**2*g2*s**2 + 1188*Dd**2*f**2*g2*s - 396*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(f*(17*fd - 10*fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 20*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(17*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 20*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - 10*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 60*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*b1*(-2*D1**2*K*f*fd*r**2 - 4*D1**2*K*f*fd*r*s + 2*D1**2*K*f*fd*r - 2*D1**2*K*f*fd*s**2 + 2*D1**2*K*f*fd*s - D1**2*K*f*fd + 2*D1**2*K*f*fdd*r**2 + 4*D1**2*K*f*fdd*r*s - 2*D1**2*K*f*fdd*r + 2*D1**2*K*f*fdd*s**2 - 2*D1**2*K*f*fdd*s + D1**2*K*f*fdd + 2*D1**2*K*fd**2*r**2 + 4*D1**2*K*fd**2*r*s - 2*D1**2*K*fd**2*r + 2*D1**2*K*fd**2*s**2 - 2*D1**2*K*fd**2*s - 20*D1**2*bdd1*f**2*(r + s - 1)**2 + 6*D1**2*f**2*fd*r**2 + 12*D1**2*f**2*fd*r*s - 8*D1**2*f**2*fd*r + 6*D1**2*f**2*fd*s**2 - 8*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 4*D1*Dd*K*f**2*r**2 - 8*D1*Dd*K*f**2*r*s + 6*D1*Dd*K*f**2*r - 4*D1*Dd*K*f**2*s**2 + 6*D1*Dd*K*f**2*s - 3*D1*Dd*K*f**2 + 16*D1*Dd*K*f*fd*r**2 + 32*D1*Dd*K*f*fd*r*s - 20*D1*Dd*K*f*fd*r + 16*D1*Dd*K*f*fd*s**2 - 20*D1*Dd*K*f*fd*s + 6*D1*Dd*K*f*fd + 8*D1*Dd*f**3*r**2 + 16*D1*Dd*f**3*r*s - 12*D1*Dd*f**3*r + 8*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 6*D1*Dd*f**3 + 4*D1*Ddd*K*f**2*r**2 + 8*D1*Ddd*K*f**2*r*s - 6*D1*Ddd*K*f**2*r + 4*D1*Ddd*K*f**2*s**2 - 6*D1*Ddd*K*f**2*s + 3*D1*Ddd*K*f**2 + 2*D1*bd1*f*(r + s - 1)*(17*D1*f*(r + s - 1) - 20*D1*fd*(2*r + 2*s - 1) - 20*Dd*f*(4*r + 4*s - 3)) + 12*Dd**2*K*f**2*r**2 + 24*Dd**2*K*f**2*r*s - 18*Dd**2*K*f**2*r + 12*Dd**2*K*f**2*s**2 - 18*Dd**2*K*f**2*s + 6*Dd**2*K*f**2))/(1386*d**2*k3**6) + D1**2*Pk2*Pkdd3*k1**4*k2**2*(12*D1**2*K*bd1**2*f*(r + s - 1)**2 + D1**2*bdd1*f*(r + s - 1)**2*(10*C*f + 12*K*b1 - 5*f - 12*g2) - 2*D1*bd1*(D1*(f**2*(4*C + 6*b1 - 2)*(r + s - 1) - f*fd*(10*C - 5)*(2*r + 2*s - 1) - f*(r + s - 1)*(-5*K*b1 + 5*g2 - 12*gd2) + 12*fd*(r + s)*(-K*b1 + g2)) - Dd*f*(4*r + 4*s - 3)*(10*C*f + 12*K*b1 - 5*f - 12*g2))*(r + s - 1) - b1*(D1**2*(f*(fd*(8*C + 6*b1 - 4)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - fdd*(10*C - 5)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + (-10*gd2 + 12*gdd2)*(r + s - 1)**2) - (r + s)*(fd**2*(20*C - 10)*(r + s - 1) - 24*fd*gd2*(r + s - 1) + 5*fd*(r + s)*(-K*b1 + 2*g2) - 6*fdd*(r + s)*(-K*b1 + 2*g2))) + D1*(Dd*(f**2*(8*C + 6*b1 - 4)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(20*K*b1*r**2 + 40*K*b1*r*s - 30*K*b1*r + 20*K*b1*s**2 - 30*K*b1*s + 15*K*b1 - fd*(20*C - 10)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 10*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 96*gd2*r**2 + 192*gd2*r*s - 168*gd2*r + 96*gd2*s**2 - 168*gd2*s + 72*gd2) + 12*fd*(-K*b1 + 2*g2)*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - Ddd*f*(10*C*f + 6*K*b1 - 5*f - 12*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(10*C*f + 6*K*b1 - 5*f - 12*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k3**6) + D1**2*Pk2*Pkdd3*k1**4*st**2*(102*C*D1**2*f**2*fd*r**2 + 204*C*D1**2*f**2*fd*r*s - 136*C*D1**2*f**2*fd*r + 102*C*D1**2*f**2*fd*s**2 - 136*C*D1**2*f**2*fd*s + 68*C*D1**2*f**2*fd - 150*C*D1**2*f**2*fdd*r**2 - 300*C*D1**2*f**2*fdd*r*s + 200*C*D1**2*f**2*fdd*r - 150*C*D1**2*f**2*fdd*s**2 + 200*C*D1**2*f**2*fdd*s - 100*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*r**2 - 600*C*D1**2*f*fd**2*r*s + 400*C*D1**2*f*fd**2*r - 300*C*D1**2*f*fd**2*s**2 + 400*C*D1**2*f*fd**2*s - 100*C*D1**2*f*fd**2 + 136*C*D1*Dd*f**3*r**2 + 272*C*D1*Dd*f**3*r*s - 204*C*D1*Dd*f**3*r + 136*C*D1*Dd*f**3*s**2 - 204*C*D1*Dd*f**3*s + 102*C*D1*Dd*f**3 - 1200*C*D1*Dd*f**2*fd*r**2 - 2400*C*D1*Dd*f**2*fd*r*s + 1700*C*D1*Dd*f**2*fd*r - 1200*C*D1*Dd*f**2*fd*s**2 + 1700*C*D1*Dd*f**2*fd*s - 600*C*D1*Dd*f**2*fd - 200*C*D1*Ddd*f**3*r**2 - 400*C*D1*Ddd*f**3*r*s + 300*C*D1*Ddd*f**3*r - 200*C*D1*Ddd*f**3*s**2 + 300*C*D1*Ddd*f**3*s - 150*C*D1*Ddd*f**3 - 600*C*Dd**2*f**3*r**2 - 1200*C*Dd**2*f**3*r*s + 900*C*Dd**2*f**3*r - 600*C*Dd**2*f**3*s**2 + 900*C*Dd**2*f**3*s - 300*C*Dd**2*f**3 - 33*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*K*bdd1*f**2*r*s + 66*D1**2*K*bdd1*f**2*r - 33*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s - 33*D1**2*K*bdd1*f**2 + 66*D1**2*b2*f*fd*r**2 + 132*D1**2*b2*f*fd*r*s - 66*D1**2*b2*f*fd*r + 66*D1**2*b2*f*fd*s**2 - 66*D1**2*b2*f*fd*s + 33*D1**2*b2*f*fd - 66*D1**2*b2*f*fdd*r**2 - 132*D1**2*b2*f*fdd*r*s + 66*D1**2*b2*f*fdd*r - 66*D1**2*b2*f*fdd*s**2 + 66*D1**2*b2*f*fdd*s - 33*D1**2*b2*f*fdd - 66*D1**2*b2*fd**2*r**2 - 132*D1**2*b2*fd**2*r*s + 66*D1**2*b2*fd**2*r - 66*D1**2*b2*fd**2*s**2 + 66*D1**2*b2*fd**2*s + 132*D1**2*bd1**2*f**2*(3*r**2 + r*(6*s - 5) + 3*s**2 - 5*s + 2) + 33*D1**2*bd2*f**2*r**2 + 66*D1**2*bd2*f**2*r*s - 66*D1**2*bd2*f**2*r + 33*D1**2*bd2*f**2*s**2 - 66*D1**2*bd2*f**2*s + 33*D1**2*bd2*f**2 - 132*D1**2*bd2*f*fd*r**2 - 264*D1**2*bd2*f*fd*r*s + 198*D1**2*bd2*f*fd*r - 132*D1**2*bd2*f*fd*s**2 + 198*D1**2*bd2*f*fd*s - 66*D1**2*bd2*f*fd - 33*D1**2*bdd2*f**2*r**2 - 66*D1**2*bdd2*f**2*r*s + 66*D1**2*bdd2*f**2*r - 33*D1**2*bdd2*f**2*s**2 + 66*D1**2*bdd2*f**2*s - 33*D1**2*bdd2*f**2 - 51*D1**2*f**2*fd*r**2 - 102*D1**2*f**2*fd*r*s + 68*D1**2*f**2*fd*r - 51*D1**2*f**2*fd*s**2 + 68*D1**2*f**2*fd*s - 34*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r**2 + 150*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd - 66*D1**2*f**2*gd2*r**2 - 132*D1**2*f**2*gd2*r*s + 132*D1**2*f**2*gd2*r - 66*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s - 66*D1**2*f**2*gd2 + 66*D1**2*f**2*gdd2*r**2 + 132*D1**2*f**2*gdd2*r*s - 132*D1**2*f**2*gdd2*r + 66*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 66*D1**2*f**2*gdd2 + 150*D1**2*f*fd**2*r**2 + 300*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 50*D1**2*f*fd**2 - 132*D1**2*f*fd*g2*r**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 132*D1**2*f*fd*g2*s**2 + 132*D1**2*f*fd*g2*s - 66*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 + 528*D1**2*f*fd*gd2*r*s - 396*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 396*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r**2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 132*D1*Dd*b2*f**2*r**2 + 264*D1*Dd*b2*f**2*r*s - 198*D1*Dd*b2*f**2*r + 132*D1*Dd*b2*f**2*s**2 - 198*D1*Dd*b2*f**2*s + 99*D1*Dd*b2*f**2 - 528*D1*Dd*b2*f*fd*r**2 - 1056*D1*Dd*b2*f*fd*r*s + 660*D1*Dd*b2*f*fd*r - 528*D1*Dd*b2*f*fd*s**2 + 660*D1*Dd*b2*f*fd*s - 198*D1*Dd*b2*f*fd - 264*D1*Dd*bd2*f**2*r**2 - 528*D1*Dd*bd2*f**2*r*s + 462*D1*Dd*bd2*f**2*r - 264*D1*Dd*bd2*f**2*s**2 + 462*D1*Dd*bd2*f**2*s - 198*D1*Dd*bd2*f**2 - 68*D1*Dd*f**3*r**2 - 136*D1*Dd*f**3*r*s + 102*D1*Dd*f**3*r - 68*D1*Dd*f**3*s**2 + 102*D1*Dd*f**3*s - 51*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r**2 + 1200*D1*Dd*f**2*fd*r*s - 850*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 850*D1*Dd*f**2*fd*s + 300*D1*Dd*f**2*fd - 264*D1*Dd*f**2*g2*r**2 - 528*D1*Dd*f**2*g2*r*s + 396*D1*Dd*f**2*g2*r - 264*D1*Dd*f**2*g2*s**2 + 396*D1*Dd*f**2*g2*s - 198*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 + 1056*D1*Dd*f**2*gd2*r*s - 924*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 924*D1*Dd*f**2*gd2*s + 396*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r**2 + 2112*D1*Dd*f*fd*g2*r*s - 1320*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1320*D1*Dd*f*fd*g2*s + 396*D1*Dd*f*fd*g2 - 132*D1*Ddd*b2*f**2*r**2 - 264*D1*Ddd*b2*f**2*r*s + 198*D1*Ddd*b2*f**2*r - 132*D1*Ddd*b2*f**2*s**2 + 198*D1*Ddd*b2*f**2*s - 99*D1*Ddd*b2*f**2 + 100*D1*Ddd*f**3*r**2 + 200*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 150*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r**2 + 528*D1*Ddd*f**2*g2*r*s - 396*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 396*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 33*D1*K*bd1*f*(r + s - 1)*(D1*f*(r + s - 1) - 2*D1*fd*(2*r + 2*s - 1) - 2*Dd*f*(4*r + 4*s - 3)) - 396*Dd**2*b2*f**2*r**2 - 792*Dd**2*b2*f**2*r*s + 594*Dd**2*b2*f**2*r - 396*Dd**2*b2*f**2*s**2 + 594*Dd**2*b2*f**2*s - 198*Dd**2*b2*f**2 + 300*Dd**2*f**3*r**2 + 600*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 450*Dd**2*f**3*s + 150*Dd**2*f**3 + 792*Dd**2*f**2*g2*r**2 + 1584*Dd**2*f**2*g2*r*s - 1188*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 1188*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2 - 66*b1**2*(D1**2*(f*(fd*(10*r**2 + 20*r*s - 14*r + 10*s**2 - 14*s + 7) - 2*fdd*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2)) - 2*fd**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1)) + D1*f*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 4*fd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) - 3*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 18*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 33*b1*(-2*D1**2*bdd1*f**2*(6*r**2 + 2*r*(6*s - 5) + 6*s**2 - 10*s + 5) + 4*D1*bd1*f*(D1*(f*(5*r**2 + 10*r*s - 8*r + 5*s**2 - 8*s + 4) - 6*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - Dd*f*(24*r**2 + r*(48*s - 38) + 24*s**2 - 38*s + 15)) + K*(D1**2*(-f*(fd - fdd)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*fd**2*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(Dd*(-f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*fd*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))))/(1386*d**2*k3**4) + D1**2*Pk2*Pkdd3*k1**4*(D1*(r + s - 1)*(-12*D1*K*bd1**2*f*(r + s - 1) - D1*bdd1*f*(f*(10*C - 5) - 12*g2)*(r + s - 1) + b2*(-6*D1*bdd1*f*(r + s - 1) + bd1*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3))) - 2*bd1*(6*D1*bd2*f*(r + s - 1) + D1*(f**2*(2 - 4*C)*(r + s - 1) + f*fd*(10*C - 5)*(2*r + 2*s - 1) + f*(5*g2 - 12*gd2)*(r + s - 1) - 12*fd*g2*(r + s)) + Dd*f*(f*(10*C - 5) - 12*g2)*(4*r + 4*s - 3))) + b1**3*(D1**2*(5*fd - 6*fdd)*(r + s - 1)**2 + D1*(Dd*(5*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-6*D1**2*bdd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + D1*bd1*(D1*(5*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - 12*fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - 12*Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + K*(D1**2*(5*fd - 6*fdd)*(r + s)**2 + D1*(Dd*(5*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 12*fd*(4*r**2 + r*(8*s - 3) + s*(4*s - 3))) - 6*Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 36*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) - b1*(-16*C*D1**2*f*fd*r**2 - 32*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r - 16*C*D1**2*f*fd*s**2 + 16*C*D1**2*f*fd*s - 8*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r**2 + 40*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*r + 20*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r**2 + 40*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*r + 20*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 32*C*D1*Dd*f**2*r**2 - 64*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*r**2 + 320*C*D1*Dd*f*fd*r*s - 200*C*D1*Dd*f*fd*r + 160*C*D1*Dd*f*fd*s**2 - 200*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*r**2 + 80*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 40*C*D1*Ddd*f**2*s**2 - 60*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*r**2 + 240*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 120*C*Dd**2*f**2*s**2 - 180*C*Dd**2*f**2*s + 60*C*Dd**2*f**2 + 12*D1**2*K*bdd1*f*r**2 + 24*D1**2*K*bdd1*f*r*s - 24*D1**2*K*bdd1*f*r + 12*D1**2*K*bdd1*f*s**2 - 24*D1**2*K*bdd1*f*s + 12*D1**2*K*bdd1*f - 5*D1**2*b2*fd*r**2 - 10*D1**2*b2*fd*r*s - 5*D1**2*b2*fd*s**2 + 6*D1**2*b2*fdd*r**2 + 12*D1**2*b2*fdd*r*s + 6*D1**2*b2*fdd*s**2 + 12*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 6*D1**2*bdd2*f*r**2 + 12*D1**2*bdd2*f*r*s - 12*D1**2*bdd2*f*r + 6*D1**2*bdd2*f*s**2 - 12*D1**2*bdd2*f*s + 6*D1**2*bdd2*f + 8*D1**2*f*fd*r**2 + 16*D1**2*f*fd*r*s - 8*D1**2*f*fd*r + 8*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s + 4*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd + 10*D1**2*f*gd2*r**2 + 20*D1**2*f*gd2*r*s - 20*D1**2*f*gd2*r + 10*D1**2*f*gd2*s**2 - 20*D1**2*f*gd2*s + 10*D1**2*f*gd2 - 12*D1**2*f*gdd2*r**2 - 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*r - 12*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 12*D1**2*f*gdd2 - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 10*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 10*D1**2*fd*g2*r**2 + 20*D1**2*fd*g2*r*s + 10*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r**2 - 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 24*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r**2 - 24*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 20*D1*Dd*b2*f*r**2 - 40*D1*Dd*b2*f*r*s + 30*D1*Dd*b2*f*r - 20*D1*Dd*b2*f*s**2 + 30*D1*Dd*b2*f*s - 15*D1*Dd*b2*f + 48*D1*Dd*b2*fd*r**2 + 96*D1*Dd*b2*fd*r*s - 36*D1*Dd*b2*fd*r + 48*D1*Dd*b2*fd*s**2 - 36*D1*Dd*b2*fd*s + 16*D1*Dd*f**2*r**2 + 32*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 100*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 100*D1*Dd*f*fd*s - 30*D1*Dd*f*fd + 40*D1*Dd*f*g2*r**2 + 80*D1*Dd*f*g2*r*s - 60*D1*Dd*f*g2*r + 40*D1*Dd*f*g2*s**2 - 60*D1*Dd*f*g2*s + 30*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r**2 - 192*D1*Dd*f*gd2*r*s + 168*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 168*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r**2 - 192*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 72*D1*Dd*fd*g2*s + 24*D1*Ddd*b2*f*r**2 + 48*D1*Ddd*b2*f*r*s - 36*D1*Ddd*b2*f*r + 24*D1*Ddd*b2*f*s**2 - 36*D1*Ddd*b2*f*s + 18*D1*Ddd*b2*f - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r**2 - 96*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 72*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 - 2*D1*K*bd1*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - D1*bd2*(r + s - 1)*(5*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 72*Dd**2*b2*f*r**2 + 144*Dd**2*b2*f*r*s - 108*Dd**2*b2*f*r + 72*Dd**2*b2*f*s**2 - 108*Dd**2*b2*f*s + 36*Dd**2*b2*f - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2 - 144*Dd**2*f*g2*r**2 - 288*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 216*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(21*d**2*k3**4) - D1**2*Pk2*Pkdd3*k1**2*k2**4*st**2*(44*C*D1**2*b1*f*fd*r**2 + 88*C*D1**2*b1*f*fd*r*s - 44*C*D1**2*b1*f*fd*r + 44*C*D1**2*b1*f*fd*s**2 - 44*C*D1**2*b1*f*fd*s + 22*C*D1**2*b1*f*fd - 24*C*D1**2*b1*f*fdd*r**2 - 48*C*D1**2*b1*f*fdd*r*s + 24*C*D1**2*b1*f*fdd*r - 24*C*D1**2*b1*f*fdd*s**2 + 24*C*D1**2*b1*f*fdd*s - 12*C*D1**2*b1*f*fdd - 24*C*D1**2*b1*fd**2*r**2 - 48*C*D1**2*b1*fd**2*r*s + 24*C*D1**2*b1*fd**2*r - 24*C*D1**2*b1*fd**2*s**2 + 24*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r**2 - 12*C*D1**2*f**2*fd*r*s + 8*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 8*C*D1**2*f**2*fd*s - 4*C*D1**2*f**2*fd + 88*C*D1*Dd*b1*f**2*r**2 + 176*C*D1*Dd*b1*f**2*r*s - 132*C*D1*Dd*b1*f**2*r + 88*C*D1*Dd*b1*f**2*s**2 - 132*C*D1*Dd*b1*f**2*s + 66*C*D1*Dd*b1*f**2 - 192*C*D1*Dd*b1*f*fd*r**2 - 384*C*D1*Dd*b1*f*fd*r*s + 240*C*D1*Dd*b1*f*fd*r - 192*C*D1*Dd*b1*f*fd*s**2 + 240*C*D1*Dd*b1*f*fd*s - 72*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r**2 - 16*C*D1*Dd*f**3*r*s + 12*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 12*C*D1*Dd*f**3*s - 6*C*D1*Dd*f**3 - 48*C*D1*Ddd*b1*f**2*r**2 - 96*C*D1*Ddd*b1*f**2*r*s + 72*C*D1*Ddd*b1*f**2*r - 48*C*D1*Ddd*b1*f**2*s**2 + 72*C*D1*Ddd*b1*f**2*s - 36*C*D1*Ddd*b1*f**2 - 144*C*Dd**2*b1*f**2*r**2 - 288*C*Dd**2*b1*f**2*r*s + 216*C*Dd**2*b1*f**2*r - 144*C*Dd**2*b1*f**2*s**2 + 216*C*Dd**2*b1*f**2*s - 72*C*Dd**2*b1*f**2 + 19*D1**2*K*b1**2*fd*r**2 + 38*D1**2*K*b1**2*fd*r*s + 19*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r**2 - 12*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 - 2*D1**2*K*b1*f*fd*r**2 - 4*D1**2*K*b1*f*fd*r*s + 2*D1**2*K*b1*f*fd*r - 2*D1**2*K*b1*f*fd*s**2 + 2*D1**2*K*b1*f*fd*s - D1**2*K*b1*f*fd - 12*D1**2*K*bd1**2*f*(r + s - 1)**2 + 6*D1**2*b1**2*f*fd*r**2 + 12*D1**2*b1**2*f*fd*r*s - 6*D1**2*b1**2*f*fd*r + 6*D1**2*b1**2*f*fd*s**2 - 6*D1**2*b1**2*f*fd*s + 3*D1**2*b1**2*f*fd - 22*D1**2*b1*f*fd*r**2 - 44*D1**2*b1*f*fd*r*s + 22*D1**2*b1*f*fd*r - 22*D1**2*b1*f*fd*s**2 + 22*D1**2*b1*f*fd*s - 11*D1**2*b1*f*fd + 12*D1**2*b1*f*fdd*r**2 + 24*D1**2*b1*f*fdd*r*s - 12*D1**2*b1*f*fdd*r + 12*D1**2*b1*f*fdd*s**2 - 12*D1**2*b1*f*fdd*s + 6*D1**2*b1*f*fdd - 38*D1**2*b1*f*gd2*r**2 - 76*D1**2*b1*f*gd2*r*s + 76*D1**2*b1*f*gd2*r - 38*D1**2*b1*f*gd2*s**2 + 76*D1**2*b1*f*gd2*s - 38*D1**2*b1*f*gd2 + 12*D1**2*b1*f*gdd2*r**2 + 24*D1**2*b1*f*gdd2*r*s - 24*D1**2*b1*f*gdd2*r + 12*D1**2*b1*f*gdd2*s**2 - 24*D1**2*b1*f*gdd2*s + 12*D1**2*b1*f*gdd2 + 12*D1**2*b1*fd**2*r**2 + 24*D1**2*b1*fd**2*r*s - 12*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 - 12*D1**2*b1*fd**2*s - 38*D1**2*b1*fd*g2*r**2 - 76*D1**2*b1*fd*g2*r*s - 38*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r**2 + 48*D1**2*b1*fd*gd2*r*s - 24*D1**2*b1*fd*gd2*r + 24*D1**2*b1*fd*gd2*s**2 - 24*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r**2 + 24*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - 6*D1**2*bdd1*f*(r + s - 1)**2*(2*C*f + 2*K*b1 - f - 2*g2) + 3*D1**2*f**2*fd*r**2 + 6*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + 2*D1**2*f**2*fd + 2*D1**2*f**2*gd2*r**2 + 4*D1**2*f**2*gd2*r*s - 4*D1**2*f**2*gd2*r + 2*D1**2*f**2*gd2*s**2 - 4*D1**2*f**2*gd2*s + 2*D1**2*f**2*gd2 + 4*D1**2*f*fd*g2*r**2 + 8*D1**2*f*fd*g2*r*s - 4*D1**2*f*fd*g2*r + 4*D1**2*f*fd*g2*s**2 - 4*D1**2*f*fd*g2*s + 2*D1**2*f*fd*g2 + 76*D1*Dd*K*b1**2*f*r**2 + 152*D1*Dd*K*b1**2*f*r*s - 114*D1*Dd*K*b1**2*f*r + 76*D1*Dd*K*b1**2*f*s**2 - 114*D1*Dd*K*b1**2*f*s + 57*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r**2 - 96*D1*Dd*K*b1**2*fd*r*s + 36*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 36*D1*Dd*K*b1**2*fd*s - 4*D1*Dd*K*b1*f**2*r**2 - 8*D1*Dd*K*b1*f**2*r*s + 6*D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s**2 + 6*D1*Dd*K*b1*f**2*s - 3*D1*Dd*K*b1*f**2 + 12*D1*Dd*b1**2*f**2*r**2 + 24*D1*Dd*b1**2*f**2*r*s - 18*D1*Dd*b1**2*f**2*r + 12*D1*Dd*b1**2*f**2*s**2 - 18*D1*Dd*b1**2*f**2*s + 9*D1*Dd*b1**2*f**2 - 44*D1*Dd*b1*f**2*r**2 - 88*D1*Dd*b1*f**2*r*s + 66*D1*Dd*b1*f**2*r - 44*D1*Dd*b1*f**2*s**2 + 66*D1*Dd*b1*f**2*s - 33*D1*Dd*b1*f**2 + 96*D1*Dd*b1*f*fd*r**2 + 192*D1*Dd*b1*f*fd*r*s - 120*D1*Dd*b1*f*fd*r + 96*D1*Dd*b1*f*fd*s**2 - 120*D1*Dd*b1*f*fd*s + 36*D1*Dd*b1*f*fd - 152*D1*Dd*b1*f*g2*r**2 - 304*D1*Dd*b1*f*g2*r*s + 228*D1*Dd*b1*f*g2*r - 152*D1*Dd*b1*f*g2*s**2 + 228*D1*Dd*b1*f*g2*s - 114*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r**2 + 192*D1*Dd*b1*f*gd2*r*s - 168*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 168*D1*Dd*b1*f*gd2*s + 72*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r**2 + 192*D1*Dd*b1*fd*g2*r*s - 72*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 72*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r**2 + 8*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 6*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 8*D1*Dd*f**2*g2*r**2 + 16*D1*Dd*f**2*g2*r*s - 12*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s**2 - 12*D1*Dd*f**2*g2*s + 6*D1*Dd*f**2*g2 - 24*D1*Ddd*K*b1**2*f*r**2 - 48*D1*Ddd*K*b1**2*f*r*s + 36*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 36*D1*Ddd*K*b1**2*f*s - 18*D1*Ddd*K*b1**2*f + 24*D1*Ddd*b1*f**2*r**2 + 48*D1*Ddd*b1*f**2*r*s - 36*D1*Ddd*b1*f**2*r + 24*D1*Ddd*b1*f**2*s**2 - 36*D1*Ddd*b1*f**2*s + 18*D1*Ddd*b1*f**2 + 48*D1*Ddd*b1*f*g2*r**2 + 96*D1*Ddd*b1*f*g2*r*s - 72*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 72*D1*Ddd*b1*f*g2*s + 36*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(22*C - K + 6*b1 - 11) - f*fd*(24*C - 12)*(2*r + 2*s - 1) - 2*f*(r + s - 1)*(-19*K*b1 + 19*g2 - 12*gd2) + 24*fd*(r + s)*(-K*b1 + g2)) - 12*Dd*f*(4*r + 4*s - 3)*(2*K*b1 + f*(2*C - 1) - 2*g2))*(r + s - 1) - 72*Dd**2*K*b1**2*f*r**2 - 144*Dd**2*K*b1**2*f*r*s + 108*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 108*Dd**2*K*b1**2*f*s - 36*Dd**2*K*b1**2*f + 72*Dd**2*b1*f**2*r**2 + 144*Dd**2*b1*f**2*r*s - 108*Dd**2*b1*f**2*r + 72*Dd**2*b1*f**2*s**2 - 108*Dd**2*b1*f**2*s + 36*Dd**2*b1*f**2 + 144*Dd**2*b1*f*g2*r**2 + 288*Dd**2*b1*f*g2*r*s - 216*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 216*Dd**2*b1*f*g2*s + 72*Dd**2*b1*f*g2)/(42*d**2*k3**6) + D1**2*Pk2*Pkdd3*k1**2*k2**2*st**2*(D1*(-2*D1*K*bd1**2*f*(5*r**2 + r*(10*s - 11) + 5*s**2 - 11*s + 6) + b2*(bd1*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) - f*(6*D1*bdd1*(r + s - 1)**2 + D1*fd*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + Dd*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3))) - bd1*(12*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(-2*C*(10*r**2 + r*(20*s - 22) + 10*s**2 - 22*s + 11) + K*(r + s - 1)**2 + 10*r**2 + 20*r*s - 22*r + 10*s**2 - 22*s + 11) + 2*f*(fd*(4*C - 2)*(5*r**2 + 2*r*(5*s - 4) + 5*s**2 - 8*s + 3) + g2*(10*r**2 + 20*r*s - 38*r + 10*s**2 - 38*s + 19) - 2*gd2*(5*r**2 + 10*r*s - 11*r + 5*s**2 - 11*s + 6)) - 20*fd*g2*(r**2 + r*(2*s - 1) + s*(s - 1))) + 2*Dd*f*(f*(2*C - 1) - 2*g2)*(20*r**2 + r*(40*s - 39) + 20*s**2 - 39*s + 18)) + f*(-6*C*D1*f*fd*r**2 - 12*C*D1*f*fd*r*s + 8*C*D1*f*fd*r - 6*C*D1*f*fd*s**2 + 8*C*D1*f*fd*s - 4*C*D1*f*fd - 8*C*Dd*f**2*r**2 - 16*C*Dd*f**2*r*s + 12*C*Dd*f**2*r - 8*C*Dd*f**2*s**2 + 12*C*Dd*f**2*s - 6*C*Dd*f**2 - D1*bd2*f*(r + s - 1)**2 - D1*bdd1*(f*(2*C - 1) - 2*g2)*(5*r**2 + 2*r*(5*s - 6) + 5*s**2 - 12*s + 6) + 3*D1*f*fd*r**2 + 6*D1*f*fd*r*s - 4*D1*f*fd*r + 3*D1*f*fd*s**2 - 4*D1*f*fd*s + 2*D1*f*fd + 2*D1*f*gd2*r**2 + 4*D1*f*gd2*r*s - 4*D1*f*gd2*r + 2*D1*f*gd2*s**2 - 4*D1*f*gd2*s + 2*D1*f*gd2 + 4*D1*fd*g2*r**2 + 8*D1*fd*g2*r*s - 4*D1*fd*g2*r + 4*D1*fd*g2*s**2 - 4*D1*fd*g2*s + 2*D1*fd*g2 + 4*Dd*f**2*r**2 + 8*Dd*f**2*r*s - 6*Dd*f**2*r + 4*Dd*f**2*s**2 - 6*Dd*f**2*s + 3*Dd*f**2 + 8*Dd*f*g2*r**2 + 16*Dd*f*g2*r*s - 12*Dd*f*g2*r + 8*Dd*f*g2*s**2 - 12*Dd*f*g2*s + 6*Dd*f*g2)) + 3*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(10*D1**2*K*fd*r**2 + 20*D1**2*K*fd*r*s + 18*D1**2*K*fd*r + 10*D1**2*K*fd*s**2 + 18*D1**2*K*fd*s - 9*D1**2*K*fd - 5*D1**2*K*fdd*r**2 - 10*D1**2*K*fdd*r*s - 2*D1**2*K*fdd*r - 5*D1**2*K*fdd*s**2 - 2*D1**2*K*fdd*s + D1**2*K*fdd - 3*D1**2*bdd1*f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 4*D1**2*f*fd*r**2 + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd + 40*D1*Dd*K*f*r**2 + 80*D1*Dd*K*f*r*s - 60*D1*Dd*K*f*r + 40*D1*Dd*K*f*s**2 - 60*D1*Dd*K*f*s + 30*D1*Dd*K*f - 40*D1*Dd*K*fd*r**2 - 80*D1*Dd*K*fd*r*s + 22*D1*Dd*K*fd*r - 40*D1*Dd*K*fd*s**2 + 22*D1*Dd*K*fd*s + 6*D1*Dd*K*fd + 8*D1*Dd*f**2*r**2 + 16*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 20*D1*Ddd*K*f*r**2 - 40*D1*Ddd*K*f*r*s + 30*D1*Ddd*K*f*r - 20*D1*Ddd*K*f*s**2 + 30*D1*Ddd*K*f*s - 15*D1*Ddd*K*f + 6*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) - 60*Dd**2*K*f*r**2 - 120*Dd**2*K*f*r*s + 90*Dd**2*K*f*r - 60*Dd**2*K*f*s**2 + 90*Dd**2*K*f*s - 30*Dd**2*K*f) - b1*(-40*C*D1**2*f*fd*r**2 - 80*C*D1**2*f*fd*r*s + 36*C*D1**2*f*fd*r - 40*C*D1**2*f*fd*s**2 + 36*C*D1**2*f*fd*s - 18*C*D1**2*f*fd + 20*C*D1**2*f*fdd*r**2 + 40*C*D1**2*f*fdd*r*s - 16*C*D1**2*f*fdd*r + 20*C*D1**2*f*fdd*s**2 - 16*C*D1**2*f*fdd*s + 8*C*D1**2*f*fdd + 20*C*D1**2*fd**2*r**2 + 40*C*D1**2*fd**2*r*s - 16*C*D1**2*fd**2*r + 20*C*D1**2*fd**2*s**2 - 16*C*D1**2*fd**2*s - 4*C*D1**2*fd**2 - 80*C*D1*Dd*f**2*r**2 - 160*C*D1*Dd*f**2*r*s + 120*C*D1*Dd*f**2*r - 80*C*D1*Dd*f**2*s**2 + 120*C*D1*Dd*f**2*s - 60*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*r**2 + 320*C*D1*Dd*f*fd*r*s - 184*C*D1*Dd*f*fd*r + 160*C*D1*Dd*f*fd*s**2 - 184*C*D1*Dd*f*fd*s + 48*C*D1*Dd*f*fd + 40*C*D1*Ddd*f**2*r**2 + 80*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 40*C*D1*Ddd*f**2*s**2 - 60*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*r**2 + 240*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 120*C*Dd**2*f**2*s**2 - 180*C*Dd**2*f**2*s + 60*C*Dd**2*f**2 + 10*D1**2*K*bdd1*f*r**2 + 20*D1**2*K*bdd1*f*r*s - 22*D1**2*K*bdd1*f*r + 10*D1**2*K*bdd1*f*s**2 - 22*D1**2*K*bdd1*f*s + 11*D1**2*K*bdd1*f + 2*D1**2*K*f*fd*r**2 + 4*D1**2*K*f*fd*r*s - 2*D1**2*K*f*fd*r + 2*D1**2*K*f*fd*s**2 - 2*D1**2*K*f*fd*s + D1**2*K*f*fd - 19*D1**2*b2*fd*r**2 - 38*D1**2*b2*fd*r*s - 19*D1**2*b2*fd*s**2 + 6*D1**2*b2*fdd*r**2 + 12*D1**2*b2*fdd*r*s + 6*D1**2*b2*fdd*s**2 + 6*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 6*D1**2*bdd2*f*r**2 + 12*D1**2*bdd2*f*r*s - 12*D1**2*bdd2*f*r + 6*D1**2*bdd2*f*s**2 - 12*D1**2*bdd2*f*s + 6*D1**2*bdd2*f + 20*D1**2*f*fd*r**2 + 40*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 20*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 9*D1**2*f*fd - 10*D1**2*f*fdd*r**2 - 20*D1**2*f*fdd*r*s + 8*D1**2*f*fdd*r - 10*D1**2*f*fdd*s**2 + 8*D1**2*f*fdd*s - 4*D1**2*f*fdd + 20*D1**2*f*gd2*r**2 + 40*D1**2*f*gd2*r*s - 40*D1**2*f*gd2*r + 20*D1**2*f*gd2*s**2 - 40*D1**2*f*gd2*s + 20*D1**2*f*gd2 - 10*D1**2*f*gdd2*r**2 - 20*D1**2*f*gdd2*r*s + 20*D1**2*f*gdd2*r - 10*D1**2*f*gdd2*s**2 + 20*D1**2*f*gdd2*s - 10*D1**2*f*gdd2 - 10*D1**2*fd**2*r**2 - 20*D1**2*fd**2*r*s + 8*D1**2*fd**2*r - 10*D1**2*fd**2*s**2 + 8*D1**2*fd**2*s + 2*D1**2*fd**2 + 20*D1**2*fd*g2*r**2 + 40*D1**2*fd*g2*r*s + 36*D1**2*fd*g2*r + 20*D1**2*fd*g2*s**2 + 36*D1**2*fd*g2*s - 18*D1**2*fd*g2 - 20*D1**2*fd*gd2*r**2 - 40*D1**2*fd*gd2*r*s + 16*D1**2*fd*gd2*r - 20*D1**2*fd*gd2*s**2 + 16*D1**2*fd*gd2*s + 4*D1**2*fd*gd2 - 10*D1**2*fdd*g2*r**2 - 20*D1**2*fdd*g2*r*s - 4*D1**2*fdd*g2*r - 10*D1**2*fdd*g2*s**2 - 4*D1**2*fdd*g2*s + 2*D1**2*fdd*g2 + 4*D1*Dd*K*f**2*r**2 + 8*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r + 4*D1*Dd*K*f**2*s**2 - 6*D1*Dd*K*f**2*s + 3*D1*Dd*K*f**2 - 76*D1*Dd*b2*f*r**2 - 152*D1*Dd*b2*f*r*s + 114*D1*Dd*b2*f*r - 76*D1*Dd*b2*f*s**2 + 114*D1*Dd*b2*f*s - 57*D1*Dd*b2*f + 48*D1*Dd*b2*fd*r**2 + 96*D1*Dd*b2*fd*r*s - 36*D1*Dd*b2*fd*r + 48*D1*Dd*b2*fd*s**2 - 36*D1*Dd*b2*fd*s + 40*D1*Dd*f**2*r**2 + 80*D1*Dd*f**2*r*s - 60*D1*Dd*f**2*r + 40*D1*Dd*f**2*s**2 - 60*D1*Dd*f**2*s + 30*D1*Dd*f**2 - 80*D1*Dd*f*fd*r**2 - 160*D1*Dd*f*fd*r*s + 92*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 92*D1*Dd*f*fd*s - 24*D1*Dd*f*fd + 80*D1*Dd*f*g2*r**2 + 160*D1*Dd*f*g2*r*s - 120*D1*Dd*f*g2*r + 80*D1*Dd*f*g2*s**2 - 120*D1*Dd*f*g2*s + 60*D1*Dd*f*g2 - 80*D1*Dd*f*gd2*r**2 - 160*D1*Dd*f*gd2*r*s + 140*D1*Dd*f*gd2*r - 80*D1*Dd*f*gd2*s**2 + 140*D1*Dd*f*gd2*s - 60*D1*Dd*f*gd2 - 80*D1*Dd*fd*g2*r**2 - 160*D1*Dd*fd*g2*r*s + 44*D1*Dd*fd*g2*r - 80*D1*Dd*fd*g2*s**2 + 44*D1*Dd*fd*g2*s + 12*D1*Dd*fd*g2 + 24*D1*Ddd*b2*f*r**2 + 48*D1*Ddd*b2*f*r*s - 36*D1*Ddd*b2*f*r + 24*D1*Ddd*b2*f*s**2 - 36*D1*Ddd*b2*f*s + 18*D1*Ddd*b2*f - 20*D1*Ddd*f**2*r**2 - 40*D1*Ddd*f**2*r*s + 30*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 30*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 40*D1*Ddd*f*g2*r**2 - 80*D1*Ddd*f*g2*r*s + 60*D1*Ddd*f*g2*r - 40*D1*Ddd*f*g2*s**2 + 60*D1*Ddd*f*g2*s - 30*D1*Ddd*f*g2 - D1*bd1*(D1*(K*f*(20*r**2 + 40*r*s - 58*r + 20*s**2 - 58*s + 29) + 2*K*fd*(-10*r**2 - 20*r*s + 9*r - 10*s**2 + 9*s + 1) + 4*f**2*(r + s - 1)**2) - 2*Dd*K*f*(40*r**2 + r*(80*s - 74) + 40*s**2 - 74*s + 33)) - D1*bd2*(r + s - 1)*(19*D1*f*(r + s - 1) - 12*D1*fd*(r + s) - 12*Dd*f*(4*r + 4*s - 3)) + 72*Dd**2*b2*f*r**2 + 144*Dd**2*b2*f*r*s - 108*Dd**2*b2*f*r + 72*Dd**2*b2*f*s**2 - 108*Dd**2*b2*f*s + 36*Dd**2*b2*f - 60*Dd**2*f**2*r**2 - 120*Dd**2*f**2*r*s + 90*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 90*Dd**2*f**2*s - 30*Dd**2*f**2 - 120*Dd**2*f*g2*r**2 - 240*Dd**2*f*g2*r*s + 180*Dd**2*f*g2*r - 120*Dd**2*f*g2*s**2 + 180*Dd**2*f*g2*s - 60*Dd**2*f*g2))/(42*d**2*k3**4) - D1**2*Pk2*Pkdd3*k1**2*k2**2*(D1**2*bd1*(7*b2*f*(r + s - 1) + (-2*bd1*(r + s) + f*(r + s - 1))*(2*f*(6*C - 3) - 14*g2))*(r + s - 1) + D1*b1*(-24*C*D1*bdd1*f*r**2 - 48*C*D1*bdd1*f*r*s + 24*C*D1*bdd1*f*r - 24*C*D1*bdd1*f*s**2 + 24*C*D1*bdd1*f*s - 12*C*D1*bdd1*f + 24*C*D1*f*fd*r**2 + 48*C*D1*f*fd*r*s - 24*C*D1*f*fd*r + 24*C*D1*f*fd*s**2 - 24*C*D1*f*fd*s + 12*C*D1*f*fd + 48*C*Dd*f**2*r**2 + 96*C*Dd*f**2*r*s - 72*C*Dd*f**2*r + 48*C*Dd*f**2*s**2 - 72*C*Dd*f**2*s + 36*C*Dd*f**2 - 14*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*D1*b2*fd*r**2 + 14*D1*b2*fd*r*s + 7*D1*b2*fd*s**2 + 7*D1*bd2*f*(r + s - 1)**2 + 12*D1*bdd1*f*r**2 + 24*D1*bdd1*f*r*s - 12*D1*bdd1*f*r + 12*D1*bdd1*f*s**2 - 12*D1*bdd1*f*s + 6*D1*bdd1*f + 28*D1*bdd1*g2*r**2 + 56*D1*bdd1*g2*r*s - 28*D1*bdd1*g2*r + 28*D1*bdd1*g2*s**2 - 28*D1*bdd1*g2*s + 14*D1*bdd1*g2 - 12*D1*f*fd*r**2 - 24*D1*f*fd*r*s + 12*D1*f*fd*r - 12*D1*f*fd*s**2 + 12*D1*f*fd*s - 6*D1*f*fd - 14*D1*f*gd2*r**2 - 28*D1*f*gd2*r*s + 28*D1*f*gd2*r - 14*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 14*D1*f*gd2 - 14*D1*fd*g2*r**2 - 28*D1*fd*g2*r*s - 14*D1*fd*g2*s**2 + 28*Dd*b2*f*r**2 + 56*Dd*b2*f*r*s - 42*Dd*b2*f*r + 28*Dd*b2*f*s**2 - 42*Dd*b2*f*s + 21*Dd*b2*f - 24*Dd*f**2*r**2 - 48*Dd*f**2*r*s + 36*Dd*f**2*r - 24*Dd*f**2*s**2 + 36*Dd*f**2*s - 18*Dd*f**2 - 56*Dd*f*g2*r**2 - 112*Dd*f*g2*r*s + 84*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 84*Dd*f*g2*s - 42*Dd*f*g2 + bd1*(D1*(f*(10*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 14*K*(r + s - 1)**2 - 10*r**2 - 20*r*s + 10*r - 10*s**2 + 10*s - 5) - 4*fd*(6*C - 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 28*g2*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 28*gd2*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) - 4*Dd*(f*(6*C - 3) - 7*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 7*b1**3*(D1**2*fd*(r + s - 1)**2 + D1*(Dd*(2*K + f) - Ddd*K)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*K*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(D1**2*(-7*K*bdd1*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + fd*(10*C*(r + s - 1)**2 + 7*K*s**2 + r**2*(7*K - 5) + 2*r*(7*K*s - 5*s + 5) - 5*s**2 + 10*s - 5) + fdd*(6 - 12*C)*(r + s - 1)**2 - 28*gd2*(r + s - 1)**2 + 14*gdd2*(r + s - 1)**2) + 7*D1*bd1*(D1*(2*K + f)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*Dd*K*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + D1*(Dd*(f*(10*C + 7*K - 5)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 4*fd*(6*C - 3)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) - 28*g2*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 28*gd2*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - 2*Ddd*(f*(6*C - 3) - 7*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 12*Dd**2*(f*(6*C - 3) - 7*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(21*d**2*k3**4) - D1**2*Pk2*Pkdd3*k1**2*st**2*(D1*(r + s)*(2*D1*K*bd1**2*f*(r + s - 1) + D1*bdd1*f*(r + s)*(b2 + f*(2*C - 1) - 2*g2) + bd1*(-2*C*D1*f**2*r - 2*C*D1*f**2*s + 8*C*D1*f*fd*r + 8*C*D1*f*fd*s - 8*C*D1*f*fd + 16*C*Dd*f**2*r + 16*C*Dd*f**2*s - 12*C*Dd*f**2 + 2*D1*bd2*f*(r + s - 1) + D1*f**2*r + D1*f**2*s - 4*D1*f*fd*r - 4*D1*f*fd*s + 4*D1*f*fd + 18*D1*f*g2*r + 18*D1*f*g2*s - 4*D1*f*gd2*r - 4*D1*f*gd2*s + 4*D1*f*gd2 - 4*D1*fd*g2*r - 4*D1*fd*g2*s + 4*D1*fd*g2 - 8*Dd*f**2*r - 8*Dd*f**2*s + 6*Dd*f**2 - 16*Dd*f*g2*r - 16*Dd*f*g2*s + 12*Dd*f*g2 + b2*(-9*D1*f*(r + s) + 2*D1*fd*(r + s - 1) + 2*Dd*f*(4*r + 4*s - 3)))) + 2*b1**3*(D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(2*Dd*(f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-2*D1**2*bdd1*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + 4*D1*bd1*(D1*(f*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - fd*(3*r**2 + 6*r*s - 5*r + 3*s**2 - 5*s + 2)) - Dd*f*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6)) + K*(-D1**2*(9*fd - fdd)*(r + s - 1)**2 + D1*(Dd*(-9*f*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + 2*fd*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))) + b1*(-4*C*D1**2*f*fd*r**2 - 8*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*r - 4*C*D1**2*f*fd*s**2 + 8*C*D1**2*f*fd*s - 4*C*D1**2*f*fd + 4*C*D1**2*f*fdd*r**2 + 8*C*D1**2*f*fdd*r*s - 8*C*D1**2*f*fdd*r + 4*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s + 4*C*D1**2*f*fdd + 4*C*D1**2*fd**2*r**2 + 8*C*D1**2*fd**2*r*s - 8*C*D1**2*fd**2*r + 4*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s + 4*C*D1**2*fd**2 - 8*C*D1*Dd*f**2*r**2 - 16*C*D1*Dd*f**2*r*s + 12*C*D1*Dd*f**2*r - 8*C*D1*Dd*f**2*s**2 + 12*C*D1*Dd*f**2*s - 6*C*D1*Dd*f**2 + 32*C*D1*Dd*f*fd*r**2 + 64*C*D1*Dd*f*fd*r*s - 56*C*D1*Dd*f*fd*r + 32*C*D1*Dd*f*fd*s**2 - 56*C*D1*Dd*f*fd*s + 24*C*D1*Dd*f*fd + 8*C*D1*Ddd*f**2*r**2 + 16*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 8*C*D1*Ddd*f**2*s**2 - 12*C*D1*Ddd*f**2*s + 6*C*D1*Ddd*f**2 + 24*C*Dd**2*f**2*r**2 + 48*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 24*C*Dd**2*f**2*s**2 - 36*C*Dd**2*f**2*s + 12*C*Dd**2*f**2 + 2*D1**2*K*bdd1*f*r**2 + 4*D1**2*K*bdd1*f*r*s - 2*D1**2*K*bdd1*f*r + 2*D1**2*K*bdd1*f*s**2 - 2*D1**2*K*bdd1*f*s + D1**2*K*bdd1*f - 9*D1**2*b2*fd*r**2 - 18*D1**2*b2*fd*r*s + 18*D1**2*b2*fd*r - 9*D1**2*b2*fd*s**2 + 18*D1**2*b2*fd*s - 9*D1**2*b2*fd + D1**2*b2*fdd*r**2 + 2*D1**2*b2*fdd*r*s - 2*D1**2*b2*fdd*r + D1**2*b2*fdd*s**2 - 2*D1**2*b2*fdd*s + D1**2*b2*fdd - 4*D1**2*bd1**2*f*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + D1**2*bdd2*f*r**2 + 2*D1**2*bdd2*f*r*s - 2*D1**2*bdd2*f*r + D1**2*bdd2*f*s**2 - 2*D1**2*bdd2*f*s + D1**2*bdd2*f + 2*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s + 2*D1**2*f*fd - 2*D1**2*f*fdd*r**2 - 4*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*r - 2*D1**2*f*fdd*s**2 + 4*D1**2*f*fdd*s - 2*D1**2*f*fdd + 18*D1**2*f*gd2*r**2 + 36*D1**2*f*gd2*r*s - 36*D1**2*f*gd2*r + 18*D1**2*f*gd2*s**2 - 36*D1**2*f*gd2*s + 18*D1**2*f*gd2 - 2*D1**2*f*gdd2*r**2 - 4*D1**2*f*gdd2*r*s + 4*D1**2*f*gdd2*r - 2*D1**2*f*gdd2*s**2 + 4*D1**2*f*gdd2*s - 2*D1**2*f*gdd2 - 2*D1**2*fd**2*r**2 - 4*D1**2*fd**2*r*s + 4*D1**2*fd**2*r - 2*D1**2*fd**2*s**2 + 4*D1**2*fd**2*s - 2*D1**2*fd**2 + 18*D1**2*fd*g2*r**2 + 36*D1**2*fd*g2*r*s - 36*D1**2*fd*g2*r + 18*D1**2*fd*g2*s**2 - 36*D1**2*fd*g2*s + 18*D1**2*fd*g2 - 4*D1**2*fd*gd2*r**2 - 8*D1**2*fd*gd2*r*s + 8*D1**2*fd*gd2*r - 4*D1**2*fd*gd2*s**2 + 8*D1**2*fd*gd2*s - 4*D1**2*fd*gd2 - 2*D1**2*fdd*g2*r**2 - 4*D1**2*fdd*g2*r*s + 4*D1**2*fdd*g2*r - 2*D1**2*fdd*g2*s**2 + 4*D1**2*fdd*g2*s - 2*D1**2*fdd*g2 - 36*D1*Dd*b2*f*r**2 - 72*D1*Dd*b2*f*r*s + 54*D1*Dd*b2*f*r - 36*D1*Dd*b2*f*s**2 + 54*D1*Dd*b2*f*s - 27*D1*Dd*b2*f + 8*D1*Dd*b2*fd*r**2 + 16*D1*Dd*b2*fd*r*s - 14*D1*Dd*b2*fd*r + 8*D1*Dd*b2*fd*s**2 - 14*D1*Dd*b2*fd*s + 6*D1*Dd*b2*fd + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 16*D1*Dd*f*fd*r**2 - 32*D1*Dd*f*fd*r*s + 28*D1*Dd*f*fd*r - 16*D1*Dd*f*fd*s**2 + 28*D1*Dd*f*fd*s - 12*D1*Dd*f*fd + 72*D1*Dd*f*g2*r**2 + 144*D1*Dd*f*g2*r*s - 108*D1*Dd*f*g2*r + 72*D1*Dd*f*g2*s**2 - 108*D1*Dd*f*g2*s + 54*D1*Dd*f*g2 - 16*D1*Dd*f*gd2*r**2 - 32*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 16*D1*Dd*f*gd2*s**2 + 28*D1*Dd*f*gd2*s - 12*D1*Dd*f*gd2 - 16*D1*Dd*fd*g2*r**2 - 32*D1*Dd*fd*g2*r*s + 28*D1*Dd*fd*g2*r - 16*D1*Dd*fd*g2*s**2 + 28*D1*Dd*fd*g2*s - 12*D1*Dd*fd*g2 + 4*D1*Ddd*b2*f*r**2 + 8*D1*Ddd*b2*f*r*s - 6*D1*Ddd*b2*f*r + 4*D1*Ddd*b2*f*s**2 - 6*D1*Ddd*b2*f*s + 3*D1*Ddd*b2*f - 4*D1*Ddd*f**2*r**2 - 8*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 4*D1*Ddd*f**2*s**2 + 6*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 - 8*D1*Ddd*f*g2*r**2 - 16*D1*Ddd*f*g2*r*s + 12*D1*Ddd*f*g2*r - 8*D1*Ddd*f*g2*s**2 + 12*D1*Ddd*f*g2*s - 6*D1*Ddd*f*g2 + D1*K*bd1*(D1*(-9*f*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + 2*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + 2*Dd*f*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - D1*bd2*(D1*(9*f - 2*fd)*(r + s - 1) - 2*Dd*f*(4*r + 4*s - 3))*(r + s - 1) + 12*Dd**2*b2*f*r**2 + 24*Dd**2*b2*f*r*s - 18*Dd**2*b2*f*r + 12*Dd**2*b2*f*s**2 - 18*Dd**2*b2*f*s + 6*Dd**2*b2*f - 12*Dd**2*f**2*r**2 - 24*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 12*Dd**2*f**2*s**2 + 18*Dd**2*f**2*s - 6*Dd**2*f**2 - 24*Dd**2*f*g2*r**2 - 48*Dd**2*f*g2*r*s + 36*Dd**2*f*g2*r - 24*Dd**2*f*g2*s**2 + 36*Dd**2*f*g2*s - 12*Dd**2*f*g2))/(42*d**2*k3**2) - D1**2*Pk2*Pkdd3*k1**2*(2*D1**2*bd1**2*(r**2 + r*(2*s - 1) + s*(s - 1))*(12*C*f + 7*b2 - 6*f - 14*g2) + D1*b1*(14*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 2*D1*bdd1*(f*(6*C - 3) - 7*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 7*b2*(-2*D1*bd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 2*Dd*bd1*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) + bd1*(14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f*(5 - 10*C)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 4*fd*(6*C - 3)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 4*Dd*(f*(6*C - 3) - 7*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-10*C*D1**2*fd*r**2 - 20*C*D1**2*fd*r*s + 20*C*D1**2*fd*r - 10*C*D1**2*fd*s**2 + 20*C*D1**2*fd*s - 10*C*D1**2*fd + 12*C*D1**2*fdd*r**2 + 24*C*D1**2*fdd*r*s - 24*C*D1**2*fdd*r + 12*C*D1**2*fdd*s**2 - 24*C*D1**2*fdd*s + 12*C*D1**2*fdd - 40*C*D1*Dd*f*r**2 - 80*C*D1*Dd*f*r*s + 60*C*D1*Dd*f*r - 40*C*D1*Dd*f*s**2 + 60*C*D1*Dd*f*s - 30*C*D1*Dd*f + 96*C*D1*Dd*fd*r**2 + 192*C*D1*Dd*fd*r*s - 168*C*D1*Dd*fd*r + 96*C*D1*Dd*fd*s**2 - 168*C*D1*Dd*fd*s + 72*C*D1*Dd*fd + 48*C*D1*Ddd*f*r**2 + 96*C*D1*Ddd*f*r*s - 72*C*D1*Ddd*f*r + 48*C*D1*Ddd*f*s**2 - 72*C*D1*Ddd*f*s + 36*C*D1*Ddd*f + 144*C*Dd**2*f*r**2 + 288*C*Dd**2*f*r*s - 216*C*Dd**2*f*r + 144*C*Dd**2*f*s**2 - 216*C*Dd**2*f*s + 72*C*Dd**2*f - 42*D1**2*K*bd1*r**2 - 84*D1**2*K*bd1*r*s + 56*D1**2*K*bd1*r - 42*D1**2*K*bd1*s**2 + 56*D1**2*K*bd1*s - 28*D1**2*K*bd1 + 21*D1**2*K*bdd1*r**2 + 42*D1**2*K*bdd1*r*s - 28*D1**2*K*bdd1*r + 21*D1**2*K*bdd1*s**2 - 28*D1**2*K*bdd1*s + 14*D1**2*K*bdd1 + 7*D1**2*bdd2*(r + s - 1)**2 + 5*D1**2*fd*r**2 + 10*D1**2*fd*r*s - 10*D1**2*fd*r + 5*D1**2*fd*s**2 - 10*D1**2*fd*s + 5*D1**2*fd - 6*D1**2*fdd*r**2 - 12*D1**2*fdd*r*s + 12*D1**2*fdd*r - 6*D1**2*fdd*s**2 + 12*D1**2*fdd*s - 6*D1**2*fdd + 28*D1**2*gd2*r**2 + 56*D1**2*gd2*r*s - 56*D1**2*gd2*r + 28*D1**2*gd2*s**2 - 56*D1**2*gd2*s + 28*D1**2*gd2 - 14*D1**2*gdd2*r**2 - 28*D1**2*gdd2*r*s + 28*D1**2*gdd2*r - 14*D1**2*gdd2*s**2 + 28*D1**2*gdd2*s - 14*D1**2*gdd2 + 168*D1*Dd*K*bd1*r**2 + 336*D1*Dd*K*bd1*r*s - 238*D1*Dd*K*bd1*r + 168*D1*Dd*K*bd1*s**2 - 238*D1*Dd*K*bd1*s + 84*D1*Dd*K*bd1 - 56*D1*Dd*b2*r**2 - 112*D1*Dd*b2*r*s + 84*D1*Dd*b2*r - 56*D1*Dd*b2*s**2 + 84*D1*Dd*b2*s - 42*D1*Dd*b2 + 20*D1*Dd*f*r**2 + 40*D1*Dd*f*r*s - 30*D1*Dd*f*r + 20*D1*Dd*f*s**2 - 30*D1*Dd*f*s + 15*D1*Dd*f - 48*D1*Dd*fd*r**2 - 96*D1*Dd*fd*r*s + 84*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 + 84*D1*Dd*fd*s - 36*D1*Dd*fd + 112*D1*Dd*g2*r**2 + 224*D1*Dd*g2*r*s - 168*D1*Dd*g2*r + 112*D1*Dd*g2*s**2 - 168*D1*Dd*g2*s + 84*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 - 224*D1*Dd*gd2*r*s + 196*D1*Dd*gd2*r - 112*D1*Dd*gd2*s**2 + 196*D1*Dd*gd2*s - 84*D1*Dd*gd2 + 28*D1*Ddd*b2*r**2 + 56*D1*Ddd*b2*r*s - 42*D1*Ddd*b2*r + 28*D1*Ddd*b2*s**2 - 42*D1*Ddd*b2*s + 21*D1*Ddd*b2 - 24*D1*Ddd*f*r**2 - 48*D1*Ddd*f*r*s + 36*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 36*D1*Ddd*f*s - 18*D1*Ddd*f - 56*D1*Ddd*g2*r**2 - 112*D1*Ddd*g2*r*s + 84*D1*Ddd*g2*r - 56*D1*Ddd*g2*s**2 + 84*D1*Ddd*g2*s - 42*D1*Ddd*g2 - 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) + 84*Dd**2*b2*r**2 + 168*Dd**2*b2*r*s - 126*Dd**2*b2*r + 84*Dd**2*b2*s**2 - 126*Dd**2*b2*s + 42*Dd**2*b2 - 72*Dd**2*f*r**2 - 144*Dd**2*f*r*s + 108*Dd**2*f*r - 72*Dd**2*f*s**2 + 108*Dd**2*f*s - 36*Dd**2*f - 168*Dd**2*g2*r**2 - 336*Dd**2*g2*r*s + 252*Dd**2*g2*r - 168*Dd**2*g2*s**2 + 252*Dd**2*g2*s - 84*Dd**2*g2))/(21*d**2*k3**2) + 5*D1**2*Pk2*Pkdd3*k2**6*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - fdd*(2*C - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + (r + s - 1)**2*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(4*C - 2)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) - 66*fd*(K*(-b1*(2*r**2 + 4*r*s - 2*r + 2*s**2 - 2*s + 1) + bd1*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1)) + g2*(4*r**2 + r*(8*s - 4) + 4*s**2 - 4*s + 2) - 2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 33*fdd*(-K*b1 + 2*g2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1)) + 66*fd**2*(-K*b1 + 2*g2)*(r**2 + r*(2*s - 1) + s*(s - 1))) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(33*K*(b1*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) - bd1*(4*r**2 + 8*r*s - 7*r + 4*s**2 - 7*s + 3)) - fd*(2*C - 1)*(12*r**2 + r*(24*s - 17) + 12*s**2 - 17*s + 6) - 66*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 66*gd2*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3)) + 33*fd*(-K*b1 + 2*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3)) - Ddd*f*(2*C*f + 33*K*b1 - f - 66*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) - 6*Dd**2*f**2*(2*C*f + 33*K*b1 - f - 66*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1))/(1386*d**2*k3**6) - D1**2*Pk2*Pkdd3*k2**6*st**4*(-2*D1**2*K*b1**2*fd*r**2 - 4*D1**2*K*b1**2*fd*r*s - 2*D1**2*K*b1**2*fd*s**2 + D1**2*K*b1**2*fdd*r**2 + 2*D1**2*K*b1**2*fdd*r*s + D1**2*K*b1**2*fdd*s**2 + 2*D1**2*K*b1*f*fd*r**2 + 4*D1**2*K*b1*f*fd*r*s - 2*D1**2*K*b1*f*fd*r + 2*D1**2*K*b1*f*fd*s**2 - 2*D1**2*K*b1*f*fd*s + D1**2*K*b1*f*fd + 2*D1**2*K*bd1**2*f*(r + s - 1)**2 + 4*D1**2*b1*f*gd2*r**2 + 8*D1**2*b1*f*gd2*r*s - 8*D1**2*b1*f*gd2*r + 4*D1**2*b1*f*gd2*s**2 - 8*D1**2*b1*f*gd2*s + 4*D1**2*b1*f*gd2 - 2*D1**2*b1*f*gdd2*r**2 - 4*D1**2*b1*f*gdd2*r*s + 4*D1**2*b1*f*gdd2*r - 2*D1**2*b1*f*gdd2*s**2 + 4*D1**2*b1*f*gdd2*s - 2*D1**2*b1*f*gdd2 + 4*D1**2*b1*fd*g2*r**2 + 8*D1**2*b1*fd*g2*r*s + 4*D1**2*b1*fd*g2*s**2 - 4*D1**2*b1*fd*gd2*r**2 - 8*D1**2*b1*fd*gd2*r*s + 4*D1**2*b1*fd*gd2*r - 4*D1**2*b1*fd*gd2*s**2 + 4*D1**2*b1*fd*gd2*s - 2*D1**2*b1*fdd*g2*r**2 - 4*D1**2*b1*fdd*g2*r*s - 2*D1**2*b1*fdd*g2*s**2 - 2*D1**2*bdd1*f*(-K*b1 + g2)*(r + s - 1)**2 - 2*D1**2*f**2*gd2*r**2 - 4*D1**2*f**2*gd2*r*s + 4*D1**2*f**2*gd2*r - 2*D1**2*f**2*gd2*s**2 + 4*D1**2*f**2*gd2*s - 2*D1**2*f**2*gd2 - 4*D1**2*f*fd*g2*r**2 - 8*D1**2*f*fd*g2*r*s + 4*D1**2*f*fd*g2*r - 4*D1**2*f*fd*g2*s**2 + 4*D1**2*f*fd*g2*s - 2*D1**2*f*fd*g2 - 8*D1*Dd*K*b1**2*f*r**2 - 16*D1*Dd*K*b1**2*f*r*s + 12*D1*Dd*K*b1**2*f*r - 8*D1*Dd*K*b1**2*f*s**2 + 12*D1*Dd*K*b1**2*f*s - 6*D1*Dd*K*b1**2*f + 8*D1*Dd*K*b1**2*fd*r**2 + 16*D1*Dd*K*b1**2*fd*r*s - 6*D1*Dd*K*b1**2*fd*r + 8*D1*Dd*K*b1**2*fd*s**2 - 6*D1*Dd*K*b1**2*fd*s + 4*D1*Dd*K*b1*f**2*r**2 + 8*D1*Dd*K*b1*f**2*r*s - 6*D1*Dd*K*b1*f**2*r + 4*D1*Dd*K*b1*f**2*s**2 - 6*D1*Dd*K*b1*f**2*s + 3*D1*Dd*K*b1*f**2 + 16*D1*Dd*b1*f*g2*r**2 + 32*D1*Dd*b1*f*g2*r*s - 24*D1*Dd*b1*f*g2*r + 16*D1*Dd*b1*f*g2*s**2 - 24*D1*Dd*b1*f*g2*s + 12*D1*Dd*b1*f*g2 - 16*D1*Dd*b1*f*gd2*r**2 - 32*D1*Dd*b1*f*gd2*r*s + 28*D1*Dd*b1*f*gd2*r - 16*D1*Dd*b1*f*gd2*s**2 + 28*D1*Dd*b1*f*gd2*s - 12*D1*Dd*b1*f*gd2 - 16*D1*Dd*b1*fd*g2*r**2 - 32*D1*Dd*b1*fd*g2*r*s + 12*D1*Dd*b1*fd*g2*r - 16*D1*Dd*b1*fd*g2*s**2 + 12*D1*Dd*b1*fd*g2*s - 8*D1*Dd*f**2*g2*r**2 - 16*D1*Dd*f**2*g2*r*s + 12*D1*Dd*f**2*g2*r - 8*D1*Dd*f**2*g2*s**2 + 12*D1*Dd*f**2*g2*s - 6*D1*Dd*f**2*g2 + 4*D1*Ddd*K*b1**2*f*r**2 + 8*D1*Ddd*K*b1**2*f*r*s - 6*D1*Ddd*K*b1**2*f*r + 4*D1*Ddd*K*b1**2*f*s**2 - 6*D1*Ddd*K*b1**2*f*s + 3*D1*Ddd*K*b1**2*f - 8*D1*Ddd*b1*f*g2*r**2 - 16*D1*Ddd*b1*f*g2*r*s + 12*D1*Ddd*b1*f*g2*r - 8*D1*Ddd*b1*f*g2*s**2 + 12*D1*Ddd*b1*f*g2*s - 6*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(K*f**2*(r + s - 1) + 4*f*(r + s - 1)*(-K*b1 + g2 - gd2) - 4*fd*(r + s)*(-K*b1 + g2)) - 4*Dd*f*(-K*b1 + g2)*(4*r + 4*s - 3))*(r + s - 1) + 12*Dd**2*K*b1**2*f*r**2 + 24*Dd**2*K*b1**2*f*r*s - 18*Dd**2*K*b1**2*f*r + 12*Dd**2*K*b1**2*f*s**2 - 18*Dd**2*K*b1**2*f*s + 6*Dd**2*K*b1**2*f - 24*Dd**2*b1*f*g2*r**2 - 48*Dd**2*b1*f*g2*r*s + 36*Dd**2*b1*f*g2*r - 24*Dd**2*b1*f*g2*s**2 + 36*Dd**2*b1*f*g2*s - 12*Dd**2*b1*f*g2)/(7*d**2*k3**6) - 5*D1**2*Pk2*Pkdd3*k2**4*st**6*(12*C*D1**2*f**2*fd*r**2 + 24*C*D1**2*f**2*fd*r*s - 16*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 16*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r**2 - 12*C*D1**2*f**2*fdd*r*s + 8*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 8*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r**2 - 24*C*D1**2*f*fd**2*r*s + 16*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 16*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r**2 + 32*C*D1*Dd*f**3*r*s - 24*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 12*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r**2 - 96*C*D1*Dd*f**2*fd*r*s + 68*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 68*C*D1*Dd*f**2*fd*s - 24*C*D1*Dd*f**2*fd - 8*C*D1*Ddd*f**3*r**2 - 16*C*D1*Ddd*f**3*r*s + 12*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 12*C*D1*Ddd*f**3*s - 6*C*D1*Ddd*f**3 - 24*C*Dd**2*f**3*r**2 - 48*C*Dd**2*f**3*r*s + 36*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 36*C*Dd**2*f**3*s - 12*C*Dd**2*f**3 + 132*D1**2*K*b1*f*fd*r**2 + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r + 132*D1**2*K*b1*f*fd*s**2 - 132*D1**2*K*b1*f*fd*s + 66*D1**2*K*b1*f*fd - 66*D1**2*K*b1*f*fdd*r**2 - 132*D1**2*K*b1*f*fdd*r*s + 66*D1**2*K*b1*f*fdd*r - 66*D1**2*K*b1*f*fdd*s**2 + 66*D1**2*K*b1*f*fdd*s - 33*D1**2*K*b1*f*fdd - 66*D1**2*K*b1*fd**2*r**2 - 132*D1**2*K*b1*fd**2*r*s + 66*D1**2*K*b1*fd**2*r - 66*D1**2*K*b1*fd**2*s**2 + 66*D1**2*K*b1*fd**2*s + 66*D1**2*K*bd1*f**2*r**2 + 132*D1**2*K*bd1*f**2*r*s - 132*D1**2*K*bd1*f**2*r + 66*D1**2*K*bd1*f**2*s**2 - 132*D1**2*K*bd1*f**2*s + 66*D1**2*K*bd1*f**2 - 132*D1**2*K*bd1*f*fd*r**2 - 264*D1**2*K*bd1*f*fd*r*s + 198*D1**2*K*bd1*f*fd*r - 132*D1**2*K*bd1*f*fd*s**2 + 198*D1**2*K*bd1*f*fd*s - 66*D1**2*K*bd1*f*fd - 33*D1**2*K*bdd1*f**2*r**2 - 66*D1**2*K*bdd1*f**2*r*s + 66*D1**2*K*bdd1*f**2*r - 33*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s - 33*D1**2*K*bdd1*f**2 + 132*D1**2*b2*f*fd*r**2 + 264*D1**2*b2*f*fd*r*s - 132*D1**2*b2*f*fd*r + 132*D1**2*b2*f*fd*s**2 - 132*D1**2*b2*f*fd*s + 66*D1**2*b2*f*fd - 66*D1**2*b2*f*fdd*r**2 - 132*D1**2*b2*f*fdd*r*s + 66*D1**2*b2*f*fdd*r - 66*D1**2*b2*f*fdd*s**2 + 66*D1**2*b2*f*fdd*s - 33*D1**2*b2*f*fdd - 66*D1**2*b2*fd**2*r**2 - 132*D1**2*b2*fd**2*r*s + 66*D1**2*b2*fd**2*r - 66*D1**2*b2*fd**2*s**2 + 66*D1**2*b2*fd**2*s - 33*D1**2*bdd2*f**2*(r + s - 1)**2 - 6*D1**2*f**2*fd*r**2 - 12*D1**2*f**2*fd*r*s + 8*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 8*D1**2*f**2*fd*s - 4*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r**2 + 6*D1**2*f**2*fdd*r*s - 4*D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 4*D1**2*f**2*fdd*s + 2*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r**2 - 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*r - 132*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s - 132*D1**2*f**2*gd2 + 66*D1**2*f**2*gdd2*r**2 + 132*D1**2*f**2*gdd2*r*s - 132*D1**2*f**2*gdd2*r + 66*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 66*D1**2*f**2*gdd2 + 6*D1**2*f*fd**2*r**2 + 12*D1**2*f*fd**2*r*s - 8*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 8*D1**2*f*fd**2*s + 2*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r**2 + 528*D1**2*f*fd*gd2*r*s - 396*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 396*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r**2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r**2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 264*D1*Dd*K*b1*f**2*r**2 + 528*D1*Dd*K*b1*f**2*r*s - 396*D1*Dd*K*b1*f**2*r + 264*D1*Dd*K*b1*f**2*s**2 - 396*D1*Dd*K*b1*f**2*s + 198*D1*Dd*K*b1*f**2 - 528*D1*Dd*K*b1*f*fd*r**2 - 1056*D1*Dd*K*b1*f*fd*r*s + 660*D1*Dd*K*b1*f*fd*r - 528*D1*Dd*K*b1*f*fd*s**2 + 660*D1*Dd*K*b1*f*fd*s - 198*D1*Dd*K*b1*f*fd - 264*D1*Dd*K*bd1*f**2*r**2 - 528*D1*Dd*K*bd1*f**2*r*s + 462*D1*Dd*K*bd1*f**2*r - 264*D1*Dd*K*bd1*f**2*s**2 + 462*D1*Dd*K*bd1*f**2*s - 198*D1*Dd*K*bd1*f**2 + 264*D1*Dd*b2*f**2*r**2 + 528*D1*Dd*b2*f**2*r*s - 396*D1*Dd*b2*f**2*r + 264*D1*Dd*b2*f**2*s**2 - 396*D1*Dd*b2*f**2*s + 198*D1*Dd*b2*f**2 - 528*D1*Dd*b2*f*fd*r**2 - 1056*D1*Dd*b2*f*fd*r*s + 660*D1*Dd*b2*f*fd*r - 528*D1*Dd*b2*f*fd*s**2 + 660*D1*Dd*b2*f*fd*s - 198*D1*Dd*b2*f*fd - 8*D1*Dd*f**3*r**2 - 16*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r**2 + 48*D1*Dd*f**2*fd*r*s - 34*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 34*D1*Dd*f**2*fd*s + 12*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r**2 - 1056*D1*Dd*f**2*g2*r*s + 792*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 792*D1*Dd*f**2*g2*s - 396*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r**2 + 1056*D1*Dd*f**2*gd2*r*s - 924*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 924*D1*Dd*f**2*gd2*s + 396*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r**2 + 2112*D1*Dd*f*fd*g2*r*s - 1320*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1320*D1*Dd*f*fd*g2*s + 396*D1*Dd*f*fd*g2 - 132*D1*Ddd*K*b1*f**2*r**2 - 264*D1*Ddd*K*b1*f**2*r*s + 198*D1*Ddd*K*b1*f**2*r - 132*D1*Ddd*K*b1*f**2*s**2 + 198*D1*Ddd*K*b1*f**2*s - 99*D1*Ddd*K*b1*f**2 - 132*D1*Ddd*b2*f**2*r**2 - 264*D1*Ddd*b2*f**2*r*s + 198*D1*Ddd*b2*f**2*r - 132*D1*Ddd*b2*f**2*s**2 + 198*D1*Ddd*b2*f**2*s - 99*D1*Ddd*b2*f**2 + 4*D1*Ddd*f**3*r**2 + 8*D1*Ddd*f**3*r*s - 6*D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 6*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r**2 + 528*D1*Ddd*f**2*g2*r*s - 396*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 396*D1*Ddd*f**2*g2*s + 198*D1*Ddd*f**2*g2 + 66*D1*bd2*f*(D1*(f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) - 396*Dd**2*K*b1*f**2*r**2 - 792*Dd**2*K*b1*f**2*r*s + 594*Dd**2*K*b1*f**2*r - 396*Dd**2*K*b1*f**2*s**2 + 594*Dd**2*K*b1*f**2*s - 198*Dd**2*K*b1*f**2 - 396*Dd**2*b2*f**2*r**2 - 792*Dd**2*b2*f**2*r*s + 594*Dd**2*b2*f**2*r - 396*Dd**2*b2*f**2*s**2 + 594*Dd**2*b2*f**2*s - 198*Dd**2*b2*f**2 + 12*Dd**2*f**3*r**2 + 24*Dd**2*f**3*r*s - 18*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 18*Dd**2*f**3*s + 6*Dd**2*f**3 + 792*Dd**2*f**2*g2*r**2 + 1584*Dd**2*f**2*g2*r*s - 1188*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 1188*Dd**2*f**2*g2*s + 396*Dd**2*f**2*g2)/(1386*d**2*k3**4) + D1**2*Pk2*Pkdd3*k2**4*st**4*(D1*(K*b1**2*(-D1*(2*fd - fdd)*(2*r + 2*s - 1) + 2*Dd*fd*(4*r + 4*s - 3)) + b1*(4*D1*K*bd1*f*r + 4*D1*K*bd1*f*s - 2*D1*K*bd1*f + 2*D1*K*bd1*fd*r + 2*D1*K*bd1*fd*s - 2*D1*K*bd1*fd - 2*D1*K*bdd1*f*r - 2*D1*K*bdd1*f*s + D1*K*bdd1*f + 2*D1*K*f*fd*r**2 + 4*D1*K*f*fd*r*s - 2*D1*K*f*fd*r + 2*D1*K*f*fd*s**2 - 2*D1*K*f*fd*s + D1*K*f*fd + D1*bdd2*f*(r + s - 1)**2 + 8*D1*fd*g2*r + 8*D1*fd*g2*s - 4*D1*fd*g2 - 4*D1*fd*gd2*r - 4*D1*fd*gd2*s + 4*D1*fd*gd2 - 4*D1*fdd*g2*r - 4*D1*fdd*g2*s + 2*D1*fdd*g2 - 8*Dd*K*bd1*f*r - 8*Dd*K*bd1*f*s + 6*Dd*K*bd1*f + 4*Dd*K*f**2*r**2 + 8*Dd*K*f**2*r*s - 6*Dd*K*f**2*r + 4*Dd*K*f**2*s**2 - 6*Dd*K*f**2*s + 3*Dd*K*f**2 - 16*Dd*fd*g2*r - 16*Dd*fd*g2*s + 12*Dd*fd*g2 - 2*bd2*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3))) + f*(-2*D1*K*bd1**2*(r + s - 1) + D1*bd2*f*r**2 + 2*D1*bd2*f*r*s - 2*D1*bd2*f*r + D1*bd2*f*s**2 - 2*D1*bd2*f*s + D1*bd2*f + 4*D1*bdd1*g2*r + 4*D1*bdd1*g2*s - 2*D1*bdd1*g2 - 2*D1*f*gd2*r**2 - 4*D1*f*gd2*r*s + 4*D1*f*gd2*r - 2*D1*f*gd2*s**2 + 4*D1*f*gd2*s - 2*D1*f*gd2 - 4*D1*fd*g2*r**2 - 8*D1*fd*g2*r*s + 4*D1*fd*g2*r - 4*D1*fd*g2*s**2 + 4*D1*fd*g2*s - 2*D1*fd*g2 - 8*Dd*f*g2*r**2 - 16*Dd*f*g2*r*s + 12*Dd*f*g2*r - 8*Dd*f*g2*s**2 + 12*Dd*f*g2*s - 6*Dd*f*g2 + bd1*(2*D1*bd2*(r + s - 1)**2 + D1*g2*(-8*r - 8*s + 4) + D1*(K*f*(r + s - 1) + 4*gd2)*(r + s - 1) + 4*Dd*g2*(4*r + 4*s - 3)))) + b2*(-2*D1**2*b1*fd*r**2 - 4*D1**2*b1*fd*r*s - 2*D1**2*b1*fd*s**2 + D1**2*b1*fdd*r**2 + 2*D1**2*b1*fdd*r*s + D1**2*b1*fdd*s**2 + D1**2*bdd1*f*(r + s - 1)**2 + 2*D1**2*f*fd*r**2 + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + D1**2*f*fd - 8*D1*Dd*b1*f*r**2 - 16*D1*Dd*b1*f*r*s + 12*D1*Dd*b1*f*r - 8*D1*Dd*b1*f*s**2 + 12*D1*Dd*b1*f*s - 6*D1*Dd*b1*f + 8*D1*Dd*b1*fd*r**2 + 16*D1*Dd*b1*fd*r*s - 6*D1*Dd*b1*fd*r + 8*D1*Dd*b1*fd*s**2 - 6*D1*Dd*b1*fd*s + 4*D1*Dd*f**2*r**2 + 8*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s + 3*D1*Dd*f**2 + 4*D1*Ddd*b1*f*r**2 + 8*D1*Ddd*b1*f*r*s - 6*D1*Ddd*b1*f*r + 4*D1*Ddd*b1*f*s**2 - 6*D1*Ddd*b1*f*s + 3*D1*Ddd*b1*f - 2*D1*bd1*(r + s - 1)*(D1*f*(r + s - 1) - D1*fd*(r + s) + Dd*f*(-4*r - 4*s + 3)) + 12*Dd**2*b1*f*r**2 + 24*Dd**2*b1*f*r*s - 18*Dd**2*b1*f*r + 12*Dd**2*b1*f*s**2 - 18*Dd**2*b1*f*s + 6*Dd**2*b1*f))/(7*d**2*k3**4) + D1**2*Pk2*Pkdd3*k2**4*st**2*(D1**2*bd1*(7*b2*f*(r + s - 1)**2 + (2*bd1*(r**2 + r*(2*s - 1) + s*(s - 1)) + f*(2*r + 2*s - 1))*(f*(2*C - 1) + 14*g2)) + D1*b1*(4*C*D1*bdd1*f*r**2 + 8*C*D1*bdd1*f*r*s - 4*C*D1*bdd1*f*r + 4*C*D1*bdd1*f*s**2 - 4*C*D1*bdd1*f*s + 2*C*D1*bdd1*f - 4*C*D1*f*fd*r - 4*C*D1*f*fd*s + 2*C*D1*f*fd - 14*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*D1*b2*fd*r**2 + 14*D1*b2*fd*r*s + 7*D1*b2*fd*s**2 + 7*D1*bd2*f*(r + s - 1)**2 - 2*D1*bdd1*f*r**2 - 4*D1*bdd1*f*r*s + 2*D1*bdd1*f*r - 2*D1*bdd1*f*s**2 + 2*D1*bdd1*f*s - D1*bdd1*f + 28*D1*bdd1*g2*r**2 + 56*D1*bdd1*g2*r*s - 28*D1*bdd1*g2*r + 28*D1*bdd1*g2*s**2 - 28*D1*bdd1*g2*s + 14*D1*bdd1*g2 + 2*D1*f*fd*r + 2*D1*f*fd*s - D1*f*fd - 28*D1*fd*g2*r - 28*D1*fd*g2*s + 14*D1*fd*g2 + 28*Dd*b2*f*r**2 + 56*Dd*b2*f*r*s - 42*Dd*b2*f*r + 28*Dd*b2*f*s**2 - 42*Dd*b2*f*s + 21*Dd*b2*f + bd1*(D1*(f*(-4*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 7*K*(2*r + 2*s - 1) + 4*r**2 + 8*r*s - 4*r + 4*s**2 - 4*s + 2) + fd*(4*C - 2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) - 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*Dd*(f*(2*C - 1) + 14*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) + 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(-D1**2*(4*C*fd*(r + s - 1)**2 - 7*K*fd*(2*r + 2*s - 1) - K*(14*bd1 - 7*bdd1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) - 2*fd*(r + s - 1)**2 - fdd*(2*C - 1)*(r + s - 1)**2 + 28*gd2*(r + s - 1)**2 - 14*gdd2*(r + s - 1)**2) + D1*(-2*Dd*(f*(2*C - 1)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - fd*(2*C - 1)*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + 14*g2*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + (K*bd1*(-3*r - 3*s + 2) + 2*gd2*(r + s - 1))*(-28*r - 28*s + 21)) + Ddd*(f*(2*C - 1) + 14*g2)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*(f*(2*C - 1) + 14*g2)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)))/(42*d**2*k3**4) + D1**2*Pk2*Pkdd3*k2**2*st**4*(D1*(r + s)*(2*D1*K*bd1**2*f*(r + s - 1) + D1*bdd1*f*(b2 - 2*g2)*(r + s) + 2*bd1*(-D1*b2*f*(r + s) + D1*b2*fd*(r + s - 1) + D1*bd2*f*(r + s - 1) + 2*D1*(f*g2*(r + s) - f*gd2*(r + s - 1) - fd*g2*(r + s - 1)) + Dd*b2*f*(4*r + 4*s - 3) - 2*Dd*f*g2*(4*r + 4*s - 3))) + K*b1**2*(-D1**2*(2*fd - fdd)*(r + s - 1)**2 + D1*(-2*Dd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + 2*Dd*fd*(4*r**2 + r*(8*s - 7) + 4*s**2 - 7*s + 3) + Ddd*f*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3)) + 6*Dd**2*f*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1*(-4*D1**2*K*bd1*f*r**2 - 8*D1**2*K*bd1*f*r*s + 4*D1**2*K*bd1*f*r - 4*D1**2*K*bd1*f*s**2 + 4*D1**2*K*bd1*f*s - 2*D1**2*K*bd1*f + 4*D1**2*K*bd1*fd*r**2 + 8*D1**2*K*bd1*fd*r*s - 6*D1**2*K*bd1*fd*r + 4*D1**2*K*bd1*fd*s**2 - 6*D1**2*K*bd1*fd*s + 2*D1**2*K*bd1*fd + 2*D1**2*K*bdd1*f*r**2 + 4*D1**2*K*bdd1*f*r*s - 2*D1**2*K*bdd1*f*r + 2*D1**2*K*bdd1*f*s**2 - 2*D1**2*K*bdd1*f*s + D1**2*K*bdd1*f - 2*D1**2*b2*fd*r**2 - 4*D1**2*b2*fd*r*s + 4*D1**2*b2*fd*r - 2*D1**2*b2*fd*s**2 + 4*D1**2*b2*fd*s - 2*D1**2*b2*fd + D1**2*b2*fdd*r**2 + 2*D1**2*b2*fdd*r*s - 2*D1**2*b2*fdd*r + D1**2*b2*fdd*s**2 - 2*D1**2*b2*fdd*s + D1**2*b2*fdd + D1**2*bdd2*f*(r + s - 1)**2 + 4*D1**2*f*gd2*r**2 + 8*D1**2*f*gd2*r*s - 8*D1**2*f*gd2*r + 4*D1**2*f*gd2*s**2 - 8*D1**2*f*gd2*s + 4*D1**2*f*gd2 - 2*D1**2*f*gdd2*r**2 - 4*D1**2*f*gdd2*r*s + 4*D1**2*f*gdd2*r - 2*D1**2*f*gdd2*s**2 + 4*D1**2*f*gdd2*s - 2*D1**2*f*gdd2 + 4*D1**2*fd*g2*r**2 + 8*D1**2*fd*g2*r*s - 8*D1**2*fd*g2*r + 4*D1**2*fd*g2*s**2 - 8*D1**2*fd*g2*s + 4*D1**2*fd*g2 - 4*D1**2*fd*gd2*r**2 - 8*D1**2*fd*gd2*r*s + 8*D1**2*fd*gd2*r - 4*D1**2*fd*gd2*s**2 + 8*D1**2*fd*gd2*s - 4*D1**2*fd*gd2 - 2*D1**2*fdd*g2*r**2 - 4*D1**2*fdd*g2*r*s + 4*D1**2*fdd*g2*r - 2*D1**2*fdd*g2*s**2 + 4*D1**2*fdd*g2*s - 2*D1**2*fdd*g2 + 16*D1*Dd*K*bd1*f*r**2 + 32*D1*Dd*K*bd1*f*r*s - 20*D1*Dd*K*bd1*f*r + 16*D1*Dd*K*bd1*f*s**2 - 20*D1*Dd*K*bd1*f*s + 6*D1*Dd*K*bd1*f - 8*D1*Dd*b2*f*r**2 - 16*D1*Dd*b2*f*r*s + 12*D1*Dd*b2*f*r - 8*D1*Dd*b2*f*s**2 + 12*D1*Dd*b2*f*s - 6*D1*Dd*b2*f + 8*D1*Dd*b2*fd*r**2 + 16*D1*Dd*b2*fd*r*s - 14*D1*Dd*b2*fd*r + 8*D1*Dd*b2*fd*s**2 - 14*D1*Dd*b2*fd*s + 6*D1*Dd*b2*fd + 16*D1*Dd*f*g2*r**2 + 32*D1*Dd*f*g2*r*s - 24*D1*Dd*f*g2*r + 16*D1*Dd*f*g2*s**2 - 24*D1*Dd*f*g2*s + 12*D1*Dd*f*g2 - 16*D1*Dd*f*gd2*r**2 - 32*D1*Dd*f*gd2*r*s + 28*D1*Dd*f*gd2*r - 16*D1*Dd*f*gd2*s**2 + 28*D1*Dd*f*gd2*s - 12*D1*Dd*f*gd2 - 16*D1*Dd*fd*g2*r**2 - 32*D1*Dd*fd*g2*r*s + 28*D1*Dd*fd*g2*r - 16*D1*Dd*fd*g2*s**2 + 28*D1*Dd*fd*g2*s - 12*D1*Dd*fd*g2 + 4*D1*Ddd*b2*f*r**2 + 8*D1*Ddd*b2*f*r*s - 6*D1*Ddd*b2*f*r + 4*D1*Ddd*b2*f*s**2 - 6*D1*Ddd*b2*f*s + 3*D1*Ddd*b2*f - 8*D1*Ddd*f*g2*r**2 - 16*D1*Ddd*f*g2*r*s + 12*D1*Ddd*f*g2*r - 8*D1*Ddd*f*g2*s**2 + 12*D1*Ddd*f*g2*s - 6*D1*Ddd*f*g2 - 2*D1*bd2*(D1*(f - fd)*(r + s - 1) + Dd*f*(-4*r - 4*s + 3))*(r + s - 1) + 12*Dd**2*b2*f*r**2 + 24*Dd**2*b2*f*r*s - 18*Dd**2*b2*f*r + 12*Dd**2*b2*f*s**2 - 18*Dd**2*b2*f*s + 6*Dd**2*b2*f - 24*Dd**2*f*g2*r**2 - 48*Dd**2*f*g2*r*s + 36*Dd**2*f*g2*r - 24*Dd**2*f*g2*s**2 + 36*Dd**2*f*g2*s - 12*Dd**2*f*g2))/(7*d**2*k3**2) + D1**2*Pk2*Pkdd3*k2**2*st**2*(D1**2*bd1*(r + s)*(2*bd1*(r + s - 1) + f*(r + s))*(-2*C*f + 7*b2 + f - 14*g2) + D1*b1*(-4*C*D1*bdd1*f*r**2 - 8*C*D1*bdd1*f*r*s + 4*C*D1*bdd1*f*r - 4*C*D1*bdd1*f*s**2 + 4*C*D1*bdd1*f*s - 2*C*D1*bdd1*f - 4*C*D1*f*fd*r**2 - 8*C*D1*f*fd*r*s + 8*C*D1*f*fd*r - 4*C*D1*f*fd*s**2 + 8*C*D1*f*fd*s - 4*C*D1*f*fd - 8*C*Dd*f**2*r**2 - 16*C*Dd*f**2*r*s + 12*C*Dd*f**2*r - 8*C*Dd*f**2*s**2 + 12*C*Dd*f**2*s - 6*C*Dd*f**2 + 14*D1*K*bd1**2*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 7*D1*bd2*f*r**2 + 14*D1*bd2*f*r*s - 14*D1*bd2*f*r + 7*D1*bd2*f*s**2 - 14*D1*bd2*f*s + 7*D1*bd2*f + 2*D1*bdd1*f*r**2 + 4*D1*bdd1*f*r*s - 2*D1*bdd1*f*r + 2*D1*bdd1*f*s**2 - 2*D1*bdd1*f*s + D1*bdd1*f - 28*D1*bdd1*g2*r**2 - 56*D1*bdd1*g2*r*s + 28*D1*bdd1*g2*r - 28*D1*bdd1*g2*s**2 + 28*D1*bdd1*g2*s - 14*D1*bdd1*g2 + 2*D1*f*fd*r**2 + 4*D1*f*fd*r*s - 4*D1*f*fd*r + 2*D1*f*fd*s**2 - 4*D1*f*fd*s + 2*D1*f*fd - 14*D1*f*gd2*r**2 - 28*D1*f*gd2*r*s + 28*D1*f*gd2*r - 14*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 14*D1*f*gd2 - 14*D1*fd*g2*r**2 - 28*D1*fd*g2*r*s + 28*D1*fd*g2*r - 14*D1*fd*g2*s**2 + 28*D1*fd*g2*s - 14*D1*fd*g2 + 4*Dd*f**2*r**2 + 8*Dd*f**2*r*s - 6*Dd*f**2*r + 4*Dd*f**2*s**2 - 6*Dd*f**2*s + 3*Dd*f**2 - 56*Dd*f*g2*r**2 - 112*Dd*f*g2*r*s + 84*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 84*Dd*f*g2*s - 42*Dd*f*g2 - 7*b2*(2*D1*bd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - D1*bdd1*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - D1*fd*r**2 - 2*D1*fd*r*s + 2*D1*fd*r - D1*fd*s**2 + 2*D1*fd*s - D1*fd - 2*Dd*bd1*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) - 4*Dd*f*r**2 - 8*Dd*f*r*s + 6*Dd*f*r - 4*Dd*f*s**2 + 6*Dd*f*s - 3*Dd*f) + bd1*(14*D1*bd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + D1*(f*(4*C + 7*K - 2)*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + fd*(2 - 4*C)*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Dd*(f*(2*C - 1) + 14*g2)*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3))) - 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + b1**2*(4*C*D1**2*fd*r**2 + 8*C*D1**2*fd*r*s - 8*C*D1**2*fd*r + 4*C*D1**2*fd*s**2 - 8*C*D1**2*fd*s + 4*C*D1**2*fd - 2*C*D1**2*fdd*r**2 - 4*C*D1**2*fdd*r*s + 4*C*D1**2*fdd*r - 2*C*D1**2*fdd*s**2 + 4*C*D1**2*fdd*s - 2*C*D1**2*fdd + 16*C*D1*Dd*f*r**2 + 32*C*D1*Dd*f*r*s - 24*C*D1*Dd*f*r + 16*C*D1*Dd*f*s**2 - 24*C*D1*Dd*f*s + 12*C*D1*Dd*f - 16*C*D1*Dd*fd*r**2 - 32*C*D1*Dd*fd*r*s + 28*C*D1*Dd*fd*r - 16*C*D1*Dd*fd*s**2 + 28*C*D1*Dd*fd*s - 12*C*D1*Dd*fd - 8*C*D1*Ddd*f*r**2 - 16*C*D1*Ddd*f*r*s + 12*C*D1*Ddd*f*r - 8*C*D1*Ddd*f*s**2 + 12*C*D1*Ddd*f*s - 6*C*D1*Ddd*f - 24*C*Dd**2*f*r**2 - 48*C*Dd**2*f*r*s + 36*C*Dd**2*f*r - 24*C*Dd**2*f*s**2 + 36*C*Dd**2*f*s - 12*C*Dd**2*f - 42*D1**2*K*bd1*r**2 - 84*D1**2*K*bd1*r*s + 56*D1**2*K*bd1*r - 42*D1**2*K*bd1*s**2 + 56*D1**2*K*bd1*s - 28*D1**2*K*bd1 + 21*D1**2*K*bdd1*r**2 + 42*D1**2*K*bdd1*r*s - 28*D1**2*K*bdd1*r + 21*D1**2*K*bdd1*s**2 - 28*D1**2*K*bdd1*s + 14*D1**2*K*bdd1 + 7*D1**2*K*fd*r**2 + 14*D1**2*K*fd*r*s - 14*D1**2*K*fd*r + 7*D1**2*K*fd*s**2 - 14*D1**2*K*fd*s + 7*D1**2*K*fd + 7*D1**2*bdd2*(r + s - 1)**2 - 2*D1**2*fd*r**2 - 4*D1**2*fd*r*s + 4*D1**2*fd*r - 2*D1**2*fd*s**2 + 4*D1**2*fd*s - 2*D1**2*fd + D1**2*fdd*r**2 + 2*D1**2*fdd*r*s - 2*D1**2*fdd*r + D1**2*fdd*s**2 - 2*D1**2*fdd*s + D1**2*fdd + 28*D1**2*gd2*r**2 + 56*D1**2*gd2*r*s - 56*D1**2*gd2*r + 28*D1**2*gd2*s**2 - 56*D1**2*gd2*s + 28*D1**2*gd2 - 14*D1**2*gdd2*r**2 - 28*D1**2*gdd2*r*s + 28*D1**2*gdd2*r - 14*D1**2*gdd2*s**2 + 28*D1**2*gdd2*s - 14*D1**2*gdd2 + 168*D1*Dd*K*bd1*r**2 + 336*D1*Dd*K*bd1*r*s - 238*D1*Dd*K*bd1*r + 168*D1*Dd*K*bd1*s**2 - 238*D1*Dd*K*bd1*s + 84*D1*Dd*K*bd1 + 28*D1*Dd*K*f*r**2 + 56*D1*Dd*K*f*r*s - 42*D1*Dd*K*f*r + 28*D1*Dd*K*f*s**2 - 42*D1*Dd*K*f*s + 21*D1*Dd*K*f - 56*D1*Dd*b2*r**2 - 112*D1*Dd*b2*r*s + 84*D1*Dd*b2*r - 56*D1*Dd*b2*s**2 + 84*D1*Dd*b2*s - 42*D1*Dd*b2 - 8*D1*Dd*f*r**2 - 16*D1*Dd*f*r*s + 12*D1*Dd*f*r - 8*D1*Dd*f*s**2 + 12*D1*Dd*f*s - 6*D1*Dd*f + 8*D1*Dd*fd*r**2 + 16*D1*Dd*fd*r*s - 14*D1*Dd*fd*r + 8*D1*Dd*fd*s**2 - 14*D1*Dd*fd*s + 6*D1*Dd*fd + 112*D1*Dd*g2*r**2 + 224*D1*Dd*g2*r*s - 168*D1*Dd*g2*r + 112*D1*Dd*g2*s**2 - 168*D1*Dd*g2*s + 84*D1*Dd*g2 - 112*D1*Dd*gd2*r**2 - 224*D1*Dd*gd2*r*s + 196*D1*Dd*gd2*r - 112*D1*Dd*gd2*s**2 + 196*D1*Dd*gd2*s - 84*D1*Dd*gd2 + 28*D1*Ddd*b2*r**2 + 56*D1*Ddd*b2*r*s - 42*D1*Ddd*b2*r + 28*D1*Ddd*b2*s**2 - 42*D1*Ddd*b2*s + 21*D1*Ddd*b2 + 4*D1*Ddd*f*r**2 + 8*D1*Ddd*f*r*s - 6*D1*Ddd*f*r + 4*D1*Ddd*f*s**2 - 6*D1*Ddd*f*s + 3*D1*Ddd*f - 56*D1*Ddd*g2*r**2 - 112*D1*Ddd*g2*r*s + 84*D1*Ddd*g2*r - 56*D1*Ddd*g2*s**2 + 84*D1*Ddd*g2*s - 42*D1*Ddd*g2 - 14*D1*bd2*(D1*(r + s - 1) + Dd*(-4*r - 4*s + 3))*(r + s - 1) + 84*Dd**2*b2*r**2 + 168*Dd**2*b2*r*s - 126*Dd**2*b2*r + 84*Dd**2*b2*s**2 - 126*Dd**2*b2*s + 42*Dd**2*b2 + 12*Dd**2*f*r**2 + 24*Dd**2*f*r*s - 18*Dd**2*f*r + 12*Dd**2*f*s**2 - 18*Dd**2*f*s + 6*Dd**2*f - 168*Dd**2*g2*r**2 - 336*Dd**2*g2*r*s + 252*Dd**2*g2*r - 168*Dd**2*g2*s**2 + 252*Dd**2*g2*s - 84*Dd**2*g2))/(42*d**2*k3**2) + 40*D1**2*Pk3*Pkd2*ct**8*k1**2*k2**3*(4368*C*D1**2*f**2*fd*r*s - 1456*C*D1**2*f**2*fd*r + 4368*C*D1**2*f**2*fd*s**2 - 4368*C*D1**2*f**2*fd*s + 1456*C*D1**2*f**2*fd - 2184*C*D1**2*f**2*fdd*r*s + 728*C*D1**2*f**2*fdd*r - 2184*C*D1**2*f**2*fdd*s**2 + 2184*C*D1**2*f**2*fdd*s - 728*C*D1**2*f**2*fdd - 4368*C*D1**2*f*fd**2*r*s + 1456*C*D1**2*f*fd**2*r - 4368*C*D1**2*f*fd**2*s**2 + 4368*C*D1**2*f*fd**2*s - 728*C*D1**2*f*fd**2 + 5824*C*D1*Dd*f**3*r*s - 1456*C*D1*Dd*f**3*r + 5824*C*D1*Dd*f**3*s**2 - 5824*C*D1*Dd*f**3*s + 1456*C*D1*Dd*f**3 - 17472*C*D1*Dd*f**2*fd*r*s + 5096*C*D1*Dd*f**2*fd*r - 17472*C*D1*Dd*f**2*fd*s**2 + 17472*C*D1*Dd*f**2*fd*s - 3640*C*D1*Dd*f**2*fd - 2912*C*D1*Ddd*f**3*r*s + 728*C*D1*Ddd*f**3*r - 2912*C*D1*Ddd*f**3*s**2 + 2912*C*D1*Ddd*f**3*s - 728*C*D1*Ddd*f**3 - 8736*C*Dd**2*f**3*r*s + 2184*C*Dd**2*f**3*r - 8736*C*Dd**2*f**3*s**2 + 8736*C*Dd**2*f**3*s - 1456*C*Dd**2*f**3 - 429*D1**2*K*bdd1*f**2*r*s - 429*D1**2*K*bdd1*f**2*s**2 + 429*D1**2*K*bdd1*f**2*s + 429*D1**2*bdd1*f**2*r*s + 429*D1**2*bdd1*f**2*s**2 - 429*D1**2*bdd1*f**2*s + 2520*D1**2*f**3*fd*r*s - 630*D1**2*f**3*fd*r + 2520*D1**2*f**3*fd*s**2 - 2520*D1**2*f**3*fd*s + 630*D1**2*f**3*fd - 1260*D1**2*f**3*fdd*r*s + 315*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s**2 + 1260*D1**2*f**3*fdd*s - 315*D1**2*f**3*fdd - 3780*D1**2*f**2*fd**2*r*s + 945*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s**2 + 3780*D1**2*f**2*fd**2*s - 630*D1**2*f**2*fd**2 - 4368*D1**2*f**2*fd*r*s + 1456*D1**2*f**2*fd*r - 4368*D1**2*f**2*fd*s**2 + 4368*D1**2*f**2*fd*s - 1456*D1**2*f**2*fd + 2184*D1**2*f**2*fdd*r*s - 728*D1**2*f**2*fdd*r + 2184*D1**2*f**2*fdd*s**2 - 2184*D1**2*f**2*fdd*s + 728*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r*s - 1716*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s + 858*D1**2*f**2*gdd2*r*s + 858*D1**2*f**2*gdd2*s**2 - 858*D1**2*f**2*gdd2*s + 4368*D1**2*f*fd**2*r*s - 1456*D1**2*f*fd**2*r + 4368*D1**2*f*fd**2*s**2 - 4368*D1**2*f*fd**2*s + 728*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r*s - 858*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 3432*D1**2*f*fd*gd2*s + 858*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r*s - 858*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r*s - 858*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 2520*D1*Dd*f**4*r*s - 630*D1*Dd*f**4*r + 2520*D1*Dd*f**4*s**2 - 2520*D1*Dd*f**4*s + 630*D1*Dd*f**4 - 10080*D1*Dd*f**3*fd*r*s + 2520*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s**2 + 10080*D1*Dd*f**3*fd*s - 1890*D1*Dd*f**3*fd - 5824*D1*Dd*f**3*r*s + 1456*D1*Dd*f**3*r - 5824*D1*Dd*f**3*s**2 + 5824*D1*Dd*f**3*s - 1456*D1*Dd*f**3 + 17472*D1*Dd*f**2*fd*r*s - 5096*D1*Dd*f**2*fd*r + 17472*D1*Dd*f**2*fd*s**2 - 17472*D1*Dd*f**2*fd*s + 3640*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r*s + 1716*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 6864*D1*Dd*f**2*g2*s - 1716*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r*s - 858*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 6864*D1*Dd*f**2*gd2*s + 858*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r*s - 5148*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 13728*D1*Dd*f*fd*g2*s + 3432*D1*Dd*f*fd*g2 - 1260*D1*Ddd*f**4*r*s + 315*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s**2 + 1260*D1*Ddd*f**4*s - 315*D1*Ddd*f**4 + 2912*D1*Ddd*f**3*r*s - 728*D1*Ddd*f**3*r + 2912*D1*Ddd*f**3*s**2 - 2912*D1*Ddd*f**3*s + 728*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r*s - 858*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 3432*D1*Ddd*f**2*g2*s + 858*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 3780*Dd**2*f**4*r*s + 945*Dd**2*f**4*r - 3780*Dd**2*f**4*s**2 + 3780*Dd**2*f**4*s - 630*Dd**2*f**4 + 8736*Dd**2*f**3*r*s - 2184*Dd**2*f**3*r + 8736*Dd**2*f**3*s**2 - 8736*Dd**2*f**3*s + 1456*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r*s - 2574*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 10296*Dd**2*f**2*g2*s + 1716*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**6) + 5*D1**2*Pk3*Pkd2*ct**8*k1**2*k2*(D1**2*(315*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-1890*fd**2*s*(2*s - 1) + fd*(1456*C - 1456)*(3*s**2 - 2*s + 1) - fdd*(728*C - 728)*(3*s**2 - 2*s + 1) + s**2*(-429*K*bdd1 + 858*bd1*(K - 1) + 429*bdd1 - 1716*gd2 + 858*gdd2)) - 26*f*(fd**2*s*(56*C - 56)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 1716*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(315*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(104*C*(4*s**2 - 2*s + 1) - 45*fd*(1 - 4*s)**2 - 416*s**2 + 208*s - 104) - 13*f*(fd*(56*C - 56)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 858*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(315*f**2 + f*(728*C - 728) - 858*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(315*f**2 + f*(728*C - 728) - 858*g2) + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1001*d**2*k3**4) + 8*D1**2*Pk3*Pkd2*ct**7*k1**3*k2**2*(52650*C*D1**2*f**2*fd*r*s - 17550*C*D1**2*f**2*fd*r + 52650*C*D1**2*f**2*fd*s**2 - 52650*C*D1**2*f**2*fd*s + 17550*C*D1**2*f**2*fd - 32760*C*D1**2*f**2*fdd*r*s + 10920*C*D1**2*f**2*fdd*r - 32760*C*D1**2*f**2*fdd*s**2 + 32760*C*D1**2*f**2*fdd*s - 10920*C*D1**2*f**2*fdd - 65520*C*D1**2*f*fd**2*r*s + 21840*C*D1**2*f*fd**2*r - 65520*C*D1**2*f*fd**2*s**2 + 65520*C*D1**2*f*fd**2*s - 10920*C*D1**2*f*fd**2 + 70200*C*D1*Dd*f**3*r*s - 17550*C*D1*Dd*f**3*r + 70200*C*D1*Dd*f**3*s**2 - 70200*C*D1*Dd*f**3*s + 17550*C*D1*Dd*f**3 - 262080*C*D1*Dd*f**2*fd*r*s + 76440*C*D1*Dd*f**2*fd*r - 262080*C*D1*Dd*f**2*fd*s**2 + 262080*C*D1*Dd*f**2*fd*s - 54600*C*D1*Dd*f**2*fd - 43680*C*D1*Ddd*f**3*r*s + 10920*C*D1*Ddd*f**3*r - 43680*C*D1*Ddd*f**3*s**2 + 43680*C*D1*Ddd*f**3*s - 10920*C*D1*Ddd*f**3 - 131040*C*Dd**2*f**3*r*s + 32760*C*Dd**2*f**3*r - 131040*C*Dd**2*f**3*s**2 + 131040*C*Dd**2*f**3*s - 21840*C*Dd**2*f**3 - 6435*D1**2*K*bdd1*f**2*r*s - 6435*D1**2*K*bdd1*f**2*s**2 + 6435*D1**2*K*bdd1*f**2*s + 6435*D1**2*bdd1*f**2*r*s + 6435*D1**2*bdd1*f**2*s**2 - 6435*D1**2*bdd1*f**2*s + 43120*D1**2*f**3*fd*r*s - 10780*D1**2*f**3*fd*r + 43120*D1**2*f**3*fd*s**2 - 43120*D1**2*f**3*fd*s + 10780*D1**2*f**3*fd - 25200*D1**2*f**3*fdd*r*s + 6300*D1**2*f**3*fdd*r - 25200*D1**2*f**3*fdd*s**2 + 25200*D1**2*f**3*fdd*s - 6300*D1**2*f**3*fdd - 75600*D1**2*f**2*fd**2*r*s + 18900*D1**2*f**2*fd**2*r - 75600*D1**2*f**2*fd**2*s**2 + 75600*D1**2*f**2*fd**2*s - 12600*D1**2*f**2*fd**2 - 52650*D1**2*f**2*fd*r*s + 17550*D1**2*f**2*fd*r - 52650*D1**2*f**2*fd*s**2 + 52650*D1**2*f**2*fd*s - 17550*D1**2*f**2*fd + 32760*D1**2*f**2*fdd*r*s - 10920*D1**2*f**2*fdd*r + 32760*D1**2*f**2*fdd*s**2 - 32760*D1**2*f**2*fdd*s + 10920*D1**2*f**2*fdd - 20592*D1**2*f**2*gd2*r*s - 20592*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s + 12870*D1**2*f**2*gdd2*r*s + 12870*D1**2*f**2*gdd2*s**2 - 12870*D1**2*f**2*gdd2*s + 65520*D1**2*f*fd**2*r*s - 21840*D1**2*f*fd**2*r + 65520*D1**2*f*fd**2*s**2 - 65520*D1**2*f*fd**2*s + 10920*D1**2*f*fd**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 41184*D1**2*f*fd*g2*s**2 + 41184*D1**2*f*fd*g2*s - 20592*D1**2*f*fd*g2 + 51480*D1**2*f*fd*gd2*r*s - 12870*D1**2*f*fd*gd2*r + 51480*D1**2*f*fd*gd2*s**2 - 51480*D1**2*f*fd*gd2*s + 12870*D1**2*f*fd*gd2 + 25740*D1**2*f*fdd*g2*r*s - 12870*D1**2*f*fdd*g2*r + 25740*D1**2*f*fdd*g2*s**2 - 25740*D1**2*f*fdd*g2*s + 12870*D1**2*f*fdd*g2 + 25740*D1**2*fd**2*g2*r*s - 12870*D1**2*fd**2*g2*r + 25740*D1**2*fd**2*g2*s**2 - 25740*D1**2*fd**2*g2*s + 43120*D1*Dd*f**4*r*s - 10780*D1*Dd*f**4*r + 43120*D1*Dd*f**4*s**2 - 43120*D1*Dd*f**4*s + 10780*D1*Dd*f**4 - 201600*D1*Dd*f**3*fd*r*s + 50400*D1*Dd*f**3*fd*r - 201600*D1*Dd*f**3*fd*s**2 + 201600*D1*Dd*f**3*fd*s - 37800*D1*Dd*f**3*fd - 70200*D1*Dd*f**3*r*s + 17550*D1*Dd*f**3*r - 70200*D1*Dd*f**3*s**2 + 70200*D1*Dd*f**3*s - 17550*D1*Dd*f**3 + 262080*D1*Dd*f**2*fd*r*s - 76440*D1*Dd*f**2*fd*r + 262080*D1*Dd*f**2*fd*s**2 - 262080*D1*Dd*f**2*fd*s + 54600*D1*Dd*f**2*fd - 82368*D1*Dd*f**2*g2*r*s + 20592*D1*Dd*f**2*g2*r - 82368*D1*Dd*f**2*g2*s**2 + 82368*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*g2 + 102960*D1*Dd*f**2*gd2*r*s - 12870*D1*Dd*f**2*gd2*r + 102960*D1*Dd*f**2*gd2*s**2 - 102960*D1*Dd*f**2*gd2*s + 12870*D1*Dd*f**2*gd2 + 205920*D1*Dd*f*fd*g2*r*s - 77220*D1*Dd*f*fd*g2*r + 205920*D1*Dd*f*fd*g2*s**2 - 205920*D1*Dd*f*fd*g2*s + 51480*D1*Dd*f*fd*g2 - 25200*D1*Ddd*f**4*r*s + 6300*D1*Ddd*f**4*r - 25200*D1*Ddd*f**4*s**2 + 25200*D1*Ddd*f**4*s - 6300*D1*Ddd*f**4 + 43680*D1*Ddd*f**3*r*s - 10920*D1*Ddd*f**3*r + 43680*D1*Ddd*f**3*s**2 - 43680*D1*Ddd*f**3*s + 10920*D1*Ddd*f**3 + 51480*D1*Ddd*f**2*g2*r*s - 12870*D1*Ddd*f**2*g2*r + 51480*D1*Ddd*f**2*g2*s**2 - 51480*D1*Ddd*f**2*g2*s + 12870*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(D1*(8*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 75600*Dd**2*f**4*r*s + 18900*Dd**2*f**4*r - 75600*Dd**2*f**4*s**2 + 75600*Dd**2*f**4*s - 12600*Dd**2*f**4 + 131040*Dd**2*f**3*r*s - 32760*Dd**2*f**3*r + 131040*Dd**2*f**3*s**2 - 131040*Dd**2*f**3*s + 21840*Dd**2*f**3 + 154440*Dd**2*f**2*g2*r*s - 38610*Dd**2*f**2*g2*r + 154440*Dd**2*f**2*g2*s**2 - 154440*Dd**2*f**2*g2*s + 25740*Dd**2*f**2*g2 + 1287*b1*(K - 1)*(D1**2*(f*(8*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k3**6) + 5*D1**2*Pk3*Pkd2*ct**7*k1**3*(D1**2*(945*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(2835*fd**2*s*(2*s - 1) - fd*(1456*C - 1456)*(3*s**2 - 2*s + 1) + fdd*(728*C - 728)*(3*s**2 - 2*s + 1) + s**2*(429*K*bdd1 - 858*bd1*(K - 1) - 429*bdd1 + 1716*gd2 - 858*gdd2)) - 52*f*(fd**2*s*(56*C - 56)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 3432*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(945*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(208*C*(4*s**2 - 2*s + 1) - 135*fd*(1 - 4*s)**2 - 832*s**2 + 416*s - 208) - 26*f*(fd*(56*C - 56)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 1716*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(945*f**2 + f*(1456*C - 1456) - 1716*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(945*f**2 + f*(1456*C - 1456) - 1716*g2) + 858*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1001*d**2*k3**4) + 40*D1**2*Pk3*Pkd2*ct**7*k1*k2**4*(672*C*D1**2*f**2*fd*r*s - 224*C*D1**2*f**2*fd*r + 672*C*D1**2*f**2*fd*s**2 - 672*C*D1**2*f**2*fd*s + 224*C*D1**2*f**2*fd - 336*C*D1**2*f**2*fdd*r*s + 112*C*D1**2*f**2*fdd*r - 336*C*D1**2*f**2*fdd*s**2 + 336*C*D1**2*f**2*fdd*s - 112*C*D1**2*f**2*fdd - 672*C*D1**2*f*fd**2*r*s + 224*C*D1**2*f*fd**2*r - 672*C*D1**2*f*fd**2*s**2 + 672*C*D1**2*f*fd**2*s - 112*C*D1**2*f*fd**2 + 896*C*D1*Dd*f**3*r*s - 224*C*D1*Dd*f**3*r + 896*C*D1*Dd*f**3*s**2 - 896*C*D1*Dd*f**3*s + 224*C*D1*Dd*f**3 - 2688*C*D1*Dd*f**2*fd*r*s + 784*C*D1*Dd*f**2*fd*r - 2688*C*D1*Dd*f**2*fd*s**2 + 2688*C*D1*Dd*f**2*fd*s - 560*C*D1*Dd*f**2*fd - 448*C*D1*Ddd*f**3*r*s + 112*C*D1*Ddd*f**3*r - 448*C*D1*Ddd*f**3*s**2 + 448*C*D1*Ddd*f**3*s - 112*C*D1*Ddd*f**3 - 1344*C*Dd**2*f**3*r*s + 336*C*Dd**2*f**3*r - 1344*C*Dd**2*f**3*s**2 + 1344*C*Dd**2*f**3*s - 224*C*Dd**2*f**3 - 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s + 28*D1**2*bdd1*f**3*r*s + 28*D1**2*bdd1*f**3*s**2 - 28*D1**2*bdd1*f**3*s + 33*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s - 504*D1**2*f**2*fd*r*s + 168*D1**2*f**2*fd*r - 504*D1**2*f**2*fd*s**2 + 504*D1**2*f**2*fd*s - 168*D1**2*f**2*fd + 252*D1**2*f**2*fdd*r*s - 84*D1**2*f**2*fdd*r + 252*D1**2*f**2*fdd*s**2 - 252*D1**2*f**2*fdd*s + 84*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 504*D1**2*f*fd**2*r*s - 168*D1**2*f*fd**2*r + 504*D1**2*f*fd**2*s**2 - 504*D1**2*f*fd**2*s + 84*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r*s - 132*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 528*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s - 672*D1*Dd*f**3*r*s + 168*D1*Dd*f**3*r - 672*D1*Dd*f**3*s**2 + 672*D1*Dd*f**3*s - 168*D1*Dd*f**3 + 2016*D1*Dd*f**2*fd*r*s - 588*D1*Dd*f**2*fd*r + 2016*D1*Dd*f**2*fd*s**2 - 2016*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r*s - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1056*D1*Dd*f**2*gd2*s + 132*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r*s - 792*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2112*D1*Dd*f*fd*g2*s + 528*D1*Dd*f*fd*g2 + 336*D1*Ddd*f**3*r*s - 84*D1*Ddd*f**3*r + 336*D1*Ddd*f**3*s**2 - 336*D1*Ddd*f**3*s + 84*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r*s - 132*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 528*D1*Ddd*f**2*g2*s + 132*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(28*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-66*K + 28*f + 33)*(r + s - 1) - 33*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-66*K + 28*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 1008*Dd**2*f**3*r*s - 252*Dd**2*f**3*r + 1008*Dd**2*f**3*s**2 - 1008*Dd**2*f**3*s + 168*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r*s - 396*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 1584*Dd**2*f**2*g2*s + 264*Dd**2*f**2*g2 + b1*(D1**2*(-28*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*fd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 33*fdd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 33*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(-2*Dd*(28*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-14*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (33 - 66*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 33*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-66*K + 28*f + 33)) + Dd**2*f**2*(-66*K + 28*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**6) + 5*D1**2*Pk3*Pkd2*ct**7*k1*k2**2*(-1584*C*D1**2*f**2*fd*r*s + 528*C*D1**2*f**2*fd*r + 3360*C*D1**2*f**2*fd*s**2 - 1712*C*D1**2*f**2*fd*s + 1120*C*D1**2*f**2*fd + 792*C*D1**2*f**2*fdd*r*s - 264*C*D1**2*f**2*fdd*r - 1680*C*D1**2*f**2*fdd*s**2 + 856*C*D1**2*f**2*fdd*s - 560*C*D1**2*f**2*fdd + 1584*C*D1**2*f*fd**2*r*s - 528*C*D1**2*f*fd**2*r - 3360*C*D1**2*f*fd**2*s**2 + 1712*C*D1**2*f*fd**2*s + 264*C*D1**2*f*fd**2 - 2112*C*D1*Dd*f**3*r*s + 528*C*D1*Dd*f**3*r + 4480*C*D1*Dd*f**3*s**2 - 1184*C*D1*Dd*f**3*s + 1120*C*D1*Dd*f**3 + 6336*C*D1*Dd*f**2*fd*r*s - 1848*C*D1*Dd*f**2*fd*r - 13440*C*D1*Dd*f**2*fd*s**2 + 5200*C*D1*Dd*f**2*fd*s - 328*C*D1*Dd*f**2*fd + 1056*C*D1*Ddd*f**3*r*s - 264*C*D1*Ddd*f**3*r - 2240*C*D1*Ddd*f**3*s**2 + 592*C*D1*Ddd*f**3*s - 560*C*D1*Ddd*f**3 + 3168*C*Dd**2*f**3*r*s - 792*C*Dd**2*f**3*r - 6720*C*Dd**2*f**3*s**2 + 1776*C*Dd**2*f**3*s + 528*C*Dd**2*f**3 + 132*D1**2*K*bdd1*f**2*r*s - 330*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s - 112*D1**2*bdd1*f**3*r*s + 28*D1**2*bdd1*f**3*s**2 + 112*D1**2*bdd1*f**3*s - 264*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 + 264*D1**2*bdd1*f**2*s - 448*D1**2*f**3*fd*r*s + 112*D1**2*f**3*fd*r + 224*D1**2*f**3*fd*s + 448*D1**2*f**3*fdd*r*s - 112*D1**2*f**3*fdd*r - 224*D1**2*f**3*fdd*s + 1344*D1**2*f**2*fd**2*r*s - 336*D1**2*f**2*fd**2*r - 672*D1**2*f**2*fd**2*s + 224*D1**2*f**2*fd**2 + 2256*D1**2*f**2*fd*r*s - 752*D1**2*f**2*fd*r - 1848*D1**2*f**2*fd*s**2 + 480*D1**2*f**2*fd*s - 616*D1**2*f**2*fd - 1128*D1**2*f**2*fdd*r*s + 376*D1**2*f**2*fdd*r + 924*D1**2*f**2*fdd*s**2 - 240*D1**2*f**2*fdd*s + 308*D1**2*f**2*fdd + 528*D1**2*f**2*gd2*r*s - 1320*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s - 264*D1**2*f**2*gdd2*r*s + 660*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 2256*D1**2*f*fd**2*r*s + 752*D1**2*f*fd**2*r + 1848*D1**2*f*fd**2*s**2 - 480*D1**2*f*fd**2*s - 376*D1**2*f*fd**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r - 2640*D1**2*f*fd*g2*s**2 + 2640*D1**2*f*fd*g2*s - 1320*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r*s + 264*D1**2*f*fd*gd2*r + 2640*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r + 1320*D1**2*f*fdd*g2*s**2 - 1320*D1**2*f*fdd*g2*s + 660*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r + 1320*D1**2*fd**2*g2*s**2 - 1320*D1**2*fd**2*g2*s - 448*D1*Dd*f**4*r*s + 112*D1*Dd*f**4*r + 224*D1*Dd*f**4*s + 3584*D1*Dd*f**3*fd*r*s - 896*D1*Dd*f**3*fd*r - 1792*D1*Dd*f**3*fd*s + 448*D1*Dd*f**3*fd + 3008*D1*Dd*f**3*r*s - 752*D1*Dd*f**3*r - 2464*D1*Dd*f**3*s**2 - 272*D1*Dd*f**3*s - 616*D1*Dd*f**3 - 9024*D1*Dd*f**2*fd*r*s + 2632*D1*Dd*f**2*fd*r + 7392*D1*Dd*f**2*fd*s**2 - 552*D1*Dd*f**2*fd*s - 512*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*g2*r*s - 528*D1*Dd*f**2*g2*r - 5280*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 1320*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r*s + 264*D1*Dd*f**2*gd2*r + 5280*D1*Dd*f**2*gd2*s**2 + 264*D1*Dd*f**2*gd2*s - 264*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r*s + 1584*D1*Dd*f*fd*g2*r + 10560*D1*Dd*f*fd*g2*s**2 - 6864*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 + 448*D1*Ddd*f**4*r*s - 112*D1*Ddd*f**4*r - 224*D1*Ddd*f**4*s - 1504*D1*Ddd*f**3*r*s + 376*D1*Ddd*f**3*r + 1232*D1*Ddd*f**3*s**2 + 136*D1*Ddd*f**3*s + 308*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r*s + 264*D1*Ddd*f**2*g2*r + 2640*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 660*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(f*s*(-66*K*(2*r - 5*s - 2) + 28*f*(4*r - s - 4) + 264*r - 33*s - 264) + fd*(33*K*(8*r*s - 2*r - 20*s**2 + 6*s + 2) + 28*f*(r*(2 - 12*s) + 3*s**2 + 7*s - 2) - 528*r*s + 132*r + 66*s**2 + 231*s - 132)) + Dd*f*(-66*K*(-8*r*s + r + 20*s**2 + s - 1) + 28*f*(r*(2 - 16*s) + 4*s**2 + 11*s - 2) - 1056*r*s + 132*r + 132*s**2 + 759*s - 132)) + 1344*Dd**2*f**4*r*s - 336*Dd**2*f**4*r - 672*Dd**2*f**4*s + 224*Dd**2*f**4 - 4512*Dd**2*f**3*r*s + 1128*Dd**2*f**3*r + 3696*Dd**2*f**3*s**2 + 408*Dd**2*f**3*s - 752*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r*s + 792*Dd**2*f**2*g2*r + 7920*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s - 528*Dd**2*f**2*g2 + b1*(D1**2*(-28*f**2*(2*fd - fdd)*(r*(4 - 12*s) + 3*s**2 + 2*s + 1) + f*(56*fd**2*(r*(4 - 12*s) + 3*s**2 + 2*s - 2) - 66*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1) + 33*fdd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1)) + 66*fd**2*(r*(2*K - 4)*(2*s - 1) - s*(10*K - 1)*(s - 1))) + D1*f*(2*Dd*(-28*f**2*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) + f*(-66*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + 28*fd*(r*(14 - 48*s) + 12*s**2 + 13*s - 5) + 1056*r*s - 264*r - 132*s**2 - 462*s - 33) + 33*fd*(2*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) - 64*r*s + 24*r + 8*s**2 + 10*s - 7)) + Ddd*f*(66*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + 28*f*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) - 1056*r*s + 264*r + 132*s**2 + 462*s + 33)) + 2*Dd**2*f**2*(66*K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) + 28*f*(r*(6 - 24*s) + 6*s**2 + 9*s - 4) - 1584*r*s + 396*r + 198*s**2 + 693*s - 264)))/(693*d**2*k3**4) + 5*D1**2*Pk3*Pkd2*ct**7*k1*(b1*(D1**2*(28*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-56*fd**2*s*(3*s - 2) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(28*f**2*(4*s**2 - 2*s + 1) - 28*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(28*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(28*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(56*bd1 - 28*bdd1) + f*(-56*fd*(s**2*(3*bd1 - 3) - s*(bd1 - 2) - 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) - 2*D1*f*(28*Dd*f*(s**2*(4*bd1 - 4) - s*(bd1 - 2) - 1) + Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) + 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k3**2) + 8*D1**2*Pk3*Pkd2*ct**6*k1**4*k2*(13260*C*D1**2*f**2*fd*r*s - 4420*C*D1**2*f**2*fd*r + 13260*C*D1**2*f**2*fd*s**2 - 13260*C*D1**2*f**2*fd*s + 4420*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r*s + 3640*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 10920*C*D1**2*f**2*fdd*s - 3640*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r*s + 7280*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 21840*C*D1**2*f*fd**2*s - 3640*C*D1**2*f*fd**2 + 17680*C*D1*Dd*f**3*r*s - 4420*C*D1*Dd*f**3*r + 17680*C*D1*Dd*f**3*s**2 - 17680*C*D1*Dd*f**3*s + 4420*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r*s + 25480*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 87360*C*D1*Dd*f**2*fd*s - 18200*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r*s + 3640*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 14560*C*D1*Ddd*f**3*s - 3640*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r*s + 10920*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 43680*C*Dd**2*f**3*s - 7280*C*Dd**2*f**3 - 2145*D1**2*K*bdd1*f**2*r*s - 2145*D1**2*K*bdd1*f**2*s**2 + 2145*D1**2*K*bdd1*f**2*s + 2145*D1**2*bdd1*f**2*r*s + 2145*D1**2*bdd1*f**2*s**2 - 2145*D1**2*bdd1*f**2*s + 17920*D1**2*f**3*fd*r*s - 4480*D1**2*f**3*fd*r + 17920*D1**2*f**3*fd*s**2 - 17920*D1**2*f**3*fd*s + 4480*D1**2*f**3*fd - 12600*D1**2*f**3*fdd*r*s + 3150*D1**2*f**3*fdd*r - 12600*D1**2*f**3*fdd*s**2 + 12600*D1**2*f**3*fdd*s - 3150*D1**2*f**3*fdd - 37800*D1**2*f**2*fd**2*r*s + 9450*D1**2*f**2*fd**2*r - 37800*D1**2*f**2*fd**2*s**2 + 37800*D1**2*f**2*fd**2*s - 6300*D1**2*f**2*fd**2 - 13260*D1**2*f**2*fd*r*s + 4420*D1**2*f**2*fd*r - 13260*D1**2*f**2*fd*s**2 + 13260*D1**2*f**2*fd*s - 4420*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r*s - 3640*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 10920*D1**2*f**2*fdd*s + 3640*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r*s - 5148*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s + 4290*D1**2*f**2*gdd2*r*s + 4290*D1**2*f**2*gdd2*s**2 - 4290*D1**2*f**2*gdd2*s + 21840*D1**2*f*fd**2*r*s - 7280*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 21840*D1**2*f*fd**2*s + 3640*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r*s - 4290*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 17160*D1**2*f*fd*gd2*s + 4290*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r*s - 4290*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r*s - 4290*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 17920*D1*Dd*f**4*r*s - 4480*D1*Dd*f**4*r + 17920*D1*Dd*f**4*s**2 - 17920*D1*Dd*f**4*s + 4480*D1*Dd*f**4 - 100800*D1*Dd*f**3*fd*r*s + 25200*D1*Dd*f**3*fd*r - 100800*D1*Dd*f**3*fd*s**2 + 100800*D1*Dd*f**3*fd*s - 18900*D1*Dd*f**3*fd - 17680*D1*Dd*f**3*r*s + 4420*D1*Dd*f**3*r - 17680*D1*Dd*f**3*s**2 + 17680*D1*Dd*f**3*s - 4420*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r*s - 25480*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 87360*D1*Dd*f**2*fd*s + 18200*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r*s - 4290*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 34320*D1*Dd*f**2*gd2*s + 4290*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r*s - 25740*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 68640*D1*Dd*f*fd*g2*s + 17160*D1*Dd*f*fd*g2 - 12600*D1*Ddd*f**4*r*s + 3150*D1*Ddd*f**4*r - 12600*D1*Ddd*f**4*s**2 + 12600*D1*Ddd*f**4*s - 3150*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r*s - 3640*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 14560*D1*Ddd*f**3*s + 3640*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r*s - 4290*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 17160*D1*Ddd*f**2*g2*s + 4290*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(6*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 37800*Dd**2*f**4*r*s + 9450*Dd**2*f**4*r - 37800*Dd**2*f**4*s**2 + 37800*Dd**2*f**4*s - 6300*Dd**2*f**4 + 43680*Dd**2*f**3*r*s - 10920*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 43680*Dd**2*f**3*s + 7280*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r*s - 12870*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 51480*Dd**2*f**2*g2*s + 8580*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(6*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**6) + 5*D1**2*Pk3*Pkd2*ct**6*k1**4*(D1**2*(945*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-5670*fd**2*s*(2*s - 1) + fd*(1456*C - 1456)*(3*s**2 - 2*s + 1) - fdd*(728*C - 728)*(3*s**2 - 2*s + 1) + s**2*(-429*K*bdd1 + 858*bd1*(K - 1) + 429*bdd1 - 1716*gd2 + 858*gdd2)) - 26*f*(fd**2*s*(56*C - 56)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 1716*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(945*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(104*C*(4*s**2 - 2*s + 1) - 135*fd*(1 - 4*s)**2 - 416*s**2 + 208*s - 104) - 13*f*(fd*(56*C - 56)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 858*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(945*f**2 + f*(728*C - 728) - 858*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(945*f**2 + f*(728*C - 728) - 858*g2) + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1001*d**2*k2*k3**4) + 20*D1**2*Pk3*Pkd2*ct**6*k1**2*k2**3*st**2*(11700*C*D1**2*f**2*fd*r*s - 3900*C*D1**2*f**2*fd*r + 11700*C*D1**2*f**2*fd*s**2 - 11700*C*D1**2*f**2*fd*s + 3900*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 15600*C*D1*Dd*f**3*r*s - 3900*C*D1*Dd*f**3*r + 15600*C*D1*Dd*f**3*s**2 - 15600*C*D1*Dd*f**3*s + 3900*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 10976*D1**2*f**3*fd*r*s - 2744*D1**2*f**3*fd*r + 10976*D1**2*f**3*fd*s**2 - 10976*D1**2*f**3*fd*s + 2744*D1**2*f**3*fd - 5488*D1**2*f**3*fdd*r*s + 1372*D1**2*f**3*fdd*r - 5488*D1**2*f**3*fdd*s**2 + 5488*D1**2*f**3*fdd*s - 1372*D1**2*f**3*fdd - 16464*D1**2*f**2*fd**2*r*s + 4116*D1**2*f**2*fd**2*r - 16464*D1**2*f**2*fd**2*s**2 + 16464*D1**2*f**2*fd**2*s - 2744*D1**2*f**2*fd**2 - 11700*D1**2*f**2*fd*r*s + 3900*D1**2*f**2*fd*r - 11700*D1**2*f**2*fd*s**2 + 11700*D1**2*f**2*fd*s - 3900*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r*s - 5148*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 10976*D1*Dd*f**4*r*s - 2744*D1*Dd*f**4*r + 10976*D1*Dd*f**4*s**2 - 10976*D1*Dd*f**4*s + 2744*D1*Dd*f**4 - 43904*D1*Dd*f**3*fd*r*s + 10976*D1*Dd*f**3*fd*r - 43904*D1*Dd*f**3*fd*s**2 + 43904*D1*Dd*f**3*fd*s - 8232*D1*Dd*f**3*fd - 15600*D1*Dd*f**3*r*s + 3900*D1*Dd*f**3*r - 15600*D1*Dd*f**3*s**2 + 15600*D1*Dd*f**3*s - 3900*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 5488*D1*Ddd*f**4*r*s + 1372*D1*Ddd*f**4*r - 5488*D1*Ddd*f**4*s**2 + 5488*D1*Ddd*f**4*s - 1372*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 16464*Dd**2*f**4*r*s + 4116*Dd**2*f**4*r - 16464*Dd**2*f**4*s**2 + 16464*Dd**2*f**4*s - 2744*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 1287*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**6) + 8*D1**2*Pk3*Pkd2*ct**6*k1**2*k2**3*(-330*C*D1**2*bdd1*f**2*r*s + 330*C*D1**2*bdd1*f**2*r - 330*C*D1**2*bdd1*f**2*s**2 + 660*C*D1**2*bdd1*f**2*s - 330*C*D1**2*bdd1*f**2 + 7110*C*D1**2*f**2*fd*r*s - 2370*C*D1**2*f**2*fd*r + 7110*C*D1**2*f**2*fd*s**2 - 7110*C*D1**2*f**2*fd*s + 2370*C*D1**2*f**2*fd - 5040*C*D1**2*f**2*fdd*r*s + 1680*C*D1**2*f**2*fdd*r - 5040*C*D1**2*f**2*fdd*s**2 + 5040*C*D1**2*f**2*fdd*s - 1680*C*D1**2*f**2*fdd - 10080*C*D1**2*f*fd**2*r*s + 3360*C*D1**2*f*fd**2*r - 10080*C*D1**2*f*fd**2*s**2 + 10080*C*D1**2*f*fd**2*s - 1680*C*D1**2*f*fd**2 + 9480*C*D1*Dd*f**3*r*s - 2370*C*D1*Dd*f**3*r + 9480*C*D1*Dd*f**3*s**2 - 9480*C*D1*Dd*f**3*s + 2370*C*D1*Dd*f**3 - 40320*C*D1*Dd*f**2*fd*r*s + 11760*C*D1*Dd*f**2*fd*r - 40320*C*D1*Dd*f**2*fd*s**2 + 40320*C*D1*Dd*f**2*fd*s - 8400*C*D1*Dd*f**2*fd - 6720*C*D1*Ddd*f**3*r*s + 1680*C*D1*Ddd*f**3*r - 6720*C*D1*Ddd*f**3*s**2 + 6720*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 20160*C*Dd**2*f**3*r*s + 5040*C*Dd**2*f**3*r - 20160*C*Dd**2*f**3*s**2 + 20160*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 990*D1**2*K*bdd1*f**2*r*s - 990*D1**2*K*bdd1*f**2*s**2 + 990*D1**2*K*bdd1*f**2*s - 198*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 420*D1**2*bdd1*f**3*r*s + 140*D1**2*bdd1*f**3*r + 420*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s - 140*D1**2*bdd1*f**3 + 825*D1**2*bdd1*f**2*r*s - 330*D1**2*bdd1*f**2*r + 825*D1**2*bdd1*f**2*s**2 - 1155*D1**2*bdd1*f**2*s + 330*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r*s - 396*D1**2*bdd1*f*g2*r + 396*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 560*D1**2*f**3*fd*r*s + 140*D1**2*f**3*fd*r - 560*D1**2*f**3*fd*s**2 + 560*D1**2*f**3*fd*s - 140*D1**2*f**3*fd - 5085*D1**2*f**2*fd*r*s + 1695*D1**2*f**2*fd*r - 5085*D1**2*f**2*fd*s**2 + 5085*D1**2*f**2*fd*s - 1695*D1**2*f**2*fd + 3780*D1**2*f**2*fdd*r*s - 1260*D1**2*f**2*fdd*r + 3780*D1**2*f**2*fdd*s**2 - 3780*D1**2*f**2*fdd*s + 1260*D1**2*f**2*fdd - 2772*D1**2*f**2*gd2*r*s - 2772*D1**2*f**2*gd2*s**2 + 2772*D1**2*f**2*gd2*s + 1980*D1**2*f**2*gdd2*r*s + 1980*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 7560*D1**2*f*fd**2*r*s - 2520*D1**2*f*fd**2*r + 7560*D1**2*f*fd**2*s**2 - 7560*D1**2*f*fd**2*s + 1260*D1**2*f*fd**2 - 5544*D1**2*f*fd*g2*r*s + 2772*D1**2*f*fd*g2*r - 5544*D1**2*f*fd*g2*s**2 + 5544*D1**2*f*fd*g2*s - 2772*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s - 560*D1*Dd*f**4*r*s + 140*D1*Dd*f**4*r - 560*D1*Dd*f**4*s**2 + 560*D1*Dd*f**4*s - 140*D1*Dd*f**4 - 6780*D1*Dd*f**3*r*s + 1695*D1*Dd*f**3*r - 6780*D1*Dd*f**3*s**2 + 6780*D1*Dd*f**3*s - 1695*D1*Dd*f**3 + 30240*D1*Dd*f**2*fd*r*s - 8820*D1*Dd*f**2*fd*r + 30240*D1*Dd*f**2*fd*s**2 - 30240*D1*Dd*f**2*fd*s + 6300*D1*Dd*f**2*fd - 11088*D1*Dd*f**2*g2*r*s + 2772*D1*Dd*f**2*g2*r - 11088*D1*Dd*f**2*g2*s**2 + 11088*D1*Dd*f**2*g2*s - 2772*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r*s - 1980*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 15840*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 31680*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 5040*D1*Ddd*f**3*r*s - 1260*D1*Ddd*f**3*r + 5040*D1*Ddd*f**3*s**2 - 5040*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 1980*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(135*s + 56)*(r + s - 1) + 2*f**2*(330*C*(s - 1)*(r + s - 1) + 70*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + (33*r + 33*s - 33)*(21*K*s - 19*s + 10)) - 33*f*(5*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 6*K*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 7*r - 20*s**2 + 22*s - 5) + (12*r + 12*s - 12)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 396*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(140*f**2*(24*r*s + r + 4*s*(6*s - 5)) - 165*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 6*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 40*r*s + 13*r - 40*s**2 + 48*s - 11) + 396*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 15120*Dd**2*f**3*r*s - 3780*Dd**2*f**3*r + 15120*Dd**2*f**3*s**2 - 15120*Dd**2*f**3*s + 2520*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 3960*Dd**2*f**2*g2 + 198*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(1320*C*D1**2*f*fd*r*s + 1320*C*D1**2*f*fd*s**2 - 660*C*D1**2*f*fd*s - 660*C*D1**2*f*fdd*r*s - 660*C*D1**2*f*fdd*s**2 + 330*C*D1**2*f*fdd*s - 660*C*D1**2*fd**2*r*s - 660*C*D1**2*fd**2*s**2 + 330*C*D1**2*fd**2*s + 2640*C*D1*Dd*f**2*r*s - 660*C*D1*Dd*f**2*r + 2640*C*D1*Dd*f**2*s**2 - 2640*C*D1*Dd*f**2*s + 660*C*D1*Dd*f**2 - 5280*C*D1*Dd*f*fd*r*s + 660*C*D1*Dd*f*fd*r - 5280*C*D1*Dd*f*fd*s**2 + 3960*C*D1*Dd*f*fd*s - 330*C*D1*Dd*f*fd - 1320*C*D1*Ddd*f**2*r*s + 330*C*D1*Ddd*f**2*r - 1320*C*D1*Ddd*f**2*s**2 + 1320*C*D1*Ddd*f**2*s - 330*C*D1*Ddd*f**2 - 3960*C*Dd**2*f**2*r*s + 990*C*Dd**2*f**2*r - 3960*C*Dd**2*f**2*s**2 + 3960*C*Dd**2*f**2*s - 660*C*Dd**2*f**2 + 2772*D1**2*K*f*fd*r*s - 1386*D1**2*K*f*fd*r + 2772*D1**2*K*f*fd*s**2 - 2772*D1**2*K*f*fd*s + 1386*D1**2*K*f*fd - 1980*D1**2*K*f*fdd*r*s + 990*D1**2*K*f*fdd*r - 1980*D1**2*K*f*fdd*s**2 + 1980*D1**2*K*f*fdd*s - 990*D1**2*K*f*fdd - 1980*D1**2*K*fd**2*r*s + 990*D1**2*K*fd**2*r - 1980*D1**2*K*fd**2*s**2 + 1980*D1**2*K*fd**2*s - 198*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 2025*D1**2*f**2*fd*r*s + 955*D1**2*f**2*fd*r - 2025*D1**2*f**2*fd*s**2 + 2305*D1**2*f**2*fd*s - 955*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1400*D1**2*f**2*fdd*s + 560*D1**2*f**2*fdd + 2520*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 2800*D1**2*f*fd**2*s + 560*D1**2*f*fd**2 - 2508*D1**2*f*fd*r*s + 594*D1**2*f*fd*r - 2508*D1**2*f*fd*s**2 + 1848*D1**2*f*fd*s - 594*D1**2*f*fd + 1650*D1**2*f*fdd*r*s - 495*D1**2*f*fdd*r + 1650*D1**2*f*fdd*s**2 - 1320*D1**2*f*fdd*s + 495*D1**2*f*fdd - 792*D1**2*f*gd2*r*s - 792*D1**2*f*gd2*s**2 + 792*D1**2*f*gd2*s + 396*D1**2*f*gdd2*r*s + 396*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s + 1650*D1**2*fd**2*r*s - 495*D1**2*fd**2*r + 1650*D1**2*fd**2*s**2 - 1320*D1**2*fd**2*s - 792*D1**2*fd*g2*r*s - 792*D1**2*fd*g2*s**2 + 792*D1**2*fd*gd2*r*s + 792*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 396*D1**2*fdd*g2*r*s + 396*D1**2*fdd*g2*s**2 + 5544*D1*Dd*K*f**2*r*s - 1386*D1*Dd*K*f**2*r + 5544*D1*Dd*K*f**2*s**2 - 5544*D1*Dd*K*f**2*s + 1386*D1*Dd*K*f**2 - 15840*D1*Dd*K*f*fd*r*s + 5940*D1*Dd*K*f*fd*r - 15840*D1*Dd*K*f*fd*s**2 + 15840*D1*Dd*K*f*fd*s - 3960*D1*Dd*K*f*fd - 2700*D1*Dd*f**3*r*s + 675*D1*Dd*f**3*r - 2700*D1*Dd*f**3*s**2 + 2700*D1*Dd*f**3*s - 675*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r*s - 3500*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 10640*D1*Dd*f**2*fd*s + 2520*D1*Dd*f**2*fd - 5016*D1*Dd*f**2*r*s + 1254*D1*Dd*f**2*r - 5016*D1*Dd*f**2*s**2 + 5016*D1*Dd*f**2*s - 1254*D1*Dd*f**2 + 13200*D1*Dd*f*fd*r*s - 3630*D1*Dd*f*fd*r + 13200*D1*Dd*f*fd*s**2 - 11880*D1*Dd*f*fd*s + 2310*D1*Dd*f*fd - 3168*D1*Dd*f*g2*r*s + 792*D1*Dd*f*g2*r - 3168*D1*Dd*f*g2*s**2 + 3168*D1*Dd*f*g2*s - 792*D1*Dd*f*g2 + 3168*D1*Dd*f*gd2*r*s - 396*D1*Dd*f*gd2*r + 3168*D1*Dd*f*gd2*s**2 - 3168*D1*Dd*f*gd2*s + 396*D1*Dd*f*gd2 + 3168*D1*Dd*fd*g2*r*s - 396*D1*Dd*fd*g2*r + 3168*D1*Dd*fd*g2*s**2 - 1584*D1*Dd*fd*g2*s - 3960*D1*Ddd*K*f**2*r*s + 990*D1*Ddd*K*f**2*r - 3960*D1*Ddd*K*f**2*s**2 + 3960*D1*Ddd*K*f**2*s - 990*D1*Ddd*K*f**2 + 1680*D1*Ddd*f**3*r*s - 420*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 1680*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 3300*D1*Ddd*f**2*r*s - 825*D1*Ddd*f**2*r + 3300*D1*Ddd*f**2*s**2 - 3300*D1*Ddd*f**2*s + 825*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r*s - 396*D1*Ddd*f*g2*r + 1584*D1*Ddd*f*g2*s**2 - 1584*D1*Ddd*f*g2*s + 396*D1*Ddd*f*g2 + 198*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 11880*Dd**2*K*f**2*r*s + 2970*Dd**2*K*f**2*r - 11880*Dd**2*K*f**2*s**2 + 11880*Dd**2*K*f**2*s - 1980*Dd**2*K*f**2 + 5040*Dd**2*f**3*r*s - 1260*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 5040*Dd**2*f**3*s + 840*Dd**2*f**3 + 9900*Dd**2*f**2*r*s - 2475*Dd**2*f**2*r + 9900*Dd**2*f**2*s**2 - 9900*Dd**2*f**2*s + 1650*Dd**2*f**2 + 4752*Dd**2*f*g2*r*s - 1188*Dd**2*f*g2*r + 4752*Dd**2*f*g2*s**2 - 4752*Dd**2*f*g2*s + 792*Dd**2*f*g2))/(693*d**2*k3**6) + 5*D1**2*Pk3*Pkd2*ct**6*k1**2*k2*st**2*(D1**2*(1372*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 3*f**2*(2744*fd**2*s*(2*s - 1) - fd*(1300*C - 1300)*(3*s**2 - 2*s + 1) + fdd*(650*C - 650)*(3*s**2 - 2*s + 1) + s**2*(429*K*bdd1 - 858*bd1*(K - 1) - 429*bdd1 + 1716*gd2 - 858*gdd2)) - 78*f*(fd**2*s*(50*C - 50)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 5148*fd**2*g2*s*(s - 1)) + 2*D1*f*(Dd*(1372*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(975*C*(4*s**2 - 2*s + 1) - 686*fd*(1 - 4*s)**2 - 3900*s**2 + 1950*s - 975) - 39*f*(fd*(50*C - 50)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 2574*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(686*f**2 + f*(975*C - 975) - 1287*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(2*s - 1)*(686*f**2 + f*(975*C - 975) - 1287*g2) + 1287*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(2002*d**2*k3**4) + 2*D1**2*Pk3*Pkd2*ct**6*k1**2*k2*(-660*C*D1**2*bdd1*f**2*r*s - 1485*C*D1**2*bdd1*f**2*s**2 + 1650*C*D1**2*bdd1*f**2*s - 825*C*D1**2*bdd1*f**2 - 9900*C*D1**2*f**2*fd*r*s + 3300*C*D1**2*f**2*fd*r + 7500*C*D1**2*f**2*fd*s**2 - 1700*C*D1**2*f**2*fd*s + 2500*C*D1**2*f**2*fd + 5940*C*D1**2*f**2*fdd*r*s - 1980*C*D1**2*f**2*fdd*r - 2265*C*D1**2*f**2*fdd*s**2 - 470*C*D1**2*f**2*fdd*s - 755*C*D1**2*f**2*fdd + 11880*C*D1**2*f*fd**2*r*s - 3960*C*D1**2*f*fd**2*r - 4530*C*D1**2*f*fd**2*s**2 - 940*C*D1**2*f*fd**2*s + 1980*C*D1**2*f*fd**2 - 13200*C*D1*Dd*f**3*r*s + 3300*C*D1*Dd*f**3*r + 10000*C*D1*Dd*f**3*s**2 + 1600*C*D1*Dd*f**3*s + 2500*C*D1*Dd*f**3 + 47520*C*D1*Dd*f**2*fd*r*s - 13860*C*D1*Dd*f**2*fd*r - 18120*C*D1*Dd*f**2*fd*s**2 - 9230*C*D1*Dd*f**2*fd*s + 4430*C*D1*Dd*f**2*fd + 7920*C*D1*Ddd*f**3*r*s - 1980*C*D1*Ddd*f**3*r - 3020*C*D1*Ddd*f**3*s**2 - 2450*C*D1*Ddd*f**3*s - 755*C*D1*Ddd*f**3 + 23760*C*Dd**2*f**3*r*s - 5940*C*Dd**2*f**3*r - 9060*C*Dd**2*f**3*s**2 - 7350*C*Dd**2*f**3*s + 3960*C*Dd**2*f**3 + 1056*D1**2*K*bdd1*f**2*r*s - 429*D1**2*K*bdd1*f**2*s**2 - 1056*D1**2*K*bdd1*f**2*s - 198*D1**2*bd1**2*f*s*(K - 1)*(4*r + 9*s - 7) - 1120*D1**2*bdd1*f**3*r*s - 420*D1**2*bdd1*f**3*s**2 + 1540*D1**2*bdd1*f**3*s - 350*D1**2*bdd1*f**3 - 1386*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*s**2 + 396*D1**2*bdd1*f**2*s + 825*D1**2*bdd1*f**2 + 792*D1**2*bdd1*f*g2*r*s + 1782*D1**2*bdd1*f*g2*s**2 - 1980*D1**2*bdd1*f*g2*s + 990*D1**2*bdd1*f*g2 - 5040*D1**2*f**3*fd*r*s + 1260*D1**2*f**3*fd*r - 5600*D1**2*f**3*fd*s**2 + 5320*D1**2*f**3*fd*s - 1400*D1**2*f**3*fd + 5040*D1**2*f**3*fdd*r*s - 1260*D1**2*f**3*fdd*r + 3640*D1**2*f**3*fdd*s**2 - 4340*D1**2*f**3*fdd*s + 910*D1**2*f**3*fdd + 15120*D1**2*f**2*fd**2*r*s - 3780*D1**2*f**2*fd**2*r + 10920*D1**2*f**2*fd**2*s**2 - 13020*D1**2*f**2*fd**2*s + 2520*D1**2*f**2*fd**2 + 13950*D1**2*f**2*fd*r*s - 4650*D1**2*f**2*fd*r + 750*D1**2*f**2*fd*s**2 - 5150*D1**2*f**2*fd*s + 250*D1**2*f**2*fd - 8460*D1**2*f**2*fdd*r*s + 2820*D1**2*f**2*fdd*r - 2355*D1**2*f**2*fdd*s**2 + 4390*D1**2*f**2*fdd*s - 785*D1**2*f**2*fdd + 3432*D1**2*f**2*gd2*r*s - 2904*D1**2*f**2*gd2*s**2 - 3432*D1**2*f**2*gd2*s - 2112*D1**2*f**2*gdd2*r*s + 858*D1**2*f**2*gdd2*s**2 + 2112*D1**2*f**2*gdd2*s - 16920*D1**2*f*fd**2*r*s + 5640*D1**2*f*fd**2*r - 4710*D1**2*f*fd**2*s**2 + 8780*D1**2*f*fd**2*s - 2820*D1**2*f*fd**2 + 6864*D1**2*f*fd*g2*r*s - 3432*D1**2*f*fd*g2*r - 5808*D1**2*f*fd*g2*s**2 + 5808*D1**2*f*fd*g2*s - 2904*D1**2*f*fd*g2 - 8448*D1**2*f*fd*gd2*r*s + 2112*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 + 2508*D1**2*f*fd*gd2*s - 2112*D1**2*f*fd*gd2 - 4224*D1**2*f*fdd*g2*r*s + 2112*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 - 4224*D1**2*fd**2*g2*r*s + 2112*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s - 5040*D1*Dd*f**4*r*s + 1260*D1*Dd*f**4*r - 5600*D1*Dd*f**4*s**2 + 5320*D1*Dd*f**4*s - 1400*D1*Dd*f**4 + 40320*D1*Dd*f**3*fd*r*s - 10080*D1*Dd*f**3*fd*r + 29120*D1*Dd*f**3*fd*s**2 - 34720*D1*Dd*f**3*fd*s + 6860*D1*Dd*f**3*fd + 18600*D1*Dd*f**3*r*s - 4650*D1*Dd*f**3*r + 1000*D1*Dd*f**3*s**2 - 9800*D1*Dd*f**3*s + 250*D1*Dd*f**3 - 67680*D1*Dd*f**2*fd*r*s + 19740*D1*Dd*f**2*fd*r - 18840*D1*Dd*f**2*fd*s**2 + 39190*D1*Dd*f**2*fd*s - 10030*D1*Dd*f**2*fd + 13728*D1*Dd*f**2*g2*r*s - 3432*D1*Dd*f**2*g2*r - 11616*D1*Dd*f**2*g2*s**2 - 1056*D1*Dd*f**2*g2*s - 2904*D1*Dd*f**2*g2 - 16896*D1*Dd*f**2*gd2*r*s + 2112*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 + 10956*D1*Dd*f**2*gd2*s - 2112*D1*Dd*f**2*gd2 - 33792*D1*Dd*f*fd*g2*r*s + 12672*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 1848*D1*Dd*f*fd*g2*s - 2508*D1*Dd*f*fd*g2 + 5040*D1*Ddd*f**4*r*s - 1260*D1*Ddd*f**4*r + 3640*D1*Ddd*f**4*s**2 - 4340*D1*Ddd*f**4*s + 910*D1*Ddd*f**4 - 11280*D1*Ddd*f**3*r*s + 2820*D1*Ddd*f**3*r - 3140*D1*Ddd*f**3*s**2 + 7210*D1*Ddd*f**3*s - 785*D1*Ddd*f**3 - 8448*D1*Ddd*f**2*g2*r*s + 2112*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 + 2508*D1*Ddd*f**2*g2*s + 858*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(5*f**3*(51*s**2 + s*(191*r - 275) + 70) + f**2*(165*C*(9*s**2 + s*(4*r - 10) + 5) + 66*K*s*(-13*r + 11*s + 13) - 140*fd*(4*r*(6*s - 1) + 9*s**2 - 22*s + 3) + 990*r*s - 594*s**2 - 825) + 33*f*(fd*(-90*C*s**2 + 80*C*s + K*(16*r*(4*s - 1) - 26*s**2 - 19*s + 16) - r*(10*C + 21)*(4*s - 1) + 6*s**2 + 24*s - 31) - 6*g2*(9*s**2 + s*(4*r - 10) + 5) - 6*gd2*s*(-4*r - 9*s + 7)) + 198*fd*g2*(r*(4*s - 2) + s*(9*s - 9))) + Dd*f*(-70*f**2*(8*r*(8*s - 1) + 24*s**2 - 66*s + 11) - 33*f*(5*C*(2*r*(8*s - 1) + 36*s**2 - 33*s + 5) + K*(-128*r*s + 16*r + 52*s**2 + 83*s - 16) + 168*r*s - 21*r - 12*s**2 - 63*s + 6) + 198*g2*(2*r*(8*s - 1) + 36*s**2 - 33*s + 5))) + 15120*Dd**2*f**4*r*s - 3780*Dd**2*f**4*r + 10920*Dd**2*f**4*s**2 - 13020*Dd**2*f**4*s + 2520*Dd**2*f**4 - 33840*Dd**2*f**3*r*s + 8460*Dd**2*f**3*r - 9420*Dd**2*f**3*s**2 + 21630*Dd**2*f**3*s - 5640*Dd**2*f**3 - 25344*Dd**2*f**2*g2*r*s + 6336*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 + 7524*Dd**2*f**2*g2*s - 4224*Dd**2*f**2*g2 + 99*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(4*r*(s - 1) + 9*s**2 - 8*s + 4) + D1*(2*Dd*(f*(16*r*s - 4*r + 36*s**2 - 26*s + 9) + fd*(-16*r*s + 10*r - 36*s**2 + 29*s - 8)) + Ddd*f*(r*(4 - 16*s) - 36*s**2 + 26*s - 9)) - 2*Dd**2*f*(6*r*(4*s - 1) + 54*s**2 - 39*s + 4)) + b1*(2640*C*D1**2*f*fd*r*s - 1320*C*D1**2*f*fd*r + 5940*C*D1**2*f*fd*s**2 - 3960*C*D1**2*f*fd*s + 1320*C*D1**2*f*fd - 1320*C*D1**2*f*fdd*r*s + 660*C*D1**2*f*fdd*r - 2970*C*D1**2*f*fdd*s**2 + 1980*C*D1**2*f*fdd*s - 660*C*D1**2*f*fdd - 1320*C*D1**2*fd**2*r*s + 660*C*D1**2*fd**2*r - 2970*C*D1**2*fd**2*s**2 + 1980*C*D1**2*fd**2*s - 660*C*D1**2*fd**2 + 5280*C*D1*Dd*f**2*r*s - 1320*C*D1*Dd*f**2*r + 11880*C*D1*Dd*f**2*s**2 - 8580*C*D1*Dd*f**2*s + 2970*C*D1*Dd*f**2 - 10560*C*D1*Dd*f*fd*r*s + 3960*C*D1*Dd*f*fd*r - 23760*C*D1*Dd*f*fd*s**2 + 16500*C*D1*Dd*f*fd*s - 3300*C*D1*Dd*f*fd - 2640*C*D1*Ddd*f**2*r*s + 660*C*D1*Ddd*f**2*r - 5940*C*D1*Ddd*f**2*s**2 + 4290*C*D1*Ddd*f**2*s - 1485*C*D1*Ddd*f**2 - 7920*C*Dd**2*f**2*r*s + 1980*C*Dd**2*f**2*r - 17820*C*Dd**2*f**2*s**2 + 12870*C*Dd**2*f**2*s - 1320*C*Dd**2*f**2 - 3432*D1**2*K*f*fd*r*s + 1716*D1**2*K*f*fd*r + 2904*D1**2*K*f*fd*s**2 - 2904*D1**2*K*f*fd*s + 1452*D1**2*K*f*fd + 2112*D1**2*K*f*fdd*r*s - 1056*D1**2*K*f*fdd*r - 858*D1**2*K*f*fdd*s**2 + 858*D1**2*K*f*fdd*s - 429*D1**2*K*f*fdd + 2112*D1**2*K*fd**2*r*s - 1056*D1**2*K*fd**2*r - 858*D1**2*K*fd**2*s**2 + 858*D1**2*K*fd**2*s - 99*D1**2*bdd1*f*(K - 1)*(8*r*s + 18*s**2 - 14*s + 5) + 5730*D1**2*f**2*fd*r*s - 1910*D1**2*f**2*fd*r + 1530*D1**2*f**2*fd*s**2 - 2090*D1**2*f**2*fd*s - 190*D1**2*f**2*fd - 3360*D1**2*f**2*fdd*r*s + 1120*D1**2*f**2*fdd*r - 1260*D1**2*f**2*fdd*s**2 + 1540*D1**2*f**2*fdd*s - 70*D1**2*f**2*fdd - 6720*D1**2*f*fd**2*r*s + 2240*D1**2*f*fd**2*r - 2520*D1**2*f*fd**2*s**2 + 3080*D1**2*f*fd**2*s - 1400*D1**2*f*fd**2 + 3960*D1**2*f*fd*r*s - 1980*D1**2*f*fd*r - 2376*D1**2*f*fd*s**2 + 396*D1**2*f*fd*s + 462*D1**2*f*fd - 2772*D1**2*f*fdd*r*s + 1386*D1**2*f*fdd*r + 198*D1**2*f*fdd*s**2 + 792*D1**2*f*fdd*s - 726*D1**2*f*fdd - 1584*D1**2*f*gd2*r*s - 3564*D1**2*f*gd2*s**2 + 1584*D1**2*f*gd2*s + 792*D1**2*f*gdd2*r*s + 1782*D1**2*f*gdd2*s**2 - 792*D1**2*f*gdd2*s - 2772*D1**2*fd**2*r*s + 1386*D1**2*fd**2*r + 198*D1**2*fd**2*s**2 + 792*D1**2*fd**2*s + 660*D1**2*fd**2 - 1584*D1**2*fd*g2*r*s + 1584*D1**2*fd*g2*r - 3564*D1**2*fd*g2*s**2 + 3168*D1**2*fd*g2*s - 1584*D1**2*fd*g2 + 1584*D1**2*fd*gd2*r*s - 792*D1**2*fd*gd2*r + 3564*D1**2*fd*gd2*s**2 - 2376*D1**2*fd*gd2*s + 792*D1**2*fd*gd2 + 792*D1**2*fdd*g2*r*s - 792*D1**2*fdd*g2*r + 1782*D1**2*fdd*g2*s**2 - 1584*D1**2*fdd*g2*s + 792*D1**2*fdd*g2 - 6864*D1*Dd*K*f**2*r*s + 1716*D1*Dd*K*f**2*r + 5808*D1*Dd*K*f**2*s**2 + 528*D1*Dd*K*f**2*s + 1452*D1*Dd*K*f**2 + 16896*D1*Dd*K*f*fd*r*s - 6336*D1*Dd*K*f*fd*r - 6864*D1*Dd*K*f*fd*s**2 + 924*D1*Dd*K*f*fd*s + 1254*D1*Dd*K*f*fd + 7640*D1*Dd*f**3*r*s - 1910*D1*Dd*f**3*r + 2040*D1*Dd*f**3*s**2 - 4840*D1*Dd*f**3*s + 510*D1*Dd*f**3 - 26880*D1*Dd*f**2*fd*r*s + 7840*D1*Dd*f**2*fd*r - 10080*D1*Dd*f**2*fd*s**2 + 15400*D1*Dd*f**2*fd*s - 3780*D1*Dd*f**2*fd + 7920*D1*Dd*f**2*r*s - 1980*D1*Dd*f**2*r - 4752*D1*Dd*f**2*s**2 - 1584*D1*Dd*f**2*s - 1188*D1*Dd*f**2 - 22176*D1*Dd*f*fd*r*s + 8316*D1*Dd*f*fd*r + 1584*D1*Dd*f*fd*s**2 + 8316*D1*Dd*f*fd*s - 3564*D1*Dd*f*fd - 6336*D1*Dd*f*g2*r*s + 1584*D1*Dd*f*g2*r - 14256*D1*Dd*f*g2*s**2 + 10296*D1*Dd*f*g2*s - 3564*D1*Dd*f*g2 + 6336*D1*Dd*f*gd2*r*s - 792*D1*Dd*f*gd2*r + 14256*D1*Dd*f*gd2*s**2 - 8316*D1*Dd*f*gd2*s + 792*D1*Dd*f*gd2 + 6336*D1*Dd*fd*g2*r*s - 3960*D1*Dd*fd*g2*r + 14256*D1*Dd*fd*g2*s**2 - 11484*D1*Dd*fd*g2*s + 3168*D1*Dd*fd*g2 + 4224*D1*Ddd*K*f**2*r*s - 1056*D1*Ddd*K*f**2*r - 1716*D1*Ddd*K*f**2*s**2 - 1254*D1*Ddd*K*f**2*s - 429*D1*Ddd*K*f**2 - 4480*D1*Ddd*f**3*r*s + 1120*D1*Ddd*f**3*r - 1680*D1*Ddd*f**3*s**2 + 3080*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 5544*D1*Ddd*f**2*r*s + 1386*D1*Ddd*f**2*r + 396*D1*Ddd*f**2*s**2 + 2574*D1*Ddd*f**2*s + 99*D1*Ddd*f**2 + 3168*D1*Ddd*f*g2*r*s - 792*D1*Ddd*f*g2*r + 7128*D1*Ddd*f*g2*s**2 - 5148*D1*Ddd*f*g2*s + 1782*D1*Ddd*f*g2 + 198*D1*bd1*(K - 1)*(D1*(f*(8*r*s + 18*s**2 - 14*s + 5) + fd*(-8*r*s + 4*r - 18*s**2 + 15*s - 2)) + Dd*f*(r*(4 - 32*s) - 72*s**2 + 54*s - 7)) + 12672*Dd**2*K*f**2*r*s - 3168*Dd**2*K*f**2*r - 5148*Dd**2*K*f**2*s**2 - 3762*Dd**2*K*f**2*s + 2112*Dd**2*K*f**2 - 13440*Dd**2*f**3*r*s + 3360*Dd**2*f**3*r - 5040*Dd**2*f**3*s**2 + 9240*Dd**2*f**3*s - 2240*Dd**2*f**3 - 16632*Dd**2*f**2*r*s + 4158*Dd**2*f**2*r + 1188*Dd**2*f**2*s**2 + 7722*Dd**2*f**2*s - 2772*Dd**2*f**2 + 9504*Dd**2*f*g2*r*s - 2376*Dd**2*f*g2*r + 21384*Dd**2*f*g2*s**2 - 15444*Dd**2*f*g2*s + 1584*Dd**2*f*g2))/(693*d**2*k3**4) + 2*D1**2*Pk3*Pkd2*ct**6*k1**2*(D1**2*(396*bd1*fd*g2*s*(s - 1) + f**3*s**2*(420*bd1 - 210*bdd1) - 5*f**2*(C*s**2*(-66*bd1 + 33*bdd1) + 28*fd*(s**2*(9*bd1 - 6) + s*(4 - 3*bd1) - 2) + 28*fdd*(3*s**2 - 2*s + 1)) - 2*f*s*(99*bd1**2*s*(K - 1) + 33*bd1*(5*C*fd*(2*s - 1) + s*(6*g2 - 6*gd2)) - 99*bdd1*g2*s + 140*fd**2*(3*s - 2))) - 2*D1*f*(Dd*(198*bd1*g2*s*(1 - 4*s) + 70*f**2*(s**2*(12*bd1 - 8) + s*(4 - 3*bd1) - 2) + 5*f*(4*s - 1)*(33*C*bd1*s + 28*fd*(3*s - 1))) + 70*Ddd*f**2*(4*s**2 - 2*s + 1)) + 840*Dd**2*f**3*s*(1 - 2*s) + 99*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(55*C*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)) + 2*D1**2*(35*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*s*(-70*fd**2*(3*s - 2) + s*(-33*K*bdd1 + 66*bd1*(K - 1) + 33*bdd1 - 66*gd2 + 33*gdd2)) + (33 - 33*s)*(2*fd*g2*(s - 1) - 2*fd*s*(-K*bd1 + bd1 + gd2) - fdd*g2*(s - 1))) + 2*D1*(2*Dd*(35*f**3*(4*s**2 - 2*s + 1) - 35*f**2*fd*(12*s**2 - 7*s + 1) - 33*f*g2*(4*s**2 - 2*s + 1) + 33*f*s*(4*s - 1)*(-K*bd1 + bd1 + gd2) + 33*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(35*f**2 - 33*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f*s*(35*f**2 - 33*g2)*(2*s - 1)))/(77*d**2*k2*k3**2) + 40*D1**2*Pk3*Pkd2*ct**6*k2**5*(D1**2*(f**2*(fd*(112*C - 56)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(56*C - 28)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(56*C - 28)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 33*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) + 33*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 33*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(112*C - 56)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(33*K*(b1*r*(8*s - 2) + 2*b1*(1 - 2*s)**2 + bd1*(-8*r*s + r - 8*s**2 + 8*s - 1)) + fd*(28 - 56*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 132*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 66*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 66*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(56*C*f + 33*K*b1 - 28*f - 66*g2)) - Dd**2*f**2*(56*C*f + 33*K*b1 - 28*f - 66*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(693*d**2*k3**6) + 5*D1**2*Pk3*Pkd2*ct**6*k2**3*(-3168*C*D1**2*f**2*fd*r*s + 1056*C*D1**2*f**2*fd*r - 1008*C*D1**2*f**2*fd*s**2 + 1728*C*D1**2*f**2*fd*s - 336*C*D1**2*f**2*fd + 1584*C*D1**2*f**2*fdd*r*s - 528*C*D1**2*f**2*fdd*r + 504*C*D1**2*f**2*fdd*s**2 - 864*C*D1**2*f**2*fdd*s + 168*C*D1**2*f**2*fdd + 3168*C*D1**2*f*fd**2*r*s - 1056*C*D1**2*f*fd**2*r + 1008*C*D1**2*f*fd**2*s**2 - 1728*C*D1**2*f*fd**2*s + 528*C*D1**2*f*fd**2 - 4224*C*D1*Dd*f**3*r*s + 1056*C*D1*Dd*f**3*r - 1344*C*D1*Dd*f**3*s**2 + 2784*C*D1*Dd*f**3*s - 336*C*D1*Dd*f**3 + 12672*C*D1*Dd*f**2*fd*r*s - 3696*C*D1*Dd*f**2*fd*r + 4032*C*D1*Dd*f**2*fd*s**2 - 7632*C*D1*Dd*f**2*fd*s + 1920*C*D1*Dd*f**2*fd + 2112*C*D1*Ddd*f**3*r*s - 528*C*D1*Ddd*f**3*r + 672*C*D1*Ddd*f**3*s**2 - 1392*C*D1*Ddd*f**3*s + 168*C*D1*Ddd*f**3 + 6336*C*Dd**2*f**3*r*s - 1584*C*Dd**2*f**3*r + 2016*C*Dd**2*f**3*s**2 - 4176*C*Dd**2*f**3*s + 1056*C*Dd**2*f**3 - 1056*D1**2*K*b1*f*fd*r*s + 528*D1**2*K*b1*f*fd*r - 396*D1**2*K*b1*f*fd*s**2 + 396*D1**2*K*b1*f*fd*s - 198*D1**2*K*b1*f*fd + 528*D1**2*K*b1*f*fdd*r*s - 264*D1**2*K*b1*f*fdd*r + 198*D1**2*K*b1*f*fdd*s**2 - 198*D1**2*K*b1*f*fdd*s + 99*D1**2*K*b1*f*fdd + 528*D1**2*K*b1*fd**2*r*s - 264*D1**2*K*b1*fd**2*r + 198*D1**2*K*b1*fd**2*s**2 - 198*D1**2*K*b1*fd**2*s + 264*D1**2*K*bdd1*f**2*r*s + 99*D1**2*K*bdd1*f**2*s**2 - 264*D1**2*K*bdd1*f**2*s + 198*D1**2*b1*f**2*fd*r*s - 66*D1**2*b1*f**2*fd*r - 66*D1**2*b1*f**2*fd*s - 198*D1**2*b1*f**2*fdd*r*s + 66*D1**2*b1*f**2*fdd*r + 66*D1**2*b1*f**2*fdd*s - 396*D1**2*b1*f*fd**2*r*s + 132*D1**2*b1*f*fd**2*r + 132*D1**2*b1*f*fd**2*s - 66*D1**2*b1*f*fd**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 264*D1**2*bd2*f**2*r*s - 264*D1**2*bd2*f**2*s**2 + 264*D1**2*bd2*f**2*s + 528*D1**2*bd2*f*fd*r*s - 132*D1**2*bd2*f*fd*r + 528*D1**2*bd2*f*fd*s**2 - 528*D1**2*bd2*f*fd*s + 132*D1**2*bd2*f*fd - 66*D1**2*bdd1*f**3*r*s + 66*D1**2*bdd1*f**3*s - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*s + 132*D1**2*bdd2*f**2*r*s + 132*D1**2*bdd2*f**2*s**2 - 132*D1**2*bdd2*f**2*s + 2040*D1**2*f**2*fd*r*s - 680*D1**2*f**2*fd*r + 504*D1**2*f**2*fd*s**2 - 1016*D1**2*f**2*fd*s + 168*D1**2*f**2*fd - 1020*D1**2*f**2*fdd*r*s + 340*D1**2*f**2*fdd*r - 252*D1**2*f**2*fdd*s**2 + 508*D1**2*f**2*fdd*s - 84*D1**2*f**2*fdd + 1056*D1**2*f**2*gd2*r*s + 396*D1**2*f**2*gd2*s**2 - 1056*D1**2*f**2*gd2*s - 528*D1**2*f**2*gdd2*r*s - 198*D1**2*f**2*gdd2*s**2 + 528*D1**2*f**2*gdd2*s - 2040*D1**2*f*fd**2*r*s + 680*D1**2*f*fd**2*r - 504*D1**2*f*fd**2*s**2 + 1016*D1**2*f*fd**2*s - 340*D1**2*f*fd**2 + 2112*D1**2*f*fd*g2*r*s - 1056*D1**2*f*fd*g2*r + 792*D1**2*f*fd*g2*s**2 - 792*D1**2*f*fd*g2*s + 396*D1**2*f*fd*g2 - 2112*D1**2*f*fd*gd2*r*s + 528*D1**2*f*fd*gd2*r - 792*D1**2*f*fd*gd2*s**2 + 1452*D1**2*f*fd*gd2*s - 528*D1**2*f*fd*gd2 - 1056*D1**2*f*fdd*g2*r*s + 528*D1**2*f*fdd*g2*r - 396*D1**2*f*fdd*g2*s**2 + 396*D1**2*f*fdd*g2*s - 198*D1**2*f*fdd*g2 - 1056*D1**2*fd**2*g2*r*s + 528*D1**2*fd**2*g2*r - 396*D1**2*fd**2*g2*s**2 + 396*D1**2*fd**2*g2*s - 2112*D1*Dd*K*b1*f**2*r*s + 528*D1*Dd*K*b1*f**2*r - 792*D1*Dd*K*b1*f**2*s**2 + 1452*D1*Dd*K*b1*f**2*s - 198*D1*Dd*K*b1*f**2 + 4224*D1*Dd*K*b1*f*fd*r*s - 1584*D1*Dd*K*b1*f*fd*r + 1584*D1*Dd*K*b1*f*fd*s**2 - 2244*D1*Dd*K*b1*f*fd*s + 726*D1*Dd*K*b1*f*fd + 264*D1*Dd*b1*f**3*r*s - 66*D1*Dd*b1*f**3*r - 132*D1*Dd*b1*f**3*s - 1584*D1*Dd*b1*f**2*fd*r*s + 462*D1*Dd*b1*f**2*fd*r + 660*D1*Dd*b1*f**2*fd*s - 198*D1*Dd*b1*f**2*fd + 528*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s - 1056*D1*Dd*b1*f*fd*r*s + 396*D1*Dd*b1*f*fd*r + 264*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 1056*D1*Dd*bd2*f**2*r*s - 132*D1*Dd*bd2*f**2*r + 1056*D1*Dd*bd2*f**2*s**2 - 1056*D1*Dd*bd2*f**2*s + 132*D1*Dd*bd2*f**2 + 2720*D1*Dd*f**3*r*s - 680*D1*Dd*f**3*r + 672*D1*Dd*f**3*s**2 - 1696*D1*Dd*f**3*s + 168*D1*Dd*f**3 - 8160*D1*Dd*f**2*fd*r*s + 2380*D1*Dd*f**2*fd*r - 2016*D1*Dd*f**2*fd*s**2 + 4576*D1*Dd*f**2*fd*s - 1188*D1*Dd*f**2*fd + 4224*D1*Dd*f**2*g2*r*s - 1056*D1*Dd*f**2*g2*r + 1584*D1*Dd*f**2*g2*s**2 - 2904*D1*Dd*f**2*g2*s + 396*D1*Dd*f**2*g2 - 4224*D1*Dd*f**2*gd2*r*s + 528*D1*Dd*f**2*gd2*r - 1584*D1*Dd*f**2*gd2*s**2 + 3564*D1*Dd*f**2*gd2*s - 528*D1*Dd*f**2*gd2 - 8448*D1*Dd*f*fd*g2*r*s + 3168*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s**2 + 4488*D1*Dd*f*fd*g2*s - 1452*D1*Dd*f*fd*g2 + 1056*D1*Ddd*K*b1*f**2*r*s - 264*D1*Ddd*K*b1*f**2*r + 396*D1*Ddd*K*b1*f**2*s**2 - 726*D1*Ddd*K*b1*f**2*s + 99*D1*Ddd*K*b1*f**2 - 264*D1*Ddd*b1*f**3*r*s + 66*D1*Ddd*b1*f**3*r + 132*D1*Ddd*b1*f**3*s - 264*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s - 1360*D1*Ddd*f**3*r*s + 340*D1*Ddd*f**3*r - 336*D1*Ddd*f**3*s**2 + 848*D1*Ddd*f**3*s - 84*D1*Ddd*f**3 - 2112*D1*Ddd*f**2*g2*r*s + 528*D1*Ddd*f**2*g2*r - 792*D1*Ddd*f**2*g2*s**2 + 1452*D1*Ddd*f**2*g2*s - 198*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(D1*(f*s*(K*(-8*r - 3*s + 8) + f*(r - 1) + 2*r - 2) + fd*(K*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + f*(-6*r*s + r + 4*s - 1) - 4*r*s + r + 2*s - 1)) + Dd*f*(K*(32*r*s - 4*r + 12*s**2 - 27*s + 4) + f*(-8*r*s + r + 6*s - 1) - 8*r*s + r + 6*s - 1)) + 3168*Dd**2*K*b1*f**2*r*s - 792*Dd**2*K*b1*f**2*r + 1188*Dd**2*K*b1*f**2*s**2 - 2178*Dd**2*K*b1*f**2*s + 528*Dd**2*K*b1*f**2 - 792*Dd**2*b1*f**3*r*s + 198*Dd**2*b1*f**3*r + 396*Dd**2*b1*f**3*s - 132*Dd**2*b1*f**3 - 792*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s - 132*Dd**2*b1*f**2 - 4080*Dd**2*f**3*r*s + 1020*Dd**2*f**3*r - 1008*Dd**2*f**3*s**2 + 2544*Dd**2*f**3*s - 680*Dd**2*f**3 - 6336*Dd**2*f**2*g2*r*s + 1584*Dd**2*f**2*g2*r - 2376*Dd**2*f**2*g2*s**2 + 4356*Dd**2*f**2*g2*s - 1056*Dd**2*f**2*g2 - 132*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**4) - 5*D1**2*Pk3*Pkd2*ct**6*k2*(1680*C*D1**2*f**2*fd*s**2 - 1120*C*D1**2*f**2*fd*s + 560*C*D1**2*f**2*fd - 840*C*D1**2*f**2*fdd*s**2 + 560*C*D1**2*f**2*fdd*s - 280*C*D1**2*f**2*fdd - 1680*C*D1**2*f*fd**2*s**2 + 1120*C*D1**2*f*fd**2*s + 2240*C*D1*Dd*f**3*s**2 - 1120*C*D1*Dd*f**3*s + 560*C*D1*Dd*f**3 - 6720*C*D1*Dd*f**2*fd*s**2 + 3920*C*D1*Dd*f**2*fd*s - 560*C*D1*Dd*f**2*fd - 1120*C*D1*Ddd*f**3*s**2 + 560*C*D1*Ddd*f**3*s - 280*C*D1*Ddd*f**3 - 3360*C*Dd**2*f**3*s**2 + 1680*C*Dd**2*f**3*s + 660*D1**2*K*b1*f*fd*s**2 - 660*D1**2*K*b1*f*fd*s + 330*D1**2*K*b1*f*fd - 330*D1**2*K*b1*f*fdd*s**2 + 330*D1**2*K*b1*f*fdd*s - 165*D1**2*K*b1*f*fdd - 330*D1**2*K*b1*fd**2*s**2 + 330*D1**2*K*b1*fd**2*s - 165*D1**2*K*bdd1*f**2*s**2 + 198*D1**2*b1*f**2*fd*r*s - 66*D1**2*b1*f**2*fd*r - 66*D1**2*b1*f**2*fd*s - 198*D1**2*b1*f**2*fdd*r*s + 66*D1**2*b1*f**2*fdd*r + 66*D1**2*b1*f**2*fdd*s - 396*D1**2*b1*f*fd**2*r*s + 132*D1**2*b1*f*fd**2*r + 132*D1**2*b1*f*fd**2*s - 66*D1**2*b1*f*fd**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r + 330*D1**2*bd2*f**2*s**2 - 660*D1**2*bd2*f*fd*s**2 + 330*D1**2*bd2*f*fd*s - 66*D1**2*bdd1*f**3*r*s + 66*D1**2*bdd1*f**3*s - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*s - 165*D1**2*bdd2*f**2*s**2 + 456*D1**2*f**2*fd*r*s - 152*D1**2*f**2*fd*r - 840*D1**2*f**2*fd*s**2 + 408*D1**2*f**2*fd*s - 280*D1**2*f**2*fd - 228*D1**2*f**2*fdd*r*s + 76*D1**2*f**2*fdd*r + 420*D1**2*f**2*fdd*s**2 - 204*D1**2*f**2*fdd*s + 140*D1**2*f**2*fdd - 660*D1**2*f**2*gd2*s**2 + 330*D1**2*f**2*gdd2*s**2 - 456*D1**2*f*fd**2*r*s + 152*D1**2*f*fd**2*r + 840*D1**2*f*fd**2*s**2 - 408*D1**2*f*fd**2*s - 76*D1**2*f*fd**2 - 1320*D1**2*f*fd*g2*s**2 + 1320*D1**2*f*fd*g2*s - 660*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*s**2 - 660*D1**2*f*fd*gd2*s + 660*D1**2*f*fdd*g2*s**2 - 660*D1**2*f*fdd*g2*s + 330*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*s**2 - 660*D1**2*fd**2*g2*s + 1320*D1*Dd*K*b1*f**2*s**2 - 660*D1*Dd*K*b1*f**2*s + 330*D1*Dd*K*b1*f**2 - 2640*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 330*D1*Dd*K*b1*f*fd + 264*D1*Dd*b1*f**3*r*s - 66*D1*Dd*b1*f**3*r - 132*D1*Dd*b1*f**3*s - 1584*D1*Dd*b1*f**2*fd*r*s + 462*D1*Dd*b1*f**2*fd*r + 660*D1*Dd*b1*f**2*fd*s - 198*D1*Dd*b1*f**2*fd + 528*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s - 1056*D1*Dd*b1*f*fd*r*s + 396*D1*Dd*b1*f*fd*r + 264*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd - 1320*D1*Dd*bd2*f**2*s**2 + 330*D1*Dd*bd2*f**2*s + 608*D1*Dd*f**3*r*s - 152*D1*Dd*f**3*r - 1120*D1*Dd*f**3*s**2 + 256*D1*Dd*f**3*s - 280*D1*Dd*f**3 - 1824*D1*Dd*f**2*fd*r*s + 532*D1*Dd*f**2*fd*r + 3360*D1*Dd*f**2*fd*s**2 - 1200*D1*Dd*f**2*fd*s + 52*D1*Dd*f**2*fd - 2640*D1*Dd*f**2*g2*s**2 + 1320*D1*Dd*f**2*g2*s - 660*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*s**2 - 660*D1*Dd*f**2*gd2*s + 5280*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 660*D1*Dd*f*fd*g2 - 660*D1*Ddd*K*b1*f**2*s**2 + 330*D1*Ddd*K*b1*f**2*s - 165*D1*Ddd*K*b1*f**2 - 264*D1*Ddd*b1*f**3*r*s + 66*D1*Ddd*b1*f**3*r + 132*D1*Ddd*b1*f**3*s - 264*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s - 304*D1*Ddd*f**3*r*s + 76*D1*Ddd*f**3*r + 560*D1*Ddd*f**3*s**2 - 128*D1*Ddd*f**3*s + 140*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*g2*s**2 - 660*D1*Ddd*f**2*g2*s + 330*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(D1*(f*s*(5*K*s + f*(r - 1) + 2*r - 2) + fd*(f*(-6*r*s + r + 4*s - 1) - 4*r*s + r - (2*s - 1)*(5*K*s - 1))) - Dd*f*(20*K*s**2 - 5*K*s + f*r*(8*s - 1) - 6*f*s + f + r*(8*s - 1) - 6*s + 1)) - 1980*Dd**2*K*b1*f**2*s**2 + 990*Dd**2*K*b1*f**2*s - 792*Dd**2*b1*f**3*r*s + 198*Dd**2*b1*f**3*r + 396*Dd**2*b1*f**3*s - 132*Dd**2*b1*f**3 - 792*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s - 132*Dd**2*b1*f**2 - 912*Dd**2*f**3*r*s + 228*Dd**2*f**3*r + 1680*Dd**2*f**3*s**2 - 384*Dd**2*f**3*s - 152*Dd**2*f**3 + 3960*Dd**2*f**2*g2*s**2 - 1980*Dd**2*f**2*g2*s + 165*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(693*d**2*k3**2) + 225*D1**2*Pk3*Pkd2*ct**5*f**2*k1**5*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(143*d**2*k2**2*k3**4) + D1**2*Pk3*Pkd2*ct**5*f*k2**4*(200*C - 100)*(D1*Dd*f*(2*f*(-4*r*s + r + 2*s) + fd*(24*r*s - 7*r - 10*s + 3)) + D1*(D1*(2*f*fd*(-3*r*s + r + s) + f*fdd*(3*r*s - r - s) + fd**2*(6*r*s - 2*r - 2*s + 1)) + Ddd*f**2*(r*(4*s - 1) - 2*s)) + Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2))/(693*d**2*k1*k3**4) + D1**2*Pk3*Pkd2*ct**5*f*k2**2*(200*C - 100)*(D1*Dd*f*(2*f*(4*r*s - r - 2*s) + fd*(-24*r*s + 7*r + 10*s - 3)) + D1*(D1*(2*f*fd*(3*r*s - r - s) + f*fdd*(-3*r*s + r + s) + fd**2*(-6*r*s + 2*r + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + 2*s)) + Dd**2*f**2*(r*(3 - 12*s) + 6*s - 2))/(693*d**2*k1*k3**2) + 8*D1**2*Pk3*Pkd2*ct**5*k1**5*(8970*C*D1**2*f**2*fd*r*s - 2990*C*D1**2*f**2*fd*r + 8970*C*D1**2*f**2*fd*s**2 - 8970*C*D1**2*f**2*fd*s + 2990*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r*s + 3640*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 10920*C*D1**2*f**2*fdd*s - 3640*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r*s + 7280*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 21840*C*D1**2*f*fd**2*s - 3640*C*D1**2*f*fd**2 + 11960*C*D1*Dd*f**3*r*s - 2990*C*D1*Dd*f**3*r + 11960*C*D1*Dd*f**3*s**2 - 11960*C*D1*Dd*f**3*s + 2990*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r*s + 25480*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 87360*C*D1*Dd*f**2*fd*s - 18200*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r*s + 3640*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 14560*C*D1*Ddd*f**3*s - 3640*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r*s + 10920*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 43680*C*Dd**2*f**3*s - 7280*C*Dd**2*f**3 - 2145*D1**2*K*bdd1*f**2*r*s - 2145*D1**2*K*bdd1*f**2*s**2 + 2145*D1**2*K*bdd1*f**2*s + 2145*D1**2*bdd1*f**2*r*s + 2145*D1**2*bdd1*f**2*s**2 - 2145*D1**2*bdd1*f**2*s + 28560*D1**2*f**3*fd*r*s - 7140*D1**2*f**3*fd*r + 28560*D1**2*f**3*fd*s**2 - 28560*D1**2*f**3*fd*s + 7140*D1**2*f**3*fd - 25200*D1**2*f**3*fdd*r*s + 6300*D1**2*f**3*fdd*r - 25200*D1**2*f**3*fdd*s**2 + 25200*D1**2*f**3*fdd*s - 6300*D1**2*f**3*fdd - 75600*D1**2*f**2*fd**2*r*s + 18900*D1**2*f**2*fd**2*r - 75600*D1**2*f**2*fd**2*s**2 + 75600*D1**2*f**2*fd**2*s - 12600*D1**2*f**2*fd**2 - 8970*D1**2*f**2*fd*r*s + 2990*D1**2*f**2*fd*r - 8970*D1**2*f**2*fd*s**2 + 8970*D1**2*f**2*fd*s - 2990*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r*s - 3640*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 10920*D1**2*f**2*fdd*s + 3640*D1**2*f**2*fdd - 3432*D1**2*f**2*gd2*r*s - 3432*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s + 4290*D1**2*f**2*gdd2*r*s + 4290*D1**2*f**2*gdd2*s**2 - 4290*D1**2*f**2*gdd2*s + 21840*D1**2*f*fd**2*r*s - 7280*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 21840*D1**2*f*fd**2*s + 3640*D1**2*f*fd**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 6864*D1**2*f*fd*g2*s**2 + 6864*D1**2*f*fd*g2*s - 3432*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r*s - 4290*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 17160*D1**2*f*fd*gd2*s + 4290*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r*s - 4290*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r*s - 4290*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 28560*D1*Dd*f**4*r*s - 7140*D1*Dd*f**4*r + 28560*D1*Dd*f**4*s**2 - 28560*D1*Dd*f**4*s + 7140*D1*Dd*f**4 - 201600*D1*Dd*f**3*fd*r*s + 50400*D1*Dd*f**3*fd*r - 201600*D1*Dd*f**3*fd*s**2 + 201600*D1*Dd*f**3*fd*s - 37800*D1*Dd*f**3*fd - 11960*D1*Dd*f**3*r*s + 2990*D1*Dd*f**3*r - 11960*D1*Dd*f**3*s**2 + 11960*D1*Dd*f**3*s - 2990*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r*s - 25480*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 87360*D1*Dd*f**2*fd*s + 18200*D1*Dd*f**2*fd - 13728*D1*Dd*f**2*g2*r*s + 3432*D1*Dd*f**2*g2*r - 13728*D1*Dd*f**2*g2*s**2 + 13728*D1*Dd*f**2*g2*s - 3432*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r*s - 4290*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 34320*D1*Dd*f**2*gd2*s + 4290*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r*s - 25740*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 68640*D1*Dd*f*fd*g2*s + 17160*D1*Dd*f*fd*g2 - 25200*D1*Ddd*f**4*r*s + 6300*D1*Ddd*f**4*r - 25200*D1*Ddd*f**4*s**2 + 25200*D1*Ddd*f**4*s - 6300*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r*s - 3640*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 14560*D1*Ddd*f**3*s + 3640*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r*s - 4290*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 17160*D1*Ddd*f**2*g2*s + 4290*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(4*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 75600*Dd**2*f**4*r*s + 18900*Dd**2*f**4*r - 75600*Dd**2*f**4*s**2 + 75600*Dd**2*f**4*s - 12600*Dd**2*f**4 + 43680*Dd**2*f**3*r*s - 10920*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 43680*Dd**2*f**3*s + 7280*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r*s - 12870*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 51480*Dd**2*f**2*g2*s + 8580*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(4*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 5*fd*(8*r*s - 3*r + 8*s**2 - 8*s + 2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**5*k1**3*k2**2*st**2*(33852*C*D1**2*f**2*fd*r*s - 11284*C*D1**2*f**2*fd*r + 33852*C*D1**2*f**2*fd*s**2 - 33852*C*D1**2*f**2*fd*s + 11284*C*D1**2*f**2*fd - 19500*C*D1**2*f**2*fdd*r*s + 6500*C*D1**2*f**2*fdd*r - 19500*C*D1**2*f**2*fdd*s**2 + 19500*C*D1**2*f**2*fdd*s - 6500*C*D1**2*f**2*fdd - 39000*C*D1**2*f*fd**2*r*s + 13000*C*D1**2*f*fd**2*r - 39000*C*D1**2*f*fd**2*s**2 + 39000*C*D1**2*f*fd**2*s - 6500*C*D1**2*f*fd**2 + 45136*C*D1*Dd*f**3*r*s - 11284*C*D1*Dd*f**3*r + 45136*C*D1*Dd*f**3*s**2 - 45136*C*D1*Dd*f**3*s + 11284*C*D1*Dd*f**3 - 156000*C*D1*Dd*f**2*fd*r*s + 45500*C*D1*Dd*f**2*fd*r - 156000*C*D1*Dd*f**2*fd*s**2 + 156000*C*D1*Dd*f**2*fd*s - 32500*C*D1*Dd*f**2*fd - 26000*C*D1*Ddd*f**3*r*s + 6500*C*D1*Ddd*f**3*r - 26000*C*D1*Ddd*f**3*s**2 + 26000*C*D1*Ddd*f**3*s - 6500*C*D1*Ddd*f**3 - 78000*C*Dd**2*f**3*r*s + 19500*C*Dd**2*f**3*r - 78000*C*Dd**2*f**3*s**2 + 78000*C*Dd**2*f**3*s - 13000*C*Dd**2*f**3 - 4290*D1**2*K*bdd1*f**2*r*s - 4290*D1**2*K*bdd1*f**2*s**2 + 4290*D1**2*K*bdd1*f**2*s + 4290*D1**2*bdd1*f**2*r*s + 4290*D1**2*bdd1*f**2*s**2 - 4290*D1**2*bdd1*f**2*s + 48380*D1**2*f**3*fd*r*s - 12095*D1**2*f**3*fd*r + 48380*D1**2*f**3*fd*s**2 - 48380*D1**2*f**3*fd*s + 12095*D1**2*f**3*fd - 27440*D1**2*f**3*fdd*r*s + 6860*D1**2*f**3*fdd*r - 27440*D1**2*f**3*fdd*s**2 + 27440*D1**2*f**3*fdd*s - 6860*D1**2*f**3*fdd - 82320*D1**2*f**2*fd**2*r*s + 20580*D1**2*f**2*fd**2*r - 82320*D1**2*f**2*fd**2*s**2 + 82320*D1**2*f**2*fd**2*s - 13720*D1**2*f**2*fd**2 - 33852*D1**2*f**2*fd*r*s + 11284*D1**2*f**2*fd*r - 33852*D1**2*f**2*fd*s**2 + 33852*D1**2*f**2*fd*s - 11284*D1**2*f**2*fd + 19500*D1**2*f**2*fdd*r*s - 6500*D1**2*f**2*fdd*r + 19500*D1**2*f**2*fdd*s**2 - 19500*D1**2*f**2*fdd*s + 6500*D1**2*f**2*fdd - 15444*D1**2*f**2*gd2*r*s - 15444*D1**2*f**2*gd2*s**2 + 15444*D1**2*f**2*gd2*s + 8580*D1**2*f**2*gdd2*r*s + 8580*D1**2*f**2*gdd2*s**2 - 8580*D1**2*f**2*gdd2*s + 39000*D1**2*f*fd**2*r*s - 13000*D1**2*f*fd**2*r + 39000*D1**2*f*fd**2*s**2 - 39000*D1**2*f*fd**2*s + 6500*D1**2*f*fd**2 - 30888*D1**2*f*fd*g2*r*s + 15444*D1**2*f*fd*g2*r - 30888*D1**2*f*fd*g2*s**2 + 30888*D1**2*f*fd*g2*s - 15444*D1**2*f*fd*g2 + 34320*D1**2*f*fd*gd2*r*s - 8580*D1**2*f*fd*gd2*r + 34320*D1**2*f*fd*gd2*s**2 - 34320*D1**2*f*fd*gd2*s + 8580*D1**2*f*fd*gd2 + 17160*D1**2*f*fdd*g2*r*s - 8580*D1**2*f*fdd*g2*r + 17160*D1**2*f*fdd*g2*s**2 - 17160*D1**2*f*fdd*g2*s + 8580*D1**2*f*fdd*g2 + 17160*D1**2*fd**2*g2*r*s - 8580*D1**2*fd**2*g2*r + 17160*D1**2*fd**2*g2*s**2 - 17160*D1**2*fd**2*g2*s + 48380*D1*Dd*f**4*r*s - 12095*D1*Dd*f**4*r + 48380*D1*Dd*f**4*s**2 - 48380*D1*Dd*f**4*s + 12095*D1*Dd*f**4 - 219520*D1*Dd*f**3*fd*r*s + 54880*D1*Dd*f**3*fd*r - 219520*D1*Dd*f**3*fd*s**2 + 219520*D1*Dd*f**3*fd*s - 41160*D1*Dd*f**3*fd - 45136*D1*Dd*f**3*r*s + 11284*D1*Dd*f**3*r - 45136*D1*Dd*f**3*s**2 + 45136*D1*Dd*f**3*s - 11284*D1*Dd*f**3 + 156000*D1*Dd*f**2*fd*r*s - 45500*D1*Dd*f**2*fd*r + 156000*D1*Dd*f**2*fd*s**2 - 156000*D1*Dd*f**2*fd*s + 32500*D1*Dd*f**2*fd - 61776*D1*Dd*f**2*g2*r*s + 15444*D1*Dd*f**2*g2*r - 61776*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 15444*D1*Dd*f**2*g2 + 68640*D1*Dd*f**2*gd2*r*s - 8580*D1*Dd*f**2*gd2*r + 68640*D1*Dd*f**2*gd2*s**2 - 68640*D1*Dd*f**2*gd2*s + 8580*D1*Dd*f**2*gd2 + 137280*D1*Dd*f*fd*g2*r*s - 51480*D1*Dd*f*fd*g2*r + 137280*D1*Dd*f*fd*g2*s**2 - 137280*D1*Dd*f*fd*g2*s + 34320*D1*Dd*f*fd*g2 - 27440*D1*Ddd*f**4*r*s + 6860*D1*Ddd*f**4*r - 27440*D1*Ddd*f**4*s**2 + 27440*D1*Ddd*f**4*s - 6860*D1*Ddd*f**4 + 26000*D1*Ddd*f**3*r*s - 6500*D1*Ddd*f**3*r + 26000*D1*Ddd*f**3*s**2 - 26000*D1*Ddd*f**3*s + 6500*D1*Ddd*f**3 + 34320*D1*Ddd*f**2*g2*r*s - 8580*D1*Ddd*f**2*g2*r + 34320*D1*Ddd*f**2*g2*s**2 - 34320*D1*Ddd*f**2*g2*s + 8580*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(D1*(9*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 82320*Dd**2*f**4*r*s + 20580*Dd**2*f**4*r - 82320*Dd**2*f**4*s**2 + 82320*Dd**2*f**4*s - 13720*Dd**2*f**4 + 78000*Dd**2*f**3*r*s - 19500*Dd**2*f**3*r + 78000*Dd**2*f**3*s**2 - 78000*Dd**2*f**3*s + 13000*Dd**2*f**3 + 102960*Dd**2*f**2*g2*r*s - 25740*Dd**2*f**2*g2*r + 102960*Dd**2*f**2*g2*s**2 - 102960*Dd**2*f**2*g2*s + 17160*Dd**2*f**2*g2 + 858*b1*(K - 1)*(D1**2*(f*(9*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(9*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**6) + 8*D1**2*Pk3*Pkd2*ct**5*k1**3*k2**2*(-990*C*D1**2*bdd1*f**2*r*s + 990*C*D1**2*bdd1*f**2*r - 990*C*D1**2*bdd1*f**2*s**2 + 1980*C*D1**2*bdd1*f**2*s - 990*C*D1**2*bdd1*f**2 + 4140*C*D1**2*f**2*fd*r*s - 1380*C*D1**2*f**2*fd*r + 4140*C*D1**2*f**2*fd*s**2 - 4140*C*D1**2*f**2*fd*s + 1380*C*D1**2*f**2*fd - 5040*C*D1**2*f**2*fdd*r*s + 1680*C*D1**2*f**2*fdd*r - 5040*C*D1**2*f**2*fdd*s**2 + 5040*C*D1**2*f**2*fdd*s - 1680*C*D1**2*f**2*fdd - 10080*C*D1**2*f*fd**2*r*s + 3360*C*D1**2*f*fd**2*r - 10080*C*D1**2*f*fd**2*s**2 + 10080*C*D1**2*f*fd**2*s - 1680*C*D1**2*f*fd**2 + 5520*C*D1*Dd*f**3*r*s - 1380*C*D1*Dd*f**3*r + 5520*C*D1*Dd*f**3*s**2 - 5520*C*D1*Dd*f**3*s + 1380*C*D1*Dd*f**3 - 40320*C*D1*Dd*f**2*fd*r*s + 11760*C*D1*Dd*f**2*fd*r - 40320*C*D1*Dd*f**2*fd*s**2 + 40320*C*D1*Dd*f**2*fd*s - 8400*C*D1*Dd*f**2*fd - 6720*C*D1*Ddd*f**3*r*s + 1680*C*D1*Ddd*f**3*r - 6720*C*D1*Ddd*f**3*s**2 + 6720*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 20160*C*Dd**2*f**3*r*s + 5040*C*Dd**2*f**3*r - 20160*C*Dd**2*f**3*s**2 + 20160*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 990*D1**2*K*bdd1*f**2*r*s - 990*D1**2*K*bdd1*f**2*s**2 + 990*D1**2*K*bdd1*f**2*s - 594*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 280*D1**2*bdd1*f**3*r*s + 560*D1**2*bdd1*f**3*r + 280*D1**2*bdd1*f**3*s**2 + 280*D1**2*bdd1*f**3*s - 560*D1**2*bdd1*f**3 + 1485*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*r + 1485*D1**2*bdd1*f**2*s**2 - 2475*D1**2*bdd1*f**2*s + 990*D1**2*bdd1*f**2 + 1188*D1**2*bdd1*f*g2*r*s - 1188*D1**2*bdd1*f*g2*r + 1188*D1**2*bdd1*f*g2*s**2 - 2376*D1**2*bdd1*f*g2*s + 1188*D1**2*bdd1*f*g2 - 1680*D1**2*f**3*fd*r*s + 420*D1**2*f**3*fd*r - 1680*D1**2*f**3*fd*s**2 + 1680*D1**2*f**3*fd*s - 420*D1**2*f**3*fd - 2610*D1**2*f**2*fd*r*s + 870*D1**2*f**2*fd*r - 2610*D1**2*f**2*fd*s**2 + 2610*D1**2*f**2*fd*s - 870*D1**2*f**2*fd + 3780*D1**2*f**2*fdd*r*s - 1260*D1**2*f**2*fdd*r + 3780*D1**2*f**2*fdd*s**2 - 3780*D1**2*f**2*fdd*s + 1260*D1**2*f**2*fdd - 1584*D1**2*f**2*gd2*r*s - 1584*D1**2*f**2*gd2*s**2 + 1584*D1**2*f**2*gd2*s + 1980*D1**2*f**2*gdd2*r*s + 1980*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 7560*D1**2*f*fd**2*r*s - 2520*D1**2*f*fd**2*r + 7560*D1**2*f*fd**2*s**2 - 7560*D1**2*f*fd**2*s + 1260*D1**2*f*fd**2 - 3168*D1**2*f*fd*g2*r*s + 1584*D1**2*f*fd*g2*r - 3168*D1**2*f*fd*g2*s**2 + 3168*D1**2*f*fd*g2*s - 1584*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s - 1680*D1*Dd*f**4*r*s + 420*D1*Dd*f**4*r - 1680*D1*Dd*f**4*s**2 + 1680*D1*Dd*f**4*s - 420*D1*Dd*f**4 - 3480*D1*Dd*f**3*r*s + 870*D1*Dd*f**3*r - 3480*D1*Dd*f**3*s**2 + 3480*D1*Dd*f**3*s - 870*D1*Dd*f**3 + 30240*D1*Dd*f**2*fd*r*s - 8820*D1*Dd*f**2*fd*r + 30240*D1*Dd*f**2*fd*s**2 - 30240*D1*Dd*f**2*fd*s + 6300*D1*Dd*f**2*fd - 6336*D1*Dd*f**2*g2*r*s + 1584*D1*Dd*f**2*g2*r - 6336*D1*Dd*f**2*g2*s**2 + 6336*D1*Dd*f**2*g2*s - 1584*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r*s - 1980*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 15840*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 31680*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 5040*D1*Ddd*f**3*r*s - 1260*D1*Ddd*f**3*r + 5040*D1*Ddd*f**3*s**2 - 5040*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 1980*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(5*f**3*(46*s + 191)*(r + s - 1) - 2*f**2*(792*C*(s - 1)*(r + s - 1) + 140*fd*(r*(6*s + 3) + 6*s**2 - 2*s - 1) + (s*(4*K - 9) + 8)*(99*r + 99*s - 99)) + 33*f*(15*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 5*r - 12*s**2 + 14*s - 3) + (58*g2*(s - 1) + 36*gd2*(1 - 2*s))*(r + s - 1)) - 1188*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(280*f**2*(r*(8*s + 7) + 8*s**2 - 5) - 495*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 11*r - 24*s**2 + 32*s - 9) + 1188*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 15120*Dd**2*f**3*r*s - 3780*Dd**2*f**3*r + 15120*Dd**2*f**3*s**2 - 15120*Dd**2*f**3*s + 2520*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 3960*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*s*(29*fd - 18*fdd)*(r + s) + D1*Dd*(29*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 1) + 4*s*(2*s - 1))) - 18*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(3168*C*D1**2*f*fd*r*s + 3168*C*D1**2*f*fd*s**2 - 1584*C*D1**2*f*fd*s - 1980*C*D1**2*f*fdd*r*s - 1980*C*D1**2*f*fdd*s**2 + 990*C*D1**2*f*fdd*s - 1980*C*D1**2*fd**2*r*s - 1980*C*D1**2*fd**2*s**2 + 990*C*D1**2*fd**2*s + 6336*C*D1*Dd*f**2*r*s - 1584*C*D1*Dd*f**2*r + 6336*C*D1*Dd*f**2*s**2 - 6336*C*D1*Dd*f**2*s + 1584*C*D1*Dd*f**2 - 15840*C*D1*Dd*f*fd*r*s + 1980*C*D1*Dd*f*fd*r - 15840*C*D1*Dd*f*fd*s**2 + 11880*C*D1*Dd*f*fd*s - 990*C*D1*Dd*f*fd - 3960*C*D1*Ddd*f**2*r*s + 990*C*D1*Ddd*f**2*r - 3960*C*D1*Ddd*f**2*s**2 + 3960*C*D1*Ddd*f**2*s - 990*C*D1*Ddd*f**2 - 11880*C*Dd**2*f**2*r*s + 2970*C*Dd**2*f**2*r - 11880*C*Dd**2*f**2*s**2 + 11880*C*Dd**2*f**2*s - 1980*C*Dd**2*f**2 + 1584*D1**2*K*f*fd*r*s - 792*D1**2*K*f*fd*r + 1584*D1**2*K*f*fd*s**2 - 1584*D1**2*K*f*fd*s + 792*D1**2*K*f*fd - 1980*D1**2*K*f*fdd*r*s + 990*D1**2*K*f*fdd*r - 1980*D1**2*K*f*fdd*s**2 + 1980*D1**2*K*f*fdd*s - 990*D1**2*K*f*fdd - 1980*D1**2*K*fd**2*r*s + 990*D1**2*K*fd**2*r - 1980*D1**2*K*fd**2*s**2 + 1980*D1**2*K*fd**2*s - 594*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 690*D1**2*f**2*fd*r*s + 1185*D1**2*f**2*fd*r - 690*D1**2*f**2*fd*s**2 + 1645*D1**2*f**2*fd*s - 1185*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r*s - 840*D1**2*f**2*fdd*r + 840*D1**2*f**2*fdd*s**2 - 1400*D1**2*f**2*fdd*s + 840*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r*s - 1680*D1**2*f*fd**2*r + 1680*D1**2*f*fd**2*s**2 - 2800*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 3564*D1**2*f*fd*r*s + 198*D1**2*f*fd*r - 3564*D1**2*f*fd*s**2 + 1980*D1**2*f*fd*s - 198*D1**2*f*fd + 2970*D1**2*f*fdd*r*s - 495*D1**2*f*fdd*r + 2970*D1**2*f*fdd*s**2 - 1980*D1**2*f*fdd*s + 495*D1**2*f*fdd - 1914*D1**2*f*gd2*r*s - 1914*D1**2*f*gd2*s**2 + 1914*D1**2*f*gd2*s + 1188*D1**2*f*gdd2*r*s + 1188*D1**2*f*gdd2*s**2 - 1188*D1**2*f*gdd2*s + 2970*D1**2*fd**2*r*s - 495*D1**2*fd**2*r + 2970*D1**2*fd**2*s**2 - 1980*D1**2*fd**2*s - 1914*D1**2*fd*g2*r*s - 1914*D1**2*fd*g2*s**2 + 2376*D1**2*fd*gd2*r*s + 2376*D1**2*fd*gd2*s**2 - 1188*D1**2*fd*gd2*s + 1188*D1**2*fdd*g2*r*s + 1188*D1**2*fdd*g2*s**2 + 3168*D1*Dd*K*f**2*r*s - 792*D1*Dd*K*f**2*r + 3168*D1*Dd*K*f**2*s**2 - 3168*D1*Dd*K*f**2*s + 792*D1*Dd*K*f**2 - 15840*D1*Dd*K*f*fd*r*s + 5940*D1*Dd*K*f*fd*r - 15840*D1*Dd*K*f*fd*s**2 + 15840*D1*Dd*K*f*fd*s - 3960*D1*Dd*K*f*fd - 920*D1*Dd*f**3*r*s + 230*D1*Dd*f**3*r - 920*D1*Dd*f**3*s**2 + 920*D1*Dd*f**3*s - 230*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r*s - 4200*D1*Dd*f**2*fd*r + 6720*D1*Dd*f**2*fd*s**2 - 8960*D1*Dd*f**2*fd*s + 3080*D1*Dd*f**2*fd - 7128*D1*Dd*f**2*r*s + 1782*D1*Dd*f**2*r - 7128*D1*Dd*f**2*s**2 + 7128*D1*Dd*f**2*s - 1782*D1*Dd*f**2 + 23760*D1*Dd*f*fd*r*s - 4950*D1*Dd*f*fd*r + 23760*D1*Dd*f*fd*s**2 - 19800*D1*Dd*f*fd*s + 2970*D1*Dd*f*fd - 7656*D1*Dd*f*g2*r*s + 1914*D1*Dd*f*g2*r - 7656*D1*Dd*f*g2*s**2 + 7656*D1*Dd*f*g2*s - 1914*D1*Dd*f*g2 + 9504*D1*Dd*f*gd2*r*s - 1188*D1*Dd*f*gd2*r + 9504*D1*Dd*f*gd2*s**2 - 9504*D1*Dd*f*gd2*s + 1188*D1*Dd*f*gd2 + 9504*D1*Dd*fd*g2*r*s - 1188*D1*Dd*fd*g2*r + 9504*D1*Dd*fd*g2*s**2 - 4752*D1*Dd*fd*g2*s - 3960*D1*Ddd*K*f**2*r*s + 990*D1*Ddd*K*f**2*r - 3960*D1*Ddd*K*f**2*s**2 + 3960*D1*Ddd*K*f**2*s - 990*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r + 1120*D1*Ddd*f**3*s**2 - 1120*D1*Ddd*f**3*s + 280*D1*Ddd*f**3 + 5940*D1*Ddd*f**2*r*s - 1485*D1*Ddd*f**2*r + 5940*D1*Ddd*f**2*s**2 - 5940*D1*Ddd*f**2*s + 1485*D1*Ddd*f**2 + 4752*D1*Ddd*f*g2*r*s - 1188*D1*Ddd*f*g2*r + 4752*D1*Ddd*f*g2*s**2 - 4752*D1*Ddd*f*g2*s + 1188*D1*Ddd*f*g2 + 33*D1*bd1*(K - 1)*(D1*(29*f*(2*s - 1)*(r + s - 1) + 18*fd*(-4*r*s + r + s*(3 - 4*s))) - 18*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 11880*Dd**2*K*f**2*r*s + 2970*Dd**2*K*f**2*r - 11880*Dd**2*K*f**2*s**2 + 11880*Dd**2*K*f**2*s - 1980*Dd**2*K*f**2 + 3360*Dd**2*f**3*r*s - 840*Dd**2*f**3*r + 3360*Dd**2*f**3*s**2 - 3360*Dd**2*f**3*s + 560*Dd**2*f**3 + 17820*Dd**2*f**2*r*s - 4455*Dd**2*f**2*r + 17820*Dd**2*f**2*s**2 - 17820*Dd**2*f**2*s + 2970*Dd**2*f**2 + 14256*Dd**2*f*g2*r*s - 3564*Dd**2*f*g2*r + 14256*Dd**2*f*g2*s**2 - 14256*Dd**2*f*g2*s + 2376*Dd**2*f*g2))/(693*d**2*k3**6) + 5*D1**2*Pk3*Pkd2*ct**5*k1**3*st**2*(D1**2*(3087*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(9261*fd**2*s*(2*s - 1) - fd*(2600*C - 2600)*(3*s**2 - 2*s + 1) + fdd*(1300*C - 1300)*(3*s**2 - 2*s + 1) + s**2*(858*K*bdd1 - 1716*bd1*(K - 1) - 858*bdd1 + 3432*gd2 - 1716*gdd2)) - 104*f*(fd**2*s*(50*C - 50)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 6864*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(3087*f**3*(4*s**2 - 2*s + 1) + f**2*(2600*C*(4*s**2 - 2*s + 1) - 3087*fd*(1 - 4*s)**2 - 10400*s**2 + 5200*s - 2600) - 52*f*(fd*(50*C - 50)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 3432*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(3087*f**2 + f*(2600*C - 2600) - 3432*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(3087*f**2 + f*(2600*C - 2600) - 3432*g2) + 1716*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(2002*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**5*k1**3*(1320*C*D1**2*bdd1*f**2*r*s + 4620*C*D1**2*bdd1*f**2*s**2 - 6600*C*D1**2*bdd1*f**2*s + 3300*C*D1**2*bdd1*f**2 + 11880*C*D1**2*f**2*fd*r*s - 3960*C*D1**2*f**2*fd*r + 16440*C*D1**2*f**2*fd*s**2 - 14920*C*D1**2*f**2*fd*s + 5480*C*D1**2*f**2*fd - 7920*C*D1**2*f**2*fdd*r*s + 2640*C*D1**2*f**2*fdd*r - 12180*C*D1**2*f**2*fdd*s**2 + 10760*C*D1**2*f**2*fdd*s - 4060*C*D1**2*f**2*fdd - 15840*C*D1**2*f*fd**2*r*s + 5280*C*D1**2*f*fd**2*r - 24360*C*D1**2*f*fd**2*s**2 + 21520*C*D1**2*f*fd**2*s - 2640*C*D1**2*f*fd**2 + 15840*C*D1*Dd*f**3*r*s - 3960*C*D1*Dd*f**3*r + 21920*C*D1*Dd*f**3*s**2 - 18880*C*D1*Dd*f**3*s + 5480*C*D1*Dd*f**3 - 63360*C*D1*Dd*f**2*fd*r*s + 18480*C*D1*Dd*f**2*fd*r - 97440*C*D1*Dd*f**2*fd*s**2 + 83240*C*D1*Dd*f**2*fd*s - 16040*C*D1*Dd*f**2*fd - 10560*C*D1*Ddd*f**3*r*s + 2640*C*D1*Ddd*f**3*r - 16240*C*D1*Ddd*f**3*s**2 + 13400*C*D1*Ddd*f**3*s - 4060*C*D1*Ddd*f**3 - 31680*C*Dd**2*f**3*r*s + 7920*C*Dd**2*f**3*r - 48720*C*Dd**2*f**3*s**2 + 40200*C*Dd**2*f**3*s - 5280*C*Dd**2*f**3 - 1452*D1**2*K*bdd1*f**2*r*s - 2442*D1**2*K*bdd1*f**2*s**2 + 1452*D1**2*K*bdd1*f**2*s + 792*D1**2*bd1**2*f*s*(K - 1)*(2*r + 7*s - 6) + 2800*D1**2*bdd1*f**3*r*s + 2800*D1**2*bdd1*f**3*s**2 - 5880*D1**2*bdd1*f**3*s + 2100*D1**2*bdd1*f**3 + 2112*D1**2*bdd1*f**2*r*s + 627*D1**2*bdd1*f**2*s**2 + 3168*D1**2*bdd1*f**2*s - 3300*D1**2*bdd1*f**2 - 1584*D1**2*bdd1*f*g2*r*s - 5544*D1**2*bdd1*f*g2*s**2 + 7920*D1**2*bdd1*f*g2*s - 3960*D1**2*bdd1*f*g2 + 13440*D1**2*f**3*fd*r*s - 3360*D1**2*f**3*fd*r + 30240*D1**2*f**3*fd*s**2 - 21840*D1**2*f**3*fd*s + 7560*D1**2*f**3*fd - 13440*D1**2*f**3*fdd*r*s + 3360*D1**2*f**3*fdd*r - 18480*D1**2*f**3*fdd*s**2 + 15960*D1**2*f**3*fdd*s - 4620*D1**2*f**3*fdd - 40320*D1**2*f**2*fd**2*r*s + 10080*D1**2*f**2*fd**2*r - 55440*D1**2*f**2*fd**2*s**2 + 47880*D1**2*f**2*fd**2*s - 6720*D1**2*f**2*fd**2 - 18000*D1**2*f**2*fd*r*s + 6000*D1**2*f**2*fd*r - 26760*D1**2*f**2*fd*s**2 + 23840*D1**2*f**2*fd*s - 8920*D1**2*f**2*fd + 12960*D1**2*f**2*fdd*r*s - 4320*D1**2*f**2*fdd*r + 19320*D1**2*f**2*fdd*s**2 - 17200*D1**2*f**2*fdd*s + 6440*D1**2*f**2*fdd - 4224*D1**2*f**2*gd2*r*s - 6600*D1**2*f**2*gd2*s**2 + 4224*D1**2*f**2*gd2*s + 2904*D1**2*f**2*gdd2*r*s + 4884*D1**2*f**2*gdd2*s**2 - 2904*D1**2*f**2*gdd2*s + 25920*D1**2*f*fd**2*r*s - 8640*D1**2*f*fd**2*r + 38640*D1**2*f*fd**2*s**2 - 34400*D1**2*f*fd**2*s + 4320*D1**2*f*fd**2 - 8448*D1**2*f*fd*g2*r*s + 4224*D1**2*f*fd*g2*r - 13200*D1**2*f*fd*g2*s**2 + 13200*D1**2*f*fd*g2*s - 6600*D1**2*f*fd*g2 + 11616*D1**2*f*fd*gd2*r*s - 2904*D1**2*f*fd*gd2*r + 19536*D1**2*f*fd*gd2*s**2 - 15576*D1**2*f*fd*gd2*s + 2904*D1**2*f*fd*gd2 + 5808*D1**2*f*fdd*g2*r*s - 2904*D1**2*f*fdd*g2*r + 9768*D1**2*f*fdd*g2*s**2 - 9768*D1**2*f*fdd*g2*s + 4884*D1**2*f*fdd*g2 + 5808*D1**2*fd**2*g2*r*s - 2904*D1**2*fd**2*g2*r + 9768*D1**2*fd**2*g2*s**2 - 9768*D1**2*fd**2*g2*s + 13440*D1*Dd*f**4*r*s - 3360*D1*Dd*f**4*r + 30240*D1*Dd*f**4*s**2 - 21840*D1*Dd*f**4*s + 7560*D1*Dd*f**4 - 107520*D1*Dd*f**3*fd*r*s + 26880*D1*Dd*f**3*fd*r - 147840*D1*Dd*f**3*fd*s**2 + 127680*D1*Dd*f**3*fd*s - 22680*D1*Dd*f**3*fd - 24000*D1*Dd*f**3*r*s + 6000*D1*Dd*f**3*r - 35680*D1*Dd*f**3*s**2 + 29840*D1*Dd*f**3*s - 8920*D1*Dd*f**3 + 103680*D1*Dd*f**2*fd*r*s - 30240*D1*Dd*f**2*fd*r + 154560*D1*Dd*f**2*fd*s**2 - 133360*D1*Dd*f**2*fd*s + 25840*D1*Dd*f**2*fd - 16896*D1*Dd*f**2*g2*r*s + 4224*D1*Dd*f**2*g2*r - 26400*D1*Dd*f**2*g2*s**2 + 21648*D1*Dd*f**2*g2*s - 6600*D1*Dd*f**2*g2 + 23232*D1*Dd*f**2*gd2*r*s - 2904*D1*Dd*f**2*gd2*r + 39072*D1*Dd*f**2*gd2*s**2 - 27192*D1*Dd*f**2*gd2*s + 2904*D1*Dd*f**2*gd2 + 46464*D1*Dd*f*fd*g2*r*s - 17424*D1*Dd*f*fd*g2*r + 78144*D1*Dd*f*fd*g2*s**2 - 70224*D1*Dd*f*fd*g2*s + 15576*D1*Dd*f*fd*g2 - 13440*D1*Ddd*f**4*r*s + 3360*D1*Ddd*f**4*r - 18480*D1*Ddd*f**4*s**2 + 15960*D1*Ddd*f**4*s - 4620*D1*Ddd*f**4 + 17280*D1*Ddd*f**3*r*s - 4320*D1*Ddd*f**3*r + 25760*D1*Ddd*f**3*s**2 - 21520*D1*Ddd*f**3*s + 6440*D1*Ddd*f**3 + 11616*D1*Ddd*f**2*g2*r*s - 2904*D1*Ddd*f**2*g2*r + 19536*D1*Ddd*f**2*g2*s**2 - 15576*D1*Ddd*f**2*g2*s + 4884*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(10*f**3*(181*s**2 + s*(181*r - 522) + 210) + f**2*(132*C*(29*s**2 + s*(4*r - 50) + 25) - 280*fd*(5*r*(6*s - 1) + 30*s**2 - 41*s + 3) - 33*s**2*(50*K + 5) - 33*s*(32*K*(r - 1) - 52*r - 132) - 3300) + 33*f*(fd*(-280*C*s**2 + 260*C*s + 2*K*(11*r*(4*s - 1) + 74*s**2 - 59*s + 11) - r*(20*C + 32)*(4*s - 1) - 38*s**2 + 3*s - 52) - 20*g2*(7*s**2 + s*(r - 12) + 6) + 24*gd2*s*(2*r + 7*s - 6)) + 792*fd*g2*(r*(2*s - 1) + s*(7*s - 7))) + Dd*f*(-140*f**2*(10*r*(8*s - 1) + 80*s**2 - 124*s + 21) - 33*f*(20*C*(r*(8*s - 1) + 28*s**2 - 29*s + 5) - 2*K*(88*r*s - 11*r + 148*s**2 - 103*s + 11) + 256*r*s - 32*r + 76*s**2 + 109*s - 48) + 792*g2*(r*(8*s - 1) + 28*s**2 - 29*s + 5))) - 40320*Dd**2*f**4*r*s + 10080*Dd**2*f**4*r - 55440*Dd**2*f**4*s**2 + 47880*Dd**2*f**4*s - 6720*Dd**2*f**4 + 51840*Dd**2*f**3*r*s - 12960*Dd**2*f**3*r + 77280*Dd**2*f**3*s**2 - 64560*Dd**2*f**3*s + 8640*Dd**2*f**3 + 34848*Dd**2*f**2*g2*r*s - 8712*Dd**2*f**2*g2*r + 58608*Dd**2*f**2*g2*s**2 - 46728*Dd**2*f**2*g2*s + 5808*Dd**2*f**2*g2 - 132*b1**2*(K - 1)*(D1**2*(5*fd*(r*(s - 1) + 7*s**2 - 2*s + 1) - 3*fdd*(2*r*(s - 1) + 7*s**2 - 4*s + 2)) + D1*(Dd*(5*f*(4*r*s - r + 28*s**2 - 16*s + 7) - 6*fd*(8*r*s - 5*r + 28*s**2 - 17*s + 4)) - 3*Ddd*f*(r*(8*s - 2) + 28*s**2 - 18*s + 7)) - 6*Dd**2*f*(3*r*(4*s - 1) + 42*s**2 - 27*s + 2)) + b1*(-2112*C*D1**2*f*fd*r*s + 1056*C*D1**2*f*fd*r - 15312*C*D1**2*f*fd*s**2 + 3168*C*D1**2*f*fd*s - 1056*C*D1**2*f*fd + 2640*C*D1**2*f*fdd*r*s - 1320*C*D1**2*f*fdd*r + 9240*C*D1**2*f*fdd*s**2 - 3960*C*D1**2*f*fdd*s + 1320*C*D1**2*f*fdd + 2640*C*D1**2*fd**2*r*s - 1320*C*D1**2*fd**2*r + 9240*C*D1**2*fd**2*s**2 - 3960*C*D1**2*fd**2*s + 1320*C*D1**2*fd**2 - 4224*C*D1*Dd*f**2*r*s + 1056*C*D1*Dd*f**2*r - 30624*C*D1*Dd*f**2*s**2 + 17424*C*D1*Dd*f**2*s - 7656*C*D1*Dd*f**2 + 21120*C*D1*Dd*f*fd*r*s - 7920*C*D1*Dd*f*fd*r + 73920*C*D1*Dd*f*fd*s**2 - 39600*C*D1*Dd*f*fd*s + 6600*C*D1*Dd*f*fd + 5280*C*D1*Ddd*f**2*r*s - 1320*C*D1*Ddd*f**2*r + 18480*C*D1*Ddd*f**2*s**2 - 11880*C*D1*Ddd*f**2*s + 4620*C*D1*Ddd*f**2 + 15840*C*Dd**2*f**2*r*s - 3960*C*Dd**2*f**2*r + 55440*C*Dd**2*f**2*s**2 - 35640*C*Dd**2*f**2*s + 2640*C*Dd**2*f**2 + 4224*D1**2*K*f*fd*r*s - 2112*D1**2*K*f*fd*r + 6600*D1**2*K*f*fd*s**2 - 6600*D1**2*K*f*fd*s + 3300*D1**2*K*f*fd - 2904*D1**2*K*f*fdd*r*s + 1452*D1**2*K*f*fdd*r - 4884*D1**2*K*f*fdd*s**2 + 4884*D1**2*K*f*fdd*s - 2442*D1**2*K*f*fdd - 2904*D1**2*K*fd**2*r*s + 1452*D1**2*K*fd**2*r - 4884*D1**2*K*fd**2*s**2 + 4884*D1**2*K*fd**2*s + 396*D1**2*bdd1*f*(K - 1)*(14*s**2 + s*(4*r - 12) + 5) - 10860*D1**2*f**2*fd*r*s + 3620*D1**2*f**2*fd*r - 10860*D1**2*f**2*fd*s**2 + 4040*D1**2*f**2*fd*s + 580*D1**2*f**2*fd + 8400*D1**2*f**2*fdd*r*s - 2800*D1**2*f**2*fdd*r + 8400*D1**2*f**2*fdd*s**2 - 5320*D1**2*f**2*fdd*s + 700*D1**2*f**2*fdd + 16800*D1**2*f*fd**2*r*s - 5600*D1**2*f*fd**2*r + 16800*D1**2*f*fd**2*s**2 - 10640*D1**2*f*fd**2*s + 3920*D1**2*f*fd**2 - 6864*D1**2*f*fd*r*s + 3432*D1**2*f*fd*r + 660*D1**2*f*fd*s**2 + 11484*D1**2*f*fd*s - 6270*D1**2*f*fd + 4224*D1**2*f*fdd*r*s - 2112*D1**2*f*fdd*r + 1254*D1**2*f*fdd*s**2 - 6534*D1**2*f*fdd*s + 3927*D1**2*f*fdd + 1320*D1**2*f*gd2*r*s + 9240*D1**2*f*gd2*s**2 - 1320*D1**2*f*gd2*s - 1584*D1**2*f*gdd2*r*s - 5544*D1**2*f*gdd2*s**2 + 1584*D1**2*f*gdd2*s + 4224*D1**2*fd**2*r*s - 2112*D1**2*fd**2*r + 1254*D1**2*fd**2*s**2 - 6534*D1**2*fd**2*s - 1320*D1**2*fd**2 + 1320*D1**2*fd*g2*r*s - 1320*D1**2*fd*g2*r + 9240*D1**2*fd*g2*s**2 - 2640*D1**2*fd*g2*s + 1320*D1**2*fd*g2 - 3168*D1**2*fd*gd2*r*s + 1584*D1**2*fd*gd2*r - 11088*D1**2*fd*gd2*s**2 + 4752*D1**2*fd*gd2*s - 1584*D1**2*fd*gd2 - 1584*D1**2*fdd*g2*r*s + 1584*D1**2*fdd*g2*r - 5544*D1**2*fdd*g2*s**2 + 3168*D1**2*fdd*g2*s - 1584*D1**2*fdd*g2 + 8448*D1*Dd*K*f**2*r*s - 2112*D1*Dd*K*f**2*r + 13200*D1*Dd*K*f**2*s**2 - 10824*D1*Dd*K*f**2*s + 3300*D1*Dd*K*f**2 - 23232*D1*Dd*K*f*fd*r*s + 8712*D1*Dd*K*f*fd*r - 39072*D1*Dd*K*f*fd*s**2 + 35112*D1*Dd*K*f*fd*s - 7788*D1*Dd*K*f*fd - 14480*D1*Dd*f**3*r*s + 3620*D1*Dd*f**3*r - 14480*D1*Dd*f**3*s**2 + 14480*D1*Dd*f**3*s - 3620*D1*Dd*f**3 + 67200*D1*Dd*f**2*fd*r*s - 19600*D1*Dd*f**2*fd*r + 67200*D1*Dd*f**2*fd*s**2 - 54880*D1*Dd*f**2*fd*s + 10920*D1*Dd*f**2*fd - 13728*D1*Dd*f**2*r*s + 3432*D1*Dd*f**2*r + 1320*D1*Dd*f**2*s**2 + 6204*D1*Dd*f**2*s + 330*D1*Dd*f**2 + 33792*D1*Dd*f*fd*r*s - 12672*D1*Dd*f*fd*r + 10032*D1*Dd*f*fd*s**2 - 37092*D1*Dd*f*fd*s + 10758*D1*Dd*f*fd + 5280*D1*Dd*f*g2*r*s - 1320*D1*Dd*f*g2*r + 36960*D1*Dd*f*g2*s**2 - 21120*D1*Dd*f*g2*s + 9240*D1*Dd*f*g2 - 12672*D1*Dd*f*gd2*r*s + 1584*D1*Dd*f*gd2*r - 44352*D1*Dd*f*gd2*s**2 + 20592*D1*Dd*f*gd2*s - 1584*D1*Dd*f*gd2 - 12672*D1*Dd*fd*g2*r*s + 7920*D1*Dd*fd*g2*r - 44352*D1*Dd*fd*g2*s**2 + 26928*D1*Dd*fd*g2*s - 6336*D1*Dd*fd*g2 - 5808*D1*Ddd*K*f**2*r*s + 1452*D1*Ddd*K*f**2*r - 9768*D1*Ddd*K*f**2*s**2 + 7788*D1*Ddd*K*f**2*s - 2442*D1*Ddd*K*f**2 + 11200*D1*Ddd*f**3*r*s - 2800*D1*Ddd*f**3*r + 11200*D1*Ddd*f**3*s**2 - 11200*D1*Ddd*f**3*s + 2800*D1*Ddd*f**3 + 8448*D1*Ddd*f**2*r*s - 2112*D1*Ddd*f**2*r + 2508*D1*Ddd*f**2*s**2 - 5478*D1*Ddd*f**2*s + 627*D1*Ddd*f**2 - 6336*D1*Ddd*f*g2*r*s + 1584*D1*Ddd*f*g2*r - 22176*D1*Ddd*f*g2*s**2 + 14256*D1*Ddd*f*g2*s - 5544*D1*Ddd*f*g2 - 132*D1*bd1*(K - 1)*(D1*(5*f*(2*r*s + 14*s**2 - 13*s + 6) - 6*fd*(4*r*s - 2*r + 14*s**2 - 10*s + 1)) - 12*Dd*f*(r*(8*s - 1) + 28*s**2 - 21*s + 3)) - 17424*Dd**2*K*f**2*r*s + 4356*Dd**2*K*f**2*r - 29304*Dd**2*K*f**2*s**2 + 23364*Dd**2*K*f**2*s - 2904*Dd**2*K*f**2 + 33600*Dd**2*f**3*r*s - 8400*Dd**2*f**3*r + 33600*Dd**2*f**3*s**2 - 33600*Dd**2*f**3*s + 5600*Dd**2*f**3 + 25344*Dd**2*f**2*r*s - 6336*Dd**2*f**2*r + 7524*Dd**2*f**2*s**2 - 16434*Dd**2*f**2*s + 4224*Dd**2*f**2 - 19008*Dd**2*f*g2*r*s + 4752*Dd**2*f*g2*r - 66528*Dd**2*f*g2*s**2 + 42768*Dd**2*f*g2*s - 3168*Dd**2*f*g2))/(693*d**2*k3**4) + 5*D1**2*Pk3*Pkd2*ct**5*k1**3*(b1*(D1**2*(56*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-112*fd**2*s*(3*s - 2) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(56*f**2*(4*s**2 - 2*s + 1) - 56*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(56*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(56*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(112*bd1 - 56*bdd1) + f*(-56*fd*(s**2*(6*bd1 - 3) - s*(2*bd1 - 2) - 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) - 2*D1*f*(28*Dd*f*(s**2*(8*bd1 - 4) - s*(2*bd1 - 2) - 1) + Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) + 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2**2*k3**2) + 20*D1**2*Pk3*Pkd2*ct**5*k1*k2**4*st**2*(600*C*D1**2*f**2*fd*r*s - 200*C*D1**2*f**2*fd*r + 600*C*D1**2*f**2*fd*s**2 - 600*C*D1**2*f**2*fd*s + 200*C*D1**2*f**2*fd - 300*C*D1**2*f**2*fdd*r*s + 100*C*D1**2*f**2*fdd*r - 300*C*D1**2*f**2*fdd*s**2 + 300*C*D1**2*f**2*fdd*s - 100*C*D1**2*f**2*fdd - 600*C*D1**2*f*fd**2*r*s + 200*C*D1**2*f*fd**2*r - 600*C*D1**2*f*fd**2*s**2 + 600*C*D1**2*f*fd**2*s - 100*C*D1**2*f*fd**2 + 800*C*D1*Dd*f**3*r*s - 200*C*D1*Dd*f**3*r + 800*C*D1*Dd*f**3*s**2 - 800*C*D1*Dd*f**3*s + 200*C*D1*Dd*f**3 - 2400*C*D1*Dd*f**2*fd*r*s + 700*C*D1*Dd*f**2*fd*r - 2400*C*D1*Dd*f**2*fd*s**2 + 2400*C*D1*Dd*f**2*fd*s - 500*C*D1*Dd*f**2*fd - 400*C*D1*Ddd*f**3*r*s + 100*C*D1*Ddd*f**3*r - 400*C*D1*Ddd*f**3*s**2 + 400*C*D1*Ddd*f**3*s - 100*C*D1*Ddd*f**3 - 1200*C*Dd**2*f**3*r*s + 300*C*Dd**2*f**3*r - 1200*C*Dd**2*f**3*s**2 + 1200*C*Dd**2*f**3*s - 200*C*Dd**2*f**3 - 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s + 35*D1**2*bdd1*f**3*r*s + 35*D1**2*bdd1*f**3*s**2 - 35*D1**2*bdd1*f**3*s + 33*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s - 450*D1**2*f**2*fd*r*s + 150*D1**2*f**2*fd*r - 450*D1**2*f**2*fd*s**2 + 450*D1**2*f**2*fd*s - 150*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r*s - 75*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 225*D1**2*f**2*fdd*s + 75*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 450*D1**2*f*fd**2*r*s - 150*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 450*D1**2*f*fd**2*s + 75*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r*s - 132*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 528*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s - 600*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 600*D1*Dd*f**3*s**2 + 600*D1*Dd*f**3*s - 150*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r*s - 525*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 1800*D1*Dd*f**2*fd*s + 375*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r*s - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1056*D1*Dd*f**2*gd2*s + 132*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r*s - 792*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2112*D1*Dd*f*fd*g2*s + 528*D1*Dd*f*fd*g2 + 300*D1*Ddd*f**3*r*s - 75*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r*s - 132*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 528*D1*Ddd*f**2*g2*s + 132*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(35*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-66*K + 35*f + 33)*(r + s - 1) - 33*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-66*K + 35*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 900*Dd**2*f**3*r*s - 225*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 150*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r*s - 396*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 1584*Dd**2*f**2*g2*s + 264*Dd**2*f**2*g2 + b1*(D1**2*(-35*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(35*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*fd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 33*fdd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 33*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-70*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(35*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (132*K - 66)*(r*(4*s - 1) + (1 - 2*s)**2)) - 66*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-66*K + 35*f + 33)) + Dd**2*f**2*(-66*K + 35*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k3**6) - 8*D1**2*Pk3*Pkd2*ct**5*k1*k2**4*(220*C*D1**2*bdd1*f**2*r*s - 220*C*D1**2*bdd1*f**2*r + 220*C*D1**2*bdd1*f**2*s**2 - 440*C*D1**2*bdd1*f**2*s + 220*C*D1**2*bdd1*f**2 - 690*C*D1**2*f**2*fd*r*s + 230*C*D1**2*f**2*fd*r - 690*C*D1**2*f**2*fd*s**2 + 690*C*D1**2*f**2*fd*s - 230*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 920*C*D1*Dd*f**3*r*s + 230*C*D1*Dd*f**3*r - 920*C*D1*Dd*f**3*s**2 + 920*C*D1*Dd*f**3*s - 230*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 11*D1**2*bd1**2*f*(2*s - 1)*(-12*K + 5*f + 6)*(r + s - 1) - 165*D1**2*bdd1*f**2*r*s + 165*D1**2*bdd1*f**2*r - 165*D1**2*bdd1*f**2*s**2 + 330*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r*s + 264*D1**2*bdd1*f*g2*r - 264*D1**2*bdd1*f*g2*s**2 + 528*D1**2*bdd1*f*g2*s - 264*D1**2*bdd1*f*g2 + 180*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 180*D1**2*f**2*fd*s**2 - 180*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 840*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 240*D1*Dd*f**3*s**2 - 240*D1*Dd*f**3*s + 60*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3360*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r*s - 264*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1056*D1*Dd*f**2*g2*s + 264*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + 2*f**2*(r + s - 1)*(20*C*(s - 1) + s*(6*K - 12) + 15) + f*(-5*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 3*K*(r*(4*s - 1) + (1 - 2*s)**2) - 12*r*s + 6*r - 12*s**2 + 15*s - 3) + (-24*r - 24*s + 24)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 24*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-5*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 3*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) + 24*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 1680*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 11*b1**2*(D1**2*s*(5*f*(2*fd - fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 12*fd*(2*K - 1)*(r + s) + 6*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (12 - 24*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-12*K + 5*f + 6)) - Dd**2*f*(-12*K + 5*f + 6)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(-80*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*s**2 + 40*C*D1**2*f*fd*s + 40*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 40*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 40*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r*s + 12*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*s - 1)*(-12*K + 5*f + 6)*(r + s - 1) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 48*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s - 6*D1**2*f*fd - 30*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*s**2 + 15*D1**2*f*fdd*s + 48*D1**2*f*gd2*r*s + 48*D1**2*f*gd2*s**2 - 48*D1**2*f*gd2*s - 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 30*D1**2*fd**2*r*s - 30*D1**2*fd**2*s**2 + 15*D1**2*fd**2*s + 48*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r*s - 48*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r*s + 12*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 48*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 + 96*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 96*D1*Dd*f**2*s + 24*D1*Dd*f**2 - 240*D1*Dd*f*fd*r*s + 30*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 15*D1*Dd*f*fd + 192*D1*Dd*f*g2*r*s - 48*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 192*D1*Dd*f*g2*s + 48*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r*s + 24*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 192*D1*Dd*f*gd2*s - 24*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r*s + 24*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 96*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 60*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 96*D1*Ddd*f*g2*s - 24*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(2*s - 1)*(r + s - 1) + f*(-5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (12 - 24*K)*(2*s - 1)*(r + s - 1)) + 6*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-12*K + 5*f + 6)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 180*Dd**2*f**2*r*s + 45*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 30*Dd**2*f**2 - 288*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 288*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(231*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**5*k1*k2**2*st**2*(-18672*C*D1**2*f**2*fd*r*s + 6224*C*D1**2*f**2*fd*r + 45000*C*D1**2*f**2*fd*s**2 - 23776*C*D1**2*f**2*fd*s + 15000*C*D1**2*f**2*fd + 10920*C*D1**2*f**2*fdd*r*s - 3640*C*D1**2*f**2*fdd*r - 22500*C*D1**2*f**2*fdd*s**2 + 11360*C*D1**2*f**2*fdd*s - 7500*C*D1**2*f**2*fdd + 21840*C*D1**2*f*fd**2*r*s - 7280*C*D1**2*f*fd**2*r - 45000*C*D1**2*f*fd**2*s**2 + 22720*C*D1**2*f*fd**2*s + 3640*C*D1**2*f*fd**2 - 24896*C*D1*Dd*f**3*r*s + 6224*C*D1*Dd*f**3*r + 60000*C*D1*Dd*f**3*s**2 - 17552*C*D1*Dd*f**3*s + 15000*C*D1*Dd*f**3 + 87360*C*D1*Dd*f**2*fd*r*s - 25480*C*D1*Dd*f**2*fd*r - 180000*C*D1*Dd*f**2*fd*s**2 + 68600*C*D1*Dd*f**2*fd*s - 4080*C*D1*Dd*f**2*fd + 14560*C*D1*Ddd*f**3*r*s - 3640*C*D1*Ddd*f**3*r - 30000*C*D1*Ddd*f**3*s**2 + 7720*C*D1*Ddd*f**3*s - 7500*C*D1*Ddd*f**3 + 43680*C*Dd**2*f**3*r*s - 10920*C*Dd**2*f**3*r - 90000*C*Dd**2*f**3*s**2 + 23160*C*Dd**2*f**3*s + 7280*C*Dd**2*f**3 + 1980*D1**2*K*bdd1*f**2*r*s - 4950*D1**2*K*bdd1*f**2*s**2 - 1980*D1**2*K*bdd1*f**2*s - 2100*D1**2*bdd1*f**3*r*s + 525*D1**2*bdd1*f**3*s**2 + 2100*D1**2*bdd1*f**3*s - 3960*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*s**2 + 3960*D1**2*bdd1*f**2*s - 8400*D1**2*f**3*fd*r*s + 2100*D1**2*f**3*fd*r + 4200*D1**2*f**3*fd*s + 8400*D1**2*f**3*fdd*r*s - 2100*D1**2*f**3*fdd*r - 4200*D1**2*f**3*fdd*s + 25200*D1**2*f**2*fd**2*r*s - 6300*D1**2*f**2*fd**2*r - 12600*D1**2*f**2*fd**2*s + 4200*D1**2*f**2*fd**2 + 27672*D1**2*f**2*fd*r*s - 9224*D1**2*f**2*fd*r - 24750*D1**2*f**2*fd*s**2 + 7276*D1**2*f**2*fd*s - 8250*D1**2*f**2*fd - 15420*D1**2*f**2*fdd*r*s + 5140*D1**2*f**2*fdd*r + 12375*D1**2*f**2*fdd*s**2 - 3110*D1**2*f**2*fdd*s + 4125*D1**2*f**2*fdd + 7920*D1**2*f**2*gd2*r*s - 19800*D1**2*f**2*gd2*s**2 - 7920*D1**2*f**2*gd2*s - 3960*D1**2*f**2*gdd2*r*s + 9900*D1**2*f**2*gdd2*s**2 + 3960*D1**2*f**2*gdd2*s - 30840*D1**2*f*fd**2*r*s + 10280*D1**2*f*fd**2*r + 24750*D1**2*f*fd**2*s**2 - 6220*D1**2*f*fd**2*s - 5140*D1**2*f*fd**2 + 15840*D1**2*f*fd*g2*r*s - 7920*D1**2*f*fd*g2*r - 39600*D1**2*f*fd*g2*s**2 + 39600*D1**2*f*fd*g2*s - 19800*D1**2*f*fd*g2 - 15840*D1**2*f*fd*gd2*r*s + 3960*D1**2*f*fd*gd2*r + 39600*D1**2*f*fd*gd2*s**2 - 11880*D1**2*f*fd*gd2*s - 3960*D1**2*f*fd*gd2 - 7920*D1**2*f*fdd*g2*r*s + 3960*D1**2*f*fdd*g2*r + 19800*D1**2*f*fdd*g2*s**2 - 19800*D1**2*f*fdd*g2*s + 9900*D1**2*f*fdd*g2 - 7920*D1**2*fd**2*g2*r*s + 3960*D1**2*fd**2*g2*r + 19800*D1**2*fd**2*g2*s**2 - 19800*D1**2*fd**2*g2*s - 8400*D1*Dd*f**4*r*s + 2100*D1*Dd*f**4*r + 4200*D1*Dd*f**4*s + 67200*D1*Dd*f**3*fd*r*s - 16800*D1*Dd*f**3*fd*r - 33600*D1*Dd*f**3*fd*s + 8400*D1*Dd*f**3*fd + 36896*D1*Dd*f**3*r*s - 9224*D1*Dd*f**3*r - 33000*D1*Dd*f**3*s**2 - 1948*D1*Dd*f**3*s - 8250*D1*Dd*f**3 - 123360*D1*Dd*f**2*fd*r*s + 35980*D1*Dd*f**2*fd*r + 99000*D1*Dd*f**2*fd*s**2 - 6350*D1*Dd*f**2*fd*s - 7170*D1*Dd*f**2*fd + 31680*D1*Dd*f**2*g2*r*s - 7920*D1*Dd*f**2*g2*r - 79200*D1*Dd*f**2*g2*s**2 + 23760*D1*Dd*f**2*g2*s - 19800*D1*Dd*f**2*g2 - 31680*D1*Dd*f**2*gd2*r*s + 3960*D1*Dd*f**2*gd2*r + 79200*D1*Dd*f**2*gd2*s**2 + 3960*D1*Dd*f**2*gd2*s - 3960*D1*Dd*f**2*gd2 - 63360*D1*Dd*f*fd*g2*r*s + 23760*D1*Dd*f*fd*g2*r + 158400*D1*Dd*f*fd*g2*s**2 - 102960*D1*Dd*f*fd*g2*s + 11880*D1*Dd*f*fd*g2 + 8400*D1*Ddd*f**4*r*s - 2100*D1*Ddd*f**4*r - 4200*D1*Ddd*f**4*s - 20560*D1*Ddd*f**3*r*s + 5140*D1*Ddd*f**3*r + 16500*D1*Ddd*f**3*s**2 + 2030*D1*Ddd*f**3*s + 4125*D1*Ddd*f**3 - 15840*D1*Ddd*f**2*g2*r*s + 3960*D1*Ddd*f**2*g2*r + 39600*D1*Ddd*f**2*g2*s**2 - 11880*D1*Ddd*f**2*g2*s + 9900*D1*Ddd*f**2*g2 + 30*D1*bd1*f*(D1*(f*s*(-66*K*(2*r - 5*s - 2) + 35*f*(4*r - s - 4) + 264*r - 33*s - 264) + fd*(33*K*(8*r*s - 2*r - 20*s**2 + 6*s + 2) + 35*f*(r*(2 - 12*s) + 3*s**2 + 7*s - 2) - 528*r*s + 132*r + 66*s**2 + 231*s - 132)) + Dd*f*(-66*K*(-8*r*s + r + 20*s**2 + s - 1) + 35*f*(r*(2 - 16*s) + 4*s**2 + 11*s - 2) - 1056*r*s + 132*r + 132*s**2 + 759*s - 132)) + 25200*Dd**2*f**4*r*s - 6300*Dd**2*f**4*r - 12600*Dd**2*f**4*s + 4200*Dd**2*f**4 - 61680*Dd**2*f**3*r*s + 15420*Dd**2*f**3*r + 49500*Dd**2*f**3*s**2 + 6090*Dd**2*f**3*s - 10280*Dd**2*f**3 - 47520*Dd**2*f**2*g2*r*s + 11880*Dd**2*f**2*g2*r + 118800*Dd**2*f**2*g2*s**2 - 35640*Dd**2*f**2*g2*s - 7920*Dd**2*f**2*g2 + 15*b1*(D1**2*(-35*f**2*(2*fd - fdd)*(r*(4 - 12*s) + 3*s**2 + 2*s + 1) + f*(70*fd**2*(r*(4 - 12*s) + 3*s**2 + 2*s - 2) - 66*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1) + 33*fdd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1)) + 66*fd**2*(r*(2*K - 4)*(2*s - 1) - s*(10*K - 1)*(s - 1))) + D1*f*(2*Dd*(-35*f**2*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) + f*(-66*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + 35*fd*(r*(14 - 48*s) + 12*s**2 + 13*s - 5) + 1056*r*s - 264*r - 132*s**2 - 462*s - 33) + 33*fd*(2*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) - 64*r*s + 24*r + 8*s**2 + 10*s - 7)) + Ddd*f*(66*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + 35*f*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) - 1056*r*s + 264*r + 132*s**2 + 462*s + 33)) + 2*Dd**2*f**2*(66*K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) + 35*f*(r*(6 - 24*s) + 6*s**2 + 9*s - 4) - 1584*r*s + 396*r + 198*s**2 + 693*s - 264)))/(1386*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**5*k1*k2**2*(-1056*C*D1**2*bdd1*f**2*r*s - 1584*C*D1**2*bdd1*f**2*r - 3300*C*D1**2*bdd1*f**2*s**2 + 1320*C*D1**2*bdd1*f**2*s - 660*C*D1**2*bdd1*f**2 - 38400*C*D1**2*f**2*fd*r*s + 12800*C*D1**2*f**2*fd*r - 39360*C*D1**2*f**2*fd*s**2 + 39040*C*D1**2*f**2*fd*s - 13120*C*D1**2*f**2*fd + 27120*C*D1**2*f**2*fdd*r*s - 9040*C*D1**2*f**2*fdd*r + 29580*C*D1**2*f**2*fdd*s**2 - 28760*C*D1**2*f**2*fdd*s + 9860*C*D1**2*f**2*fdd + 54240*C*D1**2*f*fd**2*r*s - 18080*C*D1**2*f*fd**2*r + 59160*C*D1**2*f*fd**2*s**2 - 57520*C*D1**2*f*fd**2*s + 9040*C*D1**2*f*fd**2 - 51200*C*D1*Dd*f**3*r*s + 12800*C*D1*Dd*f**3*r - 52480*C*D1*Dd*f**3*s**2 + 51840*C*D1*Dd*f**3*s - 13120*C*D1*Dd*f**3 + 216960*C*D1*Dd*f**2*fd*r*s - 63280*C*D1*Dd*f**2*fd*r + 236640*C*D1*Dd*f**2*fd*s**2 - 228440*C*D1*Dd*f**2*fd*s + 46840*C*D1*Dd*f**2*fd + 36160*C*D1*Ddd*f**3*r*s - 9040*C*D1*Ddd*f**3*r + 39440*C*D1*Ddd*f**3*s**2 - 37800*C*D1*Ddd*f**3*s + 9860*C*D1*Ddd*f**3 + 108480*C*Dd**2*f**3*r*s - 27120*C*Dd**2*f**3*r + 118320*C*Dd**2*f**3*s**2 - 113400*C*Dd**2*f**3*s + 18080*C*Dd**2*f**3 + 4884*D1**2*K*bdd1*f**2*r*s + 5874*D1**2*K*bdd1*f**2*s**2 - 4884*D1**2*K*bdd1*f**2*s - 6336*D1**2*b2*f*fd*r*s + 3168*D1**2*b2*f*fd*r - 6336*D1**2*b2*f*fd*s**2 + 6336*D1**2*b2*f*fd*s - 3168*D1**2*b2*f*fd + 3960*D1**2*b2*f*fdd*r*s - 1980*D1**2*b2*f*fdd*r + 3960*D1**2*b2*f*fdd*s**2 - 3960*D1**2*b2*f*fdd*s + 1980*D1**2*b2*f*fdd + 3960*D1**2*b2*fd**2*r*s - 1980*D1**2*b2*fd**2*r + 3960*D1**2*b2*fd**2*s**2 - 3960*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*f*(-12*K*(2*r*s + r + 5*s**2 - 2*s - 1) + 5*f*(2*r + s**2 + 3*s - 2) - 24*r*(s - 1) + 6*s**2 + 30*s - 24) - 3168*D1**2*bd2*f**2*r*s - 3168*D1**2*bd2*f**2*s**2 + 3168*D1**2*bd2*f**2*s + 7920*D1**2*bd2*f*fd*r*s - 1980*D1**2*bd2*f*fd*r + 7920*D1**2*bd2*f*fd*s**2 - 7920*D1**2*bd2*f*fd*s + 1980*D1**2*bd2*f*fd - 1320*D1**2*bdd1*f**3*r*s - 660*D1**2*bdd1*f**3*r - 1815*D1**2*bdd1*f**3*s**2 + 1980*D1**2*bdd1*f**3*s - 1716*D1**2*bdd1*f**2*r*s + 2244*D1**2*bdd1*f**2*r - 297*D1**2*bdd1*f**2*s**2 + 1782*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 + 1584*D1**2*bdd1*f*g2*r*s + 1584*D1**2*bdd1*f*g2*r + 3960*D1**2*bdd1*f*g2*s**2 - 1584*D1**2*bdd1*f*g2*s + 792*D1**2*bdd1*f*g2 + 1980*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*s**2 - 1980*D1**2*bdd2*f**2*s + 21780*D1**2*f**2*fd*r*s - 7260*D1**2*f**2*fd*r + 24330*D1**2*f**2*fd*s**2 - 23480*D1**2*f**2*fd*s + 8110*D1**2*f**2*fd - 17820*D1**2*f**2*fdd*r*s + 5940*D1**2*f**2*fdd*r - 20085*D1**2*f**2*fdd*s**2 + 19330*D1**2*f**2*fdd*s - 6695*D1**2*f**2*fdd + 13200*D1**2*f**2*gd2*r*s + 15576*D1**2*f**2*gd2*s**2 - 13200*D1**2*f**2*gd2*s - 9768*D1**2*f**2*gdd2*r*s - 11748*D1**2*f**2*gdd2*s**2 + 9768*D1**2*f**2*gdd2*s - 35640*D1**2*f*fd**2*r*s + 11880*D1**2*f*fd**2*r - 40170*D1**2*f*fd**2*s**2 + 38660*D1**2*f*fd**2*s - 5940*D1**2*f*fd**2 + 26400*D1**2*f*fd*g2*r*s - 13200*D1**2*f*fd*g2*r + 31152*D1**2*f*fd*g2*s**2 - 31152*D1**2*f*fd*g2*s + 15576*D1**2*f*fd*g2 - 39072*D1**2*f*fd*gd2*r*s + 9768*D1**2*f*fd*gd2*r - 46992*D1**2*f*fd*gd2*s**2 + 43032*D1**2*f*fd*gd2*s - 9768*D1**2*f*fd*gd2 - 19536*D1**2*f*fdd*g2*r*s + 9768*D1**2*f*fdd*g2*r - 23496*D1**2*f*fdd*g2*s**2 + 23496*D1**2*f*fdd*g2*s - 11748*D1**2*f*fdd*g2 - 19536*D1**2*fd**2*g2*r*s + 9768*D1**2*fd**2*g2*r - 23496*D1**2*fd**2*g2*s**2 + 23496*D1**2*fd**2*g2*s - 12672*D1*Dd*b2*f**2*r*s + 3168*D1*Dd*b2*f**2*r - 12672*D1*Dd*b2*f**2*s**2 + 12672*D1*Dd*b2*f**2*s - 3168*D1*Dd*b2*f**2 + 31680*D1*Dd*b2*f*fd*r*s - 11880*D1*Dd*b2*f*fd*r + 31680*D1*Dd*b2*f*fd*s**2 - 31680*D1*Dd*b2*f*fd*s + 7920*D1*Dd*b2*f*fd + 15840*D1*Dd*bd2*f**2*r*s - 1980*D1*Dd*bd2*f**2*r + 15840*D1*Dd*bd2*f**2*s**2 - 15840*D1*Dd*bd2*f**2*s + 1980*D1*Dd*bd2*f**2 + 29040*D1*Dd*f**3*r*s - 7260*D1*Dd*f**3*r + 32440*D1*Dd*f**3*s**2 - 30740*D1*Dd*f**3*s + 8110*D1*Dd*f**3 - 142560*D1*Dd*f**2*fd*r*s + 41580*D1*Dd*f**2*fd*r - 160680*D1*Dd*f**2*fd*s**2 + 153130*D1*Dd*f**2*fd*s - 31210*D1*Dd*f**2*fd + 52800*D1*Dd*f**2*g2*r*s - 13200*D1*Dd*f**2*g2*r + 62304*D1*Dd*f**2*g2*s**2 - 57552*D1*Dd*f**2*g2*s + 15576*D1*Dd*f**2*g2 - 78144*D1*Dd*f**2*gd2*r*s + 9768*D1*Dd*f**2*gd2*r - 93984*D1*Dd*f**2*gd2*s**2 + 82104*D1*Dd*f**2*gd2*s - 9768*D1*Dd*f**2*gd2 - 156288*D1*Dd*f*fd*g2*r*s + 58608*D1*Dd*f*fd*g2*r - 187968*D1*Dd*f*fd*g2*s**2 + 180048*D1*Dd*f*fd*g2*s - 43032*D1*Dd*f*fd*g2 + 7920*D1*Ddd*b2*f**2*r*s - 1980*D1*Ddd*b2*f**2*r + 7920*D1*Ddd*b2*f**2*s**2 - 7920*D1*Ddd*b2*f**2*s + 1980*D1*Ddd*b2*f**2 - 23760*D1*Ddd*f**3*r*s + 5940*D1*Ddd*f**3*r - 26780*D1*Ddd*f**3*s**2 + 25270*D1*Ddd*f**3*s - 6695*D1*Ddd*f**3 - 39072*D1*Ddd*f**2*g2*r*s + 9768*D1*Ddd*f**2*g2*r - 46992*D1*Ddd*f**2*g2*s**2 + 43032*D1*Ddd*f**2*g2*s - 11748*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(5*f**3*(2*r*(s + 1) + s*(5*s - 4)) + f**2*(4*C*(8*r*s + 12*r + 25*s**2 - 10*s + 5) - 100*K*r*s - 118*K*s**2 + 100*K*s - 5*fd*(24*r*s + 33*s**2 - 31*s + 2) + 16*r*s - 68*r - 27*s**2 - 18*s + 5) - 2*f*(fd*(4*C*(8*r*s + r + 25*s**2 - 17*s - 3) + K*(-148*r*s + 37*r - 178*s**2 + 163*s - 37) + 52*r*s - 30*r + 9*s**2 - 31*s + 28) + 12*g2*(2*r*(s + 1) + 5*s**2 - 2*s + 1) - 12*gd2*(2*r*s + r + 5*s**2 - 2*s - 1)) + 24*fd*g2*(r*(2*s - 1) + s*(5*s - 5))) - Dd*f*(5*f**2*(4*r*(8*s + 1) + 44*s**2 - 43*s + 2) + f*(4*C*(4*r*(8*s + 5) + 100*s**2 - 53*s - 7) + K*(-592*r*s + 74*r - 712*s**2 + 622*s - 74) + 208*r*s - 162*r + 36*s**2 - 169*s + 95) - 24*g2*(r*(8*s + 3) + 20*s**2 - 11*s - 1))) + 23760*Dd**2*b2*f**2*r*s - 5940*Dd**2*b2*f**2*r + 23760*Dd**2*b2*f**2*s**2 - 23760*Dd**2*b2*f**2*s + 3960*Dd**2*b2*f**2 - 71280*Dd**2*f**3*r*s + 17820*Dd**2*f**3*r - 80340*Dd**2*f**3*s**2 + 75810*Dd**2*f**3*s - 11880*Dd**2*f**3 - 117216*Dd**2*f**2*g2*r*s + 29304*Dd**2*f**2*g2*r - 140976*Dd**2*f**2*g2*s**2 + 129096*Dd**2*f**2*g2*s - 19536*Dd**2*f**2*g2 + 33*b1**2*(-2*D1**2*(-10*f*fd*(2*r - s**2 + 4*s - 2) + 5*f*fdd*(2*r - s**2 + 4*s - 2) + 5*fd**2*(2*r - s**2 + 4*s - 2) - 6*fd*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4) + 3*fdd*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4)) - 2*D1*Dd*(5*f**2*(4*s**2 - 2*s + 1) + 2*f*(-6*K*(8*r*s - 2*r + 20*s**2 - 14*s + 5) + 5*fd*(4*r - 4*s**2 + 9*s - 4) - 48*r*s + 12*r + 12*s**2 + 18*s + 3) + 6*fd*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8)) + D1*Ddd*f*(-12*K*(8*r*s - 2*r + 20*s**2 - 14*s + 5) + 5*f*(4*s**2 - 2*s + 1) - 96*r*s + 24*r + 24*s**2 + 36*s + 6) + 6*Dd**2*f*(-4*K*(3*r*(4*s - 1) + 30*s**2 - 21*s + 2) + 10*f*s**2 - 5*f*s + r*(12 - 48*s) + 12*s**2 + 18*s - 8)) - 33*b1*(-128*C*D1**2*f*fd*r*s + 160*C*D1**2*f*fd*r - 400*C*D1**2*f*fd*s**2 + 384*C*D1**2*f*fd*s - 160*C*D1**2*f*fd + 64*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 200*C*D1**2*f*fdd*s**2 - 192*C*D1**2*f*fdd*s + 80*C*D1**2*f*fdd + 64*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 200*C*D1**2*fd**2*s**2 - 192*C*D1**2*fd**2*s + 80*C*D1**2*fd**2 - 256*C*D1*Dd*f**2*r*s + 64*C*D1*Dd*f**2*r - 800*C*D1*Dd*f**2*s**2 + 528*C*D1*Dd*f**2*s - 200*C*D1*Dd*f**2 + 512*C*D1*Dd*f*fd*r*s - 384*C*D1*Dd*f*fd*r + 1600*C*D1*Dd*f*fd*s**2 - 1296*C*D1*Dd*f*fd*s + 352*C*D1*Dd*f*fd + 128*C*D1*Ddd*f**2*r*s - 32*C*D1*Ddd*f**2*r + 400*C*D1*Ddd*f**2*s**2 - 264*C*D1*Ddd*f**2*s + 100*C*D1*Ddd*f**2 + 384*C*Dd**2*f**2*r*s - 96*C*Dd**2*f**2*r + 1200*C*Dd**2*f**2*s**2 - 792*C*Dd**2*f**2*s + 64*C*Dd**2*f**2 + 400*D1**2*K*f*fd*r*s - 200*D1**2*K*f*fd*r + 472*D1**2*K*f*fd*s**2 - 472*D1**2*K*f*fd*s + 236*D1**2*K*f*fd - 296*D1**2*K*f*fdd*r*s + 148*D1**2*K*f*fdd*r - 356*D1**2*K*f*fdd*s**2 + 356*D1**2*K*f*fdd*s - 178*D1**2*K*f*fdd - 296*D1**2*K*fd**2*r*s + 148*D1**2*K*fd**2*r - 356*D1**2*K*fd**2*s**2 + 356*D1**2*K*fd**2*s + D1**2*bdd1*f*(6*K*(r*(8*s + 4) + 20*s**2 - 8*s + 2) - 5*f*(4*r + 2*s**2 + 6*s - 3) + 48*r*(s - 1) - 12*s**2 - 60*s + 18) - 60*D1**2*f**2*fd*r*s + 40*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 120*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 130*D1**2*f**2*fdd*s + 55*D1**2*f**2*fdd + 240*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 260*D1**2*f*fd**2*s + 60*D1**2*f*fd**2 - 64*D1**2*f*fd*r*s - 104*D1**2*f*fd*r + 108*D1**2*f*fd*s**2 - 112*D1**2*f*fd*s + 64*D1**2*f*fd + 104*D1**2*f*fdd*r*s + 16*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 16*D1**2*f*fdd*s + 4*D1**2*f*fdd + 96*D1**2*f*gd2*r*s + 240*D1**2*f*gd2*s**2 - 96*D1**2*f*gd2*s - 48*D1**2*f*gdd2*r*s - 120*D1**2*f*gdd2*s**2 + 48*D1**2*f*gdd2*s + 104*D1**2*fd**2*r*s + 16*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 16*D1**2*fd**2*s - 60*D1**2*fd**2 + 96*D1**2*fd*g2*r*s - 192*D1**2*fd*g2*r + 240*D1**2*fd*g2*s**2 - 384*D1**2*fd*g2*s + 192*D1**2*fd*g2 - 96*D1**2*fd*gd2*r*s + 96*D1**2*fd*gd2*r - 240*D1**2*fd*gd2*s**2 + 240*D1**2*fd*gd2*s - 96*D1**2*fd*gd2 - 48*D1**2*fdd*g2*r*s + 96*D1**2*fdd*g2*r - 120*D1**2*fdd*g2*s**2 + 192*D1**2*fdd*g2*s - 96*D1**2*fdd*g2 + 800*D1*Dd*K*f**2*r*s - 200*D1*Dd*K*f**2*r + 944*D1*Dd*K*f**2*s**2 - 872*D1*Dd*K*f**2*s + 236*D1*Dd*K*f**2 - 2368*D1*Dd*K*f*fd*r*s + 888*D1*Dd*K*f*fd*r - 2848*D1*Dd*K*f*fd*s**2 + 2728*D1*Dd*K*f*fd*s - 652*D1*Dd*K*f*fd - 80*D1*Dd*f**3*r*s + 20*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 140*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 960*D1*Dd*f**2*fd*r*s - 360*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1090*D1*Dd*f**2*fd*s + 250*D1*Dd*f**2*fd - 128*D1*Dd*f**2*r*s + 32*D1*Dd*f**2*r + 216*D1*Dd*f**2*s**2 - 44*D1*Dd*f**2*s + 54*D1*Dd*f**2 + 832*D1*Dd*f*fd*r*s - 40*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 308*D1*Dd*f*fd*s - 16*D1*Dd*f*fd + 384*D1*Dd*f*g2*r*s - 96*D1*Dd*f*g2*r + 960*D1*Dd*f*g2*s**2 - 672*D1*Dd*f*g2*s + 240*D1*Dd*f*g2 - 384*D1*Dd*f*gd2*r*s + 48*D1*Dd*f*gd2*r - 960*D1*Dd*f*gd2*s**2 + 528*D1*Dd*f*gd2*s - 48*D1*Dd*f*gd2 - 384*D1*Dd*fd*g2*r*s + 432*D1*Dd*fd*g2*r - 960*D1*Dd*fd*g2*s**2 + 1104*D1*Dd*fd*g2*s - 384*D1*Dd*fd*g2 - 592*D1*Ddd*K*f**2*r*s + 148*D1*Ddd*K*f**2*r - 712*D1*Ddd*K*f**2*s**2 + 652*D1*Ddd*K*f**2*s - 178*D1*Ddd*K*f**2 + 160*D1*Ddd*f**3*r*s - 40*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 190*D1*Ddd*f**3*s + 55*D1*Ddd*f**3 + 208*D1*Ddd*f**2*r*s - 52*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 122*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 - 192*D1*Ddd*f*g2*r*s + 48*D1*Ddd*f*g2*r - 480*D1*Ddd*f*g2*s**2 + 336*D1*Ddd*f*g2*s - 120*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*f**2*(4*r + 2*s**2 + 6*s - 3) - 2*f*(6*K*(r*(4*s + 2) + 10*s**2 - 4*s + 1) + 10*fd*s**2 - 5*fd*s + 24*r*(s - 1) - 6*s**2 - 30*s + 9) + 6*fd*(K*(8*r*s - 6*r + 20*s**2 - 20*s + 4) - 2*s**2 + s*(8*r + 3) - 2)) + Dd*f*(-5*f*(8*r + 8*s**2 + 10*s - 7) + 24*r*(8*K*s + K + 8*s - 5) + 6*s**2*(80*K - 8) - 6*s*(44*K + 26) + 78)) - 1776*Dd**2*K*f**2*r*s + 444*Dd**2*K*f**2*r - 2136*Dd**2*K*f**2*s**2 + 1956*Dd**2*K*f**2*s - 296*Dd**2*K*f**2 + 480*Dd**2*f**3*r*s - 120*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 570*Dd**2*f**3*s + 80*Dd**2*f**3 + 624*Dd**2*f**2*r*s - 156*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 366*Dd**2*f**2*s + 104*Dd**2*f**2 - 576*Dd**2*f*g2*r*s + 144*Dd**2*f*g2*r - 1440*Dd**2*f*g2*s**2 + 1008*Dd**2*f*g2*s - 96*Dd**2*f*g2))/(693*d**2*k3**4) + 15*D1**2*Pk3*Pkd2*ct**5*k1*st**2*(b1*(D1**2*(35*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-70*fd**2*s*(3*s - 2) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(35*f**2*(4*s**2 - 2*s + 1) - 35*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(35*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(35*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(70*bd1 - 35*bdd1) + f*(-10*fd*(s**2*(21*bd1 - 15) + s*(10 - 7*bd1) - 5) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(-10*Dd*f*(s**2*(28*bd1 - 20) + s*(10 - 7*bd1) - 5) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**5*k1*(1584*C*D1**2*bdd1*f**2*r*s - 3300*C*D1**2*bdd1*f**2*s**2 - 16800*C*D1**2*f**2*fd*s**2 + 11200*C*D1**2*f**2*fd*s - 5600*C*D1**2*f**2*fd + 8400*C*D1**2*f**2*fdd*s**2 - 5600*C*D1**2*f**2*fdd*s + 2800*C*D1**2*f**2*fdd + 16800*C*D1**2*f*fd**2*s**2 - 11200*C*D1**2*f*fd**2*s - 22400*C*D1*Dd*f**3*s**2 + 11200*C*D1*Dd*f**3*s - 5600*C*D1*Dd*f**3 + 67200*C*D1*Dd*f**2*fd*s**2 - 39200*C*D1*Dd*f**2*fd*s + 5600*C*D1*Dd*f**2*fd + 11200*C*D1*Ddd*f**3*s**2 - 5600*C*D1*Ddd*f**3*s + 2800*C*D1*Ddd*f**3 + 33600*C*Dd**2*f**3*s**2 - 16800*C*Dd**2*f**3*s + 1650*D1**2*K*bdd1*f**2*s**2 - 6600*D1**2*b2*f*fd*s**2 + 6600*D1**2*b2*f*fd*s - 3300*D1**2*b2*f*fd + 3300*D1**2*b2*f*fdd*s**2 - 3300*D1**2*b2*f*fdd*s + 1650*D1**2*b2*f*fdd + 3300*D1**2*b2*fd**2*s**2 - 3300*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*f*s*(12*K*(2*r - 5*s - 1) + 25*f - 24*r + 42) - 3300*D1**2*bd2*f**2*s**2 + 6600*D1**2*bd2*f*fd*s**2 - 3300*D1**2*bd2*f*fd*s + 1980*D1**2*bdd1*f**3*r*s + 1815*D1**2*bdd1*f**3*s**2 - 1320*D1**2*bdd1*f**3*s - 132*D1**2*bdd1*f**2*r*s + 3762*D1**2*bdd1*f**2*s**2 + 198*D1**2*bdd1*f**2*s - 825*D1**2*bdd1*f**2 - 1584*D1**2*bdd1*f*g2*r*s + 3960*D1**2*bdd1*f*g2*s**2 + 1650*D1**2*bdd2*f**2*s**2 - 6540*D1**2*f**2*fd*r*s + 2180*D1**2*f**2*fd*r - 210*D1**2*f**2*fd*s**2 + 2320*D1**2*f**2*fd*s - 70*D1**2*f**2*fd + 4260*D1**2*f**2*fdd*r*s - 1420*D1**2*f**2*fdd*r + 1095*D1**2*f**2*fdd*s**2 - 2150*D1**2*f**2*fdd*s + 365*D1**2*f**2*fdd + 6600*D1**2*f**2*gd2*s**2 - 3300*D1**2*f**2*gdd2*s**2 + 8520*D1**2*f*fd**2*r*s - 2840*D1**2*f*fd**2*r + 2190*D1**2*f*fd**2*s**2 - 4300*D1**2*f*fd**2*s + 1420*D1**2*f*fd**2 + 13200*D1**2*f*fd*g2*s**2 - 13200*D1**2*f*fd*g2*s + 6600*D1**2*f*fd*g2 - 13200*D1**2*f*fd*gd2*s**2 + 6600*D1**2*f*fd*gd2*s - 6600*D1**2*f*fdd*g2*s**2 + 6600*D1**2*f*fdd*g2*s - 3300*D1**2*f*fdd*g2 - 6600*D1**2*fd**2*g2*s**2 + 6600*D1**2*fd**2*g2*s - 13200*D1*Dd*b2*f**2*s**2 + 6600*D1*Dd*b2*f**2*s - 3300*D1*Dd*b2*f**2 + 26400*D1*Dd*b2*f*fd*s**2 - 19800*D1*Dd*b2*f*fd*s + 3300*D1*Dd*b2*f*fd + 13200*D1*Dd*bd2*f**2*s**2 - 3300*D1*Dd*bd2*f**2*s - 8720*D1*Dd*f**3*r*s + 2180*D1*Dd*f**3*r - 280*D1*Dd*f**3*s**2 + 4500*D1*Dd*f**3*s - 70*D1*Dd*f**3 + 34080*D1*Dd*f**2*fd*r*s - 9940*D1*Dd*f**2*fd*r + 8760*D1*Dd*f**2*fd*s**2 - 19310*D1*Dd*f**2*fd*s + 4990*D1*Dd*f**2*fd + 26400*D1*Dd*f**2*g2*s**2 - 13200*D1*Dd*f**2*g2*s + 6600*D1*Dd*f**2*g2 - 26400*D1*Dd*f**2*gd2*s**2 + 6600*D1*Dd*f**2*gd2*s - 52800*D1*Dd*f*fd*g2*s**2 + 39600*D1*Dd*f*fd*g2*s - 6600*D1*Dd*f*fd*g2 + 6600*D1*Ddd*b2*f**2*s**2 - 3300*D1*Ddd*b2*f**2*s + 1650*D1*Ddd*b2*f**2 + 5680*D1*Ddd*f**3*r*s - 1420*D1*Ddd*f**3*r + 1460*D1*Ddd*f**3*s**2 - 3570*D1*Ddd*f**3*s + 365*D1*Ddd*f**3 - 13200*D1*Ddd*f**2*g2*s**2 + 6600*D1*Ddd*f**2*g2*s - 3300*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(5*f**3*s*(6*r + 9*s - 4) + f**2*(-5*fd*(6*r*(6*s - 1) + 33*s**2 - 31*s + 4) + s**2*(-100*C + 50*K + 102) + s*(48*C*r - 16*r + 18) - 25) - f*(fd*(r*(24*C - 2)*(4*s - 1) - s**2*(200*C - 100*K - 228) + s*(76*C - 50*K - 109) + 22) + 24*s*(2*g2*r - 5*g2*s - 2*gd2*r + 5*gd2*s + gd2)) - 24*fd*g2*(-2*r*s + r + s*(5*s - 5))) + Dd*f*(-5*f**2*(6*r*(8*s - 1) + 44*s**2 - 39*s + 4) + f*(-r*(24*C - 2)*(8*s - 1) + s**2*(400*C - 200*K - 456) + s*(-52*C + 50*K + 98) + 3) - 24*g2*(-8*r*s + r + s*(20*s - 3)))) + 19800*Dd**2*b2*f**2*s**2 - 9900*Dd**2*b2*f**2*s + 17040*Dd**2*f**3*r*s - 4260*Dd**2*f**3*r + 4380*Dd**2*f**3*s**2 - 10710*Dd**2*f**3*s + 2840*Dd**2*f**3 - 39600*Dd**2*f**2*g2*s**2 + 19800*Dd**2*f**2*g2*s + 33*b1**2*(-2*D1*Dd*(12*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s) + fd*(6*K*(2*r*(5 - 8*s) + 40*s**2 - 46*s + 6) + 25*f*(4*s - 1) + 96*r*s - 60*r + 96*s - 6)) + D1*(D1*(50*f*fd*(2*s - 1) + f*fdd*(25 - 50*s) - 50*fd**2*s - 12*fd*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + 6*fdd*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5)) + 12*Ddd*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s)) + 24*Dd**2*f*(K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) - 12*r*s + 3*r + 6*s - 2)) - 33*b1*(192*C*D1**2*f*fd*r*s - 96*C*D1**2*f*fd*r - 400*C*D1**2*f*fd*s**2 + 304*C*D1**2*f*fd*s - 200*C*D1**2*f*fd - 96*C*D1**2*f*fdd*r*s + 48*C*D1**2*f*fdd*r + 200*C*D1**2*f*fdd*s**2 - 152*C*D1**2*f*fdd*s + 100*C*D1**2*f*fdd - 96*C*D1**2*fd**2*r*s + 48*C*D1**2*fd**2*r + 200*C*D1**2*fd**2*s**2 - 152*C*D1**2*fd**2*s - 48*C*D1**2*fd**2 + 384*C*D1*Dd*f**2*r*s - 96*C*D1*Dd*f**2*r - 800*C*D1*Dd*f**2*s**2 + 208*C*D1*Dd*f**2*s - 200*C*D1*Dd*f**2 - 768*C*D1*Dd*f*fd*r*s + 288*C*D1*Dd*f*fd*r + 1600*C*D1*Dd*f*fd*s**2 - 816*C*D1*Dd*f*fd*s + 56*C*D1*Dd*f*fd - 192*C*D1*Ddd*f**2*r*s + 48*C*D1*Ddd*f**2*r + 400*C*D1*Ddd*f**2*s**2 - 104*C*D1*Ddd*f**2*s + 100*C*D1*Ddd*f**2 - 576*C*Dd**2*f**2*r*s + 144*C*Dd**2*f**2*r + 1200*C*Dd**2*f**2*s**2 - 312*C*Dd**2*f**2*s - 96*C*Dd**2*f**2 + 200*D1**2*K*f*fd*s**2 - 200*D1**2*K*f*fd*s + 100*D1**2*K*f*fd - 100*D1**2*K*f*fdd*s**2 + 100*D1**2*K*f*fdd*s - 50*D1**2*K*f*fdd - 100*D1**2*K*fd**2*s**2 + 100*D1**2*K*fd**2*s + D1**2*bdd1*f*(120*K*s**2 + f*(25 - 50*s) + 6*s*(-8*K*r + 4*K + 8*r - 14) + 30) + 180*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 270*D1**2*f**2*fd*s**2 - 260*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 165*D1**2*f**2*fdd*s**2 + 190*D1**2*f**2*fdd*s - 55*D1**2*f**2*fdd - 360*D1**2*f*fd**2*r*s + 120*D1**2*f*fd**2*r - 330*D1**2*f*fd**2*s**2 + 380*D1**2*f*fd**2*s - 80*D1**2*f*fd**2 - 64*D1**2*f*fd*r*s + 32*D1**2*f*fd*r + 408*D1**2*f*fd*s**2 - 412*D1**2*f*fd*s + 254*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r - 228*D1**2*f*fdd*s**2 + 230*D1**2*f*fdd*s - 139*D1**2*f*fdd - 96*D1**2*f*gd2*r*s + 240*D1**2*f*gd2*s**2 + 96*D1**2*f*gd2*s + 48*D1**2*f*gdd2*r*s - 120*D1**2*f*gdd2*s**2 - 48*D1**2*f*gdd2*s + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r - 228*D1**2*fd**2*s**2 + 230*D1**2*fd**2*s + 48*D1**2*fd**2 - 96*D1**2*fd*g2*r*s + 96*D1**2*fd*g2*r + 240*D1**2*fd*g2*s**2 - 480*D1**2*fd*g2*s + 240*D1**2*fd*g2 + 96*D1**2*fd*gd2*r*s - 48*D1**2*fd*gd2*r - 240*D1**2*fd*gd2*s**2 + 192*D1**2*fd*gd2*s + 48*D1**2*fd*gd2 + 48*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*r - 120*D1**2*fdd*g2*s**2 + 240*D1**2*fdd*g2*s - 120*D1**2*fdd*g2 + 400*D1*Dd*K*f**2*s**2 - 200*D1*Dd*K*f**2*s + 100*D1*Dd*K*f**2 - 800*D1*Dd*K*f*fd*s**2 + 600*D1*Dd*K*f*fd*s - 100*D1*Dd*K*f*fd + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 360*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r*s + 420*D1*Dd*f**2*fd*r - 1320*D1*Dd*f**2*fd*s**2 + 1450*D1*Dd*f**2*fd*s - 310*D1*Dd*f**2*fd - 128*D1*Dd*f**2*r*s + 32*D1*Dd*f**2*r + 816*D1*Dd*f**2*s**2 - 344*D1*Dd*f**2*s + 204*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r - 1824*D1*Dd*f*fd*s**2 + 1360*D1*Dd*f*fd*s - 222*D1*Dd*f*fd - 384*D1*Dd*f*g2*r*s + 96*D1*Dd*f*g2*r + 960*D1*Dd*f*g2*s**2 - 288*D1*Dd*f*g2*s + 240*D1*Dd*f*g2 + 384*D1*Dd*f*gd2*r*s - 48*D1*Dd*f*gd2*r - 960*D1*Dd*f*gd2*s**2 - 48*D1*Dd*f*gd2*s + 48*D1*Dd*f*gd2 + 384*D1*Dd*fd*g2*r*s - 240*D1*Dd*fd*g2*r - 960*D1*Dd*fd*g2*s**2 + 1104*D1*Dd*fd*g2*s - 144*D1*Dd*fd*g2 - 200*D1*Ddd*K*f**2*s**2 + 100*D1*Ddd*K*f**2*s - 50*D1*Ddd*K*f**2 - 240*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 220*D1*Ddd*f**3*s**2 + 230*D1*Ddd*f**3*s - 55*D1*Ddd*f**3 + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r - 456*D1*Ddd*f**2*s**2 + 220*D1*Ddd*f**2*s - 114*D1*Ddd*f**2 + 192*D1*Ddd*f*g2*r*s - 48*D1*Ddd*f*g2*r - 480*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 120*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(25*f**2*(2*s - 1) - 6*f*(20*K*s**2 + s*(-8*K*r + 4*K + 8*r - 14) + 5) - 6*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) - 8*r*s + 4*r - 3*s - 2)) + Dd*f*(-6*K*(32*r*s - 4*r - 80*s**2 + 4*s + 2) - 25*f*(4*s - 1) + 192*r*s - 24*r - 216*s + 42)) - 600*Dd**2*K*f**2*s**2 + 300*Dd**2*K*f**2*s - 720*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 660*Dd**2*f**3*s**2 + 690*Dd**2*f**3*s - 120*Dd**2*f**3 + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r - 1368*Dd**2*f**2*s**2 + 660*Dd**2*f**2*s + 8*Dd**2*f**2 + 576*Dd**2*f*g2*r*s - 144*Dd**2*f*g2*r - 1440*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s + 96*Dd**2*f*g2))/(693*d**2*k3**2) + 3*D1**2*Pk3*Pkd2*ct**5*k1*(-D1*f*s*(2*D1*bd1**2*s*(5*f + 6) + 5*D1*bdd1*f*s + 10*bd1*(-D1*(f*s - 2*fd*s + fd) + Dd*f*(4*s - 1))) + b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 12*fd*(s - 1)**2 - 6*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 6*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 6)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 6)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) + f*(-10*fd*(s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) - 5*fdd*(2*s**2 - 2*s + 1) + s**2*(24*bd1 - 12*bdd1)) - 2*fd*s*(12*bd1 + 5*fd)*(s - 1)) + D1*f*(-2*Dd*(5*f*(s**2*(8*bd1 - 4) - s*(2*bd1 - 2) - 1) + (4*s - 1)*(12*bd1*s + 5*fd*(2*s - 1))) - 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k2**2) + 40*D1**2*Pk3*Pkd2*ct**4*f**2*k1**6*(D1**2*(f*(38*fd - 45*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 45*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(38*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 90*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) - 45*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 45*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1287*d**2*k2*k3**6) + 80*D1**2*Pk3*Pkd2*ct**4*f*k1**2*k2**3*st**4*(D1**2*(70*f**2*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-70*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + fd*(78*C - 78)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(39*C - 39)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(39*C - 39)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(140*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(78*C*(r*(4*s - 1) + (1 - 2*s)**2) - 140*fd*(4*s - 1)*(4*r + 4*s - 3) - 78*r*(4*s - 1) - 78*(1 - 2*s)**2) - fd*(39*C - 39)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(39*C + 70*f - 39)) - Dd**2*f**2*(39*C + 70*f - 39)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k3**6) + 30*D1**2*Pk3*Pkd2*ct**4*f*k1**2*k2*st**4*(D1**2*(70*f**2*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 420*f*fd**2*s*(2*s - 1) + f*fd*(78*C - 78)*(3*s**2 - 2*s + 1) - f*fdd*(39*C - 39)*(3*s**2 - 2*s + 1) - fd**2*s*(78*C - 78)*(3*s - 2)) + D1*f*(2*Dd*(70*f**2*(4*s**2 - 2*s + 1) + f*(39*C*(4*s**2 - 2*s + 1) - 70*fd*(1 - 4*s)**2 - 156*s**2 + 78*s - 39) - fd*(39*C - 39)*(12*s**2 - 7*s + 1)) - Ddd*f*(39*C + 70*f - 39)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(39*C + 70*f - 39))/(1001*d**2*k3**4) + 8*D1**2*Pk3*Pkd2*ct**4*k1**4*k2*st**2*(9126*C*D1**2*f**2*fd*r*s - 3042*C*D1**2*f**2*fd*r + 9126*C*D1**2*f**2*fd*s**2 - 9126*C*D1**2*f**2*fd*s + 3042*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 12168*C*D1*Dd*f**3*r*s - 3042*C*D1*Dd*f**3*r + 12168*C*D1*Dd*f**3*s**2 - 12168*C*D1*Dd*f**3*s + 3042*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 22900*D1**2*f**3*fd*r*s - 5725*D1**2*f**3*fd*r + 22900*D1**2*f**3*fd*s**2 - 22900*D1**2*f**3*fd*s + 5725*D1**2*f**3*fd - 14700*D1**2*f**3*fdd*r*s + 3675*D1**2*f**3*fdd*r - 14700*D1**2*f**3*fdd*s**2 + 14700*D1**2*f**3*fdd*s - 3675*D1**2*f**3*fdd - 44100*D1**2*f**2*fd**2*r*s + 11025*D1**2*f**2*fd**2*r - 44100*D1**2*f**2*fd**2*s**2 + 44100*D1**2*f**2*fd**2*s - 7350*D1**2*f**2*fd**2 - 9126*D1**2*f**2*fd*r*s + 3042*D1**2*f**2*fd*r - 9126*D1**2*f**2*fd*s**2 + 9126*D1**2*f**2*fd*s - 3042*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*s**2 + 4290*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 8580*D1**2*f*fd*g2*r*s + 4290*D1**2*f*fd*g2*r - 8580*D1**2*f*fd*g2*s**2 + 8580*D1**2*f*fd*g2*s - 4290*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 22900*D1*Dd*f**4*r*s - 5725*D1*Dd*f**4*r + 22900*D1*Dd*f**4*s**2 - 22900*D1*Dd*f**4*s + 5725*D1*Dd*f**4 - 117600*D1*Dd*f**3*fd*r*s + 29400*D1*Dd*f**3*fd*r - 117600*D1*Dd*f**3*fd*s**2 + 117600*D1*Dd*f**3*fd*s - 22050*D1*Dd*f**3*fd - 12168*D1*Dd*f**3*r*s + 3042*D1*Dd*f**3*r - 12168*D1*Dd*f**3*s**2 + 12168*D1*Dd*f**3*s - 3042*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 17160*D1*Dd*f**2*g2*r*s + 4290*D1*Dd*f**2*g2*r - 17160*D1*Dd*f**2*g2*s**2 + 17160*D1*Dd*f**2*g2*s - 4290*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 14700*D1*Ddd*f**4*r*s + 3675*D1*Ddd*f**4*r - 14700*D1*Ddd*f**4*s**2 + 14700*D1*Ddd*f**4*s - 3675*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 44100*Dd**2*f**4*r*s + 11025*Dd**2*f**4*r - 44100*Dd**2*f**4*s**2 + 44100*Dd**2*f**4*s - 7350*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**6) - 8*D1**2*Pk3*Pkd2*ct**4*k1**4*k2*(990*C*D1**2*bdd1*f**2*r*s - 990*C*D1**2*bdd1*f**2*r + 990*C*D1**2*bdd1*f**2*s**2 - 1980*C*D1**2*bdd1*f**2*s + 990*C*D1**2*bdd1*f**2 - 390*C*D1**2*f**2*fd*r*s + 130*C*D1**2*f**2*fd*r - 390*C*D1**2*f**2*fd*s**2 + 390*C*D1**2*f**2*fd*s - 130*C*D1**2*f**2*fd + 1680*C*D1**2*f**2*fdd*r*s - 560*C*D1**2*f**2*fdd*r + 1680*C*D1**2*f**2*fdd*s**2 - 1680*C*D1**2*f**2*fdd*s + 560*C*D1**2*f**2*fdd + 3360*C*D1**2*f*fd**2*r*s - 1120*C*D1**2*f*fd**2*r + 3360*C*D1**2*f*fd**2*s**2 - 3360*C*D1**2*f*fd**2*s + 560*C*D1**2*f*fd**2 - 520*C*D1*Dd*f**3*r*s + 130*C*D1*Dd*f**3*r - 520*C*D1*Dd*f**3*s**2 + 520*C*D1*Dd*f**3*s - 130*C*D1*Dd*f**3 + 13440*C*D1*Dd*f**2*fd*r*s - 3920*C*D1*Dd*f**2*fd*r + 13440*C*D1*Dd*f**2*fd*s**2 - 13440*C*D1*Dd*f**2*fd*s + 2800*C*D1*Dd*f**2*fd + 2240*C*D1*Ddd*f**3*r*s - 560*C*D1*Ddd*f**3*r + 2240*C*D1*Ddd*f**3*s**2 - 2240*C*D1*Ddd*f**3*s + 560*C*D1*Ddd*f**3 + 6720*C*Dd**2*f**3*r*s - 1680*C*Dd**2*f**3*r + 6720*C*Dd**2*f**3*s**2 - 6720*C*Dd**2*f**3*s + 1120*C*Dd**2*f**3 + 330*D1**2*K*bdd1*f**2*r*s + 330*D1**2*K*bdd1*f**2*s**2 - 330*D1**2*K*bdd1*f**2*s + 594*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 280*D1**2*bdd1*f**3*r*s - 840*D1**2*bdd1*f**3*r + 280*D1**2*bdd1*f**3*s**2 - 1120*D1**2*bdd1*f**3*s + 840*D1**2*bdd1*f**3 - 1155*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*r - 1155*D1**2*bdd1*f**2*s**2 + 2145*D1**2*bdd1*f**2*s - 990*D1**2*bdd1*f**2 - 1188*D1**2*bdd1*f*g2*r*s + 1188*D1**2*bdd1*f*g2*r - 1188*D1**2*bdd1*f*g2*s**2 + 2376*D1**2*bdd1*f*g2*s - 1188*D1**2*bdd1*f*g2 + 1680*D1**2*f**3*fd*r*s - 420*D1**2*f**3*fd*r + 1680*D1**2*f**3*fd*s**2 - 1680*D1**2*f**3*fd*s + 420*D1**2*f**3*fd + 45*D1**2*f**2*fd*r*s - 15*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s**2 - 45*D1**2*f**2*fd*s + 15*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r - 1260*D1**2*f**2*fdd*s**2 + 1260*D1**2*f**2*fdd*s - 420*D1**2*f**2*fdd + 132*D1**2*f**2*gd2*r*s + 132*D1**2*f**2*gd2*s**2 - 132*D1**2*f**2*gd2*s - 660*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*s**2 + 660*D1**2*f**2*gdd2*s - 2520*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r - 2520*D1**2*f*fd**2*s**2 + 2520*D1**2*f*fd**2*s - 420*D1**2*f*fd**2 + 264*D1**2*f*fd*g2*r*s - 132*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r*s + 660*D1**2*f*fd*gd2*r - 2640*D1**2*f*fd*gd2*s**2 + 2640*D1**2*f*fd*gd2*s - 660*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r*s + 660*D1**2*f*fdd*g2*r - 1320*D1**2*f*fdd*g2*s**2 + 1320*D1**2*f*fdd*g2*s - 660*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r*s + 660*D1**2*fd**2*g2*r - 1320*D1**2*fd**2*g2*s**2 + 1320*D1**2*fd**2*g2*s + 1680*D1*Dd*f**4*r*s - 420*D1*Dd*f**4*r + 1680*D1*Dd*f**4*s**2 - 1680*D1*Dd*f**4*s + 420*D1*Dd*f**4 + 60*D1*Dd*f**3*r*s - 15*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 15*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r*s + 2940*D1*Dd*f**2*fd*r - 10080*D1*Dd*f**2*fd*s**2 + 10080*D1*Dd*f**2*fd*s - 2100*D1*Dd*f**2*fd + 528*D1*Dd*f**2*g2*r*s - 132*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 - 528*D1*Dd*f**2*g2*s + 132*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r*s + 660*D1*Dd*f**2*gd2*r - 5280*D1*Dd*f**2*gd2*s**2 + 5280*D1*Dd*f**2*gd2*s - 660*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r*s + 3960*D1*Dd*f*fd*g2*r - 10560*D1*Dd*f*fd*g2*s**2 + 10560*D1*Dd*f*fd*g2*s - 2640*D1*Dd*f*fd*g2 - 1680*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 1680*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r*s + 660*D1*Ddd*f**2*g2*r - 2640*D1*Ddd*f**2*g2*s**2 + 2640*D1*Ddd*f**2*g2*s - 660*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(112*s - 237)*(r + s - 1) - 2*f**2*(594*C*(s - 1)*(r + s - 1) - 140*fd*(r*(6*s - 7) + 6*s**2 - 12*s + 4) + (s*(K - 17) + 18)*(33*r + 33*s - 33)) + 33*f*(5*fd*(6*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 28*r*s + 13*r - 28*s**2 + 34*s - 7) + (44*g2*(s - 1) + 36*gd2*(1 - 2*s))*(r + s - 1)) - 1188*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(280*f**2*(r*(8*s - 13) + 8*s**2 - 20*s + 10) + 165*f*(6*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 56*r*s + 31*r - 56*s**2 + 80*s - 25) - 1188*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 5040*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 5040*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 840*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r*s + 1980*Dd**2*f**2*g2*r - 7920*Dd**2*f**2*g2*s**2 + 7920*Dd**2*f**2*g2*s - 1320*Dd**2*f**2*g2 - 66*b1**2*(K - 1)*(D1**2*s*(11*fd - 9*fdd)*(r + s) + D1*Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(-8*r*s + r + s*(4 - 8*s))) - 9*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-2376*C*D1**2*f*fd*r*s - 2376*C*D1**2*f*fd*s**2 + 1188*C*D1**2*f*fd*s + 1980*C*D1**2*f*fdd*r*s + 1980*C*D1**2*f*fdd*s**2 - 990*C*D1**2*f*fdd*s + 1980*C*D1**2*fd**2*r*s + 1980*C*D1**2*fd**2*s**2 - 990*C*D1**2*fd**2*s - 4752*C*D1*Dd*f**2*r*s + 1188*C*D1*Dd*f**2*r - 4752*C*D1*Dd*f**2*s**2 + 4752*C*D1*Dd*f**2*s - 1188*C*D1*Dd*f**2 + 15840*C*D1*Dd*f*fd*r*s - 1980*C*D1*Dd*f*fd*r + 15840*C*D1*Dd*f*fd*s**2 - 11880*C*D1*Dd*f*fd*s + 990*C*D1*Dd*f*fd + 3960*C*D1*Ddd*f**2*r*s - 990*C*D1*Ddd*f**2*r + 3960*C*D1*Ddd*f**2*s**2 - 3960*C*D1*Ddd*f**2*s + 990*C*D1*Ddd*f**2 + 11880*C*Dd**2*f**2*r*s - 2970*C*Dd**2*f**2*r + 11880*C*Dd**2*f**2*s**2 - 11880*C*Dd**2*f**2*s + 1980*C*Dd**2*f**2 - 132*D1**2*K*f*fd*r*s + 66*D1**2*K*f*fd*r - 132*D1**2*K*f*fd*s**2 + 132*D1**2*K*f*fd*s - 66*D1**2*K*f*fd + 660*D1**2*K*f*fdd*r*s - 330*D1**2*K*f*fdd*r + 660*D1**2*K*f*fdd*s**2 - 660*D1**2*K*f*fdd*s + 330*D1**2*K*f*fdd + 660*D1**2*K*fd**2*r*s - 330*D1**2*K*fd**2*r + 660*D1**2*K*fd**2*s**2 - 660*D1**2*K*fd**2*s + 594*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 1680*D1**2*f**2*fd*r*s - 625*D1**2*f**2*fd*r - 1680*D1**2*f**2*fd*s**2 + 495*D1**2*f**2*fd*s + 625*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r + 840*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r + 1680*D1**2*f*fd**2*s**2 - 560*D1**2*f*fd**2 + 2244*D1**2*f*fd*r*s + 66*D1**2*f*fd*r + 2244*D1**2*f*fd*s**2 - 1056*D1**2*f*fd*s - 66*D1**2*f*fd - 2310*D1**2*f*fdd*r*s + 165*D1**2*f*fdd*r - 2310*D1**2*f*fdd*s**2 + 1320*D1**2*f*fdd*s - 165*D1**2*f*fdd + 1452*D1**2*f*gd2*r*s + 1452*D1**2*f*gd2*s**2 - 1452*D1**2*f*gd2*s - 1188*D1**2*f*gdd2*r*s - 1188*D1**2*f*gdd2*s**2 + 1188*D1**2*f*gdd2*s - 2310*D1**2*fd**2*r*s + 165*D1**2*fd**2*r - 2310*D1**2*fd**2*s**2 + 1320*D1**2*fd**2*s + 1452*D1**2*fd*g2*r*s + 1452*D1**2*fd*g2*s**2 - 2376*D1**2*fd*gd2*r*s - 2376*D1**2*fd*gd2*s**2 + 1188*D1**2*fd*gd2*s - 1188*D1**2*fdd*g2*r*s - 1188*D1**2*fdd*g2*s**2 - 264*D1*Dd*K*f**2*r*s + 66*D1*Dd*K*f**2*r - 264*D1*Dd*K*f**2*s**2 + 264*D1*Dd*K*f**2*s - 66*D1*Dd*K*f**2 + 5280*D1*Dd*K*f*fd*r*s - 1980*D1*Dd*K*f*fd*r + 5280*D1*Dd*K*f*fd*s**2 - 5280*D1*Dd*K*f*fd*s + 1320*D1*Dd*K*f*fd - 2240*D1*Dd*f**3*r*s + 560*D1*Dd*f**3*r - 2240*D1*Dd*f**3*s**2 + 2240*D1*Dd*f**3*s - 560*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r*s + 1400*D1*Dd*f**2*fd*r + 6720*D1*Dd*f**2*fd*s**2 - 3360*D1*Dd*f**2*fd*s - 1120*D1*Dd*f**2*fd + 4488*D1*Dd*f**2*r*s - 1122*D1*Dd*f**2*r + 4488*D1*Dd*f**2*s**2 - 4488*D1*Dd*f**2*s + 1122*D1*Dd*f**2 - 18480*D1*Dd*f*fd*r*s + 2970*D1*Dd*f*fd*r - 18480*D1*Dd*f*fd*s**2 + 14520*D1*Dd*f*fd*s - 1650*D1*Dd*f*fd + 5808*D1*Dd*f*g2*r*s - 1452*D1*Dd*f*g2*r + 5808*D1*Dd*f*g2*s**2 - 5808*D1*Dd*f*g2*s + 1452*D1*Dd*f*g2 - 9504*D1*Dd*f*gd2*r*s + 1188*D1*Dd*f*gd2*r - 9504*D1*Dd*f*gd2*s**2 + 9504*D1*Dd*f*gd2*s - 1188*D1*Dd*f*gd2 - 9504*D1*Dd*fd*g2*r*s + 1188*D1*Dd*fd*g2*r - 9504*D1*Dd*fd*g2*s**2 + 4752*D1*Dd*fd*g2*s + 1320*D1*Ddd*K*f**2*r*s - 330*D1*Ddd*K*f**2*r + 1320*D1*Ddd*K*f**2*s**2 - 1320*D1*Ddd*K*f**2*s + 330*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r + 1120*D1*Ddd*f**3*s**2 - 1120*D1*Ddd*f**3*s + 280*D1*Ddd*f**3 - 4620*D1*Ddd*f**2*r*s + 1155*D1*Ddd*f**2*r - 4620*D1*Ddd*f**2*s**2 + 4620*D1*Ddd*f**2*s - 1155*D1*Ddd*f**2 - 4752*D1*Ddd*f*g2*r*s + 1188*D1*Ddd*f*g2*r - 4752*D1*Ddd*f*g2*s**2 + 4752*D1*Ddd*f*g2*s - 1188*D1*Ddd*f*g2 - 66*D1*bd1*(K - 1)*(D1*(11*f*(2*s - 1)*(r + s - 1) + 9*fd*(-4*r*s + r + s*(3 - 4*s))) - 9*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 3960*Dd**2*K*f**2*r*s - 990*Dd**2*K*f**2*r + 3960*Dd**2*K*f**2*s**2 - 3960*Dd**2*K*f**2*s + 660*Dd**2*K*f**2 + 3360*Dd**2*f**3*r*s - 840*Dd**2*f**3*r + 3360*Dd**2*f**3*s**2 - 3360*Dd**2*f**3*s + 560*Dd**2*f**3 - 13860*Dd**2*f**2*r*s + 3465*Dd**2*f**2*r - 13860*Dd**2*f**2*s**2 + 13860*Dd**2*f**2*s - 2310*Dd**2*f**2 - 14256*Dd**2*f*g2*r*s + 3564*Dd**2*f*g2*r - 14256*Dd**2*f*g2*s**2 + 14256*Dd**2*f*g2*s - 2376*Dd**2*f*g2))/(693*d**2*k3**6) + 3*D1**2*Pk3*Pkd2*ct**4*k1**4*st**2*(D1**2*(3675*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 2*f**2*(11025*fd**2*s*(2*s - 1) - fd*(1300*C - 1300)*(3*s**2 - 2*s + 1) + fdd*(650*C - 650)*(3*s**2 - 2*s + 1) + s**2*(429*K*bdd1 - 858*bd1*(K - 1) - 429*bdd1 + 1716*gd2 - 858*gdd2)) - 52*f*(fd**2*s*(50*C - 50)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 3432*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(3675*f**3*(4*s**2 - 2*s + 1) + 25*f**2*(52*C*(4*s**2 - 2*s + 1) - 147*fd*(1 - 4*s)**2 - 208*s**2 + 104*s - 52) - 26*f*(fd*(50*C - 50)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 1716*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(3675*f**2 + f*(1300*C - 1300) - 1716*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(3675*f**2 + f*(1300*C - 1300) - 1716*g2) + 858*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(2002*d**2*k2*k3**4) - 2*D1**2*Pk3*Pkd2*ct**4*k1**4*(825*C*D1**2*bdd1*f**2*s**2 - 1650*C*D1**2*bdd1*f**2*s + 825*C*D1**2*bdd1*f**2 + 7320*C*D1**2*f**2*fd*s**2 - 4880*C*D1**2*f**2*fd*s + 2440*C*D1**2*f**2*fd - 4155*C*D1**2*f**2*fdd*s**2 + 2770*C*D1**2*f**2*fdd*s - 1385*C*D1**2*f**2*fdd - 8310*C*D1**2*f*fd**2*s**2 + 5540*C*D1**2*f*fd**2*s + 9760*C*D1*Dd*f**3*s**2 - 4880*C*D1*Dd*f**3*s + 2440*C*D1*Dd*f**3 - 33240*C*D1*Dd*f**2*fd*s**2 + 19390*C*D1*Dd*f**2*fd*s - 2770*C*D1*Dd*f**2*fd - 5540*C*D1*Ddd*f**3*s**2 + 2770*C*D1*Ddd*f**3*s - 1385*C*D1*Ddd*f**3 - 16620*C*Dd**2*f**3*s**2 + 8310*C*Dd**2*f**3*s - 825*D1**2*K*bdd1*f**2*s**2 + 990*D1**2*bd1**2*f*s*(K - 1)*(s - 1) + 560*D1**2*bdd1*f**3*r*s + 1260*D1**2*bdd1*f**3*s**2 - 2380*D1**2*bdd1*f**3*s + 1050*D1**2*bdd1*f**3 + 330*D1**2*bdd1*f**2*r*s + 330*D1**2*bdd1*f**2*s**2 + 1320*D1**2*bdd1*f**2*s - 825*D1**2*bdd1*f**2 - 990*D1**2*bdd1*f*g2*s**2 + 1980*D1**2*bdd1*f*g2*s - 990*D1**2*bdd1*f*g2 + 2800*D1**2*f**3*fd*r*s - 700*D1**2*f**3*fd*r + 13440*D1**2*f**3*fd*s**2 - 8120*D1**2*f**3*fd*s + 3360*D1**2*f**3*fd - 2800*D1**2*f**3*fdd*r*s + 700*D1**2*f**3*fdd*r - 7560*D1**2*f**3*fdd*s**2 + 5180*D1**2*f**3*fdd*s - 1890*D1**2*f**3*fdd - 8400*D1**2*f**2*fd**2*r*s + 2100*D1**2*f**2*fd**2*r - 22680*D1**2*f**2*fd**2*s**2 + 15540*D1**2*f**2*fd**2*s - 1400*D1**2*f**2*fd**2 - 690*D1**2*f**2*fd*r*s + 230*D1**2*f**2*fd*r - 8010*D1**2*f**2*fd*s**2 + 5570*D1**2*f**2*fd*s - 2670*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r*s - 280*D1**2*f**2*fdd*r + 4995*D1**2*f**2*fdd*s**2 - 3610*D1**2*f**2*fdd*s + 1665*D1**2*f**2*fdd - 2904*D1**2*f**2*gd2*s**2 + 1650*D1**2*f**2*gdd2*s**2 + 1680*D1**2*f*fd**2*r*s - 560*D1**2*f*fd**2*r + 9990*D1**2*f*fd**2*s**2 - 7220*D1**2*f*fd**2*s + 280*D1**2*f*fd**2 - 5808*D1**2*f*fd*g2*s**2 + 5808*D1**2*f*fd*g2*s - 2904*D1**2*f*fd*g2 + 6600*D1**2*f*fd*gd2*s**2 - 3300*D1**2*f*fd*gd2*s + 3300*D1**2*f*fdd*g2*s**2 - 3300*D1**2*f*fdd*g2*s + 1650*D1**2*f*fdd*g2 + 3300*D1**2*fd**2*g2*s**2 - 3300*D1**2*fd**2*g2*s + 2800*D1*Dd*f**4*r*s - 700*D1*Dd*f**4*r + 13440*D1*Dd*f**4*s**2 - 8120*D1*Dd*f**4*s + 3360*D1*Dd*f**4 - 22400*D1*Dd*f**3*fd*r*s + 5600*D1*Dd*f**3*fd*r - 60480*D1*Dd*f**3*fd*s**2 + 41440*D1*Dd*f**3*fd*s - 6580*D1*Dd*f**3*fd - 920*D1*Dd*f**3*r*s + 230*D1*Dd*f**3*r - 10680*D1*Dd*f**3*s**2 + 5800*D1*Dd*f**3*s - 2670*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r*s - 1960*D1*Dd*f**2*fd*r + 39960*D1*Dd*f**2*fd*s**2 - 26110*D1*Dd*f**2*fd*s + 4170*D1*Dd*f**2*fd - 11616*D1*Dd*f**2*g2*s**2 + 5808*D1*Dd*f**2*g2*s - 2904*D1*Dd*f**2*g2 + 13200*D1*Dd*f**2*gd2*s**2 - 3300*D1*Dd*f**2*gd2*s + 26400*D1*Dd*f*fd*g2*s**2 - 19800*D1*Dd*f*fd*g2*s + 3300*D1*Dd*f*fd*g2 - 2800*D1*Ddd*f**4*r*s + 700*D1*Ddd*f**4*r - 7560*D1*Ddd*f**4*s**2 + 5180*D1*Ddd*f**4*s - 1890*D1*Ddd*f**4 + 1120*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r + 6660*D1*Ddd*f**3*s**2 - 3890*D1*Ddd*f**3*s + 1665*D1*Ddd*f**3 + 6600*D1*Ddd*f**2*g2*s**2 - 3300*D1*Ddd*f**2*g2*s + 1650*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(5*f**3*(186*s**2 + s*(46*r - 443) + 210) + f**2*(825*C*(s - 1)**2 - 140*fd*(2*r*(6*s - 1) + 27*s**2 - 30*s + 1) + 33*s**2*(1 - 22*K) + 33*s*(4*r + 46) - 825) - 165*f*(fd*(r*(4*s - 1) + s**2*(10*C - 10*K + 4) + s*(-10*C + 5*K + 1) + 1) + (6*s - 6)*(g2*(s - 1) - gd2*s)) + 990*fd*g2*s*(s - 1)) - 5*Dd*f*(14*f**2*(4*r*(8*s - 1) + 72*s**2 - 94*s + 17) + 33*f*(5*C*(4*s**2 - 5*s + 1) - 20*K*s**2 + 5*K*s + 8*r*s - r + 8*s**2 + 12*s - 4) - 198*g2*(4*s**2 - 5*s + 1))) - 8400*Dd**2*f**4*r*s + 2100*Dd**2*f**4*r - 22680*Dd**2*f**4*s**2 + 15540*Dd**2*f**4*s - 1400*Dd**2*f**4 + 3360*Dd**2*f**3*r*s - 840*Dd**2*f**3*r + 19980*Dd**2*f**3*s**2 - 11670*Dd**2*f**3*s + 560*Dd**2*f**3 + 19800*Dd**2*f**2*g2*s**2 - 9900*Dd**2*f**2*g2*s - 495*b1**2*(K - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-3300*C*D1**2*f*fd*s**2 + 1650*C*D1**2*f*fdd*s**2 + 1650*C*D1**2*fd**2*s**2 - 6600*C*D1*Dd*f**2*s**2 + 3300*C*D1*Dd*f**2*s - 1650*C*D1*Dd*f**2 + 13200*C*D1*Dd*f*fd*s**2 - 3300*C*D1*Dd*f*fd*s + 3300*C*D1*Ddd*f**2*s**2 - 1650*C*D1*Ddd*f**2*s + 825*C*D1*Ddd*f**2 + 9900*C*Dd**2*f**2*s**2 - 4950*C*Dd**2*f**2*s + 2904*D1**2*K*f*fd*s**2 - 2904*D1**2*K*f*fd*s + 1452*D1**2*K*f*fd - 1650*D1**2*K*f*fdd*s**2 + 1650*D1**2*K*f*fdd*s - 825*D1**2*K*f*fdd - 1650*D1**2*K*fd**2*s**2 + 1650*D1**2*K*fd**2*s + 495*D1**2*bdd1*f*(K - 1)*(2*s**2 - 2*s + 1) - 1380*D1**2*f**2*fd*r*s + 460*D1**2*f**2*fd*r - 5580*D1**2*f**2*fd*s**2 + 210*D1**2*f**2*fd*s + 240*D1**2*f**2*fd + 1680*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 3780*D1**2*f**2*fdd*s**2 - 1260*D1**2*f**2*fdd*s + 210*D1**2*f**2*fdd + 3360*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 7560*D1**2*f*fd**2*s**2 - 2520*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 528*D1**2*f*fd*r*s + 264*D1**2*f*fd*r - 132*D1**2*f*fd*s**2 + 3432*D1**2*f*fd*s - 1716*D1**2*f*fd + 660*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 660*D1**2*f*fdd*s**2 - 2310*D1**2*f*fdd*s + 1155*D1**2*f*fdd + 1980*D1**2*f*gd2*s**2 - 990*D1**2*f*gdd2*s**2 + 660*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 660*D1**2*fd**2*s**2 - 2310*D1**2*fd**2*s + 1980*D1**2*fd*g2*s**2 - 1980*D1**2*fd*gd2*s**2 - 990*D1**2*fdd*g2*s**2 + 5808*D1*Dd*K*f**2*s**2 - 2904*D1*Dd*K*f**2*s + 1452*D1*Dd*K*f**2 - 13200*D1*Dd*K*f*fd*s**2 + 9900*D1*Dd*K*f*fd*s - 1650*D1*Dd*K*f*fd - 1840*D1*Dd*f**3*r*s + 460*D1*Dd*f**3*r - 7440*D1*Dd*f**3*s**2 + 4640*D1*Dd*f**3*s - 1860*D1*Dd*f**3 + 13440*D1*Dd*f**2*fd*r*s - 3920*D1*Dd*f**2*fd*r + 30240*D1*Dd*f**2*fd*s**2 - 15960*D1*Dd*f**2*fd*s + 2380*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*r*s + 264*D1*Dd*f**2*r - 264*D1*Dd*f**2*s**2 + 660*D1*Dd*f**2*s - 66*D1*Dd*f**2 + 5280*D1*Dd*f*fd*r*s - 1980*D1*Dd*f*fd*r + 5280*D1*Dd*f*fd*s**2 - 11880*D1*Dd*f*fd*s + 2970*D1*Dd*f*fd + 7920*D1*Dd*f*g2*s**2 - 3960*D1*Dd*f*g2*s + 1980*D1*Dd*f*g2 - 7920*D1*Dd*f*gd2*s**2 + 1980*D1*Dd*f*gd2*s - 7920*D1*Dd*fd*g2*s**2 + 1980*D1*Dd*fd*g2*s - 3300*D1*Ddd*K*f**2*s**2 + 1650*D1*Ddd*K*f**2*s - 825*D1*Ddd*K*f**2 + 2240*D1*Ddd*f**3*r*s - 560*D1*Ddd*f**3*r + 5040*D1*Ddd*f**3*s**2 - 3640*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*r*s - 330*D1*Ddd*f**2*r + 1320*D1*Ddd*f**2*s**2 - 1320*D1*Ddd*f**2*s + 330*D1*Ddd*f**2 - 3960*D1*Ddd*f*g2*s**2 + 1980*D1*Ddd*f*g2*s - 990*D1*Ddd*f*g2 - 990*D1*bd1*(K - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 9900*Dd**2*K*f**2*s**2 + 4950*Dd**2*K*f**2*s + 6720*Dd**2*f**3*r*s - 1680*Dd**2*f**3*r + 15120*Dd**2*f**3*s**2 - 10920*Dd**2*f**3*s + 1120*Dd**2*f**3 + 3960*Dd**2*f**2*r*s - 990*Dd**2*f**2*r + 3960*Dd**2*f**2*s**2 - 3960*Dd**2*f**2*s + 660*Dd**2*f**2 - 11880*Dd**2*f*g2*s**2 + 5940*Dd**2*f*g2*s))/(693*d**2*k2*k3**4) + 4*D1**2*Pk3*Pkd2*ct**4*k1**2*k2**3*st**2*(-132*C*D1**2*bdd1*f**2*r*s + 132*C*D1**2*bdd1*f**2*r - 132*C*D1**2*bdd1*f**2*s**2 + 264*C*D1**2*bdd1*f**2*s - 132*C*D1**2*bdd1*f**2 + 4812*C*D1**2*f**2*fd*r*s - 1604*C*D1**2*f**2*fd*r + 4812*C*D1**2*f**2*fd*s**2 - 4812*C*D1**2*f**2*fd*s + 1604*C*D1**2*f**2*fd - 3000*C*D1**2*f**2*fdd*r*s + 1000*C*D1**2*f**2*fdd*r - 3000*C*D1**2*f**2*fdd*s**2 + 3000*C*D1**2*f**2*fdd*s - 1000*C*D1**2*f**2*fdd - 6000*C*D1**2*f*fd**2*r*s + 2000*C*D1**2*f*fd**2*r - 6000*C*D1**2*f*fd**2*s**2 + 6000*C*D1**2*f*fd**2*s - 1000*C*D1**2*f*fd**2 + 6416*C*D1*Dd*f**3*r*s - 1604*C*D1*Dd*f**3*r + 6416*C*D1*Dd*f**3*s**2 - 6416*C*D1*Dd*f**3*s + 1604*C*D1*Dd*f**3 - 24000*C*D1*Dd*f**2*fd*r*s + 7000*C*D1*Dd*f**2*fd*r - 24000*C*D1*Dd*f**2*fd*s**2 + 24000*C*D1*Dd*f**2*fd*s - 5000*C*D1*Dd*f**2*fd - 4000*C*D1*Ddd*f**3*r*s + 1000*C*D1*Ddd*f**3*r - 4000*C*D1*Ddd*f**3*s**2 + 4000*C*D1*Ddd*f**3*s - 1000*C*D1*Ddd*f**3 - 12000*C*Dd**2*f**3*r*s + 3000*C*Dd**2*f**3*r - 12000*C*Dd**2*f**3*s**2 + 12000*C*Dd**2*f**3*s - 2000*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*s**2 + 660*D1**2*K*bdd1*f**2*s - 66*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 375*D1**2*bdd1*f**3*r*s + 125*D1**2*bdd1*f**3*r + 375*D1**2*bdd1*f**3*s**2 - 250*D1**2*bdd1*f**3*s - 125*D1**2*bdd1*f**3 + 462*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*r + 462*D1**2*bdd1*f**2*s**2 - 594*D1**2*bdd1*f**2*s + 132*D1**2*bdd1*f**2 + 132*D1**2*bdd1*f*g2*r*s - 132*D1**2*bdd1*f*g2*r + 132*D1**2*bdd1*f*g2*s**2 - 264*D1**2*bdd1*f*g2*s + 132*D1**2*bdd1*f*g2 - 500*D1**2*f**3*fd*r*s + 125*D1**2*f**3*fd*r - 500*D1**2*f**3*fd*s**2 + 500*D1**2*f**3*fd*s - 125*D1**2*f**3*fd - 3510*D1**2*f**2*fd*r*s + 1170*D1**2*f**2*fd*r - 3510*D1**2*f**2*fd*s**2 + 3510*D1**2*f**2*fd*s - 1170*D1**2*f**2*fd + 2250*D1**2*f**2*fdd*r*s - 750*D1**2*f**2*fdd*r + 2250*D1**2*f**2*fdd*s**2 - 2250*D1**2*f**2*fdd*s + 750*D1**2*f**2*fdd - 2244*D1**2*f**2*gd2*r*s - 2244*D1**2*f**2*gd2*s**2 + 2244*D1**2*f**2*gd2*s + 1320*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*s**2 - 1320*D1**2*f**2*gdd2*s + 4500*D1**2*f*fd**2*r*s - 1500*D1**2*f*fd**2*r + 4500*D1**2*f*fd**2*s**2 - 4500*D1**2*f*fd**2*s + 750*D1**2*f*fd**2 - 4488*D1**2*f*fd*g2*r*s + 2244*D1**2*f*fd*g2*r - 4488*D1**2*f*fd*g2*s**2 + 4488*D1**2*f*fd*g2*s - 2244*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r*s - 1320*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 5280*D1**2*f*fd*gd2*s + 1320*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r*s - 1320*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r*s - 1320*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s - 500*D1*Dd*f**4*r*s + 125*D1*Dd*f**4*r - 500*D1*Dd*f**4*s**2 + 500*D1*Dd*f**4*s - 125*D1*Dd*f**4 - 4680*D1*Dd*f**3*r*s + 1170*D1*Dd*f**3*r - 4680*D1*Dd*f**3*s**2 + 4680*D1*Dd*f**3*s - 1170*D1*Dd*f**3 + 18000*D1*Dd*f**2*fd*r*s - 5250*D1*Dd*f**2*fd*r + 18000*D1*Dd*f**2*fd*s**2 - 18000*D1*Dd*f**2*fd*s + 3750*D1*Dd*f**2*fd - 8976*D1*Dd*f**2*g2*r*s + 2244*D1*Dd*f**2*g2*r - 8976*D1*Dd*f**2*g2*s**2 + 8976*D1*Dd*f**2*g2*s - 2244*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r*s - 1320*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 10560*D1*Dd*f**2*gd2*s + 1320*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r*s - 7920*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 21120*D1*Dd*f*fd*g2*s + 5280*D1*Dd*f*fd*g2 + 3000*D1*Ddd*f**3*r*s - 750*D1*Ddd*f**3*r + 3000*D1*Ddd*f**3*s**2 - 3000*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r*s - 1320*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 5280*D1*Ddd*f**2*g2*s + 1320*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-10*f**3*(64*s + 25)*(r + s - 1) + f**2*(264*C*(s - 1)*(r + s - 1) + 125*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + (s*(17*K - 12) + 4)*(66*r + 66*s - 66)) - 66*f*(fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 10*K*(r*(4*s - 1) + (1 - 2*s)**2) - 28*r*s + 9*r - 28*s**2 + 30*s - 7) + (2*r + 2*s - 2)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 132*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(125*f**2*(24*r*s + r + 4*s*(6*s - 5)) - 66*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 56*r*s + 15*r - 56*s**2 + 64*s - 13) + 132*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 9000*Dd**2*f**3*r*s - 2250*Dd**2*f**3*r + 9000*Dd**2*f**3*s**2 - 9000*Dd**2*f**3*s + 1500*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r*s - 3960*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 15840*Dd**2*f**2*g2*s + 2640*Dd**2*f**2*g2 + 66*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(528*C*D1**2*f*fd*r*s + 528*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s - 264*C*D1**2*f*fdd*r*s - 264*C*D1**2*f*fdd*s**2 + 132*C*D1**2*f*fdd*s - 264*C*D1**2*fd**2*r*s - 264*C*D1**2*fd**2*s**2 + 132*C*D1**2*fd**2*s + 1056*C*D1*Dd*f**2*r*s - 264*C*D1*Dd*f**2*r + 1056*C*D1*Dd*f**2*s**2 - 1056*C*D1*Dd*f**2*s + 264*C*D1*Dd*f**2 - 2112*C*D1*Dd*f*fd*r*s + 264*C*D1*Dd*f*fd*r - 2112*C*D1*Dd*f*fd*s**2 + 1584*C*D1*Dd*f*fd*s - 132*C*D1*Dd*f*fd - 528*C*D1*Ddd*f**2*r*s + 132*C*D1*Ddd*f**2*r - 528*C*D1*Ddd*f**2*s**2 + 528*C*D1*Ddd*f**2*s - 132*C*D1*Ddd*f**2 - 1584*C*Dd**2*f**2*r*s + 396*C*Dd**2*f**2*r - 1584*C*Dd**2*f**2*s**2 + 1584*C*Dd**2*f**2*s - 264*C*Dd**2*f**2 + 2244*D1**2*K*f*fd*r*s - 1122*D1**2*K*f*fd*r + 2244*D1**2*K*f*fd*s**2 - 2244*D1**2*K*f*fd*s + 1122*D1**2*K*f*fd - 1320*D1**2*K*f*fdd*r*s + 660*D1**2*K*f*fdd*r - 1320*D1**2*K*f*fdd*s**2 + 1320*D1**2*K*f*fdd*s - 660*D1**2*K*f*fdd - 1320*D1**2*K*fd**2*r*s + 660*D1**2*K*fd**2*r - 1320*D1**2*K*fd**2*s**2 + 1320*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 1920*D1**2*f**2*fd*r*s + 890*D1**2*f**2*fd*r - 1920*D1**2*f**2*fd*s**2 + 2170*D1**2*f**2*fd*s - 890*D1**2*f**2*fd + 1125*D1**2*f**2*fdd*r*s - 500*D1**2*f**2*fdd*r + 1125*D1**2*f**2*fdd*s**2 - 1250*D1**2*f**2*fdd*s + 500*D1**2*f**2*fdd + 2250*D1**2*f*fd**2*r*s - 1000*D1**2*f*fd**2*r + 2250*D1**2*f*fd**2*s**2 - 2500*D1**2*f*fd**2*s + 500*D1**2*f*fd**2 - 1584*D1**2*f*fd*r*s + 528*D1**2*f*fd*r - 1584*D1**2*f*fd*s**2 + 1320*D1**2*f*fd*s - 528*D1**2*f*fd + 924*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 924*D1**2*f*fdd*s**2 - 792*D1**2*f*fdd*s + 330*D1**2*f*fdd - 264*D1**2*f*gd2*r*s - 264*D1**2*f*gd2*s**2 + 264*D1**2*f*gd2*s + 132*D1**2*f*gdd2*r*s + 132*D1**2*f*gdd2*s**2 - 132*D1**2*f*gdd2*s + 924*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 924*D1**2*fd**2*s**2 - 792*D1**2*fd**2*s - 264*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*s**2 + 264*D1**2*fd*gd2*r*s + 264*D1**2*fd*gd2*s**2 - 132*D1**2*fd*gd2*s + 132*D1**2*fdd*g2*r*s + 132*D1**2*fdd*g2*s**2 + 4488*D1*Dd*K*f**2*r*s - 1122*D1*Dd*K*f**2*r + 4488*D1*Dd*K*f**2*s**2 - 4488*D1*Dd*K*f**2*s + 1122*D1*Dd*K*f**2 - 10560*D1*Dd*K*f*fd*r*s + 3960*D1*Dd*K*f*fd*r - 10560*D1*Dd*K*f*fd*s**2 + 10560*D1*Dd*K*f*fd*s - 2640*D1*Dd*K*f*fd - 2560*D1*Dd*f**3*r*s + 640*D1*Dd*f**3*r - 2560*D1*Dd*f**3*s**2 + 2560*D1*Dd*f**3*s - 640*D1*Dd*f**3 + 9000*D1*Dd*f**2*fd*r*s - 3125*D1*Dd*f**2*fd*r + 9000*D1*Dd*f**2*fd*s**2 - 9500*D1*Dd*f**2*fd*s + 2250*D1*Dd*f**2*fd - 3168*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 3168*D1*Dd*f**2*s**2 + 3168*D1*Dd*f**2*s - 792*D1*Dd*f**2 + 7392*D1*Dd*f*fd*r*s - 2244*D1*Dd*f*fd*r + 7392*D1*Dd*f*fd*s**2 - 6864*D1*Dd*f*fd*s + 1452*D1*Dd*f*fd - 1056*D1*Dd*f*g2*r*s + 264*D1*Dd*f*g2*r - 1056*D1*Dd*f*g2*s**2 + 1056*D1*Dd*f*g2*s - 264*D1*Dd*f*g2 + 1056*D1*Dd*f*gd2*r*s - 132*D1*Dd*f*gd2*r + 1056*D1*Dd*f*gd2*s**2 - 1056*D1*Dd*f*gd2*s + 132*D1*Dd*f*gd2 + 1056*D1*Dd*fd*g2*r*s - 132*D1*Dd*fd*g2*r + 1056*D1*Dd*fd*g2*s**2 - 528*D1*Dd*fd*g2*s - 2640*D1*Ddd*K*f**2*r*s + 660*D1*Ddd*K*f**2*r - 2640*D1*Ddd*K*f**2*s**2 + 2640*D1*Ddd*K*f**2*s - 660*D1*Ddd*K*f**2 + 1500*D1*Ddd*f**3*r*s - 375*D1*Ddd*f**3*r + 1500*D1*Ddd*f**3*s**2 - 1500*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 + 1848*D1*Ddd*f**2*r*s - 462*D1*Ddd*f**2*r + 1848*D1*Ddd*f**2*s**2 - 1848*D1*Ddd*f**2*s + 462*D1*Ddd*f**2 + 528*D1*Ddd*f*g2*r*s - 132*D1*Ddd*f*g2*r + 528*D1*Ddd*f*g2*s**2 - 528*D1*Ddd*f*g2*s + 132*D1*Ddd*f*g2 + 66*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 7920*Dd**2*K*f**2*r*s + 1980*Dd**2*K*f**2*r - 7920*Dd**2*K*f**2*s**2 + 7920*Dd**2*K*f**2*s - 1320*Dd**2*K*f**2 + 4500*Dd**2*f**3*r*s - 1125*Dd**2*f**3*r + 4500*Dd**2*f**3*s**2 - 4500*Dd**2*f**3*s + 750*Dd**2*f**3 + 5544*Dd**2*f**2*r*s - 1386*Dd**2*f**2*r + 5544*Dd**2*f**2*s**2 - 5544*Dd**2*f**2*s + 924*Dd**2*f**2 + 1584*Dd**2*f*g2*r*s - 396*Dd**2*f*g2*r + 1584*Dd**2*f*g2*s**2 - 1584*Dd**2*f*g2*s + 264*Dd**2*f*g2))/(231*d**2*k3**6) - 8*D1**2*Pk3*Pkd2*ct**4*k1**2*k2**3*(660*C*D1**2*bdd1*f**2*r*s - 660*C*D1**2*bdd1*f**2*r + 660*C*D1**2*bdd1*f**2*s**2 - 1320*C*D1**2*bdd1*f**2*s + 660*C*D1**2*bdd1*f**2 + 300*C*D1**2*f**2*fd*r*s - 100*C*D1**2*f**2*fd*r + 300*C*D1**2*f**2*fd*s**2 - 300*C*D1**2*f**2*fd*s + 100*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 + 400*C*D1*Dd*f**3*r*s - 100*C*D1*Dd*f**3*r + 400*C*D1*Dd*f**3*s**2 - 400*C*D1*Dd*f**3*s + 100*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 22*D1**2*bd1**2*f*(2*s - 1)*(-18*K + 10*f + 9)*(r + s - 1) - 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*r - 495*D1**2*bdd1*f**2*s**2 + 990*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r - 792*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 - 480*D1**2*f**2*fd*r*s + 160*D1**2*f**2*fd*r - 480*D1**2*f**2*fd*s**2 + 480*D1**2*f**2*fd*s - 160*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 840*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s - 640*D1*Dd*f**3*r*s + 160*D1*Dd*f**3*r - 640*D1*Dd*f**3*s**2 + 640*D1*Dd*f**3*s - 160*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3360*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r*s + 132*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*(2*s + 1)*(r + s - 1) + 6*f**2*(r + s - 1)*(14*C*(s - 1) - s*(K + 8) + 10) - 3*f*(5*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + (34*g2*(s - 1) + 24*gd2*(1 - 2*s))*(r + s - 1)) + 72*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(5*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 24*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 1680*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 11*b1**2*(D1**2*s*(2*f*(17*fd - 10*fdd)*(2*r + 2*s - 1) - 20*fd**2*(2*r + 2*s - 1) - fd*(51*K - 22)*(r + s) + 18*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(34*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-20*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - (51*K - 22)*(r*(4*s - 1) + (1 - 2*s)**2)) + 18*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 10*f + 9)) - 2*Dd**2*f*(-18*K + 10*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(-168*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*s**2 + 84*C*D1**2*f*fd*s + 120*C*D1**2*f*fdd*r*s + 120*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 120*C*D1**2*fd**2*r*s + 120*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s - 336*C*D1*Dd*f**2*r*s + 84*C*D1*Dd*f**2*r - 336*C*D1*Dd*f**2*s**2 + 336*C*D1*Dd*f**2*s - 84*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r*s - 120*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 240*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 720*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 + 12*D1**2*K*f*fd*r*s - 6*D1**2*K*f*fd*r + 12*D1**2*K*f*fd*s**2 - 12*D1**2*K*f*fd*s + 6*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(2*s - 1)*(-18*K + 10*f + 9)*(r + s - 1) - 30*D1**2*f**2*fd*r*s + 15*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 35*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 96*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 96*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s - 12*D1**2*f*fd - 90*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*s**2 + 45*D1**2*f*fdd*s + 102*D1**2*f*gd2*r*s + 102*D1**2*f*gd2*s**2 - 102*D1**2*f*gd2*s - 72*D1**2*f*gdd2*r*s - 72*D1**2*f*gdd2*s**2 + 72*D1**2*f*gdd2*s - 90*D1**2*fd**2*r*s - 90*D1**2*fd**2*s**2 + 45*D1**2*fd**2*s + 102*D1**2*fd*g2*r*s + 102*D1**2*fd*g2*s**2 - 144*D1**2*fd*gd2*r*s - 144*D1**2*fd*gd2*s**2 + 72*D1**2*fd*gd2*s - 72*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*s**2 + 24*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s**2 - 24*D1*Dd*K*f**2*s + 6*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 40*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 40*D1*Dd*f**3*s - 10*D1*Dd*f**3 + 192*D1*Dd*f**2*r*s - 48*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 192*D1*Dd*f**2*s + 48*D1*Dd*f**2 - 720*D1*Dd*f*fd*r*s + 90*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 540*D1*Dd*f*fd*s - 45*D1*Dd*f*fd + 408*D1*Dd*f*g2*r*s - 102*D1*Dd*f*g2*r + 408*D1*Dd*f*g2*s**2 - 408*D1*Dd*f*g2*s + 102*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r*s + 72*D1*Dd*f*gd2*r - 576*D1*Dd*f*gd2*s**2 + 576*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 576*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 180*D1*Ddd*f**2*r*s + 45*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 288*D1*Ddd*f*g2*s**2 + 288*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + D1*bd1*(D1*(34*f**2*(2*s - 1)*(r + s - 1) + f*(-20*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) - (51*K - 22)*(2*s - 1)*(r + s - 1)) + 18*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 2*Dd*f*(-18*K + 10*f + 9)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 540*Dd**2*f**2*r*s + 135*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 90*Dd**2*f**2 - 864*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 864*Dd**2*f*g2*s**2 + 864*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(231*d**2*k3**6) - D1**2*Pk3*Pkd2*ct**4*k1**2*k2*st**2*(1584*C*D1**2*bdd1*f**2*r*s + 3564*C*D1**2*bdd1*f**2*s**2 - 3960*C*D1**2*bdd1*f**2*s + 1980*C*D1**2*bdd1*f**2 + 28608*C*D1**2*f**2*fd*r*s - 9536*C*D1**2*f**2*fd*r - 33744*C*D1**2*f**2*fd*s**2 + 12960*C*D1**2*f**2*fd*s - 11248*C*D1**2*f**2*fd - 19056*C*D1**2*f**2*fdd*r*s + 6352*C*D1**2*f**2*fdd*r + 13308*C*D1**2*f**2*fdd*s**2 - 2520*C*D1**2*f**2*fdd*s + 4436*C*D1**2*f**2*fdd - 38112*C*D1**2*f*fd**2*r*s + 12704*C*D1**2*f*fd**2*r + 26616*C*D1**2*f*fd**2*s**2 - 5040*C*D1**2*f*fd**2*s - 6352*C*D1**2*f*fd**2 + 38144*C*D1*Dd*f**3*r*s - 9536*C*D1*Dd*f**3*r - 44992*C*D1*Dd*f**3*s**2 + 3424*C*D1*Dd*f**3*s - 11248*C*D1*Dd*f**3 - 152448*C*D1*Dd*f**2*fd*r*s + 44464*C*D1*Dd*f**2*fd*r + 106464*C*D1*Dd*f**2*fd*s**2 + 1416*C*D1*Dd*f**2*fd*s - 10184*C*D1*Dd*f**2*fd - 25408*C*D1*Ddd*f**3*r*s + 6352*C*D1*Ddd*f**3*r + 17744*C*D1*Ddd*f**3*s**2 + 3832*C*D1*Ddd*f**3*s + 4436*C*D1*Ddd*f**3 - 76224*C*Dd**2*f**3*r*s + 19056*C*Dd**2*f**3*r + 53232*C*Dd**2*f**3*s**2 + 11496*C*Dd**2*f**3*s - 12704*C*Dd**2*f**3 - 3432*D1**2*K*bdd1*f**2*r*s + 3498*D1**2*K*bdd1*f**2*s**2 + 3432*D1**2*K*bdd1*f**2*s + 396*D1**2*bd1**2*f*s*(K - 1)*(4*r + 9*s - 7) + 6000*D1**2*bdd1*f**3*r*s + 2250*D1**2*bdd1*f**3*s**2 - 8250*D1**2*bdd1*f**3*s + 1875*D1**2*bdd1*f**3 + 5808*D1**2*bdd1*f**2*r*s + 198*D1**2*bdd1*f**2*s**2 - 3432*D1**2*bdd1*f**2*s - 1980*D1**2*bdd1*f**2 - 1584*D1**2*bdd1*f*g2*r*s - 3564*D1**2*bdd1*f*g2*s**2 + 3960*D1**2*bdd1*f*g2*s - 1980*D1**2*bdd1*f*g2 + 27000*D1**2*f**3*fd*r*s - 6750*D1**2*f**3*fd*r + 30000*D1**2*f**3*fd*s**2 - 28500*D1**2*f**3*fd*s + 7500*D1**2*f**3*fd - 27000*D1**2*f**3*fdd*r*s + 6750*D1**2*f**3*fdd*r - 19500*D1**2*f**3*fdd*s**2 + 23250*D1**2*f**3*fdd*s - 4875*D1**2*f**3*fdd - 81000*D1**2*f**2*fd**2*r*s + 20250*D1**2*f**2*fd**2*r - 58500*D1**2*f**2*fd**2*s**2 + 69750*D1**2*f**2*fd**2*s - 13500*D1**2*f**2*fd**2 - 44232*D1**2*f**2*fd*r*s + 14744*D1**2*f**2*fd*r + 3120*D1**2*f**2*fd*s**2 + 12664*D1**2*f**2*fd*s + 1040*D1**2*f**2*fd + 28056*D1**2*f**2*fdd*r*s - 9352*D1**2*f**2*fdd*r + 3192*D1**2*f**2*fdd*s**2 - 11480*D1**2*f**2*fdd*s + 1064*D1**2*f**2*fdd - 12144*D1**2*f**2*gd2*r*s + 16368*D1**2*f**2*gd2*s**2 + 12144*D1**2*f**2*gd2*s + 6864*D1**2*f**2*gdd2*r*s - 6996*D1**2*f**2*gdd2*s**2 - 6864*D1**2*f**2*gdd2*s + 56112*D1**2*f*fd**2*r*s - 18704*D1**2*f*fd**2*r + 6384*D1**2*f*fd**2*s**2 - 22960*D1**2*f*fd**2*s + 9352*D1**2*f*fd**2 - 24288*D1**2*f*fd*g2*r*s + 12144*D1**2*f*fd*g2*r + 32736*D1**2*f*fd*g2*s**2 - 32736*D1**2*f*fd*g2*s + 16368*D1**2*f*fd*g2 + 27456*D1**2*f*fd*gd2*r*s - 6864*D1**2*f*fd*gd2*r - 27984*D1**2*f*fd*gd2*s**2 + 264*D1**2*f*fd*gd2*s + 6864*D1**2*f*fd*gd2 + 13728*D1**2*f*fdd*g2*r*s - 6864*D1**2*f*fdd*g2*r - 13992*D1**2*f*fdd*g2*s**2 + 13992*D1**2*f*fdd*g2*s - 6996*D1**2*f*fdd*g2 + 13728*D1**2*fd**2*g2*r*s - 6864*D1**2*fd**2*g2*r - 13992*D1**2*fd**2*g2*s**2 + 13992*D1**2*fd**2*g2*s + 27000*D1*Dd*f**4*r*s - 6750*D1*Dd*f**4*r + 30000*D1*Dd*f**4*s**2 - 28500*D1*Dd*f**4*s + 7500*D1*Dd*f**4 - 216000*D1*Dd*f**3*fd*r*s + 54000*D1*Dd*f**3*fd*r - 156000*D1*Dd*f**3*fd*s**2 + 186000*D1*Dd*f**3*fd*s - 36750*D1*Dd*f**3*fd - 58976*D1*Dd*f**3*r*s + 14744*D1*Dd*f**3*r + 4160*D1*Dd*f**3*s**2 + 27408*D1*Dd*f**3*s + 1040*D1*Dd*f**3 + 224448*D1*Dd*f**2*fd*r*s - 65464*D1*Dd*f**2*fd*r + 25536*D1*Dd*f**2*fd*s**2 - 108416*D1*Dd*f**2*fd*s + 30184*D1*Dd*f**2*fd - 48576*D1*Dd*f**2*g2*r*s + 12144*D1*Dd*f**2*g2*r + 65472*D1*Dd*f**2*g2*s**2 - 8448*D1*Dd*f**2*g2*s + 16368*D1*Dd*f**2*g2 + 54912*D1*Dd*f**2*gd2*r*s - 6864*D1*Dd*f**2*gd2*r - 55968*D1*Dd*f**2*gd2*s**2 - 27192*D1*Dd*f**2*gd2*s + 6864*D1*Dd*f**2*gd2 + 109824*D1*Dd*f*fd*g2*r*s - 41184*D1*Dd*f*fd*g2*r - 111936*D1*Dd*f*fd*g2*s**2 + 56496*D1*Dd*f*fd*g2*s - 264*D1*Dd*f*fd*g2 - 27000*D1*Ddd*f**4*r*s + 6750*D1*Ddd*f**4*r - 19500*D1*Ddd*f**4*s**2 + 23250*D1*Ddd*f**4*s - 4875*D1*Ddd*f**4 + 37408*D1*Ddd*f**3*r*s - 9352*D1*Ddd*f**3*r + 4256*D1*Ddd*f**3*s**2 - 20832*D1*Ddd*f**3*s + 1064*D1*Ddd*f**3 + 27456*D1*Ddd*f**2*g2*r*s - 6864*D1*Ddd*f**2*g2*r - 27984*D1*Ddd*f**2*g2*s**2 + 264*D1*Ddd*f**2*g2*s - 6996*D1*Ddd*f**2*g2 - 6*D1*bd1*(D1*(5*f**3*(106*s**2 + s*(356*r - 506) + 125) + 2*f**2*(66*C*(9*s**2 + s*(4*r - 10) + 5) - 125*fd*(4*r*(6*s - 1) + 9*s**2 - 22*s + 3) - 22*s**2*(6 - 31*K) - 22*s*(23*K*(r - 1) - 38*r + 20) - 330) + 22*f*(fd*(-108*C*s**2 + 96*C*s + K*(26*r*(4*s - 1) - 106*s**2 + s + 26) - r*(12*C + 44)*(4*s - 1) - 6*s**2 + 73*s - 56) - 6*g2*(9*s**2 + s*(4*r - 10) + 5) - 6*gd2*s*(-4*r - 9*s + 7)) + 132*fd*g2*(r*(4*s - 2) + s*(9*s - 9))) - Dd*f*(125*f**2*(8*r*(8*s - 1) + 24*s**2 - 66*s + 11) + 22*f*(6*C*(2*r*(8*s - 1) + 36*s**2 - 33*s + 5) + K*(-208*r*s + 26*r + 212*s**2 + 103*s - 26) + 352*r*s - 44*r + 12*s**2 - 195*s + 26) - 132*g2*(2*r*(8*s - 1) + 36*s**2 - 33*s + 5))) - 81000*Dd**2*f**4*r*s + 20250*Dd**2*f**4*r - 58500*Dd**2*f**4*s**2 + 69750*Dd**2*f**4*s - 13500*Dd**2*f**4 + 112224*Dd**2*f**3*r*s - 28056*Dd**2*f**3*r + 12768*Dd**2*f**3*s**2 - 62496*Dd**2*f**3*s + 18704*Dd**2*f**3 + 82368*Dd**2*f**2*g2*r*s - 20592*Dd**2*f**2*g2*r - 83952*Dd**2*f**2*g2*s**2 + 792*Dd**2*f**2*g2*s + 13728*Dd**2*f**2*g2 - 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(4*r*(s - 1) + 9*s**2 - 8*s + 4) + D1*(2*Dd*(f*(16*r*s - 4*r + 36*s**2 - 26*s + 9) + fd*(-16*r*s + 10*r - 36*s**2 + 29*s - 8)) + Ddd*f*(r*(4 - 16*s) - 36*s**2 + 26*s - 9)) - 2*Dd**2*f*(6*r*(4*s - 1) + 54*s**2 - 39*s + 4)) - 3*b1*(2112*C*D1**2*f*fd*r*s - 1056*C*D1**2*f*fd*r + 4752*C*D1**2*f*fd*s**2 - 3168*C*D1**2*f*fd*s + 1056*C*D1**2*f*fd - 1056*C*D1**2*f*fdd*r*s + 528*C*D1**2*f*fdd*r - 2376*C*D1**2*f*fdd*s**2 + 1584*C*D1**2*f*fdd*s - 528*C*D1**2*f*fdd - 1056*C*D1**2*fd**2*r*s + 528*C*D1**2*fd**2*r - 2376*C*D1**2*fd**2*s**2 + 1584*C*D1**2*fd**2*s - 528*C*D1**2*fd**2 + 4224*C*D1*Dd*f**2*r*s - 1056*C*D1*Dd*f**2*r + 9504*C*D1*Dd*f**2*s**2 - 6864*C*D1*Dd*f**2*s + 2376*C*D1*Dd*f**2 - 8448*C*D1*Dd*f*fd*r*s + 3168*C*D1*Dd*f*fd*r - 19008*C*D1*Dd*f*fd*s**2 + 13200*C*D1*Dd*f*fd*s - 2640*C*D1*Dd*f*fd - 2112*C*D1*Ddd*f**2*r*s + 528*C*D1*Ddd*f**2*r - 4752*C*D1*Ddd*f**2*s**2 + 3432*C*D1*Ddd*f**2*s - 1188*C*D1*Ddd*f**2 - 6336*C*Dd**2*f**2*r*s + 1584*C*Dd**2*f**2*r - 14256*C*Dd**2*f**2*s**2 + 10296*C*Dd**2*f**2*s - 1056*C*Dd**2*f**2 - 4048*D1**2*K*f*fd*r*s + 2024*D1**2*K*f*fd*r + 5456*D1**2*K*f*fd*s**2 - 5456*D1**2*K*f*fd*s + 2728*D1**2*K*f*fd + 2288*D1**2*K*f*fdd*r*s - 1144*D1**2*K*f*fdd*r - 2332*D1**2*K*f*fdd*s**2 + 2332*D1**2*K*f*fdd*s - 1166*D1**2*K*f*fdd + 2288*D1**2*K*fd**2*r*s - 1144*D1**2*K*fd**2*r - 2332*D1**2*K*fd**2*s**2 + 2332*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(K - 1)*(8*r*s + 18*s**2 - 14*s + 5) + 10680*D1**2*f**2*fd*r*s - 3560*D1**2*f**2*fd*r + 3180*D1**2*f**2*fd*s**2 - 4180*D1**2*f**2*fd*s - 190*D1**2*f**2*fd - 6000*D1**2*f**2*fdd*r*s + 2000*D1**2*f**2*fdd*r - 2250*D1**2*f**2*fdd*s**2 + 2750*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd - 12000*D1**2*f*fd**2*r*s + 4000*D1**2*f*fd**2*r - 4500*D1**2*f*fd**2*s**2 + 5500*D1**2*f*fd**2*s - 2500*D1**2*f*fd**2 + 6688*D1**2*f*fd*r*s - 3344*D1**2*f*fd*r - 1056*D1**2*f*fd*s**2 - 528*D1**2*f*fd*s + 792*D1**2*f*fd - 3872*D1**2*f*fdd*r*s + 1936*D1**2*f*fdd*r - 132*D1**2*f*fdd*s**2 + 924*D1**2*f*fdd*s - 726*D1**2*f*fdd - 1056*D1**2*f*gd2*r*s - 2376*D1**2*f*gd2*s**2 + 1056*D1**2*f*gd2*s + 528*D1**2*f*gdd2*r*s + 1188*D1**2*f*gdd2*s**2 - 528*D1**2*f*gdd2*s - 3872*D1**2*fd**2*r*s + 1936*D1**2*fd**2*r - 132*D1**2*fd**2*s**2 + 924*D1**2*fd**2*s + 528*D1**2*fd**2 - 1056*D1**2*fd*g2*r*s + 1056*D1**2*fd*g2*r - 2376*D1**2*fd*g2*s**2 + 2112*D1**2*fd*g2*s - 1056*D1**2*fd*g2 + 1056*D1**2*fd*gd2*r*s - 528*D1**2*fd*gd2*r + 2376*D1**2*fd*gd2*s**2 - 1584*D1**2*fd*gd2*s + 528*D1**2*fd*gd2 + 528*D1**2*fdd*g2*r*s - 528*D1**2*fdd*g2*r + 1188*D1**2*fdd*g2*s**2 - 1056*D1**2*fdd*g2*s + 528*D1**2*fdd*g2 - 8096*D1*Dd*K*f**2*r*s + 2024*D1*Dd*K*f**2*r + 10912*D1*Dd*K*f**2*s**2 - 1408*D1*Dd*K*f**2*s + 2728*D1*Dd*K*f**2 + 18304*D1*Dd*K*f*fd*r*s - 6864*D1*Dd*K*f*fd*r - 18656*D1*Dd*K*f*fd*s**2 + 9416*D1*Dd*K*f*fd*s - 44*D1*Dd*K*f*fd + 14240*D1*Dd*f**3*r*s - 3560*D1*Dd*f**3*r + 4240*D1*Dd*f**3*s**2 - 9240*D1*Dd*f**3*s + 1060*D1*Dd*f**3 - 48000*D1*Dd*f**2*fd*r*s + 14000*D1*Dd*f**2*fd*r - 18000*D1*Dd*f**2*fd*s**2 + 27500*D1*Dd*f**2*fd*s - 6750*D1*Dd*f**2*fd + 13376*D1*Dd*f**2*r*s - 3344*D1*Dd*f**2*r - 2112*D1*Dd*f**2*s**2 - 5632*D1*Dd*f**2*s - 528*D1*Dd*f**2 - 30976*D1*Dd*f*fd*r*s + 11616*D1*Dd*f*fd*r - 1056*D1*Dd*f*fd*s**2 + 11704*D1*Dd*f*fd*s - 4796*D1*Dd*f*fd - 4224*D1*Dd*f*g2*r*s + 1056*D1*Dd*f*g2*r - 9504*D1*Dd*f*g2*s**2 + 6864*D1*Dd*f*g2*s - 2376*D1*Dd*f*g2 + 4224*D1*Dd*f*gd2*r*s - 528*D1*Dd*f*gd2*r + 9504*D1*Dd*f*gd2*s**2 - 5544*D1*Dd*f*gd2*s + 528*D1*Dd*f*gd2 + 4224*D1*Dd*fd*g2*r*s - 2640*D1*Dd*fd*g2*r + 9504*D1*Dd*fd*g2*s**2 - 7656*D1*Dd*fd*g2*s + 2112*D1*Dd*fd*g2 + 4576*D1*Ddd*K*f**2*r*s - 1144*D1*Ddd*K*f**2*r - 4664*D1*Ddd*K*f**2*s**2 + 44*D1*Ddd*K*f**2*s - 1166*D1*Ddd*K*f**2 - 8000*D1*Ddd*f**3*r*s + 2000*D1*Ddd*f**3*r - 3000*D1*Ddd*f**3*s**2 + 5500*D1*Ddd*f**3*s - 750*D1*Ddd*f**3 - 7744*D1*Ddd*f**2*r*s + 1936*D1*Ddd*f**2*r - 264*D1*Ddd*f**2*s**2 + 4004*D1*Ddd*f**2*s - 66*D1*Ddd*f**2 + 2112*D1*Ddd*f*g2*r*s - 528*D1*Ddd*f*g2*r + 4752*D1*Ddd*f*g2*s**2 - 3432*D1*Ddd*f*g2*s + 1188*D1*Ddd*f*g2 + 132*D1*bd1*(K - 1)*(D1*(f*(8*r*s + 18*s**2 - 14*s + 5) + fd*(-8*r*s + 4*r - 18*s**2 + 15*s - 2)) + Dd*f*(r*(4 - 32*s) - 72*s**2 + 54*s - 7)) + 13728*Dd**2*K*f**2*r*s - 3432*Dd**2*K*f**2*r - 13992*Dd**2*K*f**2*s**2 + 132*Dd**2*K*f**2*s + 2288*Dd**2*K*f**2 - 24000*Dd**2*f**3*r*s + 6000*Dd**2*f**3*r - 9000*Dd**2*f**3*s**2 + 16500*Dd**2*f**3*s - 4000*Dd**2*f**3 - 23232*Dd**2*f**2*r*s + 5808*Dd**2*f**2*r - 792*Dd**2*f**2*s**2 + 12012*Dd**2*f**2*s - 3872*Dd**2*f**2 + 6336*Dd**2*f*g2*r*s - 1584*Dd**2*f*g2*r + 14256*Dd**2*f*g2*s**2 - 10296*Dd**2*f*g2*s + 1056*Dd**2*f*g2))/(1386*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**4*k1**2*k2*(-2112*C*D1**2*bdd1*f**2*r*s + 4752*C*D1**2*bdd1*f**2*r + 660*C*D1**2*bdd1*f**2*s**2 + 3960*C*D1**2*bdd1*f**2*s - 1980*C*D1**2*bdd1*f**2 + 21360*C*D1**2*f**2*fd*r*s - 7120*C*D1**2*f**2*fd*r + 55680*C*D1**2*f**2*fd*s**2 - 44240*C*D1**2*f**2*fd*s + 18560*C*D1**2*f**2*fd - 22560*C*D1**2*f**2*fdd*r*s + 7520*C*D1**2*f**2*fdd*r - 43680*C*D1**2*f**2*fdd*s**2 + 36640*C*D1**2*f**2*fdd*s - 14560*C*D1**2*f**2*fdd - 45120*C*D1**2*f*fd**2*r*s + 15040*C*D1**2*f*fd**2*r - 87360*C*D1**2*f*fd**2*s**2 + 73280*C*D1**2*f*fd**2*s - 7520*C*D1**2*f*fd**2 + 28480*C*D1*Dd*f**3*r*s - 7120*C*D1*Dd*f**3*r + 74240*C*D1*Dd*f**3*s**2 - 51360*C*D1*Dd*f**3*s + 18560*C*D1*Dd*f**3 - 180480*C*D1*Dd*f**2*fd*r*s + 52640*C*D1*Dd*f**2*fd*r - 349440*C*D1*Dd*f**2*fd*s**2 + 279040*C*D1*Dd*f**2*fd*s - 51680*C*D1*Dd*f**2*fd - 30080*C*D1*Ddd*f**3*r*s + 7520*C*D1*Ddd*f**3*r - 58240*C*D1*Ddd*f**3*s**2 + 44160*C*D1*Ddd*f**3*s - 14560*C*D1*Ddd*f**3 - 90240*C*Dd**2*f**3*r*s + 22560*C*Dd**2*f**3*r - 174720*C*Dd**2*f**3*s**2 + 132480*C*Dd**2*f**3*s - 15040*C*Dd**2*f**3 - 4224*D1**2*K*bdd1*f**2*r*s - 8679*D1**2*K*bdd1*f**2*s**2 + 4224*D1**2*K*bdd1*f**2*s + 4752*D1**2*b2*f*fd*r*s - 2376*D1**2*b2*f*fd*r + 4752*D1**2*b2*f*fd*s**2 - 4752*D1**2*b2*f*fd*s + 2376*D1**2*b2*f*fd - 3960*D1**2*b2*f*fdd*r*s + 1980*D1**2*b2*f*fdd*r - 3960*D1**2*b2*f*fdd*s**2 + 3960*D1**2*b2*f*fdd*s - 1980*D1**2*b2*f*fdd - 3960*D1**2*b2*fd**2*r*s + 1980*D1**2*b2*fd**2*r - 3960*D1**2*b2*fd**2*s**2 + 3960*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*(5*f**2*(8*r*(s - 1) + 5*s**2 - 15*s + 6) + f*(48*C*s**2 - 48*C*s + K*(r*(38 - 28*s) + 13*s**2 + 49*s - 38) + r*(48*C*s - 24*C + 76*s - 50) + 47*s**2 - 133*s + 74) + 28*g2*(-2*r*s + r - s*(2*s - 2))) + 2376*D1**2*bd2*f**2*r*s + 2376*D1**2*bd2*f**2*s**2 - 2376*D1**2*bd2*f**2*s - 7920*D1**2*bd2*f*fd*r*s + 1980*D1**2*bd2*f*fd*r - 7920*D1**2*bd2*f*fd*s**2 + 7920*D1**2*bd2*f*fd*s - 1980*D1**2*bd2*f*fd + 2970*D1**2*bdd1*f**3*r + 2970*D1**2*bdd1*f**3*s**2 - 1485*D1**2*bdd1*f**3 + 5874*D1**2*bdd1*f**2*r*s - 6732*D1**2*bdd1*f**2*r + 5742*D1**2*bdd1*f**2*s**2 - 9702*D1**2*bdd1*f**2*s + 4290*D1**2*bdd1*f**2 + 1848*D1**2*bdd1*f*g2*r*s - 5016*D1**2*bdd1*f*g2*r - 858*D1**2*bdd1*f*g2*s**2 - 4620*D1**2*bdd1*f*g2*s + 2310*D1**2*bdd1*f*g2 - 1980*D1**2*bdd2*f**2*r*s - 1980*D1**2*bdd2*f**2*s**2 + 1980*D1**2*bdd2*f**2*s - 7020*D1**2*f**2*fd*r*s + 2340*D1**2*f**2*fd*r - 35160*D1**2*f**2*fd*s**2 + 25780*D1**2*f**2*fd*s - 11720*D1**2*f**2*fd + 14400*D1**2*f**2*fdd*r*s - 4800*D1**2*f**2*fdd*r + 30450*D1**2*f**2*fdd*s**2 - 25100*D1**2*f**2*fdd*s + 10150*D1**2*f**2*fdd - 7392*D1**2*f**2*gd2*r*s - 22044*D1**2*f**2*gd2*s**2 + 7392*D1**2*f**2*gd2*s + 8448*D1**2*f**2*gdd2*r*s + 17358*D1**2*f**2*gdd2*s**2 - 8448*D1**2*f**2*gdd2*s + 28800*D1**2*f*fd**2*r*s - 9600*D1**2*f*fd**2*r + 60900*D1**2*f*fd**2*s**2 - 50200*D1**2*f*fd**2*s + 4800*D1**2*f*fd**2 - 14784*D1**2*f*fd*g2*r*s + 7392*D1**2*f*fd*g2*r - 44088*D1**2*f*fd*g2*s**2 + 44088*D1**2*f*fd*g2*s - 22044*D1**2*f*fd*g2 + 33792*D1**2*f*fd*gd2*r*s - 8448*D1**2*f*fd*gd2*r + 69432*D1**2*f*fd*gd2*s**2 - 51612*D1**2*f*fd*gd2*s + 8448*D1**2*f*fd*gd2 + 16896*D1**2*f*fdd*g2*r*s - 8448*D1**2*f*fdd*g2*r + 34716*D1**2*f*fdd*g2*s**2 - 34716*D1**2*f*fdd*g2*s + 17358*D1**2*f*fdd*g2 + 16896*D1**2*fd**2*g2*r*s - 8448*D1**2*fd**2*g2*r + 34716*D1**2*fd**2*g2*s**2 - 34716*D1**2*fd**2*g2*s + 9504*D1*Dd*b2*f**2*r*s - 2376*D1*Dd*b2*f**2*r + 9504*D1*Dd*b2*f**2*s**2 - 9504*D1*Dd*b2*f**2*s + 2376*D1*Dd*b2*f**2 - 31680*D1*Dd*b2*f*fd*r*s + 11880*D1*Dd*b2*f*fd*r - 31680*D1*Dd*b2*f*fd*s**2 + 31680*D1*Dd*b2*f*fd*s - 7920*D1*Dd*b2*f*fd - 15840*D1*Dd*bd2*f**2*r*s + 1980*D1*Dd*bd2*f**2*r - 15840*D1*Dd*bd2*f**2*s**2 + 15840*D1*Dd*bd2*f**2*s - 1980*D1*Dd*bd2*f**2 - 9360*D1*Dd*f**3*r*s + 2340*D1*Dd*f**3*r - 46880*D1*Dd*f**3*s**2 + 28120*D1*Dd*f**3*s - 11720*D1*Dd*f**3 + 115200*D1*Dd*f**2*fd*r*s - 33600*D1*Dd*f**2*fd*r + 243600*D1*Dd*f**2*fd*s**2 - 190100*D1*Dd*f**2*fd*s + 34700*D1*Dd*f**2*fd - 29568*D1*Dd*f**2*g2*r*s + 7392*D1*Dd*f**2*g2*r - 88176*D1*Dd*f**2*g2*s**2 + 58872*D1*Dd*f**2*g2*s - 22044*D1*Dd*f**2*g2 + 67584*D1*Dd*f**2*gd2*r*s - 8448*D1*Dd*f**2*gd2*r + 138864*D1*Dd*f**2*gd2*s**2 - 85404*D1*Dd*f**2*gd2*s + 8448*D1*Dd*f**2*gd2 + 135168*D1*Dd*f*fd*g2*r*s - 50688*D1*Dd*f*fd*g2*r + 277728*D1*Dd*f*fd*g2*s**2 - 242088*D1*Dd*f*fd*g2*s + 51612*D1*Dd*f*fd*g2 - 7920*D1*Ddd*b2*f**2*r*s + 1980*D1*Ddd*b2*f**2*r - 7920*D1*Ddd*b2*f**2*s**2 + 7920*D1*Ddd*b2*f**2*s - 1980*D1*Ddd*b2*f**2 + 19200*D1*Ddd*f**3*r*s - 4800*D1*Ddd*f**3*r + 40600*D1*Ddd*f**3*s**2 - 29900*D1*Ddd*f**3*s + 10150*D1*Ddd*f**3 + 33792*D1*Ddd*f**2*g2*r*s - 8448*D1*Ddd*f**2*g2*r + 69432*D1*Ddd*f**2*g2*s**2 - 51612*D1*Ddd*f**2*g2*s + 17358*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(5*f**3*(r*(6*s - 9) - 6*s**2 - 7*s + 6) + f**2*(8*C*(r*(14*s - 15) + 2*s**2 - 6*s + 3) + 56*K*r*s + 167*K*s**2 - 56*K*s + 45*fd*(2*r + 6*s**2 - 2*s - 1) - 142*r*s + 168*r - 126*s**2 + 138*s - 82) + f*(fd*(8*C*(r*(13 - 16*s) + 5*s**2 + 9*s - 9) + K*(-256*r*s + 64*r - 526*s**2 + 391*s - 64) + 356*r*s - 191*r + 348*s**2 - 410*s + 119) - 4*g2*(r*(28*s - 31) + 4*s**2 - 14*s + 7) - 2*gd2*(r*(38 - 28*s) + 13*s**2 + 49*s - 38)) + 2*fd*g2*(14*r*(2*s - 1) + s*(13 - 13*s))) + Dd*f*(90*f**2*(2*r + 4*s**2 - s - 1) + f*(4*C*(r*(80 - 64*s) + 20*s**2 + 71*s - 51) + K*(-512*r*s + 64*r - 1052*s**2 + 647*s - 64) + 712*r*s - 497*r + 696*s**2 - 940*s + 351) + 2*g2*(2*r*(56*s - 83) - 52*s**2 - 155*s + 111))) - 23760*Dd**2*b2*f**2*r*s + 5940*Dd**2*b2*f**2*r - 23760*Dd**2*b2*f**2*s**2 + 23760*Dd**2*b2*f**2*s - 3960*Dd**2*b2*f**2 + 57600*Dd**2*f**3*r*s - 14400*Dd**2*f**3*r + 121800*Dd**2*f**3*s**2 - 89700*Dd**2*f**3*s + 9600*Dd**2*f**3 + 101376*Dd**2*f**2*g2*r*s - 25344*Dd**2*f**2*g2*r + 208296*Dd**2*f**2*g2*s**2 - 154836*Dd**2*f**2*g2*s + 16896*Dd**2*f**2*g2 - 924*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) - 33*b1**2*(96*C*D1**2*fd*r*s + 96*C*D1**2*fd*s**2 - 96*C*D1**2*fd*s - 48*C*D1**2*fdd*r*s - 48*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s + 384*C*D1*Dd*f*r*s - 96*C*D1*Dd*f*r + 384*C*D1*Dd*f*s**2 - 384*C*D1*Dd*f*s + 96*C*D1*Dd*f - 384*C*D1*Dd*fd*r*s + 48*C*D1*Dd*fd*r - 384*C*D1*Dd*fd*s**2 + 384*C*D1*Dd*fd*s - 48*C*D1*Dd*fd - 192*C*D1*Ddd*f*r*s + 48*C*D1*Ddd*f*r - 192*C*D1*Ddd*f*s**2 + 192*C*D1*Ddd*f*s - 48*C*D1*Ddd*f - 576*C*Dd**2*f*r*s + 144*C*Dd**2*f*r - 576*C*Dd**2*f*s**2 + 576*C*Dd**2*f*s - 96*C*Dd**2*f - 112*D1**2*K*fd*r*s - 12*D1**2*K*fd*r - 16*D1**2*K*fd*s**2 - 24*D1**2*K*fd*s + 12*D1**2*K*fd + 28*D1**2*K*fdd*r*s + 48*D1**2*K*fdd*r - 13*D1**2*K*fdd*s**2 + 96*D1**2*K*fdd*s - 48*D1**2*K*fdd - 28*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 160*D1**2*f*fd*r*s + 56*D1**2*f*fd*r + 100*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s - 56*D1**2*f*fd - 80*D1**2*f*fdd*r*s - 40*D1**2*f*fdd*r - 50*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 40*D1**2*f*fdd - 80*D1**2*fd**2*r*s - 40*D1**2*fd**2*r - 50*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s + 40*D1**2*fd**2 + 152*D1**2*fd*r*s - 8*D1**2*fd*r + 80*D1**2*fd*s**2 + 80*D1**2*fd*s + 8*D1**2*fd - 76*D1**2*fdd*r*s - 24*D1**2*fdd*r - 47*D1**2*fdd*s**2 - 96*D1**2*fdd*s + 24*D1**2*fdd - 112*D1**2*gd2*r*s - 112*D1**2*gd2*s**2 + 112*D1**2*gd2*s + 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s - 448*D1*Dd*K*f*r*s + 112*D1*Dd*K*f*r - 64*D1*Dd*K*f*s**2 + 256*D1*Dd*K*f*s - 16*D1*Dd*K*f + 224*D1*Dd*K*fd*r*s + 164*D1*Dd*K*fd*r - 104*D1*Dd*K*fd*s**2 + 354*D1*Dd*K*fd*s - 192*D1*Dd*K*fd + 320*D1*Dd*f**2*r*s - 80*D1*Dd*f**2*r + 200*D1*Dd*f**2*s**2 - 260*D1*Dd*f**2*s + 50*D1*Dd*f**2 - 640*D1*Dd*f*fd*r*s - 80*D1*Dd*f*fd*r - 400*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s + 100*D1*Dd*f*fd + 608*D1*Dd*f*r*s - 152*D1*Dd*f*r + 320*D1*Dd*f*s**2 - 464*D1*Dd*f*s + 80*D1*Dd*f - 608*D1*Dd*fd*r*s - 20*D1*Dd*fd*r - 376*D1*Dd*fd*s**2 - 138*D1*Dd*fd*s + 144*D1*Dd*fd - 448*D1*Dd*g2*r*s + 112*D1*Dd*g2*r - 448*D1*Dd*g2*s**2 + 448*D1*Dd*g2*s - 112*D1*Dd*g2 + 448*D1*Dd*gd2*r*s - 56*D1*Dd*gd2*r + 448*D1*Dd*gd2*s**2 - 448*D1*Dd*gd2*s + 56*D1*Dd*gd2 + 112*D1*Ddd*K*f*r*s - 28*D1*Ddd*K*f*r - 52*D1*Ddd*K*f*s**2 - 30*D1*Ddd*K*f*s - 13*D1*Ddd*K*f - 160*D1*Ddd*f**2*r*s + 40*D1*Ddd*f**2*r - 100*D1*Ddd*f**2*s**2 + 130*D1*Ddd*f**2*s - 25*D1*Ddd*f**2 - 304*D1*Ddd*f*r*s + 76*D1*Ddd*f*r - 188*D1*Ddd*f*s**2 + 246*D1*Ddd*f*s - 47*D1*Ddd*f + 224*D1*Ddd*g2*r*s - 56*D1*Ddd*g2*r + 224*D1*Ddd*g2*s**2 - 224*D1*Ddd*g2*s + 56*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 336*Dd**2*K*f*r*s - 84*Dd**2*K*f*r - 156*Dd**2*K*f*s**2 - 90*Dd**2*K*f*s + 56*Dd**2*K*f - 480*Dd**2*f**2*r*s + 120*Dd**2*f**2*r - 300*Dd**2*f**2*s**2 + 390*Dd**2*f**2*s - 80*Dd**2*f**2 - 912*Dd**2*f*r*s + 228*Dd**2*f*r - 564*Dd**2*f*s**2 + 738*Dd**2*f*s - 152*Dd**2*f + 672*Dd**2*g2*r*s - 168*Dd**2*g2*r + 672*Dd**2*g2*s**2 - 672*Dd**2*g2*s + 112*Dd**2*g2) + 33*b1*(448*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*r + 64*C*D1**2*f*fd*s**2 - 192*C*D1**2*f*fd*s - 16*C*D1**2*f*fd - 128*C*D1**2*f*fdd*r*s - 80*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 96*C*D1**2*f*fdd*s + 80*C*D1**2*f*fdd - 128*C*D1**2*fd**2*r*s - 80*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 96*C*D1**2*fd**2*s + 80*C*D1**2*fd**2 + 896*C*D1*Dd*f**2*r*s - 224*C*D1*Dd*f**2*r + 128*C*D1*Dd*f**2*s**2 - 512*C*D1*Dd*f**2*s + 32*C*D1*Dd*f**2 - 1024*C*D1*Dd*f*fd*r*s - 192*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 208*C*D1*Dd*f*fd*s + 256*C*D1*Dd*f*fd - 256*C*D1*Ddd*f**2*r*s + 64*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 + 88*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 - 768*C*Dd**2*f**2*r*s + 192*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 + 264*C*Dd**2*f**2*s - 128*C*Dd**2*f**2 + 224*D1**2*K*f*fd*r*s - 112*D1**2*K*f*fd*r + 668*D1**2*K*f*fd*s**2 - 668*D1**2*K*f*fd*s + 334*D1**2*K*f*fd - 256*D1**2*K*f*fdd*r*s + 128*D1**2*K*f*fdd*r - 526*D1**2*K*f*fdd*s**2 + 526*D1**2*K*f*fdd*s - 263*D1**2*K*f*fdd - 256*D1**2*K*fd**2*r*s + 128*D1**2*K*fd**2*r - 526*D1**2*K*fd**2*s**2 + 526*D1**2*K*fd**2*s + 28*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(5*f**2*(16*r*(s - 1) + 10*s**2 - 30*s + 13) + f*(48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-56*r*s + 76*r + 26*s**2 + 98*s - 35) + 152*r*s - 100*r + 94*s**2 - 266*s + 71) - 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 180*D1**2*f**2*fd*r*s + 30*D1**2*f**2*fd*r - 180*D1**2*f**2*fd*s**2 + 70*D1**2*f**2*fd*s - 120*D1**2*f**2*fd - 90*D1**2*f**2*fdd*r + 270*D1**2*f**2*fdd*s**2 - 180*D1**2*f**2*fdd*s + 135*D1**2*f**2*fdd - 180*D1**2*f*fd**2*r + 540*D1**2*f*fd**2*s**2 - 360*D1**2*f*fd**2*s + 90*D1**2*f*fd**2 - 568*D1**2*f*fd*r*s - 52*D1**2*f*fd*r - 504*D1**2*f*fd*s**2 + 512*D1**2*f*fd*s - 88*D1**2*f*fd + 356*D1**2*f*fdd*r*s + 26*D1**2*f*fdd*r + 348*D1**2*f*fdd*s**2 - 232*D1**2*f*fdd*s + 44*D1**2*f*fdd - 224*D1**2*f*gd2*r*s - 32*D1**2*f*gd2*s**2 + 224*D1**2*f*gd2*s + 56*D1**2*f*gdd2*r*s - 26*D1**2*f*gdd2*s**2 - 56*D1**2*f*gdd2*s + 356*D1**2*fd**2*r*s + 26*D1**2*fd**2*r + 348*D1**2*fd**2*s**2 - 232*D1**2*fd**2*s - 60*D1**2*fd**2 - 224*D1**2*fd*g2*r*s - 24*D1**2*fd*g2*r - 32*D1**2*fd*g2*s**2 - 48*D1**2*fd*g2*s + 24*D1**2*fd*g2 + 112*D1**2*fd*gd2*r*s + 96*D1**2*fd*gd2*r - 52*D1**2*fd*gd2*s**2 + 136*D1**2*fd*gd2*s - 96*D1**2*fd*gd2 + 56*D1**2*fdd*g2*r*s + 96*D1**2*fdd*g2*r - 26*D1**2*fdd*g2*s**2 + 192*D1**2*fdd*g2*s - 96*D1**2*fdd*g2 + 448*D1*Dd*K*f**2*r*s - 112*D1*Dd*K*f**2*r + 1336*D1*Dd*K*f**2*s**2 - 892*D1*Dd*K*f**2*s + 334*D1*Dd*K*f**2 - 2048*D1*Dd*K*f*fd*r*s + 768*D1*Dd*K*f*fd*r - 4208*D1*Dd*K*f*fd*s**2 + 3668*D1*Dd*K*f*fd*s - 782*D1*Dd*K*f*fd + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r - 240*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r + 2160*D1*Dd*f**2*fd*s**2 - 1260*D1*Dd*f**2*fd*s + 360*D1*Dd*f**2*fd - 1136*D1*Dd*f**2*r*s + 284*D1*Dd*f**2*r - 1008*D1*Dd*f**2*s**2 + 1072*D1*Dd*f**2*s - 252*D1*Dd*f**2 + 2848*D1*Dd*f*fd*r*s - 252*D1*Dd*f*fd*r + 2784*D1*Dd*f*fd*s**2 - 2336*D1*Dd*f*fd*s + 180*D1*Dd*f*fd - 896*D1*Dd*f*g2*r*s + 224*D1*Dd*f*g2*r - 128*D1*Dd*f*g2*s**2 + 512*D1*Dd*f*g2*s - 32*D1*Dd*f*g2 + 448*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r - 208*D1*Dd*f*gd2*s**2 - 284*D1*Dd*f*gd2*s + 56*D1*Dd*f*gd2 + 448*D1*Dd*fd*g2*r*s + 328*D1*Dd*fd*g2*r - 208*D1*Dd*fd*g2*s**2 + 708*D1*Dd*fd*g2*s - 384*D1*Dd*fd*g2 - 512*D1*Ddd*K*f**2*r*s + 128*D1*Ddd*K*f**2*r - 1052*D1*Ddd*K*f**2*s**2 + 782*D1*Ddd*K*f**2*s - 263*D1*Ddd*K*f**2 + 360*D1*Ddd*f**3*s**2 - 180*D1*Ddd*f**3*s + 90*D1*Ddd*f**3 + 712*D1*Ddd*f**2*r*s - 178*D1*Ddd*f**2*r + 696*D1*Ddd*f**2*s**2 - 704*D1*Ddd*f**2*s + 174*D1*Ddd*f**2 + 224*D1*Ddd*f*g2*r*s - 56*D1*Ddd*f*g2*r - 104*D1*Ddd*f*g2*s**2 - 60*D1*Ddd*f*g2*s - 26*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(f**2*(r*(80*s - 68) + 50*s**2 - 126*s + 53) + 2*f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 56*K*r*s + 31*K*r - 8*K*s**2 + 42*K*s - 7*K - 5*fd*(16*r*s - 4*r + 10*s**2 - 13*s + 3) + 76*r*s - 36*r + 40*s**2 - 98*s + 18) + fd*(-24*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(56*r*s + 10*r - 26*s**2 + 47*s - 24) - 152*r*s + 26*r - 94*s**2 + 37*s + 36) - 28*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 28*gd2*(-4*r*s + r - (1 - 2*s)**2)) - Dd*(5*f**2*(8*r*(8*s - 5) + 40*s**2 - 86*s + 31) + f*(48*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + K*(-224*r*s + 180*r + 104*s**2 + 226*s - 125) + 608*r*s - 276*r + 376*s**2 - 778*s + 233) - 56*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 1536*Dd**2*K*f**2*r*s + 384*Dd**2*K*f**2*r - 3156*Dd**2*K*f**2*s**2 + 2346*Dd**2*K*f**2*s - 256*Dd**2*K*f**2 + 1080*Dd**2*f**3*s**2 - 540*Dd**2*f**3*s + 2136*Dd**2*f**2*r*s - 534*Dd**2*f**2*r + 2088*Dd**2*f**2*s**2 - 2112*Dd**2*f**2*s + 356*Dd**2*f**2 + 672*Dd**2*f*g2*r*s - 168*Dd**2*f*g2*r - 312*Dd**2*f*g2*s**2 - 180*Dd**2*f*g2*s + 112*Dd**2*f*g2))/(693*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**4*k1**2*st**2*(D1**2*(792*bd1*fd*g2*s*(s - 1) + f**3*s**2*(2250*bd1 - 1125*bdd1) - 2*f**2*(125*fd*(s**2*(27*bd1 - 12) + s*(8 - 9*bd1) - 4) + 250*fdd*(3*s**2 - 2*s + 1) + s**2*(3*C + 2)*(-132*bd1 + 66*bdd1)) - 4*f*s*(99*bd1**2*s*(K - 1) + 66*bd1*(fd*(3*C + 2)*(2*s - 1) + s*(3*g2 - 3*gd2)) - 99*bdd1*g2*s + 250*fd**2*(3*s - 2))) - 2*D1*f*(Dd*(396*bd1*g2*s*(1 - 4*s) + 125*f**2*(s**2*(36*bd1 - 16) + s*(8 - 9*bd1) - 4) + 4*f*(4*s - 1)*(33*bd1*s*(3*C + 2) + 125*fd*(3*s - 1))) + 250*Ddd*f**2*(4*s**2 - 2*s + 1)) + 3000*Dd**2*f**3*s*(1 - 2*s) + 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + 3*b1*(D1**2*(375*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) - 2*f*(375*fd**2*s*(3*s - 2) - fd*(132*C + 88)*(2*s**2 - 2*s + 1) + fdd*(66*C + 44)*(2*s**2 - 2*s + 1) + s**2*(66*K*bdd1 - 132*bd1*(K - 1) - 66*bdd1 + 132*gd2 - 66*gdd2)) + (44 - 44*s)*(fd**2*s*(6*C + 4) + 6*fd*g2*(s - 1) - 6*fd*s*(-K*bd1 + bd1 + gd2) - 3*fdd*g2*(s - 1))) + D1*(2*Dd*(375*f**3*(4*s**2 - 2*s + 1) + f**2*(132*C*(4*s**2 - 2*s + 1) - 375*fd*(12*s**2 - 7*s + 1) + 352*s**2 - 176*s + 88) - 44*f*(fd*(3*C + 2)*(8*s**2 - 6*s + 1) + 3*g2*(4*s**2 - 2*s + 1) + s*(4*s - 1)*(3*K*bd1 - 3*bd1 - 3*gd2)) + 132*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(375*f**2 + f*(132*C + 88) - 132*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(375*f**2 + f*(132*C + 88) - 132*g2)))/(154*d**2*k2*k3**2) + D1**2*Pk3*Pkd2*ct**4*k1**2*(3300*C*D1**2*bdd1*f**2*s**2 - 8400*C*D1**2*f**2*fd*s**2 + 5600*C*D1**2*f**2*fd*s - 2800*C*D1**2*f**2*fd + 4200*C*D1**2*f**2*fdd*s**2 - 2800*C*D1**2*f**2*fdd*s + 1400*C*D1**2*f**2*fdd + 8400*C*D1**2*f*fd**2*s**2 - 5600*C*D1**2*f*fd**2*s - 11200*C*D1*Dd*f**3*s**2 + 5600*C*D1*Dd*f**3*s - 2800*C*D1*Dd*f**3 + 33600*C*D1*Dd*f**2*fd*s**2 - 19600*C*D1*Dd*f**2*fd*s + 2800*C*D1*Dd*f**2*fd + 5600*C*D1*Ddd*f**3*s**2 - 2800*C*D1*Ddd*f**3*s + 1400*C*D1*Ddd*f**3 + 16800*C*Dd**2*f**3*s**2 - 8400*C*Dd**2*f**3*s + 825*D1**2*K*bdd1*f**2*s**2 - 3300*D1**2*b2*f*fd*s**2 + 3300*D1**2*b2*f*fd*s - 1650*D1**2*b2*f*fd + 1650*D1**2*b2*f*fdd*s**2 - 1650*D1**2*b2*f*fdd*s + 825*D1**2*b2*f*fdd + 1650*D1**2*b2*fd**2*s**2 - 1650*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*s*(60*C*f*(s - 1) + 25*f**2*(2*s - 3) - 59*f*s*(K - 1) - 70*g2*(s - 1)) - 1650*D1**2*bd2*f**2*s**2 + 3300*D1**2*bd2*f*fd*s**2 - 1650*D1**2*bd2*f*fd*s + 1980*D1**2*bdd1*f**3*r*s + 4455*D1**2*bdd1*f**3*s**2 - 990*D1**2*bdd1*f**3*s + 1122*D1**2*bdd1*f**2*r*s - 1518*D1**2*bdd1*f**2*s**2 + 2178*D1**2*bdd1*f**2*s - 1650*D1**2*bdd1*f**2 - 3894*D1**2*bdd1*f*g2*s**2 + 825*D1**2*bdd2*f**2*s**2 - 4260*D1**2*f**2*fd*r*s + 1420*D1**2*f**2*fd*r - 11040*D1**2*f**2*fd*s**2 + 8780*D1**2*f**2*fd*s - 3680*D1**2*f**2*fd + 3120*D1**2*f**2*fdd*r*s - 1040*D1**2*f**2*fdd*r + 6510*D1**2*f**2*fdd*s**2 - 5380*D1**2*f**2*fdd*s + 2170*D1**2*f**2*fdd + 3300*D1**2*f**2*gd2*s**2 - 1650*D1**2*f**2*gdd2*s**2 + 6240*D1**2*f*fd**2*r*s - 2080*D1**2*f*fd**2*r + 13020*D1**2*f*fd**2*s**2 - 10760*D1**2*f*fd**2*s + 1040*D1**2*f*fd**2 + 6600*D1**2*f*fd*g2*s**2 - 6600*D1**2*f*fd*g2*s + 3300*D1**2*f*fd*g2 - 6600*D1**2*f*fd*gd2*s**2 + 3300*D1**2*f*fd*gd2*s - 3300*D1**2*f*fdd*g2*s**2 + 3300*D1**2*f*fdd*g2*s - 1650*D1**2*f*fdd*g2 - 3300*D1**2*fd**2*g2*s**2 + 3300*D1**2*fd**2*g2*s - 6600*D1*Dd*b2*f**2*s**2 + 3300*D1*Dd*b2*f**2*s - 1650*D1*Dd*b2*f**2 + 13200*D1*Dd*b2*f*fd*s**2 - 9900*D1*Dd*b2*f*fd*s + 1650*D1*Dd*b2*f*fd + 6600*D1*Dd*bd2*f**2*s**2 - 1650*D1*Dd*bd2*f**2*s - 5680*D1*Dd*f**3*r*s + 1420*D1*Dd*f**3*r - 14720*D1*Dd*f**3*s**2 + 10200*D1*Dd*f**3*s - 3680*D1*Dd*f**3 + 24960*D1*Dd*f**2*fd*r*s - 7280*D1*Dd*f**2*fd*r + 52080*D1*Dd*f**2*fd*s**2 - 40780*D1*Dd*f**2*fd*s + 7460*D1*Dd*f**2*fd + 13200*D1*Dd*f**2*g2*s**2 - 6600*D1*Dd*f**2*g2*s + 3300*D1*Dd*f**2*g2 - 13200*D1*Dd*f**2*gd2*s**2 + 3300*D1*Dd*f**2*gd2*s - 26400*D1*Dd*f*fd*g2*s**2 + 19800*D1*Dd*f*fd*g2*s - 3300*D1*Dd*f*fd*g2 + 3300*D1*Ddd*b2*f**2*s**2 - 1650*D1*Ddd*b2*f**2*s + 825*D1*Ddd*b2*f**2 + 4160*D1*Ddd*f**3*r*s - 1040*D1*Ddd*f**3*r + 8680*D1*Ddd*f**3*s**2 - 6420*D1*Ddd*f**3*s + 2170*D1*Ddd*f**3 - 6600*D1*Ddd*f**2*g2*s**2 + 3300*D1*Ddd*f**2*g2*s - 1650*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(15*f**3*s*(2*r + 8*s - 1) + f**2*(-15*fd*(2*r*(6*s - 1) + 27*s**2 - 15*s + 1) + s**2*(88*C + 25*K - 46) + s*(22*r + 78) - 50) + f*(fd*(r*(17 - 68*s) + s**2*(-200*C - 50*K + 92) + s*(100*C + 25*K - 62) - 17) + s**2*(-104*g2 + 118*gd2)) + 118*fd*g2*s*(s - 1)) + Dd*f*(-15*f**2*(2*r*(8*s - 1) + 36*s**2 - 17*s + 1) + f*(-17*r*(8*s - 1) - s**2*(400*C + 100*K - 184) + s*(100*C + 25*K - 144) + 33) + 118*g2*s*(4*s - 1))) + 9900*Dd**2*b2*f**2*s**2 - 4950*Dd**2*b2*f**2*s + 12480*Dd**2*f**3*r*s - 3120*Dd**2*f**3*r + 26040*Dd**2*f**3*s**2 - 19260*Dd**2*f**3*s + 2080*Dd**2*f**3 - 19800*Dd**2*f**2*g2*s**2 + 9900*Dd**2*f**2*g2*s + 1155*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 33*b1**2*(120*C*D1**2*fd*s**2 - 60*C*D1**2*fdd*s**2 + 480*C*D1*Dd*f*s**2 - 240*C*D1*Dd*f*s + 120*C*D1*Dd*f - 480*C*D1*Dd*fd*s**2 + 120*C*D1*Dd*fd*s - 240*C*D1*Ddd*f*s**2 + 120*C*D1*Ddd*f*s - 60*C*D1*Ddd*f - 720*C*Dd**2*f*s**2 + 360*C*Dd**2*f*s - 104*D1**2*K*fd*s**2 + 208*D1**2*K*fd*s - 104*D1**2*K*fd + 59*D1**2*K*fdd*s**2 - 118*D1**2*K*fdd*s + 59*D1**2*K*fdd - 35*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) + 200*D1**2*f*fd*s**2 + 100*D1**2*f*fd*s - 50*D1**2*f*fd - 100*D1**2*f*fdd*s**2 - 50*D1**2*f*fdd*s + 25*D1**2*f*fdd - 100*D1**2*fd**2*s**2 - 50*D1**2*fd**2*s + 104*D1**2*fd*s**2 - 208*D1**2*fd*s + 104*D1**2*fd - 59*D1**2*fdd*s**2 + 118*D1**2*fdd*s - 59*D1**2*fdd - 140*D1**2*gd2*s**2 + 70*D1**2*gdd2*s**2 - 416*D1*Dd*K*f*s**2 + 208*D1*Dd*K*f*s - 104*D1*Dd*K*f + 472*D1*Dd*K*fd*s**2 - 590*D1*Dd*K*fd*s + 118*D1*Dd*K*fd + 400*D1*Dd*f**2*s**2 - 200*D1*Dd*f**2*s + 100*D1*Dd*f**2 - 800*D1*Dd*f*fd*s**2 + 50*D1*Dd*f*fd + 416*D1*Dd*f*s**2 - 208*D1*Dd*f*s + 104*D1*Dd*f - 472*D1*Dd*fd*s**2 + 590*D1*Dd*fd*s - 118*D1*Dd*fd - 560*D1*Dd*g2*s**2 + 280*D1*Dd*g2*s - 140*D1*Dd*g2 + 560*D1*Dd*gd2*s**2 - 140*D1*Dd*gd2*s + 236*D1*Ddd*K*f*s**2 - 118*D1*Ddd*K*f*s + 59*D1*Ddd*K*f - 200*D1*Ddd*f**2*s**2 + 100*D1*Ddd*f**2*s - 50*D1*Ddd*f**2 - 236*D1*Ddd*f*s**2 + 118*D1*Ddd*f*s - 59*D1*Ddd*f + 280*D1*Ddd*g2*s**2 - 140*D1*Ddd*g2*s + 70*D1*Ddd*g2 + 70*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) + 708*Dd**2*K*f*s**2 - 354*Dd**2*K*f*s - 600*Dd**2*f**2*s**2 + 300*Dd**2*f**2*s - 708*Dd**2*f*s**2 + 354*Dd**2*f*s + 840*Dd**2*g2*s**2 - 420*Dd**2*g2*s) - 33*b1*(120*C*D1**2*bdd1*f*s**2 - 120*C*D1**2*bdd1*f*s + 60*C*D1**2*bdd1*f + 352*C*D1**2*f*fd*s**2 - 352*C*D1**2*f*fd*s + 176*C*D1**2*f*fd - 200*C*D1**2*f*fdd*s**2 + 200*C*D1**2*f*fdd*s - 100*C*D1**2*f*fdd - 200*C*D1**2*fd**2*s**2 + 200*C*D1**2*fd**2*s + 704*C*D1*Dd*f**2*s**2 - 352*C*D1*Dd*f**2*s + 176*C*D1*Dd*f**2 - 1600*C*D1*Dd*f*fd*s**2 + 1200*C*D1*Dd*f*fd*s - 200*C*D1*Dd*f*fd - 400*C*D1*Ddd*f**2*s**2 + 200*C*D1*Ddd*f**2*s - 100*C*D1*Ddd*f**2 - 1200*C*Dd**2*f**2*s**2 + 600*C*Dd**2*f**2*s - 118*D1**2*K*bdd1*f*s**2 + 100*D1**2*K*f*fd*s**2 - 100*D1**2*K*f*fd*s + 50*D1**2*K*f*fd - 50*D1**2*K*f*fdd*s**2 + 50*D1**2*K*f*fdd*s - 25*D1**2*K*f*fdd - 50*D1**2*K*fd**2*s**2 + 50*D1**2*K*fd**2*s + 70*D1**2*bd1**2*s*(K - 1)*(3*s - 2) + 100*D1**2*bdd1*f**2*s**2 - 150*D1**2*bdd1*f**2*s + 75*D1**2*bdd1*f**2 + 118*D1**2*bdd1*f*s**2 - 140*D1**2*bdd1*g2*s**2 + 140*D1**2*bdd1*g2*s - 70*D1**2*bdd1*g2 + 180*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 720*D1**2*f**2*fd*s**2 - 570*D1**2*f**2*fd*s + 240*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 405*D1**2*f**2*fdd*s**2 + 360*D1**2*f**2*fdd*s - 135*D1**2*f**2*fdd - 360*D1**2*f*fd**2*r*s + 120*D1**2*f*fd**2*r - 810*D1**2*f*fd**2*s**2 + 720*D1**2*f*fd**2*s - 90*D1**2*f*fd**2 + 88*D1**2*f*fd*r*s - 44*D1**2*f*fd*r - 184*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 8*D1**2*f*fd - 68*D1**2*f*fdd*r*s + 34*D1**2*f*fdd*r + 92*D1**2*f*fdd*s**2 + 8*D1**2*f*fdd*s - 4*D1**2*f*fdd - 208*D1**2*f*gd2*s**2 + 118*D1**2*f*gdd2*s**2 - 68*D1**2*fd**2*r*s + 34*D1**2*fd**2*r + 92*D1**2*fd**2*s**2 + 8*D1**2*fd**2*s - 208*D1**2*fd*g2*s**2 + 416*D1**2*fd*g2*s - 208*D1**2*fd*g2 + 236*D1**2*fd*gd2*s**2 - 236*D1**2*fd*gd2*s + 118*D1**2*fdd*g2*s**2 - 236*D1**2*fdd*g2*s + 118*D1**2*fdd*g2 + 200*D1*Dd*K*f**2*s**2 - 100*D1*Dd*K*f**2*s + 50*D1*Dd*K*f**2 - 400*D1*Dd*K*f*fd*s**2 + 300*D1*Dd*K*f*fd*s - 50*D1*Dd*K*f*fd + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 960*D1*Dd*f**3*s**2 - 600*D1*Dd*f**3*s + 240*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r*s + 420*D1*Dd*f**2*fd*r - 3240*D1*Dd*f**2*fd*s**2 + 2610*D1*Dd*f**2*fd*s - 480*D1*Dd*f**2*fd + 176*D1*Dd*f**2*r*s - 44*D1*Dd*f**2*r - 368*D1*Dd*f**2*s**2 + 96*D1*Dd*f**2*s - 92*D1*Dd*f**2 - 544*D1*Dd*f*fd*r*s + 204*D1*Dd*f*fd*r + 736*D1*Dd*f*fd*s**2 - 16*D1*Dd*f*fd*s - 76*D1*Dd*f*fd - 832*D1*Dd*f*g2*s**2 + 416*D1*Dd*f*g2*s - 208*D1*Dd*f*g2 + 944*D1*Dd*f*gd2*s**2 - 236*D1*Dd*f*gd2*s + 944*D1*Dd*fd*g2*s**2 - 1180*D1*Dd*fd*g2*s + 236*D1*Dd*fd*g2 - 100*D1*Ddd*K*f**2*s**2 + 50*D1*Ddd*K*f**2*s - 25*D1*Ddd*K*f**2 - 240*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 540*D1*Ddd*f**3*s**2 + 390*D1*Ddd*f**3*s - 135*D1*Ddd*f**3 - 136*D1*Ddd*f**2*r*s + 34*D1*Ddd*f**2*r + 184*D1*Ddd*f**2*s**2 - 24*D1*Ddd*f**2*s + 46*D1*Ddd*f**2 + 472*D1*Ddd*f*g2*s**2 - 236*D1*Ddd*f*g2*s + 118*D1*Ddd*f*g2 - 2*D1*bd1*(60*C*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) + D1*(25*f**2*(4*s**2 - 6*s + 3) - 4*f*s*(25*fd*(2*s - 1) + s*(26*K - 26)) + 118*fd*s*(K - 1)*(s - 1) - 70*g2*(2*s**2 - 2*s + 1) + 70*gd2*s*(2*s - 1)) - Dd*(4*s - 1)*(25*f**2*(4*s - 3) - 118*f*s*(K - 1) + 70*g2*(1 - 2*s))) - 300*Dd**2*K*f**2*s**2 + 150*Dd**2*K*f**2*s - 720*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 1620*Dd**2*f**3*s**2 + 1170*Dd**2*f**3*s - 120*Dd**2*f**3 - 408*Dd**2*f**2*r*s + 102*Dd**2*f**2*r + 552*Dd**2*f**2*s**2 - 72*Dd**2*f**2*s - 68*Dd**2*f**2 + 1416*Dd**2*f*g2*s**2 - 708*Dd**2*f*g2*s))/(693*d**2*k2*k3**2) + 20*D1**2*Pk3*Pkd2*ct**4*k2**5*st**2*(D1**2*(f**2*(fd*(100*C - 50)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(50*C - 25)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(50*C - 25)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 33*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) + 33*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 33*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(100*C - 50)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(33*K*(b1*r*(8*s - 2) + 2*b1*(1 - 2*s)**2 + bd1*(-8*r*s + r - 8*s**2 + 8*s - 1)) + fd*(25 - 50*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 132*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 66*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 66*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(50*C*f + 33*K*b1 - 25*f - 66*g2)) - Dd**2*f**2*(50*C*f + 33*K*b1 - 25*f - 66*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k3**6) + 8*D1**2*Pk3*Pkd2*ct**4*k2**5*(40*C*D1**2*b1*f*fd*r*s + 40*C*D1**2*b1*f*fd*s**2 - 20*C*D1**2*b1*f*fd*s - 20*C*D1**2*b1*f*fdd*r*s - 20*C*D1**2*b1*f*fdd*s**2 + 10*C*D1**2*b1*f*fdd*s - 20*C*D1**2*b1*fd**2*r*s - 20*C*D1**2*b1*fd**2*s**2 + 10*C*D1**2*b1*fd**2*s - 30*C*D1**2*f**2*fd*r*s + 10*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 30*C*D1**2*f**2*fd*s - 10*C*D1**2*f**2*fd + 80*C*D1*Dd*b1*f**2*r*s - 20*C*D1*Dd*b1*f**2*r + 80*C*D1*Dd*b1*f**2*s**2 - 80*C*D1*Dd*b1*f**2*s + 20*C*D1*Dd*b1*f**2 - 160*C*D1*Dd*b1*f*fd*r*s + 20*C*D1*Dd*b1*f*fd*r - 160*C*D1*Dd*b1*f*fd*s**2 + 120*C*D1*Dd*b1*f*fd*s - 10*C*D1*Dd*b1*f*fd - 40*C*D1*Dd*f**3*r*s + 10*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 40*C*D1*Dd*f**3*s - 10*C*D1*Dd*f**3 - 40*C*D1*Ddd*b1*f**2*r*s + 10*C*D1*Ddd*b1*f**2*r - 40*C*D1*Ddd*b1*f**2*s**2 + 40*C*D1*Ddd*b1*f**2*s - 10*C*D1*Ddd*b1*f**2 - 120*C*Dd**2*b1*f**2*r*s + 30*C*Dd**2*b1*f**2*r - 120*C*Dd**2*b1*f**2*s**2 + 120*C*Dd**2*b1*f**2*s - 20*C*Dd**2*b1*f**2 + 12*D1**2*K*b1**2*fd*r*s + 12*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 - 12*D1**2*K*b1*f*fd*r*s + 6*D1**2*K*b1*f*fd*r - 12*D1**2*K*b1*f*fd*s**2 + 12*D1**2*K*b1*f*fd*s - 6*D1**2*K*b1*f*fd - 6*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 20*D1**2*b1*f*fd*r*s - 20*D1**2*b1*f*fd*s**2 + 10*D1**2*b1*f*fd*s + 10*D1**2*b1*f*fdd*r*s + 10*D1**2*b1*f*fdd*s**2 - 5*D1**2*b1*f*fdd*s - 24*D1**2*b1*f*gd2*r*s - 24*D1**2*b1*f*gd2*s**2 + 24*D1**2*b1*f*gd2*s + 12*D1**2*b1*f*gdd2*r*s + 12*D1**2*b1*f*gdd2*s**2 - 12*D1**2*b1*f*gdd2*s + 10*D1**2*b1*fd**2*r*s + 10*D1**2*b1*fd**2*s**2 - 5*D1**2*b1*fd**2*s - 24*D1**2*b1*fd*g2*r*s - 24*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r*s + 24*D1**2*b1*fd*gd2*s**2 - 12*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)*(6*K*b1*(2*s - 1) + f*(10*C - 5)*(s - 1) - 12*g2*(s - 1)) + 15*D1**2*f**2*fd*r*s - 5*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 15*D1**2*f**2*fd*s + 5*D1**2*f**2*fd + 12*D1**2*f**2*gd2*r*s + 12*D1**2*f**2*gd2*s**2 - 12*D1**2*f**2*gd2*s + 24*D1**2*f*fd*g2*r*s - 12*D1**2*f*fd*g2*r + 24*D1**2*f*fd*g2*s**2 - 24*D1**2*f*fd*g2*s + 12*D1**2*f*fd*g2 + 48*D1*Dd*K*b1**2*f*r*s - 12*D1*Dd*K*b1**2*f*r + 48*D1*Dd*K*b1**2*f*s**2 - 48*D1*Dd*K*b1**2*f*s + 12*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r*s + 6*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 24*D1*Dd*K*b1**2*fd*s - 24*D1*Dd*K*b1*f**2*r*s + 6*D1*Dd*K*b1*f**2*r - 24*D1*Dd*K*b1*f**2*s**2 + 24*D1*Dd*K*b1*f**2*s - 6*D1*Dd*K*b1*f**2 - 40*D1*Dd*b1*f**2*r*s + 10*D1*Dd*b1*f**2*r - 40*D1*Dd*b1*f**2*s**2 + 40*D1*Dd*b1*f**2*s - 10*D1*Dd*b1*f**2 + 80*D1*Dd*b1*f*fd*r*s - 10*D1*Dd*b1*f*fd*r + 80*D1*Dd*b1*f*fd*s**2 - 60*D1*Dd*b1*f*fd*s + 5*D1*Dd*b1*f*fd - 96*D1*Dd*b1*f*g2*r*s + 24*D1*Dd*b1*f*g2*r - 96*D1*Dd*b1*f*g2*s**2 + 96*D1*Dd*b1*f*g2*s - 24*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r*s - 12*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 96*D1*Dd*b1*f*gd2*s + 12*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r*s - 12*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 48*D1*Dd*b1*fd*g2*s + 20*D1*Dd*f**3*r*s - 5*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 20*D1*Dd*f**3*s + 5*D1*Dd*f**3 + 48*D1*Dd*f**2*g2*r*s - 12*D1*Dd*f**2*g2*r + 48*D1*Dd*f**2*g2*s**2 - 48*D1*Dd*f**2*g2*s + 12*D1*Dd*f**2*g2 - 24*D1*Ddd*K*b1**2*f*r*s + 6*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 24*D1*Ddd*K*b1**2*f*s - 6*D1*Ddd*K*b1**2*f + 20*D1*Ddd*b1*f**2*r*s - 5*D1*Ddd*b1*f**2*r + 20*D1*Ddd*b1*f**2*s**2 - 20*D1*Ddd*b1*f**2*s + 5*D1*Ddd*b1*f**2 + 48*D1*Ddd*b1*f*g2*r*s - 12*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 48*D1*Ddd*b1*f*g2*s + 12*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(2*f**2*(r + s - 1)*(10*C*(s - 1) - s*(3*K + 5) + 5) + f*(-fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(-12*r - 12*s + 12)) + 6*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(-6*K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - f*(10*C - 5)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 12*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 72*Dd**2*K*b1**2*f*r*s + 18*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 72*Dd**2*K*b1**2*f*s - 12*Dd**2*K*b1**2*f + 60*Dd**2*b1*f**2*r*s - 15*Dd**2*b1*f**2*r + 60*Dd**2*b1*f**2*s**2 - 60*Dd**2*b1*f**2*s + 10*Dd**2*b1*f**2 + 144*Dd**2*b1*f*g2*r*s - 36*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 144*Dd**2*b1*f*g2*s + 24*Dd**2*b1*f*g2)/(21*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**4*k2**3*st**2*(-37344*C*D1**2*f**2*fd*r*s + 12448*C*D1**2*f**2*fd*r - 13500*C*D1**2*f**2*fd*s**2 + 21448*C*D1**2*f**2*fd*s - 4500*C*D1**2*f**2*fd + 21840*C*D1**2*f**2*fdd*r*s - 7280*C*D1**2*f**2*fdd*r + 6750*C*D1**2*f**2*fdd*s**2 - 11780*C*D1**2*f**2*fdd*s + 2250*C*D1**2*f**2*fdd + 43680*C*D1**2*f*fd**2*r*s - 14560*C*D1**2*f*fd**2*r + 13500*C*D1**2*f*fd**2*s**2 - 23560*C*D1**2*f*fd**2*s + 7280*C*D1**2*f*fd**2 - 49792*C*D1*Dd*f**3*r*s + 12448*C*D1*Dd*f**3*r - 18000*C*D1*Dd*f**3*s**2 + 33896*C*D1*Dd*f**3*s - 4500*C*D1*Dd*f**3 + 174720*C*D1*Dd*f**2*fd*r*s - 50960*C*D1*Dd*f**2*fd*r + 54000*C*D1*Dd*f**2*fd*s**2 - 104300*C*D1*Dd*f**2*fd*s + 26340*C*D1*Dd*f**2*fd + 29120*C*D1*Ddd*f**3*r*s - 7280*C*D1*Ddd*f**3*r + 9000*C*D1*Ddd*f**3*s**2 - 19060*C*D1*Ddd*f**3*s + 2250*C*D1*Ddd*f**3 + 87360*C*Dd**2*f**3*r*s - 21840*C*Dd**2*f**3*r + 27000*C*Dd**2*f**3*s**2 - 57180*C*Dd**2*f**3*s + 14560*C*Dd**2*f**3 - 15840*D1**2*K*b1*f*fd*r*s + 7920*D1**2*K*b1*f*fd*r - 5940*D1**2*K*b1*f*fd*s**2 + 5940*D1**2*K*b1*f*fd*s - 2970*D1**2*K*b1*f*fd + 7920*D1**2*K*b1*f*fdd*r*s - 3960*D1**2*K*b1*f*fdd*r + 2970*D1**2*K*b1*f*fdd*s**2 - 2970*D1**2*K*b1*f*fdd*s + 1485*D1**2*K*b1*f*fdd + 7920*D1**2*K*b1*fd**2*r*s - 3960*D1**2*K*b1*fd**2*r + 2970*D1**2*K*b1*fd**2*s**2 - 2970*D1**2*K*b1*fd**2*s + 3960*D1**2*K*bdd1*f**2*r*s + 1485*D1**2*K*bdd1*f**2*s**2 - 3960*D1**2*K*bdd1*f**2*s + 2970*D1**2*b1*f**2*fd*r*s - 990*D1**2*b1*f**2*fd*r - 990*D1**2*b1*f**2*fd*s - 2970*D1**2*b1*f**2*fdd*r*s + 990*D1**2*b1*f**2*fdd*r + 990*D1**2*b1*f**2*fdd*s - 5940*D1**2*b1*f*fd**2*r*s + 1980*D1**2*b1*f*fd**2*r + 1980*D1**2*b1*f*fd**2*s - 990*D1**2*b1*f*fd**2 + 3960*D1**2*b1*f*fd*r*s - 1980*D1**2*b1*f*fd*r - 1980*D1**2*b1*f*fdd*r*s + 990*D1**2*b1*f*fdd*r - 1980*D1**2*b1*fd**2*r*s + 990*D1**2*b1*fd**2*r - 3960*D1**2*bd2*f**2*r*s - 3960*D1**2*bd2*f**2*s**2 + 3960*D1**2*bd2*f**2*s + 7920*D1**2*bd2*f*fd*r*s - 1980*D1**2*bd2*f*fd*r + 7920*D1**2*bd2*f*fd*s**2 - 7920*D1**2*bd2*f*fd*s + 1980*D1**2*bd2*f*fd - 990*D1**2*bdd1*f**3*r*s + 990*D1**2*bdd1*f**3*s - 990*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*s + 1980*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*s**2 - 1980*D1**2*bdd2*f**2*s + 23508*D1**2*f**2*fd*r*s - 7836*D1**2*f**2*fd*r + 6750*D1**2*f**2*fd*s**2 - 12336*D1**2*f**2*fd*s + 2250*D1**2*f**2*fd - 14130*D1**2*f**2*fdd*r*s + 4710*D1**2*f**2*fdd*r - 3375*D1**2*f**2*fdd*s**2 + 6960*D1**2*f**2*fdd*s - 1125*D1**2*f**2*fdd + 15840*D1**2*f**2*gd2*r*s + 5940*D1**2*f**2*gd2*s**2 - 15840*D1**2*f**2*gd2*s - 7920*D1**2*f**2*gdd2*r*s - 2970*D1**2*f**2*gdd2*s**2 + 7920*D1**2*f**2*gdd2*s - 28260*D1**2*f*fd**2*r*s + 9420*D1**2*f*fd**2*r - 6750*D1**2*f*fd**2*s**2 + 13920*D1**2*f*fd**2*s - 4710*D1**2*f*fd**2 + 31680*D1**2*f*fd*g2*r*s - 15840*D1**2*f*fd*g2*r + 11880*D1**2*f*fd*g2*s**2 - 11880*D1**2*f*fd*g2*s + 5940*D1**2*f*fd*g2 - 31680*D1**2*f*fd*gd2*r*s + 7920*D1**2*f*fd*gd2*r - 11880*D1**2*f*fd*gd2*s**2 + 21780*D1**2*f*fd*gd2*s - 7920*D1**2*f*fd*gd2 - 15840*D1**2*f*fdd*g2*r*s + 7920*D1**2*f*fdd*g2*r - 5940*D1**2*f*fdd*g2*s**2 + 5940*D1**2*f*fdd*g2*s - 2970*D1**2*f*fdd*g2 - 15840*D1**2*fd**2*g2*r*s + 7920*D1**2*fd**2*g2*r - 5940*D1**2*fd**2*g2*s**2 + 5940*D1**2*fd**2*g2*s - 31680*D1*Dd*K*b1*f**2*r*s + 7920*D1*Dd*K*b1*f**2*r - 11880*D1*Dd*K*b1*f**2*s**2 + 21780*D1*Dd*K*b1*f**2*s - 2970*D1*Dd*K*b1*f**2 + 63360*D1*Dd*K*b1*f*fd*r*s - 23760*D1*Dd*K*b1*f*fd*r + 23760*D1*Dd*K*b1*f*fd*s**2 - 33660*D1*Dd*K*b1*f*fd*s + 10890*D1*Dd*K*b1*f*fd + 3960*D1*Dd*b1*f**3*r*s - 990*D1*Dd*b1*f**3*r - 1980*D1*Dd*b1*f**3*s - 23760*D1*Dd*b1*f**2*fd*r*s + 6930*D1*Dd*b1*f**2*fd*r + 9900*D1*Dd*b1*f**2*fd*s - 2970*D1*Dd*b1*f**2*fd + 7920*D1*Dd*b1*f**2*r*s - 1980*D1*Dd*b1*f**2*r - 3960*D1*Dd*b1*f**2*s - 15840*D1*Dd*b1*f*fd*r*s + 5940*D1*Dd*b1*f*fd*r + 3960*D1*Dd*b1*f*fd*s - 1980*D1*Dd*b1*f*fd + 15840*D1*Dd*bd2*f**2*r*s - 1980*D1*Dd*bd2*f**2*r + 15840*D1*Dd*bd2*f**2*s**2 - 15840*D1*Dd*bd2*f**2*s + 1980*D1*Dd*bd2*f**2 + 31344*D1*Dd*f**3*r*s - 7836*D1*Dd*f**3*r + 9000*D1*Dd*f**3*s**2 - 20172*D1*Dd*f**3*s + 2250*D1*Dd*f**3 - 113040*D1*Dd*f**2*fd*r*s + 32970*D1*Dd*f**2*fd*r - 27000*D1*Dd*f**2*fd*s**2 + 62850*D1*Dd*f**2*fd*s - 16380*D1*Dd*f**2*fd + 63360*D1*Dd*f**2*g2*r*s - 15840*D1*Dd*f**2*g2*r + 23760*D1*Dd*f**2*g2*s**2 - 43560*D1*Dd*f**2*g2*s + 5940*D1*Dd*f**2*g2 - 63360*D1*Dd*f**2*gd2*r*s + 7920*D1*Dd*f**2*gd2*r - 23760*D1*Dd*f**2*gd2*s**2 + 53460*D1*Dd*f**2*gd2*s - 7920*D1*Dd*f**2*gd2 - 126720*D1*Dd*f*fd*g2*r*s + 47520*D1*Dd*f*fd*g2*r - 47520*D1*Dd*f*fd*g2*s**2 + 67320*D1*Dd*f*fd*g2*s - 21780*D1*Dd*f*fd*g2 + 15840*D1*Ddd*K*b1*f**2*r*s - 3960*D1*Ddd*K*b1*f**2*r + 5940*D1*Ddd*K*b1*f**2*s**2 - 10890*D1*Ddd*K*b1*f**2*s + 1485*D1*Ddd*K*b1*f**2 - 3960*D1*Ddd*b1*f**3*r*s + 990*D1*Ddd*b1*f**3*r + 1980*D1*Ddd*b1*f**3*s - 3960*D1*Ddd*b1*f**2*r*s + 990*D1*Ddd*b1*f**2*r + 1980*D1*Ddd*b1*f**2*s - 18840*D1*Ddd*f**3*r*s + 4710*D1*Ddd*f**3*r - 4500*D1*Ddd*f**3*s**2 + 11670*D1*Ddd*f**3*s - 1125*D1*Ddd*f**3 - 31680*D1*Ddd*f**2*g2*r*s + 7920*D1*Ddd*f**2*g2*r - 11880*D1*Ddd*f**2*g2*s**2 + 21780*D1*Ddd*f**2*g2*s - 2970*D1*Ddd*f**2*g2 + 990*D1*bd1*f*(D1*(f*s*(K*(-8*r - 3*s + 8) + f*(r - 1) + 2*r - 2) + fd*(K*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + f*(-6*r*s + r + 4*s - 1) - 4*r*s + r + 2*s - 1)) + Dd*f*(K*(32*r*s - 4*r + 12*s**2 - 27*s + 4) + f*(-8*r*s + r + 6*s - 1) - 8*r*s + r + 6*s - 1)) + 47520*Dd**2*K*b1*f**2*r*s - 11880*Dd**2*K*b1*f**2*r + 17820*Dd**2*K*b1*f**2*s**2 - 32670*Dd**2*K*b1*f**2*s + 7920*Dd**2*K*b1*f**2 - 11880*Dd**2*b1*f**3*r*s + 2970*Dd**2*b1*f**3*r + 5940*Dd**2*b1*f**3*s - 1980*Dd**2*b1*f**3 - 11880*Dd**2*b1*f**2*r*s + 2970*Dd**2*b1*f**2*r + 5940*Dd**2*b1*f**2*s - 1980*Dd**2*b1*f**2 - 56520*Dd**2*f**3*r*s + 14130*Dd**2*f**3*r - 13500*Dd**2*f**3*s**2 + 35010*Dd**2*f**3*s - 9420*Dd**2*f**3 - 95040*Dd**2*f**2*g2*r*s + 23760*Dd**2*f**2*g2*r - 35640*Dd**2*f**2*g2*s**2 + 65340*Dd**2*f**2*g2*s - 15840*Dd**2*f**2*g2 - 1980*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(1386*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**4*k2**3*(-7392*C*D1**2*b1*f*fd*r*s - 2640*C*D1**2*b1*f*fd*r - 3960*C*D1**2*b1*f*fd*s**2 - 1584*C*D1**2*b1*f*fd*s + 2640*C*D1**2*b1*f*fd + 3696*C*D1**2*b1*f*fdd*r*s + 1320*C*D1**2*b1*f*fdd*r + 1980*C*D1**2*b1*f*fdd*s**2 + 792*C*D1**2*b1*f*fdd*s - 1320*C*D1**2*b1*f*fdd + 3696*C*D1**2*b1*fd**2*r*s + 1320*C*D1**2*b1*fd**2*r + 1980*C*D1**2*b1*fd**2*s**2 + 792*C*D1**2*b1*fd**2*s - 1320*C*D1**2*b1*fd**2 + 1848*C*D1**2*bdd1*f**2*r*s - 3168*C*D1**2*bdd1*f**2*r + 990*C*D1**2*bdd1*f**2*s**2 - 4620*C*D1**2*bdd1*f**2*s + 2310*C*D1**2*bdd1*f**2 + 1560*C*D1**2*f**2*fd*r*s - 520*C*D1**2*f**2*fd*r - 3960*C*D1**2*f**2*fd*s**2 + 2120*C*D1**2*f**2*fd*s - 1320*C*D1**2*f**2*fd + 5160*C*D1**2*f**2*fdd*r*s - 1720*C*D1**2*f**2*fdd*r + 8910*C*D1**2*f**2*fdd*s**2 - 7660*C*D1**2*f**2*fdd*s + 2970*C*D1**2*f**2*fdd + 10320*C*D1**2*f*fd**2*r*s - 3440*C*D1**2*f*fd**2*r + 17820*C*D1**2*f*fd**2*s**2 - 15320*C*D1**2*f*fd**2*s + 1720*C*D1**2*f*fd**2 - 14784*C*D1*Dd*b1*f**2*r*s + 3696*C*D1*Dd*b1*f**2*r - 7920*C*D1*Dd*b1*f**2*s**2 + 11352*C*D1*Dd*b1*f**2*s - 1980*C*D1*Dd*b1*f**2 + 29568*C*D1*Dd*b1*f*fd*r*s + 1584*C*D1*Dd*b1*f*fd*r + 15840*C*D1*Dd*b1*f*fd*s**2 - 8184*C*D1*Dd*b1*f*fd*s - 3432*C*D1*Dd*b1*f*fd + 2080*C*D1*Dd*f**3*r*s - 520*C*D1*Dd*f**3*r - 5280*C*D1*Dd*f**3*s**2 + 1600*C*D1*Dd*f**3*s - 1320*C*D1*Dd*f**3 + 41280*C*D1*Dd*f**2*fd*r*s - 12040*C*D1*Dd*f**2*fd*r + 71280*C*D1*Dd*f**2*fd*s**2 - 58780*C*D1*Dd*f**2*fd*s + 11100*C*D1*Dd*f**2*fd + 7392*C*D1*Ddd*b1*f**2*r*s - 1848*C*D1*Ddd*b1*f**2*r + 3960*C*D1*Ddd*b1*f**2*s**2 - 5676*C*D1*Ddd*b1*f**2*s + 990*C*D1*Ddd*b1*f**2 + 6880*C*D1*Ddd*f**3*r*s - 1720*C*D1*Ddd*f**3*r + 11880*C*D1*Ddd*f**3*s**2 - 9380*C*D1*Ddd*f**3*s + 2970*C*D1*Ddd*f**3 + 22176*C*Dd**2*b1*f**2*r*s - 5544*C*Dd**2*b1*f**2*r + 11880*C*Dd**2*b1*f**2*s**2 - 17028*C*Dd**2*b1*f**2*s + 3696*C*Dd**2*b1*f**2 + 20640*C*Dd**2*f**3*r*s - 5160*C*Dd**2*f**3*r + 35640*C*Dd**2*f**3*s**2 - 28140*C*Dd**2*f**3*s + 3440*C*Dd**2*f**3 - 1584*D1**2*K*b1**2*fd*r*s - 1584*D1**2*K*b1**2*fd*r - 1188*D1**2*K*b1**2*fd*s**2 - 3168*D1**2*K*b1**2*fd*s + 1584*D1**2*K*b1**2*fd + 792*D1**2*K*b1**2*fdd*r*s + 792*D1**2*K*b1**2*fdd*r + 594*D1**2*K*b1**2*fdd*s**2 + 1584*D1**2*K*b1**2*fdd*s - 792*D1**2*K*b1**2*fdd + 1584*D1**2*K*b1*bdd1*f*r*s - 1584*D1**2*K*b1*bdd1*f*r + 1188*D1**2*K*b1*bdd1*f*s**2 - 3564*D1**2*K*b1*bdd1*f*s + 1386*D1**2*K*b1*bdd1*f + 1584*D1**2*K*b1*f*fd*r*s - 792*D1**2*K*b1*f*fd*r - 1584*D1**2*K*b1*f*fd*s**2 + 1584*D1**2*K*b1*f*fd*s - 792*D1**2*K*b1*f*fd + 1584*D1**2*K*b1*f*fdd*r*s - 792*D1**2*K*b1*f*fdd*r + 3564*D1**2*K*b1*f*fdd*s**2 - 3564*D1**2*K*b1*f*fdd*s + 1782*D1**2*K*b1*f*fdd + 1584*D1**2*K*b1*fd**2*r*s - 792*D1**2*K*b1*fd**2*r + 3564*D1**2*K*b1*fd**2*s**2 - 3564*D1**2*K*b1*fd**2*s + 792*D1**2*K*bdd1*f**2*r*s + 1782*D1**2*K*bdd1*f**2*s**2 - 792*D1**2*K*bdd1*f**2*s + 792*D1**2*b1**2*f*fd*r*s - 396*D1**2*b1**2*f*fd*s - 792*D1**2*b1**2*f*fdd*r*s + 396*D1**2*b1**2*f*fdd*s - 792*D1**2*b1**2*fd**2*r*s + 396*D1**2*b1**2*fd**2*s + 792*D1**2*b1**2*fd*r*s - 396*D1**2*b1**2*fdd*r*s - 1584*D1**2*b1*bd2*f*r*s - 1584*D1**2*b1*bd2*f*s**2 + 1584*D1**2*b1*bd2*f*s + 1584*D1**2*b1*bd2*fd*r*s + 1584*D1**2*b1*bd2*fd*s**2 - 792*D1**2*b1*bd2*fd*s - 792*D1**2*b1*bdd1*f**2*r*s + 396*D1**2*b1*bdd1*f**2*r + 396*D1**2*b1*bdd1*f**2*s - 792*D1**2*b1*bdd1*f*r*s + 396*D1**2*b1*bdd1*f*r + 396*D1**2*b1*bdd1*f*s + 792*D1**2*b1*bdd2*f*r*s + 792*D1**2*b1*bdd2*f*s**2 - 792*D1**2*b1*bdd2*f*s + 4752*D1**2*b1*f*fd*r*s + 1716*D1**2*b1*f*fd*r + 1980*D1**2*b1*f*fd*s**2 - 132*D1**2*b1*f*fd*s - 1320*D1**2*b1*f*fd - 2772*D1**2*b1*f*fdd*r*s - 660*D1**2*b1*f*fdd*r - 990*D1**2*b1*f*fdd*s**2 + 66*D1**2*b1*f*fdd*s + 660*D1**2*b1*f*fdd + 3168*D1**2*b1*f*gd2*r*s + 2376*D1**2*b1*f*gd2*s**2 - 3168*D1**2*b1*f*gd2*s - 1584*D1**2*b1*f*gdd2*r*s - 1188*D1**2*b1*f*gdd2*s**2 + 1584*D1**2*b1*f*gdd2*s - 2772*D1**2*b1*fd**2*r*s - 660*D1**2*b1*fd**2*r - 990*D1**2*b1*fd**2*s**2 + 66*D1**2*b1*fd**2*s + 660*D1**2*b1*fd**2 + 3168*D1**2*b1*fd*g2*r*s + 3168*D1**2*b1*fd*g2*r + 2376*D1**2*b1*fd*g2*s**2 + 6336*D1**2*b1*fd*g2*s - 3168*D1**2*b1*fd*g2 - 3168*D1**2*b1*fd*gd2*r*s - 1584*D1**2*b1*fd*gd2*r - 2376*D1**2*b1*fd*gd2*s**2 - 1584*D1**2*b1*fd*gd2*s + 1584*D1**2*b1*fd*gd2 - 1584*D1**2*b1*fdd*g2*r*s - 1584*D1**2*b1*fdd*g2*r - 1188*D1**2*b1*fdd*g2*s**2 - 3168*D1**2*b1*fdd*g2*s + 1584*D1**2*b1*fdd*g2 - 396*D1**2*bd1**2*f*(K*(-4*r*(s - 1) - 3*s**2 + 9*s - 4) + f*r*(2*s - 1) - f*s + f + 2*r*s - r - s + 1) + 792*D1**2*bd2*f**2*r*s + 792*D1**2*bd2*f**2*s**2 - 792*D1**2*bd2*f**2*s - 1386*D1**2*bdd1*f**2*r*s + 2046*D1**2*bdd1*f**2*r - 495*D1**2*bdd1*f**2*s**2 + 2310*D1**2*bdd1*f**2*s - 1155*D1**2*bdd1*f**2 - 1584*D1**2*bdd1*f*g2*r*s + 3168*D1**2*bdd1*f*g2*r - 1188*D1**2*bdd1*f*g2*s**2 + 5544*D1**2*bdd1*f*g2*s - 2772*D1**2*bdd1*f*g2 - 1770*D1**2*f**2*fd*r*s + 590*D1**2*f**2*fd*r + 1980*D1**2*f**2*fd*s**2 - 730*D1**2*f**2*fd*s + 660*D1**2*f**2*fd - 2580*D1**2*f**2*fdd*r*s + 860*D1**2*f**2*fdd*r - 4455*D1**2*f**2*fdd*s**2 + 3830*D1**2*f**2*fdd*s - 1485*D1**2*f**2*fdd - 1584*D1**2*f**2*gd2*r*s + 1584*D1**2*f**2*gd2*s**2 + 1584*D1**2*f**2*gd2*s - 1584*D1**2*f**2*gdd2*r*s - 3564*D1**2*f**2*gdd2*s**2 + 1584*D1**2*f**2*gdd2*s - 5160*D1**2*f*fd**2*r*s + 1720*D1**2*f*fd**2*r - 8910*D1**2*f*fd**2*s**2 + 7660*D1**2*f*fd**2*s - 860*D1**2*f*fd**2 - 3168*D1**2*f*fd*g2*r*s + 1584*D1**2*f*fd*g2*r + 3168*D1**2*f*fd*g2*s**2 - 3168*D1**2*f*fd*g2*s + 1584*D1**2*f*fd*g2 - 6336*D1**2*f*fd*gd2*r*s + 1584*D1**2*f*fd*gd2*r - 14256*D1**2*f*fd*gd2*s**2 + 10296*D1**2*f*fd*gd2*s - 1584*D1**2*f*fd*gd2 - 3168*D1**2*f*fdd*g2*r*s + 1584*D1**2*f*fdd*g2*r - 7128*D1**2*f*fdd*g2*s**2 + 7128*D1**2*f*fdd*g2*s - 3564*D1**2*f*fdd*g2 - 3168*D1**2*fd**2*g2*r*s + 1584*D1**2*fd**2*g2*r - 7128*D1**2*fd**2*g2*s**2 + 7128*D1**2*fd**2*g2*s - 6336*D1*Dd*K*b1**2*f*r*s + 1584*D1*Dd*K*b1**2*f*r - 4752*D1*Dd*K*b1**2*f*s**2 + 5544*D1*Dd*K*b1**2*f*s - 1188*D1*Dd*K*b1**2*f + 6336*D1*Dd*K*b1**2*fd*r*s + 2376*D1*Dd*K*b1**2*fd*r + 4752*D1*Dd*K*b1**2*fd*s**2 + 3564*D1*Dd*K*b1**2*fd*s - 3168*D1*Dd*K*b1**2*fd + 3168*D1*Dd*K*b1*f**2*r*s - 792*D1*Dd*K*b1*f**2*r - 3168*D1*Dd*K*b1*f**2*s**2 - 792*D1*Dd*K*b1*f**2 + 12672*D1*Dd*K*b1*f*fd*r*s - 4752*D1*Dd*K*b1*f*fd*r + 28512*D1*Dd*K*b1*f*fd*s**2 - 24552*D1*Dd*K*b1*f*fd*s + 5148*D1*Dd*K*b1*f*fd + 1584*D1*Dd*b1**2*f**2*r*s - 396*D1*Dd*b1**2*f**2*r - 792*D1*Dd*b1**2*f**2*s - 6336*D1*Dd*b1**2*f*fd*r*s + 792*D1*Dd*b1**2*f*fd*r + 3168*D1*Dd*b1**2*f*fd*s - 396*D1*Dd*b1**2*f*fd + 3168*D1*Dd*b1**2*f*r*s - 792*D1*Dd*b1**2*f*r - 1584*D1*Dd*b1**2*f*s - 3168*D1*Dd*b1**2*fd*r*s + 396*D1*Dd*b1**2*fd*r + 792*D1*Dd*b1**2*fd*s + 6336*D1*Dd*b1*bd2*f*r*s - 792*D1*Dd*b1*bd2*f*r + 6336*D1*Dd*b1*bd2*f*s**2 - 6336*D1*Dd*b1*bd2*f*s + 792*D1*Dd*b1*bd2*f + 9504*D1*Dd*b1*f**2*r*s - 2376*D1*Dd*b1*f**2*r + 3960*D1*Dd*b1*f**2*s**2 - 6732*D1*Dd*b1*f**2*s + 990*D1*Dd*b1*f**2 - 22176*D1*Dd*b1*f*fd*r*s + 132*D1*Dd*b1*f*fd*r - 7920*D1*Dd*b1*f*fd*s**2 + 7788*D1*Dd*b1*f*fd*s + 1254*D1*Dd*b1*f*fd + 12672*D1*Dd*b1*f*g2*r*s - 3168*D1*Dd*b1*f*g2*r + 9504*D1*Dd*b1*f*g2*s**2 - 11088*D1*Dd*b1*f*g2*s + 2376*D1*Dd*b1*f*g2 - 12672*D1*Dd*b1*f*gd2*r*s + 1584*D1*Dd*b1*f*gd2*r - 9504*D1*Dd*b1*f*gd2*s**2 + 11880*D1*Dd*b1*f*gd2*s - 1584*D1*Dd*b1*f*gd2 - 12672*D1*Dd*b1*fd*g2*r*s - 4752*D1*Dd*b1*fd*g2*r - 9504*D1*Dd*b1*fd*g2*s**2 - 7128*D1*Dd*b1*fd*g2*s + 6336*D1*Dd*b1*fd*g2 - 2360*D1*Dd*f**3*r*s + 590*D1*Dd*f**3*r + 2640*D1*Dd*f**3*s**2 - 140*D1*Dd*f**3*s + 660*D1*Dd*f**3 - 20640*D1*Dd*f**2*fd*r*s + 6020*D1*Dd*f**2*fd*r - 35640*D1*Dd*f**2*fd*s**2 + 29390*D1*Dd*f**2*fd*s - 5550*D1*Dd*f**2*fd - 6336*D1*Dd*f**2*g2*r*s + 1584*D1*Dd*f**2*g2*r + 6336*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2 - 12672*D1*Dd*f**2*gd2*r*s + 1584*D1*Dd*f**2*gd2*r - 28512*D1*Dd*f**2*gd2*s**2 + 16632*D1*Dd*f**2*gd2*s - 1584*D1*Dd*f**2*gd2 - 25344*D1*Dd*f*fd*g2*r*s + 9504*D1*Dd*f*fd*g2*r - 57024*D1*Dd*f*fd*g2*s**2 + 49104*D1*Dd*f*fd*g2*s - 10296*D1*Dd*f*fd*g2 + 3168*D1*Ddd*K*b1**2*f*r*s - 792*D1*Ddd*K*b1**2*f*r + 2376*D1*Ddd*K*b1**2*f*s**2 - 2772*D1*Ddd*K*b1**2*f*s + 594*D1*Ddd*K*b1**2*f + 3168*D1*Ddd*K*b1*f**2*r*s - 792*D1*Ddd*K*b1*f**2*r + 7128*D1*Ddd*K*b1*f**2*s**2 - 5148*D1*Ddd*K*b1*f**2*s + 1782*D1*Ddd*K*b1*f**2 - 1584*D1*Ddd*b1**2*f**2*r*s + 396*D1*Ddd*b1**2*f**2*r + 792*D1*Ddd*b1**2*f**2*s - 1584*D1*Ddd*b1**2*f*r*s + 396*D1*Ddd*b1**2*f*r + 792*D1*Ddd*b1**2*f*s - 5544*D1*Ddd*b1*f**2*r*s + 1386*D1*Ddd*b1*f**2*r - 1980*D1*Ddd*b1*f**2*s**2 + 3762*D1*Ddd*b1*f**2*s - 495*D1*Ddd*b1*f**2 - 6336*D1*Ddd*b1*f*g2*r*s + 1584*D1*Ddd*b1*f*g2*r - 4752*D1*Ddd*b1*f*g2*s**2 + 5544*D1*Ddd*b1*f*g2*s - 1188*D1*Ddd*b1*f*g2 - 3440*D1*Ddd*f**3*r*s + 860*D1*Ddd*f**3*r - 5940*D1*Ddd*f**3*s**2 + 4690*D1*Ddd*f**3*s - 1485*D1*Ddd*f**3 - 6336*D1*Ddd*f**2*g2*r*s + 1584*D1*Ddd*f**2*g2*r - 14256*D1*Ddd*f**2*g2*s**2 + 10296*D1*Ddd*f**2*g2*s - 3564*D1*Ddd*f**2*g2 + 66*D1*bd1*(-56*C*D1*f**2*r*s + 96*C*D1*f**2*r - 30*C*D1*f**2*s**2 + 140*C*D1*f**2*s - 70*C*D1*f**2 + 112*C*D1*f*fd*r*s - 76*C*D1*f*fd*r + 60*C*D1*f*fd*s**2 - 128*C*D1*f*fd*s + 48*C*D1*f*fd + 224*C*Dd*f**2*r*s - 220*C*Dd*f**2*r + 120*C*Dd*f**2*s**2 - 366*C*Dd*f**2*s + 166*C*Dd*f**2 + 12*D1*K*f**2*r*s - 12*D1*K*f**2*s**2 - 12*D1*K*f**2*s + 48*D1*K*f*fd*r*s - 12*D1*K*f*fd*r + 108*D1*K*f*fd*s**2 - 78*D1*K*f*fd*s + 12*D1*K*f*fd + 12*D1*bd2*f*(2*s - 1)*(r + s - 1) + 36*D1*f**2*r*s - 62*D1*f**2*r + 15*D1*f**2*s**2 - 64*D1*f**2*s + 35*D1*f**2 - 84*D1*f*fd*r*s + 52*D1*f*fd*r - 30*D1*f*fd*s**2 + 71*D1*f*fd*s - 31*D1*f*fd + 48*D1*f*g2*r*s - 96*D1*f*g2*r + 36*D1*f*g2*s**2 - 168*D1*f*g2*s + 84*D1*f*g2 - 48*D1*f*gd2*r*s + 48*D1*f*gd2*r - 36*D1*f*gd2*s**2 + 108*D1*f*gd2*s - 48*D1*f*gd2 - 48*D1*fd*g2*r*s + 24*D1*fd*g2*r - 36*D1*fd*g2*s**2 + 36*D1*fd*g2*s + 96*Dd*K*f**2*r*s - 12*Dd*K*f**2*r + 216*Dd*K*f**2*s**2 - 126*Dd*K*f**2*s + 12*Dd*K*f**2 - 168*Dd*f**2*r*s + 145*Dd*f**2*r - 60*Dd*f**2*s**2 + 197*Dd*f**2*s - 97*Dd*f**2 - 192*Dd*f*g2*r*s + 216*Dd*f*g2*r - 144*Dd*f*g2*s**2 + 420*Dd*f*g2*s - 180*Dd*f*g2 - 6*b1*(D1*(f**2*(-2*r*s + r + s) + f*(K*(8*r*(s - 1) + 6*s**2 - 18*s + 7) + fd*(2*r - 1)*(4*s - 1) - 4*r*s + 2*r + 2*s) - fd*(K*(6*s**2 + s*(8*r - 1) - 2) - 4*r*s + r + s)) + Dd*f*(K*(-32*r*s + 20*r - 24*s**2 + 50*s - 17) + f*(2*r - 1)*(8*s - 3) + (2*r - 1)*(8*s - 3)))) + 9504*Dd**2*K*b1**2*f*r*s - 2376*Dd**2*K*b1**2*f*r + 7128*Dd**2*K*b1**2*f*s**2 - 8316*Dd**2*K*b1**2*f*s + 1584*Dd**2*K*b1**2*f + 9504*Dd**2*K*b1*f**2*r*s - 2376*Dd**2*K*b1*f**2*r + 21384*Dd**2*K*b1*f**2*s**2 - 15444*Dd**2*K*b1*f**2*s + 1584*Dd**2*K*b1*f**2 - 4752*Dd**2*b1**2*f**2*r*s + 1188*Dd**2*b1**2*f**2*r + 2376*Dd**2*b1**2*f**2*s - 792*Dd**2*b1**2*f**2 - 4752*Dd**2*b1**2*f*r*s + 1188*Dd**2*b1**2*f*r + 2376*Dd**2*b1**2*f*s - 792*Dd**2*b1**2*f - 16632*Dd**2*b1*f**2*r*s + 4158*Dd**2*b1*f**2*r - 5940*Dd**2*b1*f**2*s**2 + 11286*Dd**2*b1*f**2*s - 2772*Dd**2*b1*f**2 - 19008*Dd**2*b1*f*g2*r*s + 4752*Dd**2*b1*f*g2*r - 14256*Dd**2*b1*f*g2*s**2 + 16632*Dd**2*b1*f*g2*s - 3168*Dd**2*b1*f*g2 - 10320*Dd**2*f**3*r*s + 2580*Dd**2*f**3*r - 17820*Dd**2*f**3*s**2 + 14070*Dd**2*f**3*s - 1720*Dd**2*f**3 - 19008*Dd**2*f**2*g2*r*s + 4752*Dd**2*f**2*g2*r - 42768*Dd**2*f**2*g2*s**2 + 30888*Dd**2*f**2*g2*s - 3168*Dd**2*f**2*g2 - 792*b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(693*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**4*k2*st**2*(-22500*C*D1**2*f**2*fd*s**2 + 15000*C*D1**2*f**2*fd*s - 7500*C*D1**2*f**2*fd + 11250*C*D1**2*f**2*fdd*s**2 - 7500*C*D1**2*f**2*fdd*s + 3750*C*D1**2*f**2*fdd + 22500*C*D1**2*f*fd**2*s**2 - 15000*C*D1**2*f*fd**2*s - 30000*C*D1*Dd*f**3*s**2 + 15000*C*D1*Dd*f**3*s - 7500*C*D1*Dd*f**3 + 90000*C*D1*Dd*f**2*fd*s**2 - 52500*C*D1*Dd*f**2*fd*s + 7500*C*D1*Dd*f**2*fd + 15000*C*D1*Ddd*f**3*s**2 - 7500*C*D1*Ddd*f**3*s + 3750*C*D1*Ddd*f**3 + 45000*C*Dd**2*f**3*s**2 - 22500*C*Dd**2*f**3*s - 9900*D1**2*K*b1*f*fd*s**2 + 9900*D1**2*K*b1*f*fd*s - 4950*D1**2*K*b1*f*fd + 4950*D1**2*K*b1*f*fdd*s**2 - 4950*D1**2*K*b1*f*fdd*s + 2475*D1**2*K*b1*f*fdd + 4950*D1**2*K*b1*fd**2*s**2 - 4950*D1**2*K*b1*fd**2*s + 2475*D1**2*K*bdd1*f**2*s**2 - 2970*D1**2*b1*f**2*fd*r*s + 990*D1**2*b1*f**2*fd*r + 990*D1**2*b1*f**2*fd*s + 2970*D1**2*b1*f**2*fdd*r*s - 990*D1**2*b1*f**2*fdd*r - 990*D1**2*b1*f**2*fdd*s + 5940*D1**2*b1*f*fd**2*r*s - 1980*D1**2*b1*f*fd**2*r - 1980*D1**2*b1*f*fd**2*s + 990*D1**2*b1*f*fd**2 - 3960*D1**2*b1*f*fd*r*s + 1980*D1**2*b1*f*fd*r + 1980*D1**2*b1*f*fdd*r*s - 990*D1**2*b1*f*fdd*r + 1980*D1**2*b1*fd**2*r*s - 990*D1**2*b1*fd**2*r - 4950*D1**2*bd2*f**2*s**2 + 9900*D1**2*bd2*f*fd*s**2 - 4950*D1**2*bd2*f*fd*s + 990*D1**2*bdd1*f**3*r*s - 990*D1**2*bdd1*f**3*s + 990*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*s + 2475*D1**2*bdd2*f**2*s**2 - 4836*D1**2*f**2*fd*r*s + 1612*D1**2*f**2*fd*r + 11250*D1**2*f**2*fd*s**2 - 5888*D1**2*f**2*fd*s + 3750*D1**2*f**2*fd + 3210*D1**2*f**2*fdd*r*s - 1070*D1**2*f**2*fdd*r - 5625*D1**2*f**2*fdd*s**2 + 2680*D1**2*f**2*fdd*s - 1875*D1**2*f**2*fdd + 9900*D1**2*f**2*gd2*s**2 - 4950*D1**2*f**2*gdd2*s**2 + 6420*D1**2*f*fd**2*r*s - 2140*D1**2*f*fd**2*r - 11250*D1**2*f*fd**2*s**2 + 5360*D1**2*f*fd**2*s + 1070*D1**2*f*fd**2 + 19800*D1**2*f*fd*g2*s**2 - 19800*D1**2*f*fd*g2*s + 9900*D1**2*f*fd*g2 - 19800*D1**2*f*fd*gd2*s**2 + 9900*D1**2*f*fd*gd2*s - 9900*D1**2*f*fdd*g2*s**2 + 9900*D1**2*f*fdd*g2*s - 4950*D1**2*f*fdd*g2 - 9900*D1**2*fd**2*g2*s**2 + 9900*D1**2*fd**2*g2*s - 19800*D1*Dd*K*b1*f**2*s**2 + 9900*D1*Dd*K*b1*f**2*s - 4950*D1*Dd*K*b1*f**2 + 39600*D1*Dd*K*b1*f*fd*s**2 - 29700*D1*Dd*K*b1*f*fd*s + 4950*D1*Dd*K*b1*f*fd - 3960*D1*Dd*b1*f**3*r*s + 990*D1*Dd*b1*f**3*r + 1980*D1*Dd*b1*f**3*s + 23760*D1*Dd*b1*f**2*fd*r*s - 6930*D1*Dd*b1*f**2*fd*r - 9900*D1*Dd*b1*f**2*fd*s + 2970*D1*Dd*b1*f**2*fd - 7920*D1*Dd*b1*f**2*r*s + 1980*D1*Dd*b1*f**2*r + 3960*D1*Dd*b1*f**2*s + 15840*D1*Dd*b1*f*fd*r*s - 5940*D1*Dd*b1*f*fd*r - 3960*D1*Dd*b1*f*fd*s + 1980*D1*Dd*b1*f*fd + 19800*D1*Dd*bd2*f**2*s**2 - 4950*D1*Dd*bd2*f**2*s - 6448*D1*Dd*f**3*r*s + 1612*D1*Dd*f**3*r + 15000*D1*Dd*f**3*s**2 - 4276*D1*Dd*f**3*s + 3750*D1*Dd*f**3 + 25680*D1*Dd*f**2*fd*r*s - 7490*D1*Dd*f**2*fd*r - 45000*D1*Dd*f**2*fd*s**2 + 15550*D1*Dd*f**2*fd*s - 540*D1*Dd*f**2*fd + 39600*D1*Dd*f**2*g2*s**2 - 19800*D1*Dd*f**2*g2*s + 9900*D1*Dd*f**2*g2 - 39600*D1*Dd*f**2*gd2*s**2 + 9900*D1*Dd*f**2*gd2*s - 79200*D1*Dd*f*fd*g2*s**2 + 59400*D1*Dd*f*fd*g2*s - 9900*D1*Dd*f*fd*g2 + 9900*D1*Ddd*K*b1*f**2*s**2 - 4950*D1*Ddd*K*b1*f**2*s + 2475*D1*Ddd*K*b1*f**2 + 3960*D1*Ddd*b1*f**3*r*s - 990*D1*Ddd*b1*f**3*r - 1980*D1*Ddd*b1*f**3*s + 3960*D1*Ddd*b1*f**2*r*s - 990*D1*Ddd*b1*f**2*r - 1980*D1*Ddd*b1*f**2*s + 4280*D1*Ddd*f**3*r*s - 1070*D1*Ddd*f**3*r - 7500*D1*Ddd*f**3*s**2 + 1610*D1*Ddd*f**3*s - 1875*D1*Ddd*f**3 - 19800*D1*Ddd*f**2*g2*s**2 + 9900*D1*Ddd*f**2*g2*s - 4950*D1*Ddd*f**2*g2 - 990*D1*bd1*f*(D1*(f*s*(5*K*s + f*(r - 1) + 2*r - 2) + fd*(f*(-6*r*s + r + 4*s - 1) - 4*r*s + r - (2*s - 1)*(5*K*s - 1))) - Dd*f*(20*K*s**2 - 5*K*s + f*r*(8*s - 1) - 6*f*s + f + r*(8*s - 1) - 6*s + 1)) + 29700*Dd**2*K*b1*f**2*s**2 - 14850*Dd**2*K*b1*f**2*s + 11880*Dd**2*b1*f**3*r*s - 2970*Dd**2*b1*f**3*r - 5940*Dd**2*b1*f**3*s + 1980*Dd**2*b1*f**3 + 11880*Dd**2*b1*f**2*r*s - 2970*Dd**2*b1*f**2*r - 5940*Dd**2*b1*f**2*s + 1980*Dd**2*b1*f**2 + 12840*Dd**2*f**3*r*s - 3210*Dd**2*f**3*r - 22500*Dd**2*f**3*s**2 + 4830*Dd**2*f**3*s + 2140*Dd**2*f**3 - 59400*Dd**2*f**2*g2*s**2 + 29700*Dd**2*f**2*g2*s - 2475*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1386*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**4*k2*(-7392*C*D1**2*b1*f*fd*r*s + 3696*C*D1**2*b1*f*fd*r + 2376*C*D1**2*b1*f*fd*s + 660*C*D1**2*b1*f*fd + 3696*C*D1**2*b1*f*fdd*r*s - 1848*C*D1**2*b1*f*fdd*r - 1188*C*D1**2*b1*f*fdd*s - 330*C*D1**2*b1*f*fdd + 3696*C*D1**2*b1*fd**2*r*s - 1848*C*D1**2*b1*fd**2*r - 1188*C*D1**2*b1*fd**2*s + 1848*C*D1**2*b1*fd**2 + 1848*C*D1**2*bdd1*f**2*r*s - 660*C*D1**2*bdd1*f**2*s + 330*C*D1**2*bdd1*f**2 + 6360*C*D1**2*f**2*fd*r*s - 2120*C*D1**2*f**2*fd*r + 11880*C*D1**2*f**2*fd*s**2 - 10040*C*D1**2*f**2*fd*s + 3960*C*D1**2*f**2*fd - 5160*C*D1**2*f**2*fdd*r*s + 1720*C*D1**2*f**2*fdd*r - 8910*C*D1**2*f**2*fdd*s**2 + 7660*C*D1**2*f**2*fdd*s - 2970*C*D1**2*f**2*fdd - 10320*C*D1**2*f*fd**2*r*s + 3440*C*D1**2*f*fd**2*r - 17820*C*D1**2*f*fd**2*s**2 + 15320*C*D1**2*f*fd**2*s - 1720*C*D1**2*f*fd**2 - 14784*C*D1*Dd*b1*f**2*r*s + 3696*C*D1*Dd*b1*f**2*r + 7392*C*D1*Dd*b1*f**2*s + 29568*C*D1*Dd*b1*f*fd*r*s - 11088*C*D1*Dd*b1*f*fd*r - 12144*C*D1*Dd*b1*f*fd*s + 4884*C*D1*Dd*b1*f*fd + 8480*C*D1*Dd*f**3*r*s - 2120*C*D1*Dd*f**3*r + 15840*C*D1*Dd*f**3*s**2 - 12160*C*D1*Dd*f**3*s + 3960*C*D1*Dd*f**3 - 41280*C*D1*Dd*f**2*fd*r*s + 12040*C*D1*Dd*f**2*fd*r - 71280*C*D1*Dd*f**2*fd*s**2 + 58780*C*D1*Dd*f**2*fd*s - 11100*C*D1*Dd*f**2*fd + 7392*C*D1*Ddd*b1*f**2*r*s - 1848*C*D1*Ddd*b1*f**2*r - 3696*C*D1*Ddd*b1*f**2*s - 6880*C*D1*Ddd*f**3*r*s + 1720*C*D1*Ddd*f**3*r - 11880*C*D1*Ddd*f**3*s**2 + 9380*C*D1*Ddd*f**3*s - 2970*C*D1*Ddd*f**3 + 22176*C*Dd**2*b1*f**2*r*s - 5544*C*Dd**2*b1*f**2*r - 11088*C*Dd**2*b1*f**2*s + 3696*C*Dd**2*b1*f**2 - 20640*C*Dd**2*f**3*r*s + 5160*C*Dd**2*f**3*r - 35640*C*Dd**2*f**3*s**2 + 28140*C*Dd**2*f**3*s - 3440*C*Dd**2*f**3 - 1584*D1**2*K*b1**2*fd*r*s + 1584*D1**2*K*b1**2*fd*r - 792*D1**2*K*b1**2*fd*s + 396*D1**2*K*b1**2*fd + 792*D1**2*K*b1**2*fdd*r*s - 792*D1**2*K*b1**2*fdd*r + 396*D1**2*K*b1**2*fdd*s - 198*D1**2*K*b1**2*fdd + 1584*D1**2*K*b1*bdd1*f*r*s - 1188*D1**2*K*b1*bdd1*f*s + 198*D1**2*K*b1*bdd1*f + 1584*D1**2*K*b1*f*fd*r*s - 792*D1**2*K*b1*f*fd*r + 4752*D1**2*K*b1*f*fd*s**2 - 4752*D1**2*K*b1*f*fd*s + 2376*D1**2*K*b1*f*fd - 1584*D1**2*K*b1*f*fdd*r*s + 792*D1**2*K*b1*f*fdd*r - 3564*D1**2*K*b1*f*fdd*s**2 + 3564*D1**2*K*b1*f*fdd*s - 1782*D1**2*K*b1*f*fdd - 1584*D1**2*K*b1*fd**2*r*s + 792*D1**2*K*b1*fd**2*r - 3564*D1**2*K*b1*fd**2*s**2 + 3564*D1**2*K*b1*fd**2*s - 792*D1**2*K*bdd1*f**2*r*s - 1782*D1**2*K*bdd1*f**2*s**2 + 792*D1**2*K*bdd1*f**2*s - 396*D1**2*b1**2*f*fd*r + 396*D1**2*b1**2*f*fdd*r + 396*D1**2*b1**2*fd**2*r - 396*D1**2*b1**2*fd**2 - 792*D1**2*b1**2*fd*r + 396*D1**2*b1**2*fdd*r - 396*D1**2*b1*bd2*f*s**2 + 396*D1**2*b1*bd2*fd*s**2 - 396*D1**2*b1*bdd1*f**2*r - 396*D1**2*b1*bdd1*f*r + 198*D1**2*b1*bdd2*f*s**2 + 4488*D1**2*b1*f*fd*r*s - 3168*D1**2*b1*f*fd*r - 1188*D1**2*b1*f*fd*s - 330*D1**2*b1*f*fd - 1848*D1**2*b1*f*fdd*r*s + 1386*D1**2*b1*f*fdd*r + 594*D1**2*b1*f*fdd*s + 165*D1**2*b1*f*fdd + 3168*D1**2*b1*f*gd2*r*s - 3168*D1**2*b1*f*gd2*s - 1584*D1**2*b1*f*gdd2*r*s + 1584*D1**2*b1*f*gdd2*s - 1848*D1**2*b1*fd**2*r*s + 1386*D1**2*b1*fd**2*r + 594*D1**2*b1*fd**2*s - 1386*D1**2*b1*fd**2 + 3168*D1**2*b1*fd*g2*r*s - 3168*D1**2*b1*fd*g2*r + 1584*D1**2*b1*fd*g2*s - 792*D1**2*b1*fd*g2 - 3168*D1**2*b1*fd*gd2*r*s + 1584*D1**2*b1*fd*gd2*r + 792*D1**2*b1*fd*gd2*s - 1584*D1**2*b1*fd*gd2 - 1584*D1**2*b1*fdd*g2*r*s + 1584*D1**2*b1*fdd*g2*r - 792*D1**2*b1*fdd*g2*s + 396*D1**2*b1*fdd*g2 - 396*D1**2*bd1**2*f*(-4*K*r*s + 3*K*s + f*(r - 1) + r - 1) + 792*D1**2*bd2*f**2*r*s + 2376*D1**2*bd2*f**2*s**2 - 792*D1**2*bd2*f**2*s - 3168*D1**2*bd2*f*fd*r*s + 792*D1**2*bd2*f*fd*r - 7128*D1**2*bd2*f*fd*s**2 + 5148*D1**2*bd2*f*fd*s - 792*D1**2*bd2*f*fd - 924*D1**2*bdd1*f**2*r*s - 462*D1**2*bdd1*f**2*r + 330*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 - 1584*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*s - 396*D1**2*bdd1*f*g2 - 792*D1**2*bdd2*f**2*r*s - 1782*D1**2*bdd2*f**2*s**2 + 792*D1**2*bdd2*f**2*s - 2190*D1**2*f**2*fd*r*s + 730*D1**2*f**2*fd*r - 5940*D1**2*f**2*fd*s**2 + 4690*D1**2*f**2*fd*s - 1980*D1**2*f**2*fd + 2580*D1**2*f**2*fdd*r*s - 860*D1**2*f**2*fdd*r + 4455*D1**2*f**2*fdd*s**2 - 3830*D1**2*f**2*fdd*s + 1485*D1**2*f**2*fdd - 1584*D1**2*f**2*gd2*r*s - 4752*D1**2*f**2*gd2*s**2 + 1584*D1**2*f**2*gd2*s + 1584*D1**2*f**2*gdd2*r*s + 3564*D1**2*f**2*gdd2*s**2 - 1584*D1**2*f**2*gdd2*s + 5160*D1**2*f*fd**2*r*s - 1720*D1**2*f*fd**2*r + 8910*D1**2*f*fd**2*s**2 - 7660*D1**2*f*fd**2*s + 860*D1**2*f*fd**2 - 3168*D1**2*f*fd*g2*r*s + 1584*D1**2*f*fd*g2*r - 9504*D1**2*f*fd*g2*s**2 + 9504*D1**2*f*fd*g2*s - 4752*D1**2*f*fd*g2 + 6336*D1**2*f*fd*gd2*r*s - 1584*D1**2*f*fd*gd2*r + 14256*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 1584*D1**2*f*fd*gd2 + 3168*D1**2*f*fdd*g2*r*s - 1584*D1**2*f*fdd*g2*r + 7128*D1**2*f*fdd*g2*s**2 - 7128*D1**2*f*fdd*g2*s + 3564*D1**2*f*fdd*g2 + 3168*D1**2*fd**2*g2*r*s - 1584*D1**2*fd**2*g2*r + 7128*D1**2*fd**2*g2*s**2 - 7128*D1**2*fd**2*g2*s - 6336*D1*Dd*K*b1**2*f*r*s + 1584*D1*Dd*K*b1**2*f*r + 3168*D1*Dd*K*b1**2*f*s + 6336*D1*Dd*K*b1**2*fd*r*s - 3960*D1*Dd*K*b1**2*fd*r + 1188*D1*Dd*K*b1**2*fd + 3168*D1*Dd*K*b1*f**2*r*s - 792*D1*Dd*K*b1*f**2*r + 9504*D1*Dd*K*b1*f**2*s**2 - 6336*D1*Dd*K*b1*f**2*s + 2376*D1*Dd*K*b1*f**2 - 12672*D1*Dd*K*b1*f*fd*r*s + 4752*D1*Dd*K*b1*f*fd*r - 28512*D1*Dd*K*b1*f*fd*s**2 + 24552*D1*Dd*K*b1*f*fd*s - 5148*D1*Dd*K*b1*f*fd + 1584*D1*Dd*b1**2*f*fd*r - 792*D1*Dd*b1**2*f*fd + 1584*D1*Dd*b1**2*fd*r - 792*D1*Dd*b1**2*fd + 1584*D1*Dd*b1*bd2*f*s**2 - 396*D1*Dd*b1*bd2*f*s + 8976*D1*Dd*b1*f**2*r*s - 2244*D1*Dd*b1*f**2*r - 4488*D1*Dd*b1*f**2*s - 14784*D1*Dd*b1*f*fd*r*s + 7392*D1*Dd*b1*f*fd*r + 6072*D1*Dd*b1*f*fd*s - 3366*D1*Dd*b1*f*fd + 12672*D1*Dd*b1*f*g2*r*s - 3168*D1*Dd*b1*f*g2*r - 6336*D1*Dd*b1*f*g2*s - 12672*D1*Dd*b1*f*gd2*r*s + 1584*D1*Dd*b1*f*gd2*r + 9504*D1*Dd*b1*f*gd2*s - 1584*D1*Dd*b1*f*gd2 - 12672*D1*Dd*b1*fd*g2*r*s + 7920*D1*Dd*b1*fd*g2*r - 2376*D1*Dd*b1*fd*g2 - 6336*D1*Dd*bd2*f**2*r*s + 792*D1*Dd*bd2*f**2*r - 14256*D1*Dd*bd2*f**2*s**2 + 8316*D1*Dd*bd2*f**2*s - 792*D1*Dd*bd2*f**2 - 2920*D1*Dd*f**3*r*s + 730*D1*Dd*f**3*r - 7920*D1*Dd*f**3*s**2 + 5420*D1*Dd*f**3*s - 1980*D1*Dd*f**3 + 20640*D1*Dd*f**2*fd*r*s - 6020*D1*Dd*f**2*fd*r + 35640*D1*Dd*f**2*fd*s**2 - 29390*D1*Dd*f**2*fd*s + 5550*D1*Dd*f**2*fd - 6336*D1*Dd*f**2*g2*r*s + 1584*D1*Dd*f**2*g2*r - 19008*D1*Dd*f**2*g2*s**2 + 12672*D1*Dd*f**2*g2*s - 4752*D1*Dd*f**2*g2 + 12672*D1*Dd*f**2*gd2*r*s - 1584*D1*Dd*f**2*gd2*r + 28512*D1*Dd*f**2*gd2*s**2 - 16632*D1*Dd*f**2*gd2*s + 1584*D1*Dd*f**2*gd2 + 25344*D1*Dd*f*fd*g2*r*s - 9504*D1*Dd*f*fd*g2*r + 57024*D1*Dd*f*fd*g2*s**2 - 49104*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 + 3168*D1*Ddd*K*b1**2*f*r*s - 792*D1*Ddd*K*b1**2*f*r - 1584*D1*Ddd*K*b1**2*f*s - 3168*D1*Ddd*K*b1*f**2*r*s + 792*D1*Ddd*K*b1*f**2*r - 7128*D1*Ddd*K*b1*f**2*s**2 + 5148*D1*Ddd*K*b1*f**2*s - 1782*D1*Ddd*K*b1*f**2 - 3696*D1*Ddd*b1*f**2*r*s + 924*D1*Ddd*b1*f**2*r + 1848*D1*Ddd*b1*f**2*s - 6336*D1*Ddd*b1*f*g2*r*s + 1584*D1*Ddd*b1*f*g2*r + 3168*D1*Ddd*b1*f*g2*s + 3440*D1*Ddd*f**3*r*s - 860*D1*Ddd*f**3*r + 5940*D1*Ddd*f**3*s**2 - 4690*D1*Ddd*f**3*s + 1485*D1*Ddd*f**3 + 6336*D1*Ddd*f**2*g2*r*s - 1584*D1*Ddd*f**2*g2*r + 14256*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 3564*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(f**2*(-2*C*(s*(28*r - 10) + 5) + 36*K*s**2 - 12*K*s + 2*r*(6*K*s + 17*s + 7) - 16*s + 5) + f*(fd*(-38*C*s - 6*K*(r*(8*s - 2) + 18*s**2 - 13*s + 2) + 7*r*(16*C*s - 4*C - 8*s + 1) + 19*s + 7) + 6*g2*(s*(8*r - 4) + 2) + 6*s*(bd2*(s - 1) - 8*gd2*r + 6*gd2)) + 24*fd*g2*r*(1 - 2*s)) + Dd*f*(f*(2*C*(14*r*(8*s - 1) - 48*s + 5) - 6*K*(16*r*s - 2*r + 36*s**2 - 21*s + 2) - 112*r*s - 14*r + 48*s + 9) - 12*g2*(2*r - 1)*(8*s - 1)) - 6*b1*(D1*(f*(K*s*(8*r - 6) + K - r*(f + 2)) + fd*(K*(-8*r*s + 4*r + s - 2) - r + 1)) + Dd*f*(K*(-32*r*s + 4*r + 20*s - 3) + f*(4*r - 2) + 4*r - 2))) + 9504*Dd**2*K*b1**2*f*r*s - 2376*Dd**2*K*b1**2*f*r - 4752*Dd**2*K*b1**2*f*s + 1584*Dd**2*K*b1**2*f - 9504*Dd**2*K*b1*f**2*r*s + 2376*Dd**2*K*b1*f**2*r - 21384*Dd**2*K*b1*f**2*s**2 + 15444*Dd**2*K*b1*f**2*s - 1584*Dd**2*K*b1*f**2 - 11088*Dd**2*b1*f**2*r*s + 2772*Dd**2*b1*f**2*r + 5544*Dd**2*b1*f**2*s - 1848*Dd**2*b1*f**2 - 19008*Dd**2*b1*f*g2*r*s + 4752*Dd**2*b1*f*g2*r + 9504*Dd**2*b1*f*g2*s - 3168*Dd**2*b1*f*g2 + 10320*Dd**2*f**3*r*s - 2580*Dd**2*f**3*r + 17820*Dd**2*f**3*s**2 - 14070*Dd**2*f**3*s + 1720*Dd**2*f**3 + 19008*Dd**2*f**2*g2*r*s - 4752*Dd**2*f**2*g2*r + 42768*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 3168*Dd**2*f**2*g2 - 198*b2*(2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s + 8*D1*Dd*b1*f*s**2 - 4*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*s**2 + 2*D1*Dd*b1*fd*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 124*D1*Dd*f*fd*s + 26*D1*Dd*f*fd - 4*D1*Ddd*b1*f*s**2 + 2*D1*Ddd*b1*f*s - D1*Ddd*b1*f + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 26*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) - 12*Dd**2*b1*f*s**2 + 6*Dd**2*b1*f*s + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 78*Dd**2*f**2*s + 8*Dd**2*f**2))/(693*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**4*(D1*(12*D1*bd1**2*f*s*(5*K*s + f*(2*r - 1) + 2*r - 1) + D1*bdd1*f*s*(14*f*r + f*s*(50*C - 25) + s*(30*b2 - 60*g2)) + 2*bd1*(D1*(f**2*s*(-14*r + s*(25 - 50*C)) + f*(7*fd*r*(4*s - 1) + 2*fd*s*(25*C*(2*s - 1) - 25*s + 9) + s**2*(-30*b2 + 30*bd2 + 60*g2 - 60*gd2)) + 30*fd*s*(b2 - 2*g2)*(s - 1)) + Dd*f*(7*f*r*(8*s - 1) + f*s*(50*C*(4*s - 1) - 100*s + 11) + s*(30*b2 - 60*g2)*(4*s - 1)))) + 6*b1**2*(2*D1*Dd*(f*(-5*K*(4*s**2 - 2*s + 1) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(5*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(4*s - 2) - 2*s + 2) - 2*fd*(5*K*(s - 1)**2 - f*s + r*(2*f*s - f + 2*s - 2)) + fdd*(5*K*(s - 1)**2 - 2*f*s + 2*r*(2*f*s - f + s - 1))) + Ddd*f*(5*K*(4*s**2 - 2*s + 1) + (2*f + 2)*(r*(4*s - 1) - 2*s))) + 2*Dd**2*f*(30*K*s**2 - 15*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(-200*C*D1**2*f*fd*s**2 + 200*C*D1**2*f*fd*s - 100*C*D1**2*f*fd + 100*C*D1**2*f*fdd*s**2 - 100*C*D1**2*f*fdd*s + 50*C*D1**2*f*fdd + 100*C*D1**2*fd**2*s**2 - 100*C*D1**2*fd**2*s - 400*C*D1*Dd*f**2*s**2 + 200*C*D1*Dd*f**2*s - 100*C*D1*Dd*f**2 + 800*C*D1*Dd*f*fd*s**2 - 600*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 200*C*D1*Ddd*f**2*s**2 - 100*C*D1*Ddd*f**2*s + 50*C*D1*Ddd*f**2 + 600*C*Dd**2*f**2*s**2 - 300*C*Dd**2*f**2*s + 60*D1**2*K*bdd1*f*s**2 - 60*D1**2*bd2*f*s**2 + 60*D1**2*bd2*fd*s**2 - 60*D1**2*bd2*fd*s + 24*D1**2*bdd1*f**2*r*s - 12*D1**2*bdd1*f**2*s + 24*D1**2*bdd1*f*r*s - 12*D1**2*bdd1*f*s + 30*D1**2*bdd2*f*s**2 - 56*D1**2*f*fd*r*s + 28*D1**2*f*fd*r + 100*D1**2*f*fd*s**2 - 72*D1**2*f*fd*s + 50*D1**2*f*fd + 28*D1**2*f*fdd*r*s - 14*D1**2*f*fdd*r - 50*D1**2*f*fdd*s**2 + 36*D1**2*f*fdd*s - 25*D1**2*f*fdd + 120*D1**2*f*gd2*s**2 - 60*D1**2*f*gdd2*s**2 + 28*D1**2*fd**2*r*s - 14*D1**2*fd**2*r - 50*D1**2*fd**2*s**2 + 36*D1**2*fd**2*s + 14*D1**2*fd**2 + 120*D1**2*fd*g2*s**2 - 240*D1**2*fd*g2*s + 120*D1**2*fd*g2 - 120*D1**2*fd*gd2*s**2 + 120*D1**2*fd*gd2*s - 60*D1**2*fdd*g2*s**2 + 120*D1**2*fdd*g2*s - 60*D1**2*fdd*g2 + 240*D1*Dd*bd2*f*s**2 - 60*D1*Dd*bd2*f*s - 112*D1*Dd*f**2*r*s + 28*D1*Dd*f**2*r + 200*D1*Dd*f**2*s**2 - 44*D1*Dd*f**2*s + 50*D1*Dd*f**2 + 224*D1*Dd*f*fd*r*s - 84*D1*Dd*f*fd*r - 400*D1*Dd*f*fd*s**2 + 188*D1*Dd*f*fd*s - 8*D1*Dd*f*fd + 480*D1*Dd*f*g2*s**2 - 240*D1*Dd*f*g2*s + 120*D1*Dd*f*g2 - 480*D1*Dd*f*gd2*s**2 + 120*D1*Dd*f*gd2*s - 480*D1*Dd*fd*g2*s**2 + 600*D1*Dd*fd*g2*s - 120*D1*Dd*fd*g2 + 56*D1*Ddd*f**2*r*s - 14*D1*Ddd*f**2*r - 100*D1*Ddd*f**2*s**2 + 22*D1*Ddd*f**2*s - 25*D1*Ddd*f**2 - 240*D1*Ddd*f*g2*s**2 + 120*D1*Ddd*f*g2*s - 60*D1*Ddd*f*g2 + 12*D1*bd1*(D1*(f*s*(-10*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(10*K*s - 1))) + Dd*f*(40*K*s**2 - 10*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) + 168*Dd**2*f**2*r*s - 42*Dd**2*f**2*r - 300*Dd**2*f**2*s**2 + 66*Dd**2*f**2*s + 28*Dd**2*f**2 - 720*Dd**2*f*g2*s**2 + 360*Dd**2*f*g2*s - 30*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(21*d**2*k2) + 175*D1**2*Pk3*Pkd2*ct**3*f**2*k1**5*st**2*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(143*d**2*k2**2*k3**4) + 20*D1**2*Pk3*Pkd2*ct**3*f*k1**5*(30*D1**2*b1*f*fd*s**2 - 15*D1**2*b1*f*fdd*s**2 - 30*D1**2*b1*fd**2*s**2 - 5*D1**2*bdd1*f**2*(s - 1)**2 - 56*D1**2*f**2*fd*s**2 + 28*D1**2*f**2*fd*s - 14*D1**2*f**2*fd + 28*D1**2*f**2*fdd*s**2 - 14*D1**2*f**2*fdd*s + 7*D1**2*f**2*fdd + 84*D1**2*f*fd**2*s**2 - 42*D1**2*f*fd**2*s + 40*D1*Dd*b1*f**2*s**2 - 20*D1*Dd*b1*f**2*s + 10*D1*Dd*b1*f**2 - 120*D1*Dd*b1*f*fd*s**2 + 30*D1*Dd*b1*f*fd*s - 56*D1*Dd*f**3*s**2 + 28*D1*Dd*f**3*s - 14*D1*Dd*f**3 + 224*D1*Dd*f**2*fd*s**2 - 112*D1*Dd*f**2*fd*s + 14*D1*Dd*f**2*fd - 20*D1*Ddd*b1*f**2*s**2 + 10*D1*Ddd*b1*f**2*s - 5*D1*Ddd*b1*f**2 + 28*D1*Ddd*f**3*s**2 - 14*D1*Ddd*f**3*s + 7*D1*Ddd*f**3 + 10*D1*bd1*f*(s - 1)*(D1*f*(s - 1) - 3*D1*fd*s + Dd*f*(1 - 4*s)) - 60*Dd**2*b1*f**2*s**2 + 30*Dd**2*b1*f**2*s + 84*Dd**2*f**3*s**2 - 42*Dd**2*f**3*s)/(99*d**2*k2**2*k3**4) + 8*D1**2*Pk3*Pkd2*ct**3*f*k1**3*k2**2*st**4*(D1**2*(5*f**2*(521*fd - 280*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - f*(1400*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - fd*(780*C - 780)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(390*C - 390)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-429*K*bd1 + 429*bd1 + 858*gd2)) - 78*fd*(fd*(5*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 11*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1))) + 429*D1*b1*(K - 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*f*(Dd*(2605*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 20*f*(39*C*(r*(4*s - 1) + (1 - 2*s)**2) - 140*fd*(4*s - 1)*(4*r + 4*s - 3) - 39*r*(4*s - 1) - 39*(1 - 2*s)**2) - 78*fd*(5*C - 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 858*g2*(r*(4*s - 1) + (1 - 2*s)**2)) - 10*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(39*C + 140*f - 39)) - 10*Dd**2*f**2*(39*C + 140*f - 39)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k3**6) + 30*D1**2*Pk3*Pkd2*ct**3*f*k1**3*st**4*(D1**2*(105*f**2*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 630*f*fd**2*s*(2*s - 1) + f*fd*(52*C - 52)*(3*s**2 - 2*s + 1) - f*fdd*(26*C - 26)*(3*s**2 - 2*s + 1) - fd**2*s*(52*C - 52)*(3*s - 2)) + D1*f*(2*Dd*(105*f**2*(4*s**2 - 2*s + 1) + f*(26*C*(4*s**2 - 2*s + 1) - 105*fd*(1 - 4*s)**2 - 104*s**2 + 52*s - 26) - fd*(26*C - 26)*(12*s**2 - 7*s + 1)) - Ddd*f*(26*C + 105*f - 26)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(26*C + 105*f - 26))/(1001*d**2*k3**4) - 40*D1**2*Pk3*Pkd2*ct**3*f*k1*k2**4*st**4*(D1**2*(f**2*s*(14*bd1 - 7*bdd1)*(r + s - 1) + f*(fd*(14*b1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*bd1*(6*r*s - r + 6*s**2 - 6*s + 1) + (18 - 24*C)*(3*r*s - r + 3*s**2 - 3*s + 1)) - fdd*(-12*C + 7*b1 + 9)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(-12*C + 7*b1 + 9)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(f*(14*b1*(r*(4*s - 1) + (1 - 2*s)**2) - 7*bd1*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - (24*C - 18)*(r*(4*s - 1) + (1 - 2*s)**2)) - fd*(-12*C + 7*b1 + 9)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-12*C + 7*b1 + 9)) - Dd**2*f**2*(-12*C + 7*b1 + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k3**6) + 5*D1**2*Pk3*Pkd2*ct**3*f*k1*k2**2*st**4*(D1**2*(7*f**2*(4*fd*(-4*r*s + r + 2*s) + 4*fdd*(4*r*s - r - 2*s) + s*(2*bd1 - bdd1)*(4*r - s - 4)) + f*(28*fd**2*(3*r*(4*s - 1) - 6*s + 2) + 2*fd*(-48*C*r*s + 16*C*r + 180*C*s**2 - 104*C*s + 60*C - 7*b1*(r*(4 - 12*s) + 3*s**2 + 2*s + 1) + 7*bd1*(r*(2 - 12*s) + 3*s**2 + 7*s - 2) + 84*r*s - 28*r - 99*s**2 + 38*s - 33) + fdd*(4*C*(12*r*s - 4*r - 45*s**2 + 26*s - 15) + 7*b1*(r*(4 - 12*s) + 3*s**2 + 2*s + 1) - 84*r*s + 28*r + 99*s**2 - 38*s + 33)) + 2*fd**2*(4*C*(12*r*s - 4*r - 45*s**2 + 26*s + 2) + 7*b1*(r*(4 - 12*s) + 3*s**2 + 2*s - 2) - 84*r*s + 28*r + 99*s**2 - 38*s - 14)) + D1*f*(-2*Dd*(14*f**2*(r*(4*s - 1) - 2*s) + f*(64*C*r*s - 16*C*r - 240*C*s**2 + 88*C*s - 60*C + 7*b1*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) + 7*bd1*(16*r*s - 2*r - 4*s**2 - 11*s + 2) - 448*fd*r*s + 112*fd*r + 224*fd*s - 56*fd - 112*r*s + 28*r + 132*s**2 - 10*s + 33) + fd*(4*C*(r*(14 - 48*s) + 180*s**2 - 85*s + 9) + 7*b1*(2*r*(24*s - 7) - 12*s**2 - 13*s + 5) + 336*r*s - 98*r - 396*s**2 + 91*s + 9)) + Ddd*f*(4*C*(16*r*s - 4*r - 60*s**2 + 22*s - 15) + 7*b1*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) + 112*f*r*s - 28*f*r - 56*f*s - 112*r*s + 28*r + 132*s**2 - 10*s + 33)) + 2*Dd**2*f**2*(4*C*(24*r*s - 6*r - 90*s**2 + 33*s + 4) + 7*b1*(r*(6 - 24*s) + 6*s**2 + 9*s - 4) + 168*f*r*s - 42*f*r - 84*f*s + 28*f - 168*r*s + 42*r + 198*s**2 - 15*s - 28))/(231*d**2*k3**4) + 15*D1**2*Pk3*Pkd2*ct**3*f*k1*st**4*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) + 2*f*fd*(7*b1*(3*s**2 - 2*s + 1) + s**2*(9 - 21*bd1) + s*(7*bd1 - 6) + 3) - f*fdd*(7*b1 + 3)*(3*s**2 - 2*s + 1) - fd**2*s*(14*b1 + 6)*(3*s - 2)) + D1*f*(2*Dd*f*(7*b1*(4*s**2 - 2*s + 1) - s**2*(28*bd1 - 12) + s*(7*bd1 - 6) + 3) - Dd*fd*(14*b1 + 6)*(12*s**2 - 7*s + 1) - Ddd*f*(7*b1 + 3)*(4*s**2 - 2*s + 1)) + Dd**2*f**2*s*(-42*b1 - 18)*(2*s - 1))/(77*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**3*f*k2**4*st**2*(16*C - 8)*(D1*Dd*f*(7*f*(-4*r*s + r + 2*s) + 20*fd*(24*r*s - 7*r - 10*s + 3)) + D1*(D1*(7*f*fd*(-3*r*s + r + s) + 20*f*fdd*(3*r*s - r - s) + 20*fd**2*(6*r*s - 2*r - 2*s + 1)) + 20*Ddd*f**2*(r*(4*s - 1) - 2*s)) + 20*Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2))/(693*d**2*k1*k3**4) - D1**2*Pk3*Pkd2*ct**3*f*k2**2*st**2*(16*C - 8)*(D1*Dd*f*(7*f*(-4*r*s + r + 2*s) + 20*fd*(24*r*s - 7*r - 10*s + 3)) + D1*(D1*(7*f*fd*(-3*r*s + r + s) + 20*f*fdd*(3*r*s - r - s) + 20*fd**2*(6*r*s - 2*r - 2*s + 1)) + 20*Ddd*f**2*(r*(4*s - 1) - 2*s)) + 20*Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2))/(693*d**2*k1*k3**2) + 4*D1**2*Pk3*Pkd2*ct**3*k1**5*st**2*(9126*C*D1**2*f**2*fd*r*s - 3042*C*D1**2*f**2*fd*r + 9126*C*D1**2*f**2*fd*s**2 - 9126*C*D1**2*f**2*fd*s + 3042*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 12168*C*D1*Dd*f**3*r*s - 3042*C*D1*Dd*f**3*r + 12168*C*D1*Dd*f**3*s**2 - 12168*C*D1*Dd*f**3*s + 3042*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 55000*D1**2*f**3*fd*r*s - 13750*D1**2*f**3*fd*r + 55000*D1**2*f**3*fd*s**2 - 55000*D1**2*f**3*fd*s + 13750*D1**2*f**3*fd - 39200*D1**2*f**3*fdd*r*s + 9800*D1**2*f**3*fdd*r - 39200*D1**2*f**3*fdd*s**2 + 39200*D1**2*f**3*fdd*s - 9800*D1**2*f**3*fdd - 117600*D1**2*f**2*fd**2*r*s + 29400*D1**2*f**2*fd**2*r - 117600*D1**2*f**2*fd**2*s**2 + 117600*D1**2*f**2*fd**2*s - 19600*D1**2*f**2*fd**2 - 9126*D1**2*f**2*fd*r*s + 3042*D1**2*f**2*fd*r - 9126*D1**2*f**2*fd*s**2 + 9126*D1**2*f**2*fd*s - 3042*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*s**2 + 4290*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 8580*D1**2*f*fd*g2*r*s + 4290*D1**2*f*fd*g2*r - 8580*D1**2*f*fd*g2*s**2 + 8580*D1**2*f*fd*g2*s - 4290*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 55000*D1*Dd*f**4*r*s - 13750*D1*Dd*f**4*r + 55000*D1*Dd*f**4*s**2 - 55000*D1*Dd*f**4*s + 13750*D1*Dd*f**4 - 313600*D1*Dd*f**3*fd*r*s + 78400*D1*Dd*f**3*fd*r - 313600*D1*Dd*f**3*fd*s**2 + 313600*D1*Dd*f**3*fd*s - 58800*D1*Dd*f**3*fd - 12168*D1*Dd*f**3*r*s + 3042*D1*Dd*f**3*r - 12168*D1*Dd*f**3*s**2 + 12168*D1*Dd*f**3*s - 3042*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 17160*D1*Dd*f**2*g2*r*s + 4290*D1*Dd*f**2*g2*r - 17160*D1*Dd*f**2*g2*s**2 + 17160*D1*Dd*f**2*g2*s - 4290*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 39200*D1*Ddd*f**4*r*s + 9800*D1*Ddd*f**4*r - 39200*D1*Ddd*f**4*s**2 + 39200*D1*Ddd*f**4*s - 9800*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 117600*Dd**2*f**4*r*s + 29400*Dd**2*f**4*r - 117600*Dd**2*f**4*s**2 + 117600*Dd**2*f**4*s - 19600*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k3**6) + 8*D1**2*Pk3*Pkd2*ct**3*k1**5*(-D1*(198*D1*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + D1*bd1*(-5*f**3*(102*s - 125)*(r + s - 1) - 4*f**2*(66*C*(s - 1)*(r + s - 1) - 35*fd*(18*r*s - 11*r + 18*s**2 - 26*s + 7) + (66 - 66*s)*(r + s - 1)) + 66*f*(fd*(5*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (5*g2*(s - 1) + 6*gd2*(1 - 2*s))*(r + s - 1)) - 396*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*D1*bdd1*f*(r + s - 1)*(70*f**2*(3*s - 4) + f*(165*C - 165)*(s - 1) - 198*g2*(s - 1)) + 2*Dd*bd1*f*(70*f**2*(r*(24*s - 19) + 24*s**2 - 40*s + 15) + f*(165*C - 165)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 198*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 140*f**3*(D1*fd + Dd*f)*(r*(4*s - 1) + (1 - 2*s)**2)) + 33*b1**2*(K - 1)*(D1**2*s*(5*fd - 6*fdd)*(r + s) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) + 6*fd*(-8*r*s + r + s*(4 - 8*s))) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(528*C*D1**2*f*fd*r*s + 528*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s - 660*C*D1**2*f*fdd*r*s - 660*C*D1**2*f*fdd*s**2 + 330*C*D1**2*f*fdd*s - 660*C*D1**2*fd**2*r*s - 660*C*D1**2*fd**2*s**2 + 330*C*D1**2*fd**2*s + 1056*C*D1*Dd*f**2*r*s - 264*C*D1*Dd*f**2*r + 1056*C*D1*Dd*f**2*s**2 - 1056*C*D1*Dd*f**2*s + 264*C*D1*Dd*f**2 - 5280*C*D1*Dd*f*fd*r*s + 660*C*D1*Dd*f*fd*r - 5280*C*D1*Dd*f*fd*s**2 + 3960*C*D1*Dd*f*fd*s - 330*C*D1*Dd*f*fd - 1320*C*D1*Ddd*f**2*r*s + 330*C*D1*Ddd*f**2*r - 1320*C*D1*Ddd*f**2*s**2 + 1320*C*D1*Ddd*f**2*s - 330*C*D1*Ddd*f**2 - 3960*C*Dd**2*f**2*r*s + 990*C*Dd**2*f**2*r - 3960*C*Dd**2*f**2*s**2 + 3960*C*Dd**2*f**2*s - 660*C*Dd**2*f**2 - 198*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 1530*D1**2*f**2*fd*r*s + 115*D1**2*f**2*fd*r + 1530*D1**2*f**2*fd*s**2 - 905*D1**2*f**2*fd*s - 115*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r - 1260*D1**2*f**2*fdd*s**2 + 700*D1**2*f**2*fdd*s + 140*D1**2*f**2*fdd - 2520*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r - 2520*D1**2*f*fd**2*s**2 + 1400*D1**2*f*fd**2*s + 140*D1**2*f*fd**2 - 528*D1**2*f*fd*r*s - 528*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s + 660*D1**2*f*fdd*r*s + 660*D1**2*f*fdd*s**2 - 330*D1**2*f*fdd*s - 330*D1**2*f*gd2*r*s - 330*D1**2*f*gd2*s**2 + 330*D1**2*f*gd2*s + 396*D1**2*f*gdd2*r*s + 396*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s + 660*D1**2*fd**2*r*s + 660*D1**2*fd**2*s**2 - 330*D1**2*fd**2*s - 330*D1**2*fd*g2*r*s - 330*D1**2*fd*g2*s**2 + 792*D1**2*fd*gd2*r*s + 792*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 396*D1**2*fdd*g2*r*s + 396*D1**2*fdd*g2*s**2 + 2040*D1*Dd*f**3*r*s - 510*D1*Dd*f**3*r + 2040*D1*Dd*f**3*s**2 - 2040*D1*Dd*f**3*s + 510*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r*s + 700*D1*Dd*f**2*fd*r - 10080*D1*Dd*f**2*fd*s**2 + 7840*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*r*s + 264*D1*Dd*f**2*r - 1056*D1*Dd*f**2*s**2 + 1056*D1*Dd*f**2*s - 264*D1*Dd*f**2 + 5280*D1*Dd*f*fd*r*s - 660*D1*Dd*f*fd*r + 5280*D1*Dd*f*fd*s**2 - 3960*D1*Dd*f*fd*s + 330*D1*Dd*f*fd - 1320*D1*Dd*f*g2*r*s + 330*D1*Dd*f*g2*r - 1320*D1*Dd*f*g2*s**2 + 1320*D1*Dd*f*g2*s - 330*D1*Dd*f*g2 + 3168*D1*Dd*f*gd2*r*s - 396*D1*Dd*f*gd2*r + 3168*D1*Dd*f*gd2*s**2 - 3168*D1*Dd*f*gd2*s + 396*D1*Dd*f*gd2 + 3168*D1*Dd*fd*g2*r*s - 396*D1*Dd*fd*g2*r + 3168*D1*Dd*fd*g2*s**2 - 1584*D1*Dd*fd*g2*s - 1680*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 1680*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*r*s - 330*D1*Ddd*f**2*r + 1320*D1*Ddd*f**2*s**2 - 1320*D1*Ddd*f**2*s + 330*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r*s - 396*D1*Ddd*f*g2*r + 1584*D1*Ddd*f*g2*s**2 - 1584*D1*Ddd*f*g2*s + 396*D1*Ddd*f*g2 + 33*D1*bd1*(K - 1)*(D1*(5*f*(2*s - 1)*(r + s - 1) + 6*fd*(-4*r*s + r + s*(3 - 4*s))) - 6*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 5040*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 5040*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 840*Dd**2*f**3 + 3960*Dd**2*f**2*r*s - 990*Dd**2*f**2*r + 3960*Dd**2*f**2*s**2 - 3960*Dd**2*f**2*s + 660*Dd**2*f**2 + 4752*Dd**2*f*g2*r*s - 1188*Dd**2*f*g2*r + 4752*Dd**2*f*g2*s**2 - 4752*Dd**2*f*g2*s + 792*Dd**2*f*g2))/(693*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct**3*k1**3*k2**2*st**2*(-297*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 2*D1**2*bdd1*f*(r + s - 1)*(250*f**2*(s + 2) - 297*f*(C*(s - 1) + s*(2*K - 2) + 1) + 297*g2*(s - 1)) + 6*D1**2*(-125*f**3*fd*(r*(4*s - 1) + (1 - 2*s)**2) + 3*f**2*(fd*(134*C - 95)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(100*C - 75)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-198*gd2 + 132*gdd2)*(r + s - 1)) - 3*f*(fd**2*(100*C - 75)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*fd*(g2*(r*(6*s - 3) + 6*s**2 - 6*s + 3) + 2*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 132*fdd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 396*fd**2*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*D1*bd1*(D1*(f**3*(302*s + 901)*(r + s - 1) - f**2*(561*C*(s - 1)*(r + s - 1) + 250*fd*(r*(6*s + 3) + 6*s**2 - 2*s - 1) + (s*(27*K - 29) + 17)*(33*r + 33*s - 33)) + 33*f*(9*fd*(C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 8*r*s + 3*r - 8*s**2 + 9*s - 2) + (25*g2*(s - 1) + 9*gd2*(1 - 2*s))*(r + s - 1)) - 297*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(250*f**2*(r*(8*s + 7) + 8*s**2 - 5) - 297*f*(C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 16*r*s + 6*r - 16*s**2 + 20*s - 5) + 297*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 6*D1*f*(Dd*(-125*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(402*C - 285)*(r*(4*s - 1) + (1 - 2*s)**2) - 3*f*(fd*(100*C - 75)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 198*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 132*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 792*fd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(f*(100*C - 75) - 132*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*Dd**2*f**2*(f*(100*C - 75) - 132*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 33*b1**2*(K - 1)*(D1**2*s*(25*fd - 9*fdd)*(r + s) + D1*Dd*(25*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(-8*r*s + r + s*(4 - 8*s))) - 9*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-297*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 2*D1**2*(f**2*(fd*(r*(1203 - 906*s) - 906*s**2 + 1807*s - 1203) + 250*fdd*(3*r*(s - 1) + 3*s**2 - 5*s + 3)) + f*(250*fd**2*(6*r*(s - 1) + 6*s**2 - 10*s + 3) + 33*fd*(34*C*s**2 - 17*C*s + 27*K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*r*(17*C*s - 29*s + 6) - 58*s**2 + 41*s - 12) - 297*fdd*(2*C*r*s + 2*C*s**2 - C*s + K*(4*r*s - 2*r + 4*s**2 - 4*s + 2) - 4*r*s + r - 4*s**2 + 3*s - 1) - 33*s*(25*gd2 - 9*gdd2)*(r + s - 1)) - 297*fd**2*(r*(K*(4*s - 2) + s*(2*C - 4) + 1) + s*(C*(2*s - 1) + 4*K*(s - 1) - 4*s + 3)) - 33*fd*s*(25*g2*(r + s) - 9*gd2*(2*r + 2*s - 1)) + 297*fdd*g2*s*(r + s)) + 33*D1*bd1*(K - 1)*(D1*(25*f*(2*s - 1)*(r + s - 1) + 9*fd*(-4*r*s + r + s*(3 - 4*s))) - 9*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 2*D1*(Dd*(-302*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(561*C*(r*(4*s - 1) + (1 - 2*s)**2) + 250*fd*(3*r*(8*s - 5) + 24*s**2 - 32*s + 11) + (891*K - 957)*(r*(4*s - 1) + (1 - 2*s)**2)) - 33*f*(9*fd*(C*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 4*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - (4*s - 1)*(8*r + 8*s - 5)) + 25*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 9*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 297*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(250*f**2 - 297*f*(C + 2*K - 2) + 297*g2)) + 2*Dd**2*f*(250*f**2 - 297*f*(C + 2*K - 2) + 297*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**6) - 8*D1**2*Pk3*Pkd2*ct**3*k1**3*k2**2*(1980*C*D1**2*bdd1*f**2*r*s - 1980*C*D1**2*bdd1*f**2*r + 1980*C*D1**2*bdd1*f**2*s**2 - 3960*C*D1**2*bdd1*f**2*s + 1980*C*D1**2*bdd1*f**2 + 1290*C*D1**2*f**2*fd*r*s - 430*C*D1**2*f**2*fd*r + 1290*C*D1**2*f**2*fd*s**2 - 1290*C*D1**2*f**2*fd*s + 430*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 + 1720*C*D1*Dd*f**3*r*s - 430*C*D1*Dd*f**3*r + 1720*C*D1*Dd*f**3*s**2 - 1720*C*D1*Dd*f**3*s + 430*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 198*D1**2*bd1**2*f*(2*s - 1)*(-6*K + 5*f + 3)*(r + s - 1) - 1485*D1**2*bdd1*f**2*r*s + 1485*D1**2*bdd1*f**2*r - 1485*D1**2*bdd1*f**2*s**2 + 2970*D1**2*bdd1*f**2*s - 1485*D1**2*bdd1*f**2 - 2376*D1**2*bdd1*f*g2*r*s + 2376*D1**2*bdd1*f*g2*r - 2376*D1**2*bdd1*f*g2*s**2 + 4752*D1**2*bdd1*f*g2*s - 2376*D1**2*bdd1*f*g2 - 1140*D1**2*f**2*fd*r*s + 380*D1**2*f**2*fd*r - 1140*D1**2*f**2*fd*s**2 + 1140*D1**2*f**2*fd*s - 380*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 840*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s - 1520*D1*Dd*f**3*r*s + 380*D1*Dd*f**3*r - 1520*D1*Dd*f**3*s**2 + 1520*D1*Dd*f**3*s - 380*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3360*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*g2*r*s + 528*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s**2 + 2112*D1*Dd*f**2*g2*s - 528*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(15*f**3*(r + s - 1) + 2*f**2*(r + s - 1)*(24*C*(s - 1) - s*(4*K + 12) + 15) + f*(-5*fd*(12*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 9*r*(4*s - 2) - 36*s**2 + 45*s - 9) + (-5*g2*(s - 1) + 6*gd2*(2*s - 1))*(12*r + 12*s - 12)) + 72*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-5*f*(12*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 72*r*s + 45*r - 72*s**2 + 108*s - 36) + 72*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 1680*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 66*b1**2*(D1**2*s*(3*f*(7*fd - 5*fdd)*(2*r + 2*s - 1) - 15*fd**2*(2*r + 2*s - 1) - fd*(15*K - 4)*(r + s) + 9*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(21*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-15*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - (15*K - 4)*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-6*K + 5*f + 3)) - 3*Dd**2*f*(-6*K + 5*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 33*b1*(-96*C*D1**2*f*fd*r*s - 96*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s + 120*C*D1**2*f*fdd*r*s + 120*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 120*C*D1**2*fd**2*r*s + 120*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s - 192*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 192*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r*s - 120*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 240*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 720*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 + 16*D1**2*K*f*fd*r*s - 8*D1**2*K*f*fd*r + 16*D1**2*K*f*fd*s**2 - 16*D1**2*K*f*fd*s + 8*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r*s - 5*D1**2*K*f*fdd*r + 10*D1**2*K*f*fdd*s**2 - 10*D1**2*K*f*fdd*s + 5*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r*s - 5*D1**2*K*fd**2*r + 10*D1**2*K*fd**2*s**2 - 10*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(2*s - 1)*(-6*K + 5*f + 3)*(r + s - 1) + 15*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 48*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s - 6*D1**2*f*fd - 90*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*s**2 + 45*D1**2*f*fdd*s + 60*D1**2*f*gd2*r*s + 60*D1**2*f*gd2*s**2 - 60*D1**2*f*gd2*s - 72*D1**2*f*gdd2*r*s - 72*D1**2*f*gdd2*s**2 + 72*D1**2*f*gdd2*s - 90*D1**2*fd**2*r*s - 90*D1**2*fd**2*s**2 + 45*D1**2*fd**2*s + 60*D1**2*fd*g2*r*s + 60*D1**2*fd*g2*s**2 - 144*D1**2*fd*gd2*r*s - 144*D1**2*fd*gd2*s**2 + 72*D1**2*fd*gd2*s - 72*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*s**2 + 32*D1*Dd*K*f**2*r*s - 8*D1*Dd*K*f**2*r + 32*D1*Dd*K*f**2*s**2 - 32*D1*Dd*K*f**2*s + 8*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r*s - 30*D1*Dd*K*f*fd*r + 80*D1*Dd*K*f*fd*s**2 - 80*D1*Dd*K*f*fd*s + 20*D1*Dd*K*f*fd + 96*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 96*D1*Dd*f**2*s + 24*D1*Dd*f**2 - 720*D1*Dd*f*fd*r*s + 90*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 540*D1*Dd*f*fd*s - 45*D1*Dd*f*fd + 240*D1*Dd*f*g2*r*s - 60*D1*Dd*f*g2*r + 240*D1*Dd*f*g2*s**2 - 240*D1*Dd*f*g2*s + 60*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r*s + 72*D1*Dd*f*gd2*r - 576*D1*Dd*f*gd2*s**2 + 576*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 576*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s + 20*D1*Ddd*K*f**2*r*s - 5*D1*Ddd*K*f**2*r + 20*D1*Ddd*K*f**2*s**2 - 20*D1*Ddd*K*f**2*s + 5*D1*Ddd*K*f**2 - 180*D1*Ddd*f**2*r*s + 45*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 288*D1*Ddd*f*g2*s**2 + 288*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(21*f**2*(2*s - 1)*(r + s - 1) + f*(-15*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) - (15*K - 4)*(2*s - 1)*(r + s - 1)) + 9*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 3*Dd*f*(-6*K + 5*f + 3)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 60*Dd**2*K*f**2*r*s - 15*Dd**2*K*f**2*r + 60*Dd**2*K*f**2*s**2 - 60*Dd**2*K*f**2*s + 10*Dd**2*K*f**2 - 540*Dd**2*f**2*r*s + 135*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 90*Dd**2*f**2 - 864*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 864*Dd**2*f*g2*s**2 + 864*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(693*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**3*k1**3*st**2*(-396*C*D1**2*bdd1*f**2*r*s - 1386*C*D1**2*bdd1*f**2*s**2 + 1980*C*D1**2*bdd1*f**2*s - 990*C*D1**2*bdd1*f**2 - 4572*C*D1**2*f**2*fd*r*s + 1524*C*D1**2*f**2*fd*r - 4140*C*D1**2*f**2*fd*s**2 + 4284*C*D1**2*f**2*fd*s - 1380*C*D1**2*f**2*fd + 3276*C*D1**2*f**2*fdd*r*s - 1092*C*D1**2*f**2*fdd*r + 3258*C*D1**2*f**2*fdd*s**2 - 3264*C*D1**2*f**2*fdd*s + 1086*C*D1**2*f**2*fdd + 6552*C*D1**2*f*fd**2*r*s - 2184*C*D1**2*f*fd**2*r + 6516*C*D1**2*f*fd**2*s**2 - 6528*C*D1**2*f*fd**2*s + 1092*C*D1**2*f*fd**2 - 6096*C*D1*Dd*f**3*r*s + 1524*C*D1*Dd*f**3*r - 5520*C*D1*Dd*f**3*s**2 + 5808*C*D1*Dd*f**3*s - 1380*C*D1*Dd*f**3 + 26208*C*D1*Dd*f**2*fd*r*s - 7644*C*D1*Dd*f**2*fd*r + 26064*C*D1*Dd*f**2*fd*s**2 - 26124*C*D1*Dd*f**2*fd*s + 5448*C*D1*Dd*f**2*fd + 4368*C*D1*Ddd*f**3*r*s - 1092*C*D1*Ddd*f**3*r + 4344*C*D1*Ddd*f**3*s**2 - 4356*C*D1*Ddd*f**3*s + 1086*C*D1*Ddd*f**3 + 13104*C*Dd**2*f**3*r*s - 3276*C*Dd**2*f**3*r + 13032*C*Dd**2*f**3*s**2 - 13068*C*Dd**2*f**3*s + 2184*C*Dd**2*f**3 + 594*D1**2*K*bdd1*f**2*r*s + 495*D1**2*K*bdd1*f**2*s**2 - 594*D1**2*K*bdd1*f**2*s - 198*D1**2*bd1**2*f*s*(K - 1)*(2*r + 7*s - 6) - 2500*D1**2*bdd1*f**3*r*s - 2500*D1**2*bdd1*f**3*s**2 + 5250*D1**2*bdd1*f**3*s - 1875*D1**2*bdd1*f**3 - 1386*D1**2*bdd1*f**2*r*s - 792*D1**2*bdd1*f**2*s**2 - 198*D1**2*bdd1*f**2*s + 990*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r*s + 1386*D1**2*bdd1*f*g2*s**2 - 1980*D1**2*bdd1*f*g2*s + 990*D1**2*bdd1*f*g2 - 12000*D1**2*f**3*fd*r*s + 3000*D1**2*f**3*fd*r - 27000*D1**2*f**3*fd*s**2 + 19500*D1**2*f**3*fd*s - 6750*D1**2*f**3*fd + 12000*D1**2*f**3*fdd*r*s - 3000*D1**2*f**3*fdd*r + 16500*D1**2*f**3*fdd*s**2 - 14250*D1**2*f**3*fdd*s + 4125*D1**2*f**3*fdd + 36000*D1**2*f**2*fd**2*r*s - 9000*D1**2*f**2*fd**2*r + 49500*D1**2*f**2*fd**2*s**2 - 42750*D1**2*f**2*fd**2*s + 6000*D1**2*f**2*fd**2 + 8784*D1**2*f**2*fd*r*s - 2928*D1**2*f**2*fd*r + 10602*D1**2*f**2*fd*s**2 - 9996*D1**2*f**2*fd*s + 3534*D1**2*f**2*fd - 5976*D1**2*f**2*fdd*r*s + 1992*D1**2*f**2*fdd*r - 7083*D1**2*f**2*fdd*s**2 + 6714*D1**2*f**2*fdd*s - 2361*D1**2*f**2*fdd + 1980*D1**2*f**2*gd2*r*s + 1188*D1**2*f**2*gd2*s**2 - 1980*D1**2*f**2*gd2*s - 1188*D1**2*f**2*gdd2*r*s - 990*D1**2*f**2*gdd2*s**2 + 1188*D1**2*f**2*gdd2*s - 11952*D1**2*f*fd**2*r*s + 3984*D1**2*f*fd**2*r - 14166*D1**2*f*fd**2*s**2 + 13428*D1**2*f*fd**2*s - 1992*D1**2*f*fd**2 + 3960*D1**2*f*fd*g2*r*s - 1980*D1**2*f*fd*g2*r + 2376*D1**2*f*fd*g2*s**2 - 2376*D1**2*f*fd*g2*s + 1188*D1**2*f*fd*g2 - 4752*D1**2*f*fd*gd2*r*s + 1188*D1**2*f*fd*gd2*r - 3960*D1**2*f*fd*gd2*s**2 + 4356*D1**2*f*fd*gd2*s - 1188*D1**2*f*fd*gd2 - 2376*D1**2*f*fdd*g2*r*s + 1188*D1**2*f*fdd*g2*r - 1980*D1**2*f*fdd*g2*s**2 + 1980*D1**2*f*fdd*g2*s - 990*D1**2*f*fdd*g2 - 2376*D1**2*fd**2*g2*r*s + 1188*D1**2*fd**2*g2*r - 1980*D1**2*fd**2*g2*s**2 + 1980*D1**2*fd**2*g2*s - 12000*D1*Dd*f**4*r*s + 3000*D1*Dd*f**4*r - 27000*D1*Dd*f**4*s**2 + 19500*D1*Dd*f**4*s - 6750*D1*Dd*f**4 + 96000*D1*Dd*f**3*fd*r*s - 24000*D1*Dd*f**3*fd*r + 132000*D1*Dd*f**3*fd*s**2 - 114000*D1*Dd*f**3*fd*s + 20250*D1*Dd*f**3*fd + 11712*D1*Dd*f**3*r*s - 2928*D1*Dd*f**3*r + 14136*D1*Dd*f**3*s**2 - 12924*D1*Dd*f**3*s + 3534*D1*Dd*f**3 - 47808*D1*Dd*f**2*fd*r*s + 13944*D1*Dd*f**2*fd*r - 56664*D1*Dd*f**2*fd*s**2 + 52974*D1*Dd*f**2*fd*s - 10698*D1*Dd*f**2*fd + 7920*D1*Dd*f**2*g2*r*s - 1980*D1*Dd*f**2*g2*r + 4752*D1*Dd*f**2*g2*s**2 - 6336*D1*Dd*f**2*g2*s + 1188*D1*Dd*f**2*g2 - 9504*D1*Dd*f**2*gd2*r*s + 1188*D1*Dd*f**2*gd2*r - 7920*D1*Dd*f**2*gd2*s**2 + 9108*D1*Dd*f**2*gd2*s - 1188*D1*Dd*f**2*gd2 - 19008*D1*Dd*f*fd*g2*r*s + 7128*D1*Dd*f*fd*g2*r - 15840*D1*Dd*f*fd*g2*s**2 + 16632*D1*Dd*f*fd*g2*s - 4356*D1*Dd*f*fd*g2 + 12000*D1*Ddd*f**4*r*s - 3000*D1*Ddd*f**4*r + 16500*D1*Ddd*f**4*s**2 - 14250*D1*Ddd*f**4*s + 4125*D1*Ddd*f**4 - 7968*D1*Ddd*f**3*r*s + 1992*D1*Ddd*f**3*r - 9444*D1*Ddd*f**3*s**2 + 8706*D1*Ddd*f**3*s - 2361*D1*Ddd*f**3 - 4752*D1*Ddd*f**2*g2*r*s + 1188*D1*Ddd*f**2*g2*r - 3960*D1*Ddd*f**2*g2*s**2 + 4356*D1*Ddd*f**2*g2*s - 990*D1*Ddd*f**2*g2 + 2*D1*bd1*(D1*(f**3*(1906*s**2 + s*(1906*r - 4854) + 1875) + f**2*(330*C*(4*s**2 + s*(r - 6) + 3) - 250*fd*(5*r*(6*s - 1) + 30*s**2 - 41*s + 3) - 33*s**2*(9*K - 14) - 33*s*(15*K*(r - 1) - 35*r - 15) - 990) + 33*f*(3*fd*(-28*C*s**2 + 26*C*s + K*(3*r*(4*s - 1) + 10*s**2 - 11*s + 3) - r*(2*C + 7)*(4*s - 1) - 16*s**2 + 14*s - 9) - 2*g2*(28*s**2 + s*(13*r - 30) + 15) + 6*gd2*s*(2*r + 7*s - 6)) + 198*fd*g2*(r*(2*s - 1) + s*(7*s - 7))) + Dd*f*(-125*f**2*(10*r*(8*s - 1) + 80*s**2 - 124*s + 21) - 99*f*(2*C*(r*(8*s - 1) + 28*s**2 - 29*s + 5) + K*(-24*r*s + 3*r - 20*s**2 + 23*s - 3) + 56*r*s - 7*r + 32*s**2 - 18*s - 1) + 198*g2*(r*(8*s - 1) + 28*s**2 - 29*s + 5))) + 36000*Dd**2*f**4*r*s - 9000*Dd**2*f**4*r + 49500*Dd**2*f**4*s**2 - 42750*Dd**2*f**4*s + 6000*Dd**2*f**4 - 23904*Dd**2*f**3*r*s + 5976*Dd**2*f**3*r - 28332*Dd**2*f**3*s**2 + 26118*Dd**2*f**3*s - 3984*Dd**2*f**3 - 14256*Dd**2*f**2*g2*r*s + 3564*Dd**2*f**2*g2*r - 11880*Dd**2*f**2*g2*s**2 + 13068*Dd**2*f**2*g2*s - 2376*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*(fd*(26*r*(s - 1) + 56*s**2 - 52*s + 26) - 3*fdd*(2*r*(s - 1) + 7*s**2 - 4*s + 2)) + D1*(2*Dd*(f*(52*r*s - 13*r + 112*s**2 - 82*s + 28) - 3*fd*(8*r*s - 5*r + 28*s**2 - 17*s + 4)) - 3*Ddd*f*(r*(8*s - 2) + 28*s**2 - 18*s + 7)) - 6*Dd**2*f*(3*r*(4*s - 1) + 42*s**2 - 27*s + 2)) + b1*(1320*C*D1**2*f*fd*r*s - 660*C*D1**2*f*fd*r + 5280*C*D1**2*f*fd*s**2 - 1980*C*D1**2*f*fd*s + 660*C*D1**2*f*fd - 792*C*D1**2*f*fdd*r*s + 396*C*D1**2*f*fdd*r - 2772*C*D1**2*f*fdd*s**2 + 1188*C*D1**2*f*fdd*s - 396*C*D1**2*f*fdd - 792*C*D1**2*fd**2*r*s + 396*C*D1**2*fd**2*r - 2772*C*D1**2*fd**2*s**2 + 1188*C*D1**2*fd**2*s - 396*C*D1**2*fd**2 + 2640*C*D1*Dd*f**2*r*s - 660*C*D1*Dd*f**2*r + 10560*C*D1*Dd*f**2*s**2 - 6600*C*D1*Dd*f**2*s + 2640*C*D1*Dd*f**2 - 6336*C*D1*Dd*f*fd*r*s + 2376*C*D1*Dd*f*fd*r - 22176*C*D1*Dd*f*fd*s**2 + 11880*C*D1*Dd*f*fd*s - 1980*C*D1*Dd*f*fd - 1584*C*D1*Ddd*f**2*r*s + 396*C*D1*Ddd*f**2*r - 5544*C*D1*Ddd*f**2*s**2 + 3564*C*D1*Ddd*f**2*s - 1386*C*D1*Ddd*f**2 - 4752*C*Dd**2*f**2*r*s + 1188*C*Dd**2*f**2*r - 16632*C*Dd**2*f**2*s**2 + 10692*C*Dd**2*f**2*s - 792*C*Dd**2*f**2 - 1980*D1**2*K*f*fd*r*s + 990*D1**2*K*f*fd*r - 1188*D1**2*K*f*fd*s**2 + 1188*D1**2*K*f*fd*s - 594*D1**2*K*f*fd + 1188*D1**2*K*f*fdd*r*s - 594*D1**2*K*f*fdd*r + 990*D1**2*K*f*fdd*s**2 - 990*D1**2*K*f*fdd*s + 495*D1**2*K*f*fdd + 1188*D1**2*K*fd**2*r*s - 594*D1**2*K*fd**2*r + 990*D1**2*K*fd**2*s**2 - 990*D1**2*K*fd**2*s - 99*D1**2*bdd1*f*(K - 1)*(14*s**2 + s*(4*r - 12) + 5) + 11436*D1**2*f**2*fd*r*s - 3812*D1**2*f**2*fd*r + 11436*D1**2*f**2*fd*s**2 - 5540*D1**2*f**2*fd*s + 62*D1**2*f**2*fd - 7500*D1**2*f**2*fdd*r*s + 2500*D1**2*f**2*fdd*r - 7500*D1**2*f**2*fdd*s**2 + 4750*D1**2*f**2*fdd*s - 625*D1**2*f**2*fdd - 15000*D1**2*f*fd**2*r*s + 5000*D1**2*f*fd**2*r - 15000*D1**2*f*fd**2*s**2 + 9500*D1**2*f*fd**2*s - 3500*D1**2*f*fd**2 + 4620*D1**2*f*fd*r*s - 2310*D1**2*f*fd*r + 1848*D1**2*f*fd*s**2 - 5148*D1**2*f*fd*s + 2904*D1**2*f*fd - 2772*D1**2*f*fdd*r*s + 1386*D1**2*f*fdd*r - 1584*D1**2*f*fdd*s**2 + 3168*D1**2*f*fdd*s - 1782*D1**2*f*fdd - 1716*D1**2*f*gd2*r*s - 3696*D1**2*f*gd2*s**2 + 1716*D1**2*f*gd2*s + 396*D1**2*f*gdd2*r*s + 1386*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s - 2772*D1**2*fd**2*r*s + 1386*D1**2*fd**2*r - 1584*D1**2*fd**2*s**2 + 3168*D1**2*fd**2*s + 396*D1**2*fd**2 - 1716*D1**2*fd*g2*r*s + 1716*D1**2*fd*g2*r - 3696*D1**2*fd*g2*s**2 + 3432*D1**2*fd*g2*s - 1716*D1**2*fd*g2 + 792*D1**2*fd*gd2*r*s - 396*D1**2*fd*gd2*r + 2772*D1**2*fd*gd2*s**2 - 1188*D1**2*fd*gd2*s + 396*D1**2*fd*gd2 + 396*D1**2*fdd*g2*r*s - 396*D1**2*fdd*g2*r + 1386*D1**2*fdd*g2*s**2 - 792*D1**2*fdd*g2*s + 396*D1**2*fdd*g2 - 3960*D1*Dd*K*f**2*r*s + 990*D1*Dd*K*f**2*r - 2376*D1*Dd*K*f**2*s**2 + 3168*D1*Dd*K*f**2*s - 594*D1*Dd*K*f**2 + 9504*D1*Dd*K*f*fd*r*s - 3564*D1*Dd*K*f*fd*r + 7920*D1*Dd*K*f*fd*s**2 - 8316*D1*Dd*K*f*fd*s + 2178*D1*Dd*K*f*fd + 15248*D1*Dd*f**3*r*s - 3812*D1*Dd*f**3*r + 15248*D1*Dd*f**3*s**2 - 15248*D1*Dd*f**3*s + 3812*D1*Dd*f**3 - 60000*D1*Dd*f**2*fd*r*s + 17500*D1*Dd*f**2*fd*r - 60000*D1*Dd*f**2*fd*s**2 + 49000*D1*Dd*f**2*fd*s - 9750*D1*Dd*f**2*fd + 9240*D1*Dd*f**2*r*s - 2310*D1*Dd*f**2*r + 3696*D1*Dd*f**2*s**2 - 6468*D1*Dd*f**2*s + 924*D1*Dd*f**2 - 22176*D1*Dd*f*fd*r*s + 8316*D1*Dd*f*fd*r - 12672*D1*Dd*f*fd*s**2 + 21384*D1*Dd*f*fd*s - 5940*D1*Dd*f*fd - 6864*D1*Dd*f*g2*r*s + 1716*D1*Dd*f*g2*r - 14784*D1*Dd*f*g2*s**2 + 10824*D1*Dd*f*g2*s - 3696*D1*Dd*f*g2 + 3168*D1*Dd*f*gd2*r*s - 396*D1*Dd*f*gd2*r + 11088*D1*Dd*f*gd2*s**2 - 5148*D1*Dd*f*gd2*s + 396*D1*Dd*f*gd2 + 3168*D1*Dd*fd*g2*r*s - 1980*D1*Dd*fd*g2*r + 11088*D1*Dd*fd*g2*s**2 - 6732*D1*Dd*fd*g2*s + 1584*D1*Dd*fd*g2 + 2376*D1*Ddd*K*f**2*r*s - 594*D1*Ddd*K*f**2*r + 1980*D1*Ddd*K*f**2*s**2 - 2178*D1*Ddd*K*f**2*s + 495*D1*Ddd*K*f**2 - 10000*D1*Ddd*f**3*r*s + 2500*D1*Ddd*f**3*r - 10000*D1*Ddd*f**3*s**2 + 10000*D1*Ddd*f**3*s - 2500*D1*Ddd*f**3 - 5544*D1*Ddd*f**2*r*s + 1386*D1*Ddd*f**2*r - 3168*D1*Ddd*f**2*s**2 + 4356*D1*Ddd*f**2*s - 792*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r*s - 396*D1*Ddd*f*g2*r + 5544*D1*Ddd*f*g2*s**2 - 3564*D1*Ddd*f*g2*s + 1386*D1*Ddd*f*g2 + 66*D1*bd1*(K - 1)*(D1*(f*(26*r*s + 56*s**2 - 43*s + 15) - 3*fd*(4*r*s - 2*r + 14*s**2 - 10*s + 1)) - 6*Dd*f*(r*(8*s - 1) + 28*s**2 - 21*s + 3)) + 7128*Dd**2*K*f**2*r*s - 1782*Dd**2*K*f**2*r + 5940*Dd**2*K*f**2*s**2 - 6534*Dd**2*K*f**2*s + 1188*Dd**2*K*f**2 - 30000*Dd**2*f**3*r*s + 7500*Dd**2*f**3*r - 30000*Dd**2*f**3*s**2 + 30000*Dd**2*f**3*s - 5000*Dd**2*f**3 - 16632*Dd**2*f**2*r*s + 4158*Dd**2*f**2*r - 9504*Dd**2*f**2*s**2 + 13068*Dd**2*f**2*s - 2772*Dd**2*f**2 + 4752*Dd**2*f*g2*r*s - 1188*Dd**2*f*g2*r + 16632*Dd**2*f*g2*s**2 - 10692*Dd**2*f*g2*s + 792*Dd**2*f*g2))/(693*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**3*k1**3*(3168*C*D1**2*bdd1*f**2*r*s - 3168*C*D1**2*bdd1*f**2*r + 4356*C*D1**2*bdd1*f**2*s**2 - 8712*C*D1**2*bdd1*f**2*s + 4356*C*D1**2*bdd1*f**2 + 1200*C*D1**2*f**2*fd*r*s - 400*C*D1**2*f**2*fd*r - 21360*C*D1**2*f**2*fd*s**2 + 13840*C*D1**2*f**2*fd*s - 7120*C*D1**2*f**2*fd + 3360*C*D1**2*f**2*fdd*r*s - 1120*C*D1**2*f**2*fdd*r + 16620*C*D1**2*f**2*fdd*s**2 - 12200*C*D1**2*f**2*fdd*s + 5540*C*D1**2*f**2*fdd + 6720*C*D1**2*f*fd**2*r*s - 2240*C*D1**2*f*fd**2*r + 33240*C*D1**2*f*fd**2*s**2 - 24400*C*D1**2*f*fd**2*s + 1120*C*D1**2*f*fd**2 + 1600*C*D1*Dd*f**3*r*s - 400*C*D1*Dd*f**3*r - 28480*C*D1*Dd*f**3*s**2 + 13440*C*D1*Dd*f**3*s - 7120*C*D1*Dd*f**3 + 26880*C*D1*Dd*f**2*fd*r*s - 7840*C*D1*Dd*f**2*fd*r + 132960*C*D1*Dd*f**2*fd*s**2 - 88760*C*D1*Dd*f**2*fd*s + 14440*C*D1*Dd*f**2*fd + 4480*C*D1*Ddd*f**3*r*s - 1120*C*D1*Ddd*f**3*r + 22160*C*D1*Ddd*f**3*s**2 - 13320*C*D1*Ddd*f**3*s + 5540*C*D1*Ddd*f**3 + 13440*C*Dd**2*f**3*r*s - 3360*C*Dd**2*f**3*r + 66480*C*Dd**2*f**3*s**2 - 39960*C*Dd**2*f**3*s + 2240*C*Dd**2*f**3 + 660*D1**2*K*bdd1*f**2*r*s + 3300*D1**2*K*bdd1*f**2*s**2 - 660*D1**2*K*bdd1*f**2*s - 1056*D1**2*b2*f*fd*r*s + 528*D1**2*b2*f*fd*r - 1056*D1**2*b2*f*fd*s**2 + 1056*D1**2*b2*f*fd*s - 528*D1**2*b2*f*fd + 1320*D1**2*b2*f*fdd*r*s - 660*D1**2*b2*f*fdd*r + 1320*D1**2*b2*f*fdd*s**2 - 1320*D1**2*b2*f*fdd*s + 660*D1**2*b2*f*fdd + 1320*D1**2*b2*fd**2*r*s - 660*D1**2*b2*fd**2*r + 1320*D1**2*b2*fd**2*s**2 - 1320*D1**2*b2*fd**2*s - 66*D1**2*bd1**2*(5*f**2*(2*r*(8*s - 5) + 13*s**2 - 21*s + 6) + 2*f*(-13*K*(r*(2*s - 1) + 3*s**2 - 4*s + 1) + r*(12*C + 19)*(2*s - 1) + (s - 1)*(s*(24*C + 54) - 31)) + 28*g2*(-2*r*s + r - s*(2*s - 2))) - 528*D1**2*bd2*f**2*r*s - 528*D1**2*bd2*f**2*s**2 + 528*D1**2*bd2*f**2*s + 2640*D1**2*bd2*f*fd*r*s - 660*D1**2*bd2*f*fd*r + 2640*D1**2*bd2*f*fd*s**2 - 2640*D1**2*bd2*f*fd*s + 660*D1**2*bd2*f*fd + 2640*D1**2*bdd1*f**3*r*s - 3960*D1**2*bdd1*f**3*r - 5610*D1**2*bdd1*f**3*s + 3465*D1**2*bdd1*f**3 - 5148*D1**2*bdd1*f**2*r*s + 5148*D1**2*bdd1*f**2*r - 7821*D1**2*bdd1*f**2*s**2 + 13002*D1**2*bdd1*f**2*s - 6501*D1**2*bdd1*f**2 - 3432*D1**2*bdd1*f*g2*r*s + 3432*D1**2*bdd1*f*g2*r - 5148*D1**2*bdd1*f*g2*s**2 + 10296*D1**2*bdd1*f*g2*s - 5148*D1**2*bdd1*f*g2 + 660*D1**2*bdd2*f**2*r*s + 660*D1**2*bdd2*f**2*s**2 - 660*D1**2*bdd2*f**2*s - 4560*D1**2*f**2*fd*r*s + 1520*D1**2*f**2*fd*r + 13350*D1**2*f**2*fd*s**2 - 7380*D1**2*f**2*fd*s + 4450*D1**2*f**2*fd - 1680*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r - 11625*D1**2*f**2*fdd*s**2 + 8310*D1**2*f**2*fdd*s - 3875*D1**2*f**2*fdd - 528*D1**2*f**2*gd2*r*s + 8448*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s - 1320*D1**2*f**2*gdd2*r*s - 6600*D1**2*f**2*gdd2*s**2 + 1320*D1**2*f**2*gdd2*s - 3360*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r - 23250*D1**2*f*fd**2*s**2 + 16620*D1**2*f*fd**2*s - 560*D1**2*f*fd**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r + 16896*D1**2*f*fd*g2*s**2 - 16896*D1**2*f*fd*g2*s + 8448*D1**2*f*fd*g2 - 5280*D1**2*f*fd*gd2*r*s + 1320*D1**2*f*fd*gd2*r - 26400*D1**2*f*fd*gd2*s**2 + 15840*D1**2*f*fd*gd2*s - 1320*D1**2*f*fd*gd2 - 2640*D1**2*f*fdd*g2*r*s + 1320*D1**2*f*fdd*g2*r - 13200*D1**2*f*fdd*g2*s**2 + 13200*D1**2*f*fdd*g2*s - 6600*D1**2*f*fdd*g2 - 2640*D1**2*fd**2*g2*r*s + 1320*D1**2*fd**2*g2*r - 13200*D1**2*fd**2*g2*s**2 + 13200*D1**2*fd**2*g2*s - 2112*D1*Dd*b2*f**2*r*s + 528*D1*Dd*b2*f**2*r - 2112*D1*Dd*b2*f**2*s**2 + 2112*D1*Dd*b2*f**2*s - 528*D1*Dd*b2*f**2 + 10560*D1*Dd*b2*f*fd*r*s - 3960*D1*Dd*b2*f*fd*r + 10560*D1*Dd*b2*f*fd*s**2 - 10560*D1*Dd*b2*f*fd*s + 2640*D1*Dd*b2*f*fd + 5280*D1*Dd*bd2*f**2*r*s - 660*D1*Dd*bd2*f**2*r + 5280*D1*Dd*bd2*f**2*s**2 - 5280*D1*Dd*bd2*f**2*s + 660*D1*Dd*bd2*f**2 - 6080*D1*Dd*f**3*r*s + 1520*D1*Dd*f**3*r + 17800*D1*Dd*f**3*s**2 - 5860*D1*Dd*f**3*s + 4450*D1*Dd*f**3 - 13440*D1*Dd*f**2*fd*r*s + 3920*D1*Dd*f**2*fd*r - 93000*D1*Dd*f**2*fd*s**2 + 59850*D1*Dd*f**2*fd*s - 9430*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*g2*r*s + 528*D1*Dd*f**2*g2*r + 33792*D1*Dd*f**2*g2*s**2 - 15840*D1*Dd*f**2*g2*s + 8448*D1*Dd*f**2*g2 - 10560*D1*Dd*f**2*gd2*r*s + 1320*D1*Dd*f**2*gd2*r - 52800*D1*Dd*f**2*gd2*s**2 + 21120*D1*Dd*f**2*gd2*s - 1320*D1*Dd*f**2*gd2 - 21120*D1*Dd*f*fd*g2*r*s + 7920*D1*Dd*f*fd*g2*r - 105600*D1*Dd*f*fd*g2*s**2 + 84480*D1*Dd*f*fd*g2*s - 15840*D1*Dd*f*fd*g2 + 2640*D1*Ddd*b2*f**2*r*s - 660*D1*Ddd*b2*f**2*r + 2640*D1*Ddd*b2*f**2*s**2 - 2640*D1*Ddd*b2*f**2*s + 660*D1*Ddd*b2*f**2 - 2240*D1*Ddd*f**3*r*s + 560*D1*Ddd*f**3*r - 15500*D1*Ddd*f**3*s**2 + 8870*D1*Ddd*f**3*s - 3875*D1*Ddd*f**3 - 5280*D1*Ddd*f**2*g2*r*s + 1320*D1*Ddd*f**2*g2*r - 26400*D1*Ddd*f**2*g2*s**2 + 15840*D1*Ddd*f**2*g2*s - 6600*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(5*f**3*(12*r*(s - 1) + 4*s**2 - 28*s + 15) + f**2*(12*C*(s - 1)*(6*r + 7*s - 7) - 4*K*r*s + 64*K*s**2 + 4*K*s - 10*fd*(8*r*(3*s - 2) - 25*s + 10) - 84*r*s + 108*r - 141*s**2 + 226*s - 125) - 2*f*(fd*(12*C*(r*(8*s - 4) + 11*s**2 - 13*s + 2) + 5*K*(4*r*s - r + 20*s**2 - 12*s + 1) - 156*r*s + 78*r - 237*s**2 + 256*s - 39) + 2*g2*(s - 1)*(19*r + 25*s - 25) - 26*gd2*(r*(2*s - 1) + 3*s**2 - 4*s + 1)) + 52*fd*g2*(r*(2*s - 1) + s*(3*s - 3))) + Dd*f*(-5*f**2*(8*r*(8*s - 7) - 84*s + 41) + f*(-12*C*(4*r*(8*s - 5) + 44*s**2 - 63*s + 19) - 10*K*(8*r*s - r + 40*s**2 - 16*s + 1) + 624*r*s - 390*r + 948*s**2 - 1181*s + 353) + 52*g2*(r*(8*s - 5) + 12*s**2 - 17*s + 5))) + 7920*Dd**2*b2*f**2*r*s - 1980*Dd**2*b2*f**2*r + 7920*Dd**2*b2*f**2*s**2 - 7920*Dd**2*b2*f**2*s + 1320*Dd**2*b2*f**2 - 6720*Dd**2*f**3*r*s + 1680*Dd**2*f**3*r - 46500*Dd**2*f**3*s**2 + 26610*Dd**2*f**3*s - 1120*Dd**2*f**3 - 15840*Dd**2*f**2*g2*r*s + 3960*Dd**2*f**2*g2*r - 79200*Dd**2*f**2*g2*s**2 + 47520*Dd**2*f**2*g2*s - 2640*Dd**2*f**2*g2 + 924*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 33*b1**2*(40*C*D1**2*fd*r*s + 40*C*D1**2*fd*s**2 - 40*C*D1**2*fd*s - 48*C*D1**2*fdd*r*s - 48*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s + 160*C*D1*Dd*f*r*s - 40*C*D1*Dd*f*r + 160*C*D1*Dd*f*s**2 - 160*C*D1*Dd*f*s + 40*C*D1*Dd*f - 384*C*D1*Dd*fd*r*s + 48*C*D1*Dd*fd*r - 384*C*D1*Dd*fd*s**2 + 384*C*D1*Dd*fd*s - 48*C*D1*Dd*fd - 192*C*D1*Ddd*f*r*s + 48*C*D1*Ddd*f*r - 192*C*D1*Ddd*f*s**2 + 192*C*D1*Ddd*f*s - 48*C*D1*Ddd*f - 576*C*Dd**2*f*r*s + 144*C*Dd**2*f*r - 576*C*Dd**2*f*s**2 + 576*C*Dd**2*f*s - 96*C*Dd**2*f - 76*D1**2*K*fd*r*s - 100*D1**2*K*fd*s**2 + 52*D1**2*K*fdd*r*s + 78*D1**2*K*fdd*s**2 - 28*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 224*D1**2*f*fd*r*s + 16*D1**2*f*fd*r + 164*D1**2*f*fd*s**2 - 136*D1**2*f*fd*s - 16*D1**2*f*fd - 160*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r - 130*D1**2*f*fdd*s**2 + 80*D1**2*f*fdd*s + 20*D1**2*f*fdd - 160*D1**2*fd**2*r*s - 20*D1**2*fd**2*r - 130*D1**2*fd**2*s**2 + 80*D1**2*fd**2*s + 20*D1**2*fd**2 + 124*D1**2*fd*r*s + 160*D1**2*fd*s**2 + 40*D1**2*fd*s - 76*D1**2*fdd*r*s - 108*D1**2*fdd*s**2 - 48*D1**2*fdd*s - 112*D1**2*gd2*r*s - 112*D1**2*gd2*s**2 + 112*D1**2*gd2*s + 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s - 304*D1*Dd*K*f*r*s + 76*D1*Dd*K*f*r - 400*D1*Dd*K*f*s**2 + 352*D1*Dd*K*f*s - 100*D1*Dd*K*f + 416*D1*Dd*K*fd*r*s - 52*D1*Dd*K*fd*r + 624*D1*Dd*K*fd*s**2 - 260*D1*Dd*K*fd*s + 448*D1*Dd*f**2*r*s - 112*D1*Dd*f**2*r + 328*D1*Dd*f**2*s**2 - 388*D1*Dd*f**2*s + 82*D1*Dd*f**2 - 1280*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r - 1040*D1*Dd*f*fd*s**2 + 900*D1*Dd*f*fd*s - 40*D1*Dd*f*fd + 496*D1*Dd*f*r*s - 124*D1*Dd*f*r + 640*D1*Dd*f*s**2 - 568*D1*Dd*f*s + 160*D1*Dd*f - 608*D1*Dd*fd*r*s + 76*D1*Dd*fd*r - 864*D1*Dd*fd*s**2 + 176*D1*Dd*fd*s + 48*D1*Dd*fd - 448*D1*Dd*g2*r*s + 112*D1*Dd*g2*r - 448*D1*Dd*g2*s**2 + 448*D1*Dd*g2*s - 112*D1*Dd*g2 + 448*D1*Dd*gd2*r*s - 56*D1*Dd*gd2*r + 448*D1*Dd*gd2*s**2 - 448*D1*Dd*gd2*s + 56*D1*Dd*gd2 + 208*D1*Ddd*K*f*r*s - 52*D1*Ddd*K*f*r + 312*D1*Ddd*K*f*s**2 - 260*D1*Ddd*K*f*s + 78*D1*Ddd*K*f - 320*D1*Ddd*f**2*r*s + 80*D1*Ddd*f**2*r - 260*D1*Ddd*f**2*s**2 + 290*D1*Ddd*f**2*s - 65*D1*Ddd*f**2 - 304*D1*Ddd*f*r*s + 76*D1*Ddd*f*r - 432*D1*Ddd*f*s**2 + 368*D1*Ddd*f*s - 108*D1*Ddd*f + 224*D1*Ddd*g2*r*s - 56*D1*Ddd*g2*r + 224*D1*Ddd*g2*s**2 - 224*D1*Ddd*g2*s + 56*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 624*Dd**2*K*f*r*s - 156*Dd**2*K*f*r + 936*Dd**2*K*f*s**2 - 780*Dd**2*K*f*s + 104*Dd**2*K*f - 960*Dd**2*f**2*r*s + 240*Dd**2*f**2*r - 780*Dd**2*f**2*s**2 + 870*Dd**2*f**2*s - 160*Dd**2*f**2 - 912*Dd**2*f*r*s + 228*Dd**2*f*r - 1296*Dd**2*f*s**2 + 1104*Dd**2*f*s - 152*Dd**2*f + 672*Dd**2*g2*r*s - 168*Dd**2*g2*r + 672*Dd**2*g2*s**2 - 672*Dd**2*g2*s + 112*Dd**2*g2) - 33*b1*(288*C*D1**2*f*fd*r*s + 336*C*D1**2*f*fd*s**2 - 144*C*D1**2*f*fd*s - 192*C*D1**2*f*fdd*r*s - 264*C*D1**2*f*fdd*s**2 + 96*C*D1**2*f*fdd*s - 192*C*D1**2*fd**2*r*s - 264*C*D1**2*fd**2*s**2 + 96*C*D1**2*fd**2*s + 576*C*D1*Dd*f**2*r*s - 144*C*D1*Dd*f**2*r + 672*C*D1*Dd*f**2*s**2 - 624*C*D1*Dd*f**2*s + 168*C*D1*Dd*f**2 - 1536*C*D1*Dd*f*fd*r*s + 192*C*D1*Dd*f*fd*r - 2112*C*D1*Dd*f*fd*s**2 + 1296*C*D1*Dd*f*fd*s - 96*C*D1*Dd*f*fd - 384*C*D1*Ddd*f**2*r*s + 96*C*D1*Ddd*f**2*r - 528*C*D1*Ddd*f**2*s**2 + 456*C*D1*Ddd*f**2*s - 132*C*D1*Ddd*f**2 - 1152*C*Dd**2*f**2*r*s + 288*C*Dd**2*f**2*r - 1584*C*Dd**2*f**2*s**2 + 1368*C*Dd**2*f**2*s - 192*C*Dd**2*f**2 - 16*D1**2*K*f*fd*r*s + 8*D1**2*K*f*fd*r + 256*D1**2*K*f*fd*s**2 - 256*D1**2*K*f*fd*s + 128*D1**2*K*f*fd - 40*D1**2*K*f*fdd*r*s + 20*D1**2*K*f*fdd*r - 200*D1**2*K*f*fdd*s**2 + 200*D1**2*K*f*fdd*s - 100*D1**2*K*f*fdd - 40*D1**2*K*fd**2*r*s + 20*D1**2*K*fd**2*r - 200*D1**2*K*fd**2*s**2 + 200*D1**2*K*fd**2*s + 28*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(5*f**2*(4*r*(8*s - 5) + 26*s**2 - 42*s + 17) + 2*f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 13*K*(4*r*s - 2*r + 6*s**2 - 8*s + 3) + 76*r*s - 38*r + 108*s**2 - 170*s + 54) - 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 360*D1**2*f**2*fd*r*s + 120*D1**2*f**2*fd*s**2 - 40*D1**2*f**2*fd*s - 110*D1**2*f**2*fd - 240*D1**2*f**2*fdd*r*s - 40*D1**2*f**2*fdd*r - 10*D1**2*f**2*fdd*s + 105*D1**2*f**2*fdd - 480*D1**2*f*fd**2*r*s - 80*D1**2*f*fd**2*r - 20*D1**2*f*fd**2*s + 40*D1**2*f*fd**2 - 336*D1**2*f*fd*r*s - 48*D1**2*f*fd*r - 564*D1**2*f*fd*s**2 + 280*D1**2*f*fd*s - 32*D1**2*f*fd + 312*D1**2*f*fdd*r*s + 474*D1**2*f*fdd*s**2 - 236*D1**2*f*fdd*s + 40*D1**2*f*fdd - 152*D1**2*f*gd2*r*s - 200*D1**2*f*gd2*s**2 + 152*D1**2*f*gd2*s + 104*D1**2*f*gdd2*r*s + 156*D1**2*f*gdd2*s**2 - 104*D1**2*f*gdd2*s + 312*D1**2*fd**2*r*s + 474*D1**2*fd**2*s**2 - 236*D1**2*fd**2*s - 152*D1**2*fd*g2*r*s - 200*D1**2*fd*g2*s**2 + 208*D1**2*fd*gd2*r*s + 312*D1**2*fd*gd2*s**2 - 104*D1**2*fd*gd2*s + 104*D1**2*fdd*g2*r*s + 156*D1**2*fdd*g2*s**2 - 32*D1*Dd*K*f**2*r*s + 8*D1*Dd*K*f**2*r + 512*D1*Dd*K*f**2*s**2 - 240*D1*Dd*K*f**2*s + 128*D1*Dd*K*f**2 - 320*D1*Dd*K*f*fd*r*s + 120*D1*Dd*K*f*fd*r - 1600*D1*Dd*K*f*fd*s**2 + 1280*D1*Dd*K*f*fd*s - 240*D1*Dd*K*f*fd + 480*D1*Dd*f**3*r*s - 120*D1*Dd*f**3*r + 160*D1*Dd*f**3*s**2 - 320*D1*Dd*f**3*s + 40*D1*Dd*f**3 - 1920*D1*Dd*f**2*fd*r*s + 80*D1*Dd*f**2*fd*r + 440*D1*Dd*f**2*fd*s + 90*D1*Dd*f**2*fd - 672*D1*Dd*f**2*r*s + 168*D1*Dd*f**2*r - 1128*D1*Dd*f**2*s**2 + 900*D1*Dd*f**2*s - 282*D1*Dd*f**2 + 2496*D1*Dd*f*fd*r*s - 312*D1*Dd*f*fd*r + 3792*D1*Dd*f*fd*s**2 - 2516*D1*Dd*f*fd*s + 236*D1*Dd*f*fd - 608*D1*Dd*f*g2*r*s + 152*D1*Dd*f*g2*r - 800*D1*Dd*f*g2*s**2 + 704*D1*Dd*f*g2*s - 200*D1*Dd*f*g2 + 832*D1*Dd*f*gd2*r*s - 104*D1*Dd*f*gd2*r + 1248*D1*Dd*f*gd2*s**2 - 936*D1*Dd*f*gd2*s + 104*D1*Dd*f*gd2 + 832*D1*Dd*fd*g2*r*s - 104*D1*Dd*fd*g2*r + 1248*D1*Dd*fd*g2*s**2 - 520*D1*Dd*fd*g2*s - 80*D1*Ddd*K*f**2*r*s + 20*D1*Ddd*K*f**2*r - 400*D1*Ddd*K*f**2*s**2 + 240*D1*Ddd*K*f**2*s - 100*D1*Ddd*K*f**2 - 320*D1*Ddd*f**3*r*s + 80*D1*Ddd*f**3*r + 160*D1*Ddd*f**3*s + 624*D1*Ddd*f**2*r*s - 156*D1*Ddd*f**2*r + 948*D1*Ddd*f**2*s**2 - 786*D1*Ddd*f**2*s + 237*D1*Ddd*f**2 + 416*D1*Ddd*f*g2*r*s - 104*D1*Ddd*f*g2*r + 624*D1*Ddd*f*g2*s**2 - 520*D1*Ddd*f*g2*s + 156*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(f**2*(16*r*(7*s - 4) + 82*s**2 - 126*s + 49) + 2*f*(10*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 38*K*r*s + 19*K*r - 50*K*s**2 + 69*K*s - 25*K - 5*fd*(32*r*s - 8*r + 26*s**2 - 29*s + 6) + 62*r*s - 31*r + 80*s**2 - 121*s + 40) - 2*fd*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) - 78*K*s**2 + 52*K*s - r*(13*K - 19)*(4*s - 1) + 108*s**2 - 61*s - 12) - 28*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 28*gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*(-5*f**2*(8*r*(16*s - 7) + 104*s**2 - 142*s + 41) - 2*f*(24*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 26*K*(8*r*s - 3*r + 12*s**2 - 13*s + 3) + 304*r*s - 114*r + 432*s**2 - 524*s + 123) + 56*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 240*Dd**2*K*f**2*r*s + 60*Dd**2*K*f**2*r - 1200*Dd**2*K*f**2*s**2 + 720*Dd**2*K*f**2*s - 40*Dd**2*K*f**2 - 960*Dd**2*f**3*r*s + 240*Dd**2*f**3*r + 480*Dd**2*f**3*s - 160*Dd**2*f**3 + 1872*Dd**2*f**2*r*s - 468*Dd**2*f**2*r + 2844*Dd**2*f**2*s**2 - 2358*Dd**2*f**2*s + 312*Dd**2*f**2 + 1248*Dd**2*f*g2*r*s - 312*Dd**2*f*g2*r + 1872*Dd**2*f*g2*s**2 - 1560*Dd**2*f*g2*s + 208*Dd**2*f*g2))/(693*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**3*k1**3*st**2*(b1*(D1**2*(250*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-500*fd**2*s*(3*s - 2) + 198*fd*(2*s**2 - 2*s + 1) - 99*fdd*(2*s**2 - 2*s + 1)) - 198*fd**2*s*(s - 1)) + D1*f*(2*Dd*(250*f**2*(4*s**2 - 2*s + 1) - 250*f*fd*(12*s**2 - 7*s + 1) + 99*f*(4*s**2 - 2*s + 1) - 99*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(250*f + 99)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(250*f + 99)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(500*bd1 - 250*bdd1) + f*(-50*fd*(s**2*(30*bd1 - 9) + s*(6 - 10*bd1) - 3) - 75*fdd*(3*s**2 - 2*s + 1) + s**2*(198*bd1 - 99*bdd1)) - 6*fd*s*(33*bd1*(2*s - 1) + 25*fd*(3*s - 2))) + D1*f*(-50*Dd*f*(s**2*(40*bd1 - 12) + s*(6 - 10*bd1) - 3) - 6*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 75*Ddd*f*(4*s**2 - 2*s + 1)) + 450*Dd**2*f**2*s*(1 - 2*s)))/(77*d**2*k2**2*k3**2) + 5*D1**2*Pk3*Pkd2*ct**3*k1**3*(66*b1**2*(D1**2*s**2*(-10*fd**2 + fd*(20*f + 6) - fdd*(10*f + 3)) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(s**2*(12 - 40*fd) + s*(10*fd - 6) + 3) + 3*fd*s*(1 - 4*s)) - Ddd*f*(5*f + 3)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 3)*(2*s - 1)) + 33*b1*(-2*D1**2*bdd1*f*(5*f + 3)*(2*s**2 - 2*s + 1) - 84*D1**2*f**2*fd*s**2 + 56*D1**2*f**2*fd*s - 28*D1**2*f**2*fd + 42*D1**2*f**2*fdd*s**2 - 28*D1**2*f**2*fdd*s + 14*D1**2*f**2*fdd + 84*D1**2*f*fd**2*s**2 - 56*D1**2*f*fd**2*s - 12*D1**2*f*fd*s**2 + 32*D1**2*f*fd*s - 16*D1**2*f*fd + 6*D1**2*f*fdd*s**2 - 16*D1**2*f*fdd*s + 8*D1**2*f*fdd + 6*D1**2*fd**2*s**2 - 16*D1**2*fd**2*s - 112*D1*Dd*f**3*s**2 + 56*D1*Dd*f**3*s - 28*D1*Dd*f**3 + 336*D1*Dd*f**2*fd*s**2 - 196*D1*Dd*f**2*fd*s + 28*D1*Dd*f**2*fd - 24*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 48*D1*Dd*f*fd*s**2 - 76*D1*Dd*f*fd*s + 16*D1*Dd*f*fd + 56*D1*Ddd*f**3*s**2 - 28*D1*Ddd*f**3*s + 14*D1*Ddd*f**3 + 12*D1*Ddd*f**2*s**2 - 6*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 4*D1*bd1*(D1*(5*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(6 - 20*fd) + s*(10*fd - 6) + 3) + 3*fd*s*(1 - 2*s)) - Dd*f*(5*f + 3)*(8*s**2 - 6*s + 1)) + 168*Dd**2*f**3*s**2 - 84*Dd**2*f**3*s + 36*Dd**2*f**2*s**2 - 18*Dd**2*f**2*s) + f*(-132*D1**2*bd1**2*s*(5*f + 3)*(s - 1) + 33*D1**2*bdd1*f*(s**2*(14*f + 3) + 10*s - 5) - 221*D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) - 66*D1*bd1*(D1*(14*f**2*s**2 + f*(s**2*(3 - 42*fd) + s*(14*fd + 10) - 5) - 2*fd*s*(3*s + 1)) - Dd*f*(4*s - 1)*(s*(14*f + 3) + 5)) - 221*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 1326*Dd**2*f**2*s*(1 - 2*s)))/(693*d**2*k2**2*k3**2) - 8*D1**2*Pk3*Pkd2*ct**3*k1*k2**4*st**2*(132*C*D1**2*bdd1*f**2*r*s - 132*C*D1**2*bdd1*f**2*r + 132*C*D1**2*bdd1*f**2*s**2 - 264*C*D1**2*bdd1*f**2*s + 132*C*D1**2*bdd1*f**2 - 906*C*D1**2*f**2*fd*r*s + 302*C*D1**2*f**2*fd*r - 906*C*D1**2*f**2*fd*s**2 + 906*C*D1**2*f**2*fd*s - 302*C*D1**2*f**2*fd + 750*C*D1**2*f**2*fdd*r*s - 250*C*D1**2*f**2*fdd*r + 750*C*D1**2*f**2*fdd*s**2 - 750*C*D1**2*f**2*fdd*s + 250*C*D1**2*f**2*fdd + 1500*C*D1**2*f*fd**2*r*s - 500*C*D1**2*f*fd**2*r + 1500*C*D1**2*f*fd**2*s**2 - 1500*C*D1**2*f*fd**2*s + 250*C*D1**2*f*fd**2 - 1208*C*D1*Dd*f**3*r*s + 302*C*D1*Dd*f**3*r - 1208*C*D1*Dd*f**3*s**2 + 1208*C*D1*Dd*f**3*s - 302*C*D1*Dd*f**3 + 6000*C*D1*Dd*f**2*fd*r*s - 1750*C*D1*Dd*f**2*fd*r + 6000*C*D1*Dd*f**2*fd*s**2 - 6000*C*D1*Dd*f**2*fd*s + 1250*C*D1*Dd*f**2*fd + 1000*C*D1*Ddd*f**3*r*s - 250*C*D1*Ddd*f**3*r + 1000*C*D1*Ddd*f**3*s**2 - 1000*C*D1*Ddd*f**3*s + 250*C*D1*Ddd*f**3 + 3000*C*Dd**2*f**3*r*s - 750*C*Dd**2*f**3*r + 3000*C*Dd**2*f**3*s**2 - 3000*C*Dd**2*f**3*s + 500*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 11*D1**2*bd1**2*f*(2*s - 1)*(-6*K + 5*f + 3)*(r + s - 1) - 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*r - 99*D1**2*bdd1*f**2*s**2 + 198*D1**2*bdd1*f**2*s - 99*D1**2*bdd1*f**2 - 132*D1**2*bdd1*f*g2*r*s + 132*D1**2*bdd1*f*g2*r - 132*D1**2*bdd1*f*g2*s**2 + 264*D1**2*bdd1*f*g2*s - 132*D1**2*bdd1*f*g2 + 354*D1**2*f**2*fd*r*s - 118*D1**2*f**2*fd*r + 354*D1**2*f**2*fd*s**2 - 354*D1**2*f**2*fd*s + 118*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r*s + 125*D1**2*f**2*fdd*r - 375*D1**2*f**2*fdd*s**2 + 375*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd + 462*D1**2*f**2*gd2*r*s + 462*D1**2*f**2*gd2*s**2 - 462*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 750*D1**2*f*fd**2*r*s + 250*D1**2*f*fd**2*r - 750*D1**2*f*fd**2*s**2 + 750*D1**2*f*fd**2*s - 125*D1**2*f*fd**2 + 924*D1**2*f*fd*g2*r*s - 462*D1**2*f*fd*g2*r + 924*D1**2*f*fd*g2*s**2 - 924*D1**2*f*fd*g2*s + 462*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s + 472*D1*Dd*f**3*r*s - 118*D1*Dd*f**3*r + 472*D1*Dd*f**3*s**2 - 472*D1*Dd*f**3*s + 118*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r*s + 875*D1*Dd*f**2*fd*r - 3000*D1*Dd*f**2*fd*s**2 + 3000*D1*Dd*f**2*fd*s - 625*D1*Dd*f**2*fd + 1848*D1*Dd*f**2*g2*r*s - 462*D1*Dd*f**2*g2*r + 1848*D1*Dd*f**2*g2*s**2 - 1848*D1*Dd*f**2*g2*s + 462*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 - 500*D1*Ddd*f**3*r*s + 125*D1*Ddd*f**3*r - 500*D1*Ddd*f**3*s**2 + 500*D1*Ddd*f**3*s - 125*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + 3*f**2*(r + s - 1)*(8*C*(s - 1) + s*(7*K - 5) + 6) - 3*f*(fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 5*K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + (4*r + 4*s - 4)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 5*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 4*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 1500*Dd**2*f**3*r*s + 375*Dd**2*f**3*r - 1500*Dd**2*f**3*s**2 + 1500*Dd**2*f**3*s - 250*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 11*b1**2*(D1**2*s*(5*f*(2*fd - fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 6*fd*(2*K - 1)*(r + s) + 3*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (6 - 12*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-6*K + 5*f + 3)) - Dd**2*f*(-6*K + 5*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(-48*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s + 24*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*s**2 - 12*C*D1**2*f*fdd*s + 24*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*s**2 - 12*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r*s - 24*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 144*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 42*D1**2*K*f*fd*r*s + 21*D1**2*K*f*fd*r - 42*D1**2*K*f*fd*s**2 + 42*D1**2*K*f*fd*s - 21*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*s - 1)*(-6*K + 5*f + 3)*(r + s - 1) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 30*D1**2*f*fd*r*s + 3*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s - 3*D1**2*f*fd - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s + 24*D1**2*f*gd2*r*s + 24*D1**2*f*gd2*s**2 - 24*D1**2*f*gd2*s - 12*D1**2*f*gdd2*r*s - 12*D1**2*f*gdd2*s**2 + 12*D1**2*f*gdd2*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 24*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*s**2 + 12*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 84*D1*Dd*K*f**2*r*s + 21*D1*Dd*K*f**2*r - 84*D1*Dd*K*f**2*s**2 + 84*D1*Dd*K*f**2*s - 21*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 + 60*D1*Dd*f**2*r*s - 15*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 60*D1*Dd*f**2*s + 15*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 108*D1*Dd*f*fd*s - 9*D1*Dd*f*fd + 96*D1*Dd*f*g2*r*s - 24*D1*Dd*f*g2*r + 96*D1*Dd*f*g2*s**2 - 96*D1*Dd*f*g2*s + 24*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r*s + 12*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 96*D1*Dd*f*gd2*s - 12*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r*s + 12*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 48*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r*s + 12*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 48*D1*Ddd*f*g2*s - 12*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(2*s - 1)*(r + s - 1) + f*(-5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (6 - 12*K)*(2*s - 1)*(r + s - 1)) + 3*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-6*K + 5*f + 3)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2 - 144*Dd**2*f*g2*r*s + 36*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 144*Dd**2*f*g2*s - 24*Dd**2*f*g2))/(231*d**2*k3**6) + 8*D1**2*Pk3*Pkd2*ct**3*k1*k2**4*(D1*(-18*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 3*bd1*(D1*(2*f**2*(r + s - 1)*(4*C*(s - 1) - s*(2*K + 1) + 1) + f*(-fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (-5*g2*(s - 1) + 6*gd2*(2*s - 1))*(2*r + 2*s - 2)) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + f*(-3*D1*bdd1*(s - 1)*(f*(10*C - 5) - 12*g2)*(r + s - 1) + 2*D1*(f*(-fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 12*gd2*s*(r + s - 1)) + 12*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 2*Dd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**2*(D1**2*s*(6*f*fd*(2*r + 2*s - 1) + (r + s)*(-18*K*fdd + fd*(15*K + 7))) + D1*(Dd*(-18*K*fd*(r*(8*s - 1) + 4*s*(2*s - 1)) + 6*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(15*K + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(3*D1**2*(-6*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(-4*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(8*C - 2)*(2*r + 2*s - 1) + s*(-fdd*(10*C - 5)*(2*r + 2*s - 1) + (-10*gd2 + 12*gdd2)*(r + s - 1))) + s*(-fd**2*(10*C - 5)*(2*r + 2*s - 1) + 2*fd*(-5*g2*(r + s) + 6*gd2*(2*r + 2*s - 1)) + 12*fdd*g2*(r + s))) + D1*bd1*(D1*(18*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 6*f**2*(2*s - 1)*(r + s - 1) + f*(15*K + 7)*(2*s - 1)*(r + s - 1)) - 18*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 3*D1*(Dd*(2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(4*C - 2*K - 1) + f*(-fd*(10*C - 5)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 10*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 12*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 12*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(f*(10*C - 5) - 12*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**3*k1*k2**2*st**2*(-792*C*D1**2*bdd1*f**2*r*s - 792*C*D1**2*bdd1*f**2*r - 1980*C*D1**2*bdd1*f**2*s**2 + 792*C*D1**2*bdd1*f**2*s - 396*C*D1**2*bdd1*f**2 - 29856*C*D1**2*f**2*fd*r*s + 9952*C*D1**2*f**2*fd*r - 30504*C*D1**2*f**2*fd*s**2 + 30288*C*D1**2*f**2*fd*s - 10168*C*D1**2*f**2*fd + 22056*C*D1**2*f**2*fdd*r*s - 7352*C*D1**2*f**2*fdd*r + 21192*C*D1**2*f**2*fdd*s**2 - 21480*C*D1**2*f**2*fdd*s + 7064*C*D1**2*f**2*fdd + 44112*C*D1**2*f*fd**2*r*s - 14704*C*D1**2*f*fd**2*r + 42384*C*D1**2*f*fd**2*s**2 - 42960*C*D1**2*f*fd**2*s + 7352*C*D1**2*f*fd**2 - 39808*C*D1*Dd*f**3*r*s + 9952*C*D1*Dd*f**3*r - 40672*C*D1*Dd*f**3*s**2 + 40240*C*D1*Dd*f**3*s - 10168*C*D1*Dd*f**3 + 176448*C*D1*Dd*f**2*fd*r*s - 51464*C*D1*Dd*f**2*fd*r + 169536*C*D1*Dd*f**2*fd*s**2 - 172416*C*D1*Dd*f**2*fd*s + 36184*C*D1*Dd*f**2*fd + 29408*C*D1*Ddd*f**3*r*s - 7352*C*D1*Ddd*f**3*r + 28256*C*D1*Ddd*f**3*s**2 - 28832*C*D1*Ddd*f**3*s + 7064*C*D1*Ddd*f**3 + 88224*C*Dd**2*f**3*r*s - 22056*C*Dd**2*f**3*r + 84768*C*Dd**2*f**3*s**2 - 86496*C*Dd**2*f**3*s + 14704*C*Dd**2*f**3 + 4092*D1**2*K*bdd1*f**2*r*s + 4092*D1**2*K*bdd1*f**2*s**2 - 4092*D1**2*K*bdd1*f**2*s - 7128*D1**2*b2*f*fd*r*s + 3564*D1**2*b2*f*fd*r - 7128*D1**2*b2*f*fd*s**2 + 7128*D1**2*b2*f*fd*s - 3564*D1**2*b2*f*fd + 3960*D1**2*b2*f*fdd*r*s - 1980*D1**2*b2*f*fdd*r + 3960*D1**2*b2*f*fdd*s**2 - 3960*D1**2*b2*f*fdd*s + 1980*D1**2*b2*f*fdd + 3960*D1**2*b2*fd**2*r*s - 1980*D1**2*b2*fd**2*r + 3960*D1**2*b2*fd**2*s**2 - 3960*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*f*(-6*K*(2*r*s + r + 5*s**2 - 2*s - 1) + 5*f*(2*r + s**2 + 3*s - 2) - 12*r*(s - 1) + 3*s**2 + 15*s - 12) - 3564*D1**2*bd2*f**2*r*s - 3564*D1**2*bd2*f**2*s**2 + 3564*D1**2*bd2*f**2*s + 7920*D1**2*bd2*f*fd*r*s - 1980*D1**2*bd2*f*fd*r + 7920*D1**2*bd2*f*fd*s**2 - 7920*D1**2*bd2*f*fd*s + 1980*D1**2*bd2*f*fd - 1320*D1**2*bdd1*f**3*r*s - 660*D1**2*bdd1*f**3*r - 1815*D1**2*bdd1*f**3*s**2 + 1980*D1**2*bdd1*f**3*s - 1056*D1**2*bdd1*f**2*r*s + 1188*D1**2*bdd1*f**2*r - 132*D1**2*bdd1*f**2*s**2 + 1254*D1**2*bdd1*f**2*s - 99*D1**2*bdd1*f**2 + 792*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r + 1980*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 + 1980*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*s**2 - 1980*D1**2*bdd2*f**2*s + 16704*D1**2*f**2*fd*r*s - 5568*D1**2*f**2*fd*r + 18534*D1**2*f**2*fd*s**2 - 17924*D1**2*f**2*fd*s + 6178*D1**2*f**2*fd - 14292*D1**2*f**2*fdd*r*s + 4764*D1**2*f**2*fdd*r - 14019*D1**2*f**2*fdd*s**2 + 14110*D1**2*f**2*fdd*s - 4673*D1**2*f**2*fdd + 13200*D1**2*f**2*gd2*r*s + 12408*D1**2*f**2*gd2*s**2 - 13200*D1**2*f**2*gd2*s - 8184*D1**2*f**2*gdd2*r*s - 8184*D1**2*f**2*gdd2*s**2 + 8184*D1**2*f**2*gdd2*s - 28584*D1**2*f*fd**2*r*s + 9528*D1**2*f*fd**2*r - 28038*D1**2*f*fd**2*s**2 + 28220*D1**2*f*fd**2*s - 4764*D1**2*f*fd**2 + 26400*D1**2*f*fd*g2*r*s - 13200*D1**2*f*fd*g2*r + 24816*D1**2*f*fd*g2*s**2 - 24816*D1**2*f*fd*g2*s + 12408*D1**2*f*fd*g2 - 32736*D1**2*f*fd*gd2*r*s + 8184*D1**2*f*fd*gd2*r - 32736*D1**2*f*fd*gd2*s**2 + 32736*D1**2*f*fd*gd2*s - 8184*D1**2*f*fd*gd2 - 16368*D1**2*f*fdd*g2*r*s + 8184*D1**2*f*fdd*g2*r - 16368*D1**2*f*fdd*g2*s**2 + 16368*D1**2*f*fdd*g2*s - 8184*D1**2*f*fdd*g2 - 16368*D1**2*fd**2*g2*r*s + 8184*D1**2*fd**2*g2*r - 16368*D1**2*fd**2*g2*s**2 + 16368*D1**2*fd**2*g2*s - 14256*D1*Dd*b2*f**2*r*s + 3564*D1*Dd*b2*f**2*r - 14256*D1*Dd*b2*f**2*s**2 + 14256*D1*Dd*b2*f**2*s - 3564*D1*Dd*b2*f**2 + 31680*D1*Dd*b2*f*fd*r*s - 11880*D1*Dd*b2*f*fd*r + 31680*D1*Dd*b2*f*fd*s**2 - 31680*D1*Dd*b2*f*fd*s + 7920*D1*Dd*b2*f*fd + 15840*D1*Dd*bd2*f**2*r*s - 1980*D1*Dd*bd2*f**2*r + 15840*D1*Dd*bd2*f**2*s**2 - 15840*D1*Dd*bd2*f**2*s + 1980*D1*Dd*bd2*f**2 + 22272*D1*Dd*f**3*r*s - 5568*D1*Dd*f**3*r + 24712*D1*Dd*f**3*s**2 - 23492*D1*Dd*f**3*s + 6178*D1*Dd*f**3 - 114336*D1*Dd*f**2*fd*r*s + 33348*D1*Dd*f**2*fd*r - 112152*D1*Dd*f**2*fd*s**2 + 113062*D1*Dd*f**2*fd*s - 23638*D1*Dd*f**2*fd + 52800*D1*Dd*f**2*g2*r*s - 13200*D1*Dd*f**2*g2*r + 49632*D1*Dd*f**2*g2*s**2 - 51216*D1*Dd*f**2*g2*s + 12408*D1*Dd*f**2*g2 - 65472*D1*Dd*f**2*gd2*r*s + 8184*D1*Dd*f**2*gd2*r - 65472*D1*Dd*f**2*gd2*s**2 + 65472*D1*Dd*f**2*gd2*s - 8184*D1*Dd*f**2*gd2 - 130944*D1*Dd*f*fd*g2*r*s + 49104*D1*Dd*f*fd*g2*r - 130944*D1*Dd*f*fd*g2*s**2 + 130944*D1*Dd*f*fd*g2*s - 32736*D1*Dd*f*fd*g2 + 7920*D1*Ddd*b2*f**2*r*s - 1980*D1*Ddd*b2*f**2*r + 7920*D1*Ddd*b2*f**2*s**2 - 7920*D1*Ddd*b2*f**2*s + 1980*D1*Ddd*b2*f**2 - 19056*D1*Ddd*f**3*r*s + 4764*D1*Ddd*f**3*r - 18692*D1*Ddd*f**3*s**2 + 18874*D1*Ddd*f**3*s - 4673*D1*Ddd*f**3 - 32736*D1*Ddd*f**2*g2*r*s + 8184*D1*Ddd*f**2*g2*r - 32736*D1*Ddd*f**2*g2*s**2 + 32736*D1*Ddd*f**2*g2*s - 8184*D1*Ddd*f**2*g2 + 66*D1*bd1*(D1*(5*f**3*(2*r*(s + 1) + s*(5*s - 4)) + f**2*(4*C*(r*(7*s + 5) + 15*s**2 - 6*s + 3) - 100*K*r*s - 94*K*s**2 + 100*K*s - 5*fd*(24*r*s + 33*s**2 - 31*s + 2) + 10*r*s - 32*r - 14*s**2 - 20*s + 3) - f*(fd*(12*C*(10*s**2 + s*(4*r - 7) - 1) - 62*K*(r*(4*s - 1) + (1 - 2*s)**2) + 64*r*s - 34*r + 8*s**2 - 39*s + 34) + 12*g2*(2*r*(s + 1) + 5*s**2 - 2*s + 1) - 12*gd2*(2*r*s + r + 5*s**2 - 2*s - 1)) + 12*fd*g2*(r*(2*s - 1) + s*(5*s - 5))) - Dd*f*(5*f**2*(4*r*(8*s + 1) + 44*s**2 - 43*s + 2) + f*(12*C*(r*(8*s + 3) + 20*s**2 - 11*s - 1) - 62*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 128*r*s - 88*r + 16*s**2 - 112*s + 55) - 12*g2*(r*(8*s + 3) + 20*s**2 - 11*s - 1))) + 23760*Dd**2*b2*f**2*r*s - 5940*Dd**2*b2*f**2*r + 23760*Dd**2*b2*f**2*s**2 - 23760*Dd**2*b2*f**2*s + 3960*Dd**2*b2*f**2 - 57168*Dd**2*f**3*r*s + 14292*Dd**2*f**3*r - 56076*Dd**2*f**3*s**2 + 56622*Dd**2*f**3*s - 9528*Dd**2*f**3 - 98208*Dd**2*f**2*g2*r*s + 24552*Dd**2*f**2*g2*r - 98208*Dd**2*f**2*g2*s**2 + 98208*Dd**2*f**2*g2*s - 16368*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(20*f*fd*(2*r - s**2 + 4*s - 2) - 10*f*fdd*(2*r - s**2 + 4*s - 2) - 10*fd**2*(2*r - s**2 + 4*s - 2) + 6*fd*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4) - 3*fdd*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4)) - 2*D1*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(-6*K*(8*r*s - 2*r + 20*s**2 - 14*s + 5) + 10*fd*(4*r - 4*s**2 + 9*s - 4) - 48*r*s + 12*r + 12*s**2 + 18*s + 3) + 3*fd*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8)) + D1*Ddd*f*(-6*K*(8*r*s - 2*r + 20*s**2 - 14*s + 5) + 5*f*(4*s**2 - 2*s + 1) - 48*r*s + 12*r + 12*s**2 + 18*s + 3) + 6*Dd**2*f*(K*(r*(6 - 24*s) - 60*s**2 + 42*s - 4) + 10*f*s**2 - 5*f*s + r*(6 - 24*s) + 6*s**2 + 9*s - 4)) - 33*b1*(-112*C*D1**2*f*fd*r*s + 96*C*D1**2*f*fd*r - 240*C*D1**2*f*fd*s**2 + 248*C*D1**2*f*fd*s - 96*C*D1**2*f*fd + 48*C*D1**2*f*fdd*r*s - 48*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 48*C*D1**2*f*fdd + 48*C*D1**2*fd**2*r*s - 48*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s + 48*C*D1**2*fd**2 - 224*C*D1*Dd*f**2*r*s + 56*C*D1*Dd*f**2*r - 480*C*D1*Dd*f**2*s**2 + 352*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 + 384*C*D1*Dd*f*fd*r*s - 240*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 816*C*D1*Dd*f*fd*s + 216*C*D1*Dd*f*fd + 96*C*D1*Ddd*f**2*r*s - 24*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 168*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 288*C*Dd**2*f**2*r*s - 72*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 504*C*Dd**2*f**2*s + 48*C*Dd**2*f**2 + 400*D1**2*K*f*fd*r*s - 200*D1**2*K*f*fd*r + 376*D1**2*K*f*fd*s**2 - 376*D1**2*K*f*fd*s + 188*D1**2*K*f*fd - 248*D1**2*K*f*fdd*r*s + 124*D1**2*K*f*fdd*r - 248*D1**2*K*f*fdd*s**2 + 248*D1**2*K*f*fdd*s - 124*D1**2*K*f*fdd - 248*D1**2*K*fd**2*r*s + 124*D1**2*K*fd**2*r - 248*D1**2*K*fd**2*s**2 + 248*D1**2*K*fd**2*s + D1**2*bdd1*f*(6*K*(r*(4*s + 2) + 10*s**2 - 4*s + 1) - 5*f*(4*r + 2*s**2 + 6*s - 3) + 24*r*(s - 1) - 6*s**2 - 30*s + 9) - 60*D1**2*f**2*fd*r*s + 40*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 120*D1**2*f**2*fdd*r*s - 60*D1**2*f**2*fdd*r + 165*D1**2*f**2*fdd*s**2 - 130*D1**2*f**2*fdd*s + 55*D1**2*f**2*fdd + 240*D1**2*f*fd**2*r*s - 120*D1**2*f*fd**2*r + 330*D1**2*f*fd**2*s**2 - 260*D1**2*f*fd**2*s + 60*D1**2*f*fd**2 - 40*D1**2*f*fd*r*s - 44*D1**2*f*fd*r + 56*D1**2*f*fd*s**2 - 76*D1**2*f*fd*s + 34*D1**2*f*fd + 64*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*r + 8*D1**2*f*fdd*s**2 - 2*D1**2*f*fdd*s + D1**2*f*fdd + 48*D1**2*f*gd2*r*s + 120*D1**2*f*gd2*s**2 - 48*D1**2*f*gd2*s - 24*D1**2*f*gdd2*r*s - 60*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s + 64*D1**2*fd**2*r*s + 4*D1**2*fd**2*r + 8*D1**2*fd**2*s**2 - 2*D1**2*fd**2*s - 36*D1**2*fd**2 + 48*D1**2*fd*g2*r*s - 96*D1**2*fd*g2*r + 120*D1**2*fd*g2*s**2 - 192*D1**2*fd*g2*s + 96*D1**2*fd*g2 - 48*D1**2*fd*gd2*r*s + 48*D1**2*fd*gd2*r - 120*D1**2*fd*gd2*s**2 + 120*D1**2*fd*gd2*s - 48*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r*s + 48*D1**2*fdd*g2*r - 60*D1**2*fdd*g2*s**2 + 96*D1**2*fdd*g2*s - 48*D1**2*fdd*g2 + 800*D1*Dd*K*f**2*r*s - 200*D1*Dd*K*f**2*r + 752*D1*Dd*K*f**2*s**2 - 776*D1*Dd*K*f**2*s + 188*D1*Dd*K*f**2 - 1984*D1*Dd*K*f*fd*r*s + 744*D1*Dd*K*f*fd*r - 1984*D1*Dd*K*f*fd*s**2 + 1984*D1*Dd*K*f*fd*s - 496*D1*Dd*K*f*fd - 80*D1*Dd*f**3*r*s + 20*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 140*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 960*D1*Dd*f**2*fd*r*s - 360*D1*Dd*f**2*fd*r + 1320*D1*Dd*f**2*fd*s**2 - 1090*D1*Dd*f**2*fd*s + 250*D1*Dd*f**2*fd - 80*D1*Dd*f**2*r*s + 20*D1*Dd*f**2*r + 112*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 28*D1*Dd*f**2 + 512*D1*Dd*f*fd*r*s - 48*D1*Dd*f*fd*r + 64*D1*Dd*f*fd*s**2 - 152*D1*Dd*f*fd*s - 6*D1*Dd*f*fd + 192*D1*Dd*f*g2*r*s - 48*D1*Dd*f*g2*r + 480*D1*Dd*f*g2*s**2 - 336*D1*Dd*f*g2*s + 120*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r*s + 24*D1*Dd*f*gd2*r - 480*D1*Dd*f*gd2*s**2 + 264*D1*Dd*f*gd2*s - 24*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r*s + 216*D1*Dd*fd*g2*r - 480*D1*Dd*fd*g2*s**2 + 552*D1*Dd*fd*g2*s - 192*D1*Dd*fd*g2 - 496*D1*Ddd*K*f**2*r*s + 124*D1*Ddd*K*f**2*r - 496*D1*Ddd*K*f**2*s**2 + 496*D1*Ddd*K*f**2*s - 124*D1*Ddd*K*f**2 + 160*D1*Ddd*f**3*r*s - 40*D1*Ddd*f**3*r + 220*D1*Ddd*f**3*s**2 - 190*D1*Ddd*f**3*s + 55*D1*Ddd*f**3 + 128*D1*Ddd*f**2*r*s - 32*D1*Ddd*f**2*r + 16*D1*Ddd*f**2*s**2 - 72*D1*Ddd*f**2*s + 4*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r - 240*D1*Ddd*f*g2*s**2 + 168*D1*Ddd*f*g2*s - 60*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*f**2*(4*r + 2*s**2 + 6*s - 3) - f*(6*K*(r*(4*s + 2) + 10*s**2 - 4*s + 1) + 20*fd*s**2 - 10*fd*s + 24*r*(s - 1) - 6*s**2 - 30*s + 9) + 3*fd*(K*(8*r*s - 6*r + 20*s**2 - 20*s + 4) - 2*s**2 + s*(8*r + 3) - 2)) + Dd*f*(-5*f*(8*r + 8*s**2 + 10*s - 7) + 12*r*(8*K*s + K + 8*s - 5) + s**2*(240*K - 24) - s*(132*K + 78) + 39)) - 1488*Dd**2*K*f**2*r*s + 372*Dd**2*K*f**2*r - 1488*Dd**2*K*f**2*s**2 + 1488*Dd**2*K*f**2*s - 248*Dd**2*K*f**2 + 480*Dd**2*f**3*r*s - 120*Dd**2*f**3*r + 660*Dd**2*f**3*s**2 - 570*Dd**2*f**3*s + 80*Dd**2*f**3 + 384*Dd**2*f**2*r*s - 96*Dd**2*f**2*r + 48*Dd**2*f**2*s**2 - 216*Dd**2*f**2*s + 64*Dd**2*f**2 - 288*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r - 720*Dd**2*f*g2*s**2 + 504*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(693*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**3*k1*k2**2*(-9504*C*D1**2*bdd1*f**2*r*s + 10824*C*D1**2*bdd1*f**2*r - 9900*C*D1**2*bdd1*f**2*s**2 + 22440*C*D1**2*bdd1*f**2*s - 11220*C*D1**2*bdd1*f**2 - 10680*C*D1**2*f**2*fd*r*s + 3560*C*D1**2*f**2*fd*r + 3960*C*D1**2*f**2*fd*s**2 + 920*C*D1**2*f**2*fd*s + 1320*C*D1**2*f**2*fd - 4560*C*D1**2*f**2*fdd*r*s + 1520*C*D1**2*f**2*fdd*r - 13860*C*D1**2*f**2*fdd*s**2 + 10760*C*D1**2*f**2*fdd*s - 4620*C*D1**2*f**2*fdd - 9120*C*D1**2*f*fd**2*r*s + 3040*C*D1**2*f*fd**2*r - 27720*C*D1**2*f*fd**2*s**2 + 21520*C*D1**2*f*fd**2*s - 1520*C*D1**2*f*fd**2 - 14240*C*D1*Dd*f**3*r*s + 3560*C*D1*Dd*f**3*r + 5280*C*D1*Dd*f**3*s**2 + 4480*C*D1*Dd*f**3*s + 1320*C*D1*Dd*f**3 - 36480*C*D1*Dd*f**2*fd*r*s + 10640*C*D1*Dd*f**2*fd*r - 110880*C*D1*Dd*f**2*fd*s**2 + 79880*C*D1*Dd*f**2*fd*s - 13800*C*D1*Dd*f**2*fd - 6080*C*D1*Ddd*f**3*r*s + 1520*C*D1*Ddd*f**3*r - 18480*C*D1*Ddd*f**3*s**2 + 12280*C*D1*Ddd*f**3*s - 4620*C*D1*Ddd*f**3 - 18240*C*Dd**2*f**3*r*s + 4560*C*Dd**2*f**3*r - 55440*C*Dd**2*f**3*s**2 + 36840*C*Dd**2*f**3*s - 3040*C*Dd**2*f**3 - 792*D1**2*K*bdd1*f**2*r*s - 2772*D1**2*K*bdd1*f**2*s**2 + 792*D1**2*K*bdd1*f**2*s + 66*D1**2*bd1**2*(6*f**2*(6*r*(2*s - 1) + 7*s**2 - 13*s + 6) + f*(-2*K*(r*(76*s - 44) + 89*s**2 - 139*s + 44) + r*(48*C - 10)*(2*s - 1) + (s - 1)*(96*C*s - 25*s - 26)) - 56*g2*(r*(2*s - 1) + s*(2*s - 2))) - 1584*D1**2*bd2*f**2*r*s - 1584*D1**2*bd2*f**2*s**2 + 1584*D1**2*bd2*f**2*s + 6468*D1**2*bdd1*f**2*r*s - 7128*D1**2*bdd1*f**2*r + 6270*D1**2*bdd1*f**2*s**2 - 13860*D1**2*bdd1*f**2*s + 6930*D1**2*bdd1*f**2 + 10032*D1**2*bdd1*f*g2*r*s - 11616*D1**2*bdd1*f*g2*r + 11748*D1**2*bdd1*f*g2*s**2 - 26664*D1**2*bdd1*f*g2*s + 13332*D1**2*bdd1*f*g2 + 7320*D1**2*f**2*fd*r*s - 2440*D1**2*f**2*fd*r - 1980*D1**2*f**2*fd*s**2 - 1120*D1**2*f**2*fd*s - 660*D1**2*f**2*fd + 2280*D1**2*f**2*fdd*r*s - 760*D1**2*f**2*fdd*r + 6930*D1**2*f**2*fdd*s**2 - 5380*D1**2*f**2*fdd*s + 2310*D1**2*f**2*fdd + 4752*D1**2*f**2*gd2*r*s - 1584*D1**2*f**2*gd2*s**2 - 4752*D1**2*f**2*gd2*s + 1584*D1**2*f**2*gdd2*r*s + 5544*D1**2*f**2*gdd2*s**2 - 1584*D1**2*f**2*gdd2*s + 4560*D1**2*f*fd**2*r*s - 1520*D1**2*f*fd**2*r + 13860*D1**2*f*fd**2*s**2 - 10760*D1**2*f*fd**2*s + 760*D1**2*f*fd**2 + 9504*D1**2*f*fd*g2*r*s - 4752*D1**2*f*fd*g2*r - 3168*D1**2*f*fd*g2*s**2 + 3168*D1**2*f*fd*g2*s - 1584*D1**2*f*fd*g2 + 6336*D1**2*f*fd*gd2*r*s - 1584*D1**2*f*fd*gd2*r + 22176*D1**2*f*fd*gd2*s**2 - 14256*D1**2*f*fd*gd2*s + 1584*D1**2*f*fd*gd2 + 3168*D1**2*f*fdd*g2*r*s - 1584*D1**2*f*fdd*g2*r + 11088*D1**2*f*fdd*g2*s**2 - 11088*D1**2*f*fdd*g2*s + 5544*D1**2*f*fdd*g2 + 3168*D1**2*fd**2*g2*r*s - 1584*D1**2*fd**2*g2*r + 11088*D1**2*fd**2*g2*s**2 - 11088*D1**2*fd**2*g2*s + 9760*D1*Dd*f**3*r*s - 2440*D1*Dd*f**3*r - 2640*D1*Dd*f**3*s**2 - 3560*D1*Dd*f**3*s - 660*D1*Dd*f**3 + 18240*D1*Dd*f**2*fd*r*s - 5320*D1*Dd*f**2*fd*r + 55440*D1*Dd*f**2*fd*s**2 - 39940*D1*Dd*f**2*fd*s + 6900*D1*Dd*f**2*fd + 19008*D1*Dd*f**2*g2*r*s - 4752*D1*Dd*f**2*g2*r - 6336*D1*Dd*f**2*g2*s**2 - 6336*D1*Dd*f**2*g2*s - 1584*D1*Dd*f**2*g2 + 12672*D1*Dd*f**2*gd2*r*s - 1584*D1*Dd*f**2*gd2*r + 44352*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 1584*D1*Dd*f**2*gd2 + 25344*D1*Dd*f*fd*g2*r*s - 9504*D1*Dd*f*fd*g2*r + 88704*D1*Dd*f*fd*g2*s**2 - 72864*D1*Dd*f*fd*g2*s + 14256*D1*Dd*f*fd*g2 + 3040*D1*Ddd*f**3*r*s - 760*D1*Ddd*f**3*r + 9240*D1*Ddd*f**3*s**2 - 6140*D1*Ddd*f**3*s + 2310*D1*Ddd*f**3 + 6336*D1*Ddd*f**2*g2*r*s - 1584*D1*Ddd*f**2*g2*r + 22176*D1*Ddd*f**2*g2*s**2 - 14256*D1*Ddd*f**2*g2*s + 5544*D1*Ddd*f**2*g2 + 132*D1*b2*(bd1*(D1*(29*f*(s - 1)*(r + s - 1) + 18*fd*(-2*r*s + r - s*(2*s - 2))) - 18*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 6*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + 2*D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) - 132*D1*bd1*(18*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(f**2*(-2*C*(r*(66*s - 58) + 63*s**2 - 110*s + 55) - 6*K*s**2 - 18*K*s + 2*r*(9*K*s + 37*s - 33) + 71*s**2 - 108*s + 57) + f*(fd*(2*C*(r*(144*s - 77) + 150*s**2 - 196*s + 41) + 6*K*(4*r*s - r + 14*s**2 - 9*s + 1) - 196*r*s + 103*r - 190*s**2 + 249*s - 54) + 6*g2*(r*(23*s - 20) + 25*s**2 - 44*s + 22) - 2*gd2*(r*(76*s - 44) + 89*s**2 - 139*s + 44)) + 2*fd*g2*(r*(38 - 76*s) - s*(89*s - 89))) + Dd*f*(f*(C*(16*r*(36*s - 25) + 600*s**2 - 974*s + 334) + 6*K*(8*r*s - r + 28*s**2 - 13*s + 1) - 392*r*s + 265*r - 380*s**2 + 613*s - 213) - 2*g2*(r*(304*s - 214) + 356*s**2 - 569*s + 189))) + 9120*Dd**2*f**3*r*s - 2280*Dd**2*f**3*r + 27720*Dd**2*f**3*s**2 - 18420*Dd**2*f**3*s + 1520*Dd**2*f**3 + 19008*Dd**2*f**2*g2*r*s - 4752*Dd**2*f**2*g2*r + 66528*Dd**2*f**2*g2*s**2 - 42768*Dd**2*f**2*g2*s + 3168*Dd**2*f**2*g2 + 132*b1**3*(6*D1**2*s*(2*fd - fdd)*(r + s - 1) + 2*D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - (14*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 6*f + 7) - Dd**2*(-14*K + 6*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 33*b1**2*(-192*C*D1**2*fd*r*s - 192*C*D1**2*fd*s**2 + 192*C*D1**2*fd*s + 96*C*D1**2*fdd*r*s + 96*C*D1**2*fdd*s**2 - 96*C*D1**2*fdd*s - 768*C*D1*Dd*f*r*s + 192*C*D1*Dd*f*r - 768*C*D1*Dd*f*s**2 + 768*C*D1*Dd*f*s - 192*C*D1*Dd*f + 768*C*D1*Dd*fd*r*s - 96*C*D1*Dd*fd*r + 768*C*D1*Dd*fd*s**2 - 768*C*D1*Dd*fd*s + 96*C*D1*Dd*fd + 384*C*D1*Ddd*f*r*s - 96*C*D1*Ddd*f*r + 384*C*D1*Ddd*f*s**2 - 384*C*D1*Ddd*f*s + 96*C*D1*Ddd*f + 1152*C*Dd**2*f*r*s - 288*C*Dd**2*f*r + 1152*C*Dd**2*f*s**2 - 1152*C*Dd**2*f*s + 192*C*Dd**2*f + 276*D1**2*K*fd*r*s - 36*D1**2*K*fd*r + 300*D1**2*K*fd*s**2 - 72*D1**2*K*fd*s + 36*D1**2*K*fd - 152*D1**2*K*fdd*r*s - 24*D1**2*K*fdd*r - 178*D1**2*K*fdd*s**2 - 48*D1**2*K*fdd*s + 24*D1**2*K*fdd - 4*D1**2*bdd1*(-14*K + 6*f + 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 144*D1**2*f*fd*r*s + 24*D1**2*f*fd*r - 72*D1**2*f*fd*s**2 + 120*D1**2*f*fd*s - 24*D1**2*f*fd + 144*D1**2*f*fdd*r*s + 84*D1**2*f*fdd*s**2 - 72*D1**2*f*fdd*s + 144*D1**2*fd**2*r*s + 84*D1**2*fd**2*s**2 - 72*D1**2*fd**2*s + 96*D1**2*fd*r*s + 28*D1**2*fd*r + 106*D1**2*fd*s**2 - 88*D1**2*fd*s - 28*D1**2*fd - 20*D1**2*fdd*r*s - 25*D1**2*fdd*s**2 + 72*D1**2*fdd*s + 224*D1**2*gd2*r*s + 224*D1**2*gd2*s**2 - 224*D1**2*gd2*s - 112*D1**2*gdd2*r*s - 112*D1**2*gdd2*s**2 + 112*D1**2*gdd2*s + 1104*D1*Dd*K*f*r*s - 276*D1*Dd*K*f*r + 1200*D1*Dd*K*f*s**2 - 1152*D1*Dd*K*f*s + 300*D1*Dd*K*f - 1216*D1*Dd*K*fd*r*s + 56*D1*Dd*K*fd*r - 1424*D1*Dd*K*fd*s**2 + 468*D1*Dd*K*fd*s + 96*D1*Dd*K*fd - 288*D1*Dd*f**2*r*s + 72*D1*Dd*f**2*r - 144*D1*Dd*f**2*s**2 + 216*D1*Dd*f**2*s - 36*D1*Dd*f**2 + 1152*D1*Dd*f*fd*r*s - 144*D1*Dd*f*fd*r + 672*D1*Dd*f*fd*s**2 - 744*D1*Dd*f*fd*s + 72*D1*Dd*f*fd + 384*D1*Dd*f*r*s - 96*D1*Dd*f*r + 424*D1*Dd*f*s**2 - 404*D1*Dd*f*s + 106*D1*Dd*f - 160*D1*Dd*fd*r*s + 20*D1*Dd*fd*r - 200*D1*Dd*fd*s**2 + 378*D1*Dd*fd*s - 72*D1*Dd*fd + 896*D1*Dd*g2*r*s - 224*D1*Dd*g2*r + 896*D1*Dd*g2*s**2 - 896*D1*Dd*g2*s + 224*D1*Dd*g2 - 896*D1*Dd*gd2*r*s + 112*D1*Dd*gd2*r - 896*D1*Dd*gd2*s**2 + 896*D1*Dd*gd2*s - 112*D1*Dd*gd2 - 608*D1*Ddd*K*f*r*s + 152*D1*Ddd*K*f*r - 712*D1*Ddd*K*f*s**2 + 660*D1*Ddd*K*f*s - 178*D1*Ddd*K*f + 288*D1*Ddd*f**2*r*s - 72*D1*Ddd*f**2*r + 168*D1*Ddd*f**2*s**2 - 228*D1*Ddd*f**2*s + 42*D1*Ddd*f**2 - 80*D1*Ddd*f*r*s + 20*D1*Ddd*f*r - 100*D1*Ddd*f*s**2 + 90*D1*Ddd*f*s - 25*D1*Ddd*f - 448*D1*Ddd*g2*r*s + 112*D1*Ddd*g2*r - 448*D1*Ddd*g2*s**2 + 448*D1*Ddd*g2*s - 112*D1*Ddd*g2 + 4*D1*bd1*(2*D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + (7 - 14*K)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(-14*K + 6*f + 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 1824*Dd**2*K*f*r*s + 456*Dd**2*K*f*r - 2136*Dd**2*K*f*s**2 + 1980*Dd**2*K*f*s - 304*Dd**2*K*f + 864*Dd**2*f**2*r*s - 216*Dd**2*f**2*r + 504*Dd**2*f**2*s**2 - 684*Dd**2*f**2*s + 144*Dd**2*f**2 - 240*Dd**2*f*r*s + 60*Dd**2*f*r - 300*Dd**2*f*s**2 + 270*Dd**2*f*s - 40*Dd**2*f - 1344*Dd**2*g2*r*s + 336*Dd**2*g2*r - 1344*Dd**2*g2*s**2 + 1344*Dd**2*g2*s - 224*Dd**2*g2) - 33*b1*(-1056*C*D1**2*f*fd*r*s + 64*C*D1**2*f*fd*r - 1008*C*D1**2*f*fd*s**2 + 656*C*D1**2*f*fd*s - 64*C*D1**2*f*fd + 576*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*r + 600*C*D1**2*f*fdd*s**2 - 208*C*D1**2*f*fdd*s - 40*C*D1**2*f*fdd + 576*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*r + 600*C*D1**2*fd**2*s**2 - 208*C*D1**2*fd**2*s - 40*C*D1**2*fd**2 - 2112*C*D1*Dd*f**2*r*s + 528*C*D1*Dd*f**2*r - 2016*C*D1*Dd*f**2*s**2 + 2064*C*D1*Dd*f**2*s - 504*C*D1*Dd*f**2 + 4608*C*D1*Dd*f*fd*r*s - 416*C*D1*Dd*f*fd*r + 4800*C*D1*Dd*f*fd*s**2 - 3184*C*D1*Dd*f*fd*s + 128*C*D1*Dd*f*fd + 1152*C*D1*Ddd*f**2*r*s - 288*C*D1*Ddd*f**2*r + 1200*C*D1*Ddd*f**2*s**2 - 1176*C*D1*Ddd*f**2*s + 300*C*D1*Ddd*f**2 + 3456*C*Dd**2*f**2*r*s - 864*C*Dd**2*f**2*r + 3600*C*Dd**2*f**2*s**2 - 3528*C*Dd**2*f**2*s + 576*C*Dd**2*f**2 + 144*D1**2*K*f*fd*r*s - 72*D1**2*K*f*fd*r - 48*D1**2*K*f*fd*s**2 + 48*D1**2*K*f*fd*s - 24*D1**2*K*f*fd + 48*D1**2*K*f*fdd*r*s - 24*D1**2*K*f*fdd*r + 168*D1**2*K*f*fdd*s**2 - 168*D1**2*K*f*fdd*s + 84*D1**2*K*f*fdd + 48*D1**2*K*fd**2*r*s - 24*D1**2*K*fd**2*r + 168*D1**2*K*fd**2*s**2 - 168*D1**2*K*fd**2*s + 4*D1**2*bd1**2*(-14*K + 6*f + 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(-6*f**2*(12*r*(2*s - 1) + 14*s**2 - 26*s + 7) + f*(-96*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*K*(152*r*s - 88*r + 178*s**2 - 278*s + 101) + 40*r*s - 20*r + 50*s**2 + 2*s + 25) + 112*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 72*D1**2*bdd2*f*r*s + 72*D1**2*bdd2*f*s**2 - 72*D1**2*bdd2*f*s + 592*D1**2*f*fd*r*s - 32*D1**2*f*fd*r + 568*D1**2*f*fd*s**2 - 432*D1**2*f*fd*s + 56*D1**2*f*fd - 392*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r - 380*D1**2*f*fdd*s**2 + 156*D1**2*f*fdd*s + 20*D1**2*f*fdd + 552*D1**2*f*gd2*r*s + 600*D1**2*f*gd2*s**2 - 552*D1**2*f*gd2*s - 304*D1**2*f*gdd2*r*s - 356*D1**2*f*gdd2*s**2 + 304*D1**2*f*gdd2*s - 392*D1**2*fd**2*r*s - 20*D1**2*fd**2*r - 380*D1**2*fd**2*s**2 + 156*D1**2*fd**2*s + 20*D1**2*fd**2 + 552*D1**2*fd*g2*r*s - 72*D1**2*fd*g2*r + 600*D1**2*fd*g2*s**2 - 144*D1**2*fd*g2*s + 72*D1**2*fd*g2 - 608*D1**2*fd*gd2*r*s - 48*D1**2*fd*gd2*r - 712*D1**2*fd*gd2*s**2 + 208*D1**2*fd*gd2*s + 48*D1**2*fd*gd2 - 304*D1**2*fdd*g2*r*s - 48*D1**2*fdd*g2*r - 356*D1**2*fdd*g2*s**2 - 96*D1**2*fdd*g2*s + 48*D1**2*fdd*g2 + 288*D1*Dd*K*f**2*r*s - 72*D1*Dd*K*f**2*r - 96*D1*Dd*K*f**2*s**2 - 96*D1*Dd*K*f**2*s - 24*D1*Dd*K*f**2 + 384*D1*Dd*K*f*fd*r*s - 144*D1*Dd*K*f*fd*r + 1344*D1*Dd*K*f*fd*s**2 - 1104*D1*Dd*K*f*fd*s + 216*D1*Dd*K*f*fd + 1184*D1*Dd*f**2*r*s - 296*D1*Dd*f**2*r + 1136*D1*Dd*f**2*s**2 - 1160*D1*Dd*f**2*s + 284*D1*Dd*f**2 - 3136*D1*Dd*f*fd*r*s + 312*D1*Dd*f*fd*r - 3040*D1*Dd*f*fd*s**2 + 2168*D1*Dd*f*fd*s - 116*D1*Dd*f*fd + 2208*D1*Dd*f*g2*r*s - 552*D1*Dd*f*g2*r + 2400*D1*Dd*f*g2*s**2 - 2304*D1*Dd*f*g2*s + 600*D1*Dd*f*g2 - 2432*D1*Dd*f*gd2*r*s + 304*D1*Dd*f*gd2*r - 2848*D1*Dd*f*gd2*s**2 + 2536*D1*Dd*f*gd2*s - 304*D1*Dd*f*gd2 - 2432*D1*Dd*fd*g2*r*s + 112*D1*Dd*fd*g2*r - 2848*D1*Dd*fd*g2*s**2 + 936*D1*Dd*fd*g2*s + 192*D1*Dd*fd*g2 + 96*D1*Ddd*K*f**2*r*s - 24*D1*Ddd*K*f**2*r + 336*D1*Ddd*K*f**2*s**2 - 216*D1*Ddd*K*f**2*s + 84*D1*Ddd*K*f**2 - 784*D1*Ddd*f**2*r*s + 196*D1*Ddd*f**2*r - 760*D1*Ddd*f**2*s**2 + 772*D1*Ddd*f**2*s - 190*D1*Ddd*f**2 - 1216*D1*Ddd*f*g2*r*s + 304*D1*Ddd*f*g2*r - 1424*D1*Ddd*f*g2*s**2 + 1320*D1*Ddd*f*g2*s - 356*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(6*f**2*(4*r*(3*s - 1) + 6*s**2 - 8*s + 1) + f*(96*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 276*K*r*s + 120*K*r - 300*K*s**2 + 402*K*s - 132*K - 12*fd*(24*r*s - 6*r + 14*s**2 - 19*s + 3) - 96*r*s + 62*r - 106*s**2 + 110*s - 67) + fd*(-48*C*(r*(4*s - 1) + (1 - 2*s)**2) + 2*K*(8*r*(19*s - 4) + 178*s**2 - 115*s - 6) + 40*r*s - 10*r + 50*s**2 - 71*s + 36) - 56*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 56*gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*(-6*f**2*(12*r*(8*s - 3) + 56*s**2 - 90*s + 25) + f*(-96*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 2*K*(608*r*s - 252*r + 712*s**2 - 886*s + 227) + 160*r*s - 60*r + 200*s**2 - 86*s + 19) + 112*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 4*D1*bd2*(D1*s*(29*f*(r + s - 1) - 18*fd*(2*r + 2*s - 1)) - 18*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 288*Dd**2*K*f**2*r*s - 72*Dd**2*K*f**2*r + 1008*Dd**2*K*f**2*s**2 - 648*Dd**2*K*f**2*s + 48*Dd**2*K*f**2 - 2352*Dd**2*f**2*r*s + 588*Dd**2*f**2*r - 2280*Dd**2*f**2*s**2 + 2316*Dd**2*f**2*s - 392*Dd**2*f**2 - 3648*Dd**2*f*g2*r*s + 912*Dd**2*f*g2*r - 4272*Dd**2*f*g2*s**2 + 3960*Dd**2*f*g2*s - 608*Dd**2*f*g2 - 4*b2*(D1**2*s*(29*fd - 18*fdd)*(r + s) + D1*Dd*(29*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 1) + 4*s*(2*s - 1))) - 18*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2))))/(693*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**3*k1*st**2*(792*C*D1**2*bdd1*f**2*r*s - 1980*C*D1**2*bdd1*f**2*s**2 - 15000*C*D1**2*f**2*fd*s**2 + 10000*C*D1**2*f**2*fd*s - 5000*C*D1**2*f**2*fd + 7500*C*D1**2*f**2*fdd*s**2 - 5000*C*D1**2*f**2*fdd*s + 2500*C*D1**2*f**2*fdd + 15000*C*D1**2*f*fd**2*s**2 - 10000*C*D1**2*f*fd**2*s - 20000*C*D1*Dd*f**3*s**2 + 10000*C*D1*Dd*f**3*s - 5000*C*D1*Dd*f**3 + 60000*C*D1*Dd*f**2*fd*s**2 - 35000*C*D1*Dd*f**2*fd*s + 5000*C*D1*Dd*f**2*fd + 10000*C*D1*Ddd*f**3*s**2 - 5000*C*D1*Ddd*f**3*s + 2500*C*D1*Ddd*f**3 + 30000*C*Dd**2*f**3*s**2 - 15000*C*Dd**2*f**3*s + 1650*D1**2*K*bdd1*f**2*s**2 - 6600*D1**2*b2*f*fd*s**2 + 6600*D1**2*b2*f*fd*s - 3300*D1**2*b2*f*fd + 3300*D1**2*b2*f*fdd*s**2 - 3300*D1**2*b2*f*fdd*s + 1650*D1**2*b2*f*fdd + 3300*D1**2*b2*fd**2*s**2 - 3300*D1**2*b2*fd**2*s + 66*D1**2*bd1**2*f*s*(6*K*(2*r - 5*s - 1) + 25*f - 12*r + 21) - 3300*D1**2*bd2*f**2*s**2 + 6600*D1**2*bd2*f*fd*s**2 - 3300*D1**2*bd2*f*fd*s + 1980*D1**2*bdd1*f**3*r*s + 1815*D1**2*bdd1*f**3*s**2 - 1320*D1**2*bdd1*f**3*s + 264*D1**2*bdd1*f**2*r*s + 2211*D1**2*bdd1*f**2*s**2 - 66*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r*s + 1980*D1**2*bdd1*f*g2*s**2 + 1650*D1**2*bdd2*f**2*s**2 - 4152*D1**2*f**2*fd*r*s + 1384*D1**2*f**2*fd*r + 1842*D1**2*f**2*fd*s**2 + 156*D1**2*f**2*fd*s + 614*D1**2*f**2*fd + 3264*D1**2*f**2*fdd*r*s - 1088*D1**2*f**2*fdd*r - 327*D1**2*f**2*fdd*s**2 - 870*D1**2*f**2*fdd*s - 109*D1**2*f**2*fdd + 6600*D1**2*f**2*gd2*s**2 - 3300*D1**2*f**2*gdd2*s**2 + 6528*D1**2*f*fd**2*r*s - 2176*D1**2*f*fd**2*r - 654*D1**2*f*fd**2*s**2 - 1740*D1**2*f*fd**2*s + 1088*D1**2*f*fd**2 + 13200*D1**2*f*fd*g2*s**2 - 13200*D1**2*f*fd*g2*s + 6600*D1**2*f*fd*g2 - 13200*D1**2*f*fd*gd2*s**2 + 6600*D1**2*f*fd*gd2*s - 6600*D1**2*f*fdd*g2*s**2 + 6600*D1**2*f*fdd*g2*s - 3300*D1**2*f*fdd*g2 - 6600*D1**2*fd**2*g2*s**2 + 6600*D1**2*fd**2*g2*s - 13200*D1*Dd*b2*f**2*s**2 + 6600*D1*Dd*b2*f**2*s - 3300*D1*Dd*b2*f**2 + 26400*D1*Dd*b2*f*fd*s**2 - 19800*D1*Dd*b2*f*fd*s + 3300*D1*Dd*b2*f*fd + 13200*D1*Dd*bd2*f**2*s**2 - 3300*D1*Dd*bd2*f**2*s - 5536*D1*Dd*f**3*r*s + 1384*D1*Dd*f**3*r + 2456*D1*Dd*f**3*s**2 + 1540*D1*Dd*f**3*s + 614*D1*Dd*f**3 + 26112*D1*Dd*f**2*fd*r*s - 7616*D1*Dd*f**2*fd*r - 2616*D1*Dd*f**2*fd*s**2 - 9354*D1*Dd*f**2*fd*s + 3046*D1*Dd*f**2*fd + 26400*D1*Dd*f**2*g2*s**2 - 13200*D1*Dd*f**2*g2*s + 6600*D1*Dd*f**2*g2 - 26400*D1*Dd*f**2*gd2*s**2 + 6600*D1*Dd*f**2*gd2*s - 52800*D1*Dd*f*fd*g2*s**2 + 39600*D1*Dd*f*fd*g2*s - 6600*D1*Dd*f*fd*g2 + 6600*D1*Ddd*b2*f**2*s**2 - 3300*D1*Ddd*b2*f**2*s + 1650*D1*Ddd*b2*f**2 + 4352*D1*Ddd*f**3*r*s - 1088*D1*Ddd*f**3*r - 436*D1*Ddd*f**3*s**2 - 1958*D1*Ddd*f**3*s - 109*D1*Ddd*f**3 - 13200*D1*Ddd*f**2*g2*s**2 + 6600*D1*Ddd*f**2*g2*s - 3300*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(5*f**3*s*(6*r + 9*s - 4) + f**2*(-5*fd*(6*r*(6*s - 1) + 33*s**2 - 31*s + 4) + s**2*(-60*C + 50*K + 61) + s*(20*C*r + 6*r + 4) - 15) - 2*f*(fd*(r*(6*C + 2)*(4*s - 1) + s**2*(-60*C + 50*K + 67) + s*(24*C - 25*K - 36) + 8) + 6*s*(2*g2*r - 5*g2*s - 2*gd2*r + 5*gd2*s + gd2)) - 12*fd*g2*(-2*r*s + r + s*(5*s - 5))) - Dd*f*(5*f**2*(6*r*(8*s - 1) + 44*s**2 - 39*s + 4) + f*(r*(12*C + 4)*(8*s - 1) - s**2*(240*C - 200*K - 268) + s*(36*C - 50*K - 79) + 1) + 12*g2*(-8*r*s + r + s*(20*s - 3)))) + 19800*Dd**2*b2*f**2*s**2 - 9900*Dd**2*b2*f**2*s + 13056*Dd**2*f**3*r*s - 3264*Dd**2*f**3*r - 1308*Dd**2*f**3*s**2 - 5874*Dd**2*f**3*s + 2176*Dd**2*f**3 - 39600*Dd**2*f**2*g2*s**2 + 19800*Dd**2*f**2*g2*s + 33*b1**2*(-2*D1*Dd*(6*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s) + fd*(3*K*(2*r*(5 - 8*s) + 40*s**2 - 46*s + 6) + 25*f*(4*s - 1) + 48*r*s - 30*r + 48*s - 3)) + D1*(D1*(50*f*fd*(2*s - 1) - 50*fd**2*s - 6*fd*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*s + 4*r - 10*s + 5) + fdd*(6*K*(s - 1)*(2*r - 5*s + 5) + f*(25 - 50*s) - 12*r*s + 12*r - 30*s + 15)) + 6*Ddd*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s)) + 12*Dd**2*f*(K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) - 12*r*s + 3*r + 6*s - 2)) - 33*b1*(80*C*D1**2*f*fd*r*s - 40*C*D1**2*f*fd*r - 240*C*D1**2*f*fd*s**2 + 200*C*D1**2*f*fd*s - 120*C*D1**2*f*fd - 48*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r + 120*C*D1**2*f*fdd*s**2 - 96*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r + 120*C*D1**2*fd**2*s**2 - 96*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 + 160*C*D1*Dd*f**2*r*s - 40*C*D1*Dd*f**2*r - 480*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 120*C*D1*Dd*f**2 - 384*C*D1*Dd*f*fd*r*s + 144*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 528*C*D1*Dd*f*fd*s + 48*C*D1*Dd*f*fd - 96*C*D1*Ddd*f**2*r*s + 24*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 72*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 - 288*C*Dd**2*f**2*r*s + 72*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 216*C*Dd**2*f**2*s - 48*C*Dd**2*f**2 + 200*D1**2*K*f*fd*s**2 - 200*D1**2*K*f*fd*s + 100*D1**2*K*f*fd - 100*D1**2*K*f*fdd*s**2 + 100*D1**2*K*f*fdd*s - 50*D1**2*K*f*fdd - 100*D1**2*K*fd**2*s**2 + 100*D1**2*K*fd**2*s + D1**2*bdd1*f*(60*K*s**2 + f*(25 - 50*s) - s*(6*K*(4*r - 2) - 24*r + 42) + 15) + 180*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 270*D1**2*f**2*fd*s**2 - 260*D1**2*f**2*fd*s + 90*D1**2*f**2*fd - 180*D1**2*f**2*fdd*r*s + 60*D1**2*f**2*fdd*r - 165*D1**2*f**2*fdd*s**2 + 190*D1**2*f**2*fdd*s - 55*D1**2*f**2*fdd - 360*D1**2*f*fd**2*r*s + 120*D1**2*f*fd**2*r - 330*D1**2*f*fd**2*s**2 + 380*D1**2*f*fd**2*s - 80*D1**2*f*fd**2 + 24*D1**2*f*fd*r*s - 12*D1**2*f*fd*r + 244*D1**2*f*fd*s**2 - 264*D1**2*f*fd*s + 152*D1**2*f*fd - 16*D1**2*f*fdd*r*s + 8*D1**2*f*fdd*r - 134*D1**2*f*fdd*s**2 + 140*D1**2*f*fdd*s - 82*D1**2*f*fdd - 48*D1**2*f*gd2*r*s + 120*D1**2*f*gd2*s**2 + 48*D1**2*f*gd2*s + 24*D1**2*f*gdd2*r*s - 60*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s - 16*D1**2*fd**2*r*s + 8*D1**2*fd**2*r - 134*D1**2*fd**2*s**2 + 140*D1**2*fd**2*s + 24*D1**2*fd**2 - 48*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*r + 120*D1**2*fd*g2*s**2 - 240*D1**2*fd*g2*s + 120*D1**2*fd*g2 + 48*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*r - 120*D1**2*fd*gd2*s**2 + 96*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 + 24*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r - 60*D1**2*fdd*g2*s**2 + 120*D1**2*fdd*g2*s - 60*D1**2*fdd*g2 + 400*D1*Dd*K*f**2*s**2 - 200*D1*Dd*K*f**2*s + 100*D1*Dd*K*f**2 - 800*D1*Dd*K*f*fd*s**2 + 600*D1*Dd*K*f*fd*s - 100*D1*Dd*K*f*fd + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 360*D1*Dd*f**3*s**2 - 300*D1*Dd*f**3*s + 90*D1*Dd*f**3 - 1440*D1*Dd*f**2*fd*r*s + 420*D1*Dd*f**2*fd*r - 1320*D1*Dd*f**2*fd*s**2 + 1450*D1*Dd*f**2*fd*s - 310*D1*Dd*f**2*fd + 48*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 488*D1*Dd*f**2*s**2 - 268*D1*Dd*f**2*s + 122*D1*Dd*f**2 - 128*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r - 1072*D1*Dd*f*fd*s**2 + 860*D1*Dd*f*fd*s - 156*D1*Dd*f*fd - 192*D1*Dd*f*g2*r*s + 48*D1*Dd*f*g2*r + 480*D1*Dd*f*g2*s**2 - 144*D1*Dd*f*g2*s + 120*D1*Dd*f*g2 + 192*D1*Dd*f*gd2*r*s - 24*D1*Dd*f*gd2*r - 480*D1*Dd*f*gd2*s**2 - 24*D1*Dd*f*gd2*s + 24*D1*Dd*f*gd2 + 192*D1*Dd*fd*g2*r*s - 120*D1*Dd*fd*g2*r - 480*D1*Dd*fd*g2*s**2 + 552*D1*Dd*fd*g2*s - 72*D1*Dd*fd*g2 - 200*D1*Ddd*K*f**2*s**2 + 100*D1*Ddd*K*f**2*s - 50*D1*Ddd*K*f**2 - 240*D1*Ddd*f**3*r*s + 60*D1*Ddd*f**3*r - 220*D1*Ddd*f**3*s**2 + 230*D1*Ddd*f**3*s - 55*D1*Ddd*f**3 - 32*D1*Ddd*f**2*r*s + 8*D1*Ddd*f**2*r - 268*D1*Ddd*f**2*s**2 + 150*D1*Ddd*f**2*s - 67*D1*Ddd*f**2 + 96*D1*Ddd*f*g2*r*s - 24*D1*Ddd*f*g2*r - 240*D1*Ddd*f*g2*s**2 + 72*D1*Ddd*f*g2*s - 60*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(25*f**2*(2*s - 1) - 3*f*(20*K*s**2 + s*(-8*K*r + 4*K + 8*r - 14) + 5) + 3*fd*(-2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) + 8*r*s - 4*r + 3*s + 2)) + Dd*f*(-3*K*(32*r*s - 4*r - 80*s**2 + 4*s + 2) - 25*f*(4*s - 1) + 96*r*s - 12*r - 108*s + 21)) - 600*Dd**2*K*f**2*s**2 + 300*Dd**2*K*f**2*s - 720*Dd**2*f**3*r*s + 180*Dd**2*f**3*r - 660*Dd**2*f**3*s**2 + 690*Dd**2*f**3*s - 120*Dd**2*f**3 - 96*Dd**2*f**2*r*s + 24*Dd**2*f**2*r - 804*Dd**2*f**2*s**2 + 450*Dd**2*f**2*s - 16*Dd**2*f**2 + 288*Dd**2*f*g2*r*s - 72*Dd**2*f*g2*r - 720*Dd**2*f*g2*s**2 + 216*Dd**2*f*g2*s + 48*Dd**2*f*g2))/(693*d**2*k3**2) - D1**2*Pk3*Pkd2*ct**3*k1*(-5940*C*D1**2*bdd1*f**2*s**2 + 1320*C*D1**2*bdd1*f**2*s - 660*C*D1**2*bdd1*f**2 - 5160*C*D1**2*f**2*fd*r*s + 1720*C*D1**2*f**2*fd*r - 19800*C*D1**2*f**2*fd*s**2 + 14920*C*D1**2*f**2*fd*s - 6600*C*D1**2*f**2*fd + 4560*C*D1**2*f**2*fdd*r*s - 1520*C*D1**2*f**2*fdd*r + 13860*C*D1**2*f**2*fdd*s**2 - 10760*C*D1**2*f**2*fdd*s + 4620*C*D1**2*f**2*fdd + 9120*C*D1**2*f*fd**2*r*s - 3040*C*D1**2*f*fd**2*r + 27720*C*D1**2*f*fd**2*s**2 - 21520*C*D1**2*f*fd**2*s + 1520*C*D1**2*f*fd**2 - 6880*C*D1*Dd*f**3*r*s + 1720*C*D1*Dd*f**3*r - 26400*C*D1*Dd*f**3*s**2 + 16640*C*D1*Dd*f**3*s - 6600*C*D1*Dd*f**3 + 36480*C*D1*Dd*f**2*fd*r*s - 10640*C*D1*Dd*f**2*fd*r + 110880*C*D1*Dd*f**2*fd*s**2 - 79880*C*D1*Dd*f**2*fd*s + 13800*C*D1*Dd*f**2*fd + 6080*C*D1*Ddd*f**3*r*s - 1520*C*D1*Ddd*f**3*r + 18480*C*D1*Ddd*f**3*s**2 - 12280*C*D1*Ddd*f**3*s + 4620*C*D1*Ddd*f**3 + 18240*C*Dd**2*f**3*r*s - 4560*C*Dd**2*f**3*r + 55440*C*Dd**2*f**3*s**2 - 36840*C*Dd**2*f**3*s + 3040*C*Dd**2*f**3 + 792*D1**2*K*bdd1*f**2*r*s + 2772*D1**2*K*bdd1*f**2*s**2 - 792*D1**2*K*bdd1*f**2*s - 66*D1**2*bd1**2*(6*f**2*(r*(8*s - 6) - 9*s + 4) + f*(r*(28*C - 2)*(2*s - 1) + s**2*(-24*C + 106*K + 18) + s*(24*C - 12*K - 91) + 26) - 28*g2*(2*r*s - r - s**2 + s)) - 792*D1**2*bd2*f**2*r*s - 3960*D1**2*bd2*f**2*s**2 + 792*D1**2*bd2*f**2*s + 3168*D1**2*bd2*f*fd*r*s - 792*D1**2*bd2*f*fd*r + 11088*D1**2*bd2*f*fd*s**2 - 7128*D1**2*bd2*f*fd*s + 792*D1**2*bd2*f*fd - 1716*D1**2*bdd1*f**2*r*s + 1716*D1**2*bdd1*f**2*r + 2970*D1**2*bdd1*f**2*s**2 + 1980*D1**2*bdd1*f**2*s - 990*D1**2*bdd1*f**2 + 6996*D1**2*bdd1*f*g2*s**2 - 1584*D1**2*bdd1*f*g2*s + 792*D1**2*bdd1*f*g2 + 792*D1**2*bdd2*f**2*r*s + 2772*D1**2*bdd2*f**2*s**2 - 792*D1**2*bdd2*f**2*s + 600*D1**2*f**2*fd*r*s - 200*D1**2*f**2*fd*r + 9900*D1**2*f**2*fd*s**2 - 6800*D1**2*f**2*fd*s + 3300*D1**2*f**2*fd - 2280*D1**2*f**2*fdd*r*s + 760*D1**2*f**2*fdd*r - 6930*D1**2*f**2*fdd*s**2 + 5380*D1**2*f**2*fdd*s - 2310*D1**2*f**2*fdd + 1584*D1**2*f**2*gd2*r*s + 7920*D1**2*f**2*gd2*s**2 - 1584*D1**2*f**2*gd2*s - 1584*D1**2*f**2*gdd2*r*s - 5544*D1**2*f**2*gdd2*s**2 + 1584*D1**2*f**2*gdd2*s - 4560*D1**2*f*fd**2*r*s + 1520*D1**2*f*fd**2*r - 13860*D1**2*f*fd**2*s**2 + 10760*D1**2*f*fd**2*s - 760*D1**2*f*fd**2 + 3168*D1**2*f*fd*g2*r*s - 1584*D1**2*f*fd*g2*r + 15840*D1**2*f*fd*g2*s**2 - 15840*D1**2*f*fd*g2*s + 7920*D1**2*f*fd*g2 - 6336*D1**2*f*fd*gd2*r*s + 1584*D1**2*f*fd*gd2*r - 22176*D1**2*f*fd*gd2*s**2 + 14256*D1**2*f*fd*gd2*s - 1584*D1**2*f*fd*gd2 - 3168*D1**2*f*fdd*g2*r*s + 1584*D1**2*f*fdd*g2*r - 11088*D1**2*f*fdd*g2*s**2 + 11088*D1**2*f*fdd*g2*s - 5544*D1**2*f*fdd*g2 - 3168*D1**2*fd**2*g2*r*s + 1584*D1**2*fd**2*g2*r - 11088*D1**2*fd**2*g2*s**2 + 11088*D1**2*fd**2*g2*s + 6336*D1*Dd*bd2*f**2*r*s - 792*D1*Dd*bd2*f**2*r + 22176*D1*Dd*bd2*f**2*s**2 - 10296*D1*Dd*bd2*f**2*s + 792*D1*Dd*bd2*f**2 + 800*D1*Dd*f**3*r*s - 200*D1*Dd*f**3*r + 13200*D1*Dd*f**3*s**2 - 7000*D1*Dd*f**3*s + 3300*D1*Dd*f**3 - 18240*D1*Dd*f**2*fd*r*s + 5320*D1*Dd*f**2*fd*r - 55440*D1*Dd*f**2*fd*s**2 + 39940*D1*Dd*f**2*fd*s - 6900*D1*Dd*f**2*fd + 6336*D1*Dd*f**2*g2*r*s - 1584*D1*Dd*f**2*g2*r + 31680*D1*Dd*f**2*g2*s**2 - 19008*D1*Dd*f**2*g2*s + 7920*D1*Dd*f**2*g2 - 12672*D1*Dd*f**2*gd2*r*s + 1584*D1*Dd*f**2*gd2*r - 44352*D1*Dd*f**2*gd2*s**2 + 20592*D1*Dd*f**2*gd2*s - 1584*D1*Dd*f**2*gd2 - 25344*D1*Dd*f*fd*g2*r*s + 9504*D1*Dd*f*fd*g2*r - 88704*D1*Dd*f*fd*g2*s**2 + 72864*D1*Dd*f*fd*g2*s - 14256*D1*Dd*f*fd*g2 - 3040*D1*Ddd*f**3*r*s + 760*D1*Ddd*f**3*r - 9240*D1*Ddd*f**3*s**2 + 6140*D1*Ddd*f**3*s - 2310*D1*Ddd*f**3 - 6336*D1*Ddd*f**2*g2*r*s + 1584*D1*Ddd*f**2*g2*r - 22176*D1*Ddd*f**2*g2*s**2 + 14256*D1*Ddd*f**2*g2*s - 5544*D1*Ddd*f**2*g2 - 132*D1*bd1*(D1*(f**2*(2*C*(-33*s**2 + s*(6*r + 10) - 5) + 30*K*s**2 - 6*K*s + r*(6*K*s - 26*s + 20) + 33*s**2 + 12*s - 9) + f*(fd*(180*C*s**2 - 100*C*s - 6*K*(4*r*s - r + 14*s**2 - 9*s + 1) + 52*r*s - 26*r - 90*s**2 + 17*s + 13) + 2*g2*(39*s**2 - s*(7*r + 12) + 6) + 2*s*(3*bd2*(s - 1) + gd2*(6 - 53*s))) - 106*fd*g2*s*(s - 1)) + Dd*f*(f*(10*C*(36*s**2 - 13*s + 1) - 6*K*(8*r*s - r + 28*s**2 - 13*s + 1) + 104*r*s - 65*r - 180*s**2 - 41*s + 41) - 2*g2*(212*s**2 - 77*s + 6))) - 9120*Dd**2*f**3*r*s + 2280*Dd**2*f**3*r - 27720*Dd**2*f**3*s**2 + 18420*Dd**2*f**3*s - 1520*Dd**2*f**3 - 19008*Dd**2*f**2*g2*r*s + 4752*Dd**2*f**2*g2*r - 66528*Dd**2*f**2*g2*s**2 + 42768*Dd**2*f**2*g2*s - 3168*Dd**2*f**2*g2 + 33*b1**3*(6*D1**2*s**2*(2*fd - fdd) + D1*(2*Dd*(-14*K*(r*(2 - 8*s) + 4*s**2 + 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s - 112*r*s + 28*r + 28*s**2 + 42*s + 7) + Ddd*(14*K*(r*(2 - 8*s) + 4*s**2 + 2*s + 1) - 6*f*(4*s**2 - 2*s + 1) + 112*r*s - 28*r - 28*s**2 - 42*s - 7)) + 2*Dd**2*(14*K*(r*(3 - 12*s) + 6*s**2 + 3*s - 2) - 36*f*s**2 + 18*f*s + 42*r*(4*s - 1) - 42*s**2 - 63*s + 28)) + 33*b1**2*(112*C*D1**2*fd*r*s - 48*C*D1**2*fd*s**2 - 112*C*D1**2*fd*s - 56*C*D1**2*fdd*r*s + 24*C*D1**2*fdd*s**2 + 56*C*D1**2*fdd*s + 448*C*D1*Dd*f*r*s - 112*C*D1*Dd*f*r - 192*C*D1*Dd*f*s**2 - 128*C*D1*Dd*f*s - 48*C*D1*Dd*f - 448*C*D1*Dd*fd*r*s + 56*C*D1*Dd*fd*r + 192*C*D1*Dd*fd*s**2 + 288*C*D1*Dd*fd*s - 56*C*D1*Dd*fd - 224*C*D1*Ddd*f*r*s + 56*C*D1*Ddd*f*r + 96*C*D1*Ddd*f*s**2 + 64*C*D1*Ddd*f*s + 24*C*D1*Ddd*f - 672*C*Dd**2*f*r*s + 168*C*Dd**2*f*r + 288*C*Dd**2*f*s**2 + 192*C*Dd**2*f*s - 112*C*Dd**2*f - 28*D1**2*K*fd*r*s + 28*D1**2*K*fd*r + 156*D1**2*K*fd*s**2 - 264*D1**2*K*fd*s + 132*D1**2*K*fd - 106*D1**2*K*fdd*s**2 + 188*D1**2*K*fdd*s - 94*D1**2*K*fdd - D1**2*bdd1*(-14*K*(r*(2 - 6*s) + 3*s**2 + 1) + 6*f*(3*s**2 - 2*s + 1) - 84*r*s + 28*r + 21*s**2 + 14*s + 7) + 96*D1**2*f*fd*r*s + 24*D1**2*f*fd*r + 48*D1**2*f*fd*s - 60*D1**2*f*fd - 96*D1**2*f*fdd*r*s - 24*D1**2*f*fdd*r - 12*D1**2*f*fdd*s + 42*D1**2*f*fdd - 96*D1**2*fd**2*r*s - 24*D1**2*fd**2*r - 12*D1**2*fd**2*s + 24*D1**2*fd**2 - 8*D1**2*fd*r*s - 28*D1**2*fd*r + 36*D1**2*fd*s**2 + 244*D1**2*fd*s - 66*D1**2*fd + 4*D1**2*fdd*r*s - 18*D1**2*fdd*s**2 - 150*D1**2*fdd*s + 47*D1**2*fdd - 112*D1**2*gd2*r*s + 56*D1**2*gd2*s**2 + 112*D1**2*gd2*s + 56*D1**2*gdd2*r*s - 28*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s - 112*D1*Dd*K*f*r*s + 28*D1*Dd*K*f*r + 624*D1*Dd*K*f*s**2 - 256*D1*Dd*K*f*s + 156*D1*Dd*K*f - 848*D1*Dd*K*fd*s**2 + 964*D1*Dd*K*fd*s - 188*D1*Dd*K*fd + 192*D1*Dd*f**2*r*s - 48*D1*Dd*f**2*r - 96*D1*Dd*f**2*s - 768*D1*Dd*f*fd*r*s + 144*D1*Dd*f*fd*s + 60*D1*Dd*f*fd - 32*D1*Dd*f*r*s + 8*D1*Dd*f*r + 144*D1*Dd*f*s**2 - 56*D1*Dd*f*s + 36*D1*Dd*f + 32*D1*Dd*fd*r*s - 4*D1*Dd*fd*r - 144*D1*Dd*fd*s**2 - 572*D1*Dd*fd*s + 150*D1*Dd*fd - 448*D1*Dd*g2*r*s + 112*D1*Dd*g2*r + 224*D1*Dd*g2*s**2 + 112*D1*Dd*g2*s + 56*D1*Dd*g2 + 448*D1*Dd*gd2*r*s - 56*D1*Dd*gd2*r - 224*D1*Dd*gd2*s**2 - 280*D1*Dd*gd2*s + 56*D1*Dd*gd2 - 424*D1*Ddd*K*f*s**2 + 212*D1*Ddd*K*f*s - 106*D1*Ddd*K*f - 192*D1*Ddd*f**2*r*s + 48*D1*Ddd*f**2*r + 96*D1*Ddd*f**2*s + 16*D1*Ddd*f*r*s - 4*D1*Ddd*f*r - 72*D1*Ddd*f*s**2 + 28*D1*Ddd*f*s - 18*D1*Ddd*f + 224*D1*Ddd*g2*r*s - 56*D1*Ddd*g2*r - 112*D1*Ddd*g2*s**2 - 56*D1*Ddd*g2*s - 28*D1*Ddd*g2 + 2*D1*bd1*(D1*(-14*K*(r*(2 - 6*s) + 3*s**2 + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s - 84*r*s + 28*r + 21*s**2 + 14*s + 7) + Dd*(-14*K*(24*r*s - 7*r - 12*s**2 - 3*s + 2) - 6*f*(12*s**2 - 7*s + 1) + 336*r*s - 98*r - 84*s**2 - 91*s + 35)) - 1272*Dd**2*K*f*s**2 + 636*Dd**2*K*f*s - 576*Dd**2*f**2*r*s + 144*Dd**2*f**2*r + 288*Dd**2*f**2*s - 96*Dd**2*f**2 + 48*Dd**2*f*r*s - 12*Dd**2*f*r - 216*Dd**2*f*s**2 + 84*Dd**2*f*s + 8*Dd**2*f + 672*Dd**2*g2*r*s - 168*Dd**2*g2*r - 336*Dd**2*g2*s**2 - 168*Dd**2*g2*s + 112*Dd**2*g2) - 33*b1*(2*D1**2*bd1**2*(14*K*(r*(6*s - 2) - 3*s**2 + 1) + 18*f*s**2 - 12*f*s + r*(28 - 84*s) + 21*s**2 + 14*s - 14) + D1**2*bdd1*(6*f**2*(4*r*(4*s - 3) - 18*s + 7) + f*(8*C*(7*r*(2*s - 1) - 6*s**2 + 6*s - 3) + 4*K*(53*s**2 - 6*s + 3) - 8*r*s + 4*r + 36*s**2 - 182*s + 65) + 28*g2*(r*(2 - 4*s) + 2*s**2 - 2*s + 1)) + 4*D1**2*(f*(2*fd*(2*C*(r*(6*s - 3) - 33*s**2 + 25*s - 14) + 3*K*(2*r*s - r + 10*s**2 - 10*s + 5) - 26*r*s + 3*r + 33*s**2 - 26*s + 21) + fdd*(10*C*(9*s**2 - 8*s + 4) - 3*K*(4*r*s - 2*r + 14*s**2 - 14*s + 7) + 26*r*s - 45*s**2 + 47*s - 30) + s*(gd2*(-14*r + 78*s + 14) + s*(-6*bd2 + 3*bdd2 - 53*gdd2))) + fd**2*(-6*K*(r*(2*s - 1) + s*(7*s - 7)) + s*(10*C*(9*s - 8) + 26*r - 45*s + 47)) - 2*fd*(g2*(7*r*(s - 1) - 39*s**2 + 66*s - 33) + s*(-3*bd2*s + gd2*(53*s - 47))) + fdd*g2*(-53*s**2 + 94*s - 47)) - 2*D1*bd1*(D1*(6*f**2*(r*(8*s - 6) - 12*s + 5) + f*(8*C*(7*r*(2*s - 1) - 6*s**2 + 6*s - 3) - 28*K*r*s + 156*K*s**2 - 10*K*s + 12*K - 12*fd*(16*r*s - 4*r - 8*s + 3) - 8*r*s + 18*r + 36*s**2 - 154*s + 51) + fd*(4*C*(r*(7 - 28*s) + 12*s**2 + 8*s - 7) - 212*K*s**2 + 200*K*s + r*(8*s - 2) - 36*s**2 - 59*s + 28) - 28*g2*(r*(4*s - 2) - 2*s**2 + 2*s - 1) - 28*gd2*(-4*r*s + r + 2*s**2 + s - 1)) - Dd*(6*f**2*(32*r*(2*s - 1) - 52*s + 21) + f*(8*C*(7*r*(8*s - 3) - 24*s**2 + 4*s + 4) + 4*K*(212*s**2 - 65*s + 3) - 32*r*s + 12*r + 144*s**2 - 392*s + 87) + 28*g2*(r*(6 - 16*s) + 8*s**2 - 2*s - 1))) - 2*D1*(-2*Dd*(f**2*(6*C*(r*(8*s - 2) - 44*s**2 + 18*s - 11) + 6*K*(4*r*s - r + 20*s**2 - 12*s + 5) - 104*r*s + 26*r + 132*s**2 - 14*s + 33) + f*(fd*(20*C*(36*s**2 - 25*s + 4) - 6*K*(16*r*s - 6*r + 56*s**2 - 46*s + 9) + 208*r*s - 26*r - 360*s**2 + 226*s - 47) + 2*g2*(r*(7 - 28*s) + 156*s**2 - 64*s + 39) + 2*s*(3*bd2 - 53*gd2)*(4*s - 1)) - 2*fd*g2*(212*s**2 - 241*s + 47)) + Ddd*f*(f*(-90*C*(4*s**2 - 2*s + 1) + 6*K*(8*r*s - 2*r + 28*s**2 - 18*s + 7) - 104*r*s + 26*r + 180*s**2 - 38*s + 45) + 106*g2*(4*s**2 - 2*s + 1))) - 4*Dd**2*f*(f*(-540*C*s**2 + 270*C*s + 6*K*(12*r*s - 3*r + 42*s**2 - 27*s + 2) - 156*r*s + 39*r + 270*s**2 - 57*s - 26) + 318*g2*s*(2*s - 1)) - 12*b2*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))) + 396*b2*(-D1**2*bdd1*f*(s - 1)**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 20*D1**2*f*fd*s - 10*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r + 14*D1**2*f*fdd*s**2 - 14*D1**2*f*fdd*s + 7*D1**2*f*fdd + 4*D1**2*fd**2*r*s - 2*D1**2*fd**2*r + 14*D1**2*fd**2*s**2 - 14*D1**2*fd**2*s - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 112*D1*Dd*f*fd*s**2 - 92*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 28*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 84*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 4*Dd**2*f**2))/(693*d**2*k3**2) + 3*D1**2*Pk3*Pkd2*ct**3*k1*st**2*(-D1*f*s*(2*D1*bd1**2*s*(5*f + 3) - 6*D1*bd1*(f*s - 2*fd*s + fd) + 3*D1*bdd1*f*s + 6*Dd*bd1*f*(4*s - 1)) + b1**2*(D1**2*(10*f*fd*(2*s**2 - 2*s + 1) - 5*f*fdd*(2*s**2 - 2*s + 1) - 10*fd**2*s*(s - 1) + 6*fd*(s - 1)**2 - 3*fdd*(s - 1)**2) + D1*(2*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(-5*fd*(8*s**2 - 6*s + 1) + 12*s**2 - 6*s + 3) - 3*fd*(4*s**2 - 5*s + 1)) - Ddd*f*(5*f + 3)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(5*f + 3)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) + f*fd*(s**2*(12 - 40*bd1) + s*(20*bd1 - 12) + 6) - 3*f*(fdd*(2*s**2 - 2*s + 1) + s**2*(-4*bd1 + 2*bdd1)) - 6*fd*s*(2*bd1 + fd)*(s - 1)) + D1*f*(-2*Dd*(f*(s**2*(40*bd1 - 12) + s*(6 - 10*bd1) - 3) + (12*s - 3)*(2*bd1*s + fd*(2*s - 1))) - 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(1 - 2*s)))/(7*d**2*k2**2) + D1**2*Pk3*Pkd2*ct**3*k1*(2*D1*f*s*(D1*bd1**2*(s*(42*f + 17) + 30) + 20*D1*bdd1*f*s + 40*bd1*(-D1*(f*s - 2*fd*s + fd) + Dd*f*(4*s - 1))) + 5*b1**3*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(6*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 28) + s*(6*fd - 14) + 7) - D1*Ddd*(6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(6*f + 7)*(2*s - 1)) + b1**2*(-5*D1**2*bdd1*(6*f + 7)*(3*s**2 - 2*s + 1) - 168*D1**2*f*fd*s**2 + 168*D1**2*f*fd*s - 84*D1**2*f*fd + 84*D1**2*f*fdd*s**2 - 84*D1**2*f*fdd*s + 42*D1**2*f*fdd + 84*D1**2*fd**2*s**2 - 84*D1**2*fd**2*s - 34*D1**2*fd*s**2 + 188*D1**2*fd*s - 94*D1**2*fd + 17*D1**2*fdd*s**2 - 94*D1**2*fdd*s + 47*D1**2*fdd - 336*D1*Dd*f**2*s**2 + 168*D1*Dd*f**2*s - 84*D1*Dd*f**2 + 672*D1*Dd*f*fd*s**2 - 504*D1*Dd*f*fd*s + 84*D1*Dd*f*fd - 136*D1*Dd*f*s**2 + 68*D1*Dd*f*s - 34*D1*Dd*f + 136*D1*Dd*fd*s**2 - 410*D1*Dd*fd*s + 94*D1*Dd*fd + 168*D1*Ddd*f**2*s**2 - 84*D1*Ddd*f**2*s + 42*D1*Ddd*f**2 + 68*D1*Ddd*f*s**2 - 34*D1*Ddd*f*s + 17*D1*Ddd*f + 10*D1*bd1*(D1*(6*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 21) + s*(6*fd - 14) + 7) - Dd*(6*f + 7)*(12*s**2 - 7*s + 1)) + 504*Dd**2*f**2*s**2 - 252*Dd**2*f**2*s + 204*Dd**2*f*s**2 - 102*Dd**2*f*s) - 2*b1*(5*D1**2*bd1**2*s*(6*f + 7)*(3*s - 2) - D1**2*bdd1*f*(s**2*(42*f + 17) + 30*s - 15) + 20*D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + 2*D1*bd1*(D1*(42*f**2*s**2 + f*(s**2*(17 - 84*fd) + s*(42*fd + 30) - 15) + fd*s*(32 - 17*s)) - Dd*f*(4*s - 1)*(s*(42*f + 17) + 15)) + 20*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 120*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2**2) - D1**2*Pk3*Pkd2*ct**3*k2**4*(8*C - 4)*(-D1**2*bdd1*f**2*r*(s - 1) + D1*bd1*f*(2*D1*f*r*(s - 1) + D1*fd*(r*(2 - 4*s) + s - 1) + Dd*f*(-8*r*s + 5*r + 2*s - 2)) + b1*(D1*Dd*f*(2*f*r*(4*s - 1) - 4*f*s - fd*(2*r - 1)*(8*s - 1)) + D1*(D1*s*(2*r - 1)*(2*f*fd - f*fdd - fd**2) + Ddd*f**2*(-4*r*s + r + 2*s)) + Dd**2*f**2*(r*(3 - 12*s) + 6*s - 2)))/(21*d**2*k1*k3**4) + D1**2*Pk3*Pkd2*ct**3*(8*C - 4)*(D1*f*(-D1*bdd1*f*r*s + bd1*(2*D1*f*r*s + D1*fd*(-4*r*s + r + s) + Dd*f*(-8*r*s + r + 2*s))) + b1*(D1*Dd*f*(2*f*r*(4*s - 1) - 4*f*s - fd*(2*r - 1)*(8*s - 3)) + D1*(D1*(2*f*fd*(2*r*s - r - s) + f*fdd*(-2*r*s + r + s) + fd**2*(-2*r*s + r + s - 1)) + Ddd*f**2*(-4*r*s + r + 2*s)) + Dd**2*f**2*(r*(3 - 12*s) + 6*s - 2)))/(21*d**2*k1) + 20*D1**2*Pk3*Pkd2*ct**2*f**2*k1**6*st**2*(D1**2*(f*(131*fd - 98*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 98*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(131*f*(r*(4*s - 1) + (1 - 2*s)**2) - 196*fd*(4*s - 1)*(4*r + 4*s - 3)) - 98*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 98*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k2*k3**6) + 40*D1**2*Pk3*Pkd2*ct**2*f*k1**6*(-28*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(23*f*(s - 1)*(r + s - 1) - 28*fd*(6*r*s - 3*r + 6*s**2 - 8*s + 2)) - 28*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + b1*(D1**2*s*(3*r + 3*s - 2)*(23*f*fd - 28*f*fdd - 56*fd**2) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 28*fd*(3*r*(8*s - 1) + 24*s**2 - 20*s + 2)) - 28*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 28*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k2*k3**6) + 8*D1**2*Pk3*Pkd2*ct**2*f*k1**4*k2*st**4*(D1**2*(5*f**2*(107*fd - 60*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(150*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - fd*(26*C - 26)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(13*C - 13)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(26*C - 26)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(535*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 4*f*(13*C*(r*(4*s - 1) + (1 - 2*s)**2) - 150*fd*(4*s - 1)*(4*r + 4*s - 3) - 13*r*(4*s - 1) - 13*(1 - 2*s)**2) - fd*(26*C - 26)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(13*C + 150*f - 13)) - 2*Dd**2*f**2*(13*C + 150*f - 13)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1001*d**2*k3**6) + 6*D1**2*Pk3*Pkd2*ct**2*f*k1**4*st**4*(D1**2*(225*f**2*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f*(-1350*fd**2*s*(2*s - 1) + fd*(26*C - 26)*(3*s**2 - 2*s + 1) - fdd*(13*C - 13)*(3*s**2 - 2*s + 1)) + fd**2*s*(26 - 26*C)*(3*s - 2)) + D1*f*(2*Dd*(225*f**2*(4*s**2 - 2*s + 1) + f*(13*C*(4*s**2 - 2*s + 1) - 225*fd*(1 - 4*s)**2 - 52*s**2 + 26*s - 13) - fd*(13*C - 13)*(12*s**2 - 7*s + 1)) - Ddd*f*(13*C + 225*f - 13)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(13*C + 225*f - 13))/(1001*d**2*k2*k3**4) + D1**2*Pk3*Pkd2*ct**2*f*k2**5*st**4*(80*C - 40)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(77*d**2*k3**6) - 5*D1**2*Pk3*Pkd2*ct**2*f*k2**3*st**4*(D1**2*(f*(2*fd - fdd)*(2*C*(16*r*(3*s - 1) + 27*s**2 - 34*s + 9) + (3*s - 1)*(-18*r - 9*s + 9)) - 2*fd**2*(2*C*(16*r*(3*s - 1) + 27*s**2 - 34*s + 8) + (3*s - 1)*(-18*r - 9*s + 9))) + D1*f*(2*Dd*(2*C*f*(16*r*(4*s - 1) + 36*s**2 - 50*s + 9) - 2*C*fd*(8*r*(24*s - 7) + 108*s**2 - 143*s + 33) - 9*f*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + 9*fd*(r*(24*s - 7) + 12*s**2 - 17*s + 4)) + Ddd*f*(-2*C*(64*r*s - 16*r + 36*s**2 - 50*s + 9) + 72*r*s - 18*r + 36*s**2 - 54*s + 9)) + 2*Dd**2*f**2*(-2*C*(24*r*(4*s - 1) + 54*s**2 - 75*s + 16) + 27*r*(4*s - 1) + 54*s**2 - 81*s + 18))/(231*d**2*k3**4) - 5*D1**2*Pk3*Pkd2*ct**2*f*k2*st**4*(D1**2*(f*(2*fd - fdd)*(30*C*(3*s**2 - 2*s + 1) + r*(6*s - 2) - 45*s**2 + 28*s - 15) - 2*fd**2*(r*(6*s - 2) + s**2*(90*C - 45) + s*(28 - 60*C) + 1)) + D1*f*(2*Dd*(f*(30*C*(4*s**2 - 2*s + 1) + 8*r*s - 2*r - 60*s**2 + 26*s - 15) + fd*(-30*C*(12*s**2 - 7*s + 1) - 24*r*s + 7*r + 180*s**2 - 95*s + 12)) + Ddd*f*(-30*C*(4*s**2 - 2*s + 1) - 8*r*s + 2*r + 60*s**2 - 26*s + 15)) - 2*Dd**2*f**2*(3*r*(4*s - 1) + s**2*(180*C - 90) + s*(39 - 90*C) + 2))/(231*d**2*k3**2) - 4*D1**2*Pk3*Pkd2*ct**2*k1**4*k2*st**2*(66*C*D1**2*bdd1*f**2*r*s - 66*C*D1**2*bdd1*f**2*r + 66*C*D1**2*bdd1*f**2*s**2 - 132*C*D1**2*bdd1*f**2*s + 66*C*D1**2*bdd1*f**2 - 402*C*D1**2*f**2*fd*r*s + 134*C*D1**2*f**2*fd*r - 402*C*D1**2*f**2*fd*s**2 + 402*C*D1**2*f**2*fd*s - 134*C*D1**2*f**2*fd + 300*C*D1**2*f**2*fdd*r*s - 100*C*D1**2*f**2*fdd*r + 300*C*D1**2*f**2*fdd*s**2 - 300*C*D1**2*f**2*fdd*s + 100*C*D1**2*f**2*fdd + 600*C*D1**2*f*fd**2*r*s - 200*C*D1**2*f*fd**2*r + 600*C*D1**2*f*fd**2*s**2 - 600*C*D1**2*f*fd**2*s + 100*C*D1**2*f*fd**2 - 536*C*D1*Dd*f**3*r*s + 134*C*D1*Dd*f**3*r - 536*C*D1*Dd*f**3*s**2 + 536*C*D1*Dd*f**3*s - 134*C*D1*Dd*f**3 + 2400*C*D1*Dd*f**2*fd*r*s - 700*C*D1*Dd*f**2*fd*r + 2400*C*D1*Dd*f**2*fd*s**2 - 2400*C*D1*Dd*f**2*fd*s + 500*C*D1*Dd*f**2*fd + 400*C*D1*Ddd*f**3*r*s - 100*C*D1*Ddd*f**3*r + 400*C*D1*Ddd*f**3*s**2 - 400*C*D1*Ddd*f**3*s + 100*C*D1*Ddd*f**3 + 1200*C*Dd**2*f**3*r*s - 300*C*Dd**2*f**3*r + 1200*C*Dd**2*f**3*s**2 - 1200*C*Dd**2*f**3*s + 200*C*Dd**2*f**3 + 66*D1**2*K*bdd1*f**2*r*s + 66*D1**2*K*bdd1*f**2*s**2 - 66*D1**2*K*bdd1*f**2*s + 33*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 100*D1**2*bdd1*f**3*r*s - 300*D1**2*bdd1*f**3*r + 100*D1**2*bdd1*f**3*s**2 - 400*D1**2*bdd1*f**3*s + 300*D1**2*bdd1*f**3 - 99*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r - 99*D1**2*bdd1*f**2*s**2 + 165*D1**2*bdd1*f**2*s - 66*D1**2*bdd1*f**2 - 66*D1**2*bdd1*f*g2*r*s + 66*D1**2*bdd1*f*g2*r - 66*D1**2*bdd1*f*g2*s**2 + 132*D1**2*bdd1*f*g2*s - 66*D1**2*bdd1*f*g2 + 600*D1**2*f**3*fd*r*s - 150*D1**2*f**3*fd*r + 600*D1**2*f**3*fd*s**2 - 600*D1**2*f**3*fd*s + 150*D1**2*f**3*fd + 285*D1**2*f**2*fd*r*s - 95*D1**2*f**2*fd*r + 285*D1**2*f**2*fd*s**2 - 285*D1**2*f**2*fd*s + 95*D1**2*f**2*fd - 225*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 225*D1**2*f**2*fdd*s - 75*D1**2*f**2*fdd + 198*D1**2*f**2*gd2*r*s + 198*D1**2*f**2*gd2*s**2 - 198*D1**2*f**2*gd2*s - 132*D1**2*f**2*gdd2*r*s - 132*D1**2*f**2*gdd2*s**2 + 132*D1**2*f**2*gdd2*s - 450*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 450*D1**2*f*fd**2*s - 75*D1**2*f*fd**2 + 396*D1**2*f*fd*g2*r*s - 198*D1**2*f*fd*g2*r + 396*D1**2*f*fd*g2*s**2 - 396*D1**2*f*fd*g2*s + 198*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r*s + 132*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 528*D1**2*f*fd*gd2*s - 132*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r*s + 132*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r*s + 132*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s + 600*D1*Dd*f**4*r*s - 150*D1*Dd*f**4*r + 600*D1*Dd*f**4*s**2 - 600*D1*Dd*f**4*s + 150*D1*Dd*f**4 + 380*D1*Dd*f**3*r*s - 95*D1*Dd*f**3*r + 380*D1*Dd*f**3*s**2 - 380*D1*Dd*f**3*s + 95*D1*Dd*f**3 - 1800*D1*Dd*f**2*fd*r*s + 525*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 1800*D1*Dd*f**2*fd*s - 375*D1*Dd*f**2*fd + 792*D1*Dd*f**2*g2*r*s - 198*D1*Dd*f**2*g2*r + 792*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 198*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r*s + 132*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1056*D1*Dd*f**2*gd2*s - 132*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r*s + 792*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2112*D1*Dd*f*fd*g2*s - 528*D1*Dd*f*fd*g2 - 300*D1*Ddd*f**3*r*s + 75*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 300*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r*s + 132*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 528*D1*Ddd*f**2*g2*s - 132*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-f**3*(200*s - 501)*(r + s - 1) + f**2*(-132*C*(s - 1)*(r + s - 1) + 100*fd*(6*r*s - 7*r + 6*s**2 - 12*s + 4) - (11*r + 11*s - 11)*(9*K*s - 16*s + 12)) + 33*f*(fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 5*r - 12*s**2 + 14*s - 3) + (2*r + 2*s - 2)*(2*g2*(s - 1) - 2*gd2*s + gd2)) - 66*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(100*f**2*(r*(8*s - 13) + 8*s**2 - 20*s + 10) + 33*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 11*r - 24*s**2 + 32*s - 9) - 66*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 900*Dd**2*f**3*r*s + 225*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 900*Dd**2*f**3*s - 150*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r*s + 396*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 1584*Dd**2*f**2*g2*s - 264*Dd**2*f**2*g2 - 33*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(-264*C*D1**2*f*fd*r*s - 264*C*D1**2*f*fd*s**2 + 132*C*D1**2*f*fd*s + 132*C*D1**2*f*fdd*r*s + 132*C*D1**2*f*fdd*s**2 - 66*C*D1**2*f*fdd*s + 132*C*D1**2*fd**2*r*s + 132*C*D1**2*fd**2*s**2 - 66*C*D1**2*fd**2*s - 528*C*D1*Dd*f**2*r*s + 132*C*D1*Dd*f**2*r - 528*C*D1*Dd*f**2*s**2 + 528*C*D1*Dd*f**2*s - 132*C*D1*Dd*f**2 + 1056*C*D1*Dd*f*fd*r*s - 132*C*D1*Dd*f*fd*r + 1056*C*D1*Dd*f*fd*s**2 - 792*C*D1*Dd*f*fd*s + 66*C*D1*Dd*f*fd + 264*C*D1*Ddd*f**2*r*s - 66*C*D1*Ddd*f**2*r + 264*C*D1*Ddd*f**2*s**2 - 264*C*D1*Ddd*f**2*s + 66*C*D1*Ddd*f**2 + 792*C*Dd**2*f**2*r*s - 198*C*Dd**2*f**2*r + 792*C*Dd**2*f**2*s**2 - 792*C*Dd**2*f**2*s + 132*C*Dd**2*f**2 - 198*D1**2*K*f*fd*r*s + 99*D1**2*K*f*fd*r - 198*D1**2*K*f*fd*s**2 + 198*D1**2*K*f*fd*s - 99*D1**2*K*f*fd + 132*D1**2*K*f*fdd*r*s - 66*D1**2*K*f*fdd*r + 132*D1**2*K*f*fdd*s**2 - 132*D1**2*K*f*fdd*s + 66*D1**2*K*f*fdd + 132*D1**2*K*fd**2*r*s - 66*D1**2*K*fd**2*r + 132*D1**2*K*fd**2*s**2 - 132*D1**2*K*fd**2*s + 33*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 600*D1**2*f**2*fd*r*s - 301*D1**2*f**2*fd*r - 600*D1**2*f**2*fd*s**2 + 99*D1**2*f**2*fd*s + 301*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r*s + 200*D1**2*f**2*fdd*r + 300*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd + 600*D1**2*f*fd**2*r*s + 400*D1**2*f*fd**2*r + 600*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2 + 352*D1**2*f*fd*r*s - 44*D1**2*f*fd*r + 352*D1**2*f*fd*s**2 - 220*D1**2*f*fd*s + 44*D1**2*f*fd - 198*D1**2*f*fdd*r*s + 33*D1**2*f*fdd*r - 198*D1**2*f*fdd*s**2 + 132*D1**2*f*fdd*s - 33*D1**2*f*fdd + 132*D1**2*f*gd2*r*s + 132*D1**2*f*gd2*s**2 - 132*D1**2*f*gd2*s - 66*D1**2*f*gdd2*r*s - 66*D1**2*f*gdd2*s**2 + 66*D1**2*f*gdd2*s - 198*D1**2*fd**2*r*s + 33*D1**2*fd**2*r - 198*D1**2*fd**2*s**2 + 132*D1**2*fd**2*s + 132*D1**2*fd*g2*r*s + 132*D1**2*fd*g2*s**2 - 132*D1**2*fd*gd2*r*s - 132*D1**2*fd*gd2*s**2 + 66*D1**2*fd*gd2*s - 66*D1**2*fdd*g2*r*s - 66*D1**2*fdd*g2*s**2 - 396*D1*Dd*K*f**2*r*s + 99*D1*Dd*K*f**2*r - 396*D1*Dd*K*f**2*s**2 + 396*D1*Dd*K*f**2*s - 99*D1*Dd*K*f**2 + 1056*D1*Dd*K*f*fd*r*s - 396*D1*Dd*K*f*fd*r + 1056*D1*Dd*K*f*fd*s**2 - 1056*D1*Dd*K*f*fd*s + 264*D1*Dd*K*f*fd - 800*D1*Dd*f**3*r*s + 200*D1*Dd*f**3*r - 800*D1*Dd*f**3*s**2 + 800*D1*Dd*f**3*s - 200*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r*s + 500*D1*Dd*f**2*fd*r + 2400*D1*Dd*f**2*fd*s**2 - 1200*D1*Dd*f**2*fd*s - 400*D1*Dd*f**2*fd + 704*D1*Dd*f**2*r*s - 176*D1*Dd*f**2*r + 704*D1*Dd*f**2*s**2 - 704*D1*Dd*f**2*s + 176*D1*Dd*f**2 - 1584*D1*Dd*f*fd*r*s + 330*D1*Dd*f*fd*r - 1584*D1*Dd*f*fd*s**2 + 1320*D1*Dd*f*fd*s - 198*D1*Dd*f*fd + 528*D1*Dd*f*g2*r*s - 132*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s**2 - 528*D1*Dd*f*g2*s + 132*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r*s + 66*D1*Dd*f*gd2*r - 528*D1*Dd*f*gd2*s**2 + 528*D1*Dd*f*gd2*s - 66*D1*Dd*f*gd2 - 528*D1*Dd*fd*g2*r*s + 66*D1*Dd*fd*g2*r - 528*D1*Dd*fd*g2*s**2 + 264*D1*Dd*fd*g2*s + 264*D1*Ddd*K*f**2*r*s - 66*D1*Ddd*K*f**2*r + 264*D1*Ddd*K*f**2*s**2 - 264*D1*Ddd*K*f**2*s + 66*D1*Ddd*K*f**2 + 400*D1*Ddd*f**3*r*s - 100*D1*Ddd*f**3*r + 400*D1*Ddd*f**3*s**2 - 400*D1*Ddd*f**3*s + 100*D1*Ddd*f**3 - 396*D1*Ddd*f**2*r*s + 99*D1*Ddd*f**2*r - 396*D1*Ddd*f**2*s**2 + 396*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 - 264*D1*Ddd*f*g2*r*s + 66*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2*s**2 + 264*D1*Ddd*f*g2*s - 66*D1*Ddd*f*g2 - 33*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) + 792*Dd**2*K*f**2*r*s - 198*Dd**2*K*f**2*r + 792*Dd**2*K*f**2*s**2 - 792*Dd**2*K*f**2*s + 132*Dd**2*K*f**2 + 1200*Dd**2*f**3*r*s - 300*Dd**2*f**3*r + 1200*Dd**2*f**3*s**2 - 1200*Dd**2*f**3*s + 200*Dd**2*f**3 - 1188*Dd**2*f**2*r*s + 297*Dd**2*f**2*r - 1188*Dd**2*f**2*s**2 + 1188*Dd**2*f**2*s - 198*Dd**2*f**2 - 792*Dd**2*f*g2*r*s + 198*Dd**2*f*g2*r - 792*Dd**2*f*g2*s**2 + 792*Dd**2*f*g2*s - 132*Dd**2*f*g2))/(231*d**2*k3**6) - 8*D1**2*Pk3*Pkd2*ct**2*k1**4*k2*(-D1*(2*D1*bd1**2*f*(2*s - 1)*(-6*K + 10*f + 3)*(r + s - 1) - D1*bdd1*f*(s - 1)*(f*(20*C - 15) - 24*g2)*(r + s - 1) + bd1*(4*C*f*(D1*(f*(s - 1)*(r + s - 1) - 5*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + D1*(-5*f**3*(2*s - 3)*(r + s - 1) + 3*f*(5*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*r + 2*s - 2)*(-g2*s + g2 + 8*gd2*s - 4*gd2)) + 24*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 3*Dd*f*(5*f + 8*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + b1**2*(-D1**2*s*(-2*f*(11*fd - 10*fdd)*(2*r + 2*s - 1) + 20*fd**2*(2*r + 2*s - 1) + fd*(3*K + 2)*(r + s) - 6*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(22*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(20*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (3*K + 2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-6*K + 10*f + 3)) - 2*Dd**2*f*(-6*K + 10*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-8*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*s**2 + 4*C*D1**2*f*fd*s + 40*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 40*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 16*C*D1*Dd*f**2*r*s + 4*C*D1*Dd*f**2*r - 16*C*D1*Dd*f**2*s**2 + 16*C*D1*Dd*f**2*s - 4*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 40*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(2*s - 1)*(-6*K + 10*f + 3)*(r + s - 1) + 30*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd - 30*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*s**2 + 15*D1**2*f*fdd*s + 6*D1**2*f*gd2*r*s + 6*D1**2*f*gd2*s**2 - 6*D1**2*f*gd2*s - 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 30*D1**2*fd**2*r*s - 30*D1**2*fd**2*s**2 + 15*D1**2*fd**2*s + 6*D1**2*fd*g2*r*s + 6*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r*s - 48*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 + 40*D1*Dd*f**3*r*s - 10*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 40*D1*Dd*f**3*s + 10*D1*Dd*f**3 - 240*D1*Dd*f*fd*r*s + 30*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 15*D1*Dd*f*fd + 24*D1*Dd*f*g2*r*s - 6*D1*Dd*f*g2*r + 24*D1*Dd*f*g2*s**2 - 24*D1*Dd*f*g2*s + 6*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r*s + 24*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 192*D1*Dd*f*gd2*s - 24*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r*s + 24*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 96*D1*Dd*fd*g2*s - 60*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 96*D1*Ddd*f*g2*s - 24*D1*Ddd*f*g2 + D1*bd1*(D1*(22*f**2*(2*s - 1)*(r + s - 1) - f*(20*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (3*K + 2)*(2*s - 1)*(r + s - 1)) + 6*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 2*Dd*f*(-6*K + 10*f + 3)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 180*Dd**2*f**2*r*s + 45*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 30*Dd**2*f**2 - 288*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 288*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(21*d**2*k3**6) - D1**2*Pk3*Pkd2*ct**2*k1**4*st**2*(110*C*D1**2*bdd1*f**2*s**2 - 220*C*D1**2*bdd1*f**2*s + 110*C*D1**2*bdd1*f**2 + 1728*C*D1**2*f**2*fd*s**2 - 1152*C*D1**2*f**2*fd*s + 576*C*D1**2*f**2*fd - 930*C*D1**2*f**2*fdd*s**2 + 620*C*D1**2*f**2*fdd*s - 310*C*D1**2*f**2*fdd - 1860*C*D1**2*f*fd**2*s**2 + 1240*C*D1**2*f*fd**2*s + 2304*C*D1*Dd*f**3*s**2 - 1152*C*D1*Dd*f**3*s + 576*C*D1*Dd*f**3 - 7440*C*D1*Dd*f**2*fd*s**2 + 4340*C*D1*Dd*f**2*fd*s - 620*C*D1*Dd*f**2*fd - 1240*C*D1*Ddd*f**3*s**2 + 620*C*D1*Ddd*f**3*s - 310*C*D1*Ddd*f**3 - 3720*C*Dd**2*f**3*s**2 + 1860*C*Dd**2*f**3*s - 187*D1**2*K*bdd1*f**2*s**2 + 110*D1**2*bd1**2*f*s*(K - 1)*(s - 1) + 400*D1**2*bdd1*f**3*r*s + 900*D1**2*bdd1*f**3*s**2 - 1700*D1**2*bdd1*f**3*s + 750*D1**2*bdd1*f**3 + 132*D1**2*bdd1*f**2*r*s + 209*D1**2*bdd1*f**2*s**2 + 88*D1**2*bdd1*f**2*s - 110*D1**2*bdd1*f**2 - 110*D1**2*bdd1*f*g2*s**2 + 220*D1**2*bdd1*f*g2*s - 110*D1**2*bdd1*f*g2 + 2000*D1**2*f**3*fd*r*s - 500*D1**2*f**3*fd*r + 9600*D1**2*f**3*fd*s**2 - 5800*D1**2*f**3*fd*s + 2400*D1**2*f**3*fd - 2000*D1**2*f**3*fdd*r*s + 500*D1**2*f**3*fdd*r - 5400*D1**2*f**3*fdd*s**2 + 3700*D1**2*f**3*fdd*s - 1350*D1**2*f**3*fdd - 6000*D1**2*f**2*fd**2*r*s + 1500*D1**2*f**2*fd**2*r - 16200*D1**2*f**2*fd**2*s**2 + 11100*D1**2*f**2*fd**2*s - 1000*D1**2*f**2*fd**2 - 468*D1**2*f**2*fd*r*s + 156*D1**2*f**2*fd*r - 2196*D1**2*f**2*fd*s**2 + 1620*D1**2*f**2*fd*s - 732*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r*s - 100*D1**2*f**2*fdd*r + 1230*D1**2*f**2*fdd*s**2 - 920*D1**2*f**2*fdd*s + 410*D1**2*f**2*fdd - 704*D1**2*f**2*gd2*s**2 + 374*D1**2*f**2*gdd2*s**2 + 600*D1**2*f*fd**2*r*s - 200*D1**2*f*fd**2*r + 2460*D1**2*f*fd**2*s**2 - 1840*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 - 1408*D1**2*f*fd*g2*s**2 + 1408*D1**2*f*fd*g2*s - 704*D1**2*f*fd*g2 + 1496*D1**2*f*fd*gd2*s**2 - 748*D1**2*f*fd*gd2*s + 748*D1**2*f*fdd*g2*s**2 - 748*D1**2*f*fdd*g2*s + 374*D1**2*f*fdd*g2 + 748*D1**2*fd**2*g2*s**2 - 748*D1**2*fd**2*g2*s + 2000*D1*Dd*f**4*r*s - 500*D1*Dd*f**4*r + 9600*D1*Dd*f**4*s**2 - 5800*D1*Dd*f**4*s + 2400*D1*Dd*f**4 - 16000*D1*Dd*f**3*fd*r*s + 4000*D1*Dd*f**3*fd*r - 43200*D1*Dd*f**3*fd*s**2 + 29600*D1*Dd*f**3*fd*s - 4700*D1*Dd*f**3*fd - 624*D1*Dd*f**3*r*s + 156*D1*Dd*f**3*r - 2928*D1*Dd*f**3*s**2 + 1776*D1*Dd*f**3*s - 732*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r*s - 700*D1*Dd*f**2*fd*r + 9840*D1*Dd*f**2*fd*s**2 - 6740*D1*Dd*f**2*fd*s + 1120*D1*Dd*f**2*fd - 2816*D1*Dd*f**2*g2*s**2 + 1408*D1*Dd*f**2*g2*s - 704*D1*Dd*f**2*g2 + 2992*D1*Dd*f**2*gd2*s**2 - 748*D1*Dd*f**2*gd2*s + 5984*D1*Dd*f*fd*g2*s**2 - 4488*D1*Dd*f*fd*g2*s + 748*D1*Dd*f*fd*g2 - 2000*D1*Ddd*f**4*r*s + 500*D1*Ddd*f**4*r - 5400*D1*Ddd*f**4*s**2 + 3700*D1*Ddd*f**4*s - 1350*D1*Ddd*f**4 + 400*D1*Ddd*f**3*r*s - 100*D1*Ddd*f**3*r + 1640*D1*Ddd*f**3*s**2 - 1020*D1*Ddd*f**3*s + 410*D1*Ddd*f**3 + 1496*D1*Ddd*f**2*g2*s**2 - 748*D1*Ddd*f**2*g2*s + 374*D1*Ddd*f**2*g2 - 2*D1*bd1*(D1*(2*f**3*(384*s**2 + s*(134*r - 817) + 375) + 2*f**2*(55*C*(s - 1)**2 - 50*fd*(2*r*(6*s - 1) + 27*s**2 - 30*s + 1) - 11*s**2*(8*K - 8) + 11*s*(5*r + 5) - 55) - 11*f*(fd*(6*r*(4*s - 1) + s**2*(20*C - 34*K + 38) + s*(-20*C + 17*K - 21) + 6) + (10*s - 10)*(g2*(s - 1) - gd2*s)) + 110*fd*g2*s*(s - 1)) + Dd*f*(-50*f**2*(4*r*(8*s - 1) + 72*s**2 - 94*s + 17) - 11*f*(10*C*(4*s**2 - 5*s + 1) - 68*K*s**2 + 17*K*s + 48*r*s - 6*r + 76*s**2 - 15*s - 4) + 110*g2*(4*s**2 - 5*s + 1))) - 6000*Dd**2*f**4*r*s + 1500*Dd**2*f**4*r - 16200*Dd**2*f**4*s**2 + 11100*Dd**2*f**4*s - 1000*Dd**2*f**4 + 1200*Dd**2*f**3*r*s - 300*Dd**2*f**3*r + 4920*Dd**2*f**3*s**2 - 3060*Dd**2*f**3*s + 200*Dd**2*f**3 + 4488*Dd**2*f**2*g2*s**2 - 2244*Dd**2*f**2*g2*s - 55*b1**2*(K - 1)*(D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(-440*C*D1**2*f*fd*s**2 + 220*C*D1**2*f*fdd*s**2 + 220*C*D1**2*fd**2*s**2 - 880*C*D1*Dd*f**2*s**2 + 440*C*D1*Dd*f**2*s - 220*C*D1*Dd*f**2 + 1760*C*D1*Dd*f*fd*s**2 - 440*C*D1*Dd*f*fd*s + 440*C*D1*Ddd*f**2*s**2 - 220*C*D1*Ddd*f**2*s + 110*C*D1*Ddd*f**2 + 1320*C*Dd**2*f**2*s**2 - 660*C*Dd**2*f**2*s + 704*D1**2*K*f*fd*s**2 - 704*D1**2*K*f*fd*s + 352*D1**2*K*f*fd - 374*D1**2*K*f*fdd*s**2 + 374*D1**2*K*f*fdd*s - 187*D1**2*K*f*fdd - 374*D1**2*K*fd**2*s**2 + 374*D1**2*K*fd**2*s + 55*D1**2*bdd1*f*(K - 1)*(2*s**2 - 2*s + 1) - 1608*D1**2*f**2*fd*r*s + 536*D1**2*f**2*fd*r - 4608*D1**2*f**2*fd*s**2 + 876*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 1200*D1**2*f**2*fdd*r*s - 400*D1**2*f**2*fdd*r + 2700*D1**2*f**2*fdd*s**2 - 900*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd + 2400*D1**2*f*fd**2*r*s - 800*D1**2*f*fd**2*r + 5400*D1**2*f*fd**2*s**2 - 1800*D1**2*f*fd**2*s + 600*D1**2*f*fd**2 - 440*D1**2*f*fd*r*s + 220*D1**2*f*fd*r - 704*D1**2*f*fd*s**2 + 1144*D1**2*f*fd*s - 572*D1**2*f*fd + 264*D1**2*f*fdd*r*s - 132*D1**2*f*fdd*r + 418*D1**2*f*fdd*s**2 - 638*D1**2*f*fdd*s + 319*D1**2*f*fdd + 220*D1**2*f*gd2*s**2 - 110*D1**2*f*gdd2*s**2 + 264*D1**2*fd**2*r*s - 132*D1**2*fd**2*r + 418*D1**2*fd**2*s**2 - 638*D1**2*fd**2*s + 220*D1**2*fd*g2*s**2 - 220*D1**2*fd*gd2*s**2 - 110*D1**2*fdd*g2*s**2 + 1408*D1*Dd*K*f**2*s**2 - 704*D1*Dd*K*f**2*s + 352*D1*Dd*K*f**2 - 2992*D1*Dd*K*f*fd*s**2 + 2244*D1*Dd*K*f*fd*s - 374*D1*Dd*K*f*fd - 2144*D1*Dd*f**3*r*s + 536*D1*Dd*f**3*r - 6144*D1*Dd*f**3*s**2 + 4144*D1*Dd*f**3*s - 1536*D1*Dd*f**3 + 9600*D1*Dd*f**2*fd*r*s - 2800*D1*Dd*f**2*fd*r + 21600*D1*Dd*f**2*fd*s**2 - 11400*D1*Dd*f**2*fd*s + 1700*D1*Dd*f**2*fd - 880*D1*Dd*f**2*r*s + 220*D1*Dd*f**2*r - 1408*D1*Dd*f**2*s**2 + 1144*D1*Dd*f**2*s - 352*D1*Dd*f**2 + 2112*D1*Dd*f*fd*r*s - 792*D1*Dd*f*fd*r + 3344*D1*Dd*f*fd*s**2 - 3916*D1*Dd*f*fd*s + 902*D1*Dd*f*fd + 880*D1*Dd*f*g2*s**2 - 440*D1*Dd*f*g2*s + 220*D1*Dd*f*g2 - 880*D1*Dd*f*gd2*s**2 + 220*D1*Dd*f*gd2*s - 880*D1*Dd*fd*g2*s**2 + 220*D1*Dd*fd*g2*s - 748*D1*Ddd*K*f**2*s**2 + 374*D1*Ddd*K*f**2*s - 187*D1*Ddd*K*f**2 + 1600*D1*Ddd*f**3*r*s - 400*D1*Ddd*f**3*r + 3600*D1*Ddd*f**3*s**2 - 2600*D1*Ddd*f**3*s + 900*D1*Ddd*f**3 + 528*D1*Ddd*f**2*r*s - 132*D1*Ddd*f**2*r + 836*D1*Ddd*f**2*s**2 - 682*D1*Ddd*f**2*s + 209*D1*Ddd*f**2 - 440*D1*Ddd*f*g2*s**2 + 220*D1*Ddd*f*g2*s - 110*D1*Ddd*f*g2 - 110*D1*bd1*(K - 1)*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1)) - 2244*Dd**2*K*f**2*s**2 + 1122*Dd**2*K*f**2*s + 4800*Dd**2*f**3*r*s - 1200*Dd**2*f**3*r + 10800*Dd**2*f**3*s**2 - 7800*Dd**2*f**3*s + 800*Dd**2*f**3 + 1584*Dd**2*f**2*r*s - 396*Dd**2*f**2*r + 2508*Dd**2*f**2*s**2 - 2046*Dd**2*f**2*s + 264*Dd**2*f**2 - 1320*Dd**2*f*g2*s**2 + 660*Dd**2*f*g2*s))/(462*d**2*k2*k3**4) + D1**2*Pk3*Pkd2*ct**2*k1**4*(-D1*(2*D1*bd1**2*f*(5*f*(r*(8*s - 4) + 7*s**2 - 9*s + 2) + 12*r*(2*s - 1) - (s - 1)*(31*K*s - 55*s + 12)) + D1*bdd1*f*(-25*f**2*(2*r*(s - 1) + 2*s**2 - 6*s + 3) + 4*f*(s - 1)*(-13*C*(s - 1) + 5*r + 18*s - 18) + 62*g2*(s - 1)**2) + 2*bd1*(D1*(5*f**3*(5*r*(s - 1) + 8*s**2 - 24*s + 12) + f**2*(40*C*(s - 1)**2 - 25*fd*(6*r*s - 3*r + 6*s**2 - 10*s + 2) - (8*s - 8)*(r + 6*s - 6)) + 2*f*(fd*(10*r*(2*s - 1) - (s - 1)*(52*C*s - 72*s + 5)) - (s - 1)*(24*g2*(s - 1) - 31*gd2*s)) + 62*fd*g2*s*(s - 1)) + Dd*f*(-25*f**2*(r*(8*s - 5) + 8*s**2 - 16*s + 5) + f*(-52*C*(4*s**2 - 5*s + 1) + 80*r*s - 50*r + 288*s**2 - 380*s + 92) + 62*g2*(4*s**2 - 5*s + 1)))) + b1**2*(D1**2*s*(f*fd*(64*r + 44*s - 48) - 10*f*fdd*(8*r + 7*s - 6) - 10*fd**2*(8*r + 7*s - 6) + 20*fd*r + 4*fd*s*(17 - 12*K) - 24*fdd*r + fdd*s*(31*K - 55)) + D1*(2*Dd*(f**2*(16*r*(4*s - 1) + 44*s**2 - 54*s + 11) - 2*f*(12*K*(4*s**2 - 2*s + 1) + 5*fd*(4*r*(8*s - 1) + 28*s**2 - 27*s + 3) - 20*r*s + 5*r - 68*s**2 + 44*s - 17) + fd*(r*(12 - 96*s) + s*(31*K*(4*s - 1) - 220*s + 79))) + Ddd*f*(31*K*(4*s**2 - 2*s + 1) - 5*f*(8*r*(4*s - 1) + 28*s**2 - 30*s + 7) - 96*r*s + 24*r - 220*s**2 + 158*s - 55)) - 2*Dd**2*f*(5*f*(12*r*(4*s - 1) + 42*s**2 - 45*s + 8) + 36*r*(4*s - 1) + 3*s**2*(110 - 62*K) + 3*s*(31*K - 79) + 24)) + b1*(-160*C*D1**2*f*fd*s**2 + 104*C*D1**2*f*fdd*s**2 + 104*C*D1**2*fd**2*s**2 - 320*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 80*C*D1*Dd*f**2 + 832*C*D1*Dd*f*fd*s**2 - 208*C*D1*Dd*f*fd*s + 208*C*D1*Ddd*f**2*s**2 - 104*C*D1*Ddd*f**2*s + 52*C*D1*Ddd*f**2 + 624*C*Dd**2*f**2*s**2 - 312*C*Dd**2*f**2*s + D1**2*bdd1*f*(31*K*(2*s**2 - 2*s + 1) - 5*f*(8*r*(2*s - 1) + 14*s**2 - 18*s + 7) - 48*r*s + 24*r - 110*s**2 + 134*s - 55) - 150*D1**2*f**2*fd*r*s - 240*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s + 40*D1**2*f**2*fd + 150*D1**2*f**2*fdd*r*s + 150*D1**2*f**2*fdd*s**2 - 50*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd + 300*D1**2*f*fd**2*r*s + 300*D1**2*f*fd**2*s**2 - 100*D1**2*f*fd**2*s + 32*D1**2*f*fd*r*s + 192*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s - 40*D1**2*f*fdd*r*s - 144*D1**2*f*fdd*s**2 + 20*D1**2*f*fdd*s + 96*D1**2*f*gd2*s**2 - 62*D1**2*f*gdd2*s**2 - 40*D1**2*fd**2*r*s - 144*D1**2*fd**2*s**2 + 20*D1**2*fd**2*s + 96*D1**2*fd*g2*s**2 - 124*D1**2*fd*gd2*s**2 - 62*D1**2*fdd*g2*s**2 - 200*D1*Dd*f**3*r*s + 50*D1*Dd*f**3*r - 320*D1*Dd*f**3*s**2 + 260*D1*Dd*f**3*s - 80*D1*Dd*f**3 + 1200*D1*Dd*f**2*fd*r*s - 150*D1*Dd*f**2*fd*r + 1200*D1*Dd*f**2*fd*s**2 - 800*D1*Dd*f**2*fd*s + 50*D1*Dd*f**2*fd + 64*D1*Dd*f**2*r*s - 16*D1*Dd*f**2*r + 384*D1*Dd*f**2*s**2 - 224*D1*Dd*f**2*s + 96*D1*Dd*f**2 - 320*D1*Dd*f*fd*r*s + 40*D1*Dd*f*fd*r - 1152*D1*Dd*f*fd*s**2 + 448*D1*Dd*f*fd*s - 20*D1*Dd*f*fd + 384*D1*Dd*f*g2*s**2 - 192*D1*Dd*f*g2*s + 96*D1*Dd*f*g2 - 496*D1*Dd*f*gd2*s**2 + 124*D1*Dd*f*gd2*s - 496*D1*Dd*fd*g2*s**2 + 124*D1*Dd*fd*g2*s + 200*D1*Ddd*f**3*r*s - 50*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s**2 - 200*D1*Ddd*f**3*s + 50*D1*Ddd*f**3 - 80*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 288*D1*Ddd*f**2*s**2 + 184*D1*Ddd*f**2*s - 72*D1*Ddd*f**2 - 248*D1*Ddd*f*g2*s**2 + 124*D1*Ddd*f*g2*s - 62*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*(16*r*(2*s - 1) + 22*s**2 - 30*s + 11) - 2*f*(12*K*(2*s**2 - 2*s + 1) + 5*fd*(4*r*(4*s - 1) + 14*s**2 - 15*s + 3) - 10*r*s + 5*r - 34*s**2 + 39*s - 17) + fd*(r*(12 - 48*s) + s*(31*K*(2*s - 1) - 110*s + 67))) + Dd*f*(31*K*(8*s**2 - 6*s + 1) - 5*f*(8*r*(8*s - 3) + 56*s**2 - 66*s + 17) - 192*r*s + 72*r - 440*s**2 + 426*s - 91)) + 600*Dd**2*f**3*r*s - 150*Dd**2*f**3*r + 600*Dd**2*f**3*s**2 - 600*Dd**2*f**3*s + 100*Dd**2*f**3 - 240*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 864*Dd**2*f**2*s**2 + 552*Dd**2*f**2*s - 40*Dd**2*f**2 - 744*Dd**2*f*g2*s**2 + 372*Dd**2*f*g2*s))/(21*d**2*k2*k3**4) - 20*D1**2*Pk3*Pkd2*ct**2*k1**2*k2**3*st**6*(156*C*D1**2*f**2*fd*r*s - 52*C*D1**2*f**2*fd*r + 156*C*D1**2*f**2*fd*s**2 - 156*C*D1**2*f**2*fd*s + 52*C*D1**2*f**2*fd - 78*C*D1**2*f**2*fdd*r*s + 26*C*D1**2*f**2*fdd*r - 78*C*D1**2*f**2*fdd*s**2 + 78*C*D1**2*f**2*fdd*s - 26*C*D1**2*f**2*fdd - 156*C*D1**2*f*fd**2*r*s + 52*C*D1**2*f*fd**2*r - 156*C*D1**2*f*fd**2*s**2 + 156*C*D1**2*f*fd**2*s - 26*C*D1**2*f*fd**2 + 208*C*D1*Dd*f**3*r*s - 52*C*D1*Dd*f**3*r + 208*C*D1*Dd*f**3*s**2 - 208*C*D1*Dd*f**3*s + 52*C*D1*Dd*f**3 - 624*C*D1*Dd*f**2*fd*r*s + 182*C*D1*Dd*f**2*fd*r - 624*C*D1*Dd*f**2*fd*s**2 + 624*C*D1*Dd*f**2*fd*s - 130*C*D1*Dd*f**2*fd - 104*C*D1*Ddd*f**3*r*s + 26*C*D1*Ddd*f**3*r - 104*C*D1*Ddd*f**3*s**2 + 104*C*D1*Ddd*f**3*s - 26*C*D1*Ddd*f**3 - 312*C*Dd**2*f**3*r*s + 78*C*Dd**2*f**3*r - 312*C*Dd**2*f**3*s**2 + 312*C*Dd**2*f**3*s - 52*C*Dd**2*f**3 - 429*D1**2*K*bdd1*f**2*r*s - 429*D1**2*K*bdd1*f**2*s**2 + 429*D1**2*K*bdd1*f**2*s + 429*D1**2*bdd1*f**2*r*s + 429*D1**2*bdd1*f**2*s**2 - 429*D1**2*bdd1*f**2*s - 672*D1**2*f**3*fd*r*s + 168*D1**2*f**3*fd*r - 672*D1**2*f**3*fd*s**2 + 672*D1**2*f**3*fd*s - 168*D1**2*f**3*fd + 336*D1**2*f**3*fdd*r*s - 84*D1**2*f**3*fdd*r + 336*D1**2*f**3*fdd*s**2 - 336*D1**2*f**3*fdd*s + 84*D1**2*f**3*fdd + 1008*D1**2*f**2*fd**2*r*s - 252*D1**2*f**2*fd**2*r + 1008*D1**2*f**2*fd**2*s**2 - 1008*D1**2*f**2*fd**2*s + 168*D1**2*f**2*fd**2 - 156*D1**2*f**2*fd*r*s + 52*D1**2*f**2*fd*r - 156*D1**2*f**2*fd*s**2 + 156*D1**2*f**2*fd*s - 52*D1**2*f**2*fd + 78*D1**2*f**2*fdd*r*s - 26*D1**2*f**2*fdd*r + 78*D1**2*f**2*fdd*s**2 - 78*D1**2*f**2*fdd*s + 26*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r*s - 1716*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s + 858*D1**2*f**2*gdd2*r*s + 858*D1**2*f**2*gdd2*s**2 - 858*D1**2*f**2*gdd2*s + 156*D1**2*f*fd**2*r*s - 52*D1**2*f*fd**2*r + 156*D1**2*f*fd**2*s**2 - 156*D1**2*f*fd**2*s + 26*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r*s - 858*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 3432*D1**2*f*fd*gd2*s + 858*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r*s - 858*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r*s - 858*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s - 672*D1*Dd*f**4*r*s + 168*D1*Dd*f**4*r - 672*D1*Dd*f**4*s**2 + 672*D1*Dd*f**4*s - 168*D1*Dd*f**4 + 2688*D1*Dd*f**3*fd*r*s - 672*D1*Dd*f**3*fd*r + 2688*D1*Dd*f**3*fd*s**2 - 2688*D1*Dd*f**3*fd*s + 504*D1*Dd*f**3*fd - 208*D1*Dd*f**3*r*s + 52*D1*Dd*f**3*r - 208*D1*Dd*f**3*s**2 + 208*D1*Dd*f**3*s - 52*D1*Dd*f**3 + 624*D1*Dd*f**2*fd*r*s - 182*D1*Dd*f**2*fd*r + 624*D1*Dd*f**2*fd*s**2 - 624*D1*Dd*f**2*fd*s + 130*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r*s + 1716*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 6864*D1*Dd*f**2*g2*s - 1716*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r*s - 858*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 6864*D1*Dd*f**2*gd2*s + 858*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r*s - 5148*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 13728*D1*Dd*f*fd*g2*s + 3432*D1*Dd*f*fd*g2 + 336*D1*Ddd*f**4*r*s - 84*D1*Ddd*f**4*r + 336*D1*Ddd*f**4*s**2 - 336*D1*Ddd*f**4*s + 84*D1*Ddd*f**4 + 104*D1*Ddd*f**3*r*s - 26*D1*Ddd*f**3*r + 104*D1*Ddd*f**3*s**2 - 104*D1*Ddd*f**3*s + 26*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r*s - 858*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 3432*D1*Ddd*f**2*g2*s + 858*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 1008*Dd**2*f**4*r*s - 252*Dd**2*f**4*r + 1008*Dd**2*f**4*s**2 - 1008*Dd**2*f**4*s + 168*Dd**2*f**4 + 312*Dd**2*f**3*r*s - 78*Dd**2*f**3*r + 312*Dd**2*f**3*s**2 - 312*Dd**2*f**3*s + 52*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r*s - 2574*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 10296*Dd**2*f**2*g2*s + 1716*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**6) - 8*D1**2*Pk3*Pkd2*ct**2*k1**2*k2**3*st**4*(-11*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + D1*bd1*(D1*(10*f**3*(3*s + 1)*(r + s - 1) + f**2*(-5*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + s*(22 - 33*K)*(r + s - 1)) - 22*f*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 22*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-5*f**2*(24*r*s + r + 4*s*(6*s - 5)) + 22*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 11*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(-66*D1**2*K*f*fd*r*s + 33*D1**2*K*f*fd*r - 66*D1**2*K*f*fd*s**2 + 66*D1**2*K*f*fd*s - 33*D1**2*K*f*fd - 11*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 90*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 40*D1**2*f**2*fd - 45*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 45*D1**2*f**2*fdd*s**2 + 50*D1**2*f**2*fdd*s - 20*D1**2*f**2*fdd - 90*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 90*D1**2*f*fd**2*s**2 + 100*D1**2*f*fd**2*s - 20*D1**2*f*fd**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 44*D1**2*f*fd*s**2 - 44*D1**2*f*fd*s + 22*D1**2*f*fd - 44*D1**2*f*gd2*r*s - 44*D1**2*f*gd2*s**2 + 44*D1**2*f*gd2*s + 22*D1**2*f*gdd2*r*s + 22*D1**2*f*gdd2*s**2 - 22*D1**2*f*gdd2*s - 44*D1**2*fd*g2*r*s - 44*D1**2*fd*g2*s**2 + 44*D1**2*fd*gd2*r*s + 44*D1**2*fd*gd2*s**2 - 22*D1**2*fd*gd2*s + 22*D1**2*fdd*g2*r*s + 22*D1**2*fdd*g2*s**2 - 132*D1*Dd*K*f**2*r*s + 33*D1*Dd*K*f**2*r - 132*D1*Dd*K*f**2*s**2 + 132*D1*Dd*K*f**2*s - 33*D1*Dd*K*f**2 + 120*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 120*D1*Dd*f**3*s**2 - 120*D1*Dd*f**3*s + 30*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r*s + 125*D1*Dd*f**2*fd*r - 360*D1*Dd*f**2*fd*s**2 + 380*D1*Dd*f**2*fd*s - 90*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r*s - 22*D1*Dd*f**2*r + 88*D1*Dd*f**2*s**2 - 88*D1*Dd*f**2*s + 22*D1*Dd*f**2 - 176*D1*Dd*f*g2*r*s + 44*D1*Dd*f*g2*r - 176*D1*Dd*f*g2*s**2 + 176*D1*Dd*f*g2*s - 44*D1*Dd*f*g2 + 176*D1*Dd*f*gd2*r*s - 22*D1*Dd*f*gd2*r + 176*D1*Dd*f*gd2*s**2 - 176*D1*Dd*f*gd2*s + 22*D1*Dd*f*gd2 + 176*D1*Dd*fd*g2*r*s - 22*D1*Dd*fd*g2*r + 176*D1*Dd*fd*g2*s**2 - 88*D1*Dd*fd*g2*s - 60*D1*Ddd*f**3*r*s + 15*D1*Ddd*f**3*r - 60*D1*Ddd*f**3*s**2 + 60*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 + 88*D1*Ddd*f*g2*r*s - 22*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2*s**2 - 88*D1*Ddd*f*g2*s + 22*D1*Ddd*f*g2 + 11*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 180*Dd**2*f**3*r*s + 45*Dd**2*f**3*r - 180*Dd**2*f**3*s**2 + 180*Dd**2*f**3*s - 30*Dd**2*f**3 + 264*Dd**2*f*g2*r*s - 66*Dd**2*f*g2*r + 264*Dd**2*f*g2*s**2 - 264*Dd**2*f*g2*s + 44*Dd**2*f*g2) + f*(-D1**2*bdd1*(5*f**2*(3*s + 1) - 22*g2*(s - 1))*(r + s - 1) + D1**2*(5*f**2*fd*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-fd*(40*C - 30)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(20*C - 15)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 66*gd2*s*(r + s - 1)) + fd*(fd*(20*C - 15)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1))) + D1*f*(Dd*(5*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(30 - 40*C)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(20*C - 15)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 66*g2*(r*(4*s - 1) + (1 - 2*s)**2)) + Ddd*f*(20*C - 15)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(20*C - 15)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(77*d**2*k3**6) - 4*D1**2*Pk3*Pkd2*ct**2*k1**2*k2**3*st**2*(-33*D1**2*bd1**2*f*(2*s - 1)*(-6*K + 8*f + 3)*(r + s - 1) + 99*D1**2*bdd1*f*(f*(4*C*(s - 1) + 2*K*s - 3*s + 3) - 4*g2*(s - 1))*(r + s - 1) - 6*D1**2*(f**2*(fd*(34*C - 6)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(50*C - 25)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-66*gd2 + 66*gdd2)*(r + s - 1)) + f*(-fd**2*(50*C - 25)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 66*fd*(g2*(2*r*s - r + 2*s**2 - 2*s + 1) + gd2*(-4*r*s + r - 4*s**2 + 4*s - 1)) + 66*fdd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 66*fd**2*g2*(r*(2*s - 1) + s*(2*s - 2))) - 11*D1*bd1*(D1*(6*f**3*(2*s + 1)*(r + s - 1) + f**2*(r + s - 1)*(66*C*(s - 1) + s*(18*K - 43) + 49) - 3*f*(3*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 6*r - 12*s**2 + 15*s - 3) + (38*g2*(s - 1) + 12*gd2*(1 - 2*s))*(r + s - 1)) + 36*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 9*Dd*f*(f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 4*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 6*D1*f*(Dd*(f**2*(34*C - 6)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(25 - 50*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 66*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 66*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 132*fd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(f*(50*C - 25) - 66*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*Dd**2*f**2*(f*(50*C - 25) - 66*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 11*b1**2*(D1**2*s*(3*f*(15*fd - 8*fdd)*(2*r + 2*s - 1) - 24*fd**2*(2*r + 2*s - 1) - fd*(57*K - 32)*(r + s) + 9*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(45*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-24*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - (57*K - 32)*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-6*K + 8*f + 3)) - 3*Dd**2*f*(-6*K + 8*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(-132*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*s**2 + 66*C*D1**2*f*fd*s + 72*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 72*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*s**2 - 36*C*D1**2*fd**2*s - 264*C*D1*Dd*f**2*r*s + 66*C*D1*Dd*f**2*r - 264*C*D1*Dd*f**2*s**2 + 264*C*D1*Dd*f**2*s - 66*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r*s - 72*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 432*C*D1*Dd*f*fd*s + 36*C*D1*Dd*f*fd + 144*C*D1*Ddd*f**2*r*s - 36*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r*s - 108*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 36*D1**2*K*f*fd*r*s + 18*D1**2*K*f*fd*r - 36*D1**2*K*f*fd*s**2 + 36*D1**2*K*f*fd*s - 18*D1**2*K*f*fd + 36*D1**2*K*f*fdd*r*s - 18*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r*s - 18*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(2*s - 1)*(-6*K + 8*f + 3)*(r + s - 1) - 36*D1**2*f**2*fd*r*s + 18*D1**2*f**2*fd*r - 36*D1**2*f**2*fd*s**2 + 42*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 86*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 86*D1**2*f*fd*s**2 - 37*D1**2*f*fd*s - 6*D1**2*f*fd - 54*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*s**2 + 27*D1**2*f*fdd*s + 114*D1**2*f*gd2*r*s + 114*D1**2*f*gd2*s**2 - 114*D1**2*f*gd2*s - 36*D1**2*f*gdd2*r*s - 36*D1**2*f*gdd2*s**2 + 36*D1**2*f*gdd2*s - 54*D1**2*fd**2*r*s - 54*D1**2*fd**2*s**2 + 27*D1**2*fd**2*s + 114*D1**2*fd*g2*r*s + 114*D1**2*fd*g2*s**2 - 72*D1**2*fd*gd2*r*s - 72*D1**2*fd*gd2*s**2 + 36*D1**2*fd*gd2*s - 36*D1**2*fdd*g2*r*s - 36*D1**2*fdd*g2*s**2 - 72*D1*Dd*K*f**2*r*s + 18*D1*Dd*K*f**2*r - 72*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 18*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r*s - 108*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 288*D1*Dd*K*f*fd*s + 72*D1*Dd*K*f*fd - 48*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r - 48*D1*Dd*f**3*s**2 + 48*D1*Dd*f**3*s - 12*D1*Dd*f**3 + 172*D1*Dd*f**2*r*s - 43*D1*Dd*f**2*r + 172*D1*Dd*f**2*s**2 - 172*D1*Dd*f**2*s + 43*D1*Dd*f**2 - 432*D1*Dd*f*fd*r*s + 54*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 324*D1*Dd*f*fd*s - 27*D1*Dd*f*fd + 456*D1*Dd*f*g2*r*s - 114*D1*Dd*f*g2*r + 456*D1*Dd*f*g2*s**2 - 456*D1*Dd*f*g2*s + 114*D1*Dd*f*g2 - 288*D1*Dd*f*gd2*r*s + 36*D1*Dd*f*gd2*r - 288*D1*Dd*f*gd2*s**2 + 288*D1*Dd*f*gd2*s - 36*D1*Dd*f*gd2 - 288*D1*Dd*fd*g2*r*s + 36*D1*Dd*fd*g2*r - 288*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s + 72*D1*Ddd*K*f**2*r*s - 18*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 72*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 - 108*D1*Ddd*f**2*r*s + 27*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 144*D1*Ddd*f*g2*r*s + 36*D1*Ddd*f*g2*r - 144*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + D1*bd1*(D1*(45*f**2*(2*s - 1)*(r + s - 1) + f*(-24*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) - (57*K - 32)*(2*s - 1)*(r + s - 1)) + 9*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 3*Dd*f*(-6*K + 8*f + 3)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 216*Dd**2*K*f**2*r*s - 54*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 216*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 - 324*Dd**2*f**2*r*s + 81*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 54*Dd**2*f**2 - 432*Dd**2*f*g2*r*s + 108*Dd**2*f*g2*r - 432*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(231*d**2*k3**6) + 8*D1**2*Pk3*Pkd2*ct**2*k1**2*k2**3*(D1*(-18*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 3*bd1*(D1*(2*f**2*(r + s - 1)*(2*C*(s - 1) + s*(K - 3) + 3) + f*(fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (g2*(s - 1) + 3*gd2*(2*s - 1))*(-4*r - 4*s + 4)) + 12*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + f*(-3*D1*bdd1*(s - 1)*(f*(10*C - 5) - 12*g2)*(r + s - 1) + D1*(f*(-fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 12*gd2*s*(r + s - 1)) + 12*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 2*b1**2*(D1**2*s*(9*f*fd*(2*r + 2*s - 1) - (r + s)*(9*K*fdd + fd*(3*K - 7))) + D1*(Dd*(9*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 9*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(3*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*(6*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(2*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(4*C - 6)*(2*r + 2*s - 1) + fdd*s*(10*C - 5)*(2*r + 2*s - 1) + s*(-4*gd2 - 12*gdd2)*(r + s - 1)) + s*(fd**2*(10*C - 5)*(2*r + 2*s - 1) - 4*fd*(g2*(r + s) + gd2*(6*r + 6*s - 3)) - 12*fdd*g2*(r + s))) + 2*D1*bd1*(D1*(9*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 9*f**2*(2*s - 1)*(r + s - 1) - f*(3*K - 7)*(2*s - 1)*(r + s - 1)) - 9*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*D1*(Dd*(2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(2*C + K - 3) + f*(fd*(10*C - 5)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 4*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 12*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 12*fd*g2*(-8*r*s + r + s*(4 - 8*s))) + Ddd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(f*(10*C - 5) - 12*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**6) - 5*D1**2*Pk3*Pkd2*ct**2*k1**2*k2*st**6*(D1**2*(-84*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(504*fd**2*s*(2*s - 1) + fd*(52*C - 52)*(3*s**2 - 2*s + 1) - fdd*(26*C - 26)*(3*s**2 - 2*s + 1) + s**2*(-429*K*bdd1 + 858*bd1*(K - 1) + 429*bdd1 - 1716*gd2 + 858*gdd2)) - 26*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 1716*fd**2*g2*s*(s - 1)) - 2*D1*f*(Dd*(84*f**3*(4*s**2 - 2*s + 1) - 2*f**2*(13*C*(4*s**2 - 2*s + 1) + 42*fd*(1 - 4*s)**2 - 52*s**2 + 26*s - 13) + 13*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 858*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(42*f**2 + f*(13 - 13*C) + 429*g2)*(4*s**2 - 2*s + 1)) + 12*Dd**2*f**2*s*(2*s - 1)*(42*f**2 + f*(13 - 13*C) + 429*g2) + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(2002*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**2*k1**2*k2*st**4*(-384*C*D1**2*f**2*fd*r*s + 128*C*D1**2*f**2*fd*r + 960*C*D1**2*f**2*fd*s**2 - 512*C*D1**2*f**2*fd*s + 320*C*D1**2*f**2*fd + 192*C*D1**2*f**2*fdd*r*s - 64*C*D1**2*f**2*fdd*r - 480*C*D1**2*f**2*fdd*s**2 + 256*C*D1**2*f**2*fdd*s - 160*C*D1**2*f**2*fdd + 384*C*D1**2*f*fd**2*r*s - 128*C*D1**2*f*fd**2*r - 960*C*D1**2*f*fd**2*s**2 + 512*C*D1**2*f*fd**2*s + 64*C*D1**2*f*fd**2 - 512*C*D1*Dd*f**3*r*s + 128*C*D1*Dd*f**3*r + 1280*C*D1*Dd*f**3*s**2 - 384*C*D1*Dd*f**3*s + 320*C*D1*Dd*f**3 + 1536*C*D1*Dd*f**2*fd*r*s - 448*C*D1*Dd*f**2*fd*r - 3840*C*D1*Dd*f**2*fd*s**2 + 1600*C*D1*Dd*f**2*fd*s - 128*C*D1*Dd*f**2*fd + 256*C*D1*Ddd*f**3*r*s - 64*C*D1*Ddd*f**3*r - 640*C*D1*Ddd*f**3*s**2 + 192*C*D1*Ddd*f**3*s - 160*C*D1*Ddd*f**3 + 768*C*Dd**2*f**3*r*s - 192*C*Dd**2*f**3*r - 1920*C*Dd**2*f**3*s**2 + 576*C*Dd**2*f**3*s + 128*C*Dd**2*f**3 - 132*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 132*D1**2*K*bdd1*f**2*s + 66*D1**2*bd1**2*f*s*(K - 1)*(4*r + 9*s - 7) - 240*D1**2*bdd1*f**3*r*s - 90*D1**2*bdd1*f**3*s**2 + 330*D1**2*bdd1*f**3*s - 75*D1**2*bdd1*f**3 + 132*D1**2*bdd1*f**2*r*s + 297*D1**2*bdd1*f**2*s**2 - 132*D1**2*bdd1*f**2*s - 264*D1**2*bdd1*f*g2*r*s - 594*D1**2*bdd1*f*g2*s**2 + 660*D1**2*bdd1*f*g2*s - 330*D1**2*bdd1*f*g2 - 1080*D1**2*f**3*fd*r*s + 270*D1**2*f**3*fd*r - 1200*D1**2*f**3*fd*s**2 + 1140*D1**2*f**3*fd*s - 300*D1**2*f**3*fd + 1080*D1**2*f**3*fdd*r*s - 270*D1**2*f**3*fdd*r + 780*D1**2*f**3*fdd*s**2 - 930*D1**2*f**3*fdd*s + 195*D1**2*f**3*fdd + 3240*D1**2*f**2*fd**2*r*s - 810*D1**2*f**2*fd**2*r + 2340*D1**2*f**2*fd**2*s**2 - 2790*D1**2*f**2*fd**2*s + 540*D1**2*f**2*fd**2 + 744*D1**2*f**2*fd*r*s - 248*D1**2*f**2*fd*r - 300*D1**2*f**2*fd*s**2 - 48*D1**2*f**2*fd*s - 100*D1**2*f**2*fd - 372*D1**2*f**2*fdd*r*s + 124*D1**2*f**2*fdd*r + 150*D1**2*f**2*fdd*s**2 + 24*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 792*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 264*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s - 744*D1**2*f*fd**2*r*s + 248*D1**2*f*fd**2*r + 300*D1**2*f*fd**2*s**2 + 48*D1**2*f*fd**2*s - 124*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 1584*D1**2*f*fd*g2*s**2 + 1584*D1**2*f*fd*g2*s - 792*D1**2*f*fd*g2 + 1056*D1**2*f*fd*gd2*r*s - 264*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 1716*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s - 1080*D1*Dd*f**4*r*s + 270*D1*Dd*f**4*r - 1200*D1*Dd*f**4*s**2 + 1140*D1*Dd*f**4*s - 300*D1*Dd*f**4 + 8640*D1*Dd*f**3*fd*r*s - 2160*D1*Dd*f**3*fd*r + 6240*D1*Dd*f**3*fd*s**2 - 7440*D1*Dd*f**3*fd*s + 1470*D1*Dd*f**3*fd + 992*D1*Dd*f**3*r*s - 248*D1*Dd*f**3*r - 400*D1*Dd*f**3*s**2 - 296*D1*Dd*f**3*s - 100*D1*Dd*f**3 - 2976*D1*Dd*f**2*fd*r*s + 868*D1*Dd*f**2*fd*r + 1200*D1*Dd*f**2*fd*s**2 + 540*D1*Dd*f**2*fd*s - 272*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 3168*D1*Dd*f**2*g2*s**2 + 2112*D1*Dd*f**2*g2*s - 792*D1*Dd*f**2*g2 + 2112*D1*Dd*f**2*gd2*r*s - 264*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 264*D1*Dd*f**2*gd2 + 4224*D1*Dd*f*fd*g2*r*s - 1584*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 8184*D1*Dd*f*fd*g2*s + 1716*D1*Dd*f*fd*g2 + 1080*D1*Ddd*f**4*r*s - 270*D1*Ddd*f**4*r + 780*D1*Ddd*f**4*s**2 - 930*D1*Ddd*f**4*s + 195*D1*Ddd*f**4 - 496*D1*Ddd*f**3*r*s + 124*D1*Ddd*f**3*r + 200*D1*Ddd*f**3*s**2 + 148*D1*Ddd*f**3*s + 50*D1*Ddd*f**3 + 1056*D1*Ddd*f**2*g2*r*s - 264*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 1716*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 6*D1*bd1*(D1*(5*f**3*(6*s**2 + s*(16*r - 22) + 5) + f**2*(-10*fd*(4*r*(6*s - 1) + 9*s**2 - 22*s + 3) + 22*s*(K*(r + 3*s - 1) - 2*s)) - 11*f*(fd*(K - 1)*(r*(8*s - 2) + 18*s**2 - 13*s + 2) - 2*g2*(4*r*s + 9*s**2 - 10*s + 5) - 2*gd2*s*(-4*r - 9*s + 7)) - 22*fd*g2*(r*(4*s - 2) + s*(9*s - 9))) - Dd*f*(5*f**2*(64*r*s - 8*r + 24*s**2 - 66*s + 11) + 11*f*(K - 1)*(16*r*s - 2*r + 36*s**2 - 21*s + 2) + 22*g2*(16*r*s - 2*r + 36*s**2 - 33*s + 5))) + 3240*Dd**2*f**4*r*s - 810*Dd**2*f**4*r + 2340*Dd**2*f**4*s**2 - 2790*Dd**2*f**4*s + 540*Dd**2*f**4 - 1488*Dd**2*f**3*r*s + 372*Dd**2*f**3*r + 600*Dd**2*f**3*s**2 + 444*Dd**2*f**3*s - 248*Dd**2*f**3 + 3168*Dd**2*f**2*g2*r*s - 792*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 5148*Dd**2*f**2*g2*s + 528*Dd**2*f**2*g2 - 33*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(4*r*(s - 1) + 9*s**2 - 8*s + 4) + D1*(2*Dd*(f*(16*r*s - 4*r + 36*s**2 - 26*s + 9) + fd*(-16*r*s + 10*r - 36*s**2 + 29*s - 8)) + Ddd*f*(r*(4 - 16*s) - 36*s**2 + 26*s - 9)) - 2*Dd**2*f*(6*r*(4*s - 1) + 54*s**2 - 39*s + 4)) - 3*b1*(-88*D1**2*K*f*fd*r*s + 44*D1**2*K*f*fd*r - 264*D1**2*K*f*fd*s**2 + 264*D1**2*K*f*fd*s - 132*D1**2*K*f*fd + 88*D1**2*K*f*fdd*r*s - 44*D1**2*K*f*fdd*r + 198*D1**2*K*f*fdd*s**2 - 198*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 88*D1**2*K*fd**2*r*s - 44*D1**2*K*fd**2*r + 198*D1**2*K*fd**2*s**2 - 198*D1**2*K*fd**2*s - 11*D1**2*bdd1*f*(K - 1)*(8*r*s + 18*s**2 - 14*s + 5) - 480*D1**2*f**2*fd*r*s + 160*D1**2*f**2*fd*r - 180*D1**2*f**2*fd*s**2 + 220*D1**2*f**2*fd*s - 10*D1**2*f**2*fd + 240*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 90*D1**2*f**2*fdd*s**2 - 110*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 480*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 180*D1**2*f*fd**2*s**2 - 220*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 + 176*D1**2*f*fd*s**2 - 176*D1**2*f*fd*s + 88*D1**2*f*fd - 88*D1**2*f*fdd*r*s + 44*D1**2*f*fdd*r - 198*D1**2*f*fdd*s**2 + 198*D1**2*f*fdd*s - 99*D1**2*f*fdd - 176*D1**2*f*gd2*r*s - 396*D1**2*f*gd2*s**2 + 176*D1**2*f*gd2*s + 88*D1**2*f*gdd2*r*s + 198*D1**2*f*gdd2*s**2 - 88*D1**2*f*gdd2*s - 88*D1**2*fd**2*r*s + 44*D1**2*fd**2*r - 198*D1**2*fd**2*s**2 + 198*D1**2*fd**2*s - 176*D1**2*fd*g2*r*s + 176*D1**2*fd*g2*r - 396*D1**2*fd*g2*s**2 + 352*D1**2*fd*g2*s - 176*D1**2*fd*g2 + 176*D1**2*fd*gd2*r*s - 88*D1**2*fd*gd2*r + 396*D1**2*fd*gd2*s**2 - 264*D1**2*fd*gd2*s + 88*D1**2*fd*gd2 + 88*D1**2*fdd*g2*r*s - 88*D1**2*fdd*g2*r + 198*D1**2*fdd*g2*s**2 - 176*D1**2*fdd*g2*s + 88*D1**2*fdd*g2 - 176*D1*Dd*K*f**2*r*s + 44*D1*Dd*K*f**2*r - 528*D1*Dd*K*f**2*s**2 + 352*D1*Dd*K*f**2*s - 132*D1*Dd*K*f**2 + 704*D1*Dd*K*f*fd*r*s - 264*D1*Dd*K*f*fd*r + 1584*D1*Dd*K*f*fd*s**2 - 1364*D1*Dd*K*f*fd*s + 286*D1*Dd*K*f*fd - 640*D1*Dd*f**3*r*s + 160*D1*Dd*f**3*r - 240*D1*Dd*f**3*s**2 + 440*D1*Dd*f**3*s - 60*D1*Dd*f**3 + 1920*D1*Dd*f**2*fd*r*s - 560*D1*Dd*f**2*fd*r + 720*D1*Dd*f**2*fd*s**2 - 1100*D1*Dd*f**2*fd*s + 270*D1*Dd*f**2*fd + 352*D1*Dd*f**2*s**2 - 176*D1*Dd*f**2*s + 88*D1*Dd*f**2 - 704*D1*Dd*f*fd*r*s + 264*D1*Dd*f*fd*r - 1584*D1*Dd*f*fd*s**2 + 1364*D1*Dd*f*fd*s - 286*D1*Dd*f*fd - 704*D1*Dd*f*g2*r*s + 176*D1*Dd*f*g2*r - 1584*D1*Dd*f*g2*s**2 + 1144*D1*Dd*f*g2*s - 396*D1*Dd*f*g2 + 704*D1*Dd*f*gd2*r*s - 88*D1*Dd*f*gd2*r + 1584*D1*Dd*f*gd2*s**2 - 924*D1*Dd*f*gd2*s + 88*D1*Dd*f*gd2 + 704*D1*Dd*fd*g2*r*s - 440*D1*Dd*fd*g2*r + 1584*D1*Dd*fd*g2*s**2 - 1276*D1*Dd*fd*g2*s + 352*D1*Dd*fd*g2 + 176*D1*Ddd*K*f**2*r*s - 44*D1*Ddd*K*f**2*r + 396*D1*Ddd*K*f**2*s**2 - 286*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 + 320*D1*Ddd*f**3*r*s - 80*D1*Ddd*f**3*r + 120*D1*Ddd*f**3*s**2 - 220*D1*Ddd*f**3*s + 30*D1*Ddd*f**3 - 176*D1*Ddd*f**2*r*s + 44*D1*Ddd*f**2*r - 396*D1*Ddd*f**2*s**2 + 286*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 + 352*D1*Ddd*f*g2*r*s - 88*D1*Ddd*f*g2*r + 792*D1*Ddd*f*g2*s**2 - 572*D1*Ddd*f*g2*s + 198*D1*Ddd*f*g2 + 22*D1*bd1*(K - 1)*(D1*(f*(8*r*s + 18*s**2 - 14*s + 5) + fd*(-8*r*s + 4*r - 18*s**2 + 15*s - 2)) + Dd*f*(r*(4 - 32*s) - 72*s**2 + 54*s - 7)) + 528*Dd**2*K*f**2*r*s - 132*Dd**2*K*f**2*r + 1188*Dd**2*K*f**2*s**2 - 858*Dd**2*K*f**2*s + 88*Dd**2*K*f**2 + 960*Dd**2*f**3*r*s - 240*Dd**2*f**3*r + 360*Dd**2*f**3*s**2 - 660*Dd**2*f**3*s + 160*Dd**2*f**3 - 528*Dd**2*f**2*r*s + 132*Dd**2*f**2*r - 1188*Dd**2*f**2*s**2 + 858*Dd**2*f**2*s - 88*Dd**2*f**2 + 1056*Dd**2*f*g2*r*s - 264*Dd**2*f*g2*r + 2376*Dd**2*f*g2*s**2 - 1716*Dd**2*f*g2*s + 176*Dd**2*f*g2))/(231*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**2*k1**2*k2*st**2*(7728*C*D1**2*f**2*fd*r*s - 2576*C*D1**2*f**2*fd*r + 16152*C*D1**2*f**2*fd*s**2 - 13344*C*D1**2*f**2*fd*s + 5384*C*D1**2*f**2*fd - 6768*C*D1**2*f**2*fdd*r*s + 2256*C*D1**2*f**2*fdd*r - 11244*C*D1**2*f**2*fdd*s**2 + 9752*C*D1**2*f**2*fdd*s - 3748*C*D1**2*f**2*fdd - 13536*C*D1**2*f*fd**2*r*s + 4512*C*D1**2*f*fd**2*r - 22488*C*D1**2*f*fd**2*s**2 + 19504*C*D1**2*f*fd**2*s - 2256*C*D1**2*f*fd**2 + 10304*C*D1*Dd*f**3*r*s - 2576*C*D1*Dd*f**3*r + 21536*C*D1*Dd*f**3*s**2 - 15920*C*D1*Dd*f**3*s + 5384*C*D1*Dd*f**3 - 54144*C*D1*Dd*f**2*fd*r*s + 15792*C*D1*Dd*f**2*fd*r - 89952*C*D1*Dd*f**2*fd*s**2 + 75032*C*D1*Dd*f**2*fd*s - 14264*C*D1*Dd*f**2*fd - 9024*C*D1*Ddd*f**3*r*s + 2256*C*D1*Ddd*f**3*r - 14992*C*D1*Ddd*f**3*s**2 + 12008*C*D1*Ddd*f**3*s - 3748*C*D1*Ddd*f**3 - 27072*C*Dd**2*f**3*r*s + 6768*C*Dd**2*f**3*r - 44976*C*Dd**2*f**3*s**2 + 36024*C*Dd**2*f**3*s - 4512*C*Dd**2*f**3 + 22*D1**2*bd1**2*(6*f**2*(8*r*(s - 1) + 5*s**2 - 15*s + 6) + f*(8*C*s**2 - 8*C*s + K*(r*(28*s - 2) + 59*s**2 - 49*s + 2) + 4*r*(2*C*s - C + 3*s - 3) - 13*s**2 - 9*s + 16) + 28*g2*(r*(2*s - 1) + s*(2*s - 2))) + 22*D1**2*bdd1*f*(27*f**2*(2*r + 2*s**2 - 1) + f*(C*(-4*r*(s - 7) + 19*s**2 + 10*s - 5) - 99*K*s**2 + 60*K*s + r*(-60*K*s + 40*s - 46) + 41*s**2 - 64*s + 26) + g2*(r*(4 - 28*s) - 59*s**2 + 70*s - 35)) - 792*D1**2*bdd2*f**2*r*s - 792*D1**2*bdd2*f**2*s**2 + 792*D1**2*bdd2*f**2*s - 3204*D1**2*f**2*fd*r*s + 1068*D1**2*f**2*fd*r - 10068*D1**2*f**2*fd*s**2 + 7780*D1**2*f**2*fd*s - 3356*D1**2*f**2*fd + 4176*D1**2*f**2*fdd*r*s - 1392*D1**2*f**2*fdd*r + 7608*D1**2*f**2*fdd*s**2 - 6464*D1**2*f**2*fdd*s + 2536*D1**2*f**2*fdd - 3696*D1**2*f**2*gd2*r*s - 6600*D1**2*f**2*gd2*s**2 + 3696*D1**2*f**2*gd2*s + 2640*D1**2*f**2*gdd2*r*s + 4356*D1**2*f**2*gdd2*s**2 - 2640*D1**2*f**2*gdd2*s + 8352*D1**2*f*fd**2*r*s - 2784*D1**2*f*fd**2*r + 15216*D1**2*f*fd**2*s**2 - 12928*D1**2*f*fd**2*s + 1392*D1**2*f*fd**2 - 7392*D1**2*f*fd*g2*r*s + 3696*D1**2*f*fd*g2*r - 13200*D1**2*f*fd*g2*s**2 + 13200*D1**2*f*fd*g2*s - 6600*D1**2*f*fd*g2 + 10560*D1**2*f*fd*gd2*r*s - 2640*D1**2*f*fd*gd2*r + 17424*D1**2*f*fd*gd2*s**2 - 13992*D1**2*f*fd*gd2*s + 2640*D1**2*f*fd*gd2 + 5280*D1**2*f*fdd*g2*r*s - 2640*D1**2*f*fdd*g2*r + 8712*D1**2*f*fdd*g2*s**2 - 8712*D1**2*f*fdd*g2*s + 4356*D1**2*f*fdd*g2 + 5280*D1**2*fd**2*g2*r*s - 2640*D1**2*fd**2*g2*r + 8712*D1**2*fd**2*g2*s**2 - 8712*D1**2*fd**2*g2*s - 4272*D1*Dd*f**3*r*s + 1068*D1*Dd*f**3*r - 13424*D1*Dd*f**3*s**2 + 8848*D1*Dd*f**3*s - 3356*D1*Dd*f**3 + 33408*D1*Dd*f**2*fd*r*s - 9744*D1*Dd*f**2*fd*r + 60864*D1*Dd*f**2*fd*s**2 - 49424*D1*Dd*f**2*fd*s + 9248*D1*Dd*f**2*fd - 14784*D1*Dd*f**2*g2*r*s + 3696*D1*Dd*f**2*g2*r - 26400*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 6600*D1*Dd*f**2*g2 + 21120*D1*Dd*f**2*gd2*r*s - 2640*D1*Dd*f**2*gd2*r + 34848*D1*Dd*f**2*gd2*s**2 - 24552*D1*Dd*f**2*gd2*s + 2640*D1*Dd*f**2*gd2 + 42240*D1*Dd*f*fd*g2*r*s - 15840*D1*Dd*f*fd*g2*r + 69696*D1*Dd*f*fd*g2*s**2 - 62832*D1*Dd*f*fd*g2*s + 13992*D1*Dd*f*fd*g2 + 5568*D1*Ddd*f**3*r*s - 1392*D1*Ddd*f**3*r + 10144*D1*Ddd*f**3*s**2 - 7856*D1*Ddd*f**3*s + 2536*D1*Ddd*f**3 + 10560*D1*Ddd*f**2*g2*r*s - 2640*D1*Ddd*f**2*g2*r + 17424*D1*Ddd*f**2*g2*s**2 - 13992*D1*Ddd*f**2*g2*s + 4356*D1*Ddd*f**2*g2 + 44*D1*bd1*(D1*(3*f**3*(r*(6*s - 9) - 6*s**2 - 7*s + 6) + f**2*(2*C*(r*(2*s - 11) - 8*s**2 - 2*s + 1) + 42*K*r*s + 75*K*s**2 - 42*K*s + 27*fd*(2*r + 6*s**2 - 2*s - 1) - 23*r*s + 39*r - 27*s**2 + 41*s - 22) + f*(fd*(-2*C*(4*r*(s - 2) - 19*s**2 + 6*s + 7) - 3*K*(40*r*s - 10*r + 66*s**2 - 53*s + 10) + 80*r*s - 43*r + 82*s**2 - 93*s + 29) + 2*g2*(r*(28*s + 5) + 40*s**2 - 14*s + 7) + gd2*(r*(2 - 28*s) - 59*s**2 + 49*s - 2)) + fd*g2*(r*(14 - 28*s) - s*(59*s - 59))) + Dd*f*(54*f**2*(2*r + 4*s**2 - s - 1) + f*(C*(r*(58 - 16*s) + 76*s**2 + 5*s - 33) - 3*K*(80*r*s - 10*r + 132*s**2 - 93*s + 10) + 160*r*s - 112*r + 164*s**2 - 209*s + 78) + g2*(r*(22 - 112*s) - 236*s**2 + 227*s - 39))) + 264*D1*bd2*f*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 16704*Dd**2*f**3*r*s - 4176*Dd**2*f**3*r + 30432*Dd**2*f**3*s**2 - 23568*Dd**2*f**3*s + 2784*Dd**2*f**3 + 31680*Dd**2*f**2*g2*r*s - 7920*Dd**2*f**2*g2*r + 52272*Dd**2*f**2*g2*s**2 - 41976*Dd**2*f**2*g2*s + 5280*Dd**2*f**2*g2 + 308*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 11*b1**2*(-16*C*D1**2*fd*r*s - 16*C*D1**2*fd*s**2 + 16*C*D1**2*fd*s + 8*C*D1**2*fdd*r*s + 8*C*D1**2*fdd*s**2 - 8*C*D1**2*fdd*s - 64*C*D1*Dd*f*r*s + 16*C*D1*Dd*f*r - 64*C*D1*Dd*f*s**2 + 64*C*D1*Dd*f*s - 16*C*D1*Dd*f + 64*C*D1*Dd*fd*r*s - 8*C*D1*Dd*fd*r + 64*C*D1*Dd*fd*s**2 - 64*C*D1*Dd*fd*s + 8*C*D1*Dd*fd + 32*C*D1*Ddd*f*r*s - 8*C*D1*Ddd*f*r + 32*C*D1*Ddd*f*s**2 - 32*C*D1*Ddd*f*s + 8*C*D1*Ddd*f + 96*C*Dd**2*f*r*s - 24*C*Dd**2*f*r + 96*C*Dd**2*f*s**2 - 96*C*Dd**2*f*s + 16*C*Dd**2*f - 112*D1**2*K*fd*r*s + 132*D1**2*K*fd*r - 160*D1**2*K*fd*s**2 + 264*D1**2*K*fd*s - 132*D1**2*K*fd + 28*D1**2*K*fdd*r*s - 24*D1**2*K*fdd*r + 59*D1**2*K*fdd*s**2 - 48*D1**2*K*fdd*s + 24*D1**2*K*fdd - 28*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 192*D1**2*f*fd*r*s - 84*D1**2*f*fd*r - 120*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 84*D1**2*f*fd + 96*D1**2*f*fdd*r*s + 48*D1**2*f*fdd*r + 60*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s - 48*D1**2*f*fdd + 96*D1**2*fd**2*r*s + 48*D1**2*fd**2*r + 60*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s - 48*D1**2*fd**2 - 24*D1**2*fd*r*s - 80*D1**2*fd*r + 12*D1**2*fd*s**2 - 176*D1**2*fd*s + 80*D1**2*fd + 12*D1**2*fdd*r*s + 12*D1**2*fdd*r - 13*D1**2*fdd*s**2 + 32*D1**2*fdd*s - 12*D1**2*fdd - 112*D1**2*gd2*r*s - 112*D1**2*gd2*s**2 + 112*D1**2*gd2*s + 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s - 448*D1*Dd*K*f*r*s + 112*D1*Dd*K*f*r - 640*D1*Dd*K*f*s**2 + 544*D1*Dd*K*f*s - 160*D1*Dd*K*f + 224*D1*Dd*K*fd*r*s - 124*D1*Dd*K*fd*r + 472*D1*Dd*K*fd*s**2 - 366*D1*Dd*K*fd*s + 96*D1*Dd*K*fd - 384*D1*Dd*f**2*r*s + 96*D1*Dd*f**2*r - 240*D1*Dd*f**2*s**2 + 312*D1*Dd*f**2*s - 60*D1*Dd*f**2 + 768*D1*Dd*f*fd*r*s + 96*D1*Dd*f*fd*r + 480*D1*Dd*f*fd*s**2 - 216*D1*Dd*f*fd*s - 120*D1*Dd*f*fd - 96*D1*Dd*f*r*s + 24*D1*Dd*f*r + 48*D1*Dd*f*s**2 + 24*D1*Dd*f*s + 12*D1*Dd*f + 96*D1*Dd*fd*r*s + 36*D1*Dd*fd*r - 104*D1*Dd*fd*s**2 + 130*D1*Dd*fd*s - 56*D1*Dd*fd - 448*D1*Dd*g2*r*s + 112*D1*Dd*g2*r - 448*D1*Dd*g2*s**2 + 448*D1*Dd*g2*s - 112*D1*Dd*g2 + 448*D1*Dd*gd2*r*s - 56*D1*Dd*gd2*r + 448*D1*Dd*gd2*s**2 - 448*D1*Dd*gd2*s + 56*D1*Dd*gd2 + 112*D1*Ddd*K*f*r*s - 28*D1*Ddd*K*f*r + 236*D1*Ddd*K*f*s**2 - 174*D1*Ddd*K*f*s + 59*D1*Ddd*K*f + 192*D1*Ddd*f**2*r*s - 48*D1*Ddd*f**2*r + 120*D1*Ddd*f**2*s**2 - 156*D1*Ddd*f**2*s + 30*D1*Ddd*f**2 + 48*D1*Ddd*f*r*s - 12*D1*Ddd*f*r - 52*D1*Ddd*f*s**2 + 2*D1*Ddd*f*s - 13*D1*Ddd*f + 224*D1*Ddd*g2*r*s - 56*D1*Ddd*g2*r + 224*D1*Ddd*g2*s**2 - 224*D1*Ddd*g2*s + 56*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 336*Dd**2*K*f*r*s - 84*Dd**2*K*f*r + 708*Dd**2*K*f*s**2 - 522*Dd**2*K*f*s + 56*Dd**2*K*f + 576*Dd**2*f**2*r*s - 144*Dd**2*f**2*r + 360*Dd**2*f**2*s**2 - 468*Dd**2*f**2*s + 96*Dd**2*f**2 + 144*Dd**2*f*r*s - 36*Dd**2*f*r - 156*Dd**2*f*s**2 + 6*Dd**2*f*s + 24*Dd**2*f + 672*Dd**2*g2*r*s - 168*Dd**2*g2*r + 672*Dd**2*g2*s**2 - 672*Dd**2*g2*s + 112*Dd**2*g2) - 11*b1*(28*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(-6*f**2*(16*r*(s - 1) + 10*s**2 - 30*s + 13) + f*(-8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-56*r*s + 4*r - 118*s**2 + 98*s - 35) - 24*r*s + 24*r + 26*s**2 + 18*s + 1) - 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 2*D1**2*(3*f**2*(2*fd*(3*r*(6*s + 1) - 18*s**2 + 7*s - 12) - 9*fdd*(2*r - 6*s**2 + 4*s - 3)) + f*(-54*fd**2*(2*r - 6*s**2 + 4*s - 1) + 2*fd*(2*C*(r*(4*s + 9) - 16*s**2 + 16*s - 9) + 3*K*(28*r*s - 14*r + 50*s**2 - 50*s + 25) - 46*r*s - 16*r - 54*s**2 + 36*s - 5) + fdd*(C*(-8*r*(s + 3) + 38*s**2 - 44*s + 24) - 3*K*(40*r*s - 20*r + 66*s**2 - 66*s + 33) + 80*r*s + 6*r + 82*s**2 - 58*s + 15) + s*(16*gd2*(7*r + 10*s - 7) + gdd2*(-28*r - 59*s + 28))) - 2*fd**2*(C*(4*r*(s + 3) - 19*s**2 + 22*s - 12) + 99*K*s**2 - 99*K*s + r*(60*K*s - 30*K - 40*s - 3) - 41*s**2 + 29*s + 9) + 2*fd*(2*g2*(r*(28*s - 33) + 40*s**2 - 66*s + 33) + gd2*(-4*r*(7*s - 3) - 59*s**2 + 38*s - 12)) + fdd*g2*(-4*r*(7*s - 6) - 59*s**2 + 48*s - 24)) + 2*D1*bd1*(D1*(6*f**2*(16*r*s - 15*r + 10*s**2 - 28*s + 12) + 2*f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + 56*K*r*s + 5*K*r + 80*K*s**2 - 42*K*s + 7*K - 6*fd*(16*r*s - 4*r + 10*s**2 - 13*s + 3) + 12*r*s - 26*r - 6*s**2 - 44*s + 17) - fd*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(56*r*s - 26*r + 118*s**2 - 97*s + 12) + 24*r*s - 26*s**2 + 23*s - 10) + 28*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 28*gd2*(-4*r*s + r - (1 - 2*s)**2)) - Dd*(6*f**2*(8*r*(8*s - 5) + 40*s**2 - 86*s + 31) + f*(8*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + K*(4*r*(56*s - 9) + 472*s**2 - 370*s + 53) + 96*r*s - 60*r - 104*s**2 - 34*s + 33) + 56*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 2*D1*(2*Dd*(-18*f**3*(-4*r*s + r + 4*s**2 + 1) + f**2*(-4*C*(-4*r*s + r + 16*s**2 - 6*s + 4) + 168*K*r*s - 42*K*r + 300*K*s**2 - 234*K*s + 75*K - 54*fd*(2*r - 12*s**2 + 7*s - 2) - 92*r*s + 23*r - 108*s**2 + 100*s - 27) + f*(fd*(2*C*(-2*r*(8*s + 11) + 76*s**2 - 59*s + 23) - 3*K*(20*r*(8*s - 3) + 264*s**2 - 238*s + 53) + 320*r*s - 28*r + 328*s**2 - 278*s + 23) + 8*g2*(7*r*(4*s - 1) + 40*s**2 - 34*s + 10) + gd2*(-14*r*(8*s - 1) - 236*s**2 + 143*s - 14)) + fd*g2*(r*(62 - 112*s) - 236*s**2 + 183*s - 48)) + Ddd*f*(54*f**2*(4*s**2 - 2*s + 1) + f*(C*(r*(4 - 16*s) + 76*s**2 - 30*s + 19) - 3*K*(80*r*s - 20*r + 132*s**2 - 106*s + 33) + 160*r*s - 40*r + 164*s**2 - 162*s + 41) + g2*(-28*r*(4*s - 1) - 236*s**2 + 174*s - 59))) + 4*Dd**2*f*(-162*f**2*s*(2*s - 1) + f*(C*(6*r*(4*s - 1) - 114*s**2 + 45*s + 4) + K*(90*r*(4*s - 1) + 594*s**2 - 477*s + 60) - 240*r*s + 60*r - 246*s**2 + 243*s - 40) + g2*(42*r*(4*s - 1) + 354*s**2 - 261*s + 28))) + 264*b2*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(462*d**2*k3**4) - D1**2*Pk3*Pkd2*ct**2*k1**2*k2*(192*C*D1**2*bd1**2*f*r*s - 96*C*D1**2*bd1**2*f*r + 192*C*D1**2*bd1**2*f*s**2 - 192*C*D1**2*bd1**2*f*s + 256*C*D1**2*bd1*f**2*r*s - 256*C*D1**2*bd1*f**2*r + 364*C*D1**2*bd1*f**2*s**2 - 728*C*D1**2*bd1*f**2*s + 364*C*D1**2*bd1*f**2 - 1088*C*D1**2*bd1*f*fd*r*s + 544*C*D1**2*bd1*f*fd*r - 1496*C*D1**2*bd1*f*fd*s**2 + 1768*C*D1**2*bd1*f*fd*s - 272*C*D1**2*bd1*f*fd - 272*C*D1**2*bdd1*f**2*r*s + 272*C*D1**2*bdd1*f**2*r - 374*C*D1**2*bdd1*f**2*s**2 + 748*C*D1**2*bdd1*f**2*s - 374*C*D1**2*bdd1*f**2 - 240*C*D1**2*f**2*fd*r*s + 80*C*D1**2*f**2*fd*r + 80*C*D1**2*f**2*fd*s - 150*C*D1**2*f**2*fdd*s**2 + 100*C*D1**2*f**2*fdd*s - 50*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*s**2 + 200*C*D1**2*f*fd**2*s - 2176*C*D1*Dd*bd1*f**2*r*s + 1360*C*D1*Dd*bd1*f**2*r - 2992*C*D1*Dd*bd1*f**2*s**2 + 4284*C*D1*Dd*bd1*f**2*s - 1292*C*D1*Dd*bd1*f**2 - 320*C*D1*Dd*f**3*r*s + 80*C*D1*Dd*f**3*r + 160*C*D1*Dd*f**3*s - 1200*C*D1*Dd*f**2*fd*s**2 + 700*C*D1*Dd*f**2*fd*s - 100*C*D1*Dd*f**2*fd - 200*C*D1*Ddd*f**3*s**2 + 100*C*D1*Ddd*f**3*s - 50*C*D1*Ddd*f**3 - 600*C*Dd**2*f**3*s**2 + 300*C*Dd**2*f**3*s - 304*D1**2*K*bd1**2*f*r*s + 152*D1**2*K*bd1**2*f*r - 444*D1**2*K*bd1**2*f*s**2 + 596*D1**2*K*bd1**2*f*s - 152*D1**2*K*bd1**2*f - 48*D1**2*K*bd1*f**2*r*s + 48*D1**2*K*bd1*f**2*s - 120*D1**2*K*bd1*f*fd*s**2 + 60*D1**2*K*bd1*f*fd*s - 30*D1**2*K*bdd1*f**2*s**2 + 216*D1**2*bd1**2*f**2*r*s - 108*D1**2*bd1**2*f**2*r + 180*D1**2*bd1**2*f**2*s**2 - 288*D1**2*bd1**2*f**2*s + 108*D1**2*bd1**2*f**2 - 64*D1**2*bd1**2*f*r*s + 32*D1**2*bd1**2*f*r - 12*D1**2*bd1**2*f*s**2 - 28*D1**2*bd1**2*f*s + 40*D1**2*bd1**2*f - 224*D1**2*bd1**2*g2*r*s + 112*D1**2*bd1**2*g2*r - 224*D1**2*bd1**2*g2*s**2 + 224*D1**2*bd1**2*g2*s - 144*D1**2*bd1*bd2*f*r*s + 72*D1**2*bd1*bd2*f*r - 144*D1**2*bd1*bd2*f*s**2 + 216*D1**2*bd1*bd2*f*s - 72*D1**2*bd1*bd2*f - 72*D1**2*bd1*f**2*r*s + 84*D1**2*bd1*f**2*r - 174*D1**2*bd1*f**2*s**2 + 336*D1**2*bd1*f**2*s - 174*D1**2*bd1*f**2 + 696*D1**2*bd1*f*fd*r*s - 348*D1**2*bd1*f*fd*r + 972*D1**2*bd1*f*fd*s**2 - 1146*D1**2*bd1*f*fd*s + 174*D1**2*bd1*f*fd - 272*D1**2*bd1*f*g2*r*s + 272*D1**2*bd1*f*g2*r - 440*D1**2*bd1*f*g2*s**2 + 880*D1**2*bd1*f*g2*s - 440*D1**2*bd1*f*g2 + 608*D1**2*bd1*f*gd2*r*s - 304*D1**2*bd1*f*gd2*r + 888*D1**2*bd1*f*gd2*s**2 - 1192*D1**2*bd1*f*gd2*s + 304*D1**2*bd1*f*gd2 + 608*D1**2*bd1*fd*g2*r*s - 304*D1**2*bd1*fd*g2*r + 888*D1**2*bd1*fd*g2*s**2 - 888*D1**2*bd1*fd*g2*s - 24*D1**2*bd2*f**2*r*s - 24*D1**2*bd2*f**2*s**2 + 24*D1**2*bd2*f**2*s + 174*D1**2*bdd1*f**2*r*s - 174*D1**2*bdd1*f**2*r + 243*D1**2*bdd1*f**2*s**2 - 486*D1**2*bdd1*f**2*s + 243*D1**2*bdd1*f**2 + 304*D1**2*bdd1*f*g2*r*s - 304*D1**2*bdd1*f*g2*r + 444*D1**2*bdd1*f*g2*s**2 - 888*D1**2*bdd1*f*g2*s + 444*D1**2*bdd1*f*g2 + 150*D1**2*f**2*fd*r*s - 50*D1**2*f**2*fd*r - 50*D1**2*f**2*fd*s + 75*D1**2*f**2*fdd*s**2 - 50*D1**2*f**2*fdd*s + 25*D1**2*f**2*fdd + 96*D1**2*f**2*gd2*r*s - 96*D1**2*f**2*gd2*s + 60*D1**2*f**2*gdd2*s**2 + 150*D1**2*f*fd**2*s**2 - 100*D1**2*f*fd**2*s + 192*D1**2*f*fd*g2*r*s - 96*D1**2*f*fd*g2*r + 240*D1**2*f*fd*gd2*s**2 - 120*D1**2*f*fd*gd2*s + 120*D1**2*f*fdd*g2*s**2 - 120*D1**2*f*fdd*g2*s + 60*D1**2*f*fdd*g2 + 120*D1**2*fd**2*g2*s**2 - 120*D1**2*fd**2*g2*s - 240*D1*Dd*K*bd1*f**2*s**2 + 60*D1*Dd*K*bd1*f**2*s + 1392*D1*Dd*bd1*f**2*r*s - 870*D1*Dd*bd1*f**2*r + 1944*D1*Dd*bd1*f**2*s**2 - 2778*D1*Dd*bd1*f**2*s + 834*D1*Dd*bd1*f**2 + 2432*D1*Dd*bd1*f*g2*r*s - 1520*D1*Dd*bd1*f*g2*r + 3552*D1*Dd*bd1*f*g2*s**2 - 5048*D1*Dd*bd1*f*g2*s + 1496*D1*Dd*bd1*f*g2 + 200*D1*Dd*f**3*r*s - 50*D1*Dd*f**3*r - 100*D1*Dd*f**3*s + 600*D1*Dd*f**2*fd*s**2 - 350*D1*Dd*f**2*fd*s + 50*D1*Dd*f**2*fd + 384*D1*Dd*f**2*g2*r*s - 96*D1*Dd*f**2*g2*r - 192*D1*Dd*f**2*g2*s + 480*D1*Dd*f**2*gd2*s**2 - 120*D1*Dd*f**2*gd2*s + 960*D1*Dd*f*fd*g2*s**2 - 720*D1*Dd*f*fd*g2*s + 120*D1*Dd*f*fd*g2 + 100*D1*Ddd*f**3*s**2 - 50*D1*Ddd*f**3*s + 25*D1*Ddd*f**3 + 240*D1*Ddd*f**2*g2*s**2 - 120*D1*Ddd*f**2*g2*s + 60*D1*Ddd*f**2*g2 + 8*D1*b2*(bd1*(D1*(11*f*(s - 1)*(r + s - 1) + 9*fd*(-2*r*s + r - s*(2*s - 2))) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + 300*Dd**2*f**3*s**2 - 150*Dd**2*f**3*s + 720*Dd**2*f**2*g2*s**2 - 360*Dd**2*f**2*g2*s + 4*b1**3*(D1**2*s*(17*fd - 12*fdd)*(r + s - 1) + D1*Dd*(17*f*(r*(4*s - 1) + (1 - 2*s)**2) - 12*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 2*(14*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 12*f + 7) - Dd**2*(-14*K + 12*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 2*b1**2*(-12*C*D1**2*fd*r*s - 12*C*D1**2*fd*s**2 + 12*C*D1**2*fd*s + 48*C*D1**2*fdd*r*s + 48*C*D1**2*fdd*s**2 - 48*C*D1**2*fdd*s - 48*C*D1*Dd*f*r*s + 12*C*D1*Dd*f*r - 48*C*D1*Dd*f*s**2 + 48*C*D1*Dd*f*s - 12*C*D1*Dd*f + 384*C*D1*Dd*fd*r*s - 48*C*D1*Dd*fd*r + 384*C*D1*Dd*fd*s**2 - 384*C*D1*Dd*fd*s + 48*C*D1*Dd*fd + 192*C*D1*Ddd*f*r*s - 48*C*D1*Ddd*f*r + 192*C*D1*Ddd*f*s**2 - 192*C*D1*Ddd*f*s + 48*C*D1*Ddd*f + 576*C*Dd**2*f*r*s - 144*C*Dd**2*f*r + 576*C*Dd**2*f*s**2 - 576*C*Dd**2*f*s + 96*C*Dd**2*f + 68*D1**2*K*fd*r*s + 110*D1**2*K*fd*s**2 - 76*D1**2*K*fdd*r*s - 111*D1**2*K*fdd*s**2 - 2*D1**2*bdd1*(-14*K + 12*f + 7)*(3*r*s - r + 3*s**2 - 3*s + 1) - 60*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 42*D1**2*f*fd*s - 12*D1**2*f*fd + 108*D1**2*f*fdd*r*s + 90*D1**2*f*fdd*s**2 - 54*D1**2*f*fdd*s + 108*D1**2*fd**2*r*s + 90*D1**2*fd**2*s**2 - 54*D1**2*fd**2*s + 32*D1**2*fd*r*s + 6*D1**2*fd*s**2 - 2*D1**2*fd*s - 16*D1**2*fdd*r*s - 3*D1**2*fdd*s**2 + 36*D1**2*fdd*s + 112*D1**2*gd2*r*s + 112*D1**2*gd2*s**2 - 112*D1**2*gd2*s - 56*D1**2*gdd2*r*s - 56*D1**2*gdd2*s**2 + 56*D1**2*gdd2*s + 272*D1*Dd*K*f*r*s - 68*D1*Dd*K*f*r + 440*D1*Dd*K*f*s**2 - 356*D1*Dd*K*f*s + 110*D1*Dd*K*f - 608*D1*Dd*K*fd*r*s + 76*D1*Dd*K*fd*r - 888*D1*Dd*K*fd*s**2 + 374*D1*Dd*K*fd*s - 120*D1*Dd*f**2*r*s + 30*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 84*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 864*D1*Dd*f*fd*r*s - 108*D1*Dd*f*fd*r + 720*D1*Dd*f*fd*s**2 - 612*D1*Dd*f*fd*s + 54*D1*Dd*f*fd + 128*D1*Dd*f*r*s - 32*D1*Dd*f*r + 24*D1*Dd*f*s**2 - 76*D1*Dd*f*s + 6*D1*Dd*f - 128*D1*Dd*fd*r*s + 16*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 182*D1*Dd*fd*s - 36*D1*Dd*fd + 448*D1*Dd*g2*r*s - 112*D1*Dd*g2*r + 448*D1*Dd*g2*s**2 - 448*D1*Dd*g2*s + 112*D1*Dd*g2 - 448*D1*Dd*gd2*r*s + 56*D1*Dd*gd2*r - 448*D1*Dd*gd2*s**2 + 448*D1*Dd*gd2*s - 56*D1*Dd*gd2 - 304*D1*Ddd*K*f*r*s + 76*D1*Ddd*K*f*r - 444*D1*Ddd*K*f*s**2 + 374*D1*Ddd*K*f*s - 111*D1*Ddd*K*f + 216*D1*Ddd*f**2*r*s - 54*D1*Ddd*f**2*r + 180*D1*Ddd*f**2*s**2 - 198*D1*Ddd*f**2*s + 45*D1*Ddd*f**2 - 64*D1*Ddd*f*r*s + 16*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 38*D1*Ddd*f*s - 3*D1*Ddd*f - 224*D1*Ddd*g2*r*s + 56*D1*Ddd*g2*r - 224*D1*Ddd*g2*s**2 + 224*D1*Ddd*g2*s - 56*D1*Ddd*g2 + 2*D1*bd1*(D1*(17*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 12*fd*(6*r*s - r + 6*s**2 - 6*s + 1) - 2*(14*K - 7)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(-14*K + 12*f + 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 912*Dd**2*K*f*r*s + 228*Dd**2*K*f*r - 1332*Dd**2*K*f*s**2 + 1122*Dd**2*K*f*s - 152*Dd**2*K*f + 648*Dd**2*f**2*r*s - 162*Dd**2*f**2*r + 540*Dd**2*f**2*s**2 - 594*Dd**2*f**2*s + 108*Dd**2*f**2 - 192*Dd**2*f*r*s + 48*Dd**2*f*r - 36*Dd**2*f*s**2 + 114*Dd**2*f*s - 32*Dd**2*f - 672*Dd**2*g2*r*s + 168*Dd**2*g2*r - 672*Dd**2*g2*s**2 + 672*Dd**2*g2*s - 112*Dd**2*g2) - b1*(-512*C*D1**2*f*fd*r*s - 728*C*D1**2*f*fd*s**2 + 256*C*D1**2*f*fd*s + 544*C*D1**2*f*fdd*r*s + 748*C*D1**2*f*fdd*s**2 - 272*C*D1**2*f*fdd*s + 544*C*D1**2*fd**2*r*s + 748*C*D1**2*fd**2*s**2 - 272*C*D1**2*fd**2*s - 1024*C*D1*Dd*f**2*r*s + 256*C*D1*Dd*f**2*r - 1456*C*D1*Dd*f**2*s**2 + 1240*C*D1*Dd*f**2*s - 364*C*D1*Dd*f**2 + 4352*C*D1*Dd*f*fd*r*s - 544*C*D1*Dd*f*fd*r + 5984*C*D1*Dd*f*fd*s**2 - 3672*C*D1*Dd*f*fd*s + 272*C*D1*Dd*f*fd + 1088*C*D1*Ddd*f**2*r*s - 272*C*D1*Ddd*f**2*r + 1496*C*D1*Ddd*f**2*s**2 - 1292*C*D1*Ddd*f**2*s + 374*C*D1*Ddd*f**2 + 3264*C*Dd**2*f**2*r*s - 816*C*Dd**2*f**2*r + 4488*C*Dd**2*f**2*s**2 - 3876*C*Dd**2*f**2*s + 544*C*Dd**2*f**2 + 96*D1**2*K*f*fd*r*s - 48*D1**2*K*f*fd*r + 60*D1**2*K*f*fdd*s**2 - 60*D1**2*K*f*fdd*s + 30*D1**2*K*f*fdd + 60*D1**2*K*fd**2*s**2 - 60*D1**2*K*fd**2*s - 88*D1**2*b2*fd*r*s - 88*D1**2*b2*fd*s**2 + 72*D1**2*b2*fdd*r*s + 72*D1**2*b2*fdd*s**2 + 4*D1**2*bd1**2*(-14*K + 12*f + 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 88*D1**2*bd2*f*r*s - 88*D1**2*bd2*f*s**2 + 88*D1**2*bd2*f*s + 144*D1**2*bd2*fd*r*s + 144*D1**2*bd2*fd*s**2 - 72*D1**2*bd2*fd*s - 2*D1**2*bdd1*(9*f**2*(6*r*(2*s - 1) + 10*s**2 - 16*s + 5) + f*(48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-152*r*s + 76*r - 222*s**2 + 298*s - 111) - 32*r*s + 16*r - 6*s**2 - 14*s - 3) - 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 72*D1**2*bdd2*f*r*s + 72*D1**2*bdd2*f*s**2 - 72*D1**2*bdd2*f*s + 144*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 348*D1**2*f*fd*s**2 - 84*D1**2*f*fd*s - 348*D1**2*f*fdd*r*s - 486*D1**2*f*fdd*s**2 + 174*D1**2*f*fdd*s + 272*D1**2*f*gd2*r*s + 440*D1**2*f*gd2*s**2 - 272*D1**2*f*gd2*s - 304*D1**2*f*gdd2*r*s - 444*D1**2*f*gdd2*s**2 + 304*D1**2*f*gdd2*s - 348*D1**2*fd**2*r*s - 486*D1**2*fd**2*s**2 + 174*D1**2*fd**2*s + 272*D1**2*fd*g2*r*s + 440*D1**2*fd*g2*s**2 - 608*D1**2*fd*gd2*r*s - 888*D1**2*fd*gd2*s**2 + 304*D1**2*fd*gd2*s - 304*D1**2*fdd*g2*r*s - 444*D1**2*fdd*g2*s**2 + 192*D1*Dd*K*f**2*r*s - 48*D1*Dd*K*f**2*r - 96*D1*Dd*K*f**2*s + 480*D1*Dd*K*f*fd*s**2 - 360*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 352*D1*Dd*b2*f*r*s + 88*D1*Dd*b2*f*r - 352*D1*Dd*b2*f*s**2 + 352*D1*Dd*b2*f*s - 88*D1*Dd*b2*f + 576*D1*Dd*b2*fd*r*s - 72*D1*Dd*b2*fd*r + 576*D1*Dd*b2*fd*s**2 - 288*D1*Dd*b2*fd*s + 576*D1*Dd*bd2*f*r*s - 72*D1*Dd*bd2*f*r + 576*D1*Dd*bd2*f*s**2 - 576*D1*Dd*bd2*f*s + 72*D1*Dd*bd2*f + 288*D1*Dd*f**2*r*s - 72*D1*Dd*f**2*r + 696*D1*Dd*f**2*s**2 - 492*D1*Dd*f**2*s + 174*D1*Dd*f**2 - 2784*D1*Dd*f*fd*r*s + 348*D1*Dd*f*fd*r - 3888*D1*Dd*f*fd*s**2 + 2364*D1*Dd*f*fd*s - 174*D1*Dd*f*fd + 1088*D1*Dd*f*g2*r*s - 272*D1*Dd*f*g2*r + 1760*D1*Dd*f*g2*s**2 - 1424*D1*Dd*f*g2*s + 440*D1*Dd*f*g2 - 2432*D1*Dd*f*gd2*r*s + 304*D1*Dd*f*gd2*r - 3552*D1*Dd*f*gd2*s**2 + 2712*D1*Dd*f*gd2*s - 304*D1*Dd*f*gd2 - 2432*D1*Dd*fd*g2*r*s + 304*D1*Dd*fd*g2*r - 3552*D1*Dd*fd*g2*s**2 + 1496*D1*Dd*fd*g2*s + 120*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 30*D1*Ddd*K*f**2 + 288*D1*Ddd*b2*f*r*s - 72*D1*Ddd*b2*f*r + 288*D1*Ddd*b2*f*s**2 - 288*D1*Ddd*b2*f*s + 72*D1*Ddd*b2*f - 696*D1*Ddd*f**2*r*s + 174*D1*Ddd*f**2*r - 972*D1*Ddd*f**2*s**2 + 834*D1*Ddd*f**2*s - 243*D1*Ddd*f**2 - 1216*D1*Ddd*f*g2*r*s + 304*D1*Ddd*f*g2*r - 1776*D1*Ddd*f*g2*s**2 + 1496*D1*Ddd*f*g2*s - 444*D1*Ddd*f*g2 + 4*D1*bd1*(D1*(3*f**2*(r*(10*s - 3) + s*(4*s - 7)) + f*(6*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 68*K*r*s + 34*K*r - 110*K*s**2 + 144*K*s - 55*K - 9*fd*(24*r*s - 6*r + 20*s**2 - 22*s + 3) - 32*r*s + 16*r - 6*s**2 + 21*s - 3) + fd*(-24*C*(r*(4*s - 1) + (1 - 2*s)**2) + 222*K*s**2 - 149*K*s + r*(38*K + 8)*(4*s - 1) + 6*s**2 - 29*s + 18) - 28*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 28*gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*(-18*f**2*(3*r*(8*s - 3) + 20*s**2 - 27*s + 7) + f*(-48*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + K*(76*r*(8*s - 3) + 888*s**2 - 970*s + 225) + 128*r*s - 48*r + 24*s**2 - 10*s + 9) + 56*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 360*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 864*Dd**2*b2*f*r*s - 216*Dd**2*b2*f*r + 864*Dd**2*b2*f*s**2 - 864*Dd**2*b2*f*s + 144*Dd**2*b2*f - 2088*Dd**2*f**2*r*s + 522*Dd**2*f**2*r - 2916*Dd**2*f**2*s**2 + 2502*Dd**2*f**2*s - 348*Dd**2*f**2 - 3648*Dd**2*f*g2*r*s + 912*Dd**2*f*g2*r - 5328*Dd**2*f*g2*s**2 + 4488*Dd**2*f*g2*s - 608*Dd**2*f*g2))/(21*d**2*k3**4) - 3*D1**2*Pk3*Pkd2*ct**2*k1**2*st**4*(D1**2*(132*bd1*fd*g2*s*(s - 1) + f**3*s**2*(-90*bd1 + 45*bdd1) + 10*f**2*(fd*(s**2*(27*bd1 - 6) + s*(4 - 9*bd1) - 2) + fdd*(3*s**2 - 2*s + 1)) + 2*f*s*(10*fd**2*(3*s - 2) + s*(-33*K*bd1**2 + 33*bd1**2 - 66*bd1*g2 + 66*bd1*gd2 + 33*bdd1*g2))) + 2*D1*f*(Dd*(66*bd1*g2*s*(4*s - 1) + 5*f**2*(s**2*(36*bd1 - 8) + s*(4 - 9*bd1) - 2) + 10*f*fd*(12*s**2 - 7*s + 1)) + 5*Ddd*f**2*(4*s**2 - 2*s + 1)) + 60*Dd**2*f**3*s*(2*s - 1) + 33*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) - 3*b1*(D1**2*(15*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*f*s*(fd**2*(30 - 45*s) - s*(-11*K*bdd1 + 22*bd1*(K - 1) + 11*bdd1 - 22*gd2 + 11*gdd2)) + (22*s - 22)*(2*fd*g2*(s - 1) - 2*fd*s*(-K*bd1 + bd1 + gd2) - fdd*g2*(s - 1))) + D1*(2*Dd*(15*f**3*(4*s**2 - 2*s + 1) - 15*f**2*fd*(12*s**2 - 7*s + 1) + 22*f*(g2*(4*s**2 - 2*s + 1) - s*(4*s - 1)*(-K*bd1 + bd1 + gd2)) - 22*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(15*f**2 + 22*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(15*f**2 + 22*g2)*(2*s - 1)))/(77*d**2*k2*k3**2) + D1**2*Pk3*Pkd2*ct**2*k1**2*st**2*(-3000*C*D1**2*f**2*fd*s**2 + 2000*C*D1**2*f**2*fd*s - 1000*C*D1**2*f**2*fd + 1500*C*D1**2*f**2*fdd*s**2 - 1000*C*D1**2*f**2*fdd*s + 500*C*D1**2*f**2*fdd + 3000*C*D1**2*f*fd**2*s**2 - 2000*C*D1**2*f*fd**2*s - 4000*C*D1*Dd*f**3*s**2 + 2000*C*D1*Dd*f**3*s - 1000*C*D1*Dd*f**3 + 12000*C*D1*Dd*f**2*fd*s**2 - 7000*C*D1*Dd*f**2*fd*s + 1000*C*D1*Dd*f**2*fd + 2000*C*D1*Ddd*f**3*s**2 - 1000*C*D1*Ddd*f**3*s + 500*C*D1*Ddd*f**3 + 6000*C*Dd**2*f**3*s**2 - 3000*C*Dd**2*f**3*s - 1320*D1**2*b2*f*fd*s**2 + 1320*D1**2*b2*f*fd*s - 660*D1**2*b2*f*fd + 660*D1**2*b2*f*fdd*s**2 - 660*D1**2*b2*f*fdd*s + 330*D1**2*b2*f*fdd + 660*D1**2*b2*fd**2*s**2 - 660*D1**2*b2*fd**2*s - 22*D1**2*bd1**2*s*(30*f**2*(2*s - 3) + f*(10*C*(s - 1) + 23*K*s - 3*s - 20) + 70*g2*(s - 1)) - 660*D1**2*bd2*f**2*s**2 + 1320*D1**2*bd2*f*fd*s**2 - 660*D1**2*bd2*f*fd*s + 22*D1**2*bdd1*f*(9*f**2*s*(4*r + 9*s - 2) + f*(s**2*(17*C + 15*K + 1) + s*(12*r + 18) - 15) + 23*g2*s**2) + 330*D1**2*bdd2*f**2*s**2 - 924*D1**2*f**2*fd*r*s + 308*D1**2*f**2*fd*r - 2076*D1**2*f**2*fd*s**2 + 1692*D1**2*f**2*fd*s - 692*D1**2*f**2*fd + 792*D1**2*f**2*fdd*r*s - 264*D1**2*f**2*fdd*r + 1236*D1**2*f**2*fdd*s**2 - 1088*D1**2*f**2*fdd*s + 412*D1**2*f**2*fdd + 1320*D1**2*f**2*gd2*s**2 - 660*D1**2*f**2*gdd2*s**2 + 1584*D1**2*f*fd**2*r*s - 528*D1**2*f*fd**2*r + 2472*D1**2*f*fd**2*s**2 - 2176*D1**2*f*fd**2*s + 264*D1**2*f*fd**2 + 2640*D1**2*f*fd*g2*s**2 - 2640*D1**2*f*fd*g2*s + 1320*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 1320*D1**2*f*fdd*g2*s**2 + 1320*D1**2*f*fdd*g2*s - 660*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*s**2 + 1320*D1**2*fd**2*g2*s - 2640*D1*Dd*b2*f**2*s**2 + 1320*D1*Dd*b2*f**2*s - 660*D1*Dd*b2*f**2 + 5280*D1*Dd*b2*f*fd*s**2 - 3960*D1*Dd*b2*f*fd*s + 660*D1*Dd*b2*f*fd + 2640*D1*Dd*bd2*f**2*s**2 - 660*D1*Dd*bd2*f**2*s - 1232*D1*Dd*f**3*r*s + 308*D1*Dd*f**3*r - 2768*D1*Dd*f**3*s**2 + 2000*D1*Dd*f**3*s - 692*D1*Dd*f**3 + 6336*D1*Dd*f**2*fd*r*s - 1848*D1*Dd*f**2*fd*r + 9888*D1*Dd*f**2*fd*s**2 - 8408*D1*Dd*f**2*fd*s + 1616*D1*Dd*f**2*fd + 5280*D1*Dd*f**2*g2*s**2 - 2640*D1*Dd*f**2*g2*s + 1320*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*s**2 + 1320*D1*Dd*f**2*gd2*s - 10560*D1*Dd*f*fd*g2*s**2 + 7920*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 + 1320*D1*Ddd*b2*f**2*s**2 - 660*D1*Ddd*b2*f**2*s + 330*D1*Ddd*b2*f**2 + 1056*D1*Ddd*f**3*r*s - 264*D1*Ddd*f**3*r + 1648*D1*Ddd*f**3*s**2 - 1352*D1*Ddd*f**3*s + 412*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 660*D1*Ddd*f**2*g2 - 44*D1*bd1*(D1*(9*f**3*s*(2*r + 8*s - 1) + f**2*(-9*fd*(2*r*(6*s - 1) + 27*s**2 - 15*s + 1) + s**2*(16*C + 15*K - 1) + s*(9*r + 21) - 15) - f*(fd*(6*r*(4*s - 1) + s**2*(34*C + 30*K + 2) + s*(-17*C - 15*K + 2) + 6) + s**2*(-16*g2 + 23*gd2)) - 23*fd*g2*s*(s - 1)) - Dd*f*(9*f**2*(2*r*(8*s - 1) + 36*s**2 - 17*s + 1) + f*(6*r*(8*s - 1) + s**2*(68*C + 60*K + 4) + s*(-17*C - 15*K + 23) - 9) + 23*g2*s*(4*s - 1))) + 3960*Dd**2*b2*f**2*s**2 - 1980*Dd**2*b2*f**2*s + 3168*Dd**2*f**3*r*s - 792*Dd**2*f**3*r + 4944*Dd**2*f**3*s**2 - 4056*Dd**2*f**3*s + 528*Dd**2*f**3 - 7920*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 385*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) - 11*b1**2*(-20*C*D1**2*fd*s**2 + 10*C*D1**2*fdd*s**2 - 80*C*D1*Dd*f*s**2 + 40*C*D1*Dd*f*s - 20*C*D1*Dd*f + 80*C*D1*Dd*fd*s**2 - 20*C*D1*Dd*fd*s + 40*C*D1*Ddd*f*s**2 - 20*C*D1*Ddd*f*s + 10*C*D1*Ddd*f + 120*C*Dd**2*f*s**2 - 60*C*Dd**2*f*s - 32*D1**2*K*fd*s**2 + 64*D1**2*K*fd*s - 32*D1**2*K*fd + 23*D1**2*K*fdd*s**2 - 46*D1**2*K*fdd*s + 23*D1**2*K*fdd - 35*D1**2*bdd1*(K - 1)*(3*s**2 - 2*s + 1) - 240*D1**2*f*fd*s**2 - 120*D1**2*f*fd*s + 60*D1**2*f*fd + 120*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s - 30*D1**2*f*fdd + 120*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s - 8*D1**2*fd*s**2 - 64*D1**2*fd*s + 32*D1**2*fd - 3*D1**2*fdd*s**2 + 46*D1**2*fdd*s - 23*D1**2*fdd - 140*D1**2*gd2*s**2 + 70*D1**2*gdd2*s**2 - 128*D1*Dd*K*f*s**2 + 64*D1*Dd*K*f*s - 32*D1*Dd*K*f + 184*D1*Dd*K*fd*s**2 - 230*D1*Dd*K*fd*s + 46*D1*Dd*K*fd - 480*D1*Dd*f**2*s**2 + 240*D1*Dd*f**2*s - 120*D1*Dd*f**2 + 960*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd - 32*D1*Dd*f*s**2 + 16*D1*Dd*f*s - 8*D1*Dd*f - 24*D1*Dd*fd*s**2 + 190*D1*Dd*fd*s - 46*D1*Dd*fd - 560*D1*Dd*g2*s**2 + 280*D1*Dd*g2*s - 140*D1*Dd*g2 + 560*D1*Dd*gd2*s**2 - 140*D1*Dd*gd2*s + 92*D1*Ddd*K*f*s**2 - 46*D1*Ddd*K*f*s + 23*D1*Ddd*K*f + 240*D1*Ddd*f**2*s**2 - 120*D1*Ddd*f**2*s + 60*D1*Ddd*f**2 - 12*D1*Ddd*f*s**2 + 6*D1*Ddd*f*s - 3*D1*Ddd*f + 280*D1*Ddd*g2*s**2 - 140*D1*Ddd*g2*s + 70*D1*Ddd*g2 + 70*D1*bd1*(K - 1)*(D1*(3*s**2 - 2*s + 1) + Dd*(-12*s**2 + 7*s - 1)) + 276*Dd**2*K*f*s**2 - 138*Dd**2*K*f*s + 720*Dd**2*f**2*s**2 - 360*Dd**2*f**2*s - 36*Dd**2*f*s**2 + 18*Dd**2*f*s + 840*Dd**2*g2*s**2 - 420*Dd**2*g2*s) + 22*b1*(-64*C*D1**2*f*fd*s**2 + 64*C*D1**2*f*fd*s - 32*C*D1**2*f*fd + 34*C*D1**2*f*fdd*s**2 - 34*C*D1**2*f*fdd*s + 17*C*D1**2*f*fdd + 34*C*D1**2*fd**2*s**2 - 34*C*D1**2*fd**2*s - 128*C*D1*Dd*f**2*s**2 + 64*C*D1*Dd*f**2*s - 32*C*D1*Dd*f**2 + 272*C*D1*Dd*f*fd*s**2 - 204*C*D1*Dd*f*fd*s + 34*C*D1*Dd*f*fd + 68*C*D1*Ddd*f**2*s**2 - 34*C*D1*Ddd*f**2*s + 17*C*D1*Ddd*f**2 + 204*C*Dd**2*f**2*s**2 - 102*C*Dd**2*f**2*s - 60*D1**2*K*f*fd*s**2 + 60*D1**2*K*f*fd*s - 30*D1**2*K*f*fd + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s + 35*D1**2*bd1**2*s*(K - 1)*(3*s - 2) - D1**2*bdd1*(15*f**2*(4*s**2 - 6*s + 3) + f*(5*C*(2*s**2 - 2*s + 1) + s**2*(23*K - 3) - 20*s + 10) + 35*g2*(2*s**2 - 2*s + 1)) - 108*D1**2*f**2*fd*r*s + 36*D1**2*f**2*fd*r - 432*D1**2*f**2*fd*s**2 + 342*D1**2*f**2*fd*s - 144*D1**2*f**2*fd + 108*D1**2*f**2*fdd*r*s - 36*D1**2*f**2*fdd*r + 243*D1**2*f**2*fdd*s**2 - 216*D1**2*f**2*fdd*s + 81*D1**2*f**2*fdd + 216*D1**2*f*fd**2*r*s - 72*D1**2*f*fd**2*r + 486*D1**2*f*fd**2*s**2 - 432*D1**2*f*fd**2*s + 54*D1**2*f*fd**2 - 36*D1**2*f*fd*r*s + 18*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 + 56*D1**2*f*fd*s - 28*D1**2*f*fd + 24*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 32*D1**2*f*fdd*s + 16*D1**2*f*fdd - 32*D1**2*f*gd2*s**2 + 23*D1**2*f*gdd2*s**2 + 24*D1**2*fd**2*r*s - 12*D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 32*D1**2*fd**2*s - 32*D1**2*fd*g2*s**2 + 64*D1**2*fd*g2*s - 32*D1**2*fd*g2 + 46*D1**2*fd*gd2*s**2 - 46*D1**2*fd*gd2*s + 23*D1**2*fdd*g2*s**2 - 46*D1**2*fdd*g2*s + 23*D1**2*fdd*g2 - 120*D1*Dd*K*f**2*s**2 + 60*D1*Dd*K*f**2*s - 30*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*s**2 - 180*D1*Dd*K*f*fd*s + 30*D1*Dd*K*f*fd - 144*D1*Dd*f**3*r*s + 36*D1*Dd*f**3*r - 576*D1*Dd*f**3*s**2 + 360*D1*Dd*f**3*s - 144*D1*Dd*f**3 + 864*D1*Dd*f**2*fd*r*s - 252*D1*Dd*f**2*fd*r + 1944*D1*Dd*f**2*fd*s**2 - 1566*D1*Dd*f**2*fd*s + 288*D1*Dd*f**2*fd - 72*D1*Dd*f**2*r*s + 18*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s + 2*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 180*D1*Dd*f*fd*s + 56*D1*Dd*f*fd - 128*D1*Dd*f*g2*s**2 + 64*D1*Dd*f*g2*s - 32*D1*Dd*f*g2 + 184*D1*Dd*f*gd2*s**2 - 46*D1*Dd*f*gd2*s + 184*D1*Dd*fd*g2*s**2 - 230*D1*Dd*fd*g2*s + 46*D1*Dd*fd*g2 + 60*D1*Ddd*K*f**2*s**2 - 30*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 + 144*D1*Ddd*f**3*r*s - 36*D1*Ddd*f**3*r + 324*D1*Ddd*f**3*s**2 - 234*D1*Ddd*f**3*s + 81*D1*Ddd*f**3 + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 26*D1*Ddd*f**2*s + D1*Ddd*f**2 + 92*D1*Ddd*f*g2*s**2 - 46*D1*Ddd*f*g2*s + 23*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(15*f**2*(4*s**2 - 6*s + 3) + f*(5*C*(2*s**2 - 2*s + 1) + s**2*(16*K - 120*fd + 4) + s*(60*fd - 20) + 10) + fd*s*(C*(5 - 10*s) - 23*K*(s - 1) + 3*s - 13) + 35*g2*(2*s**2 - 2*s + 1) + 35*gd2*s*(1 - 2*s)) - Dd*(4*s - 1)*(15*f**2*(4*s - 3) + f*(5*C*(2*s - 1) + 23*K*s - 3*s - 10) + 35*g2*(2*s - 1))) + 180*Dd**2*K*f**2*s**2 - 90*Dd**2*K*f**2*s + 432*Dd**2*f**3*r*s - 108*Dd**2*f**3*r + 972*Dd**2*f**3*s**2 - 702*Dd**2*f**3*s + 72*Dd**2*f**3 + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 78*Dd**2*f**2*s + 24*Dd**2*f**2 + 276*Dd**2*f*g2*s**2 - 138*Dd**2*f*g2*s))/(462*d**2*k2*k3**2) + D1**2*Pk3*Pkd2*ct**2*k1**2*(124*C*D1**2*bd1**2*f*s**2 - 124*C*D1**2*bd1**2*f*s - 20*C*D1**2*bd1*f**2*s**2 + 40*C*D1**2*bd1*f**2*s - 20*C*D1**2*bd1*f**2 + 40*C*D1**2*bd1*f*fd*s**2 - 40*C*D1**2*bd1*f*fd*s + 10*C*D1**2*bdd1*f**2*s**2 - 20*C*D1**2*bdd1*f**2*s + 10*C*D1**2*bdd1*f**2 + 240*C*D1**2*f**2*fd*s**2 - 160*C*D1**2*f**2*fd*s + 80*C*D1**2*f**2*fd - 150*C*D1**2*f**2*fdd*s**2 + 100*C*D1**2*f**2*fdd*s - 50*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*s**2 + 200*C*D1**2*f*fd**2*s + 80*C*D1*Dd*bd1*f**2*s**2 - 100*C*D1*Dd*bd1*f**2*s + 20*C*D1*Dd*bd1*f**2 + 320*C*D1*Dd*f**3*s**2 - 160*C*D1*Dd*f**3*s + 80*C*D1*Dd*f**3 - 1200*C*D1*Dd*f**2*fd*s**2 + 700*C*D1*Dd*f**2*fd*s - 100*C*D1*Dd*f**2*fd - 200*C*D1*Ddd*f**3*s**2 + 100*C*D1*Ddd*f**3*s - 50*C*D1*Ddd*f**3 - 600*C*Dd**2*f**3*s**2 + 300*C*Dd**2*f**3*s + 12*D1**2*K*bd1**2*f*s**2 - 12*D1**2*K*bd1**2*f*s + 48*D1**2*K*bd1*f**2*s**2 - 120*D1**2*K*bd1*f*fd*s**2 + 60*D1**2*K*bd1*f*fd*s - 30*D1**2*K*bdd1*f**2*s**2 + 144*D1**2*bd1**2*f**2*r*s - 72*D1**2*bd1**2*f**2*r + 120*D1**2*bd1**2*f**2*s**2 - 216*D1**2*bd1**2*f**2*s + 36*D1**2*bd1**2*f**2 + 80*D1**2*bd1**2*f*r*s - 40*D1**2*bd1**2*f*r + 8*D1**2*bd1**2*f*s**2 - 48*D1**2*bd1**2*f*s + 40*D1**2*bd1**2*f - 112*D1**2*bd1**2*g2*s**2 + 112*D1**2*bd1**2*g2*s + 12*D1**2*bd1*bd2*f*s**2 - 12*D1**2*bd1*bd2*f*s - 40*D1**2*bd1*f**2*r*s + 52*D1**2*bd1*f**2*r - 78*D1**2*bd1*f**2*s**2 + 144*D1**2*bd1*f**2*s - 78*D1**2*bd1*f**2 + 152*D1**2*bd1*f*fd*r*s - 76*D1**2*bd1*f*fd*r + 204*D1**2*bd1*f*fd*s**2 - 242*D1**2*bd1*f*fd*s + 38*D1**2*bd1*f*fd + 24*D1**2*bd1*f*g2*s**2 - 48*D1**2*bd1*f*g2*s + 24*D1**2*bd1*f*g2 - 24*D1**2*bd1*f*gd2*s**2 + 24*D1**2*bd1*f*gd2*s - 24*D1**2*bd1*fd*g2*s**2 + 24*D1**2*bd1*fd*g2*s + 48*D1**2*bd2*f**2*s**2 - 120*D1**2*bd2*f*fd*s**2 + 60*D1**2*bd2*f*fd*s + 38*D1**2*bdd1*f**2*r*s - 38*D1**2*bdd1*f**2*r + 51*D1**2*bdd1*f**2*s**2 - 102*D1**2*bdd1*f**2*s + 51*D1**2*bdd1*f**2 - 12*D1**2*bdd1*f*g2*s**2 + 24*D1**2*bdd1*f*g2*s - 12*D1**2*bdd1*f*g2 - 30*D1**2*bdd2*f**2*s**2 + 30*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r - 120*D1**2*f**2*fd*s**2 + 70*D1**2*f**2*fd*s - 40*D1**2*f**2*fd + 75*D1**2*f**2*fdd*s**2 - 50*D1**2*f**2*fdd*s + 25*D1**2*f**2*fdd - 96*D1**2*f**2*gd2*s**2 + 60*D1**2*f**2*gdd2*s**2 + 150*D1**2*f*fd**2*s**2 - 100*D1**2*f*fd**2*s - 192*D1**2*f*fd*g2*s**2 + 192*D1**2*f*fd*g2*s - 96*D1**2*f*fd*g2 + 240*D1**2*f*fd*gd2*s**2 - 120*D1**2*f*fd*gd2*s + 120*D1**2*f*fdd*g2*s**2 - 120*D1**2*f*fdd*g2*s + 60*D1**2*f*fdd*g2 + 120*D1**2*fd**2*g2*s**2 - 120*D1**2*fd**2*g2*s - 240*D1*Dd*K*bd1*f**2*s**2 + 60*D1*Dd*K*bd1*f**2*s + 304*D1*Dd*bd1*f**2*r*s - 190*D1*Dd*bd1*f**2*r + 408*D1*Dd*bd1*f**2*s**2 - 586*D1*Dd*bd1*f**2*s + 178*D1*Dd*bd1*f**2 - 96*D1*Dd*bd1*f*g2*s**2 + 120*D1*Dd*bd1*f*g2*s - 24*D1*Dd*bd1*f*g2 - 240*D1*Dd*bd2*f**2*s**2 + 60*D1*Dd*bd2*f**2*s + 40*D1*Dd*f**3*r*s - 10*D1*Dd*f**3*r - 160*D1*Dd*f**3*s**2 + 60*D1*Dd*f**3*s - 40*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*s**2 - 350*D1*Dd*f**2*fd*s + 50*D1*Dd*f**2*fd - 384*D1*Dd*f**2*g2*s**2 + 192*D1*Dd*f**2*g2*s - 96*D1*Dd*f**2*g2 + 480*D1*Dd*f**2*gd2*s**2 - 120*D1*Dd*f**2*gd2*s + 960*D1*Dd*f*fd*g2*s**2 - 720*D1*Dd*f*fd*g2*s + 120*D1*Dd*f*fd*g2 + 100*D1*Ddd*f**3*s**2 - 50*D1*Ddd*f**3*s + 25*D1*Ddd*f**3 + 240*D1*Ddd*f**2*g2*s**2 - 120*D1*Ddd*f**2*g2*s + 60*D1*Ddd*f**2*g2 + 300*Dd**2*f**3*s**2 - 150*Dd**2*f**3*s + 720*Dd**2*f**2*g2*s**2 - 360*Dd**2*f**2*g2*s - 2*b1**3*(3*D1**2*s**2*(2*fd - fdd) + D1*(2*Dd*(14*K*(4*s**2 - 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s - 56*s**2 + 28*s - 14) - Ddd*(14*K + 3*f - 14)*(4*s**2 - 2*s + 1)) - 6*Dd**2*s*(2*s - 1)*(14*K + 3*f - 14)) - 2*b1**2*(48*C*D1**2*fd*s**2 - 31*C*D1**2*fdd*s**2 + 192*C*D1*Dd*f*s**2 - 96*C*D1*Dd*f*s + 48*C*D1*Dd*f - 248*C*D1*Dd*fd*s**2 + 62*C*D1*Dd*fd*s - 124*C*D1*Ddd*f*s**2 + 62*C*D1*Ddd*f*s - 31*C*D1*Ddd*f - 372*C*Dd**2*f*s**2 + 186*C*Dd**2*f*s + 6*D1**2*K*fd*s**2 - 3*D1**2*K*fdd*s**2 - D1**2*bdd1*(14*K + 3*f - 14)*(3*s**2 - 2*s + 1) + 72*D1**2*f*fd*r*s + 96*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s - 24*D1**2*f*fd - 72*D1**2*f*fdd*r*s - 60*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s + 15*D1**2*f*fdd - 72*D1**2*fd**2*r*s - 60*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s + 26*D1**2*fd*r*s + 4*D1**2*fd*s**2 - 20*D1**2*fdd*r*s - 2*D1**2*fdd*s**2 - 56*D1**2*gd2*s**2 + 28*D1**2*gdd2*s**2 + 24*D1*Dd*K*f*s**2 - 12*D1*Dd*K*f*s + 6*D1*Dd*K*f - 24*D1*Dd*K*fd*s**2 + 6*D1*Dd*K*fd*s + 144*D1*Dd*f**2*r*s - 36*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 168*D1*Dd*f**2*s + 48*D1*Dd*f**2 - 576*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*r - 480*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 24*D1*Dd*f*fd + 104*D1*Dd*f*r*s - 26*D1*Dd*f*r + 16*D1*Dd*f*s**2 - 60*D1*Dd*f*s + 4*D1*Dd*f - 160*D1*Dd*fd*r*s + 20*D1*Dd*fd*r - 16*D1*Dd*fd*s**2 + 44*D1*Dd*fd*s - 224*D1*Dd*g2*s**2 + 112*D1*Dd*g2*s - 56*D1*Dd*g2 + 224*D1*Dd*gd2*s**2 - 56*D1*Dd*gd2*s - 12*D1*Ddd*K*f*s**2 + 6*D1*Ddd*K*f*s - 3*D1*Ddd*K*f - 144*D1*Ddd*f**2*r*s + 36*D1*Ddd*f**2*r - 120*D1*Ddd*f**2*s**2 + 132*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 - 80*D1*Ddd*f*r*s + 20*D1*Ddd*f*r - 8*D1*Ddd*f*s**2 + 44*D1*Ddd*f*s - 2*D1*Ddd*f + 112*D1*Ddd*g2*s**2 - 56*D1*Ddd*g2*s + 28*D1*Ddd*g2 + 2*D1*bd1*(D1*(14*K*(3*s**2 - 2*s + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s - 42*s**2 + 28*s - 14) - Dd*(14*K + 3*f - 14)*(12*s**2 - 7*s + 1)) - 36*Dd**2*K*f*s**2 + 18*Dd**2*K*f*s - 432*Dd**2*f**2*r*s + 108*Dd**2*f**2*r - 360*Dd**2*f**2*s**2 + 396*Dd**2*f**2*s - 72*Dd**2*f**2 - 240*Dd**2*f*r*s + 60*Dd**2*f*r - 24*Dd**2*f*s**2 + 132*Dd**2*f*s - 40*Dd**2*f + 336*Dd**2*g2*s**2 - 168*Dd**2*g2*s) + b1*(-40*C*D1**2*f*fd*s**2 + 20*C*D1**2*f*fdd*s**2 + 20*C*D1**2*fd**2*s**2 - 80*C*D1*Dd*f**2*s**2 + 40*C*D1*Dd*f**2*s - 20*C*D1*Dd*f**2 + 160*C*D1*Dd*f*fd*s**2 - 40*C*D1*Dd*f*fd*s + 40*C*D1*Ddd*f**2*s**2 - 20*C*D1*Ddd*f**2*s + 10*C*D1*Ddd*f**2 + 120*C*Dd**2*f**2*s**2 - 60*C*Dd**2*f**2*s + 96*D1**2*K*f*fd*s**2 - 96*D1**2*K*f*fd*s + 48*D1**2*K*f*fd - 60*D1**2*K*f*fdd*s**2 + 60*D1**2*K*f*fdd*s - 30*D1**2*K*f*fdd - 60*D1**2*K*fd**2*s**2 + 60*D1**2*K*fd**2*s - 12*D1**2*b2*fd*s**2 + 6*D1**2*b2*fdd*s**2 + 4*D1**2*bd1**2*s*(3*s - 2)*(14*K + 3*f - 14) - 12*D1**2*bd2*f*s**2 + 12*D1**2*bd2*fd*s**2 + 2*D1**2*bdd1*(3*f**2*(12*r*(2*s - 1) + 20*s**2 - 36*s + 15) + f*(31*C*(2*s**2 - 2*s + 1) + K*(6*s**2 - 6*s + 3) + 40*r*s - 20*r + 4*s**2 - 24*s + 2) - 28*g2*(2*s**2 - 2*s + 1)) + 6*D1**2*bdd2*f*s**2 - 80*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 156*D1**2*f*fd*s**2 + 52*D1**2*f*fd*s + 76*D1**2*f*fdd*r*s + 102*D1**2*f*fdd*s**2 - 38*D1**2*f*fdd*s + 24*D1**2*f*gd2*s**2 - 12*D1**2*f*gdd2*s**2 + 76*D1**2*fd**2*r*s + 102*D1**2*fd**2*s**2 - 38*D1**2*fd**2*s + 24*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*s**2 - 12*D1**2*fdd*g2*s**2 + 192*D1*Dd*K*f**2*s**2 - 96*D1*Dd*K*f**2*s + 48*D1*Dd*K*f**2 - 480*D1*Dd*K*f*fd*s**2 + 360*D1*Dd*K*f*fd*s - 60*D1*Dd*K*f*fd - 48*D1*Dd*b2*f*s**2 + 24*D1*Dd*b2*f*s - 12*D1*Dd*b2*f + 48*D1*Dd*b2*fd*s**2 - 12*D1*Dd*b2*fd*s + 48*D1*Dd*bd2*f*s**2 - 12*D1*Dd*bd2*f*s - 160*D1*Dd*f**2*r*s + 40*D1*Dd*f**2*r - 312*D1*Dd*f**2*s**2 + 236*D1*Dd*f**2*s - 78*D1*Dd*f**2 + 608*D1*Dd*f*fd*r*s - 76*D1*Dd*f*fd*r + 816*D1*Dd*f*fd*s**2 - 508*D1*Dd*f*fd*s + 38*D1*Dd*f*fd + 96*D1*Dd*f*g2*s**2 - 48*D1*Dd*f*g2*s + 24*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*s**2 + 24*D1*Dd*f*gd2*s - 96*D1*Dd*fd*g2*s**2 + 24*D1*Dd*fd*g2*s - 120*D1*Ddd*K*f**2*s**2 + 60*D1*Ddd*K*f**2*s - 30*D1*Ddd*K*f**2 + 24*D1*Ddd*b2*f*s**2 - 12*D1*Ddd*b2*f*s + 6*D1*Ddd*b2*f + 152*D1*Ddd*f**2*r*s - 38*D1*Ddd*f**2*r + 204*D1*Ddd*f**2*s**2 - 178*D1*Ddd*f**2*s + 51*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*s**2 + 24*D1*Ddd*f*g2*s - 12*D1*Ddd*f*g2 - 4*D1*bd1*(D1*(-62*C*fd*s**2 + 31*C*fd*s - 6*K*fd*s**2 + 3*K*fd*s + 3*f**2*(6*r*(2*s - 1) + 16*s**2 - 27*s + 12) + f*(24*C*(2*s**2 - 2*s + 1) + 6*K*s**2 - 6*K*s + 3*K - 3*fd*(48*r*s - 12*r + 40*s**2 - 44*s + 9) + 26*r*s - 13*r + 4*s**2 - 17*s + 2) - 40*fd*r*s + 10*fd*r - 4*fd*s**2 + 12*fd*s - 56*g2*s**2 + 56*g2*s - 28*g2 + 56*gd2*s**2 - 28*gd2*s) - Dd*(6*f**2*(6*r*(8*s - 3) + 40*s**2 - 58*s + 15) + f*(31*C*(8*s**2 - 6*s + 1) + 3*K*(8*s**2 - 6*s + 1) + 20*r*(8*s - 3) + 16*s**2 - 92*s + 32) - 28*g2*(8*s**2 - 6*s + 1))) - 360*Dd**2*K*f**2*s**2 + 180*Dd**2*K*f**2*s + 72*Dd**2*b2*f*s**2 - 36*Dd**2*b2*f*s + 456*Dd**2*f**2*r*s - 114*Dd**2*f**2*r + 612*Dd**2*f**2*s**2 - 534*Dd**2*f**2*s + 76*Dd**2*f**2 - 144*Dd**2*f*g2*s**2 + 72*Dd**2*f*g2*s) - 6*b2*(-D1**2*bdd1*f*(s - 1)**2 - 16*D1**2*f*fd*s**2 + 16*D1**2*f*fd*s - 8*D1**2*f*fd + 10*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 5*D1**2*f*fdd + 10*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s - 32*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 80*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 10*D1*Dd*f*fd + 20*D1*Ddd*f**2*s**2 - 10*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) + 60*Dd**2*f**2*s**2 - 30*Dd**2*f**2*s))/(21*d**2*k2*k3**2) + 8*D1**2*Pk3*Pkd2*ct**2*k2**5*st**2*(8*C*D1**2*b1*f*fd*r*s + 8*C*D1**2*b1*f*fd*s**2 - 4*C*D1**2*b1*f*fd*s - 4*C*D1**2*b1*f*fdd*r*s - 4*C*D1**2*b1*f*fdd*s**2 + 2*C*D1**2*b1*f*fdd*s - 4*C*D1**2*b1*fd**2*r*s - 4*C*D1**2*b1*fd**2*s**2 + 2*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r*s + 2*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 6*C*D1**2*f**2*fd*s - 2*C*D1**2*f**2*fd + 16*C*D1*Dd*b1*f**2*r*s - 4*C*D1*Dd*b1*f**2*r + 16*C*D1*Dd*b1*f**2*s**2 - 16*C*D1*Dd*b1*f**2*s + 4*C*D1*Dd*b1*f**2 - 32*C*D1*Dd*b1*f*fd*r*s + 4*C*D1*Dd*b1*f*fd*r - 32*C*D1*Dd*b1*f*fd*s**2 + 24*C*D1*Dd*b1*f*fd*s - 2*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r*s + 2*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 8*C*D1*Dd*f**3*s - 2*C*D1*Dd*f**3 - 8*C*D1*Ddd*b1*f**2*r*s + 2*C*D1*Ddd*b1*f**2*r - 8*C*D1*Ddd*b1*f**2*s**2 + 8*C*D1*Ddd*b1*f**2*s - 2*C*D1*Ddd*b1*f**2 - 24*C*Dd**2*b1*f**2*r*s + 6*C*Dd**2*b1*f**2*r - 24*C*Dd**2*b1*f**2*s**2 + 24*C*Dd**2*b1*f**2*s - 4*C*Dd**2*b1*f**2 + 2*D1**2*K*b1**2*fd*r*s + 2*D1**2*K*b1**2*fd*s**2 - D1**2*K*b1**2*fdd*r*s - D1**2*K*b1**2*fdd*s**2 - 2*D1**2*K*b1*f*fd*r*s + D1**2*K*b1*f*fd*r - 2*D1**2*K*b1*f*fd*s**2 + 2*D1**2*K*b1*f*fd*s - D1**2*K*b1*f*fd - D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 4*D1**2*b1*f*fd*r*s - 4*D1**2*b1*f*fd*s**2 + 2*D1**2*b1*f*fd*s + 2*D1**2*b1*f*fdd*r*s + 2*D1**2*b1*f*fdd*s**2 - D1**2*b1*f*fdd*s - 4*D1**2*b1*f*gd2*r*s - 4*D1**2*b1*f*gd2*s**2 + 4*D1**2*b1*f*gd2*s + 2*D1**2*b1*f*gdd2*r*s + 2*D1**2*b1*f*gdd2*s**2 - 2*D1**2*b1*f*gdd2*s + 2*D1**2*b1*fd**2*r*s + 2*D1**2*b1*fd**2*s**2 - D1**2*b1*fd**2*s - 4*D1**2*b1*fd*g2*r*s - 4*D1**2*b1*fd*g2*s**2 + 4*D1**2*b1*fd*gd2*r*s + 4*D1**2*b1*fd*gd2*s**2 - 2*D1**2*b1*fd*gd2*s + 2*D1**2*b1*fdd*g2*r*s + 2*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)*(K*b1*(2*s - 1) + f*(2*C - 1)*(s - 1) - 2*g2*(s - 1)) + 3*D1**2*f**2*fd*r*s - D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 3*D1**2*f**2*fd*s + D1**2*f**2*fd + 2*D1**2*f**2*gd2*r*s + 2*D1**2*f**2*gd2*s**2 - 2*D1**2*f**2*gd2*s + 4*D1**2*f*fd*g2*r*s - 2*D1**2*f*fd*g2*r + 4*D1**2*f*fd*g2*s**2 - 4*D1**2*f*fd*g2*s + 2*D1**2*f*fd*g2 + 8*D1*Dd*K*b1**2*f*r*s - 2*D1*Dd*K*b1**2*f*r + 8*D1*Dd*K*b1**2*f*s**2 - 8*D1*Dd*K*b1**2*f*s + 2*D1*Dd*K*b1**2*f - 8*D1*Dd*K*b1**2*fd*r*s + D1*Dd*K*b1**2*fd*r - 8*D1*Dd*K*b1**2*fd*s**2 + 4*D1*Dd*K*b1**2*fd*s - 4*D1*Dd*K*b1*f**2*r*s + D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s**2 + 4*D1*Dd*K*b1*f**2*s - D1*Dd*K*b1*f**2 - 8*D1*Dd*b1*f**2*r*s + 2*D1*Dd*b1*f**2*r - 8*D1*Dd*b1*f**2*s**2 + 8*D1*Dd*b1*f**2*s - 2*D1*Dd*b1*f**2 + 16*D1*Dd*b1*f*fd*r*s - 2*D1*Dd*b1*f*fd*r + 16*D1*Dd*b1*f*fd*s**2 - 12*D1*Dd*b1*f*fd*s + D1*Dd*b1*f*fd - 16*D1*Dd*b1*f*g2*r*s + 4*D1*Dd*b1*f*g2*r - 16*D1*Dd*b1*f*g2*s**2 + 16*D1*Dd*b1*f*g2*s - 4*D1*Dd*b1*f*g2 + 16*D1*Dd*b1*f*gd2*r*s - 2*D1*Dd*b1*f*gd2*r + 16*D1*Dd*b1*f*gd2*s**2 - 16*D1*Dd*b1*f*gd2*s + 2*D1*Dd*b1*f*gd2 + 16*D1*Dd*b1*fd*g2*r*s - 2*D1*Dd*b1*fd*g2*r + 16*D1*Dd*b1*fd*g2*s**2 - 8*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r*s - D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s + D1*Dd*f**3 + 8*D1*Dd*f**2*g2*r*s - 2*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s**2 - 8*D1*Dd*f**2*g2*s + 2*D1*Dd*f**2*g2 - 4*D1*Ddd*K*b1**2*f*r*s + D1*Ddd*K*b1**2*f*r - 4*D1*Ddd*K*b1**2*f*s**2 + 4*D1*Ddd*K*b1**2*f*s - D1*Ddd*K*b1**2*f + 4*D1*Ddd*b1*f**2*r*s - D1*Ddd*b1*f**2*r + 4*D1*Ddd*b1*f**2*s**2 - 4*D1*Ddd*b1*f**2*s + D1*Ddd*b1*f**2 + 8*D1*Ddd*b1*f*g2*r*s - 2*D1*Ddd*b1*f*g2*r + 8*D1*Ddd*b1*f*g2*s**2 - 8*D1*Ddd*b1*f*g2*s + 2*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(4*C*(s - 1) - s*(K + 2) + 2) + f*(-fd*(2*C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(-2*r - 2*s + 2)) + fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(K*b1*(-16*r*s + 6*r - 16*s**2 + 20*s - 5) - f*(2*C - 1)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 12*Dd**2*K*b1**2*f*r*s + 3*Dd**2*K*b1**2*f*r - 12*Dd**2*K*b1**2*f*s**2 + 12*Dd**2*K*b1**2*f*s - 2*Dd**2*K*b1**2*f + 12*Dd**2*b1*f**2*r*s - 3*Dd**2*b1*f**2*r + 12*Dd**2*b1*f**2*s**2 - 12*Dd**2*b1*f**2*s + 2*Dd**2*b1*f**2 + 24*Dd**2*b1*f*g2*r*s - 6*Dd**2*b1*f*g2*r + 24*Dd**2*b1*f*g2*s**2 - 24*Dd**2*b1*f*g2*s + 4*Dd**2*b1*f*g2)/(7*d**2*k3**6) + D1**2*Pk3*Pkd2*ct**2*k2**3*st**2*(-704*C*D1**2*b1*f*fd*r*s - 528*C*D1**2*b1*f*fd*r - 792*C*D1**2*b1*f*fd*s**2 - 704*C*D1**2*b1*f*fd*s + 528*C*D1**2*b1*f*fd + 528*C*D1**2*b1*f*fdd*r*s + 264*C*D1**2*b1*f*fdd*r + 396*C*D1**2*b1*f*fdd*s**2 + 264*C*D1**2*b1*f*fdd*s - 264*C*D1**2*b1*f*fdd + 528*C*D1**2*b1*fd**2*r*s + 264*C*D1**2*b1*fd**2*r + 396*C*D1**2*b1*fd**2*s**2 + 264*C*D1**2*b1*fd**2*s - 264*C*D1**2*b1*fd**2 + 264*C*D1**2*bdd1*f**2*r*s - 528*C*D1**2*bdd1*f**2*r + 198*C*D1**2*bdd1*f**2*s**2 - 924*C*D1**2*bdd1*f**2*s + 462*C*D1**2*bdd1*f**2 + 816*C*D1**2*f**2*fd*r*s - 272*C*D1**2*f**2*fd*r - 792*C*D1**2*f**2*fd*s**2 + 256*C*D1**2*f**2*fd*s - 264*C*D1**2*f**2*fd + 1176*C*D1**2*f**2*fdd*r*s - 392*C*D1**2*f**2*fdd*r + 1782*C*D1**2*f**2*fdd*s**2 - 1580*C*D1**2*f**2*fdd*s + 594*C*D1**2*f**2*fdd + 2352*C*D1**2*f*fd**2*r*s - 784*C*D1**2*f*fd**2*r + 3564*C*D1**2*f*fd**2*s**2 - 3160*C*D1**2*f*fd**2*s + 392*C*D1**2*f*fd**2 - 1408*C*D1*Dd*b1*f**2*r*s + 352*C*D1*Dd*b1*f**2*r - 1584*C*D1*Dd*b1*f**2*s**2 + 1496*C*D1*Dd*b1*f**2*s - 396*C*D1*Dd*b1*f**2 + 4224*C*D1*Dd*b1*f*fd*r*s + 528*C*D1*Dd*b1*f*fd*r + 3168*C*D1*Dd*b1*f*fd*s**2 - 792*C*D1*Dd*b1*f*fd*s - 792*C*D1*Dd*b1*f*fd + 1088*C*D1*Dd*f**3*r*s - 272*C*D1*Dd*f**3*r - 1056*C*D1*Dd*f**3*s**2 - 16*C*D1*Dd*f**3*s - 264*C*D1*Dd*f**3 + 9408*C*D1*Dd*f**2*fd*r*s - 2744*C*D1*Dd*f**2*fd*r + 14256*C*D1*Dd*f**2*fd*s**2 - 12236*C*D1*Dd*f**2*fd*s + 2364*C*D1*Dd*f**2*fd + 1056*C*D1*Ddd*b1*f**2*r*s - 264*C*D1*Ddd*b1*f**2*r + 792*C*D1*Ddd*b1*f**2*s**2 - 924*C*D1*Ddd*b1*f**2*s + 198*C*D1*Ddd*b1*f**2 + 1568*C*D1*Ddd*f**3*r*s - 392*C*D1*Ddd*f**3*r + 2376*C*D1*Ddd*f**3*s**2 - 1972*C*D1*Ddd*f**3*s + 594*C*D1*Ddd*f**3 + 3168*C*Dd**2*b1*f**2*r*s - 792*C*Dd**2*b1*f**2*r + 2376*C*Dd**2*b1*f**2*s**2 - 2772*C*Dd**2*b1*f**2*s + 528*C*Dd**2*b1*f**2 + 4704*C*Dd**2*f**3*r*s - 1176*C*Dd**2*f**3*r + 7128*C*Dd**2*f**3*s**2 - 5916*C*Dd**2*f**3*s + 784*C*Dd**2*f**3 - 264*D1**2*K*b1**2*fd*r*s - 264*D1**2*K*b1**2*fd*r - 198*D1**2*K*b1**2*fd*s**2 - 528*D1**2*K*b1**2*fd*s + 264*D1**2*K*b1**2*fd + 132*D1**2*K*b1**2*fdd*r*s + 132*D1**2*K*b1**2*fdd*r + 99*D1**2*K*b1**2*fdd*s**2 + 264*D1**2*K*b1**2*fdd*s - 132*D1**2*K*b1**2*fdd + 264*D1**2*K*b1*bdd1*f*r*s - 264*D1**2*K*b1*bdd1*f*r + 198*D1**2*K*b1*bdd1*f*s**2 - 594*D1**2*K*b1*bdd1*f*s + 231*D1**2*K*b1*bdd1*f + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r - 264*D1**2*K*b1*f*fd*s**2 + 264*D1**2*K*b1*f*fd*s - 132*D1**2*K*b1*f*fd + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 594*D1**2*K*b1*f*fdd*s**2 - 594*D1**2*K*b1*f*fdd*s + 297*D1**2*K*b1*f*fdd + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 594*D1**2*K*b1*fd**2*s**2 - 594*D1**2*K*b1*fd**2*s + 132*D1**2*K*bdd1*f**2*r*s + 297*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s + 132*D1**2*b1**2*f*fd*r*s - 66*D1**2*b1**2*f*fd*s - 132*D1**2*b1**2*f*fdd*r*s + 66*D1**2*b1**2*f*fdd*s - 132*D1**2*b1**2*fd**2*r*s + 66*D1**2*b1**2*fd**2*s + 132*D1**2*b1**2*fd*r*s - 66*D1**2*b1**2*fdd*r*s - 264*D1**2*b1*bd2*f*r*s - 264*D1**2*b1*bd2*f*s**2 + 264*D1**2*b1*bd2*f*s + 264*D1**2*b1*bd2*fd*r*s + 264*D1**2*b1*bd2*fd*s**2 - 132*D1**2*b1*bd2*fd*s - 132*D1**2*b1*bdd1*f**2*r*s + 66*D1**2*b1*bdd1*f**2*r + 66*D1**2*b1*bdd1*f**2*s - 132*D1**2*b1*bdd1*f*r*s + 66*D1**2*b1*bdd1*f*r + 66*D1**2*b1*bdd1*f*s + 132*D1**2*b1*bdd2*f*r*s + 132*D1**2*b1*bdd2*f*s**2 - 132*D1**2*b1*bdd2*f*s + 396*D1**2*b1*f*fd*r*s + 330*D1**2*b1*f*fd*r + 396*D1**2*b1*f*fd*s**2 + 264*D1**2*b1*f*fd*s - 264*D1**2*b1*f*fd - 396*D1**2*b1*f*fdd*r*s - 132*D1**2*b1*f*fdd*r - 198*D1**2*b1*f*fdd*s**2 - 66*D1**2*b1*f*fdd*s + 132*D1**2*b1*f*fdd + 528*D1**2*b1*f*gd2*r*s + 396*D1**2*b1*f*gd2*s**2 - 528*D1**2*b1*f*gd2*s - 264*D1**2*b1*f*gdd2*r*s - 198*D1**2*b1*f*gdd2*s**2 + 264*D1**2*b1*f*gdd2*s - 396*D1**2*b1*fd**2*r*s - 132*D1**2*b1*fd**2*r - 198*D1**2*b1*fd**2*s**2 - 66*D1**2*b1*fd**2*s + 132*D1**2*b1*fd**2 + 528*D1**2*b1*fd*g2*r*s + 528*D1**2*b1*fd*g2*r + 396*D1**2*b1*fd*g2*s**2 + 1056*D1**2*b1*fd*g2*s - 528*D1**2*b1*fd*g2 - 528*D1**2*b1*fd*gd2*r*s - 264*D1**2*b1*fd*gd2*r - 396*D1**2*b1*fd*gd2*s**2 - 264*D1**2*b1*fd*gd2*s + 264*D1**2*b1*fd*gd2 - 264*D1**2*b1*fdd*g2*r*s - 264*D1**2*b1*fdd*g2*r - 198*D1**2*b1*fdd*g2*s**2 - 528*D1**2*b1*fdd*g2*s + 264*D1**2*b1*fdd*g2 - 66*D1**2*bd1**2*f*(K*(-4*r*(s - 1) - 3*s**2 + 9*s - 4) + f*r*(2*s - 1) - f*s + f + 2*r*s - r - s + 1) + 132*D1**2*bd2*f**2*r*s + 132*D1**2*bd2*f**2*s**2 - 132*D1**2*bd2*f**2*s - 198*D1**2*bdd1*f**2*r*s + 330*D1**2*bdd1*f**2*r - 99*D1**2*bdd1*f**2*s**2 + 462*D1**2*bdd1*f**2*s - 231*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r*s + 528*D1**2*bdd1*f*g2*r - 198*D1**2*bdd1*f*g2*s**2 + 924*D1**2*bdd1*f*g2*s - 462*D1**2*bdd1*f*g2 - 606*D1**2*f**2*fd*r*s + 202*D1**2*f**2*fd*r + 396*D1**2*f**2*fd*s**2 - 62*D1**2*f**2*fd*s + 132*D1**2*f**2*fd - 588*D1**2*f**2*fdd*r*s + 196*D1**2*f**2*fdd*r - 891*D1**2*f**2*fdd*s**2 + 790*D1**2*f**2*fdd*s - 297*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s - 264*D1**2*f**2*gdd2*r*s - 594*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 1176*D1**2*f*fd**2*r*s + 392*D1**2*f*fd**2*r - 1782*D1**2*f*fd**2*s**2 + 1580*D1**2*f*fd**2*s - 196*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r*s + 264*D1**2*f*fd*gd2*r - 2376*D1**2*f*fd*gd2*s**2 + 1716*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 1188*D1**2*f*fdd*g2*s**2 + 1188*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 1188*D1**2*fd**2*g2*s**2 + 1188*D1**2*fd**2*g2*s - 1056*D1*Dd*K*b1**2*f*r*s + 264*D1*Dd*K*b1**2*f*r - 792*D1*Dd*K*b1**2*f*s**2 + 924*D1*Dd*K*b1**2*f*s - 198*D1*Dd*K*b1**2*f + 1056*D1*Dd*K*b1**2*fd*r*s + 396*D1*Dd*K*b1**2*fd*r + 792*D1*Dd*K*b1**2*fd*s**2 + 594*D1*Dd*K*b1**2*fd*s - 528*D1*Dd*K*b1**2*fd + 528*D1*Dd*K*b1*f**2*r*s - 132*D1*Dd*K*b1*f**2*r - 528*D1*Dd*K*b1*f**2*s**2 - 132*D1*Dd*K*b1*f**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 792*D1*Dd*K*b1*f*fd*r + 4752*D1*Dd*K*b1*f*fd*s**2 - 4092*D1*Dd*K*b1*f*fd*s + 858*D1*Dd*K*b1*f*fd + 264*D1*Dd*b1**2*f**2*r*s - 66*D1*Dd*b1**2*f**2*r - 132*D1*Dd*b1**2*f**2*s - 1056*D1*Dd*b1**2*f*fd*r*s + 132*D1*Dd*b1**2*f*fd*r + 528*D1*Dd*b1**2*f*fd*s - 66*D1*Dd*b1**2*f*fd + 528*D1*Dd*b1**2*f*r*s - 132*D1*Dd*b1**2*f*r - 264*D1*Dd*b1**2*f*s - 528*D1*Dd*b1**2*fd*r*s + 66*D1*Dd*b1**2*fd*r + 132*D1*Dd*b1**2*fd*s + 1056*D1*Dd*b1*bd2*f*r*s - 132*D1*Dd*b1*bd2*f*r + 1056*D1*Dd*b1*bd2*f*s**2 - 1056*D1*Dd*b1*bd2*f*s + 132*D1*Dd*b1*bd2*f + 792*D1*Dd*b1*f**2*r*s - 198*D1*Dd*b1*f**2*r + 792*D1*Dd*b1*f**2*s**2 - 792*D1*Dd*b1*f**2*s + 198*D1*Dd*b1*f**2 - 3168*D1*Dd*b1*f*fd*r*s - 132*D1*Dd*b1*f*fd*r - 1584*D1*Dd*b1*f*fd*s**2 + 924*D1*Dd*b1*f*fd*s + 330*D1*Dd*b1*f*fd + 2112*D1*Dd*b1*f*g2*r*s - 528*D1*Dd*b1*f*g2*r + 1584*D1*Dd*b1*f*g2*s**2 - 1848*D1*Dd*b1*f*g2*s + 396*D1*Dd*b1*f*g2 - 2112*D1*Dd*b1*f*gd2*r*s + 264*D1*Dd*b1*f*gd2*r - 1584*D1*Dd*b1*f*gd2*s**2 + 1980*D1*Dd*b1*f*gd2*s - 264*D1*Dd*b1*f*gd2 - 2112*D1*Dd*b1*fd*g2*r*s - 792*D1*Dd*b1*fd*g2*r - 1584*D1*Dd*b1*fd*g2*s**2 - 1188*D1*Dd*b1*fd*g2*s + 1056*D1*Dd*b1*fd*g2 - 808*D1*Dd*f**3*r*s + 202*D1*Dd*f**3*r + 528*D1*Dd*f**3*s**2 + 140*D1*Dd*f**3*s + 132*D1*Dd*f**3 - 4704*D1*Dd*f**2*fd*r*s + 1372*D1*Dd*f**2*fd*r - 7128*D1*Dd*f**2*fd*s**2 + 6118*D1*Dd*f**2*fd*s - 1182*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 + 264*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r*s + 264*D1*Dd*f**2*gd2*r - 4752*D1*Dd*f**2*gd2*s**2 + 2772*D1*Dd*f**2*gd2*s - 264*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r*s + 1584*D1*Dd*f*fd*g2*r - 9504*D1*Dd*f*fd*g2*s**2 + 8184*D1*Dd*f*fd*g2*s - 1716*D1*Dd*f*fd*g2 + 528*D1*Ddd*K*b1**2*f*r*s - 132*D1*Ddd*K*b1**2*f*r + 396*D1*Ddd*K*b1**2*f*s**2 - 462*D1*Ddd*K*b1**2*f*s + 99*D1*Ddd*K*b1**2*f + 528*D1*Ddd*K*b1*f**2*r*s - 132*D1*Ddd*K*b1*f**2*r + 1188*D1*Ddd*K*b1*f**2*s**2 - 858*D1*Ddd*K*b1*f**2*s + 297*D1*Ddd*K*b1*f**2 - 264*D1*Ddd*b1**2*f**2*r*s + 66*D1*Ddd*b1**2*f**2*r + 132*D1*Ddd*b1**2*f**2*s - 264*D1*Ddd*b1**2*f*r*s + 66*D1*Ddd*b1**2*f*r + 132*D1*Ddd*b1**2*f*s - 792*D1*Ddd*b1*f**2*r*s + 198*D1*Ddd*b1*f**2*r - 396*D1*Ddd*b1*f**2*s**2 + 594*D1*Ddd*b1*f**2*s - 99*D1*Ddd*b1*f**2 - 1056*D1*Ddd*b1*f*g2*r*s + 264*D1*Ddd*b1*f*g2*r - 792*D1*Ddd*b1*f*g2*s**2 + 924*D1*Ddd*b1*f*g2*s - 198*D1*Ddd*b1*f*g2 - 784*D1*Ddd*f**3*r*s + 196*D1*Ddd*f**3*r - 1188*D1*Ddd*f**3*s**2 + 986*D1*Ddd*f**3*s - 297*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r*s + 264*D1*Ddd*f**2*g2*r - 2376*D1*Ddd*f**2*g2*s**2 + 1716*D1*Ddd*f**2*g2*s - 594*D1*Ddd*f**2*g2 + 22*D1*bd1*(-16*C*D1*f**2*r*s + 40*C*D1*f**2*r - 18*C*D1*f**2*s**2 + 84*C*D1*f**2*s - 42*C*D1*f**2 + 48*C*D1*f*fd*r*s - 36*C*D1*f*fd*r + 36*C*D1*f*fd*s**2 - 72*C*D1*f*fd*s + 24*C*D1*f*fd + 96*C*Dd*f**2*r*s - 108*C*Dd*f**2*r + 72*C*Dd*f**2*s**2 - 210*C*Dd*f**2*s + 90*C*Dd*f**2 + 6*D1*K*f**2*r*s - 6*D1*K*f**2*s**2 - 6*D1*K*f**2*s + 24*D1*K*f*fd*r*s - 6*D1*K*f*fd*r + 54*D1*K*f*fd*s**2 - 39*D1*K*f*fd*s + 6*D1*K*f*fd + 6*D1*bd2*f*(2*s - 1)*(r + s - 1) + 9*D1*f**2*r*s - 24*D1*f**2*r + 9*D1*f**2*s**2 - 39*D1*f**2*s + 21*D1*f**2 - 36*D1*f*fd*r*s + 24*D1*f*fd*r - 18*D1*f*fd*s**2 + 39*D1*f*fd*s - 15*D1*f*fd + 24*D1*f*g2*r*s - 48*D1*f*g2*r + 18*D1*f*g2*s**2 - 84*D1*f*g2*s + 42*D1*f*g2 - 24*D1*f*gd2*r*s + 24*D1*f*gd2*r - 18*D1*f*gd2*s**2 + 54*D1*f*gd2*s - 24*D1*f*gd2 - 24*D1*fd*g2*r*s + 12*D1*fd*g2*r - 18*D1*fd*g2*s**2 + 18*D1*fd*g2*s + 48*Dd*K*f**2*r*s - 6*Dd*K*f**2*r + 108*Dd*K*f**2*s**2 - 63*Dd*K*f**2*s + 6*Dd*K*f**2 - 72*Dd*f**2*r*s + 69*Dd*f**2*r - 36*Dd*f**2*s**2 + 111*Dd*f**2*s - 51*Dd*f**2 - 96*Dd*f*g2*r*s + 108*Dd*f*g2*r - 72*Dd*f*g2*s**2 + 210*Dd*f*g2*s - 90*Dd*f*g2 - 3*b1*(D1*(f**2*(-2*r*s + r + s) + f*(K*(8*r*(s - 1) + 6*s**2 - 18*s + 7) + fd*(2*r - 1)*(4*s - 1) - 4*r*s + 2*r + 2*s) - fd*(K*(6*s**2 + s*(8*r - 1) - 2) - 4*r*s + r + s)) + Dd*f*(K*(-32*r*s + 20*r - 24*s**2 + 50*s - 17) + f*(2*r - 1)*(8*s - 3) + (2*r - 1)*(8*s - 3)))) + 1584*Dd**2*K*b1**2*f*r*s - 396*Dd**2*K*b1**2*f*r + 1188*Dd**2*K*b1**2*f*s**2 - 1386*Dd**2*K*b1**2*f*s + 264*Dd**2*K*b1**2*f + 1584*Dd**2*K*b1*f**2*r*s - 396*Dd**2*K*b1*f**2*r + 3564*Dd**2*K*b1*f**2*s**2 - 2574*Dd**2*K*b1*f**2*s + 264*Dd**2*K*b1*f**2 - 792*Dd**2*b1**2*f**2*r*s + 198*Dd**2*b1**2*f**2*r + 396*Dd**2*b1**2*f**2*s - 132*Dd**2*b1**2*f**2 - 792*Dd**2*b1**2*f*r*s + 198*Dd**2*b1**2*f*r + 396*Dd**2*b1**2*f*s - 132*Dd**2*b1**2*f - 2376*Dd**2*b1*f**2*r*s + 594*Dd**2*b1*f**2*r - 1188*Dd**2*b1*f**2*s**2 + 1782*Dd**2*b1*f**2*s - 396*Dd**2*b1*f**2 - 3168*Dd**2*b1*f*g2*r*s + 792*Dd**2*b1*f*g2*r - 2376*Dd**2*b1*f*g2*s**2 + 2772*Dd**2*b1*f*g2*s - 528*Dd**2*b1*f*g2 - 2352*Dd**2*f**3*r*s + 588*Dd**2*f**3*r - 3564*Dd**2*f**3*s**2 + 2958*Dd**2*f**3*s - 392*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r*s + 792*Dd**2*f**2*g2*r - 7128*Dd**2*f**2*g2*s**2 + 5148*Dd**2*f**2*g2*s - 528*Dd**2*f**2*g2 - 132*b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(231*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**2*k2**3*(2*D1*(14*D1*b2*bd1*f*(s - 1)*(r + s - 1) + D1*bd1**2*(7*K*f*(r*(4*s - 2) + 5*s**2 - 7*s + 2) - f*(24*C - 12)*(r*(2*s - 1) + s*(2*s - 2)) + 28*g2*r*(2*s - 1) + 56*g2*s*(s - 1)) + D1*bdd1*f*(s - 1)*(f*(2*C - 1)*(16*r + 15*s - 15) - 7*g2*(4*r + 5*s - 5)) - 2*bd1*(D1*(f**2*(4*C*(2*r*s + r + 6*s - 3) - r*(s + 5) - 12*s + 6) + f*(fd*(2 - 4*C)*(8*r*(2*s - 1) + 15*s**2 - 19*s + 4) - 14*g2*(r + 2*s - 1) - 7*gd2*(-4*r*s + 2*r - 5*s**2 + 7*s - 2)) + 7*fd*g2*(r*(4*s - 2) + s*(5*s - 5))) + Dd*f*(-f*(2*C - 1)*(8*r*(8*s - 5) + 60*s**2 - 91*s + 31) + 7*g2*(2*r*(8*s - 5) + 20*s**2 - 29*s + 9)))) + 28*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(D1**2*(96*C*fd*r*s + 96*C*fd*s**2 - 96*C*fd*s - 48*C*fdd*r*s - 48*C*fdd*s**2 + 48*C*fdd*s + 56*K*bd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*K*bdd1*(3*r*s - r + 3*s**2 - 3*s + 1) + 28*K*fd*r + 56*K*fd*s - 28*K*fd + 28*K*fdd*r*s + 35*K*fdd*s**2 - 62*fd*r*s - 48*fd*s**2 + 48*fd*s + 24*fdd*r*s + 24*fdd*s**2 - 24*fdd*s - 112*gd2*r*s - 112*gd2*s**2 + 112*gd2*s + 56*gdd2*r*s + 56*gdd2*s**2 - 56*gdd2*s) + D1*(2*Dd*(-14*K*bd1*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + f*(48*C*(r*(4*s - 1) + (1 - 2*s)**2) - 31*r*(4*s - 1) - 96*s**2 + 110*s - 24) + fd*(-24*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 140*K*s**2 - 63*K*s + r*(14*K + 12)*(8*s - 1) + 96*s**2 - 96*s + 12) - 56*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 28*gd2*(8*r*s - r + 8*s**2 - 8*s + 1)) + Ddd*(f*(-48*C*(r*(4*s - 1) + (1 - 2*s)**2) + 7*K*(4*r*(4*s - 1) + 20*s**2 - 18*s + 5) + 24*r*(4*s - 1) + 24*(1 - 2*s)**2) + 56*g2*(r*(4*s - 1) + (1 - 2*s)**2))) + 2*Dd**2*(f*(-24*C*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 7*K*(24*r*s - 6*r + 30*s**2 - 27*s + 4) + 144*r*s - 36*r + 144*s**2 - 144*s + 24) + 28*g2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))) - b1*(28*D1**2*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(f*(48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 7*K*(8*r*s - 4*r + 10*s**2 - 14*s + 5) - 48*r*s + 24*r - 48*s**2 + 48*s - 24) - 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 4*D1*Dd*(f**2*(8*C - 1)*(r*(4*s - 1) - 2*s) + f*(-fd*(4*C - 2)*(64*r*s - 8*r + 60*s**2 - 47*s + 4) + 7*gd2*(16*r*s - 2*r + 20*s**2 - 17*s + 2)) + 7*fd*g2*(2*r*(8*s - 1) + s*(20*s - 9))) - 28*D1*b2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*D1*bd1*(D1*f*(48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 14*K*(r + 2*s - 1) - 62*r*s + 31*r - 48*s**2 + 55*s - 24) + D1*fd*(-24*C*(r*(4*s - 1) + (1 - 2*s)**2) + 70*K*s**2 - 49*K*s + r*(14*K + 12)*(4*s - 1) + 48*s**2 - 48*s + 12) - 28*D1*(g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*f*(-48*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 7*K*(4*r*(8*s - 3) + 40*s**2 - 46*s + 11) + 24*r*(8*s - 3) + 48*(1 - 2*s)**2) + 56*Dd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + 2*D1*(D1*(2*f*fd*(4*C*(r*(4*s - 3) - 8*s + 3) - 2*r*(s - 3) + 13*s - 6) + f*s*(-14*bd2*(r + s - 1) - fdd*(4*C - 2)*(16*r + 15*s - 8) + 7*gdd2*(4*r + 5*s - 4)) - fd**2*s*(4*C - 2)*(16*r + 15*s - 8) + 28*fd*g2*(r + 2*s - 1) + 14*fd*gd2*s*(4*r + 5*s - 2) + 7*fdd*g2*s*(4*r + 5*s)) + Ddd*f*(-f*(2*C - 1)*(16*r*(4*s - 1) + 60*s**2 - 62*s + 15) + 7*g2*(4*r*(4*s - 1) + 20*s**2 - 18*s + 5))) - 4*Dd**2*f*(f*(2*C - 1)*(24*r*(4*s - 1) + 90*s**2 - 93*s + 16) - 7*g2*(6*r*(4*s - 1) + 30*s**2 - 27*s + 4))))/(21*d**2*k3**4) + D1**2*Pk3*Pkd2*ct**2*k2*st**2*(-704*C*D1**2*b1*f*fd*r*s + 352*C*D1**2*b1*f*fd*r + 88*C*D1**2*b1*f*fd*s + 132*C*D1**2*b1*f*fd + 528*C*D1**2*b1*f*fdd*r*s - 264*C*D1**2*b1*f*fdd*r - 132*C*D1**2*b1*f*fdd*s - 66*C*D1**2*b1*f*fdd + 528*C*D1**2*b1*fd**2*r*s - 264*C*D1**2*b1*fd**2*r - 132*C*D1**2*b1*fd**2*s + 264*C*D1**2*b1*fd**2 + 264*C*D1**2*bdd1*f**2*r*s - 132*C*D1**2*bdd1*f**2*s + 66*C*D1**2*bdd1*f**2 + 768*C*D1**2*f**2*fd*r*s - 256*C*D1**2*f**2*fd*r + 2376*C*D1**2*f**2*fd*s**2 - 1840*C*D1**2*f**2*fd*s + 792*C*D1**2*f**2*fd - 1176*C*D1**2*f**2*fdd*r*s + 392*C*D1**2*f**2*fdd*r - 1782*C*D1**2*f**2*fdd*s**2 + 1580*C*D1**2*f**2*fdd*s - 594*C*D1**2*f**2*fdd - 2352*C*D1**2*f*fd**2*r*s + 784*C*D1**2*f*fd**2*r - 3564*C*D1**2*f*fd**2*s**2 + 3160*C*D1**2*f*fd**2*s - 392*C*D1**2*f*fd**2 - 1408*C*D1*Dd*b1*f**2*r*s + 352*C*D1*Dd*b1*f**2*r + 704*C*D1*Dd*b1*f**2*s + 4224*C*D1*Dd*b1*f*fd*r*s - 1584*C*D1*Dd*b1*f*fd*r - 1584*C*D1*Dd*b1*f*fd*s + 660*C*D1*Dd*b1*f*fd + 1024*C*D1*Dd*f**3*r*s - 256*C*D1*Dd*f**3*r + 3168*C*D1*Dd*f**3*s**2 - 2096*C*D1*Dd*f**3*s + 792*C*D1*Dd*f**3 - 9408*C*D1*Dd*f**2*fd*r*s + 2744*C*D1*Dd*f**2*fd*r - 14256*C*D1*Dd*f**2*fd*s**2 + 12236*C*D1*Dd*f**2*fd*s - 2364*C*D1*Dd*f**2*fd + 1056*C*D1*Ddd*b1*f**2*r*s - 264*C*D1*Ddd*b1*f**2*r - 528*C*D1*Ddd*b1*f**2*s - 1568*C*D1*Ddd*f**3*r*s + 392*C*D1*Ddd*f**3*r - 2376*C*D1*Ddd*f**3*s**2 + 1972*C*D1*Ddd*f**3*s - 594*C*D1*Ddd*f**3 + 3168*C*Dd**2*b1*f**2*r*s - 792*C*Dd**2*b1*f**2*r - 1584*C*Dd**2*b1*f**2*s + 528*C*Dd**2*b1*f**2 - 4704*C*Dd**2*f**3*r*s + 1176*C*Dd**2*f**3*r - 7128*C*Dd**2*f**3*s**2 + 5916*C*Dd**2*f**3*s - 784*C*Dd**2*f**3 - 264*D1**2*K*b1**2*fd*r*s + 264*D1**2*K*b1**2*fd*r - 132*D1**2*K*b1**2*fd*s + 66*D1**2*K*b1**2*fd + 132*D1**2*K*b1**2*fdd*r*s - 132*D1**2*K*b1**2*fdd*r + 66*D1**2*K*b1**2*fdd*s - 33*D1**2*K*b1**2*fdd + 264*D1**2*K*b1*bdd1*f*r*s - 198*D1**2*K*b1*bdd1*f*s + 33*D1**2*K*b1*bdd1*f + 264*D1**2*K*b1*f*fd*r*s - 132*D1**2*K*b1*f*fd*r + 792*D1**2*K*b1*f*fd*s**2 - 792*D1**2*K*b1*f*fd*s + 396*D1**2*K*b1*f*fd - 264*D1**2*K*b1*f*fdd*r*s + 132*D1**2*K*b1*f*fdd*r - 594*D1**2*K*b1*f*fdd*s**2 + 594*D1**2*K*b1*f*fdd*s - 297*D1**2*K*b1*f*fdd - 264*D1**2*K*b1*fd**2*r*s + 132*D1**2*K*b1*fd**2*r - 594*D1**2*K*b1*fd**2*s**2 + 594*D1**2*K*b1*fd**2*s - 132*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 132*D1**2*K*bdd1*f**2*s - 66*D1**2*b1**2*f*fd*r + 66*D1**2*b1**2*f*fdd*r + 66*D1**2*b1**2*fd**2*r - 66*D1**2*b1**2*fd**2 - 132*D1**2*b1**2*fd*r + 66*D1**2*b1**2*fdd*r - 66*D1**2*b1*bd2*f*s**2 + 66*D1**2*b1*bd2*fd*s**2 - 66*D1**2*b1*bdd1*f**2*r - 66*D1**2*b1*bdd1*f*r + 33*D1**2*b1*bdd2*f*s**2 + 484*D1**2*b1*f*fd*r*s - 330*D1**2*b1*f*fd*r - 44*D1**2*b1*f*fd*s - 66*D1**2*b1*f*fd - 264*D1**2*b1*f*fdd*r*s + 198*D1**2*b1*f*fdd*r + 66*D1**2*b1*f*fdd*s + 33*D1**2*b1*f*fdd + 528*D1**2*b1*f*gd2*r*s - 528*D1**2*b1*f*gd2*s - 264*D1**2*b1*f*gdd2*r*s + 264*D1**2*b1*f*gdd2*s - 264*D1**2*b1*fd**2*r*s + 198*D1**2*b1*fd**2*r + 66*D1**2*b1*fd**2*s - 198*D1**2*b1*fd**2 + 528*D1**2*b1*fd*g2*r*s - 528*D1**2*b1*fd*g2*r + 264*D1**2*b1*fd*g2*s - 132*D1**2*b1*fd*g2 - 528*D1**2*b1*fd*gd2*r*s + 264*D1**2*b1*fd*gd2*r + 132*D1**2*b1*fd*gd2*s - 264*D1**2*b1*fd*gd2 - 264*D1**2*b1*fdd*g2*r*s + 264*D1**2*b1*fdd*g2*r - 132*D1**2*b1*fdd*g2*s + 66*D1**2*b1*fdd*g2 - 66*D1**2*bd1**2*f*(-4*K*r*s + 3*K*s + f*(r - 1) + r - 1) + 132*D1**2*bd2*f**2*r*s + 396*D1**2*bd2*f**2*s**2 - 132*D1**2*bd2*f**2*s - 528*D1**2*bd2*f*fd*r*s + 132*D1**2*bd2*f*fd*r - 1188*D1**2*bd2*f*fd*s**2 + 858*D1**2*bd2*f*fd*s - 132*D1**2*bd2*f*fd - 132*D1**2*bdd1*f**2*r*s - 66*D1**2*bdd1*f**2*r + 66*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r*s + 132*D1**2*bdd1*f*g2*s - 66*D1**2*bdd1*f*g2 - 132*D1**2*bdd2*f**2*r*s - 297*D1**2*bdd2*f**2*s**2 + 132*D1**2*bdd2*f**2*s - 186*D1**2*f**2*fd*r*s + 62*D1**2*f**2*fd*r - 1188*D1**2*f**2*fd*s**2 + 854*D1**2*f**2*fd*s - 396*D1**2*f**2*fd + 588*D1**2*f**2*fdd*r*s - 196*D1**2*f**2*fdd*r + 891*D1**2*f**2*fdd*s**2 - 790*D1**2*f**2*fdd*s + 297*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 792*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 264*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 1176*D1**2*f*fd**2*r*s - 392*D1**2*f*fd**2*r + 1782*D1**2*f*fd**2*s**2 - 1580*D1**2*f*fd**2*s + 196*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 1584*D1**2*f*fd*g2*s**2 + 1584*D1**2*f*fd*g2*s - 792*D1**2*f*fd*g2 + 1056*D1**2*f*fd*gd2*r*s - 264*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 1716*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s - 1056*D1*Dd*K*b1**2*f*r*s + 264*D1*Dd*K*b1**2*f*r + 528*D1*Dd*K*b1**2*f*s + 1056*D1*Dd*K*b1**2*fd*r*s - 660*D1*Dd*K*b1**2*fd*r + 198*D1*Dd*K*b1**2*fd + 528*D1*Dd*K*b1*f**2*r*s - 132*D1*Dd*K*b1*f**2*r + 1584*D1*Dd*K*b1*f**2*s**2 - 1056*D1*Dd*K*b1*f**2*s + 396*D1*Dd*K*b1*f**2 - 2112*D1*Dd*K*b1*f*fd*r*s + 792*D1*Dd*K*b1*f*fd*r - 4752*D1*Dd*K*b1*f*fd*s**2 + 4092*D1*Dd*K*b1*f*fd*s - 858*D1*Dd*K*b1*f*fd + 264*D1*Dd*b1**2*f*fd*r - 132*D1*Dd*b1**2*f*fd + 264*D1*Dd*b1**2*fd*r - 132*D1*Dd*b1**2*fd + 264*D1*Dd*b1*bd2*f*s**2 - 66*D1*Dd*b1*bd2*f*s + 968*D1*Dd*b1*f**2*r*s - 242*D1*Dd*b1*f**2*r - 484*D1*Dd*b1*f**2*s - 2112*D1*Dd*b1*f*fd*r*s + 1056*D1*Dd*b1*f*fd*r + 792*D1*Dd*b1*f*fd*s - 462*D1*Dd*b1*f*fd + 2112*D1*Dd*b1*f*g2*r*s - 528*D1*Dd*b1*f*g2*r - 1056*D1*Dd*b1*f*g2*s - 2112*D1*Dd*b1*f*gd2*r*s + 264*D1*Dd*b1*f*gd2*r + 1584*D1*Dd*b1*f*gd2*s - 264*D1*Dd*b1*f*gd2 - 2112*D1*Dd*b1*fd*g2*r*s + 1320*D1*Dd*b1*fd*g2*r - 396*D1*Dd*b1*fd*g2 - 1056*D1*Dd*bd2*f**2*r*s + 132*D1*Dd*bd2*f**2*r - 2376*D1*Dd*bd2*f**2*s**2 + 1386*D1*Dd*bd2*f**2*s - 132*D1*Dd*bd2*f**2 - 248*D1*Dd*f**3*r*s + 62*D1*Dd*f**3*r - 1584*D1*Dd*f**3*s**2 + 916*D1*Dd*f**3*s - 396*D1*Dd*f**3 + 4704*D1*Dd*f**2*fd*r*s - 1372*D1*Dd*f**2*fd*r + 7128*D1*Dd*f**2*fd*s**2 - 6118*D1*Dd*f**2*fd*s + 1182*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 3168*D1*Dd*f**2*g2*s**2 + 2112*D1*Dd*f**2*g2*s - 792*D1*Dd*f**2*g2 + 2112*D1*Dd*f**2*gd2*r*s - 264*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 264*D1*Dd*f**2*gd2 + 4224*D1*Dd*f*fd*g2*r*s - 1584*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 8184*D1*Dd*f*fd*g2*s + 1716*D1*Dd*f*fd*g2 + 528*D1*Ddd*K*b1**2*f*r*s - 132*D1*Ddd*K*b1**2*f*r - 264*D1*Ddd*K*b1**2*f*s - 528*D1*Ddd*K*b1*f**2*r*s + 132*D1*Ddd*K*b1*f**2*r - 1188*D1*Ddd*K*b1*f**2*s**2 + 858*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 - 528*D1*Ddd*b1*f**2*r*s + 132*D1*Ddd*b1*f**2*r + 264*D1*Ddd*b1*f**2*s - 1056*D1*Ddd*b1*f*g2*r*s + 264*D1*Ddd*b1*f*g2*r + 528*D1*Ddd*b1*f*g2*s + 784*D1*Ddd*f**3*r*s - 196*D1*Ddd*f**3*r + 1188*D1*Ddd*f**3*s**2 - 986*D1*Ddd*f**3*s + 297*D1*Ddd*f**3 + 1056*D1*Ddd*f**2*g2*r*s - 264*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 1716*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 + 22*D1*bd1*(D1*(f**2*(-2*C*(s*(8*r - 6) + 3) + r*(6*K*s + 11*s + 4) + (9*s - 3)*(2*K*s - 1)) - 3*f*(fd*(6*C*s + K*(r*(8*s - 2) + 18*s**2 - 13*s + 2) + r*(-16*C*s + 4*C + 8*s - 1) - 3*s - 1) + g2*(s*(4 - 8*r) - 2) + s*(-bd2*s + bd2 + 8*gd2*r - 6*gd2)) + 12*fd*g2*r*(1 - 2*s)) + 3*Dd*f*(f*(2*C*(2*r - 1)*(8*s - 1) + K*(-16*r*s + 2*r - 36*s**2 + 21*s - 2) - (2*r - 1)*(8*s + 1)) - 2*g2*(2*r - 1)*(8*s - 1)) - 3*b1*(D1*(f*(K*s*(8*r - 6) + K - r*(f + 2)) + fd*(K*(-8*r*s + 4*r + s - 2) - r + 1)) + Dd*f*(K*(-32*r*s + 4*r + 20*s - 3) + f*(4*r - 2) + 4*r - 2))) + 1584*Dd**2*K*b1**2*f*r*s - 396*Dd**2*K*b1**2*f*r - 792*Dd**2*K*b1**2*f*s + 264*Dd**2*K*b1**2*f - 1584*Dd**2*K*b1*f**2*r*s + 396*Dd**2*K*b1*f**2*r - 3564*Dd**2*K*b1*f**2*s**2 + 2574*Dd**2*K*b1*f**2*s - 264*Dd**2*K*b1*f**2 - 1584*Dd**2*b1*f**2*r*s + 396*Dd**2*b1*f**2*r + 792*Dd**2*b1*f**2*s - 264*Dd**2*b1*f**2 - 3168*Dd**2*b1*f*g2*r*s + 792*Dd**2*b1*f*g2*r + 1584*Dd**2*b1*f*g2*s - 528*Dd**2*b1*f*g2 + 2352*Dd**2*f**3*r*s - 588*Dd**2*f**3*r + 3564*Dd**2*f**3*s**2 - 2958*Dd**2*f**3*s + 392*Dd**2*f**3 + 3168*Dd**2*f**2*g2*r*s - 792*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 5148*Dd**2*f**2*g2*s + 528*Dd**2*f**2*g2 - 33*b2*(2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s + 8*D1*Dd*b1*f*s**2 - 4*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*s**2 + 2*D1*Dd*b1*fd*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 124*D1*Dd*f*fd*s + 26*D1*Dd*f*fd - 4*D1*Ddd*b1*f*s**2 + 2*D1*Ddd*b1*f*s - D1*Ddd*b1*f + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 26*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) - 12*Dd**2*b1*f*s**2 + 6*Dd**2*b1*f*s + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 78*Dd**2*f**2*s + 8*Dd**2*f**2))/(231*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**2*k2*(D1*(-7*D1*b2*bdd1*f*(s - 1)*(4*r + 5*s - 5) + 2*D1*bd1**2*(f*(-7*K*(r*(4*s - 2) - 7*s + 2) + r*(32*C - 24)*(2*s - 1) + s*(36*C - 18)*(s - 1)) + 14*g2*(r*(2 - 4*s) - s*(3*s - 3))) + 2*D1*bdd1*f*(-f*(2*C - 1)*(16*r*(s - 1) - 30*s + 15) + 7*g2*(4*r*(s - 1) - 10*s + 5)) + 14*b2*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*r*(2 - 4*s) - 5*fd*s*(s - 1)) + Dd*f*(-2*r*(8*s - 5) - 20*s**2 + 29*s - 9)) + 2*bd1*(-7*D1*bd2*f*(r*(4*s - 2) + 5*s**2 - 7*s + 2) + 2*D1*(f**2*(4*C*(8*r*s - 5*r - 6*s + 3) - 16*r*s + 7*r + 12*s - 6) + f*(-fd*(2*C - 1)*(16*r*(2*s - 1) - 23*s + 8) - 14*g2*(r - 1)*(2*s - 1) - 7*gd2*(-4*r*s + 2*r + 7*s - 2)) + 14*fd*g2*r*(2*s - 1)) + 2*Dd*f*(-f*(2*C - 1)*(8*r*(8*s - 5) - 76*s + 31) + 7*g2*(2*r*(8*s - 5) - 24*s + 9)))) - 7*b1**3*(2*D1*Dd*(K*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) + fd*r*(8*s - 1) - 6*fd*s + fd - (f + 2)*(r*(4*s - 1) - 2*s)) - D1*(2*D1*s*(fd - fdd)*(r - 1) + Ddd*K*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) - 2*Ddd*(f + 1)*(r*(4*s - 1) - 2*s)) + 2*Dd**2*(K*(-24*r*s + 6*r - 18*s**2 + 21*s - 4) + f*(3*r*(4*s - 1) - 6*s + 2) + 12*r*s - 3*r - 6*s + 2)) + b1**2*(D1**2*(64*C*fdd*r*s + 36*C*fdd*s**2 - 64*C*fdd*s - 28*K*fdd*r*s - 70*K*fdd*s + 35*K*fdd + 7*bdd1*(K*(4*r*(3*s - 1) + 9*s**2 - 10*s + 3) + (-2*f - 2)*(r*(3*s - 1) - s)) + 2*fd*(14*K*(r + 1)*(2*s - 1) + r*(-64*C*s + 48*s + 7) + 2*s*(-18*C*s + 32*C + 9*s - 24)) - 48*fdd*r*s - 18*fdd*s**2 + 48*fdd*s + 112*gd2*r*s + 84*gd2*s**2 - 112*gd2*s - 56*gdd2*r*s - 42*gdd2*s**2 + 56*gdd2*s) + 14*D1*bd1*(-D1*(K*(4*r*(3*s - 1) + 9*s**2 - 10*s + 3) + fd*r*(6*s - 1) - 4*fd*s + fd - (f + 2)*(r*(3*s - 1) - s)) + Dd*(K*(48*r*s - 14*r + 36*s**2 - 41*s + 9) + f*(r*(7 - 24*s) + 10*s - 3) - 24*r*s + 7*r + 10*s - 3)) - 2*D1*(2*Dd*f*(2*C*(16*r*(4*s - 1) + 36*s**2 - 50*s + 9) + 28*K*s - r*(14*K + 24)*(4*s - 1) - 36*s**2 + 66*s - 9) + Dd*fd*(-4*C*(8*r*(8*s - 1) + 36*s**2 - 57*s + 8) + 7*K*(16*r*s - 2*r + 16*s - 5) + 192*r*s - 24*r + 72*s**2 - 162*s + 24) - 14*Dd*(g2*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) + gd2*(r*(2 - 16*s) - 12*s**2 + 15*s - 2)) + Ddd*f*(-2*C*(16*r*(4*s - 1) + 36*s**2 - 50*s + 9) - 28*K*s + r*(14*K + 24)*(4*s - 1) + 36*s**2 - 66*s + 9) + 7*Ddd*g2*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3)) + 4*Dd**2*(f*(2*C*(24*r*(4*s - 1) + 54*s**2 - 75*s + 16) - 7*K*(12*r*s - 3*r - 6*s + 2) - 144*r*s + 36*r - 54*s**2 + 99*s - 24) - 7*g2*(6*r*(4*s - 1) + 18*s**2 - 21*s + 4))) - b1*(-256*C*D1**2*f*fd*r*s + 48*C*D1**2*f*fd*r + 32*C*D1**2*f*fd*s + 48*C*D1**2*f*fd + 128*C*D1**2*f*fdd*r*s + 56*C*D1**2*f*fdd*s - 60*C*D1**2*f*fdd + 128*C*D1**2*fd**2*r*s + 56*C*D1**2*fd**2*s - 512*C*D1*Dd*f**2*r*s + 128*C*D1*Dd*f**2*r + 256*C*D1*Dd*f**2*s + 1024*C*D1*Dd*f*fd*r*s - 128*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s - 56*C*D1*Dd*f*fd + 256*C*D1*Ddd*f**2*r*s - 64*C*D1*Ddd*f**2*r - 128*C*D1*Ddd*f**2*s + 768*C*Dd**2*f**2*r*s - 192*C*Dd**2*f**2*r - 384*C*Dd**2*f**2*s + 128*C*Dd**2*f**2 - 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*s**2 + 28*D1**2*b2*fdd*r*s + 35*D1**2*b2*fdd*s**2 + 14*D1**2*bd1**2*(K*(r*(4 - 12*s) - 9*s**2 + 10*s - 2) + f*r*(6*s - 2) - 2*f*s + f + 6*r*s - 2*r - 2*s + 1) - 28*D1**2*bd2*f*r*s - 28*D1**2*bd2*f*s**2 + 28*D1**2*bd2*f*s + 56*D1**2*bd2*fd*r*s + 70*D1**2*bd2*fd*s**2 - 28*D1**2*bd2*fd*s + D1**2*bdd1*(f*(-4*C*(32*r*s - 16*r + 18*s**2 - 18*s + 9) + 7*K*(8*r*s - 4*r - 14*s + 5) + 96*r*s - 48*r + 36*s**2 - 36*s + 18) + 14*g2*(r*(8*s - 4) + 6*s**2 - 6*s + 3)) + 28*D1**2*bdd2*f*r*s + 35*D1**2*bdd2*f*s**2 - 28*D1**2*bdd2*f*s + 128*D1**2*f*fd*r*s - 36*D1**2*f*fd*r - 16*D1**2*f*fd*s - 24*D1**2*f*fd - 64*D1**2*f*fdd*r*s - 28*D1**2*f*fdd*s + 30*D1**2*f*fdd + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*s - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*s - 64*D1**2*fd**2*r*s - 28*D1**2*fd**2*s + 112*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 - 112*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*s - 56*D1**2*fdd*g2*r*s - 140*D1**2*fdd*g2*s + 70*D1**2*fdd*g2 - 112*D1*Dd*b2*f*r*s + 28*D1*Dd*b2*f*r - 112*D1*Dd*b2*f*s**2 + 112*D1*Dd*b2*f*s - 28*D1*Dd*b2*f + 224*D1*Dd*b2*fd*r*s - 28*D1*Dd*b2*fd*r + 280*D1*Dd*b2*fd*s**2 - 126*D1*Dd*b2*fd*s + 224*D1*Dd*bd2*f*r*s - 28*D1*Dd*bd2*f*r + 280*D1*Dd*bd2*f*s**2 - 238*D1*Dd*bd2*f*s + 28*D1*Dd*bd2*f + 256*D1*Dd*f**2*r*s - 64*D1*Dd*f**2*r - 128*D1*Dd*f**2*s - 512*D1*Dd*f*fd*r*s + 64*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s + 28*D1*Dd*f*fd + 448*D1*Dd*f*g2*r*s - 112*D1*Dd*f*g2*r - 224*D1*Dd*f*g2*s - 448*D1*Dd*f*gd2*r*s + 56*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s - 56*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r*s + 56*D1*Dd*fd*g2*r - 448*D1*Dd*fd*g2*s + 140*D1*Dd*fd*g2 + 112*D1*Ddd*b2*f*r*s - 28*D1*Ddd*b2*f*r + 140*D1*Ddd*b2*f*s**2 - 126*D1*Ddd*b2*f*s + 35*D1*Ddd*b2*f - 128*D1*Ddd*f**2*r*s + 32*D1*Ddd*f**2*r + 64*D1*Ddd*f**2*s - 224*D1*Ddd*f*g2*r*s + 56*D1*Ddd*f*g2*r + 112*D1*Ddd*f*g2*s + 2*D1*bd1*(D1*f*(4*C*(32*r*s - 16*r + 18*s**2 - 18*s + 9) - 14*K*(r - 1)*(4*s - 1) - 96*r*s + 55*r - 36*s**2 + 36*s - 18) + D1*fd*(-4*C*(8*r*(4*s - 1) + 18*s**2 - 25*s + 8) + 21*K*s + r*(14*K + 24)*(4*s - 1) + 36*s**2 - 66*s + 24) - 14*D1*(g2*(r*(8*s - 4) + 6*s**2 - 6*s + 3) + gd2*(r*(2 - 8*s) - 6*s**2 + 7*s - 2)) + Dd*f*(-4*C*(16*r*(8*s - 3) + 72*s**2 - 86*s + 25) + 7*K*(4*r*(8*s - 3) - 36*s + 11) + 48*r*(8*s - 3) + 144*s**2 - 204*s + 66) + 14*Dd*g2*(4*r*(8*s - 3) + 24*s**2 - 26*s + 7)) + 336*Dd**2*b2*f*r*s - 84*Dd**2*b2*f*r + 420*Dd**2*b2*f*s**2 - 378*Dd**2*b2*f*s + 56*Dd**2*b2*f - 384*Dd**2*f**2*r*s + 96*Dd**2*f**2*r + 192*Dd**2*f**2*s - 64*Dd**2*f**2 - 672*Dd**2*f*g2*r*s + 168*Dd**2*f*g2*r + 336*Dd**2*f*g2*s - 112*Dd**2*f*g2))/(21*d**2*k3**2) + D1**2*Pk3*Pkd2*ct**2*st**2*(D1*(6*D1*bd1**2*f*s*(5*K*s + f*(2*r - 1) + 2*r - 1) + 3*D1*bdd1*f*s*(2*f*r + f*s*(10*C - 5) + s*(5*b2 - 10*g2)) + 2*bd1*(D1*(f**2*s*(-4*r + s*(15 - 30*C)) + 3*f*(fd*r*(4*s - 1) + 2*fd*s*(5*C*(2*s - 1) - 5*s + 2) + s**2*(-5*b2 + 5*bd2 + 10*g2 - 10*gd2)) + 15*fd*s*(b2 - 2*g2)*(s - 1)) + 3*Dd*f*(f*r*(8*s - 1) + f*s*(10*C*(4*s - 1) - 20*s + 3) + s*(5*b2 - 10*g2)*(4*s - 1)))) + 3*b1**2*(2*D1*Dd*(f*(-5*K*(4*s**2 - 2*s + 1) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(5*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(fd**2*(r*(4*s - 2) - 2*s + 2) - 2*fd*(5*K*(s - 1)**2 - f*s + r*(2*f*s - f + 2*s - 2)) + fdd*(5*K*(s - 1)**2 - 2*f*s + 2*r*(2*f*s - f + s - 1))) + Ddd*f*(5*K*(4*s**2 - 2*s + 1) + (2*f + 2)*(r*(4*s - 1) - 2*s))) + 2*Dd**2*f*(30*K*s**2 - 15*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(-120*C*D1**2*f*fd*s**2 + 120*C*D1**2*f*fd*s - 60*C*D1**2*f*fd + 60*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 30*C*D1**2*f*fdd + 60*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s - 240*C*D1*Dd*f**2*s**2 + 120*C*D1*Dd*f**2*s - 60*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*s**2 - 360*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*s**2 - 60*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*s**2 - 180*C*Dd**2*f**2*s + 30*D1**2*K*bdd1*f*s**2 - 30*D1**2*bd2*f*s**2 + 30*D1**2*bd2*fd*s**2 - 30*D1**2*bd2*fd*s + 12*D1**2*bdd1*f**2*r*s - 6*D1**2*bdd1*f**2*s + 12*D1**2*bdd1*f*r*s - 6*D1**2*bdd1*f*s + 15*D1**2*bdd2*f*s**2 - 16*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 60*D1**2*f*fd*s**2 - 52*D1**2*f*fd*s + 30*D1**2*f*fd + 12*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*r - 30*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s - 15*D1**2*f*fdd + 60*D1**2*f*gd2*s**2 - 30*D1**2*f*gdd2*s**2 + 12*D1**2*fd**2*r*s - 6*D1**2*fd**2*r - 30*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s + 6*D1**2*fd**2 + 60*D1**2*fd*g2*s**2 - 120*D1**2*fd*g2*s + 60*D1**2*fd*g2 - 60*D1**2*fd*gd2*s**2 + 60*D1**2*fd*gd2*s - 30*D1**2*fdd*g2*s**2 + 60*D1**2*fdd*g2*s - 30*D1**2*fdd*g2 + 120*D1*Dd*bd2*f*s**2 - 30*D1*Dd*bd2*f*s - 32*D1*Dd*f**2*r*s + 8*D1*Dd*f**2*r + 120*D1*Dd*f**2*s**2 - 44*D1*Dd*f**2*s + 30*D1*Dd*f**2 + 96*D1*Dd*f*fd*r*s - 36*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 132*D1*Dd*f*fd*s - 12*D1*Dd*f*fd + 240*D1*Dd*f*g2*s**2 - 120*D1*Dd*f*g2*s + 60*D1*Dd*f*g2 - 240*D1*Dd*f*gd2*s**2 + 60*D1*Dd*f*gd2*s - 240*D1*Dd*fd*g2*s**2 + 300*D1*Dd*fd*g2*s - 60*D1*Dd*fd*g2 + 24*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 120*D1*Ddd*f*g2*s**2 + 60*D1*Ddd*f*g2*s - 30*D1*Ddd*f*g2 + 6*D1*bd1*(D1*(f*s*(-10*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(10*K*s - 1))) + Dd*f*(40*K*s**2 - 10*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) + 72*Dd**2*f**2*r*s - 18*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s + 12*Dd**2*f**2 - 360*Dd**2*f*g2*s**2 + 180*Dd**2*f*g2*s - 15*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(21*d**2*k2) - D1**2*Pk3*Pkd2*ct**2*(D1*(-2*D1*bd1**2*(8*f*r*(2*s - 1) + f*s*(12*C*(s - 1) - s*(35*K + 6) + 6) + s*(7*b2 - 14*g2)*(s - 1)) + 5*D1*bdd1*f*s**2*(12*C*f + 7*b2 - 6*f - 14*g2) + 2*bd1*s*(D1*(-6*f**2*(8*C*s + r - 4*s) + f*fd*(60*C - 30)*(2*s - 1) + 7*f*s*(5*bd2 + 8*g2 - 10*gd2) - 70*fd*g2*(s - 1)) + 10*Dd*f*(4*s - 1)*(f*(6*C - 3) - 7*g2) + 7*b2*(-4*D1*f*s + 5*D1*fd*(s - 1) + 5*Dd*f*(4*s - 1)))) - 7*b1**3*(2*D1*Dd*(K*(-4*s**2 + 2*s - 1) + fd*r*(8*s - 1) - 6*fd*s + fd - (f + 2)*(r*(4*s - 1) - 2*s)) + D1*(-2*D1*s*(fd - fdd)*(r - 1) + Ddd*K*(4*s**2 - 2*s + 1) + 2*Ddd*(f + 1)*(r*(4*s - 1) - 2*s)) + 2*Dd**2*(6*K*s**2 - 3*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1**2*(24*C*D1**2*fd*s**2 - 12*C*D1**2*fdd*s**2 + 96*C*D1*Dd*f*s**2 - 48*C*D1*Dd*f*s + 24*C*D1*Dd*f - 96*C*D1*Dd*fd*s**2 + 24*C*D1*Dd*fd*s - 48*C*D1*Ddd*f*s**2 + 24*C*D1*Ddd*f*s - 12*C*D1*Ddd*f - 144*C*Dd**2*f*s**2 + 72*C*Dd**2*f*s - 21*D1**2*K*bdd1*s**2 + 14*D1**2*K*bdd1*s - 7*D1**2*K*bdd1 - 56*D1**2*K*fd*s**2 + 112*D1**2*K*fd*s - 56*D1**2*K*fd + 35*D1**2*K*fdd*s**2 - 70*D1**2*K*fdd*s + 35*D1**2*K*fdd + 14*D1**2*bd2*s**2 - 42*D1**2*bdd1*f*r*s + 14*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s - 42*D1**2*bdd1*r*s + 14*D1**2*bdd1*r + 14*D1**2*bdd1*s - 7*D1**2*bdd2*s**2 + 18*D1**2*fd*r*s + 14*D1**2*fd*r - 12*D1**2*fd*s**2 - 32*D1**2*fd*s - 16*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 + 16*D1**2*fdd*s - 28*D1**2*gd2*s**2 + 14*D1**2*gdd2*s**2 - 224*D1*Dd*K*f*s**2 + 112*D1*Dd*K*f*s - 56*D1*Dd*K*f + 280*D1*Dd*K*fd*s**2 - 350*D1*Dd*K*fd*s + 70*D1*Dd*K*fd - 56*D1*Dd*bd2*s**2 + 14*D1*Dd*bd2*s + 72*D1*Dd*f*r*s - 18*D1*Dd*f*r - 48*D1*Dd*f*s**2 - 12*D1*Dd*f*s - 12*D1*Dd*f - 128*D1*Dd*fd*r*s + 16*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 + 84*D1*Dd*fd*s - 16*D1*Dd*fd - 112*D1*Dd*g2*s**2 + 56*D1*Dd*g2*s - 28*D1*Dd*g2 + 112*D1*Dd*gd2*s**2 - 28*D1*Dd*gd2*s + 140*D1*Ddd*K*f*s**2 - 70*D1*Ddd*K*f*s + 35*D1*Ddd*K*f - 64*D1*Ddd*f*r*s + 16*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 + 20*D1*Ddd*f*s + 6*D1*Ddd*f + 56*D1*Ddd*g2*s**2 - 28*D1*Ddd*g2*s + 14*D1*Ddd*g2 + 14*D1*bd1*(D1*(K*(3*s**2 - 2*s + 1) + fd*(-6*r*s + r + 4*s - 1) + (f + 2)*(3*r*s - r - s)) - Dd*(12*K*s**2 - 7*K*s + K + f*(r*(24*s - 7) - 10*s + 3) + 24*r*s - 7*r - 10*s + 3)) + 420*Dd**2*K*f*s**2 - 210*Dd**2*K*f*s - 192*Dd**2*f*r*s + 48*Dd**2*f*r + 72*Dd**2*f*s**2 + 60*Dd**2*f*s - 32*Dd**2*f + 168*Dd**2*g2*s**2 - 84*Dd**2*g2*s + 7*b2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s))) + b1*(-24*C*D1**2*bdd1*f*s**2 + 24*C*D1**2*bdd1*f*s - 12*C*D1**2*bdd1*f - 192*C*D1**2*f*fd*s**2 + 192*C*D1**2*f*fd*s - 96*C*D1**2*f*fd + 120*C*D1**2*f*fdd*s**2 - 120*C*D1**2*f*fdd*s + 60*C*D1**2*f*fdd + 120*C*D1**2*fd**2*s**2 - 120*C*D1**2*fd**2*s - 384*C*D1*Dd*f**2*s**2 + 192*C*D1*Dd*f**2*s - 96*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 120*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 70*D1**2*K*bdd1*f*s**2 - 14*D1**2*bd1**2*(3*K*s**2 - 2*K*s + f*r*(6*s - 2) - 2*f*s + f + r*(6*s - 2) - 2*s + 1) - 56*D1**2*bd2*f*s**2 + 70*D1**2*bd2*fd*s**2 - 70*D1**2*bd2*fd*s - 32*D1**2*bdd1*f*r*s + 16*D1**2*bdd1*f*r + 12*D1**2*bdd1*f*s**2 - 12*D1**2*bdd1*f*s + 6*D1**2*bdd1*f + 28*D1**2*bdd1*g2*s**2 - 28*D1**2*bdd1*g2*s + 14*D1**2*bdd1*g2 + 35*D1**2*bdd2*f*s**2 - 24*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 96*D1**2*f*fd*s**2 - 84*D1**2*f*fd*s + 48*D1**2*f*fd - 60*D1**2*f*fdd*s**2 + 60*D1**2*f*fdd*s - 30*D1**2*f*fdd + 112*D1**2*f*gd2*s**2 - 70*D1**2*f*gdd2*s**2 - 60*D1**2*fd**2*s**2 + 60*D1**2*fd**2*s + 112*D1**2*fd*g2*s**2 - 224*D1**2*fd*g2*s + 112*D1**2*fd*g2 - 140*D1**2*fd*gd2*s**2 + 140*D1**2*fd*gd2*s - 70*D1**2*fdd*g2*s**2 + 140*D1**2*fdd*g2*s - 70*D1**2*fdd*g2 + 280*D1*Dd*bd2*f*s**2 - 70*D1*Dd*bd2*f*s - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 48*D1*Dd*f**2 - 480*D1*Dd*f*fd*s**2 + 360*D1*Dd*f*fd*s - 60*D1*Dd*f*fd + 448*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 112*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*s**2 + 140*D1*Dd*f*gd2*s - 560*D1*Dd*fd*g2*s**2 + 700*D1*Dd*fd*g2*s - 140*D1*Dd*fd*g2 - 120*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 30*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*s**2 + 140*D1*Ddd*f*g2*s - 70*D1*Ddd*f*g2 + 2*D1*bd1*(D1*f*(12*C*(2*s**2 - 2*s + 1) - 56*K*s**2 + 2*r*(9*s - 8) - 12*s**2 + 19*s - 6) - 2*D1*fd*(4*r*(4*s - 1) + s**2*(12*C - 35*K - 6) + s*(-6*C + 35*K - 5) + 4) - 7*D1*(g2*(4*s**2 - 4*s + 2) + s*(bd2 - 2*gd2)*(2*s - 1)) - 2*Dd*f*(6*C*(8*s**2 - 6*s + 1) - 140*K*s**2 + 35*K*s + 8*r*(8*s - 3) - 24*s**2 + 2*s + 5) + 14*Dd*g2*(8*s**2 - 6*s + 1)) - 360*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 840*Dd**2*f*g2*s**2 + 420*Dd**2*f*g2*s + 7*b2*(-D1**2*bdd1*(2*s**2 - 2*s + 1) - 8*D1**2*fd*s**2 + 16*D1**2*fd*s - 8*D1**2*fd + 5*D1**2*fdd*s**2 - 10*D1**2*fdd*s + 5*D1**2*fdd - 32*D1*Dd*f*s**2 + 16*D1*Dd*f*s - 8*D1*Dd*f + 40*D1*Dd*fd*s**2 - 50*D1*Dd*fd*s + 10*D1*Dd*fd + 20*D1*Ddd*f*s**2 - 10*D1*Ddd*f*s + 5*D1*Ddd*f + 2*D1*bd1*(D1*(2*s**2 - 2*s + 1) + Dd*(-8*s**2 + 6*s - 1)) + 60*Dd**2*f*s**2 - 30*Dd**2*f*s)))/(21*d**2*k2) + 8*D1**2*Pk3*Pkd2*ct*f**2*k1**5*st**4*(D1**2*(f*(361*fd - 200*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 200*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(361*f*(r*(4*s - 1) + (1 - 2*s)**2) - 400*fd*(4*s - 1)*(4*r + 4*s - 3)) - 200*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 200*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k3**6) + 150*D1**2*Pk3*Pkd2*ct*f**2*k1**5*st**4*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(1001*d**2*k2**2*k3**4) + 20*D1**2*Pk3*Pkd2*ct*f**2*k1**3*k2**2*st**6*(D1**2*(f*(181*fd - 84*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 84*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(181*f*(r*(4*s - 1) + (1 - 2*s)**2) - 168*fd*(4*s - 1)*(4*r + 4*s - 3)) - 84*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 84*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(9009*d**2*k3**6) + 45*D1**2*Pk3*Pkd2*ct*f**2*k1**3*st**6*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(286*d**2*k3**4) - 4*D1**2*Pk3*Pkd2*ct*f*k1**5*st**2*(-384*D1**2*b1*f*fd*r*s - 39*D1**2*b1*f*fd*r - 384*D1**2*b1*f*fd*s**2 + 217*D1**2*b1*f*fd*s + 39*D1**2*b1*f*fd + 225*D1**2*b1*f*fdd*r*s + 25*D1**2*b1*f*fdd*r + 225*D1**2*b1*f*fdd*s**2 - 125*D1**2*b1*f*fdd*s - 25*D1**2*b1*f*fdd + 450*D1**2*b1*fd**2*r*s + 50*D1**2*b1*fd**2*r + 450*D1**2*b1*fd**2*s**2 - 250*D1**2*b1*fd**2*s - 25*D1**2*b1*fd**2 + 25*D1**2*bdd1*f**2*(3*s - 4)*(r + s - 1) + 100*D1**2*f**2*fd*r*s - 25*D1**2*f**2*fd*r + 100*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 512*D1*Dd*b1*f**2*r*s + 128*D1*Dd*b1*f**2*r - 512*D1*Dd*b1*f**2*s**2 + 512*D1*Dd*b1*f**2*s - 128*D1*Dd*b1*f**2 + 1800*D1*Dd*b1*f*fd*r*s - 125*D1*Dd*b1*f*fd*r + 1800*D1*Dd*b1*f*fd*s**2 - 1400*D1*Dd*b1*f*fd*s + 75*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r*s - 25*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 100*D1*Dd*f**3*s + 25*D1*Dd*f**3 + 300*D1*Ddd*b1*f**2*r*s - 75*D1*Ddd*b1*f**2*r + 300*D1*Ddd*b1*f**2*s**2 - 300*D1*Ddd*b1*f**2*s + 75*D1*Ddd*b1*f**2 + D1*bd1*f*(D1*(-f*(128*s - 167)*(r + s - 1) + 25*fd*(18*r*s - 11*r + 18*s**2 - 26*s + 7)) + 25*Dd*f*(r*(24*s - 19) + 24*s**2 - 40*s + 15)) + 900*Dd**2*b1*f**2*r*s - 225*Dd**2*b1*f**2*r + 900*Dd**2*b1*f**2*s**2 - 900*Dd**2*b1*f**2*s + 150*Dd**2*b1*f**2)/(231*d**2*k3**6) + 25*D1**2*Pk3*Pkd2*ct*f*k1**5*st**2*(30*D1**2*b1*f*fd*s**2 - 15*D1**2*b1*f*fdd*s**2 - 30*D1**2*b1*fd**2*s**2 - 5*D1**2*bdd1*f**2*(s - 1)**2 - 56*D1**2*f**2*fd*s**2 + 28*D1**2*f**2*fd*s - 14*D1**2*f**2*fd + 28*D1**2*f**2*fdd*s**2 - 14*D1**2*f**2*fdd*s + 7*D1**2*f**2*fdd + 84*D1**2*f*fd**2*s**2 - 42*D1**2*f*fd**2*s + 40*D1*Dd*b1*f**2*s**2 - 20*D1*Dd*b1*f**2*s + 10*D1*Dd*b1*f**2 - 120*D1*Dd*b1*f*fd*s**2 + 30*D1*Dd*b1*f*fd*s - 56*D1*Dd*f**3*s**2 + 28*D1*Dd*f**3*s - 14*D1*Dd*f**3 + 224*D1*Dd*f**2*fd*s**2 - 112*D1*Dd*f**2*fd*s + 14*D1*Dd*f**2*fd - 20*D1*Ddd*b1*f**2*s**2 + 10*D1*Ddd*b1*f**2*s - 5*D1*Ddd*b1*f**2 + 28*D1*Ddd*f**3*s**2 - 14*D1*Ddd*f**3*s + 7*D1*Ddd*f**3 + 10*D1*bd1*f*(s - 1)*(D1*f*(s - 1) - 3*D1*fd*s + Dd*f*(1 - 4*s)) - 60*Dd**2*b1*f**2*s**2 + 30*Dd**2*b1*f**2*s + 84*Dd**2*f**3*s**2 - 42*Dd**2*f**3*s)/(462*d**2*k2**2*k3**4) + 5*D1**2*Pk3*Pkd2*ct*f*k1**5*(D1**2*bdd1*f**2*(s - 1)**2 - 2*D1*bd1*f*(s - 1)*(D1*f*(s - 1) - 3*D1*fd*s + Dd*f*(1 - 4*s)) + b1*(3*D1**2*s**2*(f*(-2*fd + fdd) + 2*fd**2) + D1*f*(-2*Dd*(f*(4*s**2 - 2*s + 1) + 3*fd*s*(1 - 4*s)) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)))/(7*d**2*k2**2*k3**4) - 8*D1**2*Pk3*Pkd2*ct*f*k1**3*k2**2*st**4*(-72*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 36*C*D1**2*f*fdd*r*s - 12*C*D1**2*f*fdd*r + 36*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 72*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 72*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r*s - 84*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 288*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 + 60*D1**2*b1*f*fd*r*s - 60*D1**2*b1*f*fd*r + 60*D1**2*b1*f*fd*s**2 - 100*D1**2*b1*f*fd*s + 60*D1**2*b1*f*fd - 30*D1**2*b1*f*fdd*r*s + 30*D1**2*b1*f*fdd*r - 30*D1**2*b1*f*fdd*s**2 + 50*D1**2*b1*f*fdd*s - 30*D1**2*b1*f*fdd - 60*D1**2*b1*fd**2*r*s + 60*D1**2*b1*fd**2*r - 60*D1**2*b1*fd**2*s**2 + 100*D1**2*b1*fd**2*s - 30*D1**2*b1*fd**2 - 10*D1**2*bdd1*f**2*(s + 2)*(r + s - 1) + 60*D1**2*f**2*fd*r*s - 15*D1**2*f**2*fd*r + 60*D1**2*f**2*fd*s**2 - 60*D1**2*f**2*fd*s + 15*D1**2*f**2*fd + 54*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 54*D1**2*f*fd*s**2 - 54*D1**2*f*fd*s + 18*D1**2*f*fd - 27*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r - 27*D1**2*f*fdd*s**2 + 27*D1**2*f*fdd*s - 9*D1**2*f*fdd - 54*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 54*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s - 9*D1**2*fd**2 + 80*D1*Dd*b1*f**2*r*s - 20*D1*Dd*b1*f**2*r + 80*D1*Dd*b1*f**2*s**2 - 80*D1*Dd*b1*f**2*s + 20*D1*Dd*b1*f**2 - 240*D1*Dd*b1*f*fd*r*s + 150*D1*Dd*b1*f*fd*r - 240*D1*Dd*b1*f*fd*s**2 + 320*D1*Dd*b1*f*fd*s - 110*D1*Dd*b1*f*fd + 60*D1*Dd*f**3*r*s - 15*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 72*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 18*D1*Dd*f**2 - 216*D1*Dd*f*fd*r*s + 63*D1*Dd*f*fd*r - 216*D1*Dd*f*fd*s**2 + 216*D1*Dd*f*fd*s - 45*D1*Dd*f*fd - 40*D1*Ddd*b1*f**2*r*s + 10*D1*Ddd*b1*f**2*r - 40*D1*Ddd*b1*f**2*s**2 + 40*D1*Ddd*b1*f**2*s - 10*D1*Ddd*b1*f**2 - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 10*D1*bd1*f*(D1*(2*f*(s + 2)*(r + s - 1) + fd*(-6*r*s - 3*r - 6*s**2 + 2*s + 1)) - Dd*f*(r*(8*s + 7) + 8*s**2 - 5)) - 120*Dd**2*b1*f**2*r*s + 30*Dd**2*b1*f**2*r - 120*Dd**2*b1*f**2*s**2 + 120*Dd**2*b1*f**2*s - 20*Dd**2*b1*f**2 - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2)/(231*d**2*k3**6) - D1**2*Pk3*Pkd2*ct*f*k1**3*st**4*(48*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r - 24*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r*s + 8*C*D1**2*f*fdd*r + 12*C*D1**2*f*fdd*s**2 + 4*C*D1**2*f*fdd - 48*C*D1**2*fd**2*r*s + 16*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2 + 64*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s**2 - 16*C*D1*Dd*f**2*s - 8*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r*s + 56*C*D1*Dd*f*fd*r + 96*C*D1*Dd*f*fd*s**2 + 24*C*D1*Dd*f*fd*s - 16*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r*s + 8*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s**2 + 8*C*D1*Ddd*f**2*s + 4*C*D1*Ddd*f**2 - 96*C*Dd**2*f**2*r*s + 24*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s**2 + 24*C*Dd**2*f**2*s - 16*C*Dd**2*f**2 - 600*D1**2*b1*f*fd*r*s + 200*D1**2*b1*f*fd*r - 600*D1**2*b1*f*fd*s**2 + 380*D1**2*b1*f*fd*s - 50*D1**2*b1*f*fd + 300*D1**2*b1*f*fdd*r*s - 100*D1**2*b1*f*fdd*r + 300*D1**2*b1*f*fdd*s**2 - 190*D1**2*b1*f*fdd*s + 25*D1**2*b1*f*fdd + 600*D1**2*b1*fd**2*r*s - 200*D1**2*b1*fd**2*r + 600*D1**2*b1*fd**2*s**2 - 380*D1**2*b1*fd**2*s + 140*D1**2*b1*fd**2 + 5*D1**2*bdd1*f**2*(20*r*s + 20*s**2 - 42*s + 15) + 480*D1**2*f**2*fd*r*s - 120*D1**2*f**2*fd*r + 1080*D1**2*f**2*fd*s**2 - 780*D1**2*f**2*fd*s + 270*D1**2*f**2*fd - 480*D1**2*f**2*fdd*r*s + 120*D1**2*f**2*fdd*r - 660*D1**2*f**2*fdd*s**2 + 570*D1**2*f**2*fdd*s - 165*D1**2*f**2*fdd - 1440*D1**2*f*fd**2*r*s + 360*D1**2*f*fd**2*r - 1980*D1**2*f*fd**2*s**2 + 1710*D1**2*f*fd**2*s - 240*D1**2*f*fd**2 - 120*D1**2*f*fd*r*s + 40*D1**2*f*fd*r - 78*D1**2*f*fd*s**2 + 92*D1**2*f*fd*s - 26*D1**2*f*fd + 60*D1**2*f*fdd*r*s - 20*D1**2*f*fdd*r + 39*D1**2*f*fdd*s**2 - 46*D1**2*f*fdd*s + 13*D1**2*f*fdd + 120*D1**2*fd**2*r*s - 40*D1**2*fd**2*r + 78*D1**2*fd**2*s**2 - 92*D1**2*fd**2*s + 20*D1**2*fd**2 - 800*D1*Dd*b1*f**2*r*s + 200*D1*Dd*b1*f**2*r - 800*D1*Dd*b1*f**2*s**2 + 800*D1*Dd*b1*f**2*s - 200*D1*Dd*b1*f**2 + 2400*D1*Dd*b1*f*fd*r*s - 700*D1*Dd*b1*f*fd*r + 2400*D1*Dd*b1*f*fd*s**2 - 1960*D1*Dd*b1*f*fd*s + 390*D1*Dd*b1*f*fd + 480*D1*Dd*f**3*r*s - 120*D1*Dd*f**3*r + 1080*D1*Dd*f**3*s**2 - 780*D1*Dd*f**3*s + 270*D1*Dd*f**3 - 3840*D1*Dd*f**2*fd*r*s + 960*D1*Dd*f**2*fd*r - 5280*D1*Dd*f**2*fd*s**2 + 4560*D1*Dd*f**2*fd*s - 810*D1*Dd*f**2*fd - 160*D1*Dd*f**2*r*s + 40*D1*Dd*f**2*r - 104*D1*Dd*f**2*s**2 + 132*D1*Dd*f**2*s - 26*D1*Dd*f**2 + 480*D1*Dd*f*fd*r*s - 140*D1*Dd*f*fd*r + 312*D1*Dd*f*fd*s**2 - 382*D1*Dd*f*fd*s + 86*D1*Dd*f*fd + 400*D1*Ddd*b1*f**2*r*s - 100*D1*Ddd*b1*f**2*r + 400*D1*Ddd*b1*f**2*s**2 - 400*D1*Ddd*b1*f**2*s + 100*D1*Ddd*b1*f**2 - 480*D1*Ddd*f**3*r*s + 120*D1*Ddd*f**3*r - 660*D1*Ddd*f**3*s**2 + 570*D1*Ddd*f**3*s - 165*D1*Ddd*f**3 + 80*D1*Ddd*f**2*r*s - 20*D1*Ddd*f**2*r + 52*D1*Ddd*f**2*s**2 - 66*D1*Ddd*f**2*s + 13*D1*Ddd*f**2 - 10*D1*bd1*f*(D1*(f*(20*r*s + 20*s**2 - 42*s + 15) - 2*fd*(30*r*s - 5*r + 30*s**2 - 41*s + 3)) + Dd*f*(r*(10 - 80*s) - 80*s**2 + 124*s - 21)) + 1200*Dd**2*b1*f**2*r*s - 300*Dd**2*b1*f**2*r + 1200*Dd**2*b1*f**2*s**2 - 1200*Dd**2*b1*f**2*s + 200*Dd**2*b1*f**2 - 1440*Dd**2*f**3*r*s + 360*Dd**2*f**3*r - 1980*Dd**2*f**3*s**2 + 1710*Dd**2*f**3*s - 240*Dd**2*f**3 + 240*Dd**2*f**2*r*s - 60*Dd**2*f**2*r + 156*Dd**2*f**2*s**2 - 198*Dd**2*f**2*s + 40*Dd**2*f**2)/(231*d**2*k3**4) + 3*D1**2*Pk3*Pkd2*ct*f*k1**3*st**4*(D1**2*(f**2*s**2*(20*bd1 - 10*bdd1) + f*fd*(20*b1*(3*s**2 - 2*s + 1) + s**2*(6 - 60*bd1) + s*(20*bd1 - 4) + 2) - f*fdd*(10*b1 + 1)*(3*s**2 - 2*s + 1) - fd**2*s*(20*b1 + 2)*(3*s - 2)) + D1*f*(2*Dd*f*(10*b1*(4*s**2 - 2*s + 1) + s**2*(4 - 40*bd1) + s*(10*bd1 - 2) + 1) - Dd*fd*(20*b1 + 2)*(12*s**2 - 7*s + 1) - Ddd*f*(10*b1 + 1)*(4*s**2 - 2*s + 1)) + Dd**2*f**2*s*(-60*b1 - 6)*(2*s - 1))/(77*d**2*k2**2*k3**2) + D1**2*Pk3*Pkd2*ct*f*k2**4*st**4*(40*C - 20)*(D1*Dd*f*(2*f*(4*r*s - r - 2*s) + fd*(-24*r*s + 7*r + 10*s - 3)) + D1*(D1*(2*f*fd*(3*r*s - r - s) + f*fdd*(-3*r*s + r + s) + fd**2*(-6*r*s + 2*r + 2*s - 1)) + Ddd*f**2*(-4*r*s + r + 2*s)) + Dd**2*f**2*(r*(3 - 12*s) + 6*s - 2))/(231*d**2*k1*k3**4) + D1**2*Pk3*Pkd2*ct*f*k2**2*st**4*(40*C - 20)*(D1*Dd*f*(2*f*(-4*r*s + r + 2*s) + fd*(24*r*s - 7*r - 10*s + 3)) + D1*(D1*(2*f*fd*(-3*r*s + r + s) + f*fdd*(3*r*s - r - s) + fd**2*(6*r*s - 2*r - 2*s + 1)) + Ddd*f**2*(r*(4*s - 1) - 2*s)) + Dd**2*f**2*(3*r*(4*s - 1) - 6*s + 2))/(231*d**2*k1*k3**2) - 8*D1**2*Pk3*Pkd2*ct*k1**5*(-5*D1**2*bd1*f**2*(r + s - 1)*(bd1*(2*s - 1) - f*s + f) + D1*b1*f*(bd1*(D1*(4*f*(2*s - 1)*(r + s - 1) - 5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1)) - 5*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 5*f*(-D1*bdd1*(2*s - 1)*(r + s - 1) + D1*fd*s*(3*r + 3*s - 2) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**2*(D1**2*s*(2*r + 2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + D1*f*(Dd*(4*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**6) - 4*D1**2*Pk3*Pkd2*ct*k1**3*k2**2*st**2*(132*C*D1**2*bdd1*f**2*r*s - 132*C*D1**2*bdd1*f**2*r + 132*C*D1**2*bdd1*f**2*s**2 - 264*C*D1**2*bdd1*f**2*s + 132*C*D1**2*bdd1*f**2 - 102*C*D1**2*f**2*fd*r*s + 34*C*D1**2*f**2*fd*r - 102*C*D1**2*f**2*fd*s**2 + 102*C*D1**2*f**2*fd*s - 34*C*D1**2*f**2*fd + 150*C*D1**2*f**2*fdd*r*s - 50*C*D1**2*f**2*fdd*r + 150*C*D1**2*f**2*fdd*s**2 - 150*C*D1**2*f**2*fdd*s + 50*C*D1**2*f**2*fdd + 300*C*D1**2*f*fd**2*r*s - 100*C*D1**2*f*fd**2*r + 300*C*D1**2*f*fd**2*s**2 - 300*C*D1**2*f*fd**2*s + 50*C*D1**2*f*fd**2 - 136*C*D1*Dd*f**3*r*s + 34*C*D1*Dd*f**3*r - 136*C*D1*Dd*f**3*s**2 + 136*C*D1*Dd*f**3*s - 34*C*D1*Dd*f**3 + 1200*C*D1*Dd*f**2*fd*r*s - 350*C*D1*Dd*f**2*fd*r + 1200*C*D1*Dd*f**2*fd*s**2 - 1200*C*D1*Dd*f**2*fd*s + 250*C*D1*Dd*f**2*fd + 200*C*D1*Ddd*f**3*r*s - 50*C*D1*Ddd*f**3*r + 200*C*D1*Ddd*f**3*s**2 - 200*C*D1*Ddd*f**3*s + 50*C*D1*Ddd*f**3 + 600*C*Dd**2*f**3*r*s - 150*C*Dd**2*f**3*r + 600*C*Dd**2*f**3*s**2 - 600*C*Dd**2*f**3*s + 100*C*Dd**2*f**3 + 33*D1**2*K*bdd1*f**2*r*s + 33*D1**2*K*bdd1*f**2*s**2 - 33*D1**2*K*bdd1*f**2*s - 33*D1**2*bd1**2*f*(2*s - 1)*(-2*K + 6*f + 1)*(r + s - 1) - 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*r - 99*D1**2*bdd1*f**2*s**2 + 198*D1**2*bdd1*f**2*s - 99*D1**2*bdd1*f**2 - 132*D1**2*bdd1*f*g2*r*s + 132*D1**2*bdd1*f*g2*r - 132*D1**2*bdd1*f*g2*s**2 + 264*D1**2*bdd1*f*g2*s - 132*D1**2*bdd1*f*g2 + 18*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 18*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r*s + 25*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 75*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd + 66*D1**2*f**2*gd2*r*s + 66*D1**2*f**2*gd2*s**2 - 66*D1**2*f**2*gd2*s - 66*D1**2*f**2*gdd2*r*s - 66*D1**2*f**2*gdd2*s**2 + 66*D1**2*f**2*gdd2*s - 150*D1**2*f*fd**2*r*s + 50*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 150*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 132*D1**2*f*fd*g2*r*s - 66*D1**2*f*fd*g2*r + 132*D1**2*f*fd*g2*s**2 - 132*D1**2*f*fd*g2*s + 66*D1**2*f*fd*g2 - 264*D1**2*f*fd*gd2*r*s + 66*D1**2*f*fd*gd2*r - 264*D1**2*f*fd*gd2*s**2 + 264*D1**2*f*fd*gd2*s - 66*D1**2*f*fd*gd2 - 132*D1**2*f*fdd*g2*r*s + 66*D1**2*f*fdd*g2*r - 132*D1**2*f*fdd*g2*s**2 + 132*D1**2*f*fdd*g2*s - 66*D1**2*f*fdd*g2 - 132*D1**2*fd**2*g2*r*s + 66*D1**2*fd**2*g2*r - 132*D1**2*fd**2*g2*s**2 + 132*D1**2*fd**2*g2*s + 24*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 24*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r*s + 175*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 600*D1*Dd*f**2*fd*s - 125*D1*Dd*f**2*fd + 264*D1*Dd*f**2*g2*r*s - 66*D1*Dd*f**2*g2*r + 264*D1*Dd*f**2*g2*s**2 - 264*D1*Dd*f**2*g2*s + 66*D1*Dd*f**2*g2 - 528*D1*Dd*f**2*gd2*r*s + 66*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s**2 + 528*D1*Dd*f**2*gd2*s - 66*D1*Dd*f**2*gd2 - 1056*D1*Dd*f*fd*g2*r*s + 396*D1*Dd*f*fd*g2*r - 1056*D1*Dd*f*fd*g2*s**2 + 1056*D1*Dd*f*fd*g2*s - 264*D1*Dd*f*fd*g2 - 100*D1*Ddd*f**3*r*s + 25*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 100*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 - 264*D1*Ddd*f**2*g2*r*s + 66*D1*Ddd*f**2*g2*r - 264*D1*Ddd*f**2*g2*s**2 + 264*D1*Ddd*f**2*g2*s - 66*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(9*f**3*(r + s - 1) + f**2*(r + s - 1)*(24*C*(s - 1) + s*(3*K - 17) + 18) - 3*f*(fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + (4*r + 4*s - 4)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 4*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 300*Dd**2*f**3*r*s + 75*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 300*Dd**2*f**3*s - 50*Dd**2*f**3 - 792*Dd**2*f**2*g2*r*s + 198*Dd**2*f**2*g2*r - 792*Dd**2*f**2*g2*s**2 + 792*Dd**2*f**2*g2*s - 132*Dd**2*f**2*g2 + 33*b1**2*(-D1**2*s*(-f*(11*fd - 6*fdd)*(2*r + 2*s - 1) + 6*fd**2*(2*r + 2*s - 1) + 2*fd*(2*K - 1)*(r + s) - fdd*(2*K - 1)*(r + s)) + D1*(Dd*(11*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(fd*(6*r*(8*s - 1) + 48*s**2 - 36*s + 3) + (2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-2*K + 6*f + 1)) - Dd**2*f*(-2*K + 6*f + 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(-48*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s + 24*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*s**2 - 12*C*D1**2*f*fdd*s + 24*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*s**2 - 12*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r*s - 24*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 144*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 6*D1**2*K*f*fd*r*s + 3*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd + 6*D1**2*K*f*fdd*r*s - 3*D1**2*K*f*fdd*r + 6*D1**2*K*f*fdd*s**2 - 6*D1**2*K*f*fdd*s + 3*D1**2*K*f*fdd + 6*D1**2*K*fd**2*r*s - 3*D1**2*K*fd**2*r + 6*D1**2*K*fd**2*s**2 - 6*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(2*s - 1)*(-2*K + 6*f + 1)*(r + s - 1) + 9*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s - 9*D1**2*f**2*fd + 34*D1**2*f*fd*r*s + D1**2*f*fd*r + 34*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s - D1**2*f*fd - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s + 24*D1**2*f*gd2*r*s + 24*D1**2*f*gd2*s**2 - 24*D1**2*f*gd2*s - 12*D1**2*f*gdd2*r*s - 12*D1**2*f*gdd2*s**2 + 12*D1**2*f*gdd2*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 24*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*s**2 + 12*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 12*D1*Dd*K*f**2*r*s + 3*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 12*D1*Dd*K*f**2*s - 3*D1*Dd*K*f**2 + 48*D1*Dd*K*f*fd*r*s - 18*D1*Dd*K*f*fd*r + 48*D1*Dd*K*f*fd*s**2 - 48*D1*Dd*K*f*fd*s + 12*D1*Dd*K*f*fd + 68*D1*Dd*f**2*r*s - 17*D1*Dd*f**2*r + 68*D1*Dd*f**2*s**2 - 68*D1*Dd*f**2*s + 17*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 108*D1*Dd*f*fd*s - 9*D1*Dd*f*fd + 96*D1*Dd*f*g2*r*s - 24*D1*Dd*f*g2*r + 96*D1*Dd*f*g2*s**2 - 96*D1*Dd*f*g2*s + 24*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r*s + 12*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 96*D1*Dd*f*gd2*s - 12*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r*s + 12*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 48*D1*Dd*fd*g2*s + 12*D1*Ddd*K*f**2*r*s - 3*D1*Ddd*K*f**2*r + 12*D1*Ddd*K*f**2*s**2 - 12*D1*Ddd*K*f**2*s + 3*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r*s + 12*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 48*D1*Ddd*f*g2*s - 12*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(11*f**2*(2*s - 1)*(r + s - 1) - 2*f*(3*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (2*K - 1)*(2*s - 1)*(r + s - 1)) + fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-2*K + 6*f + 1)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 36*Dd**2*K*f**2*r*s - 9*Dd**2*K*f**2*r + 36*Dd**2*K*f**2*s**2 - 36*Dd**2*K*f**2*s + 6*Dd**2*K*f**2 - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2 - 144*Dd**2*f*g2*r*s + 36*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 144*Dd**2*f*g2*s - 24*Dd**2*f*g2))/(231*d**2*k3**6) + 8*D1**2*Pk3*Pkd2*ct*k1**3*k2**2*(D1*(-6*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) - D1*bdd1*f*(s - 1)*(f*(10*C - 5) - 12*g2)*(r + s - 1) + bd1*(D1*(f**2*(14 - 16*C)*(s - 1)*(r + s - 1) + f*(-fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (3*g2*(s - 1) + 2*gd2*(2*s - 1))*(6*r + 6*s - 6)) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + b1**2*(D1**2*s*(18*f*fd*(2*r + 2*s - 1) - (r + s)*(6*K*fdd + fd*(9*K - 7))) + D1*(Dd*(6*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 18*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(9*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - 6*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 6*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(-6*K*bdd1*f*(2*s - 1)*(r + s - 1) + s*(f*(-fd*(16*C - 14)*(2*r + 2*s - 1) - fdd*(10*C - 5)*(2*r + 2*s - 1) + (18*gd2 + 12*gdd2)*(r + s - 1)) - fd**2*(10*C - 5)*(2*r + 2*s - 1) + 6*fd*(3*g2*(r + s) + gd2*(4*r + 4*s - 2)) + 12*fdd*g2*(r + s))) + D1*bd1*(D1*(6*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 18*f**2*(2*s - 1)*(r + s - 1) - f*(9*K - 7)*(2*s - 1)*(r + s - 1)) - 6*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + D1*(Dd*(f**2*(14 - 16*C)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(5 - 10*C)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 18*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 12*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 12*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(f*(10*C - 5) - 12*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**6) + D1**2*Pk3*Pkd2*ct*k1**3*st**2*(88*C*D1**2*bdd1*f**2*r*s - 88*C*D1**2*bdd1*f**2*r + 132*C*D1**2*bdd1*f**2*s**2 - 264*C*D1**2*bdd1*f**2*s + 132*C*D1**2*bdd1*f**2 - 672*C*D1**2*f**2*fd*r*s + 224*C*D1**2*f**2*fd*r - 2928*C*D1**2*f**2*fd*s**2 + 2176*C*D1**2*f**2*fd*s - 976*C*D1**2*f**2*fd + 600*C*D1**2*f**2*fdd*r*s - 200*C*D1**2*f**2*fdd*r + 1860*C*D1**2*f**2*fdd*s**2 - 1440*C*D1**2*f**2*fdd*s + 620*C*D1**2*f**2*fdd + 1200*C*D1**2*f*fd**2*r*s - 400*C*D1**2*f*fd**2*r + 3720*C*D1**2*f*fd**2*s**2 - 2880*C*D1**2*f*fd**2*s + 200*C*D1**2*f*fd**2 - 896*C*D1*Dd*f**3*r*s + 224*C*D1*Dd*f**3*r - 3904*C*D1*Dd*f**3*s**2 + 2400*C*D1*Dd*f**3*s - 976*C*D1*Dd*f**3 + 4800*C*D1*Dd*f**2*fd*r*s - 1400*C*D1*Dd*f**2*fd*r + 14880*C*D1*Dd*f**2*fd*s**2 - 10680*C*D1*Dd*f**2*fd*s + 1840*C*D1*Dd*f**2*fd + 800*C*D1*Ddd*f**3*r*s - 200*C*D1*Ddd*f**3*r + 2480*C*D1*Ddd*f**3*s**2 - 1640*C*D1*Ddd*f**3*s + 620*C*D1*Ddd*f**3 + 2400*C*Dd**2*f**3*r*s - 600*C*Dd**2*f**3*r + 7440*C*Dd**2*f**3*s**2 - 4920*C*Dd**2*f**3*s + 400*C*Dd**2*f**3 + 132*D1**2*K*bdd1*f**2*r*s + 374*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s - 440*D1**2*b2*f*fd*r*s + 220*D1**2*b2*f*fd*r - 440*D1**2*b2*f*fd*s**2 + 440*D1**2*b2*f*fd*s - 220*D1**2*b2*f*fd + 264*D1**2*b2*f*fdd*r*s - 132*D1**2*b2*f*fdd*r + 264*D1**2*b2*f*fdd*s**2 - 264*D1**2*b2*f*fdd*s + 132*D1**2*b2*f*fdd + 264*D1**2*b2*fd**2*r*s - 132*D1**2*b2*fd**2*r + 264*D1**2*b2*fd**2*s**2 - 264*D1**2*b2*fd**2*s - 22*D1**2*bd1**2*f*(K*(-4*r*s + 2*r - 6*s**2 + 8*s - 2) + 3*f*(2*r*(8*s - 5) + 13*s**2 - 21*s + 6) + 16*r*s - 8*r + 19*s**2 - 27*s + 8) - 220*D1**2*bd2*f**2*r*s - 220*D1**2*bd2*f**2*s**2 + 220*D1**2*bd2*f**2*s + 528*D1**2*bd2*f*fd*r*s - 132*D1**2*bd2*f*fd*r + 528*D1**2*bd2*f*fd*s**2 - 528*D1**2*bd2*f*fd*s + 132*D1**2*bd2*f*fd + 528*D1**2*bdd1*f**3*r*s - 792*D1**2*bdd1*f**3*r - 1122*D1**2*bdd1*f**3*s + 693*D1**2*bdd1*f**3 - 220*D1**2*bdd1*f**2*r*s + 220*D1**2*bdd1*f**2*r - 396*D1**2*bdd1*f**2*s**2 + 550*D1**2*bdd1*f**2*s - 275*D1**2*bdd1*f**2 - 88*D1**2*bdd1*f*g2*r*s + 88*D1**2*bdd1*f*g2*r - 132*D1**2*bdd1*f*g2*s**2 + 264*D1**2*bdd1*f*g2*s - 132*D1**2*bdd1*f*g2 + 132*D1**2*bdd2*f**2*r*s + 132*D1**2*bdd2*f**2*s**2 - 132*D1**2*bdd2*f**2*s + 72*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r + 1830*D1**2*f**2*fd*s**2 - 1244*D1**2*f**2*fd*s + 610*D1**2*f**2*fd - 300*D1**2*f**2*fdd*r*s + 100*D1**2*f**2*fdd*r - 1245*D1**2*f**2*fdd*s**2 + 930*D1**2*f**2*fdd*s - 415*D1**2*f**2*fdd + 352*D1**2*f**2*gd2*r*s + 1232*D1**2*f**2*gd2*s**2 - 352*D1**2*f**2*gd2*s - 264*D1**2*f**2*gdd2*r*s - 748*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 600*D1**2*f*fd**2*r*s + 200*D1**2*f*fd**2*r - 2490*D1**2*f*fd**2*s**2 + 1860*D1**2*f*fd**2*s - 100*D1**2*f*fd**2 + 704*D1**2*f*fd*g2*r*s - 352*D1**2*f*fd*g2*r + 2464*D1**2*f*fd*g2*s**2 - 2464*D1**2*f*fd*g2*s + 1232*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r*s + 264*D1**2*f*fd*gd2*r - 2992*D1**2*f*fd*gd2*s**2 + 2024*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 1496*D1**2*f*fdd*g2*s**2 + 1496*D1**2*f*fdd*g2*s - 748*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 1496*D1**2*fd**2*g2*s**2 + 1496*D1**2*fd**2*g2*s - 880*D1*Dd*b2*f**2*r*s + 220*D1*Dd*b2*f**2*r - 880*D1*Dd*b2*f**2*s**2 + 880*D1*Dd*b2*f**2*s - 220*D1*Dd*b2*f**2 + 2112*D1*Dd*b2*f*fd*r*s - 792*D1*Dd*b2*f*fd*r + 2112*D1*Dd*b2*f*fd*s**2 - 2112*D1*Dd*b2*f*fd*s + 528*D1*Dd*b2*f*fd + 1056*D1*Dd*bd2*f**2*r*s - 132*D1*Dd*bd2*f**2*r + 1056*D1*Dd*bd2*f**2*s**2 - 1056*D1*Dd*bd2*f**2*s + 132*D1*Dd*bd2*f**2 + 96*D1*Dd*f**3*r*s - 24*D1*Dd*f**3*r + 2440*D1*Dd*f**3*s**2 - 1268*D1*Dd*f**3*s + 610*D1*Dd*f**3 - 2400*D1*Dd*f**2*fd*r*s + 700*D1*Dd*f**2*fd*r - 9960*D1*Dd*f**2*fd*s**2 + 6810*D1*Dd*f**2*fd*s - 1130*D1*Dd*f**2*fd + 1408*D1*Dd*f**2*g2*r*s - 352*D1*Dd*f**2*g2*r + 4928*D1*Dd*f**2*g2*s**2 - 3168*D1*Dd*f**2*g2*s + 1232*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r*s + 264*D1*Dd*f**2*gd2*r - 5984*D1*Dd*f**2*gd2*s**2 + 3080*D1*Dd*f**2*gd2*s - 264*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r*s + 1584*D1*Dd*f*fd*g2*r - 11968*D1*Dd*f*fd*g2*s**2 + 10032*D1*Dd*f*fd*g2*s - 2024*D1*Dd*f*fd*g2 + 528*D1*Ddd*b2*f**2*r*s - 132*D1*Ddd*b2*f**2*r + 528*D1*Ddd*b2*f**2*s**2 - 528*D1*Ddd*b2*f**2*s + 132*D1*Ddd*b2*f**2 - 400*D1*Ddd*f**3*r*s + 100*D1*Ddd*f**3*r - 1660*D1*Ddd*f**3*s**2 + 1030*D1*Ddd*f**3*s - 415*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r*s + 264*D1*Ddd*f**2*g2*r - 2992*D1*Ddd*f**2*g2*s**2 + 2024*D1*Ddd*f**2*g2*s - 748*D1*Ddd*f**2*g2 - 22*D1*bd1*(D1*(3*f**3*(12*r*(s - 1) + 4*s**2 - 28*s + 15) + f**2*(4*C*(s - 1)*(2*r + 3*s - 3) + 8*K*r*s + 28*K*s**2 - 8*K*s - 6*fd*(8*r*(3*s - 2) - 25*s + 10) - 16*r*s + 20*r - 32*s**2 + 46*s - 25) + f*(fd*(-4*C*(r*(4*s - 2) + 6*s**2 - 7*s + 1) + K*(-24*r*s + 6*r - 68*s**2 + 46*s - 6) + 40*r*s - 20*r + 72*s**2 - 71*s + 10) - 4*g2*(s - 1)*(2*r + 3*s - 3) - 4*gd2*(-2*r*s + r - 3*s**2 + 4*s - 1)) + 4*fd*g2*(r*(2*s - 1) + s*(3*s - 3))) + Dd*f*(-3*f**2*(8*r*(8*s - 7) - 84*s + 41) + f*(-4*C*(r*(8*s - 5) + 12*s**2 - 17*s + 5) - 2*K*(24*r*s - 3*r + 68*s**2 - 35*s + 3) + 80*r*s - 50*r + 144*s**2 - 156*s + 45) + 4*g2*(r*(8*s - 5) + 12*s**2 - 17*s + 5))) + 1584*Dd**2*b2*f**2*r*s - 396*Dd**2*b2*f**2*r + 1584*Dd**2*b2*f**2*s**2 - 1584*Dd**2*b2*f**2*s + 264*Dd**2*b2*f**2 - 1200*Dd**2*f**3*r*s + 300*Dd**2*f**3*r - 4980*Dd**2*f**3*s**2 + 3090*Dd**2*f**3*s - 200*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r*s + 792*Dd**2*f**2*g2*r - 8976*Dd**2*f**2*g2*s**2 + 6072*Dd**2*f**2*g2*s - 528*Dd**2*f**2*g2 + 11*b1**2*(D1**2*(4*f*fd*(r*(44*s + 5) + 35*s**2 - 23*s - 5) - 6*f*fdd*(2*r*(8*s + 1) + 13*s**2 - 8*s - 2) - 6*fd**2*(2*r*(8*s + 1) + 13*s**2 - 8*s - 2) + 2*fd*s*(r*(16 - 4*K) + s*(19 - 6*K)) + fdd*s*(r*(4*K - 16) + s*(6*K - 19))) + D1*(2*Dd*(f**2*(44*r*(4*s - 1) + 140*s**2 - 158*s + 35) + f*(-2*K*(8*r*s - 2*r + 12*s**2 - 10*s + 3) - 6*fd*(r*(64*s - 4) + 52*s**2 - 45*s + 2) + 64*r*s - 16*r + 76*s**2 - 70*s + 19) + fd*(r*(2*K - 8)*(8*s - 1) + s*(2*K*(12*s - 5) - 76*s + 35))) + Ddd*f*(2*K*(8*r*s - 2*r + 12*s**2 - 10*s + 3) - 3*f*(16*r*(4*s - 1) + 52*s**2 - 58*s + 13) - 64*r*s + 16*r - 76*s**2 + 70*s - 19)) - 2*Dd**2*f*(K*(-24*r*s + 6*r - 36*s**2 + 30*s - 4) + 3*f*(24*r*(4*s - 1) + 78*s**2 - 87*s + 16) + 96*r*s - 24*r + 114*s**2 - 105*s + 16)) + 11*b1*(-32*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*s**2 + 16*C*D1**2*f*fd*s + 16*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s + 16*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s - 64*C*D1*Dd*f**2*r*s + 16*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 80*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 128*C*D1*Dd*f*fd*r*s - 16*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 112*C*D1*Dd*f*fd*s + 8*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r*s - 8*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 40*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r*s - 24*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 120*C*Dd**2*f**2*s + 16*C*Dd**2*f**2 - 32*D1**2*K*f*fd*r*s + 16*D1**2*K*f*fd*r - 112*D1**2*K*f*fd*s**2 + 112*D1**2*K*f*fd*s - 56*D1**2*K*f*fd + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 68*D1**2*K*f*fdd*s**2 - 68*D1**2*K*f*fdd*s + 34*D1**2*K*f*fdd + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 68*D1**2*K*fd**2*s**2 - 68*D1**2*K*fd**2*s + D1**2*bdd1*f*(2*K*(4*r*s - 2*r + 6*s**2 - 8*s + 3) - 3*f*(4*r*(8*s - 5) + 26*s**2 - 42*s + 17) - 32*r*s + 16*r - 38*s**2 + 54*s - 19) - 216*D1**2*f**2*fd*r*s - 72*D1**2*f**2*fd*s**2 + 24*D1**2*f**2*fd*s + 66*D1**2*f**2*fd + 144*D1**2*f**2*fdd*r*s + 24*D1**2*f**2*fdd*r + 6*D1**2*f**2*fdd*s - 63*D1**2*f**2*fdd + 288*D1**2*f*fd**2*r*s + 48*D1**2*f*fd**2*r + 12*D1**2*f*fd**2*s - 24*D1**2*f*fd**2 + 64*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 128*D1**2*f*fd*s**2 - 68*D1**2*f*fd*s + 14*D1**2*f*fd - 40*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*s**2 + 42*D1**2*f*fdd*s - 11*D1**2*f*fdd + 16*D1**2*f*gd2*r*s + 24*D1**2*f*gd2*s**2 - 16*D1**2*f*gd2*s - 8*D1**2*f*gdd2*r*s - 12*D1**2*f*gdd2*s**2 + 8*D1**2*f*gdd2*s - 40*D1**2*fd**2*r*s - 72*D1**2*fd**2*s**2 + 42*D1**2*fd**2*s + 16*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*s**2 - 16*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*s**2 + 8*D1**2*fd*gd2*s - 8*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 64*D1*Dd*K*f**2*r*s + 16*D1*Dd*K*f**2*r - 224*D1*Dd*K*f**2*s**2 + 144*D1*Dd*K*f**2*s - 56*D1*Dd*K*f**2 + 192*D1*Dd*K*f*fd*r*s - 72*D1*Dd*K*f*fd*r + 544*D1*Dd*K*f*fd*s**2 - 456*D1*Dd*K*f*fd*s + 92*D1*Dd*K*f*fd - 288*D1*Dd*f**3*r*s + 72*D1*Dd*f**3*r - 96*D1*Dd*f**3*s**2 + 192*D1*Dd*f**3*s - 24*D1*Dd*f**3 + 1152*D1*Dd*f**2*fd*r*s - 48*D1*Dd*f**2*fd*r - 264*D1*Dd*f**2*fd*s - 54*D1*Dd*f**2*fd + 128*D1*Dd*f**2*r*s - 32*D1*Dd*f**2*r + 256*D1*Dd*f**2*s**2 - 192*D1*Dd*f**2*s + 64*D1*Dd*f**2 - 320*D1*Dd*f*fd*r*s + 40*D1*Dd*f*fd*r - 576*D1*Dd*f*fd*s**2 + 392*D1*Dd*f*fd*s - 42*D1*Dd*f*fd + 64*D1*Dd*f*g2*r*s - 16*D1*Dd*f*g2*r + 96*D1*Dd*f*g2*s**2 - 80*D1*Dd*f*g2*s + 24*D1*Dd*f*g2 - 64*D1*Dd*f*gd2*r*s + 8*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 72*D1*Dd*f*gd2*s - 8*D1*Dd*f*gd2 - 64*D1*Dd*fd*g2*r*s + 8*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 40*D1*Dd*fd*g2*s + 48*D1*Ddd*K*f**2*r*s - 12*D1*Ddd*K*f**2*r + 136*D1*Ddd*K*f**2*s**2 - 92*D1*Ddd*K*f**2*s + 34*D1*Ddd*K*f**2 + 192*D1*Ddd*f**3*r*s - 48*D1*Ddd*f**3*r - 96*D1*Ddd*f**3*s - 80*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 144*D1*Ddd*f**2*s**2 + 112*D1*Ddd*f**2*s - 36*D1*Ddd*f**2 - 32*D1*Ddd*f*g2*r*s + 8*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 40*D1*Ddd*f*g2*s - 12*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*(r*(88*s - 54) + 70*s**2 - 112*s + 45) + f*(-2*K*(4*r*s - 2*r + 6*s**2 - 8*s + 3) - 6*fd*(8*r*(4*s - 1) + 26*s**2 - 29*s + 6) + 32*r*s - 16*r + 38*s**2 - 54*s + 19) + fd*(r*(2*K - 8)*(4*s - 1) + s*(4*K*(3*s - 2) - 38*s + 27))) + Dd*f*(4*K*(8*r*s - 3*r + 12*s**2 - 13*s + 3) - 3*f*(8*r*(16*s - 7) + 104*s**2 - 142*s + 41) - 128*r*s + 48*r - 152*s**2 + 178*s - 43)) + 144*Dd**2*K*f**2*r*s - 36*Dd**2*K*f**2*r + 408*Dd**2*K*f**2*s**2 - 276*Dd**2*K*f**2*s + 24*Dd**2*K*f**2 + 576*Dd**2*f**3*r*s - 144*Dd**2*f**3*r - 288*Dd**2*f**3*s + 96*Dd**2*f**3 - 240*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 432*Dd**2*f**2*s**2 + 336*Dd**2*f**2*s - 40*Dd**2*f**2 - 96*Dd**2*f*g2*r*s + 24*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 120*Dd**2*f*g2*s - 16*Dd**2*f*g2))/(462*d**2*k3**4) - D1**2*Pk3*Pkd2*ct*k1**3*(2*D1*(D1*bd1**2*f*(-2*K*(12*r*s - 6*r + 31*s**2 - 37*s + 6) + 6*f*(r*(8*s - 4) + 9*s**2 - 13*s + 4) + s*(19*s - 19)) - 2*D1*bdd1*f*(s - 1)*(f*(10*C*r + 26*C*(s - 1) - 5*r - 17*s + 17) + g2*(-12*r - 31*s + 31)) + 2*b2*(D1*bd1*(5*f*(s - 1)*(r + s - 1) + 6*fd*(-2*r*s + r - s*(2*s - 2))) - 6*D1*bdd1*f*(s - 1)*(r + s - 1) - 6*Dd*bd1*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 2*bd1*(6*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(2*f**2*(s - 1)*(2*C*(r - 4*s + 4) - 7*r + 2*s - 2) + f*(fd*(2*C*(20*r*s - 10*r + 52*s**2 - 57*s + 5) - 20*r*s + 10*r - 68*s**2 + 73*s - 5) - 4*g2*(s - 1)*(r - 5*s + 5) - 2*gd2*(12*r*s - 6*r + 31*s**2 - 37*s + 6)) + 2*fd*g2*(r*(6 - 12*s) - s*(31*s - 31))) + Dd*f*(f*(10*C*r*(8*s - 5) + 8*C*(26*s**2 - 35*s + 9) - 40*r*s + 25*r - 136*s**2 + 180*s - 44) - 2*g2*(6*r*(8*s - 5) + 124*s**2 - 167*s + 43)))) + 4*b1**3*(D1**2*s*(5*fd - 6*fdd)*(r + s - 1) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-8*D1**2*K*fd*r*s + 40*D1**2*K*fd*s**2 - 24*D1**2*K*fdd*r*s - 62*D1**2*K*fdd*s**2 - 24*D1**2*bdd1*f*(3*r*s - r + 3*s**2 - 3*s + 1) + 24*D1**2*f*fd*s**2 - 24*D1**2*f*fd*s + 96*D1**2*f*fdd*r*s + 108*D1**2*f*fdd*s**2 - 48*D1**2*f*fdd*s + 96*D1**2*fd**2*r*s + 108*D1**2*fd**2*s**2 - 48*D1**2*fd**2*s + 56*D1**2*fd*r*s + 18*D1**2*fd*s**2 + 19*D1**2*fdd*s**2 - 32*D1*Dd*K*f*r*s + 8*D1*Dd*K*f*r + 160*D1*Dd*K*f*s**2 - 64*D1*Dd*K*f*s + 40*D1*Dd*K*f - 192*D1*Dd*K*fd*r*s + 24*D1*Dd*K*fd*r - 496*D1*Dd*K*fd*s**2 + 172*D1*Dd*K*fd*s + 48*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 12*D1*Dd*f**2 + 768*D1*Dd*f*fd*r*s - 96*D1*Dd*f*fd*r + 864*D1*Dd*f*fd*s**2 - 600*D1*Dd*f*fd*s + 48*D1*Dd*f*fd + 224*D1*Dd*f*r*s - 56*D1*Dd*f*r + 72*D1*Dd*f*s**2 - 148*D1*Dd*f*s + 18*D1*Dd*f + 152*D1*Dd*fd*s**2 - 38*D1*Dd*fd*s - 96*D1*Ddd*K*f*r*s + 24*D1*Ddd*K*f*r - 248*D1*Ddd*K*f*s**2 + 172*D1*Ddd*K*f*s - 62*D1*Ddd*K*f + 192*D1*Ddd*f**2*r*s - 48*D1*Ddd*f**2*r + 216*D1*Ddd*f**2*s**2 - 204*D1*Ddd*f**2*s + 54*D1*Ddd*f**2 + 76*D1*Ddd*f*s**2 - 38*D1*Ddd*f*s + 19*D1*Ddd*f + 4*D1*bd1*(D1*(5*f*(3*r*s - r + 3*s**2 - 3*s + 1) - 6*fd*(6*r*s - r + 6*s**2 - 6*s + 1)) - 6*Dd*f*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 288*Dd**2*K*f*r*s + 72*Dd**2*K*f*r - 744*Dd**2*K*f*s**2 + 516*Dd**2*K*f*s - 48*Dd**2*K*f + 576*Dd**2*f**2*r*s - 144*Dd**2*f**2*r + 648*Dd**2*f**2*s**2 - 612*Dd**2*f**2*s + 96*Dd**2*f**2 + 228*Dd**2*f*s**2 - 114*Dd**2*f*s) + b1*(-32*C*D1**2*f*fd*r*s + 128*C*D1**2*f*fd*s**2 + 16*C*D1**2*f*fd*s - 80*C*D1**2*f*fdd*r*s - 208*C*D1**2*f*fdd*s**2 + 40*C*D1**2*f*fdd*s - 80*C*D1**2*fd**2*r*s - 208*C*D1**2*fd**2*s**2 + 40*C*D1**2*fd**2*s - 64*C*D1*Dd*f**2*r*s + 16*C*D1*Dd*f**2*r + 256*C*D1*Dd*f**2*s**2 - 96*C*D1*Dd*f**2*s + 64*C*D1*Dd*f**2 - 640*C*D1*Dd*f*fd*r*s + 80*C*D1*Dd*f*fd*r - 1664*C*D1*Dd*f*fd*s**2 + 736*C*D1*Dd*f*fd*s - 40*C*D1*Dd*f*fd - 160*C*D1*Ddd*f**2*r*s + 40*C*D1*Ddd*f**2*r - 416*C*D1*Ddd*f**2*s**2 + 288*C*D1*Ddd*f**2*s - 104*C*D1*Ddd*f**2 - 480*C*Dd**2*f**2*r*s + 120*C*Dd**2*f**2*r - 1248*C*Dd**2*f**2*s**2 + 864*C*Dd**2*f**2*s - 80*C*Dd**2*f**2 - 24*D1**2*bd1**2*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*f*(-2*K*(24*r*s - 12*r + 62*s**2 - 74*s + 31) + 6*f*(8*r*(2*s - 1) + 18*s**2 - 26*s + 9) + 38*s**2 - 38*s + 19) - 24*D1**2*bdd2*f*r*s - 24*D1**2*bdd2*f*s**2 + 24*D1**2*bdd2*f*s + 112*D1**2*f*fd*r*s - 32*D1**2*f*fd*s**2 - 56*D1**2*f*fd*s + 40*D1**2*f*fdd*r*s + 136*D1**2*f*fdd*s**2 - 20*D1**2*f*fdd*s + 16*D1**2*f*gd2*r*s - 80*D1**2*f*gd2*s**2 - 16*D1**2*f*gd2*s + 48*D1**2*f*gdd2*r*s + 124*D1**2*f*gdd2*s**2 - 48*D1**2*f*gdd2*s + 40*D1**2*fd**2*r*s + 136*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s + 16*D1**2*fd*g2*r*s - 80*D1**2*fd*g2*s**2 + 96*D1**2*fd*gd2*r*s + 248*D1**2*fd*gd2*s**2 - 48*D1**2*fd*gd2*s + 48*D1**2*fdd*g2*r*s + 124*D1**2*fdd*g2*s**2 + 224*D1*Dd*f**2*r*s - 56*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 - 80*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 320*D1*Dd*f*fd*r*s - 40*D1*Dd*f*fd*r + 1088*D1*Dd*f*fd*s**2 - 432*D1*Dd*f*fd*s + 20*D1*Dd*f*fd + 64*D1*Dd*f*g2*r*s - 16*D1*Dd*f*g2*r - 320*D1*Dd*f*g2*s**2 + 128*D1*Dd*f*g2*s - 80*D1*Dd*f*g2 + 384*D1*Dd*f*gd2*r*s - 48*D1*Dd*f*gd2*r + 992*D1*Dd*f*gd2*s**2 - 536*D1*Dd*f*gd2*s + 48*D1*Dd*f*gd2 + 384*D1*Dd*fd*g2*r*s - 48*D1*Dd*fd*g2*r + 992*D1*Dd*fd*g2*s**2 - 344*D1*Dd*fd*g2*s + 80*D1*Ddd*f**2*r*s - 20*D1*Ddd*f**2*r + 272*D1*Ddd*f**2*s**2 - 176*D1*Ddd*f**2*s + 68*D1*Ddd*f**2 + 192*D1*Ddd*f*g2*r*s - 48*D1*Ddd*f*g2*r + 496*D1*Ddd*f*g2*s**2 - 344*D1*Ddd*f*g2*s + 124*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(6*f**2*(2*s**2 + 1) + f*(4*K*(-2*r*s + r + 10*s**2 - 9*s + 5) + 12*fd*(4*r*(4*s - 1) + 18*s**2 - 17*s + 2) + 56*r*s - 28*r + 18*s**2 - 46*s + 9) + fd*(-2*K*(6*r*(4*s - 1) + s*(62*s - 37)) + 19*s*(2*s - 1))) + Dd*f*(-2*K*(96*r*s - 36*r + 248*s**2 - 234*s + 49) + 6*f*(8*r*(8*s - 3) + 72*s**2 - 86*s + 21) + 152*s**2 - 114*s + 19)) + 4*D1*bd2*(D1*s*(5*f*(r + s - 1) - 6*fd*(2*r + 2*s - 1)) - 6*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 240*Dd**2*f**2*r*s - 60*Dd**2*f**2*r + 816*Dd**2*f**2*s**2 - 528*Dd**2*f**2*s + 40*Dd**2*f**2 + 576*Dd**2*f*g2*r*s - 144*Dd**2*f*g2*r + 1488*Dd**2*f*g2*s**2 - 1032*Dd**2*f*g2*s + 96*Dd**2*f*g2 + 4*b2*(D1**2*s*(5*fd - 6*fdd)*(r + s) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) + 6*fd*(-8*r*s + r + s*(4 - 8*s))) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2))))/(21*d**2*k3**4) + D1**2*Pk3*Pkd2*ct*k1**3*st**2*(55*b1**2*(-D1**2*s**2*(12*f*fdd + 12*fd**2 + fd*(-24*f - 2) + fdd) + D1*(2*Dd*(6*f**2*(4*s**2 - 2*s + 1) + f*s**2*(4 - 48*fd) + 2*f*s*(6*fd - 1) + f + fd*s*(1 - 4*s)) - Ddd*f*(6*f + 1)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(6*f + 1)*(2*s - 1)) + 11*b1*(-5*D1**2*bdd1*f*(6*f + 1)*(2*s**2 - 2*s + 1) - 252*D1**2*f**2*fd*s**2 + 168*D1**2*f**2*fd*s - 84*D1**2*f**2*fd + 126*D1**2*f**2*fdd*s**2 - 84*D1**2*f**2*fdd*s + 42*D1**2*f**2*fdd + 252*D1**2*f*fd**2*s**2 - 168*D1**2*f*fd**2*s - 24*D1**2*f*fd*s**2 + 44*D1**2*f*fd*s - 22*D1**2*f*fd + 12*D1**2*f*fdd*s**2 - 22*D1**2*f*fdd*s + 11*D1**2*f*fdd + 12*D1**2*fd**2*s**2 - 22*D1**2*fd**2*s - 336*D1*Dd*f**3*s**2 + 168*D1*Dd*f**3*s - 84*D1*Dd*f**3 + 1008*D1*Dd*f**2*fd*s**2 - 588*D1*Dd*f**2*fd*s + 84*D1*Dd*f**2*fd - 48*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 96*D1*Dd*f*fd*s**2 - 112*D1*Dd*f*fd*s + 22*D1*Dd*f*fd + 168*D1*Ddd*f**3*s**2 - 84*D1*Ddd*f**3*s + 42*D1*Ddd*f**3 + 24*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 10*D1*bd1*(D1*(6*f**2*(2*s**2 - 2*s + 1) + f*s**2*(2 - 24*fd) + 2*f*s*(6*fd - 1) + f + fd*s*(1 - 2*s)) - Dd*f*(6*f + 1)*(8*s**2 - 6*s + 1)) + 504*Dd**2*f**3*s**2 - 252*Dd**2*f**3*s + 72*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s) + f*(-110*D1**2*bd1**2*s*(6*f + 1)*(s - 1) + 11*D1**2*bdd1*f*(s**2*(42*f + 6) + 10*s - 5) - 105*D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) - 22*D1*bd1*(D1*(42*f**2*s**2 + f*(s**2*(6 - 126*fd) + s*(42*fd + 10) - 5) + fd*s*(1 - 12*s)) - Dd*f*(4*s - 1)*(s*(42*f + 6) + 5)) - 105*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 630*Dd**2*f**2*s*(1 - 2*s)))/(462*d**2*k2**2*k3**2) + D1**2*Pk3*Pkd2*ct*k1**3*(2*D1*f*(s - 1)*(D1*bd1**2*s*(36*f + 19) + 8*D1*bdd1*f*(s - 1) + 16*bd1*(D1*(-f*s + f + 2*fd*s) + Dd*f*(4*s - 1))) + b1**2*(D1**2*s**2*(72*fd**2 + fd*(-144*f - 38) + fdd*(72*f + 19)) + D1*(-2*Dd*(36*f**2*(4*s**2 - 2*s + 1) + f*(s**2*(76 - 288*fd) + s*(72*fd - 38) + 19) + 19*fd*s*(1 - 4*s)) + Ddd*f*(36*f + 19)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f*s*(36*f + 19)*(2*s - 1)) + b1*(D1**2*bdd1*f*(36*f + 19)*(2*s**2 - 2*s + 1) - 32*D1**2*s**2*(2*f*fd - f*fdd - fd**2) - 2*D1*bd1*(D1*(36*f**2*(2*s**2 - 2*s + 1) + f*(s**2*(38 - 144*fd) + s*(72*fd - 38) + 19) + 19*fd*s*(1 - 2*s)) - Dd*f*(36*f + 19)*(8*s**2 - 6*s + 1)) - 16*D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) + 4*Dd*fd*s*(1 - 4*s) + Ddd*f*(-4*s**2 + 2*s - 1)) - 96*Dd**2*f**2*s*(1 - 2*s)))/(21*d**2*k2**2*k3**2) - 20*D1**2*Pk3*Pkd2*ct*k1*k2**4*st**6*(24*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r + 24*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r*s + 4*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r*s + 8*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 32*C*D1*Dd*f**3*r*s - 8*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s**2 - 32*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r*s + 28*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 96*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 16*C*D1*Ddd*f**3*r*s + 4*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 16*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 48*C*Dd**2*f**3*r*s + 12*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 48*C*Dd**2*f**3*s - 8*C*Dd**2*f**3 - 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s + 7*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 - 7*D1**2*bdd1*f**3*s + 33*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s - 18*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 18*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 9*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r + 9*D1**2*f**2*fdd*s**2 - 9*D1**2*f**2*fdd*s + 3*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 18*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r + 18*D1**2*f*fd**2*s**2 - 18*D1**2*f*fd**2*s + 3*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r*s - 132*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 528*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s - 24*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 24*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 72*D1*Dd*f**2*fd*r*s - 21*D1*Dd*f**2*fd*r + 72*D1*Dd*f**2*fd*s**2 - 72*D1*Dd*f**2*fd*s + 15*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r*s - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1056*D1*Dd*f**2*gd2*s + 132*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r*s - 792*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2112*D1*Dd*f*fd*g2*s + 528*D1*Dd*f*fd*g2 + 12*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r*s - 132*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 528*D1*Ddd*f**2*g2*s + 132*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-66*K + 7*f + 33)*(r + s - 1) - 33*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-66*K + 7*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 36*Dd**2*f**3*r*s - 9*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 6*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r*s - 396*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 1584*Dd**2*f**2*g2*s + 264*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*fd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 33*fdd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 33*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (132*K - 66)*(r*(4*s - 1) + (1 - 2*s)**2)) - 66*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-66*K + 7*f + 33)) + Dd**2*f**2*(-66*K + 7*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**6) - 8*D1**2*Pk3*Pkd2*ct*k1*k2**4*st**4*(-11*D1**2*bd1**2*f*(2*K - 1)*(2*s - 1)*(r + s - 1) - 11*D1*bd1*(D1*(f**2*s*(3*K - 1)*(r + s - 1) + 4*f*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 4*fd*g2*(-2*r*s + r - s*(2*s - 2))) - 4*Dd*f*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 11*b1**2*(2*K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 11*b1*(-6*D1**2*K*f*fd*r*s + 3*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd - D1**2*bdd1*f*(2*K - 1)*(2*s - 1)*(r + s - 1) + 2*D1**2*f*fd*r*s - D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + D1**2*f*fd - 8*D1**2*f*gd2*r*s - 8*D1**2*f*gd2*s**2 + 8*D1**2*f*gd2*s + 4*D1**2*f*gdd2*r*s + 4*D1**2*f*gdd2*s**2 - 4*D1**2*f*gdd2*s - 8*D1**2*fd*g2*r*s - 8*D1**2*fd*g2*s**2 + 8*D1**2*fd*gd2*r*s + 8*D1**2*fd*gd2*s**2 - 4*D1**2*fd*gd2*s + 4*D1**2*fdd*g2*r*s + 4*D1**2*fdd*g2*s**2 - 12*D1*Dd*K*f**2*r*s + 3*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 12*D1*Dd*K*f**2*s - 3*D1*Dd*K*f**2 + 4*D1*Dd*f**2*r*s - D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 4*D1*Dd*f**2*s + D1*Dd*f**2 - 32*D1*Dd*f*g2*r*s + 8*D1*Dd*f*g2*r - 32*D1*Dd*f*g2*s**2 + 32*D1*Dd*f*g2*s - 8*D1*Dd*f*g2 + 32*D1*Dd*f*gd2*r*s - 4*D1*Dd*f*gd2*r + 32*D1*Dd*f*gd2*s**2 - 32*D1*Dd*f*gd2*s + 4*D1*Dd*f*gd2 + 32*D1*Dd*fd*g2*r*s - 4*D1*Dd*fd*g2*r + 32*D1*Dd*fd*g2*s**2 - 16*D1*Dd*fd*g2*s + 16*D1*Ddd*f*g2*r*s - 4*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s**2 - 16*D1*Ddd*f*g2*s + 4*D1*Ddd*f*g2 + D1*bd1*(2*K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) + 48*Dd**2*f*g2*r*s - 12*Dd**2*f*g2*r + 48*Dd**2*f*g2*s**2 - 48*Dd**2*f*g2*s + 8*Dd**2*f*g2) + f*(D1**2*(44*bdd1*g2*(s - 1)*(r + s - 1) + f*(-fd*(20*C - 10)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 66*gd2*s*(r + s - 1)) + fd**2*(10*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + D1*f*(Dd*(f*(10 - 20*C)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(10*C - 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 66*g2*(r*(4*s - 1) + (1 - 2*s)**2)) + Ddd*f*(10*C - 5)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(10*C - 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(77*d**2*k3**6) + 4*D1**2*Pk3*Pkd2*ct*k1*k2**4*st**2*(D1*(-9*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + D1*bd1*(2*f**2*(r + s - 1)*(15*C*(s - 1) - s*(3*K + 7) + 7) - 3*f*(fd*(6*C - 3)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (26*g2*(s - 1) + 2*gd2*(3 - 6*s))*(r + s - 1)) + 18*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 9*D1*bdd1*f*(s - 1)*(f*(2*C - 1) - 2*g2)*(r + s - 1) - 9*Dd*bd1*f*(f*(2*C - 1) - 2*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 6*f*(D1*(f*fd*(2*C - 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 2*f*gd2*s*(r + s - 1) + 2*fd*g2*(-2*r*s + r - 2*s**2 + 2*s - 1)) + Dd*f*(f*(2*C - 1) - 2*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**2*(D1**2*s*(3*f*fd*(2*r + 2*s - 1) + (r + s)*(-9*K*fdd + fd*(39*K - 7))) + D1*(Dd*(9*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 3*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(39*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(-9*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(-6*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(30*C - 14)*(2*r + 2*s - 1) - 3*s*(fdd*(6*C - 3)*(2*r + 2*s - 1) + (26*gd2 - 6*gdd2)*(r + s - 1))) - 3*s*(fd**2*(6*C - 3)*(2*r + 2*s - 1) + 26*fd*g2*(r + s) - 6*fd*gd2*(2*r + 2*s - 1) - 6*fdd*g2*(r + s))) + D1*bd1*(D1*(9*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 3*f**2*(2*s - 1)*(r + s - 1) + f*(39*K - 7)*(2*s - 1)*(r + s - 1)) - 9*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + D1*(Dd*(2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(15*C - 3*K - 7) - 3*f*(fd*(6*C - 3)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 26*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 6*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 18*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - 9*Ddd*f*(f*(2*C - 1) - 2*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*f*(f*(2*C - 1) - 2*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**6) - 5*D1**2*Pk3*Pkd2*ct*k1*k2**2*st**6*(-48*C*D1**2*f**2*fd*r*s + 16*C*D1**2*f**2*fd*r + 120*C*D1**2*f**2*fd*s**2 - 64*C*D1**2*f**2*fd*s + 40*C*D1**2*f**2*fd + 24*C*D1**2*f**2*fdd*r*s - 8*C*D1**2*f**2*fdd*r - 60*C*D1**2*f**2*fdd*s**2 + 32*C*D1**2*f**2*fdd*s - 20*C*D1**2*f**2*fdd + 48*C*D1**2*f*fd**2*r*s - 16*C*D1**2*f*fd**2*r - 120*C*D1**2*f*fd**2*s**2 + 64*C*D1**2*f*fd**2*s + 8*C*D1**2*f*fd**2 - 64*C*D1*Dd*f**3*r*s + 16*C*D1*Dd*f**3*r + 160*C*D1*Dd*f**3*s**2 - 48*C*D1*Dd*f**3*s + 40*C*D1*Dd*f**3 + 192*C*D1*Dd*f**2*fd*r*s - 56*C*D1*Dd*f**2*fd*r - 480*C*D1*Dd*f**2*fd*s**2 + 200*C*D1*Dd*f**2*fd*s - 16*C*D1*Dd*f**2*fd + 32*C*D1*Ddd*f**3*r*s - 8*C*D1*Ddd*f**3*r - 80*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s - 20*C*D1*Ddd*f**3 + 96*C*Dd**2*f**3*r*s - 24*C*Dd**2*f**3*r - 240*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s + 16*C*Dd**2*f**3 + 132*D1**2*K*bdd1*f**2*r*s - 330*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s - 28*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 + 28*D1**2*bdd1*f**3*s - 264*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 + 264*D1**2*bdd1*f**2*s - 112*D1**2*f**3*fd*r*s + 28*D1**2*f**3*fd*r + 56*D1**2*f**3*fd*s + 112*D1**2*f**3*fdd*r*s - 28*D1**2*f**3*fdd*r - 56*D1**2*f**3*fdd*s + 336*D1**2*f**2*fd**2*r*s - 84*D1**2*f**2*fd**2*r - 168*D1**2*f**2*fd**2*s + 56*D1**2*f**2*fd**2 + 72*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r - 66*D1**2*f**2*fd*s**2 + 20*D1**2*f**2*fd*s - 22*D1**2*f**2*fd - 36*D1**2*f**2*fdd*r*s + 12*D1**2*f**2*fdd*r + 33*D1**2*f**2*fdd*s**2 - 10*D1**2*f**2*fdd*s + 11*D1**2*f**2*fdd + 528*D1**2*f**2*gd2*r*s - 1320*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s - 264*D1**2*f**2*gdd2*r*s + 660*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 72*D1**2*f*fd**2*r*s + 24*D1**2*f*fd**2*r + 66*D1**2*f*fd**2*s**2 - 20*D1**2*f*fd**2*s - 12*D1**2*f*fd**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r - 2640*D1**2*f*fd*g2*s**2 + 2640*D1**2*f*fd*g2*s - 1320*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r*s + 264*D1**2*f*fd*gd2*r + 2640*D1**2*f*fd*gd2*s**2 - 792*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r + 1320*D1**2*f*fdd*g2*s**2 - 1320*D1**2*f*fdd*g2*s + 660*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r + 1320*D1**2*fd**2*g2*s**2 - 1320*D1**2*fd**2*g2*s - 112*D1*Dd*f**4*r*s + 28*D1*Dd*f**4*r + 56*D1*Dd*f**4*s + 896*D1*Dd*f**3*fd*r*s - 224*D1*Dd*f**3*fd*r - 448*D1*Dd*f**3*fd*s + 112*D1*Dd*f**3*fd + 96*D1*Dd*f**3*r*s - 24*D1*Dd*f**3*r - 88*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s - 22*D1*Dd*f**3 - 288*D1*Dd*f**2*fd*r*s + 84*D1*Dd*f**2*fd*r + 264*D1*Dd*f**2*fd*s**2 - 34*D1*Dd*f**2*fd*s - 14*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*g2*r*s - 528*D1*Dd*f**2*g2*r - 5280*D1*Dd*f**2*g2*s**2 + 1584*D1*Dd*f**2*g2*s - 1320*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r*s + 264*D1*Dd*f**2*gd2*r + 5280*D1*Dd*f**2*gd2*s**2 + 264*D1*Dd*f**2*gd2*s - 264*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r*s + 1584*D1*Dd*f*fd*g2*r + 10560*D1*Dd*f*fd*g2*s**2 - 6864*D1*Dd*f*fd*g2*s + 792*D1*Dd*f*fd*g2 + 112*D1*Ddd*f**4*r*s - 28*D1*Ddd*f**4*r - 56*D1*Ddd*f**4*s - 48*D1*Ddd*f**3*r*s + 12*D1*Ddd*f**3*r + 44*D1*Ddd*f**3*s**2 + 2*D1*Ddd*f**3*s + 11*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r*s + 264*D1*Ddd*f**2*g2*r + 2640*D1*Ddd*f**2*g2*s**2 - 792*D1*Ddd*f**2*g2*s + 660*D1*Ddd*f**2*g2 + 2*D1*bd1*f*(D1*(f*s*(-66*K*(2*r - 5*s - 2) + 7*f*(4*r - s - 4) + 264*r - 33*s - 264) + fd*(33*K*(8*r*s - 2*r - 20*s**2 + 6*s + 2) + 7*f*(r*(2 - 12*s) + 3*s**2 + 7*s - 2) - 528*r*s + 132*r + 66*s**2 + 231*s - 132)) + Dd*f*(-66*K*(-8*r*s + r + 20*s**2 + s - 1) + 7*f*(r*(2 - 16*s) + 4*s**2 + 11*s - 2) - 1056*r*s + 132*r + 132*s**2 + 759*s - 132)) + 336*Dd**2*f**4*r*s - 84*Dd**2*f**4*r - 168*Dd**2*f**4*s + 56*Dd**2*f**4 - 144*Dd**2*f**3*r*s + 36*Dd**2*f**3*r + 132*Dd**2*f**3*s**2 + 6*Dd**2*f**3*s - 24*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r*s + 792*Dd**2*f**2*g2*r + 7920*Dd**2*f**2*g2*s**2 - 2376*Dd**2*f**2*g2*s - 528*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(4 - 12*s) + 3*s**2 + 2*s + 1) + f*(14*fd**2*(r*(4 - 12*s) + 3*s**2 + 2*s - 2) - 66*fd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1) + 33*fdd*(2*K*(4*r*s - 2*r - 10*s**2 + 10*s - 5) - 16*r*s + 8*r + 2*s**2 - 2*s + 1)) + 66*fd**2*(r*(2*K - 4)*(2*s - 1) - s*(10*K - 1)*(s - 1))) + D1*f*(2*Dd*(-7*f**2*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) + f*(-66*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + fd*(r*(98 - 336*s) + 84*s**2 + 91*s - 35) + 1056*r*s - 264*r - 132*s**2 - 462*s - 33) + 33*fd*(2*K*(16*r*s - 6*r - 40*s**2 + 26*s - 3) - 64*r*s + 24*r + 8*s**2 + 10*s - 7)) + Ddd*f*(66*K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) + 7*f*(r*(4 - 16*s) + 4*s**2 + 6*s + 1) - 1056*r*s + 264*r + 132*s**2 + 462*s + 33)) + 2*Dd**2*f**2*(66*K*(12*r*s - 3*r - 30*s**2 + 9*s + 2) + 7*f*(r*(6 - 24*s) + 6*s**2 + 9*s - 4) - 1584*r*s + 396*r + 198*s**2 + 693*s - 264)))/(1386*d**2*k3**4) - D1**2*Pk3*Pkd2*ct*k1*k2**2*st**4*(1008*C*D1**2*f**2*fd*r*s - 336*C*D1**2*f**2*fd*r + 840*C*D1**2*f**2*fd*s**2 - 896*C*D1**2*f**2*fd*s + 280*C*D1**2*f**2*fd - 504*C*D1**2*f**2*fdd*r*s + 168*C*D1**2*f**2*fdd*r - 420*C*D1**2*f**2*fdd*s**2 + 448*C*D1**2*f**2*fdd*s - 140*C*D1**2*f**2*fdd - 1008*C*D1**2*f*fd**2*r*s + 336*C*D1**2*f*fd**2*r - 840*C*D1**2*f*fd**2*s**2 + 896*C*D1**2*f*fd**2*s - 168*C*D1**2*f*fd**2 + 1344*C*D1*Dd*f**3*r*s - 336*C*D1*Dd*f**3*r + 1120*C*D1*Dd*f**3*s**2 - 1232*C*D1*Dd*f**3*s + 280*C*D1*Dd*f**3 - 4032*C*D1*Dd*f**2*fd*r*s + 1176*C*D1*Dd*f**2*fd*r - 3360*C*D1*Dd*f**2*fd*s**2 + 3640*C*D1*Dd*f**2*fd*s - 784*C*D1*Dd*f**2*fd - 672*C*D1*Ddd*f**3*r*s + 168*C*D1*Ddd*f**3*r - 560*C*D1*Ddd*f**3*s**2 + 616*C*D1*Ddd*f**3*s - 140*C*D1*Ddd*f**3 - 2016*C*Dd**2*f**3*r*s + 504*C*Dd**2*f**3*r - 1680*C*Dd**2*f**3*s**2 + 1848*C*Dd**2*f**3*s - 336*C*Dd**2*f**3 + 264*D1**2*K*bdd1*f**2*r*s + 594*D1**2*K*bdd1*f**2*s**2 - 264*D1**2*K*bdd1*f**2*s + 264*D1**2*b2*f*fd*r*s - 132*D1**2*b2*f*fd*r + 264*D1**2*b2*f*fd*s**2 - 264*D1**2*b2*f*fd*s + 132*D1**2*b2*f*fd - 66*D1**2*bd1**2*f*(2*K*(2*r*s + r + 5*s**2 - 2*s - 1) + 4*r*(s - 1) - s**2 - 5*s + 4) + 132*D1**2*bd2*f**2*r*s + 132*D1**2*bd2*f**2*s**2 - 132*D1**2*bd2*f**2*s - 132*D1**2*bdd1*f**2*r*s - 297*D1**2*bdd1*f**2*s**2 + 132*D1**2*bdd1*f**2*s + 264*D1**2*bdd1*f*g2*r*s + 264*D1**2*bdd1*f*g2*r + 660*D1**2*bdd1*f*g2*s**2 - 264*D1**2*bdd1*f*g2*s + 132*D1**2*bdd1*f*g2 - 576*D1**2*f**2*fd*r*s + 192*D1**2*f**2*fd*r - 480*D1**2*f**2*fd*s**2 + 512*D1**2*f**2*fd*s - 160*D1**2*f**2*fd + 288*D1**2*f**2*fdd*r*s - 96*D1**2*f**2*fdd*r + 240*D1**2*f**2*fdd*s**2 - 256*D1**2*f**2*fdd*s + 80*D1**2*f**2*fdd + 1056*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gdd2*r*s - 1188*D1**2*f**2*gdd2*s**2 + 528*D1**2*f**2*gdd2*s + 576*D1**2*f*fd**2*r*s - 192*D1**2*f*fd**2*r + 480*D1**2*f*fd**2*s**2 - 512*D1**2*f*fd**2*s + 96*D1**2*f*fd**2 + 2112*D1**2*f*fd*g2*s**2 - 2112*D1**2*f*fd*g2*s + 1056*D1**2*f*fd*g2 - 2112*D1**2*f*fd*gd2*r*s + 528*D1**2*f*fd*gd2*r - 4752*D1**2*f*fd*gd2*s**2 + 3432*D1**2*f*fd*gd2*s - 528*D1**2*f*fd*gd2 - 1056*D1**2*f*fdd*g2*r*s + 528*D1**2*f*fdd*g2*r - 2376*D1**2*f*fdd*g2*s**2 + 2376*D1**2*f*fdd*g2*s - 1188*D1**2*f*fdd*g2 - 1056*D1**2*fd**2*g2*r*s + 528*D1**2*fd**2*g2*r - 2376*D1**2*fd**2*g2*s**2 + 2376*D1**2*fd**2*g2*s + 528*D1*Dd*b2*f**2*r*s - 132*D1*Dd*b2*f**2*r + 528*D1*Dd*b2*f**2*s**2 - 528*D1*Dd*b2*f**2*s + 132*D1*Dd*b2*f**2 - 768*D1*Dd*f**3*r*s + 192*D1*Dd*f**3*r - 640*D1*Dd*f**3*s**2 + 704*D1*Dd*f**3*s - 160*D1*Dd*f**3 + 2304*D1*Dd*f**2*fd*r*s - 672*D1*Dd*f**2*fd*r + 1920*D1*Dd*f**2*fd*s**2 - 2080*D1*Dd*f**2*fd*s + 448*D1*Dd*f**2*fd + 4224*D1*Dd*f**2*g2*s**2 - 2112*D1*Dd*f**2*g2*s + 1056*D1*Dd*f**2*g2 - 4224*D1*Dd*f**2*gd2*r*s + 528*D1*Dd*f**2*gd2*r - 9504*D1*Dd*f**2*gd2*s**2 + 5544*D1*Dd*f**2*gd2*s - 528*D1*Dd*f**2*gd2 - 8448*D1*Dd*f*fd*g2*r*s + 3168*D1*Dd*f*fd*g2*r - 19008*D1*Dd*f*fd*g2*s**2 + 16368*D1*Dd*f*fd*g2*s - 3432*D1*Dd*f*fd*g2 + 384*D1*Ddd*f**3*r*s - 96*D1*Ddd*f**3*r + 320*D1*Ddd*f**3*s**2 - 352*D1*Ddd*f**3*s + 80*D1*Ddd*f**3 - 2112*D1*Ddd*f**2*g2*r*s + 528*D1*Ddd*f**2*g2*r - 4752*D1*Ddd*f**2*g2*s**2 + 3432*D1*Ddd*f**2*g2*s - 1188*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(f**2*s*(8*K*s + 2*r - 3*s - 2) + f*(-fd*(2*K - 1)*(r*(8*s - 2) + 18*s**2 - 13*s + 2) + 4*g2*(2*r*(s + 1) + 5*s**2 - 2*s + 1) - 4*gd2*(2*r*s + r + 5*s**2 - 2*s - 1)) + 4*fd*g2*(-2*r*s + r - s*(5*s - 5))) + Dd*f*(-f*(2*K - 1)*(16*r*s - 2*r + 36*s**2 - 21*s + 2) - 4*g2*(8*r*s + 3*r + 20*s**2 - 11*s - 1))) + 1152*Dd**2*f**3*r*s - 288*Dd**2*f**3*r + 960*Dd**2*f**3*s**2 - 1056*Dd**2*f**3*s + 192*Dd**2*f**3 - 6336*Dd**2*f**2*g2*r*s + 1584*Dd**2*f**2*g2*r - 14256*Dd**2*f**2*g2*s**2 + 10296*Dd**2*f**2*g2*s - 1056*Dd**2*f**2*g2 + 33*b1**2*(D1**2*(2*fd - fdd)*(2*K*(2*r*(s - 2) + 5*s**2 - 8*s + 4) + 4*r*(s + 1) - s**2 + 8*s - 4) + D1*(2*Dd*(f*(2*K*(8*r*s - 2*r + 20*s**2 - 14*s + 5) + 16*r*s - 4*r - 4*s**2 - 6*s - 1) - fd*(2*K*(8*r*s - 9*r + 20*s**2 - 23*s + 8) + 16*r*s + 6*r - 4*s**2 + 13*s - 8)) + Ddd*f*(-2*K*(8*r*s - 2*r + 20*s**2 - 14*s + 5) - 16*r*s + 4*r + 4*s**2 + 6*s + 1)) - 2*Dd**2*f*(K*(6*r*(4*s - 1) + 60*s**2 - 42*s + 4) + 6*r*(4*s - 1) - 6*s**2 - 9*s + 4)) + 33*b1*(-32*D1**2*K*f*fd*s**2 + 32*D1**2*K*f*fd*s - 16*D1**2*K*f*fd + 16*D1**2*K*f*fdd*r*s - 8*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 16*D1**2*K*fd**2*r*s - 8*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - D1**2*bdd1*f*(K*(r*(8*s + 4) + 20*s**2 - 8*s + 2) + 8*r*(s - 1) - 2*s**2 - 10*s + 3) - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r + 12*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s + 6*D1**2*f*fd - 8*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 16*D1**2*f*gd2*r*s - 40*D1**2*f*gd2*s**2 + 16*D1**2*f*gd2*s + 8*D1**2*f*gdd2*r*s + 20*D1**2*f*gdd2*s**2 - 8*D1**2*f*gdd2*s - 8*D1**2*fd**2*r*s + 4*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s - 16*D1**2*fd*g2*r*s + 32*D1**2*fd*g2*r - 40*D1**2*fd*g2*s**2 + 64*D1**2*fd*g2*s - 32*D1**2*fd*g2 + 16*D1**2*fd*gd2*r*s - 16*D1**2*fd*gd2*r + 40*D1**2*fd*gd2*s**2 - 40*D1**2*fd*gd2*s + 16*D1**2*fd*gd2 + 8*D1**2*fdd*g2*r*s - 16*D1**2*fdd*g2*r + 20*D1**2*fdd*g2*s**2 - 32*D1**2*fdd*g2*s + 16*D1**2*fdd*g2 - 64*D1*Dd*K*f**2*s**2 + 32*D1*Dd*K*f**2*s - 16*D1*Dd*K*f**2 + 128*D1*Dd*K*f*fd*r*s - 48*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 248*D1*Dd*K*f*fd*s + 52*D1*Dd*K*f*fd - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 4*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 64*D1*Dd*f*fd*r*s + 24*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 124*D1*Dd*f*fd*s - 26*D1*Dd*f*fd - 64*D1*Dd*f*g2*r*s + 16*D1*Dd*f*g2*r - 160*D1*Dd*f*g2*s**2 + 112*D1*Dd*f*g2*s - 40*D1*Dd*f*g2 + 64*D1*Dd*f*gd2*r*s - 8*D1*Dd*f*gd2*r + 160*D1*Dd*f*gd2*s**2 - 88*D1*Dd*f*gd2*s + 8*D1*Dd*f*gd2 + 64*D1*Dd*fd*g2*r*s - 72*D1*Dd*fd*g2*r + 160*D1*Dd*fd*g2*s**2 - 184*D1*Dd*fd*g2*s + 64*D1*Dd*fd*g2 + 32*D1*Ddd*K*f**2*r*s - 8*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 52*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 - 16*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 26*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 32*D1*Ddd*f*g2*r*s - 8*D1*Ddd*f*g2*r + 80*D1*Ddd*f*g2*s**2 - 56*D1*Ddd*f*g2*s + 20*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f*(K*(r*(8*s + 4) + 20*s**2 - 8*s + 2) + 8*r*(s - 1) - 2*s**2 - 10*s + 3) + fd*(K*(-8*r*s + 6*r - 20*s**2 + 20*s - 4) + 2*s**2 - s*(8*r + 3) + 2)) + Dd*f*(-4*r*(8*K*s + K + 8*s - 5) + s**2*(8 - 80*K) + s*(44*K + 26) - 13)) + 96*Dd**2*K*f**2*r*s - 24*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 156*Dd**2*K*f**2*s + 16*Dd**2*K*f**2 - 48*Dd**2*f**2*r*s + 12*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 78*Dd**2*f**2*s - 8*Dd**2*f**2 + 96*Dd**2*f*g2*r*s - 24*Dd**2*f*g2*r + 240*Dd**2*f*g2*s**2 - 168*Dd**2*f*g2*s + 16*Dd**2*f*g2))/(231*d**2*k3**4) + D1**2*Pk3*Pkd2*ct*k1*k2**2*st**2*(-352*C*D1**2*bd1**2*f*r*s + 176*C*D1**2*bd1**2*f*r - 352*C*D1**2*bd1**2*f*s**2 + 352*C*D1**2*bd1**2*f*s - 2024*C*D1**2*bd1*f**2*r*s + 2288*C*D1**2*bd1*f**2*r - 2640*C*D1**2*bd1*f**2*s**2 + 5808*C*D1**2*bd1*f**2*s - 2904*C*D1**2*bd1*f**2 + 4928*C*D1**2*bd1*f*fd*r*s - 2728*C*D1**2*bd1*f*fd*r + 5632*C*D1**2*bd1*f*fd*s**2 - 7392*C*D1**2*bd1*f*fd*s + 1496*C*D1**2*bd1*f*fd + 1232*C*D1**2*bdd1*f**2*r*s - 1496*C*D1**2*bdd1*f**2*r + 1408*C*D1**2*bdd1*f**2*s**2 - 3344*C*D1**2*bdd1*f**2*s + 1672*C*D1**2*bdd1*f**2 + 2520*C*D1**2*f**2*fd*r*s - 840*C*D1**2*f**2*fd*r - 792*C*D1**2*f**2*fd*s**2 - 312*C*D1**2*f**2*fd*s - 264*C*D1**2*f**2*fd + 984*C*D1**2*f**2*fdd*r*s - 328*C*D1**2*f**2*fdd*r + 2772*C*D1**2*f**2*fdd*s**2 - 2176*C*D1**2*f**2*fdd*s + 924*C*D1**2*f**2*fdd + 1968*C*D1**2*f*fd**2*r*s - 656*C*D1**2*f*fd**2*r + 5544*C*D1**2*f*fd**2*s**2 - 4352*C*D1**2*f*fd**2*s + 328*C*D1**2*f*fd**2 + 9856*C*D1*Dd*bd1*f**2*r*s - 7216*C*D1*Dd*bd1*f**2*r + 11264*C*D1*Dd*bd1*f**2*s**2 - 18656*C*D1*Dd*bd1*f**2*s + 6336*C*D1*Dd*bd1*f**2 + 3360*C*D1*Dd*f**3*r*s - 840*C*D1*Dd*f**3*r - 1056*C*D1*Dd*f**3*s**2 - 1152*C*D1*Dd*f**3*s - 264*C*D1*Dd*f**3 + 7872*C*D1*Dd*f**2*fd*r*s - 2296*C*D1*Dd*f**2*fd*r + 22176*C*D1*Dd*f**2*fd*s**2 - 16216*C*D1*Dd*f**2*fd*s + 2832*C*D1*Dd*f**2*fd + 1312*C*D1*Ddd*f**3*r*s - 328*C*D1*Ddd*f**3*r + 3696*C*D1*Ddd*f**3*s**2 - 2504*C*D1*Ddd*f**3*s + 924*C*D1*Ddd*f**3 + 3936*C*Dd**2*f**3*r*s - 984*C*Dd**2*f**3*r + 11088*C*Dd**2*f**3*s**2 - 7512*C*Dd**2*f**3*s + 656*C*Dd**2*f**3 - 176*D1**2*K*bd1**2*f*r*s - 44*D1**2*K*bd1**2*f*r - 352*D1**2*K*bd1**2*f*s**2 + 176*D1**2*K*bd1**2*f*s + 44*D1**2*K*bd1**2*f + 396*D1**2*K*bd1*f**2*r*s - 132*D1**2*K*bd1*f**2*s**2 - 396*D1**2*K*bd1*f**2*s + 528*D1**2*K*bd1*f*fd*r*s - 132*D1**2*K*bd1*f*fd*r + 1848*D1**2*K*bd1*f*fd*s**2 - 1188*D1**2*K*bd1*f*fd*s + 132*D1**2*K*bd1*f*fd + 132*D1**2*K*bdd1*f**2*r*s + 462*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s - 792*D1**2*bd1**2*f**2*r*s + 396*D1**2*bd1**2*f**2*r - 462*D1**2*bd1**2*f**2*s**2 + 858*D1**2*bd1**2*f**2*s - 396*D1**2*bd1**2*f**2 + 616*D1**2*bd1**2*f*r*s - 308*D1**2*bd1**2*f*r + 902*D1**2*bd1**2*f*s**2 - 1078*D1**2*bd1**2*f*s + 176*D1**2*bd1**2*f - 2464*D1**2*bd1**2*g2*r*s + 1232*D1**2*bd1**2*g2*r - 2464*D1**2*bd1**2*g2*s**2 + 2464*D1**2*bd1**2*g2*s + 792*D1**2*bd1*bd2*f*r*s - 396*D1**2*bd1*bd2*f*r + 792*D1**2*bd1*bd2*f*s**2 - 1188*D1**2*bd1*bd2*f*s + 396*D1**2*bd1*bd2*f + 1056*D1**2*bd1*f**2*r*s - 1276*D1**2*bd1*f**2*r + 1474*D1**2*bd1*f**2*s**2 - 2992*D1**2*bd1*f**2*s + 1562*D1**2*bd1*f**2 - 3168*D1**2*bd1*f*fd*r*s + 1716*D1**2*bd1*f*fd*r - 3300*D1**2*bd1*f*fd*s**2 + 4356*D1**2*bd1*f*fd*s - 924*D1**2*bd1*f*fd + 264*D1**2*bd1*f*g2*r*s - 2640*D1**2*bd1*f*g2*r + 528*D1**2*bd1*f*g2*s**2 - 5808*D1**2*bd1*f*g2*s + 2904*D1**2*bd1*f*g2 + 352*D1**2*bd1*f*gd2*r*s + 88*D1**2*bd1*f*gd2*r + 704*D1**2*bd1*f*gd2*s**2 - 352*D1**2*bd1*f*gd2*s - 88*D1**2*bd1*f*gd2 + 352*D1**2*bd1*fd*g2*r*s - 176*D1**2*bd1*fd*g2*r + 704*D1**2*bd1*fd*g2*s**2 - 704*D1**2*bd1*fd*g2*s + 264*D1**2*bd2*f**2*r*s + 264*D1**2*bd2*f**2*s**2 - 264*D1**2*bd2*f**2*s - 792*D1**2*bdd1*f**2*r*s + 924*D1**2*bdd1*f**2*r - 825*D1**2*bdd1*f**2*s**2 + 1914*D1**2*bdd1*f**2*s - 957*D1**2*bdd1*f**2 + 176*D1**2*bdd1*f*g2*r*s + 88*D1**2*bdd1*f*g2*r + 352*D1**2*bdd1*f*g2*s**2 - 176*D1**2*bdd1*f*g2*s + 88*D1**2*bdd1*f*g2 - 1656*D1**2*f**2*fd*r*s + 552*D1**2*f**2*fd*r + 396*D1**2*f**2*fd*s**2 + 288*D1**2*f**2*fd*s + 132*D1**2*f**2*fd - 492*D1**2*f**2*fdd*r*s + 164*D1**2*f**2*fdd*r - 1386*D1**2*f**2*fdd*s**2 + 1088*D1**2*f**2*fdd*s - 462*D1**2*f**2*fdd - 792*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*s**2 + 792*D1**2*f**2*gd2*s - 264*D1**2*f**2*gdd2*r*s - 924*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 984*D1**2*f*fd**2*r*s + 328*D1**2*f*fd**2*r - 2772*D1**2*f*fd**2*s**2 + 2176*D1**2*f*fd**2*s - 164*D1**2*f*fd**2 - 1584*D1**2*f*fd*g2*r*s + 792*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r*s + 264*D1**2*f*fd*gd2*r - 3696*D1**2*f*fd*gd2*s**2 + 2376*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 1848*D1**2*f*fdd*g2*s**2 + 1848*D1**2*f*fdd*g2*s - 924*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 1848*D1**2*fd**2*g2*s**2 + 1848*D1**2*fd**2*g2*s + 1056*D1*Dd*K*bd1*f**2*r*s - 132*D1*Dd*K*bd1*f**2*r + 3696*D1*Dd*K*bd1*f**2*s**2 - 1716*D1*Dd*K*bd1*f**2*s + 132*D1*Dd*K*bd1*f**2 - 6336*D1*Dd*bd1*f**2*r*s + 4488*D1*Dd*bd1*f**2*r - 6600*D1*Dd*bd1*f**2*s**2 + 10890*D1*Dd*bd1*f**2*s - 3762*D1*Dd*bd1*f**2 + 1408*D1*Dd*bd1*f*g2*r*s + 176*D1*Dd*bd1*f*g2*r + 2816*D1*Dd*bd1*f*g2*s**2 - 1760*D1*Dd*bd1*f*g2*s - 2208*D1*Dd*f**3*r*s + 552*D1*Dd*f**3*r + 528*D1*Dd*f**3*s**2 + 840*D1*Dd*f**3*s + 132*D1*Dd*f**3 - 3936*D1*Dd*f**2*fd*r*s + 1148*D1*Dd*f**2*fd*r - 11088*D1*Dd*f**2*fd*s**2 + 8108*D1*Dd*f**2*fd*s - 1416*D1*Dd*f**2*fd - 3168*D1*Dd*f**2*g2*r*s + 792*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s + 264*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r*s + 264*D1*Dd*f**2*gd2*r - 7392*D1*Dd*f**2*gd2*s**2 + 3432*D1*Dd*f**2*gd2*s - 264*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r*s + 1584*D1*Dd*f*fd*g2*r - 14784*D1*Dd*f*fd*g2*s**2 + 12144*D1*Dd*f*fd*g2*s - 2376*D1*Dd*f*fd*g2 - 656*D1*Ddd*f**3*r*s + 164*D1*Ddd*f**3*r - 1848*D1*Ddd*f**3*s**2 + 1252*D1*Ddd*f**3*s - 462*D1*Ddd*f**3 - 1056*D1*Ddd*f**2*g2*r*s + 264*D1*Ddd*f**2*g2*r - 3696*D1*Ddd*f**2*g2*s**2 + 2376*D1*Ddd*f**2*g2*s - 924*D1*Ddd*f**2*g2 - 44*D1*b2*(bd1*(D1*(25*f*(s - 1)*(r + s - 1) + 9*fd*(-2*r*s + r - s*(2*s - 2))) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + 2*D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) - 1968*Dd**2*f**3*r*s + 492*Dd**2*f**3*r - 5544*Dd**2*f**3*s**2 + 3756*Dd**2*f**3*s - 328*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r*s + 792*Dd**2*f**2*g2*r - 11088*Dd**2*f**2*g2*s**2 + 7128*Dd**2*f**2*g2*s - 528*Dd**2*f**2*g2 - 44*b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + (28*K - 14)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(14*K + 3*f - 7) - Dd**2*(14*K + 3*f - 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 11*b1**2*(-32*C*D1**2*fd*r*s - 32*C*D1**2*fd*s**2 + 32*C*D1**2*fd*s + 16*C*D1**2*fdd*r*s + 16*C*D1**2*fdd*s**2 - 16*C*D1**2*fdd*s - 128*C*D1*Dd*f*r*s + 32*C*D1*Dd*f*r - 128*C*D1*Dd*f*s**2 + 128*C*D1*Dd*f*s - 32*C*D1*Dd*f + 128*C*D1*Dd*fd*r*s - 16*C*D1*Dd*fd*r + 128*C*D1*Dd*fd*s**2 - 128*C*D1*Dd*fd*s + 16*C*D1*Dd*fd + 64*C*D1*Ddd*f*r*s - 16*C*D1*Ddd*f*r + 64*C*D1*Ddd*f*s**2 - 64*C*D1*Ddd*f*s + 16*C*D1*Ddd*f + 192*C*Dd**2*f*r*s - 48*C*Dd**2*f*r + 192*C*Dd**2*f*s**2 - 192*C*Dd**2*f*s + 32*C*Dd**2*f + 12*D1**2*K*fd*r*s + 108*D1**2*K*fd*r + 24*D1**2*K*fd*s**2 + 216*D1**2*K*fd*s - 108*D1**2*K*fd + 8*D1**2*K*fdd*r*s - 12*D1**2*K*fdd*r + 16*D1**2*K*fdd*s**2 - 24*D1**2*K*fdd*s + 12*D1**2*K*fdd - 4*D1**2*bdd1*(14*K + 3*f - 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 72*D1**2*f*fd*r*s + 12*D1**2*f*fd*r - 36*D1**2*f*fd*s**2 + 60*D1**2*f*fd*s - 12*D1**2*f*fd + 72*D1**2*f*fdd*r*s + 42*D1**2*f*fdd*s**2 - 36*D1**2*f*fdd*s + 72*D1**2*fd**2*r*s + 42*D1**2*fd**2*s**2 - 36*D1**2*fd**2*s - 28*D1**2*fd*r + 26*D1**2*fd*s**2 - 80*D1**2*fd*s + 28*D1**2*fd - 28*D1**2*fdd*r*s - 41*D1**2*fdd*s**2 + 12*D1**2*fdd*s - 224*D1**2*gd2*r*s - 224*D1**2*gd2*s**2 + 224*D1**2*gd2*s + 112*D1**2*gdd2*r*s + 112*D1**2*gdd2*s**2 - 112*D1**2*gdd2*s + 48*D1*Dd*K*f*r*s - 12*D1*Dd*K*f*r + 96*D1*Dd*K*f*s**2 - 72*D1*Dd*K*f*s + 24*D1*Dd*K*f + 64*D1*Dd*K*fd*r*s - 56*D1*Dd*K*fd*r + 128*D1*Dd*K*fd*s**2 - 144*D1*Dd*K*fd*s + 48*D1*Dd*K*fd - 144*D1*Dd*f**2*r*s + 36*D1*Dd*f**2*r - 72*D1*Dd*f**2*s**2 + 108*D1*Dd*f**2*s - 18*D1*Dd*f**2 + 576*D1*Dd*f*fd*r*s - 72*D1*Dd*f*fd*r + 336*D1*Dd*f*fd*s**2 - 372*D1*Dd*f*fd*s + 36*D1*Dd*f*fd + 104*D1*Dd*f*s**2 - 52*D1*Dd*f*s + 26*D1*Dd*f - 224*D1*Dd*fd*r*s + 28*D1*Dd*fd*r - 328*D1*Dd*fd*s**2 + 186*D1*Dd*fd*s - 12*D1*Dd*fd - 896*D1*Dd*g2*r*s + 224*D1*Dd*g2*r - 896*D1*Dd*g2*s**2 + 896*D1*Dd*g2*s - 224*D1*Dd*g2 + 896*D1*Dd*gd2*r*s - 112*D1*Dd*gd2*r + 896*D1*Dd*gd2*s**2 - 896*D1*Dd*gd2*s + 112*D1*Dd*gd2 + 32*D1*Ddd*K*f*r*s - 8*D1*Ddd*K*f*r + 64*D1*Ddd*K*f*s**2 - 48*D1*Ddd*K*f*s + 16*D1*Ddd*K*f + 144*D1*Ddd*f**2*r*s - 36*D1*Ddd*f**2*r + 84*D1*Ddd*f**2*s**2 - 114*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 - 112*D1*Ddd*f*r*s + 28*D1*Ddd*f*r - 164*D1*Ddd*f*s**2 + 138*D1*Ddd*f*s - 41*D1*Ddd*f + 448*D1*Ddd*g2*r*s - 112*D1*Ddd*g2*r + 448*D1*Ddd*g2*s**2 - 448*D1*Ddd*g2*s + 112*D1*Ddd*g2 + 4*D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + (28*K - 14)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(14*K + 3*f - 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 96*Dd**2*K*f*r*s - 24*Dd**2*K*f*r + 192*Dd**2*K*f*s**2 - 144*Dd**2*K*f*s + 16*Dd**2*K*f + 432*Dd**2*f**2*r*s - 108*Dd**2*f**2*r + 252*Dd**2*f**2*s**2 - 342*Dd**2*f**2*s + 72*Dd**2*f**2 - 336*Dd**2*f*r*s + 84*Dd**2*f*r - 492*Dd**2*f*s**2 + 414*Dd**2*f*s - 56*Dd**2*f + 1344*Dd**2*g2*r*s - 336*Dd**2*g2*r + 1344*Dd**2*g2*s**2 - 1344*Dd**2*g2*s + 224*Dd**2*g2) + 11*b1*(-368*C*D1**2*f*fd*r*s - 24*C*D1**2*f*fd*r - 480*C*D1**2*f*fd*s**2 + 136*C*D1**2*f*fd*s + 24*C*D1**2*f*fd + 224*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*r + 256*C*D1**2*f*fdd*s**2 - 64*C*D1**2*f*fdd*s - 24*C*D1**2*f*fdd + 224*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*r + 256*C*D1**2*fd**2*s**2 - 64*C*D1**2*fd**2*s - 24*C*D1**2*fd**2 - 736*C*D1*Dd*f**2*r*s + 184*C*D1*Dd*f**2*r - 960*C*D1*Dd*f**2*s**2 + 848*C*D1*Dd*f**2*s - 240*C*D1*Dd*f**2 + 1792*C*D1*Dd*f*fd*r*s - 128*C*D1*Dd*f*fd*r + 2048*C*D1*Dd*f*fd*s**2 - 1216*C*D1*Dd*f*fd*s + 16*C*D1*Dd*f*fd + 448*C*D1*Ddd*f**2*r*s - 112*C*D1*Ddd*f**2*r + 512*C*D1*Ddd*f**2*s**2 - 480*C*D1*Ddd*f**2*s + 128*C*D1*Ddd*f**2 + 1344*C*Dd**2*f**2*r*s - 336*C*Dd**2*f**2*r + 1536*C*Dd**2*f**2*s**2 - 1440*C*Dd**2*f**2*s + 224*C*Dd**2*f**2 + 72*D1**2*K*f*fd*r*s - 36*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 24*D1**2*K*f*fdd*r*s - 12*D1**2*K*f*fdd*r + 84*D1**2*K*f*fdd*s**2 - 84*D1**2*K*f*fdd*s + 42*D1**2*K*f*fdd + 24*D1**2*K*fd**2*r*s - 12*D1**2*K*fd**2*r + 84*D1**2*K*fd**2*s**2 - 84*D1**2*K*fd**2*s - 100*D1**2*b2*fd*r*s - 100*D1**2*b2*fd*s**2 + 36*D1**2*b2*fdd*r*s + 36*D1**2*b2*fdd*s**2 + 4*D1**2*bd1**2*(14*K + 3*f - 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 100*D1**2*bd2*f*r*s - 100*D1**2*bd2*f*s**2 + 100*D1**2*bd2*f*s + 72*D1**2*bd2*fd*r*s + 72*D1**2*bd2*fd*s**2 - 36*D1**2*bd2*fd*s - D1**2*bdd1*(3*f**2*(12*r*(2*s - 1) + 14*s**2 - 26*s + 7) + f*(16*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 4*K*(4*r*s + r + 8*s**2 - 4*s + 1) - 56*r*s + 28*r - 82*s**2 + 98*s - 41) + 112*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 36*D1**2*bdd2*f*r*s + 36*D1**2*bdd2*f*s**2 - 36*D1**2*bdd2*f*s + 192*D1**2*f*fd*r*s + 20*D1**2*f*fd*r + 268*D1**2*f*fd*s**2 - 92*D1**2*f*fd*s - 8*D1**2*f*fd - 144*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r - 150*D1**2*f*fdd*s**2 + 48*D1**2*f*fdd*s + 12*D1**2*f*fdd + 24*D1**2*f*gd2*r*s + 48*D1**2*f*gd2*s**2 - 24*D1**2*f*gd2*s + 16*D1**2*f*gdd2*r*s + 32*D1**2*f*gdd2*s**2 - 16*D1**2*f*gdd2*s - 144*D1**2*fd**2*r*s - 12*D1**2*fd**2*r - 150*D1**2*fd**2*s**2 + 48*D1**2*fd**2*s + 12*D1**2*fd**2 + 24*D1**2*fd*g2*r*s + 216*D1**2*fd*g2*r + 48*D1**2*fd*g2*s**2 + 432*D1**2*fd*g2*s - 216*D1**2*fd*g2 + 32*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*r + 64*D1**2*fd*gd2*s**2 - 64*D1**2*fd*gd2*s + 24*D1**2*fd*gd2 + 16*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*r + 32*D1**2*fdd*g2*s**2 - 48*D1**2*fdd*g2*s + 24*D1**2*fdd*g2 + 144*D1*Dd*K*f**2*r*s - 36*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 - 48*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 192*D1*Dd*K*f*fd*r*s - 72*D1*Dd*K*f*fd*r + 672*D1*Dd*K*f*fd*s**2 - 552*D1*Dd*K*f*fd*s + 108*D1*Dd*K*f*fd - 400*D1*Dd*b2*f*r*s + 100*D1*Dd*b2*f*r - 400*D1*Dd*b2*f*s**2 + 400*D1*Dd*b2*f*s - 100*D1*Dd*b2*f + 288*D1*Dd*b2*fd*r*s - 36*D1*Dd*b2*fd*r + 288*D1*Dd*b2*fd*s**2 - 144*D1*Dd*b2*fd*s + 288*D1*Dd*bd2*f*r*s - 36*D1*Dd*bd2*f*r + 288*D1*Dd*bd2*f*s**2 - 288*D1*Dd*bd2*f*s + 36*D1*Dd*bd2*f + 384*D1*Dd*f**2*r*s - 96*D1*Dd*f**2*r + 536*D1*Dd*f**2*s**2 - 460*D1*Dd*f**2*s + 134*D1*Dd*f**2 - 1152*D1*Dd*f*fd*r*s + 96*D1*Dd*f*fd*r - 1200*D1*Dd*f*fd*s**2 + 780*D1*Dd*f*fd*s - 24*D1*Dd*f*fd + 96*D1*Dd*f*g2*r*s - 24*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 144*D1*Dd*f*g2*s + 48*D1*Dd*f*g2 + 128*D1*Dd*f*gd2*r*s - 16*D1*Dd*f*gd2*r + 256*D1*Dd*f*gd2*s**2 - 160*D1*Dd*f*gd2*s + 16*D1*Dd*f*gd2 + 128*D1*Dd*fd*g2*r*s - 112*D1*Dd*fd*g2*r + 256*D1*Dd*fd*g2*s**2 - 288*D1*Dd*fd*g2*s + 96*D1*Dd*fd*g2 + 48*D1*Ddd*K*f**2*r*s - 12*D1*Ddd*K*f**2*r + 168*D1*Ddd*K*f**2*s**2 - 108*D1*Ddd*K*f**2*s + 42*D1*Ddd*K*f**2 + 144*D1*Ddd*b2*f*r*s - 36*D1*Ddd*b2*f*r + 144*D1*Ddd*b2*f*s**2 - 144*D1*Ddd*b2*f*s + 36*D1*Ddd*b2*f - 288*D1*Ddd*f**2*r*s + 72*D1*Ddd*f**2*r - 300*D1*Ddd*f**2*s**2 + 294*D1*Ddd*f**2*s - 75*D1*Ddd*f**2 + 64*D1*Ddd*f*g2*r*s - 16*D1*Ddd*f*g2*r + 128*D1*Ddd*f*g2*s**2 - 96*D1*Ddd*f*g2*s + 32*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(3*f**2*(4*r*(3*s - 1) + 6*s**2 - 8*s + 1) + f*(16*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 12*K*r*s + 60*K*r - 24*K*s**2 + 138*K*s - 66*K - 6*fd*(24*r*s - 6*r + 14*s**2 - 19*s + 3) - 14*r - 26*s**2 - 14*s + 1) + fd*(-8*C*(r*(4*s - 1) + (1 - 2*s)**2) - 2*K*(8*r*s - 5*r + 16*s**2 - 16*s + 3) + 56*r*s - 14*r + 82*s**2 - 61*s + 6) + 56*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 56*gd2*(-4*r*s + r - (1 - 2*s)**2)) - Dd*(3*f**2*(12*r*(8*s - 3) + 56*s**2 - 90*s + 25) + f*(16*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 4*K*(32*s**2 + s*(16*r - 20) + 1) - 224*r*s + 84*r - 328*s**2 + 334*s - 77) + 112*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 144*Dd**2*K*f**2*r*s - 36*Dd**2*K*f**2*r + 504*Dd**2*K*f**2*s**2 - 324*Dd**2*K*f**2*s + 24*Dd**2*K*f**2 + 432*Dd**2*b2*f*r*s - 108*Dd**2*b2*f*r + 432*Dd**2*b2*f*s**2 - 432*Dd**2*b2*f*s + 72*Dd**2*b2*f - 864*Dd**2*f**2*r*s + 216*Dd**2*f**2*r - 900*Dd**2*f**2*s**2 + 882*Dd**2*f**2*s - 144*Dd**2*f**2 + 192*Dd**2*f*g2*r*s - 48*Dd**2*f*g2*r + 384*Dd**2*f*g2*s**2 - 288*Dd**2*f*g2*s + 32*Dd**2*f*g2))/(462*d**2*k3**4) + 2*D1**2*Pk3*Pkd2*ct*k1*k2**2*(2*D1*(14*D1*b2*bd1*f*(s - 1)*(r + s - 1) + D1*bd1**2*(7*K*f*(r*(2*s - 1) + 3*s**2 - 4*s + 1) - f*(12*C - 6)*(r*(2*s - 1) + s*(2*s - 2)) + 14*g2*r*(2*s - 1) + 28*g2*s*(s - 1)) + D1*bdd1*f*(s - 1)*(f*(2*C - 1)*(7*r + 9*s - 9) - 7*g2*(2*r + 3*s - 3)) + bd1*(D1*(2*f**2*(s - 1)*(2*C*(8*r + 9*s - 9) - 11*r - 9*s + 9) + f*(fd*(2*C - 1)*(14*r*(2*s - 1) + 36*s**2 - 43*s + 7) - 42*g2*(s - 1)*(r + s - 1) - 14*gd2*(2*r*s - r + 3*s**2 - 4*s + 1)) + 14*fd*g2*(-2*r*s + r - s*(3*s - 3))) + Dd*f*(f*(2*C - 1)*(7*r*(8*s - 5) + 72*s**2 - 104*s + 32) - 14*g2*(r*(8*s - 5) + 12*s**2 - 17*s + 5)))) + 14*b1**3*(D1**2*fd*s*(r + s - 1) + D1*(Dd*(2*K + f) - Ddd*K)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*K*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(D1**2*(-14*K*bdd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(fd*(-36*C*(r + s - 1) + 42*K*s + r*(42*K + 18) + 32*s - 32) + fdd*(-24*C*(r + s - 1) + 21*K*s + r*(14*K + 12) + 12*s - 12) + (-56*gd2 + 28*gdd2)*(r + s - 1))) + 14*D1*bd1*(D1*(2*K + f)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*K*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) + D1*(-2*Dd*(f*(18*C*(r*(4*s - 1) + (1 - 2*s)**2) - 21*K*(r*(4*s - 1) + (1 - 2*s)**2) - 36*r*s + 9*r - 64*s**2 + 50*s - 16) + fd*(12*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 84*K*s**2 + 35*K*s - r*(7*K + 6)*(8*s - 1) - 48*s**2 + 48*s - 6) + 14*g2*r*(8*s - 2) + 28*g2*(1 - 2*s)**2 + 14*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + Ddd*(f*(-24*C*(r*(4*s - 1) + (1 - 2*s)**2) + 7*K*(r*(8*s - 2) + 12*s**2 - 10*s + 3) + 12*r*(4*s - 1) + 12*(1 - 2*s)**2) + 28*g2*(r*(4*s - 1) + (1 - 2*s)**2))) + 2*Dd**2*(f*(-12*C*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 7*K*(12*r*s - 3*r + 18*s**2 - 15*s + 2) + 72*r*s - 18*r + 72*s**2 - 72*s + 12) + 14*g2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))) - b1*(14*D1**2*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 7*K*(4*r*s - 2*r + 6*s**2 - 8*s + 3) - 24*r*s + 12*r - 24*s**2 + 24*s - 12) - 28*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 2*D1**2*s*(28*C*fd**2*r + 36*C*fd**2*s - 14*C*fd**2 + 14*bd2*f*(r + s - 1) + f*(fd*(8*C*(8*r + 9*s - 4) - 44*r - 36*s + 22) + fdd*(2*C - 1)*(14*r + 18*s - 7) - 42*gd2*(r + s - 1) - 7*gdd2*(2*r + 3*s - 2)) - 14*fd**2*r - 18*fd**2*s + 7*fd**2 - 42*fd*g2*r - 42*fd*g2*s - 28*fd*gd2*r - 42*fd*gd2*s + 14*fd*gd2 - 14*fdd*g2*r - 21*fdd*g2*s) - 28*D1*b2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*D1*bd1*(D1*f*(18*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 21*K*(2*s - 1)*(r + s - 1) - 18*r*s + 9*r - 32*s**2 + 25*s - 16) + D1*fd*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) - 42*K*s**2 + 28*K*s - r*(7*K + 6)*(4*s - 1) - 24*s**2 + 24*s - 6) + 14*D1*(g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*f*(12*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 7*K*(8*r*s - 3*r + 12*s**2 - 13*s + 3) - 48*r*s + 18*r - 48*s**2 + 48*s - 12) - 28*Dd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 2*D1*(Dd*(2*f**2*(2*C*(32*r*s - 8*r + 36*s**2 - 34*s + 9) - 44*r*s + 11*r - 36*s**2 + 40*s - 9) + f*(fd*(2*C - 1)*(14*r*(8*s - 1) + 144*s**2 - 92*s + 7) - 42*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 14*gd2*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) - 14*fd*g2*(r*(8*s - 1) + s*(12*s - 5))) + Ddd*f*(f*(2*C - 1)*(28*r*s - 7*r + 36*s**2 - 32*s + 9) - 7*g2*(8*r*s - 2*r + 12*s**2 - 10*s + 3))) - 2*Dd**2*f*(f*(2*C - 1)*(84*r*s - 21*r + 108*s**2 - 96*s + 14) - 14*g2*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2))))/(21*d**2*k3**4) - 5*D1**2*Pk3*Pkd2*ct*k1*st**6*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) - f*(2*fd*(s**2*(21*bd1 - 3) + s*(2 - 7*bd1) - 1) + fdd*(3*s**2 - 2*s + 1) + s**2*(-66*bd1 + 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) - D1*f*(2*Dd*(f*(s**2*(28*bd1 - 4) + s*(2 - 7*bd1) - 1) + (4*s - 1)*(33*bd1*s + fd*(3*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(154*d**2*k3**2) + D1**2*Pk3*Pkd2*ct*k1*st**4*(66*D1**2*bd1**2*f*s*(K*(-4*r + 10*s + 2) + 4*r - 7) + 66*D1*bd1*(D1*(f**2*s*(2*r + 7*s - 2) - f*(fd*(8*r*s - 2*r + 18*s**2 - 13*s + 2) + 4*s*(2*g2*r - 5*g2*s - 2*gd2*r + 5*gd2*s + gd2)) - 4*fd*g2*(-2*r*s + r + s*(5*s - 5))) + Dd*f*(f*(r*(2 - 16*s) - 36*s**2 + 21*s - 2) - 4*g2*(-8*r*s + r + s*(20*s - 3)))) - 33*b1**2*(2*D1*Dd*(-2*f*(K*(8*r*s - 2*r - 20*s**2 + 6*s - 5) - 8*r*s + 2*r + 4*s) + fd*(2*K*(8*r*s - 5*r - 20*s**2 + 23*s - 3) - 16*r*s + 10*r - 16*s + 1)) + D1*(-D1*(2*fd - fdd)*(2*K*(s - 1)*(2*r - 5*s + 5) - 4*r*(s - 1) - 10*s + 5) + 2*Ddd*f*(K*(r*(8*s - 2) - 20*s**2 + 6*s - 5) + r*(2 - 8*s) + 4*s)) + 4*Dd**2*f*(K*(3*r*(4*s - 1) - 30*s**2 + 9*s + 2) + r*(3 - 12*s) + 6*s - 2)) + 33*b1*(D1**2*bdd1*f*(20*K*s**2 + s*(-8*K*r + 4*K + 8*r - 14) + 5) + 8*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 28*D1**2*f*fd*s**2 - 28*D1**2*f*fd*s + 14*D1**2*f*fd - 8*D1**2*f*fdd*r*s + 4*D1**2*f*fdd*r - 18*D1**2*f*fdd*s**2 + 18*D1**2*f*fdd*s - 9*D1**2*f*fdd - 16*D1**2*f*gd2*r*s + 40*D1**2*f*gd2*s**2 + 16*D1**2*f*gd2*s + 8*D1**2*f*gdd2*r*s - 20*D1**2*f*gdd2*s**2 - 8*D1**2*f*gdd2*s - 8*D1**2*fd**2*r*s + 4*D1**2*fd**2*r - 18*D1**2*fd**2*s**2 + 18*D1**2*fd**2*s - 16*D1**2*fd*g2*r*s + 16*D1**2*fd*g2*r + 40*D1**2*fd*g2*s**2 - 80*D1**2*fd*g2*s + 40*D1**2*fd*g2 + 16*D1**2*fd*gd2*r*s - 8*D1**2*fd*gd2*r - 40*D1**2*fd*gd2*s**2 + 32*D1**2*fd*gd2*s + 8*D1**2*fd*gd2 + 8*D1**2*fdd*g2*r*s - 8*D1**2*fdd*g2*r - 20*D1**2*fdd*g2*s**2 + 40*D1**2*fdd*g2*s - 20*D1**2*fdd*g2 + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r + 56*D1*Dd*f**2*s**2 - 36*D1*Dd*f**2*s + 14*D1*Dd*f**2 - 64*D1*Dd*f*fd*r*s + 24*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 124*D1*Dd*f*fd*s - 26*D1*Dd*f*fd - 64*D1*Dd*f*g2*r*s + 16*D1*Dd*f*g2*r + 160*D1*Dd*f*g2*s**2 - 48*D1*Dd*f*g2*s + 40*D1*Dd*f*g2 + 64*D1*Dd*f*gd2*r*s - 8*D1*Dd*f*gd2*r - 160*D1*Dd*f*gd2*s**2 - 8*D1*Dd*f*gd2*s + 8*D1*Dd*f*gd2 + 64*D1*Dd*fd*g2*r*s - 40*D1*Dd*fd*g2*r - 160*D1*Dd*fd*g2*s**2 + 184*D1*Dd*fd*g2*s - 24*D1*Dd*fd*g2 - 16*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 26*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 32*D1*Ddd*f*g2*r*s - 8*D1*Ddd*f*g2*r - 80*D1*Ddd*f*g2*s**2 + 24*D1*Ddd*f*g2*s - 20*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(-f*(20*K*s**2 + s*(-8*K*r + 4*K + 8*r - 14) + 5) + fd*(-2*K*(4*r*s - 2*r - 10*s**2 + 9*s + 1) + 8*r*s - 4*r + 3*s + 2)) + Dd*f*(K*(-32*r*s + 4*r + 80*s**2 - 4*s - 2) + 32*r*s - 4*r - 36*s + 7)) - 48*Dd**2*f**2*r*s + 12*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 78*Dd**2*f**2*s - 8*Dd**2*f**2 + 96*Dd**2*f*g2*r*s - 24*Dd**2*f*g2*r - 240*Dd**2*f*g2*s**2 + 72*Dd**2*f*g2*s + 16*Dd**2*f*g2) + f*(D1**2*(-33*bdd1*f*s*(4*r + 9*s - 4) + 132*bdd1*g2*s*(2*r - 5*s) - 8*f*fd*(25*C*(3*s**2 - 2*s + 1) + r*(9*s - 3) - 30*s**2 + 17*s - 10) + 4*f*fdd*(25*C*(3*s**2 - 2*s + 1) + r*(9*s - 3) - 30*s**2 + 17*s - 10) + 4*fd**2*(6*r*(3*s - 1) + s**2*(150*C - 60) + s*(34 - 100*C) + 3)) - 4*D1*f*(Dd*(2*f*(25*C*(4*s**2 - 2*s + 1) + 12*r*s - 3*r - 40*s**2 + 14*s - 10) + fd*(-50*C*(12*s**2 - 7*s + 1) - 72*r*s + 21*r + 240*s**2 - 110*s + 11)) + Ddd*f*(-25*C*(4*s**2 - 2*s + 1) - 12*r*s + 3*r + 40*s**2 - 14*s + 10)) + 12*Dd**2*f**2*(3*r*(4*s - 1) + s**2*(100*C - 40) + s*(14 - 50*C) + 2)))/(231*d**2*k3**2) + D1**2*Pk3*Pkd2*ct*k1*st**2*(176*C*D1**2*bd1**2*f*r*s - 88*C*D1**2*bd1**2*f*r - 88*C*D1**2*bd1**2*f*s**2 + 88*C*D1**2*bd1**2*f*s + 88*C*D1**2*bd1*f**2*r*s - 1056*C*D1**2*bd1*f**2*s**2 + 528*C*D1**2*bd1*f**2*s - 264*C*D1**2*bd1*f**2 + 2464*C*D1**2*bd1*f*fd*s**2 - 1496*C*D1**2*bd1*f*fd*s + 616*C*D1**2*bdd1*f**2*s**2 - 264*C*D1**2*bdd1*f**2*s + 132*C*D1**2*bdd1*f**2 + 648*C*D1**2*f**2*fd*r*s - 216*C*D1**2*f**2*fd*r + 3960*C*D1**2*f**2*fd*s**2 - 2856*C*D1**2*f**2*fd*s + 1320*C*D1**2*f**2*fd - 984*C*D1**2*f**2*fdd*r*s + 328*C*D1**2*f**2*fdd*r - 2772*C*D1**2*f**2*fdd*s**2 + 2176*C*D1**2*f**2*fdd*s - 924*C*D1**2*f**2*fdd - 1968*C*D1**2*f*fd**2*r*s + 656*C*D1**2*f*fd**2*r - 5544*C*D1**2*f*fd**2*s**2 + 4352*C*D1**2*f*fd**2*s - 328*C*D1**2*f*fd**2 + 4928*C*D1*Dd*bd1*f**2*s**2 - 2288*C*D1*Dd*bd1*f**2*s + 264*C*D1*Dd*bd1*f**2 + 864*C*D1*Dd*f**3*r*s - 216*C*D1*Dd*f**3*r + 5280*C*D1*Dd*f**3*s**2 - 3072*C*D1*Dd*f**3*s + 1320*C*D1*Dd*f**3 - 7872*C*D1*Dd*f**2*fd*r*s + 2296*C*D1*Dd*f**2*fd*r - 22176*C*D1*Dd*f**2*fd*s**2 + 16216*C*D1*Dd*f**2*fd*s - 2832*C*D1*Dd*f**2*fd - 1312*C*D1*Ddd*f**3*r*s + 328*C*D1*Ddd*f**3*r - 3696*C*D1*Ddd*f**3*s**2 + 2504*C*D1*Ddd*f**3*s - 924*C*D1*Ddd*f**3 - 3936*C*Dd**2*f**3*r*s + 984*C*Dd**2*f**3*r - 11088*C*Dd**2*f**3*s**2 + 7512*C*Dd**2*f**3*s - 656*C*Dd**2*f**3 - 1144*D1**2*K*bd1**2*f*s**2 - 132*D1**2*K*bd1**2*f*s + 132*D1**2*K*bd1*f**2*r*s + 660*D1**2*K*bd1*f**2*s**2 - 132*D1**2*K*bd1*f**2*s - 528*D1**2*K*bd1*f*fd*r*s + 132*D1**2*K*bd1*f*fd*r - 1848*D1**2*K*bd1*f*fd*s**2 + 1188*D1**2*K*bd1*f*fd*s - 132*D1**2*K*bd1*f*fd - 132*D1**2*K*bdd1*f**2*r*s - 462*D1**2*K*bdd1*f**2*s**2 + 132*D1**2*K*bdd1*f**2*s + 528*D1**2*bd1**2*f**2*r*s - 396*D1**2*bd1**2*f**2*r - 594*D1**2*bd1**2*f**2*s + 264*D1**2*bd1**2*f**2 - 528*D1**2*bd1**2*f*r*s + 264*D1**2*bd1**2*f*r + 66*D1**2*bd1**2*f*s**2 + 748*D1**2*bd1**2*f*s - 176*D1**2*bd1**2*f + 1232*D1**2*bd1**2*g2*r*s - 616*D1**2*bd1**2*g2*r - 616*D1**2*bd1**2*g2*s**2 + 616*D1**2*bd1**2*g2*s + 132*D1**2*bd1*bd2*f*s**2 - 132*D1**2*bd1*bd2*f*s - 176*D1**2*bd1*f**2*r*s + 220*D1**2*bd1*f**2*r + 528*D1**2*bd1*f**2*s**2 - 66*D1**2*bd1*f**2 + 704*D1**2*bd1*f*fd*r*s - 352*D1**2*bd1*f*fd*r - 1232*D1**2*bd1*f*fd*s**2 + 330*D1**2*bd1*f*fd*s + 176*D1**2*bd1*f*fd + 616*D1**2*bd1*f*g2*r*s - 1056*D1**2*bd1*f*g2*s**2 - 528*D1**2*bd1*f*g2*s + 264*D1**2*bd1*f*g2 + 2288*D1**2*bd1*f*gd2*s**2 + 264*D1**2*bd1*f*gd2*s + 2288*D1**2*bd1*fd*g2*s**2 - 2288*D1**2*bd1*fd*g2*s + 132*D1**2*bd2*f**2*r*s + 660*D1**2*bd2*f**2*s**2 - 132*D1**2*bd2*f**2*s - 528*D1**2*bd2*f*fd*r*s + 132*D1**2*bd2*f*fd*r - 1848*D1**2*bd2*f*fd*s**2 + 1188*D1**2*bd2*f*fd*s - 132*D1**2*bd2*f*fd + 176*D1**2*bdd1*f**2*r*s - 176*D1**2*bdd1*f**2*r - 308*D1**2*bdd1*f**2*s**2 - 110*D1**2*bdd1*f**2*s + 55*D1**2*bdd1*f**2 + 1144*D1**2*bdd1*f*g2*s**2 + 264*D1**2*bdd1*f*g2*s - 132*D1**2*bdd1*f*g2 - 132*D1**2*bdd2*f**2*r*s - 462*D1**2*bdd2*f**2*s**2 + 132*D1**2*bdd2*f**2*s + 72*D1**2*f**2*fd*r*s - 24*D1**2*f**2*fd*r - 1980*D1**2*f**2*fd*s**2 + 1296*D1**2*f**2*fd*s - 660*D1**2*f**2*fd + 492*D1**2*f**2*fdd*r*s - 164*D1**2*f**2*fdd*r + 1386*D1**2*f**2*fdd*s**2 - 1088*D1**2*f**2*fdd*s + 462*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 1320*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 264*D1**2*f**2*gdd2*r*s + 924*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 984*D1**2*f*fd**2*r*s - 328*D1**2*f*fd**2*r + 2772*D1**2*f*fd**2*s**2 - 2176*D1**2*f*fd**2*s + 164*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 2640*D1**2*f*fd*g2*s**2 + 2640*D1**2*f*fd*g2*s - 1320*D1**2*f*fd*g2 + 1056*D1**2*f*fd*gd2*r*s - 264*D1**2*f*fd*gd2*r + 3696*D1**2*f*fd*gd2*s**2 - 2376*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 1848*D1**2*f*fdd*g2*s**2 - 1848*D1**2*f*fdd*g2*s + 924*D1**2*f*fdd*g2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 1848*D1**2*fd**2*g2*s**2 - 1848*D1**2*fd**2*g2*s - 1056*D1*Dd*K*bd1*f**2*r*s + 132*D1*Dd*K*bd1*f**2*r - 3696*D1*Dd*K*bd1*f**2*s**2 + 1716*D1*Dd*K*bd1*f**2*s - 132*D1*Dd*K*bd1*f**2 + 1408*D1*Dd*bd1*f**2*r*s - 880*D1*Dd*bd1*f**2*r - 2464*D1*Dd*bd1*f**2*s**2 - 176*D1*Dd*bd1*f**2*s + 462*D1*Dd*bd1*f**2 + 9152*D1*Dd*bd1*f*g2*s**2 - 1232*D1*Dd*bd1*f*g2*s - 264*D1*Dd*bd1*f*g2 - 1056*D1*Dd*bd2*f**2*r*s + 132*D1*Dd*bd2*f**2*r - 3696*D1*Dd*bd2*f**2*s**2 + 1716*D1*Dd*bd2*f**2*s - 132*D1*Dd*bd2*f**2 + 96*D1*Dd*f**3*r*s - 24*D1*Dd*f**3*r - 2640*D1*Dd*f**3*s**2 + 1272*D1*Dd*f**3*s - 660*D1*Dd*f**3 + 3936*D1*Dd*f**2*fd*r*s - 1148*D1*Dd*f**2*fd*r + 11088*D1*Dd*f**2*fd*s**2 - 8108*D1*Dd*f**2*fd*s + 1416*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 5280*D1*Dd*f**2*g2*s**2 + 3168*D1*Dd*f**2*g2*s - 1320*D1*Dd*f**2*g2 + 2112*D1*Dd*f**2*gd2*r*s - 264*D1*Dd*f**2*gd2*r + 7392*D1*Dd*f**2*gd2*s**2 - 3432*D1*Dd*f**2*gd2*s + 264*D1*Dd*f**2*gd2 + 4224*D1*Dd*f*fd*g2*r*s - 1584*D1*Dd*f*fd*g2*r + 14784*D1*Dd*f*fd*g2*s**2 - 12144*D1*Dd*f*fd*g2*s + 2376*D1*Dd*f*fd*g2 + 656*D1*Ddd*f**3*r*s - 164*D1*Ddd*f**3*r + 1848*D1*Ddd*f**3*s**2 - 1252*D1*Ddd*f**3*s + 462*D1*Ddd*f**3 + 1056*D1*Ddd*f**2*g2*r*s - 264*D1*Ddd*f**2*g2*r + 3696*D1*Ddd*f**2*g2*s**2 - 2376*D1*Ddd*f**2*g2*s + 924*D1*Ddd*f**2*g2 + 1968*Dd**2*f**3*r*s - 492*Dd**2*f**3*r + 5544*Dd**2*f**3*s**2 - 3756*Dd**2*f**3*s + 328*Dd**2*f**3 + 3168*Dd**2*f**2*g2*r*s - 792*Dd**2*f**2*g2*r + 11088*Dd**2*f**2*g2*s**2 - 7128*Dd**2*f**2*g2*s + 528*Dd**2*f**2*g2 - 11*b1**3*(3*D1**2*s**2*(2*fd - fdd) + D1*(2*Dd*(14*K*(r*(2 - 8*s) + 4*s**2 + 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s + 112*r*s - 28*r - 28*s**2 - 42*s - 7) + Ddd*(-14*K*(r*(2 - 8*s) + 4*s**2 + 2*s + 1) - 3*f*(4*s**2 - 2*s + 1) - 112*r*s + 28*r + 28*s**2 + 42*s + 7)) + 2*Dd**2*(14*K*(3*r*(4*s - 1) - 6*s**2 - 3*s + 2) - 18*f*s**2 + 9*f*s - 42*r*(4*s - 1) + 42*s**2 + 63*s - 28)) - 11*b1**2*(16*C*D1**2*fd*r*s - 8*C*D1**2*fd*s**2 - 16*C*D1**2*fd*s - 8*C*D1**2*fdd*r*s + 4*C*D1**2*fdd*s**2 + 8*C*D1**2*fdd*s + 64*C*D1*Dd*f*r*s - 16*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 - 16*C*D1*Dd*f*s - 8*C*D1*Dd*f - 64*C*D1*Dd*fd*r*s + 8*C*D1*Dd*fd*r + 32*C*D1*Dd*fd*s**2 + 40*C*D1*Dd*fd*s - 8*C*D1*Dd*fd - 32*C*D1*Ddd*f*r*s + 8*C*D1*Ddd*f*r + 16*C*D1*Ddd*f*s**2 + 8*C*D1*Ddd*f*s + 4*C*D1*Ddd*f - 96*C*Dd**2*f*r*s + 24*C*Dd**2*f*r + 48*C*Dd**2*f*s**2 + 24*C*Dd**2*f*s - 16*C*Dd**2*f + 28*D1**2*K*fd*r*s - 28*D1**2*K*fd*r - 48*D1**2*K*fd*s**2 + 120*D1**2*K*fd*s - 60*D1**2*K*fd + 52*D1**2*K*fdd*s**2 - 116*D1**2*K*fdd*s + 58*D1**2*K*fdd + D1**2*bdd1*(-14*K*(r*(2 - 6*s) + 3*s**2 + 1) + f*(-9*s**2 + 6*s - 3) - 84*r*s + 28*r + 21*s**2 + 14*s + 7) + 48*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 24*D1**2*f*fd*s - 30*D1**2*f*fd - 48*D1**2*f*fdd*r*s - 12*D1**2*f*fdd*r - 6*D1**2*f*fdd*s + 21*D1**2*f*fdd - 48*D1**2*fd**2*r*s - 12*D1**2*fd**2*r - 6*D1**2*fd**2*s + 12*D1**2*fd**2 - 48*D1**2*fd*r*s + 28*D1**2*fd*r + 6*D1**2*fd*s**2 - 44*D1**2*fd*s + 30*D1**2*fd + 24*D1**2*fdd*r*s - 3*D1**2*fdd*s**2 + 50*D1**2*fdd*s - 29*D1**2*fdd + 112*D1**2*gd2*r*s - 56*D1**2*gd2*s**2 - 112*D1**2*gd2*s - 56*D1**2*gdd2*r*s + 28*D1**2*gdd2*s**2 + 56*D1**2*gdd2*s + 112*D1*Dd*K*f*r*s - 28*D1*Dd*K*f*r - 192*D1*Dd*K*f*s**2 + 40*D1*Dd*K*f*s - 48*D1*Dd*K*f + 416*D1*Dd*K*fd*s**2 - 568*D1*Dd*K*fd*s + 116*D1*Dd*K*fd + 96*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r - 48*D1*Dd*f**2*s - 384*D1*Dd*f*fd*r*s + 72*D1*Dd*f*fd*s + 30*D1*Dd*f*fd - 192*D1*Dd*f*r*s + 48*D1*Dd*f*r + 24*D1*Dd*f*s**2 + 84*D1*Dd*f*s + 6*D1*Dd*f + 192*D1*Dd*fd*r*s - 24*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 158*D1*Dd*fd*s - 50*D1*Dd*fd + 448*D1*Dd*g2*r*s - 112*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 - 112*D1*Dd*g2*s - 56*D1*Dd*g2 - 448*D1*Dd*gd2*r*s + 56*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 + 280*D1*Dd*gd2*s - 56*D1*Dd*gd2 + 208*D1*Ddd*K*f*s**2 - 104*D1*Ddd*K*f*s + 52*D1*Ddd*K*f - 96*D1*Ddd*f**2*r*s + 24*D1*Ddd*f**2*r + 48*D1*Ddd*f**2*s + 96*D1*Ddd*f*r*s - 24*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 - 42*D1*Ddd*f*s - 3*D1*Ddd*f - 224*D1*Ddd*g2*r*s + 56*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 + 56*D1*Ddd*g2*s + 28*D1*Ddd*g2 + 2*D1*bd1*(D1*(14*K*(-6*r*s + 2*r + 3*s**2 + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s + 84*r*s - 28*r - 21*s**2 - 14*s - 7) + Dd*(14*K*(24*r*s - 7*r - 12*s**2 - 3*s + 2) - 3*f*(12*s**2 - 7*s + 1) - 336*r*s + 98*r + 84*s**2 + 91*s - 35)) + 624*Dd**2*K*f*s**2 - 312*Dd**2*K*f*s - 288*Dd**2*f**2*r*s + 72*Dd**2*f**2*r + 144*Dd**2*f**2*s - 48*Dd**2*f**2 + 288*Dd**2*f*r*s - 72*Dd**2*f*r - 36*Dd**2*f*s**2 - 126*Dd**2*f*s + 48*Dd**2*f - 672*Dd**2*g2*r*s + 168*Dd**2*g2*r + 336*Dd**2*g2*s**2 + 168*Dd**2*g2*s - 112*Dd**2*g2) + 11*b1*(16*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r - 192*C*D1**2*f*fd*s**2 + 136*C*D1**2*f*fd*s - 72*C*D1**2*f*fd + 112*C*D1**2*f*fdd*s**2 - 88*C*D1**2*f*fdd*s + 44*C*D1**2*f*fdd + 112*C*D1**2*fd**2*s**2 - 88*C*D1**2*fd**2*s + 32*C*D1*Dd*f**2*r*s - 8*C*D1*Dd*f**2*r - 384*C*D1*Dd*f**2*s**2 + 176*C*D1*Dd*f**2*s - 96*C*D1*Dd*f**2 + 896*C*D1*Dd*f*fd*s**2 - 576*C*D1*Dd*f*fd*s + 88*C*D1*Dd*f*fd + 224*C*D1*Ddd*f**2*s**2 - 112*C*D1*Ddd*f**2*s + 56*C*D1*Ddd*f**2 + 672*C*Dd**2*f**2*s**2 - 336*C*Dd**2*f**2*s + 24*D1**2*K*f*fd*r*s - 12*D1**2*K*f*fd*r + 120*D1**2*K*f*fd*s**2 - 120*D1**2*K*f*fd*s + 60*D1**2*K*f*fd - 24*D1**2*K*f*fdd*r*s + 12*D1**2*K*f*fdd*r - 84*D1**2*K*f*fdd*s**2 + 84*D1**2*K*f*fdd*s - 42*D1**2*K*f*fdd - 24*D1**2*K*fd**2*r*s + 12*D1**2*K*fd**2*r - 84*D1**2*K*fd**2*s**2 + 84*D1**2*K*fd**2*s - 12*D1**2*b2*fd*s**2 + 6*D1**2*b2*fdd*s**2 - 2*D1**2*bd1**2*(14*K*(r*(6*s - 2) - 3*s**2 + 1) - 9*f*s**2 + 6*f*s + r*(28 - 84*s) + 21*s**2 + 14*s - 14) - 12*D1**2*bd2*f*s**2 + 12*D1**2*bd2*fd*s**2 + D1**2*bdd1*(3*f**2*(4*r*(4*s - 3) - 18*s + 7) + 2*f*(C*(r*(8*s - 4) - 4*s**2 + 4*s - 2) + K*(-52*s**2 - 6*s + 3) - 24*r*s + 12*r + 3*s**2 + 34*s - 13) + 28*g2*(r*(4*s - 2) - 2*s**2 + 2*s - 1)) + 6*D1**2*bdd2*f*s**2 - 32*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 96*D1**2*f*fd*s**2 - 80*D1**2*f*fd*s + 54*D1**2*f*fd + 32*D1**2*f*fdd*r*s - 56*D1**2*f*fdd*s**2 + 50*D1**2*f*fdd*s - 33*D1**2*f*fdd + 56*D1**2*f*gd2*r*s - 96*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s + 104*D1**2*f*gdd2*s**2 + 32*D1**2*fd**2*r*s - 56*D1**2*fd**2*s**2 + 50*D1**2*fd**2*s + 56*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r - 96*D1**2*fd*g2*s**2 + 240*D1**2*fd*g2*s - 120*D1**2*fd*g2 + 208*D1**2*fd*gd2*s**2 - 232*D1**2*fd*gd2*s + 104*D1**2*fdd*g2*s**2 - 232*D1**2*fdd*g2*s + 116*D1**2*fdd*g2 + 48*D1*Dd*K*f**2*r*s - 12*D1*Dd*K*f**2*r + 240*D1*Dd*K*f**2*s**2 - 144*D1*Dd*K*f**2*s + 60*D1*Dd*K*f**2 - 192*D1*Dd*K*f*fd*r*s + 72*D1*Dd*K*f*fd*r - 672*D1*Dd*K*f*fd*s**2 + 552*D1*Dd*K*f*fd*s - 108*D1*Dd*K*f*fd - 48*D1*Dd*b2*f*s**2 + 24*D1*Dd*b2*f*s - 12*D1*Dd*b2*f + 48*D1*Dd*b2*fd*s**2 - 12*D1*Dd*b2*fd*s + 48*D1*Dd*bd2*f*s**2 - 12*D1*Dd*bd2*f*s - 64*D1*Dd*f**2*r*s + 16*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 64*D1*Dd*f**2*s + 48*D1*Dd*f**2 + 256*D1*Dd*f*fd*r*s - 32*D1*Dd*f*fd*r - 448*D1*Dd*f*fd*s**2 + 248*D1*Dd*f*fd*s - 50*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r - 384*D1*Dd*f*g2*s**2 + 80*D1*Dd*f*g2*s - 96*D1*Dd*f*g2 + 832*D1*Dd*f*gd2*s**2 - 208*D1*Dd*f*gd2*s + 832*D1*Dd*fd*g2*s**2 - 1136*D1*Dd*fd*g2*s + 232*D1*Dd*fd*g2 - 48*D1*Ddd*K*f**2*r*s + 12*D1*Ddd*K*f**2*r - 168*D1*Ddd*K*f**2*s**2 + 108*D1*Ddd*K*f**2*s - 42*D1*Ddd*K*f**2 + 24*D1*Ddd*b2*f*s**2 - 12*D1*Ddd*b2*f*s + 6*D1*Ddd*b2*f + 64*D1*Ddd*f**2*r*s - 16*D1*Ddd*f**2*r - 112*D1*Ddd*f**2*s**2 + 24*D1*Ddd*f**2*s - 28*D1*Ddd*f**2 + 416*D1*Ddd*f*g2*s**2 - 208*D1*Ddd*f*g2*s + 104*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(3*f**2*(r*(8*s - 6) - 12*s + 5) + 2*f*(C*(r*(8*s - 4) - 4*s**2 + 4*s - 2) + 14*K*r*s - 24*K*s**2 - 13*K*s + 3*K - 3*fd*(16*r*s - 4*r - 8*s + 3) - 24*r*s + 5*r + 3*s**2 + 20*s - 6) - 2*fd*(C*(8*r*s - 2*r - 4*s**2 - 2*s + 2) - 52*K*s**2 + 55*K*s + r*(6 - 24*s) + 3*s**2 - 8*s - 2) + 28*g2*(r*(4*s - 2) - 2*s**2 + 2*s - 1) + 28*gd2*(-4*r*s + r + 2*s**2 + s - 1)) - Dd*(3*f**2*(32*r*(2*s - 1) - 52*s + 21) + 2*f*(2*C*(2*r*(8*s - 3) - 8*s**2 + 2*s + 1) + K*(-208*s**2 + 40*s + 3) - 96*r*s + 36*r + 12*s**2 + 89*s - 29) + 28*g2*(2*r*(8*s - 3) - 8*s**2 + 2*s + 1))) - 144*Dd**2*K*f**2*r*s + 36*Dd**2*K*f**2*r - 504*Dd**2*K*f**2*s**2 + 324*Dd**2*K*f**2*s - 24*Dd**2*K*f**2 + 72*Dd**2*b2*f*s**2 - 36*Dd**2*b2*f*s + 192*Dd**2*f**2*r*s - 48*Dd**2*f**2*r - 336*Dd**2*f**2*s**2 + 72*Dd**2*f**2*s + 32*Dd**2*f**2 + 1248*Dd**2*f*g2*s**2 - 624*Dd**2*f*g2*s) - 66*b2*(-D1**2*bdd1*f*(s - 1)**2 - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 20*D1**2*f*fd*s - 10*D1**2*f*fd + 4*D1**2*f*fdd*r*s - 2*D1**2*f*fdd*r + 14*D1**2*f*fdd*s**2 - 14*D1**2*f*fdd*s + 7*D1**2*f*fdd + 4*D1**2*fd**2*r*s - 2*D1**2*fd**2*r + 14*D1**2*fd**2*s**2 - 14*D1**2*fd**2*s - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 12*D1*Dd*f*fd*r + 112*D1*Dd*f*fd*s**2 - 92*D1*Dd*f*fd*s + 18*D1*Dd*f*fd + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 28*D1*Ddd*f**2*s**2 - 18*D1*Ddd*f**2*s + 7*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 84*Dd**2*f**2*s**2 - 54*Dd**2*f**2*s + 4*Dd**2*f**2))/(462*d**2*k3**2) + D1**2*Pk3*Pkd2*ct*k1*(2*D1*(D1*bd1**2*(-14*K*f*(r*(2*s - 1) + 3*s**2 - 4*s + 1) + f*s*(76*C - 57)*(s - 1) - 56*g2*s*(s - 1)) - 2*D1*bdd1*f*(s - 1)*(f*(2*C - 1)*(7*r + 9*s - 9) - 7*g2*(2*r + 3*s - 3)) + 7*b2*(-D1*bdd1*f*(s - 1)*(2*r + 3*s - 3) + 2*bd1*(D1*(f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(3*s - 3))) + Dd*f*(r*(5 - 8*s) - 12*s**2 + 17*s - 5))) - 2*bd1*(7*D1*bd2*f*(r*(2*s - 1) + 3*s**2 - 4*s + 1) + D1*(-2*f**2*(s - 1)*(C*(8*r + 6*s - 6) - r - 3*s + 3) + f*(fd*(2*C - 1)*(14*r*(2*s - 1) + 36*s**2 - 43*s + 7) + 14*g2*(s - 1)*(r + s - 1) + 14*gd2*(-2*r*s + r - 3*s**2 + 4*s - 1)) + 14*fd*g2*(-2*r*s + r - s*(3*s - 3))) + Dd*f*(f*(2*C - 1)*(7*r*(8*s - 5) + 72*s**2 - 104*s + 32) - 14*g2*(r*(8*s - 5) + 12*s**2 - 17*s + 5)))) + 7*b1**3*(D1**2*s*(2*fd*(2*r + s - 2) + fdd*(-4*r - 3*s + 4)) + D1*(2*Dd*(f*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + fd*(-16*r*s + 2*r - 12*s**2 + 15*s - 2) - (4*K - 2)*(4*s**2 - 2*s + 1)) + Ddd*(f*(r*(4 - 16*s) - 12*s**2 + 14*s - 3) + (4*K - 2)*(4*s**2 - 2*s + 1))) - 2*Dd**2*(f*(6*r*(4*s - 1) + 18*s**2 - 21*s + 4) + s*(6 - 12*K)*(2*s - 1))) + b1**2*(56*C*D1**2*fd*r*s - 40*C*D1**2*fd*s**2 - 56*C*D1**2*fd*s + 76*C*D1**2*fdd*s**2 + 224*C*D1*Dd*f*r*s - 56*C*D1*Dd*f*r - 160*C*D1*Dd*f*s**2 - 32*C*D1*Dd*f*s - 40*C*D1*Dd*f + 608*C*D1*Dd*fd*s**2 - 152*C*D1*Dd*fd*s + 304*C*D1*Ddd*f*s**2 - 152*C*D1*Ddd*f*s + 76*C*D1*Ddd*f + 912*C*Dd**2*f*s**2 - 456*C*Dd**2*f*s + 28*D1**2*K*fd*r*s + 28*D1**2*K*fd*s**2 - 28*D1**2*K*fdd*r*s - 42*D1**2*K*fdd*s**2 - 7*D1**2*bdd1*(f*(4*r*(3*s - 1) + 9*s**2 - 10*s + 3) + (2 - 4*K)*(3*s**2 - 2*s + 1)) - 28*D1**2*fd*r*s + 30*D1**2*fd*s**2 + 56*D1**2*fd*s - 57*D1**2*fdd*s**2 + 112*D1**2*gd2*s**2 - 56*D1**2*gdd2*s**2 + 112*D1*Dd*K*f*r*s - 28*D1*Dd*K*f*r + 112*D1*Dd*K*f*s**2 - 112*D1*Dd*K*f*s + 28*D1*Dd*K*f - 224*D1*Dd*K*fd*r*s + 28*D1*Dd*K*fd*r - 336*D1*Dd*K*fd*s**2 + 140*D1*Dd*K*fd*s - 112*D1*Dd*f*r*s + 28*D1*Dd*f*r + 120*D1*Dd*f*s**2 - 4*D1*Dd*f*s + 30*D1*Dd*f - 456*D1*Dd*fd*s**2 + 114*D1*Dd*fd*s + 448*D1*Dd*g2*s**2 - 224*D1*Dd*g2*s + 112*D1*Dd*g2 - 448*D1*Dd*gd2*s**2 + 112*D1*Dd*gd2*s - 112*D1*Ddd*K*f*r*s + 28*D1*Ddd*K*f*r - 168*D1*Ddd*K*f*s**2 + 140*D1*Ddd*K*f*s - 42*D1*Ddd*K*f - 228*D1*Ddd*f*s**2 + 114*D1*Ddd*f*s - 57*D1*Ddd*f - 224*D1*Ddd*g2*s**2 + 112*D1*Ddd*g2*s - 56*D1*Ddd*g2 + 14*D1*bd1*(D1*f*(3*s - 1)*(2*r + s - 1) + D1*fd*(r*(2 - 12*s) - 9*s**2 + 11*s - 2) - 2*D1*(2*K - 1)*(3*s**2 - 2*s + 1) + Dd*f*(r*(14 - 48*s) - 36*s**2 + 41*s - 9) + 2*Dd*(2*K - 1)*(12*s**2 - 7*s + 1)) - 336*Dd**2*K*f*r*s + 84*Dd**2*K*f*r - 504*Dd**2*K*f*s**2 + 420*Dd**2*K*f*s - 56*Dd**2*K*f - 684*Dd**2*f*s**2 + 342*Dd**2*f*s - 672*Dd**2*g2*s**2 + 336*Dd**2*g2*s) - b1*(-128*C*D1**2*f*fd*r*s - 96*C*D1**2*f*fd*s**2 + 64*C*D1**2*f*fd*s + 112*C*D1**2*f*fdd*r*s + 144*C*D1**2*f*fdd*s**2 - 56*C*D1**2*f*fdd*s + 112*C*D1**2*fd**2*r*s + 144*C*D1**2*fd**2*s**2 - 56*C*D1**2*fd**2*s - 256*C*D1*Dd*f**2*r*s + 64*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 224*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 896*C*D1*Dd*f*fd*r*s - 112*C*D1*Dd*f*fd*r + 1152*C*D1*Dd*f*fd*s**2 - 736*C*D1*Dd*f*fd*s + 56*C*D1*Dd*f*fd + 224*C*D1*Ddd*f**2*r*s - 56*C*D1*Ddd*f**2*r + 288*C*D1*Ddd*f**2*s**2 - 256*C*D1*Ddd*f**2*s + 72*C*D1*Ddd*f**2 + 672*C*Dd**2*f**2*r*s - 168*C*Dd**2*f**2*r + 864*C*Dd**2*f**2*s**2 - 768*C*Dd**2*f**2*s + 112*C*Dd**2*f**2 + 14*D1**2*bd1**2*(f*(4*r*(3*s - 1) + 9*s**2 - 10*s + 2) + 2*s*(K*(4 - 6*s) + 3*s - 2)) + D1**2*bdd1*(f*(-76*C*(2*s**2 - 2*s + 1) + 14*K*(4*r*s - 2*r + 6*s**2 - 8*s + 3) + 114*s**2 - 114*s + 57) + 56*g2*(2*s**2 - 2*s + 1)) + 28*D1**2*bdd2*f*r*s + 42*D1**2*bdd2*f*s**2 - 28*D1**2*bdd2*f*s + 16*D1**2*f*fd*r*s + 48*D1**2*f*fd*s**2 - 8*D1**2*f*fd*s - 56*D1**2*f*fdd*r*s - 72*D1**2*f*fdd*s**2 + 28*D1**2*f*fdd*s + 56*D1**2*f*gd2*r*s + 56*D1**2*f*gd2*s**2 - 56*D1**2*f*gd2*s - 56*D1**2*f*gdd2*r*s - 84*D1**2*f*gdd2*s**2 + 56*D1**2*f*gdd2*s - 56*D1**2*fd**2*r*s - 72*D1**2*fd**2*s**2 + 28*D1**2*fd**2*s + 56*D1**2*fd*g2*r*s + 56*D1**2*fd*g2*s**2 - 112*D1**2*fd*gd2*r*s - 168*D1**2*fd*gd2*s**2 + 56*D1**2*fd*gd2*s - 56*D1**2*fdd*g2*r*s - 84*D1**2*fdd*g2*s**2 + 32*D1*Dd*f**2*r*s - 8*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 64*D1*Dd*f**2*s + 24*D1*Dd*f**2 - 448*D1*Dd*f*fd*r*s + 56*D1*Dd*f*fd*r - 576*D1*Dd*f*fd*s**2 + 368*D1*Dd*f*fd*s - 28*D1*Dd*f*fd + 224*D1*Dd*f*g2*r*s - 56*D1*Dd*f*g2*r + 224*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 56*D1*Dd*f*g2 - 448*D1*Dd*f*gd2*r*s + 56*D1*Dd*f*gd2*r - 672*D1*Dd*f*gd2*s**2 + 504*D1*Dd*f*gd2*s - 56*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r*s + 56*D1*Dd*fd*g2*r - 672*D1*Dd*fd*g2*s**2 + 280*D1*Dd*fd*g2*s - 112*D1*Ddd*f**2*r*s + 28*D1*Ddd*f**2*r - 144*D1*Ddd*f**2*s**2 + 128*D1*Ddd*f**2*s - 36*D1*Ddd*f**2 - 224*D1*Ddd*f*g2*r*s + 56*D1*Ddd*f*g2*r - 336*D1*Ddd*f*g2*s**2 + 280*D1*Ddd*f*g2*s - 84*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(152*C*fd*s**2 - 76*C*fd*s - 56*K*fd*r*s + 14*K*fd*r - 84*K*fd*s**2 + 56*K*fd*s + f*(4*C*(14*r*s - 7*r - 10*s**2 + 10*s - 5) + 14*K*(2*s - 1)*(r + s - 1) - 28*r*s + 14*r + 30*s**2 - 44*s + 15) - 114*fd*s**2 + 57*fd*s + 112*g2*s**2 - 112*g2*s + 56*g2 - 112*gd2*s**2 + 56*gd2*s) + Dd*(f*(76*C*(8*s**2 - 6*s + 1) - 28*K*(8*r*s - 3*r + 12*s**2 - 13*s + 3) - 456*s**2 + 342*s - 57) - 56*g2*(8*s**2 - 6*s + 1))) - 28*D1*bd2*(D1*s*(f*(r + s - 1) - 2*fd*r - 3*fd*s + fd) - Dd*f*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) - 336*Dd**2*f**2*r*s + 84*Dd**2*f**2*r - 432*Dd**2*f**2*s**2 + 384*Dd**2*f**2*s - 56*Dd**2*f**2 - 672*Dd**2*f*g2*r*s + 168*Dd**2*f*g2*r - 1008*Dd**2*f*g2*s**2 + 840*Dd**2*f*g2*s - 112*Dd**2*f*g2 - 14*b2*(D1**2*s*(2*fd*(r + s) - fdd*(2*r + 3*s)) + D1*(2*Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(-8*r*s + r + s*(5 - 12*s))) + Ddd*f*(r*(2 - 8*s) - 12*s**2 + 10*s - 3)) - 2*Dd**2*f*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2))))/(21*d**2*k3**2) + 9*D1**2*Pk3*Pkd2*ct*k1*st**4*(2*D1**2*bd1**2*f*s**2 + 2*D1*b1*s*(D1*bdd1*f*s + 2*bd1*(-D1*f*s + D1*fd*(s - 1) + Dd*f*(4*s - 1))) + b1**2*(-D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(-4*s**2 + 2*s - 1) + fd*(4*s**2 - 5*s + 1)) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1)))/(7*d**2*k2**2) + D1**2*Pk3*Pkd2*ct*k1*st**2*(D1*f*s*(2*D1*bd1**2*(s*(21*f - 34) + 5) + 11*D1*bdd1*f*s + 22*bd1*(-D1*(f*s - 2*fd*s + fd) + Dd*f*(4*s - 1))) + 5*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) - s**2*(12*fd + 28) + s*(3*fd + 14) - 7) - D1*Ddd*(3*f - 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f - 7)*(2*s - 1)) + b1**2*(-5*D1**2*bdd1*(3*f - 7)*(3*s**2 - 2*s + 1) - 84*D1**2*f*fd*s**2 + 84*D1**2*f*fd*s - 42*D1**2*f*fd + 42*D1**2*f*fdd*s**2 - 42*D1**2*f*fdd*s + 21*D1**2*f*fdd + 42*D1**2*fd**2*s**2 - 42*D1**2*fd**2*s + 68*D1**2*fd*s**2 - 116*D1**2*fd*s + 58*D1**2*fd - 34*D1**2*fdd*s**2 + 58*D1**2*fdd*s - 29*D1**2*fdd - 168*D1*Dd*f**2*s**2 + 84*D1*Dd*f**2*s - 42*D1*Dd*f**2 + 336*D1*Dd*f*fd*s**2 - 252*D1*Dd*f*fd*s + 42*D1*Dd*f*fd + 272*D1*Dd*f*s**2 - 136*D1*Dd*f*s + 68*D1*Dd*f - 272*D1*Dd*fd*s**2 + 300*D1*Dd*fd*s - 58*D1*Dd*fd + 84*D1*Ddd*f**2*s**2 - 42*D1*Ddd*f**2*s + 21*D1*Ddd*f**2 - 136*D1*Ddd*f*s**2 + 68*D1*Ddd*f*s - 34*D1*Ddd*f + 10*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) - s**2*(9*fd + 21) + s*(3*fd + 14) - 7) - Dd*(3*f - 7)*(12*s**2 - 7*s + 1)) + 252*Dd**2*f**2*s**2 - 126*Dd**2*f**2*s - 408*Dd**2*f*s**2 + 204*Dd**2*f*s) + b1*(-10*D1**2*bd1**2*s*(3*f - 7)*(3*s - 2) + D1**2*bdd1*f*(s**2*(42*f - 68) + 10*s - 5) - 11*D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) - 2*D1*bd1*(D1*(42*f**2*s**2 + f*(-s**2*(84*fd + 68) + s*(42*fd + 10) - 5) + fd*s*(68*s - 63)) - Dd*f*(4*s - 1)*(s*(42*f - 68) + 5)) - 11*D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) - 66*Dd**2*f**2*s*(1 - 2*s)))/(42*d**2*k2**2) + D1**2*Pk3*Pkd2*ct*k1*(38*D1**2*bd1**2*f*s*(s - 1) + D1*b1*(14*D1*bd1**2*s*(3*f + 2)*(3*s - 2) + 19*D1*bdd1*f*(2*s**2 - 2*s + 1) - 38*bd1*(D1*f*(2*s**2 - 2*s + 1) + D1*fd*s*(1 - 2*s) + Dd*f*(-8*s**2 + 6*s - 1))) - 7*b1**3*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(3*f*(4*s**2 - 2*s + 1) + s**2*(8 - 12*fd) + s*(3*fd - 4) + 2) - D1*Ddd*(3*f + 2)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(3*f + 2)*(2*s - 1)) + b1**2*(7*D1**2*bdd1*(3*f + 2)*(3*s**2 - 2*s + 1) - 19*D1**2*s**2*(2*fd - fdd) - 38*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) - 19*D1*Ddd*f*(-4*s**2 + 2*s - 1) - 14*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) + s**2*(6 - 9*fd) + s*(3*fd - 4) + 2) - Dd*(3*f + 2)*(12*s**2 - 7*s + 1)) - 114*Dd**2*f*s*(1 - 2*s)))/(21*d**2*k2**2) - D1**2*Pk3*Pkd2*ct*k2**2*(8*C - 4)*(D1**2*bd1**2*f*r*(1 - 2*s) + D1*b1*(D1*bd1*(2*f*r*(2*s - 1) + fd*(-4*r*s + r + 2*s - 1)) + D1*bdd1*f*r*(1 - 2*s) - 2*Dd*bd1*f*(r*(8*s - 3) - 2*s + 1)) + b1**2*(-D1*Dd*(2*f*(-4*r*s + r + 2*s) + fd*r*(8*s - 1) - 6*fd*s + fd) + D1*(D1*s*(2*fd - fdd)*(r - 1) + Ddd*f*(-4*r*s + r + 2*s)) + Dd**2*f*(r*(3 - 12*s) + 6*s - 2)))/(21*d**2*k1*k3**2) + D1**2*Pk3*Pkd2*ct*(8*C - 4)*(D1**2*bd1**2*f*r*(1 - 2*s) + D1*b1*(D1*bd1*(2*f*r*(2*s - 1) + fd*(-4*r*s + r + 2*s - 1)) + D1*bdd1*f*r*(1 - 2*s) - 2*Dd*bd1*f*(r*(8*s - 3) - 2*s + 1)) + b1**2*(-D1*Dd*(2*f*(-4*r*s + r + 2*s) + fd*r*(8*s - 1) - 6*fd*s + fd) + D1*(D1*s*(2*fd - fdd)*(r - 1) + Ddd*f*(-4*r*s + r + 2*s)) + Dd**2*f*(r*(3 - 12*s) + 6*s - 2)))/(21*d**2*k1) + 80*D1**2*Pk3*Pkd2*f**2*k1**6*st**4*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(3003*d**2*k2*k3**6) + 40*D1**2*Pk3*Pkd2*f**2*k1**4*k2*st**6*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(1001*d**2*k3**6) + 45*D1**2*Pk3*Pkd2*f**2*k1**4*st**6*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(2002*d**2*k2*k3**4) - 40*D1**2*Pk3*Pkd2*f**2*k1**2*k2**3*st**8*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(1287*d**2*k3**6) - 5*D1**2*Pk3*Pkd2*f**2*k1**2*k2*st**8*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(143*d**2*k3**4) + 100*D1**2*Pk3*Pkd2*f*k1**6*st**2*(-D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) + b1*(D1**2*s*(3*r + 3*s - 2)*(2*f*fd - f*fdd - 2*fd**2) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(3 - 24*s) - 24*s**2 + 20*s - 2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k2*k3**6) - 8*D1**2*Pk3*Pkd2*f*k1**4*k2*st**4*(-12*D1**2*b1*f*fd*r*s - 8*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s**2 + 8*D1**2*b1*f*fd + 6*D1**2*b1*f*fdd*r*s + 4*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 - 4*D1**2*b1*f*fdd + 12*D1**2*b1*fd**2*r*s + 8*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 - 4*D1**2*b1*fd**2 + 2*D1**2*bdd1*f**2*(s - 3)*(r + s - 1) + 12*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 12*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 3*D1**2*f**2*fd - 16*D1*Dd*b1*f**2*r*s + 4*D1*Dd*b1*f**2*r - 16*D1*Dd*b1*f**2*s**2 + 16*D1*Dd*b1*f**2*s - 4*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r*s + 10*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 24*D1*Dd*b1*f*fd*s - 8*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 8*D1*Ddd*b1*f**2*r*s - 2*D1*Ddd*b1*f**2*r + 8*D1*Ddd*b1*f**2*s**2 - 8*D1*Ddd*b1*f**2*s + 2*D1*Ddd*b1*f**2 - 2*D1*bd1*f*(D1*(2*f*(s - 3)*(r + s - 1) + fd*(-6*r*s + 7*r - 6*s**2 + 12*s - 4)) + Dd*f*(r*(13 - 8*s) - 8*s**2 + 20*s - 10)) + 24*Dd**2*b1*f**2*r*s - 6*Dd**2*b1*f**2*r + 24*Dd**2*b1*f**2*s**2 - 24*Dd**2*b1*f**2*s + 4*Dd**2*b1*f**2)/(231*d**2*k3**6) + D1**2*Pk3*Pkd2*f*k1**4*st**4*(48*D1**2*b1*f*fd*r*s - 16*D1**2*b1*f*fd*r + 108*D1**2*b1*f*fd*s**2 - 36*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fd - 24*D1**2*b1*f*fdd*r*s + 8*D1**2*b1*f*fdd*r - 54*D1**2*b1*f*fdd*s**2 + 18*D1**2*b1*f*fdd*s - 3*D1**2*b1*f*fdd - 48*D1**2*b1*fd**2*r*s + 16*D1**2*b1*fd**2*r - 108*D1**2*b1*fd**2*s**2 + 36*D1**2*b1*fd**2*s - 12*D1**2*b1*fd**2 - D1**2*bdd1*f**2*(8*r*s + 18*s**2 - 34*s + 15) - 40*D1**2*f**2*fd*r*s + 10*D1**2*f**2*fd*r - 192*D1**2*f**2*fd*s**2 + 116*D1**2*f**2*fd*s - 48*D1**2*f**2*fd + 40*D1**2*f**2*fdd*r*s - 10*D1**2*f**2*fdd*r + 108*D1**2*f**2*fdd*s**2 - 74*D1**2*f**2*fdd*s + 27*D1**2*f**2*fdd + 120*D1**2*f*fd**2*r*s - 30*D1**2*f*fd**2*r + 324*D1**2*f*fd**2*s**2 - 222*D1**2*f*fd**2*s + 20*D1**2*f*fd**2 + 64*D1*Dd*b1*f**2*r*s - 16*D1*Dd*b1*f**2*r + 144*D1*Dd*b1*f**2*s**2 - 104*D1*Dd*b1*f**2*s + 36*D1*Dd*b1*f**2 - 192*D1*Dd*b1*f*fd*r*s + 56*D1*Dd*b1*f*fd*r - 432*D1*Dd*b1*f*fd*s**2 + 228*D1*Dd*b1*f*fd*s - 34*D1*Dd*b1*f*fd - 40*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r - 192*D1*Dd*f**3*s**2 + 116*D1*Dd*f**3*s - 48*D1*Dd*f**3 + 320*D1*Dd*f**2*fd*r*s - 80*D1*Dd*f**2*fd*r + 864*D1*Dd*f**2*fd*s**2 - 592*D1*Dd*f**2*fd*s + 94*D1*Dd*f**2*fd - 32*D1*Ddd*b1*f**2*r*s + 8*D1*Ddd*b1*f**2*r - 72*D1*Ddd*b1*f**2*s**2 + 52*D1*Ddd*b1*f**2*s - 18*D1*Ddd*b1*f**2 + 40*D1*Ddd*f**3*r*s - 10*D1*Ddd*f**3*r + 108*D1*Ddd*f**3*s**2 - 74*D1*Ddd*f**3*s + 27*D1*Ddd*f**3 + 2*D1*bd1*f*(D1*(f*(8*r*s + 18*s**2 - 34*s + 15) - 2*fd*(12*r*s - 2*r + 27*s**2 - 30*s + 1)) + Dd*f*(r*(4 - 32*s) - 72*s**2 + 94*s - 17)) - 96*Dd**2*b1*f**2*r*s + 24*Dd**2*b1*f**2*r - 216*Dd**2*b1*f**2*s**2 + 156*Dd**2*b1*f**2*s - 16*Dd**2*b1*f**2 + 120*Dd**2*f**3*r*s - 30*Dd**2*f**3*r + 324*Dd**2*f**3*s**2 - 222*Dd**2*f**3*s + 20*Dd**2*f**3)/(231*d**2*k2*k3**4) + 20*D1**2*Pk3*Pkd2*f*k1**2*k2**3*st**6*(18*D1**2*b1*f*fd*r*s - 8*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fd*s**2 - 20*D1**2*b1*f*fd*s + 8*D1**2*b1*f*fd - 9*D1**2*b1*f*fdd*r*s + 4*D1**2*b1*f*fdd*r - 9*D1**2*b1*f*fdd*s**2 + 10*D1**2*b1*f*fdd*s - 4*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r*s + 8*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 20*D1**2*b1*fd**2*s - 4*D1**2*b1*fd**2 - D1**2*bdd1*f**2*(3*s + 1)*(r + s - 1) + 4*D1**2*f**2*fd*r*s - D1**2*f**2*fd*r + 4*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + D1**2*f**2*fd + 24*D1*Dd*b1*f**2*r*s - 6*D1*Dd*b1*f**2*r + 24*D1*Dd*b1*f**2*s**2 - 24*D1*Dd*b1*f**2*s + 6*D1*Dd*b1*f**2 - 72*D1*Dd*b1*f*fd*r*s + 25*D1*Dd*b1*f*fd*r - 72*D1*Dd*b1*f*fd*s**2 + 76*D1*Dd*b1*f*fd*s - 18*D1*Dd*b1*f*fd + 4*D1*Dd*f**3*r*s - D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s + D1*Dd*f**3 - 12*D1*Ddd*b1*f**2*r*s + 3*D1*Ddd*b1*f**2*r - 12*D1*Ddd*b1*f**2*s**2 + 12*D1*Ddd*b1*f**2*s - 3*D1*Ddd*b1*f**2 + D1*bd1*f*(D1*(2*f*(3*s + 1)*(r + s - 1) + fd*(-18*r*s + r - 18*s**2 + 16*s - 2)) - Dd*f*(24*r*s + r + 4*s*(6*s - 5))) - 36*Dd**2*b1*f**2*r*s + 9*Dd**2*b1*f**2*r - 36*Dd**2*b1*f**2*s**2 + 36*Dd**2*b1*f**2*s - 6*Dd**2*b1*f**2)/(693*d**2*k3**6) + D1**2*Pk3*Pkd2*f*k1**2*k2**3*st**4*(16*C - 8)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(77*d**2*k3**6) + 5*D1**2*Pk3*Pkd2*f*k1**2*k2*st**6*(-96*D1**2*b1*f*fd*r*s + 32*D1**2*b1*f*fd*r - 36*D1**2*b1*f*fd*s**2 + 44*D1**2*b1*f*fd*s - 2*D1**2*b1*f*fd + 48*D1**2*b1*f*fdd*r*s - 16*D1**2*b1*f*fdd*r + 18*D1**2*b1*f*fdd*s**2 - 22*D1**2*b1*f*fdd*s + D1**2*b1*f*fdd + 96*D1**2*b1*fd**2*r*s - 32*D1**2*b1*fd**2*r + 36*D1**2*b1*fd**2*s**2 - 44*D1**2*b1*fd**2*s + 20*D1**2*b1*fd**2 + D1**2*bdd1*f**2*(16*r*s + 6*s**2 - 22*s + 5) + 72*D1**2*f**2*fd*r*s - 18*D1**2*f**2*fd*r + 80*D1**2*f**2*fd*s**2 - 76*D1**2*f**2*fd*s + 20*D1**2*f**2*fd - 72*D1**2*f**2*fdd*r*s + 18*D1**2*f**2*fdd*r - 52*D1**2*f**2*fdd*s**2 + 62*D1**2*f**2*fdd*s - 13*D1**2*f**2*fdd - 216*D1**2*f*fd**2*r*s + 54*D1**2*f*fd**2*r - 156*D1**2*f*fd**2*s**2 + 186*D1**2*f*fd**2*s - 36*D1**2*f*fd**2 - 128*D1*Dd*b1*f**2*r*s + 32*D1*Dd*b1*f**2*r - 48*D1*Dd*b1*f**2*s**2 + 88*D1*Dd*b1*f**2*s - 12*D1*Dd*b1*f**2 + 384*D1*Dd*b1*f*fd*r*s - 112*D1*Dd*b1*f*fd*r + 144*D1*Dd*b1*f*fd*s**2 - 220*D1*Dd*b1*f*fd*s + 54*D1*Dd*b1*f*fd + 72*D1*Dd*f**3*r*s - 18*D1*Dd*f**3*r + 80*D1*Dd*f**3*s**2 - 76*D1*Dd*f**3*s + 20*D1*Dd*f**3 - 576*D1*Dd*f**2*fd*r*s + 144*D1*Dd*f**2*fd*r - 416*D1*Dd*f**2*fd*s**2 + 496*D1*Dd*f**2*fd*s - 98*D1*Dd*f**2*fd + 64*D1*Ddd*b1*f**2*r*s - 16*D1*Ddd*b1*f**2*r + 24*D1*Ddd*b1*f**2*s**2 - 44*D1*Ddd*b1*f**2*s + 6*D1*Ddd*b1*f**2 - 72*D1*Ddd*f**3*r*s + 18*D1*Ddd*f**3*r - 52*D1*Ddd*f**3*s**2 + 62*D1*Ddd*f**3*s - 13*D1*Ddd*f**3 - 2*D1*bd1*f*(D1*(f*(16*r*s + 6*s**2 - 22*s + 5) - 2*fd*(24*r*s - 4*r + 9*s**2 - 22*s + 3)) + Dd*f*(r*(8 - 64*s) - 24*s**2 + 66*s - 11)) + 192*Dd**2*b1*f**2*r*s - 48*Dd**2*b1*f**2*r + 72*Dd**2*b1*f**2*s**2 - 132*Dd**2*b1*f**2*s + 32*Dd**2*b1*f**2 - 216*Dd**2*f**3*r*s + 54*Dd**2*f**3*r - 156*Dd**2*f**3*s**2 + 186*Dd**2*f**3*s - 36*Dd**2*f**3)/(1386*d**2*k3**4) + D1**2*Pk3*Pkd2*f*k1**2*k2*st**4*(D1**2*(-f*(2*fd - fdd)*(2*C*(16*r*(3*s - 1) + 57*s**2 - 54*s + 19) + r*(18 - 54*s) - 69*s**2 + 64*s - 23) + 2*fd**2*(2*C*(16*r*(3*s - 1) + 57*s**2 - 54*s + 8) + r*(18 - 54*s) - 69*s**2 + 64*s - 9)) + D1*f*(-2*Dd*(f*(2*C*(16*r*(4*s - 1) + 76*s**2 - 70*s + 19) + r*(18 - 72*s) - 92*s**2 + 82*s - 23) + fd*(-2*C*(8*r*(24*s - 7) + 228*s**2 - 213*s + 43) + 9*r*(24*s - 7) + 276*s**2 - 251*s + 50)) + Ddd*f*(2*C*(16*r*(4*s - 1) + 76*s**2 - 70*s + 19) + r*(18 - 72*s) - 92*s**2 + 82*s - 23)) + 2*Dd**2*f**2*(2*C*(24*r*(4*s - 1) + 114*s**2 - 105*s + 16) - 27*r*(4*s - 1) - 138*s**2 + 123*s - 18))/(231*d**2*k3**4) + 15*D1**2*Pk3*Pkd2*f*k1**2*st**6*(D1*f*s*(D1*bdd1*f*s - 2*bd1*(D1*(f*s - 3*fd*s + fd) + Dd*(-4*f*s + f))) + b1*(D1**2*(-f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(3*s - 2)) + D1*f*(2*Dd*(f*(-4*s**2 + 2*s - 1) + fd*(12*s**2 - 7*s + 1)) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)))/(154*d**2*k2*k3**2) - D1**2*Pk3*Pkd2*f*k1**2*st**4*(D1**2*(f*(2*fd - fdd)*(10*C*(3*s**2 - 2*s + 1) + r*(6*s - 2) - 3*s**2 - 1) + 2*fd**2*(10*C*s*(2 - 3*s) + r*(2 - 6*s) + 3*s**2 - 1)) + D1*f*(2*Dd*(f*(10*C*(4*s**2 - 2*s + 1) + 8*r*s - 2*r - 4*s**2 - 2*s - 1) + fd*(-10*C*(12*s**2 - 7*s + 1) - 24*r*s + 7*r + 12*s**2 + 3*s - 2)) + Ddd*f*(-10*C*(4*s**2 - 2*s + 1) - 8*r*s + 2*r + 4*s**2 + 2*s + 1)) + 2*Dd**2*f**2*(r*(3 - 12*s) + s**2*(6 - 60*C) + s*(30*C + 3) - 2))/(231*d**2*k2*k3**2) - 4*D1**2*Pk3*Pkd2*k1**4*k2*st**2*(D1**2*bd1*f**2*(bd1*(4 - 8*s) + f*(2*s - 3))*(r + s - 1) + D1*b1*f*(4*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-8*r*s + 2*r - 8*s**2 + 8*s - 1)) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) + f*(-4*D1*bdd1*(2*s - 1)*(r + s - 1) + D1*fd*(6*r*s + r + 6*s**2 - 3*s - 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + 4*b1**2*(D1**2*s*(2*r + 2*s - 1)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(2 - 16*s) - 16*s**2 + 12*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(21*d**2*k3**6) + D1**2*Pk3*Pkd2*k1**4*st**2*(D1*f**2*(-2*D1*bd1**2*(r*(8*s - 4) + 7*s**2 - 9*s + 2) + 5*D1*bdd1*f*(2*r*(s - 1) + 2*s**2 - 6*s + 3) - 2*bd1*(D1*(f*(5*r*s - 5*r + 8*s**2 - 24*s + 12) - 5*fd*(6*r*s - 3*r + 6*s**2 - 10*s + 2)) - 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 16*s + 5))) + b1**2*(2*D1**2*s*(8*r + 7*s - 6)*(2*f*fd - f*fdd - fd**2) + D1*f*(2*Dd*(f*(32*r*s - 8*r + 28*s**2 - 30*s + 7) - 2*fd*(32*r*s - 4*r + 28*s**2 - 27*s + 3)) + Ddd*f*(r*(8 - 32*s) - 28*s**2 + 30*s - 7)) - 2*Dd**2*f**2*(12*r*(4*s - 1) + 42*s**2 - 45*s + 8)) + b1*f*(D1**2*bdd1*f*(-16*r*s + 8*r - 14*s**2 + 18*s - 7) - 30*D1**2*f*fd*r*s - 48*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s + 8*D1**2*f*fd + 30*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s - 5*D1**2*f*fdd + 60*D1**2*fd**2*r*s + 60*D1**2*fd**2*s**2 - 20*D1**2*fd**2*s - 40*D1*Dd*f**2*r*s + 10*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 + 52*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 240*D1*Dd*f*fd*r*s - 30*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 160*D1*Dd*f*fd*s + 10*D1*Dd*f*fd + 40*D1*Ddd*f**2*r*s - 10*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 40*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 + 2*D1*bd1*(D1*(f*(16*r*s - 8*r + 14*s**2 - 18*s + 7) - 2*fd*(16*r*s - 4*r + 14*s**2 - 15*s + 3)) + Dd*f*(-8*r*(8*s - 3) - 56*s**2 + 66*s - 17)) + 120*Dd**2*f**2*r*s - 30*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 120*Dd**2*f**2*s + 20*Dd**2*f**2))/(42*d**2*k2*k3**4) - 2*D1**2*Pk3*Pkd2*k1**4*(2*D1**2*bd1**2*f**2*s*(s - 1) + D1*b1*f*(D1*bdd1*f*(2*s**2 - 2*s + 1) + 2*bd1*(2*s - 1)*(2*D1*fd*s + Dd*f*(4*s - 1))) + b1**2*(2*D1**2*s**2*(f*fdd + fd**2) + D1*f*(4*Dd*fd*s*(4*s - 1) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)))/(7*d**2*k2*k3**4) + 4*D1**2*Pk3*Pkd2*k1**2*k2**3*st**2*(24*C*D1**2*b1*f*fd*r*s + 24*C*D1**2*b1*f*fd*s**2 - 12*C*D1**2*b1*f*fd*s - 12*C*D1**2*b1*f*fdd*r*s - 12*C*D1**2*b1*f*fdd*s**2 + 6*C*D1**2*b1*f*fdd*s - 12*C*D1**2*b1*fd**2*r*s - 12*C*D1**2*b1*fd**2*s**2 + 6*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r*s + 2*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 6*C*D1**2*f**2*fd*s - 2*C*D1**2*f**2*fd + 48*C*D1*Dd*b1*f**2*r*s - 12*C*D1*Dd*b1*f**2*r + 48*C*D1*Dd*b1*f**2*s**2 - 48*C*D1*Dd*b1*f**2*s + 12*C*D1*Dd*b1*f**2 - 96*C*D1*Dd*b1*f*fd*r*s + 12*C*D1*Dd*b1*f*fd*r - 96*C*D1*Dd*b1*f*fd*s**2 + 72*C*D1*Dd*b1*f*fd*s - 6*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r*s + 2*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 8*C*D1*Dd*f**3*s - 2*C*D1*Dd*f**3 - 24*C*D1*Ddd*b1*f**2*r*s + 6*C*D1*Ddd*b1*f**2*r - 24*C*D1*Ddd*b1*f**2*s**2 + 24*C*D1*Ddd*b1*f**2*s - 6*C*D1*Ddd*b1*f**2 - 72*C*Dd**2*b1*f**2*r*s + 18*C*Dd**2*b1*f**2*r - 72*C*Dd**2*b1*f**2*s**2 + 72*C*Dd**2*b1*f**2*s - 12*C*Dd**2*b1*f**2 + 6*D1**2*K*b1**2*fd*r*s + 6*D1**2*K*b1**2*fd*s**2 - 3*D1**2*K*b1**2*fdd*r*s - 3*D1**2*K*b1**2*fdd*s**2 - 2*D1**2*K*b1*f*fd*r*s + D1**2*K*b1*f*fd*r - 2*D1**2*K*b1*f*fd*s**2 + 2*D1**2*K*b1*f*fd*s - D1**2*K*b1*f*fd - 3*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 6*D1**2*b1**2*f*fd*r*s + 6*D1**2*b1**2*f*fd*s**2 - 3*D1**2*b1**2*f*fd*s - 12*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*s**2 + 6*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*s**2 - 3*D1**2*b1*f*fdd*s - 12*D1**2*b1*f*gd2*r*s - 12*D1**2*b1*f*gd2*s**2 + 12*D1**2*b1*f*gd2*s + 6*D1**2*b1*f*gdd2*r*s + 6*D1**2*b1*f*gdd2*s**2 - 6*D1**2*b1*f*gdd2*s + 6*D1**2*b1*fd**2*r*s + 6*D1**2*b1*fd**2*s**2 - 3*D1**2*b1*fd**2*s - 12*D1**2*b1*fd*g2*r*s - 12*D1**2*b1*fd*g2*s**2 + 12*D1**2*b1*fd*gd2*r*s + 12*D1**2*b1*fd*gd2*s**2 - 6*D1**2*b1*fd*gd2*s + 6*D1**2*b1*fdd*g2*r*s + 6*D1**2*b1*fdd*g2*s**2 - 3*D1**2*bdd1*f*(r + s - 1)*(K*b1*(2*s - 1) + f*(2*C - 1)*(s - 1) - 2*g2*(s - 1)) + 3*D1**2*f**2*fd*r*s - D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 3*D1**2*f**2*fd*s + D1**2*f**2*fd + 2*D1**2*f**2*gd2*r*s + 2*D1**2*f**2*gd2*s**2 - 2*D1**2*f**2*gd2*s + 4*D1**2*f*fd*g2*r*s - 2*D1**2*f*fd*g2*r + 4*D1**2*f*fd*g2*s**2 - 4*D1**2*f*fd*g2*s + 2*D1**2*f*fd*g2 + 24*D1*Dd*K*b1**2*f*r*s - 6*D1*Dd*K*b1**2*f*r + 24*D1*Dd*K*b1**2*f*s**2 - 24*D1*Dd*K*b1**2*f*s + 6*D1*Dd*K*b1**2*f - 24*D1*Dd*K*b1**2*fd*r*s + 3*D1*Dd*K*b1**2*fd*r - 24*D1*Dd*K*b1**2*fd*s**2 + 12*D1*Dd*K*b1**2*fd*s - 4*D1*Dd*K*b1*f**2*r*s + D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s**2 + 4*D1*Dd*K*b1*f**2*s - D1*Dd*K*b1*f**2 + 12*D1*Dd*b1**2*f**2*r*s - 3*D1*Dd*b1**2*f**2*r + 12*D1*Dd*b1**2*f**2*s**2 - 12*D1*Dd*b1**2*f**2*s + 3*D1*Dd*b1**2*f**2 - 24*D1*Dd*b1*f**2*r*s + 6*D1*Dd*b1*f**2*r - 24*D1*Dd*b1*f**2*s**2 + 24*D1*Dd*b1*f**2*s - 6*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r*s - 6*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 36*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 48*D1*Dd*b1*f*g2*r*s + 12*D1*Dd*b1*f*g2*r - 48*D1*Dd*b1*f*g2*s**2 + 48*D1*Dd*b1*f*g2*s - 12*D1*Dd*b1*f*g2 + 48*D1*Dd*b1*f*gd2*r*s - 6*D1*Dd*b1*f*gd2*r + 48*D1*Dd*b1*f*gd2*s**2 - 48*D1*Dd*b1*f*gd2*s + 6*D1*Dd*b1*f*gd2 + 48*D1*Dd*b1*fd*g2*r*s - 6*D1*Dd*b1*fd*g2*r + 48*D1*Dd*b1*fd*g2*s**2 - 24*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r*s - D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s + D1*Dd*f**3 + 8*D1*Dd*f**2*g2*r*s - 2*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s**2 - 8*D1*Dd*f**2*g2*s + 2*D1*Dd*f**2*g2 - 12*D1*Ddd*K*b1**2*f*r*s + 3*D1*Ddd*K*b1**2*f*r - 12*D1*Ddd*K*b1**2*f*s**2 + 12*D1*Ddd*K*b1**2*f*s - 3*D1*Ddd*K*b1**2*f + 12*D1*Ddd*b1*f**2*r*s - 3*D1*Ddd*b1*f**2*r + 12*D1*Ddd*b1*f**2*s**2 - 12*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 24*D1*Ddd*b1*f*g2*r*s - 6*D1*Ddd*b1*f*g2*r + 24*D1*Ddd*b1*f*g2*s**2 - 24*D1*Ddd*b1*f*g2*s + 6*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(12*C*(s - 1) - K*s + b1*(6*s - 3) - 6*s + 6) - 3*f*(fd*(2*C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(2*r + 2*s - 2)) + 3*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) - 3*Dd*f*(K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + f*(2*C - 1)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 2*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 36*Dd**2*K*b1**2*f*r*s + 9*Dd**2*K*b1**2*f*r - 36*Dd**2*K*b1**2*f*s**2 + 36*Dd**2*K*b1**2*f*s - 6*Dd**2*K*b1**2*f + 36*Dd**2*b1*f**2*r*s - 9*Dd**2*b1*f**2*r + 36*Dd**2*b1*f**2*s**2 - 36*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 72*Dd**2*b1*f*g2*r*s - 18*Dd**2*b1*f*g2*r + 72*Dd**2*b1*f*g2*s**2 - 72*Dd**2*b1*f*g2*s + 12*Dd**2*b1*f*g2)/(21*d**2*k3**6) - D1**2*Pk3*Pkd2*k1**2*k2*st**2*(64*C*D1**2*bd1*f**2*r*s - 64*C*D1**2*bd1*f**2*r + 92*C*D1**2*bd1*f**2*s**2 - 184*C*D1**2*bd1*f**2*s + 92*C*D1**2*bd1*f**2 - 128*C*D1**2*bd1*f*fd*r*s + 64*C*D1**2*bd1*f*fd*r - 184*C*D1**2*bd1*f*fd*s**2 + 216*C*D1**2*bd1*f*fd*s - 32*C*D1**2*bd1*f*fd - 32*C*D1**2*bdd1*f**2*r*s + 32*C*D1**2*bdd1*f**2*r - 46*C*D1**2*bdd1*f**2*s**2 + 92*C*D1**2*bdd1*f**2*s - 46*C*D1**2*bdd1*f**2 - 48*C*D1**2*f**2*fd*r*s + 16*C*D1**2*f**2*fd*r + 16*C*D1**2*f**2*fd*s - 30*C*D1**2*f**2*fdd*s**2 + 20*C*D1**2*f**2*fdd*s - 10*C*D1**2*f**2*fdd - 60*C*D1**2*f*fd**2*s**2 + 40*C*D1**2*f*fd**2*s - 256*C*D1*Dd*bd1*f**2*r*s + 160*C*D1*Dd*bd1*f**2*r - 368*C*D1*Dd*bd1*f**2*s**2 + 524*C*D1*Dd*bd1*f**2*s - 156*C*D1*Dd*bd1*f**2 - 64*C*D1*Dd*f**3*r*s + 16*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s - 240*C*D1*Dd*f**2*fd*s**2 + 140*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 40*C*D1*Ddd*f**3*s**2 + 20*C*D1*Ddd*f**3*s - 10*C*D1*Ddd*f**3 - 120*C*Dd**2*f**3*s**2 + 60*C*Dd**2*f**3*s - 32*D1**2*K*bd1**2*f*r*s + 16*D1**2*K*bd1**2*f*r - 46*D1**2*K*bd1**2*f*s**2 + 62*D1**2*K*bd1**2*f*s - 16*D1**2*K*bd1**2*f - 8*D1**2*K*bd1*f**2*r*s + 8*D1**2*K*bd1*f**2*s - 20*D1**2*K*bd1*f*fd*s**2 + 10*D1**2*K*bd1*f*fd*s - 5*D1**2*K*bdd1*f**2*s**2 + 36*D1**2*bd1**2*f**2*r*s - 18*D1**2*bd1**2*f**2*r + 30*D1**2*bd1**2*f**2*s**2 - 48*D1**2*bd1**2*f**2*s + 18*D1**2*bd1**2*f**2 + 4*D1**2*bd1**2*f*r*s - 2*D1**2*bd1**2*f*r + 8*D1**2*bd1**2*f*s**2 - 10*D1**2*bd1**2*f*s + 2*D1**2*bd1**2*f - 24*D1**2*bd1*bd2*f*r*s + 12*D1**2*bd1*bd2*f*r - 24*D1**2*bd1*bd2*f*s**2 + 36*D1**2*bd1*bd2*f*s - 12*D1**2*bd1*bd2*f - 34*D1**2*bd1*f**2*r*s + 36*D1**2*bd1*f**2*r - 54*D1**2*bd1*f**2*s**2 + 106*D1**2*bd1*f**2*s - 54*D1**2*bd1*f**2 + 72*D1**2*bd1*f*fd*r*s - 36*D1**2*bd1*f*fd*r + 108*D1**2*bd1*f*fd*s**2 - 126*D1**2*bd1*f*fd*s + 18*D1**2*bd1*f*fd - 64*D1**2*bd1*f*g2*r*s + 64*D1**2*bd1*f*g2*r - 92*D1**2*bd1*f*g2*s**2 + 184*D1**2*bd1*f*g2*s - 92*D1**2*bd1*f*g2 + 64*D1**2*bd1*f*gd2*r*s - 32*D1**2*bd1*f*gd2*r + 92*D1**2*bd1*f*gd2*s**2 - 124*D1**2*bd1*f*gd2*s + 32*D1**2*bd1*f*gd2 + 64*D1**2*bd1*fd*g2*r*s - 32*D1**2*bd1*fd*g2*r + 92*D1**2*bd1*fd*g2*s**2 - 92*D1**2*bd1*fd*g2*s - 4*D1**2*bd2*f**2*r*s - 4*D1**2*bd2*f**2*s**2 + 4*D1**2*bd2*f**2*s + 18*D1**2*bdd1*f**2*r*s - 18*D1**2*bdd1*f**2*r + 27*D1**2*bdd1*f**2*s**2 - 54*D1**2*bdd1*f**2*s + 27*D1**2*bdd1*f**2 + 32*D1**2*bdd1*f*g2*r*s - 32*D1**2*bdd1*f*g2*r + 46*D1**2*bdd1*f*g2*s**2 - 92*D1**2*bdd1*f*g2*s + 46*D1**2*bdd1*f*g2 + 30*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r - 10*D1**2*f**2*fd*s + 15*D1**2*f**2*fdd*s**2 - 10*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd + 16*D1**2*f**2*gd2*r*s - 16*D1**2*f**2*gd2*s + 10*D1**2*f**2*gdd2*s**2 + 30*D1**2*f*fd**2*s**2 - 20*D1**2*f*fd**2*s + 32*D1**2*f*fd*g2*r*s - 16*D1**2*f*fd*g2*r + 40*D1**2*f*fd*gd2*s**2 - 20*D1**2*f*fd*gd2*s + 20*D1**2*f*fdd*g2*s**2 - 20*D1**2*f*fdd*g2*s + 10*D1**2*f*fdd*g2 + 20*D1**2*fd**2*g2*s**2 - 20*D1**2*fd**2*g2*s - 40*D1*Dd*K*bd1*f**2*s**2 + 10*D1*Dd*K*bd1*f**2*s + 144*D1*Dd*bd1*f**2*r*s - 90*D1*Dd*bd1*f**2*r + 216*D1*Dd*bd1*f**2*s**2 - 306*D1*Dd*bd1*f**2*s + 90*D1*Dd*bd1*f**2 + 256*D1*Dd*bd1*f*g2*r*s - 160*D1*Dd*bd1*f*g2*r + 368*D1*Dd*bd1*f*g2*s**2 - 524*D1*Dd*bd1*f*g2*s + 156*D1*Dd*bd1*f*g2 + 40*D1*Dd*f**3*r*s - 10*D1*Dd*f**3*r - 20*D1*Dd*f**3*s + 120*D1*Dd*f**2*fd*s**2 - 70*D1*Dd*f**2*fd*s + 10*D1*Dd*f**2*fd + 64*D1*Dd*f**2*g2*r*s - 16*D1*Dd*f**2*g2*r - 32*D1*Dd*f**2*g2*s + 80*D1*Dd*f**2*gd2*s**2 - 20*D1*Dd*f**2*gd2*s + 160*D1*Dd*f*fd*g2*s**2 - 120*D1*Dd*f*fd*g2*s + 20*D1*Dd*f*fd*g2 + 20*D1*Ddd*f**3*s**2 - 10*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 40*D1*Ddd*f**2*g2*s**2 - 20*D1*Ddd*f**2*g2*s + 10*D1*Ddd*f**2*g2 + 4*D1*b2*(3*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - f*(3*D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + 60*Dd**2*f**3*s**2 - 30*Dd**2*f**3*s + 120*Dd**2*f**2*g2*s**2 - 60*Dd**2*f**2*g2*s + 8*b1**3*(D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r - 8*s**2 + 8*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(32*D1**2*K*fd*r*s + 46*D1**2*K*fd*s**2 - 16*D1**2*K*fdd*r*s - 23*D1**2*K*fdd*s**2 - 8*D1**2*bdd1*f*(3*r*s - r + 3*s**2 - 3*s + 1) - 20*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + 14*D1**2*f*fd*s - 4*D1**2*f*fd + 36*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 36*D1**2*fd**2*r*s + 30*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 4*D1**2*fd*r*s - 8*D1**2*fd*s**2 + 2*D1**2*fdd*r*s + 4*D1**2*fdd*s**2 + 128*D1*Dd*K*f*r*s - 32*D1*Dd*K*f*r + 184*D1*Dd*K*f*s**2 - 156*D1*Dd*K*f*s + 46*D1*Dd*K*f - 128*D1*Dd*K*fd*r*s + 16*D1*Dd*K*fd*r - 184*D1*Dd*K*fd*s**2 + 78*D1*Dd*K*fd*s - 40*D1*Dd*f**2*r*s + 10*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 28*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 288*D1*Dd*f*fd*r*s - 36*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 204*D1*Dd*f*fd*s + 18*D1*Dd*f*fd - 16*D1*Dd*f*r*s + 4*D1*Dd*f*r - 32*D1*Dd*f*s**2 + 24*D1*Dd*f*s - 8*D1*Dd*f + 16*D1*Dd*fd*r*s - 2*D1*Dd*fd*r + 32*D1*Dd*fd*s**2 - 12*D1*Dd*fd*s - 64*D1*Ddd*K*f*r*s + 16*D1*Ddd*K*f*r - 92*D1*Ddd*K*f*s**2 + 78*D1*Ddd*K*f*s - 23*D1*Ddd*K*f + 72*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 66*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 + 8*D1*Ddd*f*r*s - 2*D1*Ddd*f*r + 16*D1*Ddd*f*s**2 - 12*D1*Ddd*f*s + 4*D1*Ddd*f + 8*D1*bd1*(D1*(f*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + fd*(-6*r*s + r - 6*s**2 + 6*s - 1)) + Dd*f*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) - 192*Dd**2*K*f*r*s + 48*Dd**2*K*f*r - 276*Dd**2*K*f*s**2 + 234*Dd**2*K*f*s - 32*Dd**2*K*f + 216*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 198*Dd**2*f**2*s + 36*Dd**2*f**2 + 24*Dd**2*f*r*s - 6*Dd**2*f*r + 48*Dd**2*f*s**2 - 36*Dd**2*f*s + 4*Dd**2*f) + b1*(128*C*D1**2*f*fd*r*s + 184*C*D1**2*f*fd*s**2 - 64*C*D1**2*f*fd*s - 64*C*D1**2*f*fdd*r*s - 92*C*D1**2*f*fdd*s**2 + 32*C*D1**2*f*fdd*s - 64*C*D1**2*fd**2*r*s - 92*C*D1**2*fd**2*s**2 + 32*C*D1**2*fd**2*s + 256*C*D1*Dd*f**2*r*s - 64*C*D1*Dd*f**2*r + 368*C*D1*Dd*f**2*s**2 - 312*C*D1*Dd*f**2*s + 92*C*D1*Dd*f**2 - 512*C*D1*Dd*f*fd*r*s + 64*C*D1*Dd*f*fd*r - 736*C*D1*Dd*f*fd*s**2 + 440*C*D1*Dd*f*fd*s - 32*C*D1*Dd*f*fd - 128*C*D1*Ddd*f**2*r*s + 32*C*D1*Ddd*f**2*r - 184*C*D1*Ddd*f**2*s**2 + 156*C*D1*Ddd*f**2*s - 46*C*D1*Ddd*f**2 - 384*C*Dd**2*f**2*r*s + 96*C*Dd**2*f**2*r - 552*C*Dd**2*f**2*s**2 + 468*C*Dd**2*f**2*s - 64*C*Dd**2*f**2 - 16*D1**2*K*f*fd*r*s + 8*D1**2*K*f*fd*r - 10*D1**2*K*f*fdd*s**2 + 10*D1**2*K*f*fdd*s - 5*D1**2*K*f*fdd - 10*D1**2*K*fd**2*s**2 + 10*D1**2*K*fd**2*s + 24*D1**2*b2*fd*r*s + 24*D1**2*b2*fd*s**2 - 12*D1**2*b2*fdd*r*s - 12*D1**2*b2*fdd*s**2 - 8*D1**2*bd1**2*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 24*D1**2*bd2*f*r*s + 24*D1**2*bd2*f*s**2 - 24*D1**2*bd2*f*s - 24*D1**2*bd2*fd*r*s - 24*D1**2*bd2*fd*s**2 + 12*D1**2*bd2*fd*s + D1**2*bdd1*f*(K*(-32*r*s + 16*r - 46*s**2 + 62*s - 23) + 3*f*(6*r*(2*s - 1) + 10*s**2 - 16*s + 5) + 4*r*s - 2*r + 8*s**2 - 10*s + 4) - 12*D1**2*bdd2*f*r*s - 12*D1**2*bdd2*f*s**2 + 12*D1**2*bdd2*f*s - 68*D1**2*f*fd*r*s - 2*D1**2*f*fd*r - 108*D1**2*f*fd*s**2 + 36*D1**2*f*fd*s + 36*D1**2*f*fdd*r*s + 54*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s - 64*D1**2*f*gd2*r*s - 92*D1**2*f*gd2*s**2 + 64*D1**2*f*gd2*s + 32*D1**2*f*gdd2*r*s + 46*D1**2*f*gdd2*s**2 - 32*D1**2*f*gdd2*s + 36*D1**2*fd**2*r*s + 54*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s - 64*D1**2*fd*g2*r*s - 92*D1**2*fd*g2*s**2 + 64*D1**2*fd*gd2*r*s + 92*D1**2*fd*gd2*s**2 - 32*D1**2*fd*gd2*s + 32*D1**2*fdd*g2*r*s + 46*D1**2*fdd*g2*s**2 - 32*D1*Dd*K*f**2*r*s + 8*D1*Dd*K*f**2*r + 16*D1*Dd*K*f**2*s - 80*D1*Dd*K*f*fd*s**2 + 60*D1*Dd*K*f*fd*s - 10*D1*Dd*K*f*fd + 96*D1*Dd*b2*f*r*s - 24*D1*Dd*b2*f*r + 96*D1*Dd*b2*f*s**2 - 96*D1*Dd*b2*f*s + 24*D1*Dd*b2*f - 96*D1*Dd*b2*fd*r*s + 12*D1*Dd*b2*fd*r - 96*D1*Dd*b2*fd*s**2 + 48*D1*Dd*b2*fd*s - 96*D1*Dd*bd2*f*r*s + 12*D1*Dd*bd2*f*r - 96*D1*Dd*bd2*f*s**2 + 96*D1*Dd*bd2*f*s - 12*D1*Dd*bd2*f - 136*D1*Dd*f**2*r*s + 34*D1*Dd*f**2*r - 216*D1*Dd*f**2*s**2 + 176*D1*Dd*f**2*s - 54*D1*Dd*f**2 + 288*D1*Dd*f*fd*r*s - 36*D1*Dd*f*fd*r + 432*D1*Dd*f*fd*s**2 - 252*D1*Dd*f*fd*s + 18*D1*Dd*f*fd - 256*D1*Dd*f*g2*r*s + 64*D1*Dd*f*g2*r - 368*D1*Dd*f*g2*s**2 + 312*D1*Dd*f*g2*s - 92*D1*Dd*f*g2 + 256*D1*Dd*f*gd2*r*s - 32*D1*Dd*f*gd2*r + 368*D1*Dd*f*gd2*s**2 - 284*D1*Dd*f*gd2*s + 32*D1*Dd*f*gd2 + 256*D1*Dd*fd*g2*r*s - 32*D1*Dd*fd*g2*r + 368*D1*Dd*fd*g2*s**2 - 156*D1*Dd*fd*g2*s - 20*D1*Ddd*K*f**2*s**2 + 10*D1*Ddd*K*f**2*s - 5*D1*Ddd*K*f**2 - 48*D1*Ddd*b2*f*r*s + 12*D1*Ddd*b2*f*r - 48*D1*Ddd*b2*f*s**2 + 48*D1*Ddd*b2*f*s - 12*D1*Ddd*b2*f + 72*D1*Ddd*f**2*r*s - 18*D1*Ddd*f**2*r + 108*D1*Ddd*f**2*s**2 - 90*D1*Ddd*f**2*s + 27*D1*Ddd*f**2 + 128*D1*Ddd*f*g2*r*s - 32*D1*Ddd*f*g2*r + 184*D1*Ddd*f*g2*s**2 - 156*D1*Ddd*f*g2*s + 46*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(f**2*(r*(10*s - 3) + s*(4*s - 7)) + f*(K*(-32*r*s + 16*r - 46*s**2 + 62*s - 23) - 3*fd*(6*r*(4*s - 1) + 20*s**2 - 22*s + 3) + 4*r*s - 2*r + 8*s**2 - 10*s + 4) + fd*(r*(8*K - 1)*(4*s - 1) + s*(K*(46*s - 31) - 8*s + 5))) + Dd*f*(K*(16*r*(8*s - 3) + 184*s**2 - 202*s + 47) - 6*f*(3*r*(8*s - 3) + 20*s**2 - 27*s + 7) - 16*r*s + 6*r - 32*s**2 + 32*s - 7)) - 60*Dd**2*K*f**2*s**2 + 30*Dd**2*K*f**2*s - 144*Dd**2*b2*f*r*s + 36*Dd**2*b2*f*r - 144*Dd**2*b2*f*s**2 + 144*Dd**2*b2*f*s - 24*Dd**2*b2*f + 216*Dd**2*f**2*r*s - 54*Dd**2*f**2*r + 324*Dd**2*f**2*s**2 - 270*Dd**2*f**2*s + 36*Dd**2*f**2 + 384*Dd**2*f*g2*r*s - 96*Dd**2*f*g2*r + 552*Dd**2*f*g2*s**2 - 468*Dd**2*f*g2*s + 64*Dd**2*f*g2))/(42*d**2*k3**4) + D1**2*Pk3*Pkd2*k1**2*k2*(28*D1*b1**3*(D1*fd*s*(r + s - 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*D1*(s - 1)*(7*D1*K*bd1**2*f*s + 14*D1*b2*bd1*f*(r + s - 1) + D1*bdd1*f*(s - 1)*(f*(6*C - 3) - 7*g2) + 2*bd1*(D1*(3*f**2*(8*C*(r + s - 1) - 5*r - 4*s + 4) - f*(fd*s*(6 - 12*C) + 28*g2*(r + s - 1) + 7*gd2*s) - 7*fd*g2*s) + Dd*f*(4*s - 1)*(f*(6*C - 3) - 7*g2))) + 7*b1**2*(4*D1**2*bd1*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + D1**2*s*(8*K*fd*s + K*fdd*s + fd*r*(8*K - 2)) + D1*(2*Dd*(K*fd*s*(4*s - 1) + f*(4*K*(r*(4*s - 1) + (1 - 2*s)**2) - 4*r*s + r + 2*s)) + Ddd*K*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*K*f*s*(2*s - 1)) + b1*(D1**2*(7*K*bdd1*f*(2*s**2 - 2*s + 1) + 14*bd1*(K*fd*s*(2*s - 1) + f*(4*K*(2*s - 1)*(r + s - 1) - 2*r*s + r + s)) + 2*s*(12*C*fd**2*s + 14*bd2*f*(r + s - 1) + f*(6*fd*(8*C*(2*r + 2*s - 1) - 10*r - 8*s + 5) - 56*gd2*(r + s - 1) + s*(12*C*fdd - 6*fdd - 7*gdd2)) - 6*fd**2*s - 56*fd*g2*r - 56*fd*g2*s - 14*fd*gd2*s - 7*fdd*g2*s)) + 28*D1*b2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*D1*(Dd*(6*f**2*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 5*r - 16*s**2 + 18*s - 4) + f*(-56*g2*(r*(4*s - 1) + (1 - 2*s)**2) + (4*s - 1)*(7*K*bd1*(2*s - 1) + s*(24*C*fd - 12*fd - 14*gd2))) + 14*fd*g2*s*(1 - 4*s)) + Ddd*f*(f*(6*C - 3) - 7*g2)*(4*s**2 - 2*s + 1)) + 12*Dd**2*f*s*(2*s - 1)*(f*(6*C - 3) - 7*g2)))/(21*d**2*k3**4) + D1**2*Pk3*Pkd2*k1**2*st**2*(-4*C*D1**2*bd1*f**2*s**2 + 8*C*D1**2*bd1*f**2*s - 4*C*D1**2*bd1*f**2 + 8*C*D1**2*bd1*f*fd*s**2 - 8*C*D1**2*bd1*f*fd*s + 2*C*D1**2*bdd1*f**2*s**2 - 4*C*D1**2*bdd1*f**2*s + 2*C*D1**2*bdd1*f**2 + 48*C*D1**2*f**2*fd*s**2 - 32*C*D1**2*f**2*fd*s + 16*C*D1**2*f**2*fd - 30*C*D1**2*f**2*fdd*s**2 + 20*C*D1**2*f**2*fdd*s - 10*C*D1**2*f**2*fdd - 60*C*D1**2*f*fd**2*s**2 + 40*C*D1**2*f*fd**2*s + 16*C*D1*Dd*bd1*f**2*s**2 - 20*C*D1*Dd*bd1*f**2*s + 4*C*D1*Dd*bd1*f**2 + 64*C*D1*Dd*f**3*s**2 - 32*C*D1*Dd*f**3*s + 16*C*D1*Dd*f**3 - 240*C*D1*Dd*f**2*fd*s**2 + 140*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 40*C*D1*Ddd*f**3*s**2 + 20*C*D1*Ddd*f**3*s - 10*C*D1*Ddd*f**3 - 120*C*Dd**2*f**3*s**2 + 60*C*Dd**2*f**3*s + 2*D1**2*K*bd1**2*f*s**2 - 2*D1**2*K*bd1**2*f*s + 8*D1**2*K*bd1*f**2*s**2 - 20*D1**2*K*bd1*f*fd*s**2 + 10*D1**2*K*bd1*f*fd*s - 5*D1**2*K*bdd1*f**2*s**2 + 24*D1**2*bd1**2*f**2*r*s - 12*D1**2*bd1**2*f**2*r + 20*D1**2*bd1**2*f**2*s**2 - 36*D1**2*bd1**2*f**2*s + 6*D1**2*bd1**2*f**2 + 4*D1**2*bd1**2*f*r*s - 2*D1**2*bd1**2*f*r + 8*D1**2*bd1**2*f*s**2 - 10*D1**2*bd1**2*f*s + 2*D1**2*bd1**2*f + 2*D1**2*bd1*bd2*f*s**2 - 2*D1**2*bd1*bd2*f*s - 2*D1**2*bd1*f**2*r*s + 4*D1**2*bd1*f**2*r - 6*D1**2*bd1*f**2*s**2 + 10*D1**2*bd1*f**2*s - 6*D1**2*bd1*f**2 + 8*D1**2*bd1*f*fd*r*s - 4*D1**2*bd1*f*fd*r + 12*D1**2*bd1*f*fd*s**2 - 14*D1**2*bd1*f*fd*s + 2*D1**2*bd1*f*fd + 4*D1**2*bd1*f*g2*s**2 - 8*D1**2*bd1*f*g2*s + 4*D1**2*bd1*f*g2 - 4*D1**2*bd1*f*gd2*s**2 + 4*D1**2*bd1*f*gd2*s - 4*D1**2*bd1*fd*g2*s**2 + 4*D1**2*bd1*fd*g2*s + 8*D1**2*bd2*f**2*s**2 - 20*D1**2*bd2*f*fd*s**2 + 10*D1**2*bd2*f*fd*s + 2*D1**2*bdd1*f**2*r*s - 2*D1**2*bdd1*f**2*r + 3*D1**2*bdd1*f**2*s**2 - 6*D1**2*bdd1*f**2*s + 3*D1**2*bdd1*f**2 - 2*D1**2*bdd1*f*g2*s**2 + 4*D1**2*bdd1*f*g2*s - 2*D1**2*bdd1*f*g2 - 5*D1**2*bdd2*f**2*s**2 + 6*D1**2*f**2*fd*r*s - 2*D1**2*f**2*fd*r - 24*D1**2*f**2*fd*s**2 + 14*D1**2*f**2*fd*s - 8*D1**2*f**2*fd + 15*D1**2*f**2*fdd*s**2 - 10*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd - 16*D1**2*f**2*gd2*s**2 + 10*D1**2*f**2*gdd2*s**2 + 30*D1**2*f*fd**2*s**2 - 20*D1**2*f*fd**2*s - 32*D1**2*f*fd*g2*s**2 + 32*D1**2*f*fd*g2*s - 16*D1**2*f*fd*g2 + 40*D1**2*f*fd*gd2*s**2 - 20*D1**2*f*fd*gd2*s + 20*D1**2*f*fdd*g2*s**2 - 20*D1**2*f*fdd*g2*s + 10*D1**2*f*fdd*g2 + 20*D1**2*fd**2*g2*s**2 - 20*D1**2*fd**2*g2*s - 40*D1*Dd*K*bd1*f**2*s**2 + 10*D1*Dd*K*bd1*f**2*s + 16*D1*Dd*bd1*f**2*r*s - 10*D1*Dd*bd1*f**2*r + 24*D1*Dd*bd1*f**2*s**2 - 34*D1*Dd*bd1*f**2*s + 10*D1*Dd*bd1*f**2 - 16*D1*Dd*bd1*f*g2*s**2 + 20*D1*Dd*bd1*f*g2*s - 4*D1*Dd*bd1*f*g2 - 40*D1*Dd*bd2*f**2*s**2 + 10*D1*Dd*bd2*f**2*s + 8*D1*Dd*f**3*r*s - 2*D1*Dd*f**3*r - 32*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 8*D1*Dd*f**3 + 120*D1*Dd*f**2*fd*s**2 - 70*D1*Dd*f**2*fd*s + 10*D1*Dd*f**2*fd - 64*D1*Dd*f**2*g2*s**2 + 32*D1*Dd*f**2*g2*s - 16*D1*Dd*f**2*g2 + 80*D1*Dd*f**2*gd2*s**2 - 20*D1*Dd*f**2*gd2*s + 160*D1*Dd*f*fd*g2*s**2 - 120*D1*Dd*f*fd*g2*s + 20*D1*Dd*f*fd*g2 + 20*D1*Ddd*f**3*s**2 - 10*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 40*D1*Ddd*f**2*g2*s**2 - 20*D1*Ddd*f**2*g2*s + 10*D1*Ddd*f**2*g2 + 60*Dd**2*f**3*s**2 - 30*Dd**2*f**3*s + 120*Dd**2*f**2*g2*s**2 - 60*Dd**2*f**2*g2*s + b1**3*(D1**2*s**2*(-2*fd + fdd) - 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1)) + b1**2*(-2*D1**2*K*fd*s**2 + D1**2*K*fdd*s**2 + D1**2*bdd1*f*(3*s**2 - 2*s + 1) - 24*D1**2*f*fd*r*s - 32*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s + 8*D1**2*f*fd + 24*D1**2*f*fdd*r*s + 20*D1**2*f*fdd*s**2 - 8*D1**2*f*fdd*s - 5*D1**2*f*fdd + 24*D1**2*fd**2*r*s + 20*D1**2*fd**2*s**2 - 8*D1**2*fd**2*s - 4*D1**2*fd*r*s - 8*D1**2*fd*s**2 + 2*D1**2*fdd*r*s + 4*D1**2*fdd*s**2 - 8*D1*Dd*K*f*s**2 + 4*D1*Dd*K*f*s - 2*D1*Dd*K*f + 8*D1*Dd*K*fd*s**2 - 2*D1*Dd*K*fd*s - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 64*D1*Dd*f**2*s**2 + 56*D1*Dd*f**2*s - 16*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 160*D1*Dd*f*fd*s**2 - 120*D1*Dd*f*fd*s + 8*D1*Dd*f*fd - 16*D1*Dd*f*r*s + 4*D1*Dd*f*r - 32*D1*Dd*f*s**2 + 24*D1*Dd*f*s - 8*D1*Dd*f + 16*D1*Dd*fd*r*s - 2*D1*Dd*fd*r + 32*D1*Dd*fd*s**2 - 12*D1*Dd*fd*s + 4*D1*Ddd*K*f*s**2 - 2*D1*Ddd*K*f*s + D1*Ddd*K*f + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 44*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 + 8*D1*Ddd*f*r*s - 2*D1*Ddd*f*r + 16*D1*Ddd*f*s**2 - 12*D1*Ddd*f*s + 4*D1*Ddd*f - 2*D1*bd1*(D1*f*(3*s**2 - 2*s + 1) + D1*fd*s*(1 - 3*s) + Dd*f*(-12*s**2 + 7*s - 1)) + 12*Dd**2*K*f*s**2 - 6*Dd**2*K*f*s + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 132*Dd**2*f**2*s + 24*Dd**2*f**2 + 24*Dd**2*f*r*s - 6*Dd**2*f*r + 48*Dd**2*f*s**2 - 36*Dd**2*f*s + 4*Dd**2*f) + b1*(-8*C*D1**2*f*fd*s**2 + 4*C*D1**2*f*fdd*s**2 + 4*C*D1**2*fd**2*s**2 - 16*C*D1*Dd*f**2*s**2 + 8*C*D1*Dd*f**2*s - 4*C*D1*Dd*f**2 + 32*C*D1*Dd*f*fd*s**2 - 8*C*D1*Dd*f*fd*s + 8*C*D1*Ddd*f**2*s**2 - 4*C*D1*Ddd*f**2*s + 2*C*D1*Ddd*f**2 + 24*C*Dd**2*f**2*s**2 - 12*C*Dd**2*f**2*s + 16*D1**2*K*f*fd*s**2 - 16*D1**2*K*f*fd*s + 8*D1**2*K*f*fd - 10*D1**2*K*f*fdd*s**2 + 10*D1**2*K*f*fdd*s - 5*D1**2*K*f*fdd - 10*D1**2*K*fd**2*s**2 + 10*D1**2*K*fd**2*s - 2*D1**2*b2*fd*s**2 + D1**2*b2*fdd*s**2 + 2*D1**2*bd1**2*f*s*(3*s - 2) - 2*D1**2*bd2*f*s**2 + 2*D1**2*bd2*fd*s**2 + D1**2*bdd1*f*(2*K*s**2 - 2*K*s + K + f*(24*r*s - 12*r + 20*s**2 - 36*s + 15) + 4*r*s - 2*r + 8*s**2 - 10*s + 4) + D1**2*bdd2*f*s**2 - 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 + 4*D1**2*f*fd*s + 4*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*s**2 - 2*D1**2*f*fdd*s + 4*D1**2*f*gd2*s**2 - 2*D1**2*f*gdd2*s**2 + 4*D1**2*fd**2*r*s + 6*D1**2*fd**2*s**2 - 2*D1**2*fd**2*s + 4*D1**2*fd*g2*s**2 - 4*D1**2*fd*gd2*s**2 - 2*D1**2*fdd*g2*s**2 + 32*D1*Dd*K*f**2*s**2 - 16*D1*Dd*K*f**2*s + 8*D1*Dd*K*f**2 - 80*D1*Dd*K*f*fd*s**2 + 60*D1*Dd*K*f*fd*s - 10*D1*Dd*K*f*fd - 8*D1*Dd*b2*f*s**2 + 4*D1*Dd*b2*f*s - 2*D1*Dd*b2*f + 8*D1*Dd*b2*fd*s**2 - 2*D1*Dd*b2*fd*s + 8*D1*Dd*bd2*f*s**2 - 2*D1*Dd*bd2*f*s - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 32*D1*Dd*f*fd*r*s - 4*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 28*D1*Dd*f*fd*s + 2*D1*Dd*f*fd + 16*D1*Dd*f*g2*s**2 - 8*D1*Dd*f*g2*s + 4*D1*Dd*f*g2 - 16*D1*Dd*f*gd2*s**2 + 4*D1*Dd*f*gd2*s - 16*D1*Dd*fd*g2*s**2 + 4*D1*Dd*fd*g2*s - 20*D1*Ddd*K*f**2*s**2 + 10*D1*Ddd*K*f**2*s - 5*D1*Ddd*K*f**2 + 4*D1*Ddd*b2*f*s**2 - 2*D1*Ddd*b2*f*s + D1*Ddd*b2*f + 8*D1*Ddd*f**2*r*s - 2*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 10*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 - 8*D1*Ddd*f*g2*s**2 + 4*D1*Ddd*f*g2*s - 2*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(f**2*(6*r*(2*s - 1) + 16*s**2 - 27*s + 12) + f*(2*K*s**2 - 2*K*s + K + fd*(-48*r*s + 12*r - 40*s**2 + 44*s - 9) + 4*r*s - 2*r + 8*s**2 - 10*s + 4) + fd*(-4*r*s + r + s*(-2*K*s + K - 8*s + 5))) - Dd*f*(8*K*s**2 - 6*K*s + K + 2*f*(6*r*(8*s - 3) + 40*s**2 - 58*s + 15) + 16*r*s - 6*r + 32*s**2 - 32*s + 7)) - 60*Dd**2*K*f**2*s**2 + 30*Dd**2*K*f**2*s + 12*Dd**2*b2*f*s**2 - 6*Dd**2*b2*f*s + 24*Dd**2*f**2*r*s - 6*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 30*Dd**2*f**2*s + 4*Dd**2*f**2 - 24*Dd**2*f*g2*s**2 + 12*Dd**2*f*g2*s) + b2*(D1**2*bdd1*f*(s - 1)**2 + 16*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s + 8*D1**2*f*fd - 10*D1**2*f*fdd*s**2 + 10*D1**2*f*fdd*s - 5*D1**2*f*fdd - 10*D1**2*fd**2*s**2 + 10*D1**2*fd**2*s + 32*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 8*D1*Dd*f**2 - 80*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 10*D1*Dd*f*fd - 20*D1*Ddd*f**2*s**2 + 10*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 - 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) - 60*Dd**2*f**2*s**2 + 30*Dd**2*f**2*s))/(42*d**2*k2*k3**2) - D1**2*Pk3*Pkd2*k1**2*(D1*(s - 1)*(7*D1*b2*bdd1*f*(s - 1) + 2*D1*bdd1*f*(s - 1)*(f*(6*C - 3) - 7*g2) + 14*b2*bd1*(D1*fd*s + Dd*f*(4*s - 1)) + 2*bd1*(D1*(-6*f**2*r + f*s*(24*C*fd + 7*K*bd1 + 7*bd2 - 12*fd - 14*gd2) - 14*fd*g2*s) + 2*Dd*f*(4*s - 1)*(f*(6*C - 3) - 7*g2))) + 7*b1**3*(D1**2*fdd*s**2 + 2*D1*Dd*fd*s*(4*s - 1) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1)) + 7*b1**2*(D1**2*K*fdd*s**2 + D1**2*bdd1*f*(3*s**2 - 2*s + 1) - 2*D1**2*fd*r*s + 8*D1*Dd*K*fd*s**2 - 2*D1*Dd*K*fd*s - 8*D1*Dd*f*r*s + 2*D1*Dd*f*r + 4*D1*Dd*f*s + 4*D1*Ddd*K*f*s**2 - 2*D1*Ddd*K*f*s + D1*Ddd*K*f + 2*D1*bd1*(3*s - 1)*(D1*fd*s + Dd*f*(4*s - 1)) + 12*Dd**2*K*f*s**2 - 6*Dd**2*K*f*s) + b1*(D1**2*(7*K*bdd1*f*(2*s**2 - 2*s + 1) + 14*bd1**2*f*s*(3*s - 2) + 14*bd1*(K*fd*s*(2*s - 1) + f*(-2*r*s + r + s)) + s*(f*fd*(12 - 24*r) + f*s*(24*C*fdd + 7*bdd2 - 12*fdd - 14*gdd2) + s*(14*bd2*fd + 2*fd**2*(12*C - 6) - 28*fd*gd2 - 14*fdd*g2))) + 2*D1*(Dd*(7*K*bd1*f*(8*s**2 - 6*s + 1) + 6*f**2*(-4*r*s + r + 2*s) + f*s*(4*s - 1)*(24*C*fd + 7*bd2 - 12*fd - 14*gd2) + 14*fd*g2*s*(1 - 4*s)) + Ddd*f*(f*(6*C - 3) - 7*g2)*(4*s**2 - 2*s + 1)) + 12*Dd**2*f*s*(2*s - 1)*(f*(6*C - 3) - 7*g2) + 7*b2*(D1**2*fdd*s**2 + 2*D1*Dd*fd*s*(4*s - 1) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1))))/(21*d**2*k2*k3**2) - 20*D1**2*Pk3*Pkd2*k2**5*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(2*C - 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(2*C - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 33*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) + 33*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 33*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(4*C - 2)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(33*K*(b1*r*(8*s - 2) + 2*b1*(1 - 2*s)**2 + bd1*(-8*r*s + r - 8*s**2 + 8*s - 1)) - fd*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 132*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 66*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 66*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(2*C*f + 33*K*b1 - f - 66*g2)) - Dd**2*f**2*(2*C*f + 33*K*b1 - f - 66*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(693*d**2*k3**6) + 8*D1**2*Pk3*Pkd2*k2**5*st**4*(-2*D1**2*K*b1**2*fd*r*s - 2*D1**2*K*b1**2*fd*s**2 + D1**2*K*b1**2*fdd*r*s + D1**2*K*b1**2*fdd*s**2 + 2*D1**2*K*b1*f*fd*r*s - D1**2*K*b1*f*fd*r + 2*D1**2*K*b1*f*fd*s**2 - 2*D1**2*K*b1*f*fd*s + D1**2*K*b1*f*fd + D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 4*D1**2*b1*f*gd2*r*s + 4*D1**2*b1*f*gd2*s**2 - 4*D1**2*b1*f*gd2*s - 2*D1**2*b1*f*gdd2*r*s - 2*D1**2*b1*f*gdd2*s**2 + 2*D1**2*b1*f*gdd2*s + 4*D1**2*b1*fd*g2*r*s + 4*D1**2*b1*fd*g2*s**2 - 4*D1**2*b1*fd*gd2*r*s - 4*D1**2*b1*fd*gd2*s**2 + 2*D1**2*b1*fd*gd2*s - 2*D1**2*b1*fdd*g2*r*s - 2*D1**2*b1*fdd*g2*s**2 + D1**2*bdd1*f*(K*b1*(2*s - 1) - 2*g2*(s - 1))*(r + s - 1) - 2*D1**2*f**2*gd2*r*s - 2*D1**2*f**2*gd2*s**2 + 2*D1**2*f**2*gd2*s - 4*D1**2*f*fd*g2*r*s + 2*D1**2*f*fd*g2*r - 4*D1**2*f*fd*g2*s**2 + 4*D1**2*f*fd*g2*s - 2*D1**2*f*fd*g2 - 8*D1*Dd*K*b1**2*f*r*s + 2*D1*Dd*K*b1**2*f*r - 8*D1*Dd*K*b1**2*f*s**2 + 8*D1*Dd*K*b1**2*f*s - 2*D1*Dd*K*b1**2*f + 8*D1*Dd*K*b1**2*fd*r*s - D1*Dd*K*b1**2*fd*r + 8*D1*Dd*K*b1**2*fd*s**2 - 4*D1*Dd*K*b1**2*fd*s + 4*D1*Dd*K*b1*f**2*r*s - D1*Dd*K*b1*f**2*r + 4*D1*Dd*K*b1*f**2*s**2 - 4*D1*Dd*K*b1*f**2*s + D1*Dd*K*b1*f**2 + 16*D1*Dd*b1*f*g2*r*s - 4*D1*Dd*b1*f*g2*r + 16*D1*Dd*b1*f*g2*s**2 - 16*D1*Dd*b1*f*g2*s + 4*D1*Dd*b1*f*g2 - 16*D1*Dd*b1*f*gd2*r*s + 2*D1*Dd*b1*f*gd2*r - 16*D1*Dd*b1*f*gd2*s**2 + 16*D1*Dd*b1*f*gd2*s - 2*D1*Dd*b1*f*gd2 - 16*D1*Dd*b1*fd*g2*r*s + 2*D1*Dd*b1*fd*g2*r - 16*D1*Dd*b1*fd*g2*s**2 + 8*D1*Dd*b1*fd*g2*s - 8*D1*Dd*f**2*g2*r*s + 2*D1*Dd*f**2*g2*r - 8*D1*Dd*f**2*g2*s**2 + 8*D1*Dd*f**2*g2*s - 2*D1*Dd*f**2*g2 + 4*D1*Ddd*K*b1**2*f*r*s - D1*Ddd*K*b1**2*f*r + 4*D1*Ddd*K*b1**2*f*s**2 - 4*D1*Ddd*K*b1**2*f*s + D1*Ddd*K*b1**2*f - 8*D1*Ddd*b1*f*g2*r*s + 2*D1*Ddd*b1*f*g2*r - 8*D1*Ddd*b1*f*g2*s**2 + 8*D1*Ddd*b1*f*g2*s - 2*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(K*f**2*s*(r + s - 1) + 2*f*(2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(r + s - 1) + fd*(K*b1*r*(4*s - 1) + K*b1*s*(4*s - 3) + g2*r*(2 - 4*s) - 4*g2*s*(s - 1))) + Dd*f*(K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - 2*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) + 12*Dd**2*K*b1**2*f*r*s - 3*Dd**2*K*b1**2*f*r + 12*Dd**2*K*b1**2*f*s**2 - 12*Dd**2*K*b1**2*f*s + 2*Dd**2*K*b1**2*f - 24*Dd**2*b1*f*g2*r*s + 6*Dd**2*b1*f*g2*r - 24*Dd**2*b1*f*g2*s**2 + 24*Dd**2*b1*f*g2*s - 4*Dd**2*b1*f*g2)/(7*d**2*k3**6) - 5*D1**2*Pk3*Pkd2*k2**3*st**6*(-96*C*D1**2*f**2*fd*r*s + 32*C*D1**2*f**2*fd*r - 36*C*D1**2*f**2*fd*s**2 + 56*C*D1**2*f**2*fd*s - 12*C*D1**2*f**2*fd + 48*C*D1**2*f**2*fdd*r*s - 16*C*D1**2*f**2*fdd*r + 18*C*D1**2*f**2*fdd*s**2 - 28*C*D1**2*f**2*fdd*s + 6*C*D1**2*f**2*fdd + 96*C*D1**2*f*fd**2*r*s - 32*C*D1**2*f*fd**2*r + 36*C*D1**2*f*fd**2*s**2 - 56*C*D1**2*f*fd**2*s + 16*C*D1**2*f*fd**2 - 128*C*D1*Dd*f**3*r*s + 32*C*D1*Dd*f**3*r - 48*C*D1*Dd*f**3*s**2 + 88*C*D1*Dd*f**3*s - 12*C*D1*Dd*f**3 + 384*C*D1*Dd*f**2*fd*r*s - 112*C*D1*Dd*f**2*fd*r + 144*C*D1*Dd*f**2*fd*s**2 - 244*C*D1*Dd*f**2*fd*s + 60*C*D1*Dd*f**2*fd + 64*C*D1*Ddd*f**3*r*s - 16*C*D1*Ddd*f**3*r + 24*C*D1*Ddd*f**3*s**2 - 44*C*D1*Ddd*f**3*s + 6*C*D1*Ddd*f**3 + 192*C*Dd**2*f**3*r*s - 48*C*Dd**2*f**3*r + 72*C*Dd**2*f**3*s**2 - 132*C*Dd**2*f**3*s + 32*C*Dd**2*f**3 - 1056*D1**2*K*b1*f*fd*r*s + 528*D1**2*K*b1*f*fd*r - 396*D1**2*K*b1*f*fd*s**2 + 396*D1**2*K*b1*f*fd*s - 198*D1**2*K*b1*f*fd + 528*D1**2*K*b1*f*fdd*r*s - 264*D1**2*K*b1*f*fdd*r + 198*D1**2*K*b1*f*fdd*s**2 - 198*D1**2*K*b1*f*fdd*s + 99*D1**2*K*b1*f*fdd + 528*D1**2*K*b1*fd**2*r*s - 264*D1**2*K*b1*fd**2*r + 198*D1**2*K*b1*fd**2*s**2 - 198*D1**2*K*b1*fd**2*s + 264*D1**2*K*bdd1*f**2*r*s + 99*D1**2*K*bdd1*f**2*s**2 - 264*D1**2*K*bdd1*f**2*s + 198*D1**2*b1*f**2*fd*r*s - 66*D1**2*b1*f**2*fd*r - 66*D1**2*b1*f**2*fd*s - 198*D1**2*b1*f**2*fdd*r*s + 66*D1**2*b1*f**2*fdd*r + 66*D1**2*b1*f**2*fdd*s - 396*D1**2*b1*f*fd**2*r*s + 132*D1**2*b1*f*fd**2*r + 132*D1**2*b1*f*fd**2*s - 66*D1**2*b1*f*fd**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r - 264*D1**2*bd2*f**2*r*s - 264*D1**2*bd2*f**2*s**2 + 264*D1**2*bd2*f**2*s + 528*D1**2*bd2*f*fd*r*s - 132*D1**2*bd2*f*fd*r + 528*D1**2*bd2*f*fd*s**2 - 528*D1**2*bd2*f*fd*s + 132*D1**2*bd2*f*fd - 66*D1**2*bdd1*f**3*r*s + 66*D1**2*bdd1*f**3*s - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*s + 132*D1**2*bdd2*f**2*r*s + 132*D1**2*bdd2*f**2*s**2 - 132*D1**2*bdd2*f**2*s + 60*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 32*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 30*D1**2*f**2*fdd*r*s + 10*D1**2*f**2*fdd*r - 9*D1**2*f**2*fdd*s**2 + 16*D1**2*f**2*fdd*s - 3*D1**2*f**2*fdd + 1056*D1**2*f**2*gd2*r*s + 396*D1**2*f**2*gd2*s**2 - 1056*D1**2*f**2*gd2*s - 528*D1**2*f**2*gdd2*r*s - 198*D1**2*f**2*gdd2*s**2 + 528*D1**2*f**2*gdd2*s - 60*D1**2*f*fd**2*r*s + 20*D1**2*f*fd**2*r - 18*D1**2*f*fd**2*s**2 + 32*D1**2*f*fd**2*s - 10*D1**2*f*fd**2 + 2112*D1**2*f*fd*g2*r*s - 1056*D1**2*f*fd*g2*r + 792*D1**2*f*fd*g2*s**2 - 792*D1**2*f*fd*g2*s + 396*D1**2*f*fd*g2 - 2112*D1**2*f*fd*gd2*r*s + 528*D1**2*f*fd*gd2*r - 792*D1**2*f*fd*gd2*s**2 + 1452*D1**2*f*fd*gd2*s - 528*D1**2*f*fd*gd2 - 1056*D1**2*f*fdd*g2*r*s + 528*D1**2*f*fdd*g2*r - 396*D1**2*f*fdd*g2*s**2 + 396*D1**2*f*fdd*g2*s - 198*D1**2*f*fdd*g2 - 1056*D1**2*fd**2*g2*r*s + 528*D1**2*fd**2*g2*r - 396*D1**2*fd**2*g2*s**2 + 396*D1**2*fd**2*g2*s - 2112*D1*Dd*K*b1*f**2*r*s + 528*D1*Dd*K*b1*f**2*r - 792*D1*Dd*K*b1*f**2*s**2 + 1452*D1*Dd*K*b1*f**2*s - 198*D1*Dd*K*b1*f**2 + 4224*D1*Dd*K*b1*f*fd*r*s - 1584*D1*Dd*K*b1*f*fd*r + 1584*D1*Dd*K*b1*f*fd*s**2 - 2244*D1*Dd*K*b1*f*fd*s + 726*D1*Dd*K*b1*f*fd + 264*D1*Dd*b1*f**3*r*s - 66*D1*Dd*b1*f**3*r - 132*D1*Dd*b1*f**3*s - 1584*D1*Dd*b1*f**2*fd*r*s + 462*D1*Dd*b1*f**2*fd*r + 660*D1*Dd*b1*f**2*fd*s - 198*D1*Dd*b1*f**2*fd + 528*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s - 1056*D1*Dd*b1*f*fd*r*s + 396*D1*Dd*b1*f*fd*r + 264*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd + 1056*D1*Dd*bd2*f**2*r*s - 132*D1*Dd*bd2*f**2*r + 1056*D1*Dd*bd2*f**2*s**2 - 1056*D1*Dd*bd2*f**2*s + 132*D1*Dd*bd2*f**2 + 80*D1*Dd*f**3*r*s - 20*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 52*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 240*D1*Dd*f**2*fd*r*s + 70*D1*Dd*f**2*fd*r - 72*D1*Dd*f**2*fd*s**2 + 142*D1*Dd*f**2*fd*s - 36*D1*Dd*f**2*fd + 4224*D1*Dd*f**2*g2*r*s - 1056*D1*Dd*f**2*g2*r + 1584*D1*Dd*f**2*g2*s**2 - 2904*D1*Dd*f**2*g2*s + 396*D1*Dd*f**2*g2 - 4224*D1*Dd*f**2*gd2*r*s + 528*D1*Dd*f**2*gd2*r - 1584*D1*Dd*f**2*gd2*s**2 + 3564*D1*Dd*f**2*gd2*s - 528*D1*Dd*f**2*gd2 - 8448*D1*Dd*f*fd*g2*r*s + 3168*D1*Dd*f*fd*g2*r - 3168*D1*Dd*f*fd*g2*s**2 + 4488*D1*Dd*f*fd*g2*s - 1452*D1*Dd*f*fd*g2 + 1056*D1*Ddd*K*b1*f**2*r*s - 264*D1*Ddd*K*b1*f**2*r + 396*D1*Ddd*K*b1*f**2*s**2 - 726*D1*Ddd*K*b1*f**2*s + 99*D1*Ddd*K*b1*f**2 - 264*D1*Ddd*b1*f**3*r*s + 66*D1*Ddd*b1*f**3*r + 132*D1*Ddd*b1*f**3*s - 264*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s - 40*D1*Ddd*f**3*r*s + 10*D1*Ddd*f**3*r - 12*D1*Ddd*f**3*s**2 + 26*D1*Ddd*f**3*s - 3*D1*Ddd*f**3 - 2112*D1*Ddd*f**2*g2*r*s + 528*D1*Ddd*f**2*g2*r - 792*D1*Ddd*f**2*g2*s**2 + 1452*D1*Ddd*f**2*g2*s - 198*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(D1*(f*s*(K*(-8*r - 3*s + 8) + f*(r - 1) + 2*r - 2) + fd*(K*(16*r*s - 4*r + 6*s**2 - 11*s + 4) + f*(-6*r*s + r + 4*s - 1) - 4*r*s + r + 2*s - 1)) + Dd*f*(K*(32*r*s - 4*r + 12*s**2 - 27*s + 4) + f*(-8*r*s + r + 6*s - 1) - 8*r*s + r + 6*s - 1)) + 3168*Dd**2*K*b1*f**2*r*s - 792*Dd**2*K*b1*f**2*r + 1188*Dd**2*K*b1*f**2*s**2 - 2178*Dd**2*K*b1*f**2*s + 528*Dd**2*K*b1*f**2 - 792*Dd**2*b1*f**3*r*s + 198*Dd**2*b1*f**3*r + 396*Dd**2*b1*f**3*s - 132*Dd**2*b1*f**3 - 792*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s - 132*Dd**2*b1*f**2 - 120*Dd**2*f**3*r*s + 30*Dd**2*f**3*r - 36*Dd**2*f**3*s**2 + 78*Dd**2*f**3*s - 20*Dd**2*f**3 - 6336*Dd**2*f**2*g2*r*s + 1584*Dd**2*f**2*g2*r - 2376*Dd**2*f**2*g2*s**2 + 4356*Dd**2*f**2*g2*s - 1056*Dd**2*f**2*g2 - 132*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(1386*d**2*k3**4) + D1**2*Pk3*Pkd2*k2**3*st**4*(96*C*D1**2*f**2*fd*r*s - 32*C*D1**2*f**2*fd*r - 32*C*D1**2*f**2*fd*s - 48*C*D1**2*f**2*fdd*r*s + 16*C*D1**2*f**2*fdd*r + 16*C*D1**2*f**2*fdd*s - 96*C*D1**2*f*fd**2*r*s + 32*C*D1**2*f*fd**2*r + 32*C*D1**2*f*fd**2*s - 16*C*D1**2*f*fd**2 + 128*C*D1*Dd*f**3*r*s - 32*C*D1*Dd*f**3*r - 64*C*D1*Dd*f**3*s - 384*C*D1*Dd*f**2*fd*r*s + 112*C*D1*Dd*f**2*fd*r + 160*C*D1*Dd*f**2*fd*s - 48*C*D1*Dd*f**2*fd - 64*C*D1*Ddd*f**3*r*s + 16*C*D1*Ddd*f**3*r + 32*C*D1*Ddd*f**3*s - 192*C*Dd**2*f**3*r*s + 48*C*Dd**2*f**3*r + 96*C*Dd**2*f**3*s - 32*C*Dd**2*f**3 + 264*D1**2*K*b1**2*fd*r*s + 264*D1**2*K*b1**2*fd*r + 198*D1**2*K*b1**2*fd*s**2 + 528*D1**2*K*b1**2*fd*s - 264*D1**2*K*b1**2*fd - 132*D1**2*K*b1**2*fdd*r*s - 132*D1**2*K*b1**2*fdd*r - 99*D1**2*K*b1**2*fdd*s**2 - 264*D1**2*K*b1**2*fdd*s + 132*D1**2*K*b1**2*fdd - 264*D1**2*K*b1*bdd1*f*r*s + 264*D1**2*K*b1*bdd1*f*r - 198*D1**2*K*b1*bdd1*f*s**2 + 594*D1**2*K*b1*bdd1*f*s - 231*D1**2*K*b1*bdd1*f - 264*D1**2*K*b1*f*fd*r*s + 132*D1**2*K*b1*f*fd*r + 264*D1**2*K*b1*f*fd*s**2 - 264*D1**2*K*b1*f*fd*s + 132*D1**2*K*b1*f*fd - 264*D1**2*K*b1*f*fdd*r*s + 132*D1**2*K*b1*f*fdd*r - 594*D1**2*K*b1*f*fdd*s**2 + 594*D1**2*K*b1*f*fdd*s - 297*D1**2*K*b1*f*fdd - 264*D1**2*K*b1*fd**2*r*s + 132*D1**2*K*b1*fd**2*r - 594*D1**2*K*b1*fd**2*s**2 + 594*D1**2*K*b1*fd**2*s - 132*D1**2*K*bdd1*f**2*r*s - 297*D1**2*K*bdd1*f**2*s**2 + 132*D1**2*K*bdd1*f**2*s - 132*D1**2*b1**2*f*fd*r*s + 66*D1**2*b1**2*f*fd*s + 132*D1**2*b1**2*f*fdd*r*s - 66*D1**2*b1**2*f*fdd*s + 132*D1**2*b1**2*fd**2*r*s - 66*D1**2*b1**2*fd**2*s - 132*D1**2*b1**2*fd*r*s + 66*D1**2*b1**2*fdd*r*s + 264*D1**2*b1*bd2*f*r*s + 264*D1**2*b1*bd2*f*s**2 - 264*D1**2*b1*bd2*f*s - 264*D1**2*b1*bd2*fd*r*s - 264*D1**2*b1*bd2*fd*s**2 + 132*D1**2*b1*bd2*fd*s + 132*D1**2*b1*bdd1*f**2*r*s - 66*D1**2*b1*bdd1*f**2*r - 66*D1**2*b1*bdd1*f**2*s + 132*D1**2*b1*bdd1*f*r*s - 66*D1**2*b1*bdd1*f*r - 66*D1**2*b1*bdd1*f*s - 132*D1**2*b1*bdd2*f*r*s - 132*D1**2*b1*bdd2*f*s**2 + 132*D1**2*b1*bdd2*f*s + 132*D1**2*b1*f*fd*r*s - 66*D1**2*b1*f*fd*r - 528*D1**2*b1*f*gd2*r*s - 396*D1**2*b1*f*gd2*s**2 + 528*D1**2*b1*f*gd2*s + 264*D1**2*b1*f*gdd2*r*s + 198*D1**2*b1*f*gdd2*s**2 - 264*D1**2*b1*f*gdd2*s - 528*D1**2*b1*fd*g2*r*s - 528*D1**2*b1*fd*g2*r - 396*D1**2*b1*fd*g2*s**2 - 1056*D1**2*b1*fd*g2*s + 528*D1**2*b1*fd*g2 + 528*D1**2*b1*fd*gd2*r*s + 264*D1**2*b1*fd*gd2*r + 396*D1**2*b1*fd*gd2*s**2 + 264*D1**2*b1*fd*gd2*s - 264*D1**2*b1*fd*gd2 + 264*D1**2*b1*fdd*g2*r*s + 264*D1**2*b1*fdd*g2*r + 198*D1**2*b1*fdd*g2*s**2 + 528*D1**2*b1*fdd*g2*s - 264*D1**2*b1*fdd*g2 + 66*D1**2*bd1**2*f*(K*(-4*r*(s - 1) - 3*s**2 + 9*s - 4) + f*r*(2*s - 1) - f*s + f + 2*r*s - r - s + 1) - 132*D1**2*bd2*f**2*r*s - 132*D1**2*bd2*f**2*s**2 + 132*D1**2*bd2*f**2*s + 264*D1**2*bdd1*f*g2*r*s - 528*D1**2*bdd1*f*g2*r + 198*D1**2*bdd1*f*g2*s**2 - 924*D1**2*bdd1*f*g2*s + 462*D1**2*bdd1*f*g2 - 48*D1**2*f**2*fd*r*s + 16*D1**2*f**2*fd*r + 16*D1**2*f**2*fd*s + 24*D1**2*f**2*fdd*r*s - 8*D1**2*f**2*fdd*r - 8*D1**2*f**2*fdd*s + 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s + 264*D1**2*f**2*gdd2*r*s + 594*D1**2*f**2*gdd2*s**2 - 264*D1**2*f**2*gdd2*s + 48*D1**2*f*fd**2*r*s - 16*D1**2*f*fd**2*r - 16*D1**2*f*fd**2*s + 8*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 1056*D1**2*f*fd*gd2*r*s - 264*D1**2*f*fd*gd2*r + 2376*D1**2*f*fd*gd2*s**2 - 1716*D1**2*f*fd*gd2*s + 264*D1**2*f*fd*gd2 + 528*D1**2*f*fdd*g2*r*s - 264*D1**2*f*fdd*g2*r + 1188*D1**2*f*fdd*g2*s**2 - 1188*D1**2*f*fdd*g2*s + 594*D1**2*f*fdd*g2 + 528*D1**2*fd**2*g2*r*s - 264*D1**2*fd**2*g2*r + 1188*D1**2*fd**2*g2*s**2 - 1188*D1**2*fd**2*g2*s + 1056*D1*Dd*K*b1**2*f*r*s - 264*D1*Dd*K*b1**2*f*r + 792*D1*Dd*K*b1**2*f*s**2 - 924*D1*Dd*K*b1**2*f*s + 198*D1*Dd*K*b1**2*f - 1056*D1*Dd*K*b1**2*fd*r*s - 396*D1*Dd*K*b1**2*fd*r - 792*D1*Dd*K*b1**2*fd*s**2 - 594*D1*Dd*K*b1**2*fd*s + 528*D1*Dd*K*b1**2*fd - 528*D1*Dd*K*b1*f**2*r*s + 132*D1*Dd*K*b1*f**2*r + 528*D1*Dd*K*b1*f**2*s**2 + 132*D1*Dd*K*b1*f**2 - 2112*D1*Dd*K*b1*f*fd*r*s + 792*D1*Dd*K*b1*f*fd*r - 4752*D1*Dd*K*b1*f*fd*s**2 + 4092*D1*Dd*K*b1*f*fd*s - 858*D1*Dd*K*b1*f*fd - 264*D1*Dd*b1**2*f**2*r*s + 66*D1*Dd*b1**2*f**2*r + 132*D1*Dd*b1**2*f**2*s + 1056*D1*Dd*b1**2*f*fd*r*s - 132*D1*Dd*b1**2*f*fd*r - 528*D1*Dd*b1**2*f*fd*s + 66*D1*Dd*b1**2*f*fd - 528*D1*Dd*b1**2*f*r*s + 132*D1*Dd*b1**2*f*r + 264*D1*Dd*b1**2*f*s + 528*D1*Dd*b1**2*fd*r*s - 66*D1*Dd*b1**2*fd*r - 132*D1*Dd*b1**2*fd*s - 1056*D1*Dd*b1*bd2*f*r*s + 132*D1*Dd*b1*bd2*f*r - 1056*D1*Dd*b1*bd2*f*s**2 + 1056*D1*Dd*b1*bd2*f*s - 132*D1*Dd*b1*bd2*f + 264*D1*Dd*b1*f**2*r*s - 66*D1*Dd*b1*f**2*r - 132*D1*Dd*b1*f**2*s - 2112*D1*Dd*b1*f*g2*r*s + 528*D1*Dd*b1*f*g2*r - 1584*D1*Dd*b1*f*g2*s**2 + 1848*D1*Dd*b1*f*g2*s - 396*D1*Dd*b1*f*g2 + 2112*D1*Dd*b1*f*gd2*r*s - 264*D1*Dd*b1*f*gd2*r + 1584*D1*Dd*b1*f*gd2*s**2 - 1980*D1*Dd*b1*f*gd2*s + 264*D1*Dd*b1*f*gd2 + 2112*D1*Dd*b1*fd*g2*r*s + 792*D1*Dd*b1*fd*g2*r + 1584*D1*Dd*b1*fd*g2*s**2 + 1188*D1*Dd*b1*fd*g2*s - 1056*D1*Dd*b1*fd*g2 - 64*D1*Dd*f**3*r*s + 16*D1*Dd*f**3*r + 32*D1*Dd*f**3*s + 192*D1*Dd*f**2*fd*r*s - 56*D1*Dd*f**2*fd*r - 80*D1*Dd*f**2*fd*s + 24*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r*s - 264*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 - 264*D1*Dd*f**2*g2 + 2112*D1*Dd*f**2*gd2*r*s - 264*D1*Dd*f**2*gd2*r + 4752*D1*Dd*f**2*gd2*s**2 - 2772*D1*Dd*f**2*gd2*s + 264*D1*Dd*f**2*gd2 + 4224*D1*Dd*f*fd*g2*r*s - 1584*D1*Dd*f*fd*g2*r + 9504*D1*Dd*f*fd*g2*s**2 - 8184*D1*Dd*f*fd*g2*s + 1716*D1*Dd*f*fd*g2 - 528*D1*Ddd*K*b1**2*f*r*s + 132*D1*Ddd*K*b1**2*f*r - 396*D1*Ddd*K*b1**2*f*s**2 + 462*D1*Ddd*K*b1**2*f*s - 99*D1*Ddd*K*b1**2*f - 528*D1*Ddd*K*b1*f**2*r*s + 132*D1*Ddd*K*b1*f**2*r - 1188*D1*Ddd*K*b1*f**2*s**2 + 858*D1*Ddd*K*b1*f**2*s - 297*D1*Ddd*K*b1*f**2 + 264*D1*Ddd*b1**2*f**2*r*s - 66*D1*Ddd*b1**2*f**2*r - 132*D1*Ddd*b1**2*f**2*s + 264*D1*Ddd*b1**2*f*r*s - 66*D1*Ddd*b1**2*f*r - 132*D1*Ddd*b1**2*f*s + 1056*D1*Ddd*b1*f*g2*r*s - 264*D1*Ddd*b1*f*g2*r + 792*D1*Ddd*b1*f*g2*s**2 - 924*D1*Ddd*b1*f*g2*s + 198*D1*Ddd*b1*f*g2 + 32*D1*Ddd*f**3*r*s - 8*D1*Ddd*f**3*r - 16*D1*Ddd*f**3*s + 1056*D1*Ddd*f**2*g2*r*s - 264*D1*Ddd*f**2*g2*r + 2376*D1*Ddd*f**2*g2*s**2 - 1716*D1*Ddd*f**2*g2*s + 594*D1*Ddd*f**2*g2 - 66*D1*bd1*(2*D1*K*f**2*r*s - 2*D1*K*f**2*s**2 - 2*D1*K*f**2*s + 8*D1*K*f*fd*r*s - 2*D1*K*f*fd*r + 18*D1*K*f*fd*s**2 - 13*D1*K*f*fd*s + 2*D1*K*f*fd + 2*D1*bd2*f*(2*s - 1)*(r + s - 1) - D1*f**2*r*s + D1*f**2*s + 8*D1*f*g2*r*s - 16*D1*f*g2*r + 6*D1*f*g2*s**2 - 28*D1*f*g2*s + 14*D1*f*g2 - 8*D1*f*gd2*r*s + 8*D1*f*gd2*r - 6*D1*f*gd2*s**2 + 18*D1*f*gd2*s - 8*D1*f*gd2 - 8*D1*fd*g2*r*s + 4*D1*fd*g2*r - 6*D1*fd*g2*s**2 + 6*D1*fd*g2*s + 16*Dd*K*f**2*r*s - 2*Dd*K*f**2*r + 36*Dd*K*f**2*s**2 - 21*Dd*K*f**2*s + 2*Dd*K*f**2 - 32*Dd*f*g2*r*s + 36*Dd*f*g2*r - 24*Dd*f*g2*s**2 + 70*Dd*f*g2*s - 30*Dd*f*g2 - b1*(D1*(f**2*(-2*r*s + r + s) + f*(K*(8*r*(s - 1) + 6*s**2 - 18*s + 7) + fd*(2*r - 1)*(4*s - 1) - 4*r*s + 2*r + 2*s) - fd*(K*(6*s**2 + s*(8*r - 1) - 2) - 4*r*s + r + s)) + Dd*f*(K*(-32*r*s + 20*r - 24*s**2 + 50*s - 17) + f*(2*r - 1)*(8*s - 3) + (2*r - 1)*(8*s - 3)))) - 1584*Dd**2*K*b1**2*f*r*s + 396*Dd**2*K*b1**2*f*r - 1188*Dd**2*K*b1**2*f*s**2 + 1386*Dd**2*K*b1**2*f*s - 264*Dd**2*K*b1**2*f - 1584*Dd**2*K*b1*f**2*r*s + 396*Dd**2*K*b1*f**2*r - 3564*Dd**2*K*b1*f**2*s**2 + 2574*Dd**2*K*b1*f**2*s - 264*Dd**2*K*b1*f**2 + 792*Dd**2*b1**2*f**2*r*s - 198*Dd**2*b1**2*f**2*r - 396*Dd**2*b1**2*f**2*s + 132*Dd**2*b1**2*f**2 + 792*Dd**2*b1**2*f*r*s - 198*Dd**2*b1**2*f*r - 396*Dd**2*b1**2*f*s + 132*Dd**2*b1**2*f + 3168*Dd**2*b1*f*g2*r*s - 792*Dd**2*b1*f*g2*r + 2376*Dd**2*b1*f*g2*s**2 - 2772*Dd**2*b1*f*g2*s + 528*Dd**2*b1*f*g2 + 96*Dd**2*f**3*r*s - 24*Dd**2*f**3*r - 48*Dd**2*f**3*s + 16*Dd**2*f**3 + 3168*Dd**2*f**2*g2*r*s - 792*Dd**2*f**2*g2*r + 7128*Dd**2*f**2*g2*s**2 - 5148*Dd**2*f**2*g2*s + 528*Dd**2*f**2*g2 + 132*b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(231*d**2*k3**4) + D1**2*Pk3*Pkd2*k2**3*st**2*(D1*(-28*D1*b2*bd1*f*(s - 1)*(r + s - 1) - 2*D1*bd1**2*(7*K*f*(r*(4*s - 2) + 5*s**2 - 7*s + 2) + f*(4*C - 2)*(r*(2*s - 1) + s*(2*s - 2)) + 28*g2*r*(2*s - 1) + 56*g2*s*(s - 1)) + D1*bdd1*f*(s - 1)*(f*(2*C - 1) + 14*g2)*(4*r + 5*s - 5) + 2*bd1*(D1*(f**2*(4*C*(2*r*s - 3*r - 2*s + 1) - 5*r*s + 7*r + 4*s - 2) + 2*f*(fd*(2*C - 1)*(r*(4*s - 2) + 5*s**2 - 6*s + 1) - 14*g2*(r + 2*s - 1) - 7*gd2*(-4*r*s + 2*r - 5*s**2 + 7*s - 2)) + 14*fd*g2*(r*(4*s - 2) + s*(5*s - 5))) + Dd*f*(f*(2*C - 1) + 14*g2)*(2*r*(8*s - 5) + 20*s**2 - 29*s + 9))) - 28*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(D1**2*(16*C*fd*r*s + 16*C*fd*s**2 - 16*C*fd*s - 8*C*fdd*r*s - 8*C*fdd*s**2 + 8*C*fdd*s - 56*K*bd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 28*K*bdd1*(3*r*s - r + 3*s**2 - 3*s + 1) - 28*K*fd*r - 56*K*fd*s + 28*K*fd - 28*K*fdd*r*s - 35*K*fdd*s**2 + 6*fd*r*s - 8*fd*s**2 + 8*fd*s + 4*fdd*r*s + 4*fdd*s**2 - 4*fdd*s + 112*gd2*r*s + 112*gd2*s**2 - 112*gd2*s - 56*gdd2*r*s - 56*gdd2*s**2 + 56*gdd2*s) + D1*(2*Dd*(14*K*bd1*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + f*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) + 3*r*(4*s - 1) - 16*s**2 + 2*s - 4) + fd*(-4*C*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 140*K*s**2 + 63*K*s - r*(14*K - 2)*(8*s - 1) + 16*s**2 - 16*s + 2) + 56*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 28*gd2*(8*r*s - r + 8*s**2 - 8*s + 1)) - Ddd*(f*(8*C*(r*(4*s - 1) + (1 - 2*s)**2) + 7*K*(4*r*(4*s - 1) + 20*s**2 - 18*s + 5) - 4*r*(4*s - 1) - 4*(1 - 2*s)**2) + 56*g2*(r*(4*s - 1) + (1 - 2*s)**2))) - 2*Dd**2*(f*(4*C*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 7*K*(24*r*s - 6*r + 30*s**2 - 27*s + 4) - 24*r*s + 6*r - 24*s**2 + 24*s - 4) + 28*g2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))) + b1*(32*C*D1**2*f*fd*r*s + 8*C*D1**2*f*fd*r - 8*C*D1**2*f*fd + 16*C*D1**2*f*fdd*r*s + 20*C*D1**2*f*fdd*s**2 - 8*C*D1**2*f*fdd*s + 16*C*D1**2*fd**2*r*s + 20*C*D1**2*fd**2*s**2 - 8*C*D1**2*fd**2*s + 64*C*D1*Dd*f**2*r*s - 16*C*D1*Dd*f**2*r - 32*C*D1*Dd*f**2*s + 128*C*D1*Dd*f*fd*r*s - 16*C*D1*Dd*f*fd*r + 160*C*D1*Dd*f*fd*s**2 - 104*C*D1*Dd*f*fd*s + 8*C*D1*Dd*f*fd + 32*C*D1*Ddd*f**2*r*s - 8*C*D1*Ddd*f**2*r + 40*C*D1*Ddd*f**2*s**2 - 36*C*D1*Ddd*f**2*s + 10*C*D1*Ddd*f**2 + 96*C*Dd**2*f**2*r*s - 24*C*Dd**2*f**2*r + 120*C*Dd**2*f**2*s**2 - 108*C*Dd**2*f**2*s + 16*C*Dd**2*f**2 + 28*D1**2*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*s**2 - 28*D1**2*bd2*f*r*s - 28*D1**2*bd2*f*s**2 + 28*D1**2*bd2*f*s - D1**2*bdd1*(f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 7*K*(8*r*s - 4*r + 10*s**2 - 14*s + 5) - 8*r*s + 4*r - 8*s**2 + 8*s - 4) + 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 20*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 2*D1**2*f*fd*s + 4*D1**2*f*fd - 8*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*s**2 + 4*D1**2*f*fdd*s + 56*D1**2*f*gdd2*r*s + 70*D1**2*f*gdd2*s**2 - 56*D1**2*f*gdd2*s - 8*D1**2*fd**2*r*s - 10*D1**2*fd**2*s**2 + 4*D1**2*fd**2*s + 56*D1**2*fd*g2*r + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 + 112*D1**2*fd*gd2*r*s + 140*D1**2*fd*gd2*s**2 - 56*D1**2*fd*gd2*s + 56*D1**2*fdd*g2*r*s + 70*D1**2*fdd*g2*s**2 - 112*D1*Dd*b2*f*r*s + 28*D1*Dd*b2*f*r - 112*D1*Dd*b2*f*s**2 + 112*D1*Dd*b2*f*s - 28*D1*Dd*b2*f - 40*D1*Dd*f**2*r*s + 10*D1*Dd*f**2*r + 20*D1*Dd*f**2*s - 64*D1*Dd*f*fd*r*s + 8*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 52*D1*Dd*f*fd*s - 4*D1*Dd*f*fd + 448*D1*Dd*f*gd2*r*s - 56*D1*Dd*f*gd2*r + 560*D1*Dd*f*gd2*s**2 - 476*D1*Dd*f*gd2*s + 56*D1*Dd*f*gd2 + 448*D1*Dd*fd*g2*r*s - 56*D1*Dd*fd*g2*r + 560*D1*Dd*fd*g2*s**2 - 252*D1*Dd*fd*g2*s - 16*D1*Ddd*f**2*r*s + 4*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 18*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + 224*D1*Ddd*f*g2*r*s - 56*D1*Ddd*f*g2*r + 280*D1*Ddd*f*g2*s**2 - 252*D1*Ddd*f*g2*s + 70*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 14*K*(r + 2*s - 1) + 6*r*s - 3*r - 8*s**2 + s - 4) + fd*(-4*C*(r*(4*s - 1) + (1 - 2*s)**2) - 70*K*s**2 + 49*K*s - r*(14*K - 2)*(4*s - 1) + 8*s**2 - 8*s + 2) + 28*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 28*gd2*(-4*r*s + r - (1 - 2*s)**2)) - Dd*(f*(8*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 7*K*(4*r*(8*s - 3) + 40*s**2 - 46*s + 11) - 4*r*(8*s - 3) - 8*(1 - 2*s)**2) + 56*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 48*Dd**2*f**2*r*s + 12*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 54*Dd**2*f**2*s - 8*Dd**2*f**2 + 672*Dd**2*f*g2*r*s - 168*Dd**2*f*g2*r + 840*Dd**2*f*g2*s**2 - 756*Dd**2*f*g2*s + 112*Dd**2*f*g2))/(42*d**2*k3**4) + 5*D1**2*Pk3*Pkd2*k2*st**6*(60*C*D1**2*f**2*fd*s**2 - 40*C*D1**2*f**2*fd*s + 20*C*D1**2*f**2*fd - 30*C*D1**2*f**2*fdd*s**2 + 20*C*D1**2*f**2*fdd*s - 10*C*D1**2*f**2*fdd - 60*C*D1**2*f*fd**2*s**2 + 40*C*D1**2*f*fd**2*s + 80*C*D1*Dd*f**3*s**2 - 40*C*D1*Dd*f**3*s + 20*C*D1*Dd*f**3 - 240*C*D1*Dd*f**2*fd*s**2 + 140*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 40*C*D1*Ddd*f**3*s**2 + 20*C*D1*Ddd*f**3*s - 10*C*D1*Ddd*f**3 - 120*C*Dd**2*f**3*s**2 + 60*C*Dd**2*f**3*s + 660*D1**2*K*b1*f*fd*s**2 - 660*D1**2*K*b1*f*fd*s + 330*D1**2*K*b1*f*fd - 330*D1**2*K*b1*f*fdd*s**2 + 330*D1**2*K*b1*f*fdd*s - 165*D1**2*K*b1*f*fdd - 330*D1**2*K*b1*fd**2*s**2 + 330*D1**2*K*b1*fd**2*s - 165*D1**2*K*bdd1*f**2*s**2 + 198*D1**2*b1*f**2*fd*r*s - 66*D1**2*b1*f**2*fd*r - 66*D1**2*b1*f**2*fd*s - 198*D1**2*b1*f**2*fdd*r*s + 66*D1**2*b1*f**2*fdd*r + 66*D1**2*b1*f**2*fdd*s - 396*D1**2*b1*f*fd**2*r*s + 132*D1**2*b1*f*fd**2*r + 132*D1**2*b1*f*fd**2*s - 66*D1**2*b1*f*fd**2 + 264*D1**2*b1*f*fd*r*s - 132*D1**2*b1*f*fd*r - 132*D1**2*b1*f*fdd*r*s + 66*D1**2*b1*f*fdd*r - 132*D1**2*b1*fd**2*r*s + 66*D1**2*b1*fd**2*r + 330*D1**2*bd2*f**2*s**2 - 660*D1**2*bd2*f*fd*s**2 + 330*D1**2*bd2*f*fd*s - 66*D1**2*bdd1*f**3*r*s + 66*D1**2*bdd1*f**3*s - 66*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*s - 165*D1**2*bdd2*f**2*s**2 + 12*D1**2*f**2*fd*r*s - 4*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 16*D1**2*f**2*fd*s - 10*D1**2*f**2*fd - 6*D1**2*f**2*fdd*r*s + 2*D1**2*f**2*fdd*r + 15*D1**2*f**2*fdd*s**2 - 8*D1**2*f**2*fdd*s + 5*D1**2*f**2*fdd - 660*D1**2*f**2*gd2*s**2 + 330*D1**2*f**2*gdd2*s**2 - 12*D1**2*f*fd**2*r*s + 4*D1**2*f*fd**2*r + 30*D1**2*f*fd**2*s**2 - 16*D1**2*f*fd**2*s - 2*D1**2*f*fd**2 - 1320*D1**2*f*fd*g2*s**2 + 1320*D1**2*f*fd*g2*s - 660*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*s**2 - 660*D1**2*f*fd*gd2*s + 660*D1**2*f*fdd*g2*s**2 - 660*D1**2*f*fdd*g2*s + 330*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*s**2 - 660*D1**2*fd**2*g2*s + 1320*D1*Dd*K*b1*f**2*s**2 - 660*D1*Dd*K*b1*f**2*s + 330*D1*Dd*K*b1*f**2 - 2640*D1*Dd*K*b1*f*fd*s**2 + 1980*D1*Dd*K*b1*f*fd*s - 330*D1*Dd*K*b1*f*fd + 264*D1*Dd*b1*f**3*r*s - 66*D1*Dd*b1*f**3*r - 132*D1*Dd*b1*f**3*s - 1584*D1*Dd*b1*f**2*fd*r*s + 462*D1*Dd*b1*f**2*fd*r + 660*D1*Dd*b1*f**2*fd*s - 198*D1*Dd*b1*f**2*fd + 528*D1*Dd*b1*f**2*r*s - 132*D1*Dd*b1*f**2*r - 264*D1*Dd*b1*f**2*s - 1056*D1*Dd*b1*f*fd*r*s + 396*D1*Dd*b1*f*fd*r + 264*D1*Dd*b1*f*fd*s - 132*D1*Dd*b1*f*fd - 1320*D1*Dd*bd2*f**2*s**2 + 330*D1*Dd*bd2*f**2*s + 16*D1*Dd*f**3*r*s - 4*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 10*D1*Dd*f**3 - 48*D1*Dd*f**2*fd*r*s + 14*D1*Dd*f**2*fd*r + 120*D1*Dd*f**2*fd*s**2 - 50*D1*Dd*f**2*fd*s + 4*D1*Dd*f**2*fd - 2640*D1*Dd*f**2*g2*s**2 + 1320*D1*Dd*f**2*g2*s - 660*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*s**2 - 660*D1*Dd*f**2*gd2*s + 5280*D1*Dd*f*fd*g2*s**2 - 3960*D1*Dd*f*fd*g2*s + 660*D1*Dd*f*fd*g2 - 660*D1*Ddd*K*b1*f**2*s**2 + 330*D1*Ddd*K*b1*f**2*s - 165*D1*Ddd*K*b1*f**2 - 264*D1*Ddd*b1*f**3*r*s + 66*D1*Ddd*b1*f**3*r + 132*D1*Ddd*b1*f**3*s - 264*D1*Ddd*b1*f**2*r*s + 66*D1*Ddd*b1*f**2*r + 132*D1*Ddd*b1*f**2*s - 8*D1*Ddd*f**3*r*s + 2*D1*Ddd*f**3*r + 20*D1*Ddd*f**3*s**2 - 6*D1*Ddd*f**3*s + 5*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*g2*s**2 - 660*D1*Ddd*f**2*g2*s + 330*D1*Ddd*f**2*g2 + 66*D1*bd1*f*(D1*(f*s*(5*K*s + f*(r - 1) + 2*r - 2) + fd*(f*(-6*r*s + r + 4*s - 1) - 4*r*s + r - (2*s - 1)*(5*K*s - 1))) - Dd*f*(20*K*s**2 - 5*K*s + f*r*(8*s - 1) - 6*f*s + f + r*(8*s - 1) - 6*s + 1)) - 1980*Dd**2*K*b1*f**2*s**2 + 990*Dd**2*K*b1*f**2*s - 792*Dd**2*b1*f**3*r*s + 198*Dd**2*b1*f**3*r + 396*Dd**2*b1*f**3*s - 132*Dd**2*b1*f**3 - 792*Dd**2*b1*f**2*r*s + 198*Dd**2*b1*f**2*r + 396*Dd**2*b1*f**2*s - 132*Dd**2*b1*f**2 - 24*Dd**2*f**3*r*s + 6*Dd**2*f**3*r + 60*Dd**2*f**3*s**2 - 18*Dd**2*f**3*s - 4*Dd**2*f**3 + 3960*Dd**2*f**2*g2*s**2 - 1980*Dd**2*f**2*g2*s + 165*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1386*d**2*k3**2) + D1**2*Pk3*Pkd2*k2*st**4*(-96*C*D1**2*f**2*fd*r*s + 32*C*D1**2*f**2*fd*r + 32*C*D1**2*f**2*fd*s + 48*C*D1**2*f**2*fdd*r*s - 16*C*D1**2*f**2*fdd*r - 16*C*D1**2*f**2*fdd*s + 96*C*D1**2*f*fd**2*r*s - 32*C*D1**2*f*fd**2*r - 32*C*D1**2*f*fd**2*s + 16*C*D1**2*f*fd**2 - 128*C*D1*Dd*f**3*r*s + 32*C*D1*Dd*f**3*r + 64*C*D1*Dd*f**3*s + 384*C*D1*Dd*f**2*fd*r*s - 112*C*D1*Dd*f**2*fd*r - 160*C*D1*Dd*f**2*fd*s + 48*C*D1*Dd*f**2*fd + 64*C*D1*Ddd*f**3*r*s - 16*C*D1*Ddd*f**3*r - 32*C*D1*Ddd*f**3*s + 192*C*Dd**2*f**3*r*s - 48*C*Dd**2*f**3*r - 96*C*Dd**2*f**3*s + 32*C*Dd**2*f**3 + 264*D1**2*K*b1**2*fd*r*s - 264*D1**2*K*b1**2*fd*r + 132*D1**2*K*b1**2*fd*s - 66*D1**2*K*b1**2*fd - 132*D1**2*K*b1**2*fdd*r*s + 132*D1**2*K*b1**2*fdd*r - 66*D1**2*K*b1**2*fdd*s + 33*D1**2*K*b1**2*fdd - 264*D1**2*K*b1*bdd1*f*r*s + 198*D1**2*K*b1*bdd1*f*s - 33*D1**2*K*b1*bdd1*f - 264*D1**2*K*b1*f*fd*r*s + 132*D1**2*K*b1*f*fd*r - 792*D1**2*K*b1*f*fd*s**2 + 792*D1**2*K*b1*f*fd*s - 396*D1**2*K*b1*f*fd + 264*D1**2*K*b1*f*fdd*r*s - 132*D1**2*K*b1*f*fdd*r + 594*D1**2*K*b1*f*fdd*s**2 - 594*D1**2*K*b1*f*fdd*s + 297*D1**2*K*b1*f*fdd + 264*D1**2*K*b1*fd**2*r*s - 132*D1**2*K*b1*fd**2*r + 594*D1**2*K*b1*fd**2*s**2 - 594*D1**2*K*b1*fd**2*s + 132*D1**2*K*bdd1*f**2*r*s + 297*D1**2*K*bdd1*f**2*s**2 - 132*D1**2*K*bdd1*f**2*s + 66*D1**2*b1**2*f*fd*r - 66*D1**2*b1**2*f*fdd*r - 66*D1**2*b1**2*fd**2*r + 66*D1**2*b1**2*fd**2 + 132*D1**2*b1**2*fd*r - 66*D1**2*b1**2*fdd*r + 66*D1**2*b1*bd2*f*s**2 - 66*D1**2*b1*bd2*fd*s**2 + 66*D1**2*b1*bdd1*f**2*r + 66*D1**2*b1*bdd1*f*r - 33*D1**2*b1*bdd2*f*s**2 - 132*D1**2*b1*f*fd*r*s + 66*D1**2*b1*f*fd*r - 528*D1**2*b1*f*gd2*r*s + 528*D1**2*b1*f*gd2*s + 264*D1**2*b1*f*gdd2*r*s - 264*D1**2*b1*f*gdd2*s - 528*D1**2*b1*fd*g2*r*s + 528*D1**2*b1*fd*g2*r - 264*D1**2*b1*fd*g2*s + 132*D1**2*b1*fd*g2 + 528*D1**2*b1*fd*gd2*r*s - 264*D1**2*b1*fd*gd2*r - 132*D1**2*b1*fd*gd2*s + 264*D1**2*b1*fd*gd2 + 264*D1**2*b1*fdd*g2*r*s - 264*D1**2*b1*fdd*g2*r + 132*D1**2*b1*fdd*g2*s - 66*D1**2*b1*fdd*g2 + 66*D1**2*bd1**2*f*(-4*K*r*s + 3*K*s + f*(r - 1) + r - 1) - 132*D1**2*bd2*f**2*r*s - 396*D1**2*bd2*f**2*s**2 + 132*D1**2*bd2*f**2*s + 528*D1**2*bd2*f*fd*r*s - 132*D1**2*bd2*f*fd*r + 1188*D1**2*bd2*f*fd*s**2 - 858*D1**2*bd2*f*fd*s + 132*D1**2*bd2*f*fd + 264*D1**2*bdd1*f*g2*r*s - 132*D1**2*bdd1*f*g2*s + 66*D1**2*bdd1*f*g2 + 132*D1**2*bdd2*f**2*r*s + 297*D1**2*bdd2*f**2*s**2 - 132*D1**2*bdd2*f**2*s + 48*D1**2*f**2*fd*r*s - 16*D1**2*f**2*fd*r - 16*D1**2*f**2*fd*s - 24*D1**2*f**2*fdd*r*s + 8*D1**2*f**2*fdd*r + 8*D1**2*f**2*fdd*s + 264*D1**2*f**2*gd2*r*s + 792*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s - 264*D1**2*f**2*gdd2*r*s - 594*D1**2*f**2*gdd2*s**2 + 264*D1**2*f**2*gdd2*s - 48*D1**2*f*fd**2*r*s + 16*D1**2*f*fd**2*r + 16*D1**2*f*fd**2*s - 8*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 1584*D1**2*f*fd*g2*s**2 - 1584*D1**2*f*fd*g2*s + 792*D1**2*f*fd*g2 - 1056*D1**2*f*fd*gd2*r*s + 264*D1**2*f*fd*gd2*r - 2376*D1**2*f*fd*gd2*s**2 + 1716*D1**2*f*fd*gd2*s - 264*D1**2*f*fd*gd2 - 528*D1**2*f*fdd*g2*r*s + 264*D1**2*f*fdd*g2*r - 1188*D1**2*f*fdd*g2*s**2 + 1188*D1**2*f*fdd*g2*s - 594*D1**2*f*fdd*g2 - 528*D1**2*fd**2*g2*r*s + 264*D1**2*fd**2*g2*r - 1188*D1**2*fd**2*g2*s**2 + 1188*D1**2*fd**2*g2*s + 1056*D1*Dd*K*b1**2*f*r*s - 264*D1*Dd*K*b1**2*f*r - 528*D1*Dd*K*b1**2*f*s - 1056*D1*Dd*K*b1**2*fd*r*s + 660*D1*Dd*K*b1**2*fd*r - 198*D1*Dd*K*b1**2*fd - 528*D1*Dd*K*b1*f**2*r*s + 132*D1*Dd*K*b1*f**2*r - 1584*D1*Dd*K*b1*f**2*s**2 + 1056*D1*Dd*K*b1*f**2*s - 396*D1*Dd*K*b1*f**2 + 2112*D1*Dd*K*b1*f*fd*r*s - 792*D1*Dd*K*b1*f*fd*r + 4752*D1*Dd*K*b1*f*fd*s**2 - 4092*D1*Dd*K*b1*f*fd*s + 858*D1*Dd*K*b1*f*fd - 264*D1*Dd*b1**2*f*fd*r + 132*D1*Dd*b1**2*f*fd - 264*D1*Dd*b1**2*fd*r + 132*D1*Dd*b1**2*fd - 264*D1*Dd*b1*bd2*f*s**2 + 66*D1*Dd*b1*bd2*f*s - 264*D1*Dd*b1*f**2*r*s + 66*D1*Dd*b1*f**2*r + 132*D1*Dd*b1*f**2*s - 2112*D1*Dd*b1*f*g2*r*s + 528*D1*Dd*b1*f*g2*r + 1056*D1*Dd*b1*f*g2*s + 2112*D1*Dd*b1*f*gd2*r*s - 264*D1*Dd*b1*f*gd2*r - 1584*D1*Dd*b1*f*gd2*s + 264*D1*Dd*b1*f*gd2 + 2112*D1*Dd*b1*fd*g2*r*s - 1320*D1*Dd*b1*fd*g2*r + 396*D1*Dd*b1*fd*g2 + 1056*D1*Dd*bd2*f**2*r*s - 132*D1*Dd*bd2*f**2*r + 2376*D1*Dd*bd2*f**2*s**2 - 1386*D1*Dd*bd2*f**2*s + 132*D1*Dd*bd2*f**2 + 64*D1*Dd*f**3*r*s - 16*D1*Dd*f**3*r - 32*D1*Dd*f**3*s - 192*D1*Dd*f**2*fd*r*s + 56*D1*Dd*f**2*fd*r + 80*D1*Dd*f**2*fd*s - 24*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r*s - 264*D1*Dd*f**2*g2*r + 3168*D1*Dd*f**2*g2*s**2 - 2112*D1*Dd*f**2*g2*s + 792*D1*Dd*f**2*g2 - 2112*D1*Dd*f**2*gd2*r*s + 264*D1*Dd*f**2*gd2*r - 4752*D1*Dd*f**2*gd2*s**2 + 2772*D1*Dd*f**2*gd2*s - 264*D1*Dd*f**2*gd2 - 4224*D1*Dd*f*fd*g2*r*s + 1584*D1*Dd*f*fd*g2*r - 9504*D1*Dd*f*fd*g2*s**2 + 8184*D1*Dd*f*fd*g2*s - 1716*D1*Dd*f*fd*g2 - 528*D1*Ddd*K*b1**2*f*r*s + 132*D1*Ddd*K*b1**2*f*r + 264*D1*Ddd*K*b1**2*f*s + 528*D1*Ddd*K*b1*f**2*r*s - 132*D1*Ddd*K*b1*f**2*r + 1188*D1*Ddd*K*b1*f**2*s**2 - 858*D1*Ddd*K*b1*f**2*s + 297*D1*Ddd*K*b1*f**2 + 1056*D1*Ddd*b1*f*g2*r*s - 264*D1*Ddd*b1*f*g2*r - 528*D1*Ddd*b1*f*g2*s - 32*D1*Ddd*f**3*r*s + 8*D1*Ddd*f**3*r + 16*D1*Ddd*f**3*s - 1056*D1*Ddd*f**2*g2*r*s + 264*D1*Ddd*f**2*g2*r - 2376*D1*Ddd*f**2*g2*s**2 + 1716*D1*Ddd*f**2*g2*s - 594*D1*Ddd*f**2*g2 - 66*D1*bd1*(D1*(f**2*s*(2*K*(r + 3*s - 1) + r - 1) + f*(K*fd*(r*(2 - 8*s) - 18*s**2 + 13*s - 2) + g2*(s*(8*r - 4) + 2) + s*(bd2*(s - 1) - 8*gd2*r + 6*gd2)) + 4*fd*g2*r*(1 - 2*s)) + Dd*f*(K*f*(r*(2 - 16*s) - 36*s**2 + 21*s - 2) - 2*g2*(2*r - 1)*(8*s - 1)) + b1*(D1*(f*(K*(-8*r*s + 6*s - 1) + r*(f + 2)) + fd*(K*(8*r*s - 4*r - s + 2) + r - 1)) + Dd*f*(K*(32*r*s - 4*r - 20*s + 3) + f*(2 - 4*r) - 4*r + 2))) - 1584*Dd**2*K*b1**2*f*r*s + 396*Dd**2*K*b1**2*f*r + 792*Dd**2*K*b1**2*f*s - 264*Dd**2*K*b1**2*f + 1584*Dd**2*K*b1*f**2*r*s - 396*Dd**2*K*b1*f**2*r + 3564*Dd**2*K*b1*f**2*s**2 - 2574*Dd**2*K*b1*f**2*s + 264*Dd**2*K*b1*f**2 + 3168*Dd**2*b1*f*g2*r*s - 792*Dd**2*b1*f*g2*r - 1584*Dd**2*b1*f*g2*s + 528*Dd**2*b1*f*g2 - 96*Dd**2*f**3*r*s + 24*Dd**2*f**3*r + 48*Dd**2*f**3*s - 16*Dd**2*f**3 - 3168*Dd**2*f**2*g2*r*s + 792*Dd**2*f**2*g2*r - 7128*Dd**2*f**2*g2*s**2 + 5148*Dd**2*f**2*g2*s - 528*Dd**2*f**2*g2 + 33*b2*(2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)**2 - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 24*D1**2*f*fd*s - 12*D1**2*f*fd + 8*D1**2*f*fdd*r*s - 4*D1**2*f*fdd*r + 18*D1**2*f*fdd*s**2 - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd + 8*D1**2*fd**2*r*s - 4*D1**2*fd**2*r + 18*D1**2*fd**2*s**2 - 18*D1**2*fd**2*s + 8*D1*Dd*b1*f*s**2 - 4*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*s**2 + 2*D1*Dd*b1*fd*s - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 32*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 64*D1*Dd*f*fd*r*s - 24*D1*Dd*f*fd*r + 144*D1*Dd*f*fd*s**2 - 124*D1*Dd*f*fd*s + 26*D1*Dd*f*fd - 4*D1*Ddd*b1*f*s**2 + 2*D1*Ddd*b1*f*s - D1*Ddd*b1*f + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r + 36*D1*Ddd*f**2*s**2 - 26*D1*Ddd*f**2*s + 9*D1*Ddd*f**2 + 2*D1*bd1*(s - 1)*(D1*f*(s - 1) - D1*fd*s + Dd*f*(1 - 4*s)) - 12*Dd**2*b1*f*s**2 + 6*Dd**2*b1*f*s + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r + 108*Dd**2*f**2*s**2 - 78*Dd**2*f**2*s + 8*Dd**2*f**2))/(231*d**2*k3**2) + D1**2*Pk3*Pkd2*k2*st**2*(D1*(2*D1*bd1**2*(f*(7*K*(r*(4*s - 2) - 7*s + 2) + r*(4*C - 3)*(2*s - 1) + s*(6*C - 3)*(s - 1)) + 14*g2*(r*(4*s - 2) + s*(3*s - 3))) - D1*bdd1*f*(f*(2*C - 1) + 14*g2)*(4*r*(s - 1) - 10*s + 5) + 7*b2*(D1*bdd1*f*(s - 1)*(4*r + 5*s - 5) - 2*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*r*(2 - 4*s) - 5*fd*s*(s - 1)) + Dd*f*(-2*r*(8*s - 5) - 20*s**2 + 29*s - 9))) + 2*bd1*(7*D1*bd2*f*(r*(4*s - 2) + 5*s**2 - 7*s + 2) + D1*(f**2*(4*C*(r - 2*s + 1) - 3*r + 4*s - 2) + f*(-fd*(2*C - 1)*(r*(8*s - 4) - 7*s + 2) + 28*g2*(r - 1)*(2*s - 1) + 14*gd2*(-4*r*s + 2*r + 7*s - 2)) + 28*fd*g2*r*(1 - 2*s)) - Dd*f*(f*(2*C - 1) + 14*g2)*(2*r*(8*s - 5) - 24*s + 9))) + 7*b1**3*(2*D1*Dd*(K*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) + fd*r*(8*s - 1) - 6*fd*s + fd - (f + 2)*(r*(4*s - 1) - 2*s)) - D1*(2*D1*s*(fd - fdd)*(r - 1) + Ddd*K*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) - 2*Ddd*(f + 1)*(r*(4*s - 1) - 2*s)) + 2*Dd**2*(K*(-24*r*s + 6*r - 18*s**2 + 21*s - 4) + f*(3*r*(4*s - 1) - 6*s + 2) + 12*r*s - 3*r - 6*s + 2)) + b1**2*(-D1**2*(-8*C*fdd*r*s - 6*C*fdd*s**2 + 8*C*fdd*s - 28*K*fdd*r*s - 70*K*fdd*s + 35*K*fdd + 7*bdd1*(K*(4*r*(3*s - 1) + 9*s**2 - 10*s + 3) + (-2*f - 2)*(r*(3*s - 1) - s)) + 2*fd*(14*K*(r + 1)*(2*s - 1) + r*(8*C*s - 6*s + 7) + s*(6*C*s - 8*C - 3*s + 6)) + 6*fdd*r*s + 3*fdd*s**2 - 6*fdd*s + 112*gd2*r*s + 84*gd2*s**2 - 112*gd2*s - 56*gdd2*r*s - 42*gdd2*s**2 + 56*gdd2*s) - 14*D1*bd1*(-D1*(K*(4*r*(3*s - 1) + 9*s**2 - 10*s + 3) + fd*r*(6*s - 1) - 4*fd*s + fd - (f + 2)*(r*(3*s - 1) - s)) + Dd*(K*(48*r*s - 14*r + 36*s**2 - 41*s + 9) + f*(r*(7 - 24*s) + 10*s - 3) - 24*r*s + 7*r + 10*s - 3)) + D1*(-2*Dd*(f*(C*(8*r*(4*s - 1) + 24*s**2 - 28*s + 6) - 56*K*s + r*(28*K - 6)*(4*s - 1) - 12*s**2 + 18*s - 3) + fd*(C*(r*(4 - 32*s) - 24*s**2 + 30*s - 4) - 7*K*(16*r*s - 2*r + 16*s - 5) + 24*r*s - 3*r + 12*s**2 - 21*s + 3) + 14*g2*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3) + 14*gd2*(r*(2 - 16*s) - 12*s**2 + 15*s - 2)) + Ddd*(f*(C*(8*r*(4*s - 1) + 24*s**2 - 28*s + 6) - 56*K*s + r*(28*K - 6)*(4*s - 1) - 12*s**2 + 18*s - 3) + 14*g2*(4*r*(4*s - 1) + 12*s**2 - 14*s + 3))) + 2*Dd**2*(f*(2*C*(6*r*(4*s - 1) + 18*s**2 - 21*s + 4) + 14*K*(12*r*s - 3*r - 6*s + 2) - 36*r*s + 9*r - 18*s**2 + 27*s - 6) + 14*g2*(6*r*(4*s - 1) + 18*s**2 - 21*s + 4))) + b1*(-8*C*D1**2*f*fd*r + 16*C*D1**2*f*fd*s - 8*C*D1**2*f*fd - 16*C*D1**2*f*fdd*r*s - 12*C*D1**2*f*fdd*s + 10*C*D1**2*f*fdd - 16*C*D1**2*fd**2*r*s - 12*C*D1**2*fd**2*s - 128*C*D1*Dd*f*fd*r*s + 16*C*D1*Dd*f*fd*r - 16*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd - 32*C*D1*Ddd*f**2*r*s + 8*C*D1*Ddd*f**2*r + 16*C*D1*Ddd*f**2*s - 96*C*Dd**2*f**2*r*s + 24*C*Dd**2*f**2*r + 48*C*Dd**2*f**2*s - 16*C*Dd**2*f**2 - 28*D1**2*b2*fd*r*s - 28*D1**2*b2*fd*s**2 + 28*D1**2*b2*fdd*r*s + 35*D1**2*b2*fdd*s**2 + 14*D1**2*bd1**2*(K*(r*(4 - 12*s) - 9*s**2 + 10*s - 2) + f*r*(6*s - 2) - 2*f*s + f + 6*r*s - 2*r - 2*s + 1) - 28*D1**2*bd2*f*r*s - 28*D1**2*bd2*f*s**2 + 28*D1**2*bd2*f*s + 56*D1**2*bd2*fd*r*s + 70*D1**2*bd2*fd*s**2 - 28*D1**2*bd2*fd*s + D1**2*bdd1*(f*(2*C*(r*(8*s - 4) + 6*s**2 - 6*s + 3) + 7*K*(8*r*s - 4*r - 14*s + 5) - 12*r*s + 6*r - 6*s**2 + 6*s - 3) + 14*g2*(r*(8*s - 4) + 6*s**2 - 6*s + 3)) + 28*D1**2*bdd2*f*r*s + 35*D1**2*bdd2*f*s**2 - 28*D1**2*bdd2*f*s + 6*D1**2*f*fd*r - 8*D1**2*f*fd*s + 4*D1**2*f*fd + 8*D1**2*f*fdd*r*s + 6*D1**2*f*fdd*s - 5*D1**2*f*fdd + 112*D1**2*f*gd2*r*s - 112*D1**2*f*gd2*s - 56*D1**2*f*gdd2*r*s + 56*D1**2*f*gdd2*s + 8*D1**2*fd**2*r*s + 6*D1**2*fd**2*s + 112*D1**2*fd*g2*r*s - 56*D1**2*fd*g2*r + 112*D1**2*fd*g2*s - 56*D1**2*fd*g2 - 112*D1**2*fd*gd2*r*s - 84*D1**2*fd*gd2*s - 56*D1**2*fdd*g2*r*s - 140*D1**2*fdd*g2*s + 70*D1**2*fdd*g2 - 112*D1*Dd*b2*f*r*s + 28*D1*Dd*b2*f*r - 112*D1*Dd*b2*f*s**2 + 112*D1*Dd*b2*f*s - 28*D1*Dd*b2*f + 224*D1*Dd*b2*fd*r*s - 28*D1*Dd*b2*fd*r + 280*D1*Dd*b2*fd*s**2 - 126*D1*Dd*b2*fd*s + 224*D1*Dd*bd2*f*r*s - 28*D1*Dd*bd2*f*r + 280*D1*Dd*bd2*f*s**2 - 238*D1*Dd*bd2*f*s + 28*D1*Dd*bd2*f + 64*D1*Dd*f*fd*r*s - 8*D1*Dd*f*fd*r + 8*D1*Dd*f*fd*s - 6*D1*Dd*f*fd + 448*D1*Dd*f*g2*r*s - 112*D1*Dd*f*g2*r - 224*D1*Dd*f*g2*s - 448*D1*Dd*f*gd2*r*s + 56*D1*Dd*f*gd2*r + 336*D1*Dd*f*gd2*s - 56*D1*Dd*f*gd2 - 448*D1*Dd*fd*g2*r*s + 56*D1*Dd*fd*g2*r - 448*D1*Dd*fd*g2*s + 140*D1*Dd*fd*g2 + 112*D1*Ddd*b2*f*r*s - 28*D1*Ddd*b2*f*r + 140*D1*Ddd*b2*f*s**2 - 126*D1*Ddd*b2*f*s + 35*D1*Ddd*b2*f + 16*D1*Ddd*f**2*r*s - 4*D1*Ddd*f**2*r - 8*D1*Ddd*f**2*s - 224*D1*Ddd*f*g2*r*s + 56*D1*Ddd*f*g2*r + 112*D1*Ddd*f*g2*s - 2*D1*bd1*(D1*f*(2*C*(r*(8*s - 4) + 6*s**2 - 6*s + 3) + 14*K*(r - 1)*(4*s - 1) - 12*r*s - r - 6*s**2 + 6*s - 3) + D1*fd*(-2*C*(r*(8*s - 2) + 6*s**2 - 7*s + 2) - 21*K*s - r*(14*K - 3)*(4*s - 1) + 6*s**2 - 9*s + 3) + 14*D1*(g2*(r*(8*s - 4) + 6*s**2 - 6*s + 3) + gd2*(r*(2 - 8*s) - 6*s**2 + 7*s - 2)) + Dd*f*(-2*C*(4*r*(8*s - 3) + 24*s**2 - 26*s + 7) - 7*K*(4*r*(8*s - 3) - 36*s + 11) + 6*r*(8*s - 3) + 24*s**2 - 30*s + 9) - 14*Dd*g2*(4*r*(8*s - 3) + 24*s**2 - 26*s + 7)) + 336*Dd**2*b2*f*r*s - 84*Dd**2*b2*f*r + 420*Dd**2*b2*f*s**2 - 378*Dd**2*b2*f*s + 56*Dd**2*b2*f + 48*Dd**2*f**2*r*s - 12*Dd**2*f**2*r - 24*Dd**2*f**2*s + 8*Dd**2*f**2 - 672*Dd**2*f*g2*r*s + 168*Dd**2*f*g2*r + 336*Dd**2*f*g2*s - 112*Dd**2*f*g2))/(42*d**2*k3**2) + D1**2*Pk3*Pkd2*k2*(2*D1**2*bd1**2*f*s*(2*C - 1)*(s - 1) + D1*b1*(D1*bdd1*f*(2*C - 1)*(2*s**2 - 2*s + 1) + 2*bd1*(D1*f*(C*(8*r*s - 4*r + 8*s**2 - 8*s + 4) - 6*r*s + 3*r - 4*s**2 + 4*s - 2) + D1*fd*s*(2*C - 1)*(2*s - 1) + Dd*f*(2*C - 1)*(8*s**2 - 6*s + 1))) + b1**2*(D1**2*s*(fd*(8*C*(r + s - 1) - 6*r - 4*s + 6) + fdd*s*(2*C - 1)) + D1*(2*Dd*(4*C*f*(r*(4*s - 1) + (1 - 2*s)**2) - f*(4*s - 1)*(3*r + 2*s - 2) + fd*s*(2*C - 1)*(4*s - 1)) + Ddd*f*(2*C - 1)*(4*s**2 - 2*s + 1)) + Dd**2*f*s*(12*C - 6)*(2*s - 1)))/(3*d**2*k3**2) + D1**2*Pk3*Pkd2*st**4*(D1*s*(-2*D1*bd1**2*f*(5*K*s + f*(2*r - 1) + 2*r - 1) - 5*D1*bdd1*f*s*(b2 - 2*g2) - 10*bd1*(D1*f*s*(bd2 + 2*g2 - 2*gd2) - 2*D1*fd*g2*(s - 1) + 2*Dd*f*g2*(1 - 4*s) + b2*(-D1*f*s + D1*fd*(s - 1) + Dd*f*(4*s - 1)))) + b1**2*(-2*D1*Dd*(f*(-5*K*(4*s**2 - 2*s + 1) - (f + 2)*(r*(4*s - 1) - 2*s)) + fd*(5*K*(4*s**2 - 5*s + 1) + f*(2*r - 1)*(8*s - 3) + 8*r*s - 5*r - 2*s + 2)) + D1*(D1*(2*fd**2*(-2*r*s + r + s - 1) + 2*fd*(5*K*(s - 1)**2 - f*s + r*(2*f*s - f + 2*s - 2)) + fdd*(-5*K*(s - 1)**2 + 2*f*s + 2*r*(-2*f*s + f - s + 1))) + Ddd*f*(-5*K*(4*s**2 - 2*s + 1) - (2*f + 2)*(r*(4*s - 1) - 2*s))) - 2*Dd**2*f*(30*K*s**2 - 15*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1*(-10*D1**2*K*bdd1*f*s**2 + 10*D1**2*bd2*f*s**2 - 10*D1**2*bd2*fd*s**2 + 10*D1**2*bd2*fd*s - 4*D1**2*bdd1*f**2*r*s + 2*D1**2*bdd1*f**2*s - 4*D1**2*bdd1*f*r*s + 2*D1**2*bdd1*f*s - 5*D1**2*bdd2*f*s**2 - 20*D1**2*f*gd2*s**2 + 10*D1**2*f*gdd2*s**2 - 20*D1**2*fd*g2*s**2 + 40*D1**2*fd*g2*s - 20*D1**2*fd*g2 + 20*D1**2*fd*gd2*s**2 - 20*D1**2*fd*gd2*s + 10*D1**2*fdd*g2*s**2 - 20*D1**2*fdd*g2*s + 10*D1**2*fdd*g2 - 40*D1*Dd*bd2*f*s**2 + 10*D1*Dd*bd2*f*s - 80*D1*Dd*f*g2*s**2 + 40*D1*Dd*f*g2*s - 20*D1*Dd*f*g2 + 80*D1*Dd*f*gd2*s**2 - 20*D1*Dd*f*gd2*s + 80*D1*Dd*fd*g2*s**2 - 100*D1*Dd*fd*g2*s + 20*D1*Dd*fd*g2 + 40*D1*Ddd*f*g2*s**2 - 20*D1*Ddd*f*g2*s + 10*D1*Ddd*f*g2 + 2*D1*bd1*(-D1*(f*s*(-10*K*s - 2*f*r + f - 4*r + 2) + fd*(f*(2*r - 1)*(4*s - 1) + r*(4*s - 2) + (s - 1)*(10*K*s - 1))) - Dd*f*(40*K*s**2 - 10*K*s + f*(2*r - 1)*(8*s - 1) + 2*r*(8*s - 1) - 8*s + 1)) + 120*Dd**2*f*g2*s**2 - 60*Dd**2*f*g2*s + 5*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(7*d**2*k2) + D1**2*Pk3*Pkd2*st**2*(D1*(2*D1*bd1**2*(f*r*(2*s - 1) + f*s*(2*C*(s - 1) + s*(35*K - 1) + 1) + s*(-7*b2 + 14*g2)*(s - 1)) + 5*D1*bdd1*f*s**2*(-2*C*f + 7*b2 + f - 14*g2) + 2*bd1*s*(D1*(f**2*(8*C*s + r - 4*s) - f*fd*(10*C - 5)*(2*s - 1) + 7*f*s*(5*bd2 + 8*g2 - 10*gd2) - 70*fd*g2*(s - 1)) - 5*Dd*f*(4*s - 1)*(f*(2*C - 1) + 14*g2) + 7*b2*(-4*D1*f*s + 5*D1*fd*(s - 1) + 5*Dd*f*(4*s - 1)))) - 7*b1**3*(2*D1*Dd*(K*(-4*s**2 + 2*s - 1) + fd*r*(8*s - 1) - 6*fd*s + fd - (f + 2)*(r*(4*s - 1) - 2*s)) + D1*(-2*D1*s*(fd - fdd)*(r - 1) + Ddd*K*(4*s**2 - 2*s + 1) + 2*Ddd*(f + 1)*(r*(4*s - 1) - 2*s)) + 2*Dd**2*(6*K*s**2 - 3*K*s + f*(3*r*(4*s - 1) - 6*s + 2) + 3*r*(4*s - 1) - 6*s + 2)) + b1**2*(-4*C*D1**2*fd*s**2 + 2*C*D1**2*fdd*s**2 - 16*C*D1*Dd*f*s**2 + 8*C*D1*Dd*f*s - 4*C*D1*Dd*f + 16*C*D1*Dd*fd*s**2 - 4*C*D1*Dd*fd*s + 8*C*D1*Ddd*f*s**2 - 4*C*D1*Ddd*f*s + 2*C*D1*Ddd*f + 24*C*Dd**2*f*s**2 - 12*C*Dd**2*f*s - 21*D1**2*K*bdd1*s**2 + 14*D1**2*K*bdd1*s - 7*D1**2*K*bdd1 - 56*D1**2*K*fd*s**2 + 112*D1**2*K*fd*s - 56*D1**2*K*fd + 35*D1**2*K*fdd*s**2 - 70*D1**2*K*fdd*s + 35*D1**2*K*fdd + 14*D1**2*bd2*s**2 - 42*D1**2*bdd1*f*r*s + 14*D1**2*bdd1*f*r + 14*D1**2*bdd1*f*s - 42*D1**2*bdd1*r*s + 14*D1**2*bdd1*r + 14*D1**2*bdd1*s - 7*D1**2*bdd2*s**2 - 18*D1**2*fd*r*s + 14*D1**2*fd*r + 2*D1**2*fd*s**2 + 4*D1**2*fd*s + 2*D1**2*fdd*r*s - D1**2*fdd*s**2 - 2*D1**2*fdd*s - 28*D1**2*gd2*s**2 + 14*D1**2*gdd2*s**2 - 224*D1*Dd*K*f*s**2 + 112*D1*Dd*K*f*s - 56*D1*Dd*K*f + 280*D1*Dd*K*fd*s**2 - 350*D1*Dd*K*fd*s + 70*D1*Dd*K*fd - 56*D1*Dd*bd2*s**2 + 14*D1*Dd*bd2*s - 72*D1*Dd*f*r*s + 18*D1*Dd*f*r + 8*D1*Dd*f*s**2 + 32*D1*Dd*f*s + 2*D1*Dd*f + 16*D1*Dd*fd*r*s - 2*D1*Dd*fd*r - 8*D1*Dd*fd*s**2 - 10*D1*Dd*fd*s + 2*D1*Dd*fd - 112*D1*Dd*g2*s**2 + 56*D1*Dd*g2*s - 28*D1*Dd*g2 + 112*D1*Dd*gd2*s**2 - 28*D1*Dd*gd2*s + 140*D1*Ddd*K*f*s**2 - 70*D1*Ddd*K*f*s + 35*D1*Ddd*K*f + 8*D1*Ddd*f*r*s - 2*D1*Ddd*f*r - 4*D1*Ddd*f*s**2 - 2*D1*Ddd*f*s - D1*Ddd*f + 56*D1*Ddd*g2*s**2 - 28*D1*Ddd*g2*s + 14*D1*Ddd*g2 + 14*D1*bd1*(D1*(K*(3*s**2 - 2*s + 1) + fd*(-6*r*s + r + 4*s - 1) + (f + 2)*(3*r*s - r - s)) - Dd*(12*K*s**2 - 7*K*s + K + f*(r*(24*s - 7) - 10*s + 3) + 24*r*s - 7*r - 10*s + 3)) + 420*Dd**2*K*f*s**2 - 210*Dd**2*K*f*s + 24*Dd**2*f*r*s - 6*Dd**2*f*r - 12*Dd**2*f*s**2 - 6*Dd**2*f*s + 4*Dd**2*f + 168*Dd**2*g2*s**2 - 84*Dd**2*g2*s + 7*b2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s))) + b1*(4*C*D1**2*bdd1*f*s**2 - 4*C*D1**2*bdd1*f*s + 2*C*D1**2*bdd1*f + 32*C*D1**2*f*fd*s**2 - 32*C*D1**2*f*fd*s + 16*C*D1**2*f*fd - 20*C*D1**2*f*fdd*s**2 + 20*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd - 20*C*D1**2*fd**2*s**2 + 20*C*D1**2*fd**2*s + 64*C*D1*Dd*f**2*s**2 - 32*C*D1*Dd*f**2*s + 16*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*s**2 + 120*C*D1*Dd*f*fd*s - 20*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*s**2 + 20*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*s**2 + 60*C*Dd**2*f**2*s + 70*D1**2*K*bdd1*f*s**2 - 14*D1**2*bd1**2*(3*K*s**2 - 2*K*s + f*r*(6*s - 2) - 2*f*s + f + r*(6*s - 2) - 2*s + 1) - 56*D1**2*bd2*f*s**2 + 70*D1**2*bd2*fd*s**2 - 70*D1**2*bd2*fd*s + 4*D1**2*bdd1*f*r*s - 2*D1**2*bdd1*f*r - 2*D1**2*bdd1*f*s**2 + 2*D1**2*bdd1*f*s - D1**2*bdd1*f + 28*D1**2*bdd1*g2*s**2 - 28*D1**2*bdd1*g2*s + 14*D1**2*bdd1*g2 + 35*D1**2*bdd2*f*s**2 + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r - 16*D1**2*f*fd*s**2 + 14*D1**2*f*fd*s - 8*D1**2*f*fd + 10*D1**2*f*fdd*s**2 - 10*D1**2*f*fdd*s + 5*D1**2*f*fdd + 112*D1**2*f*gd2*s**2 - 70*D1**2*f*gdd2*s**2 + 10*D1**2*fd**2*s**2 - 10*D1**2*fd**2*s + 112*D1**2*fd*g2*s**2 - 224*D1**2*fd*g2*s + 112*D1**2*fd*g2 - 140*D1**2*fd*gd2*s**2 + 140*D1**2*fd*gd2*s - 70*D1**2*fdd*g2*s**2 + 140*D1**2*fdd*g2*s - 70*D1**2*fdd*g2 + 280*D1*Dd*bd2*f*s**2 - 70*D1*Dd*bd2*f*s + 8*D1*Dd*f**2*r*s - 2*D1*Dd*f**2*r - 32*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 8*D1*Dd*f**2 + 80*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 10*D1*Dd*f*fd + 448*D1*Dd*f*g2*s**2 - 224*D1*Dd*f*g2*s + 112*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*s**2 + 140*D1*Dd*f*gd2*s - 560*D1*Dd*fd*g2*s**2 + 700*D1*Dd*fd*g2*s - 140*D1*Dd*fd*g2 + 20*D1*Ddd*f**2*s**2 - 10*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*s**2 + 140*D1*Ddd*f*g2*s - 70*D1*Ddd*f*g2 - 2*D1*bd1*(D1*(f*(C*(4*s**2 - 4*s + 2) + 56*K*s**2 + 2*r*(9*s - 1) - 2*s**2 - 5*s - 1) + fd*(-4*r*s + r + s**2*(-4*C - 70*K + 2) + s*(2*C + 70*K + 1) - 1) + 7*g2*(4*s**2 - 4*s + 2) + s*(7*bd2 - 14*gd2)*(2*s - 1)) - Dd*(f*(2*C*(8*s**2 - 6*s + 1) + 280*K*s**2 - 70*K*s + 16*r*s - 6*r - 8*s**2 + 2*s + 1) + 14*g2*(8*s**2 - 6*s + 1))) + 60*Dd**2*f**2*s**2 - 30*Dd**2*f**2*s - 840*Dd**2*f*g2*s**2 + 420*Dd**2*f*g2*s + 7*b2*(-D1**2*bdd1*(2*s**2 - 2*s + 1) - 8*D1**2*fd*s**2 + 16*D1**2*fd*s - 8*D1**2*fd + 5*D1**2*fdd*s**2 - 10*D1**2*fdd*s + 5*D1**2*fdd - 32*D1*Dd*f*s**2 + 16*D1*Dd*f*s - 8*D1*Dd*f + 40*D1*Dd*fd*s**2 - 50*D1*Dd*fd*s + 10*D1*Dd*fd + 20*D1*Ddd*f*s**2 - 10*D1*Ddd*f*s + 5*D1*Ddd*f + 2*D1*bd1*(D1*(2*s**2 - 2*s + 1) + Dd*(-8*s**2 + 6*s - 1)) + 60*Dd**2*f*s**2 - 30*Dd**2*f*s)))/(42*d**2*k2) + D1**2*Pk3*Pkd2*(2*D1**2*bd1**2*f*s*(-2*C*(s - 1) + s - 1) + D1*b1*(-D1*bdd1*f*(2*C - 1)*(2*s**2 - 2*s + 1) - 2*bd1*(2*s - 1)*(-D1*(f*r + fd*s*(1 - 2*C)) + Dd*f*(2*C - 1)*(4*s - 1))) + b1**2*(D1**2*s*(2*fd*(r - 1) + fdd*s*(1 - 2*C)) + D1*(-2*Dd*(f*(-4*r*s + r + 2*s) + fd*s*(2*C - 1)*(4*s - 1)) - Ddd*f*(2*C - 1)*(4*s**2 - 2*s + 1)) + Dd**2*f*s*(6 - 12*C)*(2*s - 1)))/(3*d**2*k2) - 5*D1**2*Pk3*Pkdd2*ct**8*k1**2*k2**2*(D1**2*(315*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(-1890*fd**2*s*(2*s - 1) + fd*(1456*C - 1456)*(3*s**2 - 2*s + 1) - fdd*(728*C - 728)*(3*s**2 - 2*s + 1) + s**2*(-429*K*bdd1 + 858*bd1*(K - 1) + 429*bdd1 - 1716*gd2 + 858*gdd2)) - 26*f*(fd**2*s*(56*C - 56)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 1716*fd**2*g2*s*(s - 1)) + D1*f*(2*Dd*(315*f**3*(4*s**2 - 2*s + 1) + 7*f**2*(104*C*(4*s**2 - 2*s + 1) - 45*fd*(1 - 4*s)**2 - 416*s**2 + 208*s - 104) - 13*f*(fd*(56*C - 56)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 858*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(315*f**2 + f*(728*C - 728) - 858*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(315*f**2 + f*(728*C - 728) - 858*g2) + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(9009*d**2*k3**4) + 5*D1**2*Pk3*Pkdd2*ct**7*k1*k2**3*(D1**2*(f**3*s**2*(56*bd1 - 28*bdd1) + f**2*(-56*fd*(4*C*(3*s**2 - 2*s + 1) + s**2*(3*bd1 - 9) - s*(bd1 - 6) - 3) + fdd*(112*C - 84)*(3*s**2 - 2*s + 1) + s**2*(66*K*bdd1 - 33*bd1*(4*K - 2) - 33*bdd1 + 264*gd2 - 132*gdd2)) + 2*f*(fd**2*s*(112*C - 84)*(3*s - 2) + 33*fd*(g2*(8*s**2 - 8*s + 4) - s*(2*s - 1)*(-2*K*bd1 + bd1 + 4*gd2)) - 66*fdd*g2*(2*s**2 - 2*s + 1)) - 264*fd**2*g2*s*(s - 1)) - 2*D1*f*(Dd*(28*f**2*(4*C*(4*s**2 - 2*s + 1) + s**2*(4*bd1 - 12) - s*(bd1 - 6) - 3) + f*(fd*(84 - 112*C)*(12*s**2 - 7*s + 1) - 132*g2*(4*s**2 - 2*s + 1) + 33*s*(4*s - 1)*(-2*K*bd1 + bd1 + 4*gd2)) + 132*fd*g2*(8*s**2 - 6*s + 1)) - 2*Ddd*f*(f*(28*C - 21) - 33*g2)*(4*s**2 - 2*s + 1)) + 24*Dd**2*f**2*s*(2*s - 1)*(f*(28*C - 21) - 33*g2) + b1*(D1**2*(28*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-56*fd**2*s*(3*s - 2) - 66*fd*(2*K - 1)*(2*s**2 - 2*s + 1) + 33*fdd*(2*K - 1)*(2*s**2 - 2*s + 1)) + 66*fd**2*s*(2*K - 1)*(s - 1)) + D1*f*(2*Dd*(28*f**2*(4*s**2 - 2*s + 1) - 28*f*fd*(12*s**2 - 7*s + 1) - 33*f*(2*K - 1)*(4*s**2 - 2*s + 1) + 33*fd*(2*K - 1)*(8*s**2 - 6*s + 1)) - Ddd*f*(-66*K + 28*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(-66*K + 28*f + 33)))/(693*d**2*k3**4) - 5*D1**2*Pk3*Pkdd2*ct**7*k1*k2*(b1*(D1**2*(28*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-56*fd**2*s*(3*s - 2) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(28*f**2*(4*s**2 - 2*s + 1) - 28*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(28*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(28*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(56*bd1 - 28*bdd1) + f*(-56*fd*(s**2*(3*bd1 - 3) - s*(bd1 - 2) - 1) - 28*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 28*fd*(2 - 3*s))) - 2*D1*f*(28*Dd*f*(s**2*(4*bd1 - 4) - s*(bd1 - 2) - 1) + Dd*(4*s - 1)*(33*bd1*s + 28*fd*(3*s - 1)) + 14*Ddd*f*(4*s**2 - 2*s + 1)) + 168*Dd**2*f**2*s*(1 - 2*s)))/(693*d**2*k3**2) - 5*D1**2*Pk3*Pkdd2*ct**6*k1**2*k2**2*st**2*(D1**2*(1372*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 3*f**2*(2744*fd**2*s*(2*s - 1) - fd*(1300*C - 1300)*(3*s**2 - 2*s + 1) + fdd*(650*C - 650)*(3*s**2 - 2*s + 1) + s**2*(429*K*bdd1 - 858*bd1*(K - 1) - 429*bdd1 + 1716*gd2 - 858*gdd2)) - 78*f*(fd**2*s*(50*C - 50)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 5148*fd**2*g2*s*(s - 1)) + 2*D1*f*(Dd*(1372*f**3*(4*s**2 - 2*s + 1) + 2*f**2*(975*C*(4*s**2 - 2*s + 1) - 686*fd*(1 - 4*s)**2 - 3900*s**2 + 1950*s - 975) - 39*f*(fd*(50*C - 50)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) + 2574*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(686*f**2 + f*(975*C - 975) - 1287*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*f**2*s*(2*s - 1)*(686*f**2 + f*(975*C - 975) - 1287*g2) + 1287*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(18018*d**2*k3**4) - 5*D1**2*Pk3*Pkdd2*ct**6*k2**4*(D1**2*(f**2*(fd*(112*C - 56)*(3*s**2 - 2*s + 1) - fdd*(56*C - 28)*(3*s**2 - 2*s + 1) + s**2*(66*K*bd1 - 33*K*bdd1 - 132*gd2 + 66*gdd2)) + f*(fd**2*s*(56 - 112*C)*(3*s - 2) + 66*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) + s*(2*s - 1)*(-K*bd1 + 2*gd2)) + 33*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 66*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(56*C - 28)*(4*s**2 - 2*s + 1) - f*fd*(56*C - 28)*(12*s**2 - 7*s + 1) + 33*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) + s*(4*s - 1)*(-K*bd1 + 2*gd2)) + 33*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(56*C*f + 33*K*b1 - 28*f - 66*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(56*C*f + 33*K*b1 - 28*f - 66*g2))/(693*d**2*k3**4) + 5*D1**2*Pk3*Pkdd2*ct**6*k2**2*(D1**2*(f**2*(fd*(112*C - 56)*(3*s**2 - 2*s + 1) - fdd*(56*C - 28)*(3*s**2 - 2*s + 1) + s**2*(66*K*bd1 - 33*K*bdd1 + 66*bd2 - 33*bdd2 - 132*gd2 + 66*gdd2)) + f*(fd**2*s*(56 - 112*C)*(3*s - 2) + 66*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) - s*(2*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 33*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 66*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(56*C - 28)*(4*s**2 - 2*s + 1) - f*fd*(56*C - 28)*(12*s**2 - 7*s + 1) + 33*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) - s*(4*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 33*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(56*C*f + 33*K*b1 - 28*f - 66*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(56*C*f + 33*K*b1 - 28*f - 66*g2) + 33*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(693*d**2*k3**2) + 5*D1**2*Pk3*Pkdd2*ct**5*k1*k2**3*st**2*(D1**2*(f**3*s**2*(70*bd1 - 35*bdd1) + f**2*(-10*fd*(20*C*(3*s**2 - 2*s + 1) + s**2*(21*bd1 - 45) + s*(30 - 7*bd1) - 15) + fdd*(100*C - 75)*(3*s**2 - 2*s + 1) + s**2*(66*K*bdd1 - 33*bd1*(4*K - 2) - 33*bdd1 + 264*gd2 - 132*gdd2)) + 2*f*(fd**2*s*(100*C - 75)*(3*s - 2) + 33*fd*(g2*(8*s**2 - 8*s + 4) - s*(2*s - 1)*(-2*K*bd1 + bd1 + 4*gd2)) - 66*fdd*g2*(2*s**2 - 2*s + 1)) - 264*fd**2*g2*s*(s - 1)) + D1*f*(-2*Dd*(5*f**2*(20*C*(4*s**2 - 2*s + 1) + s**2*(28*bd1 - 60) + s*(30 - 7*bd1) - 15) + f*(fd*(75 - 100*C)*(12*s**2 - 7*s + 1) - 132*g2*(4*s**2 - 2*s + 1) + 33*s*(4*s - 1)*(-2*K*bd1 + bd1 + 4*gd2)) + 132*fd*g2*(8*s**2 - 6*s + 1)) + Ddd*f*(f*(100*C - 75) - 132*g2)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)*(f*(100*C - 75) - 132*g2) + b1*(D1**2*(35*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-70*fd**2*s*(3*s - 2) - 66*fd*(2*K - 1)*(2*s**2 - 2*s + 1) + 33*fdd*(2*K - 1)*(2*s**2 - 2*s + 1)) + 66*fd**2*s*(2*K - 1)*(s - 1)) + D1*f*(2*Dd*(35*f**2*(4*s**2 - 2*s + 1) - 35*f*fd*(12*s**2 - 7*s + 1) - 33*f*(2*K - 1)*(4*s**2 - 2*s + 1) + 33*fd*(2*K - 1)*(8*s**2 - 6*s + 1)) - Ddd*f*(-66*K + 35*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(-66*K + 35*f + 33)))/(462*d**2*k3**4) - 5*D1**2*Pk3*Pkdd2*ct**5*k1*k2*st**2*(b1*(D1**2*(35*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(-70*fd**2*s*(3*s - 2) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(35*f**2*(4*s**2 - 2*s + 1) - 35*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(35*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(35*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(70*bd1 - 35*bdd1) + f*(-10*fd*(s**2*(21*bd1 - 15) + s*(10 - 7*bd1) - 5) - 25*fdd*(3*s**2 - 2*s + 1) + s**2*(66*bd1 - 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + 25*fd*(2 - 3*s))) + D1*f*(-10*Dd*f*(s**2*(28*bd1 - 20) + s*(10 - 7*bd1) - 5) - 2*Dd*(4*s - 1)*(33*bd1*s + 25*fd*(3*s - 1)) - 25*Ddd*f*(4*s**2 - 2*s + 1)) + 150*Dd**2*f**2*s*(1 - 2*s)))/(462*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct**5*k1*(D1*f*s*(2*D1*bd1**2*s*(5*f + 6) + 5*D1*bdd1*f*s + 10*bd1*(-D1*(f*s - 2*fd*s + fd) + Dd*f*(4*s - 1))) + b1**2*(D1**2*(10*fd**2*s*(s - 1) - 2*fd*(5*f*(2*s**2 - 2*s + 1) + 6*(s - 1)**2) + fdd*(5*f*(2*s**2 - 2*s + 1) + 6*(s - 1)**2)) + D1*(-2*Dd*(5*f**2*(4*s**2 - 2*s + 1) - 5*f*fd*(8*s**2 - 6*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 6*fd*(4*s**2 - 5*s + 1)) + Ddd*f*(5*f + 6)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f*s*(5*f + 6)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(-20*bd1 + 10*bdd1) + f*(10*fd*(s**2*(4*bd1 - 2) - s*(2*bd1 - 2) - 1) + 5*fdd*(2*s**2 - 2*s + 1) + s**2*(-24*bd1 + 12*bdd1)) + 2*fd*s*(12*bd1 + 5*fd)*(s - 1)) + D1*f*(2*Dd*(5*f*(s**2*(8*bd1 - 4) - s*(2*bd1 - 2) - 1) + (4*s - 1)*(12*bd1*s + 5*fd*(2*s - 1))) + 5*Ddd*f*(4*s**2 - 2*s + 1)) + 30*Dd**2*f**2*s*(2*s - 1)))/(21*d**2*k2) - 10*D1**2*Pk3*Pkdd2*ct**4*f*k1**2*k2**2*st**4*(D1**2*(70*f**2*(2*fd - fdd)*(4*s**2 - 2*s + 1) - 420*f*fd**2*s*(2*s - 1) + f*fd*(78*C - 78)*(3*s**2 - 2*s + 1) - f*fdd*(39*C - 39)*(3*s**2 - 2*s + 1) - fd**2*s*(78*C - 78)*(3*s - 2)) + D1*f*(2*Dd*(70*f**2*(4*s**2 - 2*s + 1) + f*(39*C*(4*s**2 - 2*s + 1) - 70*fd*(1 - 4*s)**2 - 156*s**2 + 78*s - 39) - fd*(39*C - 39)*(12*s**2 - 7*s + 1)) - Ddd*f*(39*C + 70*f - 39)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(39*C + 70*f - 39))/(3003*d**2*k3**4) - 5*D1**2*Pk3*Pkdd2*ct**4*k2**4*st**2*(D1**2*(f**2*(fd*(100*C - 50)*(3*s**2 - 2*s + 1) - fdd*(50*C - 25)*(3*s**2 - 2*s + 1) + s**2*(66*K*bd1 - 33*K*bdd1 - 132*gd2 + 66*gdd2)) + f*(fd**2*s*(50 - 100*C)*(3*s - 2) + 66*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) + s*(2*s - 1)*(-K*bd1 + 2*gd2)) + 33*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 66*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(50*C - 25)*(4*s**2 - 2*s + 1) - f*fd*(50*C - 25)*(12*s**2 - 7*s + 1) + 33*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) + s*(4*s - 1)*(-K*bd1 + 2*gd2)) + 33*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(50*C*f + 33*K*b1 - 25*f - 66*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(50*C*f + 33*K*b1 - 25*f - 66*g2))/(462*d**2*k3**4) + 5*D1**2*Pk3*Pkdd2*ct**4*k2**2*st**2*(D1**2*(f**2*(fd*(100*C - 50)*(3*s**2 - 2*s + 1) - fdd*(50*C - 25)*(3*s**2 - 2*s + 1) + s**2*(66*K*bd1 - 33*K*bdd1 + 66*bd2 - 33*bdd2 - 132*gd2 + 66*gdd2)) + f*(fd**2*s*(50 - 100*C)*(3*s - 2) + 66*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) - s*(2*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 33*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 66*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(50*C - 25)*(4*s**2 - 2*s + 1) - f*fd*(50*C - 25)*(12*s**2 - 7*s + 1) + 33*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) - s*(4*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 33*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(50*C*f + 33*K*b1 - 25*f - 66*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(50*C*f + 33*K*b1 - 25*f - 66*g2) + 33*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(462*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct**4*(D1*s*(-12*D1*K*bd1**2*f*s + D1*bdd1*f*s*(f*(5 - 10*C) + 12*g2) - 6*b2*(D1*bdd1*f*s + 2*bd1*(-D1*f*s + D1*fd*(s - 1) + Dd*f*(4*s - 1))) - 2*bd1*(D1*(f**2*s*(5 - 10*C) + f*fd*(10*C - 5)*(2*s - 1) + 6*f*s*(bd2 + 2*g2 - 2*gd2) - 12*fd*g2*(s - 1)) + Dd*f*(4*s - 1)*(f*(10*C - 5) - 12*g2))) + 6*K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(D1**2*(f*(fd*(20*C - 10)*(2*s**2 - 2*s + 1) - fdd*(10*C - 5)*(2*s**2 - 2*s + 1) + s**2*(24*K*bd1 - 12*K*bdd1 + 12*bd2 - 6*bdd2 - 24*gd2 + 12*gdd2)) + (2 - 2*s)*(fd**2*s*(10*C - 5) + 6*fd*(2*g2*(s - 1) + s*(2*K*bd1 + bd2 - 2*gd2)) - 6*fdd*g2*(s - 1))) + D1*(2*Dd*(f**2*(10*C - 5)*(4*s**2 - 2*s + 1) - f*fd*(10*C - 5)*(8*s**2 - 6*s + 1) - 6*f*(g2*(8*s**2 - 4*s + 2) + s*(4*s - 1)*(2*K*bd1 + bd2 - 2*gd2)) + 12*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(f*(10*C - 5) - 12*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(f*(10*C - 5) - 12*g2) + 6*b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(21*d**2) + 5*D1**2*Pk3*Pkdd2*ct**3*f*k1*k2**3*st**4*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) + 2*f*fd*(-12*C*(3*s**2 - 2*s + 1) + 7*b1*(3*s**2 - 2*s + 1) - 21*bd1*s**2 + 7*bd1*s + 27*s**2 - 18*s + 9) - f*fdd*(-12*C + 7*b1 + 9)*(3*s**2 - 2*s + 1) - fd**2*s*(3*s - 2)*(-24*C + 14*b1 + 18)) + D1*f*(2*Dd*f*(-12*C*(4*s**2 - 2*s + 1) + 7*b1*(4*s**2 - 2*s + 1) - 28*bd1*s**2 + 7*bd1*s + 36*s**2 - 18*s + 9) - Dd*fd*(-24*C + 14*b1 + 18)*(12*s**2 - 7*s + 1) - Ddd*f*(-12*C + 7*b1 + 9)*(4*s**2 - 2*s + 1)) + Dd**2*f**2*s*(2*s - 1)*(72*C - 42*b1 - 54))/(231*d**2*k3**4) - 5*D1**2*Pk3*Pkdd2*ct**3*f*k1*k2*st**4*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) + 2*f*fd*(7*b1*(3*s**2 - 2*s + 1) + s**2*(9 - 21*bd1) + s*(7*bd1 - 6) + 3) - f*fdd*(7*b1 + 3)*(3*s**2 - 2*s + 1) - fd**2*s*(14*b1 + 6)*(3*s - 2)) + D1*f*(2*Dd*f*(7*b1*(4*s**2 - 2*s + 1) - s**2*(28*bd1 - 12) + s*(7*bd1 - 6) + 3) - Dd*fd*(14*b1 + 6)*(12*s**2 - 7*s + 1) - Ddd*f*(7*b1 + 3)*(4*s**2 - 2*s + 1)) + Dd**2*f**2*s*(-42*b1 - 18)*(2*s - 1))/(231*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct**3*k1*st**2*(D1*f*s*(2*D1*bd1**2*s*(5*f + 3) - 6*D1*bd1*(f*s - 2*fd*s + fd) + 3*D1*bdd1*f*s + 6*Dd*bd1*f*(4*s - 1)) + b1**2*(D1**2*(-10*f*fd*(2*s**2 - 2*s + 1) + 5*f*fdd*(2*s**2 - 2*s + 1) + 10*fd**2*s*(s - 1) - 6*fd*(s - 1)**2 + 3*fdd*(s - 1)**2) + D1*(-2*Dd*(5*f**2*(4*s**2 - 2*s + 1) + f*(-5*fd*(8*s**2 - 6*s + 1) + 12*s**2 - 6*s + 3) - 3*fd*(4*s**2 - 5*s + 1)) + Ddd*f*(5*f + 3)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f*s*(5*f + 3)*(2*s - 1)) + b1*(D1**2*(f**2*s**2*(-20*bd1 + 10*bdd1) + f*(2*fd*(s**2*(20*bd1 - 6) + s*(6 - 10*bd1) - 3) + fdd*(6*s**2 - 6*s + 3) + s**2*(-12*bd1 + 6*bdd1)) + 6*fd*s*(2*bd1 + fd)*(s - 1)) + D1*f*(2*Dd*f*(s**2*(40*bd1 - 12) + s*(6 - 10*bd1) - 3) + 6*Dd*(4*s - 1)*(2*bd1*s + fd*(2*s - 1)) + 3*Ddd*f*(4*s**2 - 2*s + 1)) + 18*Dd**2*f**2*s*(2*s - 1)))/(21*d**2*k2) - D1**2*Pk3*Pkdd2*ct**2*f*k2**4*st**4*(10*C - 5)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k3**4) + D1**2*Pk3*Pkdd2*ct**2*f*k2**2*st**4*(10*C - 5)*(D1**2*(f*(2*fd - fdd)*(3*s**2 - 2*s + 1) + 2*fd**2*s*(2 - 3*s)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 12*fd*s**2 + 7*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(77*d**2*k3**2) + 5*D1**2*Pk3*Pkdd2*ct**2*k1**2*k2**2*st**6*(D1**2*(-84*f**3*(2*fd - fdd)*(4*s**2 - 2*s + 1) + f**2*(504*fd**2*s*(2*s - 1) + fd*(52*C - 52)*(3*s**2 - 2*s + 1) - fdd*(26*C - 26)*(3*s**2 - 2*s + 1) + s**2*(-429*K*bdd1 + 858*bd1*(K - 1) + 429*bdd1 - 1716*gd2 + 858*gdd2)) - 26*f*(fd**2*s*(2*C - 2)*(3*s - 2) + 33*fd*(g2*(4*s**2 - 4*s + 2) + s*(2*s - 1)*(bd1*(K - 1) - 2*gd2)) - 33*fdd*g2*(2*s**2 - 2*s + 1)) + 1716*fd**2*g2*s*(s - 1)) - 2*D1*f*(Dd*(84*f**3*(4*s**2 - 2*s + 1) - 2*f**2*(13*C*(4*s**2 - 2*s + 1) + 42*fd*(1 - 4*s)**2 - 52*s**2 + 26*s - 13) + 13*f*(fd*(2*C - 2)*(12*s**2 - 7*s + 1) + 33*g2*(8*s**2 - 4*s + 2) + 33*s*(4*s - 1)*(bd1*(K - 1) - 2*gd2)) - 858*fd*g2*(8*s**2 - 6*s + 1)) - Ddd*f*(42*f**2 + f*(13 - 13*C) + 429*g2)*(4*s**2 - 2*s + 1)) + 12*Dd**2*f**2*s*(2*s - 1)*(42*f**2 + f*(13 - 13*C) + 429*g2) + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(18018*d**2*k3**4) - D1**2*Pk3*Pkdd2*ct**2*k2**2*(D1**2*bd1*(7*b2*f*(s - 1)**2 - (2*f*(6*C - 3) - 14*g2)*(2*bd1*s*(s - 1) + f*(2*s - 1))) + D1*b1*(24*C*D1*f*fd*s - 12*C*D1*f*fd + 14*D1*K*bd1**2*s*(2 - 3*s) + 7*D1*b2*fd*s**2 + D1*bd1*(f*(24*C*(2*s**2 - 2*s + 1) - 14*K*s + 7*K - 24*s**2 + 24*s - 12) - 28*g2*(2*s**2 - 2*s + 1) - 4*s*(2*s - 1)*(6*C*fd - 3*fd - 7*gd2)) + 7*D1*bd2*f*s**2 - 2*D1*bdd1*(f*(6*C - 3) - 7*g2)*(2*s**2 - 2*s + 1) - 12*D1*f*fd*s + 6*D1*f*fd - 28*D1*fd*g2*s + 14*D1*fd*g2 + 28*Dd*b2*f*s**2 - 14*Dd*b2*f*s + 7*Dd*b2*f - 4*Dd*bd1*(f*(6*C - 3) - 7*g2)*(8*s**2 - 6*s + 1)) + 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + b1**2*(D1**2*(24*C*fd*s**2 - 12*C*fdd*s**2 + 14*K*bd1*(3*s**2 - 2*s + 1) - 7*K*bdd1*(3*s**2 - 2*s + 1) + 14*K*fd*s - 7*K*fd - 12*fd*s**2 + 6*fdd*s**2 - 28*gd2*s**2 + 14*gdd2*s**2) + 2*D1*(Dd*(f*(12*C - 6)*(4*s**2 - 2*s + 1) - 14*g2*(4*s**2 - 2*s + 1) - (4*s - 1)*(7*K*bd1*(3*s - 1) + s*(12*C*fd - 6*fd - 14*gd2))) - Ddd*(f*(6*C - 3) - 7*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*s*(2*s - 1)*(f*(6*C - 3) - 7*g2)))/(21*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct**2*st**2*(D1*s*(-2*D1*K*bd1**2*f*s + D1*bdd1*f*s*(-2*C*f + f + 2*g2) + b2*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*(-4*f*s + f))) - 2*bd1*(D1*(f**2*(-2*C*s + s) + f*fd*(2*C - 1)*(2*s - 1) + f*s*(bd2 + 2*g2 - 2*gd2) - 2*fd*g2*(s - 1)) + Dd*f*(4*s - 1)*(f*(2*C - 1) - 2*g2))) + K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)) + b1*(D1**2*(f*(fd*(4*C - 2)*(2*s**2 - 2*s + 1) - fdd*(2*C - 1)*(2*s**2 - 2*s + 1) + s**2*(4*K*bd1 - 2*K*bdd1 + 2*bd2 - bdd2 - 4*gd2 + 2*gdd2)) + (2 - 2*s)*(fd**2*s*(2*C - 1) + 2*fd*g2*(s - 1) + fd*s*(2*K*bd1 + bd2 - 2*gd2) - fdd*g2*(s - 1))) + D1*(2*Dd*(f**2*(2*C - 1)*(4*s**2 - 2*s + 1) + f*(-fd*(2*C - 1)*(8*s**2 - 6*s + 1) + g2*(-8*s**2 + 4*s - 2) - s*(4*s - 1)*(2*K*bd1 + bd2 - 2*gd2)) + 2*fd*g2*(4*s**2 - 5*s + 1)) - Ddd*f*(f*(2*C - 1) - 2*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f*s*(2*s - 1)*(f*(2*C - 1) - 2*g2) + b2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s))))/(7*d**2) - 5*D1**2*Pk3*Pkdd2*ct*k1*k2**3*st**6*(D1**2*(f**3*s**2*(14*bd1 - 7*bdd1) + f**2*(-2*fd*(4*C*(3*s**2 - 2*s + 1) + s**2*(21*bd1 - 9) + s*(6 - 7*bd1) - 3) + fdd*(4*C - 3)*(3*s**2 - 2*s + 1) + s**2*(66*K*bdd1 - 33*bd1*(4*K - 2) - 33*bdd1 + 264*gd2 - 132*gdd2)) + 2*f*(fd**2*s*(4*C - 3)*(3*s - 2) + 33*fd*(g2*(8*s**2 - 8*s + 4) - s*(2*s - 1)*(-2*K*bd1 + bd1 + 4*gd2)) - 66*fdd*g2*(2*s**2 - 2*s + 1)) - 264*fd**2*g2*s*(s - 1)) + D1*f*(-2*Dd*(f**2*(4*C*(4*s**2 - 2*s + 1) + s**2*(28*bd1 - 12) + s*(6 - 7*bd1) - 3) + f*(-fd*(4*C - 3)*(12*s**2 - 7*s + 1) - 132*g2*(4*s**2 - 2*s + 1) + 33*s*(4*s - 1)*(-2*K*bd1 + bd1 + 4*gd2)) + 132*fd*g2*(8*s**2 - 6*s + 1)) + Ddd*f*(f*(4*C - 3) - 132*g2)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(2*s - 1)*(f*(4*C - 3) - 132*g2) + b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) - 66*fd*(2*K - 1)*(2*s**2 - 2*s + 1) + 33*fdd*(2*K - 1)*(2*s**2 - 2*s + 1)) + 66*fd**2*s*(2*K - 1)*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) - 33*f*(2*K - 1)*(4*s**2 - 2*s + 1) + 33*fd*(2*K - 1)*(8*s**2 - 6*s + 1)) - Ddd*f*(-66*K + 7*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(2*s - 1)*(-66*K + 7*f + 33)))/(1386*d**2*k3**4) + 5*D1**2*Pk3*Pkdd2*ct*k1*k2*st**6*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s**2 - 2*s + 1) + f*(14*fd**2*s*(2 - 3*s) + 66*fd*(2*s**2 - 2*s + 1) - 33*fdd*(2*s**2 - 2*s + 1)) - 66*fd**2*s*(s - 1)) + D1*f*(2*Dd*(7*f**2*(4*s**2 - 2*s + 1) - 7*f*fd*(12*s**2 - 7*s + 1) + 33*f*(4*s**2 - 2*s + 1) - 33*fd*(8*s**2 - 6*s + 1)) - Ddd*f*(7*f + 33)*(4*s**2 - 2*s + 1)) - 6*Dd**2*f**2*s*(7*f + 33)*(2*s - 1)) + f*(D1**2*(f**2*s**2*(14*bd1 - 7*bdd1) - f*(2*fd*(s**2*(21*bd1 - 3) + s*(2 - 7*bd1) - 1) + fdd*(3*s**2 - 2*s + 1) + s**2*(-66*bd1 + 33*bdd1)) + 2*fd*s*(bd1*(33 - 66*s) + fd*(2 - 3*s))) - D1*f*(2*Dd*(f*(s**2*(28*bd1 - 4) + s*(2 - 7*bd1) - 1) + (4*s - 1)*(33*bd1*s + fd*(3*s - 1))) + Ddd*f*(4*s**2 - 2*s + 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1386*d**2*k3**2) + D1**2*Pk3*Pkdd2*ct*k1*st**4*(-2*D1**2*bd1**2*f*s**2 + 2*D1*b1*s*(-D1*bdd1*f*s + 2*bd1*(D1*(f*s - fd*s + fd) + Dd*(-4*f*s + f))) + b1**2*(D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(4*s**2 - 2*s + 1) + fd*(-4*s**2 + 5*s - 1)) + D1*Ddd*f*(-4*s**2 + 2*s - 1) + 6*Dd**2*f*s*(1 - 2*s)))/(7*d**2*k2) + 5*D1**2*Pk3*Pkdd2*f**2*k1**2*k2**2*st**8*(D1**2*(f*(2*fd - fdd)*(4*s**2 - 2*s + 1) + 6*fd**2*s*(1 - 2*s)) + D1*f*(2*Dd*f*(4*s**2 - 2*s + 1) - 2*Dd*fd*(1 - 4*s)**2 + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s))/(1287*d**2*k3**4) + 5*D1**2*Pk3*Pkdd2*k2**4*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(3*s**2 - 2*s + 1) - fdd*(2*C - 1)*(3*s**2 - 2*s + 1) + s**2*(66*K*bd1 - 33*K*bdd1 - 132*gd2 + 66*gdd2)) + f*(2*fd**2*s*(C*(4 - 6*s) + 3*s - 2) + 66*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) + s*(2*s - 1)*(-K*bd1 + 2*gd2)) + 33*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 66*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*s**2 - 2*s + 1) - f*fd*(2*C - 1)*(12*s**2 - 7*s + 1) + 33*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) + s*(4*s - 1)*(-K*bd1 + 2*gd2)) + 33*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(2*C*f + 33*K*b1 - f - 66*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(2*C*f + 33*K*b1 - f - 66*g2))/(1386*d**2*k3**4) - 5*D1**2*Pk3*Pkdd2*k2**2*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(3*s**2 - 2*s + 1) - fdd*(2*C - 1)*(3*s**2 - 2*s + 1) + s**2*(66*K*bd1 - 33*K*bdd1 + 66*bd2 - 33*bdd2 - 132*gd2 + 66*gdd2)) + f*(2*fd**2*s*(C*(4 - 6*s) + 3*s - 2) + 66*fd*(K*b1*(2*s**2 - 2*s + 1) + g2*(-4*s**2 + 4*s - 2) - s*(2*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 33*fdd*(-K*b1 + 2*g2)*(2*s**2 - 2*s + 1)) + 66*fd**2*s*(s - 1)*(-K*b1 + 2*g2)) + D1*f*(2*Dd*(f**2*(2*C - 1)*(4*s**2 - 2*s + 1) - f*fd*(2*C - 1)*(12*s**2 - 7*s + 1) + 33*f*(K*b1*(4*s**2 - 2*s + 1) + g2*(-8*s**2 + 4*s - 2) - s*(4*s - 1)*(K*bd1 + bd2 - 2*gd2)) + 33*fd*(-K*b1 + 2*g2)*(8*s**2 - 6*s + 1)) - Ddd*f*(4*s**2 - 2*s + 1)*(2*C*f + 33*K*b1 - f - 66*g2)) - 6*Dd**2*f**2*s*(2*s - 1)*(2*C*f + 33*K*b1 - f - 66*g2) + 33*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1386*d**2*k3**2) + D1**2*Pk3*Pkdd2*k2**2*st**2*(D1**2*bd1*(7*b2*f*(s - 1)**2 + (f*(2*C - 1) + 14*g2)*(2*bd1*s*(s - 1) + f*(2*s - 1))) + D1*b1*(-4*C*D1*f*fd*s + 2*C*D1*f*fd + 14*D1*K*bd1**2*s*(2 - 3*s) + 7*D1*b2*fd*s**2 + D1*bd1*(f*(C*(-8*s**2 + 8*s - 4) - 14*K*s + 7*K + 4*s**2 - 4*s + 2) - 28*g2*(2*s**2 - 2*s + 1) + s*(2*s - 1)*(4*C*fd - 2*fd + 28*gd2)) + 7*D1*bd2*f*s**2 + D1*bdd1*(f*(2*C - 1) + 14*g2)*(2*s**2 - 2*s + 1) + 2*D1*f*fd*s - D1*f*fd - 28*D1*fd*g2*s + 14*D1*fd*g2 + 28*Dd*b2*f*s**2 - 14*Dd*b2*f*s + 7*Dd*b2*f + 2*Dd*bd1*(f*(2*C - 1) + 14*g2)*(8*s**2 - 6*s + 1)) + 7*K*b1**3*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) - b1**2*(D1**2*(4*C*fd*s**2 - 2*C*fdd*s**2 - 14*K*bd1*(3*s**2 - 2*s + 1) + 7*K*bdd1*(3*s**2 - 2*s + 1) - 14*K*fd*s + 7*K*fd - 2*fd*s**2 + fdd*s**2 + 28*gd2*s**2 - 14*gdd2*s**2) + D1*(2*Dd*(f*(2*C - 1)*(4*s**2 - 2*s + 1) + 14*g2*(4*s**2 - 2*s + 1) + (4*s - 1)*(7*K*bd1*(3*s - 1) + s*(-2*C*fd + fd - 14*gd2))) - Ddd*(f*(2*C - 1) + 14*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*s*(2*s - 1)*(f*(2*C - 1) + 14*g2)))/(42*d**2*k3**2) + D1**2*Pk3*Pkdd2*st**4*(D1*s*(2*D1*K*bd1**2*f*s + D1*b2*bdd1*f*s - 2*D1*bdd1*f*g2*s + 2*b2*bd1*(-D1*f*s + D1*fd*(s - 1) + Dd*f*(4*s - 1)) + 2*bd1*(D1*f*s*(bd2 + 2*g2 - 2*gd2) - 2*D1*fd*g2*(s - 1) + 2*Dd*f*g2*(1 - 4*s))) + K*b1**2*(-D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(-4*s**2 + 2*s - 1) + fd*(4*s**2 - 5*s + 1)) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1)) + b1*(D1**2*(f*s**2*(-4*K*bd1 + 2*K*bdd1 - 2*bd2 + bdd2 + 4*gd2 - 2*gdd2) + 2*fd*(s - 1)*(2*g2*(s - 1) + s*(2*K*bd1 + bd2 - 2*gd2)) - 2*fdd*g2*(s - 1)**2) + 2*D1*(Dd*(f*g2*(8*s**2 - 4*s + 2) + f*s*(4*s - 1)*(2*K*bd1 + bd2 - 2*gd2) - 2*fd*g2*(4*s**2 - 5*s + 1)) + Ddd*f*g2*(-4*s**2 + 2*s - 1)) + 12*Dd**2*f*g2*s*(1 - 2*s) + b2*(-D1**2*(2*fd - fdd)*(s - 1)**2 + 2*D1*Dd*(f*(-4*s**2 + 2*s - 1) + fd*(4*s**2 - 5*s + 1)) + D1*Ddd*f*(4*s**2 - 2*s + 1) + 6*Dd**2*f*s*(2*s - 1))))/(7*d**2) - 5*D1**2*Pk3*ct**7*k1*k2*(-82368*C*D1**2*Pk2*f**2*fd*r*s + 27456*C*D1**2*Pk2*f**2*fd*r + 69888*C*D1**2*Pk2*f**2*fd*s**2 - 19136*C*D1**2*Pk2*f**2*fd*s + 23296*C*D1**2*Pk2*f**2*fd + 41184*C*D1**2*Pk2*f**2*fdd*r*s - 13728*C*D1**2*Pk2*f**2*fdd*r - 34944*C*D1**2*Pk2*f**2*fdd*s**2 + 9568*C*D1**2*Pk2*f**2*fdd*s - 11648*C*D1**2*Pk2*f**2*fdd + 82368*C*D1**2*Pk2*f*fd**2*r*s - 27456*C*D1**2*Pk2*f*fd**2*r - 69888*C*D1**2*Pk2*f*fd**2*s**2 + 19136*C*D1**2*Pk2*f*fd**2*s + 13728*C*D1**2*Pk2*f*fd**2 + 8736*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 5824*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 2912*C*D1**2*Pkdd2*f**2*fd*k1**2 - 4368*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 2912*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 1456*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 8736*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 5824*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 109824*C*D1*Dd*Pk2*f**3*r*s + 27456*C*D1*Dd*Pk2*f**3*r + 93184*C*D1*Dd*Pk2*f**3*s**2 + 8320*C*D1*Dd*Pk2*f**3*s + 23296*C*D1*Dd*Pk2*f**3 + 329472*C*D1*Dd*Pk2*f**2*fd*r*s - 96096*C*D1*Dd*Pk2*f**2*fd*r - 279552*C*D1*Dd*Pk2*f**2*fd*s**2 + 25792*C*D1*Dd*Pk2*f**2*fd*s + 17888*C*D1*Dd*Pk2*f**2*fd + 11648*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 5824*C*D1*Dd*Pkdd2*f**3*k1**2*s + 2912*C*D1*Dd*Pkdd2*f**3*k1**2 - 34944*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 20384*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 2912*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 54912*C*D1*Ddd*Pk2*f**3*r*s - 13728*C*D1*Ddd*Pk2*f**3*r - 46592*C*D1*Ddd*Pk2*f**3*s**2 - 4160*C*D1*Ddd*Pk2*f**3*s - 11648*C*D1*Ddd*Pk2*f**3 - 5824*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 2912*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 1456*C*D1*Ddd*Pkdd2*f**3*k1**2 + 164736*C*Dd**2*Pk2*f**3*r*s - 41184*C*Dd**2*Pk2*f**3*r - 139776*C*Dd**2*Pk2*f**3*s**2 - 12480*C*Dd**2*Pk2*f**3*s + 27456*C*Dd**2*Pk2*f**3 - 17472*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 8736*C*Dd**2*Pkdd2*f**3*k1**2*s + 6864*D1**2*K*Pk2*bdd1*f**2*r*s - 6864*D1**2*K*Pk2*bdd1*f**2*s**2 - 6864*D1**2*K*Pk2*bdd1*f**2*s - 858*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 5824*D1**2*Pk2*bdd1*f**3*r*s - 2912*D1**2*Pk2*bdd1*f**3*s**2 + 5824*D1**2*Pk2*bdd1*f**3*s - 13728*D1**2*Pk2*bdd1*f**2*r*s - 3432*D1**2*Pk2*bdd1*f**2*s**2 + 13728*D1**2*Pk2*bdd1*f**2*s - 23296*D1**2*Pk2*f**3*fd*r*s + 5824*D1**2*Pk2*f**3*fd*r + 11648*D1**2*Pk2*f**3*fd*s + 23296*D1**2*Pk2*f**3*fdd*r*s - 5824*D1**2*Pk2*f**3*fdd*r - 11648*D1**2*Pk2*f**3*fdd*s + 69888*D1**2*Pk2*f**2*fd**2*r*s - 17472*D1**2*Pk2*f**2*fd**2*r - 34944*D1**2*Pk2*f**2*fd**2*s + 11648*D1**2*Pk2*f**2*fd**2 + 117312*D1**2*Pk2*f**2*fd*r*s - 39104*D1**2*Pk2*f**2*fd*r - 17472*D1**2*Pk2*f**2*fd*s**2 - 27456*D1**2*Pk2*f**2*fd*s - 5824*D1**2*Pk2*f**2*fd - 58656*D1**2*Pk2*f**2*fdd*r*s + 19552*D1**2*Pk2*f**2*fdd*r + 8736*D1**2*Pk2*f**2*fdd*s**2 + 13728*D1**2*Pk2*f**2*fdd*s + 2912*D1**2*Pk2*f**2*fdd + 27456*D1**2*Pk2*f**2*gd2*r*s - 27456*D1**2*Pk2*f**2*gd2*s**2 - 27456*D1**2*Pk2*f**2*gd2*s - 13728*D1**2*Pk2*f**2*gdd2*r*s + 13728*D1**2*Pk2*f**2*gdd2*s**2 + 13728*D1**2*Pk2*f**2*gdd2*s - 117312*D1**2*Pk2*f*fd**2*r*s + 39104*D1**2*Pk2*f*fd**2*r + 17472*D1**2*Pk2*f*fd**2*s**2 + 27456*D1**2*Pk2*f*fd**2*s - 19552*D1**2*Pk2*f*fd**2 + 54912*D1**2*Pk2*f*fd*g2*r*s - 27456*D1**2*Pk2*f*fd*g2*r - 54912*D1**2*Pk2*f*fd*g2*s**2 + 54912*D1**2*Pk2*f*fd*g2*s - 27456*D1**2*Pk2*f*fd*g2 - 54912*D1**2*Pk2*f*fd*gd2*r*s + 13728*D1**2*Pk2*f*fd*gd2*r + 54912*D1**2*Pk2*f*fd*gd2*s**2 - 13728*D1**2*Pk2*f*fd*gd2 - 27456*D1**2*Pk2*f*fdd*g2*r*s + 13728*D1**2*Pk2*f*fdd*g2*r + 27456*D1**2*Pk2*f*fdd*g2*s**2 - 27456*D1**2*Pk2*f*fdd*g2*s + 13728*D1**2*Pk2*f*fdd*g2 - 27456*D1**2*Pk2*fd**2*g2*r*s + 13728*D1**2*Pk2*fd**2*g2*r + 27456*D1**2*Pk2*fd**2*g2*s**2 - 27456*D1**2*Pk2*fd**2*g2*s + 858*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 7560*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 3780*D1**2*Pkdd2*f**3*fd*k1**2*s + 1890*D1**2*Pkdd2*f**3*fd*k1**2 - 3780*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 1890*D1**2*Pkdd2*f**3*fdd*k1**2*s - 945*D1**2*Pkdd2*f**3*fdd*k1**2 - 11340*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 5670*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 8736*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 5824*D1**2*Pkdd2*f**2*fd*k1**2*s - 2912*D1**2*Pkdd2*f**2*fd*k1**2 + 4368*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 2912*D1**2*Pkdd2*f**2*fdd*k1**2*s + 1456*D1**2*Pkdd2*f**2*fdd*k1**2 - 3432*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 1716*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 8736*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 5824*D1**2*Pkdd2*f*fd**2*k1**2*s - 6864*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 6864*D1**2*Pkdd2*f*fd*g2*k1**2*s - 3432*D1**2*Pkdd2*f*fd*g2*k1**2 + 6864*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 3432*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 3432*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 3432*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 1716*D1**2*Pkdd2*f*fdd*g2*k1**2 + 3432*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 3432*D1**2*Pkdd2*fd**2*g2*k1**2*s - 23296*D1*Dd*Pk2*f**4*r*s + 5824*D1*Dd*Pk2*f**4*r + 11648*D1*Dd*Pk2*f**4*s + 186368*D1*Dd*Pk2*f**3*fd*r*s - 46592*D1*Dd*Pk2*f**3*fd*r - 93184*D1*Dd*Pk2*f**3*fd*s + 23296*D1*Dd*Pk2*f**3*fd + 156416*D1*Dd*Pk2*f**3*r*s - 39104*D1*Dd*Pk2*f**3*r - 23296*D1*Dd*Pk2*f**3*s**2 - 66560*D1*Dd*Pk2*f**3*s - 5824*D1*Dd*Pk2*f**3 - 469248*D1*Dd*Pk2*f**2*fd*r*s + 136864*D1*Dd*Pk2*f**2*fd*r + 69888*D1*Dd*Pk2*f**2*fd*s**2 + 154752*D1*Dd*Pk2*f**2*fd*s - 52832*D1*Dd*Pk2*f**2*fd + 109824*D1*Dd*Pk2*f**2*g2*r*s - 27456*D1*Dd*Pk2*f**2*g2*r - 109824*D1*Dd*Pk2*f**2*g2*s**2 - 27456*D1*Dd*Pk2*f**2*g2 - 109824*D1*Dd*Pk2*f**2*gd2*r*s + 13728*D1*Dd*Pk2*f**2*gd2*r + 109824*D1*Dd*Pk2*f**2*gd2*s**2 + 54912*D1*Dd*Pk2*f**2*gd2*s - 13728*D1*Dd*Pk2*f**2*gd2 - 219648*D1*Dd*Pk2*f*fd*g2*r*s + 82368*D1*Dd*Pk2*f*fd*g2*r + 219648*D1*Dd*Pk2*f*fd*g2*s**2 - 109824*D1*Dd*Pk2*f*fd*g2*s + 7560*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 3780*D1*Dd*Pkdd2*f**4*k1**2*s + 1890*D1*Dd*Pkdd2*f**4*k1**2 - 30240*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 15120*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 1890*D1*Dd*Pkdd2*f**3*fd*k1**2 - 11648*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 5824*D1*Dd*Pkdd2*f**3*k1**2*s - 2912*D1*Dd*Pkdd2*f**3*k1**2 + 34944*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 20384*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 2912*D1*Dd*Pkdd2*f**2*fd*k1**2 - 13728*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 6864*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 3432*D1*Dd*Pkdd2*f**2*g2*k1**2 + 13728*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 3432*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 27456*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 20592*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 3432*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 23296*D1*Ddd*Pk2*f**4*r*s - 5824*D1*Ddd*Pk2*f**4*r - 11648*D1*Ddd*Pk2*f**4*s - 78208*D1*Ddd*Pk2*f**3*r*s + 19552*D1*Ddd*Pk2*f**3*r + 11648*D1*Ddd*Pk2*f**3*s**2 + 33280*D1*Ddd*Pk2*f**3*s + 2912*D1*Ddd*Pk2*f**3 - 54912*D1*Ddd*Pk2*f**2*g2*r*s + 13728*D1*Ddd*Pk2*f**2*g2*r + 54912*D1*Ddd*Pk2*f**2*g2*s**2 + 13728*D1*Ddd*Pk2*f**2*g2 - 3780*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 1890*D1*Ddd*Pkdd2*f**4*k1**2*s - 945*D1*Ddd*Pkdd2*f**4*k1**2 + 5824*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 2912*D1*Ddd*Pkdd2*f**3*k1**2*s + 1456*D1*Ddd*Pkdd2*f**3*k1**2 + 6864*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 3432*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 1716*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 52*D1*bd1*f*(D1*f*s*(4*Pk2*(-66*K*(r - s - 1) + 28*f*(2*r + s - 2) + 132*r + 33*s - 132) + Pkdd2*k1**2*s*(33*K - 33)) - D1*fd*(4*Pk2*(-33*K*r*(4*s - 1) + 132*K*s**2 - 33*K + 28*f*(r*(6*s - 1) + 3*s**2 - 5*s + 1) - 33*r*(2 - 8*s) + 66*s**2 - 165*s + 66) + Pkdd2*k1**2*s*(33*K - 33)*(2*s - 1)) - 4*Dd*Pk2*f*(33*K*(-8*r*s + r + 8*s**2 + 4*s - 1) + 28*f*(r*(8*s - 1) + 4*s**2 - 7*s + 1) + 528*r*s - 66*r + 132*s**2 - 429*s + 66) - 33*Dd*Pkdd2*f*k1**2*s*(K - 1)*(4*s - 1)) + 69888*Dd**2*Pk2*f**4*r*s - 17472*Dd**2*Pk2*f**4*r - 34944*Dd**2*Pk2*f**4*s + 11648*Dd**2*Pk2*f**4 - 234624*Dd**2*Pk2*f**3*r*s + 58656*Dd**2*Pk2*f**3*r + 34944*Dd**2*Pk2*f**3*s**2 + 99840*Dd**2*Pk2*f**3*s - 39104*Dd**2*Pk2*f**3 - 164736*Dd**2*Pk2*f**2*g2*r*s + 41184*Dd**2*Pk2*f**2*g2*r + 164736*Dd**2*Pk2*f**2*g2*s**2 - 27456*Dd**2*Pk2*f**2*g2 - 11340*Dd**2*Pkdd2*f**4*k1**2*s**2 + 5670*Dd**2*Pkdd2*f**4*k1**2*s + 17472*Dd**2*Pkdd2*f**3*k1**2*s**2 - 8736*Dd**2*Pkdd2*f**3*k1**2*s + 20592*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 10296*Dd**2*Pkdd2*f**2*g2*k1**2*s + 26*b1*(D1**2*(112*Pk2*f**2*(2*fd - fdd)*(3*s - 1)*(2*r + s - 1) + f*(-224*Pk2*fd**2*(3*s - 1)*(2*r + s - 1) - 264*Pk2*fd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) + r*(4 - 8*s) - 2*s**2 + 2*s - 1) + 132*Pk2*fdd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) + r*(4 - 8*s) - 2*s**2 + 2*s - 1) + 66*Pkdd2*fd*k1**2*(K - 1)*(2*s**2 - 2*s + 1) - 33*Pkdd2*fdd*k1**2*(K - 1)*(2*s**2 - 2*s + 1)) + 66*fd**2*(Pk2*r*(4*K - 8)*(2*s - 1) + Pk2*s*(-8*K - 4)*(s - 1) + Pkdd2*k1**2*s*(-K*s + K + s - 1))) + D1*f*(2*Dd*(112*Pk2*f**2*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + f*(-4*Pk2*(-66*K*(-4*r*s + r + 4*s**2 + 1) + 28*fd*(r*(24*s - 7) + 12*s**2 - 17*s + 4) - 528*r*s + 132*r - 132*s**2 + 330*s - 33) + Pkdd2*k1**2*(33*K - 33)*(4*s**2 - 2*s + 1)) + 33*fd*(Pk2*r*(8*K - 16)*(8*s - 3) - 4*Pk2*(2*s - 1)*(s*(8*K + 4) - 5) - Pkdd2*k1**2*(K - 1)*(8*s**2 - 6*s + 1))) - Ddd*f*(4*Pk2*(66*K*(-4*r*s + r + 4*s**2 + 1) + 28*f*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + 528*r*s - 132*r + 132*s**2 - 330*s + 33) + Pkdd2*k1**2*(33*K - 33)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(4*Pk2*(-33*K*(12*r*s - 3*r - 12*s**2 + 2) + 28*f*(3*r*(4*s - 1) + 6*s**2 - 9*s + 2) + 792*r*s - 198*r + 198*s**2 - 495*s + 132) + Pkdd2*k1**2*s*(99*K - 99)*(2*s - 1))))/(9009*d**2*k3**4) + D1**2*Pk3*ct**6*k1**2*(68640*C*D1**2*Pk2*bdd1*f**2*r*s + 102960*C*D1**2*Pk2*bdd1*f**2*s**2 - 68640*C*D1**2*Pk2*bdd1*f**2*s + 34320*C*D1**2*Pk2*bdd1*f**2 + 1029600*C*D1**2*Pk2*f**2*fd*r*s - 343200*C*D1**2*Pk2*f**2*fd*r + 113880*C*D1**2*Pk2*f**2*fd*s**2 - 419120*C*D1**2*Pk2*f**2*fd*s + 37960*C*D1**2*Pk2*f**2*fd - 617760*C*D1**2*Pk2*f**2*fdd*r*s + 205920*C*D1**2*Pk2*f**2*fdd*r - 288600*C*D1**2*Pk2*f**2*fdd*s**2 + 398320*C*D1**2*Pk2*f**2*fdd*s - 96200*C*D1**2*Pk2*f**2*fdd - 1235520*C*D1**2*Pk2*f*fd**2*r*s + 411840*C*D1**2*Pk2*f*fd**2*r - 577200*C*D1**2*Pk2*f*fd**2*s**2 + 796640*C*D1**2*Pk2*f*fd**2*s - 205920*C*D1**2*Pk2*f*fd**2 - 21840*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 14560*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 7280*C*D1**2*Pkdd2*f**2*fd*k1**2 + 10920*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 7280*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 3640*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 21840*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 14560*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 1372800*C*D1*Dd*Pk2*f**3*r*s - 343200*C*D1*Dd*Pk2*f**3*r + 151840*C*D1*Dd*Pk2*f**3*s**2 - 762320*C*D1*Dd*Pk2*f**3*s + 37960*C*D1*Dd*Pk2*f**3 - 4942080*C*D1*Dd*Pk2*f**2*fd*r*s + 1441440*C*D1*Dd*Pk2*f**2*fd*r - 2308800*C*D1*Dd*Pk2*f**2*fd*s**2 + 3406000*C*D1*Dd*Pk2*f**2*fd*s - 810160*C*D1*Dd*Pk2*f**2*fd - 29120*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 14560*C*D1*Dd*Pkdd2*f**3*k1**2*s - 7280*C*D1*Dd*Pkdd2*f**3*k1**2 + 87360*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 50960*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 7280*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 823680*C*D1*Ddd*Pk2*f**3*r*s + 205920*C*D1*Ddd*Pk2*f**3*r - 384800*C*D1*Ddd*Pk2*f**3*s**2 + 604240*C*D1*Ddd*Pk2*f**3*s - 96200*C*D1*Ddd*Pk2*f**3 + 14560*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 7280*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 3640*C*D1*Ddd*Pkdd2*f**3*k1**2 - 2471040*C*Dd**2*Pk2*f**3*r*s + 617760*C*Dd**2*Pk2*f**3*r - 1154400*C*Dd**2*Pk2*f**3*s**2 + 1812720*C*Dd**2*Pk2*f**3*s - 411840*C*Dd**2*Pk2*f**3 + 43680*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 21840*C*Dd**2*Pkdd2*f**3*k1**2*s - 109824*D1**2*K*Pk2*bdd1*f**2*r*s - 58344*D1**2*K*Pk2*bdd1*f**2*s**2 + 109824*D1**2*K*Pk2*bdd1*f**2*s + 2145*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 41184*D1**2*Pk2*bd1**2*f*s*(K - 1)*(2*r + 3*s - 2) + 116480*D1**2*Pk2*bdd1*f**3*r*s + 87360*D1**2*Pk2*bdd1*f**3*s**2 - 116480*D1**2*Pk2*bdd1*f**3*s + 14560*D1**2*Pk2*bdd1*f**3 + 144144*D1**2*Pk2*bdd1*f**2*r*s + 92664*D1**2*Pk2*bdd1*f**2*s**2 - 144144*D1**2*Pk2*bdd1*f**2*s - 34320*D1**2*Pk2*bdd1*f**2 - 82368*D1**2*Pk2*bdd1*f*g2*r*s - 123552*D1**2*Pk2*bdd1*f*g2*s**2 + 82368*D1**2*Pk2*bdd1*f*g2*s - 41184*D1**2*Pk2*bdd1*f*g2 + 524160*D1**2*Pk2*f**3*fd*r*s - 131040*D1**2*Pk2*f**3*fd*r + 495040*D1**2*Pk2*f**3*fd*s**2 - 509600*D1**2*Pk2*f**3*fd*s + 123760*D1**2*Pk2*f**3*fd - 524160*D1**2*Pk2*f**3*fdd*r*s + 131040*D1**2*Pk2*f**3*fdd*r - 378560*D1**2*Pk2*f**3*fdd*s**2 + 451360*D1**2*Pk2*f**3*fdd*s - 94640*D1**2*Pk2*f**3*fdd - 1572480*D1**2*Pk2*f**2*fd**2*r*s + 393120*D1**2*Pk2*f**2*fd**2*r - 1135680*D1**2*Pk2*f**2*fd**2*s**2 + 1354080*D1**2*Pk2*f**2*fd**2*s - 262080*D1**2*Pk2*f**2*fd**2 - 1450800*D1**2*Pk2*f**2*fd*r*s + 483600*D1**2*Pk2*f**2*fd*r - 709800*D1**2*Pk2*f**2*fd*s**2 + 956800*D1**2*Pk2*f**2*fd*s - 236600*D1**2*Pk2*f**2*fd + 879840*D1**2*Pk2*f**2*fdd*r*s - 293280*D1**2*Pk2*f**2*fdd*r + 638040*D1**2*Pk2*f**2*fdd*s**2 - 718640*D1**2*Pk2*f**2*fdd*s + 212680*D1**2*Pk2*f**2*fdd - 356928*D1**2*Pk2*f**2*gd2*r*s - 48048*D1**2*Pk2*f**2*gd2*s**2 + 356928*D1**2*Pk2*f**2*gd2*s + 219648*D1**2*Pk2*f**2*gdd2*r*s + 116688*D1**2*Pk2*f**2*gdd2*s**2 - 219648*D1**2*Pk2*f**2*gdd2*s + 1759680*D1**2*Pk2*f*fd**2*r*s - 586560*D1**2*Pk2*f*fd**2*r + 1276080*D1**2*Pk2*f*fd**2*s**2 - 1437280*D1**2*Pk2*f*fd**2*s + 293280*D1**2*Pk2*f*fd**2 - 713856*D1**2*Pk2*f*fd*g2*r*s + 356928*D1**2*Pk2*f*fd*g2*r - 96096*D1**2*Pk2*f*fd*g2*s**2 + 96096*D1**2*Pk2*f*fd*g2*s - 48048*D1**2*Pk2*f*fd*g2 + 878592*D1**2*Pk2*f*fd*gd2*r*s - 219648*D1**2*Pk2*f*fd*gd2*r + 466752*D1**2*Pk2*f*fd*gd2*s**2 - 672672*D1**2*Pk2*f*fd*gd2*s + 219648*D1**2*Pk2*f*fd*gd2 + 439296*D1**2*Pk2*f*fdd*g2*r*s - 219648*D1**2*Pk2*f*fdd*g2*r + 233376*D1**2*Pk2*f*fdd*g2*s**2 - 233376*D1**2*Pk2*f*fdd*g2*s + 116688*D1**2*Pk2*f*fdd*g2 + 439296*D1**2*Pk2*fd**2*g2*r*s - 219648*D1**2*Pk2*fd**2*g2*r + 233376*D1**2*Pk2*fd**2*g2*s**2 - 233376*D1**2*Pk2*fd**2*g2*s - 2145*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 37800*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 18900*D1**2*Pkdd2*f**3*fd*k1**2*s - 9450*D1**2*Pkdd2*f**3*fd*k1**2 + 18900*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 9450*D1**2*Pkdd2*f**3*fdd*k1**2*s + 4725*D1**2*Pkdd2*f**3*fdd*k1**2 + 56700*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 28350*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 21840*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 14560*D1**2*Pkdd2*f**2*fd*k1**2*s + 7280*D1**2*Pkdd2*f**2*fd*k1**2 - 10920*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 7280*D1**2*Pkdd2*f**2*fdd*k1**2*s - 3640*D1**2*Pkdd2*f**2*fdd*k1**2 + 8580*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 4290*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 21840*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 14560*D1**2*Pkdd2*f*fd**2*k1**2*s + 17160*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 17160*D1**2*Pkdd2*f*fd*g2*k1**2*s + 8580*D1**2*Pkdd2*f*fd*g2*k1**2 - 17160*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 8580*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 8580*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 8580*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 4290*D1**2*Pkdd2*f*fdd*g2*k1**2 - 8580*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 8580*D1**2*Pkdd2*fd**2*g2*k1**2*s + 524160*D1*Dd*Pk2*f**4*r*s - 131040*D1*Dd*Pk2*f**4*r + 495040*D1*Dd*Pk2*f**4*s**2 - 509600*D1*Dd*Pk2*f**4*s + 123760*D1*Dd*Pk2*f**4 - 4193280*D1*Dd*Pk2*f**3*fd*r*s + 1048320*D1*Dd*Pk2*f**3*fd*r - 3028480*D1*Dd*Pk2*f**3*fd*s**2 + 3610880*D1*Dd*Pk2*f**3*fd*s - 713440*D1*Dd*Pk2*f**3*fd - 1934400*D1*Dd*Pk2*f**3*r*s + 483600*D1*Dd*Pk2*f**3*r - 946400*D1*Dd*Pk2*f**3*s**2 + 1440400*D1*Dd*Pk2*f**3*s - 236600*D1*Dd*Pk2*f**3 + 7038720*D1*Dd*Pk2*f**2*fd*r*s - 2052960*D1*Dd*Pk2*f**2*fd*r + 5104320*D1*Dd*Pk2*f**2*fd*s**2 - 5910320*D1*Dd*Pk2*f**2*fd*s + 1305200*D1*Dd*Pk2*f**2*fd - 1427712*D1*Dd*Pk2*f**2*g2*r*s + 356928*D1*Dd*Pk2*f**2*g2*r - 192192*D1*Dd*Pk2*f**2*g2*s**2 + 809952*D1*Dd*Pk2*f**2*g2*s - 48048*D1*Dd*Pk2*f**2*g2 + 1757184*D1*Dd*Pk2*f**2*gd2*r*s - 219648*D1*Dd*Pk2*f**2*gd2*r + 933504*D1*Dd*Pk2*f**2*gd2*s**2 - 1551264*D1*Dd*Pk2*f**2*gd2*s + 219648*D1*Dd*Pk2*f**2*gd2 + 3514368*D1*Dd*Pk2*f*fd*g2*r*s - 1317888*D1*Dd*Pk2*f*fd*g2*r + 1867008*D1*Dd*Pk2*f*fd*g2*s**2 - 2278848*D1*Dd*Pk2*f*fd*g2*s + 672672*D1*Dd*Pk2*f*fd*g2 - 37800*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 18900*D1*Dd*Pkdd2*f**4*k1**2*s - 9450*D1*Dd*Pkdd2*f**4*k1**2 + 151200*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 75600*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 9450*D1*Dd*Pkdd2*f**3*fd*k1**2 + 29120*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 14560*D1*Dd*Pkdd2*f**3*k1**2*s + 7280*D1*Dd*Pkdd2*f**3*k1**2 - 87360*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 50960*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 7280*D1*Dd*Pkdd2*f**2*fd*k1**2 + 34320*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 17160*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 8580*D1*Dd*Pkdd2*f**2*g2*k1**2 - 34320*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 8580*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 68640*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 51480*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 8580*D1*Dd*Pkdd2*f*fd*g2*k1**2 - 524160*D1*Ddd*Pk2*f**4*r*s + 131040*D1*Ddd*Pk2*f**4*r - 378560*D1*Ddd*Pk2*f**4*s**2 + 451360*D1*Ddd*Pk2*f**4*s - 94640*D1*Ddd*Pk2*f**4 + 1173120*D1*Ddd*Pk2*f**3*r*s - 293280*D1*Ddd*Pk2*f**3*r + 850720*D1*Ddd*Pk2*f**3*s**2 - 1011920*D1*Ddd*Pk2*f**3*s + 212680*D1*Ddd*Pk2*f**3 + 878592*D1*Ddd*Pk2*f**2*g2*r*s - 219648*D1*Ddd*Pk2*f**2*g2*r + 466752*D1*Ddd*Pk2*f**2*g2*s**2 - 672672*D1*Ddd*Pk2*f**2*g2*s + 116688*D1*Ddd*Pk2*f**2*g2 + 18900*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 9450*D1*Ddd*Pkdd2*f**4*k1**2*s + 4725*D1*Ddd*Pkdd2*f**4*k1**2 - 14560*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 7280*D1*Ddd*Pkdd2*f**3*k1**2*s - 3640*D1*Ddd*Pkdd2*f**3*k1**2 - 17160*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 8580*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 4290*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 26*D1*bd1*(D1*(40*Pk2*f**3*(135*s**2 + s*(191*r - 191) + 28) + 3168*Pk2*fd*g2*(r*(2*s - 1) + s*(3*s - 3)) + f**2*(4*Pk2*(660*C*(3*s**2 + s*(2*r - 2) + 1) - 280*fd*(4*r*(6*s - 1) + 18*s**2 - 22*s + 3) - 33*s**2*(7*K - 15) - 33*s*(52*K - 60)*(r - 1) - 660) + Pkdd2*k1**2*s**2*(165*K - 165)) + 33*f*(-96*Pk2*(3*g2*s**2 + 2*g2*s*(r - 1) + g2 + gd2*s*(-2*r - 3*s + 2)) + fd*(8*Pk2*(-60*C*s**2 + 50*C*s + K*(16*r*(4*s - 1) + 34*s**2 - 49*s + 16) - r*(10*C + 21)*(4*s - 1) - 54*s**2 + 69*s - 31) + 5*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1)))) + Dd*f*(-2240*Pk2*f**2*(2*r*(8*s - 1) + 12*s**2 - 15*s + 2) + 3168*Pk2*g2*(r*(8*s - 1) + 12*s**2 - 9*s + 1) - 33*f*(8*Pk2*(10*C*(r*(8*s - 1) + 12*s**2 - 9*s + 1) + K*(-128*r*s + 16*r - 68*s**2 + 113*s - 16) + 168*r*s - 21*r + 108*s**2 - 153*s + 21) + Pkdd2*k1**2*s*(5*K - 5)*(4*s - 1)))) - 1572480*Dd**2*Pk2*f**4*r*s + 393120*Dd**2*Pk2*f**4*r - 1135680*Dd**2*Pk2*f**4*s**2 + 1354080*Dd**2*Pk2*f**4*s - 262080*Dd**2*Pk2*f**4 + 3519360*Dd**2*Pk2*f**3*r*s - 879840*Dd**2*Pk2*f**3*r + 2552160*Dd**2*Pk2*f**3*s**2 - 3035760*Dd**2*Pk2*f**3*s + 586560*Dd**2*Pk2*f**3 + 2635776*Dd**2*Pk2*f**2*g2*r*s - 658944*Dd**2*Pk2*f**2*g2*r + 1400256*Dd**2*Pk2*f**2*g2*s**2 - 2018016*Dd**2*Pk2*f**2*g2*s + 439296*Dd**2*Pk2*f**2*g2 + 56700*Dd**2*Pkdd2*f**4*k1**2*s**2 - 28350*Dd**2*Pkdd2*f**4*k1**2*s - 43680*Dd**2*Pkdd2*f**3*k1**2*s**2 + 21840*Dd**2*Pkdd2*f**3*k1**2*s - 51480*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 25740*Dd**2*Pkdd2*f**2*g2*k1**2*s - 20592*Pk2*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + D1*(2*Dd*(f*(8*r*s - 2*r + 12*s**2 - 10*s + 3) + fd*(-8*r*s + 5*r - 12*s**2 + 13*s - 4)) + Ddd*f*(r*(2 - 8*s) - 12*s**2 + 10*s - 3)) - 2*Dd**2*f*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2)) - 13*b1*(21120*C*D1**2*Pk2*f*fd*r*s - 10560*C*D1**2*Pk2*f*fd*r + 31680*C*D1**2*Pk2*f*fd*s**2 - 31680*C*D1**2*Pk2*f*fd*s + 10560*C*D1**2*Pk2*f*fd - 10560*C*D1**2*Pk2*f*fdd*r*s + 5280*C*D1**2*Pk2*f*fdd*r - 15840*C*D1**2*Pk2*f*fdd*s**2 + 15840*C*D1**2*Pk2*f*fdd*s - 5280*C*D1**2*Pk2*f*fdd - 10560*C*D1**2*Pk2*fd**2*r*s + 5280*C*D1**2*Pk2*fd**2*r - 15840*C*D1**2*Pk2*fd**2*s**2 + 15840*C*D1**2*Pk2*fd**2*s - 5280*C*D1**2*Pk2*fd**2 + 42240*C*D1*Dd*Pk2*f**2*r*s - 10560*C*D1*Dd*Pk2*f**2*r + 63360*C*D1*Dd*Pk2*f**2*s**2 - 52800*C*D1*Dd*Pk2*f**2*s + 15840*C*D1*Dd*Pk2*f**2 - 84480*C*D1*Dd*Pk2*f*fd*r*s + 31680*C*D1*Dd*Pk2*f*fd*r - 126720*C*D1*Dd*Pk2*f*fd*s**2 + 116160*C*D1*Dd*Pk2*f*fd*s - 26400*C*D1*Dd*Pk2*f*fd - 21120*C*D1*Ddd*Pk2*f**2*r*s + 5280*C*D1*Ddd*Pk2*f**2*r - 31680*C*D1*Ddd*Pk2*f**2*s**2 + 26400*C*D1*Ddd*Pk2*f**2*s - 7920*C*D1*Ddd*Pk2*f**2 - 63360*C*Dd**2*Pk2*f**2*r*s + 15840*C*Dd**2*Pk2*f**2*r - 95040*C*Dd**2*Pk2*f**2*s**2 + 79200*C*Dd**2*Pk2*f**2*s - 10560*C*Dd**2*Pk2*f**2 - 27456*D1**2*K*Pk2*f*fd*r*s + 13728*D1**2*K*Pk2*f*fd*r - 3696*D1**2*K*Pk2*f*fd*s**2 + 3696*D1**2*K*Pk2*f*fd*s - 1848*D1**2*K*Pk2*f*fd + 16896*D1**2*K*Pk2*f*fdd*r*s - 8448*D1**2*K*Pk2*f*fdd*r + 8976*D1**2*K*Pk2*f*fdd*s**2 - 8976*D1**2*K*Pk2*f*fdd*s + 4488*D1**2*K*Pk2*f*fdd + 16896*D1**2*K*Pk2*fd**2*r*s - 8448*D1**2*K*Pk2*fd**2*r + 8976*D1**2*K*Pk2*fd**2*s**2 - 8976*D1**2*K*Pk2*fd**2*s + 660*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 660*D1**2*K*Pkdd2*f*fd*k1**2*s + 330*D1**2*K*Pkdd2*f*fd*k1**2 - 330*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 330*D1**2*K*Pkdd2*f*fdd*k1**2*s - 165*D1**2*K*Pkdd2*f*fdd*k1**2 - 330*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 330*D1**2*K*Pkdd2*fd**2*k1**2*s - 1584*D1**2*Pk2*bdd1*f*(K - 1)*(6*s**2 + s*(4*r - 4) + 1) + 45840*D1**2*Pk2*f**2*fd*r*s - 15280*D1**2*Pk2*f**2*fd*r + 32400*D1**2*Pk2*f**2*fd*s**2 - 36880*D1**2*Pk2*f**2*fd*s + 8560*D1**2*Pk2*f**2*fd - 26880*D1**2*Pk2*f**2*fdd*r*s + 8960*D1**2*Pk2*f**2*fdd*r - 20160*D1**2*Pk2*f**2*fdd*s**2 + 22400*D1**2*Pk2*f**2*fdd*s - 5600*D1**2*Pk2*f**2*fdd - 53760*D1**2*Pk2*f*fd**2*r*s + 17920*D1**2*Pk2*f*fd**2*r - 40320*D1**2*Pk2*f*fd**2*s**2 + 44800*D1**2*Pk2*f*fd**2*s - 11200*D1**2*Pk2*f*fd**2 + 31680*D1**2*Pk2*f*fd*r*s - 15840*D1**2*Pk2*f*fd*r + 7920*D1**2*Pk2*f*fd*s**2 - 7920*D1**2*Pk2*f*fd*s + 9240*D1**2*Pk2*f*fd - 22176*D1**2*Pk2*f*fdd*r*s + 11088*D1**2*Pk2*f*fdd*r - 14256*D1**2*Pk2*f*fdd*s**2 + 14256*D1**2*Pk2*f*fdd*s - 9768*D1**2*Pk2*f*fdd - 12672*D1**2*Pk2*f*gd2*r*s - 19008*D1**2*Pk2*f*gd2*s**2 + 12672*D1**2*Pk2*f*gd2*s + 6336*D1**2*Pk2*f*gdd2*r*s + 9504*D1**2*Pk2*f*gdd2*s**2 - 6336*D1**2*Pk2*f*gdd2*s - 22176*D1**2*Pk2*fd**2*r*s + 11088*D1**2*Pk2*fd**2*r - 14256*D1**2*Pk2*fd**2*s**2 + 14256*D1**2*Pk2*fd**2*s + 5280*D1**2*Pk2*fd**2 - 12672*D1**2*Pk2*fd*g2*r*s + 12672*D1**2*Pk2*fd*g2*r - 19008*D1**2*Pk2*fd*g2*s**2 + 25344*D1**2*Pk2*fd*g2*s - 12672*D1**2*Pk2*fd*g2 + 12672*D1**2*Pk2*fd*gd2*r*s - 6336*D1**2*Pk2*fd*gd2*r + 19008*D1**2*Pk2*fd*gd2*s**2 - 19008*D1**2*Pk2*fd*gd2*s + 6336*D1**2*Pk2*fd*gd2 + 6336*D1**2*Pk2*fdd*g2*r*s - 6336*D1**2*Pk2*fdd*g2*r + 9504*D1**2*Pk2*fdd*g2*s**2 - 12672*D1**2*Pk2*fdd*g2*s + 6336*D1**2*Pk2*fdd*g2 - 660*D1**2*Pkdd2*f*fd*k1**2*s**2 + 660*D1**2*Pkdd2*f*fd*k1**2*s - 330*D1**2*Pkdd2*f*fd*k1**2 + 330*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 330*D1**2*Pkdd2*f*fdd*k1**2*s + 165*D1**2*Pkdd2*f*fdd*k1**2 + 330*D1**2*Pkdd2*fd**2*k1**2*s**2 - 330*D1**2*Pkdd2*fd**2*k1**2*s - 54912*D1*Dd*K*Pk2*f**2*r*s + 13728*D1*Dd*K*Pk2*f**2*r - 7392*D1*Dd*K*Pk2*f**2*s**2 + 31152*D1*Dd*K*Pk2*f**2*s - 1848*D1*Dd*K*Pk2*f**2 + 135168*D1*Dd*K*Pk2*f*fd*r*s - 50688*D1*Dd*K*Pk2*f*fd*r + 71808*D1*Dd*K*Pk2*f*fd*s**2 - 87648*D1*Dd*K*Pk2*f*fd*s + 25872*D1*Dd*K*Pk2*f*fd + 1320*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 660*D1*Dd*K*Pkdd2*f**2*k1**2*s + 330*D1*Dd*K*Pkdd2*f**2*k1**2 - 2640*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 1980*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 330*D1*Dd*K*Pkdd2*f*fd*k1**2 + 61120*D1*Dd*Pk2*f**3*r*s - 15280*D1*Dd*Pk2*f**3*r + 43200*D1*Dd*Pk2*f**3*s**2 - 52160*D1*Dd*Pk2*f**3*s + 10800*D1*Dd*Pk2*f**3 - 215040*D1*Dd*Pk2*f**2*fd*r*s + 62720*D1*Dd*Pk2*f**2*fd*r - 161280*D1*Dd*Pk2*f**2*fd*s**2 + 183680*D1*Dd*Pk2*f**2*fd*s - 40320*D1*Dd*Pk2*f**2*fd + 63360*D1*Dd*Pk2*f**2*r*s - 15840*D1*Dd*Pk2*f**2*r + 15840*D1*Dd*Pk2*f**2*s**2 - 39600*D1*Dd*Pk2*f**2*s + 3960*D1*Dd*Pk2*f**2 - 177408*D1*Dd*Pk2*f*fd*r*s + 66528*D1*Dd*Pk2*f*fd*r - 114048*D1*Dd*Pk2*f*fd*s**2 + 129888*D1*Dd*Pk2*f*fd*s - 36432*D1*Dd*Pk2*f*fd - 50688*D1*Dd*Pk2*f*g2*r*s + 12672*D1*Dd*Pk2*f*g2*r - 76032*D1*Dd*Pk2*f*g2*s**2 + 63360*D1*Dd*Pk2*f*g2*s - 19008*D1*Dd*Pk2*f*g2 + 50688*D1*Dd*Pk2*f*gd2*r*s - 6336*D1*Dd*Pk2*f*gd2*r + 76032*D1*Dd*Pk2*f*gd2*s**2 - 57024*D1*Dd*Pk2*f*gd2*s + 6336*D1*Dd*Pk2*f*gd2 + 50688*D1*Dd*Pk2*fd*g2*r*s - 31680*D1*Dd*Pk2*fd*g2*r + 76032*D1*Dd*Pk2*fd*g2*s**2 - 82368*D1*Dd*Pk2*fd*g2*s + 25344*D1*Dd*Pk2*fd*g2 - 1320*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 660*D1*Dd*Pkdd2*f**2*k1**2*s - 330*D1*Dd*Pkdd2*f**2*k1**2 + 2640*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 1980*D1*Dd*Pkdd2*f*fd*k1**2*s + 330*D1*Dd*Pkdd2*f*fd*k1**2 + 33792*D1*Ddd*K*Pk2*f**2*r*s - 8448*D1*Ddd*K*Pk2*f**2*r + 17952*D1*Ddd*K*Pk2*f**2*s**2 - 25872*D1*Ddd*K*Pk2*f**2*s + 4488*D1*Ddd*K*Pk2*f**2 - 660*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 330*D1*Ddd*K*Pkdd2*f**2*k1**2*s - 165*D1*Ddd*K*Pkdd2*f**2*k1**2 - 35840*D1*Ddd*Pk2*f**3*r*s + 8960*D1*Ddd*Pk2*f**3*r - 26880*D1*Ddd*Pk2*f**3*s**2 + 31360*D1*Ddd*Pk2*f**3*s - 6720*D1*Ddd*Pk2*f**3 - 44352*D1*Ddd*Pk2*f**2*r*s + 11088*D1*Ddd*Pk2*f**2*r - 28512*D1*Ddd*Pk2*f**2*s**2 + 36432*D1*Ddd*Pk2*f**2*s - 7128*D1*Ddd*Pk2*f**2 + 25344*D1*Ddd*Pk2*f*g2*r*s - 6336*D1*Ddd*Pk2*f*g2*r + 38016*D1*Ddd*Pk2*f*g2*s**2 - 31680*D1*Ddd*Pk2*f*g2*s + 9504*D1*Ddd*Pk2*f*g2 + 660*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 330*D1*Ddd*Pkdd2*f**2*k1**2*s + 165*D1*Ddd*Pkdd2*f**2*k1**2 + 3168*D1*Pk2*bd1*(K - 1)*(D1*(f*(6*s**2 + s*(4*r - 4) + 1) + fd*(r*(2 - 4*s) - 6*s**2 + 6*s - 1)) - 2*Dd*f*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) + 101376*Dd**2*K*Pk2*f**2*r*s - 25344*Dd**2*K*Pk2*f**2*r + 53856*Dd**2*K*Pk2*f**2*s**2 - 77616*Dd**2*K*Pk2*f**2*s + 16896*Dd**2*K*Pk2*f**2 - 1980*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 990*Dd**2*K*Pkdd2*f**2*k1**2*s - 107520*Dd**2*Pk2*f**3*r*s + 26880*Dd**2*Pk2*f**3*r - 80640*Dd**2*Pk2*f**3*s**2 + 94080*Dd**2*Pk2*f**3*s - 17920*Dd**2*Pk2*f**3 - 133056*Dd**2*Pk2*f**2*r*s + 33264*Dd**2*Pk2*f**2*r - 85536*Dd**2*Pk2*f**2*s**2 + 109296*Dd**2*Pk2*f**2*s - 22176*Dd**2*Pk2*f**2 + 76032*Dd**2*Pk2*f*g2*r*s - 19008*Dd**2*Pk2*f*g2*r + 114048*Dd**2*Pk2*f*g2*s**2 - 95040*Dd**2*Pk2*f*g2*s + 12672*Dd**2*Pk2*f*g2 + 1980*Dd**2*Pkdd2*f**2*k1**2*s**2 - 990*Dd**2*Pkdd2*f**2*k1**2*s))/(9009*d**2*k3**4) - 2*D1**2*Pk3*ct**6*k2**2*(3858*C*D1**2*Pk2*f**2*fd*r**2 - 15840*C*D1**2*Pk2*f**2*fd*r*s + 2708*C*D1**2*Pk2*f**2*fd*r - 6720*C*D1**2*Pk2*f**2*fd*s**2 + 9760*C*D1**2*Pk2*f**2*fd*s - 954*C*D1**2*Pk2*f**2*fd - 1038*C*D1**2*Pk2*f**2*fdd*r**2 + 7920*C*D1**2*Pk2*f**2*fdd*r*s - 1948*C*D1**2*Pk2*f**2*fdd*r + 3360*C*D1**2*Pk2*f**2*fdd*s**2 - 4880*C*D1**2*Pk2*f**2*fdd*s + 774*C*D1**2*Pk2*f**2*fdd - 2076*C*D1**2*Pk2*f*fd**2*r**2 + 15840*C*D1**2*Pk2*f*fd**2*r*s - 3896*C*D1**2*Pk2*f*fd**2*r + 6720*C*D1**2*Pk2*f*fd**2*s**2 - 9760*C*D1**2*Pk2*f*fd**2*s + 2640*C*D1**2*Pk2*f*fd**2 + 660*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 330*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 330*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 2865*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 1910*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 955*C*D1**2*Pkdd2*f**2*fd*k1**2 - 1680*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 1120*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 560*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 3360*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 2240*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 5144*C*D1*Dd*Pk2*f**3*r**2 - 21120*C*D1*Dd*Pk2*f**3*r*s + 136*C*D1*Dd*Pk2*f**3*r - 8960*C*D1*Dd*Pk2*f**3*s**2 + 15040*C*D1*Dd*Pk2*f**3*s + 332*C*D1*Dd*Pk2*f**3 - 8304*C*D1*Dd*Pk2*f**2*fd*r**2 + 63360*C*D1*Dd*Pk2*f**2*fd*r*s - 11560*C*D1*Dd*Pk2*f**2*fd*r + 26880*C*D1*Dd*Pk2*f**2*fd*s**2 - 42080*C*D1*Dd*Pk2*f**2*fd*s + 8776*C*D1*Dd*Pk2*f**2*fd + 1320*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 660*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 330*C*D1*Dd*Pkdd2*b1*f**2*k1**2 - 2640*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 660*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 3820*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 1910*C*D1*Dd*Pkdd2*f**3*k1**2*s + 955*C*D1*Dd*Pkdd2*f**3*k1**2 - 13440*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 7840*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 1120*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1384*C*D1*Ddd*Pk2*f**3*r**2 + 10560*C*D1*Ddd*Pk2*f**3*r*s - 1256*C*D1*Ddd*Pk2*f**3*r + 4480*C*D1*Ddd*Pk2*f**3*s**2 - 7520*C*D1*Ddd*Pk2*f**3*s + 428*C*D1*Ddd*Pk2*f**3 - 660*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 330*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 165*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 2240*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 1120*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 560*C*D1*Ddd*Pkdd2*f**3*k1**2 - 4152*C*Dd**2*Pk2*f**3*r**2 + 31680*C*Dd**2*Pk2*f**3*r*s - 3768*C*Dd**2*Pk2*f**3*r + 13440*C*Dd**2*Pk2*f**3*s**2 - 22560*C*Dd**2*Pk2*f**3*s + 4588*C*Dd**2*Pk2*f**3 - 1980*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 990*C*Dd**2*Pkdd2*b1*f**2*k1**2*s - 6720*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 3360*C*Dd**2*Pkdd2*f**3*k1**2*s + 660*D1**2*K*Pk2*b1*f*fd*r**2 - 5280*D1**2*K*Pk2*b1*f*fd*r*s + 2640*D1**2*K*Pk2*b1*f*fd*r - 2640*D1**2*K*Pk2*b1*f*fd*s**2 + 2640*D1**2*K*Pk2*b1*f*fd*s - 1320*D1**2*K*Pk2*b1*f*fd - 330*D1**2*K*Pk2*b1*f*fdd*r**2 + 2640*D1**2*K*Pk2*b1*f*fdd*r*s - 1320*D1**2*K*Pk2*b1*f*fdd*r + 1320*D1**2*K*Pk2*b1*f*fdd*s**2 - 1320*D1**2*K*Pk2*b1*f*fdd*s + 660*D1**2*K*Pk2*b1*f*fdd - 330*D1**2*K*Pk2*b1*fd**2*r**2 + 2640*D1**2*K*Pk2*b1*fd**2*r*s - 1320*D1**2*K*Pk2*b1*fd**2*r + 1320*D1**2*K*Pk2*b1*fd**2*s**2 - 1320*D1**2*K*Pk2*b1*fd**2*s + 198*D1**2*K*Pkdd2*b1**2*fd*k1**2*s**2 - 99*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s**2 + 1122*D1**2*K*Pkdd2*b1*f*fd*k1**2*s**2 - 1122*D1**2*K*Pkdd2*b1*f*fd*k1**2*s + 561*D1**2*K*Pkdd2*b1*f*fd*k1**2 - 660*D1**2*K*Pkdd2*b1*f*fdd*k1**2*s**2 + 660*D1**2*K*Pkdd2*b1*f*fdd*k1**2*s - 330*D1**2*K*Pkdd2*b1*f*fdd*k1**2 - 660*D1**2*K*Pkdd2*b1*fd**2*k1**2*s**2 + 660*D1**2*K*Pkdd2*b1*fd**2*k1**2*s - 990*D1**2*Pk2*b1*f**2*fd*r**2 + 660*D1**2*Pk2*b1*f**2*fd*r - 330*D1**2*Pk2*b1*f**2*fd + 990*D1**2*Pk2*b1*f**2*fdd*r**2 - 660*D1**2*Pk2*b1*f**2*fdd*r + 330*D1**2*Pk2*b1*f**2*fdd + 1980*D1**2*Pk2*b1*f*fd**2*r**2 - 1320*D1**2*Pk2*b1*f*fd**2*r - 1980*D1**2*Pk2*b1*f*fd*r**2 + 990*D1**2*Pk2*b1*f*fdd*r**2 + 990*D1**2*Pk2*b1*fd**2*r**2 - 2640*D1**2*Pk2*b2*f*fd*r*s + 1320*D1**2*Pk2*b2*f*fd*r - 2640*D1**2*Pk2*b2*f*fd*s**2 + 2640*D1**2*Pk2*b2*f*fd*s - 1320*D1**2*Pk2*b2*f*fd + 1320*D1**2*Pk2*b2*f*fdd*r*s - 660*D1**2*Pk2*b2*f*fdd*r + 1320*D1**2*Pk2*b2*f*fdd*s**2 - 1320*D1**2*Pk2*b2*f*fdd*s + 660*D1**2*Pk2*b2*f*fdd + 1320*D1**2*Pk2*b2*fd**2*r*s - 660*D1**2*Pk2*b2*fd**2*r + 1320*D1**2*Pk2*b2*fd**2*s**2 - 1320*D1**2*Pk2*b2*fd**2*s - 1320*D1**2*Pk2*bd2*f**2*r*s - 1320*D1**2*Pk2*bd2*f**2*s**2 + 1320*D1**2*Pk2*bd2*f**2*s + 2640*D1**2*Pk2*bd2*f*fd*r*s - 660*D1**2*Pk2*bd2*f*fd*r + 2640*D1**2*Pk2*bd2*f*fd*s**2 - 2640*D1**2*Pk2*bd2*f*fd*s + 660*D1**2*Pk2*bd2*f*fd + 660*D1**2*Pk2*bdd2*f**2*r*s + 660*D1**2*Pk2*bdd2*f**2*s**2 - 660*D1**2*Pk2*bdd2*f**2*s + 660*D1**2*Pk2*f**3*fd*r**2 - 660*D1**2*Pk2*f**3*fd*r + 330*D1**2*Pk2*f**3*fd - 660*D1**2*Pk2*f**3*fdd*r**2 + 660*D1**2*Pk2*f**3*fdd*r - 330*D1**2*Pk2*f**3*fdd - 1980*D1**2*Pk2*f**2*fd**2*r**2 + 1980*D1**2*Pk2*f**2*fd**2*r - 330*D1**2*Pk2*f**2*fd**2 - 6138*D1**2*Pk2*f**2*fd*r**2 + 7920*D1**2*Pk2*f**2*fd*r*s + 1452*D1**2*Pk2*f**2*fd*r + 3360*D1**2*Pk2*f**2*fd*s**2 - 4880*D1**2*Pk2*f**2*fd*s - 926*D1**2*Pk2*f**2*fd + 2178*D1**2*Pk2*f**2*fdd*r**2 - 3960*D1**2*Pk2*f**2*fdd*r*s - 132*D1**2*Pk2*f**2*fdd*r - 1680*D1**2*Pk2*f**2*fdd*s**2 + 2440*D1**2*Pk2*f**2*fdd*s + 166*D1**2*Pk2*f**2*fdd - 660*D1**2*Pk2*f**2*gd2*r**2 + 5280*D1**2*Pk2*f**2*gd2*r*s + 1320*D1**2*Pk2*f**2*gd2*r + 2640*D1**2*Pk2*f**2*gd2*s**2 - 5280*D1**2*Pk2*f**2*gd2*s - 660*D1**2*Pk2*f**2*gd2 + 330*D1**2*Pk2*f**2*gdd2*r**2 - 2640*D1**2*Pk2*f**2*gdd2*r*s - 660*D1**2*Pk2*f**2*gdd2*r - 1320*D1**2*Pk2*f**2*gdd2*s**2 + 2640*D1**2*Pk2*f**2*gdd2*s + 330*D1**2*Pk2*f**2*gdd2 + 4356*D1**2*Pk2*f*fd**2*r**2 - 7920*D1**2*Pk2*f*fd**2*r*s - 264*D1**2*Pk2*f*fd**2*r - 3360*D1**2*Pk2*f*fd**2*s**2 + 4880*D1**2*Pk2*f*fd**2*s - 1320*D1**2*Pk2*f*fd**2 - 1320*D1**2*Pk2*f*fd*g2*r**2 + 10560*D1**2*Pk2*f*fd*g2*r*s - 5280*D1**2*Pk2*f*fd*g2*r + 5280*D1**2*Pk2*f*fd*g2*s**2 - 5280*D1**2*Pk2*f*fd*g2*s + 2640*D1**2*Pk2*f*fd*g2 + 1320*D1**2*Pk2*f*fd*gd2*r**2 - 10560*D1**2*Pk2*f*fd*gd2*r*s + 1320*D1**2*Pk2*f*fd*gd2*r - 5280*D1**2*Pk2*f*fd*gd2*s**2 + 7920*D1**2*Pk2*f*fd*gd2*s - 2640*D1**2*Pk2*f*fd*gd2 + 660*D1**2*Pk2*f*fdd*g2*r**2 - 5280*D1**2*Pk2*f*fdd*g2*r*s + 2640*D1**2*Pk2*f*fdd*g2*r - 2640*D1**2*Pk2*f*fdd*g2*s**2 + 2640*D1**2*Pk2*f*fdd*g2*s - 1320*D1**2*Pk2*f*fdd*g2 + 660*D1**2*Pk2*fd**2*g2*r**2 - 5280*D1**2*Pk2*fd**2*g2*r*s + 2640*D1**2*Pk2*fd**2*g2*r - 2640*D1**2*Pk2*fd**2*g2*s**2 + 2640*D1**2*Pk2*fd**2*g2*s - 198*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 99*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 840*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 840*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 420*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 420*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 420*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 210*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 840*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 840*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 1122*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 462*D1**2*Pkdd2*b1*f*fd*k1**2*s - 231*D1**2*Pkdd2*b1*f*fd*k1**2 + 660*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 330*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 165*D1**2*Pkdd2*b1*f*fdd*k1**2 - 396*D1**2*Pkdd2*b1*f*gd2*k1**2*s**2 + 198*D1**2*Pkdd2*b1*f*gdd2*k1**2*s**2 + 660*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 330*D1**2*Pkdd2*b1*fd**2*k1**2*s - 396*D1**2*Pkdd2*b1*fd*g2*k1**2*s**2 + 396*D1**2*Pkdd2*b1*fd*gd2*k1**2*s**2 + 198*D1**2*Pkdd2*b1*fdd*g2*k1**2*s**2 - 198*D1**2*Pkdd2*bd1**2*f*k1**2*s*(K - 1)*(s - 1) - 280*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 140*D1**2*Pkdd2*f**3*fd*k1**2*s - 70*D1**2*Pkdd2*f**3*fd*k1**2 - 2025*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 1350*D1**2*Pkdd2*f**2*fd*k1**2*s - 675*D1**2*Pkdd2*f**2*fd*k1**2 + 1260*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 840*D1**2*Pkdd2*f**2*fdd*k1**2*s + 420*D1**2*Pkdd2*f**2*fdd*k1**2 - 1122*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 660*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 2520*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 1680*D1**2*Pkdd2*f*fd**2*k1**2*s - 2244*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 2244*D1**2*Pkdd2*f*fd*g2*k1**2*s - 1122*D1**2*Pkdd2*f*fd*g2*k1**2 + 2640*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 1320*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 1320*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 1320*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 660*D1**2*Pkdd2*f*fdd*g2*k1**2 + 1320*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 1320*D1**2*Pkdd2*fd**2*g2*k1**2*s + D1**2*bdd1*f*(-99*Pkdd2*k1**2*(b1*(K - 1)*(2*s**2 - 2*s + 1) - 2*g2*(s - 1)**2) + 10*f**2*(33*Pk2*(r - 1)**2 + 7*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 165*f*(K*Pk2*(r**2 - 2*r*(4*s + 1) - 4*s**2 + 8*s + 1) - 3*Pk2*(r - 1)**2 + Pkdd2*k1**2*(C*(s - 1)**2 + s**2*(2*K - 2) + 2*s - 1))) + 1320*D1*Dd*K*Pk2*b1*f**2*r**2 - 10560*D1*Dd*K*Pk2*b1*f**2*r*s + 1320*D1*Dd*K*Pk2*b1*f**2*r - 5280*D1*Dd*K*Pk2*b1*f**2*s**2 + 7920*D1*Dd*K*Pk2*b1*f**2*s - 660*D1*Dd*K*Pk2*b1*f**2 - 2640*D1*Dd*K*Pk2*b1*f*fd*r**2 + 21120*D1*Dd*K*Pk2*b1*f*fd*r*s - 6600*D1*Dd*K*Pk2*b1*f*fd*r + 10560*D1*Dd*K*Pk2*b1*f*fd*s**2 - 13200*D1*Dd*K*Pk2*b1*f*fd*s + 3960*D1*Dd*K*Pk2*b1*f*fd + 792*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s**2 - 396*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s + 198*D1*Dd*K*Pkdd2*b1**2*f*k1**2 - 792*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s**2 + 198*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s + 2244*D1*Dd*K*Pkdd2*b1*f**2*k1**2*s**2 - 1122*D1*Dd*K*Pkdd2*b1*f**2*k1**2*s + 561*D1*Dd*K*Pkdd2*b1*f**2*k1**2 - 5280*D1*Dd*K*Pkdd2*b1*f*fd*k1**2*s**2 + 3960*D1*Dd*K*Pkdd2*b1*f*fd*k1**2*s - 660*D1*Dd*K*Pkdd2*b1*f*fd*k1**2 - 1320*D1*Dd*Pk2*b1*f**3*r**2 + 1320*D1*Dd*Pk2*b1*f**3*r - 660*D1*Dd*Pk2*b1*f**3 + 7920*D1*Dd*Pk2*b1*f**2*fd*r**2 - 6600*D1*Dd*Pk2*b1*f**2*fd*r + 1320*D1*Dd*Pk2*b1*f**2*fd - 3960*D1*Dd*Pk2*b1*f**2*r**2 + 3960*D1*Dd*Pk2*b1*f**2*r - 1980*D1*Dd*Pk2*b1*f**2 + 7920*D1*Dd*Pk2*b1*f*fd*r**2 - 3960*D1*Dd*Pk2*b1*f*fd*r - 5280*D1*Dd*Pk2*b2*f**2*r*s + 1320*D1*Dd*Pk2*b2*f**2*r - 5280*D1*Dd*Pk2*b2*f**2*s**2 + 5280*D1*Dd*Pk2*b2*f**2*s - 1320*D1*Dd*Pk2*b2*f**2 + 10560*D1*Dd*Pk2*b2*f*fd*r*s - 3960*D1*Dd*Pk2*b2*f*fd*r + 10560*D1*Dd*Pk2*b2*f*fd*s**2 - 10560*D1*Dd*Pk2*b2*f*fd*s + 2640*D1*Dd*Pk2*b2*f*fd + 5280*D1*Dd*Pk2*bd2*f**2*r*s - 660*D1*Dd*Pk2*bd2*f**2*r + 5280*D1*Dd*Pk2*bd2*f**2*s**2 - 5280*D1*Dd*Pk2*bd2*f**2*s + 660*D1*Dd*Pk2*bd2*f**2 + 660*D1*Dd*Pk2*f**4*r**2 - 660*D1*Dd*Pk2*f**4*r + 330*D1*Dd*Pk2*f**4 - 5280*D1*Dd*Pk2*f**3*fd*r**2 + 5280*D1*Dd*Pk2*f**3*fd*r - 1320*D1*Dd*Pk2*f**3*fd - 8184*D1*Dd*Pk2*f**3*r**2 + 10560*D1*Dd*Pk2*f**3*r*s + 5544*D1*Dd*Pk2*f**3*r + 4480*D1*Dd*Pk2*f**3*s**2 - 7520*D1*Dd*Pk2*f**3*s - 2972*D1*Dd*Pk2*f**3 + 17424*D1*Dd*Pk2*f**2*fd*r**2 - 31680*D1*Dd*Pk2*f**2*fd*r*s - 5280*D1*Dd*Pk2*f**2*fd*r - 13440*D1*Dd*Pk2*f**2*fd*s**2 + 21040*D1*Dd*Pk2*f**2*fd*s - 2176*D1*Dd*Pk2*f**2*fd - 2640*D1*Dd*Pk2*f**2*g2*r**2 + 21120*D1*Dd*Pk2*f**2*g2*r*s - 2640*D1*Dd*Pk2*f**2*g2*r + 10560*D1*Dd*Pk2*f**2*g2*s**2 - 15840*D1*Dd*Pk2*f**2*g2*s + 1320*D1*Dd*Pk2*f**2*g2 + 2640*D1*Dd*Pk2*f**2*gd2*r**2 - 21120*D1*Dd*Pk2*f**2*gd2*r*s - 1320*D1*Dd*Pk2*f**2*gd2*r - 10560*D1*Dd*Pk2*f**2*gd2*s**2 + 18480*D1*Dd*Pk2*f**2*gd2*s - 1320*D1*Dd*Pk2*f**2*gd2 + 5280*D1*Dd*Pk2*f*fd*g2*r**2 - 42240*D1*Dd*Pk2*f*fd*g2*r*s + 13200*D1*Dd*Pk2*f*fd*g2*r - 21120*D1*Dd*Pk2*f*fd*g2*s**2 + 26400*D1*Dd*Pk2*f*fd*g2*s - 7920*D1*Dd*Pk2*f*fd*g2 - 792*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 396*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 198*D1*Dd*Pkdd2*b1**2*f*k1**2 + 792*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 198*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 1120*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 560*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 280*D1*Dd*Pkdd2*b1*f**3*k1**2 + 3360*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 2520*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 420*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 2244*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 1122*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 561*D1*Dd*Pkdd2*b1*f**2*k1**2 + 5280*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 2640*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 330*D1*Dd*Pkdd2*b1*f*fd*k1**2 - 1584*D1*Dd*Pkdd2*b1*f*g2*k1**2*s**2 + 792*D1*Dd*Pkdd2*b1*f*g2*k1**2*s - 396*D1*Dd*Pkdd2*b1*f*g2*k1**2 + 1584*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s**2 - 396*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s + 1584*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s**2 - 396*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s - 280*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 140*D1*Dd*Pkdd2*f**4*k1**2*s - 70*D1*Dd*Pkdd2*f**4*k1**2 - 2700*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 1350*D1*Dd*Pkdd2*f**3*k1**2*s - 675*D1*Dd*Pkdd2*f**3*k1**2 + 10080*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 5880*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 840*D1*Dd*Pkdd2*f**2*fd*k1**2 - 4488*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 2244*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 1122*D1*Dd*Pkdd2*f**2*g2*k1**2 + 5280*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 1320*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 10560*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 7920*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 1320*D1*Dd*Pkdd2*f*fd*g2*k1**2 - 660*D1*Ddd*K*Pk2*b1*f**2*r**2 + 5280*D1*Ddd*K*Pk2*b1*f**2*r*s - 660*D1*Ddd*K*Pk2*b1*f**2*r + 2640*D1*Ddd*K*Pk2*b1*f**2*s**2 - 3960*D1*Ddd*K*Pk2*b1*f**2*s + 330*D1*Ddd*K*Pk2*b1*f**2 - 396*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s**2 + 198*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s - 99*D1*Ddd*K*Pkdd2*b1**2*f*k1**2 - 1320*D1*Ddd*K*Pkdd2*b1*f**2*k1**2*s**2 + 660*D1*Ddd*K*Pkdd2*b1*f**2*k1**2*s - 330*D1*Ddd*K*Pkdd2*b1*f**2*k1**2 + 1320*D1*Ddd*Pk2*b1*f**3*r**2 - 1320*D1*Ddd*Pk2*b1*f**3*r + 660*D1*Ddd*Pk2*b1*f**3 + 1980*D1*Ddd*Pk2*b1*f**2*r**2 - 1980*D1*Ddd*Pk2*b1*f**2*r + 990*D1*Ddd*Pk2*b1*f**2 + 2640*D1*Ddd*Pk2*b2*f**2*r*s - 660*D1*Ddd*Pk2*b2*f**2*r + 2640*D1*Ddd*Pk2*b2*f**2*s**2 - 2640*D1*Ddd*Pk2*b2*f**2*s + 660*D1*Ddd*Pk2*b2*f**2 - 660*D1*Ddd*Pk2*f**4*r**2 + 660*D1*Ddd*Pk2*f**4*r - 330*D1*Ddd*Pk2*f**4 + 2904*D1*Ddd*Pk2*f**3*r**2 - 5280*D1*Ddd*Pk2*f**3*r*s - 1584*D1*Ddd*Pk2*f**3*r - 2240*D1*Ddd*Pk2*f**3*s**2 + 3760*D1*Ddd*Pk2*f**3*s + 892*D1*Ddd*Pk2*f**3 + 1320*D1*Ddd*Pk2*f**2*g2*r**2 - 10560*D1*Ddd*Pk2*f**2*g2*r*s + 1320*D1*Ddd*Pk2*f**2*g2*r - 5280*D1*Ddd*Pk2*f**2*g2*s**2 + 7920*D1*Ddd*Pk2*f**2*g2*s - 660*D1*Ddd*Pk2*f**2*g2 + 396*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 198*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 99*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 560*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 280*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 140*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 1320*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 660*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 330*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 792*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s**2 - 396*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s + 198*D1*Ddd*Pkdd2*b1*f*g2*k1**2 + 1680*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 840*D1*Ddd*Pkdd2*f**3*k1**2*s + 420*D1*Ddd*Pkdd2*f**3*k1**2 + 2640*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 1320*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 660*D1*Ddd*Pkdd2*f**2*g2*k1**2 + D1*bd1*(D1*(-198*Pkdd2*fd*k1**2*s*(b1*(K - 1)*(2*s - 1) - 2*g2*(s - 1)) - 10*f**3*(33*Pk2*(r - 1)**2 + 14*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) + 3*f**2*(110*Pk2*(K*(r**2 - 8*r*s - 2*r - 4*s**2 + 8*s + 1) + fd*(6*r**2 - 8*r + 2) - 3*(r - 1)**2) + Pkdd2*k1**2*(110*C*(s - 1)**2 + s**2*(187*K + 280*fd - 187) + 220*s - 110)) - 66*f*(3*Pkdd2*k1**2*(-b1*(K - 1)*(2*s**2 - 2*s + 1) + (2*s - 2)*(g2*(s - 1) - gd2*s)) + 5*fd*(2*K*(Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + Pkdd2*k1**2*s*(2*s - 1)) - 6*Pk2*r*(r - 1) + Pkdd2*k1**2*s*(2*C*(s - 1) - 4*s + 3)))) + 2*Dd*f*(-99*Pkdd2*k1**2*(4*s - 1)*(b1*(K - 1)*(2*s - 1) - 2*g2*(s - 1)) + 10*f**2*(66*Pk2*(2*r**2 - 3*r + 1) + 7*Pkdd2*k1**2*(8*s**2 + 2*s - 1)) - 165*f*(2*Pk2*(K*(2*r**2 - r*(16*s + 1) - 8*s**2 + 14*s - 1) - 6*r**2 + 9*r - 3) + Pkdd2*k1**2*(4*s - 1)*(C*(s - 1) + s*(2*K - 2) + 1)))) - 1980*Dd**2*K*Pk2*b1*f**2*r**2 + 15840*Dd**2*K*Pk2*b1*f**2*r*s - 1980*Dd**2*K*Pk2*b1*f**2*r + 7920*Dd**2*K*Pk2*b1*f**2*s**2 - 11880*Dd**2*K*Pk2*b1*f**2*s + 2310*Dd**2*K*Pk2*b1*f**2 - 1188*Dd**2*K*Pkdd2*b1**2*f*k1**2*s**2 + 594*Dd**2*K*Pkdd2*b1**2*f*k1**2*s - 3960*Dd**2*K*Pkdd2*b1*f**2*k1**2*s**2 + 1980*Dd**2*K*Pkdd2*b1*f**2*k1**2*s + 3960*Dd**2*Pk2*b1*f**3*r**2 - 3960*Dd**2*Pk2*b1*f**3*r + 660*Dd**2*Pk2*b1*f**3 + 5940*Dd**2*Pk2*b1*f**2*r**2 - 5940*Dd**2*Pk2*b1*f**2*r + 990*Dd**2*Pk2*b1*f**2 + 7920*Dd**2*Pk2*b2*f**2*r*s - 1980*Dd**2*Pk2*b2*f**2*r + 7920*Dd**2*Pk2*b2*f**2*s**2 - 7920*Dd**2*Pk2*b2*f**2*s + 1320*Dd**2*Pk2*b2*f**2 - 1980*Dd**2*Pk2*f**4*r**2 + 1980*Dd**2*Pk2*f**4*r - 330*Dd**2*Pk2*f**4 + 8712*Dd**2*Pk2*f**3*r**2 - 15840*Dd**2*Pk2*f**3*r*s - 4752*Dd**2*Pk2*f**3*r - 6720*Dd**2*Pk2*f**3*s**2 + 11280*Dd**2*Pk2*f**3*s - 1188*Dd**2*Pk2*f**3 + 3960*Dd**2*Pk2*f**2*g2*r**2 - 31680*Dd**2*Pk2*f**2*g2*r*s + 3960*Dd**2*Pk2*f**2*g2*r - 15840*Dd**2*Pk2*f**2*g2*s**2 + 23760*Dd**2*Pk2*f**2*g2*s - 4620*Dd**2*Pk2*f**2*g2 + 1188*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 594*Dd**2*Pkdd2*b1**2*f*k1**2*s + 1680*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 840*Dd**2*Pkdd2*b1*f**3*k1**2*s + 3960*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 1980*Dd**2*Pkdd2*b1*f**2*k1**2*s + 2376*Dd**2*Pkdd2*b1*f*g2*k1**2*s**2 - 1188*Dd**2*Pkdd2*b1*f*g2*k1**2*s + 5040*Dd**2*Pkdd2*f**3*k1**2*s**2 - 2520*Dd**2*Pkdd2*f**3*k1**2*s + 7920*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 3960*Dd**2*Pkdd2*f**2*g2*k1**2*s)/(693*d**2*k3**4) - 2*D1**2*Pk3*ct**6*(-6720*C*D1**2*Pk2*f**2*fd*s**2 + 4480*C*D1**2*Pk2*f**2*fd*s - 2240*C*D1**2*Pk2*f**2*fd + 3360*C*D1**2*Pk2*f**2*fdd*s**2 - 2240*C*D1**2*Pk2*f**2*fdd*s + 1120*C*D1**2*Pk2*f**2*fdd + 6720*C*D1**2*Pk2*f*fd**2*s**2 - 4480*C*D1**2*Pk2*f*fd**2*s + 660*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 660*C*D1**2*Pkdd2*b1*f*fd*k1**2*s + 330*C*D1**2*Pkdd2*b1*f*fd*k1**2 - 330*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 330*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 165*C*D1**2*Pkdd2*b1*f*fdd*k1**2 - 330*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 330*C*D1**2*Pkdd2*b1*fd**2*k1**2*s - 165*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 8960*C*D1*Dd*Pk2*f**3*s**2 + 4480*C*D1*Dd*Pk2*f**3*s - 2240*C*D1*Dd*Pk2*f**3 + 26880*C*D1*Dd*Pk2*f**2*fd*s**2 - 15680*C*D1*Dd*Pk2*f**2*fd*s + 2240*C*D1*Dd*Pk2*f**2*fd + 1320*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 660*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 330*C*D1*Dd*Pkdd2*b1*f**2*k1**2 - 2640*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 1980*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 330*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 4480*C*D1*Ddd*Pk2*f**3*s**2 - 2240*C*D1*Ddd*Pk2*f**3*s + 1120*C*D1*Ddd*Pk2*f**3 - 660*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 330*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 165*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 13440*C*Dd**2*Pk2*f**3*s**2 - 6720*C*Dd**2*Pk2*f**3*s - 1980*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 990*C*Dd**2*Pkdd2*b1*f**2*k1**2*s - 2640*D1**2*K*Pk2*b1*f*fd*s**2 + 2640*D1**2*K*Pk2*b1*f*fd*s - 1320*D1**2*K*Pk2*b1*f*fd + 1320*D1**2*K*Pk2*b1*f*fdd*s**2 - 1320*D1**2*K*Pk2*b1*f*fdd*s + 660*D1**2*K*Pk2*b1*f*fdd + 1320*D1**2*K*Pk2*b1*fd**2*s**2 - 1320*D1**2*K*Pk2*b1*fd**2*s + 660*D1**2*K*Pk2*bdd1*f**2*s**2 + 198*D1**2*K*Pkdd2*b1**2*fd*k1**2*s**2 - 396*D1**2*K*Pkdd2*b1**2*fd*k1**2*s + 198*D1**2*K*Pkdd2*b1**2*fd*k1**2 - 99*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s**2 + 198*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s - 99*D1**2*K*Pkdd2*b1**2*fdd*k1**2 - 198*D1**2*K*Pkdd2*b1*bdd1*f*k1**2*s**2 - 1980*D1**2*Pk2*b1*f**2*fd*r*s + 660*D1**2*Pk2*b1*f**2*fd*r + 660*D1**2*Pk2*b1*f**2*fd*s + 1980*D1**2*Pk2*b1*f**2*fdd*r*s - 660*D1**2*Pk2*b1*f**2*fdd*r - 660*D1**2*Pk2*b1*f**2*fdd*s + 3960*D1**2*Pk2*b1*f*fd**2*r*s - 1320*D1**2*Pk2*b1*f*fd**2*r - 1320*D1**2*Pk2*b1*f*fd**2*s + 660*D1**2*Pk2*b1*f*fd**2 - 2640*D1**2*Pk2*b1*f*fd*r*s + 1320*D1**2*Pk2*b1*f*fd*r + 1320*D1**2*Pk2*b1*f*fdd*r*s - 660*D1**2*Pk2*b1*f*fdd*r + 1320*D1**2*Pk2*b1*fd**2*r*s - 660*D1**2*Pk2*b1*fd**2*r - 1320*D1**2*Pk2*bd2*f**2*s**2 + 2640*D1**2*Pk2*bd2*f*fd*s**2 - 1320*D1**2*Pk2*bd2*f*fd*s + 660*D1**2*Pk2*bdd1*f**3*r*s - 660*D1**2*Pk2*bdd1*f**3*s + 660*D1**2*Pk2*bdd1*f**2*r*s - 660*D1**2*Pk2*bdd1*f**2*s + 660*D1**2*Pk2*bdd2*f**2*s**2 - 4560*D1**2*Pk2*f**2*fd*r*s + 1520*D1**2*Pk2*f**2*fd*r + 3360*D1**2*Pk2*f**2*fd*s**2 - 720*D1**2*Pk2*f**2*fd*s + 1120*D1**2*Pk2*f**2*fd + 2280*D1**2*Pk2*f**2*fdd*r*s - 760*D1**2*Pk2*f**2*fdd*r - 1680*D1**2*Pk2*f**2*fdd*s**2 + 360*D1**2*Pk2*f**2*fdd*s - 560*D1**2*Pk2*f**2*fdd + 2640*D1**2*Pk2*f**2*gd2*s**2 - 1320*D1**2*Pk2*f**2*gdd2*s**2 + 4560*D1**2*Pk2*f*fd**2*r*s - 1520*D1**2*Pk2*f*fd**2*r - 3360*D1**2*Pk2*f*fd**2*s**2 + 720*D1**2*Pk2*f*fd**2*s + 760*D1**2*Pk2*f*fd**2 + 5280*D1**2*Pk2*f*fd*g2*s**2 - 5280*D1**2*Pk2*f*fd*g2*s + 2640*D1**2*Pk2*f*fd*g2 - 5280*D1**2*Pk2*f*fd*gd2*s**2 + 2640*D1**2*Pk2*f*fd*gd2*s - 2640*D1**2*Pk2*f*fdd*g2*s**2 + 2640*D1**2*Pk2*f*fdd*g2*s - 1320*D1**2*Pk2*f*fdd*g2 - 2640*D1**2*Pk2*fd**2*g2*s**2 + 2640*D1**2*Pk2*fd**2*g2*s - 198*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 + 396*D1**2*Pkdd2*b1**2*fd*k1**2*s - 198*D1**2*Pkdd2*b1**2*fd*k1**2 + 99*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 - 198*D1**2*Pkdd2*b1**2*fdd*k1**2*s + 99*D1**2*Pkdd2*b1**2*fdd*k1**2 + 198*D1**2*Pkdd2*b1*bdd1*f*k1**2*s**2 + 1260*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 - 840*D1**2*Pkdd2*b1*f**2*fd*k1**2*s + 420*D1**2*Pkdd2*b1*f**2*fd*k1**2 - 630*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 + 420*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s - 210*D1**2*Pkdd2*b1*f**2*fdd*k1**2 - 1260*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 + 840*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 396*D1**2*Pkdd2*b1*f*gd2*k1**2*s**2 + 198*D1**2*Pkdd2*b1*f*gdd2*k1**2*s**2 - 396*D1**2*Pkdd2*b1*fd*g2*k1**2*s**2 + 792*D1**2*Pkdd2*b1*fd*g2*k1**2*s - 396*D1**2*Pkdd2*b1*fd*g2*k1**2 + 396*D1**2*Pkdd2*b1*fd*gd2*k1**2*s**2 - 396*D1**2*Pkdd2*b1*fd*gd2*k1**2*s + 198*D1**2*Pkdd2*b1*fdd*g2*k1**2*s**2 - 396*D1**2*Pkdd2*b1*fdd*g2*k1**2*s + 198*D1**2*Pkdd2*b1*fdd*g2*k1**2 - 198*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(K - 1) - 210*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 198*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 + 840*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 560*D1**2*Pkdd2*f**2*fd*k1**2*s + 280*D1**2*Pkdd2*f**2*fd*k1**2 - 420*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 280*D1**2*Pkdd2*f**2*fdd*k1**2*s - 140*D1**2*Pkdd2*f**2*fdd*k1**2 - 840*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 560*D1**2*Pkdd2*f*fd**2*k1**2*s - 5280*D1*Dd*K*Pk2*b1*f**2*s**2 + 2640*D1*Dd*K*Pk2*b1*f**2*s - 1320*D1*Dd*K*Pk2*b1*f**2 + 10560*D1*Dd*K*Pk2*b1*f*fd*s**2 - 7920*D1*Dd*K*Pk2*b1*f*fd*s + 1320*D1*Dd*K*Pk2*b1*f*fd + 792*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s**2 - 396*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s + 198*D1*Dd*K*Pkdd2*b1**2*f*k1**2 - 792*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s**2 + 990*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s - 198*D1*Dd*K*Pkdd2*b1**2*fd*k1**2 - 2640*D1*Dd*Pk2*b1*f**3*r*s + 660*D1*Dd*Pk2*b1*f**3*r + 1320*D1*Dd*Pk2*b1*f**3*s + 15840*D1*Dd*Pk2*b1*f**2*fd*r*s - 4620*D1*Dd*Pk2*b1*f**2*fd*r - 6600*D1*Dd*Pk2*b1*f**2*fd*s + 1980*D1*Dd*Pk2*b1*f**2*fd - 5280*D1*Dd*Pk2*b1*f**2*r*s + 1320*D1*Dd*Pk2*b1*f**2*r + 2640*D1*Dd*Pk2*b1*f**2*s + 10560*D1*Dd*Pk2*b1*f*fd*r*s - 3960*D1*Dd*Pk2*b1*f*fd*r - 2640*D1*Dd*Pk2*b1*f*fd*s + 1320*D1*Dd*Pk2*b1*f*fd + 5280*D1*Dd*Pk2*bd2*f**2*s**2 - 1320*D1*Dd*Pk2*bd2*f**2*s - 6080*D1*Dd*Pk2*f**3*r*s + 1520*D1*Dd*Pk2*f**3*r + 4480*D1*Dd*Pk2*f**3*s**2 + 800*D1*Dd*Pk2*f**3*s + 1120*D1*Dd*Pk2*f**3 + 18240*D1*Dd*Pk2*f**2*fd*r*s - 5320*D1*Dd*Pk2*f**2*fd*r - 13440*D1*Dd*Pk2*f**2*fd*s**2 + 240*D1*Dd*Pk2*f**2*fd*s + 1160*D1*Dd*Pk2*f**2*fd + 10560*D1*Dd*Pk2*f**2*g2*s**2 - 5280*D1*Dd*Pk2*f**2*g2*s + 2640*D1*Dd*Pk2*f**2*g2 - 10560*D1*Dd*Pk2*f**2*gd2*s**2 + 2640*D1*Dd*Pk2*f**2*gd2*s - 21120*D1*Dd*Pk2*f*fd*g2*s**2 + 15840*D1*Dd*Pk2*f*fd*g2*s - 2640*D1*Dd*Pk2*f*fd*g2 - 792*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 + 396*D1*Dd*Pkdd2*b1**2*f*k1**2*s - 198*D1*Dd*Pkdd2*b1**2*f*k1**2 + 792*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 - 990*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 198*D1*Dd*Pkdd2*b1**2*fd*k1**2 + 1680*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 - 840*D1*Dd*Pkdd2*b1*f**3*k1**2*s + 420*D1*Dd*Pkdd2*b1*f**3*k1**2 - 5040*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 + 2940*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s - 420*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 1584*D1*Dd*Pkdd2*b1*f*g2*k1**2*s**2 + 792*D1*Dd*Pkdd2*b1*f*g2*k1**2*s - 396*D1*Dd*Pkdd2*b1*f*g2*k1**2 + 1584*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s**2 - 396*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s + 1584*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s**2 - 1980*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s + 396*D1*Dd*Pkdd2*b1*fd*g2*k1**2 + 1120*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 560*D1*Dd*Pkdd2*f**3*k1**2*s + 280*D1*Dd*Pkdd2*f**3*k1**2 - 3360*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 1960*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 280*D1*Dd*Pkdd2*f**2*fd*k1**2 + 2640*D1*Ddd*K*Pk2*b1*f**2*s**2 - 1320*D1*Ddd*K*Pk2*b1*f**2*s + 660*D1*Ddd*K*Pk2*b1*f**2 - 396*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s**2 + 198*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s - 99*D1*Ddd*K*Pkdd2*b1**2*f*k1**2 + 2640*D1*Ddd*Pk2*b1*f**3*r*s - 660*D1*Ddd*Pk2*b1*f**3*r - 1320*D1*Ddd*Pk2*b1*f**3*s + 2640*D1*Ddd*Pk2*b1*f**2*r*s - 660*D1*Ddd*Pk2*b1*f**2*r - 1320*D1*Ddd*Pk2*b1*f**2*s + 3040*D1*Ddd*Pk2*f**3*r*s - 760*D1*Ddd*Pk2*f**3*r - 2240*D1*Ddd*Pk2*f**3*s**2 - 400*D1*Ddd*Pk2*f**3*s - 560*D1*Ddd*Pk2*f**3 - 5280*D1*Ddd*Pk2*f**2*g2*s**2 + 2640*D1*Ddd*Pk2*f**2*g2*s - 1320*D1*Ddd*Pk2*f**2*g2 + 396*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 - 198*D1*Ddd*Pkdd2*b1**2*f*k1**2*s + 99*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 840*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 + 420*D1*Ddd*Pkdd2*b1*f**3*k1**2*s - 210*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 792*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s**2 - 396*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s + 198*D1*Ddd*Pkdd2*b1*f*g2*k1**2 - 560*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 280*D1*Ddd*Pkdd2*f**3*k1**2*s - 140*D1*Ddd*Pkdd2*f**3*k1**2 - 6*D1*bd1*(D1*(-66*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) + 10*f**3*s*(11*Pk2*(r - 1) - 7*Pkdd2*k1**2*s) - 5*f**2*(2*fd*(11*Pk2*(6*r*s - r - 4*s + 1) + 7*Pkdd2*k1**2*s*(1 - 3*s)) + 11*s*(C*Pkdd2*k1**2*s - 4*Pk2*(K*s + r - 1))) - 11*f*(Pkdd2*k1**2*s**2*(6*b1*(K - 1) - 6*g2 + 6*gd2) + 5*fd*(C*Pkdd2*k1**2*s*(1 - 2*s) + Pk2*r*(8*s - 2) + 2*Pk2*(2*s - 1)*(2*K*s - 1)))) + Dd*f*(Pkdd2*k1**2*s*(4*s - 1)*(66*K*b1 - 66*b1 - 66*g2) - 10*f**2*(11*Pk2*(r*(8*s - 1) - 6*s + 1) + 7*Pkdd2*k1**2*s*(1 - 4*s)) - 55*f*(C*Pkdd2*k1**2*s*(1 - 4*s) + 2*Pk2*(8*K*s**2 + r*(8*s - 1) - s*(2*K + 6) + 1)))) + 7920*Dd**2*K*Pk2*b1*f**2*s**2 - 3960*Dd**2*K*Pk2*b1*f**2*s - 1188*Dd**2*K*Pkdd2*b1**2*f*k1**2*s**2 + 594*Dd**2*K*Pkdd2*b1**2*f*k1**2*s + 7920*Dd**2*Pk2*b1*f**3*r*s - 1980*Dd**2*Pk2*b1*f**3*r - 3960*Dd**2*Pk2*b1*f**3*s + 1320*Dd**2*Pk2*b1*f**3 + 7920*Dd**2*Pk2*b1*f**2*r*s - 1980*Dd**2*Pk2*b1*f**2*r - 3960*Dd**2*Pk2*b1*f**2*s + 1320*Dd**2*Pk2*b1*f**2 + 9120*Dd**2*Pk2*f**3*r*s - 2280*Dd**2*Pk2*f**3*r - 6720*Dd**2*Pk2*f**3*s**2 - 1200*Dd**2*Pk2*f**3*s + 1520*Dd**2*Pk2*f**3 - 15840*Dd**2*Pk2*f**2*g2*s**2 + 7920*Dd**2*Pk2*f**2*g2*s + 1188*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 - 594*Dd**2*Pkdd2*b1**2*f*k1**2*s - 2520*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 + 1260*Dd**2*Pkdd2*b1*f**3*k1**2*s + 2376*Dd**2*Pkdd2*b1*f*g2*k1**2*s**2 - 1188*Dd**2*Pkdd2*b1*f*g2*k1**2*s - 1680*Dd**2*Pkdd2*f**3*k1**2*s**2 + 840*Dd**2*Pkdd2*f**3*k1**2*s - 660*Pk2*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(693*d**2*k3**2) + D1**2*Pk3*ct**5*k1**3*(68640*C*D1**2*Pk2*bdd1*f**2*r*s + 137280*C*D1**2*Pk2*bdd1*f**2*s**2 - 137280*C*D1**2*Pk2*bdd1*f**2*s + 68640*C*D1**2*Pk2*bdd1*f**2 + 617760*C*D1**2*Pk2*f**2*fd*r*s - 205920*C*D1**2*Pk2*f**2*fd*r + 1070160*C*D1**2*Pk2*f**2*fd*s**2 - 919360*C*D1**2*Pk2*f**2*fd*s + 356720*C*D1**2*Pk2*f**2*fd - 411840*C*D1**2*Pk2*f**2*fdd*r*s + 137280*C*D1**2*Pk2*f**2*fdd*r - 895440*C*D1**2*Pk2*f**2*fdd*s**2 + 734240*C*D1**2*Pk2*f**2*fdd*s - 298480*C*D1**2*Pk2*f**2*fdd - 823680*C*D1**2*Pk2*f*fd**2*r*s + 274560*C*D1**2*Pk2*f*fd**2*r - 1790880*C*D1**2*Pk2*f*fd**2*s**2 + 1468480*C*D1**2*Pk2*f*fd**2*s - 137280*C*D1**2*Pk2*f*fd**2 + 823680*C*D1*Dd*Pk2*f**3*r*s - 205920*C*D1*Dd*Pk2*f**3*r + 1426880*C*D1*Dd*Pk2*f**3*s**2 - 1125280*C*D1*Dd*Pk2*f**3*s + 356720*C*D1*Dd*Pk2*f**3 - 3294720*C*D1*Dd*Pk2*f**2*fd*r*s + 960960*C*D1*Dd*Pk2*f**2*fd*r - 7163520*C*D1*Dd*Pk2*f**2*fd*s**2 + 5551520*C*D1*Dd*Pk2*f**2*fd*s - 1008800*C*D1*Dd*Pk2*f**2*fd - 549120*C*D1*Ddd*Pk2*f**3*r*s + 137280*C*D1*Ddd*Pk2*f**3*r - 1193920*C*D1*Ddd*Pk2*f**3*s**2 + 871520*C*D1*Ddd*Pk2*f**3*s - 298480*C*D1*Ddd*Pk2*f**3 - 1647360*C*Dd**2*Pk2*f**3*r*s + 411840*C*Dd**2*Pk2*f**3*r - 3581760*C*Dd**2*Pk2*f**3*s**2 + 2614560*C*Dd**2*Pk2*f**3*s - 274560*C*Dd**2*Pk2*f**3 - 75504*D1**2*K*Pk2*bdd1*f**2*r*s - 178464*D1**2*K*Pk2*bdd1*f**2*s**2 + 75504*D1**2*K*Pk2*bdd1*f**2*s + 41184*D1**2*Pk2*bd1**2*f*s*(K - 1)*(2*r + 4*s - 3) + 145600*D1**2*Pk2*bdd1*f**3*r*s + 145600*D1**2*Pk2*bdd1*f**3*s**2 - 174720*D1**2*Pk2*bdd1*f**3*s + 43680*D1**2*Pk2*bdd1*f**3 + 109824*D1**2*Pk2*bdd1*f**2*r*s + 161304*D1**2*Pk2*bdd1*f**2*s**2 - 41184*D1**2*Pk2*bdd1*f**2*s - 68640*D1**2*Pk2*bdd1*f**2 - 82368*D1**2*Pk2*bdd1*f*g2*r*s - 164736*D1**2*Pk2*bdd1*f*g2*s**2 + 164736*D1**2*Pk2*bdd1*f*g2*s - 82368*D1**2*Pk2*bdd1*f*g2 + 698880*D1**2*Pk2*f**3*fd*r*s - 174720*D1**2*Pk2*f**3*fd*r + 1310400*D1**2*Pk2*f**3*fd*s**2 - 1004640*D1**2*Pk2*f**3*fd*s + 327600*D1**2*Pk2*f**3*fd - 698880*D1**2*Pk2*f**3*fdd*r*s + 174720*D1**2*Pk2*f**3*fdd*r - 960960*D1**2*Pk2*f**3*fdd*s**2 + 829920*D1**2*Pk2*f**3*fdd*s - 240240*D1**2*Pk2*f**3*fdd - 2096640*D1**2*Pk2*f**2*fd**2*r*s + 524160*D1**2*Pk2*f**2*fd**2*r - 2882880*D1**2*Pk2*f**2*fd**2*s**2 + 2489760*D1**2*Pk2*f**2*fd**2*s - 349440*D1**2*Pk2*f**2*fd**2 - 936000*D1**2*Pk2*f**2*fd*r*s + 312000*D1**2*Pk2*f**2*fd*r - 1475760*D1**2*Pk2*f**2*fd*s**2 + 1295840*D1**2*Pk2*f**2*fd*s - 491920*D1**2*Pk2*f**2*fd + 673920*D1**2*Pk2*f**2*fdd*r*s - 224640*D1**2*Pk2*f**2*fdd*r + 1201200*D1**2*Pk2*f**2*fdd*s**2 - 1025440*D1**2*Pk2*f**2*fdd*s + 400400*D1**2*Pk2*f**2*fdd - 219648*D1**2*Pk2*f**2*gd2*r*s - 425568*D1**2*Pk2*f**2*gd2*s**2 + 219648*D1**2*Pk2*f**2*gd2*s + 151008*D1**2*Pk2*f**2*gdd2*r*s + 356928*D1**2*Pk2*f**2*gdd2*s**2 - 151008*D1**2*Pk2*f**2*gdd2*s + 1347840*D1**2*Pk2*f*fd**2*r*s - 449280*D1**2*Pk2*f*fd**2*r + 2402400*D1**2*Pk2*f*fd**2*s**2 - 2050880*D1**2*Pk2*f*fd**2*s + 224640*D1**2*Pk2*f*fd**2 - 439296*D1**2*Pk2*f*fd*g2*r*s + 219648*D1**2*Pk2*f*fd*g2*r - 851136*D1**2*Pk2*f*fd*g2*s**2 + 851136*D1**2*Pk2*f*fd*g2*s - 425568*D1**2*Pk2*f*fd*g2 + 604032*D1**2*Pk2*f*fd*gd2*r*s - 151008*D1**2*Pk2*f*fd*gd2*r + 1427712*D1**2*Pk2*f*fd*gd2*s**2 - 1015872*D1**2*Pk2*f*fd*gd2*s + 151008*D1**2*Pk2*f*fd*gd2 + 302016*D1**2*Pk2*f*fdd*g2*r*s - 151008*D1**2*Pk2*f*fdd*g2*r + 713856*D1**2*Pk2*f*fdd*g2*s**2 - 713856*D1**2*Pk2*f*fdd*g2*s + 356928*D1**2*Pk2*f*fdd*g2 + 302016*D1**2*Pk2*fd**2*g2*r*s - 151008*D1**2*Pk2*fd**2*g2*r + 713856*D1**2*Pk2*fd**2*g2*s**2 - 713856*D1**2*Pk2*fd**2*g2*s - 12600*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 6300*D1**2*Pkdd2*f**3*fd*k1**2*s - 3150*D1**2*Pkdd2*f**3*fd*k1**2 + 6300*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 3150*D1**2*Pkdd2*f**3*fdd*k1**2*s + 1575*D1**2*Pkdd2*f**3*fdd*k1**2 + 18900*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 9450*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 698880*D1*Dd*Pk2*f**4*r*s - 174720*D1*Dd*Pk2*f**4*r + 1310400*D1*Dd*Pk2*f**4*s**2 - 1004640*D1*Dd*Pk2*f**4*s + 327600*D1*Dd*Pk2*f**4 - 5591040*D1*Dd*Pk2*f**3*fd*r*s + 1397760*D1*Dd*Pk2*f**3*fd*r - 7687680*D1*Dd*Pk2*f**3*fd*s**2 + 6639360*D1*Dd*Pk2*f**3*fd*s - 1179360*D1*Dd*Pk2*f**3*fd - 1248000*D1*Dd*Pk2*f**3*r*s + 312000*D1*Dd*Pk2*f**3*r - 1967680*D1*Dd*Pk2*f**3*s**2 + 1607840*D1*Dd*Pk2*f**3*s - 491920*D1*Dd*Pk2*f**3 + 5391360*D1*Dd*Pk2*f**2*fd*r*s - 1572480*D1*Dd*Pk2*f**2*fd*r + 9609600*D1*Dd*Pk2*f**2*fd*s**2 - 7852000*D1*Dd*Pk2*f**2*fd*s + 1474720*D1*Dd*Pk2*f**2*fd - 878592*D1*Dd*Pk2*f**2*g2*r*s + 219648*D1*Dd*Pk2*f**2*g2*r - 1702272*D1*Dd*Pk2*f**2*g2*s**2 + 1290432*D1*Dd*Pk2*f**2*g2*s - 425568*D1*Dd*Pk2*f**2*g2 + 1208064*D1*Dd*Pk2*f**2*gd2*r*s - 151008*D1*Dd*Pk2*f**2*gd2*r + 2855424*D1*Dd*Pk2*f**2*gd2*s**2 - 1619904*D1*Dd*Pk2*f**2*gd2*s + 151008*D1*Dd*Pk2*f**2*gd2 + 2416128*D1*Dd*Pk2*f*fd*g2*r*s - 906048*D1*Dd*Pk2*f*fd*g2*r + 5710848*D1*Dd*Pk2*f*fd*g2*s**2 - 4887168*D1*Dd*Pk2*f*fd*g2*s + 1015872*D1*Dd*Pk2*f*fd*g2 - 12600*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 6300*D1*Dd*Pkdd2*f**4*k1**2*s - 3150*D1*Dd*Pkdd2*f**4*k1**2 + 50400*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 25200*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 3150*D1*Dd*Pkdd2*f**3*fd*k1**2 - 698880*D1*Ddd*Pk2*f**4*r*s + 174720*D1*Ddd*Pk2*f**4*r - 960960*D1*Ddd*Pk2*f**4*s**2 + 829920*D1*Ddd*Pk2*f**4*s - 240240*D1*Ddd*Pk2*f**4 + 898560*D1*Ddd*Pk2*f**3*r*s - 224640*D1*Ddd*Pk2*f**3*r + 1601600*D1*Ddd*Pk2*f**3*s**2 - 1250080*D1*Ddd*Pk2*f**3*s + 400400*D1*Ddd*Pk2*f**3 + 604032*D1*Ddd*Pk2*f**2*g2*r*s - 151008*D1*Ddd*Pk2*f**2*g2*r + 1427712*D1*Ddd*Pk2*f**2*g2*s**2 - 1015872*D1*Ddd*Pk2*f**2*g2*s + 356928*D1*Ddd*Pk2*f**2*g2 + 6300*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 3150*D1*Ddd*Pkdd2*f**4*k1**2*s + 1575*D1*Ddd*Pkdd2*f**4*k1**2 - 208*D1*Pk2*bd1*(D1*(5*f**3*(181*s**2 + s*(181*r - 270) + 84) + f**2*(132*C*(7*s**2 + s*(2*r - 10) + 5) - 140*fd*(5*r*(6*s - 1) + 30*s**2 - 32*s + 3) - 33*s**2*(31*K - 26) - 33*s*(16*K*(r - 1) - 26*r - 6) - 660) + 33*f*(fd*(-80*C*s**2 + 70*C*s + K*(11*r*(4*s - 1) + 104*s**2 - 74*s + 11) - r*(10*C + 16)*(4*s - 1) - 94*s**2 + 69*s - 26) - 2*g2*(17*s**2 + s*(5*r - 24) + 12) + 12*gd2*s*(2*r + 4*s - 3)) + 396*fd*g2*(r*(2*s - 1) + s*(4*s - 4))) + Dd*f*(-140*f**2*(5*r*(8*s - 1) + 40*s**2 - 44*s + 6) - 33*f*(10*C*(8*r*s - r + 16*s**2 - 14*s + 2) + K*(-88*r*s + 11*r - 208*s**2 + 118*s - 11) + 128*r*s - 16*r + 188*s**2 - 103*s + 6) + 396*g2*(8*r*s - r + 16*s**2 - 14*s + 2))) - 2096640*Dd**2*Pk2*f**4*r*s + 524160*Dd**2*Pk2*f**4*r - 2882880*Dd**2*Pk2*f**4*s**2 + 2489760*Dd**2*Pk2*f**4*s - 349440*Dd**2*Pk2*f**4 + 2695680*Dd**2*Pk2*f**3*r*s - 673920*Dd**2*Pk2*f**3*r + 4804800*Dd**2*Pk2*f**3*s**2 - 3750240*Dd**2*Pk2*f**3*s + 449280*Dd**2*Pk2*f**3 + 1812096*Dd**2*Pk2*f**2*g2*r*s - 453024*Dd**2*Pk2*f**2*g2*r + 4283136*Dd**2*Pk2*f**2*g2*s**2 - 3047616*Dd**2*Pk2*f**2*g2*s + 302016*Dd**2*Pk2*f**2*g2 + 18900*Dd**2*Pkdd2*f**4*k1**2*s**2 - 9450*Dd**2*Pkdd2*f**4*k1**2*s - 6864*Pk2*b1**2*(K - 1)*(D1**2*(fd*(5*r*(s - 1) + 17*s**2 - 10*s + 5) - 6*fdd*(r*(s - 1) + 2*s**2 - 2*s + 1)) + D1*(Dd*(f*(20*r*s - 5*r + 68*s**2 - 44*s + 17) - 6*fd*(8*r*s - 5*r + 16*s**2 - 14*s + 4)) - 6*Ddd*f*(r*(4*s - 1) + 8*s**2 - 6*s + 2)) - 6*Dd**2*f*(3*r*(4*s - 1) + 24*s**2 - 18*s + 2)) - 104*Pk2*b1*(1056*C*D1**2*f*fd*r*s - 528*C*D1**2*f*fd*r + 3696*C*D1**2*f*fd*s**2 - 1584*C*D1**2*f*fd*s + 528*C*D1**2*f*fd - 1320*C*D1**2*f*fdd*r*s + 660*C*D1**2*f*fdd*r - 2640*C*D1**2*f*fdd*s**2 + 1980*C*D1**2*f*fdd*s - 660*C*D1**2*f*fdd - 1320*C*D1**2*fd**2*r*s + 660*C*D1**2*fd**2*r - 2640*C*D1**2*fd**2*s**2 + 1980*C*D1**2*fd**2*s - 660*C*D1**2*fd**2 + 2112*C*D1*Dd*f**2*r*s - 528*C*D1*Dd*f**2*r + 7392*C*D1*Dd*f**2*s**2 - 4752*C*D1*Dd*f**2*s + 1848*C*D1*Dd*f**2 - 10560*C*D1*Dd*f*fd*r*s + 3960*C*D1*Dd*f*fd*r - 21120*C*D1*Dd*f*fd*s**2 + 15840*C*D1*Dd*f*fd*s - 3300*C*D1*Dd*f*fd - 2640*C*D1*Ddd*f**2*r*s + 660*C*D1*Ddd*f**2*r - 5280*C*D1*Ddd*f**2*s**2 + 3960*C*D1*Ddd*f**2*s - 1320*C*D1*Ddd*f**2 - 7920*C*Dd**2*f**2*r*s + 1980*C*Dd**2*f**2*r - 15840*C*Dd**2*f**2*s**2 + 11880*C*Dd**2*f**2*s - 1320*C*Dd**2*f**2 - 2112*D1**2*K*f*fd*r*s + 1056*D1**2*K*f*fd*r - 4092*D1**2*K*f*fd*s**2 + 4092*D1**2*K*f*fd*s - 2046*D1**2*K*f*fd + 1452*D1**2*K*f*fdd*r*s - 726*D1**2*K*f*fdd*r + 3432*D1**2*K*f*fdd*s**2 - 3432*D1**2*K*f*fdd*s + 1716*D1**2*K*f*fdd + 1452*D1**2*K*fd**2*r*s - 726*D1**2*K*fd**2*r + 3432*D1**2*K*fd**2*s**2 - 3432*D1**2*K*fd**2*s - 396*D1**2*bdd1*f*(K - 1)*(2*r*s + 4*s**2 - 3*s + 1) + 5430*D1**2*f**2*fd*r*s - 1810*D1**2*f**2*fd*r + 5430*D1**2*f**2*fd*s**2 - 4540*D1**2*f**2*fd*s + 970*D1**2*f**2*fd - 4200*D1**2*f**2*fdd*r*s + 1400*D1**2*f**2*fdd*r - 4200*D1**2*f**2*fdd*s**2 + 3920*D1**2*f**2*fdd*s - 980*D1**2*f**2*fdd - 8400*D1**2*f*fd**2*r*s + 2800*D1**2*f*fd**2*r - 8400*D1**2*f*fd**2*s**2 + 7840*D1**2*f*fd**2*s - 1960*D1**2*f*fd**2 + 3432*D1**2*f*fd*r*s - 1716*D1**2*f*fd*r + 3432*D1**2*f*fd*s**2 - 5544*D1**2*f*fd*s + 3036*D1**2*f*fd - 2112*D1**2*f*fdd*r*s + 1056*D1**2*f*fdd*r - 3102*D1**2*f*fdd*s**2 + 3762*D1**2*f*fdd*s - 2211*D1**2*f*fdd - 660*D1**2*f*gd2*r*s - 2244*D1**2*f*gd2*s**2 + 660*D1**2*f*gd2*s + 792*D1**2*f*gdd2*r*s + 1584*D1**2*f*gdd2*s**2 - 792*D1**2*f*gdd2*s - 2112*D1**2*fd**2*r*s + 1056*D1**2*fd**2*r - 3102*D1**2*fd**2*s**2 + 3762*D1**2*fd**2*s + 660*D1**2*fd**2 - 660*D1**2*fd*g2*r*s + 660*D1**2*fd*g2*r - 2244*D1**2*fd*g2*s**2 + 1320*D1**2*fd*g2*s - 660*D1**2*fd*g2 + 1584*D1**2*fd*gd2*r*s - 792*D1**2*fd*gd2*r + 3168*D1**2*fd*gd2*s**2 - 2376*D1**2*fd*gd2*s + 792*D1**2*fd*gd2 + 792*D1**2*fdd*g2*r*s - 792*D1**2*fdd*g2*r + 1584*D1**2*fdd*g2*s**2 - 1584*D1**2*fdd*g2*s + 792*D1**2*fdd*g2 - 4224*D1*Dd*K*f**2*r*s + 1056*D1*Dd*K*f**2*r - 8184*D1*Dd*K*f**2*s**2 + 6204*D1*Dd*K*f**2*s - 2046*D1*Dd*K*f**2 + 11616*D1*Dd*K*f*fd*r*s - 4356*D1*Dd*K*f*fd*r + 27456*D1*Dd*K*f*fd*s**2 - 23496*D1*Dd*K*f*fd*s + 4884*D1*Dd*K*f*fd + 7240*D1*Dd*f**3*r*s - 1810*D1*Dd*f**3*r + 7240*D1*Dd*f**3*s**2 - 7240*D1*Dd*f**3*s + 1810*D1*Dd*f**3 - 33600*D1*Dd*f**2*fd*r*s + 9800*D1*Dd*f**2*fd*r - 33600*D1*Dd*f**2*fd*s**2 + 32480*D1*Dd*f**2*fd*s - 6720*D1*Dd*f**2*fd + 6864*D1*Dd*f**2*r*s - 1716*D1*Dd*f**2*r + 6864*D1*Dd*f**2*s**2 - 6864*D1*Dd*f**2*s + 1716*D1*Dd*f**2 - 16896*D1*Dd*f*fd*r*s + 6336*D1*Dd*f*fd*r - 24816*D1*Dd*f*fd*s**2 + 25476*D1*Dd*f*fd*s - 5874*D1*Dd*f*fd - 2640*D1*Dd*f*g2*r*s + 660*D1*Dd*f*g2*r - 8976*D1*Dd*f*g2*s**2 + 5808*D1*Dd*f*g2*s - 2244*D1*Dd*f*g2 + 6336*D1*Dd*f*gd2*r*s - 792*D1*Dd*f*gd2*r + 12672*D1*Dd*f*gd2*s**2 - 7920*D1*Dd*f*gd2*s + 792*D1*Dd*f*gd2 + 6336*D1*Dd*fd*g2*r*s - 3960*D1*Dd*fd*g2*r + 12672*D1*Dd*fd*g2*s**2 - 11088*D1*Dd*fd*g2*s + 3168*D1*Dd*fd*g2 + 2904*D1*Ddd*K*f**2*r*s - 726*D1*Ddd*K*f**2*r + 6864*D1*Ddd*K*f**2*s**2 - 4884*D1*Ddd*K*f**2*s + 1716*D1*Ddd*K*f**2 - 5600*D1*Ddd*f**3*r*s + 1400*D1*Ddd*f**3*r - 5600*D1*Ddd*f**3*s**2 + 5600*D1*Ddd*f**3*s - 1400*D1*Ddd*f**3 - 4224*D1*Ddd*f**2*r*s + 1056*D1*Ddd*f**2*r - 6204*D1*Ddd*f**2*s**2 + 5214*D1*Ddd*f**2*s - 1551*D1*Ddd*f**2 + 3168*D1*Ddd*f*g2*r*s - 792*D1*Ddd*f*g2*r + 6336*D1*Ddd*f*g2*s**2 - 4752*D1*Ddd*f*g2*s + 1584*D1*Ddd*f*g2 + 66*D1*bd1*(K - 1)*(D1*(f*(10*r*s + 34*s**2 - 29*s + 12) - 6*fd*(4*r*s - 2*r + 8*s**2 - 7*s + 1)) - 6*Dd*f*(2*r*(8*s - 1) + 32*s**2 - 24*s + 3)) + 8712*Dd**2*K*f**2*r*s - 2178*Dd**2*K*f**2*r + 20592*Dd**2*K*f**2*s**2 - 14652*Dd**2*K*f**2*s + 1452*Dd**2*K*f**2 - 16800*Dd**2*f**3*r*s + 4200*Dd**2*f**3*r - 16800*Dd**2*f**3*s**2 + 16800*Dd**2*f**3*s - 2800*Dd**2*f**3 - 12672*Dd**2*f**2*r*s + 3168*Dd**2*f**2*r - 18612*Dd**2*f**2*s**2 + 15642*Dd**2*f**2*s - 2112*Dd**2*f**2 + 9504*Dd**2*f*g2*r*s - 2376*Dd**2*f*g2*r + 19008*Dd**2*f*g2*s**2 - 14256*Dd**2*f*g2*s + 1584*Dd**2*f*g2))/(9009*d**2*k2*k3**4) - D1**2*Pk3*ct**5*k1*k2*st**2*(-970944*C*D1**2*Pk2*f**2*fd*r*s + 323648*C*D1**2*Pk2*f**2*fd*r + 936000*C*D1**2*Pk2*f**2*fd*s**2 - 300352*C*D1**2*Pk2*f**2*fd*s + 312000*C*D1**2*Pk2*f**2*fd + 567840*C*D1**2*Pk2*f**2*fdd*r*s - 189280*C*D1**2*Pk2*f**2*fdd*r - 468000*C*D1**2*Pk2*f**2*fdd*s**2 + 122720*C*D1**2*Pk2*f**2*fdd*s - 156000*C*D1**2*Pk2*f**2*fdd + 1135680*C*D1**2*Pk2*f*fd**2*r*s - 378560*C*D1**2*Pk2*f*fd**2*r - 936000*C*D1**2*Pk2*f*fd**2*s**2 + 245440*C*D1**2*Pk2*f*fd**2*s + 189280*C*D1**2*Pk2*f*fd**2 + 78000*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 52000*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 26000*C*D1**2*Pkdd2*f**2*fd*k1**2 - 39000*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 26000*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 13000*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 78000*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 52000*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 1294592*C*D1*Dd*Pk2*f**3*r*s + 323648*C*D1*Dd*Pk2*f**3*r + 1248000*C*D1*Dd*Pk2*f**3*s**2 + 23296*C*D1*Dd*Pk2*f**3*s + 312000*C*D1*Dd*Pk2*f**3 + 4542720*C*D1*Dd*Pk2*f**2*fd*r*s - 1324960*C*D1*Dd*Pk2*f**2*fd*r - 3744000*C*D1*Dd*Pk2*f**2*fd*s**2 + 291200*C*D1*Dd*Pk2*f**2*fd*s + 255840*C*D1*Dd*Pk2*f**2*fd + 104000*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 52000*C*D1*Dd*Pkdd2*f**3*k1**2*s + 26000*C*D1*Dd*Pkdd2*f**3*k1**2 - 312000*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 182000*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 26000*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 757120*C*D1*Ddd*Pk2*f**3*r*s - 189280*C*D1*Ddd*Pk2*f**3*r - 624000*C*D1*Ddd*Pk2*f**3*s**2 - 66560*C*D1*Ddd*Pk2*f**3*s - 156000*C*D1*Ddd*Pk2*f**3 - 52000*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 26000*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 13000*C*D1*Ddd*Pkdd2*f**3*k1**2 + 2271360*C*Dd**2*Pk2*f**3*r*s - 567840*C*Dd**2*Pk2*f**3*r - 1872000*C*Dd**2*Pk2*f**3*s**2 - 199680*C*Dd**2*Pk2*f**3*s + 378560*C*Dd**2*Pk2*f**3 - 156000*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 78000*C*Dd**2*Pkdd2*f**3*k1**2*s + 102960*D1**2*K*Pk2*bdd1*f**2*r*s - 102960*D1**2*K*Pk2*bdd1*f**2*s**2 - 102960*D1**2*K*Pk2*bdd1*f**2*s - 8580*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 109200*D1**2*Pk2*bdd1*f**3*r*s - 54600*D1**2*Pk2*bdd1*f**3*s**2 + 109200*D1**2*Pk2*bdd1*f**3*s - 205920*D1**2*Pk2*bdd1*f**2*r*s - 51480*D1**2*Pk2*bdd1*f**2*s**2 + 205920*D1**2*Pk2*bdd1*f**2*s - 436800*D1**2*Pk2*f**3*fd*r*s + 109200*D1**2*Pk2*f**3*fd*r + 218400*D1**2*Pk2*f**3*fd*s + 436800*D1**2*Pk2*f**3*fdd*r*s - 109200*D1**2*Pk2*f**3*fdd*r - 218400*D1**2*Pk2*f**3*fdd*s + 1310400*D1**2*Pk2*f**2*fd**2*r*s - 327600*D1**2*Pk2*f**2*fd**2*r - 655200*D1**2*Pk2*f**2*fd**2*s + 218400*D1**2*Pk2*f**2*fd**2 + 1438944*D1**2*Pk2*f**2*fd*r*s - 479648*D1**2*Pk2*f**2*fd*r - 234000*D1**2*Pk2*f**2*fd*s**2 - 323648*D1**2*Pk2*f**2*fd*s - 78000*D1**2*Pk2*f**2*fd - 801840*D1**2*Pk2*f**2*fdd*r*s + 267280*D1**2*Pk2*f**2*fdd*r + 117000*D1**2*Pk2*f**2*fdd*s**2 + 189280*D1**2*Pk2*f**2*fdd*s + 39000*D1**2*Pk2*f**2*fdd + 411840*D1**2*Pk2*f**2*gd2*r*s - 411840*D1**2*Pk2*f**2*gd2*s**2 - 411840*D1**2*Pk2*f**2*gd2*s - 205920*D1**2*Pk2*f**2*gdd2*r*s + 205920*D1**2*Pk2*f**2*gdd2*s**2 + 205920*D1**2*Pk2*f**2*gdd2*s - 1603680*D1**2*Pk2*f*fd**2*r*s + 534560*D1**2*Pk2*f*fd**2*r + 234000*D1**2*Pk2*f*fd**2*s**2 + 378560*D1**2*Pk2*f*fd**2*s - 267280*D1**2*Pk2*f*fd**2 + 823680*D1**2*Pk2*f*fd*g2*r*s - 411840*D1**2*Pk2*f*fd*g2*r - 823680*D1**2*Pk2*f*fd*g2*s**2 + 823680*D1**2*Pk2*f*fd*g2*s - 411840*D1**2*Pk2*f*fd*g2 - 823680*D1**2*Pk2*f*fd*gd2*r*s + 205920*D1**2*Pk2*f*fd*gd2*r + 823680*D1**2*Pk2*f*fd*gd2*s**2 - 205920*D1**2*Pk2*f*fd*gd2 - 411840*D1**2*Pk2*f*fdd*g2*r*s + 205920*D1**2*Pk2*f*fdd*g2*r + 411840*D1**2*Pk2*f*fdd*g2*s**2 - 411840*D1**2*Pk2*f*fdd*g2*s + 205920*D1**2*Pk2*f*fdd*g2 - 411840*D1**2*Pk2*fd**2*g2*r*s + 205920*D1**2*Pk2*fd**2*g2*r + 411840*D1**2*Pk2*fd**2*g2*s**2 - 411840*D1**2*Pk2*fd**2*g2*s + 8580*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 123480*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 61740*D1**2*Pkdd2*f**3*fd*k1**2*s + 30870*D1**2*Pkdd2*f**3*fd*k1**2 - 61740*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 30870*D1**2*Pkdd2*f**3*fdd*k1**2*s - 15435*D1**2*Pkdd2*f**3*fdd*k1**2 - 185220*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 92610*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 78000*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 52000*D1**2*Pkdd2*f**2*fd*k1**2*s - 26000*D1**2*Pkdd2*f**2*fd*k1**2 + 39000*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 26000*D1**2*Pkdd2*f**2*fdd*k1**2*s + 13000*D1**2*Pkdd2*f**2*fdd*k1**2 - 34320*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 17160*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 78000*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 52000*D1**2*Pkdd2*f*fd**2*k1**2*s - 68640*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 68640*D1**2*Pkdd2*f*fd*g2*k1**2*s - 34320*D1**2*Pkdd2*f*fd*g2*k1**2 + 68640*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 34320*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 34320*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 34320*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 17160*D1**2*Pkdd2*f*fdd*g2*k1**2 + 34320*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 34320*D1**2*Pkdd2*fd**2*g2*k1**2*s - 436800*D1*Dd*Pk2*f**4*r*s + 109200*D1*Dd*Pk2*f**4*r + 218400*D1*Dd*Pk2*f**4*s + 3494400*D1*Dd*Pk2*f**3*fd*r*s - 873600*D1*Dd*Pk2*f**3*fd*r - 1747200*D1*Dd*Pk2*f**3*fd*s + 436800*D1*Dd*Pk2*f**3*fd + 1918592*D1*Dd*Pk2*f**3*r*s - 479648*D1*Dd*Pk2*f**3*r - 312000*D1*Dd*Pk2*f**3*s**2 - 803296*D1*Dd*Pk2*f**3*s - 78000*D1*Dd*Pk2*f**3 - 6414720*D1*Dd*Pk2*f**2*fd*r*s + 1870960*D1*Dd*Pk2*f**2*fd*r + 936000*D1*Dd*Pk2*f**2*fd*s**2 + 2126800*D1*Dd*Pk2*f**2*fd*s - 723840*D1*Dd*Pk2*f**2*fd + 1647360*D1*Dd*Pk2*f**2*g2*r*s - 411840*D1*Dd*Pk2*f**2*g2*r - 1647360*D1*Dd*Pk2*f**2*g2*s**2 - 411840*D1*Dd*Pk2*f**2*g2 - 1647360*D1*Dd*Pk2*f**2*gd2*r*s + 205920*D1*Dd*Pk2*f**2*gd2*r + 1647360*D1*Dd*Pk2*f**2*gd2*s**2 + 823680*D1*Dd*Pk2*f**2*gd2*s - 205920*D1*Dd*Pk2*f**2*gd2 - 3294720*D1*Dd*Pk2*f*fd*g2*r*s + 1235520*D1*Dd*Pk2*f*fd*g2*r + 3294720*D1*Dd*Pk2*f*fd*g2*s**2 - 1647360*D1*Dd*Pk2*f*fd*g2*s + 123480*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 61740*D1*Dd*Pkdd2*f**4*k1**2*s + 30870*D1*Dd*Pkdd2*f**4*k1**2 - 493920*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 246960*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 30870*D1*Dd*Pkdd2*f**3*fd*k1**2 - 104000*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 52000*D1*Dd*Pkdd2*f**3*k1**2*s - 26000*D1*Dd*Pkdd2*f**3*k1**2 + 312000*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 182000*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 26000*D1*Dd*Pkdd2*f**2*fd*k1**2 - 137280*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 68640*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 34320*D1*Dd*Pkdd2*f**2*g2*k1**2 + 137280*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 34320*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 274560*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 205920*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 34320*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 436800*D1*Ddd*Pk2*f**4*r*s - 109200*D1*Ddd*Pk2*f**4*r - 218400*D1*Ddd*Pk2*f**4*s - 1069120*D1*Ddd*Pk2*f**3*r*s + 267280*D1*Ddd*Pk2*f**3*r + 156000*D1*Ddd*Pk2*f**3*s**2 + 456560*D1*Ddd*Pk2*f**3*s + 39000*D1*Ddd*Pk2*f**3 - 823680*D1*Ddd*Pk2*f**2*g2*r*s + 205920*D1*Ddd*Pk2*f**2*g2*r + 823680*D1*Ddd*Pk2*f**2*g2*s**2 + 205920*D1*Ddd*Pk2*f**2*g2 - 61740*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 30870*D1*Ddd*Pkdd2*f**4*k1**2*s - 15435*D1*Ddd*Pkdd2*f**4*k1**2 + 52000*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 26000*D1*Ddd*Pkdd2*f**3*k1**2*s + 13000*D1*Ddd*Pkdd2*f**3*k1**2 + 68640*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 34320*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 17160*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 1560*D1*bd1*f*(D1*(f*s*(70*Pk2*f*(2*r + s - 2) - 66*Pk2*(2*K*(r - s - 1) - 4*r - s + 4) + Pkdd2*k1**2*s*(11*K - 11)) - fd*(70*Pk2*f*(r*(6*s - 1) + 3*s**2 - 5*s + 1) - 66*Pk2*(K*r*(4*s - 1) - 4*K*s**2 + K + r*(2 - 8*s) - 2*s**2 + 5*s - 2) + Pkdd2*k1**2*s*(11*K - 11)*(2*s - 1))) - Dd*f*(70*Pk2*f*(r*(8*s - 1) + 4*s**2 - 7*s + 1) - 66*Pk2*(-K*(-8*r*s + r + 8*s**2 + 4*s - 1) - 16*r*s + 2*r - 4*s**2 + 13*s - 2) + Pkdd2*k1**2*s*(11*K - 11)*(4*s - 1))) + 1310400*Dd**2*Pk2*f**4*r*s - 327600*Dd**2*Pk2*f**4*r - 655200*Dd**2*Pk2*f**4*s + 218400*Dd**2*Pk2*f**4 - 3207360*Dd**2*Pk2*f**3*r*s + 801840*Dd**2*Pk2*f**3*r + 468000*Dd**2*Pk2*f**3*s**2 + 1369680*Dd**2*Pk2*f**3*s - 534560*Dd**2*Pk2*f**3 - 2471040*Dd**2*Pk2*f**2*g2*r*s + 617760*Dd**2*Pk2*f**2*g2*r + 2471040*Dd**2*Pk2*f**2*g2*s**2 - 411840*Dd**2*Pk2*f**2*g2 - 185220*Dd**2*Pkdd2*f**4*k1**2*s**2 + 92610*Dd**2*Pkdd2*f**4*k1**2*s + 156000*Dd**2*Pkdd2*f**3*k1**2*s**2 - 78000*Dd**2*Pkdd2*f**3*k1**2*s + 205920*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 102960*Dd**2*Pkdd2*f**2*g2*k1**2*s + 780*b1*(D1**2*(70*Pk2*f**2*(2*fd - fdd)*(3*s - 1)*(2*r + s - 1) + f*(-140*Pk2*fd**2*(3*s - 1)*(2*r + s - 1) - 132*Pk2*fd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) + r*(4 - 8*s) - 2*s**2 + 2*s - 1) + 66*Pk2*fdd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) + r*(4 - 8*s) - 2*s**2 + 2*s - 1) + 22*Pkdd2*fd*k1**2*(K - 1)*(2*s**2 - 2*s + 1) - 11*Pkdd2*fdd*k1**2*(K - 1)*(2*s**2 - 2*s + 1)) + 22*fd**2*(Pk2*r*(6*K - 12)*(2*s - 1) + Pk2*s*(-12*K - 6)*(s - 1) + Pkdd2*k1**2*s*(-K*s + K + s - 1))) + D1*f*(2*Dd*(70*Pk2*f**2*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + f*(-70*Pk2*fd*(r*(24*s - 7) + 12*s**2 - 17*s + 4) - 66*Pk2*(-2*K*(-4*r*s + r + 4*s**2 + 1) + r*(4 - 16*s) - 4*s**2 + 10*s - 1) + Pkdd2*k1**2*(11*K - 11)*(4*s**2 - 2*s + 1)) + 11*fd*(Pk2*r*(12*K - 24)*(8*s - 3) - 6*Pk2*(2*s - 1)*(s*(8*K + 4) - 5) - Pkdd2*k1**2*(K - 1)*(8*s**2 - 6*s + 1))) - Ddd*f*(70*Pk2*f*(r*(8*s - 2) + 4*s**2 - 6*s + 1) - 66*Pk2*(-2*K*(-4*r*s + r + 4*s**2 + 1) - 16*r*s + 4*r - 4*s**2 + 10*s - 1) + Pkdd2*k1**2*(11*K - 11)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(70*Pk2*f*(3*r*(4*s - 1) + 6*s**2 - 9*s + 2) - 66*Pk2*(K*(12*r*s - 3*r - 12*s**2 + 2) - 24*r*s + 6*r - 6*s**2 + 15*s - 4) + Pkdd2*k1**2*s*(33*K - 33)*(2*s - 1))))/(18018*d**2*k3**4) - D1**2*Pk3*ct**5*k1*k2*(3168*C*D1**2*Pk2*bdd1*f**2*r**2 + 1056*C*D1**2*Pk2*bdd1*f**2*r*s - 3168*C*D1**2*Pk2*bdd1*f**2*r - 5280*C*D1**2*Pk2*bdd1*f**2*s**2 + 24936*C*D1**2*Pk2*f**2*fd*r**2 - 48672*C*D1**2*Pk2*f**2*fd*r*s - 400*C*D1**2*Pk2*f**2*fd*r - 81480*C*D1**2*Pk2*f**2*fd*s**2 + 70544*C*D1**2*Pk2*f**2*fd*s - 18848*C*D1**2*Pk2*f**2*fd - 13656*C*D1**2*Pk2*f**2*fdd*r**2 + 26712*C*D1**2*Pk2*f**2*fdd*r*s + 200*C*D1**2*Pk2*f**2*fdd*r + 62520*C*D1**2*Pk2*f**2*fdd*s**2 - 50584*C*D1**2*Pk2*f**2*fdd*s + 16288*C*D1**2*Pk2*f**2*fdd - 27312*C*D1**2*Pk2*f*fd**2*r**2 + 53424*C*D1**2*Pk2*f*fd**2*r*s + 400*C*D1**2*Pk2*f*fd**2*r + 125040*C*D1**2*Pk2*f*fd**2*s**2 - 101168*C*D1**2*Pk2*f*fd**2*s + 8904*C*D1**2*Pk2*f*fd**2 - 660*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 1320*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 660*C*D1**2*Pkdd2*bdd1*f**2*k1**2 + 1380*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 920*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 460*C*D1**2*Pkdd2*f**2*fd*k1**2 - 1680*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 1120*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 560*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 3360*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 2240*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 33248*C*D1*Dd*Pk2*f**3*r**2 - 64896*C*D1*Dd*Pk2*f**3*r*s - 17024*C*D1*Dd*Pk2*f**3*r - 108640*C*D1*Dd*Pk2*f**3*s**2 + 86768*C*D1*Dd*Pk2*f**3*s - 10536*C*D1*Dd*Pk2*f**3 - 109248*C*D1*Dd*Pk2*f**2*fd*r**2 + 213696*C*D1*Dd*Pk2*f**2*fd*r*s + 28712*C*D1*Dd*Pk2*f**2*fd*r + 500160*C*D1*Dd*Pk2*f**2*fd*s**2 - 380800*C*D1*Dd*Pk2*f**2*fd*s + 50184*C*D1*Dd*Pk2*f**2*fd + 1840*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 920*C*D1*Dd*Pkdd2*f**3*k1**2*s + 460*C*D1*Dd*Pkdd2*f**3*k1**2 - 13440*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 7840*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 1120*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 18208*C*D1*Ddd*Pk2*f**3*r**2 + 35616*C*D1*Ddd*Pk2*f**3*r*s + 9304*C*D1*Ddd*Pk2*f**3*r + 83360*C*D1*Ddd*Pk2*f**3*s**2 - 59488*C*D1*Ddd*Pk2*f**3*s + 11736*C*D1*Ddd*Pk2*f**3 - 2240*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 1120*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 560*C*D1*Ddd*Pkdd2*f**3*k1**2 - 54624*C*Dd**2*Pk2*f**3*r**2 + 106848*C*Dd**2*Pk2*f**3*r*s + 27912*C*Dd**2*Pk2*f**3*r + 250080*C*Dd**2*Pk2*f**3*s**2 - 178464*C*Dd**2*Pk2*f**3*s + 8704*C*Dd**2*Pk2*f**3 - 6720*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 3360*C*Dd**2*Pkdd2*f**3*k1**2*s - 2244*D1**2*K*Pk2*bdd1*f**2*r**2 + 5148*D1**2*K*Pk2*bdd1*f**2*r*s + 4488*D1**2*K*Pk2*bdd1*f**2*r + 12408*D1**2*K*Pk2*bdd1*f**2*s**2 - 5148*D1**2*K*Pk2*bdd1*f**2*s - 2244*D1**2*K*Pk2*bdd1*f**2 - 330*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 12672*D1**2*Pk2*b2*f*fd*r*s + 6336*D1**2*Pk2*b2*f*fd*r - 12672*D1**2*Pk2*b2*f*fd*s**2 + 12672*D1**2*Pk2*b2*f*fd*s - 6336*D1**2*Pk2*b2*f*fd + 7920*D1**2*Pk2*b2*f*fdd*r*s - 3960*D1**2*Pk2*b2*f*fdd*r + 7920*D1**2*Pk2*b2*f*fdd*s**2 - 7920*D1**2*Pk2*b2*f*fdd*s + 3960*D1**2*Pk2*b2*f*fdd + 7920*D1**2*Pk2*b2*fd**2*r*s - 3960*D1**2*Pk2*b2*fd**2*r + 7920*D1**2*Pk2*b2*fd**2*s**2 - 7920*D1**2*Pk2*b2*fd**2*s - 6336*D1**2*Pk2*bd2*f**2*r*s - 6336*D1**2*Pk2*bd2*f**2*s**2 + 6336*D1**2*Pk2*bd2*f**2*s + 15840*D1**2*Pk2*bd2*f*fd*r*s - 3960*D1**2*Pk2*bd2*f*fd*r + 15840*D1**2*Pk2*bd2*f*fd*s**2 - 15840*D1**2*Pk2*bd2*f*fd*s + 3960*D1**2*Pk2*bd2*f*fd + 4950*D1**2*Pk2*bdd1*f**3*r**2 + 5940*D1**2*Pk2*bdd1*f**3*r*s - 8580*D1**2*Pk2*bdd1*f**3*r - 3300*D1**2*Pk2*bdd1*f**3*s + 3630*D1**2*Pk2*bdd1*f**3 + 3036*D1**2*Pk2*bdd1*f**2*r**2 + 6204*D1**2*Pk2*bdd1*f**2*r*s - 7920*D1**2*Pk2*bdd1*f**2*r + 2640*D1**2*Pk2*bdd1*f**2*s**2 - 7260*D1**2*Pk2*bdd1*f**2*s + 4884*D1**2*Pk2*bdd1*f**2 - 3168*D1**2*Pk2*bdd1*f*g2*r**2 + 3168*D1**2*Pk2*bdd1*f*g2*r + 6336*D1**2*Pk2*bdd1*f*g2*s**2 + 3960*D1**2*Pk2*bdd2*f**2*r*s + 3960*D1**2*Pk2*bdd2*f**2*s**2 - 3960*D1**2*Pk2*bdd2*f**2*s + 11880*D1**2*Pk2*f**3*fd*r**2 + 15840*D1**2*Pk2*f**3*fd*r*s - 15840*D1**2*Pk2*f**3*fd*r - 7920*D1**2*Pk2*f**3*fd*s + 5940*D1**2*Pk2*f**3*fd - 11880*D1**2*Pk2*f**3*fdd*r**2 - 15840*D1**2*Pk2*f**3*fdd*r*s + 15840*D1**2*Pk2*f**3*fdd*r + 7920*D1**2*Pk2*f**3*fdd*s - 5940*D1**2*Pk2*f**3*fdd - 35640*D1**2*Pk2*f**2*fd**2*r**2 - 47520*D1**2*Pk2*f**2*fd**2*r*s + 47520*D1**2*Pk2*f**2*fd**2*r + 23760*D1**2*Pk2*f**2*fd**2*s - 13860*D1**2*Pk2*f**2*fd**2 - 39606*D1**2*Pk2*f**2*fd*r**2 - 11508*D1**2*Pk2*f**2*fd*r*s + 30240*D1**2*Pk2*f**2*fd*r + 36780*D1**2*Pk2*f**2*fd*s**2 - 20684*D1**2*Pk2*f**2*fd*s - 942*D1**2*Pk2*f**2*fd + 25446*D1**2*Pk2*f**2*fdd*r**2 + 14268*D1**2*Pk2*f**2*fdd*r*s - 21720*D1**2*Pk2*f**2*fdd*r - 31260*D1**2*Pk2*f**2*fdd*s**2 + 16084*D1**2*Pk2*f**2*fdd*s - 1938*D1**2*Pk2*f**2*fdd - 5808*D1**2*Pk2*f**2*gd2*r**2 + 17424*D1**2*Pk2*f**2*gd2*r*s + 11616*D1**2*Pk2*f**2*gd2*r + 32208*D1**2*Pk2*f**2*gd2*s**2 - 17424*D1**2*Pk2*f**2*gd2*s - 5808*D1**2*Pk2*f**2*gd2 + 4488*D1**2*Pk2*f**2*gdd2*r**2 - 10296*D1**2*Pk2*f**2*gdd2*r*s - 8976*D1**2*Pk2*f**2*gdd2*r - 24816*D1**2*Pk2*f**2*gdd2*s**2 + 10296*D1**2*Pk2*f**2*gdd2*s + 4488*D1**2*Pk2*f**2*gdd2 + 50892*D1**2*Pk2*f*fd**2*r**2 + 28536*D1**2*Pk2*f*fd**2*r*s - 43440*D1**2*Pk2*f*fd**2*r - 62520*D1**2*Pk2*f*fd**2*s**2 + 32168*D1**2*Pk2*f*fd**2*s + 4756*D1**2*Pk2*f*fd**2 - 11616*D1**2*Pk2*f*fd*g2*r**2 + 34848*D1**2*Pk2*f*fd*g2*r*s - 17424*D1**2*Pk2*f*fd*g2*r + 64416*D1**2*Pk2*f*fd*g2*s**2 - 64416*D1**2*Pk2*f*fd*g2*s + 32208*D1**2*Pk2*f*fd*g2 + 17952*D1**2*Pk2*f*fd*gd2*r**2 - 41184*D1**2*Pk2*f*fd*gd2*r*s - 7656*D1**2*Pk2*f*fd*gd2*r - 99264*D1**2*Pk2*f*fd*gd2*s**2 + 70224*D1**2*Pk2*f*fd*gd2*s - 10296*D1**2*Pk2*f*fd*gd2 + 8976*D1**2*Pk2*f*fdd*g2*r**2 - 20592*D1**2*Pk2*f*fdd*g2*r*s + 10296*D1**2*Pk2*f*fdd*g2*r - 49632*D1**2*Pk2*f*fdd*g2*s**2 + 49632*D1**2*Pk2*f*fdd*g2*s - 24816*D1**2*Pk2*f*fdd*g2 + 8976*D1**2*Pk2*fd**2*g2*r**2 - 20592*D1**2*Pk2*fd**2*g2*r*s + 10296*D1**2*Pk2*fd**2*g2*r - 49632*D1**2*Pk2*fd**2*g2*s**2 + 49632*D1**2*Pk2*fd**2*g2*s + 840*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 420*D1**2*Pkdd2*bdd1*f**3*k1**2 + 825*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 1320*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 660*D1**2*Pkdd2*bdd1*f**2*k1**2 + 792*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 1584*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 792*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 1680*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 840*D1**2*Pkdd2*f**3*fd*k1**2*s - 420*D1**2*Pkdd2*f**3*fd*k1**2 - 540*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 360*D1**2*Pkdd2*f**2*fd*k1**2*s - 180*D1**2*Pkdd2*f**2*fd*k1**2 + 1260*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 840*D1**2*Pkdd2*f**2*fdd*k1**2*s + 420*D1**2*Pkdd2*f**2*fdd*k1**2 - 528*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 660*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 2520*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 1680*D1**2*Pkdd2*f*fd**2*k1**2*s - 1056*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 1056*D1**2*Pkdd2*f*fd*g2*k1**2*s - 528*D1**2*Pkdd2*f*fd*g2*k1**2 + 2640*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 1320*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 1320*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 1320*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 660*D1**2*Pkdd2*f*fdd*g2*k1**2 + 1320*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 1320*D1**2*Pkdd2*fd**2*g2*k1**2*s + 264*D1**2*bd1**2*f*(Pk2*(6*K*(2*r**2 - 3*r - 4*s**2 + 1) + 5*f*(r + 2*s - 1) - (12*r - 12)*(r + 2*s - 1)) + 3*Pkdd2*k1**2*s*(-K*s + K + s - 1)) - 25344*D1*Dd*Pk2*b2*f**2*r*s + 6336*D1*Dd*Pk2*b2*f**2*r - 25344*D1*Dd*Pk2*b2*f**2*s**2 + 25344*D1*Dd*Pk2*b2*f**2*s - 6336*D1*Dd*Pk2*b2*f**2 + 63360*D1*Dd*Pk2*b2*f*fd*r*s - 23760*D1*Dd*Pk2*b2*f*fd*r + 63360*D1*Dd*Pk2*b2*f*fd*s**2 - 63360*D1*Dd*Pk2*b2*f*fd*s + 15840*D1*Dd*Pk2*b2*f*fd + 31680*D1*Dd*Pk2*bd2*f**2*r*s - 3960*D1*Dd*Pk2*bd2*f**2*r + 31680*D1*Dd*Pk2*bd2*f**2*s**2 - 31680*D1*Dd*Pk2*bd2*f**2*s + 3960*D1*Dd*Pk2*bd2*f**2 + 11880*D1*Dd*Pk2*f**4*r**2 + 15840*D1*Dd*Pk2*f**4*r*s - 15840*D1*Dd*Pk2*f**4*r - 7920*D1*Dd*Pk2*f**4*s + 5940*D1*Dd*Pk2*f**4 - 95040*D1*Dd*Pk2*f**3*fd*r**2 - 126720*D1*Dd*Pk2*f**3*fd*r*s + 126720*D1*Dd*Pk2*f**3*fd*r + 63360*D1*Dd*Pk2*f**3*fd*s - 39600*D1*Dd*Pk2*f**3*fd - 52808*D1*Dd*Pk2*f**3*r**2 - 15344*D1*Dd*Pk2*f**3*r*s + 56644*D1*Dd*Pk2*f**3*r + 49040*D1*Dd*Pk2*f**3*s**2 - 16848*D1*Dd*Pk2*f**3*s - 14144*D1*Dd*Pk2*f**3 + 203568*D1*Dd*Pk2*f**2*fd*r**2 + 114144*D1*Dd*Pk2*f**2*fd*r*s - 202932*D1*Dd*Pk2*f**2*fd*r - 250080*D1*Dd*Pk2*f**2*fd*s**2 + 98320*D1*Dd*Pk2*f**2*fd*s + 27356*D1*Dd*Pk2*f**2*fd - 23232*D1*Dd*Pk2*f**2*g2*r**2 + 69696*D1*Dd*Pk2*f**2*g2*r*s + 5808*D1*Dd*Pk2*f**2*g2*r + 128832*D1*Dd*Pk2*f**2*g2*s**2 - 99264*D1*Dd*Pk2*f**2*g2*s + 20592*D1*Dd*Pk2*f**2*g2 + 35904*D1*Dd*Pk2*f**2*gd2*r**2 - 82368*D1*Dd*Pk2*f**2*gd2*r*s - 43560*D1*Dd*Pk2*f**2*gd2*r - 198528*D1*Dd*Pk2*f**2*gd2*s**2 + 111408*D1*Dd*Pk2*f**2*gd2*s + 7656*D1*Dd*Pk2*f**2*gd2 + 71808*D1*Dd*Pk2*f*fd*g2*r**2 - 164736*D1*Dd*Pk2*f*fd*g2*r*s + 25872*D1*Dd*Pk2*f*fd*g2*r - 397056*D1*Dd*Pk2*f*fd*g2*s**2 + 338976*D1*Dd*Pk2*f*fd*g2*s - 70224*D1*Dd*Pk2*f*fd*g2 - 1680*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 840*D1*Dd*Pkdd2*f**4*k1**2*s - 420*D1*Dd*Pkdd2*f**4*k1**2 - 720*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 360*D1*Dd*Pkdd2*f**3*k1**2*s - 180*D1*Dd*Pkdd2*f**3*k1**2 + 10080*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 5880*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 840*D1*Dd*Pkdd2*f**2*fd*k1**2 - 2112*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 1056*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 528*D1*Dd*Pkdd2*f**2*g2*k1**2 + 5280*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 1320*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 10560*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 7920*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 1320*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 15840*D1*Ddd*Pk2*b2*f**2*r*s - 3960*D1*Ddd*Pk2*b2*f**2*r + 15840*D1*Ddd*Pk2*b2*f**2*s**2 - 15840*D1*Ddd*Pk2*b2*f**2*s + 3960*D1*Ddd*Pk2*b2*f**2 - 11880*D1*Ddd*Pk2*f**4*r**2 - 15840*D1*Ddd*Pk2*f**4*r*s + 15840*D1*Ddd*Pk2*f**4*r + 7920*D1*Ddd*Pk2*f**4*s - 5940*D1*Ddd*Pk2*f**4 + 33928*D1*Ddd*Pk2*f**3*r**2 + 19024*D1*Ddd*Pk2*f**3*r*s - 38684*D1*Ddd*Pk2*f**3*r - 41680*D1*Ddd*Pk2*f**3*s**2 + 11328*D1*Ddd*Pk2*f**3*s + 6544*D1*Ddd*Pk2*f**3 + 17952*D1*Ddd*Pk2*f**2*g2*r**2 - 41184*D1*Ddd*Pk2*f**2*g2*r*s - 7656*D1*Ddd*Pk2*f**2*g2*r - 99264*D1*Ddd*Pk2*f**2*g2*s**2 + 70224*D1*Ddd*Pk2*f**2*g2*s - 15840*D1*Ddd*Pk2*f**2*g2 + 1680*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 840*D1*Ddd*Pkdd2*f**3*k1**2*s + 420*D1*Ddd*Pkdd2*f**3*k1**2 + 2640*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 1320*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 660*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 6*D1*bd1*(D1*(5*f**3*(11*Pk2*(13*r**2 + 22*r*(s - 1) + 4*s**2 - 14*s + 9) + 28*Pkdd2*k1**2*(2*s - 1)) + f**2*(-22*Pk2*(-48*C*r**2 - 16*C*r*s + 48*C*r + 80*C*s**2 + 2*K*(11*r**2 - 11*r*(3*s + 2) - 61*s**2 + 33*s + 11) + 5*fd*(45*r**2 + r*(54*s - 65) - 28*s + 20) - 7*r**2 - 40*r*s + 42*r - 52*s**2 + 56*s - 35) - Pkdd2*k1**2*(220*C*(s - 1)**2 + s**2*(44*K - 209) + s*(280*fd + 440) - 220)) - 11*f*(-96*Pk2*g2*(-r**2 + r + 2*s**2) - 24*Pk2*gd2*(4*r**2 - 6*r - 8*s**2 + 2) - 24*Pkdd2*g2*k1**2*(s - 1)**2 + 24*Pkdd2*gd2*k1**2*s*(s - 1) + fd*(2*Pk2*(8*C*(12*r**2 + 2*r*(2*s - 5) - 20*s**2 + 9*s + 3) + K*(-68*r**2 + 156*r*s + 29*r + 376*s**2 - 266*s + 39) + 92*r**2 + 188*r*s - 153*r + 80*s**2 - 142*s + 41) - 5*Pkdd2*k1**2*s*(8*C*(s - 1) + K*(4*s - 2) - 10*s + 9))) + 264*fd*g2*(4*Pk2*(r**2 - s*(2*s - 2)) - Pkdd2*k1**2*s*(s - 1))) - Dd*f*(10*f**2*(11*Pk2*(60*r**2 + r*(72*s - 91) - 38*s + 31) + 14*Pkdd2*k1**2*(4*s - 1)) + 11*f*(2*Pk2*(8*C*(24*r**2 + r*(8*s - 25) - 40*s**2 + 8*s + 6) + K*(-136*r**2 + 312*r*s + 165*r + 752*s**2 - 422*s - 29) + 184*r**2 + 376*r*s - 379*r + 160*s**2 - 354*s + 175) - 5*Pkdd2*k1**2*(4*s - 1)*(4*C*(s - 1) + s*(2*K - 5) + 4)) + 264*g2*(-4*Pk2*(4*r**2 - 4*r - 8*s**2 + 2*s + 1) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 47520*Dd**2*Pk2*b2*f**2*r*s - 11880*Dd**2*Pk2*b2*f**2*r + 47520*Dd**2*Pk2*b2*f**2*s**2 - 47520*Dd**2*Pk2*b2*f**2*s + 7920*Dd**2*Pk2*b2*f**2 - 35640*Dd**2*Pk2*f**4*r**2 - 47520*Dd**2*Pk2*f**4*r*s + 47520*Dd**2*Pk2*f**4*r + 23760*Dd**2*Pk2*f**4*s - 13860*Dd**2*Pk2*f**4 + 101784*Dd**2*Pk2*f**3*r**2 + 57072*Dd**2*Pk2*f**3*r*s - 116052*Dd**2*Pk2*f**3*r - 125040*Dd**2*Pk2*f**3*s**2 + 33984*Dd**2*Pk2*f**3*s + 26476*Dd**2*Pk2*f**3 + 53856*Dd**2*Pk2*f**2*g2*r**2 - 123552*Dd**2*Pk2*f**2*g2*r*s - 22968*Dd**2*Pk2*f**2*g2*r - 297792*Dd**2*Pk2*f**2*g2*s**2 + 210672*Dd**2*Pk2*f**2*g2*s - 11616*Dd**2*Pk2*f**2*g2 + 5040*Dd**2*Pkdd2*f**3*k1**2*s**2 - 2520*Dd**2*Pkdd2*f**3*k1**2*s + 7920*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 3960*Dd**2*Pkdd2*f**2*g2*k1**2*s + 132*b1**2*(D1**2*(-10*Pk2*fd**2*(r + 2*s - 1) + 4*Pk2*fd*(-6*K*(r**2 + r - 2*(s - 1)**2) + 5*f*(r + 2*s - 1) + (6*r + 6)*(r + 2*s - 1)) - 2*Pk2*fdd*(-6*K*(r**2 + r - 2*(s - 1)**2) + 5*f*(r + 2*s - 1) + (6*r + 6)*(r + 2*s - 1)) + 6*Pkdd2*fd*k1**2*s**2*(K - 1) - 3*Pkdd2*fdd*k1**2*s**2*(K - 1)) - D1*(2*Dd*(f*(4*Pk2*(5*fd*(r + 2*s - 1) + r**2*(12*K - 12) - 6*r*(2*K + 4*s - 3) - (12*s - 6)*(2*K*s - 1)) + Pkdd2*k1**2*(3 - 3*K)*(4*s**2 - 2*s + 1)) + 3*fd*(-4*K*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + 4*Pk2*(4*r + 1)*(r + 2*s - 1) + Pkdd2*k1**2*s*(K - 1)*(4*s - 1))) + 3*Ddd*f*(-8*Pk2*(r**2*(2*K - 2) + r*(-2*K - 4*s + 3) - (2*s - 1)*(2*K*s - 1)) + Pkdd2*k1**2*(K - 1)*(4*s**2 - 2*s + 1))) + 6*Dd**2*f*(4*Pk2*(K*(6*r**2 - 6*r - 12*s**2 + 6*s + 1) + (3 - 6*r)*(r + 2*s - 1)) + 3*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1))) - 3*b1*(4224*C*D1**2*Pk2*f*fd*r**2 + 1408*C*D1**2*Pk2*f*fd*r*s - 2816*C*D1**2*Pk2*f*fd*r - 7040*C*D1**2*Pk2*f*fd*s**2 + 6336*C*D1**2*Pk2*f*fd*s - 1408*C*D1**2*Pk2*f*fd - 2112*C*D1**2*Pk2*f*fdd*r**2 - 704*C*D1**2*Pk2*f*fdd*r*s + 1408*C*D1**2*Pk2*f*fdd*r + 3520*C*D1**2*Pk2*f*fdd*s**2 - 3168*C*D1**2*Pk2*f*fdd*s + 704*C*D1**2*Pk2*f*fdd - 2112*C*D1**2*Pk2*fd**2*r**2 - 704*C*D1**2*Pk2*fd**2*r*s + 1408*C*D1**2*Pk2*fd**2*r + 3520*C*D1**2*Pk2*fd**2*s**2 - 3168*C*D1**2*Pk2*fd**2*s + 704*C*D1**2*Pk2*fd**2 - 880*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 440*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 440*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 8448*C*D1*Dd*Pk2*f**2*r**2 + 2816*C*D1*Dd*Pk2*f**2*r*s - 9152*C*D1*Dd*Pk2*f**2*r - 14080*C*D1*Dd*Pk2*f**2*s**2 + 5632*C*D1*Dd*Pk2*f**2*s + 704*C*D1*Dd*Pk2*f**2 - 16896*C*D1*Dd*Pk2*f*fd*r**2 - 5632*C*D1*Dd*Pk2*f*fd*r*s + 14784*C*D1*Dd*Pk2*f*fd*r + 28160*C*D1*Dd*Pk2*f*fd*s**2 - 18304*C*D1*Dd*Pk2*f*fd*s + 352*C*D1*Dd*Pk2*f*fd - 1760*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 880*C*D1*Dd*Pkdd2*f**2*k1**2*s - 440*C*D1*Dd*Pkdd2*f**2*k1**2 + 3520*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 880*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 4224*C*D1*Ddd*Pk2*f**2*r**2 - 1408*C*D1*Ddd*Pk2*f**2*r*s + 4576*C*D1*Ddd*Pk2*f**2*r + 7040*C*D1*Ddd*Pk2*f**2*s**2 - 2816*C*D1*Ddd*Pk2*f**2*s - 352*C*D1*Ddd*Pk2*f**2 + 880*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 440*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 220*C*D1*Ddd*Pkdd2*f**2*k1**2 - 12672*C*Dd**2*Pk2*f**2*r**2 - 4224*C*Dd**2*Pk2*f**2*r*s + 13728*C*Dd**2*Pk2*f**2*r + 21120*C*Dd**2*Pk2*f**2*s**2 - 8448*C*Dd**2*Pk2*f**2*s - 2816*C*Dd**2*Pk2*f**2 + 2640*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 1320*C*Dd**2*Pkdd2*f**2*k1**2*s - 1936*D1**2*K*Pk2*f*fd*r**2 + 5808*D1**2*K*Pk2*f*fd*r*s - 2904*D1**2*K*Pk2*f*fd*r + 10736*D1**2*K*Pk2*f*fd*s**2 - 10736*D1**2*K*Pk2*f*fd*s + 5368*D1**2*K*Pk2*f*fd + 1496*D1**2*K*Pk2*f*fdd*r**2 - 3432*D1**2*K*Pk2*f*fdd*r*s + 1716*D1**2*K*Pk2*f*fdd*r - 8272*D1**2*K*Pk2*f*fdd*s**2 + 8272*D1**2*K*Pk2*f*fdd*s - 4136*D1**2*K*Pk2*f*fdd + 1496*D1**2*K*Pk2*fd**2*r**2 - 3432*D1**2*K*Pk2*fd**2*r*s + 1716*D1**2*K*Pk2*fd**2*r - 8272*D1**2*K*Pk2*fd**2*s**2 + 8272*D1**2*K*Pk2*fd**2*s - 176*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 176*D1**2*K*Pkdd2*f*fd*k1**2*s - 88*D1**2*K*Pkdd2*f*fd*k1**2 + 220*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 220*D1**2*K*Pkdd2*f*fdd*k1**2*s + 110*D1**2*K*Pkdd2*f*fdd*k1**2 + 220*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 220*D1**2*K*Pkdd2*fd**2*k1**2*s + 4290*D1**2*Pk2*f**2*fd*r**2 + 7260*D1**2*Pk2*f**2*fd*r*s - 5720*D1**2*Pk2*f**2*fd*r + 1320*D1**2*Pk2*f**2*fd*s**2 - 4180*D1**2*Pk2*f**2*fd*s + 2310*D1**2*Pk2*f**2*fd - 4950*D1**2*Pk2*f**2*fdd*r**2 - 5940*D1**2*Pk2*f**2*fdd*r*s + 5720*D1**2*Pk2*f**2*fdd*r + 2860*D1**2*Pk2*f**2*fdd*s - 2090*D1**2*Pk2*f**2*fdd - 9900*D1**2*Pk2*f*fd**2*r**2 - 11880*D1**2*Pk2*f*fd**2*r*s + 11440*D1**2*Pk2*f*fd**2*r + 5720*D1**2*Pk2*f*fd**2*s - 2860*D1**2*Pk2*f*fd**2 + 616*D1**2*Pk2*f*fd*r**2 + 3520*D1**2*Pk2*f*fd*r*s - 528*D1**2*Pk2*f*fd*r + 4576*D1**2*Pk2*f*fd*s**2 - 3872*D1**2*Pk2*f*fd*s + 1056*D1**2*Pk2*f*fd - 2024*D1**2*Pk2*f*fdd*r**2 - 4136*D1**2*Pk2*f*fdd*r*s + 1452*D1**2*Pk2*f*fdd*r - 1760*D1**2*Pk2*f*fdd*s**2 + 1408*D1**2*Pk2*f*fdd*s - 264*D1**2*Pk2*f*fdd - 2112*D1**2*Pk2*f*gd2*r**2 + 4224*D1**2*Pk2*f*gd2*r + 4224*D1**2*Pk2*f*gd2*s**2 - 2112*D1**2*Pk2*f*gd2 + 1056*D1**2*Pk2*f*gdd2*r**2 - 2112*D1**2*Pk2*f*gdd2*r - 2112*D1**2*Pk2*f*gdd2*s**2 + 1056*D1**2*Pk2*f*gdd2 - 2024*D1**2*Pk2*fd**2*r**2 - 4136*D1**2*Pk2*fd**2*r*s + 1452*D1**2*Pk2*fd**2*r - 1760*D1**2*Pk2*fd**2*s**2 + 1408*D1**2*Pk2*fd**2*s - 264*D1**2*Pk2*fd**2 - 2112*D1**2*Pk2*fd*g2*r**2 - 2112*D1**2*Pk2*fd*g2*r + 4224*D1**2*Pk2*fd*g2*s**2 - 8448*D1**2*Pk2*fd*g2*s + 4224*D1**2*Pk2*fd*g2 + 2112*D1**2*Pk2*fd*gd2*r**2 - 1056*D1**2*Pk2*fd*gd2*r - 4224*D1**2*Pk2*fd*gd2*s**2 + 4224*D1**2*Pk2*fd*gd2*s - 1056*D1**2*Pk2*fd*gd2 + 1056*D1**2*Pk2*fdd*g2*r**2 + 1056*D1**2*Pk2*fdd*g2*r - 2112*D1**2*Pk2*fdd*g2*s**2 + 4224*D1**2*Pk2*fdd*g2*s - 2112*D1**2*Pk2*fdd*g2 - 560*D1**2*Pkdd2*f**2*fd*k1**2*s + 280*D1**2*Pkdd2*f**2*fd*k1**2 + 280*D1**2*Pkdd2*f**2*fdd*k1**2*s - 140*D1**2*Pkdd2*f**2*fdd*k1**2 + 560*D1**2*Pkdd2*f*fd**2*k1**2*s + 836*D1**2*Pkdd2*f*fd*k1**2*s**2 + 44*D1**2*Pkdd2*f*fd*k1**2*s - 22*D1**2*Pkdd2*f*fd*k1**2 - 550*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 110*D1**2*Pkdd2*f*fdd*k1**2*s - 55*D1**2*Pkdd2*f*fdd*k1**2 + 528*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 264*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 550*D1**2*Pkdd2*fd**2*k1**2*s**2 + 110*D1**2*Pkdd2*fd**2*k1**2*s + 528*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 528*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 264*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 44*D1**2*bdd1*f*(2*Pk2*(6*K*(2*r**2 - 3*r - 4*s**2 + 1) + 5*f*(r + 2*s - 1) - (12*r - 12)*(r + 2*s - 1)) + Pkdd2*k1**2*(3 - 3*K)*(2*s**2 - 2*s + 1)) - 3872*D1*Dd*K*Pk2*f**2*r**2 + 11616*D1*Dd*K*Pk2*f**2*r*s + 968*D1*Dd*K*Pk2*f**2*r + 21472*D1*Dd*K*Pk2*f**2*s**2 - 16544*D1*Dd*K*Pk2*f**2*s + 3432*D1*Dd*K*Pk2*f**2 + 11968*D1*Dd*K*Pk2*f*fd*r**2 - 27456*D1*Dd*K*Pk2*f*fd*r*s + 4312*D1*Dd*K*Pk2*f*fd*r - 66176*D1*Dd*K*Pk2*f*fd*s**2 + 56496*D1*Dd*K*Pk2*f*fd*s - 11704*D1*Dd*K*Pk2*f*fd - 352*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 176*D1*Dd*K*Pkdd2*f**2*k1**2*s - 88*D1*Dd*K*Pkdd2*f**2*k1**2 + 1760*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 1320*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 220*D1*Dd*K*Pkdd2*f*fd*k1**2 + 5720*D1*Dd*Pk2*f**3*r**2 + 9680*D1*Dd*Pk2*f**3*r*s - 8140*D1*Dd*Pk2*f**3*r + 1760*D1*Dd*Pk2*f**3*s**2 - 5720*D1*Dd*Pk2*f**3*s + 3300*D1*Dd*Pk2*f**3 - 39600*D1*Dd*Pk2*f**2*fd*r**2 - 47520*D1*Dd*Pk2*f**2*fd*r*s + 48620*D1*Dd*Pk2*f**2*fd*r + 23320*D1*Dd*Pk2*f**2*fd*s - 14300*D1*Dd*Pk2*f**2*fd + 1232*D1*Dd*Pk2*f**2*r**2 + 7040*D1*Dd*Pk2*f**2*r*s - 2992*D1*Dd*Pk2*f**2*r + 9152*D1*Dd*Pk2*f**2*s**2 - 8096*D1*Dd*Pk2*f**2*s + 2904*D1*Dd*Pk2*f**2 - 16192*D1*Dd*Pk2*f*fd*r**2 - 33088*D1*Dd*Pk2*f*fd*r*s + 18040*D1*Dd*Pk2*f*fd*r - 14080*D1*Dd*Pk2*f*fd*s**2 + 17424*D1*Dd*Pk2*f*fd*s - 4312*D1*Dd*Pk2*f*fd - 8448*D1*Dd*Pk2*f*g2*r**2 + 8448*D1*Dd*Pk2*f*g2*r + 16896*D1*Dd*Pk2*f*g2*s**2 - 8448*D1*Dd*Pk2*f*g2*s + 8448*D1*Dd*Pk2*f*gd2*r**2 - 12672*D1*Dd*Pk2*f*gd2*r - 16896*D1*Dd*Pk2*f*gd2*s**2 + 4224*D1*Dd*Pk2*f*gd2*s + 4224*D1*Dd*Pk2*f*gd2 + 8448*D1*Dd*Pk2*fd*g2*r**2 - 16896*D1*Dd*Pk2*fd*g2*s**2 + 21120*D1*Dd*Pk2*fd*g2*s - 6336*D1*Dd*Pk2*fd*g2 + 1120*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 280*D1*Dd*Pkdd2*f**2*fd*k1**2 + 1672*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 836*D1*Dd*Pkdd2*f**2*k1**2*s + 418*D1*Dd*Pkdd2*f**2*k1**2 - 4400*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 1540*D1*Dd*Pkdd2*f*fd*k1**2*s - 110*D1*Dd*Pkdd2*f*fd*k1**2 + 2112*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 1056*D1*Dd*Pkdd2*f*g2*k1**2*s + 528*D1*Dd*Pkdd2*f*g2*k1**2 - 2112*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 528*D1*Dd*Pkdd2*f*gd2*k1**2*s - 2112*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 528*D1*Dd*Pkdd2*fd*g2*k1**2*s + 2992*D1*Ddd*K*Pk2*f**2*r**2 - 6864*D1*Ddd*K*Pk2*f**2*r*s - 1276*D1*Ddd*K*Pk2*f**2*r - 16544*D1*Ddd*K*Pk2*f**2*s**2 + 11704*D1*Ddd*K*Pk2*f**2*s - 2640*D1*Ddd*K*Pk2*f**2 + 440*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 220*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 110*D1*Ddd*K*Pkdd2*f**2*k1**2 - 6600*D1*Ddd*Pk2*f**3*r**2 - 7920*D1*Ddd*Pk2*f**3*r*s + 8580*D1*Ddd*Pk2*f**3*r + 3960*D1*Ddd*Pk2*f**3*s - 3300*D1*Ddd*Pk2*f**3 - 4048*D1*Ddd*Pk2*f**2*r**2 - 8272*D1*Ddd*Pk2*f**2*r*s + 6116*D1*Ddd*Pk2*f**2*r - 3520*D1*Ddd*Pk2*f**2*s**2 + 5896*D1*Ddd*Pk2*f**2*s - 2904*D1*Ddd*Pk2*f**2 + 4224*D1*Ddd*Pk2*f*g2*r**2 - 4224*D1*Ddd*Pk2*f*g2*r - 8448*D1*Ddd*Pk2*f*g2*s**2 + 4224*D1*Ddd*Pk2*f*g2*s - 1100*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 550*D1*Ddd*Pkdd2*f**2*k1**2*s - 275*D1*Ddd*Pkdd2*f**2*k1**2 - 1056*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 528*D1*Ddd*Pkdd2*f*g2*k1**2*s - 264*D1*Ddd*Pkdd2*f*g2*k1**2 + 88*D1*bd1*(D1*(10*Pk2*f**2*(r + 2*s - 1) + 3*f*(4*K*Pk2*(2*r**2 - 3*r - 4*s**2 + 1) - 8*Pk2*(r - 1)*(r + 2*s - 1) - Pkdd2*k1**2*(K - 1)*(2*s**2 - 2*s + 1)) + 3*fd*(2*K*Pk2*(-4*r**2 + r + 8*s**2 - 8*s + 1) + K*Pkdd2*k1**2*s*(2*s - 1) + 8*Pk2*r*(r + 2*s - 1) + Pkdd2*k1**2*s*(1 - 2*s))) + Dd*f*(-4*Pk2*(3*K*(8*r**2 - 10*r - 16*s**2 + 4*s + 3) + 5*f*(r + 2*s - 1) - (24*r - 18)*(r + 2*s - 1)) + Pkdd2*k1**2*(3*K - 3)*(8*s**2 - 6*s + 1))) + 8976*Dd**2*K*Pk2*f**2*r**2 - 20592*Dd**2*K*Pk2*f**2*r*s - 3828*Dd**2*K*Pk2*f**2*r - 49632*Dd**2*K*Pk2*f**2*s**2 + 35112*Dd**2*K*Pk2*f**2*s - 1936*Dd**2*K*Pk2*f**2 + 1320*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 660*Dd**2*K*Pkdd2*f**2*k1**2*s - 19800*Dd**2*Pk2*f**3*r**2 - 23760*Dd**2*Pk2*f**3*r*s + 25740*Dd**2*Pk2*f**3*r + 11880*Dd**2*Pk2*f**3*s - 7260*Dd**2*Pk2*f**3 - 12144*Dd**2*Pk2*f**2*r**2 - 24816*Dd**2*Pk2*f**2*r*s + 18348*Dd**2*Pk2*f**2*r - 10560*Dd**2*Pk2*f**2*s**2 + 17688*Dd**2*Pk2*f**2*s - 6160*Dd**2*Pk2*f**2 + 12672*Dd**2*Pk2*f*g2*r**2 - 12672*Dd**2*Pk2*f*g2*r - 25344*Dd**2*Pk2*f*g2*s**2 + 12672*Dd**2*Pk2*f*g2*s + 2112*Dd**2*Pk2*f*g2 - 3300*Dd**2*Pkdd2*f**2*k1**2*s**2 + 1650*Dd**2*Pkdd2*f**2*k1**2*s - 3168*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 1584*Dd**2*Pkdd2*f*g2*k1**2*s))/(693*d**2*k3**4) - D1**2*Pk3*ct**5*k1*(6336*C*D1**2*Pk2*bdd1*f**2*r*s - 5280*C*D1**2*Pk2*bdd1*f**2*s**2 - 26880*C*D1**2*Pk2*f**2*fd*s**2 + 17920*C*D1**2*Pk2*f**2*fd*s - 8960*C*D1**2*Pk2*f**2*fd + 13440*C*D1**2*Pk2*f**2*fdd*s**2 - 8960*C*D1**2*Pk2*f**2*fdd*s + 4480*C*D1**2*Pk2*f**2*fdd + 26880*C*D1**2*Pk2*f*fd**2*s**2 - 17920*C*D1**2*Pk2*f*fd**2*s - 35840*C*D1*Dd*Pk2*f**3*s**2 + 17920*C*D1*Dd*Pk2*f**3*s - 8960*C*D1*Dd*Pk2*f**3 + 107520*C*D1*Dd*Pk2*f**2*fd*s**2 - 62720*C*D1*Dd*Pk2*f**2*fd*s + 8960*C*D1*Dd*Pk2*f**2*fd + 17920*C*D1*Ddd*Pk2*f**3*s**2 - 8960*C*D1*Ddd*Pk2*f**3*s + 4480*C*D1*Ddd*Pk2*f**3 + 53760*C*Dd**2*Pk2*f**3*s**2 - 26880*C*Dd**2*Pk2*f**3*s + 2640*D1**2*K*Pk2*bdd1*f**2*s**2 - 10560*D1**2*Pk2*b2*f*fd*s**2 + 10560*D1**2*Pk2*b2*f*fd*s - 5280*D1**2*Pk2*b2*f*fd + 5280*D1**2*Pk2*b2*f*fdd*s**2 - 5280*D1**2*Pk2*b2*f*fdd*s + 2640*D1**2*Pk2*b2*f*fdd + 5280*D1**2*Pk2*b2*fd**2*s**2 - 5280*D1**2*Pk2*b2*fd**2*s + 528*D1**2*Pk2*bd1**2*f*s*(6*K*(2*r - 2*s - 1) + 5*f - 12*r + 12) - 5280*D1**2*Pk2*bd2*f**2*s**2 + 10560*D1**2*Pk2*bd2*f*fd*s**2 - 5280*D1**2*Pk2*bd2*f*fd*s + 7920*D1**2*Pk2*bdd1*f**3*r*s + 7260*D1**2*Pk2*bdd1*f**3*s**2 - 5280*D1**2*Pk2*bdd1*f**3*s - 528*D1**2*Pk2*bdd1*f**2*r*s + 11088*D1**2*Pk2*bdd1*f**2*s**2 - 3168*D1**2*Pk2*bdd1*f**2*s - 1320*D1**2*Pk2*bdd1*f**2 - 6336*D1**2*Pk2*bdd1*f*g2*r*s + 6336*D1**2*Pk2*bdd1*f*g2*s**2 + 2640*D1**2*Pk2*bdd2*f**2*s**2 - 26160*D1**2*Pk2*f**2*fd*r*s + 8720*D1**2*Pk2*f**2*fd*r - 15060*D1**2*Pk2*f**2*fd*s**2 + 18760*D1**2*Pk2*f**2*fd*s - 5020*D1**2*Pk2*f**2*fd + 17040*D1**2*Pk2*f**2*fdd*r*s - 5680*D1**2*Pk2*f**2*fdd*r + 14460*D1**2*Pk2*f**2*fdd*s**2 - 15320*D1**2*Pk2*f**2*fdd*s + 4820*D1**2*Pk2*f**2*fdd + 10560*D1**2*Pk2*f**2*gd2*s**2 - 5280*D1**2*Pk2*f**2*gdd2*s**2 + 34080*D1**2*Pk2*f*fd**2*r*s - 11360*D1**2*Pk2*f*fd**2*r + 28920*D1**2*Pk2*f*fd**2*s**2 - 30640*D1**2*Pk2*f*fd**2*s + 5680*D1**2*Pk2*f*fd**2 + 21120*D1**2*Pk2*f*fd*g2*s**2 - 21120*D1**2*Pk2*f*fd*g2*s + 10560*D1**2*Pk2*f*fd*g2 - 21120*D1**2*Pk2*f*fd*gd2*s**2 + 10560*D1**2*Pk2*f*fd*gd2*s - 10560*D1**2*Pk2*f*fdd*g2*s**2 + 10560*D1**2*Pk2*f*fdd*g2*s - 5280*D1**2*Pk2*f*fdd*g2 - 10560*D1**2*Pk2*fd**2*g2*s**2 + 10560*D1**2*Pk2*fd**2*g2*s - 280*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 165*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 840*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 560*D1**2*Pkdd2*f**2*fd*k1**2*s + 280*D1**2*Pkdd2*f**2*fd*k1**2 - 420*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 280*D1**2*Pkdd2*f**2*fdd*k1**2*s - 140*D1**2*Pkdd2*f**2*fdd*k1**2 - 840*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 560*D1**2*Pkdd2*f*fd**2*k1**2*s - 21120*D1*Dd*Pk2*b2*f**2*s**2 + 10560*D1*Dd*Pk2*b2*f**2*s - 5280*D1*Dd*Pk2*b2*f**2 + 42240*D1*Dd*Pk2*b2*f*fd*s**2 - 31680*D1*Dd*Pk2*b2*f*fd*s + 5280*D1*Dd*Pk2*b2*f*fd + 21120*D1*Dd*Pk2*bd2*f**2*s**2 - 5280*D1*Dd*Pk2*bd2*f**2*s - 34880*D1*Dd*Pk2*f**3*r*s + 8720*D1*Dd*Pk2*f**3*r - 20080*D1*Dd*Pk2*f**3*s**2 + 27480*D1*Dd*Pk2*f**3*s - 5020*D1*Dd*Pk2*f**3 + 136320*D1*Dd*Pk2*f**2*fd*r*s - 39760*D1*Dd*Pk2*f**2*fd*r + 115680*D1*Dd*Pk2*f**2*fd*s**2 - 124280*D1*Dd*Pk2*f**2*fd*s + 26680*D1*Dd*Pk2*f**2*fd + 42240*D1*Dd*Pk2*f**2*g2*s**2 - 21120*D1*Dd*Pk2*f**2*g2*s + 10560*D1*Dd*Pk2*f**2*g2 - 42240*D1*Dd*Pk2*f**2*gd2*s**2 + 10560*D1*Dd*Pk2*f**2*gd2*s - 84480*D1*Dd*Pk2*f*fd*g2*s**2 + 63360*D1*Dd*Pk2*f*fd*g2*s - 10560*D1*Dd*Pk2*f*fd*g2 + 1120*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 560*D1*Dd*Pkdd2*f**3*k1**2*s + 280*D1*Dd*Pkdd2*f**3*k1**2 - 3360*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 1960*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 280*D1*Dd*Pkdd2*f**2*fd*k1**2 + 10560*D1*Ddd*Pk2*b2*f**2*s**2 - 5280*D1*Ddd*Pk2*b2*f**2*s + 2640*D1*Ddd*Pk2*b2*f**2 + 22720*D1*Ddd*Pk2*f**3*r*s - 5680*D1*Ddd*Pk2*f**3*r + 19280*D1*Ddd*Pk2*f**3*s**2 - 21000*D1*Ddd*Pk2*f**3*s + 4820*D1*Ddd*Pk2*f**3 - 21120*D1*Ddd*Pk2*f**2*g2*s**2 + 10560*D1*Ddd*Pk2*f**2*g2*s - 5280*D1*Ddd*Pk2*f**2*g2 - 560*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 280*D1*Ddd*Pkdd2*f**3*k1**2*s - 140*D1*Ddd*Pkdd2*f**3*k1**2 - 2*D1*bd1*(D1*(-3168*Pk2*fd*g2*(-2*r*s + r + s*(2*s - 2)) + 10*f**3*s*(33*Pk2*(12*r + 15*s - 8) - 28*Pkdd2*k1**2*s) - f**2*(132*Pk2*(5*fd*(6*r*(6*s - 1) + 33*s**2 - 31*s + 4) + s**2*(40*C - 20*K - 63) + s*(-48*C*r + 16*r + 12) + 10) + 5*Pkdd2*k1**2*s*(-56*fd*(3*s - 1) + 33*s)) - 33*f*(8*Pk2*fd*(r*(12*C - 1)*(4*s - 1) + s**2*(-40*C + 20*K + 84) + s*(8*C - 10*K - 47) + 11) + 96*Pk2*s*(2*g2*r - 2*g2*s - 2*gd2*r + 2*gd2*s + gd2) + 5*Pkdd2*fd*k1**2*s*(1 - 2*s))) + Dd*f*(-3168*Pk2*g2*(-8*r*s + r + 8*s**2) - 20*f**2*(33*Pk2*(48*r*s - 6*r + 44*s**2 - 39*s + 4) + 14*Pkdd2*k1**2*s*(1 - 4*s)) - 33*f*(8*Pk2*(r*(12*C - 1)*(8*s - 1) + s**2*(-80*C + 40*K + 168) - s*(4*C + 10*K + 64) + 6) + 5*Pkdd2*k1**2*s*(1 - 4*s)))) + 31680*Dd**2*Pk2*b2*f**2*s**2 - 15840*Dd**2*Pk2*b2*f**2*s + 68160*Dd**2*Pk2*f**3*r*s - 17040*Dd**2*Pk2*f**3*r + 57840*Dd**2*Pk2*f**3*s**2 - 63000*Dd**2*Pk2*f**3*s + 11360*Dd**2*Pk2*f**3 - 63360*Dd**2*Pk2*f**2*g2*s**2 + 31680*Dd**2*Pk2*f**2*g2*s - 1680*Dd**2*Pkdd2*f**3*k1**2*s**2 + 840*Dd**2*Pkdd2*f**3*k1**2*s + 264*Pk2*b1**2*(-2*D1*Dd*(12*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s) + fd*(48*K*s**2 - 48*K*s + 5*f*(4*s - 1) - r*(6*K - 6)*(8*s - 5) + 12*s + 6)) - D1*(D1*(-10*f*fd*(2*s - 1) + 5*f*fdd*(2*s - 1) + 10*fd**2*s + 12*fd*(2*K*(s - 1)*(r - s + 1) - 2*r*s + 2*r - 2*s + 1) - 6*fdd*(2*K*(s - 1)*(r - s + 1) - 2*r*s + 2*r - 2*s + 1)) - 12*Ddd*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s)) + 12*Dd**2*f*(K*(12*r*s - 3*r - 12*s**2 + 2) - 12*r*s + 3*r + 6*s - 2)) + b1*(-25344*C*D1**2*Pk2*f*fd*r*s + 12672*C*D1**2*Pk2*f*fd*r + 21120*C*D1**2*Pk2*f*fd*s**2 - 8448*C*D1**2*Pk2*f*fd*s + 10560*C*D1**2*Pk2*f*fd + 12672*C*D1**2*Pk2*f*fdd*r*s - 6336*C*D1**2*Pk2*f*fdd*r - 10560*C*D1**2*Pk2*f*fdd*s**2 + 4224*C*D1**2*Pk2*f*fdd*s - 5280*C*D1**2*Pk2*f*fdd + 12672*C*D1**2*Pk2*fd**2*r*s - 6336*C*D1**2*Pk2*fd**2*r - 10560*C*D1**2*Pk2*fd**2*s**2 + 4224*C*D1**2*Pk2*fd**2*s + 6336*C*D1**2*Pk2*fd**2 - 50688*C*D1*Dd*Pk2*f**2*r*s + 12672*C*D1*Dd*Pk2*f**2*r + 42240*C*D1*Dd*Pk2*f**2*s**2 + 4224*C*D1*Dd*Pk2*f**2*s + 10560*C*D1*Dd*Pk2*f**2 + 101376*C*D1*Dd*Pk2*f*fd*r*s - 38016*C*D1*Dd*Pk2*f*fd*r - 84480*C*D1*Dd*Pk2*f*fd*s**2 + 12672*C*D1*Dd*Pk2*f*fd*s + 8448*C*D1*Dd*Pk2*f*fd + 25344*C*D1*Ddd*Pk2*f**2*r*s - 6336*C*D1*Ddd*Pk2*f**2*r - 21120*C*D1*Ddd*Pk2*f**2*s**2 - 2112*C*D1*Ddd*Pk2*f**2*s - 5280*C*D1*Ddd*Pk2*f**2 + 76032*C*Dd**2*Pk2*f**2*r*s - 19008*C*Dd**2*Pk2*f**2*r - 63360*C*Dd**2*Pk2*f**2*s**2 - 6336*C*Dd**2*Pk2*f**2*s + 12672*C*Dd**2*Pk2*f**2 - 10560*D1**2*K*Pk2*f*fd*s**2 + 10560*D1**2*K*Pk2*f*fd*s - 5280*D1**2*K*Pk2*f*fd + 5280*D1**2*K*Pk2*f*fdd*s**2 - 5280*D1**2*K*Pk2*f*fdd*s + 2640*D1**2*K*Pk2*f*fdd + 5280*D1**2*K*Pk2*fd**2*s**2 - 5280*D1**2*K*Pk2*fd**2*s + 264*D1**2*Pk2*bdd1*f*(-24*K*s**2 + 5*f*(2*s - 1) - 6*s*(-4*K*r + 2*K + 4*r - 4) - 6) - 23760*D1**2*Pk2*f**2*fd*r*s + 7920*D1**2*Pk2*f**2*fd*r - 29700*D1**2*Pk2*f**2*fd*s**2 + 30360*D1**2*Pk2*f**2*fd*s - 9900*D1**2*Pk2*f**2*fd + 23760*D1**2*Pk2*f**2*fdd*r*s - 7920*D1**2*Pk2*f**2*fdd*r + 21780*D1**2*Pk2*f**2*fdd*s**2 - 25080*D1**2*Pk2*f**2*fdd*s + 7260*D1**2*Pk2*f**2*fdd + 47520*D1**2*Pk2*f*fd**2*r*s - 15840*D1**2*Pk2*f*fd**2*r + 43560*D1**2*Pk2*f*fd**2*s**2 - 50160*D1**2*Pk2*f*fd**2*s + 10560*D1**2*Pk2*f*fd**2 + 8448*D1**2*Pk2*f*fd*r*s - 4224*D1**2*Pk2*f*fd*r - 33264*D1**2*Pk2*f*fd*s**2 + 25872*D1**2*Pk2*f*fd*s - 19272*D1**2*Pk2*f*fd - 1056*D1**2*Pk2*f*fdd*r*s + 528*D1**2*Pk2*f*fdd*r + 22176*D1**2*Pk2*f*fdd*s**2 - 18480*D1**2*Pk2*f*fdd*s + 12408*D1**2*Pk2*f*fdd + 12672*D1**2*Pk2*f*gd2*r*s - 12672*D1**2*Pk2*f*gd2*s**2 - 12672*D1**2*Pk2*f*gd2*s - 6336*D1**2*Pk2*f*gdd2*r*s + 6336*D1**2*Pk2*f*gdd2*s**2 + 6336*D1**2*Pk2*f*gdd2*s - 1056*D1**2*Pk2*fd**2*r*s + 528*D1**2*Pk2*fd**2*r + 22176*D1**2*Pk2*fd**2*s**2 - 18480*D1**2*Pk2*fd**2*s - 6336*D1**2*Pk2*fd**2 + 12672*D1**2*Pk2*fd*g2*r*s - 12672*D1**2*Pk2*fd*g2*r - 12672*D1**2*Pk2*fd*g2*s**2 + 25344*D1**2*Pk2*fd*g2*s - 12672*D1**2*Pk2*fd*g2 - 12672*D1**2*Pk2*fd*gd2*r*s + 6336*D1**2*Pk2*fd*gd2*r + 12672*D1**2*Pk2*fd*gd2*s**2 - 6336*D1**2*Pk2*fd*gd2*s - 6336*D1**2*Pk2*fd*gd2 - 6336*D1**2*Pk2*fdd*g2*r*s + 6336*D1**2*Pk2*fdd*g2*r + 6336*D1**2*Pk2*fdd*g2*s**2 - 12672*D1**2*Pk2*fdd*g2*s + 6336*D1**2*Pk2*fdd*g2 + 1680*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 1120*D1**2*Pkdd2*f**2*fd*k1**2*s + 560*D1**2*Pkdd2*f**2*fd*k1**2 - 840*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 560*D1**2*Pkdd2*f**2*fdd*k1**2*s - 280*D1**2*Pkdd2*f**2*fdd*k1**2 - 1680*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 1120*D1**2*Pkdd2*f*fd**2*k1**2*s + 660*D1**2*Pkdd2*f*fd*k1**2*s**2 - 660*D1**2*Pkdd2*f*fd*k1**2*s + 330*D1**2*Pkdd2*f*fd*k1**2 - 330*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 330*D1**2*Pkdd2*f*fdd*k1**2*s - 165*D1**2*Pkdd2*f*fdd*k1**2 - 330*D1**2*Pkdd2*fd**2*k1**2*s**2 + 330*D1**2*Pkdd2*fd**2*k1**2*s - 21120*D1*Dd*K*Pk2*f**2*s**2 + 10560*D1*Dd*K*Pk2*f**2*s - 5280*D1*Dd*K*Pk2*f**2 + 42240*D1*Dd*K*Pk2*f*fd*s**2 - 31680*D1*Dd*K*Pk2*f*fd*s + 5280*D1*Dd*K*Pk2*f*fd - 31680*D1*Dd*Pk2*f**3*r*s + 7920*D1*Dd*Pk2*f**3*r - 39600*D1*Dd*Pk2*f**3*s**2 + 35640*D1*Dd*Pk2*f**3*s - 9900*D1*Dd*Pk2*f**3 + 190080*D1*Dd*Pk2*f**2*fd*r*s - 55440*D1*Dd*Pk2*f**2*fd*r + 174240*D1*Dd*Pk2*f**2*fd*s**2 - 191400*D1*Dd*Pk2*f**2*fd*s + 40920*D1*Dd*Pk2*f**2*fd + 16896*D1*Dd*Pk2*f**2*r*s - 4224*D1*Dd*Pk2*f**2*r - 66528*D1*Dd*Pk2*f**2*s**2 + 24816*D1*Dd*Pk2*f**2*s - 16632*D1*Dd*Pk2*f**2 - 8448*D1*Dd*Pk2*f*fd*r*s + 3168*D1*Dd*Pk2*f*fd*r + 177408*D1*Dd*Pk2*f*fd*s**2 - 116160*D1*Dd*Pk2*f*fd*s + 17424*D1*Dd*Pk2*f*fd + 50688*D1*Dd*Pk2*f*g2*r*s - 12672*D1*Dd*Pk2*f*g2*r - 50688*D1*Dd*Pk2*f*g2*s**2 - 12672*D1*Dd*Pk2*f*g2 - 50688*D1*Dd*Pk2*f*gd2*r*s + 6336*D1*Dd*Pk2*f*gd2*r + 50688*D1*Dd*Pk2*f*gd2*s**2 + 25344*D1*Dd*Pk2*f*gd2*s - 6336*D1*Dd*Pk2*f*gd2 - 50688*D1*Dd*Pk2*fd*g2*r*s + 31680*D1*Dd*Pk2*fd*g2*r + 50688*D1*Dd*Pk2*fd*g2*s**2 - 50688*D1*Dd*Pk2*fd*g2*s + 2240*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 1120*D1*Dd*Pkdd2*f**3*k1**2*s + 560*D1*Dd*Pkdd2*f**3*k1**2 - 6720*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 3920*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 560*D1*Dd*Pkdd2*f**2*fd*k1**2 + 1320*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 660*D1*Dd*Pkdd2*f**2*k1**2*s + 330*D1*Dd*Pkdd2*f**2*k1**2 - 2640*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 1980*D1*Dd*Pkdd2*f*fd*k1**2*s - 330*D1*Dd*Pkdd2*f*fd*k1**2 + 10560*D1*Ddd*K*Pk2*f**2*s**2 - 5280*D1*Ddd*K*Pk2*f**2*s + 2640*D1*Ddd*K*Pk2*f**2 + 31680*D1*Ddd*Pk2*f**3*r*s - 7920*D1*Ddd*Pk2*f**3*r + 29040*D1*Ddd*Pk2*f**3*s**2 - 30360*D1*Ddd*Pk2*f**3*s + 7260*D1*Ddd*Pk2*f**3 - 2112*D1*Ddd*Pk2*f**2*r*s + 528*D1*Ddd*Pk2*f**2*r + 44352*D1*Ddd*Pk2*f**2*s**2 - 21120*D1*Ddd*Pk2*f**2*s + 11088*D1*Ddd*Pk2*f**2 - 25344*D1*Ddd*Pk2*f*g2*r*s + 6336*D1*Ddd*Pk2*f*g2*r + 25344*D1*Ddd*Pk2*f*g2*s**2 + 6336*D1*Ddd*Pk2*f*g2 - 1120*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 560*D1*Ddd*Pkdd2*f**3*k1**2*s - 280*D1*Ddd*Pkdd2*f**3*k1**2 - 660*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 330*D1*Ddd*Pkdd2*f**2*k1**2*s - 165*D1*Ddd*Pkdd2*f**2*k1**2 - 528*D1*Pk2*bd1*(D1*(5*f**2*(2*s - 1) - 6*f*(4*K*s**2 + s*(-4*K*r + 2*K + 4*r - 4) + 1) - 6*fd*(K*(4*r*s - 2*r - 4*s**2 + 3*s + 1) - 4*r*s + 2*r - 1)) + Dd*f*(-6*K*(16*r*s - 2*r - 16*s**2 - 4*s + 1) + f*(5 - 20*s) + 96*r*s - 12*r - 72*s + 12)) + 31680*Dd**2*K*Pk2*f**2*s**2 - 15840*Dd**2*K*Pk2*f**2*s + 95040*Dd**2*Pk2*f**3*r*s - 23760*Dd**2*Pk2*f**3*r + 87120*Dd**2*Pk2*f**3*s**2 - 91080*Dd**2*Pk2*f**3*s + 15840*Dd**2*Pk2*f**3 - 6336*Dd**2*Pk2*f**2*r*s + 1584*Dd**2*Pk2*f**2*r + 133056*Dd**2*Pk2*f**2*s**2 - 63360*Dd**2*Pk2*f**2*s - 1056*Dd**2*Pk2*f**2 - 76032*Dd**2*Pk2*f*g2*r*s + 19008*Dd**2*Pk2*f*g2*r + 76032*Dd**2*Pk2*f*g2*s**2 - 12672*Dd**2*Pk2*f*g2 - 3360*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1680*Dd**2*Pkdd2*f**3*k1**2*s - 1980*Dd**2*Pkdd2*f**2*k1**2*s**2 + 990*Dd**2*Pkdd2*f**2*k1**2*s))/(693*d**2*k2*k3**2) - D1**2*Pk3*ct**5*k2**3*(D1**2*(165*Pkdd2*bd1*f**3*k1**2*s**2 + 66*Pkdd2*k1**2*s*(b1**2*s*(5*fd**2 + 6*fd*(2*K - 1) + fdd*(3 - 6*K)) + b1*(-6*bd1*fd*(2*K - 1)*(2*s - 1) - 5*fd**2*(2*K*(s - 1) + s*(4*C - 3)) - 24*fd*s*(g2 - gd2) + 12*fdd*g2*s) + 4*fd*g2*(6*bd1 + 5*fd)*(s - 1)) + f**2*(33*Pkdd2*k1**2*(10*bd1**2*s*(s - 1) + bd1*(40*C*(s - 1)**2 + 8*K*s**2 - 10*b1*(2*s**2 - 2*s + 1) - 24*s**2 + 60*s - 30) + 5*bdd1*(-4*C*(s - 1)**2 - 2*K*s**2 + b1*(2*s**2 - 2*s + 1) + 3*s**2 - 6*s + 3) + s**2*(-16*gd2 + 20*gdd2)) + fd*(2*Pk2*(4*C*(1089*r**2 + 300*r*s - 826*r - 100*s + 363) - 2967*r**2 - 600*r*s + 2178*r + 200*s - 989) + Pkdd2*k1**2*(460*C + 165*b1 - 65)*(3*s**2 - 2*s + 1)) - 2*fdd*(Pk2*(4*C*(99*r**2 + 2*r*(75*s - 58) - 50*s + 33) - 147*r**2 - 300*r*s + 198*r + 100*s - 49) + Pkdd2*k1**2*(280*C - 140)*(3*s**2 - 2*s + 1))) - 2*f*(33*Pkdd2*fd*k1**2*(10*b1**2*s**2 + b1*(K*(-8*s**2 + 8*s - 4) - s**2*(40*C + 20*bd1 - 24) + s*(10*bd1 + 6) - 3) + 2*g2*(8*s**2 - 8*s + 4) + 10*s*(bd1*(4*C*(s - 1) + 2*K*s - K - 3*s + 3) - 4*gd2*s + 2*gd2)) - 33*Pkdd2*k1**2*(5*b1**2*fdd*s**2 + b1*(-20*C*fdd*s**2 - 10*K*fdd*s**2 + 10*K*fdd*s - 5*K*fdd + 6*bd1*(2*K - 1)*(2*s**2 - 2*s + 1) - 3*bdd1*(2*K - 1)*(2*s**2 - 2*s + 1) + 15*fdd*s**2 - 24*gd2*s**2 + 12*gdd2*s**2) - 6*bd1**2*s*(2*K - 1)*(s - 1) - 24*bd1*(s - 1)*(g2*(s - 1) - gd2*s) + 2*g2*(6*bdd1*(s - 1)**2 + 5*fdd*(2*s**2 - 2*s + 1))) + 2*fd**2*(Pk2*(4*C*(99*r**2 + 2*r*(75*s - 58) - 50*s + 25) - 147*r**2 - 300*r*s + 198*r + 100*s - 50) + Pkdd2*k1**2*s*(280*C - 140)*(3*s - 2)))) + D1*(Dd*(-396*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(b1*(2*K - 1) - 4*g2) + 132*Pkdd2*f*k1**2*(b1**2*(6*K*(4*s**2 - 2*s + 1) + s**2*(20*fd - 12) + s*(6 - 5*fd) - 3) - b1*(3*bd1*(2*K - 1)*(8*s**2 - 6*s + 1) + 12*g2*(4*s**2 - 2*s + 1) + (4*s - 1)*(5*fd*(4*C*s + 2*K*s - K - 3*s) - 12*gd2*s)) + 2*g2*(4*s - 1)*(6*bd1*(s - 1) + 5*fd*(2*s - 1))) + f**3*(4*Pk2*(4*C*(726*r**2 + 8*r*(25*s - 97) - 100*s + 363) - 1978*r**2 - 400*r*s + 2078*r + 200*s - 989) + Pkdd2*k1**2*(460*C + 165*b1 - 65)*(4*s**2 - 2*s + 1)) - 2*f**2*(33*Pkdd2*k1**2*(5*b1**2*(4*s**2 - 2*s + 1) - b1*(5*bd1*(8*s**2 - 6*s + 1) + (20*C + 4*K - 12)*(4*s**2 - 2*s + 1)) + 5*bd1*(4*s - 1)*(4*C*(s - 1) + 2*K*s - 3*s + 3) + 4*g2*(8*s**2 - 4*s + 2) + 20*gd2*s*(1 - 4*s)) + 8*fd*(Pk2*(C*(396*r**2 + 600*r*s - 505*r - 250*s + 141) - 147*r**2 - 300*r*s + 210*r + 125*s - 62) + Pkdd2*k1**2*(70*C - 35)*(12*s**2 - 7*s + 1)))) + Ddd*f*(-198*Pkdd2*b1*k1**2*(b1*(2*K - 1) - 4*g2)*(4*s**2 - 2*s + 1) + 165*Pkdd2*f*k1**2*(b1**2 + b1*(-4*C - 2*K + 3) + 4*g2)*(4*s**2 - 2*s + 1) - 4*f**2*(Pk2*(4*C*(66*r**2 + 100*r*s - 91*r - 50*s + 33) - 98*r**2 - 200*r*s + 148*r + 100*s - 49) + Pkdd2*k1**2*(140*C - 70)*(4*s**2 - 2*s + 1)))) + 2*Dd**2*f*(-594*Pkdd2*b1*k1**2*s*(2*s - 1)*(b1*(2*K - 1) - 4*g2) + 495*Pkdd2*f*k1**2*s*(2*s - 1)*(b1**2 + b1*(-4*C - 2*K + 3) + 4*g2) - 2*f**2*(Pk2*(4*C*(198*r**2 + 300*r*s - 273*r - 150*s + 83) - 294*r**2 - 600*r*s + 444*r + 300*s - 149) + Pkdd2*k1**2*s*(840*C - 420)*(2*s - 1))))/(693*d**2*k1*k3**4) + D1**2*Pk3*ct**5*k2*(D1**2*(165*Pkdd2*bd1*f**3*k1**2*s**2 + 66*Pkdd2*k1**2*(b1**2*(5*fd**2*s - 6*fd*(2*K*(s - 1)**2 + 2*s - 1) + 3*fdd*(2*K*(s - 1)**2 + 2*s - 1)) + b1*(5*fd**2*s*(4*C*(s - 1) - 2*K*(s - 1) - 2*s + 3) + 6*fd*(4*g2*(s - 1)**2 + s*(4*K*bd1*(s - 1) + bd1 - 4*gd2*(s - 1))) - 12*fdd*g2*(s - 1)**2) - 2*fd*s*(s - 1)*(5*b2*fd + g2*(12*bd1 - 10*fd))) - f**2*(2*Pk2*fdd*(51*r**2 + r*(-200*C*(3*s - 1) + 300*s - 134) + s*(200*C - 100) + 17) + Pkdd2*fdd*k1**2*(560*C - 280)*(3*s**2 - 2*s + 1) + 33*Pkdd2*k1**2*(10*bd1**2*s + 2*bd1*(b1*(5 - 10*s) + s**2*(20*C - 10*K - 13) - 10*s + 5) + 5*bdd1*(b1*(2*s - 1) + s**2*(-4*C + 2*K + 2) + 2*s - 1) + 5*s**2*(-4*bd2 + 2*bdd2 + 8*gd2 - 4*gdd2)) + fd*(2*Pk2*(-400*C*s + 789*r**2 + 2*r*(200*C*(3*s - 1) - 300*s - 163) + 200*s + 263) + Pkdd2*k1**2*(-1120*C - 165*b1 + 395)*(3*s**2 - 2*s + 1))) + f*(-66*Pkdd2*fd*k1**2*(5*b1**2*(2*s - 1) + 2*b1*(10*C*(2*s**2 - 2*s + 1) - 5*K*(2*s**2 - 2*s + 1) - 13*s**2 + 18*s - 9) - 5*b2*(4*s**2 - 4*s + 2) - 5*bd1*s*(C*(8*s - 4) - 4*K*s + 2*K - 4*s + 1) - 5*g2*(-8*s**2 + 8*s - 4) - 5*s*(-2*bd2 + 4*gd2)*(2*s - 1)) + 33*Pkdd2*k1**2*(5*b1**2*fdd*(2*s - 1) + b1*(40*C*fdd*s**2 - 40*C*fdd*s + 20*C*fdd - 20*K*fdd*s**2 + 20*K*fdd*s - 10*K*fdd - 12*bd1*(4*K*s**2 - 2*s + 1) + 6*bdd1*(4*K*s**2 - 2*s + 1) - 20*fdd*s**2 + 30*fdd*s - 15*fdd + 48*gd2*s**2 - 24*gdd2*s**2) - 10*b2*fdd*(2*s**2 - 2*s + 1) + 20*fdd*g2*(2*s**2 - 2*s + 1) - 12*s*(bd1**2*(-2*K*s + 1) + 4*bd1*s*(-g2 + gd2) + 2*bdd1*g2*s)) + 4*fd**2*(Pk2*(100*C*(6*r*s - 2*r - 2*s + 1) - 51*r**2 - 300*r*s + 134*r + 100*s - 50) + Pkdd2*k1**2*s*(140 - 280*C)*(3*s - 2)))) - D1*Dd*(-396*Pkdd2*b1*fd*k1**2*(4*s - 1)*(2*K*b1*(s - 1) + b1 - 4*g2*(s - 1)) - 66*Pkdd2*f*k1**2*(b1**2*(-12*K*(4*s**2 - 2*s + 1) + 5*fd*(4*s - 1)) + b1*(6*bd1*(4*s - 1)*(4*K*s - 1) + 5*fd*(4*s - 1)*(8*C*s - 4*C - 4*K*s + 2*K - 4*s + 3) + 96*g2*s**2 - 48*g2*s + 24*g2 - 96*gd2*s**2 + 24*gd2*s) + (2 - 8*s)*(5*b2*fd*(2*s - 1) + 2*g2*(6*bd1*s + fd*(5 - 10*s)))) + f**3*(4*Pk2*(-400*C*s + 526*r**2 + r*(200*C*(4*s - 1) - 400*s - 426) + 200*s + 263) + Pkdd2*k1**2*(-1120*C - 165*b1 + 395)*(4*s**2 - 2*s + 1)) - 2*f**2*(-33*Pkdd2*k1**2*(5*b1*bd1*(4*s - 1) + b1*(20*C - 10*K - 13)*(4*s**2 - 2*s + 1) - 5*b2*(8*s**2 - 4*s + 2) - 5*bd1*(4*s - 1)*(4*C*s - s*(2*K + 2) - 1) + 20*g2*(4*s**2 - 2*s + 1) + s*(10*bd2 - 20*gd2)*(4*s - 1)) + 8*fd*(Pk2*(25*C*(24*r*s - 7*r - 10*s + 3) - 51*r**2 - 300*r*s + 130*r + 125*s - 46) + Pkdd2*k1**2*(35 - 70*C)*(12*s**2 - 7*s + 1)))) + 2*D1*Ddd*f*(198*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1) - 165*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)*(b1*(-2*C + K + 1) + b2 - 2*g2) + 2*f**2*(-Pk2*(34*r**2 - 4*r*(25*C*(4*s - 1) - 50*s + 21) + s*(200*C - 100) + 17) + Pkdd2*k1**2*(70 - 140*C)*(4*s**2 - 2*s + 1))) + 4*Dd**2*f*(594*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2) - 495*Pkdd2*f*k1**2*s*(2*s - 1)*(b1*(-2*C + K + 1) + b2 - 2*g2) + f**2*(100*C*Pk2*(3*r*(4*s - 1) - 6*s + 2) - 3*Pk2*(34*r**2 + 4*r*(50*s - 21) - 100*s + 39) + Pkdd2*k1**2*s*(420 - 840*C)*(2*s - 1))))/(693*d**2*k1*k3**2) - D1**2*Pk3*ct**4*k1**2*st**2*(-82368*C*D1**2*Pk2*bdd1*f**2*r*s - 123552*C*D1**2*Pk2*bdd1*f**2*s**2 + 82368*C*D1**2*Pk2*bdd1*f**2*s - 41184*C*D1**2*Pk2*bdd1*f**2 - 1487616*C*D1**2*Pk2*f**2*fd*r*s + 495872*C*D1**2*Pk2*f**2*fd*r + 68016*C*D1**2*Pk2*f**2*fd*s**2 + 450528*C*D1**2*Pk2*f**2*fd*s + 22672*C*D1**2*Pk2*f**2*fd + 990912*C*D1**2*Pk2*f**2*fdd*r*s - 330304*C*D1**2*Pk2*f**2*fdd*r + 243984*C*D1**2*Pk2*f**2*fdd*s**2 - 492960*C*D1**2*Pk2*f**2*fdd*s + 81328*C*D1**2*Pk2*f**2*fdd + 1981824*C*D1**2*Pk2*f*fd**2*r*s - 660608*C*D1**2*Pk2*f*fd**2*r + 487968*C*D1**2*Pk2*f*fd**2*s**2 - 985920*C*D1**2*Pk2*f*fd**2*s + 330304*C*D1**2*Pk2*f*fd**2 + 23400*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 15600*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 7800*C*D1**2*Pkdd2*f**2*fd*k1**2 - 11700*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 7800*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 3900*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 23400*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 15600*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 1983488*C*D1*Dd*Pk2*f**3*r*s + 495872*C*D1*Dd*Pk2*f**3*r + 90688*C*D1*Dd*Pk2*f**3*s**2 + 946400*C*D1*Dd*Pk2*f**3*s + 22672*C*D1*Dd*Pk2*f**3 + 7927296*C*D1*Dd*Pk2*f**2*fd*r*s - 2312128*C*D1*Dd*Pk2*f**2*fd*r + 1951872*C*D1*Dd*Pk2*f**2*fd*s**2 - 4441632*C*D1*Dd*Pk2*f**2*fd*s + 1153568*C*D1*Dd*Pk2*f**2*fd + 31200*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 15600*C*D1*Dd*Pkdd2*f**3*k1**2*s + 7800*C*D1*Dd*Pkdd2*f**3*k1**2 - 93600*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 54600*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 7800*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 1321216*C*D1*Ddd*Pk2*f**3*r*s - 330304*C*D1*Ddd*Pk2*f**3*r + 325312*C*D1*Ddd*Pk2*f**3*s**2 - 823264*C*D1*Ddd*Pk2*f**3*s + 81328*C*D1*Ddd*Pk2*f**3 - 15600*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 7800*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 3900*C*D1*Ddd*Pkdd2*f**3*k1**2 + 3963648*C*Dd**2*Pk2*f**3*r*s - 990912*C*Dd**2*Pk2*f**3*r + 975936*C*Dd**2*Pk2*f**3*s**2 - 2469792*C*Dd**2*Pk2*f**3*s + 660608*C*Dd**2*Pk2*f**3 - 46800*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 23400*C*Dd**2*Pkdd2*f**3*k1**2*s + 178464*D1**2*K*Pk2*bdd1*f**2*r*s + 24024*D1**2*K*Pk2*bdd1*f**2*s**2 - 178464*D1**2*K*Pk2*bdd1*f**2*s - 2574*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 41184*D1**2*Pk2*bd1**2*f*s*(K - 1)*(2*r + 3*s - 2) - 312000*D1**2*Pk2*bdd1*f**3*r*s - 234000*D1**2*Pk2*bdd1*f**3*s**2 + 312000*D1**2*Pk2*bdd1*f**3*s - 39000*D1**2*Pk2*bdd1*f**3 - 302016*D1**2*Pk2*bdd1*f**2*r*s - 175032*D1**2*Pk2*bdd1*f**2*s**2 + 302016*D1**2*Pk2*bdd1*f**2*s + 41184*D1**2*Pk2*bdd1*f**2 + 82368*D1**2*Pk2*bdd1*f*g2*r*s + 123552*D1**2*Pk2*bdd1*f*g2*s**2 - 82368*D1**2*Pk2*bdd1*f*g2*s + 41184*D1**2*Pk2*bdd1*f*g2 - 1404000*D1**2*Pk2*f**3*fd*r*s + 351000*D1**2*Pk2*f**3*fd*r - 1326000*D1**2*Pk2*f**3*fd*s**2 + 1365000*D1**2*Pk2*f**3*fd*s - 331500*D1**2*Pk2*f**3*fd + 1404000*D1**2*Pk2*f**3*fdd*r*s - 351000*D1**2*Pk2*f**3*fdd*r + 1014000*D1**2*Pk2*f**3*fdd*s**2 - 1209000*D1**2*Pk2*f**3*fdd*s + 253500*D1**2*Pk2*f**3*fdd + 4212000*D1**2*Pk2*f**2*fd**2*r*s - 1053000*D1**2*Pk2*f**2*fd**2*r + 3042000*D1**2*Pk2*f**2*fd**2*s**2 - 3627000*D1**2*Pk2*f**2*fd**2*s + 702000*D1**2*Pk2*f**2*fd**2 + 2300064*D1**2*Pk2*f**2*fd*r*s - 766688*D1**2*Pk2*f**2*fd*r + 1056432*D1**2*Pk2*f**2*fd*s**2 - 1470976*D1**2*Pk2*f**2*fd*s + 352144*D1**2*Pk2*f**2*fd - 1458912*D1**2*Pk2*f**2*fdd*r*s + 486304*D1**2*Pk2*f**2*fdd*r - 867984*D1**2*Pk2*f**2*fdd*s**2 + 1064960*D1**2*Pk2*f**2*fdd*s - 289328*D1**2*Pk2*f**2*fdd + 631488*D1**2*Pk2*f**2*gd2*r*s - 89232*D1**2*Pk2*f**2*gd2*s**2 - 631488*D1**2*Pk2*f**2*gd2*s - 356928*D1**2*Pk2*f**2*gdd2*r*s - 48048*D1**2*Pk2*f**2*gdd2*s**2 + 356928*D1**2*Pk2*f**2*gdd2*s - 2917824*D1**2*Pk2*f*fd**2*r*s + 972608*D1**2*Pk2*f*fd**2*r - 1735968*D1**2*Pk2*f*fd**2*s**2 + 2129920*D1**2*Pk2*f*fd**2*s - 486304*D1**2*Pk2*f*fd**2 + 1262976*D1**2*Pk2*f*fd*g2*r*s - 631488*D1**2*Pk2*f*fd*g2*r - 178464*D1**2*Pk2*f*fd*g2*s**2 + 178464*D1**2*Pk2*f*fd*g2*s - 89232*D1**2*Pk2*f*fd*g2 - 1427712*D1**2*Pk2*f*fd*gd2*r*s + 356928*D1**2*Pk2*f*fd*gd2*r - 192192*D1**2*Pk2*f*fd*gd2*s**2 + 809952*D1**2*Pk2*f*fd*gd2*s - 356928*D1**2*Pk2*f*fd*gd2 - 713856*D1**2*Pk2*f*fdd*g2*r*s + 356928*D1**2*Pk2*f*fdd*g2*r - 96096*D1**2*Pk2*f*fdd*g2*s**2 + 96096*D1**2*Pk2*f*fdd*g2*s - 48048*D1**2*Pk2*f*fdd*g2 - 713856*D1**2*Pk2*fd**2*g2*r*s + 356928*D1**2*Pk2*fd**2*g2*r - 96096*D1**2*Pk2*fd**2*g2*s**2 + 96096*D1**2*Pk2*fd**2*g2*s + 2574*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 88200*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 44100*D1**2*Pkdd2*f**3*fd*k1**2*s + 22050*D1**2*Pkdd2*f**3*fd*k1**2 - 44100*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 22050*D1**2*Pkdd2*f**3*fdd*k1**2*s - 11025*D1**2*Pkdd2*f**3*fdd*k1**2 - 132300*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 66150*D1**2*Pkdd2*f**2*fd**2*k1**2*s - 23400*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 15600*D1**2*Pkdd2*f**2*fd*k1**2*s - 7800*D1**2*Pkdd2*f**2*fd*k1**2 + 11700*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 7800*D1**2*Pkdd2*f**2*fdd*k1**2*s + 3900*D1**2*Pkdd2*f**2*fdd*k1**2 - 10296*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 5148*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 23400*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 15600*D1**2*Pkdd2*f*fd**2*k1**2*s - 20592*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 20592*D1**2*Pkdd2*f*fd*g2*k1**2*s - 10296*D1**2*Pkdd2*f*fd*g2*k1**2 + 20592*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 10296*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 10296*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 10296*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 5148*D1**2*Pkdd2*f*fdd*g2*k1**2 + 10296*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 10296*D1**2*Pkdd2*fd**2*g2*k1**2*s - 1404000*D1*Dd*Pk2*f**4*r*s + 351000*D1*Dd*Pk2*f**4*r - 1326000*D1*Dd*Pk2*f**4*s**2 + 1365000*D1*Dd*Pk2*f**4*s - 331500*D1*Dd*Pk2*f**4 + 11232000*D1*Dd*Pk2*f**3*fd*r*s - 2808000*D1*Dd*Pk2*f**3*fd*r + 8112000*D1*Dd*Pk2*f**3*fd*s**2 - 9672000*D1*Dd*Pk2*f**3*fd*s + 1911000*D1*Dd*Pk2*f**3*fd + 3066752*D1*Dd*Pk2*f**3*r*s - 766688*D1*Dd*Pk2*f**3*r + 1408576*D1*Dd*Pk2*f**3*s**2 - 2237664*D1*Dd*Pk2*f**3*s + 352144*D1*Dd*Pk2*f**3 - 11671296*D1*Dd*Pk2*f**2*fd*r*s + 3404128*D1*Dd*Pk2*f**2*fd*r - 6943872*D1*Dd*Pk2*f**2*fd*s**2 + 8913632*D1*Dd*Pk2*f**2*fd*s - 2037568*D1*Dd*Pk2*f**2*fd + 2525952*D1*Dd*Pk2*f**2*g2*r*s - 631488*D1*Dd*Pk2*f**2*g2*r - 356928*D1*Dd*Pk2*f**2*g2*s**2 - 1084512*D1*Dd*Pk2*f**2*g2*s - 89232*D1*Dd*Pk2*f**2*g2 - 2855424*D1*Dd*Pk2*f**2*gd2*r*s + 356928*D1*Dd*Pk2*f**2*gd2*r - 384384*D1*Dd*Pk2*f**2*gd2*s**2 + 2237664*D1*Dd*Pk2*f**2*gd2*s - 356928*D1*Dd*Pk2*f**2*gd2 - 5710848*D1*Dd*Pk2*f*fd*g2*r*s + 2141568*D1*Dd*Pk2*f*fd*g2*r - 768768*D1*Dd*Pk2*f*fd*g2*s**2 + 2004288*D1*Dd*Pk2*f*fd*g2*s - 809952*D1*Dd*Pk2*f*fd*g2 + 88200*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 44100*D1*Dd*Pkdd2*f**4*k1**2*s + 22050*D1*Dd*Pkdd2*f**4*k1**2 - 352800*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 176400*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 22050*D1*Dd*Pkdd2*f**3*fd*k1**2 - 31200*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 15600*D1*Dd*Pkdd2*f**3*k1**2*s - 7800*D1*Dd*Pkdd2*f**3*k1**2 + 93600*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 54600*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 7800*D1*Dd*Pkdd2*f**2*fd*k1**2 - 41184*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 20592*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 10296*D1*Dd*Pkdd2*f**2*g2*k1**2 + 41184*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 10296*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 82368*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 61776*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 10296*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 1404000*D1*Ddd*Pk2*f**4*r*s - 351000*D1*Ddd*Pk2*f**4*r + 1014000*D1*Ddd*Pk2*f**4*s**2 - 1209000*D1*Ddd*Pk2*f**4*s + 253500*D1*Ddd*Pk2*f**4 - 1945216*D1*Ddd*Pk2*f**3*r*s + 486304*D1*Ddd*Pk2*f**3*r - 1157312*D1*Ddd*Pk2*f**3*s**2 + 1551264*D1*Ddd*Pk2*f**3*s - 289328*D1*Ddd*Pk2*f**3 - 1427712*D1*Ddd*Pk2*f**2*g2*r*s + 356928*D1*Ddd*Pk2*f**2*g2*r - 192192*D1*Ddd*Pk2*f**2*g2*s**2 + 809952*D1*Ddd*Pk2*f**2*g2*s - 48048*D1*Ddd*Pk2*f**2*g2 - 44100*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 22050*D1*Ddd*Pkdd2*f**4*k1**2*s - 11025*D1*Ddd*Pkdd2*f**4*k1**2 + 15600*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 7800*D1*Ddd*Pkdd2*f**3*k1**2*s + 3900*D1*Ddd*Pkdd2*f**3*k1**2 + 20592*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 10296*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 5148*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 156*D1*bd1*(D1*(20*Pk2*f**3*(128*s**2 + s*(178*r - 178) + 25) + 528*Pk2*fd*g2*(r*(2*s - 1) + s*(3*s - 3)) + f**2*(528*C*Pk2*(3*s**2 + s*(2*r - 2) + 1) - 500*Pk2*fd*(4*r*(6*s - 1) + 18*s**2 - 22*s + 3) + 22*Pk2*(s**2*(13*K + 63) - s*(92*K - 152)*(r - 1) - 24) + Pkdd2*k1**2*s**2*(33*K - 33)) + 11*f*(-48*Pk2*(3*g2*s**2 + 2*g2*s*(r - 1) + g2 + gd2*s*(-2*r - 3*s + 2)) + fd*(4*Pk2*(-72*C*s**2 + 60*C*s + K*(26*r*(4*s - 1) + 14*s**2 - 59*s + 26) - r*(12*C + 44)*(4*s - 1) - 102*s**2 + 139*s - 56) + 3*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1)))) + Dd*f*(-1000*Pk2*f**2*(2*r*(8*s - 1) + 12*s**2 - 15*s + 2) + 528*Pk2*g2*(r*(8*s - 1) + 12*s**2 - 9*s + 1) - 11*f*(4*Pk2*(12*C*(r*(8*s - 1) + 12*s**2 - 9*s + 1) + K*(-208*r*s + 26*r - 28*s**2 + 163*s - 26) + 352*r*s - 44*r + 204*s**2 - 315*s + 44) + Pkdd2*k1**2*s*(3*K - 3)*(4*s - 1)))) + 4212000*Dd**2*Pk2*f**4*r*s - 1053000*Dd**2*Pk2*f**4*r + 3042000*Dd**2*Pk2*f**4*s**2 - 3627000*Dd**2*Pk2*f**4*s + 702000*Dd**2*Pk2*f**4 - 5835648*Dd**2*Pk2*f**3*r*s + 1458912*Dd**2*Pk2*f**3*r - 3471936*Dd**2*Pk2*f**3*s**2 + 4653792*Dd**2*Pk2*f**3*s - 972608*Dd**2*Pk2*f**3 - 4283136*Dd**2*Pk2*f**2*g2*r*s + 1070784*Dd**2*Pk2*f**2*g2*r - 576576*Dd**2*Pk2*f**2*g2*s**2 + 2429856*Dd**2*Pk2*f**2*g2*s - 713856*Dd**2*Pk2*f**2*g2 - 132300*Dd**2*Pkdd2*f**4*k1**2*s**2 + 66150*Dd**2*Pkdd2*f**4*k1**2*s + 46800*Dd**2*Pkdd2*f**3*k1**2*s**2 - 23400*Dd**2*Pkdd2*f**3*k1**2*s + 61776*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 30888*Dd**2*Pkdd2*f**2*g2*k1**2*s + 20592*Pk2*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + D1*(2*Dd*(f*(8*r*s - 2*r + 12*s**2 - 10*s + 3) + fd*(-8*r*s + 5*r - 12*s**2 + 13*s - 4)) + Ddd*f*(r*(2 - 8*s) - 12*s**2 + 10*s - 3)) - 2*Dd**2*f*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2)) + 78*b1*(4224*C*D1**2*Pk2*f*fd*r*s - 2112*C*D1**2*Pk2*f*fd*r + 6336*C*D1**2*Pk2*f*fd*s**2 - 6336*C*D1**2*Pk2*f*fd*s + 2112*C*D1**2*Pk2*f*fd - 2112*C*D1**2*Pk2*f*fdd*r*s + 1056*C*D1**2*Pk2*f*fdd*r - 3168*C*D1**2*Pk2*f*fdd*s**2 + 3168*C*D1**2*Pk2*f*fdd*s - 1056*C*D1**2*Pk2*f*fdd - 2112*C*D1**2*Pk2*fd**2*r*s + 1056*C*D1**2*Pk2*fd**2*r - 3168*C*D1**2*Pk2*fd**2*s**2 + 3168*C*D1**2*Pk2*fd**2*s - 1056*C*D1**2*Pk2*fd**2 + 8448*C*D1*Dd*Pk2*f**2*r*s - 2112*C*D1*Dd*Pk2*f**2*r + 12672*C*D1*Dd*Pk2*f**2*s**2 - 10560*C*D1*Dd*Pk2*f**2*s + 3168*C*D1*Dd*Pk2*f**2 - 16896*C*D1*Dd*Pk2*f*fd*r*s + 6336*C*D1*Dd*Pk2*f*fd*r - 25344*C*D1*Dd*Pk2*f*fd*s**2 + 23232*C*D1*Dd*Pk2*f*fd*s - 5280*C*D1*Dd*Pk2*f*fd - 4224*C*D1*Ddd*Pk2*f**2*r*s + 1056*C*D1*Ddd*Pk2*f**2*r - 6336*C*D1*Ddd*Pk2*f**2*s**2 + 5280*C*D1*Ddd*Pk2*f**2*s - 1584*C*D1*Ddd*Pk2*f**2 - 12672*C*Dd**2*Pk2*f**2*r*s + 3168*C*Dd**2*Pk2*f**2*r - 19008*C*Dd**2*Pk2*f**2*s**2 + 15840*C*Dd**2*Pk2*f**2*s - 2112*C*Dd**2*Pk2*f**2 - 8096*D1**2*K*Pk2*f*fd*r*s + 4048*D1**2*K*Pk2*f*fd*r + 1144*D1**2*K*Pk2*f*fd*s**2 - 1144*D1**2*K*Pk2*f*fd*s + 572*D1**2*K*Pk2*f*fd + 4576*D1**2*K*Pk2*f*fdd*r*s - 2288*D1**2*K*Pk2*f*fdd*r + 616*D1**2*K*Pk2*f*fdd*s**2 - 616*D1**2*K*Pk2*f*fdd*s + 308*D1**2*K*Pk2*f*fdd + 4576*D1**2*K*Pk2*fd**2*r*s - 2288*D1**2*K*Pk2*fd**2*r + 616*D1**2*K*Pk2*fd**2*s**2 - 616*D1**2*K*Pk2*fd**2*s + 132*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 132*D1**2*K*Pkdd2*f*fd*k1**2*s + 66*D1**2*K*Pkdd2*f*fd*k1**2 - 66*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 66*D1**2*K*Pkdd2*f*fdd*k1**2*s - 33*D1**2*K*Pkdd2*f*fdd*k1**2 - 66*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 66*D1**2*K*Pkdd2*fd**2*k1**2*s - 264*D1**2*Pk2*bdd1*f*(K - 1)*(6*s**2 + s*(4*r - 4) + 1) + 21360*D1**2*Pk2*f**2*fd*r*s - 7120*D1**2*Pk2*f**2*fd*r + 15360*D1**2*Pk2*f**2*fd*s**2 - 17360*D1**2*Pk2*f**2*fd*s + 4120*D1**2*Pk2*f**2*fd - 12000*D1**2*Pk2*f**2*fdd*r*s + 4000*D1**2*Pk2*f**2*fdd*r - 9000*D1**2*Pk2*f**2*fdd*s**2 + 10000*D1**2*Pk2*f**2*fdd*s - 2500*D1**2*Pk2*f**2*fdd - 24000*D1**2*Pk2*f*fd**2*r*s + 8000*D1**2*Pk2*f*fd**2*r - 18000*D1**2*Pk2*f*fd**2*s**2 + 20000*D1**2*Pk2*f*fd**2*s - 5000*D1**2*Pk2*f*fd**2 + 13376*D1**2*Pk2*f*fd*r*s - 6688*D1**2*Pk2*f*fd*r + 5544*D1**2*Pk2*f*fd*s**2 - 5544*D1**2*Pk2*f*fd*s + 3828*D1**2*Pk2*f*fd - 7744*D1**2*Pk2*f*fdd*r*s + 3872*D1**2*Pk2*f*fdd*r - 4488*D1**2*Pk2*f*fdd*s**2 + 4488*D1**2*Pk2*f*fdd*s - 2772*D1**2*Pk2*f*fdd - 2112*D1**2*Pk2*f*gd2*r*s - 3168*D1**2*Pk2*f*gd2*s**2 + 2112*D1**2*Pk2*f*gd2*s + 1056*D1**2*Pk2*f*gdd2*r*s + 1584*D1**2*Pk2*f*gdd2*s**2 - 1056*D1**2*Pk2*f*gdd2*s - 7744*D1**2*Pk2*fd**2*r*s + 3872*D1**2*Pk2*fd**2*r - 4488*D1**2*Pk2*fd**2*s**2 + 4488*D1**2*Pk2*fd**2*s + 1056*D1**2*Pk2*fd**2 - 2112*D1**2*Pk2*fd*g2*r*s + 2112*D1**2*Pk2*fd*g2*r - 3168*D1**2*Pk2*fd*g2*s**2 + 4224*D1**2*Pk2*fd*g2*s - 2112*D1**2*Pk2*fd*g2 + 2112*D1**2*Pk2*fd*gd2*r*s - 1056*D1**2*Pk2*fd*gd2*r + 3168*D1**2*Pk2*fd*gd2*s**2 - 3168*D1**2*Pk2*fd*gd2*s + 1056*D1**2*Pk2*fd*gd2 + 1056*D1**2*Pk2*fdd*g2*r*s - 1056*D1**2*Pk2*fdd*g2*r + 1584*D1**2*Pk2*fdd*g2*s**2 - 2112*D1**2*Pk2*fdd*g2*s + 1056*D1**2*Pk2*fdd*g2 - 132*D1**2*Pkdd2*f*fd*k1**2*s**2 + 132*D1**2*Pkdd2*f*fd*k1**2*s - 66*D1**2*Pkdd2*f*fd*k1**2 + 66*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 66*D1**2*Pkdd2*f*fdd*k1**2*s + 33*D1**2*Pkdd2*f*fdd*k1**2 + 66*D1**2*Pkdd2*fd**2*k1**2*s**2 - 66*D1**2*Pkdd2*fd**2*k1**2*s - 16192*D1*Dd*K*Pk2*f**2*r*s + 4048*D1*Dd*K*Pk2*f**2*r + 2288*D1*Dd*K*Pk2*f**2*s**2 + 6952*D1*Dd*K*Pk2*f**2*s + 572*D1*Dd*K*Pk2*f**2 + 36608*D1*Dd*K*Pk2*f*fd*r*s - 13728*D1*Dd*K*Pk2*f*fd*r + 4928*D1*Dd*K*Pk2*f*fd*s**2 - 12848*D1*Dd*K*Pk2*f*fd*s + 5192*D1*Dd*K*Pk2*f*fd + 264*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 132*D1*Dd*K*Pkdd2*f**2*k1**2*s + 66*D1*Dd*K*Pkdd2*f**2*k1**2 - 528*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 396*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 66*D1*Dd*K*Pkdd2*f*fd*k1**2 + 28480*D1*Dd*Pk2*f**3*r*s - 7120*D1*Dd*Pk2*f**3*r + 20480*D1*Dd*Pk2*f**3*s**2 - 24480*D1*Dd*Pk2*f**3*s + 5120*D1*Dd*Pk2*f**3 - 96000*D1*Dd*Pk2*f**2*fd*r*s + 28000*D1*Dd*Pk2*f**2*fd*r - 72000*D1*Dd*Pk2*f**2*fd*s**2 + 82000*D1*Dd*Pk2*f**2*fd*s - 18000*D1*Dd*Pk2*f**2*fd + 26752*D1*Dd*Pk2*f**2*r*s - 6688*D1*Dd*Pk2*f**2*r + 11088*D1*Dd*Pk2*f**2*s**2 - 18920*D1*Dd*Pk2*f**2*s + 2772*D1*Dd*Pk2*f**2 - 61952*D1*Dd*Pk2*f*fd*r*s + 23232*D1*Dd*Pk2*f*fd*r - 35904*D1*Dd*Pk2*f*fd*s**2 + 42416*D1*Dd*Pk2*f*fd*s - 12232*D1*Dd*Pk2*f*fd - 8448*D1*Dd*Pk2*f*g2*r*s + 2112*D1*Dd*Pk2*f*g2*r - 12672*D1*Dd*Pk2*f*g2*s**2 + 10560*D1*Dd*Pk2*f*g2*s - 3168*D1*Dd*Pk2*f*g2 + 8448*D1*Dd*Pk2*f*gd2*r*s - 1056*D1*Dd*Pk2*f*gd2*r + 12672*D1*Dd*Pk2*f*gd2*s**2 - 9504*D1*Dd*Pk2*f*gd2*s + 1056*D1*Dd*Pk2*f*gd2 + 8448*D1*Dd*Pk2*fd*g2*r*s - 5280*D1*Dd*Pk2*fd*g2*r + 12672*D1*Dd*Pk2*fd*g2*s**2 - 13728*D1*Dd*Pk2*fd*g2*s + 4224*D1*Dd*Pk2*fd*g2 - 264*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 132*D1*Dd*Pkdd2*f**2*k1**2*s - 66*D1*Dd*Pkdd2*f**2*k1**2 + 528*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 396*D1*Dd*Pkdd2*f*fd*k1**2*s + 66*D1*Dd*Pkdd2*f*fd*k1**2 + 9152*D1*Ddd*K*Pk2*f**2*r*s - 2288*D1*Ddd*K*Pk2*f**2*r + 1232*D1*Ddd*K*Pk2*f**2*s**2 - 5192*D1*Ddd*K*Pk2*f**2*s + 308*D1*Ddd*K*Pk2*f**2 - 132*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 66*D1*Ddd*K*Pkdd2*f**2*k1**2*s - 33*D1*Ddd*K*Pkdd2*f**2*k1**2 - 16000*D1*Ddd*Pk2*f**3*r*s + 4000*D1*Ddd*Pk2*f**3*r - 12000*D1*Ddd*Pk2*f**3*s**2 + 14000*D1*Ddd*Pk2*f**3*s - 3000*D1*Ddd*Pk2*f**3 - 15488*D1*Ddd*Pk2*f**2*r*s + 3872*D1*Ddd*Pk2*f**2*r - 8976*D1*Ddd*Pk2*f**2*s**2 + 12232*D1*Ddd*Pk2*f**2*s - 2244*D1*Ddd*Pk2*f**2 + 4224*D1*Ddd*Pk2*f*g2*r*s - 1056*D1*Ddd*Pk2*f*g2*r + 6336*D1*Ddd*Pk2*f*g2*s**2 - 5280*D1*Ddd*Pk2*f*g2*s + 1584*D1*Ddd*Pk2*f*g2 + 132*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 66*D1*Ddd*Pkdd2*f**2*k1**2*s + 33*D1*Ddd*Pkdd2*f**2*k1**2 + 528*D1*Pk2*bd1*(K - 1)*(D1*(f*(6*s**2 + s*(4*r - 4) + 1) + fd*(r*(2 - 4*s) - 6*s**2 + 6*s - 1)) - 2*Dd*f*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) + 27456*Dd**2*K*Pk2*f**2*r*s - 6864*Dd**2*K*Pk2*f**2*r + 3696*Dd**2*K*Pk2*f**2*s**2 - 15576*Dd**2*K*Pk2*f**2*s + 4576*Dd**2*K*Pk2*f**2 - 396*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 198*Dd**2*K*Pkdd2*f**2*k1**2*s - 48000*Dd**2*Pk2*f**3*r*s + 12000*Dd**2*Pk2*f**3*r - 36000*Dd**2*Pk2*f**3*s**2 + 42000*Dd**2*Pk2*f**3*s - 8000*Dd**2*Pk2*f**3 - 46464*Dd**2*Pk2*f**2*r*s + 11616*Dd**2*Pk2*f**2*r - 26928*Dd**2*Pk2*f**2*s**2 + 36696*Dd**2*Pk2*f**2*s - 7744*Dd**2*Pk2*f**2 + 12672*Dd**2*Pk2*f*g2*r*s - 3168*Dd**2*Pk2*f*g2*r + 19008*Dd**2*Pk2*f*g2*s**2 - 15840*Dd**2*Pk2*f*g2*s + 2112*Dd**2*Pk2*f*g2 + 396*Dd**2*Pkdd2*f**2*k1**2*s**2 - 198*Dd**2*Pkdd2*f**2*k1**2*s))/(18018*d**2*k3**4) - 2*D1**2*Pk3*ct**4*k1**2*(1980*C*D1**2*Pk2*bdd1*f**2*r**2 + 7392*C*D1**2*Pk2*bdd1*f**2*r*s - 4752*C*D1**2*Pk2*bdd1*f**2*r + 3960*C*D1**2*Pk2*bdd1*f**2*s**2 - 6600*C*D1**2*Pk2*bdd1*f**2*s + 3300*C*D1**2*Pk2*bdd1*f**2 + 9798*C*D1**2*Pk2*f**2*fd*r**2 + 13104*C*D1**2*Pk2*f**2*fd*r*s - 10900*C*D1**2*Pk2*f**2*fd*r - 37662*C*D1**2*Pk2*f**2*fd*s**2 + 20740*C*D1**2*Pk2*f**2*fd*s - 9288*C*D1**2*Pk2*f**2*fd - 6978*C*D1**2*Pk2*f**2*fdd*r**2 - 11304*C*D1**2*Pk2*f**2*fdd*r*s + 8420*C*D1**2*Pk2*f**2*fdd*r + 28632*C*D1**2*Pk2*f**2*fdd*s**2 - 15320*C*D1**2*Pk2*f**2*fdd*s + 7218*C*D1**2*Pk2*f**2*fdd - 13956*C*D1**2*Pk2*f*fd**2*r**2 - 22608*C*D1**2*Pk2*f*fd**2*r*s + 16840*C*D1**2*Pk2*f*fd**2*r + 57264*C*D1**2*Pk2*f*fd**2*s**2 - 30640*C*D1**2*Pk2*f*fd**2*s - 3768*C*D1**2*Pk2*f*fd**2 - 165*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 330*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 165*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 495*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 330*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 165*C*D1**2*Pkdd2*f**2*fd*k1**2 + 13064*C*D1*Dd*Pk2*f**3*r**2 + 17472*C*D1*Dd*Pk2*f**3*r*s - 17432*C*D1*Dd*Pk2*f**3*r - 50216*C*D1*Dd*Pk2*f**3*s**2 + 16372*C*D1*Dd*Pk2*f**3*s - 6022*C*D1*Dd*Pk2*f**3 - 55824*C*D1*Dd*Pk2*f**2*fd*r**2 - 90432*C*D1*Dd*Pk2*f**2*fd*r*s + 72896*C*D1*Dd*Pk2*f**2*fd*r + 229056*C*D1*Dd*Pk2*f**2*fd*s**2 - 95936*C*D1*Dd*Pk2*f**2*fd*s - 1520*C*D1*Dd*Pk2*f**2*fd - 660*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 330*C*D1*Dd*Pkdd2*f**3*k1**2*s - 165*C*D1*Dd*Pkdd2*f**3*k1**2 - 9304*C*D1*Ddd*Pk2*f**3*r**2 - 15072*C*D1*Ddd*Pk2*f**3*r*s + 13072*C*D1*Ddd*Pk2*f**3*r + 38176*C*D1*Ddd*Pk2*f**3*s**2 - 11552*C*D1*Ddd*Pk2*f**3*s + 4892*C*D1*Ddd*Pk2*f**3 - 27912*C*Dd**2*Pk2*f**3*r**2 - 45216*C*Dd**2*Pk2*f**3*r*s + 39216*C*Dd**2*Pk2*f**3*r + 114528*C*Dd**2*Pk2*f**3*s**2 - 34656*C*Dd**2*Pk2*f**3*s - 12188*C*Dd**2*Pk2*f**3 - 1188*D1**2*K*Pk2*bdd1*f**2*r**2 - 1782*D1**2*K*Pk2*bdd1*f**2*r*s + 2376*D1**2*K*Pk2*bdd1*f**2*r + 5709*D1**2*K*Pk2*bdd1*f**2*s**2 + 1782*D1**2*K*Pk2*bdd1*f**2*s - 1188*D1**2*K*Pk2*bdd1*f**2 - 4752*D1**2*Pk2*b2*f*fd*r*s + 2376*D1**2*Pk2*b2*f*fd*r - 4752*D1**2*Pk2*b2*f*fd*s**2 + 4752*D1**2*Pk2*b2*f*fd*s - 2376*D1**2*Pk2*b2*f*fd + 3960*D1**2*Pk2*b2*f*fdd*r*s - 1980*D1**2*Pk2*b2*f*fdd*r + 3960*D1**2*Pk2*b2*f*fdd*s**2 - 3960*D1**2*Pk2*b2*f*fdd*s + 1980*D1**2*Pk2*b2*f*fdd + 3960*D1**2*Pk2*b2*fd**2*r*s - 1980*D1**2*Pk2*b2*fd**2*r + 3960*D1**2*Pk2*b2*fd**2*s**2 - 3960*D1**2*Pk2*b2*fd**2*s - 2376*D1**2*Pk2*bd2*f**2*r*s - 2376*D1**2*Pk2*bd2*f**2*s**2 + 2376*D1**2*Pk2*bd2*f**2*s + 7920*D1**2*Pk2*bd2*f*fd*r*s - 1980*D1**2*Pk2*bd2*f*fd*r + 7920*D1**2*Pk2*bd2*f*fd*s**2 - 7920*D1**2*Pk2*bd2*f*fd*s + 1980*D1**2*Pk2*bd2*f*fd + 4455*D1**2*Pk2*bdd1*f**3*r**2 + 10560*D1**2*Pk2*bdd1*f**3*r*s - 8250*D1**2*Pk2*bdd1*f**3*r + 3135*D1**2*Pk2*bdd1*f**3*s**2 - 7260*D1**2*Pk2*bdd1*f**3*s + 4125*D1**2*Pk2*bdd1*f**3 + 2178*D1**2*Pk2*bdd1*f**2*r**2 + 3168*D1**2*Pk2*bdd1*f**2*r*s - 1584*D1**2*Pk2*bdd1*f**2*r - 1551*D1**2*Pk2*bdd1*f**2*s**2 - 2640*D1**2*Pk2*bdd1*f**2*s - 1122*D1**2*Pk2*bdd1*f**2 - 2046*D1**2*Pk2*bdd1*f*g2*r**2 - 7788*D1**2*Pk2*bdd1*f*g2*r*s + 5016*D1**2*Pk2*bdd1*f*g2*r - 4620*D1**2*Pk2*bdd1*f*g2*s**2 + 7788*D1**2*Pk2*bdd1*f*g2*s - 3894*D1**2*Pk2*bdd1*f*g2 + 1980*D1**2*Pk2*bdd2*f**2*r*s + 1980*D1**2*Pk2*bdd2*f**2*s**2 - 1980*D1**2*Pk2*bdd2*f**2*s + 11880*D1**2*Pk2*f**3*fd*r**2 + 29700*D1**2*Pk2*f**3*fd*r*s - 19305*D1**2*Pk2*f**3*fd*r + 9900*D1**2*Pk2*f**3*fd*s**2 - 19800*D1**2*Pk2*f**3*fd*s + 8415*D1**2*Pk2*f**3*fd - 11880*D1**2*Pk2*f**3*fdd*r**2 - 29700*D1**2*Pk2*f**3*fdd*r*s + 19305*D1**2*Pk2*f**3*fdd*r - 9900*D1**2*Pk2*f**3*fdd*s**2 + 19800*D1**2*Pk2*f**3*fdd*s - 8415*D1**2*Pk2*f**3*fdd - 35640*D1**2*Pk2*f**2*fd**2*r**2 - 89100*D1**2*Pk2*f**2*fd**2*r*s + 57915*D1**2*Pk2*f**2*fd**2*r - 29700*D1**2*Pk2*f**2*fd**2*s**2 + 59400*D1**2*Pk2*f**2*fd**2*s - 20790*D1**2*Pk2*f**2*fd**2 - 17628*D1**2*Pk2*f**2*fd*r**2 - 50214*D1**2*Pk2*f**2*fd*r*s + 28490*D1**2*Pk2*f**2*fd*r + 2352*D1**2*Pk2*f**2*fd*s**2 + 15170*D1**2*Pk2*f**2*fd*s - 5092*D1**2*Pk2*f**2*fd + 15348*D1**2*Pk2*f**2*fdd*r**2 + 41244*D1**2*Pk2*f**2*fdd*r*s - 23980*D1**2*Pk2*f**2*fdd*r - 1572*D1**2*Pk2*f**2*fdd*s**2 - 12700*D1**2*Pk2*f**2*fdd*s + 4592*D1**2*Pk2*f**2*fdd - 2706*D1**2*Pk2*f**2*gd2*r**2 - 4356*D1**2*Pk2*f**2*gd2*r*s + 5412*D1**2*Pk2*f**2*gd2*r + 14916*D1**2*Pk2*f**2*gd2*s**2 + 4356*D1**2*Pk2*f**2*gd2*s - 2706*D1**2*Pk2*f**2*gd2 + 2376*D1**2*Pk2*f**2*gdd2*r**2 + 3564*D1**2*Pk2*f**2*gdd2*r*s - 4752*D1**2*Pk2*f**2*gdd2*r - 11418*D1**2*Pk2*f**2*gdd2*s**2 - 3564*D1**2*Pk2*f**2*gdd2*s + 2376*D1**2*Pk2*f**2*gdd2 + 30696*D1**2*Pk2*f*fd**2*r**2 + 82488*D1**2*Pk2*f*fd**2*r*s - 47960*D1**2*Pk2*f*fd**2*r - 3144*D1**2*Pk2*f*fd**2*s**2 - 25400*D1**2*Pk2*f*fd**2*s + 13748*D1**2*Pk2*f*fd**2 - 5412*D1**2*Pk2*f*fd*g2*r**2 - 8712*D1**2*Pk2*f*fd*g2*r*s + 4356*D1**2*Pk2*f*fd*g2*r + 29832*D1**2*Pk2*f*fd*g2*s**2 - 29832*D1**2*Pk2*f*fd*g2*s + 14916*D1**2*Pk2*f*fd*g2 + 9504*D1**2*Pk2*f*fd*gd2*r**2 + 14256*D1**2*Pk2*f*fd*gd2*r*s - 13068*D1**2*Pk2*f*fd*gd2*r - 45672*D1**2*Pk2*f*fd*gd2*s**2 + 15708*D1**2*Pk2*f*fd*gd2*s + 3564*D1**2*Pk2*f*fd*gd2 + 4752*D1**2*Pk2*f*fdd*g2*r**2 + 7128*D1**2*Pk2*f*fdd*g2*r*s - 3564*D1**2*Pk2*f*fdd*g2*r - 22836*D1**2*Pk2*f*fdd*g2*s**2 + 22836*D1**2*Pk2*f*fdd*g2*s - 11418*D1**2*Pk2*f*fdd*g2 + 4752*D1**2*Pk2*fd**2*g2*r**2 + 7128*D1**2*Pk2*fd**2*g2*r*s - 3564*D1**2*Pk2*fd**2*g2*r - 22836*D1**2*Pk2*fd**2*g2*s**2 + 22836*D1**2*Pk2*fd**2*g2*s - 140*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 420*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 210*D1**2*Pkdd2*bdd1*f**3*k1**2 + 165*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 330*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 165*D1**2*Pkdd2*bdd1*f**2*k1**2 + 198*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 396*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 198*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 840*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 420*D1**2*Pkdd2*f**3*fd*k1**2*s - 210*D1**2*Pkdd2*f**3*fd*k1**2 + 495*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 330*D1**2*Pkdd2*f**2*fd*k1**2*s + 165*D1**2*Pkdd2*f**2*fd*k1**2 + 198*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 396*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 396*D1**2*Pkdd2*f*fd*g2*k1**2*s + 198*D1**2*Pkdd2*f*fd*g2*k1**2 - 66*D1**2*bd1**2*(10*Pk2*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 3) + 28*Pk2*g2*(-2*r*s + r - s*(2*s - 2)) + f*(Pk2*(-K*(31*r**2 + r*(118*s - 69) + 70*s**2 - 118*s + 38) + 31*r**2 + r*(24*C*(2*s - 1) + 166*s - 81) + s**2*(48*C + 118) - s*(48*C + 190) + 74) + Pkdd2*k1**2*s*(3*K - 3)*(s - 1))) - 9504*D1*Dd*Pk2*b2*f**2*r*s + 2376*D1*Dd*Pk2*b2*f**2*r - 9504*D1*Dd*Pk2*b2*f**2*s**2 + 9504*D1*Dd*Pk2*b2*f**2*s - 2376*D1*Dd*Pk2*b2*f**2 + 31680*D1*Dd*Pk2*b2*f*fd*r*s - 11880*D1*Dd*Pk2*b2*f*fd*r + 31680*D1*Dd*Pk2*b2*f*fd*s**2 - 31680*D1*Dd*Pk2*b2*f*fd*s + 7920*D1*Dd*Pk2*b2*f*fd + 15840*D1*Dd*Pk2*bd2*f**2*r*s - 1980*D1*Dd*Pk2*bd2*f**2*r + 15840*D1*Dd*Pk2*bd2*f**2*s**2 - 15840*D1*Dd*Pk2*bd2*f**2*s + 1980*D1*Dd*Pk2*bd2*f**2 + 11880*D1*Dd*Pk2*f**4*r**2 + 29700*D1*Dd*Pk2*f**4*r*s - 19305*D1*Dd*Pk2*f**4*r + 9900*D1*Dd*Pk2*f**4*s**2 - 19800*D1*Dd*Pk2*f**4*s + 8415*D1*Dd*Pk2*f**4 - 95040*D1*Dd*Pk2*f**3*fd*r**2 - 237600*D1*Dd*Pk2*f**3*fd*r*s + 154440*D1*Dd*Pk2*f**3*fd*r - 79200*D1*Dd*Pk2*f**3*fd*s**2 + 158400*D1*Dd*Pk2*f**3*fd*s - 58410*D1*Dd*Pk2*f**3*fd - 23504*D1*Dd*Pk2*f**3*r**2 - 66952*D1*Dd*Pk2*f**3*r*s + 40242*D1*Dd*Pk2*f**3*r + 3136*D1*Dd*Pk2*f**3*s**2 + 31908*D1*Dd*Pk2*f**3*s - 10968*D1*Dd*Pk2*f**3 + 122784*D1*Dd*Pk2*f**2*fd*r**2 + 329952*D1*Dd*Pk2*f**2*fd*r*s - 198556*D1*Dd*Pk2*f**2*fd*r - 12576*D1*Dd*Pk2*f**2*fd*s**2 - 130144*D1*Dd*Pk2*f**2*fd*s + 60660*D1*Dd*Pk2*f**2*fd - 10824*D1*Dd*Pk2*f**2*g2*r**2 - 17424*D1*Dd*Pk2*f**2*g2*r*s + 15180*D1*Dd*Pk2*f**2*g2*r + 59664*D1*Dd*Pk2*f**2*g2*s**2 - 21120*D1*Dd*Pk2*f**2*g2*s + 9504*D1*Dd*Pk2*f**2*g2 + 19008*D1*Dd*Pk2*f**2*gd2*r**2 + 28512*D1*Dd*Pk2*f**2*gd2*r*s - 32076*D1*Dd*Pk2*f**2*gd2*r - 91344*D1*Dd*Pk2*f**2*gd2*s**2 + 1452*D1*Dd*Pk2*f**2*gd2*s + 13068*D1*Dd*Pk2*f**2*gd2 + 38016*D1*Dd*Pk2*f*fd*g2*r**2 + 57024*D1*Dd*Pk2*f*fd*g2*r*s - 40392*D1*Dd*Pk2*f*fd*g2*r - 182688*D1*Dd*Pk2*f*fd*g2*s**2 + 122760*D1*Dd*Pk2*f*fd*g2*s - 15708*D1*Dd*Pk2*f*fd*g2 - 840*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 420*D1*Dd*Pkdd2*f**4*k1**2*s - 210*D1*Dd*Pkdd2*f**4*k1**2 + 660*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 330*D1*Dd*Pkdd2*f**3*k1**2*s + 165*D1*Dd*Pkdd2*f**3*k1**2 + 792*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 396*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 198*D1*Dd*Pkdd2*f**2*g2*k1**2 + 7920*D1*Ddd*Pk2*b2*f**2*r*s - 1980*D1*Ddd*Pk2*b2*f**2*r + 7920*D1*Ddd*Pk2*b2*f**2*s**2 - 7920*D1*Ddd*Pk2*b2*f**2*s + 1980*D1*Ddd*Pk2*b2*f**2 - 11880*D1*Ddd*Pk2*f**4*r**2 - 29700*D1*Ddd*Pk2*f**4*r*s + 19305*D1*Ddd*Pk2*f**4*r - 9900*D1*Ddd*Pk2*f**4*s**2 + 19800*D1*Ddd*Pk2*f**4*s - 8415*D1*Ddd*Pk2*f**4 + 20464*D1*Ddd*Pk2*f**3*r**2 + 54992*D1*Ddd*Pk2*f**3*r*s - 34212*D1*Ddd*Pk2*f**3*r - 2096*D1*Ddd*Pk2*f**3*s**2 - 26448*D1*Ddd*Pk2*f**3*s + 9708*D1*Ddd*Pk2*f**3 + 9504*D1*Ddd*Pk2*f**2*g2*r**2 + 14256*D1*Ddd*Pk2*f**2*g2*r*s - 13068*D1*Ddd*Pk2*f**2*g2*r - 45672*D1*Ddd*Pk2*f**2*g2*s**2 + 15708*D1*Ddd*Pk2*f**2*g2*s - 6666*D1*Ddd*Pk2*f**2*g2 - D1*bd1*(D1*(5*f**3*(33*Pk2*(21*r**2 + r*(76*s - 42) + 33*s**2 - 56*s + 23) - 28*Pkdd2*k1**2*(2*s**2 - 6*s + 3)) + f**2*(33*Pk2*(4*C*(9*r**2 + r*(94*s - 60) + 54*s**2 - 58*s + 29) - 41*K*r**2 - 66*K*r*s + 82*K*r + 226*K*s**2 + 66*K*s - 41*K - 10*fd*(81*r**2 + 8*r*(24*s - 17) + 57*s**2 - 127*s + 47) + 77*r**2 - 6*r*s + 110*r - 130*s**2 - 58*s - 99) + Pkdd2*k1**2*(-330*C*(s - 1)**2 + s**2*(99*K + 840*fd + 231) - s*(1120*fd + 660) + 330)) - 66*f*(-2*Pk2*gd2*(31*r**2 + r*(118*s - 69) + 70*s**2 - 118*s + 38) + 6*Pkdd2*gd2*k1**2*s*(s - 1) + fd*(Pk2*(4*C*(30*r**2 + r*(112*s - 61) + 60*s**2 - 83*s + 18) - K*(72*r**2 + 108*r*s - 99*r - 346*s**2 + 119*s + 27) + 132*r**2 + 192*r*s - 138*r - 94*s**2 - 41*s + 98) + Pkdd2*k1**2*s*(10 - 10*C)*(s - 1)) + g2*(Pk2*(13*r**2 + 2*r*(97*s - 62) + 126*s**2 - 138*s + 69) - 6*Pkdd2*k1**2*(s - 1)**2)) + 132*fd*g2*(Pk2*(31*r**2 + 59*r*(2*s - 1) + s*(70*s - 70)) - 3*Pkdd2*k1**2*s*(s - 1))) + 2*Dd*f*(-5*f**2*(33*Pk2*(108*r**2 + 2*r*(128*s - 93) + 76*s**2 - 171*s + 72) - 14*Pkdd2*k1**2*(8*s**2 - 14*s + 3)) - 33*f*(Pk2*(4*C*(60*r**2 + 2*r*(112*s - 65) + 120*s**2 - 186*s + 61) - K*(144*r**2 + 27*r*(8*s - 9) - 692*s**2 + 11*s + 99) + 264*r**2 + 384*r*s - 276*r - 188*s**2 - 209*s + 88) + Pkdd2*k1**2*(5 - 5*C)*(4*s**2 - 5*s + 1)) + 66*g2*(Pk2*(124*r**2 + r*(472*s - 273) + 280*s**2 - 424*s + 135) - 3*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 23760*Dd**2*Pk2*b2*f**2*r*s - 5940*Dd**2*Pk2*b2*f**2*r + 23760*Dd**2*Pk2*b2*f**2*s**2 - 23760*Dd**2*Pk2*b2*f**2*s + 3960*Dd**2*Pk2*b2*f**2 - 35640*Dd**2*Pk2*f**4*r**2 - 89100*Dd**2*Pk2*f**4*r*s + 57915*Dd**2*Pk2*f**4*r - 29700*Dd**2*Pk2*f**4*s**2 + 59400*Dd**2*Pk2*f**4*s - 20790*Dd**2*Pk2*f**4 + 61392*Dd**2*Pk2*f**3*r**2 + 164976*Dd**2*Pk2*f**3*r*s - 102636*Dd**2*Pk2*f**3*r - 6288*Dd**2*Pk2*f**3*s**2 - 79344*Dd**2*Pk2*f**3*s + 37728*Dd**2*Pk2*f**3 + 28512*Dd**2*Pk2*f**2*g2*r**2 + 42768*Dd**2*Pk2*f**2*g2*r*s - 39204*Dd**2*Pk2*f**2*g2*r - 137016*Dd**2*Pk2*f**2*g2*s**2 + 47124*Dd**2*Pk2*f**2*g2*s + 11880*Dd**2*Pk2*f**2*g2 + 924*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 33*b1**2*(96*C*D1**2*Pk2*fd*r*s + 96*C*D1**2*Pk2*fd*s**2 - 96*C*D1**2*Pk2*fd*s - 48*C*D1**2*Pk2*fdd*r*s - 48*C*D1**2*Pk2*fdd*s**2 + 48*C*D1**2*Pk2*fdd*s + 384*C*D1*Dd*Pk2*f*r*s - 96*C*D1*Dd*Pk2*f*r + 384*C*D1*Dd*Pk2*f*s**2 - 384*C*D1*Dd*Pk2*f*s + 96*C*D1*Dd*Pk2*f - 384*C*D1*Dd*Pk2*fd*r*s + 48*C*D1*Dd*Pk2*fd*r - 384*C*D1*Dd*Pk2*fd*s**2 + 384*C*D1*Dd*Pk2*fd*s - 48*C*D1*Dd*Pk2*fd - 192*C*D1*Ddd*Pk2*f*r*s + 48*C*D1*Ddd*Pk2*f*r - 192*C*D1*Ddd*Pk2*f*s**2 + 192*C*D1*Ddd*Pk2*f*s - 48*C*D1*Ddd*Pk2*f - 576*C*Dd**2*Pk2*f*r*s + 144*C*Dd**2*Pk2*f*r - 576*C*Dd**2*Pk2*f*s**2 + 576*C*Dd**2*Pk2*f*s - 96*C*Dd**2*Pk2*f - 13*D1**2*K*Pk2*fd*r**2 - 194*D1**2*K*Pk2*fd*r*s + 70*D1**2*K*Pk2*fd*r - 126*D1**2*K*Pk2*fd*s**2 + 114*D1**2*K*Pk2*fd*s - 57*D1**2*K*Pk2*fd + 31*D1**2*K*Pk2*fdd*r**2 + 118*D1**2*K*Pk2*fdd*r*s - 42*D1**2*K*Pk2*fdd*r + 70*D1**2*K*Pk2*fdd*s**2 - 22*D1**2*K*Pk2*fdd*s + 11*D1**2*K*Pk2*fdd + 6*D1**2*K*Pkdd2*fd*k1**2*s**2 - 3*D1**2*K*Pkdd2*fdd*k1**2*s**2 - 28*D1**2*Pk2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 160*D1**2*Pk2*f*fd*r*s + 56*D1**2*Pk2*f*fd*r + 160*D1**2*Pk2*f*fd*s**2 - 8*D1**2*Pk2*f*fd*s - 56*D1**2*Pk2*f*fd - 80*D1**2*Pk2*f*fdd*r*s - 40*D1**2*Pk2*f*fdd*r - 80*D1**2*Pk2*f*fdd*s**2 - 20*D1**2*Pk2*f*fdd*s + 40*D1**2*Pk2*f*fdd - 80*D1**2*Pk2*fd**2*r*s - 40*D1**2*Pk2*fd**2*r - 80*D1**2*Pk2*fd**2*s**2 - 20*D1**2*Pk2*fd**2*s + 40*D1**2*Pk2*fd**2 + 13*D1**2*Pk2*fd*r**2 + 234*D1**2*Pk2*fd*r*s - 90*D1**2*Pk2*fd*r + 166*D1**2*Pk2*fd*s**2 - 58*D1**2*Pk2*fd*s + 77*D1**2*Pk2*fd - 31*D1**2*Pk2*fdd*r**2 - 166*D1**2*Pk2*fdd*r*s + 66*D1**2*Pk2*fdd*r - 118*D1**2*Pk2*fdd*s**2 + 22*D1**2*Pk2*fdd*s - 35*D1**2*Pk2*fdd - 112*D1**2*Pk2*gd2*r*s - 112*D1**2*Pk2*gd2*s**2 + 112*D1**2*Pk2*gd2*s + 56*D1**2*Pk2*gdd2*r*s + 56*D1**2*Pk2*gdd2*s**2 - 56*D1**2*Pk2*gdd2*s - 6*D1**2*Pkdd2*fd*k1**2*s**2 + 3*D1**2*Pkdd2*fdd*k1**2*s**2 - 52*D1*Dd*K*Pk2*f*r**2 - 776*D1*Dd*K*Pk2*f*r*s + 246*D1*Dd*K*Pk2*f*r - 504*D1*Dd*K*Pk2*f*s**2 + 640*D1*Dd*K*Pk2*f*s - 152*D1*Dd*K*Pk2*f + 248*D1*Dd*K*Pk2*fd*r**2 + 944*D1*Dd*K*Pk2*fd*r*s - 410*D1*Dd*K*Pk2*fd*r + 560*D1*Dd*K*Pk2*fd*s**2 - 464*D1*Dd*K*Pk2*fd*s + 106*D1*Dd*K*Pk2*fd + 24*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 12*D1*Dd*K*Pkdd2*f*k1**2*s + 6*D1*Dd*K*Pkdd2*f*k1**2 - 24*D1*Dd*K*Pkdd2*fd*k1**2*s**2 + 6*D1*Dd*K*Pkdd2*fd*k1**2*s + 320*D1*Dd*Pk2*f**2*r*s - 80*D1*Dd*Pk2*f**2*r + 320*D1*Dd*Pk2*f**2*s**2 - 320*D1*Dd*Pk2*f**2*s + 80*D1*Dd*Pk2*f**2 - 640*D1*Dd*Pk2*f*fd*r*s - 80*D1*Dd*Pk2*f*fd*r - 640*D1*Dd*Pk2*f*fd*s**2 + 240*D1*Dd*Pk2*f*fd*s + 100*D1*Dd*Pk2*f*fd + 52*D1*Dd*Pk2*f*r**2 + 936*D1*Dd*Pk2*f*r*s - 286*D1*Dd*Pk2*f*r + 664*D1*Dd*Pk2*f*s**2 - 800*D1*Dd*Pk2*f*s + 192*D1*Dd*Pk2*f - 248*D1*Dd*Pk2*fd*r**2 - 1328*D1*Dd*Pk2*fd*r*s + 554*D1*Dd*Pk2*fd*r - 944*D1*Dd*Pk2*fd*s**2 + 656*D1*Dd*Pk2*fd*s - 154*D1*Dd*Pk2*fd - 448*D1*Dd*Pk2*g2*r*s + 112*D1*Dd*Pk2*g2*r - 448*D1*Dd*Pk2*g2*s**2 + 448*D1*Dd*Pk2*g2*s - 112*D1*Dd*Pk2*g2 + 448*D1*Dd*Pk2*gd2*r*s - 56*D1*Dd*Pk2*gd2*r + 448*D1*Dd*Pk2*gd2*s**2 - 448*D1*Dd*Pk2*gd2*s + 56*D1*Dd*Pk2*gd2 - 24*D1*Dd*Pkdd2*f*k1**2*s**2 + 12*D1*Dd*Pkdd2*f*k1**2*s - 6*D1*Dd*Pkdd2*f*k1**2 + 24*D1*Dd*Pkdd2*fd*k1**2*s**2 - 6*D1*Dd*Pkdd2*fd*k1**2*s + 124*D1*Ddd*K*Pk2*f*r**2 + 472*D1*Ddd*K*Pk2*f*r*s - 242*D1*Ddd*K*Pk2*f*r + 280*D1*Ddd*K*Pk2*f*s**2 - 376*D1*Ddd*K*Pk2*f*s + 132*D1*Ddd*K*Pk2*f - 12*D1*Ddd*K*Pkdd2*f*k1**2*s**2 + 6*D1*Ddd*K*Pkdd2*f*k1**2*s - 3*D1*Ddd*K*Pkdd2*f*k1**2 - 160*D1*Ddd*Pk2*f**2*r*s + 40*D1*Ddd*Pk2*f**2*r - 160*D1*Ddd*Pk2*f**2*s**2 + 160*D1*Ddd*Pk2*f**2*s - 40*D1*Ddd*Pk2*f**2 - 124*D1*Ddd*Pk2*f*r**2 - 664*D1*Ddd*Pk2*f*r*s + 290*D1*Ddd*Pk2*f*r - 472*D1*Ddd*Pk2*f*s**2 + 568*D1*Ddd*Pk2*f*s - 180*D1*Ddd*Pk2*f + 224*D1*Ddd*Pk2*g2*r*s - 56*D1*Ddd*Pk2*g2*r + 224*D1*Ddd*Pk2*g2*s**2 - 224*D1*Ddd*Pk2*g2*s + 56*D1*Ddd*Pk2*g2 + 12*D1*Ddd*Pkdd2*f*k1**2*s**2 - 6*D1*Ddd*Pkdd2*f*k1**2*s + 3*D1*Ddd*Pkdd2*f*k1**2 + 28*D1*Pk2*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 372*Dd**2*K*Pk2*f*r**2 + 1416*Dd**2*K*Pk2*f*r*s - 726*Dd**2*K*Pk2*f*r + 840*Dd**2*K*Pk2*f*s**2 - 1128*Dd**2*K*Pk2*f*s + 298*Dd**2*K*Pk2*f - 36*Dd**2*K*Pkdd2*f*k1**2*s**2 + 18*Dd**2*K*Pkdd2*f*k1**2*s - 480*Dd**2*Pk2*f**2*r*s + 120*Dd**2*Pk2*f**2*r - 480*Dd**2*Pk2*f**2*s**2 + 480*Dd**2*Pk2*f**2*s - 80*Dd**2*Pk2*f**2 - 372*Dd**2*Pk2*f*r**2 - 1992*Dd**2*Pk2*f*r*s + 870*Dd**2*Pk2*f*r - 1416*Dd**2*Pk2*f*s**2 + 1704*Dd**2*Pk2*f*s - 394*Dd**2*Pk2*f + 672*Dd**2*Pk2*g2*r*s - 168*Dd**2*Pk2*g2*r + 672*Dd**2*Pk2*g2*s**2 - 672*Dd**2*Pk2*g2*s + 112*Dd**2*Pk2*g2 + 36*Dd**2*Pkdd2*f*k1**2*s**2 - 18*Dd**2*Pkdd2*f*k1**2*s) + b1*(-2376*C*D1**2*Pk2*f*fd*r**2 - 24816*C*D1**2*Pk2*f*fd*r*s + 6864*C*D1**2*Pk2*f*fd*r - 14256*C*D1**2*Pk2*f*fd*s**2 + 19008*C*D1**2*Pk2*f*fd*s - 4488*C*D1**2*Pk2*f*fd + 3960*C*D1**2*Pk2*f*fdd*r**2 + 14784*C*D1**2*Pk2*f*fdd*r*s - 6600*C*D1**2*Pk2*f*fdd*r + 7920*C*D1**2*Pk2*f*fdd*s**2 - 8712*C*D1**2*Pk2*f*fdd*s + 2640*C*D1**2*Pk2*f*fdd + 3960*C*D1**2*Pk2*fd**2*r**2 + 14784*C*D1**2*Pk2*fd**2*r*s - 6600*C*D1**2*Pk2*fd**2*r + 7920*C*D1**2*Pk2*fd**2*s**2 - 8712*C*D1**2*Pk2*fd**2*s + 2640*C*D1**2*Pk2*fd**2 + 660*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 330*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 330*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 4752*C*D1*Dd*Pk2*f**2*r**2 - 49632*C*D1*Dd*Pk2*f**2*r*s + 17160*C*D1*Dd*Pk2*f**2*r - 28512*C*D1*Dd*Pk2*f**2*s**2 + 39072*C*D1*Dd*Pk2*f**2*s - 9504*C*D1*Dd*Pk2*f**2 + 31680*C*D1*Dd*Pk2*f*fd*r**2 + 118272*C*D1*Dd*Pk2*f*fd*r*s - 57024*C*D1*Dd*Pk2*f*fd*r + 63360*C*D1*Dd*Pk2*f*fd*s**2 - 80256*C*D1*Dd*Pk2*f*fd*s + 21912*C*D1*Dd*Pk2*f*fd + 1320*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 660*C*D1*Dd*Pkdd2*f**2*k1**2*s + 330*C*D1*Dd*Pkdd2*f**2*k1**2 - 2640*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 660*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 7920*C*D1*Ddd*Pk2*f**2*r**2 + 29568*C*D1*Ddd*Pk2*f**2*r*s - 15312*C*D1*Ddd*Pk2*f**2*r + 15840*C*D1*Ddd*Pk2*f**2*s**2 - 22704*C*D1*Ddd*Pk2*f**2*s + 7920*C*D1*Ddd*Pk2*f**2 - 660*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 330*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 165*C*D1*Ddd*Pkdd2*f**2*k1**2 + 23760*C*Dd**2*Pk2*f**2*r**2 + 88704*C*Dd**2*Pk2*f**2*r*s - 45936*C*Dd**2*Pk2*f**2*r + 47520*C*Dd**2*Pk2*f**2*s**2 - 68112*C*Dd**2*Pk2*f**2*s + 18744*C*Dd**2*Pk2*f**2 - 1980*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 990*C*Dd**2*Pkdd2*f**2*k1**2*s + 2706*D1**2*K*Pk2*f*fd*r**2 + 4356*D1**2*K*Pk2*f*fd*r*s - 2178*D1**2*K*Pk2*f*fd*r - 14916*D1**2*K*Pk2*f*fd*s**2 + 14916*D1**2*K*Pk2*f*fd*s - 7458*D1**2*K*Pk2*f*fd - 2376*D1**2*K*Pk2*f*fdd*r**2 - 3564*D1**2*K*Pk2*f*fdd*r*s + 1782*D1**2*K*Pk2*f*fdd*r + 11418*D1**2*K*Pk2*f*fdd*s**2 - 11418*D1**2*K*Pk2*f*fdd*s + 5709*D1**2*K*Pk2*f*fdd - 2376*D1**2*K*Pk2*fd**2*r**2 - 3564*D1**2*K*Pk2*fd**2*r*s + 1782*D1**2*K*Pk2*fd**2*r + 11418*D1**2*K*Pk2*fd**2*s**2 - 11418*D1**2*K*Pk2*fd**2*s - 198*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 198*D1**2*K*Pkdd2*f*fd*k1**2*s - 99*D1**2*K*Pkdd2*f*fd*k1**2 - 924*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 10395*D1**2*Pk2*f**2*fd*r**2 - 37620*D1**2*Pk2*f**2*fd*r*s + 19470*D1**2*Pk2*f**2*fd*r - 16335*D1**2*Pk2*f**2*fd*s**2 + 26730*D1**2*Pk2*f**2*fd*s - 8580*D1**2*Pk2*f**2*fd + 13365*D1**2*Pk2*f**2*fdd*r**2 + 31680*D1**2*Pk2*f**2*fdd*r*s - 20130*D1**2*Pk2*f**2*fdd*r + 9405*D1**2*Pk2*f**2*fdd*s**2 - 20130*D1**2*Pk2*f**2*fdd*s + 7920*D1**2*Pk2*f**2*fdd + 26730*D1**2*Pk2*f*fd**2*r**2 + 63360*D1**2*Pk2*f*fd**2*r*s - 40260*D1**2*Pk2*f*fd**2*r + 18810*D1**2*Pk2*f*fd**2*s**2 - 40260*D1**2*Pk2*f*fd**2*s + 14520*D1**2*Pk2*f*fd**2 - 5082*D1**2*Pk2*f*fd*r**2 + 396*D1**2*Pk2*f*fd*r*s + 8514*D1**2*Pk2*f*fd*r + 8580*D1**2*Pk2*f*fd*s**2 - 10692*D1**2*Pk2*f*fd*s - 1518*D1**2*Pk2*f*fd + 4356*D1**2*Pk2*f*fdd*r**2 + 6336*D1**2*Pk2*f*fdd*r*s - 5940*D1**2*Pk2*f*fdd*r - 3102*D1**2*Pk2*f*fdd*s**2 + 2574*D1**2*Pk2*f*fdd*s + 1749*D1**2*Pk2*f*fdd + 858*D1**2*Pk2*f*gd2*r**2 + 12804*D1**2*Pk2*f*gd2*r*s - 1716*D1**2*Pk2*f*gd2*r + 8316*D1**2*Pk2*f*gd2*s**2 - 12804*D1**2*Pk2*f*gd2*s + 858*D1**2*Pk2*f*gd2 - 2046*D1**2*Pk2*f*gdd2*r**2 - 7788*D1**2*Pk2*f*gdd2*r*s + 4092*D1**2*Pk2*f*gdd2*r - 4620*D1**2*Pk2*f*gdd2*s**2 + 7788*D1**2*Pk2*f*gdd2*s - 2046*D1**2*Pk2*f*gdd2 + 4356*D1**2*Pk2*fd**2*r**2 + 6336*D1**2*Pk2*fd**2*r*s - 5940*D1**2*Pk2*fd**2*r - 3102*D1**2*Pk2*fd**2*s**2 + 2574*D1**2*Pk2*fd**2*s - 3300*D1**2*Pk2*fd**2 + 858*D1**2*Pk2*fd*g2*r**2 + 12804*D1**2*Pk2*fd*g2*r*s - 4620*D1**2*Pk2*fd*g2*r + 8316*D1**2*Pk2*fd*g2*s**2 - 7524*D1**2*Pk2*fd*g2*s + 3762*D1**2*Pk2*fd*g2 - 4092*D1**2*Pk2*fd*gd2*r**2 - 15576*D1**2*Pk2*fd*gd2*r*s + 6864*D1**2*Pk2*fd*gd2*r - 9240*D1**2*Pk2*fd*gd2*s**2 + 9240*D1**2*Pk2*fd*gd2*s - 2772*D1**2*Pk2*fd*gd2 - 2046*D1**2*Pk2*fdd*g2*r**2 - 7788*D1**2*Pk2*fdd*g2*r*s + 2772*D1**2*Pk2*fdd*g2*r - 4620*D1**2*Pk2*fdd*g2*s**2 + 1452*D1**2*Pk2*fdd*g2*s - 726*D1**2*Pk2*fdd*g2 + 840*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 280*D1**2*Pkdd2*f**2*fd*k1**2*s - 140*D1**2*Pkdd2*f**2*fd*k1**2 - 420*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 140*D1**2*Pkdd2*f**2*fdd*k1**2*s + 70*D1**2*Pkdd2*f**2*fdd*k1**2 - 840*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 280*D1**2*Pkdd2*f*fd**2*k1**2*s - 462*D1**2*Pkdd2*f*fd*k1**2*s**2 - 198*D1**2*Pkdd2*f*fd*k1**2*s + 99*D1**2*Pkdd2*f*fd*k1**2 + 330*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 396*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 198*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 330*D1**2*Pkdd2*fd**2*k1**2*s**2 - 396*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 396*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 198*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 33*D1**2*bdd1*(20*Pk2*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 4) - 56*Pk2*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + f*(2*Pk2*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - K*(31*r**2 + 118*r*s - 69*r + 70*s**2 - 118*s + 45) + 31*r**2 + 166*r*s - 81*r + 118*s**2 - 190*s + 57) + Pkdd2*k1**2*(3*K - 3)*(2*s**2 - 2*s + 1))) + 5412*D1*Dd*K*Pk2*f**2*r**2 + 8712*D1*Dd*K*Pk2*f**2*r*s - 7590*D1*Dd*K*Pk2*f**2*r - 29832*D1*Dd*K*Pk2*f**2*s**2 + 10560*D1*Dd*K*Pk2*f**2*s - 4752*D1*Dd*K*Pk2*f**2 - 19008*D1*Dd*K*Pk2*f*fd*r**2 - 28512*D1*Dd*K*Pk2*f*fd*r*s + 20196*D1*Dd*K*Pk2*f*fd*r + 91344*D1*Dd*K*Pk2*f*fd*s**2 - 61380*D1*Dd*K*Pk2*f*fd*s + 7854*D1*Dd*K*Pk2*f*fd - 396*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 198*D1*Dd*K*Pkdd2*f**2*k1**2*s - 99*D1*Dd*K*Pkdd2*f**2*k1**2 - 13860*D1*Dd*Pk2*f**3*r**2 - 50160*D1*Dd*Pk2*f**3*r*s + 26400*D1*Dd*Pk2*f**3*r - 21780*D1*Dd*Pk2*f**3*s**2 + 35970*D1*Dd*Pk2*f**3*s - 12375*D1*Dd*Pk2*f**3 + 106920*D1*Dd*Pk2*f**2*fd*r**2 + 253440*D1*Dd*Pk2*f**2*fd*r*s - 165660*D1*Dd*Pk2*f**2*fd*r + 75240*D1*Dd*Pk2*f**2*fd*s**2 - 162690*D1*Dd*Pk2*f**2*fd*s + 60390*D1*Dd*Pk2*f**2*fd - 10164*D1*Dd*Pk2*f**2*r**2 + 792*D1*Dd*Pk2*f**2*r*s + 9966*D1*Dd*Pk2*f**2*r + 17160*D1*Dd*Pk2*f**2*s**2 - 8976*D1*Dd*Pk2*f**2*s - 792*D1*Dd*Pk2*f**2 + 34848*D1*Dd*Pk2*f*fd*r**2 + 50688*D1*Dd*Pk2*f*fd*r*s - 47520*D1*Dd*Pk2*f*fd*r - 24816*D1*Dd*Pk2*f*fd*s**2 + 3828*D1*Dd*Pk2*f*fd*s + 9306*D1*Dd*Pk2*f*fd + 3432*D1*Dd*Pk2*f*g2*r**2 + 51216*D1*Dd*Pk2*f*g2*r*s - 16236*D1*Dd*Pk2*f*g2*r + 33264*D1*Dd*Pk2*f*g2*s**2 - 42240*D1*Dd*Pk2*f*g2*s + 10032*D1*Dd*Pk2*f*g2 - 16368*D1*Dd*Pk2*f*gd2*r**2 - 62304*D1*Dd*Pk2*f*gd2*r*s + 32340*D1*Dd*Pk2*f*gd2*r - 36960*D1*Dd*Pk2*f*gd2*s**2 + 55968*D1*Dd*Pk2*f*gd2*s - 15972*D1*Dd*Pk2*f*gd2 - 16368*D1*Dd*Pk2*fd*g2*r**2 - 62304*D1*Dd*Pk2*fd*g2*r*s + 27060*D1*Dd*Pk2*fd*g2*r - 36960*D1*Dd*Pk2*fd*g2*s**2 + 30624*D1*Dd*Pk2*fd*g2*s - 6996*D1*Dd*Pk2*fd*g2 + 1120*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 560*D1*Dd*Pkdd2*f**3*k1**2*s + 280*D1*Dd*Pkdd2*f**3*k1**2 - 3360*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 280*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 140*D1*Dd*Pkdd2*f**2*fd*k1**2 - 924*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 462*D1*Dd*Pkdd2*f**2*k1**2*s - 231*D1*Dd*Pkdd2*f**2*k1**2 + 2640*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 660*D1*Dd*Pkdd2*f*fd*k1**2*s - 1584*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 792*D1*Dd*Pkdd2*f*g2*k1**2*s - 396*D1*Dd*Pkdd2*f*g2*k1**2 + 1584*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 - 396*D1*Dd*Pkdd2*f*gd2*k1**2*s + 1584*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 - 396*D1*Dd*Pkdd2*fd*g2*k1**2*s - 4752*D1*Ddd*K*Pk2*f**2*r**2 - 7128*D1*Ddd*K*Pk2*f**2*r*s + 6534*D1*Ddd*K*Pk2*f**2*r + 22836*D1*Ddd*K*Pk2*f**2*s**2 - 7854*D1*Ddd*K*Pk2*f**2*s + 3333*D1*Ddd*K*Pk2*f**2 + 17820*D1*Ddd*Pk2*f**3*r**2 + 42240*D1*Ddd*Pk2*f**3*r*s - 28380*D1*Ddd*Pk2*f**3*r + 12540*D1*Ddd*Pk2*f**3*s**2 - 27390*D1*Ddd*Pk2*f**3*s + 12045*D1*Ddd*Pk2*f**3 + 8712*D1*Ddd*Pk2*f**2*r**2 + 12672*D1*Ddd*Pk2*f**2*r*s - 11880*D1*Ddd*Pk2*f**2*r - 6204*D1*Ddd*Pk2*f**2*s**2 - 3234*D1*Ddd*Pk2*f**2*s + 2805*D1*Ddd*Pk2*f**2 - 8184*D1*Ddd*Pk2*f*g2*r**2 - 31152*D1*Ddd*Pk2*f*g2*r*s + 15972*D1*Ddd*Pk2*f*g2*r - 18480*D1*Ddd*Pk2*f*g2*s**2 + 24816*D1*Ddd*Pk2*f*g2*s - 8712*D1*Ddd*Pk2*f*g2 - 560*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 280*D1*Ddd*Pkdd2*f**3*k1**2*s - 140*D1*Ddd*Pkdd2*f**3*k1**2 + 660*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 330*D1*Ddd*Pkdd2*f**2*k1**2*s + 165*D1*Ddd*Pkdd2*f**2*k1**2 + 792*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 - 396*D1*Ddd*Pkdd2*f*g2*k1**2*s + 198*D1*Ddd*Pkdd2*f*g2*k1**2 + 66*D1*bd1*(D1*(4*Pk2*f**2*(r*(20*s - 17) + 20*s**2 - 39*s + 17) - 28*Pk2*(g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + gd2*(-4*r*s + r - (1 - 2*s)**2)) + f*(Pk2*(48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 13*K*r**2 - 194*K*r*s + 75*K*r - 126*K*s**2 + 166*K*s - 41*K - 10*fd*(4*s - 1)*(4*r + 4*s - 3) + 13*r**2 + 234*r*s - 85*r + 166*s**2 - 254*s + 51) + Pkdd2*k1**2*(3*K - 3)*(2*s**2 - 2*s + 1)) + fd*(Pk2*(-24*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(62*r**2 + 236*r*s - 111*r + 140*s**2 - 140*s + 21) - 62*r**2 - 332*r*s + 147*r - 236*s**2 + 212*s - 9) + 3*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1))) + Dd*(-10*Pk2*f**2*(4*r*(8*s - 5) + 32*s**2 - 52*s + 17) + 56*Pk2*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + f*(-2*Pk2*(24*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - K*(124*r**2 + 472*r*s - 259*r + 280*s**2 - 424*s + 128) + 124*r**2 + 664*r*s - 307*r + 472*s**2 - 664*s + 176) + Pkdd2*k1**2*(3 - 3*K)*(8*s**2 - 6*s + 1)))) - 14256*Dd**2*K*Pk2*f**2*r**2 - 21384*Dd**2*K*Pk2*f**2*r*s + 19602*Dd**2*K*Pk2*f**2*r + 68508*Dd**2*K*Pk2*f**2*s**2 - 23562*Dd**2*K*Pk2*f**2*s - 5940*Dd**2*K*Pk2*f**2 + 53460*Dd**2*Pk2*f**3*r**2 + 126720*Dd**2*Pk2*f**3*r*s - 85140*Dd**2*Pk2*f**3*r + 37620*Dd**2*Pk2*f**3*s**2 - 82170*Dd**2*Pk2*f**3*s + 30030*Dd**2*Pk2*f**3 + 26136*Dd**2*Pk2*f**2*r**2 + 38016*Dd**2*Pk2*f**2*r*s - 35640*Dd**2*Pk2*f**2*r - 18612*Dd**2*Pk2*f**2*s**2 - 9702*Dd**2*Pk2*f**2*s + 10692*Dd**2*Pk2*f**2 - 24552*Dd**2*Pk2*f*g2*r**2 - 93456*Dd**2*Pk2*f*g2*r*s + 47916*Dd**2*Pk2*f*g2*r - 55440*Dd**2*Pk2*f*g2*s**2 + 74448*Dd**2*Pk2*f*g2*s - 19668*Dd**2*Pk2*f*g2 - 1680*Dd**2*Pkdd2*f**3*k1**2*s**2 + 840*Dd**2*Pkdd2*f**3*k1**2*s + 1980*Dd**2*Pkdd2*f**2*k1**2*s**2 - 990*Dd**2*Pkdd2*f**2*k1**2*s + 2376*Dd**2*Pkdd2*f*g2*k1**2*s**2 - 1188*Dd**2*Pkdd2*f*g2*k1**2*s))/(693*d**2*k3**4) + D1**2*Pk3*ct**4*k2**2*st**2*(-10488*C*D1**2*Pk2*f**2*fd*r**2 + 74688*C*D1**2*Pk2*f**2*fd*r*s - 17904*C*D1**2*Pk2*f**2*fd*r + 36000*C*D1**2*Pk2*f**2*fd*s**2 - 48896*C*D1**2*Pk2*f**2*fd*s + 8504*C*D1**2*Pk2*f**2*fd + 6036*C*D1**2*Pk2*f**2*fdd*r**2 - 43680*C*D1**2*Pk2*f**2*fdd*r*s + 10536*C*D1**2*Pk2*f**2*fdd*r - 18000*C*D1**2*Pk2*f**2*fdd*s**2 + 26560*C*D1**2*Pk2*f**2*fdd*s - 3988*C*D1**2*Pk2*f**2*fdd + 12072*C*D1**2*Pk2*f*fd**2*r**2 - 87360*C*D1**2*Pk2*f*fd**2*r*s + 21072*C*D1**2*Pk2*f*fd**2*r - 36000*C*D1**2*Pk2*f*fd**2*s**2 + 53120*C*D1**2*Pk2*f*fd**2*s - 14560*C*D1**2*Pk2*f*fd**2 - 1584*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 792*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 792*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 10812*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 7208*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 3604*C*D1**2*Pkdd2*f**2*fd*k1**2 + 6000*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 4000*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 2000*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 12000*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 8000*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 13984*C*D1*Dd*Pk2*f**3*r**2 + 99584*C*D1*Dd*Pk2*f**3*r*s - 10912*C*D1*Dd*Pk2*f**3*r + 48000*C*D1*Dd*Pk2*f**3*s**2 - 73792*C*D1*Dd*Pk2*f**3*s + 5008*C*D1*Dd*Pk2*f**3 + 48288*C*D1*Dd*Pk2*f**2*fd*r**2 - 349440*C*D1*Dd*Pk2*f**2*fd*r*s + 61680*C*D1*Dd*Pk2*f**2*fd*r - 144000*C*D1*Dd*Pk2*f**2*fd*s**2 + 229600*C*D1*Dd*Pk2*f**2*fd*s - 47632*C*D1*Dd*Pk2*f**2*fd - 3168*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 1584*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 792*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 6336*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 1584*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 14416*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 7208*C*D1*Dd*Pkdd2*f**3*k1**2*s - 3604*C*D1*Dd*Pkdd2*f**3*k1**2 + 48000*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 28000*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 4000*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 8048*C*D1*Ddd*Pk2*f**3*r**2 - 58240*C*D1*Ddd*Pk2*f**3*r*s + 6512*C*D1*Ddd*Pk2*f**3*r - 24000*C*D1*Ddd*Pk2*f**3*s**2 + 41120*C*D1*Ddd*Pk2*f**3*s - 1976*C*D1*Ddd*Pk2*f**3 + 1584*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 792*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 396*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 + 8000*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 4000*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 2000*C*D1*Ddd*Pkdd2*f**3*k1**2 + 24144*C*Dd**2*Pk2*f**3*r**2 - 174720*C*Dd**2*Pk2*f**3*r*s + 19536*C*Dd**2*Pk2*f**3*r - 72000*C*Dd**2*Pk2*f**3*s**2 + 123360*C*Dd**2*Pk2*f**3*s - 25096*C*Dd**2*Pk2*f**3 + 4752*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 2376*C*Dd**2*Pkdd2*b1*f**2*k1**2*s + 24000*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 12000*C*Dd**2*Pkdd2*f**3*k1**2*s - 3960*D1**2*K*Pk2*b1*f*fd*r**2 + 31680*D1**2*K*Pk2*b1*f*fd*r*s - 15840*D1**2*K*Pk2*b1*f*fd*r + 15840*D1**2*K*Pk2*b1*f*fd*s**2 - 15840*D1**2*K*Pk2*b1*f*fd*s + 7920*D1**2*K*Pk2*b1*f*fd + 1980*D1**2*K*Pk2*b1*f*fdd*r**2 - 15840*D1**2*K*Pk2*b1*f*fdd*r*s + 7920*D1**2*K*Pk2*b1*f*fdd*r - 7920*D1**2*K*Pk2*b1*f*fdd*s**2 + 7920*D1**2*K*Pk2*b1*f*fdd*s - 3960*D1**2*K*Pk2*b1*f*fdd + 1980*D1**2*K*Pk2*b1*fd**2*r**2 - 15840*D1**2*K*Pk2*b1*fd**2*r*s + 7920*D1**2*K*Pk2*b1*fd**2*r - 7920*D1**2*K*Pk2*b1*fd**2*s**2 + 7920*D1**2*K*Pk2*b1*fd**2*s - 396*D1**2*K*Pkdd2*b1**2*fd*k1**2*s**2 + 198*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s**2 - 4884*D1**2*K*Pkdd2*b1*f*fd*k1**2*s**2 + 4884*D1**2*K*Pkdd2*b1*f*fd*k1**2*s - 2442*D1**2*K*Pkdd2*b1*f*fd*k1**2 + 2640*D1**2*K*Pkdd2*b1*f*fdd*k1**2*s**2 - 2640*D1**2*K*Pkdd2*b1*f*fdd*k1**2*s + 1320*D1**2*K*Pkdd2*b1*f*fdd*k1**2 + 2640*D1**2*K*Pkdd2*b1*fd**2*k1**2*s**2 - 2640*D1**2*K*Pkdd2*b1*fd**2*k1**2*s + 5940*D1**2*Pk2*b1*f**2*fd*r**2 - 3960*D1**2*Pk2*b1*f**2*fd*r + 1980*D1**2*Pk2*b1*f**2*fd - 5940*D1**2*Pk2*b1*f**2*fdd*r**2 + 3960*D1**2*Pk2*b1*f**2*fdd*r - 1980*D1**2*Pk2*b1*f**2*fdd - 11880*D1**2*Pk2*b1*f*fd**2*r**2 + 7920*D1**2*Pk2*b1*f*fd**2*r + 11880*D1**2*Pk2*b1*f*fd*r**2 - 5940*D1**2*Pk2*b1*f*fdd*r**2 - 5940*D1**2*Pk2*b1*fd**2*r**2 + 15840*D1**2*Pk2*b2*f*fd*r*s - 7920*D1**2*Pk2*b2*f*fd*r + 15840*D1**2*Pk2*b2*f*fd*s**2 - 15840*D1**2*Pk2*b2*f*fd*s + 7920*D1**2*Pk2*b2*f*fd - 7920*D1**2*Pk2*b2*f*fdd*r*s + 3960*D1**2*Pk2*b2*f*fdd*r - 7920*D1**2*Pk2*b2*f*fdd*s**2 + 7920*D1**2*Pk2*b2*f*fdd*s - 3960*D1**2*Pk2*b2*f*fdd - 7920*D1**2*Pk2*b2*fd**2*r*s + 3960*D1**2*Pk2*b2*fd**2*r - 7920*D1**2*Pk2*b2*fd**2*s**2 + 7920*D1**2*Pk2*b2*fd**2*s + 7920*D1**2*Pk2*bd2*f**2*r*s + 7920*D1**2*Pk2*bd2*f**2*s**2 - 7920*D1**2*Pk2*bd2*f**2*s - 15840*D1**2*Pk2*bd2*f*fd*r*s + 3960*D1**2*Pk2*bd2*f*fd*r - 15840*D1**2*Pk2*bd2*f*fd*s**2 + 15840*D1**2*Pk2*bd2*f*fd*s - 3960*D1**2*Pk2*bd2*f*fd - 3960*D1**2*Pk2*bdd2*f**2*r*s - 3960*D1**2*Pk2*bdd2*f**2*s**2 + 3960*D1**2*Pk2*bdd2*f**2*s - 3960*D1**2*Pk2*f**3*fd*r**2 + 3960*D1**2*Pk2*f**3*fd*r - 1980*D1**2*Pk2*f**3*fd + 3960*D1**2*Pk2*f**3*fdd*r**2 - 3960*D1**2*Pk2*f**3*fdd*r + 1980*D1**2*Pk2*f**3*fdd + 11880*D1**2*Pk2*f**2*fd**2*r**2 - 11880*D1**2*Pk2*f**2*fd**2*r + 1980*D1**2*Pk2*f**2*fd**2 + 20160*D1**2*Pk2*f**2*fd*r**2 - 37344*D1**2*Pk2*f**2*fd*r*s - 992*D1**2*Pk2*f**2*fd*r - 18000*D1**2*Pk2*f**2*fd*s**2 + 24448*D1**2*Pk2*f**2*fd*s + 720*D1**2*Pk2*f**2*fd - 12456*D1**2*Pk2*f**2*fdd*r**2 + 21840*D1**2*Pk2*f**2*fdd*r*s + 1024*D1**2*Pk2*f**2*fdd*r + 9000*D1**2*Pk2*f**2*fdd*s**2 - 13280*D1**2*Pk2*f**2*fdd*s - 1152*D1**2*Pk2*f**2*fdd + 3960*D1**2*Pk2*f**2*gd2*r**2 - 31680*D1**2*Pk2*f**2*gd2*r*s - 7920*D1**2*Pk2*f**2*gd2*r - 15840*D1**2*Pk2*f**2*gd2*s**2 + 31680*D1**2*Pk2*f**2*gd2*s + 3960*D1**2*Pk2*f**2*gd2 - 1980*D1**2*Pk2*f**2*gdd2*r**2 + 15840*D1**2*Pk2*f**2*gdd2*r*s + 3960*D1**2*Pk2*f**2*gdd2*r + 7920*D1**2*Pk2*f**2*gdd2*s**2 - 15840*D1**2*Pk2*f**2*gdd2*s - 1980*D1**2*Pk2*f**2*gdd2 - 24912*D1**2*Pk2*f*fd**2*r**2 + 43680*D1**2*Pk2*f*fd**2*r*s + 2048*D1**2*Pk2*f*fd**2*r + 18000*D1**2*Pk2*f*fd**2*s**2 - 26560*D1**2*Pk2*f*fd**2*s + 7280*D1**2*Pk2*f*fd**2 + 7920*D1**2*Pk2*f*fd*g2*r**2 - 63360*D1**2*Pk2*f*fd*g2*r*s + 31680*D1**2*Pk2*f*fd*g2*r - 31680*D1**2*Pk2*f*fd*g2*s**2 + 31680*D1**2*Pk2*f*fd*g2*s - 15840*D1**2*Pk2*f*fd*g2 - 7920*D1**2*Pk2*f*fd*gd2*r**2 + 63360*D1**2*Pk2*f*fd*gd2*r*s - 7920*D1**2*Pk2*f*fd*gd2*r + 31680*D1**2*Pk2*f*fd*gd2*s**2 - 47520*D1**2*Pk2*f*fd*gd2*s + 15840*D1**2*Pk2*f*fd*gd2 - 3960*D1**2*Pk2*f*fdd*g2*r**2 + 31680*D1**2*Pk2*f*fdd*g2*r*s - 15840*D1**2*Pk2*f*fdd*g2*r + 15840*D1**2*Pk2*f*fdd*g2*s**2 - 15840*D1**2*Pk2*f*fdd*g2*s + 7920*D1**2*Pk2*f*fdd*g2 - 3960*D1**2*Pk2*fd**2*g2*r**2 + 31680*D1**2*Pk2*fd**2*g2*r*s - 15840*D1**2*Pk2*fd**2*g2*r + 15840*D1**2*Pk2*fd**2*g2*s**2 - 15840*D1**2*Pk2*fd**2*g2*s + 396*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 198*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 4500*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 - 4500*D1**2*Pkdd2*b1*f**2*fd*k1**2*s + 2250*D1**2*Pkdd2*b1*f**2*fd*k1**2 - 2250*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 + 2250*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s - 1125*D1**2*Pkdd2*b1*f**2*fdd*k1**2 - 4500*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 + 4500*D1**2*Pkdd2*b1*f*fd**2*k1**2*s + 3828*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 - 2244*D1**2*Pkdd2*b1*f*fd*k1**2*s + 1122*D1**2*Pkdd2*b1*f*fd*k1**2 - 2112*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 + 1320*D1**2*Pkdd2*b1*f*fdd*k1**2*s - 660*D1**2*Pkdd2*b1*f*fdd*k1**2 + 792*D1**2*Pkdd2*b1*f*gd2*k1**2*s**2 - 396*D1**2*Pkdd2*b1*f*gdd2*k1**2*s**2 - 2112*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 + 1320*D1**2*Pkdd2*b1*fd**2*k1**2*s + 792*D1**2*Pkdd2*b1*fd*g2*k1**2*s**2 - 792*D1**2*Pkdd2*b1*fd*gd2*k1**2*s**2 - 396*D1**2*Pkdd2*b1*fdd*g2*k1**2*s**2 + 396*D1**2*Pkdd2*bd1**2*f*k1**2*s*(K - 1)*(s - 1) + 1500*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 750*D1**2*Pkdd2*f**3*fd*k1**2*s + 375*D1**2*Pkdd2*f**3*fd*k1**2 + 7812*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 5208*D1**2*Pkdd2*f**2*fd*k1**2*s + 2604*D1**2*Pkdd2*f**2*fd*k1**2 - 4500*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 3000*D1**2*Pkdd2*f**2*fdd*k1**2*s - 1500*D1**2*Pkdd2*f**2*fdd*k1**2 + 4884*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 2640*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 9000*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 6000*D1**2*Pkdd2*f*fd**2*k1**2*s + 9768*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 9768*D1**2*Pkdd2*f*fd*g2*k1**2*s + 4884*D1**2*Pkdd2*f*fd*g2*k1**2 - 10560*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 5280*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 5280*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 5280*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 2640*D1**2*Pkdd2*f*fdd*g2*k1**2 - 5280*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 5280*D1**2*Pkdd2*fd**2*g2*k1**2*s - 3*D1**2*bdd1*f*(-66*Pkdd2*k1**2*(b1*(K - 1)*(2*s**2 - 2*s + 1) - 2*g2*(s - 1)**2) + 5*f**2*(132*Pk2*(r - 1)**2 + 25*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 22*f*(15*Pk2*(K*(r**2 - 2*r*(4*s + 1) - 4*s**2 + 8*s + 1) - 3*(r - 1)**2) + 2*Pkdd2*k1**2*(3*C*(s - 1)**2 + s**2*(10*K - 8) + 6*s - 3))) - 7920*D1*Dd*K*Pk2*b1*f**2*r**2 + 63360*D1*Dd*K*Pk2*b1*f**2*r*s - 7920*D1*Dd*K*Pk2*b1*f**2*r + 31680*D1*Dd*K*Pk2*b1*f**2*s**2 - 47520*D1*Dd*K*Pk2*b1*f**2*s + 3960*D1*Dd*K*Pk2*b1*f**2 + 15840*D1*Dd*K*Pk2*b1*f*fd*r**2 - 126720*D1*Dd*K*Pk2*b1*f*fd*r*s + 39600*D1*Dd*K*Pk2*b1*f*fd*r - 63360*D1*Dd*K*Pk2*b1*f*fd*s**2 + 79200*D1*Dd*K*Pk2*b1*f*fd*s - 23760*D1*Dd*K*Pk2*b1*f*fd - 1584*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s**2 + 792*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s - 396*D1*Dd*K*Pkdd2*b1**2*f*k1**2 + 1584*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s**2 - 396*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s - 9768*D1*Dd*K*Pkdd2*b1*f**2*k1**2*s**2 + 4884*D1*Dd*K*Pkdd2*b1*f**2*k1**2*s - 2442*D1*Dd*K*Pkdd2*b1*f**2*k1**2 + 21120*D1*Dd*K*Pkdd2*b1*f*fd*k1**2*s**2 - 15840*D1*Dd*K*Pkdd2*b1*f*fd*k1**2*s + 2640*D1*Dd*K*Pkdd2*b1*f*fd*k1**2 + 7920*D1*Dd*Pk2*b1*f**3*r**2 - 7920*D1*Dd*Pk2*b1*f**3*r + 3960*D1*Dd*Pk2*b1*f**3 - 47520*D1*Dd*Pk2*b1*f**2*fd*r**2 + 39600*D1*Dd*Pk2*b1*f**2*fd*r - 7920*D1*Dd*Pk2*b1*f**2*fd + 23760*D1*Dd*Pk2*b1*f**2*r**2 - 23760*D1*Dd*Pk2*b1*f**2*r + 11880*D1*Dd*Pk2*b1*f**2 - 47520*D1*Dd*Pk2*b1*f*fd*r**2 + 23760*D1*Dd*Pk2*b1*f*fd*r + 31680*D1*Dd*Pk2*b2*f**2*r*s - 7920*D1*Dd*Pk2*b2*f**2*r + 31680*D1*Dd*Pk2*b2*f**2*s**2 - 31680*D1*Dd*Pk2*b2*f**2*s + 7920*D1*Dd*Pk2*b2*f**2 - 63360*D1*Dd*Pk2*b2*f*fd*r*s + 23760*D1*Dd*Pk2*b2*f*fd*r - 63360*D1*Dd*Pk2*b2*f*fd*s**2 + 63360*D1*Dd*Pk2*b2*f*fd*s - 15840*D1*Dd*Pk2*b2*f*fd - 31680*D1*Dd*Pk2*bd2*f**2*r*s + 3960*D1*Dd*Pk2*bd2*f**2*r - 31680*D1*Dd*Pk2*bd2*f**2*s**2 + 31680*D1*Dd*Pk2*bd2*f**2*s - 3960*D1*Dd*Pk2*bd2*f**2 - 3960*D1*Dd*Pk2*f**4*r**2 + 3960*D1*Dd*Pk2*f**4*r - 1980*D1*Dd*Pk2*f**4 + 31680*D1*Dd*Pk2*f**3*fd*r**2 - 31680*D1*Dd*Pk2*f**3*fd*r + 7920*D1*Dd*Pk2*f**3*fd + 26880*D1*Dd*Pk2*f**3*r**2 - 49792*D1*Dd*Pk2*f**3*r*s - 14432*D1*Dd*Pk2*f**3*r - 24000*D1*Dd*Pk2*f**3*s**2 + 36896*D1*Dd*Pk2*f**3*s + 7440*D1*Dd*Pk2*f**3 - 99648*D1*Dd*Pk2*f**2*fd*r**2 + 174720*D1*Dd*Pk2*f**2*fd*r*s + 32080*D1*Dd*Pk2*f**2*fd*r + 72000*D1*Dd*Pk2*f**2*fd*s**2 - 114800*D1*Dd*Pk2*f**2*fd*s + 11232*D1*Dd*Pk2*f**2*fd + 15840*D1*Dd*Pk2*f**2*g2*r**2 - 126720*D1*Dd*Pk2*f**2*g2*r*s + 15840*D1*Dd*Pk2*f**2*g2*r - 63360*D1*Dd*Pk2*f**2*g2*s**2 + 95040*D1*Dd*Pk2*f**2*g2*s - 7920*D1*Dd*Pk2*f**2*g2 - 15840*D1*Dd*Pk2*f**2*gd2*r**2 + 126720*D1*Dd*Pk2*f**2*gd2*r*s + 7920*D1*Dd*Pk2*f**2*gd2*r + 63360*D1*Dd*Pk2*f**2*gd2*s**2 - 110880*D1*Dd*Pk2*f**2*gd2*s + 7920*D1*Dd*Pk2*f**2*gd2 - 31680*D1*Dd*Pk2*f*fd*g2*r**2 + 253440*D1*Dd*Pk2*f*fd*g2*r*s - 79200*D1*Dd*Pk2*f*fd*g2*r + 126720*D1*Dd*Pk2*f*fd*g2*s**2 - 158400*D1*Dd*Pk2*f*fd*g2*s + 47520*D1*Dd*Pk2*f*fd*g2 + 1584*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 792*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 396*D1*Dd*Pkdd2*b1**2*f*k1**2 - 1584*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 396*D1*Dd*Pkdd2*b1**2*fd*k1**2*s + 6000*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 - 3000*D1*Dd*Pkdd2*b1*f**3*k1**2*s + 1500*D1*Dd*Pkdd2*b1*f**3*k1**2 - 18000*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 + 13500*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s - 2250*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 + 7656*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 - 3828*D1*Dd*Pkdd2*b1*f**2*k1**2*s + 1914*D1*Dd*Pkdd2*b1*f**2*k1**2 - 16896*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 + 9504*D1*Dd*Pkdd2*b1*f*fd*k1**2*s - 1320*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 3168*D1*Dd*Pkdd2*b1*f*g2*k1**2*s**2 - 1584*D1*Dd*Pkdd2*b1*f*g2*k1**2*s + 792*D1*Dd*Pkdd2*b1*f*g2*k1**2 - 3168*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s**2 + 792*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s - 3168*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s**2 + 792*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s + 1500*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 750*D1*Dd*Pkdd2*f**4*k1**2*s + 375*D1*Dd*Pkdd2*f**4*k1**2 + 10416*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 5208*D1*Dd*Pkdd2*f**3*k1**2*s + 2604*D1*Dd*Pkdd2*f**3*k1**2 - 36000*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 21000*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 3000*D1*Dd*Pkdd2*f**2*fd*k1**2 + 19536*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 9768*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 4884*D1*Dd*Pkdd2*f**2*g2*k1**2 - 21120*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 5280*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 42240*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 31680*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 5280*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 3960*D1*Ddd*K*Pk2*b1*f**2*r**2 - 31680*D1*Ddd*K*Pk2*b1*f**2*r*s + 3960*D1*Ddd*K*Pk2*b1*f**2*r - 15840*D1*Ddd*K*Pk2*b1*f**2*s**2 + 23760*D1*Ddd*K*Pk2*b1*f**2*s - 1980*D1*Ddd*K*Pk2*b1*f**2 + 792*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s**2 - 396*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s + 198*D1*Ddd*K*Pkdd2*b1**2*f*k1**2 + 5280*D1*Ddd*K*Pkdd2*b1*f**2*k1**2*s**2 - 2640*D1*Ddd*K*Pkdd2*b1*f**2*k1**2*s + 1320*D1*Ddd*K*Pkdd2*b1*f**2*k1**2 - 7920*D1*Ddd*Pk2*b1*f**3*r**2 + 7920*D1*Ddd*Pk2*b1*f**3*r - 3960*D1*Ddd*Pk2*b1*f**3 - 11880*D1*Ddd*Pk2*b1*f**2*r**2 + 11880*D1*Ddd*Pk2*b1*f**2*r - 5940*D1*Ddd*Pk2*b1*f**2 - 15840*D1*Ddd*Pk2*b2*f**2*r*s + 3960*D1*Ddd*Pk2*b2*f**2*r - 15840*D1*Ddd*Pk2*b2*f**2*s**2 + 15840*D1*Ddd*Pk2*b2*f**2*s - 3960*D1*Ddd*Pk2*b2*f**2 + 3960*D1*Ddd*Pk2*f**4*r**2 - 3960*D1*Ddd*Pk2*f**4*r + 1980*D1*Ddd*Pk2*f**4 - 16608*D1*Ddd*Pk2*f**3*r**2 + 29120*D1*Ddd*Pk2*f**3*r*s + 9328*D1*Ddd*Pk2*f**3*r + 12000*D1*Ddd*Pk2*f**3*s**2 - 20560*D1*Ddd*Pk2*f**3*s - 5304*D1*Ddd*Pk2*f**3 - 7920*D1*Ddd*Pk2*f**2*g2*r**2 + 63360*D1*Ddd*Pk2*f**2*g2*r*s - 7920*D1*Ddd*Pk2*f**2*g2*r + 31680*D1*Ddd*Pk2*f**2*g2*s**2 - 47520*D1*Ddd*Pk2*f**2*g2*s + 3960*D1*Ddd*Pk2*f**2*g2 - 792*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 396*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 198*D1*Ddd*Pkdd2*b1**2*f*k1**2 - 3000*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 + 1500*D1*Ddd*Pkdd2*b1*f**3*k1**2*s - 750*D1*Ddd*Pkdd2*b1*f**3*k1**2 - 4224*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 + 2112*D1*Ddd*Pkdd2*b1*f**2*k1**2*s - 1056*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 1584*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s**2 + 792*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s - 396*D1*Ddd*Pkdd2*b1*f*g2*k1**2 - 6000*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 3000*D1*Ddd*Pkdd2*f**3*k1**2*s - 1500*D1*Ddd*Pkdd2*f**3*k1**2 - 10560*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 5280*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 2640*D1*Ddd*Pkdd2*f**2*g2*k1**2 + 6*D1*bd1*(D1*(66*Pkdd2*fd*k1**2*s*(b1*(K - 1)*(2*s - 1) - 2*g2*(s - 1)) + 5*f**3*(66*Pk2*(r - 1)**2 + 25*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - f**2*(330*Pk2*(K*(r**2 - 8*r*s - 2*r - 4*s**2 + 8*s + 1) + fd*(6*r**2 - 8*r + 2) - 3*(r - 1)**2) + Pkdd2*k1**2*(132*C*(s - 1)**2 + s**2*(407*K + 750*fd - 319) + 264*s - 132)) + 22*f*(3*Pkdd2*k1**2*(-b1*(K - 1)*(2*s**2 - 2*s + 1) + (2*s - 2)*(g2*(s - 1) - gd2*s)) + 2*fd*(5*K*(3*Pk2*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + 2*Pkdd2*k1**2*s*(2*s - 1)) - 45*Pk2*r*(r - 1) + Pkdd2*k1**2*s*(6*C*(s - 1) - 16*s + 11)))) - Dd*f*(-66*Pkdd2*k1**2*(4*s - 1)*(b1*(K - 1)*(2*s - 1) - 2*g2*(s - 1)) + 5*f**2*(264*Pk2*(2*r**2 - 3*r + 1) + 25*Pkdd2*k1**2*(8*s**2 + 2*s - 1)) - 44*f*(15*Pk2*(K*(2*r**2 - 16*r*s - r - 8*s**2 + 14*s - 1) - 6*r**2 + 9*r - 3) + Pkdd2*k1**2*(4*s - 1)*(3*C*(s - 1) + 10*K*s - 8*s + 3)))) + 11880*Dd**2*K*Pk2*b1*f**2*r**2 - 95040*Dd**2*K*Pk2*b1*f**2*r*s + 11880*Dd**2*K*Pk2*b1*f**2*r - 47520*Dd**2*K*Pk2*b1*f**2*s**2 + 71280*Dd**2*K*Pk2*b1*f**2*s - 13860*Dd**2*K*Pk2*b1*f**2 + 2376*Dd**2*K*Pkdd2*b1**2*f*k1**2*s**2 - 1188*Dd**2*K*Pkdd2*b1**2*f*k1**2*s + 15840*Dd**2*K*Pkdd2*b1*f**2*k1**2*s**2 - 7920*Dd**2*K*Pkdd2*b1*f**2*k1**2*s - 23760*Dd**2*Pk2*b1*f**3*r**2 + 23760*Dd**2*Pk2*b1*f**3*r - 3960*Dd**2*Pk2*b1*f**3 - 35640*Dd**2*Pk2*b1*f**2*r**2 + 35640*Dd**2*Pk2*b1*f**2*r - 5940*Dd**2*Pk2*b1*f**2 - 47520*Dd**2*Pk2*b2*f**2*r*s + 11880*Dd**2*Pk2*b2*f**2*r - 47520*Dd**2*Pk2*b2*f**2*s**2 + 47520*Dd**2*Pk2*b2*f**2*s - 7920*Dd**2*Pk2*b2*f**2 + 11880*Dd**2*Pk2*f**4*r**2 - 11880*Dd**2*Pk2*f**4*r + 1980*Dd**2*Pk2*f**4 - 49824*Dd**2*Pk2*f**3*r**2 + 87360*Dd**2*Pk2*f**3*r*s + 27984*Dd**2*Pk2*f**3*r + 36000*Dd**2*Pk2*f**3*s**2 - 61680*Dd**2*Pk2*f**3*s + 6256*Dd**2*Pk2*f**3 - 23760*Dd**2*Pk2*f**2*g2*r**2 + 190080*Dd**2*Pk2*f**2*g2*r*s - 23760*Dd**2*Pk2*f**2*g2*r + 95040*Dd**2*Pk2*f**2*g2*s**2 - 142560*Dd**2*Pk2*f**2*g2*s + 27720*Dd**2*Pk2*f**2*g2 - 2376*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 1188*Dd**2*Pkdd2*b1**2*f*k1**2*s - 9000*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 + 4500*Dd**2*Pkdd2*b1*f**3*k1**2*s - 12672*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 + 6336*Dd**2*Pkdd2*b1*f**2*k1**2*s - 4752*Dd**2*Pkdd2*b1*f*g2*k1**2*s**2 + 2376*Dd**2*Pkdd2*b1*f*g2*k1**2*s - 18000*Dd**2*Pkdd2*f**3*k1**2*s**2 + 9000*Dd**2*Pkdd2*f**3*k1**2*s - 31680*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 15840*Dd**2*Pkdd2*f**2*g2*k1**2*s)/(1386*d**2*k3**4) - D1**2*Pk3*ct**4*k2**2*(2904*C*D1**2*Pk2*bdd1*f**2*r**2 + 3696*C*D1**2*Pk2*bdd1*f**2*r*s + 34872*C*D1**2*Pk2*f**2*fd*r**2 + 63456*C*D1**2*Pk2*f**2*fd*r*s - 44400*C*D1**2*Pk2*f**2*fd*r + 21780*C*D1**2*Pk2*f**2*fd*s**2 - 35672*C*D1**2*Pk2*f**2*fd*s + 18884*C*D1**2*Pk2*f**2*fd - 23772*C*D1**2*Pk2*f**2*fdd*r**2 - 58656*C*D1**2*Pk2*f**2*fdd*r*s + 35400*C*D1**2*Pk2*f**2*fdd*r - 17820*C*D1**2*Pk2*f**2*fdd*s**2 + 31432*C*D1**2*Pk2*f**2*fdd*s - 13864*C*D1**2*Pk2*f**2*fdd - 47544*C*D1**2*Pk2*f*fd**2*r**2 - 117312*C*D1**2*Pk2*f*fd**2*r*s + 70800*C*D1**2*Pk2*f*fd**2*r - 35640*C*D1**2*Pk2*f*fd**2*s**2 + 62864*C*D1**2*Pk2*f*fd**2*s - 19552*C*D1**2*Pk2*f*fd**2 - 1320*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 2640*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 1320*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 2280*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 1520*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 760*C*D1**2*Pkdd2*f**2*fd*k1**2 - 840*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 560*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 280*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 1680*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 1120*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 46496*C*D1*Dd*Pk2*f**3*r**2 + 84608*C*D1*Dd*Pk2*f**3*r*s - 67648*C*D1*Dd*Pk2*f**3*r + 29040*C*D1*Dd*Pk2*f**3*s**2 - 56824*C*D1*Dd*Pk2*f**3*s + 30508*C*D1*Dd*Pk2*f**3 - 190176*C*D1*Dd*Pk2*f**2*fd*r**2 - 469248*C*D1*Dd*Pk2*f**2*fd*r*s + 295344*C*D1*Dd*Pk2*f**2*fd*r - 142560*C*D1*Dd*Pk2*f**2*fd*s**2 + 278680*C*D1*Dd*Pk2*f**2*fd*s - 102232*C*D1*Dd*Pk2*f**2*fd - 3040*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 1520*C*D1*Dd*Pkdd2*f**3*k1**2*s - 760*C*D1*Dd*Pkdd2*f**3*k1**2 - 6720*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 3920*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 560*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 31696*C*D1*Ddd*Pk2*f**3*r**2 - 78208*C*D1*Ddd*Pk2*f**3*r*s + 51248*C*D1*Ddd*Pk2*f**3*r - 23760*C*D1*Ddd*Pk2*f**3*s**2 + 50984*C*D1*Ddd*Pk2*f**3*s - 21788*C*D1*Ddd*Pk2*f**3 - 1120*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 560*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 280*C*D1*Ddd*Pkdd2*f**3*k1**2 - 95088*C*Dd**2*Pk2*f**3*r**2 - 234624*C*Dd**2*Pk2*f**3*r*s + 153744*C*Dd**2*Pk2*f**3*r - 71280*C*Dd**2*Pk2*f**3*s**2 + 152952*C*Dd**2*Pk2*f**3*s - 54952*C*Dd**2*Pk2*f**3 - 3360*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1680*C*Dd**2*Pkdd2*f**3*k1**2*s - 3564*D1**2*K*Pk2*bdd1*f**2*r**2 - 9504*D1**2*K*Pk2*bdd1*f**2*r*s + 7128*D1**2*K*Pk2*bdd1*f**2*r - 3564*D1**2*K*Pk2*bdd1*f**2*s**2 + 9504*D1**2*K*Pk2*bdd1*f**2*s - 3564*D1**2*K*Pk2*bdd1*f**2 - 165*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 + 2376*D1**2*Pk2*b2*f*fd*r**2 + 11088*D1**2*Pk2*b2*f*fd*r*s - 5544*D1**2*Pk2*b2*f*fd*r + 8712*D1**2*Pk2*b2*f*fd*s**2 - 8712*D1**2*Pk2*b2*f*fd*s + 4356*D1**2*Pk2*b2*f*fd - 3960*D1**2*Pk2*b2*f*fdd*r**2 - 11088*D1**2*Pk2*b2*f*fdd*r*s + 5544*D1**2*Pk2*b2*f*fdd*r - 7128*D1**2*Pk2*b2*f*fdd*s**2 + 7128*D1**2*Pk2*b2*f*fdd*s - 3564*D1**2*Pk2*b2*f*fdd - 3960*D1**2*Pk2*b2*fd**2*r**2 - 11088*D1**2*Pk2*b2*fd**2*r*s + 5544*D1**2*Pk2*b2*fd**2*r - 7128*D1**2*Pk2*b2*fd**2*s**2 + 7128*D1**2*Pk2*b2*fd**2*s + 1188*D1**2*Pk2*bd2*f**2*r**2 + 5544*D1**2*Pk2*bd2*f**2*r*s - 2376*D1**2*Pk2*bd2*f**2*r + 4356*D1**2*Pk2*bd2*f**2*s**2 - 5544*D1**2*Pk2*bd2*f**2*s + 1188*D1**2*Pk2*bd2*f**2 - 7920*D1**2*Pk2*bd2*f*fd*r**2 - 22176*D1**2*Pk2*bd2*f*fd*r*s + 13464*D1**2*Pk2*bd2*f*fd*r - 14256*D1**2*Pk2*bd2*f*fd*s**2 + 18216*D1**2*Pk2*bd2*f*fd*s - 5544*D1**2*Pk2*bd2*f*fd + 792*D1**2*Pk2*bdd1*f**3*r**2 + 1980*D1**2*Pk2*bdd1*f**3*r*s - 2376*D1**2*Pk2*bdd1*f**3*r - 1980*D1**2*Pk2*bdd1*f**3*s + 1188*D1**2*Pk2*bdd1*f**3 - 264*D1**2*Pk2*bdd1*f**2*r**2 + 132*D1**2*Pk2*bdd1*f**2*r*s - 2508*D1**2*Pk2*bdd1*f**2*r - 1980*D1**2*Pk2*bdd1*f**2*s + 792*D1**2*Pk2*bdd1*f**2 - 2376*D1**2*Pk2*bdd1*f*g2*r**2 - 3168*D1**2*Pk2*bdd1*f*g2*r*s - 1980*D1**2*Pk2*bdd2*f**2*r**2 - 5544*D1**2*Pk2*bdd2*f**2*r*s + 3960*D1**2*Pk2*bdd2*f**2*r - 3564*D1**2*Pk2*bdd2*f**2*s**2 + 5544*D1**2*Pk2*bdd2*f**2*s - 1980*D1**2*Pk2*bdd2*f**2 - 20394*D1**2*Pk2*f**2*fd*r**2 - 36882*D1**2*Pk2*f**2*fd*r*s + 25890*D1**2*Pk2*f**2*fd*r - 10890*D1**2*Pk2*f**2*fd*s**2 + 19554*D1**2*Pk2*f**2*fd*s - 10428*D1**2*Pk2*f**2*fd + 14454*D1**2*Pk2*f**2*fdd*r**2 + 36162*D1**2*Pk2*f**2*fdd*r*s - 21690*D1**2*Pk2*f**2*fdd*r + 8910*D1**2*Pk2*f**2*fdd*s**2 - 17994*D1**2*Pk2*f**2*fdd*s + 7788*D1**2*Pk2*f**2*fdd - 4752*D1**2*Pk2*f**2*gd2*r**2 - 19008*D1**2*Pk2*f**2*gd2*r*s + 9504*D1**2*Pk2*f**2*gd2*r - 8712*D1**2*Pk2*f**2*gd2*s**2 + 19008*D1**2*Pk2*f**2*gd2*s - 4752*D1**2*Pk2*f**2*gd2 + 7128*D1**2*Pk2*f**2*gdd2*r**2 + 19008*D1**2*Pk2*f**2*gdd2*r*s - 14256*D1**2*Pk2*f**2*gdd2*r + 7128*D1**2*Pk2*f**2*gdd2*s**2 - 19008*D1**2*Pk2*f**2*gdd2*s + 7128*D1**2*Pk2*f**2*gdd2 + 28908*D1**2*Pk2*f*fd**2*r**2 + 72324*D1**2*Pk2*f*fd**2*r*s - 43380*D1**2*Pk2*f*fd**2*r + 17820*D1**2*Pk2*f*fd**2*s**2 - 35988*D1**2*Pk2*f*fd**2*s + 12054*D1**2*Pk2*f*fd**2 - 9504*D1**2*Pk2*f*fd*g2*r**2 - 38016*D1**2*Pk2*f*fd*g2*r*s + 19008*D1**2*Pk2*f*fd*g2*r - 17424*D1**2*Pk2*f*fd*g2*s**2 + 17424*D1**2*Pk2*f*fd*g2*s - 8712*D1**2*Pk2*f*fd*g2 + 28512*D1**2*Pk2*f*fd*gd2*r**2 + 76032*D1**2*Pk2*f*fd*gd2*r*s - 47520*D1**2*Pk2*f*fd*gd2*r + 28512*D1**2*Pk2*f*fd*gd2*s**2 - 52272*D1**2*Pk2*f*fd*gd2*s + 19008*D1**2*Pk2*f*fd*gd2 + 14256*D1**2*Pk2*f*fdd*g2*r**2 + 38016*D1**2*Pk2*f*fdd*g2*r*s - 19008*D1**2*Pk2*f*fdd*g2*r + 14256*D1**2*Pk2*f*fdd*g2*s**2 - 14256*D1**2*Pk2*f*fdd*g2*s + 7128*D1**2*Pk2*f*fdd*g2 + 14256*D1**2*Pk2*fd**2*g2*r**2 + 38016*D1**2*Pk2*fd**2*g2*r*s - 19008*D1**2*Pk2*fd**2*g2*r + 14256*D1**2*Pk2*fd**2*g2*s**2 - 14256*D1**2*Pk2*fd**2*g2*s + 990*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 1980*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 990*D1**2*Pkdd2*bdd1*f**2*k1**2 + 1584*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 3168*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 1584*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 2130*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 1420*D1**2*Pkdd2*f**2*fd*k1**2*s + 710*D1**2*Pkdd2*f**2*fd*k1**2 + 420*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 280*D1**2*Pkdd2*f**2*fdd*k1**2*s + 140*D1**2*Pkdd2*f**2*fdd*k1**2 + 924*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 330*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 840*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 560*D1**2*Pkdd2*f*fd**2*k1**2*s + 1848*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 1848*D1**2*Pkdd2*f*fd*g2*k1**2*s + 924*D1**2*Pkdd2*f*fd*g2*k1**2 + 1320*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 660*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 660*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 660*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 330*D1**2*Pkdd2*f*fdd*g2*k1**2 + 660*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 660*D1**2*Pkdd2*fd**2*g2*k1**2*s - 198*D1**2*bd1**2*f*(4*Pk2*(2*K*s + f*(r - 1) - r**2*(3*K + 1) + r*(-4*K*s + 3*K + 2) - 1) - Pkdd2*k1**2*s*(s - 1)*(-8*K + 5*f + 4)) + 4752*D1*Dd*Pk2*b2*f**2*r**2 + 22176*D1*Dd*Pk2*b2*f**2*r*s - 10296*D1*Dd*Pk2*b2*f**2*r + 17424*D1*Dd*Pk2*b2*f**2*s**2 - 19800*D1*Dd*Pk2*b2*f**2*s + 6732*D1*Dd*Pk2*b2*f**2 - 31680*D1*Dd*Pk2*b2*f*fd*r**2 - 88704*D1*Dd*Pk2*b2*f*fd*r*s + 49104*D1*Dd*Pk2*b2*f*fd*r - 57024*D1*Dd*Pk2*b2*f*fd*s**2 + 64944*D1*Dd*Pk2*b2*f*fd*s - 18216*D1*Dd*Pk2*b2*f*fd - 15840*D1*Dd*Pk2*bd2*f**2*r**2 - 44352*D1*Dd*Pk2*bd2*f**2*r*s + 29304*D1*Dd*Pk2*bd2*f**2*r - 28512*D1*Dd*Pk2*bd2*f**2*s**2 + 40392*D1*Dd*Pk2*bd2*f**2*s - 13464*D1*Dd*Pk2*bd2*f**2 - 27192*D1*Dd*Pk2*f**3*r**2 - 49176*D1*Dd*Pk2*f**3*r*s + 39486*D1*Dd*Pk2*f**3*r - 14520*D1*Dd*Pk2*f**3*s**2 + 31848*D1*Dd*Pk2*f**3*s - 17226*D1*Dd*Pk2*f**3 + 115632*D1*Dd*Pk2*f**2*fd*r**2 + 289296*D1*Dd*Pk2*f**2*fd*r*s - 180738*D1*Dd*Pk2*f**2*fd*r + 71280*D1*Dd*Pk2*f**2*fd*s**2 - 162120*D1*Dd*Pk2*f**2*fd*s + 61374*D1*Dd*Pk2*f**2*fd - 19008*D1*Dd*Pk2*f**2*g2*r**2 - 76032*D1*Dd*Pk2*f**2*g2*r*s + 38016*D1*Dd*Pk2*f**2*g2*r - 34848*D1*Dd*Pk2*f**2*g2*s**2 + 55440*D1*Dd*Pk2*f**2*g2*s - 18216*D1*Dd*Pk2*f**2*g2 + 57024*D1*Dd*Pk2*f**2*gd2*r**2 + 152064*D1*Dd*Pk2*f**2*gd2*r*s - 104544*D1*Dd*Pk2*f**2*gd2*r + 57024*D1*Dd*Pk2*f**2*gd2*s**2 - 128304*D1*Dd*Pk2*f**2*gd2*s + 47520*D1*Dd*Pk2*f**2*gd2 + 114048*D1*Dd*Pk2*f*fd*g2*r**2 + 304128*D1*Dd*Pk2*f*fd*g2*r*s - 171072*D1*Dd*Pk2*f*fd*g2*r + 114048*D1*Dd*Pk2*f*fd*g2*s**2 - 161568*D1*Dd*Pk2*f*fd*g2*s + 52272*D1*Dd*Pk2*f*fd*g2 + 2840*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 1420*D1*Dd*Pkdd2*f**3*k1**2*s + 710*D1*Dd*Pkdd2*f**3*k1**2 + 3360*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 1960*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 280*D1*Dd*Pkdd2*f**2*fd*k1**2 + 3696*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 1848*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 924*D1*Dd*Pkdd2*f**2*g2*k1**2 + 2640*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 660*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 5280*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 3960*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 660*D1*Dd*Pkdd2*f*fd*g2*k1**2 - 7920*D1*Ddd*Pk2*b2*f**2*r**2 - 22176*D1*Ddd*Pk2*b2*f**2*r*s + 13464*D1*Ddd*Pk2*b2*f**2*r - 14256*D1*Ddd*Pk2*b2*f**2*s**2 + 18216*D1*Ddd*Pk2*b2*f**2*s - 7524*D1*Ddd*Pk2*b2*f**2 + 19272*D1*Ddd*Pk2*f**3*r**2 + 48216*D1*Ddd*Pk2*f**3*r*s - 31326*D1*Ddd*Pk2*f**3*r + 11880*D1*Ddd*Pk2*f**3*s**2 - 30048*D1*Ddd*Pk2*f**3*s + 12606*D1*Ddd*Pk2*f**3 + 28512*D1*Ddd*Pk2*f**2*g2*r**2 + 76032*D1*Ddd*Pk2*f**2*g2*r*s - 47520*D1*Ddd*Pk2*f**2*g2*r + 28512*D1*Ddd*Pk2*f**2*g2*s**2 - 52272*D1*Ddd*Pk2*f**2*g2*s + 21384*D1*Ddd*Pk2*f**2*g2 + 560*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 280*D1*Ddd*Pkdd2*f**3*k1**2*s + 140*D1*Ddd*Pkdd2*f**3*k1**2 + 1320*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 660*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 330*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 33*D1*bd1*(D1*(f**3*(12*Pk2*(2*r**2 + r*(5*s - 6) - 5*s + 3) - 5*Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 2*f**2*(2*Pk2*(-33*C*r**2 - 56*C*r*s + 3*K*(6*r**2 + 24*r*s - 12*r + 11*s**2 - 24*s + 6) + fd*(36*r**2 + 15*r*(6*s - 5) - 60*s + 33) + 8*r**2 + 19*r*s + 8*r + 9*s + 3) + Pkdd2*k1**2*(34*C*(s - 1)**2 - s**2*(7*K + 18) + 48*s - 24)) + 2*f*(-24*Pk2*g2*r*(3*r + 4*s) + 24*Pk2*gd2*(3*r**2 + r*(4*s - 3) - 2*s) + 41*Pkdd2*g2*k1**2*(s - 1)**2 - 48*Pkdd2*gd2*k1**2*s*(s - 1) + fd*(4*Pk2*(14*C*s + 9*K*(6*r**2 + 2*r*(8*s - 5) + 6*s**2 - 11*s + 4) + r**2*(4 - 44*C) - 2*r*(28*C*s - 18*C + s - 4) + 8*s - 11) + 5*Pkdd2*k1**2*s*(16*C*(s - 1) + 2*K*s - K - 12*s + 12))) + 48*fd*g2*(Pk2*r*(3*r + 4*s - 2) - 2*Pkdd2*k1**2*s*(s - 1))) + 2*Dd*f*(-6*Pk2*f**2*(16*r**2 + r*(40*s - 37) - 30*s + 17) + f*(2*Pk2*(56*C*s + 18*K*(12*r**2 + r*(32*s - 22) + 12*s**2 - 27*s + 10) + r**2*(16 - 176*C) + r*(-224*C*s + 116*C - 8*s + 69) + 62*s - 53) + 5*Pkdd2*k1**2*(4*s - 1)*(8*C*(s - 1) + s*(K - 6) + 6)) - 48*g2*(2*Pk2*(-3*r**2 + r*(2 - 4*s) + s) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 23760*Dd**2*Pk2*b2*f**2*r**2 - 66528*Dd**2*Pk2*b2*f**2*r*s + 40392*Dd**2*Pk2*b2*f**2*r - 42768*Dd**2*Pk2*b2*f**2*s**2 + 54648*Dd**2*Pk2*b2*f**2*s - 15048*Dd**2*Pk2*b2*f**2 + 57816*Dd**2*Pk2*f**3*r**2 + 144648*Dd**2*Pk2*f**3*r*s - 93978*Dd**2*Pk2*f**3*r + 35640*Dd**2*Pk2*f**3*s**2 - 90144*Dd**2*Pk2*f**3*s + 33744*Dd**2*Pk2*f**3 + 85536*Dd**2*Pk2*f**2*g2*r**2 + 228096*Dd**2*Pk2*f**2*g2*r*s - 142560*Dd**2*Pk2*f**2*g2*r + 85536*Dd**2*Pk2*f**2*g2*s**2 - 156816*Dd**2*Pk2*f**2*g2*s + 52272*Dd**2*Pk2*f**2*g2 + 1680*Dd**2*Pkdd2*f**3*k1**2*s**2 - 840*Dd**2*Pkdd2*f**3*k1**2*s + 3960*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 1980*Dd**2*Pkdd2*f**2*g2*k1**2*s - 33*b1**2*(D1**2*(-6*fd**2*(4*Pk2*(r - 1) + 5*Pkdd2*k1**2*s**2) + fd*(24*Pk2*r*(K*(3*r + 4*s - 4) + f + r + 2) + Pkdd2*k1**2*s**2*(-41*K + 60*f + 17)) - 6*fdd*(2*Pk2*r*(K*(3*r + 4*s - 4) + 2*f + r + 2) + Pkdd2*k1**2*s**2*(-4*K + 5*f + 2))) + D1*(Dd*(30*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + f*(48*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) - 2*fd*r + fd + 2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-41*K*(4*s**2 - 2*s + 1) + s**2*(68 - 240*fd) + s*(60*fd - 34) + 17)) - 24*fd*(2*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) + 2*r**2 + r - 1) + Pkdd2*k1**2*s*(K*(2 - 8*s) + 4*s - 1))) - 3*Ddd*f*(8*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + 2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-8*K + 5*f + 4)*(4*s**2 - 2*s + 1))) - 6*Dd**2*f*(4*Pk2*(K*(18*r**2 + 24*r*(s - 1) - 12*s + 7) + 6*r**2 - 6*r + 1) + Pkdd2*k1**2*s*(2*s - 1)*(-24*K + 15*f + 12))) + 33*b1*(-264*C*D1**2*Pk2*f*fd*r**2 - 448*C*D1**2*Pk2*f*fd*r*s + 488*C*D1**2*Pk2*f*fd*r + 224*C*D1**2*Pk2*f*fd*s - 132*C*D1**2*Pk2*f*fd + 176*C*D1**2*Pk2*f*fdd*r**2 + 224*C*D1**2*Pk2*f*fdd*r*s - 288*C*D1**2*Pk2*f*fdd*r - 112*C*D1**2*Pk2*f*fdd*s + 88*C*D1**2*Pk2*f*fdd + 176*C*D1**2*Pk2*fd**2*r**2 + 224*C*D1**2*Pk2*fd**2*r*s - 288*C*D1**2*Pk2*fd**2*r - 112*C*D1**2*Pk2*fd**2*s + 112*C*D1**2*Pk2*fd**2 + 136*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 80*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 80*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 528*C*D1*Dd*Pk2*f**2*r**2 - 896*C*D1*Dd*Pk2*f**2*r*s + 752*C*D1*Dd*Pk2*f**2*r + 448*C*D1*Dd*Pk2*f**2*s - 264*C*D1*Dd*Pk2*f**2 + 1408*C*D1*Dd*Pk2*f*fd*r**2 + 1792*C*D1*Dd*Pk2*f*fd*r*s - 2080*C*D1*Dd*Pk2*f*fd*r - 896*C*D1*Dd*Pk2*f*fd*s + 688*C*D1*Dd*Pk2*f*fd + 272*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 136*C*D1*Dd*Pkdd2*f**2*k1**2*s + 68*C*D1*Dd*Pkdd2*f**2*k1**2 - 640*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 160*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 352*C*D1*Ddd*Pk2*f**2*r**2 + 448*C*D1*Ddd*Pk2*f**2*r*s - 464*C*D1*Ddd*Pk2*f**2*r - 224*C*D1*Ddd*Pk2*f**2*s + 176*C*D1*Ddd*Pk2*f**2 - 160*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 80*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 40*C*D1*Ddd*Pkdd2*f**2*k1**2 + 1056*C*Dd**2*Pk2*f**2*r**2 + 1344*C*Dd**2*Pk2*f**2*r*s - 1392*C*Dd**2*Pk2*f**2*r - 672*C*Dd**2*Pk2*f**2*s + 400*C*Dd**2*Pk2*f**2 - 480*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 240*C*Dd**2*Pkdd2*f**2*k1**2*s + 144*D1**2*K*Pk2*f*fd*r**2 + 576*D1**2*K*Pk2*f*fd*r*s - 288*D1**2*K*Pk2*f*fd*r + 264*D1**2*K*Pk2*f*fd*s**2 - 264*D1**2*K*Pk2*f*fd*s + 132*D1**2*K*Pk2*f*fd - 216*D1**2*K*Pk2*f*fdd*r**2 - 576*D1**2*K*Pk2*f*fdd*r*s + 288*D1**2*K*Pk2*f*fdd*r - 216*D1**2*K*Pk2*f*fdd*s**2 + 216*D1**2*K*Pk2*f*fdd*s - 108*D1**2*K*Pk2*f*fdd - 216*D1**2*K*Pk2*fd**2*r**2 - 576*D1**2*K*Pk2*fd**2*r*s + 288*D1**2*K*Pk2*fd**2*r - 216*D1**2*K*Pk2*fd**2*s**2 + 216*D1**2*K*Pk2*fd**2*s - 28*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 28*D1**2*K*Pkdd2*f*fd*k1**2*s - 14*D1**2*K*Pkdd2*f*fd*k1**2 - 10*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 10*D1**2*K*Pkdd2*f*fdd*k1**2*s - 5*D1**2*K*Pkdd2*f*fdd*k1**2 - 10*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 10*D1**2*K*Pkdd2*fd**2*k1**2*s - 72*D1**2*Pk2*f**2*fd*r**2 - 180*D1**2*Pk2*f**2*fd*r*s + 84*D1**2*Pk2*f**2*fd*r + 60*D1**2*Pk2*f**2*fd*s - 12*D1**2*Pk2*f**2*fd + 72*D1**2*Pk2*f**2*fdd*r**2 + 180*D1**2*Pk2*f**2*fdd*r*s - 84*D1**2*Pk2*f**2*fdd*r - 60*D1**2*Pk2*f**2*fdd*s + 12*D1**2*Pk2*f**2*fdd + 144*D1**2*Pk2*f*fd**2*r**2 + 360*D1**2*Pk2*f*fd**2*r*s - 168*D1**2*Pk2*f*fd**2*r - 120*D1**2*Pk2*f*fd**2*s + 36*D1**2*Pk2*f*fd**2 + 64*D1**2*Pk2*f*fd*r**2 + 152*D1**2*Pk2*f*fd*r*s - 172*D1**2*Pk2*f*fd*r - 112*D1**2*Pk2*f*fd*s + 20*D1**2*Pk2*f*fd - 16*D1**2*Pk2*f*fdd*r**2 + 8*D1**2*Pk2*f*fdd*r*s + 88*D1**2*Pk2*f*fdd*r + 56*D1**2*Pk2*f*fdd*s - 32*D1**2*Pk2*f*fdd + 144*D1**2*Pk2*f*gd2*r**2 + 192*D1**2*Pk2*f*gd2*r*s - 288*D1**2*Pk2*f*gd2*r - 192*D1**2*Pk2*f*gd2*s + 144*D1**2*Pk2*f*gd2 - 72*D1**2*Pk2*f*gdd2*r**2 - 96*D1**2*Pk2*f*gdd2*r*s + 144*D1**2*Pk2*f*gdd2*r + 96*D1**2*Pk2*f*gdd2*s - 72*D1**2*Pk2*f*gdd2 - 16*D1**2*Pk2*fd**2*r**2 + 8*D1**2*Pk2*fd**2*r*s + 88*D1**2*Pk2*fd**2*r + 56*D1**2*Pk2*fd**2*s - 84*D1**2*Pk2*fd**2 + 144*D1**2*Pk2*fd*g2*r**2 + 192*D1**2*Pk2*fd*g2*r*s - 192*D1**2*Pk2*fd*g2*r - 144*D1**2*Pk2*fd*gd2*r**2 - 192*D1**2*Pk2*fd*gd2*r*s + 240*D1**2*Pk2*fd*gd2*r + 96*D1**2*Pk2*fd*gd2*s - 96*D1**2*Pk2*fd*gd2 - 72*D1**2*Pk2*fdd*g2*r**2 - 96*D1**2*Pk2*fdd*g2*r*s + 96*D1**2*Pk2*fdd*g2*r + 30*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 30*D1**2*Pkdd2*f**2*fd*k1**2*s + 15*D1**2*Pkdd2*f**2*fd*k1**2 - 72*D1**2*Pkdd2*f*fd*k1**2*s**2 - 24*D1**2*Pkdd2*f*fd*k1**2*s + 12*D1**2*Pkdd2*f*fd*k1**2 + 60*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 82*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 48*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 60*D1**2*Pkdd2*fd**2*k1**2*s**2 - 82*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 96*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 48*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 3*D1**2*bdd1*f*(-4*Pk2*(K*(6*r**2 + r*(8*s - 6) - 4*s + 3) + 2*r**2 - r*(2*f + 4) + 1) - Pkdd2*k1**2*(-8*K + 5*f + 4)*(2*s**2 - 2*s + 1)) + 288*D1*Dd*K*Pk2*f**2*r**2 + 1152*D1*Dd*K*Pk2*f**2*r*s - 576*D1*Dd*K*Pk2*f**2*r + 528*D1*Dd*K*Pk2*f**2*s**2 - 840*D1*Dd*K*Pk2*f**2*s + 276*D1*Dd*K*Pk2*f**2 - 1728*D1*Dd*K*Pk2*f*fd*r**2 - 4608*D1*Dd*K*Pk2*f*fd*r*s + 2592*D1*Dd*K*Pk2*f*fd*r - 1728*D1*Dd*K*Pk2*f*fd*s**2 + 2448*D1*Dd*K*Pk2*f*fd*s - 792*D1*Dd*K*Pk2*f*fd - 56*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 28*D1*Dd*K*Pkdd2*f**2*k1**2*s - 14*D1*Dd*K*Pkdd2*f**2*k1**2 - 80*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 60*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 10*D1*Dd*K*Pkdd2*f*fd*k1**2 - 96*D1*Dd*Pk2*f**3*r**2 - 240*D1*Dd*Pk2*f**3*r*s + 156*D1*Dd*Pk2*f**3*r + 120*D1*Dd*Pk2*f**3*s - 48*D1*Dd*Pk2*f**3 + 576*D1*Dd*Pk2*f**2*fd*r**2 + 1440*D1*Dd*Pk2*f**2*fd*r*s - 804*D1*Dd*Pk2*f**2*fd*r - 600*D1*Dd*Pk2*f**2*fd*s + 228*D1*Dd*Pk2*f**2*fd + 128*D1*Dd*Pk2*f**2*r**2 + 304*D1*Dd*Pk2*f**2*r*s - 204*D1*Dd*Pk2*f**2*r - 152*D1*Dd*Pk2*f**2*s + 64*D1*Dd*Pk2*f**2 - 128*D1*Dd*Pk2*f*fd*r**2 + 64*D1*Dd*Pk2*f*fd*r*s + 408*D1*Dd*Pk2*f*fd*r + 208*D1*Dd*Pk2*f*fd*s - 232*D1*Dd*Pk2*f*fd + 576*D1*Dd*Pk2*f*g2*r**2 + 768*D1*Dd*Pk2*f*g2*r*s - 768*D1*Dd*Pk2*f*g2*r - 384*D1*Dd*Pk2*f*g2*s + 288*D1*Dd*Pk2*f*g2 - 576*D1*Dd*Pk2*f*gd2*r**2 - 768*D1*Dd*Pk2*f*gd2*r*s + 960*D1*Dd*Pk2*f*gd2*r + 576*D1*Dd*Pk2*f*gd2*s - 384*D1*Dd*Pk2*f*gd2 - 576*D1*Dd*Pk2*fd*g2*r**2 - 768*D1*Dd*Pk2*fd*g2*r*s + 768*D1*Dd*Pk2*fd*g2*r + 192*D1*Dd*Pk2*fd*g2*s - 192*D1*Dd*Pk2*fd*g2 + 40*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 20*D1*Dd*Pkdd2*f**3*k1**2*s + 10*D1*Dd*Pkdd2*f**3*k1**2 - 144*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 72*D1*Dd*Pkdd2*f**2*k1**2*s - 36*D1*Dd*Pkdd2*f**2*k1**2 + 480*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 120*D1*Dd*Pkdd2*f*fd*k1**2*s - 328*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 164*D1*Dd*Pkdd2*f*g2*k1**2*s - 82*D1*Dd*Pkdd2*f*g2*k1**2 + 384*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 - 96*D1*Dd*Pkdd2*f*gd2*k1**2*s + 384*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 - 96*D1*Dd*Pkdd2*fd*g2*k1**2*s - 432*D1*Ddd*K*Pk2*f**2*r**2 - 1152*D1*Ddd*K*Pk2*f**2*r*s + 720*D1*Ddd*K*Pk2*f**2*r - 432*D1*Ddd*K*Pk2*f**2*s**2 + 792*D1*Ddd*K*Pk2*f**2*s - 324*D1*Ddd*K*Pk2*f**2 - 20*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 10*D1*Ddd*K*Pkdd2*f**2*k1**2*s - 5*D1*Ddd*K*Pkdd2*f**2*k1**2 + 96*D1*Ddd*Pk2*f**3*r**2 + 240*D1*Ddd*Pk2*f**3*r*s - 156*D1*Ddd*Pk2*f**3*r - 120*D1*Ddd*Pk2*f**3*s + 48*D1*Ddd*Pk2*f**3 - 32*D1*Ddd*Pk2*f**2*r**2 + 16*D1*Ddd*Pk2*f**2*r*s + 28*D1*Ddd*Pk2*f**2*r - 8*D1*Ddd*Pk2*f**2*s - 16*D1*Ddd*Pk2*f**2 - 288*D1*Ddd*Pk2*f*g2*r**2 - 384*D1*Ddd*Pk2*f*g2*r*s + 384*D1*Ddd*Pk2*f*g2*r + 192*D1*Ddd*Pk2*f*g2*s - 144*D1*Ddd*Pk2*f*g2 + 120*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 60*D1*Ddd*Pkdd2*f**2*k1**2*s + 30*D1*Ddd*Pkdd2*f**2*k1**2 + 192*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 - 96*D1*Ddd*Pkdd2*f*g2*k1**2*s + 48*D1*Ddd*Pkdd2*f*g2*k1**2 + D1*bd1*(D1*(-6*f**2*(-4*Pk2*r + 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - f*(24*Pk2*(K*(6*r**2 + r*(8*s - 6) - 4*s + 3) + 2*r**2 - 4*r + 1) + Pkdd2*k1**2*(-41*K*(2*s**2 - 2*s + 1) + s**2*(34 - 120*fd) + s*(60*fd - 34) + 17)) - 24*fd*(K*Pk2*(-6*r**2 - 8*r*s + 7*r + 2*s - 2) - 2*Pk2*r**2 + Pk2 + Pkdd2*k1**2*s*(2*K - 1)*(2*s - 1))) + 6*Dd*f*(-8*Pk2*(2*r - 1)*(-2*K*(3*r + 4*s - 2) + f - 2*r + 2) + Pkdd2*k1**2*(-8*K + 5*f + 4)*(8*s**2 - 6*s + 1))) - 1296*Dd**2*K*Pk2*f**2*r**2 - 3456*Dd**2*K*Pk2*f**2*r*s + 2160*Dd**2*K*Pk2*f**2*r - 1296*Dd**2*K*Pk2*f**2*s**2 + 2376*Dd**2*K*Pk2*f**2*s - 792*Dd**2*K*Pk2*f**2 - 60*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 30*Dd**2*K*Pkdd2*f**2*k1**2*s + 288*Dd**2*Pk2*f**3*r**2 + 720*Dd**2*Pk2*f**3*r*s - 468*Dd**2*Pk2*f**3*r - 360*Dd**2*Pk2*f**3*s + 168*Dd**2*Pk2*f**3 - 96*Dd**2*Pk2*f**2*r**2 + 48*Dd**2*Pk2*f**2*r*s + 84*Dd**2*Pk2*f**2*r - 24*Dd**2*Pk2*f**2*s - 8*Dd**2*Pk2*f**2 - 864*Dd**2*Pk2*f*g2*r**2 - 1152*Dd**2*Pk2*f*g2*r*s + 1152*Dd**2*Pk2*f*g2*r + 576*Dd**2*Pk2*f*g2*s - 336*Dd**2*Pk2*f*g2 + 360*Dd**2*Pkdd2*f**2*k1**2*s**2 - 180*Dd**2*Pkdd2*f**2*k1**2*s + 576*Dd**2*Pkdd2*f*g2*k1**2*s**2 - 288*Dd**2*Pkdd2*f*g2*k1**2*s))/(693*d**2*k3**4) + D1**2*Pk3*ct**4*st**2*(36000*C*D1**2*Pk2*f**2*fd*s**2 - 24000*C*D1**2*Pk2*f**2*fd*s + 12000*C*D1**2*Pk2*f**2*fd - 18000*C*D1**2*Pk2*f**2*fdd*s**2 + 12000*C*D1**2*Pk2*f**2*fdd*s - 6000*C*D1**2*Pk2*f**2*fdd - 36000*C*D1**2*Pk2*f*fd**2*s**2 + 24000*C*D1**2*Pk2*f*fd**2*s - 1584*C*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 1584*C*D1**2*Pkdd2*b1*f*fd*k1**2*s - 792*C*D1**2*Pkdd2*b1*f*fd*k1**2 + 792*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 792*C*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 396*C*D1**2*Pkdd2*b1*f*fdd*k1**2 + 792*C*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 792*C*D1**2*Pkdd2*b1*fd**2*k1**2*s + 396*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 48000*C*D1*Dd*Pk2*f**3*s**2 - 24000*C*D1*Dd*Pk2*f**3*s + 12000*C*D1*Dd*Pk2*f**3 - 144000*C*D1*Dd*Pk2*f**2*fd*s**2 + 84000*C*D1*Dd*Pk2*f**2*fd*s - 12000*C*D1*Dd*Pk2*f**2*fd - 3168*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 1584*C*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 792*C*D1*Dd*Pkdd2*b1*f**2*k1**2 + 6336*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 4752*C*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 792*C*D1*Dd*Pkdd2*b1*f*fd*k1**2 - 24000*C*D1*Ddd*Pk2*f**3*s**2 + 12000*C*D1*Ddd*Pk2*f**3*s - 6000*C*D1*Ddd*Pk2*f**3 + 1584*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 792*C*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 396*C*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 72000*C*Dd**2*Pk2*f**3*s**2 + 36000*C*Dd**2*Pk2*f**3*s + 4752*C*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 2376*C*Dd**2*Pkdd2*b1*f**2*k1**2*s + 15840*D1**2*K*Pk2*b1*f*fd*s**2 - 15840*D1**2*K*Pk2*b1*f*fd*s + 7920*D1**2*K*Pk2*b1*f*fd - 7920*D1**2*K*Pk2*b1*f*fdd*s**2 + 7920*D1**2*K*Pk2*b1*f*fdd*s - 3960*D1**2*K*Pk2*b1*f*fdd - 7920*D1**2*K*Pk2*b1*fd**2*s**2 + 7920*D1**2*K*Pk2*b1*fd**2*s - 3960*D1**2*K*Pk2*bdd1*f**2*s**2 - 396*D1**2*K*Pkdd2*b1**2*fd*k1**2*s**2 + 792*D1**2*K*Pkdd2*b1**2*fd*k1**2*s - 396*D1**2*K*Pkdd2*b1**2*fd*k1**2 + 198*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s**2 - 396*D1**2*K*Pkdd2*b1**2*fdd*k1**2*s + 198*D1**2*K*Pkdd2*b1**2*fdd*k1**2 + 396*D1**2*K*Pkdd2*b1*bdd1*f*k1**2*s**2 + 11880*D1**2*Pk2*b1*f**2*fd*r*s - 3960*D1**2*Pk2*b1*f**2*fd*r - 3960*D1**2*Pk2*b1*f**2*fd*s - 11880*D1**2*Pk2*b1*f**2*fdd*r*s + 3960*D1**2*Pk2*b1*f**2*fdd*r + 3960*D1**2*Pk2*b1*f**2*fdd*s - 23760*D1**2*Pk2*b1*f*fd**2*r*s + 7920*D1**2*Pk2*b1*f*fd**2*r + 7920*D1**2*Pk2*b1*f*fd**2*s - 3960*D1**2*Pk2*b1*f*fd**2 + 15840*D1**2*Pk2*b1*f*fd*r*s - 7920*D1**2*Pk2*b1*f*fd*r - 7920*D1**2*Pk2*b1*f*fdd*r*s + 3960*D1**2*Pk2*b1*f*fdd*r - 7920*D1**2*Pk2*b1*fd**2*r*s + 3960*D1**2*Pk2*b1*fd**2*r + 7920*D1**2*Pk2*bd2*f**2*s**2 - 15840*D1**2*Pk2*bd2*f*fd*s**2 + 7920*D1**2*Pk2*bd2*f*fd*s - 3960*D1**2*Pk2*bdd1*f**3*r*s + 3960*D1**2*Pk2*bdd1*f**3*s - 3960*D1**2*Pk2*bdd1*f**2*r*s + 3960*D1**2*Pk2*bdd1*f**2*s - 3960*D1**2*Pk2*bdd2*f**2*s**2 + 19344*D1**2*Pk2*f**2*fd*r*s - 6448*D1**2*Pk2*f**2*fd*r - 18000*D1**2*Pk2*f**2*fd*s**2 + 5552*D1**2*Pk2*f**2*fd*s - 6000*D1**2*Pk2*f**2*fd - 12840*D1**2*Pk2*f**2*fdd*r*s + 4280*D1**2*Pk2*f**2*fdd*r + 9000*D1**2*Pk2*f**2*fdd*s**2 - 1720*D1**2*Pk2*f**2*fdd*s + 3000*D1**2*Pk2*f**2*fdd - 15840*D1**2*Pk2*f**2*gd2*s**2 + 7920*D1**2*Pk2*f**2*gdd2*s**2 - 25680*D1**2*Pk2*f*fd**2*r*s + 8560*D1**2*Pk2*f*fd**2*r + 18000*D1**2*Pk2*f*fd**2*s**2 - 3440*D1**2*Pk2*f*fd**2*s - 4280*D1**2*Pk2*f*fd**2 - 31680*D1**2*Pk2*f*fd*g2*s**2 + 31680*D1**2*Pk2*f*fd*g2*s - 15840*D1**2*Pk2*f*fd*g2 + 31680*D1**2*Pk2*f*fd*gd2*s**2 - 15840*D1**2*Pk2*f*fd*gd2*s + 15840*D1**2*Pk2*f*fdd*g2*s**2 - 15840*D1**2*Pk2*f*fdd*g2*s + 7920*D1**2*Pk2*f*fdd*g2 + 15840*D1**2*Pk2*fd**2*g2*s**2 - 15840*D1**2*Pk2*fd**2*g2*s + 396*D1**2*Pkdd2*b1**2*fd*k1**2*s**2 - 792*D1**2*Pkdd2*b1**2*fd*k1**2*s + 396*D1**2*Pkdd2*b1**2*fd*k1**2 - 198*D1**2*Pkdd2*b1**2*fdd*k1**2*s**2 + 396*D1**2*Pkdd2*b1**2*fdd*k1**2*s - 198*D1**2*Pkdd2*b1**2*fdd*k1**2 - 396*D1**2*Pkdd2*b1*bdd1*f*k1**2*s**2 - 6750*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 + 4500*D1**2*Pkdd2*b1*f**2*fd*k1**2*s - 2250*D1**2*Pkdd2*b1*f**2*fd*k1**2 + 3375*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 - 2250*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s + 1125*D1**2*Pkdd2*b1*f**2*fdd*k1**2 + 6750*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 - 4500*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 1056*D1**2*Pkdd2*b1*f*fd*k1**2*s**2 + 1056*D1**2*Pkdd2*b1*f*fd*k1**2*s - 528*D1**2*Pkdd2*b1*f*fd*k1**2 + 528*D1**2*Pkdd2*b1*f*fdd*k1**2*s**2 - 528*D1**2*Pkdd2*b1*f*fdd*k1**2*s + 264*D1**2*Pkdd2*b1*f*fdd*k1**2 + 792*D1**2*Pkdd2*b1*f*gd2*k1**2*s**2 - 396*D1**2*Pkdd2*b1*f*gdd2*k1**2*s**2 + 528*D1**2*Pkdd2*b1*fd**2*k1**2*s**2 - 528*D1**2*Pkdd2*b1*fd**2*k1**2*s + 792*D1**2*Pkdd2*b1*fd*g2*k1**2*s**2 - 1584*D1**2*Pkdd2*b1*fd*g2*k1**2*s + 792*D1**2*Pkdd2*b1*fd*g2*k1**2 - 792*D1**2*Pkdd2*b1*fd*gd2*k1**2*s**2 + 792*D1**2*Pkdd2*b1*fd*gd2*k1**2*s - 396*D1**2*Pkdd2*b1*fdd*g2*k1**2*s**2 + 792*D1**2*Pkdd2*b1*fdd*g2*k1**2*s - 396*D1**2*Pkdd2*b1*fdd*g2*k1**2 + 396*D1**2*Pkdd2*bd1**2*f*k1**2*s**2*(K - 1) + 1125*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 264*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 396*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 3000*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 2000*D1**2*Pkdd2*f**2*fd*k1**2*s - 1000*D1**2*Pkdd2*f**2*fd*k1**2 + 1500*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 1000*D1**2*Pkdd2*f**2*fdd*k1**2*s + 500*D1**2*Pkdd2*f**2*fdd*k1**2 + 3000*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 2000*D1**2*Pkdd2*f*fd**2*k1**2*s + 31680*D1*Dd*K*Pk2*b1*f**2*s**2 - 15840*D1*Dd*K*Pk2*b1*f**2*s + 7920*D1*Dd*K*Pk2*b1*f**2 - 63360*D1*Dd*K*Pk2*b1*f*fd*s**2 + 47520*D1*Dd*K*Pk2*b1*f*fd*s - 7920*D1*Dd*K*Pk2*b1*f*fd - 1584*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s**2 + 792*D1*Dd*K*Pkdd2*b1**2*f*k1**2*s - 396*D1*Dd*K*Pkdd2*b1**2*f*k1**2 + 1584*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s**2 - 1980*D1*Dd*K*Pkdd2*b1**2*fd*k1**2*s + 396*D1*Dd*K*Pkdd2*b1**2*fd*k1**2 + 15840*D1*Dd*Pk2*b1*f**3*r*s - 3960*D1*Dd*Pk2*b1*f**3*r - 7920*D1*Dd*Pk2*b1*f**3*s - 95040*D1*Dd*Pk2*b1*f**2*fd*r*s + 27720*D1*Dd*Pk2*b1*f**2*fd*r + 39600*D1*Dd*Pk2*b1*f**2*fd*s - 11880*D1*Dd*Pk2*b1*f**2*fd + 31680*D1*Dd*Pk2*b1*f**2*r*s - 7920*D1*Dd*Pk2*b1*f**2*r - 15840*D1*Dd*Pk2*b1*f**2*s - 63360*D1*Dd*Pk2*b1*f*fd*r*s + 23760*D1*Dd*Pk2*b1*f*fd*r + 15840*D1*Dd*Pk2*b1*f*fd*s - 7920*D1*Dd*Pk2*b1*f*fd - 31680*D1*Dd*Pk2*bd2*f**2*s**2 + 7920*D1*Dd*Pk2*bd2*f**2*s + 25792*D1*Dd*Pk2*f**3*r*s - 6448*D1*Dd*Pk2*f**3*r - 24000*D1*Dd*Pk2*f**3*s**2 - 896*D1*Dd*Pk2*f**3*s - 6000*D1*Dd*Pk2*f**3 - 102720*D1*Dd*Pk2*f**2*fd*r*s + 29960*D1*Dd*Pk2*f**2*fd*r + 72000*D1*Dd*Pk2*f**2*fd*s**2 + 800*D1*Dd*Pk2*f**2*fd*s - 6840*D1*Dd*Pk2*f**2*fd - 63360*D1*Dd*Pk2*f**2*g2*s**2 + 31680*D1*Dd*Pk2*f**2*g2*s - 15840*D1*Dd*Pk2*f**2*g2 + 63360*D1*Dd*Pk2*f**2*gd2*s**2 - 15840*D1*Dd*Pk2*f**2*gd2*s + 126720*D1*Dd*Pk2*f*fd*g2*s**2 - 95040*D1*Dd*Pk2*f*fd*g2*s + 15840*D1*Dd*Pk2*f*fd*g2 + 1584*D1*Dd*Pkdd2*b1**2*f*k1**2*s**2 - 792*D1*Dd*Pkdd2*b1**2*f*k1**2*s + 396*D1*Dd*Pkdd2*b1**2*f*k1**2 - 1584*D1*Dd*Pkdd2*b1**2*fd*k1**2*s**2 + 1980*D1*Dd*Pkdd2*b1**2*fd*k1**2*s - 396*D1*Dd*Pkdd2*b1**2*fd*k1**2 - 9000*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 + 4500*D1*Dd*Pkdd2*b1*f**3*k1**2*s - 2250*D1*Dd*Pkdd2*b1*f**3*k1**2 + 27000*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 - 15750*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s + 2250*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 - 2112*D1*Dd*Pkdd2*b1*f**2*k1**2*s**2 + 1056*D1*Dd*Pkdd2*b1*f**2*k1**2*s - 528*D1*Dd*Pkdd2*b1*f**2*k1**2 + 4224*D1*Dd*Pkdd2*b1*f*fd*k1**2*s**2 - 3168*D1*Dd*Pkdd2*b1*f*fd*k1**2*s + 528*D1*Dd*Pkdd2*b1*f*fd*k1**2 + 3168*D1*Dd*Pkdd2*b1*f*g2*k1**2*s**2 - 1584*D1*Dd*Pkdd2*b1*f*g2*k1**2*s + 792*D1*Dd*Pkdd2*b1*f*g2*k1**2 - 3168*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s**2 + 792*D1*Dd*Pkdd2*b1*f*gd2*k1**2*s - 3168*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s**2 + 3960*D1*Dd*Pkdd2*b1*fd*g2*k1**2*s - 792*D1*Dd*Pkdd2*b1*fd*g2*k1**2 - 4000*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 2000*D1*Dd*Pkdd2*f**3*k1**2*s - 1000*D1*Dd*Pkdd2*f**3*k1**2 + 12000*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 7000*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 1000*D1*Dd*Pkdd2*f**2*fd*k1**2 - 15840*D1*Ddd*K*Pk2*b1*f**2*s**2 + 7920*D1*Ddd*K*Pk2*b1*f**2*s - 3960*D1*Ddd*K*Pk2*b1*f**2 + 792*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s**2 - 396*D1*Ddd*K*Pkdd2*b1**2*f*k1**2*s + 198*D1*Ddd*K*Pkdd2*b1**2*f*k1**2 - 15840*D1*Ddd*Pk2*b1*f**3*r*s + 3960*D1*Ddd*Pk2*b1*f**3*r + 7920*D1*Ddd*Pk2*b1*f**3*s - 15840*D1*Ddd*Pk2*b1*f**2*r*s + 3960*D1*Ddd*Pk2*b1*f**2*r + 7920*D1*Ddd*Pk2*b1*f**2*s - 17120*D1*Ddd*Pk2*f**3*r*s + 4280*D1*Ddd*Pk2*f**3*r + 12000*D1*Ddd*Pk2*f**3*s**2 + 2560*D1*Ddd*Pk2*f**3*s + 3000*D1*Ddd*Pk2*f**3 + 31680*D1*Ddd*Pk2*f**2*g2*s**2 - 15840*D1*Ddd*Pk2*f**2*g2*s + 7920*D1*Ddd*Pk2*f**2*g2 - 792*D1*Ddd*Pkdd2*b1**2*f*k1**2*s**2 + 396*D1*Ddd*Pkdd2*b1**2*f*k1**2*s - 198*D1*Ddd*Pkdd2*b1**2*f*k1**2 + 4500*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 - 2250*D1*Ddd*Pkdd2*b1*f**3*k1**2*s + 1125*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 1056*D1*Ddd*Pkdd2*b1*f**2*k1**2*s**2 - 528*D1*Ddd*Pkdd2*b1*f**2*k1**2*s + 264*D1*Ddd*Pkdd2*b1*f**2*k1**2 - 1584*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s**2 + 792*D1*Ddd*Pkdd2*b1*f*g2*k1**2*s - 396*D1*Ddd*Pkdd2*b1*f*g2*k1**2 + 2000*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 1000*D1*Ddd*Pkdd2*f**3*k1**2*s + 500*D1*Ddd*Pkdd2*f**3*k1**2 + 6*D1*bd1*(D1*(-132*Pkdd2*fd*k1**2*s*(s - 1)*(-K*b1 + b1 + g2) - 15*f**3*s*(-44*Pk2*(r - 1) + 25*Pkdd2*k1**2*s) + f**2*(-15*fd*(44*Pk2*(6*r*s - r - 4*s + 1) + 25*Pkdd2*k1**2*s*(1 - 3*s)) - 44*s*(-30*Pk2*(K*s + r - 1) + Pkdd2*k1**2*s*(3*C + 2))) - 44*f*(Pkdd2*k1**2*s**2*(3*b1*(K - 1) - 3*g2 + 3*gd2) + fd*(15*Pk2*(r*(4*s - 1) + (2*s - 1)*(2*K*s - 1)) - Pkdd2*k1**2*s*(3*C + 2)*(2*s - 1)))) + Dd*f*(Pkdd2*k1**2*s*(4*s - 1)*(132*K*b1 - 132*b1 - 132*g2) - 15*f**2*(44*Pk2*(r*(8*s - 1) - 6*s + 1) + 25*Pkdd2*k1**2*s*(1 - 4*s)) + 44*f*(-15*Pk2*(8*K*s**2 + r*(8*s - 1) - s*(2*K + 6) + 1) + Pkdd2*k1**2*s*(3*C + 2)*(4*s - 1)))) - 47520*Dd**2*K*Pk2*b1*f**2*s**2 + 23760*Dd**2*K*Pk2*b1*f**2*s + 2376*Dd**2*K*Pkdd2*b1**2*f*k1**2*s**2 - 1188*Dd**2*K*Pkdd2*b1**2*f*k1**2*s - 47520*Dd**2*Pk2*b1*f**3*r*s + 11880*Dd**2*Pk2*b1*f**3*r + 23760*Dd**2*Pk2*b1*f**3*s - 7920*Dd**2*Pk2*b1*f**3 - 47520*Dd**2*Pk2*b1*f**2*r*s + 11880*Dd**2*Pk2*b1*f**2*r + 23760*Dd**2*Pk2*b1*f**2*s - 7920*Dd**2*Pk2*b1*f**2 - 51360*Dd**2*Pk2*f**3*r*s + 12840*Dd**2*Pk2*f**3*r + 36000*Dd**2*Pk2*f**3*s**2 + 7680*Dd**2*Pk2*f**3*s - 8560*Dd**2*Pk2*f**3 + 95040*Dd**2*Pk2*f**2*g2*s**2 - 47520*Dd**2*Pk2*f**2*g2*s - 2376*Dd**2*Pkdd2*b1**2*f*k1**2*s**2 + 1188*Dd**2*Pkdd2*b1**2*f*k1**2*s + 13500*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 - 6750*Dd**2*Pkdd2*b1*f**3*k1**2*s + 3168*Dd**2*Pkdd2*b1*f**2*k1**2*s**2 - 1584*Dd**2*Pkdd2*b1*f**2*k1**2*s - 4752*Dd**2*Pkdd2*b1*f*g2*k1**2*s**2 + 2376*Dd**2*Pkdd2*b1*f*g2*k1**2*s + 6000*Dd**2*Pkdd2*f**3*k1**2*s**2 - 3000*Dd**2*Pkdd2*f**3*k1**2*s + 3960*Pk2*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1386*d**2*k3**2) + D1**2*Pk3*ct**4*(792*C*D1**2*Pk2*bdd1*f**2*r**2 - 3696*C*D1**2*Pk2*bdd1*f**2*r*s - 12720*C*D1**2*Pk2*f**2*fd*r*s + 4240*C*D1**2*Pk2*f**2*fd*r - 21780*C*D1**2*Pk2*f**2*fd*s**2 + 18760*C*D1**2*Pk2*f**2*fd*s - 7260*C*D1**2*Pk2*f**2*fd + 10320*C*D1**2*Pk2*f**2*fdd*r*s - 3440*C*D1**2*Pk2*f**2*fdd*r + 17820*C*D1**2*Pk2*f**2*fdd*s**2 - 15320*C*D1**2*Pk2*f**2*fdd*s + 5940*C*D1**2*Pk2*f**2*fdd + 20640*C*D1**2*Pk2*f*fd**2*r*s - 6880*C*D1**2*Pk2*f*fd**2*r + 35640*C*D1**2*Pk2*f*fd**2*s**2 - 30640*C*D1**2*Pk2*f*fd**2*s + 3440*C*D1**2*Pk2*f*fd**2 + 1680*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 1120*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 560*C*D1**2*Pkdd2*f**2*fd*k1**2 - 840*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 560*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 280*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 1680*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 1120*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 16960*C*D1*Dd*Pk2*f**3*r*s + 4240*C*D1*Dd*Pk2*f**3*r - 29040*C*D1*Dd*Pk2*f**3*s**2 + 23000*C*D1*Dd*Pk2*f**3*s - 7260*C*D1*Dd*Pk2*f**3 + 82560*C*D1*Dd*Pk2*f**2*fd*r*s - 24080*C*D1*Dd*Pk2*f**2*fd*r + 142560*C*D1*Dd*Pk2*f**2*fd*s**2 - 117560*C*D1*Dd*Pk2*f**2*fd*s + 22200*C*D1*Dd*Pk2*f**2*fd + 2240*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 1120*C*D1*Dd*Pkdd2*f**3*k1**2*s + 560*C*D1*Dd*Pkdd2*f**3*k1**2 - 6720*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 3920*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 560*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 13760*C*D1*Ddd*Pk2*f**3*r*s - 3440*C*D1*Ddd*Pk2*f**3*r + 23760*C*D1*Ddd*Pk2*f**3*s**2 - 18760*C*D1*Ddd*Pk2*f**3*s + 5940*C*D1*Ddd*Pk2*f**3 - 1120*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 560*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 280*C*D1*Ddd*Pkdd2*f**3*k1**2 + 41280*C*Dd**2*Pk2*f**3*r*s - 10320*C*Dd**2*Pk2*f**3*r + 71280*C*Dd**2*Pk2*f**3*s**2 - 56280*C*Dd**2*Pk2*f**3*s + 6880*C*Dd**2*Pk2*f**3 - 3360*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1680*C*Dd**2*Pkdd2*f**3*k1**2*s + 1584*D1**2*K*Pk2*bdd1*f**2*r*s + 3564*D1**2*K*Pk2*bdd1*f**2*s**2 - 1584*D1**2*K*Pk2*bdd1*f**2*s - 165*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 3168*D1**2*Pk2*b2*f*fd*r*s + 1584*D1**2*Pk2*b2*f*fd*r - 8712*D1**2*Pk2*b2*f*fd*s**2 + 8712*D1**2*Pk2*b2*f*fd*s - 4356*D1**2*Pk2*b2*f*fd + 3168*D1**2*Pk2*b2*f*fdd*r*s - 1584*D1**2*Pk2*b2*f*fdd*r + 7128*D1**2*Pk2*b2*f*fdd*s**2 - 7128*D1**2*Pk2*b2*f*fdd*s + 3564*D1**2*Pk2*b2*f*fdd + 3168*D1**2*Pk2*b2*fd**2*r*s - 1584*D1**2*Pk2*b2*fd**2*r + 7128*D1**2*Pk2*b2*fd**2*s**2 - 7128*D1**2*Pk2*b2*fd**2*s - 1584*D1**2*Pk2*bd2*f**2*r*s - 4356*D1**2*Pk2*bd2*f**2*s**2 + 1584*D1**2*Pk2*bd2*f**2*s + 6336*D1**2*Pk2*bd2*f*fd*r*s - 1584*D1**2*Pk2*bd2*f*fd*r + 14256*D1**2*Pk2*bd2*f*fd*s**2 - 10296*D1**2*Pk2*bd2*f*fd*s + 1584*D1**2*Pk2*bd2*f*fd + 1188*D1**2*Pk2*bdd1*f**3*r**2 + 1980*D1**2*Pk2*bdd1*f**3*r*s - 1584*D1**2*Pk2*bdd1*f**3*r - 1980*D1**2*Pk2*bdd1*f**3*s + 792*D1**2*Pk2*bdd1*f**3 + 3828*D1**2*Pk2*bdd1*f**2*r*s - 660*D1**2*Pk2*bdd1*f**2*r - 1980*D1**2*Pk2*bdd1*f**2*s + 792*D1**2*Pk2*bdd1*f**2 - 792*D1**2*Pk2*bdd1*f*g2*r**2 + 3168*D1**2*Pk2*bdd1*f*g2*r*s + 1584*D1**2*Pk2*bdd2*f**2*r*s + 3564*D1**2*Pk2*bdd2*f**2*s**2 - 1584*D1**2*Pk2*bdd2*f**2*s - 5928*D1**2*Pk2*f**2*fd*r**2 - 2754*D1**2*Pk2*f**2*fd*r*s + 4870*D1**2*Pk2*f**2*fd*r + 10890*D1**2*Pk2*f**2*fd*s**2 - 6342*D1**2*Pk2*f**2*fd*s + 1654*D1**2*Pk2*f**2*fd + 2568*D1**2*Pk2*f**2*fdd*r**2 + 1674*D1**2*Pk2*f**2*fdd*r*s - 2270*D1**2*Pk2*f**2*fdd*r - 8910*D1**2*Pk2*f**2*fdd*s**2 + 5382*D1**2*Pk2*f**2*fdd*s - 2114*D1**2*Pk2*f**2*fdd + 3168*D1**2*Pk2*f**2*gd2*r*s + 8712*D1**2*Pk2*f**2*gd2*s**2 - 3168*D1**2*Pk2*f**2*gd2*s - 3168*D1**2*Pk2*f**2*gdd2*r*s - 7128*D1**2*Pk2*f**2*gdd2*s**2 + 3168*D1**2*Pk2*f**2*gdd2*s + 5136*D1**2*Pk2*f*fd**2*r**2 + 3348*D1**2*Pk2*f*fd**2*r*s - 4540*D1**2*Pk2*f*fd**2*r - 17820*D1**2*Pk2*f*fd**2*s**2 + 10764*D1**2*Pk2*f*fd**2*s + 558*D1**2*Pk2*f*fd**2 + 6336*D1**2*Pk2*f*fd*g2*r*s - 3168*D1**2*Pk2*f*fd*g2*r + 17424*D1**2*Pk2*f*fd*g2*s**2 - 17424*D1**2*Pk2*f*fd*g2*s + 8712*D1**2*Pk2*f*fd*g2 - 12672*D1**2*Pk2*f*fd*gd2*r*s + 3168*D1**2*Pk2*f*fd*gd2*r - 28512*D1**2*Pk2*f*fd*gd2*s**2 + 20592*D1**2*Pk2*f*fd*gd2*s - 3168*D1**2*Pk2*f*fd*gd2 - 6336*D1**2*Pk2*f*fdd*g2*r*s + 3168*D1**2*Pk2*f*fdd*g2*r - 14256*D1**2*Pk2*f*fdd*g2*s**2 + 14256*D1**2*Pk2*f*fdd*g2*s - 7128*D1**2*Pk2*f*fdd*g2 - 6336*D1**2*Pk2*fd**2*g2*r*s + 3168*D1**2*Pk2*fd**2*g2*r - 14256*D1**2*Pk2*fd**2*g2*s**2 + 14256*D1**2*Pk2*fd**2*g2*s + 660*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 - 660*D1**2*Pkdd2*b2*f*fd*k1**2*s + 330*D1**2*Pkdd2*b2*f*fd*k1**2 - 330*D1**2*Pkdd2*b2*f*fdd*k1**2*s**2 + 330*D1**2*Pkdd2*b2*f*fdd*k1**2*s - 165*D1**2*Pkdd2*b2*f*fdd*k1**2 - 330*D1**2*Pkdd2*b2*fd**2*k1**2*s**2 + 330*D1**2*Pkdd2*b2*fd**2*k1**2*s + 330*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 - 660*D1**2*Pkdd2*bd2*f*fd*k1**2*s**2 + 330*D1**2*Pkdd2*bd2*f*fd*k1**2*s + 330*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 660*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 330*D1**2*Pkdd2*bdd1*f**2*k1**2 - 165*D1**2*Pkdd2*bdd2*f**2*k1**2*s**2 + 150*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 100*D1**2*Pkdd2*f**2*fd*k1**2*s + 50*D1**2*Pkdd2*f**2*fd*k1**2 + 420*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 280*D1**2*Pkdd2*f**2*fdd*k1**2*s + 140*D1**2*Pkdd2*f**2*fdd*k1**2 - 660*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 330*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 840*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 560*D1**2*Pkdd2*f*fd**2*k1**2*s - 1320*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 1320*D1**2*Pkdd2*f*fd*g2*k1**2*s - 660*D1**2*Pkdd2*f*fd*g2*k1**2 + 1320*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 660*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 660*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 660*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 330*D1**2*Pkdd2*f*fdd*g2*k1**2 + 660*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 660*D1**2*Pkdd2*fd**2*g2*k1**2*s + 66*D1**2*bd1**2*(-14*Pkdd2*g2*k1**2*s*(s - 1) + f**2*(12*Pk2*(r - 1) + 5*Pkdd2*k1**2*s*(2*s - 3)) + 12*f*(C*Pkdd2*k1**2*s*(s - 1) + Pk2*(2*K*s + r**2*(K - 1) - r*(4*K*s + K - 2) - 1))) - 6336*D1*Dd*Pk2*b2*f**2*r*s + 1584*D1*Dd*Pk2*b2*f**2*r - 17424*D1*Dd*Pk2*b2*f**2*s**2 + 11880*D1*Dd*Pk2*b2*f**2*s - 4356*D1*Dd*Pk2*b2*f**2 + 25344*D1*Dd*Pk2*b2*f*fd*r*s - 9504*D1*Dd*Pk2*b2*f*fd*r + 57024*D1*Dd*Pk2*b2*f*fd*s**2 - 49104*D1*Dd*Pk2*b2*f*fd*s + 10296*D1*Dd*Pk2*b2*f*fd + 12672*D1*Dd*Pk2*bd2*f**2*r*s - 1584*D1*Dd*Pk2*bd2*f**2*r + 28512*D1*Dd*Pk2*bd2*f**2*s**2 - 16632*D1*Dd*Pk2*bd2*f**2*s + 1584*D1*Dd*Pk2*bd2*f**2 - 7904*D1*Dd*Pk2*f**3*r**2 - 3672*D1*Dd*Pk2*f**3*r*s + 8822*D1*Dd*Pk2*f**3*r + 14520*D1*Dd*Pk2*f**3*s**2 - 5424*D1*Dd*Pk2*f**3*s - 322*D1*Dd*Pk2*f**3 + 20544*D1*Dd*Pk2*f**2*fd*r**2 + 13392*D1*Dd*Pk2*f**2*fd*r*s - 21026*D1*Dd*Pk2*f**2*fd*r - 71280*D1*Dd*Pk2*f**2*fd*s**2 + 36000*D1*Dd*Pk2*f**2*fd*s - 842*D1*Dd*Pk2*f**2*fd + 12672*D1*Dd*Pk2*f**2*g2*r*s - 3168*D1*Dd*Pk2*f**2*g2*r + 34848*D1*Dd*Pk2*f**2*g2*s**2 - 23760*D1*Dd*Pk2*f**2*g2*s + 8712*D1*Dd*Pk2*f**2*g2 - 25344*D1*Dd*Pk2*f**2*gd2*r*s + 3168*D1*Dd*Pk2*f**2*gd2*r - 57024*D1*Dd*Pk2*f**2*gd2*s**2 + 33264*D1*Dd*Pk2*f**2*gd2*s - 3168*D1*Dd*Pk2*f**2*gd2 - 50688*D1*Dd*Pk2*f*fd*g2*r*s + 19008*D1*Dd*Pk2*f*fd*g2*r - 114048*D1*Dd*Pk2*f*fd*g2*s**2 + 98208*D1*Dd*Pk2*f*fd*g2*s - 20592*D1*Dd*Pk2*f*fd*g2 + 1320*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 - 660*D1*Dd*Pkdd2*b2*f**2*k1**2*s + 330*D1*Dd*Pkdd2*b2*f**2*k1**2 - 2640*D1*Dd*Pkdd2*b2*f*fd*k1**2*s**2 + 1980*D1*Dd*Pkdd2*b2*f*fd*k1**2*s - 330*D1*Dd*Pkdd2*b2*f*fd*k1**2 - 1320*D1*Dd*Pkdd2*bd2*f**2*k1**2*s**2 + 330*D1*Dd*Pkdd2*bd2*f**2*k1**2*s + 200*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 100*D1*Dd*Pkdd2*f**3*k1**2*s + 50*D1*Dd*Pkdd2*f**3*k1**2 + 3360*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 1960*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 280*D1*Dd*Pkdd2*f**2*fd*k1**2 - 2640*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 1320*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 660*D1*Dd*Pkdd2*f**2*g2*k1**2 + 2640*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 660*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 5280*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 3960*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 660*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 6336*D1*Ddd*Pk2*b2*f**2*r*s - 1584*D1*Ddd*Pk2*b2*f**2*r + 14256*D1*Ddd*Pk2*b2*f**2*s**2 - 10296*D1*Ddd*Pk2*b2*f**2*s + 3564*D1*Ddd*Pk2*b2*f**2 + 3424*D1*Ddd*Pk2*f**3*r**2 + 2232*D1*Ddd*Pk2*f**3*r*s - 3982*D1*Ddd*Pk2*f**3*r - 11880*D1*Ddd*Pk2*f**3*s**2 + 4824*D1*Ddd*Pk2*f**3*s - 1258*D1*Ddd*Pk2*f**3 - 12672*D1*Ddd*Pk2*f**2*g2*r*s + 3168*D1*Ddd*Pk2*f**2*g2*r - 28512*D1*Ddd*Pk2*f**2*g2*s**2 + 20592*D1*Ddd*Pk2*f**2*g2*s - 7128*D1*Ddd*Pk2*f**2*g2 - 660*D1*Ddd*Pkdd2*b2*f**2*k1**2*s**2 + 330*D1*Ddd*Pkdd2*b2*f**2*k1**2*s - 165*D1*Ddd*Pkdd2*b2*f**2*k1**2 + 560*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 280*D1*Ddd*Pkdd2*f**3*k1**2*s + 140*D1*Ddd*Pkdd2*f**3*k1**2 + 1320*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 660*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 330*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 33*D1*bd1*(D1*(48*Pk2*fd*g2*r*(r - 4*s + 2) + 3*f**3*(4*Pk2*(3*r**2 + r*(5*s - 4) - 5*s + 2) - 5*Pkdd2*k1**2*s**2) - 2*f**2*(2*Pk2*(-33*K*s**2 + 12*K*s + 3*fd*(18*r**2 + 5*r*(6*s - 5) - 20*s + 9) + r**2*(17 - 23*C) + r*(s*(56*C - 12*K - 49) - 2) + 21*s - 6) + Pkdd2*k1**2*(s**2*(6*C + 5*K - 10) + 20*s - 10)) - 2*f*(-24*Pk2*gd2*(r**2 - r*(4*s + 1) + 2*s) + fd*(4*Pk2*(12*C*r**2 + 14*C*s + 3*K*(r*(8*s - 2) + 18*s**2 - 13*s + 2) + r*(-56*C*s + 8*C + 58*s - 17) - 22*s + 4) + 5*Pkdd2*k1**2*s*(-2*K*s + K + 4*s - 4)) + g2*(24*Pk2*r*(r - 4*s) - 7*Pkdd2*k1**2*s**2))) - 2*Dd*f*(6*Pk2*f**2*(24*r**2 + r*(40*s - 33) - 30*s + 13) - 96*Pk2*g2*(r**2 - 4*r*s + s) + f*(2*Pk2*(48*C*r**2 + 56*C*s + 6*K*(2*r*(8*s - 1) + 36*s**2 - 21*s + 2) + r*(-224*C*s + 4*C + 232*s - 49) - 118*s + 25) - 5*Pkdd2*k1**2*(4*s - 1)*(s*(K - 2) + 2)))) + 19008*Dd**2*Pk2*b2*f**2*r*s - 4752*Dd**2*Pk2*b2*f**2*r + 42768*Dd**2*Pk2*b2*f**2*s**2 - 30888*Dd**2*Pk2*b2*f**2*s + 3168*Dd**2*Pk2*b2*f**2 + 10272*Dd**2*Pk2*f**3*r**2 + 6696*Dd**2*Pk2*f**3*r*s - 11946*Dd**2*Pk2*f**3*r - 35640*Dd**2*Pk2*f**3*s**2 + 14472*Dd**2*Pk2*f**3*s + 2828*Dd**2*Pk2*f**3 - 38016*Dd**2*Pk2*f**2*g2*r*s + 9504*Dd**2*Pk2*f**2*g2*r - 85536*Dd**2*Pk2*f**2*g2*s**2 + 61776*Dd**2*Pk2*f**2*g2*s - 6336*Dd**2*Pk2*f**2*g2 - 1980*Dd**2*Pkdd2*b2*f**2*k1**2*s**2 + 990*Dd**2*Pkdd2*b2*f**2*k1**2*s + 1680*Dd**2*Pkdd2*f**3*k1**2*s**2 - 840*Dd**2*Pkdd2*f**3*k1**2*s + 3960*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 1980*Dd**2*Pkdd2*f**2*g2*k1**2*s - 231*Pkdd2*b1**3*k1**2*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 33*b1**2*(D1**2*(12*C*Pkdd2*fdd*k1**2*s**2 + 12*K*Pk2*fdd*r**2 - 48*K*Pk2*fdd*r*s + 48*K*Pk2*fdd*r + 21*K*Pkdd2*bdd1*k1**2*s**2 - 14*K*Pkdd2*bdd1*k1**2*s + 7*K*Pkdd2*bdd1*k1**2 - 24*Pk2*f*fdd*r - 12*Pk2*fdd*r**2 - 24*Pk2*fdd*r - 14*Pkdd2*bd1*k1**2*(K - 1)*(3*s**2 - 2*s + 1) - 21*Pkdd2*bdd1*k1**2*s**2 + 14*Pkdd2*bdd1*k1**2*s - 7*Pkdd2*bdd1*k1**2 + 20*Pkdd2*f*fdd*k1**2*s**2 + 10*Pkdd2*f*fdd*k1**2*s - 5*Pkdd2*f*fdd*k1**2 + 28*Pkdd2*gd2*k1**2*s**2 - 14*Pkdd2*gdd2*k1**2*s**2 + fd**2*(-24*Pk2*(r - 1) + 10*Pkdd2*k1**2*s*(2*s + 1)) + fd*(24*Pk2*r*(-K*(r - 4*s + 4) + f + r + 2) - Pkdd2*k1**2*(24*C*s**2 - 7*K*(s - 1)**2 + 10*f*(4*s**2 + 2*s - 1) + 7*s**2 - 14*s + 7))) + D1*(-Dd*(48*Pk2*f*(K*(2*r**2 - 8*r*s + 4*s + 1) + fd*(2*r - 1) - 2*r**2 + 2*r - 1) + 20*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*f*k1**2*(24*C*(4*s**2 - 2*s + 1) + fd*(10 - 160*s**2) - (7*K - 7)*(4*s**2 - 2*s + 1)) - 14*Pkdd2*k1**2*(bd1*(K - 1)*(12*s**2 - 7*s + 1) + 2*g2*(4*s**2 - 2*s + 1) + 2*gd2*s*(1 - 4*s)) - 24*fd*(C*Pkdd2*k1**2*s*(4*s - 1) + 2*Pk2*(2*K*(r**2 - 4*r*s + 2*r + s - 1) - 2*r**2 - r + 1))) + 2*Ddd*(5*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) - 7*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 6*f*(C*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + 2*Pk2*(2*K*r**2 - 8*K*r*s + 4*K*s + K - 2*r**2 + 2*r - 1)))) + 12*Dd**2*(6*C*Pkdd2*f*k1**2*s*(2*s - 1) + 2*Pk2*f*(3*K*(2*r**2 - 8*r*s + 4*s - 1) - 6*r**2 + 6*r - 1) + 5*Pkdd2*f**2*k1**2*s*(2*s - 1) + 7*Pkdd2*g2*k1**2*s*(1 - 2*s))) + 33*b1*(-184*C*D1**2*Pk2*f*fd*r**2 + 448*C*D1**2*Pk2*f*fd*r*s - 40*C*D1**2*Pk2*f*fd*r - 224*C*D1**2*Pk2*f*fd*s - 92*C*D1**2*Pk2*f*fd + 48*C*D1**2*Pk2*f*fdd*r**2 - 224*C*D1**2*Pk2*f*fdd*r*s + 64*C*D1**2*Pk2*f*fdd*r + 112*C*D1**2*Pk2*f*fdd*s + 24*C*D1**2*Pk2*f*fdd + 48*C*D1**2*Pk2*fd**2*r**2 - 224*C*D1**2*Pk2*fd**2*r*s + 64*C*D1**2*Pk2*fd**2*r + 112*C*D1**2*Pk2*fd**2*s - 112*C*D1**2*Pk2*fd**2 + 24*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 24*C*D1**2*Pkdd2*f*fd*k1**2*s + 12*C*D1**2*Pkdd2*f*fd*k1**2 - 368*C*D1*Dd*Pk2*f**2*r**2 + 896*C*D1*Dd*Pk2*f**2*r*s + 144*C*D1*Dd*Pk2*f**2*r - 448*C*D1*Dd*Pk2*f**2*s - 184*C*D1*Dd*Pk2*f**2 + 384*C*D1*Dd*Pk2*f*fd*r**2 - 1792*C*D1*Dd*Pk2*f*fd*r*s + 288*C*D1*Dd*Pk2*f*fd*r + 896*C*D1*Dd*Pk2*f*fd*s - 240*C*D1*Dd*Pk2*f*fd + 48*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 24*C*D1*Dd*Pkdd2*f**2*k1**2*s + 12*C*D1*Dd*Pkdd2*f**2*k1**2 + 96*C*D1*Ddd*Pk2*f**2*r**2 - 448*C*D1*Ddd*Pk2*f**2*r*s + 16*C*D1*Ddd*Pk2*f**2*r + 224*C*D1*Ddd*Pk2*f**2*s + 48*C*D1*Ddd*Pk2*f**2 + 288*C*Dd**2*Pk2*f**2*r**2 - 1344*C*Dd**2*Pk2*f**2*r*s + 48*C*Dd**2*Pk2*f**2*r + 672*C*Dd**2*Pk2*f**2*s - 176*C*Dd**2*Pk2*f**2 - 96*D1**2*K*Pk2*f*fd*r*s + 48*D1**2*K*Pk2*f*fd*r - 264*D1**2*K*Pk2*f*fd*s**2 + 264*D1**2*K*Pk2*f*fd*s - 132*D1**2*K*Pk2*f*fd + 96*D1**2*K*Pk2*f*fdd*r*s - 48*D1**2*K*Pk2*f*fdd*r + 216*D1**2*K*Pk2*f*fdd*s**2 - 216*D1**2*K*Pk2*f*fdd*s + 108*D1**2*K*Pk2*f*fdd + 96*D1**2*K*Pk2*fd**2*r*s - 48*D1**2*K*Pk2*fd**2*r + 216*D1**2*K*Pk2*fd**2*s**2 - 216*D1**2*K*Pk2*fd**2*s + 20*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 20*D1**2*K*Pkdd2*f*fd*k1**2*s + 10*D1**2*K*Pkdd2*f*fd*k1**2 - 10*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 + 10*D1**2*K*Pkdd2*f*fdd*k1**2*s - 5*D1**2*K*Pkdd2*f*fdd*k1**2 - 10*D1**2*K*Pkdd2*fd**2*k1**2*s**2 + 10*D1**2*K*Pkdd2*fd**2*k1**2*s - 108*D1**2*Pk2*f**2*fd*r**2 - 180*D1**2*Pk2*f**2*fd*r*s + 156*D1**2*Pk2*f**2*fd*r + 60*D1**2*Pk2*f**2*fd*s - 48*D1**2*Pk2*f**2*fd + 108*D1**2*Pk2*f**2*fdd*r**2 + 180*D1**2*Pk2*f**2*fdd*r*s - 156*D1**2*Pk2*f**2*fdd*r - 60*D1**2*Pk2*f**2*fdd*s + 48*D1**2*Pk2*f**2*fdd + 216*D1**2*Pk2*f*fd**2*r**2 + 360*D1**2*Pk2*f*fd**2*r*s - 312*D1**2*Pk2*f*fd**2*r - 120*D1**2*Pk2*f*fd**2*s + 84*D1**2*Pk2*f*fd**2 + 136*D1**2*Pk2*f*fd*r**2 - 392*D1**2*Pk2*f*fd*r*s + 68*D1**2*Pk2*f*fd*r + 112*D1**2*Pk2*f*fd*s + 92*D1**2*Pk2*f*fd + 232*D1**2*Pk2*f*fdd*r*s - 96*D1**2*Pk2*f*fdd*r - 56*D1**2*Pk2*f*fdd*s - 24*D1**2*Pk2*f*fdd + 48*D1**2*Pk2*f*gd2*r**2 - 192*D1**2*Pk2*f*gd2*r*s - 96*D1**2*Pk2*f*gd2*r + 192*D1**2*Pk2*f*gd2*s + 48*D1**2*Pk2*f*gd2 - 24*D1**2*Pk2*f*gdd2*r**2 + 96*D1**2*Pk2*f*gdd2*r*s + 48*D1**2*Pk2*f*gdd2*r - 96*D1**2*Pk2*f*gdd2*s - 24*D1**2*Pk2*f*gdd2 + 232*D1**2*Pk2*fd**2*r*s - 96*D1**2*Pk2*fd**2*r - 56*D1**2*Pk2*fd**2*s + 84*D1**2*Pk2*fd**2 + 48*D1**2*Pk2*fd*g2*r**2 - 192*D1**2*Pk2*fd*g2*r*s + 192*D1**2*Pk2*fd*g2*r - 48*D1**2*Pk2*fd*gd2*r**2 + 192*D1**2*Pk2*fd*gd2*r*s - 48*D1**2*Pk2*fd*gd2*r - 96*D1**2*Pk2*fd*gd2*s + 96*D1**2*Pk2*fd*gd2 - 24*D1**2*Pk2*fdd*g2*r**2 + 96*D1**2*Pk2*fdd*g2*r*s - 96*D1**2*Pk2*fdd*g2*r + 14*D1**2*Pkdd2*bd1**2*k1**2*s*(K - 1)*(3*s - 2) + 45*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 30*D1**2*Pkdd2*f**2*fd*k1**2*s + 15*D1**2*Pkdd2*f**2*fd*k1**2 - 40*D1**2*Pkdd2*f*fd*k1**2*s**2 + 20*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 14*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 20*D1**2*Pkdd2*fd**2*k1**2*s**2 - 14*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 28*D1**2*Pkdd2*fd*g2*k1**2*s - 14*D1**2*Pkdd2*fd*g2*k1**2 + D1**2*bdd1*(-14*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + f**2*(24*Pk2*r + 5*Pkdd2*k1**2*(4*s**2 - 6*s + 3)) + 12*f*(C*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + Pk2*(K*(2*r**2 - 8*r*s - 2*r + 4*s + 1) - 2*r**2 + 4*r - 1))) - 192*D1*Dd*K*Pk2*f**2*r*s + 48*D1*Dd*K*Pk2*f**2*r - 528*D1*Dd*K*Pk2*f**2*s**2 + 360*D1*Dd*K*Pk2*f**2*s - 132*D1*Dd*K*Pk2*f**2 + 768*D1*Dd*K*Pk2*f*fd*r*s - 288*D1*Dd*K*Pk2*f*fd*r + 1728*D1*Dd*K*Pk2*f*fd*s**2 - 1488*D1*Dd*K*Pk2*f*fd*s + 312*D1*Dd*K*Pk2*f*fd + 40*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 20*D1*Dd*K*Pkdd2*f**2*k1**2*s + 10*D1*Dd*K*Pkdd2*f**2*k1**2 - 80*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 + 60*D1*Dd*K*Pkdd2*f*fd*k1**2*s - 10*D1*Dd*K*Pkdd2*f*fd*k1**2 - 144*D1*Dd*Pk2*f**3*r**2 - 240*D1*Dd*Pk2*f**3*r*s + 204*D1*Dd*Pk2*f**3*r + 120*D1*Dd*Pk2*f**3*s - 72*D1*Dd*Pk2*f**3 + 864*D1*Dd*Pk2*f**2*fd*r**2 + 1440*D1*Dd*Pk2*f**2*fd*r*s - 1236*D1*Dd*Pk2*f**2*fd*r - 600*D1*Dd*Pk2*f**2*fd*s + 372*D1*Dd*Pk2*f**2*fd + 272*D1*Dd*Pk2*f**2*r**2 - 784*D1*Dd*Pk2*f**2*r*s - 76*D1*Dd*Pk2*f**2*r + 392*D1*Dd*Pk2*f**2*s + 136*D1*Dd*Pk2*f**2 + 1856*D1*Dd*Pk2*f*fd*r*s - 616*D1*Dd*Pk2*f*fd*r - 688*D1*Dd*Pk2*f*fd*s + 248*D1*Dd*Pk2*f*fd + 192*D1*Dd*Pk2*f*g2*r**2 - 768*D1*Dd*Pk2*f*g2*r*s + 384*D1*Dd*Pk2*f*g2*s + 96*D1*Dd*Pk2*f*g2 - 192*D1*Dd*Pk2*f*gd2*r**2 + 768*D1*Dd*Pk2*f*gd2*r*s + 192*D1*Dd*Pk2*f*gd2*r - 576*D1*Dd*Pk2*f*gd2*s - 192*D1*Dd*Pk2*fd*g2*r**2 + 768*D1*Dd*Pk2*fd*g2*r*s - 384*D1*Dd*Pk2*fd*g2*r - 192*D1*Dd*Pk2*fd*g2*s + 192*D1*Dd*Pk2*fd*g2 + 60*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 30*D1*Dd*Pkdd2*f**3*k1**2*s + 15*D1*Dd*Pkdd2*f**3*k1**2 - 80*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 40*D1*Dd*Pkdd2*f**2*k1**2*s - 20*D1*Dd*Pkdd2*f**2*k1**2 + 160*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 40*D1*Dd*Pkdd2*f*fd*k1**2*s - 56*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 28*D1*Dd*Pkdd2*f*g2*k1**2*s - 14*D1*Dd*Pkdd2*f*g2*k1**2 + 192*D1*Ddd*K*Pk2*f**2*r*s - 48*D1*Ddd*K*Pk2*f**2*r + 432*D1*Ddd*K*Pk2*f**2*s**2 - 312*D1*Ddd*K*Pk2*f**2*s + 108*D1*Ddd*K*Pk2*f**2 - 20*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 + 10*D1*Ddd*K*Pkdd2*f**2*k1**2*s - 5*D1*Ddd*K*Pkdd2*f**2*k1**2 + 144*D1*Ddd*Pk2*f**3*r**2 + 240*D1*Ddd*Pk2*f**3*r*s - 204*D1*Ddd*Pk2*f**3*r - 120*D1*Ddd*Pk2*f**3*s + 72*D1*Ddd*Pk2*f**3 + 464*D1*Ddd*Pk2*f**2*r*s - 116*D1*Ddd*Pk2*f**2*r - 232*D1*Ddd*Pk2*f**2*s - 96*D1*Ddd*Pk2*f*g2*r**2 + 384*D1*Ddd*Pk2*f*g2*r*s - 192*D1*Ddd*Pk2*f*g2*s - 48*D1*Ddd*Pk2*f*g2 + 40*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 20*D1*Ddd*Pkdd2*f**2*k1**2*s + 10*D1*Ddd*Pkdd2*f**2*k1**2 - 2*D1*bd1*(D1*(-14*Pkdd2*k1**2*(g2*(2*s**2 - 2*s + 1) + gd2*s*(1 - 2*s)) + f**2*(12*Pk2*r + 5*Pkdd2*k1**2*(4*s**2 - 6*s + 3)) + f*(12*Pk2*(K*(2*r**2 - 8*r*s - 2*r + 4*s + 1) - 2*r**2 + 4*r - 1) + Pkdd2*k1**2*(12*C*(2*s**2 - 2*s + 1) + s*(-7*K*s - 40*fd*s + 20*fd + 7*s))) - 12*fd*(C*Pkdd2*k1**2*s*(2*s - 1) + K*Pk2*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*Pk2*r**2 + Pk2)) + Dd*(14*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) + f**2*(Pk2*(24 - 48*r) - 5*Pkdd2*k1**2*(16*s**2 - 16*s + 3)) - 12*f*(C*Pkdd2*k1**2*(8*s**2 - 6*s + 1) + 4*Pk2*(2*r - 1)*(-4*K*s + r*(K - 1) + 1)))) + 576*Dd**2*K*Pk2*f**2*r*s - 144*Dd**2*K*Pk2*f**2*r + 1296*Dd**2*K*Pk2*f**2*s**2 - 936*Dd**2*K*Pk2*f**2*s + 96*Dd**2*K*Pk2*f**2 - 60*Dd**2*K*Pkdd2*f**2*k1**2*s**2 + 30*Dd**2*K*Pkdd2*f**2*k1**2*s + 432*Dd**2*Pk2*f**3*r**2 + 720*Dd**2*Pk2*f**3*r*s - 612*Dd**2*Pk2*f**3*r - 360*Dd**2*Pk2*f**3*s + 192*Dd**2*Pk2*f**3 + 1392*Dd**2*Pk2*f**2*r*s - 348*Dd**2*Pk2*f**2*r - 696*Dd**2*Pk2*f**2*s + 232*Dd**2*Pk2*f**2 - 288*Dd**2*Pk2*f*g2*r**2 + 1152*Dd**2*Pk2*f*g2*r*s - 576*Dd**2*Pk2*f*g2*s + 144*Dd**2*Pk2*f*g2 + 120*Dd**2*Pkdd2*f**2*k1**2*s**2 - 60*Dd**2*Pkdd2*f**2*k1**2*s))/(693*d**2*k3**2) + D1**2*Pk3*ct**4*k2**4*(D1**2*(-66*Pkdd2*k1**2*s*(b1*s*(-3*K*b1*fdd + fd**2*(5 - 10*C) + 6*fd*(K*b1 - 2*g2 + 2*gd2) + 6*fdd*g2) + 6*bd1*fd*(K*b1*(1 - 2*s) + 2*g2*(s - 1))) + f**2*(Pk2*fdd*(134 - 268*C)*(3*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(2*bd1*(10*C*(s - 1)**2 - s**2*(3*K + 5) + 10*s - 5) - 5*bdd1*(2*C - 1)*(s - 1)**2 + 12*gd2*s**2) - fd*(2*C - 1)*(326*Pk2*(3*r**2 - 2*r + 1) - 165*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + 2*f*(-804*C*Pk2*fd**2*r**2 + 536*C*Pk2*fd**2*r - 660*C*Pkdd2*b1*fd*k1**2*s**2 + 330*C*Pkdd2*b1*fdd*k1**2*s**2 + 198*K*Pkdd2*b1*fd*k1**2*s**2 - 198*K*Pkdd2*b1*fd*k1**2*s + 99*K*Pkdd2*b1*fd*k1**2 + 198*K*Pkdd2*bd1**2*k1**2*s*(s - 1) + 402*Pk2*fd**2*r**2 - 268*Pk2*fd**2*r + 330*Pkdd2*b1*fd*k1**2*s**2 - 165*Pkdd2*b1*fdd*k1**2*s**2 + 396*Pkdd2*b1*gd2*k1**2*s**2 - 198*Pkdd2*b1*gdd2*k1**2*s**2 + 66*Pkdd2*bd1*k1**2*(-3*K*b1*(2*s**2 - 2*s + 1) + 6*g2*(s - 1)**2 + s*(s - 1)*(10*C*fd - 5*fd - 6*gd2)) - 99*Pkdd2*bdd1*k1**2*(K*b1*(-2*s**2 + 2*s - 1) + 2*g2*(s - 1)**2) - 396*Pkdd2*fd*g2*k1**2*s**2 + 396*Pkdd2*fd*g2*k1**2*s - 198*Pkdd2*fd*g2*k1**2)) + D1*(Dd*(396*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(K*b1 - 2*g2) - 132*Pkdd2*f*k1**2*(3*K*b1**2*(4*s**2 - 2*s + 1) - b1*(6*g2*(4*s**2 - 2*s + 1) + (4*s - 1)*(3*K*bd1*(2*s - 1) + fd*s*(10*C - 5) - 6*gd2*s)) + 6*bd1*g2*(4*s**2 - 5*s + 1)) - f**3*(2*C - 1)*(652*Pk2*(2*r**2 - 2*r + 1) - 165*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) - 2*f**2*(Pk2*fd*(536*C - 268)*(6*r**2 - 5*r + 1) + 33*Pkdd2*k1**2*(b1*(10*C - 3*K - 5)*(4*s**2 - 2*s + 1) - 5*bd1*(2*C - 1)*(4*s**2 - 5*s + 1) + 6*g2*(4*s**2 - 2*s + 1)))) + Ddd*f*(Pk2*f**2*(268 - 536*C)*(2*r**2 - 2*r + 1) + 165*Pkdd2*b1*f*k1**2*(2*C - 1)*(4*s**2 - 2*s + 1) + 198*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*f**2*(134 - 268*C)*(6*r**2 - 6*r + 1) + 495*Pkdd2*b1*f*k1**2*s*(2*C - 1)*(2*s - 1) + 594*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2)))/(693*d**2*k1**2*k3**4) + D1**2*Pk3*ct**4*k2**2*(D1**2*(66*Pkdd2*k1**2*(3*K*b1**2*(2*fd - fdd)*(2*s - 1) + b1*(fd**2*s*(5 - 10*C) - 6*fd*(g2*(4*s - 2) + s*(K*bd1 - b2*s + bd2*s - 2*gd2)) - 3*fdd*(b2*s**2 + g2*(2 - 4*s))) - 6*b2*bd1*fd*s*(s - 1)) + f**2*(Pk2*fdd*(268*C - 134)*(3*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(2*bd1*(10*C*(2*s - 1) + 3*K*s**2 - 10*s + 5) - 5*bdd1*(2*C - 1)*(2*s - 1) + s**2*(6*bd2 - 12*gd2)) + fd*(2*C - 1)*(326*Pk2*(3*r**2 - 2*r + 1) - 165*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + f*(396*K*Pkdd2*bd1**2*k1**2*s + 33*Pkdd2*b1*k1**2*(-12*K*bd1*(2*s - 1) - 6*bdd1*(-2*K*s + K) - 2*fd*(C*(10 - 20*s) + K*(6*s**2 - 6*s + 3) + 10*s - 5) + fdd*(5 - 10*C)*(2*s - 1) - 6*s**2*(-2*bd2 + bdd2)) - 198*Pkdd2*b2*k1**2*(-2*bd1*(s - 1)**2 + bdd1*(s - 1)**2 + fd*(2*s**2 - 2*s + 1)) + 66*Pkdd2*bd1*k1**2*(12*g2*(2*s - 1) + s*(10*C*fd - 6*bd2*(s - 1) - 5*fd - 12*gd2)) - 396*Pkdd2*bdd1*g2*k1**2*(2*s - 1) + 4*fd*(Pk2*fd*r*(134*C - 67)*(3*r - 2) + 99*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1)))) + D1*(Dd*(-396*Pkdd2*b1*fd*k1**2*(4*s - 1)*(K*b1 + b2*s - 2*g2) + 66*Pkdd2*f*k1**2*(b1*(6*b2*(4*s**2 - 2*s + 1) - (4*s - 1)*(10*C*fd - 6*K*bd1 + 6*bd2*s - 5*fd)) - 6*bd1*(4*s - 1)*(b2*(s - 1) + 2*g2)) + f**3*(2*C - 1)*(652*Pk2*(2*r**2 - 2*r + 1) - 165*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 2*f**2*(Pk2*fd*(536*C - 268)*(6*r**2 - 5*r + 1) - 33*Pkdd2*k1**2*(3*b2*(4*s**2 - 2*s + 1) - 5*bd1*(2*C - 1)*(4*s - 1) - (-3*K*b1 + 6*g2)*(4*s**2 - 2*s + 1)))) + 2*Ddd*f*(Pk2*f**2*(268*C - 134)*(2*r**2 - 2*r + 1) - 99*Pkdd2*b1*b2*k1**2*(4*s**2 - 2*s + 1))) - 4*Dd**2*f*(Pk2*f**2*(67 - 134*C)*(6*r**2 - 6*r + 1) + 297*Pkdd2*b1*b2*k1**2*s*(2*s - 1)))/(693*d**2*k1**2*k3**2) - 10*D1**2*Pk3*ct**3*f*k1*k2*st**4*(D1**2*(7*f**2*(104*Pk2*fd*(-4*r*s + r + 2*s) - 104*Pk2*fdd*(-4*r*s + r + 2*s) + Pk2*s*(104*bd1 - 52*bdd1)*(2*r + s - 2) + 30*Pkdd2*fd*k1**2*(4*s**2 - 2*s + 1) - 15*Pkdd2*fdd*k1**2*(4*s**2 - 2*s + 1)) + 2*f*(7*fd**2*(52*Pk2*(3*r*(4*s - 1) - 6*s + 2) + 45*Pkdd2*k1**2*s*(1 - 2*s)) + 26*fd*(2*Pk2*(-24*C*r*s + 8*C*r + 36*C*s**2 - 16*C*s + 12*C + 7*b1*(3*s - 1)*(2*r + s - 1) - 7*bd1*(6*r*s - r + 3*s**2 - 5*s + 1) + 42*r*s - 14*r - 9*s**2 - 8*s - 3) + Pkdd2*k1**2*(C - 1)*(3*s**2 - 2*s + 1)) - 13*fdd*(2*Pk2*(4*C*(r*(2 - 6*s) + 9*s**2 - 4*s + 3) + 7*b1*(3*s - 1)*(2*r + s - 1) + 42*r*s - 14*r - 9*s**2 - 8*s - 3) + Pkdd2*k1**2*(C - 1)*(3*s**2 - 2*s + 1))) - 52*fd**2*(2*Pk2*(-4*C*(6*r*s - 2*r - 9*s**2 + 4*s + 1) + 7*b1*(3*s - 1)*(2*r + s - 1) + 42*r*s - 14*r - 9*s**2 - 8*s + 7) + Pkdd2*k1**2*s*(C - 1)*(3*s - 2))) - D1*f*(2*Dd*(-7*f**2*(52*Pk2*(-4*r*s + r + 2*s) + 15*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(-52*Pk2*(-32*C*r*s + 8*C*r + 48*C*s**2 - 8*C*s + 12*C + 7*b1*(r*(8*s - 2) + 4*s**2 - 6*s + 1) - 7*bd1*(8*r*s - r + 4*s**2 - 7*s + 1) + 224*fd*r*s - 56*fd*r - 112*fd*s + 28*fd + 56*r*s - 14*r - 12*s**2 - 22*s - 3) + Pkdd2*k1**2*(-26*C*(4*s**2 - 2*s + 1) + 105*fd*(1 - 4*s)**2 + 104*s**2 - 52*s + 26)) + 26*fd*(2*Pk2*(144*C*s**2 - 44*C*s + 7*b1*(r*(24*s - 7) + 12*s**2 - 17*s + 4) - r*(4*C - 7)*(24*s - 7) - 36*s**2 - 49*s + 18) + Pkdd2*k1**2*(C - 1)*(12*s**2 - 7*s + 1))) + Ddd*f*(52*Pk2*(C*(-32*r*s + 8*r + 48*s**2 - 8*s + 12) + 7*b1*(r*(8*s - 2) + 4*s**2 - 6*s + 1) - 56*f*r*s + 14*f*r + 28*f*s + 56*r*s - 14*r - 12*s**2 - 22*s - 3) + Pkdd2*k1**2*(26*C + 105*f - 26)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f**2*(52*Pk2*(-4*C*(12*r*s - 3*r - 18*s**2 + 3*s + 2) + 7*b1*(3*r*(4*s - 1) + 6*s**2 - 9*s + 2) - 84*f*r*s + 21*f*r + 42*f*s - 14*f + 84*r*s - 21*r - 18*s**2 - 33*s + 14) + Pkdd2*k1**2*s*(2*s - 1)*(78*C + 315*f - 78)))/(3003*d**2*k3**4) + D1**2*Pk3*ct**3*k1**3*st**2*(20592*C*D1**2*Pk2*bdd1*f**2*r*s + 41184*C*D1**2*Pk2*bdd1*f**2*s**2 - 41184*C*D1**2*Pk2*bdd1*f**2*s + 20592*C*D1**2*Pk2*bdd1*f**2 + 237744*C*D1**2*Pk2*f**2*fd*r*s - 79248*C*D1**2*Pk2*f**2*fd*r + 403416*C*D1**2*Pk2*f**2*fd*s**2 - 348192*C*D1**2*Pk2*f**2*fd*s + 134472*C*D1**2*Pk2*f**2*fd - 170352*C*D1**2*Pk2*f**2*fdd*r*s + 56784*C*D1**2*Pk2*f**2*fdd*r - 309816*C*D1**2*Pk2*f**2*fdd*s**2 + 263328*C*D1**2*Pk2*f**2*fdd*s - 103272*C*D1**2*Pk2*f**2*fdd - 340704*C*D1**2*Pk2*f*fd**2*r*s + 113568*C*D1**2*Pk2*f*fd**2*r - 619632*C*D1**2*Pk2*f*fd**2*s**2 + 526656*C*D1**2*Pk2*f*fd**2*s - 56784*C*D1**2*Pk2*f*fd**2 + 316992*C*D1*Dd*Pk2*f**3*r*s - 79248*C*D1*Dd*Pk2*f**3*r + 537888*C*D1*Dd*Pk2*f**3*s**2 - 427440*C*D1*Dd*Pk2*f**3*s + 134472*C*D1*Dd*Pk2*f**3 - 1362816*C*D1*Dd*Pk2*f**2*fd*r*s + 397488*C*D1*Dd*Pk2*f**2*fd*r - 2478528*C*D1*Dd*Pk2*f**2*fd*s**2 + 2013648*C*D1*Dd*Pk2*f**2*fd*s - 376896*C*D1*Dd*Pk2*f**2*fd - 227136*C*D1*Ddd*Pk2*f**3*r*s + 56784*C*D1*Ddd*Pk2*f**3*r - 413088*C*D1*Ddd*Pk2*f**3*s**2 + 320112*C*D1*Ddd*Pk2*f**3*s - 103272*C*D1*Ddd*Pk2*f**3 - 681408*C*Dd**2*Pk2*f**3*r*s + 170352*C*Dd**2*Pk2*f**3*r - 1239264*C*Dd**2*Pk2*f**3*s**2 + 960336*C*Dd**2*Pk2*f**3*s - 113568*C*Dd**2*Pk2*f**3 - 30888*D1**2*K*Pk2*bdd1*f**2*r*s - 56628*D1**2*K*Pk2*bdd1*f**2*s**2 + 30888*D1**2*K*Pk2*bdd1*f**2*s + 10296*D1**2*Pk2*bd1**2*f*s*(K - 1)*(2*r + 4*s - 3) + 130000*D1**2*Pk2*bdd1*f**3*r*s + 130000*D1**2*Pk2*bdd1*f**3*s**2 - 156000*D1**2*Pk2*bdd1*f**3*s + 39000*D1**2*Pk2*bdd1*f**3 + 72072*D1**2*Pk2*bdd1*f**2*r*s + 87516*D1**2*Pk2*bdd1*f**2*s**2 - 51480*D1**2*Pk2*bdd1*f**2*s - 20592*D1**2*Pk2*bdd1*f**2 - 20592*D1**2*Pk2*bdd1*f*g2*r*s - 41184*D1**2*Pk2*bdd1*f*g2*s**2 + 41184*D1**2*Pk2*bdd1*f*g2*s - 20592*D1**2*Pk2*bdd1*f*g2 + 624000*D1**2*Pk2*f**3*fd*r*s - 156000*D1**2*Pk2*f**3*fd*r + 1170000*D1**2*Pk2*f**3*fd*s**2 - 897000*D1**2*Pk2*f**3*fd*s + 292500*D1**2*Pk2*f**3*fd - 624000*D1**2*Pk2*f**3*fdd*r*s + 156000*D1**2*Pk2*f**3*fdd*r - 858000*D1**2*Pk2*f**3*fdd*s**2 + 741000*D1**2*Pk2*f**3*fdd*s - 214500*D1**2*Pk2*f**3*fdd - 1872000*D1**2*Pk2*f**2*fd**2*r*s + 468000*D1**2*Pk2*f**2*fd**2*r - 2574000*D1**2*Pk2*f**2*fd**2*s**2 + 2223000*D1**2*Pk2*f**2*fd**2*s - 312000*D1**2*Pk2*f**2*fd**2 - 456768*D1**2*Pk2*f**2*fd*r*s + 152256*D1**2*Pk2*f**2*fd*r - 669240*D1**2*Pk2*f**2*fd*s**2 + 598416*D1**2*Pk2*f**2*fd*s - 223080*D1**2*Pk2*f**2*fd + 310752*D1**2*Pk2*f**2*fdd*r*s - 103584*D1**2*Pk2*f**2*fdd*r + 473616*D1**2*Pk2*f**2*fdd*s**2 - 419328*D1**2*Pk2*f**2*fdd*s + 157872*D1**2*Pk2*f**2*fdd - 102960*D1**2*Pk2*f**2*gd2*r*s - 154440*D1**2*Pk2*f**2*gd2*s**2 + 102960*D1**2*Pk2*f**2*gd2*s + 61776*D1**2*Pk2*f**2*gdd2*r*s + 113256*D1**2*Pk2*f**2*gdd2*s**2 - 61776*D1**2*Pk2*f**2*gdd2*s + 621504*D1**2*Pk2*f*fd**2*r*s - 207168*D1**2*Pk2*f*fd**2*r + 947232*D1**2*Pk2*f*fd**2*s**2 - 838656*D1**2*Pk2*f*fd**2*s + 103584*D1**2*Pk2*f*fd**2 - 205920*D1**2*Pk2*f*fd*g2*r*s + 102960*D1**2*Pk2*f*fd*g2*r - 308880*D1**2*Pk2*f*fd*g2*s**2 + 308880*D1**2*Pk2*f*fd*g2*s - 154440*D1**2*Pk2*f*fd*g2 + 247104*D1**2*Pk2*f*fd*gd2*r*s - 61776*D1**2*Pk2*f*fd*gd2*r + 453024*D1**2*Pk2*f*fd*gd2*s**2 - 350064*D1**2*Pk2*f*fd*gd2*s + 61776*D1**2*Pk2*f*fd*gd2 + 123552*D1**2*Pk2*f*fdd*g2*r*s - 61776*D1**2*Pk2*f*fdd*g2*r + 226512*D1**2*Pk2*f*fdd*g2*s**2 - 226512*D1**2*Pk2*f*fdd*g2*s + 113256*D1**2*Pk2*f*fdd*g2 + 123552*D1**2*Pk2*fd**2*g2*r*s - 61776*D1**2*Pk2*fd**2*g2*r + 226512*D1**2*Pk2*fd**2*g2*s**2 - 226512*D1**2*Pk2*fd**2*g2*s - 9800*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 4900*D1**2*Pkdd2*f**3*fd*k1**2*s - 2450*D1**2*Pkdd2*f**3*fd*k1**2 + 4900*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 2450*D1**2*Pkdd2*f**3*fdd*k1**2*s + 1225*D1**2*Pkdd2*f**3*fdd*k1**2 + 14700*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 7350*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 624000*D1*Dd*Pk2*f**4*r*s - 156000*D1*Dd*Pk2*f**4*r + 1170000*D1*Dd*Pk2*f**4*s**2 - 897000*D1*Dd*Pk2*f**4*s + 292500*D1*Dd*Pk2*f**4 - 4992000*D1*Dd*Pk2*f**3*fd*r*s + 1248000*D1*Dd*Pk2*f**3*fd*r - 6864000*D1*Dd*Pk2*f**3*fd*s**2 + 5928000*D1*Dd*Pk2*f**3*fd*s - 1053000*D1*Dd*Pk2*f**3*fd - 609024*D1*Dd*Pk2*f**3*r*s + 152256*D1*Dd*Pk2*f**3*r - 892320*D1*Dd*Pk2*f**3*s**2 + 750672*D1*Dd*Pk2*f**3*s - 223080*D1*Dd*Pk2*f**3 + 2486016*D1*Dd*Pk2*f**2*fd*r*s - 725088*D1*Dd*Pk2*f**2*fd*r + 3788928*D1*Dd*Pk2*f**2*fd*s**2 - 3246048*D1*Dd*Pk2*f**2*fd*s + 626496*D1*Dd*Pk2*f**2*fd - 411840*D1*Dd*Pk2*f**2*g2*r*s + 102960*D1*Dd*Pk2*f**2*g2*r - 617760*D1*Dd*Pk2*f**2*g2*s**2 + 514800*D1*Dd*Pk2*f**2*g2*s - 154440*D1*Dd*Pk2*f**2*g2 + 494208*D1*Dd*Pk2*f**2*gd2*r*s - 61776*D1*Dd*Pk2*f**2*gd2*r + 906048*D1*Dd*Pk2*f**2*gd2*s**2 - 597168*D1*Dd*Pk2*f**2*gd2*s + 61776*D1*Dd*Pk2*f**2*gd2 + 988416*D1*Dd*Pk2*f*fd*g2*r*s - 370656*D1*Dd*Pk2*f*fd*g2*r + 1812096*D1*Dd*Pk2*f*fd*g2*s**2 - 1606176*D1*Dd*Pk2*f*fd*g2*s + 350064*D1*Dd*Pk2*f*fd*g2 - 9800*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 4900*D1*Dd*Pkdd2*f**4*k1**2*s - 2450*D1*Dd*Pkdd2*f**4*k1**2 + 39200*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 19600*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 2450*D1*Dd*Pkdd2*f**3*fd*k1**2 - 624000*D1*Ddd*Pk2*f**4*r*s + 156000*D1*Ddd*Pk2*f**4*r - 858000*D1*Ddd*Pk2*f**4*s**2 + 741000*D1*Ddd*Pk2*f**4*s - 214500*D1*Ddd*Pk2*f**4 + 414336*D1*Ddd*Pk2*f**3*r*s - 103584*D1*Ddd*Pk2*f**3*r + 631488*D1*Ddd*Pk2*f**3*s**2 - 522912*D1*Ddd*Pk2*f**3*s + 157872*D1*Ddd*Pk2*f**3 + 247104*D1*Ddd*Pk2*f**2*g2*r*s - 61776*D1*Ddd*Pk2*f**2*g2*r + 453024*D1*Ddd*Pk2*f**2*g2*s**2 - 350064*D1*Ddd*Pk2*f**2*g2*s + 113256*D1*Ddd*Pk2*f**2*g2 + 4900*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 2450*D1*Ddd*Pkdd2*f**4*k1**2*s + 1225*D1*Ddd*Pkdd2*f**4*k1**2 - 52*D1*Pk2*bd1*(D1*(4*f**3*(953*s**2 + s*(953*r - 1302) + 375) + f**2*(132*C*(11*s**2 + s*(5*r - 12) + 6) - 500*fd*(5*r*(6*s - 1) + 30*s**2 - 32*s + 3) - 33*s**2*(45*K - 73) - 33*s*(30*K*(r - 1) - 70*r + 42) - 792) + 66*f*(3*fd*(-16*C*s**2 + 14*C*s + K*(3*r*(4*s - 1) + 22*s**2 - 17*s + 3) - r*(2*C + 7)*(4*s - 1) - 34*s**2 + 29*s - 9) - 2*g2*(19*s**2 + s*(13*r - 12) + 6) + 6*gd2*s*(2*r + 4*s - 3)) + 396*fd*g2*(r*(2*s - 1) + s*(4*s - 4))) - 2*Dd*f*(250*f**2*(5*r*(8*s - 1) + 40*s**2 - 44*s + 6) + 99*f*(2*C*(8*r*s - r + 16*s**2 - 14*s + 2) + K*(-24*r*s + 3*r - 44*s**2 + 29*s - 3) + 56*r*s - 7*r + 68*s**2 - 51*s + 5) - 198*g2*(8*r*s - r + 16*s**2 - 14*s + 2))) - 1872000*Dd**2*Pk2*f**4*r*s + 468000*Dd**2*Pk2*f**4*r - 2574000*Dd**2*Pk2*f**4*s**2 + 2223000*Dd**2*Pk2*f**4*s - 312000*Dd**2*Pk2*f**4 + 1243008*Dd**2*Pk2*f**3*r*s - 310752*Dd**2*Pk2*f**3*r + 1894464*Dd**2*Pk2*f**3*s**2 - 1568736*Dd**2*Pk2*f**3*s + 207168*Dd**2*Pk2*f**3 + 741312*Dd**2*Pk2*f**2*g2*r*s - 185328*Dd**2*Pk2*f**2*g2*r + 1359072*Dd**2*Pk2*f**2*g2*s**2 - 1050192*Dd**2*Pk2*f**2*g2*s + 123552*Dd**2*Pk2*f**2*g2 + 14700*Dd**2*Pkdd2*f**4*k1**2*s**2 - 7350*Dd**2*Pkdd2*f**4*k1**2*s - 3432*Pk2*b1**2*(K - 1)*(D1**2*(fd*(13*r*(s - 1) + 19*s**2 - 26*s + 13) - 3*fdd*(r*(s - 1) + 2*s**2 - 2*s + 1)) + D1*(Dd*(f*(52*r*s - 13*r + 76*s**2 - 64*s + 19) - 3*fd*(8*r*s - 5*r + 16*s**2 - 14*s + 4)) - 3*Ddd*f*(r*(4*s - 1) + 8*s**2 - 6*s + 2)) - 3*Dd**2*f*(3*r*(4*s - 1) + 24*s**2 - 18*s + 2)) - 52*Pk2*b1*(1320*C*D1**2*f*fd*r*s - 660*C*D1**2*f*fd*r + 2904*C*D1**2*f*fd*s**2 - 1980*C*D1**2*f*fd*s + 660*C*D1**2*f*fd - 792*C*D1**2*f*fdd*r*s + 396*C*D1**2*f*fdd*r - 1584*C*D1**2*f*fdd*s**2 + 1188*C*D1**2*f*fdd*s - 396*C*D1**2*f*fdd - 792*C*D1**2*fd**2*r*s + 396*C*D1**2*fd**2*r - 1584*C*D1**2*fd**2*s**2 + 1188*C*D1**2*fd**2*s - 396*C*D1**2*fd**2 + 2640*C*D1*Dd*f**2*r*s - 660*C*D1*Dd*f**2*r + 5808*C*D1*Dd*f**2*s**2 - 4224*C*D1*Dd*f**2*s + 1452*C*D1*Dd*f**2 - 6336*C*D1*Dd*f*fd*r*s + 2376*C*D1*Dd*f*fd*r - 12672*C*D1*Dd*f*fd*s**2 + 9504*C*D1*Dd*f*fd*s - 1980*C*D1*Dd*f*fd - 1584*C*D1*Ddd*f**2*r*s + 396*C*D1*Ddd*f**2*r - 3168*C*D1*Ddd*f**2*s**2 + 2376*C*D1*Ddd*f**2*s - 792*C*D1*Ddd*f**2 - 4752*C*Dd**2*f**2*r*s + 1188*C*Dd**2*f**2*r - 9504*C*Dd**2*f**2*s**2 + 7128*C*Dd**2*f**2*s - 792*C*Dd**2*f**2 - 1980*D1**2*K*f*fd*r*s + 990*D1**2*K*f*fd*r - 2970*D1**2*K*f*fd*s**2 + 2970*D1**2*K*f*fd*s - 1485*D1**2*K*f*fd + 1188*D1**2*K*f*fdd*r*s - 594*D1**2*K*f*fdd*r + 2178*D1**2*K*f*fdd*s**2 - 2178*D1**2*K*f*fdd*s + 1089*D1**2*K*f*fdd + 1188*D1**2*K*fd**2*r*s - 594*D1**2*K*fd**2*r + 2178*D1**2*K*fd**2*s**2 - 2178*D1**2*K*fd**2*s - 198*D1**2*bdd1*f*(K - 1)*(2*r*s + 4*s**2 - 3*s + 1) + 11436*D1**2*f**2*fd*r*s - 3812*D1**2*f**2*fd*r + 11436*D1**2*f**2*fd*s**2 - 10040*D1**2*f**2*fd*s + 2312*D1**2*f**2*fd - 7500*D1**2*f**2*fdd*r*s + 2500*D1**2*f**2*fdd*r - 7500*D1**2*f**2*fdd*s**2 + 7000*D1**2*f**2*fdd*s - 1750*D1**2*f**2*fdd - 15000*D1**2*f*fd**2*r*s + 5000*D1**2*f*fd**2*r - 15000*D1**2*f*fd**2*s**2 + 14000*D1**2*f*fd**2*s - 3500*D1**2*f*fd**2 + 4620*D1**2*f*fd*r*s - 2310*D1**2*f*fd*r + 4818*D1**2*f*fd*s**2 - 5742*D1**2*f*fd*s + 3201*D1**2*f*fd - 2772*D1**2*f*fdd*r*s + 1386*D1**2*f*fdd*r - 3366*D1**2*f*fdd*s**2 + 3762*D1**2*f*fdd*s - 2079*D1**2*f*fdd - 1716*D1**2*f*gd2*r*s - 2508*D1**2*f*gd2*s**2 + 1716*D1**2*f*gd2*s + 396*D1**2*f*gdd2*r*s + 792*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s - 2772*D1**2*fd**2*r*s + 1386*D1**2*fd**2*r - 3366*D1**2*fd**2*s**2 + 3762*D1**2*fd**2*s + 396*D1**2*fd**2 - 1716*D1**2*fd*g2*r*s + 1716*D1**2*fd*g2*r - 2508*D1**2*fd*g2*s**2 + 3432*D1**2*fd*g2*s - 1716*D1**2*fd*g2 + 792*D1**2*fd*gd2*r*s - 396*D1**2*fd*gd2*r + 1584*D1**2*fd*gd2*s**2 - 1188*D1**2*fd*gd2*s + 396*D1**2*fd*gd2 + 396*D1**2*fdd*g2*r*s - 396*D1**2*fdd*g2*r + 792*D1**2*fdd*g2*s**2 - 792*D1**2*fdd*g2*s + 396*D1**2*fdd*g2 - 3960*D1*Dd*K*f**2*r*s + 990*D1*Dd*K*f**2*r - 5940*D1*Dd*K*f**2*s**2 + 4950*D1*Dd*K*f**2*s - 1485*D1*Dd*K*f**2 + 9504*D1*Dd*K*f*fd*r*s - 3564*D1*Dd*K*f*fd*r + 17424*D1*Dd*K*f*fd*s**2 - 15444*D1*Dd*K*f*fd*s + 3366*D1*Dd*K*f*fd + 15248*D1*Dd*f**3*r*s - 3812*D1*Dd*f**3*r + 15248*D1*Dd*f**3*s**2 - 15248*D1*Dd*f**3*s + 3812*D1*Dd*f**3 - 60000*D1*Dd*f**2*fd*r*s + 17500*D1*Dd*f**2*fd*r - 60000*D1*Dd*f**2*fd*s**2 + 58000*D1*Dd*f**2*fd*s - 12000*D1*Dd*f**2*fd + 9240*D1*Dd*f**2*r*s - 2310*D1*Dd*f**2*r + 9636*D1*Dd*f**2*s**2 - 9438*D1*Dd*f**2*s + 2409*D1*Dd*f**2 - 22176*D1*Dd*f*fd*r*s + 8316*D1*Dd*f*fd*r - 26928*D1*Dd*f*fd*s**2 + 27324*D1*Dd*f*fd*s - 6534*D1*Dd*f*fd - 6864*D1*Dd*f*g2*r*s + 1716*D1*Dd*f*g2*r - 10032*D1*Dd*f*g2*s**2 + 8448*D1*Dd*f*g2*s - 2508*D1*Dd*f*g2 + 3168*D1*Dd*f*gd2*r*s - 396*D1*Dd*f*gd2*r + 6336*D1*Dd*f*gd2*s**2 - 3960*D1*Dd*f*gd2*s + 396*D1*Dd*f*gd2 + 3168*D1*Dd*fd*g2*r*s - 1980*D1*Dd*fd*g2*r + 6336*D1*Dd*fd*g2*s**2 - 5544*D1*Dd*fd*g2*s + 1584*D1*Dd*fd*g2 + 2376*D1*Ddd*K*f**2*r*s - 594*D1*Ddd*K*f**2*r + 4356*D1*Ddd*K*f**2*s**2 - 3366*D1*Ddd*K*f**2*s + 1089*D1*Ddd*K*f**2 - 10000*D1*Ddd*f**3*r*s + 2500*D1*Ddd*f**3*r - 10000*D1*Ddd*f**3*s**2 + 10000*D1*Ddd*f**3*s - 2500*D1*Ddd*f**3 - 5544*D1*Ddd*f**2*r*s + 1386*D1*Ddd*f**2*r - 6732*D1*Ddd*f**2*s**2 + 6138*D1*Ddd*f**2*s - 1683*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r*s - 396*D1*Ddd*f*g2*r + 3168*D1*Ddd*f*g2*s**2 - 2376*D1*Ddd*f*g2*s + 792*D1*Ddd*f*g2 + 66*D1*bd1*(K - 1)*(D1*(f*(26*r*s + 38*s**2 - 25*s + 6) - 3*fd*(4*r*s - 2*r + 8*s**2 - 7*s + 1)) - 3*Dd*f*(2*r*(8*s - 1) + 32*s**2 - 24*s + 3)) + 7128*Dd**2*K*f**2*r*s - 1782*Dd**2*K*f**2*r + 13068*Dd**2*K*f**2*s**2 - 10098*Dd**2*K*f**2*s + 1188*Dd**2*K*f**2 - 30000*Dd**2*f**3*r*s + 7500*Dd**2*f**3*r - 30000*Dd**2*f**3*s**2 + 30000*Dd**2*f**3*s - 5000*Dd**2*f**3 - 16632*Dd**2*f**2*r*s + 4158*Dd**2*f**2*r - 20196*Dd**2*f**2*s**2 + 18414*Dd**2*f**2*s - 2772*Dd**2*f**2 + 4752*Dd**2*f*g2*r*s - 1188*Dd**2*f*g2*r + 9504*Dd**2*f*g2*s**2 - 7128*Dd**2*f*g2*s + 792*Dd**2*f*g2))/(9009*d**2*k2*k3**4) - 2*D1**2*Pk3*ct**3*k1**3*(6072*C*D1**2*Pk2*bdd1*f**2*r*s - 3168*C*D1**2*Pk2*bdd1*f**2*r + 7920*C*D1**2*Pk2*bdd1*f**2*s**2 - 10032*C*D1**2*Pk2*bdd1*f**2*s + 5016*C*D1**2*Pk2*bdd1*f**2 + 19224*C*D1**2*Pk2*f**2*fd*r*s - 6408*C*D1**2*Pk2*f**2*fd*r + 1008*C*D1**2*Pk2*f**2*fd*s**2 - 7080*C*D1**2*Pk2*f**2*fd*s + 336*C*D1**2*Pk2*f**2*fd - 14364*C*D1**2*Pk2*f**2*fdd*r*s + 4788*C*D1**2*Pk2*f**2*fdd*r - 4068*C*D1**2*Pk2*f**2*fdd*s**2 + 7500*C*D1**2*Pk2*f**2*fdd*s - 1356*C*D1**2*Pk2*f**2*fdd - 28728*C*D1**2*Pk2*f*fd**2*r*s + 9576*C*D1**2*Pk2*f*fd**2*r - 8136*C*D1**2*Pk2*f*fd**2*s**2 + 15000*C*D1**2*Pk2*f*fd**2*s - 4788*C*D1**2*Pk2*f*fd**2 + 25632*C*D1*Dd*Pk2*f**3*r*s - 6408*C*D1*Dd*Pk2*f**3*r + 1344*C*D1*Dd*Pk2*f**3*s**2 - 13488*C*D1*Dd*Pk2*f**3*s + 336*C*D1*Dd*Pk2*f**3 - 114912*C*D1*Dd*Pk2*f**2*fd*r*s + 33516*C*D1*Dd*Pk2*f**2*fd*r - 32544*C*D1*Dd*Pk2*f**2*fd*s**2 + 66864*C*D1*Dd*Pk2*f**2*fd*s - 17076*C*D1*Dd*Pk2*f**2*fd - 19152*C*D1*Ddd*Pk2*f**3*r*s + 4788*C*D1*Ddd*Pk2*f**3*r - 5424*C*D1*Ddd*Pk2*f**3*s**2 + 12288*C*D1*Ddd*Pk2*f**3*s - 1356*C*D1*Ddd*Pk2*f**3 - 57456*C*Dd**2*Pk2*f**3*r*s + 14364*C*Dd**2*Pk2*f**3*r - 16272*C*Dd**2*Pk2*f**3*s**2 + 36864*C*Dd**2*Pk2*f**3*s - 9576*C*Dd**2*Pk2*f**3 - 2574*D1**2*K*Pk2*bdd1*f**2*r*s - 792*D1**2*K*Pk2*bdd1*f**2*s**2 + 2574*D1**2*K*Pk2*bdd1*f**2*s - 1056*D1**2*Pk2*b2*f*fd*r*s + 528*D1**2*Pk2*b2*f*fd*r - 1056*D1**2*Pk2*b2*f*fd*s**2 + 1056*D1**2*Pk2*b2*f*fd*s - 528*D1**2*Pk2*b2*f*fd + 1320*D1**2*Pk2*b2*f*fdd*r*s - 660*D1**2*Pk2*b2*f*fdd*r + 1320*D1**2*Pk2*b2*f*fdd*s**2 - 1320*D1**2*Pk2*b2*f*fdd*s + 660*D1**2*Pk2*b2*f*fdd + 1320*D1**2*Pk2*b2*fd**2*r*s - 660*D1**2*Pk2*b2*fd**2*r + 1320*D1**2*Pk2*b2*fd**2*s**2 - 1320*D1**2*Pk2*b2*fd**2*s - 132*D1**2*Pk2*bd1**2*(5*f**2*(r*(8*s - 5) + 8*s**2 - 12*s + 3) + f*(24*C*s**2 - 24*C*s + K*(r*(13 - 52*s) - 71*s**2 + 71*s - 13) + r*(24*C*s - 12*C + 64*s - 19) + 83*s**2 - 101*s + 31) + 14*g2*(-2*r*s + r - s*(2*s - 2))) - 528*D1**2*Pk2*bd2*f**2*r*s - 528*D1**2*Pk2*bd2*f**2*s**2 + 528*D1**2*Pk2*bd2*f**2*s + 2640*D1**2*Pk2*bd2*f*fd*r*s - 660*D1**2*Pk2*bd2*f*fd*r + 2640*D1**2*Pk2*bd2*f*fd*s**2 - 2640*D1**2*Pk2*bd2*f*fd*s + 660*D1**2*Pk2*bd2*f*fd + 2310*D1**2*Pk2*bdd1*f**3*r**2 + 11220*D1**2*Pk2*bdd1*f**3*r*s - 6270*D1**2*Pk2*bdd1*f**3*r + 6270*D1**2*Pk2*bdd1*f**3*s**2 - 10560*D1**2*Pk2*bdd1*f**3*s + 4620*D1**2*Pk2*bdd1*f**3 + 1320*D1**2*Pk2*bdd1*f**2*r**2 + 858*D1**2*Pk2*bdd1*f**2*r*s + 2508*D1**2*Pk2*bdd1*f**2*r - 2772*D1**2*Pk2*bdd1*f**2*s**2 + 5082*D1**2*Pk2*bdd1*f**2*s - 5676*D1**2*Pk2*bdd1*f**2 - 6864*D1**2*Pk2*bdd1*f*g2*r*s + 3432*D1**2*Pk2*bdd1*f*g2*r - 9372*D1**2*Pk2*bdd1*f*g2*s**2 + 11880*D1**2*Pk2*bdd1*f*g2*s - 5940*D1**2*Pk2*bdd1*f*g2 + 660*D1**2*Pk2*bdd2*f**2*r*s + 660*D1**2*Pk2*bdd2*f**2*s**2 - 660*D1**2*Pk2*bdd2*f**2*s + 6600*D1**2*Pk2*f**3*fd*r**2 + 31680*D1**2*Pk2*f**3*fd*r*s - 14520*D1**2*Pk2*f**3*fd*r + 19800*D1**2*Pk2*f**3*fd*s**2 - 25740*D1**2*Pk2*f**3*fd*s + 8250*D1**2*Pk2*f**3*fd - 6600*D1**2*Pk2*f**3*fdd*r**2 - 31680*D1**2*Pk2*f**3*fdd*r*s + 14520*D1**2*Pk2*f**3*fdd*r - 19800*D1**2*Pk2*f**3*fdd*s**2 + 25740*D1**2*Pk2*f**3*fdd*s - 8250*D1**2*Pk2*f**3*fdd - 19800*D1**2*Pk2*f**2*fd**2*r**2 - 95040*D1**2*Pk2*f**2*fd**2*r*s + 43560*D1**2*Pk2*f**2*fd**2*r - 59400*D1**2*Pk2*f**2*fd**2*s**2 + 77220*D1**2*Pk2*f**2*fd**2*s - 19140*D1**2*Pk2*f**2*fd**2 - 2775*D1**2*Pk2*f**2*fd*r**2 - 36834*D1**2*Pk2*f**2*fd*r*s + 14128*D1**2*Pk2*f**2*fd*r - 19998*D1**2*Pk2*f**2*fd*s**2 + 25610*D1**2*Pk2*f**2*fd*s - 7591*D1**2*Pk2*f**2*fd + 3615*D1**2*Pk2*f**2*fdd*r**2 + 30594*D1**2*Pk2*f**2*fdd*r*s - 12608*D1**2*Pk2*f**2*fdd*r + 19998*D1**2*Pk2*f**2*fdd*s**2 - 23530*D1**2*Pk2*f**2*fdd*s + 7871*D1**2*Pk2*f**2*fdd - 6864*D1**2*Pk2*f**2*gd2*r*s - 396*D1**2*Pk2*f**2*gd2*s**2 + 6864*D1**2*Pk2*f**2*gd2*s + 5148*D1**2*Pk2*f**2*gdd2*r*s + 1584*D1**2*Pk2*f**2*gdd2*s**2 - 5148*D1**2*Pk2*f**2*gdd2*s + 7230*D1**2*Pk2*f*fd**2*r**2 + 61188*D1**2*Pk2*f*fd**2*r*s - 25216*D1**2*Pk2*f*fd**2*r + 39996*D1**2*Pk2*f*fd**2*s**2 - 47060*D1**2*Pk2*f*fd**2*s + 10198*D1**2*Pk2*f*fd**2 - 13728*D1**2*Pk2*f*fd*g2*r*s + 6864*D1**2*Pk2*f*fd*g2*r - 792*D1**2*Pk2*f*fd*g2*s**2 + 792*D1**2*Pk2*f*fd*g2*s - 396*D1**2*Pk2*f*fd*g2 + 20592*D1**2*Pk2*f*fd*gd2*r*s - 5148*D1**2*Pk2*f*fd*gd2*r + 6336*D1**2*Pk2*f*fd*gd2*s**2 - 13464*D1**2*Pk2*f*fd*gd2*s + 5148*D1**2*Pk2*f*fd*gd2 + 10296*D1**2*Pk2*f*fdd*g2*r*s - 5148*D1**2*Pk2*f*fdd*g2*r + 3168*D1**2*Pk2*f*fdd*g2*s**2 - 3168*D1**2*Pk2*f*fdd*g2*s + 1584*D1**2*Pk2*f*fdd*g2 + 10296*D1**2*Pk2*fd**2*g2*r*s - 5148*D1**2*Pk2*fd**2*g2*r + 3168*D1**2*Pk2*fd**2*g2*s**2 - 3168*D1**2*Pk2*fd**2*g2*s - 70*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 140*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 70*D1**2*Pkdd2*bdd1*f**3*k1**2 - 280*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 140*D1**2*Pkdd2*f**3*fd*k1**2*s - 70*D1**2*Pkdd2*f**3*fd*k1**2 - 2112*D1*Dd*Pk2*b2*f**2*r*s + 528*D1*Dd*Pk2*b2*f**2*r - 2112*D1*Dd*Pk2*b2*f**2*s**2 + 2112*D1*Dd*Pk2*b2*f**2*s - 528*D1*Dd*Pk2*b2*f**2 + 10560*D1*Dd*Pk2*b2*f*fd*r*s - 3960*D1*Dd*Pk2*b2*f*fd*r + 10560*D1*Dd*Pk2*b2*f*fd*s**2 - 10560*D1*Dd*Pk2*b2*f*fd*s + 2640*D1*Dd*Pk2*b2*f*fd + 5280*D1*Dd*Pk2*bd2*f**2*r*s - 660*D1*Dd*Pk2*bd2*f**2*r + 5280*D1*Dd*Pk2*bd2*f**2*s**2 - 5280*D1*Dd*Pk2*bd2*f**2*s + 660*D1*Dd*Pk2*bd2*f**2 + 6600*D1*Dd*Pk2*f**4*r**2 + 31680*D1*Dd*Pk2*f**4*r*s - 14520*D1*Dd*Pk2*f**4*r + 19800*D1*Dd*Pk2*f**4*s**2 - 25740*D1*Dd*Pk2*f**4*s + 8250*D1*Dd*Pk2*f**4 - 52800*D1*Dd*Pk2*f**3*fd*r**2 - 253440*D1*Dd*Pk2*f**3*fd*r*s + 116160*D1*Dd*Pk2*f**3*fd*r - 158400*D1*Dd*Pk2*f**3*fd*s**2 + 205920*D1*Dd*Pk2*f**3*fd*s - 54780*D1*Dd*Pk2*f**3*fd - 3700*D1*Dd*Pk2*f**3*r**2 - 49112*D1*Dd*Pk2*f**3*r*s + 15978*D1*Dd*Pk2*f**3*r - 26664*D1*Dd*Pk2*f**3*s**2 + 37888*D1*Dd*Pk2*f**3*s - 8516*D1*Dd*Pk2*f**3 + 28920*D1*Dd*Pk2*f**2*fd*r**2 + 244752*D1*Dd*Pk2*f**2*fd*r*s - 95486*D1*Dd*Pk2*f**2*fd*r + 159984*D1*Dd*Pk2*f**2*fd*s**2 - 195304*D1*Dd*Pk2*f**2*fd*s + 48746*D1*Dd*Pk2*f**2*fd - 27456*D1*Dd*Pk2*f**2*g2*r*s + 6864*D1*Dd*Pk2*f**2*g2*r - 1584*D1*Dd*Pk2*f**2*g2*s**2 + 14520*D1*Dd*Pk2*f**2*g2*s - 396*D1*Dd*Pk2*f**2*g2 + 41184*D1*Dd*Pk2*f**2*gd2*r*s - 5148*D1*Dd*Pk2*f**2*gd2*r + 12672*D1*Dd*Pk2*f**2*gd2*s**2 - 34056*D1*Dd*Pk2*f**2*gd2*s + 5148*D1*Dd*Pk2*f**2*gd2 + 82368*D1*Dd*Pk2*f*fd*g2*r*s - 30888*D1*Dd*Pk2*f*fd*g2*r + 25344*D1*Dd*Pk2*f*fd*g2*s**2 - 39600*D1*Dd*Pk2*f*fd*g2*s + 13464*D1*Dd*Pk2*f*fd*g2 - 280*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 140*D1*Dd*Pkdd2*f**4*k1**2*s - 70*D1*Dd*Pkdd2*f**4*k1**2 + 2640*D1*Ddd*Pk2*b2*f**2*r*s - 660*D1*Ddd*Pk2*b2*f**2*r + 2640*D1*Ddd*Pk2*b2*f**2*s**2 - 2640*D1*Ddd*Pk2*b2*f**2*s + 660*D1*Ddd*Pk2*b2*f**2 - 6600*D1*Ddd*Pk2*f**4*r**2 - 31680*D1*Ddd*Pk2*f**4*r*s + 14520*D1*Ddd*Pk2*f**4*r - 19800*D1*Ddd*Pk2*f**4*s**2 + 25740*D1*Ddd*Pk2*f**4*s - 8250*D1*Ddd*Pk2*f**4 + 4820*D1*Ddd*Pk2*f**3*r**2 + 40792*D1*Ddd*Pk2*f**3*r*s - 15018*D1*Ddd*Pk2*f**3*r + 26664*D1*Ddd*Pk2*f**3*s**2 - 33728*D1*Ddd*Pk2*f**3*s + 9076*D1*Ddd*Pk2*f**3 + 20592*D1*Ddd*Pk2*f**2*g2*r*s - 5148*D1*Ddd*Pk2*f**2*g2*r + 6336*D1*Ddd*Pk2*f**2*g2*s**2 - 13464*D1*Ddd*Pk2*f**2*g2*s + 1584*D1*Ddd*Pk2*f**2*g2 - 2*D1*bd1*(D1*(-33*Pk2*f*(fd*(4*C*(r*(92*s - 35) + 120*s**2 - 121*s + 12) - 3*K*(52*r*s - 13*r + 16*s**2 - 34*s + 13) + 80*r**2 + 52*r*s - 15*r - 168*s**2 + 148*s + 57) + 2*g2*(r*(62*s - 38) + 79*s**2 - 110*s + 55) - 4*gd2*(13*r*(4*s - 1) + 71*s**2 - 71*s + 13)) + 132*Pk2*fd*g2*(26*r*(2*s - 1) + s*(71*s - 71)) + 5*f**3*(33*Pk2*(5*r**2 + r*(38*s - 17) + (4 - 5*s)**2) - 14*Pkdd2*k1**2*(s - 1)**2) + 3*f**2*(11*Pk2*(4*C*(2*r*(14*s - 9) + 33*s**2 - 46*s + 23) - 52*K*r*s - 3*K*s**2 + 52*K*s - 10*fd*(21*r**2 + 102*r*s - 50*r + 57*s**2 - 85*s + 21) + 13*r**2 + 6*r*s + 82*r - 51*s**2 + 102*s - 115) + 70*Pkdd2*fd*k1**2*s*(s - 1))) - Dd*f*(33*Pk2*f*(4*C*(r*(184*s - 71) + 240*s**2 - 258*s + 62) - 3*K*(13*r*(8*s - 1) + 32*s**2 - 86*s + 13) + 160*r**2 + 104*r*s + 59*r - 336*s**2 + 366*s - 153) - 132*Pk2*g2*(26*r*(8*s - 3) + 284*s**2 - 303*s + 71) + 10*f**2*(33*Pk2*(28*r**2 + r*(136*s - 69) + 76*s**2 - 117*s + 35) - 7*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 7920*Dd**2*Pk2*b2*f**2*r*s - 1980*Dd**2*Pk2*b2*f**2*r + 7920*Dd**2*Pk2*b2*f**2*s**2 - 7920*Dd**2*Pk2*b2*f**2*s + 1320*Dd**2*Pk2*b2*f**2 - 19800*Dd**2*Pk2*f**4*r**2 - 95040*Dd**2*Pk2*f**4*r*s + 43560*Dd**2*Pk2*f**4*r - 59400*Dd**2*Pk2*f**4*s**2 + 77220*Dd**2*Pk2*f**4*s - 19140*Dd**2*Pk2*f**4 + 14460*Dd**2*Pk2*f**3*r**2 + 122376*Dd**2*Pk2*f**3*r*s - 45054*Dd**2*Pk2*f**3*r + 79992*Dd**2*Pk2*f**3*s**2 - 101184*Dd**2*Pk2*f**3*s + 22806*Dd**2*Pk2*f**3 + 61776*Dd**2*Pk2*f**2*g2*r*s - 15444*Dd**2*Pk2*f**2*g2*r + 19008*Dd**2*Pk2*f**2*g2*s**2 - 40392*Dd**2*Pk2*f**2*g2*s + 10296*Dd**2*Pk2*f**2*g2 + 924*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 66*Pk2*b1**2*(20*C*D1**2*fd*r*s + 20*C*D1**2*fd*s**2 - 20*C*D1**2*fd*s - 24*C*D1**2*fdd*r*s - 24*C*D1**2*fdd*s**2 + 24*C*D1**2*fdd*s + 80*C*D1*Dd*f*r*s - 20*C*D1*Dd*f*r + 80*C*D1*Dd*f*s**2 - 80*C*D1*Dd*f*s + 20*C*D1*Dd*f - 192*C*D1*Dd*fd*r*s + 24*C*D1*Dd*fd*r - 192*C*D1*Dd*fd*s**2 + 192*C*D1*Dd*fd*s - 24*C*D1*Dd*fd - 96*C*D1*Ddd*f*r*s + 24*C*D1*Ddd*f*r - 96*C*D1*Ddd*f*s**2 + 96*C*D1*Ddd*f*s - 24*C*D1*Ddd*f - 288*C*Dd**2*f*r*s + 72*C*Dd**2*f*r - 288*C*Dd**2*f*s**2 + 288*C*Dd**2*f*s - 48*C*Dd**2*f - 62*D1**2*K*fd*r*s + 24*D1**2*K*fd*r - 79*D1**2*K*fd*s**2 + 48*D1**2*K*fd*s - 24*D1**2*K*fd + 52*D1**2*K*fdd*r*s - 26*D1**2*K*fdd*r + 71*D1**2*K*fdd*s**2 - 52*D1**2*K*fdd*s + 26*D1**2*K*fdd - 14*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 112*D1**2*f*fd*r*s + 8*D1**2*f*fd*r + 112*D1**2*f*fd*s**2 - 68*D1**2*f*fd*s - 8*D1**2*f*fd - 80*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r - 80*D1**2*f*fdd*s**2 + 40*D1**2*f*fdd*s + 10*D1**2*f*fdd - 80*D1**2*fd**2*r*s - 10*D1**2*fd**2*r - 80*D1**2*fd**2*s**2 + 40*D1**2*fd**2*s + 10*D1**2*fd**2 + 86*D1**2*fd*r*s - 24*D1**2*fd*r + 103*D1**2*fd*s**2 - 28*D1**2*fd*s + 24*D1**2*fd - 64*D1**2*fdd*r*s + 26*D1**2*fdd*r - 83*D1**2*fdd*s**2 + 28*D1**2*fdd*s - 26*D1**2*fdd - 56*D1**2*gd2*r*s - 56*D1**2*gd2*s**2 + 56*D1**2*gd2*s + 28*D1**2*gdd2*r*s + 28*D1**2*gdd2*s**2 - 28*D1**2*gdd2*s - 248*D1*Dd*K*f*r*s + 62*D1*Dd*K*f*r - 316*D1*Dd*K*f*s**2 + 282*D1*Dd*K*f*s - 79*D1*Dd*K*f + 416*D1*Dd*K*fd*r*s - 156*D1*Dd*K*fd*r + 568*D1*Dd*K*fd*s**2 - 454*D1*Dd*K*fd*s + 104*D1*Dd*K*fd + 224*D1*Dd*f**2*r*s - 56*D1*Dd*f**2*r + 224*D1*Dd*f**2*s**2 - 224*D1*Dd*f**2*s + 56*D1*Dd*f**2 - 640*D1*Dd*f*fd*r*s + 40*D1*Dd*f*fd*r - 640*D1*Dd*f*fd*s**2 + 480*D1*Dd*f*fd*s - 20*D1*Dd*f*fd + 344*D1*Dd*f*r*s - 86*D1*Dd*f*r + 412*D1*Dd*f*s**2 - 378*D1*Dd*f*s + 103*D1*Dd*f - 512*D1*Dd*fd*r*s + 168*D1*Dd*fd*r - 664*D1*Dd*fd*s**2 + 406*D1*Dd*fd*s - 80*D1*Dd*fd - 224*D1*Dd*g2*r*s + 56*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 224*D1*Dd*g2*s - 56*D1*Dd*g2 + 224*D1*Dd*gd2*r*s - 28*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 224*D1*Dd*gd2*s + 28*D1*Dd*gd2 + 208*D1*Ddd*K*f*r*s - 52*D1*Ddd*K*f*r + 284*D1*Ddd*K*f*s**2 - 246*D1*Ddd*K*f*s + 71*D1*Ddd*K*f - 160*D1*Ddd*f**2*r*s + 40*D1*Ddd*f**2*r - 160*D1*Ddd*f**2*s**2 + 160*D1*Ddd*f**2*s - 40*D1*Ddd*f**2 - 256*D1*Ddd*f*r*s + 64*D1*Ddd*f*r - 332*D1*Ddd*f*s**2 + 294*D1*Ddd*f*s - 83*D1*Ddd*f + 112*D1*Ddd*g2*r*s - 28*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 112*D1*Ddd*g2*s + 28*D1*Ddd*g2 + 14*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 624*Dd**2*K*f*r*s - 156*Dd**2*K*f*r + 852*Dd**2*K*f*s**2 - 738*Dd**2*K*f*s + 104*Dd**2*K*f - 480*Dd**2*f**2*r*s + 120*Dd**2*f**2*r - 480*Dd**2*f**2*s**2 + 480*Dd**2*f**2*s - 80*Dd**2*f**2 - 768*Dd**2*f*r*s + 192*Dd**2*f*r - 996*Dd**2*f*s**2 + 882*Dd**2*f*s - 128*Dd**2*f + 336*Dd**2*g2*r*s - 84*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 336*Dd**2*g2*s + 56*Dd**2*g2) - 2*b1*(7392*C*D1**2*Pk2*f*fd*r*s - 1320*C*D1**2*Pk2*f*fd*r + 8712*C*D1**2*Pk2*f*fd*s**2 - 6336*C*D1**2*Pk2*f*fd*s + 1320*C*D1**2*Pk2*f*fd - 6072*C*D1**2*Pk2*f*fdd*r*s + 1452*C*D1**2*Pk2*f*fdd*r - 7920*C*D1**2*Pk2*f*fdd*s**2 + 5940*C*D1**2*Pk2*f*fdd*s - 1452*C*D1**2*Pk2*f*fdd - 6072*C*D1**2*Pk2*fd**2*r*s + 1452*C*D1**2*Pk2*fd**2*r - 7920*C*D1**2*Pk2*fd**2*s**2 + 5940*C*D1**2*Pk2*fd**2*s - 1452*C*D1**2*Pk2*fd**2 + 14784*C*D1*Dd*Pk2*f**2*r*s - 3696*C*D1*Dd*Pk2*f**2*r + 17424*C*D1*Dd*Pk2*f**2*s**2 - 16104*C*D1*Dd*Pk2*f**2*s + 4356*C*D1*Dd*Pk2*f**2 - 48576*C*D1*Dd*Pk2*f*fd*r*s + 11880*C*D1*Dd*Pk2*f*fd*r - 63360*C*D1*Dd*Pk2*f*fd*s**2 + 51744*C*D1*Dd*Pk2*f*fd*s - 8844*C*D1*Dd*Pk2*f*fd - 12144*C*D1*Ddd*Pk2*f**2*r*s + 3036*C*D1*Ddd*Pk2*f**2*r - 15840*C*D1*Ddd*Pk2*f**2*s**2 + 13992*C*D1*Ddd*Pk2*f**2*s - 3960*C*D1*Ddd*Pk2*f**2 - 36432*C*Dd**2*Pk2*f**2*r*s + 9108*C*Dd**2*Pk2*f**2*r - 47520*C*Dd**2*Pk2*f**2*s**2 + 41976*C*Dd**2*Pk2*f**2*s - 6072*C*Dd**2*Pk2*f**2 - 3432*D1**2*K*Pk2*f*fd*r*s + 1716*D1**2*K*Pk2*f*fd*r - 198*D1**2*K*Pk2*f*fd*s**2 + 198*D1**2*K*Pk2*f*fd*s - 99*D1**2*K*Pk2*f*fd + 2574*D1**2*K*Pk2*f*fdd*r*s - 1287*D1**2*K*Pk2*f*fdd*r + 792*D1**2*K*Pk2*f*fdd*s**2 - 792*D1**2*K*Pk2*f*fdd*s + 396*D1**2*K*Pk2*f*fdd + 2574*D1**2*K*Pk2*fd**2*r*s - 1287*D1**2*K*Pk2*fd**2*r + 792*D1**2*K*Pk2*fd**2*s**2 - 792*D1**2*K*Pk2*fd**2*s + 462*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 33*D1**2*Pk2*bdd1*(10*f**2*(r*(8*s - 5) + 8*s**2 - 12*s + 5) + f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-104*r*s + 26*r - 142*s**2 + 142*s - 45) + 128*r*s - 38*r + 166*s**2 - 202*s + 57) - 28*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 2475*D1**2*Pk2*f**2*fd*r**2 + 18810*D1**2*Pk2*f**2*fd*r*s - 6765*D1**2*Pk2*f**2*fd*r + 12375*D1**2*Pk2*f**2*fd*s**2 - 14190*D1**2*Pk2*f**2*fd*s + 3135*D1**2*Pk2*f**2*fd - 3465*D1**2*Pk2*f**2*fdd*r**2 - 16830*D1**2*Pk2*f**2*fdd*r*s + 7095*D1**2*Pk2*f**2*fdd*r - 9405*D1**2*Pk2*f**2*fdd*s**2 + 12210*D1**2*Pk2*f**2*fdd*s - 3135*D1**2*Pk2*f**2*fdd - 6930*D1**2*Pk2*f*fd**2*r**2 - 33660*D1**2*Pk2*f*fd**2*r*s + 14190*D1**2*Pk2*f*fd**2*r - 18810*D1**2*Pk2*f*fd**2*s**2 + 24420*D1**2*Pk2*f*fd**2*s - 6600*D1**2*Pk2*f*fd**2 + 858*D1**2*Pk2*f*fd*r**2 + 396*D1**2*Pk2*f*fd*r*s - 3762*D1**2*Pk2*f*fd*r - 3366*D1**2*Pk2*f*fd*s**2 - 198*D1**2*Pk2*f*fd*s + 2541*D1**2*Pk2*f*fd - 1320*D1**2*Pk2*f*fdd*r**2 - 858*D1**2*Pk2*f*fdd*r*s + 3003*D1**2*Pk2*f*fdd*r + 2772*D1**2*Pk2*f*fdd*s**2 + 198*D1**2*Pk2*f*fdd*s - 2112*D1**2*Pk2*f*fdd - 4092*D1**2*Pk2*f*gd2*r*s - 5214*D1**2*Pk2*f*gd2*s**2 + 4092*D1**2*Pk2*f*gd2*s + 3432*D1**2*Pk2*f*gdd2*r*s + 4686*D1**2*Pk2*f*gdd2*s**2 - 3432*D1**2*Pk2*f*gdd2*s - 1320*D1**2*Pk2*fd**2*r**2 - 858*D1**2*Pk2*fd**2*r*s + 3003*D1**2*Pk2*fd**2*r + 2772*D1**2*Pk2*fd**2*s**2 + 198*D1**2*Pk2*fd**2*s + 1452*D1**2*Pk2*fd**2 - 4092*D1**2*Pk2*fd*g2*r*s + 1584*D1**2*Pk2*fd*g2*r - 5214*D1**2*Pk2*fd*g2*s**2 + 3168*D1**2*Pk2*fd*g2*s - 1584*D1**2*Pk2*fd*g2 + 6864*D1**2*Pk2*fd*gd2*r*s - 1716*D1**2*Pk2*fd*gd2*r + 9372*D1**2*Pk2*fd*gd2*s**2 - 6864*D1**2*Pk2*fd*gd2*s + 1716*D1**2*Pk2*fd*gd2 + 3432*D1**2*Pk2*fdd*g2*r*s - 1716*D1**2*Pk2*fdd*g2*r + 4686*D1**2*Pk2*fdd*g2*s**2 - 3432*D1**2*Pk2*fdd*g2*s + 1716*D1**2*Pk2*fdd*g2 - 210*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 105*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 210*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 6864*D1*Dd*K*Pk2*f**2*r*s + 1716*D1*Dd*K*Pk2*f**2*r - 396*D1*Dd*K*Pk2*f**2*s**2 + 3630*D1*Dd*K*Pk2*f**2*s - 99*D1*Dd*K*Pk2*f**2 + 20592*D1*Dd*K*Pk2*f*fd*r*s - 7722*D1*Dd*K*Pk2*f*fd*r + 6336*D1*Dd*K*Pk2*f*fd*s**2 - 9900*D1*Dd*K*Pk2*f*fd*s + 3366*D1*Dd*K*Pk2*f*fd + 3300*D1*Dd*Pk2*f**3*r**2 + 25080*D1*Dd*Pk2*f**3*r*s - 9570*D1*Dd*Pk2*f**3*r + 16500*D1*Dd*Pk2*f**3*s**2 - 20790*D1*Dd*Pk2*f**3*s + 5775*D1*Dd*Pk2*f**3 - 27720*D1*Dd*Pk2*f**2*fd*r**2 - 134640*D1*Dd*Pk2*f**2*fd*r*s + 59070*D1*Dd*Pk2*f**2*fd*r - 75240*D1*Dd*Pk2*f**2*fd*s**2 + 101310*D1*Dd*Pk2*f**2*fd*s - 26400*D1*Dd*Pk2*f**2*fd + 1716*D1*Dd*Pk2*f**2*r**2 + 792*D1*Dd*Pk2*f**2*r*s - 1914*D1*Dd*Pk2*f**2*r - 6732*D1*Dd*Pk2*f**2*s**2 + 2970*D1*Dd*Pk2*f**2*s - 825*D1*Dd*Pk2*f**2 - 10560*D1*Dd*Pk2*f*fd*r**2 - 6864*D1*Dd*Pk2*f*fd*r*s + 18150*D1*Dd*Pk2*f*fd*r + 22176*D1*Dd*Pk2*f*fd*s**2 - 3036*D1*Dd*Pk2*f*fd*s - 6204*D1*Dd*Pk2*f*fd - 16368*D1*Dd*Pk2*f*g2*r*s + 4092*D1*Dd*Pk2*f*g2*r - 20856*D1*Dd*Pk2*f*g2*s**2 + 18612*D1*Dd*Pk2*f*g2*s - 5214*D1*Dd*Pk2*f*g2 + 27456*D1*Dd*Pk2*f*gd2*r*s - 3432*D1*Dd*Pk2*f*gd2*r + 37488*D1*Dd*Pk2*f*gd2*s**2 - 29964*D1*Dd*Pk2*f*gd2*s + 3432*D1*Dd*Pk2*f*gd2 + 27456*D1*Dd*Pk2*fd*g2*r*s - 10296*D1*Dd*Pk2*fd*g2*r + 37488*D1*Dd*Pk2*fd*g2*s**2 - 29964*D1*Dd*Pk2*fd*g2*s + 6864*D1*Dd*Pk2*fd*g2 - 280*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 140*D1*Dd*Pkdd2*f**3*k1**2*s - 70*D1*Dd*Pkdd2*f**3*k1**2 + 840*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 210*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 5148*D1*Ddd*K*Pk2*f**2*r*s - 1287*D1*Ddd*K*Pk2*f**2*r + 1584*D1*Ddd*K*Pk2*f**2*s**2 - 3366*D1*Ddd*K*Pk2*f**2*s + 396*D1*Ddd*K*Pk2*f**2 - 4620*D1*Ddd*Pk2*f**3*r**2 - 22440*D1*Ddd*Pk2*f**3*r*s + 10230*D1*Ddd*Pk2*f**3*r - 12540*D1*Ddd*Pk2*f**3*s**2 + 17490*D1*Ddd*Pk2*f**3*s - 5445*D1*Ddd*Pk2*f**3 - 2640*D1*Ddd*Pk2*f**2*r**2 - 1716*D1*Ddd*Pk2*f**2*r*s + 3069*D1*Ddd*Pk2*f**2*r + 5544*D1*Ddd*Pk2*f**2*s**2 - 1914*D1*Ddd*Pk2*f**2*s + 66*D1*Ddd*Pk2*f**2 + 13728*D1*Ddd*Pk2*f*g2*r*s - 3432*D1*Ddd*Pk2*f*g2*r + 18744*D1*Ddd*Pk2*f*g2*s**2 - 16236*D1*Ddd*Pk2*f*g2*s + 4686*D1*Ddd*Pk2*f*g2 + 140*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 70*D1*Ddd*Pkdd2*f**3*k1**2*s + 35*D1*Ddd*Pkdd2*f**3*k1**2 - 33*D1*Pk2*bd1*(D1*(4*f**2*(4*r*(7*s - 4) + 28*s**2 - 39*s + 16) + f*(20*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 124*K*r*s + 38*K*r - 158*K*s**2 + 172*K*s - 55*K - 20*fd*(4*s - 1)*(4*r + 4*s - 3) + 172*r*s - 62*r + 206*s**2 - 264*s + 79) - 2*fd*(12*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(-104*r*s + 39*r - 142*s**2 + 123*s - 13) + 128*r*s - 45*r + 166*s**2 - 129*s + 1) - 28*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 28*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd*(10*f**2*(2*r*(16*s - 7) + 32*s**2 - 40*s + 11) + f*(24*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) - K*(4*s - 1)*(104*r + 142*s - 97) + 512*r*s - 140*r + 664*s**2 - 698*s + 139) - 28*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 15444*Dd**2*K*Pk2*f**2*r*s - 3861*Dd**2*K*Pk2*f**2*r + 4752*Dd**2*K*Pk2*f**2*s**2 - 10098*Dd**2*K*Pk2*f**2*s + 2574*Dd**2*K*Pk2*f**2 - 13860*Dd**2*Pk2*f**3*r**2 - 67320*Dd**2*Pk2*f**3*r*s + 30690*Dd**2*Pk2*f**3*r - 37620*Dd**2*Pk2*f**3*s**2 + 52470*Dd**2*Pk2*f**3*s - 13530*Dd**2*Pk2*f**3 - 7920*Dd**2*Pk2*f**2*r**2 - 5148*Dd**2*Pk2*f**2*r*s + 9207*Dd**2*Pk2*f**2*r + 16632*Dd**2*Pk2*f**2*s**2 - 5742*Dd**2*Pk2*f**2*s - 2178*Dd**2*Pk2*f**2 + 41184*Dd**2*Pk2*f*g2*r*s - 10296*Dd**2*Pk2*f*g2*r + 56232*Dd**2*Pk2*f*g2*s**2 - 48708*Dd**2*Pk2*f*g2*s + 6864*Dd**2*Pk2*f*g2 + 420*Dd**2*Pkdd2*f**3*k1**2*s**2 - 210*Dd**2*Pkdd2*f**3*k1**2*s))/(693*d**2*k2*k3**4) - D1**2*Pk3*ct**3*k1*k2*st**2*(1584*C*D1**2*Pk2*bdd1*f**2*r**2 - 1584*C*D1**2*Pk2*bdd1*f**2*r - 3168*C*D1**2*Pk2*bdd1*f**2*s**2 + 10680*C*D1**2*Pk2*f**2*fd*r**2 - 41904*C*D1**2*Pk2*f**2*fd*r*s + 6848*C*D1**2*Pk2*f**2*fd*r - 64632*C*D1**2*Pk2*f**2*fd*s**2 + 57056*C*D1**2*Pk2*f**2*fd*s - 17984*C*D1**2*Pk2*f**2*fd - 8904*C*D1**2*Pk2*f**2*fdd*r**2 + 28080*C*D1**2*Pk2*f**2*fdd*r*s - 3424*C*D1**2*Pk2*f**2*fdd*r + 45384*C*D1**2*Pk2*f**2*fdd*s**2 - 39616*C*D1**2*Pk2*f**2*fdd*s + 12160*C*D1**2*Pk2*f**2*fdd - 17808*C*D1**2*Pk2*f*fd**2*r**2 + 56160*C*D1**2*Pk2*f*fd**2*r*s - 6848*C*D1**2*Pk2*f*fd**2*r + 90768*C*D1**2*Pk2*f*fd**2*s**2 - 79232*C*D1**2*Pk2*f*fd**2*s + 9360*C*D1**2*Pk2*f*fd**2 - 198*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 396*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 198*C*D1**2*Pkdd2*bdd1*f**2*k1**2 + 1206*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 804*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 402*C*D1**2*Pkdd2*f**2*fd*k1**2 - 900*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 600*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 300*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 1800*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 1200*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 14240*C*D1*Dd*Pk2*f**3*r**2 - 55872*C*D1*Dd*Pk2*f**3*r*s - 272*C*D1*Dd*Pk2*f**3*r - 86176*C*D1*Dd*Pk2*f**3*s**2 + 71024*C*D1*Dd*Pk2*f**3*s - 14424*C*D1*Dd*Pk2*f**3 - 71232*C*D1*Dd*Pk2*f**2*fd*r**2 + 224640*C*D1*Dd*Pk2*f**2*fd*r*s - 6160*C*D1*Dd*Pk2*f**2*fd*r + 363072*C*D1*Dd*Pk2*f**2*fd*s**2 - 305392*C*D1*Dd*Pk2*f**2*fd*s + 46464*C*D1*Dd*Pk2*f**2*fd + 1608*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 804*C*D1*Dd*Pkdd2*f**3*k1**2*s + 402*C*D1*Dd*Pkdd2*f**3*k1**2 - 7200*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 4200*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 600*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 11872*C*D1*Ddd*Pk2*f**3*r**2 + 37440*C*D1*Ddd*Pk2*f**3*r*s + 2512*C*D1*Ddd*Pk2*f**3*r + 60512*C*D1*Ddd*Pk2*f**3*s**2 - 48976*C*D1*Ddd*Pk2*f**3*s + 9192*C*D1*Ddd*Pk2*f**3 - 1200*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 600*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 300*C*D1*Ddd*Pkdd2*f**3*k1**2 - 35616*C*Dd**2*Pk2*f**3*r**2 + 112320*C*Dd**2*Pk2*f**3*r*s + 7536*C*Dd**2*Pk2*f**3*r + 181536*C*Dd**2*Pk2*f**3*s**2 - 146928*C*Dd**2*Pk2*f**3*s + 12784*C*Dd**2*Pk2*f**3 - 3600*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1800*C*Dd**2*Pkdd2*f**3*k1**2*s - 1452*D1**2*K*Pk2*bdd1*f**2*r**2 + 5544*D1**2*K*Pk2*bdd1*f**2*r*s + 2904*D1**2*K*Pk2*bdd1*f**2*r + 8844*D1**2*K*Pk2*bdd1*f**2*s**2 - 5544*D1**2*K*Pk2*bdd1*f**2*s - 1452*D1**2*K*Pk2*bdd1*f**2 - 198*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 14256*D1**2*Pk2*b2*f*fd*r*s + 7128*D1**2*Pk2*b2*f*fd*r - 14256*D1**2*Pk2*b2*f*fd*s**2 + 14256*D1**2*Pk2*b2*f*fd*s - 7128*D1**2*Pk2*b2*f*fd + 7920*D1**2*Pk2*b2*f*fdd*r*s - 3960*D1**2*Pk2*b2*f*fdd*r + 7920*D1**2*Pk2*b2*f*fdd*s**2 - 7920*D1**2*Pk2*b2*f*fdd*s + 3960*D1**2*Pk2*b2*f*fdd + 7920*D1**2*Pk2*b2*fd**2*r*s - 3960*D1**2*Pk2*b2*fd**2*r + 7920*D1**2*Pk2*b2*fd**2*s**2 - 7920*D1**2*Pk2*b2*fd**2*s - 7128*D1**2*Pk2*bd2*f**2*r*s - 7128*D1**2*Pk2*bd2*f**2*s**2 + 7128*D1**2*Pk2*bd2*f**2*s + 15840*D1**2*Pk2*bd2*f*fd*r*s - 3960*D1**2*Pk2*bd2*f*fd*r + 15840*D1**2*Pk2*bd2*f*fd*s**2 - 15840*D1**2*Pk2*bd2*f*fd*s + 3960*D1**2*Pk2*bd2*f*fd + 4950*D1**2*Pk2*bdd1*f**3*r**2 + 5940*D1**2*Pk2*bdd1*f**3*r*s - 8580*D1**2*Pk2*bdd1*f**3*r - 3300*D1**2*Pk2*bdd1*f**3*s + 3630*D1**2*Pk2*bdd1*f**3 + 2838*D1**2*Pk2*bdd1*f**2*r**2 + 4356*D1**2*Pk2*bdd1*f**2*r*s - 6468*D1**2*Pk2*bdd1*f**2*r + 1584*D1**2*Pk2*bdd1*f**2*s**2 - 4356*D1**2*Pk2*bdd1*f**2*s + 3630*D1**2*Pk2*bdd1*f**2 - 1584*D1**2*Pk2*bdd1*f*g2*r**2 + 1584*D1**2*Pk2*bdd1*f*g2*r + 3168*D1**2*Pk2*bdd1*f*g2*s**2 + 3960*D1**2*Pk2*bdd2*f**2*r*s + 3960*D1**2*Pk2*bdd2*f**2*s**2 - 3960*D1**2*Pk2*bdd2*f**2*s + 11880*D1**2*Pk2*f**3*fd*r**2 + 15840*D1**2*Pk2*f**3*fd*r*s - 15840*D1**2*Pk2*f**3*fd*r - 7920*D1**2*Pk2*f**3*fd*s + 5940*D1**2*Pk2*f**3*fd - 11880*D1**2*Pk2*f**3*fdd*r**2 - 15840*D1**2*Pk2*f**3*fdd*r*s + 15840*D1**2*Pk2*f**3*fdd*r + 7920*D1**2*Pk2*f**3*fdd*s - 5940*D1**2*Pk2*f**3*fdd - 35640*D1**2*Pk2*f**2*fd**2*r**2 - 47520*D1**2*Pk2*f**2*fd**2*r*s + 47520*D1**2*Pk2*f**2*fd**2*r + 23760*D1**2*Pk2*f**2*fd**2*s - 13860*D1**2*Pk2*f**2*fd**2 - 21354*D1**2*Pk2*f**2*fd*r**2 - 3420*D1**2*Pk2*f**2*fd*r*s + 15376*D1**2*Pk2*f**2*fd*r + 29940*D1**2*Pk2*f**2*fd*s**2 - 18820*D1**2*Pk2*f**2*fd*s + 2862*D1**2*Pk2*f**2*fd + 18102*D1**2*Pk2*f**2*fdd*r**2 + 3492*D1**2*Pk2*f**2*fdd*r*s - 13232*D1**2*Pk2*f**2*fdd*r - 22692*D1**2*Pk2*f**2*fdd*s**2 + 13964*D1**2*Pk2*f**2*fdd*s - 1530*D1**2*Pk2*f**2*fdd - 4224*D1**2*Pk2*f**2*gd2*r**2 + 20592*D1**2*Pk2*f**2*gd2*r*s + 8448*D1**2*Pk2*f**2*gd2*r + 26664*D1**2*Pk2*f**2*gd2*s**2 - 20592*D1**2*Pk2*f**2*gd2*s - 4224*D1**2*Pk2*f**2*gd2 + 2904*D1**2*Pk2*f**2*gdd2*r**2 - 11088*D1**2*Pk2*f**2*gdd2*r*s - 5808*D1**2*Pk2*f**2*gdd2*r - 17688*D1**2*Pk2*f**2*gdd2*s**2 + 11088*D1**2*Pk2*f**2*gdd2*s + 2904*D1**2*Pk2*f**2*gdd2 + 36204*D1**2*Pk2*f*fd**2*r**2 + 6984*D1**2*Pk2*f*fd**2*r*s - 26464*D1**2*Pk2*f*fd**2*r - 45384*D1**2*Pk2*f*fd**2*s**2 + 27928*D1**2*Pk2*f*fd**2*s + 1164*D1**2*Pk2*f*fd**2 - 8448*D1**2*Pk2*f*fd*g2*r**2 + 41184*D1**2*Pk2*f*fd*g2*r*s - 20592*D1**2*Pk2*f*fd*g2*r + 53328*D1**2*Pk2*f*fd*g2*s**2 - 53328*D1**2*Pk2*f*fd*g2*s + 26664*D1**2*Pk2*f*fd*g2 + 11616*D1**2*Pk2*f*fd*gd2*r**2 - 44352*D1**2*Pk2*f*fd*gd2*r*s - 528*D1**2*Pk2*f*fd*gd2*r - 70752*D1**2*Pk2*f*fd*gd2*s**2 + 57552*D1**2*Pk2*f*fd*gd2*s - 11088*D1**2*Pk2*f*fd*gd2 + 5808*D1**2*Pk2*f*fdd*g2*r**2 - 22176*D1**2*Pk2*f*fdd*g2*r*s + 11088*D1**2*Pk2*f*fdd*g2*r - 35376*D1**2*Pk2*f*fdd*g2*s**2 + 35376*D1**2*Pk2*f*fdd*g2*s - 17688*D1**2*Pk2*f*fdd*g2 + 5808*D1**2*Pk2*fd**2*g2*r**2 - 22176*D1**2*Pk2*fd**2*g2*r*s + 11088*D1**2*Pk2*fd**2*g2*r - 35376*D1**2*Pk2*fd**2*g2*s**2 + 35376*D1**2*Pk2*fd**2*g2*s + 750*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 375*D1**2*Pkdd2*bdd1*f**3*k1**2 + 297*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 396*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 198*D1**2*Pkdd2*bdd1*f**2*k1**2 + 198*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 396*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 198*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 1500*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 750*D1**2*Pkdd2*f**3*fd*k1**2*s - 375*D1**2*Pkdd2*f**3*fd*k1**2 - 756*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 504*D1**2*Pkdd2*f**2*fd*k1**2*s - 252*D1**2*Pkdd2*f**2*fd*k1**2 + 675*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 450*D1**2*Pkdd2*f**2*fdd*k1**2*s + 225*D1**2*Pkdd2*f**2*fdd*k1**2 - 594*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 396*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 1350*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 900*D1**2*Pkdd2*f*fd**2*k1**2*s - 1188*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 1188*D1**2*Pkdd2*f*fd*g2*k1**2*s - 594*D1**2*Pkdd2*f*fd*g2*k1**2 + 1584*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 792*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 792*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 792*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 396*D1**2*Pkdd2*f*fdd*g2*k1**2 + 792*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 792*D1**2*Pkdd2*fd**2*g2*k1**2*s + 66*D1**2*bd1**2*f*(4*Pk2*(3*K*(2*r**2 - 3*r - 4*s**2 + 1) + 5*f*(r + 2*s - 1) - (6*r - 6)*(r + 2*s - 1)) + 3*Pkdd2*k1**2*s*(-K*s + K + s - 1)) - 28512*D1*Dd*Pk2*b2*f**2*r*s + 7128*D1*Dd*Pk2*b2*f**2*r - 28512*D1*Dd*Pk2*b2*f**2*s**2 + 28512*D1*Dd*Pk2*b2*f**2*s - 7128*D1*Dd*Pk2*b2*f**2 + 63360*D1*Dd*Pk2*b2*f*fd*r*s - 23760*D1*Dd*Pk2*b2*f*fd*r + 63360*D1*Dd*Pk2*b2*f*fd*s**2 - 63360*D1*Dd*Pk2*b2*f*fd*s + 15840*D1*Dd*Pk2*b2*f*fd + 31680*D1*Dd*Pk2*bd2*f**2*r*s - 3960*D1*Dd*Pk2*bd2*f**2*r + 31680*D1*Dd*Pk2*bd2*f**2*s**2 - 31680*D1*Dd*Pk2*bd2*f**2*s + 3960*D1*Dd*Pk2*bd2*f**2 + 11880*D1*Dd*Pk2*f**4*r**2 + 15840*D1*Dd*Pk2*f**4*r*s - 15840*D1*Dd*Pk2*f**4*r - 7920*D1*Dd*Pk2*f**4*s + 5940*D1*Dd*Pk2*f**4 - 95040*D1*Dd*Pk2*f**3*fd*r**2 - 126720*D1*Dd*Pk2*f**3*fd*r*s + 126720*D1*Dd*Pk2*f**3*fd*r + 63360*D1*Dd*Pk2*f**3*fd*s - 39600*D1*Dd*Pk2*f**3*fd - 28472*D1*Dd*Pk2*f**3*r**2 - 4560*D1*Dd*Pk2*f**3*r*s + 29612*D1*Dd*Pk2*f**3*r + 39920*D1*Dd*Pk2*f**3*s**2 - 17680*D1*Dd*Pk2*f**3*s - 4256*D1*Dd*Pk2*f**3 + 144816*D1*Dd*Pk2*f**2*fd*r**2 + 27936*D1*Dd*Pk2*f**2*fd*r*s - 128828*D1*Dd*Pk2*f**2*fd*r - 181536*D1*Dd*Pk2*f**2*fd*s**2 + 94256*D1*Dd*Pk2*f**2*fd*s + 12500*D1*Dd*Pk2*f**2*fd - 16896*D1*Dd*Pk2*f**2*g2*r**2 + 82368*D1*Dd*Pk2*f**2*g2*r*s - 3696*D1*Dd*Pk2*f**2*g2*r + 106656*D1*Dd*Pk2*f**2*g2*s**2 - 94512*D1*Dd*Pk2*f**2*g2*s + 18216*D1*Dd*Pk2*f**2*g2 + 23232*D1*Dd*Pk2*f**2*gd2*r**2 - 88704*D1*Dd*Pk2*f**2*gd2*r*s - 23760*D1*Dd*Pk2*f**2*gd2*r - 141504*D1*Dd*Pk2*f**2*gd2*s**2 + 101904*D1*Dd*Pk2*f**2*gd2*s + 528*D1*Dd*Pk2*f**2*gd2 + 46464*D1*Dd*Pk2*f*fd*g2*r**2 - 177408*D1*Dd*Pk2*f*fd*g2*r*s + 43296*D1*Dd*Pk2*f*fd*g2*r - 283008*D1*Dd*Pk2*f*fd*g2*s**2 + 256608*D1*Dd*Pk2*f*fd*g2*s - 57552*D1*Dd*Pk2*f*fd*g2 - 1500*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 750*D1*Dd*Pkdd2*f**4*k1**2*s - 375*D1*Dd*Pkdd2*f**4*k1**2 - 1008*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 504*D1*Dd*Pkdd2*f**3*k1**2*s - 252*D1*Dd*Pkdd2*f**3*k1**2 + 5400*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 3150*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 450*D1*Dd*Pkdd2*f**2*fd*k1**2 - 2376*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 1188*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 594*D1*Dd*Pkdd2*f**2*g2*k1**2 + 3168*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 792*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 6336*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 4752*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 792*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 15840*D1*Ddd*Pk2*b2*f**2*r*s - 3960*D1*Ddd*Pk2*b2*f**2*r + 15840*D1*Ddd*Pk2*b2*f**2*s**2 - 15840*D1*Ddd*Pk2*b2*f**2*s + 3960*D1*Ddd*Pk2*b2*f**2 - 11880*D1*Ddd*Pk2*f**4*r**2 - 15840*D1*Ddd*Pk2*f**4*r*s + 15840*D1*Ddd*Pk2*f**4*r + 7920*D1*Ddd*Pk2*f**4*s - 5940*D1*Ddd*Pk2*f**4 + 24136*D1*Ddd*Pk2*f**3*r**2 + 4656*D1*Ddd*Pk2*f**3*r*s - 25300*D1*Ddd*Pk2*f**3*r - 30256*D1*Ddd*Pk2*f**3*s**2 + 12800*D1*Ddd*Pk2*f**3*s + 4504*D1*Ddd*Pk2*f**3 + 11616*D1*Ddd*Pk2*f**2*g2*r**2 - 44352*D1*Ddd*Pk2*f**2*g2*r*s - 528*D1*Ddd*Pk2*f**2*g2*r - 70752*D1*Ddd*Pk2*f**2*g2*s**2 + 57552*D1*Ddd*Pk2*f**2*g2*s - 11880*D1*Ddd*Pk2*f**2*g2 + 900*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 450*D1*Ddd*Pkdd2*f**3*k1**2*s + 225*D1*Ddd*Pkdd2*f**3*k1**2 + 1584*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 792*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 396*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 3*D1*bd1*(D1*(10*f**3*(11*Pk2*(13*r**2 + 22*r*(s - 1) + 4*s**2 - 14*s + 9) + 25*Pkdd2*k1**2*(2*s - 1)) - f**2*(22*Pk2*(-40*C*r**2 + 16*C*r*s + 40*C*r + 96*C*s**2 + 2*K*(16*r**2 - 78*r*s - 32*r - 101*s**2 + 78*s + 16) + 10*fd*(45*r**2 + r*(54*s - 65) - 28*s + 20) - 55*r**2 - 94*r*s + 126*r - 60*s**2 + 78*s - 71) + Pkdd2*k1**2*(132*C*(s - 1)**2 + s**2*(99*K - 165) + s*(500*fd + 264) - 132)) - 22*f*(-48*Pk2*g2*(-r**2 + r + 2*s**2) - 24*Pk2*gd2*(2*r**2 - 3*r - 4*s**2 + 1) - 6*Pkdd2*g2*k1**2*(s - 1)**2 + 6*Pkdd2*gd2*k1**2*s*(s - 1) + fd*(2*Pk2*(12*C*(4*r**2 - 3*r - 8*s**2 + 4*s + 1) + 2*K*(-22*r**2 + 84*r*s + r + 134*s**2 - 109*s + 21) + 86*r**2 + 132*r*s - 125*r + 48*s**2 - 90*s + 27) - 3*Pkdd2*k1**2*s*(4*C*(s - 1) + K*(4*s - 2) - 6*s + 5))) + 132*fd*g2*(8*Pk2*(r**2 - s*(2*s - 2)) - Pkdd2*k1**2*s*(s - 1))) - 2*Dd*f*(5*f**2*(22*Pk2*(60*r**2 + r*(72*s - 91) - 38*s + 31) + 25*Pkdd2*k1**2*(4*s - 1)) + 11*f*(2*Pk2*(24*C*(4*r**2 - 4*r - 8*s**2 + 2*s + 1) + K*(-88*r**2 + 336*r*s + 90*r + 536*s**2 - 386*s - 2) + 172*r**2 + 264*r*s - 315*r + 96*s**2 - 222*s + 131) - 3*Pkdd2*k1**2*(4*s - 1)*(2*C*(s - 1) + s*(2*K - 3) + 2)) + 66*g2*(-8*Pk2*(4*r**2 - 4*r - 8*s**2 + 2*s + 1) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 47520*Dd**2*Pk2*b2*f**2*r*s - 11880*Dd**2*Pk2*b2*f**2*r + 47520*Dd**2*Pk2*b2*f**2*s**2 - 47520*Dd**2*Pk2*b2*f**2*s + 7920*Dd**2*Pk2*b2*f**2 - 35640*Dd**2*Pk2*f**4*r**2 - 47520*Dd**2*Pk2*f**4*r*s + 47520*Dd**2*Pk2*f**4*r + 23760*Dd**2*Pk2*f**4*s - 13860*Dd**2*Pk2*f**4 + 72408*Dd**2*Pk2*f**3*r**2 + 13968*Dd**2*Pk2*f**3*r*s - 75900*Dd**2*Pk2*f**3*r - 90768*Dd**2*Pk2*f**3*s**2 + 38400*Dd**2*Pk2*f**3*s + 14396*Dd**2*Pk2*f**3 + 34848*Dd**2*Pk2*f**2*g2*r**2 - 133056*Dd**2*Pk2*f**2*g2*r*s - 1584*Dd**2*Pk2*f**2*g2*r - 212256*Dd**2*Pk2*f**2*g2*s**2 + 172656*Dd**2*Pk2*f**2*g2*s - 16368*Dd**2*Pk2*f**2*g2 + 2700*Dd**2*Pkdd2*f**3*k1**2*s**2 - 1350*Dd**2*Pkdd2*f**3*k1**2*s + 4752*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 2376*Dd**2*Pkdd2*f**2*g2*k1**2*s + 33*b1**2*(D1**2*(-40*Pk2*fd**2*(r + 2*s - 1) + 16*Pk2*fd*(-3*K*(r**2 + r - 2*(s - 1)**2) + 5*f*(r + 2*s - 1) + (3*r + 3)*(r + 2*s - 1)) - 8*Pk2*fdd*(-3*K*(r**2 + r - 2*(s - 1)**2) + 5*f*(r + 2*s - 1) + (3*r + 3)*(r + 2*s - 1)) + 6*Pkdd2*fd*k1**2*s**2*(K - 1) - 3*Pkdd2*fdd*k1**2*s**2*(K - 1)) - D1*(2*Dd*f*(16*Pk2*(5*fd*(r + 2*s - 1) + r**2*(6*K - 6) - 3*r*(2*K + 4*s - 3) - (6*s - 3)*(2*K*s - 1)) + Pkdd2*k1**2*(3 - 3*K)*(4*s**2 - 2*s + 1)) + 6*Dd*fd*(-8*K*Pk2*(4*r**2 - 8*s**2 + 10*s - 3) + 8*Pk2*(4*r + 1)*(r + 2*s - 1) + Pkdd2*k1**2*s*(K - 1)*(4*s - 1)) - 48*Ddd*Pk2*f*(r**2*(2*K - 2) + r*(-2*K - 4*s + 3) - (2*s - 1)*(2*K*s - 1)) + 3*Ddd*Pkdd2*f*k1**2*(K - 1)*(4*s**2 - 2*s + 1)) + 6*Dd**2*f*(8*Pk2*(K*(6*r**2 - 6*r - 12*s**2 + 6*s + 1) + (3 - 6*r)*(r + 2*s - 1)) + 3*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1))) - 3*b1*(1760*C*D1**2*Pk2*f*fd*r**2 - 704*C*D1**2*Pk2*f*fd*r*s - 528*C*D1**2*Pk2*f*fd*r - 4224*C*D1**2*Pk2*f*fd*s**2 + 4576*C*D1**2*Pk2*f*fd*s - 1232*C*D1**2*Pk2*f*fd - 1056*C*D1**2*Pk2*f*fdd*r**2 + 528*C*D1**2*Pk2*f*fdd*r + 2112*C*D1**2*Pk2*f*fdd*s**2 - 2112*C*D1**2*Pk2*f*fdd*s + 528*C*D1**2*Pk2*f*fdd - 1056*C*D1**2*Pk2*fd**2*r**2 + 528*C*D1**2*Pk2*fd**2*r + 2112*C*D1**2*Pk2*fd**2*s**2 - 2112*C*D1**2*Pk2*fd**2*s + 528*C*D1**2*Pk2*fd**2 - 264*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 132*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 132*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 3520*C*D1*Dd*Pk2*f**2*r**2 - 1408*C*D1*Dd*Pk2*f**2*r*s - 3168*C*D1*Dd*Pk2*f**2*r - 8448*C*D1*Dd*Pk2*f**2*s**2 + 4928*C*D1*Dd*Pk2*f**2*s - 352*C*D1*Dd*Pk2*f**2 - 8448*C*D1*Dd*Pk2*f*fd*r**2 + 6336*C*D1*Dd*Pk2*f*fd*r + 16896*C*D1*Dd*Pk2*f*fd*s**2 - 12672*C*D1*Dd*Pk2*f*fd*s + 1056*C*D1*Dd*Pk2*f*fd - 528*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 264*C*D1*Dd*Pkdd2*f**2*k1**2*s - 132*C*D1*Dd*Pkdd2*f**2*k1**2 + 1056*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 264*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 2112*C*D1*Ddd*Pk2*f**2*r**2 + 2112*C*D1*Ddd*Pk2*f**2*r + 4224*C*D1*Ddd*Pk2*f**2*s**2 - 2112*C*D1*Ddd*Pk2*f**2*s + 264*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 132*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 66*C*D1*Ddd*Pkdd2*f**2*k1**2 - 6336*C*Dd**2*Pk2*f**2*r**2 + 6336*C*Dd**2*Pk2*f**2*r + 12672*C*Dd**2*Pk2*f**2*s**2 - 6336*C*Dd**2*Pk2*f**2*s - 1056*C*Dd**2*Pk2*f**2 + 792*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 396*C*Dd**2*Pkdd2*f**2*k1**2*s - 1408*D1**2*K*Pk2*f*fd*r**2 + 6864*D1**2*K*Pk2*f*fd*r*s - 3432*D1**2*K*Pk2*f*fd*r + 8888*D1**2*K*Pk2*f*fd*s**2 - 8888*D1**2*K*Pk2*f*fd*s + 4444*D1**2*K*Pk2*f*fd + 968*D1**2*K*Pk2*f*fdd*r**2 - 3696*D1**2*K*Pk2*f*fdd*r*s + 1848*D1**2*K*Pk2*f*fdd*r - 5896*D1**2*K*Pk2*f*fdd*s**2 + 5896*D1**2*K*Pk2*f*fdd*s - 2948*D1**2*K*Pk2*f*fdd + 968*D1**2*K*Pk2*fd**2*r**2 - 3696*D1**2*K*Pk2*fd**2*r*s + 1848*D1**2*K*Pk2*fd**2*r - 5896*D1**2*K*Pk2*fd**2*s**2 + 5896*D1**2*K*Pk2*fd**2*s - 198*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 198*D1**2*K*Pkdd2*f*fd*k1**2*s - 99*D1**2*K*Pkdd2*f*fd*k1**2 + 132*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 132*D1**2*K*Pkdd2*f*fdd*k1**2*s + 66*D1**2*K*Pkdd2*f*fdd*k1**2 + 132*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 132*D1**2*K*Pkdd2*fd**2*k1**2*s + 4290*D1**2*Pk2*f**2*fd*r**2 + 7260*D1**2*Pk2*f**2*fd*r*s - 5720*D1**2*Pk2*f**2*fd*r + 1320*D1**2*Pk2*f**2*fd*s**2 - 4180*D1**2*Pk2*f**2*fd*s + 2310*D1**2*Pk2*f**2*fd - 4950*D1**2*Pk2*f**2*fdd*r**2 - 5940*D1**2*Pk2*f**2*fdd*r*s + 5720*D1**2*Pk2*f**2*fdd*r + 2860*D1**2*Pk2*f**2*fdd*s - 2090*D1**2*Pk2*f**2*fdd - 9900*D1**2*Pk2*f*fd**2*r**2 - 11880*D1**2*Pk2*f*fd**2*r*s + 11440*D1**2*Pk2*f*fd**2*r + 5720*D1**2*Pk2*f*fd**2*s - 2860*D1**2*Pk2*f*fd**2 + 2420*D1**2*Pk2*f*fd*r**2 + 4136*D1**2*Pk2*f*fd*r*s - 1716*D1**2*Pk2*f*fd*r + 2640*D1**2*Pk2*f*fd*s**2 - 2992*D1**2*Pk2*f*fd*s + 968*D1**2*Pk2*f*fd - 1892*D1**2*Pk2*f*fdd*r**2 - 2904*D1**2*Pk2*f*fdd*r*s + 1188*D1**2*Pk2*f*fdd*r - 1056*D1**2*Pk2*f*fdd*s**2 + 1056*D1**2*Pk2*f*fdd*s - 264*D1**2*Pk2*f*fdd - 1056*D1**2*Pk2*f*gd2*r**2 + 2112*D1**2*Pk2*f*gd2*r + 2112*D1**2*Pk2*f*gd2*s**2 - 1056*D1**2*Pk2*f*gd2 + 528*D1**2*Pk2*f*gdd2*r**2 - 1056*D1**2*Pk2*f*gdd2*r - 1056*D1**2*Pk2*f*gdd2*s**2 + 528*D1**2*Pk2*f*gdd2 - 1892*D1**2*Pk2*fd**2*r**2 - 2904*D1**2*Pk2*fd**2*r*s + 1188*D1**2*Pk2*fd**2*r - 1056*D1**2*Pk2*fd**2*s**2 + 1056*D1**2*Pk2*fd**2*s - 264*D1**2*Pk2*fd**2 - 1056*D1**2*Pk2*fd*g2*r**2 - 1056*D1**2*Pk2*fd*g2*r + 2112*D1**2*Pk2*fd*g2*s**2 - 4224*D1**2*Pk2*fd*g2*s + 2112*D1**2*Pk2*fd*g2 + 1056*D1**2*Pk2*fd*gd2*r**2 - 528*D1**2*Pk2*fd*gd2*r - 2112*D1**2*Pk2*fd*gd2*s**2 + 2112*D1**2*Pk2*fd*gd2*s - 528*D1**2*Pk2*fd*gd2 + 528*D1**2*Pk2*fdd*g2*r**2 + 528*D1**2*Pk2*fdd*g2*r - 1056*D1**2*Pk2*fdd*g2*s**2 + 2112*D1**2*Pk2*fdd*g2*s - 1056*D1**2*Pk2*fdd*g2 - 500*D1**2*Pkdd2*f**2*fd*k1**2*s + 250*D1**2*Pkdd2*f**2*fd*k1**2 + 250*D1**2*Pkdd2*f**2*fdd*k1**2*s - 125*D1**2*Pkdd2*f**2*fdd*k1**2 + 500*D1**2*Pkdd2*f*fd**2*k1**2*s + 330*D1**2*Pkdd2*f*fd*k1**2*s**2 - 66*D1**2*Pkdd2*f*fd*k1**2*s + 33*D1**2*Pkdd2*f*fd*k1**2 - 198*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 66*D1**2*Pkdd2*f*fdd*k1**2*s - 33*D1**2*Pkdd2*f*fdd*k1**2 + 132*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 66*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 198*D1**2*Pkdd2*fd**2*k1**2*s**2 + 66*D1**2*Pkdd2*fd**2*k1**2*s + 132*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 132*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 66*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 11*D1**2*bdd1*f*(8*Pk2*(3*K*(2*r**2 - 3*r - 4*s**2 + 1) + 5*f*(r + 2*s - 1) - (6*r - 6)*(r + 2*s - 1)) + Pkdd2*k1**2*(3 - 3*K)*(2*s**2 - 2*s + 1)) - 2816*D1*Dd*K*Pk2*f**2*r**2 + 13728*D1*Dd*K*Pk2*f**2*r*s - 616*D1*Dd*K*Pk2*f**2*r + 17776*D1*Dd*K*Pk2*f**2*s**2 - 15752*D1*Dd*K*Pk2*f**2*s + 3036*D1*Dd*K*Pk2*f**2 + 7744*D1*Dd*K*Pk2*f*fd*r**2 - 29568*D1*Dd*K*Pk2*f*fd*r*s + 7216*D1*Dd*K*Pk2*f*fd*r - 47168*D1*Dd*K*Pk2*f*fd*s**2 + 42768*D1*Dd*K*Pk2*f*fd*s - 9592*D1*Dd*K*Pk2*f*fd - 396*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 198*D1*Dd*K*Pkdd2*f**2*k1**2*s - 99*D1*Dd*K*Pkdd2*f**2*k1**2 + 1056*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 792*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 132*D1*Dd*K*Pkdd2*f*fd*k1**2 + 5720*D1*Dd*Pk2*f**3*r**2 + 9680*D1*Dd*Pk2*f**3*r*s - 8140*D1*Dd*Pk2*f**3*r + 1760*D1*Dd*Pk2*f**3*s**2 - 5720*D1*Dd*Pk2*f**3*s + 3300*D1*Dd*Pk2*f**3 - 39600*D1*Dd*Pk2*f**2*fd*r**2 - 47520*D1*Dd*Pk2*f**2*fd*r*s + 48620*D1*Dd*Pk2*f**2*fd*r + 23320*D1*Dd*Pk2*f**2*fd*s - 14300*D1*Dd*Pk2*f**2*fd + 4840*D1*Dd*Pk2*f**2*r**2 + 8272*D1*Dd*Pk2*f**2*r*s - 6908*D1*Dd*Pk2*f**2*r + 5280*D1*Dd*Pk2*f**2*s**2 - 6776*D1*Dd*Pk2*f**2*s + 3740*D1*Dd*Pk2*f**2 - 15136*D1*Dd*Pk2*f*fd*r**2 - 23232*D1*Dd*Pk2*f*fd*r*s + 15224*D1*Dd*Pk2*f*fd*r - 8448*D1*Dd*Pk2*f*fd*s**2 + 12144*D1*Dd*Pk2*f*fd*s - 3432*D1*Dd*Pk2*f*fd - 4224*D1*Dd*Pk2*f*g2*r**2 + 4224*D1*Dd*Pk2*f*g2*r + 8448*D1*Dd*Pk2*f*g2*s**2 - 4224*D1*Dd*Pk2*f*g2*s + 4224*D1*Dd*Pk2*f*gd2*r**2 - 6336*D1*Dd*Pk2*f*gd2*r - 8448*D1*Dd*Pk2*f*gd2*s**2 + 2112*D1*Dd*Pk2*f*gd2*s + 2112*D1*Dd*Pk2*f*gd2 + 4224*D1*Dd*Pk2*fd*g2*r**2 - 8448*D1*Dd*Pk2*fd*g2*s**2 + 10560*D1*Dd*Pk2*fd*g2*s - 3168*D1*Dd*Pk2*fd*g2 + 1000*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 250*D1*Dd*Pkdd2*f**2*fd*k1**2 + 660*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 330*D1*Dd*Pkdd2*f**2*k1**2*s + 165*D1*Dd*Pkdd2*f**2*k1**2 - 1584*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 660*D1*Dd*Pkdd2*f*fd*k1**2*s - 66*D1*Dd*Pkdd2*f*fd*k1**2 + 528*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 264*D1*Dd*Pkdd2*f*g2*k1**2*s + 132*D1*Dd*Pkdd2*f*g2*k1**2 - 528*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 132*D1*Dd*Pkdd2*f*gd2*k1**2*s - 528*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 132*D1*Dd*Pkdd2*fd*g2*k1**2*s + 1936*D1*Ddd*K*Pk2*f**2*r**2 - 7392*D1*Ddd*K*Pk2*f**2*r*s - 88*D1*Ddd*K*Pk2*f**2*r - 11792*D1*Ddd*K*Pk2*f**2*s**2 + 9592*D1*Ddd*K*Pk2*f**2*s - 1980*D1*Ddd*K*Pk2*f**2 + 264*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 132*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 66*D1*Ddd*K*Pkdd2*f**2*k1**2 - 6600*D1*Ddd*Pk2*f**3*r**2 - 7920*D1*Ddd*Pk2*f**3*r*s + 8580*D1*Ddd*Pk2*f**3*r + 3960*D1*Ddd*Pk2*f**3*s - 3300*D1*Ddd*Pk2*f**3 - 3784*D1*Ddd*Pk2*f**2*r**2 - 5808*D1*Ddd*Pk2*f**2*r*s + 5236*D1*Ddd*Pk2*f**2*r - 2112*D1*Ddd*Pk2*f**2*s**2 + 3960*D1*Ddd*Pk2*f**2*s - 2420*D1*Ddd*Pk2*f**2 + 2112*D1*Ddd*Pk2*f*g2*r**2 - 2112*D1*Ddd*Pk2*f*g2*r - 4224*D1*Ddd*Pk2*f*g2*s**2 + 2112*D1*Ddd*Pk2*f*g2*s - 396*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 198*D1*Ddd*Pkdd2*f**2*k1**2*s - 99*D1*Ddd*Pkdd2*f**2*k1**2 - 264*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 132*D1*Ddd*Pkdd2*f*g2*k1**2*s - 66*D1*Ddd*Pkdd2*f*g2*k1**2 + 22*D1*bd1*(D1*(40*Pk2*f**2*(r + 2*s - 1) + 3*f*(8*Pk2*(K*(2*r**2 - 3*r - 4*s**2 + 1) + (2 - 2*r)*(r + 2*s - 1)) - Pkdd2*k1**2*(K - 1)*(2*s**2 - 2*s + 1)) + 3*fd*(-4*K*Pk2*(4*r**2 - r - 8*s**2 + 8*s - 1) + K*Pkdd2*k1**2*s*(2*s - 1) + 16*Pk2*r*(r + 2*s - 1) + Pkdd2*k1**2*s*(1 - 2*s))) + Dd*f*(-8*Pk2*(3*K*(8*r**2 - 10*r - 16*s**2 + 4*s + 3) + 10*f*(r + 2*s - 1) - (24*r - 18)*(r + 2*s - 1)) + Pkdd2*k1**2*(3*K - 3)*(8*s**2 - 6*s + 1))) + 5808*Dd**2*K*Pk2*f**2*r**2 - 22176*Dd**2*K*Pk2*f**2*r*s - 264*Dd**2*K*Pk2*f**2*r - 35376*Dd**2*K*Pk2*f**2*s**2 + 28776*Dd**2*K*Pk2*f**2*s - 2728*Dd**2*K*Pk2*f**2 + 792*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 396*Dd**2*K*Pkdd2*f**2*k1**2*s - 19800*Dd**2*Pk2*f**3*r**2 - 23760*Dd**2*Pk2*f**3*r*s + 25740*Dd**2*Pk2*f**3*r + 11880*Dd**2*Pk2*f**3*s - 7260*Dd**2*Pk2*f**3 - 11352*Dd**2*Pk2*f**2*r**2 - 17424*Dd**2*Pk2*f**2*r*s + 15708*Dd**2*Pk2*f**2*r - 6336*Dd**2*Pk2*f**2*s**2 + 11880*Dd**2*Pk2*f**2*s - 4796*Dd**2*Pk2*f**2 + 6336*Dd**2*Pk2*f*g2*r**2 - 6336*Dd**2*Pk2*f*g2*r - 12672*Dd**2*Pk2*f*g2*s**2 + 6336*Dd**2*Pk2*f*g2*s + 1056*Dd**2*Pk2*f*g2 - 1188*Dd**2*Pkdd2*f**2*k1**2*s**2 + 594*Dd**2*Pkdd2*f**2*k1**2*s - 792*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 396*Dd**2*Pkdd2*f*g2*k1**2*s))/(693*d**2*k3**4) - D1**2*Pk3*ct**3*k1*k2*(8712*C*D1**2*Pk2*bdd1*f**2*r*s + 7128*C*D1**2*Pk2*bdd1*f**2*r + 10560*C*D1**2*Pk2*bdd1*f**2*s**2 + 37272*C*D1**2*Pk2*f**2*fd*r**2 + 152976*C*D1**2*Pk2*f**2*fd*r*s - 75840*C*D1**2*Pk2*f**2*fd*r + 95832*C*D1**2*Pk2*f**2*fd*s**2 - 114880*C*D1**2*Pk2*f**2*fd*s + 44368*C*D1**2*Pk2*f**2*fd - 38832*C*D1**2*Pk2*f**2*fdd*r**2 - 146976*C*D1**2*Pk2*f**2*fdd*r*s + 74880*C*D1**2*Pk2*f**2*fdd*r - 87912*C*D1**2*Pk2*f**2*fdd*s**2 + 107600*C*D1**2*Pk2*f**2*fdd*s - 42248*C*D1**2*Pk2*f**2*fdd - 77664*C*D1**2*Pk2*f*fd**2*r**2 - 293952*C*D1**2*Pk2*f*fd**2*r*s + 149760*C*D1**2*Pk2*f*fd**2*r - 175824*C*D1**2*Pk2*f*fd**2*s**2 + 215200*C*D1**2*Pk2*f*fd**2*s - 48992*C*D1**2*Pk2*f*fd**2 - 660*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 1320*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 660*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 1980*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 1320*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 660*C*D1**2*Pkdd2*f**2*fd*k1**2 + 49696*C*D1*Dd*Pk2*f**3*r**2 + 203968*C*D1*Dd*Pk2*f**3*r*s - 100688*C*D1*Dd*Pk2*f**3*r + 127776*C*D1*Dd*Pk2*f**3*s**2 - 165872*C*D1*Dd*Pk2*f**3*s + 56792*C*D1*Dd*Pk2*f**3 - 310656*C*D1*Dd*Pk2*f**2*fd*r**2 - 1175808*C*D1*Dd*Pk2*f**2*fd*r*s + 601824*C*D1*Dd*Pk2*f**2*fd*r - 703296*C*D1*Dd*Pk2*f**2*fd*s**2 + 900176*C*D1*Dd*Pk2*f**2*fd*s - 257360*C*D1*Dd*Pk2*f**2*fd - 2640*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 1320*C*D1*Dd*Pkdd2*f**3*k1**2*s - 660*C*D1*Dd*Pkdd2*f**3*k1**2 - 51776*C*D1*Ddd*Pk2*f**3*r**2 - 195968*C*D1*Ddd*Pk2*f**3*r*s + 100768*C*D1*Ddd*Pk2*f**3*r - 117216*C*D1*Ddd*Pk2*f**3*s**2 + 156592*C*D1*Ddd*Pk2*f**3*s - 55192*C*D1*Ddd*Pk2*f**3 - 155328*C*Dd**2*Pk2*f**3*r**2 - 587904*C*Dd**2*Pk2*f**3*r*s + 302304*C*Dd**2*Pk2*f**3*r - 351648*C*Dd**2*Pk2*f**3*s**2 + 469776*C*Dd**2*Pk2*f**3*s - 123872*C*Dd**2*Pk2*f**3 - 6468*D1**2*K*Pk2*bdd1*f**2*r**2 - 26136*D1**2*K*Pk2*bdd1*f**2*r*s + 12936*D1**2*K*Pk2*bdd1*f**2*r - 17424*D1**2*K*Pk2*bdd1*f**2*s**2 + 26136*D1**2*K*Pk2*bdd1*f**2*s - 6468*D1**2*K*Pk2*bdd1*f**2 + 4752*D1**2*Pk2*b2*f*fd*r**2 + 25344*D1**2*Pk2*b2*f*fd*r*s - 12672*D1**2*Pk2*b2*f*fd*r + 20592*D1**2*Pk2*b2*f*fd*s**2 - 20592*D1**2*Pk2*b2*f*fd*s + 10296*D1**2*Pk2*b2*f*fd - 7920*D1**2*Pk2*b2*f*fdd*r**2 - 25344*D1**2*Pk2*b2*f*fdd*r*s + 12672*D1**2*Pk2*b2*f*fdd*r - 17424*D1**2*Pk2*b2*f*fdd*s**2 + 17424*D1**2*Pk2*b2*f*fdd*s - 8712*D1**2*Pk2*b2*f*fdd - 7920*D1**2*Pk2*b2*fd**2*r**2 - 25344*D1**2*Pk2*b2*fd**2*r*s + 12672*D1**2*Pk2*b2*fd**2*r - 17424*D1**2*Pk2*b2*fd**2*s**2 + 17424*D1**2*Pk2*b2*fd**2*s + 2376*D1**2*Pk2*bd2*f**2*r**2 + 12672*D1**2*Pk2*bd2*f**2*r*s - 4752*D1**2*Pk2*bd2*f**2*r + 10296*D1**2*Pk2*bd2*f**2*s**2 - 12672*D1**2*Pk2*bd2*f**2*s + 2376*D1**2*Pk2*bd2*f**2 - 15840*D1**2*Pk2*bd2*f*fd*r**2 - 50688*D1**2*Pk2*bd2*f*fd*r*s + 28512*D1**2*Pk2*bd2*f*fd*r - 34848*D1**2*Pk2*bd2*f*fd*s**2 + 42768*D1**2*Pk2*bd2*f*fd*s - 12672*D1**2*Pk2*bd2*f*fd + 6336*D1**2*Pk2*bdd1*f**3*r*s - 3960*D1**2*Pk2*bdd1*f**3*r + 3960*D1**2*Pk2*bdd1*f**3*s**2 - 9504*D1**2*Pk2*bdd1*f**3*s + 3564*D1**2*Pk2*bdd1*f**3 + 7326*D1**2*Pk2*bdd1*f**2*r**2 + 9372*D1**2*Pk2*bdd1*f**2*r*s - 17028*D1**2*Pk2*bdd1*f**2*r - 924*D1**2*Pk2*bdd1*f**2*s**2 - 12012*D1**2*Pk2*bdd1*f**2*s + 3894*D1**2*Pk2*bdd1*f**2 + 264*D1**2*Pk2*bdd1*f*g2*r**2 - 10296*D1**2*Pk2*bdd1*f*g2*r*s - 7128*D1**2*Pk2*bdd1*f*g2*r - 12408*D1**2*Pk2*bdd1*f*g2*s**2 - 3960*D1**2*Pk2*bdd2*f**2*r**2 - 12672*D1**2*Pk2*bdd2*f**2*r*s + 7920*D1**2*Pk2*bdd2*f**2*r - 8712*D1**2*Pk2*bdd2*f**2*s**2 + 12672*D1**2*Pk2*bdd2*f**2*s - 3960*D1**2*Pk2*bdd2*f**2 - 18234*D1**2*Pk2*f**2*fd*r**2 - 93132*D1**2*Pk2*f**2*fd*r*s + 43200*D1**2*Pk2*f**2*fd*r - 59004*D1**2*Pk2*f**2*fd*s**2 + 70380*D1**2*Pk2*f**2*fd*s - 25746*D1**2*Pk2*f**2*fd + 23274*D1**2*Pk2*f**2*fdd*r**2 + 93492*D1**2*Pk2*f**2*fdd*r*s - 46680*D1**2*Pk2*f**2*fdd*r + 55044*D1**2*Pk2*f**2*fdd*s**2 - 67860*D1**2*Pk2*f**2*fdd*s + 26106*D1**2*Pk2*f**2*fdd - 8184*D1**2*Pk2*f**2*gd2*r**2 - 52272*D1**2*Pk2*f**2*gd2*r*s + 16368*D1**2*Pk2*f**2*gd2*r - 38016*D1**2*Pk2*f**2*gd2*s**2 + 52272*D1**2*Pk2*f**2*gd2*s - 8184*D1**2*Pk2*f**2*gd2 + 12936*D1**2*Pk2*f**2*gdd2*r**2 + 52272*D1**2*Pk2*f**2*gdd2*r*s - 25872*D1**2*Pk2*f**2*gdd2*r + 34848*D1**2*Pk2*f**2*gdd2*s**2 - 52272*D1**2*Pk2*f**2*gdd2*s + 12936*D1**2*Pk2*f**2*gdd2 + 46548*D1**2*Pk2*f*fd**2*r**2 + 186984*D1**2*Pk2*f*fd**2*r*s - 93360*D1**2*Pk2*f*fd**2*r + 110088*D1**2*Pk2*f*fd**2*s**2 - 135720*D1**2*Pk2*f*fd**2*s + 31164*D1**2*Pk2*f*fd**2 - 16368*D1**2*Pk2*f*fd*g2*r**2 - 104544*D1**2*Pk2*f*fd*g2*r*s + 52272*D1**2*Pk2*f*fd*g2*r - 76032*D1**2*Pk2*f*fd*g2*s**2 + 76032*D1**2*Pk2*f*fd*g2*s - 38016*D1**2*Pk2*f*fd*g2 + 51744*D1**2*Pk2*f*fd*gd2*r**2 + 209088*D1**2*Pk2*f*fd*gd2*r*s - 104016*D1**2*Pk2*f*fd*gd2*r + 139392*D1**2*Pk2*f*fd*gd2*s**2 - 174240*D1**2*Pk2*f*fd*gd2*s + 52272*D1**2*Pk2*f*fd*gd2 + 25872*D1**2*Pk2*f*fdd*g2*r**2 + 104544*D1**2*Pk2*f*fdd*g2*r*s - 52272*D1**2*Pk2*f*fdd*g2*r + 69696*D1**2*Pk2*f*fdd*g2*s**2 - 69696*D1**2*Pk2*f*fdd*g2*s + 34848*D1**2*Pk2*f*fdd*g2 + 25872*D1**2*Pk2*fd**2*g2*r**2 + 104544*D1**2*Pk2*fd**2*g2*r*s - 52272*D1**2*Pk2*fd**2*g2*r + 69696*D1**2*Pk2*fd**2*g2*s**2 - 69696*D1**2*Pk2*fd**2*g2*s + 495*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 990*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 495*D1**2*Pkdd2*bdd1*f**2*k1**2 + 792*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 1584*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 792*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 1485*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 990*D1**2*Pkdd2*f**2*fd*k1**2*s + 495*D1**2*Pkdd2*f**2*fd*k1**2 + 792*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 1584*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 1584*D1**2*Pkdd2*f*fd*g2*k1**2*s + 792*D1**2*Pkdd2*f*fd*g2*k1**2 + 66*D1**2*bd1**2*(-56*Pk2*g2*r*(2*r + 2*s - 1) + 3*f**2*(4*Pk2*(8*r**2 + r*(8*s - 15) - 9*s + 9) + 5*Pkdd2*k1**2*s*(s - 1)) - 2*f*(K*Pk2*(2*r**2 - r*(78*s + 29) - 94*s**2 + 39*s + 27) - 2*Pk2*(14*C*r*(2*s - 1) + r**2*(28*C + 18) + 25*r*(s - 3) - 50*s + 43) + Pkdd2*k1**2*s*(6*K - 3)*(s - 1))) + 9504*D1*Dd*Pk2*b2*f**2*r**2 + 50688*D1*Dd*Pk2*b2*f**2*r*s - 22176*D1*Dd*Pk2*b2*f**2*r + 41184*D1*Dd*Pk2*b2*f**2*s**2 - 45936*D1*Dd*Pk2*b2*f**2*s + 15048*D1*Dd*Pk2*b2*f**2 - 63360*D1*Dd*Pk2*b2*f*fd*r**2 - 202752*D1*Dd*Pk2*b2*f*fd*r*s + 107712*D1*Dd*Pk2*b2*f*fd*r - 139392*D1*Dd*Pk2*b2*f*fd*s**2 + 155232*D1*Dd*Pk2*b2*f*fd*s - 42768*D1*Dd*Pk2*b2*f*fd - 31680*D1*Dd*Pk2*bd2*f**2*r**2 - 101376*D1*Dd*Pk2*bd2*f**2*r*s + 60192*D1*Dd*Pk2*bd2*f**2*r - 69696*D1*Dd*Pk2*bd2*f**2*s**2 + 93456*D1*Dd*Pk2*bd2*f**2*s - 28512*D1*Dd*Pk2*bd2*f**2 - 24312*D1*Dd*Pk2*f**3*r**2 - 124176*D1*Dd*Pk2*f**3*r*s + 55356*D1*Dd*Pk2*f**3*r - 78672*D1*Dd*Pk2*f**3*s**2 + 101424*D1*Dd*Pk2*f**3*s - 31824*D1*Dd*Pk2*f**3 + 186192*D1*Dd*Pk2*f**2*fd*r**2 + 747936*D1*Dd*Pk2*f**2*fd*r*s - 373308*D1*Dd*Pk2*f**2*fd*r + 440352*D1*Dd*Pk2*f**2*fd*s**2 - 568512*D1*Dd*Pk2*f**2*fd*s + 161220*D1*Dd*Pk2*f**2*fd - 32736*D1*Dd*Pk2*f**2*g2*r**2 - 209088*D1*Dd*Pk2*f**2*g2*r*s + 85008*D1*Dd*Pk2*f**2*g2*r - 152064*D1*Dd*Pk2*f**2*g2*s**2 + 180576*D1*Dd*Pk2*f**2*g2*s - 54384*D1*Dd*Pk2*f**2*g2 + 103488*D1*Dd*Pk2*f**2*gd2*r**2 + 418176*D1*Dd*Pk2*f**2*gd2*r*s - 207504*D1*Dd*Pk2*f**2*gd2*r + 278784*D1*Dd*Pk2*f**2*gd2*s**2 - 383328*D1*Dd*Pk2*f**2*gd2*s + 104016*D1*Dd*Pk2*f**2*gd2 + 206976*D1*Dd*Pk2*f*fd*g2*r**2 + 836352*D1*Dd*Pk2*f*fd*g2*r*s - 417120*D1*Dd*Pk2*f*fd*g2*r + 557568*D1*Dd*Pk2*f*fd*g2*s**2 - 627264*D1*Dd*Pk2*f*fd*g2*s + 174240*D1*Dd*Pk2*f*fd*g2 + 1980*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 990*D1*Dd*Pkdd2*f**3*k1**2*s + 495*D1*Dd*Pkdd2*f**3*k1**2 + 3168*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 1584*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 792*D1*Dd*Pkdd2*f**2*g2*k1**2 - 15840*D1*Ddd*Pk2*b2*f**2*r**2 - 50688*D1*Ddd*Pk2*b2*f**2*r*s + 28512*D1*Ddd*Pk2*b2*f**2*r - 34848*D1*Ddd*Pk2*b2*f**2*s**2 + 42768*D1*Ddd*Pk2*b2*f**2*s - 16632*D1*Ddd*Pk2*b2*f**2 + 31032*D1*Ddd*Pk2*f**3*r**2 + 124656*D1*Ddd*Pk2*f**3*r*s - 62196*D1*Ddd*Pk2*f**3*r + 73392*D1*Ddd*Pk2*f**3*s**2 - 99024*D1*Ddd*Pk2*f**3*s + 33864*D1*Ddd*Pk2*f**3 + 51744*D1*Ddd*Pk2*f**2*g2*r**2 + 209088*D1*Ddd*Pk2*f**2*g2*r*s - 104016*D1*Ddd*Pk2*f**2*g2*r + 139392*D1*Ddd*Pk2*f**2*g2*s**2 - 174240*D1*Ddd*Pk2*f**2*g2*s + 60720*D1*Ddd*Pk2*f**2*g2 - 33*D1*bd1*(D1*(3*f**3*(4*Pk2*(2*r*(8*s - 5) + 10*s**2 - 24*s + 9) + 5*Pkdd2*k1**2*(1 - 2*s)) - 2*f**2*(Pk2*(156*C*r**2 - 80*C*r*s - 112*C*r - 200*C*s**2 + 2*K*(31*r**2 + 198*r*s - 62*r + 144*s**2 - 198*s + 31) + 12*fd*(6*r*(8*s - 3) + 30*s**2 - 50*s + 13) - 239*r**2 - 198*r*s + 218*r + 34*s**2 + 178*s - 33) + Pkdd2*k1**2*(8*C*(s - 1)**2 - 6*K*s**2 + 6*s - 3)) - 4*f*(2*Pk2*g2*(-37*r**2 + r*(22*s + 26) + 59*s**2) + 2*Pk2*gd2*(2*r**2 - r*(78*s + 29) - 94*s**2 + 39*s + 27) - 5*Pkdd2*g2*k1**2*(s - 1)**2 + 12*Pkdd2*gd2*k1**2*s*(s - 1) + fd*(Pk2*(2*C*(6*r*(22*s - 1) + 160*s**2 - 113*s - 27) - 2*K*(98*r**2 + 396*r*s - 197*r + 264*s**2 - 330*s + 99) + 222*r**2 + 284*r*s - 311*r - 28*s**2 - 148*s + 161) + Pkdd2*k1**2*s*(15 - 20*C)*(s - 1))) - 8*fd*g2*(Pk2*(2*r**2 + r*(39 - 78*s) - s*(94*s - 94)) + 6*Pkdd2*k1**2*s*(s - 1))) - 2*Dd*f*(24*Pk2*f**2*(2*r*(16*s - 7) + 20*s**2 - 37*s + 11) + f*(2*Pk2*(2*C*(3*r*(88*s + 25) + 320*s**2 - 146*s - 54) - 2*K*(196*r**2 + 792*r*s - 393*r + 528*s**2 - 726*s + 197) + 444*r**2 + 568*r*s - 809*r - 56*s**2 - 492*s + 349) + Pkdd2*k1**2*(15 - 20*C)*(4*s**2 - 5*s + 1)) + 4*g2*(Pk2*(8*r**2 - r*(312*s + 73) - 376*s**2 + 172*s + 54) + 6*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 47520*Dd**2*Pk2*b2*f**2*r**2 - 152064*Dd**2*Pk2*b2*f**2*r*s + 85536*Dd**2*Pk2*b2*f**2*r - 104544*Dd**2*Pk2*b2*f**2*s**2 + 128304*Dd**2*Pk2*b2*f**2*s - 33264*Dd**2*Pk2*b2*f**2 + 93096*Dd**2*Pk2*f**3*r**2 + 373968*Dd**2*Pk2*f**3*r*s - 186588*Dd**2*Pk2*f**3*r + 220176*Dd**2*Pk2*f**3*s**2 - 297072*Dd**2*Pk2*f**3*s + 77844*Dd**2*Pk2*f**3 + 155232*Dd**2*Pk2*f**2*g2*r**2 + 627264*Dd**2*Pk2*f**2*g2*r*s - 312048*Dd**2*Pk2*f**2*g2*r + 418176*Dd**2*Pk2*f**2*g2*s**2 - 522720*Dd**2*Pk2*f**2*g2*s + 130416*Dd**2*Pk2*f**2*g2 - 1848*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)) - 33*b1**2*(224*C*D1**2*Pk2*fd*r**2 + 224*C*D1**2*Pk2*fd*r*s - 448*C*D1**2*Pk2*fd*r - 224*C*D1**2*Pk2*fd*s + 224*C*D1**2*Pk2*fd - 112*C*D1**2*Pk2*fdd*r**2 - 112*C*D1**2*Pk2*fdd*r*s + 224*C*D1**2*Pk2*fdd*r + 112*C*D1**2*Pk2*fdd*s - 112*C*D1**2*Pk2*fdd + 896*C*D1*Dd*Pk2*f*r**2 + 896*C*D1*Dd*Pk2*f*r*s - 1120*C*D1*Dd*Pk2*f*r - 448*C*D1*Dd*Pk2*f*s + 448*C*D1*Dd*Pk2*f - 896*C*D1*Dd*Pk2*fd*r**2 - 896*C*D1*Dd*Pk2*fd*r*s + 1456*C*D1*Dd*Pk2*fd*r + 672*C*D1*Dd*Pk2*fd*s - 560*C*D1*Dd*Pk2*fd - 448*C*D1*Ddd*Pk2*f*r**2 - 448*C*D1*Ddd*Pk2*f*r*s + 560*C*D1*Ddd*Pk2*f*r + 224*C*D1*Ddd*Pk2*f*s - 224*C*D1*Ddd*Pk2*f - 1344*C*Dd**2*Pk2*f*r**2 - 1344*C*Dd**2*Pk2*f*r*s + 1680*C*Dd**2*Pk2*f*r + 672*C*Dd**2*Pk2*f*s - 448*C*Dd**2*Pk2*f - 148*D1**2*K*Pk2*fd*r**2 + 88*D1**2*K*Pk2*fd*r*s - 192*D1**2*K*Pk2*fd*r + 236*D1**2*K*Pk2*fd*s**2 - 472*D1**2*K*Pk2*fd*s + 236*D1**2*K*Pk2*fd + 4*D1**2*K*Pk2*fdd*r**2 - 156*D1**2*K*Pk2*fdd*r*s + 264*D1**2*K*Pk2*fdd*r - 188*D1**2*K*Pk2*fdd*s**2 + 376*D1**2*K*Pk2*fdd*s - 188*D1**2*K*Pk2*fdd - 10*D1**2*K*Pkdd2*fd*k1**2*s**2 + 12*D1**2*K*Pkdd2*fdd*k1**2*s**2 - 56*D1**2*Pk2*bdd1*(K - 1)*(3*r**2 + 3*r*(s - 1) - s + 1) + 192*D1**2*Pk2*f*fd*r**2 + 192*D1**2*Pk2*f*fd*r*s - 120*D1**2*Pk2*f*fd*r + 72*D1**2*Pk2*f*fd*s + 36*D1**2*Pk2*f*fd - 192*D1**2*Pk2*f*fdd*r**2 - 192*D1**2*Pk2*f*fdd*r*s + 120*D1**2*Pk2*f*fdd*r - 24*D1**2*Pk2*f*fdd*s - 60*D1**2*Pk2*f*fdd - 192*D1**2*Pk2*fd**2*r**2 - 192*D1**2*Pk2*fd**2*r*s + 120*D1**2*Pk2*fd**2*r - 24*D1**2*Pk2*fd**2*s + 72*D1**2*Pk2*fd**2 + 88*D1**2*Pk2*fd*r**2 + 88*D1**2*Pk2*fd*r*s + 516*D1**2*Pk2*fd*r + 460*D1**2*Pk2*fd*s - 342*D1**2*Pk2*fd - 72*D1**2*Pk2*fdd*r**2 - 100*D1**2*Pk2*fdd*r*s - 356*D1**2*Pk2*fdd*r - 300*D1**2*Pk2*fdd*s + 206*D1**2*Pk2*fdd - 224*D1**2*Pk2*gd2*r**2 - 224*D1**2*Pk2*gd2*r*s + 448*D1**2*Pk2*gd2*r + 224*D1**2*Pk2*gd2*s - 224*D1**2*Pk2*gd2 + 112*D1**2*Pk2*gdd2*r**2 + 112*D1**2*Pk2*gdd2*r*s - 224*D1**2*Pk2*gdd2*r - 112*D1**2*Pk2*gdd2*s + 112*D1**2*Pk2*gdd2 + 60*D1**2*Pkdd2*f*fd*k1**2*s**2 - 30*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 30*D1**2*Pkdd2*fd**2*k1**2*s**2 - 2*D1**2*Pkdd2*fd*k1**2*s**2 - 6*D1**2*Pkdd2*fdd*k1**2*s**2 - 592*D1*Dd*K*Pk2*f*r**2 + 352*D1*Dd*K*Pk2*f*r*s + 504*D1*Dd*K*Pk2*f*r + 944*D1*Dd*K*Pk2*f*s**2 - 648*D1*Dd*K*Pk2*f*s - 60*D1*Dd*K*Pk2*f + 32*D1*Dd*K*Pk2*fd*r**2 - 1248*D1*Dd*K*Pk2*fd*r*s + 1196*D1*Dd*K*Pk2*fd*r - 1504*D1*Dd*K*Pk2*fd*s**2 + 2192*D1*Dd*K*Pk2*fd*s - 904*D1*Dd*K*Pk2*fd - 40*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 20*D1*Dd*K*Pkdd2*f*k1**2*s - 10*D1*Dd*K*Pkdd2*f*k1**2 + 96*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 24*D1*Dd*K*Pkdd2*fd*k1**2*s + 384*D1*Dd*Pk2*f**2*r**2 + 384*D1*Dd*Pk2*f**2*r*s - 480*D1*Dd*Pk2*f**2*r - 192*D1*Dd*Pk2*f**2*s + 192*D1*Dd*Pk2*f**2 - 1536*D1*Dd*Pk2*f*fd*r**2 - 1536*D1*Dd*Pk2*f*fd*r*s + 1440*D1*Dd*Pk2*f*fd*r + 288*D1*Dd*Pk2*f*fd*s - 216*D1*Dd*Pk2*f*fd + 352*D1*Dd*Pk2*f*r**2 + 352*D1*Dd*Pk2*f*r*s - 440*D1*Dd*Pk2*f*r - 176*D1*Dd*Pk2*f*s + 176*D1*Dd*Pk2*f - 576*D1*Dd*Pk2*fd*r**2 - 800*D1*Dd*Pk2*fd*r*s - 1036*D1*Dd*Pk2*fd*r - 1000*D1*Dd*Pk2*fd*s + 1012*D1*Dd*Pk2*fd - 896*D1*Dd*Pk2*g2*r**2 - 896*D1*Dd*Pk2*g2*r*s + 1120*D1*Dd*Pk2*g2*r + 448*D1*Dd*Pk2*g2*s - 448*D1*Dd*Pk2*g2 + 896*D1*Dd*Pk2*gd2*r**2 + 896*D1*Dd*Pk2*gd2*r*s - 1456*D1*Dd*Pk2*gd2*r - 672*D1*Dd*Pk2*gd2*s + 560*D1*Dd*Pk2*gd2 + 120*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 60*D1*Dd*Pkdd2*f**2*k1**2*s + 30*D1*Dd*Pkdd2*f**2*k1**2 - 240*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 60*D1*Dd*Pkdd2*f*fd*k1**2*s - 8*D1*Dd*Pkdd2*f*k1**2*s**2 + 4*D1*Dd*Pkdd2*f*k1**2*s - 2*D1*Dd*Pkdd2*f*k1**2 - 48*D1*Dd*Pkdd2*fd*k1**2*s**2 + 12*D1*Dd*Pkdd2*fd*k1**2*s + 16*D1*Ddd*K*Pk2*f*r**2 - 624*D1*Ddd*K*Pk2*f*r*s + 140*D1*Ddd*K*Pk2*f*r - 752*D1*Ddd*K*Pk2*f*s**2 + 688*D1*Ddd*K*Pk2*f*s - 180*D1*Ddd*K*Pk2*f + 48*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 24*D1*Ddd*K*Pkdd2*f*k1**2*s + 12*D1*Ddd*K*Pkdd2*f*k1**2 - 384*D1*Ddd*Pk2*f**2*r**2 - 384*D1*Ddd*Pk2*f**2*r*s + 480*D1*Ddd*Pk2*f**2*r + 192*D1*Ddd*Pk2*f**2*s - 192*D1*Ddd*Pk2*f**2 - 288*D1*Ddd*Pk2*f*r**2 - 400*D1*Ddd*Pk2*f*r*s + 388*D1*Ddd*Pk2*f*r + 200*D1*Ddd*Pk2*f*s - 144*D1*Ddd*Pk2*f + 448*D1*Ddd*Pk2*g2*r**2 + 448*D1*Ddd*Pk2*g2*r*s - 560*D1*Ddd*Pk2*g2*r - 224*D1*Ddd*Pk2*g2*s + 224*D1*Ddd*Pk2*g2 - 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 30*D1*Ddd*Pkdd2*f**2*k1**2*s - 15*D1*Ddd*Pkdd2*f**2*k1**2 - 24*D1*Ddd*Pkdd2*f*k1**2*s**2 + 12*D1*Ddd*Pkdd2*f*k1**2*s - 6*D1*Ddd*Pkdd2*f*k1**2 + 56*D1*Pk2*bd1*(K - 1)*(D1*(6*r**2 + 6*r*(s - 1) - 2*s + 2) + Dd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7)) + 48*Dd**2*K*Pk2*f*r**2 - 1872*Dd**2*K*Pk2*f*r*s + 420*Dd**2*K*Pk2*f*r - 2256*Dd**2*K*Pk2*f*s**2 + 2064*Dd**2*K*Pk2*f*s - 304*Dd**2*K*Pk2*f + 144*Dd**2*K*Pkdd2*f*k1**2*s**2 - 72*Dd**2*K*Pkdd2*f*k1**2*s - 1152*Dd**2*Pk2*f**2*r**2 - 1152*Dd**2*Pk2*f**2*r*s + 1440*Dd**2*Pk2*f**2*r + 576*Dd**2*Pk2*f**2*s - 384*Dd**2*Pk2*f**2 - 864*Dd**2*Pk2*f*r**2 - 1200*Dd**2*Pk2*f*r*s + 1164*Dd**2*Pk2*f*r + 600*Dd**2*Pk2*f*s - 344*Dd**2*Pk2*f + 1344*Dd**2*Pk2*g2*r**2 + 1344*Dd**2*Pk2*g2*r*s - 1680*Dd**2*Pk2*g2*r - 672*Dd**2*Pk2*g2*s + 448*Dd**2*Pk2*g2 - 180*Dd**2*Pkdd2*f**2*k1**2*s**2 + 90*Dd**2*Pkdd2*f**2*k1**2*s - 72*Dd**2*Pkdd2*f*k1**2*s**2 + 36*Dd**2*Pkdd2*f*k1**2*s) + 33*b1*(624*C*D1**2*Pk2*f*fd*r**2 - 320*C*D1**2*Pk2*f*fd*r*s - 240*C*D1**2*Pk2*f*fd*r - 800*C*D1**2*Pk2*f*fd*s**2 + 960*C*D1**2*Pk2*f*fd*s - 88*C*D1**2*Pk2*f*fd + 528*C*D1**2*Pk2*f*fdd*r*s - 480*C*D1**2*Pk2*f*fdd*r + 640*C*D1**2*Pk2*f*fdd*s**2 - 904*C*D1**2*Pk2*f*fdd*s + 320*C*D1**2*Pk2*f*fdd + 528*C*D1**2*Pk2*fd**2*r*s - 480*C*D1**2*Pk2*fd**2*r + 640*C*D1**2*Pk2*fd**2*s**2 - 904*C*D1**2*Pk2*fd**2*s + 480*C*D1**2*Pk2*fd**2 + 32*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 40*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 40*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 1248*C*D1*Dd*Pk2*f**2*r**2 - 640*C*D1*Dd*Pk2*f**2*r*s - 1088*C*D1*Dd*Pk2*f**2*r - 1600*C*D1*Dd*Pk2*f**2*s**2 + 1120*C*D1*Dd*Pk2*f**2*s + 224*C*D1*Dd*Pk2*f**2 + 4224*C*D1*Dd*Pk2*f*fd*r*s - 2448*C*D1*Dd*Pk2*f*fd*r + 5120*C*D1*Dd*Pk2*f*fd*s**2 - 5952*C*D1*Dd*Pk2*f*fd*s + 1864*C*D1*Dd*Pk2*f*fd + 64*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 32*C*D1*Dd*Pkdd2*f**2*k1**2*s + 16*C*D1*Dd*Pkdd2*f**2*k1**2 - 320*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 80*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 1056*C*D1*Ddd*Pk2*f**2*r*s - 264*C*D1*Ddd*Pk2*f**2*r + 1280*C*D1*Ddd*Pk2*f**2*s**2 - 1168*C*D1*Ddd*Pk2*f**2*s + 320*C*D1*Ddd*Pk2*f**2 - 80*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 40*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 20*C*D1*Ddd*Pkdd2*f**2*k1**2 + 3168*C*Dd**2*Pk2*f**2*r*s - 792*C*Dd**2*Pk2*f**2*r + 3840*C*Dd**2*Pk2*f**2*s**2 - 3504*C*Dd**2*Pk2*f**2*s + 528*C*Dd**2*Pk2*f**2 - 240*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 120*C*Dd**2*Pkdd2*f**2*k1**2*s + 248*D1**2*K*Pk2*f*fd*r**2 + 1584*D1**2*K*Pk2*f*fd*r*s - 792*D1**2*K*Pk2*f*fd*r + 1152*D1**2*K*Pk2*f*fd*s**2 - 1152*D1**2*K*Pk2*f*fd*s + 576*D1**2*K*Pk2*f*fd - 392*D1**2*K*Pk2*f*fdd*r**2 - 1584*D1**2*K*Pk2*f*fdd*r*s + 792*D1**2*K*Pk2*f*fdd*r - 1056*D1**2*K*Pk2*f*fdd*s**2 + 1056*D1**2*K*Pk2*f*fdd*s - 528*D1**2*K*Pk2*f*fdd - 392*D1**2*K*Pk2*fd**2*r**2 - 1584*D1**2*K*Pk2*fd**2*r*s + 792*D1**2*K*Pk2*fd**2*r - 1056*D1**2*K*Pk2*fd**2*s**2 + 1056*D1**2*K*Pk2*fd**2*s - 24*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 24*D1**2*K*Pkdd2*f*fd*k1**2*s - 12*D1**2*K*Pkdd2*f*fd*k1**2 + 56*D1**2*Pk2*bd1**2*(K - 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) - 576*D1**2*Pk2*f**2*fd*r*s + 72*D1**2*Pk2*f**2*fd*r - 360*D1**2*Pk2*f**2*fd*s**2 + 336*D1**2*Pk2*f**2*fd*s - 12*D1**2*Pk2*f**2*fd + 576*D1**2*Pk2*f**2*fdd*r*s - 72*D1**2*Pk2*f**2*fdd*r + 360*D1**2*Pk2*f**2*fdd*s**2 - 336*D1**2*Pk2*f**2*fdd*s + 12*D1**2*Pk2*f**2*fdd + 1152*D1**2*Pk2*f*fd**2*r*s - 144*D1**2*Pk2*f*fd**2*r + 720*D1**2*Pk2*f*fd**2*s**2 - 672*D1**2*Pk2*f*fd**2*s + 72*D1**2*Pk2*f*fd**2 - 956*D1**2*Pk2*f*fd*r**2 - 792*D1**2*Pk2*f*fd*r*s + 916*D1**2*Pk2*f*fd*r + 136*D1**2*Pk2*f*fd*s**2 - 96*D1**2*Pk2*f*fd*s - 344*D1**2*Pk2*f*fd + 444*D1**2*Pk2*f*fdd*r**2 + 568*D1**2*Pk2*f*fdd*r*s - 212*D1**2*Pk2*f*fdd*r - 56*D1**2*Pk2*f*fdd*s**2 + 136*D1**2*Pk2*f*fdd*s + 76*D1**2*Pk2*f*fdd - 296*D1**2*Pk2*f*gd2*r**2 + 176*D1**2*Pk2*f*gd2*r*s + 592*D1**2*Pk2*f*gd2*r + 472*D1**2*Pk2*f*gd2*s**2 - 176*D1**2*Pk2*f*gd2*s - 296*D1**2*Pk2*f*gd2 + 8*D1**2*Pk2*f*gdd2*r**2 - 312*D1**2*Pk2*f*gdd2*r*s - 16*D1**2*Pk2*f*gdd2*r - 376*D1**2*Pk2*f*gdd2*s**2 + 312*D1**2*Pk2*f*gdd2*s + 8*D1**2*Pk2*f*gdd2 + 444*D1**2*Pk2*fd**2*r**2 + 568*D1**2*Pk2*fd**2*r*s - 212*D1**2*Pk2*fd**2*r - 56*D1**2*Pk2*fd**2*s**2 + 136*D1**2*Pk2*fd**2*s - 360*D1**2*Pk2*fd**2 - 296*D1**2*Pk2*fd*g2*r**2 + 176*D1**2*Pk2*fd*g2*r*s - 384*D1**2*Pk2*fd*g2*r + 472*D1**2*Pk2*fd*g2*s**2 - 944*D1**2*Pk2*fd*g2*s + 472*D1**2*Pk2*fd*g2 + 16*D1**2*Pk2*fd*gd2*r**2 - 624*D1**2*Pk2*fd*gd2*r*s + 512*D1**2*Pk2*fd*gd2*r - 752*D1**2*Pk2*fd*gd2*s**2 + 1064*D1**2*Pk2*fd*gd2*s - 528*D1**2*Pk2*fd*gd2 + 8*D1**2*Pk2*fdd*g2*r**2 - 312*D1**2*Pk2*fdd*g2*r*s + 528*D1**2*Pk2*fdd*g2*r - 376*D1**2*Pk2*fdd*g2*s**2 + 752*D1**2*Pk2*fdd*g2*s - 376*D1**2*Pk2*fdd*g2 - 30*D1**2*Pkdd2*f**2*fd*k1**2*s + 15*D1**2*Pkdd2*f**2*fd*k1**2 - 12*D1**2*Pkdd2*f*fd*k1**2*s + 6*D1**2*Pkdd2*f*fd*k1**2 + 30*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 20*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 24*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 30*D1**2*Pkdd2*fd**2*k1**2*s**2 - 20*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 48*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 24*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + D1**2*bdd1*(-112*Pk2*g2*r*(2*r + 2*s - 1) + 3*f**2*(4*Pk2*(16*r**2 + 2*r*(8*s - 15) - 18*s + 11) + 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - 2*f*(Pk2*(2*K*(2*r**2 - r*(78*s + 29) - 94*s**2 + 39*s + 1) - r**2*(112*C + 72) - 4*r*(28*C*s - 14*C + 25*s - 75) + 200*s - 139) + Pkdd2*k1**2*(6*K - 3)*(2*s**2 - 2*s + 1))) + 496*D1*Dd*K*Pk2*f**2*r**2 + 3168*D1*Dd*K*Pk2*f**2*r*s - 1288*D1*Dd*K*Pk2*f**2*r + 2304*D1*Dd*K*Pk2*f**2*s**2 - 2736*D1*Dd*K*Pk2*f**2*s + 824*D1*Dd*K*Pk2*f**2 - 3136*D1*Dd*K*Pk2*f*fd*r**2 - 12672*D1*Dd*K*Pk2*f*fd*r*s + 6320*D1*Dd*K*Pk2*f*fd*r - 8448*D1*Dd*K*Pk2*f*fd*s**2 + 9504*D1*Dd*K*Pk2*f*fd*s - 2640*D1*Dd*K*Pk2*f*fd - 48*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 24*D1*Dd*K*Pkdd2*f**2*k1**2*s - 12*D1*Dd*K*Pkdd2*f**2*k1**2 - 768*D1*Dd*Pk2*f**3*r*s + 192*D1*Dd*Pk2*f**3*r - 480*D1*Dd*Pk2*f**3*s**2 + 624*D1*Dd*Pk2*f**3*s - 120*D1*Dd*Pk2*f**3 + 4608*D1*Dd*Pk2*f**2*fd*r*s - 864*D1*Dd*Pk2*f**2*fd*r + 2880*D1*Dd*Pk2*f**2*fd*s**2 - 3216*D1*Dd*Pk2*f**2*fd*s + 480*D1*Dd*Pk2*f**2*fd - 1912*D1*Dd*Pk2*f**2*r**2 - 1584*D1*Dd*Pk2*f**2*r*s + 2308*D1*Dd*Pk2*f**2*r + 272*D1*Dd*Pk2*f**2*s**2 + 656*D1*Dd*Pk2*f**2*s - 888*D1*Dd*Pk2*f**2 + 3552*D1*Dd*Pk2*f*fd*r**2 + 4544*D1*Dd*Pk2*f*fd*r*s - 3192*D1*Dd*Pk2*f*fd*r - 448*D1*Dd*Pk2*f*fd*s**2 - 480*D1*Dd*Pk2*f*fd*s + 288*D1*Dd*Pk2*f*fd - 1184*D1*Dd*Pk2*f*g2*r**2 + 704*D1*Dd*Pk2*f*g2*r*s + 1008*D1*Dd*Pk2*f*g2*r + 1888*D1*Dd*Pk2*f*g2*s**2 - 1296*D1*Dd*Pk2*f*g2*s - 120*D1*Dd*Pk2*f*g2 + 64*D1*Dd*Pk2*f*gd2*r**2 - 2496*D1*Dd*Pk2*f*gd2*r*s + 216*D1*Dd*Pk2*f*gd2*r - 3008*D1*Dd*Pk2*f*gd2*s**2 + 2624*D1*Dd*Pk2*f*gd2*s - 280*D1*Dd*Pk2*f*gd2 + 64*D1*Dd*Pk2*fd*g2*r**2 - 2496*D1*Dd*Pk2*fd*g2*r*s + 2392*D1*Dd*Pk2*fd*g2*r - 3008*D1*Dd*Pk2*fd*g2*s**2 + 4384*D1*Dd*Pk2*fd*g2*s - 1808*D1*Dd*Pk2*fd*g2 + 240*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 60*D1*Dd*Pkdd2*f*fd*k1**2*s - 80*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 40*D1*Dd*Pkdd2*f*g2*k1**2*s - 20*D1*Dd*Pkdd2*f*g2*k1**2 + 192*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 - 48*D1*Dd*Pkdd2*f*gd2*k1**2*s + 192*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 - 48*D1*Dd*Pkdd2*fd*g2*k1**2*s - 784*D1*Ddd*K*Pk2*f**2*r**2 - 3168*D1*Ddd*K*Pk2*f**2*r*s + 1576*D1*Ddd*K*Pk2*f**2*r - 2112*D1*Ddd*K*Pk2*f**2*s**2 + 2640*D1*Ddd*K*Pk2*f**2*s - 920*D1*Ddd*K*Pk2*f**2 + 768*D1*Ddd*Pk2*f**3*r*s - 192*D1*Ddd*Pk2*f**3*r + 480*D1*Ddd*Pk2*f**3*s**2 - 624*D1*Ddd*Pk2*f**3*s + 120*D1*Ddd*Pk2*f**3 + 888*D1*Ddd*Pk2*f**2*r**2 + 1136*D1*Ddd*Pk2*f**2*r*s - 1172*D1*Ddd*Pk2*f**2*r - 112*D1*Ddd*Pk2*f**2*s**2 - 512*D1*Ddd*Pk2*f**2*s + 416*D1*Ddd*Pk2*f**2 + 32*D1*Ddd*Pk2*f*g2*r**2 - 1248*D1*Ddd*Pk2*f*g2*r*s + 280*D1*Ddd*Pk2*f*g2*r - 1504*D1*Ddd*Pk2*f*g2*s**2 + 1376*D1*Ddd*Pk2*f*g2*s - 360*D1*Ddd*Pk2*f*g2 + 60*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 30*D1*Ddd*Pkdd2*f**2*k1**2*s + 15*D1*Ddd*Pkdd2*f**2*k1**2 + 96*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 - 48*D1*Ddd*Pkdd2*f*g2*k1**2*s + 24*D1*Ddd*Pkdd2*f*g2*k1**2 - 2*D1*bd1*(3*D1*f**2*(Pk2*(32*r**2 + 4*r*(8*s - 15) - 44*s + 26) + 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - D1*f*(Pk2*(-224*C*r**2 - 224*C*r*s + 112*C*r + 2*K*(74*r**2 - 4*r*(11*s + 25) - 118*s**2 + 22*s + 37) + 24*fd*(16*r**2 + 4*r*(4*s - 5) - 8*s + 5) - 88*r**2 - 88*r*s + 390*r + 274*s - 215) + Pkdd2*k1**2*(5*K*(2*s**2 - 2*s + 1) + s**2*(60*fd + 2) - s*(30*fd + 2) + 1)) - 2*D1*(Pk2*fd*(28*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + K*(-4*r**2 + 156*r*s - 103*r + 188*s**2 - 227*s + 66) + 72*r**2 + 100*r*s + 28*r + 50*s - 61) + 56*Pk2*g2*r*(2*r + 2*s - 1) - 28*Pk2*gd2*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 3*Pkdd2*fd*k1**2*s*(K*(2 - 4*s) + 2*s - 1)) + 112*Dd*Pk2*g2*(8*r**2 + r*(8*s - 7) - 2*s + 1) - 3*Dd*f**2*(4*Pk2*(16*r - 13)*(4*r + 4*s - 3) + 5*Pkdd2*k1**2*(8*s**2 - 6*s + 1)) - 2*Dd*f*(Pk2*(56*C*(8*r**2 + r*(8*s - 7) - 2*s + 1) + K*(-16*r**2 + 624*r*s + 46*r + 752*s**2 - 500*s - 19) + 288*r**2 + 400*r*s - 794*r - 500*s + 400) + Pkdd2*k1**2*(3 - 6*K)*(8*s**2 - 6*s + 1))) - 2352*Dd**2*K*Pk2*f**2*r**2 - 9504*Dd**2*K*Pk2*f**2*r*s + 4728*Dd**2*K*Pk2*f**2*r - 6336*Dd**2*K*Pk2*f**2*s**2 + 7920*Dd**2*K*Pk2*f**2*s - 1976*Dd**2*K*Pk2*f**2 + 2304*Dd**2*Pk2*f**3*r*s - 576*Dd**2*Pk2*f**3*r + 1440*Dd**2*Pk2*f**3*s**2 - 1872*Dd**2*Pk2*f**3*s + 384*Dd**2*Pk2*f**3 + 2664*Dd**2*Pk2*f**2*r**2 + 3408*Dd**2*Pk2*f**2*r*s - 3516*Dd**2*Pk2*f**2*r - 336*Dd**2*Pk2*f**2*s**2 - 1536*Dd**2*Pk2*f**2*s + 1012*Dd**2*Pk2*f**2 + 96*Dd**2*Pk2*f*g2*r**2 - 3744*Dd**2*Pk2*f*g2*r*s + 840*Dd**2*Pk2*f*g2*r - 4512*Dd**2*Pk2*f*g2*s**2 + 4128*Dd**2*Pk2*f*g2*s - 608*Dd**2*Pk2*f*g2 + 180*Dd**2*Pkdd2*f**2*k1**2*s**2 - 90*Dd**2*Pkdd2*f**2*k1**2*s + 288*Dd**2*Pkdd2*f*g2*k1**2*s**2 - 144*Dd**2*Pkdd2*f*g2*k1**2*s))/(693*d**2*k3**4) - D1**2*Pk3*ct**3*k1*st**2*(3168*C*D1**2*Pk2*bdd1*f**2*r*s - 3168*C*D1**2*Pk2*bdd1*f**2*s**2 - 24000*C*D1**2*Pk2*f**2*fd*s**2 + 16000*C*D1**2*Pk2*f**2*fd*s - 8000*C*D1**2*Pk2*f**2*fd + 12000*C*D1**2*Pk2*f**2*fdd*s**2 - 8000*C*D1**2*Pk2*f**2*fdd*s + 4000*C*D1**2*Pk2*f**2*fdd + 24000*C*D1**2*Pk2*f*fd**2*s**2 - 16000*C*D1**2*Pk2*f*fd**2*s - 32000*C*D1*Dd*Pk2*f**3*s**2 + 16000*C*D1*Dd*Pk2*f**3*s - 8000*C*D1*Dd*Pk2*f**3 + 96000*C*D1*Dd*Pk2*f**2*fd*s**2 - 56000*C*D1*Dd*Pk2*f**2*fd*s + 8000*C*D1*Dd*Pk2*f**2*fd + 16000*C*D1*Ddd*Pk2*f**3*s**2 - 8000*C*D1*Ddd*Pk2*f**3*s + 4000*C*D1*Ddd*Pk2*f**3 + 48000*C*Dd**2*Pk2*f**3*s**2 - 24000*C*Dd**2*Pk2*f**3*s + 2640*D1**2*K*Pk2*bdd1*f**2*s**2 - 10560*D1**2*Pk2*b2*f*fd*s**2 + 10560*D1**2*Pk2*b2*f*fd*s - 5280*D1**2*Pk2*b2*f*fd + 5280*D1**2*Pk2*b2*f*fdd*s**2 - 5280*D1**2*Pk2*b2*f*fdd*s + 2640*D1**2*Pk2*b2*f*fdd + 5280*D1**2*Pk2*b2*fd**2*s**2 - 5280*D1**2*Pk2*b2*fd**2*s + 528*D1**2*Pk2*bd1**2*f*s*(K*(6*r - 6*s - 3) + 5*f - 6*r + 6) - 5280*D1**2*Pk2*bd2*f**2*s**2 + 10560*D1**2*Pk2*bd2*f*fd*s**2 - 5280*D1**2*Pk2*bd2*f*fd*s + 7920*D1**2*Pk2*bdd1*f**3*r*s + 7260*D1**2*Pk2*bdd1*f**3*s**2 - 5280*D1**2*Pk2*bdd1*f**3*s + 1056*D1**2*Pk2*bdd1*f**2*r*s + 6468*D1**2*Pk2*bdd1*f**2*s**2 - 2640*D1**2*Pk2*bdd1*f**2*s - 792*D1**2*Pk2*bdd1*f**2 - 3168*D1**2*Pk2*bdd1*f*g2*r*s + 3168*D1**2*Pk2*bdd1*f*g2*s**2 + 2640*D1**2*Pk2*bdd2*f**2*s**2 - 16608*D1**2*Pk2*f**2*fd*r*s + 5536*D1**2*Pk2*f**2*fd*r - 7068*D1**2*Pk2*f**2*fd*s**2 + 10248*D1**2*Pk2*f**2*fd*s - 2356*D1**2*Pk2*f**2*fd + 13056*D1**2*Pk2*f**2*fdd*r*s - 4352*D1**2*Pk2*f**2*fdd*r + 7692*D1**2*Pk2*f**2*fdd*s**2 - 9480*D1**2*Pk2*f**2*fdd*s + 2564*D1**2*Pk2*f**2*fdd + 10560*D1**2*Pk2*f**2*gd2*s**2 - 5280*D1**2*Pk2*f**2*gdd2*s**2 + 26112*D1**2*Pk2*f*fd**2*r*s - 8704*D1**2*Pk2*f*fd**2*r + 15384*D1**2*Pk2*f*fd**2*s**2 - 18960*D1**2*Pk2*f*fd**2*s + 4352*D1**2*Pk2*f*fd**2 + 21120*D1**2*Pk2*f*fd*g2*s**2 - 21120*D1**2*Pk2*f*fd*g2*s + 10560*D1**2*Pk2*f*fd*g2 - 21120*D1**2*Pk2*f*fd*gd2*s**2 + 10560*D1**2*Pk2*f*fd*gd2*s - 10560*D1**2*Pk2*f*fdd*g2*s**2 + 10560*D1**2*Pk2*f*fdd*g2*s - 5280*D1**2*Pk2*f*fdd*g2 - 10560*D1**2*Pk2*fd**2*g2*s**2 + 10560*D1**2*Pk2*fd**2*g2*s - 250*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 99*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 450*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 300*D1**2*Pkdd2*f**2*fd*k1**2*s + 150*D1**2*Pkdd2*f**2*fd*k1**2 - 225*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 150*D1**2*Pkdd2*f**2*fdd*k1**2*s - 75*D1**2*Pkdd2*f**2*fdd*k1**2 - 450*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 300*D1**2*Pkdd2*f*fd**2*k1**2*s - 21120*D1*Dd*Pk2*b2*f**2*s**2 + 10560*D1*Dd*Pk2*b2*f**2*s - 5280*D1*Dd*Pk2*b2*f**2 + 42240*D1*Dd*Pk2*b2*f*fd*s**2 - 31680*D1*Dd*Pk2*b2*f*fd*s + 5280*D1*Dd*Pk2*b2*f*fd + 21120*D1*Dd*Pk2*bd2*f**2*s**2 - 5280*D1*Dd*Pk2*bd2*f**2*s - 22144*D1*Dd*Pk2*f**3*r*s + 5536*D1*Dd*Pk2*f**3*r - 9424*D1*Dd*Pk2*f**3*s**2 + 15784*D1*Dd*Pk2*f**3*s - 2356*D1*Dd*Pk2*f**3 + 104448*D1*Dd*Pk2*f**2*fd*r*s - 30464*D1*Dd*Pk2*f**2*fd*r + 61536*D1*Dd*Pk2*f**2*fd*s**2 - 79416*D1*Dd*Pk2*f**2*fd*s + 18184*D1*Dd*Pk2*f**2*fd + 42240*D1*Dd*Pk2*f**2*g2*s**2 - 21120*D1*Dd*Pk2*f**2*g2*s + 10560*D1*Dd*Pk2*f**2*g2 - 42240*D1*Dd*Pk2*f**2*gd2*s**2 + 10560*D1*Dd*Pk2*f**2*gd2*s - 84480*D1*Dd*Pk2*f*fd*g2*s**2 + 63360*D1*Dd*Pk2*f*fd*g2*s - 10560*D1*Dd*Pk2*f*fd*g2 + 600*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 300*D1*Dd*Pkdd2*f**3*k1**2*s + 150*D1*Dd*Pkdd2*f**3*k1**2 - 1800*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 1050*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 150*D1*Dd*Pkdd2*f**2*fd*k1**2 + 10560*D1*Ddd*Pk2*b2*f**2*s**2 - 5280*D1*Ddd*Pk2*b2*f**2*s + 2640*D1*Ddd*Pk2*b2*f**2 + 17408*D1*Ddd*Pk2*f**3*r*s - 4352*D1*Ddd*Pk2*f**3*r + 10256*D1*Ddd*Pk2*f**3*s**2 - 13832*D1*Ddd*Pk2*f**3*s + 2564*D1*Ddd*Pk2*f**3 - 21120*D1*Ddd*Pk2*f**2*g2*s**2 + 10560*D1*Ddd*Pk2*f**2*g2*s - 5280*D1*Ddd*Pk2*f**2*g2 - 300*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 150*D1*Ddd*Pkdd2*f**3*k1**2*s - 75*D1*Ddd*Pkdd2*f**3*k1**2 - 2*D1*bd1*(D1*(-1584*Pk2*fd*g2*(-2*r*s + r + s*(2*s - 2)) + 10*f**3*s*(33*Pk2*(12*r + 15*s - 8) - 25*Pkdd2*k1**2*s) + f**2*(-66*Pk2*(10*fd*(6*r*(6*s - 1) + 33*s**2 - 31*s + 4) + s**2*(48*C - 40*K - 77) - s*(40*C*r + 12*r - 28) + 12) + Pkdd2*k1**2*s*(250*fd*(3*s - 1) - 99*s)) - 33*f*(4*Pk2*fd*(r*(12*C + 4)*(4*s - 1) + s**2*(-48*C + 40*K + 98) + s*(12*C - 20*K - 63) + 16) + 48*Pk2*s*(2*g2*r - 2*g2*s - 2*gd2*r + 2*gd2*s + gd2) + 3*Pkdd2*fd*k1**2*s*(1 - 2*s))) - Dd*f*(1584*Pk2*g2*(-8*r*s + r + 8*s**2) + 10*f**2*(66*Pk2*(6*r*(8*s - 1) + 44*s**2 - 39*s + 4) + 25*Pkdd2*k1**2*s*(1 - 4*s)) + 33*f*(4*Pk2*(r*(12*C + 4)*(8*s - 1) + s**2*(-96*C + 80*K + 196) - s*(20*K + 97) + 10) + 3*Pkdd2*k1**2*s*(1 - 4*s)))) + 31680*Dd**2*Pk2*b2*f**2*s**2 - 15840*Dd**2*Pk2*b2*f**2*s + 52224*Dd**2*Pk2*f**3*r*s - 13056*Dd**2*Pk2*f**3*r + 30768*Dd**2*Pk2*f**3*s**2 - 41496*Dd**2*Pk2*f**3*s + 8704*Dd**2*Pk2*f**3 - 63360*Dd**2*Pk2*f**2*g2*s**2 + 31680*Dd**2*Pk2*f**2*g2*s - 900*Dd**2*Pkdd2*f**3*k1**2*s**2 + 450*Dd**2*Pkdd2*f**3*k1**2*s + 264*Pk2*b1**2*(-2*D1*Dd*(6*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s) + fd*(24*K*s**2 - 24*K*s + 5*f*(4*s - 1) - r*(3*K - 3)*(8*s - 5) + 6*s + 3)) - D1*(D1*(10*fd**2*s - 2*fd*(-6*K*(s - 1)*(r - s + 1) + 5*f*(2*s - 1) + 6*r*s - 6*r + 6*s - 3) + fdd*(-6*K*(s - 1)*(r - s + 1) + 5*f*(2*s - 1) + 6*r*s - 6*r + 6*s - 3)) - 6*Ddd*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s)) + 6*Dd**2*f*(K*(3*r*(4*s - 1) - 12*s**2 + 2) + r*(3 - 12*s) + 6*s - 2)) + b1*(-10560*C*D1**2*Pk2*f*fd*r*s + 5280*C*D1**2*Pk2*f*fd*r + 12672*C*D1**2*Pk2*f*fd*s**2 - 7392*C*D1**2*Pk2*f*fd*s + 6336*C*D1**2*Pk2*f*fd + 6336*C*D1**2*Pk2*f*fdd*r*s - 3168*C*D1**2*Pk2*f*fdd*r - 6336*C*D1**2*Pk2*f*fdd*s**2 + 3168*C*D1**2*Pk2*f*fdd*s - 3168*C*D1**2*Pk2*f*fdd + 6336*C*D1**2*Pk2*fd**2*r*s - 3168*C*D1**2*Pk2*fd**2*r - 6336*C*D1**2*Pk2*fd**2*s**2 + 3168*C*D1**2*Pk2*fd**2*s + 3168*C*D1**2*Pk2*fd**2 - 21120*C*D1*Dd*Pk2*f**2*r*s + 5280*C*D1*Dd*Pk2*f**2*r + 25344*C*D1*Dd*Pk2*f**2*s**2 - 2112*C*D1*Dd*Pk2*f**2*s + 6336*C*D1*Dd*Pk2*f**2 + 50688*C*D1*Dd*Pk2*f*fd*r*s - 19008*C*D1*Dd*Pk2*f*fd*r - 50688*C*D1*Dd*Pk2*f*fd*s**2 + 12672*C*D1*Dd*Pk2*f*fd*s + 3168*C*D1*Dd*Pk2*f*fd + 12672*C*D1*Ddd*Pk2*f**2*r*s - 3168*C*D1*Ddd*Pk2*f**2*r - 12672*C*D1*Ddd*Pk2*f**2*s**2 - 3168*C*D1*Ddd*Pk2*f**2 + 38016*C*Dd**2*Pk2*f**2*r*s - 9504*C*Dd**2*Pk2*f**2*r - 38016*C*Dd**2*Pk2*f**2*s**2 + 6336*C*Dd**2*Pk2*f**2 - 10560*D1**2*K*Pk2*f*fd*s**2 + 10560*D1**2*K*Pk2*f*fd*s - 5280*D1**2*K*Pk2*f*fd + 5280*D1**2*K*Pk2*f*fdd*s**2 - 5280*D1**2*K*Pk2*f*fdd*s + 2640*D1**2*K*Pk2*f*fdd + 5280*D1**2*K*Pk2*fd**2*s**2 - 5280*D1**2*K*Pk2*fd**2*s + 264*D1**2*Pk2*bdd1*f*(-12*K*s**2 + 5*f*(2*s - 1) - 3*s*(-4*K*r + 2*K + 4*r - 4) - 3) - 23760*D1**2*Pk2*f**2*fd*r*s + 7920*D1**2*Pk2*f**2*fd*r - 29700*D1**2*Pk2*f**2*fd*s**2 + 30360*D1**2*Pk2*f**2*fd*s - 9900*D1**2*Pk2*f**2*fd + 23760*D1**2*Pk2*f**2*fdd*r*s - 7920*D1**2*Pk2*f**2*fdd*r + 21780*D1**2*Pk2*f**2*fdd*s**2 - 25080*D1**2*Pk2*f**2*fdd*s + 7260*D1**2*Pk2*f**2*fdd + 47520*D1**2*Pk2*f*fd**2*r*s - 15840*D1**2*Pk2*f*fd**2*r + 43560*D1**2*Pk2*f*fd**2*s**2 - 50160*D1**2*Pk2*f*fd**2*s + 10560*D1**2*Pk2*f*fd**2 - 3168*D1**2*Pk2*f*fd*r*s + 1584*D1**2*Pk2*f*fd*r - 20328*D1**2*Pk2*f*fd*s**2 + 18216*D1**2*Pk2*f*fd*s - 11748*D1**2*Pk2*f*fd + 2112*D1**2*Pk2*f*fdd*r*s - 1056*D1**2*Pk2*f*fdd*r + 12936*D1**2*Pk2*f*fdd*s**2 - 11352*D1**2*Pk2*f*fdd*s + 7260*D1**2*Pk2*f*fdd + 6336*D1**2*Pk2*f*gd2*r*s - 6336*D1**2*Pk2*f*gd2*s**2 - 6336*D1**2*Pk2*f*gd2*s - 3168*D1**2*Pk2*f*gdd2*r*s + 3168*D1**2*Pk2*f*gdd2*s**2 + 3168*D1**2*Pk2*f*gdd2*s + 2112*D1**2*Pk2*fd**2*r*s - 1056*D1**2*Pk2*fd**2*r + 12936*D1**2*Pk2*fd**2*s**2 - 11352*D1**2*Pk2*fd**2*s - 3168*D1**2*Pk2*fd**2 + 6336*D1**2*Pk2*fd*g2*r*s - 6336*D1**2*Pk2*fd*g2*r - 6336*D1**2*Pk2*fd*g2*s**2 + 12672*D1**2*Pk2*fd*g2*s - 6336*D1**2*Pk2*fd*g2 - 6336*D1**2*Pk2*fd*gd2*r*s + 3168*D1**2*Pk2*fd*gd2*r + 6336*D1**2*Pk2*fd*gd2*s**2 - 3168*D1**2*Pk2*fd*gd2*s - 3168*D1**2*Pk2*fd*gd2 - 3168*D1**2*Pk2*fdd*g2*r*s + 3168*D1**2*Pk2*fdd*g2*r + 3168*D1**2*Pk2*fdd*g2*s**2 - 6336*D1**2*Pk2*fdd*g2*s + 3168*D1**2*Pk2*fdd*g2 + 1500*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 1000*D1**2*Pkdd2*f**2*fd*k1**2*s + 500*D1**2*Pkdd2*f**2*fd*k1**2 - 750*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 500*D1**2*Pkdd2*f**2*fdd*k1**2*s - 250*D1**2*Pkdd2*f**2*fdd*k1**2 - 1500*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 1000*D1**2*Pkdd2*f*fd**2*k1**2*s + 396*D1**2*Pkdd2*f*fd*k1**2*s**2 - 396*D1**2*Pkdd2*f*fd*k1**2*s + 198*D1**2*Pkdd2*f*fd*k1**2 - 198*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 198*D1**2*Pkdd2*f*fdd*k1**2*s - 99*D1**2*Pkdd2*f*fdd*k1**2 - 198*D1**2*Pkdd2*fd**2*k1**2*s**2 + 198*D1**2*Pkdd2*fd**2*k1**2*s - 21120*D1*Dd*K*Pk2*f**2*s**2 + 10560*D1*Dd*K*Pk2*f**2*s - 5280*D1*Dd*K*Pk2*f**2 + 42240*D1*Dd*K*Pk2*f*fd*s**2 - 31680*D1*Dd*K*Pk2*f*fd*s + 5280*D1*Dd*K*Pk2*f*fd - 31680*D1*Dd*Pk2*f**3*r*s + 7920*D1*Dd*Pk2*f**3*r - 39600*D1*Dd*Pk2*f**3*s**2 + 35640*D1*Dd*Pk2*f**3*s - 9900*D1*Dd*Pk2*f**3 + 190080*D1*Dd*Pk2*f**2*fd*r*s - 55440*D1*Dd*Pk2*f**2*fd*r + 174240*D1*Dd*Pk2*f**2*fd*s**2 - 191400*D1*Dd*Pk2*f**2*fd*s + 40920*D1*Dd*Pk2*f**2*fd - 6336*D1*Dd*Pk2*f**2*r*s + 1584*D1*Dd*Pk2*f**2*r - 40656*D1*Dd*Pk2*f**2*s**2 + 23496*D1*Dd*Pk2*f**2*s - 10164*D1*Dd*Pk2*f**2 + 16896*D1*Dd*Pk2*f*fd*r*s - 6336*D1*Dd*Pk2*f*fd*r + 103488*D1*Dd*Pk2*f*fd*s**2 - 75504*D1*Dd*Pk2*f*fd*s + 13464*D1*Dd*Pk2*f*fd + 25344*D1*Dd*Pk2*f*g2*r*s - 6336*D1*Dd*Pk2*f*g2*r - 25344*D1*Dd*Pk2*f*g2*s**2 - 6336*D1*Dd*Pk2*f*g2 - 25344*D1*Dd*Pk2*f*gd2*r*s + 3168*D1*Dd*Pk2*f*gd2*r + 25344*D1*Dd*Pk2*f*gd2*s**2 + 12672*D1*Dd*Pk2*f*gd2*s - 3168*D1*Dd*Pk2*f*gd2 - 25344*D1*Dd*Pk2*fd*g2*r*s + 15840*D1*Dd*Pk2*fd*g2*r + 25344*D1*Dd*Pk2*fd*g2*s**2 - 25344*D1*Dd*Pk2*fd*g2*s + 2000*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 1000*D1*Dd*Pkdd2*f**3*k1**2*s + 500*D1*Dd*Pkdd2*f**3*k1**2 - 6000*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 3500*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 500*D1*Dd*Pkdd2*f**2*fd*k1**2 + 792*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 396*D1*Dd*Pkdd2*f**2*k1**2*s + 198*D1*Dd*Pkdd2*f**2*k1**2 - 1584*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 1188*D1*Dd*Pkdd2*f*fd*k1**2*s - 198*D1*Dd*Pkdd2*f*fd*k1**2 + 10560*D1*Ddd*K*Pk2*f**2*s**2 - 5280*D1*Ddd*K*Pk2*f**2*s + 2640*D1*Ddd*K*Pk2*f**2 + 31680*D1*Ddd*Pk2*f**3*r*s - 7920*D1*Ddd*Pk2*f**3*r + 29040*D1*Ddd*Pk2*f**3*s**2 - 30360*D1*Ddd*Pk2*f**3*s + 7260*D1*Ddd*Pk2*f**3 + 4224*D1*Ddd*Pk2*f**2*r*s - 1056*D1*Ddd*Pk2*f**2*r + 25872*D1*Ddd*Pk2*f**2*s**2 - 15048*D1*Ddd*Pk2*f**2*s + 6468*D1*Ddd*Pk2*f**2 - 12672*D1*Ddd*Pk2*f*g2*r*s + 3168*D1*Ddd*Pk2*f*g2*r + 12672*D1*Ddd*Pk2*f*g2*s**2 + 3168*D1*Ddd*Pk2*f*g2 - 1000*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 500*D1*Ddd*Pkdd2*f**3*k1**2*s - 250*D1*Ddd*Pkdd2*f**3*k1**2 - 396*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 198*D1*Ddd*Pkdd2*f**2*k1**2*s - 99*D1*Ddd*Pkdd2*f**2*k1**2 - 528*D1*Pk2*bd1*(D1*(5*f**2*(2*s - 1) - 3*f*(4*K*s**2 + s*(-4*K*r + 2*K + 4*r - 4) + 1) - 3*fd*(K*(4*r*s - 2*r - 4*s**2 + 3*s + 1) - 4*r*s + 2*r - 1)) + Dd*f*(K*(-48*r*s + 6*r + 48*s**2 + 12*s - 3) + f*(5 - 20*s) + 48*r*s - 6*r - 36*s + 6)) + 31680*Dd**2*K*Pk2*f**2*s**2 - 15840*Dd**2*K*Pk2*f**2*s + 95040*Dd**2*Pk2*f**3*r*s - 23760*Dd**2*Pk2*f**3*r + 87120*Dd**2*Pk2*f**3*s**2 - 91080*Dd**2*Pk2*f**3*s + 15840*Dd**2*Pk2*f**3 + 12672*Dd**2*Pk2*f**2*r*s - 3168*Dd**2*Pk2*f**2*r + 77616*Dd**2*Pk2*f**2*s**2 - 45144*Dd**2*Pk2*f**2*s + 2112*Dd**2*Pk2*f**2 - 38016*Dd**2*Pk2*f*g2*r*s + 9504*Dd**2*Pk2*f*g2*r + 38016*Dd**2*Pk2*f*g2*s**2 - 6336*Dd**2*Pk2*f*g2 - 3000*Dd**2*Pkdd2*f**3*k1**2*s**2 + 1500*Dd**2*Pkdd2*f**3*k1**2*s - 1188*Dd**2*Pkdd2*f**2*k1**2*s**2 + 594*Dd**2*Pkdd2*f**2*k1**2*s))/(693*d**2*k2*k3**2) + D1**2*Pk3*ct**3*k1*(7128*C*D1**2*Pk2*bdd1*f**2*r*s - 10560*C*D1**2*Pk2*bdd1*f**2*s**2 - 10320*C*D1**2*Pk2*f**2*fd*r*s + 3440*C*D1**2*Pk2*f**2*fd*r - 35640*C*D1**2*Pk2*f**2*fd*s**2 + 27200*C*D1**2*Pk2*f**2*fd*s - 11880*C*D1**2*Pk2*f**2*fd + 9120*C*D1**2*Pk2*f**2*fdd*r*s - 3040*C*D1**2*Pk2*f**2*fdd*r + 27720*C*D1**2*Pk2*f**2*fdd*s**2 - 21520*C*D1**2*Pk2*f**2*fdd*s + 9240*C*D1**2*Pk2*f**2*fdd + 18240*C*D1**2*Pk2*f*fd**2*r*s - 6080*C*D1**2*Pk2*f*fd**2*r + 55440*C*D1**2*Pk2*f*fd**2*s**2 - 43040*C*D1**2*Pk2*f*fd**2*s + 3040*C*D1**2*Pk2*f*fd**2 - 13760*C*D1*Dd*Pk2*f**3*r*s + 3440*C*D1*Dd*Pk2*f**3*r - 47520*C*D1*Dd*Pk2*f**3*s**2 + 30640*C*D1*Dd*Pk2*f**3*s - 11880*C*D1*Dd*Pk2*f**3 + 72960*C*D1*Dd*Pk2*f**2*fd*r*s - 21280*C*D1*Dd*Pk2*f**2*fd*r + 221760*C*D1*Dd*Pk2*f**2*fd*s**2 - 159760*C*D1*Dd*Pk2*f**2*fd*s + 27600*C*D1*Dd*Pk2*f**2*fd + 12160*C*D1*Ddd*Pk2*f**3*r*s - 3040*C*D1*Ddd*Pk2*f**3*r + 36960*C*D1*Ddd*Pk2*f**3*s**2 - 24560*C*D1*Ddd*Pk2*f**3*s + 9240*C*D1*Ddd*Pk2*f**3 + 36480*C*Dd**2*Pk2*f**3*r*s - 9120*C*Dd**2*Pk2*f**3*r + 110880*C*Dd**2*Pk2*f**3*s**2 - 73680*C*Dd**2*Pk2*f**3*s + 6080*C*Dd**2*Pk2*f**3 + 1584*D1**2*K*Pk2*bdd1*f**2*r*s + 5544*D1**2*K*Pk2*bdd1*f**2*s**2 - 1584*D1**2*K*Pk2*bdd1*f**2*s - 3168*D1**2*Pk2*b2*f*fd*r*s + 1584*D1**2*Pk2*b2*f*fd*r - 14256*D1**2*Pk2*b2*f*fd*s**2 + 14256*D1**2*Pk2*b2*f*fd*s - 7128*D1**2*Pk2*b2*f*fd + 3168*D1**2*Pk2*b2*f*fdd*r*s - 1584*D1**2*Pk2*b2*f*fdd*r + 11088*D1**2*Pk2*b2*f*fdd*s**2 - 11088*D1**2*Pk2*b2*f*fdd*s + 5544*D1**2*Pk2*b2*f*fdd + 3168*D1**2*Pk2*b2*fd**2*r*s - 1584*D1**2*Pk2*b2*fd**2*r + 11088*D1**2*Pk2*b2*fd**2*s**2 - 11088*D1**2*Pk2*b2*fd**2*s - 1584*D1**2*Pk2*bd2*f**2*r*s - 7128*D1**2*Pk2*bd2*f**2*s**2 + 1584*D1**2*Pk2*bd2*f**2*s + 6336*D1**2*Pk2*bd2*f*fd*r*s - 1584*D1**2*Pk2*bd2*f*fd*r + 22176*D1**2*Pk2*bd2*f*fd*s**2 - 14256*D1**2*Pk2*bd2*f*fd*s + 1584*D1**2*Pk2*bd2*f*fd + 2376*D1**2*Pk2*bdd1*f**3*r**2 + 9504*D1**2*Pk2*bdd1*f**3*r*s - 2376*D1**2*Pk2*bdd1*f**3*r + 3960*D1**2*Pk2*bdd1*f**3*s**2 - 6336*D1**2*Pk2*bdd1*f**3*s + 1188*D1**2*Pk2*bdd1*f**3 + 1254*D1**2*Pk2*bdd1*f**2*r**2 - 3828*D1**2*Pk2*bdd1*f**2*r*s + 924*D1**2*Pk2*bdd1*f**2*r + 9636*D1**2*Pk2*bdd1*f**2*s**2 - 1452*D1**2*Pk2*bdd1*f**2*s - 1386*D1**2*Pk2*bdd1*f**2 - 7128*D1**2*Pk2*bdd1*f*g2*r*s + 12408*D1**2*Pk2*bdd1*f*g2*s**2 + 1584*D1**2*Pk2*bdd2*f**2*r*s + 5544*D1**2*Pk2*bdd2*f**2*s**2 - 1584*D1**2*Pk2*bdd2*f**2*s - 5538*D1**2*Pk2*f**2*fd*r**2 - 19404*D1**2*Pk2*f**2*fd*r*s + 10160*D1**2*Pk2*f**2*fd*r + 6732*D1**2*Pk2*f**2*fd*s**2 + 1980*D1**2*Pk2*f**2*fd*s + 398*D1**2*Pk2*f**2*fd + 3858*D1**2*Pk2*f**2*fdd*r**2 + 15444*D1**2*Pk2*f**2*fdd*r*s - 7720*D1**2*Pk2*f**2*fdd*r - 2772*D1**2*Pk2*f**2*fdd*s**2 - 3300*D1**2*Pk2*f**2*fdd*s + 362*D1**2*Pk2*f**2*fdd + 3168*D1**2*Pk2*f**2*gd2*r*s + 14256*D1**2*Pk2*f**2*gd2*s**2 - 3168*D1**2*Pk2*f**2*gd2*s - 3168*D1**2*Pk2*f**2*gdd2*r*s - 11088*D1**2*Pk2*f**2*gdd2*s**2 + 3168*D1**2*Pk2*f**2*gdd2*s + 7716*D1**2*Pk2*f*fd**2*r**2 + 30888*D1**2*Pk2*f*fd**2*r*s - 15440*D1**2*Pk2*f*fd**2*r - 5544*D1**2*Pk2*f*fd**2*s**2 - 6600*D1**2*Pk2*f*fd**2*s + 5148*D1**2*Pk2*f*fd**2 + 6336*D1**2*Pk2*f*fd*g2*r*s - 3168*D1**2*Pk2*f*fd*g2*r + 28512*D1**2*Pk2*f*fd*g2*s**2 - 28512*D1**2*Pk2*f*fd*g2*s + 14256*D1**2*Pk2*f*fd*g2 - 12672*D1**2*Pk2*f*fd*gd2*r*s + 3168*D1**2*Pk2*f*fd*gd2*r - 44352*D1**2*Pk2*f*fd*gd2*s**2 + 28512*D1**2*Pk2*f*fd*gd2*s - 3168*D1**2*Pk2*f*fd*gd2 - 6336*D1**2*Pk2*f*fdd*g2*r*s + 3168*D1**2*Pk2*f*fdd*g2*r - 22176*D1**2*Pk2*f*fdd*g2*s**2 + 22176*D1**2*Pk2*f*fdd*g2*s - 11088*D1**2*Pk2*f*fdd*g2 - 6336*D1**2*Pk2*fd**2*g2*r*s + 3168*D1**2*Pk2*fd**2*g2*r - 22176*D1**2*Pk2*fd**2*g2*s**2 + 22176*D1**2*Pk2*fd**2*g2*s + 165*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 330*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 165*D1**2*Pkdd2*bdd1*f**2*k1**2 + 495*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 330*D1**2*Pkdd2*f**2*fd*k1**2*s + 165*D1**2*Pkdd2*f**2*fd*k1**2 - 132*D1**2*bd1**2*(28*Pk2*g2*r*(1 - 2*s) + f**2*(6*Pk2*(8*r*s - 6*r - 9*s + 4) - 5*Pkdd2*k1**2*s*(s - 1)) + f*(Pk2*(94*K*s**2 + 27*K*s + r*(56*C*s - 28*C - 54*K*s + 50*s + 2) - 100*s + 26) - 3*Pkdd2*k1**2*s*(s - 1))) - 6336*D1*Dd*Pk2*b2*f**2*r*s + 1584*D1*Dd*Pk2*b2*f**2*r - 28512*D1*Dd*Pk2*b2*f**2*s**2 + 17424*D1*Dd*Pk2*b2*f**2*s - 7128*D1*Dd*Pk2*b2*f**2 + 25344*D1*Dd*Pk2*b2*f*fd*r*s - 9504*D1*Dd*Pk2*b2*f*fd*r + 88704*D1*Dd*Pk2*b2*f*fd*s**2 - 72864*D1*Dd*Pk2*b2*f*fd*s + 14256*D1*Dd*Pk2*b2*f*fd + 12672*D1*Dd*Pk2*bd2*f**2*r*s - 1584*D1*Dd*Pk2*bd2*f**2*r + 44352*D1*Dd*Pk2*bd2*f**2*s**2 - 20592*D1*Dd*Pk2*bd2*f**2*s + 1584*D1*Dd*Pk2*bd2*f**2 - 7384*D1*Dd*Pk2*f**3*r**2 - 25872*D1*Dd*Pk2*f**3*r*s + 13852*D1*Dd*Pk2*f**3*r + 8976*D1*Dd*Pk2*f**3*s**2 + 8448*D1*Dd*Pk2*f**3*s - 1448*D1*Dd*Pk2*f**3 + 30864*D1*Dd*Pk2*f**2*fd*r**2 + 123552*D1*Dd*Pk2*f**2*fd*r*s - 61756*D1*Dd*Pk2*f**2*fd*r - 22176*D1*Dd*Pk2*f**2*fd*s**2 - 38544*D1*Dd*Pk2*f**2*fd*s + 18740*D1*Dd*Pk2*f**2*fd + 12672*D1*Dd*Pk2*f**2*g2*r*s - 3168*D1*Dd*Pk2*f**2*g2*r + 57024*D1*Dd*Pk2*f**2*g2*s**2 - 34848*D1*Dd*Pk2*f**2*g2*s + 14256*D1*Dd*Pk2*f**2*g2 - 25344*D1*Dd*Pk2*f**2*gd2*r*s + 3168*D1*Dd*Pk2*f**2*gd2*r - 88704*D1*Dd*Pk2*f**2*gd2*s**2 + 41184*D1*Dd*Pk2*f**2*gd2*s - 3168*D1*Dd*Pk2*f**2*gd2 - 50688*D1*Dd*Pk2*f*fd*g2*r*s + 19008*D1*Dd*Pk2*f*fd*g2*r - 177408*D1*Dd*Pk2*f*fd*g2*s**2 + 145728*D1*Dd*Pk2*f*fd*g2*s - 28512*D1*Dd*Pk2*f*fd*g2 + 660*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 330*D1*Dd*Pkdd2*f**3*k1**2*s + 165*D1*Dd*Pkdd2*f**3*k1**2 + 6336*D1*Ddd*Pk2*b2*f**2*r*s - 1584*D1*Ddd*Pk2*b2*f**2*r + 22176*D1*Ddd*Pk2*b2*f**2*s**2 - 14256*D1*Ddd*Pk2*b2*f**2*s + 5544*D1*Ddd*Pk2*b2*f**2 + 5144*D1*Ddd*Pk2*f**3*r**2 + 20592*D1*Ddd*Pk2*f**3*r*s - 10292*D1*Ddd*Pk2*f**3*r - 3696*D1*Ddd*Pk2*f**3*s**2 - 8448*D1*Ddd*Pk2*f**3*s + 1648*D1*Ddd*Pk2*f**3 - 12672*D1*Ddd*Pk2*f**2*g2*r*s + 3168*D1*Ddd*Pk2*f**2*g2*r - 44352*D1*Ddd*Pk2*f**2*g2*s**2 + 28512*D1*Ddd*Pk2*f**2*g2*s - 11088*D1*Ddd*Pk2*f**2*g2 - 66*D1*bd1*(D1*(4*Pk2*fd*g2*(27*r*(2*s - 1) + s*(94 - 94*s)) + f**3*(6*Pk2*(6*r**2 + 6*r*(4*s - 1) + 10*s**2 - 16*s + 3) - 5*Pkdd2*k1**2*s**2) + f**2*(Pk2*(-200*C*s**2 + 108*K*s**2 - 24*K*s - 12*fd*(18*r**2 + 6*r*(12*s - 5) + 30*s**2 - 50*s + 11) + 19*r**2 + 2*r*(s*(80*C + 12*K - 57) + 21) + 166*s**2 - 26*s - 31) + Pkdd2*k1**2*(2*s**2 - 10*s + 5)) - 2*f*(2*Pk2*s*(g2*(40*r - 59*s) + gd2*(-54*r + 94*s + 27)) + fd*(Pk2*(-320*C*s**2 + 106*C*s + 12*K*(r*(4*s - 1) + 14*s**2 - 9*s + 1) + 38*r**2 + r*(54*C*(4*s - 1) - 116*s + 17) + 292*s**2 - 128*s + 25) + 5*Pkdd2*k1**2*s*(s - 1)))) - Dd*f*(24*Pk2*f**2*(12*r**2 + 6*r*(8*s - 3) + 20*s**2 - 33*s + 7) + 4*Pk2*g2*(-27*r*(8*s - 1) + 8*s*(47*s - 5)) + f*(2*Pk2*(-640*C*s**2 + 52*C*s + 12*K*(r*(8*s - 1) + 28*s**2 - 13*s + 1) + 76*r**2 + r*(54*C*(8*s - 1) - 232*s + 19) + 584*s**2 - 132*s - 3) + 5*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 19008*Dd**2*Pk2*b2*f**2*r*s - 4752*Dd**2*Pk2*b2*f**2*r + 66528*Dd**2*Pk2*b2*f**2*s**2 - 42768*Dd**2*Pk2*b2*f**2*s + 3168*Dd**2*Pk2*b2*f**2 + 15432*Dd**2*Pk2*f**3*r**2 + 61776*Dd**2*Pk2*f**3*r*s - 30876*Dd**2*Pk2*f**3*r - 11088*Dd**2*Pk2*f**3*s**2 - 25344*Dd**2*Pk2*f**3*s + 12868*Dd**2*Pk2*f**3 - 38016*Dd**2*Pk2*f**2*g2*r*s + 9504*Dd**2*Pk2*f**2*g2*r - 133056*Dd**2*Pk2*f**2*g2*s**2 + 85536*Dd**2*Pk2*f**2*g2*s - 6336*Dd**2*Pk2*f**2*g2 - 1848*Pk2*b1**3*(K - 1)*(2*D1*Dd*(-4*r*s + r + 2*s) + D1*Ddd*(r*(4*s - 1) - 2*s) + Dd**2*(3*r*(4*s - 1) - 6*s + 2)) + 66*b1**2*(-2*D1*Dd*(-224*C*Pk2*f*r*s + 56*C*Pk2*f*r + 112*C*Pk2*f*s + 160*K*Pk2*f*r*s - 40*K*Pk2*f*r - 236*K*Pk2*f*s**2 + 38*K*Pk2*f*s - 59*K*Pk2*f - 96*Pk2*f**2*r*s + 24*Pk2*f**2*r + 48*Pk2*f**2*s - 88*Pk2*f*r*s + 22*Pk2*f*r + 44*Pk2*f*s + Pk2*fd*(28*C*(r*(8*s - 1) - 6*s + 1) - 216*K*r*s + 135*K*r + 376*K*s**2 - 416*K*s + 40*K + 6*f*(64*r*s - 12*s - 5) + 200*r*s - 133*r + 250*s - 21) + 224*Pk2*g2*r*s - 56*Pk2*g2*r - 112*Pk2*g2*s - 28*Pk2*gd2*(r*(8*s - 1) - 6*s + 1) + 20*Pkdd2*f**2*k1**2*s**2 - 10*Pkdd2*f**2*k1**2*s + 5*Pkdd2*f**2*k1**2 + 12*Pkdd2*f*k1**2*s**2 - 6*Pkdd2*f*k1**2*s + 3*Pkdd2*f*k1**2 - Pkdd2*fd*k1**2*s*(10*f + 3)*(4*s - 1)) - 28*D1*Pk2*bd1*(K - 1)*(2*D1*(-3*r*s + r + s) + Dd*(r*(24*s - 7) - 10*s + 3)) + D1*(D1*(-28*Pk2*(bdd1*(K - 1)*(r*(3*s - 1) - s) + s*(4*gd2 - 2*gdd2)*(r - 1)) - 2*fd**2*(6*Pk2*(r*(8*s + 2) + s - 2) - 5*Pkdd2*k1**2*s**2) + fd*(Pk2*(112*C*r*s - 112*C*s - 2*K*(s - 1)*(40*r - 59*s + 59) + 6*f*(4*r*(4*s + 1) + 6*s - 9) + 44*r*s - 80*r + 230*s - 59) + Pkdd2*k1**2*s**2*(-20*f - 6)) + fdd*(-Pk2*(56*C*r*s - 56*C*s - 2*K*(s - 1)*(27*r - 47*s + 47) + 6*f*(4*r*(4*s + 1) + 2*s - 7) + 50*r*s - 54*r + 150*s - 47) + Pkdd2*k1**2*s**2*(10*f + 3))) + Ddd*(56*Pk2*g2*(r*(4*s - 1) - 2*s) + f**2*(48*Pk2*(-4*r*s + r + 2*s) + 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(2*K*Pk2*(27*r*(4*s - 1) - 188*s**2 + 40*s - 47) + Pk2*(-56*C - 50)*(4*r*s - r - 2*s) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) - 2*Dd**2*(-28*Pk2*g2*(3*r*(4*s - 1) - 6*s + 2) + 3*f**2*(8*Pk2*(3*r*(4*s - 1) - 6*s + 2) + 5*Pkdd2*k1**2*s*(1 - 2*s)) + f*(Pk2*(28*C*(3*r*(4*s - 1) - 6*s + 2) - 3*K*(27*r*(4*s - 1) - 188*s**2 + 40*s + 18) + 75*r*(4*s - 1) - 150*s + 50) + 9*Pkdd2*k1**2*s*(1 - 2*s)))) - 33*b1*(640*C*D1**2*Pk2*f*fd*r*s - 320*C*D1**2*Pk2*f*fd*r - 800*C*D1**2*Pk2*f*fd*s**2 + 480*C*D1**2*Pk2*f*fd*s - 400*C*D1**2*Pk2*f*fd - 432*C*D1**2*Pk2*f*fdd*r*s + 216*C*D1**2*Pk2*f*fdd*r + 640*C*D1**2*Pk2*f*fdd*s**2 - 424*C*D1**2*Pk2*f*fdd*s + 320*C*D1**2*Pk2*f*fdd - 432*C*D1**2*Pk2*fd**2*r*s + 216*C*D1**2*Pk2*fd**2*r + 640*C*D1**2*Pk2*fd**2*s**2 - 424*C*D1**2*Pk2*fd**2*s - 216*C*D1**2*Pk2*fd**2 + 1280*C*D1*Dd*Pk2*f**2*r*s - 320*C*D1*Dd*Pk2*f**2*r - 1600*C*D1*Dd*Pk2*f**2*s**2 + 160*C*D1*Dd*Pk2*f**2*s - 400*C*D1*Dd*Pk2*f**2 - 3456*C*D1*Dd*Pk2*f*fd*r*s + 1296*C*D1*Dd*Pk2*f*fd*r + 5120*C*D1*Dd*Pk2*f*fd*s**2 - 2112*C*D1*Dd*Pk2*f*fd*s - 8*C*D1*Dd*Pk2*f*fd - 864*C*D1*Ddd*Pk2*f**2*r*s + 216*C*D1*Ddd*Pk2*f**2*r + 1280*C*D1*Ddd*Pk2*f**2*s**2 - 208*C*D1*Ddd*Pk2*f**2*s + 320*C*D1*Ddd*Pk2*f**2 - 2592*C*Dd**2*Pk2*f**2*r*s + 648*C*Dd**2*Pk2*f**2*r + 3840*C*Dd**2*Pk2*f**2*s**2 - 624*C*Dd**2*Pk2*f**2*s - 432*C*Dd**2*Pk2*f**2 + 96*D1**2*K*Pk2*f*fd*r*s - 48*D1**2*K*Pk2*f*fd*r + 432*D1**2*K*Pk2*f*fd*s**2 - 432*D1**2*K*Pk2*f*fd*s + 216*D1**2*K*Pk2*f*fd - 96*D1**2*K*Pk2*f*fdd*r*s + 48*D1**2*K*Pk2*f*fdd*r - 336*D1**2*K*Pk2*f*fdd*s**2 + 336*D1**2*K*Pk2*f*fdd*s - 168*D1**2*K*Pk2*f*fdd - 96*D1**2*K*Pk2*fd**2*r*s + 48*D1**2*K*Pk2*fd**2*r - 336*D1**2*K*Pk2*fd**2*s**2 + 336*D1**2*K*Pk2*fd**2*s + 56*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) - 2*s + 1) + 216*D1**2*Pk2*f**2*fd*r**2 + 864*D1**2*Pk2*f**2*fd*r*s - 504*D1**2*Pk2*f**2*fd*r + 360*D1**2*Pk2*f**2*fd*s**2 - 624*D1**2*Pk2*f**2*fd*s + 228*D1**2*Pk2*f**2*fd - 216*D1**2*Pk2*f**2*fdd*r**2 - 864*D1**2*Pk2*f**2*fdd*r*s + 504*D1**2*Pk2*f**2*fdd*r - 360*D1**2*Pk2*f**2*fdd*s**2 + 624*D1**2*Pk2*f**2*fdd*s - 228*D1**2*Pk2*f**2*fdd - 432*D1**2*Pk2*f*fd**2*r**2 - 1728*D1**2*Pk2*f*fd**2*r*s + 1008*D1**2*Pk2*f*fd**2*r - 720*D1**2*Pk2*f*fd**2*s**2 + 1248*D1**2*Pk2*f*fd**2*s - 456*D1**2*Pk2*f*fd**2 + 76*D1**2*Pk2*f*fd*r**2 - 456*D1**2*Pk2*f*fd*r*s + 68*D1**2*Pk2*f*fd*r + 664*D1**2*Pk2*f*fd*s**2 - 384*D1**2*Pk2*f*fd*s + 432*D1**2*Pk2*f*fd - 76*D1**2*Pk2*f*fdd*r**2 + 232*D1**2*Pk2*f*fdd*r*s - 12*D1**2*Pk2*f*fdd*r - 584*D1**2*Pk2*f*fdd*s**2 + 424*D1**2*Pk2*f*fdd*s - 372*D1**2*Pk2*f*fdd - 320*D1**2*Pk2*f*gd2*r*s + 472*D1**2*Pk2*f*gd2*s**2 + 320*D1**2*Pk2*f*gd2*s + 216*D1**2*Pk2*f*gdd2*r*s - 376*D1**2*Pk2*f*gdd2*s**2 - 216*D1**2*Pk2*f*gdd2*s - 76*D1**2*Pk2*fd**2*r**2 + 232*D1**2*Pk2*fd**2*r*s - 12*D1**2*Pk2*fd**2*r - 584*D1**2*Pk2*fd**2*s**2 + 424*D1**2*Pk2*fd**2*s + 216*D1**2*Pk2*fd**2 - 320*D1**2*Pk2*fd*g2*r*s + 320*D1**2*Pk2*fd*g2*r + 472*D1**2*Pk2*fd*g2*s**2 - 944*D1**2*Pk2*fd*g2*s + 472*D1**2*Pk2*fd*g2 + 432*D1**2*Pk2*fd*gd2*r*s - 216*D1**2*Pk2*fd*gd2*r - 752*D1**2*Pk2*fd*gd2*s**2 + 536*D1**2*Pk2*fd*gd2*s + 216*D1**2*Pk2*fd*gd2 + 216*D1**2*Pk2*fdd*g2*r*s - 216*D1**2*Pk2*fdd*g2*r - 376*D1**2*Pk2*fdd*g2*s**2 + 752*D1**2*Pk2*fdd*g2*s - 376*D1**2*Pk2*fdd*g2 - 30*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 20*D1**2*Pkdd2*f**2*fd*k1**2*s - 10*D1**2*Pkdd2*f**2*fd*k1**2 + 8*D1**2*Pkdd2*f*fd*k1**2*s**2 + 12*D1**2*Pkdd2*f*fd*k1**2*s - 6*D1**2*Pkdd2*f*fd*k1**2 - 10*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 10*D1**2*Pkdd2*fd**2*k1**2*s**2 + 2*D1**2*bdd1*(56*Pk2*g2*r*(1 - 2*s) + f**2*(6*Pk2*(4*r*(4*s - 3) - 18*s + 7) - 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(Pk2*(188*K*s**2 + 54*K*s + 4*r*(28*C*s - 14*C - 27*K*s + 25*s + 1) - 200*s + 47) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 192*D1*Dd*K*Pk2*f**2*r*s - 48*D1*Dd*K*Pk2*f**2*r + 864*D1*Dd*K*Pk2*f**2*s**2 - 528*D1*Dd*K*Pk2*f**2*s + 216*D1*Dd*K*Pk2*f**2 - 768*D1*Dd*K*Pk2*f*fd*r*s + 288*D1*Dd*K*Pk2*f*fd*r - 2688*D1*Dd*K*Pk2*f*fd*s**2 + 2208*D1*Dd*K*Pk2*f*fd*s - 432*D1*Dd*K*Pk2*f*fd + 288*D1*Dd*Pk2*f**3*r**2 + 1152*D1*Dd*Pk2*f**3*r*s - 576*D1*Dd*Pk2*f**3*r + 480*D1*Dd*Pk2*f**3*s**2 - 816*D1*Dd*Pk2*f**3*s + 264*D1*Dd*Pk2*f**3 - 1728*D1*Dd*Pk2*f**2*fd*r**2 - 6912*D1*Dd*Pk2*f**2*fd*r*s + 3744*D1*Dd*Pk2*f**2*fd*r - 2880*D1*Dd*Pk2*f**2*fd*s**2 + 4944*D1*Dd*Pk2*f**2*fd*s - 1632*D1*Dd*Pk2*f**2*fd + 152*D1*Dd*Pk2*f**2*r**2 - 912*D1*Dd*Pk2*f**2*r*s + 76*D1*Dd*Pk2*f**2*r + 1328*D1*Dd*Pk2*f**2*s**2 - 208*D1*Dd*Pk2*f**2*s + 408*D1*Dd*Pk2*f**2 - 608*D1*Dd*Pk2*f*fd*r**2 + 1856*D1*Dd*Pk2*f*fd*r*s + 24*D1*Dd*Pk2*f*fd*r - 4672*D1*Dd*Pk2*f*fd*s**2 + 2400*D1*Dd*Pk2*f*fd*s - 400*D1*Dd*Pk2*f*fd - 1280*D1*Dd*Pk2*f*g2*r*s + 320*D1*Dd*Pk2*f*g2*r + 1888*D1*Dd*Pk2*f*g2*s**2 - 304*D1*Dd*Pk2*f*g2*s + 472*D1*Dd*Pk2*f*g2 + 1728*D1*Dd*Pk2*f*gd2*r*s - 216*D1*Dd*Pk2*f*gd2*r - 3008*D1*Dd*Pk2*f*gd2*s**2 - 544*D1*Dd*Pk2*f*gd2*s + 216*D1*Dd*Pk2*f*gd2 + 1728*D1*Dd*Pk2*fd*g2*r*s - 1080*D1*Dd*Pk2*fd*g2*r - 3008*D1*Dd*Pk2*fd*g2*s**2 + 3328*D1*Dd*Pk2*fd*g2*s - 320*D1*Dd*Pk2*fd*g2 - 40*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 20*D1*Dd*Pkdd2*f**3*k1**2*s - 10*D1*Dd*Pkdd2*f**3*k1**2 + 16*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 8*D1*Dd*Pkdd2*f**2*k1**2*s + 4*D1*Dd*Pkdd2*f**2*k1**2 - 80*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 20*D1*Dd*Pkdd2*f*fd*k1**2*s - 192*D1*Ddd*K*Pk2*f**2*r*s + 48*D1*Ddd*K*Pk2*f**2*r - 672*D1*Ddd*K*Pk2*f**2*s**2 + 432*D1*Ddd*K*Pk2*f**2*s - 168*D1*Ddd*K*Pk2*f**2 - 288*D1*Ddd*Pk2*f**3*r**2 - 1152*D1*Ddd*Pk2*f**3*r*s + 576*D1*Ddd*Pk2*f**3*r - 480*D1*Ddd*Pk2*f**3*s**2 + 816*D1*Ddd*Pk2*f**3*s - 264*D1*Ddd*Pk2*f**3 - 152*D1*Ddd*Pk2*f**2*r**2 + 464*D1*Ddd*Pk2*f**2*r*s + 36*D1*Ddd*Pk2*f**2*r - 1168*D1*Ddd*Pk2*f**2*s**2 + 352*D1*Ddd*Pk2*f**2*s - 368*D1*Ddd*Pk2*f**2 + 864*D1*Ddd*Pk2*f*g2*r*s - 216*D1*Ddd*Pk2*f*g2*r - 1504*D1*Ddd*Pk2*f*g2*s**2 + 320*D1*Ddd*Pk2*f*g2*s - 376*D1*Ddd*Pk2*f*g2 - 20*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 10*D1*Ddd*Pkdd2*f**2*k1**2*s - 5*D1*Ddd*Pkdd2*f**2*k1**2 - 2*D1*bd1*(D1*(-2*Pk2*fd*(28*C*(r*(4*s - 1) - 2*s + 1) + K*(-108*r*s + 54*r + 188*s**2 - 161*s - 27) + 100*r*s - 52*r + 50*s - 1) - 112*Pk2*g2*r*(2*s - 1) - 56*Pk2*gd2*(-4*r*s + r + 2*s - 1) - 6*Pkdd2*fd*k1**2*s*(1 - 2*s) + 2*f**2*(3*Pk2*(4*r*(4*s - 3) - 22*s + 9) - 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(Pk2*(236*K*s**2 + 80*K*s - 24*fd*(4*r*(4*s - 1) - 8*s + 3) + 4*r*(56*C*s - 28*C - 40*K*s + 22*s + 9) - 274*s + 59) + 2*Pkdd2*k1**2*(s**2*(20*fd - 6) + s*(6 - 10*fd) - 3))) - 2*Dd*(-56*Pk2*g2*(r*(8*s - 3) - 2*s + 1) + f**2*(6*Pk2*(32*r*(2*s - 1) - 52*s + 21) - 5*Pkdd2*k1**2*(8*s**2 - 6*s + 1)) + f*(Pk2*(56*C*(r*(8*s - 3) - 2*s + 1) + K*(-432*r*s + 54*r + 752*s**2 + 28*s - 27) + 400*r*s - 42*r - 500*s + 96) - 3*Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) - 576*Dd**2*K*Pk2*f**2*r*s + 144*Dd**2*K*Pk2*f**2*r - 2016*Dd**2*K*Pk2*f**2*s**2 + 1296*Dd**2*K*Pk2*f**2*s - 96*Dd**2*K*Pk2*f**2 - 864*Dd**2*Pk2*f**3*r**2 - 3456*Dd**2*Pk2*f**3*r*s + 1728*Dd**2*Pk2*f**3*r - 1440*Dd**2*Pk2*f**3*s**2 + 2448*Dd**2*Pk2*f**3*s - 720*Dd**2*Pk2*f**3 - 456*Dd**2*Pk2*f**2*r**2 + 1392*Dd**2*Pk2*f**2*r*s + 108*Dd**2*Pk2*f**2*r - 3504*Dd**2*Pk2*f**2*s**2 + 1056*Dd**2*Pk2*f**2*s + 156*Dd**2*Pk2*f**2 + 2592*Dd**2*Pk2*f*g2*r*s - 648*Dd**2*Pk2*f*g2*r - 4512*Dd**2*Pk2*f*g2*s**2 + 960*Dd**2*Pk2*f*g2*s + 432*Dd**2*Pk2*f*g2 - 60*Dd**2*Pkdd2*f**2*k1**2*s**2 + 30*Dd**2*Pkdd2*f**2*k1**2*s))/(693*d**2*k2*k3**2) - D1**2*Pk3*ct**3*k2**3*st**2*(D1**2*(165*Pkdd2*bd1*f**3*k1**2*s**2 + 33*Pkdd2*k1**2*s*(b1**2*s*(10*fd**2 + 6*fd*(2*K - 1) + fdd*(3 - 6*K)) - 2*b1*(3*bd1*fd*(2*K - 1)*(2*s - 1) + fd**2*(10*K*(s - 1) + s*(12*C - 9)) + 12*fd*s*(g2 - gd2) - 6*fdd*g2*s) + 8*fd*g2*(3*bd1 + 5*fd)*(s - 1)) + f**2*(33*Pkdd2*k1**2*(10*bd1**2*s*(s - 1) + bd1*(24*C*(s - 1)**2 + 14*K*s**2 - 10*b1*(2*s**2 - 2*s + 1) - 15*s**2 + 36*s - 18) + bdd1*(-12*C*(s - 1)**2 - 10*K*s**2 + 5*b1*(2*s**2 - 2*s + 1) + 9*s**2 - 18*s + 9) + s**2*(-28*gd2 + 20*gdd2)) + fd*(4*Pk2*(4*C*(93*r**2 + 42*r*s - 76*r - 14*s + 31) - 237*r**2 - 84*r*s + 186*r + 28*s - 79) + Pkdd2*k1**2*(604*C + 165*b1 - 203)*(3*s**2 - 2*s + 1)) - 2*fdd*(16*Pk2*(4*C*(12*r**2 + 15*r*s - 13*r - 5*s + 4) - 21*r**2 - 30*r*s + 24*r + 10*s - 7) + Pkdd2*k1**2*(250*C - 125)*(3*s**2 - 2*s + 1))) + f*(-33*Pkdd2*fd*k1**2*(20*b1**2*s**2 + b1*(-14*K*(2*s**2 - 2*s + 1) + s**2*(-48*C - 40*bd1 + 30) + s*(20*bd1 + 6) - 3) + 4*bd1*s*(12*C*(s - 1) + 5*K*(2*s - 1) - 9*s + 9) + 28*g2*(2*s**2 - 2*s + 1) + 40*gd2*s*(1 - 2*s)) + 33*Pkdd2*k1**2*(10*b1**2*fdd*s**2 + b1*(-10*K*fdd*(2*s**2 - 2*s + 1) + 6*bd1*(2*K - 1)*(2*s**2 - 2*s + 1) - 3*bdd1*(2*K - 1)*(2*s**2 - 2*s + 1) - 2*fdd*s**2*(12*C - 9) - 2*s**2*(12*gd2 - 6*gdd2)) - 6*bd1**2*s*(2*K - 1)*(s - 1) - 24*bd1*(s - 1)*(g2*(s - 1) - gd2*s) + 4*g2*(3*bdd1*(s - 1)**2 + 5*fdd*(2*s**2 - 2*s + 1))) - 4*fd**2*(16*Pk2*(2*C*(24*r**2 + 30*r*s - 26*r - 10*s + 5) - 21*r**2 - 30*r*s + 24*r + 10*s - 5) + Pkdd2*k1**2*s*(250*C - 125)*(3*s - 2)))) + D1*(Dd*(-198*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(b1*(2*K - 1) - 4*g2) + 66*Pkdd2*f*k1**2*(b1**2*(6*K*(4*s**2 - 2*s + 1) + s**2*(40*fd - 12) + s*(6 - 10*fd) - 3) - b1*(3*bd1*(2*K - 1)*(8*s**2 - 6*s + 1) + 12*g2*(4*s**2 - 2*s + 1) + (8*s - 2)*(5*K*fd*(2*s - 1) + fd*s*(12*C - 9) - 6*gd2*s)) + 4*g2*(4*s - 1)*(3*bd1*(s - 1) + 5*fd*(2*s - 1))) + f**3*(8*Pk2*(4*C*(62*r**2 + 28*r*s - 69*r - 14*s + 31) - 158*r**2 - 56*r*s + 172*r + 28*s - 79) + Pkdd2*k1**2*(604*C + 165*b1 - 203)*(4*s**2 - 2*s + 1)) + f**2*(-33*Pkdd2*k1**2*(10*b1**2*(4*s**2 - 2*s + 1) - b1*(10*bd1*(8*s**2 - 6*s + 1) + (24*C + 14*K - 15)*(4*s**2 - 2*s + 1)) + 2*bd1*(4*s - 1)*(12*C*(s - 1) + s*(10*K - 9) + 9) + 28*g2*(4*s**2 - 2*s + 1) + 40*gd2*s*(1 - 4*s)) - 4*fd*(16*Pk2*(2*C*(96*r**2 + 5*r*(24*s - 23) - 50*s + 31) - 84*r**2 - 15*r*(8*s - 7) + 50*s - 29) + Pkdd2*k1**2*(250*C - 125)*(12*s**2 - 7*s + 1)))) + Ddd*f*(-99*Pkdd2*b1*k1**2*(b1*(2*K - 1) - 4*g2)*(4*s**2 - 2*s + 1) + 33*Pkdd2*f*k1**2*(5*b1**2 + b1*(-12*C - 10*K + 9) + 20*g2)*(4*s**2 - 2*s + 1) - 2*f**2*(32*Pk2*(2*C*(16*r**2 + 20*r*s - 21*r - 10*s + 8) - 14*r**2 - 20*r*s + 19*r + 10*s - 7) + Pkdd2*k1**2*(250*C - 125)*(4*s**2 - 2*s + 1)))) + 2*Dd**2*f*(-297*Pkdd2*b1*k1**2*s*(2*s - 1)*(b1*(2*K - 1) - 4*g2) + 99*Pkdd2*f*k1**2*s*(2*s - 1)*(5*b1**2 + b1*(-12*C - 10*K + 9) + 20*g2) - 2*f**2*(16*Pk2*(6*C*(16*r**2 + 20*r*s - 21*r - 10*s + 6) - 42*r**2 - 60*r*s + 57*r + 30*s - 17) + Pkdd2*k1**2*s*(750*C - 375)*(2*s - 1))))/(693*d**2*k1*k3**4) - D1**2*Pk3*ct**3*k2**3*(-792*D1**2*K*Pkdd2*bd1**2*f*k1**2*s*(s - 1) + 66*D1*bd1*(D1*(24*Pkdd2*fd*g2*k1**2*s*(s - 1) + f**2*(Pk2*r*(4*C*(9*r + 4*s - 8) - 27*r - 8*s + 16) + Pkdd2*k1**2*(8*C*(s - 1)**2 - s**2*(6*K + 1) + 2*s - 1)) + 2*f*(-Pkdd2*k1**2*(s - 1)*(5*g2*(s - 1) - 12*gd2*s) + fd*(Pk2*(4*C*(2*r**2 - 4*r*s + 2*r + s - 2) - 6*r**2 + 8*r*s - 3*r - 2*s + 4) + Pkdd2*k1**2*s*(10 - 20*C)*(s - 1)))) + 2*Dd*f*(4*Pk2*f*(C*(4*r**2 - 8*r*s + 7*r + 2*s - 4) - 3*r**2 + r*(4*s - 3) - s + 2) + Pkdd2*f*k1**2*(5 - 10*C)*(4*s**2 - 5*s + 1) + 12*Pkdd2*g2*k1**2*(4*s**2 - 5*s + 1))) + 33*Pkdd2*b1**2*k1**2*(D1**2*s**2*(-12*K*fdd + fd*(10*K + 12*f + 7)) + D1*(Dd*(24*K*fd*s*(1 - 4*s) + 6*f**2*(4*s**2 - 2*s + 1) + f*(10*K + 7)*(4*s**2 - 2*s + 1)) - 12*Ddd*K*f*(4*s**2 - 2*s + 1)) + 72*Dd**2*K*f*s*(1 - 2*s)) + 33*b1*(D1**2*(6*Pkdd2*bd1*f**2*k1**2*(2*s**2 - 2*s + 1) + 4*Pkdd2*fd*k1**2*s*(6*K*bd1*(1 - 2*s) - 5*g2*s + 12*gd2*s) + 24*Pkdd2*fdd*g2*k1**2*s**2 + f*(Pkdd2*k1**2*(-12*K*bdd1*(2*s**2 - 2*s + 1) + bd1*(10*K + 7)*(2*s**2 - 2*s + 1) - 4*s**2*(5*gd2 - 6*gdd2)) + 2*fd*(Pk2*(4*C*(18*r**2 + 8*r*s - 14*r - 4*s + 9) - 54*r**2 - 16*r*s + 46*r + 8*s - 27) - 2*Pkdd2*k1**2*(K*(6*s**2 - 6*s + 3) + s**2*(1 - 8*C))) + 2*fdd*(Pk2*(4*C*(2*r**2 - 4*r*(s + 1) + 2*s + 1) - 6*r**2 + 8*r*s + 10*r - 4*s - 3) + Pkdd2*k1**2*s**2*(10 - 20*C))) + 4*fd**2*(Pk2*(4*C*(r**2 - 2*r*(s + 1) + s + 1) - 3*r**2 + 4*r*s + 5*r - 2*s - 2) + Pkdd2*k1**2*s**2*(5 - 10*C))) + 2*D1*(Dd*(24*Pkdd2*fd*g2*k1**2*s*(4*s - 1) + f**2*(2*Pk2*(4*C*(18*r**2 + 8*r*s - 20*r - 4*s + 9) - 54*r**2 - 16*r*s + 58*r + 8*s - 27) + Pkdd2*k1**2*(8*C - 6*K - 1)*(4*s**2 - 2*s + 1)) + 2*f*(4*Pk2*fd*(2*r - 1)*(C*(4*r - 8*s - 3) - 3*r + 4*s + 2) + Pkdd2*fd*k1**2*s*(10 - 20*C)*(4*s - 1) - 5*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 6*Pkdd2*k1**2*(4*s - 1)*(bd1*(-2*K*s + K) + 2*gd2*s))) + Ddd*f*(2*Pk2*f*(4*C*(2*r**2 - r*(4*s + 1) + 2*s + 1) - 6*r**2 + r*(8*s + 4) - 4*s - 3) + Pkdd2*f*k1**2*(5 - 10*C)*(4*s**2 - 2*s + 1) + 12*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1))) + 4*Dd**2*f*(Pk2*f*(4*C*(6*r**2 - 3*r*(4*s + 1) + 6*s - 1) - 18*r**2 + 12*r*(2*s + 1) - 12*s + 1) + Pkdd2*f*k1**2*s*(15 - 30*C)*(2*s - 1) + 36*Pkdd2*g2*k1**2*s*(2*s - 1))) + 2*f*(D1**2*(4*Pk2*fd**2*(2*C - 1)*(3*r**2 - 396*r*s + 130*r + 132*s - 66) + 396*Pkdd2*bdd1*g2*k1**2*(s - 1)**2 + 396*Pkdd2*fd*g2*k1**2*(2*s**2 - 2*s + 1) + f*(-33*Pk2*bdd1*r*(-4*C*(r - 2*s + 4) + 3*r - 4*s + 8) + Pk2*fdd*(4*C - 2)*(3*r**2 + r*(130 - 396*s) + 132*s + 1) - 165*Pkdd2*bdd1*k1**2*(2*C - 1)*(s - 1)**2 + 396*Pkdd2*gd2*k1**2*s**2 + fd*(2*C - 1)*(2*Pk2*(687*r**2 + r*(396*s - 590) - 132*s + 229) - 165*Pkdd2*k1**2*(3*s**2 - 2*s + 1)))) + D1*f*(Dd*(4*Pk2*fd*(8*C - 4)*(3*r**2 + r*(113 - 396*s) + 165*s - 49) + 396*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + f*(2*C - 1)*(4*Pk2*(458*r**2 + 4*r*(66*s - 131) - 132*s + 229) - 165*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(8*C - 4)*(2*r**2 - 8*r*(33*s - 8) + 132*s + 1)) + Dd**2*Pk2*f**2*(8*C - 4)*(6*r**2 - 24*r*(33*s - 8) + 396*s - 131)))/(693*d**2*k1*k3**4) + D1**2*Pk3*ct**3*k2*st**2*(D1**2*(165*Pkdd2*bd1*f**3*k1**2*s**2 + 33*Pkdd2*k1**2*(b1**2*(10*fd**2*s - 6*fd*(2*K*(s - 1)**2 + 2*s - 1) + 3*fdd*(2*K*(s - 1)**2 + 2*s - 1)) + 2*b1*(fd**2*s*(12*C*(s - 1) - 10*K*(s - 1) - 6*s + 9) + 3*fd*(4*g2*(s - 1)**2 + s*(4*K*bd1*(s - 1) + bd1 - 4*gd2*(s - 1))) - 6*fdd*g2*(s - 1)**2) - 4*fd*s*(s - 1)*(5*b2*fd + 6*bd1*g2 - 10*fd*g2)) - f**2*(32*Pk2*fdd*(3*r**2 + r*(-60*C*s + 20*C + 30*s - 12) + s*(20*C - 10) + 1) + Pkdd2*fdd*k1**2*(500*C - 250)*(3*s**2 - 2*s + 1) + 33*Pkdd2*k1**2*(10*bd1**2*s + bd1*(b1*(10 - 20*s) + s**2*(24*C - 20*K - 15) - 12*s + 6) + bdd1*(5*b1*(2*s - 1) + s**2*(-12*C + 10*K + 6) + 6*s - 3) + s**2*(-20*bd2 + 10*bdd2 + 40*gd2 - 20*gdd2)) + fd*(4*Pk2*(-56*C*s + 51*r**2 + 2*r*(84*C*s - 28*C - 42*s - 3) + 28*s + 17) - Pkdd2*k1**2*(1000*C + 165*b1 - 401)*(3*s**2 - 2*s + 1))) + f*(-33*Pkdd2*fd*k1**2*(-48*C*bd1*s**2 + 24*C*bd1*s + 40*K*bd1*s**2 - 20*K*bd1*s + 10*b1**2*(2*s - 1) + b1*(24*C*(2*s**2 - 2*s + 1) - 20*K*(2*s**2 - 2*s + 1) - 30*s**2 + 42*s - 21) - 20*b2*(2*s**2 - 2*s + 1) + 24*bd1*s**2 - 6*bd1*s + 40*bd2*s**2 - 20*bd2*s + 80*g2*s**2 - 80*g2*s + 40*g2 - 80*gd2*s**2 + 40*gd2*s) + 33*Pkdd2*k1**2*(5*b1**2*fdd*(2*s - 1) + b1*(24*C*fdd*s**2 - 24*C*fdd*s + 12*C*fdd - 20*K*fdd*s**2 + 20*K*fdd*s - 10*K*fdd - 6*bd1*(4*K*s**2 - 2*s + 1) + 3*bdd1*(4*K*s**2 - 2*s + 1) - 12*fdd*s**2 + 18*fdd*s - 9*fdd + 24*gd2*s**2 - 12*gdd2*s**2) - 10*b2*fdd*(2*s**2 - 2*s + 1) + 20*fdd*g2*(2*s**2 - 2*s + 1) + 6*s*(bd1**2*(2*K*s - 1) + 4*bd1*s*(g2 - gd2) - 2*bdd1*g2*s)) + 4*fd**2*(16*Pk2*(10*C*(6*r*s - 2*r - 2*s + 1) - 3*r**2 - 30*r*s + 12*r + 10*s - 5) + Pkdd2*k1**2*s*(125 - 250*C)*(3*s - 2)))) - D1*Dd*(-198*Pkdd2*b1*fd*k1**2*(4*s - 1)*(2*K*b1*(s - 1) + b1 - 4*g2*(s - 1)) - 66*Pkdd2*f*k1**2*(b1**2*(-6*K*(4*s**2 - 2*s + 1) + 5*fd*(4*s - 1)) + b1*(3*bd1*(4*s - 1)*(4*K*s - 1) + fd*(4*s - 1)*(24*C*s - 12*C - 20*K*s + 10*K - 12*s + 9) + 48*g2*s**2 - 24*g2*s + 12*g2 - 48*gd2*s**2 + 12*gd2*s) + (2 - 8*s)*(5*b2*fd*(2*s - 1) + 6*bd1*g2*s + 2*fd*g2*(5 - 10*s))) + f**3*(8*Pk2*(34*r**2 + 4*r*(7*C*(4*s - 1) - 14*s - 5) + s*(28 - 56*C) + 17) - Pkdd2*k1**2*(1000*C + 165*b1 - 401)*(4*s**2 - 2*s + 1)) + f**2*(-64*Pk2*fd*(10*C*(r*(24*s - 7) - 10*s + 3) - 12*r**2 - 15*r*(8*s - 3) + 50*s - 17) + Pkdd2*fd*k1**2*(1000*C - 500)*(12*s**2 - 7*s + 1) + 33*Pkdd2*k1**2*(-96*C*bd1*s**2 + 24*C*bd1*s + 80*K*bd1*s**2 - 20*K*bd1*s + 10*b1*bd1*(4*s - 1) + b1*(24*C - 20*K - 15)*(4*s**2 - 2*s + 1) - 20*b2*(4*s**2 - 2*s + 1) + 48*bd1*s**2 + 12*bd1*s - 6*bd1 + 80*bd2*s**2 - 20*bd2*s + 160*g2*s**2 - 80*g2*s + 40*g2 - 160*gd2*s**2 + 40*gd2*s))) + 2*D1*Ddd*f*(99*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1) - 33*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)*(b1*(-6*C + 5*K + 3) + 5*b2 - 10*g2) + f**2*(-32*Pk2*(20*C*s + 2*r**2 + r*(-40*C*s + 10*C + 20*s - 7) - 10*s + 1) + Pkdd2*k1**2*(125 - 250*C)*(4*s**2 - 2*s + 1))) + 4*Dd**2*f*(297*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2) - 99*Pkdd2*f*k1**2*s*(2*s - 1)*(b1*(-6*C + 5*K + 3) + 5*b2 - 10*g2) + f**2*(16*Pk2*(10*C*(12*r*s - 3*r - 6*s + 2) - 6*r**2 - 60*r*s + 21*r + 30*s - 11) + Pkdd2*k1**2*s*(375 - 750*C)*(2*s - 1))))/(693*d**2*k1*k3**2) + D1**2*Pk3*ct**3*k2*(2*D1**2*(-132*Pkdd2*bd1*k1**2*s*(s - 1)*(3*b2*fd + 7*bd1*g2 - 6*fd*g2) + f**2*(594*Pk2*bd1*r**2*(1 - 2*C) + Pk2*fdd*(4*C - 2)*(3*r**2 + r*(130 - 396*s) + 132*s + 1) + 33*Pkdd2*bd1*k1**2*(4*C*(8*s**2 - 10*s + 5) - s**2*(6*K + 16) + 14*s - 7) - 33*Pkdd2*k1**2*s**2*(6*bd2 - 12*gd2) - 33*bdd1*(2*C - 1)*(2*Pk2*r**2 + 5*Pkdd2*k1**2*(s - 1)**2) + fd*(2*C - 1)*(2*Pk2*(687*r**2 + r*(396*s - 590) - 132*s + 229) - 165*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + 2*f*(Pk2*fd**2*(4*C - 2)*(3*r**2 - 396*r*s + 130*r + 132*s - 66) + 33*Pkdd2*k1**2*(3*b2*(2*bd1 - bdd1)*(s - 1)**2 + 3*bd1**2*s*(s - 1)*(4*C - 2*K - 3) + bd1*g2*(-19*s**2 + 24*s - 12) - 6*bd1*s*(bd2 - 2*gd2)*(s - 1) + 6*bdd1*g2*(s - 1)**2) - 33*fd*(3*Pkdd2*b2*k1**2*(2*s**2 - 2*s + 1) - 6*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 2*bd1*(2*C - 1)*(Pk2*r*(2*r - 1) + 5*Pkdd2*k1**2*s*(s - 1))))) + 2*D1*f*(Dd*(-396*Pkdd2*bd1*k1**2*(b2 - 2*g2)*(4*s**2 - 5*s + 1) + f**2*(2*C - 1)*(4*Pk2*(458*r**2 + 4*r*(66*s - 131) - 132*s + 229) - 165*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 2*f*(Pk2*fd*(16*C - 8)*(3*r**2 + r*(113 - 396*s) + 165*s - 49) - 99*Pkdd2*b2*k1**2*(4*s**2 - 2*s + 1) + 198*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) - 33*bd1*(2*C - 1)*(4*Pk2*r*(2*r - 1) + 5*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + Ddd*Pk2*f**2*(8*C - 4)*(2*r**2 - 8*r*(33*s - 8) + 132*s + 1)) + 2*Dd**2*Pk2*f**3*(8*C - 4)*(6*r**2 - 24*r*(33*s - 8) + 396*s - 131) + 33*Pkdd2*b1**3*k1**2*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(-14*K*(4*s**2 - 2*s + 1) + 6*f*(4*s**2 - 2*s + 1) - 24*fd*s**2 + 6*fd*s + 28*s**2 - 14*s + 7) - D1*Ddd*(-14*K + 6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(-14*K + 6*f + 7)) + 33*Pkdd2*b1**2*k1**2*(-48*C*D1**2*fd*s**2 + 24*C*D1**2*fdd*s**2 - 192*C*D1*Dd*f*s**2 + 96*C*D1*Dd*f*s - 48*C*D1*Dd*f + 192*C*D1*Dd*fd*s**2 - 48*C*D1*Dd*fd*s + 96*C*D1*Ddd*f*s**2 - 48*C*D1*Ddd*f*s + 24*C*D1*Ddd*f + 288*C*Dd**2*f*s**2 - 144*C*Dd**2*f*s + 38*D1**2*K*fd*s**2 - 28*D1**2*K*fd*s + 14*D1**2*K*fd - 12*D1**2*K*fdd*s**2 - D1**2*bdd1*(-14*K + 6*f + 7)*(3*s**2 - 2*s + 1) + 12*D1**2*f*fd*s - 6*D1**2*f*fd + 36*D1**2*fd*s**2 + 14*D1**2*fd*s - 7*D1**2*fd - 18*D1**2*fdd*s**2 + 56*D1**2*gd2*s**2 - 28*D1**2*gdd2*s**2 + 152*D1*Dd*K*f*s**2 - 76*D1*Dd*K*f*s + 38*D1*Dd*K*f - 96*D1*Dd*K*fd*s**2 + 24*D1*Dd*K*fd*s + 144*D1*Dd*f*s**2 - 72*D1*Dd*f*s + 36*D1*Dd*f - 144*D1*Dd*fd*s**2 + 36*D1*Dd*fd*s + 224*D1*Dd*g2*s**2 - 112*D1*Dd*g2*s + 56*D1*Dd*g2 - 224*D1*Dd*gd2*s**2 + 56*D1*Dd*gd2*s - 48*D1*Ddd*K*f*s**2 + 24*D1*Ddd*K*f*s - 12*D1*Ddd*K*f - 72*D1*Ddd*f*s**2 + 36*D1*Ddd*f*s - 18*D1*Ddd*f - 112*D1*Ddd*g2*s**2 + 56*D1*Ddd*g2*s - 28*D1*Ddd*g2 + 2*D1*bd1*(D1*(-14*K*(3*s**2 - 2*s + 1) + 6*f*(3*s**2 - 2*s + 1) - 18*fd*s**2 + 6*fd*s + 21*s**2 - 14*s + 7) - Dd*(-14*K + 6*f + 7)*(12*s**2 - 7*s + 1)) - 144*Dd**2*K*f*s**2 + 72*Dd**2*K*f*s - 216*Dd**2*f*s**2 + 108*Dd**2*f*s - 336*Dd**2*g2*s**2 + 168*Dd**2*g2*s) - 33*b1*(D1**2*(-14*Pkdd2*bd1**2*k1**2*s*(2*K - 1)*(3*s - 2) + 6*Pkdd2*bd1*f**2*k1**2*(2*s - 1) - 4*Pkdd2*bd1*k1**2*(14*g2*(2*s**2 - 2*s + 1) + s*(2*s - 1)*(3*fd*(4*C - 2*K - 3) - 14*gd2)) + 28*Pkdd2*bdd1*g2*k1**2*(2*s**2 - 2*s + 1) - 4*Pkdd2*fd*k1**2*(g2*(-19*s**2 + 14*s - 7) + s**2*(6*b2 - 6*bd2 + 12*gd2)) + 12*Pkdd2*fdd*k1**2*s**2*(b2 - 2*g2) + f*(Pkdd2*k1**2*(12*bd1**2*s*(3*s - 2) + bd1*(48*C*(2*s**2 - 2*s + 1) - 4*K*(19*s**2 - 12*s + 6) - 72*s**2 + 86*s - 43) - 6*bdd1*(4*C - 2*K - 3)*(2*s**2 - 2*s + 1) + s**2*(-24*bd2 + 12*bdd2 + 76*gd2 - 24*gdd2)) + 2*fd*(Pk2*(36*C - 18)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-4*C*(16*s**2 - 6*s + 3) + 6*K*(2*s**2 - 2*s + 1) + 32*s**2 - 18*s + 9)) + fdd*(8*C - 4)*(2*Pk2*r**2 - 2*Pk2*r + Pk2 + 5*Pkdd2*k1**2*s**2)) + 4*fd**2*(2*C - 1)*(2*Pk2*r*(r - 1) + 5*Pkdd2*k1**2*s**2)) + 2*D1*(2*Dd*(2*Pkdd2*k1**2*(4*s - 1)*(7*bd1*g2*(2*s - 1) + 3*fd*s*(b2 - 2*g2)) + f**2*(Pk2*(36*C - 18)*(2*r**2 - 2*r + 1) - Pkdd2*k1**2*(16*C - 3*K - 8)*(4*s**2 - 2*s + 1)) + f*(Pkdd2*k1**2*(-6*b2*(4*s**2 - 2*s + 1) - 3*bd1*(4*C - 2*K - 3)*(8*s**2 - 6*s + 1) + 24*bd2*s**2 - 6*bd2*s + 76*g2*s**2 - 38*g2*s + 19*g2 - 48*gd2*s**2 + 12*gd2*s) + fd*(4*C - 2)*(2*Pk2*(1 - 2*r)**2 + 5*Pkdd2*k1**2*s*(4*s - 1)))) + Ddd*f*(Pkdd2*k1**2*(6*b2 - 12*g2)*(4*s**2 - 2*s + 1) + f*(2*C - 1)*(Pk2*(8*r**2 - 8*r + 4) + 5*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 4*Dd**2*f*(Pkdd2*k1**2*s*(18*b2 - 36*g2)*(2*s - 1) + f*(2*C - 1)*(2*Pk2*(6*r**2 - 6*r + 1) + 15*Pkdd2*k1**2*s*(2*s - 1)))))/(693*d**2*k1*k3**2) - D1**2*Pk3*ct**3*(2*D1*f*(D1*Pk2*bdd1*f*r*(r + s*(4 - 8*C)) - 6*D1*Pkdd2*bd1**2*k1**2*s*(s - 1) + D1*bd1*(2*Pk2*fd*(2*r**2 + r*(-16*C*s + 4*C + 8*s - 3) + s*(4*C - 2)) + f*(Pk2*r*(16*C*s + 9*r - 8*s) - 3*Pkdd2*k1**2*s**2)) + 8*Dd*Pk2*bd1*f*(r**2 + r*(-8*C*s + C + 4*s - 1) + s*(2*C - 1))) + Pkdd2*b1**3*k1**2*(6*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(6*f*(4*s**2 - 2*s + 1) - s**2*(24*fd - 28) + s*(6*fd - 14) + 7) - D1*Ddd*(6*f + 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(6*f + 7)*(2*s - 1)) + Pkdd2*b1**2*k1**2*(-D1**2*bdd1*(6*f + 7)*(3*s**2 - 2*s + 1) - 12*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 6*D1**2*f*fd + 5*D1**2*fd*s**2 + 14*D1**2*fd*s - 7*D1**2*fd - 6*D1**2*fdd*s**2 - 24*D1*Dd*f**2*s**2 + 12*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 20*D1*Dd*f*s**2 - 10*D1*Dd*f*s + 5*D1*Dd*f - 48*D1*Dd*fd*s**2 + 12*D1*Dd*fd*s - 24*D1*Ddd*f*s**2 + 12*D1*Ddd*f*s - 6*D1*Ddd*f + 2*D1*bd1*(D1*(6*f*(3*s**2 - 2*s + 1) - s**2*(18*fd - 21) + s*(6*fd - 14) + 7) - Dd*(6*f + 7)*(12*s**2 - 7*s + 1)) - 72*Dd**2*f*s**2 + 36*Dd**2*f*s) - 2*b1*(D1**2*(-2*Pk2*fd**2*(4*C*(-2*r*s + r + s - 1) + r**2 + r*(4*s - 3) - 2*s + 2) + 7*Pkdd2*bd1**2*k1**2*s*(3*s - 2) + 6*Pkdd2*bd1*f**2*k1**2*s**2 + 6*Pkdd2*bd1*fd*k1**2*s*(2*s - 1) - f*(Pk2*fdd*(8*C*s + 2*r**2 + r*(-16*C*s + 8*C + 8*s - 6) - 4*s + 1) + Pkdd2*k1**2*(-6*bd1**2*s*(3*s - 2) + bd1*(5*s**2 - 12*s + 6) - 3*bdd1*(2*s**2 - 2*s + 1)) + fd*(Pk2*(-16*C*s + 18*r**2 + 2*r*(16*C*s - 8*C - 8*s - 5) + 8*s + 9) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)))) + D1*f*(Dd*(-8*Pk2*fd*(2*r - 1)*(C*(3 - 8*s) + r + 4*s - 2) + 6*Pkdd2*bd1*k1**2*(8*s**2 - 6*s + 1) + f*(-2*Pk2*(-16*C*s + 18*r**2 + 2*r*(16*C*s - 4*C - 8*s - 7) + 8*s + 9) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 2*Ddd*Pk2*f*(8*C*s + 2*r**2 + 4*r*(-4*C*s + C + 2*s - 1) - 4*s + 1)) + 2*Dd**2*Pk2*f**2*(4*C*(3*r*(4*s - 1) - 6*s + 2) - 6*r**2 + r*(12 - 24*s) + 12*s - 5)))/(21*d**2*k1*k2) + 2*D1**2*Pk3*ct**2*k1**2*st**4*(9984*C*D1**2*Pk2*f**2*fd*r*s - 3328*C*D1**2*Pk2*f**2*fd*r - 6240*C*D1**2*Pk2*f**2*fd*s**2 + 832*C*D1**2*Pk2*f**2*fd*s - 2080*C*D1**2*Pk2*f**2*fd - 4992*C*D1**2*Pk2*f**2*fdd*r*s + 1664*C*D1**2*Pk2*f**2*fdd*r + 3120*C*D1**2*Pk2*f**2*fdd*s**2 - 416*C*D1**2*Pk2*f**2*fdd*s + 1040*C*D1**2*Pk2*f**2*fdd - 9984*C*D1**2*Pk2*f*fd**2*r*s + 3328*C*D1**2*Pk2*f*fd**2*r + 6240*C*D1**2*Pk2*f*fd**2*s**2 - 832*C*D1**2*Pk2*f*fd**2*s - 1664*C*D1**2*Pk2*f*fd**2 - 78*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 52*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 26*C*D1**2*Pkdd2*f**2*fd*k1**2 + 39*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 26*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 13*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 78*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 52*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 13312*C*D1*Dd*Pk2*f**3*r*s - 3328*C*D1*Dd*Pk2*f**3*r - 8320*C*D1*Dd*Pk2*f**3*s**2 - 2496*C*D1*Dd*Pk2*f**3*s - 2080*C*D1*Dd*Pk2*f**3 - 39936*C*D1*Dd*Pk2*f**2*fd*r*s + 11648*C*D1*Dd*Pk2*f**2*fd*r + 24960*C*D1*Dd*Pk2*f**2*fd*s**2 + 2080*C*D1*Dd*Pk2*f**2*fd*s - 2912*C*D1*Dd*Pk2*f**2*fd - 104*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 52*C*D1*Dd*Pkdd2*f**3*k1**2*s - 26*C*D1*Dd*Pkdd2*f**3*k1**2 + 312*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 182*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 26*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 6656*C*D1*Ddd*Pk2*f**3*r*s + 1664*C*D1*Ddd*Pk2*f**3*r + 4160*C*D1*Ddd*Pk2*f**3*s**2 + 1248*C*D1*Ddd*Pk2*f**3*s + 1040*C*D1*Ddd*Pk2*f**3 + 52*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 26*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 13*C*D1*Ddd*Pkdd2*f**3*k1**2 - 19968*C*Dd**2*Pk2*f**3*r*s + 4992*C*Dd**2*Pk2*f**3*r + 12480*C*Dd**2*Pk2*f**3*s**2 + 3744*C*Dd**2*Pk2*f**3*s - 3328*C*Dd**2*Pk2*f**3 + 156*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 78*C*Dd**2*Pkdd2*f**3*k1**2*s + 3432*D1**2*K*Pk2*bdd1*f**2*r*s + 7722*D1**2*K*Pk2*bdd1*f**2*s**2 - 3432*D1**2*K*Pk2*bdd1*f**2*s - 3432*D1**2*Pk2*bd1**2*f*s*(K - 1)*(2*r + 3*s - 2) + 6240*D1**2*Pk2*bdd1*f**3*r*s + 4680*D1**2*Pk2*bdd1*f**3*s**2 - 6240*D1**2*Pk2*bdd1*f**3*s + 780*D1**2*Pk2*bdd1*f**3 - 3432*D1**2*Pk2*bdd1*f**2*r*s - 7722*D1**2*Pk2*bdd1*f**2*s**2 + 3432*D1**2*Pk2*bdd1*f**2*s + 6864*D1**2*Pk2*bdd1*f*g2*r*s + 10296*D1**2*Pk2*bdd1*f*g2*s**2 - 6864*D1**2*Pk2*bdd1*f*g2*s + 3432*D1**2*Pk2*bdd1*f*g2 + 28080*D1**2*Pk2*f**3*fd*r*s - 7020*D1**2*Pk2*f**3*fd*r + 26520*D1**2*Pk2*f**3*fd*s**2 - 27300*D1**2*Pk2*f**3*fd*s + 6630*D1**2*Pk2*f**3*fd - 28080*D1**2*Pk2*f**3*fdd*r*s + 7020*D1**2*Pk2*f**3*fdd*r - 20280*D1**2*Pk2*f**3*fdd*s**2 + 24180*D1**2*Pk2*f**3*fdd*s - 5070*D1**2*Pk2*f**3*fdd - 84240*D1**2*Pk2*f**2*fd**2*r*s + 21060*D1**2*Pk2*f**2*fd**2*r - 60840*D1**2*Pk2*f**2*fd**2*s**2 + 72540*D1**2*Pk2*f**2*fd**2*s - 14040*D1**2*Pk2*f**2*fd**2 - 19344*D1**2*Pk2*f**2*fd*r*s + 6448*D1**2*Pk2*f**2*fd*r - 6240*D1**2*Pk2*f**2*fd*s**2 + 10608*D1**2*Pk2*f**2*fd*s - 2080*D1**2*Pk2*f**2*fd + 9672*D1**2*Pk2*f**2*fdd*r*s - 3224*D1**2*Pk2*f**2*fdd*r + 3120*D1**2*Pk2*f**2*fdd*s**2 - 5304*D1**2*Pk2*f**2*fdd*s + 1040*D1**2*Pk2*f**2*fdd + 6864*D1**2*Pk2*f**2*gd2*r*s + 15444*D1**2*Pk2*f**2*gd2*s**2 - 6864*D1**2*Pk2*f**2*gd2*s - 6864*D1**2*Pk2*f**2*gdd2*r*s - 15444*D1**2*Pk2*f**2*gdd2*s**2 + 6864*D1**2*Pk2*f**2*gdd2*s + 19344*D1**2*Pk2*f*fd**2*r*s - 6448*D1**2*Pk2*f*fd**2*r + 6240*D1**2*Pk2*f*fd**2*s**2 - 10608*D1**2*Pk2*f*fd**2*s + 3224*D1**2*Pk2*f*fd**2 + 13728*D1**2*Pk2*f*fd*g2*r*s - 6864*D1**2*Pk2*f*fd*g2*r + 30888*D1**2*Pk2*f*fd*g2*s**2 - 30888*D1**2*Pk2*f*fd*g2*s + 15444*D1**2*Pk2*f*fd*g2 - 27456*D1**2*Pk2*f*fd*gd2*r*s + 6864*D1**2*Pk2*f*fd*gd2*r - 61776*D1**2*Pk2*f*fd*gd2*s**2 + 44616*D1**2*Pk2*f*fd*gd2*s - 6864*D1**2*Pk2*f*fd*gd2 - 13728*D1**2*Pk2*f*fdd*g2*r*s + 6864*D1**2*Pk2*f*fdd*g2*r - 30888*D1**2*Pk2*f*fdd*g2*s**2 + 30888*D1**2*Pk2*f*fdd*g2*s - 15444*D1**2*Pk2*f*fdd*g2 - 13728*D1**2*Pk2*fd**2*g2*r*s + 6864*D1**2*Pk2*fd**2*g2*r - 30888*D1**2*Pk2*fd**2*g2*s**2 + 30888*D1**2*Pk2*fd**2*g2*s - 1800*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 900*D1**2*Pkdd2*f**3*fd*k1**2*s - 450*D1**2*Pkdd2*f**3*fd*k1**2 + 900*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 - 450*D1**2*Pkdd2*f**3*fdd*k1**2*s + 225*D1**2*Pkdd2*f**3*fdd*k1**2 + 2700*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 - 1350*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 78*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 52*D1**2*Pkdd2*f**2*fd*k1**2*s + 26*D1**2*Pkdd2*f**2*fd*k1**2 - 39*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 26*D1**2*Pkdd2*f**2*fdd*k1**2*s - 13*D1**2*Pkdd2*f**2*fdd*k1**2 - 78*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 52*D1**2*Pkdd2*f*fd**2*k1**2*s + 28080*D1*Dd*Pk2*f**4*r*s - 7020*D1*Dd*Pk2*f**4*r + 26520*D1*Dd*Pk2*f**4*s**2 - 27300*D1*Dd*Pk2*f**4*s + 6630*D1*Dd*Pk2*f**4 - 224640*D1*Dd*Pk2*f**3*fd*r*s + 56160*D1*Dd*Pk2*f**3*fd*r - 162240*D1*Dd*Pk2*f**3*fd*s**2 + 193440*D1*Dd*Pk2*f**3*fd*s - 38220*D1*Dd*Pk2*f**3*fd - 25792*D1*Dd*Pk2*f**3*r*s + 6448*D1*Dd*Pk2*f**3*r - 8320*D1*Dd*Pk2*f**3*s**2 + 17056*D1*Dd*Pk2*f**3*s - 2080*D1*Dd*Pk2*f**3 + 77376*D1*Dd*Pk2*f**2*fd*r*s - 22568*D1*Dd*Pk2*f**2*fd*r + 24960*D1*Dd*Pk2*f**2*fd*s**2 - 46800*D1*Dd*Pk2*f**2*fd*s + 11752*D1*Dd*Pk2*f**2*fd + 27456*D1*Dd*Pk2*f**2*g2*r*s - 6864*D1*Dd*Pk2*f**2*g2*r + 61776*D1*Dd*Pk2*f**2*g2*s**2 - 44616*D1*Dd*Pk2*f**2*g2*s + 15444*D1*Dd*Pk2*f**2*g2 - 54912*D1*Dd*Pk2*f**2*gd2*r*s + 6864*D1*Dd*Pk2*f**2*gd2*r - 123552*D1*Dd*Pk2*f**2*gd2*s**2 + 72072*D1*Dd*Pk2*f**2*gd2*s - 6864*D1*Dd*Pk2*f**2*gd2 - 109824*D1*Dd*Pk2*f*fd*g2*r*s + 41184*D1*Dd*Pk2*f*fd*g2*r - 247104*D1*Dd*Pk2*f*fd*g2*s**2 + 212784*D1*Dd*Pk2*f*fd*g2*s - 44616*D1*Dd*Pk2*f*fd*g2 - 1800*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 900*D1*Dd*Pkdd2*f**4*k1**2*s - 450*D1*Dd*Pkdd2*f**4*k1**2 + 7200*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 - 3600*D1*Dd*Pkdd2*f**3*fd*k1**2*s + 450*D1*Dd*Pkdd2*f**3*fd*k1**2 + 104*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 52*D1*Dd*Pkdd2*f**3*k1**2*s + 26*D1*Dd*Pkdd2*f**3*k1**2 - 312*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 182*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 26*D1*Dd*Pkdd2*f**2*fd*k1**2 - 28080*D1*Ddd*Pk2*f**4*r*s + 7020*D1*Ddd*Pk2*f**4*r - 20280*D1*Ddd*Pk2*f**4*s**2 + 24180*D1*Ddd*Pk2*f**4*s - 5070*D1*Ddd*Pk2*f**4 + 12896*D1*Ddd*Pk2*f**3*r*s - 3224*D1*Ddd*Pk2*f**3*r + 4160*D1*Ddd*Pk2*f**3*s**2 - 8528*D1*Ddd*Pk2*f**3*s + 1040*D1*Ddd*Pk2*f**3 - 27456*D1*Ddd*Pk2*f**2*g2*r*s + 6864*D1*Ddd*Pk2*f**2*g2*r - 61776*D1*Ddd*Pk2*f**2*g2*s**2 + 44616*D1*Ddd*Pk2*f**2*g2*s - 15444*D1*Ddd*Pk2*f**2*g2 + 900*D1*Ddd*Pkdd2*f**4*k1**2*s**2 - 450*D1*Ddd*Pkdd2*f**4*k1**2*s + 225*D1*Ddd*Pkdd2*f**4*k1**2 - 52*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 26*D1*Ddd*Pkdd2*f**3*k1**2*s - 13*D1*Ddd*Pkdd2*f**3*k1**2 - 78*D1*Pk2*bd1*(D1*(20*f**3*(6*s**2 + s*(8*r - 8) + 1) + f**2*(-20*fd*(4*r*(6*s - 1) + 18*s**2 - 22*s + 3) + 11*s*(K*(4*r + 9*s - 4) - 5*s)) - 22*f*(fd*(K - 1)*(r*(8*s - 2) + 18*s**2 - 13*s + 2) - 12*g2*s**2 - 8*g2*s*(r - 1) - 4*g2 - 4*gd2*s*(-2*r - 3*s + 2)) - 88*fd*g2*(r*(2*s - 1) + s*(3*s - 3))) - 2*Dd*f*(20*f**2*(2*r*(8*s - 1) + 12*s**2 - 15*s + 2) + 11*f*(K - 1)*(2*r*(8*s - 1) + 36*s**2 - 21*s + 2) + 44*g2*(r*(8*s - 1) + 12*s**2 - 9*s + 1))) - 84240*Dd**2*Pk2*f**4*r*s + 21060*Dd**2*Pk2*f**4*r - 60840*Dd**2*Pk2*f**4*s**2 + 72540*Dd**2*Pk2*f**4*s - 14040*Dd**2*Pk2*f**4 + 38688*Dd**2*Pk2*f**3*r*s - 9672*Dd**2*Pk2*f**3*r + 12480*Dd**2*Pk2*f**3*s**2 - 25584*Dd**2*Pk2*f**3*s + 6448*Dd**2*Pk2*f**3 - 82368*Dd**2*Pk2*f**2*g2*r*s + 20592*Dd**2*Pk2*f**2*g2*r - 185328*Dd**2*Pk2*f**2*g2*s**2 + 133848*Dd**2*Pk2*f**2*g2*s - 13728*Dd**2*Pk2*f**2*g2 + 2700*Dd**2*Pkdd2*f**4*k1**2*s**2 - 1350*Dd**2*Pkdd2*f**4*k1**2*s - 156*Dd**2*Pkdd2*f**3*k1**2*s**2 + 78*Dd**2*Pkdd2*f**3*k1**2*s + 1716*Pk2*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(2*r*(s - 1) + 3*s**2 - 4*s + 2) + D1*(2*Dd*(f*(8*r*s - 2*r + 12*s**2 - 10*s + 3) + fd*(-8*r*s + 5*r - 12*s**2 + 13*s - 4)) + Ddd*f*(r*(2 - 8*s) - 12*s**2 + 10*s - 3)) - 2*Dd**2*f*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2)) + 78*Pk2*b1*(-88*D1**2*K*f*fd*r*s + 44*D1**2*K*f*fd*r - 198*D1**2*K*f*fd*s**2 + 198*D1**2*K*f*fd*s - 99*D1**2*K*f*fd + 88*D1**2*K*f*fdd*r*s - 44*D1**2*K*f*fdd*r + 198*D1**2*K*f*fdd*s**2 - 198*D1**2*K*f*fdd*s + 99*D1**2*K*f*fdd + 88*D1**2*K*fd**2*r*s - 44*D1**2*K*fd**2*r + 198*D1**2*K*fd**2*s**2 - 198*D1**2*K*fd**2*s - 22*D1**2*bdd1*f*(K - 1)*(6*s**2 + s*(4*r - 4) + 1) - 480*D1**2*f**2*fd*r*s + 160*D1**2*f**2*fd*r - 360*D1**2*f**2*fd*s**2 + 400*D1**2*f**2*fd*s - 100*D1**2*f**2*fd + 240*D1**2*f**2*fdd*r*s - 80*D1**2*f**2*fdd*r + 180*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd*s + 50*D1**2*f**2*fdd + 480*D1**2*f*fd**2*r*s - 160*D1**2*f*fd**2*r + 360*D1**2*f*fd**2*s**2 - 400*D1**2*f*fd**2*s + 100*D1**2*f*fd**2 + 110*D1**2*f*fd*s**2 - 110*D1**2*f*fd*s + 55*D1**2*f*fd - 88*D1**2*f*fdd*r*s + 44*D1**2*f*fdd*r - 198*D1**2*f*fdd*s**2 + 198*D1**2*f*fdd*s - 99*D1**2*f*fdd - 176*D1**2*f*gd2*r*s - 264*D1**2*f*gd2*s**2 + 176*D1**2*f*gd2*s + 88*D1**2*f*gdd2*r*s + 132*D1**2*f*gdd2*s**2 - 88*D1**2*f*gdd2*s - 88*D1**2*fd**2*r*s + 44*D1**2*fd**2*r - 198*D1**2*fd**2*s**2 + 198*D1**2*fd**2*s - 176*D1**2*fd*g2*r*s + 176*D1**2*fd*g2*r - 264*D1**2*fd*g2*s**2 + 352*D1**2*fd*g2*s - 176*D1**2*fd*g2 + 176*D1**2*fd*gd2*r*s - 88*D1**2*fd*gd2*r + 264*D1**2*fd*gd2*s**2 - 264*D1**2*fd*gd2*s + 88*D1**2*fd*gd2 + 88*D1**2*fdd*g2*r*s - 88*D1**2*fdd*g2*r + 132*D1**2*fdd*g2*s**2 - 176*D1**2*fdd*g2*s + 88*D1**2*fdd*g2 - 176*D1*Dd*K*f**2*r*s + 44*D1*Dd*K*f**2*r - 396*D1*Dd*K*f**2*s**2 + 286*D1*Dd*K*f**2*s - 99*D1*Dd*K*f**2 + 704*D1*Dd*K*f*fd*r*s - 264*D1*Dd*K*f*fd*r + 1584*D1*Dd*K*f*fd*s**2 - 1364*D1*Dd*K*f*fd*s + 286*D1*Dd*K*f*fd - 640*D1*Dd*f**3*r*s + 160*D1*Dd*f**3*r - 480*D1*Dd*f**3*s**2 + 560*D1*Dd*f**3*s - 120*D1*Dd*f**3 + 1920*D1*Dd*f**2*fd*r*s - 560*D1*Dd*f**2*fd*r + 1440*D1*Dd*f**2*fd*s**2 - 1640*D1*Dd*f**2*fd*s + 360*D1*Dd*f**2*fd + 220*D1*Dd*f**2*s**2 - 110*D1*Dd*f**2*s + 55*D1*Dd*f**2 - 704*D1*Dd*f*fd*r*s + 264*D1*Dd*f*fd*r - 1584*D1*Dd*f*fd*s**2 + 1364*D1*Dd*f*fd*s - 286*D1*Dd*f*fd - 704*D1*Dd*f*g2*r*s + 176*D1*Dd*f*g2*r - 1056*D1*Dd*f*g2*s**2 + 880*D1*Dd*f*g2*s - 264*D1*Dd*f*g2 + 704*D1*Dd*f*gd2*r*s - 88*D1*Dd*f*gd2*r + 1056*D1*Dd*f*gd2*s**2 - 792*D1*Dd*f*gd2*s + 88*D1*Dd*f*gd2 + 704*D1*Dd*fd*g2*r*s - 440*D1*Dd*fd*g2*r + 1056*D1*Dd*fd*g2*s**2 - 1144*D1*Dd*fd*g2*s + 352*D1*Dd*fd*g2 + 176*D1*Ddd*K*f**2*r*s - 44*D1*Ddd*K*f**2*r + 396*D1*Ddd*K*f**2*s**2 - 286*D1*Ddd*K*f**2*s + 99*D1*Ddd*K*f**2 + 320*D1*Ddd*f**3*r*s - 80*D1*Ddd*f**3*r + 240*D1*Ddd*f**3*s**2 - 280*D1*Ddd*f**3*s + 60*D1*Ddd*f**3 - 176*D1*Ddd*f**2*r*s + 44*D1*Ddd*f**2*r - 396*D1*Ddd*f**2*s**2 + 286*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 + 352*D1*Ddd*f*g2*r*s - 88*D1*Ddd*f*g2*r + 528*D1*Ddd*f*g2*s**2 - 440*D1*Ddd*f*g2*s + 132*D1*Ddd*f*g2 + 44*D1*bd1*(K - 1)*(D1*(f*(6*s**2 + s*(4*r - 4) + 1) + fd*(r*(2 - 4*s) - 6*s**2 + 6*s - 1)) - 2*Dd*f*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) + 528*Dd**2*K*f**2*r*s - 132*Dd**2*K*f**2*r + 1188*Dd**2*K*f**2*s**2 - 858*Dd**2*K*f**2*s + 88*Dd**2*K*f**2 + 960*Dd**2*f**3*r*s - 240*Dd**2*f**3*r + 720*Dd**2*f**3*s**2 - 840*Dd**2*f**3*s + 160*Dd**2*f**3 - 528*Dd**2*f**2*r*s + 132*Dd**2*f**2*r - 1188*Dd**2*f**2*s**2 + 858*Dd**2*f**2*s - 88*Dd**2*f**2 + 1056*Dd**2*f*g2*r*s - 264*Dd**2*f*g2*r + 1584*Dd**2*f*g2*s**2 - 1320*Dd**2*f*g2*s + 176*Dd**2*f*g2))/(3003*d**2*k3**4) - D1**2*Pk3*ct**2*k1**2*st**2*(7908*C*D1**2*Pk2*f**2*fd*r**2 - 5976*C*D1**2*Pk2*f**2*fd*r*s - 3280*C*D1**2*Pk2*f**2*fd*r - 82656*C*D1**2*Pk2*f**2*fd*s**2 + 57096*C*D1**2*Pk2*f**2*fd*s - 24916*C*D1**2*Pk2*f**2*fd - 7716*C*D1**2*Pk2*f**2*fdd*r**2 + 4968*C*D1**2*Pk2*f**2*fdd*r*s + 3488*C*D1**2*Pk2*f**2*fdd*r + 55584*C*D1**2*Pk2*f**2*fdd*s**2 - 38712*C*D1**2*Pk2*f**2*fdd*s + 15956*C*D1**2*Pk2*f**2*fdd - 15432*C*D1**2*Pk2*f*fd**2*r**2 + 9936*C*D1**2*Pk2*f*fd**2*r*s + 6976*C*D1**2*Pk2*f*fd**2*r + 111168*C*D1**2*Pk2*f*fd**2*s**2 - 77424*C*D1**2*Pk2*f*fd**2*s + 1656*C*D1**2*Pk2*f*fd**2 - 198*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 132*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 66*C*D1**2*Pkdd2*f**2*fd*k1**2 + 10544*C*D1*Dd*Pk2*f**3*r**2 - 7968*C*D1*Dd*Pk2*f**3*r*s - 8552*C*D1*Dd*Pk2*f**3*r - 110208*C*D1*Dd*Pk2*f**3*s**2 + 59088*C*D1*Dd*Pk2*f**3*s - 22280*C*D1*Dd*Pk2*f**3 - 61728*C*D1*Dd*Pk2*f**2*fd*r**2 + 39744*C*D1*Dd*Pk2*f**2*fd*r*s + 39848*C*D1*Dd*Pk2*f**2*fd*r + 444672*C*D1*Dd*Pk2*f**2*fd*s**2 - 275952*C*D1*Dd*Pk2*f**2*fd*s + 31736*C*D1*Dd*Pk2*f**2*fd - 264*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 132*C*D1*Dd*Pkdd2*f**3*k1**2*s - 66*C*D1*Dd*Pkdd2*f**3*k1**2 - 10288*C*D1*Ddd*Pk2*f**3*r**2 + 6624*C*D1*Ddd*Pk2*f**3*r*s + 8632*C*D1*Ddd*Pk2*f**3*r + 74112*C*D1*Ddd*Pk2*f**3*s**2 - 40368*C*D1*Ddd*Pk2*f**3*s + 13384*C*D1*Ddd*Pk2*f**3 - 30864*C*Dd**2*Pk2*f**3*r**2 + 19872*C*Dd**2*Pk2*f**3*r*s + 25896*C*Dd**2*Pk2*f**3*r + 222336*C*Dd**2*Pk2*f**3*s**2 - 121104*C*Dd**2*Pk2*f**3*s - 1832*C*Dd**2*Pk2*f**3 - 7920*D1**2*Pk2*bd2*f**2*r*s - 7920*D1**2*Pk2*bd2*f**2*s**2 + 7920*D1**2*Pk2*bd2*f**2*s + 19008*D1**2*Pk2*bd2*f*fd*r*s - 4752*D1**2*Pk2*bd2*f*fd*r + 19008*D1**2*Pk2*bd2*f*fd*s**2 - 19008*D1**2*Pk2*bd2*f*fd*s + 4752*D1**2*Pk2*bd2*f*fd + 4752*D1**2*Pk2*bdd2*f**2*r*s + 4752*D1**2*Pk2*bdd2*f**2*s**2 - 4752*D1**2*Pk2*bdd2*f**2*s + 28512*D1**2*Pk2*f**3*fd*r**2 + 71280*D1**2*Pk2*f**3*fd*r*s - 46332*D1**2*Pk2*f**3*fd*r + 23760*D1**2*Pk2*f**3*fd*s**2 - 47520*D1**2*Pk2*f**3*fd*s + 20196*D1**2*Pk2*f**3*fd - 28512*D1**2*Pk2*f**3*fdd*r**2 - 71280*D1**2*Pk2*f**3*fdd*r*s + 46332*D1**2*Pk2*f**3*fdd*r - 23760*D1**2*Pk2*f**3*fdd*s**2 + 47520*D1**2*Pk2*f**3*fdd*s - 20196*D1**2*Pk2*f**3*fdd - 85536*D1**2*Pk2*f**2*fd**2*r**2 - 213840*D1**2*Pk2*f**2*fd**2*r*s + 138996*D1**2*Pk2*f**2*fd**2*r - 71280*D1**2*Pk2*f**2*fd**2*s**2 + 142560*D1**2*Pk2*f**2*fd**2*s - 49896*D1**2*Pk2*f**2*fd**2 - 21768*D1**2*Pk2*f**2*fd*r**2 - 56520*D1**2*Pk2*f**2*fd*r*s + 33352*D1**2*Pk2*f**2*fd*r + 24048*D1**2*Pk2*f**2*fd*s**2 + 2808*D1**2*Pk2*f**2*fd*s + 760*D1**2*Pk2*f**2*fd + 20784*D1**2*Pk2*f**2*fdd*r**2 + 42120*D1**2*Pk2*f**2*fdd*r*s - 27896*D1**2*Pk2*f**2*fdd*r - 14400*D1**2*Pk2*f**2*fdd*s**2 - 4440*D1**2*Pk2*f**2*fdd*s + 2128*D1**2*Pk2*f**2*fdd - 2244*D1**2*Pk2*f**2*gd2*r**2 + 15048*D1**2*Pk2*f**2*gd2*r*s + 4488*D1**2*Pk2*f**2*gd2*r + 41184*D1**2*Pk2*f**2*gd2*s**2 - 15048*D1**2*Pk2*f**2*gd2*s - 2244*D1**2*Pk2*f**2*gd2 + 1452*D1**2*Pk2*f**2*gdd2*r**2 - 10296*D1**2*Pk2*f**2*gdd2*r*s - 2904*D1**2*Pk2*f**2*gdd2*r - 28512*D1**2*Pk2*f**2*gdd2*s**2 + 10296*D1**2*Pk2*f**2*gdd2*s + 1452*D1**2*Pk2*f**2*gdd2 + 41568*D1**2*Pk2*f*fd**2*r**2 + 84240*D1**2*Pk2*f*fd**2*r*s - 55792*D1**2*Pk2*f*fd**2*r - 28800*D1**2*Pk2*f*fd**2*s**2 - 8880*D1**2*Pk2*f*fd**2*s + 14040*D1**2*Pk2*f*fd**2 - 4488*D1**2*Pk2*f*fd*g2*r**2 + 30096*D1**2*Pk2*f*fd*g2*r*s - 15048*D1**2*Pk2*f*fd*g2*r + 82368*D1**2*Pk2*f*fd*g2*s**2 - 82368*D1**2*Pk2*f*fd*g2*s + 41184*D1**2*Pk2*f*fd*g2 + 5808*D1**2*Pk2*f*fd*gd2*r**2 - 41184*D1**2*Pk2*f*fd*gd2*r*s + 4488*D1**2*Pk2*f*fd*gd2*r - 114048*D1**2*Pk2*f*fd*gd2*s**2 + 77616*D1**2*Pk2*f*fd*gd2*s - 10296*D1**2*Pk2*f*fd*gd2 + 2904*D1**2*Pk2*f*fdd*g2*r**2 - 20592*D1**2*Pk2*f*fdd*g2*r*s + 10296*D1**2*Pk2*f*fdd*g2*r - 57024*D1**2*Pk2*f*fdd*g2*s**2 + 57024*D1**2*Pk2*f*fdd*g2*s - 28512*D1**2*Pk2*f*fdd*g2 + 2904*D1**2*Pk2*fd**2*g2*r**2 - 20592*D1**2*Pk2*fd**2*g2*r*s + 10296*D1**2*Pk2*fd**2*g2*r - 57024*D1**2*Pk2*fd**2*g2*s**2 + 57024*D1**2*Pk2*fd**2*g2*s - 1800*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 900*D1**2*Pkdd2*f**3*fd*k1**2*s - 450*D1**2*Pkdd2*f**3*fd*k1**2 + 198*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 132*D1**2*Pkdd2*f**2*fd*k1**2*s + 66*D1**2*Pkdd2*f**2*fd*k1**2 + 66*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 132*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 132*D1**2*Pkdd2*f*fd*g2*k1**2*s + 66*D1**2*Pkdd2*f*fd*g2*k1**2 - 66*D1**2*bd1**2*(24*Pk2*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 3) + 56*Pk2*g2*(r*(2*s - 1) + s*(2*s - 2)) + f*(-2*Pk2*(-8*C*s**2 + 8*C*s + K*(5*r**2 - r*(46*s + 3) - 70*s**2 + 46*s - 2) - 5*r**2 + r*(-8*C*s + 4*C + 6*s + 17) + 30*s**2 + 6*s - 16) + Pkdd2*k1**2*s*(K - 1)*(s - 1))) + 6*D1**2*bdd1*f*(f**2*(66*Pk2*(27*r**2 + r*(64*s - 50) + 19*s**2 - 44*s + 25) - 25*Pkdd2*k1**2*(2*s**2 - 6*s + 3)) + 11*f*(Pk2*(C*(26*r**2 + r*(68*s - 56) + 20*s**2 - 68*s + 34) + K*(-11*r**2 + 78*r*s + 22*r + 216*s**2 - 78*s - 11) + 51*r**2 + 70*r*s - 62*r - 44*s**2 - 46*s + 7) - Pkdd2*k1**2*(C - 1)*(s - 1)**2) + 11*g2*(-2*Pk2*(5*r**2 + r*(4 - 46*s) - 70*s**2 + 46*s - 23) + Pkdd2*k1**2*(s - 1)**2)) + 38016*D1*Dd*Pk2*bd2*f**2*r*s - 4752*D1*Dd*Pk2*bd2*f**2*r + 38016*D1*Dd*Pk2*bd2*f**2*s**2 - 38016*D1*Dd*Pk2*bd2*f**2*s + 4752*D1*Dd*Pk2*bd2*f**2 + 28512*D1*Dd*Pk2*f**4*r**2 + 71280*D1*Dd*Pk2*f**4*r*s - 46332*D1*Dd*Pk2*f**4*r + 23760*D1*Dd*Pk2*f**4*s**2 - 47520*D1*Dd*Pk2*f**4*s + 20196*D1*Dd*Pk2*f**4 - 228096*D1*Dd*Pk2*f**3*fd*r**2 - 570240*D1*Dd*Pk2*f**3*fd*r*s + 370656*D1*Dd*Pk2*f**3*fd*r - 190080*D1*Dd*Pk2*f**3*fd*s**2 + 380160*D1*Dd*Pk2*f**3*fd*s - 140184*D1*Dd*Pk2*f**3*fd - 29024*D1*Dd*Pk2*f**3*r**2 - 75360*D1*Dd*Pk2*f**3*r*s + 47864*D1*Dd*Pk2*f**3*r + 32064*D1*Dd*Pk2*f**3*s**2 + 21648*D1*Dd*Pk2*f**3*s - 6496*D1*Dd*Pk2*f**3 + 166272*D1*Dd*Pk2*f**2*fd*r**2 + 336960*D1*Dd*Pk2*f**2*fd*r*s - 236840*D1*Dd*Pk2*f**2*fd*r - 115200*D1*Dd*Pk2*f**2*fd*s**2 - 73200*D1*Dd*Pk2*f**2*fd*s + 60232*D1*Dd*Pk2*f**2*fd - 8976*D1*Dd*Pk2*f**2*g2*r**2 + 60192*D1*Dd*Pk2*f**2*g2*r*s - 6072*D1*Dd*Pk2*f**2*g2*r + 164736*D1*Dd*Pk2*f**2*g2*s**2 - 112464*D1*Dd*Pk2*f**2*g2*s + 36696*D1*Dd*Pk2*f**2*g2 + 11616*D1*Dd*Pk2*f**2*gd2*r**2 - 82368*D1*Dd*Pk2*f**2*gd2*r*s - 7128*D1*Dd*Pk2*f**2*gd2*r - 228096*D1*Dd*Pk2*f**2*gd2*s**2 + 118800*D1*Dd*Pk2*f**2*gd2*s - 4488*D1*Dd*Pk2*f**2*gd2 + 23232*D1*Dd*Pk2*f*fd*g2*r**2 - 164736*D1*Dd*Pk2*f*fd*g2*r*s + 50160*D1*Dd*Pk2*f*fd*g2*r - 456192*D1*Dd*Pk2*f*fd*g2*s**2 + 383328*D1*Dd*Pk2*f*fd*g2*s - 77616*D1*Dd*Pk2*f*fd*g2 - 1800*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 900*D1*Dd*Pkdd2*f**4*k1**2*s - 450*D1*Dd*Pkdd2*f**4*k1**2 + 264*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 132*D1*Dd*Pkdd2*f**3*k1**2*s + 66*D1*Dd*Pkdd2*f**3*k1**2 + 264*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 132*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 66*D1*Dd*Pkdd2*f**2*g2*k1**2 - 28512*D1*Ddd*Pk2*f**4*r**2 - 71280*D1*Ddd*Pk2*f**4*r*s + 46332*D1*Ddd*Pk2*f**4*r - 23760*D1*Ddd*Pk2*f**4*s**2 + 47520*D1*Ddd*Pk2*f**4*s - 20196*D1*Ddd*Pk2*f**4 + 27712*D1*Ddd*Pk2*f**3*r**2 + 56160*D1*Ddd*Pk2*f**3*r*s - 41752*D1*Ddd*Pk2*f**3*r - 19200*D1*Ddd*Pk2*f**3*s**2 - 18480*D1*Ddd*Pk2*f**3*s + 9056*D1*Ddd*Pk2*f**3 + 5808*D1*Ddd*Pk2*f**2*g2*r**2 - 41184*D1*Ddd*Pk2*f**2*g2*r*s + 4488*D1*Ddd*Pk2*f**2*g2*r - 114048*D1*Ddd*Pk2*f**2*g2*s**2 + 77616*D1*Ddd*Pk2*f**2*g2*s - 25608*D1*Ddd*Pk2*f**2*g2 - 3*D1*bd1*(D1*(4*f**3*(33*Pk2*(21*r**2 + r*(76*s - 42) + 33*s**2 - 56*s + 23) - 25*Pkdd2*k1**2*(2*s**2 - 6*s + 3)) + f**2*(22*Pk2*(2*C*(19*r**2 + r*(54*s - 44) + 18*s**2 - 54*s + 27) - 17*K*r**2 + 114*K*r*s + 34*K*r + 312*K*s**2 - 114*K*s - 17*K - 12*fd*(81*r**2 + 8*r*(24*s - 17) + 57*s**2 - 127*s + 47) + 57*r**2 + 74*r*s - 34*r - 76*s**2 - 26*s - 27) + Pkdd2*k1**2*(-44*C*(s - 1)**2 + s**2*(11*K + 600*fd + 33) - s*(800*fd + 88) + 44)) - 44*f*(Pk2*g2*(59*r**2 - 10*r*(5*s + 2) - 126*s**2 - 6*s + 3) + Pk2*gd2*(-10*r**2 + r*(92*s + 6) + 140*s**2 - 92*s + 4) - Pkdd2*g2*k1**2*(s - 1)**2 + Pkdd2*gd2*k1**2*s*(s - 1) + fd*(Pk2*(4*C*(13*r**2 + r*(34*s - 22) + 10*s**2 - 22*s + 7) + K*(-22*r**2 + 156*r*s - 17*r + 432*s**2 - 294*s + 39) + 102*r**2 + 140*r*s - 117*r - 88*s**2 - 14*s + 47) + 2*Pkdd2*k1**2*s*(-C*s + C + s - 1))) + 44*fd*g2*(2*Pk2*(5*r**2 + r*(23 - 46*s) - s*(70*s - 70)) - Pkdd2*k1**2*s*(s - 1))) - 4*Dd*f*(f**2*(66*Pk2*(108*r**2 + 2*r*(128*s - 93) + 76*s**2 - 171*s + 72) - 25*Pkdd2*k1**2*(8*s**2 - 14*s + 3)) + 11*f*(Pk2*(2*C*(52*r**2 + r*(136*s - 99) + 40*s**2 - 112*s + 45) + K*(-44*r**2 + 312*r*s + 27*r + 864*s**2 - 450*s + 17) + 204*r**2 + 280*r*s - 261*r - 176*s**2 - 118*s + 85) - Pkdd2*k1**2*(C - 1)*(4*s**2 - 5*s + 1)) + 11*g2*(Pk2*(-40*r**2 + r*(368*s - 42) + 560*s**2 - 416*s + 54) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 85536*Dd**2*Pk2*f**4*r**2 - 213840*Dd**2*Pk2*f**4*r*s + 138996*Dd**2*Pk2*f**4*r - 71280*Dd**2*Pk2*f**4*s**2 + 142560*Dd**2*Pk2*f**4*s - 49896*Dd**2*Pk2*f**4 + 83136*Dd**2*Pk2*f**3*r**2 + 168480*Dd**2*Pk2*f**3*r*s - 125256*Dd**2*Pk2*f**3*r - 57600*Dd**2*Pk2*f**3*s**2 - 55440*Dd**2*Pk2*f**3*s + 41936*Dd**2*Pk2*f**3 + 17424*Dd**2*Pk2*f**2*g2*r**2 - 123552*Dd**2*Pk2*f**2*g2*r*s + 13464*Dd**2*Pk2*f**2*g2*r - 342144*Dd**2*Pk2*f**2*g2*s**2 + 232848*Dd**2*Pk2*f**2*g2*s - 17688*Dd**2*Pk2*f**2*g2 - 1848*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) - 1584*Pk2*b2*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 33*b1**2*(-32*C*D1**2*Pk2*fd*r*s - 32*C*D1**2*Pk2*fd*s**2 + 32*C*D1**2*Pk2*fd*s + 16*C*D1**2*Pk2*fdd*r*s + 16*C*D1**2*Pk2*fdd*s**2 - 16*C*D1**2*Pk2*fdd*s - 128*C*D1*Dd*Pk2*f*r*s + 32*C*D1*Dd*Pk2*f*r - 128*C*D1*Dd*Pk2*f*s**2 + 128*C*D1*Dd*Pk2*f*s - 32*C*D1*Dd*Pk2*f + 128*C*D1*Dd*Pk2*fd*r*s - 16*C*D1*Dd*Pk2*fd*r + 128*C*D1*Dd*Pk2*fd*s**2 - 128*C*D1*Dd*Pk2*fd*s + 16*C*D1*Dd*Pk2*fd + 64*C*D1*Ddd*Pk2*f*r*s - 16*C*D1*Ddd*Pk2*f*r + 64*C*D1*Ddd*Pk2*f*s**2 - 64*C*D1*Ddd*Pk2*f*s + 16*C*D1*Ddd*Pk2*f + 192*C*Dd**2*Pk2*f*r*s - 48*C*Dd**2*Pk2*f*r + 192*C*Dd**2*Pk2*f*s**2 - 192*C*Dd**2*Pk2*f*s + 32*C*Dd**2*Pk2*f + 118*D1**2*K*Pk2*fd*r**2 - 100*D1**2*K*Pk2*fd*r*s + 140*D1**2*K*Pk2*fd*r - 252*D1**2*K*Pk2*fd*s**2 + 516*D1**2*K*Pk2*fd*s - 258*D1**2*K*Pk2*fd - 10*D1**2*K*Pk2*fdd*r**2 + 92*D1**2*K*Pk2*fdd*r*s - 84*D1**2*K*Pk2*fdd*r + 140*D1**2*K*Pk2*fdd*s**2 - 188*D1**2*K*Pk2*fdd*s + 94*D1**2*K*Pk2*fdd - 2*D1**2*K*Pkdd2*fd*k1**2*s**2 + D1**2*K*Pkdd2*fdd*k1**2*s**2 - 56*D1**2*Pk2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 384*D1**2*Pk2*f*fd*r*s - 168*D1**2*Pk2*f*fd*r - 384*D1**2*Pk2*f*fd*s**2 - 48*D1**2*Pk2*f*fd*s + 168*D1**2*Pk2*f*fd + 192*D1**2*Pk2*f*fdd*r*s + 96*D1**2*Pk2*f*fdd*r + 192*D1**2*Pk2*f*fdd*s**2 + 48*D1**2*Pk2*f*fdd*s - 96*D1**2*Pk2*f*fdd + 192*D1**2*Pk2*fd**2*r*s + 96*D1**2*Pk2*fd**2*r + 192*D1**2*Pk2*fd**2*s**2 + 48*D1**2*Pk2*fd**2*s - 96*D1**2*Pk2*fd**2 - 118*D1**2*Pk2*fd*r**2 - 172*D1**2*Pk2*fd*r*s - 36*D1**2*Pk2*fd*r - 20*D1**2*Pk2*fd*s**2 - 340*D1**2*Pk2*fd*s + 154*D1**2*Pk2*fd + 10*D1**2*Pk2*fdd*r**2 - 12*D1**2*Pk2*fdd*r*s + 60*D1**2*Pk2*fdd*r - 60*D1**2*Pk2*fdd*s**2 + 156*D1**2*Pk2*fdd*s - 70*D1**2*Pk2*fdd - 224*D1**2*Pk2*gd2*r*s - 224*D1**2*Pk2*gd2*s**2 + 224*D1**2*Pk2*gd2*s + 112*D1**2*Pk2*gdd2*r*s + 112*D1**2*Pk2*gdd2*s**2 - 112*D1**2*Pk2*gdd2*s + 2*D1**2*Pkdd2*fd*k1**2*s**2 - D1**2*Pkdd2*fdd*k1**2*s**2 + 472*D1*Dd*K*Pk2*f*r**2 - 400*D1*Dd*K*Pk2*f*r*s - 372*D1*Dd*K*Pk2*f*r - 1008*D1*Dd*K*Pk2*f*s**2 + 704*D1*Dd*K*Pk2*f*s - 16*D1*Dd*K*Pk2*f - 80*D1*Dd*K*Pk2*fd*r**2 + 736*D1*Dd*K*Pk2*fd*r*s - 388*D1*Dd*K*Pk2*fd*r + 1120*D1*Dd*K*Pk2*fd*s**2 - 1216*D1*Dd*K*Pk2*fd*s + 356*D1*Dd*K*Pk2*fd - 8*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 4*D1*Dd*K*Pkdd2*f*k1**2*s - 2*D1*Dd*K*Pkdd2*f*k1**2 + 8*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 2*D1*Dd*K*Pkdd2*fd*k1**2*s - 768*D1*Dd*Pk2*f**2*r*s + 192*D1*Dd*Pk2*f**2*r - 768*D1*Dd*Pk2*f**2*s**2 + 768*D1*Dd*Pk2*f**2*s - 192*D1*Dd*Pk2*f**2 + 1536*D1*Dd*Pk2*f*fd*r*s + 192*D1*Dd*Pk2*f*fd*r + 1536*D1*Dd*Pk2*f*fd*s**2 - 576*D1*Dd*Pk2*f*fd*s - 240*D1*Dd*Pk2*f*fd - 472*D1*Dd*Pk2*f*r**2 - 688*D1*Dd*Pk2*f*r*s + 644*D1*Dd*Pk2*f*r - 80*D1*Dd*Pk2*f*s**2 + 384*D1*Dd*Pk2*f*s - 256*D1*Dd*Pk2*f + 80*D1*Dd*Pk2*fd*r**2 - 96*D1*Dd*Pk2*fd*r*s + 212*D1*Dd*Pk2*fd*r - 480*D1*Dd*Pk2*fd*s**2 + 768*D1*Dd*Pk2*fd*s - 276*D1*Dd*Pk2*fd - 896*D1*Dd*Pk2*g2*r*s + 224*D1*Dd*Pk2*g2*r - 896*D1*Dd*Pk2*g2*s**2 + 896*D1*Dd*Pk2*g2*s - 224*D1*Dd*Pk2*g2 + 896*D1*Dd*Pk2*gd2*r*s - 112*D1*Dd*Pk2*gd2*r + 896*D1*Dd*Pk2*gd2*s**2 - 896*D1*Dd*Pk2*gd2*s + 112*D1*Dd*Pk2*gd2 + 8*D1*Dd*Pkdd2*f*k1**2*s**2 - 4*D1*Dd*Pkdd2*f*k1**2*s + 2*D1*Dd*Pkdd2*f*k1**2 - 8*D1*Dd*Pkdd2*fd*k1**2*s**2 + 2*D1*Dd*Pkdd2*fd*k1**2*s - 40*D1*Ddd*K*Pk2*f*r**2 + 368*D1*Ddd*K*Pk2*f*r*s - 52*D1*Ddd*K*Pk2*f*r + 560*D1*Ddd*K*Pk2*f*s**2 - 464*D1*Ddd*K*Pk2*f*s + 120*D1*Ddd*K*Pk2*f + 4*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 2*D1*Ddd*K*Pkdd2*f*k1**2*s + D1*Ddd*K*Pkdd2*f*k1**2 + 384*D1*Ddd*Pk2*f**2*r*s - 96*D1*Ddd*Pk2*f**2*r + 384*D1*Ddd*Pk2*f**2*s**2 - 384*D1*Ddd*Pk2*f**2*s + 96*D1*Ddd*Pk2*f**2 + 40*D1*Ddd*Pk2*f*r**2 - 48*D1*Ddd*Pk2*f*r*s - 28*D1*Ddd*Pk2*f*r - 240*D1*Ddd*Pk2*f*s**2 + 144*D1*Ddd*Pk2*f*s - 40*D1*Ddd*Pk2*f + 448*D1*Ddd*Pk2*g2*r*s - 112*D1*Ddd*Pk2*g2*r + 448*D1*Ddd*Pk2*g2*s**2 - 448*D1*Ddd*Pk2*g2*s + 112*D1*Ddd*Pk2*g2 - 4*D1*Ddd*Pkdd2*f*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f*k1**2*s - D1*Ddd*Pkdd2*f*k1**2 + 56*D1*Pk2*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) - 120*Dd**2*K*Pk2*f*r**2 + 1104*Dd**2*K*Pk2*f*r*s - 156*Dd**2*K*Pk2*f*r + 1680*Dd**2*K*Pk2*f*s**2 - 1392*Dd**2*K*Pk2*f*s + 164*Dd**2*K*Pk2*f + 12*Dd**2*K*Pkdd2*f*k1**2*s**2 - 6*Dd**2*K*Pkdd2*f*k1**2*s + 1152*Dd**2*Pk2*f**2*r*s - 288*Dd**2*Pk2*f**2*r + 1152*Dd**2*Pk2*f**2*s**2 - 1152*Dd**2*Pk2*f**2*s + 192*Dd**2*Pk2*f**2 + 120*Dd**2*Pk2*f*r**2 - 144*Dd**2*Pk2*f*r*s - 84*Dd**2*Pk2*f*r - 720*Dd**2*Pk2*f*s**2 + 432*Dd**2*Pk2*f*s - 4*Dd**2*Pk2*f + 1344*Dd**2*Pk2*g2*r*s - 336*Dd**2*Pk2*g2*r + 1344*Dd**2*Pk2*g2*s**2 - 1344*Dd**2*Pk2*g2*s + 224*Dd**2*Pk2*g2 - 12*Dd**2*Pkdd2*f*k1**2*s**2 + 6*Dd**2*Pkdd2*f*k1**2*s) + 3*b1*(-1672*C*D1**2*Pk2*f*fd*r**2 - 4752*C*D1**2*Pk2*f*fd*r*s + 2112*C*D1**2*Pk2*f*fd*r - 1584*C*D1**2*Pk2*f*fd*s**2 + 1584*C*D1**2*Pk2*f*fd*s - 440*C*D1**2*Pk2*f*fd + 1144*C*D1**2*Pk2*f*fdd*r**2 + 2992*C*D1**2*Pk2*f*fdd*r*s - 1408*C*D1**2*Pk2*f*fdd*r + 880*C*D1**2*Pk2*f*fdd*s**2 - 880*C*D1**2*Pk2*f*fdd*s + 264*C*D1**2*Pk2*f*fdd + 1144*C*D1**2*Pk2*fd**2*r**2 + 2992*C*D1**2*Pk2*fd**2*r*s - 1408*C*D1**2*Pk2*fd**2*r + 880*C*D1**2*Pk2*fd**2*s**2 - 880*C*D1**2*Pk2*fd**2*s + 264*C*D1**2*Pk2*fd**2 + 88*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 44*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 44*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 3344*C*D1*Dd*Pk2*f**2*r**2 - 9504*C*D1*Dd*Pk2*f**2*r*s + 5720*C*D1*Dd*Pk2*f**2*r - 3168*C*D1*Dd*Pk2*f**2*s**2 + 6336*C*D1*Dd*Pk2*f**2*s - 2464*C*D1*Dd*Pk2*f**2 + 9152*C*D1*Dd*Pk2*f*fd*r**2 + 23936*C*D1*Dd*Pk2*f*fd*r*s - 13200*C*D1*Dd*Pk2*f*fd*r + 7040*C*D1*Dd*Pk2*f*fd*s**2 - 11264*C*D1*Dd*Pk2*f*fd*s + 3696*C*D1*Dd*Pk2*f*fd + 176*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 88*C*D1*Dd*Pkdd2*f**2*k1**2*s + 44*C*D1*Dd*Pkdd2*f**2*k1**2 - 352*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 88*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 2288*C*D1*Ddd*Pk2*f**2*r**2 + 5984*C*D1*Ddd*Pk2*f**2*r*s - 3784*C*D1*Ddd*Pk2*f**2*r + 1760*C*D1*Ddd*Pk2*f**2*s**2 - 3872*C*D1*Ddd*Pk2*f**2*s + 1584*C*D1*Ddd*Pk2*f**2 - 88*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 44*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 22*C*D1*Ddd*Pkdd2*f**2*k1**2 + 6864*C*Dd**2*Pk2*f**2*r**2 + 17952*C*Dd**2*Pk2*f**2*r*s - 11352*C*Dd**2*Pk2*f**2*r + 5280*C*Dd**2*Pk2*f**2*s**2 - 11616*C*Dd**2*Pk2*f**2*s + 4136*C*Dd**2*Pk2*f**2 - 264*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 132*C*Dd**2*Pkdd2*f**2*k1**2*s + 748*D1**2*K*Pk2*f*fd*r**2 - 5016*D1**2*K*Pk2*f*fd*r*s + 2508*D1**2*K*Pk2*f*fd*r - 13728*D1**2*K*Pk2*f*fd*s**2 + 13728*D1**2*K*Pk2*f*fd*s - 6864*D1**2*K*Pk2*f*fd - 484*D1**2*K*Pk2*f*fdd*r**2 + 3432*D1**2*K*Pk2*f*fdd*r*s - 1716*D1**2*K*Pk2*f*fdd*r + 9504*D1**2*K*Pk2*f*fdd*s**2 - 9504*D1**2*K*Pk2*f*fdd*s + 4752*D1**2*K*Pk2*f*fdd - 484*D1**2*K*Pk2*fd**2*r**2 + 3432*D1**2*K*Pk2*fd**2*r*s - 1716*D1**2*K*Pk2*fd**2*r + 9504*D1**2*K*Pk2*fd**2*s**2 - 9504*D1**2*K*Pk2*fd**2*s - 22*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 22*D1**2*K*Pkdd2*f*fd*k1**2*s - 11*D1**2*K*Pkdd2*f*fd*k1**2 + 616*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 8316*D1**2*Pk2*f**2*fd*r**2 - 30096*D1**2*Pk2*f**2*fd*r*s + 15576*D1**2*Pk2*f**2*fd*r - 13068*D1**2*Pk2*f**2*fd*s**2 + 21384*D1**2*Pk2*f**2*fd*s - 6864*D1**2*Pk2*f**2*fd + 10692*D1**2*Pk2*f**2*fdd*r**2 + 25344*D1**2*Pk2*f**2*fdd*r*s - 16104*D1**2*Pk2*f**2*fdd*r + 7524*D1**2*Pk2*f**2*fdd*s**2 - 16104*D1**2*Pk2*f**2*fdd*s + 6336*D1**2*Pk2*f**2*fdd + 21384*D1**2*Pk2*f*fd**2*r**2 + 50688*D1**2*Pk2*f*fd**2*r*s - 32208*D1**2*Pk2*f*fd**2*r + 15048*D1**2*Pk2*f*fd**2*s**2 - 32208*D1**2*Pk2*f*fd**2*s + 11616*D1**2*Pk2*f*fd**2 - 2508*D1**2*Pk2*f*fd*r**2 - 3256*D1**2*Pk2*f*fd*r*s + 3388*D1**2*Pk2*f*fd*r + 3344*D1**2*Pk2*f*fd*s**2 - 2288*D1**2*Pk2*f*fd*s - 176*D1**2*Pk2*f*fd + 2244*D1**2*Pk2*f*fdd*r**2 + 3080*D1**2*Pk2*f*fdd*r*s - 2420*D1**2*Pk2*f*fdd*r - 1936*D1**2*Pk2*f*fdd*s**2 + 1408*D1**2*Pk2*f*fdd*s + 2596*D1**2*Pk2*f*gd2*r**2 - 2200*D1**2*Pk2*f*gd2*r*s - 5192*D1**2*Pk2*f*gd2*r - 5544*D1**2*Pk2*f*gd2*s**2 + 2200*D1**2*Pk2*f*gd2*s + 2596*D1**2*Pk2*f*gd2 - 220*D1**2*Pk2*f*gdd2*r**2 + 2024*D1**2*Pk2*f*gdd2*r*s + 440*D1**2*Pk2*f*gdd2*r + 3080*D1**2*Pk2*f*gdd2*s**2 - 2024*D1**2*Pk2*f*gdd2*s - 220*D1**2*Pk2*f*gdd2 + 2244*D1**2*Pk2*fd**2*r**2 + 3080*D1**2*Pk2*fd**2*r*s - 2420*D1**2*Pk2*fd**2*r - 1936*D1**2*Pk2*fd**2*s**2 + 1408*D1**2*Pk2*fd**2*s - 528*D1**2*Pk2*fd**2 + 2596*D1**2*Pk2*fd*g2*r**2 - 2200*D1**2*Pk2*fd*g2*r*s + 3080*D1**2*Pk2*fd*g2*r - 5544*D1**2*Pk2*fd*g2*s**2 + 11352*D1**2*Pk2*fd*g2*s - 5676*D1**2*Pk2*fd*g2 - 440*D1**2*Pk2*fd*gd2*r**2 + 4048*D1**2*Pk2*fd*gd2*r*s - 1408*D1**2*Pk2*fd*gd2*r + 6160*D1**2*Pk2*fd*gd2*s**2 - 6160*D1**2*Pk2*fd*gd2*s + 1848*D1**2*Pk2*fd*gd2 - 220*D1**2*Pk2*fdd*g2*r**2 + 2024*D1**2*Pk2*fdd*g2*r*s - 1848*D1**2*Pk2*fdd*g2*r + 3080*D1**2*Pk2*fdd*g2*s**2 - 4136*D1**2*Pk2*fdd*g2*s + 2068*D1**2*Pk2*fdd*g2 + 600*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 200*D1**2*Pkdd2*f**2*fd*k1**2*s - 100*D1**2*Pkdd2*f**2*fd*k1**2 - 300*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 100*D1**2*Pkdd2*f**2*fdd*k1**2*s + 50*D1**2*Pkdd2*f**2*fdd*k1**2 - 600*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 200*D1**2*Pkdd2*f*fd**2*k1**2*s - 66*D1**2*Pkdd2*f*fd*k1**2*s**2 - 22*D1**2*Pkdd2*f*fd*k1**2*s + 11*D1**2*Pkdd2*f*fd*k1**2 + 44*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 44*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 22*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 44*D1**2*Pkdd2*fd**2*k1**2*s**2 - 44*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 44*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 22*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 11*D1**2*bdd1*(48*Pk2*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 4) + 112*Pk2*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + f*(4*Pk2*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + K*(-5*r**2 + 46*r*s + 3*r + 70*s**2 - 46*s + 9) + 5*r**2 - 6*r*s - 17*r - 30*s**2 - 6*s + 5) + Pkdd2*k1**2*(K - 1)*(2*s**2 - 2*s + 1))) + 1496*D1*Dd*K*Pk2*f**2*r**2 - 10032*D1*Dd*K*Pk2*f**2*r*s + 1012*D1*Dd*K*Pk2*f**2*r - 27456*D1*Dd*K*Pk2*f**2*s**2 + 18744*D1*Dd*K*Pk2*f**2*s - 6116*D1*Dd*K*Pk2*f**2 - 3872*D1*Dd*K*Pk2*f*fd*r**2 + 27456*D1*Dd*K*Pk2*f*fd*r*s - 8360*D1*Dd*K*Pk2*f*fd*r + 76032*D1*Dd*K*Pk2*f*fd*s**2 - 63888*D1*Dd*K*Pk2*f*fd*s + 12936*D1*Dd*K*Pk2*f*fd - 44*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 22*D1*Dd*K*Pkdd2*f**2*k1**2*s - 11*D1*Dd*K*Pkdd2*f**2*k1**2 - 11088*D1*Dd*Pk2*f**3*r**2 - 40128*D1*Dd*Pk2*f**3*r*s + 21120*D1*Dd*Pk2*f**3*r - 17424*D1*Dd*Pk2*f**3*s**2 + 28776*D1*Dd*Pk2*f**3*s - 9900*D1*Dd*Pk2*f**3 + 85536*D1*Dd*Pk2*f**2*fd*r**2 + 202752*D1*Dd*Pk2*f**2*fd*r*s - 132528*D1*Dd*Pk2*f**2*fd*r + 60192*D1*Dd*Pk2*f**2*fd*s**2 - 130152*D1*Dd*Pk2*f**2*fd*s + 48312*D1*Dd*Pk2*f**2*fd - 5016*D1*Dd*Pk2*f**2*r**2 - 6512*D1*Dd*Pk2*f**2*r*s + 6644*D1*Dd*Pk2*f**2*r + 6688*D1*Dd*Pk2*f**2*s**2 - 88*D1*Dd*Pk2*f**2*s - 836*D1*Dd*Pk2*f**2 + 17952*D1*Dd*Pk2*f*fd*r**2 + 24640*D1*Dd*Pk2*f*fd*r*s - 21736*D1*Dd*Pk2*f*fd*r - 15488*D1*Dd*Pk2*f*fd*s**2 + 3344*D1*Dd*Pk2*f*fd*s + 3432*D1*Dd*Pk2*f*fd + 10384*D1*Dd*Pk2*f*g2*r**2 - 8800*D1*Dd*Pk2*f*g2*r*s - 8184*D1*Dd*Pk2*f*g2*r - 22176*D1*Dd*Pk2*f*g2*s**2 + 15488*D1*Dd*Pk2*f*g2*s - 352*D1*Dd*Pk2*f*g2 - 1760*D1*Dd*Pk2*f*gd2*r**2 + 16192*D1*Dd*Pk2*f*gd2*r*s + 616*D1*Dd*Pk2*f*gd2*r + 24640*D1*Dd*Pk2*f*gd2*s**2 - 18304*D1*Dd*Pk2*f*gd2*s + 1144*D1*Dd*Pk2*f*gd2 - 1760*D1*Dd*Pk2*fd*g2*r**2 + 16192*D1*Dd*Pk2*fd*g2*r*s - 8536*D1*Dd*Pk2*fd*g2*r + 24640*D1*Dd*Pk2*fd*g2*s**2 - 26752*D1*Dd*Pk2*fd*g2*s + 7832*D1*Dd*Pk2*fd*g2 + 800*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 400*D1*Dd*Pkdd2*f**3*k1**2*s + 200*D1*Dd*Pkdd2*f**3*k1**2 - 2400*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 200*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 100*D1*Dd*Pkdd2*f**2*fd*k1**2 - 132*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 66*D1*Dd*Pkdd2*f**2*k1**2*s - 33*D1*Dd*Pkdd2*f**2*k1**2 + 352*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 88*D1*Dd*Pkdd2*f*fd*k1**2*s - 176*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 88*D1*Dd*Pkdd2*f*g2*k1**2*s - 44*D1*Dd*Pkdd2*f*g2*k1**2 + 176*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 - 44*D1*Dd*Pkdd2*f*gd2*k1**2*s + 176*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 - 44*D1*Dd*Pkdd2*fd*g2*k1**2*s - 968*D1*Ddd*K*Pk2*f**2*r**2 + 6864*D1*Ddd*K*Pk2*f**2*r*s - 748*D1*Ddd*K*Pk2*f**2*r + 19008*D1*Ddd*K*Pk2*f**2*s**2 - 12936*D1*Ddd*K*Pk2*f**2*s + 4268*D1*Ddd*K*Pk2*f**2 + 14256*D1*Ddd*Pk2*f**3*r**2 + 33792*D1*Ddd*Pk2*f**3*r*s - 22704*D1*Ddd*Pk2*f**3*r + 10032*D1*Ddd*Pk2*f**3*s**2 - 21912*D1*Ddd*Pk2*f**3*s + 9636*D1*Ddd*Pk2*f**3 + 4488*D1*Ddd*Pk2*f**2*r**2 + 6160*D1*Ddd*Pk2*f**2*r*s - 6028*D1*Ddd*Pk2*f**2*r - 3872*D1*Ddd*Pk2*f**2*s**2 - 1144*D1*Ddd*Pk2*f**2*s + 1276*D1*Ddd*Pk2*f**2 - 880*D1*Ddd*Pk2*f*g2*r**2 + 8096*D1*Ddd*Pk2*f*g2*r*s - 1144*D1*Ddd*Pk2*f*g2*r + 12320*D1*Ddd*Pk2*f*g2*s**2 - 10208*D1*Ddd*Pk2*f*g2*s + 2640*D1*Ddd*Pk2*f*g2 - 400*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 200*D1*Ddd*Pkdd2*f**3*k1**2*s - 100*D1*Ddd*Pkdd2*f**3*k1**2 + 88*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 44*D1*Ddd*Pkdd2*f**2*k1**2*s + 22*D1*Ddd*Pkdd2*f**2*k1**2 + 88*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 - 44*D1*Ddd*Pkdd2*f*g2*k1**2*s + 22*D1*Ddd*Pkdd2*f*g2*k1**2 + 22*D1*bd1*(D1*(12*Pk2*f**2*(r*(16*s - 15) + 16*s**2 - 34*s + 15) + 56*Pk2*(g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + gd2*(-4*r*s + r - (1 - 2*s)**2)) + f*(2*Pk2*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 59*K*r**2 + 50*K*r*s + 69*K*r + 126*K*s**2 - 22*K*s - 31*K - 12*fd*(4*s - 1)*(4*r + 4*s - 3) + 59*r**2 + 86*r*s - 111*r + 10*s**2 - 138*s + 73) + Pkdd2*k1**2*(K - 1)*(2*s**2 - 2*s + 1)) + fd*(-2*Pk2*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(-10*r**2 + 92*r*s - 39*r + 140*s**2 - 140*s + 21) + 10*r**2 - 12*r*s + 13*r - 60*s**2 + 72*s - 19) + Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 1))) - Dd*(24*Pk2*f**2*(4*r*(8*s - 5) + 32*s**2 - 52*s + 17) + 112*Pk2*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2) + f*(4*Pk2*(4*C*r*(8*s - 3) + 8*C*(1 - 2*s)**2 + K*(-20*r**2 + r*(184*s - 7) + 280*s**2 - 208*s + 20) + 20*r**2 - 24*r*s - 41*r - 120*s**2 + 24*s + 20) + Pkdd2*k1**2*(K - 1)*(8*s**2 - 6*s + 1)))) - 2904*Dd**2*K*Pk2*f**2*r**2 + 20592*Dd**2*K*Pk2*f**2*r*s - 2244*Dd**2*K*Pk2*f**2*r + 57024*Dd**2*K*Pk2*f**2*s**2 - 38808*Dd**2*K*Pk2*f**2*s + 2948*Dd**2*K*Pk2*f**2 + 42768*Dd**2*Pk2*f**3*r**2 + 101376*Dd**2*Pk2*f**3*r*s - 68112*Dd**2*Pk2*f**3*r + 30096*Dd**2*Pk2*f**3*s**2 - 65736*Dd**2*Pk2*f**3*s + 24024*Dd**2*Pk2*f**3 + 13464*Dd**2*Pk2*f**2*r**2 + 18480*Dd**2*Pk2*f**2*r*s - 18084*Dd**2*Pk2*f**2*r - 11616*Dd**2*Pk2*f**2*s**2 - 3432*Dd**2*Pk2*f**2*s + 5324*Dd**2*Pk2*f**2 - 2640*Dd**2*Pk2*f*g2*r**2 + 24288*Dd**2*Pk2*f*g2*r*s - 3432*Dd**2*Pk2*f*g2*r + 36960*Dd**2*Pk2*f*g2*s**2 - 30624*Dd**2*Pk2*f*g2*s + 3608*Dd**2*Pk2*f*g2 - 1200*Dd**2*Pkdd2*f**3*k1**2*s**2 + 600*Dd**2*Pkdd2*f**3*k1**2*s + 264*Dd**2*Pkdd2*f**2*k1**2*s**2 - 132*Dd**2*Pkdd2*f**2*k1**2*s + 264*Dd**2*Pkdd2*f*g2*k1**2*s**2 - 132*Dd**2*Pkdd2*f*g2*k1**2*s))/(1386*d**2*k3**4) + D1**2*Pk3*ct**2*k1**2*(-66*D1**2*bd1**2*(4*Pk2*f*(31*C*s**2 - 31*C*s + K*(-17*r**2 + r*(44 - 14*s) + 23*s**2 + 24*s - 27) + r**2*(35*C + 35) + r*(66*C*s - 33*C + 74*s - 117) + 19*s**2 - 109*s + 80) - 112*Pk2*g2*(r**2 + r*(2*s - 1) + s*(s - 1)) + f**2*(12*Pk2*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + 5*Pkdd2*k1**2*s*(s - 1))) - 33*D1*bd1*(D1*(16*Pk2*fd*g2*(17*r**2 + 7*r*(2*s - 1) - s*(23*s - 23)) + f**3*(36*Pk2*(4*r**2 - 5*r + s*(5 - 4*s)) - 5*Pkdd2*k1**2*(2*s**2 - 6*s + 3)) + 4*f**2*(Pk2*(C*(58*r**2 + 2*r*(29*s - 61) - 29*s**2 - 70*s + 35) + 6*K*r**2 + 124*K*r*s - 12*K*r + 135*K*s**2 - 124*K*s + 6*K - 9*fd*(24*r**2 - 26*r - 24*s**2 + 18*s + 5) - 97*r**2 - 199*r*s + 206*r - 80*s**2 + 201*s - 80) + Pkdd2*k1**2*(3 - 3*C)*(s - 1)**2) - 2*f*(2*Pk2*fd*(2*C*(82*r**2 + 25*r*(4*s - 5) - 64*s**2 - 29*s + 59) + 2*K*(30*r**2 + 248*r*s - 92*r + 258*s**2 - 253*s + 62) - 368*r**2 - 768*r*s + 590*r - 276*s**2 + 521*s - 243) - 8*Pk2*gd2*(17*r**2 + 2*r*(7*s - 22) - 23*s**2 - 24*s + 27) + g2*(2*Pk2*(40*r**2 + 4*r*(7*s - 26) - 43*s**2 - 66*s + 33) - 7*Pkdd2*k1**2*(s - 1)**2))) - 4*Dd*Pk2*f*(9*f**2*(32*r**2 - 36*r - 32*s**2 + 28*s + 5) + f*(C*(328*r**2 + r*(400*s - 686) - 256*s**2 - 324*s + 308) + 2*K*(60*r**2 + 8*r*(62*s - 19) + 516*s**2 - 501*s + 92) - 736*r**2 - 1536*r*s + 1416*r - 552*s**2 + 1286*s - 619) - 4*g2*(68*r**2 + r*(56*s - 149) - 92*s**2 - 59*s + 71))) + 1848*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) - 6*Dd**2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) - 2*Pk2*(3180*C*D1**2*f**2*fd*r**2 + 45168*C*D1**2*f**2*fd*r*s - 17176*C*D1**2*f**2*fd*r + 44946*C*D1**2*f**2*fd*s**2 - 45020*C*D1**2*f**2*fd*s + 16042*C*D1**2*f**2*fd - 5550*C*D1**2*f**2*fdd*r**2 - 43968*C*D1**2*f**2*fdd*r*s + 18356*C*D1**2*f**2*fdd*r - 42966*C*D1**2*f**2*fdd*s**2 + 43300*C*D1**2*f**2*fdd*s - 16172*C*D1**2*f**2*fdd - 11100*C*D1**2*f*fd**2*r**2 - 87936*C*D1**2*f*fd**2*r*s + 36712*C*D1**2*f*fd**2*r - 85932*C*D1**2*f*fd**2*s**2 + 86600*C*D1**2*f*fd**2*s - 14656*C*D1**2*f*fd**2 + 4240*C*D1*Dd*f**3*r**2 + 60224*C*D1*Dd*f**3*r*s - 19296*C*D1*Dd*f**3*r + 59928*C*D1*Dd*f**3*s**2 - 60076*C*D1*Dd*f**3*s + 17102*C*D1*Dd*f**3 - 44400*C*D1*Dd*f**2*fd*r**2 - 351744*C*D1*Dd*f**2*fd*r*s + 139592*C*D1*Dd*f**2*fd*r - 343728*C*D1*Dd*f**2*fd*s**2 + 347068*C*D1*Dd*f**2*fd*s - 80012*C*D1*Dd*f**2*fd - 7400*C*D1*Ddd*f**3*r**2 - 58624*C*D1*Ddd*f**3*r*s + 22056*C*D1*Ddd*f**3*r - 57288*C*D1*Ddd*f**3*s**2 + 57956*C*D1*Ddd*f**3*s - 18022*C*D1*Ddd*f**3 - 22200*C*Dd**2*f**3*r**2 - 175872*C*Dd**2*f**3*r*s + 66168*C*Dd**2*f**3*r - 171864*C*Dd**2*f**3*s**2 + 173868*C*Dd**2*f**3*s - 33012*C*Dd**2*f**3 + 1188*D1**2*b2*f*fd*r**2 + 8712*D1**2*b2*f*fd*r*s - 4356*D1**2*b2*f*fd*r + 7524*D1**2*b2*f*fd*s**2 - 7524*D1**2*b2*f*fd*s + 3762*D1**2*b2*f*fd - 1980*D1**2*b2*f*fdd*r**2 - 8712*D1**2*b2*f*fdd*r*s + 4356*D1**2*b2*f*fdd*r - 6732*D1**2*b2*f*fdd*s**2 + 6732*D1**2*b2*f*fdd*s - 3366*D1**2*b2*f*fdd - 1980*D1**2*b2*fd**2*r**2 - 8712*D1**2*b2*fd**2*r*s + 4356*D1**2*b2*fd**2*r - 6732*D1**2*b2*fd**2*s**2 + 6732*D1**2*b2*fd**2*s - 66*D1**2*bdd1*f*(9*f**2*(4*r**2 - 5*r + s*(5 - 4*s)) + f*(C*(41*r**2 + 50*r*s - 118*r - 32*s**2 - 72*s + 36) + K*(15*r**2 + 124*r*s - 30*r + 129*s**2 - 124*s + 15) - 92*r**2 - 192*r*s + 214*r - 69*s**2 + 191*s - 81) + 2*g2*(-17*r**2 + r*(54 - 14*s) + 23*s**2 + 34*s - 17)) - 990*D1**2*bdd2*f**2*r**2 - 4356*D1**2*bdd2*f**2*r*s + 1980*D1**2*bdd2*f**2*r - 3366*D1**2*bdd2*f**2*s**2 + 4356*D1**2*bdd2*f**2*s - 990*D1**2*bdd2*f**2 - 105*D1**2*f**2*fd*r**2 - 27141*D1**2*f**2*fd*r*s + 9117*D1**2*f**2*fd*r - 29007*D1**2*f**2*fd*s**2 + 28385*D1**2*f**2*fd*s - 9704*D1**2*f**2*fd + 2775*D1**2*f**2*fdd*r**2 + 27381*D1**2*f**2*fdd*r*s - 10977*D1**2*f**2*fdd*r + 28017*D1**2*f**2*fdd*s**2 - 27805*D1**2*f**2*fdd*s + 10264*D1**2*f**2*fdd - 792*D1**2*f**2*gd2*r**2 - 16368*D1**2*f**2*gd2*r*s + 1584*D1**2*f**2*gd2*r - 17820*D1**2*f**2*gd2*s**2 + 16368*D1**2*f**2*gd2*s - 792*D1**2*f**2*gd2 + 1980*D1**2*f**2*gdd2*r**2 + 16368*D1**2*f**2*gdd2*r*s - 3960*D1**2*f**2*gdd2*r + 17028*D1**2*f**2*gdd2*s**2 - 16368*D1**2*f**2*gdd2*s + 1980*D1**2*f**2*gdd2 + 5550*D1**2*f*fd**2*r**2 + 54762*D1**2*f*fd**2*r*s - 21954*D1**2*f*fd**2*r + 56034*D1**2*f*fd**2*s**2 - 55610*D1**2*f*fd**2*s + 9127*D1**2*f*fd**2 - 1584*D1**2*f*fd*g2*r**2 - 32736*D1**2*f*fd*g2*r*s + 16368*D1**2*f*fd*g2*r - 35640*D1**2*f*fd*g2*s**2 + 35640*D1**2*f*fd*g2*s - 17820*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r**2 + 65472*D1**2*f*fd*gd2*r*s - 24288*D1**2*f*fd*gd2*r + 68112*D1**2*f*fd*gd2*s**2 - 66792*D1**2*f*fd*gd2*s + 16368*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r**2 + 32736*D1**2*f*fdd*g2*r*s - 16368*D1**2*f*fdd*g2*r + 34056*D1**2*f*fdd*g2*s**2 - 34056*D1**2*f*fdd*g2*s + 17028*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r**2 + 32736*D1**2*fd**2*g2*r*s - 16368*D1**2*fd**2*g2*r + 34056*D1**2*fd**2*g2*s**2 - 34056*D1**2*fd**2*g2*s + 2376*D1*Dd*b2*f**2*r**2 + 17424*D1*Dd*b2*f**2*r*s - 6732*D1*Dd*b2*f**2*r + 15048*D1*Dd*b2*f**2*s**2 - 16236*D1*Dd*b2*f**2*s + 4950*D1*Dd*b2*f**2 - 15840*D1*Dd*b2*f*fd*r**2 - 69696*D1*Dd*b2*f*fd*r*s + 34056*D1*Dd*b2*f*fd*r - 53856*D1*Dd*b2*f*fd*s**2 + 57816*D1*Dd*b2*f*fd*s - 15444*D1*Dd*b2*f*fd - 140*D1*Dd*f**3*r**2 - 36188*D1*Dd*f**3*r*s + 9187*D1*Dd*f**3*r - 38676*D1*Dd*f**3*s**2 + 37432*D1*Dd*f**3*s - 9739*D1*Dd*f**3 + 22200*D1*Dd*f**2*fd*r**2 + 219048*D1*Dd*f**2*fd*r*s - 82389*D1*Dd*f**2*fd*r + 224136*D1*Dd*f**2*fd*s**2 - 222016*D1*Dd*f**2*fd*s + 49759*D1*Dd*f**2*fd - 3168*D1*Dd*f**2*g2*r**2 - 65472*D1*Dd*f**2*g2*r*s + 19536*D1*Dd*f**2*g2*r - 71280*D1*Dd*f**2*g2*s**2 + 68376*D1*Dd*f**2*g2*s - 19404*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r**2 + 130944*D1*Dd*f**2*gd2*r*s - 40128*D1*Dd*f**2*gd2*r + 136224*D1*Dd*f**2*gd2*s**2 - 132264*D1*Dd*f**2*gd2*s + 24288*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r**2 + 261888*D1*Dd*f*fd*g2*r*s - 114048*D1*Dd*f*fd*g2*r + 272448*D1*Dd*f*fd*g2*s**2 - 269808*D1*Dd*f*fd*g2*s + 66792*D1*Dd*f*fd*g2 - 3960*D1*Ddd*b2*f**2*r**2 - 17424*D1*Ddd*b2*f**2*r*s + 8316*D1*Ddd*b2*f**2*r - 13464*D1*Ddd*b2*f**2*s**2 + 15444*D1*Ddd*b2*f**2*s - 5346*D1*Ddd*b2*f**2 + 3700*D1*Ddd*f**3*r**2 + 36508*D1*Ddd*f**3*r*s - 12827*D1*Ddd*f**3*r + 37356*D1*Ddd*f**3*s**2 - 36932*D1*Ddd*f**3*s + 11189*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r**2 + 65472*D1*Ddd*f**2*g2*r*s - 24288*D1*Ddd*f**2*g2*r + 68112*D1*Ddd*f**2*g2*s**2 - 66792*D1*Ddd*f**2*g2*s + 20988*D1*Ddd*f**2*g2 + 198*D1*bd2*f*(D1*(f*(3*r**2 + 22*r*s - 6*r + 19*s**2 - 22*s + 3) - 2*fd*(10*r**2 + 44*r*s - 21*r + 34*s**2 - 39*s + 11)) - 2*Dd*f*(20*r**2 + r*(88*s - 41) + 68*s**2 - 83*s + 21)) - 11880*Dd**2*b2*f**2*r**2 - 52272*Dd**2*b2*f**2*r*s + 24948*Dd**2*b2*f**2*r - 40392*Dd**2*b2*f**2*s**2 + 46332*Dd**2*b2*f**2*s - 10692*Dd**2*b2*f**2 + 11100*Dd**2*f**3*r**2 + 109524*Dd**2*f**3*r*s - 38481*Dd**2*f**3*r + 112068*Dd**2*f**3*s**2 - 110796*Dd**2*f**3*s + 20104*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r**2 + 196416*Dd**2*f**2*g2*r*s - 72864*Dd**2*f**2*g2*r + 204336*Dd**2*f**2*g2*s**2 - 200376*Dd**2*f**2*g2*s + 36696*Dd**2*f**2*g2) + 33*b1**2*(84*C*D1**2*Pk2*fd*r**2 + 248*C*D1**2*Pk2*fd*r*s - 168*C*D1**2*Pk2*fd*r + 164*C*D1**2*Pk2*fd*s**2 - 248*C*D1**2*Pk2*fd*s + 84*C*D1**2*Pk2*fd - 140*C*D1**2*Pk2*fdd*r**2 - 264*C*D1**2*Pk2*fdd*r*s + 280*C*D1**2*Pk2*fdd*r - 124*C*D1**2*Pk2*fdd*s**2 + 264*C*D1**2*Pk2*fdd*s - 140*C*D1**2*Pk2*fdd + 336*C*D1*Dd*Pk2*f*r**2 + 992*C*D1*Dd*Pk2*f*r*s - 584*C*D1*Dd*Pk2*f*r + 656*C*D1*Dd*Pk2*f*s**2 - 824*C*D1*Dd*Pk2*f*s + 332*C*D1*Dd*Pk2*f - 1120*C*D1*Dd*Pk2*fd*r**2 - 2112*C*D1*Dd*Pk2*fd*r*s + 1944*C*D1*Dd*Pk2*fd*r - 992*C*D1*Dd*Pk2*fd*s**2 + 1832*C*D1*Dd*Pk2*fd*s - 824*C*D1*Dd*Pk2*fd - 560*C*D1*Ddd*Pk2*f*r**2 - 1056*C*D1*Ddd*Pk2*f*r*s + 824*C*D1*Ddd*Pk2*f*r - 496*C*D1*Ddd*Pk2*f*s**2 + 776*C*D1*Ddd*Pk2*f*s - 404*C*D1*Ddd*Pk2*f - 1680*C*Dd**2*Pk2*f*r**2 - 3168*C*Dd**2*Pk2*f*r*s + 2472*C*Dd**2*Pk2*f*r - 1488*C*Dd**2*Pk2*f*s**2 + 2328*C*Dd**2*Pk2*f*s - 808*C*Dd**2*Pk2*f - 80*D1**2*K*Pk2*fd*r**2 - 56*D1**2*K*Pk2*fd*r*s - 152*D1**2*K*Pk2*fd*r + 86*D1**2*K*Pk2*fd*s**2 - 304*D1**2*K*Pk2*fd*s + 152*D1**2*K*Pk2*fd + 68*D1**2*K*Pk2*fdd*r**2 + 56*D1**2*K*Pk2*fdd*r*s + 160*D1**2*K*Pk2*fdd*r - 92*D1**2*K*Pk2*fdd*s**2 + 320*D1**2*K*Pk2*fdd*s - 160*D1**2*K*Pk2*fdd + 7*D1**2*K*Pkdd2*fd*k1**2*s**2 - 56*D1**2*Pk2*bdd1*(K - 1)*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + 432*D1**2*Pk2*f*fd*r**2 + 768*D1**2*Pk2*f*fd*r*s - 456*D1**2*Pk2*f*fd*r + 336*D1**2*Pk2*f*fd*s**2 - 264*D1**2*Pk2*f*fd*s + 168*D1**2*Pk2*f*fd - 528*D1**2*Pk2*f*fdd*r**2 - 768*D1**2*Pk2*f*fdd*r*s + 600*D1**2*Pk2*f*fdd*r - 240*D1**2*Pk2*f*fdd*s**2 + 312*D1**2*Pk2*f*fdd*s - 264*D1**2*Pk2*f*fdd - 528*D1**2*Pk2*fd**2*r**2 - 768*D1**2*Pk2*fd**2*r*s + 600*D1**2*Pk2*fd**2*r - 240*D1**2*Pk2*fd**2*s**2 + 312*D1**2*Pk2*fd**2*s - 72*D1**2*Pk2*fd**2 + 168*D1**2*Pk2*fd*r**2 + 312*D1**2*Pk2*fd*r*s + 244*D1**2*Pk2*fd*r + 82*D1**2*Pk2*fd*s**2 + 400*D1**2*Pk2*fd*s - 160*D1**2*Pk2*fd - 140*D1**2*Pk2*fdd*r**2 - 296*D1**2*Pk2*fdd*r*s - 360*D1**2*Pk2*fdd*r - 76*D1**2*Pk2*fdd*s**2 - 424*D1**2*Pk2*fdd*s + 220*D1**2*Pk2*fdd - 224*D1**2*Pk2*gd2*r**2 - 448*D1**2*Pk2*gd2*r*s + 448*D1**2*Pk2*gd2*r - 224*D1**2*Pk2*gd2*s**2 + 448*D1**2*Pk2*gd2*s - 224*D1**2*Pk2*gd2 + 112*D1**2*Pk2*gdd2*r**2 + 224*D1**2*Pk2*gdd2*r*s - 224*D1**2*Pk2*gdd2*r + 112*D1**2*Pk2*gdd2*s**2 - 224*D1**2*Pk2*gdd2*s + 112*D1**2*Pk2*gdd2 + 20*D1**2*Pkdd2*f*fd*k1**2*s**2 - 10*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 10*D1**2*Pkdd2*fd**2*k1**2*s**2 - 7*D1**2*Pkdd2*fd*k1**2*s**2 - 320*D1*Dd*K*Pk2*f*r**2 - 224*D1*Dd*K*Pk2*f*r*s + 376*D1*Dd*K*Pk2*f*r + 344*D1*Dd*K*Pk2*f*s**2 - 60*D1*Dd*K*Pk2*f*s - 74*D1*Dd*K*Pk2*f + 544*D1*Dd*K*Pk2*fd*r**2 + 448*D1*Dd*K*Pk2*fd*r*s + 312*D1*Dd*K*Pk2*fd*r - 736*D1*Dd*K*Pk2*fd*s**2 + 1352*D1*Dd*K*Pk2*fd*s - 640*D1*Dd*K*Pk2*fd + 28*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 14*D1*Dd*K*Pkdd2*f*k1**2*s + 7*D1*Dd*K*Pkdd2*f*k1**2 + 864*D1*Dd*Pk2*f**2*r**2 + 1536*D1*Dd*Pk2*f**2*r*s - 1248*D1*Dd*Pk2*f**2*r + 672*D1*Dd*Pk2*f**2*s**2 - 1104*D1*Dd*Pk2*f**2*s + 600*D1*Dd*Pk2*f**2 - 4224*D1*Dd*Pk2*f*fd*r**2 - 6144*D1*Dd*Pk2*f*fd*r*s + 5280*D1*Dd*Pk2*f*fd*r - 1920*D1*Dd*Pk2*f*fd*s**2 + 3264*D1*Dd*Pk2*f*fd*s - 1512*D1*Dd*Pk2*f*fd + 672*D1*Dd*Pk2*f*r**2 + 1248*D1*Dd*Pk2*f*r*s - 984*D1*Dd*Pk2*f*r + 328*D1*Dd*Pk2*f*s**2 - 788*D1*Dd*Pk2*f*s + 418*D1*Dd*Pk2*f - 1120*D1*Dd*Pk2*fd*r**2 - 2368*D1*Dd*Pk2*fd*r*s - 584*D1*Dd*Pk2*fd*r - 608*D1*Dd*Pk2*fd*s**2 - 952*D1*Dd*Pk2*fd*s + 1144*D1*Dd*Pk2*fd - 896*D1*Dd*Pk2*g2*r**2 - 1792*D1*Dd*Pk2*g2*r*s + 1344*D1*Dd*Pk2*g2*r - 896*D1*Dd*Pk2*g2*s**2 + 1344*D1*Dd*Pk2*g2*s - 672*D1*Dd*Pk2*g2 + 896*D1*Dd*Pk2*gd2*r**2 + 1792*D1*Dd*Pk2*gd2*r*s - 1568*D1*Dd*Pk2*gd2*r + 896*D1*Dd*Pk2*gd2*s**2 - 1568*D1*Dd*Pk2*gd2*s + 672*D1*Dd*Pk2*gd2 + 40*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 20*D1*Dd*Pkdd2*f**2*k1**2*s + 10*D1*Dd*Pkdd2*f**2*k1**2 - 80*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 20*D1*Dd*Pkdd2*f*fd*k1**2*s - 28*D1*Dd*Pkdd2*f*k1**2*s**2 + 14*D1*Dd*Pkdd2*f*k1**2*s - 7*D1*Dd*Pkdd2*f*k1**2 + 272*D1*Ddd*K*Pk2*f*r**2 + 224*D1*Ddd*K*Pk2*f*r*s - 328*D1*Ddd*K*Pk2*f*r - 368*D1*Ddd*K*Pk2*f*s**2 + 72*D1*Ddd*K*Pk2*f*s + 44*D1*Ddd*K*Pk2*f - 1056*D1*Ddd*Pk2*f**2*r**2 - 1536*D1*Ddd*Pk2*f**2*r*s + 1440*D1*Ddd*Pk2*f**2*r - 480*D1*Ddd*Pk2*f**2*s**2 + 1008*D1*Ddd*Pk2*f**2*s - 648*D1*Ddd*Pk2*f**2 - 560*D1*Ddd*Pk2*f*r**2 - 1184*D1*Ddd*Pk2*f*r*s + 856*D1*Ddd*Pk2*f*r - 304*D1*Ddd*Pk2*f*s**2 + 744*D1*Ddd*Pk2*f*s - 356*D1*Ddd*Pk2*f + 448*D1*Ddd*Pk2*g2*r**2 + 896*D1*Ddd*Pk2*g2*r*s - 672*D1*Ddd*Pk2*g2*r + 448*D1*Ddd*Pk2*g2*s**2 - 672*D1*Ddd*Pk2*g2*s + 336*D1*Ddd*Pk2*g2 - 20*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 10*D1*Ddd*Pkdd2*f**2*k1**2*s - 5*D1*Ddd*Pkdd2*f**2*k1**2 + 112*D1*Pk2*bd1*(K - 1)*(D1*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) - Dd*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6)) + 816*Dd**2*K*Pk2*f*r**2 + 672*Dd**2*K*Pk2*f*r*s - 984*Dd**2*K*Pk2*f*r - 1104*Dd**2*K*Pk2*f*s**2 + 216*Dd**2*K*Pk2*f*s + 248*Dd**2*K*Pk2*f - 3168*Dd**2*Pk2*f**2*r**2 - 4608*Dd**2*Pk2*f**2*r*s + 4320*Dd**2*Pk2*f**2*r - 1440*Dd**2*Pk2*f**2*s**2 + 3024*Dd**2*Pk2*f**2*s - 1296*Dd**2*Pk2*f**2 - 1680*Dd**2*Pk2*f*r**2 - 3552*Dd**2*Pk2*f*r*s + 2568*Dd**2*Pk2*f*r - 912*Dd**2*Pk2*f*s**2 + 2232*Dd**2*Pk2*f*s - 872*Dd**2*Pk2*f + 1344*Dd**2*Pk2*g2*r**2 + 2688*Dd**2*Pk2*g2*r*s - 2016*Dd**2*Pk2*g2*r + 1344*Dd**2*Pk2*g2*s**2 - 2016*Dd**2*Pk2*g2*s + 672*Dd**2*Pk2*g2 - 60*Dd**2*Pkdd2*f**2*k1**2*s**2 + 30*Dd**2*Pkdd2*f**2*k1**2*s) - 33*b1*(464*C*D1**2*Pk2*f*fd*r**2 + 464*C*D1**2*Pk2*f*fd*r*s - 208*C*D1**2*Pk2*f*fd*r - 232*C*D1**2*Pk2*f*fd*s**2 + 280*C*D1**2*Pk2*f*fd*s - 24*C*D1**2*Pk2*f*fd - 328*C*D1**2*Pk2*f*fdd*r**2 - 400*C*D1**2*Pk2*f*fdd*r*s + 56*C*D1**2*Pk2*f*fdd*r + 256*C*D1**2*Pk2*f*fdd*s**2 - 344*C*D1**2*Pk2*f*fdd*s + 108*C*D1**2*Pk2*f*fdd - 328*C*D1**2*Pk2*fd**2*r**2 - 400*C*D1**2*Pk2*fd**2*r*s + 56*C*D1**2*Pk2*fd**2*r + 256*C*D1**2*Pk2*fd**2*s**2 - 344*C*D1**2*Pk2*fd**2*s + 272*C*D1**2*Pk2*fd**2 - 24*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 928*C*D1*Dd*Pk2*f**2*r**2 + 928*C*D1*Dd*Pk2*f**2*r*s - 1160*C*D1*Dd*Pk2*f**2*r - 464*C*D1*Dd*Pk2*f**2*s**2 - 232*C*D1*Dd*Pk2*f**2*s + 348*C*D1*Dd*Pk2*f**2 - 2624*C*D1*Dd*Pk2*f*fd*r**2 - 3200*C*D1*Dd*Pk2*f*fd*r*s + 1936*C*D1*Dd*Pk2*f*fd*r + 2048*C*D1*Dd*Pk2*f*fd*s**2 - 1088*C*D1*Dd*Pk2*f*fd*s + 232*C*D1*Dd*Pk2*f*fd - 48*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 24*C*D1*Dd*Pkdd2*f**2*k1**2*s - 12*C*D1*Dd*Pkdd2*f**2*k1**2 - 656*C*D1*Ddd*Pk2*f**2*r**2 - 800*C*D1*Ddd*Pk2*f**2*r*s + 856*C*D1*Ddd*Pk2*f**2*r + 512*C*D1*Ddd*Pk2*f**2*s**2 + 144*C*D1*Ddd*Pk2*f**2*s - 200*C*D1*Ddd*Pk2*f**2 - 1968*C*Dd**2*Pk2*f**2*r**2 - 2400*C*Dd**2*Pk2*f**2*r*s + 2568*C*Dd**2*Pk2*f**2*r + 1536*C*Dd**2*Pk2*f**2*s**2 + 432*C*Dd**2*Pk2*f**2*s - 728*C*Dd**2*Pk2*f**2 + 48*D1**2*K*Pk2*f*fd*r**2 + 992*D1**2*K*Pk2*f*fd*r*s - 496*D1**2*K*Pk2*f*fd*r + 1080*D1**2*K*Pk2*f*fd*s**2 - 1080*D1**2*K*Pk2*f*fd*s + 540*D1**2*K*Pk2*f*fd - 120*D1**2*K*Pk2*f*fdd*r**2 - 992*D1**2*K*Pk2*f*fdd*r*s + 496*D1**2*K*Pk2*f*fdd*r - 1032*D1**2*K*Pk2*f*fdd*s**2 + 1032*D1**2*K*Pk2*f*fdd*s - 516*D1**2*K*Pk2*f*fdd - 120*D1**2*K*Pk2*fd**2*r**2 - 992*D1**2*K*Pk2*fd**2*r*s + 496*D1**2*K*Pk2*fd**2*r - 1032*D1**2*K*Pk2*fd**2*s**2 + 1032*D1**2*K*Pk2*fd**2*s + 112*D1**2*Pk2*bd1**2*(K - 1)*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 1) + 432*D1**2*Pk2*f**2*fd*r**2 - 396*D1**2*Pk2*f**2*fd*r - 432*D1**2*Pk2*f**2*fd*s**2 + 108*D1**2*Pk2*f**2*fd*s + 144*D1**2*Pk2*f**2*fd - 432*D1**2*Pk2*f**2*fdd*r**2 + 396*D1**2*Pk2*f**2*fdd*r + 432*D1**2*Pk2*f**2*fdd*s**2 - 108*D1**2*Pk2*f**2*fdd*s - 144*D1**2*Pk2*f**2*fdd - 864*D1**2*Pk2*f*fd**2*r**2 + 792*D1**2*Pk2*f*fd**2*r + 864*D1**2*Pk2*f*fd**2*s**2 - 216*D1**2*Pk2*f*fd**2*s - 108*D1**2*Pk2*f*fd**2 - 776*D1**2*Pk2*f*fd*r**2 - 1592*D1**2*Pk2*f*fd*r*s + 748*D1**2*Pk2*f*fd*r - 640*D1**2*Pk2*f*fd*s**2 + 632*D1**2*Pk2*f*fd*s - 388*D1**2*Pk2*f*fd + 736*D1**2*Pk2*f*fdd*r**2 + 1536*D1**2*Pk2*f*fdd*r*s - 648*D1**2*Pk2*f*fdd*r + 552*D1**2*Pk2*f*fdd*s**2 - 556*D1**2*Pk2*f*fdd*s + 320*D1**2*Pk2*f*fdd - 160*D1**2*Pk2*f*gd2*r**2 - 112*D1**2*Pk2*f*gd2*r*s + 320*D1**2*Pk2*f*gd2*r + 172*D1**2*Pk2*f*gd2*s**2 + 112*D1**2*Pk2*f*gd2*s - 160*D1**2*Pk2*f*gd2 + 136*D1**2*Pk2*f*gdd2*r**2 + 112*D1**2*Pk2*f*gdd2*r*s - 272*D1**2*Pk2*f*gdd2*r - 184*D1**2*Pk2*f*gdd2*s**2 - 112*D1**2*Pk2*f*gdd2*s + 136*D1**2*Pk2*f*gdd2 + 736*D1**2*Pk2*fd**2*r**2 + 1536*D1**2*Pk2*fd**2*r*s - 648*D1**2*Pk2*fd**2*r + 552*D1**2*Pk2*fd**2*s**2 - 556*D1**2*Pk2*fd**2*s - 204*D1**2*Pk2*fd**2 - 160*D1**2*Pk2*fd*g2*r**2 - 112*D1**2*Pk2*fd*g2*r*s - 304*D1**2*Pk2*fd*g2*r + 172*D1**2*Pk2*fd*g2*s**2 - 608*D1**2*Pk2*fd*g2*s + 304*D1**2*Pk2*fd*g2 + 272*D1**2*Pk2*fd*gd2*r**2 + 224*D1**2*Pk2*fd*gd2*r*s + 48*D1**2*Pk2*fd*gd2*r - 368*D1**2*Pk2*fd*gd2*s**2 + 528*D1**2*Pk2*fd*gd2*s - 320*D1**2*Pk2*fd*gd2 + 136*D1**2*Pk2*fdd*g2*r**2 + 112*D1**2*Pk2*fdd*g2*r*s + 320*D1**2*Pk2*fdd*g2*r - 184*D1**2*Pk2*fdd*g2*s**2 + 640*D1**2*Pk2*fdd*g2*s - 320*D1**2*Pk2*fdd*g2 - 30*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 10*D1**2*Pkdd2*f**2*fd*k1**2*s + 5*D1**2*Pkdd2*f**2*fd*k1**2 + 24*D1**2*Pkdd2*f*fd*k1**2*s**2 + 14*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 14*D1**2*Pkdd2*fd*g2*k1**2*s**2 + D1**2*bdd1*(4*Pk2*f*(C*(70*r**2 + 66*r*(2*s - 1) + 62*s**2 - 62*s + 31) + K*(-34*r**2 - 28*r*s + 88*r + 46*s**2 + 48*s - 34) + 70*r**2 + 148*r*s - 234*r + 38*s**2 - 218*s + 109) - 112*Pk2*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + f**2*(24*Pk2*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 96*D1*Dd*K*Pk2*f**2*r**2 + 1984*D1*Dd*K*Pk2*f**2*r*s - 592*D1*Dd*K*Pk2*f**2*r + 2160*D1*Dd*K*Pk2*f**2*s**2 - 2072*D1*Dd*K*Pk2*f**2*s + 588*D1*Dd*K*Pk2*f**2 - 960*D1*Dd*K*Pk2*f*fd*r**2 - 7936*D1*Dd*K*Pk2*f*fd*r*s + 3456*D1*Dd*K*Pk2*f*fd*r - 8256*D1*Dd*K*Pk2*f*fd*s**2 + 8176*D1*Dd*K*Pk2*f*fd*s - 2024*D1*Dd*K*Pk2*f*fd + 576*D1*Dd*Pk2*f**3*r**2 - 576*D1*Dd*Pk2*f**3*r - 576*D1*Dd*Pk2*f**3*s**2 + 288*D1*Dd*Pk2*f**3*s + 144*D1*Dd*Pk2*f**3 - 3456*D1*Dd*Pk2*f**2*fd*r**2 + 3312*D1*Dd*Pk2*f**2*fd*r + 3456*D1*Dd*Pk2*f**2*fd*s**2 - 1296*D1*Dd*Pk2*f**2*fd*s - 684*D1*Dd*Pk2*f**2*fd - 1552*D1*Dd*Pk2*f**2*r**2 - 3184*D1*Dd*Pk2*f**2*r*s + 2348*D1*Dd*Pk2*f**2*r - 1280*D1*Dd*Pk2*f**2*s**2 + 2232*D1*Dd*Pk2*f**2*s - 1096*D1*Dd*Pk2*f**2 + 5888*D1*Dd*Pk2*f*fd*r**2 + 12288*D1*Dd*Pk2*f*fd*r*s - 7072*D1*Dd*Pk2*f*fd*r + 4416*D1*Dd*Pk2*f*fd*s**2 - 6400*D1*Dd*Pk2*f*fd*s + 1852*D1*Dd*Pk2*f*fd - 640*D1*Dd*Pk2*f*g2*r**2 - 448*D1*Dd*Pk2*f*g2*r*s + 752*D1*Dd*Pk2*f*g2*r + 688*D1*Dd*Pk2*f*g2*s**2 - 120*D1*Dd*Pk2*f*g2*s - 148*D1*Dd*Pk2*f*g2 + 1088*D1*Dd*Pk2*f*gd2*r**2 + 896*D1*Dd*Pk2*f*gd2*r*s - 1744*D1*Dd*Pk2*f*gd2*r - 1472*D1*Dd*Pk2*f*gd2*s**2 - 304*D1*Dd*Pk2*f*gd2*s + 656*D1*Dd*Pk2*f*gd2 + 1088*D1*Dd*Pk2*fd*g2*r**2 + 896*D1*Dd*Pk2*fd*g2*r*s + 624*D1*Dd*Pk2*fd*g2*r - 1472*D1*Dd*Pk2*fd*g2*s**2 + 2704*D1*Dd*Pk2*fd*g2*s - 1280*D1*Dd*Pk2*fd*g2 - 40*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 20*D1*Dd*Pkdd2*f**3*k1**2*s - 10*D1*Dd*Pkdd2*f**3*k1**2 + 48*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 24*D1*Dd*Pkdd2*f**2*k1**2*s + 12*D1*Dd*Pkdd2*f**2*k1**2 + 56*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 28*D1*Dd*Pkdd2*f*g2*k1**2*s + 14*D1*Dd*Pkdd2*f*g2*k1**2 - 240*D1*Ddd*K*Pk2*f**2*r**2 - 1984*D1*Ddd*K*Pk2*f**2*r*s + 736*D1*Ddd*K*Pk2*f**2*r - 2064*D1*Ddd*K*Pk2*f**2*s**2 + 2024*D1*Ddd*K*Pk2*f**2*s - 636*D1*Ddd*K*Pk2*f**2 - 576*D1*Ddd*Pk2*f**3*r**2 + 576*D1*Ddd*Pk2*f**3*r + 576*D1*Ddd*Pk2*f**3*s**2 - 288*D1*Ddd*Pk2*f**3*s - 144*D1*Ddd*Pk2*f**3 + 1472*D1*Ddd*Pk2*f**2*r**2 + 3072*D1*Ddd*Pk2*f**2*r*s - 2240*D1*Ddd*Pk2*f**2*r + 1104*D1*Ddd*Pk2*f**2*s**2 - 2088*D1*Ddd*Pk2*f**2*s + 1012*D1*Ddd*Pk2*f**2 + 544*D1*Ddd*Pk2*f*g2*r**2 + 448*D1*Ddd*Pk2*f*g2*r*s - 656*D1*Ddd*Pk2*f*g2*r - 736*D1*Ddd*Pk2*f*g2*s**2 + 144*D1*Ddd*Pk2*f*g2*s + 88*D1*Ddd*Pk2*f*g2 + D1*bd1*(-D1*(-8*Pk2*(fd*(C*(70*r**2 + r*(132*s - 103) + 62*s**2 - 97*s + 33) + K*(-34*r**2 - 28*r*s + 4*r + 46*s**2 - 56*s + 20) + 70*r**2 + 148*r*s - 27*r + 38*s**2 - 3*s - 43) + 28*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) - 28*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1)) + 2*f**2*(12*Pk2*(18*r**2 + r*(32*s - 33) + 14*s**2 - 35*s + 18) + 5*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(2*Pk2*(2*C*(42*r**2 + 62*r*(2*s - 1) + 82*s**2 - 82*s + 41) - 80*K*r**2 - 56*K*r*s + 184*K*r + 86*K*s**2 + 94*K*s - 73*K - 12*fd*(88*r**2 + 8*r*(16*s - 15) + 40*s**2 - 84*s + 35) + 168*r**2 + 312*r*s - 446*r + 82*s**2 - 438*s + 205) + Pkdd2*k1**2*(7*K*(2*s**2 - 2*s + 1) - s**2*(40*fd + 14) + s*(20*fd + 14) - 7))) + 2*Dd*(4*Pk2*f*(C*(280*r**2 + r*(528*s - 338) + 248*s**2 - 318*s + 97) - 2*K*(68*r**2 + 56*r*s - 129*r - 92*s**2 - 39*s + 56) + 280*r**2 + 592*r*s - 682*r + 152*s**2 - 622*s + 343) - 112*Pk2*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f**2*(12*Pk2*(176*r**2 + 4*r*(64*s - 65) + 80*s**2 - 200*s + 99) + 5*Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) - 720*Dd**2*K*Pk2*f**2*r**2 - 5952*Dd**2*K*Pk2*f**2*r*s + 2208*Dd**2*K*Pk2*f**2*r - 6192*Dd**2*K*Pk2*f**2*s**2 + 6072*Dd**2*K*Pk2*f**2*s - 1112*Dd**2*K*Pk2*f**2 - 1728*Dd**2*Pk2*f**3*r**2 + 1728*Dd**2*Pk2*f**3*r + 1728*Dd**2*Pk2*f**3*s**2 - 864*Dd**2*Pk2*f**3*s - 288*Dd**2*Pk2*f**3 + 4416*Dd**2*Pk2*f**2*r**2 + 9216*Dd**2*Pk2*f**2*r*s - 6720*Dd**2*Pk2*f**2*r + 3312*Dd**2*Pk2*f**2*s**2 - 6264*Dd**2*Pk2*f**2*s + 2272*Dd**2*Pk2*f**2 + 1632*Dd**2*Pk2*f*g2*r**2 + 1344*Dd**2*Pk2*f*g2*r*s - 1968*Dd**2*Pk2*f*g2*r - 2208*Dd**2*Pk2*f*g2*s**2 + 432*Dd**2*Pk2*f*g2*s + 496*Dd**2*Pk2*f*g2))/(693*d**2*k3**4) + D1**2*Pk3*ct**2*k2**2*st**4*(D1**2*(15*Pkdd2*f**3*k1**2*(bd1*(4*s**2 + 4*s - 2) - 2*bdd1*s**2 - 2*bdd1*s + bdd1 + 4*fd*s**2 - 2*fd*s + fd) + 33*Pkdd2*k1**2*s*(b1**2*s*(K - 1)*(2*fd - fdd) - 2*b1*bd1*fd*(K - 1)*(2*s - 1) + 2*b1*s*(-2*fd*g2 + 2*fd*gd2 + fdd*g2) + 4*bd1*fd*g2*(s - 1)) + f**2*(-4*Pk2*fdd*(2*C*(51*r**2 + 2*r*(60*s - 37) + 90*s**2 - 100*s + 47) - 87*r**2 + r*(98 - 120*s) - 90*s**2 + 100*s - 59) - 5*Pkdd2*fdd*k1**2*(9*b1*(2*s**2 - 2*s + 1) - (8*C - 6)*(3*s**2 - 2*s + 1)) + Pkdd2*k1**2*s**2*(-33*K*bd1 + 33*bd1 + 66*gd2) + 10*fd*(2*Pk2*(C*(21*r**2 + r*(96*s - 46) + 72*s**2 - 80*s + 31) - 15*r**2 + r*(26 - 48*s) - 36*s**2 + 40*s - 17) + Pkdd2*k1**2*(-8*C*(3*s**2 - 2*s + 1) + 9*b1*(2*s**2 - 2*s + 1) - 2*s**2*(9*bd1 - 9) - 12*s + 6))) + f*(33*Pkdd2*fd*k1**2*(2*s**2 - 2*s + 1)*(-K*b1 + b1 + 2*g2) + 33*Pkdd2*k1**2*(b1*(2*bd1*(K - 1)*(2*s**2 - 2*s + 1) - bdd1*(K - 1)*(2*s**2 - 2*s + 1) + s**2*(-4*gd2 + 2*gdd2)) + (2 - 2*s)*(bd1**2*s*(K - 1) + 2*bd1*g2*(s - 1) - 2*bd1*gd2*s - bdd1*g2*(s - 1))) - 4*fd**2*(2*Pk2*(2*C*(51*r**2 + 120*r*s - 74*r + 90*s**2 - 100*s + 20) - 87*r**2 - 120*r*s + 98*r - 90*s**2 + 100*s - 20) + 5*Pkdd2*k1**2*s*(9*b1*(s - 1) - (4*C - 3)*(3*s - 2))))) + D1*(Dd*(-66*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(b1*(K - 1) - 2*g2) + 15*Pkdd2*f**4*k1**2*(4*s**2 - 2*s + 1) + 66*Pkdd2*f*k1**2*(b1**2*(K - 1)*(4*s**2 - 2*s + 1) - b1*bd1*(K - 1)*(8*s**2 - 6*s + 1) - 2*b1*(g2*(4*s**2 - 2*s + 1) + gd2*s*(1 - 4*s)) + 2*bd1*g2*(4*s**2 - 5*s + 1)) + 10*f**3*(4*Pk2*(C*(14*r**2 + r*(64*s - 30) + 48*s**2 - 56*s + 19) - 10*r**2 + r*(18 - 32*s) - 24*s**2 + 28*s - 11) + Pkdd2*k1**2*(6*b1*(4*s**2 - 2*s + 1) - 3*bd1*(8*s**2 + 2*s - 1) - (8*C - 6)*(4*s**2 - 2*s + 1))) + f**2*(Pkdd2*k1**2*(4*s**2 - 2*s + 1)*(-33*K*b1 + 33*b1 + 66*g2) - 2*fd*(8*Pk2*(2*C*(102*r**2 + 5*r*(48*s - 31) + 180*s**2 - 205*s + 62) - 174*r**2 - 240*r*s + 215*r - 180*s**2 + 205*s - 74) + 5*Pkdd2*k1**2*(4*s - 1)*(9*b1*(2*s - 1) - (8*C - 6)*(3*s - 1))))) + Ddd*f*(-33*Pkdd2*b1*k1**2*(b1*(K - 1) - 2*g2)*(4*s**2 - 2*s + 1) - 2*f**2*(8*Pk2*(C*(34*r**2 + 80*r*s - 54*r + 60*s**2 - 70*s + 32) - 29*r**2 - 40*r*s + 39*r - 30*s**2 + 35*s - 22) + Pkdd2*k1**2*(-20*C + 15*b1 + 15)*(4*s**2 - 2*s + 1)))) - 6*Dd**2*f*(33*Pkdd2*b1*k1**2*s*(2*s - 1)*(b1*(K - 1) - 2*g2) + 2*f**2*(2*Pk2*(2*C*(34*r**2 + 80*r*s - 54*r + 60*s**2 - 70*s + 19) - 58*r**2 - 80*r*s + 78*r - 60*s**2 + 70*s - 23) + Pkdd2*k1**2*s*(2*s - 1)*(-20*C + 15*b1 + 15))))/(231*d**2*k3**4) + D1**2*Pk3*ct**2*k2**2*st**2*(-1144*C*D1**2*Pk2*bdd1*f**2*r**2 - 1056*C*D1**2*Pk2*bdd1*f**2*r*s - 6192*C*D1**2*Pk2*f**2*fd*r**2 - 21984*C*D1**2*Pk2*f**2*fd*r*s + 11456*C*D1**2*Pk2*f**2*fd*r - 8712*C*D1**2*Pk2*f**2*fd*s**2 + 13136*C*D1**2*Pk2*f**2*fd*s - 4968*C*D1**2*Pk2*f**2*fd + 9432*C*D1**2*Pk2*f**2*fdd*r**2 + 22080*C*D1**2*Pk2*f**2*fdd*r*s - 13648*C*D1**2*Pk2*f**2*fdd*r + 7128*C*D1**2*Pk2*f**2*fdd*s**2 - 12112*C*D1**2*Pk2*f**2*fdd*s + 5520*C*D1**2*Pk2*f**2*fdd + 18864*C*D1**2*Pk2*f*fd**2*r**2 + 44160*C*D1**2*Pk2*f*fd**2*r*s - 27296*C*D1**2*Pk2*f*fd**2*r + 14256*C*D1**2*Pk2*f*fd**2*s**2 - 24224*C*D1**2*Pk2*f*fd**2*s + 7360*C*D1**2*Pk2*f*fd**2 + 264*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 528*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 264*C*D1**2*Pkdd2*bdd1*f**2*k1**2 + 192*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 128*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 64*C*D1**2*Pkdd2*f**2*fd*k1**2 + 300*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 200*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 100*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 600*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 400*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 8256*C*D1*Dd*Pk2*f**3*r**2 - 29312*C*D1*Dd*Pk2*f**3*r*s + 15584*C*D1*Dd*Pk2*f**3*r - 11616*C*D1*Dd*Pk2*f**3*s**2 + 20464*C*D1*Dd*Pk2*f**3*s - 7032*C*D1*Dd*Pk2*f**3 + 75456*C*D1*Dd*Pk2*f**2*fd*r**2 + 176640*C*D1*Dd*Pk2*f**2*fd*r*s - 114400*C*D1*Dd*Pk2*f**2*fd*r + 57024*C*D1*Dd*Pk2*f**2*fd*s**2 - 106864*C*D1*Dd*Pk2*f**2*fd*s + 39408*C*D1*Dd*Pk2*f**2*fd + 256*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 128*C*D1*Dd*Pkdd2*f**3*k1**2*s + 64*C*D1*Dd*Pkdd2*f**3*k1**2 + 2400*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 1400*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 200*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 12576*C*D1*Ddd*Pk2*f**3*r**2 + 29440*C*D1*Ddd*Pk2*f**3*r*s - 19936*C*D1*Ddd*Pk2*f**3*r + 9504*C*D1*Ddd*Pk2*f**3*s**2 - 19472*C*D1*Ddd*Pk2*f**3*s + 8664*C*D1*Ddd*Pk2*f**3 + 400*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 200*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 100*C*D1*Ddd*Pkdd2*f**3*k1**2 + 37728*C*Dd**2*Pk2*f**3*r**2 + 88320*C*Dd**2*Pk2*f**3*r*s - 59808*C*Dd**2*Pk2*f**3*r + 28512*C*Dd**2*Pk2*f**3*s**2 - 58416*C*Dd**2*Pk2*f**3*s + 21008*C*Dd**2*Pk2*f**3 + 1200*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 600*C*Dd**2*Pkdd2*f**3*k1**2*s + 1188*D1**2*K*Pk2*bdd1*f**2*r**2 + 3168*D1**2*K*Pk2*bdd1*f**2*r*s - 2376*D1**2*K*Pk2*bdd1*f**2*r + 1188*D1**2*K*Pk2*bdd1*f**2*s**2 - 3168*D1**2*K*Pk2*bdd1*f**2*s + 1188*D1**2*K*Pk2*bdd1*f**2 + 66*D1**2*K*Pkdd2*bdd1*f**2*k1**2*s**2 - 792*D1**2*Pk2*b2*f*fd*r**2 - 3696*D1**2*Pk2*b2*f*fd*r*s + 1848*D1**2*Pk2*b2*f*fd*r - 2904*D1**2*Pk2*b2*f*fd*s**2 + 2904*D1**2*Pk2*b2*f*fd*s - 1452*D1**2*Pk2*b2*f*fd + 1320*D1**2*Pk2*b2*f*fdd*r**2 + 3696*D1**2*Pk2*b2*f*fdd*r*s - 1848*D1**2*Pk2*b2*f*fdd*r + 2376*D1**2*Pk2*b2*f*fdd*s**2 - 2376*D1**2*Pk2*b2*f*fdd*s + 1188*D1**2*Pk2*b2*f*fdd + 1320*D1**2*Pk2*b2*fd**2*r**2 + 3696*D1**2*Pk2*b2*fd**2*r*s - 1848*D1**2*Pk2*b2*fd**2*r + 2376*D1**2*Pk2*b2*fd**2*s**2 - 2376*D1**2*Pk2*b2*fd**2*s - 264*D1**2*Pk2*bdd1*f**3*r**2 - 660*D1**2*Pk2*bdd1*f**3*r*s + 792*D1**2*Pk2*bdd1*f**3*r + 660*D1**2*Pk2*bdd1*f**3*s - 396*D1**2*Pk2*bdd1*f**3 + 352*D1**2*Pk2*bdd1*f**2*r**2 - 132*D1**2*Pk2*bdd1*f**2*r*s + 792*D1**2*Pk2*bdd1*f**2*r + 660*D1**2*Pk2*bdd1*f**2*s - 264*D1**2*Pk2*bdd1*f**2 + 792*D1**2*Pk2*bdd1*f*g2*r**2 + 1056*D1**2*Pk2*bdd1*f*g2*r*s + 660*D1**2*Pk2*bdd2*f**2*r**2 + 1848*D1**2*Pk2*bdd2*f**2*r*s - 1320*D1**2*Pk2*bdd2*f**2*r + 1188*D1**2*Pk2*bdd2*f**2*s**2 - 1848*D1**2*Pk2*bdd2*f**2*s + 660*D1**2*Pk2*bdd2*f**2 + 2700*D1**2*Pk2*f**2*fd*r**2 + 12564*D1**2*Pk2*f**2*fd*r*s - 5988*D1**2*Pk2*f**2*fd*r + 4356*D1**2*Pk2*f**2*fd*s**2 - 7092*D1**2*Pk2*f**2*fd*s + 2352*D1**2*Pk2*f**2*fd - 5508*D1**2*Pk2*f**2*fdd*r**2 - 13212*D1**2*Pk2*f**2*fdd*r*s + 8076*D1**2*Pk2*f**2*fdd*r - 3564*D1**2*Pk2*f**2*fdd*s**2 + 6780*D1**2*Pk2*f**2*fdd*s - 3024*D1**2*Pk2*f**2*fdd + 1584*D1**2*Pk2*f**2*gd2*r**2 + 6336*D1**2*Pk2*f**2*gd2*r*s - 3168*D1**2*Pk2*f**2*gd2*r + 2904*D1**2*Pk2*f**2*gd2*s**2 - 6336*D1**2*Pk2*f**2*gd2*s + 1584*D1**2*Pk2*f**2*gd2 - 2376*D1**2*Pk2*f**2*gdd2*r**2 - 6336*D1**2*Pk2*f**2*gdd2*r*s + 4752*D1**2*Pk2*f**2*gdd2*r - 2376*D1**2*Pk2*f**2*gdd2*s**2 + 6336*D1**2*Pk2*f**2*gdd2*s - 2376*D1**2*Pk2*f**2*gdd2 - 11016*D1**2*Pk2*f*fd**2*r**2 - 26424*D1**2*Pk2*f*fd**2*r*s + 16152*D1**2*Pk2*f*fd**2*r - 7128*D1**2*Pk2*f*fd**2*s**2 + 13560*D1**2*Pk2*f*fd**2*s - 4404*D1**2*Pk2*f*fd**2 + 3168*D1**2*Pk2*f*fd*g2*r**2 + 12672*D1**2*Pk2*f*fd*g2*r*s - 6336*D1**2*Pk2*f*fd*g2*r + 5808*D1**2*Pk2*f*fd*g2*s**2 - 5808*D1**2*Pk2*f*fd*g2*s + 2904*D1**2*Pk2*f*fd*g2 - 9504*D1**2*Pk2*f*fd*gd2*r**2 - 25344*D1**2*Pk2*f*fd*gd2*r*s + 15840*D1**2*Pk2*f*fd*gd2*r - 9504*D1**2*Pk2*f*fd*gd2*s**2 + 17424*D1**2*Pk2*f*fd*gd2*s - 6336*D1**2*Pk2*f*fd*gd2 - 4752*D1**2*Pk2*f*fdd*g2*r**2 - 12672*D1**2*Pk2*f*fdd*g2*r*s + 6336*D1**2*Pk2*f*fdd*g2*r - 4752*D1**2*Pk2*f*fdd*g2*s**2 + 4752*D1**2*Pk2*f*fdd*g2*s - 2376*D1**2*Pk2*f*fdd*g2 - 4752*D1**2*Pk2*fd**2*g2*r**2 - 12672*D1**2*Pk2*fd**2*g2*r*s + 6336*D1**2*Pk2*fd**2*g2*r - 4752*D1**2*Pk2*fd**2*g2*s**2 + 4752*D1**2*Pk2*fd**2*g2*s - 198*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 396*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 198*D1**2*Pkdd2*bdd1*f**2*k1**2 - 264*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 + 528*D1**2*Pkdd2*bdd1*f*g2*k1**2*s - 264*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 294*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 196*D1**2*Pkdd2*f**2*fd*k1**2*s - 98*D1**2*Pkdd2*f**2*fd*k1**2 - 150*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 100*D1**2*Pkdd2*f**2*fdd*k1**2*s - 50*D1**2*Pkdd2*f**2*fdd*k1**2 - 132*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 - 300*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 200*D1**2*Pkdd2*f*fd**2*k1**2*s - 528*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 + 264*D1**2*Pkdd2*f*fd*gd2*k1**2*s - 264*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 + 264*D1**2*Pkdd2*f*fdd*g2*k1**2*s - 132*D1**2*Pkdd2*f*fdd*g2*k1**2 - 264*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 + 264*D1**2*Pkdd2*fd**2*g2*k1**2*s + 132*D1**2*bd1**2*f*(2*Pk2*(2*K*s + f*(r - 1) - r**2*(3*K + 1) + r*(-4*K*s + 3*K + 2) - 1) - Pkdd2*k1**2*s*(s - 1)*(-2*K + 3*f + 1)) - 1584*D1*Dd*Pk2*b2*f**2*r**2 - 7392*D1*Dd*Pk2*b2*f**2*r*s + 3432*D1*Dd*Pk2*b2*f**2*r - 5808*D1*Dd*Pk2*b2*f**2*s**2 + 6600*D1*Dd*Pk2*b2*f**2*s - 2244*D1*Dd*Pk2*b2*f**2 + 10560*D1*Dd*Pk2*b2*f*fd*r**2 + 29568*D1*Dd*Pk2*b2*f*fd*r*s - 16368*D1*Dd*Pk2*b2*f*fd*r + 19008*D1*Dd*Pk2*b2*f*fd*s**2 - 21648*D1*Dd*Pk2*b2*f*fd*s + 6072*D1*Dd*Pk2*b2*f*fd + 3600*D1*Dd*Pk2*f**3*r**2 + 16752*D1*Dd*Pk2*f**3*r*s - 7788*D1*Dd*Pk2*f**3*r + 5808*D1*Dd*Pk2*f**3*s**2 - 11280*D1*Dd*Pk2*f**3*s + 3252*D1*Dd*Pk2*f**3 - 44064*D1*Dd*Pk2*f**2*fd*r**2 - 105696*D1*Dd*Pk2*f**2*fd*r*s + 67548*D1*Dd*Pk2*f**2*fd*r - 28512*D1*Dd*Pk2*f**2*fd*s**2 + 60672*D1*Dd*Pk2*f**2*fd*s - 22932*D1*Dd*Pk2*f**2*fd + 6336*D1*Dd*Pk2*f**2*g2*r**2 + 25344*D1*Dd*Pk2*f**2*g2*r*s - 12672*D1*Dd*Pk2*f**2*g2*r + 11616*D1*Dd*Pk2*f**2*g2*s**2 - 18480*D1*Dd*Pk2*f**2*g2*s + 6072*D1*Dd*Pk2*f**2*g2 - 19008*D1*Dd*Pk2*f**2*gd2*r**2 - 50688*D1*Dd*Pk2*f**2*gd2*r*s + 34848*D1*Dd*Pk2*f**2*gd2*r - 19008*D1*Dd*Pk2*f**2*gd2*s**2 + 42768*D1*Dd*Pk2*f**2*gd2*s - 15840*D1*Dd*Pk2*f**2*gd2 - 38016*D1*Dd*Pk2*f*fd*g2*r**2 - 101376*D1*Dd*Pk2*f*fd*g2*r*s + 57024*D1*Dd*Pk2*f*fd*g2*r - 38016*D1*Dd*Pk2*f*fd*g2*s**2 + 53856*D1*Dd*Pk2*f*fd*g2*s - 17424*D1*Dd*Pk2*f*fd*g2 - 392*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 196*D1*Dd*Pkdd2*f**3*k1**2*s - 98*D1*Dd*Pkdd2*f**3*k1**2 - 1200*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 700*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 100*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1056*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 + 264*D1*Dd*Pkdd2*f**2*gd2*k1**2*s - 2112*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 + 1584*D1*Dd*Pkdd2*f*fd*g2*k1**2*s - 264*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 2640*D1*Ddd*Pk2*b2*f**2*r**2 + 7392*D1*Ddd*Pk2*b2*f**2*r*s - 4488*D1*Ddd*Pk2*b2*f**2*r + 4752*D1*Ddd*Pk2*b2*f**2*s**2 - 6072*D1*Ddd*Pk2*b2*f**2*s + 2508*D1*Ddd*Pk2*b2*f**2 - 7344*D1*Ddd*Pk2*f**3*r**2 - 17616*D1*Ddd*Pk2*f**3*r*s + 11748*D1*Ddd*Pk2*f**3*r - 4752*D1*Ddd*Pk2*f**3*s**2 + 11184*D1*Ddd*Pk2*f**3*s - 4860*D1*Ddd*Pk2*f**3 - 9504*D1*Ddd*Pk2*f**2*g2*r**2 - 25344*D1*Ddd*Pk2*f**2*g2*r*s + 15840*D1*Ddd*Pk2*f**2*g2*r - 9504*D1*Ddd*Pk2*f**2*g2*s**2 + 17424*D1*Ddd*Pk2*f**2*g2*s - 7128*D1*Ddd*Pk2*f**2*g2 - 200*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 100*D1*Ddd*Pkdd2*f**3*k1**2*s - 50*D1*Ddd*Pkdd2*f**3*k1**2 - 528*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 + 264*D1*Ddd*Pkdd2*f**2*g2*k1**2*s - 132*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 132*D1*Pk2*bd2*f*(D1*(f*(3*r**2 + 14*r*s - 6*r + 11*s**2 - 14*s + 3) - 2*fd*(10*r**2 + 28*r*s - 17*r + 18*s**2 - 23*s + 7)) - 2*Dd*f*(20*r**2 + r*(56*s - 37) + 36*s**2 - 51*s + 17)) + 22*D1*bd1*(D1*(3*f**3*(2*Pk2*(2*r**2 + r*(5*s - 6) - 5*s + 3) + Pkdd2*k1**2*(-2*s**2 - 2*s + 1)) - f**2*(2*Pk2*(-34*C*r**2 - 32*C*r*s + 3*K*(6*r**2 + 24*r*s - 12*r + 11*s**2 - 24*s + 6) + fd*(36*r**2 + 15*r*(6*s - 5) - 60*s + 33) + 21*r**2 + 7*r*s + 2*r + 9*s + 3) + Pkdd2*k1**2*(23*C*(s - 1)**2 - 14*s**2 + 34*s - 17)) + f*(-24*Pk2*g2*r*(3*r + 4*s) + 24*Pk2*gd2*(3*r**2 + r*(4*s - 3) - 2*s) + 31*Pkdd2*g2*k1**2*(s - 1)**2 - 24*Pkdd2*gd2*k1**2*s*(s - 1) + 2*fd*(Pk2*(24*C*s + 18*K*(6*r**2 + 2*r*(8*s - 5) + 6*s**2 - 11*s + 4) + r**2*(32 - 104*C) + r*(-96*C*s + 76*C - 12*s + 5) + 18*s - 21) + 3*Pkdd2*k1**2*s*(8*C*(s - 1) + K*(2*s - 1) - 6*s + 6))) + 24*fd*g2*(Pk2*r*(3*r + 4*s - 2) - Pkdd2*k1**2*s*(s - 1))) + 2*Dd*f*(-3*Pk2*f**2*(16*r**2 + r*(40*s - 37) - 30*s + 17) + f*(Pk2*(48*C*s + 18*K*(12*r**2 + r*(32*s - 22) + 12*s**2 - 27*s + 10) + r**2*(64 - 208*C) + r*(-64*C*(3*s - 2) - 24*s + 43) + 66*s - 51) + 3*Pkdd2*k1**2*(4*s - 1)*(4*C*(s - 1) + s*(K - 3) + 3)) - 12*g2*(4*Pk2*(-3*r**2 + r*(2 - 4*s) + s) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 7920*Dd**2*Pk2*b2*f**2*r**2 + 22176*Dd**2*Pk2*b2*f**2*r*s - 13464*Dd**2*Pk2*b2*f**2*r + 14256*Dd**2*Pk2*b2*f**2*s**2 - 18216*Dd**2*Pk2*b2*f**2*s + 5016*Dd**2*Pk2*b2*f**2 - 22032*Dd**2*Pk2*f**3*r**2 - 52848*Dd**2*Pk2*f**3*r*s + 35244*Dd**2*Pk2*f**3*r - 14256*Dd**2*Pk2*f**3*s**2 + 33552*Dd**2*Pk2*f**3*s - 12480*Dd**2*Pk2*f**3 - 28512*Dd**2*Pk2*f**2*g2*r**2 - 76032*Dd**2*Pk2*f**2*g2*r*s + 47520*Dd**2*Pk2*f**2*g2*r - 28512*Dd**2*Pk2*f**2*g2*s**2 + 52272*Dd**2*Pk2*f**2*g2*s - 17424*Dd**2*Pk2*f**2*g2 - 600*Dd**2*Pkdd2*f**3*k1**2*s**2 + 300*Dd**2*Pkdd2*f**3*k1**2*s - 1584*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 + 792*Dd**2*Pkdd2*f**2*g2*k1**2*s + 11*b1**2*(D1**2*(-12*fd**2*(2*Pk2*(r - 1) + 3*Pkdd2*k1**2*s**2) + fd*(24*Pk2*r*(K*(3*r + 4*s - 4) + f + r + 2) + Pkdd2*k1**2*s**2*(-31*K + 72*f + 19)) - 6*fdd*(2*Pk2*r*(K*(3*r + 4*s - 4) + 2*f + r + 2) + Pkdd2*k1**2*s**2*(-2*K + 6*f + 1))) + D1*(Dd*(36*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + f*(48*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) - 2*fd*r + fd + 2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-31*K*(4*s**2 - 2*s + 1) + s**2*(76 - 288*fd) + s*(72*fd - 38) + 19)) - 12*fd*(4*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) + 2*r**2 + r - 1) + Pkdd2*k1**2*s*(K*(2 - 8*s) + 4*s - 1))) - 6*Ddd*f*(4*Pk2*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + 2*r**2 - 2*r + 1) + Pkdd2*k1**2*(-2*K + 3*f + 1)*(4*s**2 - 2*s + 1))) - 12*Dd**2*f*(2*Pk2*(K*(18*r**2 + 24*r*(s - 1) - 12*s + 7) + 6*r**2 - 6*r + 1) + Pkdd2*k1**2*s*(2*s - 1)*(-6*K + 9*f + 3))) - 11*b1*(-6*D1**2*bdd1*f*(-2*Pk2*(K*(6*r**2 + r*(8*s - 6) - 4*s + 3) + 2*r**2 - r*(2*f + 4) + 1) - Pkdd2*k1**2*(-2*K + 3*f + 1)*(2*s**2 - 2*s + 1)) + 2*D1**2*(f**2*(-6*Pk2*fd*(6*r**2 + r*(15*s - 7) - 5*s + 1) + 6*Pk2*fdd*(6*r**2 + r*(15*s - 7) - 5*s + 1) + 9*Pkdd2*fd*k1**2*(2*s**2 - 2*s + 1)) + f*(6*Pk2*fd**2*(12*r**2 + 2*r*(15*s - 7) - 10*s + 3) + 2*Pk2*fdd*(C*(52*r**2 + r*(48*s - 76) - 24*s + 26) - 9*K*(6*r**2 + 16*r*s - 8*r + 6*s**2 - 6*s + 3) - 16*r**2 + 6*r*s + 31*r + 12*s - 14) + 72*Pk2*gd2*r**2 + 96*Pk2*gd2*r*s - 144*Pk2*gd2*r - 96*Pk2*gd2*s + 72*Pk2*gd2 - 36*Pk2*gdd2*r**2 - 48*Pk2*gdd2*r*s + 72*Pk2*gdd2*r + 48*Pk2*gdd2*s - 36*Pk2*gdd2 - 3*Pkdd2*fdd*k1**2*(K*(2*s**2 - 2*s + 1) + s**2*(8*C - 6)) - 31*Pkdd2*gd2*k1**2*s**2 + 12*Pkdd2*gdd2*k1**2*s**2 + fd*(2*Pk2*(-2*C*(34*r**2 + r*(32*s - 50) - 16*s + 17) + 3*K*(12*r**2 + 48*r*s - 24*r + 22*s**2 - 22*s + 11) + 42*r**2 + 14*r*s - 51*r - 16*s + 18) + Pkdd2*k1**2*(s**2*(46*C - 28) - 6*s + 3))) + 2*fd**2*(Pk2*(4*C*(13*r**2 + r*(12*s - 19) - 6*s + 6) - 54*K*s**2 + 54*K*s + r**2*(-54*K - 16) + r*(-144*K*s + 72*K + 6*s + 31) + 12*s - 18) + 3*Pkdd2*k1**2*s*(-K*s + K + s*(3 - 4*C))) + fd*(24*Pk2*g2*r*(3*r + 4*s - 4) - 24*Pk2*gd2*(3*r**2 + r*(4*s - 5) - 2*s + 2) - 31*Pkdd2*g2*k1**2*s**2 + 24*Pkdd2*gd2*k1**2*s**2) + 12*fdd*g2*(Pk2*r*(-3*r - 4*s + 4) + Pkdd2*k1**2*s**2)) + D1*bd1*(D1*(-12*f**2*(-2*Pk2*r + 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - f*(24*Pk2*(K*(6*r**2 + r*(8*s - 6) - 4*s + 3) + 2*r**2 - 4*r + 1) + Pkdd2*k1**2*(-31*K*(2*s**2 - 2*s + 1) + s**2*(38 - 144*fd) + s*(72*fd - 38) + 19)) + 12*fd*(2*Pk2*(K*(6*r**2 + 8*r*s - 7*r - 2*s + 2) + 2*r**2 - 1) + Pkdd2*k1**2*s*(K*(2 - 4*s) + 2*s - 1))) + 12*Dd*f*(-4*Pk2*(2*r - 1)*(-2*K*(3*r + 4*s - 2) + f - 2*r + 2) + Pkdd2*k1**2*(-2*K + 3*f + 1)*(8*s**2 - 6*s + 1))) - 2*D1*(Dd*(6*f**3*(Pk2*(8*r**2 + r*(20*s - 13) - 10*s + 4) + Pkdd2*k1**2*(-4*s**2 + 2*s - 1)) + f**2*(2*Pk2*(4*C*(34*r**2 + r*(32*s - 42) - 16*s + 17) - 72*K*r**2 - 288*K*r*s + 144*K*r - 132*K*s**2 + 210*K*s - 69*K - 3*fd*(48*r**2 + 120*r*s - 67*r - 50*s + 19) - 84*r**2 - 28*r*s + 91*r + 14*s - 42) - Pkdd2*k1**2*(23*C - 14)*(4*s**2 - 2*s + 1)) + f*(-4*Pk2*fd*(8*C*(2*r - 1)*(13*r + 12*s - 11) - 9*K*(24*r**2 + 64*r*s - 36*r + 24*s**2 - 34*s + 11) - 64*r**2 + 24*r*s + 91*r + 18*s - 37) - 48*Pk2*g2*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + 96*Pk2*gd2*(3*r**2 + r*(4*s - 5) - 3*s + 2) + 6*Pkdd2*fd*k1**2*(4*s - 1)*(8*C*s + 2*K*s - K - 6*s) + 31*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 24*Pkdd2*gd2*k1**2*s*(1 - 4*s)) + 24*fd*g2*(4*Pk2*(3*r**2 + 4*r*(s - 1) - s + 1) + Pkdd2*k1**2*s*(1 - 4*s))) + Ddd*f*(-6*Pk2*f**2*(8*r**2 + r*(20*s - 13) - 10*s + 4) + f*(-2*Pk2*(4*C*(26*r**2 + 8*r*(3*s - 4) - 12*s + 13) - 9*K*(12*r**2 + 4*r*(8*s - 5) + 12*s**2 - 22*s + 9) - 32*r**2 + 12*r*s + 29*r - 6*s - 16) + Pkdd2*k1**2*(12*C + 3*K - 9)*(4*s**2 - 2*s + 1)) + 12*g2*(2*Pk2*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + Pkdd2*k1**2*(-4*s**2 + 2*s - 1)))) - 4*Dd**2*f*(-3*Pk2*f**2*(24*r**2 + r*(60*s - 39) - 30*s + 14) + f*(Pk2*(-4*C*(78*r**2 + 24*r*(3*s - 4) - 36*s + 25) + 18*K*(18*r**2 + 6*r*(8*s - 5) + 18*s**2 - 33*s + 11) + 96*r**2 - 36*r*s - 87*r + 18*s + 10) + Pkdd2*k1**2*s*(2*s - 1)*(36*C + 9*K - 27)) + 12*g2*(Pk2*(18*r**2 + 24*r*(s - 1) - 12*s + 7) + 3*Pkdd2*k1**2*s*(1 - 2*s)))))/(462*d**2*k3**4) - D1**2*Pk3*ct**2*k2**2*(8448*C*D1**2*Pk2*bd1**2*f*r**2 + 14784*C*D1**2*Pk2*bd1**2*f*r*s - 7392*C*D1**2*Pk2*bd1**2*f*r + 6336*C*D1**2*Pk2*bd1**2*f*s**2 - 6336*C*D1**2*Pk2*bd1**2*f*s + 16632*C*D1**2*Pk2*bd1*f**2*r**2 + 17424*C*D1**2*Pk2*bd1*f**2*r*s - 16896*C*D1**2*Pk2*bd1*f**2*r + 2376*C*D1**2*Pk2*bd1*f**2*s**2 - 9504*C*D1**2*Pk2*bd1*f**2*s + 4752*C*D1**2*Pk2*bd1*f**2 - 31680*C*D1**2*Pk2*bd1*f*fd*r**2 - 59136*C*D1**2*Pk2*bd1*f*fd*r*s + 50688*C*D1**2*Pk2*bd1*f*fd*r - 15840*C*D1**2*Pk2*bd1*f*fd*s**2 + 38544*C*D1**2*Pk2*bd1*f*fd*s - 20064*C*D1**2*Pk2*bd1*f*fd - 7920*C*D1**2*Pk2*bdd1*f**2*r**2 - 14784*C*D1**2*Pk2*bdd1*f**2*r*s + 20064*C*D1**2*Pk2*bdd1*f**2*r - 3960*C*D1**2*Pk2*bdd1*f**2*s**2 + 15840*C*D1**2*Pk2*bdd1*f**2*s - 7920*C*D1**2*Pk2*bdd1*f**2 + 5916*C*D1**2*Pk2*f**2*fd*r**2 + 19008*C*D1**2*Pk2*f**2*fd*r*s - 10280*C*D1**2*Pk2*f**2*fd*r + 14256*C*D1**2*Pk2*f**2*fd*s**2 - 15840*C*D1**2*Pk2*f**2*fd*s + 6724*C*D1**2*Pk2*f**2*fd - 3156*C*D1**2*Pk2*f**2*fdd*r**2 - 19008*C*D1**2*Pk2*f**2*fdd*r*s + 8440*C*D1**2*Pk2*f**2*fdd*r - 14256*C*D1**2*Pk2*f**2*fdd*s**2 + 15840*C*D1**2*Pk2*f**2*fdd*s - 5804*C*D1**2*Pk2*f**2*fdd - 6312*C*D1**2*Pk2*f*fd**2*r**2 - 38016*C*D1**2*Pk2*f*fd**2*r*s + 16880*C*D1**2*Pk2*f*fd**2*r - 28512*C*D1**2*Pk2*f*fd**2*s**2 + 31680*C*D1**2*Pk2*f*fd**2*s - 6336*C*D1**2*Pk2*f*fd**2 - 924*C*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 + 1848*C*D1**2*Pkdd2*bd1*f**2*k1**2*s - 924*C*D1**2*Pkdd2*bd1*f**2*k1**2 - 1320*C*D1**2*Pkdd2*bd1*f*fd*k1**2*s**2 + 1320*C*D1**2*Pkdd2*bd1*f*fd*k1**2*s - 330*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 660*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 330*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 990*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 660*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 330*C*D1**2*Pkdd2*f**2*fd*k1**2 - 63360*C*D1*Dd*Pk2*bd1*f**2*r**2 - 118272*C*D1*Dd*Pk2*bd1*f**2*r*s + 126720*C*D1*Dd*Pk2*bd1*f**2*r - 31680*C*D1*Dd*Pk2*bd1*f**2*s**2 + 100848*C*D1*Dd*Pk2*bd1*f**2*s - 55968*C*D1*Dd*Pk2*bd1*f**2 + 7888*C*D1*Dd*Pk2*f**3*r**2 + 25344*C*D1*Dd*Pk2*f**3*r*s - 14224*C*D1*Dd*Pk2*f**3*r + 19008*C*D1*Dd*Pk2*f**3*s**2 - 22176*C*D1*Dd*Pk2*f**3*s + 8696*C*D1*Dd*Pk2*f**3 - 25248*C*D1*Dd*Pk2*f**2*fd*r**2 - 152064*C*D1*Dd*Pk2*f**2*fd*r*s + 65392*C*D1*Dd*Pk2*f**2*fd*r - 114048*C*D1*Dd*Pk2*f**2*fd*s**2 + 129888*C*D1*Dd*Pk2*f**2*fd*s - 32720*C*D1*Dd*Pk2*f**2*fd - 2640*C*D1*Dd*Pkdd2*bd1*f**2*k1**2*s**2 + 3300*C*D1*Dd*Pkdd2*bd1*f**2*k1**2*s - 660*C*D1*Dd*Pkdd2*bd1*f**2*k1**2 - 1320*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 660*C*D1*Dd*Pkdd2*f**3*k1**2*s - 330*C*D1*Dd*Pkdd2*f**3*k1**2 - 4208*C*D1*Ddd*Pk2*f**3*r**2 - 25344*C*D1*Ddd*Pk2*f**3*r*s + 10544*C*D1*Ddd*Pk2*f**3*r - 19008*C*D1*Ddd*Pk2*f**3*s**2 + 22176*C*D1*Ddd*Pk2*f**3*s - 6856*C*D1*Ddd*Pk2*f**3 - 12624*C*Dd**2*Pk2*f**3*r**2 - 76032*C*Dd**2*Pk2*f**3*r*s + 31632*C*Dd**2*Pk2*f**3*r - 57024*C*Dd**2*Pk2*f**3*s**2 + 66528*C*Dd**2*Pk2*f**3*s - 14776*C*Dd**2*Pk2*f**3 - 7392*D1**2*K*Pk2*bd1**2*f*r**2 - 12936*D1**2*K*Pk2*bd1**2*f*r*s + 16632*D1**2*K*Pk2*bd1**2*f*r - 4620*D1**2*K*Pk2*bd1**2*f*s**2 + 15708*D1**2*K*Pk2*bd1**2*f*s - 9240*D1**2*K*Pk2*bd1**2*f + 462*D1**2*K*Pk2*bd1*f**2*r**2 + 2772*D1**2*K*Pk2*bd1*f**2*r*s - 924*D1**2*K*Pk2*bd1*f**2*r + 2772*D1**2*K*Pk2*bd1*f**2*s**2 - 2772*D1**2*K*Pk2*bd1*f**2*s + 462*D1**2*K*Pk2*bd1*f**2 - 1848*D1**2*K*Pk2*bd1*f*fd*r**2 - 11088*D1**2*K*Pk2*bd1*f*fd*r*s + 4620*D1**2*K*Pk2*bd1*f*fd*r - 11088*D1**2*K*Pk2*bd1*f*fd*s**2 + 11088*D1**2*K*Pk2*bd1*f*fd*s - 2772*D1**2*K*Pk2*bd1*f*fd - 462*D1**2*K*Pk2*bdd1*f**2*r**2 - 2772*D1**2*K*Pk2*bdd1*f**2*r*s + 924*D1**2*K*Pk2*bdd1*f**2*r - 2772*D1**2*K*Pk2*bdd1*f**2*s**2 + 2772*D1**2*K*Pk2*bdd1*f**2*s - 462*D1**2*K*Pk2*bdd1*f**2 - 396*D1**2*K*Pkdd2*bd1**2*f*k1**2*s**2 + 396*D1**2*K*Pkdd2*bd1**2*f*k1**2*s - 198*D1**2*K*Pkdd2*bd1*f**2*k1**2*s**2 + 2772*D1**2*Pk2*bd1**2*f**2*r**2 + 2772*D1**2*Pk2*bd1**2*f**2*r*s - 4158*D1**2*Pk2*bd1**2*f**2*r - 1386*D1**2*Pk2*bd1**2*f**2*s + 1386*D1**2*Pk2*bd1**2*f**2 - 4488*D1**2*Pk2*bd1**2*f*r**2 - 6732*D1**2*Pk2*bd1**2*f*r*s + 1518*D1**2*Pk2*bd1**2*f*r - 3168*D1**2*Pk2*bd1**2*f*s**2 + 1782*D1**2*Pk2*bd1**2*f*s + 1386*D1**2*Pk2*bd1**2*f - 7392*D1**2*Pk2*bd1**2*g2*r**2 - 14784*D1**2*Pk2*bd1**2*g2*r*s + 7392*D1**2*Pk2*bd1**2*g2*r - 7392*D1**2*Pk2*bd1**2*g2*s**2 + 7392*D1**2*Pk2*bd1**2*g2*s - 4620*D1**2*Pk2*bd1*bd2*f*r**2 - 9240*D1**2*Pk2*bd1*bd2*f*r*s + 9240*D1**2*Pk2*bd1*bd2*f*r - 4620*D1**2*Pk2*bd1*bd2*f*s**2 + 9240*D1**2*Pk2*bd1*bd2*f*s - 4620*D1**2*Pk2*bd1*bd2*f - 10164*D1**2*Pk2*bd1*f**2*r**2 - 9636*D1**2*Pk2*bd1*f**2*r*s + 8580*D1**2*Pk2*bd1*f**2*r - 1188*D1**2*Pk2*bd1*f**2*s**2 + 4752*D1**2*Pk2*bd1*f**2*s - 2376*D1**2*Pk2*bd1*f**2 + 19536*D1**2*Pk2*bd1*f*fd*r**2 + 35904*D1**2*Pk2*bd1*f*fd*r*s - 30360*D1**2*Pk2*bd1*f*fd*r + 7920*D1**2*Pk2*bd1*f*fd*s**2 - 20856*D1**2*Pk2*bd1*f*fd*s + 11616*D1**2*Pk2*bd1*f*fd - 10164*D1**2*Pk2*bd1*f*g2*r**2 - 12936*D1**2*Pk2*bd1*f*g2*r*s + 11088*D1**2*Pk2*bd1*f*g2*r - 2772*D1**2*Pk2*bd1*f*g2*s**2 + 11088*D1**2*Pk2*bd1*f*g2*s - 5544*D1**2*Pk2*bd1*f*g2 + 14784*D1**2*Pk2*bd1*f*gd2*r**2 + 25872*D1**2*Pk2*bd1*f*gd2*r*s - 33264*D1**2*Pk2*bd1*f*gd2*r + 9240*D1**2*Pk2*bd1*f*gd2*s**2 - 31416*D1**2*Pk2*bd1*f*gd2*s + 18480*D1**2*Pk2*bd1*f*gd2 + 14784*D1**2*Pk2*bd1*fd*g2*r**2 + 25872*D1**2*Pk2*bd1*fd*g2*r*s - 12936*D1**2*Pk2*bd1*fd*g2*r + 9240*D1**2*Pk2*bd1*fd*g2*s**2 - 9240*D1**2*Pk2*bd1*fd*g2*s + 4884*D1**2*Pk2*bdd1*f**2*r**2 + 8976*D1**2*Pk2*bdd1*f**2*r*s - 11616*D1**2*Pk2*bdd1*f**2*r + 1980*D1**2*Pk2*bdd1*f**2*s**2 - 7920*D1**2*Pk2*bdd1*f**2*s + 3960*D1**2*Pk2*bdd1*f**2 + 7392*D1**2*Pk2*bdd1*f*g2*r**2 + 12936*D1**2*Pk2*bdd1*f*g2*r*s - 18480*D1**2*Pk2*bdd1*f*g2*r + 4620*D1**2*Pk2*bdd1*f*g2*s**2 - 18480*D1**2*Pk2*bdd1*f*g2*s + 9240*D1**2*Pk2*bdd1*f*g2 - 2958*D1**2*Pk2*f**2*fd*r**2 - 9504*D1**2*Pk2*f**2*fd*r*s + 5140*D1**2*Pk2*f**2*fd*r - 7128*D1**2*Pk2*f**2*fd*s**2 + 7920*D1**2*Pk2*f**2*fd*s - 3362*D1**2*Pk2*f**2*fd + 1578*D1**2*Pk2*f**2*fdd*r**2 + 9504*D1**2*Pk2*f**2*fdd*r*s - 4220*D1**2*Pk2*f**2*fdd*r + 7128*D1**2*Pk2*f**2*fdd*s**2 - 7920*D1**2*Pk2*f**2*fdd*s + 2902*D1**2*Pk2*f**2*fdd - 924*D1**2*Pk2*f**2*gd2*r**2 - 5544*D1**2*Pk2*f**2*gd2*r*s + 1848*D1**2*Pk2*f**2*gd2*r - 5544*D1**2*Pk2*f**2*gd2*s**2 + 5544*D1**2*Pk2*f**2*gd2*s - 924*D1**2*Pk2*f**2*gd2 + 924*D1**2*Pk2*f**2*gdd2*r**2 + 5544*D1**2*Pk2*f**2*gdd2*r*s - 1848*D1**2*Pk2*f**2*gdd2*r + 5544*D1**2*Pk2*f**2*gdd2*s**2 - 5544*D1**2*Pk2*f**2*gdd2*s + 924*D1**2*Pk2*f**2*gdd2 + 3156*D1**2*Pk2*f*fd**2*r**2 + 19008*D1**2*Pk2*f*fd**2*r*s - 8440*D1**2*Pk2*f*fd**2*r + 14256*D1**2*Pk2*f*fd**2*s**2 - 15840*D1**2*Pk2*f*fd**2*s + 3168*D1**2*Pk2*f*fd**2 - 1848*D1**2*Pk2*f*fd*g2*r**2 - 11088*D1**2*Pk2*f*fd*g2*r*s + 5544*D1**2*Pk2*f*fd*g2*r - 11088*D1**2*Pk2*f*fd*g2*s**2 + 11088*D1**2*Pk2*f*fd*g2*s - 5544*D1**2*Pk2*f*fd*g2 + 3696*D1**2*Pk2*f*fd*gd2*r**2 + 22176*D1**2*Pk2*f*fd*gd2*r*s - 9240*D1**2*Pk2*f*fd*gd2*r + 22176*D1**2*Pk2*f*fd*gd2*s**2 - 22176*D1**2*Pk2*f*fd*gd2*s + 5544*D1**2*Pk2*f*fd*gd2 + 1848*D1**2*Pk2*f*fdd*g2*r**2 + 11088*D1**2*Pk2*f*fdd*g2*r*s - 5544*D1**2*Pk2*f*fdd*g2*r + 11088*D1**2*Pk2*f*fdd*g2*s**2 - 11088*D1**2*Pk2*f*fdd*g2*s + 5544*D1**2*Pk2*f*fdd*g2 + 1848*D1**2*Pk2*fd**2*g2*r**2 + 11088*D1**2*Pk2*fd**2*g2*r*s - 5544*D1**2*Pk2*fd**2*g2*r + 11088*D1**2*Pk2*fd**2*g2*s**2 - 11088*D1**2*Pk2*fd**2*g2*s + 858*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 - 1716*D1**2*Pkdd2*bd1*f**2*k1**2*s + 858*D1**2*Pkdd2*bd1*f**2*k1**2 + 660*D1**2*Pkdd2*bd1*f*fd*k1**2*s**2 - 660*D1**2*Pkdd2*bd1*f*fd*k1**2*s + 1056*D1**2*Pkdd2*bd1*f*g2*k1**2*s**2 - 2112*D1**2*Pkdd2*bd1*f*g2*k1**2*s + 1056*D1**2*Pkdd2*bd1*f*g2*k1**2 + 792*D1**2*Pkdd2*bd1*f*gd2*k1**2*s**2 - 792*D1**2*Pkdd2*bd1*f*gd2*k1**2*s + 792*D1**2*Pkdd2*bd1*fd*g2*k1**2*s**2 - 792*D1**2*Pkdd2*bd1*fd*g2*k1**2*s + 165*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 330*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 165*D1**2*Pkdd2*bdd1*f**2*k1**2 + 396*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 792*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 396*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 495*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 330*D1**2*Pkdd2*f**2*fd*k1**2*s + 165*D1**2*Pkdd2*f**2*fd*k1**2 + 396*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 792*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 792*D1**2*Pkdd2*f*fd*g2*k1**2*s + 396*D1**2*Pkdd2*f*fd*g2*k1**2 - 3696*D1*Dd*K*Pk2*bd1*f**2*r**2 - 22176*D1*Dd*K*Pk2*bd1*f**2*r*s + 8316*D1*Dd*K*Pk2*bd1*f**2*r - 22176*D1*Dd*K*Pk2*bd1*f**2*s**2 + 22176*D1*Dd*K*Pk2*bd1*f**2*s - 4620*D1*Dd*K*Pk2*bd1*f**2 + 39072*D1*Dd*Pk2*bd1*f**2*r**2 + 71808*D1*Dd*Pk2*bd1*f**2*r*s - 74976*D1*Dd*Pk2*bd1*f**2*r + 15840*D1*Dd*Pk2*bd1*f**2*s**2 - 53592*D1*Dd*Pk2*bd1*f**2*s + 31152*D1*Dd*Pk2*bd1*f**2 + 59136*D1*Dd*Pk2*bd1*f*g2*r**2 + 103488*D1*Dd*Pk2*bd1*f*g2*r*s - 116424*D1*Dd*Pk2*bd1*f*g2*r + 36960*D1*Dd*Pk2*bd1*f*g2*s**2 - 109032*D1*Dd*Pk2*bd1*f*g2*s + 55440*D1*Dd*Pk2*bd1*f*g2 - 3944*D1*Dd*Pk2*f**3*r**2 - 12672*D1*Dd*Pk2*f**3*r*s + 7112*D1*Dd*Pk2*f**3*r - 9504*D1*Dd*Pk2*f**3*s**2 + 11088*D1*Dd*Pk2*f**3*s - 4348*D1*Dd*Pk2*f**3 + 12624*D1*Dd*Pk2*f**2*fd*r**2 + 76032*D1*Dd*Pk2*f**2*fd*r*s - 32696*D1*Dd*Pk2*f**2*fd*r + 57024*D1*Dd*Pk2*f**2*fd*s**2 - 64944*D1*Dd*Pk2*f**2*fd*s + 16360*D1*Dd*Pk2*f**2*fd - 3696*D1*Dd*Pk2*f**2*g2*r**2 - 22176*D1*Dd*Pk2*f**2*g2*r*s + 9240*D1*Dd*Pk2*f**2*g2*r - 22176*D1*Dd*Pk2*f**2*g2*s**2 + 22176*D1*Dd*Pk2*f**2*g2*s - 7392*D1*Dd*Pk2*f**2*g2 + 7392*D1*Dd*Pk2*f**2*gd2*r**2 + 44352*D1*Dd*Pk2*f**2*gd2*r*s - 16632*D1*Dd*Pk2*f**2*gd2*r + 44352*D1*Dd*Pk2*f**2*gd2*s**2 - 44352*D1*Dd*Pk2*f**2*gd2*s + 9240*D1*Dd*Pk2*f**2*gd2 + 14784*D1*Dd*Pk2*f*fd*g2*r**2 + 88704*D1*Dd*Pk2*f*fd*g2*r*s - 40656*D1*Dd*Pk2*f*fd*g2*r + 88704*D1*Dd*Pk2*f*fd*g2*s**2 - 88704*D1*Dd*Pk2*f*fd*g2*s + 22176*D1*Dd*Pk2*f*fd*g2 + 1320*D1*Dd*Pkdd2*bd1*f**2*k1**2*s**2 - 1650*D1*Dd*Pkdd2*bd1*f**2*k1**2*s + 330*D1*Dd*Pkdd2*bd1*f**2*k1**2 + 3168*D1*Dd*Pkdd2*bd1*f*g2*k1**2*s**2 - 3960*D1*Dd*Pkdd2*bd1*f*g2*k1**2*s + 792*D1*Dd*Pkdd2*bd1*f*g2*k1**2 + 660*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 330*D1*Dd*Pkdd2*f**3*k1**2*s + 165*D1*Dd*Pkdd2*f**3*k1**2 + 1584*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 792*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 396*D1*Dd*Pkdd2*f**2*g2*k1**2 + 2104*D1*Ddd*Pk2*f**3*r**2 + 12672*D1*Ddd*Pk2*f**3*r*s - 5272*D1*Ddd*Pk2*f**3*r + 9504*D1*Ddd*Pk2*f**3*s**2 - 11088*D1*Ddd*Pk2*f**3*s + 3428*D1*Ddd*Pk2*f**3 + 3696*D1*Ddd*Pk2*f**2*g2*r**2 + 22176*D1*Ddd*Pk2*f**2*g2*r*s - 9240*D1*Ddd*Pk2*f**2*g2*r + 22176*D1*Ddd*Pk2*f**2*g2*s**2 - 22176*D1*Ddd*Pk2*f**2*g2*s + 7392*D1*Ddd*Pk2*f**2*g2 + 462*D1*Pk2*b2*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + 6312*Dd**2*Pk2*f**3*r**2 + 38016*Dd**2*Pk2*f**3*r*s - 15816*Dd**2*Pk2*f**3*r + 28512*Dd**2*Pk2*f**3*s**2 - 33264*Dd**2*Pk2*f**3*s + 7388*Dd**2*Pk2*f**3 + 11088*Dd**2*Pk2*f**2*g2*r**2 + 66528*Dd**2*Pk2*f**2*g2*r*s - 27720*Dd**2*Pk2*f**2*g2*r + 66528*Dd**2*Pk2*f**2*g2*s**2 - 66528*Dd**2*Pk2*f**2*g2*s + 12936*Dd**2*Pk2*f**2*g2 + 924*Pk2*b1**3*(D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(Dd*(-4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) + Ddd*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 66*b1**2*(-128*C*D1**2*Pk2*fd*r**2 - 224*C*D1**2*Pk2*fd*r*s + 256*C*D1**2*Pk2*fd*r - 96*C*D1**2*Pk2*fd*s**2 + 224*C*D1**2*Pk2*fd*s - 128*C*D1**2*Pk2*fd + 64*C*D1**2*Pk2*fdd*r**2 + 112*C*D1**2*Pk2*fdd*r*s - 128*C*D1**2*Pk2*fdd*r + 48*C*D1**2*Pk2*fdd*s**2 - 112*C*D1**2*Pk2*fdd*s + 64*C*D1**2*Pk2*fdd - 512*C*D1*Dd*Pk2*f*r**2 - 896*C*D1*Dd*Pk2*f*r*s + 736*C*D1*Dd*Pk2*f*r - 384*C*D1*Dd*Pk2*f*s**2 + 640*C*D1*Dd*Pk2*f*s - 352*C*D1*Dd*Pk2*f + 512*C*D1*Dd*Pk2*fd*r**2 + 896*C*D1*Dd*Pk2*fd*r*s - 880*C*D1*Dd*Pk2*fd*r + 384*C*D1*Dd*Pk2*fd*s**2 - 768*C*D1*Dd*Pk2*fd*s + 368*C*D1*Dd*Pk2*fd + 256*C*D1*Ddd*Pk2*f*r**2 + 448*C*D1*Ddd*Pk2*f*r*s - 368*C*D1*Ddd*Pk2*f*r + 192*C*D1*Ddd*Pk2*f*s**2 - 320*C*D1*Ddd*Pk2*f*s + 176*C*D1*Ddd*Pk2*f + 768*C*Dd**2*Pk2*f*r**2 + 1344*C*Dd**2*Pk2*f*r*s - 1104*C*Dd**2*Pk2*f*r + 576*C*Dd**2*Pk2*f*s**2 - 960*C*Dd**2*Pk2*f*s + 352*C*Dd**2*Pk2*f + 77*D1**2*K*Pk2*fd*r**2 + 98*D1**2*K*Pk2*fd*r*s - 14*D1**2*K*Pk2*fd*r + 21*D1**2*K*Pk2*fd*s**2 + 42*D1**2*K*Pk2*fd*s - 21*D1**2*K*Pk2*fd - 56*D1**2*K*Pk2*fdd*r**2 - 98*D1**2*K*Pk2*fdd*r*s - 42*D1**2*K*Pk2*fdd*r - 35*D1**2*K*Pk2*fdd*s**2 - 70*D1**2*K*Pk2*fdd*s + 35*D1**2*K*Pk2*fdd - 8*D1**2*K*Pkdd2*fd*k1**2*s**2 - 3*D1**2*K*Pkdd2*fdd*k1**2*s**2 + 14*D1**2*Pk2*bdd1*(2*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(-3*r**2 - 3*r*(s - 1) + s - 1) - 3*r**2 - 3*r*s + 3*r + s - 1) - 42*D1**2*Pk2*f*fd*r**2 - 42*D1**2*Pk2*f*fd*r*s + 42*D1**2*Pk2*f*fd*r + 21*D1**2*Pk2*f*fd*s - 21*D1**2*Pk2*f*fd + 42*D1**2*Pk2*f*fdd*r**2 + 42*D1**2*Pk2*f*fdd*r*s - 42*D1**2*Pk2*f*fdd*r - 21*D1**2*Pk2*f*fdd*s + 21*D1**2*Pk2*f*fdd + 42*D1**2*Pk2*fd**2*r**2 + 42*D1**2*Pk2*fd**2*r*s - 42*D1**2*Pk2*fd**2*r - 21*D1**2*Pk2*fd**2*s + 89*D1**2*Pk2*fd*r**2 + 137*D1**2*Pk2*fd*r*s - 178*D1**2*Pk2*fd*r + 48*D1**2*Pk2*fd*s**2 - 144*D1**2*Pk2*fd*s + 96*D1**2*Pk2*fd - 34*D1**2*Pk2*fdd*r**2 - 51*D1**2*Pk2*fdd*r*s + 96*D1**2*Pk2*fdd*r - 24*D1**2*Pk2*fdd*s**2 + 72*D1**2*Pk2*fdd*s - 48*D1**2*Pk2*fdd + 112*D1**2*Pk2*gd2*r**2 + 224*D1**2*Pk2*gd2*r*s - 224*D1**2*Pk2*gd2*r + 112*D1**2*Pk2*gd2*s**2 - 224*D1**2*Pk2*gd2*s + 112*D1**2*Pk2*gd2 - 56*D1**2*Pk2*gdd2*r**2 - 112*D1**2*Pk2*gdd2*r*s + 112*D1**2*Pk2*gdd2*r - 56*D1**2*Pk2*gdd2*s**2 + 112*D1**2*Pk2*gdd2*s - 56*D1**2*Pk2*gdd2 + 18*D1**2*Pkdd2*f*fd*k1**2*s**2 + 7*D1**2*Pkdd2*fd*k1**2*s**2 + 308*D1*Dd*K*Pk2*f*r**2 + 392*D1*Dd*K*Pk2*f*r*s - 406*D1*Dd*K*Pk2*f*r + 84*D1*Dd*K*Pk2*f*s**2 - 238*D1*Dd*K*Pk2*f*s + 175*D1*Dd*K*Pk2*f - 448*D1*Dd*K*Pk2*fd*r**2 - 784*D1*Dd*K*Pk2*fd*r*s + 154*D1*Dd*K*Pk2*fd*r - 280*D1*Dd*K*Pk2*fd*s**2 - 14*D1*Dd*K*Pk2*fd*s + 154*D1*Dd*K*Pk2*fd - 32*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 16*D1*Dd*K*Pkdd2*f*k1**2*s - 8*D1*Dd*K*Pkdd2*f*k1**2 - 24*D1*Dd*K*Pkdd2*fd*k1**2*s**2 + 6*D1*Dd*K*Pkdd2*fd*k1**2*s - 84*D1*Dd*Pk2*f**2*r**2 - 84*D1*Dd*Pk2*f**2*r*s + 105*D1*Dd*Pk2*f**2*r + 42*D1*Dd*Pk2*f**2*s - 42*D1*Dd*Pk2*f**2 + 336*D1*Dd*Pk2*f*fd*r**2 + 336*D1*Dd*Pk2*f*fd*r*s - 378*D1*Dd*Pk2*f*fd*r - 168*D1*Dd*Pk2*f*fd*s + 105*D1*Dd*Pk2*f*fd + 356*D1*Dd*Pk2*f*r**2 + 548*D1*Dd*Pk2*f*r*s - 493*D1*Dd*Pk2*f*r + 192*D1*Dd*Pk2*f*s**2 - 370*D1*Dd*Pk2*f*s + 226*D1*Dd*Pk2*f - 272*D1*Dd*Pk2*fd*r**2 - 408*D1*Dd*Pk2*fd*r*s + 571*D1*Dd*Pk2*fd*r - 192*D1*Dd*Pk2*fd*s**2 + 438*D1*Dd*Pk2*fd*s - 264*D1*Dd*Pk2*fd + 448*D1*Dd*Pk2*g2*r**2 + 896*D1*Dd*Pk2*g2*r*s - 672*D1*Dd*Pk2*g2*r + 448*D1*Dd*Pk2*g2*s**2 - 672*D1*Dd*Pk2*g2*s + 336*D1*Dd*Pk2*g2 - 448*D1*Dd*Pk2*gd2*r**2 - 896*D1*Dd*Pk2*gd2*r*s + 784*D1*Dd*Pk2*gd2*r - 448*D1*Dd*Pk2*gd2*s**2 + 784*D1*Dd*Pk2*gd2*s - 336*D1*Dd*Pk2*gd2 + 36*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Dd*Pkdd2*f**2*k1**2*s + 9*D1*Dd*Pkdd2*f**2*k1**2 + 28*D1*Dd*Pkdd2*f*k1**2*s**2 - 14*D1*Dd*Pkdd2*f*k1**2*s + 7*D1*Dd*Pkdd2*f*k1**2 - 224*D1*Ddd*K*Pk2*f*r**2 - 392*D1*Ddd*K*Pk2*f*r*s + 322*D1*Ddd*K*Pk2*f*r - 140*D1*Ddd*K*Pk2*f*s**2 + 266*D1*Ddd*K*Pk2*f*s - 147*D1*Ddd*K*Pk2*f - 12*D1*Ddd*K*Pkdd2*f*k1**2*s**2 + 6*D1*Ddd*K*Pkdd2*f*k1**2*s - 3*D1*Ddd*K*Pkdd2*f*k1**2 + 84*D1*Ddd*Pk2*f**2*r**2 + 84*D1*Ddd*Pk2*f**2*r*s - 105*D1*Ddd*Pk2*f**2*r - 42*D1*Ddd*Pk2*f**2*s + 42*D1*Ddd*Pk2*f**2 - 136*D1*Ddd*Pk2*f*r**2 - 204*D1*Ddd*Pk2*f*r*s + 187*D1*Ddd*Pk2*f*r - 96*D1*Ddd*Pk2*f*s**2 + 150*D1*Ddd*Pk2*f*s - 92*D1*Ddd*Pk2*f - 224*D1*Ddd*Pk2*g2*r**2 - 448*D1*Ddd*Pk2*g2*r*s + 336*D1*Ddd*Pk2*g2*r - 224*D1*Ddd*Pk2*g2*s**2 + 336*D1*Ddd*Pk2*g2*s - 168*D1*Ddd*Pk2*g2 + 14*D1*Pk2*bd1*(D1*(-4*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) + Dd*(4*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) - 24*r**2 - 24*r*s + 27*r + 10*s - 7)) - 672*Dd**2*K*Pk2*f*r**2 - 1176*Dd**2*K*Pk2*f*r*s + 966*Dd**2*K*Pk2*f*r - 420*Dd**2*K*Pk2*f*s**2 + 798*Dd**2*K*Pk2*f*s - 308*Dd**2*K*Pk2*f - 36*Dd**2*K*Pkdd2*f*k1**2*s**2 + 18*Dd**2*K*Pkdd2*f*k1**2*s + 252*Dd**2*Pk2*f**2*r**2 + 252*Dd**2*Pk2*f**2*r*s - 315*Dd**2*Pk2*f**2*r - 126*Dd**2*Pk2*f**2*s + 84*Dd**2*Pk2*f**2 - 408*Dd**2*Pk2*f*r**2 - 612*Dd**2*Pk2*f*r*s + 561*Dd**2*Pk2*f*r - 288*Dd**2*Pk2*f*s**2 + 450*Dd**2*Pk2*f*s - 170*Dd**2*Pk2*f - 672*Dd**2*Pk2*g2*r**2 - 1344*Dd**2*Pk2*g2*r*s + 1008*Dd**2*Pk2*g2*r - 672*Dd**2*Pk2*g2*s**2 + 1008*Dd**2*Pk2*g2*s - 336*Dd**2*Pk2*g2) - 33*b1*(-256*C*D1**2*Pk2*bdd1*f*r**2 - 448*C*D1**2*Pk2*bdd1*f*r*s + 224*C*D1**2*Pk2*bdd1*f*r - 192*C*D1**2*Pk2*bdd1*f*s**2 + 192*C*D1**2*Pk2*bdd1*f*s - 96*C*D1**2*Pk2*bdd1*f - 1008*C*D1**2*Pk2*f*fd*r**2 - 1056*C*D1**2*Pk2*f*fd*r*s + 1024*C*D1**2*Pk2*f*fd*r - 144*C*D1**2*Pk2*f*fd*s**2 + 384*C*D1**2*Pk2*f*fd*s - 432*C*D1**2*Pk2*f*fd + 480*C*D1**2*Pk2*f*fdd*r**2 + 896*C*D1**2*Pk2*f*fdd*r*s - 320*C*D1**2*Pk2*f*fdd*r + 240*C*D1**2*Pk2*f*fdd*s**2 - 208*C*D1**2*Pk2*f*fdd*s + 120*C*D1**2*Pk2*f*fdd + 480*C*D1**2*Pk2*fd**2*r**2 + 896*C*D1**2*Pk2*fd**2*r*s - 320*C*D1**2*Pk2*fd**2*r + 240*C*D1**2*Pk2*fd**2*s**2 - 208*C*D1**2*Pk2*fd**2*s - 160*C*D1**2*Pk2*fd**2 + 56*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 20*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 20*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 2016*C*D1*Dd*Pk2*f**2*r**2 - 2112*C*D1*Dd*Pk2*f**2*r*s + 2544*C*D1*Dd*Pk2*f**2*r - 288*C*D1*Dd*Pk2*f**2*s**2 + 1200*C*D1*Dd*Pk2*f**2*s - 1080*C*D1*Dd*Pk2*f**2 + 3840*C*D1*Dd*Pk2*f*fd*r**2 + 7168*C*D1*Dd*Pk2*f*fd*r*s - 4096*C*D1*Dd*Pk2*f*fd*r + 1920*C*D1*Dd*Pk2*f*fd*s**2 - 3104*C*D1*Dd*Pk2*f*fd*s + 848*C*D1*Dd*Pk2*f*fd + 112*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 56*C*D1*Dd*Pkdd2*f**2*k1**2*s + 28*C*D1*Dd*Pkdd2*f**2*k1**2 + 160*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 40*C*D1*Dd*Pkdd2*f*fd*k1**2*s + 960*C*D1*Ddd*Pk2*f**2*r**2 + 1792*C*D1*Ddd*Pk2*f**2*r*s - 1408*C*D1*Ddd*Pk2*f**2*r + 480*C*D1*Ddd*Pk2*f**2*s**2 - 1136*C*D1*Ddd*Pk2*f**2*s + 600*C*D1*Ddd*Pk2*f**2 + 40*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 20*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 10*C*D1*Ddd*Pkdd2*f**2*k1**2 + 2880*C*Dd**2*Pk2*f**2*r**2 + 5376*C*Dd**2*Pk2*f**2*r*s - 4224*C*Dd**2*Pk2*f**2*r + 1440*C*Dd**2*Pk2*f**2*s**2 - 3408*C*Dd**2*Pk2*f**2*s + 1376*C*Dd**2*Pk2*f**2 + 120*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 60*C*Dd**2*Pkdd2*f**2*k1**2*s + 224*D1**2*K*Pk2*bdd1*f*r**2 + 392*D1**2*K*Pk2*bdd1*f*r*s - 504*D1**2*K*Pk2*bdd1*f*r + 140*D1**2*K*Pk2*bdd1*f*s**2 - 476*D1**2*K*Pk2*bdd1*f*s + 252*D1**2*K*Pk2*bdd1*f - 28*D1**2*K*Pk2*f*fd*r**2 - 168*D1**2*K*Pk2*f*fd*r*s + 84*D1**2*K*Pk2*f*fd*r - 168*D1**2*K*Pk2*f*fd*s**2 + 168*D1**2*K*Pk2*f*fd*s - 84*D1**2*K*Pk2*f*fd + 28*D1**2*K*Pk2*f*fdd*r**2 + 168*D1**2*K*Pk2*f*fdd*r*s - 84*D1**2*K*Pk2*f*fdd*r + 168*D1**2*K*Pk2*f*fdd*s**2 - 168*D1**2*K*Pk2*f*fdd*s + 84*D1**2*K*Pk2*f*fdd + 28*D1**2*K*Pk2*fd**2*r**2 + 168*D1**2*K*Pk2*fd**2*r*s - 84*D1**2*K*Pk2*fd**2*r + 168*D1**2*K*Pk2*fd**2*s**2 - 168*D1**2*K*Pk2*fd**2*s + 12*D1**2*K*Pkdd2*bdd1*f*k1**2*s**2 - 12*D1**2*K*Pkdd2*bdd1*f*k1**2*s + 6*D1**2*K*Pkdd2*bdd1*f*k1**2 + 12*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 12*D1**2*K*Pkdd2*f*fd*k1**2*s + 6*D1**2*K*Pkdd2*f*fd*k1**2 - 42*D1**2*Pk2*b2*fd*r**2 - 84*D1**2*Pk2*b2*fd*r*s - 42*D1**2*Pk2*b2*fd*s**2 + 70*D1**2*Pk2*b2*fdd*r**2 + 140*D1**2*Pk2*b2*fdd*r*s + 70*D1**2*Pk2*b2*fdd*s**2 + 28*D1**2*Pk2*bd1**2*(-4*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*r**2 + 6*r*s - 6*r - 2*s + 1) - 84*D1**2*Pk2*bdd1*f**2*r**2 - 84*D1**2*Pk2*bdd1*f**2*r*s + 126*D1**2*Pk2*bdd1*f**2*r + 42*D1**2*Pk2*bdd1*f**2*s - 42*D1**2*Pk2*bdd1*f**2 + 136*D1**2*Pk2*bdd1*f*r**2 + 204*D1**2*Pk2*bdd1*f*r*s - 46*D1**2*Pk2*bdd1*f*r + 96*D1**2*Pk2*bdd1*f*s**2 - 54*D1**2*Pk2*bdd1*f*s + 20*D1**2*Pk2*bdd1*f + 224*D1**2*Pk2*bdd1*g2*r**2 + 448*D1**2*Pk2*bdd1*g2*r*s - 224*D1**2*Pk2*bdd1*g2*r + 224*D1**2*Pk2*bdd1*g2*s**2 - 224*D1**2*Pk2*bdd1*g2*s + 112*D1**2*Pk2*bdd1*g2 + 70*D1**2*Pk2*bdd2*f*r**2 + 140*D1**2*Pk2*bdd2*f*r*s - 140*D1**2*Pk2*bdd2*f*r + 70*D1**2*Pk2*bdd2*f*s**2 - 140*D1**2*Pk2*bdd2*f*s + 70*D1**2*Pk2*bdd2*f + 616*D1**2*Pk2*f*fd*r**2 + 584*D1**2*Pk2*f*fd*r*s - 648*D1**2*Pk2*f*fd*r + 72*D1**2*Pk2*f*fd*s**2 - 220*D1**2*Pk2*f*fd*s + 272*D1**2*Pk2*f*fd - 296*D1**2*Pk2*f*fdd*r**2 - 544*D1**2*Pk2*f*fdd*r*s + 216*D1**2*Pk2*f*fdd*r - 120*D1**2*Pk2*f*fdd*s**2 + 152*D1**2*Pk2*f*fdd*s - 88*D1**2*Pk2*f*fdd + 308*D1**2*Pk2*f*gd2*r**2 + 392*D1**2*Pk2*f*gd2*r*s - 616*D1**2*Pk2*f*gd2*r + 84*D1**2*Pk2*f*gd2*s**2 - 392*D1**2*Pk2*f*gd2*s + 308*D1**2*Pk2*f*gd2 - 224*D1**2*Pk2*f*gdd2*r**2 - 392*D1**2*Pk2*f*gdd2*r*s + 448*D1**2*Pk2*f*gdd2*r - 140*D1**2*Pk2*f*gdd2*s**2 + 392*D1**2*Pk2*f*gdd2*s - 224*D1**2*Pk2*f*gdd2 - 296*D1**2*Pk2*fd**2*r**2 - 544*D1**2*Pk2*fd**2*r*s + 216*D1**2*Pk2*fd**2*r - 120*D1**2*Pk2*fd**2*s**2 + 152*D1**2*Pk2*fd**2*s + 80*D1**2*Pk2*fd**2 + 308*D1**2*Pk2*fd*g2*r**2 + 392*D1**2*Pk2*fd*g2*r*s - 56*D1**2*Pk2*fd*g2*r + 84*D1**2*Pk2*fd*g2*s**2 + 168*D1**2*Pk2*fd*g2*s - 84*D1**2*Pk2*fd*g2 - 448*D1**2*Pk2*fd*gd2*r**2 - 784*D1**2*Pk2*fd*gd2*r*s + 280*D1**2*Pk2*fd*gd2*r - 280*D1**2*Pk2*fd*gd2*s**2 + 112*D1**2*Pk2*fd*gd2*s + 168*D1**2*Pk2*fd*gd2 - 224*D1**2*Pk2*fdd*g2*r**2 - 392*D1**2*Pk2*fdd*g2*r*s - 168*D1**2*Pk2*fdd*g2*r - 140*D1**2*Pk2*fdd*g2*s**2 - 280*D1**2*Pk2*fdd*g2*s + 140*D1**2*Pk2*fdd*g2 - 52*D1**2*Pkdd2*f*fd*k1**2*s**2 - 10*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 32*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 12*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 10*D1**2*Pkdd2*fd**2*k1**2*s**2 - 32*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 24*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 12*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 56*D1*Dd*K*Pk2*f**2*r**2 - 336*D1*Dd*K*Pk2*f**2*r*s + 140*D1*Dd*K*Pk2*f**2*r - 336*D1*Dd*K*Pk2*f**2*s**2 + 336*D1*Dd*K*Pk2*f**2*s - 112*D1*Dd*K*Pk2*f**2 + 224*D1*Dd*K*Pk2*f*fd*r**2 + 1344*D1*Dd*K*Pk2*f*fd*r*s - 616*D1*Dd*K*Pk2*f*fd*r + 1344*D1*Dd*K*Pk2*f*fd*s**2 - 1344*D1*Dd*K*Pk2*f*fd*s + 336*D1*Dd*K*Pk2*f*fd + 24*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 12*D1*Dd*K*Pkdd2*f**2*k1**2*s + 6*D1*Dd*K*Pkdd2*f**2*k1**2 - 168*D1*Dd*Pk2*b2*f*r**2 - 336*D1*Dd*Pk2*b2*f*r*s + 252*D1*Dd*Pk2*b2*f*r - 168*D1*Dd*Pk2*b2*f*s**2 + 252*D1*Dd*Pk2*b2*f*s - 126*D1*Dd*Pk2*b2*f + 560*D1*Dd*Pk2*b2*fd*r**2 + 1120*D1*Dd*Pk2*b2*fd*r*s - 420*D1*Dd*Pk2*b2*fd*r + 560*D1*Dd*Pk2*b2*fd*s**2 - 420*D1*Dd*Pk2*b2*fd*s + 1232*D1*Dd*Pk2*f**2*r**2 + 1168*D1*Dd*Pk2*f**2*r*s - 1524*D1*Dd*Pk2*f**2*r + 144*D1*Dd*Pk2*f**2*s**2 - 656*D1*Dd*Pk2*f**2*s + 652*D1*Dd*Pk2*f**2 - 2368*D1*Dd*Pk2*f*fd*r**2 - 4352*D1*Dd*Pk2*f*fd*r*s + 2592*D1*Dd*Pk2*f*fd*r - 960*D1*Dd*Pk2*f*fd*s**2 + 1936*D1*Dd*Pk2*f*fd*s - 584*D1*Dd*Pk2*f*fd + 1232*D1*Dd*Pk2*f*g2*r**2 + 1568*D1*Dd*Pk2*f*g2*r*s - 1624*D1*Dd*Pk2*f*g2*r + 336*D1*Dd*Pk2*f*g2*s**2 - 952*D1*Dd*Pk2*f*g2*s + 700*D1*Dd*Pk2*f*g2 - 1792*D1*Dd*Pk2*f*gd2*r**2 - 3136*D1*Dd*Pk2*f*gd2*r*s + 3080*D1*Dd*Pk2*f*gd2*r - 1120*D1*Dd*Pk2*f*gd2*s**2 + 2632*D1*Dd*Pk2*f*gd2*s - 1288*D1*Dd*Pk2*f*gd2 - 1792*D1*Dd*Pk2*fd*g2*r**2 - 3136*D1*Dd*Pk2*fd*g2*r*s + 616*D1*Dd*Pk2*fd*g2*r - 1120*D1*Dd*Pk2*fd*g2*s**2 - 56*D1*Dd*Pk2*fd*g2*s + 616*D1*Dd*Pk2*fd*g2 - 104*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 52*D1*Dd*Pkdd2*f**2*k1**2*s - 26*D1*Dd*Pkdd2*f**2*k1**2 - 80*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 20*D1*Dd*Pkdd2*f*fd*k1**2*s - 128*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 64*D1*Dd*Pkdd2*f*g2*k1**2*s - 32*D1*Dd*Pkdd2*f*g2*k1**2 - 96*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 24*D1*Dd*Pkdd2*f*gd2*k1**2*s - 96*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 24*D1*Dd*Pkdd2*fd*g2*k1**2*s + 56*D1*Ddd*K*Pk2*f**2*r**2 + 336*D1*Ddd*K*Pk2*f**2*r*s - 140*D1*Ddd*K*Pk2*f**2*r + 336*D1*Ddd*K*Pk2*f**2*s**2 - 336*D1*Ddd*K*Pk2*f**2*s + 112*D1*Ddd*K*Pk2*f**2 + 280*D1*Ddd*Pk2*b2*f*r**2 + 560*D1*Ddd*Pk2*b2*f*r*s - 420*D1*Ddd*Pk2*b2*f*r + 280*D1*Ddd*Pk2*b2*f*s**2 - 420*D1*Ddd*Pk2*b2*f*s + 210*D1*Ddd*Pk2*b2*f - 592*D1*Ddd*Pk2*f**2*r**2 - 1088*D1*Ddd*Pk2*f**2*r*s + 864*D1*Ddd*Pk2*f**2*r - 240*D1*Ddd*Pk2*f**2*s**2 + 664*D1*Ddd*Pk2*f**2*s - 356*D1*Ddd*Pk2*f**2 - 896*D1*Ddd*Pk2*f*g2*r**2 - 1568*D1*Ddd*Pk2*f*g2*r*s + 1288*D1*Ddd*Pk2*f*g2*r - 560*D1*Ddd*Pk2*f*g2*s**2 + 1064*D1*Ddd*Pk2*f*g2*s - 588*D1*Ddd*Pk2*f*g2 - 20*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 10*D1*Ddd*Pkdd2*f**2*k1**2*s - 5*D1*Ddd*Pkdd2*f**2*k1**2 - 48*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 24*D1*Ddd*Pkdd2*f*g2*k1**2*s - 12*D1*Ddd*Pkdd2*f*g2*k1**2 - 14*D1*Pk2*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 2*D1*bd1*(D1*(6*K*Pkdd2*fd*k1**2*s*(2*s - 1) + Pk2*fd*(-16*C*(16*r**2 + r*(28*s - 23) + 12*s**2 - 20*s + 7) + 14*K*(16*r**2 + 4*r*(7*s - 3) + 10*s**2 - 7*s - 3) + 136*r**2 + 204*r*s - 215*r + 96*s**2 - 171*s + 72) - 112*Pk2*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 112*Pk2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 3*f**2*(7*Pk2*(2*r - 1)*(r + s - 1) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(Pk2*(32*C*(8*r**2 + 7*r*(2*s - 1) + 6*s**2 - 6*s + 3) - 154*K*r**2 - 196*K*r*s + 238*K*r - 42*K*s**2 + 182*K*s - 119*K - 21*fd*(2*r - 1)*(4*r + 4*s - 3) - 178*r**2 - 274*r*s + 137*r - 96*s**2 + 89*s - 41) + Pkdd2*k1**2*(8*K - 7)*(2*s**2 - 2*s + 1))) + Dd*(-21*Pk2*f**2*(2*r - 1)*(8*r + 8*s - 7) + 112*Pk2*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f*(6*K*Pkdd2*k1**2*(8*s**2 - 6*s + 1) + Pk2*(-32*C*(32*r**2 + r*(56*s - 37) + 24*s**2 - 32*s + 10) + 14*K*(64*r**2 + 2*r*(56*s - 59) + 40*s**2 - 106*s + 53) + 544*r**2 + 816*r*s - 466*r + 384*s**2 - 408*s + 73)))) + 168*Dd**2*K*Pk2*f**2*r**2 + 1008*Dd**2*K*Pk2*f**2*r*s - 420*Dd**2*K*Pk2*f**2*r + 1008*Dd**2*K*Pk2*f**2*s**2 - 1008*Dd**2*K*Pk2*f**2*s + 196*Dd**2*K*Pk2*f**2 + 840*Dd**2*Pk2*b2*f*r**2 + 1680*Dd**2*Pk2*b2*f*r*s - 1260*Dd**2*Pk2*b2*f*r + 840*Dd**2*Pk2*b2*f*s**2 - 1260*Dd**2*Pk2*b2*f*s + 420*Dd**2*Pk2*b2*f - 1776*Dd**2*Pk2*f**2*r**2 - 3264*Dd**2*Pk2*f**2*r*s + 2592*Dd**2*Pk2*f**2*r - 720*Dd**2*Pk2*f**2*s**2 + 1992*Dd**2*Pk2*f**2*s - 840*Dd**2*Pk2*f**2 - 2688*Dd**2*Pk2*f*g2*r**2 - 4704*Dd**2*Pk2*f*g2*r*s + 3864*Dd**2*Pk2*f*g2*r - 1680*Dd**2*Pk2*f*g2*s**2 + 3192*Dd**2*Pk2*f*g2*s - 1232*Dd**2*Pk2*f*g2 - 60*Dd**2*Pkdd2*f**2*k1**2*s**2 + 30*Dd**2*Pkdd2*f**2*k1**2*s - 144*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 72*Dd**2*Pkdd2*f*g2*k1**2*s))/(693*d**2*k3**4) + D1**2*Pk3*ct**2*st**4*(D1**2*(Pkdd2*f**3*k1**2*s**2*(-90*bd1 + 45*bdd1) + 66*Pkdd2*f*k1**2*s**2*(-K*bd1**2 + b1*(-K*bdd1 + 2*bd1*(K - 1) + bdd1 - 2*gd2 + gdd2) + bd1**2 - 2*bd1*g2 + 2*bd1*gd2 + bdd1*g2) + 33*Pkdd2*k1**2*(s - 1)*(b1**2*(K - 1)*(2*fd - fdd)*(s - 1) + 4*b1*fd*(-g2*s + g2 + s*(-K*bd1 + bd1 + gd2)) + 2*b1*fdd*g2*(s - 1) + 4*bd1*fd*g2*s) + 5*f**2*(16*Pk2*fd*(6*C*(3*s**2 - 2*s + 1) + r*(3*s - 1) - 9*s**2 + 5*s - 3) - 8*Pk2*fdd*(6*C*(3*s**2 - 2*s + 1) + r*(3*s - 1) - 9*s**2 + 5*s - 3) - 2*Pkdd2*fd*k1**2*(9*b1*(3*s**2 - 2*s + 1) + s**2*(6 - 27*bd1) + s*(9*bd1 - 4) + 2) + Pkdd2*fdd*k1**2*(9*b1 + 2)*(3*s**2 - 2*s + 1)) - 10*f*fd**2*(4*Pk2*(r*(6*s - 2) + s**2*(36*C - 18) + s*(10 - 24*C) + 1) - Pkdd2*k1**2*s*(9*b1 + 2)*(3*s - 2))) + D1*(2*Dd*(-33*Pkdd2*b1*fd*k1**2*(b1*(K - 1) - 2*g2)*(4*s**2 - 5*s + 1) + 33*Pkdd2*f*k1**2*(b1**2*(K - 1)*(4*s**2 - 2*s + 1) - 2*b1*g2*(4*s**2 - 2*s + 1) + 2*b1*s*(4*s - 1)*(-K*bd1 + bd1 + gd2) + 2*bd1*g2*s*(4*s - 1)) + 5*f**3*(8*Pk2*(6*C*(4*s**2 - 2*s + 1) + r*(4*s - 1) - 12*s**2 + 4*s - 3) - Pkdd2*k1**2*(9*b1*(4*s**2 - 2*s + 1) + s**2*(8 - 36*bd1) + s*(9*bd1 - 4) + 2)) - 5*f**2*fd*(4*Pk2*(12*C*(12*s**2 - 7*s + 1) + 24*r*s - 7*r - 72*s**2 + 32*s - 3) - Pkdd2*k1**2*(9*b1 + 2)*(12*s**2 - 7*s + 1))) + Ddd*f*(-33*Pkdd2*b1*k1**2*(b1*(K - 1) - 2*g2)*(4*s**2 - 2*s + 1) - 5*f**2*(8*Pk2*(6*C*(4*s**2 - 2*s + 1) + 4*r*s - r - 12*s**2 + 4*s - 3) - Pkdd2*k1**2*(9*b1 + 2)*(4*s**2 - 2*s + 1)))) - 2*Dd**2*f*(99*Pkdd2*b1*k1**2*s*(2*s - 1)*(b1*(K - 1) - 2*g2) + 5*f**2*(4*Pk2*(3*r*(4*s - 1) + s**2*(72*C - 36) + s*(12 - 36*C) + 2) + Pkdd2*k1**2*s*(-27*b1 - 6)*(2*s - 1))))/(231*d**2*k3**2) + D1**2*Pk3*ct**2*st**2*(-3072*C*D1**2*Pk2*f**2*fd*r*s + 1024*C*D1**2*Pk2*f**2*fd*r - 8712*C*D1**2*Pk2*f**2*fd*s**2 + 6832*C*D1**2*Pk2*f**2*fd*s - 2904*C*D1**2*Pk2*f**2*fd + 4704*C*D1**2*Pk2*f**2*fdd*r*s - 1568*C*D1**2*Pk2*f**2*fdd*r + 7128*C*D1**2*Pk2*f**2*fdd*s**2 - 6320*C*D1**2*Pk2*f**2*fdd*s + 2376*C*D1**2*Pk2*f**2*fdd + 9408*C*D1**2*Pk2*f*fd**2*r*s - 3136*C*D1**2*Pk2*f*fd**2*r + 14256*C*D1**2*Pk2*f*fd**2*s**2 - 12640*C*D1**2*Pk2*f*fd**2*s + 1568*C*D1**2*Pk2*f*fd**2 + 600*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 400*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 200*C*D1**2*Pkdd2*f**2*fd*k1**2 - 300*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 200*C*D1**2*Pkdd2*f**2*fdd*k1**2*s - 100*C*D1**2*Pkdd2*f**2*fdd*k1**2 - 600*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 400*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 4096*C*D1*Dd*Pk2*f**3*r*s + 1024*C*D1*Dd*Pk2*f**3*r - 11616*C*D1*Dd*Pk2*f**3*s**2 + 7856*C*D1*Dd*Pk2*f**3*s - 2904*C*D1*Dd*Pk2*f**3 + 37632*C*D1*Dd*Pk2*f**2*fd*r*s - 10976*C*D1*Dd*Pk2*f**2*fd*r + 57024*C*D1*Dd*Pk2*f**2*fd*s**2 - 48944*C*D1*Dd*Pk2*f**2*fd*s + 9456*C*D1*Dd*Pk2*f**2*fd + 800*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 400*C*D1*Dd*Pkdd2*f**3*k1**2*s + 200*C*D1*Dd*Pkdd2*f**3*k1**2 - 2400*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 1400*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 200*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 6272*C*D1*Ddd*Pk2*f**3*r*s - 1568*C*D1*Ddd*Pk2*f**3*r + 9504*C*D1*Ddd*Pk2*f**3*s**2 - 7888*C*D1*Ddd*Pk2*f**3*s + 2376*C*D1*Ddd*Pk2*f**3 - 400*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 200*C*D1*Ddd*Pkdd2*f**3*k1**2*s - 100*C*D1*Ddd*Pkdd2*f**3*k1**2 + 18816*C*Dd**2*Pk2*f**3*r*s - 4704*C*Dd**2*Pk2*f**3*r + 28512*C*Dd**2*Pk2*f**3*s**2 - 23664*C*Dd**2*Pk2*f**3*s + 3136*C*Dd**2*Pk2*f**3 - 1200*C*Dd**2*Pkdd2*f**3*k1**2*s**2 + 600*C*Dd**2*Pkdd2*f**3*k1**2*s - 1056*D1**2*Pk2*b2*f*fd*r*s + 528*D1**2*Pk2*b2*f*fd*r - 2904*D1**2*Pk2*b2*f*fd*s**2 + 2904*D1**2*Pk2*b2*f*fd*s - 1452*D1**2*Pk2*b2*f*fd + 1056*D1**2*Pk2*b2*f*fdd*r*s - 528*D1**2*Pk2*b2*f*fdd*r + 2376*D1**2*Pk2*b2*f*fdd*s**2 - 2376*D1**2*Pk2*b2*f*fdd*s + 1188*D1**2*Pk2*b2*f*fdd + 1056*D1**2*Pk2*b2*fd**2*r*s - 528*D1**2*Pk2*b2*fd**2*r + 2376*D1**2*Pk2*b2*fd**2*s**2 - 2376*D1**2*Pk2*b2*fd**2*s - 528*D1**2*Pk2*bd2*f**2*r*s - 1452*D1**2*Pk2*bd2*f**2*s**2 + 528*D1**2*Pk2*bd2*f**2*s + 2112*D1**2*Pk2*bd2*f*fd*r*s - 528*D1**2*Pk2*bd2*f*fd*r + 4752*D1**2*Pk2*bd2*f*fd*s**2 - 3432*D1**2*Pk2*bd2*f*fd*s + 528*D1**2*Pk2*bd2*f*fd + 528*D1**2*Pk2*bdd2*f**2*r*s + 1188*D1**2*Pk2*bdd2*f**2*s**2 - 528*D1**2*Pk2*bdd2*f**2*s - 792*D1**2*Pk2*f**2*fd*r**2 - 1620*D1**2*Pk2*f**2*fd*r*s + 1068*D1**2*Pk2*f**2*fd*r + 4356*D1**2*Pk2*f**2*fd*s**2 - 2364*D1**2*Pk2*f**2*fd*s + 1188*D1**2*Pk2*f**2*fd + 792*D1**2*Pk2*f**2*fdd*r**2 - 180*D1**2*Pk2*f**2*fdd*r*s - 468*D1**2*Pk2*f**2*fdd*r - 3564*D1**2*Pk2*f**2*fdd*s**2 + 2436*D1**2*Pk2*f**2*fdd*s - 924*D1**2*Pk2*f**2*fdd + 1056*D1**2*Pk2*f**2*gd2*r*s + 2904*D1**2*Pk2*f**2*gd2*s**2 - 1056*D1**2*Pk2*f**2*gd2*s - 1056*D1**2*Pk2*f**2*gdd2*r*s - 2376*D1**2*Pk2*f**2*gdd2*s**2 + 1056*D1**2*Pk2*f**2*gdd2*s + 1584*D1**2*Pk2*f*fd**2*r**2 - 360*D1**2*Pk2*f*fd**2*r*s - 936*D1**2*Pk2*f*fd**2*r - 7128*D1**2*Pk2*f*fd**2*s**2 + 4872*D1**2*Pk2*f*fd**2*s - 60*D1**2*Pk2*f*fd**2 + 2112*D1**2*Pk2*f*fd*g2*r*s - 1056*D1**2*Pk2*f*fd*g2*r + 5808*D1**2*Pk2*f*fd*g2*s**2 - 5808*D1**2*Pk2*f*fd*g2*s + 2904*D1**2*Pk2*f*fd*g2 - 4224*D1**2*Pk2*f*fd*gd2*r*s + 1056*D1**2*Pk2*f*fd*gd2*r - 9504*D1**2*Pk2*f*fd*gd2*s**2 + 6864*D1**2*Pk2*f*fd*gd2*s - 1056*D1**2*Pk2*f*fd*gd2 - 2112*D1**2*Pk2*f*fdd*g2*r*s + 1056*D1**2*Pk2*f*fdd*g2*r - 4752*D1**2*Pk2*f*fdd*g2*s**2 + 4752*D1**2*Pk2*f*fdd*g2*s - 2376*D1**2*Pk2*f*fdd*g2 - 2112*D1**2*Pk2*fd**2*g2*r*s + 1056*D1**2*Pk2*fd**2*g2*r - 4752*D1**2*Pk2*fd**2*g2*s**2 + 4752*D1**2*Pk2*fd**2*g2*s + 264*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 - 264*D1**2*Pkdd2*b2*f*fd*k1**2*s + 132*D1**2*Pkdd2*b2*f*fd*k1**2 - 132*D1**2*Pkdd2*b2*f*fdd*k1**2*s**2 + 132*D1**2*Pkdd2*b2*f*fdd*k1**2*s - 66*D1**2*Pkdd2*b2*f*fdd*k1**2 - 132*D1**2*Pkdd2*b2*fd**2*k1**2*s**2 + 132*D1**2*Pkdd2*b2*fd**2*k1**2*s + 132*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 - 264*D1**2*Pkdd2*bd2*f*fd*k1**2*s**2 + 132*D1**2*Pkdd2*bd2*f*fd*k1**2*s - 66*D1**2*Pkdd2*bdd2*f**2*k1**2*s**2 - 102*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 68*D1**2*Pkdd2*f**2*fd*k1**2*s - 34*D1**2*Pkdd2*f**2*fd*k1**2 + 150*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 100*D1**2*Pkdd2*f**2*fdd*k1**2*s + 50*D1**2*Pkdd2*f**2*fdd*k1**2 - 264*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 132*D1**2*Pkdd2*f**2*gdd2*k1**2*s**2 + 300*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 200*D1**2*Pkdd2*f*fd**2*k1**2*s - 528*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 528*D1**2*Pkdd2*f*fd*g2*k1**2*s - 264*D1**2*Pkdd2*f*fd*g2*k1**2 + 528*D1**2*Pkdd2*f*fd*gd2*k1**2*s**2 - 264*D1**2*Pkdd2*f*fd*gd2*k1**2*s + 264*D1**2*Pkdd2*f*fdd*g2*k1**2*s**2 - 264*D1**2*Pkdd2*f*fdd*g2*k1**2*s + 132*D1**2*Pkdd2*f*fdd*g2*k1**2 + 264*D1**2*Pkdd2*fd**2*g2*k1**2*s**2 - 264*D1**2*Pkdd2*fd**2*g2*k1**2*s + 44*D1**2*bd1**2*(7*Pkdd2*g2*k1**2*s*(s - 1) + f**2*(6*Pk2*(r - 1) + 3*Pkdd2*k1**2*s*(2*s - 3)) + f*(6*Pk2*(2*K*s + r**2*(K - 1) - r*(4*K*s + K - 2) - 1) + Pkdd2*k1**2*s*(C + 2)*(s - 1))) + 22*D1**2*bdd1*f*(6*Pk2*f**2*(3*r**2 + r*(5*s - 4) - 5*s + 2) - 12*Pk2*g2*r*(r - 4*s) + f*(-2*Pk2*(-27*K*s**2 + r**2*(2*C - 8) + r*s*(24*C - 12*K - 27) + 6*r + s*(12*K + 15) - 6) + 3*Pkdd2*k1**2*(-s**2*(K - 1) - 2*s + 1))) - 2112*D1*Dd*Pk2*b2*f**2*r*s + 528*D1*Dd*Pk2*b2*f**2*r - 5808*D1*Dd*Pk2*b2*f**2*s**2 + 3960*D1*Dd*Pk2*b2*f**2*s - 1452*D1*Dd*Pk2*b2*f**2 + 8448*D1*Dd*Pk2*b2*f*fd*r*s - 3168*D1*Dd*Pk2*b2*f*fd*r + 19008*D1*Dd*Pk2*b2*f*fd*s**2 - 16368*D1*Dd*Pk2*b2*f*fd*s + 3432*D1*Dd*Pk2*b2*f*fd + 4224*D1*Dd*Pk2*bd2*f**2*r*s - 528*D1*Dd*Pk2*bd2*f**2*r + 9504*D1*Dd*Pk2*bd2*f**2*s**2 - 5544*D1*Dd*Pk2*bd2*f**2*s + 528*D1*Dd*Pk2*bd2*f**2 - 1056*D1*Dd*Pk2*f**3*r**2 - 2160*D1*Dd*Pk2*f**3*r*s + 1596*D1*Dd*Pk2*f**3*r + 5808*D1*Dd*Pk2*f**3*s**2 - 1824*D1*Dd*Pk2*f**3*s + 924*D1*Dd*Pk2*f**3 + 6336*D1*Dd*Pk2*f**2*fd*r**2 - 1440*D1*Dd*Pk2*f**2*fd*r*s - 4860*D1*Dd*Pk2*f**2*fd*r - 28512*D1*Dd*Pk2*f**2*fd*s**2 + 17232*D1*Dd*Pk2*f**2*fd*s - 1500*D1*Dd*Pk2*f**2*fd + 4224*D1*Dd*Pk2*f**2*g2*r*s - 1056*D1*Dd*Pk2*f**2*g2*r + 11616*D1*Dd*Pk2*f**2*g2*s**2 - 7920*D1*Dd*Pk2*f**2*g2*s + 2904*D1*Dd*Pk2*f**2*g2 - 8448*D1*Dd*Pk2*f**2*gd2*r*s + 1056*D1*Dd*Pk2*f**2*gd2*r - 19008*D1*Dd*Pk2*f**2*gd2*s**2 + 11088*D1*Dd*Pk2*f**2*gd2*s - 1056*D1*Dd*Pk2*f**2*gd2 - 16896*D1*Dd*Pk2*f*fd*g2*r*s + 6336*D1*Dd*Pk2*f*fd*g2*r - 38016*D1*Dd*Pk2*f*fd*g2*s**2 + 32736*D1*Dd*Pk2*f*fd*g2*s - 6864*D1*Dd*Pk2*f*fd*g2 + 528*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 - 264*D1*Dd*Pkdd2*b2*f**2*k1**2*s + 132*D1*Dd*Pkdd2*b2*f**2*k1**2 - 1056*D1*Dd*Pkdd2*b2*f*fd*k1**2*s**2 + 792*D1*Dd*Pkdd2*b2*f*fd*k1**2*s - 132*D1*Dd*Pkdd2*b2*f*fd*k1**2 - 528*D1*Dd*Pkdd2*bd2*f**2*k1**2*s**2 + 132*D1*Dd*Pkdd2*bd2*f**2*k1**2*s - 136*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 68*D1*Dd*Pkdd2*f**3*k1**2*s - 34*D1*Dd*Pkdd2*f**3*k1**2 + 1200*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 700*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 100*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1056*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 528*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 264*D1*Dd*Pkdd2*f**2*g2*k1**2 + 1056*D1*Dd*Pkdd2*f**2*gd2*k1**2*s**2 - 264*D1*Dd*Pkdd2*f**2*gd2*k1**2*s + 2112*D1*Dd*Pkdd2*f*fd*g2*k1**2*s**2 - 1584*D1*Dd*Pkdd2*f*fd*g2*k1**2*s + 264*D1*Dd*Pkdd2*f*fd*g2*k1**2 + 2112*D1*Ddd*Pk2*b2*f**2*r*s - 528*D1*Ddd*Pk2*b2*f**2*r + 4752*D1*Ddd*Pk2*b2*f**2*s**2 - 3432*D1*Ddd*Pk2*b2*f**2*s + 1188*D1*Ddd*Pk2*b2*f**2 + 1056*D1*Ddd*Pk2*f**3*r**2 - 240*D1*Ddd*Pk2*f**3*r*s - 996*D1*Ddd*Pk2*f**3*r - 4752*D1*Ddd*Pk2*f**3*s**2 + 2496*D1*Ddd*Pk2*f**3*s - 660*D1*Ddd*Pk2*f**3 - 4224*D1*Ddd*Pk2*f**2*g2*r*s + 1056*D1*Ddd*Pk2*f**2*g2*r - 9504*D1*Ddd*Pk2*f**2*g2*s**2 + 6864*D1*Ddd*Pk2*f**2*g2*s - 2376*D1*Ddd*Pk2*f**2*g2 - 264*D1*Ddd*Pkdd2*b2*f**2*k1**2*s**2 + 132*D1*Ddd*Pkdd2*b2*f**2*k1**2*s - 66*D1*Ddd*Pkdd2*b2*f**2*k1**2 + 200*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 100*D1*Ddd*Pkdd2*f**3*k1**2*s + 50*D1*Ddd*Pkdd2*f**3*k1**2 + 528*D1*Ddd*Pkdd2*f**2*g2*k1**2*s**2 - 264*D1*Ddd*Pkdd2*f**2*g2*k1**2*s + 132*D1*Ddd*Pkdd2*f**2*g2*k1**2 - 22*D1*bd1*(D1*(24*Pk2*fd*g2*r*(r - 4*s + 2) + 3*f**3*(2*Pk2*(3*r**2 + r*(5*s - 4) - 5*s + 2) - 3*Pkdd2*k1**2*s**2) - f**2*(2*Pk2*(-33*K*s**2 + 12*K*s + 3*fd*(18*r**2 + 5*r*(6*s - 5) - 20*s + 9) + r**2*(2*C - 8) + r*(s*(32*C - 12*K - 37) + 4) + 21*s - 6) + Pkdd2*k1**2*(s**2*(C + 6*K - 4) + 12*s - 6)) - f*(-24*Pk2*gd2*(r**2 - r*(4*s + 1) + 2*s) + 2*fd*(Pk2*(24*C*s + 6*K*(r*(8*s - 2) + 18*s**2 - 13*s + 2) - r**2*(8*C - 32) + r*(-96*C*s + 28*C + 108*s - 49) - 42*s + 9) + 3*Pkdd2*k1**2*s*(-2*K*s + K + 2*s - 2)) + g2*(24*Pk2*r*(r - 4*s) + 7*Pkdd2*k1**2*s**2))) - 2*Dd*f*(3*Pk2*f**2*(24*r**2 + r*(40*s - 33) - 30*s + 13) - 48*Pk2*g2*(r**2 - 4*r*s + s) + f*(Pk2*(6*K*(2*r*(8*s - 1) + 36*s**2 - 21*s + 2) - r**2*(16*C - 64) + r*(-32*C*(6*s - 1) + 216*s - 83) + s*(48*C - 114) + 27) - 3*Pkdd2*k1**2*(4*s - 1)*(s*(K - 1) + 1)))) + 6336*Dd**2*Pk2*b2*f**2*r*s - 1584*Dd**2*Pk2*b2*f**2*r + 14256*Dd**2*Pk2*b2*f**2*s**2 - 10296*Dd**2*Pk2*b2*f**2*s + 1056*Dd**2*Pk2*b2*f**2 + 3168*Dd**2*Pk2*f**3*r**2 - 720*Dd**2*Pk2*f**3*r*s - 2988*Dd**2*Pk2*f**3*r - 14256*Dd**2*Pk2*f**3*s**2 + 7488*Dd**2*Pk2*f**3*s + 408*Dd**2*Pk2*f**3 - 12672*Dd**2*Pk2*f**2*g2*r*s + 3168*Dd**2*Pk2*f**2*g2*r - 28512*Dd**2*Pk2*f**2*g2*s**2 + 20592*Dd**2*Pk2*f**2*g2*s - 2112*Dd**2*Pk2*f**2*g2 - 792*Dd**2*Pkdd2*b2*f**2*k1**2*s**2 + 396*Dd**2*Pkdd2*b2*f**2*k1**2*s + 600*Dd**2*Pkdd2*f**3*k1**2*s**2 - 300*Dd**2*Pkdd2*f**3*k1**2*s + 1584*Dd**2*Pkdd2*f**2*g2*k1**2*s**2 - 792*Dd**2*Pkdd2*f**2*g2*k1**2*s + 77*Pkdd2*b1**3*k1**2*(K - 1)*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + 11*b1**2*(D1**2*(2*C*Pkdd2*fdd*k1**2*s**2 + 12*K*Pk2*fdd*r**2 - 48*K*Pk2*fdd*r*s + 48*K*Pk2*fdd*r - 21*K*Pkdd2*bdd1*k1**2*s**2 + 14*K*Pkdd2*bdd1*k1**2*s - 7*K*Pkdd2*bdd1*k1**2 - 24*Pk2*f*fdd*r + 24*Pk2*fd*r*(-K*(r - 4*s + 4) + f + r + 2) - 12*Pk2*fdd*r**2 - 24*Pk2*fdd*r + 14*Pkdd2*bd1*k1**2*(K - 1)*(3*s**2 - 2*s + 1) + 21*Pkdd2*bdd1*k1**2*s**2 - 14*Pkdd2*bdd1*k1**2*s + 7*Pkdd2*bdd1*k1**2 + 24*Pkdd2*f*fdd*k1**2*s**2 + 12*Pkdd2*f*fdd*k1**2*s - 6*Pkdd2*f*fdd*k1**2 - Pkdd2*fd*k1**2*(4*C*s**2 + 7*K*(s - 1)**2 + 12*f*(4*s**2 + 2*s - 1) + s**2 + 14*s - 7) + 4*Pkdd2*fdd*k1**2*s**2 - 28*Pkdd2*gd2*k1**2*s**2 + 14*Pkdd2*gdd2*k1**2*s**2 + 12*fd**2*(-2*Pk2*(r - 1) + Pkdd2*k1**2*s*(2*s + 1))) - D1*Dd*(24*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + 14*Pkdd2*k1**2*(bd1*(K - 1)*(12*s**2 - 7*s + 1) + 2*g2*(4*s**2 - 2*s + 1) + 2*gd2*s*(1 - 4*s)) + f*(48*Pk2*(K*(2*r**2 - 8*r*s + 4*s + 1) + fd*(2*r - 1) - 2*r**2 + 2*r - 1) + Pkdd2*k1**2*(4*C*(4*s**2 - 2*s + 1) + fd*(12 - 192*s**2) + (7*K + 1)*(4*s**2 - 2*s + 1))) - 4*fd*(12*Pk2*(2*K*(r**2 - 4*r*s + 2*r + s - 1) - 2*r**2 - r + 1) + Pkdd2*k1**2*s*(C + 2)*(4*s - 1))) + 2*D1*Ddd*(12*Pk2*f*(K*(2*r**2 - 8*r*s + 4*s + 1) - 2*r**2 + 2*r - 1) + 6*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + Pkdd2*f*k1**2*(C + 2)*(4*s**2 - 2*s + 1) + 7*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1)) + 12*Dd**2*(2*Pk2*f*(3*K*(2*r**2 - 8*r*s + 4*s - 1) - 6*r**2 + 6*r - 1) + 6*Pkdd2*f**2*k1**2*s*(2*s - 1) + Pkdd2*f*k1**2*s*(C + 2)*(2*s - 1) + 7*Pkdd2*g2*k1**2*s*(2*s - 1))) - 22*b1*(-8*C*D1**2*Pk2*f*fd*r**2 - 128*C*D1**2*Pk2*f*fd*r*s + 72*C*D1**2*Pk2*f*fd*r + 64*C*D1**2*Pk2*f*fd*s - 4*C*D1**2*Pk2*f*fd + 8*C*D1**2*Pk2*f*fdd*r**2 + 96*C*D1**2*Pk2*f*fdd*r*s - 56*C*D1**2*Pk2*f*fdd*r - 48*C*D1**2*Pk2*f*fdd*s + 4*C*D1**2*Pk2*f*fdd + 8*C*D1**2*Pk2*fd**2*r**2 + 96*C*D1**2*Pk2*fd**2*r*s - 56*C*D1**2*Pk2*fd**2*r - 48*C*D1**2*Pk2*fd**2*s + 48*C*D1**2*Pk2*fd**2 - 2*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 2*C*D1**2*Pkdd2*f*fd*k1**2*s - C*D1**2*Pkdd2*f*fd*k1**2 - 16*C*D1*Dd*Pk2*f**2*r**2 - 256*C*D1*Dd*Pk2*f**2*r*s + 80*C*D1*Dd*Pk2*f**2*r + 128*C*D1*Dd*Pk2*f**2*s - 8*C*D1*Dd*Pk2*f**2 + 64*C*D1*Dd*Pk2*f*fd*r**2 + 768*C*D1*Dd*Pk2*f*fd*r*s - 352*C*D1*Dd*Pk2*f*fd*r - 384*C*D1*Dd*Pk2*f*fd*s + 160*C*D1*Dd*Pk2*f*fd - 4*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 2*C*D1*Dd*Pkdd2*f**2*k1**2*s - C*D1*Dd*Pkdd2*f**2*k1**2 + 16*C*D1*Ddd*Pk2*f**2*r**2 + 192*C*D1*Ddd*Pk2*f**2*r*s - 64*C*D1*Ddd*Pk2*f**2*r - 96*C*D1*Ddd*Pk2*f**2*s + 8*C*D1*Ddd*Pk2*f**2 + 48*C*Dd**2*Pk2*f**2*r**2 + 576*C*Dd**2*Pk2*f**2*r*s - 192*C*Dd**2*Pk2*f**2*r - 288*C*Dd**2*Pk2*f**2*s + 104*C*Dd**2*Pk2*f**2 + 48*D1**2*K*Pk2*f*fd*r*s - 24*D1**2*K*Pk2*f*fd*r + 132*D1**2*K*Pk2*f*fd*s**2 - 132*D1**2*K*Pk2*f*fd*s + 66*D1**2*K*Pk2*f*fd - 48*D1**2*K*Pk2*f*fdd*r*s + 24*D1**2*K*Pk2*f*fdd*r - 108*D1**2*K*Pk2*f*fdd*s**2 + 108*D1**2*K*Pk2*f*fdd*s - 54*D1**2*K*Pk2*f*fdd - 48*D1**2*K*Pk2*fd**2*r*s + 24*D1**2*K*Pk2*fd**2*r - 108*D1**2*K*Pk2*fd**2*s**2 + 108*D1**2*K*Pk2*fd**2*s - 12*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 12*D1**2*K*Pkdd2*f*fd*k1**2*s - 6*D1**2*K*Pkdd2*f*fd*k1**2 + 6*D1**2*K*Pkdd2*f*fdd*k1**2*s**2 - 6*D1**2*K*Pkdd2*f*fdd*k1**2*s + 3*D1**2*K*Pkdd2*f*fdd*k1**2 + 6*D1**2*K*Pkdd2*fd**2*k1**2*s**2 - 6*D1**2*K*Pkdd2*fd**2*k1**2*s + 54*D1**2*Pk2*f**2*fd*r**2 + 90*D1**2*Pk2*f**2*fd*r*s - 78*D1**2*Pk2*f**2*fd*r - 30*D1**2*Pk2*f**2*fd*s + 24*D1**2*Pk2*f**2*fd - 54*D1**2*Pk2*f**2*fdd*r**2 - 90*D1**2*Pk2*f**2*fdd*r*s + 78*D1**2*Pk2*f**2*fdd*r + 30*D1**2*Pk2*f**2*fdd*s - 24*D1**2*Pk2*f**2*fdd - 108*D1**2*Pk2*f*fd**2*r**2 - 180*D1**2*Pk2*f*fd**2*r*s + 156*D1**2*Pk2*f*fd**2*r + 60*D1**2*Pk2*f*fd**2*s - 42*D1**2*Pk2*f*fd**2 + 32*D1**2*Pk2*f*fd*r**2 + 148*D1**2*Pk2*f*fd*r*s - 98*D1**2*Pk2*f*fd*r - 32*D1**2*Pk2*f*fd*s + 4*D1**2*Pk2*f*fd - 32*D1**2*Pk2*f*fdd*r**2 - 108*D1**2*Pk2*f*fdd*r*s + 74*D1**2*Pk2*f*fdd*r + 24*D1**2*Pk2*f*fdd*s - 4*D1**2*Pk2*f*fdd - 24*D1**2*Pk2*f*gd2*r**2 + 96*D1**2*Pk2*f*gd2*r*s + 48*D1**2*Pk2*f*gd2*r - 96*D1**2*Pk2*f*gd2*s - 24*D1**2*Pk2*f*gd2 + 12*D1**2*Pk2*f*gdd2*r**2 - 48*D1**2*Pk2*f*gdd2*r*s - 24*D1**2*Pk2*f*gdd2*r + 48*D1**2*Pk2*f*gdd2*s + 12*D1**2*Pk2*f*gdd2 - 32*D1**2*Pk2*fd**2*r**2 - 108*D1**2*Pk2*fd**2*r*s + 74*D1**2*Pk2*fd**2*r + 24*D1**2*Pk2*fd**2*s - 36*D1**2*Pk2*fd**2 - 24*D1**2*Pk2*fd*g2*r**2 + 96*D1**2*Pk2*fd*g2*r*s - 96*D1**2*Pk2*fd*g2*r + 24*D1**2*Pk2*fd*gd2*r**2 - 96*D1**2*Pk2*fd*gd2*r*s + 24*D1**2*Pk2*fd*gd2*r + 48*D1**2*Pk2*fd*gd2*s - 48*D1**2*Pk2*fd*gd2 + 12*D1**2*Pk2*fdd*g2*r**2 - 48*D1**2*Pk2*fdd*g2*r*s + 48*D1**2*Pk2*fdd*g2*r + 7*D1**2*Pkdd2*bd1**2*k1**2*s*(K - 1)*(3*s - 2) - 27*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 18*D1**2*Pkdd2*f**2*fd*k1**2*s - 9*D1**2*Pkdd2*f**2*fd*k1**2 + 8*D1**2*Pkdd2*f*fd*k1**2*s**2 + 4*D1**2*Pkdd2*f*fd*k1**2*s - 2*D1**2*Pkdd2*f*fd*k1**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 7*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s**2 - 7*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 14*D1**2*Pkdd2*fd*g2*k1**2*s - 7*D1**2*Pkdd2*fd*g2*k1**2 - D1**2*bdd1*(7*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1) + 3*f**2*(4*Pk2*r + Pkdd2*k1**2*(4*s**2 - 6*s + 3)) + f*(6*Pk2*(K*(2*r**2 - 8*r*s - 2*r + 4*s + 1) - 2*r**2 + 4*r - 1) + Pkdd2*k1**2*(C + 2)*(2*s**2 - 2*s + 1))) + 96*D1*Dd*K*Pk2*f**2*r*s - 24*D1*Dd*K*Pk2*f**2*r + 264*D1*Dd*K*Pk2*f**2*s**2 - 180*D1*Dd*K*Pk2*f**2*s + 66*D1*Dd*K*Pk2*f**2 - 384*D1*Dd*K*Pk2*f*fd*r*s + 144*D1*Dd*K*Pk2*f*fd*r - 864*D1*Dd*K*Pk2*f*fd*s**2 + 744*D1*Dd*K*Pk2*f*fd*s - 156*D1*Dd*K*Pk2*f*fd - 24*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 12*D1*Dd*K*Pkdd2*f**2*k1**2*s - 6*D1*Dd*K*Pkdd2*f**2*k1**2 + 48*D1*Dd*K*Pkdd2*f*fd*k1**2*s**2 - 36*D1*Dd*K*Pkdd2*f*fd*k1**2*s + 6*D1*Dd*K*Pkdd2*f*fd*k1**2 + 72*D1*Dd*Pk2*f**3*r**2 + 120*D1*Dd*Pk2*f**3*r*s - 102*D1*Dd*Pk2*f**3*r - 60*D1*Dd*Pk2*f**3*s + 36*D1*Dd*Pk2*f**3 - 432*D1*Dd*Pk2*f**2*fd*r**2 - 720*D1*Dd*Pk2*f**2*fd*r*s + 618*D1*Dd*Pk2*f**2*fd*r + 300*D1*Dd*Pk2*f**2*fd*s - 186*D1*Dd*Pk2*f**2*fd + 64*D1*Dd*Pk2*f**2*r**2 + 296*D1*Dd*Pk2*f**2*r*s - 138*D1*Dd*Pk2*f**2*r - 148*D1*Dd*Pk2*f**2*s + 32*D1*Dd*Pk2*f**2 - 256*D1*Dd*Pk2*f*fd*r**2 - 864*D1*Dd*Pk2*f*fd*r*s + 532*D1*Dd*Pk2*f*fd*r + 312*D1*Dd*Pk2*f*fd*s - 172*D1*Dd*Pk2*f*fd - 96*D1*Dd*Pk2*f*g2*r**2 + 384*D1*Dd*Pk2*f*g2*r*s - 192*D1*Dd*Pk2*f*g2*s - 48*D1*Dd*Pk2*f*g2 + 96*D1*Dd*Pk2*f*gd2*r**2 - 384*D1*Dd*Pk2*f*gd2*r*s - 96*D1*Dd*Pk2*f*gd2*r + 288*D1*Dd*Pk2*f*gd2*s + 96*D1*Dd*Pk2*fd*g2*r**2 - 384*D1*Dd*Pk2*fd*g2*r*s + 192*D1*Dd*Pk2*fd*g2*r + 96*D1*Dd*Pk2*fd*g2*s - 96*D1*Dd*Pk2*fd*g2 - 36*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 18*D1*Dd*Pkdd2*f**3*k1**2*s - 9*D1*Dd*Pkdd2*f**3*k1**2 + 16*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 8*D1*Dd*Pkdd2*f**2*k1**2*s + 4*D1*Dd*Pkdd2*f**2*k1**2 - 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*Pkdd2*f*fd*k1**2*s - 28*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 14*D1*Dd*Pkdd2*f*g2*k1**2*s - 7*D1*Dd*Pkdd2*f*g2*k1**2 - 96*D1*Ddd*K*Pk2*f**2*r*s + 24*D1*Ddd*K*Pk2*f**2*r - 216*D1*Ddd*K*Pk2*f**2*s**2 + 156*D1*Ddd*K*Pk2*f**2*s - 54*D1*Ddd*K*Pk2*f**2 + 12*D1*Ddd*K*Pkdd2*f**2*k1**2*s**2 - 6*D1*Ddd*K*Pkdd2*f**2*k1**2*s + 3*D1*Ddd*K*Pkdd2*f**2*k1**2 - 72*D1*Ddd*Pk2*f**3*r**2 - 120*D1*Ddd*Pk2*f**3*r*s + 102*D1*Ddd*Pk2*f**3*r + 60*D1*Ddd*Pk2*f**3*s - 36*D1*Ddd*Pk2*f**3 - 64*D1*Ddd*Pk2*f**2*r**2 - 216*D1*Ddd*Pk2*f**2*r*s + 118*D1*Ddd*Pk2*f**2*r + 108*D1*Ddd*Pk2*f**2*s - 32*D1*Ddd*Pk2*f**2 + 48*D1*Ddd*Pk2*f*g2*r**2 - 192*D1*Ddd*Pk2*f*g2*r*s + 96*D1*Ddd*Pk2*f*g2*s + 24*D1*Ddd*Pk2*f*g2 - 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*D1*Ddd*Pkdd2*f**2*k1**2 + D1*bd1*(D1*(14*Pkdd2*k1**2*(g2*(2*s**2 - 2*s + 1) + gd2*s*(1 - 2*s)) + 6*f**2*(2*Pk2*r + Pkdd2*k1**2*(4*s**2 - 6*s + 3)) + f*(12*Pk2*(K*(2*r**2 - 2*r*(4*s + 1) + 4*s + 1) - 2*r**2 + 4*r - 1) + Pkdd2*k1**2*(C*(4*s**2 - 4*s + 2) + s**2*(7*K - 48*fd + 1) + s*(24*fd - 8) + 4)) + 2*fd*(-6*Pk2*(K*(2*r**2 - 8*r*s + 3*r + 2*s - 2) - 2*r**2 + 1) - Pkdd2*k1**2*s*(C + 2)*(2*s - 1))) - 2*Dd*(7*Pkdd2*g2*k1**2*(8*s**2 - 6*s + 1) + 3*f**2*(Pk2*(8*r - 4) + Pkdd2*k1**2*(16*s**2 - 16*s + 3)) + f*(24*Pk2*(2*r - 1)*(-4*K*s + r*(K - 1) + 1) + Pkdd2*k1**2*(C + 2)*(8*s**2 - 6*s + 1)))) - 288*Dd**2*K*Pk2*f**2*r*s + 72*Dd**2*K*Pk2*f**2*r - 648*Dd**2*K*Pk2*f**2*s**2 + 468*Dd**2*K*Pk2*f**2*s - 48*Dd**2*K*Pk2*f**2 + 36*Dd**2*K*Pkdd2*f**2*k1**2*s**2 - 18*Dd**2*K*Pkdd2*f**2*k1**2*s - 216*Dd**2*Pk2*f**3*r**2 - 360*Dd**2*Pk2*f**3*r*s + 306*Dd**2*Pk2*f**3*r + 180*Dd**2*Pk2*f**3*s - 96*Dd**2*Pk2*f**3 - 192*Dd**2*Pk2*f**2*r**2 - 648*Dd**2*Pk2*f**2*r*s + 354*Dd**2*Pk2*f**2*r + 324*Dd**2*Pk2*f**2*s - 140*Dd**2*Pk2*f**2 + 144*Dd**2*Pk2*f*g2*r**2 - 576*Dd**2*Pk2*f*g2*r*s + 288*Dd**2*Pk2*f*g2*s - 72*Dd**2*Pk2*f*g2 - 36*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*Dd**2*Pkdd2*f**2*k1**2*s))/(462*d**2*k3**2) + D1**2*Pk3*ct**2*(6336*C*D1**2*Pk2*bdd1*f**2*r*s + 5916*C*D1**2*Pk2*f**2*fd*r**2 + 19008*C*D1**2*Pk2*f**2*fd*r*s - 10280*C*D1**2*Pk2*f**2*fd*r + 14256*C*D1**2*Pk2*f**2*fd*s**2 - 15840*C*D1**2*Pk2*f**2*fd*s + 6724*C*D1**2*Pk2*f**2*fd - 3156*C*D1**2*Pk2*f**2*fdd*r**2 - 19008*C*D1**2*Pk2*f**2*fdd*r*s + 8440*C*D1**2*Pk2*f**2*fdd*r - 14256*C*D1**2*Pk2*f**2*fdd*s**2 + 15840*C*D1**2*Pk2*f**2*fdd*s - 5804*C*D1**2*Pk2*f**2*fdd - 6312*C*D1**2*Pk2*f*fd**2*r**2 - 38016*C*D1**2*Pk2*f*fd**2*r*s + 16880*C*D1**2*Pk2*f*fd**2*r - 28512*C*D1**2*Pk2*f*fd**2*s**2 + 31680*C*D1**2*Pk2*f*fd**2*s - 6336*C*D1**2*Pk2*f*fd**2 - 330*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 660*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 330*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 990*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 660*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 330*C*D1**2*Pkdd2*f**2*fd*k1**2 + 7888*C*D1*Dd*Pk2*f**3*r**2 + 25344*C*D1*Dd*Pk2*f**3*r*s - 14224*C*D1*Dd*Pk2*f**3*r + 19008*C*D1*Dd*Pk2*f**3*s**2 - 22176*C*D1*Dd*Pk2*f**3*s + 8696*C*D1*Dd*Pk2*f**3 - 25248*C*D1*Dd*Pk2*f**2*fd*r**2 - 152064*C*D1*Dd*Pk2*f**2*fd*r*s + 65392*C*D1*Dd*Pk2*f**2*fd*r - 114048*C*D1*Dd*Pk2*f**2*fd*s**2 + 129888*C*D1*Dd*Pk2*f**2*fd*s - 32720*C*D1*Dd*Pk2*f**2*fd - 1320*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 660*C*D1*Dd*Pkdd2*f**3*k1**2*s - 330*C*D1*Dd*Pkdd2*f**3*k1**2 - 4208*C*D1*Ddd*Pk2*f**3*r**2 - 25344*C*D1*Ddd*Pk2*f**3*r*s + 10544*C*D1*Ddd*Pk2*f**3*r - 19008*C*D1*Ddd*Pk2*f**3*s**2 + 22176*C*D1*Ddd*Pk2*f**3*s - 6856*C*D1*Ddd*Pk2*f**3 - 12624*C*Dd**2*Pk2*f**3*r**2 - 76032*C*Dd**2*Pk2*f**3*r*s + 31632*C*Dd**2*Pk2*f**3*r - 57024*C*Dd**2*Pk2*f**3*s**2 + 66528*C*Dd**2*Pk2*f**3*s - 14776*C*Dd**2*Pk2*f**3 - 462*D1**2*K*Pk2*bdd1*f**2*r**2 - 2772*D1**2*K*Pk2*bdd1*f**2*r*s + 924*D1**2*K*Pk2*bdd1*f**2*r - 2772*D1**2*K*Pk2*bdd1*f**2*s**2 + 2772*D1**2*K*Pk2*bdd1*f**2*s - 462*D1**2*K*Pk2*bdd1*f**2 + 924*D1**2*Pk2*b2*f*fd*r**2 + 5544*D1**2*Pk2*b2*f*fd*r*s - 2772*D1**2*Pk2*b2*f*fd*r + 5544*D1**2*Pk2*b2*f*fd*s**2 - 5544*D1**2*Pk2*b2*f*fd*s + 2772*D1**2*Pk2*b2*f*fd - 924*D1**2*Pk2*b2*f*fdd*r**2 - 5544*D1**2*Pk2*b2*f*fdd*r*s + 2772*D1**2*Pk2*b2*f*fdd*r - 5544*D1**2*Pk2*b2*f*fdd*s**2 + 5544*D1**2*Pk2*b2*f*fdd*s - 2772*D1**2*Pk2*b2*f*fdd - 924*D1**2*Pk2*b2*fd**2*r**2 - 5544*D1**2*Pk2*b2*fd**2*r*s + 2772*D1**2*Pk2*b2*fd**2*r - 5544*D1**2*Pk2*b2*fd**2*s**2 + 5544*D1**2*Pk2*b2*fd**2*s + 462*D1**2*Pk2*bd2*f**2*r**2 + 2772*D1**2*Pk2*bd2*f**2*r*s - 924*D1**2*Pk2*bd2*f**2*r + 2772*D1**2*Pk2*bd2*f**2*s**2 - 2772*D1**2*Pk2*bd2*f**2*s + 462*D1**2*Pk2*bd2*f**2 - 1848*D1**2*Pk2*bd2*f*fd*r**2 - 11088*D1**2*Pk2*bd2*f*fd*r*s + 4620*D1**2*Pk2*bd2*f*fd*r - 11088*D1**2*Pk2*bd2*f*fd*s**2 + 11088*D1**2*Pk2*bd2*f*fd*s - 2772*D1**2*Pk2*bd2*f*fd + 924*D1**2*Pk2*bdd1*f**2*r**2 - 3168*D1**2*Pk2*bdd1*f**2*r*s - 1584*D1**2*Pk2*bdd1*f**2*r - 5544*D1**2*Pk2*bdd1*f*g2*r*s - 462*D1**2*Pk2*bdd2*f**2*r**2 - 2772*D1**2*Pk2*bdd2*f**2*r*s + 924*D1**2*Pk2*bdd2*f**2*r - 2772*D1**2*Pk2*bdd2*f**2*s**2 + 2772*D1**2*Pk2*bdd2*f**2*s - 462*D1**2*Pk2*bdd2*f**2 - 2958*D1**2*Pk2*f**2*fd*r**2 - 9504*D1**2*Pk2*f**2*fd*r*s + 5140*D1**2*Pk2*f**2*fd*r - 7128*D1**2*Pk2*f**2*fd*s**2 + 7920*D1**2*Pk2*f**2*fd*s - 3362*D1**2*Pk2*f**2*fd + 1578*D1**2*Pk2*f**2*fdd*r**2 + 9504*D1**2*Pk2*f**2*fdd*r*s - 4220*D1**2*Pk2*f**2*fdd*r + 7128*D1**2*Pk2*f**2*fdd*s**2 - 7920*D1**2*Pk2*f**2*fdd*s + 2902*D1**2*Pk2*f**2*fdd - 924*D1**2*Pk2*f**2*gd2*r**2 - 5544*D1**2*Pk2*f**2*gd2*r*s + 1848*D1**2*Pk2*f**2*gd2*r - 5544*D1**2*Pk2*f**2*gd2*s**2 + 5544*D1**2*Pk2*f**2*gd2*s - 924*D1**2*Pk2*f**2*gd2 + 924*D1**2*Pk2*f**2*gdd2*r**2 + 5544*D1**2*Pk2*f**2*gdd2*r*s - 1848*D1**2*Pk2*f**2*gdd2*r + 5544*D1**2*Pk2*f**2*gdd2*s**2 - 5544*D1**2*Pk2*f**2*gdd2*s + 924*D1**2*Pk2*f**2*gdd2 + 3156*D1**2*Pk2*f*fd**2*r**2 + 19008*D1**2*Pk2*f*fd**2*r*s - 8440*D1**2*Pk2*f*fd**2*r + 14256*D1**2*Pk2*f*fd**2*s**2 - 15840*D1**2*Pk2*f*fd**2*s + 3168*D1**2*Pk2*f*fd**2 - 1848*D1**2*Pk2*f*fd*g2*r**2 - 11088*D1**2*Pk2*f*fd*g2*r*s + 5544*D1**2*Pk2*f*fd*g2*r - 11088*D1**2*Pk2*f*fd*g2*s**2 + 11088*D1**2*Pk2*f*fd*g2*s - 5544*D1**2*Pk2*f*fd*g2 + 3696*D1**2*Pk2*f*fd*gd2*r**2 + 22176*D1**2*Pk2*f*fd*gd2*r*s - 9240*D1**2*Pk2*f*fd*gd2*r + 22176*D1**2*Pk2*f*fd*gd2*s**2 - 22176*D1**2*Pk2*f*fd*gd2*s + 5544*D1**2*Pk2*f*fd*gd2 + 1848*D1**2*Pk2*f*fdd*g2*r**2 + 11088*D1**2*Pk2*f*fdd*g2*r*s - 5544*D1**2*Pk2*f*fdd*g2*r + 11088*D1**2*Pk2*f*fdd*g2*s**2 - 11088*D1**2*Pk2*f*fdd*g2*s + 5544*D1**2*Pk2*f*fdd*g2 + 1848*D1**2*Pk2*fd**2*g2*r**2 + 11088*D1**2*Pk2*fd**2*g2*r*s - 5544*D1**2*Pk2*fd**2*g2*r + 11088*D1**2*Pk2*fd**2*g2*s**2 - 11088*D1**2*Pk2*fd**2*g2*s - 198*D1**2*Pkdd2*b2*bdd1*f*k1**2*s**2 + 396*D1**2*Pkdd2*b2*bdd1*f*k1**2*s - 198*D1**2*Pkdd2*b2*bdd1*f*k1**2 - 396*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 + 396*D1**2*Pkdd2*b2*f*fd*k1**2*s - 198*D1**2*Pkdd2*b2*f*fd*k1**2 - 198*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 + 165*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 330*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 165*D1**2*Pkdd2*bdd1*f**2*k1**2 + 396*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 792*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 396*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 495*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 330*D1**2*Pkdd2*f**2*fd*k1**2*s + 165*D1**2*Pkdd2*f**2*fd*k1**2 + 396*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 792*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 792*D1**2*Pkdd2*f*fd*g2*k1**2*s + 396*D1**2*Pkdd2*f*fd*g2*k1**2 + 66*D1**2*bd1**2*(-6*K*Pkdd2*f*k1**2*s*(s - 1) + 7*Pk2*f**2*(4*r**2 - 5*r + 3) + Pk2*f*(-42*K*s - r**2*(4*C - 32) + 7*r*(12*K*s - 7) + 21) - 28*Pk2*g2*r**2) + 1848*D1*Dd*Pk2*b2*f**2*r**2 + 11088*D1*Dd*Pk2*b2*f**2*r*s - 4620*D1*Dd*Pk2*b2*f**2*r + 11088*D1*Dd*Pk2*b2*f**2*s**2 - 11088*D1*Dd*Pk2*b2*f**2*s + 3696*D1*Dd*Pk2*b2*f**2 - 7392*D1*Dd*Pk2*b2*f*fd*r**2 - 44352*D1*Dd*Pk2*b2*f*fd*r*s + 20328*D1*Dd*Pk2*b2*f*fd*r - 44352*D1*Dd*Pk2*b2*f*fd*s**2 + 44352*D1*Dd*Pk2*b2*f*fd*s - 11088*D1*Dd*Pk2*b2*f*fd - 3696*D1*Dd*Pk2*bd2*f**2*r**2 - 22176*D1*Dd*Pk2*bd2*f**2*r*s + 8316*D1*Dd*Pk2*bd2*f**2*r - 22176*D1*Dd*Pk2*bd2*f**2*s**2 + 22176*D1*Dd*Pk2*bd2*f**2*s - 4620*D1*Dd*Pk2*bd2*f**2 - 3944*D1*Dd*Pk2*f**3*r**2 - 12672*D1*Dd*Pk2*f**3*r*s + 7112*D1*Dd*Pk2*f**3*r - 9504*D1*Dd*Pk2*f**3*s**2 + 11088*D1*Dd*Pk2*f**3*s - 4348*D1*Dd*Pk2*f**3 + 12624*D1*Dd*Pk2*f**2*fd*r**2 + 76032*D1*Dd*Pk2*f**2*fd*r*s - 32696*D1*Dd*Pk2*f**2*fd*r + 57024*D1*Dd*Pk2*f**2*fd*s**2 - 64944*D1*Dd*Pk2*f**2*fd*s + 16360*D1*Dd*Pk2*f**2*fd - 3696*D1*Dd*Pk2*f**2*g2*r**2 - 22176*D1*Dd*Pk2*f**2*g2*r*s + 9240*D1*Dd*Pk2*f**2*g2*r - 22176*D1*Dd*Pk2*f**2*g2*s**2 + 22176*D1*Dd*Pk2*f**2*g2*s - 7392*D1*Dd*Pk2*f**2*g2 + 7392*D1*Dd*Pk2*f**2*gd2*r**2 + 44352*D1*Dd*Pk2*f**2*gd2*r*s - 16632*D1*Dd*Pk2*f**2*gd2*r + 44352*D1*Dd*Pk2*f**2*gd2*s**2 - 44352*D1*Dd*Pk2*f**2*gd2*s + 9240*D1*Dd*Pk2*f**2*gd2 + 14784*D1*Dd*Pk2*f*fd*g2*r**2 + 88704*D1*Dd*Pk2*f*fd*g2*r*s - 40656*D1*Dd*Pk2*f*fd*g2*r + 88704*D1*Dd*Pk2*f*fd*g2*s**2 - 88704*D1*Dd*Pk2*f*fd*g2*s + 22176*D1*Dd*Pk2*f*fd*g2 - 792*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 + 396*D1*Dd*Pkdd2*b2*f**2*k1**2*s - 198*D1*Dd*Pkdd2*b2*f**2*k1**2 + 660*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 330*D1*Dd*Pkdd2*f**3*k1**2*s + 165*D1*Dd*Pkdd2*f**3*k1**2 + 1584*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 792*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 396*D1*Dd*Pkdd2*f**2*g2*k1**2 - 1848*D1*Ddd*Pk2*b2*f**2*r**2 - 11088*D1*Ddd*Pk2*b2*f**2*r*s + 4620*D1*Ddd*Pk2*b2*f**2*r - 11088*D1*Ddd*Pk2*b2*f**2*s**2 + 11088*D1*Ddd*Pk2*b2*f**2*s - 3696*D1*Ddd*Pk2*b2*f**2 + 2104*D1*Ddd*Pk2*f**3*r**2 + 12672*D1*Ddd*Pk2*f**3*r*s - 5272*D1*Ddd*Pk2*f**3*r + 9504*D1*Ddd*Pk2*f**3*s**2 - 11088*D1*Ddd*Pk2*f**3*s + 3428*D1*Ddd*Pk2*f**3 + 3696*D1*Ddd*Pk2*f**2*g2*r**2 + 22176*D1*Ddd*Pk2*f**2*g2*r*s - 9240*D1*Ddd*Pk2*f**2*g2*r + 22176*D1*Ddd*Pk2*f**2*g2*s**2 - 22176*D1*Ddd*Pk2*f**2*g2*s + 7392*D1*Ddd*Pk2*f**2*g2 + 66*D1*bd1*(D1*(f**2*(7*K*Pk2*(r**2 + r*(6*s - 2) + 6*s**2 - 6*s + 1) - 3*K*Pkdd2*k1**2*s**2 + 2*Pk2*r*(r*(6*C - 23) + s*(26 - 52*C) + 13) + Pkdd2*k1**2*(10*C + 1)*(s - 1)**2) - 2*f*(7*Pk2*g2*r**2 - 42*Pk2*g2*r*s + 84*Pk2*gd2*r*s - 42*Pk2*gd2*s - 3*Pkdd2*b2*k1**2*(s - 1)**2 + 3*Pkdd2*bd2*k1**2*s**2 - 3*Pkdd2*bd2*k1**2*s + 6*Pkdd2*g2*k1**2*s**2 - 12*Pkdd2*g2*k1**2*s + 6*Pkdd2*g2*k1**2 - 6*Pkdd2*gd2*k1**2*s**2 + 6*Pkdd2*gd2*k1**2*s + fd*(7*K*Pk2*(2*r**2 + r*(12*s - 5) + 3*(1 - 2*s)**2) + 2*Pk2*(C*r*(24 - 96*s) - 14*r**2 + 48*r*s + r + s*(24*C - 12) - 6) + Pkdd2*k1**2*s*(10*C - 5)*(s - 1))) - 6*fd*(14*Pk2*g2*r*(2*s - 1) + Pkdd2*b2*k1**2*s*(s - 1) - 2*Pkdd2*g2*k1**2*s*(s - 1))) + Dd*f*(-6*Pkdd2*b2*k1**2*(4*s**2 - 5*s + 1) - f*(14*K*Pk2*(4*r**2 + 3*r*(8*s - 3) + 24*s**2 - 24*s + 5) + 8*Pk2*(-14*r**2 + r*(C*(12 - 96*s) + 48*s + 13) + s*(24*C - 12) - 6) + Pkdd2*k1**2*(10*C - 5)*(4*s**2 - 5*s + 1)) + 12*g2*(7*Pk2*(-8*r*s + r + 2*s) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 5544*Dd**2*Pk2*b2*f**2*r**2 - 33264*Dd**2*Pk2*b2*f**2*r*s + 13860*Dd**2*Pk2*b2*f**2*r - 33264*Dd**2*Pk2*b2*f**2*s**2 + 33264*Dd**2*Pk2*b2*f**2*s - 6468*Dd**2*Pk2*b2*f**2 + 6312*Dd**2*Pk2*f**3*r**2 + 38016*Dd**2*Pk2*f**3*r*s - 15816*Dd**2*Pk2*f**3*r + 28512*Dd**2*Pk2*f**3*s**2 - 33264*Dd**2*Pk2*f**3*s + 7388*Dd**2*Pk2*f**3 + 11088*Dd**2*Pk2*f**2*g2*r**2 + 66528*Dd**2*Pk2*f**2*g2*r*s - 27720*Dd**2*Pk2*f**2*g2*r + 66528*Dd**2*Pk2*f**2*g2*s**2 - 66528*Dd**2*Pk2*f**2*g2*s + 12936*Dd**2*Pk2*f**2*g2 + 66*b1**3*(3*D1**2*Pkdd2*k1**2*s**2*(2*fd - fdd) + D1*(-28*Dd*Pk2*(K - 1)*(2*r**2 - 2*r + 1) + 6*Dd*Pkdd2*k1**2*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) + 14*Ddd*Pk2*(K - 1)*(2*r**2 - 2*r + 1) - 3*Ddd*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) + 2*Dd**2*(Pk2*(7*K - 7)*(6*r**2 - 6*r + 1) + 9*Pkdd2*f*k1**2*s*(1 - 2*s))) - 66*b1**2*(38*C*D1**2*Pk2*fd*r**2 - 76*C*D1**2*Pk2*fd*r + 38*C*D1**2*Pk2*fd + 2*C*D1**2*Pk2*fdd*r**2 - 4*C*D1**2*Pk2*fdd*r + 2*C*D1**2*Pk2*fdd - 7*C*D1**2*Pkdd2*fd*k1**2*s**2 + 152*C*D1*Dd*Pk2*f*r**2 - 152*C*D1*Dd*Pk2*f*r + 76*C*D1*Dd*Pk2*f + 16*C*D1*Dd*Pk2*fd*r**2 - 24*C*D1*Dd*Pk2*fd*r + 8*C*D1*Dd*Pk2*fd - 28*C*D1*Dd*Pkdd2*f*k1**2*s**2 + 14*C*D1*Dd*Pkdd2*f*k1**2*s - 7*C*D1*Dd*Pkdd2*f*k1**2 + 8*C*D1*Ddd*Pk2*f*r**2 - 8*C*D1*Ddd*Pk2*f*r + 4*C*D1*Ddd*Pk2*f + 24*C*Dd**2*Pk2*f*r**2 - 24*C*Dd**2*Pk2*f*r + 4*C*Dd**2*Pk2*f - 7*D1**2*K*Pk2*fd*r**2 + 42*D1**2*K*Pk2*fd*r*s - 42*D1**2*K*Pk2*fd*r - 42*D1**2*K*Pk2*fdd*r*s + 42*D1**2*K*Pk2*fdd*r - 6*D1**2*K*Pkdd2*fd*k1**2*s**2 + 3*D1**2*K*Pkdd2*fdd*k1**2*s**2 + 28*D1**2*Pk2*f*fd*r**2 - 21*D1**2*Pk2*f*fd*r + 21*D1**2*Pk2*f*fd - 28*D1**2*Pk2*f*fdd*r**2 + 21*D1**2*Pk2*f*fdd*r - 21*D1**2*Pk2*f*fdd - 28*D1**2*Pk2*fd**2*r**2 + 21*D1**2*Pk2*fd**2*r + 7*D1**2*Pk2*fd**2 - 17*D1**2*Pk2*fd*r**2 + 97*D1**2*Pk2*fd*r - 38*D1**2*Pk2*fd - 16*D1**2*Pk2*fdd*r**2 - 17*D1**2*Pk2*fdd*r - 2*D1**2*Pk2*fdd - 28*D1**2*Pk2*gd2*r**2 + 56*D1**2*Pk2*gd2*r - 28*D1**2*Pk2*gd2 + 14*D1**2*Pk2*gdd2*r**2 - 28*D1**2*Pk2*gdd2*r + 14*D1**2*Pk2*gdd2 - 12*D1**2*Pkdd2*f*fd*k1**2*s**2 - 6*D1**2*Pkdd2*f*fd*k1**2*s + 3*D1**2*Pkdd2*f*fd*k1**2 + D1**2*bdd1*(Pk2*(7 - 7*K)*(3*r**2 - 2*r + 1) + 3*Pkdd2*f*k1**2*(3*s**2 - 2*s + 1)) - 28*D1*Dd*K*Pk2*f*r**2 + 168*D1*Dd*K*Pk2*f*r*s - 14*D1*Dd*K*Pk2*f*r - 84*D1*Dd*K*Pk2*f*s - 14*D1*Dd*K*Pk2*f - 336*D1*Dd*K*Pk2*fd*r*s + 210*D1*Dd*K*Pk2*fd*r + 84*D1*Dd*K*Pk2*fd*s - 84*D1*Dd*K*Pk2*fd - 24*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 12*D1*Dd*K*Pkdd2*f*k1**2*s - 6*D1*Dd*K*Pkdd2*f*k1**2 + 24*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 6*D1*Dd*K*Pkdd2*fd*k1**2*s + 56*D1*Dd*Pk2*f**2*r**2 - 56*D1*Dd*Pk2*f**2*r + 28*D1*Dd*Pk2*f**2 - 224*D1*Dd*Pk2*f*fd*r**2 + 196*D1*Dd*Pk2*f*fd*r - 42*D1*Dd*Pk2*f*fd - 68*D1*Dd*Pk2*f*r**2 + 68*D1*Dd*Pk2*f*r - 34*D1*Dd*Pk2*f - 128*D1*Dd*Pk2*fd*r**2 - 4*D1*Dd*Pk2*fd*r + 34*D1*Dd*Pk2*fd - 112*D1*Dd*Pk2*g2*r**2 + 112*D1*Dd*Pk2*g2*r - 56*D1*Dd*Pk2*g2 + 112*D1*Dd*Pk2*gd2*r**2 - 168*D1*Dd*Pk2*gd2*r + 56*D1*Dd*Pk2*gd2 - 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 12*D1*Dd*Pkdd2*f**2*k1**2*s - 6*D1*Dd*Pkdd2*f**2*k1**2 - 168*D1*Ddd*K*Pk2*f*r*s + 42*D1*Ddd*K*Pk2*f*r + 84*D1*Ddd*K*Pk2*f*s + 12*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 6*D1*Ddd*K*Pkdd2*f*k1**2*s + 3*D1*Ddd*K*Pkdd2*f*k1**2 - 56*D1*Ddd*Pk2*f**2*r**2 + 56*D1*Ddd*Pk2*f**2*r - 28*D1*Ddd*Pk2*f**2 - 64*D1*Ddd*Pk2*f*r**2 + 64*D1*Ddd*Pk2*f*r - 32*D1*Ddd*Pk2*f + 56*D1*Ddd*Pk2*g2*r**2 - 56*D1*Ddd*Pk2*g2*r + 28*D1*Ddd*Pk2*g2 + 2*D1*bd1*(7*D1*Pk2*(K - 1)*(3*r**2 - 2*r + 1) - 3*D1*Pkdd2*k1**2*(f*(3*s**2 - 2*s + 1) + fd*s*(1 - 3*s)) - 14*Dd*Pk2*(K - 1)*(6*r**2 - 5*r + 1) + 3*Dd*Pkdd2*f*k1**2*(12*s**2 - 7*s + 1)) - 504*Dd**2*K*Pk2*f*r*s + 126*Dd**2*K*Pk2*f*r + 252*Dd**2*K*Pk2*f*s - 84*Dd**2*K*Pk2*f + 36*Dd**2*K*Pkdd2*f*k1**2*s**2 - 18*Dd**2*K*Pkdd2*f*k1**2*s - 168*Dd**2*Pk2*f**2*r**2 + 168*Dd**2*Pk2*f**2*r - 28*Dd**2*Pk2*f**2 - 192*Dd**2*Pk2*f*r**2 + 192*Dd**2*Pk2*f*r - 32*Dd**2*Pk2*f + 168*Dd**2*Pk2*g2*r**2 - 168*Dd**2*Pk2*g2*r + 28*Dd**2*Pk2*g2) - 33*b1*(-48*C*D1**2*Pk2*f*fd*r**2 + 416*C*D1**2*Pk2*f*fd*r*s - 160*C*D1**2*Pk2*f*fd*r - 208*C*D1**2*Pk2*f*fd*s - 24*C*D1**2*Pk2*f*fd - 384*C*D1**2*Pk2*f*fdd*r*s + 192*C*D1**2*Pk2*f*fdd*r + 192*C*D1**2*Pk2*f*fdd*s - 384*C*D1**2*Pk2*fd**2*r*s + 192*C*D1**2*Pk2*fd**2*r + 192*C*D1**2*Pk2*fd**2*s - 192*C*D1**2*Pk2*fd**2 - 40*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 20*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 20*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 96*C*D1*Dd*Pk2*f**2*r**2 + 832*C*D1*Dd*Pk2*f**2*r*s - 112*C*D1*Dd*Pk2*f**2*r - 416*C*D1*Dd*Pk2*f**2*s - 48*C*D1*Dd*Pk2*f**2 - 3072*C*D1*Dd*Pk2*f*fd*r*s + 1152*C*D1*Dd*Pk2*f*fd*r + 1536*C*D1*Dd*Pk2*f*fd*s - 576*C*D1*Dd*Pk2*f*fd - 80*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 40*C*D1*Dd*Pkdd2*f**2*k1**2*s - 20*C*D1*Dd*Pkdd2*f**2*k1**2 + 160*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 40*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 768*C*D1*Ddd*Pk2*f**2*r*s + 192*C*D1*Ddd*Pk2*f**2*r + 384*C*D1*Ddd*Pk2*f**2*s + 40*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 20*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 10*C*D1*Ddd*Pkdd2*f**2*k1**2 - 2304*C*Dd**2*Pk2*f**2*r*s + 576*C*Dd**2*Pk2*f**2*r + 1152*C*Dd**2*Pk2*f**2*s - 384*C*Dd**2*Pk2*f**2 + 120*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 60*C*Dd**2*Pkdd2*f**2*k1**2*s - 28*D1**2*K*Pk2*f*fd*r**2 - 168*D1**2*K*Pk2*f*fd*r*s + 84*D1**2*K*Pk2*f*fd*r - 168*D1**2*K*Pk2*f*fd*s**2 + 168*D1**2*K*Pk2*f*fd*s - 84*D1**2*K*Pk2*f*fd + 28*D1**2*K*Pk2*f*fdd*r**2 + 168*D1**2*K*Pk2*f*fdd*r*s - 84*D1**2*K*Pk2*f*fdd*r + 168*D1**2*K*Pk2*f*fdd*s**2 - 168*D1**2*K*Pk2*f*fdd*s + 84*D1**2*K*Pk2*f*fdd + 28*D1**2*K*Pk2*fd**2*r**2 + 168*D1**2*K*Pk2*fd**2*r*s - 84*D1**2*K*Pk2*fd**2*r + 168*D1**2*K*Pk2*fd**2*s**2 - 168*D1**2*K*Pk2*fd**2*s + 12*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 12*D1**2*K*Pkdd2*f*fd*k1**2*s + 6*D1**2*K*Pkdd2*f*fd*k1**2 + 184*D1**2*Pk2*f*fd*r**2 - 208*D1**2*Pk2*f*fd*r*s - 28*D1**2*Pk2*f*fd*r + 104*D1**2*Pk2*f*fd*s + 92*D1**2*Pk2*f*fd - 56*D1**2*Pk2*f*fdd*r**2 + 192*D1**2*Pk2*f*fdd*r*s - 88*D1**2*Pk2*f*fdd*r - 96*D1**2*Pk2*f*fdd*s - 28*D1**2*Pk2*f*fdd + 28*D1**2*Pk2*f*gd2*r**2 - 168*D1**2*Pk2*f*gd2*r*s - 56*D1**2*Pk2*f*gd2*r + 168*D1**2*Pk2*f*gd2*s + 28*D1**2*Pk2*f*gd2 + 168*D1**2*Pk2*f*gdd2*r*s - 168*D1**2*Pk2*f*gdd2*s - 56*D1**2*Pk2*fd**2*r**2 + 192*D1**2*Pk2*fd**2*r*s - 88*D1**2*Pk2*fd**2*r - 96*D1**2*Pk2*fd**2*s + 144*D1**2*Pk2*fd**2 + 28*D1**2*Pk2*fd*g2*r**2 - 168*D1**2*Pk2*fd*g2*r*s + 168*D1**2*Pk2*fd*g2*r + 336*D1**2*Pk2*fd*gd2*r*s - 168*D1**2*Pk2*fd*gd2*r - 168*D1**2*Pk2*fd*gd2*s + 168*D1**2*Pk2*fd*gd2 + 168*D1**2*Pk2*fdd*g2*r*s - 168*D1**2*Pk2*fdd*g2*r - 12*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 6*D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 12*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 12*D1**2*Pkdd2*bd2*fd*k1**2*s**2 + 6*D1**2*Pkdd2*bdd2*f*k1**2*s**2 - 4*D1**2*Pkdd2*f*fd*k1**2*s**2 - 10*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 24*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 12*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 10*D1**2*Pkdd2*fd**2*k1**2*s**2 + 24*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 24*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 12*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 4*D1**2*bd1**2*(Pk2*r*(7*K - 7)*(3*r - 2) + 3*Pkdd2*f*k1**2*s*(2 - 3*s)) - 2*D1**2*bdd1*(-3*K*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + 7*Pk2*f**2*(4*r**2 - 5*r + 1) + Pk2*f*(-42*K*s - r**2*(4*C - 32) + 7*r*(12*K*s - 7) + 14) - 28*Pk2*g2*r**2) - 56*D1*Dd*K*Pk2*f**2*r**2 - 336*D1*Dd*K*Pk2*f**2*r*s + 140*D1*Dd*K*Pk2*f**2*r - 336*D1*Dd*K*Pk2*f**2*s**2 + 336*D1*Dd*K*Pk2*f**2*s - 112*D1*Dd*K*Pk2*f**2 + 224*D1*Dd*K*Pk2*f*fd*r**2 + 1344*D1*Dd*K*Pk2*f*fd*r*s - 616*D1*Dd*K*Pk2*f*fd*r + 1344*D1*Dd*K*Pk2*f*fd*s**2 - 1344*D1*Dd*K*Pk2*f*fd*s + 336*D1*Dd*K*Pk2*f*fd + 24*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 12*D1*Dd*K*Pkdd2*f**2*k1**2*s + 6*D1*Dd*K*Pkdd2*f**2*k1**2 + 368*D1*Dd*Pk2*f**2*r**2 - 416*D1*Dd*Pk2*f**2*r*s - 264*D1*Dd*Pk2*f**2*r + 208*D1*Dd*Pk2*f**2*s + 184*D1*Dd*Pk2*f**2 - 448*D1*Dd*Pk2*f*fd*r**2 + 1536*D1*Dd*Pk2*f*fd*r*s - 320*D1*Dd*Pk2*f*fd*r - 768*D1*Dd*Pk2*f*fd*s + 272*D1*Dd*Pk2*f*fd + 112*D1*Dd*Pk2*f*g2*r**2 - 672*D1*Dd*Pk2*f*g2*r*s + 56*D1*Dd*Pk2*f*g2*r + 336*D1*Dd*Pk2*f*g2*s + 56*D1*Dd*Pk2*f*g2 + 1344*D1*Dd*Pk2*f*gd2*r*s - 168*D1*Dd*Pk2*f*gd2*r - 1008*D1*Dd*Pk2*f*gd2*s + 168*D1*Dd*Pk2*f*gd2 + 1344*D1*Dd*Pk2*fd*g2*r*s - 840*D1*Dd*Pk2*fd*g2*r - 336*D1*Dd*Pk2*fd*g2*s + 336*D1*Dd*Pk2*fd*g2 - 48*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 24*D1*Dd*Pkdd2*b2*f*k1**2*s - 12*D1*Dd*Pkdd2*b2*f*k1**2 + 48*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 12*D1*Dd*Pkdd2*b2*fd*k1**2*s + 48*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 12*D1*Dd*Pkdd2*bd2*f*k1**2*s - 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 4*D1*Dd*Pkdd2*f**2*k1**2*s - 2*D1*Dd*Pkdd2*f**2*k1**2 - 80*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 20*D1*Dd*Pkdd2*f*fd*k1**2*s + 96*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 48*D1*Dd*Pkdd2*f*g2*k1**2*s + 24*D1*Dd*Pkdd2*f*g2*k1**2 - 96*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 24*D1*Dd*Pkdd2*f*gd2*k1**2*s - 96*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 24*D1*Dd*Pkdd2*fd*g2*k1**2*s + 56*D1*Ddd*K*Pk2*f**2*r**2 + 336*D1*Ddd*K*Pk2*f**2*r*s - 140*D1*Ddd*K*Pk2*f**2*r + 336*D1*Ddd*K*Pk2*f**2*s**2 - 336*D1*Ddd*K*Pk2*f**2*s + 112*D1*Ddd*K*Pk2*f**2 - 112*D1*Ddd*Pk2*f**2*r**2 + 384*D1*Ddd*Pk2*f**2*r*s + 16*D1*Ddd*Pk2*f**2*r - 192*D1*Ddd*Pk2*f**2*s - 56*D1*Ddd*Pk2*f**2 + 672*D1*Ddd*Pk2*f*g2*r*s - 168*D1*Ddd*Pk2*f*g2*r - 336*D1*Ddd*Pk2*f*g2*s + 24*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 12*D1*Ddd*Pkdd2*b2*f*k1**2*s + 6*D1*Ddd*Pkdd2*b2*f*k1**2 - 20*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 10*D1*Ddd*Pkdd2*f**2*k1**2*s - 5*D1*Ddd*Pkdd2*f**2*k1**2 - 48*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 24*D1*Ddd*Pkdd2*f*g2*k1**2*s - 12*D1*Ddd*Pkdd2*f*g2*k1**2 + 2*D1*bd1*(D1*(6*K*Pkdd2*fd*k1**2*s*(2*s - 1) + Pk2*fd*(-42*K*(r*(4*s - 2) - s + 1) + r**2*(8*C - 64) + r*(15 - 8*C) + 21) - 56*Pk2*r*(g2*r - gd2*r + gd2) + f**2*(7*Pk2*(4*r**2 - 5*r + 1) - 3*Pkdd2*k1**2*(4*s**2 - 6*s + 3)) - f*(Pk2*(-76*C*r**2 + 7*K*(2*r**2 - 2*r*(6*s + 1) + 6*s + 1) + 14*fd*(8*r**2 - 8*r + 1) + 34*r**2 + 63*r - 21) + Pkdd2*k1**2*(7*C + 6*K)*(2*s**2 - 2*s + 1))) - 2*Dd*(-3*K*Pkdd2*f*k1**2*(8*s**2 - 6*s + 1) + 7*Pk2*f**2*(16*r**2 - 18*r + 5) + Pk2*f*(2*r - 1)*(21*K*(8*s - 1) - r*(8*C - 64) - 49) + 56*Pk2*g2*r*(1 - 2*r))) + 168*Dd**2*K*Pk2*f**2*r**2 + 1008*Dd**2*K*Pk2*f**2*r*s - 420*Dd**2*K*Pk2*f**2*r + 1008*Dd**2*K*Pk2*f**2*s**2 - 1008*Dd**2*K*Pk2*f**2*s + 196*Dd**2*K*Pk2*f**2 - 336*Dd**2*Pk2*f**2*r**2 + 1152*Dd**2*Pk2*f**2*r*s + 48*Dd**2*Pk2*f**2*r - 576*Dd**2*Pk2*f**2*s + 136*Dd**2*Pk2*f**2 + 2016*Dd**2*Pk2*f*g2*r*s - 504*Dd**2*Pk2*f*g2*r - 1008*Dd**2*Pk2*f*g2*s + 336*Dd**2*Pk2*f*g2 + 72*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 36*Dd**2*Pkdd2*b2*f*k1**2*s - 60*Dd**2*Pkdd2*f**2*k1**2*s**2 + 30*Dd**2*Pkdd2*f**2*k1**2*s - 144*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 72*Dd**2*Pkdd2*f*g2*k1**2*s))/(693*d**2*k3**2) + D1**2*Pk3*ct**2*k2**4*st**2*(D1**2*(-33*Pkdd2*k1**2*s*(b1*s*(fd**2*(2 - 4*C) + fd*(2*K*b1 - 4*g2 + 4*gd2) + fdd*(-K*b1 + 2*g2)) + 2*bd1*fd*(K*b1*(1 - 2*s) + 2*g2*(s - 1))) + f**2*(Pk2*fdd*(64 - 128*C)*(3*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(bd1*(4*C*(s - 1)**2 - s**2*(K + 2) + 4*s - 2) - bdd1*(2*C - 1)*(s - 1)**2 + 2*gd2*s**2) - fd*(2*C - 1)*(4*Pk2*(3*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + f*(-768*C*Pk2*fd**2*r**2 + 512*C*Pk2*fd**2*r - 264*C*Pkdd2*b1*fd*k1**2*s**2 + 132*C*Pkdd2*b1*fdd*k1**2*s**2 + 66*K*Pkdd2*b1*fd*k1**2*s**2 - 66*K*Pkdd2*b1*fd*k1**2*s + 33*K*Pkdd2*b1*fd*k1**2 + 66*K*Pkdd2*bd1**2*k1**2*s*(s - 1) + 384*Pk2*fd**2*r**2 - 256*Pk2*fd**2*r + 132*Pkdd2*b1*fd*k1**2*s**2 - 66*Pkdd2*b1*fdd*k1**2*s**2 + 132*Pkdd2*b1*gd2*k1**2*s**2 - 66*Pkdd2*b1*gdd2*k1**2*s**2 + 66*Pkdd2*bd1*k1**2*(-K*b1*(2*s**2 - 2*s + 1) + 2*g2*(s - 1)**2 + s*(s - 1)*(4*C*fd - 2*fd - 2*gd2)) - 33*Pkdd2*bdd1*k1**2*(K*b1*(-2*s**2 + 2*s - 1) + 2*g2*(s - 1)**2) - 132*Pkdd2*fd*g2*k1**2*s**2 + 132*Pkdd2*fd*g2*k1**2*s - 66*Pkdd2*fd*g2*k1**2)) + D1*(Dd*(66*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(K*b1 - 2*g2) - 66*Pkdd2*f*k1**2*(K*b1**2*(4*s**2 - 2*s + 1) - b1*(g2*(8*s**2 - 4*s + 2) + (4*s - 1)*(K*bd1*(2*s - 1) + fd*s*(4*C - 2) - 2*gd2*s)) + 2*bd1*g2*(4*s**2 - 5*s + 1)) - f**3*(2*C - 1)*(8*Pk2*(2*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(Pk2*fd*(256 - 512*C)*(6*r**2 - 5*r + 1) - 33*Pkdd2*k1**2*(b1*(4*C - K - 2)*(4*s**2 - 2*s + 1) - 2*bd1*(2*C - 1)*(4*s**2 - 5*s + 1) + 2*g2*(4*s**2 - 2*s + 1)))) + Ddd*f*(Pk2*f**2*(128 - 256*C)*(2*r**2 - 2*r + 1) + 33*Pkdd2*b1*f*k1**2*(2*C - 1)*(4*s**2 - 2*s + 1) + 33*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*f**2*(64 - 128*C)*(6*r**2 - 6*r + 1) + 99*Pkdd2*b1*f*k1**2*s*(2*C - 1)*(2*s - 1) + 99*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2)))/(231*d**2*k1**2*k3**4) + D1**2*Pk3*ct**2*k2**4*(7*D1*K*Pkdd2*b1**2*k1**2*(D1*fd*s**2 + Dd*f*(4*s**2 - 2*s + 1)) + 2*D1*f*(3*D1*Pk2*bdd1*f*r**2*(1 - 2*C) + D1*bd1*(Pk2*fd*r*(6 - 12*C)*(2*r - 1) - 7*Pkdd2*g2*k1**2*(s - 1)**2 + f*(2*C - 1)*(-5*Pk2*r**2 + 3*Pkdd2*k1**2*(s - 1)**2)) - 12*Dd*Pk2*bd1*f*r*(2*C - 1)*(2*r - 1)) - b1*(D1**2*(f*(Pk2*fdd*(12*C - 6)*(2*r**2 - 2*r + 1) - 7*Pkdd2*k1**2*(K*bd1*(2*s**2 - 2*s + 1) - 2*gd2*s**2) + fd*(4*C - 2)*(5*Pk2*(2*r**2 - 2*r + 1) - 6*Pkdd2*k1**2*s**2)) + 2*fd*(Pk2*fd*r*(12*C - 6)*(r - 1) + 7*Pkdd2*g2*k1**2*s**2)) + 2*D1*f*(Dd*(Pk2*fd*(1 - 2*r)**2*(24*C - 12) + 7*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + f*(2*C - 1)*(10*Pk2*(2*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(12*C - 6)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f**2*(24*C - 12)*(6*r**2 - 6*r + 1)))/(21*d**2*k1**2*k3**4) + D1**2*Pk3*ct**2*k2**2*st**2*(D1**2*(33*Pkdd2*k1**2*(K*b1**2*(2*fd - fdd)*(2*s - 1) - b1*(b2*fdd*s**2 + fd**2*s*(4*C - 2) + 4*fd*g2*(2*s - 1) + 2*fd*s*(K*bd1 - b2*s + bd2*s - 2*gd2) + fdd*g2*(2 - 4*s)) - 2*b2*bd1*fd*s*(s - 1)) + f**2*(Pk2*fdd*(128*C - 64)*(3*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(bd1*(C*(8*s - 4) + K*s**2 - 4*s + 2) + bdd1*(-4*C*s + 2*C + 2*s - 1) + s**2*(bd2 - 2*gd2)) + fd*(2*C - 1)*(4*Pk2*(3*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + f*(66*K*Pkdd2*bd1**2*k1**2*s + 33*Pkdd2*b1*k1**2*(-4*K*bd1*s + 2*K*bd1 + 2*K*bdd1*s - K*bdd1 + 2*bd2*s**2 - bdd2*s**2 - fd*(C*(4 - 8*s) + 2*K*s**2 - 2*K*s + K + 4*s - 2) + fdd*(-4*C*s + 2*C + 2*s - 1)) - 33*Pkdd2*b2*k1**2*(-2*bd1*(s - 1)**2 + bdd1*(s - 1)**2 + fd*(2*s**2 - 2*s + 1)) + 66*Pkdd2*bd1*k1**2*(g2*(4*s - 2) - s*(-2*C*fd + bd2*(s - 1) + fd + 2*gd2)) + 66*Pkdd2*bdd1*g2*k1**2*(1 - 2*s) + 2*fd*(Pk2*fd*r*(128*C - 64)*(3*r - 2) + 33*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1)))) + D1*(Dd*(-66*Pkdd2*b1*fd*k1**2*(4*s - 1)*(K*b1 + b2*s - 2*g2) + 66*Pkdd2*f*k1**2*(b1*(b2*(4*s**2 - 2*s + 1) - (4*s - 1)*(2*C*fd - K*bd1 + bd2*s - fd)) - bd1*(4*s - 1)*(b2*(s - 1) + 2*g2)) + f**3*(2*C - 1)*(8*Pk2*(2*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f**2*(Pk2*fd*(512*C - 256)*(6*r**2 - 5*r + 1) - 33*Pkdd2*k1**2*(b2*(4*s**2 - 2*s + 1) - 2*bd1*(2*C - 1)*(4*s - 1) - (-K*b1 + 2*g2)*(4*s**2 - 2*s + 1)))) + Ddd*f*(Pk2*f**2*(256*C - 128)*(2*r**2 - 2*r + 1) - 33*Pkdd2*b1*b2*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(Pk2*f**2*(64 - 128*C)*(6*r**2 - 6*r + 1) + 99*Pkdd2*b1*b2*k1**2*s*(2*s - 1)))/(231*d**2*k1**2*k3**2) + D1**2*Pk3*ct**2*(D1*(6*D1*Pk2*bdd1*f**2*r**2*(2*C - 1) - 2*D1*Pkdd2*bd1**2*k1**2*s*(s - 1)*(12*C*f + 7*b2 - 6*f - 14*g2) + bd1*f*(D1*(Pk2*fd*r*(24*C - 12)*(2*r - 1) - Pkdd2*k1**2*s**2*(7*b2 - 14*g2) + f*(4*C - 2)*(5*Pk2*r**2 - 3*Pkdd2*k1**2*s**2)) + Dd*Pk2*f*r*(48*C - 24)*(2*r - 1))) + 7*K*Pkdd2*b1**3*k1**2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + Pkdd2*b1**2*k1**2*(D1**2*(24*C*fd*s**2 - 12*C*fdd*s**2 + 14*K*bd1*(3*s**2 - 2*s + 1) - 7*K*bdd1*(3*s**2 - 2*s + 1) - 7*K*fd*s**2 + 14*K*fd*s - 7*K*fd + 14*bd2*s**2 - 7*bdd2*s**2 - 12*fd*s**2 + 6*fdd*s**2 - 28*gd2*s**2 + 14*gdd2*s**2) + D1*(Dd*(f*(24*C - 7*K - 12)*(4*s**2 - 2*s + 1) - 28*g2*(4*s**2 - 2*s + 1) - (8*s - 2)*(7*K*bd1*(3*s - 1) + s*(12*C*fd + 7*bd2 - 6*fd - 14*gd2))) - 2*Ddd*(f*(6*C - 3) - 7*g2)*(4*s**2 - 2*s + 1)) - 12*Dd**2*s*(2*s - 1)*(f*(6*C - 3) - 7*g2) + 7*b2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s))) + b1*(D1**2*(-14*K*Pkdd2*bd1**2*k1**2*s*(3*s - 2) - 7*Pkdd2*b2*k1**2*(bd1*(-4*s**2 + 4*s - 2) + bdd1*(2*s**2 - 2*s + 1) + fd*(s - 1)**2) - 2*Pkdd2*bd1*k1**2*(14*g2*(2*s**2 - 2*s + 1) + s*(2*s - 1)*(12*C*fd + 7*bd2 - 6*fd - 14*gd2)) + 14*Pkdd2*bdd1*g2*k1**2*(2*s**2 - 2*s + 1) + f*(Pk2*fdd*(12*C - 6)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(2*bd1*(12*C*(2*s**2 - 2*s + 1) - s**2*(7*K + 12) + 12*s - 6) - 6*bdd1*(2*C - 1)*(2*s**2 - 2*s + 1) + s**2*(-7*bd2 + 14*gd2)) + fd*(4*C - 2)*(5*Pk2*(2*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 2*fd*(6*Pk2*fd*r*(-2*C*(r - 1) + r - 1) - 7*Pkdd2*g2*k1**2*(s - 1)**2)) + D1*(Dd*(-14*Pkdd2*bd1*k1**2*(b2 - 2*g2)*(8*s**2 - 6*s + 1) + f**2*(4*C - 2)*(10*Pk2*(2*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(Pk2*fd*(1 - 2*r)**2*(48*C - 24) + Pkdd2*k1**2*(-7*b2*(4*s**2 - 2*s + 1) - 12*bd1*(2*C - 1)*(8*s**2 - 6*s + 1) + 14*g2*(4*s**2 - 2*s + 1)))) + Ddd*Pk2*f**2*(24*C - 12)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f**2*(24*C - 12)*(6*r**2 - 6*r + 1)))/(21*d**2*k1**2) - 2*D1**2*Pk3*ct*f*k1**3*st**4*(-1248*C*D1**2*Pk2*f*fd*r*s + 416*C*D1**2*Pk2*f*fd*r - 1248*C*D1**2*Pk2*f*fd*s**2 + 1248*C*D1**2*Pk2*f*fd*s - 416*C*D1**2*Pk2*f*fd + 624*C*D1**2*Pk2*f*fdd*r*s - 208*C*D1**2*Pk2*f*fdd*r + 624*C*D1**2*Pk2*f*fdd*s**2 - 624*C*D1**2*Pk2*f*fdd*s + 208*C*D1**2*Pk2*f*fdd + 1248*C*D1**2*Pk2*fd**2*r*s - 416*C*D1**2*Pk2*fd**2*r + 1248*C*D1**2*Pk2*fd**2*s**2 - 1248*C*D1**2*Pk2*fd**2*s + 208*C*D1**2*Pk2*fd**2 - 1664*C*D1*Dd*Pk2*f**2*r*s + 416*C*D1*Dd*Pk2*f**2*r - 1664*C*D1*Dd*Pk2*f**2*s**2 + 1664*C*D1*Dd*Pk2*f**2*s - 416*C*D1*Dd*Pk2*f**2 + 4992*C*D1*Dd*Pk2*f*fd*r*s - 1456*C*D1*Dd*Pk2*f*fd*r + 4992*C*D1*Dd*Pk2*f*fd*s**2 - 4992*C*D1*Dd*Pk2*f*fd*s + 1040*C*D1*Dd*Pk2*f*fd + 832*C*D1*Ddd*Pk2*f**2*r*s - 208*C*D1*Ddd*Pk2*f**2*r + 832*C*D1*Ddd*Pk2*f**2*s**2 - 832*C*D1*Ddd*Pk2*f**2*s + 208*C*D1*Ddd*Pk2*f**2 + 2496*C*Dd**2*Pk2*f**2*r*s - 624*C*Dd**2*Pk2*f**2*r + 2496*C*Dd**2*Pk2*f**2*s**2 - 2496*C*Dd**2*Pk2*f**2*s + 416*C*Dd**2*Pk2*f**2 + 15600*D1**2*Pk2*b1*f*fd*r*s - 5200*D1**2*Pk2*b1*f*fd*r + 15600*D1**2*Pk2*b1*f*fd*s**2 - 14560*D1**2*Pk2*b1*f*fd*s + 3640*D1**2*Pk2*b1*f*fd - 7800*D1**2*Pk2*b1*f*fdd*r*s + 2600*D1**2*Pk2*b1*f*fdd*r - 7800*D1**2*Pk2*b1*f*fdd*s**2 + 7280*D1**2*Pk2*b1*f*fdd*s - 1820*D1**2*Pk2*b1*f*fdd - 15600*D1**2*Pk2*b1*fd**2*r*s + 5200*D1**2*Pk2*b1*fd**2*r - 15600*D1**2*Pk2*b1*fd**2*s**2 + 14560*D1**2*Pk2*b1*fd**2*s - 3640*D1**2*Pk2*b1*fd**2 - 260*D1**2*Pk2*bdd1*f**2*(10*s**2 + s*(10*r - 12) + 3) - 12480*D1**2*Pk2*f**2*fd*r*s + 3120*D1**2*Pk2*f**2*fd*r - 23400*D1**2*Pk2*f**2*fd*s**2 + 17940*D1**2*Pk2*f**2*fd*s - 5850*D1**2*Pk2*f**2*fd + 12480*D1**2*Pk2*f**2*fdd*r*s - 3120*D1**2*Pk2*f**2*fdd*r + 17160*D1**2*Pk2*f**2*fdd*s**2 - 14820*D1**2*Pk2*f**2*fdd*s + 4290*D1**2*Pk2*f**2*fdd + 37440*D1**2*Pk2*f*fd**2*r*s - 9360*D1**2*Pk2*f*fd**2*r + 51480*D1**2*Pk2*f*fd**2*s**2 - 44460*D1**2*Pk2*f*fd**2*s + 6240*D1**2*Pk2*f*fd**2 + 3120*D1**2*Pk2*f*fd*r*s - 1040*D1**2*Pk2*f*fd*r + 3432*D1**2*Pk2*f*fd*s**2 - 3328*D1**2*Pk2*f*fd*s + 1144*D1**2*Pk2*f*fd - 1560*D1**2*Pk2*f*fdd*r*s + 520*D1**2*Pk2*f*fdd*r - 1716*D1**2*Pk2*f*fdd*s**2 + 1664*D1**2*Pk2*f*fdd*s - 572*D1**2*Pk2*f*fdd - 3120*D1**2*Pk2*fd**2*r*s + 1040*D1**2*Pk2*fd**2*r - 3432*D1**2*Pk2*fd**2*s**2 + 3328*D1**2*Pk2*fd**2*s - 520*D1**2*Pk2*fd**2 + 200*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 100*D1**2*Pkdd2*f**2*fd*k1**2*s + 50*D1**2*Pkdd2*f**2*fd*k1**2 - 100*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 50*D1**2*Pkdd2*f**2*fdd*k1**2*s - 25*D1**2*Pkdd2*f**2*fdd*k1**2 - 300*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 150*D1**2*Pkdd2*f*fd**2*k1**2*s + 20800*D1*Dd*Pk2*b1*f**2*r*s - 5200*D1*Dd*Pk2*b1*f**2*r + 20800*D1*Dd*Pk2*b1*f**2*s**2 - 20800*D1*Dd*Pk2*b1*f**2*s + 5200*D1*Dd*Pk2*b1*f**2 - 62400*D1*Dd*Pk2*b1*f*fd*r*s + 18200*D1*Dd*Pk2*b1*f*fd*r - 62400*D1*Dd*Pk2*b1*f*fd*s**2 + 60320*D1*Dd*Pk2*b1*f*fd*s - 12480*D1*Dd*Pk2*b1*f*fd - 12480*D1*Dd*Pk2*f**3*r*s + 3120*D1*Dd*Pk2*f**3*r - 23400*D1*Dd*Pk2*f**3*s**2 + 17940*D1*Dd*Pk2*f**3*s - 5850*D1*Dd*Pk2*f**3 + 99840*D1*Dd*Pk2*f**2*fd*r*s - 24960*D1*Dd*Pk2*f**2*fd*r + 137280*D1*Dd*Pk2*f**2*fd*s**2 - 118560*D1*Dd*Pk2*f**2*fd*s + 21060*D1*Dd*Pk2*f**2*fd + 4160*D1*Dd*Pk2*f**2*r*s - 1040*D1*Dd*Pk2*f**2*r + 4576*D1*Dd*Pk2*f**2*s**2 - 4368*D1*Dd*Pk2*f**2*s + 1144*D1*Dd*Pk2*f**2 - 12480*D1*Dd*Pk2*f*fd*r*s + 3640*D1*Dd*Pk2*f*fd*r - 13728*D1*Dd*Pk2*f*fd*s**2 + 13208*D1*Dd*Pk2*f*fd*s - 2704*D1*Dd*Pk2*f*fd + 200*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 100*D1*Dd*Pkdd2*f**3*k1**2*s + 50*D1*Dd*Pkdd2*f**3*k1**2 - 800*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 400*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 50*D1*Dd*Pkdd2*f**2*fd*k1**2 - 10400*D1*Ddd*Pk2*b1*f**2*r*s + 2600*D1*Ddd*Pk2*b1*f**2*r - 10400*D1*Ddd*Pk2*b1*f**2*s**2 + 10400*D1*Ddd*Pk2*b1*f**2*s - 2600*D1*Ddd*Pk2*b1*f**2 + 12480*D1*Ddd*Pk2*f**3*r*s - 3120*D1*Ddd*Pk2*f**3*r + 17160*D1*Ddd*Pk2*f**3*s**2 - 14820*D1*Ddd*Pk2*f**3*s + 4290*D1*Ddd*Pk2*f**3 - 2080*D1*Ddd*Pk2*f**2*r*s + 520*D1*Ddd*Pk2*f**2*r - 2288*D1*Ddd*Pk2*f**2*s**2 + 2184*D1*Ddd*Pk2*f**2*s - 572*D1*Ddd*Pk2*f**2 - 100*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 50*D1*Ddd*Pkdd2*f**3*k1**2*s - 25*D1*Ddd*Pkdd2*f**3*k1**2 + 520*D1*Pk2*bd1*f*(D1*(f*(10*s**2 + s*(10*r - 12) + 3) + fd*(r*(5 - 30*s) - 30*s**2 + 32*s - 3)) + Dd*f*(r*(5 - 40*s) - 40*s**2 + 44*s - 6)) - 31200*Dd**2*Pk2*b1*f**2*r*s + 7800*Dd**2*Pk2*b1*f**2*r - 31200*Dd**2*Pk2*b1*f**2*s**2 + 31200*Dd**2*Pk2*b1*f**2*s - 5200*Dd**2*Pk2*b1*f**2 + 37440*Dd**2*Pk2*f**3*r*s - 9360*Dd**2*Pk2*f**3*r + 51480*Dd**2*Pk2*f**3*s**2 - 44460*Dd**2*Pk2*f**3*s + 6240*Dd**2*Pk2*f**3 - 6240*Dd**2*Pk2*f**2*r*s + 1560*Dd**2*Pk2*f**2*r - 6864*Dd**2*Pk2*f**2*s**2 + 6552*Dd**2*Pk2*f**2*s - 1040*Dd**2*Pk2*f**2 - 300*Dd**2*Pkdd2*f**3*k1**2*s**2 + 150*Dd**2*Pkdd2*f**3*k1**2*s)/(3003*d**2*k2*k3**4) - D1**2*Pk3*ct*k1**3*st**2*(1056*C*D1**2*Pk2*bdd1*f**2*r*s - 528*C*D1**2*Pk2*bdd1*f**2*r + 1584*C*D1**2*Pk2*bdd1*f**2*s**2 - 2112*C*D1**2*Pk2*bdd1*f**2*s + 1056*C*D1**2*Pk2*bdd1*f**2 + 3504*C*D1**2*Pk2*f**2*fd*r*s - 1168*C*D1**2*Pk2*f**2*fd*r - 10800*C*D1**2*Pk2*f**2*fd*s**2 + 6032*C*D1**2*Pk2*f**2*fd*s - 3600*C*D1**2*Pk2*f**2*fd - 2544*C*D1**2*Pk2*f**2*fdd*r*s + 848*C*D1**2*Pk2*f**2*fdd*r + 4608*C*D1**2*Pk2*f**2*fdd*s**2 - 2224*C*D1**2*Pk2*f**2*fdd*s + 1536*C*D1**2*Pk2*f**2*fdd - 5088*C*D1**2*Pk2*f*fd**2*r*s + 1696*C*D1**2*Pk2*f*fd**2*r + 9216*C*D1**2*Pk2*f*fd**2*s**2 - 4448*C*D1**2*Pk2*f*fd**2*s - 848*C*D1**2*Pk2*f*fd**2 + 4672*C*D1*Dd*Pk2*f**3*r*s - 1168*C*D1*Dd*Pk2*f**3*r - 14400*C*D1*Dd*Pk2*f**3*s**2 + 4864*C*D1*Dd*Pk2*f**3*s - 3600*C*D1*Dd*Pk2*f**3 - 20352*C*D1*Dd*Pk2*f**2*fd*r*s + 5936*C*D1*Dd*Pk2*f**2*fd*r + 36864*C*D1*Dd*Pk2*f**2*fd*s**2 - 13024*C*D1*Dd*Pk2*f**2*fd*s + 528*C*D1*Dd*Pk2*f**2*fd - 3392*C*D1*Ddd*Pk2*f**3*r*s + 848*C*D1*Ddd*Pk2*f**3*r + 6144*C*D1*Ddd*Pk2*f**3*s**2 - 1376*C*D1*Ddd*Pk2*f**3*s + 1536*C*D1*Ddd*Pk2*f**3 - 10176*C*Dd**2*Pk2*f**3*r*s + 2544*C*Dd**2*Pk2*f**3*r + 18432*C*Dd**2*Pk2*f**3*s**2 - 4128*C*Dd**2*Pk2*f**3*s - 1696*C*Dd**2*Pk2*f**3 - 264*D1**2*K*Pk2*bdd1*f**2*r*s + 1056*D1**2*K*Pk2*bdd1*f**2*s**2 + 264*D1**2*K*Pk2*bdd1*f**2*s - 2640*D1**2*Pk2*b2*f*fd*r*s + 1320*D1**2*Pk2*b2*f*fd*r - 2640*D1**2*Pk2*b2*f*fd*s**2 + 2640*D1**2*Pk2*b2*f*fd*s - 1320*D1**2*Pk2*b2*f*fd + 1584*D1**2*Pk2*b2*f*fdd*r*s - 792*D1**2*Pk2*b2*f*fdd*r + 1584*D1**2*Pk2*b2*f*fdd*s**2 - 1584*D1**2*Pk2*b2*f*fdd*s + 792*D1**2*Pk2*b2*f*fdd + 1584*D1**2*Pk2*b2*fd**2*r*s - 792*D1**2*Pk2*b2*fd**2*r + 1584*D1**2*Pk2*b2*fd**2*s**2 - 1584*D1**2*Pk2*b2*fd**2*s - 264*D1**2*Pk2*bd1**2*f*(K*(-4*r*s + r - 6*s**2 + 6*s - 1) + 3*f*(r*(8*s - 5) + 8*s**2 - 12*s + 3) + 10*r*s - 4*r + 12*s**2 - 15*s + 4) - 1320*D1**2*Pk2*bd2*f**2*r*s - 1320*D1**2*Pk2*bd2*f**2*s**2 + 1320*D1**2*Pk2*bd2*f**2*s + 3168*D1**2*Pk2*bd2*f*fd*r*s - 792*D1**2*Pk2*bd2*f*fd*r + 3168*D1**2*Pk2*bd2*f*fd*s**2 - 3168*D1**2*Pk2*bd2*f*fd*s + 792*D1**2*Pk2*bd2*f*fd + 2772*D1**2*Pk2*bdd1*f**3*r**2 + 13464*D1**2*Pk2*bdd1*f**3*r*s - 7524*D1**2*Pk2*bdd1*f**3*r + 7524*D1**2*Pk2*bdd1*f**3*s**2 - 12672*D1**2*Pk2*bdd1*f**3*s + 5544*D1**2*Pk2*bdd1*f**3 + 726*D1**2*Pk2*bdd1*f**2*r**2 + 2244*D1**2*Pk2*bdd1*f**2*r*s - 132*D1**2*Pk2*bdd1*f**2*r + 396*D1**2*Pk2*bdd1*f**2*s**2 - 396*D1**2*Pk2*bdd1*f**2*s - 1122*D1**2*Pk2*bdd1*f**2 - 1056*D1**2*Pk2*bdd1*f*g2*r*s + 528*D1**2*Pk2*bdd1*f*g2*r - 1584*D1**2*Pk2*bdd1*f*g2*s**2 + 2112*D1**2*Pk2*bdd1*f*g2*s - 1056*D1**2*Pk2*bdd1*f*g2 + 792*D1**2*Pk2*bdd2*f**2*r*s + 792*D1**2*Pk2*bdd2*f**2*s**2 - 792*D1**2*Pk2*bdd2*f**2*s + 7920*D1**2*Pk2*f**3*fd*r**2 + 38016*D1**2*Pk2*f**3*fd*r*s - 17424*D1**2*Pk2*f**3*fd*r + 23760*D1**2*Pk2*f**3*fd*s**2 - 30888*D1**2*Pk2*f**3*fd*s + 9900*D1**2*Pk2*f**3*fd - 7920*D1**2*Pk2*f**3*fdd*r**2 - 38016*D1**2*Pk2*f**3*fdd*r*s + 17424*D1**2*Pk2*f**3*fdd*r - 23760*D1**2*Pk2*f**3*fdd*s**2 + 30888*D1**2*Pk2*f**3*fdd*s - 9900*D1**2*Pk2*f**3*fdd - 23760*D1**2*Pk2*f**2*fd**2*r**2 - 114048*D1**2*Pk2*f**2*fd**2*r*s + 52272*D1**2*Pk2*f**2*fd**2*r - 71280*D1**2*Pk2*f**2*fd**2*s**2 + 92664*D1**2*Pk2*f**2*fd**2*s - 22968*D1**2*Pk2*f**2*fd**2 - 2382*D1**2*Pk2*f**2*fd*r**2 - 15876*D1**2*Pk2*f**2*fd*r*s + 6880*D1**2*Pk2*f**2*fd*r - 1980*D1**2*Pk2*f**2*fd*s**2 + 6612*D1**2*Pk2*f**2*fd*s - 1454*D1**2*Pk2*f**2*fd + 2082*D1**2*Pk2*f**2*fdd*r**2 + 12492*D1**2*Pk2*f**2*fdd*r*s - 5552*D1**2*Pk2*f**2*fdd*r + 5148*D1**2*Pk2*f**2*fdd*s**2 - 7596*D1**2*Pk2*f**2*fdd*s + 2410*D1**2*Pk2*f**2*fdd - 528*D1**2*Pk2*f**2*gd2*r*s + 4752*D1**2*Pk2*f**2*gd2*s**2 + 528*D1**2*Pk2*f**2*gd2*s + 528*D1**2*Pk2*f**2*gdd2*r*s - 2112*D1**2*Pk2*f**2*gdd2*s**2 - 528*D1**2*Pk2*f**2*gdd2*s + 4164*D1**2*Pk2*f*fd**2*r**2 + 24984*D1**2*Pk2*f*fd**2*r*s - 11104*D1**2*Pk2*f*fd**2*r + 10296*D1**2*Pk2*f*fd**2*s**2 - 15192*D1**2*Pk2*f*fd**2*s + 4164*D1**2*Pk2*f*fd**2 - 1056*D1**2*Pk2*f*fd*g2*r*s + 528*D1**2*Pk2*f*fd*g2*r + 9504*D1**2*Pk2*f*fd*g2*s**2 - 9504*D1**2*Pk2*f*fd*g2*s + 4752*D1**2*Pk2*f*fd*g2 + 2112*D1**2*Pk2*f*fd*gd2*r*s - 528*D1**2*Pk2*f*fd*gd2*r - 8448*D1**2*Pk2*f*fd*gd2*s**2 + 3168*D1**2*Pk2*f*fd*gd2*s + 528*D1**2*Pk2*f*fd*gd2 + 1056*D1**2*Pk2*f*fdd*g2*r*s - 528*D1**2*Pk2*f*fdd*g2*r - 4224*D1**2*Pk2*f*fdd*g2*s**2 + 4224*D1**2*Pk2*f*fdd*g2*s - 2112*D1**2*Pk2*f*fdd*g2 + 1056*D1**2*Pk2*fd**2*g2*r*s - 528*D1**2*Pk2*fd**2*g2*r - 4224*D1**2*Pk2*fd**2*g2*s**2 + 4224*D1**2*Pk2*fd**2*g2*s - 75*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 + 150*D1**2*Pkdd2*bdd1*f**3*k1**2*s - 75*D1**2*Pkdd2*bdd1*f**3*k1**2 - 300*D1**2*Pkdd2*f**3*fd*k1**2*s**2 + 150*D1**2*Pkdd2*f**3*fd*k1**2*s - 75*D1**2*Pkdd2*f**3*fd*k1**2 - 5280*D1*Dd*Pk2*b2*f**2*r*s + 1320*D1*Dd*Pk2*b2*f**2*r - 5280*D1*Dd*Pk2*b2*f**2*s**2 + 5280*D1*Dd*Pk2*b2*f**2*s - 1320*D1*Dd*Pk2*b2*f**2 + 12672*D1*Dd*Pk2*b2*f*fd*r*s - 4752*D1*Dd*Pk2*b2*f*fd*r + 12672*D1*Dd*Pk2*b2*f*fd*s**2 - 12672*D1*Dd*Pk2*b2*f*fd*s + 3168*D1*Dd*Pk2*b2*f*fd + 6336*D1*Dd*Pk2*bd2*f**2*r*s - 792*D1*Dd*Pk2*bd2*f**2*r + 6336*D1*Dd*Pk2*bd2*f**2*s**2 - 6336*D1*Dd*Pk2*bd2*f**2*s + 792*D1*Dd*Pk2*bd2*f**2 + 7920*D1*Dd*Pk2*f**4*r**2 + 38016*D1*Dd*Pk2*f**4*r*s - 17424*D1*Dd*Pk2*f**4*r + 23760*D1*Dd*Pk2*f**4*s**2 - 30888*D1*Dd*Pk2*f**4*s + 9900*D1*Dd*Pk2*f**4 - 63360*D1*Dd*Pk2*f**3*fd*r**2 - 304128*D1*Dd*Pk2*f**3*fd*r*s + 139392*D1*Dd*Pk2*f**3*fd*r - 190080*D1*Dd*Pk2*f**3*fd*s**2 + 247104*D1*Dd*Pk2*f**3*fd*s - 65736*D1*Dd*Pk2*f**3*fd - 3176*D1*Dd*Pk2*f**3*r**2 - 21168*D1*Dd*Pk2*f**3*r*s + 8468*D1*Dd*Pk2*f**3*r - 2640*D1*Dd*Pk2*f**3*s**2 + 11904*D1*Dd*Pk2*f**3*s - 2248*D1*Dd*Pk2*f**3 + 16656*D1*Dd*Pk2*f**2*fd*r**2 + 99936*D1*Dd*Pk2*f**2*fd*r*s - 43028*D1*Dd*Pk2*f**2*fd*r + 41184*D1*Dd*Pk2*f**2*fd*s**2 - 65664*D1*Dd*Pk2*f**2*fd*s + 18700*D1*Dd*Pk2*f**2*fd - 2112*D1*Dd*Pk2*f**2*g2*r*s + 528*D1*Dd*Pk2*f**2*g2*r + 19008*D1*Dd*Pk2*f**2*g2*s**2 - 8448*D1*Dd*Pk2*f**2*g2*s + 4752*D1*Dd*Pk2*f**2*g2 + 4224*D1*Dd*Pk2*f**2*gd2*r*s - 528*D1*Dd*Pk2*f**2*gd2*r - 16896*D1*Dd*Pk2*f**2*gd2*s**2 + 1056*D1*Dd*Pk2*f**2*gd2*s + 528*D1*Dd*Pk2*f**2*gd2 + 8448*D1*Dd*Pk2*f*fd*g2*r*s - 3168*D1*Dd*Pk2*f*fd*g2*r - 33792*D1*Dd*Pk2*f*fd*g2*s**2 + 23232*D1*Dd*Pk2*f*fd*g2*s - 3168*D1*Dd*Pk2*f*fd*g2 - 300*D1*Dd*Pkdd2*f**4*k1**2*s**2 + 150*D1*Dd*Pkdd2*f**4*k1**2*s - 75*D1*Dd*Pkdd2*f**4*k1**2 + 3168*D1*Ddd*Pk2*b2*f**2*r*s - 792*D1*Ddd*Pk2*b2*f**2*r + 3168*D1*Ddd*Pk2*b2*f**2*s**2 - 3168*D1*Ddd*Pk2*b2*f**2*s + 792*D1*Ddd*Pk2*b2*f**2 - 7920*D1*Ddd*Pk2*f**4*r**2 - 38016*D1*Ddd*Pk2*f**4*r*s + 17424*D1*Ddd*Pk2*f**4*r - 23760*D1*Ddd*Pk2*f**4*s**2 + 30888*D1*Ddd*Pk2*f**4*s - 9900*D1*Ddd*Pk2*f**4 + 2776*D1*Ddd*Pk2*f**3*r**2 + 16656*D1*Ddd*Pk2*f**3*r*s - 6940*D1*Ddd*Pk2*f**3*r + 6864*D1*Ddd*Pk2*f**3*s**2 - 11760*D1*Ddd*Pk2*f**3*s + 3104*D1*Ddd*Pk2*f**3 + 2112*D1*Ddd*Pk2*f**2*g2*r*s - 528*D1*Ddd*Pk2*f**2*g2*r - 8448*D1*Ddd*Pk2*f**2*g2*s**2 + 3168*D1*Ddd*Pk2*f**2*g2*s - 2112*D1*Ddd*Pk2*f**2*g2 - 6*D1*bd1*(D1*(-22*Pk2*f*(fd*(4*C*(r*(8*s - 3) + 12*s**2 - 12*s + 1) + 2*K*(-4*r*s + r + 16*s**2 - 6*s - 1) + 22*r**2 + 68*r*s - 29*r + 12*s**2 - 26*s + 21) + 4*g2*(r*(11*s - 2) + 13*s**2 - 8*s + 4) + 4*gd2*(-4*r*s + r - 6*s**2 + 6*s - 1)) + 176*Pk2*fd*g2*(r*(2*s - 1) + s*(3*s - 3)) + f**3*(66*Pk2*(5*r**2 + r*(38*s - 17) + (4 - 5*s)**2) - 25*Pkdd2*k1**2*(s - 1)**2) + f**2*(11*Pk2*(8*C*(r*(3*s - 2) + 5*s**2 - 8*s + 4) - 4*K*r*s + 36*K*s**2 + 4*K*s - 12*fd*(21*r**2 + 102*r*s - 50*r + 57*s**2 - 85*s + 21) + 13*r**2 + 34*r*s + 14*r - 18*s**2 + 30*s - 43) + 75*Pkdd2*fd*k1**2*s*(s - 1))) - Dd*f*(22*Pk2*f*(8*C*(r*(8*s - 3) + 12*s**2 - 13*s + 3) + 2*K*(-8*r*s + r + 32*s**2 - 2*s - 1) + 44*r**2 + 136*r*s - 43*r + 24*s**2 - 52*s + 5) - 176*Pk2*g2*(r*(8*s - 3) + 12*s**2 - 13*s + 3) + f**2*(132*Pk2*(28*r**2 + r*(136*s - 69) + 76*s**2 - 117*s + 35) - 25*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 9504*Dd**2*Pk2*b2*f**2*r*s - 2376*Dd**2*Pk2*b2*f**2*r + 9504*Dd**2*Pk2*b2*f**2*s**2 - 9504*Dd**2*Pk2*b2*f**2*s + 1584*Dd**2*Pk2*b2*f**2 - 23760*Dd**2*Pk2*f**4*r**2 - 114048*Dd**2*Pk2*f**4*r*s + 52272*Dd**2*Pk2*f**4*r - 71280*Dd**2*Pk2*f**4*s**2 + 92664*Dd**2*Pk2*f**4*s - 22968*Dd**2*Pk2*f**4 + 8328*Dd**2*Pk2*f**3*r**2 + 49968*Dd**2*Pk2*f**3*r*s - 20820*Dd**2*Pk2*f**3*r + 20592*Dd**2*Pk2*f**3*s**2 - 35280*Dd**2*Pk2*f**3*s + 9716*Dd**2*Pk2*f**3 + 6336*Dd**2*Pk2*f**2*g2*r*s - 1584*Dd**2*Pk2*f**2*g2*r - 25344*Dd**2*Pk2*f**2*g2*s**2 + 9504*Dd**2*Pk2*f**2*g2*s + 1056*Dd**2*Pk2*f**2*g2 + 264*Pk2*b1**2*(-D1**2*(3*fd**2*(8*r*s + r + 8*s**2 - 4*s - 1) + fd*(K*(11*r*s - 9*r + 13*s**2 - 18*s + 9) + f*(-r*(44*s + 5) - 44*s**2 + 23*s + 5) - 17*r*s + 9*r - 19*s**2 + 18*s - 9) + fdd*(K*(-2*r*s + r - 3*s**2 + 2*s - 1) + 3*f*(8*r*s + r + 8*s**2 - 4*s - 1) + 5*r*s - r + 6*s**2 - 2*s + 1)) + D1*(Dd*(22*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(K*(-44*r*s + 11*r - 52*s**2 + 48*s - 13) - 6*fd*(r*(32*s - 2) + 32*s**2 - 24*s + 1) + 68*r*s - 17*r + 76*s**2 - 72*s + 19) + fd*(2*K*(r*(8*s - 3) + 12*s**2 - 9*s + 2) + r*(9 - 40*s) - 48*s**2 + 30*s - 4)) + Ddd*f*(K*(8*r*s - 2*r + 12*s**2 - 10*s + 3) - 12*f*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 5*r - 24*s**2 + 22*s - 6)) + Dd**2*f*(K*(24*r*s - 6*r + 36*s**2 - 30*s + 4) - 12*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - 60*r*s + 15*r - 72*s**2 + 66*s - 10)) + 3*b1*(-1056*C*D1**2*Pk2*f*fd*r*s + 176*C*D1**2*Pk2*f*fd*r - 1760*C*D1**2*Pk2*f*fd*s**2 + 880*C*D1**2*Pk2*f*fd*s - 176*C*D1**2*Pk2*f*fd + 704*C*D1**2*Pk2*f*fdd*r*s - 176*C*D1**2*Pk2*f*fdd*r + 1056*C*D1**2*Pk2*f*fdd*s**2 - 704*C*D1**2*Pk2*f*fdd*s + 176*C*D1**2*Pk2*f*fdd + 704*C*D1**2*Pk2*fd**2*r*s - 176*C*D1**2*Pk2*fd**2*r + 1056*C*D1**2*Pk2*fd**2*s**2 - 704*C*D1**2*Pk2*fd**2*s + 176*C*D1**2*Pk2*fd**2 - 2112*C*D1*Dd*Pk2*f**2*r*s + 528*C*D1*Dd*Pk2*f**2*r - 3520*C*D1*Dd*Pk2*f**2*s**2 + 2816*C*D1*Dd*Pk2*f**2*s - 880*C*D1*Dd*Pk2*f**2 + 5632*C*D1*Dd*Pk2*f*fd*r*s - 1408*C*D1*Dd*Pk2*f*fd*r + 8448*C*D1*Dd*Pk2*f*fd*s**2 - 6336*C*D1*Dd*Pk2*f*fd*s + 1056*C*D1*Dd*Pk2*f*fd + 1408*C*D1*Ddd*Pk2*f**2*r*s - 352*C*D1*Ddd*Pk2*f**2*r + 2112*C*D1*Ddd*Pk2*f**2*s**2 - 1760*C*D1*Ddd*Pk2*f**2*s + 528*C*D1*Ddd*Pk2*f**2 + 4224*C*Dd**2*Pk2*f**2*r*s - 1056*C*Dd**2*Pk2*f**2*r + 6336*C*Dd**2*Pk2*f**2*s**2 - 5280*C*Dd**2*Pk2*f**2*s + 704*C*Dd**2*Pk2*f**2 + 176*D1**2*K*Pk2*f*fd*r*s - 88*D1**2*K*Pk2*f*fd*r - 1584*D1**2*K*Pk2*f*fd*s**2 + 1584*D1**2*K*Pk2*f*fd*s - 792*D1**2*K*Pk2*f*fd - 176*D1**2*K*Pk2*f*fdd*r*s + 88*D1**2*K*Pk2*f*fdd*r + 704*D1**2*K*Pk2*f*fdd*s**2 - 704*D1**2*K*Pk2*f*fdd*s + 352*D1**2*K*Pk2*f*fdd - 176*D1**2*K*Pk2*fd**2*r*s + 88*D1**2*K*Pk2*fd**2*r + 704*D1**2*K*Pk2*fd**2*s**2 - 704*D1**2*K*Pk2*fd**2*s - 88*D1**2*Pk2*bdd1*f*(K*(-4*r*s + r - 6*s**2 + 6*s - 2) + 3*f*(r*(8*s - 5) + 8*s**2 - 12*s + 5) + 10*r*s - 4*r + 12*s**2 - 15*s + 5) - 1980*D1**2*Pk2*f**2*fd*r**2 - 15048*D1**2*Pk2*f**2*fd*r*s + 5412*D1**2*Pk2*f**2*fd*r - 9900*D1**2*Pk2*f**2*fd*s**2 + 11352*D1**2*Pk2*f**2*fd*s - 2508*D1**2*Pk2*f**2*fd + 2772*D1**2*Pk2*f**2*fdd*r**2 + 13464*D1**2*Pk2*f**2*fdd*r*s - 5676*D1**2*Pk2*f**2*fdd*r + 7524*D1**2*Pk2*f**2*fdd*s**2 - 9768*D1**2*Pk2*f**2*fdd*s + 2508*D1**2*Pk2*f**2*fdd + 5544*D1**2*Pk2*f*fd**2*r**2 + 26928*D1**2*Pk2*f*fd**2*r*s - 11352*D1**2*Pk2*f*fd**2*r + 15048*D1**2*Pk2*f*fd**2*s**2 - 19536*D1**2*Pk2*f*fd**2*s + 5280*D1**2*Pk2*f*fd**2 - 572*D1**2*Pk2*f*fd*r**2 - 1496*D1**2*Pk2*f*fd*r*s + 1628*D1**2*Pk2*f*fd*r + 792*D1**2*Pk2*f*fd*s**2 + 616*D1**2*Pk2*f*fd*s - 836*D1**2*Pk2*f*fd + 484*D1**2*Pk2*f*fdd*r**2 + 1496*D1**2*Pk2*f*fdd*r*s - 1188*D1**2*Pk2*f*fdd*r + 264*D1**2*Pk2*f*fdd*s**2 - 880*D1**2*Pk2*f*fdd*s + 748*D1**2*Pk2*f*fdd + 1936*D1**2*Pk2*f*gd2*r*s + 2288*D1**2*Pk2*f*gd2*s**2 - 1936*D1**2*Pk2*f*gd2*s - 352*D1**2*Pk2*f*gdd2*r*s - 528*D1**2*Pk2*f*gdd2*s**2 + 352*D1**2*Pk2*f*gdd2*s + 484*D1**2*Pk2*fd**2*r**2 + 1496*D1**2*Pk2*fd**2*r*s - 1188*D1**2*Pk2*fd**2*r + 264*D1**2*Pk2*fd**2*s**2 - 880*D1**2*Pk2*fd**2*s - 176*D1**2*Pk2*fd**2 + 1936*D1**2*Pk2*fd*g2*r*s - 1584*D1**2*Pk2*fd*g2*r + 2288*D1**2*Pk2*fd*g2*s**2 - 3168*D1**2*Pk2*fd*g2*s + 1584*D1**2*Pk2*fd*g2 - 704*D1**2*Pk2*fd*gd2*r*s + 176*D1**2*Pk2*fd*gd2*r - 1056*D1**2*Pk2*fd*gd2*s**2 + 704*D1**2*Pk2*fd*gd2*s - 176*D1**2*Pk2*fd*gd2 - 352*D1**2*Pk2*fdd*g2*r*s + 176*D1**2*Pk2*fdd*g2*r - 528*D1**2*Pk2*fdd*g2*s**2 + 352*D1**2*Pk2*fdd*g2*s - 176*D1**2*Pk2*fdd*g2 + 150*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 75*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 150*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 352*D1*Dd*K*Pk2*f**2*r*s - 88*D1*Dd*K*Pk2*f**2*r - 3168*D1*Dd*K*Pk2*f**2*s**2 + 1408*D1*Dd*K*Pk2*f**2*s - 792*D1*Dd*K*Pk2*f**2 - 1408*D1*Dd*K*Pk2*f*fd*r*s + 528*D1*Dd*K*Pk2*f*fd*r + 5632*D1*Dd*K*Pk2*f*fd*s**2 - 3872*D1*Dd*K*Pk2*f*fd*s + 528*D1*Dd*K*Pk2*f*fd - 2640*D1*Dd*Pk2*f**3*r**2 - 20064*D1*Dd*Pk2*f**3*r*s + 7656*D1*Dd*Pk2*f**3*r - 13200*D1*Dd*Pk2*f**3*s**2 + 16632*D1*Dd*Pk2*f**3*s - 4620*D1*Dd*Pk2*f**3 + 22176*D1*Dd*Pk2*f**2*fd*r**2 + 107712*D1*Dd*Pk2*f**2*fd*r*s - 47256*D1*Dd*Pk2*f**2*fd*r + 60192*D1*Dd*Pk2*f**2*fd*s**2 - 81048*D1*Dd*Pk2*f**2*fd*s + 21120*D1*Dd*Pk2*f**2*fd - 1144*D1*Dd*Pk2*f**2*r**2 - 2992*D1*Dd*Pk2*f**2*r*s + 1892*D1*Dd*Pk2*f**2*r + 1584*D1*Dd*Pk2*f**2*s**2 + 704*D1*Dd*Pk2*f**2*s - 176*D1*Dd*Pk2*f**2 + 3872*D1*Dd*Pk2*f*fd*r**2 + 11968*D1*Dd*Pk2*f*fd*r*s - 8184*D1*Dd*Pk2*f*fd*r + 2112*D1*Dd*Pk2*f*fd*s**2 - 7040*D1*Dd*Pk2*f*fd*s + 3256*D1*Dd*Pk2*f*fd + 7744*D1*Dd*Pk2*f*g2*r*s - 1936*D1*Dd*Pk2*f*g2*r + 9152*D1*Dd*Pk2*f*g2*s**2 - 8448*D1*Dd*Pk2*f*g2*s + 2288*D1*Dd*Pk2*f*g2 - 2816*D1*Dd*Pk2*f*gd2*r*s + 352*D1*Dd*Pk2*f*gd2*r - 4224*D1*Dd*Pk2*f*gd2*s**2 + 3168*D1*Dd*Pk2*f*gd2*s - 352*D1*Dd*Pk2*f*gd2 - 2816*D1*Dd*Pk2*fd*g2*r*s + 1056*D1*Dd*Pk2*fd*g2*r - 4224*D1*Dd*Pk2*fd*g2*s**2 + 3168*D1*Dd*Pk2*fd*g2*s - 704*D1*Dd*Pk2*fd*g2 + 200*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 100*D1*Dd*Pkdd2*f**3*k1**2*s + 50*D1*Dd*Pkdd2*f**3*k1**2 - 600*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 150*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 352*D1*Ddd*K*Pk2*f**2*r*s + 88*D1*Ddd*K*Pk2*f**2*r + 1408*D1*Ddd*K*Pk2*f**2*s**2 - 528*D1*Ddd*K*Pk2*f**2*s + 352*D1*Ddd*K*Pk2*f**2 + 3696*D1*Ddd*Pk2*f**3*r**2 + 17952*D1*Ddd*Pk2*f**3*r*s - 8184*D1*Ddd*Pk2*f**3*r + 10032*D1*Ddd*Pk2*f**3*s**2 - 13992*D1*Ddd*Pk2*f**3*s + 4356*D1*Ddd*Pk2*f**3 + 968*D1*Ddd*Pk2*f**2*r**2 + 2992*D1*Ddd*Pk2*f**2*r*s - 1716*D1*Ddd*Pk2*f**2*r + 528*D1*Ddd*Pk2*f**2*s**2 - 1760*D1*Ddd*Pk2*f**2*s + 616*D1*Ddd*Pk2*f**2 - 1408*D1*Ddd*Pk2*f*g2*r*s + 352*D1*Ddd*Pk2*f*g2*r - 2112*D1*Ddd*Pk2*f*g2*s**2 + 1760*D1*Ddd*Pk2*f*g2*s - 528*D1*Ddd*Pk2*f*g2 - 100*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 50*D1*Ddd*Pkdd2*f**3*k1**2*s - 25*D1*Ddd*Pkdd2*f**3*k1**2 + 88*D1*Pk2*bd1*(D1*(f**2*(r*(44*s - 27) + 44*s**2 - 65*s + 27) + f*(K*(-22*r*s + 2*r - 26*s**2 + 19*s - 4) - 6*fd*(4*s - 1)*(4*r + 4*s - 3) + 34*r*s - 8*r + 38*s**2 - 37*s + 10) + fd*(K*(r*(8*s - 3) + 12*s**2 - 10*s + 1) + r*(6 - 20*s) - 24*s**2 + 19*s - 1)) + Dd*f*(4*K*(4*s - 1)*(2*r + 3*s - 2) - 6*f*(2*r*(16*s - 7) + 32*s**2 - 40*s + 11) - 80*r*s + 26*r - 96*s**2 + 104*s - 23)) - 1056*Dd**2*K*Pk2*f**2*r*s + 264*Dd**2*K*Pk2*f**2*r + 4224*Dd**2*K*Pk2*f**2*s**2 - 1584*Dd**2*K*Pk2*f**2*s - 176*Dd**2*K*Pk2*f**2 + 11088*Dd**2*Pk2*f**3*r**2 + 53856*Dd**2*Pk2*f**3*r*s - 24552*Dd**2*Pk2*f**3*r + 30096*Dd**2*Pk2*f**3*s**2 - 41976*Dd**2*Pk2*f**3*s + 10824*Dd**2*Pk2*f**3 + 2904*Dd**2*Pk2*f**2*r**2 + 8976*Dd**2*Pk2*f**2*r*s - 5148*Dd**2*Pk2*f**2*r + 1584*Dd**2*Pk2*f**2*s**2 - 5280*Dd**2*Pk2*f**2*s + 1980*Dd**2*Pk2*f**2 - 4224*Dd**2*Pk2*f*g2*r*s + 1056*Dd**2*Pk2*f*g2*r - 6336*Dd**2*Pk2*f*g2*s**2 + 5280*Dd**2*Pk2*f*g2*s - 704*Dd**2*Pk2*f*g2 - 300*Dd**2*Pkdd2*f**3*k1**2*s**2 + 150*Dd**2*Pkdd2*f**3*k1**2*s))/(1386*d**2*k2*k3**4) + D1**2*Pk3*ct*k1**3*(-4*D1**2*Pk2*bd1**2*(6*f**2*(14*r**2 + r*(28*s - 23) + 14*s**2 - 25*s + 9) + f*(K*(r*(27 - 54*s) - 40*s**2 + 67*s - 27) + 47*r**2 + r*(48*C*s - 24*C + 124*s - 109) + (s - 1)*(48*C*s + 63*s - 86)) + 28*g2*(-2*r*s + r - s*(2*s - 2))) + D1*bd1*(D1*(-2*Pk2*f**2*(8*C*(s - 1)*(13*r + 8*s - 8) + 24*K*r*s + 62*K*s**2 - 24*K*s - 24*fd*(15*r**2 + 24*r*s - 26*r - 13*s + 10) - 34*r**2 - 204*r*s + 204*r - 149*s**2 + 260*s - 130) + 4*Pk2*f*(fd*(2*C*(50*r*(2*s - 1) + 68*s**2 - 93*s + 25) + 2*K*(24*r*s - 6*r + 62*s**2 - 43*s + 6) - 88*r**2 - 408*r*s + 248*r - 294*s**2 + 377*s - 102) + 2*g2*(s - 1)*(26*r + 19*s - 19) + 2*gd2*(r*(27 - 54*s) - 40*s**2 + 67*s - 27)) - 8*Pk2*fd*g2*(27*r*(2*s - 1) + s*(40*s - 40)) + f**3*(-12*Pk2*(10*r**2 + 8*r*(2*s - 3) - 10*s + 9) + 5*Pkdd2*k1**2*(s - 1)**2)) + 4*Dd*Pk2*f*(6*f**2*(40*r**2 + r*(64*s - 76) - 36*s + 29) + f*(50*C*r*(8*s - 5) + 8*C*(34*s**2 - 55*s + 21) + 2*K*(48*r*s - 6*r + 124*s**2 - 67*s + 6) - 176*r**2 - 816*r*s + 598*r - 588*s**2 + 863*s - 332) - 2*g2*(27*r*(8*s - 5) + 160*s**2 - 254*s + 94))) + 56*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 2*Pk2*b1**2*(40*C*D1**2*fd*r*s + 40*C*D1**2*fd*s**2 - 40*C*D1**2*fd*s - 48*C*D1**2*fdd*r*s - 48*C*D1**2*fdd*s**2 + 48*C*D1**2*fdd*s + 160*C*D1*Dd*f*r*s - 40*C*D1*Dd*f*r + 160*C*D1*Dd*f*s**2 - 160*C*D1*Dd*f*s + 40*C*D1*Dd*f - 384*C*D1*Dd*fd*r*s + 48*C*D1*Dd*fd*r - 384*C*D1*Dd*fd*s**2 + 384*C*D1*Dd*fd*s - 48*C*D1*Dd*fd - 192*C*D1*Ddd*f*r*s + 48*C*D1*Ddd*f*r - 192*C*D1*Ddd*f*s**2 + 192*C*D1*Ddd*f*s - 48*C*D1*Ddd*f - 576*C*Dd**2*f*r*s + 144*C*Dd**2*f*r - 576*C*Dd**2*f*s**2 + 576*C*Dd**2*f*s - 96*C*Dd**2*f - 52*D1**2*K*fd*r*s - 38*D1**2*K*fd*s**2 + 54*D1**2*K*fdd*r*s + 40*D1**2*K*fdd*s**2 - 28*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 120*D1**2*f*fd*r**2 + 336*D1**2*f*fd*r*s - 156*D1**2*f*fd*r + 216*D1**2*f*fd*s**2 - 204*D1**2*f*fd*s + 66*D1**2*f*fd - 168*D1**2*f*fdd*r**2 - 336*D1**2*f*fdd*r*s + 228*D1**2*f*fdd*r - 168*D1**2*f*fdd*s**2 + 204*D1**2*f*fdd*s - 102*D1**2*f*fdd - 168*D1**2*fd**2*r**2 - 336*D1**2*fd**2*r*s + 228*D1**2*fd**2*r - 168*D1**2*fd**2*s**2 + 204*D1**2*fd**2*s - 60*D1**2*fd**2 + 31*D1**2*fd*r**2 + 122*D1**2*fd*r*s + 77*D1**2*fd*s**2 + 40*D1**2*fd*s - 47*D1**2*fdd*r**2 - 124*D1**2*fdd*r*s - 63*D1**2*fdd*s**2 - 48*D1**2*fdd*s - 112*D1**2*gd2*r*s - 112*D1**2*gd2*s**2 + 112*D1**2*gd2*s + 56*D1**2*gdd2*r*s + 56*D1**2*gdd2*s**2 - 56*D1**2*gdd2*s - 208*D1*Dd*K*f*r*s + 52*D1*Dd*K*f*r - 152*D1*Dd*K*f*s**2 + 180*D1*Dd*K*f*s - 38*D1*Dd*K*f + 432*D1*Dd*K*fd*r*s - 54*D1*Dd*K*fd*r + 320*D1*Dd*K*fd*s**2 - 188*D1*Dd*K*fd*s + 240*D1*Dd*f**2*r**2 + 672*D1*Dd*f**2*r*s - 408*D1*Dd*f**2*r + 432*D1*Dd*f**2*s**2 - 552*D1*Dd*f**2*s + 228*D1*Dd*f**2 - 1344*D1*Dd*f*fd*r**2 - 2688*D1*Dd*f*fd*r*s + 1920*D1*Dd*f*fd*r - 1344*D1*Dd*f*fd*s**2 + 1824*D1*Dd*f*fd*s - 660*D1*Dd*f*fd + 124*D1*Dd*f*r**2 + 488*D1*Dd*f*r*s - 246*D1*Dd*f*r + 308*D1*Dd*f*s**2 - 398*D1*Dd*f*s + 139*D1*Dd*f - 376*D1*Dd*fd*r**2 - 992*D1*Dd*fd*r*s + 312*D1*Dd*fd*r - 504*D1*Dd*fd*s**2 + 182*D1*Dd*fd*s + 48*D1*Dd*fd - 448*D1*Dd*g2*r*s + 112*D1*Dd*g2*r - 448*D1*Dd*g2*s**2 + 448*D1*Dd*g2*s - 112*D1*Dd*g2 + 448*D1*Dd*gd2*r*s - 56*D1*Dd*gd2*r + 448*D1*Dd*gd2*s**2 - 448*D1*Dd*gd2*s + 56*D1*Dd*gd2 + 216*D1*Ddd*K*f*r*s - 54*D1*Ddd*K*f*r + 160*D1*Ddd*K*f*s**2 - 188*D1*Ddd*K*f*s + 40*D1*Ddd*K*f - 336*D1*Ddd*f**2*r**2 - 672*D1*Ddd*f**2*r*s + 504*D1*Ddd*f**2*r - 336*D1*Ddd*f**2*s**2 + 504*D1*Ddd*f**2*s - 252*D1*Ddd*f**2 - 188*D1*Ddd*f*r**2 - 496*D1*Ddd*f*r*s + 312*D1*Ddd*f*r - 252*D1*Ddd*f*s**2 + 374*D1*Ddd*f*s - 157*D1*Ddd*f + 224*D1*Ddd*g2*r*s - 56*D1*Ddd*g2*r + 224*D1*Ddd*g2*s**2 - 224*D1*Ddd*g2*s + 56*D1*Ddd*g2 + 28*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 648*Dd**2*K*f*r*s - 162*Dd**2*K*f*r + 480*Dd**2*K*f*s**2 - 564*Dd**2*K*f*s + 108*Dd**2*K*f - 1008*Dd**2*f**2*r**2 - 2016*Dd**2*f**2*r*s + 1512*Dd**2*f**2*r - 1008*Dd**2*f**2*s**2 + 1512*Dd**2*f**2*s - 504*Dd**2*f**2 - 564*Dd**2*f*r**2 - 1488*Dd**2*f*r*s + 936*Dd**2*f*r - 756*Dd**2*f*s**2 + 1122*Dd**2*f*s - 342*Dd**2*f + 672*Dd**2*g2*r*s - 168*Dd**2*g2*r + 672*Dd**2*g2*s**2 - 672*Dd**2*g2*s + 112*Dd**2*g2) + 2*Pk2*(-120*C*D1**2*f**2*fd*r*s + 40*C*D1**2*f**2*fd*r - 312*C*D1**2*f**2*fd*s**2 + 248*C*D1**2*f**2*fd*s - 104*C*D1**2*f**2*fd + 120*C*D1**2*f**2*fdd*r*s - 40*C*D1**2*f**2*fdd*r + 312*C*D1**2*f**2*fdd*s**2 - 248*C*D1**2*f**2*fdd*s + 104*C*D1**2*f**2*fdd + 240*C*D1**2*f*fd**2*r*s - 80*C*D1**2*f*fd**2*r + 624*C*D1**2*f*fd**2*s**2 - 496*C*D1**2*f*fd**2*s + 40*C*D1**2*f*fd**2 - 160*C*D1*Dd*f**3*r*s + 40*C*D1*Dd*f**3*r - 416*C*D1*Dd*f**3*s**2 + 288*C*D1*Dd*f**3*s - 104*C*D1*Dd*f**3 + 960*C*D1*Dd*f**2*fd*r*s - 280*C*D1*Dd*f**2*fd*r + 2496*C*D1*Dd*f**2*fd*s**2 - 1856*C*D1*Dd*f**2*fd*s + 328*C*D1*Dd*f**2*fd + 160*C*D1*Ddd*f**3*r*s - 40*C*D1*Ddd*f**3*r + 416*C*D1*Ddd*f**3*s**2 - 288*C*D1*Ddd*f**3*s + 104*C*D1*Ddd*f**3 + 480*C*Dd**2*f**3*r*s - 120*C*Dd**2*f**3*r + 1248*C*Dd**2*f**3*s**2 - 864*C*Dd**2*f**3*s + 80*C*Dd**2*f**3 + D1**2*bdd1*f*(6*f**2*(10*r**2 + 8*r*(2*s - 3) - 10*s + 9) + f*(4*C*(s - 1)*(25*r + 17*s - 17) + 62*K*s**2 - 24*K*s - 44*r**2 + 12*r*(2*K*s - 17*s + 17) - 147*s**2 + 256*s - 128) - 4*g2*(s - 1)*(27*r + 20*s - 20)) + 24*D1**2*bdd2*f**2*r*s + 24*D1**2*bdd2*f**2*s**2 - 24*D1**2*bdd2*f**2*s + 60*D1**2*f**2*fd*r*s - 20*D1**2*f**2*fd*r + 204*D1**2*f**2*fd*s**2 - 156*D1**2*f**2*fd*s + 68*D1**2*f**2*fd - 60*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 204*D1**2*f**2*fdd*s**2 + 156*D1**2*f**2*fdd*s - 68*D1**2*f**2*fdd + 48*D1**2*f**2*gd2*r*s + 124*D1**2*f**2*gd2*s**2 - 48*D1**2*f**2*gd2*s - 48*D1**2*f**2*gdd2*r*s - 124*D1**2*f**2*gdd2*s**2 + 48*D1**2*f**2*gdd2*s - 120*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 408*D1**2*f*fd**2*s**2 + 312*D1**2*f*fd**2*s - 20*D1**2*f*fd**2 + 96*D1**2*f*fd*g2*r*s - 48*D1**2*f*fd*g2*r + 248*D1**2*f*fd*g2*s**2 - 248*D1**2*f*fd*g2*s + 124*D1**2*f*fd*g2 - 192*D1**2*f*fd*gd2*r*s + 48*D1**2*f*fd*gd2*r - 496*D1**2*f*fd*gd2*s**2 + 344*D1**2*f*fd*gd2*s - 48*D1**2*f*fd*gd2 - 96*D1**2*f*fdd*g2*r*s + 48*D1**2*f*fdd*g2*r - 248*D1**2*f*fdd*g2*s**2 + 248*D1**2*f*fdd*g2*s - 124*D1**2*f*fdd*g2 - 96*D1**2*fd**2*g2*r*s + 48*D1**2*fd**2*g2*r - 248*D1**2*fd**2*g2*s**2 + 248*D1**2*fd**2*g2*s + 80*D1*Dd*f**3*r*s - 20*D1*Dd*f**3*r + 272*D1*Dd*f**3*s**2 - 176*D1*Dd*f**3*s + 68*D1*Dd*f**3 - 480*D1*Dd*f**2*fd*r*s + 140*D1*Dd*f**2*fd*r - 1632*D1*Dd*f**2*fd*s**2 + 1152*D1*Dd*f**2*fd*s - 196*D1*Dd*f**2*fd + 192*D1*Dd*f**2*g2*r*s - 48*D1*Dd*f**2*g2*r + 496*D1*Dd*f**2*g2*s**2 - 344*D1*Dd*f**2*g2*s + 124*D1*Dd*f**2*g2 - 384*D1*Dd*f**2*gd2*r*s + 48*D1*Dd*f**2*gd2*r - 992*D1*Dd*f**2*gd2*s**2 + 536*D1*Dd*f**2*gd2*s - 48*D1*Dd*f**2*gd2 - 768*D1*Dd*f*fd*g2*r*s + 288*D1*Dd*f*fd*g2*r - 1984*D1*Dd*f*fd*g2*s**2 + 1680*D1*Dd*f*fd*g2*s - 344*D1*Dd*f*fd*g2 - 80*D1*Ddd*f**3*r*s + 20*D1*Ddd*f**3*r - 272*D1*Ddd*f**3*s**2 + 176*D1*Ddd*f**3*s - 68*D1*Ddd*f**3 - 192*D1*Ddd*f**2*g2*r*s + 48*D1*Ddd*f**2*g2*r - 496*D1*Ddd*f**2*g2*s**2 + 344*D1*Ddd*f**2*g2*s - 124*D1*Ddd*f**2*g2 - 24*D1*bd2*f*(D1*(f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 240*Dd**2*f**3*r*s + 60*Dd**2*f**3*r - 816*Dd**2*f**3*s**2 + 528*Dd**2*f**3*s - 40*Dd**2*f**3 - 576*Dd**2*f**2*g2*r*s + 144*Dd**2*f**2*g2*r - 1488*Dd**2*f**2*g2*s**2 + 1032*Dd**2*f**2*g2*s - 96*Dd**2*f**2*g2 - 24*b2*(D1**2*(f*(fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))) - b1*(416*C*D1**2*Pk2*f*fd*r*s + 256*C*D1**2*Pk2*f*fd*s**2 - 208*C*D1**2*Pk2*f*fd*s - 400*C*D1**2*Pk2*f*fdd*r*s - 272*C*D1**2*Pk2*f*fdd*s**2 + 200*C*D1**2*Pk2*f*fdd*s - 400*C*D1**2*Pk2*fd**2*r*s - 272*C*D1**2*Pk2*fd**2*s**2 + 200*C*D1**2*Pk2*fd**2*s + 832*C*D1*Dd*Pk2*f**2*r*s - 208*C*D1*Dd*Pk2*f**2*r + 512*C*D1*Dd*Pk2*f**2*s**2 - 672*C*D1*Dd*Pk2*f**2*s + 128*C*D1*Dd*Pk2*f**2 - 3200*C*D1*Dd*Pk2*f*fd*r*s + 400*C*D1*Dd*Pk2*f*fd*r - 2176*C*D1*Dd*Pk2*f*fd*s**2 + 2144*C*D1*Dd*Pk2*f*fd*s - 200*C*D1*Dd*Pk2*f*fd - 800*C*D1*Ddd*Pk2*f**2*r*s + 200*C*D1*Ddd*Pk2*f**2*r - 544*C*D1*Ddd*Pk2*f**2*s**2 + 672*C*D1*Ddd*Pk2*f**2*s - 136*C*D1*Ddd*Pk2*f**2 - 2400*C*Dd**2*Pk2*f**2*r*s + 600*C*Dd**2*Pk2*f**2*r - 1632*C*Dd**2*Pk2*f**2*s**2 + 2016*C*Dd**2*Pk2*f**2*s - 400*C*Dd**2*Pk2*f**2 + 96*D1**2*K*Pk2*f*fd*r*s - 48*D1**2*K*Pk2*f*fd*r + 248*D1**2*K*Pk2*f*fd*s**2 - 248*D1**2*K*Pk2*f*fd*s + 124*D1**2*K*Pk2*f*fd - 96*D1**2*K*Pk2*f*fdd*r*s + 48*D1**2*K*Pk2*f*fdd*r - 248*D1**2*K*Pk2*f*fdd*s**2 + 248*D1**2*K*Pk2*f*fdd*s - 124*D1**2*K*Pk2*f*fdd - 96*D1**2*K*Pk2*fd**2*r*s + 48*D1**2*K*Pk2*fd**2*r - 248*D1**2*K*Pk2*fd**2*s**2 + 248*D1**2*K*Pk2*fd**2*s + 56*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 4*D1**2*Pk2*bdd1*(3*f**2*(28*r**2 + r*(56*s - 46) + 28*s**2 - 50*s + 25) + f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(-54*r*s + 27*r - 40*s**2 + 67*s - 20) + 47*r**2 + 124*r*s - 109*r + 63*s**2 - 149*s + 55) - 28*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 360*D1**2*Pk2*f**2*fd*r**2 + 576*D1**2*Pk2*f**2*fd*r*s - 384*D1**2*Pk2*f**2*fd*r - 264*D1**2*Pk2*f**2*fd*s + 132*D1**2*Pk2*f**2*fd - 360*D1**2*Pk2*f**2*fdd*r**2 - 576*D1**2*Pk2*f**2*fdd*r*s + 384*D1**2*Pk2*f**2*fdd*r + 264*D1**2*Pk2*f**2*fdd*s - 132*D1**2*Pk2*f**2*fdd - 720*D1**2*Pk2*f*fd**2*r**2 - 1152*D1**2*Pk2*f*fd**2*r*s + 768*D1**2*Pk2*f*fd**2*r + 528*D1**2*Pk2*f*fd**2*s - 144*D1**2*Pk2*f*fd**2 - 136*D1**2*Pk2*f*fd*r**2 - 816*D1**2*Pk2*f*fd*r*s + 136*D1**2*Pk2*f*fd*r - 596*D1**2*Pk2*f*fd*s**2 + 484*D1**2*Pk2*f*fd*s - 106*D1**2*Pk2*f*fd + 176*D1**2*Pk2*f*fdd*r**2 + 816*D1**2*Pk2*f*fdd*r*s - 176*D1**2*Pk2*f*fdd*r + 588*D1**2*Pk2*f*fdd*s**2 - 484*D1**2*Pk2*f*fdd*s + 126*D1**2*Pk2*f*fdd - 208*D1**2*Pk2*f*gd2*r*s - 152*D1**2*Pk2*f*gd2*s**2 + 208*D1**2*Pk2*f*gd2*s + 216*D1**2*Pk2*f*gdd2*r*s + 160*D1**2*Pk2*f*gdd2*s**2 - 216*D1**2*Pk2*f*gdd2*s + 176*D1**2*Pk2*fd**2*r**2 + 816*D1**2*Pk2*fd**2*r*s - 176*D1**2*Pk2*fd**2*r + 588*D1**2*Pk2*fd**2*s**2 - 484*D1**2*Pk2*fd**2*s - 208*D1**2*Pk2*fd*g2*r*s - 152*D1**2*Pk2*fd*g2*s**2 + 432*D1**2*Pk2*fd*gd2*r*s + 320*D1**2*Pk2*fd*gd2*s**2 - 216*D1**2*Pk2*fd*gd2*s + 216*D1**2*Pk2*fdd*g2*r*s + 160*D1**2*Pk2*fdd*g2*s**2 - 15*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 192*D1*Dd*K*Pk2*f**2*r*s - 48*D1*Dd*K*Pk2*f**2*r + 496*D1*Dd*K*Pk2*f**2*s**2 - 344*D1*Dd*K*Pk2*f**2*s + 124*D1*Dd*K*Pk2*f**2 - 768*D1*Dd*K*Pk2*f*fd*r*s + 288*D1*Dd*K*Pk2*f*fd*r - 1984*D1*Dd*K*Pk2*f*fd*s**2 + 1680*D1*Dd*K*Pk2*f*fd*s - 344*D1*Dd*K*Pk2*f*fd + 480*D1*Dd*Pk2*f**3*r**2 + 768*D1*Dd*Pk2*f**3*r*s - 672*D1*Dd*Pk2*f**3*r - 384*D1*Dd*Pk2*f**3*s + 240*D1*Dd*Pk2*f**3 - 2880*D1*Dd*Pk2*f**2*fd*r**2 - 4608*D1*Dd*Pk2*f**2*fd*r*s + 3552*D1*Dd*Pk2*f**2*fd*r + 2208*D1*Dd*Pk2*f**2*fd*s - 1032*D1*Dd*Pk2*f**2*fd - 272*D1*Dd*Pk2*f**2*r**2 - 1632*D1*Dd*Pk2*f**2*r*s + 680*D1*Dd*Pk2*f**2*r - 1192*D1*Dd*Pk2*f**2*s**2 + 1412*D1*Dd*Pk2*f**2*s - 434*D1*Dd*Pk2*f**2 + 1408*D1*Dd*Pk2*f*fd*r**2 + 6528*D1*Dd*Pk2*f*fd*r*s - 2224*D1*Dd*Pk2*f*fd*r + 4704*D1*Dd*Pk2*f*fd*s**2 - 4744*D1*Dd*Pk2*f*fd*s + 836*D1*Dd*Pk2*f*fd - 832*D1*Dd*Pk2*f*g2*r*s + 208*D1*Dd*Pk2*f*g2*r - 608*D1*Dd*Pk2*f*g2*s**2 + 720*D1*Dd*Pk2*f*g2*s - 152*D1*Dd*Pk2*f*g2 + 1728*D1*Dd*Pk2*f*gd2*r*s - 216*D1*Dd*Pk2*f*gd2*r + 1280*D1*Dd*Pk2*f*gd2*s**2 - 1616*D1*Dd*Pk2*f*gd2*s + 216*D1*Dd*Pk2*f*gd2 + 1728*D1*Dd*Pk2*fd*g2*r*s - 216*D1*Dd*Pk2*fd*g2*r + 1280*D1*Dd*Pk2*fd*g2*s**2 - 752*D1*Dd*Pk2*fd*g2*s - 20*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 10*D1*Dd*Pkdd2*f**3*k1**2*s - 5*D1*Dd*Pkdd2*f**3*k1**2 - 192*D1*Ddd*K*Pk2*f**2*r*s + 48*D1*Ddd*K*Pk2*f**2*r - 496*D1*Ddd*K*Pk2*f**2*s**2 + 344*D1*Ddd*K*Pk2*f**2*s - 124*D1*Ddd*K*Pk2*f**2 - 480*D1*Ddd*Pk2*f**3*r**2 - 768*D1*Ddd*Pk2*f**3*r*s + 672*D1*Ddd*Pk2*f**3*r + 384*D1*Ddd*Pk2*f**3*s - 240*D1*Ddd*Pk2*f**3 + 352*D1*Ddd*Pk2*f**2*r**2 + 1632*D1*Ddd*Pk2*f**2*r*s - 760*D1*Ddd*Pk2*f**2*r + 1176*D1*Ddd*Pk2*f**2*s**2 - 1404*D1*Ddd*Pk2*f**2*s + 470*D1*Ddd*Pk2*f**2 + 864*D1*Ddd*Pk2*f*g2*r*s - 216*D1*Ddd*Pk2*f*g2*r + 640*D1*Ddd*Pk2*f*g2*s**2 - 752*D1*Ddd*Pk2*f*g2*s + 160*D1*Ddd*Pk2*f*g2 - 4*D1*Pk2*bd1*(D1*(3*f**2*(20*r**2 + 14*r*(4*s - 3) + 36*s**2 - 58*s + 27) + f*(20*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 52*K*r*s + 26*K*r - 38*K*s**2 + 64*K*s - 19*K - 168*fd*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + 31*r**2 + 122*r*s - 92*r + 77*s**2 - 158*s + 54) + fd*(-24*C*(r*(4*s - 1) + (1 - 2*s)**2) + 80*K*s**2 - 67*K*s - 94*r**2 + r*(27*K*(4*s - 1) - 248*s + 109) - 126*s**2 + 101*s + 24) - 28*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 28*gd2*(-4*r*s + r - (1 - 2*s)**2)) - Dd*(6*f**2*(112*r**2 + 16*r*(14*s - 11) + 112*s**2 - 184*s + 71) + f*(48*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + K*(-54*r*(8*s - 3) - 320*s**2 + 456*s - 121) + 376*r**2 + 992*r*s - 748*r + 504*s**2 - 970*s + 367) - 56*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 576*Dd**2*K*Pk2*f**2*r*s + 144*Dd**2*K*Pk2*f**2*r - 1488*Dd**2*K*Pk2*f**2*s**2 + 1032*Dd**2*K*Pk2*f**2*s - 96*Dd**2*K*Pk2*f**2 - 1440*Dd**2*Pk2*f**3*r**2 - 2304*Dd**2*Pk2*f**3*r*s + 2016*Dd**2*Pk2*f**3*r + 1152*Dd**2*Pk2*f**3*s - 624*Dd**2*Pk2*f**3 + 1056*Dd**2*Pk2*f**2*r**2 + 4896*Dd**2*Pk2*f**2*r*s - 2280*Dd**2*Pk2*f**2*r + 3528*Dd**2*Pk2*f**2*s**2 - 4212*Dd**2*Pk2*f**2*s + 992*Dd**2*Pk2*f**2 + 2592*Dd**2*Pk2*f*g2*r*s - 648*Dd**2*Pk2*f*g2*r + 1920*Dd**2*Pk2*f*g2*s**2 - 2256*Dd**2*Pk2*f*g2*s + 432*Dd**2*Pk2*f*g2))/(21*d**2*k2*k3**4) - 5*D1**2*Pk3*ct*k1*k2*st**6*(2496*C*D1**2*Pk2*f**2*fd*r*s - 832*C*D1**2*Pk2*f**2*fd*r - 2496*C*D1**2*Pk2*f**2*fd*s**2 + 832*C*D1**2*Pk2*f**2*fd*s - 832*C*D1**2*Pk2*f**2*fd - 1248*C*D1**2*Pk2*f**2*fdd*r*s + 416*C*D1**2*Pk2*f**2*fdd*r + 1248*C*D1**2*Pk2*f**2*fdd*s**2 - 416*C*D1**2*Pk2*f**2*fdd*s + 416*C*D1**2*Pk2*f**2*fdd - 2496*C*D1**2*Pk2*f*fd**2*r*s + 832*C*D1**2*Pk2*f*fd**2*r + 2496*C*D1**2*Pk2*f*fd**2*s**2 - 832*C*D1**2*Pk2*f*fd**2*s - 416*C*D1**2*Pk2*f*fd**2 + 3328*C*D1*Dd*Pk2*f**3*r*s - 832*C*D1*Dd*Pk2*f**3*r - 3328*C*D1*Dd*Pk2*f**3*s**2 - 832*C*D1*Dd*Pk2*f**3 - 9984*C*D1*Dd*Pk2*f**2*fd*r*s + 2912*C*D1*Dd*Pk2*f**2*fd*r + 9984*C*D1*Dd*Pk2*f**2*fd*s**2 - 1664*C*D1*Dd*Pk2*f**2*fd*s - 416*C*D1*Dd*Pk2*f**2*fd - 1664*C*D1*Ddd*Pk2*f**3*r*s + 416*C*D1*Ddd*Pk2*f**3*r + 1664*C*D1*Ddd*Pk2*f**3*s**2 + 416*C*D1*Ddd*Pk2*f**3 - 4992*C*Dd**2*Pk2*f**3*r*s + 1248*C*Dd**2*Pk2*f**3*r + 4992*C*Dd**2*Pk2*f**3*s**2 - 832*C*Dd**2*Pk2*f**3 - 6864*D1**2*K*Pk2*bdd1*f**2*r*s + 6864*D1**2*K*Pk2*bdd1*f**2*s**2 + 6864*D1**2*K*Pk2*bdd1*f**2*s + 1456*D1**2*Pk2*bdd1*f**3*r*s + 728*D1**2*Pk2*bdd1*f**3*s**2 - 1456*D1**2*Pk2*bdd1*f**3*s + 13728*D1**2*Pk2*bdd1*f**2*r*s + 3432*D1**2*Pk2*bdd1*f**2*s**2 - 13728*D1**2*Pk2*bdd1*f**2*s + 5824*D1**2*Pk2*f**3*fd*r*s - 1456*D1**2*Pk2*f**3*fd*r - 2912*D1**2*Pk2*f**3*fd*s - 5824*D1**2*Pk2*f**3*fdd*r*s + 1456*D1**2*Pk2*f**3*fdd*r + 2912*D1**2*Pk2*f**3*fdd*s - 17472*D1**2*Pk2*f**2*fd**2*r*s + 4368*D1**2*Pk2*f**2*fd**2*r + 8736*D1**2*Pk2*f**2*fd**2*s - 2912*D1**2*Pk2*f**2*fd**2 - 3744*D1**2*Pk2*f**2*fd*r*s + 1248*D1**2*Pk2*f**2*fd*r + 624*D1**2*Pk2*f**2*fd*s**2 + 832*D1**2*Pk2*f**2*fd*s + 208*D1**2*Pk2*f**2*fd + 1872*D1**2*Pk2*f**2*fdd*r*s - 624*D1**2*Pk2*f**2*fdd*r - 312*D1**2*Pk2*f**2*fdd*s**2 - 416*D1**2*Pk2*f**2*fdd*s - 104*D1**2*Pk2*f**2*fdd - 27456*D1**2*Pk2*f**2*gd2*r*s + 27456*D1**2*Pk2*f**2*gd2*s**2 + 27456*D1**2*Pk2*f**2*gd2*s + 13728*D1**2*Pk2*f**2*gdd2*r*s - 13728*D1**2*Pk2*f**2*gdd2*s**2 - 13728*D1**2*Pk2*f**2*gdd2*s + 3744*D1**2*Pk2*f*fd**2*r*s - 1248*D1**2*Pk2*f*fd**2*r - 624*D1**2*Pk2*f*fd**2*s**2 - 832*D1**2*Pk2*f*fd**2*s + 624*D1**2*Pk2*f*fd**2 - 54912*D1**2*Pk2*f*fd*g2*r*s + 27456*D1**2*Pk2*f*fd*g2*r + 54912*D1**2*Pk2*f*fd*g2*s**2 - 54912*D1**2*Pk2*f*fd*g2*s + 27456*D1**2*Pk2*f*fd*g2 + 54912*D1**2*Pk2*f*fd*gd2*r*s - 13728*D1**2*Pk2*f*fd*gd2*r - 54912*D1**2*Pk2*f*fd*gd2*s**2 + 13728*D1**2*Pk2*f*fd*gd2 + 27456*D1**2*Pk2*f*fdd*g2*r*s - 13728*D1**2*Pk2*f*fdd*g2*r - 27456*D1**2*Pk2*f*fdd*g2*s**2 + 27456*D1**2*Pk2*f*fdd*g2*s - 13728*D1**2*Pk2*f*fdd*g2 + 27456*D1**2*Pk2*fd**2*g2*r*s - 13728*D1**2*Pk2*fd**2*g2*r - 27456*D1**2*Pk2*fd**2*g2*s**2 + 27456*D1**2*Pk2*fd**2*g2*s + 504*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 252*D1**2*Pkdd2*f**3*fd*k1**2*s + 126*D1**2*Pkdd2*f**3*fd*k1**2 - 252*D1**2*Pkdd2*f**3*fdd*k1**2*s**2 + 126*D1**2*Pkdd2*f**3*fdd*k1**2*s - 63*D1**2*Pkdd2*f**3*fdd*k1**2 - 756*D1**2*Pkdd2*f**2*fd**2*k1**2*s**2 + 378*D1**2*Pkdd2*f**2*fd**2*k1**2*s + 5824*D1*Dd*Pk2*f**4*r*s - 1456*D1*Dd*Pk2*f**4*r - 2912*D1*Dd*Pk2*f**4*s - 46592*D1*Dd*Pk2*f**3*fd*r*s + 11648*D1*Dd*Pk2*f**3*fd*r + 23296*D1*Dd*Pk2*f**3*fd*s - 5824*D1*Dd*Pk2*f**3*fd - 4992*D1*Dd*Pk2*f**3*r*s + 1248*D1*Dd*Pk2*f**3*r + 832*D1*Dd*Pk2*f**3*s**2 + 2080*D1*Dd*Pk2*f**3*s + 208*D1*Dd*Pk2*f**3 + 14976*D1*Dd*Pk2*f**2*fd*r*s - 4368*D1*Dd*Pk2*f**2*fd*r - 2496*D1*Dd*Pk2*f**2*fd*s**2 - 4784*D1*Dd*Pk2*f**2*fd*s + 1664*D1*Dd*Pk2*f**2*fd - 109824*D1*Dd*Pk2*f**2*g2*r*s + 27456*D1*Dd*Pk2*f**2*g2*r + 109824*D1*Dd*Pk2*f**2*g2*s**2 + 27456*D1*Dd*Pk2*f**2*g2 + 109824*D1*Dd*Pk2*f**2*gd2*r*s - 13728*D1*Dd*Pk2*f**2*gd2*r - 109824*D1*Dd*Pk2*f**2*gd2*s**2 - 54912*D1*Dd*Pk2*f**2*gd2*s + 13728*D1*Dd*Pk2*f**2*gd2 + 219648*D1*Dd*Pk2*f*fd*g2*r*s - 82368*D1*Dd*Pk2*f*fd*g2*r - 219648*D1*Dd*Pk2*f*fd*g2*s**2 + 109824*D1*Dd*Pk2*f*fd*g2*s + 504*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 252*D1*Dd*Pkdd2*f**4*k1**2*s + 126*D1*Dd*Pkdd2*f**4*k1**2 - 2016*D1*Dd*Pkdd2*f**3*fd*k1**2*s**2 + 1008*D1*Dd*Pkdd2*f**3*fd*k1**2*s - 126*D1*Dd*Pkdd2*f**3*fd*k1**2 - 5824*D1*Ddd*Pk2*f**4*r*s + 1456*D1*Ddd*Pk2*f**4*r + 2912*D1*Ddd*Pk2*f**4*s + 2496*D1*Ddd*Pk2*f**3*r*s - 624*D1*Ddd*Pk2*f**3*r - 416*D1*Ddd*Pk2*f**3*s**2 - 1040*D1*Ddd*Pk2*f**3*s - 104*D1*Ddd*Pk2*f**3 + 54912*D1*Ddd*Pk2*f**2*g2*r*s - 13728*D1*Ddd*Pk2*f**2*g2*r - 54912*D1*Ddd*Pk2*f**2*g2*s**2 - 13728*D1*Ddd*Pk2*f**2*g2 - 252*D1*Ddd*Pkdd2*f**4*k1**2*s**2 + 126*D1*Ddd*Pkdd2*f**4*k1**2*s - 63*D1*Ddd*Pkdd2*f**4*k1**2 - 208*D1*Pk2*bd1*f*(-7*D1*f*fd*(r*(6*s - 1) + 3*s**2 - 5*s + 1) + D1*f*s*(-66*K*(r - s - 1) + 7*f*(2*r + s - 2) + 132*r + 33*s - 132) + 33*D1*fd*(K*r*(4*s - 1) - 4*K*s**2 + K + r*(2 - 8*s) - 2*s**2 + 5*s - 2) - 7*Dd*f**2*(r*(8*s - 1) + 4*s**2 - 7*s + 1) + 33*Dd*f*(-K*(-8*r*s + r + 8*s**2 + 4*s - 1) + r*(2 - 16*s) - 4*s**2 + 13*s - 2)) - 17472*Dd**2*Pk2*f**4*r*s + 4368*Dd**2*Pk2*f**4*r + 8736*Dd**2*Pk2*f**4*s - 2912*Dd**2*Pk2*f**4 + 7488*Dd**2*Pk2*f**3*r*s - 1872*Dd**2*Pk2*f**3*r - 1248*Dd**2*Pk2*f**3*s**2 - 3120*Dd**2*Pk2*f**3*s + 1248*Dd**2*Pk2*f**3 + 164736*Dd**2*Pk2*f**2*g2*r*s - 41184*Dd**2*Pk2*f**2*g2*r - 164736*Dd**2*Pk2*f**2*g2*s**2 + 27456*Dd**2*Pk2*f**2*g2 - 756*Dd**2*Pkdd2*f**4*k1**2*s**2 + 378*Dd**2*Pkdd2*f**4*k1**2*s - 104*Pk2*b1*(D1**2*(7*f**2*(2*fd - fdd)*(3*s - 1)*(2*r + s - 1) + f*(-14*fd**2*(3*s - 1)*(2*r + s - 1) - 66*fd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) - 8*r*s + 4*r - 2*s**2 + 2*s - 1) + 33*fdd*(-2*K*(-2*r*s + r + 2*s**2 - 2*s + 1) - 8*r*s + 4*r - 2*s**2 + 2*s - 1)) + 66*fd**2*(r*(K - 2)*(2*s - 1) - s*(2*K + 1)*(s - 1))) + D1*f*(2*Dd*(7*f**2*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + f*(66*K*(-4*r*s + r + 4*s**2 + 1) - 7*fd*(r*(24*s - 7) + 12*s**2 - 17*s + 4) + 528*r*s - 132*r + 132*s**2 - 330*s + 33) + 33*fd*(r*(2*K - 4)*(8*s - 3) - (2*s - 1)*(8*K*s + 4*s - 5))) - Ddd*f*(66*K*(-4*r*s + r + 4*s**2 + 1) + 7*f*(r*(8*s - 2) + 4*s**2 - 6*s + 1) + 528*r*s - 132*r + 132*s**2 - 330*s + 33)) - 2*Dd**2*f**2*(-33*K*(12*r*s - 3*r - 12*s**2 + 2) + 7*f*(3*r*(4*s - 1) + 6*s**2 - 9*s + 2) + 792*r*s - 198*r + 198*s**2 - 495*s + 132)))/(18018*d**2*k3**4) + D1**2*Pk3*ct*k1*k2*st**4*(-48*C*D1**2*Pk2*f**2*fd*r**2 + 1872*C*D1**2*Pk2*f**2*fd*r*s - 592*C*D1**2*Pk2*f**2*fd*r + 1920*C*D1**2*Pk2*f**2*fd*s**2 - 1904*C*D1**2*Pk2*f**2*fd*s + 624*C*D1**2*Pk2*f**2*fd + 24*C*D1**2*Pk2*f**2*fdd*r**2 - 936*C*D1**2*Pk2*f**2*fdd*r*s + 296*C*D1**2*Pk2*f**2*fdd*r - 960*C*D1**2*Pk2*f**2*fdd*s**2 + 952*C*D1**2*Pk2*f**2*fdd*s - 312*C*D1**2*Pk2*f**2*fdd + 48*C*D1**2*Pk2*f*fd**2*r**2 - 1872*C*D1**2*Pk2*f*fd**2*r*s + 592*C*D1**2*Pk2*f*fd**2*r - 1920*C*D1**2*Pk2*f*fd**2*s**2 + 1904*C*D1**2*Pk2*f*fd**2*s - 312*C*D1**2*Pk2*f*fd**2 - 24*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 16*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 8*C*D1**2*Pkdd2*f**2*fd*k1**2 + 12*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 8*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 4*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 24*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 16*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 64*C*D1*Dd*Pk2*f**3*r**2 + 2496*C*D1*Dd*Pk2*f**3*r*s - 560*C*D1*Dd*Pk2*f**3*r + 2560*C*D1*Dd*Pk2*f**3*s**2 - 2528*C*D1*Dd*Pk2*f**3*s + 608*C*D1*Dd*Pk2*f**3 + 192*C*D1*Dd*Pk2*f**2*fd*r**2 - 7488*C*D1*Dd*Pk2*f**2*fd*r*s + 2024*C*D1*Dd*Pk2*f**2*fd*r - 7680*C*D1*Dd*Pk2*f**2*fd*s**2 + 7600*C*D1*Dd*Pk2*f**2*fd*s - 1544*C*D1*Dd*Pk2*f**2*fd - 32*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 16*C*D1*Dd*Pkdd2*f**3*k1**2*s - 8*C*D1*Dd*Pkdd2*f**3*k1**2 + 96*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 56*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 8*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 32*C*D1*Ddd*Pk2*f**3*r**2 - 1248*C*D1*Ddd*Pk2*f**3*r*s + 280*C*D1*Ddd*Pk2*f**3*r - 1280*C*D1*Ddd*Pk2*f**3*s**2 + 1264*C*D1*Ddd*Pk2*f**3*s - 304*C*D1*Ddd*Pk2*f**3 + 16*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 8*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 4*C*D1*Ddd*Pkdd2*f**3*k1**2 + 96*C*Dd**2*Pk2*f**3*r**2 - 3744*C*Dd**2*Pk2*f**3*r*s + 840*C*Dd**2*Pk2*f**3*r - 3840*C*Dd**2*Pk2*f**3*s**2 + 3792*C*Dd**2*Pk2*f**3*s - 608*C*Dd**2*Pk2*f**3 + 48*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 24*C*Dd**2*Pkdd2*f**3*k1**2*s - 264*D1**2*K*Pk2*bdd1*f**2*r**2 - 132*D1**2*K*Pk2*bdd1*f**2*r*s + 528*D1**2*K*Pk2*bdd1*f**2*r + 1188*D1**2*K*Pk2*bdd1*f**2*s**2 + 132*D1**2*K*Pk2*bdd1*f**2*s - 264*D1**2*K*Pk2*bdd1*f**2 + 528*D1**2*Pk2*b2*f*fd*r*s - 264*D1**2*Pk2*b2*f*fd*r + 528*D1**2*Pk2*b2*f*fd*s**2 - 528*D1**2*Pk2*b2*f*fd*s + 264*D1**2*Pk2*b2*f*fd + 264*D1**2*Pk2*bd1**2*f*(K*(2*r**2 - 3*r - 4*s**2 + 1) + (2 - 2*r)*(r + 2*s - 1)) + 264*D1**2*Pk2*bd2*f**2*r*s + 264*D1**2*Pk2*bd2*f**2*s**2 - 264*D1**2*Pk2*bd2*f**2*s + 594*D1**2*Pk2*bdd1*f**2*r**2 + 1320*D1**2*Pk2*bdd1*f**2*r*s - 1188*D1**2*Pk2*bdd1*f**2*r - 1320*D1**2*Pk2*bdd1*f**2*s + 594*D1**2*Pk2*bdd1*f**2 - 528*D1**2*Pk2*bdd1*f*g2*r**2 + 528*D1**2*Pk2*bdd1*f*g2*r + 1056*D1**2*Pk2*bdd1*f*g2*s**2 + 264*D1**2*Pk2*f**2*fd*r**2 - 672*D1**2*Pk2*f**2*fd*r*s + 48*D1**2*Pk2*f**2*fd*r - 960*D1**2*Pk2*f**2*fd*s**2 + 864*D1**2*Pk2*f**2*fd*s - 232*D1**2*Pk2*f**2*fd - 132*D1**2*Pk2*f**2*fdd*r**2 + 336*D1**2*Pk2*f**2*fdd*r*s - 24*D1**2*Pk2*f**2*fdd*r + 480*D1**2*Pk2*f**2*fdd*s**2 - 432*D1**2*Pk2*f**2*fdd*s + 116*D1**2*Pk2*f**2*fdd - 528*D1**2*Pk2*f**2*gd2*r**2 - 1056*D1**2*Pk2*f**2*gd2*r*s + 1056*D1**2*Pk2*f**2*gd2*r + 1848*D1**2*Pk2*f**2*gd2*s**2 + 1056*D1**2*Pk2*f**2*gd2*s - 528*D1**2*Pk2*f**2*gd2 + 528*D1**2*Pk2*f**2*gdd2*r**2 + 264*D1**2*Pk2*f**2*gdd2*r*s - 1056*D1**2*Pk2*f**2*gdd2*r - 2376*D1**2*Pk2*f**2*gdd2*s**2 - 264*D1**2*Pk2*f**2*gdd2*s + 528*D1**2*Pk2*f**2*gdd2 - 264*D1**2*Pk2*f*fd**2*r**2 + 672*D1**2*Pk2*f*fd**2*r*s - 48*D1**2*Pk2*f*fd**2*r + 960*D1**2*Pk2*f*fd**2*s**2 - 864*D1**2*Pk2*f*fd**2*s + 112*D1**2*Pk2*f*fd**2 - 1056*D1**2*Pk2*f*fd*g2*r**2 - 2112*D1**2*Pk2*f*fd*g2*r*s + 1056*D1**2*Pk2*f*fd*g2*r + 3696*D1**2*Pk2*f*fd*g2*s**2 - 3696*D1**2*Pk2*f*fd*g2*s + 1848*D1**2*Pk2*f*fd*g2 + 2112*D1**2*Pk2*f*fd*gd2*r**2 + 1056*D1**2*Pk2*f*fd*gd2*r*s - 2376*D1**2*Pk2*f*fd*gd2*r - 9504*D1**2*Pk2*f*fd*gd2*s**2 + 4224*D1**2*Pk2*f*fd*gd2*s + 264*D1**2*Pk2*f*fd*gd2 + 1056*D1**2*Pk2*f*fdd*g2*r**2 + 528*D1**2*Pk2*f*fdd*g2*r*s - 264*D1**2*Pk2*f*fdd*g2*r - 4752*D1**2*Pk2*f*fdd*g2*s**2 + 4752*D1**2*Pk2*f*fdd*g2*s - 2376*D1**2*Pk2*f*fdd*g2 + 1056*D1**2*Pk2*fd**2*g2*r**2 + 528*D1**2*Pk2*fd**2*g2*r*s - 264*D1**2*Pk2*fd**2*g2*r - 4752*D1**2*Pk2*fd**2*g2*s**2 + 4752*D1**2*Pk2*fd**2*g2*s - 30*D1**2*Pkdd2*bdd1*f**3*k1**2*s + 15*D1**2*Pkdd2*bdd1*f**3*k1**2 + 60*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 30*D1**2*Pkdd2*f**3*fd*k1**2*s + 15*D1**2*Pkdd2*f**3*fd*k1**2 + 18*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 12*D1**2*Pkdd2*f**2*fd*k1**2*s + 6*D1**2*Pkdd2*f**2*fd*k1**2 - 9*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 6*D1**2*Pkdd2*f**2*fdd*k1**2*s - 3*D1**2*Pkdd2*f**2*fdd*k1**2 - 18*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 12*D1**2*Pkdd2*f*fd**2*k1**2*s + 1056*D1*Dd*Pk2*b2*f**2*r*s - 264*D1*Dd*Pk2*b2*f**2*r + 1056*D1*Dd*Pk2*b2*f**2*s**2 - 1056*D1*Dd*Pk2*b2*f**2*s + 264*D1*Dd*Pk2*b2*f**2 + 352*D1*Dd*Pk2*f**3*r**2 - 896*D1*Dd*Pk2*f**3*r*s - 128*D1*Dd*Pk2*f**3*r - 1280*D1*Dd*Pk2*f**3*s**2 + 1088*D1*Dd*Pk2*f**3*s - 144*D1*Dd*Pk2*f**3 - 1056*D1*Dd*Pk2*f**2*fd*r**2 + 2688*D1*Dd*Pk2*f**2*fd*r*s + 96*D1*Dd*Pk2*f**2*fd*r + 3840*D1*Dd*Pk2*f**2*fd*s**2 - 3360*D1*Dd*Pk2*f**2*fd*s + 480*D1*Dd*Pk2*f**2*fd - 2112*D1*Dd*Pk2*f**2*g2*r**2 - 4224*D1*Dd*Pk2*f**2*g2*r*s + 3168*D1*Dd*Pk2*f**2*g2*r + 7392*D1*Dd*Pk2*f**2*g2*s**2 - 1584*D1*Dd*Pk2*f**2*g2*s + 792*D1*Dd*Pk2*f**2*g2 + 4224*D1*Dd*Pk2*f**2*gd2*r**2 + 2112*D1*Dd*Pk2*f**2*gd2*r*s - 6600*D1*Dd*Pk2*f**2*gd2*r - 19008*D1*Dd*Pk2*f**2*gd2*s**2 + 3168*D1*Dd*Pk2*f**2*gd2*s + 2376*D1*Dd*Pk2*f**2*gd2 + 8448*D1*Dd*Pk2*f*fd*g2*r**2 + 4224*D1*Dd*Pk2*f*fd*g2*r*s - 5808*D1*Dd*Pk2*f*fd*g2*r - 38016*D1*Dd*Pk2*f*fd*g2*s**2 + 27456*D1*Dd*Pk2*f*fd*g2*s - 4224*D1*Dd*Pk2*f*fd*g2 + 60*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 30*D1*Dd*Pkdd2*f**4*k1**2*s + 15*D1*Dd*Pkdd2*f**4*k1**2 + 24*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 12*D1*Dd*Pkdd2*f**3*k1**2*s + 6*D1*Dd*Pkdd2*f**3*k1**2 - 72*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 42*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 6*D1*Dd*Pkdd2*f**2*fd*k1**2 - 176*D1*Ddd*Pk2*f**3*r**2 + 448*D1*Ddd*Pk2*f**3*r*s + 64*D1*Ddd*Pk2*f**3*r + 640*D1*Ddd*Pk2*f**3*s**2 - 544*D1*Ddd*Pk2*f**3*s + 72*D1*Ddd*Pk2*f**3 + 2112*D1*Ddd*Pk2*f**2*g2*r**2 + 1056*D1*Ddd*Pk2*f**2*g2*r*s - 2376*D1*Ddd*Pk2*f**2*g2*r - 9504*D1*Ddd*Pk2*f**2*g2*s**2 + 4224*D1*Ddd*Pk2*f**2*g2*s - 1320*D1*Ddd*Pk2*f**2*g2 - 12*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**3*k1**2*s - 3*D1*Ddd*Pkdd2*f**3*k1**2 + 6*D1*bd1*(D1*(-22*Pk2*f*(K*fd*(8*r**2 + r*(4*s - 9) - 36*s**2 + 16*s + 1) - 2*fd*(9*r**2 + 2*r*(10*s - 7) - 10*s + 5) + 8*g2*(-r**2 + r + 2*s**2) + 4*gd2*(2*r**2 - 3*r - 4*s**2 + 1)) - 176*Pk2*fd*g2*(r**2 - s*(2*s - 2)) + 5*Pkdd2*f**3*k1**2*(2*s - 1) + f**2*(11*Pk2*(2*K*(2*r**2 + 4*r*(s - 1) - 7*s**2 - 4*s + 2) - 5*r**2 - 22*r*s + 10*r - 4*s**2 + 22*s - 5) - 10*Pkdd2*fd*k1**2*s)) - Dd*f*(22*Pk2*f*(K*(16*r**2 + r*(8*s - 25) - 72*s**2 + 12*s + 9) - 36*r**2 - 16*r*(5*s - 4) + 60*s - 28) + 176*Pk2*g2*(4*r**2 - 4*r - 8*s**2 + 2*s + 1) + 5*Pkdd2*f**2*k1**2*(4*s - 1))) - 528*Dd**2*Pk2*f**3*r**2 + 1344*Dd**2*Pk2*f**3*r*s + 192*Dd**2*Pk2*f**3*r + 1920*Dd**2*Pk2*f**3*s**2 - 1632*Dd**2*Pk2*f**3*s + 136*Dd**2*Pk2*f**3 + 6336*Dd**2*Pk2*f**2*g2*r**2 + 3168*Dd**2*Pk2*f**2*g2*r*s - 7128*Dd**2*Pk2*f**2*g2*r - 28512*Dd**2*Pk2*f**2*g2*s**2 + 12672*Dd**2*Pk2*f**2*g2*s + 1584*Dd**2*Pk2*f**2*g2 - 36*Dd**2*Pkdd2*f**3*k1**2*s**2 + 18*Dd**2*Pkdd2*f**3*k1**2*s - 264*Pk2*b1**2*(D1**2*(2*fd - fdd)*(K*(r**2 + r - 2*(s - 1)**2) - (r + 1)*(r + 2*s - 1)) + 2*D1*(Dd*(K*fd*(-4*r**2 + 8*s**2 - 10*s + 3) + 4*f*r**2*(K - 1) + f*r*(-4*K - 8*s + 6) - 2*f*(2*s - 1)*(2*K*s - 1) + fd*(4*r + 1)*(r + 2*s - 1)) + Ddd*f*(r**2*(2 - 2*K) + r*(2*K + 4*s - 3) + (2*s - 1)*(2*K*s - 1))) - 2*Dd**2*f*(K*(6*r**2 - 6*r - 12*s**2 + 6*s + 1) + (3 - 6*r)*(r + 2*s - 1))) - 3*b1*(-176*D1**2*K*Pk2*f*fd*r**2 - 352*D1**2*K*Pk2*f*fd*r*s + 176*D1**2*K*Pk2*f*fd*r + 616*D1**2*K*Pk2*f*fd*s**2 - 616*D1**2*K*Pk2*f*fd*s + 308*D1**2*K*Pk2*f*fd + 176*D1**2*K*Pk2*f*fdd*r**2 + 88*D1**2*K*Pk2*f*fdd*r*s - 44*D1**2*K*Pk2*f*fdd*r - 792*D1**2*K*Pk2*f*fdd*s**2 + 792*D1**2*K*Pk2*f*fdd*s - 396*D1**2*K*Pk2*f*fdd + 176*D1**2*K*Pk2*fd**2*r**2 + 88*D1**2*K*Pk2*fd**2*r*s - 44*D1**2*K*Pk2*fd**2*r - 792*D1**2*K*Pk2*fd**2*s**2 + 792*D1**2*K*Pk2*fd**2*s - 88*D1**2*Pk2*bdd1*f*(K*(2*r**2 - 3*r - 4*s**2 + 1) + (2 - 2*r)*(r + 2*s - 1)) + 220*D1**2*Pk2*f*fd*r**2 + 968*D1**2*Pk2*f*fd*r*s - 484*D1**2*Pk2*f*fd*r + 176*D1**2*Pk2*f*fd*s**2 - 176*D1**2*Pk2*f*fd*s + 88*D1**2*Pk2*f*fd - 396*D1**2*Pk2*f*fdd*r**2 - 880*D1**2*Pk2*f*fdd*r*s + 440*D1**2*Pk2*f*fdd*r - 352*D1**2*Pk2*f*gd2*r**2 + 704*D1**2*Pk2*f*gd2*r + 704*D1**2*Pk2*f*gd2*s**2 - 352*D1**2*Pk2*f*gd2 + 176*D1**2*Pk2*f*gdd2*r**2 - 352*D1**2*Pk2*f*gdd2*r - 352*D1**2*Pk2*f*gdd2*s**2 + 176*D1**2*Pk2*f*gdd2 - 396*D1**2*Pk2*fd**2*r**2 - 880*D1**2*Pk2*fd**2*r*s + 440*D1**2*Pk2*fd**2*r - 352*D1**2*Pk2*fd*g2*r**2 - 352*D1**2*Pk2*fd*g2*r + 704*D1**2*Pk2*fd*g2*s**2 - 1408*D1**2*Pk2*fd*g2*s + 704*D1**2*Pk2*fd*g2 + 352*D1**2*Pk2*fd*gd2*r**2 - 176*D1**2*Pk2*fd*gd2*r - 704*D1**2*Pk2*fd*gd2*s**2 + 704*D1**2*Pk2*fd*gd2*s - 176*D1**2*Pk2*fd*gd2 + 176*D1**2*Pk2*fdd*g2*r**2 + 176*D1**2*Pk2*fdd*g2*r - 352*D1**2*Pk2*fdd*g2*s**2 + 704*D1**2*Pk2*fdd*g2*s - 352*D1**2*Pk2*fdd*g2 + 20*D1**2*Pkdd2*f**2*fd*k1**2*s - 10*D1**2*Pkdd2*f**2*fd*k1**2 - 10*D1**2*Pkdd2*f**2*fdd*k1**2*s + 5*D1**2*Pkdd2*f**2*fdd*k1**2 - 20*D1**2*Pkdd2*f*fd**2*k1**2*s - 352*D1*Dd*K*Pk2*f**2*r**2 - 704*D1*Dd*K*Pk2*f**2*r*s + 528*D1*Dd*K*Pk2*f**2*r + 1232*D1*Dd*K*Pk2*f**2*s**2 - 264*D1*Dd*K*Pk2*f**2*s + 132*D1*Dd*K*Pk2*f**2 + 1408*D1*Dd*K*Pk2*f*fd*r**2 + 704*D1*Dd*K*Pk2*f*fd*r*s - 968*D1*Dd*K*Pk2*f*fd*r - 6336*D1*Dd*K*Pk2*f*fd*s**2 + 4576*D1*Dd*K*Pk2*f*fd*s - 704*D1*Dd*K*Pk2*f*fd + 440*D1*Dd*Pk2*f**2*r**2 + 1936*D1*Dd*Pk2*f**2*r*s - 924*D1*Dd*Pk2*f**2*r + 352*D1*Dd*Pk2*f**2*s**2 - 1144*D1*Dd*Pk2*f**2*s + 308*D1*Dd*Pk2*f**2 - 3168*D1*Dd*Pk2*f*fd*r**2 - 7040*D1*Dd*Pk2*f*fd*r*s + 4224*D1*Dd*Pk2*f*fd*r + 1760*D1*Dd*Pk2*f*fd*s - 880*D1*Dd*Pk2*f*fd - 1408*D1*Dd*Pk2*f*g2*r**2 + 1408*D1*Dd*Pk2*f*g2*r + 2816*D1*Dd*Pk2*f*g2*s**2 - 1408*D1*Dd*Pk2*f*g2*s + 1408*D1*Dd*Pk2*f*gd2*r**2 - 2112*D1*Dd*Pk2*f*gd2*r - 2816*D1*Dd*Pk2*f*gd2*s**2 + 704*D1*Dd*Pk2*f*gd2*s + 704*D1*Dd*Pk2*f*gd2 + 1408*D1*Dd*Pk2*fd*g2*r**2 - 2816*D1*Dd*Pk2*fd*g2*s**2 + 3520*D1*Dd*Pk2*fd*g2*s - 1056*D1*Dd*Pk2*fd*g2 - 40*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 10*D1*Dd*Pkdd2*f**2*fd*k1**2 + 352*D1*Ddd*K*Pk2*f**2*r**2 + 176*D1*Ddd*K*Pk2*f**2*r*s - 396*D1*Ddd*K*Pk2*f**2*r - 1584*D1*Ddd*K*Pk2*f**2*s**2 + 704*D1*Ddd*K*Pk2*f**2*s - 220*D1*Ddd*K*Pk2*f**2 - 792*D1*Ddd*Pk2*f**2*r**2 - 1760*D1*Ddd*Pk2*f**2*r*s + 1232*D1*Ddd*Pk2*f**2*r + 880*D1*Ddd*Pk2*f**2*s - 396*D1*Ddd*Pk2*f**2 + 704*D1*Ddd*Pk2*f*g2*r**2 - 704*D1*Ddd*Pk2*f*g2*r - 1408*D1*Ddd*Pk2*f*g2*s**2 + 704*D1*Ddd*Pk2*f*g2*s + 88*D1*Pk2*bd1*(D1*(2*K*f*(2*r**2 - 3*r - 4*s**2 + 1) + K*fd*(-4*r**2 + r + 8*s**2 - 8*s + 1) - 4*f*(r - 1)*(r + 2*s - 1) + 4*fd*r*(r + 2*s - 1)) + 2*Dd*f*(K*(-8*r**2 + 10*r + 16*s**2 - 4*s - 3) + (8*r - 6)*(r + 2*s - 1))) + 1056*Dd**2*K*Pk2*f**2*r**2 + 528*Dd**2*K*Pk2*f**2*r*s - 1188*Dd**2*K*Pk2*f**2*r - 4752*Dd**2*K*Pk2*f**2*s**2 + 2112*Dd**2*K*Pk2*f**2*s + 264*Dd**2*K*Pk2*f**2 - 2376*Dd**2*Pk2*f**2*r**2 - 5280*Dd**2*Pk2*f**2*r*s + 3696*Dd**2*Pk2*f**2*r + 2640*Dd**2*Pk2*f**2*s - 1276*Dd**2*Pk2*f**2 + 2112*Dd**2*Pk2*f*g2*r**2 - 2112*Dd**2*Pk2*f*g2*r - 4224*Dd**2*Pk2*f*g2*s**2 + 2112*Dd**2*Pk2*f*g2*s + 352*Dd**2*Pk2*f*g2))/(231*d**2*k3**4) - D1**2*Pk3*ct*k1*k2*st**2*(528*C*D1**2*Pk2*bdd1*f**2*r**2 + 3168*C*D1**2*Pk2*bdd1*f**2*r*s + 1584*C*D1**2*Pk2*bdd1*f**2*r + 2904*C*D1**2*Pk2*bdd1*f**2*s**2 + 13224*C*D1**2*Pk2*f**2*fd*r**2 + 74880*C*D1**2*Pk2*f**2*fd*r*s - 33776*C*D1**2*Pk2*f**2*fd*r + 45144*C*D1**2*Pk2*f**2*fd*s**2 - 55056*C*D1**2*Pk2*f**2*fd*s + 19456*C*D1**2*Pk2*f**2*fd - 21264*C*D1**2*Pk2*f**2*fdd*r**2 - 72288*C*D1**2*Pk2*f**2*fdd*r*s + 38272*C*D1**2*Pk2*f**2*fdd*r - 40392*C*D1**2*Pk2*f**2*fdd*s**2 + 51024*C*D1**2*Pk2*f**2*fdd*s - 20552*C*D1**2*Pk2*f**2*fdd - 42528*C*D1**2*Pk2*f*fd**2*r**2 - 144576*C*D1**2*Pk2*f*fd**2*r*s + 76544*C*D1**2*Pk2*f*fd**2*r - 80784*C*D1**2*Pk2*f*fd**2*s**2 + 102048*C*D1**2*Pk2*f*fd**2*s - 24096*C*D1**2*Pk2*f*fd**2 - 132*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 264*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 132*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 396*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 264*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 132*C*D1**2*Pkdd2*f**2*fd*k1**2 + 17632*C*D1*Dd*Pk2*f**3*r**2 + 99840*C*D1*Dd*Pk2*f**3*r*s - 42592*C*D1*Dd*Pk2*f**3*r + 60192*C*D1*Dd*Pk2*f**3*s**2 - 80016*C*D1*Dd*Pk2*f**3*s + 23864*C*D1*Dd*Pk2*f**3 - 170112*C*D1*Dd*Pk2*f**2*fd*r**2 - 578304*C*D1*Dd*Pk2*f**2*fd*r*s + 310432*C*D1*Dd*Pk2*f**2*fd*r - 323136*C*D1*Dd*Pk2*f**2*fd*s**2 + 429456*C*D1*Dd*Pk2*f**2*fd*s - 127568*C*D1*Dd*Pk2*f**2*fd - 528*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 264*C*D1*Dd*Pkdd2*f**3*k1**2*s - 132*C*D1*Dd*Pkdd2*f**3*k1**2 - 28352*C*D1*Ddd*Pk2*f**3*r**2 - 96384*C*D1*Ddd*Pk2*f**3*r*s + 52448*C*D1*Ddd*Pk2*f**3*r - 53856*C*D1*Ddd*Pk2*f**3*s**2 + 75120*C*D1*Ddd*Pk2*f**3*s - 27640*C*D1*Ddd*Pk2*f**3 - 85056*C*Dd**2*Pk2*f**3*r**2 - 289152*C*Dd**2*Pk2*f**3*r*s + 157344*C*Dd**2*Pk2*f**3*r - 161568*C*Dd**2*Pk2*f**3*s**2 + 225360*C*Dd**2*Pk2*f**3*s - 62368*C*Dd**2*Pk2*f**3 - 1848*D1**2*K*Pk2*bdd1*f**2*r**2 - 4752*D1**2*K*Pk2*bdd1*f**2*r*s + 3696*D1**2*K*Pk2*bdd1*f**2*r - 396*D1**2*K*Pk2*bdd1*f**2*s**2 + 4752*D1**2*K*Pk2*bdd1*f**2*s - 1848*D1**2*K*Pk2*bdd1*f**2 + 2376*D1**2*Pk2*b2*f*fd*r**2 + 12672*D1**2*Pk2*b2*f*fd*r*s - 6336*D1**2*Pk2*b2*f*fd*r + 10296*D1**2*Pk2*b2*f*fd*s**2 - 10296*D1**2*Pk2*b2*f*fd*s + 5148*D1**2*Pk2*b2*f*fd - 3960*D1**2*Pk2*b2*f*fdd*r**2 - 12672*D1**2*Pk2*b2*f*fdd*r*s + 6336*D1**2*Pk2*b2*f*fdd*r - 8712*D1**2*Pk2*b2*f*fdd*s**2 + 8712*D1**2*Pk2*b2*f*fdd*s - 4356*D1**2*Pk2*b2*f*fdd - 3960*D1**2*Pk2*b2*fd**2*r**2 - 12672*D1**2*Pk2*b2*fd**2*r*s + 6336*D1**2*Pk2*b2*fd**2*r - 8712*D1**2*Pk2*b2*fd**2*s**2 + 8712*D1**2*Pk2*b2*fd**2*s + 1188*D1**2*Pk2*bd2*f**2*r**2 + 6336*D1**2*Pk2*bd2*f**2*r*s - 2376*D1**2*Pk2*bd2*f**2*r + 5148*D1**2*Pk2*bd2*f**2*s**2 - 6336*D1**2*Pk2*bd2*f**2*s + 1188*D1**2*Pk2*bd2*f**2 - 7920*D1**2*Pk2*bd2*f*fd*r**2 - 25344*D1**2*Pk2*bd2*f*fd*r*s + 14256*D1**2*Pk2*bd2*f*fd*r - 17424*D1**2*Pk2*bd2*f*fd*s**2 + 21384*D1**2*Pk2*bd2*f*fd*s - 6336*D1**2*Pk2*bd2*f*fd + 3168*D1**2*Pk2*bdd1*f**3*r*s - 1980*D1**2*Pk2*bdd1*f**3*r + 1980*D1**2*Pk2*bdd1*f**3*s**2 - 4752*D1**2*Pk2*bdd1*f**3*s + 1782*D1**2*Pk2*bdd1*f**3 + 1386*D1**2*Pk2*bdd1*f**2*r**2 - 528*D1**2*Pk2*bdd1*f**2*r*s - 3696*D1**2*Pk2*bdd1*f**2*r - 3432*D1**2*Pk2*bdd1*f**2*s**2 - 660*D1**2*Pk2*bdd1*f**2*s + 660*D1**2*Pk2*bdd1*f**2 - 2640*D1**2*Pk2*bdd1*f*g2*r**2 + 3168*D1**2*Pk2*bdd1*f*g2*r*s + 4752*D1**2*Pk2*bdd1*f*g2*r + 7656*D1**2*Pk2*bdd1*f*g2*s**2 - 1980*D1**2*Pk2*bdd2*f**2*r**2 - 6336*D1**2*Pk2*bdd2*f**2*r*s + 3960*D1**2*Pk2*bdd2*f**2*r - 4356*D1**2*Pk2*bdd2*f**2*s**2 + 6336*D1**2*Pk2*bdd2*f**2*s - 1980*D1**2*Pk2*bdd2*f**2 - 4230*D1**2*Pk2*f**2*fd*r**2 - 43344*D1**2*Pk2*f**2*fd*r*s + 17268*D1**2*Pk2*f**2*fd*r - 26136*D1**2*Pk2*f**2*fd*s**2 + 31872*D1**2*Pk2*f**2*fd*s - 10122*D1**2*Pk2*f**2*fd + 12114*D1**2*Pk2*f**2*fdd*r**2 + 43848*D1**2*Pk2*f**2*fdd*r*s - 22692*D1**2*Pk2*f**2*fdd*r + 23760*D1**2*Pk2*f**2*fdd*s**2 - 30456*D1**2*Pk2*f**2*fdd*s + 11958*D1**2*Pk2*f**2*fdd - 1320*D1**2*Pk2*f**2*gd2*r**2 - 9504*D1**2*Pk2*f**2*gd2*r*s + 2640*D1**2*Pk2*f**2*gd2*r - 2376*D1**2*Pk2*f**2*gd2*s**2 + 9504*D1**2*Pk2*f**2*gd2*s - 1320*D1**2*Pk2*f**2*gd2 + 3696*D1**2*Pk2*f**2*gdd2*r**2 + 9504*D1**2*Pk2*f**2*gdd2*r*s - 7392*D1**2*Pk2*f**2*gdd2*r + 792*D1**2*Pk2*f**2*gdd2*s**2 - 9504*D1**2*Pk2*f**2*gdd2*s + 3696*D1**2*Pk2*f**2*gdd2 + 24228*D1**2*Pk2*f*fd**2*r**2 + 87696*D1**2*Pk2*f*fd**2*r*s - 45384*D1**2*Pk2*f*fd**2*r + 47520*D1**2*Pk2*f*fd**2*s**2 - 60912*D1**2*Pk2*f*fd**2*s + 14616*D1**2*Pk2*f*fd**2 - 2640*D1**2*Pk2*f*fd*g2*r**2 - 19008*D1**2*Pk2*f*fd*g2*r*s + 9504*D1**2*Pk2*f*fd*g2*r - 4752*D1**2*Pk2*f*fd*g2*s**2 + 4752*D1**2*Pk2*f*fd*g2*s - 2376*D1**2*Pk2*f*fd*g2 + 14784*D1**2*Pk2*f*fd*gd2*r**2 + 38016*D1**2*Pk2*f*fd*gd2*r*s - 24288*D1**2*Pk2*f*fd*gd2*r + 3168*D1**2*Pk2*f*fd*gd2*s**2 - 20592*D1**2*Pk2*f*fd*gd2*s + 9504*D1**2*Pk2*f*fd*gd2 + 7392*D1**2*Pk2*f*fdd*g2*r**2 + 19008*D1**2*Pk2*f*fdd*g2*r*s - 9504*D1**2*Pk2*f*fdd*g2*r + 1584*D1**2*Pk2*f*fdd*g2*s**2 - 1584*D1**2*Pk2*f*fdd*g2*s + 792*D1**2*Pk2*f*fdd*g2 + 7392*D1**2*Pk2*fd**2*g2*r**2 + 19008*D1**2*Pk2*fd**2*g2*r*s - 9504*D1**2*Pk2*fd**2*g2*r + 1584*D1**2*Pk2*fd**2*g2*s**2 - 1584*D1**2*Pk2*fd**2*g2*s + 99*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 198*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 99*D1**2*Pkdd2*bdd1*f**2*k1**2 + 132*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 264*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 132*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 297*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 198*D1**2*Pkdd2*f**2*fd*k1**2*s + 99*D1**2*Pkdd2*f**2*fd*k1**2 + 132*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 264*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 264*D1**2*Pkdd2*f*fd*g2*k1**2*s + 132*D1**2*Pkdd2*f*fd*g2*k1**2 + 66*D1**2*bd1**2*(56*Pk2*g2*r*(2*r + 2*s - 1) + f**2*(6*Pk2*(8*r**2 + r*(8*s - 15) - 9*s + 9) + 9*Pkdd2*k1**2*s*(s - 1)) + f*(2*Pk2*(2*K*(10*r**2 - r*(12*s + 19) - 29*s**2 + 6*s + 9) + r**2*(8*C - 46) + r*(8*C*s - 4*C - 60*s + 83) + 55*s - 41) + Pkdd2*k1**2*s*(-2*K*(s - 1) + s - 1))) + 4752*D1*Dd*Pk2*b2*f**2*r**2 + 25344*D1*Dd*Pk2*b2*f**2*r*s - 11088*D1*Dd*Pk2*b2*f**2*r + 20592*D1*Dd*Pk2*b2*f**2*s**2 - 22968*D1*Dd*Pk2*b2*f**2*s + 7524*D1*Dd*Pk2*b2*f**2 - 31680*D1*Dd*Pk2*b2*f*fd*r**2 - 101376*D1*Dd*Pk2*b2*f*fd*r*s + 53856*D1*Dd*Pk2*b2*f*fd*r - 69696*D1*Dd*Pk2*b2*f*fd*s**2 + 77616*D1*Dd*Pk2*b2*f*fd*s - 21384*D1*Dd*Pk2*b2*f*fd - 15840*D1*Dd*Pk2*bd2*f**2*r**2 - 50688*D1*Dd*Pk2*bd2*f**2*r*s + 30096*D1*Dd*Pk2*bd2*f**2*r - 34848*D1*Dd*Pk2*bd2*f**2*s**2 + 46728*D1*Dd*Pk2*bd2*f**2*s - 14256*D1*Dd*Pk2*bd2*f**2 - 5640*D1*Dd*Pk2*f**3*r**2 - 57792*D1*Dd*Pk2*f**3*r*s + 20088*D1*Dd*Pk2*f**3*r - 34848*D1*Dd*Pk2*f**3*s**2 + 46320*D1*Dd*Pk2*f**3*s - 11532*D1*Dd*Pk2*f**3 + 96912*D1*Dd*Pk2*f**2*fd*r**2 + 350784*D1*Dd*Pk2*f**2*fd*r*s - 183072*D1*Dd*Pk2*f**2*fd*r + 190080*D1*Dd*Pk2*f**2*fd*s**2 - 257040*D1*Dd*Pk2*f**2*fd*s + 75840*D1*Dd*Pk2*f**2*fd - 5280*D1*Dd*Pk2*f**2*g2*r**2 - 38016*D1*Dd*Pk2*f**2*g2*r*s + 14784*D1*Dd*Pk2*f**2*g2*r - 9504*D1*Dd*Pk2*f**2*g2*s**2 + 23760*D1*Dd*Pk2*f**2*g2*s - 5016*D1*Dd*Pk2*f**2*g2 + 29568*D1*Dd*Pk2*f**2*gd2*r**2 + 76032*D1*Dd*Pk2*f**2*gd2*r*s - 53856*D1*Dd*Pk2*f**2*gd2*r + 6336*D1*Dd*Pk2*f**2*gd2*s**2 - 58608*D1*Dd*Pk2*f**2*gd2*s + 24288*D1*Dd*Pk2*f**2*gd2 + 59136*D1*Dd*Pk2*f*fd*g2*r**2 + 152064*D1*Dd*Pk2*f*fd*g2*r*s - 86592*D1*Dd*Pk2*f*fd*g2*r + 12672*D1*Dd*Pk2*f*fd*g2*s**2 - 47520*D1*Dd*Pk2*f*fd*g2*s + 20592*D1*Dd*Pk2*f*fd*g2 + 396*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 198*D1*Dd*Pkdd2*f**3*k1**2*s + 99*D1*Dd*Pkdd2*f**3*k1**2 + 528*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 264*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 132*D1*Dd*Pkdd2*f**2*g2*k1**2 - 7920*D1*Ddd*Pk2*b2*f**2*r**2 - 25344*D1*Ddd*Pk2*b2*f**2*r*s + 14256*D1*Ddd*Pk2*b2*f**2*r - 17424*D1*Ddd*Pk2*b2*f**2*s**2 + 21384*D1*Ddd*Pk2*b2*f**2*s - 8316*D1*Ddd*Pk2*b2*f**2 + 16152*D1*Ddd*Pk2*f**3*r**2 + 58464*D1*Ddd*Pk2*f**3*r*s - 30768*D1*Ddd*Pk2*f**3*r + 31680*D1*Ddd*Pk2*f**3*s**2 - 45072*D1*Ddd*Pk2*f**3*s + 15996*D1*Ddd*Pk2*f**3 + 14784*D1*Ddd*Pk2*f**2*g2*r**2 + 38016*D1*Ddd*Pk2*f**2*g2*r*s - 24288*D1*Ddd*Pk2*f**2*g2*r + 3168*D1*Ddd*Pk2*f**2*g2*s**2 - 20592*D1*Ddd*Pk2*f**2*g2*s + 8184*D1*Ddd*Pk2*f**2*g2 - 33*D1*bd1*(D1*(3*f**3*(2*Pk2*(2*r*(8*s - 5) + 10*s**2 - 24*s + 9) + 3*Pkdd2*k1**2*(1 - 2*s)) - f**2*(2*Pk2*(-12*C*r**2 - 64*C*r*s - 32*C*r - 68*C*s**2 + 2*K*(5*r**2 + 36*r*s - 10*r + 9*s**2 - 36*s + 5) + 6*fd*(6*r*(8*s - 3) + 30*s**2 - 50*s + 13) - 7*r**2 + 16*r*s + 40*r + 64*s**2 + 10*s + 2) + Pkdd2*k1**2*(8*C*(s - 1)**2 - s**2*(2*K + 5) + 12*s - 6)) - 4*f*(Pk2*fd*(4*C*(4*r**2 + r*(24*s - 5) + 22*s**2 - 17*s - 3) - 2*K*(28*r**2 + 72*r*s - 46*r + 6*s**2 - 39*s + 18) + 42*r**2 - 16*r*s - 45*r - 104*s**2 + 51*s + 23) + 2*Pk2*g2*(55*r**2 + 8*r*(4*s - 1) - 23*s**2) - 4*Pk2*gd2*(10*r**2 - r*(12*s + 19) - 29*s**2 + 6*s + 9) - Pkdd2*fd*k1**2*s*(4*C - 3)*(s - 1) - 2*Pkdd2*g2*k1**2*(s - 1)**2 + 2*Pkdd2*gd2*k1**2*s*(s - 1)) + 8*fd*g2*(2*Pk2*(10*r**2 + r*(6 - 12*s) - s*(29*s - 29)) - Pkdd2*k1**2*s*(s - 1))) - 2*Dd*f*(12*Pk2*f**2*(2*r*(16*s - 7) + 20*s**2 - 37*s + 11) + f*(2*Pk2*(4*C*(8*r**2 + r*(48*s + 2) + 44*s**2 - 23*s - 6) - 2*K*(56*r**2 + 6*r*(24*s - 17) + 12*s**2 - 111*s + 46) + 84*r**2 - 32*r*s - 150*r - 208*s**2 + 40*s + 61) - Pkdd2*k1**2*(4*C - 3)*(4*s**2 - 5*s + 1)) + 4*g2*(Pk2*(-80*r**2 + 4*r*(24*s + 25) + 232*s**2 - 82*s - 36) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) - 23760*Dd**2*Pk2*b2*f**2*r**2 - 76032*Dd**2*Pk2*b2*f**2*r*s + 42768*Dd**2*Pk2*b2*f**2*r - 52272*Dd**2*Pk2*b2*f**2*s**2 + 64152*Dd**2*Pk2*b2*f**2*s - 16632*Dd**2*Pk2*b2*f**2 + 48456*Dd**2*Pk2*f**3*r**2 + 175392*Dd**2*Pk2*f**3*r*s - 92304*Dd**2*Pk2*f**3*r + 95040*Dd**2*Pk2*f**3*s**2 - 135216*Dd**2*Pk2*f**3*s + 37308*Dd**2*Pk2*f**3 + 44352*Dd**2*Pk2*f**2*g2*r**2 + 114048*Dd**2*Pk2*f**2*g2*r*s - 72864*Dd**2*Pk2*f**2*g2*r + 9504*Dd**2*Pk2*f**2*g2*s**2 - 61776*Dd**2*Pk2*f**2*g2*s + 26400*Dd**2*Pk2*f**2*g2 + 1848*Pk2*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(4*r**2 + r*(4*s - 5) - 2*s + 2) + Dd**2*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4)) + 33*b1**2*(-32*C*D1**2*Pk2*fd*r**2 - 32*C*D1**2*Pk2*fd*r*s + 64*C*D1**2*Pk2*fd*r + 32*C*D1**2*Pk2*fd*s - 32*C*D1**2*Pk2*fd + 16*C*D1**2*Pk2*fdd*r**2 + 16*C*D1**2*Pk2*fdd*r*s - 32*C*D1**2*Pk2*fdd*r - 16*C*D1**2*Pk2*fdd*s + 16*C*D1**2*Pk2*fdd - 128*C*D1*Dd*Pk2*f*r**2 - 128*C*D1*Dd*Pk2*f*r*s + 160*C*D1*Dd*Pk2*f*r + 64*C*D1*Dd*Pk2*f*s - 64*C*D1*Dd*Pk2*f + 128*C*D1*Dd*Pk2*fd*r**2 + 128*C*D1*Dd*Pk2*fd*r*s - 208*C*D1*Dd*Pk2*fd*r - 96*C*D1*Dd*Pk2*fd*s + 80*C*D1*Dd*Pk2*fd + 64*C*D1*Ddd*Pk2*f*r**2 + 64*C*D1*Ddd*Pk2*f*r*s - 80*C*D1*Ddd*Pk2*f*r - 32*C*D1*Ddd*Pk2*f*s + 32*C*D1*Ddd*Pk2*f + 192*C*Dd**2*Pk2*f*r**2 + 192*C*Dd**2*Pk2*f*r*s - 240*C*Dd**2*Pk2*f*r - 96*C*Dd**2*Pk2*f*s + 64*C*Dd**2*Pk2*f - 220*D1**2*K*Pk2*fd*r**2 - 128*D1**2*K*Pk2*fd*r*s + 96*D1**2*K*Pk2*fd*r + 92*D1**2*K*Pk2*fd*s**2 - 184*D1**2*K*Pk2*fd*s + 92*D1**2*K*Pk2*fd + 40*D1**2*K*Pk2*fdd*r**2 - 48*D1**2*K*Pk2*fdd*r*s + 120*D1**2*K*Pk2*fdd*r - 116*D1**2*K*Pk2*fdd*s**2 + 232*D1**2*K*Pk2*fdd*s - 116*D1**2*K*Pk2*fdd + 4*D1**2*K*Pkdd2*fd*k1**2*s**2 - 2*D1**2*K*Pkdd2*fdd*k1**2*s**2 - 56*D1**2*Pk2*bdd1*(K - 1)*(3*r**2 + 3*r*(s - 1) - s + 1) - 96*D1**2*Pk2*f*fd*r**2 - 96*D1**2*Pk2*f*fd*r*s + 60*D1**2*Pk2*f*fd*r - 36*D1**2*Pk2*f*fd*s - 18*D1**2*Pk2*f*fd + 96*D1**2*Pk2*f*fdd*r**2 + 96*D1**2*Pk2*f*fdd*r*s - 60*D1**2*Pk2*f*fdd*r + 12*D1**2*Pk2*f*fdd*s + 30*D1**2*Pk2*f*fdd + 96*D1**2*Pk2*fd**2*r**2 + 96*D1**2*Pk2*fd**2*r*s - 60*D1**2*Pk2*fd**2*r + 12*D1**2*Pk2*fd**2*s - 36*D1**2*Pk2*fd**2 + 128*D1**2*Pk2*fd*r**2 + 128*D1**2*Pk2*fd*r*s - 140*D1**2*Pk2*fd*r + 60*D1**2*Pk2*fd*s - 14*D1**2*Pk2*fd - 92*D1**2*Pk2*fdd*r**2 - 120*D1**2*Pk2*fdd*r*s - 28*D1**2*Pk2*fdd*r - 100*D1**2*Pk2*fdd*s + 42*D1**2*Pk2*fdd - 224*D1**2*Pk2*gd2*r**2 - 224*D1**2*Pk2*gd2*r*s + 448*D1**2*Pk2*gd2*r + 224*D1**2*Pk2*gd2*s - 224*D1**2*Pk2*gd2 + 112*D1**2*Pk2*gdd2*r**2 + 112*D1**2*Pk2*gdd2*r*s - 224*D1**2*Pk2*gdd2*r - 112*D1**2*Pk2*gdd2*s + 112*D1**2*Pk2*gdd2 - 36*D1**2*Pkdd2*f*fd*k1**2*s**2 + 18*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 18*D1**2*Pkdd2*fd**2*k1**2*s**2 - 2*D1**2*Pkdd2*fd*k1**2*s**2 + D1**2*Pkdd2*fdd*k1**2*s**2 - 880*D1*Dd*K*Pk2*f*r**2 - 512*D1*Dd*K*Pk2*f*r*s + 1008*D1*Dd*K*Pk2*f*r + 368*D1*Dd*K*Pk2*f*s**2 + 72*D1*Dd*K*Pk2*f*s - 348*D1*Dd*K*Pk2*f + 320*D1*Dd*K*Pk2*fd*r**2 - 384*D1*Dd*K*Pk2*fd*r*s + 368*D1*Dd*K*Pk2*fd*r - 928*D1*Dd*K*Pk2*fd*s**2 + 1256*D1*Dd*K*Pk2*fd*s - 472*D1*Dd*K*Pk2*fd + 16*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 8*D1*Dd*K*Pkdd2*f*k1**2*s + 4*D1*Dd*K*Pkdd2*f*k1**2 - 16*D1*Dd*K*Pkdd2*fd*k1**2*s**2 + 4*D1*Dd*K*Pkdd2*fd*k1**2*s - 192*D1*Dd*Pk2*f**2*r**2 - 192*D1*Dd*Pk2*f**2*r*s + 240*D1*Dd*Pk2*f**2*r + 96*D1*Dd*Pk2*f**2*s - 96*D1*Dd*Pk2*f**2 + 768*D1*Dd*Pk2*f*fd*r**2 + 768*D1*Dd*Pk2*f*fd*r*s - 720*D1*Dd*Pk2*f*fd*r - 144*D1*Dd*Pk2*f*fd*s + 108*D1*Dd*Pk2*f*fd + 512*D1*Dd*Pk2*f*r**2 + 512*D1*Dd*Pk2*f*r*s - 640*D1*Dd*Pk2*f*r - 256*D1*Dd*Pk2*f*s + 256*D1*Dd*Pk2*f - 736*D1*Dd*Pk2*fd*r**2 - 960*D1*Dd*Pk2*fd*r*s + 376*D1*Dd*Pk2*fd*r - 160*D1*Dd*Pk2*fd*s + 156*D1*Dd*Pk2*fd - 896*D1*Dd*Pk2*g2*r**2 - 896*D1*Dd*Pk2*g2*r*s + 1120*D1*Dd*Pk2*g2*r + 448*D1*Dd*Pk2*g2*s - 448*D1*Dd*Pk2*g2 + 896*D1*Dd*Pk2*gd2*r**2 + 896*D1*Dd*Pk2*gd2*r*s - 1456*D1*Dd*Pk2*gd2*r - 672*D1*Dd*Pk2*gd2*s + 560*D1*Dd*Pk2*gd2 - 72*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 36*D1*Dd*Pkdd2*f**2*k1**2*s - 18*D1*Dd*Pkdd2*f**2*k1**2 + 144*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 36*D1*Dd*Pkdd2*f*fd*k1**2*s - 8*D1*Dd*Pkdd2*f*k1**2*s**2 + 4*D1*Dd*Pkdd2*f*k1**2*s - 2*D1*Dd*Pkdd2*f*k1**2 + 8*D1*Dd*Pkdd2*fd*k1**2*s**2 - 2*D1*Dd*Pkdd2*fd*k1**2*s + 160*D1*Ddd*K*Pk2*f*r**2 - 192*D1*Ddd*K*Pk2*f*r*s - 112*D1*Ddd*K*Pk2*f*r - 464*D1*Ddd*K*Pk2*f*s**2 + 328*D1*Ddd*K*Pk2*f*s - 36*D1*Ddd*K*Pk2*f - 8*D1*Ddd*K*Pkdd2*f*k1**2*s**2 + 4*D1*Ddd*K*Pkdd2*f*k1**2*s - 2*D1*Ddd*K*Pkdd2*f*k1**2 + 192*D1*Ddd*Pk2*f**2*r**2 + 192*D1*Ddd*Pk2*f**2*r*s - 240*D1*Ddd*Pk2*f**2*r - 96*D1*Ddd*Pk2*f**2*s + 96*D1*Ddd*Pk2*f**2 - 368*D1*Ddd*Pk2*f*r**2 - 480*D1*Ddd*Pk2*f*r*s + 488*D1*Ddd*Pk2*f*r + 240*D1*Ddd*Pk2*f*s - 184*D1*Ddd*Pk2*f + 448*D1*Ddd*Pk2*g2*r**2 + 448*D1*Ddd*Pk2*g2*r*s - 560*D1*Ddd*Pk2*g2*r - 224*D1*Ddd*Pk2*g2*s + 224*D1*Ddd*Pk2*g2 + 36*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 18*D1*Ddd*Pkdd2*f**2*k1**2*s + 9*D1*Ddd*Pkdd2*f**2*k1**2 + 4*D1*Ddd*Pkdd2*f*k1**2*s**2 - 2*D1*Ddd*Pkdd2*f*k1**2*s + D1*Ddd*Pkdd2*f*k1**2 + 56*D1*Pk2*bd1*(K - 1)*(D1*(6*r**2 + 6*r*(s - 1) - 2*s + 2) + Dd*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7)) + 480*Dd**2*K*Pk2*f*r**2 - 576*Dd**2*K*Pk2*f*r*s - 336*Dd**2*K*Pk2*f*r - 1392*Dd**2*K*Pk2*f*s**2 + 984*Dd**2*K*Pk2*f*s - 16*Dd**2*K*Pk2*f - 24*Dd**2*K*Pkdd2*f*k1**2*s**2 + 12*Dd**2*K*Pkdd2*f*k1**2*s + 576*Dd**2*Pk2*f**2*r**2 + 576*Dd**2*Pk2*f**2*r*s - 720*Dd**2*Pk2*f**2*r - 288*Dd**2*Pk2*f**2*s + 192*Dd**2*Pk2*f**2 - 1104*Dd**2*Pk2*f*r**2 - 1440*Dd**2*Pk2*f*r*s + 1464*Dd**2*Pk2*f*r + 720*Dd**2*Pk2*f*s - 424*Dd**2*Pk2*f + 1344*Dd**2*Pk2*g2*r**2 + 1344*Dd**2*Pk2*g2*r*s - 1680*Dd**2*Pk2*g2*r - 672*Dd**2*Pk2*g2*s + 448*Dd**2*Pk2*g2 + 108*Dd**2*Pkdd2*f**2*k1**2*s**2 - 54*Dd**2*Pkdd2*f**2*k1**2*s + 12*Dd**2*Pkdd2*f*k1**2*s**2 - 6*Dd**2*Pkdd2*f*k1**2*s) - 33*b1*(48*C*D1**2*Pk2*f*fd*r**2 + 256*C*D1**2*Pk2*f*fd*r*s - 240*C*D1**2*Pk2*f*fd*r + 272*C*D1**2*Pk2*f*fd*s**2 - 400*C*D1**2*Pk2*f*fd*s + 160*C*D1**2*Pk2*f*fd - 32*C*D1**2*Pk2*f*fdd*r**2 - 192*C*D1**2*Pk2*f*fdd*r*s + 176*C*D1**2*Pk2*f*fdd*r - 176*C*D1**2*Pk2*f*fdd*s**2 + 272*C*D1**2*Pk2*f*fdd*s - 104*C*D1**2*Pk2*f*fdd - 32*C*D1**2*Pk2*fd**2*r**2 - 192*C*D1**2*Pk2*fd**2*r*s + 176*C*D1**2*Pk2*fd**2*r - 176*C*D1**2*Pk2*fd**2*s**2 + 272*C*D1**2*Pk2*fd**2*s - 144*C*D1**2*Pk2*fd**2 - 16*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 8*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 8*C*D1**2*Pkdd2*fd**2*k1**2*s**2 + 96*C*D1*Dd*Pk2*f**2*r**2 + 512*C*D1*Dd*Pk2*f**2*r*s - 224*C*D1*Dd*Pk2*f**2*r + 544*C*D1*Dd*Pk2*f**2*s**2 - 528*C*D1*Dd*Pk2*f**2*s + 184*C*D1*Dd*Pk2*f**2 - 256*C*D1*Dd*Pk2*f*fd*r**2 - 1536*C*D1*Dd*Pk2*f*fd*r*s + 1024*C*D1*Dd*Pk2*f*fd*r - 1408*C*D1*Dd*Pk2*f*fd*s**2 + 1824*C*D1*Dd*Pk2*f*fd*s - 624*C*D1*Dd*Pk2*f*fd - 32*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 16*C*D1*Dd*Pkdd2*f**2*k1**2*s - 8*C*D1*Dd*Pkdd2*f**2*k1**2 + 64*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 16*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 64*C*D1*Ddd*Pk2*f**2*r**2 - 384*C*D1*Ddd*Pk2*f**2*r*s + 160*C*D1*Ddd*Pk2*f**2*r - 352*C*D1*Ddd*Pk2*f**2*s**2 + 368*C*D1*Ddd*Pk2*f**2*s - 120*C*D1*Ddd*Pk2*f**2 + 16*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 8*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 4*C*D1*Ddd*Pkdd2*f**2*k1**2 - 192*C*Dd**2*Pk2*f**2*r**2 - 1152*C*Dd**2*Pk2*f**2*r*s + 480*C*Dd**2*Pk2*f**2*r - 1056*C*Dd**2*Pk2*f**2*s**2 + 1104*C*Dd**2*Pk2*f**2*s - 224*C*Dd**2*Pk2*f**2 + 48*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 24*C*Dd**2*Pkdd2*f**2*k1**2*s - 40*D1**2*K*Pk2*f*fd*r**2 - 288*D1**2*K*Pk2*f*fd*r*s + 144*D1**2*K*Pk2*f*fd*r - 72*D1**2*K*Pk2*f*fd*s**2 + 72*D1**2*K*Pk2*f*fd*s - 36*D1**2*K*Pk2*f*fd + 112*D1**2*K*Pk2*f*fdd*r**2 + 288*D1**2*K*Pk2*f*fdd*r*s - 144*D1**2*K*Pk2*f*fdd*r + 24*D1**2*K*Pk2*f*fdd*s**2 - 24*D1**2*K*Pk2*f*fdd*s + 12*D1**2*K*Pk2*f*fdd + 112*D1**2*K*Pk2*fd**2*r**2 + 288*D1**2*K*Pk2*fd**2*r*s - 144*D1**2*K*Pk2*fd**2*r + 24*D1**2*K*Pk2*fd**2*s**2 - 24*D1**2*K*Pk2*fd**2*s + 4*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 4*D1**2*K*Pkdd2*f*fd*k1**2*s + 2*D1**2*K*Pkdd2*f*fd*k1**2 + 56*D1**2*Pk2*bd1**2*(K - 1)*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 288*D1**2*Pk2*f**2*fd*r*s - 36*D1**2*Pk2*f**2*fd*r + 180*D1**2*Pk2*f**2*fd*s**2 - 168*D1**2*Pk2*f**2*fd*s + 6*D1**2*Pk2*f**2*fd - 288*D1**2*Pk2*f**2*fdd*r*s + 36*D1**2*Pk2*f**2*fdd*r - 180*D1**2*Pk2*f**2*fdd*s**2 + 168*D1**2*Pk2*f**2*fdd*s - 6*D1**2*Pk2*f**2*fdd - 576*D1**2*Pk2*f*fd**2*r*s + 72*D1**2*Pk2*f*fd**2*r - 360*D1**2*Pk2*f*fd**2*s**2 + 336*D1**2*Pk2*f*fd**2*s - 36*D1**2*Pk2*f*fd**2 + 28*D1**2*Pk2*f*fd*r**2 - 64*D1**2*Pk2*f*fd*r*s + 84*D1**2*Pk2*f*fd*r - 256*D1**2*Pk2*f*fd*s**2 + 308*D1**2*Pk2*f*fd*s - 110*D1**2*Pk2*f*fd - 84*D1**2*Pk2*f*fdd*r**2 + 32*D1**2*Pk2*f*fdd*r*s - 44*D1**2*Pk2*f*fdd*r + 208*D1**2*Pk2*f*fdd*s**2 - 244*D1**2*Pk2*f*fdd*s + 82*D1**2*Pk2*f*fdd - 440*D1**2*Pk2*f*gd2*r**2 - 256*D1**2*Pk2*f*gd2*r*s + 880*D1**2*Pk2*f*gd2*r + 184*D1**2*Pk2*f*gd2*s**2 + 256*D1**2*Pk2*f*gd2*s - 440*D1**2*Pk2*f*gd2 + 80*D1**2*Pk2*f*gdd2*r**2 - 96*D1**2*Pk2*f*gdd2*r*s - 160*D1**2*Pk2*f*gdd2*r - 232*D1**2*Pk2*f*gdd2*s**2 + 96*D1**2*Pk2*f*gdd2*s + 80*D1**2*Pk2*f*gdd2 - 84*D1**2*Pk2*fd**2*r**2 + 32*D1**2*Pk2*fd**2*r*s - 44*D1**2*Pk2*fd**2*r + 208*D1**2*Pk2*fd**2*s**2 - 244*D1**2*Pk2*fd**2*s + 108*D1**2*Pk2*fd**2 - 440*D1**2*Pk2*fd*g2*r**2 - 256*D1**2*Pk2*fd*g2*r*s + 192*D1**2*Pk2*fd*g2*r + 184*D1**2*Pk2*fd*g2*s**2 - 368*D1**2*Pk2*fd*g2*s + 184*D1**2*Pk2*fd*g2 + 160*D1**2*Pk2*fd*gd2*r**2 - 192*D1**2*Pk2*fd*gd2*r*s + 80*D1**2*Pk2*fd*gd2*r - 464*D1**2*Pk2*fd*gd2*s**2 + 560*D1**2*Pk2*fd*gd2*s - 240*D1**2*Pk2*fd*gd2 + 80*D1**2*Pk2*fdd*g2*r**2 - 96*D1**2*Pk2*fdd*g2*r*s + 240*D1**2*Pk2*fdd*g2*r - 232*D1**2*Pk2*fdd*g2*s**2 + 464*D1**2*Pk2*fdd*g2*s - 232*D1**2*Pk2*fdd*g2 + 18*D1**2*Pkdd2*f**2*fd*k1**2*s - 9*D1**2*Pkdd2*f**2*fd*k1**2 + 10*D1**2*Pkdd2*f*fd*k1**2*s**2 + 2*D1**2*Pkdd2*f*fd*k1**2*s - D1**2*Pkdd2*f*fd*k1**2 - 6*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 8*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 4*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 6*D1**2*Pkdd2*fd**2*k1**2*s**2 + 8*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 8*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 4*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - D1**2*bdd1*(112*Pk2*g2*r*(2*r + 2*s - 1) + 3*f**2*(Pk2*(32*r**2 + 4*r*(8*s - 15) - 36*s + 22) + 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(2*Pk2*(4*K*(10*r**2 - r*(12*s + 19) - 29*s**2 + 6*s + 5) + r**2*(16*C - 92) + 2*r*(8*C*s - 4*C - 60*s + 83) + 110*s - 67) - Pkdd2*k1**2*(2*K - 1)*(2*s**2 - 2*s + 1))) - 80*D1*Dd*K*Pk2*f**2*r**2 - 576*D1*Dd*K*Pk2*f**2*r*s + 224*D1*Dd*K*Pk2*f**2*r - 144*D1*Dd*K*Pk2*f**2*s**2 + 360*D1*Dd*K*Pk2*f**2*s - 76*D1*Dd*K*Pk2*f**2 + 896*D1*Dd*K*Pk2*f*fd*r**2 + 2304*D1*Dd*K*Pk2*f*fd*r*s - 1312*D1*Dd*K*Pk2*f*fd*r + 192*D1*Dd*K*Pk2*f*fd*s**2 - 720*D1*Dd*K*Pk2*f*fd*s + 312*D1*Dd*K*Pk2*f*fd + 8*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 4*D1*Dd*K*Pkdd2*f**2*k1**2*s + 2*D1*Dd*K*Pkdd2*f**2*k1**2 + 384*D1*Dd*Pk2*f**3*r*s - 96*D1*Dd*Pk2*f**3*r + 240*D1*Dd*Pk2*f**3*s**2 - 312*D1*Dd*Pk2*f**3*s + 60*D1*Dd*Pk2*f**3 - 2304*D1*Dd*Pk2*f**2*fd*r*s + 432*D1*Dd*Pk2*f**2*fd*r - 1440*D1*Dd*Pk2*f**2*fd*s**2 + 1608*D1*Dd*Pk2*f**2*fd*s - 240*D1*Dd*Pk2*f**2*fd + 56*D1*Dd*Pk2*f**2*r**2 - 128*D1*Dd*Pk2*f**2*r*s - 24*D1*Dd*Pk2*f**2*r - 512*D1*Dd*Pk2*f**2*s**2 + 320*D1*Dd*Pk2*f**2*s - 100*D1*Dd*Pk2*f**2 - 672*D1*Dd*Pk2*f*fd*r**2 + 256*D1*Dd*Pk2*f*fd*r*s + 128*D1*Dd*Pk2*f*fd*r + 1664*D1*Dd*Pk2*f*fd*s**2 - 1456*D1*Dd*Pk2*f*fd*s + 332*D1*Dd*Pk2*f*fd - 1760*D1*Dd*Pk2*f*g2*r**2 - 1024*D1*Dd*Pk2*f*g2*r*s + 2016*D1*Dd*Pk2*f*g2*r + 736*D1*Dd*Pk2*f*g2*s**2 + 144*D1*Dd*Pk2*f*g2*s - 696*D1*Dd*Pk2*f*g2 + 640*D1*Dd*Pk2*f*gd2*r**2 - 768*D1*Dd*Pk2*f*gd2*r*s - 864*D1*Dd*Pk2*f*gd2*r - 1856*D1*Dd*Pk2*f*gd2*s**2 + 1040*D1*Dd*Pk2*f*gd2*s + 224*D1*Dd*Pk2*f*gd2 + 640*D1*Dd*Pk2*fd*g2*r**2 - 768*D1*Dd*Pk2*fd*g2*r*s + 736*D1*Dd*Pk2*fd*g2*r - 1856*D1*Dd*Pk2*fd*g2*s**2 + 2512*D1*Dd*Pk2*fd*g2*s - 944*D1*Dd*Pk2*fd*g2 + 20*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 10*D1*Dd*Pkdd2*f**2*k1**2*s + 5*D1*Dd*Pkdd2*f**2*k1**2 - 48*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 12*D1*Dd*Pkdd2*f*fd*k1**2*s + 32*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 16*D1*Dd*Pkdd2*f*g2*k1**2*s + 8*D1*Dd*Pkdd2*f*g2*k1**2 - 32*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 8*D1*Dd*Pkdd2*f*gd2*k1**2*s - 32*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 8*D1*Dd*Pkdd2*fd*g2*k1**2*s + 224*D1*Ddd*K*Pk2*f**2*r**2 + 576*D1*Ddd*K*Pk2*f**2*r*s - 368*D1*Ddd*K*Pk2*f**2*r + 48*D1*Ddd*K*Pk2*f**2*s**2 - 312*D1*Ddd*K*Pk2*f**2*s + 124*D1*Ddd*K*Pk2*f**2 - 384*D1*Ddd*Pk2*f**3*r*s + 96*D1*Ddd*Pk2*f**3*r - 240*D1*Ddd*Pk2*f**3*s**2 + 312*D1*Ddd*Pk2*f**3*s - 60*D1*Ddd*Pk2*f**3 - 168*D1*Ddd*Pk2*f**2*r**2 + 64*D1*Ddd*Pk2*f**2*r*s + 152*D1*Ddd*Pk2*f**2*r + 416*D1*Ddd*Pk2*f**2*s**2 - 240*D1*Ddd*Pk2*f**2*s + 20*D1*Ddd*Pk2*f**2 + 320*D1*Ddd*Pk2*f*g2*r**2 - 384*D1*Ddd*Pk2*f*g2*r*s - 224*D1*Ddd*Pk2*f*g2*r - 928*D1*Ddd*Pk2*f*g2*s**2 + 656*D1*Ddd*Pk2*f*g2*s - 72*D1*Ddd*Pk2*f*g2 - 12*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 6*D1*Ddd*Pkdd2*f**2*k1**2*s - 3*D1*Ddd*Pkdd2*f**2*k1**2 - 16*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 8*D1*Ddd*Pkdd2*f*g2*k1**2*s - 4*D1*Ddd*Pkdd2*f*g2*k1**2 + 2*D1*bd1*(D1*(-2*Pk2*fd*(4*C*(4*r**2 + r*(4*s - 5) - 2*s + 1) + 2*K*(20*r**2 - 24*r*s + 11*r - 58*s**2 + 64*s - 15) - 92*r**2 - 120*r*s + 69*r + 5*s + 11) + 112*Pk2*g2*r*(2*r + 2*s - 1) - 56*Pk2*gd2*(4*r**2 + r*(4*s - 5) - 2*s + 1) + Pkdd2*fd*k1**2*s*(2*K - 1)*(2*s - 1) + 3*f**2*(Pk2*(16*r**2 + 2*r*(8*s - 15) - 22*s + 13) + 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(Pk2*(32*C*r**2 + 32*C*r*s - 16*C*r + 2*K*(110*r**2 + 64*r*s - 118*r - 46*s**2 - 32*s + 55) - 12*fd*(16*r**2 + 4*r*(4*s - 5) - 8*s + 5) - 128*r**2 - 128*r*s + 122*r + 94*s - 71) + Pkdd2*k1**2*(K*(-4*s**2 + 4*s - 2) + s**2*(2 - 36*fd) + s*(18*fd - 2) + 1))) - Dd*(112*Pk2*g2*(8*r**2 + r*(8*s - 7) - 2*s + 1) + 3*f**2*(2*Pk2*(16*r - 13)*(4*r + 4*s - 3) + 3*Pkdd2*k1**2*(8*s**2 - 6*s + 1)) + f*(2*Pk2*(8*C*(8*r**2 + r*(8*s - 7) - 2*s + 1) + 4*K*(40*r**2 - 48*r*s - 52*r - 116*s**2 + 53*s + 16) - 368*r**2 - 480*r*s + 576*r + 340*s - 221) - Pkdd2*k1**2*(2*K - 1)*(8*s**2 - 6*s + 1)))) + 672*Dd**2*K*Pk2*f**2*r**2 + 1728*Dd**2*K*Pk2*f**2*r*s - 1104*Dd**2*K*Pk2*f**2*r + 144*Dd**2*K*Pk2*f**2*s**2 - 936*Dd**2*K*Pk2*f**2*s + 400*Dd**2*K*Pk2*f**2 - 1152*Dd**2*Pk2*f**3*r*s + 288*Dd**2*Pk2*f**3*r - 720*Dd**2*Pk2*f**3*s**2 + 936*Dd**2*Pk2*f**3*s - 192*Dd**2*Pk2*f**3 - 504*Dd**2*Pk2*f**2*r**2 + 192*Dd**2*Pk2*f**2*r*s + 456*Dd**2*Pk2*f**2*r + 1248*Dd**2*Pk2*f**2*s**2 - 720*Dd**2*Pk2*f**2*s - 52*Dd**2*Pk2*f**2 + 960*Dd**2*Pk2*f*g2*r**2 - 1152*Dd**2*Pk2*f*g2*r*s - 672*Dd**2*Pk2*f*g2*r - 2784*Dd**2*Pk2*f*g2*s**2 + 1968*Dd**2*Pk2*f*g2*s - 32*Dd**2*Pk2*f*g2 - 36*Dd**2*Pkdd2*f**2*k1**2*s**2 + 18*Dd**2*Pkdd2*f**2*k1**2*s - 48*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 24*Dd**2*Pkdd2*f*g2*k1**2*s))/(1386*d**2*k3**4) + D1**2*Pk3*ct*k1*k2*(-4*D1**2*Pk2*bd1**2*(21*f**2*(3*r**2 + r*(4*s - 5) + s**2 - 3*s + 2) + f*(-14*K*(7*r**2 + 16*r*(s - 1) + 8*s**2 - 18*s + 9) + r**2*(92*C - 55) + 4*r*(54*C*s - 27*C - 27*s + 10) + (s - 1)*(124*C*s - 67*s - 21)) - 28*g2*(2*r**2 + r*(6*s - 3) + s*(4*s - 4))) - 28*D1*Pk2*b2*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) - 2*D1*bd1*(-140*D1*Pk2*bd2*f*(r + s - 1)**2 + D1*(56*Pk2*fd*g2*(7*r**2 + 8*r*(2*s - 1) + s*(8*s - 8)) + f**2*(Pk2*(4*C*(56*r**2 + 6*r*(15*s - 17) + 31*s**2 - 86*s + 43) + 42*K*s**2 - 28*K*s - 108*r**2 + 2*r*(14*K*s - 97*s + 109) - 81*s**2 + 210*s - 105) + Pkdd2*k1**2*(9 - 12*C)*(s - 1)**2) - 2*f*(Pk2*fd*(4*C*(116*r**2 + 2*r*(126*s - 95) + 110*s**2 - 185*s + 69) + 14*K*(4*r*s - r + 6*s**2 - 5*s + 1) - 276*r**2 - 620*r*s + 460*r - 258*s**2 + 437*s - 167) - 28*Pk2*gd2*(7*r**2 + 16*r*(s - 1) + 8*s**2 - 18*s + 9) - 7*g2*(-4*Pk2*(2*r**2 + 4*r*s - 5*r + 2*s**2 - 6*s + 3) + Pkdd2*k1**2*(s - 1)**2))) - 2*Dd*Pk2*f*(f*(4*C*(232*r**2 + 7*r*(72*s - 65) + 220*s**2 - 449*s + 205) + 14*K*(8*r*s - r + 12*s**2 - 9*s + 1) - 552*r**2 - 1240*r*s + 1099*r - 516*s**2 + 1051*s - 487) - 56*g2*(14*r**2 + 32*r*s - 29*r + 16*s**2 - 32*s + 14))) - 14*Pk2*b1**3*(D1**2*(fd*(5*r + s - 5) + fdd*(-7*r - 3*s + 7))*(r + s - 1) + D1*(Dd*f*(20*r**2 + r*(24*s - 26) + 4*s**2 - 14*s + 11) - 2*Dd*(4*K*(4*r**2 + 12*r*s - 7*r + 8*s**2 - 10*s + 4) + fd*(28*r**2 + r*(40*s - 47) + 12*s**2 - 33*s + 19) - 8*r**2 - 16*r*s + 12*r - 8*s**2 + 12*s - 6) - Ddd*f*(28*r**2 + r*(40*s - 38) + 12*s**2 - 26*s + 17) - 2*Ddd*(-2*K*(4*r**2 + 12*r*s - 7*r + 8*s**2 - 10*s + 4) + 4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3)) - 2*Dd**2*(-2*K*(12*r**2 + 3*r*(12*s - 7) + 24*s**2 - 30*s + 8) + f*(42*r**2 + r*(60*s - 57) + 18*s**2 - 39*s + 17) + 12*r**2 + 6*r*(4*s - 3) + 12*s**2 - 18*s + 6)) - 2*Pk2*(D1**2*bdd1*f*(f*(-4*C*(58*r**2 + 6*r*(21*s - 23) + 55*s**2 - 134*s + 67) - 42*K*s**2 + 28*K*s + 138*r**2 + r*(-28*K*s + 310*s - 334) + 129*s**2 - 306*s + 153) + 28*g2*(7*r**2 + 2*r*(8*s - 9) + 8*s**2 - 20*s + 10)) + 4*D1**2*(f**2*(fd*(2*C - 1)*(7*r*(3*s - 1) + 27*s**2 - 25*s + 9) - fdd*(2*C - 1)*(21*r*s - 7*r + 27*s**2 - 25*s + 9) + s*(-7*gd2 + 7*gdd2)*(2*r + 3*s - 2)) + f*(-fd**2*(2*C - 1)*(14*r*(3*s - 1) + 54*s**2 - 50*s + 7) - 7*fd*(g2*(4*r*s - 2*r + 6*s**2 - 6*s + 3) - 2*gd2*(4*r*s - r + 6*s**2 - 5*s + 1)) + 7*fdd*g2*(r*(4*s - 2) + 6*s**2 - 6*s + 3)) + 14*fd**2*g2*(r*(2*s - 1) + s*(3*s - 3))) + 4*D1*f*(Dd*(f**2*(2*C - 1)*(7*r*(4*s - 1) + 36*s**2 - 32*s + 9) + f*(-fd*(2*C - 1)*(7*r*(24*s - 7) + 216*s**2 - 196*s + 39) - 7*g2*(r*(8*s - 2) + 12*s**2 - 10*s + 3) + 14*gd2*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) + 14*fd*g2*(2*r*(8*s - 3) + 24*s**2 - 22*s + 5)) + Ddd*f*(-f*(2*C - 1)*(7*r*(4*s - 1) + 36*s**2 - 32*s + 9) + 7*g2*(r*(8*s - 2) + 12*s**2 - 10*s + 3))) + 4*Dd**2*f**2*(-f*(2*C - 1)*(84*r*s - 21*r + 108*s**2 - 96*s + 14) + 14*g2*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2))) + b1**2*(-24*C*D1**2*Pk2*fd*r**2 + 80*C*D1**2*Pk2*fd*r*s + 48*C*D1**2*Pk2*fd*r + 104*C*D1**2*Pk2*fd*s**2 - 80*C*D1**2*Pk2*fd*s - 24*C*D1**2*Pk2*fd - 184*C*D1**2*Pk2*fdd*r**2 - 432*C*D1**2*Pk2*fdd*r*s + 368*C*D1**2*Pk2*fdd*r - 248*C*D1**2*Pk2*fdd*s**2 + 432*C*D1**2*Pk2*fdd*s - 184*C*D1**2*Pk2*fdd - 96*C*D1*Dd*Pk2*f*r**2 + 320*C*D1*Dd*Pk2*f*r*s + 16*C*D1*Dd*Pk2*f*r + 416*C*D1*Dd*Pk2*f*s**2 - 368*C*D1*Dd*Pk2*f*s + 56*C*D1*Dd*Pk2*f - 1472*C*D1*Dd*Pk2*fd*r**2 - 3456*C*D1*Dd*Pk2*fd*r*s + 2640*C*D1*Dd*Pk2*fd*r - 1984*C*D1*Dd*Pk2*fd*s**2 + 3088*C*D1*Dd*Pk2*fd*s - 1168*C*D1*Dd*Pk2*fd - 736*C*D1*Ddd*Pk2*f*r**2 - 1728*C*D1*Ddd*Pk2*f*r*s + 1168*C*D1*Ddd*Pk2*f*r - 992*C*D1*Ddd*Pk2*f*s**2 + 1360*C*D1*Ddd*Pk2*f*s - 616*C*D1*Ddd*Pk2*f - 2208*C*Dd**2*Pk2*f*r**2 - 5184*C*Dd**2*Pk2*f*r*s + 3504*C*Dd**2*Pk2*f*r - 2976*C*Dd**2*Pk2*f*s**2 + 4080*C*Dd**2*Pk2*f*s - 1232*C*Dd**2*Pk2*f - 112*D1**2*K*Pk2*fd*r**2 - 224*D1**2*K*Pk2*fd*r*s - 56*D1**2*K*Pk2*fd*r - 112*D1**2*K*Pk2*fd*s**2 - 112*D1**2*K*Pk2*fd*s + 56*D1**2*K*Pk2*fd + 196*D1**2*K*Pk2*fdd*r**2 + 448*D1**2*K*Pk2*fdd*r*s + 56*D1**2*K*Pk2*fdd*r + 224*D1**2*K*Pk2*fdd*s**2 + 112*D1**2*K*Pk2*fdd*s - 56*D1**2*K*Pk2*fdd + 14*D1**2*K*Pkdd2*fd*k1**2*s**2 + 14*D1**2*Pk2*bdd1*(-4*K*(3*r**2 + r*(9*s - 5) + 6*s**2 - 7*s + 3) + f*(21*r**2 + 6*r*(5*s - 4) + 9*s**2 - 16*s + 10) + 6*r**2 + 12*r*s - 8*r + 6*s**2 - 8*s + 4) + 252*D1**2*Pk2*f*fd*r**2 + 336*D1**2*Pk2*f*fd*r*s - 252*D1**2*Pk2*f*fd*r + 84*D1**2*Pk2*f*fd*s**2 - 168*D1**2*Pk2*f*fd*s + 126*D1**2*Pk2*f*fd - 252*D1**2*Pk2*f*fdd*r**2 - 336*D1**2*Pk2*f*fdd*r*s + 252*D1**2*Pk2*f*fdd*r - 84*D1**2*Pk2*f*fdd*s**2 + 168*D1**2*Pk2*f*fdd*s - 126*D1**2*Pk2*f*fdd - 252*D1**2*Pk2*fd**2*r**2 - 336*D1**2*Pk2*fd**2*r*s + 252*D1**2*Pk2*fd**2*r - 84*D1**2*Pk2*fd**2*s**2 + 168*D1**2*Pk2*fd**2*s - 10*D1**2*Pk2*fd*r**2 - 40*D1**2*Pk2*fd*r*s - 92*D1**2*Pk2*fd*r - 30*D1**2*Pk2*fd*s**2 + 12*D1**2*Pk2*fd*s + 46*D1**2*Pk2*fd + 110*D1**2*Pk2*fdd*r**2 + 216*D1**2*Pk2*fdd*r*s - 276*D1**2*Pk2*fdd*r + 134*D1**2*Pk2*fdd*s**2 - 300*D1**2*Pk2*fdd*s + 138*D1**2*Pk2*fdd - 224*D1**2*Pk2*gd2*r**2 - 672*D1**2*Pk2*gd2*r*s + 448*D1**2*Pk2*gd2*r - 448*D1**2*Pk2*gd2*s**2 + 672*D1**2*Pk2*gd2*s - 224*D1**2*Pk2*gd2 + 112*D1**2*Pk2*gdd2*r**2 + 336*D1**2*Pk2*gdd2*r*s - 224*D1**2*Pk2*gdd2*r + 224*D1**2*Pk2*gdd2*s**2 - 336*D1**2*Pk2*gdd2*s + 112*D1**2*Pk2*gdd2 - 36*D1**2*Pkdd2*f*fd*k1**2*s**2 - 7*D1**2*Pkdd2*fd*k1**2*s**2 - 448*D1*Dd*K*Pk2*f*r**2 - 896*D1*Dd*K*Pk2*f*r*s + 672*D1*Dd*K*Pk2*f*r - 448*D1*Dd*K*Pk2*f*s**2 + 672*D1*Dd*K*Pk2*f*s - 336*D1*Dd*K*Pk2*f + 1568*D1*Dd*K*Pk2*fd*r**2 + 3584*D1*Dd*K*Pk2*fd*r*s - 1008*D1*Dd*K*Pk2*fd*r + 1792*D1*Dd*K*Pk2*fd*s**2 - 896*D1*Dd*K*Pk2*fd*s - 224*D1*Dd*K*Pk2*fd + 56*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 28*D1*Dd*K*Pkdd2*f*k1**2*s + 14*D1*Dd*K*Pkdd2*f*k1**2 + 504*D1*Dd*Pk2*f**2*r**2 + 672*D1*Dd*Pk2*f**2*r*s - 672*D1*Dd*Pk2*f**2*r + 168*D1*Dd*Pk2*f**2*s**2 - 420*D1*Dd*Pk2*f**2*s + 294*D1*Dd*Pk2*f**2 - 2016*D1*Dd*Pk2*f*fd*r**2 - 2688*D1*Dd*Pk2*f*fd*r*s + 2352*D1*Dd*Pk2*f*fd*r - 672*D1*Dd*Pk2*f*fd*s**2 + 1512*D1*Dd*Pk2*f*fd*s - 672*D1*Dd*Pk2*f*fd - 40*D1*Dd*Pk2*f*r**2 - 160*D1*Dd*Pk2*f*r*s + 80*D1*Dd*Pk2*f*r - 120*D1*Dd*Pk2*f*s**2 + 140*D1*Dd*Pk2*f*s - 50*D1*Dd*Pk2*f + 880*D1*Dd*Pk2*fd*r**2 + 1728*D1*Dd*Pk2*fd*r*s - 1760*D1*Dd*Pk2*fd*r + 1072*D1*Dd*Pk2*fd*s**2 - 1900*D1*Dd*Pk2*fd*s + 852*D1*Dd*Pk2*fd - 896*D1*Dd*Pk2*g2*r**2 - 2688*D1*Dd*Pk2*g2*r*s + 1568*D1*Dd*Pk2*g2*r - 1792*D1*Dd*Pk2*g2*s**2 + 2240*D1*Dd*Pk2*g2*s - 896*D1*Dd*Pk2*g2 + 896*D1*Dd*Pk2*gd2*r**2 + 2688*D1*Dd*Pk2*gd2*r*s - 1680*D1*Dd*Pk2*gd2*r + 1792*D1*Dd*Pk2*gd2*s**2 - 2464*D1*Dd*Pk2*gd2*s + 784*D1*Dd*Pk2*gd2 - 72*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 36*D1*Dd*Pkdd2*f**2*k1**2*s - 18*D1*Dd*Pkdd2*f**2*k1**2 - 28*D1*Dd*Pkdd2*f*k1**2*s**2 + 14*D1*Dd*Pkdd2*f*k1**2*s - 7*D1*Dd*Pkdd2*f*k1**2 + 784*D1*Ddd*K*Pk2*f*r**2 + 1792*D1*Ddd*K*Pk2*f*r*s - 1232*D1*Ddd*K*Pk2*f*r + 896*D1*Ddd*K*Pk2*f*s**2 - 1344*D1*Ddd*K*Pk2*f*s + 616*D1*Ddd*K*Pk2*f - 504*D1*Ddd*Pk2*f**2*r**2 - 672*D1*Ddd*Pk2*f**2*r*s + 672*D1*Ddd*Pk2*f**2*r - 168*D1*Ddd*Pk2*f**2*s**2 + 420*D1*Ddd*Pk2*f**2*s - 294*D1*Ddd*Pk2*f**2 + 440*D1*Ddd*Pk2*f*r**2 + 864*D1*Ddd*Pk2*f*r*s - 656*D1*Ddd*Pk2*f*r + 536*D1*Ddd*Pk2*f*s**2 - 700*D1*Ddd*Pk2*f*s + 354*D1*Ddd*Pk2*f + 448*D1*Ddd*Pk2*g2*r**2 + 1344*D1*Ddd*Pk2*g2*r*s - 784*D1*Ddd*Pk2*g2*r + 896*D1*Ddd*Pk2*g2*s**2 - 1120*D1*Ddd*Pk2*g2*s + 448*D1*Ddd*Pk2*g2 - 14*D1*Pk2*bd1*(D1*(-8*K*(3*r**2 + r*(9*s - 5) + 6*s**2 - 7*s + 3) + f*(15*r**2 + 2*r*(9*s - 8) + 3*s**2 - 8*s + 6) - 2*fd*(21*r**2 + r*(30*s - 33) + 9*s**2 - 23*s + 12) + 12*r**2 + 24*r*s - 16*r + 12*s**2 - 16*s + 8) - 2*Dd*(-2*K*(24*r**2 + r*(72*s - 41) + 48*s**2 - 58*s + 17) + f*(84*r**2 + 15*r*(8*s - 7) + 36*s**2 - 71*s + 32) + 24*r**2 + 48*r*s - 34*r + 24*s**2 - 34*s + 12)) + 2352*Dd**2*K*Pk2*f*r**2 + 5376*Dd**2*K*Pk2*f*r*s - 3696*Dd**2*K*Pk2*f*r + 2688*Dd**2*K*Pk2*f*s**2 - 4032*Dd**2*K*Pk2*f*s + 1288*Dd**2*K*Pk2*f - 1512*Dd**2*Pk2*f**2*r**2 - 2016*Dd**2*Pk2*f**2*r*s + 2016*Dd**2*Pk2*f**2*r - 504*Dd**2*Pk2*f**2*s**2 + 1260*Dd**2*Pk2*f**2*s - 588*Dd**2*Pk2*f**2 + 1320*Dd**2*Pk2*f*r**2 + 2592*Dd**2*Pk2*f*r*s - 1968*Dd**2*Pk2*f*r + 1608*Dd**2*Pk2*f*s**2 - 2100*Dd**2*Pk2*f*s + 652*Dd**2*Pk2*f + 1344*Dd**2*Pk2*g2*r**2 + 4032*Dd**2*Pk2*g2*r*s - 2352*Dd**2*Pk2*g2*r + 2688*Dd**2*Pk2*g2*s**2 - 3360*Dd**2*Pk2*g2*s + 896*Dd**2*Pk2*g2) + b1*(-896*C*D1**2*Pk2*f*fd*r**2 - 1440*C*D1**2*Pk2*f*fd*r*s + 800*C*D1**2*Pk2*f*fd*r - 496*C*D1**2*Pk2*f*fd*s**2 + 528*C*D1**2*Pk2*f*fd*s - 352*C*D1**2*Pk2*f*fd + 928*C*D1**2*Pk2*f*fdd*r**2 + 2016*C*D1**2*Pk2*f*fdd*r*s - 832*C*D1**2*Pk2*f*fdd*r + 880*C*D1**2*Pk2*f*fdd*s**2 - 816*C*D1**2*Pk2*f*fdd*s + 368*C*D1**2*Pk2*f*fdd + 928*C*D1**2*Pk2*fd**2*r**2 + 2016*C*D1**2*Pk2*fd**2*r*s - 832*C*D1**2*Pk2*fd**2*r + 880*C*D1**2*Pk2*fd**2*s**2 - 816*C*D1**2*Pk2*fd**2*s - 96*C*D1**2*Pk2*fd**2 + 48*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 1792*C*D1*Dd*Pk2*f**2*r**2 - 2880*C*D1*Dd*Pk2*f**2*r*s + 2512*C*D1*Dd*Pk2*f**2*r - 992*C*D1*Dd*Pk2*f**2*s**2 + 1936*C*D1*Dd*Pk2*f**2*s - 1144*C*D1*Dd*Pk2*f**2 + 7424*C*D1*Dd*Pk2*f*fd*r**2 + 16128*C*D1*Dd*Pk2*f*fd*r*s - 9056*C*D1*Dd*Pk2*f*fd*r + 7040*C*D1*Dd*Pk2*f*fd*s**2 - 9056*C*D1*Dd*Pk2*f*fd*s + 2480*C*D1*Dd*Pk2*f*fd + 96*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 48*C*D1*Dd*Pkdd2*f**2*k1**2*s + 24*C*D1*Dd*Pkdd2*f**2*k1**2 + 1856*C*D1*Ddd*Pk2*f**2*r**2 + 4032*C*D1*Ddd*Pk2*f**2*r*s - 2864*C*D1*Ddd*Pk2*f**2*r + 1760*C*D1*Ddd*Pk2*f**2*s**2 - 2896*C*D1*Ddd*Pk2*f**2*s + 1368*C*D1*Ddd*Pk2*f**2 + 5568*C*Dd**2*Pk2*f**2*r**2 + 12096*C*Dd**2*Pk2*f**2*r*s - 8592*C*Dd**2*Pk2*f**2*r + 5280*C*Dd**2*Pk2*f**2*s**2 - 8688*C*Dd**2*Pk2*f**2*s + 2944*C*Dd**2*Pk2*f**2 - 112*D1**2*K*Pk2*f*fd*r*s + 56*D1**2*K*Pk2*f*fd*r - 168*D1**2*K*Pk2*f*fd*s**2 + 168*D1**2*K*Pk2*f*fd*s - 84*D1**2*K*Pk2*f*fd + 112*D1**2*K*Pk2*f*fdd*r*s - 56*D1**2*K*Pk2*f*fdd*r + 168*D1**2*K*Pk2*f*fdd*s**2 - 168*D1**2*K*Pk2*f*fdd*s + 84*D1**2*K*Pk2*f*fdd + 112*D1**2*K*Pk2*fd**2*r*s - 56*D1**2*K*Pk2*fd**2*r + 168*D1**2*K*Pk2*fd**2*s**2 - 168*D1**2*K*Pk2*fd**2*s - 84*D1**2*Pk2*b2*fd*r**2 - 168*D1**2*Pk2*b2*fd*r*s - 84*D1**2*Pk2*b2*fd*s**2 + 140*D1**2*Pk2*b2*fdd*r**2 + 280*D1**2*Pk2*b2*fdd*r*s + 140*D1**2*Pk2*b2*fdd*s**2 + 28*D1**2*Pk2*bd1**2*(-2*K*(6*r**2 + 2*r*(9*s - 5) + 12*s**2 - 14*s + 3) + f*(21*r**2 + 6*r*(5*s - 4) + 9*s**2 - 16*s + 5) + 6*r**2 + 12*r*s - 8*r + 6*s**2 - 8*s + 2) - 2*D1**2*Pk2*bdd1*(42*f**2*(3*r**2 + r*(4*s - 5) + s**2 - 3*s + 2) + f*(4*C*(46*r**2 + 54*r*(2*s - 1) + 62*s**2 - 62*s + 31) - 14*K*(14*r**2 + 32*r*(s - 1) + 16*s**2 - 36*s + 17) - 110*r**2 - 216*r*s + 80*r - 134*s**2 + 92*s - 53) - 56*g2*(2*r**2 + r*(6*s - 3) + 4*s**2 - 4*s + 2)) + 140*D1**2*Pk2*bdd2*f*r**2 + 280*D1**2*Pk2*bdd2*f*r*s - 280*D1**2*Pk2*bdd2*f*r + 140*D1**2*Pk2*bdd2*f*s**2 - 280*D1**2*Pk2*bdd2*f*s + 140*D1**2*Pk2*bdd2*f + 432*D1**2*Pk2*f*fd*r**2 + 776*D1**2*Pk2*f*fd*r*s - 384*D1**2*Pk2*f*fd*r + 324*D1**2*Pk2*f*fd*s**2 - 292*D1**2*Pk2*f*fd*s + 168*D1**2*Pk2*f*fd - 552*D1**2*Pk2*f*fdd*r**2 - 1240*D1**2*Pk2*f*fdd*r*s + 504*D1**2*Pk2*f*fdd*r - 516*D1**2*Pk2*f*fdd*s**2 + 524*D1**2*Pk2*f*fdd*s - 228*D1**2*Pk2*f*fdd + 224*D1**2*Pk2*f*gd2*r**2 + 448*D1**2*Pk2*f*gd2*r*s - 448*D1**2*Pk2*f*gd2*r + 224*D1**2*Pk2*f*gd2*s**2 - 448*D1**2*Pk2*f*gd2*s + 224*D1**2*Pk2*f*gd2 - 392*D1**2*Pk2*f*gdd2*r**2 - 896*D1**2*Pk2*f*gdd2*r*s + 784*D1**2*Pk2*f*gdd2*r - 448*D1**2*Pk2*f*gdd2*s**2 + 896*D1**2*Pk2*f*gdd2*s - 392*D1**2*Pk2*f*gdd2 - 552*D1**2*Pk2*fd**2*r**2 - 1240*D1**2*Pk2*fd**2*r*s + 504*D1**2*Pk2*fd**2*r - 516*D1**2*Pk2*fd**2*s**2 + 524*D1**2*Pk2*fd**2*s + 48*D1**2*Pk2*fd**2 + 224*D1**2*Pk2*fd*g2*r**2 + 448*D1**2*Pk2*fd*g2*r*s + 112*D1**2*Pk2*fd*g2*r + 224*D1**2*Pk2*fd*g2*s**2 + 224*D1**2*Pk2*fd*g2*s - 112*D1**2*Pk2*fd*g2 - 784*D1**2*Pk2*fd*gd2*r**2 - 1792*D1**2*Pk2*fd*gd2*r*s + 672*D1**2*Pk2*fd*gd2*r - 896*D1**2*Pk2*fd*gd2*s**2 + 672*D1**2*Pk2*fd*gd2*s + 112*D1**2*Pk2*fd*gd2 - 392*D1**2*Pk2*fdd*g2*r**2 - 896*D1**2*Pk2*fdd*g2*r*s - 112*D1**2*Pk2*fdd*g2*r - 448*D1**2*Pk2*fdd*g2*s**2 - 224*D1**2*Pk2*fdd*g2*s + 112*D1**2*Pk2*fdd*g2 - 36*D1**2*Pkdd2*f*fd*k1**2*s**2 - 28*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 28*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 224*D1*Dd*K*Pk2*f**2*r*s + 56*D1*Dd*K*Pk2*f**2*r - 336*D1*Dd*K*Pk2*f**2*s**2 + 280*D1*Dd*K*Pk2*f**2*s - 84*D1*Dd*K*Pk2*f**2 + 896*D1*Dd*K*Pk2*f*fd*r*s - 336*D1*Dd*K*Pk2*f*fd*r + 1344*D1*Dd*K*Pk2*f*fd*s**2 - 1232*D1*Dd*K*Pk2*f*fd*s + 280*D1*Dd*K*Pk2*f*fd - 336*D1*Dd*Pk2*b2*f*r**2 - 672*D1*Dd*Pk2*b2*f*r*s + 504*D1*Dd*Pk2*b2*f*r - 336*D1*Dd*Pk2*b2*f*s**2 + 504*D1*Dd*Pk2*b2*f*s - 252*D1*Dd*Pk2*b2*f + 1120*D1*Dd*Pk2*b2*fd*r**2 + 2240*D1*Dd*Pk2*b2*fd*r*s - 840*D1*Dd*Pk2*b2*fd*r + 1120*D1*Dd*Pk2*b2*fd*s**2 - 840*D1*Dd*Pk2*b2*fd*s + 864*D1*Dd*Pk2*f**2*r**2 + 1552*D1*Dd*Pk2*f**2*r*s - 1252*D1*Dd*Pk2*f**2*r + 648*D1*Dd*Pk2*f**2*s**2 - 1100*D1*Dd*Pk2*f**2*s + 594*D1*Dd*Pk2*f**2 - 4416*D1*Dd*Pk2*f*fd*r**2 - 9920*D1*Dd*Pk2*f*fd*r*s + 5464*D1*Dd*Pk2*f*fd*r - 4128*D1*Dd*Pk2*f*fd*s**2 + 5608*D1*Dd*Pk2*f*fd*s - 1532*D1*Dd*Pk2*f*fd + 896*D1*Dd*Pk2*f*g2*r**2 + 1792*D1*Dd*Pk2*f*g2*r*s - 1344*D1*Dd*Pk2*f*g2*r + 896*D1*Dd*Pk2*f*g2*s**2 - 1344*D1*Dd*Pk2*f*g2*s + 672*D1*Dd*Pk2*f*g2 - 3136*D1*Dd*Pk2*f*gd2*r**2 - 7168*D1*Dd*Pk2*f*gd2*r*s + 5600*D1*Dd*Pk2*f*gd2*r - 3584*D1*Dd*Pk2*f*gd2*s**2 + 6272*D1*Dd*Pk2*f*gd2*s - 2464*D1*Dd*Pk2*f*gd2 - 3136*D1*Dd*Pk2*fd*g2*r**2 - 7168*D1*Dd*Pk2*fd*g2*r*s + 2016*D1*Dd*Pk2*fd*g2*r - 3584*D1*Dd*Pk2*fd*g2*s**2 + 1792*D1*Dd*Pk2*fd*g2*s + 448*D1*Dd*Pk2*fd*g2 - 72*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 36*D1*Dd*Pkdd2*f**2*k1**2*s - 18*D1*Dd*Pkdd2*f**2*k1**2 - 112*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 56*D1*Dd*Pkdd2*f*g2*k1**2*s - 28*D1*Dd*Pkdd2*f*g2*k1**2 + 224*D1*Ddd*K*Pk2*f**2*r*s - 56*D1*Ddd*K*Pk2*f**2*r + 336*D1*Ddd*K*Pk2*f**2*s**2 - 280*D1*Ddd*K*Pk2*f**2*s + 84*D1*Ddd*K*Pk2*f**2 + 560*D1*Ddd*Pk2*b2*f*r**2 + 1120*D1*Ddd*Pk2*b2*f*r*s - 840*D1*Ddd*Pk2*b2*f*r + 560*D1*Ddd*Pk2*b2*f*s**2 - 840*D1*Ddd*Pk2*b2*f*s + 420*D1*Ddd*Pk2*b2*f - 1104*D1*Ddd*Pk2*f**2*r**2 - 2480*D1*Ddd*Pk2*f**2*r*s + 1724*D1*Ddd*Pk2*f**2*r - 1032*D1*Ddd*Pk2*f**2*s**2 + 1756*D1*Ddd*Pk2*f**2*s - 810*D1*Ddd*Pk2*f**2 - 1568*D1*Ddd*Pk2*f*g2*r**2 - 3584*D1*Ddd*Pk2*f*g2*r*s + 2464*D1*Ddd*Pk2*f*g2*r - 1792*D1*Ddd*Pk2*f*g2*s**2 + 2688*D1*Ddd*Pk2*f*g2*s - 1232*D1*Ddd*Pk2*f*g2 - 28*D1*Pk2*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + D1*bd1*(D1*(-2*Pk2*f*(4*C*(6*r**2 - 20*r*s + 10*r - 26*s**2 + 26*s - 13) + 112*K*r**2 + 224*K*r*s - 252*K*r + 112*K*s**2 - 280*K*s + 140*K + 42*fd*(12*r**2 + 16*r*(s - 1) + 4*s**2 - 10*s + 5) + 10*r**2 + 40*r*s - 76*r + 30*s**2 - 44*s + 43) - 4*Pk2*(fd*(4*C*(46*r**2 + r*(108*s - 73) + 62*s**2 - 85*s + 27) - 14*K*(14*r**2 + 32*r*s - 14*r + 16*s**2 - 14*s - 1) - 110*r**2 - 216*r*s + 178*r - 134*s**2 + 196*s - 75) + 56*g2*(2*r**2 + r*(6*s - 3) + 4*s**2 - 4*s + 2) - 28*gd2*(4*r**2 + r*(12*s - 7) + 8*s**2 - 10*s + 3)) + 7*Pkdd2*f*k1**2*(2*K - 1)*(2*s**2 - 2*s + 1) + 6*f**2*(14*Pk2*(3*r**2 + r*(4*s - 5) + s**2 - 3*s + 2) - 3*Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 4*Dd*Pk2*(21*f**2*(24*r**2 + 4*r*(8*s - 9) + 8*s**2 - 22*s + 13) + 2*f*(2*C*(184*r**2 + r*(432*s - 254) + 248*s**2 - 294*s + 85) - 14*K*(28*r**2 + 64*r*s - 54*r + 32*s**2 - 60*s + 25) - 220*r**2 - 432*r*s + 244*r - 268*s**2 + 267*s - 63) - 56*g2*(8*r**2 + r*(24*s - 13) + 16*s**2 - 18*s + 5))) + 672*Dd**2*K*Pk2*f**2*r*s - 168*Dd**2*K*Pk2*f**2*r + 1008*Dd**2*K*Pk2*f**2*s**2 - 840*Dd**2*K*Pk2*f**2*s + 112*Dd**2*K*Pk2*f**2 + 1680*Dd**2*Pk2*b2*f*r**2 + 3360*Dd**2*Pk2*b2*f*r*s - 2520*Dd**2*Pk2*b2*f*r + 1680*Dd**2*Pk2*b2*f*s**2 - 2520*Dd**2*Pk2*b2*f*s + 840*Dd**2*Pk2*b2*f - 3312*Dd**2*Pk2*f**2*r**2 - 7440*Dd**2*Pk2*f**2*r*s + 5172*Dd**2*Pk2*f**2*r - 3096*Dd**2*Pk2*f**2*s**2 + 5268*Dd**2*Pk2*f**2*s - 1792*Dd**2*Pk2*f**2 - 4704*Dd**2*Pk2*f*g2*r**2 - 10752*Dd**2*Pk2*f*g2*r*s + 7392*Dd**2*Pk2*f*g2*r - 5376*Dd**2*Pk2*f*g2*s**2 + 8064*Dd**2*Pk2*f*g2*s - 2576*Dd**2*Pk2*f*g2))/(21*d**2*k3**4) + D1**2*Pk3*ct*k1*st**4*(-528*D1**2*Pk2*bd1**2*f*s*(-2*K*r + 2*K*s + K + 2*r - 2) - 4*D1*bd1*(D1*(-66*Pk2*f*(fd*(8*r*s - 2*r + 18*s**2 - 13*s + 2) + 4*s*(2*g2*r - 2*g2*s - 2*gd2*r + 2*gd2*s + gd2)) - 264*Pk2*fd*g2*(-2*r*s + r + s*(2*s - 2)) + 5*Pkdd2*f**3*k1**2*s**2 + f**2*s*(33*Pk2*(4*r + 11*s - 4) + 5*Pkdd2*fd*k1**2*(1 - 3*s))) - Dd*f*(66*Pk2*f*(2*r*(8*s - 1) + 36*s**2 - 21*s + 2) + 264*Pk2*g2*(-8*r*s + r + 8*s**2) + 5*Pkdd2*f**2*k1**2*s*(4*s - 1))) + 264*Pk2*b1**2*(2*D1*Dd*(2*f*(K*(-4*r*s + r + 4*s**2 + 1) + 4*r*s - r - 2*s) + fd*(-8*K*s**2 + 8*K*s + r*(K - 1)*(8*s - 5) - 2*s - 1)) + D1*(-D1*(2*fd - fdd)*(2*K*(s - 1)*(r - s + 1) - 2*r*(s - 1) - 2*s + 1) + 2*Ddd*f*(-K*(-4*r*s + r + 4*s**2 + 1) - 4*r*s + r + 2*s)) + 2*Dd**2*f*(K*(3*r*(4*s - 1) - 12*s**2 + 2) + r*(3 - 12*s) + 6*s - 2)) - 2*b1*(132*D1**2*Pk2*bdd1*f*(4*K*s**2 + s*(-4*K*r + 2*K + 4*r - 4) + 1) + 528*D1**2*Pk2*f*fd*r*s - 264*D1**2*Pk2*f*fd*r + 1452*D1**2*Pk2*f*fd*s**2 - 1452*D1**2*Pk2*f*fd*s + 726*D1**2*Pk2*f*fd - 528*D1**2*Pk2*f*fdd*r*s + 264*D1**2*Pk2*f*fdd*r - 1188*D1**2*Pk2*f*fdd*s**2 + 1188*D1**2*Pk2*f*fdd*s - 594*D1**2*Pk2*f*fdd - 1056*D1**2*Pk2*f*gd2*r*s + 1056*D1**2*Pk2*f*gd2*s**2 + 1056*D1**2*Pk2*f*gd2*s + 528*D1**2*Pk2*f*gdd2*r*s - 528*D1**2*Pk2*f*gdd2*s**2 - 528*D1**2*Pk2*f*gdd2*s - 528*D1**2*Pk2*fd**2*r*s + 264*D1**2*Pk2*fd**2*r - 1188*D1**2*Pk2*fd**2*s**2 + 1188*D1**2*Pk2*fd**2*s - 1056*D1**2*Pk2*fd*g2*r*s + 1056*D1**2*Pk2*fd*g2*r + 1056*D1**2*Pk2*fd*g2*s**2 - 2112*D1**2*Pk2*fd*g2*s + 1056*D1**2*Pk2*fd*g2 + 1056*D1**2*Pk2*fd*gd2*r*s - 528*D1**2*Pk2*fd*gd2*r - 1056*D1**2*Pk2*fd*gd2*s**2 + 528*D1**2*Pk2*fd*gd2*s + 528*D1**2*Pk2*fd*gd2 + 528*D1**2*Pk2*fdd*g2*r*s - 528*D1**2*Pk2*fdd*g2*r - 528*D1**2*Pk2*fdd*g2*s**2 + 1056*D1**2*Pk2*fdd*g2*s - 528*D1**2*Pk2*fdd*g2 + 30*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 20*D1**2*Pkdd2*f**2*fd*k1**2*s + 10*D1**2*Pkdd2*f**2*fd*k1**2 - 15*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 10*D1**2*Pkdd2*f**2*fdd*k1**2*s - 5*D1**2*Pkdd2*f**2*fdd*k1**2 - 30*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 20*D1**2*Pkdd2*f*fd**2*k1**2*s + 1056*D1*Dd*Pk2*f**2*r*s - 264*D1*Dd*Pk2*f**2*r + 2904*D1*Dd*Pk2*f**2*s**2 - 1980*D1*Dd*Pk2*f**2*s + 726*D1*Dd*Pk2*f**2 - 4224*D1*Dd*Pk2*f*fd*r*s + 1584*D1*Dd*Pk2*f*fd*r - 9504*D1*Dd*Pk2*f*fd*s**2 + 8184*D1*Dd*Pk2*f*fd*s - 1716*D1*Dd*Pk2*f*fd - 4224*D1*Dd*Pk2*f*g2*r*s + 1056*D1*Dd*Pk2*f*g2*r + 4224*D1*Dd*Pk2*f*g2*s**2 + 1056*D1*Dd*Pk2*f*g2 + 4224*D1*Dd*Pk2*f*gd2*r*s - 528*D1*Dd*Pk2*f*gd2*r - 4224*D1*Dd*Pk2*f*gd2*s**2 - 2112*D1*Dd*Pk2*f*gd2*s + 528*D1*Dd*Pk2*f*gd2 + 4224*D1*Dd*Pk2*fd*g2*r*s - 2640*D1*Dd*Pk2*fd*g2*r - 4224*D1*Dd*Pk2*fd*g2*s**2 + 4224*D1*Dd*Pk2*fd*g2*s + 40*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 20*D1*Dd*Pkdd2*f**3*k1**2*s + 10*D1*Dd*Pkdd2*f**3*k1**2 - 120*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 70*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 10*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1056*D1*Ddd*Pk2*f**2*r*s + 264*D1*Ddd*Pk2*f**2*r - 2376*D1*Ddd*Pk2*f**2*s**2 + 1716*D1*Ddd*Pk2*f**2*s - 594*D1*Ddd*Pk2*f**2 + 2112*D1*Ddd*Pk2*f*g2*r*s - 528*D1*Ddd*Pk2*f*g2*r - 2112*D1*Ddd*Pk2*f*g2*s**2 - 528*D1*Ddd*Pk2*f*g2 - 20*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 10*D1*Ddd*Pkdd2*f**3*k1**2*s - 5*D1*Ddd*Pkdd2*f**3*k1**2 + 264*D1*Pk2*bd1*(-D1*f*(4*K*s**2 + s*(-4*K*r + 2*K + 4*r - 4) + 1) - D1*fd*(K*(4*r*s - 2*r - 4*s**2 + 3*s + 1) - 4*r*s + 2*r - 1) + Dd*K*f*(r*(2 - 16*s) + 16*s**2 + 4*s - 1) + 2*Dd*f*(r*(8*s - 1) - 6*s + 1)) - 3168*Dd**2*Pk2*f**2*r*s + 792*Dd**2*Pk2*f**2*r - 7128*Dd**2*Pk2*f**2*s**2 + 5148*Dd**2*Pk2*f**2*s - 528*Dd**2*Pk2*f**2 + 6336*Dd**2*Pk2*f*g2*r*s - 1584*Dd**2*Pk2*f*g2*r - 6336*Dd**2*Pk2*f*g2*s**2 + 1056*Dd**2*Pk2*f*g2 - 60*Dd**2*Pkdd2*f**3*k1**2*s**2 + 30*Dd**2*Pkdd2*f**3*k1**2*s) + f*(D1**2*(-1056*Pk2*bdd1*g2*s*(r - s) + 10*Pkdd2*bdd1*f**2*k1**2*s**2 + f*(132*Pk2*bdd1*s*(4*r + 9*s - 4) - 8*Pk2*fdd*(20*C*(3*s**2 - 2*s + 1) + 18*r*s - 6*r - 15*s**2 + 4*s - 5) + Pkdd2*fdd*k1**2*(3*s**2 - 2*s + 1) + fd*(16*Pk2*(20*C*(3*s**2 - 2*s + 1) + 18*r*s - 6*r - 15*s**2 + 4*s - 5) - 2*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) - 2*fd**2*(8*Pk2*(6*r*(3*s - 1) + s**2*(60*C - 15) + s*(4 - 40*C) + 3) + Pkdd2*k1**2*s*(2 - 3*s))) + D1*f*(2*Dd*(8*Pk2*f*(20*C*(4*s**2 - 2*s + 1) + 24*r*s - 6*r - 20*s**2 - 2*s - 5) - 8*Pk2*fd*(20*C*(12*s**2 - 7*s + 1) + 72*r*s - 21*r - 60*s**2 + 5*s + 4) + Pkdd2*f*k1**2*(-4*s**2 + 2*s - 1) + Pkdd2*fd*k1**2*(12*s**2 - 7*s + 1)) + Ddd*f*(-8*Pk2*(20*C*(4*s**2 - 2*s + 1) + 24*r*s - 6*r - 20*s**2 - 2*s - 5) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - 6*Dd**2*f**2*(8*Pk2*(3*r*(4*s - 1) + s**2*(40*C - 10) - s*(20*C + 1) + 2) + Pkdd2*k1**2*s*(1 - 2*s))))/(231*d**2*k2*k3**2) + D1**2*Pk3*ct*k1*st**2*(1584*C*D1**2*Pk2*bdd1*f**2*r*s - 2904*C*D1**2*Pk2*bdd1*f**2*s**2 - 3888*C*D1**2*Pk2*f**2*fd*r*s + 1296*C*D1**2*Pk2*f**2*fd*r - 21384*C*D1**2*Pk2*f**2*fd*s**2 + 15552*C*D1**2*Pk2*f**2*fd*s - 7128*C*D1**2*Pk2*f**2*fd + 5904*C*D1**2*Pk2*f**2*fdd*r*s - 1968*C*D1**2*Pk2*f**2*fdd*r + 16632*C*D1**2*Pk2*f**2*fdd*s**2 - 13056*C*D1**2*Pk2*f**2*fdd*s + 5544*C*D1**2*Pk2*f**2*fdd + 11808*C*D1**2*Pk2*f*fd**2*r*s - 3936*C*D1**2*Pk2*f*fd**2*r + 33264*C*D1**2*Pk2*f*fd**2*s**2 - 26112*C*D1**2*Pk2*f*fd**2*s + 1968*C*D1**2*Pk2*f*fd**2 - 5184*C*D1*Dd*Pk2*f**3*r*s + 1296*C*D1*Dd*Pk2*f**3*r - 28512*C*D1*Dd*Pk2*f**3*s**2 + 16848*C*D1*Dd*Pk2*f**3*s - 7128*C*D1*Dd*Pk2*f**3 + 47232*C*D1*Dd*Pk2*f**2*fd*r*s - 13776*C*D1*Dd*Pk2*f**2*fd*r + 133056*C*D1*Dd*Pk2*f**2*fd*s**2 - 97296*C*D1*Dd*Pk2*f**2*fd*s + 16992*C*D1*Dd*Pk2*f**2*fd + 7872*C*D1*Ddd*Pk2*f**3*r*s - 1968*C*D1*Ddd*Pk2*f**3*r + 22176*C*D1*Ddd*Pk2*f**3*s**2 - 15024*C*D1*Ddd*Pk2*f**3*s + 5544*C*D1*Ddd*Pk2*f**3 + 23616*C*Dd**2*Pk2*f**3*r*s - 5904*C*Dd**2*Pk2*f**3*r + 66528*C*Dd**2*Pk2*f**3*s**2 - 45072*C*Dd**2*Pk2*f**3*s + 3936*C*Dd**2*Pk2*f**3 + 792*D1**2*K*Pk2*bdd1*f**2*r*s + 2772*D1**2*K*Pk2*bdd1*f**2*s**2 - 792*D1**2*K*Pk2*bdd1*f**2*s - 1584*D1**2*Pk2*b2*f*fd*r*s + 792*D1**2*Pk2*b2*f*fd*r - 7128*D1**2*Pk2*b2*f*fd*s**2 + 7128*D1**2*Pk2*b2*f*fd*s - 3564*D1**2*Pk2*b2*f*fd + 1584*D1**2*Pk2*b2*f*fdd*r*s - 792*D1**2*Pk2*b2*f*fdd*r + 5544*D1**2*Pk2*b2*f*fdd*s**2 - 5544*D1**2*Pk2*b2*f*fdd*s + 2772*D1**2*Pk2*b2*f*fdd + 1584*D1**2*Pk2*b2*fd**2*r*s - 792*D1**2*Pk2*b2*fd**2*r + 5544*D1**2*Pk2*b2*fd**2*s**2 - 5544*D1**2*Pk2*b2*fd**2*s - 792*D1**2*Pk2*bd2*f**2*r*s - 3564*D1**2*Pk2*bd2*f**2*s**2 + 792*D1**2*Pk2*bd2*f**2*s + 3168*D1**2*Pk2*bd2*f*fd*r*s - 792*D1**2*Pk2*bd2*f*fd*r + 11088*D1**2*Pk2*bd2*f*fd*s**2 - 7128*D1**2*Pk2*bd2*f*fd*s + 792*D1**2*Pk2*bd2*f*fd + 1188*D1**2*Pk2*bdd1*f**3*r**2 + 4752*D1**2*Pk2*bdd1*f**3*r*s - 1188*D1**2*Pk2*bdd1*f**3*r + 1980*D1**2*Pk2*bdd1*f**3*s**2 - 3168*D1**2*Pk2*bdd1*f**3*s + 594*D1**2*Pk2*bdd1*f**3 - 66*D1**2*Pk2*bdd1*f**2*r**2 - 3432*D1**2*Pk2*bdd1*f**2*r*s + 1188*D1**2*Pk2*bdd1*f**2*r - 528*D1**2*Pk2*bdd1*f**2*s**2 + 2244*D1**2*Pk2*bdd1*f**2*s - 792*D1**2*Pk2*bdd1*f**2 + 4752*D1**2*Pk2*bdd1*f*g2*r*s - 7656*D1**2*Pk2*bdd1*f*g2*s**2 + 792*D1**2*Pk2*bdd2*f**2*r*s + 2772*D1**2*Pk2*bdd2*f**2*s**2 - 792*D1**2*Pk2*bdd2*f**2*s - 1182*D1**2*Pk2*f**2*fd*r**2 - 8712*D1**2*Pk2*f**2*fd*r*s + 3692*D1**2*Pk2*f**2*fd*r + 7128*D1**2*Pk2*f**2*fd*s**2 - 1848*D1**2*Pk2*f**2*fd*s + 1982*D1**2*Pk2*f**2*fd + 1482*D1**2*Pk2*f**2*fdd*r**2 + 4752*D1**2*Pk2*f**2*fdd*r*s - 2572*D1**2*Pk2*f**2*fdd*r - 4752*D1**2*Pk2*f**2*fdd*s**2 + 1584*D1**2*Pk2*f**2*fdd*s - 1090*D1**2*Pk2*f**2*fdd + 1584*D1**2*Pk2*f**2*gd2*r*s + 7128*D1**2*Pk2*f**2*gd2*s**2 - 1584*D1**2*Pk2*f**2*gd2*s - 1584*D1**2*Pk2*f**2*gdd2*r*s - 5544*D1**2*Pk2*f**2*gdd2*s**2 + 1584*D1**2*Pk2*f**2*gdd2*s + 2964*D1**2*Pk2*f*fd**2*r**2 + 9504*D1**2*Pk2*f*fd**2*r*s - 5144*D1**2*Pk2*f*fd**2*r - 9504*D1**2*Pk2*f*fd**2*s**2 + 3168*D1**2*Pk2*f*fd**2*s + 1584*D1**2*Pk2*f*fd**2 + 3168*D1**2*Pk2*f*fd*g2*r*s - 1584*D1**2*Pk2*f*fd*g2*r + 14256*D1**2*Pk2*f*fd*g2*s**2 - 14256*D1**2*Pk2*f*fd*g2*s + 7128*D1**2*Pk2*f*fd*g2 - 6336*D1**2*Pk2*f*fd*gd2*r*s + 1584*D1**2*Pk2*f*fd*gd2*r - 22176*D1**2*Pk2*f*fd*gd2*s**2 + 14256*D1**2*Pk2*f*fd*gd2*s - 1584*D1**2*Pk2*f*fd*gd2 - 3168*D1**2*Pk2*f*fdd*g2*r*s + 1584*D1**2*Pk2*f*fdd*g2*r - 11088*D1**2*Pk2*f*fdd*g2*s**2 + 11088*D1**2*Pk2*f*fdd*g2*s - 5544*D1**2*Pk2*f*fdd*g2 - 3168*D1**2*Pk2*fd**2*g2*r*s + 1584*D1**2*Pk2*fd**2*g2*r - 11088*D1**2*Pk2*fd**2*g2*s**2 + 11088*D1**2*Pk2*fd**2*g2*s + 33*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 66*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 33*D1**2*Pkdd2*bdd1*f**2*k1**2 + 99*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 66*D1**2*Pkdd2*f**2*fd*k1**2*s + 33*D1**2*Pkdd2*f**2*fd*k1**2 - 66*D1**2*bd1**2*(56*Pk2*g2*r*(2*s - 1) + 6*f**2*(Pk2*(8*r*s - 6*r - 9*s + 4) - Pkdd2*k1**2*s*(s - 1)) + f*(2*Pk2*(-58*K*s**2 - 18*K*s + 4*r*(2*C*s - C + 9*K*s - 15*s + 3) + 55*s - 8) - Pkdd2*k1**2*s*(s - 1))) - 3168*D1*Dd*Pk2*b2*f**2*r*s + 792*D1*Dd*Pk2*b2*f**2*r - 14256*D1*Dd*Pk2*b2*f**2*s**2 + 8712*D1*Dd*Pk2*b2*f**2*s - 3564*D1*Dd*Pk2*b2*f**2 + 12672*D1*Dd*Pk2*b2*f*fd*r*s - 4752*D1*Dd*Pk2*b2*f*fd*r + 44352*D1*Dd*Pk2*b2*f*fd*s**2 - 36432*D1*Dd*Pk2*b2*f*fd*s + 7128*D1*Dd*Pk2*b2*f*fd + 6336*D1*Dd*Pk2*bd2*f**2*r*s - 792*D1*Dd*Pk2*bd2*f**2*r + 22176*D1*Dd*Pk2*bd2*f**2*s**2 - 10296*D1*Dd*Pk2*bd2*f**2*s + 792*D1*Dd*Pk2*bd2*f**2 - 1576*D1*Dd*Pk2*f**3*r**2 - 11616*D1*Dd*Pk2*f**3*r*s + 4480*D1*Dd*Pk2*f**3*r + 9504*D1*Dd*Pk2*f**3*s**2 + 1056*D1*Dd*Pk2*f**3*s + 1588*D1*Dd*Pk2*f**3 + 11856*D1*Dd*Pk2*f**2*fd*r**2 + 38016*D1*Dd*Pk2*f**2*fd*r*s - 20968*D1*Dd*Pk2*f**2*fd*r - 38016*D1*Dd*Pk2*f**2*fd*s**2 + 6336*D1*Dd*Pk2*f**2*fd*s + 3560*D1*Dd*Pk2*f**2*fd + 6336*D1*Dd*Pk2*f**2*g2*r*s - 1584*D1*Dd*Pk2*f**2*g2*r + 28512*D1*Dd*Pk2*f**2*g2*s**2 - 17424*D1*Dd*Pk2*f**2*g2*s + 7128*D1*Dd*Pk2*f**2*g2 - 12672*D1*Dd*Pk2*f**2*gd2*r*s + 1584*D1*Dd*Pk2*f**2*gd2*r - 44352*D1*Dd*Pk2*f**2*gd2*s**2 + 20592*D1*Dd*Pk2*f**2*gd2*s - 1584*D1*Dd*Pk2*f**2*gd2 - 25344*D1*Dd*Pk2*f*fd*g2*r*s + 9504*D1*Dd*Pk2*f*fd*g2*r - 88704*D1*Dd*Pk2*f*fd*g2*s**2 + 72864*D1*Dd*Pk2*f*fd*g2*s - 14256*D1*Dd*Pk2*f*fd*g2 + 132*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 66*D1*Dd*Pkdd2*f**3*k1**2*s + 33*D1*Dd*Pkdd2*f**3*k1**2 + 3168*D1*Ddd*Pk2*b2*f**2*r*s - 792*D1*Ddd*Pk2*b2*f**2*r + 11088*D1*Ddd*Pk2*b2*f**2*s**2 - 7128*D1*Ddd*Pk2*b2*f**2*s + 2772*D1*Ddd*Pk2*b2*f**2 + 1976*D1*Ddd*Pk2*f**3*r**2 + 6336*D1*Ddd*Pk2*f**3*r*s - 3560*D1*Ddd*Pk2*f**3*r - 6336*D1*Ddd*Pk2*f**3*s**2 - 596*D1*Ddd*Pk2*f**3 - 6336*D1*Ddd*Pk2*f**2*g2*r*s + 1584*D1*Ddd*Pk2*f**2*g2*r - 22176*D1*Ddd*Pk2*f**2*g2*s**2 + 14256*D1*Ddd*Pk2*f**2*g2*s - 5544*D1*Ddd*Pk2*f**2*g2 - 33*D1*bd1*(D1*(-16*Pk2*fd*g2*(9*r*(2*s - 1) + s*(29 - 29*s)) + 6*f**3*(Pk2*(6*r**2 + 6*r*(4*s - 1) + 10*s**2 - 16*s + 3) - Pkdd2*k1**2*s**2) + f**2*(-2*Pk2*(6*fd*(18*r**2 + 6*r*(12*s - 5) + 30*s**2 - 50*s + 11) + r**2 - 2*r*(20*C*s + s*(6*K - 30) + 11) + 2*s**2*(34*C - 27*K - 2) + 2*s*(6*K - 17) + 18) + Pkdd2*k1**2*(s**2 - 4*s + 2)) - 4*f*(2*Pk2*s*(-22*g2*r + 23*g2*s + 2*gd2*(18*r - 29*s - 9)) + fd*(Pk2*(-88*C*s**2 + 32*C*s + 6*K*(r*(4*s - 1) + 14*s**2 - 9*s + 1) - 2*r**2 + 4*r*(12*C*s - 3*C - 26*s + 9) - 16*s**2 + 51*s - 14) + Pkdd2*k1**2*s*(s - 1)))) - 2*Dd*f*(12*Pk2*f**2*(12*r**2 + 6*r*(8*s - 3) + 20*s**2 - 33*s + 7) + 8*Pk2*g2*(9*r*(8*s - 1) + s*(11 - 116*s)) + f*(2*Pk2*(-176*C*s**2 + 20*C*s + 6*K*(r*(8*s - 1) + 28*s**2 - 13*s + 1) - 4*r**2 + 4*r*(24*C*s - 3*C - 52*s + 16) - 32*s**2 + 128*s - 35) + Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + 9504*Dd**2*Pk2*b2*f**2*r*s - 2376*Dd**2*Pk2*b2*f**2*r + 33264*Dd**2*Pk2*b2*f**2*s**2 - 21384*Dd**2*Pk2*b2*f**2*s + 1584*Dd**2*Pk2*b2*f**2 + 5928*Dd**2*Pk2*f**3*r**2 + 19008*Dd**2*Pk2*f**3*r*s - 10680*Dd**2*Pk2*f**3*r - 19008*Dd**2*Pk2*f**3*s**2 + 4156*Dd**2*Pk2*f**3 - 19008*Dd**2*Pk2*f**2*g2*r*s + 4752*Dd**2*Pk2*f**2*g2*r - 66528*Dd**2*Pk2*f**2*g2*s**2 + 42768*Dd**2*Pk2*f**2*g2*s - 3168*Dd**2*Pk2*f**2*g2 + 1848*Pk2*b1**3*(K - 1)*(2*D1*Dd*(-4*r*s + r + 2*s) + D1*Ddd*(r*(4*s - 1) - 2*s) + Dd**2*(3*r*(4*s - 1) - 6*s + 2)) - 33*b1**2*(2*D1*Dd*(-64*C*Pk2*f*r*s + 16*C*Pk2*f*r + 32*C*Pk2*f*s - 176*K*Pk2*f*r*s + 44*K*Pk2*f*r + 184*K*Pk2*f*s**2 - 4*K*Pk2*f*s + 46*K*Pk2*f - 96*Pk2*f**2*r*s + 24*Pk2*f**2*r + 48*Pk2*f**2*s + 256*Pk2*f*r*s - 64*Pk2*f*r - 128*Pk2*f*s + 2*Pk2*fd*(4*C*(r*(8*s - 1) - 6*s + 1) + 144*K*r*s - 90*K*r - 232*K*s**2 + 254*K*s - 22*K + 3*f*(64*r*s - 12*s - 5) - 240*r*s + 102*r - 40*s - 11) - 448*Pk2*g2*r*s + 112*Pk2*g2*r + 224*Pk2*g2*s + 56*Pk2*gd2*(r*(8*s - 1) - 6*s + 1) + 24*Pkdd2*f**2*k1**2*s**2 - 12*Pkdd2*f**2*k1**2*s + 6*Pkdd2*f**2*k1**2 + 4*Pkdd2*f*k1**2*s**2 - 2*Pkdd2*f*k1**2*s + Pkdd2*f*k1**2 - Pkdd2*fd*k1**2*s*(12*f + 1)*(4*s - 1)) - 56*D1*Pk2*bd1*(K - 1)*(2*D1*(-3*r*s + r + s) + Dd*(r*(24*s - 7) - 10*s + 3)) + D1*(D1*(-56*Pk2*(bdd1*(K - 1)*(r*(3*s - 1) - s) + s*(4*gd2 - 2*gdd2)*(r - 1)) + 12*fd**2*(Pk2*(r*(8*s + 2) + s - 2) - Pkdd2*k1**2*s**2) + 2*fd*(Pk2*(-16*C*r*s + 16*C*s - 2*K*(s - 1)*(22*r - 23*s + 23) - 3*f*(4*r*(4*s + 1) + 6*s - 9) + 64*r*s - 44*r + 30*s - 23) + Pkdd2*k1**2*s**2*(12*f + 1)) + fdd*(2*Pk2*(8*C*r*s - 8*C*s + 2*K*(s - 1)*(18*r - 29*s + 29) + 3*f*(4*r*(4*s + 1) + 2*s - 7) - 60*r*s + 36*r - 50*s + 29) - Pkdd2*k1**2*s**2*(12*f + 1))) + Ddd*(112*Pk2*g2*(r*(4*s - 1) - 2*s) - 6*f**2*(8*Pk2*(-4*r*s + r + 2*s) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(-4*K*Pk2*(r*(18 - 72*s) + 116*s**2 - 22*s + 29) + Pk2*(16*C - 120)*(4*r*s - r - 2*s) - Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 2*Dd**2*(56*Pk2*g2*(3*r*(4*s - 1) - 6*s + 2) + 6*f**2*(4*Pk2*(12*r*s - 3*r - 6*s + 2) + 3*Pkdd2*k1**2*s*(1 - 2*s)) + f*(8*C*Pk2*(3*r*(4*s - 1) - 6*s + 2) + 12*Pk2*(K*(36*r*s - 9*r - 58*s**2 + 11*s + 6) - 60*r*s + 15*r + 30*s - 10) + 3*Pkdd2*k1**2*s*(1 - 2*s)))) + 33*b1*(-160*C*D1**2*Pk2*f*fd*r*s + 80*C*D1**2*Pk2*f*fd*r + 272*C*D1**2*Pk2*f*fd*s**2 - 192*C*D1**2*Pk2*f*fd*s + 136*C*D1**2*Pk2*f*fd + 96*C*D1**2*Pk2*f*fdd*r*s - 48*C*D1**2*Pk2*f*fdd*r - 176*C*D1**2*Pk2*f*fdd*s**2 + 128*C*D1**2*Pk2*f*fdd*s - 88*C*D1**2*Pk2*f*fdd + 96*C*D1**2*Pk2*fd**2*r*s - 48*C*D1**2*Pk2*fd**2*r - 176*C*D1**2*Pk2*fd**2*s**2 + 128*C*D1**2*Pk2*fd**2*s + 48*C*D1**2*Pk2*fd**2 - 320*C*D1*Dd*Pk2*f**2*r*s + 80*C*D1*Dd*Pk2*f**2*r + 544*C*D1*Dd*Pk2*f**2*s**2 - 112*C*D1*Dd*Pk2*f**2*s + 136*C*D1*Dd*Pk2*f**2 + 768*C*D1*Dd*Pk2*f*fd*r*s - 288*C*D1*Dd*Pk2*f*fd*r - 1408*C*D1*Dd*Pk2*f*fd*s**2 + 672*C*D1*Dd*Pk2*f*fd*s - 32*C*D1*Dd*Pk2*f*fd + 192*C*D1*Ddd*Pk2*f**2*r*s - 48*C*D1*Ddd*Pk2*f**2*r - 352*C*D1*Ddd*Pk2*f**2*s**2 + 80*C*D1*Ddd*Pk2*f**2*s - 88*C*D1*Ddd*Pk2*f**2 + 576*C*Dd**2*Pk2*f**2*r*s - 144*C*Dd**2*Pk2*f**2*r - 1056*C*Dd**2*Pk2*f**2*s**2 + 240*C*Dd**2*Pk2*f**2*s + 96*C*Dd**2*Pk2*f**2 - 48*D1**2*K*Pk2*f*fd*r*s + 24*D1**2*K*Pk2*f*fd*r - 216*D1**2*K*Pk2*f*fd*s**2 + 216*D1**2*K*Pk2*f*fd*s - 108*D1**2*K*Pk2*f*fd + 48*D1**2*K*Pk2*f*fdd*r*s - 24*D1**2*K*Pk2*f*fdd*r + 168*D1**2*K*Pk2*f*fdd*s**2 - 168*D1**2*K*Pk2*f*fdd*s + 84*D1**2*K*Pk2*f*fdd + 48*D1**2*K*Pk2*fd**2*r*s - 24*D1**2*K*Pk2*fd**2*r + 168*D1**2*K*Pk2*fd**2*s**2 - 168*D1**2*K*Pk2*fd**2*s + 56*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) - 2*s + 1) - 108*D1**2*Pk2*f**2*fd*r**2 - 432*D1**2*Pk2*f**2*fd*r*s + 252*D1**2*Pk2*f**2*fd*r - 180*D1**2*Pk2*f**2*fd*s**2 + 312*D1**2*Pk2*f**2*fd*s - 114*D1**2*Pk2*f**2*fd + 108*D1**2*Pk2*f**2*fdd*r**2 + 432*D1**2*Pk2*f**2*fdd*r*s - 252*D1**2*Pk2*f**2*fdd*r + 180*D1**2*Pk2*f**2*fdd*s**2 - 312*D1**2*Pk2*f**2*fdd*s + 114*D1**2*Pk2*f**2*fdd + 216*D1**2*Pk2*f*fd**2*r**2 + 864*D1**2*Pk2*f*fd**2*r*s - 504*D1**2*Pk2*f*fd**2*r + 360*D1**2*Pk2*f*fd**2*s**2 - 624*D1**2*Pk2*f*fd**2*s + 228*D1**2*Pk2*f*fd**2 + 4*D1**2*Pk2*f*fd*r**2 + 240*D1**2*Pk2*f*fd*r*s - 80*D1**2*Pk2*f*fd*r - 16*D1**2*Pk2*f*fd*s**2 - 36*D1**2*Pk2*f*fd*s - 42*D1**2*Pk2*f*fd - 4*D1**2*Pk2*f*fdd*r**2 - 208*D1**2*Pk2*f*fdd*r*s + 72*D1**2*Pk2*f*fdd*r - 32*D1**2*Pk2*f*fdd*s**2 + 68*D1**2*Pk2*f*fdd*s + 6*D1**2*Pk2*f*fdd - 176*D1**2*Pk2*f*gd2*r*s + 184*D1**2*Pk2*f*gd2*s**2 + 176*D1**2*Pk2*f*gd2*s + 144*D1**2*Pk2*f*gdd2*r*s - 232*D1**2*Pk2*f*gdd2*s**2 - 144*D1**2*Pk2*f*gdd2*s - 4*D1**2*Pk2*fd**2*r**2 - 208*D1**2*Pk2*fd**2*r*s + 72*D1**2*Pk2*fd**2*r - 32*D1**2*Pk2*fd**2*s**2 + 68*D1**2*Pk2*fd**2*s - 48*D1**2*Pk2*fd**2 - 176*D1**2*Pk2*fd*g2*r*s + 176*D1**2*Pk2*fd*g2*r + 184*D1**2*Pk2*fd*g2*s**2 - 368*D1**2*Pk2*fd*g2*s + 184*D1**2*Pk2*fd*g2 + 288*D1**2*Pk2*fd*gd2*r*s - 144*D1**2*Pk2*fd*gd2*r - 464*D1**2*Pk2*fd*gd2*s**2 + 320*D1**2*Pk2*fd*gd2*s + 144*D1**2*Pk2*fd*gd2 + 144*D1**2*Pk2*fdd*g2*r*s - 144*D1**2*Pk2*fdd*g2*r - 232*D1**2*Pk2*fdd*g2*s**2 + 464*D1**2*Pk2*fdd*g2*s - 232*D1**2*Pk2*fdd*g2 + 18*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 12*D1**2*Pkdd2*f**2*fd*k1**2*s + 6*D1**2*Pkdd2*f**2*fd*k1**2 - 2*D1**2*Pkdd2*f*fd*k1**2*s**2 - 2*D1**2*Pkdd2*f*fd*k1**2*s + D1**2*Pkdd2*f*fd*k1**2 + 2*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 2*D1**2*Pkdd2*fd**2*k1**2*s**2 + D1**2*bdd1*(112*Pk2*g2*r*(1 - 2*s) - 6*f**2*(Pk2*(4*r*(4*s - 3) - 18*s + 7) + Pkdd2*k1**2*(-2*s**2 + 2*s - 1)) + f*(Pk2*(232*K*s**2 + 72*K*s - 16*r*(2*C*s - C + 9*K*s - 15*s + 3) - 220*s + 58) + Pkdd2*k1**2*(2*s**2 - 2*s + 1))) - 96*D1*Dd*K*Pk2*f**2*r*s + 24*D1*Dd*K*Pk2*f**2*r - 432*D1*Dd*K*Pk2*f**2*s**2 + 264*D1*Dd*K*Pk2*f**2*s - 108*D1*Dd*K*Pk2*f**2 + 384*D1*Dd*K*Pk2*f*fd*r*s - 144*D1*Dd*K*Pk2*f*fd*r + 1344*D1*Dd*K*Pk2*f*fd*s**2 - 1104*D1*Dd*K*Pk2*f*fd*s + 216*D1*Dd*K*Pk2*f*fd - 144*D1*Dd*Pk2*f**3*r**2 - 576*D1*Dd*Pk2*f**3*r*s + 288*D1*Dd*Pk2*f**3*r - 240*D1*Dd*Pk2*f**3*s**2 + 408*D1*Dd*Pk2*f**3*s - 132*D1*Dd*Pk2*f**3 + 864*D1*Dd*Pk2*f**2*fd*r**2 + 3456*D1*Dd*Pk2*f**2*fd*r*s - 1872*D1*Dd*Pk2*f**2*fd*r + 1440*D1*Dd*Pk2*f**2*fd*s**2 - 2472*D1*Dd*Pk2*f**2*fd*s + 816*D1*Dd*Pk2*f**2*fd + 8*D1*Dd*Pk2*f**2*r**2 + 480*D1*Dd*Pk2*f**2*r*s - 128*D1*Dd*Pk2*f**2*r - 32*D1*Dd*Pk2*f**2*s**2 - 224*D1*Dd*Pk2*f**2*s - 4*D1*Dd*Pk2*f**2 - 32*D1*Dd*Pk2*f*fd*r**2 - 1664*D1*Dd*Pk2*f*fd*r*s + 512*D1*Dd*Pk2*f*fd*r - 256*D1*Dd*Pk2*f*fd*s**2 + 752*D1*Dd*Pk2*f*fd*s - 212*D1*Dd*Pk2*f*fd - 704*D1*Dd*Pk2*f*g2*r*s + 176*D1*Dd*Pk2*f*g2*r + 736*D1*Dd*Pk2*f*g2*s**2 - 16*D1*Dd*Pk2*f*g2*s + 184*D1*Dd*Pk2*f*g2 + 1152*D1*Dd*Pk2*f*gd2*r*s - 144*D1*Dd*Pk2*f*gd2*r - 1856*D1*Dd*Pk2*f*gd2*s**2 - 400*D1*Dd*Pk2*f*gd2*s + 144*D1*Dd*Pk2*f*gd2 + 1152*D1*Dd*Pk2*fd*g2*r*s - 720*D1*Dd*Pk2*fd*g2*r - 1856*D1*Dd*Pk2*fd*g2*s**2 + 2032*D1*Dd*Pk2*fd*g2*s - 176*D1*Dd*Pk2*fd*g2 + 24*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 12*D1*Dd*Pkdd2*f**3*k1**2*s + 6*D1*Dd*Pkdd2*f**3*k1**2 - 4*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 2*D1*Dd*Pkdd2*f**2*k1**2*s - D1*Dd*Pkdd2*f**2*k1**2 + 16*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 4*D1*Dd*Pkdd2*f*fd*k1**2*s + 96*D1*Ddd*K*Pk2*f**2*r*s - 24*D1*Ddd*K*Pk2*f**2*r + 336*D1*Ddd*K*Pk2*f**2*s**2 - 216*D1*Ddd*K*Pk2*f**2*s + 84*D1*Ddd*K*Pk2*f**2 + 144*D1*Ddd*Pk2*f**3*r**2 + 576*D1*Ddd*Pk2*f**3*r*s - 288*D1*Ddd*Pk2*f**3*r + 240*D1*Ddd*Pk2*f**3*s**2 - 408*D1*Ddd*Pk2*f**3*s + 132*D1*Ddd*Pk2*f**3 - 8*D1*Ddd*Pk2*f**2*r**2 - 416*D1*Ddd*Pk2*f**2*r*s + 112*D1*Ddd*Pk2*f**2*r - 64*D1*Ddd*Pk2*f**2*s**2 + 240*D1*Ddd*Pk2*f**2*s - 20*D1*Ddd*Pk2*f**2 + 576*D1*Ddd*Pk2*f*g2*r*s - 144*D1*Ddd*Pk2*f*g2*r - 928*D1*Ddd*Pk2*f*g2*s**2 + 176*D1*Ddd*Pk2*f*g2*s - 232*D1*Ddd*Pk2*f*g2 + 4*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 2*D1*Ddd*Pkdd2*f**2*k1**2*s + D1*Ddd*Pkdd2*f**2*k1**2 + 2*D1*bd1*(D1*(56*Pk2*(2*g2*r*(2*s - 1) + gd2*(-4*r*s + r + 2*s - 1)) + 3*f**2*(Pk2*(4*r*(4*s - 3) - 22*s + 9) - 2*Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - f*(Pk2*(92*K*s**2 + 44*K*s + 12*fd*(4*r*(4*s - 1) - 8*s + 3) - 4*r*(8*C*s - 4*C + 22*K*s - 32*s + 5) - 94*s + 23) + Pkdd2*k1**2*(s**2*(2 - 24*fd) + s*(12*fd - 2) + 1)) - fd*(2*Pk2*(4*C*(r*(4*s - 1) - 2*s + 1) + 2*K*(36*r*s - 18*r - 58*s**2 + 49*s + 9) - 120*r*s + 48*r + 5*s - 22) + Pkdd2*k1**2*s*(1 - 2*s))) + Dd*(-112*Pk2*g2*(r*(8*s - 3) - 2*s + 1) - 6*f**2*(Pk2*(32*r*(2*s - 1) - 52*s + 21) + Pkdd2*k1**2*(-8*s**2 + 6*s - 1)) + f*(-2*Pk2*(8*C*(r*(8*s - 3) - 2*s + 1) + 2*K*(18*r*(8*s - 1) - 232*s**2 - 14*s + 9) - 480*r*s + 108*r + 340*s - 79) + Pkdd2*k1**2*(8*s**2 - 6*s + 1)))) + 288*Dd**2*K*Pk2*f**2*r*s - 72*Dd**2*K*Pk2*f**2*r + 1008*Dd**2*K*Pk2*f**2*s**2 - 648*Dd**2*K*Pk2*f**2*s + 48*Dd**2*K*Pk2*f**2 + 432*Dd**2*Pk2*f**3*r**2 + 1728*Dd**2*Pk2*f**3*r*s - 864*Dd**2*Pk2*f**3*r + 720*Dd**2*Pk2*f**3*s**2 - 1224*Dd**2*Pk2*f**3*s + 360*Dd**2*Pk2*f**3 - 24*Dd**2*Pk2*f**2*r**2 - 1248*Dd**2*Pk2*f**2*r*s + 336*Dd**2*Pk2*f**2*r - 192*Dd**2*Pk2*f**2*s**2 + 720*Dd**2*Pk2*f**2*s - 212*Dd**2*Pk2*f**2 + 1728*Dd**2*Pk2*f*g2*r*s - 432*Dd**2*Pk2*f*g2*r - 2784*Dd**2*Pk2*f*g2*s**2 + 528*Dd**2*Pk2*f*g2*s + 288*Dd**2*Pk2*f*g2 + 12*Dd**2*Pkdd2*f**2*k1**2*s**2 - 6*Dd**2*Pkdd2*f**2*k1**2*s))/(1386*d**2*k2*k3**2) + D1**2*Pk3*ct*k1*(4*D1**2*Pk2*bd1**2*(7*f**2*(6*r**2 + r*(8*s - 9) - 5*s + 4) + f*(28*K*s**2 + 14*r**2 + r*(60*C*s - 30*C - 18*s - 5) - 35*s + 21) + 14*g2*r*(1 - 2*s)) + 2*D1*bd1*(D1*(-2*Pk2*f*(fd*(-152*C*s**2 + 76*C*s + 14*K*(4*r*s - r + 6*s**2 - 5*s + 1) - 44*r**2 - 116*r*s + 80*r + 76*s**2 + 10*s - 29) + s**2*(-28*g2 + 56*gd2)) - 112*Pk2*fd*g2*s*(s - 1) + f**2*(Pk2*(-32*r**2 + r*(s*(28*K - 62) + 62) + s**2*(-76*C + 42*K + 38) + s*(38 - 28*K) - 19) + 3*Pkdd2*k1**2*(s - 1)**2)) - 2*Dd*Pk2*f*(f*(-304*C*s**2 + 76*C*s + 14*K*(8*r*s - r + 12*s**2 - 9*s + 1) - 88*r**2 - 232*r*s + 189*r + 152*s**2 + 96*s - 77) + 56*g2*s*(4*s - 1))) + 28*Pk2*b1**3*(K - 1)*(2*D1*Dd*(-4*r*s + r + 2*s) + D1*Ddd*(r*(4*s - 1) - 2*s) + Dd**2*(3*r*(4*s - 1) - 6*s + 2)) + 2*Pk2*(168*C*D1**2*f**2*fd*r*s - 56*C*D1**2*f**2*fd*r + 216*C*D1**2*f**2*fd*s**2 - 200*C*D1**2*f**2*fd*s + 72*C*D1**2*f**2*fd - 168*C*D1**2*f**2*fdd*r*s + 56*C*D1**2*f**2*fdd*r - 216*C*D1**2*f**2*fdd*s**2 + 200*C*D1**2*f**2*fdd*s - 72*C*D1**2*f**2*fdd - 336*C*D1**2*f*fd**2*r*s + 112*C*D1**2*f*fd**2*r - 432*C*D1**2*f*fd**2*s**2 + 400*C*D1**2*f*fd**2*s - 56*C*D1**2*f*fd**2 + 224*C*D1*Dd*f**3*r*s - 56*C*D1*Dd*f**3*r + 288*C*D1*Dd*f**3*s**2 - 256*C*D1*Dd*f**3*s + 72*C*D1*Dd*f**3 - 1344*C*D1*Dd*f**2*fd*r*s + 392*C*D1*Dd*f**2*fd*r - 1728*C*D1*Dd*f**2*fd*s**2 + 1568*C*D1*Dd*f**2*fd*s - 312*C*D1*Dd*f**2*fd - 224*C*D1*Ddd*f**3*r*s + 56*C*D1*Ddd*f**3*r - 288*C*D1*Ddd*f**3*s**2 + 256*C*D1*Ddd*f**3*s - 72*C*D1*Ddd*f**3 - 672*C*Dd**2*f**3*r*s + 168*C*Dd**2*f**3*r - 864*C*Dd**2*f**3*s**2 + 768*C*Dd**2*f**3*s - 112*C*Dd**2*f**3 + D1**2*bdd1*f*(f*(22*r**2 + r*(s*(58 - 28*K) - 58) + s**2*(76*C - 42*K - 38) + s*(28*K - 38) + 19) - 56*g2*s**2) - 28*D1**2*bdd2*f**2*r*s - 42*D1**2*bdd2*f**2*s**2 + 28*D1**2*bdd2*f**2*s - 84*D1**2*f**2*fd*r*s + 28*D1**2*f**2*fd*r - 108*D1**2*f**2*fd*s**2 + 100*D1**2*f**2*fd*s - 36*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r*s - 28*D1**2*f**2*fdd*r + 108*D1**2*f**2*fdd*s**2 - 100*D1**2*f**2*fdd*s + 36*D1**2*f**2*fdd - 56*D1**2*f**2*gd2*r*s - 84*D1**2*f**2*gd2*s**2 + 56*D1**2*f**2*gd2*s + 56*D1**2*f**2*gdd2*r*s + 84*D1**2*f**2*gdd2*s**2 - 56*D1**2*f**2*gdd2*s + 168*D1**2*f*fd**2*r*s - 56*D1**2*f*fd**2*r + 216*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2*s + 28*D1**2*f*fd**2 - 112*D1**2*f*fd*g2*r*s + 56*D1**2*f*fd*g2*r - 168*D1**2*f*fd*g2*s**2 + 168*D1**2*f*fd*g2*s - 84*D1**2*f*fd*g2 + 224*D1**2*f*fd*gd2*r*s - 56*D1**2*f*fd*gd2*r + 336*D1**2*f*fd*gd2*s**2 - 280*D1**2*f*fd*gd2*s + 56*D1**2*f*fd*gd2 + 112*D1**2*f*fdd*g2*r*s - 56*D1**2*f*fdd*g2*r + 168*D1**2*f*fdd*g2*s**2 - 168*D1**2*f*fdd*g2*s + 84*D1**2*f*fdd*g2 + 112*D1**2*fd**2*g2*r*s - 56*D1**2*fd**2*g2*r + 168*D1**2*fd**2*g2*s**2 - 168*D1**2*fd**2*g2*s - 112*D1*Dd*f**3*r*s + 28*D1*Dd*f**3*r - 144*D1*Dd*f**3*s**2 + 128*D1*Dd*f**3*s - 36*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r*s - 196*D1*Dd*f**2*fd*r + 864*D1*Dd*f**2*fd*s**2 - 784*D1*Dd*f**2*fd*s + 156*D1*Dd*f**2*fd - 224*D1*Dd*f**2*g2*r*s + 56*D1*Dd*f**2*g2*r - 336*D1*Dd*f**2*g2*s**2 + 280*D1*Dd*f**2*g2*s - 84*D1*Dd*f**2*g2 + 448*D1*Dd*f**2*gd2*r*s - 56*D1*Dd*f**2*gd2*r + 672*D1*Dd*f**2*gd2*s**2 - 504*D1*Dd*f**2*gd2*s + 56*D1*Dd*f**2*gd2 + 896*D1*Dd*f*fd*g2*r*s - 336*D1*Dd*f*fd*g2*r + 1344*D1*Dd*f*fd*g2*s**2 - 1232*D1*Dd*f*fd*g2*s + 280*D1*Dd*f*fd*g2 + 112*D1*Ddd*f**3*r*s - 28*D1*Ddd*f**3*r + 144*D1*Ddd*f**3*s**2 - 128*D1*Ddd*f**3*s + 36*D1*Ddd*f**3 + 224*D1*Ddd*f**2*g2*r*s - 56*D1*Ddd*f**2*g2*r + 336*D1*Ddd*f**2*g2*s**2 - 280*D1*Ddd*f**2*g2*s + 84*D1*Ddd*f**2*g2 + 14*D1*bd2*f*(D1*(f*s*(2*r + 3*s - 2) - 2*fd*(4*r*s - r + 6*s**2 - 5*s + 1)) - 2*Dd*f*(r*(8*s - 1) + 12*s**2 - 9*s + 1)) + 336*Dd**2*f**3*r*s - 84*Dd**2*f**3*r + 432*Dd**2*f**3*s**2 - 384*Dd**2*f**3*s + 56*Dd**2*f**3 + 672*Dd**2*f**2*g2*r*s - 168*Dd**2*f**2*g2*r + 1008*Dd**2*f**2*g2*s**2 - 840*Dd**2*f**2*g2*s + 112*Dd**2*f**2*g2 + 14*b2*(D1**2*(f*(fd - fdd)*(r*(4*s - 2) + 6*s**2 - 6*s + 3) + 2*fd**2*(-2*r*s + r - s*(3*s - 3))) + D1*f*(Dd*(f*(8*r*s - 2*r + 12*s**2 - 10*s + 3) - 2*fd*(16*r*s - 6*r + 24*s**2 - 22*s + 5)) + Ddd*f*(r*(2 - 8*s) - 12*s**2 + 10*s - 3)) - 2*Dd**2*f**2*(3*r*(4*s - 1) + 18*s**2 - 15*s + 2))) + b1**2*(D1**2*(28*Pk2*fd**2*(6*r**2 + r*(8*s - 7) - 3*s + 1) + 4*Pk2*(7*bdd1*(K - 1)*(r*(3*s - 1) - s) + fdd*(30*C*r*s - 30*C*s + 14*K*(s - 1)**2 + 7*f*(6*r**2 + r*(8*s - 7) - 3*s + 3) + 7*r**2 - 9*r*s + 44*s - 7) + 7*s*(4*gd2 - 2*gdd2)*(r - 1)) + fd*(-4*Pk2*(32*C*r*s - 32*C*s + 14*K*(s - 1)**2 + 7*f*(6*r**2 + r*(8*s - 7) - 3*s + 3) + 7*r**2 - 11*r*s + 46*s - 7) + Pkdd2*k1**2*s**2*(24*f + 7))) + 28*D1*Pk2*bd1*(K - 1)*(2*D1*(-3*r*s + r + s) + Dd*(r*(24*s - 7) - 10*s + 3)) + D1*(Dd*(-56*Pk2*f**2*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + 4*Pk2*f*(-128*C*r*s + 32*C*r + 64*C*s - 14*K*(4*s**2 - 2*s + 1) + 7*fd*(48*r**2 + r*(64*s - 60) - 28*s + 17) - 28*r**2 + 44*r*s + 17*r - 22*s - 14) + 4*Pk2*fd*(30*C*(r*(8*s - 1) - 6*s + 1) + 28*K*(4*s**2 - 5*s + 1) + 56*r**2 - 72*r*s - 19*r + 194*s - 44) - 56*Pk2*(2*g2*(-4*r*s + r + 2*s) + gd2*r*(8*s - 1) - 6*gd2*s + gd2) + 12*Pkdd2*f**2*k1**2*(4*s**2 - 2*s + 1) + 7*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) + 4*Ddd*Pk2*(14*f**2*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + f*(-60*C*s + 14*K*(4*s**2 - 2*s + 1) + 28*r**2 + r*(30*C*(4*s - 1) - 36*s - 19) + 18*s + 14) + 14*g2*(-4*r*s + r + 2*s))) + 4*Dd**2*Pk2*(14*f**2*(18*r**2 + 24*r*(s - 1) - 12*s + 7) + f*(30*C*(3*r*(4*s - 1) - 6*s + 2) + 168*K*s**2 - 84*K*s + 84*r**2 - 3*r*(36*s + 19) + 54*s - 4) + 14*g2*(r*(3 - 12*s) + 6*s - 2))) + b1*(28*D1**2*Pk2*bd1**2*(K - 1)*(r*(6*s - 2) - 2*s + 1) + 4*D1**2*Pk2*bdd1*(7*f**2*(6*r**2 + r*(8*s - 9) - 5*s + 3) + f*(28*K*s**2 + 14*r**2 + r*(60*C*s - 30*C - 18*s - 5) - 35*s + 14) + 14*g2*r*(1 - 2*s)) + 2*D1**2*(4*Pk2*(fd**2*(11*r**2 + r*(K*(7 - 14*s) + 29*s - 11) + s*(38*C*(s - 1) - 21*K*(s - 1) - 19*s + 14)) + 14*fd*(s - 1)*(g2*(s - 1) - 2*gd2*s) - 14*fdd*g2*(s - 1)**2) + f*(Pk2*fd*(-76*C*(2*s**2 - 2*s + 1) + 14*K*(4*r*s - 2*r + 6*s**2 - 6*s + 3) - 64*r**2 - 124*r*s + 64*r + 76*s**2 - 52*s + 25) + Pk2*fdd*(76*C*(2*s**2 - 2*s + 1) - 14*K*(4*r*s - 2*r + 6*s**2 - 6*s + 3) + 44*r**2 + 116*r*s - 44*r - 76*s**2 + 56*s - 35) + Pk2*s**2*(56*gd2 - 56*gdd2) + 6*Pkdd2*fd*k1**2*s**2)) + D1*bd1*(D1*(-28*Pk2*f**2*(6*r**2 + r*(8*s - 9) - 5*s + 3) + 4*Pk2*f*(-28*K*s**2 + 7*fd*(24*r**2 + 32*r*(s - 1) - 16*s + 9) - 14*r**2 + r*(-64*C*s + 32*C + 22*s + 3) + 35*s - 14) + 4*Pk2*fd*(30*C*(r*(4*s - 1) - 2*s + 1) + 56*K*s**2 - 56*K*s + 28*r**2 - r*(36*s + 5) + 53*s - 30) + 56*Pk2*(2*g2*r*(2*s - 1) + gd2*(-4*r*s + r + 2*s - 1)) + 12*Pkdd2*f**2*k1**2*(2*s**2 - 2*s + 1) + 7*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) + 4*Dd*Pk2*(7*f**2*(48*r**2 + r*(64*s - 68) - 36*s + 23) + f*(60*C*(r*(8*s - 3) - 2*s + 1) + 224*K*s**2 - 56*K*s + 112*r**2 - 2*r*(72*s + 29) - 104*s + 45) - 28*g2*(r*(8*s - 3) - 2*s + 1))) + 2*D1*(Dd*(4*Pk2*f*(fd*(38*C*(8*s**2 - 6*s + 1) - 7*K*(16*r*s - 6*r + 24*s**2 - 22*s + 5) + 88*r**2 + 232*r*s - 117*r - 152*s**2 + 36*s + 8) + 14*g2*(4*s**2 - 2*s + 1) + 28*gd2*s*(1 - 4*s)) - 112*Pk2*fd*g2*(4*s**2 - 5*s + 1) + f**2*(-2*Pk2*(38*C*(4*s**2 - 2*s + 1) - 7*K*(8*r*s - 2*r + 12*s**2 - 10*s + 3) + 64*r**2 + 124*r*s - 95*r - 76*s**2 - 24*s + 13) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + 2*Ddd*Pk2*f*(f*(38*C*(4*s**2 - 2*s + 1) - 7*K*(8*r*s - 2*r + 12*s**2 - 10*s + 3) + 44*r**2 + 116*r*s - 73*r - 76*s**2 - 20*s + 3) - 28*g2*(4*s**2 - 2*s + 1))) - 4*Dd**2*Pk2*f*(f*(-456*C*s**2 + 228*C*s + 14*K*(12*r*s - 3*r + 18*s**2 - 15*s + 2) - 132*r**2 - 348*r*s + 219*r + 228*s**2 + 60*s - 80) + 168*g2*s*(2*s - 1))))/(21*d**2*k2*k3**2) + D1**2*Pk3*ct*k2**3*st**4*(D1**2*(33*Pkdd2*k1**2*s*(b1**2*s*(2*K - 1)*(2*fd - fdd) - 2*b1*bd1*fd*(2*K - 1)*(2*s - 1) + 4*b1*s*(-2*fd*g2 + 2*fd*gd2 + fdd*g2) + 8*bd1*fd*g2*(s - 1)) + f**2*(-2*Pk2*fdd*(4*C*(147*r**2 + 6*r*(5*s - 18) - 10*s + 49) - 411*r**2 - 60*r*s + 294*r + 20*s - 137) + Pkdd2*fdd*k1**2*(20*C - 10)*(3*s**2 - 2*s + 1) + Pkdd2*k1**2*s**2*(-66*K*bd1 + 33*bd1 + 132*gd2) + 10*fd*(Pk2*(4*C*(39*r**2 + 6*r*(2*s - 5) - 4*s + 13) - 105*r**2 - 24*r*s + 78*r + 8*s - 35) + Pkdd2*k1**2*(2 - 4*C)*(3*s**2 - 2*s + 1))) + f*(33*Pkdd2*fd*k1**2*(2*s**2 - 2*s + 1)*(-2*K*b1 + b1 + 4*g2) + 33*Pkdd2*k1**2*(b1*(2*bd1*(2*K - 1)*(2*s**2 - 2*s + 1) - bdd1*(2*K - 1)*(2*s**2 - 2*s + 1) + s**2*(-8*gd2 + 4*gdd2)) + (2 - 2*s)*(bd1**2*s*(2*K - 1) + 4*bd1*g2*(s - 1) - 4*bd1*gd2*s - 2*bdd1*g2*(s - 1))) - 4*fd**2*(Pk2*(4*C*(147*r**2 + 6*r*(5*s - 18) - 10*s + 5) - 411*r**2 - 60*r*s + 294*r + 20*s - 10) + Pkdd2*k1**2*s*(5 - 10*C)*(3*s - 2)))) + D1*(Dd*(-66*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(b1*(2*K - 1) - 4*g2) + 66*Pkdd2*f*k1**2*(b1**2*(2*K - 1)*(4*s**2 - 2*s + 1) - b1*bd1*(2*K - 1)*(8*s**2 - 6*s + 1) - 4*b1*(g2*(4*s**2 - 2*s + 1) + gd2*s*(1 - 4*s)) + 4*bd1*g2*(4*s**2 - 5*s + 1)) + 20*f**3*(Pk2*(4*C*(26*r**2 + 8*r*s - 28*r - 4*s + 13) - 70*r**2 - 16*r*s + 74*r + 8*s - 35) - Pkdd2*k1**2*(2*C - 1)*(4*s**2 - 2*s + 1)) + f**2*(-16*Pk2*fd*(C*(588*r**2 + 15*r*(8*s - 35) - 50*s + 113) - 411*r**2 - 60*r*(s - 6) + 25*s - 76) + Pkdd2*fd*k1**2*(40*C - 20)*(12*s**2 - 7*s + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)*(-66*K*b1 + 33*b1 + 132*g2))) + Ddd*f*(-33*Pkdd2*b1*k1**2*(b1*(2*K - 1) - 4*g2)*(4*s**2 - 2*s + 1) - 2*f**2*(2*Pk2*(4*C*(98*r**2 + 20*r*s - 103*r - 10*s + 49) - 274*r**2 - 40*r*s + 284*r + 20*s - 137) + Pkdd2*k1**2*(5 - 10*C)*(4*s**2 - 2*s + 1)))) - 2*Dd**2*f*(99*Pkdd2*b1*k1**2*s*(2*s - 1)*(b1*(2*K - 1) - 4*g2) + 2*f**2*(Pk2*(4*C*(294*r**2 + 60*r*s - 309*r - 30*s + 59) - 822*r**2 - 120*r*s + 852*r + 60*s - 157) + Pkdd2*k1**2*s*(15 - 30*C)*(2*s - 1))))/(231*d**2*k1*k3**4) + D1**2*Pk3*ct*k2**3*st**2*(D1**2*(-264*Pkdd2*bd1*fd*g2*k1**2*s*(s - 1) + f**2*(-44*Pk2*bd1*r*(-4*C*(5*r + 2*s - 4) + 15*r + 4*s - 8) - 176*Pk2*bdd1*r**2*(4*C - 3) + Pk2*fdd*(128 - 256*C)*(3*r**2 - 2*r + 1) - 11*Pkdd2*bd1*k1**2*(20*C*(s - 1)**2 - s**2*(6*K + 9) + 18*s - 9) + 66*Pkdd2*bdd1*k1**2*(2*C - 1)*(s - 1)**2 - 132*Pkdd2*gd2*k1**2*s**2 - fd*(4*C - 2)*(4*Pk2*(3*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + 4*f*(33*K*Pkdd2*bd1**2*k1**2*s*(s - 1) - 33*Pkdd2*bdd1*g2*k1**2*(s - 1)**2 + 11*bd1*(Pk2*fd*r*(24 - 32*C)*(2*r - 1) + Pkdd2*fd*k1**2*s*(12*C - 6)*(s - 1) + 13*Pkdd2*g2*k1**2*(s - 1)**2 - 6*Pkdd2*gd2*k1**2*s*(s - 1)) + fd*(Pk2*fd*r*(64 - 128*C)*(3*r - 2) - 33*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1)))) - 2*D1*f*(Dd*(132*Pkdd2*bd1*g2*k1**2*(4*s**2 - 5*s + 1) + f**2*(2*C - 1)*(8*Pk2*(2*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + 2*f*(176*Pk2*bd1*r*(4*C - 3)*(2*r - 1) + Pk2*fd*(256*C - 128)*(6*r**2 - 5*r + 1) - 33*Pkdd2*bd1*k1**2*(2*C - 1)*(4*s**2 - 5*s + 1) + 33*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f**2*(256*C - 128)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f**3*(256 - 512*C)*(6*r**2 - 6*r + 1) - 11*Pkdd2*b1**2*k1**2*(D1**2*s**2*(-6*K*fdd + fd*(26*K + 6*f - 7)) + D1*(Dd*(12*K*fd*s*(1 - 4*s) + 3*f**2*(4*s**2 - 2*s + 1) + f*(26*K - 7)*(4*s**2 - 2*s + 1)) - 6*Ddd*K*f*(4*s**2 - 2*s + 1)) + 36*Dd**2*K*f*s*(1 - 2*s)) - 11*b1*(D1**2*(3*Pkdd2*bd1*f**2*k1**2*(2*s**2 - 2*s + 1) + 4*Pkdd2*fd*k1**2*s*(K*bd1*(3 - 6*s) - 13*g2*s + 6*gd2*s) + 12*Pkdd2*fdd*g2*k1**2*s**2 - f*(Pkdd2*k1**2*(6*K*bdd1*(2*s**2 - 2*s + 1) - bd1*(26*K - 7)*(2*s**2 - 2*s + 1) + s**2*(52*gd2 - 12*gdd2)) + 2*fd*(2*Pk2*(4*C*(10*r**2 + 4*r*(s - 2) - 2*s + 5) - 30*r**2 - 8*r*s + 26*r + 4*s - 15) + Pkdd2*k1**2*(K*(6*s**2 - 6*s + 3) + s**2*(9 - 20*C))) - 4*fdd*(Pk2*(16*C - 12)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*s**2*(3 - 6*C))) + 4*fd**2*(Pk2*r*(32*C - 24)*(r - 1) + Pkdd2*k1**2*s**2*(3 - 6*C))) - D1*Dd*(24*Pkdd2*fd*g2*k1**2*s*(1 - 4*s) + f**2*(8*Pk2*(4*C*(10*r**2 + r*(4*s - 11) - 2*s + 5) - 30*r**2 - 8*r*(s - 4) + 4*s - 15) - Pkdd2*k1**2*(20*C - 6*K - 9)*(4*s**2 - 2*s + 1)) - 4*f*(Pk2*fd*(1 - 2*r)**2*(64*C - 48) + 6*Pkdd2*fd*k1**2*s*(C*(2 - 8*s) + 4*s - 1) - 13*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + 3*Pkdd2*k1**2*(4*s - 1)*(bd1*(-2*K*s + K) + 2*gd2*s))) + 2*D1*Ddd*f*(Pk2*f*(64*C - 48)*(2*r**2 - 2*r + 1) - Pkdd2*f*k1**2*(6*C - 3)*(4*s**2 - 2*s + 1) + 6*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1)) + 4*Dd**2*f*(Pk2*f*(32*C - 24)*(6*r**2 - 6*r + 1) - Pkdd2*f*k1**2*s*(18*C - 9)*(2*s - 1) + 18*Pkdd2*g2*k1**2*s*(2*s - 1))))/(462*d**2*k1*k3**4) + 2*D1**2*Pk3*ct*k2**3*(-2*D1*f*(2*D1*Pk2*bd1**2*r*(2*C - 1)*(2*r + 2*s - 1) + D1*Pk2*bdd1*f*r*(2*C - 1)*(r - 2*s + 2) + D1*bd1*(Pk2*fd*(4*C - 2)*(2*r**2 - 4*r*s + r + s - 1) + 7*Pkdd2*g2*k1**2*(s - 1)**2 - f*(2*C - 1)*(Pk2*r*(-7*r - 2*s + 2) + 3*Pkdd2*k1**2*(s - 1)**2)) + 2*Dd*Pk2*bd1*f*(2*C - 1)*(4*r**2 - 8*r*s + 3*r + 2*s - 2)) + b1**2*(D1**2*(7*K*Pkdd2*fd*k1**2*s**2 + Pk2*fd*(16*C - 8)*(r - 1)*(r + s - 1) - Pk2*fdd*(8*C - 4)*(r - 1)*(r + s - 1)) + D1*(Dd*(Pk2*fd*(4 - 8*C)*(8*r**2 + r*(8*s - 13) - 6*s + 5) + f*(7*K*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + Pk2*(16*C - 8)*(4*r**2 + r*(4*s - 5) - 2*s + 2))) + Ddd*Pk2*f*(4 - 8*C)*(4*r**2 + r*(4*s - 5) - 2*s + 2)) - Dd**2*Pk2*f*(8*C - 4)*(12*r**2 + 3*r*(4*s - 5) - 6*s + 4)) + b1*(-2*D1**2*(f*(8*C*Pk2*bdd1*r**2 + 8*C*Pk2*bdd1*r*s - 4*C*Pk2*bdd1*r - 4*Pk2*bdd1*r**2 - 4*Pk2*bdd1*r*s + 2*Pk2*bdd1*r + Pk2*fdd*(2*C - 1)*(2*r**2 - 4*r*s - 2*r + 2*s + 1) + 7*Pkdd2*gd2*k1**2*s**2 + fd*(2*C - 1)*(Pk2*(14*r**2 + 4*r*s - 14*r - 2*s + 7) - 6*Pkdd2*k1**2*s**2)) + fd*(Pk2*fd*(4*C - 2)*(r**2 - r*(2*s + 1) + s) + 7*Pkdd2*g2*k1**2*s**2)) + D1*bd1*(D1*(Pk2*fd*(4 - 8*C)*(4*r**2 + r*(4*s - 5) - 2*s + 1) + f*(7*K*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + Pk2*r*(16*C - 8)*(2*r + 2*s - 1))) + Dd*Pk2*f*(8 - 16*C)*(8*r**2 + r*(8*s - 7) - 2*s + 1)) - 2*D1*f*(Dd*(Pk2*fd*(4*C - 2)*(2*r - 1)*(4*r - 8*s - 1) + 7*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + f*(2*C - 1)*(2*Pk2*(14*r**2 + r*(4*s - 15) - 2*s + 7) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(4*C - 2)*(2*r**2 - r*(4*s + 1) + 2*s + 1)) - 2*Dd**2*Pk2*f**2*(4*C - 2)*(6*r**2 - 3*r*(4*s + 1) + 6*s - 1)))/(21*d**2*k1*k3**4) + D1**2*Pk3*ct*k2*st**4*(D1**2*(33*Pkdd2*k1**2*(b1**2*(2*fd - fdd)*(2*K*(s - 1)**2 + 2*s - 1) - 2*b1*(4*fd*g2*(s - 1)**2 + fd*s*(4*K*bd1*(s - 1) + bd1 - 4*gd2*(s - 1)) - 2*fdd*g2*(s - 1)**2) + 8*bd1*fd*g2*s*(s - 1)) + f**2*(-33*Pkdd2*bd1*k1**2*s**2 + 10*fd*(Pk2*(-16*C*s + 27*r**2 + 2*r*(24*C*s - 8*C - 12*s - 5) + 8*s + 9) + Pkdd2*k1**2*(4*C - 2)*(3*s**2 - 2*s + 1)) - 2*fdd*(Pk2*(-40*C*s + 117*r**2 + 2*r*(60*C*s - 20*C - 30*s - 29) + 20*s + 39) + Pkdd2*k1**2*(10*C - 5)*(3*s**2 - 2*s + 1))) + f*(-33*Pkdd2*b1*fd*k1**2*(2*s**2 - 2*s + 1) + 33*Pkdd2*k1**2*(b1*(bd1*(8*K*s**2 - 4*s + 2) + bdd1*(-4*K*s**2 + 2*s - 1) + s**2*(-8*gd2 + 4*gdd2)) + 2*s*(bd1**2*(-2*K*s + 1) + 4*bd1*s*(-g2 + gd2) + 2*bdd1*g2*s)) - 4*fd**2*(Pk2*(20*C*(6*r*s - 2*r - 2*s + 1) + 117*r**2 - 60*r*s - 58*r + 20*s - 10) + Pkdd2*k1**2*s*(10*C - 5)*(3*s - 2)))) + D1*(Dd*(-66*Pkdd2*b1*fd*k1**2*(4*s - 1)*(2*K*b1*(s - 1) + b1 - 4*g2*(s - 1)) + 66*Pkdd2*f*k1**2*(2*K*b1**2*(4*s**2 - 2*s + 1) - b1*(bd1*(4*s - 1)*(4*K*s - 1) + 4*g2*(4*s**2 - 2*s + 1) + 4*gd2*s*(1 - 4*s)) + 4*bd1*g2*s*(4*s - 1)) + 20*f**3*(Pk2*(-16*C*s + 18*r**2 + 2*r*(16*C*s - 4*C - 8*s - 7) + 8*s + 9) + Pkdd2*k1**2*(2*C - 1)*(4*s**2 - 2*s + 1)) - f**2*(33*Pkdd2*b1*k1**2*(4*s**2 - 2*s + 1) + 4*fd*(4*Pk2*(5*C*(r*(24*s - 7) - 10*s + 3) + 117*r**2 - 20*r*(3*s + 4) + 25*s + 12) + Pkdd2*k1**2*(10*C - 5)*(12*s**2 - 7*s + 1)))) - 2*Ddd*f*(33*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1) + f**2*(2*Pk2*(-40*C*s + 78*r**2 + 4*r*(20*C*s - 5*C - 10*s - 17) + 20*s + 39) + Pkdd2*k1**2*(10*C - 5)*(4*s**2 - 2*s + 1)))) - 4*Dd**2*f*(99*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2) + f**2*(Pk2*(20*C*(3*r*(4*s - 1) - 6*s + 2) + 234*r**2 - 12*r*(10*s + 17) + 60*s + 19) + Pkdd2*k1**2*s*(30*C - 15)*(2*s - 1))))/(231*d**2*k1*k3**2) + D1**2*Pk3*ct*k2*st**2*(D1**2*(44*Pkdd2*bd1*k1**2*s*(s - 1)*(-3*b2*fd + 14*bd1*g2 + 6*fd*g2) + f**2*(440*Pk2*bd1*r**2*(2*C - 1) + Pk2*fdd*(256*C - 128)*(3*r**2 - 2*r + 1) + 11*Pkdd2*bd1*k1**2*(4*C*(7*s**2 - 12*s + 6) - s**2*(6*K + 14) + 22*s - 11) - 11*Pkdd2*k1**2*s**2*(6*bd2 - 12*gd2) - 22*bdd1*(2*C - 1)*(16*Pk2*r**2 + 3*Pkdd2*k1**2*(s - 1)**2) + fd*(4*C - 2)*(4*Pk2*(3*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(3*s**2 - 2*s + 1))) + 2*f*(-33*Pkdd2*b2*k1**2*(-2*bd1*(s - 1)**2 + bdd1*(s - 1)**2 + fd*(2*s**2 - 2*s + 1)) + 11*Pkdd2*bd1**2*k1**2*s*(s - 1)*(4*C - 6*K - 3) + 66*Pkdd2*bdd1*g2*k1**2*(s - 1)**2 + 22*bd1*(Pkdd2*g2*k1**2*(s**2 + 12*s - 6) + Pkdd2*k1**2*s*(-3*bd2 + 6*gd2)*(s - 1) - fd*(4*C - 2)*(8*Pk2*r*(2*r - 1) + 3*Pkdd2*k1**2*s*(s - 1))) + 2*fd*(Pk2*fd*r*(128*C - 64)*(3*r - 2) + 33*Pkdd2*g2*k1**2*(2*s**2 - 2*s + 1)))) + 2*D1*f*(Dd*(-66*Pkdd2*bd1*k1**2*(b2 - 2*g2)*(4*s**2 - 5*s + 1) + f**2*(2*C - 1)*(8*Pk2*(2*r**2 - 2*r + 1) - 33*Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(Pk2*fd*(512*C - 256)*(6*r**2 - 5*r + 1) - 33*Pkdd2*b2*k1**2*(4*s**2 - 2*s + 1) + 66*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) - 22*bd1*(2*C - 1)*(32*Pk2*r*(2*r - 1) + 3*Pkdd2*k1**2*(4*s**2 - 5*s + 1)))) + Ddd*Pk2*f**2*(256*C - 128)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f**3*(512*C - 256)*(6*r**2 - 6*r + 1) + 11*Pkdd2*b1**3*k1**2*(3*D1**2*s**2*(2*fd - fdd) + 2*D1*Dd*(14*K*(4*s**2 - 2*s + 1) + 3*f*(4*s**2 - 2*s + 1) - 12*fd*s**2 + 3*fd*s - 28*s**2 + 14*s - 7) - D1*Ddd*(14*K + 3*f - 7)*(4*s**2 - 2*s + 1) - 6*Dd**2*s*(2*s - 1)*(14*K + 3*f - 7)) + 11*Pkdd2*b1**2*k1**2*(-8*C*D1**2*fd*s**2 + 4*C*D1**2*fdd*s**2 - 32*C*D1*Dd*f*s**2 + 16*C*D1*Dd*f*s - 8*C*D1*Dd*f + 32*C*D1*Dd*fd*s**2 - 8*C*D1*Dd*fd*s + 16*C*D1*Ddd*f*s**2 - 8*C*D1*Ddd*f*s + 4*C*D1*Ddd*f + 48*C*Dd**2*f*s**2 - 24*C*Dd**2*f*s - 2*D1**2*K*fd*s**2 + 28*D1**2*K*fd*s - 14*D1**2*K*fd - 6*D1**2*K*fdd*s**2 - D1**2*bdd1*(14*K + 3*f - 7)*(3*s**2 - 2*s + 1) + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 6*D1**2*fd*s**2 - 14*D1**2*fd*s + 7*D1**2*fd - 3*D1**2*fdd*s**2 - 56*D1**2*gd2*s**2 + 28*D1**2*gdd2*s**2 - 8*D1*Dd*K*f*s**2 + 4*D1*Dd*K*f*s - 2*D1*Dd*K*f - 48*D1*Dd*K*fd*s**2 + 12*D1*Dd*K*fd*s + 24*D1*Dd*f*s**2 - 12*D1*Dd*f*s + 6*D1*Dd*f - 24*D1*Dd*fd*s**2 + 6*D1*Dd*fd*s - 224*D1*Dd*g2*s**2 + 112*D1*Dd*g2*s - 56*D1*Dd*g2 + 224*D1*Dd*gd2*s**2 - 56*D1*Dd*gd2*s - 24*D1*Ddd*K*f*s**2 + 12*D1*Ddd*K*f*s - 6*D1*Ddd*K*f - 12*D1*Ddd*f*s**2 + 6*D1*Ddd*f*s - 3*D1*Ddd*f + 112*D1*Ddd*g2*s**2 - 56*D1*Ddd*g2*s + 28*D1*Ddd*g2 + 2*D1*bd1*(D1*(14*K*(3*s**2 - 2*s + 1) + f*(9*s**2 - 6*s + 3) - 9*fd*s**2 + 3*fd*s - 21*s**2 + 14*s - 7) - Dd*(14*K + 3*f - 7)*(12*s**2 - 7*s + 1)) - 72*Dd**2*K*f*s**2 + 36*Dd**2*K*f*s - 36*Dd**2*f*s**2 + 18*Dd**2*f*s + 336*Dd**2*g2*s**2 - 168*Dd**2*g2*s) - 11*b1*(D1**2*(128*C*Pk2*fd**2*r**2 - 128*C*Pk2*fd**2*r + 24*C*Pkdd2*fd**2*k1**2*s**2 - 64*Pk2*fd**2*r**2 + 64*Pk2*fd**2*r - 12*Pkdd2*b2*fd*k1**2*s**2 + 6*Pkdd2*b2*fdd*k1**2*s**2 + 14*Pkdd2*bd1**2*k1**2*s*(2*K - 1)*(3*s - 2) + 3*Pkdd2*bd1*f**2*k1**2*(2*s - 1) - 2*Pkdd2*bd1*k1**2*(-28*g2*(2*s**2 - 2*s + 1) + s*(2*s - 1)*(fd*(4*C - 6*K - 3) + 28*gd2)) + 12*Pkdd2*bd2*fd*k1**2*s**2 - 28*Pkdd2*bdd1*g2*k1**2*(2*s**2 - 2*s + 1) - 12*Pkdd2*fd**2*k1**2*s**2 - 4*Pkdd2*fd*g2*k1**2*s**2 + 56*Pkdd2*fd*g2*k1**2*s - 28*Pkdd2*fd*g2*k1**2 - 24*Pkdd2*fd*gd2*k1**2*s**2 - 12*Pkdd2*fdd*g2*k1**2*s**2 + f*(Pkdd2*k1**2*(6*bd1**2*s*(3*s - 2) + bd1*(8*C*(2*s**2 - 2*s + 1) + 4*K*(s**2 + 6*s - 3) - 12*s**2 - 2*s + 1) - bdd1*(4*C - 6*K - 3)*(2*s**2 - 2*s + 1) + s**2*(-12*bd2 + 6*bdd2 - 4*gd2 - 12*gdd2)) + fd*(Pk2*(40 - 80*C)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(C*(-56*s**2 + 8*s - 4) + 6*K*(2*s**2 - 2*s + 1) + 28*s**2 - 6*s + 3)) + fdd*(8*C - 4)*(8*Pk2*(2*r**2 - 2*r + 1) + 3*Pkdd2*k1**2*s**2))) - 2*D1*(Dd*(2*Pkdd2*k1**2*(4*s - 1)*(14*bd1*g2*(2*s - 1) - 3*fd*s*(b2 - 2*g2)) + f**2*(Pk2*(80*C - 40)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(14*C - 3*K - 7)*(4*s**2 - 2*s + 1)) + f*(Pkdd2*k1**2*(6*b2*(4*s**2 - 2*s + 1) + bd1*(4*C - 6*K - 3)*(8*s**2 - 6*s + 1) + g2*(8*s**2 - 4*s + 2) + s*(-6*bd2 + 12*gd2)*(4*s - 1)) + fd*(4 - 8*C)*(16*Pk2*(1 - 2*r)**2 + 3*Pkdd2*k1**2*s*(4*s - 1)))) + Ddd*f*(Pkdd2*k1**2*(-3*b2 + 6*g2)*(4*s**2 - 2*s + 1) - f*(2*C - 1)*(32*Pk2*(2*r**2 - 2*r + 1) + 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1)))) + 4*Dd**2*f*(Pkdd2*k1**2*s*(9*b2 - 18*g2)*(2*s - 1) + f*(2*C - 1)*(16*Pk2*(6*r**2 - 6*r + 1) + 9*Pkdd2*k1**2*s*(2*s - 1)))))/(462*d**2*k1*k3**2) - D1**2*Pk3*ct*k2*(7*D1*Pkdd2*b1**3*k1**2*(D1*fd*s**2 + Dd*f*(4*s**2 - 2*s + 1)) + 2*D1*f*(2*D1*Pk2*bd1**2*r*(4*C*(9*r - 2*s + 1) - 27*r + 4*s - 2) - 2*D1*Pk2*bdd1*f*r*(2*C - 1)*(r + 2) + bd1*(D1*(Pk2*fd*(4 - 8*C)*(2*r**2 - 1) + 7*Pkdd2*b2*k1**2*(s - 1)**2 - 14*Pkdd2*g2*k1**2*(s - 1)**2 + f*(4*C - 2)*(Pk2*r*(2 - 7*r) + 3*Pkdd2*k1**2*(s - 1)**2)) + Dd*Pk2*f*(8 - 16*C)*(2*r**2 + r - 1))) + b1**2*(D1**2*(2*Pk2*fdd*(r - 1)*(4*C*(9*r - 2*s - 9) - 27*r + 4*s + 27) + 7*Pkdd2*bd1*f*k1**2*(3*s**2 - 2*s + 1) + fd*(2*Pk2*(r - 1)*(4*C*(3*r + 4*s - 3) - 9*r - 8*s + 9) + Pkdd2*k1**2*s**2*(-28*C + 14*K + 21))) + D1*(Dd*(16*Pk2*fd*(C*(36*r**2 - r*(8*s + 53) + 6*s + 17) - 27*r**2 + 4*r*(s + 10) - 3*s - 13) + f*(4*Pk2*(4*C*(6*r**2 + 8*r*(s - 1) - 4*s + 3) - 18*r**2 + r*(22 - 16*s) + 8*s - 9) - Pkdd2*k1**2*(28*C - 14*K - 21)*(4*s**2 - 2*s + 1))) + 4*Ddd*Pk2*f*(4*C*(18*r**2 - r*(4*s + 17) + 2*s + 9) - 54*r**2 + r*(8*s + 52) - 4*s - 27)) + 4*Dd**2*Pk2*f*(4*C*(54*r**2 - 3*r*(4*s + 17) + 6*s + 7) - 162*r**2 + 12*r*(2*s + 13) - 12*s - 23)) + b1*(2*D1**2*(f*(72*C*Pk2*bdd1*r**2 - 16*C*Pk2*bdd1*r*s + 8*C*Pk2*bdd1*r - 54*Pk2*bdd1*r**2 + 8*Pk2*bdd1*r*s - 4*Pk2*bdd1*r - Pk2*fdd*(4*C - 2)*(2*r**2 - 4*r + 1) + 7*Pkdd2*bd2*k1**2*s**2 - 14*Pkdd2*gd2*k1**2*s**2 - fd*(4*C - 2)*(Pk2*(14*r**2 - 12*r + 7) - 6*Pkdd2*k1**2*s**2)) + fd*(Pk2*fd*(4 - 8*C)*(r - 1)**2 + Pkdd2*k1**2*s**2*(7*b2 - 14*g2))) + D1*bd1*(D1*(8*Pk2*fd*(C*(36*r**2 - 2*r*(4*s + 17) + 4*s - 2) - 27*r**2 + r*(4*s + 26) - 2*s + 1) + f*(4*Pk2*r*(4*C*(3*r + 4*s - 2) - 9*r - 8*s + 4) + Pkdd2*k1**2*(-28*C + 14*K + 21)*(2*s**2 - 2*s + 1))) + 16*Dd*Pk2*f*(2*C*(36*r**2 - r*(8*s + 15) + 2*s - 1) - 54*r**2 + 8*r*(s + 3) - 2*s + 1)) + 2*D1*f*(Dd*(Pk2*fd*(16 - 32*C)*(2*r**2 - 3*r + 1) + Pkdd2*k1**2*(7*b2 - 14*g2)*(4*s**2 - 2*s + 1) - f*(4*C - 2)*(14*Pk2*(2*r**2 - 2*r + 1) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(4 - 8*C)*(2*r**2 - 2*r + 1)) + 2*Dd**2*Pk2*f**2*(4 - 8*C)*(6*r**2 - 6*r + 1)))/(21*d**2*k1*k3**2) + D1**2*Pk3*ct*st**2*(D1*f*(-16*D1*Pk2*bdd1*f*r**2 + 2*D1*Pkdd2*bd1**2*k1**2*s*(s - 1) + D1*bd1*(4*Pk2*f*r*(8*C*s + 5*r - 4*s) + 32*Pk2*fd*r*(1 - 2*r) + Pkdd2*f*k1**2*s**2) - 64*Dd*Pk2*bd1*f*r*(2*r - 1)) + Pkdd2*b1**3*k1**2*(3*D1**2*s**2*(-2*fd + fdd) + 2*D1*Dd*(-3*f*(4*s**2 - 2*s + 1) + s**2*(12*fd + 28) - s*(3*fd + 14) + 7) + D1*Ddd*(3*f - 7)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(3*f - 7)*(2*s - 1)) + Pkdd2*b1**2*k1**2*(D1**2*bdd1*(3*f - 7)*(3*s**2 - 2*s + 1) + 6*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s + 3*D1**2*f*fd - 9*D1**2*fd*s**2 + 14*D1**2*fd*s - 7*D1**2*fd + D1**2*fdd*s**2 + 12*D1*Dd*f**2*s**2 - 6*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 36*D1*Dd*f*s**2 + 18*D1*Dd*f*s - 9*D1*Dd*f + 8*D1*Dd*fd*s**2 - 2*D1*Dd*fd*s + 4*D1*Ddd*f*s**2 - 2*D1*Ddd*f*s + D1*Ddd*f - 2*D1*bd1*(D1*(f*(9*s**2 - 6*s + 3) - s**2*(9*fd + 21) + s*(3*fd + 14) - 7) - Dd*(3*f - 7)*(12*s**2 - 7*s + 1)) + 12*Dd**2*f*s**2 - 6*Dd**2*f*s) + b1*(D1**2*(-32*Pk2*fd**2*r**2 + 32*Pk2*fd**2*r - 42*Pkdd2*bd1**2*k1**2*s**2 + 28*Pkdd2*bd1**2*k1**2*s + 6*Pkdd2*bd1*f**2*k1**2*s**2 + 4*Pkdd2*bd1*fd*k1**2*s**2 - 2*Pkdd2*bd1*fd*k1**2*s + f*(-16*Pk2*fdd*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(6*bd1**2*s*(3*s - 2) - 2*bd1*(9*s**2 - 2*s + 1) + bdd1*(2*s**2 - 2*s + 1)) + fd*(4*Pk2*(-8*C*s + 10*r**2 + 2*r*(8*C*s - 4*C - 4*s - 3) + 4*s + 5) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)))) + D1*f*(Dd*(8*Pk2*f*(4*C*r*(4*s - 1) + 10*r**2 - 8*r*(s + 1) + s*(4 - 8*C) + 5) - 64*Pk2*fd*(1 - 2*r)**2 + 2*Pkdd2*bd1*k1**2*(8*s**2 - 6*s + 1) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 32*Ddd*Pk2*f*(2*r**2 - 2*r + 1)) - 32*Dd**2*Pk2*f**2*(6*r**2 - 6*r + 1)))/(42*d**2*k1*k2) + D1**2*Pk3*ct*(-4*D1*Pk2*f*(9*D1*bd1**2*r**2 + 2*D1*bdd1*f*r*s*(2*C - 1) + 2*bd1*(2*C - 1)*(-D1*(f*r*s + fd*(-4*r*s + r + s)) + Dd*f*(r*(8*s - 1) - 2*s))) + 7*D1*Pkdd2*b1**3*k1**2*(D1*fd*s**2 + Dd*f*(4*s**2 - 2*s + 1)) + b1**2*(D1**2*(-18*Pk2*fdd*(r - 1)**2 + 7*Pkdd2*bd1*f*k1**2*(3*s**2 - 2*s + 1) + fd*(-6*Pk2*(r - 1)**2 + 7*Pkdd2*k1**2*s**2)) - D1*(Dd*(12*Pk2*f*(2*r**2 - 2*r + 1) + 72*Pk2*fd*(2*r**2 - 3*r + 1) - 7*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) + 36*Ddd*Pk2*f*(2*r**2 - 2*r + 1)) - 36*Dd**2*Pk2*f*(6*r**2 - 6*r + 1)) + b1*(8*D1*Dd*Pk2*f*(18*bd1*r*(1 - 2*r) + f*(2*C - 1)*(4*r*s - r - 2*s) - fd*(2*C - 1)*(2*r - 1)*(8*s - 3)) + D1*(D1*(Pk2*fd**2*(8 - 16*C)*(r*(2*s - 1) - s + 1) - 8*Pk2*fd*(9*bd1*r*(r - 1) - f*(2*C - 1)*(2*r*s - r - s)) + f*(-12*Pk2*bd1*r**2 - 36*Pk2*bdd1*r**2 - Pk2*fdd*(16*C - 8)*(r*(2*s - 1) - s) + 7*Pkdd2*bd1*k1**2*(2*s**2 - 2*s + 1))) + Ddd*Pk2*f**2*(8 - 16*C)*(r*(4*s - 1) - 2*s)) + Dd**2*Pk2*f**2*(8 - 16*C)*(3*r*(4*s - 1) - 6*s + 2)))/(21*d**2*k1*k2) + 5*D1**2*Pk3*f*k1**2*st**6*(4992*D1**2*Pk2*b1*f*fd*r*s - 1664*D1**2*Pk2*b1*f*fd*r + 3744*D1**2*Pk2*b1*f*fd*s**2 - 4160*D1**2*Pk2*b1*f*fd*s + 1040*D1**2*Pk2*b1*f*fd - 2496*D1**2*Pk2*b1*f*fdd*r*s + 832*D1**2*Pk2*b1*f*fdd*r - 1872*D1**2*Pk2*b1*f*fdd*s**2 + 2080*D1**2*Pk2*b1*f*fdd*s - 520*D1**2*Pk2*b1*f*fdd - 4992*D1**2*Pk2*b1*fd**2*r*s + 1664*D1**2*Pk2*b1*fd**2*r - 3744*D1**2*Pk2*b1*fd**2*s**2 + 4160*D1**2*Pk2*b1*fd**2*s - 1040*D1**2*Pk2*b1*fd**2 - 104*D1**2*Pk2*bdd1*f**2*(6*s**2 + s*(8*r - 8) + 1) - 3744*D1**2*Pk2*f**2*fd*r*s + 936*D1**2*Pk2*f**2*fd*r - 3536*D1**2*Pk2*f**2*fd*s**2 + 3640*D1**2*Pk2*f**2*fd*s - 884*D1**2*Pk2*f**2*fd + 3744*D1**2*Pk2*f**2*fdd*r*s - 936*D1**2*Pk2*f**2*fdd*r + 2704*D1**2*Pk2*f**2*fdd*s**2 - 3224*D1**2*Pk2*f**2*fdd*s + 676*D1**2*Pk2*f**2*fdd + 11232*D1**2*Pk2*f*fd**2*r*s - 2808*D1**2*Pk2*f*fd**2*r + 8112*D1**2*Pk2*f*fd**2*s**2 - 9672*D1**2*Pk2*f*fd**2*s + 1872*D1**2*Pk2*f*fd**2 - 72*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 36*D1**2*Pkdd2*f**2*fd*k1**2*s - 18*D1**2*Pkdd2*f**2*fd*k1**2 + 36*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 18*D1**2*Pkdd2*f**2*fdd*k1**2*s + 9*D1**2*Pkdd2*f**2*fdd*k1**2 + 108*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 54*D1**2*Pkdd2*f*fd**2*k1**2*s + 6656*D1*Dd*Pk2*b1*f**2*r*s - 1664*D1*Dd*Pk2*b1*f**2*r + 4992*D1*Dd*Pk2*b1*f**2*s**2 - 5824*D1*Dd*Pk2*b1*f**2*s + 1248*D1*Dd*Pk2*b1*f**2 - 19968*D1*Dd*Pk2*b1*f*fd*r*s + 5824*D1*Dd*Pk2*b1*f*fd*r - 14976*D1*Dd*Pk2*b1*f*fd*s**2 + 17056*D1*Dd*Pk2*b1*f*fd*s - 3744*D1*Dd*Pk2*b1*f*fd - 3744*D1*Dd*Pk2*f**3*r*s + 936*D1*Dd*Pk2*f**3*r - 3536*D1*Dd*Pk2*f**3*s**2 + 3640*D1*Dd*Pk2*f**3*s - 884*D1*Dd*Pk2*f**3 + 29952*D1*Dd*Pk2*f**2*fd*r*s - 7488*D1*Dd*Pk2*f**2*fd*r + 21632*D1*Dd*Pk2*f**2*fd*s**2 - 25792*D1*Dd*Pk2*f**2*fd*s + 5096*D1*Dd*Pk2*f**2*fd - 72*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 36*D1*Dd*Pkdd2*f**3*k1**2*s - 18*D1*Dd*Pkdd2*f**3*k1**2 + 288*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 144*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 18*D1*Dd*Pkdd2*f**2*fd*k1**2 - 3328*D1*Ddd*Pk2*b1*f**2*r*s + 832*D1*Ddd*Pk2*b1*f**2*r - 2496*D1*Ddd*Pk2*b1*f**2*s**2 + 2912*D1*Ddd*Pk2*b1*f**2*s - 624*D1*Ddd*Pk2*b1*f**2 + 3744*D1*Ddd*Pk2*f**3*r*s - 936*D1*Ddd*Pk2*f**3*r + 2704*D1*Ddd*Pk2*f**3*s**2 - 3224*D1*Ddd*Pk2*f**3*s + 676*D1*Ddd*Pk2*f**3 + 36*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 18*D1*Ddd*Pkdd2*f**3*k1**2*s + 9*D1*Ddd*Pkdd2*f**3*k1**2 + 208*D1*Pk2*bd1*f*(D1*(f*(6*s**2 + s*(8*r - 8) + 1) + fd*(r*(4 - 24*s) - 18*s**2 + 22*s - 3)) - 2*Dd*f*(2*r*(8*s - 1) + 12*s**2 - 15*s + 2)) - 9984*Dd**2*Pk2*b1*f**2*r*s + 2496*Dd**2*Pk2*b1*f**2*r - 7488*Dd**2*Pk2*b1*f**2*s**2 + 8736*Dd**2*Pk2*b1*f**2*s - 1664*Dd**2*Pk2*b1*f**2 + 11232*Dd**2*Pk2*f**3*r*s - 2808*Dd**2*Pk2*f**3*r + 8112*Dd**2*Pk2*f**3*s**2 - 9672*Dd**2*Pk2*f**3*s + 1872*Dd**2*Pk2*f**3 + 108*Dd**2*Pkdd2*f**3*k1**2*s**2 - 54*Dd**2*Pkdd2*f**3*k1**2*s)/(18018*d**2*k3**4) + D1**2*Pk3*f*k1**2*st**4*(-4*C*Pk2*(D1**2*(f*(2*fd - fdd)*(3*r**2 - 36*r*s + 10*r - 57*s**2 + 50*s - 18) + 2*fd**2*(-3*r**2 + 36*r*s - 10*r + 57*s**2 - 50*s + 6)) + D1*f*(2*Dd*(f*(4*r**2 + r*(8 - 48*s) - 76*s**2 + 62*s - 17) + fd*(-12*r**2 + 16*r*(9*s - 2) + 228*s**2 - 193*s + 35)) + Ddd*f*(-4*r**2 + 8*r*(6*s - 1) + 76*s**2 - 62*s + 17)) + 2*Dd**2*f**2*(-6*r**2 + 12*r*(6*s - 1) + 114*s**2 - 93*s + 11)) - 66*D1**2*K*Pk2*bd1*f*s**2 + 132*D1**2*Pk2*bd1*f*r*s + 198*D1**2*Pk2*bd1*f*s**2 - 132*D1**2*Pk2*bd1*f*s + 96*D1**2*Pk2*f*fd*r**2 + 24*D1**2*Pk2*f*fd*r*s - 72*D1**2*Pk2*f*fd*r - 192*D1**2*Pk2*f*fd*s**2 + 120*D1**2*Pk2*f*fd*s - 32*D1**2*Pk2*f*fd - 48*D1**2*Pk2*f*fdd*r**2 - 12*D1**2*Pk2*f*fdd*r*s + 36*D1**2*Pk2*f*fdd*r + 96*D1**2*Pk2*f*fdd*s**2 - 60*D1**2*Pk2*f*fdd*s + 16*D1**2*Pk2*f*fdd + 132*D1**2*Pk2*f*gd2*s**2 - 96*D1**2*Pk2*fd**2*r**2 - 24*D1**2*Pk2*fd**2*r*s + 72*D1**2*Pk2*fd**2*r + 192*D1**2*Pk2*fd**2*s**2 - 120*D1**2*Pk2*fd**2*s - 4*D1**2*Pk2*fd**2 + 264*D1**2*Pk2*fd*g2*s**2 - 264*D1**2*Pk2*fd*g2*s + 132*D1**2*Pk2*fd*g2 - 4*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 + 12*D1**2*Pkdd2*bd1*f**2*k1**2*s - 6*D1**2*Pkdd2*bd1*f**2*k1**2 + 12*D1**2*Pkdd2*bd1*f*fd*k1**2*s**2 - 16*D1**2*Pkdd2*bd1*f*fd*k1**2*s + 2*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 6*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 3*D1**2*Pkdd2*bdd1*f**2*k1**2 + 12*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 6*D1**2*Pkdd2*f**2*fd*k1**2*s + 3*D1**2*Pkdd2*f**2*fd*k1**2 + 128*D1*Dd*Pk2*f**2*r**2 + 32*D1*Dd*Pk2*f**2*r*s - 136*D1*Dd*Pk2*f**2*r - 256*D1*Dd*Pk2*f**2*s**2 + 112*D1*Dd*Pk2*f**2*s - 384*D1*Dd*Pk2*f*fd*r**2 - 96*D1*Dd*Pk2*f*fd*r*s + 348*D1*Dd*Pk2*f*fd*r + 768*D1*Dd*Pk2*f*fd*s**2 - 408*D1*Dd*Pk2*f*fd*s - 12*D1*Dd*Pk2*f*fd + 528*D1*Dd*Pk2*f*g2*s**2 - 264*D1*Dd*Pk2*f*g2*s + 132*D1*Dd*Pk2*f*g2 + 16*D1*Dd*Pkdd2*bd1*f**2*k1**2*s**2 - 28*D1*Dd*Pkdd2*bd1*f**2*k1**2*s + 6*D1*Dd*Pkdd2*bd1*f**2*k1**2 + 12*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 6*D1*Dd*Pkdd2*f**3*k1**2*s + 3*D1*Dd*Pkdd2*f**3*k1**2 - 64*D1*Ddd*Pk2*f**2*r**2 - 16*D1*Ddd*Pk2*f**2*r*s + 68*D1*Ddd*Pk2*f**2*r + 128*D1*Ddd*Pk2*f**2*s**2 - 56*D1*Ddd*Pk2*f**2*s - 192*Dd**2*Pk2*f**2*r**2 - 48*Dd**2*Pk2*f**2*r*s + 204*Dd**2*Pk2*f**2*r + 384*Dd**2*Pk2*f**2*s**2 - 168*Dd**2*Pk2*f**2*s - 40*Dd**2*Pk2*f**2 + b1*(D1**2*(Pkdd2*f*fdd*k1**2*(6*s**2 + 2*s - 1) + 4*Pkdd2*fd**2*k1**2*s*(3*s + 1) - 2*fd*(33*Pk2*(2*K*s**2 - 2*K*s + K - 4*r*s + 2*r - 6*s**2 + 6*s - 3) + Pkdd2*f*k1**2*(6*s**2 + 2*s - 1))) - 2*D1*f*(33*Dd*Pk2*(4*K*s**2 - 2*K*s + K - 8*r*s + 2*r - 12*s**2 + 10*s - 3) + Dd*Pkdd2*k1**2*(f*(8*s**2 - 4*s + 2) - 24*fd*s**2 + 2*fd*s + fd) + Ddd*Pkdd2*f*k1**2*(-4*s**2 + 2*s - 1)) + 12*Dd**2*Pkdd2*f**2*k1**2*s*(2*s - 1)))/(231*d**2*k3**4) + D1**2*Pk3*k1**2*st**2*(-66*D1**2*bd1**2*f*(2*Pk2*(K*(-r**2 + 3*r + 3*s**2 + s - 2) + f*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + 7*r**2 + 14*r*s - 15*r + 5*s**2 - 14*s + 8) + Pkdd2*f*k1**2*s*(s - 1)) - 33*D1*bd1*(D1*(2*Pk2*f**2*(2*C*(2*r**2 + 4*r*(s - 2) - 3*s**2 - 2*s + 1) + 2*K*r**2 + 32*K*r*s - 4*K*r + 31*K*s**2 - 32*K*s + 2*K - 3*fd*(24*r**2 - 26*r - 24*s**2 + 18*s + 5) - 13*r**2 - 35*r*s + 32*r - 12*s**2 + 27*s - 9) - 2*Pk2*f*(fd*(4*C*(2*r**2 - 3*r - 6*s**2 + 2*s + 2) + 2*K*(10*r**2 + 64*r*s - 26*r + 58*s**2 - 61*s + 16) - 32*r**2 - 76*r*s + 55*r - 32*s**2 + 56*s - 25) + 2*g2*(2*r**2 - 4*r*(7*s + 2) - 27*s**2 - 18*s + 9) + 4*gd2*(-r**2 + 3*r + 3*s**2 + s - 2)) + 8*Pk2*fd*g2*(r**2 - s*(3*s - 3)) + f**3*(6*Pk2*(4*r**2 - 5*r + s*(5 - 4*s)) + Pkdd2*k1**2*(-2*s**2 + 6*s - 3))) - 2*Dd*Pk2*f*(3*f**2*(32*r**2 - 36*r - 32*s**2 + 28*s + 5) + f*(4*C*(4*r**2 - 10*r - 12*s**2 - s + 5) + K*(40*r**2 + 256*r*s - 92*r + 232*s**2 - 250*s + 52) - 64*r**2 - 152*r*s + 131*r - 64*s**2 + 138*s - 61) + 4*g2*(-4*r**2 + 10*r + 12*s**2 + s - 5))) - 2*Pk2*(780*C*D1**2*f**2*fd*r**2 + 7104*C*D1**2*f**2*fd*r*s - 2888*C*D1**2*f**2*fd*r + 6138*C*D1**2*f**2*fd*s**2 - 6460*C*D1**2*f**2*fd*s + 2306*C*D1**2*f**2*fd - 1182*C*D1**2*f**2*fdd*r**2 - 6720*C*D1**2*f**2*fdd*r*s + 3028*C*D1**2*f**2*fdd*r - 5742*C*D1**2*f**2*fdd*s**2 + 6068*C*D1**2*f**2*fdd*s - 2308*C*D1**2*f**2*fdd - 2364*C*D1**2*f*fd**2*r**2 - 13440*C*D1**2*f*fd**2*r*s + 6056*C*D1**2*f*fd**2*r - 11484*C*D1**2*f*fd**2*s**2 + 12136*C*D1**2*f*fd**2*s - 2240*C*D1**2*f*fd**2 + 1040*C*D1*Dd*f**3*r**2 + 9472*C*D1*Dd*f**3*r*s - 3408*C*D1*Dd*f**3*r + 8184*C*D1*Dd*f**3*s**2 - 8828*C*D1*Dd*f**3*s + 2566*C*D1*Dd*f**3 - 9456*C*D1*Dd*f**2*fd*r**2 - 53760*C*D1*Dd*f**2*fd*r*s + 23560*C*D1*Dd*f**2*fd*r - 45936*C*D1*Dd*f**2*fd*s**2 + 49196*C*D1*Dd*f**2*fd*s - 12124*C*D1*Dd*f**2*fd - 1576*C*D1*Ddd*f**3*r**2 - 8960*C*D1*Ddd*f**3*r*s + 3816*C*D1*Ddd*f**3*r - 7656*C*D1*Ddd*f**3*s**2 + 8308*C*D1*Ddd*f**3*s - 2702*C*D1*Ddd*f**3 - 4728*C*Dd**2*f**3*r**2 - 26880*C*Dd**2*f**3*r*s + 11448*C*Dd**2*f**3*r - 22968*C*Dd**2*f**3*s**2 + 24924*C*Dd**2*f**3*s - 5268*C*Dd**2*f**3 + 198*D1**2*b2*f*fd*r**2 + 1452*D1**2*b2*f*fd*r*s - 726*D1**2*b2*f*fd*r + 1254*D1**2*b2*f*fd*s**2 - 1254*D1**2*b2*f*fd*s + 627*D1**2*b2*f*fd - 330*D1**2*b2*f*fdd*r**2 - 1452*D1**2*b2*f*fdd*r*s + 726*D1**2*b2*f*fdd*r - 1122*D1**2*b2*f*fdd*s**2 + 1122*D1**2*b2*f*fdd*s - 561*D1**2*b2*f*fdd - 330*D1**2*b2*fd**2*r**2 - 1452*D1**2*b2*fd**2*r*s + 726*D1**2*b2*fd**2*r - 1122*D1**2*b2*fd**2*s**2 + 1122*D1**2*b2*fd**2*s - 33*D1**2*bdd1*f*(3*f**2*(4*r**2 - 5*r + s*(5 - 4*s)) + f*(2*C*(r**2 - 4*r - 3*s**2 - 2*s + 1) + K*(5*r**2 + 32*r*s - 10*r + 29*s**2 - 32*s + 5) - 8*r**2 - 19*r*s + 20*r - 8*s**2 + 21*s - 8) - 2*g2*(r**2 - 4*r - 3*s**2 - 2*s + 1)) - 165*D1**2*bdd2*f**2*r**2 - 726*D1**2*bdd2*f**2*r*s + 330*D1**2*bdd2*f**2*r - 561*D1**2*bdd2*f**2*s**2 + 726*D1**2*bdd2*f**2*s - 165*D1**2*bdd2*f**2 - 93*D1**2*f**2*fd*r**2 - 3945*D1**2*f**2*fd*r*s + 1377*D1**2*f**2*fd*r - 3663*D1**2*f**2*fd*s**2 + 3757*D1**2*f**2*fd*s - 1252*D1**2*f**2*fd + 591*D1**2*f**2*fdd*r**2 + 3903*D1**2*f**2*fdd*r*s - 1695*D1**2*f**2*fdd*r + 3465*D1**2*f**2*fdd*s**2 - 3611*D1**2*f**2*fdd*s + 1352*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r**2 - 2112*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*r - 2046*D1**2*f**2*gd2*s**2 + 2112*D1**2*f**2*gd2*s - 132*D1**2*f**2*gd2 + 330*D1**2*f**2*gdd2*r**2 + 2112*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*r + 1914*D1**2*f**2*gdd2*s**2 - 2112*D1**2*f**2*gdd2*s + 330*D1**2*f**2*gdd2 + 1182*D1**2*f*fd**2*r**2 + 7806*D1**2*f*fd**2*r*s - 3390*D1**2*f*fd**2*r + 6930*D1**2*f*fd**2*s**2 - 7222*D1**2*f*fd**2*s + 1301*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r**2 - 4224*D1**2*f*fd*g2*r*s + 2112*D1**2*f*fd*g2*r - 4092*D1**2*f*fd*g2*s**2 + 4092*D1**2*f*fd*g2*s - 2046*D1**2*f*fd*g2 + 1320*D1**2*f*fd*gd2*r**2 + 8448*D1**2*f*fd*gd2*r*s - 3432*D1**2*f*fd*gd2*r + 7656*D1**2*f*fd*gd2*s**2 - 8052*D1**2*f*fd*gd2*s + 2112*D1**2*f*fd*gd2 + 660*D1**2*f*fdd*g2*r**2 + 4224*D1**2*f*fdd*g2*r*s - 2112*D1**2*f*fdd*g2*r + 3828*D1**2*f*fdd*g2*s**2 - 3828*D1**2*f*fdd*g2*s + 1914*D1**2*f*fdd*g2 + 660*D1**2*fd**2*g2*r**2 + 4224*D1**2*fd**2*g2*r*s - 2112*D1**2*fd**2*g2*r + 3828*D1**2*fd**2*g2*s**2 - 3828*D1**2*fd**2*g2*s + 396*D1*Dd*b2*f**2*r**2 + 2904*D1*Dd*b2*f**2*r*s - 1122*D1*Dd*b2*f**2*r + 2508*D1*Dd*b2*f**2*s**2 - 2706*D1*Dd*b2*f**2*s + 825*D1*Dd*b2*f**2 - 2640*D1*Dd*b2*f*fd*r**2 - 11616*D1*Dd*b2*f*fd*r*s + 5676*D1*Dd*b2*f*fd*r - 8976*D1*Dd*b2*f*fd*s**2 + 9636*D1*Dd*b2*f*fd*s - 2574*D1*Dd*b2*f*fd - 124*D1*Dd*f**3*r**2 - 5260*D1*Dd*f**3*r*s + 1439*D1*Dd*f**3*r - 4884*D1*Dd*f**3*s**2 + 5072*D1*Dd*f**3*s - 1283*D1*Dd*f**3 + 4728*D1*Dd*f**2*fd*r**2 + 31224*D1*Dd*f**2*fd*r*s - 13047*D1*Dd*f**2*fd*r + 27720*D1*Dd*f**2*fd*s**2 - 29180*D1*Dd*f**2*fd*s + 7001*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r**2 - 8448*D1*Dd*f**2*g2*r*s + 2640*D1*Dd*f**2*g2*r - 8184*D1*Dd*f**2*g2*s**2 + 8316*D1*Dd*f**2*g2*s - 2310*D1*Dd*f**2*g2 + 2640*D1*Dd*f**2*gd2*r**2 + 16896*D1*Dd*f**2*gd2*r*s - 6072*D1*Dd*f**2*gd2*r + 15312*D1*Dd*f**2*gd2*s**2 - 16500*D1*Dd*f**2*gd2*s + 3432*D1*Dd*f**2*gd2 + 5280*D1*Dd*f*fd*g2*r**2 + 33792*D1*Dd*f*fd*g2*r*s - 15312*D1*Dd*f*fd*g2*r + 30624*D1*Dd*f*fd*g2*s**2 - 31416*D1*Dd*f*fd*g2*s + 8052*D1*Dd*f*fd*g2 - 660*D1*Ddd*b2*f**2*r**2 - 2904*D1*Ddd*b2*f**2*r*s + 1386*D1*Ddd*b2*f**2*r - 2244*D1*Ddd*b2*f**2*s**2 + 2574*D1*Ddd*b2*f**2*s - 891*D1*Ddd*b2*f**2 + 788*D1*Ddd*f**3*r**2 + 5204*D1*Ddd*f**3*r*s - 2089*D1*Ddd*f**3*r + 4620*D1*Ddd*f**3*s**2 - 4912*D1*Ddd*f**3*s + 1549*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*g2*r**2 + 8448*D1*Ddd*f**2*g2*r*s - 3432*D1*Ddd*f**2*g2*r + 7656*D1*Ddd*f**2*g2*s**2 - 8052*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 33*D1*bd2*f*(D1*(f*(3*r**2 + 22*r*s - 6*r + 19*s**2 - 22*s + 3) - 2*fd*(10*r**2 + 44*r*s - 21*r + 34*s**2 - 39*s + 11)) - 2*Dd*f*(20*r**2 + r*(88*s - 41) + 68*s**2 - 83*s + 21)) - 1980*Dd**2*b2*f**2*r**2 - 8712*Dd**2*b2*f**2*r*s + 4158*Dd**2*b2*f**2*r - 6732*Dd**2*b2*f**2*s**2 + 7722*Dd**2*b2*f**2*s - 1782*Dd**2*b2*f**2 + 2364*Dd**2*f**3*r**2 + 15612*Dd**2*f**3*r*s - 6267*Dd**2*f**3*r + 13860*Dd**2*f**3*s**2 - 14736*Dd**2*f**3*s + 2996*Dd**2*f**3 + 3960*Dd**2*f**2*g2*r**2 + 25344*Dd**2*f**2*g2*r*s - 10296*Dd**2*f**2*g2*r + 22968*Dd**2*f**2*g2*s**2 - 24156*Dd**2*f**2*g2*s + 4884*Dd**2*f**2*g2) + 33*b1**2*(-2*D1**2*(fd**2*(Pk2*(44*r**2 + r*(64*s - 50) + 20*s**2 - 26*s + 6) + Pkdd2*k1**2*s**2) - fd*(Pk2*(K*(-2*r**2 + 4*r*(7*s - 9) + 27*s**2 - 72*s + 36) + 2*f*(18*r**2 + r*(32*s - 19) + 14*s**2 - 11*s + 7) + 14*r**2 + 28*r*s + 18*r + 17*s**2 + 36*s - 18) + 2*Pkdd2*f*k1**2*s**2) + fdd*(Pk2*(-K*(r**2 + 4*r - 3*s**2 + 8*s - 4) + f*(44*r**2 + r*(64*s - 50) + 20*s**2 - 26*s + 22) + 7*r**2 + 14*r*s + 2*r + 5*s**2 + 4*s - 2) + Pkdd2*f*k1**2*s**2)) + D1*(2*Dd*(2*Pk2*fd*(K*(4*r**2 + 6*r - 12*s**2 + 19*s - 8) - 28*r**2 + r*(17 - 56*s) - 20*s**2 + 11*s + 4) + f**2*(2*Pk2*(36*r**2 + r*(64*s - 52) + 28*s**2 - 46*s + 25) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(Pk2*(K*(-8*r**2 + 4*r*(28*s - 5) + 108*s**2 - 110*s + 23) - 2*fd*(176*r**2 + 4*r*(64*s - 55) + 80*s**2 - 136*s + 63) + 56*r**2 + 112*r*s - 84*r + 68*s**2 - 90*s + 45) + 2*Pkdd2*fd*k1**2*s*(1 - 4*s))) - Ddd*f*(2*Pk2*(K*(-4*r**2 + 4*r + 12*s**2 - 6*s + 1) + 2*f*(44*r**2 + r*(64*s - 60) + 20*s**2 - 42*s + 27) + 28*r**2 + 56*r*s - 42*r + 20*s**2 - 38*s + 19) + Pkdd2*f*k1**2*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(2*Pk2*(K*(-6*r**2 + 6*r + 18*s**2 - 9*s - 1) + 6*f*(22*r**2 + r*(32*s - 30) + 10*s**2 - 21*s + 9) + 42*r**2 + 84*r*s - 63*r + 30*s**2 - 57*s + 21) + 3*Pkdd2*f*k1**2*s*(2*s - 1))) + 33*b1*(-16*C*D1**2*Pk2*f*fd*r**2 - 32*C*D1**2*Pk2*f*fd*r*s + 24*C*D1**2*Pk2*f*fd*s**2 - 16*C*D1**2*Pk2*f*fd*s + 8*C*D1**2*Pk2*f*fd + 8*C*D1**2*Pk2*f*fdd*r**2 + 8*C*D1**2*Pk2*f*fdd*r - 24*C*D1**2*Pk2*f*fdd*s**2 + 32*C*D1**2*Pk2*f*fdd*s - 12*C*D1**2*Pk2*f*fdd + 8*C*D1**2*Pk2*fd**2*r**2 + 8*C*D1**2*Pk2*fd**2*r - 24*C*D1**2*Pk2*fd**2*s**2 + 32*C*D1**2*Pk2*fd**2*s - 16*C*D1**2*Pk2*fd**2 - 32*C*D1*Dd*Pk2*f**2*r**2 - 64*C*D1*Dd*Pk2*f**2*r*s + 48*C*D1*Dd*Pk2*f**2*r + 48*C*D1*Dd*Pk2*f**2*s**2 + 8*C*D1*Dd*Pk2*f**2*s - 4*C*D1*Dd*Pk2*f**2 + 64*C*D1*Dd*Pk2*f*fd*r**2 - 192*C*D1*Dd*Pk2*f*fd*s**2 + 176*C*D1*Dd*Pk2*f*fd*s - 48*C*D1*Dd*Pk2*f*fd + 16*C*D1*Ddd*Pk2*f**2*r**2 - 16*C*D1*Ddd*Pk2*f**2*r - 48*C*D1*Ddd*Pk2*f**2*s**2 + 24*C*D1*Ddd*Pk2*f**2*s - 4*C*D1*Ddd*Pk2*f**2 + 48*C*Dd**2*Pk2*f**2*r**2 - 48*C*Dd**2*Pk2*f**2*r - 144*C*Dd**2*Pk2*f**2*s**2 + 72*C*Dd**2*Pk2*f**2*s + 8*C*Dd**2*Pk2*f**2 - 8*D1**2*K*Pk2*f*fd*r**2 - 128*D1**2*K*Pk2*f*fd*r*s + 64*D1**2*K*Pk2*f*fd*r - 124*D1**2*K*Pk2*f*fd*s**2 + 124*D1**2*K*Pk2*f*fd*s - 62*D1**2*K*Pk2*f*fd + 20*D1**2*K*Pk2*f*fdd*r**2 + 128*D1**2*K*Pk2*f*fdd*r*s - 64*D1**2*K*Pk2*f*fdd*r + 116*D1**2*K*Pk2*f*fdd*s**2 - 116*D1**2*K*Pk2*f*fdd*s + 58*D1**2*K*Pk2*f*fdd + 20*D1**2*K*Pk2*fd**2*r**2 + 128*D1**2*K*Pk2*fd**2*r*s - 64*D1**2*K*Pk2*fd**2*r + 116*D1**2*K*Pk2*fd**2*s**2 - 116*D1**2*K*Pk2*fd**2*s - 72*D1**2*Pk2*f**2*fd*r**2 + 66*D1**2*Pk2*f**2*fd*r + 72*D1**2*Pk2*f**2*fd*s**2 - 18*D1**2*Pk2*f**2*fd*s - 24*D1**2*Pk2*f**2*fd + 72*D1**2*Pk2*f**2*fdd*r**2 - 66*D1**2*Pk2*f**2*fdd*r - 72*D1**2*Pk2*f**2*fdd*s**2 + 18*D1**2*Pk2*f**2*fdd*s + 24*D1**2*Pk2*f**2*fdd + 144*D1**2*Pk2*f*fd**2*r**2 - 132*D1**2*Pk2*f*fd**2*r - 144*D1**2*Pk2*f*fd**2*s**2 + 36*D1**2*Pk2*f*fd**2*s + 18*D1**2*Pk2*f*fd**2 + 52*D1**2*Pk2*f*fd*r**2 + 140*D1**2*Pk2*f*fd*r*s - 58*D1**2*Pk2*f*fd*r + 48*D1**2*Pk2*f*fd*s**2 - 64*D1**2*Pk2*f*fd*s + 32*D1**2*Pk2*f*fd - 32*D1**2*Pk2*f*fdd*r**2 - 76*D1**2*Pk2*f*fdd*r*s + 30*D1**2*Pk2*f*fdd*r - 32*D1**2*Pk2*f*fdd*s**2 + 28*D1**2*Pk2*f*fdd*s - 16*D1**2*Pk2*f*fdd + 8*D1**2*Pk2*f*gd2*r**2 - 112*D1**2*Pk2*f*gd2*r*s - 16*D1**2*Pk2*f*gd2*r - 108*D1**2*Pk2*f*gd2*s**2 + 112*D1**2*Pk2*f*gd2*s + 8*D1**2*Pk2*f*gd2 - 4*D1**2*Pk2*f*gdd2*r**2 + 8*D1**2*Pk2*f*gdd2*r + 12*D1**2*Pk2*f*gdd2*s**2 - 4*D1**2*Pk2*f*gdd2 - 32*D1**2*Pk2*fd**2*r**2 - 76*D1**2*Pk2*fd**2*r*s + 30*D1**2*Pk2*fd**2*r - 32*D1**2*Pk2*fd**2*s**2 + 28*D1**2*Pk2*fd**2*s + 12*D1**2*Pk2*fd**2 + 8*D1**2*Pk2*fd*g2*r**2 - 112*D1**2*Pk2*fd*g2*r*s + 144*D1**2*Pk2*fd*g2*r - 108*D1**2*Pk2*fd*g2*s**2 + 288*D1**2*Pk2*fd*g2*s - 144*D1**2*Pk2*fd*g2 - 8*D1**2*Pk2*fd*gd2*r**2 - 8*D1**2*Pk2*fd*gd2*r + 24*D1**2*Pk2*fd*gd2*s**2 - 32*D1**2*Pk2*fd*gd2*s + 16*D1**2*Pk2*fd*gd2 - 4*D1**2*Pk2*fdd*g2*r**2 - 16*D1**2*Pk2*fdd*g2*r + 12*D1**2*Pk2*fdd*g2*s**2 - 32*D1**2*Pk2*fdd*g2*s + 16*D1**2*Pk2*fdd*g2 + 6*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 2*D1**2*Pkdd2*f**2*fd*k1**2*s - D1**2*Pkdd2*f**2*fd*k1**2 - D1**2*bdd1*f*(4*Pk2*(K*(-r**2 + 3*r + 3*s**2 + s - 1) + f*(22*r**2 + r*(32*s - 35) + 10*s**2 - 29*s + 16) + 7*r**2 + 14*r*s - 15*r + 5*s**2 - 14*s + 7) + Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) - 16*D1*Dd*K*Pk2*f**2*r**2 - 256*D1*Dd*K*Pk2*f**2*r*s + 80*D1*Dd*K*Pk2*f**2*r - 248*D1*Dd*K*Pk2*f**2*s**2 + 252*D1*Dd*K*Pk2*f**2*s - 70*D1*Dd*K*Pk2*f**2 + 160*D1*Dd*K*Pk2*f*fd*r**2 + 1024*D1*Dd*K*Pk2*f*fd*r*s - 464*D1*Dd*K*Pk2*f*fd*r + 928*D1*Dd*K*Pk2*f*fd*s**2 - 952*D1*Dd*K*Pk2*f*fd*s + 244*D1*Dd*K*Pk2*f*fd - 96*D1*Dd*Pk2*f**3*r**2 + 96*D1*Dd*Pk2*f**3*r + 96*D1*Dd*Pk2*f**3*s**2 - 48*D1*Dd*Pk2*f**3*s - 24*D1*Dd*Pk2*f**3 + 576*D1*Dd*Pk2*f**2*fd*r**2 - 552*D1*Dd*Pk2*f**2*fd*r - 576*D1*Dd*Pk2*f**2*fd*s**2 + 216*D1*Dd*Pk2*f**2*fd*s + 114*D1*Dd*Pk2*f**2*fd + 104*D1*Dd*Pk2*f**2*r**2 + 280*D1*Dd*Pk2*f**2*r*s - 174*D1*Dd*Pk2*f**2*r + 96*D1*Dd*Pk2*f**2*s**2 - 188*D1*Dd*Pk2*f**2*s + 76*D1*Dd*Pk2*f**2 - 256*D1*Dd*Pk2*f*fd*r**2 - 608*D1*Dd*Pk2*f*fd*r*s + 324*D1*Dd*Pk2*f*fd*r - 256*D1*Dd*Pk2*f*fd*s**2 + 328*D1*Dd*Pk2*f*fd*s - 88*D1*Dd*Pk2*f*fd + 32*D1*Dd*Pk2*f*g2*r**2 - 448*D1*Dd*Pk2*f*g2*r*s + 80*D1*Dd*Pk2*f*g2*r - 432*D1*Dd*Pk2*f*g2*s**2 + 440*D1*Dd*Pk2*f*g2*s - 92*D1*Dd*Pk2*f*g2 - 32*D1*Dd*Pk2*f*gd2*r**2 + 48*D1*Dd*Pk2*f*gd2*r + 96*D1*Dd*Pk2*f*gd2*s**2 - 24*D1*Dd*Pk2*f*gd2*s - 16*D1*Dd*Pk2*f*gd2 - 32*D1*Dd*Pk2*fd*g2*r**2 - 48*D1*Dd*Pk2*fd*g2*r + 96*D1*Dd*Pk2*fd*g2*s**2 - 152*D1*Dd*Pk2*fd*g2*s + 64*D1*Dd*Pk2*fd*g2 + 8*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**3*k1**2*s + 2*D1*Dd*Pkdd2*f**3*k1**2 + 40*D1*Ddd*K*Pk2*f**2*r**2 + 256*D1*Ddd*K*Pk2*f**2*r*s - 104*D1*Ddd*K*Pk2*f**2*r + 232*D1*Ddd*K*Pk2*f**2*s**2 - 244*D1*Ddd*K*Pk2*f**2*s + 78*D1*Ddd*K*Pk2*f**2 + 96*D1*Ddd*Pk2*f**3*r**2 - 96*D1*Ddd*Pk2*f**3*r - 96*D1*Ddd*Pk2*f**3*s**2 + 48*D1*Ddd*Pk2*f**3*s + 24*D1*Ddd*Pk2*f**3 - 64*D1*Ddd*Pk2*f**2*r**2 - 152*D1*Ddd*Pk2*f**2*r*s + 102*D1*Ddd*Pk2*f**2*r - 64*D1*Ddd*Pk2*f**2*s**2 + 108*D1*Ddd*Pk2*f**2*s - 48*D1*Ddd*Pk2*f**2 - 16*D1*Ddd*Pk2*f*g2*r**2 + 16*D1*Ddd*Pk2*f*g2*r + 48*D1*Ddd*Pk2*f*g2*s**2 - 24*D1*Ddd*Pk2*f*g2*s + 4*D1*Ddd*Pk2*f*g2 + 2*D1*bd1*(D1*(2*Pk2*fd*(K*(2*r**2 + r - 6*s**2 + 7*s - 2) - 14*r**2 + r*(13 - 28*s) - 10*s**2 + 10*s + 1) + f**2*(Pk2*(36*r**2 + r*(64*s - 66) + 28*s**2 - 70*s + 36) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) + f*(Pk2*(K*(-4*r**2 + 56*r*s + 12*r + 54*s**2 - 10*s - 11) - 2*fd*(88*r**2 + 8*r*(16*s - 15) + 40*s**2 - 84*s + 35) + 28*r**2 + 56*r*s - 74*r + 34*s**2 - 98*s + 49) + 2*Pkdd2*fd*k1**2*s*(1 - 2*s))) - Dd*f*(2*Pk2*(K*(-8*r**2 + 16*r + 24*s**2 - 2*s - 7) + f*(176*r**2 + 4*r*(64*s - 65) + 80*s**2 - 200*s + 99) + 56*r**2 + 2*r*(56*s - 51) + 40*s**2 - 94*s + 44) + Pkdd2*f*k1**2*(8*s**2 - 6*s + 1))) + 120*Dd**2*K*Pk2*f**2*r**2 + 768*Dd**2*K*Pk2*f**2*r*s - 312*Dd**2*K*Pk2*f**2*r + 696*Dd**2*K*Pk2*f**2*s**2 - 732*Dd**2*K*Pk2*f**2*s + 148*Dd**2*K*Pk2*f**2 + 288*Dd**2*Pk2*f**3*r**2 - 288*Dd**2*Pk2*f**3*r - 288*Dd**2*Pk2*f**3*s**2 + 144*Dd**2*Pk2*f**3*s + 48*Dd**2*Pk2*f**3 - 192*Dd**2*Pk2*f**2*r**2 - 456*Dd**2*Pk2*f**2*r*s + 306*Dd**2*Pk2*f**2*r - 192*Dd**2*Pk2*f**2*s**2 + 324*Dd**2*Pk2*f**2*s - 108*Dd**2*Pk2*f**2 - 48*Dd**2*Pk2*f*g2*r**2 + 48*Dd**2*Pk2*f*g2*r + 144*Dd**2*Pk2*f*g2*s**2 - 72*Dd**2*Pk2*f*g2*s - 8*Dd**2*Pk2*f*g2))/(1386*d**2*k3**4) - 2*D1**2*Pk3*k1**2*(7*Pk2*b1**3*(D1**2*(fd*(3*r + s - 3) + fdd*(-5*r - 3*s + 5))*(r + s - 1) + D1*(Dd*(f*(12*r**2 + 16*r*(s - 1) + 4*s**2 - 10*s + 7) - 2*fd*(20*r**2 + r*(32*s - 34) + 12*s**2 - 27*s + 14) - 2*(4*K - 2)*(r*(4*s - 1) + (1 - 2*s)**2)) - Ddd*f*(20*r**2 + 4*r*(8*s - 7) + 12*s**2 - 22*s + 13) + 2*Ddd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd**2*(f*(30*r**2 + 6*r*(8*s - 7) + 18*s**2 - 33*s + 13) - (2*K - 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))) + Pk2*(-68*C*D1**2*bdd1*f**2*r**2 - 208*C*D1**2*bdd1*f**2*r*s + 208*C*D1**2*bdd1*f**2*r - 120*C*D1**2*bdd1*f**2*s**2 + 240*C*D1**2*bdd1*f**2*s - 120*C*D1**2*bdd1*f**2 + 36*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 12*C*D1**2*f**2*fd - 36*C*D1**2*f**2*fdd*s**2 + 24*C*D1**2*f**2*fdd*s - 12*C*D1**2*f**2*fdd - 72*C*D1**2*f*fd**2*s**2 + 48*C*D1**2*f*fd**2*s + 48*C*D1*Dd*f**3*s**2 - 24*C*D1*Dd*f**3*s + 12*C*D1*Dd*f**3 - 288*C*D1*Dd*f**2*fd*s**2 + 168*C*D1*Dd*f**2*fd*s - 24*C*D1*Dd*f**2*fd - 48*C*D1*Ddd*f**3*s**2 + 24*C*D1*Ddd*f**3*s - 12*C*D1*Ddd*f**3 - 144*C*Dd**2*f**3*s**2 + 72*C*Dd**2*f**3*s - 7*D1**2*K*bdd1*f**2*s**2 + D1**2*bd1**2*(21*f**2*(4*r**2 + r*(6*s - 7) + 2*s**2 - 5*s + 3) + f*(-14*K*(5*r**2 + 16*r*s - 13*r + 10*s**2 - 18*s + 8) + r*(48*C - 15)*(2*s - 1) + (s - 1)*(96*C*s - 44*s - 21)) - 56*g2*(r*(2*s - 1) + s*(2*s - 2))) + 34*D1**2*bdd1*f**2*r**2 + 124*D1**2*bdd1*f**2*r*s - 124*D1**2*bdd1*f**2*r + 72*D1**2*bdd1*f**2*s**2 - 144*D1**2*bdd1*f**2*s + 72*D1**2*bdd1*f**2 + 70*D1**2*bdd1*f*g2*r**2 + 224*D1**2*bdd1*f*g2*r*s - 224*D1**2*bdd1*f*g2*r + 140*D1**2*bdd1*f*g2*s**2 - 280*D1**2*bdd1*f*g2*s + 140*D1**2*bdd1*f*g2 - 18*D1**2*f**2*fd*s**2 + 12*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 18*D1**2*f**2*fdd*s**2 - 12*D1**2*f**2*fdd*s + 6*D1**2*f**2*fdd - 14*D1**2*f**2*gd2*s**2 + 14*D1**2*f**2*gdd2*s**2 + 36*D1**2*f*fd**2*s**2 - 24*D1**2*f*fd**2*s - 28*D1**2*f*fd*g2*s**2 + 28*D1**2*f*fd*g2*s - 14*D1**2*f*fd*g2 + 56*D1**2*f*fd*gd2*s**2 - 28*D1**2*f*fd*gd2*s + 28*D1**2*f*fdd*g2*s**2 - 28*D1**2*f*fdd*g2*s + 14*D1**2*f*fdd*g2 + 28*D1**2*fd**2*g2*s**2 - 28*D1**2*fd**2*g2*s - 24*D1*Dd*f**3*s**2 + 12*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 144*D1*Dd*f**2*fd*s**2 - 84*D1*Dd*f**2*fd*s + 12*D1*Dd*f**2*fd - 56*D1*Dd*f**2*g2*s**2 + 28*D1*Dd*f**2*g2*s - 14*D1*Dd*f**2*g2 + 112*D1*Dd*f**2*gd2*s**2 - 28*D1*Dd*f**2*gd2*s + 224*D1*Dd*f*fd*g2*s**2 - 168*D1*Dd*f*fd*g2*s + 28*D1*Dd*f*fd*g2 + 24*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 6*D1*Ddd*f**3 + 56*D1*Ddd*f**2*g2*s**2 - 28*D1*Ddd*f**2*g2*s + 14*D1*Ddd*f**2*g2 + 7*D1*b2*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) + D1*bd1*(-70*D1*bd2*f*(r + s - 1)**2 + D1*(f**2*(8*C*(5*r**2 + 16*r*(s - 1) + 9*(s - 1)**2) + 7*K*s**2 - 2*r**2 - 62*r*(s - 1) - 48*s**2 + 96*s - 48) - 2*f*(fd*(4*C*(34*r**2 + 104*r*s - 69*r + 60*s**2 - 86*s + 26) + 14*K*s**2 - 7*K*s - 68*r**2 - 248*r*s + 158*r - 144*s**2 + 206*s - 62) + 14*g2*(r**2 + 4*r*(s - 1) + 3*(s - 1)**2) - 14*gd2*(5*r**2 + 16*r*s - 13*r + 10*s**2 - 18*s + 8)) + 28*fd*g2*(5*r**2 + 8*r*(2*s - 1) + s*(10*s - 10))) - 2*Dd*f*(f*(8*C*(34*r**2 + 104*r*s - 82*r + 60*s**2 - 101*s + 41) + 28*K*s**2 - 7*K*s - 136*r**2 - 496*r*s + 378*r - 288*s**2 + 484*s - 196) - 28*g2*(10*r**2 + r*(32*s - 25) + 20*s**2 - 33*s + 13))) + 72*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 168*Dd**2*f**2*g2*s**2 - 84*Dd**2*f**2*g2*s) + b1**2*(-40*C*D1**2*Pk2*fd*r*s - 40*C*D1**2*Pk2*fd*s**2 + 40*C*D1**2*Pk2*fd*s + 48*C*D1**2*Pk2*fdd*r*s + 48*C*D1**2*Pk2*fdd*s**2 - 48*C*D1**2*Pk2*fdd*s - 160*C*D1*Dd*Pk2*f*r*s + 40*C*D1*Dd*Pk2*f*r - 160*C*D1*Dd*Pk2*f*s**2 + 160*C*D1*Dd*Pk2*f*s - 40*C*D1*Dd*Pk2*f + 384*C*D1*Dd*Pk2*fd*r*s - 48*C*D1*Dd*Pk2*fd*r + 384*C*D1*Dd*Pk2*fd*s**2 - 384*C*D1*Dd*Pk2*fd*s + 48*C*D1*Dd*Pk2*fd + 192*C*D1*Ddd*Pk2*f*r*s - 48*C*D1*Ddd*Pk2*f*r + 192*C*D1*Ddd*Pk2*f*s**2 - 192*C*D1*Ddd*Pk2*f*s + 48*C*D1*Ddd*Pk2*f + 576*C*Dd**2*Pk2*f*r*s - 144*C*Dd**2*Pk2*f*r + 576*C*Dd**2*Pk2*f*s**2 - 576*C*Dd**2*Pk2*f*s + 96*C*Dd**2*Pk2*f + 14*D1**2*K*Pk2*fd*r**2 + 56*D1**2*K*Pk2*fd*r*s + 42*D1**2*K*Pk2*fd*s**2 - 35*D1**2*K*Pk2*fdd*r**2 - 112*D1**2*K*Pk2*fdd*r*s - 70*D1**2*K*Pk2*fdd*s**2 - 7*D1**2*Pk2*bdd1*(f*(15*r**2 + 6*r*(4*s - 3) + 9*s**2 - 14*s + 8) + (2 - 4*K)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - 84*D1**2*Pk2*f*fd*r**2 - 126*D1**2*Pk2*f*fd*r*s + 84*D1**2*Pk2*f*fd*r - 42*D1**2*Pk2*f*fd*s**2 + 63*D1**2*Pk2*f*fd*s - 42*D1**2*Pk2*f*fd + 84*D1**2*Pk2*f*fdd*r**2 + 126*D1**2*Pk2*f*fdd*r*s - 84*D1**2*Pk2*f*fdd*r + 42*D1**2*Pk2*f*fdd*s**2 - 63*D1**2*Pk2*f*fdd*s + 42*D1**2*Pk2*f*fdd + 84*D1**2*Pk2*fd**2*r**2 + 126*D1**2*Pk2*fd**2*r*s - 84*D1**2*Pk2*fd**2*r + 42*D1**2*Pk2*fd**2*s**2 - 63*D1**2*Pk2*fd**2*s + 21*D1**2*Pk2*fd*r**2 + 37*D1**2*Pk2*fd*r*s + 16*D1**2*Pk2*fd*s**2 - 30*D1**2*Pk2*fd*s - 15*D1**2*Pk2*fdd*r*s - 22*D1**2*Pk2*fdd*s**2 + 36*D1**2*Pk2*fdd*s + 112*D1**2*Pk2*gd2*r*s + 112*D1**2*Pk2*gd2*s**2 - 112*D1**2*Pk2*gd2*s - 56*D1**2*Pk2*gdd2*r*s - 56*D1**2*Pk2*gdd2*s**2 + 56*D1**2*Pk2*gdd2*s + 6*D1**2*Pkdd2*f*fd*k1**2*s**2 + 56*D1*Dd*K*Pk2*f*r**2 + 224*D1*Dd*K*Pk2*f*r*s - 112*D1*Dd*K*Pk2*f*r + 168*D1*Dd*K*Pk2*f*s**2 - 196*D1*Dd*K*Pk2*f*s + 70*D1*Dd*K*Pk2*f - 280*D1*Dd*K*Pk2*fd*r**2 - 896*D1*Dd*K*Pk2*fd*r*s + 252*D1*Dd*K*Pk2*fd*r - 560*D1*Dd*K*Pk2*fd*s**2 + 364*D1*Dd*K*Pk2*fd*s - 168*D1*Dd*Pk2*f**2*r**2 - 252*D1*Dd*Pk2*f**2*r*s + 231*D1*Dd*Pk2*f**2*r - 84*D1*Dd*Pk2*f**2*s**2 + 168*D1*Dd*Pk2*f**2*s - 105*D1*Dd*Pk2*f**2 + 672*D1*Dd*Pk2*f*fd*r**2 + 1008*D1*Dd*Pk2*f*fd*r*s - 798*D1*Dd*Pk2*f*fd*r + 336*D1*Dd*Pk2*f*fd*s**2 - 588*D1*Dd*Pk2*f*fd*s + 231*D1*Dd*Pk2*f*fd + 84*D1*Dd*Pk2*f*r**2 + 148*D1*Dd*Pk2*f*r*s - 121*D1*Dd*Pk2*f*r + 64*D1*Dd*Pk2*f*s**2 - 106*D1*Dd*Pk2*f*s + 58*D1*Dd*Pk2*f - 120*D1*Dd*Pk2*fd*r*s + 15*D1*Dd*Pk2*fd*r - 176*D1*Dd*Pk2*fd*s**2 + 218*D1*Dd*Pk2*fd*s - 36*D1*Dd*Pk2*fd + 448*D1*Dd*Pk2*g2*r*s - 112*D1*Dd*Pk2*g2*r + 448*D1*Dd*Pk2*g2*s**2 - 448*D1*Dd*Pk2*g2*s + 112*D1*Dd*Pk2*g2 - 448*D1*Dd*Pk2*gd2*r*s + 56*D1*Dd*Pk2*gd2*r - 448*D1*Dd*Pk2*gd2*s**2 + 448*D1*Dd*Pk2*gd2*s - 56*D1*Dd*Pk2*gd2 + 12*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 6*D1*Dd*Pkdd2*f**2*k1**2*s + 3*D1*Dd*Pkdd2*f**2*k1**2 - 140*D1*Ddd*K*Pk2*f*r**2 - 448*D1*Ddd*K*Pk2*f*r*s + 252*D1*Ddd*K*Pk2*f*r - 280*D1*Ddd*K*Pk2*f*s**2 + 364*D1*Ddd*K*Pk2*f*s - 140*D1*Ddd*K*Pk2*f + 168*D1*Ddd*Pk2*f**2*r**2 + 252*D1*Ddd*Pk2*f**2*r*s - 231*D1*Ddd*Pk2*f**2*r + 84*D1*Ddd*Pk2*f**2*s**2 - 168*D1*Ddd*Pk2*f**2*s + 105*D1*Ddd*Pk2*f**2 - 60*D1*Ddd*Pk2*f*r*s + 15*D1*Ddd*Pk2*f*r - 88*D1*Ddd*Pk2*f*s**2 + 74*D1*Ddd*Pk2*f*s - 22*D1*Ddd*Pk2*f - 224*D1*Ddd*Pk2*g2*r*s + 56*D1*Ddd*Pk2*g2*r - 224*D1*Ddd*Pk2*g2*s**2 + 224*D1*Ddd*Pk2*g2*s - 56*D1*Ddd*Pk2*g2 + 7*D1*Pk2*bd1*(D1*(f*(9*r**2 + 2*r*(6*s - 5) + 3*s**2 - 6*s + 4) - 2*fd*(15*r**2 + 24*r*(s - 1) + 9*s**2 - 19*s + 9) - 2*(4*K - 2)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - 2*Dd*f*(60*r**2 + r*(96*s - 78) + 36*s**2 - 61*s + 25) + 2*Dd*(2*K - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 420*Dd**2*K*Pk2*f*r**2 - 1344*Dd**2*K*Pk2*f*r*s + 756*Dd**2*K*Pk2*f*r - 840*Dd**2*K*Pk2*f*s**2 + 1092*Dd**2*K*Pk2*f*s - 294*Dd**2*K*Pk2*f + 504*Dd**2*Pk2*f**2*r**2 + 756*Dd**2*Pk2*f**2*r*s - 693*Dd**2*Pk2*f**2*r + 252*Dd**2*Pk2*f**2*s**2 - 504*Dd**2*Pk2*f**2*s + 210*Dd**2*Pk2*f**2 - 180*Dd**2*Pk2*f*r*s + 45*Dd**2*Pk2*f*r - 264*Dd**2*Pk2*f*s**2 + 222*Dd**2*Pk2*f*s - 30*Dd**2*Pk2*f - 672*Dd**2*Pk2*g2*r*s + 168*Dd**2*Pk2*g2*r - 672*Dd**2*Pk2*g2*s**2 + 672*Dd**2*Pk2*g2*s - 112*Dd**2*Pk2*g2) - b1*(14*D1**2*Pk2*bd1**2*(f*(15*r**2 + 6*r*(4*s - 3) + 9*s**2 - 14*s + 4) - (2*K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(Pk2*f*(40*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 28*K*r**2 - 112*K*r*s + 84*K*r - 84*K*s**2 + 140*K*s - 56*K - 21*fd*(16*r**2 + 24*r*s - 22*r + 8*s**2 - 16*s + 7) - 42*r**2 - 74*r*s + 79*r - 32*s**2 + 39*s - 37) + Pk2*(fd*(-48*C*(r*(4*s - 1) + (1 - 2*s)**2) + 140*K*r**2 + 280*K*s**2 - 252*K*s + r*(448*K*s - 182*K + 60*s - 15) + 88*s**2 - 95*s + 36) - 56*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 56*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 3*f**2*(7*Pk2*(4*r**2 + r*(6*s - 7) + 2*s**2 - 5*s + 3) + Pkdd2*k1**2*(-2*s**2 + 2*s - 1))) + Dd*Pk2*(-21*f**2*(32*r**2 + r*(48*s - 50) + 16*s**2 - 36*s + 19) + f*(-96*C*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 56*K*(10*r**2 + 32*r*s - 22*r + 20*s**2 - 31*s + 11) + 240*r*s - 90*r + 352*s**2 - 240*s + 53) + 112*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + Pk2*(-80*C*D1**2*f*fd*r**2 - 256*C*D1**2*f*fd*r*s + 80*C*D1**2*f*fd*r - 144*C*D1**2*f*fd*s**2 + 128*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 136*C*D1**2*f*fdd*r**2 + 416*C*D1**2*f*fdd*r*s - 136*C*D1**2*f*fdd*r + 240*C*D1**2*f*fdd*s**2 - 208*C*D1**2*f*fdd*s + 68*C*D1**2*f*fdd + 136*C*D1**2*fd**2*r**2 + 416*C*D1**2*fd**2*r*s - 136*C*D1**2*fd**2*r + 240*C*D1**2*fd**2*s**2 - 208*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r**2 - 512*C*D1*Dd*f**2*r*s + 288*C*D1*Dd*f**2*r - 288*C*D1*Dd*f**2*s**2 + 400*C*D1*Dd*f**2*s - 152*C*D1*Dd*f**2 + 1088*C*D1*Dd*f*fd*r**2 + 3328*C*D1*Dd*f*fd*r*s - 1504*C*D1*Dd*f*fd*r + 1920*C*D1*Dd*f*fd*s**2 - 2144*C*D1*Dd*f*fd*s + 480*C*D1*Dd*f*fd + 272*C*D1*Ddd*f**2*r**2 + 832*C*D1*Ddd*f**2*r*s - 480*C*D1*Ddd*f**2*r + 480*C*D1*Ddd*f**2*s**2 - 656*C*D1*Ddd*f**2*s + 256*C*D1*Ddd*f**2 + 816*C*Dd**2*f**2*r**2 + 2496*C*Dd**2*f**2*r*s - 1440*C*Dd**2*f**2*r + 1440*C*Dd**2*f**2*s**2 - 1968*C*Dd**2*f**2*s + 552*C*Dd**2*f**2 - 14*D1**2*K*f*fd*s**2 + 14*D1**2*K*f*fd*s - 7*D1**2*K*f*fd + 14*D1**2*K*f*fdd*s**2 - 14*D1**2*K*f*fdd*s + 7*D1**2*K*f*fdd + 14*D1**2*K*fd**2*s**2 - 14*D1**2*K*fd**2*s - 21*D1**2*b2*fd*r**2 - 42*D1**2*b2*fd*r*s - 21*D1**2*b2*fd*s**2 + 35*D1**2*b2*fdd*r**2 + 70*D1**2*b2*fdd*r*s + 35*D1**2*b2*fdd*s**2 + D1**2*bdd1*(-21*f**2*(4*r**2 + r*(6*s - 7) + 2*s**2 - 5*s + 3) + f*(-48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 7*K*(10*r**2 + 32*r*s - 26*r + 20*s**2 - 36*s + 15) + 30*r*s - 15*r + 44*s**2 - 23*s + 22) + 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 35*D1**2*bdd2*f*r**2 + 70*D1**2*bdd2*f*r*s - 70*D1**2*bdd2*f*r + 35*D1**2*bdd2*f*s**2 - 70*D1**2*bdd2*f*s + 35*D1**2*bdd2*f + 4*D1**2*f*fd*r**2 + 124*D1**2*f*fd*r*s - 4*D1**2*f*fd*r + 96*D1**2*f*fd*s**2 - 62*D1**2*f*fd*s + 2*D1**2*f*fd - 68*D1**2*f*fdd*r**2 - 248*D1**2*f*fdd*r*s + 68*D1**2*f*fdd*r - 144*D1**2*f*fdd*s**2 + 124*D1**2*f*fdd*s - 34*D1**2*f*fdd + 28*D1**2*f*gd2*r**2 + 112*D1**2*f*gd2*r*s - 56*D1**2*f*gd2*r + 84*D1**2*f*gd2*s**2 - 112*D1**2*f*gd2*s + 28*D1**2*f*gd2 - 70*D1**2*f*gdd2*r**2 - 224*D1**2*f*gdd2*r*s + 140*D1**2*f*gdd2*r - 140*D1**2*f*gdd2*s**2 + 224*D1**2*f*gdd2*s - 70*D1**2*f*gdd2 - 68*D1**2*fd**2*r**2 - 248*D1**2*fd**2*r*s + 68*D1**2*fd**2*r - 144*D1**2*fd**2*s**2 + 124*D1**2*fd**2*s + 28*D1**2*fd*g2*r**2 + 112*D1**2*fd*g2*r*s + 84*D1**2*fd*g2*s**2 - 140*D1**2*fd*gd2*r**2 - 448*D1**2*fd*gd2*r*s + 140*D1**2*fd*gd2*r - 280*D1**2*fd*gd2*s**2 + 224*D1**2*fd*gd2*s - 70*D1**2*fdd*g2*r**2 - 224*D1**2*fdd*g2*r*s - 140*D1**2*fdd*g2*s**2 - 28*D1*Dd*K*f**2*s**2 + 14*D1*Dd*K*f**2*s - 7*D1*Dd*K*f**2 + 112*D1*Dd*K*f*fd*s**2 - 84*D1*Dd*K*f*fd*s + 14*D1*Dd*K*f*fd - 84*D1*Dd*b2*f*r**2 - 168*D1*Dd*b2*f*r*s + 126*D1*Dd*b2*f*r - 84*D1*Dd*b2*f*s**2 + 126*D1*Dd*b2*f*s - 63*D1*Dd*b2*f + 280*D1*Dd*b2*fd*r**2 + 560*D1*Dd*b2*fd*r*s - 210*D1*Dd*b2*fd*r + 280*D1*Dd*b2*fd*s**2 - 210*D1*Dd*b2*fd*s + 8*D1*Dd*f**2*r**2 + 248*D1*Dd*f**2*r*s - 70*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 220*D1*Dd*f**2*s + 52*D1*Dd*f**2 - 544*D1*Dd*f*fd*r**2 - 1984*D1*Dd*f*fd*r*s + 792*D1*Dd*f*fd*r - 1152*D1*Dd*f*fd*s**2 + 1280*D1*Dd*f*fd*s - 260*D1*Dd*f*fd + 112*D1*Dd*f*g2*r**2 + 448*D1*Dd*f*g2*r*s - 224*D1*Dd*f*g2*r + 336*D1*Dd*f*g2*s**2 - 392*D1*Dd*f*g2*s + 140*D1*Dd*f*g2 - 560*D1*Dd*f*gd2*r**2 - 1792*D1*Dd*f*gd2*r*s + 1064*D1*Dd*f*gd2*r - 1120*D1*Dd*f*gd2*s**2 + 1624*D1*Dd*f*gd2*s - 504*D1*Dd*f*gd2 - 560*D1*Dd*fd*g2*r**2 - 1792*D1*Dd*fd*g2*r*s + 504*D1*Dd*fd*g2*r - 1120*D1*Dd*fd*g2*s**2 + 728*D1*Dd*fd*g2*s + 28*D1*Ddd*K*f**2*s**2 - 14*D1*Ddd*K*f**2*s + 7*D1*Ddd*K*f**2 + 140*D1*Ddd*b2*f*r**2 + 280*D1*Ddd*b2*f*r*s - 210*D1*Ddd*b2*f*r + 140*D1*Ddd*b2*f*s**2 - 210*D1*Ddd*b2*f*s + 105*D1*Ddd*b2*f - 136*D1*Ddd*f**2*r**2 - 496*D1*Ddd*f**2*r*s + 260*D1*Ddd*f**2*r - 288*D1*Ddd*f**2*s**2 + 392*D1*Ddd*f**2*s - 140*D1*Ddd*f**2 - 280*D1*Ddd*f*g2*r**2 - 896*D1*Ddd*f*g2*r*s + 504*D1*Ddd*f*g2*r - 560*D1*Ddd*f*g2*s**2 + 728*D1*Ddd*f*g2*s - 280*D1*Ddd*f*g2 - 7*D1*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + 84*Dd**2*K*f**2*s**2 - 42*Dd**2*K*f**2*s + 420*Dd**2*b2*f*r**2 + 840*Dd**2*b2*f*r*s - 630*Dd**2*b2*f*r + 420*Dd**2*b2*f*s**2 - 630*Dd**2*b2*f*s + 210*Dd**2*b2*f - 408*Dd**2*f**2*r**2 - 1488*Dd**2*f**2*r*s + 780*Dd**2*f**2*r - 864*Dd**2*f**2*s**2 + 1176*Dd**2*f**2*s - 316*Dd**2*f**2 - 840*Dd**2*f*g2*r**2 - 2688*Dd**2*f*g2*r*s + 1512*Dd**2*f*g2*r - 1680*Dd**2*f*g2*s**2 + 2184*Dd**2*f*g2*s - 588*Dd**2*f*g2)))/(21*d**2*k3**4) - 5*D1**2*Pk3*k2**2*st**6*(-24*C*D1**2*Pk2*f**2*fd*r**2 + 192*C*D1**2*Pk2*f**2*fd*r*s - 48*C*D1**2*Pk2*f**2*fd*r + 96*C*D1**2*Pk2*f**2*fd*s**2 - 128*C*D1**2*Pk2*f**2*fd*s + 24*C*D1**2*Pk2*f**2*fd + 12*C*D1**2*Pk2*f**2*fdd*r**2 - 96*C*D1**2*Pk2*f**2*fdd*r*s + 24*C*D1**2*Pk2*f**2*fdd*r - 48*C*D1**2*Pk2*f**2*fdd*s**2 + 64*C*D1**2*Pk2*f**2*fdd*s - 12*C*D1**2*Pk2*f**2*fdd + 24*C*D1**2*Pk2*f*fd**2*r**2 - 192*C*D1**2*Pk2*f*fd**2*r*s + 48*C*D1**2*Pk2*f*fd**2*r - 96*C*D1**2*Pk2*f*fd**2*s**2 + 128*C*D1**2*Pk2*f*fd**2*s - 32*C*D1**2*Pk2*f*fd**2 - 32*C*D1*Dd*Pk2*f**3*r**2 + 256*C*D1*Dd*Pk2*f**3*r*s - 32*C*D1*Dd*Pk2*f**3*r + 128*C*D1*Dd*Pk2*f**3*s**2 - 192*C*D1*Dd*Pk2*f**3*s + 16*C*D1*Dd*Pk2*f**3 + 96*C*D1*Dd*Pk2*f**2*fd*r**2 - 768*C*D1*Dd*Pk2*f**2*fd*r*s + 144*C*D1*Dd*Pk2*f**2*fd*r - 384*C*D1*Dd*Pk2*f**2*fd*s**2 + 544*C*D1*Dd*Pk2*f**2*fd*s - 112*C*D1*Dd*Pk2*f**2*fd + 16*C*D1*Ddd*Pk2*f**3*r**2 - 128*C*D1*Ddd*Pk2*f**3*r*s + 16*C*D1*Ddd*Pk2*f**3*r - 64*C*D1*Ddd*Pk2*f**3*s**2 + 96*C*D1*Ddd*Pk2*f**3*s - 8*C*D1*Ddd*Pk2*f**3 + 48*C*Dd**2*Pk2*f**3*r**2 - 384*C*Dd**2*Pk2*f**3*r*s + 48*C*Dd**2*Pk2*f**3*r - 192*C*Dd**2*Pk2*f**3*s**2 + 288*C*Dd**2*Pk2*f**3*s - 56*C*Dd**2*Pk2*f**3 - 264*D1**2*K*Pk2*b1*f*fd*r**2 + 2112*D1**2*K*Pk2*b1*f*fd*r*s - 1056*D1**2*K*Pk2*b1*f*fd*r + 1056*D1**2*K*Pk2*b1*f*fd*s**2 - 1056*D1**2*K*Pk2*b1*f*fd*s + 528*D1**2*K*Pk2*b1*f*fd + 132*D1**2*K*Pk2*b1*f*fdd*r**2 - 1056*D1**2*K*Pk2*b1*f*fdd*r*s + 528*D1**2*K*Pk2*b1*f*fdd*r - 528*D1**2*K*Pk2*b1*f*fdd*s**2 + 528*D1**2*K*Pk2*b1*f*fdd*s - 264*D1**2*K*Pk2*b1*f*fdd + 132*D1**2*K*Pk2*b1*fd**2*r**2 - 1056*D1**2*K*Pk2*b1*fd**2*r*s + 528*D1**2*K*Pk2*b1*fd**2*r - 528*D1**2*K*Pk2*b1*fd**2*s**2 + 528*D1**2*K*Pk2*b1*fd**2*s + 396*D1**2*Pk2*b1*f**2*fd*r**2 - 264*D1**2*Pk2*b1*f**2*fd*r + 132*D1**2*Pk2*b1*f**2*fd - 396*D1**2*Pk2*b1*f**2*fdd*r**2 + 264*D1**2*Pk2*b1*f**2*fdd*r - 132*D1**2*Pk2*b1*f**2*fdd - 792*D1**2*Pk2*b1*f*fd**2*r**2 + 528*D1**2*Pk2*b1*f*fd**2*r + 792*D1**2*Pk2*b1*f*fd*r**2 - 396*D1**2*Pk2*b1*f*fdd*r**2 - 396*D1**2*Pk2*b1*fd**2*r**2 + 1056*D1**2*Pk2*b2*f*fd*r*s - 528*D1**2*Pk2*b2*f*fd*r + 1056*D1**2*Pk2*b2*f*fd*s**2 - 1056*D1**2*Pk2*b2*f*fd*s + 528*D1**2*Pk2*b2*f*fd - 528*D1**2*Pk2*b2*f*fdd*r*s + 264*D1**2*Pk2*b2*f*fdd*r - 528*D1**2*Pk2*b2*f*fdd*s**2 + 528*D1**2*Pk2*b2*f*fdd*s - 264*D1**2*Pk2*b2*f*fdd - 528*D1**2*Pk2*b2*fd**2*r*s + 264*D1**2*Pk2*b2*fd**2*r - 528*D1**2*Pk2*b2*fd**2*s**2 + 528*D1**2*Pk2*b2*fd**2*s + 528*D1**2*Pk2*bd2*f**2*r*s + 528*D1**2*Pk2*bd2*f**2*s**2 - 528*D1**2*Pk2*bd2*f**2*s - 1056*D1**2*Pk2*bd2*f*fd*r*s + 264*D1**2*Pk2*bd2*f*fd*r - 1056*D1**2*Pk2*bd2*f*fd*s**2 + 1056*D1**2*Pk2*bd2*f*fd*s - 264*D1**2*Pk2*bd2*f*fd - 264*D1**2*Pk2*bdd2*f**2*r*s - 264*D1**2*Pk2*bdd2*f**2*s**2 + 264*D1**2*Pk2*bdd2*f**2*s - 264*D1**2*Pk2*f**3*fd*r**2 + 264*D1**2*Pk2*f**3*fd*r - 132*D1**2*Pk2*f**3*fd + 264*D1**2*Pk2*f**3*fdd*r**2 - 264*D1**2*Pk2*f**3*fdd*r + 132*D1**2*Pk2*f**3*fdd + 792*D1**2*Pk2*f**2*fd**2*r**2 - 792*D1**2*Pk2*f**2*fd**2*r + 132*D1**2*Pk2*f**2*fd**2 + 48*D1**2*Pk2*f**2*fd*r**2 - 96*D1**2*Pk2*f**2*fd*r*s - 48*D1**2*Pk2*f**2*fd*s**2 + 64*D1**2*Pk2*f**2*fd*s - 24*D1**2*Pk2*f**2*fdd*r**2 + 48*D1**2*Pk2*f**2*fdd*r*s + 24*D1**2*Pk2*f**2*fdd*s**2 - 32*D1**2*Pk2*f**2*fdd*s + 264*D1**2*Pk2*f**2*gd2*r**2 - 2112*D1**2*Pk2*f**2*gd2*r*s - 528*D1**2*Pk2*f**2*gd2*r - 1056*D1**2*Pk2*f**2*gd2*s**2 + 2112*D1**2*Pk2*f**2*gd2*s + 264*D1**2*Pk2*f**2*gd2 - 132*D1**2*Pk2*f**2*gdd2*r**2 + 1056*D1**2*Pk2*f**2*gdd2*r*s + 264*D1**2*Pk2*f**2*gdd2*r + 528*D1**2*Pk2*f**2*gdd2*s**2 - 1056*D1**2*Pk2*f**2*gdd2*s - 132*D1**2*Pk2*f**2*gdd2 - 48*D1**2*Pk2*f*fd**2*r**2 + 96*D1**2*Pk2*f*fd**2*r*s + 48*D1**2*Pk2*f*fd**2*s**2 - 64*D1**2*Pk2*f*fd**2*s + 16*D1**2*Pk2*f*fd**2 + 528*D1**2*Pk2*f*fd*g2*r**2 - 4224*D1**2*Pk2*f*fd*g2*r*s + 2112*D1**2*Pk2*f*fd*g2*r - 2112*D1**2*Pk2*f*fd*g2*s**2 + 2112*D1**2*Pk2*f*fd*g2*s - 1056*D1**2*Pk2*f*fd*g2 - 528*D1**2*Pk2*f*fd*gd2*r**2 + 4224*D1**2*Pk2*f*fd*gd2*r*s - 528*D1**2*Pk2*f*fd*gd2*r + 2112*D1**2*Pk2*f*fd*gd2*s**2 - 3168*D1**2*Pk2*f*fd*gd2*s + 1056*D1**2*Pk2*f*fd*gd2 - 264*D1**2*Pk2*f*fdd*g2*r**2 + 2112*D1**2*Pk2*f*fdd*g2*r*s - 1056*D1**2*Pk2*f*fdd*g2*r + 1056*D1**2*Pk2*f*fdd*g2*s**2 - 1056*D1**2*Pk2*f*fdd*g2*s + 528*D1**2*Pk2*f*fdd*g2 - 264*D1**2*Pk2*fd**2*g2*r**2 + 2112*D1**2*Pk2*fd**2*g2*r*s - 1056*D1**2*Pk2*fd**2*g2*r + 1056*D1**2*Pk2*fd**2*g2*s**2 - 1056*D1**2*Pk2*fd**2*g2*s + 12*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 - 12*D1**2*Pkdd2*b1*f**2*fd*k1**2*s + 6*D1**2*Pkdd2*b1*f**2*fd*k1**2 - 6*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 + 6*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s - 3*D1**2*Pkdd2*b1*f**2*fdd*k1**2 - 12*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 + 12*D1**2*Pkdd2*b1*f*fd**2*k1**2*s + 4*D1**2*Pkdd2*f**3*fd*k1**2*s**2 - 2*D1**2*Pkdd2*f**3*fd*k1**2*s + D1**2*Pkdd2*f**3*fd*k1**2 - D1**2*bdd1*f**2*(66*Pk2*(-K*(r**2 - 8*r*s - 2*r - 4*s**2 + 8*s + 1) + 2*f*(r - 1)**2 + 3*(r - 1)**2) + Pkdd2*f*k1**2*(2*s**2 + 2*s - 1)) - 528*D1*Dd*K*Pk2*b1*f**2*r**2 + 4224*D1*Dd*K*Pk2*b1*f**2*r*s - 528*D1*Dd*K*Pk2*b1*f**2*r + 2112*D1*Dd*K*Pk2*b1*f**2*s**2 - 3168*D1*Dd*K*Pk2*b1*f**2*s + 264*D1*Dd*K*Pk2*b1*f**2 + 1056*D1*Dd*K*Pk2*b1*f*fd*r**2 - 8448*D1*Dd*K*Pk2*b1*f*fd*r*s + 2640*D1*Dd*K*Pk2*b1*f*fd*r - 4224*D1*Dd*K*Pk2*b1*f*fd*s**2 + 5280*D1*Dd*K*Pk2*b1*f*fd*s - 1584*D1*Dd*K*Pk2*b1*f*fd + 528*D1*Dd*Pk2*b1*f**3*r**2 - 528*D1*Dd*Pk2*b1*f**3*r + 264*D1*Dd*Pk2*b1*f**3 - 3168*D1*Dd*Pk2*b1*f**2*fd*r**2 + 2640*D1*Dd*Pk2*b1*f**2*fd*r - 528*D1*Dd*Pk2*b1*f**2*fd + 1584*D1*Dd*Pk2*b1*f**2*r**2 - 1584*D1*Dd*Pk2*b1*f**2*r + 792*D1*Dd*Pk2*b1*f**2 - 3168*D1*Dd*Pk2*b1*f*fd*r**2 + 1584*D1*Dd*Pk2*b1*f*fd*r + 2112*D1*Dd*Pk2*b2*f**2*r*s - 528*D1*Dd*Pk2*b2*f**2*r + 2112*D1*Dd*Pk2*b2*f**2*s**2 - 2112*D1*Dd*Pk2*b2*f**2*s + 528*D1*Dd*Pk2*b2*f**2 - 4224*D1*Dd*Pk2*b2*f*fd*r*s + 1584*D1*Dd*Pk2*b2*f*fd*r - 4224*D1*Dd*Pk2*b2*f*fd*s**2 + 4224*D1*Dd*Pk2*b2*f*fd*s - 1056*D1*Dd*Pk2*b2*f*fd - 2112*D1*Dd*Pk2*bd2*f**2*r*s + 264*D1*Dd*Pk2*bd2*f**2*r - 2112*D1*Dd*Pk2*bd2*f**2*s**2 + 2112*D1*Dd*Pk2*bd2*f**2*s - 264*D1*Dd*Pk2*bd2*f**2 - 264*D1*Dd*Pk2*f**4*r**2 + 264*D1*Dd*Pk2*f**4*r - 132*D1*Dd*Pk2*f**4 + 2112*D1*Dd*Pk2*f**3*fd*r**2 - 2112*D1*Dd*Pk2*f**3*fd*r + 528*D1*Dd*Pk2*f**3*fd + 64*D1*Dd*Pk2*f**3*r**2 - 128*D1*Dd*Pk2*f**3*r*s - 32*D1*Dd*Pk2*f**3*r - 64*D1*Dd*Pk2*f**3*s**2 + 96*D1*Dd*Pk2*f**3*s + 16*D1*Dd*Pk2*f**3 - 192*D1*Dd*Pk2*f**2*fd*r**2 + 384*D1*Dd*Pk2*f**2*fd*r*s + 48*D1*Dd*Pk2*f**2*fd*r + 192*D1*Dd*Pk2*f**2*fd*s**2 - 272*D1*Dd*Pk2*f**2*fd*s + 32*D1*Dd*Pk2*f**2*fd + 1056*D1*Dd*Pk2*f**2*g2*r**2 - 8448*D1*Dd*Pk2*f**2*g2*r*s + 1056*D1*Dd*Pk2*f**2*g2*r - 4224*D1*Dd*Pk2*f**2*g2*s**2 + 6336*D1*Dd*Pk2*f**2*g2*s - 528*D1*Dd*Pk2*f**2*g2 - 1056*D1*Dd*Pk2*f**2*gd2*r**2 + 8448*D1*Dd*Pk2*f**2*gd2*r*s + 528*D1*Dd*Pk2*f**2*gd2*r + 4224*D1*Dd*Pk2*f**2*gd2*s**2 - 7392*D1*Dd*Pk2*f**2*gd2*s + 528*D1*Dd*Pk2*f**2*gd2 - 2112*D1*Dd*Pk2*f*fd*g2*r**2 + 16896*D1*Dd*Pk2*f*fd*g2*r*s - 5280*D1*Dd*Pk2*f*fd*g2*r + 8448*D1*Dd*Pk2*f*fd*g2*s**2 - 10560*D1*Dd*Pk2*f*fd*g2*s + 3168*D1*Dd*Pk2*f*fd*g2 + 16*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 - 8*D1*Dd*Pkdd2*b1*f**3*k1**2*s + 4*D1*Dd*Pkdd2*b1*f**3*k1**2 - 48*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 + 36*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s - 6*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 + 4*D1*Dd*Pkdd2*f**4*k1**2*s**2 - 2*D1*Dd*Pkdd2*f**4*k1**2*s + D1*Dd*Pkdd2*f**4*k1**2 + 264*D1*Ddd*K*Pk2*b1*f**2*r**2 - 2112*D1*Ddd*K*Pk2*b1*f**2*r*s + 264*D1*Ddd*K*Pk2*b1*f**2*r - 1056*D1*Ddd*K*Pk2*b1*f**2*s**2 + 1584*D1*Ddd*K*Pk2*b1*f**2*s - 132*D1*Ddd*K*Pk2*b1*f**2 - 528*D1*Ddd*Pk2*b1*f**3*r**2 + 528*D1*Ddd*Pk2*b1*f**3*r - 264*D1*Ddd*Pk2*b1*f**3 - 792*D1*Ddd*Pk2*b1*f**2*r**2 + 792*D1*Ddd*Pk2*b1*f**2*r - 396*D1*Ddd*Pk2*b1*f**2 - 1056*D1*Ddd*Pk2*b2*f**2*r*s + 264*D1*Ddd*Pk2*b2*f**2*r - 1056*D1*Ddd*Pk2*b2*f**2*s**2 + 1056*D1*Ddd*Pk2*b2*f**2*s - 264*D1*Ddd*Pk2*b2*f**2 + 264*D1*Ddd*Pk2*f**4*r**2 - 264*D1*Ddd*Pk2*f**4*r + 132*D1*Ddd*Pk2*f**4 - 32*D1*Ddd*Pk2*f**3*r**2 + 64*D1*Ddd*Pk2*f**3*r*s + 16*D1*Ddd*Pk2*f**3*r + 32*D1*Ddd*Pk2*f**3*s**2 - 48*D1*Ddd*Pk2*f**3*s - 8*D1*Ddd*Pk2*f**3 - 528*D1*Ddd*Pk2*f**2*g2*r**2 + 4224*D1*Ddd*Pk2*f**2*g2*r*s - 528*D1*Ddd*Pk2*f**2*g2*r + 2112*D1*Ddd*Pk2*f**2*g2*s**2 - 3168*D1*Ddd*Pk2*f**2*g2*s + 264*D1*Ddd*Pk2*f**2*g2 - 8*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 + 4*D1*Ddd*Pkdd2*b1*f**3*k1**2*s - 2*D1*Ddd*Pkdd2*b1*f**3*k1**2 + 2*D1*bd1*f*(D1*(132*Pk2*fd*(K*(r**2 - 8*r*s + r - 4*s**2 + 6*s - 2) + r*(3 - 3*r)) + f**2*(66*Pk2*(r - 1)**2 + Pkdd2*k1**2*(2*s**2 + 2*s - 1)) - 6*f*(11*Pk2*(K*(r**2 - 8*r*s - 2*r - 4*s**2 + 8*s + 1) + fd*(6*r**2 - 8*r + 2) - 3*(r - 1)**2) + Pkdd2*fd*k1**2*s**2)) - Dd*f*(132*Pk2*(K*(-2*r**2 + 16*r*s + r + 8*s**2 - 14*s + 1) + f*(4*r**2 - 6*r + 2) + 6*r**2 - 9*r + 3) + Pkdd2*f*k1**2*(8*s**2 + 2*s - 1))) + 792*Dd**2*K*Pk2*b1*f**2*r**2 - 6336*Dd**2*K*Pk2*b1*f**2*r*s + 792*Dd**2*K*Pk2*b1*f**2*r - 3168*Dd**2*K*Pk2*b1*f**2*s**2 + 4752*Dd**2*K*Pk2*b1*f**2*s - 924*Dd**2*K*Pk2*b1*f**2 - 1584*Dd**2*Pk2*b1*f**3*r**2 + 1584*Dd**2*Pk2*b1*f**3*r - 264*Dd**2*Pk2*b1*f**3 - 2376*Dd**2*Pk2*b1*f**2*r**2 + 2376*Dd**2*Pk2*b1*f**2*r - 396*Dd**2*Pk2*b1*f**2 - 3168*Dd**2*Pk2*b2*f**2*r*s + 792*Dd**2*Pk2*b2*f**2*r - 3168*Dd**2*Pk2*b2*f**2*s**2 + 3168*Dd**2*Pk2*b2*f**2*s - 528*Dd**2*Pk2*b2*f**2 + 792*Dd**2*Pk2*f**4*r**2 - 792*Dd**2*Pk2*f**4*r + 132*Dd**2*Pk2*f**4 - 96*Dd**2*Pk2*f**3*r**2 + 192*Dd**2*Pk2*f**3*r*s + 48*Dd**2*Pk2*f**3*r + 96*Dd**2*Pk2*f**3*s**2 - 144*Dd**2*Pk2*f**3*s + 16*Dd**2*Pk2*f**3 - 1584*Dd**2*Pk2*f**2*g2*r**2 + 12672*Dd**2*Pk2*f**2*g2*r*s - 1584*Dd**2*Pk2*f**2*g2*r + 6336*Dd**2*Pk2*f**2*g2*s**2 - 9504*Dd**2*Pk2*f**2*g2*s + 1848*Dd**2*Pk2*f**2*g2 - 24*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 + 12*Dd**2*Pkdd2*b1*f**3*k1**2*s)/(1386*d**2*k3**4) + D1**2*Pk3*k2**2*st**4*(480*C*D1**2*Pk2*f**2*fd*r**2 + 384*C*D1**2*Pk2*f**2*fd*r*s - 448*C*D1**2*Pk2*f**2*fd*r - 128*C*D1**2*Pk2*f**2*fd*s + 160*C*D1**2*Pk2*f**2*fd - 240*C*D1**2*Pk2*f**2*fdd*r**2 - 192*C*D1**2*Pk2*f**2*fdd*r*s + 224*C*D1**2*Pk2*f**2*fdd*r + 64*C*D1**2*Pk2*f**2*fdd*s - 80*C*D1**2*Pk2*f**2*fdd - 480*C*D1**2*Pk2*f*fd**2*r**2 - 384*C*D1**2*Pk2*f*fd**2*r*s + 448*C*D1**2*Pk2*f*fd**2*r + 128*C*D1**2*Pk2*f*fd**2*s - 64*C*D1**2*Pk2*f*fd**2 - 12*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 8*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 4*C*D1**2*Pkdd2*f**2*fd*k1**2 + 6*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 4*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 2*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 12*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 8*C*D1**2*Pkdd2*f*fd**2*k1**2*s + 640*C*D1*Dd*Pk2*f**3*r**2 + 512*C*D1*Dd*Pk2*f**3*r*s - 768*C*D1*Dd*Pk2*f**3*r - 256*C*D1*Dd*Pk2*f**3*s + 320*C*D1*Dd*Pk2*f**3 - 1920*C*D1*Dd*Pk2*f**2*fd*r**2 - 1536*C*D1*Dd*Pk2*f**2*fd*r*s + 2048*C*D1*Dd*Pk2*f**2*fd*r + 640*C*D1*Dd*Pk2*f**2*fd*s - 512*C*D1*Dd*Pk2*f**2*fd - 16*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 8*C*D1*Dd*Pkdd2*f**3*k1**2*s - 4*C*D1*Dd*Pkdd2*f**3*k1**2 + 48*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 28*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 4*C*D1*Dd*Pkdd2*f**2*fd*k1**2 - 320*C*D1*Ddd*Pk2*f**3*r**2 - 256*C*D1*Ddd*Pk2*f**3*r*s + 384*C*D1*Ddd*Pk2*f**3*r + 128*C*D1*Ddd*Pk2*f**3*s - 160*C*D1*Ddd*Pk2*f**3 + 8*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 4*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 2*C*D1*Ddd*Pkdd2*f**3*k1**2 - 960*C*Dd**2*Pk2*f**3*r**2 - 768*C*Dd**2*Pk2*f**3*r*s + 1152*C*Dd**2*Pk2*f**3*r + 384*C*Dd**2*Pk2*f**3*s - 288*C*Dd**2*Pk2*f**3 + 24*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 12*C*Dd**2*Pkdd2*f**3*k1**2*s - 594*D1**2*K*Pk2*bdd1*f**2*r**2 - 1584*D1**2*K*Pk2*bdd1*f**2*r*s + 1188*D1**2*K*Pk2*bdd1*f**2*r - 594*D1**2*K*Pk2*bdd1*f**2*s**2 + 1584*D1**2*K*Pk2*bdd1*f**2*s - 594*D1**2*K*Pk2*bdd1*f**2 + 396*D1**2*Pk2*b2*f*fd*r**2 + 1848*D1**2*Pk2*b2*f*fd*r*s - 924*D1**2*Pk2*b2*f*fd*r + 1452*D1**2*Pk2*b2*f*fd*s**2 - 1452*D1**2*Pk2*b2*f*fd*s + 726*D1**2*Pk2*b2*f*fd - 660*D1**2*Pk2*b2*f*fdd*r**2 - 1848*D1**2*Pk2*b2*f*fdd*r*s + 924*D1**2*Pk2*b2*f*fdd*r - 1188*D1**2*Pk2*b2*f*fdd*s**2 + 1188*D1**2*Pk2*b2*f*fdd*s - 594*D1**2*Pk2*b2*f*fdd - 660*D1**2*Pk2*b2*fd**2*r**2 - 1848*D1**2*Pk2*b2*fd**2*r*s + 924*D1**2*Pk2*b2*fd**2*r - 1188*D1**2*Pk2*b2*fd**2*s**2 + 1188*D1**2*Pk2*b2*fd**2*s - 132*D1**2*Pk2*bd1**2*f*(2*K*s + f*(r - 1) - r**2*(3*K + 1) + r*(-4*K*s + 3*K + 2) - 1) + 198*D1**2*Pk2*bd2*f**2*r**2 + 924*D1**2*Pk2*bd2*f**2*r*s - 396*D1**2*Pk2*bd2*f**2*r + 726*D1**2*Pk2*bd2*f**2*s**2 - 924*D1**2*Pk2*bd2*f**2*s + 198*D1**2*Pk2*bd2*f**2 - 1320*D1**2*Pk2*bd2*f*fd*r**2 - 3696*D1**2*Pk2*bd2*f*fd*r*s + 2244*D1**2*Pk2*bd2*f*fd*r - 2376*D1**2*Pk2*bd2*f*fd*s**2 + 3036*D1**2*Pk2*bd2*f*fd*s - 924*D1**2*Pk2*bd2*f*fd + 132*D1**2*Pk2*bdd1*f**3*r**2 + 330*D1**2*Pk2*bdd1*f**3*r*s - 396*D1**2*Pk2*bdd1*f**3*r - 330*D1**2*Pk2*bdd1*f**3*s + 198*D1**2*Pk2*bdd1*f**3 + 132*D1**2*Pk2*bdd1*f**2*r**2 + 330*D1**2*Pk2*bdd1*f**2*r*s - 264*D1**2*Pk2*bdd1*f**2*r - 330*D1**2*Pk2*bdd1*f**2*s + 132*D1**2*Pk2*bdd1*f**2 - 396*D1**2*Pk2*bdd1*f*g2*r**2 - 528*D1**2*Pk2*bdd1*f*g2*r*s - 330*D1**2*Pk2*bdd2*f**2*r**2 - 924*D1**2*Pk2*bdd2*f**2*r*s + 660*D1**2*Pk2*bdd2*f**2*r - 594*D1**2*Pk2*bdd2*f**2*s**2 + 924*D1**2*Pk2*bdd2*f**2*s - 330*D1**2*Pk2*bdd2*f**2 - 288*D1**2*Pk2*f**2*fd*r**2 - 216*D1**2*Pk2*f**2*fd*r*s + 264*D1**2*Pk2*f**2*fd*r + 72*D1**2*Pk2*f**2*fd*s - 96*D1**2*Pk2*f**2*fd + 144*D1**2*Pk2*f**2*fdd*r**2 + 108*D1**2*Pk2*f**2*fdd*r*s - 132*D1**2*Pk2*f**2*fdd*r - 36*D1**2*Pk2*f**2*fdd*s + 48*D1**2*Pk2*f**2*fdd - 792*D1**2*Pk2*f**2*gd2*r**2 - 3168*D1**2*Pk2*f**2*gd2*r*s + 1584*D1**2*Pk2*f**2*gd2*r - 1452*D1**2*Pk2*f**2*gd2*s**2 + 3168*D1**2*Pk2*f**2*gd2*s - 792*D1**2*Pk2*f**2*gd2 + 1188*D1**2*Pk2*f**2*gdd2*r**2 + 3168*D1**2*Pk2*f**2*gdd2*r*s - 2376*D1**2*Pk2*f**2*gdd2*r + 1188*D1**2*Pk2*f**2*gdd2*s**2 - 3168*D1**2*Pk2*f**2*gdd2*s + 1188*D1**2*Pk2*f**2*gdd2 + 288*D1**2*Pk2*f*fd**2*r**2 + 216*D1**2*Pk2*f*fd**2*r*s - 264*D1**2*Pk2*f*fd**2*r - 72*D1**2*Pk2*f*fd**2*s + 36*D1**2*Pk2*f*fd**2 - 1584*D1**2*Pk2*f*fd*g2*r**2 - 6336*D1**2*Pk2*f*fd*g2*r*s + 3168*D1**2*Pk2*f*fd*g2*r - 2904*D1**2*Pk2*f*fd*g2*s**2 + 2904*D1**2*Pk2*f*fd*g2*s - 1452*D1**2*Pk2*f*fd*g2 + 4752*D1**2*Pk2*f*fd*gd2*r**2 + 12672*D1**2*Pk2*f*fd*gd2*r*s - 7920*D1**2*Pk2*f*fd*gd2*r + 4752*D1**2*Pk2*f*fd*gd2*s**2 - 8712*D1**2*Pk2*f*fd*gd2*s + 3168*D1**2*Pk2*f*fd*gd2 + 2376*D1**2*Pk2*f*fdd*g2*r**2 + 6336*D1**2*Pk2*f*fdd*g2*r*s - 3168*D1**2*Pk2*f*fdd*g2*r + 2376*D1**2*Pk2*f*fdd*g2*s**2 - 2376*D1**2*Pk2*f*fdd*g2*s + 1188*D1**2*Pk2*f*fdd*g2 + 2376*D1**2*Pk2*fd**2*g2*r**2 + 6336*D1**2*Pk2*fd**2*g2*r*s - 3168*D1**2*Pk2*fd**2*g2*r + 2376*D1**2*Pk2*fd**2*g2*s**2 - 2376*D1**2*Pk2*fd**2*g2*s + 6*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 4*D1**2*Pkdd2*f**2*fd*k1**2*s + 2*D1**2*Pkdd2*f**2*fd*k1**2 - 3*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 2*D1**2*Pkdd2*f**2*fdd*k1**2*s - D1**2*Pkdd2*f**2*fdd*k1**2 - 6*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 4*D1**2*Pkdd2*f*fd**2*k1**2*s + 792*D1*Dd*Pk2*b2*f**2*r**2 + 3696*D1*Dd*Pk2*b2*f**2*r*s - 1716*D1*Dd*Pk2*b2*f**2*r + 2904*D1*Dd*Pk2*b2*f**2*s**2 - 3300*D1*Dd*Pk2*b2*f**2*s + 1122*D1*Dd*Pk2*b2*f**2 - 5280*D1*Dd*Pk2*b2*f*fd*r**2 - 14784*D1*Dd*Pk2*b2*f*fd*r*s + 8184*D1*Dd*Pk2*b2*f*fd*r - 9504*D1*Dd*Pk2*b2*f*fd*s**2 + 10824*D1*Dd*Pk2*b2*f*fd*s - 3036*D1*Dd*Pk2*b2*f*fd - 2640*D1*Dd*Pk2*bd2*f**2*r**2 - 7392*D1*Dd*Pk2*bd2*f**2*r*s + 4884*D1*Dd*Pk2*bd2*f**2*r - 4752*D1*Dd*Pk2*bd2*f**2*s**2 + 6732*D1*Dd*Pk2*bd2*f**2*s - 2244*D1*Dd*Pk2*bd2*f**2 - 384*D1*Dd*Pk2*f**3*r**2 - 288*D1*Dd*Pk2*f**3*r*s + 456*D1*Dd*Pk2*f**3*r + 144*D1*Dd*Pk2*f**3*s - 192*D1*Dd*Pk2*f**3 + 1152*D1*Dd*Pk2*f**2*fd*r**2 + 864*D1*Dd*Pk2*f**2*fd*r*s - 1212*D1*Dd*Pk2*f**2*fd*r - 360*D1*Dd*Pk2*f**2*fd*s + 300*D1*Dd*Pk2*f**2*fd - 3168*D1*Dd*Pk2*f**2*g2*r**2 - 12672*D1*Dd*Pk2*f**2*g2*r*s + 6336*D1*Dd*Pk2*f**2*g2*r - 5808*D1*Dd*Pk2*f**2*g2*s**2 + 9240*D1*Dd*Pk2*f**2*g2*s - 3036*D1*Dd*Pk2*f**2*g2 + 9504*D1*Dd*Pk2*f**2*gd2*r**2 + 25344*D1*Dd*Pk2*f**2*gd2*r*s - 17424*D1*Dd*Pk2*f**2*gd2*r + 9504*D1*Dd*Pk2*f**2*gd2*s**2 - 21384*D1*Dd*Pk2*f**2*gd2*s + 7920*D1*Dd*Pk2*f**2*gd2 + 19008*D1*Dd*Pk2*f*fd*g2*r**2 + 50688*D1*Dd*Pk2*f*fd*g2*r*s - 28512*D1*Dd*Pk2*f*fd*g2*r + 19008*D1*Dd*Pk2*f*fd*g2*s**2 - 26928*D1*Dd*Pk2*f*fd*g2*s + 8712*D1*Dd*Pk2*f*fd*g2 + 8*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**3*k1**2*s + 2*D1*Dd*Pkdd2*f**3*k1**2 - 24*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 14*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 2*D1*Dd*Pkdd2*f**2*fd*k1**2 - 1320*D1*Ddd*Pk2*b2*f**2*r**2 - 3696*D1*Ddd*Pk2*b2*f**2*r*s + 2244*D1*Ddd*Pk2*b2*f**2*r - 2376*D1*Ddd*Pk2*b2*f**2*s**2 + 3036*D1*Ddd*Pk2*b2*f**2*s - 1254*D1*Ddd*Pk2*b2*f**2 + 192*D1*Ddd*Pk2*f**3*r**2 + 144*D1*Ddd*Pk2*f**3*r*s - 228*D1*Ddd*Pk2*f**3*r - 72*D1*Ddd*Pk2*f**3*s + 96*D1*Ddd*Pk2*f**3 + 4752*D1*Ddd*Pk2*f**2*g2*r**2 + 12672*D1*Ddd*Pk2*f**2*g2*r*s - 7920*D1*Ddd*Pk2*f**2*g2*r + 4752*D1*Ddd*Pk2*f**2*g2*s**2 - 8712*D1*Ddd*Pk2*f**2*g2*s + 3564*D1*Ddd*Pk2*f**2*g2 - 4*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**3*k1**2*s - D1*Ddd*Pkdd2*f**3*k1**2 - 66*D1*Pk2*bd1*(D1*(f**3*(2*r**2 + r*(5*s - 6) - 5*s + 3) - f**2*(K*(6*r**2 + 24*r*s - 12*r + 11*s**2 - 24*s + 6) + fd*(12*r**2 + 5*r*(6*s - 5) - 20*s + 11) + (r - 1)*(r - 3*s - 1)) + f*(fd*(6*K*(6*r**2 + 2*r*(8*s - 5) + 6*s**2 - 11*s + 4) - 8*r**2 - 20*r*s + 13*r + 10*s - 5) - 4*g2*r*(3*r + 4*s) - 4*gd2*(-3*r**2 - 4*r*s + 3*r + 2*s)) + 4*fd*g2*r*(3*r + 4*s - 2)) + Dd*f*(f**2*(-16*r**2 + r*(37 - 40*s) + 30*s - 17) + f*(6*K*(12*r**2 + 32*r*s - 22*r + 12*s**2 - 27*s + 10) - 16*r**2 - 40*r*s + 29*r + 30*s - 13) + 16*g2*(3*r**2 + r*(4*s - 2) - s))) - 3960*Dd**2*Pk2*b2*f**2*r**2 - 11088*Dd**2*Pk2*b2*f**2*r*s + 6732*Dd**2*Pk2*b2*f**2*r - 7128*Dd**2*Pk2*b2*f**2*s**2 + 9108*Dd**2*Pk2*b2*f**2*s - 2508*Dd**2*Pk2*b2*f**2 + 576*Dd**2*Pk2*f**3*r**2 + 432*Dd**2*Pk2*f**3*r*s - 684*Dd**2*Pk2*f**3*r - 216*Dd**2*Pk2*f**3*s + 168*Dd**2*Pk2*f**3 + 14256*Dd**2*Pk2*f**2*g2*r**2 + 38016*Dd**2*Pk2*f**2*g2*r*s - 23760*Dd**2*Pk2*f**2*g2*r + 14256*Dd**2*Pk2*f**2*g2*s**2 - 26136*Dd**2*Pk2*f**2*g2*s + 8712*Dd**2*Pk2*f**2*g2 - 12*Dd**2*Pkdd2*f**3*k1**2*s**2 + 6*Dd**2*Pkdd2*f**3*k1**2*s - 66*Pk2*b1**2*(D1**2*(-2*fd**2*(r - 1) + 2*fd*r*(K*(3*r + 4*s - 4) + f + r + 2) - fdd*r*(K*(3*r + 4*s - 4) + 2*f + r + 2)) - 2*D1*(2*Dd*(-f*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) - 2*fd*r + fd + 2*r**2 - 2*r + 1) + fd*(K*(6*r**2 + 8*r*(s - 1) - 2*s + 2) + 2*r**2 + r - 1)) + Ddd*f*(K*(6*r**2 + 8*r*(s - 1) - 4*s + 3) + 2*r**2 - 2*r + 1)) - 2*Dd**2*f*(K*(18*r**2 + 24*r*(s - 1) - 12*s + 7) + 6*r**2 - 6*r + 1)) + 66*Pk2*b1*(12*D1**2*K*f*fd*r**2 + 48*D1**2*K*f*fd*r*s - 24*D1**2*K*f*fd*r + 22*D1**2*K*f*fd*s**2 - 22*D1**2*K*f*fd*s + 11*D1**2*K*f*fd - 18*D1**2*K*f*fdd*r**2 - 48*D1**2*K*f*fdd*r*s + 24*D1**2*K*f*fdd*r - 18*D1**2*K*f*fdd*s**2 + 18*D1**2*K*f*fdd*s - 9*D1**2*K*f*fdd - 18*D1**2*K*fd**2*r**2 - 48*D1**2*K*fd**2*r*s + 24*D1**2*K*fd**2*r - 18*D1**2*K*fd**2*s**2 + 18*D1**2*K*fd**2*s + D1**2*bdd1*f*(K*(6*r**2 + r*(8*s - 6) - 4*s + 3) + 2*r**2 - r*(2*f + 4) + 1) - 6*D1**2*f**2*fd*r**2 - 15*D1**2*f**2*fd*r*s + 7*D1**2*f**2*fd*r + 5*D1**2*f**2*fd*s - D1**2*f**2*fd + 6*D1**2*f**2*fdd*r**2 + 15*D1**2*f**2*fdd*r*s - 7*D1**2*f**2*fdd*r - 5*D1**2*f**2*fdd*s + D1**2*f**2*fdd + 12*D1**2*f*fd**2*r**2 + 30*D1**2*f*fd**2*r*s - 14*D1**2*f*fd**2*r - 10*D1**2*f*fd**2*s + 3*D1**2*f*fd**2 + 2*D1**2*f*fd*r**2 - 6*D1**2*f*fd*r*s + 3*D1**2*f*fd*r + 4*D1**2*f*fdd*r**2 + 10*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r + 12*D1**2*f*gd2*r**2 + 16*D1**2*f*gd2*r*s - 24*D1**2*f*gd2*r - 16*D1**2*f*gd2*s + 12*D1**2*f*gd2 - 6*D1**2*f*gdd2*r**2 - 8*D1**2*f*gdd2*r*s + 12*D1**2*f*gdd2*r + 8*D1**2*f*gdd2*s - 6*D1**2*f*gdd2 + 4*D1**2*fd**2*r**2 + 10*D1**2*fd**2*r*s - 5*D1**2*fd**2*r + 12*D1**2*fd*g2*r**2 + 16*D1**2*fd*g2*r*s - 16*D1**2*fd*g2*r - 12*D1**2*fd*gd2*r**2 - 16*D1**2*fd*gd2*r*s + 20*D1**2*fd*gd2*r + 8*D1**2*fd*gd2*s - 8*D1**2*fd*gd2 - 6*D1**2*fdd*g2*r**2 - 8*D1**2*fdd*g2*r*s + 8*D1**2*fdd*g2*r + 24*D1*Dd*K*f**2*r**2 + 96*D1*Dd*K*f**2*r*s - 48*D1*Dd*K*f**2*r + 44*D1*Dd*K*f**2*s**2 - 70*D1*Dd*K*f**2*s + 23*D1*Dd*K*f**2 - 144*D1*Dd*K*f*fd*r**2 - 384*D1*Dd*K*f*fd*r*s + 216*D1*Dd*K*f*fd*r - 144*D1*Dd*K*f*fd*s**2 + 204*D1*Dd*K*f*fd*s - 66*D1*Dd*K*f*fd - 8*D1*Dd*f**3*r**2 - 20*D1*Dd*f**3*r*s + 13*D1*Dd*f**3*r + 10*D1*Dd*f**3*s - 4*D1*Dd*f**3 + 48*D1*Dd*f**2*fd*r**2 + 120*D1*Dd*f**2*fd*r*s - 67*D1*Dd*f**2*fd*r - 50*D1*Dd*f**2*fd*s + 19*D1*Dd*f**2*fd + 4*D1*Dd*f**2*r**2 - 12*D1*Dd*f**2*r*s - D1*Dd*f**2*r + 6*D1*Dd*f**2*s + 2*D1*Dd*f**2 + 32*D1*Dd*f*fd*r**2 + 80*D1*Dd*f*fd*r*s - 46*D1*Dd*f*fd*r - 20*D1*Dd*f*fd*s + 10*D1*Dd*f*fd + 48*D1*Dd*f*g2*r**2 + 64*D1*Dd*f*g2*r*s - 64*D1*Dd*f*g2*r - 32*D1*Dd*f*g2*s + 24*D1*Dd*f*g2 - 48*D1*Dd*f*gd2*r**2 - 64*D1*Dd*f*gd2*r*s + 80*D1*Dd*f*gd2*r + 48*D1*Dd*f*gd2*s - 32*D1*Dd*f*gd2 - 48*D1*Dd*fd*g2*r**2 - 64*D1*Dd*fd*g2*r*s + 64*D1*Dd*fd*g2*r + 16*D1*Dd*fd*g2*s - 16*D1*Dd*fd*g2 - 36*D1*Ddd*K*f**2*r**2 - 96*D1*Ddd*K*f**2*r*s + 60*D1*Ddd*K*f**2*r - 36*D1*Ddd*K*f**2*s**2 + 66*D1*Ddd*K*f**2*s - 27*D1*Ddd*K*f**2 + 8*D1*Ddd*f**3*r**2 + 20*D1*Ddd*f**3*r*s - 13*D1*Ddd*f**3*r - 10*D1*Ddd*f**3*s + 4*D1*Ddd*f**3 + 8*D1*Ddd*f**2*r**2 + 20*D1*Ddd*f**2*r*s - 13*D1*Ddd*f**2*r - 10*D1*Ddd*f**2*s + 4*D1*Ddd*f**2 - 24*D1*Ddd*f*g2*r**2 - 32*D1*Ddd*f*g2*r*s + 32*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s - 12*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*r - f*(K*(6*r**2 + 8*r*s - 6*r - 4*s + 3) + 2*r**2 - 4*r + 1) + fd*(K*(6*r**2 + 8*r*s - 7*r - 2*s + 2) + 2*r**2 - 1)) - 2*Dd*f*(2*r - 1)*(-6*K*r - 8*K*s + 4*K + f - 2*r + 2)) - 108*Dd**2*K*f**2*r**2 - 288*Dd**2*K*f**2*r*s + 180*Dd**2*K*f**2*r - 108*Dd**2*K*f**2*s**2 + 198*Dd**2*K*f**2*s - 66*Dd**2*K*f**2 + 24*Dd**2*f**3*r**2 + 60*Dd**2*f**3*r*s - 39*Dd**2*f**3*r - 30*Dd**2*f**3*s + 14*Dd**2*f**3 + 24*Dd**2*f**2*r**2 + 60*Dd**2*f**2*r*s - 39*Dd**2*f**2*r - 30*Dd**2*f**2*s + 14*Dd**2*f**2 - 72*Dd**2*f*g2*r**2 - 96*Dd**2*f*g2*r*s + 96*Dd**2*f*g2*r + 48*Dd**2*f*g2*s - 28*Dd**2*f*g2))/(231*d**2*k3**4) + D1**2*Pk3*k2**2*st**2*(-1056*C*D1**2*Pk2*bd1**2*f*r**2 - 2112*C*D1**2*Pk2*bd1**2*f*r*s + 1056*C*D1**2*Pk2*bd1**2*f*r - 1056*C*D1**2*Pk2*bd1**2*f*s**2 + 1056*C*D1**2*Pk2*bd1**2*f*s + 660*C*D1**2*Pk2*bd1*f**2*r**2 + 264*C*D1**2*Pk2*bd1*f**2*r*s - 528*C*D1**2*Pk2*bd1*f**2*r - 396*C*D1**2*Pk2*bd1*f**2*s**2 + 1584*C*D1**2*Pk2*bd1*f**2*s - 792*C*D1**2*Pk2*bd1*f**2 + 4224*C*D1**2*Pk2*bd1*f*fd*r**2 + 7392*C*D1**2*Pk2*bd1*f*fd*r*s - 6600*C*D1**2*Pk2*bd1*f*fd*r + 2640*C*D1**2*Pk2*bd1*f*fd*s**2 - 5808*C*D1**2*Pk2*bd1*f*fd*s + 2640*C*D1**2*Pk2*bd1*f*fd + 1056*C*D1**2*Pk2*bdd1*f**2*r**2 + 1848*C*D1**2*Pk2*bdd1*f**2*r*s - 2640*C*D1**2*Pk2*bdd1*f**2*r + 660*C*D1**2*Pk2*bdd1*f**2*s**2 - 2640*C*D1**2*Pk2*bdd1*f**2*s + 1320*C*D1**2*Pk2*bdd1*f**2 - 420*C*D1**2*Pk2*f**2*fd*r**2 - 2376*C*D1**2*Pk2*f**2*fd*r*s + 1072*C*D1**2*Pk2*f**2*fd*r - 2376*C*D1**2*Pk2*f**2*fd*s**2 + 2376*C*D1**2*Pk2*f**2*fd*s - 932*C*D1**2*Pk2*f**2*fd + 12*C*D1**2*Pk2*f**2*fdd*r**2 + 2376*C*D1**2*Pk2*f**2*fdd*r*s - 800*C*D1**2*Pk2*f**2*fdd*r + 2376*C*D1**2*Pk2*f**2*fdd*s**2 - 2376*C*D1**2*Pk2*f**2*fdd*s + 796*C*D1**2*Pk2*f**2*fdd + 24*C*D1**2*Pk2*f*fd**2*r**2 + 4752*C*D1**2*Pk2*f*fd**2*r*s - 1600*C*D1**2*Pk2*f*fd**2*r + 4752*C*D1**2*Pk2*f*fd**2*s**2 - 4752*C*D1**2*Pk2*f*fd**2*s + 792*C*D1**2*Pk2*f*fd**2 - 132*C*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 + 264*C*D1**2*Pkdd2*bd1*f**2*k1**2*s - 132*C*D1**2*Pkdd2*bd1*f**2*k1**2 + 264*C*D1**2*Pkdd2*bd1*f*fd*k1**2*s**2 - 264*C*D1**2*Pkdd2*bd1*f*fd*k1**2*s + 66*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 132*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 66*C*D1**2*Pkdd2*bdd1*f**2*k1**2 + 198*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 132*C*D1**2*Pkdd2*f**2*fd*k1**2*s + 66*C*D1**2*Pkdd2*f**2*fd*k1**2 + 8448*C*D1*Dd*Pk2*bd1*f**2*r**2 + 14784*C*D1*Dd*Pk2*bd1*f**2*r*s - 16632*C*D1*Dd*Pk2*bd1*f**2*r + 5280*C*D1*Dd*Pk2*bd1*f**2*s**2 - 15576*C*D1*Dd*Pk2*bd1*f**2*s + 7920*C*D1*Dd*Pk2*bd1*f**2 - 560*C*D1*Dd*Pk2*f**3*r**2 - 3168*C*D1*Dd*Pk2*f**3*r*s + 1352*C*D1*Dd*Pk2*f**3*r - 3168*C*D1*Dd*Pk2*f**3*s**2 + 3168*C*D1*Dd*Pk2*f**3*s - 1072*C*D1*Dd*Pk2*f**3 + 96*C*D1*Dd*Pk2*f**2*fd*r**2 + 19008*C*D1*Dd*Pk2*f**2*fd*r*s - 5624*C*D1*Dd*Pk2*f**2*fd*r + 19008*C*D1*Dd*Pk2*f**2*fd*s**2 - 19008*C*D1*Dd*Pk2*f**2*fd*s + 3976*C*D1*Dd*Pk2*f**2*fd + 528*C*D1*Dd*Pkdd2*bd1*f**2*k1**2*s**2 - 660*C*D1*Dd*Pkdd2*bd1*f**2*k1**2*s + 132*C*D1*Dd*Pkdd2*bd1*f**2*k1**2 + 264*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 132*C*D1*Dd*Pkdd2*f**3*k1**2*s + 66*C*D1*Dd*Pkdd2*f**3*k1**2 + 16*C*D1*Ddd*Pk2*f**3*r**2 + 3168*C*D1*Ddd*Pk2*f**3*r*s - 808*C*D1*Ddd*Pk2*f**3*r + 3168*C*D1*Ddd*Pk2*f**3*s**2 - 3168*C*D1*Ddd*Pk2*f**3*s + 800*C*D1*Ddd*Pk2*f**3 + 48*C*Dd**2*Pk2*f**3*r**2 + 9504*C*Dd**2*Pk2*f**3*r*s - 2424*C*Dd**2*Pk2*f**3*r + 9504*C*Dd**2*Pk2*f**3*s**2 - 9504*C*Dd**2*Pk2*f**3*s + 1592*C*Dd**2*Pk2*f**3 - 7392*D1**2*K*Pk2*bd1**2*f*r**2 - 12936*D1**2*K*Pk2*bd1**2*f*r*s + 16632*D1**2*K*Pk2*bd1**2*f*r - 4620*D1**2*K*Pk2*bd1**2*f*s**2 + 15708*D1**2*K*Pk2*bd1**2*f*s - 9240*D1**2*K*Pk2*bd1**2*f + 462*D1**2*K*Pk2*bd1*f**2*r**2 + 2772*D1**2*K*Pk2*bd1*f**2*r*s - 924*D1**2*K*Pk2*bd1*f**2*r + 2772*D1**2*K*Pk2*bd1*f**2*s**2 - 2772*D1**2*K*Pk2*bd1*f**2*s + 462*D1**2*K*Pk2*bd1*f**2 - 1848*D1**2*K*Pk2*bd1*f*fd*r**2 - 11088*D1**2*K*Pk2*bd1*f*fd*r*s + 4620*D1**2*K*Pk2*bd1*f*fd*r - 11088*D1**2*K*Pk2*bd1*f*fd*s**2 + 11088*D1**2*K*Pk2*bd1*f*fd*s - 2772*D1**2*K*Pk2*bd1*f*fd - 462*D1**2*K*Pk2*bdd1*f**2*r**2 - 2772*D1**2*K*Pk2*bdd1*f**2*r*s + 924*D1**2*K*Pk2*bdd1*f**2*r - 2772*D1**2*K*Pk2*bdd1*f**2*s**2 + 2772*D1**2*K*Pk2*bdd1*f**2*s - 462*D1**2*K*Pk2*bdd1*f**2 + 66*D1**2*K*Pkdd2*bd1**2*f*k1**2*s**2 - 66*D1**2*K*Pkdd2*bd1**2*f*k1**2*s + 33*D1**2*K*Pkdd2*bd1*f**2*k1**2*s**2 + 2772*D1**2*Pk2*bd1**2*f**2*r**2 + 2772*D1**2*Pk2*bd1**2*f**2*r*s - 4158*D1**2*Pk2*bd1**2*f**2*r - 1386*D1**2*Pk2*bd1**2*f**2*s + 1386*D1**2*Pk2*bd1**2*f**2 + 2640*D1**2*Pk2*bd1**2*f*r**2 + 4092*D1**2*Pk2*bd1**2*f*r*s - 3894*D1**2*Pk2*bd1**2*f*r + 528*D1**2*Pk2*bd1**2*f*s**2 - 1914*D1**2*Pk2*bd1**2*f*s + 1386*D1**2*Pk2*bd1**2*f - 7392*D1**2*Pk2*bd1**2*g2*r**2 - 14784*D1**2*Pk2*bd1**2*g2*r*s + 7392*D1**2*Pk2*bd1**2*g2*r - 7392*D1**2*Pk2*bd1**2*g2*s**2 + 7392*D1**2*Pk2*bd1**2*g2*s - 4620*D1**2*Pk2*bd1*bd2*f*r**2 - 9240*D1**2*Pk2*bd1*bd2*f*r*s + 9240*D1**2*Pk2*bd1*bd2*f*r - 4620*D1**2*Pk2*bd1*bd2*f*s**2 + 9240*D1**2*Pk2*bd1*bd2*f*s - 4620*D1**2*Pk2*bd1*bd2*f - 528*D1**2*Pk2*bd1*f**2*r**2 - 66*D1**2*Pk2*bd1*f**2*r*s + 330*D1**2*Pk2*bd1*f**2*r + 198*D1**2*Pk2*bd1*f**2*s**2 - 792*D1**2*Pk2*bd1*f**2*s + 396*D1**2*Pk2*bd1*f**2 - 2640*D1**2*Pk2*bd1*f*fd*r**2 - 4488*D1**2*Pk2*bd1*f*fd*r*s + 3960*D1**2*Pk2*bd1*f*fd*r - 1320*D1**2*Pk2*bd1*f*fd*s**2 + 3102*D1**2*Pk2*bd1*f*fd*s - 1518*D1**2*Pk2*bd1*f*fd - 10164*D1**2*Pk2*bd1*f*g2*r**2 - 12936*D1**2*Pk2*bd1*f*g2*r*s + 11088*D1**2*Pk2*bd1*f*g2*r - 2772*D1**2*Pk2*bd1*f*g2*s**2 + 11088*D1**2*Pk2*bd1*f*g2*s - 5544*D1**2*Pk2*bd1*f*g2 + 14784*D1**2*Pk2*bd1*f*gd2*r**2 + 25872*D1**2*Pk2*bd1*f*gd2*r*s - 33264*D1**2*Pk2*bd1*f*gd2*r + 9240*D1**2*Pk2*bd1*f*gd2*s**2 - 31416*D1**2*Pk2*bd1*f*gd2*s + 18480*D1**2*Pk2*bd1*f*gd2 + 14784*D1**2*Pk2*bd1*fd*g2*r**2 + 25872*D1**2*Pk2*bd1*fd*g2*r*s - 12936*D1**2*Pk2*bd1*fd*g2*r + 9240*D1**2*Pk2*bd1*fd*g2*s**2 - 9240*D1**2*Pk2*bd1*fd*g2*s - 660*D1**2*Pk2*bdd1*f**2*r**2 - 1122*D1**2*Pk2*bdd1*f**2*r*s + 1518*D1**2*Pk2*bdd1*f**2*r - 330*D1**2*Pk2*bdd1*f**2*s**2 + 1320*D1**2*Pk2*bdd1*f**2*s - 660*D1**2*Pk2*bdd1*f**2 + 7392*D1**2*Pk2*bdd1*f*g2*r**2 + 12936*D1**2*Pk2*bdd1*f*g2*r*s - 18480*D1**2*Pk2*bdd1*f*g2*r + 4620*D1**2*Pk2*bdd1*f*g2*s**2 - 18480*D1**2*Pk2*bdd1*f*g2*s + 9240*D1**2*Pk2*bdd1*f*g2 + 210*D1**2*Pk2*f**2*fd*r**2 + 1188*D1**2*Pk2*f**2*fd*r*s - 536*D1**2*Pk2*f**2*fd*r + 1188*D1**2*Pk2*f**2*fd*s**2 - 1188*D1**2*Pk2*f**2*fd*s + 466*D1**2*Pk2*f**2*fd - 6*D1**2*Pk2*f**2*fdd*r**2 - 1188*D1**2*Pk2*f**2*fdd*r*s + 400*D1**2*Pk2*f**2*fdd*r - 1188*D1**2*Pk2*f**2*fdd*s**2 + 1188*D1**2*Pk2*f**2*fdd*s - 398*D1**2*Pk2*f**2*fdd - 924*D1**2*Pk2*f**2*gd2*r**2 - 5544*D1**2*Pk2*f**2*gd2*r*s + 1848*D1**2*Pk2*f**2*gd2*r - 5544*D1**2*Pk2*f**2*gd2*s**2 + 5544*D1**2*Pk2*f**2*gd2*s - 924*D1**2*Pk2*f**2*gd2 + 924*D1**2*Pk2*f**2*gdd2*r**2 + 5544*D1**2*Pk2*f**2*gdd2*r*s - 1848*D1**2*Pk2*f**2*gdd2*r + 5544*D1**2*Pk2*f**2*gdd2*s**2 - 5544*D1**2*Pk2*f**2*gdd2*s + 924*D1**2*Pk2*f**2*gdd2 - 12*D1**2*Pk2*f*fd**2*r**2 - 2376*D1**2*Pk2*f*fd**2*r*s + 800*D1**2*Pk2*f*fd**2*r - 2376*D1**2*Pk2*f*fd**2*s**2 + 2376*D1**2*Pk2*f*fd**2*s - 396*D1**2*Pk2*f*fd**2 - 1848*D1**2*Pk2*f*fd*g2*r**2 - 11088*D1**2*Pk2*f*fd*g2*r*s + 5544*D1**2*Pk2*f*fd*g2*r - 11088*D1**2*Pk2*f*fd*g2*s**2 + 11088*D1**2*Pk2*f*fd*g2*s - 5544*D1**2*Pk2*f*fd*g2 + 3696*D1**2*Pk2*f*fd*gd2*r**2 + 22176*D1**2*Pk2*f*fd*gd2*r*s - 9240*D1**2*Pk2*f*fd*gd2*r + 22176*D1**2*Pk2*f*fd*gd2*s**2 - 22176*D1**2*Pk2*f*fd*gd2*s + 5544*D1**2*Pk2*f*fd*gd2 + 1848*D1**2*Pk2*f*fdd*g2*r**2 + 11088*D1**2*Pk2*f*fdd*g2*r*s - 5544*D1**2*Pk2*f*fdd*g2*r + 11088*D1**2*Pk2*f*fdd*g2*s**2 - 11088*D1**2*Pk2*f*fdd*g2*s + 5544*D1**2*Pk2*f*fdd*g2 + 1848*D1**2*Pk2*fd**2*g2*r**2 + 11088*D1**2*Pk2*fd**2*g2*r*s - 5544*D1**2*Pk2*fd**2*g2*r + 11088*D1**2*Pk2*fd**2*g2*s**2 - 11088*D1**2*Pk2*fd**2*g2*s + 66*D1**2*Pkdd2*bd1*f**2*k1**2*s**2 - 132*D1**2*Pkdd2*bd1*f**2*k1**2*s + 66*D1**2*Pkdd2*bd1*f**2*k1**2 - 132*D1**2*Pkdd2*bd1*f*fd*k1**2*s**2 + 132*D1**2*Pkdd2*bd1*f*fd*k1**2*s + 132*D1**2*Pkdd2*bd1*f*g2*k1**2*s**2 - 264*D1**2*Pkdd2*bd1*f*g2*k1**2*s + 132*D1**2*Pkdd2*bd1*f*g2*k1**2 - 132*D1**2*Pkdd2*bd1*f*gd2*k1**2*s**2 + 132*D1**2*Pkdd2*bd1*f*gd2*k1**2*s - 132*D1**2*Pkdd2*bd1*fd*g2*k1**2*s**2 + 132*D1**2*Pkdd2*bd1*fd*g2*k1**2*s - 33*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 66*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 33*D1**2*Pkdd2*bdd1*f**2*k1**2 - 66*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 + 132*D1**2*Pkdd2*bdd1*f*g2*k1**2*s - 66*D1**2*Pkdd2*bdd1*f*g2*k1**2 - 99*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 66*D1**2*Pkdd2*f**2*fd*k1**2*s - 33*D1**2*Pkdd2*f**2*fd*k1**2 - 66*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 - 132*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 + 132*D1**2*Pkdd2*f*fd*g2*k1**2*s - 66*D1**2*Pkdd2*f*fd*g2*k1**2 - 3696*D1*Dd*K*Pk2*bd1*f**2*r**2 - 22176*D1*Dd*K*Pk2*bd1*f**2*r*s + 8316*D1*Dd*K*Pk2*bd1*f**2*r - 22176*D1*Dd*K*Pk2*bd1*f**2*s**2 + 22176*D1*Dd*K*Pk2*bd1*f**2*s - 4620*D1*Dd*K*Pk2*bd1*f**2 - 5280*D1*Dd*Pk2*bd1*f**2*r**2 - 8976*D1*Dd*Pk2*bd1*f**2*r*s + 9834*D1*Dd*Pk2*bd1*f**2*r - 2640*D1*Dd*Pk2*bd1*f**2*s**2 + 8184*D1*Dd*Pk2*bd1*f**2*s - 4356*D1*Dd*Pk2*bd1*f**2 + 59136*D1*Dd*Pk2*bd1*f*g2*r**2 + 103488*D1*Dd*Pk2*bd1*f*g2*r*s - 116424*D1*Dd*Pk2*bd1*f*g2*r + 36960*D1*Dd*Pk2*bd1*f*g2*s**2 - 109032*D1*Dd*Pk2*bd1*f*g2*s + 55440*D1*Dd*Pk2*bd1*f*g2 + 280*D1*Dd*Pk2*f**3*r**2 + 1584*D1*Dd*Pk2*f**3*r*s - 676*D1*Dd*Pk2*f**3*r + 1584*D1*Dd*Pk2*f**3*s**2 - 1584*D1*Dd*Pk2*f**3*s + 536*D1*Dd*Pk2*f**3 - 48*D1*Dd*Pk2*f**2*fd*r**2 - 9504*D1*Dd*Pk2*f**2*fd*r*s + 2812*D1*Dd*Pk2*f**2*fd*r - 9504*D1*Dd*Pk2*f**2*fd*s**2 + 9504*D1*Dd*Pk2*f**2*fd*s - 1988*D1*Dd*Pk2*f**2*fd - 3696*D1*Dd*Pk2*f**2*g2*r**2 - 22176*D1*Dd*Pk2*f**2*g2*r*s + 9240*D1*Dd*Pk2*f**2*g2*r - 22176*D1*Dd*Pk2*f**2*g2*s**2 + 22176*D1*Dd*Pk2*f**2*g2*s - 7392*D1*Dd*Pk2*f**2*g2 + 7392*D1*Dd*Pk2*f**2*gd2*r**2 + 44352*D1*Dd*Pk2*f**2*gd2*r*s - 16632*D1*Dd*Pk2*f**2*gd2*r + 44352*D1*Dd*Pk2*f**2*gd2*s**2 - 44352*D1*Dd*Pk2*f**2*gd2*s + 9240*D1*Dd*Pk2*f**2*gd2 + 14784*D1*Dd*Pk2*f*fd*g2*r**2 + 88704*D1*Dd*Pk2*f*fd*g2*r*s - 40656*D1*Dd*Pk2*f*fd*g2*r + 88704*D1*Dd*Pk2*f*fd*g2*s**2 - 88704*D1*Dd*Pk2*f*fd*g2*s + 22176*D1*Dd*Pk2*f*fd*g2 - 264*D1*Dd*Pkdd2*bd1*f**2*k1**2*s**2 + 330*D1*Dd*Pkdd2*bd1*f**2*k1**2*s - 66*D1*Dd*Pkdd2*bd1*f**2*k1**2 - 528*D1*Dd*Pkdd2*bd1*f*g2*k1**2*s**2 + 660*D1*Dd*Pkdd2*bd1*f*g2*k1**2*s - 132*D1*Dd*Pkdd2*bd1*f*g2*k1**2 - 132*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 66*D1*Dd*Pkdd2*f**3*k1**2*s - 33*D1*Dd*Pkdd2*f**3*k1**2 - 264*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 + 132*D1*Dd*Pkdd2*f**2*g2*k1**2*s - 66*D1*Dd*Pkdd2*f**2*g2*k1**2 - 8*D1*Ddd*Pk2*f**3*r**2 - 1584*D1*Ddd*Pk2*f**3*r*s + 404*D1*Ddd*Pk2*f**3*r - 1584*D1*Ddd*Pk2*f**3*s**2 + 1584*D1*Ddd*Pk2*f**3*s - 400*D1*Ddd*Pk2*f**3 + 3696*D1*Ddd*Pk2*f**2*g2*r**2 + 22176*D1*Ddd*Pk2*f**2*g2*r*s - 9240*D1*Ddd*Pk2*f**2*g2*r + 22176*D1*Ddd*Pk2*f**2*g2*s**2 - 22176*D1*Ddd*Pk2*f**2*g2*s + 7392*D1*Ddd*Pk2*f**2*g2 + 462*D1*Pk2*b2*(-5*D1*bdd1*f*(r + s - 1) + bd1*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)))*(r + s - 1) - 24*Dd**2*Pk2*f**3*r**2 - 4752*Dd**2*Pk2*f**3*r*s + 1212*Dd**2*Pk2*f**3*r - 4752*Dd**2*Pk2*f**3*s**2 + 4752*Dd**2*Pk2*f**3*s - 796*Dd**2*Pk2*f**3 + 11088*Dd**2*Pk2*f**2*g2*r**2 + 66528*Dd**2*Pk2*f**2*g2*r*s - 27720*Dd**2*Pk2*f**2*g2*r + 66528*Dd**2*Pk2*f**2*g2*s**2 - 66528*Dd**2*Pk2*f**2*g2*s + 12936*Dd**2*Pk2*f**2*g2 + 924*Pk2*b1**3*(D1**2*(fd - fdd)*(r - 1)*(r + s - 1) + D1*(Dd*(-4*K*(4*r**2 + r*(8*s - 6) + 4*s**2 - 6*s + 3) + f*(4*r**2 + r*(4*s - 5) - 2*s + 2) + fd*(-8*r**2 + r*(13 - 8*s) + 6*s - 5) + 8*r**2 + 8*r*s - 10*r - 4*s + 4) + Ddd*(2*K*(4*r**2 + 8*r*s - 6*r + 4*s**2 - 6*s + 3) + f*(-4*r**2 - 4*r*s + 5*r + 2*s - 2) - 4*r**2 - 4*r*s + 5*r + 2*s - 2)) + Dd**2*(12*K*(2*r**2 + 4*r*s - 3*r + 2*s**2 - 3*s + 1) + f*(-12*r**2 - 3*r*(4*s - 5) + 6*s - 4) - 12*r**2 - 12*r*s + 15*r + 6*s - 4)) + 33*b1**2*(32*C*D1**2*Pk2*fd*r**2 + 64*C*D1**2*Pk2*fd*r*s - 64*C*D1**2*Pk2*fd*r + 32*C*D1**2*Pk2*fd*s**2 - 64*C*D1**2*Pk2*fd*s + 32*C*D1**2*Pk2*fd - 16*C*D1**2*Pk2*fdd*r**2 - 32*C*D1**2*Pk2*fdd*r*s + 32*C*D1**2*Pk2*fdd*r - 16*C*D1**2*Pk2*fdd*s**2 + 32*C*D1**2*Pk2*fdd*s - 16*C*D1**2*Pk2*fdd + 128*C*D1*Dd*Pk2*f*r**2 + 256*C*D1*Dd*Pk2*f*r*s - 192*C*D1*Dd*Pk2*f*r + 128*C*D1*Dd*Pk2*f*s**2 - 192*C*D1*Dd*Pk2*f*s + 96*C*D1*Dd*Pk2*f - 128*C*D1*Dd*Pk2*fd*r**2 - 256*C*D1*Dd*Pk2*fd*r*s + 224*C*D1*Dd*Pk2*fd*r - 128*C*D1*Dd*Pk2*fd*s**2 + 224*C*D1*Dd*Pk2*fd*s - 96*C*D1*Dd*Pk2*fd - 64*C*D1*Ddd*Pk2*f*r**2 - 128*C*D1*Ddd*Pk2*f*r*s + 96*C*D1*Ddd*Pk2*f*r - 64*C*D1*Ddd*Pk2*f*s**2 + 96*C*D1*Ddd*Pk2*f*s - 48*C*D1*Ddd*Pk2*f - 192*C*Dd**2*Pk2*f*r**2 - 384*C*Dd**2*Pk2*f*r*s + 288*C*Dd**2*Pk2*f*r - 192*C*Dd**2*Pk2*f*s**2 + 288*C*Dd**2*Pk2*f*s - 96*C*Dd**2*Pk2*f + 154*D1**2*K*Pk2*fd*r**2 + 196*D1**2*K*Pk2*fd*r*s - 28*D1**2*K*Pk2*fd*r + 42*D1**2*K*Pk2*fd*s**2 + 84*D1**2*K*Pk2*fd*s - 42*D1**2*K*Pk2*fd - 112*D1**2*K*Pk2*fdd*r**2 - 196*D1**2*K*Pk2*fdd*r*s - 84*D1**2*K*Pk2*fdd*r - 70*D1**2*K*Pk2*fdd*s**2 - 140*D1**2*K*Pk2*fdd*s + 70*D1**2*K*Pk2*fdd - 2*D1**2*K*Pkdd2*fd*k1**2*s**2 + D1**2*K*Pkdd2*fdd*k1**2*s**2 + 28*D1**2*Pk2*bdd1*(2*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 2) + f*(-3*r**2 - 3*r*(s - 1) + s - 1) - 3*r**2 - 3*r*s + 3*r + s - 1) - 84*D1**2*Pk2*f*fd*r**2 - 84*D1**2*Pk2*f*fd*r*s + 84*D1**2*Pk2*f*fd*r + 42*D1**2*Pk2*f*fd*s - 42*D1**2*Pk2*f*fd + 84*D1**2*Pk2*f*fdd*r**2 + 84*D1**2*Pk2*f*fdd*r*s - 84*D1**2*Pk2*f*fdd*r - 42*D1**2*Pk2*f*fdd*s + 42*D1**2*Pk2*f*fdd + 84*D1**2*Pk2*fd**2*r**2 + 84*D1**2*Pk2*fd**2*r*s - 84*D1**2*Pk2*fd**2*r - 42*D1**2*Pk2*fd**2*s - 38*D1**2*Pk2*fd*r**2 - 54*D1**2*Pk2*fd*r*s + 76*D1**2*Pk2*fd*r - 16*D1**2*Pk2*fd*s**2 + 40*D1**2*Pk2*fd*s - 24*D1**2*Pk2*fd + 40*D1**2*Pk2*fdd*r**2 + 62*D1**2*Pk2*fdd*r*s - 24*D1**2*Pk2*fdd*r + 8*D1**2*Pk2*fdd*s**2 - 20*D1**2*Pk2*fdd*s + 12*D1**2*Pk2*fdd + 224*D1**2*Pk2*gd2*r**2 + 448*D1**2*Pk2*gd2*r*s - 448*D1**2*Pk2*gd2*r + 224*D1**2*Pk2*gd2*s**2 - 448*D1**2*Pk2*gd2*s + 224*D1**2*Pk2*gd2 - 112*D1**2*Pk2*gdd2*r**2 - 224*D1**2*Pk2*gdd2*r*s + 224*D1**2*Pk2*gdd2*r - 112*D1**2*Pk2*gdd2*s**2 + 224*D1**2*Pk2*gdd2*s - 112*D1**2*Pk2*gdd2 - 6*D1**2*Pkdd2*f*fd*k1**2*s**2 + 616*D1*Dd*K*Pk2*f*r**2 + 784*D1*Dd*K*Pk2*f*r*s - 812*D1*Dd*K*Pk2*f*r + 168*D1*Dd*K*Pk2*f*s**2 - 476*D1*Dd*K*Pk2*f*s + 350*D1*Dd*K*Pk2*f - 896*D1*Dd*K*Pk2*fd*r**2 - 1568*D1*Dd*K*Pk2*fd*r*s + 308*D1*Dd*K*Pk2*fd*r - 560*D1*Dd*K*Pk2*fd*s**2 - 28*D1*Dd*K*Pk2*fd*s + 308*D1*Dd*K*Pk2*fd - 8*D1*Dd*K*Pkdd2*f*k1**2*s**2 + 4*D1*Dd*K*Pkdd2*f*k1**2*s - 2*D1*Dd*K*Pkdd2*f*k1**2 + 8*D1*Dd*K*Pkdd2*fd*k1**2*s**2 - 2*D1*Dd*K*Pkdd2*fd*k1**2*s - 168*D1*Dd*Pk2*f**2*r**2 - 168*D1*Dd*Pk2*f**2*r*s + 210*D1*Dd*Pk2*f**2*r + 84*D1*Dd*Pk2*f**2*s - 84*D1*Dd*Pk2*f**2 + 672*D1*Dd*Pk2*f*fd*r**2 + 672*D1*Dd*Pk2*f*fd*r*s - 756*D1*Dd*Pk2*f*fd*r - 336*D1*Dd*Pk2*f*fd*s + 210*D1*Dd*Pk2*f*fd - 152*D1*Dd*Pk2*f*r**2 - 216*D1*Dd*Pk2*f*r*s + 206*D1*Dd*Pk2*f*r - 64*D1*Dd*Pk2*f*s**2 + 140*D1*Dd*Pk2*f*s - 92*D1*Dd*Pk2*f + 320*D1*Dd*Pk2*fd*r**2 + 496*D1*Dd*Pk2*fd*r*s - 318*D1*Dd*Pk2*fd*r + 64*D1*Dd*Pk2*fd*s**2 - 220*D1*Dd*Pk2*fd*s + 68*D1*Dd*Pk2*fd + 896*D1*Dd*Pk2*g2*r**2 + 1792*D1*Dd*Pk2*g2*r*s - 1344*D1*Dd*Pk2*g2*r + 896*D1*Dd*Pk2*g2*s**2 - 1344*D1*Dd*Pk2*g2*s + 672*D1*Dd*Pk2*g2 - 896*D1*Dd*Pk2*gd2*r**2 - 1792*D1*Dd*Pk2*gd2*r*s + 1568*D1*Dd*Pk2*gd2*r - 896*D1*Dd*Pk2*gd2*s**2 + 1568*D1*Dd*Pk2*gd2*s - 672*D1*Dd*Pk2*gd2 - 12*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 6*D1*Dd*Pkdd2*f**2*k1**2*s - 3*D1*Dd*Pkdd2*f**2*k1**2 - 448*D1*Ddd*K*Pk2*f*r**2 - 784*D1*Ddd*K*Pk2*f*r*s + 644*D1*Ddd*K*Pk2*f*r - 280*D1*Ddd*K*Pk2*f*s**2 + 532*D1*Ddd*K*Pk2*f*s - 294*D1*Ddd*K*Pk2*f + 4*D1*Ddd*K*Pkdd2*f*k1**2*s**2 - 2*D1*Ddd*K*Pkdd2*f*k1**2*s + D1*Ddd*K*Pkdd2*f*k1**2 + 168*D1*Ddd*Pk2*f**2*r**2 + 168*D1*Ddd*Pk2*f**2*r*s - 210*D1*Ddd*Pk2*f**2*r - 84*D1*Ddd*Pk2*f**2*s + 84*D1*Ddd*Pk2*f**2 + 160*D1*Ddd*Pk2*f*r**2 + 248*D1*Ddd*Pk2*f*r*s - 222*D1*Ddd*Pk2*f*r + 32*D1*Ddd*Pk2*f*s**2 - 140*D1*Ddd*Pk2*f*s + 88*D1*Ddd*Pk2*f - 448*D1*Ddd*Pk2*g2*r**2 - 896*D1*Ddd*Pk2*g2*r*s + 672*D1*Ddd*Pk2*g2*r - 448*D1*Ddd*Pk2*g2*s**2 + 672*D1*Ddd*Pk2*g2*s - 336*D1*Ddd*Pk2*g2 + 28*D1*Pk2*bd1*(D1*(-4*K*(3*r**2 + r*(6*s - 4) + 3*s**2 - 4*s + 2) + f*(3*r**2 + 3*r*(s - 1) - s + 1) + fd*(-6*r**2 + r*(9 - 6*s) + 4*s - 3) + 6*r**2 + 6*r*s - 6*r - 2*s + 2) + Dd*(4*K*(12*r**2 + 24*r*s - 17*r + 12*s**2 - 17*s + 6) + f*(-24*r**2 - 3*r*(8*s - 9) + 10*s - 7) - 24*r**2 - 24*r*s + 27*r + 10*s - 7)) - 1344*Dd**2*K*Pk2*f*r**2 - 2352*Dd**2*K*Pk2*f*r*s + 1932*Dd**2*K*Pk2*f*r - 840*Dd**2*K*Pk2*f*s**2 + 1596*Dd**2*K*Pk2*f*s - 616*Dd**2*K*Pk2*f + 12*Dd**2*K*Pkdd2*f*k1**2*s**2 - 6*Dd**2*K*Pkdd2*f*k1**2*s + 504*Dd**2*Pk2*f**2*r**2 + 504*Dd**2*Pk2*f**2*r*s - 630*Dd**2*Pk2*f**2*r - 252*Dd**2*Pk2*f**2*s + 168*Dd**2*Pk2*f**2 + 480*Dd**2*Pk2*f*r**2 + 744*Dd**2*Pk2*f*r*s - 666*Dd**2*Pk2*f*r + 96*Dd**2*Pk2*f*s**2 - 420*Dd**2*Pk2*f*s + 204*Dd**2*Pk2*f - 1344*Dd**2*Pk2*g2*r**2 - 2688*Dd**2*Pk2*g2*r*s + 2016*Dd**2*Pk2*g2*r - 1344*Dd**2*Pk2*g2*s**2 + 2016*Dd**2*Pk2*g2*s - 672*Dd**2*Pk2*g2) - 33*b1*(32*C*D1**2*Pk2*bdd1*f*r**2 + 64*C*D1**2*Pk2*bdd1*f*r*s - 32*C*D1**2*Pk2*bdd1*f*r + 32*C*D1**2*Pk2*bdd1*f*s**2 - 32*C*D1**2*Pk2*bdd1*f*s + 16*C*D1**2*Pk2*bdd1*f - 40*C*D1**2*Pk2*f*fd*r**2 - 16*C*D1**2*Pk2*f*fd*r*s + 32*C*D1**2*Pk2*f*fd*r + 24*C*D1**2*Pk2*f*fd*s**2 + 32*C*D1**2*Pk2*f*fd*s - 32*C*D1**2*Pk2*f*fd - 64*C*D1**2*Pk2*f*fdd*r**2 - 112*C*D1**2*Pk2*f*fdd*r*s + 40*C*D1**2*Pk2*f*fdd*r - 40*C*D1**2*Pk2*f*fdd*s**2 + 16*C*D1**2*Pk2*f*fdd*s - 12*C*D1**2*Pk2*f*fdd - 64*C*D1**2*Pk2*fd**2*r**2 - 112*C*D1**2*Pk2*fd**2*r*s + 40*C*D1**2*Pk2*fd**2*r - 40*C*D1**2*Pk2*fd**2*s**2 + 16*C*D1**2*Pk2*fd**2*s + 24*C*D1**2*Pk2*fd**2 + 8*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 4*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 4*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 80*C*D1*Dd*Pk2*f**2*r**2 - 32*C*D1*Dd*Pk2*f**2*r*s + 88*C*D1*Dd*Pk2*f**2*r + 48*C*D1*Dd*Pk2*f**2*s**2 - 8*C*D1*Dd*Pk2*f**2*s - 28*C*D1*Dd*Pk2*f**2 - 512*C*D1*Dd*Pk2*f*fd*r**2 - 896*C*D1*Dd*Pk2*f*fd*r*s + 528*C*D1*Dd*Pk2*f*fd*r - 320*C*D1*Dd*Pk2*f*fd*s**2 + 368*C*D1*Dd*Pk2*f*fd*s - 96*C*D1*Dd*Pk2*f*fd + 16*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 8*C*D1*Dd*Pkdd2*f**2*k1**2*s + 4*C*D1*Dd*Pkdd2*f**2*k1**2 - 32*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 8*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 128*C*D1*Ddd*Pk2*f**2*r**2 - 224*C*D1*Ddd*Pk2*f**2*r*s + 184*C*D1*Ddd*Pk2*f**2*r - 80*C*D1*Ddd*Pk2*f**2*s**2 + 152*C*D1*Ddd*Pk2*f**2*s - 84*C*D1*Ddd*Pk2*f**2 - 8*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 4*C*D1*Ddd*Pkdd2*f**2*k1**2*s - 2*C*D1*Ddd*Pkdd2*f**2*k1**2 - 384*C*Dd**2*Pk2*f**2*r**2 - 672*C*Dd**2*Pk2*f**2*r*s + 552*C*Dd**2*Pk2*f**2*r - 240*C*Dd**2*Pk2*f**2*s**2 + 456*C*Dd**2*Pk2*f**2*s - 176*C*Dd**2*Pk2*f**2 - 24*C*Dd**2*Pkdd2*f**2*k1**2*s**2 + 12*C*Dd**2*Pkdd2*f**2*k1**2*s + 224*D1**2*K*Pk2*bdd1*f*r**2 + 392*D1**2*K*Pk2*bdd1*f*r*s - 504*D1**2*K*Pk2*bdd1*f*r + 140*D1**2*K*Pk2*bdd1*f*s**2 - 476*D1**2*K*Pk2*bdd1*f*s + 252*D1**2*K*Pk2*bdd1*f - 28*D1**2*K*Pk2*f*fd*r**2 - 168*D1**2*K*Pk2*f*fd*r*s + 84*D1**2*K*Pk2*f*fd*r - 168*D1**2*K*Pk2*f*fd*s**2 + 168*D1**2*K*Pk2*f*fd*s - 84*D1**2*K*Pk2*f*fd + 28*D1**2*K*Pk2*f*fdd*r**2 + 168*D1**2*K*Pk2*f*fdd*r*s - 84*D1**2*K*Pk2*f*fdd*r + 168*D1**2*K*Pk2*f*fdd*s**2 - 168*D1**2*K*Pk2*f*fdd*s + 84*D1**2*K*Pk2*f*fdd + 28*D1**2*K*Pk2*fd**2*r**2 + 168*D1**2*K*Pk2*fd**2*r*s - 84*D1**2*K*Pk2*fd**2*r + 168*D1**2*K*Pk2*fd**2*s**2 - 168*D1**2*K*Pk2*fd**2*s - 2*D1**2*K*Pkdd2*bdd1*f*k1**2*s**2 + 2*D1**2*K*Pkdd2*bdd1*f*k1**2*s - D1**2*K*Pkdd2*bdd1*f*k1**2 - 2*D1**2*K*Pkdd2*f*fd*k1**2*s**2 + 2*D1**2*K*Pkdd2*f*fd*k1**2*s - D1**2*K*Pkdd2*f*fd*k1**2 - 42*D1**2*Pk2*b2*fd*r**2 - 84*D1**2*Pk2*b2*fd*r*s - 42*D1**2*Pk2*b2*fd*s**2 + 70*D1**2*Pk2*b2*fdd*r**2 + 140*D1**2*Pk2*b2*fdd*r*s + 70*D1**2*Pk2*b2*fdd*s**2 + 28*D1**2*Pk2*bd1**2*(-4*K*(3*r**2 + 6*r*s - 4*r + 3*s**2 - 4*s + 1) + f*(6*r**2 + 6*r*(s - 1) - 2*s + 1) + 6*r**2 + 6*r*s - 6*r - 2*s + 1) - 84*D1**2*Pk2*bdd1*f**2*r**2 - 84*D1**2*Pk2*bdd1*f**2*r*s + 126*D1**2*Pk2*bdd1*f**2*r + 42*D1**2*Pk2*bdd1*f**2*s - 42*D1**2*Pk2*bdd1*f**2 - 80*D1**2*Pk2*bdd1*f*r**2 - 124*D1**2*Pk2*bdd1*f*r*s + 118*D1**2*Pk2*bdd1*f*r - 16*D1**2*Pk2*bdd1*f*s**2 + 58*D1**2*Pk2*bdd1*f*s - 36*D1**2*Pk2*bdd1*f + 224*D1**2*Pk2*bdd1*g2*r**2 + 448*D1**2*Pk2*bdd1*g2*r*s - 224*D1**2*Pk2*bdd1*g2*r + 224*D1**2*Pk2*bdd1*g2*s**2 - 224*D1**2*Pk2*bdd1*g2*s + 112*D1**2*Pk2*bdd1*g2 + 70*D1**2*Pk2*bdd2*f*r**2 + 140*D1**2*Pk2*bdd2*f*r*s - 140*D1**2*Pk2*bdd2*f*r + 70*D1**2*Pk2*bdd2*f*s**2 - 140*D1**2*Pk2*bdd2*f*s + 70*D1**2*Pk2*bdd2*f + 32*D1**2*Pk2*f*fd*r**2 + 4*D1**2*Pk2*f*fd*r*s - 24*D1**2*Pk2*f*fd*r - 12*D1**2*Pk2*f*fd*s**2 - 14*D1**2*Pk2*f*fd*s + 22*D1**2*Pk2*f*fd + 40*D1**2*Pk2*f*fdd*r**2 + 68*D1**2*Pk2*f*fdd*r*s - 28*D1**2*Pk2*f*fdd*r + 20*D1**2*Pk2*f*fdd*s**2 - 14*D1**2*Pk2*f*fdd*s + 10*D1**2*Pk2*f*fdd + 308*D1**2*Pk2*f*gd2*r**2 + 392*D1**2*Pk2*f*gd2*r*s - 616*D1**2*Pk2*f*gd2*r + 84*D1**2*Pk2*f*gd2*s**2 - 392*D1**2*Pk2*f*gd2*s + 308*D1**2*Pk2*f*gd2 - 224*D1**2*Pk2*f*gdd2*r**2 - 392*D1**2*Pk2*f*gdd2*r*s + 448*D1**2*Pk2*f*gdd2*r - 140*D1**2*Pk2*f*gdd2*s**2 + 392*D1**2*Pk2*f*gdd2*s - 224*D1**2*Pk2*f*gdd2 + 40*D1**2*Pk2*fd**2*r**2 + 68*D1**2*Pk2*fd**2*r*s - 28*D1**2*Pk2*fd**2*r + 20*D1**2*Pk2*fd**2*s**2 - 14*D1**2*Pk2*fd**2*s - 12*D1**2*Pk2*fd**2 + 308*D1**2*Pk2*fd*g2*r**2 + 392*D1**2*Pk2*fd*g2*r*s - 56*D1**2*Pk2*fd*g2*r + 84*D1**2*Pk2*fd*g2*s**2 + 168*D1**2*Pk2*fd*g2*s - 84*D1**2*Pk2*fd*g2 - 448*D1**2*Pk2*fd*gd2*r**2 - 784*D1**2*Pk2*fd*gd2*r*s + 280*D1**2*Pk2*fd*gd2*r - 280*D1**2*Pk2*fd*gd2*s**2 + 112*D1**2*Pk2*fd*gd2*s + 168*D1**2*Pk2*fd*gd2 - 224*D1**2*Pk2*fdd*g2*r**2 - 392*D1**2*Pk2*fdd*g2*r*s - 168*D1**2*Pk2*fdd*g2*r - 140*D1**2*Pk2*fdd*g2*s**2 - 280*D1**2*Pk2*fdd*g2*s + 140*D1**2*Pk2*fdd*g2 - 4*D1**2*Pkdd2*f*fd*k1**2*s**2 + 2*D1**2*Pkdd2*f*fdd*k1**2*s**2 - 4*D1**2*Pkdd2*f*gd2*k1**2*s**2 + 2*D1**2*Pkdd2*f*gdd2*k1**2*s**2 + 2*D1**2*Pkdd2*fd**2*k1**2*s**2 - 4*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 4*D1**2*Pkdd2*fd*gd2*k1**2*s**2 + 2*D1**2*Pkdd2*fdd*g2*k1**2*s**2 - 56*D1*Dd*K*Pk2*f**2*r**2 - 336*D1*Dd*K*Pk2*f**2*r*s + 140*D1*Dd*K*Pk2*f**2*r - 336*D1*Dd*K*Pk2*f**2*s**2 + 336*D1*Dd*K*Pk2*f**2*s - 112*D1*Dd*K*Pk2*f**2 + 224*D1*Dd*K*Pk2*f*fd*r**2 + 1344*D1*Dd*K*Pk2*f*fd*r*s - 616*D1*Dd*K*Pk2*f*fd*r + 1344*D1*Dd*K*Pk2*f*fd*s**2 - 1344*D1*Dd*K*Pk2*f*fd*s + 336*D1*Dd*K*Pk2*f*fd - 4*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 + 2*D1*Dd*K*Pkdd2*f**2*k1**2*s - D1*Dd*K*Pkdd2*f**2*k1**2 - 168*D1*Dd*Pk2*b2*f*r**2 - 336*D1*Dd*Pk2*b2*f*r*s + 252*D1*Dd*Pk2*b2*f*r - 168*D1*Dd*Pk2*b2*f*s**2 + 252*D1*Dd*Pk2*b2*f*s - 126*D1*Dd*Pk2*b2*f + 560*D1*Dd*Pk2*b2*fd*r**2 + 1120*D1*Dd*Pk2*b2*fd*r*s - 420*D1*Dd*Pk2*b2*fd*r + 560*D1*Dd*Pk2*b2*fd*s**2 - 420*D1*Dd*Pk2*b2*fd*s + 64*D1*Dd*Pk2*f**2*r**2 + 8*D1*Dd*Pk2*f**2*r*s - 66*D1*Dd*Pk2*f**2*r - 24*D1*Dd*Pk2*f**2*s**2 + 8*D1*Dd*Pk2*f**2*s + 26*D1*Dd*Pk2*f**2 + 320*D1*Dd*Pk2*f*fd*r**2 + 544*D1*Dd*Pk2*f*fd*r*s - 340*D1*Dd*Pk2*f*fd*r + 160*D1*Dd*Pk2*f*fd*s**2 - 232*D1*Dd*Pk2*f*fd*s + 70*D1*Dd*Pk2*f*fd + 1232*D1*Dd*Pk2*f*g2*r**2 + 1568*D1*Dd*Pk2*f*g2*r*s - 1624*D1*Dd*Pk2*f*g2*r + 336*D1*Dd*Pk2*f*g2*s**2 - 952*D1*Dd*Pk2*f*g2*s + 700*D1*Dd*Pk2*f*g2 - 1792*D1*Dd*Pk2*f*gd2*r**2 - 3136*D1*Dd*Pk2*f*gd2*r*s + 3080*D1*Dd*Pk2*f*gd2*r - 1120*D1*Dd*Pk2*f*gd2*s**2 + 2632*D1*Dd*Pk2*f*gd2*s - 1288*D1*Dd*Pk2*f*gd2 - 1792*D1*Dd*Pk2*fd*g2*r**2 - 3136*D1*Dd*Pk2*fd*g2*r*s + 616*D1*Dd*Pk2*fd*g2*r - 1120*D1*Dd*Pk2*fd*g2*s**2 - 56*D1*Dd*Pk2*fd*g2*s + 616*D1*Dd*Pk2*fd*g2 - 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 4*D1*Dd*Pkdd2*f**2*k1**2*s - 2*D1*Dd*Pkdd2*f**2*k1**2 + 16*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 4*D1*Dd*Pkdd2*f*fd*k1**2*s - 16*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 8*D1*Dd*Pkdd2*f*g2*k1**2*s - 4*D1*Dd*Pkdd2*f*g2*k1**2 + 16*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 - 4*D1*Dd*Pkdd2*f*gd2*k1**2*s + 16*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 - 4*D1*Dd*Pkdd2*fd*g2*k1**2*s + 56*D1*Ddd*K*Pk2*f**2*r**2 + 336*D1*Ddd*K*Pk2*f**2*r*s - 140*D1*Ddd*K*Pk2*f**2*r + 336*D1*Ddd*K*Pk2*f**2*s**2 - 336*D1*Ddd*K*Pk2*f**2*s + 112*D1*Ddd*K*Pk2*f**2 + 280*D1*Ddd*Pk2*b2*f*r**2 + 560*D1*Ddd*Pk2*b2*f*r*s - 420*D1*Ddd*Pk2*b2*f*r + 280*D1*Ddd*Pk2*b2*f*s**2 - 420*D1*Ddd*Pk2*b2*f*s + 210*D1*Ddd*Pk2*b2*f + 80*D1*Ddd*Pk2*f**2*r**2 + 136*D1*Ddd*Pk2*f**2*r*s - 114*D1*Ddd*Pk2*f**2*r + 40*D1*Ddd*Pk2*f**2*s**2 - 88*D1*Ddd*Pk2*f**2*s + 50*D1*Ddd*Pk2*f**2 - 896*D1*Ddd*Pk2*f*g2*r**2 - 1568*D1*Ddd*Pk2*f*g2*r*s + 1288*D1*Ddd*Pk2*f*g2*r - 560*D1*Ddd*Pk2*f*g2*s**2 + 1064*D1*Ddd*Pk2*f*g2*s - 588*D1*Ddd*Pk2*f*g2 + 4*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 2*D1*Ddd*Pkdd2*f**2*k1**2*s + D1*Ddd*Pkdd2*f**2*k1**2 + 8*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 - 4*D1*Ddd*Pkdd2*f*g2*k1**2*s + 2*D1*Ddd*Pkdd2*f*g2*k1**2 - 14*D1*Pk2*bd2*(r + s - 1)*(3*D1*f*(r + s - 1) - 10*D1*fd*(r + s) - 10*Dd*f*(4*r + 4*s - 3)) + D1*bd1*(D1*(2*K*Pkdd2*fd*k1**2*s*(1 - 2*s) + 2*Pk2*fd*(16*C*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 14*K*(16*r**2 + 4*r*(7*s - 3) + 10*s**2 - 7*s - 3) - 80*r**2 - 124*r*s + 83*r - 16*s**2 + 49*s - 10) - 224*Pk2*g2*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 224*Pk2*gd2*(2*r**2 + r*(4*s - 3) + 2*s**2 - 3*s + 1) + 3*f**2*(14*Pk2*(2*r - 1)*(r + s - 1) + Pkdd2*k1**2*(2*s**2 - 2*s + 1)) - 2*f*(K*Pkdd2*k1**2*(-2*s**2 + 2*s - 1) + Pk2*(16*C*(2*r**2 + r*(4*s - 2) + 2*s**2 - 2*s + 1) + 154*K*r**2 + 196*K*r*s - 238*K*r + 42*K*s**2 - 182*K*s + 119*K + 21*fd*(2*r - 1)*(4*r + 4*s - 3) - 38*r**2 - 54*r*s + 27*r - 16*s**2 + 23*s - 15))) + 2*Dd*(-21*Pk2*f**2*(2*r - 1)*(8*r + 8*s - 7) + 112*Pk2*g2*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + f*(K*Pkdd2*k1**2*(-8*s**2 + 6*s - 1) + Pk2*(16*C*(8*r**2 + 2*r*(8*s - 5) + 8*s**2 - 10*s + 3) + 14*K*(64*r**2 + 2*r*(56*s - 59) + 40*s**2 - 106*s + 53) - 320*r**2 - 496*r*s + 458*r - 64*s**2 + 256*s - 147)))) + 168*Dd**2*K*Pk2*f**2*r**2 + 1008*Dd**2*K*Pk2*f**2*r*s - 420*Dd**2*K*Pk2*f**2*r + 1008*Dd**2*K*Pk2*f**2*s**2 - 1008*Dd**2*K*Pk2*f**2*s + 196*Dd**2*K*Pk2*f**2 + 840*Dd**2*Pk2*b2*f*r**2 + 1680*Dd**2*Pk2*b2*f*r*s - 1260*Dd**2*Pk2*b2*f*r + 840*Dd**2*Pk2*b2*f*s**2 - 1260*Dd**2*Pk2*b2*f*s + 420*Dd**2*Pk2*b2*f + 240*Dd**2*Pk2*f**2*r**2 + 408*Dd**2*Pk2*f**2*r*s - 342*Dd**2*Pk2*f**2*r + 120*Dd**2*Pk2*f**2*s**2 - 264*Dd**2*Pk2*f**2*s + 108*Dd**2*Pk2*f**2 - 2688*Dd**2*Pk2*f*g2*r**2 - 4704*Dd**2*Pk2*f*g2*r*s + 3864*Dd**2*Pk2*f*g2*r - 1680*Dd**2*Pk2*f*g2*s**2 + 3192*Dd**2*Pk2*f*g2*s - 1232*Dd**2*Pk2*f*g2 + 12*Dd**2*Pkdd2*f**2*k1**2*s**2 - 6*Dd**2*Pkdd2*f**2*k1**2*s + 24*Dd**2*Pkdd2*f*g2*k1**2*s**2 - 12*Dd**2*Pkdd2*f*g2*k1**2*s))/(1386*d**2*k3**4) + D1**2*Pk3*k2**2*(-2*D1*f*(2*D1*Pk2*bd1**2*(2*C - 1)*(11*r**2 + 9*r*(2*s - 1) + s*(7*s - 7)) - D1*Pk2*bdd1*f*(2*C - 1)*(8*r**2 + 18*r*(s - 1) + 7*(s - 1)**2) + bd1*(D1*(-Pk2*fd*(4*C - 2)*(16*r**2 + r*(36*s - 26) + 14*s**2 - 23*s + 9) + 7*Pkdd2*g2*k1**2*(s - 1)**2 + f*(2*C - 1)*(Pk2*(16*r**2 + 18*r*(s - 1) + 7*(s - 1)**2) - 3*Pkdd2*k1**2*(s - 1)**2)) + Dd*Pk2*f*(2 - 4*C)*(32*r**2 + r*(72*s - 61) + 28*s**2 - 53*s + 25))) + b1**2*(D1**2*(Pk2*fdd*(2 - 4*C)*(11*r**2 + 2*r*(9*s - 11) + 7*s**2 - 18*s + 11) + fd*(7*K*Pkdd2*k1**2*s**2 - 2*Pk2*(r + s - 1)*(C*(54*r + 70*s - 54) - 41*r - 35*s + 41))) + D1*(Dd*(Pk2*fd*(4 - 8*C)*(44*r**2 + r*(72*s - 75) + 28*s**2 - 61*s + 31) + f*(7*K*Pkdd2*k1**2*(4*s**2 - 2*s + 1) + Pk2*(-4*C*(108*r**2 + 248*r*s - 170*r + 140*s**2 - 194*s + 89) + 328*r**2 + 608*r*s - 480*r + 280*s**2 - 444*s + 234))) + Ddd*Pk2*f*(2 - 4*C)*(44*r**2 + r*(72*s - 62) + 28*s**2 - 50*s + 29)) + Dd**2*Pk2*f*(4 - 8*C)*(66*r**2 + 3*r*(36*s - 31) + 42*s**2 - 75*s + 29)) - b1*(2*D1**2*Pk2*bdd1*f*(2*C - 1)*(22*r**2 + 36*r*s - 18*r + 14*s**2 - 14*s + 7) + 2*D1**2*(f*(-Pk2*fdd*(4*C - 2)*(8*r**2 + 2*r*(9*s - 4) + 7*s**2 - 9*s + 4) + 7*Pkdd2*gd2*k1**2*s**2 + fd*(4*C - 2)*(Pk2*(16*r**2 + 2*r*(9*s - 8) + 7*s**2 - 9*s + 8) - 3*Pkdd2*k1**2*s**2)) + fd*(-Pk2*fd*(4*C - 2)*(8*r**2 + 2*r*(9*s - 4) + s*(7*s - 9)) + 7*Pkdd2*g2*k1**2*s**2)) + D1*bd1*(D1*(Pk2*fd*(8*C - 4)*(22*r**2 + r*(36*s - 31) + 14*s**2 - 25*s + 9) + f*(-7*K*Pkdd2*k1**2*(2*s**2 - 2*s + 1) + 2*Pk2*(2*C*(54*r**2 + 124*r*s - 62*r + 70*s**2 - 70*s + 35) - 82*r**2 - 152*r*s + 76*r - 70*s**2 + 70*s - 35))) + Dd*Pk2*f*(8*C - 4)*(88*r**2 + 2*r*(72*s - 49) + 56*s**2 - 78*s + 25)) + 2*D1*f*(Dd*(-Pk2*fd*(4*C - 2)*(64*r**2 + 2*r*(72*s - 41) + 56*s**2 - 86*s + 25) + 7*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) + f*(2*C - 1)*(Pk2*(64*r**2 + r*(72*s - 82) + 28*s**2 - 50*s + 39) - 3*Pkdd2*k1**2*(4*s**2 - 2*s + 1))) - Ddd*Pk2*f*(2*C - 1)*(32*r**2 + r*(72*s - 50) + 28*s**2 - 50*s + 23)) - 2*Dd**2*Pk2*f**2*(4*C - 2)*(48*r**2 + 3*r*(36*s - 25) + 42*s**2 - 75*s + 26)))/(21*d**2*k3**4) + 5*D1**2*Pk3*st**6*(-96*C*D1**2*Pk2*f**2*fd*s**2 + 64*C*D1**2*Pk2*f**2*fd*s - 32*C*D1**2*Pk2*f**2*fd + 48*C*D1**2*Pk2*f**2*fdd*s**2 - 32*C*D1**2*Pk2*f**2*fdd*s + 16*C*D1**2*Pk2*f**2*fdd + 96*C*D1**2*Pk2*f*fd**2*s**2 - 64*C*D1**2*Pk2*f*fd**2*s - 128*C*D1*Dd*Pk2*f**3*s**2 + 64*C*D1*Dd*Pk2*f**3*s - 32*C*D1*Dd*Pk2*f**3 + 384*C*D1*Dd*Pk2*f**2*fd*s**2 - 224*C*D1*Dd*Pk2*f**2*fd*s + 32*C*D1*Dd*Pk2*f**2*fd + 64*C*D1*Ddd*Pk2*f**3*s**2 - 32*C*D1*Ddd*Pk2*f**3*s + 16*C*D1*Ddd*Pk2*f**3 + 192*C*Dd**2*Pk2*f**3*s**2 - 96*C*Dd**2*Pk2*f**3*s - 1056*D1**2*K*Pk2*b1*f*fd*s**2 + 1056*D1**2*K*Pk2*b1*f*fd*s - 528*D1**2*K*Pk2*b1*f*fd + 528*D1**2*K*Pk2*b1*f*fdd*s**2 - 528*D1**2*K*Pk2*b1*f*fdd*s + 264*D1**2*K*Pk2*b1*f*fdd + 528*D1**2*K*Pk2*b1*fd**2*s**2 - 528*D1**2*K*Pk2*b1*fd**2*s + 264*D1**2*K*Pk2*bdd1*f**2*s**2 - 792*D1**2*Pk2*b1*f**2*fd*r*s + 264*D1**2*Pk2*b1*f**2*fd*r + 264*D1**2*Pk2*b1*f**2*fd*s + 792*D1**2*Pk2*b1*f**2*fdd*r*s - 264*D1**2*Pk2*b1*f**2*fdd*r - 264*D1**2*Pk2*b1*f**2*fdd*s + 1584*D1**2*Pk2*b1*f*fd**2*r*s - 528*D1**2*Pk2*b1*f*fd**2*r - 528*D1**2*Pk2*b1*f*fd**2*s + 264*D1**2*Pk2*b1*f*fd**2 - 1056*D1**2*Pk2*b1*f*fd*r*s + 528*D1**2*Pk2*b1*f*fd*r + 528*D1**2*Pk2*b1*f*fdd*r*s - 264*D1**2*Pk2*b1*f*fdd*r + 528*D1**2*Pk2*b1*fd**2*r*s - 264*D1**2*Pk2*b1*fd**2*r - 528*D1**2*Pk2*bd2*f**2*s**2 + 1056*D1**2*Pk2*bd2*f*fd*s**2 - 528*D1**2*Pk2*bd2*f*fd*s + 264*D1**2*Pk2*bdd1*f**3*r*s - 264*D1**2*Pk2*bdd1*f**3*s + 264*D1**2*Pk2*bdd1*f**2*r*s - 264*D1**2*Pk2*bdd1*f**2*s + 264*D1**2*Pk2*bdd2*f**2*s**2 - 48*D1**2*Pk2*f**2*fd*r*s + 16*D1**2*Pk2*f**2*fd*r + 48*D1**2*Pk2*f**2*fd*s**2 - 16*D1**2*Pk2*f**2*fd*s + 16*D1**2*Pk2*f**2*fd + 24*D1**2*Pk2*f**2*fdd*r*s - 8*D1**2*Pk2*f**2*fdd*r - 24*D1**2*Pk2*f**2*fdd*s**2 + 8*D1**2*Pk2*f**2*fdd*s - 8*D1**2*Pk2*f**2*fdd + 1056*D1**2*Pk2*f**2*gd2*s**2 - 528*D1**2*Pk2*f**2*gdd2*s**2 + 48*D1**2*Pk2*f*fd**2*r*s - 16*D1**2*Pk2*f*fd**2*r - 48*D1**2*Pk2*f*fd**2*s**2 + 16*D1**2*Pk2*f*fd**2*s + 8*D1**2*Pk2*f*fd**2 + 2112*D1**2*Pk2*f*fd*g2*s**2 - 2112*D1**2*Pk2*f*fd*g2*s + 1056*D1**2*Pk2*f*fd*g2 - 2112*D1**2*Pk2*f*fd*gd2*s**2 + 1056*D1**2*Pk2*f*fd*gd2*s - 1056*D1**2*Pk2*f*fdd*g2*s**2 + 1056*D1**2*Pk2*f*fdd*g2*s - 528*D1**2*Pk2*f*fdd*g2 - 1056*D1**2*Pk2*fd**2*g2*s**2 + 1056*D1**2*Pk2*fd**2*g2*s + 18*D1**2*Pkdd2*b1*f**2*fd*k1**2*s**2 - 12*D1**2*Pkdd2*b1*f**2*fd*k1**2*s + 6*D1**2*Pkdd2*b1*f**2*fd*k1**2 - 9*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s**2 + 6*D1**2*Pkdd2*b1*f**2*fdd*k1**2*s - 3*D1**2*Pkdd2*b1*f**2*fdd*k1**2 - 18*D1**2*Pkdd2*b1*f*fd**2*k1**2*s**2 + 12*D1**2*Pkdd2*b1*f*fd**2*k1**2*s - 3*D1**2*Pkdd2*bdd1*f**3*k1**2*s**2 - 2112*D1*Dd*K*Pk2*b1*f**2*s**2 + 1056*D1*Dd*K*Pk2*b1*f**2*s - 528*D1*Dd*K*Pk2*b1*f**2 + 4224*D1*Dd*K*Pk2*b1*f*fd*s**2 - 3168*D1*Dd*K*Pk2*b1*f*fd*s + 528*D1*Dd*K*Pk2*b1*f*fd - 1056*D1*Dd*Pk2*b1*f**3*r*s + 264*D1*Dd*Pk2*b1*f**3*r + 528*D1*Dd*Pk2*b1*f**3*s + 6336*D1*Dd*Pk2*b1*f**2*fd*r*s - 1848*D1*Dd*Pk2*b1*f**2*fd*r - 2640*D1*Dd*Pk2*b1*f**2*fd*s + 792*D1*Dd*Pk2*b1*f**2*fd - 2112*D1*Dd*Pk2*b1*f**2*r*s + 528*D1*Dd*Pk2*b1*f**2*r + 1056*D1*Dd*Pk2*b1*f**2*s + 4224*D1*Dd*Pk2*b1*f*fd*r*s - 1584*D1*Dd*Pk2*b1*f*fd*r - 1056*D1*Dd*Pk2*b1*f*fd*s + 528*D1*Dd*Pk2*b1*f*fd + 2112*D1*Dd*Pk2*bd2*f**2*s**2 - 528*D1*Dd*Pk2*bd2*f**2*s - 64*D1*Dd*Pk2*f**3*r*s + 16*D1*Dd*Pk2*f**3*r + 64*D1*Dd*Pk2*f**3*s**2 + 16*D1*Dd*Pk2*f**3 + 192*D1*Dd*Pk2*f**2*fd*r*s - 56*D1*Dd*Pk2*f**2*fd*r - 192*D1*Dd*Pk2*f**2*fd*s**2 + 32*D1*Dd*Pk2*f**2*fd*s + 8*D1*Dd*Pk2*f**2*fd + 4224*D1*Dd*Pk2*f**2*g2*s**2 - 2112*D1*Dd*Pk2*f**2*g2*s + 1056*D1*Dd*Pk2*f**2*g2 - 4224*D1*Dd*Pk2*f**2*gd2*s**2 + 1056*D1*Dd*Pk2*f**2*gd2*s - 8448*D1*Dd*Pk2*f*fd*g2*s**2 + 6336*D1*Dd*Pk2*f*fd*g2*s - 1056*D1*Dd*Pk2*f*fd*g2 + 24*D1*Dd*Pkdd2*b1*f**3*k1**2*s**2 - 12*D1*Dd*Pkdd2*b1*f**3*k1**2*s + 6*D1*Dd*Pkdd2*b1*f**3*k1**2 - 72*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s**2 + 42*D1*Dd*Pkdd2*b1*f**2*fd*k1**2*s - 6*D1*Dd*Pkdd2*b1*f**2*fd*k1**2 + 1056*D1*Ddd*K*Pk2*b1*f**2*s**2 - 528*D1*Ddd*K*Pk2*b1*f**2*s + 264*D1*Ddd*K*Pk2*b1*f**2 + 1056*D1*Ddd*Pk2*b1*f**3*r*s - 264*D1*Ddd*Pk2*b1*f**3*r - 528*D1*Ddd*Pk2*b1*f**3*s + 1056*D1*Ddd*Pk2*b1*f**2*r*s - 264*D1*Ddd*Pk2*b1*f**2*r - 528*D1*Ddd*Pk2*b1*f**2*s + 32*D1*Ddd*Pk2*f**3*r*s - 8*D1*Ddd*Pk2*f**3*r - 32*D1*Ddd*Pk2*f**3*s**2 - 8*D1*Ddd*Pk2*f**3 - 2112*D1*Ddd*Pk2*f**2*g2*s**2 + 1056*D1*Ddd*Pk2*f**2*g2*s - 528*D1*Ddd*Pk2*f**2*g2 - 12*D1*Ddd*Pkdd2*b1*f**3*k1**2*s**2 + 6*D1*Ddd*Pkdd2*b1*f**3*k1**2*s - 3*D1*Ddd*Pkdd2*b1*f**3*k1**2 - 6*D1*bd1*f*(-D1*(f*s*(-44*Pk2*(2*K*s + f*(r - 1) + 2*r - 2) + Pkdd2*f*k1**2*s) + fd*(44*Pk2*(f*r*(6*s - 1) - 4*f*s + f + r*(4*s - 1) + (2*s - 1)*(2*K*s - 1)) + Pkdd2*f*k1**2*s*(1 - 3*s))) + Dd*f*(-44*Pk2*(8*K*s**2 - 2*K*s + f*r*(8*s - 1) - 6*f*s + f + r*(8*s - 1) - 6*s + 1) + Pkdd2*f*k1**2*s*(4*s - 1))) + 3168*Dd**2*K*Pk2*b1*f**2*s**2 - 1584*Dd**2*K*Pk2*b1*f**2*s + 3168*Dd**2*Pk2*b1*f**3*r*s - 792*Dd**2*Pk2*b1*f**3*r - 1584*Dd**2*Pk2*b1*f**3*s + 528*Dd**2*Pk2*b1*f**3 + 3168*Dd**2*Pk2*b1*f**2*r*s - 792*Dd**2*Pk2*b1*f**2*r - 1584*Dd**2*Pk2*b1*f**2*s + 528*Dd**2*Pk2*b1*f**2 + 96*Dd**2*Pk2*f**3*r*s - 24*Dd**2*Pk2*f**3*r - 96*Dd**2*Pk2*f**3*s**2 + 16*Dd**2*Pk2*f**3 - 6336*Dd**2*Pk2*f**2*g2*s**2 + 3168*Dd**2*Pk2*f**2*g2*s - 36*Dd**2*Pkdd2*b1*f**3*k1**2*s**2 + 18*Dd**2*Pkdd2*b1*f**3*k1**2*s - 264*Pk2*b2*(D1**2*(f*(2*fd - fdd)*(2*s**2 - 2*s + 1) - 2*fd**2*s*(s - 1)) + D1*f*(2*Dd*(4*f*s**2 - 2*f*s + f - 8*fd*s**2 + 6*fd*s - fd) + Ddd*f*(-4*s**2 + 2*s - 1)) + 6*Dd**2*f**2*s*(1 - 2*s)))/(1386*d**2*k3**2) - D1**2*Pk3*st**4*(-192*C*D1**2*Pk2*f**2*fd*r*s + 64*C*D1**2*Pk2*f**2*fd*r + 64*C*D1**2*Pk2*f**2*fd*s + 96*C*D1**2*Pk2*f**2*fdd*r*s - 32*C*D1**2*Pk2*f**2*fdd*r - 32*C*D1**2*Pk2*f**2*fdd*s + 192*C*D1**2*Pk2*f*fd**2*r*s - 64*C*D1**2*Pk2*f*fd**2*r - 64*C*D1**2*Pk2*f*fd**2*s + 32*C*D1**2*Pk2*f*fd**2 - 12*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 8*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 4*C*D1**2*Pkdd2*f**2*fd*k1**2 + 6*C*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 - 4*C*D1**2*Pkdd2*f**2*fdd*k1**2*s + 2*C*D1**2*Pkdd2*f**2*fdd*k1**2 + 12*C*D1**2*Pkdd2*f*fd**2*k1**2*s**2 - 8*C*D1**2*Pkdd2*f*fd**2*k1**2*s - 256*C*D1*Dd*Pk2*f**3*r*s + 64*C*D1*Dd*Pk2*f**3*r + 128*C*D1*Dd*Pk2*f**3*s + 768*C*D1*Dd*Pk2*f**2*fd*r*s - 224*C*D1*Dd*Pk2*f**2*fd*r - 320*C*D1*Dd*Pk2*f**2*fd*s + 96*C*D1*Dd*Pk2*f**2*fd - 16*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 8*C*D1*Dd*Pkdd2*f**3*k1**2*s - 4*C*D1*Dd*Pkdd2*f**3*k1**2 + 48*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 - 28*C*D1*Dd*Pkdd2*f**2*fd*k1**2*s + 4*C*D1*Dd*Pkdd2*f**2*fd*k1**2 + 128*C*D1*Ddd*Pk2*f**3*r*s - 32*C*D1*Ddd*Pk2*f**3*r - 64*C*D1*Ddd*Pk2*f**3*s + 8*C*D1*Ddd*Pkdd2*f**3*k1**2*s**2 - 4*C*D1*Ddd*Pkdd2*f**3*k1**2*s + 2*C*D1*Ddd*Pkdd2*f**3*k1**2 + 384*C*Dd**2*Pk2*f**3*r*s - 96*C*Dd**2*Pk2*f**3*r - 192*C*Dd**2*Pk2*f**3*s + 64*C*Dd**2*Pk2*f**3 + 24*C*Dd**2*Pkdd2*f**3*k1**2*s**2 - 12*C*Dd**2*Pkdd2*f**3*k1**2*s + 264*D1**2*K*Pk2*bdd1*f**2*r*s + 594*D1**2*K*Pk2*bdd1*f**2*s**2 - 264*D1**2*K*Pk2*bdd1*f**2*s - 528*D1**2*Pk2*b2*f*fd*r*s + 264*D1**2*Pk2*b2*f*fd*r - 1452*D1**2*Pk2*b2*f*fd*s**2 + 1452*D1**2*Pk2*b2*f*fd*s - 726*D1**2*Pk2*b2*f*fd + 528*D1**2*Pk2*b2*f*fdd*r*s - 264*D1**2*Pk2*b2*f*fdd*r + 1188*D1**2*Pk2*b2*f*fdd*s**2 - 1188*D1**2*Pk2*b2*f*fdd*s + 594*D1**2*Pk2*b2*f*fdd + 528*D1**2*Pk2*b2*fd**2*r*s - 264*D1**2*Pk2*b2*fd**2*r + 1188*D1**2*Pk2*b2*fd**2*s**2 - 1188*D1**2*Pk2*b2*fd**2*s + 132*D1**2*Pk2*bd1**2*f*(2*K*s + f*(r - 1) + r**2*(K - 1) - r*(4*K*s + K - 2) - 1) - 264*D1**2*Pk2*bd2*f**2*r*s - 726*D1**2*Pk2*bd2*f**2*s**2 + 264*D1**2*Pk2*bd2*f**2*s + 1056*D1**2*Pk2*bd2*f*fd*r*s - 264*D1**2*Pk2*bd2*f*fd*r + 2376*D1**2*Pk2*bd2*f*fd*s**2 - 1716*D1**2*Pk2*bd2*f*fd*s + 264*D1**2*Pk2*bd2*f*fd + 198*D1**2*Pk2*bdd1*f**3*r**2 + 330*D1**2*Pk2*bdd1*f**3*r*s - 264*D1**2*Pk2*bdd1*f**3*r - 330*D1**2*Pk2*bdd1*f**3*s + 132*D1**2*Pk2*bdd1*f**3 + 132*D1**2*Pk2*bdd1*f**2*r**2 + 330*D1**2*Pk2*bdd1*f**2*r*s - 264*D1**2*Pk2*bdd1*f**2*r - 330*D1**2*Pk2*bdd1*f**2*s + 132*D1**2*Pk2*bdd1*f**2 - 132*D1**2*Pk2*bdd1*f*g2*r**2 + 528*D1**2*Pk2*bdd1*f*g2*r*s + 264*D1**2*Pk2*bdd2*f**2*r*s + 594*D1**2*Pk2*bdd2*f**2*s**2 - 264*D1**2*Pk2*bdd2*f**2*s - 48*D1**2*Pk2*f**2*fd*r**2 + 72*D1**2*Pk2*f**2*fd*r*s + 8*D1**2*Pk2*f**2*fd*r - 24*D1**2*Pk2*f**2*fd*s - 16*D1**2*Pk2*f**2*fd + 24*D1**2*Pk2*f**2*fdd*r**2 - 36*D1**2*Pk2*f**2*fdd*r*s - 4*D1**2*Pk2*f**2*fdd*r + 12*D1**2*Pk2*f**2*fdd*s + 8*D1**2*Pk2*f**2*fdd + 528*D1**2*Pk2*f**2*gd2*r*s + 1452*D1**2*Pk2*f**2*gd2*s**2 - 528*D1**2*Pk2*f**2*gd2*s - 528*D1**2*Pk2*f**2*gdd2*r*s - 1188*D1**2*Pk2*f**2*gdd2*s**2 + 528*D1**2*Pk2*f**2*gdd2*s + 48*D1**2*Pk2*f*fd**2*r**2 - 72*D1**2*Pk2*f*fd**2*r*s - 8*D1**2*Pk2*f*fd**2*r + 24*D1**2*Pk2*f*fd**2*s - 12*D1**2*Pk2*f*fd**2 + 1056*D1**2*Pk2*f*fd*g2*r*s - 528*D1**2*Pk2*f*fd*g2*r + 2904*D1**2*Pk2*f*fd*g2*s**2 - 2904*D1**2*Pk2*f*fd*g2*s + 1452*D1**2*Pk2*f*fd*g2 - 2112*D1**2*Pk2*f*fd*gd2*r*s + 528*D1**2*Pk2*f*fd*gd2*r - 4752*D1**2*Pk2*f*fd*gd2*s**2 + 3432*D1**2*Pk2*f*fd*gd2*s - 528*D1**2*Pk2*f*fd*gd2 - 1056*D1**2*Pk2*f*fdd*g2*r*s + 528*D1**2*Pk2*f*fdd*g2*r - 2376*D1**2*Pk2*f*fdd*g2*s**2 + 2376*D1**2*Pk2*f*fdd*g2*s - 1188*D1**2*Pk2*f*fdd*g2 - 1056*D1**2*Pk2*fd**2*g2*r*s + 528*D1**2*Pk2*fd**2*g2*r - 2376*D1**2*Pk2*fd**2*g2*s**2 + 2376*D1**2*Pk2*fd**2*g2*s + 6*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 4*D1**2*Pkdd2*f**2*fd*k1**2*s + 2*D1**2*Pkdd2*f**2*fd*k1**2 - 3*D1**2*Pkdd2*f**2*fdd*k1**2*s**2 + 2*D1**2*Pkdd2*f**2*fdd*k1**2*s - D1**2*Pkdd2*f**2*fdd*k1**2 - 6*D1**2*Pkdd2*f*fd**2*k1**2*s**2 + 4*D1**2*Pkdd2*f*fd**2*k1**2*s - 1056*D1*Dd*Pk2*b2*f**2*r*s + 264*D1*Dd*Pk2*b2*f**2*r - 2904*D1*Dd*Pk2*b2*f**2*s**2 + 1980*D1*Dd*Pk2*b2*f**2*s - 726*D1*Dd*Pk2*b2*f**2 + 4224*D1*Dd*Pk2*b2*f*fd*r*s - 1584*D1*Dd*Pk2*b2*f*fd*r + 9504*D1*Dd*Pk2*b2*f*fd*s**2 - 8184*D1*Dd*Pk2*b2*f*fd*s + 1716*D1*Dd*Pk2*b2*f*fd + 2112*D1*Dd*Pk2*bd2*f**2*r*s - 264*D1*Dd*Pk2*bd2*f**2*r + 4752*D1*Dd*Pk2*bd2*f**2*s**2 - 2772*D1*Dd*Pk2*bd2*f**2*s + 264*D1*Dd*Pk2*bd2*f**2 - 64*D1*Dd*Pk2*f**3*r**2 + 96*D1*Dd*Pk2*f**3*r*s + 40*D1*Dd*Pk2*f**3*r - 48*D1*Dd*Pk2*f**3*s - 32*D1*Dd*Pk2*f**3 + 192*D1*Dd*Pk2*f**2*fd*r**2 - 288*D1*Dd*Pk2*f**2*fd*r*s - 76*D1*Dd*Pk2*f**2*fd*r + 120*D1*Dd*Pk2*f**2*fd*s - 4*D1*Dd*Pk2*f**2*fd + 2112*D1*Dd*Pk2*f**2*g2*r*s - 528*D1*Dd*Pk2*f**2*g2*r + 5808*D1*Dd*Pk2*f**2*g2*s**2 - 3960*D1*Dd*Pk2*f**2*g2*s + 1452*D1*Dd*Pk2*f**2*g2 - 4224*D1*Dd*Pk2*f**2*gd2*r*s + 528*D1*Dd*Pk2*f**2*gd2*r - 9504*D1*Dd*Pk2*f**2*gd2*s**2 + 5544*D1*Dd*Pk2*f**2*gd2*s - 528*D1*Dd*Pk2*f**2*gd2 - 8448*D1*Dd*Pk2*f*fd*g2*r*s + 3168*D1*Dd*Pk2*f*fd*g2*r - 19008*D1*Dd*Pk2*f*fd*g2*s**2 + 16368*D1*Dd*Pk2*f*fd*g2*s - 3432*D1*Dd*Pk2*f*fd*g2 + 8*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**3*k1**2*s + 2*D1*Dd*Pkdd2*f**3*k1**2 - 24*D1*Dd*Pkdd2*f**2*fd*k1**2*s**2 + 14*D1*Dd*Pkdd2*f**2*fd*k1**2*s - 2*D1*Dd*Pkdd2*f**2*fd*k1**2 + 1056*D1*Ddd*Pk2*b2*f**2*r*s - 264*D1*Ddd*Pk2*b2*f**2*r + 2376*D1*Ddd*Pk2*b2*f**2*s**2 - 1716*D1*Ddd*Pk2*b2*f**2*s + 594*D1*Ddd*Pk2*b2*f**2 + 32*D1*Ddd*Pk2*f**3*r**2 - 48*D1*Ddd*Pk2*f**3*r*s - 20*D1*Ddd*Pk2*f**3*r + 24*D1*Ddd*Pk2*f**3*s + 16*D1*Ddd*Pk2*f**3 - 2112*D1*Ddd*Pk2*f**2*g2*r*s + 528*D1*Ddd*Pk2*f**2*g2*r - 4752*D1*Ddd*Pk2*f**2*g2*s**2 + 3432*D1*Ddd*Pk2*f**2*g2*s - 1188*D1*Ddd*Pk2*f**2*g2 - 4*D1*Ddd*Pkdd2*f**3*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**3*k1**2*s - D1*Ddd*Pkdd2*f**3*k1**2 - 66*D1*Pk2*bd1*(D1*(f**3*(3*r**2 + r*(5*s - 4) - 5*s + 2) + f**2*(11*K*s**2 - 4*K*s + fd*(-18*r**2 - 5*r*(6*s - 5) + 20*s - 9) + 2*r**2 + r*(4*K*s + 7*s - 4) - 7*s + 2) - f*(fd*(2*K*(8*r*s - 2*r + 18*s**2 - 13*s + 2) + 8*r**2 + 20*r*s - 13*r - 10*s + 5) + 4*g2*r*(r - 4*s) + 4*gd2*(-r**2 + 4*r*s + r - 2*s)) + 4*fd*g2*r*(r - 4*s + 2)) - Dd*f*(f**2*(24*r**2 + r*(40*s - 33) - 30*s + 13) + f*(K*(32*r*s - 4*r + 72*s**2 - 42*s + 4) + 16*r**2 + 40*r*s - 29*r - 30*s + 13) - 16*g2*(r**2 - 4*r*s + s))) + 3168*Dd**2*Pk2*b2*f**2*r*s - 792*Dd**2*Pk2*b2*f**2*r + 7128*Dd**2*Pk2*b2*f**2*s**2 - 5148*Dd**2*Pk2*b2*f**2*s + 528*Dd**2*Pk2*b2*f**2 + 96*Dd**2*Pk2*f**3*r**2 - 144*Dd**2*Pk2*f**3*r*s - 60*Dd**2*Pk2*f**3*r + 72*Dd**2*Pk2*f**3*s - 8*Dd**2*Pk2*f**3 - 6336*Dd**2*Pk2*f**2*g2*r*s + 1584*Dd**2*Pk2*f**2*g2*r - 14256*Dd**2*Pk2*f**2*g2*s**2 + 10296*Dd**2*Pk2*f**2*g2*s - 1056*Dd**2*Pk2*f**2*g2 - 12*Dd**2*Pkdd2*f**3*k1**2*s**2 + 6*Dd**2*Pkdd2*f**3*k1**2*s + 66*Pk2*b1**2*(D1**2*(-2*fd**2*(r - 1) + 2*fd*r*(-K*(r - 4*s + 4) + f + r + 2) + fdd*r*(K*(r - 4*s + 4) - 2*f - r - 2)) - 4*D1*Dd*(f*(2*K*r**2 - 8*K*r*s + 4*K*s + K + fd*(2*r - 1) - 2*r**2 + 2*r - 1) + fd*(-2*K*(r**2 - 4*r*s + 2*r + s - 1) + 2*r**2 + r - 1)) + 2*D1*Ddd*f*(K*(2*r**2 - 8*r*s + 4*s + 1) - 2*r**2 + 2*r - 1) + 2*Dd**2*f*(3*K*(2*r**2 - 8*r*s + 4*s - 1) - 6*r**2 + 6*r - 1)) - 66*Pk2*b1*(8*D1**2*K*f*fd*r*s - 4*D1**2*K*f*fd*r + 22*D1**2*K*f*fd*s**2 - 22*D1**2*K*f*fd*s + 11*D1**2*K*f*fd - 8*D1**2*K*f*fdd*r*s + 4*D1**2*K*f*fdd*r - 18*D1**2*K*f*fdd*s**2 + 18*D1**2*K*f*fdd*s - 9*D1**2*K*f*fdd - 8*D1**2*K*fd**2*r*s + 4*D1**2*K*fd**2*r - 18*D1**2*K*fd**2*s**2 + 18*D1**2*K*fd**2*s - D1**2*bdd1*f*(K*(2*r**2 - 2*r*(4*s + 1) + 4*s + 1) - 2*r**2 + r*(2*f + 4) - 1) + 9*D1**2*f**2*fd*r**2 + 15*D1**2*f**2*fd*r*s - 13*D1**2*f**2*fd*r - 5*D1**2*f**2*fd*s + 4*D1**2*f**2*fd - 9*D1**2*f**2*fdd*r**2 - 15*D1**2*f**2*fdd*r*s + 13*D1**2*f**2*fdd*r + 5*D1**2*f**2*fdd*s - 4*D1**2*f**2*fdd - 18*D1**2*f*fd**2*r**2 - 30*D1**2*f*fd**2*r*s + 26*D1**2*f*fd**2*r + 10*D1**2*f*fd**2*s - 7*D1**2*f*fd**2 + 4*D1**2*f*fd*r**2 + 14*D1**2*f*fd*r*s - 7*D1**2*f*fd*r - 4*D1**2*f*fdd*r**2 - 10*D1**2*f*fdd*r*s + 5*D1**2*f*fdd*r - 4*D1**2*f*gd2*r**2 + 16*D1**2*f*gd2*r*s + 8*D1**2*f*gd2*r - 16*D1**2*f*gd2*s - 4*D1**2*f*gd2 + 2*D1**2*f*gdd2*r**2 - 8*D1**2*f*gdd2*r*s - 4*D1**2*f*gdd2*r + 8*D1**2*f*gdd2*s + 2*D1**2*f*gdd2 - 4*D1**2*fd**2*r**2 - 10*D1**2*fd**2*r*s + 5*D1**2*fd**2*r - 4*D1**2*fd*g2*r**2 + 16*D1**2*fd*g2*r*s - 16*D1**2*fd*g2*r + 4*D1**2*fd*gd2*r**2 - 16*D1**2*fd*gd2*r*s + 4*D1**2*fd*gd2*r + 8*D1**2*fd*gd2*s - 8*D1**2*fd*gd2 + 2*D1**2*fdd*g2*r**2 - 8*D1**2*fdd*g2*r*s + 8*D1**2*fdd*g2*r + 16*D1*Dd*K*f**2*r*s - 4*D1*Dd*K*f**2*r + 44*D1*Dd*K*f**2*s**2 - 30*D1*Dd*K*f**2*s + 11*D1*Dd*K*f**2 - 64*D1*Dd*K*f*fd*r*s + 24*D1*Dd*K*f*fd*r - 144*D1*Dd*K*f*fd*s**2 + 124*D1*Dd*K*f*fd*s - 26*D1*Dd*K*f*fd + 12*D1*Dd*f**3*r**2 + 20*D1*Dd*f**3*r*s - 17*D1*Dd*f**3*r - 10*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 72*D1*Dd*f**2*fd*r**2 - 120*D1*Dd*f**2*fd*r*s + 103*D1*Dd*f**2*fd*r + 50*D1*Dd*f**2*fd*s - 31*D1*Dd*f**2*fd + 8*D1*Dd*f**2*r**2 + 28*D1*Dd*f**2*r*s - 15*D1*Dd*f**2*r - 14*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 32*D1*Dd*f*fd*r**2 - 80*D1*Dd*f*fd*r*s + 46*D1*Dd*f*fd*r + 20*D1*Dd*f*fd*s - 10*D1*Dd*f*fd - 16*D1*Dd*f*g2*r**2 + 64*D1*Dd*f*g2*r*s - 32*D1*Dd*f*g2*s - 8*D1*Dd*f*g2 + 16*D1*Dd*f*gd2*r**2 - 64*D1*Dd*f*gd2*r*s - 16*D1*Dd*f*gd2*r + 48*D1*Dd*f*gd2*s + 16*D1*Dd*fd*g2*r**2 - 64*D1*Dd*fd*g2*r*s + 32*D1*Dd*fd*g2*r + 16*D1*Dd*fd*g2*s - 16*D1*Dd*fd*g2 - 16*D1*Ddd*K*f**2*r*s + 4*D1*Ddd*K*f**2*r - 36*D1*Ddd*K*f**2*s**2 + 26*D1*Ddd*K*f**2*s - 9*D1*Ddd*K*f**2 - 12*D1*Ddd*f**3*r**2 - 20*D1*Ddd*f**3*r*s + 17*D1*Ddd*f**3*r + 10*D1*Ddd*f**3*s - 6*D1*Ddd*f**3 - 8*D1*Ddd*f**2*r**2 - 20*D1*Ddd*f**2*r*s + 13*D1*Ddd*f**2*r + 10*D1*Ddd*f**2*s - 4*D1*Ddd*f**2 + 8*D1*Ddd*f*g2*r**2 - 32*D1*Ddd*f*g2*r*s + 16*D1*Ddd*f*g2*s + 4*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(f**2*r + f*(K*(2*r**2 - 8*r*s - 2*r + 4*s + 1) - 2*r**2 + 4*r - 1) + fd*(K*(-2*r**2 + 8*r*s - 3*r - 2*s + 2) + 2*r**2 - 1)) - 2*Dd*f*(2*r - 1)*(-8*K*s + f + r*(2*K - 2) + 2)) - 48*Dd**2*K*f**2*r*s + 12*Dd**2*K*f**2*r - 108*Dd**2*K*f**2*s**2 + 78*Dd**2*K*f**2*s - 8*Dd**2*K*f**2 - 36*Dd**2*f**3*r**2 - 60*Dd**2*f**3*r*s + 51*Dd**2*f**3*r + 30*Dd**2*f**3*s - 16*Dd**2*f**3 - 24*Dd**2*f**2*r**2 - 60*Dd**2*f**2*r*s + 39*Dd**2*f**2*r + 30*Dd**2*f**2*s - 14*Dd**2*f**2 + 24*Dd**2*f*g2*r**2 - 96*Dd**2*f*g2*r*s + 48*Dd**2*f*g2*s - 12*Dd**2*f*g2))/(231*d**2*k3**2) + D1**2*Pk3*st**2*(792*C*D1**2*Pk2*bdd1*f**2*r*s + 420*C*D1**2*Pk2*f**2*fd*r**2 + 2376*C*D1**2*Pk2*f**2*fd*r*s - 1072*C*D1**2*Pk2*f**2*fd*r + 2376*C*D1**2*Pk2*f**2*fd*s**2 - 2376*C*D1**2*Pk2*f**2*fd*s + 932*C*D1**2*Pk2*f**2*fd - 12*C*D1**2*Pk2*f**2*fdd*r**2 - 2376*C*D1**2*Pk2*f**2*fdd*r*s + 800*C*D1**2*Pk2*f**2*fdd*r - 2376*C*D1**2*Pk2*f**2*fdd*s**2 + 2376*C*D1**2*Pk2*f**2*fdd*s - 796*C*D1**2*Pk2*f**2*fdd - 24*C*D1**2*Pk2*f*fd**2*r**2 - 4752*C*D1**2*Pk2*f*fd**2*r*s + 1600*C*D1**2*Pk2*f*fd**2*r - 4752*C*D1**2*Pk2*f*fd**2*s**2 + 4752*C*D1**2*Pk2*f*fd**2*s - 792*C*D1**2*Pk2*f*fd**2 - 66*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 + 132*C*D1**2*Pkdd2*bdd1*f**2*k1**2*s - 66*C*D1**2*Pkdd2*bdd1*f**2*k1**2 - 198*C*D1**2*Pkdd2*f**2*fd*k1**2*s**2 + 132*C*D1**2*Pkdd2*f**2*fd*k1**2*s - 66*C*D1**2*Pkdd2*f**2*fd*k1**2 + 560*C*D1*Dd*Pk2*f**3*r**2 + 3168*C*D1*Dd*Pk2*f**3*r*s - 1352*C*D1*Dd*Pk2*f**3*r + 3168*C*D1*Dd*Pk2*f**3*s**2 - 3168*C*D1*Dd*Pk2*f**3*s + 1072*C*D1*Dd*Pk2*f**3 - 96*C*D1*Dd*Pk2*f**2*fd*r**2 - 19008*C*D1*Dd*Pk2*f**2*fd*r*s + 5624*C*D1*Dd*Pk2*f**2*fd*r - 19008*C*D1*Dd*Pk2*f**2*fd*s**2 + 19008*C*D1*Dd*Pk2*f**2*fd*s - 3976*C*D1*Dd*Pk2*f**2*fd - 264*C*D1*Dd*Pkdd2*f**3*k1**2*s**2 + 132*C*D1*Dd*Pkdd2*f**3*k1**2*s - 66*C*D1*Dd*Pkdd2*f**3*k1**2 - 16*C*D1*Ddd*Pk2*f**3*r**2 - 3168*C*D1*Ddd*Pk2*f**3*r*s + 808*C*D1*Ddd*Pk2*f**3*r - 3168*C*D1*Ddd*Pk2*f**3*s**2 + 3168*C*D1*Ddd*Pk2*f**3*s - 800*C*D1*Ddd*Pk2*f**3 - 48*C*Dd**2*Pk2*f**3*r**2 - 9504*C*Dd**2*Pk2*f**3*r*s + 2424*C*Dd**2*Pk2*f**3*r - 9504*C*Dd**2*Pk2*f**3*s**2 + 9504*C*Dd**2*Pk2*f**3*s - 1592*C*Dd**2*Pk2*f**3 + 462*D1**2*K*Pk2*bdd1*f**2*r**2 + 2772*D1**2*K*Pk2*bdd1*f**2*r*s - 924*D1**2*K*Pk2*bdd1*f**2*r + 2772*D1**2*K*Pk2*bdd1*f**2*s**2 - 2772*D1**2*K*Pk2*bdd1*f**2*s + 462*D1**2*K*Pk2*bdd1*f**2 - 924*D1**2*Pk2*b2*f*fd*r**2 - 5544*D1**2*Pk2*b2*f*fd*r*s + 2772*D1**2*Pk2*b2*f*fd*r - 5544*D1**2*Pk2*b2*f*fd*s**2 + 5544*D1**2*Pk2*b2*f*fd*s - 2772*D1**2*Pk2*b2*f*fd + 924*D1**2*Pk2*b2*f*fdd*r**2 + 5544*D1**2*Pk2*b2*f*fdd*r*s - 2772*D1**2*Pk2*b2*f*fdd*r + 5544*D1**2*Pk2*b2*f*fdd*s**2 - 5544*D1**2*Pk2*b2*f*fdd*s + 2772*D1**2*Pk2*b2*f*fdd + 924*D1**2*Pk2*b2*fd**2*r**2 + 5544*D1**2*Pk2*b2*fd**2*r*s - 2772*D1**2*Pk2*b2*fd**2*r + 5544*D1**2*Pk2*b2*fd**2*s**2 - 5544*D1**2*Pk2*b2*fd**2*s - 462*D1**2*Pk2*bd2*f**2*r**2 - 2772*D1**2*Pk2*bd2*f**2*r*s + 924*D1**2*Pk2*bd2*f**2*r - 2772*D1**2*Pk2*bd2*f**2*s**2 + 2772*D1**2*Pk2*bd2*f**2*s - 462*D1**2*Pk2*bd2*f**2 + 1848*D1**2*Pk2*bd2*f*fd*r**2 + 11088*D1**2*Pk2*bd2*f*fd*r*s - 4620*D1**2*Pk2*bd2*f*fd*r + 11088*D1**2*Pk2*bd2*f*fd*s**2 - 11088*D1**2*Pk2*bd2*f*fd*s + 2772*D1**2*Pk2*bd2*f*fd + 132*D1**2*Pk2*bdd1*f**2*r**2 - 396*D1**2*Pk2*bdd1*f**2*r*s - 198*D1**2*Pk2*bdd1*f**2*r + 5544*D1**2*Pk2*bdd1*f*g2*r*s + 462*D1**2*Pk2*bdd2*f**2*r**2 + 2772*D1**2*Pk2*bdd2*f**2*r*s - 924*D1**2*Pk2*bdd2*f**2*r + 2772*D1**2*Pk2*bdd2*f**2*s**2 - 2772*D1**2*Pk2*bdd2*f**2*s + 462*D1**2*Pk2*bdd2*f**2 - 210*D1**2*Pk2*f**2*fd*r**2 - 1188*D1**2*Pk2*f**2*fd*r*s + 536*D1**2*Pk2*f**2*fd*r - 1188*D1**2*Pk2*f**2*fd*s**2 + 1188*D1**2*Pk2*f**2*fd*s - 466*D1**2*Pk2*f**2*fd + 6*D1**2*Pk2*f**2*fdd*r**2 + 1188*D1**2*Pk2*f**2*fdd*r*s - 400*D1**2*Pk2*f**2*fdd*r + 1188*D1**2*Pk2*f**2*fdd*s**2 - 1188*D1**2*Pk2*f**2*fdd*s + 398*D1**2*Pk2*f**2*fdd + 924*D1**2*Pk2*f**2*gd2*r**2 + 5544*D1**2*Pk2*f**2*gd2*r*s - 1848*D1**2*Pk2*f**2*gd2*r + 5544*D1**2*Pk2*f**2*gd2*s**2 - 5544*D1**2*Pk2*f**2*gd2*s + 924*D1**2*Pk2*f**2*gd2 - 924*D1**2*Pk2*f**2*gdd2*r**2 - 5544*D1**2*Pk2*f**2*gdd2*r*s + 1848*D1**2*Pk2*f**2*gdd2*r - 5544*D1**2*Pk2*f**2*gdd2*s**2 + 5544*D1**2*Pk2*f**2*gdd2*s - 924*D1**2*Pk2*f**2*gdd2 + 12*D1**2*Pk2*f*fd**2*r**2 + 2376*D1**2*Pk2*f*fd**2*r*s - 800*D1**2*Pk2*f*fd**2*r + 2376*D1**2*Pk2*f*fd**2*s**2 - 2376*D1**2*Pk2*f*fd**2*s + 396*D1**2*Pk2*f*fd**2 + 1848*D1**2*Pk2*f*fd*g2*r**2 + 11088*D1**2*Pk2*f*fd*g2*r*s - 5544*D1**2*Pk2*f*fd*g2*r + 11088*D1**2*Pk2*f*fd*g2*s**2 - 11088*D1**2*Pk2*f*fd*g2*s + 5544*D1**2*Pk2*f*fd*g2 - 3696*D1**2*Pk2*f*fd*gd2*r**2 - 22176*D1**2*Pk2*f*fd*gd2*r*s + 9240*D1**2*Pk2*f*fd*gd2*r - 22176*D1**2*Pk2*f*fd*gd2*s**2 + 22176*D1**2*Pk2*f*fd*gd2*s - 5544*D1**2*Pk2*f*fd*gd2 - 1848*D1**2*Pk2*f*fdd*g2*r**2 - 11088*D1**2*Pk2*f*fdd*g2*r*s + 5544*D1**2*Pk2*f*fdd*g2*r - 11088*D1**2*Pk2*f*fdd*g2*s**2 + 11088*D1**2*Pk2*f*fdd*g2*s - 5544*D1**2*Pk2*f*fdd*g2 - 1848*D1**2*Pk2*fd**2*g2*r**2 - 11088*D1**2*Pk2*fd**2*g2*r*s + 5544*D1**2*Pk2*fd**2*g2*r - 11088*D1**2*Pk2*fd**2*g2*s**2 + 11088*D1**2*Pk2*fd**2*g2*s - 33*D1**2*Pkdd2*b2*bdd1*f*k1**2*s**2 + 66*D1**2*Pkdd2*b2*bdd1*f*k1**2*s - 33*D1**2*Pkdd2*b2*bdd1*f*k1**2 - 66*D1**2*Pkdd2*b2*f*fd*k1**2*s**2 + 66*D1**2*Pkdd2*b2*f*fd*k1**2*s - 33*D1**2*Pkdd2*b2*f*fd*k1**2 - 33*D1**2*Pkdd2*bd2*f**2*k1**2*s**2 + 33*D1**2*Pkdd2*bdd1*f**2*k1**2*s**2 - 66*D1**2*Pkdd2*bdd1*f**2*k1**2*s + 33*D1**2*Pkdd2*bdd1*f**2*k1**2 + 66*D1**2*Pkdd2*bdd1*f*g2*k1**2*s**2 - 132*D1**2*Pkdd2*bdd1*f*g2*k1**2*s + 66*D1**2*Pkdd2*bdd1*f*g2*k1**2 + 99*D1**2*Pkdd2*f**2*fd*k1**2*s**2 - 66*D1**2*Pkdd2*f**2*fd*k1**2*s + 33*D1**2*Pkdd2*f**2*fd*k1**2 + 66*D1**2*Pkdd2*f**2*gd2*k1**2*s**2 + 132*D1**2*Pkdd2*f*fd*g2*k1**2*s**2 - 132*D1**2*Pkdd2*f*fd*g2*k1**2*s + 66*D1**2*Pkdd2*f*fd*g2*k1**2 - 66*D1**2*bd1**2*(K*Pkdd2*f*k1**2*s*(s - 1) + 7*Pk2*f**2*(4*r**2 - 5*r + 3) + Pk2*f*(-42*K*s - r**2*(4*C - 32) + 7*r*(12*K*s - 7) + 21) - 28*Pk2*g2*r**2) - 1848*D1*Dd*Pk2*b2*f**2*r**2 - 11088*D1*Dd*Pk2*b2*f**2*r*s + 4620*D1*Dd*Pk2*b2*f**2*r - 11088*D1*Dd*Pk2*b2*f**2*s**2 + 11088*D1*Dd*Pk2*b2*f**2*s - 3696*D1*Dd*Pk2*b2*f**2 + 7392*D1*Dd*Pk2*b2*f*fd*r**2 + 44352*D1*Dd*Pk2*b2*f*fd*r*s - 20328*D1*Dd*Pk2*b2*f*fd*r + 44352*D1*Dd*Pk2*b2*f*fd*s**2 - 44352*D1*Dd*Pk2*b2*f*fd*s + 11088*D1*Dd*Pk2*b2*f*fd + 3696*D1*Dd*Pk2*bd2*f**2*r**2 + 22176*D1*Dd*Pk2*bd2*f**2*r*s - 8316*D1*Dd*Pk2*bd2*f**2*r + 22176*D1*Dd*Pk2*bd2*f**2*s**2 - 22176*D1*Dd*Pk2*bd2*f**2*s + 4620*D1*Dd*Pk2*bd2*f**2 - 280*D1*Dd*Pk2*f**3*r**2 - 1584*D1*Dd*Pk2*f**3*r*s + 676*D1*Dd*Pk2*f**3*r - 1584*D1*Dd*Pk2*f**3*s**2 + 1584*D1*Dd*Pk2*f**3*s - 536*D1*Dd*Pk2*f**3 + 48*D1*Dd*Pk2*f**2*fd*r**2 + 9504*D1*Dd*Pk2*f**2*fd*r*s - 2812*D1*Dd*Pk2*f**2*fd*r + 9504*D1*Dd*Pk2*f**2*fd*s**2 - 9504*D1*Dd*Pk2*f**2*fd*s + 1988*D1*Dd*Pk2*f**2*fd + 3696*D1*Dd*Pk2*f**2*g2*r**2 + 22176*D1*Dd*Pk2*f**2*g2*r*s - 9240*D1*Dd*Pk2*f**2*g2*r + 22176*D1*Dd*Pk2*f**2*g2*s**2 - 22176*D1*Dd*Pk2*f**2*g2*s + 7392*D1*Dd*Pk2*f**2*g2 - 7392*D1*Dd*Pk2*f**2*gd2*r**2 - 44352*D1*Dd*Pk2*f**2*gd2*r*s + 16632*D1*Dd*Pk2*f**2*gd2*r - 44352*D1*Dd*Pk2*f**2*gd2*s**2 + 44352*D1*Dd*Pk2*f**2*gd2*s - 9240*D1*Dd*Pk2*f**2*gd2 - 14784*D1*Dd*Pk2*f*fd*g2*r**2 - 88704*D1*Dd*Pk2*f*fd*g2*r*s + 40656*D1*Dd*Pk2*f*fd*g2*r - 88704*D1*Dd*Pk2*f*fd*g2*s**2 + 88704*D1*Dd*Pk2*f*fd*g2*s - 22176*D1*Dd*Pk2*f*fd*g2 - 132*D1*Dd*Pkdd2*b2*f**2*k1**2*s**2 + 66*D1*Dd*Pkdd2*b2*f**2*k1**2*s - 33*D1*Dd*Pkdd2*b2*f**2*k1**2 + 132*D1*Dd*Pkdd2*f**3*k1**2*s**2 - 66*D1*Dd*Pkdd2*f**3*k1**2*s + 33*D1*Dd*Pkdd2*f**3*k1**2 + 264*D1*Dd*Pkdd2*f**2*g2*k1**2*s**2 - 132*D1*Dd*Pkdd2*f**2*g2*k1**2*s + 66*D1*Dd*Pkdd2*f**2*g2*k1**2 + 1848*D1*Ddd*Pk2*b2*f**2*r**2 + 11088*D1*Ddd*Pk2*b2*f**2*r*s - 4620*D1*Ddd*Pk2*b2*f**2*r + 11088*D1*Ddd*Pk2*b2*f**2*s**2 - 11088*D1*Ddd*Pk2*b2*f**2*s + 3696*D1*Ddd*Pk2*b2*f**2 + 8*D1*Ddd*Pk2*f**3*r**2 + 1584*D1*Ddd*Pk2*f**3*r*s - 404*D1*Ddd*Pk2*f**3*r + 1584*D1*Ddd*Pk2*f**3*s**2 - 1584*D1*Ddd*Pk2*f**3*s + 400*D1*Ddd*Pk2*f**3 - 3696*D1*Ddd*Pk2*f**2*g2*r**2 - 22176*D1*Ddd*Pk2*f**2*g2*r*s + 9240*D1*Ddd*Pk2*f**2*g2*r - 22176*D1*Ddd*Pk2*f**2*g2*s**2 + 22176*D1*Ddd*Pk2*f**2*g2*s - 7392*D1*Ddd*Pk2*f**2*g2 - 33*D1*bd1*(D1*(f**2*(K*(14*Pk2*(r**2 + 6*r*s - 2*r + 6*s**2 - 6*s + 1) + Pkdd2*k1**2*s**2) - 2*Pk2*r*(2*C*(r - 6*s) + 6*s + 3) + Pkdd2*k1**2*(2 - 4*C)*(s - 1)**2) - 2*f*(Pk2*fd*(-12*C*s + 14*K*(2*r**2 + r*(12*s - 5) + 3*(1 - 2*s)**2) + 8*r**2 + r*(48*C*s - 12*C - 24*s - 1) + 6*s + 3) + 14*Pk2*g2*r**2 - 84*Pk2*g2*r*s + 168*Pk2*gd2*r*s - 84*Pk2*gd2*s + Pkdd2*b2*k1**2*(s - 1)**2 - Pkdd2*bd2*k1**2*s**2 + Pkdd2*bd2*k1**2*s + 2*Pkdd2*fd*k1**2*s*(-2*C*(s - 1) + s - 1) - 2*Pkdd2*g2*k1**2*s**2 + 4*Pkdd2*g2*k1**2*s - 2*Pkdd2*g2*k1**2 + 2*Pkdd2*gd2*k1**2*s**2 - 2*Pkdd2*gd2*k1**2*s) + 2*fd*(Pkdd2*b2*k1**2*s*(s - 1) - 2*g2*(42*Pk2*r*(2*s - 1) + Pkdd2*k1**2*s*(s - 1)))) - 2*Dd*f*(84*Pk2*g2*(r*(8*s - 1) - 2*s) - Pkdd2*b2*k1**2*(4*s**2 - 5*s + 1) + 2*Pkdd2*g2*k1**2*(4*s**2 - 5*s + 1) + f*(2*Pk2*(-12*C*s + 7*K*(4*r**2 + 3*r*(8*s - 3) + 24*s**2 - 24*s + 5) + 8*r**2 + r*(48*C*s - 6*C - 24*s - 7) + 6*s + 3) - Pkdd2*k1**2*(2*C - 1)*(4*s**2 - 5*s + 1)))) + 5544*Dd**2*Pk2*b2*f**2*r**2 + 33264*Dd**2*Pk2*b2*f**2*r*s - 13860*Dd**2*Pk2*b2*f**2*r + 33264*Dd**2*Pk2*b2*f**2*s**2 - 33264*Dd**2*Pk2*b2*f**2*s + 6468*Dd**2*Pk2*b2*f**2 + 24*Dd**2*Pk2*f**3*r**2 + 4752*Dd**2*Pk2*f**3*r*s - 1212*Dd**2*Pk2*f**3*r + 4752*Dd**2*Pk2*f**3*s**2 - 4752*Dd**2*Pk2*f**3*s + 796*Dd**2*Pk2*f**3 - 11088*Dd**2*Pk2*f**2*g2*r**2 - 66528*Dd**2*Pk2*f**2*g2*r*s + 27720*Dd**2*Pk2*f**2*g2*r - 66528*Dd**2*Pk2*f**2*g2*s**2 + 66528*Dd**2*Pk2*f**2*g2*s - 12936*Dd**2*Pk2*f**2*g2 + 33*b1**3*(D1**2*Pkdd2*k1**2*s**2*(2*fd - fdd) + D1*(56*Dd*Pk2*(K - 1)*(2*r**2 - 2*r + 1) + 2*Dd*Pkdd2*k1**2*(f*(4*s**2 - 2*s + 1) + fd*s*(1 - 4*s)) - 28*Ddd*Pk2*(K - 1)*(2*r**2 - 2*r + 1) - Ddd*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 2*Dd**2*(Pk2*(14*K - 14)*(6*r**2 - 6*r + 1) + 3*Pkdd2*f*k1**2*s*(2*s - 1))) + 33*b1**2*(-8*C*D1**2*Pk2*fd*r**2 + 16*C*D1**2*Pk2*fd*r - 8*C*D1**2*Pk2*fd + 4*C*D1**2*Pk2*fdd*r**2 - 8*C*D1**2*Pk2*fdd*r + 4*C*D1**2*Pk2*fdd - 32*C*D1*Dd*Pk2*f*r**2 + 32*C*D1*Dd*Pk2*f*r - 16*C*D1*Dd*Pk2*f + 32*C*D1*Dd*Pk2*fd*r**2 - 48*C*D1*Dd*Pk2*fd*r + 16*C*D1*Dd*Pk2*fd + 16*C*D1*Ddd*Pk2*f*r**2 - 16*C*D1*Ddd*Pk2*f*r + 8*C*D1*Ddd*Pk2*f + 48*C*Dd**2*Pk2*f*r**2 - 48*C*Dd**2*Pk2*f*r + 8*C*Dd**2*Pk2*f - 14*D1**2*K*Pk2*fd*r**2 + 84*D1**2*K*Pk2*fd*r*s - 84*D1**2*K*Pk2*fd*r - 84*D1**2*K*Pk2*fdd*r*s + 84*D1**2*K*Pk2*fdd*r + 2*D1**2*K*Pkdd2*fd*k1**2*s**2 - D1**2*K*Pkdd2*fdd*k1**2*s**2 + 56*D1**2*Pk2*f*fd*r**2 - 42*D1**2*Pk2*f*fd*r + 42*D1**2*Pk2*f*fd - 56*D1**2*Pk2*f*fdd*r**2 + 42*D1**2*Pk2*f*fdd*r - 42*D1**2*Pk2*f*fdd - 56*D1**2*Pk2*fd**2*r**2 + 42*D1**2*Pk2*fd**2*r + 14*D1**2*Pk2*fd**2 + 50*D1**2*Pk2*fd*r**2 + 26*D1**2*Pk2*fd*r + 8*D1**2*Pk2*fd - 32*D1**2*Pk2*fdd*r**2 - 34*D1**2*Pk2*fdd*r - 4*D1**2*Pk2*fdd - 56*D1**2*Pk2*gd2*r**2 + 112*D1**2*Pk2*gd2*r - 56*D1**2*Pk2*gd2 + 28*D1**2*Pk2*gdd2*r**2 - 56*D1**2*Pk2*gdd2*r + 28*D1**2*Pk2*gdd2 + 4*D1**2*Pkdd2*f*fd*k1**2*s**2 + 2*D1**2*Pkdd2*f*fd*k1**2*s - D1**2*Pkdd2*f*fd*k1**2 - D1**2*bdd1*(Pk2*(14*K - 14)*(3*r**2 - 2*r + 1) + Pkdd2*f*k1**2*(3*s**2 - 2*s + 1)) - 56*D1*Dd*K*Pk2*f*r**2 + 336*D1*Dd*K*Pk2*f*r*s - 28*D1*Dd*K*Pk2*f*r - 168*D1*Dd*K*Pk2*f*s - 28*D1*Dd*K*Pk2*f - 672*D1*Dd*K*Pk2*fd*r*s + 420*D1*Dd*K*Pk2*fd*r + 168*D1*Dd*K*Pk2*fd*s - 168*D1*Dd*K*Pk2*fd + 8*D1*Dd*K*Pkdd2*f*k1**2*s**2 - 4*D1*Dd*K*Pkdd2*f*k1**2*s + 2*D1*Dd*K*Pkdd2*f*k1**2 - 8*D1*Dd*K*Pkdd2*fd*k1**2*s**2 + 2*D1*Dd*K*Pkdd2*fd*k1**2*s + 112*D1*Dd*Pk2*f**2*r**2 - 112*D1*Dd*Pk2*f**2*r + 56*D1*Dd*Pk2*f**2 - 448*D1*Dd*Pk2*f*fd*r**2 + 392*D1*Dd*Pk2*f*fd*r - 84*D1*Dd*Pk2*f*fd + 200*D1*Dd*Pk2*f*r**2 - 200*D1*Dd*Pk2*f*r + 100*D1*Dd*Pk2*f - 256*D1*Dd*Pk2*fd*r**2 - 8*D1*Dd*Pk2*fd*r + 68*D1*Dd*Pk2*fd - 224*D1*Dd*Pk2*g2*r**2 + 224*D1*Dd*Pk2*g2*r - 112*D1*Dd*Pk2*g2 + 224*D1*Dd*Pk2*gd2*r**2 - 336*D1*Dd*Pk2*gd2*r + 112*D1*Dd*Pk2*gd2 + 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**2*k1**2*s + 2*D1*Dd*Pkdd2*f**2*k1**2 - 336*D1*Ddd*K*Pk2*f*r*s + 84*D1*Ddd*K*Pk2*f*r + 168*D1*Ddd*K*Pk2*f*s - 4*D1*Ddd*K*Pkdd2*f*k1**2*s**2 + 2*D1*Ddd*K*Pkdd2*f*k1**2*s - D1*Ddd*K*Pkdd2*f*k1**2 - 112*D1*Ddd*Pk2*f**2*r**2 + 112*D1*Ddd*Pk2*f**2*r - 56*D1*Ddd*Pk2*f**2 - 128*D1*Ddd*Pk2*f*r**2 + 128*D1*Ddd*Pk2*f*r - 64*D1*Ddd*Pk2*f + 112*D1*Ddd*Pk2*g2*r**2 - 112*D1*Ddd*Pk2*g2*r + 56*D1*Ddd*Pk2*g2 + 2*D1*bd1*(14*D1*Pk2*(K - 1)*(3*r**2 - 2*r + 1) + D1*Pkdd2*k1**2*(f*(3*s**2 - 2*s + 1) + fd*s*(1 - 3*s)) - 28*Dd*Pk2*(K - 1)*(6*r**2 - 5*r + 1) - Dd*Pkdd2*f*k1**2*(12*s**2 - 7*s + 1)) - 1008*Dd**2*K*Pk2*f*r*s + 252*Dd**2*K*Pk2*f*r + 504*Dd**2*K*Pk2*f*s - 168*Dd**2*K*Pk2*f - 12*Dd**2*K*Pkdd2*f*k1**2*s**2 + 6*Dd**2*K*Pkdd2*f*k1**2*s - 336*Dd**2*Pk2*f**2*r**2 + 336*Dd**2*Pk2*f**2*r - 56*Dd**2*Pk2*f**2 - 384*Dd**2*Pk2*f*r**2 + 384*Dd**2*Pk2*f*r - 64*Dd**2*Pk2*f + 336*Dd**2*Pk2*g2*r**2 - 336*Dd**2*Pk2*g2*r + 56*Dd**2*Pk2*g2) - 33*b1*(-8*C*D1**2*Pk2*f*fd*r**2 + 48*C*D1**2*Pk2*f*fd*r*s - 16*C*D1**2*Pk2*f*fd*r - 24*C*D1**2*Pk2*f*fd*s - 4*C*D1**2*Pk2*f*fd - 48*C*D1**2*Pk2*f*fdd*r*s + 24*C*D1**2*Pk2*f*fdd*r + 24*C*D1**2*Pk2*f*fdd*s - 48*C*D1**2*Pk2*fd**2*r*s + 24*C*D1**2*Pk2*fd**2*r + 24*C*D1**2*Pk2*fd**2*s - 24*C*D1**2*Pk2*fd**2 - 8*C*D1**2*Pkdd2*f*fd*k1**2*s**2 + 4*C*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 4*C*D1**2*Pkdd2*fd**2*k1**2*s**2 - 16*C*D1*Dd*Pk2*f**2*r**2 + 96*C*D1*Dd*Pk2*f**2*r*s - 8*C*D1*Dd*Pk2*f**2*r - 48*C*D1*Dd*Pk2*f**2*s - 8*C*D1*Dd*Pk2*f**2 - 384*C*D1*Dd*Pk2*f*fd*r*s + 144*C*D1*Dd*Pk2*f*fd*r + 192*C*D1*Dd*Pk2*f*fd*s - 72*C*D1*Dd*Pk2*f*fd - 16*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 8*C*D1*Dd*Pkdd2*f**2*k1**2*s - 4*C*D1*Dd*Pkdd2*f**2*k1**2 + 32*C*D1*Dd*Pkdd2*f*fd*k1**2*s**2 - 8*C*D1*Dd*Pkdd2*f*fd*k1**2*s - 96*C*D1*Ddd*Pk2*f**2*r*s + 24*C*D1*Ddd*Pk2*f**2*r + 48*C*D1*Ddd*Pk2*f**2*s + 8*C*D1*Ddd*Pkdd2*f**2*k1**2*s**2 - 4*C*D1*Ddd*Pkdd2*f**2*k1**2*s + 2*C*D1*Ddd*Pkdd2*f**2*k1**2 - 288*C*Dd**2*Pk2*f**2*r*s + 72*C*Dd**2*Pk2*f**2*r + 144*C*Dd**2*Pk2*f**2*s - 48*C*Dd**2*Pk2*f**2 + 24*C*Dd**2*Pkdd2*f**2*k1**2*s**2 - 12*C*Dd**2*Pkdd2*f**2*k1**2*s + 28*D1**2*K*Pk2*f*fd*r**2 + 168*D1**2*K*Pk2*f*fd*r*s - 84*D1**2*K*Pk2*f*fd*r + 168*D1**2*K*Pk2*f*fd*s**2 - 168*D1**2*K*Pk2*f*fd*s + 84*D1**2*K*Pk2*f*fd - 28*D1**2*K*Pk2*f*fdd*r**2 - 168*D1**2*K*Pk2*f*fdd*r*s + 84*D1**2*K*Pk2*f*fdd*r - 168*D1**2*K*Pk2*f*fdd*s**2 + 168*D1**2*K*Pk2*f*fdd*s - 84*D1**2*K*Pk2*f*fdd - 28*D1**2*K*Pk2*fd**2*r**2 - 168*D1**2*K*Pk2*fd**2*r*s + 84*D1**2*K*Pk2*fd**2*r - 168*D1**2*K*Pk2*fd**2*s**2 + 168*D1**2*K*Pk2*fd**2*s + 2*D1**2*K*Pkdd2*f*fd*k1**2*s**2 - 2*D1**2*K*Pkdd2*f*fd*k1**2*s + D1**2*K*Pkdd2*f*fd*k1**2 - 24*D1**2*Pk2*f*fd*r*s + 18*D1**2*Pk2*f*fd*r + 12*D1**2*Pk2*f*fd*s - 8*D1**2*Pk2*f*fdd*r**2 + 24*D1**2*Pk2*f*fdd*r*s - 10*D1**2*Pk2*f*fdd*r - 12*D1**2*Pk2*f*fdd*s - 4*D1**2*Pk2*f*fdd - 28*D1**2*Pk2*f*gd2*r**2 + 168*D1**2*Pk2*f*gd2*r*s + 56*D1**2*Pk2*f*gd2*r - 168*D1**2*Pk2*f*gd2*s - 28*D1**2*Pk2*f*gd2 - 168*D1**2*Pk2*f*gdd2*r*s + 168*D1**2*Pk2*f*gdd2*s - 8*D1**2*Pk2*fd**2*r**2 + 24*D1**2*Pk2*fd**2*r*s - 10*D1**2*Pk2*fd**2*r - 12*D1**2*Pk2*fd**2*s + 18*D1**2*Pk2*fd**2 - 28*D1**2*Pk2*fd*g2*r**2 + 168*D1**2*Pk2*fd*g2*r*s - 168*D1**2*Pk2*fd*g2*r - 336*D1**2*Pk2*fd*gd2*r*s + 168*D1**2*Pk2*fd*gd2*r + 168*D1**2*Pk2*fd*gd2*s - 168*D1**2*Pk2*fd*gd2 - 168*D1**2*Pk2*fdd*g2*r*s + 168*D1**2*Pk2*fdd*g2*r - 2*D1**2*Pkdd2*b2*fd*k1**2*s**2 + D1**2*Pkdd2*b2*fdd*k1**2*s**2 - 2*D1**2*Pkdd2*bd2*f*k1**2*s**2 + 2*D1**2*Pkdd2*bd2*fd*k1**2*s**2 + D1**2*Pkdd2*bdd2*f*k1**2*s**2 + 4*D1**2*Pkdd2*f*fd*k1**2*s**2 - 2*D1**2*Pkdd2*f*fdd*k1**2*s**2 + 4*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 2*D1**2*Pkdd2*f*gdd2*k1**2*s**2 - 2*D1**2*Pkdd2*fd**2*k1**2*s**2 + 4*D1**2*Pkdd2*fd*g2*k1**2*s**2 - 4*D1**2*Pkdd2*fd*gd2*k1**2*s**2 - 2*D1**2*Pkdd2*fdd*g2*k1**2*s**2 + 2*D1**2*bd1**2*(Pk2*r*(14*K - 14)*(3*r - 2) + Pkdd2*f*k1**2*s*(3*s - 2)) + D1**2*bdd1*(K*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1) + 14*Pk2*f**2*(4*r**2 - 5*r + 1) + Pk2*f*(-84*K*s - r**2*(8*C - 64) + 14*r*(12*K*s - 7) + 28) - 56*Pk2*g2*r**2) + 56*D1*Dd*K*Pk2*f**2*r**2 + 336*D1*Dd*K*Pk2*f**2*r*s - 140*D1*Dd*K*Pk2*f**2*r + 336*D1*Dd*K*Pk2*f**2*s**2 - 336*D1*Dd*K*Pk2*f**2*s + 112*D1*Dd*K*Pk2*f**2 - 224*D1*Dd*K*Pk2*f*fd*r**2 - 1344*D1*Dd*K*Pk2*f*fd*r*s + 616*D1*Dd*K*Pk2*f*fd*r - 1344*D1*Dd*K*Pk2*f*fd*s**2 + 1344*D1*Dd*K*Pk2*f*fd*s - 336*D1*Dd*K*Pk2*f*fd + 4*D1*Dd*K*Pkdd2*f**2*k1**2*s**2 - 2*D1*Dd*K*Pkdd2*f**2*k1**2*s + D1*Dd*K*Pkdd2*f**2*k1**2 - 48*D1*Dd*Pk2*f**2*r*s + 12*D1*Dd*Pk2*f**2*r + 24*D1*Dd*Pk2*f**2*s - 64*D1*Dd*Pk2*f*fd*r**2 + 192*D1*Dd*Pk2*f*fd*r*s - 32*D1*Dd*Pk2*f*fd*r - 96*D1*Dd*Pk2*f*fd*s + 32*D1*Dd*Pk2*f*fd - 112*D1*Dd*Pk2*f*g2*r**2 + 672*D1*Dd*Pk2*f*g2*r*s - 56*D1*Dd*Pk2*f*g2*r - 336*D1*Dd*Pk2*f*g2*s - 56*D1*Dd*Pk2*f*g2 - 1344*D1*Dd*Pk2*f*gd2*r*s + 168*D1*Dd*Pk2*f*gd2*r + 1008*D1*Dd*Pk2*f*gd2*s - 168*D1*Dd*Pk2*f*gd2 - 1344*D1*Dd*Pk2*fd*g2*r*s + 840*D1*Dd*Pk2*fd*g2*r + 336*D1*Dd*Pk2*fd*g2*s - 336*D1*Dd*Pk2*fd*g2 - 8*D1*Dd*Pkdd2*b2*f*k1**2*s**2 + 4*D1*Dd*Pkdd2*b2*f*k1**2*s - 2*D1*Dd*Pkdd2*b2*f*k1**2 + 8*D1*Dd*Pkdd2*b2*fd*k1**2*s**2 - 2*D1*Dd*Pkdd2*b2*fd*k1**2*s + 8*D1*Dd*Pkdd2*bd2*f*k1**2*s**2 - 2*D1*Dd*Pkdd2*bd2*f*k1**2*s + 8*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 4*D1*Dd*Pkdd2*f**2*k1**2*s + 2*D1*Dd*Pkdd2*f**2*k1**2 - 16*D1*Dd*Pkdd2*f*fd*k1**2*s**2 + 4*D1*Dd*Pkdd2*f*fd*k1**2*s + 16*D1*Dd*Pkdd2*f*g2*k1**2*s**2 - 8*D1*Dd*Pkdd2*f*g2*k1**2*s + 4*D1*Dd*Pkdd2*f*g2*k1**2 - 16*D1*Dd*Pkdd2*f*gd2*k1**2*s**2 + 4*D1*Dd*Pkdd2*f*gd2*k1**2*s - 16*D1*Dd*Pkdd2*fd*g2*k1**2*s**2 + 4*D1*Dd*Pkdd2*fd*g2*k1**2*s - 56*D1*Ddd*K*Pk2*f**2*r**2 - 336*D1*Ddd*K*Pk2*f**2*r*s + 140*D1*Ddd*K*Pk2*f**2*r - 336*D1*Ddd*K*Pk2*f**2*s**2 + 336*D1*Ddd*K*Pk2*f**2*s - 112*D1*Ddd*K*Pk2*f**2 - 16*D1*Ddd*Pk2*f**2*r**2 + 48*D1*Ddd*Pk2*f**2*r*s + 4*D1*Ddd*Pk2*f**2*r - 24*D1*Ddd*Pk2*f**2*s - 8*D1*Ddd*Pk2*f**2 - 672*D1*Ddd*Pk2*f*g2*r*s + 168*D1*Ddd*Pk2*f*g2*r + 336*D1*Ddd*Pk2*f*g2*s + 4*D1*Ddd*Pkdd2*b2*f*k1**2*s**2 - 2*D1*Ddd*Pkdd2*b2*f*k1**2*s + D1*Ddd*Pkdd2*b2*f*k1**2 - 4*D1*Ddd*Pkdd2*f**2*k1**2*s**2 + 2*D1*Ddd*Pkdd2*f**2*k1**2*s - D1*Ddd*Pkdd2*f**2*k1**2 - 8*D1*Ddd*Pkdd2*f*g2*k1**2*s**2 + 4*D1*Ddd*Pkdd2*f*g2*k1**2*s - 2*D1*Ddd*Pkdd2*f*g2*k1**2 + D1*bd1*(D1*(-2*K*Pkdd2*fd*k1**2*s*(1 - 2*s) - 2*Pk2*fd*(-42*K*(r*(4*s - 2) - s + 1) + r**2*(8*C - 64) + r*(15 - 8*C) + 21) + 112*Pk2*r*(g2*r - gd2*r + gd2) - f**2*(14*Pk2*(4*r**2 - 5*r + 1) + Pkdd2*k1**2*(4*s**2 - 6*s + 3)) + 2*f*(K*Pkdd2*k1**2*(-2*s**2 + 2*s - 1) + Pk2*(8*C*r**2 + 7*K*(2*r**2 - 2*r*(6*s + 1) + 6*s + 1) + 14*fd*(8*r**2 - 8*r + 1) - 50*r**2 + 63*r - 21))) + 2*Dd*(K*Pkdd2*f*k1**2*(8*s**2 - 6*s + 1) + 14*Pk2*f**2*(16*r**2 - 18*r + 5) - 2*Pk2*f*(2*r - 1)*(-21*K*(8*s - 1) + r*(8*C - 64) + 49) + 112*Pk2*g2*r*(1 - 2*r))) - 168*Dd**2*K*Pk2*f**2*r**2 - 1008*Dd**2*K*Pk2*f**2*r*s + 420*Dd**2*K*Pk2*f**2*r - 1008*Dd**2*K*Pk2*f**2*s**2 + 1008*Dd**2*K*Pk2*f**2*s - 196*Dd**2*K*Pk2*f**2 - 48*Dd**2*Pk2*f**2*r**2 + 144*Dd**2*Pk2*f**2*r*s + 12*Dd**2*Pk2*f**2*r - 72*Dd**2*Pk2*f**2*s + 16*Dd**2*Pk2*f**2 - 2016*Dd**2*Pk2*f*g2*r*s + 504*Dd**2*Pk2*f*g2*r + 1008*Dd**2*Pk2*f*g2*s - 336*Dd**2*Pk2*f*g2 + 12*Dd**2*Pkdd2*b2*f*k1**2*s**2 - 6*Dd**2*Pkdd2*b2*f*k1**2*s - 12*Dd**2*Pkdd2*f**2*k1**2*s**2 + 6*Dd**2*Pkdd2*f**2*k1**2*s - 24*Dd**2*Pkdd2*f*g2*k1**2*s**2 + 12*Dd**2*Pkdd2*f*g2*k1**2*s))/(1386*d**2*k3**2) - D1**2*Pk3*(7*D1*Pkdd2*b1**3*k1**2*(D1*fd*s**2 + Dd*f*(4*s**2 - 2*s + 1)) + D1*f*(-2*D1*Pk2*bd1**2*(r*(36*C - 27)*(2*s - 1) + s*(28*C - 14)*(s - 1)) + 2*D1*Pk2*bdd1*f*(2*C - 1)*(8*r**2 + 18*r*(s - 1) - 14*s + 7) + bd1*(D1*(Pk2*fd*(8*C - 4)*(16*r**2 + r*(36*s - 26) - 16*s + 9) + Pkdd2*k1**2*(7*b2 - 14*g2)*(s - 1)**2 + f*(2 - 4*C)*(Pk2*(16*r**2 + 18*r*(s - 1) - 14*s + 7) - 3*Pkdd2*k1**2*(s - 1)**2)) + Dd*Pk2*f*(8*C - 4)*(32*r**2 + r*(72*s - 61) - 46*s + 25))) + b1**2*(D1**2*(2*Pk2*fdd*s*(-2*C*(18*r + 7*s - 18) + 27*r + 7*s - 27) + 7*Pkdd2*bd1*f*k1**2*(3*s**2 - 2*s + 1) + fd*(7*K*Pkdd2*k1**2*s**2 - 2*Pk2*(2*C*(7*r**2 + 6*r*s - 14*r + 7*s**2 - 6*s + 7) - 14*r**2 - 9*r*s + 28*r - 7*s**2 + 9*s - 14))) + D1*(Dd*(2*Pk2*fd*(-4*C*(9*r*(8*s - 1) + 28*s**2 - 61*s + 9) + 27*r*(8*s - 1) + 56*s**2 - 176*s + 27) + f*(7*K*Pkdd2*k1**2*(4*s**2 - 2*s + 1) - 2*Pk2*(C*(56*r**2 + 48*r*s - 68*r + 56*s**2 - 52*s + 42) - 56*r**2 - 36*r*s + 65*r - 28*s**2 + 32*s - 35))) + 2*Ddd*Pk2*f*(-2*C*(18*r*(4*s - 1) + 28*s**2 - 50*s + 7) + 27*r*(4*s - 1) + 28*s**2 - 68*s + 7)) - 6*Dd**2*Pk2*f*(4*C*(9*r*(4*s - 1) + 14*s**2 - 25*s + 6) - 27*r*(4*s - 1) - 28*s**2 + 68*s - 18)) + b1*(-128*C*D1**2*Pk2*f*fd*r**2 - 144*C*D1**2*Pk2*f*fd*r*s + 128*C*D1**2*Pk2*f*fd*r + 16*C*D1**2*Pk2*f*fd*s - 36*C*D1**2*Pk2*f*fd + 64*C*D1**2*Pk2*f*fdd*r**2 + 144*C*D1**2*Pk2*f*fdd*r*s - 64*C*D1**2*Pk2*f*fdd*r - 16*C*D1**2*Pk2*f*fdd*s + 4*C*D1**2*Pk2*f*fdd + 64*C*D1**2*Pk2*fd**2*r**2 + 144*C*D1**2*Pk2*fd**2*r*s - 64*C*D1**2*Pk2*fd**2*r - 16*C*D1**2*Pk2*fd**2*s + 24*C*D1**2*Pkdd2*f*fd*k1**2*s**2 - 256*C*D1*Dd*Pk2*f**2*r**2 - 288*C*D1*Dd*Pk2*f**2*r*s + 328*C*D1*Dd*Pk2*f**2*r + 144*C*D1*Dd*Pk2*f**2*s - 128*C*D1*Dd*Pk2*f**2 + 512*C*D1*Dd*Pk2*f*fd*r**2 + 1152*C*D1*Dd*Pk2*f*fd*r*s - 656*C*D1*Dd*Pk2*f*fd*r - 352*C*D1*Dd*Pk2*f*fd*s + 144*C*D1*Dd*Pk2*f*fd + 48*C*D1*Dd*Pkdd2*f**2*k1**2*s**2 - 24*C*D1*Dd*Pkdd2*f**2*k1**2*s + 12*C*D1*Dd*Pkdd2*f**2*k1**2 + 128*C*D1*Ddd*Pk2*f**2*r**2 + 288*C*D1*Ddd*Pk2*f**2*r*s - 200*C*D1*Ddd*Pk2*f**2*r - 144*C*D1*Ddd*Pk2*f**2*s + 64*C*D1*Ddd*Pk2*f**2 + 384*C*Dd**2*Pk2*f**2*r**2 + 864*C*Dd**2*Pk2*f**2*r*s - 600*C*Dd**2*Pk2*f**2*r - 432*C*Dd**2*Pk2*f**2*s + 208*C*Dd**2*Pk2*f**2 - 2*D1**2*Pk2*bdd1*f*(2*C*(36*r*s - 18*r + 14*s**2 - 14*s + 7) - 54*r*s + 27*r - 14*s**2 + 14*s - 7) + 64*D1**2*Pk2*f*fd*r**2 + 72*D1**2*Pk2*f*fd*r*s - 64*D1**2*Pk2*f*fd*r - 8*D1**2*Pk2*f*fd*s + 18*D1**2*Pk2*f*fd - 32*D1**2*Pk2*f*fdd*r**2 - 72*D1**2*Pk2*f*fdd*r*s + 32*D1**2*Pk2*f*fdd*r + 8*D1**2*Pk2*f*fdd*s - 2*D1**2*Pk2*f*fdd - 32*D1**2*Pk2*fd**2*r**2 - 72*D1**2*Pk2*fd**2*r*s + 32*D1**2*Pk2*fd**2*r + 8*D1**2*Pk2*fd**2*s + 7*D1**2*Pkdd2*b2*fd*k1**2*s**2 + 7*D1**2*Pkdd2*bd2*f*k1**2*s**2 - 12*D1**2*Pkdd2*f*fd*k1**2*s**2 - 14*D1**2*Pkdd2*f*gd2*k1**2*s**2 - 14*D1**2*Pkdd2*fd*g2*k1**2*s**2 + 128*D1*Dd*Pk2*f**2*r**2 + 144*D1*Dd*Pk2*f**2*r*s - 164*D1*Dd*Pk2*f**2*r - 72*D1*Dd*Pk2*f**2*s + 64*D1*Dd*Pk2*f**2 - 256*D1*Dd*Pk2*f*fd*r**2 - 576*D1*Dd*Pk2*f*fd*r*s + 328*D1*Dd*Pk2*f*fd*r + 176*D1*Dd*Pk2*f*fd*s - 72*D1*Dd*Pk2*f*fd + 28*D1*Dd*Pkdd2*b2*f*k1**2*s**2 - 14*D1*Dd*Pkdd2*b2*f*k1**2*s + 7*D1*Dd*Pkdd2*b2*f*k1**2 - 24*D1*Dd*Pkdd2*f**2*k1**2*s**2 + 12*D1*Dd*Pkdd2*f**2*k1**2*s - 6*D1*Dd*Pkdd2*f**2*k1**2 - 56*D1*Dd*Pkdd2*f*g2*k1**2*s**2 + 28*D1*Dd*Pkdd2*f*g2*k1**2*s - 14*D1*Dd*Pkdd2*f*g2*k1**2 - 64*D1*Ddd*Pk2*f**2*r**2 - 144*D1*Ddd*Pk2*f**2*r*s + 100*D1*Ddd*Pk2*f**2*r + 72*D1*Ddd*Pk2*f**2*s - 32*D1*Ddd*Pk2*f**2 + D1*bd1*(D1*(2*Pk2*fd*(-4*C*(9*r*(4*s - 1) + 14*s**2 - 25*s + 9) + 27*r*(4*s - 1) + 28*s**2 - 68*s + 27) + f*(7*K*Pkdd2*k1**2*(2*s**2 - 2*s + 1) - 2*Pk2*(2*C*(14*r**2 + 12*r*s - 6*r + 14*s**2 - 14*s + 7) - 28*r**2 - 18*r*s + 9*r - 14*s**2 + 14*s - 7))) - 4*Dd*Pk2*f*(2*C*(18*r*(8*s - 3) + 56*s**2 - 78*s + 25) - 27*r*(8*s - 3) - 56*s**2 + 96*s - 34)) - 192*Dd**2*Pk2*f**2*r**2 - 432*Dd**2*Pk2*f**2*r*s + 300*Dd**2*Pk2*f**2*r + 216*Dd**2*Pk2*f**2*s - 104*Dd**2*Pk2*f**2))/(21*d**2*k3**2) + D1**2*Pk3*k2**4*st**4*(D1**2*(33*Pkdd2*k1**2*s*(b1*s*(2*K*b1*fd - K*b1*fdd - 4*fd*g2 + 4*fd*gd2 + 2*fdd*g2) + 2*bd1*fd*(K*b1*(1 - 2*s) + 2*g2*(s - 1))) + f**2*(Pk2*fd*(100*C - 50)*(3*r**2 - 2*r + 1) - Pk2*fdd*(116*C - 58)*(3*r**2 - 2*r + 1) + Pkdd2*k1**2*s**2*(-33*K*bd1 + 66*gd2)) + f*(-696*C*Pk2*fd**2*r**2 + 464*C*Pk2*fd**2*r - 66*K*Pkdd2*b1*fd*k1**2*s**2 + 66*K*Pkdd2*b1*fd*k1**2*s - 33*K*Pkdd2*b1*fd*k1**2 - 66*K*Pkdd2*bd1**2*k1**2*s*(s - 1) + 348*Pk2*fd**2*r**2 - 232*Pk2*fd**2*r - 132*Pkdd2*b1*gd2*k1**2*s**2 + 66*Pkdd2*b1*gdd2*k1**2*s**2 - 66*Pkdd2*bd1*k1**2*(-K*b1*(2*s**2 - 2*s + 1) + 2*g2*(s - 1)**2 - 2*gd2*s*(s - 1)) + 33*Pkdd2*bdd1*k1**2*(K*b1*(-2*s**2 + 2*s - 1) + 2*g2*(s - 1)**2) + 132*Pkdd2*fd*g2*k1**2*s**2 - 132*Pkdd2*fd*g2*k1**2*s + 66*Pkdd2*fd*g2*k1**2)) + D1*(Dd*(Pk2*f**3*(200*C - 100)*(2*r**2 - 2*r + 1) - 66*Pkdd2*b1*fd*k1**2*s*(4*s - 1)*(K*b1 - 2*g2) + 66*Pkdd2*f*k1**2*(K*b1**2*(4*s**2 - 2*s + 1) - b1*(g2*(8*s**2 - 4*s + 2) + (4*s - 1)*(K*bd1*(2*s - 1) - 2*gd2*s)) + 2*bd1*g2*(4*s**2 - 5*s + 1)) + f**2*(Pk2*fd*(232 - 464*C)*(6*r**2 - 5*r + 1) + Pkdd2*k1**2*(-33*K*b1 + 66*g2)*(4*s**2 - 2*s + 1))) + Ddd*f*(Pk2*f**2*(116 - 232*C)*(2*r**2 - 2*r + 1) - 33*Pkdd2*b1*k1**2*(K*b1 - 2*g2)*(4*s**2 - 2*s + 1))) - 2*Dd**2*f*(Pk2*f**2*(116*C - 58)*(6*r**2 - 6*r + 1) + 99*Pkdd2*b1*k1**2*s*(2*s - 1)*(K*b1 - 2*g2)))/(231*d**2*k1**2*k3**4) - D1**2*Pk3*k2**4*st**2*(7*D1*K*Pkdd2*b1**2*k1**2*(D1*fd*s**2 + Dd*f*(4*s**2 - 2*s + 1)) + D1*f*(16*D1*Pk2*bdd1*f*r**2*(2*C - 1) + D1*bd1*(Pk2*fd*r*(64*C - 32)*(2*r - 1) - 14*Pkdd2*g2*k1**2*(s - 1)**2 - f*(2*C - 1)*(12*Pk2*r**2 + Pkdd2*k1**2*(s - 1)**2)) + 64*Dd*Pk2*bd1*f*r*(2*C - 1)*(2*r - 1)) + b1*(D1**2*(f*(Pk2*fdd*(32*C - 16)*(2*r**2 - 2*r + 1) + 7*Pkdd2*k1**2*(K*bd1*(2*s**2 - 2*s + 1) - 2*gd2*s**2) - fd*(4*C - 2)*(6*Pk2*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*s**2)) + 2*fd*(Pk2*fd*r*(32*C - 16)*(r - 1) - 7*Pkdd2*g2*k1**2*s**2)) + D1*f*(Dd*(Pk2*fd*(1 - 2*r)**2*(128*C - 64) - 14*Pkdd2*g2*k1**2*(4*s**2 - 2*s + 1) - f*(2*C - 1)*(24*Pk2*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1))) + Ddd*Pk2*f*(64*C - 32)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f**2*(64*C - 32)*(6*r**2 - 6*r + 1)))/(42*d**2*k1**2*k3**4) + D1**2*Pk3*k2**2*st**4*(D1**2*(-33*Pkdd2*k1**2*(K*b1**2*(2*fd - fdd)*(2*s - 1) - b1*(b2*fdd*s**2 + 4*fd*g2*(2*s - 1) + 2*fd*s*(K*bd1 - b2*s + bd2*s - 2*gd2) + fdd*g2*(2 - 4*s)) - 2*b2*bd1*fd*s*(s - 1)) + f**2*(Pk2*fd*(50 - 100*C)*(3*r**2 - 2*r + 1) + Pk2*fdd*(116*C - 58)*(3*r**2 - 2*r + 1) + Pkdd2*k1**2*s**2*(33*K*bd1 + 33*bd2 - 66*gd2)) + f*(696*C*Pk2*fd**2*r**2 - 464*C*Pk2*fd**2*r - 66*K*Pkdd2*b1*bdd1*k1**2*s + 33*K*Pkdd2*b1*bdd1*k1**2 + 66*K*Pkdd2*b1*fd*k1**2*s**2 - 66*K*Pkdd2*b1*fd*k1**2*s + 33*K*Pkdd2*b1*fd*k1**2 - 66*K*Pkdd2*bd1**2*k1**2*s - 348*Pk2*fd**2*r**2 + 232*Pk2*fd**2*r - 66*Pkdd2*b1*bd2*k1**2*s**2 + 33*Pkdd2*b1*bdd2*k1**2*s**2 + 33*Pkdd2*b2*k1**2*(-2*bd1*(s - 1)**2 + bdd1*(s - 1)**2 + fd*(2*s**2 - 2*s + 1)) + 66*Pkdd2*bd1*k1**2*(K*b1*(2*s - 1) + bd2*s*(s - 1) + g2*(2 - 4*s) + 2*gd2*s) + 132*Pkdd2*bdd1*g2*k1**2*s - 66*Pkdd2*bdd1*g2*k1**2 - 132*Pkdd2*fd*g2*k1**2*s**2 + 132*Pkdd2*fd*g2*k1**2*s - 66*Pkdd2*fd*g2*k1**2)) + D1*(Dd*(Pk2*f**3*(100 - 200*C)*(2*r**2 - 2*r + 1) + 66*Pkdd2*b1*fd*k1**2*(4*s - 1)*(K*b1 + b2*s - 2*g2) - 66*Pkdd2*f*k1**2*(b1*(b2*(4*s**2 - 2*s + 1) + (4*s - 1)*(K*bd1 - bd2*s)) - bd1*(4*s - 1)*(b2*(s - 1) + 2*g2)) + f**2*(Pk2*fd*(464*C - 232)*(6*r**2 - 5*r + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)*(33*K*b1 + 33*b2 - 66*g2))) + Ddd*f*(Pk2*f**2*(232*C - 116)*(2*r**2 - 2*r + 1) + 33*Pkdd2*b1*b2*k1**2*(4*s**2 - 2*s + 1))) + 2*Dd**2*f*(Pk2*f**2*(116*C - 58)*(6*r**2 - 6*r + 1) + 99*Pkdd2*b1*b2*k1**2*s*(2*s - 1)))/(231*d**2*k1**2*k3**2) + D1**2*Pk3*k2**2*(2*C - 1)*(-44*D1**2*Pk2*bd1**2*f*r**2 + D1*b1*(-44*D1*Pk2*bdd1*f*r**2 + D1*bd1*(4*Pk2*f*r**2 - 88*Pk2*fd*r*(r - 1) + 7*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) + 176*Dd*Pk2*bd1*f*r*(1 - 2*r)) + b1**2*(D1**2*(-22*Pk2*fdd*(r - 1)**2 + fd*(2*Pk2*(r - 1)**2 + 7*Pkdd2*k1**2*s**2)) + D1*(Dd*(Pk2*f*(8*r**2 - 8*r + 4) - 88*Pk2*fd*(2*r**2 - 3*r + 1) + 7*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 44*Ddd*Pk2*f*(2*r**2 - 2*r + 1)) - 44*Dd**2*Pk2*f*(6*r**2 - 6*r + 1)))/(21*d**2*k1**2*k3**2) + D1**2*Pk3*st**2*(D1*(16*D1*Pk2*bdd1*f**2*r**2*(2*C - 1) + 2*D1*Pkdd2*bd1**2*k1**2*s*(s - 1)*(-2*C*f + 7*b2 + f - 14*g2) + bd1*f*(D1*(Pk2*fd*r*(64*C - 32)*(2*r - 1) + Pkdd2*k1**2*s**2*(7*b2 - 14*g2) - f*(2*C - 1)*(12*Pk2*r**2 + Pkdd2*k1**2*s**2)) + Dd*Pk2*f*r*(128*C - 64)*(2*r - 1))) - 7*K*Pkdd2*b1**3*k1**2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s)) + Pkdd2*b1**2*k1**2*(D1**2*(4*C*fd*s**2 - 2*C*fdd*s**2 - 14*K*bd1*(3*s**2 - 2*s + 1) + 7*K*bdd1*(3*s**2 - 2*s + 1) + 7*K*fd*s**2 - 14*K*fd*s + 7*K*fd - 14*bd2*s**2 + 7*bdd2*s**2 - 2*fd*s**2 + fdd*s**2 + 28*gd2*s**2 - 14*gdd2*s**2) + D1*(Dd*(f*(4*C + 7*K - 2)*(4*s**2 - 2*s + 1) + 28*g2*(4*s**2 - 2*s + 1) + (8*s - 2)*(7*K*bd1*(3*s - 1) + s*(-2*C*fd + 7*bd2 + fd - 14*gd2))) - Ddd*(f*(2*C - 1) + 14*g2)*(4*s**2 - 2*s + 1)) - 6*Dd**2*s*(2*s - 1)*(f*(2*C - 1) + 14*g2) - 7*b2*(D1*(2*Dd - Ddd)*(4*s**2 - 2*s + 1) + 6*Dd**2*s*(1 - 2*s))) + b1*(D1**2*(14*K*Pkdd2*bd1**2*k1**2*s*(3*s - 2) + 7*Pkdd2*b2*k1**2*(bd1*(-4*s**2 + 4*s - 2) + bdd1*(2*s**2 - 2*s + 1) + fd*(s - 1)**2) + 2*Pkdd2*bd1*k1**2*(14*g2*(2*s**2 - 2*s + 1) + s*(2*s - 1)*(-2*C*fd + 7*bd2 + fd - 14*gd2)) - 14*Pkdd2*bdd1*g2*k1**2*(2*s**2 - 2*s + 1) + f*(Pk2*fdd*(32*C - 16)*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(2*bd1*(C*(4*s**2 - 4*s + 2) + s**2*(7*K - 2) + 2*s - 1) - bdd1*(2*C - 1)*(2*s**2 - 2*s + 1) + s**2*(7*bd2 - 14*gd2)) - fd*(2*C - 1)*(12*Pk2*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(2*s**2 - 2*s + 1))) + 2*fd*(Pk2*fd*r*(32*C - 16)*(r - 1) - 7*Pkdd2*g2*k1**2*(s - 1)**2)) + D1*(Dd*(14*Pkdd2*bd1*k1**2*(b2 - 2*g2)*(8*s**2 - 6*s + 1) - f**2*(2*C - 1)*(24*Pk2*(2*r**2 - 2*r + 1) + Pkdd2*k1**2*(4*s**2 - 2*s + 1)) + f*(Pk2*fd*(1 - 2*r)**2*(128*C - 64) + Pkdd2*k1**2*(7*b2*(4*s**2 - 2*s + 1) - 2*bd1*(2*C - 1)*(8*s**2 - 6*s + 1) - 14*g2*(4*s**2 - 2*s + 1)))) + Ddd*Pk2*f**2*(64*C - 32)*(2*r**2 - 2*r + 1)) + Dd**2*Pk2*f**2*(64*C - 32)*(6*r**2 - 6*r + 1)))/(42*d**2*k1**2) - D1**2*Pk3*(2*C - 1)*(-44*D1**2*Pk2*bd1**2*f*r**2 + D1*b1*(-44*D1*Pk2*bdd1*f*r**2 + D1*bd1*(4*Pk2*f*r**2 - 88*Pk2*fd*r*(r - 1) + 7*Pkdd2*f*k1**2*(2*s**2 - 2*s + 1)) + 176*Dd*Pk2*bd1*f*r*(1 - 2*r)) + b1**2*(D1**2*(-22*Pk2*fdd*(r - 1)**2 + fd*(2*Pk2*(r - 1)**2 + 7*Pkdd2*k1**2*s**2)) + D1*(Dd*(Pk2*f*(8*r**2 - 8*r + 4) - 88*Pk2*fd*(2*r**2 - 3*r + 1) + 7*Pkdd2*f*k1**2*(4*s**2 - 2*s + 1)) - 44*Ddd*Pk2*f*(2*r**2 - 2*r + 1)) - 44*Dd**2*Pk2*f*(6*r**2 - 6*r + 1)))/(21*d**2*k1**2) - D1**2*Pkd2*Pkd3*b1*k1**2*st**2*(D1**2*bd1**2*f*(r*(2 - 6*s) - 6*s**2 + 6*s - 1) + D1*b1*(D1*bd1*(f*(r*(6*s - 2) + 6*s**2 - 6*s + 2) + fd*(-6*r*s + r - 6*s**2 + 6*s - 1)) + D1*bdd1*f*(-3*r*s + r - 3*s**2 + 3*s - 1) + Dd*bd1*f*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) + b1**2*(D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r - 8*s**2 + 8*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(21*d**2*k2*k3) - 10*D1**2*Pkd2*Pkd3*ct**8*k1**2*k2**3*(4368*C*D1**2*f**2*fd*r*s - 1456*C*D1**2*f**2*fd*r + 4368*C*D1**2*f**2*fd*s**2 - 4368*C*D1**2*f**2*fd*s + 1456*C*D1**2*f**2*fd - 2184*C*D1**2*f**2*fdd*r*s + 728*C*D1**2*f**2*fdd*r - 2184*C*D1**2*f**2*fdd*s**2 + 2184*C*D1**2*f**2*fdd*s - 728*C*D1**2*f**2*fdd - 4368*C*D1**2*f*fd**2*r*s + 1456*C*D1**2*f*fd**2*r - 4368*C*D1**2*f*fd**2*s**2 + 4368*C*D1**2*f*fd**2*s - 728*C*D1**2*f*fd**2 + 5824*C*D1*Dd*f**3*r*s - 1456*C*D1*Dd*f**3*r + 5824*C*D1*Dd*f**3*s**2 - 5824*C*D1*Dd*f**3*s + 1456*C*D1*Dd*f**3 - 17472*C*D1*Dd*f**2*fd*r*s + 5096*C*D1*Dd*f**2*fd*r - 17472*C*D1*Dd*f**2*fd*s**2 + 17472*C*D1*Dd*f**2*fd*s - 3640*C*D1*Dd*f**2*fd - 2912*C*D1*Ddd*f**3*r*s + 728*C*D1*Ddd*f**3*r - 2912*C*D1*Ddd*f**3*s**2 + 2912*C*D1*Ddd*f**3*s - 728*C*D1*Ddd*f**3 - 8736*C*Dd**2*f**3*r*s + 2184*C*Dd**2*f**3*r - 8736*C*Dd**2*f**3*s**2 + 8736*C*Dd**2*f**3*s - 1456*C*Dd**2*f**3 - 429*D1**2*K*bdd1*f**2*r*s - 429*D1**2*K*bdd1*f**2*s**2 + 429*D1**2*K*bdd1*f**2*s + 429*D1**2*bdd1*f**2*r*s + 429*D1**2*bdd1*f**2*s**2 - 429*D1**2*bdd1*f**2*s + 2520*D1**2*f**3*fd*r*s - 630*D1**2*f**3*fd*r + 2520*D1**2*f**3*fd*s**2 - 2520*D1**2*f**3*fd*s + 630*D1**2*f**3*fd - 1260*D1**2*f**3*fdd*r*s + 315*D1**2*f**3*fdd*r - 1260*D1**2*f**3*fdd*s**2 + 1260*D1**2*f**3*fdd*s - 315*D1**2*f**3*fdd - 3780*D1**2*f**2*fd**2*r*s + 945*D1**2*f**2*fd**2*r - 3780*D1**2*f**2*fd**2*s**2 + 3780*D1**2*f**2*fd**2*s - 630*D1**2*f**2*fd**2 - 4368*D1**2*f**2*fd*r*s + 1456*D1**2*f**2*fd*r - 4368*D1**2*f**2*fd*s**2 + 4368*D1**2*f**2*fd*s - 1456*D1**2*f**2*fd + 2184*D1**2*f**2*fdd*r*s - 728*D1**2*f**2*fdd*r + 2184*D1**2*f**2*fdd*s**2 - 2184*D1**2*f**2*fdd*s + 728*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r*s - 1716*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s + 858*D1**2*f**2*gdd2*r*s + 858*D1**2*f**2*gdd2*s**2 - 858*D1**2*f**2*gdd2*s + 4368*D1**2*f*fd**2*r*s - 1456*D1**2*f*fd**2*r + 4368*D1**2*f*fd**2*s**2 - 4368*D1**2*f*fd**2*s + 728*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r*s - 858*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 3432*D1**2*f*fd*gd2*s + 858*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r*s - 858*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r*s - 858*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s + 2520*D1*Dd*f**4*r*s - 630*D1*Dd*f**4*r + 2520*D1*Dd*f**4*s**2 - 2520*D1*Dd*f**4*s + 630*D1*Dd*f**4 - 10080*D1*Dd*f**3*fd*r*s + 2520*D1*Dd*f**3*fd*r - 10080*D1*Dd*f**3*fd*s**2 + 10080*D1*Dd*f**3*fd*s - 1890*D1*Dd*f**3*fd - 5824*D1*Dd*f**3*r*s + 1456*D1*Dd*f**3*r - 5824*D1*Dd*f**3*s**2 + 5824*D1*Dd*f**3*s - 1456*D1*Dd*f**3 + 17472*D1*Dd*f**2*fd*r*s - 5096*D1*Dd*f**2*fd*r + 17472*D1*Dd*f**2*fd*s**2 - 17472*D1*Dd*f**2*fd*s + 3640*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r*s + 1716*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 6864*D1*Dd*f**2*g2*s - 1716*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r*s - 858*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 6864*D1*Dd*f**2*gd2*s + 858*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r*s - 5148*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 13728*D1*Dd*f*fd*g2*s + 3432*D1*Dd*f*fd*g2 - 1260*D1*Ddd*f**4*r*s + 315*D1*Ddd*f**4*r - 1260*D1*Ddd*f**4*s**2 + 1260*D1*Ddd*f**4*s - 315*D1*Ddd*f**4 + 2912*D1*Ddd*f**3*r*s - 728*D1*Ddd*f**3*r + 2912*D1*Ddd*f**3*s**2 - 2912*D1*Ddd*f**3*s + 728*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r*s - 858*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 3432*D1*Ddd*f**2*g2*s + 858*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 3780*Dd**2*f**4*r*s + 945*Dd**2*f**4*r - 3780*Dd**2*f**4*s**2 + 3780*Dd**2*f**4*s - 630*Dd**2*f**4 + 8736*Dd**2*f**3*r*s - 2184*Dd**2*f**3*r + 8736*Dd**2*f**3*s**2 - 8736*Dd**2*f**3*s + 1456*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r*s - 2574*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 10296*Dd**2*f**2*g2*s + 1716*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**7*k1**3*k2**2*(52650*C*D1**2*f**2*fd*r*s - 17550*C*D1**2*f**2*fd*r + 52650*C*D1**2*f**2*fd*s**2 - 52650*C*D1**2*f**2*fd*s + 17550*C*D1**2*f**2*fd - 32760*C*D1**2*f**2*fdd*r*s + 10920*C*D1**2*f**2*fdd*r - 32760*C*D1**2*f**2*fdd*s**2 + 32760*C*D1**2*f**2*fdd*s - 10920*C*D1**2*f**2*fdd - 65520*C*D1**2*f*fd**2*r*s + 21840*C*D1**2*f*fd**2*r - 65520*C*D1**2*f*fd**2*s**2 + 65520*C*D1**2*f*fd**2*s - 10920*C*D1**2*f*fd**2 + 70200*C*D1*Dd*f**3*r*s - 17550*C*D1*Dd*f**3*r + 70200*C*D1*Dd*f**3*s**2 - 70200*C*D1*Dd*f**3*s + 17550*C*D1*Dd*f**3 - 262080*C*D1*Dd*f**2*fd*r*s + 76440*C*D1*Dd*f**2*fd*r - 262080*C*D1*Dd*f**2*fd*s**2 + 262080*C*D1*Dd*f**2*fd*s - 54600*C*D1*Dd*f**2*fd - 43680*C*D1*Ddd*f**3*r*s + 10920*C*D1*Ddd*f**3*r - 43680*C*D1*Ddd*f**3*s**2 + 43680*C*D1*Ddd*f**3*s - 10920*C*D1*Ddd*f**3 - 131040*C*Dd**2*f**3*r*s + 32760*C*Dd**2*f**3*r - 131040*C*Dd**2*f**3*s**2 + 131040*C*Dd**2*f**3*s - 21840*C*Dd**2*f**3 - 6435*D1**2*K*bdd1*f**2*r*s - 6435*D1**2*K*bdd1*f**2*s**2 + 6435*D1**2*K*bdd1*f**2*s + 6435*D1**2*bdd1*f**2*r*s + 6435*D1**2*bdd1*f**2*s**2 - 6435*D1**2*bdd1*f**2*s + 43120*D1**2*f**3*fd*r*s - 10780*D1**2*f**3*fd*r + 43120*D1**2*f**3*fd*s**2 - 43120*D1**2*f**3*fd*s + 10780*D1**2*f**3*fd - 25200*D1**2*f**3*fdd*r*s + 6300*D1**2*f**3*fdd*r - 25200*D1**2*f**3*fdd*s**2 + 25200*D1**2*f**3*fdd*s - 6300*D1**2*f**3*fdd - 75600*D1**2*f**2*fd**2*r*s + 18900*D1**2*f**2*fd**2*r - 75600*D1**2*f**2*fd**2*s**2 + 75600*D1**2*f**2*fd**2*s - 12600*D1**2*f**2*fd**2 - 52650*D1**2*f**2*fd*r*s + 17550*D1**2*f**2*fd*r - 52650*D1**2*f**2*fd*s**2 + 52650*D1**2*f**2*fd*s - 17550*D1**2*f**2*fd + 32760*D1**2*f**2*fdd*r*s - 10920*D1**2*f**2*fdd*r + 32760*D1**2*f**2*fdd*s**2 - 32760*D1**2*f**2*fdd*s + 10920*D1**2*f**2*fdd - 20592*D1**2*f**2*gd2*r*s - 20592*D1**2*f**2*gd2*s**2 + 20592*D1**2*f**2*gd2*s + 12870*D1**2*f**2*gdd2*r*s + 12870*D1**2*f**2*gdd2*s**2 - 12870*D1**2*f**2*gdd2*s + 65520*D1**2*f*fd**2*r*s - 21840*D1**2*f*fd**2*r + 65520*D1**2*f*fd**2*s**2 - 65520*D1**2*f*fd**2*s + 10920*D1**2*f*fd**2 - 41184*D1**2*f*fd*g2*r*s + 20592*D1**2*f*fd*g2*r - 41184*D1**2*f*fd*g2*s**2 + 41184*D1**2*f*fd*g2*s - 20592*D1**2*f*fd*g2 + 51480*D1**2*f*fd*gd2*r*s - 12870*D1**2*f*fd*gd2*r + 51480*D1**2*f*fd*gd2*s**2 - 51480*D1**2*f*fd*gd2*s + 12870*D1**2*f*fd*gd2 + 25740*D1**2*f*fdd*g2*r*s - 12870*D1**2*f*fdd*g2*r + 25740*D1**2*f*fdd*g2*s**2 - 25740*D1**2*f*fdd*g2*s + 12870*D1**2*f*fdd*g2 + 25740*D1**2*fd**2*g2*r*s - 12870*D1**2*fd**2*g2*r + 25740*D1**2*fd**2*g2*s**2 - 25740*D1**2*fd**2*g2*s + 43120*D1*Dd*f**4*r*s - 10780*D1*Dd*f**4*r + 43120*D1*Dd*f**4*s**2 - 43120*D1*Dd*f**4*s + 10780*D1*Dd*f**4 - 201600*D1*Dd*f**3*fd*r*s + 50400*D1*Dd*f**3*fd*r - 201600*D1*Dd*f**3*fd*s**2 + 201600*D1*Dd*f**3*fd*s - 37800*D1*Dd*f**3*fd - 70200*D1*Dd*f**3*r*s + 17550*D1*Dd*f**3*r - 70200*D1*Dd*f**3*s**2 + 70200*D1*Dd*f**3*s - 17550*D1*Dd*f**3 + 262080*D1*Dd*f**2*fd*r*s - 76440*D1*Dd*f**2*fd*r + 262080*D1*Dd*f**2*fd*s**2 - 262080*D1*Dd*f**2*fd*s + 54600*D1*Dd*f**2*fd - 82368*D1*Dd*f**2*g2*r*s + 20592*D1*Dd*f**2*g2*r - 82368*D1*Dd*f**2*g2*s**2 + 82368*D1*Dd*f**2*g2*s - 20592*D1*Dd*f**2*g2 + 102960*D1*Dd*f**2*gd2*r*s - 12870*D1*Dd*f**2*gd2*r + 102960*D1*Dd*f**2*gd2*s**2 - 102960*D1*Dd*f**2*gd2*s + 12870*D1*Dd*f**2*gd2 + 205920*D1*Dd*f*fd*g2*r*s - 77220*D1*Dd*f*fd*g2*r + 205920*D1*Dd*f*fd*g2*s**2 - 205920*D1*Dd*f*fd*g2*s + 51480*D1*Dd*f*fd*g2 - 25200*D1*Ddd*f**4*r*s + 6300*D1*Ddd*f**4*r - 25200*D1*Ddd*f**4*s**2 + 25200*D1*Ddd*f**4*s - 6300*D1*Ddd*f**4 + 43680*D1*Ddd*f**3*r*s - 10920*D1*Ddd*f**3*r + 43680*D1*Ddd*f**3*s**2 - 43680*D1*Ddd*f**3*s + 10920*D1*Ddd*f**3 + 51480*D1*Ddd*f**2*g2*r*s - 12870*D1*Ddd*f**2*g2*r + 51480*D1*Ddd*f**2*g2*s**2 - 51480*D1*Ddd*f**2*g2*s + 12870*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(D1*(8*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 75600*Dd**2*f**4*r*s + 18900*Dd**2*f**4*r - 75600*Dd**2*f**4*s**2 + 75600*Dd**2*f**4*s - 12600*Dd**2*f**4 + 131040*Dd**2*f**3*r*s - 32760*Dd**2*f**3*r + 131040*Dd**2*f**3*s**2 - 131040*Dd**2*f**3*s + 21840*Dd**2*f**3 + 154440*Dd**2*f**2*g2*r*s - 38610*Dd**2*f**2*g2*r + 154440*Dd**2*f**2*g2*s**2 - 154440*Dd**2*f**2*g2*s + 25740*Dd**2*f**2*g2 + 1287*b1*(K - 1)*(D1**2*(f*(8*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k3**5) - 10*D1**2*Pkd2*Pkd3*ct**7*k1*k2**4*(672*C*D1**2*f**2*fd*r*s - 224*C*D1**2*f**2*fd*r + 672*C*D1**2*f**2*fd*s**2 - 672*C*D1**2*f**2*fd*s + 224*C*D1**2*f**2*fd - 336*C*D1**2*f**2*fdd*r*s + 112*C*D1**2*f**2*fdd*r - 336*C*D1**2*f**2*fdd*s**2 + 336*C*D1**2*f**2*fdd*s - 112*C*D1**2*f**2*fdd - 672*C*D1**2*f*fd**2*r*s + 224*C*D1**2*f*fd**2*r - 672*C*D1**2*f*fd**2*s**2 + 672*C*D1**2*f*fd**2*s - 112*C*D1**2*f*fd**2 + 896*C*D1*Dd*f**3*r*s - 224*C*D1*Dd*f**3*r + 896*C*D1*Dd*f**3*s**2 - 896*C*D1*Dd*f**3*s + 224*C*D1*Dd*f**3 - 2688*C*D1*Dd*f**2*fd*r*s + 784*C*D1*Dd*f**2*fd*r - 2688*C*D1*Dd*f**2*fd*s**2 + 2688*C*D1*Dd*f**2*fd*s - 560*C*D1*Dd*f**2*fd - 448*C*D1*Ddd*f**3*r*s + 112*C*D1*Ddd*f**3*r - 448*C*D1*Ddd*f**3*s**2 + 448*C*D1*Ddd*f**3*s - 112*C*D1*Ddd*f**3 - 1344*C*Dd**2*f**3*r*s + 336*C*Dd**2*f**3*r - 1344*C*Dd**2*f**3*s**2 + 1344*C*Dd**2*f**3*s - 224*C*Dd**2*f**3 - 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s + 28*D1**2*bdd1*f**3*r*s + 28*D1**2*bdd1*f**3*s**2 - 28*D1**2*bdd1*f**3*s + 33*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s - 504*D1**2*f**2*fd*r*s + 168*D1**2*f**2*fd*r - 504*D1**2*f**2*fd*s**2 + 504*D1**2*f**2*fd*s - 168*D1**2*f**2*fd + 252*D1**2*f**2*fdd*r*s - 84*D1**2*f**2*fdd*r + 252*D1**2*f**2*fdd*s**2 - 252*D1**2*f**2*fdd*s + 84*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 504*D1**2*f*fd**2*r*s - 168*D1**2*f*fd**2*r + 504*D1**2*f*fd**2*s**2 - 504*D1**2*f*fd**2*s + 84*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r*s - 132*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 528*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s - 672*D1*Dd*f**3*r*s + 168*D1*Dd*f**3*r - 672*D1*Dd*f**3*s**2 + 672*D1*Dd*f**3*s - 168*D1*Dd*f**3 + 2016*D1*Dd*f**2*fd*r*s - 588*D1*Dd*f**2*fd*r + 2016*D1*Dd*f**2*fd*s**2 - 2016*D1*Dd*f**2*fd*s + 420*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r*s - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1056*D1*Dd*f**2*gd2*s + 132*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r*s - 792*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2112*D1*Dd*f*fd*g2*s + 528*D1*Dd*f*fd*g2 + 336*D1*Ddd*f**3*r*s - 84*D1*Ddd*f**3*r + 336*D1*Ddd*f**3*s**2 - 336*D1*Ddd*f**3*s + 84*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r*s - 132*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 528*D1*Ddd*f**2*g2*s + 132*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(28*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-66*K + 28*f + 33)*(r + s - 1) - 33*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-66*K + 28*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 1008*Dd**2*f**3*r*s - 252*Dd**2*f**3*r + 1008*Dd**2*f**3*s**2 - 1008*Dd**2*f**3*s + 168*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r*s - 396*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 1584*Dd**2*f**2*g2*s + 264*Dd**2*f**2*g2 + b1*(D1**2*(-28*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*fd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 33*fdd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 33*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(-2*Dd*(28*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-14*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (33 - 66*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 33*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-66*K + 28*f + 33)) + Dd**2*f**2*(-66*K + 28*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**5) - 10*D1**2*Pkd2*Pkd3*ct**7*k1*k2**2*(b1*(D1**2*(28*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(-28*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 66*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 33*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 33*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(28*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-14*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2) - 33*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(28*f + 33)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(28*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(28*bdd1*f**2*s*(r + s - 1) + f*(33*bdd1*s*(r + s - 1) - 56*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-28*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 2*f*s*(28*f + 33)*(r + s - 1) - 33*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(28*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 28*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 28*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**6*k1**4*k2*(13260*C*D1**2*f**2*fd*r*s - 4420*C*D1**2*f**2*fd*r + 13260*C*D1**2*f**2*fd*s**2 - 13260*C*D1**2*f**2*fd*s + 4420*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r*s + 3640*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 10920*C*D1**2*f**2*fdd*s - 3640*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r*s + 7280*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 21840*C*D1**2*f*fd**2*s - 3640*C*D1**2*f*fd**2 + 17680*C*D1*Dd*f**3*r*s - 4420*C*D1*Dd*f**3*r + 17680*C*D1*Dd*f**3*s**2 - 17680*C*D1*Dd*f**3*s + 4420*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r*s + 25480*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 87360*C*D1*Dd*f**2*fd*s - 18200*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r*s + 3640*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 14560*C*D1*Ddd*f**3*s - 3640*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r*s + 10920*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 43680*C*Dd**2*f**3*s - 7280*C*Dd**2*f**3 - 2145*D1**2*K*bdd1*f**2*r*s - 2145*D1**2*K*bdd1*f**2*s**2 + 2145*D1**2*K*bdd1*f**2*s + 2145*D1**2*bdd1*f**2*r*s + 2145*D1**2*bdd1*f**2*s**2 - 2145*D1**2*bdd1*f**2*s + 17920*D1**2*f**3*fd*r*s - 4480*D1**2*f**3*fd*r + 17920*D1**2*f**3*fd*s**2 - 17920*D1**2*f**3*fd*s + 4480*D1**2*f**3*fd - 12600*D1**2*f**3*fdd*r*s + 3150*D1**2*f**3*fdd*r - 12600*D1**2*f**3*fdd*s**2 + 12600*D1**2*f**3*fdd*s - 3150*D1**2*f**3*fdd - 37800*D1**2*f**2*fd**2*r*s + 9450*D1**2*f**2*fd**2*r - 37800*D1**2*f**2*fd**2*s**2 + 37800*D1**2*f**2*fd**2*s - 6300*D1**2*f**2*fd**2 - 13260*D1**2*f**2*fd*r*s + 4420*D1**2*f**2*fd*r - 13260*D1**2*f**2*fd*s**2 + 13260*D1**2*f**2*fd*s - 4420*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r*s - 3640*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 10920*D1**2*f**2*fdd*s + 3640*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r*s - 5148*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s + 4290*D1**2*f**2*gdd2*r*s + 4290*D1**2*f**2*gdd2*s**2 - 4290*D1**2*f**2*gdd2*s + 21840*D1**2*f*fd**2*r*s - 7280*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 21840*D1**2*f*fd**2*s + 3640*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r*s - 4290*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 17160*D1**2*f*fd*gd2*s + 4290*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r*s - 4290*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r*s - 4290*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 17920*D1*Dd*f**4*r*s - 4480*D1*Dd*f**4*r + 17920*D1*Dd*f**4*s**2 - 17920*D1*Dd*f**4*s + 4480*D1*Dd*f**4 - 100800*D1*Dd*f**3*fd*r*s + 25200*D1*Dd*f**3*fd*r - 100800*D1*Dd*f**3*fd*s**2 + 100800*D1*Dd*f**3*fd*s - 18900*D1*Dd*f**3*fd - 17680*D1*Dd*f**3*r*s + 4420*D1*Dd*f**3*r - 17680*D1*Dd*f**3*s**2 + 17680*D1*Dd*f**3*s - 4420*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r*s - 25480*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 87360*D1*Dd*f**2*fd*s + 18200*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r*s - 4290*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 34320*D1*Dd*f**2*gd2*s + 4290*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r*s - 25740*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 68640*D1*Dd*f*fd*g2*s + 17160*D1*Dd*f*fd*g2 - 12600*D1*Ddd*f**4*r*s + 3150*D1*Ddd*f**4*r - 12600*D1*Ddd*f**4*s**2 + 12600*D1*Ddd*f**4*s - 3150*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r*s - 3640*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 14560*D1*Ddd*f**3*s + 3640*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r*s - 4290*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 17160*D1*Ddd*f**2*g2*s + 4290*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(6*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 37800*Dd**2*f**4*r*s + 9450*Dd**2*f**4*r - 37800*Dd**2*f**4*s**2 + 37800*Dd**2*f**4*s - 6300*Dd**2*f**4 + 43680*Dd**2*f**3*r*s - 10920*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 43680*Dd**2*f**3*s + 7280*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r*s - 12870*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 51480*Dd**2*f**2*g2*s + 8580*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(6*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**5) - 5*D1**2*Pkd2*Pkd3*ct**6*k1**2*k2**3*st**2*(11700*C*D1**2*f**2*fd*r*s - 3900*C*D1**2*f**2*fd*r + 11700*C*D1**2*f**2*fd*s**2 - 11700*C*D1**2*f**2*fd*s + 3900*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 15600*C*D1*Dd*f**3*r*s - 3900*C*D1*Dd*f**3*r + 15600*C*D1*Dd*f**3*s**2 - 15600*C*D1*Dd*f**3*s + 3900*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 10976*D1**2*f**3*fd*r*s - 2744*D1**2*f**3*fd*r + 10976*D1**2*f**3*fd*s**2 - 10976*D1**2*f**3*fd*s + 2744*D1**2*f**3*fd - 5488*D1**2*f**3*fdd*r*s + 1372*D1**2*f**3*fdd*r - 5488*D1**2*f**3*fdd*s**2 + 5488*D1**2*f**3*fdd*s - 1372*D1**2*f**3*fdd - 16464*D1**2*f**2*fd**2*r*s + 4116*D1**2*f**2*fd**2*r - 16464*D1**2*f**2*fd**2*s**2 + 16464*D1**2*f**2*fd**2*s - 2744*D1**2*f**2*fd**2 - 11700*D1**2*f**2*fd*r*s + 3900*D1**2*f**2*fd*r - 11700*D1**2*f**2*fd*s**2 + 11700*D1**2*f**2*fd*s - 3900*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 5148*D1**2*f**2*gd2*r*s - 5148*D1**2*f**2*gd2*s**2 + 5148*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 10296*D1**2*f*fd*g2*r*s + 5148*D1**2*f*fd*g2*r - 10296*D1**2*f*fd*g2*s**2 + 10296*D1**2*f*fd*g2*s - 5148*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 10976*D1*Dd*f**4*r*s - 2744*D1*Dd*f**4*r + 10976*D1*Dd*f**4*s**2 - 10976*D1*Dd*f**4*s + 2744*D1*Dd*f**4 - 43904*D1*Dd*f**3*fd*r*s + 10976*D1*Dd*f**3*fd*r - 43904*D1*Dd*f**3*fd*s**2 + 43904*D1*Dd*f**3*fd*s - 8232*D1*Dd*f**3*fd - 15600*D1*Dd*f**3*r*s + 3900*D1*Dd*f**3*r - 15600*D1*Dd*f**3*s**2 + 15600*D1*Dd*f**3*s - 3900*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 20592*D1*Dd*f**2*g2*r*s + 5148*D1*Dd*f**2*g2*r - 20592*D1*Dd*f**2*g2*s**2 + 20592*D1*Dd*f**2*g2*s - 5148*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 5488*D1*Ddd*f**4*r*s + 1372*D1*Ddd*f**4*r - 5488*D1*Ddd*f**4*s**2 + 5488*D1*Ddd*f**4*s - 1372*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 1287*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 16464*Dd**2*f**4*r*s + 4116*Dd**2*f**4*r - 16464*Dd**2*f**4*s**2 + 16464*Dd**2*f**4*s - 2744*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 1287*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**6*k1**2*k2**3*(-330*C*D1**2*bdd1*f**2*r*s + 330*C*D1**2*bdd1*f**2*r - 330*C*D1**2*bdd1*f**2*s**2 + 660*C*D1**2*bdd1*f**2*s - 330*C*D1**2*bdd1*f**2 + 7110*C*D1**2*f**2*fd*r*s - 2370*C*D1**2*f**2*fd*r + 7110*C*D1**2*f**2*fd*s**2 - 7110*C*D1**2*f**2*fd*s + 2370*C*D1**2*f**2*fd - 5040*C*D1**2*f**2*fdd*r*s + 1680*C*D1**2*f**2*fdd*r - 5040*C*D1**2*f**2*fdd*s**2 + 5040*C*D1**2*f**2*fdd*s - 1680*C*D1**2*f**2*fdd - 10080*C*D1**2*f*fd**2*r*s + 3360*C*D1**2*f*fd**2*r - 10080*C*D1**2*f*fd**2*s**2 + 10080*C*D1**2*f*fd**2*s - 1680*C*D1**2*f*fd**2 + 9480*C*D1*Dd*f**3*r*s - 2370*C*D1*Dd*f**3*r + 9480*C*D1*Dd*f**3*s**2 - 9480*C*D1*Dd*f**3*s + 2370*C*D1*Dd*f**3 - 40320*C*D1*Dd*f**2*fd*r*s + 11760*C*D1*Dd*f**2*fd*r - 40320*C*D1*Dd*f**2*fd*s**2 + 40320*C*D1*Dd*f**2*fd*s - 8400*C*D1*Dd*f**2*fd - 6720*C*D1*Ddd*f**3*r*s + 1680*C*D1*Ddd*f**3*r - 6720*C*D1*Ddd*f**3*s**2 + 6720*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 20160*C*Dd**2*f**3*r*s + 5040*C*Dd**2*f**3*r - 20160*C*Dd**2*f**3*s**2 + 20160*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 990*D1**2*K*bdd1*f**2*r*s - 990*D1**2*K*bdd1*f**2*s**2 + 990*D1**2*K*bdd1*f**2*s - 198*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 420*D1**2*bdd1*f**3*r*s + 140*D1**2*bdd1*f**3*r + 420*D1**2*bdd1*f**3*s**2 - 280*D1**2*bdd1*f**3*s - 140*D1**2*bdd1*f**3 + 825*D1**2*bdd1*f**2*r*s - 330*D1**2*bdd1*f**2*r + 825*D1**2*bdd1*f**2*s**2 - 1155*D1**2*bdd1*f**2*s + 330*D1**2*bdd1*f**2 + 396*D1**2*bdd1*f*g2*r*s - 396*D1**2*bdd1*f*g2*r + 396*D1**2*bdd1*f*g2*s**2 - 792*D1**2*bdd1*f*g2*s + 396*D1**2*bdd1*f*g2 - 560*D1**2*f**3*fd*r*s + 140*D1**2*f**3*fd*r - 560*D1**2*f**3*fd*s**2 + 560*D1**2*f**3*fd*s - 140*D1**2*f**3*fd - 5085*D1**2*f**2*fd*r*s + 1695*D1**2*f**2*fd*r - 5085*D1**2*f**2*fd*s**2 + 5085*D1**2*f**2*fd*s - 1695*D1**2*f**2*fd + 3780*D1**2*f**2*fdd*r*s - 1260*D1**2*f**2*fdd*r + 3780*D1**2*f**2*fdd*s**2 - 3780*D1**2*f**2*fdd*s + 1260*D1**2*f**2*fdd - 2772*D1**2*f**2*gd2*r*s - 2772*D1**2*f**2*gd2*s**2 + 2772*D1**2*f**2*gd2*s + 1980*D1**2*f**2*gdd2*r*s + 1980*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 7560*D1**2*f*fd**2*r*s - 2520*D1**2*f*fd**2*r + 7560*D1**2*f*fd**2*s**2 - 7560*D1**2*f*fd**2*s + 1260*D1**2*f*fd**2 - 5544*D1**2*f*fd*g2*r*s + 2772*D1**2*f*fd*g2*r - 5544*D1**2*f*fd*g2*s**2 + 5544*D1**2*f*fd*g2*s - 2772*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s - 560*D1*Dd*f**4*r*s + 140*D1*Dd*f**4*r - 560*D1*Dd*f**4*s**2 + 560*D1*Dd*f**4*s - 140*D1*Dd*f**4 - 6780*D1*Dd*f**3*r*s + 1695*D1*Dd*f**3*r - 6780*D1*Dd*f**3*s**2 + 6780*D1*Dd*f**3*s - 1695*D1*Dd*f**3 + 30240*D1*Dd*f**2*fd*r*s - 8820*D1*Dd*f**2*fd*r + 30240*D1*Dd*f**2*fd*s**2 - 30240*D1*Dd*f**2*fd*s + 6300*D1*Dd*f**2*fd - 11088*D1*Dd*f**2*g2*r*s + 2772*D1*Dd*f**2*g2*r - 11088*D1*Dd*f**2*g2*s**2 + 11088*D1*Dd*f**2*g2*s - 2772*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r*s - 1980*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 15840*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 31680*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 5040*D1*Ddd*f**3*r*s - 1260*D1*Ddd*f**3*r + 5040*D1*Ddd*f**3*s**2 - 5040*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 1980*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(135*s + 56)*(r + s - 1) + 2*f**2*(330*C*(s - 1)*(r + s - 1) + 70*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + (33*r + 33*s - 33)*(21*K*s - 19*s + 10)) - 33*f*(5*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 6*K*(r*(4*s - 1) + (1 - 2*s)**2) - 20*r*s + 7*r - 20*s**2 + 22*s - 5) + (12*r + 12*s - 12)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 396*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(140*f**2*(24*r*s + r + 4*s*(6*s - 5)) - 165*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 6*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 40*r*s + 13*r - 40*s**2 + 48*s - 11) + 396*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 15120*Dd**2*f**3*r*s - 3780*Dd**2*f**3*r + 15120*Dd**2*f**3*s**2 - 15120*Dd**2*f**3*s + 2520*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 3960*Dd**2*f**2*g2 + 198*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(1320*C*D1**2*f*fd*r*s + 1320*C*D1**2*f*fd*s**2 - 660*C*D1**2*f*fd*s - 660*C*D1**2*f*fdd*r*s - 660*C*D1**2*f*fdd*s**2 + 330*C*D1**2*f*fdd*s - 660*C*D1**2*fd**2*r*s - 660*C*D1**2*fd**2*s**2 + 330*C*D1**2*fd**2*s + 2640*C*D1*Dd*f**2*r*s - 660*C*D1*Dd*f**2*r + 2640*C*D1*Dd*f**2*s**2 - 2640*C*D1*Dd*f**2*s + 660*C*D1*Dd*f**2 - 5280*C*D1*Dd*f*fd*r*s + 660*C*D1*Dd*f*fd*r - 5280*C*D1*Dd*f*fd*s**2 + 3960*C*D1*Dd*f*fd*s - 330*C*D1*Dd*f*fd - 1320*C*D1*Ddd*f**2*r*s + 330*C*D1*Ddd*f**2*r - 1320*C*D1*Ddd*f**2*s**2 + 1320*C*D1*Ddd*f**2*s - 330*C*D1*Ddd*f**2 - 3960*C*Dd**2*f**2*r*s + 990*C*Dd**2*f**2*r - 3960*C*Dd**2*f**2*s**2 + 3960*C*Dd**2*f**2*s - 660*C*Dd**2*f**2 + 2772*D1**2*K*f*fd*r*s - 1386*D1**2*K*f*fd*r + 2772*D1**2*K*f*fd*s**2 - 2772*D1**2*K*f*fd*s + 1386*D1**2*K*f*fd - 1980*D1**2*K*f*fdd*r*s + 990*D1**2*K*f*fdd*r - 1980*D1**2*K*f*fdd*s**2 + 1980*D1**2*K*f*fdd*s - 990*D1**2*K*f*fdd - 1980*D1**2*K*fd**2*r*s + 990*D1**2*K*fd**2*r - 1980*D1**2*K*fd**2*s**2 + 1980*D1**2*K*fd**2*s - 198*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 2025*D1**2*f**2*fd*r*s + 955*D1**2*f**2*fd*r - 2025*D1**2*f**2*fd*s**2 + 2305*D1**2*f**2*fd*s - 955*D1**2*f**2*fd + 1260*D1**2*f**2*fdd*r*s - 560*D1**2*f**2*fdd*r + 1260*D1**2*f**2*fdd*s**2 - 1400*D1**2*f**2*fdd*s + 560*D1**2*f**2*fdd + 2520*D1**2*f*fd**2*r*s - 1120*D1**2*f*fd**2*r + 2520*D1**2*f*fd**2*s**2 - 2800*D1**2*f*fd**2*s + 560*D1**2*f*fd**2 - 2508*D1**2*f*fd*r*s + 594*D1**2*f*fd*r - 2508*D1**2*f*fd*s**2 + 1848*D1**2*f*fd*s - 594*D1**2*f*fd + 1650*D1**2*f*fdd*r*s - 495*D1**2*f*fdd*r + 1650*D1**2*f*fdd*s**2 - 1320*D1**2*f*fdd*s + 495*D1**2*f*fdd - 792*D1**2*f*gd2*r*s - 792*D1**2*f*gd2*s**2 + 792*D1**2*f*gd2*s + 396*D1**2*f*gdd2*r*s + 396*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s + 1650*D1**2*fd**2*r*s - 495*D1**2*fd**2*r + 1650*D1**2*fd**2*s**2 - 1320*D1**2*fd**2*s - 792*D1**2*fd*g2*r*s - 792*D1**2*fd*g2*s**2 + 792*D1**2*fd*gd2*r*s + 792*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 396*D1**2*fdd*g2*r*s + 396*D1**2*fdd*g2*s**2 + 5544*D1*Dd*K*f**2*r*s - 1386*D1*Dd*K*f**2*r + 5544*D1*Dd*K*f**2*s**2 - 5544*D1*Dd*K*f**2*s + 1386*D1*Dd*K*f**2 - 15840*D1*Dd*K*f*fd*r*s + 5940*D1*Dd*K*f*fd*r - 15840*D1*Dd*K*f*fd*s**2 + 15840*D1*Dd*K*f*fd*s - 3960*D1*Dd*K*f*fd - 2700*D1*Dd*f**3*r*s + 675*D1*Dd*f**3*r - 2700*D1*Dd*f**3*s**2 + 2700*D1*Dd*f**3*s - 675*D1*Dd*f**3 + 10080*D1*Dd*f**2*fd*r*s - 3500*D1*Dd*f**2*fd*r + 10080*D1*Dd*f**2*fd*s**2 - 10640*D1*Dd*f**2*fd*s + 2520*D1*Dd*f**2*fd - 5016*D1*Dd*f**2*r*s + 1254*D1*Dd*f**2*r - 5016*D1*Dd*f**2*s**2 + 5016*D1*Dd*f**2*s - 1254*D1*Dd*f**2 + 13200*D1*Dd*f*fd*r*s - 3630*D1*Dd*f*fd*r + 13200*D1*Dd*f*fd*s**2 - 11880*D1*Dd*f*fd*s + 2310*D1*Dd*f*fd - 3168*D1*Dd*f*g2*r*s + 792*D1*Dd*f*g2*r - 3168*D1*Dd*f*g2*s**2 + 3168*D1*Dd*f*g2*s - 792*D1*Dd*f*g2 + 3168*D1*Dd*f*gd2*r*s - 396*D1*Dd*f*gd2*r + 3168*D1*Dd*f*gd2*s**2 - 3168*D1*Dd*f*gd2*s + 396*D1*Dd*f*gd2 + 3168*D1*Dd*fd*g2*r*s - 396*D1*Dd*fd*g2*r + 3168*D1*Dd*fd*g2*s**2 - 1584*D1*Dd*fd*g2*s - 3960*D1*Ddd*K*f**2*r*s + 990*D1*Ddd*K*f**2*r - 3960*D1*Ddd*K*f**2*s**2 + 3960*D1*Ddd*K*f**2*s - 990*D1*Ddd*K*f**2 + 1680*D1*Ddd*f**3*r*s - 420*D1*Ddd*f**3*r + 1680*D1*Ddd*f**3*s**2 - 1680*D1*Ddd*f**3*s + 420*D1*Ddd*f**3 + 3300*D1*Ddd*f**2*r*s - 825*D1*Ddd*f**2*r + 3300*D1*Ddd*f**2*s**2 - 3300*D1*Ddd*f**2*s + 825*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r*s - 396*D1*Ddd*f*g2*r + 1584*D1*Ddd*f*g2*s**2 - 1584*D1*Ddd*f*g2*s + 396*D1*Ddd*f*g2 + 198*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 11880*Dd**2*K*f**2*r*s + 2970*Dd**2*K*f**2*r - 11880*Dd**2*K*f**2*s**2 + 11880*Dd**2*K*f**2*s - 1980*Dd**2*K*f**2 + 5040*Dd**2*f**3*r*s - 1260*Dd**2*f**3*r + 5040*Dd**2*f**3*s**2 - 5040*Dd**2*f**3*s + 840*Dd**2*f**3 + 9900*Dd**2*f**2*r*s - 2475*Dd**2*f**2*r + 9900*Dd**2*f**2*s**2 - 9900*Dd**2*f**2*s + 1650*Dd**2*f**2 + 4752*Dd**2*f*g2*r*s - 1188*Dd**2*f*g2*r + 4752*Dd**2*f*g2*s**2 - 4752*Dd**2*f*g2*s + 792*Dd**2*f*g2))/(693*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**6*k1**2*k2*(-198*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(5*f**3*s*(191*r + 191*s - 135) - 4*f**2*(35*fd*(6*s - 1)*(4*r + 4*s - 3) - 33*s*(5*C*r + 5*C*s + r + s - 6)) - 33*f*(5*fd*(r*(2*C + 1)*(4*s - 1) + s**2*(8*C + 4) - s*(6*C + 6) + 3) + 12*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 396*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(140*f**2*(8*s - 1)*(4*r + 4*s - 3) + 165*f*(r*(2*C + 1)*(8*s - 1) + s**2*(16*C + 8) - s*(8*C + 16) + 3) - 396*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 198*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(5*f**2*(fd*(191*r*(3*s - 1) + 573*s**2 - 629*s + 191) - 28*fdd*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4)) + f*(-140*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) + 132*fd*(5*C*(2*s - 1)*(r + s - 1) + r*(2*s - 1) + 2*s**2 + 3*s + 1) - 165*fdd*(2*C*(2*s - 1)*(r + s - 1) + r*(2*s - 1) + 2*s**2 + 1) - 198*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) - 165*fd**2*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 - 2) - 396*fd*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 396*fdd*g2*(s - 1)*(r + s - 1)) - 198*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(955*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + 4*f**2*(165*C*(r*(4*s - 1) + (1 - 2*s)**2) - 35*fd*(24*s - 7)*(4*r + 4*s - 3) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2) - 66*f*(5*fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + r*(8*s - 3) + 8*s**2 - 4*s + 1) + 6*g2*r*(8*s - 2) + 12*g2*(1 - 2*s)**2 + 6*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 396*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(560*f**2 + f*(330*C + 165) - 396*g2)) - Dd**2*f*(560*f**2 + f*(330*C + 165) - 396*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - f*(D1**2*(140*bdd1*f**2*s*(4*r + 4*s - 3) - 396*bdd1*g2*s*(r + s) - 15*f*(-11*bdd1*s*(2*C*r + 2*C*s + r + s - 3) + 45*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 420*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 15*D1*f*(Dd*(45*f*(r*(4*s - 1) + (1 - 2*s)**2) - 28*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 28*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 420*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**3) - 10*D1**2*Pkd2*Pkd3*ct**6*k2**5*(D1**2*(f**2*(fd*(112*C - 56)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(56*C - 28)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(56*C - 28)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 33*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) + 33*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 33*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(112*C - 56)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(33*K*(b1*r*(8*s - 2) + 2*b1*(1 - 2*s)**2 + bd1*(-8*r*s + r - 8*s**2 + 8*s - 1)) + fd*(28 - 56*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 132*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 66*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 66*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(56*C*f + 33*K*b1 - 28*f - 66*g2)) - Dd**2*f**2*(56*C*f + 33*K*b1 - 28*f - 66*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(693*d**2*k3**5) + 10*D1**2*Pkd2*Pkd3*ct**6*k2**3*(336*C*D1**2*f**2*fd*r*s - 112*C*D1**2*f**2*fd*r + 336*C*D1**2*f**2*fd*s**2 - 336*C*D1**2*f**2*fd*s + 112*C*D1**2*f**2*fd - 168*C*D1**2*f**2*fdd*r*s + 56*C*D1**2*f**2*fdd*r - 168*C*D1**2*f**2*fdd*s**2 + 168*C*D1**2*f**2*fdd*s - 56*C*D1**2*f**2*fdd - 336*C*D1**2*f*fd**2*r*s + 112*C*D1**2*f*fd**2*r - 336*C*D1**2*f*fd**2*s**2 + 336*C*D1**2*f*fd**2*s - 56*C*D1**2*f*fd**2 + 448*C*D1*Dd*f**3*r*s - 112*C*D1*Dd*f**3*r + 448*C*D1*Dd*f**3*s**2 - 448*C*D1*Dd*f**3*s + 112*C*D1*Dd*f**3 - 1344*C*D1*Dd*f**2*fd*r*s + 392*C*D1*Dd*f**2*fd*r - 1344*C*D1*Dd*f**2*fd*s**2 + 1344*C*D1*Dd*f**2*fd*s - 280*C*D1*Dd*f**2*fd - 224*C*D1*Ddd*f**3*r*s + 56*C*D1*Ddd*f**3*r - 224*C*D1*Ddd*f**3*s**2 + 224*C*D1*Ddd*f**3*s - 56*C*D1*Ddd*f**3 - 672*C*Dd**2*f**3*r*s + 168*C*Dd**2*f**3*r - 672*C*Dd**2*f**3*s**2 + 672*C*Dd**2*f**3*s - 112*C*Dd**2*f**3 + 132*D1**2*K*b1*f*fd*r*s - 66*D1**2*K*b1*f*fd*r + 132*D1**2*K*b1*f*fd*s**2 - 132*D1**2*K*b1*f*fd*s + 66*D1**2*K*b1*f*fd - 66*D1**2*K*b1*f*fdd*r*s + 33*D1**2*K*b1*f*fdd*r - 66*D1**2*K*b1*f*fdd*s**2 + 66*D1**2*K*b1*f*fdd*s - 33*D1**2*K*b1*f*fdd - 66*D1**2*K*b1*fd**2*r*s + 33*D1**2*K*b1*fd**2*r - 66*D1**2*K*b1*fd**2*s**2 + 66*D1**2*K*b1*fd**2*s + 66*D1**2*K*bd1*f**2*r*s + 66*D1**2*K*bd1*f**2*s**2 - 66*D1**2*K*bd1*f**2*s - 132*D1**2*K*bd1*f*fd*r*s + 33*D1**2*K*bd1*f*fd*r - 132*D1**2*K*bd1*f*fd*s**2 + 132*D1**2*K*bd1*f*fd*s - 33*D1**2*K*bd1*f*fd - 33*D1**2*K*bdd1*f**2*r*s - 33*D1**2*K*bdd1*f**2*s**2 + 33*D1**2*K*bdd1*f**2*s - 33*D1**2*bdd2*f**2*r*s - 33*D1**2*bdd2*f**2*s**2 + 33*D1**2*bdd2*f**2*s - 168*D1**2*f**2*fd*r*s + 56*D1**2*f**2*fd*r - 168*D1**2*f**2*fd*s**2 + 168*D1**2*f**2*fd*s - 56*D1**2*f**2*fd + 84*D1**2*f**2*fdd*r*s - 28*D1**2*f**2*fdd*r + 84*D1**2*f**2*fdd*s**2 - 84*D1**2*f**2*fdd*s + 28*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s + 66*D1**2*f**2*gdd2*r*s + 66*D1**2*f**2*gdd2*s**2 - 66*D1**2*f**2*gdd2*s + 168*D1**2*f*fd**2*r*s - 56*D1**2*f*fd**2*r + 168*D1**2*f*fd**2*s**2 - 168*D1**2*f*fd**2*s + 28*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r*s - 66*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 264*D1**2*f*fd*gd2*s + 66*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r*s - 66*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r*s - 66*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 264*D1*Dd*K*b1*f**2*r*s - 66*D1*Dd*K*b1*f**2*r + 264*D1*Dd*K*b1*f**2*s**2 - 264*D1*Dd*K*b1*f**2*s + 66*D1*Dd*K*b1*f**2 - 528*D1*Dd*K*b1*f*fd*r*s + 198*D1*Dd*K*b1*f*fd*r - 528*D1*Dd*K*b1*f*fd*s**2 + 528*D1*Dd*K*b1*f*fd*s - 132*D1*Dd*K*b1*f*fd - 264*D1*Dd*K*bd1*f**2*r*s + 33*D1*Dd*K*bd1*f**2*r - 264*D1*Dd*K*bd1*f**2*s**2 + 264*D1*Dd*K*bd1*f**2*s - 33*D1*Dd*K*bd1*f**2 - 224*D1*Dd*f**3*r*s + 56*D1*Dd*f**3*r - 224*D1*Dd*f**3*s**2 + 224*D1*Dd*f**3*s - 56*D1*Dd*f**3 + 672*D1*Dd*f**2*fd*r*s - 196*D1*Dd*f**2*fd*r + 672*D1*Dd*f**2*fd*s**2 - 672*D1*Dd*f**2*fd*s + 140*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r*s + 132*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r*s - 66*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 528*D1*Dd*f**2*gd2*s + 66*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r*s - 396*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1056*D1*Dd*f*fd*g2*s + 264*D1*Dd*f*fd*g2 - 132*D1*Ddd*K*b1*f**2*r*s + 33*D1*Ddd*K*b1*f**2*r - 132*D1*Ddd*K*b1*f**2*s**2 + 132*D1*Ddd*K*b1*f**2*s - 33*D1*Ddd*K*b1*f**2 + 112*D1*Ddd*f**3*r*s - 28*D1*Ddd*f**3*r + 112*D1*Ddd*f**3*s**2 - 112*D1*Ddd*f**3*s + 28*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r*s - 66*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 264*D1*Ddd*f**2*g2*s + 66*D1*Ddd*f**2*g2 + 33*D1*bd2*f*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 396*Dd**2*K*b1*f**2*r*s + 99*Dd**2*K*b1*f**2*r - 396*Dd**2*K*b1*f**2*s**2 + 396*Dd**2*K*b1*f**2*s - 66*Dd**2*K*b1*f**2 + 336*Dd**2*f**3*r*s - 84*Dd**2*f**3*r + 336*Dd**2*f**3*s**2 - 336*Dd**2*f**3*s + 56*Dd**2*f**3 + 792*Dd**2*f**2*g2*r*s - 198*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 792*Dd**2*f**2*g2*s + 132*Dd**2*f**2*g2 + 33*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**5*k1**5*(8970*C*D1**2*f**2*fd*r*s - 2990*C*D1**2*f**2*fd*r + 8970*C*D1**2*f**2*fd*s**2 - 8970*C*D1**2*f**2*fd*s + 2990*C*D1**2*f**2*fd - 10920*C*D1**2*f**2*fdd*r*s + 3640*C*D1**2*f**2*fdd*r - 10920*C*D1**2*f**2*fdd*s**2 + 10920*C*D1**2*f**2*fdd*s - 3640*C*D1**2*f**2*fdd - 21840*C*D1**2*f*fd**2*r*s + 7280*C*D1**2*f*fd**2*r - 21840*C*D1**2*f*fd**2*s**2 + 21840*C*D1**2*f*fd**2*s - 3640*C*D1**2*f*fd**2 + 11960*C*D1*Dd*f**3*r*s - 2990*C*D1*Dd*f**3*r + 11960*C*D1*Dd*f**3*s**2 - 11960*C*D1*Dd*f**3*s + 2990*C*D1*Dd*f**3 - 87360*C*D1*Dd*f**2*fd*r*s + 25480*C*D1*Dd*f**2*fd*r - 87360*C*D1*Dd*f**2*fd*s**2 + 87360*C*D1*Dd*f**2*fd*s - 18200*C*D1*Dd*f**2*fd - 14560*C*D1*Ddd*f**3*r*s + 3640*C*D1*Ddd*f**3*r - 14560*C*D1*Ddd*f**3*s**2 + 14560*C*D1*Ddd*f**3*s - 3640*C*D1*Ddd*f**3 - 43680*C*Dd**2*f**3*r*s + 10920*C*Dd**2*f**3*r - 43680*C*Dd**2*f**3*s**2 + 43680*C*Dd**2*f**3*s - 7280*C*Dd**2*f**3 - 2145*D1**2*K*bdd1*f**2*r*s - 2145*D1**2*K*bdd1*f**2*s**2 + 2145*D1**2*K*bdd1*f**2*s + 2145*D1**2*bdd1*f**2*r*s + 2145*D1**2*bdd1*f**2*s**2 - 2145*D1**2*bdd1*f**2*s + 28560*D1**2*f**3*fd*r*s - 7140*D1**2*f**3*fd*r + 28560*D1**2*f**3*fd*s**2 - 28560*D1**2*f**3*fd*s + 7140*D1**2*f**3*fd - 25200*D1**2*f**3*fdd*r*s + 6300*D1**2*f**3*fdd*r - 25200*D1**2*f**3*fdd*s**2 + 25200*D1**2*f**3*fdd*s - 6300*D1**2*f**3*fdd - 75600*D1**2*f**2*fd**2*r*s + 18900*D1**2*f**2*fd**2*r - 75600*D1**2*f**2*fd**2*s**2 + 75600*D1**2*f**2*fd**2*s - 12600*D1**2*f**2*fd**2 - 8970*D1**2*f**2*fd*r*s + 2990*D1**2*f**2*fd*r - 8970*D1**2*f**2*fd*s**2 + 8970*D1**2*f**2*fd*s - 2990*D1**2*f**2*fd + 10920*D1**2*f**2*fdd*r*s - 3640*D1**2*f**2*fdd*r + 10920*D1**2*f**2*fdd*s**2 - 10920*D1**2*f**2*fdd*s + 3640*D1**2*f**2*fdd - 3432*D1**2*f**2*gd2*r*s - 3432*D1**2*f**2*gd2*s**2 + 3432*D1**2*f**2*gd2*s + 4290*D1**2*f**2*gdd2*r*s + 4290*D1**2*f**2*gdd2*s**2 - 4290*D1**2*f**2*gdd2*s + 21840*D1**2*f*fd**2*r*s - 7280*D1**2*f*fd**2*r + 21840*D1**2*f*fd**2*s**2 - 21840*D1**2*f*fd**2*s + 3640*D1**2*f*fd**2 - 6864*D1**2*f*fd*g2*r*s + 3432*D1**2*f*fd*g2*r - 6864*D1**2*f*fd*g2*s**2 + 6864*D1**2*f*fd*g2*s - 3432*D1**2*f*fd*g2 + 17160*D1**2*f*fd*gd2*r*s - 4290*D1**2*f*fd*gd2*r + 17160*D1**2*f*fd*gd2*s**2 - 17160*D1**2*f*fd*gd2*s + 4290*D1**2*f*fd*gd2 + 8580*D1**2*f*fdd*g2*r*s - 4290*D1**2*f*fdd*g2*r + 8580*D1**2*f*fdd*g2*s**2 - 8580*D1**2*f*fdd*g2*s + 4290*D1**2*f*fdd*g2 + 8580*D1**2*fd**2*g2*r*s - 4290*D1**2*fd**2*g2*r + 8580*D1**2*fd**2*g2*s**2 - 8580*D1**2*fd**2*g2*s + 28560*D1*Dd*f**4*r*s - 7140*D1*Dd*f**4*r + 28560*D1*Dd*f**4*s**2 - 28560*D1*Dd*f**4*s + 7140*D1*Dd*f**4 - 201600*D1*Dd*f**3*fd*r*s + 50400*D1*Dd*f**3*fd*r - 201600*D1*Dd*f**3*fd*s**2 + 201600*D1*Dd*f**3*fd*s - 37800*D1*Dd*f**3*fd - 11960*D1*Dd*f**3*r*s + 2990*D1*Dd*f**3*r - 11960*D1*Dd*f**3*s**2 + 11960*D1*Dd*f**3*s - 2990*D1*Dd*f**3 + 87360*D1*Dd*f**2*fd*r*s - 25480*D1*Dd*f**2*fd*r + 87360*D1*Dd*f**2*fd*s**2 - 87360*D1*Dd*f**2*fd*s + 18200*D1*Dd*f**2*fd - 13728*D1*Dd*f**2*g2*r*s + 3432*D1*Dd*f**2*g2*r - 13728*D1*Dd*f**2*g2*s**2 + 13728*D1*Dd*f**2*g2*s - 3432*D1*Dd*f**2*g2 + 34320*D1*Dd*f**2*gd2*r*s - 4290*D1*Dd*f**2*gd2*r + 34320*D1*Dd*f**2*gd2*s**2 - 34320*D1*Dd*f**2*gd2*s + 4290*D1*Dd*f**2*gd2 + 68640*D1*Dd*f*fd*g2*r*s - 25740*D1*Dd*f*fd*g2*r + 68640*D1*Dd*f*fd*g2*s**2 - 68640*D1*Dd*f*fd*g2*s + 17160*D1*Dd*f*fd*g2 - 25200*D1*Ddd*f**4*r*s + 6300*D1*Ddd*f**4*r - 25200*D1*Ddd*f**4*s**2 + 25200*D1*Ddd*f**4*s - 6300*D1*Ddd*f**4 + 14560*D1*Ddd*f**3*r*s - 3640*D1*Ddd*f**3*r + 14560*D1*Ddd*f**3*s**2 - 14560*D1*Ddd*f**3*s + 3640*D1*Ddd*f**3 + 17160*D1*Ddd*f**2*g2*r*s - 4290*D1*Ddd*f**2*g2*r + 17160*D1*Ddd*f**2*g2*s**2 - 17160*D1*Ddd*f**2*g2*s + 4290*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(4*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 75600*Dd**2*f**4*r*s + 18900*Dd**2*f**4*r - 75600*Dd**2*f**4*s**2 + 75600*Dd**2*f**4*s - 12600*Dd**2*f**4 + 43680*Dd**2*f**3*r*s - 10920*Dd**2*f**3*r + 43680*Dd**2*f**3*s**2 - 43680*Dd**2*f**3*s + 7280*Dd**2*f**3 + 51480*Dd**2*f**2*g2*r*s - 12870*Dd**2*f**2*g2*r + 51480*Dd**2*f**2*g2*s**2 - 51480*Dd**2*f**2*g2*s + 8580*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(4*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 5*fd*(8*r*s - 3*r + 8*s**2 - 8*s + 2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**5*k1**3*k2**2*st**2*(33852*C*D1**2*f**2*fd*r*s - 11284*C*D1**2*f**2*fd*r + 33852*C*D1**2*f**2*fd*s**2 - 33852*C*D1**2*f**2*fd*s + 11284*C*D1**2*f**2*fd - 19500*C*D1**2*f**2*fdd*r*s + 6500*C*D1**2*f**2*fdd*r - 19500*C*D1**2*f**2*fdd*s**2 + 19500*C*D1**2*f**2*fdd*s - 6500*C*D1**2*f**2*fdd - 39000*C*D1**2*f*fd**2*r*s + 13000*C*D1**2*f*fd**2*r - 39000*C*D1**2*f*fd**2*s**2 + 39000*C*D1**2*f*fd**2*s - 6500*C*D1**2*f*fd**2 + 45136*C*D1*Dd*f**3*r*s - 11284*C*D1*Dd*f**3*r + 45136*C*D1*Dd*f**3*s**2 - 45136*C*D1*Dd*f**3*s + 11284*C*D1*Dd*f**3 - 156000*C*D1*Dd*f**2*fd*r*s + 45500*C*D1*Dd*f**2*fd*r - 156000*C*D1*Dd*f**2*fd*s**2 + 156000*C*D1*Dd*f**2*fd*s - 32500*C*D1*Dd*f**2*fd - 26000*C*D1*Ddd*f**3*r*s + 6500*C*D1*Ddd*f**3*r - 26000*C*D1*Ddd*f**3*s**2 + 26000*C*D1*Ddd*f**3*s - 6500*C*D1*Ddd*f**3 - 78000*C*Dd**2*f**3*r*s + 19500*C*Dd**2*f**3*r - 78000*C*Dd**2*f**3*s**2 + 78000*C*Dd**2*f**3*s - 13000*C*Dd**2*f**3 - 4290*D1**2*K*bdd1*f**2*r*s - 4290*D1**2*K*bdd1*f**2*s**2 + 4290*D1**2*K*bdd1*f**2*s + 4290*D1**2*bdd1*f**2*r*s + 4290*D1**2*bdd1*f**2*s**2 - 4290*D1**2*bdd1*f**2*s + 48380*D1**2*f**3*fd*r*s - 12095*D1**2*f**3*fd*r + 48380*D1**2*f**3*fd*s**2 - 48380*D1**2*f**3*fd*s + 12095*D1**2*f**3*fd - 27440*D1**2*f**3*fdd*r*s + 6860*D1**2*f**3*fdd*r - 27440*D1**2*f**3*fdd*s**2 + 27440*D1**2*f**3*fdd*s - 6860*D1**2*f**3*fdd - 82320*D1**2*f**2*fd**2*r*s + 20580*D1**2*f**2*fd**2*r - 82320*D1**2*f**2*fd**2*s**2 + 82320*D1**2*f**2*fd**2*s - 13720*D1**2*f**2*fd**2 - 33852*D1**2*f**2*fd*r*s + 11284*D1**2*f**2*fd*r - 33852*D1**2*f**2*fd*s**2 + 33852*D1**2*f**2*fd*s - 11284*D1**2*f**2*fd + 19500*D1**2*f**2*fdd*r*s - 6500*D1**2*f**2*fdd*r + 19500*D1**2*f**2*fdd*s**2 - 19500*D1**2*f**2*fdd*s + 6500*D1**2*f**2*fdd - 15444*D1**2*f**2*gd2*r*s - 15444*D1**2*f**2*gd2*s**2 + 15444*D1**2*f**2*gd2*s + 8580*D1**2*f**2*gdd2*r*s + 8580*D1**2*f**2*gdd2*s**2 - 8580*D1**2*f**2*gdd2*s + 39000*D1**2*f*fd**2*r*s - 13000*D1**2*f*fd**2*r + 39000*D1**2*f*fd**2*s**2 - 39000*D1**2*f*fd**2*s + 6500*D1**2*f*fd**2 - 30888*D1**2*f*fd*g2*r*s + 15444*D1**2*f*fd*g2*r - 30888*D1**2*f*fd*g2*s**2 + 30888*D1**2*f*fd*g2*s - 15444*D1**2*f*fd*g2 + 34320*D1**2*f*fd*gd2*r*s - 8580*D1**2*f*fd*gd2*r + 34320*D1**2*f*fd*gd2*s**2 - 34320*D1**2*f*fd*gd2*s + 8580*D1**2*f*fd*gd2 + 17160*D1**2*f*fdd*g2*r*s - 8580*D1**2*f*fdd*g2*r + 17160*D1**2*f*fdd*g2*s**2 - 17160*D1**2*f*fdd*g2*s + 8580*D1**2*f*fdd*g2 + 17160*D1**2*fd**2*g2*r*s - 8580*D1**2*fd**2*g2*r + 17160*D1**2*fd**2*g2*s**2 - 17160*D1**2*fd**2*g2*s + 48380*D1*Dd*f**4*r*s - 12095*D1*Dd*f**4*r + 48380*D1*Dd*f**4*s**2 - 48380*D1*Dd*f**4*s + 12095*D1*Dd*f**4 - 219520*D1*Dd*f**3*fd*r*s + 54880*D1*Dd*f**3*fd*r - 219520*D1*Dd*f**3*fd*s**2 + 219520*D1*Dd*f**3*fd*s - 41160*D1*Dd*f**3*fd - 45136*D1*Dd*f**3*r*s + 11284*D1*Dd*f**3*r - 45136*D1*Dd*f**3*s**2 + 45136*D1*Dd*f**3*s - 11284*D1*Dd*f**3 + 156000*D1*Dd*f**2*fd*r*s - 45500*D1*Dd*f**2*fd*r + 156000*D1*Dd*f**2*fd*s**2 - 156000*D1*Dd*f**2*fd*s + 32500*D1*Dd*f**2*fd - 61776*D1*Dd*f**2*g2*r*s + 15444*D1*Dd*f**2*g2*r - 61776*D1*Dd*f**2*g2*s**2 + 61776*D1*Dd*f**2*g2*s - 15444*D1*Dd*f**2*g2 + 68640*D1*Dd*f**2*gd2*r*s - 8580*D1*Dd*f**2*gd2*r + 68640*D1*Dd*f**2*gd2*s**2 - 68640*D1*Dd*f**2*gd2*s + 8580*D1*Dd*f**2*gd2 + 137280*D1*Dd*f*fd*g2*r*s - 51480*D1*Dd*f*fd*g2*r + 137280*D1*Dd*f*fd*g2*s**2 - 137280*D1*Dd*f*fd*g2*s + 34320*D1*Dd*f*fd*g2 - 27440*D1*Ddd*f**4*r*s + 6860*D1*Ddd*f**4*r - 27440*D1*Ddd*f**4*s**2 + 27440*D1*Ddd*f**4*s - 6860*D1*Ddd*f**4 + 26000*D1*Ddd*f**3*r*s - 6500*D1*Ddd*f**3*r + 26000*D1*Ddd*f**3*s**2 - 26000*D1*Ddd*f**3*s + 6500*D1*Ddd*f**3 + 34320*D1*Ddd*f**2*g2*r*s - 8580*D1*Ddd*f**2*g2*r + 34320*D1*Ddd*f**2*g2*s**2 - 34320*D1*Ddd*f**2*g2*s + 8580*D1*Ddd*f**2*g2 + 858*D1*bd1*f*(K - 1)*(D1*(9*f*s*(r + s - 1) - 5*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 82320*Dd**2*f**4*r*s + 20580*Dd**2*f**4*r - 82320*Dd**2*f**4*s**2 + 82320*Dd**2*f**4*s - 13720*Dd**2*f**4 + 78000*Dd**2*f**3*r*s - 19500*Dd**2*f**3*r + 78000*Dd**2*f**3*s**2 - 78000*Dd**2*f**3*s + 13000*Dd**2*f**3 + 102960*Dd**2*f**2*g2*r*s - 25740*Dd**2*f**2*g2*r + 102960*Dd**2*f**2*g2*s**2 - 102960*Dd**2*f**2*g2*s + 17160*Dd**2*f**2*g2 + 858*b1*(K - 1)*(D1**2*(f*(9*fd - 5*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 5*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(9*f*(r*(4*s - 1) + (1 - 2*s)**2) - 10*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**5*k1**3*k2**2*(-990*C*D1**2*bdd1*f**2*r*s + 990*C*D1**2*bdd1*f**2*r - 990*C*D1**2*bdd1*f**2*s**2 + 1980*C*D1**2*bdd1*f**2*s - 990*C*D1**2*bdd1*f**2 + 4140*C*D1**2*f**2*fd*r*s - 1380*C*D1**2*f**2*fd*r + 4140*C*D1**2*f**2*fd*s**2 - 4140*C*D1**2*f**2*fd*s + 1380*C*D1**2*f**2*fd - 5040*C*D1**2*f**2*fdd*r*s + 1680*C*D1**2*f**2*fdd*r - 5040*C*D1**2*f**2*fdd*s**2 + 5040*C*D1**2*f**2*fdd*s - 1680*C*D1**2*f**2*fdd - 10080*C*D1**2*f*fd**2*r*s + 3360*C*D1**2*f*fd**2*r - 10080*C*D1**2*f*fd**2*s**2 + 10080*C*D1**2*f*fd**2*s - 1680*C*D1**2*f*fd**2 + 5520*C*D1*Dd*f**3*r*s - 1380*C*D1*Dd*f**3*r + 5520*C*D1*Dd*f**3*s**2 - 5520*C*D1*Dd*f**3*s + 1380*C*D1*Dd*f**3 - 40320*C*D1*Dd*f**2*fd*r*s + 11760*C*D1*Dd*f**2*fd*r - 40320*C*D1*Dd*f**2*fd*s**2 + 40320*C*D1*Dd*f**2*fd*s - 8400*C*D1*Dd*f**2*fd - 6720*C*D1*Ddd*f**3*r*s + 1680*C*D1*Ddd*f**3*r - 6720*C*D1*Ddd*f**3*s**2 + 6720*C*D1*Ddd*f**3*s - 1680*C*D1*Ddd*f**3 - 20160*C*Dd**2*f**3*r*s + 5040*C*Dd**2*f**3*r - 20160*C*Dd**2*f**3*s**2 + 20160*C*Dd**2*f**3*s - 3360*C*Dd**2*f**3 - 990*D1**2*K*bdd1*f**2*r*s - 990*D1**2*K*bdd1*f**2*s**2 + 990*D1**2*K*bdd1*f**2*s - 594*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 280*D1**2*bdd1*f**3*r*s + 560*D1**2*bdd1*f**3*r + 280*D1**2*bdd1*f**3*s**2 + 280*D1**2*bdd1*f**3*s - 560*D1**2*bdd1*f**3 + 1485*D1**2*bdd1*f**2*r*s - 990*D1**2*bdd1*f**2*r + 1485*D1**2*bdd1*f**2*s**2 - 2475*D1**2*bdd1*f**2*s + 990*D1**2*bdd1*f**2 + 1188*D1**2*bdd1*f*g2*r*s - 1188*D1**2*bdd1*f*g2*r + 1188*D1**2*bdd1*f*g2*s**2 - 2376*D1**2*bdd1*f*g2*s + 1188*D1**2*bdd1*f*g2 - 1680*D1**2*f**3*fd*r*s + 420*D1**2*f**3*fd*r - 1680*D1**2*f**3*fd*s**2 + 1680*D1**2*f**3*fd*s - 420*D1**2*f**3*fd - 2610*D1**2*f**2*fd*r*s + 870*D1**2*f**2*fd*r - 2610*D1**2*f**2*fd*s**2 + 2610*D1**2*f**2*fd*s - 870*D1**2*f**2*fd + 3780*D1**2*f**2*fdd*r*s - 1260*D1**2*f**2*fdd*r + 3780*D1**2*f**2*fdd*s**2 - 3780*D1**2*f**2*fdd*s + 1260*D1**2*f**2*fdd - 1584*D1**2*f**2*gd2*r*s - 1584*D1**2*f**2*gd2*s**2 + 1584*D1**2*f**2*gd2*s + 1980*D1**2*f**2*gdd2*r*s + 1980*D1**2*f**2*gdd2*s**2 - 1980*D1**2*f**2*gdd2*s + 7560*D1**2*f*fd**2*r*s - 2520*D1**2*f*fd**2*r + 7560*D1**2*f*fd**2*s**2 - 7560*D1**2*f*fd**2*s + 1260*D1**2*f*fd**2 - 3168*D1**2*f*fd*g2*r*s + 1584*D1**2*f*fd*g2*r - 3168*D1**2*f*fd*g2*s**2 + 3168*D1**2*f*fd*g2*s - 1584*D1**2*f*fd*g2 + 7920*D1**2*f*fd*gd2*r*s - 1980*D1**2*f*fd*gd2*r + 7920*D1**2*f*fd*gd2*s**2 - 7920*D1**2*f*fd*gd2*s + 1980*D1**2*f*fd*gd2 + 3960*D1**2*f*fdd*g2*r*s - 1980*D1**2*f*fdd*g2*r + 3960*D1**2*f*fdd*g2*s**2 - 3960*D1**2*f*fdd*g2*s + 1980*D1**2*f*fdd*g2 + 3960*D1**2*fd**2*g2*r*s - 1980*D1**2*fd**2*g2*r + 3960*D1**2*fd**2*g2*s**2 - 3960*D1**2*fd**2*g2*s - 1680*D1*Dd*f**4*r*s + 420*D1*Dd*f**4*r - 1680*D1*Dd*f**4*s**2 + 1680*D1*Dd*f**4*s - 420*D1*Dd*f**4 - 3480*D1*Dd*f**3*r*s + 870*D1*Dd*f**3*r - 3480*D1*Dd*f**3*s**2 + 3480*D1*Dd*f**3*s - 870*D1*Dd*f**3 + 30240*D1*Dd*f**2*fd*r*s - 8820*D1*Dd*f**2*fd*r + 30240*D1*Dd*f**2*fd*s**2 - 30240*D1*Dd*f**2*fd*s + 6300*D1*Dd*f**2*fd - 6336*D1*Dd*f**2*g2*r*s + 1584*D1*Dd*f**2*g2*r - 6336*D1*Dd*f**2*g2*s**2 + 6336*D1*Dd*f**2*g2*s - 1584*D1*Dd*f**2*g2 + 15840*D1*Dd*f**2*gd2*r*s - 1980*D1*Dd*f**2*gd2*r + 15840*D1*Dd*f**2*gd2*s**2 - 15840*D1*Dd*f**2*gd2*s + 1980*D1*Dd*f**2*gd2 + 31680*D1*Dd*f*fd*g2*r*s - 11880*D1*Dd*f*fd*g2*r + 31680*D1*Dd*f*fd*g2*s**2 - 31680*D1*Dd*f*fd*g2*s + 7920*D1*Dd*f*fd*g2 + 5040*D1*Ddd*f**3*r*s - 1260*D1*Ddd*f**3*r + 5040*D1*Ddd*f**3*s**2 - 5040*D1*Ddd*f**3*s + 1260*D1*Ddd*f**3 + 7920*D1*Ddd*f**2*g2*r*s - 1980*D1*Ddd*f**2*g2*r + 7920*D1*Ddd*f**2*g2*s**2 - 7920*D1*Ddd*f**2*g2*s + 1980*D1*Ddd*f**2*g2 + D1*bd1*(-D1*(5*f**3*(46*s + 191)*(r + s - 1) - 2*f**2*(792*C*(s - 1)*(r + s - 1) + 140*fd*(r*(6*s + 3) + 6*s**2 - 2*s - 1) + (s*(4*K - 9) + 8)*(99*r + 99*s - 99)) + 33*f*(15*fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 5*r - 12*s**2 + 14*s - 3) + (58*g2*(s - 1) + 36*gd2*(1 - 2*s))*(r + s - 1)) - 1188*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(280*f**2*(r*(8*s + 7) + 8*s**2 - 5) - 495*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 11*r - 24*s**2 + 32*s - 9) + 1188*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 15120*Dd**2*f**3*r*s - 3780*Dd**2*f**3*r + 15120*Dd**2*f**3*s**2 - 15120*Dd**2*f**3*s + 2520*Dd**2*f**3 + 23760*Dd**2*f**2*g2*r*s - 5940*Dd**2*f**2*g2*r + 23760*Dd**2*f**2*g2*s**2 - 23760*Dd**2*f**2*g2*s + 3960*Dd**2*f**2*g2 + 33*b1**2*(K - 1)*(D1**2*s*(29*fd - 18*fdd)*(r + s) + D1*Dd*(29*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*fd*(r*(8*s - 1) + 4*s*(2*s - 1))) - 18*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 18*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(3168*C*D1**2*f*fd*r*s + 3168*C*D1**2*f*fd*s**2 - 1584*C*D1**2*f*fd*s - 1980*C*D1**2*f*fdd*r*s - 1980*C*D1**2*f*fdd*s**2 + 990*C*D1**2*f*fdd*s - 1980*C*D1**2*fd**2*r*s - 1980*C*D1**2*fd**2*s**2 + 990*C*D1**2*fd**2*s + 6336*C*D1*Dd*f**2*r*s - 1584*C*D1*Dd*f**2*r + 6336*C*D1*Dd*f**2*s**2 - 6336*C*D1*Dd*f**2*s + 1584*C*D1*Dd*f**2 - 15840*C*D1*Dd*f*fd*r*s + 1980*C*D1*Dd*f*fd*r - 15840*C*D1*Dd*f*fd*s**2 + 11880*C*D1*Dd*f*fd*s - 990*C*D1*Dd*f*fd - 3960*C*D1*Ddd*f**2*r*s + 990*C*D1*Ddd*f**2*r - 3960*C*D1*Ddd*f**2*s**2 + 3960*C*D1*Ddd*f**2*s - 990*C*D1*Ddd*f**2 - 11880*C*Dd**2*f**2*r*s + 2970*C*Dd**2*f**2*r - 11880*C*Dd**2*f**2*s**2 + 11880*C*Dd**2*f**2*s - 1980*C*Dd**2*f**2 + 1584*D1**2*K*f*fd*r*s - 792*D1**2*K*f*fd*r + 1584*D1**2*K*f*fd*s**2 - 1584*D1**2*K*f*fd*s + 792*D1**2*K*f*fd - 1980*D1**2*K*f*fdd*r*s + 990*D1**2*K*f*fdd*r - 1980*D1**2*K*f*fdd*s**2 + 1980*D1**2*K*f*fdd*s - 990*D1**2*K*f*fdd - 1980*D1**2*K*fd**2*r*s + 990*D1**2*K*fd**2*r - 1980*D1**2*K*fd**2*s**2 + 1980*D1**2*K*fd**2*s - 594*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 690*D1**2*f**2*fd*r*s + 1185*D1**2*f**2*fd*r - 690*D1**2*f**2*fd*s**2 + 1645*D1**2*f**2*fd*s - 1185*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r*s - 840*D1**2*f**2*fdd*r + 840*D1**2*f**2*fdd*s**2 - 1400*D1**2*f**2*fdd*s + 840*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r*s - 1680*D1**2*f*fd**2*r + 1680*D1**2*f*fd**2*s**2 - 2800*D1**2*f*fd**2*s + 840*D1**2*f*fd**2 - 3564*D1**2*f*fd*r*s + 198*D1**2*f*fd*r - 3564*D1**2*f*fd*s**2 + 1980*D1**2*f*fd*s - 198*D1**2*f*fd + 2970*D1**2*f*fdd*r*s - 495*D1**2*f*fdd*r + 2970*D1**2*f*fdd*s**2 - 1980*D1**2*f*fdd*s + 495*D1**2*f*fdd - 1914*D1**2*f*gd2*r*s - 1914*D1**2*f*gd2*s**2 + 1914*D1**2*f*gd2*s + 1188*D1**2*f*gdd2*r*s + 1188*D1**2*f*gdd2*s**2 - 1188*D1**2*f*gdd2*s + 2970*D1**2*fd**2*r*s - 495*D1**2*fd**2*r + 2970*D1**2*fd**2*s**2 - 1980*D1**2*fd**2*s - 1914*D1**2*fd*g2*r*s - 1914*D1**2*fd*g2*s**2 + 2376*D1**2*fd*gd2*r*s + 2376*D1**2*fd*gd2*s**2 - 1188*D1**2*fd*gd2*s + 1188*D1**2*fdd*g2*r*s + 1188*D1**2*fdd*g2*s**2 + 3168*D1*Dd*K*f**2*r*s - 792*D1*Dd*K*f**2*r + 3168*D1*Dd*K*f**2*s**2 - 3168*D1*Dd*K*f**2*s + 792*D1*Dd*K*f**2 - 15840*D1*Dd*K*f*fd*r*s + 5940*D1*Dd*K*f*fd*r - 15840*D1*Dd*K*f*fd*s**2 + 15840*D1*Dd*K*f*fd*s - 3960*D1*Dd*K*f*fd - 920*D1*Dd*f**3*r*s + 230*D1*Dd*f**3*r - 920*D1*Dd*f**3*s**2 + 920*D1*Dd*f**3*s - 230*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r*s - 4200*D1*Dd*f**2*fd*r + 6720*D1*Dd*f**2*fd*s**2 - 8960*D1*Dd*f**2*fd*s + 3080*D1*Dd*f**2*fd - 7128*D1*Dd*f**2*r*s + 1782*D1*Dd*f**2*r - 7128*D1*Dd*f**2*s**2 + 7128*D1*Dd*f**2*s - 1782*D1*Dd*f**2 + 23760*D1*Dd*f*fd*r*s - 4950*D1*Dd*f*fd*r + 23760*D1*Dd*f*fd*s**2 - 19800*D1*Dd*f*fd*s + 2970*D1*Dd*f*fd - 7656*D1*Dd*f*g2*r*s + 1914*D1*Dd*f*g2*r - 7656*D1*Dd*f*g2*s**2 + 7656*D1*Dd*f*g2*s - 1914*D1*Dd*f*g2 + 9504*D1*Dd*f*gd2*r*s - 1188*D1*Dd*f*gd2*r + 9504*D1*Dd*f*gd2*s**2 - 9504*D1*Dd*f*gd2*s + 1188*D1*Dd*f*gd2 + 9504*D1*Dd*fd*g2*r*s - 1188*D1*Dd*fd*g2*r + 9504*D1*Dd*fd*g2*s**2 - 4752*D1*Dd*fd*g2*s - 3960*D1*Ddd*K*f**2*r*s + 990*D1*Ddd*K*f**2*r - 3960*D1*Ddd*K*f**2*s**2 + 3960*D1*Ddd*K*f**2*s - 990*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r + 1120*D1*Ddd*f**3*s**2 - 1120*D1*Ddd*f**3*s + 280*D1*Ddd*f**3 + 5940*D1*Ddd*f**2*r*s - 1485*D1*Ddd*f**2*r + 5940*D1*Ddd*f**2*s**2 - 5940*D1*Ddd*f**2*s + 1485*D1*Ddd*f**2 + 4752*D1*Ddd*f*g2*r*s - 1188*D1*Ddd*f*g2*r + 4752*D1*Ddd*f*g2*s**2 - 4752*D1*Ddd*f*g2*s + 1188*D1*Ddd*f*g2 + 33*D1*bd1*(K - 1)*(D1*(29*f*(2*s - 1)*(r + s - 1) + 18*fd*(-4*r*s + r + s*(3 - 4*s))) - 18*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 11880*Dd**2*K*f**2*r*s + 2970*Dd**2*K*f**2*r - 11880*Dd**2*K*f**2*s**2 + 11880*Dd**2*K*f**2*s - 1980*Dd**2*K*f**2 + 3360*Dd**2*f**3*r*s - 840*Dd**2*f**3*r + 3360*Dd**2*f**3*s**2 - 3360*Dd**2*f**3*s + 560*Dd**2*f**3 + 17820*Dd**2*f**2*r*s - 4455*Dd**2*f**2*r + 17820*Dd**2*f**2*s**2 - 17820*Dd**2*f**2*s + 2970*Dd**2*f**2 + 14256*Dd**2*f*g2*r*s - 3564*Dd**2*f*g2*r + 14256*Dd**2*f*g2*s**2 - 14256*Dd**2*f*g2*s + 2376*Dd**2*f*g2))/(693*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**5*k1**3*(-198*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(5*f**3*s*(181*r + 181*s - 102) + f**2*(-140*fd*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3) + 66*s*(4*C*s + r*(4*C + 5) + 5*s - 9)) - 33*f*(5*fd*(r*(2*C + 1)*(4*s - 1) + s**2*(8*C + 4) - s*(6*C + 6) + 3) + 2*s*(5*g2*(r + s) - 6*gd2*(2*r + 2*s - 1))) + 396*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(140*f**2*(5*r*(8*s - 1) + 40*s**2 - 32*s + 3) + 165*f*(r*(2*C + 1)*(8*s - 1) + s**2*(16*C + 8) - s*(8*C + 16) + 3) - 396*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 33*b1**2*(K - 1)*(D1**2*(5*fd - 6*fdd)*(s - 1)*(r + s - 1) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(5*f**2*(fd*(181*r*(3*s - 1) + 543*s**2 - 622*s + 181) - 28*fdd*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5)) - f*(140*fd**2*(10*r*(3*s - 1) + 30*s**2 - 34*s + 7) - 66*fd*(4*C*(2*s - 1)*(r + s - 1) + 5*r*(2*s - 1) + 10*s**2 - 6*s + 5) + 165*fdd*(2*C*(2*s - 1)*(r + s - 1) + r*(2*s - 1) + 2*s**2 + 1) + 66*s*(3*bdd1*(K - 1)*(2*r + 2*s - 1) + (5*gd2 - 6*gdd2)*(r + s - 1))) - 165*fd**2*(2*C*(2*s - 1)*(r + s - 1) + 2*r*s - r + 2*s**2 - 2) - 66*fd*(5*g2*(s - 1) + 6*gd2*(1 - 2*s))*(r + s - 1) + 396*fdd*g2*(s - 1)*(r + s - 1)) - 33*D1*bd1*(K - 1)*(D1*(-5*f*s*(2*r + 2*s - 1) + 6*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 6*Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(905*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + 2*f**2*(132*C*(r*(4*s - 1) + (1 - 2*s)**2) - 70*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) + 165*r*(4*s - 1) + 165*(1 - 2*s)**2) - 66*f*(5*fd*(C*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + 8*r*s - 3*r + 8*s**2 - 4*s + 1) + 5*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 6*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 396*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(700*f**2 + f*(330*C + 165) - 396*g2)) - Dd**2*f*(700*f**2 + f*(330*C + 165) - 396*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - f*(D1**2*(140*bdd1*f**2*s*(5*r + 5*s - 3) - 396*bdd1*g2*s*(r + s) - 15*f*(-11*bdd1*s*(2*C*r + 2*C*s + r + s - 3) + 34*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 420*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 30*D1*f*(Dd*(17*f*(r*(4*s - 1) + (1 - 2*s)**2) - 14*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 14*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 420*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**3) - 5*D1**2*Pkd2*Pkd3*ct**5*k1*k2**4*st**2*(600*C*D1**2*f**2*fd*r*s - 200*C*D1**2*f**2*fd*r + 600*C*D1**2*f**2*fd*s**2 - 600*C*D1**2*f**2*fd*s + 200*C*D1**2*f**2*fd - 300*C*D1**2*f**2*fdd*r*s + 100*C*D1**2*f**2*fdd*r - 300*C*D1**2*f**2*fdd*s**2 + 300*C*D1**2*f**2*fdd*s - 100*C*D1**2*f**2*fdd - 600*C*D1**2*f*fd**2*r*s + 200*C*D1**2*f*fd**2*r - 600*C*D1**2*f*fd**2*s**2 + 600*C*D1**2*f*fd**2*s - 100*C*D1**2*f*fd**2 + 800*C*D1*Dd*f**3*r*s - 200*C*D1*Dd*f**3*r + 800*C*D1*Dd*f**3*s**2 - 800*C*D1*Dd*f**3*s + 200*C*D1*Dd*f**3 - 2400*C*D1*Dd*f**2*fd*r*s + 700*C*D1*Dd*f**2*fd*r - 2400*C*D1*Dd*f**2*fd*s**2 + 2400*C*D1*Dd*f**2*fd*s - 500*C*D1*Dd*f**2*fd - 400*C*D1*Ddd*f**3*r*s + 100*C*D1*Ddd*f**3*r - 400*C*D1*Ddd*f**3*s**2 + 400*C*D1*Ddd*f**3*s - 100*C*D1*Ddd*f**3 - 1200*C*Dd**2*f**3*r*s + 300*C*Dd**2*f**3*r - 1200*C*Dd**2*f**3*s**2 + 1200*C*Dd**2*f**3*s - 200*C*Dd**2*f**3 - 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s + 35*D1**2*bdd1*f**3*r*s + 35*D1**2*bdd1*f**3*s**2 - 35*D1**2*bdd1*f**3*s + 33*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s - 450*D1**2*f**2*fd*r*s + 150*D1**2*f**2*fd*r - 450*D1**2*f**2*fd*s**2 + 450*D1**2*f**2*fd*s - 150*D1**2*f**2*fd + 225*D1**2*f**2*fdd*r*s - 75*D1**2*f**2*fdd*r + 225*D1**2*f**2*fdd*s**2 - 225*D1**2*f**2*fdd*s + 75*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 450*D1**2*f*fd**2*r*s - 150*D1**2*f*fd**2*r + 450*D1**2*f*fd**2*s**2 - 450*D1**2*f*fd**2*s + 75*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r*s - 132*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 528*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s - 600*D1*Dd*f**3*r*s + 150*D1*Dd*f**3*r - 600*D1*Dd*f**3*s**2 + 600*D1*Dd*f**3*s - 150*D1*Dd*f**3 + 1800*D1*Dd*f**2*fd*r*s - 525*D1*Dd*f**2*fd*r + 1800*D1*Dd*f**2*fd*s**2 - 1800*D1*Dd*f**2*fd*s + 375*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r*s - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1056*D1*Dd*f**2*gd2*s + 132*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r*s - 792*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2112*D1*Dd*f*fd*g2*s + 528*D1*Dd*f*fd*g2 + 300*D1*Ddd*f**3*r*s - 75*D1*Ddd*f**3*r + 300*D1*Ddd*f**3*s**2 - 300*D1*Ddd*f**3*s + 75*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r*s - 132*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 528*D1*Ddd*f**2*g2*s + 132*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(35*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-66*K + 35*f + 33)*(r + s - 1) - 33*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-66*K + 35*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 900*Dd**2*f**3*r*s - 225*Dd**2*f**3*r + 900*Dd**2*f**3*s**2 - 900*Dd**2*f**3*s + 150*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r*s - 396*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 1584*Dd**2*f**2*g2*s + 264*Dd**2*f**2*g2 + b1*(D1**2*(-35*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(35*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*fd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 33*fdd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 33*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-70*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(35*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (132*K - 66)*(r*(4*s - 1) + (1 - 2*s)**2)) - 66*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-66*K + 35*f + 33)) + Dd**2*f**2*(-66*K + 35*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct**5*k1*k2**4*(220*C*D1**2*bdd1*f**2*r*s - 220*C*D1**2*bdd1*f**2*r + 220*C*D1**2*bdd1*f**2*s**2 - 440*C*D1**2*bdd1*f**2*s + 220*C*D1**2*bdd1*f**2 - 690*C*D1**2*f**2*fd*r*s + 230*C*D1**2*f**2*fd*r - 690*C*D1**2*f**2*fd*s**2 + 690*C*D1**2*f**2*fd*s - 230*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 920*C*D1*Dd*f**3*r*s + 230*C*D1*Dd*f**3*r - 920*C*D1*Dd*f**3*s**2 + 920*C*D1*Dd*f**3*s - 230*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 11*D1**2*bd1**2*f*(2*s - 1)*(-12*K + 5*f + 6)*(r + s - 1) - 165*D1**2*bdd1*f**2*r*s + 165*D1**2*bdd1*f**2*r - 165*D1**2*bdd1*f**2*s**2 + 330*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 - 264*D1**2*bdd1*f*g2*r*s + 264*D1**2*bdd1*f*g2*r - 264*D1**2*bdd1*f*g2*s**2 + 528*D1**2*bdd1*f*g2*s - 264*D1**2*bdd1*f*g2 + 180*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 180*D1**2*f**2*fd*s**2 - 180*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 840*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 240*D1*Dd*f**3*s**2 - 240*D1*Dd*f**3*s + 60*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3360*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r*s - 264*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1056*D1*Dd*f**2*g2*s + 264*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + 2*f**2*(r + s - 1)*(20*C*(s - 1) + s*(6*K - 12) + 15) + f*(-5*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 3*K*(r*(4*s - 1) + (1 - 2*s)**2) - 12*r*s + 6*r - 12*s**2 + 15*s - 3) + (-24*r - 24*s + 24)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 24*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-5*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 3*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) + 24*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 1680*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 11*b1**2*(D1**2*s*(5*f*(2*fd - fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 12*fd*(2*K - 1)*(r + s) + 6*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (12 - 24*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-12*K + 5*f + 6)) - Dd**2*f*(-12*K + 5*f + 6)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(-80*C*D1**2*f*fd*r*s - 80*C*D1**2*f*fd*s**2 + 40*C*D1**2*f*fd*s + 40*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 40*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 40*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r*s + 12*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*s - 1)*(-12*K + 5*f + 6)*(r + s - 1) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 48*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s - 6*D1**2*f*fd - 30*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*s**2 + 15*D1**2*f*fdd*s + 48*D1**2*f*gd2*r*s + 48*D1**2*f*gd2*s**2 - 48*D1**2*f*gd2*s - 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 30*D1**2*fd**2*r*s - 30*D1**2*fd**2*s**2 + 15*D1**2*fd**2*s + 48*D1**2*fd*g2*r*s + 48*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r*s - 48*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 - 48*D1*Dd*K*f**2*r*s + 12*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 48*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 + 96*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 96*D1*Dd*f**2*s + 24*D1*Dd*f**2 - 240*D1*Dd*f*fd*r*s + 30*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 15*D1*Dd*f*fd + 192*D1*Dd*f*g2*r*s - 48*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 192*D1*Dd*f*g2*s + 48*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r*s + 24*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 192*D1*Dd*f*gd2*s - 24*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r*s + 24*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 96*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 60*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 96*D1*Ddd*f*g2*s - 24*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(2*s - 1)*(r + s - 1) + f*(-5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (12 - 24*K)*(2*s - 1)*(r + s - 1)) + 6*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-12*K + 5*f + 6)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 180*Dd**2*f**2*r*s + 45*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 30*Dd**2*f**2 - 288*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 288*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(231*d**2*k3**5) - 5*D1**2*Pkd2*Pkd3*ct**5*k1*k2**2*st**2*(b1*(D1**2*(35*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(-35*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 66*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 33*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 33*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(70*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-35*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 66*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(35*f + 33)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(35*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(35*bdd1*f**2*s*(r + s - 1) + f*(33*bdd1*s*(r + s - 1) - 50*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-35*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 2*f*s*(35*f + 33)*(r + s - 1) - 33*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(35*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 25*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 25*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**5*k1*k2**2*(-220*C*D1**2*bdd1*f**2*r*s - 220*C*D1**2*bdd1*f**2*s**2 - 1350*C*D1**2*f**2*fd*r*s + 450*C*D1**2*f**2*fd*r - 1350*C*D1**2*f**2*fd*s**2 + 1350*C*D1**2*f**2*fd*s - 450*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 1800*C*D1*Dd*f**3*r*s + 450*C*D1*Dd*f**3*r - 1800*C*D1*Dd*f**3*s**2 + 1800*C*D1*Dd*f**3*s - 450*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 528*D1**2*b2*f*fd*r*s + 264*D1**2*b2*f*fd*r - 528*D1**2*b2*f*fd*s**2 + 528*D1**2*b2*f*fd*s - 264*D1**2*b2*f*fd + 330*D1**2*b2*f*fdd*r*s - 165*D1**2*b2*f*fdd*r + 330*D1**2*b2*f*fdd*s**2 - 330*D1**2*b2*f*fdd*s + 165*D1**2*b2*f*fdd + 330*D1**2*b2*fd**2*r*s - 165*D1**2*b2*fd**2*r + 330*D1**2*b2*fd**2*s**2 - 330*D1**2*b2*fd**2*s + 11*D1**2*bd1**2*f*(5*f*(r + 2*s - 1) - 6*r*(4*K*s - 1) - 6*(2*s - 1)*(2*K*s - 1)) - 264*D1**2*bd2*f**2*r*s - 264*D1**2*bd2*f**2*s**2 + 264*D1**2*bd2*f**2*s + 660*D1**2*bd2*f*fd*r*s - 165*D1**2*bd2*f*fd*r + 660*D1**2*bd2*f*fd*s**2 - 660*D1**2*bd2*f*fd*s + 165*D1**2*bd2*f*fd + 110*D1**2*bdd1*f**2*r*s + 55*D1**2*bdd1*f**2*r + 110*D1**2*bdd1*f**2*s**2 + 110*D1**2*bdd1*f**2*s - 55*D1**2*bdd1*f**2 + 264*D1**2*bdd1*f*g2*r*s + 264*D1**2*bdd1*f*g2*s**2 + 165*D1**2*bdd2*f**2*r*s + 165*D1**2*bdd2*f**2*s**2 - 165*D1**2*bdd2*f**2*s + 510*D1**2*f**2*fd*r*s - 170*D1**2*f**2*fd*r + 510*D1**2*f**2*fd*s**2 - 510*D1**2*f**2*fd*s + 170*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd + 528*D1**2*f**2*gd2*r*s + 528*D1**2*f**2*gd2*s**2 - 528*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 840*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 1056*D1**2*f*fd*g2*r*s - 528*D1**2*f*fd*g2*r + 1056*D1**2*f*fd*g2*s**2 - 1056*D1**2*f*fd*g2*s + 528*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s - 1056*D1*Dd*b2*f**2*r*s + 264*D1*Dd*b2*f**2*r - 1056*D1*Dd*b2*f**2*s**2 + 1056*D1*Dd*b2*f**2*s - 264*D1*Dd*b2*f**2 + 2640*D1*Dd*b2*f*fd*r*s - 990*D1*Dd*b2*f*fd*r + 2640*D1*Dd*b2*f*fd*s**2 - 2640*D1*Dd*b2*f*fd*s + 660*D1*Dd*b2*f*fd + 1320*D1*Dd*bd2*f**2*r*s - 165*D1*Dd*bd2*f**2*r + 1320*D1*Dd*bd2*f**2*s**2 - 1320*D1*Dd*bd2*f**2*s + 165*D1*Dd*bd2*f**2 + 680*D1*Dd*f**3*r*s - 170*D1*Dd*f**3*r + 680*D1*Dd*f**3*s**2 - 680*D1*Dd*f**3*s + 170*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3360*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd + 2112*D1*Dd*f**2*g2*r*s - 528*D1*Dd*f**2*g2*r + 2112*D1*Dd*f**2*g2*s**2 - 2112*D1*Dd*f**2*g2*s + 528*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 + 660*D1*Ddd*b2*f**2*r*s - 165*D1*Ddd*b2*f**2*r + 660*D1*Ddd*b2*f**2*s**2 - 660*D1*Ddd*b2*f**2*s + 165*D1*Ddd*b2*f**2 - 560*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + 2*f**2*(r*(s*(-20*C + 12*K + 13) + 5) + s**2*(-20*C + 12*K + 13) + s*(7 - 12*K) - 5) + f*(-5*fd*(-16*C*s**2 + 12*C*s + 3*K*(r*(4*s - 1) + (1 - 2*s)**2) + r*(-16*C*s + 4*C + 8*s - 1) + 8*s**2 - 4*s - 1) + 24*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) + 24*fd*g2*(-2*r*s + r - s*(2*s - 2))) - Dd*f*(5*f*(-32*C*r*s + 4*C*r - 32*C*s**2 + 16*C*s + 3*K*(8*r*s - r + 8*s**2 - 8*s + 1) + 16*r*s + 2*r + 16*s**2 - 4) + 24*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 1980*Dd**2*b2*f**2*r*s - 495*Dd**2*b2*f**2*r + 1980*Dd**2*b2*f**2*s**2 - 1980*Dd**2*b2*f**2*s + 330*Dd**2*b2*f**2 - 1680*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 - 11*b1**2*(D1**2*(5*fd**2*(r + 2*s - 1) - 2*fd*(12*K*(s - 1)*(r + s - 1) + 5*f*(r + 2*s - 1) + 6*r + 12*s - 6) + fdd*(12*K*(s - 1)*(r + s - 1) + 5*f*(r + 2*s - 1) + 6*r + 12*s - 6)) + 4*D1*(Dd*(-6*K*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(3*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 5*f*(r + 2*s - 1) + 6*r + 12*s - 6)) + 3*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 12*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 11*b1*(-80*C*D1**2*f*fd*r*s + 40*C*D1**2*f*fd*r - 80*C*D1**2*f*fd*s**2 + 120*C*D1**2*f*fd*s - 40*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s + 20*C*D1**2*fd**2 - 160*C*D1*Dd*f**2*r*s + 40*C*D1*Dd*f**2*r - 160*C*D1*Dd*f**2*s**2 + 160*C*D1*Dd*f**2*s - 40*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 120*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 + 48*D1**2*K*f*fd*r*s - 24*D1**2*K*f*fd*r + 48*D1**2*K*f*fd*s**2 - 48*D1**2*K*f*fd*s + 24*D1**2*K*f*fd - 30*D1**2*K*f*fdd*r*s + 15*D1**2*K*f*fdd*r - 30*D1**2*K*f*fdd*s**2 + 30*D1**2*K*f*fdd*s - 15*D1**2*K*f*fdd - 30*D1**2*K*fd**2*r*s + 15*D1**2*K*fd**2*r - 30*D1**2*K*fd**2*s**2 + 30*D1**2*K*fd**2*s + D1**2*bdd1*f*(-5*f*(r + 2*s - 1) + 6*r*(4*K*s - 1) + (12*s - 6)*(2*K*s - 1)) + 15*D1**2*f**2*fd*r*s - 5*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 15*D1**2*f**2*fd*s + 5*D1**2*f**2*fd + 52*D1**2*f*fd*r*s - 36*D1**2*f*fd*r + 52*D1**2*f*fd*s**2 - 92*D1**2*f*fd*s + 36*D1**2*f*fd - 20*D1**2*f*fdd*r*s + 15*D1**2*f*fdd*r - 20*D1**2*f*fdd*s**2 + 40*D1**2*f*fdd*s - 15*D1**2*f*fdd + 48*D1**2*f*gd2*r*s + 48*D1**2*f*gd2*s**2 - 48*D1**2*f*gd2*s - 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 20*D1**2*fd**2*r*s + 15*D1**2*fd**2*r - 20*D1**2*fd**2*s**2 + 40*D1**2*fd**2*s - 15*D1**2*fd**2 + 48*D1**2*fd*g2*r*s - 48*D1**2*fd*g2*r + 48*D1**2*fd*g2*s**2 - 96*D1**2*fd*g2*s + 48*D1**2*fd*g2 - 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 72*D1**2*fd*gd2*s - 24*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r*s + 24*D1**2*fdd*g2*r - 24*D1**2*fdd*g2*s**2 + 48*D1**2*fdd*g2*s - 24*D1**2*fdd*g2 + 96*D1*Dd*K*f**2*r*s - 24*D1*Dd*K*f**2*r + 96*D1*Dd*K*f**2*s**2 - 96*D1*Dd*K*f**2*s + 24*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*r*s + 90*D1*Dd*K*f*fd*r - 240*D1*Dd*K*f*fd*s**2 + 240*D1*Dd*K*f*fd*s - 60*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r*s - 5*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 20*D1*Dd*f**3*s + 5*D1*Dd*f**3 + 104*D1*Dd*f**2*r*s - 26*D1*Dd*f**2*r + 104*D1*Dd*f**2*s**2 - 104*D1*Dd*f**2*s + 26*D1*Dd*f**2 - 160*D1*Dd*f*fd*r*s + 80*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 240*D1*Dd*f*fd*s - 70*D1*Dd*f*fd + 192*D1*Dd*f*g2*r*s - 48*D1*Dd*f*g2*r + 192*D1*Dd*f*g2*s**2 - 192*D1*Dd*f*g2*s + 48*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r*s + 24*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 192*D1*Dd*f*gd2*s - 24*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r*s + 120*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s - 96*D1*Dd*fd*g2 - 60*D1*Ddd*K*f**2*r*s + 15*D1*Ddd*K*f**2*r - 60*D1*Ddd*K*f**2*s**2 + 60*D1*Ddd*K*f**2*s - 15*D1*Ddd*K*f**2 - 40*D1*Ddd*f**2*r*s + 10*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 40*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 96*D1*Ddd*f*g2*s - 24*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(5*f**2*(r + 2*s - 1) - 6*f*(r*(4*K*s - 1) + (2*s - 1)*(2*K*s - 1)) + 3*fd*(2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + r + 2*s - 1)) - 2*Dd*f*(K*(r*(6 - 48*s) - 48*s**2 + 36*s - 3) + 5*f*(r + 2*s - 1) + 6*r + 12*s - 6)) - 180*Dd**2*K*f**2*r*s + 45*Dd**2*K*f**2*r - 180*Dd**2*K*f**2*s**2 + 180*Dd**2*K*f**2*s - 30*Dd**2*K*f**2 - 120*Dd**2*f**2*r*s + 30*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 120*Dd**2*f**2*s - 20*Dd**2*f**2 - 288*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 288*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(231*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**5*k1*(-D1*f*(D1*bd1**2*s*(5*f + 6)*(2*r + 2*s - 1) + 5*D1*bdd1*f*s*(r + s) + 5*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1)))) + b1**2*(-D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) - 2*fd*(10*f*s - 5*f + 6*s - 6) + fdd*(10*f*s - 5*f + 6*s - 6)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 12*r*(4*s - 1) + 12*(1 - 2*s)**2) - 6*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(5*f + 6)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(5*f + 6)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(6*bdd1*s*(2*r + 2*s - 1) - 10*fd*(2*s - 1)*(r + s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) + 5*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + 2*f*s*(5*f + 6)*(2*r + 2*s - 1) - 6*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - Dd*f*(5*f + 6)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 5*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(6 - 16*s) - 16*s**2 + 20*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3) - 10*D1**2*Pkd2*Pkd3*ct**4*f**2*k1**6*(D1**2*(f*(38*fd - 45*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 45*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(38*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 90*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) - 45*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 45*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1287*d**2*k2*k3**5) - 20*D1**2*Pkd2*Pkd3*ct**4*f*k1**2*k2**3*st**4*(D1**2*(70*f**2*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-70*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + fd*(78*C - 78)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(39*C - 39)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(39*C - 39)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(140*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(78*C*(r*(4*s - 1) + (1 - 2*s)**2) - 140*fd*(4*s - 1)*(4*r + 4*s - 3) - 78*r*(4*s - 1) - 78*(1 - 2*s)**2) - fd*(39*C - 39)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(39*C + 70*f - 39)) - Dd**2*f**2*(39*C + 70*f - 39)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**4*k1**4*k2*st**2*(9126*C*D1**2*f**2*fd*r*s - 3042*C*D1**2*f**2*fd*r + 9126*C*D1**2*f**2*fd*s**2 - 9126*C*D1**2*f**2*fd*s + 3042*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 12168*C*D1*Dd*f**3*r*s - 3042*C*D1*Dd*f**3*r + 12168*C*D1*Dd*f**3*s**2 - 12168*C*D1*Dd*f**3*s + 3042*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 22900*D1**2*f**3*fd*r*s - 5725*D1**2*f**3*fd*r + 22900*D1**2*f**3*fd*s**2 - 22900*D1**2*f**3*fd*s + 5725*D1**2*f**3*fd - 14700*D1**2*f**3*fdd*r*s + 3675*D1**2*f**3*fdd*r - 14700*D1**2*f**3*fdd*s**2 + 14700*D1**2*f**3*fdd*s - 3675*D1**2*f**3*fdd - 44100*D1**2*f**2*fd**2*r*s + 11025*D1**2*f**2*fd**2*r - 44100*D1**2*f**2*fd**2*s**2 + 44100*D1**2*f**2*fd**2*s - 7350*D1**2*f**2*fd**2 - 9126*D1**2*f**2*fd*r*s + 3042*D1**2*f**2*fd*r - 9126*D1**2*f**2*fd*s**2 + 9126*D1**2*f**2*fd*s - 3042*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*s**2 + 4290*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 8580*D1**2*f*fd*g2*r*s + 4290*D1**2*f*fd*g2*r - 8580*D1**2*f*fd*g2*s**2 + 8580*D1**2*f*fd*g2*s - 4290*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 22900*D1*Dd*f**4*r*s - 5725*D1*Dd*f**4*r + 22900*D1*Dd*f**4*s**2 - 22900*D1*Dd*f**4*s + 5725*D1*Dd*f**4 - 117600*D1*Dd*f**3*fd*r*s + 29400*D1*Dd*f**3*fd*r - 117600*D1*Dd*f**3*fd*s**2 + 117600*D1*Dd*f**3*fd*s - 22050*D1*Dd*f**3*fd - 12168*D1*Dd*f**3*r*s + 3042*D1*Dd*f**3*r - 12168*D1*Dd*f**3*s**2 + 12168*D1*Dd*f**3*s - 3042*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 17160*D1*Dd*f**2*g2*r*s + 4290*D1*Dd*f**2*g2*r - 17160*D1*Dd*f**2*g2*s**2 + 17160*D1*Dd*f**2*g2*s - 4290*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 14700*D1*Ddd*f**4*r*s + 3675*D1*Ddd*f**4*r - 14700*D1*Ddd*f**4*s**2 + 14700*D1*Ddd*f**4*s - 3675*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 44100*Dd**2*f**4*r*s + 11025*Dd**2*f**4*r - 44100*Dd**2*f**4*s**2 + 44100*Dd**2*f**4*s - 7350*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(3003*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct**4*k1**4*k2*(990*C*D1**2*bdd1*f**2*r*s - 990*C*D1**2*bdd1*f**2*r + 990*C*D1**2*bdd1*f**2*s**2 - 1980*C*D1**2*bdd1*f**2*s + 990*C*D1**2*bdd1*f**2 - 390*C*D1**2*f**2*fd*r*s + 130*C*D1**2*f**2*fd*r - 390*C*D1**2*f**2*fd*s**2 + 390*C*D1**2*f**2*fd*s - 130*C*D1**2*f**2*fd + 1680*C*D1**2*f**2*fdd*r*s - 560*C*D1**2*f**2*fdd*r + 1680*C*D1**2*f**2*fdd*s**2 - 1680*C*D1**2*f**2*fdd*s + 560*C*D1**2*f**2*fdd + 3360*C*D1**2*f*fd**2*r*s - 1120*C*D1**2*f*fd**2*r + 3360*C*D1**2*f*fd**2*s**2 - 3360*C*D1**2*f*fd**2*s + 560*C*D1**2*f*fd**2 - 520*C*D1*Dd*f**3*r*s + 130*C*D1*Dd*f**3*r - 520*C*D1*Dd*f**3*s**2 + 520*C*D1*Dd*f**3*s - 130*C*D1*Dd*f**3 + 13440*C*D1*Dd*f**2*fd*r*s - 3920*C*D1*Dd*f**2*fd*r + 13440*C*D1*Dd*f**2*fd*s**2 - 13440*C*D1*Dd*f**2*fd*s + 2800*C*D1*Dd*f**2*fd + 2240*C*D1*Ddd*f**3*r*s - 560*C*D1*Ddd*f**3*r + 2240*C*D1*Ddd*f**3*s**2 - 2240*C*D1*Ddd*f**3*s + 560*C*D1*Ddd*f**3 + 6720*C*Dd**2*f**3*r*s - 1680*C*Dd**2*f**3*r + 6720*C*Dd**2*f**3*s**2 - 6720*C*Dd**2*f**3*s + 1120*C*Dd**2*f**3 + 330*D1**2*K*bdd1*f**2*r*s + 330*D1**2*K*bdd1*f**2*s**2 - 330*D1**2*K*bdd1*f**2*s + 594*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 280*D1**2*bdd1*f**3*r*s - 840*D1**2*bdd1*f**3*r + 280*D1**2*bdd1*f**3*s**2 - 1120*D1**2*bdd1*f**3*s + 840*D1**2*bdd1*f**3 - 1155*D1**2*bdd1*f**2*r*s + 990*D1**2*bdd1*f**2*r - 1155*D1**2*bdd1*f**2*s**2 + 2145*D1**2*bdd1*f**2*s - 990*D1**2*bdd1*f**2 - 1188*D1**2*bdd1*f*g2*r*s + 1188*D1**2*bdd1*f*g2*r - 1188*D1**2*bdd1*f*g2*s**2 + 2376*D1**2*bdd1*f*g2*s - 1188*D1**2*bdd1*f*g2 + 1680*D1**2*f**3*fd*r*s - 420*D1**2*f**3*fd*r + 1680*D1**2*f**3*fd*s**2 - 1680*D1**2*f**3*fd*s + 420*D1**2*f**3*fd + 45*D1**2*f**2*fd*r*s - 15*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s**2 - 45*D1**2*f**2*fd*s + 15*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r*s + 420*D1**2*f**2*fdd*r - 1260*D1**2*f**2*fdd*s**2 + 1260*D1**2*f**2*fdd*s - 420*D1**2*f**2*fdd + 132*D1**2*f**2*gd2*r*s + 132*D1**2*f**2*gd2*s**2 - 132*D1**2*f**2*gd2*s - 660*D1**2*f**2*gdd2*r*s - 660*D1**2*f**2*gdd2*s**2 + 660*D1**2*f**2*gdd2*s - 2520*D1**2*f*fd**2*r*s + 840*D1**2*f*fd**2*r - 2520*D1**2*f*fd**2*s**2 + 2520*D1**2*f*fd**2*s - 420*D1**2*f*fd**2 + 264*D1**2*f*fd*g2*r*s - 132*D1**2*f*fd*g2*r + 264*D1**2*f*fd*g2*s**2 - 264*D1**2*f*fd*g2*s + 132*D1**2*f*fd*g2 - 2640*D1**2*f*fd*gd2*r*s + 660*D1**2*f*fd*gd2*r - 2640*D1**2*f*fd*gd2*s**2 + 2640*D1**2*f*fd*gd2*s - 660*D1**2*f*fd*gd2 - 1320*D1**2*f*fdd*g2*r*s + 660*D1**2*f*fdd*g2*r - 1320*D1**2*f*fdd*g2*s**2 + 1320*D1**2*f*fdd*g2*s - 660*D1**2*f*fdd*g2 - 1320*D1**2*fd**2*g2*r*s + 660*D1**2*fd**2*g2*r - 1320*D1**2*fd**2*g2*s**2 + 1320*D1**2*fd**2*g2*s + 1680*D1*Dd*f**4*r*s - 420*D1*Dd*f**4*r + 1680*D1*Dd*f**4*s**2 - 1680*D1*Dd*f**4*s + 420*D1*Dd*f**4 + 60*D1*Dd*f**3*r*s - 15*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 15*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r*s + 2940*D1*Dd*f**2*fd*r - 10080*D1*Dd*f**2*fd*s**2 + 10080*D1*Dd*f**2*fd*s - 2100*D1*Dd*f**2*fd + 528*D1*Dd*f**2*g2*r*s - 132*D1*Dd*f**2*g2*r + 528*D1*Dd*f**2*g2*s**2 - 528*D1*Dd*f**2*g2*s + 132*D1*Dd*f**2*g2 - 5280*D1*Dd*f**2*gd2*r*s + 660*D1*Dd*f**2*gd2*r - 5280*D1*Dd*f**2*gd2*s**2 + 5280*D1*Dd*f**2*gd2*s - 660*D1*Dd*f**2*gd2 - 10560*D1*Dd*f*fd*g2*r*s + 3960*D1*Dd*f*fd*g2*r - 10560*D1*Dd*f*fd*g2*s**2 + 10560*D1*Dd*f*fd*g2*s - 2640*D1*Dd*f*fd*g2 - 1680*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 1680*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 - 2640*D1*Ddd*f**2*g2*r*s + 660*D1*Ddd*f**2*g2*r - 2640*D1*Ddd*f**2*g2*s**2 + 2640*D1*Ddd*f**2*g2*s - 660*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-5*f**3*(112*s - 237)*(r + s - 1) - 2*f**2*(594*C*(s - 1)*(r + s - 1) - 140*fd*(r*(6*s - 7) + 6*s**2 - 12*s + 4) + (s*(K - 17) + 18)*(33*r + 33*s - 33)) + 33*f*(5*fd*(6*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 28*r*s + 13*r - 28*s**2 + 34*s - 7) + (44*g2*(s - 1) + 36*gd2*(1 - 2*s))*(r + s - 1)) - 1188*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(280*f**2*(r*(8*s - 13) + 8*s**2 - 20*s + 10) + 165*f*(6*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 56*r*s + 31*r - 56*s**2 + 80*s - 25) - 1188*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 5040*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 5040*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 840*Dd**2*f**3 - 7920*Dd**2*f**2*g2*r*s + 1980*Dd**2*f**2*g2*r - 7920*Dd**2*f**2*g2*s**2 + 7920*Dd**2*f**2*g2*s - 1320*Dd**2*f**2*g2 - 66*b1**2*(K - 1)*(D1**2*s*(11*fd - 9*fdd)*(r + s) + D1*Dd*(11*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(-8*r*s + r + s*(4 - 8*s))) - 9*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-2376*C*D1**2*f*fd*r*s - 2376*C*D1**2*f*fd*s**2 + 1188*C*D1**2*f*fd*s + 1980*C*D1**2*f*fdd*r*s + 1980*C*D1**2*f*fdd*s**2 - 990*C*D1**2*f*fdd*s + 1980*C*D1**2*fd**2*r*s + 1980*C*D1**2*fd**2*s**2 - 990*C*D1**2*fd**2*s - 4752*C*D1*Dd*f**2*r*s + 1188*C*D1*Dd*f**2*r - 4752*C*D1*Dd*f**2*s**2 + 4752*C*D1*Dd*f**2*s - 1188*C*D1*Dd*f**2 + 15840*C*D1*Dd*f*fd*r*s - 1980*C*D1*Dd*f*fd*r + 15840*C*D1*Dd*f*fd*s**2 - 11880*C*D1*Dd*f*fd*s + 990*C*D1*Dd*f*fd + 3960*C*D1*Ddd*f**2*r*s - 990*C*D1*Ddd*f**2*r + 3960*C*D1*Ddd*f**2*s**2 - 3960*C*D1*Ddd*f**2*s + 990*C*D1*Ddd*f**2 + 11880*C*Dd**2*f**2*r*s - 2970*C*Dd**2*f**2*r + 11880*C*Dd**2*f**2*s**2 - 11880*C*Dd**2*f**2*s + 1980*C*Dd**2*f**2 - 132*D1**2*K*f*fd*r*s + 66*D1**2*K*f*fd*r - 132*D1**2*K*f*fd*s**2 + 132*D1**2*K*f*fd*s - 66*D1**2*K*f*fd + 660*D1**2*K*f*fdd*r*s - 330*D1**2*K*f*fdd*r + 660*D1**2*K*f*fdd*s**2 - 660*D1**2*K*f*fdd*s + 330*D1**2*K*f*fdd + 660*D1**2*K*fd**2*r*s - 330*D1**2*K*fd**2*r + 660*D1**2*K*fd**2*s**2 - 660*D1**2*K*fd**2*s + 594*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 1680*D1**2*f**2*fd*r*s - 625*D1**2*f**2*fd*r - 1680*D1**2*f**2*fd*s**2 + 495*D1**2*f**2*fd*s + 625*D1**2*f**2*fd + 840*D1**2*f**2*fdd*r*s + 560*D1**2*f**2*fdd*r + 840*D1**2*f**2*fdd*s**2 - 560*D1**2*f**2*fdd + 1680*D1**2*f*fd**2*r*s + 1120*D1**2*f*fd**2*r + 1680*D1**2*f*fd**2*s**2 - 560*D1**2*f*fd**2 + 2244*D1**2*f*fd*r*s + 66*D1**2*f*fd*r + 2244*D1**2*f*fd*s**2 - 1056*D1**2*f*fd*s - 66*D1**2*f*fd - 2310*D1**2*f*fdd*r*s + 165*D1**2*f*fdd*r - 2310*D1**2*f*fdd*s**2 + 1320*D1**2*f*fdd*s - 165*D1**2*f*fdd + 1452*D1**2*f*gd2*r*s + 1452*D1**2*f*gd2*s**2 - 1452*D1**2*f*gd2*s - 1188*D1**2*f*gdd2*r*s - 1188*D1**2*f*gdd2*s**2 + 1188*D1**2*f*gdd2*s - 2310*D1**2*fd**2*r*s + 165*D1**2*fd**2*r - 2310*D1**2*fd**2*s**2 + 1320*D1**2*fd**2*s + 1452*D1**2*fd*g2*r*s + 1452*D1**2*fd*g2*s**2 - 2376*D1**2*fd*gd2*r*s - 2376*D1**2*fd*gd2*s**2 + 1188*D1**2*fd*gd2*s - 1188*D1**2*fdd*g2*r*s - 1188*D1**2*fdd*g2*s**2 - 264*D1*Dd*K*f**2*r*s + 66*D1*Dd*K*f**2*r - 264*D1*Dd*K*f**2*s**2 + 264*D1*Dd*K*f**2*s - 66*D1*Dd*K*f**2 + 5280*D1*Dd*K*f*fd*r*s - 1980*D1*Dd*K*f*fd*r + 5280*D1*Dd*K*f*fd*s**2 - 5280*D1*Dd*K*f*fd*s + 1320*D1*Dd*K*f*fd - 2240*D1*Dd*f**3*r*s + 560*D1*Dd*f**3*r - 2240*D1*Dd*f**3*s**2 + 2240*D1*Dd*f**3*s - 560*D1*Dd*f**3 + 6720*D1*Dd*f**2*fd*r*s + 1400*D1*Dd*f**2*fd*r + 6720*D1*Dd*f**2*fd*s**2 - 3360*D1*Dd*f**2*fd*s - 1120*D1*Dd*f**2*fd + 4488*D1*Dd*f**2*r*s - 1122*D1*Dd*f**2*r + 4488*D1*Dd*f**2*s**2 - 4488*D1*Dd*f**2*s + 1122*D1*Dd*f**2 - 18480*D1*Dd*f*fd*r*s + 2970*D1*Dd*f*fd*r - 18480*D1*Dd*f*fd*s**2 + 14520*D1*Dd*f*fd*s - 1650*D1*Dd*f*fd + 5808*D1*Dd*f*g2*r*s - 1452*D1*Dd*f*g2*r + 5808*D1*Dd*f*g2*s**2 - 5808*D1*Dd*f*g2*s + 1452*D1*Dd*f*g2 - 9504*D1*Dd*f*gd2*r*s + 1188*D1*Dd*f*gd2*r - 9504*D1*Dd*f*gd2*s**2 + 9504*D1*Dd*f*gd2*s - 1188*D1*Dd*f*gd2 - 9504*D1*Dd*fd*g2*r*s + 1188*D1*Dd*fd*g2*r - 9504*D1*Dd*fd*g2*s**2 + 4752*D1*Dd*fd*g2*s + 1320*D1*Ddd*K*f**2*r*s - 330*D1*Ddd*K*f**2*r + 1320*D1*Ddd*K*f**2*s**2 - 1320*D1*Ddd*K*f**2*s + 330*D1*Ddd*K*f**2 + 1120*D1*Ddd*f**3*r*s - 280*D1*Ddd*f**3*r + 1120*D1*Ddd*f**3*s**2 - 1120*D1*Ddd*f**3*s + 280*D1*Ddd*f**3 - 4620*D1*Ddd*f**2*r*s + 1155*D1*Ddd*f**2*r - 4620*D1*Ddd*f**2*s**2 + 4620*D1*Ddd*f**2*s - 1155*D1*Ddd*f**2 - 4752*D1*Ddd*f*g2*r*s + 1188*D1*Ddd*f*g2*r - 4752*D1*Ddd*f*g2*s**2 + 4752*D1*Ddd*f*g2*s - 1188*D1*Ddd*f*g2 - 66*D1*bd1*(K - 1)*(D1*(11*f*(2*s - 1)*(r + s - 1) + 9*fd*(-4*r*s + r + s*(3 - 4*s))) - 9*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 3960*Dd**2*K*f**2*r*s - 990*Dd**2*K*f**2*r + 3960*Dd**2*K*f**2*s**2 - 3960*Dd**2*K*f**2*s + 660*Dd**2*K*f**2 + 3360*Dd**2*f**3*r*s - 840*Dd**2*f**3*r + 3360*Dd**2*f**3*s**2 - 3360*Dd**2*f**3*s + 560*Dd**2*f**3 - 13860*Dd**2*f**2*r*s + 3465*Dd**2*f**2*r - 13860*Dd**2*f**2*s**2 + 13860*Dd**2*f**2*s - 2310*Dd**2*f**2 - 14256*Dd**2*f*g2*r*s + 3564*Dd**2*f*g2*r - 14256*Dd**2*f*g2*s**2 + 14256*Dd**2*f*g2*s - 2376*Dd**2*f*g2))/(693*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**4*k1**4*(D1**2*b1*(5*f**2*(23*fd - 28*fdd)*(r*(6*s - 2) + 6*s**2 - 7*s + 2) + f*(-140*fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3) + 132*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 165*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) - 165*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*b1*f*(2*Dd*(115*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-70*fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 165*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 5*Ddd*f*(56*f + 33)*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*bd1*f*(D1*(f*s*(115*f*(2*r + 2*s - 1) + 132*r + 132*s - 132) - 5*fd*(28*f*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2)) - 5*Dd*f*(28*f*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 264*r*s - 33*r + 264*s**2 - 264*s + 33)) - 5*Dd**2*b1*f**2*(56*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - 5*f*(D1**2*(28*bdd1*f**2*s*(2*r + 2*s - 1) + f*(33*bdd1*s*(r + s - 1) - 23*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 28*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 28*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(-23*f*(r*(4*s - 1) + (1 - 2*s)**2) + 28*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 28*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 28*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k2*k3**3) - D1**2*Pkd2*Pkd3*ct**4*k1**2*k2**3*st**2*(-132*C*D1**2*bdd1*f**2*r*s + 132*C*D1**2*bdd1*f**2*r - 132*C*D1**2*bdd1*f**2*s**2 + 264*C*D1**2*bdd1*f**2*s - 132*C*D1**2*bdd1*f**2 + 4812*C*D1**2*f**2*fd*r*s - 1604*C*D1**2*f**2*fd*r + 4812*C*D1**2*f**2*fd*s**2 - 4812*C*D1**2*f**2*fd*s + 1604*C*D1**2*f**2*fd - 3000*C*D1**2*f**2*fdd*r*s + 1000*C*D1**2*f**2*fdd*r - 3000*C*D1**2*f**2*fdd*s**2 + 3000*C*D1**2*f**2*fdd*s - 1000*C*D1**2*f**2*fdd - 6000*C*D1**2*f*fd**2*r*s + 2000*C*D1**2*f*fd**2*r - 6000*C*D1**2*f*fd**2*s**2 + 6000*C*D1**2*f*fd**2*s - 1000*C*D1**2*f*fd**2 + 6416*C*D1*Dd*f**3*r*s - 1604*C*D1*Dd*f**3*r + 6416*C*D1*Dd*f**3*s**2 - 6416*C*D1*Dd*f**3*s + 1604*C*D1*Dd*f**3 - 24000*C*D1*Dd*f**2*fd*r*s + 7000*C*D1*Dd*f**2*fd*r - 24000*C*D1*Dd*f**2*fd*s**2 + 24000*C*D1*Dd*f**2*fd*s - 5000*C*D1*Dd*f**2*fd - 4000*C*D1*Ddd*f**3*r*s + 1000*C*D1*Ddd*f**3*r - 4000*C*D1*Ddd*f**3*s**2 + 4000*C*D1*Ddd*f**3*s - 1000*C*D1*Ddd*f**3 - 12000*C*Dd**2*f**3*r*s + 3000*C*Dd**2*f**3*r - 12000*C*Dd**2*f**3*s**2 + 12000*C*Dd**2*f**3*s - 2000*C*Dd**2*f**3 - 660*D1**2*K*bdd1*f**2*r*s - 660*D1**2*K*bdd1*f**2*s**2 + 660*D1**2*K*bdd1*f**2*s - 66*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 375*D1**2*bdd1*f**3*r*s + 125*D1**2*bdd1*f**3*r + 375*D1**2*bdd1*f**3*s**2 - 250*D1**2*bdd1*f**3*s - 125*D1**2*bdd1*f**3 + 462*D1**2*bdd1*f**2*r*s - 132*D1**2*bdd1*f**2*r + 462*D1**2*bdd1*f**2*s**2 - 594*D1**2*bdd1*f**2*s + 132*D1**2*bdd1*f**2 + 132*D1**2*bdd1*f*g2*r*s - 132*D1**2*bdd1*f*g2*r + 132*D1**2*bdd1*f*g2*s**2 - 264*D1**2*bdd1*f*g2*s + 132*D1**2*bdd1*f*g2 - 500*D1**2*f**3*fd*r*s + 125*D1**2*f**3*fd*r - 500*D1**2*f**3*fd*s**2 + 500*D1**2*f**3*fd*s - 125*D1**2*f**3*fd - 3510*D1**2*f**2*fd*r*s + 1170*D1**2*f**2*fd*r - 3510*D1**2*f**2*fd*s**2 + 3510*D1**2*f**2*fd*s - 1170*D1**2*f**2*fd + 2250*D1**2*f**2*fdd*r*s - 750*D1**2*f**2*fdd*r + 2250*D1**2*f**2*fdd*s**2 - 2250*D1**2*f**2*fdd*s + 750*D1**2*f**2*fdd - 2244*D1**2*f**2*gd2*r*s - 2244*D1**2*f**2*gd2*s**2 + 2244*D1**2*f**2*gd2*s + 1320*D1**2*f**2*gdd2*r*s + 1320*D1**2*f**2*gdd2*s**2 - 1320*D1**2*f**2*gdd2*s + 4500*D1**2*f*fd**2*r*s - 1500*D1**2*f*fd**2*r + 4500*D1**2*f*fd**2*s**2 - 4500*D1**2*f*fd**2*s + 750*D1**2*f*fd**2 - 4488*D1**2*f*fd*g2*r*s + 2244*D1**2*f*fd*g2*r - 4488*D1**2*f*fd*g2*s**2 + 4488*D1**2*f*fd*g2*s - 2244*D1**2*f*fd*g2 + 5280*D1**2*f*fd*gd2*r*s - 1320*D1**2*f*fd*gd2*r + 5280*D1**2*f*fd*gd2*s**2 - 5280*D1**2*f*fd*gd2*s + 1320*D1**2*f*fd*gd2 + 2640*D1**2*f*fdd*g2*r*s - 1320*D1**2*f*fdd*g2*r + 2640*D1**2*f*fdd*g2*s**2 - 2640*D1**2*f*fdd*g2*s + 1320*D1**2*f*fdd*g2 + 2640*D1**2*fd**2*g2*r*s - 1320*D1**2*fd**2*g2*r + 2640*D1**2*fd**2*g2*s**2 - 2640*D1**2*fd**2*g2*s - 500*D1*Dd*f**4*r*s + 125*D1*Dd*f**4*r - 500*D1*Dd*f**4*s**2 + 500*D1*Dd*f**4*s - 125*D1*Dd*f**4 - 4680*D1*Dd*f**3*r*s + 1170*D1*Dd*f**3*r - 4680*D1*Dd*f**3*s**2 + 4680*D1*Dd*f**3*s - 1170*D1*Dd*f**3 + 18000*D1*Dd*f**2*fd*r*s - 5250*D1*Dd*f**2*fd*r + 18000*D1*Dd*f**2*fd*s**2 - 18000*D1*Dd*f**2*fd*s + 3750*D1*Dd*f**2*fd - 8976*D1*Dd*f**2*g2*r*s + 2244*D1*Dd*f**2*g2*r - 8976*D1*Dd*f**2*g2*s**2 + 8976*D1*Dd*f**2*g2*s - 2244*D1*Dd*f**2*g2 + 10560*D1*Dd*f**2*gd2*r*s - 1320*D1*Dd*f**2*gd2*r + 10560*D1*Dd*f**2*gd2*s**2 - 10560*D1*Dd*f**2*gd2*s + 1320*D1*Dd*f**2*gd2 + 21120*D1*Dd*f*fd*g2*r*s - 7920*D1*Dd*f*fd*g2*r + 21120*D1*Dd*f*fd*g2*s**2 - 21120*D1*Dd*f*fd*g2*s + 5280*D1*Dd*f*fd*g2 + 3000*D1*Ddd*f**3*r*s - 750*D1*Ddd*f**3*r + 3000*D1*Ddd*f**3*s**2 - 3000*D1*Ddd*f**3*s + 750*D1*Ddd*f**3 + 5280*D1*Ddd*f**2*g2*r*s - 1320*D1*Ddd*f**2*g2*r + 5280*D1*Ddd*f**2*g2*s**2 - 5280*D1*Ddd*f**2*g2*s + 1320*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-10*f**3*(64*s + 25)*(r + s - 1) + f**2*(264*C*(s - 1)*(r + s - 1) + 125*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + (s*(17*K - 12) + 4)*(66*r + 66*s - 66)) - 66*f*(fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 10*K*(r*(4*s - 1) + (1 - 2*s)**2) - 28*r*s + 9*r - 28*s**2 + 30*s - 7) + (2*r + 2*s - 2)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 132*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(125*f**2*(24*r*s + r + 4*s*(6*s - 5)) - 66*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 56*r*s + 15*r - 56*s**2 + 64*s - 13) + 132*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 9000*Dd**2*f**3*r*s - 2250*Dd**2*f**3*r + 9000*Dd**2*f**3*s**2 - 9000*Dd**2*f**3*s + 1500*Dd**2*f**3 + 15840*Dd**2*f**2*g2*r*s - 3960*Dd**2*f**2*g2*r + 15840*Dd**2*f**2*g2*s**2 - 15840*Dd**2*f**2*g2*s + 2640*Dd**2*f**2*g2 + 66*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(528*C*D1**2*f*fd*r*s + 528*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s - 264*C*D1**2*f*fdd*r*s - 264*C*D1**2*f*fdd*s**2 + 132*C*D1**2*f*fdd*s - 264*C*D1**2*fd**2*r*s - 264*C*D1**2*fd**2*s**2 + 132*C*D1**2*fd**2*s + 1056*C*D1*Dd*f**2*r*s - 264*C*D1*Dd*f**2*r + 1056*C*D1*Dd*f**2*s**2 - 1056*C*D1*Dd*f**2*s + 264*C*D1*Dd*f**2 - 2112*C*D1*Dd*f*fd*r*s + 264*C*D1*Dd*f*fd*r - 2112*C*D1*Dd*f*fd*s**2 + 1584*C*D1*Dd*f*fd*s - 132*C*D1*Dd*f*fd - 528*C*D1*Ddd*f**2*r*s + 132*C*D1*Ddd*f**2*r - 528*C*D1*Ddd*f**2*s**2 + 528*C*D1*Ddd*f**2*s - 132*C*D1*Ddd*f**2 - 1584*C*Dd**2*f**2*r*s + 396*C*Dd**2*f**2*r - 1584*C*Dd**2*f**2*s**2 + 1584*C*Dd**2*f**2*s - 264*C*Dd**2*f**2 + 2244*D1**2*K*f*fd*r*s - 1122*D1**2*K*f*fd*r + 2244*D1**2*K*f*fd*s**2 - 2244*D1**2*K*f*fd*s + 1122*D1**2*K*f*fd - 1320*D1**2*K*f*fdd*r*s + 660*D1**2*K*f*fdd*r - 1320*D1**2*K*f*fdd*s**2 + 1320*D1**2*K*f*fdd*s - 660*D1**2*K*f*fdd - 1320*D1**2*K*fd**2*r*s + 660*D1**2*K*fd**2*r - 1320*D1**2*K*fd**2*s**2 + 1320*D1**2*K*fd**2*s - 66*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 1920*D1**2*f**2*fd*r*s + 890*D1**2*f**2*fd*r - 1920*D1**2*f**2*fd*s**2 + 2170*D1**2*f**2*fd*s - 890*D1**2*f**2*fd + 1125*D1**2*f**2*fdd*r*s - 500*D1**2*f**2*fdd*r + 1125*D1**2*f**2*fdd*s**2 - 1250*D1**2*f**2*fdd*s + 500*D1**2*f**2*fdd + 2250*D1**2*f*fd**2*r*s - 1000*D1**2*f*fd**2*r + 2250*D1**2*f*fd**2*s**2 - 2500*D1**2*f*fd**2*s + 500*D1**2*f*fd**2 - 1584*D1**2*f*fd*r*s + 528*D1**2*f*fd*r - 1584*D1**2*f*fd*s**2 + 1320*D1**2*f*fd*s - 528*D1**2*f*fd + 924*D1**2*f*fdd*r*s - 330*D1**2*f*fdd*r + 924*D1**2*f*fdd*s**2 - 792*D1**2*f*fdd*s + 330*D1**2*f*fdd - 264*D1**2*f*gd2*r*s - 264*D1**2*f*gd2*s**2 + 264*D1**2*f*gd2*s + 132*D1**2*f*gdd2*r*s + 132*D1**2*f*gdd2*s**2 - 132*D1**2*f*gdd2*s + 924*D1**2*fd**2*r*s - 330*D1**2*fd**2*r + 924*D1**2*fd**2*s**2 - 792*D1**2*fd**2*s - 264*D1**2*fd*g2*r*s - 264*D1**2*fd*g2*s**2 + 264*D1**2*fd*gd2*r*s + 264*D1**2*fd*gd2*s**2 - 132*D1**2*fd*gd2*s + 132*D1**2*fdd*g2*r*s + 132*D1**2*fdd*g2*s**2 + 4488*D1*Dd*K*f**2*r*s - 1122*D1*Dd*K*f**2*r + 4488*D1*Dd*K*f**2*s**2 - 4488*D1*Dd*K*f**2*s + 1122*D1*Dd*K*f**2 - 10560*D1*Dd*K*f*fd*r*s + 3960*D1*Dd*K*f*fd*r - 10560*D1*Dd*K*f*fd*s**2 + 10560*D1*Dd*K*f*fd*s - 2640*D1*Dd*K*f*fd - 2560*D1*Dd*f**3*r*s + 640*D1*Dd*f**3*r - 2560*D1*Dd*f**3*s**2 + 2560*D1*Dd*f**3*s - 640*D1*Dd*f**3 + 9000*D1*Dd*f**2*fd*r*s - 3125*D1*Dd*f**2*fd*r + 9000*D1*Dd*f**2*fd*s**2 - 9500*D1*Dd*f**2*fd*s + 2250*D1*Dd*f**2*fd - 3168*D1*Dd*f**2*r*s + 792*D1*Dd*f**2*r - 3168*D1*Dd*f**2*s**2 + 3168*D1*Dd*f**2*s - 792*D1*Dd*f**2 + 7392*D1*Dd*f*fd*r*s - 2244*D1*Dd*f*fd*r + 7392*D1*Dd*f*fd*s**2 - 6864*D1*Dd*f*fd*s + 1452*D1*Dd*f*fd - 1056*D1*Dd*f*g2*r*s + 264*D1*Dd*f*g2*r - 1056*D1*Dd*f*g2*s**2 + 1056*D1*Dd*f*g2*s - 264*D1*Dd*f*g2 + 1056*D1*Dd*f*gd2*r*s - 132*D1*Dd*f*gd2*r + 1056*D1*Dd*f*gd2*s**2 - 1056*D1*Dd*f*gd2*s + 132*D1*Dd*f*gd2 + 1056*D1*Dd*fd*g2*r*s - 132*D1*Dd*fd*g2*r + 1056*D1*Dd*fd*g2*s**2 - 528*D1*Dd*fd*g2*s - 2640*D1*Ddd*K*f**2*r*s + 660*D1*Ddd*K*f**2*r - 2640*D1*Ddd*K*f**2*s**2 + 2640*D1*Ddd*K*f**2*s - 660*D1*Ddd*K*f**2 + 1500*D1*Ddd*f**3*r*s - 375*D1*Ddd*f**3*r + 1500*D1*Ddd*f**3*s**2 - 1500*D1*Ddd*f**3*s + 375*D1*Ddd*f**3 + 1848*D1*Ddd*f**2*r*s - 462*D1*Ddd*f**2*r + 1848*D1*Ddd*f**2*s**2 - 1848*D1*Ddd*f**2*s + 462*D1*Ddd*f**2 + 528*D1*Ddd*f*g2*r*s - 132*D1*Ddd*f*g2*r + 528*D1*Ddd*f*g2*s**2 - 528*D1*Ddd*f*g2*s + 132*D1*Ddd*f*g2 + 66*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 7920*Dd**2*K*f**2*r*s + 1980*Dd**2*K*f**2*r - 7920*Dd**2*K*f**2*s**2 + 7920*Dd**2*K*f**2*s - 1320*Dd**2*K*f**2 + 4500*Dd**2*f**3*r*s - 1125*Dd**2*f**3*r + 4500*Dd**2*f**3*s**2 - 4500*Dd**2*f**3*s + 750*Dd**2*f**3 + 5544*Dd**2*f**2*r*s - 1386*Dd**2*f**2*r + 5544*Dd**2*f**2*s**2 - 5544*Dd**2*f**2*s + 924*Dd**2*f**2 + 1584*Dd**2*f*g2*r*s - 396*Dd**2*f*g2*r + 1584*Dd**2*f*g2*s**2 - 1584*Dd**2*f*g2*s + 264*Dd**2*f*g2))/(231*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct**4*k1**2*k2**3*(660*C*D1**2*bdd1*f**2*r*s - 660*C*D1**2*bdd1*f**2*r + 660*C*D1**2*bdd1*f**2*s**2 - 1320*C*D1**2*bdd1*f**2*s + 660*C*D1**2*bdd1*f**2 + 300*C*D1**2*f**2*fd*r*s - 100*C*D1**2*f**2*fd*r + 300*C*D1**2*f**2*fd*s**2 - 300*C*D1**2*f**2*fd*s + 100*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 + 400*C*D1*Dd*f**3*r*s - 100*C*D1*Dd*f**3*r + 400*C*D1*Dd*f**3*s**2 - 400*C*D1*Dd*f**3*s + 100*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 22*D1**2*bd1**2*f*(2*s - 1)*(-18*K + 10*f + 9)*(r + s - 1) - 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*r - 495*D1**2*bdd1*f**2*s**2 + 990*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 - 792*D1**2*bdd1*f*g2*r*s + 792*D1**2*bdd1*f*g2*r - 792*D1**2*bdd1*f*g2*s**2 + 1584*D1**2*bdd1*f*g2*s - 792*D1**2*bdd1*f*g2 - 480*D1**2*f**2*fd*r*s + 160*D1**2*f**2*fd*r - 480*D1**2*f**2*fd*s**2 + 480*D1**2*f**2*fd*s - 160*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 840*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s - 640*D1*Dd*f**3*r*s + 160*D1*Dd*f**3*r - 640*D1*Dd*f**3*s**2 + 640*D1*Dd*f**3*s - 160*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3360*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r*s + 132*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*(2*s + 1)*(r + s - 1) + 6*f**2*(r + s - 1)*(14*C*(s - 1) - s*(K + 8) + 10) - 3*f*(5*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + (34*g2*(s - 1) + 24*gd2*(1 - 2*s))*(r + s - 1)) + 72*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(5*f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 24*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 1680*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 11*b1**2*(D1**2*s*(2*f*(17*fd - 10*fdd)*(2*r + 2*s - 1) - 20*fd**2*(2*r + 2*s - 1) - fd*(51*K - 22)*(r + s) + 18*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(34*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-20*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - (51*K - 22)*(r*(4*s - 1) + (1 - 2*s)**2)) + 18*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-18*K + 10*f + 9)) - 2*Dd**2*f*(-18*K + 10*f + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(-168*C*D1**2*f*fd*r*s - 168*C*D1**2*f*fd*s**2 + 84*C*D1**2*f*fd*s + 120*C*D1**2*f*fdd*r*s + 120*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 120*C*D1**2*fd**2*r*s + 120*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s - 336*C*D1*Dd*f**2*r*s + 84*C*D1*Dd*f**2*r - 336*C*D1*Dd*f**2*s**2 + 336*C*D1*Dd*f**2*s - 84*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r*s - 120*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 240*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 720*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 + 12*D1**2*K*f*fd*r*s - 6*D1**2*K*f*fd*r + 12*D1**2*K*f*fd*s**2 - 12*D1**2*K*f*fd*s + 6*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - 2*D1**2*bdd1*f*(2*s - 1)*(-18*K + 10*f + 9)*(r + s - 1) - 30*D1**2*f**2*fd*r*s + 15*D1**2*f**2*fd*r - 30*D1**2*f**2*fd*s**2 + 35*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 96*D1**2*f*fd*r*s + 12*D1**2*f*fd*r + 96*D1**2*f*fd*s**2 - 36*D1**2*f*fd*s - 12*D1**2*f*fd - 90*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*s**2 + 45*D1**2*f*fdd*s + 102*D1**2*f*gd2*r*s + 102*D1**2*f*gd2*s**2 - 102*D1**2*f*gd2*s - 72*D1**2*f*gdd2*r*s - 72*D1**2*f*gdd2*s**2 + 72*D1**2*f*gdd2*s - 90*D1**2*fd**2*r*s - 90*D1**2*fd**2*s**2 + 45*D1**2*fd**2*s + 102*D1**2*fd*g2*r*s + 102*D1**2*fd*g2*s**2 - 144*D1**2*fd*gd2*r*s - 144*D1**2*fd*gd2*s**2 + 72*D1**2*fd*gd2*s - 72*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*s**2 + 24*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s**2 - 24*D1*Dd*K*f**2*s + 6*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 40*D1*Dd*f**3*r*s + 10*D1*Dd*f**3*r - 40*D1*Dd*f**3*s**2 + 40*D1*Dd*f**3*s - 10*D1*Dd*f**3 + 192*D1*Dd*f**2*r*s - 48*D1*Dd*f**2*r + 192*D1*Dd*f**2*s**2 - 192*D1*Dd*f**2*s + 48*D1*Dd*f**2 - 720*D1*Dd*f*fd*r*s + 90*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 540*D1*Dd*f*fd*s - 45*D1*Dd*f*fd + 408*D1*Dd*f*g2*r*s - 102*D1*Dd*f*g2*r + 408*D1*Dd*f*g2*s**2 - 408*D1*Dd*f*g2*s + 102*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r*s + 72*D1*Dd*f*gd2*r - 576*D1*Dd*f*gd2*s**2 + 576*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 576*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 180*D1*Ddd*f**2*r*s + 45*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 288*D1*Ddd*f*g2*s**2 + 288*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + D1*bd1*(D1*(34*f**2*(2*s - 1)*(r + s - 1) + f*(-20*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) - (51*K - 22)*(2*s - 1)*(r + s - 1)) + 18*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 2*Dd*f*(-18*K + 10*f + 9)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 540*Dd**2*f**2*r*s + 135*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 90*Dd**2*f**2 - 864*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 864*Dd**2*f*g2*s**2 + 864*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(231*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**4*k1**2*k2*st**2*(66*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) + D1*bd1*(D1*(-10*f**3*s*(89*r + 89*s - 64) + f**2*(125*fd*(6*s - 1)*(4*r + 4*s - 3) - 66*s*(4*C*s + r*(4*C + 5) + 5*s - 9)) + 66*f*(fd*(r*(2*C + 3)*(4*s - 1) + s**2*(8*C + 12) - s*(6*C + 14) + 5) + 2*s*(2*g2*(r + s) + gd2*(-2*r - 2*s + 1))) - 132*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(125*f**2*(8*s - 1)*(4*r + 4*s - 3) + 66*f*(r*(2*C + 3)*(8*s - 1) + s**2*(16*C + 24) - s*(8*C + 32) + 5) - 132*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 66*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(-5*f**2*(2*fd*(89*r*(3*s - 1) + 267*s**2 - 292*s + 89) - 25*fdd*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4)) + f*(125*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) - 66*fd*(4*C*(2*s - 1)*(r + s - 1) + 5*r*(2*s - 1) + 10*s**2 - 6*s + 5) + 66*fdd*(2*C*(2*s - 1)*(r + s - 1) + 6*r*s - 3*r + 6*s**2 - 4*s + 3) + 66*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) + 66*fd**2*(2*C*(2*s - 1)*(r + s - 1) + r*(6*s - 3) + 6*s**2 - 4*s - 2) + 132*fd*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) - 132*fdd*g2*(s - 1)*(r + s - 1)) + 66*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(-890*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(-264*C*(r*(4*s - 1) + (1 - 2*s)**2) + 125*fd*(24*s - 7)*(4*r + 4*s - 3) - 330*r*(4*s - 1) - 330*(1 - 2*s)**2) + 132*f*(fd*(C*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + 24*r*s - 9*r + 24*s**2 - 20*s + 5) + g2*(8*r*s - 2*r + 8*s**2 - 8*s + 2) + gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) - 132*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(250*f**2 + f*(66*C + 99) - 66*g2)) + 2*Dd**2*f*(250*f**2 + f*(66*C + 99) - 66*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(125*bdd1*f**2*s*(4*r + 4*s - 3) + 66*bdd1*f*s*(r*(2*C + 3) + s*(2*C + 3) - 5) - 132*bdd1*g2*s*(r + s) - 434*f*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 250*f*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 250*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 2*D1*f*(Dd*(217*f*(r*(4*s - 1) + (1 - 2*s)**2) - 125*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 125*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 250*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**4*k1**2*k2*(-220*C*D1**2*bdd1*f**2*r*s - 220*C*D1**2*bdd1*f**2*s**2 - 1020*C*D1**2*f**2*fd*r*s + 340*C*D1**2*f**2*fd*r - 1020*C*D1**2*f**2*fd*s**2 + 1020*C*D1**2*f**2*fd*s - 340*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 1360*C*D1*Dd*f**3*r*s + 340*C*D1*Dd*f**3*r - 1360*C*D1*Dd*f**3*s**2 + 1360*C*D1*Dd*f**3*s - 340*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 396*D1**2*b2*f*fd*r*s + 198*D1**2*b2*f*fd*r - 396*D1**2*b2*f*fd*s**2 + 396*D1**2*b2*f*fd*s - 198*D1**2*b2*f*fd + 330*D1**2*b2*f*fdd*r*s - 165*D1**2*b2*f*fdd*r + 330*D1**2*b2*f*fdd*s**2 - 330*D1**2*b2*f*fdd*s + 165*D1**2*b2*f*fdd + 330*D1**2*b2*fd**2*r*s - 165*D1**2*b2*fd**2*r + 330*D1**2*b2*fd**2*s**2 - 330*D1**2*b2*fd**2*s - 11*D1**2*bd1**2*(5*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 3) + 6*f*(r*(C*(4*s - 2) + 4*K*s - 1) + s**2*(4*C + 4*K) - s*(4*C + 2*K + 4) + 3) + 14*g2*(-2*r*s + r - s*(2*s - 2))) - 198*D1**2*bd2*f**2*r*s - 198*D1**2*bd2*f**2*s**2 + 198*D1**2*bd2*f**2*s + 660*D1**2*bd2*f*fd*r*s - 165*D1**2*bd2*f*fd*r + 660*D1**2*bd2*f*fd*s**2 - 660*D1**2*bd2*f*fd*s + 165*D1**2*bd2*f*fd + 165*D1**2*bdd1*f**2*r + 330*D1**2*bdd1*f**2*s - 165*D1**2*bdd1*f**2 + 264*D1**2*bdd1*f*g2*r*s + 264*D1**2*bdd1*f*g2*s**2 + 165*D1**2*bdd2*f**2*r*s + 165*D1**2*bdd2*f**2*s**2 - 165*D1**2*bdd2*f**2*s + 180*D1**2*f**2*fd*r*s - 60*D1**2*f**2*fd*r + 180*D1**2*f**2*fd*s**2 - 180*D1**2*f**2*fd*s + 60*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd + 396*D1**2*f**2*gd2*r*s + 396*D1**2*f**2*gd2*s**2 - 396*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 840*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 792*D1**2*f*fd*g2*r*s - 396*D1**2*f*fd*g2*r + 792*D1**2*f*fd*g2*s**2 - 792*D1**2*f*fd*g2*s + 396*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s - 792*D1*Dd*b2*f**2*r*s + 198*D1*Dd*b2*f**2*r - 792*D1*Dd*b2*f**2*s**2 + 792*D1*Dd*b2*f**2*s - 198*D1*Dd*b2*f**2 + 2640*D1*Dd*b2*f*fd*r*s - 990*D1*Dd*b2*f*fd*r + 2640*D1*Dd*b2*f*fd*s**2 - 2640*D1*Dd*b2*f*fd*s + 660*D1*Dd*b2*f*fd + 1320*D1*Dd*bd2*f**2*r*s - 165*D1*Dd*bd2*f**2*r + 1320*D1*Dd*bd2*f**2*s**2 - 1320*D1*Dd*bd2*f**2*s + 165*D1*Dd*bd2*f**2 + 240*D1*Dd*f**3*r*s - 60*D1*Dd*f**3*r + 240*D1*Dd*f**3*s**2 - 240*D1*Dd*f**3*s + 60*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3360*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd + 1584*D1*Dd*f**2*g2*r*s - 396*D1*Dd*f**2*g2*r + 1584*D1*Dd*f**2*g2*s**2 - 1584*D1*Dd*f**2*g2*s + 396*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 + 660*D1*Ddd*b2*f**2*r*s - 165*D1*Ddd*b2*f**2*r + 660*D1*Ddd*b2*f**2*s**2 - 660*D1*Ddd*b2*f**2*s + 165*D1*Ddd*b2*f**2 - 560*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*s*(3*r + 3*s - 2) + 2*f**2*(r*(s*(-2*C + 9*K - 6) + 12) + s**2*(-2*C + 9*K - 6) - s*(9*K - 18) - 12) + f*(-5*fd*(-16*C*s**2 + 12*C*s + 3*K*(r*(4*s - 1) + (1 - 2*s)**2) + r*(-16*C*s + 4*C + 3) + 6*s - 3) + 6*s*(g2*(r + s) + gd2*(-8*r - 8*s + 4))) + 24*fd*g2*(-2*r*s + r - s*(2*s - 2))) - Dd*f*(5*f*(3*K*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 4*r*(8*C*s - C - 3) - 4*(2*s - 1)*(4*C*s - 3)) + 24*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 1980*Dd**2*b2*f**2*r*s - 495*Dd**2*b2*f**2*r + 1980*Dd**2*b2*f**2*s**2 - 1980*Dd**2*b2*f**2*s + 330*Dd**2*b2*f**2 - 1680*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 77*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 11*b1**2*(24*C*D1**2*fd*r*s + 24*C*D1**2*fd*s**2 - 24*C*D1**2*fd*s - 12*C*D1**2*fdd*r*s - 12*C*D1**2*fdd*s**2 + 12*C*D1**2*fdd*s + 96*C*D1*Dd*f*r*s - 24*C*D1*Dd*f*r + 96*C*D1*Dd*f*s**2 - 96*C*D1*Dd*f*s + 24*C*D1*Dd*f - 96*C*D1*Dd*fd*r*s + 12*C*D1*Dd*fd*r - 96*C*D1*Dd*fd*s**2 + 96*C*D1*Dd*fd*s - 12*C*D1*Dd*fd - 48*C*D1*Ddd*f*r*s + 12*C*D1*Ddd*f*r - 48*C*D1*Ddd*f*s**2 + 48*C*D1*Ddd*f*s - 12*C*D1*Ddd*f - 144*C*Dd**2*f*r*s + 36*C*Dd**2*f*r - 144*C*Dd**2*f*s**2 + 144*C*Dd**2*f*s - 24*C*Dd**2*f + 3*D1**2*K*fd*r*s - 3*D1**2*K*fd*r + 3*D1**2*K*fd*s**2 - 6*D1**2*K*fd*s + 3*D1**2*K*fd - 12*D1**2*K*fdd*r*s + 12*D1**2*K*fdd*r - 12*D1**2*K*fdd*s**2 + 24*D1**2*K*fdd*s - 12*D1**2*K*fdd - 7*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 40*D1**2*f*fd*r*s + 14*D1**2*f*fd*r + 40*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s - 14*D1**2*f*fd - 20*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*r - 20*D1**2*f*fdd*s**2 - 5*D1**2*f*fdd*s + 10*D1**2*f*fdd - 20*D1**2*fd**2*r*s - 10*D1**2*fd**2*r - 20*D1**2*fd**2*s**2 - 5*D1**2*fd**2*s + 10*D1**2*fd**2 + 7*D1**2*fd*r*s - 2*D1**2*fd*r + 7*D1**2*fd*s**2 + 20*D1**2*fd*s + 2*D1**2*fd - 6*D1**2*fdd*r - 24*D1**2*fdd*s + 6*D1**2*fdd - 28*D1**2*gd2*r*s - 28*D1**2*gd2*s**2 + 28*D1**2*gd2*s + 14*D1**2*gdd2*r*s + 14*D1**2*gdd2*s**2 - 14*D1**2*gdd2*s + 12*D1*Dd*K*f*r*s - 3*D1*Dd*K*f*r + 12*D1*Dd*K*f*s**2 - 12*D1*Dd*K*f*s + 3*D1*Dd*K*f - 96*D1*Dd*K*fd*r*s + 60*D1*Dd*K*fd*r - 96*D1*Dd*K*fd*s**2 + 144*D1*Dd*K*fd*s - 48*D1*Dd*K*fd + 80*D1*Dd*f**2*r*s - 20*D1*Dd*f**2*r + 80*D1*Dd*f**2*s**2 - 80*D1*Dd*f**2*s + 20*D1*Dd*f**2 - 160*D1*Dd*f*fd*r*s - 20*D1*Dd*f*fd*r - 160*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s + 25*D1*Dd*f*fd + 28*D1*Dd*f*r*s - 7*D1*Dd*f*r + 28*D1*Dd*f*s**2 - 28*D1*Dd*f*s + 7*D1*Dd*f - 24*D1*Dd*fd*r - 96*D1*Dd*fd*s + 36*D1*Dd*fd - 112*D1*Dd*g2*r*s + 28*D1*Dd*g2*r - 112*D1*Dd*g2*s**2 + 112*D1*Dd*g2*s - 28*D1*Dd*g2 + 112*D1*Dd*gd2*r*s - 14*D1*Dd*gd2*r + 112*D1*Dd*gd2*s**2 - 112*D1*Dd*gd2*s + 14*D1*Dd*gd2 - 48*D1*Ddd*K*f*r*s + 12*D1*Ddd*K*f*r - 48*D1*Ddd*K*f*s**2 + 48*D1*Ddd*K*f*s - 12*D1*Ddd*K*f - 40*D1*Ddd*f**2*r*s + 10*D1*Ddd*f**2*r - 40*D1*Ddd*f**2*s**2 + 40*D1*Ddd*f**2*s - 10*D1*Ddd*f**2 + 56*D1*Ddd*g2*r*s - 14*D1*Ddd*g2*r + 56*D1*Ddd*g2*s**2 - 56*D1*Ddd*g2*s + 14*D1*Ddd*g2 + 7*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) - 144*Dd**2*K*f*r*s + 36*Dd**2*K*f*r - 144*Dd**2*K*f*s**2 + 144*Dd**2*K*f*s - 24*Dd**2*K*f - 120*Dd**2*f**2*r*s + 30*Dd**2*f**2*r - 120*Dd**2*f**2*s**2 + 120*Dd**2*f**2*s - 20*Dd**2*f**2 + 168*Dd**2*g2*r*s - 42*Dd**2*g2*r + 168*Dd**2*g2*s**2 - 168*Dd**2*g2*s + 28*Dd**2*g2) - 11*b1*(-8*C*D1**2*f*fd*r*s + 4*C*D1**2*f*fd*r - 8*C*D1**2*f*fd*s**2 + 12*C*D1**2*f*fd*s - 4*C*D1**2*f*fd + 40*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*r + 40*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 20*C*D1**2*f*fdd + 40*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*r + 40*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s + 20*C*D1**2*fd**2 - 16*C*D1*Dd*f**2*r*s + 4*C*D1*Dd*f**2*r - 16*C*D1*Dd*f**2*s**2 + 16*C*D1*Dd*f**2*s - 4*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 120*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 400*C*D1*Dd*f*fd*s + 100*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 + 36*D1**2*K*f*fd*r*s - 18*D1**2*K*f*fd*r + 36*D1**2*K*f*fd*s**2 - 36*D1**2*K*f*fd*s + 18*D1**2*K*f*fd - 30*D1**2*K*f*fdd*r*s + 15*D1**2*K*f*fdd*r - 30*D1**2*K*f*fdd*s**2 + 30*D1**2*K*f*fdd*s - 15*D1**2*K*f*fdd - 30*D1**2*K*fd**2*r*s + 15*D1**2*K*fd**2*r - 30*D1**2*K*fd**2*s**2 + 30*D1**2*K*fd**2*s + 7*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(5*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 4) + 6*f*(C*(4*r*s - 2*r + 4*s**2 - 4*s + 2) + 4*K*r*s + 4*K*s**2 - 2*K*s - r - 4*s + 1) - 14*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 45*D1**2*f**2*fd*r*s - 15*D1**2*f**2*fd*r + 45*D1**2*f**2*fd*s**2 - 50*D1**2*f**2*fd*s + 15*D1**2*f**2*fd - 24*D1**2*f*fd*r*s - 12*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 12*D1**2*f*fd + 15*D1**2*f*fdd*r + 30*D1**2*f*fdd*s - 15*D1**2*f*fdd + 6*D1**2*f*gd2*r*s + 6*D1**2*f*gd2*s**2 - 6*D1**2*f*gd2*s - 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s + 15*D1**2*fd**2*r + 30*D1**2*fd**2*s - 15*D1**2*fd**2 + 6*D1**2*fd*g2*r*s - 6*D1**2*fd*g2*r + 6*D1**2*fd*g2*s**2 - 12*D1**2*fd*g2*s + 6*D1**2*fd*g2 - 48*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*r - 48*D1**2*fd*gd2*s**2 + 72*D1**2*fd*gd2*s - 24*D1**2*fd*gd2 - 24*D1**2*fdd*g2*r*s + 24*D1**2*fdd*g2*r - 24*D1**2*fdd*g2*s**2 + 48*D1**2*fdd*g2*s - 24*D1**2*fdd*g2 + 72*D1*Dd*K*f**2*r*s - 18*D1*Dd*K*f**2*r + 72*D1*Dd*K*f**2*s**2 - 72*D1*Dd*K*f**2*s + 18*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*r*s + 90*D1*Dd*K*f*fd*r - 240*D1*Dd*K*f*fd*s**2 + 240*D1*Dd*K*f*fd*s - 60*D1*Dd*K*f*fd + 60*D1*Dd*f**3*r*s - 15*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 15*D1*Dd*f**3 - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 48*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 60*D1*Dd*f*fd*r + 120*D1*Dd*f*fd*s - 60*D1*Dd*f*fd + 24*D1*Dd*f*g2*r*s - 6*D1*Dd*f*g2*r + 24*D1*Dd*f*g2*s**2 - 24*D1*Dd*f*g2*s + 6*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r*s + 24*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 192*D1*Dd*f*gd2*s - 24*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r*s + 120*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s - 96*D1*Dd*fd*g2 - 60*D1*Ddd*K*f**2*r*s + 15*D1*Ddd*K*f**2*r - 60*D1*Ddd*K*f**2*s**2 + 60*D1*Ddd*K*f**2*s - 15*D1*Ddd*K*f**2 - 96*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 96*D1*Ddd*f*g2*s - 24*D1*Ddd*f*g2 + D1*bd1*(D1*(f**2*(r*(34 - 40*s) - 40*s**2 + 78*s - 34) - f*(24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 6*K*r*s + 6*K*s**2 - 3*K*s - 5*fd*(4*s - 1)*(4*r + 4*s - 3) + 14*r*s - 5*r + 14*s**2 - 41*s + 5) + 6*fd*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + 2*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + r + 4*s - 3) + 14*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 14*gd2*(-4*r*s + r - (1 - 2*s)**2)) + Dd*(5*f**2*(4*r*(8*s - 5) + 32*s**2 - 52*s + 17) + 12*f*(2*C*r*(8*s - 3) + 4*C*(1 - 2*s)**2 + K*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 2*r - 8*s + 3) - 28*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 180*Dd**2*K*f**2*r*s + 45*Dd**2*K*f**2*r - 180*Dd**2*K*f**2*s**2 + 180*Dd**2*K*f**2*s - 30*Dd**2*K*f**2 - 288*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 288*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(231*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**4*k1**2*(-D1*f*(D1*bd1**2*s*(5*f + 6)*(2*r + 2*s - 1) + D1*bd1*(-4*f*s*(r + s) + 5*fd*(r*(4*s - 1) + s*(4*s - 3))) + 5*D1*bdd1*f*s*(r + s) + 5*Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + b1**2*(-D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) + fd*(f*(4 - 8*s) - 5*s + 5) + fdd*(10*f*s - 5*f + 6*s - 6)) + D1*(Dd*(4*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 5*f*(fd*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - 4*r*s + r - 4*s**2 + 4*s - 1) - 6*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(5*f + 6)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(5*f + 6)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) + f*(6*bdd1*s*(2*r + 2*s - 1) - 4*fd*(2*s - 1)*(r + s - 1) + 5*fdd*(2*s - 1)*(r + s - 1)) + 5*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + f*s*(4*f + 5)*(2*r + 2*s - 1) - 6*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - Dd*f*(5*f + 6)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*f*(Dd*(4*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k2*k3) - 5*D1**2*Pkd2*Pkd3*ct**4*k2**5*st**2*(D1**2*(f**2*(fd*(100*C - 50)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(50*C - 25)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(50*C - 25)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 33*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) + 33*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 33*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(100*C - 50)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(33*K*(b1*r*(8*s - 2) + 2*b1*(1 - 2*s)**2 + bd1*(-8*r*s + r - 8*s**2 + 8*s - 1)) + fd*(25 - 50*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 132*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 66*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 66*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(50*C*f + 33*K*b1 - 25*f - 66*g2)) - Dd**2*f**2*(50*C*f + 33*K*b1 - 25*f - 66*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**4*k2**5*(40*C*D1**2*b1*f*fd*r*s + 40*C*D1**2*b1*f*fd*s**2 - 20*C*D1**2*b1*f*fd*s - 20*C*D1**2*b1*f*fdd*r*s - 20*C*D1**2*b1*f*fdd*s**2 + 10*C*D1**2*b1*f*fdd*s - 20*C*D1**2*b1*fd**2*r*s - 20*C*D1**2*b1*fd**2*s**2 + 10*C*D1**2*b1*fd**2*s - 30*C*D1**2*f**2*fd*r*s + 10*C*D1**2*f**2*fd*r - 30*C*D1**2*f**2*fd*s**2 + 30*C*D1**2*f**2*fd*s - 10*C*D1**2*f**2*fd + 80*C*D1*Dd*b1*f**2*r*s - 20*C*D1*Dd*b1*f**2*r + 80*C*D1*Dd*b1*f**2*s**2 - 80*C*D1*Dd*b1*f**2*s + 20*C*D1*Dd*b1*f**2 - 160*C*D1*Dd*b1*f*fd*r*s + 20*C*D1*Dd*b1*f*fd*r - 160*C*D1*Dd*b1*f*fd*s**2 + 120*C*D1*Dd*b1*f*fd*s - 10*C*D1*Dd*b1*f*fd - 40*C*D1*Dd*f**3*r*s + 10*C*D1*Dd*f**3*r - 40*C*D1*Dd*f**3*s**2 + 40*C*D1*Dd*f**3*s - 10*C*D1*Dd*f**3 - 40*C*D1*Ddd*b1*f**2*r*s + 10*C*D1*Ddd*b1*f**2*r - 40*C*D1*Ddd*b1*f**2*s**2 + 40*C*D1*Ddd*b1*f**2*s - 10*C*D1*Ddd*b1*f**2 - 120*C*Dd**2*b1*f**2*r*s + 30*C*Dd**2*b1*f**2*r - 120*C*Dd**2*b1*f**2*s**2 + 120*C*Dd**2*b1*f**2*s - 20*C*Dd**2*b1*f**2 + 12*D1**2*K*b1**2*fd*r*s + 12*D1**2*K*b1**2*fd*s**2 - 6*D1**2*K*b1**2*fdd*r*s - 6*D1**2*K*b1**2*fdd*s**2 - 12*D1**2*K*b1*f*fd*r*s + 6*D1**2*K*b1*f*fd*r - 12*D1**2*K*b1*f*fd*s**2 + 12*D1**2*K*b1*f*fd*s - 6*D1**2*K*b1*f*fd - 6*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 20*D1**2*b1*f*fd*r*s - 20*D1**2*b1*f*fd*s**2 + 10*D1**2*b1*f*fd*s + 10*D1**2*b1*f*fdd*r*s + 10*D1**2*b1*f*fdd*s**2 - 5*D1**2*b1*f*fdd*s - 24*D1**2*b1*f*gd2*r*s - 24*D1**2*b1*f*gd2*s**2 + 24*D1**2*b1*f*gd2*s + 12*D1**2*b1*f*gdd2*r*s + 12*D1**2*b1*f*gdd2*s**2 - 12*D1**2*b1*f*gdd2*s + 10*D1**2*b1*fd**2*r*s + 10*D1**2*b1*fd**2*s**2 - 5*D1**2*b1*fd**2*s - 24*D1**2*b1*fd*g2*r*s - 24*D1**2*b1*fd*g2*s**2 + 24*D1**2*b1*fd*gd2*r*s + 24*D1**2*b1*fd*gd2*s**2 - 12*D1**2*b1*fd*gd2*s + 12*D1**2*b1*fdd*g2*r*s + 12*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)*(6*K*b1*(2*s - 1) + f*(10*C - 5)*(s - 1) - 12*g2*(s - 1)) + 15*D1**2*f**2*fd*r*s - 5*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 15*D1**2*f**2*fd*s + 5*D1**2*f**2*fd + 12*D1**2*f**2*gd2*r*s + 12*D1**2*f**2*gd2*s**2 - 12*D1**2*f**2*gd2*s + 24*D1**2*f*fd*g2*r*s - 12*D1**2*f*fd*g2*r + 24*D1**2*f*fd*g2*s**2 - 24*D1**2*f*fd*g2*s + 12*D1**2*f*fd*g2 + 48*D1*Dd*K*b1**2*f*r*s - 12*D1*Dd*K*b1**2*f*r + 48*D1*Dd*K*b1**2*f*s**2 - 48*D1*Dd*K*b1**2*f*s + 12*D1*Dd*K*b1**2*f - 48*D1*Dd*K*b1**2*fd*r*s + 6*D1*Dd*K*b1**2*fd*r - 48*D1*Dd*K*b1**2*fd*s**2 + 24*D1*Dd*K*b1**2*fd*s - 24*D1*Dd*K*b1*f**2*r*s + 6*D1*Dd*K*b1*f**2*r - 24*D1*Dd*K*b1*f**2*s**2 + 24*D1*Dd*K*b1*f**2*s - 6*D1*Dd*K*b1*f**2 - 40*D1*Dd*b1*f**2*r*s + 10*D1*Dd*b1*f**2*r - 40*D1*Dd*b1*f**2*s**2 + 40*D1*Dd*b1*f**2*s - 10*D1*Dd*b1*f**2 + 80*D1*Dd*b1*f*fd*r*s - 10*D1*Dd*b1*f*fd*r + 80*D1*Dd*b1*f*fd*s**2 - 60*D1*Dd*b1*f*fd*s + 5*D1*Dd*b1*f*fd - 96*D1*Dd*b1*f*g2*r*s + 24*D1*Dd*b1*f*g2*r - 96*D1*Dd*b1*f*g2*s**2 + 96*D1*Dd*b1*f*g2*s - 24*D1*Dd*b1*f*g2 + 96*D1*Dd*b1*f*gd2*r*s - 12*D1*Dd*b1*f*gd2*r + 96*D1*Dd*b1*f*gd2*s**2 - 96*D1*Dd*b1*f*gd2*s + 12*D1*Dd*b1*f*gd2 + 96*D1*Dd*b1*fd*g2*r*s - 12*D1*Dd*b1*fd*g2*r + 96*D1*Dd*b1*fd*g2*s**2 - 48*D1*Dd*b1*fd*g2*s + 20*D1*Dd*f**3*r*s - 5*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 20*D1*Dd*f**3*s + 5*D1*Dd*f**3 + 48*D1*Dd*f**2*g2*r*s - 12*D1*Dd*f**2*g2*r + 48*D1*Dd*f**2*g2*s**2 - 48*D1*Dd*f**2*g2*s + 12*D1*Dd*f**2*g2 - 24*D1*Ddd*K*b1**2*f*r*s + 6*D1*Ddd*K*b1**2*f*r - 24*D1*Ddd*K*b1**2*f*s**2 + 24*D1*Ddd*K*b1**2*f*s - 6*D1*Ddd*K*b1**2*f + 20*D1*Ddd*b1*f**2*r*s - 5*D1*Ddd*b1*f**2*r + 20*D1*Ddd*b1*f**2*s**2 - 20*D1*Ddd*b1*f**2*s + 5*D1*Ddd*b1*f**2 + 48*D1*Ddd*b1*f*g2*r*s - 12*D1*Ddd*b1*f*g2*r + 48*D1*Ddd*b1*f*g2*s**2 - 48*D1*Ddd*b1*f*g2*s + 12*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(2*f**2*(r + s - 1)*(10*C*(s - 1) - s*(3*K + 5) + 5) + f*(-fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(-12*r - 12*s + 12)) + 6*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(-6*K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) - f*(10*C - 5)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 12*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 72*Dd**2*K*b1**2*f*r*s + 18*Dd**2*K*b1**2*f*r - 72*Dd**2*K*b1**2*f*s**2 + 72*Dd**2*K*b1**2*f*s - 12*Dd**2*K*b1**2*f + 60*Dd**2*b1*f**2*r*s - 15*Dd**2*b1*f**2*r + 60*Dd**2*b1*f**2*s**2 - 60*Dd**2*b1*f**2*s + 10*Dd**2*b1*f**2 + 144*Dd**2*b1*f*g2*r*s - 36*Dd**2*b1*f*g2*r + 144*Dd**2*b1*f*g2*s**2 - 144*Dd**2*b1*f*g2*s + 24*Dd**2*b1*f*g2)/(21*d**2*k3**5) + 5*D1**2*Pkd2*Pkd3*ct**4*k2**3*st**2*(300*C*D1**2*f**2*fd*r*s - 100*C*D1**2*f**2*fd*r + 300*C*D1**2*f**2*fd*s**2 - 300*C*D1**2*f**2*fd*s + 100*C*D1**2*f**2*fd - 150*C*D1**2*f**2*fdd*r*s + 50*C*D1**2*f**2*fdd*r - 150*C*D1**2*f**2*fdd*s**2 + 150*C*D1**2*f**2*fdd*s - 50*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*r*s + 100*C*D1**2*f*fd**2*r - 300*C*D1**2*f*fd**2*s**2 + 300*C*D1**2*f*fd**2*s - 50*C*D1**2*f*fd**2 + 400*C*D1*Dd*f**3*r*s - 100*C*D1*Dd*f**3*r + 400*C*D1*Dd*f**3*s**2 - 400*C*D1*Dd*f**3*s + 100*C*D1*Dd*f**3 - 1200*C*D1*Dd*f**2*fd*r*s + 350*C*D1*Dd*f**2*fd*r - 1200*C*D1*Dd*f**2*fd*s**2 + 1200*C*D1*Dd*f**2*fd*s - 250*C*D1*Dd*f**2*fd - 200*C*D1*Ddd*f**3*r*s + 50*C*D1*Ddd*f**3*r - 200*C*D1*Ddd*f**3*s**2 + 200*C*D1*Ddd*f**3*s - 50*C*D1*Ddd*f**3 - 600*C*Dd**2*f**3*r*s + 150*C*Dd**2*f**3*r - 600*C*Dd**2*f**3*s**2 + 600*C*Dd**2*f**3*s - 100*C*Dd**2*f**3 + 132*D1**2*K*b1*f*fd*r*s - 66*D1**2*K*b1*f*fd*r + 132*D1**2*K*b1*f*fd*s**2 - 132*D1**2*K*b1*f*fd*s + 66*D1**2*K*b1*f*fd - 66*D1**2*K*b1*f*fdd*r*s + 33*D1**2*K*b1*f*fdd*r - 66*D1**2*K*b1*f*fdd*s**2 + 66*D1**2*K*b1*f*fdd*s - 33*D1**2*K*b1*f*fdd - 66*D1**2*K*b1*fd**2*r*s + 33*D1**2*K*b1*fd**2*r - 66*D1**2*K*b1*fd**2*s**2 + 66*D1**2*K*b1*fd**2*s + 66*D1**2*K*bd1*f**2*r*s + 66*D1**2*K*bd1*f**2*s**2 - 66*D1**2*K*bd1*f**2*s - 132*D1**2*K*bd1*f*fd*r*s + 33*D1**2*K*bd1*f*fd*r - 132*D1**2*K*bd1*f*fd*s**2 + 132*D1**2*K*bd1*f*fd*s - 33*D1**2*K*bd1*f*fd - 33*D1**2*K*bdd1*f**2*r*s - 33*D1**2*K*bdd1*f**2*s**2 + 33*D1**2*K*bdd1*f**2*s - 33*D1**2*bdd2*f**2*r*s - 33*D1**2*bdd2*f**2*s**2 + 33*D1**2*bdd2*f**2*s - 150*D1**2*f**2*fd*r*s + 50*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 150*D1**2*f**2*fd*s - 50*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r*s - 25*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 75*D1**2*f**2*fdd*s + 25*D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s + 66*D1**2*f**2*gdd2*r*s + 66*D1**2*f**2*gdd2*s**2 - 66*D1**2*f**2*gdd2*s + 150*D1**2*f*fd**2*r*s - 50*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 150*D1**2*f*fd**2*s + 25*D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r*s - 66*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 264*D1**2*f*fd*gd2*s + 66*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r*s - 66*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r*s - 66*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 264*D1*Dd*K*b1*f**2*r*s - 66*D1*Dd*K*b1*f**2*r + 264*D1*Dd*K*b1*f**2*s**2 - 264*D1*Dd*K*b1*f**2*s + 66*D1*Dd*K*b1*f**2 - 528*D1*Dd*K*b1*f*fd*r*s + 198*D1*Dd*K*b1*f*fd*r - 528*D1*Dd*K*b1*f*fd*s**2 + 528*D1*Dd*K*b1*f*fd*s - 132*D1*Dd*K*b1*f*fd - 264*D1*Dd*K*bd1*f**2*r*s + 33*D1*Dd*K*bd1*f**2*r - 264*D1*Dd*K*bd1*f**2*s**2 + 264*D1*Dd*K*bd1*f**2*s - 33*D1*Dd*K*bd1*f**2 - 200*D1*Dd*f**3*r*s + 50*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 200*D1*Dd*f**3*s - 50*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r*s - 175*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 600*D1*Dd*f**2*fd*s + 125*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r*s + 132*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r*s - 66*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 528*D1*Dd*f**2*gd2*s + 66*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r*s - 396*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1056*D1*Dd*f*fd*g2*s + 264*D1*Dd*f*fd*g2 - 132*D1*Ddd*K*b1*f**2*r*s + 33*D1*Ddd*K*b1*f**2*r - 132*D1*Ddd*K*b1*f**2*s**2 + 132*D1*Ddd*K*b1*f**2*s - 33*D1*Ddd*K*b1*f**2 + 100*D1*Ddd*f**3*r*s - 25*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 100*D1*Ddd*f**3*s + 25*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r*s - 66*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 264*D1*Ddd*f**2*g2*s + 66*D1*Ddd*f**2*g2 + 33*D1*bd2*f*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 396*Dd**2*K*b1*f**2*r*s + 99*Dd**2*K*b1*f**2*r - 396*Dd**2*K*b1*f**2*s**2 + 396*Dd**2*K*b1*f**2*s - 66*Dd**2*K*b1*f**2 + 300*Dd**2*f**3*r*s - 75*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 300*Dd**2*f**3*s + 50*Dd**2*f**3 + 792*Dd**2*f**2*g2*r*s - 198*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 792*Dd**2*f**2*g2*s + 132*Dd**2*f**2*g2 + 33*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(231*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct**4*k2**3*(D1*(6*D1*K*bd1**2*f*(r + 2*s - 1) + 6*K*b1**2*(r + 2*s - 1)*(2*D1*fd - D1*fdd - 4*Dd*fd) + b1*(6*D1*bd2*s*(2*f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) + D1*f*(6*K*bdd1*(r + 2*s - 1) - 6*bdd2*s*(r + s - 1) + 2*fd*(10*C*(r + 2*s - 1) + K*(-6*r*s + 3*r - 6*s**2 + 6*s - 3) - 5*r - 10*s + 5) - fdd*(10*C - 5)*(r + 2*s - 1)) - D1*(r + 2*s - 1)*(fd**2*(10*C - 5) + 12*fd*(2*g2 - gd2) - 12*fdd*g2) - 6*Dd*K*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd*bd2*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + Dd*f*fd*(20 - 40*C)*(r + 2*s - 1) + 48*Dd*fd*g2*(r + 2*s - 1)) - bd1*(6*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(6*K*b1*fd*(r + 2*s - 1) + 2*f**2*(10*C*(r + 2*s - 1) + 3*K*s**2 - 3*K*s + r*(3*K*s - 5) - 10*s + 5) - f*(r + 2*s - 1)*(-12*K*b1 + fd*(10*C - 5) + 24*g2 - 12*gd2)) - 4*Dd*f*(r + 2*s - 1)*(10*C*f + 6*K*b1 - 5*f - 12*g2)) + f*(D1*bdd1*(f*(10*C - 5) - 12*g2)*(r + 2*s - 1) + D1*(f*(-fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-6*bd2 + 12*gd2)*(r + s - 1)) + 12*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 6*b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(21*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct**4*k2*(D1*(-6*D1*K*bd1**2*f*s*(2*r + 2*s - 1) - D1*bdd1*f*s*(r + s)*(f*(10*C - 5) - 12*g2) - 6*b2*(D1*bd1*(-2*f*s*(r + s) + fd*r*(2*s - 1) + 2*fd*s*(s - 1)) + D1*bdd1*f*s*(r + s) + Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) - bd1*(D1*(f**2*s*(10 - 20*C)*(r + s) + f*(fd*(10*C - 5)*(r*(4*s - 1) + s*(4*s - 3)) + 6*s*(bd2*(2*r + 2*s - 1) + 4*g2*(r + s) + gd2*(-4*r - 4*s + 2))) + 12*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)))) + 6*K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(40*C*D1**2*f*fd*r*s - 20*C*D1**2*f*fd*r + 40*C*D1**2*f*fd*s**2 - 60*C*D1**2*f*fd*s + 20*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r*s + 10*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 30*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r*s + 10*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 30*C*D1**2*fd**2*s - 10*C*D1**2*fd**2 + 80*C*D1*Dd*f**2*r*s - 20*C*D1*Dd*f**2*r + 80*C*D1*Dd*f**2*s**2 - 80*C*D1*Dd*f**2*s + 20*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r*s + 60*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 200*C*D1*Dd*f*fd*s - 50*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r*s + 10*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 40*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r*s + 30*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 120*C*Dd**2*f**2*s - 20*C*Dd**2*f**2 + 24*D1**2*K*bd1*f*r*s + 24*D1**2*K*bd1*f*s**2 - 12*D1**2*K*bd1*f*s - 24*D1**2*K*bd1*fd*r*s + 12*D1**2*K*bd1*fd*r - 24*D1**2*K*bd1*fd*s**2 + 30*D1**2*K*bd1*fd*s - 6*D1**2*K*bd1*fd - 12*D1**2*K*bdd1*f*r*s - 12*D1**2*K*bdd1*f*s**2 + 6*D1**2*K*bdd1*f*s - 6*D1**2*bdd2*f*r*s - 6*D1**2*bdd2*f*s**2 + 6*D1**2*bdd2*f*s - 20*D1**2*f*fd*r*s + 10*D1**2*f*fd*r - 20*D1**2*f*fd*s**2 + 30*D1**2*f*fd*s - 10*D1**2*f*fd + 10*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 15*D1**2*f*fdd*s + 5*D1**2*f*fdd - 24*D1**2*f*gd2*r*s - 24*D1**2*f*gd2*s**2 + 24*D1**2*f*gd2*s + 12*D1**2*f*gdd2*r*s + 12*D1**2*f*gdd2*s**2 - 12*D1**2*f*gdd2*s + 10*D1**2*fd**2*r*s - 5*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 15*D1**2*fd**2*s + 5*D1**2*fd**2 - 24*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*r - 24*D1**2*fd*g2*s**2 + 48*D1**2*fd*g2*s - 24*D1**2*fd*g2 + 24*D1**2*fd*gd2*r*s - 12*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 36*D1**2*fd*gd2*s + 12*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*r + 12*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 - 96*D1*Dd*K*bd1*f*r*s + 12*D1*Dd*K*bd1*f*r - 96*D1*Dd*K*bd1*f*s**2 + 72*D1*Dd*K*bd1*f*s - 6*D1*Dd*K*bd1*f - 40*D1*Dd*f**2*r*s + 10*D1*Dd*f**2*r - 40*D1*Dd*f**2*s**2 + 40*D1*Dd*f**2*s - 10*D1*Dd*f**2 + 80*D1*Dd*f*fd*r*s - 30*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 100*D1*Dd*f*fd*s + 25*D1*Dd*f*fd - 96*D1*Dd*f*g2*r*s + 24*D1*Dd*f*g2*r - 96*D1*Dd*f*g2*s**2 + 96*D1*Dd*f*g2*s - 24*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r*s - 12*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 96*D1*Dd*f*gd2*s + 12*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r*s - 60*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 144*D1*Dd*fd*g2*s + 48*D1*Dd*fd*g2 + 20*D1*Ddd*f**2*r*s - 5*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 20*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r*s - 12*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 48*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + 6*D1*bd2*(D1*(r + s - 1)*(2*f*s - 2*fd*s + fd) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 60*Dd**2*f**2*r*s - 15*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 60*Dd**2*f**2*s + 10*Dd**2*f**2 + 144*Dd**2*f*g2*r*s - 36*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 144*Dd**2*f*g2*s + 24*Dd**2*f*g2 + 6*b2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(21*d**2*k3) - 2*D1**2*Pkd2*Pkd3*ct**3*f*k1**3*k2**2*st**4*(D1**2*(5*f**2*(521*fd - 280*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - f*(1400*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - fd*(780*C - 780)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(390*C - 390)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-429*K*bd1 + 429*bd1 + 858*gd2)) - 78*fd*(fd*(5*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 11*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1))) + 429*D1*b1*(K - 1)*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*f*(Dd*(2605*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 20*f*(39*C*(r*(4*s - 1) + (1 - 2*s)**2) - 140*fd*(4*s - 1)*(4*r + 4*s - 3) - 39*r*(4*s - 1) - 39*(1 - 2*s)**2) - 78*fd*(5*C - 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 858*g2*(r*(4*s - 1) + (1 - 2*s)**2)) - 10*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(39*C + 140*f - 39)) - 10*Dd**2*f**2*(39*C + 140*f - 39)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k3**5) + 10*D1**2*Pkd2*Pkd3*ct**3*f*k1*k2**4*st**4*(D1**2*(f**2*s*(14*bd1 - 7*bdd1)*(r + s - 1) + f*(fd*(14*b1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*bd1*(6*r*s - r + 6*s**2 - 6*s + 1) + (18 - 24*C)*(3*r*s - r + 3*s**2 - 3*s + 1)) - fdd*(-12*C + 7*b1 + 9)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(-12*C + 7*b1 + 9)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(f*(14*b1*(r*(4*s - 1) + (1 - 2*s)**2) - 7*bd1*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - (24*C - 18)*(r*(4*s - 1) + (1 - 2*s)**2)) - fd*(-12*C + 7*b1 + 9)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-12*C + 7*b1 + 9)) - Dd**2*f**2*(-12*C + 7*b1 + 9)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k3**5) - 10*D1**2*Pkd2*Pkd3*ct**3*f*k1*k2**2*st**4*(D1**2*(f**2*s*(14*bd1 - 7*bdd1)*(r + s - 1) + f*(fd*(14*b1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*bd1*(6*r*s - r + 6*s**2 - 6*s + 1) + 18*r*s - 6*r + 18*s**2 - 18*s + 6) - fdd*(7*b1 + 3)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(7*b1 + 3)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(f*(14*b1*(r*(4*s - 1) + (1 - 2*s)**2) - 7*bd1*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 6*r*(4*s - 1) + 6*(1 - 2*s)**2) - fd*(7*b1 + 3)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - Ddd*f*(7*b1 + 3)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(7*b1 + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k3**3) - D1**2*Pkd2*Pkd3*ct**3*k1**5*st**2*(9126*C*D1**2*f**2*fd*r*s - 3042*C*D1**2*f**2*fd*r + 9126*C*D1**2*f**2*fd*s**2 - 9126*C*D1**2*f**2*fd*s + 3042*C*D1**2*f**2*fd - 5850*C*D1**2*f**2*fdd*r*s + 1950*C*D1**2*f**2*fdd*r - 5850*C*D1**2*f**2*fdd*s**2 + 5850*C*D1**2*f**2*fdd*s - 1950*C*D1**2*f**2*fdd - 11700*C*D1**2*f*fd**2*r*s + 3900*C*D1**2*f*fd**2*r - 11700*C*D1**2*f*fd**2*s**2 + 11700*C*D1**2*f*fd**2*s - 1950*C*D1**2*f*fd**2 + 12168*C*D1*Dd*f**3*r*s - 3042*C*D1*Dd*f**3*r + 12168*C*D1*Dd*f**3*s**2 - 12168*C*D1*Dd*f**3*s + 3042*C*D1*Dd*f**3 - 46800*C*D1*Dd*f**2*fd*r*s + 13650*C*D1*Dd*f**2*fd*r - 46800*C*D1*Dd*f**2*fd*s**2 + 46800*C*D1*Dd*f**2*fd*s - 9750*C*D1*Dd*f**2*fd - 7800*C*D1*Ddd*f**3*r*s + 1950*C*D1*Ddd*f**3*r - 7800*C*D1*Ddd*f**3*s**2 + 7800*C*D1*Ddd*f**3*s - 1950*C*D1*Ddd*f**3 - 23400*C*Dd**2*f**3*r*s + 5850*C*Dd**2*f**3*r - 23400*C*Dd**2*f**3*s**2 + 23400*C*Dd**2*f**3*s - 3900*C*Dd**2*f**3 - 1287*D1**2*K*bdd1*f**2*r*s - 1287*D1**2*K*bdd1*f**2*s**2 + 1287*D1**2*K*bdd1*f**2*s + 1287*D1**2*bdd1*f**2*r*s + 1287*D1**2*bdd1*f**2*s**2 - 1287*D1**2*bdd1*f**2*s + 55000*D1**2*f**3*fd*r*s - 13750*D1**2*f**3*fd*r + 55000*D1**2*f**3*fd*s**2 - 55000*D1**2*f**3*fd*s + 13750*D1**2*f**3*fd - 39200*D1**2*f**3*fdd*r*s + 9800*D1**2*f**3*fdd*r - 39200*D1**2*f**3*fdd*s**2 + 39200*D1**2*f**3*fdd*s - 9800*D1**2*f**3*fdd - 117600*D1**2*f**2*fd**2*r*s + 29400*D1**2*f**2*fd**2*r - 117600*D1**2*f**2*fd**2*s**2 + 117600*D1**2*f**2*fd**2*s - 19600*D1**2*f**2*fd**2 - 9126*D1**2*f**2*fd*r*s + 3042*D1**2*f**2*fd*r - 9126*D1**2*f**2*fd*s**2 + 9126*D1**2*f**2*fd*s - 3042*D1**2*f**2*fd + 5850*D1**2*f**2*fdd*r*s - 1950*D1**2*f**2*fdd*r + 5850*D1**2*f**2*fdd*s**2 - 5850*D1**2*f**2*fdd*s + 1950*D1**2*f**2*fdd - 4290*D1**2*f**2*gd2*r*s - 4290*D1**2*f**2*gd2*s**2 + 4290*D1**2*f**2*gd2*s + 2574*D1**2*f**2*gdd2*r*s + 2574*D1**2*f**2*gdd2*s**2 - 2574*D1**2*f**2*gdd2*s + 11700*D1**2*f*fd**2*r*s - 3900*D1**2*f*fd**2*r + 11700*D1**2*f*fd**2*s**2 - 11700*D1**2*f*fd**2*s + 1950*D1**2*f*fd**2 - 8580*D1**2*f*fd*g2*r*s + 4290*D1**2*f*fd*g2*r - 8580*D1**2*f*fd*g2*s**2 + 8580*D1**2*f*fd*g2*s - 4290*D1**2*f*fd*g2 + 10296*D1**2*f*fd*gd2*r*s - 2574*D1**2*f*fd*gd2*r + 10296*D1**2*f*fd*gd2*s**2 - 10296*D1**2*f*fd*gd2*s + 2574*D1**2*f*fd*gd2 + 5148*D1**2*f*fdd*g2*r*s - 2574*D1**2*f*fdd*g2*r + 5148*D1**2*f*fdd*g2*s**2 - 5148*D1**2*f*fdd*g2*s + 2574*D1**2*f*fdd*g2 + 5148*D1**2*fd**2*g2*r*s - 2574*D1**2*fd**2*g2*r + 5148*D1**2*fd**2*g2*s**2 - 5148*D1**2*fd**2*g2*s + 55000*D1*Dd*f**4*r*s - 13750*D1*Dd*f**4*r + 55000*D1*Dd*f**4*s**2 - 55000*D1*Dd*f**4*s + 13750*D1*Dd*f**4 - 313600*D1*Dd*f**3*fd*r*s + 78400*D1*Dd*f**3*fd*r - 313600*D1*Dd*f**3*fd*s**2 + 313600*D1*Dd*f**3*fd*s - 58800*D1*Dd*f**3*fd - 12168*D1*Dd*f**3*r*s + 3042*D1*Dd*f**3*r - 12168*D1*Dd*f**3*s**2 + 12168*D1*Dd*f**3*s - 3042*D1*Dd*f**3 + 46800*D1*Dd*f**2*fd*r*s - 13650*D1*Dd*f**2*fd*r + 46800*D1*Dd*f**2*fd*s**2 - 46800*D1*Dd*f**2*fd*s + 9750*D1*Dd*f**2*fd - 17160*D1*Dd*f**2*g2*r*s + 4290*D1*Dd*f**2*g2*r - 17160*D1*Dd*f**2*g2*s**2 + 17160*D1*Dd*f**2*g2*s - 4290*D1*Dd*f**2*g2 + 20592*D1*Dd*f**2*gd2*r*s - 2574*D1*Dd*f**2*gd2*r + 20592*D1*Dd*f**2*gd2*s**2 - 20592*D1*Dd*f**2*gd2*s + 2574*D1*Dd*f**2*gd2 + 41184*D1*Dd*f*fd*g2*r*s - 15444*D1*Dd*f*fd*g2*r + 41184*D1*Dd*f*fd*g2*s**2 - 41184*D1*Dd*f*fd*g2*s + 10296*D1*Dd*f*fd*g2 - 39200*D1*Ddd*f**4*r*s + 9800*D1*Ddd*f**4*r - 39200*D1*Ddd*f**4*s**2 + 39200*D1*Ddd*f**4*s - 9800*D1*Ddd*f**4 + 7800*D1*Ddd*f**3*r*s - 1950*D1*Ddd*f**3*r + 7800*D1*Ddd*f**3*s**2 - 7800*D1*Ddd*f**3*s + 1950*D1*Ddd*f**3 + 10296*D1*Ddd*f**2*g2*r*s - 2574*D1*Ddd*f**2*g2*r + 10296*D1*Ddd*f**2*g2*s**2 - 10296*D1*Ddd*f**2*g2*s + 2574*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 117600*Dd**2*f**4*r*s + 29400*Dd**2*f**4*r - 117600*Dd**2*f**4*s**2 + 117600*Dd**2*f**4*s - 19600*Dd**2*f**4 + 23400*Dd**2*f**3*r*s - 5850*Dd**2*f**3*r + 23400*Dd**2*f**3*s**2 - 23400*Dd**2*f**3*s + 3900*Dd**2*f**3 + 30888*Dd**2*f**2*g2*r*s - 7722*Dd**2*f**2*g2*r + 30888*Dd**2*f**2*g2*s**2 - 30888*Dd**2*f**2*g2*s + 5148*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(9009*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**3*k1**5*(-D1*(198*D1*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + D1*bd1*(-5*f**3*(102*s - 125)*(r + s - 1) - 4*f**2*(66*C*(s - 1)*(r + s - 1) - 35*fd*(18*r*s - 11*r + 18*s**2 - 26*s + 7) + (66 - 66*s)*(r + s - 1)) + 66*f*(fd*(5*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (5*g2*(s - 1) + 6*gd2*(1 - 2*s))*(r + s - 1)) - 396*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*D1*bdd1*f*(r + s - 1)*(70*f**2*(3*s - 4) + f*(165*C - 165)*(s - 1) - 198*g2*(s - 1)) + 2*Dd*bd1*f*(70*f**2*(r*(24*s - 19) + 24*s**2 - 40*s + 15) + f*(165*C - 165)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 198*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 140*f**3*(D1*fd + Dd*f)*(r*(4*s - 1) + (1 - 2*s)**2)) + 33*b1**2*(K - 1)*(D1**2*s*(5*fd - 6*fdd)*(r + s) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) + 6*fd*(-8*r*s + r + s*(4 - 8*s))) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(528*C*D1**2*f*fd*r*s + 528*C*D1**2*f*fd*s**2 - 264*C*D1**2*f*fd*s - 660*C*D1**2*f*fdd*r*s - 660*C*D1**2*f*fdd*s**2 + 330*C*D1**2*f*fdd*s - 660*C*D1**2*fd**2*r*s - 660*C*D1**2*fd**2*s**2 + 330*C*D1**2*fd**2*s + 1056*C*D1*Dd*f**2*r*s - 264*C*D1*Dd*f**2*r + 1056*C*D1*Dd*f**2*s**2 - 1056*C*D1*Dd*f**2*s + 264*C*D1*Dd*f**2 - 5280*C*D1*Dd*f*fd*r*s + 660*C*D1*Dd*f*fd*r - 5280*C*D1*Dd*f*fd*s**2 + 3960*C*D1*Dd*f*fd*s - 330*C*D1*Dd*f*fd - 1320*C*D1*Ddd*f**2*r*s + 330*C*D1*Ddd*f**2*r - 1320*C*D1*Ddd*f**2*s**2 + 1320*C*D1*Ddd*f**2*s - 330*C*D1*Ddd*f**2 - 3960*C*Dd**2*f**2*r*s + 990*C*Dd**2*f**2*r - 3960*C*Dd**2*f**2*s**2 + 3960*C*Dd**2*f**2*s - 660*C*Dd**2*f**2 - 198*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 1530*D1**2*f**2*fd*r*s + 115*D1**2*f**2*fd*r + 1530*D1**2*f**2*fd*s**2 - 905*D1**2*f**2*fd*s - 115*D1**2*f**2*fd - 1260*D1**2*f**2*fdd*r*s - 140*D1**2*f**2*fdd*r - 1260*D1**2*f**2*fdd*s**2 + 700*D1**2*f**2*fdd*s + 140*D1**2*f**2*fdd - 2520*D1**2*f*fd**2*r*s - 280*D1**2*f*fd**2*r - 2520*D1**2*f*fd**2*s**2 + 1400*D1**2*f*fd**2*s + 140*D1**2*f*fd**2 - 528*D1**2*f*fd*r*s - 528*D1**2*f*fd*s**2 + 264*D1**2*f*fd*s + 660*D1**2*f*fdd*r*s + 660*D1**2*f*fdd*s**2 - 330*D1**2*f*fdd*s - 330*D1**2*f*gd2*r*s - 330*D1**2*f*gd2*s**2 + 330*D1**2*f*gd2*s + 396*D1**2*f*gdd2*r*s + 396*D1**2*f*gdd2*s**2 - 396*D1**2*f*gdd2*s + 660*D1**2*fd**2*r*s + 660*D1**2*fd**2*s**2 - 330*D1**2*fd**2*s - 330*D1**2*fd*g2*r*s - 330*D1**2*fd*g2*s**2 + 792*D1**2*fd*gd2*r*s + 792*D1**2*fd*gd2*s**2 - 396*D1**2*fd*gd2*s + 396*D1**2*fdd*g2*r*s + 396*D1**2*fdd*g2*s**2 + 2040*D1*Dd*f**3*r*s - 510*D1*Dd*f**3*r + 2040*D1*Dd*f**3*s**2 - 2040*D1*Dd*f**3*s + 510*D1*Dd*f**3 - 10080*D1*Dd*f**2*fd*r*s + 700*D1*Dd*f**2*fd*r - 10080*D1*Dd*f**2*fd*s**2 + 7840*D1*Dd*f**2*fd*s - 420*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*r*s + 264*D1*Dd*f**2*r - 1056*D1*Dd*f**2*s**2 + 1056*D1*Dd*f**2*s - 264*D1*Dd*f**2 + 5280*D1*Dd*f*fd*r*s - 660*D1*Dd*f*fd*r + 5280*D1*Dd*f*fd*s**2 - 3960*D1*Dd*f*fd*s + 330*D1*Dd*f*fd - 1320*D1*Dd*f*g2*r*s + 330*D1*Dd*f*g2*r - 1320*D1*Dd*f*g2*s**2 + 1320*D1*Dd*f*g2*s - 330*D1*Dd*f*g2 + 3168*D1*Dd*f*gd2*r*s - 396*D1*Dd*f*gd2*r + 3168*D1*Dd*f*gd2*s**2 - 3168*D1*Dd*f*gd2*s + 396*D1*Dd*f*gd2 + 3168*D1*Dd*fd*g2*r*s - 396*D1*Dd*fd*g2*r + 3168*D1*Dd*fd*g2*s**2 - 1584*D1*Dd*fd*g2*s - 1680*D1*Ddd*f**3*r*s + 420*D1*Ddd*f**3*r - 1680*D1*Ddd*f**3*s**2 + 1680*D1*Ddd*f**3*s - 420*D1*Ddd*f**3 + 1320*D1*Ddd*f**2*r*s - 330*D1*Ddd*f**2*r + 1320*D1*Ddd*f**2*s**2 - 1320*D1*Ddd*f**2*s + 330*D1*Ddd*f**2 + 1584*D1*Ddd*f*g2*r*s - 396*D1*Ddd*f*g2*r + 1584*D1*Ddd*f*g2*s**2 - 1584*D1*Ddd*f*g2*s + 396*D1*Ddd*f*g2 + 33*D1*bd1*(K - 1)*(D1*(5*f*(2*s - 1)*(r + s - 1) + 6*fd*(-4*r*s + r + s*(3 - 4*s))) - 6*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 5040*Dd**2*f**3*r*s + 1260*Dd**2*f**3*r - 5040*Dd**2*f**3*s**2 + 5040*Dd**2*f**3*s - 840*Dd**2*f**3 + 3960*Dd**2*f**2*r*s - 990*Dd**2*f**2*r + 3960*Dd**2*f**2*s**2 - 3960*Dd**2*f**2*s + 660*Dd**2*f**2 + 4752*Dd**2*f*g2*r*s - 1188*Dd**2*f*g2*r + 4752*Dd**2*f*g2*s**2 - 4752*Dd**2*f*g2*s + 792*Dd**2*f*g2))/(693*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**3*k1**3*k2**2*st**2*(-297*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 2*D1**2*bdd1*f*(r + s - 1)*(250*f**2*(s + 2) - 297*f*(C*(s - 1) + s*(2*K - 2) + 1) + 297*g2*(s - 1)) + 6*D1**2*(-125*f**3*fd*(r*(4*s - 1) + (1 - 2*s)**2) + 3*f**2*(fd*(134*C - 95)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(100*C - 75)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-198*gd2 + 132*gdd2)*(r + s - 1)) - 3*f*(fd**2*(100*C - 75)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*fd*(g2*(r*(6*s - 3) + 6*s**2 - 6*s + 3) + 2*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 132*fdd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 396*fd**2*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*D1*bd1*(D1*(f**3*(302*s + 901)*(r + s - 1) - f**2*(561*C*(s - 1)*(r + s - 1) + 250*fd*(r*(6*s + 3) + 6*s**2 - 2*s - 1) + (s*(27*K - 29) + 17)*(33*r + 33*s - 33)) + 33*f*(9*fd*(C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 8*r*s + 3*r - 8*s**2 + 9*s - 2) + (25*g2*(s - 1) + 9*gd2*(1 - 2*s))*(r + s - 1)) - 297*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(250*f**2*(r*(8*s + 7) + 8*s**2 - 5) - 297*f*(C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 16*r*s + 6*r - 16*s**2 + 20*s - 5) + 297*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 6*D1*f*(Dd*(-125*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(402*C - 285)*(r*(4*s - 1) + (1 - 2*s)**2) - 3*f*(fd*(100*C - 75)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 198*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 132*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 792*fd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(f*(100*C - 75) - 132*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*Dd**2*f**2*(f*(100*C - 75) - 132*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 33*b1**2*(K - 1)*(D1**2*s*(25*fd - 9*fdd)*(r + s) + D1*Dd*(25*f*(r*(4*s - 1) + (1 - 2*s)**2) + 9*fd*(-8*r*s + r + s*(4 - 8*s))) - 9*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 9*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-297*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 2*D1**2*(f**2*(fd*(r*(1203 - 906*s) - 906*s**2 + 1807*s - 1203) + 250*fdd*(3*r*(s - 1) + 3*s**2 - 5*s + 3)) + f*(250*fd**2*(6*r*(s - 1) + 6*s**2 - 10*s + 3) + 33*fd*(34*C*s**2 - 17*C*s + 27*K*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*r*(17*C*s - 29*s + 6) - 58*s**2 + 41*s - 12) - 297*fdd*(2*C*r*s + 2*C*s**2 - C*s + K*(4*r*s - 2*r + 4*s**2 - 4*s + 2) - 4*r*s + r - 4*s**2 + 3*s - 1) - 33*s*(25*gd2 - 9*gdd2)*(r + s - 1)) - 297*fd**2*(r*(K*(4*s - 2) + s*(2*C - 4) + 1) + s*(C*(2*s - 1) + 4*K*(s - 1) - 4*s + 3)) - 33*fd*s*(25*g2*(r + s) - 9*gd2*(2*r + 2*s - 1)) + 297*fdd*g2*s*(r + s)) + 33*D1*bd1*(K - 1)*(D1*(25*f*(2*s - 1)*(r + s - 1) + 9*fd*(-4*r*s + r + s*(3 - 4*s))) - 9*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 2*D1*(Dd*(-302*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(561*C*(r*(4*s - 1) + (1 - 2*s)**2) + 250*fd*(3*r*(8*s - 5) + 24*s**2 - 32*s + 11) + (891*K - 957)*(r*(4*s - 1) + (1 - 2*s)**2)) - 33*f*(9*fd*(C*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 4*K*(8*r*s - 3*r + 8*s**2 - 8*s + 2) - (4*s - 1)*(8*r + 8*s - 5)) + 25*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 9*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 297*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(250*f**2 - 297*f*(C + 2*K - 2) + 297*g2)) + 2*Dd**2*f*(250*f**2 - 297*f*(C + 2*K - 2) + 297*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct**3*k1**3*k2**2*(1980*C*D1**2*bdd1*f**2*r*s - 1980*C*D1**2*bdd1*f**2*r + 1980*C*D1**2*bdd1*f**2*s**2 - 3960*C*D1**2*bdd1*f**2*s + 1980*C*D1**2*bdd1*f**2 + 1290*C*D1**2*f**2*fd*r*s - 430*C*D1**2*f**2*fd*r + 1290*C*D1**2*f**2*fd*s**2 - 1290*C*D1**2*f**2*fd*s + 430*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 + 1720*C*D1*Dd*f**3*r*s - 430*C*D1*Dd*f**3*r + 1720*C*D1*Dd*f**3*s**2 - 1720*C*D1*Dd*f**3*s + 430*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 198*D1**2*bd1**2*f*(2*s - 1)*(-6*K + 5*f + 3)*(r + s - 1) - 1485*D1**2*bdd1*f**2*r*s + 1485*D1**2*bdd1*f**2*r - 1485*D1**2*bdd1*f**2*s**2 + 2970*D1**2*bdd1*f**2*s - 1485*D1**2*bdd1*f**2 - 2376*D1**2*bdd1*f*g2*r*s + 2376*D1**2*bdd1*f*g2*r - 2376*D1**2*bdd1*f*g2*s**2 + 4752*D1**2*bdd1*f*g2*s - 2376*D1**2*bdd1*f*g2 - 1140*D1**2*f**2*fd*r*s + 380*D1**2*f**2*fd*r - 1140*D1**2*f**2*fd*s**2 + 1140*D1**2*f**2*fd*s - 380*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd - 528*D1**2*f**2*gd2*r*s - 528*D1**2*f**2*gd2*s**2 + 528*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 840*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 - 1056*D1**2*f*fd*g2*r*s + 528*D1**2*f*fd*g2*r - 1056*D1**2*f*fd*g2*s**2 + 1056*D1**2*f*fd*g2*s - 528*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s - 1520*D1*Dd*f**3*r*s + 380*D1*Dd*f**3*r - 1520*D1*Dd*f**3*s**2 + 1520*D1*Dd*f**3*s - 380*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3360*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd - 2112*D1*Dd*f**2*g2*r*s + 528*D1*Dd*f**2*g2*r - 2112*D1*Dd*f**2*g2*s**2 + 2112*D1*Dd*f**2*g2*s - 528*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 - 560*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 33*D1*bd1*(D1*(15*f**3*(r + s - 1) + 2*f**2*(r + s - 1)*(24*C*(s - 1) - s*(4*K + 12) + 15) + f*(-5*fd*(12*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 9*r*(4*s - 2) - 36*s**2 + 45*s - 9) + (-5*g2*(s - 1) + 6*gd2*(2*s - 1))*(12*r + 12*s - 12)) + 72*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-5*f*(12*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 72*r*s + 45*r - 72*s**2 + 108*s - 36) + 72*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 1680*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 66*b1**2*(D1**2*s*(3*f*(7*fd - 5*fdd)*(2*r + 2*s - 1) - 15*fd**2*(2*r + 2*s - 1) - fd*(15*K - 4)*(r + s) + 9*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(21*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-15*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - (15*K - 4)*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-6*K + 5*f + 3)) - 3*Dd**2*f*(-6*K + 5*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 33*b1*(-96*C*D1**2*f*fd*r*s - 96*C*D1**2*f*fd*s**2 + 48*C*D1**2*f*fd*s + 120*C*D1**2*f*fdd*r*s + 120*C*D1**2*f*fdd*s**2 - 60*C*D1**2*f*fdd*s + 120*C*D1**2*fd**2*r*s + 120*C*D1**2*fd**2*s**2 - 60*C*D1**2*fd**2*s - 192*C*D1*Dd*f**2*r*s + 48*C*D1*Dd*f**2*r - 192*C*D1*Dd*f**2*s**2 + 192*C*D1*Dd*f**2*s - 48*C*D1*Dd*f**2 + 960*C*D1*Dd*f*fd*r*s - 120*C*D1*Dd*f*fd*r + 960*C*D1*Dd*f*fd*s**2 - 720*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 240*C*D1*Ddd*f**2*r*s - 60*C*D1*Ddd*f**2*r + 240*C*D1*Ddd*f**2*s**2 - 240*C*D1*Ddd*f**2*s + 60*C*D1*Ddd*f**2 + 720*C*Dd**2*f**2*r*s - 180*C*Dd**2*f**2*r + 720*C*Dd**2*f**2*s**2 - 720*C*Dd**2*f**2*s + 120*C*Dd**2*f**2 + 16*D1**2*K*f*fd*r*s - 8*D1**2*K*f*fd*r + 16*D1**2*K*f*fd*s**2 - 16*D1**2*K*f*fd*s + 8*D1**2*K*f*fd + 10*D1**2*K*f*fdd*r*s - 5*D1**2*K*f*fdd*r + 10*D1**2*K*f*fdd*s**2 - 10*D1**2*K*f*fdd*s + 5*D1**2*K*f*fdd + 10*D1**2*K*fd**2*r*s - 5*D1**2*K*fd**2*r + 10*D1**2*K*fd**2*s**2 - 10*D1**2*K*fd**2*s - 6*D1**2*bdd1*f*(2*s - 1)*(-6*K + 5*f + 3)*(r + s - 1) + 15*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s - 15*D1**2*f**2*fd + 48*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 48*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s - 6*D1**2*f*fd - 90*D1**2*f*fdd*r*s - 90*D1**2*f*fdd*s**2 + 45*D1**2*f*fdd*s + 60*D1**2*f*gd2*r*s + 60*D1**2*f*gd2*s**2 - 60*D1**2*f*gd2*s - 72*D1**2*f*gdd2*r*s - 72*D1**2*f*gdd2*s**2 + 72*D1**2*f*gdd2*s - 90*D1**2*fd**2*r*s - 90*D1**2*fd**2*s**2 + 45*D1**2*fd**2*s + 60*D1**2*fd*g2*r*s + 60*D1**2*fd*g2*s**2 - 144*D1**2*fd*gd2*r*s - 144*D1**2*fd*gd2*s**2 + 72*D1**2*fd*gd2*s - 72*D1**2*fdd*g2*r*s - 72*D1**2*fdd*g2*s**2 + 32*D1*Dd*K*f**2*r*s - 8*D1*Dd*K*f**2*r + 32*D1*Dd*K*f**2*s**2 - 32*D1*Dd*K*f**2*s + 8*D1*Dd*K*f**2 + 80*D1*Dd*K*f*fd*r*s - 30*D1*Dd*K*f*fd*r + 80*D1*Dd*K*f*fd*s**2 - 80*D1*Dd*K*f*fd*s + 20*D1*Dd*K*f*fd + 96*D1*Dd*f**2*r*s - 24*D1*Dd*f**2*r + 96*D1*Dd*f**2*s**2 - 96*D1*Dd*f**2*s + 24*D1*Dd*f**2 - 720*D1*Dd*f*fd*r*s + 90*D1*Dd*f*fd*r - 720*D1*Dd*f*fd*s**2 + 540*D1*Dd*f*fd*s - 45*D1*Dd*f*fd + 240*D1*Dd*f*g2*r*s - 60*D1*Dd*f*g2*r + 240*D1*Dd*f*g2*s**2 - 240*D1*Dd*f*g2*s + 60*D1*Dd*f*g2 - 576*D1*Dd*f*gd2*r*s + 72*D1*Dd*f*gd2*r - 576*D1*Dd*f*gd2*s**2 + 576*D1*Dd*f*gd2*s - 72*D1*Dd*f*gd2 - 576*D1*Dd*fd*g2*r*s + 72*D1*Dd*fd*g2*r - 576*D1*Dd*fd*g2*s**2 + 288*D1*Dd*fd*g2*s + 20*D1*Ddd*K*f**2*r*s - 5*D1*Ddd*K*f**2*r + 20*D1*Ddd*K*f**2*s**2 - 20*D1*Ddd*K*f**2*s + 5*D1*Ddd*K*f**2 - 180*D1*Ddd*f**2*r*s + 45*D1*Ddd*f**2*r - 180*D1*Ddd*f**2*s**2 + 180*D1*Ddd*f**2*s - 45*D1*Ddd*f**2 - 288*D1*Ddd*f*g2*r*s + 72*D1*Ddd*f*g2*r - 288*D1*Ddd*f*g2*s**2 + 288*D1*Ddd*f*g2*s - 72*D1*Ddd*f*g2 + 2*D1*bd1*(D1*(21*f**2*(2*s - 1)*(r + s - 1) + f*(-15*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) - (15*K - 4)*(2*s - 1)*(r + s - 1)) + 9*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 3*Dd*f*(-6*K + 5*f + 3)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 60*Dd**2*K*f**2*r*s - 15*Dd**2*K*f**2*r + 60*Dd**2*K*f**2*s**2 - 60*Dd**2*K*f**2*s + 10*Dd**2*K*f**2 - 540*Dd**2*f**2*r*s + 135*Dd**2*f**2*r - 540*Dd**2*f**2*s**2 + 540*Dd**2*f**2*s - 90*Dd**2*f**2 - 864*Dd**2*f*g2*r*s + 216*Dd**2*f*g2*r - 864*Dd**2*f*g2*s**2 + 864*Dd**2*f*g2*s - 144*Dd**2*f*g2))/(693*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**3*k1**3*st**2*(99*D1**2*bd1**2*f*s*(K - 1)*(2*r + 2*s - 1) - 2*D1*bd1*(D1*(f**3*s*(953*r + 953*s - 552) - 5*f**2*(25*fd*(5*r*(6*s - 1) + 30*s**2 - 26*s + 3) - 33*s*(r*(C + 2) + s*(C + 2) - 3)) - 33*f*(3*fd*(r*(C + 2)*(4*s - 1) + s**2*(4*C + 8) - s*(3*C + 9) + 3) + s*(13*g2*(r + s) + gd2*(-6*r - 6*s + 3))) + 99*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(125*f**2*(5*r*(8*s - 1) + 40*s**2 - 32*s + 3) + 99*f*(r*(C + 2)*(8*s - 1) + s**2*(8*C + 16) - s*(4*C + 20) + 3) - 99*g2*(r*(8*s - 1) + 4*s*(2*s - 1)))) - 33*b1**2*(K - 1)*(D1**2*(13*fd - 3*fdd)*(s - 1)*(r + s - 1) + D1*Dd*(13*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(-2*f**2*(fd*(953*r*(3*s - 1) + 2859*s**2 - 3260*s + 953) - 125*fdd*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5)) + f*(250*fd**2*(10*r*(3*s - 1) + 30*s**2 - 34*s + 7) - 330*fd*(C*(2*s - 1)*(r + s - 1) + r*(4*s - 2) + 4*s**2 - 3*s + 2) + 198*fdd*(C*(2*s - 1)*(r + s - 1) + 4*r*s - 2*r + 4*s**2 - 3*s + 2) + 33*s*(3*bdd1*(K - 1)*(2*r + 2*s - 1) + (26*gd2 - 6*gdd2)*(r + s - 1))) + 198*fd**2*(C*(2*s - 1)*(r + s - 1) + r*(4*s - 2) + 4*s**2 - 3*s - 1) + 66*fd*(13*g2*(s - 1) + gd2*(3 - 6*s))*(r + s - 1) - 198*fdd*g2*(s - 1)*(r + s - 1)) - 2*D1*Dd*(953*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + 5*f**2*(33*C*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 33*f*(3*fd*(C*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 4*r*(8*s - 3) + 32*s**2 - 28*s + 7) + 13*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 3*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 99*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 2*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(625*f**2 + f*(99*C + 198) - 99*g2) + 33*D1*bd1*(K - 1)*(D1*(-13*f*s*(2*r + 2*s - 1) + 3*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 3*Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 2*Dd**2*f*(625*f**2 + f*(99*C + 198) - 99*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 2*f*(D1**2*(125*bdd1*f**2*s*(5*r + 5*s - 3) - 99*bdd1*g2*s*(r + s) - 9*f*(-11*bdd1*s*(r*(C + 2) + s*(C + 2) - 3) + 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 25*fdd*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) + 225*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) - 9*D1*f*(Dd*(39*f*(r*(4*s - 1) + (1 - 2*s)**2) - 25*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 25*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 225*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**3*k1**3*(-690*C*D1**2*f**2*fd*r*s + 230*C*D1**2*f**2*fd*r - 690*C*D1**2*f**2*fd*s**2 + 690*C*D1**2*f**2*fd*s - 230*C*D1**2*f**2*fd + 840*C*D1**2*f**2*fdd*r*s - 280*C*D1**2*f**2*fdd*r + 840*C*D1**2*f**2*fdd*s**2 - 840*C*D1**2*f**2*fdd*s + 280*C*D1**2*f**2*fdd + 1680*C*D1**2*f*fd**2*r*s - 560*C*D1**2*f*fd**2*r + 1680*C*D1**2*f*fd**2*s**2 - 1680*C*D1**2*f*fd**2*s + 280*C*D1**2*f*fd**2 - 920*C*D1*Dd*f**3*r*s + 230*C*D1*Dd*f**3*r - 920*C*D1*Dd*f**3*s**2 + 920*C*D1*Dd*f**3*s - 230*C*D1*Dd*f**3 + 6720*C*D1*Dd*f**2*fd*r*s - 1960*C*D1*Dd*f**2*fd*r + 6720*C*D1*Dd*f**2*fd*s**2 - 6720*C*D1*Dd*f**2*fd*s + 1400*C*D1*Dd*f**2*fd + 1120*C*D1*Ddd*f**3*r*s - 280*C*D1*Ddd*f**3*r + 1120*C*D1*Ddd*f**3*s**2 - 1120*C*D1*Ddd*f**3*s + 280*C*D1*Ddd*f**3 + 3360*C*Dd**2*f**3*r*s - 840*C*Dd**2*f**3*r + 3360*C*Dd**2*f**3*s**2 - 3360*C*Dd**2*f**3*s + 560*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 264*D1**2*b2*f*fd*r*s + 132*D1**2*b2*f*fd*r - 264*D1**2*b2*f*fd*s**2 + 264*D1**2*b2*f*fd*s - 132*D1**2*b2*f*fd + 330*D1**2*b2*f*fdd*r*s - 165*D1**2*b2*f*fdd*r + 330*D1**2*b2*f*fdd*s**2 - 330*D1**2*b2*f*fdd*s + 165*D1**2*b2*f*fdd + 330*D1**2*b2*fd**2*r*s - 165*D1**2*b2*fd**2*r + 330*D1**2*b2*fd**2*s**2 - 330*D1**2*b2*fd**2*s - 33*D1**2*bd1**2*(5*f**2*(r*(8*s - 5) + 8*s**2 - 12*s + 3) + 6*f*(r*(2*C + 1)*(2*s - 1) + (s - 1)*(4*C*s + 2*s - 3)) + 14*g2*(-2*r*s + r - s*(2*s - 2))) - 132*D1**2*bd2*f**2*r*s - 132*D1**2*bd2*f**2*s**2 + 132*D1**2*bd2*f**2*s + 660*D1**2*bd2*f*fd*r*s - 165*D1**2*bd2*f*fd*r + 660*D1**2*bd2*f*fd*s**2 - 660*D1**2*bd2*f*fd*s + 165*D1**2*bd2*f*fd - 495*D1**2*bdd1*f**2*r*s + 495*D1**2*bdd1*f**2*r - 495*D1**2*bdd1*f**2*s**2 + 990*D1**2*bdd1*f**2*s - 495*D1**2*bdd1*f**2 + 165*D1**2*bdd2*f**2*r*s + 165*D1**2*bdd2*f**2*s**2 - 165*D1**2*bdd2*f**2*s - 150*D1**2*f**2*fd*r*s + 50*D1**2*f**2*fd*r - 150*D1**2*f**2*fd*s**2 + 150*D1**2*f**2*fd*s - 50*D1**2*f**2*fd - 420*D1**2*f**2*fdd*r*s + 140*D1**2*f**2*fdd*r - 420*D1**2*f**2*fdd*s**2 + 420*D1**2*f**2*fdd*s - 140*D1**2*f**2*fdd + 264*D1**2*f**2*gd2*r*s + 264*D1**2*f**2*gd2*s**2 - 264*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 840*D1**2*f*fd**2*r*s + 280*D1**2*f*fd**2*r - 840*D1**2*f*fd**2*s**2 + 840*D1**2*f*fd**2*s - 140*D1**2*f*fd**2 + 528*D1**2*f*fd*g2*r*s - 264*D1**2*f*fd*g2*r + 528*D1**2*f*fd*g2*s**2 - 528*D1**2*f*fd*g2*s + 264*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s - 528*D1*Dd*b2*f**2*r*s + 132*D1*Dd*b2*f**2*r - 528*D1*Dd*b2*f**2*s**2 + 528*D1*Dd*b2*f**2*s - 132*D1*Dd*b2*f**2 + 2640*D1*Dd*b2*f*fd*r*s - 990*D1*Dd*b2*f*fd*r + 2640*D1*Dd*b2*f*fd*s**2 - 2640*D1*Dd*b2*f*fd*s + 660*D1*Dd*b2*f*fd + 1320*D1*Dd*bd2*f**2*r*s - 165*D1*Dd*bd2*f**2*r + 1320*D1*Dd*bd2*f**2*s**2 - 1320*D1*Dd*bd2*f**2*s + 165*D1*Dd*bd2*f**2 - 200*D1*Dd*f**3*r*s + 50*D1*Dd*f**3*r - 200*D1*Dd*f**3*s**2 + 200*D1*Dd*f**3*s - 50*D1*Dd*f**3 - 3360*D1*Dd*f**2*fd*r*s + 980*D1*Dd*f**2*fd*r - 3360*D1*Dd*f**2*fd*s**2 + 3360*D1*Dd*f**2*fd*s - 700*D1*Dd*f**2*fd + 1056*D1*Dd*f**2*g2*r*s - 264*D1*Dd*f**2*g2*r + 1056*D1*Dd*f**2*g2*s**2 - 1056*D1*Dd*f**2*g2*s + 264*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 + 660*D1*Ddd*b2*f**2*r*s - 165*D1*Ddd*b2*f**2*r + 660*D1*Ddd*b2*f**2*s**2 - 660*D1*Ddd*b2*f**2*s + 165*D1*Ddd*b2*f**2 - 560*D1*Ddd*f**3*r*s + 140*D1*Ddd*f**3*r - 560*D1*Ddd*f**3*s**2 + 560*D1*Ddd*f**3*s - 140*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 33*D1*bd1*f*(D1*(5*f**2*s*(2*r + 2*s - 1) + 2*f*(s*(2*K - 6) + 9)*(r + s - 1) - 5*fd*(K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3)) - 5*Dd*f*(K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12)) + 1980*Dd**2*b2*f**2*r*s - 495*Dd**2*b2*f**2*r + 1980*Dd**2*b2*f**2*s**2 - 1980*Dd**2*b2*f**2*s + 330*Dd**2*b2*f**2 - 1680*Dd**2*f**3*r*s + 420*Dd**2*f**3*r - 1680*Dd**2*f**3*s**2 + 1680*Dd**2*f**3*s - 280*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 231*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 33*b1**2*(10*C*D1**2*fd*r*s + 10*C*D1**2*fd*s**2 - 10*C*D1**2*fd*s - 12*C*D1**2*fdd*r*s - 12*C*D1**2*fdd*s**2 + 12*C*D1**2*fdd*s + 40*C*D1*Dd*f*r*s - 10*C*D1*Dd*f*r + 40*C*D1*Dd*f*s**2 - 40*C*D1*Dd*f*s + 10*C*D1*Dd*f - 96*C*D1*Dd*fd*r*s + 12*C*D1*Dd*fd*r - 96*C*D1*Dd*fd*s**2 + 96*C*D1*Dd*fd*s - 12*C*D1*Dd*fd - 48*C*D1*Ddd*f*r*s + 12*C*D1*Ddd*f*r - 48*C*D1*Ddd*f*s**2 + 48*C*D1*Ddd*f*s - 12*C*D1*Ddd*f - 144*C*Dd**2*f*r*s + 36*C*Dd**2*f*r - 144*C*Dd**2*f*s**2 + 144*C*Dd**2*f*s - 24*C*Dd**2*f - 7*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) + 56*D1**2*f*fd*r*s + 4*D1**2*f*fd*r + 56*D1**2*f*fd*s**2 - 34*D1**2*f*fd*s - 4*D1**2*f*fd - 40*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r - 40*D1**2*f*fdd*s**2 + 20*D1**2*f*fdd*s + 5*D1**2*f*fdd - 40*D1**2*fd**2*r*s - 5*D1**2*fd**2*r - 40*D1**2*fd**2*s**2 + 20*D1**2*fd**2*s + 5*D1**2*fd**2 + 12*D1**2*fd*r*s + 12*D1**2*fd*s**2 + 10*D1**2*fd*s - 6*D1**2*fdd*r*s - 6*D1**2*fdd*s**2 - 12*D1**2*fdd*s - 28*D1**2*gd2*r*s - 28*D1**2*gd2*s**2 + 28*D1**2*gd2*s + 14*D1**2*gdd2*r*s + 14*D1**2*gdd2*s**2 - 14*D1**2*gdd2*s + 112*D1*Dd*f**2*r*s - 28*D1*Dd*f**2*r + 112*D1*Dd*f**2*s**2 - 112*D1*Dd*f**2*s + 28*D1*Dd*f**2 - 320*D1*Dd*f*fd*r*s + 20*D1*Dd*f*fd*r - 320*D1*Dd*f*fd*s**2 + 240*D1*Dd*f*fd*s - 10*D1*Dd*f*fd + 48*D1*Dd*f*r*s - 12*D1*Dd*f*r + 48*D1*Dd*f*s**2 - 48*D1*Dd*f*s + 12*D1*Dd*f - 48*D1*Dd*fd*r*s + 6*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 - 24*D1*Dd*fd*s + 12*D1*Dd*fd - 112*D1*Dd*g2*r*s + 28*D1*Dd*g2*r - 112*D1*Dd*g2*s**2 + 112*D1*Dd*g2*s - 28*D1*Dd*g2 + 112*D1*Dd*gd2*r*s - 14*D1*Dd*gd2*r + 112*D1*Dd*gd2*s**2 - 112*D1*Dd*gd2*s + 14*D1*Dd*gd2 - 80*D1*Ddd*f**2*r*s + 20*D1*Ddd*f**2*r - 80*D1*Ddd*f**2*s**2 + 80*D1*Ddd*f**2*s - 20*D1*Ddd*f**2 - 24*D1*Ddd*f*r*s + 6*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 24*D1*Ddd*f*s - 6*D1*Ddd*f + 56*D1*Ddd*g2*r*s - 14*D1*Ddd*g2*r + 56*D1*Ddd*g2*s**2 - 56*D1*Ddd*g2*s + 14*D1*Ddd*g2 + 7*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) - 240*Dd**2*f**2*r*s + 60*Dd**2*f**2*r - 240*Dd**2*f**2*s**2 + 240*Dd**2*f**2*s - 40*Dd**2*f**2 - 72*Dd**2*f*r*s + 18*Dd**2*f*r - 72*Dd**2*f*s**2 + 72*Dd**2*f*s - 12*Dd**2*f + 168*Dd**2*g2*r*s - 42*Dd**2*g2*r + 168*Dd**2*g2*s**2 - 168*Dd**2*g2*s + 28*Dd**2*g2) - 33*b1*(8*D1**2*K*f*fd*r*s - 4*D1**2*K*f*fd*r + 8*D1**2*K*f*fd*s**2 - 8*D1**2*K*f*fd*s + 4*D1**2*K*f*fd - 10*D1**2*K*f*fdd*r*s + 5*D1**2*K*f*fdd*r - 10*D1**2*K*f*fdd*s**2 + 10*D1**2*K*f*fdd*s - 5*D1**2*K*f*fdd - 10*D1**2*K*fd**2*r*s + 5*D1**2*K*fd**2*r - 10*D1**2*K*fd**2*s**2 + 10*D1**2*K*fd**2*s + 7*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + D1**2*bdd1*(5*f**2*(r*(8*s - 5) + 8*s**2 - 12*s + 5) + 6*f*(C*(4*r*s - 2*r + 4*s**2 - 4*s + 2) + 2*r*s - r + 2*s**2 - 5*s + 1) - 14*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 30*D1**2*f**2*fd*r*s - 10*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 35*D1**2*f**2*fd*s + 10*D1**2*f**2*fd - 24*D1**2*f*fd*r*s - 6*D1**2*f*fd*r - 24*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s + 6*D1**2*f*fd + 30*D1**2*f*fdd*r*s + 30*D1**2*f*fdd*s**2 - 15*D1**2*f*fdd*s + 30*D1**2*fd**2*r*s + 30*D1**2*fd**2*s**2 - 15*D1**2*fd**2*s + 16*D1*Dd*K*f**2*r*s - 4*D1*Dd*K*f**2*r + 16*D1*Dd*K*f**2*s**2 - 16*D1*Dd*K*f**2*s + 4*D1*Dd*K*f**2 - 80*D1*Dd*K*f*fd*r*s + 30*D1*Dd*K*f*fd*r - 80*D1*Dd*K*f*fd*s**2 + 80*D1*Dd*K*f*fd*s - 20*D1*Dd*K*f*fd + 40*D1*Dd*f**3*r*s - 10*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 40*D1*Dd*f**3*s + 10*D1*Dd*f**3 - 48*D1*Dd*f**2*r*s + 12*D1*Dd*f**2*r - 48*D1*Dd*f**2*s**2 + 48*D1*Dd*f**2*s - 12*D1*Dd*f**2 + 240*D1*Dd*f*fd*r*s - 30*D1*Dd*f*fd*r + 240*D1*Dd*f*fd*s**2 - 180*D1*Dd*f*fd*s + 15*D1*Dd*f*fd - 20*D1*Ddd*K*f**2*r*s + 5*D1*Ddd*K*f**2*r - 20*D1*Ddd*K*f**2*s**2 + 20*D1*Ddd*K*f**2*s - 5*D1*Ddd*K*f**2 + 60*D1*Ddd*f**2*r*s - 15*D1*Ddd*f**2*r + 60*D1*Ddd*f**2*s**2 - 60*D1*Ddd*f**2*s + 15*D1*Ddd*f**2 - 2*D1*bd1*(D1*(f**2*(4*r*(7*s - 4) + 28*s**2 - 39*s + 16) + f*(5*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 5*fd*(4*s - 1)*(4*r + 4*s - 3) + 12*r*s - 6*r + 12*s**2 - 23*s + 6) - 3*fd*(C*r*(8*s - 2) + 2*C*(1 - 2*s)**2 + r*(4*s - 1) + 4*s**2 - s - 2) - 7*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 7*gd2*(-4*r*s + r - (1 - 2*s)**2)) - Dd*(5*f**2*(2*r*(16*s - 7) + 32*s**2 - 40*s + 11) + 3*f*(4*C*r*(8*s - 3) + 8*C*(1 - 2*s)**2 + 2*r*(8*s - 3) + 16*s**2 - 28*s + 7) - 14*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 60*Dd**2*K*f**2*r*s + 15*Dd**2*K*f**2*r - 60*Dd**2*K*f**2*s**2 + 60*Dd**2*K*f**2*s - 10*Dd**2*K*f**2 + 180*Dd**2*f**2*r*s - 45*Dd**2*f**2*r + 180*Dd**2*f**2*s**2 - 180*Dd**2*f**2*s + 30*Dd**2*f**2))/(693*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct**3*k1*k2**4*st**2*(132*C*D1**2*bdd1*f**2*r*s - 132*C*D1**2*bdd1*f**2*r + 132*C*D1**2*bdd1*f**2*s**2 - 264*C*D1**2*bdd1*f**2*s + 132*C*D1**2*bdd1*f**2 - 906*C*D1**2*f**2*fd*r*s + 302*C*D1**2*f**2*fd*r - 906*C*D1**2*f**2*fd*s**2 + 906*C*D1**2*f**2*fd*s - 302*C*D1**2*f**2*fd + 750*C*D1**2*f**2*fdd*r*s - 250*C*D1**2*f**2*fdd*r + 750*C*D1**2*f**2*fdd*s**2 - 750*C*D1**2*f**2*fdd*s + 250*C*D1**2*f**2*fdd + 1500*C*D1**2*f*fd**2*r*s - 500*C*D1**2*f*fd**2*r + 1500*C*D1**2*f*fd**2*s**2 - 1500*C*D1**2*f*fd**2*s + 250*C*D1**2*f*fd**2 - 1208*C*D1*Dd*f**3*r*s + 302*C*D1*Dd*f**3*r - 1208*C*D1*Dd*f**3*s**2 + 1208*C*D1*Dd*f**3*s - 302*C*D1*Dd*f**3 + 6000*C*D1*Dd*f**2*fd*r*s - 1750*C*D1*Dd*f**2*fd*r + 6000*C*D1*Dd*f**2*fd*s**2 - 6000*C*D1*Dd*f**2*fd*s + 1250*C*D1*Dd*f**2*fd + 1000*C*D1*Ddd*f**3*r*s - 250*C*D1*Ddd*f**3*r + 1000*C*D1*Ddd*f**3*s**2 - 1000*C*D1*Ddd*f**3*s + 250*C*D1*Ddd*f**3 + 3000*C*Dd**2*f**3*r*s - 750*C*Dd**2*f**3*r + 3000*C*Dd**2*f**3*s**2 - 3000*C*Dd**2*f**3*s + 500*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 11*D1**2*bd1**2*f*(2*s - 1)*(-6*K + 5*f + 3)*(r + s - 1) - 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*r - 99*D1**2*bdd1*f**2*s**2 + 198*D1**2*bdd1*f**2*s - 99*D1**2*bdd1*f**2 - 132*D1**2*bdd1*f*g2*r*s + 132*D1**2*bdd1*f*g2*r - 132*D1**2*bdd1*f*g2*s**2 + 264*D1**2*bdd1*f*g2*s - 132*D1**2*bdd1*f*g2 + 354*D1**2*f**2*fd*r*s - 118*D1**2*f**2*fd*r + 354*D1**2*f**2*fd*s**2 - 354*D1**2*f**2*fd*s + 118*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r*s + 125*D1**2*f**2*fdd*r - 375*D1**2*f**2*fdd*s**2 + 375*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd + 462*D1**2*f**2*gd2*r*s + 462*D1**2*f**2*gd2*s**2 - 462*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 750*D1**2*f*fd**2*r*s + 250*D1**2*f*fd**2*r - 750*D1**2*f*fd**2*s**2 + 750*D1**2*f*fd**2*s - 125*D1**2*f*fd**2 + 924*D1**2*f*fd*g2*r*s - 462*D1**2*f*fd*g2*r + 924*D1**2*f*fd*g2*s**2 - 924*D1**2*f*fd*g2*s + 462*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s + 472*D1*Dd*f**3*r*s - 118*D1*Dd*f**3*r + 472*D1*Dd*f**3*s**2 - 472*D1*Dd*f**3*s + 118*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r*s + 875*D1*Dd*f**2*fd*r - 3000*D1*Dd*f**2*fd*s**2 + 3000*D1*Dd*f**2*fd*s - 625*D1*Dd*f**2*fd + 1848*D1*Dd*f**2*g2*r*s - 462*D1*Dd*f**2*g2*r + 1848*D1*Dd*f**2*g2*s**2 - 1848*D1*Dd*f**2*g2*s + 462*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 - 500*D1*Ddd*f**3*r*s + 125*D1*Ddd*f**3*r - 500*D1*Ddd*f**3*s**2 + 500*D1*Ddd*f**3*s - 125*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + 3*f**2*(r + s - 1)*(8*C*(s - 1) + s*(7*K - 5) + 6) - 3*f*(fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 5*K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + (4*r + 4*s - 4)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 5*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 4*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 1500*Dd**2*f**3*r*s + 375*Dd**2*f**3*r - 1500*Dd**2*f**3*s**2 + 1500*Dd**2*f**3*s - 250*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 + 11*b1**2*(D1**2*s*(5*f*(2*fd - fdd)*(2*r + 2*s - 1) - 5*fd**2*(2*r + 2*s - 1) - 6*fd*(2*K - 1)*(r + s) + 3*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (6 - 12*K)*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-6*K + 5*f + 3)) - Dd**2*f*(-6*K + 5*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(-48*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s + 24*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*s**2 - 12*C*D1**2*f*fdd*s + 24*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*s**2 - 12*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r*s - 24*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 144*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 42*D1**2*K*f*fd*r*s + 21*D1**2*K*f*fd*r - 42*D1**2*K*f*fd*s**2 + 42*D1**2*K*f*fd*s - 21*D1**2*K*f*fd + 30*D1**2*K*f*fdd*r*s - 15*D1**2*K*f*fdd*r + 30*D1**2*K*f*fdd*s**2 - 30*D1**2*K*f*fdd*s + 15*D1**2*K*f*fdd + 30*D1**2*K*fd**2*r*s - 15*D1**2*K*fd**2*r + 30*D1**2*K*fd**2*s**2 - 30*D1**2*K*fd**2*s - D1**2*bdd1*f*(2*s - 1)*(-6*K + 5*f + 3)*(r + s - 1) - 15*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r - 15*D1**2*f**2*fd*s**2 + 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd + 30*D1**2*f*fd*r*s + 3*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 12*D1**2*f*fd*s - 3*D1**2*f*fd - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s + 24*D1**2*f*gd2*r*s + 24*D1**2*f*gd2*s**2 - 24*D1**2*f*gd2*s - 12*D1**2*f*gdd2*r*s - 12*D1**2*f*gdd2*s**2 + 12*D1**2*f*gdd2*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 24*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*s**2 + 12*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 84*D1*Dd*K*f**2*r*s + 21*D1*Dd*K*f**2*r - 84*D1*Dd*K*f**2*s**2 + 84*D1*Dd*K*f**2*s - 21*D1*Dd*K*f**2 + 240*D1*Dd*K*f*fd*r*s - 90*D1*Dd*K*f*fd*r + 240*D1*Dd*K*f*fd*s**2 - 240*D1*Dd*K*f*fd*s + 60*D1*Dd*K*f*fd - 20*D1*Dd*f**3*r*s + 5*D1*Dd*f**3*r - 20*D1*Dd*f**3*s**2 + 20*D1*Dd*f**3*s - 5*D1*Dd*f**3 + 60*D1*Dd*f**2*r*s - 15*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 60*D1*Dd*f**2*s + 15*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 108*D1*Dd*f*fd*s - 9*D1*Dd*f*fd + 96*D1*Dd*f*g2*r*s - 24*D1*Dd*f*g2*r + 96*D1*Dd*f*g2*s**2 - 96*D1*Dd*f*g2*s + 24*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r*s + 12*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 96*D1*Dd*f*gd2*s - 12*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r*s + 12*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 48*D1*Dd*fd*g2*s + 60*D1*Ddd*K*f**2*r*s - 15*D1*Ddd*K*f**2*r + 60*D1*Ddd*K*f**2*s**2 - 60*D1*Ddd*K*f**2*s + 15*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r*s + 12*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 48*D1*Ddd*f*g2*s - 12*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(2*s - 1)*(r + s - 1) + f*(-5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (6 - 12*K)*(2*s - 1)*(r + s - 1)) + 3*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-6*K + 5*f + 3)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 180*Dd**2*K*f**2*r*s - 45*Dd**2*K*f**2*r + 180*Dd**2*K*f**2*s**2 - 180*Dd**2*K*f**2*s + 30*Dd**2*K*f**2 - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2 - 144*Dd**2*f*g2*r*s + 36*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 144*Dd**2*f*g2*s - 24*Dd**2*f*g2))/(231*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**3*k1*k2**4*(D1*(-18*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 3*bd1*(D1*(2*f**2*(r + s - 1)*(4*C*(s - 1) - s*(2*K + 1) + 1) + f*(-fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (-5*g2*(s - 1) + 6*gd2*(2*s - 1))*(2*r + 2*s - 2)) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + f*(-3*D1*bdd1*(s - 1)*(f*(10*C - 5) - 12*g2)*(r + s - 1) + 2*D1*(f*(-fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 12*gd2*s*(r + s - 1)) + 12*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 2*Dd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**2*(D1**2*s*(6*f*fd*(2*r + 2*s - 1) + (r + s)*(-18*K*fdd + fd*(15*K + 7))) + D1*(Dd*(-18*K*fd*(r*(8*s - 1) + 4*s*(2*s - 1)) + 6*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(15*K + 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 18*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(3*D1**2*(-6*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(-4*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(8*C - 2)*(2*r + 2*s - 1) + s*(-fdd*(10*C - 5)*(2*r + 2*s - 1) + (-10*gd2 + 12*gdd2)*(r + s - 1))) + s*(-fd**2*(10*C - 5)*(2*r + 2*s - 1) + 2*fd*(-5*g2*(r + s) + 6*gd2*(2*r + 2*s - 1)) + 12*fdd*g2*(r + s))) + D1*bd1*(D1*(18*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 6*f**2*(2*s - 1)*(r + s - 1) + f*(15*K + 7)*(2*s - 1)*(r + s - 1)) - 18*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 3*D1*(Dd*(2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(4*C - 2*K - 1) + f*(-fd*(10*C - 5)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 10*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 12*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 12*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(f*(10*C - 5) - 12*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**3*k1*k2**2*st**2*(-132*C*D1**2*bdd1*f**2*r*s - 132*C*D1**2*bdd1*f**2*s**2 - 1302*C*D1**2*f**2*fd*r*s + 434*C*D1**2*f**2*fd*r - 1302*C*D1**2*f**2*fd*s**2 + 1302*C*D1**2*f**2*fd*s - 434*C*D1**2*f**2*fd + 750*C*D1**2*f**2*fdd*r*s - 250*C*D1**2*f**2*fdd*r + 750*C*D1**2*f**2*fdd*s**2 - 750*C*D1**2*f**2*fdd*s + 250*C*D1**2*f**2*fdd + 1500*C*D1**2*f*fd**2*r*s - 500*C*D1**2*f*fd**2*r + 1500*C*D1**2*f*fd**2*s**2 - 1500*C*D1**2*f*fd**2*s + 250*C*D1**2*f*fd**2 - 1736*C*D1*Dd*f**3*r*s + 434*C*D1*Dd*f**3*r - 1736*C*D1*Dd*f**3*s**2 + 1736*C*D1*Dd*f**3*s - 434*C*D1*Dd*f**3 + 6000*C*D1*Dd*f**2*fd*r*s - 1750*C*D1*Dd*f**2*fd*r + 6000*C*D1*Dd*f**2*fd*s**2 - 6000*C*D1*Dd*f**2*fd*s + 1250*C*D1*Dd*f**2*fd + 1000*C*D1*Ddd*f**3*r*s - 250*C*D1*Ddd*f**3*r + 1000*C*D1*Ddd*f**3*s**2 - 1000*C*D1*Ddd*f**3*s + 250*C*D1*Ddd*f**3 + 3000*C*Dd**2*f**3*r*s - 750*C*Dd**2*f**3*r + 3000*C*Dd**2*f**3*s**2 - 3000*C*Dd**2*f**3*s + 500*C*Dd**2*f**3 + 165*D1**2*K*bdd1*f**2*r*s + 165*D1**2*K*bdd1*f**2*s**2 - 165*D1**2*K*bdd1*f**2*s - 594*D1**2*b2*f*fd*r*s + 297*D1**2*b2*f*fd*r - 594*D1**2*b2*f*fd*s**2 + 594*D1**2*b2*f*fd*s - 297*D1**2*b2*f*fd + 330*D1**2*b2*f*fdd*r*s - 165*D1**2*b2*f*fdd*r + 330*D1**2*b2*f*fdd*s**2 - 330*D1**2*b2*f*fdd*s + 165*D1**2*b2*f*fdd + 330*D1**2*b2*fd**2*r*s - 165*D1**2*b2*fd**2*r + 330*D1**2*b2*fd**2*s**2 - 330*D1**2*b2*fd**2*s + 11*D1**2*bd1**2*f*(-12*K*r*s + 5*f*(r + 2*s - 1) + 3*r - 3*(2*s - 1)*(2*K*s - 1)) - 297*D1**2*bd2*f**2*r*s - 297*D1**2*bd2*f**2*s**2 + 297*D1**2*bd2*f**2*s + 660*D1**2*bd2*f*fd*r*s - 165*D1**2*bd2*f*fd*r + 660*D1**2*bd2*f*fd*s**2 - 660*D1**2*bd2*f*fd*s + 165*D1**2*bd2*f*fd + 66*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*r + 66*D1**2*bdd1*f**2*s**2 + 66*D1**2*bdd1*f**2*s - 33*D1**2*bdd1*f**2 + 132*D1**2*bdd1*f*g2*r*s + 132*D1**2*bdd1*f*g2*s**2 + 165*D1**2*bdd2*f**2*r*s + 165*D1**2*bdd2*f**2*s**2 - 165*D1**2*bdd2*f**2*s + 552*D1**2*f**2*fd*r*s - 184*D1**2*f**2*fd*r + 552*D1**2*f**2*fd*s**2 - 552*D1**2*f**2*fd*s + 184*D1**2*f**2*fd - 375*D1**2*f**2*fdd*r*s + 125*D1**2*f**2*fdd*r - 375*D1**2*f**2*fdd*s**2 + 375*D1**2*f**2*fdd*s - 125*D1**2*f**2*fdd + 594*D1**2*f**2*gd2*r*s + 594*D1**2*f**2*gd2*s**2 - 594*D1**2*f**2*gd2*s - 330*D1**2*f**2*gdd2*r*s - 330*D1**2*f**2*gdd2*s**2 + 330*D1**2*f**2*gdd2*s - 750*D1**2*f*fd**2*r*s + 250*D1**2*f*fd**2*r - 750*D1**2*f*fd**2*s**2 + 750*D1**2*f*fd**2*s - 125*D1**2*f*fd**2 + 1188*D1**2*f*fd*g2*r*s - 594*D1**2*f*fd*g2*r + 1188*D1**2*f*fd*g2*s**2 - 1188*D1**2*f*fd*g2*s + 594*D1**2*f*fd*g2 - 1320*D1**2*f*fd*gd2*r*s + 330*D1**2*f*fd*gd2*r - 1320*D1**2*f*fd*gd2*s**2 + 1320*D1**2*f*fd*gd2*s - 330*D1**2*f*fd*gd2 - 660*D1**2*f*fdd*g2*r*s + 330*D1**2*f*fdd*g2*r - 660*D1**2*f*fdd*g2*s**2 + 660*D1**2*f*fdd*g2*s - 330*D1**2*f*fdd*g2 - 660*D1**2*fd**2*g2*r*s + 330*D1**2*fd**2*g2*r - 660*D1**2*fd**2*g2*s**2 + 660*D1**2*fd**2*g2*s - 1188*D1*Dd*b2*f**2*r*s + 297*D1*Dd*b2*f**2*r - 1188*D1*Dd*b2*f**2*s**2 + 1188*D1*Dd*b2*f**2*s - 297*D1*Dd*b2*f**2 + 2640*D1*Dd*b2*f*fd*r*s - 990*D1*Dd*b2*f*fd*r + 2640*D1*Dd*b2*f*fd*s**2 - 2640*D1*Dd*b2*f*fd*s + 660*D1*Dd*b2*f*fd + 1320*D1*Dd*bd2*f**2*r*s - 165*D1*Dd*bd2*f**2*r + 1320*D1*Dd*bd2*f**2*s**2 - 1320*D1*Dd*bd2*f**2*s + 165*D1*Dd*bd2*f**2 + 736*D1*Dd*f**3*r*s - 184*D1*Dd*f**3*r + 736*D1*Dd*f**3*s**2 - 736*D1*Dd*f**3*s + 184*D1*Dd*f**3 - 3000*D1*Dd*f**2*fd*r*s + 875*D1*Dd*f**2*fd*r - 3000*D1*Dd*f**2*fd*s**2 + 3000*D1*Dd*f**2*fd*s - 625*D1*Dd*f**2*fd + 2376*D1*Dd*f**2*g2*r*s - 594*D1*Dd*f**2*g2*r + 2376*D1*Dd*f**2*g2*s**2 - 2376*D1*Dd*f**2*g2*s + 594*D1*Dd*f**2*g2 - 2640*D1*Dd*f**2*gd2*r*s + 330*D1*Dd*f**2*gd2*r - 2640*D1*Dd*f**2*gd2*s**2 + 2640*D1*Dd*f**2*gd2*s - 330*D1*Dd*f**2*gd2 - 5280*D1*Dd*f*fd*g2*r*s + 1980*D1*Dd*f*fd*g2*r - 5280*D1*Dd*f*fd*g2*s**2 + 5280*D1*Dd*f*fd*g2*s - 1320*D1*Dd*f*fd*g2 + 660*D1*Ddd*b2*f**2*r*s - 165*D1*Ddd*b2*f**2*r + 660*D1*Ddd*b2*f**2*s**2 - 660*D1*Ddd*b2*f**2*s + 165*D1*Ddd*b2*f**2 - 500*D1*Ddd*f**3*r*s + 125*D1*Ddd*f**3*r - 500*D1*Ddd*f**3*s**2 + 500*D1*Ddd*f**3*s - 125*D1*Ddd*f**3 - 1320*D1*Ddd*f**2*g2*r*s + 330*D1*Ddd*f**2*g2*r - 1320*D1*Ddd*f**2*g2*s**2 + 1320*D1*Ddd*f**2*g2*s - 330*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(5*f**3*s*(r + s - 1) + 3*f**2*(r*(s*(-8*C + 9*K + 5) + 2) + s**2*(-8*C + 9*K + 5) + s*(3 - 9*K) - 2) - 3*f*(fd*(-16*C*s**2 + 12*C*s + 5*K*(r*(4*s - 1) + (1 - 2*s)**2) + r*(-16*C*s + 4*C + 8*s - 1) + 8*s**2 - 4*s - 1) + 4*s*(-2*g2*(r + s) + gd2*(2*r + 2*s - 1))) + 12*fd*g2*(-2*r*s + r - s*(2*s - 2))) - 3*Dd*f*(5*K*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 2*f*(-16*C*r*s + 2*C*r - 16*C*s**2 + 8*C*s + 8*r*s + r + 8*s**2 - 2) + 4*g2*r*(8*s - 1) + 16*g2*s*(2*s - 1))) + 1980*Dd**2*b2*f**2*r*s - 495*Dd**2*b2*f**2*r + 1980*Dd**2*b2*f**2*s**2 - 1980*Dd**2*b2*f**2*s + 330*Dd**2*b2*f**2 - 1500*Dd**2*f**3*r*s + 375*Dd**2*f**3*r - 1500*Dd**2*f**3*s**2 + 1500*Dd**2*f**3*s - 250*Dd**2*f**3 - 3960*Dd**2*f**2*g2*r*s + 990*Dd**2*f**2*g2*r - 3960*Dd**2*f**2*g2*s**2 + 3960*Dd**2*f**2*g2*s - 660*Dd**2*f**2*g2 - 11*b1**2*(D1**2*(5*fd**2*(r + 2*s - 1) - 2*fd*(6*K*(s - 1)*(r + s - 1) + 5*f*(r + 2*s - 1) + 3*r + 6*s - 3) + fdd*(6*K*(s - 1)*(r + s - 1) + 5*f*(r + 2*s - 1) + 3*r + 6*s - 3)) + 2*D1*(Dd*(-6*K*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(3*K*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 10*f*(r + 2*s - 1) + 6*r + 12*s - 6)) + 3*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 11*b1*(-48*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r - 48*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 24*C*D1**2*f*fdd*r*s - 12*C*D1**2*f*fdd*r + 24*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 24*C*D1**2*fd**2*r*s - 12*C*D1**2*fd**2*r + 24*C*D1**2*fd**2*s**2 - 36*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r*s - 72*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 + 54*D1**2*K*f*fd*r*s - 27*D1**2*K*f*fd*r + 54*D1**2*K*f*fd*s**2 - 54*D1**2*K*f*fd*s + 27*D1**2*K*f*fd - 30*D1**2*K*f*fdd*r*s + 15*D1**2*K*f*fdd*r - 30*D1**2*K*f*fdd*s**2 + 30*D1**2*K*f*fdd*s - 15*D1**2*K*f*fdd - 30*D1**2*K*fd**2*r*s + 15*D1**2*K*fd**2*r - 30*D1**2*K*fd**2*s**2 + 30*D1**2*K*fd**2*s + D1**2*bdd1*f*(-5*f*(r + 2*s - 1) + 3*r*(4*K*s - 1) + (6*s - 3)*(2*K*s - 1)) + 15*D1**2*f**2*fd*r*s - 5*D1**2*f**2*fd*r + 15*D1**2*f**2*fd*s**2 - 15*D1**2*f**2*fd*s + 5*D1**2*f**2*fd + 30*D1**2*f*fd*r*s - 21*D1**2*f*fd*r + 30*D1**2*f*fd*s**2 - 54*D1**2*f*fd*s + 21*D1**2*f*fd - 12*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r - 12*D1**2*f*fdd*s**2 + 24*D1**2*f*fdd*s - 9*D1**2*f*fdd + 24*D1**2*f*gd2*r*s + 24*D1**2*f*gd2*s**2 - 24*D1**2*f*gd2*s - 12*D1**2*f*gdd2*r*s - 12*D1**2*f*gdd2*s**2 + 12*D1**2*f*gdd2*s - 12*D1**2*fd**2*r*s + 9*D1**2*fd**2*r - 12*D1**2*fd**2*s**2 + 24*D1**2*fd**2*s - 9*D1**2*fd**2 + 24*D1**2*fd*g2*r*s - 24*D1**2*fd*g2*r + 24*D1**2*fd*g2*s**2 - 48*D1**2*fd*g2*s + 24*D1**2*fd*g2 - 24*D1**2*fd*gd2*r*s + 12*D1**2*fd*gd2*r - 24*D1**2*fd*gd2*s**2 + 36*D1**2*fd*gd2*s - 12*D1**2*fd*gd2 - 12*D1**2*fdd*g2*r*s + 12*D1**2*fdd*g2*r - 12*D1**2*fdd*g2*s**2 + 24*D1**2*fdd*g2*s - 12*D1**2*fdd*g2 + 108*D1*Dd*K*f**2*r*s - 27*D1*Dd*K*f**2*r + 108*D1*Dd*K*f**2*s**2 - 108*D1*Dd*K*f**2*s + 27*D1*Dd*K*f**2 - 240*D1*Dd*K*f*fd*r*s + 90*D1*Dd*K*f*fd*r - 240*D1*Dd*K*f*fd*s**2 + 240*D1*Dd*K*f*fd*s - 60*D1*Dd*K*f*fd + 20*D1*Dd*f**3*r*s - 5*D1*Dd*f**3*r + 20*D1*Dd*f**3*s**2 - 20*D1*Dd*f**3*s + 5*D1*Dd*f**3 + 60*D1*Dd*f**2*r*s - 15*D1*Dd*f**2*r + 60*D1*Dd*f**2*s**2 - 60*D1*Dd*f**2*s + 15*D1*Dd*f**2 - 96*D1*Dd*f*fd*r*s + 48*D1*Dd*f*fd*r - 96*D1*Dd*f*fd*s**2 + 144*D1*Dd*f*fd*s - 42*D1*Dd*f*fd + 96*D1*Dd*f*g2*r*s - 24*D1*Dd*f*g2*r + 96*D1*Dd*f*g2*s**2 - 96*D1*Dd*f*g2*s + 24*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r*s + 12*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 96*D1*Dd*f*gd2*s - 12*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r*s + 60*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s - 48*D1*Dd*fd*g2 - 60*D1*Ddd*K*f**2*r*s + 15*D1*Ddd*K*f**2*r - 60*D1*Ddd*K*f**2*s**2 + 60*D1*Ddd*K*f**2*s - 15*D1*Ddd*K*f**2 - 24*D1*Ddd*f**2*r*s + 6*D1*Ddd*f**2*r - 24*D1*Ddd*f**2*s**2 + 24*D1*Ddd*f**2*s - 6*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r*s + 12*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 48*D1*Ddd*f*g2*s - 12*D1*Ddd*f*g2 + D1*bd1*(D1*(10*f**2*(r + 2*s - 1) - 6*f*(r*(4*K*s - 1) + (2*s - 1)*(2*K*s - 1)) + 3*fd*(2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + r + 2*s - 1)) - 2*Dd*f*(K*(r*(6 - 48*s) - 48*s**2 + 36*s - 3) + 10*f*(r + 2*s - 1) + 6*r + 12*s - 6)) - 180*Dd**2*K*f**2*r*s + 45*Dd**2*K*f**2*r - 180*Dd**2*K*f**2*s**2 + 180*Dd**2*K*f**2*s - 30*Dd**2*K*f**2 - 72*Dd**2*f**2*r*s + 18*Dd**2*f**2*r - 72*Dd**2*f**2*s**2 + 72*Dd**2*f**2*s - 12*Dd**2*f**2 - 144*Dd**2*f*g2*r*s + 36*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 144*Dd**2*f*g2*s - 24*Dd**2*f*g2))/(231*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct**3*k1*k2**2*(D1*(-2*D1*bd1**2*(3*K*f*(r*(4*s - 3) + 4*s**2 - 8*s + 3) - f*(12*C - 9)*(r*(2*s - 1) + s*(2*s - 2)) + 14*g2*r*(2*s - 1) + 28*g2*s*(s - 1)) + b2*(bd1*(D1*(29*f*(s - 1)*(r + s - 1) + 18*fd*(-2*r*s + r - s*(2*s - 2))) - 18*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 6*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + 2*D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + bd1*(-18*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(2*f**2*(8*C*(r*(4*s - 3) + 4*s**2 - 6*s + 3) - 6*K*s**2 + 6*K*s + r*(-s*(6*K + 16) + 9) - 16*s**2 + 18*s - 9) + f*(-fd*(10*C - 5)*(r*(8*s - 5) + 8*s**2 - 12*s + 3) - 2*g2*(38*r*s - 29*r + 38*s**2 - 58*s + 29) + 12*gd2*(4*r*s - 3*r + 4*s**2 - 8*s + 3)) + 24*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 2*Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 7) + 8*s**2 - 16*s + 6)) + f*(-D1*bdd1*(f*(10*C - 5) - 12*g2)*(r*(2*s - 3) + 2*s**2 - 6*s + 3) - 2*D1*(f*(fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(6*bd2 - 12*gd2)*(r + s - 1)) - 12*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 2*Dd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**3*(6*D1**2*s*(2*fd - fdd)*(r + s - 1) + 2*D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - (14*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 6*f + 7) - Dd**2*(-14*K + 6*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-48*C*D1**2*fd*r*s - 48*C*D1**2*fd*s**2 + 48*C*D1**2*fd*s + 24*C*D1**2*fdd*r*s + 24*C*D1**2*fdd*s**2 - 24*C*D1**2*fdd*s - 192*C*D1*Dd*f*r*s + 48*C*D1*Dd*f*r - 192*C*D1*Dd*f*s**2 + 192*C*D1*Dd*f*s - 48*C*D1*Dd*f + 192*C*D1*Dd*fd*r*s - 24*C*D1*Dd*fd*r + 192*C*D1*Dd*fd*s**2 - 192*C*D1*Dd*fd*s + 24*C*D1*Dd*fd + 96*C*D1*Ddd*f*r*s - 24*C*D1*Ddd*f*r + 96*C*D1*Ddd*f*s**2 - 96*C*D1*Ddd*f*s + 24*C*D1*Ddd*f + 288*C*Dd**2*f*r*s - 72*C*Dd**2*f*r + 288*C*Dd**2*f*s**2 - 288*C*Dd**2*f*s + 48*C*Dd**2*f + 38*D1**2*K*fd*r*s - 9*D1**2*K*fd*r + 38*D1**2*K*fd*s**2 - 18*D1**2*K*fd*s + 9*D1**2*K*fd - 12*D1**2*K*fdd*r*s - 6*D1**2*K*fdd*r - 12*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - D1**2*bdd1*(-14*K + 6*f + 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 6*D1**2*f*fd*r + 12*D1**2*f*fd*s - 6*D1**2*f*fd + 36*D1**2*fd*r*s + 7*D1**2*fd*r + 36*D1**2*fd*s**2 - 22*D1**2*fd*s - 7*D1**2*fd - 18*D1**2*fdd*r*s - 18*D1**2*fdd*s**2 + 18*D1**2*fdd*s + 56*D1**2*gd2*r*s + 56*D1**2*gd2*s**2 - 56*D1**2*gd2*s - 28*D1**2*gdd2*r*s - 28*D1**2*gdd2*s**2 + 28*D1**2*gdd2*s + 152*D1*Dd*K*f*r*s - 38*D1*Dd*K*f*r + 152*D1*Dd*K*f*s**2 - 152*D1*Dd*K*f*s + 38*D1*Dd*K*f - 96*D1*Dd*K*fd*r*s - 12*D1*Dd*K*fd*r - 96*D1*Dd*K*fd*s**2 + 24*D1*Dd*K*fd + 144*D1*Dd*f*r*s - 36*D1*Dd*f*r + 144*D1*Dd*f*s**2 - 144*D1*Dd*f*s + 36*D1*Dd*f - 144*D1*Dd*fd*r*s + 18*D1*Dd*fd*r - 144*D1*Dd*fd*s**2 + 144*D1*Dd*fd*s - 18*D1*Dd*fd + 224*D1*Dd*g2*r*s - 56*D1*Dd*g2*r + 224*D1*Dd*g2*s**2 - 224*D1*Dd*g2*s + 56*D1*Dd*g2 - 224*D1*Dd*gd2*r*s + 28*D1*Dd*gd2*r - 224*D1*Dd*gd2*s**2 + 224*D1*Dd*gd2*s - 28*D1*Dd*gd2 - 48*D1*Ddd*K*f*r*s + 12*D1*Ddd*K*f*r - 48*D1*Ddd*K*f*s**2 + 48*D1*Ddd*K*f*s - 12*D1*Ddd*K*f - 72*D1*Ddd*f*r*s + 18*D1*Ddd*f*r - 72*D1*Ddd*f*s**2 + 72*D1*Ddd*f*s - 18*D1*Ddd*f - 112*D1*Ddd*g2*r*s + 28*D1*Ddd*g2*r - 112*D1*Ddd*g2*s**2 + 112*D1*Ddd*g2*s - 28*D1*Ddd*g2 + D1*bd1*(2*D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + (7 - 14*K)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(-14*K + 6*f + 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 144*Dd**2*K*f*r*s + 36*Dd**2*K*f*r - 144*Dd**2*K*f*s**2 + 144*Dd**2*K*f*s - 24*Dd**2*K*f - 216*Dd**2*f*r*s + 54*Dd**2*f*r - 216*Dd**2*f*s**2 + 216*Dd**2*f*s - 36*Dd**2*f - 336*Dd**2*g2*r*s + 84*Dd**2*g2*r - 336*Dd**2*g2*s**2 + 336*Dd**2*g2*s - 56*Dd**2*g2) + b1*(128*C*D1**2*f*fd*r*s - 16*C*D1**2*f*fd*r + 128*C*D1**2*f*fd*s**2 - 96*C*D1**2*f*fd*s + 16*C*D1**2*f*fd - 40*C*D1**2*f*fdd*r*s - 10*C*D1**2*f*fdd*r - 40*C*D1**2*f*fdd*s**2 + 10*C*D1**2*f*fdd - 40*C*D1**2*fd**2*r*s - 10*C*D1**2*fd**2*r - 40*C*D1**2*fd**2*s**2 + 10*C*D1**2*fd**2 + 256*C*D1*Dd*f**2*r*s - 64*C*D1*Dd*f**2*r + 256*C*D1*Dd*f**2*s**2 - 256*C*D1*Dd*f**2*s + 64*C*D1*Dd*f**2 - 320*C*D1*Dd*f*fd*r*s - 320*C*D1*Dd*f*fd*s**2 + 160*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd - 80*C*D1*Ddd*f**2*r*s + 20*C*D1*Ddd*f**2*r - 80*C*D1*Ddd*f**2*s**2 + 80*C*D1*Ddd*f**2*s - 20*C*D1*Ddd*f**2 - 240*C*Dd**2*f**2*r*s + 60*C*Dd**2*f**2*r - 240*C*Dd**2*f**2*s**2 + 240*C*Dd**2*f**2*s - 40*C*Dd**2*f**2 - 24*D1**2*K*f*fd*r*s + 12*D1**2*K*f*fd*r - 24*D1**2*K*f*fd*s**2 + 24*D1**2*K*f*fd*s - 12*D1**2*K*f*fd + 29*D1**2*b2*fd*r*s + 29*D1**2*b2*fd*s**2 - 18*D1**2*b2*fdd*r*s - 18*D1**2*b2*fdd*s**2 - D1**2*bd1**2*(-14*K + 6*f + 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 29*D1**2*bd2*f*r*s + 29*D1**2*bd2*f*s**2 - 29*D1**2*bd2*f*s - 36*D1**2*bd2*fd*r*s - 36*D1**2*bd2*fd*s**2 + 18*D1**2*bd2*fd*s + 2*D1**2*bdd1*(3*f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + K*(-4*r*s + 3*r - 4*s**2 + 8*s - 3) - 6*r*s + 3*r - 6*s**2 + 6*s - 3) - 14*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 18*D1**2*bdd2*f*r*s - 18*D1**2*bdd2*f*s**2 + 18*D1**2*bdd2*f*s - 64*D1**2*f*fd*r*s + 14*D1**2*f*fd*r - 64*D1**2*f*fd*s**2 + 60*D1**2*f*fd*s - 14*D1**2*f*fd + 20*D1**2*f*fdd*r*s + 5*D1**2*f*fdd*r + 20*D1**2*f*fdd*s**2 - 5*D1**2*f*fdd - 76*D1**2*f*gd2*r*s - 76*D1**2*f*gd2*s**2 + 76*D1**2*f*gd2*s + 24*D1**2*f*gdd2*r*s + 24*D1**2*f*gdd2*s**2 - 24*D1**2*f*gdd2*s + 20*D1**2*fd**2*r*s + 5*D1**2*fd**2*r + 20*D1**2*fd**2*s**2 - 5*D1**2*fd**2 - 76*D1**2*fd*g2*r*s + 18*D1**2*fd*g2*r - 76*D1**2*fd*g2*s**2 + 36*D1**2*fd*g2*s - 18*D1**2*fd*g2 + 48*D1**2*fd*gd2*r*s + 12*D1**2*fd*gd2*r + 48*D1**2*fd*gd2*s**2 - 12*D1**2*fd*gd2 + 24*D1**2*fdd*g2*r*s + 12*D1**2*fdd*g2*r + 24*D1**2*fdd*g2*s**2 + 24*D1**2*fdd*g2*s - 12*D1**2*fdd*g2 - 48*D1*Dd*K*f**2*r*s + 12*D1*Dd*K*f**2*r - 48*D1*Dd*K*f**2*s**2 + 48*D1*Dd*K*f**2*s - 12*D1*Dd*K*f**2 + 116*D1*Dd*b2*f*r*s - 29*D1*Dd*b2*f*r + 116*D1*Dd*b2*f*s**2 - 116*D1*Dd*b2*f*s + 29*D1*Dd*b2*f - 144*D1*Dd*b2*fd*r*s + 18*D1*Dd*b2*fd*r - 144*D1*Dd*b2*fd*s**2 + 72*D1*Dd*b2*fd*s - 144*D1*Dd*bd2*f*r*s + 18*D1*Dd*bd2*f*r - 144*D1*Dd*bd2*f*s**2 + 144*D1*Dd*bd2*f*s - 18*D1*Dd*bd2*f - 128*D1*Dd*f**2*r*s + 32*D1*Dd*f**2*r - 128*D1*Dd*f**2*s**2 + 128*D1*Dd*f**2*s - 32*D1*Dd*f**2 + 160*D1*Dd*f*fd*r*s + 160*D1*Dd*f*fd*s**2 - 80*D1*Dd*f*fd*s - 10*D1*Dd*f*fd - 304*D1*Dd*f*g2*r*s + 76*D1*Dd*f*g2*r - 304*D1*Dd*f*g2*s**2 + 304*D1*Dd*f*g2*s - 76*D1*Dd*f*g2 + 192*D1*Dd*f*gd2*r*s - 24*D1*Dd*f*gd2*r + 192*D1*Dd*f*gd2*s**2 - 192*D1*Dd*f*gd2*s + 24*D1*Dd*f*gd2 + 192*D1*Dd*fd*g2*r*s + 24*D1*Dd*fd*g2*r + 192*D1*Dd*fd*g2*s**2 - 48*D1*Dd*fd*g2 - 72*D1*Ddd*b2*f*r*s + 18*D1*Ddd*b2*f*r - 72*D1*Ddd*b2*f*s**2 + 72*D1*Ddd*b2*f*s - 18*D1*Ddd*b2*f + 40*D1*Ddd*f**2*r*s - 10*D1*Ddd*f**2*r + 40*D1*Ddd*f**2*s**2 - 40*D1*Ddd*f**2*s + 10*D1*Ddd*f**2 + 96*D1*Ddd*f*g2*r*s - 24*D1*Ddd*f*g2*r + 96*D1*Ddd*f*g2*s**2 - 96*D1*Ddd*f*g2*s + 24*D1*Ddd*f*g2 + D1*bd1*(D1*(-6*f**2*(r + 2*s - 1) + f*(-48*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(76*r*s - 29*r + 76*s**2 - 96*s + 29) + 72*r*s - 43*r + 72*s**2 - 86*s + 43) + 6*fd*(4*C*(r*(4*s - 1) + (1 - 2*s)**2) + K*(-8*r*s + r - 8*s**2 + 4*s + 1) - 3*r*(4*s - 1) - 3*(1 - 2*s)**2) + 28*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 28*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 4*Dd*(3*f*(4*C*r*(8*s - 3) + 8*C*(1 - 2*s)**2 + K*(r*(8 - 16*s) - 16*s**2 + 24*s - 7) - 3*r*(8*s - 3) - 6*(1 - 2*s)**2) - 14*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 216*Dd**2*b2*f*r*s + 54*Dd**2*b2*f*r - 216*Dd**2*b2*f*s**2 + 216*Dd**2*b2*f*s - 36*Dd**2*b2*f + 120*Dd**2*f**2*r*s - 30*Dd**2*f**2*r + 120*Dd**2*f**2*s**2 - 120*Dd**2*f**2*s + 20*Dd**2*f**2 + 288*Dd**2*f*g2*r*s - 72*Dd**2*f*g2*r + 288*Dd**2*f*g2*s**2 - 288*Dd**2*f*g2*s + 48*Dd**2*f*g2))/(21*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**3*k1*st**2*(-D1*f*(D1*bd1**2*s*(5*f + 3)*(2*r + 2*s - 1) + 3*D1*bdd1*f*s*(r + s) + 3*bd1*(D1*(-2*f*s*(r + s) + fd*r*(4*s - 1) + fd*s*(4*s - 3)) + Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1)))) + b1**2*(-D1**2*(r + s - 1)*(5*fd**2*(2*s - 1) + fd*(f*(10 - 20*s) - 6*s + 6) + fdd*(10*f*s - 5*f + 3*s - 3)) + D1*(Dd*(10*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-5*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 6*r*(4*s - 1) + 6*(1 - 2*s)**2) - 3*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - Ddd*f*(5*f + 3)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(5*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*(5*bdd1*f**2*s*(2*r + 2*s - 1) - 3*f*(bdd1*s*(-2*r - 2*s + 1) + 2*fd*(2*s - 1)*(r + s - 1) - fdd*(2*s - 1)*(r + s - 1)) + 3*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-5*f*fd*(r*(8*s - 2) + 8*s**2 - 8*s + 1) + 2*f*s*(5*f + 3)*(2*r + 2*s - 1) - 3*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1)) - Dd*f*(5*f + 3)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + 3*D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(6 - 16*s) - 16*s**2 + 20*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3) - 2*D1**2*Pkd2*Pkd3*ct**3*k1*(D1*(6*D1*bd1**2*f*(r*s*(2*K - 2) + r + s*(K*(2*s - 1) - 2*s + 2)) + D1*bdd1*f*s*(r + s)*(6*b2 + f*(10*C - 5) - 12*g2) + bd1*(D1*(f**2*s*(-8*C - 2)*(r + s) + f*(fd*(10*C - 5)*(r*(4*s - 1) + s*(4*s - 3)) + 2*s*(bd2*(6*r + 6*s - 3) + 5*g2*(r + s) - 6*gd2*(2*r + 2*s - 1))) - 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + b2*(D1*(-5*f*s*(r + s) + 6*fd*(r*(2*s - 1) + s*(2*s - 2))) + 6*Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + b1**3*(6*D1**2*s*(2*fd - fdd)*(r + s - 1) + 2*D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 7*r*(4*s - 1) + 7*(1 - 2*s)**2) - D1*Ddd*(6*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(6*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-5*D1**2*K*fd*r*s + 5*D1**2*K*fd*r - 5*D1**2*K*fd*s**2 + 10*D1**2*K*fd*s - 5*D1**2*K*fd + 6*D1**2*K*fdd*r*s - 6*D1**2*K*fdd*r + 6*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - D1**2*bdd1*(6*f + 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 12*D1**2*f*fd*r*s + 6*D1**2*f*fd*r - 12*D1**2*f*fd*s**2 + 18*D1**2*f*fd*s - 6*D1**2*f*fd + 5*D1**2*fd*r*s + 7*D1**2*fd*r + 5*D1**2*fd*s**2 + 2*D1**2*fd*s - 7*D1**2*fd - 6*D1**2*fdd*r*s - 6*D1**2*fdd*s**2 + 6*D1**2*fdd*s - 20*D1*Dd*K*f*r*s + 5*D1*Dd*K*f*r - 20*D1*Dd*K*f*s**2 + 20*D1*Dd*K*f*s - 5*D1*Dd*K*f + 48*D1*Dd*K*fd*r*s - 30*D1*Dd*K*fd*r + 48*D1*Dd*K*fd*s**2 - 72*D1*Dd*K*fd*s + 24*D1*Dd*K*fd - 24*D1*Dd*f**2*r*s + 6*D1*Dd*f**2*r - 24*D1*Dd*f**2*s**2 + 24*D1*Dd*f**2*s - 6*D1*Dd*f**2 + 20*D1*Dd*f*r*s - 5*D1*Dd*f*r + 20*D1*Dd*f*s**2 - 20*D1*Dd*f*s + 5*D1*Dd*f - 48*D1*Dd*fd*r*s + 6*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 + 48*D1*Dd*fd*s - 6*D1*Dd*fd + 24*D1*Ddd*K*f*r*s - 6*D1*Ddd*K*f*r + 24*D1*Ddd*K*f*s**2 - 24*D1*Ddd*K*f*s + 6*D1*Ddd*K*f - 24*D1*Ddd*f*r*s + 6*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 24*D1*Ddd*f*s - 6*D1*Ddd*f + D1*bd1*(2*D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + 21*r*s - 7*r + 21*s**2 - 21*s + 7) - Dd*(6*f + 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 72*Dd**2*K*f*r*s - 18*Dd**2*K*f*r + 72*Dd**2*K*f*s**2 - 72*Dd**2*K*f*s + 12*Dd**2*K*f - 72*Dd**2*f*r*s + 18*Dd**2*f*r - 72*Dd**2*f*s**2 + 72*Dd**2*f*s - 12*Dd**2*f) - b1*(16*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*r + 16*C*D1**2*f*fd*s**2 - 24*C*D1**2*f*fd*s + 8*C*D1**2*f*fd - 20*C*D1**2*f*fdd*r*s + 10*C*D1**2*f*fdd*r - 20*C*D1**2*f*fdd*s**2 + 30*C*D1**2*f*fdd*s - 10*C*D1**2*f*fdd - 20*C*D1**2*fd**2*r*s + 10*C*D1**2*fd**2*r - 20*C*D1**2*fd**2*s**2 + 30*C*D1**2*fd**2*s - 10*C*D1**2*fd**2 + 32*C*D1*Dd*f**2*r*s - 8*C*D1*Dd*f**2*r + 32*C*D1*Dd*f**2*s**2 - 32*C*D1*Dd*f**2*s + 8*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r*s + 60*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 200*C*D1*Dd*f*fd*s - 50*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r*s + 10*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 40*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r*s + 30*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 120*C*Dd**2*f**2*s - 20*C*Dd**2*f**2 + 5*D1**2*b2*fd*r*s - 5*D1**2*b2*fd*r + 5*D1**2*b2*fd*s**2 - 10*D1**2*b2*fd*s + 5*D1**2*b2*fd - 6*D1**2*b2*fdd*r*s + 6*D1**2*b2*fdd*r - 6*D1**2*b2*fdd*s**2 + 12*D1**2*b2*fdd*s - 6*D1**2*b2*fdd + D1**2*bd1**2*(6*f + 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 5*D1**2*bd2*f*r*s + 5*D1**2*bd2*f*s**2 - 5*D1**2*bd2*f*s - 12*D1**2*bd2*fd*r*s + 6*D1**2*bd2*fd*r - 12*D1**2*bd2*fd*s**2 + 18*D1**2*bd2*fd*s - 6*D1**2*bd2*fd - 6*D1**2*bdd1*f*(r*s*(2*K - 2) + r + s**2*(2*K - 2) - s*(K - 2) - 1) - 6*D1**2*bdd2*f*r*s - 6*D1**2*bdd2*f*s**2 + 6*D1**2*bdd2*f*s + 4*D1**2*f*fd*r*s - 2*D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s + 2*D1**2*f*fd + 10*D1**2*f*fdd*r*s - 5*D1**2*f*fdd*r + 10*D1**2*f*fdd*s**2 - 15*D1**2*f*fdd*s + 5*D1**2*f*fdd - 10*D1**2*f*gd2*r*s - 10*D1**2*f*gd2*s**2 + 10*D1**2*f*gd2*s + 12*D1**2*f*gdd2*r*s + 12*D1**2*f*gdd2*s**2 - 12*D1**2*f*gdd2*s + 10*D1**2*fd**2*r*s - 5*D1**2*fd**2*r + 10*D1**2*fd**2*s**2 - 15*D1**2*fd**2*s + 5*D1**2*fd**2 - 10*D1**2*fd*g2*r*s + 10*D1**2*fd*g2*r - 10*D1**2*fd*g2*s**2 + 20*D1**2*fd*g2*s - 10*D1**2*fd*g2 + 24*D1**2*fd*gd2*r*s - 12*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 36*D1**2*fd*gd2*s + 12*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*r + 12*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 + 20*D1*Dd*b2*f*r*s - 5*D1*Dd*b2*f*r + 20*D1*Dd*b2*f*s**2 - 20*D1*Dd*b2*f*s + 5*D1*Dd*b2*f - 48*D1*Dd*b2*fd*r*s + 30*D1*Dd*b2*fd*r - 48*D1*Dd*b2*fd*s**2 + 72*D1*Dd*b2*fd*s - 24*D1*Dd*b2*fd - 48*D1*Dd*bd2*f*r*s + 6*D1*Dd*bd2*f*r - 48*D1*Dd*bd2*f*s**2 + 48*D1*Dd*bd2*f*s - 6*D1*Dd*bd2*f + 8*D1*Dd*f**2*r*s - 2*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 2*D1*Dd*f**2 + 80*D1*Dd*f*fd*r*s - 30*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 100*D1*Dd*f*fd*s + 25*D1*Dd*f*fd - 40*D1*Dd*f*g2*r*s + 10*D1*Dd*f*g2*r - 40*D1*Dd*f*g2*s**2 + 40*D1*Dd*f*g2*s - 10*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r*s - 12*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 96*D1*Dd*f*gd2*s + 12*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r*s - 60*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 144*D1*Dd*fd*g2*s + 48*D1*Dd*fd*g2 - 24*D1*Ddd*b2*f*r*s + 6*D1*Ddd*b2*f*r - 24*D1*Ddd*b2*f*s**2 + 24*D1*Ddd*b2*f*s - 6*D1*Ddd*b2*f + 20*D1*Ddd*f**2*r*s - 5*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 20*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r*s - 12*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 48*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + D1*bd1*(D1*(6*f**2*s*(2*r + 2*s - 1) + f*(2*r*(s*(5*K - 5) + 6) + s**2*(10*K - 10) + s*(17 - 5*K) - 12) - 6*fd*(K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r*s + r - (1 - 2*s)**2)) - 6*Dd*f*(2*K*r*(8*s - 1) + 16*K*s**2 - 12*K*s + K - 2*r*(8*s - 3) - 4*(1 - 2*s)**2)) - 72*Dd**2*b2*f*r*s + 18*Dd**2*b2*f*r - 72*Dd**2*b2*f*s**2 + 72*Dd**2*b2*f*s - 12*Dd**2*b2*f + 60*Dd**2*f**2*r*s - 15*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 60*Dd**2*f**2*s + 10*Dd**2*f**2 + 144*Dd**2*f*g2*r*s - 36*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 144*Dd**2*f*g2*s + 24*Dd**2*f*g2))/(21*d**2*k3) - 5*D1**2*Pkd2*Pkd3*ct**2*f**2*k1**6*st**2*(D1**2*(f*(131*fd - 98*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 98*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(131*f*(r*(4*s - 1) + (1 - 2*s)**2) - 196*fd*(4*s - 1)*(4*r + 4*s - 3)) - 98*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 98*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k2*k3**5) - 10*D1**2*Pkd2*Pkd3*ct**2*f*k1**6*(-28*D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(23*f*(s - 1)*(r + s - 1) - 28*fd*(6*r*s - 3*r + 6*s**2 - 8*s + 2)) - 28*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + b1*(D1**2*s*(3*r + 3*s - 2)*(23*f*fd - 28*f*fdd - 56*fd**2) + D1*f*(Dd*(23*f*(r*(4*s - 1) + (1 - 2*s)**2) - 28*fd*(3*r*(8*s - 1) + 24*s**2 - 20*s + 2)) - 28*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 28*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**2*f*k1**4*k2*st**4*(D1**2*(5*f**2*(107*fd - 60*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(150*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2) - fd*(26*C - 26)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(13*C - 13)*(r*(3*s - 1) + 3*s**2 - 3*s + 1)) - fd**2*(26*C - 26)*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*f*(Dd*(535*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 4*f*(13*C*(r*(4*s - 1) + (1 - 2*s)**2) - 150*fd*(4*s - 1)*(4*r + 4*s - 3) - 13*r*(4*s - 1) - 13*(1 - 2*s)**2) - fd*(26*C - 26)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(13*C + 150*f - 13)) - 2*Dd**2*f**2*(13*C + 150*f - 13)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(1001*d**2*k3**5) - D1**2*Pkd2*Pkd3*ct**2*f*k2**5*st**4*(20*C - 10)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(77*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**2*f*k2**3*st**4*(20*C - 10)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(77*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**2*k1**4*k2*st**2*(66*C*D1**2*bdd1*f**2*r*s - 66*C*D1**2*bdd1*f**2*r + 66*C*D1**2*bdd1*f**2*s**2 - 132*C*D1**2*bdd1*f**2*s + 66*C*D1**2*bdd1*f**2 - 402*C*D1**2*f**2*fd*r*s + 134*C*D1**2*f**2*fd*r - 402*C*D1**2*f**2*fd*s**2 + 402*C*D1**2*f**2*fd*s - 134*C*D1**2*f**2*fd + 300*C*D1**2*f**2*fdd*r*s - 100*C*D1**2*f**2*fdd*r + 300*C*D1**2*f**2*fdd*s**2 - 300*C*D1**2*f**2*fdd*s + 100*C*D1**2*f**2*fdd + 600*C*D1**2*f*fd**2*r*s - 200*C*D1**2*f*fd**2*r + 600*C*D1**2*f*fd**2*s**2 - 600*C*D1**2*f*fd**2*s + 100*C*D1**2*f*fd**2 - 536*C*D1*Dd*f**3*r*s + 134*C*D1*Dd*f**3*r - 536*C*D1*Dd*f**3*s**2 + 536*C*D1*Dd*f**3*s - 134*C*D1*Dd*f**3 + 2400*C*D1*Dd*f**2*fd*r*s - 700*C*D1*Dd*f**2*fd*r + 2400*C*D1*Dd*f**2*fd*s**2 - 2400*C*D1*Dd*f**2*fd*s + 500*C*D1*Dd*f**2*fd + 400*C*D1*Ddd*f**3*r*s - 100*C*D1*Ddd*f**3*r + 400*C*D1*Ddd*f**3*s**2 - 400*C*D1*Ddd*f**3*s + 100*C*D1*Ddd*f**3 + 1200*C*Dd**2*f**3*r*s - 300*C*Dd**2*f**3*r + 1200*C*Dd**2*f**3*s**2 - 1200*C*Dd**2*f**3*s + 200*C*Dd**2*f**3 + 66*D1**2*K*bdd1*f**2*r*s + 66*D1**2*K*bdd1*f**2*s**2 - 66*D1**2*K*bdd1*f**2*s + 33*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + 100*D1**2*bdd1*f**3*r*s - 300*D1**2*bdd1*f**3*r + 100*D1**2*bdd1*f**3*s**2 - 400*D1**2*bdd1*f**3*s + 300*D1**2*bdd1*f**3 - 99*D1**2*bdd1*f**2*r*s + 66*D1**2*bdd1*f**2*r - 99*D1**2*bdd1*f**2*s**2 + 165*D1**2*bdd1*f**2*s - 66*D1**2*bdd1*f**2 - 66*D1**2*bdd1*f*g2*r*s + 66*D1**2*bdd1*f*g2*r - 66*D1**2*bdd1*f*g2*s**2 + 132*D1**2*bdd1*f*g2*s - 66*D1**2*bdd1*f*g2 + 600*D1**2*f**3*fd*r*s - 150*D1**2*f**3*fd*r + 600*D1**2*f**3*fd*s**2 - 600*D1**2*f**3*fd*s + 150*D1**2*f**3*fd + 285*D1**2*f**2*fd*r*s - 95*D1**2*f**2*fd*r + 285*D1**2*f**2*fd*s**2 - 285*D1**2*f**2*fd*s + 95*D1**2*f**2*fd - 225*D1**2*f**2*fdd*r*s + 75*D1**2*f**2*fdd*r - 225*D1**2*f**2*fdd*s**2 + 225*D1**2*f**2*fdd*s - 75*D1**2*f**2*fdd + 198*D1**2*f**2*gd2*r*s + 198*D1**2*f**2*gd2*s**2 - 198*D1**2*f**2*gd2*s - 132*D1**2*f**2*gdd2*r*s - 132*D1**2*f**2*gdd2*s**2 + 132*D1**2*f**2*gdd2*s - 450*D1**2*f*fd**2*r*s + 150*D1**2*f*fd**2*r - 450*D1**2*f*fd**2*s**2 + 450*D1**2*f*fd**2*s - 75*D1**2*f*fd**2 + 396*D1**2*f*fd*g2*r*s - 198*D1**2*f*fd*g2*r + 396*D1**2*f*fd*g2*s**2 - 396*D1**2*f*fd*g2*s + 198*D1**2*f*fd*g2 - 528*D1**2*f*fd*gd2*r*s + 132*D1**2*f*fd*gd2*r - 528*D1**2*f*fd*gd2*s**2 + 528*D1**2*f*fd*gd2*s - 132*D1**2*f*fd*gd2 - 264*D1**2*f*fdd*g2*r*s + 132*D1**2*f*fdd*g2*r - 264*D1**2*f*fdd*g2*s**2 + 264*D1**2*f*fdd*g2*s - 132*D1**2*f*fdd*g2 - 264*D1**2*fd**2*g2*r*s + 132*D1**2*fd**2*g2*r - 264*D1**2*fd**2*g2*s**2 + 264*D1**2*fd**2*g2*s + 600*D1*Dd*f**4*r*s - 150*D1*Dd*f**4*r + 600*D1*Dd*f**4*s**2 - 600*D1*Dd*f**4*s + 150*D1*Dd*f**4 + 380*D1*Dd*f**3*r*s - 95*D1*Dd*f**3*r + 380*D1*Dd*f**3*s**2 - 380*D1*Dd*f**3*s + 95*D1*Dd*f**3 - 1800*D1*Dd*f**2*fd*r*s + 525*D1*Dd*f**2*fd*r - 1800*D1*Dd*f**2*fd*s**2 + 1800*D1*Dd*f**2*fd*s - 375*D1*Dd*f**2*fd + 792*D1*Dd*f**2*g2*r*s - 198*D1*Dd*f**2*g2*r + 792*D1*Dd*f**2*g2*s**2 - 792*D1*Dd*f**2*g2*s + 198*D1*Dd*f**2*g2 - 1056*D1*Dd*f**2*gd2*r*s + 132*D1*Dd*f**2*gd2*r - 1056*D1*Dd*f**2*gd2*s**2 + 1056*D1*Dd*f**2*gd2*s - 132*D1*Dd*f**2*gd2 - 2112*D1*Dd*f*fd*g2*r*s + 792*D1*Dd*f*fd*g2*r - 2112*D1*Dd*f*fd*g2*s**2 + 2112*D1*Dd*f*fd*g2*s - 528*D1*Dd*f*fd*g2 - 300*D1*Ddd*f**3*r*s + 75*D1*Ddd*f**3*r - 300*D1*Ddd*f**3*s**2 + 300*D1*Ddd*f**3*s - 75*D1*Ddd*f**3 - 528*D1*Ddd*f**2*g2*r*s + 132*D1*Ddd*f**2*g2*r - 528*D1*Ddd*f**2*g2*s**2 + 528*D1*Ddd*f**2*g2*s - 132*D1*Ddd*f**2*g2 + D1*bd1*(D1*(-f**3*(200*s - 501)*(r + s - 1) + f**2*(-132*C*(s - 1)*(r + s - 1) + 100*fd*(6*r*s - 7*r + 6*s**2 - 12*s + 4) - (11*r + 11*s - 11)*(9*K*s - 16*s + 12)) + 33*f*(fd*(2*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 5*r - 12*s**2 + 14*s - 3) + (2*r + 2*s - 2)*(2*g2*(s - 1) - 2*gd2*s + gd2)) - 66*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(100*f**2*(r*(8*s - 13) + 8*s**2 - 20*s + 10) + 33*f*(2*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 11*r - 24*s**2 + 32*s - 9) - 66*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 900*Dd**2*f**3*r*s + 225*Dd**2*f**3*r - 900*Dd**2*f**3*s**2 + 900*Dd**2*f**3*s - 150*Dd**2*f**3 - 1584*Dd**2*f**2*g2*r*s + 396*Dd**2*f**2*g2*r - 1584*Dd**2*f**2*g2*s**2 + 1584*Dd**2*f**2*g2*s - 264*Dd**2*f**2*g2 - 33*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(-264*C*D1**2*f*fd*r*s - 264*C*D1**2*f*fd*s**2 + 132*C*D1**2*f*fd*s + 132*C*D1**2*f*fdd*r*s + 132*C*D1**2*f*fdd*s**2 - 66*C*D1**2*f*fdd*s + 132*C*D1**2*fd**2*r*s + 132*C*D1**2*fd**2*s**2 - 66*C*D1**2*fd**2*s - 528*C*D1*Dd*f**2*r*s + 132*C*D1*Dd*f**2*r - 528*C*D1*Dd*f**2*s**2 + 528*C*D1*Dd*f**2*s - 132*C*D1*Dd*f**2 + 1056*C*D1*Dd*f*fd*r*s - 132*C*D1*Dd*f*fd*r + 1056*C*D1*Dd*f*fd*s**2 - 792*C*D1*Dd*f*fd*s + 66*C*D1*Dd*f*fd + 264*C*D1*Ddd*f**2*r*s - 66*C*D1*Ddd*f**2*r + 264*C*D1*Ddd*f**2*s**2 - 264*C*D1*Ddd*f**2*s + 66*C*D1*Ddd*f**2 + 792*C*Dd**2*f**2*r*s - 198*C*Dd**2*f**2*r + 792*C*Dd**2*f**2*s**2 - 792*C*Dd**2*f**2*s + 132*C*Dd**2*f**2 - 198*D1**2*K*f*fd*r*s + 99*D1**2*K*f*fd*r - 198*D1**2*K*f*fd*s**2 + 198*D1**2*K*f*fd*s - 99*D1**2*K*f*fd + 132*D1**2*K*f*fdd*r*s - 66*D1**2*K*f*fdd*r + 132*D1**2*K*f*fdd*s**2 - 132*D1**2*K*f*fdd*s + 66*D1**2*K*f*fdd + 132*D1**2*K*fd**2*r*s - 66*D1**2*K*fd**2*r + 132*D1**2*K*fd**2*s**2 - 132*D1**2*K*fd**2*s + 33*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) - 600*D1**2*f**2*fd*r*s - 301*D1**2*f**2*fd*r - 600*D1**2*f**2*fd*s**2 + 99*D1**2*f**2*fd*s + 301*D1**2*f**2*fd + 300*D1**2*f**2*fdd*r*s + 200*D1**2*f**2*fdd*r + 300*D1**2*f**2*fdd*s**2 - 200*D1**2*f**2*fdd + 600*D1**2*f*fd**2*r*s + 400*D1**2*f*fd**2*r + 600*D1**2*f*fd**2*s**2 - 200*D1**2*f*fd**2 + 352*D1**2*f*fd*r*s - 44*D1**2*f*fd*r + 352*D1**2*f*fd*s**2 - 220*D1**2*f*fd*s + 44*D1**2*f*fd - 198*D1**2*f*fdd*r*s + 33*D1**2*f*fdd*r - 198*D1**2*f*fdd*s**2 + 132*D1**2*f*fdd*s - 33*D1**2*f*fdd + 132*D1**2*f*gd2*r*s + 132*D1**2*f*gd2*s**2 - 132*D1**2*f*gd2*s - 66*D1**2*f*gdd2*r*s - 66*D1**2*f*gdd2*s**2 + 66*D1**2*f*gdd2*s - 198*D1**2*fd**2*r*s + 33*D1**2*fd**2*r - 198*D1**2*fd**2*s**2 + 132*D1**2*fd**2*s + 132*D1**2*fd*g2*r*s + 132*D1**2*fd*g2*s**2 - 132*D1**2*fd*gd2*r*s - 132*D1**2*fd*gd2*s**2 + 66*D1**2*fd*gd2*s - 66*D1**2*fdd*g2*r*s - 66*D1**2*fdd*g2*s**2 - 396*D1*Dd*K*f**2*r*s + 99*D1*Dd*K*f**2*r - 396*D1*Dd*K*f**2*s**2 + 396*D1*Dd*K*f**2*s - 99*D1*Dd*K*f**2 + 1056*D1*Dd*K*f*fd*r*s - 396*D1*Dd*K*f*fd*r + 1056*D1*Dd*K*f*fd*s**2 - 1056*D1*Dd*K*f*fd*s + 264*D1*Dd*K*f*fd - 800*D1*Dd*f**3*r*s + 200*D1*Dd*f**3*r - 800*D1*Dd*f**3*s**2 + 800*D1*Dd*f**3*s - 200*D1*Dd*f**3 + 2400*D1*Dd*f**2*fd*r*s + 500*D1*Dd*f**2*fd*r + 2400*D1*Dd*f**2*fd*s**2 - 1200*D1*Dd*f**2*fd*s - 400*D1*Dd*f**2*fd + 704*D1*Dd*f**2*r*s - 176*D1*Dd*f**2*r + 704*D1*Dd*f**2*s**2 - 704*D1*Dd*f**2*s + 176*D1*Dd*f**2 - 1584*D1*Dd*f*fd*r*s + 330*D1*Dd*f*fd*r - 1584*D1*Dd*f*fd*s**2 + 1320*D1*Dd*f*fd*s - 198*D1*Dd*f*fd + 528*D1*Dd*f*g2*r*s - 132*D1*Dd*f*g2*r + 528*D1*Dd*f*g2*s**2 - 528*D1*Dd*f*g2*s + 132*D1*Dd*f*g2 - 528*D1*Dd*f*gd2*r*s + 66*D1*Dd*f*gd2*r - 528*D1*Dd*f*gd2*s**2 + 528*D1*Dd*f*gd2*s - 66*D1*Dd*f*gd2 - 528*D1*Dd*fd*g2*r*s + 66*D1*Dd*fd*g2*r - 528*D1*Dd*fd*g2*s**2 + 264*D1*Dd*fd*g2*s + 264*D1*Ddd*K*f**2*r*s - 66*D1*Ddd*K*f**2*r + 264*D1*Ddd*K*f**2*s**2 - 264*D1*Ddd*K*f**2*s + 66*D1*Ddd*K*f**2 + 400*D1*Ddd*f**3*r*s - 100*D1*Ddd*f**3*r + 400*D1*Ddd*f**3*s**2 - 400*D1*Ddd*f**3*s + 100*D1*Ddd*f**3 - 396*D1*Ddd*f**2*r*s + 99*D1*Ddd*f**2*r - 396*D1*Ddd*f**2*s**2 + 396*D1*Ddd*f**2*s - 99*D1*Ddd*f**2 - 264*D1*Ddd*f*g2*r*s + 66*D1*Ddd*f*g2*r - 264*D1*Ddd*f*g2*s**2 + 264*D1*Ddd*f*g2*s - 66*D1*Ddd*f*g2 - 33*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) + 792*Dd**2*K*f**2*r*s - 198*Dd**2*K*f**2*r + 792*Dd**2*K*f**2*s**2 - 792*Dd**2*K*f**2*s + 132*Dd**2*K*f**2 + 1200*Dd**2*f**3*r*s - 300*Dd**2*f**3*r + 1200*Dd**2*f**3*s**2 - 1200*Dd**2*f**3*s + 200*Dd**2*f**3 - 1188*Dd**2*f**2*r*s + 297*Dd**2*f**2*r - 1188*Dd**2*f**2*s**2 + 1188*Dd**2*f**2*s - 198*Dd**2*f**2 - 792*Dd**2*f*g2*r*s + 198*Dd**2*f*g2*r - 792*Dd**2*f*g2*s**2 + 792*Dd**2*f*g2*s - 132*Dd**2*f*g2))/(231*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct**2*k1**4*k2*(-D1*(2*D1*bd1**2*f*(2*s - 1)*(-6*K + 10*f + 3)*(r + s - 1) - D1*bdd1*f*(s - 1)*(f*(20*C - 15) - 24*g2)*(r + s - 1) + bd1*(4*C*f*(D1*(f*(s - 1)*(r + s - 1) - 5*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) - 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + D1*(-5*f**3*(2*s - 3)*(r + s - 1) + 3*f*(5*fd*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*r + 2*s - 2)*(-g2*s + g2 + 8*gd2*s - 4*gd2)) + 24*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 3*Dd*f*(5*f + 8*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + b1**2*(-D1**2*s*(-2*f*(11*fd - 10*fdd)*(2*r + 2*s - 1) + 20*fd**2*(2*r + 2*s - 1) + fd*(3*K + 2)*(r + s) - 6*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(22*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(20*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + (3*K + 2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-6*K + 10*f + 3)) - 2*Dd**2*f*(-6*K + 10*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-8*C*D1**2*f*fd*r*s - 8*C*D1**2*f*fd*s**2 + 4*C*D1**2*f*fd*s + 40*C*D1**2*f*fdd*r*s + 40*C*D1**2*f*fdd*s**2 - 20*C*D1**2*f*fdd*s + 40*C*D1**2*fd**2*r*s + 40*C*D1**2*fd**2*s**2 - 20*C*D1**2*fd**2*s - 16*C*D1*Dd*f**2*r*s + 4*C*D1*Dd*f**2*r - 16*C*D1*Dd*f**2*s**2 + 16*C*D1*Dd*f**2*s - 4*C*D1*Dd*f**2 + 320*C*D1*Dd*f*fd*r*s - 40*C*D1*Dd*f*fd*r + 320*C*D1*Dd*f*fd*s**2 - 240*C*D1*Dd*f*fd*s + 20*C*D1*Dd*f*fd + 80*C*D1*Ddd*f**2*r*s - 20*C*D1*Ddd*f**2*r + 80*C*D1*Ddd*f**2*s**2 - 80*C*D1*Ddd*f**2*s + 20*C*D1*Ddd*f**2 + 240*C*Dd**2*f**2*r*s - 60*C*Dd**2*f**2*r + 240*C*Dd**2*f**2*s**2 - 240*C*Dd**2*f**2*s + 40*C*Dd**2*f**2 - 2*D1**2*bdd1*f*(2*s - 1)*(-6*K + 10*f + 3)*(r + s - 1) + 30*D1**2*f**2*fd*r*s + 5*D1**2*f**2*fd*r + 30*D1**2*f**2*fd*s**2 - 15*D1**2*f**2*fd*s - 5*D1**2*f**2*fd - 30*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*s**2 + 15*D1**2*f*fdd*s + 6*D1**2*f*gd2*r*s + 6*D1**2*f*gd2*s**2 - 6*D1**2*f*gd2*s - 24*D1**2*f*gdd2*r*s - 24*D1**2*f*gdd2*s**2 + 24*D1**2*f*gdd2*s - 30*D1**2*fd**2*r*s - 30*D1**2*fd**2*s**2 + 15*D1**2*fd**2*s + 6*D1**2*fd*g2*r*s + 6*D1**2*fd*g2*s**2 - 48*D1**2*fd*gd2*r*s - 48*D1**2*fd*gd2*s**2 + 24*D1**2*fd*gd2*s - 24*D1**2*fdd*g2*r*s - 24*D1**2*fdd*g2*s**2 + 40*D1*Dd*f**3*r*s - 10*D1*Dd*f**3*r + 40*D1*Dd*f**3*s**2 - 40*D1*Dd*f**3*s + 10*D1*Dd*f**3 - 240*D1*Dd*f*fd*r*s + 30*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 15*D1*Dd*f*fd + 24*D1*Dd*f*g2*r*s - 6*D1*Dd*f*g2*r + 24*D1*Dd*f*g2*s**2 - 24*D1*Dd*f*g2*s + 6*D1*Dd*f*g2 - 192*D1*Dd*f*gd2*r*s + 24*D1*Dd*f*gd2*r - 192*D1*Dd*f*gd2*s**2 + 192*D1*Dd*f*gd2*s - 24*D1*Dd*f*gd2 - 192*D1*Dd*fd*g2*r*s + 24*D1*Dd*fd*g2*r - 192*D1*Dd*fd*g2*s**2 + 96*D1*Dd*fd*g2*s - 60*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 96*D1*Ddd*f*g2*r*s + 24*D1*Ddd*f*g2*r - 96*D1*Ddd*f*g2*s**2 + 96*D1*Ddd*f*g2*s - 24*D1*Ddd*f*g2 + D1*bd1*(D1*(22*f**2*(2*s - 1)*(r + s - 1) - f*(20*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (3*K + 2)*(2*s - 1)*(r + s - 1)) + 6*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 2*Dd*f*(-6*K + 10*f + 3)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 180*Dd**2*f**2*r*s + 45*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 30*Dd**2*f**2 - 288*Dd**2*f*g2*r*s + 72*Dd**2*f*g2*r - 288*Dd**2*f*g2*s**2 + 288*Dd**2*f*g2*s - 48*Dd**2*f*g2))/(21*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**2*k1**4*st**2*(b1*(D1**2*(-f**2*(67*fd - 50*fdd)*(r*(6*s - 2) + 6*s**2 - 7*s + 2) + f*(50*fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3) - 55*fd*(2*r*s - r + 2*s**2 - 2*s + 1) + 33*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 33*fd**2*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-134*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + 50*f*fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11) - 55*f*(r*(4*s - 1) + (1 - 2*s)**2) + 66*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(100*f + 33)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(100*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(D1**2*(50*bdd1*f**2*s*(2*r + 2*s - 1) + f*(33*bdd1*s*(r + s - 1) - 39*fd*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 25*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + 25*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-f*s*(67*f*(2*r + 2*s - 1) + 55*r + 55*s - 55) + fd*(50*f*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1) + 33*r*(4*s - 1) + 33*(1 - 2*s)**2)) + Dd*f*(50*f*(16*r*s - 2*r + 16*s**2 - 12*s + 1) + 264*r*s - 33*r + 264*s**2 - 264*s + 33)) + D1*f*(Dd*(-39*f*(r*(4*s - 1) + (1 - 2*s)**2) + 25*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 25*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 25*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**2*k1**4*(-D1*f*(D1*bd1**2*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + (2*s - 1)*(6*r + 6*s - 6)) + 5*D1*bdd1*f*(s - 1)*(r + s - 1) + bd1*(D1*(-4*f*(s - 1)*(r + s - 1) + 5*fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 5*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + b1**2*(D1**2*s*(f*(4*fd - 5*fdd)*(4*r + 4*s - 3) - 5*fd**2*(4*r + 4*s - 3) + 5*fd*(r + s) - 6*fdd*(r + s)) + D1*(Dd*(8*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 5*f*(fd*(8*s - 1)*(4*r + 4*s - 3) - 4*r*s + r - 4*s**2 + 4*s - 1) + 6*fd*(-8*r*s + r + s*(4 - 8*s))) - 2*Ddd*f*(5*f + 3)*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd**2*f*(5*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-D1**2*bdd1*f*(5*f*(4*r*s - 2*r + 4*s**2 - 5*s + 2) + (2*s - 1)*(6*r + 6*s - 6)) + 8*D1**2*f*fd*r*s + 8*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s - 10*D1**2*f*fdd*r*s - 10*D1**2*f*fdd*s**2 + 5*D1**2*f*fdd*s - 10*D1**2*fd**2*r*s - 10*D1**2*fd**2*s**2 + 5*D1**2*fd**2*s + 16*D1*Dd*f**2*r*s - 4*D1*Dd*f**2*r + 16*D1*Dd*f**2*s**2 - 16*D1*Dd*f**2*s + 4*D1*Dd*f**2 - 80*D1*Dd*f*fd*r*s + 10*D1*Dd*f*fd*r - 80*D1*Dd*f*fd*s**2 + 60*D1*Dd*f*fd*s - 5*D1*Dd*f*fd - 20*D1*Ddd*f**2*r*s + 5*D1*Ddd*f**2*r - 20*D1*Ddd*f**2*s**2 + 20*D1*Ddd*f**2*s - 5*D1*Ddd*f**2 + D1*bd1*(D1*(4*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) - 5*f*fd*(4*s - 1)*(4*r + 4*s - 3) + 5*f*(2*s - 1)*(r + s - 1) + 6*fd*(-4*r*s + r + s*(3 - 4*s))) - Dd*f*(5*f*(8*s - 3)*(4*r + 4*s - 3) + 96*r*s - 36*r + 96*s**2 - 120*s + 30)) - 60*Dd**2*f**2*r*s + 15*Dd**2*f**2*r - 60*Dd**2*f**2*s**2 + 60*Dd**2*f**2*s - 10*Dd**2*f**2))/(21*d**2*k2*k3**3) + 5*D1**2*Pkd2*Pkd3*ct**2*k1**2*k2**3*st**6*(156*C*D1**2*f**2*fd*r*s - 52*C*D1**2*f**2*fd*r + 156*C*D1**2*f**2*fd*s**2 - 156*C*D1**2*f**2*fd*s + 52*C*D1**2*f**2*fd - 78*C*D1**2*f**2*fdd*r*s + 26*C*D1**2*f**2*fdd*r - 78*C*D1**2*f**2*fdd*s**2 + 78*C*D1**2*f**2*fdd*s - 26*C*D1**2*f**2*fdd - 156*C*D1**2*f*fd**2*r*s + 52*C*D1**2*f*fd**2*r - 156*C*D1**2*f*fd**2*s**2 + 156*C*D1**2*f*fd**2*s - 26*C*D1**2*f*fd**2 + 208*C*D1*Dd*f**3*r*s - 52*C*D1*Dd*f**3*r + 208*C*D1*Dd*f**3*s**2 - 208*C*D1*Dd*f**3*s + 52*C*D1*Dd*f**3 - 624*C*D1*Dd*f**2*fd*r*s + 182*C*D1*Dd*f**2*fd*r - 624*C*D1*Dd*f**2*fd*s**2 + 624*C*D1*Dd*f**2*fd*s - 130*C*D1*Dd*f**2*fd - 104*C*D1*Ddd*f**3*r*s + 26*C*D1*Ddd*f**3*r - 104*C*D1*Ddd*f**3*s**2 + 104*C*D1*Ddd*f**3*s - 26*C*D1*Ddd*f**3 - 312*C*Dd**2*f**3*r*s + 78*C*Dd**2*f**3*r - 312*C*Dd**2*f**3*s**2 + 312*C*Dd**2*f**3*s - 52*C*Dd**2*f**3 - 429*D1**2*K*bdd1*f**2*r*s - 429*D1**2*K*bdd1*f**2*s**2 + 429*D1**2*K*bdd1*f**2*s + 429*D1**2*bdd1*f**2*r*s + 429*D1**2*bdd1*f**2*s**2 - 429*D1**2*bdd1*f**2*s - 672*D1**2*f**3*fd*r*s + 168*D1**2*f**3*fd*r - 672*D1**2*f**3*fd*s**2 + 672*D1**2*f**3*fd*s - 168*D1**2*f**3*fd + 336*D1**2*f**3*fdd*r*s - 84*D1**2*f**3*fdd*r + 336*D1**2*f**3*fdd*s**2 - 336*D1**2*f**3*fdd*s + 84*D1**2*f**3*fdd + 1008*D1**2*f**2*fd**2*r*s - 252*D1**2*f**2*fd**2*r + 1008*D1**2*f**2*fd**2*s**2 - 1008*D1**2*f**2*fd**2*s + 168*D1**2*f**2*fd**2 - 156*D1**2*f**2*fd*r*s + 52*D1**2*f**2*fd*r - 156*D1**2*f**2*fd*s**2 + 156*D1**2*f**2*fd*s - 52*D1**2*f**2*fd + 78*D1**2*f**2*fdd*r*s - 26*D1**2*f**2*fdd*r + 78*D1**2*f**2*fdd*s**2 - 78*D1**2*f**2*fdd*s + 26*D1**2*f**2*fdd - 1716*D1**2*f**2*gd2*r*s - 1716*D1**2*f**2*gd2*s**2 + 1716*D1**2*f**2*gd2*s + 858*D1**2*f**2*gdd2*r*s + 858*D1**2*f**2*gdd2*s**2 - 858*D1**2*f**2*gdd2*s + 156*D1**2*f*fd**2*r*s - 52*D1**2*f*fd**2*r + 156*D1**2*f*fd**2*s**2 - 156*D1**2*f*fd**2*s + 26*D1**2*f*fd**2 - 3432*D1**2*f*fd*g2*r*s + 1716*D1**2*f*fd*g2*r - 3432*D1**2*f*fd*g2*s**2 + 3432*D1**2*f*fd*g2*s - 1716*D1**2*f*fd*g2 + 3432*D1**2*f*fd*gd2*r*s - 858*D1**2*f*fd*gd2*r + 3432*D1**2*f*fd*gd2*s**2 - 3432*D1**2*f*fd*gd2*s + 858*D1**2*f*fd*gd2 + 1716*D1**2*f*fdd*g2*r*s - 858*D1**2*f*fdd*g2*r + 1716*D1**2*f*fdd*g2*s**2 - 1716*D1**2*f*fdd*g2*s + 858*D1**2*f*fdd*g2 + 1716*D1**2*fd**2*g2*r*s - 858*D1**2*fd**2*g2*r + 1716*D1**2*fd**2*g2*s**2 - 1716*D1**2*fd**2*g2*s - 672*D1*Dd*f**4*r*s + 168*D1*Dd*f**4*r - 672*D1*Dd*f**4*s**2 + 672*D1*Dd*f**4*s - 168*D1*Dd*f**4 + 2688*D1*Dd*f**3*fd*r*s - 672*D1*Dd*f**3*fd*r + 2688*D1*Dd*f**3*fd*s**2 - 2688*D1*Dd*f**3*fd*s + 504*D1*Dd*f**3*fd - 208*D1*Dd*f**3*r*s + 52*D1*Dd*f**3*r - 208*D1*Dd*f**3*s**2 + 208*D1*Dd*f**3*s - 52*D1*Dd*f**3 + 624*D1*Dd*f**2*fd*r*s - 182*D1*Dd*f**2*fd*r + 624*D1*Dd*f**2*fd*s**2 - 624*D1*Dd*f**2*fd*s + 130*D1*Dd*f**2*fd - 6864*D1*Dd*f**2*g2*r*s + 1716*D1*Dd*f**2*g2*r - 6864*D1*Dd*f**2*g2*s**2 + 6864*D1*Dd*f**2*g2*s - 1716*D1*Dd*f**2*g2 + 6864*D1*Dd*f**2*gd2*r*s - 858*D1*Dd*f**2*gd2*r + 6864*D1*Dd*f**2*gd2*s**2 - 6864*D1*Dd*f**2*gd2*s + 858*D1*Dd*f**2*gd2 + 13728*D1*Dd*f*fd*g2*r*s - 5148*D1*Dd*f*fd*g2*r + 13728*D1*Dd*f*fd*g2*s**2 - 13728*D1*Dd*f*fd*g2*s + 3432*D1*Dd*f*fd*g2 + 336*D1*Ddd*f**4*r*s - 84*D1*Ddd*f**4*r + 336*D1*Ddd*f**4*s**2 - 336*D1*Ddd*f**4*s + 84*D1*Ddd*f**4 + 104*D1*Ddd*f**3*r*s - 26*D1*Ddd*f**3*r + 104*D1*Ddd*f**3*s**2 - 104*D1*Ddd*f**3*s + 26*D1*Ddd*f**3 + 3432*D1*Ddd*f**2*g2*r*s - 858*D1*Ddd*f**2*g2*r + 3432*D1*Ddd*f**2*g2*s**2 - 3432*D1*Ddd*f**2*g2*s + 858*D1*Ddd*f**2*g2 + 429*D1*bd1*f*(K - 1)*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 1008*Dd**2*f**4*r*s - 252*Dd**2*f**4*r + 1008*Dd**2*f**4*s**2 - 1008*Dd**2*f**4*s + 168*Dd**2*f**4 + 312*Dd**2*f**3*r*s - 78*Dd**2*f**3*r + 312*Dd**2*f**3*s**2 - 312*Dd**2*f**3*s + 52*Dd**2*f**3 + 10296*Dd**2*f**2*g2*r*s - 2574*Dd**2*f**2*g2*r + 10296*Dd**2*f**2*g2*s**2 - 10296*Dd**2*f**2*g2*s + 1716*Dd**2*f**2*g2 + 429*b1*(K - 1)*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(9009*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct**2*k1**2*k2**3*st**4*(-11*D1**2*bd1**2*f*(K - 1)*(2*s - 1)*(r + s - 1) + D1*bd1*(D1*(10*f**3*(3*s + 1)*(r + s - 1) + f**2*(-5*fd*(18*r*s - r + 18*s**2 - 16*s + 2) + s*(22 - 33*K)*(r + s - 1)) - 22*f*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 22*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + Dd*f*(-5*f**2*(24*r*s + r + 4*s*(6*s - 5)) + 22*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + 11*b1**2*(K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(-66*D1**2*K*f*fd*r*s + 33*D1**2*K*f*fd*r - 66*D1**2*K*f*fd*s**2 + 66*D1**2*K*f*fd*s - 33*D1**2*K*f*fd - 11*D1**2*bdd1*f*(K - 1)*(2*s - 1)*(r + s - 1) + 90*D1**2*f**2*fd*r*s - 40*D1**2*f**2*fd*r + 90*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 40*D1**2*f**2*fd - 45*D1**2*f**2*fdd*r*s + 20*D1**2*f**2*fdd*r - 45*D1**2*f**2*fdd*s**2 + 50*D1**2*f**2*fdd*s - 20*D1**2*f**2*fdd - 90*D1**2*f*fd**2*r*s + 40*D1**2*f*fd**2*r - 90*D1**2*f*fd**2*s**2 + 100*D1**2*f*fd**2*s - 20*D1**2*f*fd**2 + 44*D1**2*f*fd*r*s - 22*D1**2*f*fd*r + 44*D1**2*f*fd*s**2 - 44*D1**2*f*fd*s + 22*D1**2*f*fd - 44*D1**2*f*gd2*r*s - 44*D1**2*f*gd2*s**2 + 44*D1**2*f*gd2*s + 22*D1**2*f*gdd2*r*s + 22*D1**2*f*gdd2*s**2 - 22*D1**2*f*gdd2*s - 44*D1**2*fd*g2*r*s - 44*D1**2*fd*g2*s**2 + 44*D1**2*fd*gd2*r*s + 44*D1**2*fd*gd2*s**2 - 22*D1**2*fd*gd2*s + 22*D1**2*fdd*g2*r*s + 22*D1**2*fdd*g2*s**2 - 132*D1*Dd*K*f**2*r*s + 33*D1*Dd*K*f**2*r - 132*D1*Dd*K*f**2*s**2 + 132*D1*Dd*K*f**2*s - 33*D1*Dd*K*f**2 + 120*D1*Dd*f**3*r*s - 30*D1*Dd*f**3*r + 120*D1*Dd*f**3*s**2 - 120*D1*Dd*f**3*s + 30*D1*Dd*f**3 - 360*D1*Dd*f**2*fd*r*s + 125*D1*Dd*f**2*fd*r - 360*D1*Dd*f**2*fd*s**2 + 380*D1*Dd*f**2*fd*s - 90*D1*Dd*f**2*fd + 88*D1*Dd*f**2*r*s - 22*D1*Dd*f**2*r + 88*D1*Dd*f**2*s**2 - 88*D1*Dd*f**2*s + 22*D1*Dd*f**2 - 176*D1*Dd*f*g2*r*s + 44*D1*Dd*f*g2*r - 176*D1*Dd*f*g2*s**2 + 176*D1*Dd*f*g2*s - 44*D1*Dd*f*g2 + 176*D1*Dd*f*gd2*r*s - 22*D1*Dd*f*gd2*r + 176*D1*Dd*f*gd2*s**2 - 176*D1*Dd*f*gd2*s + 22*D1*Dd*f*gd2 + 176*D1*Dd*fd*g2*r*s - 22*D1*Dd*fd*g2*r + 176*D1*Dd*fd*g2*s**2 - 88*D1*Dd*fd*g2*s - 60*D1*Ddd*f**3*r*s + 15*D1*Ddd*f**3*r - 60*D1*Ddd*f**3*s**2 + 60*D1*Ddd*f**3*s - 15*D1*Ddd*f**3 + 88*D1*Ddd*f*g2*r*s - 22*D1*Ddd*f*g2*r + 88*D1*Ddd*f*g2*s**2 - 88*D1*Ddd*f*g2*s + 22*D1*Ddd*f*g2 + 11*D1*bd1*(K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) - 180*Dd**2*f**3*r*s + 45*Dd**2*f**3*r - 180*Dd**2*f**3*s**2 + 180*Dd**2*f**3*s - 30*Dd**2*f**3 + 264*Dd**2*f*g2*r*s - 66*Dd**2*f*g2*r + 264*Dd**2*f*g2*s**2 - 264*Dd**2*f*g2*s + 44*Dd**2*f*g2) + f*(-D1**2*bdd1*(5*f**2*(3*s + 1) - 22*g2*(s - 1))*(r + s - 1) + D1**2*(5*f**2*fd*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-fd*(40*C - 30)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(20*C - 15)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 66*gd2*s*(r + s - 1)) + fd*(fd*(20*C - 15)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1))) + D1*f*(Dd*(5*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(30 - 40*C)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(20*C - 15)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 66*g2*(r*(4*s - 1) + (1 - 2*s)**2)) + Ddd*f*(20*C - 15)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(20*C - 15)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(77*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct**2*k1**2*k2**3*st**2*(-33*D1**2*bd1**2*f*(2*s - 1)*(-6*K + 8*f + 3)*(r + s - 1) + 99*D1**2*bdd1*f*(f*(4*C*(s - 1) + 2*K*s - 3*s + 3) - 4*g2*(s - 1))*(r + s - 1) - 6*D1**2*(f**2*(fd*(34*C - 6)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(50*C - 25)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-66*gd2 + 66*gdd2)*(r + s - 1)) + f*(-fd**2*(50*C - 25)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 66*fd*(g2*(2*r*s - r + 2*s**2 - 2*s + 1) + gd2*(-4*r*s + r - 4*s**2 + 4*s - 1)) + 66*fdd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 66*fd**2*g2*(r*(2*s - 1) + s*(2*s - 2))) - 11*D1*bd1*(D1*(6*f**3*(2*s + 1)*(r + s - 1) + f**2*(r + s - 1)*(66*C*(s - 1) + s*(18*K - 43) + 49) - 3*f*(3*fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(8*r*s - 2*r + 8*s**2 - 8*s + 2) - 12*r*s + 6*r - 12*s**2 + 15*s - 3) + (38*g2*(s - 1) + 12*gd2*(1 - 2*s))*(r + s - 1)) + 36*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 9*Dd*f*(f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 4*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 6*D1*f*(Dd*(f**2*(34*C - 6)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(25 - 50*C)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 66*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 66*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 132*fd*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(f*(50*C - 25) - 66*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 6*Dd**2*f**2*(f*(50*C - 25) - 66*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 11*b1**2*(D1**2*s*(3*f*(15*fd - 8*fdd)*(2*r + 2*s - 1) - 24*fd**2*(2*r + 2*s - 1) - fd*(57*K - 32)*(r + s) + 9*fdd*(2*K - 1)*(r + s)) + D1*(Dd*(45*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-24*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - (57*K - 32)*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-6*K + 8*f + 3)) - 3*Dd**2*f*(-6*K + 8*f + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(-132*C*D1**2*f*fd*r*s - 132*C*D1**2*f*fd*s**2 + 66*C*D1**2*f*fd*s + 72*C*D1**2*f*fdd*r*s + 72*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 72*C*D1**2*fd**2*r*s + 72*C*D1**2*fd**2*s**2 - 36*C*D1**2*fd**2*s - 264*C*D1*Dd*f**2*r*s + 66*C*D1*Dd*f**2*r - 264*C*D1*Dd*f**2*s**2 + 264*C*D1*Dd*f**2*s - 66*C*D1*Dd*f**2 + 576*C*D1*Dd*f*fd*r*s - 72*C*D1*Dd*f*fd*r + 576*C*D1*Dd*f*fd*s**2 - 432*C*D1*Dd*f*fd*s + 36*C*D1*Dd*f*fd + 144*C*D1*Ddd*f**2*r*s - 36*C*D1*Ddd*f**2*r + 144*C*D1*Ddd*f**2*s**2 - 144*C*D1*Ddd*f**2*s + 36*C*D1*Ddd*f**2 + 432*C*Dd**2*f**2*r*s - 108*C*Dd**2*f**2*r + 432*C*Dd**2*f**2*s**2 - 432*C*Dd**2*f**2*s + 72*C*Dd**2*f**2 - 36*D1**2*K*f*fd*r*s + 18*D1**2*K*f*fd*r - 36*D1**2*K*f*fd*s**2 + 36*D1**2*K*f*fd*s - 18*D1**2*K*f*fd + 36*D1**2*K*f*fdd*r*s - 18*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r*s - 18*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(2*s - 1)*(-6*K + 8*f + 3)*(r + s - 1) - 36*D1**2*f**2*fd*r*s + 18*D1**2*f**2*fd*r - 36*D1**2*f**2*fd*s**2 + 42*D1**2*f**2*fd*s - 18*D1**2*f**2*fd + 86*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 86*D1**2*f*fd*s**2 - 37*D1**2*f*fd*s - 6*D1**2*f*fd - 54*D1**2*f*fdd*r*s - 54*D1**2*f*fdd*s**2 + 27*D1**2*f*fdd*s + 114*D1**2*f*gd2*r*s + 114*D1**2*f*gd2*s**2 - 114*D1**2*f*gd2*s - 36*D1**2*f*gdd2*r*s - 36*D1**2*f*gdd2*s**2 + 36*D1**2*f*gdd2*s - 54*D1**2*fd**2*r*s - 54*D1**2*fd**2*s**2 + 27*D1**2*fd**2*s + 114*D1**2*fd*g2*r*s + 114*D1**2*fd*g2*s**2 - 72*D1**2*fd*gd2*r*s - 72*D1**2*fd*gd2*s**2 + 36*D1**2*fd*gd2*s - 36*D1**2*fdd*g2*r*s - 36*D1**2*fdd*g2*s**2 - 72*D1*Dd*K*f**2*r*s + 18*D1*Dd*K*f**2*r - 72*D1*Dd*K*f**2*s**2 + 72*D1*Dd*K*f**2*s - 18*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r*s - 108*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 288*D1*Dd*K*f*fd*s + 72*D1*Dd*K*f*fd - 48*D1*Dd*f**3*r*s + 12*D1*Dd*f**3*r - 48*D1*Dd*f**3*s**2 + 48*D1*Dd*f**3*s - 12*D1*Dd*f**3 + 172*D1*Dd*f**2*r*s - 43*D1*Dd*f**2*r + 172*D1*Dd*f**2*s**2 - 172*D1*Dd*f**2*s + 43*D1*Dd*f**2 - 432*D1*Dd*f*fd*r*s + 54*D1*Dd*f*fd*r - 432*D1*Dd*f*fd*s**2 + 324*D1*Dd*f*fd*s - 27*D1*Dd*f*fd + 456*D1*Dd*f*g2*r*s - 114*D1*Dd*f*g2*r + 456*D1*Dd*f*g2*s**2 - 456*D1*Dd*f*g2*s + 114*D1*Dd*f*g2 - 288*D1*Dd*f*gd2*r*s + 36*D1*Dd*f*gd2*r - 288*D1*Dd*f*gd2*s**2 + 288*D1*Dd*f*gd2*s - 36*D1*Dd*f*gd2 - 288*D1*Dd*fd*g2*r*s + 36*D1*Dd*fd*g2*r - 288*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s + 72*D1*Ddd*K*f**2*r*s - 18*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 72*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 - 108*D1*Ddd*f**2*r*s + 27*D1*Ddd*f**2*r - 108*D1*Ddd*f**2*s**2 + 108*D1*Ddd*f**2*s - 27*D1*Ddd*f**2 - 144*D1*Ddd*f*g2*r*s + 36*D1*Ddd*f*g2*r - 144*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + D1*bd1*(D1*(45*f**2*(2*s - 1)*(r + s - 1) + f*(-24*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) - (57*K - 32)*(2*s - 1)*(r + s - 1)) + 9*fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - 3*Dd*f*(-6*K + 8*f + 3)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 216*Dd**2*K*f**2*r*s - 54*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 216*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 - 324*Dd**2*f**2*r*s + 81*Dd**2*f**2*r - 324*Dd**2*f**2*s**2 + 324*Dd**2*f**2*s - 54*Dd**2*f**2 - 432*Dd**2*f*g2*r*s + 108*Dd**2*f*g2*r - 432*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(231*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct**2*k1**2*k2**3*(D1*(-18*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 3*bd1*(D1*(2*f**2*(r + s - 1)*(2*C*(s - 1) + s*(K - 3) + 3) + f*(fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (g2*(s - 1) + 3*gd2*(2*s - 1))*(-4*r - 4*s + 4)) + 12*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + f*(-3*D1*bdd1*(s - 1)*(f*(10*C - 5) - 12*g2)*(r + s - 1) + D1*(f*(-fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 12*gd2*s*(r + s - 1)) + 12*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 2*b1**2*(D1**2*s*(9*f*fd*(2*r + 2*s - 1) - (r + s)*(9*K*fdd + fd*(3*K - 7))) + D1*(Dd*(9*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 9*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(3*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 9*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(-3*D1**2*(6*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(2*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd*s*(4*C - 6)*(2*r + 2*s - 1) + fdd*s*(10*C - 5)*(2*r + 2*s - 1) + s*(-4*gd2 - 12*gdd2)*(r + s - 1)) + s*(fd**2*(10*C - 5)*(2*r + 2*s - 1) - 4*fd*(g2*(r + s) + gd2*(6*r + 6*s - 3)) - 12*fdd*g2*(r + s))) + 2*D1*bd1*(D1*(9*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 9*f**2*(2*s - 1)*(r + s - 1) - f*(3*K - 7)*(2*s - 1)*(r + s - 1)) - 9*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 3*D1*(Dd*(2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(2*C + K - 3) + f*(fd*(10*C - 5)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) - 4*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 12*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 12*fd*g2*(-8*r*s + r + s*(4 - 8*s))) + Ddd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(f*(10*C - 5) - 12*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct**2*k1**2*k2*st**4*(D1**2*(22*bd1*fd*g2*(r*(2*s - 1) + s*(2*s - 2)) + f**3*s*(-10*bd1 + 5*bdd1)*(4*r + 4*s - 3) + f**2*(-11*bd1*s*(r + s - 1) + 5*fd*(bd1*(6*s - 1)*(4*r + 4*s - 3) - 6*r*s + 2*r - 6*s**2 + 6*s - 2) + 5*fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + f*(5*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 11*s*(bd1**2*(K - 1)*(2*r + 2*s - 1) + 4*bd1*g2*(r + s) + bd1*gd2*(-4*r - 4*s + 2) - 2*bdd1*g2*(r + s)))) + D1*f*(Dd*(22*bd1*g2*(r*(8*s - 1) + 4*s*(2*s - 1)) + 5*f**2*(bd1*(8*s - 1)*(4*r + 4*s - 3) - 8*r*s + 2*r - 8*s**2 + 8*s - 2) + 5*f*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) + 5*Ddd*f**2*(r*(4*s - 1) + (1 - 2*s)**2)) + 5*Dd**2*f**3*(12*r*s - 3*r + 12*s**2 - 12*s + 2) + 11*b1**2*(K - 1)*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(D1**2*(-5*f**2*(2*fd - fdd)*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4) + f*(5*fd**2*(8*r*(3*s - 1) + 24*s**2 - 26*s + 5) - 11*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 11*s*(bdd1*(K - 1)*(2*r + 2*s - 1) + (4*gd2 - 2*gdd2)*(r + s - 1))) - (fd*(2*g2*(s - 1) - 2*gd2*s + gd2) - fdd*g2*(s - 1))*(22*r + 22*s - 22)) - 11*D1*bd1*(K - 1)*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*(Dd*(-40*f**3*(r*(4*s - 1) + (1 - 2*s)**2) + f**2*(5*fd*(24*s - 7)*(4*r + 4*s - 3) - 11*r*(4*s - 1) - 11*(1 - 2*s)**2) - 22*f*(g2*r*(8*s - 2) + 2*g2*(1 - 2*s)**2 + gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 22*fd*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 2*Ddd*f*(10*f**2 + 11*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd**2*f*(10*f**2 + 11*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(77*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**2*k1**2*k2*st**2*(1404*C*D1**2*f**2*fd*r*s - 468*C*D1**2*f**2*fd*r + 1404*C*D1**2*f**2*fd*s**2 - 1404*C*D1**2*f**2*fd*s + 468*C*D1**2*f**2*fd - 900*C*D1**2*f**2*fdd*r*s + 300*C*D1**2*f**2*fdd*r - 900*C*D1**2*f**2*fdd*s**2 + 900*C*D1**2*f**2*fdd*s - 300*C*D1**2*f**2*fdd - 1800*C*D1**2*f*fd**2*r*s + 600*C*D1**2*f*fd**2*r - 1800*C*D1**2*f*fd**2*s**2 + 1800*C*D1**2*f*fd**2*s - 300*C*D1**2*f*fd**2 + 1872*C*D1*Dd*f**3*r*s - 468*C*D1*Dd*f**3*r + 1872*C*D1*Dd*f**3*s**2 - 1872*C*D1*Dd*f**3*s + 468*C*D1*Dd*f**3 - 7200*C*D1*Dd*f**2*fd*r*s + 2100*C*D1*Dd*f**2*fd*r - 7200*C*D1*Dd*f**2*fd*s**2 + 7200*C*D1*Dd*f**2*fd*s - 1500*C*D1*Dd*f**2*fd - 1200*C*D1*Ddd*f**3*r*s + 300*C*D1*Ddd*f**3*r - 1200*C*D1*Ddd*f**3*s**2 + 1200*C*D1*Ddd*f**3*s - 300*C*D1*Ddd*f**3 - 3600*C*Dd**2*f**3*r*s + 900*C*Dd**2*f**3*r - 3600*C*Dd**2*f**3*s**2 + 3600*C*Dd**2*f**3*s - 600*C*Dd**2*f**3 + 11*D1**2*bd1**2*(6*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 3) + f*(r*(C*(4*s - 2) + 12*K*s + 8*s - 7) + s**2*(4*C + 12*K + 8) - s*(4*C + 6*K + 20) + 9) + 14*g2*(r*(2*s - 1) + s*(2*s - 2))) - 33*D1**2*bdd1*f*(f*(r*(-4*C*s + 6*K*s + 3) + s**2*(-4*C + 6*K) - s*(6*K - 6) - 3) + 4*g2*s*(r + s)) - 198*D1**2*bdd2*f**2*r*s - 198*D1**2*bdd2*f**2*s**2 + 198*D1**2*bdd2*f**2*s - 504*D1**2*f**2*fd*r*s + 168*D1**2*f**2*fd*r - 504*D1**2*f**2*fd*s**2 + 504*D1**2*f**2*fd*s - 168*D1**2*f**2*fd + 450*D1**2*f**2*fdd*r*s - 150*D1**2*f**2*fdd*r + 450*D1**2*f**2*fdd*s**2 - 450*D1**2*f**2*fdd*s + 150*D1**2*f**2*fdd - 660*D1**2*f**2*gd2*r*s - 660*D1**2*f**2*gd2*s**2 + 660*D1**2*f**2*gd2*s + 396*D1**2*f**2*gdd2*r*s + 396*D1**2*f**2*gdd2*s**2 - 396*D1**2*f**2*gdd2*s + 900*D1**2*f*fd**2*r*s - 300*D1**2*f*fd**2*r + 900*D1**2*f*fd**2*s**2 - 900*D1**2*f*fd**2*s + 150*D1**2*f*fd**2 - 1320*D1**2*f*fd*g2*r*s + 660*D1**2*f*fd*g2*r - 1320*D1**2*f*fd*g2*s**2 + 1320*D1**2*f*fd*g2*s - 660*D1**2*f*fd*g2 + 1584*D1**2*f*fd*gd2*r*s - 396*D1**2*f*fd*gd2*r + 1584*D1**2*f*fd*gd2*s**2 - 1584*D1**2*f*fd*gd2*s + 396*D1**2*f*fd*gd2 + 792*D1**2*f*fdd*g2*r*s - 396*D1**2*f*fdd*g2*r + 792*D1**2*f*fdd*g2*s**2 - 792*D1**2*f*fdd*g2*s + 396*D1**2*f*fdd*g2 + 792*D1**2*fd**2*g2*r*s - 396*D1**2*fd**2*g2*r + 792*D1**2*fd**2*g2*s**2 - 792*D1**2*fd**2*g2*s - 672*D1*Dd*f**3*r*s + 168*D1*Dd*f**3*r - 672*D1*Dd*f**3*s**2 + 672*D1*Dd*f**3*s - 168*D1*Dd*f**3 + 3600*D1*Dd*f**2*fd*r*s - 1050*D1*Dd*f**2*fd*r + 3600*D1*Dd*f**2*fd*s**2 - 3600*D1*Dd*f**2*fd*s + 750*D1*Dd*f**2*fd - 2640*D1*Dd*f**2*g2*r*s + 660*D1*Dd*f**2*g2*r - 2640*D1*Dd*f**2*g2*s**2 + 2640*D1*Dd*f**2*g2*s - 660*D1*Dd*f**2*g2 + 3168*D1*Dd*f**2*gd2*r*s - 396*D1*Dd*f**2*gd2*r + 3168*D1*Dd*f**2*gd2*s**2 - 3168*D1*Dd*f**2*gd2*s + 396*D1*Dd*f**2*gd2 + 6336*D1*Dd*f*fd*g2*r*s - 2376*D1*Dd*f*fd*g2*r + 6336*D1*Dd*f*fd*g2*s**2 - 6336*D1*Dd*f*fd*g2*s + 1584*D1*Dd*f*fd*g2 + 600*D1*Ddd*f**3*r*s - 150*D1*Ddd*f**3*r + 600*D1*Ddd*f**3*s**2 - 600*D1*Ddd*f**3*s + 150*D1*Ddd*f**3 + 1584*D1*Ddd*f**2*g2*r*s - 396*D1*Ddd*f**2*g2*r + 1584*D1*Ddd*f**2*g2*s**2 - 1584*D1*Ddd*f**2*g2*s + 396*D1*Ddd*f**2*g2 + 11*D1*bd1*(D1*(6*f**3*s*(3*r + 3*s - 2) + f**2*(r*(s*(-18*C + 30*K + 2) + 17) + s**2*(-18*C + 30*K + 2) + s*(28 - 30*K) - 17) - 3*f*(fd*(-16*C*s**2 + 12*C*s + 6*K*(r*(4*s - 1) + (1 - 2*s)**2) + r*(-16*C*s + 4*C + 3) + 6*s - 3) + 2*s*(-11*g2*(r + s) + gd2*(4*r + 4*s - 2))) + 12*fd*g2*(-2*r*s + r - s*(2*s - 2))) - 6*Dd*f*(3*K*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 2*f*r*(-8*C*s + C + 3) - 2*f*(2*s - 1)*(4*C*s - 3) + 2*g2*r*(8*s - 1) + 8*g2*s*(2*s - 1))) + 66*D1*bd2*f*(D1*(5*f*s*(r + s - 1) - 3*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 1800*Dd**2*f**3*r*s - 450*Dd**2*f**3*r + 1800*Dd**2*f**3*s**2 - 1800*Dd**2*f**3*s + 300*Dd**2*f**3 + 4752*Dd**2*f**2*g2*r*s - 1188*Dd**2*f**2*g2*r + 4752*Dd**2*f**2*g2*s**2 - 4752*Dd**2*f**2*g2*s + 792*Dd**2*f**2*g2 + 77*b1**3*(K - 1)*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 11*b1**2*(-4*C*D1**2*fd*r*s - 4*C*D1**2*fd*s**2 + 4*C*D1**2*fd*s + 2*C*D1**2*fdd*r*s + 2*C*D1**2*fdd*s**2 - 2*C*D1**2*fdd*s - 16*C*D1*Dd*f*r*s + 4*C*D1*Dd*f*r - 16*C*D1*Dd*f*s**2 + 16*C*D1*Dd*f*s - 4*C*D1*Dd*f + 16*C*D1*Dd*fd*r*s - 2*C*D1*Dd*fd*r + 16*C*D1*Dd*fd*s**2 - 16*C*D1*Dd*fd*s + 2*C*D1*Dd*fd + 8*C*D1*Ddd*f*r*s - 2*C*D1*Ddd*f*r + 8*C*D1*Ddd*f*s**2 - 8*C*D1*Ddd*f*s + 2*C*D1*Ddd*f + 24*C*Dd**2*f*r*s - 6*C*Dd**2*f*r + 24*C*Dd**2*f*s**2 - 24*C*Dd**2*f*s + 4*C*Dd**2*f - 33*D1**2*K*fd*r*s + 33*D1**2*K*fd*r - 33*D1**2*K*fd*s**2 + 66*D1**2*K*fd*s - 33*D1**2*K*fd + 6*D1**2*K*fdd*r*s - 6*D1**2*K*fdd*r + 6*D1**2*K*fdd*s**2 - 12*D1**2*K*fdd*s + 6*D1**2*K*fdd - 7*D1**2*bdd1*(K - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - 48*D1**2*f*fd*r*s - 21*D1**2*f*fd*r - 48*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s + 21*D1**2*f*fd + 24*D1**2*f*fdd*r*s + 12*D1**2*f*fdd*r + 24*D1**2*f*fdd*s**2 + 6*D1**2*f*fdd*s - 12*D1**2*f*fdd + 24*D1**2*fd**2*r*s + 12*D1**2*fd**2*r + 24*D1**2*fd**2*s**2 + 6*D1**2*fd**2*s - 12*D1**2*fd**2 - D1**2*fd*r*s - 20*D1**2*fd*r - D1**2*fd*s**2 - 44*D1**2*fd*s + 20*D1**2*fd + 4*D1**2*fdd*r*s + 3*D1**2*fdd*r + 4*D1**2*fdd*s**2 + 8*D1**2*fdd*s - 3*D1**2*fdd - 28*D1**2*gd2*r*s - 28*D1**2*gd2*s**2 + 28*D1**2*gd2*s + 14*D1**2*gdd2*r*s + 14*D1**2*gdd2*s**2 - 14*D1**2*gdd2*s - 132*D1*Dd*K*f*r*s + 33*D1*Dd*K*f*r - 132*D1*Dd*K*f*s**2 + 132*D1*Dd*K*f*s - 33*D1*Dd*K*f + 48*D1*Dd*K*fd*r*s - 30*D1*Dd*K*fd*r + 48*D1*Dd*K*fd*s**2 - 72*D1*Dd*K*fd*s + 24*D1*Dd*K*fd - 96*D1*Dd*f**2*r*s + 24*D1*Dd*f**2*r - 96*D1*Dd*f**2*s**2 + 96*D1*Dd*f**2*s - 24*D1*Dd*f**2 + 192*D1*Dd*f*fd*r*s + 24*D1*Dd*f*fd*r + 192*D1*Dd*f*fd*s**2 - 72*D1*Dd*f*fd*s - 30*D1*Dd*f*fd - 4*D1*Dd*f*r*s + D1*Dd*f*r - 4*D1*Dd*f*s**2 + 4*D1*Dd*f*s - D1*Dd*f + 32*D1*Dd*fd*r*s + 8*D1*Dd*fd*r + 32*D1*Dd*fd*s**2 + 16*D1*Dd*fd*s - 14*D1*Dd*fd - 112*D1*Dd*g2*r*s + 28*D1*Dd*g2*r - 112*D1*Dd*g2*s**2 + 112*D1*Dd*g2*s - 28*D1*Dd*g2 + 112*D1*Dd*gd2*r*s - 14*D1*Dd*gd2*r + 112*D1*Dd*gd2*s**2 - 112*D1*Dd*gd2*s + 14*D1*Dd*gd2 + 24*D1*Ddd*K*f*r*s - 6*D1*Ddd*K*f*r + 24*D1*Ddd*K*f*s**2 - 24*D1*Ddd*K*f*s + 6*D1*Ddd*K*f + 48*D1*Ddd*f**2*r*s - 12*D1*Ddd*f**2*r + 48*D1*Ddd*f**2*s**2 - 48*D1*Ddd*f**2*s + 12*D1*Ddd*f**2 + 16*D1*Ddd*f*r*s - 4*D1*Ddd*f*r + 16*D1*Ddd*f*s**2 - 16*D1*Ddd*f*s + 4*D1*Ddd*f + 56*D1*Ddd*g2*r*s - 14*D1*Ddd*g2*r + 56*D1*Ddd*g2*s**2 - 56*D1*Ddd*g2*s + 14*D1*Ddd*g2 + 7*D1*bd1*(K - 1)*(D1*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + Dd*(-24*r*s + 7*r - 24*s**2 + 24*s - 5)) + 72*Dd**2*K*f*r*s - 18*Dd**2*K*f*r + 72*Dd**2*K*f*s**2 - 72*Dd**2*K*f*s + 12*Dd**2*K*f + 144*Dd**2*f**2*r*s - 36*Dd**2*f**2*r + 144*Dd**2*f**2*s**2 - 144*Dd**2*f**2*s + 24*Dd**2*f**2 + 48*Dd**2*f*r*s - 12*Dd**2*f*r + 48*Dd**2*f*s**2 - 48*Dd**2*f*s + 8*Dd**2*f + 168*Dd**2*g2*r*s - 42*Dd**2*g2*r + 168*Dd**2*g2*s**2 - 168*Dd**2*g2*s + 28*Dd**2*g2) - 11*b1*(36*C*D1**2*f*fd*r*s - 18*C*D1**2*f*fd*r + 36*C*D1**2*f*fd*s**2 - 54*C*D1**2*f*fd*s + 18*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r*s + 12*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 + 36*C*D1**2*f*fdd*s - 12*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r*s + 12*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 + 36*C*D1**2*fd**2*s - 12*C*D1**2*fd**2 + 72*C*D1*Dd*f**2*r*s - 18*C*D1*Dd*f**2*r + 72*C*D1*Dd*f**2*s**2 - 72*C*D1*Dd*f**2*s + 18*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r*s + 72*C*D1*Dd*f*fd*r - 192*C*D1*Dd*f*fd*s**2 + 240*C*D1*Dd*f*fd*s - 60*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 48*C*D1*Ddd*f**2*s - 12*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 144*C*Dd**2*f**2*s - 24*C*Dd**2*f**2 - 60*D1**2*K*f*fd*r*s + 30*D1**2*K*f*fd*r - 60*D1**2*K*f*fd*s**2 + 60*D1**2*K*f*fd*s - 30*D1**2*K*f*fd + 36*D1**2*K*f*fdd*r*s - 18*D1**2*K*f*fdd*r + 36*D1**2*K*f*fdd*s**2 - 36*D1**2*K*f*fdd*s + 18*D1**2*K*f*fdd + 36*D1**2*K*fd**2*r*s - 18*D1**2*K*fd**2*r + 36*D1**2*K*fd**2*s**2 - 36*D1**2*K*fd**2*s + 7*D1**2*bd1**2*(K - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - D1**2*bdd1*(6*f**2*(4*r*(s - 1) + 4*s**2 - 9*s + 4) + f*(C*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 12*K*s**2 - 6*K*s + r*(12*K*s + 8*s - 7) + 8*s**2 - 20*s + 7) + 14*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 54*D1**2*f**2*fd*r*s + 18*D1**2*f**2*fd*r - 54*D1**2*f**2*fd*s**2 + 60*D1**2*f**2*fd*s - 18*D1**2*f**2*fd - 4*D1**2*f*fd*r*s + 19*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 34*D1**2*f*fd*s - 19*D1**2*f*fd - 9*D1**2*f*fdd*r - 18*D1**2*f*fdd*s + 9*D1**2*f*fdd - 66*D1**2*f*gd2*r*s - 66*D1**2*f*gd2*s**2 + 66*D1**2*f*gd2*s + 12*D1**2*f*gdd2*r*s + 12*D1**2*f*gdd2*s**2 - 12*D1**2*f*gdd2*s - 9*D1**2*fd**2*r - 18*D1**2*fd**2*s + 9*D1**2*fd**2 - 66*D1**2*fd*g2*r*s + 66*D1**2*fd*g2*r - 66*D1**2*fd*g2*s**2 + 132*D1**2*fd*g2*s - 66*D1**2*fd*g2 + 24*D1**2*fd*gd2*r*s - 12*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 36*D1**2*fd*gd2*s + 12*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*r + 12*D1**2*fdd*g2*s**2 - 24*D1**2*fdd*g2*s + 12*D1**2*fdd*g2 - 120*D1*Dd*K*f**2*r*s + 30*D1*Dd*K*f**2*r - 120*D1*Dd*K*f**2*s**2 + 120*D1*Dd*K*f**2*s - 30*D1*Dd*K*f**2 + 288*D1*Dd*K*f*fd*r*s - 108*D1*Dd*K*f*fd*r + 288*D1*Dd*K*f*fd*s**2 - 288*D1*Dd*K*f*fd*s + 72*D1*Dd*K*f*fd - 72*D1*Dd*f**3*r*s + 18*D1*Dd*f**3*r - 72*D1*Dd*f**3*s**2 + 72*D1*Dd*f**3*s - 18*D1*Dd*f**3 - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 8*D1*Dd*f**2*s - 2*D1*Dd*f**2 - 36*D1*Dd*f*fd*r - 72*D1*Dd*f*fd*s + 36*D1*Dd*f*fd - 264*D1*Dd*f*g2*r*s + 66*D1*Dd*f*g2*r - 264*D1*Dd*f*g2*s**2 + 264*D1*Dd*f*g2*s - 66*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r*s - 12*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 96*D1*Dd*f*gd2*s + 12*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r*s - 60*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 144*D1*Dd*fd*g2*s + 48*D1*Dd*fd*g2 + 72*D1*Ddd*K*f**2*r*s - 18*D1*Ddd*K*f**2*r + 72*D1*Ddd*K*f**2*s**2 - 72*D1*Ddd*K*f**2*s + 18*D1*Ddd*K*f**2 + 48*D1*Ddd*f*g2*r*s - 12*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 48*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + D1*bd1*(D1*(3*f**2*(r*(16*s - 15) + 16*s**2 - 34*s + 15) + f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + 66*K*r*s + 66*K*s**2 - 33*K*s - 6*fd*(4*s - 1)*(4*r + 4*s - 3) + 2*r*s - 21*r + 2*s**2 - 47*s + 21) + fd*(C*r*(2 - 8*s) - 2*C*(1 - 2*s)**2 - 6*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 16*r*s + r - 16*s**2 + 4*s + 5) + 14*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 14*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd*(3*f**2*(4*r*(8*s - 5) + 32*s**2 - 52*s + 17) + f*(2*C*r*(8*s - 3) + 4*C*(1 - 2*s)**2 + K*(6*r*(8*s - 1) + 48*s**2 - 36*s + 3) + 32*r*s - 18*r + 32*s**2 - 56*s + 17) + 14*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 216*Dd**2*K*f**2*r*s - 54*Dd**2*K*f**2*r + 216*Dd**2*K*f**2*s**2 - 216*Dd**2*K*f**2*s + 36*Dd**2*K*f**2 + 144*Dd**2*f*g2*r*s - 36*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 144*Dd**2*f*g2*s + 24*Dd**2*f*g2) + 66*b2*(D1**2*(f*(5*fd - 3*fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 3*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct**2*k1**2*k2*(D1*(-2*D1*bd1**2*(9*K*f*(2*s - 1)*(r + s - 1) - f*(12*C - 9)*(r*(2*s - 1) + s*(2*s - 2)) + 14*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*b2*(bd1*(D1*(11*f*(s - 1)*(r + s - 1) + 9*fd*(-2*r*s + r - s*(2*s - 2))) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + bd1*(-18*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(6*f**2*(r + s - 1)*(6*C*(s - 1) - s*(K + 1) + 1) + f*(-fd*(30*C - 15)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (-44*g2*(s - 1) - 36*gd2*(1 - 2*s))*(r + s - 1)) + 36*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + f*(-3*D1*bdd1*(s - 1)*(f*(10*C - 5) - 12*g2)*(r + s - 1) + D1*(f*(-fd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(-6*bd2 + 12*gd2)*(r + s - 1)) + 12*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**3*(D1**2*s*(17*fd - 12*fdd)*(r + s - 1) + D1*Dd*(17*f*(r*(4*s - 1) + (1 - 2*s)**2) - 12*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 2*(14*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(-14*K + 12*f + 7) - Dd**2*(-14*K + 12*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-6*C*D1**2*fd*r*s - 6*C*D1**2*fd*s**2 + 6*C*D1**2*fd*s + 24*C*D1**2*fdd*r*s + 24*C*D1**2*fdd*s**2 - 24*C*D1**2*fdd*s - 24*C*D1*Dd*f*r*s + 6*C*D1*Dd*f*r - 24*C*D1*Dd*f*s**2 + 24*C*D1*Dd*f*s - 6*C*D1*Dd*f + 192*C*D1*Dd*fd*r*s - 24*C*D1*Dd*fd*r + 192*C*D1*Dd*fd*s**2 - 192*C*D1*Dd*fd*s + 24*C*D1*Dd*fd + 96*C*D1*Ddd*f*r*s - 24*C*D1*Ddd*f*r + 96*C*D1*Ddd*f*s**2 - 96*C*D1*Ddd*f*s + 24*C*D1*Ddd*f + 288*C*Dd**2*f*r*s - 72*C*Dd**2*f*r + 288*C*Dd**2*f*s**2 - 288*C*Dd**2*f*s + 48*C*Dd**2*f + 22*D1**2*K*fd*r*s + 22*D1**2*K*fd*s**2 - 18*D1**2*K*fdd*r*s - 18*D1**2*K*fdd*s**2 - D1**2*bdd1*(-14*K + 12*f + 7)*(3*r*s - r + 3*s**2 - 3*s + 1) + 24*D1**2*f*fd*r*s + 6*D1**2*f*fd*r + 24*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s - 6*D1**2*f*fd + 15*D1**2*fd*r*s + 15*D1**2*fd*s**2 - D1**2*fd*s - 18*D1**2*fdd*r*s - 18*D1**2*fdd*s**2 + 18*D1**2*fdd*s + 56*D1**2*gd2*r*s + 56*D1**2*gd2*s**2 - 56*D1**2*gd2*s - 28*D1**2*gdd2*r*s - 28*D1**2*gdd2*s**2 + 28*D1**2*gdd2*s + 88*D1*Dd*K*f*r*s - 22*D1*Dd*K*f*r + 88*D1*Dd*K*f*s**2 - 88*D1*Dd*K*f*s + 22*D1*Dd*K*f - 144*D1*Dd*K*fd*r*s + 18*D1*Dd*K*fd*r - 144*D1*Dd*K*fd*s**2 + 72*D1*Dd*K*fd*s + 48*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 48*D1*Dd*f**2*s + 12*D1*Dd*f**2 + 60*D1*Dd*f*r*s - 15*D1*Dd*f*r + 60*D1*Dd*f*s**2 - 60*D1*Dd*f*s + 15*D1*Dd*f - 144*D1*Dd*fd*r*s + 18*D1*Dd*fd*r - 144*D1*Dd*fd*s**2 + 144*D1*Dd*fd*s - 18*D1*Dd*fd + 224*D1*Dd*g2*r*s - 56*D1*Dd*g2*r + 224*D1*Dd*g2*s**2 - 224*D1*Dd*g2*s + 56*D1*Dd*g2 - 224*D1*Dd*gd2*r*s + 28*D1*Dd*gd2*r - 224*D1*Dd*gd2*s**2 + 224*D1*Dd*gd2*s - 28*D1*Dd*gd2 - 72*D1*Ddd*K*f*r*s + 18*D1*Ddd*K*f*r - 72*D1*Ddd*K*f*s**2 + 72*D1*Ddd*K*f*s - 18*D1*Ddd*K*f - 72*D1*Ddd*f*r*s + 18*D1*Ddd*f*r - 72*D1*Ddd*f*s**2 + 72*D1*Ddd*f*s - 18*D1*Ddd*f - 112*D1*Ddd*g2*r*s + 28*D1*Ddd*g2*r - 112*D1*Ddd*g2*s**2 + 112*D1*Ddd*g2*s - 28*D1*Ddd*g2 + D1*bd1*(D1*(17*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 12*fd*(6*r*s - r + 6*s**2 - 6*s + 1) - 2*(14*K - 7)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(-14*K + 12*f + 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 216*Dd**2*K*f*r*s + 54*Dd**2*K*f*r - 216*Dd**2*K*f*s**2 + 216*Dd**2*K*f*s - 36*Dd**2*K*f - 216*Dd**2*f*r*s + 54*Dd**2*f*r - 216*Dd**2*f*s**2 + 216*Dd**2*f*s - 36*Dd**2*f - 336*Dd**2*g2*r*s + 84*Dd**2*g2*r - 336*Dd**2*g2*s**2 + 336*Dd**2*g2*s - 56*Dd**2*g2) - b1*(-72*C*D1**2*f*fd*r*s - 72*C*D1**2*f*fd*s**2 + 36*C*D1**2*f*fd*s + 60*C*D1**2*f*fdd*r*s + 60*C*D1**2*f*fdd*s**2 - 30*C*D1**2*f*fdd*s + 60*C*D1**2*fd**2*r*s + 60*C*D1**2*fd**2*s**2 - 30*C*D1**2*fd**2*s - 144*C*D1*Dd*f**2*r*s + 36*C*D1*Dd*f**2*r - 144*C*D1*Dd*f**2*s**2 + 144*C*D1*Dd*f**2*s - 36*C*D1*Dd*f**2 + 480*C*D1*Dd*f*fd*r*s - 60*C*D1*Dd*f*fd*r + 480*C*D1*Dd*f*fd*s**2 - 360*C*D1*Dd*f*fd*s + 30*C*D1*Dd*f*fd + 120*C*D1*Ddd*f**2*r*s - 30*C*D1*Ddd*f**2*r + 120*C*D1*Ddd*f**2*s**2 - 120*C*D1*Ddd*f**2*s + 30*C*D1*Ddd*f**2 + 360*C*Dd**2*f**2*r*s - 90*C*Dd**2*f**2*r + 360*C*Dd**2*f**2*s**2 - 360*C*Dd**2*f**2*s + 60*C*Dd**2*f**2 + 12*D1**2*K*f*fd*r*s - 6*D1**2*K*f*fd*r + 12*D1**2*K*f*fd*s**2 - 12*D1**2*K*f*fd*s + 6*D1**2*K*f*fd - 22*D1**2*b2*fd*r*s - 22*D1**2*b2*fd*s**2 + 18*D1**2*b2*fdd*r*s + 18*D1**2*b2*fdd*s**2 + D1**2*bd1**2*(-14*K + 12*f + 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 22*D1**2*bd2*f*r*s - 22*D1**2*bd2*f*s**2 + 22*D1**2*bd2*f*s + 36*D1**2*bd2*fd*r*s + 36*D1**2*bd2*fd*s**2 - 18*D1**2*bd2*fd*s - 2*D1**2*bdd1*(3*f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) - 3*K*(2*s - 1)*(r + s - 1) - 6*r*s + 3*r - 6*s**2 + 6*s - 3) - 14*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 18*D1**2*bdd2*f*r*s + 18*D1**2*bdd2*f*s**2 - 18*D1**2*bdd2*f*s + 12*D1**2*f*fd*r*s + 12*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s - 30*D1**2*f*fdd*r*s - 30*D1**2*f*fdd*s**2 + 15*D1**2*f*fdd*s + 44*D1**2*f*gd2*r*s + 44*D1**2*f*gd2*s**2 - 44*D1**2*f*gd2*s - 36*D1**2*f*gdd2*r*s - 36*D1**2*f*gdd2*s**2 + 36*D1**2*f*gdd2*s - 30*D1**2*fd**2*r*s - 30*D1**2*fd**2*s**2 + 15*D1**2*fd**2*s + 44*D1**2*fd*g2*r*s + 44*D1**2*fd*g2*s**2 - 72*D1**2*fd*gd2*r*s - 72*D1**2*fd*gd2*s**2 + 36*D1**2*fd*gd2*s - 36*D1**2*fdd*g2*r*s - 36*D1**2*fdd*g2*s**2 + 24*D1*Dd*K*f**2*r*s - 6*D1*Dd*K*f**2*r + 24*D1*Dd*K*f**2*s**2 - 24*D1*Dd*K*f**2*s + 6*D1*Dd*K*f**2 - 88*D1*Dd*b2*f*r*s + 22*D1*Dd*b2*f*r - 88*D1*Dd*b2*f*s**2 + 88*D1*Dd*b2*f*s - 22*D1*Dd*b2*f + 144*D1*Dd*b2*fd*r*s - 18*D1*Dd*b2*fd*r + 144*D1*Dd*b2*fd*s**2 - 72*D1*Dd*b2*fd*s + 144*D1*Dd*bd2*f*r*s - 18*D1*Dd*bd2*f*r + 144*D1*Dd*bd2*f*s**2 - 144*D1*Dd*bd2*f*s + 18*D1*Dd*bd2*f + 24*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 240*D1*Dd*f*fd*r*s + 30*D1*Dd*f*fd*r - 240*D1*Dd*f*fd*s**2 + 180*D1*Dd*f*fd*s - 15*D1*Dd*f*fd + 176*D1*Dd*f*g2*r*s - 44*D1*Dd*f*g2*r + 176*D1*Dd*f*g2*s**2 - 176*D1*Dd*f*g2*s + 44*D1*Dd*f*g2 - 288*D1*Dd*f*gd2*r*s + 36*D1*Dd*f*gd2*r - 288*D1*Dd*f*gd2*s**2 + 288*D1*Dd*f*gd2*s - 36*D1*Dd*f*gd2 - 288*D1*Dd*fd*g2*r*s + 36*D1*Dd*fd*g2*r - 288*D1*Dd*fd*g2*s**2 + 144*D1*Dd*fd*g2*s + 72*D1*Ddd*b2*f*r*s - 18*D1*Ddd*b2*f*r + 72*D1*Ddd*b2*f*s**2 - 72*D1*Ddd*b2*f*s + 18*D1*Ddd*b2*f - 60*D1*Ddd*f**2*r*s + 15*D1*Ddd*f**2*r - 60*D1*Ddd*f**2*s**2 + 60*D1*Ddd*f**2*s - 15*D1*Ddd*f**2 - 144*D1*Ddd*f*g2*r*s + 36*D1*Ddd*f*g2*r - 144*D1*Ddd*f*g2*s**2 + 144*D1*Ddd*f*g2*s - 36*D1*Ddd*f*g2 + D1*bd1*(-D1*(24*C*fd*(r*(4*s - 1) + (1 - 2*s)**2) + 6*f**2*(4*s - 3)*(r + s - 1) + f*(-6*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 22*K*(2*s - 1)*(r + s - 1) + 30*r*s - 15*r + 30*s**2 - 44*s + 15) - 18*fd*(r*(K + 1)*(4*s - 1) + s**2*(4*K + 4) - s*(3*K + 4) + 1) + 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 28*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(-24*C*f*(r*(8*s - 3) + 2*(1 - 2*s)**2) + 9*f*(K*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) + 2*r*(8*s - 3) + 4*(1 - 2*s)**2) + 28*g2*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 216*Dd**2*b2*f*r*s - 54*Dd**2*b2*f*r + 216*Dd**2*b2*f*s**2 - 216*Dd**2*b2*f*s + 36*Dd**2*b2*f - 180*Dd**2*f**2*r*s + 45*Dd**2*f**2*r - 180*Dd**2*f**2*s**2 + 180*Dd**2*f**2*s - 30*Dd**2*f**2 - 432*Dd**2*f*g2*r*s + 108*Dd**2*f*g2*r - 432*Dd**2*f*g2*s**2 + 432*Dd**2*f*g2*s - 72*Dd**2*f*g2))/(21*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct**2*k1**2*st**2*(D1*f*(3*D1*bd1**2*s*(2*f + 1)*(2*r + 2*s - 1) + D1*bd1*(-5*f*s*(r + s) + 3*fd*(r*(4*s - 1) + s*(4*s - 3))) + 3*D1*bdd1*f*s*(r + s) + 3*Dd*bd1*f*(r*(8*s - 1) + 4*s*(2*s - 1))) + b1**2*(D1**2*(r + s - 1)*(6*fd**2*(2*s - 1) + fd*(-18*f*s + 9*f - 13*s + 13) + 3*fdd*(f*(4*s - 2) + s - 1)) + D1*(Dd*(-9*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(6*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5) - 13*r*(4*s - 1) - 13*(1 - 2*s)**2) + 3*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 3*Ddd*f*(2*f + 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd**2*f*(2*f + 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(6*bdd1*f**2*s*(2*r + 2*s - 1) + f*(3*bdd1*s*(2*r + 2*s - 1) - 5*fd*(2*s - 1)*(r + s - 1) + 3*fdd*(2*s - 1)*(r + s - 1)) + 3*fd**2*(2*s - 1)*(r + s - 1)) + D1*bd1*(D1*(-f*s*(9*f + 13)*(2*r + 2*s - 1) + 3*fd*(2*f*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + 4*r*s - 2*r + 4*s**2 - 5*s + 1)) + 3*Dd*f*(2*f + 1)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + D1*f*(Dd*(-5*f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*fd*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 3*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 3*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k2*k3) - 2*D1**2*Pkd2*Pkd3*ct**2*k1**2*(6*D1**2*bd1**2*f*(-2*r*s + r - s*(2*s - 2)) - D1*b1*(D1*bd1**2*(6*f + 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 6*D1*bdd1*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + bd1*(D1*(-5*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 6*fd*(r*(4*s - 1) + (1 - 2*s)**2)) + 12*Dd*f*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + b1**3*(D1**2*s*(5*fd - 6*fdd)*(r + s - 1) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 14*r*(4*s - 1) + 14*(1 - 2*s)**2) - D1*Ddd*(6*f + 7)*(r*(4*s - 1) + (1 - 2*s)**2) - Dd**2*(6*f + 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-D1**2*bdd1*(6*f + 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 5*D1**2*fd*r*s + 5*D1**2*fd*s**2 - 5*D1**2*fd*s - 6*D1**2*fdd*r*s - 6*D1**2*fdd*s**2 + 6*D1**2*fdd*s + 20*D1*Dd*f*r*s - 5*D1*Dd*f*r + 20*D1*Dd*f*s**2 - 20*D1*Dd*f*s + 5*D1*Dd*f - 48*D1*Dd*fd*r*s + 6*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 + 48*D1*Dd*fd*s - 6*D1*Dd*fd - 24*D1*Ddd*f*r*s + 6*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 24*D1*Ddd*f*s - 6*D1*Ddd*f + D1*bd1*(D1*(5*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 6*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + 42*r*s - 14*r + 42*s**2 - 42*s + 14) - Dd*(6*f + 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 72*Dd**2*f*r*s + 18*Dd**2*f*r - 72*Dd**2*f*s**2 + 72*Dd**2*f*s - 12*Dd**2*f))/(21*d**2*k2*k3) - 2*D1**2*Pkd2*Pkd3*ct**2*k2**5*st**2*(8*C*D1**2*b1*f*fd*r*s + 8*C*D1**2*b1*f*fd*s**2 - 4*C*D1**2*b1*f*fd*s - 4*C*D1**2*b1*f*fdd*r*s - 4*C*D1**2*b1*f*fdd*s**2 + 2*C*D1**2*b1*f*fdd*s - 4*C*D1**2*b1*fd**2*r*s - 4*C*D1**2*b1*fd**2*s**2 + 2*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r*s + 2*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 6*C*D1**2*f**2*fd*s - 2*C*D1**2*f**2*fd + 16*C*D1*Dd*b1*f**2*r*s - 4*C*D1*Dd*b1*f**2*r + 16*C*D1*Dd*b1*f**2*s**2 - 16*C*D1*Dd*b1*f**2*s + 4*C*D1*Dd*b1*f**2 - 32*C*D1*Dd*b1*f*fd*r*s + 4*C*D1*Dd*b1*f*fd*r - 32*C*D1*Dd*b1*f*fd*s**2 + 24*C*D1*Dd*b1*f*fd*s - 2*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r*s + 2*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 8*C*D1*Dd*f**3*s - 2*C*D1*Dd*f**3 - 8*C*D1*Ddd*b1*f**2*r*s + 2*C*D1*Ddd*b1*f**2*r - 8*C*D1*Ddd*b1*f**2*s**2 + 8*C*D1*Ddd*b1*f**2*s - 2*C*D1*Ddd*b1*f**2 - 24*C*Dd**2*b1*f**2*r*s + 6*C*Dd**2*b1*f**2*r - 24*C*Dd**2*b1*f**2*s**2 + 24*C*Dd**2*b1*f**2*s - 4*C*Dd**2*b1*f**2 + 2*D1**2*K*b1**2*fd*r*s + 2*D1**2*K*b1**2*fd*s**2 - D1**2*K*b1**2*fdd*r*s - D1**2*K*b1**2*fdd*s**2 - 2*D1**2*K*b1*f*fd*r*s + D1**2*K*b1*f*fd*r - 2*D1**2*K*b1*f*fd*s**2 + 2*D1**2*K*b1*f*fd*s - D1**2*K*b1*f*fd - D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 4*D1**2*b1*f*fd*r*s - 4*D1**2*b1*f*fd*s**2 + 2*D1**2*b1*f*fd*s + 2*D1**2*b1*f*fdd*r*s + 2*D1**2*b1*f*fdd*s**2 - D1**2*b1*f*fdd*s - 4*D1**2*b1*f*gd2*r*s - 4*D1**2*b1*f*gd2*s**2 + 4*D1**2*b1*f*gd2*s + 2*D1**2*b1*f*gdd2*r*s + 2*D1**2*b1*f*gdd2*s**2 - 2*D1**2*b1*f*gdd2*s + 2*D1**2*b1*fd**2*r*s + 2*D1**2*b1*fd**2*s**2 - D1**2*b1*fd**2*s - 4*D1**2*b1*fd*g2*r*s - 4*D1**2*b1*fd*g2*s**2 + 4*D1**2*b1*fd*gd2*r*s + 4*D1**2*b1*fd*gd2*s**2 - 2*D1**2*b1*fd*gd2*s + 2*D1**2*b1*fdd*g2*r*s + 2*D1**2*b1*fdd*g2*s**2 - D1**2*bdd1*f*(r + s - 1)*(K*b1*(2*s - 1) + f*(2*C - 1)*(s - 1) - 2*g2*(s - 1)) + 3*D1**2*f**2*fd*r*s - D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 3*D1**2*f**2*fd*s + D1**2*f**2*fd + 2*D1**2*f**2*gd2*r*s + 2*D1**2*f**2*gd2*s**2 - 2*D1**2*f**2*gd2*s + 4*D1**2*f*fd*g2*r*s - 2*D1**2*f*fd*g2*r + 4*D1**2*f*fd*g2*s**2 - 4*D1**2*f*fd*g2*s + 2*D1**2*f*fd*g2 + 8*D1*Dd*K*b1**2*f*r*s - 2*D1*Dd*K*b1**2*f*r + 8*D1*Dd*K*b1**2*f*s**2 - 8*D1*Dd*K*b1**2*f*s + 2*D1*Dd*K*b1**2*f - 8*D1*Dd*K*b1**2*fd*r*s + D1*Dd*K*b1**2*fd*r - 8*D1*Dd*K*b1**2*fd*s**2 + 4*D1*Dd*K*b1**2*fd*s - 4*D1*Dd*K*b1*f**2*r*s + D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s**2 + 4*D1*Dd*K*b1*f**2*s - D1*Dd*K*b1*f**2 - 8*D1*Dd*b1*f**2*r*s + 2*D1*Dd*b1*f**2*r - 8*D1*Dd*b1*f**2*s**2 + 8*D1*Dd*b1*f**2*s - 2*D1*Dd*b1*f**2 + 16*D1*Dd*b1*f*fd*r*s - 2*D1*Dd*b1*f*fd*r + 16*D1*Dd*b1*f*fd*s**2 - 12*D1*Dd*b1*f*fd*s + D1*Dd*b1*f*fd - 16*D1*Dd*b1*f*g2*r*s + 4*D1*Dd*b1*f*g2*r - 16*D1*Dd*b1*f*g2*s**2 + 16*D1*Dd*b1*f*g2*s - 4*D1*Dd*b1*f*g2 + 16*D1*Dd*b1*f*gd2*r*s - 2*D1*Dd*b1*f*gd2*r + 16*D1*Dd*b1*f*gd2*s**2 - 16*D1*Dd*b1*f*gd2*s + 2*D1*Dd*b1*f*gd2 + 16*D1*Dd*b1*fd*g2*r*s - 2*D1*Dd*b1*fd*g2*r + 16*D1*Dd*b1*fd*g2*s**2 - 8*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r*s - D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s + D1*Dd*f**3 + 8*D1*Dd*f**2*g2*r*s - 2*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s**2 - 8*D1*Dd*f**2*g2*s + 2*D1*Dd*f**2*g2 - 4*D1*Ddd*K*b1**2*f*r*s + D1*Ddd*K*b1**2*f*r - 4*D1*Ddd*K*b1**2*f*s**2 + 4*D1*Ddd*K*b1**2*f*s - D1*Ddd*K*b1**2*f + 4*D1*Ddd*b1*f**2*r*s - D1*Ddd*b1*f**2*r + 4*D1*Ddd*b1*f**2*s**2 - 4*D1*Ddd*b1*f**2*s + D1*Ddd*b1*f**2 + 8*D1*Ddd*b1*f*g2*r*s - 2*D1*Ddd*b1*f*g2*r + 8*D1*Ddd*b1*f*g2*s**2 - 8*D1*Ddd*b1*f*g2*s + 2*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(4*C*(s - 1) - s*(K + 2) + 2) + f*(-fd*(2*C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(-2*r - 2*s + 2)) + fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(K*b1*(-16*r*s + 6*r - 16*s**2 + 20*s - 5) - f*(2*C - 1)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 12*Dd**2*K*b1**2*f*r*s + 3*Dd**2*K*b1**2*f*r - 12*Dd**2*K*b1**2*f*s**2 + 12*Dd**2*K*b1**2*f*s - 2*Dd**2*K*b1**2*f + 12*Dd**2*b1*f**2*r*s - 3*Dd**2*b1*f**2*r + 12*Dd**2*b1*f**2*s**2 - 12*Dd**2*b1*f**2*s + 2*Dd**2*b1*f**2 + 24*Dd**2*b1*f*g2*r*s - 6*Dd**2*b1*f*g2*r + 24*Dd**2*b1*f*g2*s**2 - 24*Dd**2*b1*f*g2*s + 4*Dd**2*b1*f*g2)/(7*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct**2*k2**3*st**2*(D1*(D1*K*bd1**2*f*(r + 2*s - 1) + K*b1**2*(r + 2*s - 1)*(2*D1*fd - D1*fdd - 4*Dd*fd) + b1*(D1*f*(K*bdd1*r + 2*K*bdd1*s - K*bdd1 - bdd2*r*s - bdd2*s**2 + bdd2*s + fd*(4*C*(r + 2*s - 1) + K*(-2*r*s + r - 2*s**2 + 2*s - 1) - 2*r - 4*s + 2) - fdd*(2*C - 1)*(r + 2*s - 1)) - D1*(r + 2*s - 1)*(fd**2*(2*C - 1) + fd*(4*g2 - 2*gd2) - 2*fdd*g2) - Dd*K*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + Dd*f*fd*(4 - 8*C)*(r + 2*s - 1) + 8*Dd*fd*g2*(r + 2*s - 1) + bd2*(D1*s*(2*f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1))) - bd1*(D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(K*b1*fd*(r + 2*s - 1) + f**2*(4*C*(r + 2*s - 1) + K*r*s + K*s**2 - K*s - 2*r - 4*s + 2) - f*(r + 2*s - 1)*(-2*K*b1 + fd*(2*C - 1) + 4*g2 - 2*gd2)) - 4*Dd*f*(r + 2*s - 1)*(K*b1 + f*(2*C - 1) - 2*g2)) + f*(D1*bdd1*(f*(2*C - 1) - 2*g2)*(r + 2*s - 1) + D1*(f*(-fd*(2*C - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - s*(bd2 - 2*gd2)*(r + s - 1)) + 2*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(2*C - 1) - 2*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(7*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct**2*k2**3*(D1**2*bd1*(7*b2*f*(s - 1)*(r + s - 1) - (2*f*(6*C - 3) - 14*g2)*(bd1*r*(2*s - 1) + 2*bd1*s*(s - 1) + f*(r + 2*s - 1))) + D1*b1*(12*C*D1*f*fd*r + 24*C*D1*f*fd*s - 12*C*D1*f*fd - 7*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 7*D1*b2*fd*r*s + 7*D1*b2*fd*s**2 + 7*D1*bd2*f*r*s + 7*D1*bd2*f*s**2 - 7*D1*bd2*f*s - 2*D1*bdd1*(f*(6*C - 3) - 7*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 6*D1*f*fd*r - 12*D1*f*fd*s + 6*D1*f*fd - 14*D1*fd*g2*r - 28*D1*fd*g2*s + 14*D1*fd*g2 + 28*Dd*b2*f*r*s - 7*Dd*b2*f*r + 28*Dd*b2*f*s**2 - 28*Dd*b2*f*s + 7*Dd*b2*f + bd1*(D1*(24*C*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 7*K*f*(r + 2*s - 1) - 12*f*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - fd*(12*C - 6)*(r*(4*s - 1) + (1 - 2*s)**2) - 14*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) - 14*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 4*Dd*(f*(6*C - 3) - 7*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 7*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(D1**2*(24*C*fd*r*s + 24*C*fd*s**2 - 24*C*fd*s - 12*C*fdd*r*s - 12*C*fdd*s**2 + 12*C*fdd*s + 14*K*bd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*K*bdd1*(3*r*s - r + 3*s**2 - 3*s + 1) + 7*K*fd*r + 14*K*fd*s - 7*K*fd - 12*fd*r*s - 12*fd*s**2 + 12*fd*s + 6*fdd*r*s + 6*fdd*s**2 - 6*fdd*s - 28*gd2*r*s - 28*gd2*s**2 + 28*gd2*s + 14*gdd2*r*s + 14*gdd2*s**2 - 14*gdd2*s) + D1*(Dd*(-7*K*bd1*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + f*(24*C - 12)*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(12*C - 6)*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 28*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 14*gd2*(8*r*s - r + 8*s**2 - 8*s + 1)) - 2*Ddd*(f*(6*C - 3) - 7*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd**2*(f*(6*C - 3) - 7*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct**2*k2*st**2*(D1*(D1*K*bd1**2*f*s*(-2*r - 2*s + 1) - D1*bdd1*f*s*(r + s)*(f*(2*C - 1) - 2*g2) + b2*(D1*bd1*(2*f*s*(r + s) + fd*(-2*r*s + r - s*(2*s - 2))) - D1*bdd1*f*s*(r + s) + Dd*bd1*f*(-8*r*s + r + s*(4 - 8*s))) - bd1*(D1*(f**2*s*(2 - 4*C)*(r + s) + f*(fd*(2*C - 1)*(r*(4*s - 1) + s*(4*s - 3)) + s*(bd2*(2*r + 2*s - 1) + 4*g2*(r + s) + gd2*(-4*r - 4*s + 2))) + 2*fd*g2*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(f*(2*C - 1) - 2*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)))) + K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(8*C*D1**2*f*fd*r*s - 4*C*D1**2*f*fd*r + 8*C*D1**2*f*fd*s**2 - 12*C*D1**2*f*fd*s + 4*C*D1**2*f*fd - 4*C*D1**2*f*fdd*r*s + 2*C*D1**2*f*fdd*r - 4*C*D1**2*f*fdd*s**2 + 6*C*D1**2*f*fdd*s - 2*C*D1**2*f*fdd - 4*C*D1**2*fd**2*r*s + 2*C*D1**2*fd**2*r - 4*C*D1**2*fd**2*s**2 + 6*C*D1**2*fd**2*s - 2*C*D1**2*fd**2 + 16*C*D1*Dd*f**2*r*s - 4*C*D1*Dd*f**2*r + 16*C*D1*Dd*f**2*s**2 - 16*C*D1*Dd*f**2*s + 4*C*D1*Dd*f**2 - 32*C*D1*Dd*f*fd*r*s + 12*C*D1*Dd*f*fd*r - 32*C*D1*Dd*f*fd*s**2 + 40*C*D1*Dd*f*fd*s - 10*C*D1*Dd*f*fd - 8*C*D1*Ddd*f**2*r*s + 2*C*D1*Ddd*f**2*r - 8*C*D1*Ddd*f**2*s**2 + 8*C*D1*Ddd*f**2*s - 2*C*D1*Ddd*f**2 - 24*C*Dd**2*f**2*r*s + 6*C*Dd**2*f**2*r - 24*C*Dd**2*f**2*s**2 + 24*C*Dd**2*f**2*s - 4*C*Dd**2*f**2 + 4*D1**2*K*bd1*f*r*s + 4*D1**2*K*bd1*f*s**2 - 2*D1**2*K*bd1*f*s - 4*D1**2*K*bd1*fd*r*s + 2*D1**2*K*bd1*fd*r - 4*D1**2*K*bd1*fd*s**2 + 5*D1**2*K*bd1*fd*s - D1**2*K*bd1*fd - 2*D1**2*K*bdd1*f*r*s - 2*D1**2*K*bdd1*f*s**2 + D1**2*K*bdd1*f*s - D1**2*bdd2*f*r*s - D1**2*bdd2*f*s**2 + D1**2*bdd2*f*s - 4*D1**2*f*fd*r*s + 2*D1**2*f*fd*r - 4*D1**2*f*fd*s**2 + 6*D1**2*f*fd*s - 2*D1**2*f*fd + 2*D1**2*f*fdd*r*s - D1**2*f*fdd*r + 2*D1**2*f*fdd*s**2 - 3*D1**2*f*fdd*s + D1**2*f*fdd - 4*D1**2*f*gd2*r*s - 4*D1**2*f*gd2*s**2 + 4*D1**2*f*gd2*s + 2*D1**2*f*gdd2*r*s + 2*D1**2*f*gdd2*s**2 - 2*D1**2*f*gdd2*s + 2*D1**2*fd**2*r*s - D1**2*fd**2*r + 2*D1**2*fd**2*s**2 - 3*D1**2*fd**2*s + D1**2*fd**2 - 4*D1**2*fd*g2*r*s + 4*D1**2*fd*g2*r - 4*D1**2*fd*g2*s**2 + 8*D1**2*fd*g2*s - 4*D1**2*fd*g2 + 4*D1**2*fd*gd2*r*s - 2*D1**2*fd*gd2*r + 4*D1**2*fd*gd2*s**2 - 6*D1**2*fd*gd2*s + 2*D1**2*fd*gd2 + 2*D1**2*fdd*g2*r*s - 2*D1**2*fdd*g2*r + 2*D1**2*fdd*g2*s**2 - 4*D1**2*fdd*g2*s + 2*D1**2*fdd*g2 - 16*D1*Dd*K*bd1*f*r*s + 2*D1*Dd*K*bd1*f*r - 16*D1*Dd*K*bd1*f*s**2 + 12*D1*Dd*K*bd1*f*s - D1*Dd*K*bd1*f - 8*D1*Dd*f**2*r*s + 2*D1*Dd*f**2*r - 8*D1*Dd*f**2*s**2 + 8*D1*Dd*f**2*s - 2*D1*Dd*f**2 + 16*D1*Dd*f*fd*r*s - 6*D1*Dd*f*fd*r + 16*D1*Dd*f*fd*s**2 - 20*D1*Dd*f*fd*s + 5*D1*Dd*f*fd - 16*D1*Dd*f*g2*r*s + 4*D1*Dd*f*g2*r - 16*D1*Dd*f*g2*s**2 + 16*D1*Dd*f*g2*s - 4*D1*Dd*f*g2 + 16*D1*Dd*f*gd2*r*s - 2*D1*Dd*f*gd2*r + 16*D1*Dd*f*gd2*s**2 - 16*D1*Dd*f*gd2*s + 2*D1*Dd*f*gd2 + 16*D1*Dd*fd*g2*r*s - 10*D1*Dd*fd*g2*r + 16*D1*Dd*fd*g2*s**2 - 24*D1*Dd*fd*g2*s + 8*D1*Dd*fd*g2 + 4*D1*Ddd*f**2*r*s - D1*Ddd*f**2*r + 4*D1*Ddd*f**2*s**2 - 4*D1*Ddd*f**2*s + D1*Ddd*f**2 + 8*D1*Ddd*f*g2*r*s - 2*D1*Ddd*f*g2*r + 8*D1*Ddd*f*g2*s**2 - 8*D1*Ddd*f*g2*s + 2*D1*Ddd*f*g2 + D1*bd2*(D1*(r + s - 1)*(2*f*s - 2*fd*s + fd) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 12*Dd**2*f**2*r*s - 3*Dd**2*f**2*r + 12*Dd**2*f**2*s**2 - 12*Dd**2*f**2*s + 2*Dd**2*f**2 + 24*Dd**2*f*g2*r*s - 6*Dd**2*f*g2*r + 24*Dd**2*f*g2*s**2 - 24*Dd**2*f*g2*s + 4*Dd**2*f*g2 + b2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(7*d**2*k3) - 2*D1**2*Pkd2*Pkd3*ct**2*k2*(D1**2*bd1*(bd1*r*(2*s - 1) + 2*bd1*s*(s - 1) + f*s*(r + s))*(12*C*f + 7*b2 - 6*f - 14*g2) + D1*b1*(24*C*D1*bdd1*f*r*s - 12*C*D1*bdd1*f*r + 24*C*D1*bdd1*f*s**2 - 24*C*D1*bdd1*f*s + 12*C*D1*bdd1*f + 24*C*D1*f*fd*r*s - 12*C*D1*f*fd*r + 24*C*D1*f*fd*s**2 - 36*C*D1*f*fd*s + 12*C*D1*f*fd + 48*C*Dd*f**2*r*s - 12*C*Dd*f**2*r + 48*C*Dd*f**2*s**2 - 48*C*Dd*f**2*s + 12*C*Dd*f**2 + 7*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 7*D1*bd2*f*r*s + 7*D1*bd2*f*s**2 - 7*D1*bd2*f*s - 12*D1*bdd1*f*r*s + 6*D1*bdd1*f*r - 12*D1*bdd1*f*s**2 + 12*D1*bdd1*f*s - 6*D1*bdd1*f - 28*D1*bdd1*g2*r*s + 14*D1*bdd1*g2*r - 28*D1*bdd1*g2*s**2 + 28*D1*bdd1*g2*s - 14*D1*bdd1*g2 - 12*D1*f*fd*r*s + 6*D1*f*fd*r - 12*D1*f*fd*s**2 + 18*D1*f*fd*s - 6*D1*f*fd - 14*D1*f*gd2*r*s - 14*D1*f*gd2*s**2 + 14*D1*f*gd2*s - 14*D1*fd*g2*r*s + 14*D1*fd*g2*r - 14*D1*fd*g2*s**2 + 28*D1*fd*g2*s - 14*D1*fd*g2 - 24*Dd*f**2*r*s + 6*Dd*f**2*r - 24*Dd*f**2*s**2 + 24*Dd*f**2*s - 6*Dd*f**2 - 56*Dd*f*g2*r*s + 14*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 56*Dd*f*g2*s - 14*Dd*f*g2 - 7*b2*(-D1*bdd1*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - D1*fd*r*s + D1*fd*r - D1*fd*s**2 + 2*D1*fd*s - D1*fd - 4*Dd*f*r*s + Dd*f*r - 4*Dd*f*s**2 + 4*Dd*f*s - Dd*f + 2*bd1*(D1*r*(2*s - 1) + 2*D1*s**2 - 2*D1*s + D1 + Dd*r*(3 - 8*s) - 2*Dd*(1 - 2*s)**2)) + bd1*(7*D1*bd2*(r*(4*s - 1) + (1 - 2*s)**2) + D1*(f*(-24*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 14*K*s**2 - 7*K*s + 2*r*(7*K*s + 12*s - 6) + 24*s**2 - 24*s + 12) + fd*(12*C - 6)*(r*(4*s - 1) + (1 - 2*s)**2) + 14*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 14*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 4*Dd*(f*(6*C - 3) - 7*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 7*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(-24*C*D1**2*fd*r*s - 24*C*D1**2*fd*s**2 + 24*C*D1**2*fd*s + 12*C*D1**2*fdd*r*s + 12*C*D1**2*fdd*s**2 - 12*C*D1**2*fdd*s - 96*C*D1*Dd*f*r*s + 24*C*D1*Dd*f*r - 96*C*D1*Dd*f*s**2 + 96*C*D1*Dd*f*s - 24*C*D1*Dd*f + 96*C*D1*Dd*fd*r*s - 12*C*D1*Dd*fd*r + 96*C*D1*Dd*fd*s**2 - 96*C*D1*Dd*fd*s + 12*C*D1*Dd*fd + 48*C*D1*Ddd*f*r*s - 12*C*D1*Ddd*f*r + 48*C*D1*Ddd*f*s**2 - 48*C*D1*Ddd*f*s + 12*C*D1*Ddd*f + 144*C*Dd**2*f*r*s - 36*C*Dd**2*f*r + 144*C*Dd**2*f*s**2 - 144*C*Dd**2*f*s + 24*C*Dd**2*f - 42*D1**2*K*bd1*r*s + 14*D1**2*K*bd1*r - 42*D1**2*K*bd1*s**2 + 42*D1**2*K*bd1*s - 14*D1**2*K*bd1 + 21*D1**2*K*bdd1*r*s - 7*D1**2*K*bdd1*r + 21*D1**2*K*bdd1*s**2 - 21*D1**2*K*bdd1*s + 7*D1**2*K*bdd1 + 7*D1**2*K*fd*r*s - 7*D1**2*K*fd*r + 7*D1**2*K*fd*s**2 - 14*D1**2*K*fd*s + 7*D1**2*K*fd + 7*D1**2*bdd2*r*s + 7*D1**2*bdd2*s**2 - 7*D1**2*bdd2*s + 12*D1**2*fd*r*s + 12*D1**2*fd*s**2 - 12*D1**2*fd*s - 6*D1**2*fdd*r*s - 6*D1**2*fdd*s**2 + 6*D1**2*fdd*s + 28*D1**2*gd2*r*s + 28*D1**2*gd2*s**2 - 28*D1**2*gd2*s - 14*D1**2*gdd2*r*s - 14*D1**2*gdd2*s**2 + 14*D1**2*gdd2*s + 168*D1*Dd*K*bd1*r*s - 49*D1*Dd*K*bd1*r + 168*D1*Dd*K*bd1*s**2 - 168*D1*Dd*K*bd1*s + 35*D1*Dd*K*bd1 + 28*D1*Dd*K*f*r*s - 7*D1*Dd*K*f*r + 28*D1*Dd*K*f*s**2 - 28*D1*Dd*K*f*s + 7*D1*Dd*K*f + 48*D1*Dd*f*r*s - 12*D1*Dd*f*r + 48*D1*Dd*f*s**2 - 48*D1*Dd*f*s + 12*D1*Dd*f - 48*D1*Dd*fd*r*s + 6*D1*Dd*fd*r - 48*D1*Dd*fd*s**2 + 48*D1*Dd*fd*s - 6*D1*Dd*fd + 112*D1*Dd*g2*r*s - 28*D1*Dd*g2*r + 112*D1*Dd*g2*s**2 - 112*D1*Dd*g2*s + 28*D1*Dd*g2 - 112*D1*Dd*gd2*r*s + 14*D1*Dd*gd2*r - 112*D1*Dd*gd2*s**2 + 112*D1*Dd*gd2*s - 14*D1*Dd*gd2 - 24*D1*Ddd*f*r*s + 6*D1*Ddd*f*r - 24*D1*Ddd*f*s**2 + 24*D1*Ddd*f*s - 6*D1*Ddd*f - 56*D1*Ddd*g2*r*s + 14*D1*Ddd*g2*r - 56*D1*Ddd*g2*s**2 + 56*D1*Ddd*g2*s - 14*D1*Ddd*g2 - 7*D1*bd2*(2*D1*s*(r + s - 1) + Dd*(-8*r*s + r - 8*s**2 + 8*s - 1)) - 72*Dd**2*f*r*s + 18*Dd**2*f*r - 72*Dd**2*f*s**2 + 72*Dd**2*f*s - 12*Dd**2*f - 168*Dd**2*g2*r*s + 42*Dd**2*g2*r - 168*Dd**2*g2*s**2 + 168*Dd**2*g2*s - 28*Dd**2*g2 - 7*b2*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(21*d**2*k3) - 2*D1**2*Pkd2*Pkd3*ct*f**2*k1**5*st**4*(D1**2*(f*(361*fd - 200*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 200*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(361*f*(r*(4*s - 1) + (1 - 2*s)**2) - 400*fd*(4*s - 1)*(4*r + 4*s - 3)) - 200*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 200*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(3003*d**2*k3**5) - 5*D1**2*Pkd2*Pkd3*ct*f**2*k1**3*k2**2*st**6*(D1**2*(f*(181*fd - 84*fdd)*(r*(4*s - 1) + (1 - 2*s)**2) - 84*fd**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + D1*f*(Dd*(181*f*(r*(4*s - 1) + (1 - 2*s)**2) - 168*fd*(4*s - 1)*(4*r + 4*s - 3)) - 84*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 84*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(9009*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*f*k1**5*st**2*(-384*D1**2*b1*f*fd*r*s - 39*D1**2*b1*f*fd*r - 384*D1**2*b1*f*fd*s**2 + 217*D1**2*b1*f*fd*s + 39*D1**2*b1*f*fd + 225*D1**2*b1*f*fdd*r*s + 25*D1**2*b1*f*fdd*r + 225*D1**2*b1*f*fdd*s**2 - 125*D1**2*b1*f*fdd*s - 25*D1**2*b1*f*fdd + 450*D1**2*b1*fd**2*r*s + 50*D1**2*b1*fd**2*r + 450*D1**2*b1*fd**2*s**2 - 250*D1**2*b1*fd**2*s - 25*D1**2*b1*fd**2 + 25*D1**2*bdd1*f**2*(3*s - 4)*(r + s - 1) + 100*D1**2*f**2*fd*r*s - 25*D1**2*f**2*fd*r + 100*D1**2*f**2*fd*s**2 - 100*D1**2*f**2*fd*s + 25*D1**2*f**2*fd - 512*D1*Dd*b1*f**2*r*s + 128*D1*Dd*b1*f**2*r - 512*D1*Dd*b1*f**2*s**2 + 512*D1*Dd*b1*f**2*s - 128*D1*Dd*b1*f**2 + 1800*D1*Dd*b1*f*fd*r*s - 125*D1*Dd*b1*f*fd*r + 1800*D1*Dd*b1*f*fd*s**2 - 1400*D1*Dd*b1*f*fd*s + 75*D1*Dd*b1*f*fd + 100*D1*Dd*f**3*r*s - 25*D1*Dd*f**3*r + 100*D1*Dd*f**3*s**2 - 100*D1*Dd*f**3*s + 25*D1*Dd*f**3 + 300*D1*Ddd*b1*f**2*r*s - 75*D1*Ddd*b1*f**2*r + 300*D1*Ddd*b1*f**2*s**2 - 300*D1*Ddd*b1*f**2*s + 75*D1*Ddd*b1*f**2 + D1*bd1*f*(D1*(-f*(128*s - 167)*(r + s - 1) + 25*fd*(18*r*s - 11*r + 18*s**2 - 26*s + 7)) + 25*Dd*f*(r*(24*s - 19) + 24*s**2 - 40*s + 15)) + 900*Dd**2*b1*f**2*r*s - 225*Dd**2*b1*f**2*r + 900*Dd**2*b1*f**2*s**2 - 900*Dd**2*b1*f**2*s + 150*Dd**2*b1*f**2)/(231*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct*f*k1**3*k2**2*st**4*(-72*C*D1**2*f*fd*r*s + 24*C*D1**2*f*fd*r - 72*C*D1**2*f*fd*s**2 + 72*C*D1**2*f*fd*s - 24*C*D1**2*f*fd + 36*C*D1**2*f*fdd*r*s - 12*C*D1**2*f*fdd*r + 36*C*D1**2*f*fdd*s**2 - 36*C*D1**2*f*fdd*s + 12*C*D1**2*f*fdd + 72*C*D1**2*fd**2*r*s - 24*C*D1**2*fd**2*r + 72*C*D1**2*fd**2*s**2 - 72*C*D1**2*fd**2*s + 12*C*D1**2*fd**2 - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 288*C*D1*Dd*f*fd*r*s - 84*C*D1*Dd*f*fd*r + 288*C*D1*Dd*f*fd*s**2 - 288*C*D1*Dd*f*fd*s + 60*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 + 60*D1**2*b1*f*fd*r*s - 60*D1**2*b1*f*fd*r + 60*D1**2*b1*f*fd*s**2 - 100*D1**2*b1*f*fd*s + 60*D1**2*b1*f*fd - 30*D1**2*b1*f*fdd*r*s + 30*D1**2*b1*f*fdd*r - 30*D1**2*b1*f*fdd*s**2 + 50*D1**2*b1*f*fdd*s - 30*D1**2*b1*f*fdd - 60*D1**2*b1*fd**2*r*s + 60*D1**2*b1*fd**2*r - 60*D1**2*b1*fd**2*s**2 + 100*D1**2*b1*fd**2*s - 30*D1**2*b1*fd**2 - 10*D1**2*bdd1*f**2*(s + 2)*(r + s - 1) + 60*D1**2*f**2*fd*r*s - 15*D1**2*f**2*fd*r + 60*D1**2*f**2*fd*s**2 - 60*D1**2*f**2*fd*s + 15*D1**2*f**2*fd + 54*D1**2*f*fd*r*s - 18*D1**2*f*fd*r + 54*D1**2*f*fd*s**2 - 54*D1**2*f*fd*s + 18*D1**2*f*fd - 27*D1**2*f*fdd*r*s + 9*D1**2*f*fdd*r - 27*D1**2*f*fdd*s**2 + 27*D1**2*f*fdd*s - 9*D1**2*f*fdd - 54*D1**2*fd**2*r*s + 18*D1**2*fd**2*r - 54*D1**2*fd**2*s**2 + 54*D1**2*fd**2*s - 9*D1**2*fd**2 + 80*D1*Dd*b1*f**2*r*s - 20*D1*Dd*b1*f**2*r + 80*D1*Dd*b1*f**2*s**2 - 80*D1*Dd*b1*f**2*s + 20*D1*Dd*b1*f**2 - 240*D1*Dd*b1*f*fd*r*s + 150*D1*Dd*b1*f*fd*r - 240*D1*Dd*b1*f*fd*s**2 + 320*D1*Dd*b1*f*fd*s - 110*D1*Dd*b1*f*fd + 60*D1*Dd*f**3*r*s - 15*D1*Dd*f**3*r + 60*D1*Dd*f**3*s**2 - 60*D1*Dd*f**3*s + 15*D1*Dd*f**3 + 72*D1*Dd*f**2*r*s - 18*D1*Dd*f**2*r + 72*D1*Dd*f**2*s**2 - 72*D1*Dd*f**2*s + 18*D1*Dd*f**2 - 216*D1*Dd*f*fd*r*s + 63*D1*Dd*f*fd*r - 216*D1*Dd*f*fd*s**2 + 216*D1*Dd*f*fd*s - 45*D1*Dd*f*fd - 40*D1*Ddd*b1*f**2*r*s + 10*D1*Ddd*b1*f**2*r - 40*D1*Ddd*b1*f**2*s**2 + 40*D1*Ddd*b1*f**2*s - 10*D1*Ddd*b1*f**2 - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 + 10*D1*bd1*f*(D1*(2*f*(s + 2)*(r + s - 1) + fd*(-6*r*s - 3*r - 6*s**2 + 2*s + 1)) - Dd*f*(r*(8*s + 7) + 8*s**2 - 5)) - 120*Dd**2*b1*f**2*r*s + 30*Dd**2*b1*f**2*r - 120*Dd**2*b1*f**2*s**2 + 120*Dd**2*b1*f**2*s - 20*Dd**2*b1*f**2 - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2)/(231*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct*f*k1**3*st**4*(D1**2*(f**2*s*(10*bd1 - 5*bdd1)*(5*r + 5*s - 3) + f*(fd*(10*b1*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5) - 5*bd1*(30*r*s - 5*r + 30*s**2 - 26*s + 3) + 18*r*s - 6*r + 18*s**2 - 18*s + 6) - fdd*(5*b1*(5*r*(3*s - 1) + 15*s**2 - 17*s + 5) + r*(9*s - 3) + 9*s**2 - 9*s + 3)) - fd**2*(5*b1*(10*r*(3*s - 1) + 30*s**2 - 34*s + 7) + 3*r*(6*s - 2) + 18*s**2 - 18*s + 3)) + D1*f*(Dd*(50*b1*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*b1*fd*(5*r*(24*s - 7) + 120*s**2 - 128*s + 27) - 5*bd1*f*(5*r*(8*s - 1) + 40*s**2 - 32*s + 3) + 6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - Ddd*f*(25*b1 + 3)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(25*b1 + 3)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(231*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct*k1**5*(-5*D1**2*bd1*f**2*(r + s - 1)*(bd1*(2*s - 1) - f*s + f) + D1*b1*f*(bd1*(D1*(4*f*(2*s - 1)*(r + s - 1) - 5*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1)) - 5*Dd*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 5*f*(-D1*bdd1*(2*s - 1)*(r + s - 1) + D1*fd*s*(3*r + 3*s - 2) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**2*(D1**2*s*(2*r + 2*s - 1)*(4*f*fd - 5*f*fdd - 5*fd**2) + D1*f*(Dd*(4*f*(r*(4*s - 1) + (1 - 2*s)**2) - 5*fd*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) - 5*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 5*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*k1**3*k2**2*st**2*(132*C*D1**2*bdd1*f**2*r*s - 132*C*D1**2*bdd1*f**2*r + 132*C*D1**2*bdd1*f**2*s**2 - 264*C*D1**2*bdd1*f**2*s + 132*C*D1**2*bdd1*f**2 - 102*C*D1**2*f**2*fd*r*s + 34*C*D1**2*f**2*fd*r - 102*C*D1**2*f**2*fd*s**2 + 102*C*D1**2*f**2*fd*s - 34*C*D1**2*f**2*fd + 150*C*D1**2*f**2*fdd*r*s - 50*C*D1**2*f**2*fdd*r + 150*C*D1**2*f**2*fdd*s**2 - 150*C*D1**2*f**2*fdd*s + 50*C*D1**2*f**2*fdd + 300*C*D1**2*f*fd**2*r*s - 100*C*D1**2*f*fd**2*r + 300*C*D1**2*f*fd**2*s**2 - 300*C*D1**2*f*fd**2*s + 50*C*D1**2*f*fd**2 - 136*C*D1*Dd*f**3*r*s + 34*C*D1*Dd*f**3*r - 136*C*D1*Dd*f**3*s**2 + 136*C*D1*Dd*f**3*s - 34*C*D1*Dd*f**3 + 1200*C*D1*Dd*f**2*fd*r*s - 350*C*D1*Dd*f**2*fd*r + 1200*C*D1*Dd*f**2*fd*s**2 - 1200*C*D1*Dd*f**2*fd*s + 250*C*D1*Dd*f**2*fd + 200*C*D1*Ddd*f**3*r*s - 50*C*D1*Ddd*f**3*r + 200*C*D1*Ddd*f**3*s**2 - 200*C*D1*Ddd*f**3*s + 50*C*D1*Ddd*f**3 + 600*C*Dd**2*f**3*r*s - 150*C*Dd**2*f**3*r + 600*C*Dd**2*f**3*s**2 - 600*C*Dd**2*f**3*s + 100*C*Dd**2*f**3 + 33*D1**2*K*bdd1*f**2*r*s + 33*D1**2*K*bdd1*f**2*s**2 - 33*D1**2*K*bdd1*f**2*s - 33*D1**2*bd1**2*f*(2*s - 1)*(-2*K + 6*f + 1)*(r + s - 1) - 99*D1**2*bdd1*f**2*r*s + 99*D1**2*bdd1*f**2*r - 99*D1**2*bdd1*f**2*s**2 + 198*D1**2*bdd1*f**2*s - 99*D1**2*bdd1*f**2 - 132*D1**2*bdd1*f*g2*r*s + 132*D1**2*bdd1*f*g2*r - 132*D1**2*bdd1*f*g2*s**2 + 264*D1**2*bdd1*f*g2*s - 132*D1**2*bdd1*f*g2 + 18*D1**2*f**2*fd*r*s - 6*D1**2*f**2*fd*r + 18*D1**2*f**2*fd*s**2 - 18*D1**2*f**2*fd*s + 6*D1**2*f**2*fd - 75*D1**2*f**2*fdd*r*s + 25*D1**2*f**2*fdd*r - 75*D1**2*f**2*fdd*s**2 + 75*D1**2*f**2*fdd*s - 25*D1**2*f**2*fdd + 66*D1**2*f**2*gd2*r*s + 66*D1**2*f**2*gd2*s**2 - 66*D1**2*f**2*gd2*s - 66*D1**2*f**2*gdd2*r*s - 66*D1**2*f**2*gdd2*s**2 + 66*D1**2*f**2*gdd2*s - 150*D1**2*f*fd**2*r*s + 50*D1**2*f*fd**2*r - 150*D1**2*f*fd**2*s**2 + 150*D1**2*f*fd**2*s - 25*D1**2*f*fd**2 + 132*D1**2*f*fd*g2*r*s - 66*D1**2*f*fd*g2*r + 132*D1**2*f*fd*g2*s**2 - 132*D1**2*f*fd*g2*s + 66*D1**2*f*fd*g2 - 264*D1**2*f*fd*gd2*r*s + 66*D1**2*f*fd*gd2*r - 264*D1**2*f*fd*gd2*s**2 + 264*D1**2*f*fd*gd2*s - 66*D1**2*f*fd*gd2 - 132*D1**2*f*fdd*g2*r*s + 66*D1**2*f*fdd*g2*r - 132*D1**2*f*fdd*g2*s**2 + 132*D1**2*f*fdd*g2*s - 66*D1**2*f*fdd*g2 - 132*D1**2*fd**2*g2*r*s + 66*D1**2*fd**2*g2*r - 132*D1**2*fd**2*g2*s**2 + 132*D1**2*fd**2*g2*s + 24*D1*Dd*f**3*r*s - 6*D1*Dd*f**3*r + 24*D1*Dd*f**3*s**2 - 24*D1*Dd*f**3*s + 6*D1*Dd*f**3 - 600*D1*Dd*f**2*fd*r*s + 175*D1*Dd*f**2*fd*r - 600*D1*Dd*f**2*fd*s**2 + 600*D1*Dd*f**2*fd*s - 125*D1*Dd*f**2*fd + 264*D1*Dd*f**2*g2*r*s - 66*D1*Dd*f**2*g2*r + 264*D1*Dd*f**2*g2*s**2 - 264*D1*Dd*f**2*g2*s + 66*D1*Dd*f**2*g2 - 528*D1*Dd*f**2*gd2*r*s + 66*D1*Dd*f**2*gd2*r - 528*D1*Dd*f**2*gd2*s**2 + 528*D1*Dd*f**2*gd2*s - 66*D1*Dd*f**2*gd2 - 1056*D1*Dd*f*fd*g2*r*s + 396*D1*Dd*f*fd*g2*r - 1056*D1*Dd*f*fd*g2*s**2 + 1056*D1*Dd*f*fd*g2*s - 264*D1*Dd*f*fd*g2 - 100*D1*Ddd*f**3*r*s + 25*D1*Ddd*f**3*r - 100*D1*Ddd*f**3*s**2 + 100*D1*Ddd*f**3*s - 25*D1*Ddd*f**3 - 264*D1*Ddd*f**2*g2*r*s + 66*D1*Ddd*f**2*g2*r - 264*D1*Ddd*f**2*g2*s**2 + 264*D1*Ddd*f**2*g2*s - 66*D1*Ddd*f**2*g2 - 11*D1*bd1*(D1*(9*f**3*(r + s - 1) + f**2*(r + s - 1)*(24*C*(s - 1) + s*(3*K - 17) + 18) - 3*f*(fd*(4*C*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + K*(r*(4*s - 1) + (1 - 2*s)**2) - 3*r*(4*s - 2) - 12*s**2 + 15*s - 3) + (4*r + 4*s - 4)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 3*Dd*f*(f*(4*C*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + K*(8*r*s - r + 8*s**2 - 8*s + 1) - 24*r*s + 15*r - 24*s**2 + 36*s - 12) - 4*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) - 300*Dd**2*f**3*r*s + 75*Dd**2*f**3*r - 300*Dd**2*f**3*s**2 + 300*Dd**2*f**3*s - 50*Dd**2*f**3 - 792*Dd**2*f**2*g2*r*s + 198*Dd**2*f**2*g2*r - 792*Dd**2*f**2*g2*s**2 + 792*Dd**2*f**2*g2*s - 132*Dd**2*f**2*g2 + 33*b1**2*(-D1**2*s*(-f*(11*fd - 6*fdd)*(2*r + 2*s - 1) + 6*fd**2*(2*r + 2*s - 1) + 2*fd*(2*K - 1)*(r + s) - fdd*(2*K - 1)*(r + s)) + D1*(Dd*(11*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 2*f*(fd*(6*r*(8*s - 1) + 48*s**2 - 36*s + 3) + (2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + fd*(2*K - 1)*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-2*K + 6*f + 1)) - Dd**2*f*(-2*K + 6*f + 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(-48*C*D1**2*f*fd*r*s - 48*C*D1**2*f*fd*s**2 + 24*C*D1**2*f*fd*s + 24*C*D1**2*f*fdd*r*s + 24*C*D1**2*f*fdd*s**2 - 12*C*D1**2*f*fdd*s + 24*C*D1**2*fd**2*r*s + 24*C*D1**2*fd**2*s**2 - 12*C*D1**2*fd**2*s - 96*C*D1*Dd*f**2*r*s + 24*C*D1*Dd*f**2*r - 96*C*D1*Dd*f**2*s**2 + 96*C*D1*Dd*f**2*s - 24*C*D1*Dd*f**2 + 192*C*D1*Dd*f*fd*r*s - 24*C*D1*Dd*f*fd*r + 192*C*D1*Dd*f*fd*s**2 - 144*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd + 48*C*D1*Ddd*f**2*r*s - 12*C*D1*Ddd*f**2*r + 48*C*D1*Ddd*f**2*s**2 - 48*C*D1*Ddd*f**2*s + 12*C*D1*Ddd*f**2 + 144*C*Dd**2*f**2*r*s - 36*C*Dd**2*f**2*r + 144*C*Dd**2*f**2*s**2 - 144*C*Dd**2*f**2*s + 24*C*Dd**2*f**2 - 6*D1**2*K*f*fd*r*s + 3*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd + 6*D1**2*K*f*fdd*r*s - 3*D1**2*K*f*fdd*r + 6*D1**2*K*f*fdd*s**2 - 6*D1**2*K*f*fdd*s + 3*D1**2*K*f*fdd + 6*D1**2*K*fd**2*r*s - 3*D1**2*K*fd**2*r + 6*D1**2*K*fd**2*s**2 - 6*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(2*s - 1)*(-2*K + 6*f + 1)*(r + s - 1) + 9*D1**2*f**2*fd*r + 9*D1**2*f**2*fd*s - 9*D1**2*f**2*fd + 34*D1**2*f*fd*r*s + D1**2*f*fd*r + 34*D1**2*f*fd*s**2 - 16*D1**2*f*fd*s - D1**2*f*fd - 18*D1**2*f*fdd*r*s - 18*D1**2*f*fdd*s**2 + 9*D1**2*f*fdd*s + 24*D1**2*f*gd2*r*s + 24*D1**2*f*gd2*s**2 - 24*D1**2*f*gd2*s - 12*D1**2*f*gdd2*r*s - 12*D1**2*f*gdd2*s**2 + 12*D1**2*f*gdd2*s - 18*D1**2*fd**2*r*s - 18*D1**2*fd**2*s**2 + 9*D1**2*fd**2*s + 24*D1**2*fd*g2*r*s + 24*D1**2*fd*g2*s**2 - 24*D1**2*fd*gd2*r*s - 24*D1**2*fd*gd2*s**2 + 12*D1**2*fd*gd2*s - 12*D1**2*fdd*g2*r*s - 12*D1**2*fdd*g2*s**2 - 12*D1*Dd*K*f**2*r*s + 3*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 12*D1*Dd*K*f**2*s - 3*D1*Dd*K*f**2 + 48*D1*Dd*K*f*fd*r*s - 18*D1*Dd*K*f*fd*r + 48*D1*Dd*K*f*fd*s**2 - 48*D1*Dd*K*f*fd*s + 12*D1*Dd*K*f*fd + 68*D1*Dd*f**2*r*s - 17*D1*Dd*f**2*r + 68*D1*Dd*f**2*s**2 - 68*D1*Dd*f**2*s + 17*D1*Dd*f**2 - 144*D1*Dd*f*fd*r*s + 18*D1*Dd*f*fd*r - 144*D1*Dd*f*fd*s**2 + 108*D1*Dd*f*fd*s - 9*D1*Dd*f*fd + 96*D1*Dd*f*g2*r*s - 24*D1*Dd*f*g2*r + 96*D1*Dd*f*g2*s**2 - 96*D1*Dd*f*g2*s + 24*D1*Dd*f*g2 - 96*D1*Dd*f*gd2*r*s + 12*D1*Dd*f*gd2*r - 96*D1*Dd*f*gd2*s**2 + 96*D1*Dd*f*gd2*s - 12*D1*Dd*f*gd2 - 96*D1*Dd*fd*g2*r*s + 12*D1*Dd*fd*g2*r - 96*D1*Dd*fd*g2*s**2 + 48*D1*Dd*fd*g2*s + 12*D1*Ddd*K*f**2*r*s - 3*D1*Ddd*K*f**2*r + 12*D1*Ddd*K*f**2*s**2 - 12*D1*Ddd*K*f**2*s + 3*D1*Ddd*K*f**2 - 36*D1*Ddd*f**2*r*s + 9*D1*Ddd*f**2*r - 36*D1*Ddd*f**2*s**2 + 36*D1*Ddd*f**2*s - 9*D1*Ddd*f**2 - 48*D1*Ddd*f*g2*r*s + 12*D1*Ddd*f*g2*r - 48*D1*Ddd*f*g2*s**2 + 48*D1*Ddd*f*g2*s - 12*D1*Ddd*f*g2 + 3*D1*bd1*(D1*(11*f**2*(2*s - 1)*(r + s - 1) - 2*f*(3*fd*(8*r*s - 2*r + 8*s**2 - 8*s + 1) + (2*K - 1)*(2*s - 1)*(r + s - 1)) + fd*(2*K - 1)*(r*(4*s - 1) + s*(4*s - 3))) - Dd*f*(-2*K + 6*f + 1)*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 36*Dd**2*K*f**2*r*s - 9*Dd**2*K*f**2*r + 36*Dd**2*K*f**2*s**2 - 36*Dd**2*K*f**2*s + 6*Dd**2*K*f**2 - 108*Dd**2*f**2*r*s + 27*Dd**2*f**2*r - 108*Dd**2*f**2*s**2 + 108*Dd**2*f**2*s - 18*Dd**2*f**2 - 144*Dd**2*f*g2*r*s + 36*Dd**2*f*g2*r - 144*Dd**2*f*g2*s**2 + 144*Dd**2*f*g2*s - 24*Dd**2*f*g2))/(231*d**2*k3**5) - 2*D1**2*Pkd2*Pkd3*ct*k1**3*k2**2*(D1*(-6*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) - D1*bdd1*f*(s - 1)*(f*(10*C - 5) - 12*g2)*(r + s - 1) + bd1*(D1*(f**2*(14 - 16*C)*(s - 1)*(r + s - 1) + f*(-fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (3*g2*(s - 1) + 2*gd2*(2*s - 1))*(6*r + 6*s - 6)) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + b1**2*(D1**2*s*(18*f*fd*(2*r + 2*s - 1) - (r + s)*(6*K*fdd + fd*(9*K - 7))) + D1*(Dd*(6*K*fd*(-8*r*s + r + s*(4 - 8*s)) + 18*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(9*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) - 6*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 6*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(-6*K*bdd1*f*(2*s - 1)*(r + s - 1) + s*(f*(-fd*(16*C - 14)*(2*r + 2*s - 1) - fdd*(10*C - 5)*(2*r + 2*s - 1) + (18*gd2 + 12*gdd2)*(r + s - 1)) - fd**2*(10*C - 5)*(2*r + 2*s - 1) + 6*fd*(3*g2*(r + s) + gd2*(4*r + 4*s - 2)) + 12*fdd*g2*(r + s))) + D1*bd1*(D1*(6*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 18*f**2*(2*s - 1)*(r + s - 1) - f*(9*K - 7)*(2*s - 1)*(r + s - 1)) - 6*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + D1*(Dd*(f**2*(14 - 16*C)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(fd*(5 - 10*C)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 18*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 12*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 12*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) - Ddd*f*(f*(10*C - 5) - 12*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f*(f*(10*C - 5) - 12*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*k1**3*st**2*(234*C*D1**2*f**2*fd*r*s - 78*C*D1**2*f**2*fd*r + 234*C*D1**2*f**2*fd*s**2 - 234*C*D1**2*f**2*fd*s + 78*C*D1**2*f**2*fd - 150*C*D1**2*f**2*fdd*r*s + 50*C*D1**2*f**2*fdd*r - 150*C*D1**2*f**2*fdd*s**2 + 150*C*D1**2*f**2*fdd*s - 50*C*D1**2*f**2*fdd - 300*C*D1**2*f*fd**2*r*s + 100*C*D1**2*f*fd**2*r - 300*C*D1**2*f*fd**2*s**2 + 300*C*D1**2*f*fd**2*s - 50*C*D1**2*f*fd**2 + 312*C*D1*Dd*f**3*r*s - 78*C*D1*Dd*f**3*r + 312*C*D1*Dd*f**3*s**2 - 312*C*D1*Dd*f**3*s + 78*C*D1*Dd*f**3 - 1200*C*D1*Dd*f**2*fd*r*s + 350*C*D1*Dd*f**2*fd*r - 1200*C*D1*Dd*f**2*fd*s**2 + 1200*C*D1*Dd*f**2*fd*s - 250*C*D1*Dd*f**2*fd - 200*C*D1*Ddd*f**3*r*s + 50*C*D1*Ddd*f**3*r - 200*C*D1*Ddd*f**3*s**2 + 200*C*D1*Ddd*f**3*s - 50*C*D1*Ddd*f**3 - 600*C*Dd**2*f**3*r*s + 150*C*Dd**2*f**3*r - 600*C*Dd**2*f**3*s**2 + 600*C*Dd**2*f**3*s - 100*C*Dd**2*f**3 - 33*D1**2*K*bdd1*f**2*r*s - 33*D1**2*K*bdd1*f**2*s**2 + 33*D1**2*K*bdd1*f**2*s + 110*D1**2*b2*f*fd*r*s - 55*D1**2*b2*f*fd*r + 110*D1**2*b2*f*fd*s**2 - 110*D1**2*b2*f*fd*s + 55*D1**2*b2*f*fd - 66*D1**2*b2*f*fdd*r*s + 33*D1**2*b2*f*fdd*r - 66*D1**2*b2*f*fdd*s**2 + 66*D1**2*b2*f*fdd*s - 33*D1**2*b2*f*fdd - 66*D1**2*b2*fd**2*r*s + 33*D1**2*b2*fd**2*r - 66*D1**2*b2*fd**2*s**2 + 66*D1**2*b2*fd**2*s + 33*D1**2*bd1**2*f*(f*(r*(8*s - 5) + 8*s**2 - 12*s + 3) + (2*s - 1)*(r + s - 1)) + 55*D1**2*bd2*f**2*r*s + 55*D1**2*bd2*f**2*s**2 - 55*D1**2*bd2*f**2*s - 132*D1**2*bd2*f*fd*r*s + 33*D1**2*bd2*f*fd*r - 132*D1**2*bd2*f*fd*s**2 + 132*D1**2*bd2*f*fd*s - 33*D1**2*bd2*f*fd + 33*D1**2*bdd1*f**2*r*s - 33*D1**2*bdd1*f**2*r + 33*D1**2*bdd1*f**2*s**2 - 66*D1**2*bdd1*f**2*s + 33*D1**2*bdd1*f**2 - 33*D1**2*bdd2*f**2*r*s - 33*D1**2*bdd2*f**2*s**2 + 33*D1**2*bdd2*f**2*s - 84*D1**2*f**2*fd*r*s + 28*D1**2*f**2*fd*r - 84*D1**2*f**2*fd*s**2 + 84*D1**2*f**2*fd*s - 28*D1**2*f**2*fd + 75*D1**2*f**2*fdd*r*s - 25*D1**2*f**2*fdd*r + 75*D1**2*f**2*fdd*s**2 - 75*D1**2*f**2*fdd*s + 25*D1**2*f**2*fdd - 110*D1**2*f**2*gd2*r*s - 110*D1**2*f**2*gd2*s**2 + 110*D1**2*f**2*gd2*s + 66*D1**2*f**2*gdd2*r*s + 66*D1**2*f**2*gdd2*s**2 - 66*D1**2*f**2*gdd2*s + 150*D1**2*f*fd**2*r*s - 50*D1**2*f*fd**2*r + 150*D1**2*f*fd**2*s**2 - 150*D1**2*f*fd**2*s + 25*D1**2*f*fd**2 - 220*D1**2*f*fd*g2*r*s + 110*D1**2*f*fd*g2*r - 220*D1**2*f*fd*g2*s**2 + 220*D1**2*f*fd*g2*s - 110*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r*s - 66*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 264*D1**2*f*fd*gd2*s + 66*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r*s - 66*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r*s - 66*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 220*D1*Dd*b2*f**2*r*s - 55*D1*Dd*b2*f**2*r + 220*D1*Dd*b2*f**2*s**2 - 220*D1*Dd*b2*f**2*s + 55*D1*Dd*b2*f**2 - 528*D1*Dd*b2*f*fd*r*s + 198*D1*Dd*b2*f*fd*r - 528*D1*Dd*b2*f*fd*s**2 + 528*D1*Dd*b2*f*fd*s - 132*D1*Dd*b2*f*fd - 264*D1*Dd*bd2*f**2*r*s + 33*D1*Dd*bd2*f**2*r - 264*D1*Dd*bd2*f**2*s**2 + 264*D1*Dd*bd2*f**2*s - 33*D1*Dd*bd2*f**2 - 112*D1*Dd*f**3*r*s + 28*D1*Dd*f**3*r - 112*D1*Dd*f**3*s**2 + 112*D1*Dd*f**3*s - 28*D1*Dd*f**3 + 600*D1*Dd*f**2*fd*r*s - 175*D1*Dd*f**2*fd*r + 600*D1*Dd*f**2*fd*s**2 - 600*D1*Dd*f**2*fd*s + 125*D1*Dd*f**2*fd - 440*D1*Dd*f**2*g2*r*s + 110*D1*Dd*f**2*g2*r - 440*D1*Dd*f**2*g2*s**2 + 440*D1*Dd*f**2*g2*s - 110*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r*s - 66*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 528*D1*Dd*f**2*gd2*s + 66*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r*s - 396*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1056*D1*Dd*f*fd*g2*s + 264*D1*Dd*f*fd*g2 - 132*D1*Ddd*b2*f**2*r*s + 33*D1*Ddd*b2*f**2*r - 132*D1*Ddd*b2*f**2*s**2 + 132*D1*Ddd*b2*f**2*s - 33*D1*Ddd*b2*f**2 + 100*D1*Ddd*f**3*r*s - 25*D1*Ddd*f**3*r + 100*D1*Ddd*f**3*s**2 - 100*D1*Ddd*f**3*s + 25*D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r*s - 66*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 264*D1*Ddd*f**2*g2*s + 66*D1*Ddd*f**2*g2 + 11*D1*bd1*f*(D1*(3*f**2*s*(2*r + 2*s - 1) + f*(s*(5*K - 5) + 6)*(r + s - 1) - 3*fd*(K*(r*(4*s - 1) + (1 - 2*s)**2) - 4*r*s + 2*r - 4*s**2 + 5*s - 1)) - 3*Dd*f*(K*(8*r*s - r + 8*s**2 - 8*s + 1) - 8*r*s + 5*r - 8*s**2 + 12*s - 4)) - 396*Dd**2*b2*f**2*r*s + 99*Dd**2*b2*f**2*r - 396*Dd**2*b2*f**2*s**2 + 396*Dd**2*b2*f**2*s - 66*Dd**2*b2*f**2 + 300*Dd**2*f**3*r*s - 75*Dd**2*f**3*r + 300*Dd**2*f**3*s**2 - 300*Dd**2*f**3*s + 50*Dd**2*f**3 + 792*Dd**2*f**2*g2*r*s - 198*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 792*Dd**2*f**2*g2*s + 132*Dd**2*f**2*g2 - 11*b1**2*(D1**2*(f*fd*(r*(44*s + 5) + 44*s**2 - 23*s - 5) - 3*f*fdd*(8*r*s + r + 8*s**2 - 4*s - 1) - 3*fd**2*(8*r*s + r + 8*s**2 - 4*s - 1) + 6*fd*s*(r + s) - 3*fdd*s*(r + s)) + D1*(Dd*(22*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - 6*f*(fd*(32*r*s - 2*r + 32*s**2 - 24*s + 1) - 4*r*s + r - 4*s**2 + 4*s - 1) + 3*fd*(-8*r*s + r + s*(4 - 8*s))) - 3*Ddd*f*(4*f + 1)*(r*(4*s - 1) + (1 - 2*s)**2)) - 3*Dd**2*f*(4*f + 1)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) - 11*b1*(-10*D1**2*K*f*fd*r*s + 5*D1**2*K*f*fd*r - 10*D1**2*K*f*fd*s**2 + 10*D1**2*K*f*fd*s - 5*D1**2*K*f*fd + 6*D1**2*K*f*fdd*r*s - 3*D1**2*K*f*fdd*r + 6*D1**2*K*f*fdd*s**2 - 6*D1**2*K*f*fdd*s + 3*D1**2*K*f*fdd + 6*D1**2*K*fd**2*r*s - 3*D1**2*K*fd**2*r + 6*D1**2*K*fd**2*s**2 - 6*D1**2*K*fd**2*s - 3*D1**2*bdd1*f*(f*(8*r*s - 5*r + 8*s**2 - 12*s + 5) + (2*s - 1)*(r + s - 1)) - 18*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 21*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 10*D1**2*f*fd*r*s + D1**2*f*fd*r + 10*D1**2*f*fd*s**2 - 4*D1**2*f*fd*s - D1**2*f*fd - 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s - 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s - 20*D1*Dd*K*f**2*r*s + 5*D1*Dd*K*f**2*r - 20*D1*Dd*K*f**2*s**2 + 20*D1*Dd*K*f**2*s - 5*D1*Dd*K*f**2 + 48*D1*Dd*K*f*fd*r*s - 18*D1*Dd*K*f*fd*r + 48*D1*Dd*K*f*fd*s**2 - 48*D1*Dd*K*f*fd*s + 12*D1*Dd*K*f*fd - 24*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 24*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 20*D1*Dd*f**2*r*s - 5*D1*Dd*f**2*r + 20*D1*Dd*f**2*s**2 - 20*D1*Dd*f**2*s + 5*D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 36*D1*Dd*f*fd*s - 3*D1*Dd*f*fd + 12*D1*Ddd*K*f**2*r*s - 3*D1*Ddd*K*f**2*r + 12*D1*Ddd*K*f**2*s**2 - 12*D1*Ddd*K*f**2*s + 3*D1*Ddd*K*f**2 - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 + D1*bd1*(D1*(f**2*(r*(44*s - 27) + 44*s**2 - 65*s + 27) - 6*f*fd*(4*s - 1)*(4*r + 4*s - 3) + 6*f*(2*s - 1)*(r + s - 1) + 3*fd*(-4*r*s + r + s*(3 - 4*s))) - 3*Dd*f*(f*(64*r*s - 28*r + 64*s**2 - 80*s + 22) + 16*r*s - 6*r + 16*s**2 - 20*s + 5)) + 36*Dd**2*K*f**2*r*s - 9*Dd**2*K*f**2*r + 36*Dd**2*K*f**2*s**2 - 36*Dd**2*K*f**2*s + 6*Dd**2*K*f**2 - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s - 6*Dd**2*f**2))/(231*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct*k1**3*(D1*(-6*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) - D1*bdd1*f*(s - 1)*(f*(10*C - 5) - 12*g2)*(r + s - 1) + b2*(D1*bd1*(5*f*(s - 1)*(r + s - 1) + 6*fd*(-2*r*s + r - s*(2*s - 2))) - 6*D1*bdd1*f*(s - 1)*(r + s - 1) - 6*Dd*bd1*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + bd1*(-6*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(f**2*(8*C + 2)*(s - 1)*(r + s - 1) + f*(-fd*(10*C - 5)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (-5*g2*(s - 1) + 6*gd2*(2*s - 1))*(2*r + 2*s - 2)) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - Dd*f*(f*(10*C - 5) - 12*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4))) + b1**3*(D1**2*s*(5*fd - 6*fdd)*(r + s - 1) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(5*D1**2*K*fd*r*s + 5*D1**2*K*fd*s**2 - 6*D1**2*K*fdd*r*s - 6*D1**2*K*fdd*s**2 - 6*D1**2*bdd1*f*(3*r*s - r + 3*s**2 - 3*s + 1) + 24*D1**2*f*fd*r*s + 24*D1**2*f*fd*s**2 - 18*D1**2*f*fd*s + 7*D1**2*fd*r*s + 7*D1**2*fd*s**2 + 20*D1*Dd*K*f*r*s - 5*D1*Dd*K*f*r + 20*D1*Dd*K*f*s**2 - 20*D1*Dd*K*f*s + 5*D1*Dd*K*f - 48*D1*Dd*K*fd*r*s + 6*D1*Dd*K*fd*r - 48*D1*Dd*K*fd*s**2 + 24*D1*Dd*K*fd*s + 48*D1*Dd*f**2*r*s - 12*D1*Dd*f**2*r + 48*D1*Dd*f**2*s**2 - 48*D1*Dd*f**2*s + 12*D1*Dd*f**2 + 28*D1*Dd*f*r*s - 7*D1*Dd*f*r + 28*D1*Dd*f*s**2 - 28*D1*Dd*f*s + 7*D1*Dd*f - 24*D1*Ddd*K*f*r*s + 6*D1*Ddd*K*f*r - 24*D1*Ddd*K*f*s**2 + 24*D1*Ddd*K*f*s - 6*D1*Ddd*K*f + D1*bd1*(D1*(5*f*(3*r*s - r + 3*s**2 - 3*s + 1) - 6*fd*(6*r*s - r + 6*s**2 - 6*s + 1)) - 6*Dd*f*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 72*Dd**2*K*f*r*s + 18*Dd**2*K*f*r - 72*Dd**2*K*f*s**2 + 72*Dd**2*K*f*s - 12*Dd**2*K*f) + b1*(16*C*D1**2*f*fd*r*s + 16*C*D1**2*f*fd*s**2 - 8*C*D1**2*f*fd*s - 20*C*D1**2*f*fdd*r*s - 20*C*D1**2*f*fdd*s**2 + 10*C*D1**2*f*fdd*s - 20*C*D1**2*fd**2*r*s - 20*C*D1**2*fd**2*s**2 + 10*C*D1**2*fd**2*s + 32*C*D1*Dd*f**2*r*s - 8*C*D1*Dd*f**2*r + 32*C*D1*Dd*f**2*s**2 - 32*C*D1*Dd*f**2*s + 8*C*D1*Dd*f**2 - 160*C*D1*Dd*f*fd*r*s + 20*C*D1*Dd*f*fd*r - 160*C*D1*Dd*f*fd*s**2 + 120*C*D1*Dd*f*fd*s - 10*C*D1*Dd*f*fd - 40*C*D1*Ddd*f**2*r*s + 10*C*D1*Ddd*f**2*r - 40*C*D1*Ddd*f**2*s**2 + 40*C*D1*Ddd*f**2*s - 10*C*D1*Ddd*f**2 - 120*C*Dd**2*f**2*r*s + 30*C*Dd**2*f**2*r - 120*C*Dd**2*f**2*s**2 + 120*C*Dd**2*f**2*s - 20*C*Dd**2*f**2 - 12*D1**2*K*bdd1*f*r*s + 6*D1**2*K*bdd1*f*r - 12*D1**2*K*bdd1*f*s**2 + 18*D1**2*K*bdd1*f*s - 6*D1**2*K*bdd1*f - 6*D1**2*bd1**2*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 5*D1**2*bd2*f*r*s + 5*D1**2*bd2*f*s**2 - 5*D1**2*bd2*f*s - 12*D1**2*bd2*fd*r*s - 12*D1**2*bd2*fd*s**2 + 6*D1**2*bd2*fd*s - 6*D1**2*bdd2*f*r*s - 6*D1**2*bdd2*f*s**2 + 6*D1**2*bdd2*f*s + 4*D1**2*f*fd*r*s + 4*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + 10*D1**2*f*fdd*r*s + 10*D1**2*f*fdd*s**2 - 5*D1**2*f*fdd*s - 10*D1**2*f*gd2*r*s - 10*D1**2*f*gd2*s**2 + 10*D1**2*f*gd2*s + 12*D1**2*f*gdd2*r*s + 12*D1**2*f*gdd2*s**2 - 12*D1**2*f*gdd2*s + 10*D1**2*fd**2*r*s + 10*D1**2*fd**2*s**2 - 5*D1**2*fd**2*s - 10*D1**2*fd*g2*r*s - 10*D1**2*fd*g2*s**2 + 24*D1**2*fd*gd2*r*s + 24*D1**2*fd*gd2*s**2 - 12*D1**2*fd*gd2*s + 12*D1**2*fdd*g2*r*s + 12*D1**2*fdd*g2*s**2 - 48*D1*Dd*bd2*f*r*s + 6*D1*Dd*bd2*f*r - 48*D1*Dd*bd2*f*s**2 + 48*D1*Dd*bd2*f*s - 6*D1*Dd*bd2*f + 8*D1*Dd*f**2*r*s - 2*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 2*D1*Dd*f**2 + 80*D1*Dd*f*fd*r*s - 10*D1*Dd*f*fd*r + 80*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 5*D1*Dd*f*fd - 40*D1*Dd*f*g2*r*s + 10*D1*Dd*f*g2*r - 40*D1*Dd*f*g2*s**2 + 40*D1*Dd*f*g2*s - 10*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r*s - 12*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 96*D1*Dd*f*gd2*s + 12*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r*s - 12*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 48*D1*Dd*fd*g2*s + 20*D1*Ddd*f**2*r*s - 5*D1*Ddd*f**2*r + 20*D1*Ddd*f**2*s**2 - 20*D1*Ddd*f**2*s + 5*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r*s - 12*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 48*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + D1*bd1*(D1*(6*K*fd*(-4*r*s + r + s*(3 - 4*s)) + 6*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + f*(5*K + 7)*(2*s - 1)*(r + s - 1)) - 6*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + 60*Dd**2*f**2*r*s - 15*Dd**2*f**2*r + 60*Dd**2*f**2*s**2 - 60*Dd**2*f**2*s + 10*Dd**2*f**2 + 144*Dd**2*f*g2*r*s - 36*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 144*Dd**2*f*g2*s + 24*Dd**2*f*g2 + b2*(D1**2*s*(5*fd - 6*fdd)*(r + s) + D1*Dd*(5*f*(r*(4*s - 1) + (1 - 2*s)**2) + 6*fd*(-8*r*s + r + s*(4 - 8*s))) - 6*D1*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 6*Dd**2*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2))))/(21*d**2*k3**3) + 5*D1**2*Pkd2*Pkd3*ct*k1*k2**4*st**6*(24*C*D1**2*f**2*fd*r*s - 8*C*D1**2*f**2*fd*r + 24*C*D1**2*f**2*fd*s**2 - 24*C*D1**2*f**2*fd*s + 8*C*D1**2*f**2*fd - 12*C*D1**2*f**2*fdd*r*s + 4*C*D1**2*f**2*fdd*r - 12*C*D1**2*f**2*fdd*s**2 + 12*C*D1**2*f**2*fdd*s - 4*C*D1**2*f**2*fdd - 24*C*D1**2*f*fd**2*r*s + 8*C*D1**2*f*fd**2*r - 24*C*D1**2*f*fd**2*s**2 + 24*C*D1**2*f*fd**2*s - 4*C*D1**2*f*fd**2 + 32*C*D1*Dd*f**3*r*s - 8*C*D1*Dd*f**3*r + 32*C*D1*Dd*f**3*s**2 - 32*C*D1*Dd*f**3*s + 8*C*D1*Dd*f**3 - 96*C*D1*Dd*f**2*fd*r*s + 28*C*D1*Dd*f**2*fd*r - 96*C*D1*Dd*f**2*fd*s**2 + 96*C*D1*Dd*f**2*fd*s - 20*C*D1*Dd*f**2*fd - 16*C*D1*Ddd*f**3*r*s + 4*C*D1*Ddd*f**3*r - 16*C*D1*Ddd*f**3*s**2 + 16*C*D1*Ddd*f**3*s - 4*C*D1*Ddd*f**3 - 48*C*Dd**2*f**3*r*s + 12*C*Dd**2*f**3*r - 48*C*Dd**2*f**3*s**2 + 48*C*Dd**2*f**3*s - 8*C*Dd**2*f**3 - 66*D1**2*K*bdd1*f**2*r*s - 66*D1**2*K*bdd1*f**2*s**2 + 66*D1**2*K*bdd1*f**2*s + 7*D1**2*bdd1*f**3*r*s + 7*D1**2*bdd1*f**3*s**2 - 7*D1**2*bdd1*f**3*s + 33*D1**2*bdd1*f**2*r*s + 33*D1**2*bdd1*f**2*s**2 - 33*D1**2*bdd1*f**2*s - 18*D1**2*f**2*fd*r*s + 6*D1**2*f**2*fd*r - 18*D1**2*f**2*fd*s**2 + 18*D1**2*f**2*fd*s - 6*D1**2*f**2*fd + 9*D1**2*f**2*fdd*r*s - 3*D1**2*f**2*fdd*r + 9*D1**2*f**2*fdd*s**2 - 9*D1**2*f**2*fdd*s + 3*D1**2*f**2*fdd - 264*D1**2*f**2*gd2*r*s - 264*D1**2*f**2*gd2*s**2 + 264*D1**2*f**2*gd2*s + 132*D1**2*f**2*gdd2*r*s + 132*D1**2*f**2*gdd2*s**2 - 132*D1**2*f**2*gdd2*s + 18*D1**2*f*fd**2*r*s - 6*D1**2*f*fd**2*r + 18*D1**2*f*fd**2*s**2 - 18*D1**2*f*fd**2*s + 3*D1**2*f*fd**2 - 528*D1**2*f*fd*g2*r*s + 264*D1**2*f*fd*g2*r - 528*D1**2*f*fd*g2*s**2 + 528*D1**2*f*fd*g2*s - 264*D1**2*f*fd*g2 + 528*D1**2*f*fd*gd2*r*s - 132*D1**2*f*fd*gd2*r + 528*D1**2*f*fd*gd2*s**2 - 528*D1**2*f*fd*gd2*s + 132*D1**2*f*fd*gd2 + 264*D1**2*f*fdd*g2*r*s - 132*D1**2*f*fdd*g2*r + 264*D1**2*f*fdd*g2*s**2 - 264*D1**2*f*fdd*g2*s + 132*D1**2*f*fdd*g2 + 264*D1**2*fd**2*g2*r*s - 132*D1**2*fd**2*g2*r + 264*D1**2*fd**2*g2*s**2 - 264*D1**2*fd**2*g2*s - 24*D1*Dd*f**3*r*s + 6*D1*Dd*f**3*r - 24*D1*Dd*f**3*s**2 + 24*D1*Dd*f**3*s - 6*D1*Dd*f**3 + 72*D1*Dd*f**2*fd*r*s - 21*D1*Dd*f**2*fd*r + 72*D1*Dd*f**2*fd*s**2 - 72*D1*Dd*f**2*fd*s + 15*D1*Dd*f**2*fd - 1056*D1*Dd*f**2*g2*r*s + 264*D1*Dd*f**2*g2*r - 1056*D1*Dd*f**2*g2*s**2 + 1056*D1*Dd*f**2*g2*s - 264*D1*Dd*f**2*g2 + 1056*D1*Dd*f**2*gd2*r*s - 132*D1*Dd*f**2*gd2*r + 1056*D1*Dd*f**2*gd2*s**2 - 1056*D1*Dd*f**2*gd2*s + 132*D1*Dd*f**2*gd2 + 2112*D1*Dd*f*fd*g2*r*s - 792*D1*Dd*f*fd*g2*r + 2112*D1*Dd*f*fd*g2*s**2 - 2112*D1*Dd*f*fd*g2*s + 528*D1*Dd*f*fd*g2 + 12*D1*Ddd*f**3*r*s - 3*D1*Ddd*f**3*r + 12*D1*Ddd*f**3*s**2 - 12*D1*Ddd*f**3*s + 3*D1*Ddd*f**3 + 528*D1*Ddd*f**2*g2*r*s - 132*D1*Ddd*f**2*g2*r + 528*D1*Ddd*f**2*g2*s**2 - 528*D1*Ddd*f**2*g2*s + 132*D1*Ddd*f**2*g2 + D1*bd1*f*(D1*(7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) - 2*f*s*(-66*K + 7*f + 33)*(r + s - 1) - 33*fd*(2*K - 1)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd*f*(-66*K + 7*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 36*Dd**2*f**3*r*s - 9*Dd**2*f**3*r + 36*Dd**2*f**3*s**2 - 36*Dd**2*f**3*s + 6*Dd**2*f**3 + 1584*Dd**2*f**2*g2*r*s - 396*Dd**2*f**2*g2*r + 1584*Dd**2*f**2*g2*s**2 - 1584*Dd**2*f**2*g2*s + 264*Dd**2*f**2*g2 + b1*(D1**2*(-7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(7*fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*fd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 33*fdd*(2*K - 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 33*fd**2*(2*K - 1)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(-14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + (132*K - 66)*(r*(4*s - 1) + (1 - 2*s)**2)) - 66*fd*(2*K - 1)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) + Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(-66*K + 7*f + 33)) + Dd**2*f**2*(-66*K + 7*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*ct*k1*k2**4*st**4*(-11*D1**2*bd1**2*f*(2*K - 1)*(2*s - 1)*(r + s - 1) - 11*D1*bd1*(D1*(f**2*s*(3*K - 1)*(r + s - 1) + 4*f*(r + s - 1)*(2*g2*(s - 1) - 2*gd2*s + gd2) + 4*fd*g2*(-2*r*s + r - s*(2*s - 2))) - 4*Dd*f*g2*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 11*b1**2*(2*K - 1)*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + 11*b1*(-6*D1**2*K*f*fd*r*s + 3*D1**2*K*f*fd*r - 6*D1**2*K*f*fd*s**2 + 6*D1**2*K*f*fd*s - 3*D1**2*K*f*fd - D1**2*bdd1*f*(2*K - 1)*(2*s - 1)*(r + s - 1) + 2*D1**2*f*fd*r*s - D1**2*f*fd*r + 2*D1**2*f*fd*s**2 - 2*D1**2*f*fd*s + D1**2*f*fd - 8*D1**2*f*gd2*r*s - 8*D1**2*f*gd2*s**2 + 8*D1**2*f*gd2*s + 4*D1**2*f*gdd2*r*s + 4*D1**2*f*gdd2*s**2 - 4*D1**2*f*gdd2*s - 8*D1**2*fd*g2*r*s - 8*D1**2*fd*g2*s**2 + 8*D1**2*fd*gd2*r*s + 8*D1**2*fd*gd2*s**2 - 4*D1**2*fd*gd2*s + 4*D1**2*fdd*g2*r*s + 4*D1**2*fdd*g2*s**2 - 12*D1*Dd*K*f**2*r*s + 3*D1*Dd*K*f**2*r - 12*D1*Dd*K*f**2*s**2 + 12*D1*Dd*K*f**2*s - 3*D1*Dd*K*f**2 + 4*D1*Dd*f**2*r*s - D1*Dd*f**2*r + 4*D1*Dd*f**2*s**2 - 4*D1*Dd*f**2*s + D1*Dd*f**2 - 32*D1*Dd*f*g2*r*s + 8*D1*Dd*f*g2*r - 32*D1*Dd*f*g2*s**2 + 32*D1*Dd*f*g2*s - 8*D1*Dd*f*g2 + 32*D1*Dd*f*gd2*r*s - 4*D1*Dd*f*gd2*r + 32*D1*Dd*f*gd2*s**2 - 32*D1*Dd*f*gd2*s + 4*D1*Dd*f*gd2 + 32*D1*Dd*fd*g2*r*s - 4*D1*Dd*fd*g2*r + 32*D1*Dd*fd*g2*s**2 - 16*D1*Dd*fd*g2*s + 16*D1*Ddd*f*g2*r*s - 4*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s**2 - 16*D1*Ddd*f*g2*s + 4*D1*Ddd*f*g2 + D1*bd1*(2*K - 1)*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-4*r*s + r + s*(3 - 4*s))) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) + 48*Dd**2*f*g2*r*s - 12*Dd**2*f*g2*r + 48*Dd**2*f*g2*s**2 - 48*Dd**2*f*g2*s + 8*Dd**2*f*g2) + f*(D1**2*(44*bdd1*g2*(s - 1)*(r + s - 1) + f*(-fd*(20*C - 10)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + fdd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 66*gd2*s*(r + s - 1)) + fd**2*(10*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 66*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + D1*f*(Dd*(f*(10 - 20*C)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(10*C - 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 66*g2*(r*(4*s - 1) + (1 - 2*s)**2)) + Ddd*f*(10*C - 5)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(10*C - 5)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(77*d**2*k3**5) + D1**2*Pkd2*Pkd3*ct*k1*k2**4*st**2*(D1*(9*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 9*D1*bdd1*f*(s - 1)*(f*(2*C - 1) - 2*g2)*(r + s - 1) + bd1*(D1*(-2*f**2*(r + s - 1)*(15*C*(s - 1) - s*(3*K + 7) + 7) + f*fd*(18*C - 9)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + 6*f*(13*g2*(s - 1) + gd2*(3 - 6*s))*(r + s - 1) + 18*fd*g2*(-2*r*s + r - s*(2*s - 2))) + 9*Dd*f*(f*(2*C - 1) - 2*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + 6*f*(D1*(f*fd*(2*C - 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 2*f*gd2*s*(r + s - 1) + 2*fd*g2*(-2*r*s + r - 2*s**2 + 2*s - 1)) + Dd*f*(f*(2*C - 1) - 2*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**2*(D1**2*s*(-3*f*fd*(2*r + 2*s - 1) + (r + s)*(9*K*fdd + fd*(7 - 39*K))) + D1*(Dd*(9*K*fd*(r*(8*s - 1) + 4*s*(2*s - 1)) - 3*f**2*(r*(4*s - 1) + (1 - 2*s)**2) - f*(39*K - 7)*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1*(D1**2*(9*K*bdd1*f*(2*s - 1)*(r + s - 1) + f*(6*K*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - fd*s*(30*C - 14)*(2*r + 2*s - 1) + fdd*s*(18*C - 9)*(2*r + 2*s - 1) + s*(78*gd2 - 18*gdd2)*(r + s - 1)) + 3*s*(fd**2*(6*C - 3)*(2*r + 2*s - 1) + 26*fd*g2*(r + s) - 6*fd*gd2*(2*r + 2*s - 1) - 6*fdd*g2*(r + s))) + D1*bd1*(D1*(9*K*fd*(r*(4*s - 1) + s*(4*s - 3)) - 3*f**2*(2*s - 1)*(r + s - 1) - f*(39*K - 7)*(2*s - 1)*(r + s - 1)) + 9*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) + D1*(Dd*(-2*f**2*(r*(4*s - 1) + (1 - 2*s)**2)*(15*C - 3*K - 7) + 3*f*(fd*(6*C - 3)*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 26*g2*(r*(4*s - 1) + (1 - 2*s)**2) - 6*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 18*fd*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 9*Ddd*f*(f*(2*C - 1) - 2*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + 9*Dd**2*f*(f*(2*C - 1) - 2*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**5) + 5*D1**2*Pkd2*Pkd3*ct*k1*k2**2*st**6*(b1*(D1**2*(7*f**2*(2*fd - fdd)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*(-7*fd**2*(6*r*s - 2*r + 6*s**2 - 6*s + 1) + 66*fd*(2*r*s - r + 2*s**2 - 2*s + 1) - 33*fdd*(2*r*s - r + 2*s**2 - 2*s + 1)) + 33*fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(Dd*(14*f**2*(r*(4*s - 1) + (1 - 2*s)**2) + f*(-7*fd*(r*(24*s - 7) + 24*s**2 - 24*s + 5) + 66*r*(4*s - 1) + 66*(1 - 2*s)**2) - 66*fd*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(7*f + 33)*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd**2*f**2*(7*f + 33)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + f*(-D1**2*(7*bdd1*f**2*s*(r + s - 1) + f*(33*bdd1*s*(r + s - 1) + fd*(r*(2 - 6*s) - 6*s**2 + 6*s - 2) + fdd*(3*r*s - r + 3*s**2 - 3*s + 1)) + fd**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1)) + D1*bd1*(D1*(-7*f*fd*(r*(6*s - 1) + 6*s**2 - 6*s + 1) + 2*f*s*(7*f + 33)*(r + s - 1) - 33*fd*(r*(4*s - 1) + (1 - 2*s)**2)) - Dd*f*(7*f + 33)*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct*k1*k2**2*st**4*(-11*D1**2*bd1**2*f*(r*(4*K*s - 1) + (2*s - 1)*(2*K*s - 1)) + 11*D1*bd1*(D1*(f*s*(f*(K - 1)*(r + s - 1) - 8*g2*(r + s) + 4*gd2*(2*r + 2*s - 1)) + 4*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 4*Dd*f*g2*(r*(8*s - 1) + 4*s*(2*s - 1))) + 11*b1**2*(D1**2*(2*fd - fdd)*(2*K*(s - 1)*(r + s - 1) + r + 2*s - 1) - 2*D1*(Dd*(2*K*f*(-4*r*s + r - (1 - 2*s)**2) + K*fd*(r*(8*s - 5) + 8*s**2 - 12*s + 4) + 2*fd*(r + 2*s - 1)) + Ddd*K*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd**2*K*f*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + 11*b1*(2*D1**2*K*f*fd*r*s - D1**2*K*f*fd*r + 2*D1**2*K*f*fd*s**2 - 2*D1**2*K*f*fd*s + D1**2*K*f*fd + D1**2*bdd1*f*(-4*K*r*s - 4*K*s**2 + 2*K*s + r + 2*s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd - 8*D1**2*f*gd2*r*s - 8*D1**2*f*gd2*s**2 + 8*D1**2*f*gd2*s + 4*D1**2*f*gdd2*r*s + 4*D1**2*f*gdd2*s**2 - 4*D1**2*f*gdd2*s - 8*D1**2*fd*g2*r*s + 8*D1**2*fd*g2*r - 8*D1**2*fd*g2*s**2 + 16*D1**2*fd*g2*s - 8*D1**2*fd*g2 + 8*D1**2*fd*gd2*r*s - 4*D1**2*fd*gd2*r + 8*D1**2*fd*gd2*s**2 - 12*D1**2*fd*gd2*s + 4*D1**2*fd*gd2 + 4*D1**2*fdd*g2*r*s - 4*D1**2*fdd*g2*r + 4*D1**2*fdd*g2*s**2 - 8*D1**2*fdd*g2*s + 4*D1**2*fdd*g2 + 4*D1*Dd*K*f**2*r*s - D1*Dd*K*f**2*r + 4*D1*Dd*K*f**2*s**2 - 4*D1*Dd*K*f**2*s + D1*Dd*K*f**2 - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 32*D1*Dd*f*g2*r*s + 8*D1*Dd*f*g2*r - 32*D1*Dd*f*g2*s**2 + 32*D1*Dd*f*g2*s - 8*D1*Dd*f*g2 + 32*D1*Dd*f*gd2*r*s - 4*D1*Dd*f*gd2*r + 32*D1*Dd*f*gd2*s**2 - 32*D1*Dd*f*gd2*s + 4*D1*Dd*f*gd2 + 32*D1*Dd*fd*g2*r*s - 20*D1*Dd*fd*g2*r + 32*D1*Dd*fd*g2*s**2 - 48*D1*Dd*fd*g2*s + 16*D1*Dd*fd*g2 + 16*D1*Ddd*f*g2*r*s - 4*D1*Ddd*f*g2*r + 16*D1*Ddd*f*g2*s**2 - 16*D1*Ddd*f*g2*s + 4*D1*Ddd*f*g2 + D1*bd1*(D1*f*(r*(8*K*s - 2) + (4*s - 2)*(2*K*s - 1)) - D1*fd*(2*K*(4*r*s - 2*r + 4*s**2 - 5*s + 1) + r + 2*s - 1) - 2*Dd*K*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1) + 4*Dd*f*(r + 2*s - 1)) + 48*Dd**2*f*g2*r*s - 12*Dd**2*f*g2*r + 48*Dd**2*f*g2*s**2 - 48*Dd**2*f*g2*s + 8*Dd**2*f*g2) + f*(D1**2*(44*bdd1*g2*s*(r + s) + f*(fd*(20*C - 10)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(10*C - 5)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(11*bd2 - 22*gd2)*(r + s - 1)) - fd**2*(10*C - 5)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 22*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 11*D1*b2*(D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + D1*f*(Dd*(f*(20*C - 10)*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(10*C - 5)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 22*g2*(r*(4*s - 1) + (1 - 2*s)**2)) + Ddd*f*(5 - 10*C)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*f**2*(5 - 10*C)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(77*d**2*k3**3) + D1**2*Pkd2*Pkd3*ct*k1*k2**2*st**2*(D1*(D1*bd1**2*(-3*K*f*(r*(4*s - 3) + 4*s**2 - 8*s + 3) + f*(4*C - 3)*(r*(2*s - 1) + s*(2*s - 2)) + 28*g2*r*(2*s - 1) + 56*g2*s*(s - 1)) + b2*(bd1*(D1*(25*f*(s - 1)*(r + s - 1) + 9*fd*(-2*r*s + r - s*(2*s - 2))) - 9*Dd*f*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) - 3*f*(3*D1*bdd1*(s - 1)*(r + s - 1) + 2*D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + bd1*(-9*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(2*f**2*(C*(r*(14*s - 17) + 14*s**2 - 34*s + 17) - 3*K*s**2 + 3*K*s + r*(-3*K*s - 7*s + 8) - 7*s**2 + 16*s - 8) + f*(-fd*(6*C - 3)*(r*(8*s - 5) + 8*s**2 - 12*s + 3) + 2*g2*(2*r*s + 25*r + 2*s**2 + 50*s - 25) + 6*gd2*(4*r*s - 3*r + 4*s**2 - 8*s + 3)) + 12*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) - 6*Dd*f*(f*(2*C - 1) - 2*g2)*(r*(8*s - 7) + 8*s**2 - 16*s + 6)) - 3*f*(D1*bdd1*(f*(2*C - 1) - 2*g2)*(r*(2*s - 3) + 2*s**2 - 6*s + 3) + 2*D1*(f*fd*(2*C - 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + f*s*(bd2 - 2*gd2)*(r + s - 1) + 2*fd*g2*(-2*r*s + r - 2*s**2 + 2*s - 1)) + 2*Dd*f*(f*(2*C - 1) - 2*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + b1**3*(3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(6*f*(r*(4*s - 1) + (1 - 2*s)**2) - 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + (28*K - 14)*(r*(4*s - 1) + (1 - 2*s)**2)) - D1*Ddd*(r*(4*s - 1) + (1 - 2*s)**2)*(14*K + 3*f - 7) - Dd**2*(14*K + 3*f - 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(-8*C*D1**2*fd*r*s - 8*C*D1**2*fd*s**2 + 8*C*D1**2*fd*s + 4*C*D1**2*fdd*r*s + 4*C*D1**2*fdd*s**2 - 4*C*D1**2*fdd*s - 32*C*D1*Dd*f*r*s + 8*C*D1*Dd*f*r - 32*C*D1*Dd*f*s**2 + 32*C*D1*Dd*f*s - 8*C*D1*Dd*f + 32*C*D1*Dd*fd*r*s - 4*C*D1*Dd*fd*r + 32*C*D1*Dd*fd*s**2 - 32*C*D1*Dd*fd*s + 4*C*D1*Dd*fd + 16*C*D1*Ddd*f*r*s - 4*C*D1*Ddd*f*r + 16*C*D1*Ddd*f*s**2 - 16*C*D1*Ddd*f*s + 4*C*D1*Ddd*f + 48*C*Dd**2*f*r*s - 12*C*Dd**2*f*r + 48*C*Dd**2*f*s**2 - 48*C*Dd**2*f*s + 8*C*Dd**2*f - 2*D1**2*K*fd*r*s + 27*D1**2*K*fd*r - 2*D1**2*K*fd*s**2 + 54*D1**2*K*fd*s - 27*D1**2*K*fd - 6*D1**2*K*fdd*r*s - 3*D1**2*K*fdd*r - 6*D1**2*K*fdd*s**2 - 6*D1**2*K*fdd*s + 3*D1**2*K*fdd - D1**2*bdd1*(14*K + 3*f - 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 3*D1**2*f*fd*r + 6*D1**2*f*fd*s - 3*D1**2*f*fd + 6*D1**2*fd*r*s - 7*D1**2*fd*r + 6*D1**2*fd*s**2 - 20*D1**2*fd*s + 7*D1**2*fd - 3*D1**2*fdd*r*s - 3*D1**2*fdd*s**2 + 3*D1**2*fdd*s - 56*D1**2*gd2*r*s - 56*D1**2*gd2*s**2 + 56*D1**2*gd2*s + 28*D1**2*gdd2*r*s + 28*D1**2*gdd2*s**2 - 28*D1**2*gdd2*s - 8*D1*Dd*K*f*r*s + 2*D1*Dd*K*f*r - 8*D1*Dd*K*f*s**2 + 8*D1*Dd*K*f*s - 2*D1*Dd*K*f - 48*D1*Dd*K*fd*r*s - 6*D1*Dd*K*fd*r - 48*D1*Dd*K*fd*s**2 + 12*D1*Dd*K*fd + 24*D1*Dd*f*r*s - 6*D1*Dd*f*r + 24*D1*Dd*f*s**2 - 24*D1*Dd*f*s + 6*D1*Dd*f - 24*D1*Dd*fd*r*s + 3*D1*Dd*fd*r - 24*D1*Dd*fd*s**2 + 24*D1*Dd*fd*s - 3*D1*Dd*fd - 224*D1*Dd*g2*r*s + 56*D1*Dd*g2*r - 224*D1*Dd*g2*s**2 + 224*D1*Dd*g2*s - 56*D1*Dd*g2 + 224*D1*Dd*gd2*r*s - 28*D1*Dd*gd2*r + 224*D1*Dd*gd2*s**2 - 224*D1*Dd*gd2*s + 28*D1*Dd*gd2 - 24*D1*Ddd*K*f*r*s + 6*D1*Ddd*K*f*r - 24*D1*Ddd*K*f*s**2 + 24*D1*Ddd*K*f*s - 6*D1*Ddd*K*f - 12*D1*Ddd*f*r*s + 3*D1*Ddd*f*r - 12*D1*Ddd*f*s**2 + 12*D1*Ddd*f*s - 3*D1*Ddd*f + 112*D1*Ddd*g2*r*s - 28*D1*Ddd*g2*r + 112*D1*Ddd*g2*s**2 - 112*D1*Ddd*g2*s + 28*D1*Ddd*g2 + D1*bd1*(D1*(6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + (28*K - 14)*(3*r*s - r + 3*s**2 - 3*s + 1)) - Dd*(14*K + 3*f - 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 72*Dd**2*K*f*r*s + 18*Dd**2*K*f*r - 72*Dd**2*K*f*s**2 + 72*Dd**2*K*f*s - 12*Dd**2*K*f - 36*Dd**2*f*r*s + 9*Dd**2*f*r - 36*Dd**2*f*s**2 + 36*Dd**2*f*s - 6*Dd**2*f + 336*Dd**2*g2*r*s - 84*Dd**2*g2*r + 336*Dd**2*g2*s**2 - 336*Dd**2*g2*s + 56*Dd**2*g2) + b1*(56*C*D1**2*f*fd*r*s + 6*C*D1**2*f*fd*r + 56*C*D1**2*f*fd*s**2 - 16*C*D1**2*f*fd*s - 6*C*D1**2*f*fd - 24*C*D1**2*f*fdd*r*s - 6*C*D1**2*f*fdd*r - 24*C*D1**2*f*fdd*s**2 + 6*C*D1**2*f*fdd - 24*C*D1**2*fd**2*r*s - 6*C*D1**2*fd**2*r - 24*C*D1**2*fd**2*s**2 + 6*C*D1**2*fd**2 + 112*C*D1*Dd*f**2*r*s - 28*C*D1*Dd*f**2*r + 112*C*D1*Dd*f**2*s**2 - 112*C*D1*Dd*f**2*s + 28*C*D1*Dd*f**2 - 192*C*D1*Dd*f*fd*r*s - 192*C*D1*Dd*f*fd*s**2 + 96*C*D1*Dd*f*fd*s + 12*C*D1*Dd*f*fd - 48*C*D1*Ddd*f**2*r*s + 12*C*D1*Ddd*f**2*r - 48*C*D1*Ddd*f**2*s**2 + 48*C*D1*Ddd*f**2*s - 12*C*D1*Ddd*f**2 - 144*C*Dd**2*f**2*r*s + 36*C*Dd**2*f**2*r - 144*C*Dd**2*f**2*s**2 + 144*C*Dd**2*f**2*s - 24*C*Dd**2*f**2 - 12*D1**2*K*f*fd*r*s + 6*D1**2*K*f*fd*r - 12*D1**2*K*f*fd*s**2 + 12*D1**2*K*f*fd*s - 6*D1**2*K*f*fd + 25*D1**2*b2*fd*r*s + 25*D1**2*b2*fd*s**2 - 9*D1**2*b2*fdd*r*s - 9*D1**2*b2*fdd*s**2 - D1**2*bd1**2*(14*K + 3*f - 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 25*D1**2*bd2*f*r*s + 25*D1**2*bd2*f*s**2 - 25*D1**2*bd2*f*s - 18*D1**2*bd2*fd*r*s - 18*D1**2*bd2*fd*s**2 + 9*D1**2*bd2*fd*s + D1**2*bdd1*(f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) - 3*K*(4*r*s - 3*r + 4*s**2 - 8*s + 3) - 6*r*s + 3*r - 6*s**2 + 6*s - 3) + 28*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - 9*D1**2*bdd2*f*r*s - 9*D1**2*bdd2*f*s**2 + 9*D1**2*bdd2*f*s - 28*D1**2*f*fd*r*s - 2*D1**2*f*fd*r - 28*D1**2*f*fd*s**2 + 10*D1**2*f*fd*s + 2*D1**2*f*fd + 12*D1**2*f*fdd*r*s + 3*D1**2*f*fdd*r + 12*D1**2*f*fdd*s**2 - 3*D1**2*f*fdd + 4*D1**2*f*gd2*r*s + 4*D1**2*f*gd2*s**2 - 4*D1**2*f*gd2*s + 12*D1**2*f*gdd2*r*s + 12*D1**2*f*gdd2*s**2 - 12*D1**2*f*gdd2*s + 12*D1**2*fd**2*r*s + 3*D1**2*fd**2*r + 12*D1**2*fd**2*s**2 - 3*D1**2*fd**2 + 4*D1**2*fd*g2*r*s - 54*D1**2*fd*g2*r + 4*D1**2*fd*g2*s**2 - 108*D1**2*fd*g2*s + 54*D1**2*fd*g2 + 24*D1**2*fd*gd2*r*s + 6*D1**2*fd*gd2*r + 24*D1**2*fd*gd2*s**2 - 6*D1**2*fd*gd2 + 12*D1**2*fdd*g2*r*s + 6*D1**2*fdd*g2*r + 12*D1**2*fdd*g2*s**2 + 12*D1**2*fdd*g2*s - 6*D1**2*fdd*g2 - 24*D1*Dd*K*f**2*r*s + 6*D1*Dd*K*f**2*r - 24*D1*Dd*K*f**2*s**2 + 24*D1*Dd*K*f**2*s - 6*D1*Dd*K*f**2 + 100*D1*Dd*b2*f*r*s - 25*D1*Dd*b2*f*r + 100*D1*Dd*b2*f*s**2 - 100*D1*Dd*b2*f*s + 25*D1*Dd*b2*f - 72*D1*Dd*b2*fd*r*s + 9*D1*Dd*b2*fd*r - 72*D1*Dd*b2*fd*s**2 + 36*D1*Dd*b2*fd*s - 72*D1*Dd*bd2*f*r*s + 9*D1*Dd*bd2*f*r - 72*D1*Dd*bd2*f*s**2 + 72*D1*Dd*bd2*f*s - 9*D1*Dd*bd2*f - 56*D1*Dd*f**2*r*s + 14*D1*Dd*f**2*r - 56*D1*Dd*f**2*s**2 + 56*D1*Dd*f**2*s - 14*D1*Dd*f**2 + 96*D1*Dd*f*fd*r*s + 96*D1*Dd*f*fd*s**2 - 48*D1*Dd*f*fd*s - 6*D1*Dd*f*fd + 16*D1*Dd*f*g2*r*s - 4*D1*Dd*f*g2*r + 16*D1*Dd*f*g2*s**2 - 16*D1*Dd*f*g2*s + 4*D1*Dd*f*g2 + 96*D1*Dd*f*gd2*r*s - 12*D1*Dd*f*gd2*r + 96*D1*Dd*f*gd2*s**2 - 96*D1*Dd*f*gd2*s + 12*D1*Dd*f*gd2 + 96*D1*Dd*fd*g2*r*s + 12*D1*Dd*fd*g2*r + 96*D1*Dd*fd*g2*s**2 - 24*D1*Dd*fd*g2 - 36*D1*Ddd*b2*f*r*s + 9*D1*Ddd*b2*f*r - 36*D1*Ddd*b2*f*s**2 + 36*D1*Ddd*b2*f*s - 9*D1*Ddd*b2*f + 24*D1*Ddd*f**2*r*s - 6*D1*Ddd*f**2*r + 24*D1*Ddd*f**2*s**2 - 24*D1*Ddd*f**2*s + 6*D1*Ddd*f**2 + 48*D1*Ddd*f*g2*r*s - 12*D1*Ddd*f*g2*r + 48*D1*Ddd*f*g2*s**2 - 48*D1*Ddd*f*g2*s + 12*D1*Ddd*f*g2 + D1*bd1*(-D1*(-4*C*fd*(r*(4*s - 1) + (1 - 2*s)**2) + 3*f**2*(r + 2*s - 1) + f*(8*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + K*(4*r*s + 25*r + 4*s**2 + 48*s - 25) - 12*r*s - r - 12*s**2 - 2*s + 1) + 3*fd*(K*(r*(8*s - 1) + 8*s**2 - 4*s - 1) + r*(4*s - 1) + (1 - 2*s)**2) + 56*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 28*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(4*C*f*(r*(8*s - 3) + 2*(1 - 2*s)**2) - 3*f*(K*(8*r*(2*s - 1) + 16*s**2 - 24*s + 7) + r*(8*s - 3) + 2*(1 - 2*s)**2) + 28*g2*r*(8*s - 3) + 56*g2*(1 - 2*s)**2)) - 108*Dd**2*b2*f*r*s + 27*Dd**2*b2*f*r - 108*Dd**2*b2*f*s**2 + 108*Dd**2*b2*f*s - 18*Dd**2*b2*f + 72*Dd**2*f**2*r*s - 18*Dd**2*f**2*r + 72*Dd**2*f**2*s**2 - 72*Dd**2*f**2*s + 12*Dd**2*f**2 + 144*Dd**2*f*g2*r*s - 36*Dd**2*f*g2*r + 144*Dd**2*f*g2*s**2 - 144*Dd**2*f*g2*s + 24*Dd**2*f*g2))/(21*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*ct*k1*k2**2*(2*D1**2*bd1*(7*b2*f*(s - 1)*(r + s - 1) + (bd1*(-2*r*s + r - s*(2*s - 2)) + 2*f*(s - 1)*(r + s - 1))*(f*(6*C - 3) - 7*g2)) + D1*b1*(48*C*D1*f*fd*r*s + 48*C*D1*f*fd*s**2 - 24*C*D1*f*fd*s + 96*C*Dd*f**2*r*s - 24*C*Dd*f**2*r + 96*C*Dd*f**2*s**2 - 96*C*Dd*f**2*s + 24*C*Dd*f**2 - 7*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 14*D1*bd2*f*r*s + 14*D1*bd2*f*s**2 - 14*D1*bd2*f*s - 2*D1*bdd1*(f*(6*C - 3) - 7*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 24*D1*f*fd*r*s - 24*D1*f*fd*s**2 + 12*D1*f*fd*s - 28*D1*f*gd2*r*s - 28*D1*f*gd2*s**2 + 28*D1*f*gd2*s - 28*D1*fd*g2*r*s - 28*D1*fd*g2*s**2 - 48*Dd*f**2*r*s + 12*Dd*f**2*r - 48*Dd*f**2*s**2 + 48*Dd*f**2*s - 12*Dd*f**2 - 112*Dd*f*g2*r*s + 28*Dd*f*g2*r - 112*Dd*f*g2*s**2 + 112*Dd*f*g2*s - 28*Dd*f*g2 + 14*b2*(D1*fd*s*(r + s) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*bd1*(D1*(f*(9*C*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - 7*K*(2*s - 1)*(r + s - 1) - 16*r*s + 8*r - 16*s**2 + 16*s - 8) + fd*(6*C - 3)*(r*(4*s - 1) + (1 - 2*s)**2) + 7*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 7*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(f*(6*C - 3) - 7*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 7*b1**3*(D1**2*fd*s*(r + s - 1) + D1*(Dd*(2*K + f) - Ddd*K)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*K*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(D1**2*(-7*K*bdd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 2*s*(fd*(9*C*(r + s - 1) - 7*K*r - 7*K*s - 8*r - 8*s + 8) + (r + s - 1)*(fdd*(6*C - 3) + 14*gd2 - 7*gdd2))) + 7*D1*bd1*(D1*(2*K + f)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + Dd*K*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) - 2*D1*(Dd*(f*(r*(4*s - 1) + (1 - 2*s)**2)*(9*C - 7*K - 8) + fd*(6*C - 3)*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 7*g2*r*(8*s - 2) + 14*g2*(1 - 2*s)**2 + 7*gd2*(-8*r*s + r - 8*s**2 + 8*s - 1)) + Ddd*(f*(6*C - 3) - 7*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) - 2*Dd**2*(f*(6*C - 3) - 7*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**3) + 2*D1**2*Pkd2*Pkd3*ct*k1*st**4*(D1**2*bd1**2*f*s*(-2*r - 2*s + 1) + D1*b1*(D1*bdd1*f*s*(-2*r - 2*s + 1) - bd1*(D1*(-2*f*s*(2*r + 2*s - 1) + fd*(4*r*s - 2*r + 4*s**2 - 5*s + 1)) + Dd*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1))) + b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(7*d**2*k3) + D1**2*Pkd2*Pkd3*ct*k1*st**2*(-D1*(D1*bd1**2*f*(r*s*(6*K - 2) + r + s*(K*(6*s - 3) - 2*s + 2)) + 3*D1*bdd1*f*s*(r + s)*(b2 + f*(2*C - 1) - 2*g2) + bd1*(D1*(f**2*s*(4 - 10*C)*(r + s) + f*(fd*(6*C - 3)*(r*(4*s - 1) + s*(4*s - 3)) + s*(bd2*(6*r + 6*s - 3) + 26*g2*(r + s) - 6*gd2*(2*r + 2*s - 1))) + 6*fd*g2*(-2*r*s + r - s*(2*s - 2))) + 3*Dd*f*(f*(2*C - 1) - 2*g2)*(r*(8*s - 1) + 4*s*(2*s - 1)) + b2*(D1*(-13*f*s*(r + s) + fd*r*(6*s - 3) + 6*fd*s*(s - 1)) + 3*Dd*f*(r*(8*s - 1) + 4*s*(2*s - 1))))) + b1**3*(-3*D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*Dd*(-6*f*(r*(4*s - 1) + (1 - 2*s)**2) + 3*fd*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 14*r*(4*s - 1) + 14*(1 - 2*s)**2) + D1*Ddd*(3*f - 7)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(3*f - 7)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)) + b1**2*(13*D1**2*K*fd*r*s - 13*D1**2*K*fd*r + 13*D1**2*K*fd*s**2 - 26*D1**2*K*fd*s + 13*D1**2*K*fd - 3*D1**2*K*fdd*r*s + 3*D1**2*K*fdd*r - 3*D1**2*K*fdd*s**2 + 6*D1**2*K*fdd*s - 3*D1**2*K*fdd + D1**2*bdd1*(3*f - 7)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 6*D1**2*f*fd*r*s - 3*D1**2*f*fd*r + 6*D1**2*f*fd*s**2 - 9*D1**2*f*fd*s + 3*D1**2*f*fd - 9*D1**2*fd*r*s + 7*D1**2*fd*r - 9*D1**2*fd*s**2 + 16*D1**2*fd*s - 7*D1**2*fd + D1**2*fdd*r*s + D1**2*fdd*s**2 - D1**2*fdd*s + 52*D1*Dd*K*f*r*s - 13*D1*Dd*K*f*r + 52*D1*Dd*K*f*s**2 - 52*D1*Dd*K*f*s + 13*D1*Dd*K*f - 24*D1*Dd*K*fd*r*s + 15*D1*Dd*K*fd*r - 24*D1*Dd*K*fd*s**2 + 36*D1*Dd*K*fd*s - 12*D1*Dd*K*fd + 12*D1*Dd*f**2*r*s - 3*D1*Dd*f**2*r + 12*D1*Dd*f**2*s**2 - 12*D1*Dd*f**2*s + 3*D1*Dd*f**2 - 36*D1*Dd*f*r*s + 9*D1*Dd*f*r - 36*D1*Dd*f*s**2 + 36*D1*Dd*f*s - 9*D1*Dd*f + 8*D1*Dd*fd*r*s - D1*Dd*fd*r + 8*D1*Dd*fd*s**2 - 8*D1*Dd*fd*s + D1*Dd*fd - 12*D1*Ddd*K*f*r*s + 3*D1*Ddd*K*f*r - 12*D1*Ddd*K*f*s**2 + 12*D1*Ddd*K*f*s - 3*D1*Ddd*K*f + 4*D1*Ddd*f*r*s - D1*Ddd*f*r + 4*D1*Ddd*f*s**2 - 4*D1*Ddd*f*s + D1*Ddd*f + D1*bd1*(D1*(-6*f*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + 3*fd*(6*r*s - r + 6*s**2 - 6*s + 1) + 42*r*s - 14*r + 42*s**2 - 42*s + 14) + Dd*(3*f - 7)*(r*(24*s - 7) + 24*s**2 - 24*s + 5)) - 36*Dd**2*K*f*r*s + 9*Dd**2*K*f*r - 36*Dd**2*K*f*s**2 + 36*Dd**2*K*f*s - 6*Dd**2*K*f + 12*Dd**2*f*r*s - 3*Dd**2*f*r + 12*Dd**2*f*s**2 - 12*Dd**2*f*s + 2*Dd**2*f) + b1*(20*C*D1**2*f*fd*r*s - 10*C*D1**2*f*fd*r + 20*C*D1**2*f*fd*s**2 - 30*C*D1**2*f*fd*s + 10*C*D1**2*f*fd - 12*C*D1**2*f*fdd*r*s + 6*C*D1**2*f*fdd*r - 12*C*D1**2*f*fdd*s**2 + 18*C*D1**2*f*fdd*s - 6*C*D1**2*f*fdd - 12*C*D1**2*fd**2*r*s + 6*C*D1**2*fd**2*r - 12*C*D1**2*fd**2*s**2 + 18*C*D1**2*fd**2*s - 6*C*D1**2*fd**2 + 40*C*D1*Dd*f**2*r*s - 10*C*D1*Dd*f**2*r + 40*C*D1*Dd*f**2*s**2 - 40*C*D1*Dd*f**2*s + 10*C*D1*Dd*f**2 - 96*C*D1*Dd*f*fd*r*s + 36*C*D1*Dd*f*fd*r - 96*C*D1*Dd*f*fd*s**2 + 120*C*D1*Dd*f*fd*s - 30*C*D1*Dd*f*fd - 24*C*D1*Ddd*f**2*r*s + 6*C*D1*Ddd*f**2*r - 24*C*D1*Ddd*f**2*s**2 + 24*C*D1*Ddd*f**2*s - 6*C*D1*Ddd*f**2 - 72*C*Dd**2*f**2*r*s + 18*C*Dd**2*f**2*r - 72*C*Dd**2*f**2*s**2 + 72*C*Dd**2*f**2*s - 12*C*Dd**2*f**2 + 13*D1**2*b2*fd*r*s - 13*D1**2*b2*fd*r + 13*D1**2*b2*fd*s**2 - 26*D1**2*b2*fd*s + 13*D1**2*b2*fd - 3*D1**2*b2*fdd*r*s + 3*D1**2*b2*fdd*r - 3*D1**2*b2*fdd*s**2 + 6*D1**2*b2*fdd*s - 3*D1**2*b2*fdd + D1**2*bd1**2*(3*f - 7)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 13*D1**2*bd2*f*r*s + 13*D1**2*bd2*f*s**2 - 13*D1**2*bd2*f*s - 6*D1**2*bd2*fd*r*s + 3*D1**2*bd2*fd*r - 6*D1**2*bd2*fd*s**2 + 9*D1**2*bd2*fd*s - 3*D1**2*bd2*fd - D1**2*bdd1*f*(r*s*(6*K - 2) + r + s**2*(6*K - 2) + s*(2 - 3*K) - 1) - 3*D1**2*bdd2*f*r*s - 3*D1**2*bdd2*f*s**2 + 3*D1**2*bdd2*f*s - 8*D1**2*f*fd*r*s + 4*D1**2*f*fd*r - 8*D1**2*f*fd*s**2 + 12*D1**2*f*fd*s - 4*D1**2*f*fd + 6*D1**2*f*fdd*r*s - 3*D1**2*f*fdd*r + 6*D1**2*f*fdd*s**2 - 9*D1**2*f*fdd*s + 3*D1**2*f*fdd - 26*D1**2*f*gd2*r*s - 26*D1**2*f*gd2*s**2 + 26*D1**2*f*gd2*s + 6*D1**2*f*gdd2*r*s + 6*D1**2*f*gdd2*s**2 - 6*D1**2*f*gdd2*s + 6*D1**2*fd**2*r*s - 3*D1**2*fd**2*r + 6*D1**2*fd**2*s**2 - 9*D1**2*fd**2*s + 3*D1**2*fd**2 - 26*D1**2*fd*g2*r*s + 26*D1**2*fd*g2*r - 26*D1**2*fd*g2*s**2 + 52*D1**2*fd*g2*s - 26*D1**2*fd*g2 + 12*D1**2*fd*gd2*r*s - 6*D1**2*fd*gd2*r + 12*D1**2*fd*gd2*s**2 - 18*D1**2*fd*gd2*s + 6*D1**2*fd*gd2 + 6*D1**2*fdd*g2*r*s - 6*D1**2*fdd*g2*r + 6*D1**2*fdd*g2*s**2 - 12*D1**2*fdd*g2*s + 6*D1**2*fdd*g2 + 52*D1*Dd*b2*f*r*s - 13*D1*Dd*b2*f*r + 52*D1*Dd*b2*f*s**2 - 52*D1*Dd*b2*f*s + 13*D1*Dd*b2*f - 24*D1*Dd*b2*fd*r*s + 15*D1*Dd*b2*fd*r - 24*D1*Dd*b2*fd*s**2 + 36*D1*Dd*b2*fd*s - 12*D1*Dd*b2*fd - 24*D1*Dd*bd2*f*r*s + 3*D1*Dd*bd2*f*r - 24*D1*Dd*bd2*f*s**2 + 24*D1*Dd*bd2*f*s - 3*D1*Dd*bd2*f - 16*D1*Dd*f**2*r*s + 4*D1*Dd*f**2*r - 16*D1*Dd*f**2*s**2 + 16*D1*Dd*f**2*s - 4*D1*Dd*f**2 + 48*D1*Dd*f*fd*r*s - 18*D1*Dd*f*fd*r + 48*D1*Dd*f*fd*s**2 - 60*D1*Dd*f*fd*s + 15*D1*Dd*f*fd - 104*D1*Dd*f*g2*r*s + 26*D1*Dd*f*g2*r - 104*D1*Dd*f*g2*s**2 + 104*D1*Dd*f*g2*s - 26*D1*Dd*f*g2 + 48*D1*Dd*f*gd2*r*s - 6*D1*Dd*f*gd2*r + 48*D1*Dd*f*gd2*s**2 - 48*D1*Dd*f*gd2*s + 6*D1*Dd*f*gd2 + 48*D1*Dd*fd*g2*r*s - 30*D1*Dd*fd*g2*r + 48*D1*Dd*fd*g2*s**2 - 72*D1*Dd*fd*g2*s + 24*D1*Dd*fd*g2 - 12*D1*Ddd*b2*f*r*s + 3*D1*Ddd*b2*f*r - 12*D1*Ddd*b2*f*s**2 + 12*D1*Ddd*b2*f*s - 3*D1*Ddd*b2*f + 12*D1*Ddd*f**2*r*s - 3*D1*Ddd*f**2*r + 12*D1*Ddd*f**2*s**2 - 12*D1*Ddd*f**2*s + 3*D1*Ddd*f**2 + 24*D1*Ddd*f*g2*r*s - 6*D1*Ddd*f*g2*r + 24*D1*Ddd*f*g2*s**2 - 24*D1*Ddd*f*g2*s + 6*D1*Ddd*f*g2 + D1*bd1*(D1*(3*f**2*s*(2*r + 2*s - 1) + f*(2*r*(s*(13*K - 9) + 1) + s**2*(26*K - 18) + s*(11 - 13*K) - 2) - fd*(3*K*(r*(4*s - 2) + 4*s**2 - 5*s + 1) - 4*r*s + r - (1 - 2*s)**2)) + Dd*f*(K*(r*(6 - 48*s) - 48*s**2 + 36*s - 3) + 2*r*(8*s - 3) + 4*(1 - 2*s)**2)) - 36*Dd**2*b2*f*r*s + 9*Dd**2*b2*f*r - 36*Dd**2*b2*f*s**2 + 36*Dd**2*b2*f*s - 6*Dd**2*b2*f + 36*Dd**2*f**2*r*s - 9*Dd**2*f**2*r + 36*Dd**2*f**2*s**2 - 36*Dd**2*f**2*s + 6*Dd**2*f**2 + 72*Dd**2*f*g2*r*s - 18*Dd**2*f*g2*r + 72*Dd**2*f*g2*s**2 - 72*Dd**2*f*g2*s + 12*Dd**2*f*g2))/(21*d**2*k3) + 2*D1**2*Pkd2*Pkd3*ct*k1*(-D1**2*bd1**2*(r*(2*s - 1) + s*(2*s - 2))*(12*C*f + 7*b2 - 6*f - 14*g2) + D1*b1*(-7*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 2*D1*bdd1*(f*(6*C - 3) - 7*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + 7*b2*(D1*bdd1*(-2*r*s + r - 2*s**2 + 2*s - 1) + 2*bd1*(D1*r*(2*s - 1) + 2*D1*s**2 - 2*D1*s + D1 + Dd*r*(3 - 8*s) - 2*Dd*(1 - 2*s)**2)) + bd1*(-7*D1*bd2*(r*(4*s - 1) + (1 - 2*s)**2) + 2*D1*(f*(5*C + 1)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - fd*(6*C - 3)*(r*(4*s - 1) + (1 - 2*s)**2) - 7*g2*(4*r*s - 2*r + 4*s**2 - 4*s + 2) - 7*gd2*(-4*r*s + r - 4*s**2 + 4*s - 1)) - 4*Dd*(f*(6*C - 3) - 7*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 7*b1**3*(D1**2*fd*s*(r + s - 1) + D1*(Dd*(2*K + f) - Ddd*K)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*K*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(10*C*D1**2*fd*r*s + 10*C*D1**2*fd*s**2 - 10*C*D1**2*fd*s - 12*C*D1**2*fdd*r*s - 12*C*D1**2*fdd*s**2 + 12*C*D1**2*fdd*s + 40*C*D1*Dd*f*r*s - 10*C*D1*Dd*f*r + 40*C*D1*Dd*f*s**2 - 40*C*D1*Dd*f*s + 10*C*D1*Dd*f - 96*C*D1*Dd*fd*r*s + 12*C*D1*Dd*fd*r - 96*C*D1*Dd*fd*s**2 + 96*C*D1*Dd*fd*s - 12*C*D1*Dd*fd - 48*C*D1*Ddd*f*r*s + 12*C*D1*Ddd*f*r - 48*C*D1*Ddd*f*s**2 + 48*C*D1*Ddd*f*s - 12*C*D1*Ddd*f - 144*C*Dd**2*f*r*s + 36*C*Dd**2*f*r - 144*C*Dd**2*f*s**2 + 144*C*Dd**2*f*s - 24*C*Dd**2*f + 42*D1**2*K*bd1*r*s - 14*D1**2*K*bd1*r + 42*D1**2*K*bd1*s**2 - 42*D1**2*K*bd1*s + 14*D1**2*K*bd1 - 21*D1**2*K*bdd1*r*s + 7*D1**2*K*bdd1*r - 21*D1**2*K*bdd1*s**2 + 21*D1**2*K*bdd1*s - 7*D1**2*K*bdd1 + 21*D1**2*bd1*f*r*s - 7*D1**2*bd1*f*r + 21*D1**2*bd1*f*s**2 - 21*D1**2*bd1*f*s + 7*D1**2*bd1*f - 7*D1**2*bdd2*r*s - 7*D1**2*bdd2*s**2 + 7*D1**2*bdd2*s + 2*D1**2*fd*r*s + 2*D1**2*fd*s**2 - 2*D1**2*fd*s + 6*D1**2*fdd*r*s + 6*D1**2*fdd*s**2 - 6*D1**2*fdd*s - 28*D1**2*gd2*r*s - 28*D1**2*gd2*s**2 + 28*D1**2*gd2*s + 14*D1**2*gdd2*r*s + 14*D1**2*gdd2*s**2 - 14*D1**2*gdd2*s - 168*D1*Dd*K*bd1*r*s + 49*D1*Dd*K*bd1*r - 168*D1*Dd*K*bd1*s**2 + 168*D1*Dd*K*bd1*s - 35*D1*Dd*K*bd1 + 8*D1*Dd*f*r*s - 2*D1*Dd*f*r + 8*D1*Dd*f*s**2 - 8*D1*Dd*f*s + 2*D1*Dd*f + 48*D1*Dd*fd*r*s - 6*D1*Dd*fd*r + 48*D1*Dd*fd*s**2 - 48*D1*Dd*fd*s + 6*D1*Dd*fd - 112*D1*Dd*g2*r*s + 28*D1*Dd*g2*r - 112*D1*Dd*g2*s**2 + 112*D1*Dd*g2*s - 28*D1*Dd*g2 + 112*D1*Dd*gd2*r*s - 14*D1*Dd*gd2*r + 112*D1*Dd*gd2*s**2 - 112*D1*Dd*gd2*s + 14*D1*Dd*gd2 + 24*D1*Ddd*f*r*s - 6*D1*Ddd*f*r + 24*D1*Ddd*f*s**2 - 24*D1*Ddd*f*s + 6*D1*Ddd*f + 56*D1*Ddd*g2*r*s - 14*D1*Ddd*g2*r + 56*D1*Ddd*g2*s**2 - 56*D1*Ddd*g2*s + 14*D1*Ddd*g2 + 7*D1*bd2*(2*D1*s*(r + s - 1) + Dd*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 72*Dd**2*f*r*s - 18*Dd**2*f*r + 72*Dd**2*f*s**2 - 72*Dd**2*f*s + 12*Dd**2*f + 168*Dd**2*g2*r*s - 42*Dd**2*g2*r + 168*Dd**2*g2*s**2 - 168*Dd**2*g2*s + 28*Dd**2*g2 + 7*b2*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(21*d**2*k3) - 20*D1**2*Pkd2*Pkd3*f**2*k1**6*st**4*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(3003*d**2*k2*k3**5) - 10*D1**2*Pkd2*Pkd3*f**2*k1**4*k2*st**6*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(1001*d**2*k3**5) + 10*D1**2*Pkd2*Pkd3*f**2*k1**2*k2**3*st**8*(D1**2*(f*(2*fd - fdd)*(r*(4*s - 1) + (1 - 2*s)**2) + fd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + D1*f*(2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2) - 2*Dd*fd*(4*s - 1)*(4*r + 4*s - 3) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(1287*d**2*k3**5) - 25*D1**2*Pkd2*Pkd3*f*k1**6*st**2*(-D1**2*bdd1*f**2*(s - 1)*(r + s - 1) + D1*bd1*f*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-6*r*s + 3*r - 6*s**2 + 8*s - 2)) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) + b1*(D1**2*s*(3*r + 3*s - 2)*(2*f*fd - f*fdd - 2*fd**2) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(3 - 24*s) - 24*s**2 + 20*s - 2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k2*k3**5) + 2*D1**2*Pkd2*Pkd3*f*k1**4*k2*st**4*(-12*D1**2*b1*f*fd*r*s - 8*D1**2*b1*f*fd*r - 12*D1**2*b1*f*fd*s**2 + 8*D1**2*b1*f*fd + 6*D1**2*b1*f*fdd*r*s + 4*D1**2*b1*f*fdd*r + 6*D1**2*b1*f*fdd*s**2 - 4*D1**2*b1*f*fdd + 12*D1**2*b1*fd**2*r*s + 8*D1**2*b1*fd**2*r + 12*D1**2*b1*fd**2*s**2 - 4*D1**2*b1*fd**2 + 2*D1**2*bdd1*f**2*(s - 3)*(r + s - 1) + 12*D1**2*f**2*fd*r*s - 3*D1**2*f**2*fd*r + 12*D1**2*f**2*fd*s**2 - 12*D1**2*f**2*fd*s + 3*D1**2*f**2*fd - 16*D1*Dd*b1*f**2*r*s + 4*D1*Dd*b1*f**2*r - 16*D1*Dd*b1*f**2*s**2 + 16*D1*Dd*b1*f**2*s - 4*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r*s + 10*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 24*D1*Dd*b1*f*fd*s - 8*D1*Dd*b1*f*fd + 12*D1*Dd*f**3*r*s - 3*D1*Dd*f**3*r + 12*D1*Dd*f**3*s**2 - 12*D1*Dd*f**3*s + 3*D1*Dd*f**3 + 8*D1*Ddd*b1*f**2*r*s - 2*D1*Ddd*b1*f**2*r + 8*D1*Ddd*b1*f**2*s**2 - 8*D1*Ddd*b1*f**2*s + 2*D1*Ddd*b1*f**2 - 2*D1*bd1*f*(D1*(2*f*(s - 3)*(r + s - 1) + fd*(-6*r*s + 7*r - 6*s**2 + 12*s - 4)) + Dd*f*(r*(13 - 8*s) - 8*s**2 + 20*s - 10)) + 24*Dd**2*b1*f**2*r*s - 6*Dd**2*b1*f**2*r + 24*Dd**2*b1*f**2*s**2 - 24*Dd**2*b1*f**2*s + 4*Dd**2*b1*f**2)/(231*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*f*k1**4*st**4*(D1*f*(D1*bd1*(-2*f*s*(2*r + 2*s - 1) + fd*(2*r*(6*s - 1) + 12*s**2 - 10*s + 1)) + D1*bdd1*f*s*(2*r + 2*s - 1) + Dd*bd1*f*(2*r*(8*s - 1) + 16*s**2 - 12*s + 1)) + b1*(D1**2*(-f*(2*fd - fdd)*(6*r*s - 2*r + 6*s**2 - 7*s + 2) + fd**2*(12*r*s - 4*r + 12*s**2 - 14*s + 3)) + D1*f*(Dd*(-4*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(2*r*(24*s - 7) + 48*s**2 - 52*s + 11)) + 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(231*d**2*k2*k3**3) - 5*D1**2*Pkd2*Pkd3*f*k1**2*k2**3*st**6*(18*D1**2*b1*f*fd*r*s - 8*D1**2*b1*f*fd*r + 18*D1**2*b1*f*fd*s**2 - 20*D1**2*b1*f*fd*s + 8*D1**2*b1*f*fd - 9*D1**2*b1*f*fdd*r*s + 4*D1**2*b1*f*fdd*r - 9*D1**2*b1*f*fdd*s**2 + 10*D1**2*b1*f*fdd*s - 4*D1**2*b1*f*fdd - 18*D1**2*b1*fd**2*r*s + 8*D1**2*b1*fd**2*r - 18*D1**2*b1*fd**2*s**2 + 20*D1**2*b1*fd**2*s - 4*D1**2*b1*fd**2 - D1**2*bdd1*f**2*(3*s + 1)*(r + s - 1) + 4*D1**2*f**2*fd*r*s - D1**2*f**2*fd*r + 4*D1**2*f**2*fd*s**2 - 4*D1**2*f**2*fd*s + D1**2*f**2*fd + 24*D1*Dd*b1*f**2*r*s - 6*D1*Dd*b1*f**2*r + 24*D1*Dd*b1*f**2*s**2 - 24*D1*Dd*b1*f**2*s + 6*D1*Dd*b1*f**2 - 72*D1*Dd*b1*f*fd*r*s + 25*D1*Dd*b1*f*fd*r - 72*D1*Dd*b1*f*fd*s**2 + 76*D1*Dd*b1*f*fd*s - 18*D1*Dd*b1*f*fd + 4*D1*Dd*f**3*r*s - D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s + D1*Dd*f**3 - 12*D1*Ddd*b1*f**2*r*s + 3*D1*Ddd*b1*f**2*r - 12*D1*Ddd*b1*f**2*s**2 + 12*D1*Ddd*b1*f**2*s - 3*D1*Ddd*b1*f**2 + D1*bd1*f*(D1*(2*f*(3*s + 1)*(r + s - 1) + fd*(-18*r*s + r - 18*s**2 + 16*s - 2)) - Dd*f*(24*r*s + r + 4*s*(6*s - 5))) - 36*Dd**2*b1*f**2*r*s + 9*Dd**2*b1*f**2*r - 36*Dd**2*b1*f**2*s**2 + 36*Dd**2*b1*f**2*s - 6*Dd**2*b1*f**2)/(693*d**2*k3**5) - D1**2*Pkd2*Pkd3*f*k1**2*k2**3*st**4*(4*C - 2)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(77*d**2*k3**5) + 5*D1**2*Pkd2*Pkd3*f*k1**2*k2*st**6*(-D1*f*(4*r + 4*s - 3)*(-D1*bd1*(2*f*s - 6*fd*s + fd) + D1*bdd1*f*s + Dd*bd1*f*(8*s - 1)) + b1*(D1**2*(f*(2*fd - fdd)*(4*r*(3*s - 1) + 12*s**2 - 13*s + 4) + fd**2*(r*(8 - 24*s) - 24*s**2 + 26*s - 5)) + D1*f*(Dd*(8*f*(r*(4*s - 1) + (1 - 2*s)**2) - fd*(24*s - 7)*(4*r + 4*s - 3)) - 4*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) - 4*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(693*d**2*k3**3) + D1**2*Pkd2*Pkd3*f*k1**2*k2*st**4*(4*C - 2)*(D1**2*(f*(2*fd - fdd)*(3*r*s - r + 3*s**2 - 3*s + 1) + fd**2*(-6*r*s + 2*r - 6*s**2 + 6*s - 1)) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(7 - 24*s) - 24*s**2 + 24*s - 5) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))/(77*d**2*k3**3) + D1**2*Pkd2*Pkd3*k1**4*k2*st**2*(D1**2*bd1*f**2*(bd1*(4 - 8*s) + f*(2*s - 3))*(r + s - 1) + D1*b1*f*(4*bd1*(D1*(2*f*(2*s - 1)*(r + s - 1) + fd*(-8*r*s + 2*r - 8*s**2 + 8*s - 1)) + Dd*f*(r*(6 - 16*s) - 16*s**2 + 20*s - 5)) + f*(-4*D1*bdd1*(2*s - 1)*(r + s - 1) + D1*fd*(6*r*s + r + 6*s**2 - 3*s - 1) + 2*Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) + 4*b1**2*(D1**2*s*(2*r + 2*s - 1)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(2 - 16*s) - 16*s**2 + 12*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(21*d**2*k3**5) + D1**2*Pkd2*Pkd3*k1**4*st**2*(D1**2*bd1**2*f**2*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + D1*b1*f*(D1*bdd1*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + bd1*(-2*D1*f*(r*(4*s - 2) + 4*s**2 - 5*s + 2) + D1*fd*(4*s - 1)*(4*r + 4*s - 3) + Dd*f*(8*s - 3)*(4*r + 4*s - 3))) + b1**2*(-D1**2*s*(4*r + 4*s - 3)*(2*f*fd - f*fdd - fd**2) + D1*f*(Dd*(-4*f*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(8*s - 1)*(4*r + 4*s - 3)) + 2*Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)) + 2*Dd**2*f**2*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k2*k3**3) - D1**2*Pkd2*Pkd3*k1**2*k2**3*st**2*(24*C*D1**2*b1*f*fd*r*s + 24*C*D1**2*b1*f*fd*s**2 - 12*C*D1**2*b1*f*fd*s - 12*C*D1**2*b1*f*fdd*r*s - 12*C*D1**2*b1*f*fdd*s**2 + 6*C*D1**2*b1*f*fdd*s - 12*C*D1**2*b1*fd**2*r*s - 12*C*D1**2*b1*fd**2*s**2 + 6*C*D1**2*b1*fd**2*s - 6*C*D1**2*f**2*fd*r*s + 2*C*D1**2*f**2*fd*r - 6*C*D1**2*f**2*fd*s**2 + 6*C*D1**2*f**2*fd*s - 2*C*D1**2*f**2*fd + 48*C*D1*Dd*b1*f**2*r*s - 12*C*D1*Dd*b1*f**2*r + 48*C*D1*Dd*b1*f**2*s**2 - 48*C*D1*Dd*b1*f**2*s + 12*C*D1*Dd*b1*f**2 - 96*C*D1*Dd*b1*f*fd*r*s + 12*C*D1*Dd*b1*f*fd*r - 96*C*D1*Dd*b1*f*fd*s**2 + 72*C*D1*Dd*b1*f*fd*s - 6*C*D1*Dd*b1*f*fd - 8*C*D1*Dd*f**3*r*s + 2*C*D1*Dd*f**3*r - 8*C*D1*Dd*f**3*s**2 + 8*C*D1*Dd*f**3*s - 2*C*D1*Dd*f**3 - 24*C*D1*Ddd*b1*f**2*r*s + 6*C*D1*Ddd*b1*f**2*r - 24*C*D1*Ddd*b1*f**2*s**2 + 24*C*D1*Ddd*b1*f**2*s - 6*C*D1*Ddd*b1*f**2 - 72*C*Dd**2*b1*f**2*r*s + 18*C*Dd**2*b1*f**2*r - 72*C*Dd**2*b1*f**2*s**2 + 72*C*Dd**2*b1*f**2*s - 12*C*Dd**2*b1*f**2 + 6*D1**2*K*b1**2*fd*r*s + 6*D1**2*K*b1**2*fd*s**2 - 3*D1**2*K*b1**2*fdd*r*s - 3*D1**2*K*b1**2*fdd*s**2 - 2*D1**2*K*b1*f*fd*r*s + D1**2*K*b1*f*fd*r - 2*D1**2*K*b1*f*fd*s**2 + 2*D1**2*K*b1*f*fd*s - D1**2*K*b1*f*fd - 3*D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) + 6*D1**2*b1**2*f*fd*r*s + 6*D1**2*b1**2*f*fd*s**2 - 3*D1**2*b1**2*f*fd*s - 12*D1**2*b1*f*fd*r*s - 12*D1**2*b1*f*fd*s**2 + 6*D1**2*b1*f*fd*s + 6*D1**2*b1*f*fdd*r*s + 6*D1**2*b1*f*fdd*s**2 - 3*D1**2*b1*f*fdd*s - 12*D1**2*b1*f*gd2*r*s - 12*D1**2*b1*f*gd2*s**2 + 12*D1**2*b1*f*gd2*s + 6*D1**2*b1*f*gdd2*r*s + 6*D1**2*b1*f*gdd2*s**2 - 6*D1**2*b1*f*gdd2*s + 6*D1**2*b1*fd**2*r*s + 6*D1**2*b1*fd**2*s**2 - 3*D1**2*b1*fd**2*s - 12*D1**2*b1*fd*g2*r*s - 12*D1**2*b1*fd*g2*s**2 + 12*D1**2*b1*fd*gd2*r*s + 12*D1**2*b1*fd*gd2*s**2 - 6*D1**2*b1*fd*gd2*s + 6*D1**2*b1*fdd*g2*r*s + 6*D1**2*b1*fdd*g2*s**2 - 3*D1**2*bdd1*f*(r + s - 1)*(K*b1*(2*s - 1) + f*(2*C - 1)*(s - 1) - 2*g2*(s - 1)) + 3*D1**2*f**2*fd*r*s - D1**2*f**2*fd*r + 3*D1**2*f**2*fd*s**2 - 3*D1**2*f**2*fd*s + D1**2*f**2*fd + 2*D1**2*f**2*gd2*r*s + 2*D1**2*f**2*gd2*s**2 - 2*D1**2*f**2*gd2*s + 4*D1**2*f*fd*g2*r*s - 2*D1**2*f*fd*g2*r + 4*D1**2*f*fd*g2*s**2 - 4*D1**2*f*fd*g2*s + 2*D1**2*f*fd*g2 + 24*D1*Dd*K*b1**2*f*r*s - 6*D1*Dd*K*b1**2*f*r + 24*D1*Dd*K*b1**2*f*s**2 - 24*D1*Dd*K*b1**2*f*s + 6*D1*Dd*K*b1**2*f - 24*D1*Dd*K*b1**2*fd*r*s + 3*D1*Dd*K*b1**2*fd*r - 24*D1*Dd*K*b1**2*fd*s**2 + 12*D1*Dd*K*b1**2*fd*s - 4*D1*Dd*K*b1*f**2*r*s + D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s**2 + 4*D1*Dd*K*b1*f**2*s - D1*Dd*K*b1*f**2 + 12*D1*Dd*b1**2*f**2*r*s - 3*D1*Dd*b1**2*f**2*r + 12*D1*Dd*b1**2*f**2*s**2 - 12*D1*Dd*b1**2*f**2*s + 3*D1*Dd*b1**2*f**2 - 24*D1*Dd*b1*f**2*r*s + 6*D1*Dd*b1*f**2*r - 24*D1*Dd*b1*f**2*s**2 + 24*D1*Dd*b1*f**2*s - 6*D1*Dd*b1*f**2 + 48*D1*Dd*b1*f*fd*r*s - 6*D1*Dd*b1*f*fd*r + 48*D1*Dd*b1*f*fd*s**2 - 36*D1*Dd*b1*f*fd*s + 3*D1*Dd*b1*f*fd - 48*D1*Dd*b1*f*g2*r*s + 12*D1*Dd*b1*f*g2*r - 48*D1*Dd*b1*f*g2*s**2 + 48*D1*Dd*b1*f*g2*s - 12*D1*Dd*b1*f*g2 + 48*D1*Dd*b1*f*gd2*r*s - 6*D1*Dd*b1*f*gd2*r + 48*D1*Dd*b1*f*gd2*s**2 - 48*D1*Dd*b1*f*gd2*s + 6*D1*Dd*b1*f*gd2 + 48*D1*Dd*b1*fd*g2*r*s - 6*D1*Dd*b1*fd*g2*r + 48*D1*Dd*b1*fd*g2*s**2 - 24*D1*Dd*b1*fd*g2*s + 4*D1*Dd*f**3*r*s - D1*Dd*f**3*r + 4*D1*Dd*f**3*s**2 - 4*D1*Dd*f**3*s + D1*Dd*f**3 + 8*D1*Dd*f**2*g2*r*s - 2*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s**2 - 8*D1*Dd*f**2*g2*s + 2*D1*Dd*f**2*g2 - 12*D1*Ddd*K*b1**2*f*r*s + 3*D1*Ddd*K*b1**2*f*r - 12*D1*Ddd*K*b1**2*f*s**2 + 12*D1*Ddd*K*b1**2*f*s - 3*D1*Ddd*K*b1**2*f + 12*D1*Ddd*b1*f**2*r*s - 3*D1*Ddd*b1*f**2*r + 12*D1*Ddd*b1*f**2*s**2 - 12*D1*Ddd*b1*f**2*s + 3*D1*Ddd*b1*f**2 + 24*D1*Ddd*b1*f*g2*r*s - 6*D1*Ddd*b1*f*g2*r + 24*D1*Ddd*b1*f*g2*s**2 - 24*D1*Ddd*b1*f*g2*s + 6*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(f**2*(r + s - 1)*(12*C*(s - 1) - K*s + b1*(6*s - 3) - 6*s + 6) - 3*f*(fd*(2*C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(2*r + 2*s - 2)) + 3*fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) - 3*Dd*f*(K*b1*(16*r*s - 6*r + 16*s**2 - 20*s + 5) + f*(2*C - 1)*(r*(8*s - 5) + 8*s**2 - 12*s + 4) - 2*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 36*Dd**2*K*b1**2*f*r*s + 9*Dd**2*K*b1**2*f*r - 36*Dd**2*K*b1**2*f*s**2 + 36*Dd**2*K*b1**2*f*s - 6*Dd**2*K*b1**2*f + 36*Dd**2*b1*f**2*r*s - 9*Dd**2*b1*f**2*r + 36*Dd**2*b1*f**2*s**2 - 36*Dd**2*b1*f**2*s + 6*Dd**2*b1*f**2 + 72*Dd**2*b1*f*g2*r*s - 18*Dd**2*b1*f*g2*r + 72*Dd**2*b1*f*g2*s**2 - 72*Dd**2*b1*f*g2*s + 12*Dd**2*b1*f*g2)/(21*d**2*k3**5) + D1**2*Pkd2*Pkd3*k1**2*k2*st**2*(D1*(-3*D1*K*bd1**2*f*(2*s - 1)*(r + s - 1) + b2*(3*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - f*(3*D1*bdd1*(s - 1)*(r + s - 1) + D1*fd*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + Dd*f*(r*(4*s - 1) + (1 - 2*s)**2))) - bd1*(3*D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(-f**2*(r + s - 1)*(12*C*(s - 1) - s*(K + 6) + 6) + 3*f*(fd*(2*C - 1)*(r*(4*s - 2) + 4*s**2 - 5*s + 1) + (2*r + 2*s - 2)*(2*g2*(s - 1) - 2*gd2*s + gd2)) + 6*fd*g2*(-2*r*s + r - s*(2*s - 2))) + 3*Dd*f*(f*(2*C - 1) - 2*g2)*(r*(8*s - 5) + 8*s**2 - 12*s + 4)) + f*(-3*D1*bdd1*(s - 1)*(f*(2*C - 1) - 2*g2)*(r + s - 1) + D1*(f*(-fd*(2*C - 1)*(3*r*s - r + 3*s**2 - 3*s + 1) - s*(bd2 - 2*gd2)*(r + s - 1)) + 2*fd*g2*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) - Dd*f*(f*(2*C - 1) - 2*g2)*(r*(4*s - 1) + (1 - 2*s)**2))) + 2*b1**3*(D1**2*s*(2*fd - fdd)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r - 8*s**2 + 8*s - 1) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(6*D1**2*K*fd*r*s + 6*D1**2*K*fd*s**2 - 3*D1**2*K*fdd*r*s - 3*D1**2*K*fdd*s**2 - 2*D1**2*bdd1*f*(3*r*s - r + 3*s**2 - 3*s + 1) + 4*D1**2*f*fd*r*s + D1**2*f*fd*r + 4*D1**2*f*fd*s**2 - D1**2*f*fd*s - D1**2*f*fd + 24*D1*Dd*K*f*r*s - 6*D1*Dd*K*f*r + 24*D1*Dd*K*f*s**2 - 24*D1*Dd*K*f*s + 6*D1*Dd*K*f - 24*D1*Dd*K*fd*r*s + 3*D1*Dd*K*fd*r - 24*D1*Dd*K*fd*s**2 + 12*D1*Dd*K*fd*s + 8*D1*Dd*f**2*r*s - 2*D1*Dd*f**2*r + 8*D1*Dd*f**2*s**2 - 8*D1*Dd*f**2*s + 2*D1*Dd*f**2 - 12*D1*Ddd*K*f*r*s + 3*D1*Ddd*K*f*r - 12*D1*Ddd*K*f*s**2 + 12*D1*Ddd*K*f*s - 3*D1*Ddd*K*f + 2*D1*bd1*(D1*(f*(6*r*s - 2*r + 6*s**2 - 6*s + 2) + fd*(-6*r*s + r - 6*s**2 + 6*s - 1)) + Dd*f*(r*(7 - 24*s) - 24*s**2 + 24*s - 5)) - 36*Dd**2*K*f*r*s + 9*Dd**2*K*f*r - 36*Dd**2*K*f*s**2 + 36*Dd**2*K*f*s - 6*Dd**2*K*f) - b1*(-24*C*D1**2*f*fd*r*s - 24*C*D1**2*f*fd*s**2 + 12*C*D1**2*f*fd*s + 12*C*D1**2*f*fdd*r*s + 12*C*D1**2*f*fdd*s**2 - 6*C*D1**2*f*fdd*s + 12*C*D1**2*fd**2*r*s + 12*C*D1**2*fd**2*s**2 - 6*C*D1**2*fd**2*s - 48*C*D1*Dd*f**2*r*s + 12*C*D1*Dd*f**2*r - 48*C*D1*Dd*f**2*s**2 + 48*C*D1*Dd*f**2*s - 12*C*D1*Dd*f**2 + 96*C*D1*Dd*f*fd*r*s - 12*C*D1*Dd*f*fd*r + 96*C*D1*Dd*f*fd*s**2 - 72*C*D1*Dd*f*fd*s + 6*C*D1*Dd*f*fd + 24*C*D1*Ddd*f**2*r*s - 6*C*D1*Ddd*f**2*r + 24*C*D1*Ddd*f**2*s**2 - 24*C*D1*Ddd*f**2*s + 6*C*D1*Ddd*f**2 + 72*C*Dd**2*f**2*r*s - 18*C*Dd**2*f**2*r + 72*C*Dd**2*f**2*s**2 - 72*C*Dd**2*f**2*s + 12*C*Dd**2*f**2 + 6*D1**2*K*bdd1*f*r*s - 3*D1**2*K*bdd1*f*r + 6*D1**2*K*bdd1*f*s**2 - 9*D1**2*K*bdd1*f*s + 3*D1**2*K*bdd1*f + 2*D1**2*K*f*fd*r*s - D1**2*K*f*fd*r + 2*D1**2*K*f*fd*s**2 - 2*D1**2*K*f*fd*s + D1**2*K*f*fd + 2*D1**2*bd1**2*f*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 6*D1**2*bd2*f*r*s - 6*D1**2*bd2*f*s**2 + 6*D1**2*bd2*f*s + 6*D1**2*bd2*fd*r*s + 6*D1**2*bd2*fd*s**2 - 3*D1**2*bd2*fd*s + 3*D1**2*bdd2*f*r*s + 3*D1**2*bdd2*f*s**2 - 3*D1**2*bdd2*f*s + 12*D1**2*f*fd*r*s + 12*D1**2*f*fd*s**2 - 6*D1**2*f*fd*s - 6*D1**2*f*fdd*r*s - 6*D1**2*f*fdd*s**2 + 3*D1**2*f*fdd*s + 12*D1**2*f*gd2*r*s + 12*D1**2*f*gd2*s**2 - 12*D1**2*f*gd2*s - 6*D1**2*f*gdd2*r*s - 6*D1**2*f*gdd2*s**2 + 6*D1**2*f*gdd2*s - 6*D1**2*fd**2*r*s - 6*D1**2*fd**2*s**2 + 3*D1**2*fd**2*s + 12*D1**2*fd*g2*r*s + 12*D1**2*fd*g2*s**2 - 12*D1**2*fd*gd2*r*s - 12*D1**2*fd*gd2*s**2 + 6*D1**2*fd*gd2*s - 6*D1**2*fdd*g2*r*s - 6*D1**2*fdd*g2*s**2 + 4*D1*Dd*K*f**2*r*s - D1*Dd*K*f**2*r + 4*D1*Dd*K*f**2*s**2 - 4*D1*Dd*K*f**2*s + D1*Dd*K*f**2 + 24*D1*Dd*bd2*f*r*s - 3*D1*Dd*bd2*f*r + 24*D1*Dd*bd2*f*s**2 - 24*D1*Dd*bd2*f*s + 3*D1*Dd*bd2*f + 24*D1*Dd*f**2*r*s - 6*D1*Dd*f**2*r + 24*D1*Dd*f**2*s**2 - 24*D1*Dd*f**2*s + 6*D1*Dd*f**2 - 48*D1*Dd*f*fd*r*s + 6*D1*Dd*f*fd*r - 48*D1*Dd*f*fd*s**2 + 36*D1*Dd*f*fd*s - 3*D1*Dd*f*fd + 48*D1*Dd*f*g2*r*s - 12*D1*Dd*f*g2*r + 48*D1*Dd*f*g2*s**2 - 48*D1*Dd*f*g2*s + 12*D1*Dd*f*g2 - 48*D1*Dd*f*gd2*r*s + 6*D1*Dd*f*gd2*r - 48*D1*Dd*f*gd2*s**2 + 48*D1*Dd*f*gd2*s - 6*D1*Dd*f*gd2 - 48*D1*Dd*fd*g2*r*s + 6*D1*Dd*fd*g2*r - 48*D1*Dd*fd*g2*s**2 + 24*D1*Dd*fd*g2*s - 12*D1*Ddd*f**2*r*s + 3*D1*Ddd*f**2*r - 12*D1*Ddd*f**2*s**2 + 12*D1*Ddd*f**2*s - 3*D1*Ddd*f**2 - 24*D1*Ddd*f*g2*r*s + 6*D1*Ddd*f*g2*r - 24*D1*Ddd*f*g2*s**2 + 24*D1*Ddd*f*g2*s - 6*D1*Ddd*f*g2 + D1*bd1*(-D1*(6*K*f*(2*s - 1)*(r + s - 1) + 3*K*fd*(-4*r*s + r + s*(3 - 4*s)) + f**2*(4*s - 3)*(r + s - 1)) + 3*Dd*K*f*(2*r*(8*s - 3) + 16*s**2 - 20*s + 5)) - 36*Dd**2*f**2*r*s + 9*Dd**2*f**2*r - 36*Dd**2*f**2*s**2 + 36*Dd**2*f**2*s - 6*Dd**2*f**2 - 72*Dd**2*f*g2*r*s + 18*Dd**2*f*g2*r - 72*Dd**2*f*g2*s**2 + 72*Dd**2*f*g2*s - 12*Dd**2*f*g2 - 3*b2*(D1**2*s*(2*fd - fdd)*(r + s) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(-8*r*s + r + s*(4 - 8*s)) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(21*d**2*k3**3) + 5*D1**2*Pkd2*Pkd3*k2**5*st**6*(D1**2*(f**2*(fd*(4*C - 2)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - fdd*(2*C - 1)*(r*(3*s - 1) + 3*s**2 - 3*s + 1) + s*(r + s - 1)*(-33*K*(-2*bd1 + bdd1) - 132*gd2 + 66*gdd2)) + f*(-fd**2*(2*C - 1)*(r*(6*s - 2) + 6*s**2 - 6*s + 1) - 33*fd*(K*b1*(r*(2 - 4*s) - 4*s**2 + 4*s - 2) + K*bd1*(r*(4*s - 1) + (1 - 2*s)**2) + g2*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + gd2*r*(2 - 8*s) - 2*gd2*(1 - 2*s)**2) + 33*fdd*(-K*b1 + 2*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1)) + 33*fd**2*(-K*b1 + 2*g2)*(r*(2*s - 1) + s*(2*s - 2))) + D1*f*(Dd*(f**2*(4*C - 2)*(r*(4*s - 1) + (1 - 2*s)**2) + f*(33*K*(b1*r*(8*s - 2) + 2*b1*(1 - 2*s)**2 + bd1*(-8*r*s + r - 8*s**2 + 8*s - 1)) - fd*(2*C - 1)*(r*(24*s - 7) + 24*s**2 - 24*s + 5) - 132*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 66*gd2*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 66*fd*(-K*b1 + 2*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2)) - Ddd*f*(r*(4*s - 1) + (1 - 2*s)**2)*(2*C*f + 33*K*b1 - f - 66*g2)) - Dd**2*f**2*(2*C*f + 33*K*b1 - f - 66*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2))/(693*d**2*k3**5) + 2*D1**2*Pkd2*Pkd3*k2**5*st**4*(2*D1**2*K*b1**2*fd*r*s + 2*D1**2*K*b1**2*fd*s**2 - D1**2*K*b1**2*fdd*r*s - D1**2*K*b1**2*fdd*s**2 - 2*D1**2*K*b1*f*fd*r*s + D1**2*K*b1*f*fd*r - 2*D1**2*K*b1*f*fd*s**2 + 2*D1**2*K*b1*f*fd*s - D1**2*K*b1*f*fd - D1**2*K*bd1**2*f*(2*s - 1)*(r + s - 1) - 4*D1**2*b1*f*gd2*r*s - 4*D1**2*b1*f*gd2*s**2 + 4*D1**2*b1*f*gd2*s + 2*D1**2*b1*f*gdd2*r*s + 2*D1**2*b1*f*gdd2*s**2 - 2*D1**2*b1*f*gdd2*s - 4*D1**2*b1*fd*g2*r*s - 4*D1**2*b1*fd*g2*s**2 + 4*D1**2*b1*fd*gd2*r*s + 4*D1**2*b1*fd*gd2*s**2 - 2*D1**2*b1*fd*gd2*s + 2*D1**2*b1*fdd*g2*r*s + 2*D1**2*b1*fdd*g2*s**2 + D1**2*bdd1*f*(K*b1*(1 - 2*s) + 2*g2*(s - 1))*(r + s - 1) + 2*D1**2*f**2*gd2*r*s + 2*D1**2*f**2*gd2*s**2 - 2*D1**2*f**2*gd2*s + 4*D1**2*f*fd*g2*r*s - 2*D1**2*f*fd*g2*r + 4*D1**2*f*fd*g2*s**2 - 4*D1**2*f*fd*g2*s + 2*D1**2*f*fd*g2 + 8*D1*Dd*K*b1**2*f*r*s - 2*D1*Dd*K*b1**2*f*r + 8*D1*Dd*K*b1**2*f*s**2 - 8*D1*Dd*K*b1**2*f*s + 2*D1*Dd*K*b1**2*f - 8*D1*Dd*K*b1**2*fd*r*s + D1*Dd*K*b1**2*fd*r - 8*D1*Dd*K*b1**2*fd*s**2 + 4*D1*Dd*K*b1**2*fd*s - 4*D1*Dd*K*b1*f**2*r*s + D1*Dd*K*b1*f**2*r - 4*D1*Dd*K*b1*f**2*s**2 + 4*D1*Dd*K*b1*f**2*s - D1*Dd*K*b1*f**2 - 16*D1*Dd*b1*f*g2*r*s + 4*D1*Dd*b1*f*g2*r - 16*D1*Dd*b1*f*g2*s**2 + 16*D1*Dd*b1*f*g2*s - 4*D1*Dd*b1*f*g2 + 16*D1*Dd*b1*f*gd2*r*s - 2*D1*Dd*b1*f*gd2*r + 16*D1*Dd*b1*f*gd2*s**2 - 16*D1*Dd*b1*f*gd2*s + 2*D1*Dd*b1*f*gd2 + 16*D1*Dd*b1*fd*g2*r*s - 2*D1*Dd*b1*fd*g2*r + 16*D1*Dd*b1*fd*g2*s**2 - 8*D1*Dd*b1*fd*g2*s + 8*D1*Dd*f**2*g2*r*s - 2*D1*Dd*f**2*g2*r + 8*D1*Dd*f**2*g2*s**2 - 8*D1*Dd*f**2*g2*s + 2*D1*Dd*f**2*g2 - 4*D1*Ddd*K*b1**2*f*r*s + D1*Ddd*K*b1**2*f*r - 4*D1*Ddd*K*b1**2*f*s**2 + 4*D1*Ddd*K*b1**2*f*s - D1*Ddd*K*b1**2*f + 8*D1*Ddd*b1*f*g2*r*s - 2*D1*Ddd*b1*f*g2*r + 8*D1*Ddd*b1*f*g2*s**2 - 8*D1*Ddd*b1*f*g2*s + 2*D1*Ddd*b1*f*g2 + D1*bd1*(D1*(-K*f**2*s*(r + s - 1) - 2*f*(2*g2*(s - 1) - (2*s - 1)*(K*b1 + gd2))*(r + s - 1) + fd*(K*b1*(-4*r*s + r + s*(3 - 4*s)) + g2*(r*(4*s - 2) + s*(4*s - 4)))) + Dd*f*(K*b1*(-16*r*s + 6*r - 16*s**2 + 20*s - 5) + 2*g2*(8*r*s - 5*r + 8*s**2 - 12*s + 4))) - 12*Dd**2*K*b1**2*f*r*s + 3*Dd**2*K*b1**2*f*r - 12*Dd**2*K*b1**2*f*s**2 + 12*Dd**2*K*b1**2*f*s - 2*Dd**2*K*b1**2*f + 24*Dd**2*b1*f*g2*r*s - 6*Dd**2*b1*f*g2*r + 24*Dd**2*b1*f*g2*s**2 - 24*Dd**2*b1*f*g2*s + 4*Dd**2*b1*f*g2)/(7*d**2*k3**5) - 5*D1**2*Pkd2*Pkd3*k2**3*st**6*(12*C*D1**2*f**2*fd*r*s - 4*C*D1**2*f**2*fd*r + 12*C*D1**2*f**2*fd*s**2 - 12*C*D1**2*f**2*fd*s + 4*C*D1**2*f**2*fd - 6*C*D1**2*f**2*fdd*r*s + 2*C*D1**2*f**2*fdd*r - 6*C*D1**2*f**2*fdd*s**2 + 6*C*D1**2*f**2*fdd*s - 2*C*D1**2*f**2*fdd - 12*C*D1**2*f*fd**2*r*s + 4*C*D1**2*f*fd**2*r - 12*C*D1**2*f*fd**2*s**2 + 12*C*D1**2*f*fd**2*s - 2*C*D1**2*f*fd**2 + 16*C*D1*Dd*f**3*r*s - 4*C*D1*Dd*f**3*r + 16*C*D1*Dd*f**3*s**2 - 16*C*D1*Dd*f**3*s + 4*C*D1*Dd*f**3 - 48*C*D1*Dd*f**2*fd*r*s + 14*C*D1*Dd*f**2*fd*r - 48*C*D1*Dd*f**2*fd*s**2 + 48*C*D1*Dd*f**2*fd*s - 10*C*D1*Dd*f**2*fd - 8*C*D1*Ddd*f**3*r*s + 2*C*D1*Ddd*f**3*r - 8*C*D1*Ddd*f**3*s**2 + 8*C*D1*Ddd*f**3*s - 2*C*D1*Ddd*f**3 - 24*C*Dd**2*f**3*r*s + 6*C*Dd**2*f**3*r - 24*C*Dd**2*f**3*s**2 + 24*C*Dd**2*f**3*s - 4*C*Dd**2*f**3 + 132*D1**2*K*b1*f*fd*r*s - 66*D1**2*K*b1*f*fd*r + 132*D1**2*K*b1*f*fd*s**2 - 132*D1**2*K*b1*f*fd*s + 66*D1**2*K*b1*f*fd - 66*D1**2*K*b1*f*fdd*r*s + 33*D1**2*K*b1*f*fdd*r - 66*D1**2*K*b1*f*fdd*s**2 + 66*D1**2*K*b1*f*fdd*s - 33*D1**2*K*b1*f*fdd - 66*D1**2*K*b1*fd**2*r*s + 33*D1**2*K*b1*fd**2*r - 66*D1**2*K*b1*fd**2*s**2 + 66*D1**2*K*b1*fd**2*s + 66*D1**2*K*bd1*f**2*r*s + 66*D1**2*K*bd1*f**2*s**2 - 66*D1**2*K*bd1*f**2*s - 132*D1**2*K*bd1*f*fd*r*s + 33*D1**2*K*bd1*f*fd*r - 132*D1**2*K*bd1*f*fd*s**2 + 132*D1**2*K*bd1*f*fd*s - 33*D1**2*K*bd1*f*fd - 33*D1**2*K*bdd1*f**2*r*s - 33*D1**2*K*bdd1*f**2*s**2 + 33*D1**2*K*bdd1*f**2*s - 33*D1**2*bdd2*f**2*r*s - 33*D1**2*bdd2*f**2*s**2 + 33*D1**2*bdd2*f**2*s - 6*D1**2*f**2*fd*r*s + 2*D1**2*f**2*fd*r - 6*D1**2*f**2*fd*s**2 + 6*D1**2*f**2*fd*s - 2*D1**2*f**2*fd + 3*D1**2*f**2*fdd*r*s - D1**2*f**2*fdd*r + 3*D1**2*f**2*fdd*s**2 - 3*D1**2*f**2*fdd*s + D1**2*f**2*fdd - 132*D1**2*f**2*gd2*r*s - 132*D1**2*f**2*gd2*s**2 + 132*D1**2*f**2*gd2*s + 66*D1**2*f**2*gdd2*r*s + 66*D1**2*f**2*gdd2*s**2 - 66*D1**2*f**2*gdd2*s + 6*D1**2*f*fd**2*r*s - 2*D1**2*f*fd**2*r + 6*D1**2*f*fd**2*s**2 - 6*D1**2*f*fd**2*s + D1**2*f*fd**2 - 264*D1**2*f*fd*g2*r*s + 132*D1**2*f*fd*g2*r - 264*D1**2*f*fd*g2*s**2 + 264*D1**2*f*fd*g2*s - 132*D1**2*f*fd*g2 + 264*D1**2*f*fd*gd2*r*s - 66*D1**2*f*fd*gd2*r + 264*D1**2*f*fd*gd2*s**2 - 264*D1**2*f*fd*gd2*s + 66*D1**2*f*fd*gd2 + 132*D1**2*f*fdd*g2*r*s - 66*D1**2*f*fdd*g2*r + 132*D1**2*f*fdd*g2*s**2 - 132*D1**2*f*fdd*g2*s + 66*D1**2*f*fdd*g2 + 132*D1**2*fd**2*g2*r*s - 66*D1**2*fd**2*g2*r + 132*D1**2*fd**2*g2*s**2 - 132*D1**2*fd**2*g2*s + 264*D1*Dd*K*b1*f**2*r*s - 66*D1*Dd*K*b1*f**2*r + 264*D1*Dd*K*b1*f**2*s**2 - 264*D1*Dd*K*b1*f**2*s + 66*D1*Dd*K*b1*f**2 - 528*D1*Dd*K*b1*f*fd*r*s + 198*D1*Dd*K*b1*f*fd*r - 528*D1*Dd*K*b1*f*fd*s**2 + 528*D1*Dd*K*b1*f*fd*s - 132*D1*Dd*K*b1*f*fd - 264*D1*Dd*K*bd1*f**2*r*s + 33*D1*Dd*K*bd1*f**2*r - 264*D1*Dd*K*bd1*f**2*s**2 + 264*D1*Dd*K*bd1*f**2*s - 33*D1*Dd*K*bd1*f**2 - 8*D1*Dd*f**3*r*s + 2*D1*Dd*f**3*r - 8*D1*Dd*f**3*s**2 + 8*D1*Dd*f**3*s - 2*D1*Dd*f**3 + 24*D1*Dd*f**2*fd*r*s - 7*D1*Dd*f**2*fd*r + 24*D1*Dd*f**2*fd*s**2 - 24*D1*Dd*f**2*fd*s + 5*D1*Dd*f**2*fd - 528*D1*Dd*f**2*g2*r*s + 132*D1*Dd*f**2*g2*r - 528*D1*Dd*f**2*g2*s**2 + 528*D1*Dd*f**2*g2*s - 132*D1*Dd*f**2*g2 + 528*D1*Dd*f**2*gd2*r*s - 66*D1*Dd*f**2*gd2*r + 528*D1*Dd*f**2*gd2*s**2 - 528*D1*Dd*f**2*gd2*s + 66*D1*Dd*f**2*gd2 + 1056*D1*Dd*f*fd*g2*r*s - 396*D1*Dd*f*fd*g2*r + 1056*D1*Dd*f*fd*g2*s**2 - 1056*D1*Dd*f*fd*g2*s + 264*D1*Dd*f*fd*g2 - 132*D1*Ddd*K*b1*f**2*r*s + 33*D1*Ddd*K*b1*f**2*r - 132*D1*Ddd*K*b1*f**2*s**2 + 132*D1*Ddd*K*b1*f**2*s - 33*D1*Ddd*K*b1*f**2 + 4*D1*Ddd*f**3*r*s - D1*Ddd*f**3*r + 4*D1*Ddd*f**3*s**2 - 4*D1*Ddd*f**3*s + D1*Ddd*f**3 + 264*D1*Ddd*f**2*g2*r*s - 66*D1*Ddd*f**2*g2*r + 264*D1*Ddd*f**2*g2*s**2 - 264*D1*Ddd*f**2*g2*s + 66*D1*Ddd*f**2*g2 + 33*D1*bd2*f*(D1*(2*f*s*(r + s - 1) + fd*(-4*r*s + r - 4*s**2 + 4*s - 1)) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) - 396*Dd**2*K*b1*f**2*r*s + 99*Dd**2*K*b1*f**2*r - 396*Dd**2*K*b1*f**2*s**2 + 396*Dd**2*K*b1*f**2*s - 66*Dd**2*K*b1*f**2 + 12*Dd**2*f**3*r*s - 3*Dd**2*f**3*r + 12*Dd**2*f**3*s**2 - 12*Dd**2*f**3*s + 2*Dd**2*f**3 + 792*Dd**2*f**2*g2*r*s - 198*Dd**2*f**2*g2*r + 792*Dd**2*f**2*g2*s**2 - 792*Dd**2*f**2*g2*s + 132*Dd**2*f**2*g2 + 33*b2*(D1**2*(f*(2*fd - fdd)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + fd**2*(-2*r*s + r - s*(2*s - 2))) + D1*f*(2*Dd*(f*r*(4*s - 1) + f*(1 - 2*s)**2 + fd*r*(3 - 8*s) - 2*fd*(1 - 2*s)**2) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)))/(693*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*k2**3*st**4*(D1*(D1*K*bd1**2*f*(r + 2*s - 1) + K*b1**2*(r + 2*s - 1)*(2*D1*fd - D1*fdd - 4*Dd*fd) + b1*(D1*K*bdd1*f*(r + 2*s - 1) + D1*bd2*s*(2*f*(r + s - 1) - 2*fd*r - 2*fd*s + fd) - D1*bdd2*f*s*(r + s - 1) + D1*fd*(K*f*(-2*r*s + r - 2*s**2 + 2*s - 1) - 4*g2*(r + 2*s - 1) + 2*gd2*(r + 2*s - 1)) + 2*D1*fdd*g2*(r + 2*s - 1) + Dd*K*f**2*(-4*r*s + r - (1 - 2*s)**2) - Dd*bd2*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1) + 8*Dd*fd*g2*(r + 2*s - 1)) - bd1*(D1*bd2*f*(2*s - 1)*(r + s - 1) + D1*(K*b1*fd*(r + 2*s - 1) + K*f**2*s*(r + s - 1) - 2*f*(r + 2*s - 1)*(-K*b1 + 2*g2 - gd2)) + 4*Dd*f*(-K*b1 + 2*g2)*(r + 2*s - 1)) + f*(-2*D1*bdd1*g2*(r + 2*s - 1) + D1*(-f*s*(bd2 - 2*gd2)*(r + s - 1) + 2*fd*g2*(2*r*s - r + 2*s**2 - 2*s + 1)) + 2*Dd*f*g2*(r*(4*s - 1) + (1 - 2*s)**2))) + b2*(2*D1**2*b1*fd*r*s + 2*D1**2*b1*fd*s**2 - D1**2*b1*fdd*r*s - D1**2*b1*fdd*s**2 - D1**2*bdd1*f*(s - 1)*(r + s - 1) - 2*D1**2*f*fd*r*s + D1**2*f*fd*r - 2*D1**2*f*fd*s**2 + 2*D1**2*f*fd*s - D1**2*f*fd + 8*D1*Dd*b1*f*r*s - 2*D1*Dd*b1*f*r + 8*D1*Dd*b1*f*s**2 - 8*D1*Dd*b1*f*s + 2*D1*Dd*b1*f - 8*D1*Dd*b1*fd*r*s + D1*Dd*b1*fd*r - 8*D1*Dd*b1*fd*s**2 + 4*D1*Dd*b1*fd*s - 4*D1*Dd*f**2*r*s + D1*Dd*f**2*r - 4*D1*Dd*f**2*s**2 + 4*D1*Dd*f**2*s - D1*Dd*f**2 - 4*D1*Ddd*b1*f*r*s + D1*Ddd*b1*f*r - 4*D1*Ddd*b1*f*s**2 + 4*D1*Ddd*b1*f*s - D1*Ddd*b1*f + D1*bd1*(D1*(2*f*(s - 1)*(r + s - 1) + fd*(-2*r*s + r - s*(2*s - 2))) + Dd*f*(r*(5 - 8*s) - 8*s**2 + 12*s - 4)) - 12*Dd**2*b1*f*r*s + 3*Dd**2*b1*f*r - 12*Dd**2*b1*f*s**2 + 12*Dd**2*b1*f*s - 2*Dd**2*b1*f))/(7*d**2*k3**3) + D1**2*Pkd2*Pkd3*k2**3*st**2*(D1**2*bd1*(7*b2*f*(s - 1)*(r + s - 1) + (f*(2*C - 1) + 14*g2)*(bd1*r*(2*s - 1) + 2*bd1*s*(s - 1) + f*(r + 2*s - 1))) + D1*b1*(-2*C*D1*f*fd*r - 4*C*D1*f*fd*s + 2*C*D1*f*fd - 7*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 7*D1*b2*fd*r*s + 7*D1*b2*fd*s**2 + 7*D1*bd2*f*r*s + 7*D1*bd2*f*s**2 - 7*D1*bd2*f*s + D1*bdd1*(f*(2*C - 1) + 14*g2)*(r*(2*s - 1) + 2*s**2 - 2*s + 1) + D1*f*fd*r + 2*D1*f*fd*s - D1*f*fd - 14*D1*fd*g2*r - 28*D1*fd*g2*s + 14*D1*fd*g2 + 28*Dd*b2*f*r*s - 7*Dd*b2*f*r + 28*Dd*b2*f*s**2 - 28*Dd*b2*f*s + 7*Dd*b2*f + bd1*(-D1*(f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + 7*K*(r + 2*s - 1) - 4*r*s + 2*r - 4*s**2 + 4*s - 2) - fd*(2*C - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 14*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 14*gd2*(-4*r*s + r - (1 - 2*s)**2)) + 2*Dd*(f*(2*C - 1) + 14*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) + 7*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(D1**2*(-4*C*fd*r*s - 4*C*fd*s**2 + 4*C*fd*s + 2*C*fdd*r*s + 2*C*fdd*s**2 - 2*C*fdd*s + 14*K*bd1*(r*(3*s - 1) + 3*s**2 - 3*s + 1) - 7*K*bdd1*(3*r*s - r + 3*s**2 - 3*s + 1) + 7*K*fd*r + 14*K*fd*s - 7*K*fd + 2*fd*r*s + 2*fd*s**2 - 2*fd*s - fdd*r*s - fdd*s**2 + fdd*s - 28*gd2*r*s - 28*gd2*s**2 + 28*gd2*s + 14*gdd2*r*s + 14*gdd2*s**2 - 14*gdd2*s) + D1*(Dd*(-7*K*bd1*(24*r*s - 7*r + 24*s**2 - 24*s + 5) + f*(2 - 4*C)*(r*(4*s - 1) + (1 - 2*s)**2) + fd*(2*C - 1)*(r*(8*s - 1) + 8*s**2 - 8*s + 1) - 28*g2*(r*(4*s - 1) + (1 - 2*s)**2) + 14*gd2*(8*r*s - r + 8*s**2 - 8*s + 1)) + Ddd*(f*(2*C - 1) + 14*g2)*(r*(4*s - 1) + (1 - 2*s)**2)) + Dd**2*(f*(2*C - 1) + 14*g2)*(12*r*s - 3*r + 12*s**2 - 12*s + 2)))/(21*d**2*k3**3) - 2*D1**2*Pkd2*Pkd3*k2*st**4*(D1*(D1*K*bd1**2*f*s*(-2*r - 2*s + 1) + D1*bd1*(f*s*(-2*bd2*r - 2*bd2*s + bd2 - 4*g2*r - 4*g2*s + 4*gd2*r + 4*gd2*s - 2*gd2) + 2*fd*g2*(r*(2*s - 1) + s*(2*s - 2))) + 2*D1*bdd1*f*g2*s*(r + s) + 2*Dd*bd1*f*g2*(r*(8*s - 1) + 4*s*(2*s - 1)) + b2*(D1*bd1*(2*f*s*(r + s) + fd*(-2*r*s + r - s*(2*s - 2))) - D1*bdd1*f*s*(r + s) + Dd*bd1*f*(-8*r*s + r + s*(4 - 8*s)))) + K*b1**2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1*(4*D1**2*K*bd1*f*r*s + 4*D1**2*K*bd1*f*s**2 - 2*D1**2*K*bd1*f*s - 4*D1**2*K*bd1*fd*r*s + 2*D1**2*K*bd1*fd*r - 4*D1**2*K*bd1*fd*s**2 + 5*D1**2*K*bd1*fd*s - D1**2*K*bd1*fd - 2*D1**2*K*bdd1*f*r*s - 2*D1**2*K*bdd1*f*s**2 + D1**2*K*bdd1*f*s - D1**2*bdd2*f*r*s - D1**2*bdd2*f*s**2 + D1**2*bdd2*f*s - 4*D1**2*f*gd2*r*s - 4*D1**2*f*gd2*s**2 + 4*D1**2*f*gd2*s + 2*D1**2*f*gdd2*r*s + 2*D1**2*f*gdd2*s**2 - 2*D1**2*f*gdd2*s - 4*D1**2*fd*g2*r*s + 4*D1**2*fd*g2*r - 4*D1**2*fd*g2*s**2 + 8*D1**2*fd*g2*s - 4*D1**2*fd*g2 + 4*D1**2*fd*gd2*r*s - 2*D1**2*fd*gd2*r + 4*D1**2*fd*gd2*s**2 - 6*D1**2*fd*gd2*s + 2*D1**2*fd*gd2 + 2*D1**2*fdd*g2*r*s - 2*D1**2*fdd*g2*r + 2*D1**2*fdd*g2*s**2 - 4*D1**2*fdd*g2*s + 2*D1**2*fdd*g2 - 16*D1*Dd*K*bd1*f*r*s + 2*D1*Dd*K*bd1*f*r - 16*D1*Dd*K*bd1*f*s**2 + 12*D1*Dd*K*bd1*f*s - D1*Dd*K*bd1*f - 16*D1*Dd*f*g2*r*s + 4*D1*Dd*f*g2*r - 16*D1*Dd*f*g2*s**2 + 16*D1*Dd*f*g2*s - 4*D1*Dd*f*g2 + 16*D1*Dd*f*gd2*r*s - 2*D1*Dd*f*gd2*r + 16*D1*Dd*f*gd2*s**2 - 16*D1*Dd*f*gd2*s + 2*D1*Dd*f*gd2 + 16*D1*Dd*fd*g2*r*s - 10*D1*Dd*fd*g2*r + 16*D1*Dd*fd*g2*s**2 - 24*D1*Dd*fd*g2*s + 8*D1*Dd*fd*g2 + 8*D1*Ddd*f*g2*r*s - 2*D1*Ddd*f*g2*r + 8*D1*Ddd*f*g2*s**2 - 8*D1*Ddd*f*g2*s + 2*D1*Ddd*f*g2 + D1*bd2*(D1*(r + s - 1)*(2*f*s - 2*fd*s + fd) - Dd*f*(r*(8*s - 1) + 8*s**2 - 8*s + 1)) + 24*Dd**2*f*g2*r*s - 6*Dd**2*f*g2*r + 24*Dd**2*f*g2*s**2 - 24*Dd**2*f*g2*s + 4*Dd**2*f*g2 + b2*(D1**2*(2*fd - fdd)*(s - 1)*(r + s - 1) + D1*(Dd*f*(r*(8*s - 2) + 2*(1 - 2*s)**2) + Dd*fd*(r*(5 - 8*s) - 8*s**2 + 12*s - 4) + Ddd*f*(-4*r*s + r - (1 - 2*s)**2)) + Dd**2*f*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(7*d**2*k3) + D1**2*Pkd2*Pkd3*k2*st**2*(D1**2*bd1*(bd1*r*(2*s - 1) + 2*bd1*s*(s - 1) + f*s*(r + s))*(-2*C*f + 7*b2 + f - 14*g2) + D1*b1*(-4*C*D1*bdd1*f*r*s + 2*C*D1*bdd1*f*r - 4*C*D1*bdd1*f*s**2 + 4*C*D1*bdd1*f*s - 2*C*D1*bdd1*f - 4*C*D1*f*fd*r*s + 2*C*D1*f*fd*r - 4*C*D1*f*fd*s**2 + 6*C*D1*f*fd*s - 2*C*D1*f*fd - 8*C*Dd*f**2*r*s + 2*C*Dd*f**2*r - 8*C*Dd*f**2*s**2 + 8*C*Dd*f**2*s - 2*C*Dd*f**2 + 7*D1*K*bd1**2*(r*(6*s - 2) + 6*s**2 - 6*s + 1) + 7*D1*bd2*f*r*s + 7*D1*bd2*f*s**2 - 7*D1*bd2*f*s + 2*D1*bdd1*f*r*s - D1*bdd1*f*r + 2*D1*bdd1*f*s**2 - 2*D1*bdd1*f*s + D1*bdd1*f - 28*D1*bdd1*g2*r*s + 14*D1*bdd1*g2*r - 28*D1*bdd1*g2*s**2 + 28*D1*bdd1*g2*s - 14*D1*bdd1*g2 + 2*D1*f*fd*r*s - D1*f*fd*r + 2*D1*f*fd*s**2 - 3*D1*f*fd*s + D1*f*fd - 14*D1*f*gd2*r*s - 14*D1*f*gd2*s**2 + 14*D1*f*gd2*s - 14*D1*fd*g2*r*s + 14*D1*fd*g2*r - 14*D1*fd*g2*s**2 + 28*D1*fd*g2*s - 14*D1*fd*g2 + 4*Dd*f**2*r*s - Dd*f**2*r + 4*Dd*f**2*s**2 - 4*Dd*f**2*s + Dd*f**2 - 56*Dd*f*g2*r*s + 14*Dd*f*g2*r - 56*Dd*f*g2*s**2 + 56*Dd*f*g2*s - 14*Dd*f*g2 - 7*b2*(-D1*bdd1*(r*(2*s - 1) + 2*s**2 - 2*s + 1) - D1*fd*r*s + D1*fd*r - D1*fd*s**2 + 2*D1*fd*s - D1*fd - 4*Dd*f*r*s + Dd*f*r - 4*Dd*f*s**2 + 4*Dd*f*s - Dd*f + 2*bd1*(D1*r*(2*s - 1) + 2*D1*s**2 - 2*D1*s + D1 + Dd*r*(3 - 8*s) - 2*Dd*(1 - 2*s)**2)) + bd1*(7*D1*bd2*(r*(4*s - 1) + (1 - 2*s)**2) + D1*(f*(C*(r*(8*s - 4) + 8*s**2 - 8*s + 4) + 14*K*s**2 - 7*K*s + 2*r*(7*K*s - 2*s + 1) - 4*s**2 + 4*s - 2) - fd*(2*C - 1)*(r*(4*s - 1) + (1 - 2*s)**2) + 14*g2*(r*(4*s - 2) + 4*s**2 - 4*s + 2) + 14*gd2*(-4*r*s + r - (1 - 2*s)**2)) - 2*Dd*(f*(2*C - 1) + 14*g2)*(r*(8*s - 3) + 2*(1 - 2*s)**2))) - 7*K*b1**3*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2)) + b1**2*(4*C*D1**2*fd*r*s + 4*C*D1**2*fd*s**2 - 4*C*D1**2*fd*s - 2*C*D1**2*fdd*r*s - 2*C*D1**2*fdd*s**2 + 2*C*D1**2*fdd*s + 16*C*D1*Dd*f*r*s - 4*C*D1*Dd*f*r + 16*C*D1*Dd*f*s**2 - 16*C*D1*Dd*f*s + 4*C*D1*Dd*f - 16*C*D1*Dd*fd*r*s + 2*C*D1*Dd*fd*r - 16*C*D1*Dd*fd*s**2 + 16*C*D1*Dd*fd*s - 2*C*D1*Dd*fd - 8*C*D1*Ddd*f*r*s + 2*C*D1*Ddd*f*r - 8*C*D1*Ddd*f*s**2 + 8*C*D1*Ddd*f*s - 2*C*D1*Ddd*f - 24*C*Dd**2*f*r*s + 6*C*Dd**2*f*r - 24*C*Dd**2*f*s**2 + 24*C*Dd**2*f*s - 4*C*Dd**2*f - 42*D1**2*K*bd1*r*s + 14*D1**2*K*bd1*r - 42*D1**2*K*bd1*s**2 + 42*D1**2*K*bd1*s - 14*D1**2*K*bd1 + 21*D1**2*K*bdd1*r*s - 7*D1**2*K*bdd1*r + 21*D1**2*K*bdd1*s**2 - 21*D1**2*K*bdd1*s + 7*D1**2*K*bdd1 + 7*D1**2*K*fd*r*s - 7*D1**2*K*fd*r + 7*D1**2*K*fd*s**2 - 14*D1**2*K*fd*s + 7*D1**2*K*fd + 7*D1**2*bdd2*r*s + 7*D1**2*bdd2*s**2 - 7*D1**2*bdd2*s - 2*D1**2*fd*r*s - 2*D1**2*fd*s**2 + 2*D1**2*fd*s + D1**2*fdd*r*s + D1**2*fdd*s**2 - D1**2*fdd*s + 28*D1**2*gd2*r*s + 28*D1**2*gd2*s**2 - 28*D1**2*gd2*s - 14*D1**2*gdd2*r*s - 14*D1**2*gdd2*s**2 + 14*D1**2*gdd2*s + 168*D1*Dd*K*bd1*r*s - 49*D1*Dd*K*bd1*r + 168*D1*Dd*K*bd1*s**2 - 168*D1*Dd*K*bd1*s + 35*D1*Dd*K*bd1 + 28*D1*Dd*K*f*r*s - 7*D1*Dd*K*f*r + 28*D1*Dd*K*f*s**2 - 28*D1*Dd*K*f*s + 7*D1*Dd*K*f - 8*D1*Dd*f*r*s + 2*D1*Dd*f*r - 8*D1*Dd*f*s**2 + 8*D1*Dd*f*s - 2*D1*Dd*f + 8*D1*Dd*fd*r*s - D1*Dd*fd*r + 8*D1*Dd*fd*s**2 - 8*D1*Dd*fd*s + D1*Dd*fd + 112*D1*Dd*g2*r*s - 28*D1*Dd*g2*r + 112*D1*Dd*g2*s**2 - 112*D1*Dd*g2*s + 28*D1*Dd*g2 - 112*D1*Dd*gd2*r*s + 14*D1*Dd*gd2*r - 112*D1*Dd*gd2*s**2 + 112*D1*Dd*gd2*s - 14*D1*Dd*gd2 + 4*D1*Ddd*f*r*s - D1*Ddd*f*r + 4*D1*Ddd*f*s**2 - 4*D1*Ddd*f*s + D1*Ddd*f - 56*D1*Ddd*g2*r*s + 14*D1*Ddd*g2*r - 56*D1*Ddd*g2*s**2 + 56*D1*Ddd*g2*s - 14*D1*Ddd*g2 - 7*D1*bd2*(2*D1*s*(r + s - 1) + Dd*(-8*r*s + r - 8*s**2 + 8*s - 1)) + 12*Dd**2*f*r*s - 3*Dd**2*f*r + 12*Dd**2*f*s**2 - 12*Dd**2*f*s + 2*Dd**2*f - 168*Dd**2*g2*r*s + 42*Dd**2*g2*r - 168*Dd**2*g2*s**2 + 168*Dd**2*g2*s - 28*Dd**2*g2 - 7*b2*(D1*(2*Dd - Ddd)*(r*(4*s - 1) + (1 - 2*s)**2) + Dd**2*(-12*r*s + 3*r - 12*s**2 + 12*s - 2))))/(21*d**2*k3)
        
        return np.sqrt((4*np.pi)/5)*(perm12+perm13+perm23)